'use strict';
/* Scala.js runtime support
 * Copyright 2013 LAMP/EPFL
 * Author: Sébastien Doeraene
 */

/* ---------------------------------- *
 * The top-level Scala.js environment *
 * ---------------------------------- */





// Get the environment info
var $env = (typeof __ScalaJSEnv === "object" && __ScalaJSEnv) ? __ScalaJSEnv : {};

// Global scope
var $g =
  (typeof $env["global"] === "object" && $env["global"])
    ? $env["global"]
    : ((typeof global === "object" && global && global["Object"] === Object) ? global : this);
$env["global"] = $g;




// Where to send exports

var $e = exports;





$env["exportsNamespace"] = $e;


// Freeze the environment info
$g["Object"]["freeze"]($env);

// Linking info - must be in sync with scala.scalajs.runtime.LinkingInfo
var $linkingInfo = {
  "envInfo": $env,
  "semantics": {




    "asInstanceOfs": 1,








    "arrayIndexOutOfBounds": 1,










    "moduleInit": 2,





    "strictFloats": false,




    "productionMode": false

  },



  "assumingES6": false,

  "linkerVersion": "0.6.32",
  "globalThis": this
};
$g["Object"]["freeze"]($linkingInfo);
$g["Object"]["freeze"]($linkingInfo["semantics"]);

// Snapshots of builtins and polyfills






var $imul = $g["Math"]["imul"] || (function(a, b) {
  // See https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Math/imul
  var ah = (a >>> 16) & 0xffff;
  var al = a & 0xffff;
  var bh = (b >>> 16) & 0xffff;
  var bl = b & 0xffff;
  // the shift by 0 fixes the sign on the high part
  // the final |0 converts the unsigned value into a signed value
  return ((al * bl) + (((ah * bl + al * bh) << 16) >>> 0) | 0);
});

var $fround = $g["Math"]["fround"] ||









  (function(v) {
    return +v;
  });


var $clz32 = $g["Math"]["clz32"] || (function(i) {
  // See Hacker's Delight, Section 5-3
  if (i === 0) return 32;
  var r = 1;
  if ((i & 0xffff0000) === 0) { i <<= 16; r += 16; };
  if ((i & 0xff000000) === 0) { i <<= 8; r += 8; };
  if ((i & 0xf0000000) === 0) { i <<= 4; r += 4; };
  if ((i & 0xc0000000) === 0) { i <<= 2; r += 2; };
  return r + (i >> 31);
});


// Other fields




















var $lastIDHash = 0; // last value attributed to an id hash code



var $idHashCodeMap = $g["WeakMap"] ? new $g["WeakMap"]() : null;



// Core mechanism

var $makeIsArrayOfPrimitive = function(primitiveData) {
  return function(obj, depth) {
    return !!(obj && obj.$classData &&
      (obj.$classData.arrayDepth === depth) &&
      (obj.$classData.arrayBase === primitiveData));
  }
};


var $makeAsArrayOfPrimitive = function(isInstanceOfFunction, arrayEncodedName) {
  return function(obj, depth) {
    if (isInstanceOfFunction(obj, depth) || (obj === null))
      return obj;
    else
      $throwArrayCastException(obj, arrayEncodedName, depth);
  }
};


/** Encode a property name for runtime manipulation
  *  Usage:
  *    env.propertyName({someProp:0})
  *  Returns:
  *    "someProp"
  *  Useful when the property is renamed by a global optimizer (like Closure)
  *  but we must still get hold of a string of that name for runtime
  * reflection.
  */
var $propertyName = function(obj) {
  for (var prop in obj)
    return prop;
};

// Runtime functions

var $isScalaJSObject = function(obj) {
  return !!(obj && obj.$classData);
};


var $throwClassCastException = function(instance, classFullName) {




  throw new $c_sjsr_UndefinedBehaviorError().init___jl_Throwable(
    new $c_jl_ClassCastException().init___T(
      instance + " is not an instance of " + classFullName));

};

var $throwArrayCastException = function(instance, classArrayEncodedName, depth) {
  for (; depth; --depth)
    classArrayEncodedName = "[" + classArrayEncodedName;
  $throwClassCastException(instance, classArrayEncodedName);
};



var $throwArrayIndexOutOfBoundsException = function(i) {
  var msg = (i === null) ? null : ("" + i);



  throw new $c_sjsr_UndefinedBehaviorError().init___jl_Throwable(
    new $c_jl_ArrayIndexOutOfBoundsException().init___T(msg));

};


var $noIsInstance = function(instance) {
  throw new $g["TypeError"](
    "Cannot call isInstance() on a Class representing a raw JS trait/object");
};

var $makeNativeArrayWrapper = function(arrayClassData, nativeArray) {
  return new arrayClassData.constr(nativeArray);
};

var $newArrayObject = function(arrayClassData, lengths) {
  return $newArrayObjectInternal(arrayClassData, lengths, 0);
};

var $newArrayObjectInternal = function(arrayClassData, lengths, lengthIndex) {
  var result = new arrayClassData.constr(lengths[lengthIndex]);

  if (lengthIndex < lengths.length-1) {
    var subArrayClassData = arrayClassData.componentData;
    var subLengthIndex = lengthIndex+1;
    var underlying = result.u;
    for (var i = 0; i < underlying.length; i++) {
      underlying[i] = $newArrayObjectInternal(
        subArrayClassData, lengths, subLengthIndex);
    }
  }

  return result;
};

var $objectToString = function(instance) {
  if (instance === void 0)
    return "undefined";
  else
    return instance.toString();
};

var $objectGetClass = function(instance) {
  switch (typeof instance) {
    case "string":
      return $d_T.getClassOf();
    case "number": {
      var v = instance | 0;
      if (v === instance) { // is the value integral?
        if ($isByte(v))
          return $d_jl_Byte.getClassOf();
        else if ($isShort(v))
          return $d_jl_Short.getClassOf();
        else
          return $d_jl_Integer.getClassOf();
      } else {
        if ($isFloat(instance))
          return $d_jl_Float.getClassOf();
        else
          return $d_jl_Double.getClassOf();
      }
    }
    case "boolean":
      return $d_jl_Boolean.getClassOf();
    case "undefined":
      return $d_sr_BoxedUnit.getClassOf();
    default:
      if (instance === null)
        return instance.getClass__jl_Class();
      else if (instance instanceof $c_sjsr_RuntimeLong)
        return $d_jl_Long.getClassOf();
      else if ($isScalaJSObject(instance))
        return instance.$classData.getClassOf();
      else
        return null; // Exception?
  }
};

var $objectClone = function(instance) {
  if ($isScalaJSObject(instance) || (instance === null))
    return instance.clone__O();
  else
    throw new $c_jl_CloneNotSupportedException().init___();
};

var $objectNotify = function(instance) {
  // final and no-op in java.lang.Object
  if (instance === null)
    instance.notify__V();
};

var $objectNotifyAll = function(instance) {
  // final and no-op in java.lang.Object
  if (instance === null)
    instance.notifyAll__V();
};

var $objectFinalize = function(instance) {
  if ($isScalaJSObject(instance) || (instance === null))
    instance.finalize__V();
  // else no-op
};

var $objectEquals = function(instance, rhs) {
  if ($isScalaJSObject(instance) || (instance === null))
    return instance.equals__O__Z(rhs);
  else if (typeof instance === "number")
    return typeof rhs === "number" && $numberEquals(instance, rhs);
  else
    return instance === rhs;
};

var $numberEquals = function(lhs, rhs) {
  return (lhs === rhs) ? (
    // 0.0.equals(-0.0) must be false
    lhs !== 0 || 1/lhs === 1/rhs
  ) : (
    // are they both NaN?
    (lhs !== lhs) && (rhs !== rhs)
  );
};

var $objectHashCode = function(instance) {
  switch (typeof instance) {
    case "string":
      return $m_sjsr_RuntimeString$().hashCode__T__I(instance);
    case "number":
      return $m_sjsr_Bits$().numberHashCode__D__I(instance);
    case "boolean":
      return instance ? 1231 : 1237;
    case "undefined":
      return 0;
    default:
      if ($isScalaJSObject(instance) || instance === null)
        return instance.hashCode__I();

      else if ($idHashCodeMap === null)
        return 42;

      else
        return $systemIdentityHashCode(instance);
  }
};

var $comparableCompareTo = function(instance, rhs) {
  switch (typeof instance) {
    case "string":

      $as_T(rhs);

      return instance === rhs ? 0 : (instance < rhs ? -1 : 1);
    case "number":

      $asDouble(rhs);

      return $m_jl_Double$().compare__D__D__I(instance, rhs);
    case "boolean":

      $asBoolean(rhs);

      return instance - rhs; // yes, this gives the right result
    default:
      return instance.compareTo__O__I(rhs);
  }
};

var $charSequenceLength = function(instance) {
  if (typeof(instance) === "string")

    return $uI(instance["length"]);



  else
    return instance.length__I();
};

var $charSequenceCharAt = function(instance, index) {
  if (typeof(instance) === "string")

    return $uI(instance["charCodeAt"](index)) & 0xffff;



  else
    return instance.charAt__I__C(index);
};

var $charSequenceSubSequence = function(instance, start, end) {
  if (typeof(instance) === "string")

    return $as_T(instance["substring"](start, end));



  else
    return instance.subSequence__I__I__jl_CharSequence(start, end);
};

var $booleanBooleanValue = function(instance) {
  if (typeof instance === "boolean") return instance;
  else                               return instance.booleanValue__Z();
};

var $numberByteValue = function(instance) {
  if (typeof instance === "number") return (instance << 24) >> 24;
  else                              return instance.byteValue__B();
};
var $numberShortValue = function(instance) {
  if (typeof instance === "number") return (instance << 16) >> 16;
  else                              return instance.shortValue__S();
};
var $numberIntValue = function(instance) {
  if (typeof instance === "number") return instance | 0;
  else                              return instance.intValue__I();
};
var $numberLongValue = function(instance) {
  if (typeof instance === "number")
    return $m_sjsr_RuntimeLong$().fromDouble__D__sjsr_RuntimeLong(instance);
  else
    return instance.longValue__J();
};
var $numberFloatValue = function(instance) {
  if (typeof instance === "number") return $fround(instance);
  else                              return instance.floatValue__F();
};
var $numberDoubleValue = function(instance) {
  if (typeof instance === "number") return instance;
  else                              return instance.doubleValue__D();
};

var $isNaN = function(instance) {
  return instance !== instance;
};

var $isInfinite = function(instance) {
  return !$g["isFinite"](instance) && !$isNaN(instance);
};

var $doubleToInt = function(x) {
  return (x > 2147483647) ? (2147483647) : ((x < -2147483648) ? -2147483648 : (x | 0));
};

/** Instantiates a JS object with variadic arguments to the constructor. */
var $newJSObjectWithVarargs = function(ctor, args) {
  // This basically emulates the ECMAScript specification for 'new'.
  var instance = $g["Object"]["create"](ctor.prototype);
  var result = ctor["apply"](instance, args);
  switch (typeof result) {
    case "string": case "number": case "boolean": case "undefined": case "symbol":
      return instance;
    default:
      return result === null ? instance : result;
  }
};

var $resolveSuperRef = function(initialProto, propName) {
  var getPrototypeOf = $g["Object"]["getPrototypeOf"];
  var getOwnPropertyDescriptor = $g["Object"]["getOwnPropertyDescriptor"];

  var superProto = getPrototypeOf(initialProto);
  while (superProto !== null) {
    var desc = getOwnPropertyDescriptor(superProto, propName);
    if (desc !== void 0)
      return desc;
    superProto = getPrototypeOf(superProto);
  }

  return void 0;
};

var $superGet = function(initialProto, self, propName) {
  var desc = $resolveSuperRef(initialProto, propName);
  if (desc !== void 0) {
    var getter = desc["get"];
    if (getter !== void 0)
      return getter["call"](self);
    else
      return desc["value"];
  }
  return void 0;
};

var $superSet = function(initialProto, self, propName, value) {
  var desc = $resolveSuperRef(initialProto, propName);
  if (desc !== void 0) {
    var setter = desc["set"];
    if (setter !== void 0) {
      setter["call"](self, value);
      return void 0;
    }
  }
  throw new $g["TypeError"]("super has no setter '" + propName + "'.");
};


var $moduleDefault = function(m) {
  return (m && (typeof m === "object") && "default" in m) ? m["default"] : m;
};


var $propertiesOf = function(obj) {
  var result = [];
  for (var prop in obj)
    result["push"](prop);
  return result;
};

var $systemArraycopy = function(src, srcPos, dest, destPos, length) {
  var srcu = src.u;
  var destu = dest.u;


  if (srcPos < 0 || destPos < 0 || length < 0 ||
      (srcPos > ((srcu.length - length) | 0)) ||
      (destPos > ((destu.length - length) | 0))) {
    $throwArrayIndexOutOfBoundsException(null);
  }


  if (srcu !== destu || destPos < srcPos || (((srcPos + length) | 0) < destPos)) {
    for (var i = 0; i < length; i = (i + 1) | 0)
      destu[(destPos + i) | 0] = srcu[(srcPos + i) | 0];
  } else {
    for (var i = (length - 1) | 0; i >= 0; i = (i - 1) | 0)
      destu[(destPos + i) | 0] = srcu[(srcPos + i) | 0];
  }
};

var $systemIdentityHashCode =

  ($idHashCodeMap !== null) ?

  (function(obj) {
    switch (typeof obj) {
      case "string": case "number": case "boolean": case "undefined":
        return $objectHashCode(obj);
      default:
        if (obj === null) {
          return 0;
        } else {
          var hash = $idHashCodeMap["get"](obj);
          if (hash === void 0) {
            hash = ($lastIDHash + 1) | 0;
            $lastIDHash = hash;
            $idHashCodeMap["set"](obj, hash);
          }
          return hash;
        }
    }

  }) :
  (function(obj) {
    if ($isScalaJSObject(obj)) {
      var hash = obj["$idHashCode$0"];
      if (hash !== void 0) {
        return hash;
      } else if (!$g["Object"]["isSealed"](obj)) {
        hash = ($lastIDHash + 1) | 0;
        $lastIDHash = hash;
        obj["$idHashCode$0"] = hash;
        return hash;
      } else {
        return 42;
      }
    } else if (obj === null) {
      return 0;
    } else {
      return $objectHashCode(obj);
    }

  });

// is/as for hijacked boxed classes (the non-trivial ones)

var $isByte = function(v) {
  return typeof v === "number" && (v << 24 >> 24) === v && 1/v !== 1/-0;
};

var $isShort = function(v) {
  return typeof v === "number" && (v << 16 >> 16) === v && 1/v !== 1/-0;
};

var $isInt = function(v) {
  return typeof v === "number" && (v | 0) === v && 1/v !== 1/-0;
};

var $isFloat = function(v) {



  return typeof v === "number";

};


var $asUnit = function(v) {
  if (v === void 0 || v === null)
    return v;
  else
    $throwClassCastException(v, "scala.runtime.BoxedUnit");
};

var $asBoolean = function(v) {
  if (typeof v === "boolean" || v === null)
    return v;
  else
    $throwClassCastException(v, "java.lang.Boolean");
};

var $asByte = function(v) {
  if ($isByte(v) || v === null)
    return v;
  else
    $throwClassCastException(v, "java.lang.Byte");
};

var $asShort = function(v) {
  if ($isShort(v) || v === null)
    return v;
  else
    $throwClassCastException(v, "java.lang.Short");
};

var $asInt = function(v) {
  if ($isInt(v) || v === null)
    return v;
  else
    $throwClassCastException(v, "java.lang.Integer");
};

var $asFloat = function(v) {
  if ($isFloat(v) || v === null)
    return v;
  else
    $throwClassCastException(v, "java.lang.Float");
};

var $asDouble = function(v) {
  if (typeof v === "number" || v === null)
    return v;
  else
    $throwClassCastException(v, "java.lang.Double");
};


// Unboxes


var $uZ = function(value) {
  return !!$asBoolean(value);
};
var $uB = function(value) {
  return $asByte(value) | 0;
};
var $uS = function(value) {
  return $asShort(value) | 0;
};
var $uI = function(value) {
  return $asInt(value) | 0;
};
var $uJ = function(value) {
  return null === value ? $m_sjsr_RuntimeLong$().Zero$1
                        : $as_sjsr_RuntimeLong(value);
};
var $uF = function(value) {
  /* Here, it is fine to use + instead of fround, because asFloat already
   * ensures that the result is either null or a float.
   */
  return +$asFloat(value);
};
var $uD = function(value) {
  return +$asDouble(value);
};






// TypeArray conversions

var $byteArray2TypedArray = function(value) { return new $g["Int8Array"](value.u); };
var $shortArray2TypedArray = function(value) { return new $g["Int16Array"](value.u); };
var $charArray2TypedArray = function(value) { return new $g["Uint16Array"](value.u); };
var $intArray2TypedArray = function(value) { return new $g["Int32Array"](value.u); };
var $floatArray2TypedArray = function(value) { return new $g["Float32Array"](value.u); };
var $doubleArray2TypedArray = function(value) { return new $g["Float64Array"](value.u); };

var $typedArray2ByteArray = function(value) {
  var arrayClassData = $d_B.getArrayOf();
  return new arrayClassData.constr(new $g["Int8Array"](value));
};
var $typedArray2ShortArray = function(value) {
  var arrayClassData = $d_S.getArrayOf();
  return new arrayClassData.constr(new $g["Int16Array"](value));
};
var $typedArray2CharArray = function(value) {
  var arrayClassData = $d_C.getArrayOf();
  return new arrayClassData.constr(new $g["Uint16Array"](value));
};
var $typedArray2IntArray = function(value) {
  var arrayClassData = $d_I.getArrayOf();
  return new arrayClassData.constr(new $g["Int32Array"](value));
};
var $typedArray2FloatArray = function(value) {
  var arrayClassData = $d_F.getArrayOf();
  return new arrayClassData.constr(new $g["Float32Array"](value));
};
var $typedArray2DoubleArray = function(value) {
  var arrayClassData = $d_D.getArrayOf();
  return new arrayClassData.constr(new $g["Float64Array"](value));
};

// TypeData class


/** @constructor */
var $TypeData = function() {




  // Runtime support
  this.constr = void 0;
  this.parentData = void 0;
  this.ancestors = null;
  this.componentData = null;
  this.arrayBase = null;
  this.arrayDepth = 0;
  this.zero = null;
  this.arrayEncodedName = "";
  this._classOf = void 0;
  this._arrayOf = void 0;
  this.isArrayOf = void 0;

  // java.lang.Class support
  this["name"] = "";
  this["isPrimitive"] = false;
  this["isInterface"] = false;
  this["isArrayClass"] = false;
  this["isRawJSType"] = false;
  this["isInstance"] = void 0;
};


$TypeData.prototype.initPrim = function(



    zero, arrayEncodedName, displayName) {
  // Runtime support
  this.ancestors = {};
  this.componentData = null;
  this.zero = zero;
  this.arrayEncodedName = arrayEncodedName;
  this.isArrayOf = function(obj, depth) { return false; };

  // java.lang.Class support
  this["name"] = displayName;
  this["isPrimitive"] = true;
  this["isInstance"] = function(obj) { return false; };

  return this;
};


$TypeData.prototype.initClass = function(



    internalNameObj, isInterface, fullName,
    ancestors, isRawJSType, parentData, isInstance, isArrayOf) {
  var internalName = $propertyName(internalNameObj);

  isInstance = isInstance || function(obj) {
    return !!(obj && obj.$classData && obj.$classData.ancestors[internalName]);
  };

  isArrayOf = isArrayOf || function(obj, depth) {
    return !!(obj && obj.$classData && (obj.$classData.arrayDepth === depth)
      && obj.$classData.arrayBase.ancestors[internalName])
  };

  // Runtime support
  this.parentData = parentData;
  this.ancestors = ancestors;
  this.arrayEncodedName = "L"+fullName+";";
  this.isArrayOf = isArrayOf;

  // java.lang.Class support
  this["name"] = fullName;
  this["isInterface"] = isInterface;
  this["isRawJSType"] = !!isRawJSType;
  this["isInstance"] = isInstance;

  return this;
};


$TypeData.prototype.initArray = function(



    componentData) {
  // The constructor

  var componentZero0 = componentData.zero;

  // The zero for the Long runtime representation
  // is a special case here, since the class has not
  // been defined yet, when this file is read
  var componentZero = (componentZero0 == "longZero")
    ? $m_sjsr_RuntimeLong$().Zero$1
    : componentZero0;


  /** @constructor */
  var ArrayClass = function(arg) {
    if (typeof(arg) === "number") {
      // arg is the length of the array
      this.u = new Array(arg);
      for (var i = 0; i < arg; i++)
        this.u[i] = componentZero;
    } else {
      // arg is a native array that we wrap
      this.u = arg;
    }
  }
  ArrayClass.prototype = new $h_O;
  ArrayClass.prototype.constructor = ArrayClass;


  ArrayClass.prototype.get = function(i) {
    if (i < 0 || i >= this.u.length)
      $throwArrayIndexOutOfBoundsException(i);
    return this.u[i];
  };
  ArrayClass.prototype.set = function(i, v) {
    if (i < 0 || i >= this.u.length)
      $throwArrayIndexOutOfBoundsException(i);
    this.u[i] = v;
  };


  ArrayClass.prototype.clone__O = function() {
    if (this.u instanceof Array)
      return new ArrayClass(this.u["slice"](0));
    else
      // The underlying Array is a TypedArray
      return new ArrayClass(new this.u.constructor(this.u));
  };






































  ArrayClass.prototype.$classData = this;

  // Don't generate reflective call proxies. The compiler special cases
  // reflective calls to methods on scala.Array

  // The data

  var encodedName = "[" + componentData.arrayEncodedName;
  var componentBase = componentData.arrayBase || componentData;
  var arrayDepth = componentData.arrayDepth + 1;

  var isInstance = function(obj) {
    return componentBase.isArrayOf(obj, arrayDepth);
  }

  // Runtime support
  this.constr = ArrayClass;
  this.parentData = $d_O;
  this.ancestors = {O: 1, jl_Cloneable: 1, Ljava_io_Serializable: 1};
  this.componentData = componentData;
  this.arrayBase = componentBase;
  this.arrayDepth = arrayDepth;
  this.zero = null;
  this.arrayEncodedName = encodedName;
  this._classOf = undefined;
  this._arrayOf = undefined;
  this.isArrayOf = undefined;

  // java.lang.Class support
  this["name"] = encodedName;
  this["isPrimitive"] = false;
  this["isInterface"] = false;
  this["isArrayClass"] = true;
  this["isInstance"] = isInstance;

  return this;
};


$TypeData.prototype.getClassOf = function() {



  if (!this._classOf)
    this._classOf = new $c_jl_Class().init___jl_ScalaJSClassData(this);
  return this._classOf;
};


$TypeData.prototype.getArrayOf = function() {



  if (!this._arrayOf)
    this._arrayOf = new $TypeData().initArray(this);
  return this._arrayOf;
};

// java.lang.Class support


$TypeData.prototype["getFakeInstance"] = function() {



  if (this === $d_T)
    return "some string";
  else if (this === $d_jl_Boolean)
    return false;
  else if (this === $d_jl_Byte ||
           this === $d_jl_Short ||
           this === $d_jl_Integer ||
           this === $d_jl_Float ||
           this === $d_jl_Double)
    return 0;
  else if (this === $d_jl_Long)
    return $m_sjsr_RuntimeLong$().Zero$1;
  else if (this === $d_sr_BoxedUnit)
    return void 0;
  else
    return {$classData: this};
};


$TypeData.prototype["getSuperclass"] = function() {



  return this.parentData ? this.parentData.getClassOf() : null;
};


$TypeData.prototype["getComponentType"] = function() {



  return this.componentData ? this.componentData.getClassOf() : null;
};


$TypeData.prototype["newArrayOfThisClass"] = function(lengths) {



  var arrayClassData = this;
  for (var i = 0; i < lengths.length; i++)
    arrayClassData = arrayClassData.getArrayOf();
  return $newArrayObject(arrayClassData, lengths);
};




// Create primitive types

var $d_V = new $TypeData().initPrim(undefined, "V", "void");
var $d_Z = new $TypeData().initPrim(false, "Z", "boolean");
var $d_C = new $TypeData().initPrim(0, "C", "char");
var $d_B = new $TypeData().initPrim(0, "B", "byte");
var $d_S = new $TypeData().initPrim(0, "S", "short");
var $d_I = new $TypeData().initPrim(0, "I", "int");
var $d_J = new $TypeData().initPrim("longZero", "J", "long");
var $d_F = new $TypeData().initPrim(0.0, "F", "float");
var $d_D = new $TypeData().initPrim(0.0, "D", "double");

// Instance tests for array of primitives

var $isArrayOf_Z = $makeIsArrayOfPrimitive($d_Z);
$d_Z.isArrayOf = $isArrayOf_Z;

var $isArrayOf_C = $makeIsArrayOfPrimitive($d_C);
$d_C.isArrayOf = $isArrayOf_C;

var $isArrayOf_B = $makeIsArrayOfPrimitive($d_B);
$d_B.isArrayOf = $isArrayOf_B;

var $isArrayOf_S = $makeIsArrayOfPrimitive($d_S);
$d_S.isArrayOf = $isArrayOf_S;

var $isArrayOf_I = $makeIsArrayOfPrimitive($d_I);
$d_I.isArrayOf = $isArrayOf_I;

var $isArrayOf_J = $makeIsArrayOfPrimitive($d_J);
$d_J.isArrayOf = $isArrayOf_J;

var $isArrayOf_F = $makeIsArrayOfPrimitive($d_F);
$d_F.isArrayOf = $isArrayOf_F;

var $isArrayOf_D = $makeIsArrayOfPrimitive($d_D);
$d_D.isArrayOf = $isArrayOf_D;


// asInstanceOfs for array of primitives
var $asArrayOf_Z = $makeAsArrayOfPrimitive($isArrayOf_Z, "Z");
var $asArrayOf_C = $makeAsArrayOfPrimitive($isArrayOf_C, "C");
var $asArrayOf_B = $makeAsArrayOfPrimitive($isArrayOf_B, "B");
var $asArrayOf_S = $makeAsArrayOfPrimitive($isArrayOf_S, "S");
var $asArrayOf_I = $makeAsArrayOfPrimitive($isArrayOf_I, "I");
var $asArrayOf_J = $makeAsArrayOfPrimitive($isArrayOf_J, "J");
var $asArrayOf_F = $makeAsArrayOfPrimitive($isArrayOf_F, "F");
var $asArrayOf_D = $makeAsArrayOfPrimitive($isArrayOf_D, "D");

var $i_os = require("os");
var $i_path = require("path");
var $i_http = require("http");
var $i_https = require("https");
var $i_fs = require("fs");
function $is_F0(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.F0)))
}
function $as_F0(obj) {
  return (($is_F0(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.Function0"))
}
function $isArrayOf_F0(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.F0)))
}
function $asArrayOf_F0(obj, depth) {
  return (($isArrayOf_F0(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.Function0;", depth))
}
function $is_F1(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.F1)))
}
function $as_F1(obj) {
  return (($is_F1(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.Function1"))
}
function $isArrayOf_F1(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.F1)))
}
function $asArrayOf_F1(obj, depth) {
  return (($isArrayOf_F1(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.Function1;", depth))
}
function $f_F2__tupled__F1($thiz) {
  return new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var x1$2 = x0$1.$$und1__O();
        var x2 = x0$1.$$und2__O();
        return $this.apply__O__O__O(x1$2, x2)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })($thiz))
}
function $is_F2(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.F2)))
}
function $as_F2(obj) {
  return (($is_F2(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.Function2"))
}
function $isArrayOf_F2(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.F2)))
}
function $asArrayOf_F2(obj, depth) {
  return (($isArrayOf_F2(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.Function2;", depth))
}
function $is_Lamf_MessageStyle(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_MessageStyle)))
}
function $as_Lamf_MessageStyle(obj) {
  return (($is_Lamf_MessageStyle(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.MessageStyle"))
}
function $isArrayOf_Lamf_MessageStyle(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_MessageStyle)))
}
function $asArrayOf_Lamf_MessageStyle(obj, depth) {
  return (($isArrayOf_Lamf_MessageStyle(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.MessageStyle;", depth))
}
function $f_Lamf_client_commands_CommandHelper__resolve__Lamf_core_client_ParserConfig__Lamf_core_model_document_BaseUnit__s_concurrent_Future($thiz, config, unit) {
  var vendor = config.inputFormat$1;
  var vendor$1 = $f_Lamf_client_commands_CommandHelper__effectiveVendor__s_Option__T($thiz, vendor);
  if ((config.resolve$1 && config.validate$1)) {
    var inputFile = $as_T(config.input$1.get__O());
    var inputFile$1 = $f_Lamf_client_commands_CommandHelper__ensureUrl__T__T($thiz, inputFile);
    var jsx$1 = $m_s_Option$();
    var mediaType = config.inputMediaType$1;
    var vendor$2 = config.inputFormat$1;
    var x$2 = jsx$1.apply__O__s_Option($f_Lamf_client_commands_CommandHelper__effectiveMediaType__s_Option__s_Option__T($thiz, mediaType, vendor$2));
    var x$3 = config.inputFormat$1;
    var x$4 = $m_Lamf_core_remote_Context$().apply__Lamf_core_remote_Platform__Lamf_core_remote_Context($thiz.platform__Lamf_core_remote_Platform());
    var x$5 = new $c_Lamf_core_remote_Cache().init___();
    var x$6 = $m_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$();
    $m_Lamf_core_services_RuntimeCompiler$();
    var x$7 = $m_Lamf_core_parser_UnspecifiedReference$();
    $m_Lamf_core_services_RuntimeCompiler$();
    var x$8 = $m_s_None$();
    $m_Lamf_core_services_RuntimeCompiler$();
    var x$9 = $m_Lamf_internal_environment_Environment$().apply__Lamf_internal_environment_Environment();
    $m_Lamf_core_services_RuntimeCompiler$();
    var x$10 = new $c_Lamf_core_client_ParsingOptions().init___();
    var parsed = $m_Lamf_core_services_RuntimeCompiler$().apply__T__s_Option__s_Option__Lamf_core_remote_Context__Lamf_core_remote_Cache__Lamf_core_parser_ReferenceKind__s_Option__Lamf_internal_environment_Environment__Lamf_core_client_ParsingOptions__Lamf_core_parser_errorhandler_AmfParserErrorHandler__s_concurrent_ExecutionContext__s_concurrent_Future(inputFile$1, x$2, x$3, x$4, x$5, x$7, x$8, x$9, x$10, x$6, $thiz.executionContext__s_concurrent_ExecutionContext());
    return parsed.map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, vendor$3) {
      return (function(parsed$2$2) {
        var parsed$2 = $as_Lamf_core_model_document_BaseUnit(parsed$2$2);
        return $m_Lamf_core_services_RuntimeResolver$().resolve__T__Lamf_core_model_document_BaseUnit__T__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(vendor$3, parsed$2, $m_Lamf_core_resolution_pipelines_ResolutionPipeline$().DEFAULT$undPIPELINE$1, $m_Lamf_core_errorhandling_UnhandledErrorHandler$())
      })
    })($thiz, vendor$1)), $thiz.executionContext__s_concurrent_ExecutionContext())
  } else {
    return (config.resolve$1 ? $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$2$1, vendor$4, unit$1) {
      return (function() {
        return $m_Lamf_core_services_RuntimeResolver$().resolve__T__Lamf_core_model_document_BaseUnit__T__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(vendor$4, unit$1, $m_Lamf_core_resolution_pipelines_ResolutionPipeline$().DEFAULT$undPIPELINE$1, $m_Lamf_core_errorhandling_UnhandledErrorHandler$())
      })
    })($thiz, vendor$1, unit)), $thiz.executionContext__s_concurrent_ExecutionContext()) : $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$3$1, unit$2) {
      return (function() {
        return unit$2
      })
    })($thiz, unit)), $thiz.executionContext__s_concurrent_ExecutionContext()))
  }
}
function $f_Lamf_client_commands_CommandHelper__effectiveVendor__s_Option__T($thiz, vendor) {
  if ((vendor instanceof $c_s_Some)) {
    var x2 = $as_s_Some(vendor);
    var effectiveVendor = $as_T(x2.value$2);
    return effectiveVendor
  } else {
    var x = $m_s_None$();
    if ((x === vendor)) {
      return "Unknown"
    } else {
      throw new $c_s_MatchError().init___O(vendor)
    }
  }
}
function $f_Lamf_client_commands_CommandHelper__parseInput__Lamf_core_client_ParserConfig__s_concurrent_Future($thiz, config) {
  var inputFile = $as_T(config.input$1.get__O());
  var inputFile$1 = $f_Lamf_client_commands_CommandHelper__ensureUrl__T__T($thiz, inputFile);
  var jsx$1 = $m_s_Option$();
  var mediaType = config.inputMediaType$1;
  var vendor = config.inputFormat$1;
  var x$2 = jsx$1.apply__O__s_Option($f_Lamf_client_commands_CommandHelper__effectiveMediaType__s_Option__s_Option__T($thiz, mediaType, vendor));
  var x$3 = config.inputFormat$1;
  var x$4 = $m_Lamf_core_remote_Context$().apply__Lamf_core_remote_Platform__Lamf_core_remote_Context($thiz.platform__Lamf_core_remote_Platform());
  var x$5 = new $c_Lamf_core_remote_Cache().init___();
  var x$6 = $m_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$();
  $m_Lamf_core_services_RuntimeCompiler$();
  var x$7 = $m_Lamf_core_parser_UnspecifiedReference$();
  $m_Lamf_core_services_RuntimeCompiler$();
  var x$8 = $m_s_None$();
  $m_Lamf_core_services_RuntimeCompiler$();
  var x$9 = $m_Lamf_internal_environment_Environment$().apply__Lamf_internal_environment_Environment();
  $m_Lamf_core_services_RuntimeCompiler$();
  var x$10 = new $c_Lamf_core_client_ParsingOptions().init___();
  var parsed = $m_Lamf_core_services_RuntimeCompiler$().apply__T__s_Option__s_Option__Lamf_core_remote_Context__Lamf_core_remote_Cache__Lamf_core_parser_ReferenceKind__s_Option__Lamf_internal_environment_Environment__Lamf_core_client_ParsingOptions__Lamf_core_parser_errorhandler_AmfParserErrorHandler__s_concurrent_ExecutionContext__s_concurrent_Future(inputFile$1, x$2, x$3, x$4, x$5, x$7, x$8, x$9, x$10, x$6, $thiz.executionContext__s_concurrent_ExecutionContext());
  var vendor$1 = config.inputFormat$1;
  var vendor$2 = $f_Lamf_client_commands_CommandHelper__effectiveVendor__s_Option__T($thiz, vendor$1);
  return (config.resolve$1 ? parsed.map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, vendor$3) {
    return (function(unit$2) {
      var unit = $as_Lamf_core_model_document_BaseUnit(unit$2);
      return $m_Lamf_core_services_RuntimeResolver$().resolve__T__Lamf_core_model_document_BaseUnit__T__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(vendor$3, unit, $m_Lamf_core_resolution_pipelines_ResolutionPipeline$().DEFAULT$undPIPELINE$1, $m_Lamf_core_errorhandling_UnhandledErrorHandler$())
    })
  })($thiz, vendor$2)), $thiz.executionContext__s_concurrent_ExecutionContext()) : parsed)
}
function $f_Lamf_client_commands_CommandHelper__ensureUrl__T__T($thiz, inputFile) {
  return ((((($uI(inputFile.length) >= 0) && ($as_T(inputFile.substring(0, $uI("file:".length))) === "file:")) || (($uI(inputFile.length) >= 0) && ($as_T(inputFile.substring(0, $uI("http:".length))) === "http:"))) || (($uI(inputFile.length) >= 0) && ($as_T(inputFile.substring(0, $uI("https:".length))) === "https:"))) ? inputFile : ((($uI(inputFile.length) >= 0) && ($as_T(inputFile.substring(0, $uI("/".length))) === "/")) ? ("file:/" + inputFile) : ("file://" + inputFile)))
}
function $f_Lamf_client_commands_CommandHelper__processDialects__Lamf_core_client_ParserConfig__s_concurrent_Future($thiz, config) {
  var jsx$2 = config.dialects$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(dialect$2) {
      var dialect = $as_T(dialect$2);
      var qual$1 = $m_Lamf_plugins_document_vocabularies_AMLPlugin$().apply__Lamf_plugins_document_vocabularies_AMLPlugin().registry$2;
      var x$2 = $m_Lamf_internal_environment_Environment$().apply__Lamf_internal_environment_Environment();
      var this$1 = qual$1.platform$1;
      var x$3 = this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
      return qual$1.registerDialect__T__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future(dialect, x$2, x$3.$$undinternal$1.context$1)
    })
  })($thiz));
  var this$2 = $m_sc_Seq$();
  var dialectFutures = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  var jsx$3 = $m_s_concurrent_Future$();
  var this$3 = $m_sc_Seq$();
  return jsx$3.sequence__sc_TraversableOnce__scg_CanBuildFrom__s_concurrent_ExecutionContext__s_concurrent_Future(dialectFutures, this$3.ReusableCBFInstance$2, $thiz.executionContext__s_concurrent_ExecutionContext()).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$1$2) {
      $as_sc_Seq(x$1$2)
    })
  })($thiz)), $thiz.executionContext__s_concurrent_ExecutionContext())
}
function $f_Lamf_client_commands_CommandHelper__generateOutput__Lamf_core_client_ParserConfig__Lamf_core_model_document_BaseUnit__s_concurrent_Future($thiz, config, unit) {
  var generateOptions = new $c_Lamf_core_emitter_RenderOptions().init___();
  if (config.withSourceMaps$1) {
    generateOptions.withSourceMaps__Lamf_core_emitter_RenderOptions()
  };
  if (config.withCompactNamespaces$1) {
    generateOptions.withCompactUris__Lamf_core_emitter_RenderOptions()
  };
  var mediaType = config.outputMediaType$1;
  var vendor = config.outputFormat$1;
  var mediaType$1 = $f_Lamf_client_commands_CommandHelper__effectiveMediaType__s_Option__s_Option__T($thiz, mediaType, vendor);
  var vendor$1 = config.outputFormat$1;
  var vendor$2 = $f_Lamf_client_commands_CommandHelper__effectiveVendor__s_Option__T($thiz, vendor$1);
  var x1 = config.output$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var f = $as_T(x2.value$2);
    return $m_Lamf_core_services_RuntimeSerializer$().dumpToFile__Lamf_core_remote_Platform__T__Lamf_core_model_document_BaseUnit__T__T__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__s_concurrent_Future($thiz.platform__Lamf_core_remote_Platform(), f, unit, mediaType$1, vendor$2, generateOptions, ($m_Lamf_core_services_RuntimeSerializer$(), new $c_Lamf_core_emitter_ShapeRenderOptions().init___()))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, config$1, unit$1, mediaType$2, vendor$3, generateOptions$1) {
        return (function() {
          config$1.stdout$1.print__T__V($m_Lamf_core_services_RuntimeSerializer$().apply__Lamf_core_model_document_BaseUnit__T__T__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__T(unit$1, mediaType$2, vendor$3, generateOptions$1, ($m_Lamf_core_services_RuntimeSerializer$(), new $c_Lamf_core_emitter_ShapeRenderOptions().init___())))
        })
      })($thiz, config, unit, mediaType$1, vendor$2, generateOptions)), $thiz.executionContext__s_concurrent_ExecutionContext())
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
}
function $f_Lamf_client_commands_CommandHelper__AMFInit__s_concurrent_Future($thiz) {
  $m_Lamf_client_convert_WebApiRegister$().register__Lamf_core_remote_Platform__V($thiz.platform__Lamf_core_remote_Platform());
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V($m_Lamf_plugins_document_vocabularies_AMLPlugin$());
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V($m_Lamf_plugins_document_webapi_Raml10Plugin$());
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V($m_Lamf_plugins_document_webapi_Raml08Plugin$());
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V($m_Lamf_plugins_document_webapi_Oas20Plugin$());
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V($m_Lamf_plugins_document_webapi_Oas30Plugin$());
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V($m_Lamf_plugins_features_validation_AMFValidatorPlugin$());
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V($m_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$());
  return $m_Lamf_core_AMF$().init__s_concurrent_ExecutionContext__s_concurrent_Future($thiz.executionContext__s_concurrent_ExecutionContext())
}
function $f_Lamf_client_commands_CommandHelper__effectiveMediaType__s_Option__s_Option__T($thiz, mediaType, vendor) {
  if ((mediaType instanceof $c_s_Some)) {
    var x2 = $as_s_Some(mediaType);
    var effectiveMediaType = $as_T(x2.value$2);
    return effectiveMediaType
  } else {
    var x = $m_s_None$();
    if ((x === mediaType)) {
      if ((vendor instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(vendor);
        var effectiveVendor = $as_T(x2$2.value$2);
        var this$1 = $m_Lamf_core_registries_AMFPluginsRegistry$();
        if (this$1.documentPluginIDRegistry$1.get__O__s_Option(effectiveVendor).isDefined__Z()) {
          var this$2 = $m_Lamf_core_registries_AMFPluginsRegistry$();
          return $as_T($as_Lamf_client_plugins_AMFDocumentPlugin(this$2.documentPluginIDRegistry$1.get__O__s_Option(effectiveVendor).get__O()).documentSyntaxes__sc_Seq().head__O())
        }
      };
      return "*/*"
    } else {
      throw new $c_s_MatchError().init___O(mediaType)
    }
  }
}
function $f_Lamf_client_model_ValueField__is__O__Z($thiz, other) {
  var this$1 = $thiz.$$undoption__s_Option();
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    return $m_sr_BoxesRunTime$().equals__O__O__Z(arg1, other)
  } else {
    return false
  }
}
function $f_Lamf_client_model_ValueField__toString__T($thiz) {
  var this$1 = $thiz.$$undoption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var this$2 = new $c_s_Some().init___O($objectToString(arg1))
  };
  return $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()))
}
function $f_Lamf_client_model_ValueField__is__F1__Z($thiz, accepts) {
  var this$1 = $thiz.$$undoption__s_Option();
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    return $uZ(accepts.apply__O__O(arg1))
  } else {
    return false
  }
}
function $f_Lamf_client_model_domain_Linkable__isLink__Z($thiz) {
  var this$1 = $as_Lamf_core_model_domain_Linkable($thiz.$$undinternal__Lamf_core_model_domain_DomainElement());
  return $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1).isDefined__Z()
}
function $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr($thiz) {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $as_Lamf_core_model_domain_Linkable($thiz.$$undinternal__Lamf_core_model_domain_DomainElement());
  var from = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1);
  var m = $m_Lamf_client_convert_CoreClientConverters$().DomainElementMatcher__Lamf_client_convert_DomainElementConverter$DomainElementMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
}
function $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement($thiz, label) {
  var this$1 = $as_Lamf_core_model_domain_Linkable($thiz.$$undinternal__Lamf_core_model_domain_DomainElement());
  var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1;
  $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, label));
  return $as_Lamf_client_model_domain_DomainElement($thiz)
}
function $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $as_Lamf_core_model_domain_Linkable($thiz.$$undinternal__Lamf_core_model_domain_DomainElement());
  var from = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
}
function $f_Lamf_client_model_domain_Linkable__link__s_Option__O($thiz, label) {
  var this$1 = $thiz.linkCopy__Lamf_client_model_domain_Linkable();
  var target = $as_Lamf_client_model_domain_DomainElement($thiz);
  var copy = $as_Lamf_client_model_domain_Linkable($f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this$1, target));
  if ((!label.isEmpty__Z())) {
    var arg1 = label.get__O();
    var label$2 = $as_T(arg1);
    $as_Lamf_client_model_domain_Linkable($f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(copy, label$2))
  };
  return copy
}
function $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement($thiz, target) {
  var this$1 = $as_Lamf_core_model_domain_Linkable($thiz.$$undinternal__Lamf_core_model_domain_DomainElement());
  var target$1 = $as_Lamf_client_model_domain_Linkable(target).$$undinternal__Lamf_core_model_domain_DomainElement();
  $f_Lamf_core_model_domain_Linkable__withLinkTarget__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(this$1, target$1);
  return $as_Lamf_client_model_domain_DomainElement($thiz)
}
function $is_Lamf_client_model_domain_Linkable(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_client_model_domain_Linkable)))
}
function $as_Lamf_client_model_domain_Linkable(obj) {
  return (($is_Lamf_client_model_domain_Linkable(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Linkable"))
}
function $isArrayOf_Lamf_client_model_domain_Linkable(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Linkable)))
}
function $asArrayOf_Lamf_client_model_domain_Linkable(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Linkable(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Linkable;", depth))
}
function $is_Lamf_client_plugins_AMFPlugin(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_client_plugins_AMFPlugin)))
}
function $as_Lamf_client_plugins_AMFPlugin(obj) {
  return (($is_Lamf_client_plugins_AMFPlugin(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.plugins.AMFPlugin"))
}
function $isArrayOf_Lamf_client_plugins_AMFPlugin(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_plugins_AMFPlugin)))
}
function $asArrayOf_Lamf_client_plugins_AMFPlugin(obj, depth) {
  return (($isArrayOf_Lamf_client_plugins_AMFPlugin(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.plugins.AMFPlugin;", depth))
}
function $is_Lamf_client_plugins_ValidationMode(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_client_plugins_ValidationMode)))
}
function $as_Lamf_client_plugins_ValidationMode(obj) {
  return (($is_Lamf_client_plugins_ValidationMode(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.plugins.ValidationMode"))
}
function $isArrayOf_Lamf_client_plugins_ValidationMode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_plugins_ValidationMode)))
}
function $asArrayOf_Lamf_client_plugins_ValidationMode(obj, depth) {
  return (($isArrayOf_Lamf_client_plugins_ValidationMode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.plugins.ValidationMode;", depth))
}
function $is_Lamf_client_reference_ReferenceResolver(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_client_reference_ReferenceResolver)))
}
function $as_Lamf_client_reference_ReferenceResolver(obj) {
  return (($is_Lamf_client_reference_ReferenceResolver(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.reference.ReferenceResolver"))
}
function $isArrayOf_Lamf_client_reference_ReferenceResolver(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_reference_ReferenceResolver)))
}
function $asArrayOf_Lamf_client_reference_ReferenceResolver(obj, depth) {
  return (($isArrayOf_Lamf_client_reference_ReferenceResolver(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.reference.ReferenceResolver;", depth))
}
function $is_Lamf_client_render_JSONSchemaVersion(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_client_render_JSONSchemaVersion)))
}
function $as_Lamf_client_render_JSONSchemaVersion(obj) {
  return (($is_Lamf_client_render_JSONSchemaVersion(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.render.JSONSchemaVersion"))
}
function $isArrayOf_Lamf_client_render_JSONSchemaVersion(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_render_JSONSchemaVersion)))
}
function $asArrayOf_Lamf_client_render_JSONSchemaVersion(obj, depth) {
  return (($isArrayOf_Lamf_client_render_JSONSchemaVersion(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.render.JSONSchemaVersion;", depth))
}
function $is_Lamf_client_resolve_ClientErrorHandler(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_client_resolve_ClientErrorHandler)))
}
function $as_Lamf_client_resolve_ClientErrorHandler(obj) {
  return (($is_Lamf_client_resolve_ClientErrorHandler(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.resolve.ClientErrorHandler"))
}
function $isArrayOf_Lamf_client_resolve_ClientErrorHandler(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_resolve_ClientErrorHandler)))
}
function $asArrayOf_Lamf_client_resolve_ClientErrorHandler(obj, depth) {
  return (($isArrayOf_Lamf_client_resolve_ClientErrorHandler(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.resolve.ClientErrorHandler;", depth))
}
function $is_Lamf_client_resource_ResourceLoader(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_client_resource_ResourceLoader)))
}
function $as_Lamf_client_resource_ResourceLoader(obj) {
  return (($is_Lamf_client_resource_ResourceLoader(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.resource.ResourceLoader"))
}
function $isArrayOf_Lamf_client_resource_ResourceLoader(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_resource_ResourceLoader)))
}
function $asArrayOf_Lamf_client_resource_ResourceLoader(obj, depth) {
  return (($isArrayOf_Lamf_client_resource_ResourceLoader(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.resource.ResourceLoader;", depth))
}
function $is_Lamf_core_emitter_Emitter(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_emitter_Emitter)))
}
function $as_Lamf_core_emitter_Emitter(obj) {
  return (($is_Lamf_core_emitter_Emitter(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.emitter.Emitter"))
}
function $isArrayOf_Lamf_core_emitter_Emitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_emitter_Emitter)))
}
function $asArrayOf_Lamf_core_emitter_Emitter(obj, depth) {
  return (($isArrayOf_Lamf_core_emitter_Emitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.emitter.Emitter;", depth))
}
function $f_Lamf_core_errorhandling_ErrorHandler__lexical__pLamf_core_errorhandling_ErrorHandler__Lorg_mulesoft_lexer_SourceLocation__s_Option($thiz, loc) {
  var x1 = $m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(loc.lineFrom$1, loc.columnFrom$1, loc.lineTo$1, loc.columnTo$1);
  var x = $m_Lorg_mulesoft_lexer_InputRange$().Zero$1;
  if (((x === null) ? (x1 === null) : x.equals__O__Z(x1))) {
    return $m_s_None$()
  } else {
    return new $c_s_Some().init___O(new $c_Lamf_core_annotations_LexicalInformation().init___Lamf_core_parser_Range($m_Lamf_core_parser_Range$().apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range(x1)))
  }
}
function $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V($thiz, spec, n, prop, msg, l) {
  var lexical = $f_Lamf_core_errorhandling_ErrorHandler__lexical__pLamf_core_errorhandling_ErrorHandler__Lorg_mulesoft_lexer_SourceLocation__s_Option($thiz, l);
  var str = l.sourceName$1;
  var location = new $c_Lamf_core_utils_package$AmfStrings().init___T(str).option__s_Option();
  $thiz.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(spec.id$1, n, prop, msg, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
}
function $f_Lamf_core_errorhandling_ErrorHandler__warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V($thiz, specification, node, property, message, location) {
  var jsx$1 = $f_Lamf_core_errorhandling_ErrorHandler__lexical__pLamf_core_errorhandling_ErrorHandler__Lorg_mulesoft_lexer_SourceLocation__s_Option($thiz, location);
  var str = location.sourceName$1;
  $thiz.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V(specification, node, property, message, jsx$1, new $c_Lamf_core_utils_package$AmfStrings().init___T(str).option__s_Option())
}
function $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__T__V($thiz, specification, node, message, location) {
  var property = $m_s_None$();
  var lexical = $m_s_None$();
  var location$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T(location).option__s_Option();
  $thiz.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location$1)
}
function $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V($thiz, specification, node, message, annotations) {
  var property = $m_s_None$();
  var lexical = annotations.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  var this$1 = annotations.find__jl_Class__s_Option($d_Lamf_core_annotations_SourceLocation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var location = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$2 = $as_Lamf_core_annotations_SourceLocation(arg1);
    var location = new $c_s_Some().init___O(x$2.location$1)
  };
  $thiz.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
}
function $is_Lamf_core_errorhandling_ErrorHandler(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_errorhandling_ErrorHandler)))
}
function $as_Lamf_core_errorhandling_ErrorHandler(obj) {
  return (($is_Lamf_core_errorhandling_ErrorHandler(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.errorhandling.ErrorHandler"))
}
function $isArrayOf_Lamf_core_errorhandling_ErrorHandler(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_errorhandling_ErrorHandler)))
}
function $asArrayOf_Lamf_core_errorhandling_ErrorHandler(obj, depth) {
  return (($isArrayOf_Lamf_core_errorhandling_ErrorHandler(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.errorhandling.ErrorHandler;", depth))
}
function $f_Lamf_core_metamodel_MetaModelTypeMapping__metaModel__O__Lamf_core_metamodel_Obj($thiz, instance) {
  if ($is_Lamf_core_model_domain_AmfObject(instance)) {
    var x2 = $as_Lamf_core_model_domain_AmfObject(instance);
    return x2.meta__Lamf_core_metamodel_Obj()
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Missing metadata mapping for " + instance)))
  }
}
function $is_Lamf_core_metamodel_ModelDefaultBuilder(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_metamodel_ModelDefaultBuilder)))
}
function $as_Lamf_core_metamodel_ModelDefaultBuilder(obj) {
  return (($is_Lamf_core_metamodel_ModelDefaultBuilder(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.metamodel.ModelDefaultBuilder"))
}
function $isArrayOf_Lamf_core_metamodel_ModelDefaultBuilder(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_metamodel_ModelDefaultBuilder)))
}
function $asArrayOf_Lamf_core_metamodel_ModelDefaultBuilder(obj, depth) {
  return (($isArrayOf_Lamf_core_metamodel_ModelDefaultBuilder(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.metamodel.ModelDefaultBuilder;", depth))
}
function $is_Lamf_core_metamodel_Type(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_metamodel_Type)))
}
function $as_Lamf_core_metamodel_Type(obj) {
  return (($is_Lamf_core_metamodel_Type(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.metamodel.Type"))
}
function $isArrayOf_Lamf_core_metamodel_Type(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_metamodel_Type)))
}
function $asArrayOf_Lamf_core_metamodel_Type(obj, depth) {
  return (($isArrayOf_Lamf_core_metamodel_Type(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.metamodel.Type;", depth))
}
function $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  $thiz.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "description"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "description", "Human readable description of an element", $m_sci_Nil$()), true))
}
function $f_Lamf_core_metamodel_domain_common_DisplayNameField__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  $thiz.amf$core$metamodel$domain$common$DisplayNameField$$undsetter$und$DisplayName$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "displayName"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "display name", "Human readable name for the term", $m_sci_Nil$()), true))
}
function $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  $thiz.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "name"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "name", "Name of the shape", $m_sci_Nil$()), true))
}
function $f_Lamf_core_metamodel_domain_common_NameFieldShacl__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  $thiz.Name$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "name"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "name", "Additional name for the shape", $m_sci_Nil$()), true)
}
function $f_Lamf_core_model_ValueField__is__O__Z($thiz, other) {
  var this$1 = $thiz.option__s_Option();
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    return $m_sr_BoxesRunTime$().equals__O__O__Z(arg1, other)
  } else {
    return false
  }
}
function $f_Lamf_core_model_ValueField__toString__T($thiz) {
  var this$1 = $thiz.option__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var this$2 = new $c_s_Some().init___O($objectToString(arg1))
  };
  return $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()))
}
function $is_Lamf_core_model_ValueField(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_ValueField)))
}
function $as_Lamf_core_model_ValueField(obj) {
  return (($is_Lamf_core_model_ValueField(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.ValueField"))
}
function $isArrayOf_Lamf_core_model_ValueField(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_ValueField)))
}
function $asArrayOf_Lamf_core_model_ValueField(obj, depth) {
  return (($isArrayOf_Lamf_core_model_ValueField(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.ValueField;", depth))
}
function $f_Lamf_core_model_domain_AmfElement__isTrackedBy__T__Z($thiz, trackId) {
  var this$1 = $thiz.annotations__Lamf_core_parser_Annotations();
  var pf = new $c_Lamf_core_model_domain_AmfElement$$anonfun$isTrackedBy$1().init___Lamf_core_model_domain_AmfElement__T($thiz, trackId);
  var this$3 = this$1.amf$core$parser$Annotations$$annotations$1;
  var this$2 = $m_scm_ListBuffer$();
  var bf = this$2.ReusableCBFInstance$2;
  return $as_sc_Seq($f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this$3, pf, bf)).nonEmpty__Z()
}
function $f_Lamf_core_model_domain_AmfElement__location__s_Option($thiz) {
  var this$1 = $thiz.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_SourceLocation.getClassOf());
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_Lamf_core_annotations_SourceLocation(arg1);
    return new $c_s_Some().init___O(x$1.location$1)
  }
}
function $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement($thiz, annotation) {
  $thiz.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(annotation);
  return $thiz
}
function $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement($thiz, other) {
  $thiz.annotations__Lamf_core_parser_Annotations().$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(other);
  return $thiz
}
function $f_Lamf_core_model_domain_AmfElement__fromLocal__Z($thiz) {
  return $thiz.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LocalElement.getClassOf()).isDefined__Z()
}
function $is_Lamf_core_model_domain_AmfElement(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_domain_AmfElement)))
}
function $as_Lamf_core_model_domain_AmfElement(obj) {
  return (($is_Lamf_core_model_domain_AmfElement(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.AmfElement"))
}
function $isArrayOf_Lamf_core_model_domain_AmfElement(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_AmfElement)))
}
function $asArrayOf_Lamf_core_model_domain_AmfElement(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_AmfElement(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.AmfElement;", depth))
}
function $is_Lamf_core_model_domain_Annotation(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_domain_Annotation)))
}
function $as_Lamf_core_model_domain_Annotation(obj) {
  return (($is_Lamf_core_model_domain_Annotation(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.Annotation"))
}
function $isArrayOf_Lamf_core_model_domain_Annotation(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_Annotation)))
}
function $asArrayOf_Lamf_core_model_domain_Annotation(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_Annotation(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.Annotation;", depth))
}
function $is_Lamf_core_model_domain_AnnotationGraphLoader(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_domain_AnnotationGraphLoader)))
}
function $as_Lamf_core_model_domain_AnnotationGraphLoader(obj) {
  return (($is_Lamf_core_model_domain_AnnotationGraphLoader(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.AnnotationGraphLoader"))
}
function $isArrayOf_Lamf_core_model_domain_AnnotationGraphLoader(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_AnnotationGraphLoader)))
}
function $asArrayOf_Lamf_core_model_domain_AnnotationGraphLoader(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_AnnotationGraphLoader(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.AnnotationGraphLoader;", depth))
}
function $is_Lamf_core_model_domain_UriAnnotation(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_domain_UriAnnotation)))
}
function $as_Lamf_core_model_domain_UriAnnotation(obj) {
  return (($is_Lamf_core_model_domain_UriAnnotation(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.UriAnnotation"))
}
function $isArrayOf_Lamf_core_model_domain_UriAnnotation(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_UriAnnotation)))
}
function $asArrayOf_Lamf_core_model_domain_UriAnnotation(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_UriAnnotation(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.UriAnnotation;", depth))
}
function $is_Lamf_core_parser_BaseSpecParser(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_parser_BaseSpecParser)))
}
function $as_Lamf_core_parser_BaseSpecParser(obj) {
  return (($is_Lamf_core_parser_BaseSpecParser(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.BaseSpecParser"))
}
function $isArrayOf_Lamf_core_parser_BaseSpecParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_BaseSpecParser)))
}
function $asArrayOf_Lamf_core_parser_BaseSpecParser(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_BaseSpecParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.BaseSpecParser;", depth))
}
function $f_Lamf_core_parser_FutureDeclarations__resolveRef__T__Lamf_core_model_domain_Linkable__V($thiz, name, value) {
  var this$1 = $thiz.promises$1;
  var x1 = this$1.get__O__s_Option(name);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var v = x2.value$2;
    var jsx$1 = v
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var jsx$1 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
  };
  $as_sc_IterableLike(jsx$1).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, value$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_parser_DeclarationPromise(x$1$2);
      x$1.resolve__Lamf_core_model_domain_Linkable__V(value$1)
    })
  })($thiz, value)));
  $thiz.promises$1.update__O__O__V(name, $m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
}
function $f_Lamf_core_parser_FutureDeclarations__$$init$__V($thiz) {
  $thiz.promises$1 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()))
}
function $f_Lamf_core_parser_FutureDeclarations__resolve__V($thiz) {
  $as_sc_IterableLike($as_sc_TraversableLike($thiz.promises$1.values__sc_Iterable().flatten__F1__sc_GenTraversable($m_s_Predef$().singleton$und$less$colon$less$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_parser_DeclarationPromise(x$2$2);
      return (!x$2.resolved$1)
    })
  })($thiz)))).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_core_parser_DeclarationPromise(x$3$2);
      x$3.fail__V()
    })
  })($thiz)))
}
function $f_Lamf_core_parser_FutureDeclarations__futureRef__T__T__Lamf_core_parser_DeclarationPromise__V($thiz, id, name, promise) {
  var this$1 = $thiz.promises$1;
  var x1 = this$1.get__O__s_Option(name);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var v = x2.value$2;
    var jsx$1 = v
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var jsx$1 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
  };
  var otherPromises = $as_sc_Seq(jsx$1);
  var jsx$4 = $thiz.promises$1;
  var jsx$3 = $m_sc_Seq$();
  var array = [promise];
  var jsx$2 = jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
  var this$4 = $m_sc_Seq$();
  jsx$4.update__O__O__V(name, otherPromises.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$4.ReusableCBFInstance$2))
}
function $is_Lamf_core_parser_ReferenceKind(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_parser_ReferenceKind)))
}
function $as_Lamf_core_parser_ReferenceKind(obj) {
  return (($is_Lamf_core_parser_ReferenceKind(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.ReferenceKind"))
}
function $isArrayOf_Lamf_core_parser_ReferenceKind(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_ReferenceKind)))
}
function $asArrayOf_Lamf_core_parser_ReferenceKind(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_ReferenceKind(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.ReferenceKind;", depth))
}
function $is_Lamf_core_parser_SearchScope$Scope(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_parser_SearchScope$Scope)))
}
function $as_Lamf_core_parser_SearchScope$Scope(obj) {
  return (($is_Lamf_core_parser_SearchScope$Scope(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.SearchScope$Scope"))
}
function $isArrayOf_Lamf_core_parser_SearchScope$Scope(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_SearchScope$Scope)))
}
function $asArrayOf_Lamf_core_parser_SearchScope$Scope(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_SearchScope$Scope(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.SearchScope$Scope;", depth))
}
function $is_Lamf_core_parser_TypedNode(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_parser_TypedNode)))
}
function $as_Lamf_core_parser_TypedNode(obj) {
  return (($is_Lamf_core_parser_TypedNode(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.TypedNode"))
}
function $isArrayOf_Lamf_core_parser_TypedNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_TypedNode)))
}
function $asArrayOf_Lamf_core_parser_TypedNode(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_TypedNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.TypedNode;", depth))
}
function $f_Lamf_core_parser_UnresolvedReference__withContext__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement($thiz, c) {
  $thiz.ctx$3 = new $c_s_Some().init___O(c);
  return $as_Lamf_core_model_domain_DomainElement($thiz)
}
function $f_Lamf_core_rdf_RdfFramework__syntaxToRdfModel__T__jl_CharSequence__s_Option($thiz, mediaType, text) {
  var model = new $c_Lamf_plugins_features_validation_RdflibRdfModel().init___sjs_js_Dynamic($m_Lamf_plugins_features_validation_RdflibRdfModel$().$$lessinit$greater$default$1__sjs_js_Dynamic());
  model.load__T__T__V(mediaType, $objectToString(text));
  return new $c_s_Some().init___O(new $c_Lamf_core_rdf_RdfModelDocument().init___Lamf_core_rdf_RdfModel(model))
}
function $f_Lamf_core_rdf_RdfFramework__unitToRdfModel__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__Lamf_core_rdf_RdfModel($thiz, unit, options) {
  var model = new $c_Lamf_plugins_features_validation_RdflibRdfModel().init___sjs_js_Dynamic($m_Lamf_plugins_features_validation_RdflibRdfModel$().$$lessinit$greater$default$1__sjs_js_Dynamic());
  new $c_Lamf_core_rdf_RdfModelEmitter().init___Lamf_core_rdf_RdfModel(model).emit__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__V(unit, options);
  return model
}
function $is_Lamf_core_rdf_RdfFramework(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_rdf_RdfFramework)))
}
function $as_Lamf_core_rdf_RdfFramework(obj) {
  return (($is_Lamf_core_rdf_RdfFramework(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.rdf.RdfFramework"))
}
function $isArrayOf_Lamf_core_rdf_RdfFramework(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_rdf_RdfFramework)))
}
function $asArrayOf_Lamf_core_rdf_RdfFramework(obj, depth) {
  return (($isArrayOf_Lamf_core_rdf_RdfFramework(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.rdf.RdfFramework;", depth))
}
function $f_Lamf_core_rdf_RdfParserCommon__value__Lamf_core_metamodel_Type__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode($thiz, t, node) {
  _value: while (true) {
    var this$1 = node;
    var x1 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
    var x$2 = $m_Lorg_yaml_model_YType$().Seq$1;
    if ((x$2 === x1)) {
      if ((t instanceof $c_Lamf_core_metamodel_Type$Array)) {
        return node
      } else {
        var this$2 = node;
        var conversion = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
        var iv = $thiz.ctx__Lamf_core_rdf_RdfParserContext();
        node = $as_Lorg_yaml_model_YNode($as_sc_IterableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv)).head__O());
        continue _value
      }
    } else {
      var x$4 = $m_Lorg_yaml_model_YType$().Map$1;
      if ((x$4 === x1)) {
        var this$3 = node;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv$1 = $thiz.ctx__Lamf_core_rdf_RdfParserContext();
        var m = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion$1, iv$1));
        var x$6 = $m_Lamf_core_metamodel_Type$Iri$();
        if (x$6.equals__O__Z(t)) {
          return $as_Lorg_yaml_model_YMapEntry(new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(m).key__T__s_Option("@id").get__O()).value$2
        } else {
          var x$8 = $m_Lamf_core_metamodel_Type$Str$();
          if (x$8.equals__O__Z(t)) {
            var jsx$1 = true
          } else {
            var x$10 = $m_Lamf_core_metamodel_Type$RegExp$();
            if (x$10.equals__O__Z(t)) {
              var jsx$1 = true
            } else {
              var x$12 = $m_Lamf_core_metamodel_Type$Bool$();
              if (x$12.equals__O__Z(t)) {
                var jsx$1 = true
              } else {
                var x$14 = $m_Lamf_core_metamodel_Type$Int$();
                if (x$14.equals__O__Z(t)) {
                  var jsx$1 = true
                } else {
                  var x$16 = $m_Lamf_core_metamodel_Type$Any$();
                  var jsx$1 = (x$16 === t)
                }
              }
            }
          };
          if (jsx$1) {
            return $as_Lorg_yaml_model_YMapEntry(new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(m).key__T__s_Option("@value").get__O()).value$2
          } else {
            return node
          }
        }
      } else {
        return node
      }
    }
  }
}
function $f_Lamf_core_rdf_RdfParserCommon__annots__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations($thiz, sources, key) {
  var nodes = $thiz.ctx__Lamf_core_rdf_RdfParserContext().nodes$2;
  var this$1 = $f_Lamf_core_rdf_RdfParserCommon__annotations__pLamf_core_rdf_RdfParserCommon__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations($thiz, nodes, sources, key);
  var collector = $thiz.ctx__Lamf_core_rdf_RdfParserContext().collected$2;
  var f = (function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_domain_Annotation(x$1$2);
      return $is_Lamf_core_model_domain_ResolvableAnnotation(x$1)
    })
  })($thiz);
  var this$2 = this$1.amf$core$parser$Annotations$$annotations$1;
  if ((this$2 instanceof $c_sci_List)) {
    var x2 = $as_sci_List(this$2);
    var l = x2;
    var l$1 = l;
    x: {
      var result;
      _noneIn: while (true) {
        if (l$1.isEmpty__Z()) {
          var result = $m_sci_Nil$();
          break
        } else {
          var h = l$1.head__O();
          var t = $as_sci_List(l$1.tail__O());
          if (($uZ(f(h)) === false)) {
            l$1 = t;
            continue _noneIn
          };
          var start = l$1;
          var remaining = t;
          var remaining$1 = remaining;
          _allIn: while (true) {
            if (remaining$1.isEmpty__Z()) {
              var result = start;
              break x
            } else {
              var x$2 = remaining$1.head__O();
              if (($uZ(f(x$2)) !== false)) {
                remaining$1 = $as_sci_List(remaining$1.tail__O());
                continue _allIn
              };
              var firstMiss = remaining$1;
              var newHead = new $c_sci_$colon$colon().init___O__sci_List(start.head__O(), $m_sci_Nil$());
              var toProcess = $as_sci_List(start.tail__O());
              var currentLast = newHead;
              while ((toProcess !== firstMiss)) {
                var newElem = new $c_sci_$colon$colon().init___O__sci_List(toProcess.head__O(), $m_sci_Nil$());
                currentLast.tl$5 = newElem;
                currentLast = newElem;
                toProcess = $as_sci_List(toProcess.tail__O())
              };
              var next = $as_sci_List(firstMiss.tail__O());
              var nextToCopy = next;
              while ((!next.isEmpty__Z())) {
                var head = next.head__O();
                if (($uZ(f(head)) !== false)) {
                  next = $as_sci_List(next.tail__O())
                } else {
                  while ((nextToCopy !== next)) {
                    var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy.head__O(), $m_sci_Nil$());
                    currentLast.tl$5 = newElem$2;
                    currentLast = newElem$2;
                    nextToCopy = $as_sci_List(nextToCopy.tail__O())
                  };
                  nextToCopy = $as_sci_List(next.tail__O());
                  next = $as_sci_List(next.tail__O())
                }
              };
              if ((!nextToCopy.isEmpty__Z())) {
                currentLast.tl$5 = nextToCopy
              };
              var result = newHead;
              break x
            }
          }
        }
      }
    };
    var jsx$1 = result
  } else {
    $m_scm_ListBuffer$();
    var b = new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_ListBuffer().init___());
    var this$4 = this$2.scala$collection$mutable$ListBuffer$$start$6;
    var these = this$4;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      if (($uZ(f(arg1)) !== false)) {
        b.$$plus$eq__O__scm_GrowingBuilder(arg1)
      };
      these = $as_sci_List(these.tail__O())
    };
    var jsx$1 = b.elems$1
  };
  collector.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer($as_sc_TraversableOnce(jsx$1));
  return this$1
}
function $f_Lamf_core_rdf_RdfParserCommon__annotations__pLamf_core_rdf_RdfParserCommon__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations($thiz, nodes, sources, key) {
  $m_Lamf_core_parser_Annotations$();
  var result = new $c_Lamf_core_parser_Annotations().init___();
  var this$2 = sources.annotations$1;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$2)) {
    var this$3 = sources.annotations$1;
    var this$4 = this$3.elems$5;
    var this$5 = new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$4);
    while (this$5.hasNext__Z()) {
      var arg1 = this$5.next__O();
      var x0$1 = $as_T2(arg1);
      matchEnd4$2: {
        if ((x0$1 !== null)) {
          var annotation = $as_T(x0$1.$$und1__O());
          var values = $as_scm_ListMap(x0$1.$$und2__O());
          if ((values !== null)) {
            matchEnd4: {
              var o7 = $m_Lamf_core_model_domain_Annotation$().unapply__T__s_Option(annotation);
              if ((!o7.isEmpty__Z())) {
                var deserialize = $as_F2(o7.get__O());
                if ($f_sc_MapLike__contains__O__Z(values, key)) {
                  var this$6 = $as_s_Option(deserialize.apply__O__O__O($f_sc_MapLike__apply__O__O(values, key), nodes));
                  if ((!this$6.isEmpty__Z())) {
                    var arg1$1 = this$6.get__O();
                    var x$2 = $as_Lamf_core_model_domain_Annotation(arg1$1);
                    result.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(x$2)
                  };
                  break matchEnd4
                }
              }
            };
            break matchEnd4$2
          }
        };
        throw new $c_s_MatchError().init___O(x0$1)
      }
    }
  };
  return result
}
function $f_Lamf_core_rdf_converter_Converter__conversionValidation__T__Lamf_core_errorhandling_ErrorHandler__s_None$($thiz, message, errorHandler) {
  var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnableToConvertToScalar$1;
  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__T__V(errorHandler, specification, "", message, "");
  return $m_s_None$()
}
function $is_Lamf_core_registries_AMFDomainEntityResolver(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_registries_AMFDomainEntityResolver)))
}
function $as_Lamf_core_registries_AMFDomainEntityResolver(obj) {
  return (($is_Lamf_core_registries_AMFDomainEntityResolver(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.registries.AMFDomainEntityResolver"))
}
function $isArrayOf_Lamf_core_registries_AMFDomainEntityResolver(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_registries_AMFDomainEntityResolver)))
}
function $asArrayOf_Lamf_core_registries_AMFDomainEntityResolver(obj, depth) {
  return (($isArrayOf_Lamf_core_registries_AMFDomainEntityResolver(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.registries.AMFDomainEntityResolver;", depth))
}
function $f_Lamf_core_remote_FileMediaType__extension__T__s_Option($thiz, path) {
  var this$3 = new $c_s_Some().init___O($uI(path.lastIndexOf(".")));
  var arg1 = this$3.value$2;
  var x$1 = $uI(arg1);
  if ((x$1 > 0)) {
    var this$4 = this$3
  } else {
    var this$4 = $m_s_None$()
  };
  if (this$4.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1$1 = this$4.get__O();
    var dot = $uI(arg1$1);
    var beginIndex = ((1 + dot) | 0);
    return new $c_s_Some().init___O($as_T(path.substring(beginIndex)))
  }
}
function $f_Lamf_core_remote_FileMediaType__mimeFromExtension__T__s_Option($thiz, extension) {
  return ((extension === "json") ? new $c_s_Some().init___O($m_Lamf_core_remote_Mimes$().APPLICATION$divJSON$1) : (((extension === "yaml") || ((extension === "yam") || (extension === "yml"))) ? new $c_s_Some().init___O($m_Lamf_core_remote_Mimes$().APPLICATION$divYAML$1) : ((extension === "raml") ? new $c_s_Some().init___O($m_Lamf_core_remote_Mimes$().APPLICATION$divRAML$plusYAML$1) : ((extension === "openapi") ? new $c_s_Some().init___O($m_Lamf_core_remote_Mimes$().APPLICATION$divOPENAPI$plusJSON$1) : (((extension === "jsonld") || (extension === "amf")) ? new $c_s_Some().init___O($m_Lamf_core_remote_Mimes$().APPLICATION$divLD$plusJSONLD$1) : $m_s_None$())))))
}
function $is_Lamf_core_remote_Syntax$Syntax(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_remote_Syntax$Syntax)))
}
function $as_Lamf_core_remote_Syntax$Syntax(obj) {
  return (($is_Lamf_core_remote_Syntax$Syntax(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.remote.Syntax$Syntax"))
}
function $isArrayOf_Lamf_core_remote_Syntax$Syntax(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_remote_Syntax$Syntax)))
}
function $asArrayOf_Lamf_core_remote_Syntax$Syntax(obj, depth) {
  return (($isArrayOf_Lamf_core_remote_Syntax$Syntax(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.remote.Syntax$Syntax;", depth))
}
function $f_Lamf_core_remote_Vendor__isRaml__Z($thiz) {
  var x$2 = $m_Lamf_core_remote_Raml$();
  if (($thiz === x$2)) {
    var jsx$1 = true
  } else {
    var x$4 = $m_Lamf_core_remote_Raml10$();
    var jsx$1 = ($thiz === x$4)
  };
  if (jsx$1) {
    return true
  } else {
    var x$6 = $m_Lamf_core_remote_Raml08$();
    return ($thiz === x$6)
  }
}
function $is_Lamf_core_remote_Vendor(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_remote_Vendor)))
}
function $as_Lamf_core_remote_Vendor(obj) {
  return (($is_Lamf_core_remote_Vendor(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.remote.Vendor"))
}
function $isArrayOf_Lamf_core_remote_Vendor(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_remote_Vendor)))
}
function $asArrayOf_Lamf_core_remote_Vendor(obj, depth) {
  return (($isArrayOf_Lamf_core_remote_Vendor(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.remote.Vendor;", depth))
}
function $is_Lamf_core_services_RuntimeCompiler(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_services_RuntimeCompiler)))
}
function $as_Lamf_core_services_RuntimeCompiler(obj) {
  return (($is_Lamf_core_services_RuntimeCompiler(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.services.RuntimeCompiler"))
}
function $isArrayOf_Lamf_core_services_RuntimeCompiler(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_services_RuntimeCompiler)))
}
function $asArrayOf_Lamf_core_services_RuntimeCompiler(obj, depth) {
  return (($isArrayOf_Lamf_core_services_RuntimeCompiler(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.services.RuntimeCompiler;", depth))
}
function $is_Lamf_core_services_RuntimeSerializer(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_services_RuntimeSerializer)))
}
function $as_Lamf_core_services_RuntimeSerializer(obj) {
  return (($is_Lamf_core_services_RuntimeSerializer(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.services.RuntimeSerializer"))
}
function $isArrayOf_Lamf_core_services_RuntimeSerializer(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_services_RuntimeSerializer)))
}
function $asArrayOf_Lamf_core_services_RuntimeSerializer(obj, depth) {
  return (($isArrayOf_Lamf_core_services_RuntimeSerializer(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.services.RuntimeSerializer;", depth))
}
function $is_Lamf_core_validation_PayloadValidator(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_validation_PayloadValidator)))
}
function $as_Lamf_core_validation_PayloadValidator(obj) {
  return (($is_Lamf_core_validation_PayloadValidator(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.PayloadValidator"))
}
function $isArrayOf_Lamf_core_validation_PayloadValidator(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_PayloadValidator)))
}
function $asArrayOf_Lamf_core_validation_PayloadValidator(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_PayloadValidator(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.PayloadValidator;", depth))
}
function $f_Lamf_core_validation_ValidationResultProcessor__buildValidationResult__Lamf_core_model_document_BaseUnit__Lamf_core_validation_core_ValidationResult__Lamf_MessageStyle__Lamf_core_validation_EffectiveValidations__s_Option($thiz, model, result, messageStyle, validations) {
  var thiz = result.sourceShape__T();
  var prefix = $m_Lamf_core_vocabulary_Namespace$().Data$1.base$1;
  if ((($uI(thiz.length) >= 0) && ($as_T(thiz.substring(0, $uI(prefix.length))) === prefix))) {
    var thiz$1 = result.sourceShape__T();
    var target = $m_Lamf_core_vocabulary_Namespace$().Data$1.base$1;
    var validationSpecToLook = $as_T(thiz$1.split(target).join(""))
  } else {
    var validationSpecToLook = result.sourceShape__T()
  };
  var idMapping = $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x1 = validations.all$1.get__O__s_Option(validationSpecToLook);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var validationSpec = $as_Lamf_core_validation_core_ValidationSpecification(x2.value$2);
    idMapping.put__O__O__s_Option(result.sourceShape__T(), validationSpecToLook);
    var maybeTargetSpec = new $c_s_Some().init___O(validationSpec)
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var this$8 = validations.all$1;
    var this$9 = this$8.iterator__sc_Iterator();
    inlinereturn$13: {
      while (this$9.hasNext__Z()) {
        var a = this$9.next__O();
        var x0$1 = $as_T2(a);
        if ((x0$1 === null)) {
          throw new $c_s_MatchError().init___O(x0$1)
        };
        var v = $as_T(x0$1.$$und1__O());
        if ((($uI(validationSpecToLook.length) >= 0) && ($as_T(validationSpecToLook.substring(0, $uI(v.length))) === v))) {
          var x1$2 = new $c_s_Some().init___O(a);
          break inlinereturn$13
        }
      };
      var x1$2 = $m_s_None$()
    };
    matchEnd6: {
      var maybeTargetSpec;
      if ((x1$2 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$2);
        var p3 = $as_T2(x2$2.value$2);
        if ((p3 !== null)) {
          var v$1 = $as_T(p3.$$und1__O());
          var spec = $as_Lamf_core_validation_core_ValidationSpecification(p3.$$und2__O());
          idMapping.put__O__O__s_Option(result.sourceShape__T(), v$1);
          var maybeTargetSpec = new $c_s_Some().init___O(spec);
          break matchEnd6
        }
      };
      var x$3 = $m_s_None$();
      if ((x$3 === x1$2)) {
        if ((!(($uI(validationSpecToLook.length) >= 0) && ($as_T(validationSpecToLook.substring(0, $uI("_:".length))) === "_:")))) {
          throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot find validation spec for validation error:\n " + result)))
        };
        var maybeTargetSpec = $m_s_None$();
        break matchEnd6
      };
      throw new $c_s_MatchError().init___O(x1$2)
    }
  };
  if ((maybeTargetSpec instanceof $c_s_Some)) {
    var x2$3 = $as_s_Some(maybeTargetSpec);
    var targetSpec = $as_Lamf_core_validation_core_ValidationSpecification(x2$3.value$2);
    var x$5 = $m_Lamf_RAMLStyle$();
    if ((x$5 === messageStyle)) {
      var this$20 = targetSpec.ramlMessage$1;
      var message = $as_T((this$20.isEmpty__Z() ? targetSpec.message$1 : this$20.get__O()))
    } else {
      var x$7 = $m_Lamf_OASStyle$();
      if ((x$7 === messageStyle)) {
        var this$21 = targetSpec.oasMessage$1;
        var message = $as_T((this$21.isEmpty__Z() ? targetSpec.message$1 : this$21.get__O()))
      } else {
        var this$22 = $m_s_Option$().apply__O__s_Option(targetSpec.message$1);
        if (this$22.isEmpty__Z()) {
          var this$23 = result.message__s_Option();
          var jsx$1 = $as_T((this$23.isEmpty__Z() ? "" : this$23.get__O()))
        } else {
          var jsx$1 = this$22.get__O()
        };
        var message = $as_T(jsx$1)
      }
    };
    if (($m_s_Option$().apply__O__s_Option(message).isEmpty__Z() || (message === ""))) {
      var this$24 = result.message__s_Option();
      message = $as_T((this$24.isEmpty__Z() ? "Constraint violation" : this$24.get__O()))
    };
    if (targetSpec.isParserSide__Z()) {
      var this$25 = result.message__s_Option();
      var jsx$2 = this$25.isDefined__Z()
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      message = $as_T(result.message__s_Option().get__O())
    };
    var thiz$2 = $as_T(idMapping.apply__O__O(result.sourceShape__T()));
    if ((($uI(thiz$2.length) >= 0) && ($as_T(thiz$2.substring(0, $uI("http".length))) === "http"))) {
      var finalId = $as_T(idMapping.apply__O__O(result.sourceShape__T()))
    } else {
      var finalId = (("" + $m_Lamf_core_vocabulary_Namespace$().Data$1.base$1) + idMapping.apply__O__O(result.sourceShape__T()))
    };
    var id = $as_T(idMapping.apply__O__O(result.sourceShape__T()));
    var severity = $f_Lamf_core_validation_ValidationResultProcessor__findLevel__T__Lamf_core_validation_EffectiveValidations__T__T($thiz, id, validations, "");
    var validation = $m_Lamf_core_validation_AMFValidationResult$().fromSHACLValidation__Lamf_core_model_document_BaseUnit__T__T__Lamf_core_validation_core_ValidationResult__Lamf_core_validation_AMFValidationResult(model, message, severity, result);
    var message$1 = validation.message$1;
    var level = validation.level$1;
    var targetNode = validation.targetNode$1;
    var targetProperty = validation.targetProperty$1;
    var position = validation.position$1;
    var location = validation.location$1;
    var source = validation.source$1;
    return new $c_s_Some().init___O(new $c_Lamf_core_validation_AMFValidationResult().init___T__T__T__s_Option__T__s_Option__s_Option__O(message$1, level, targetNode, targetProperty, finalId, position, location, source))
  } else {
    return $m_s_None$()
  }
}
function $f_Lamf_core_validation_ValidationResultProcessor__processAggregatedResult__Lamf_core_validation_AMFValidationResult__Lamf_MessageStyle__Lamf_core_validation_EffectiveValidations__Lamf_core_validation_AMFValidationResult($thiz, result, messageStyle, validations) {
  var x1 = result.message$1;
  var message = ((x1 === "") ? "Constraint violation" : x1);
  var id = result.validationId$1;
  var level = result.level$1;
  var severity = $f_Lamf_core_validation_ValidationResultProcessor__findLevel__T__Lamf_core_validation_EffectiveValidations__T__T($thiz, id, validations, level);
  return new $c_Lamf_core_validation_AMFValidationResult().init___T__T__T__s_Option__T__s_Option__s_Option__O(message, severity, result.targetNode$1, result.targetProperty$1, result.validationId$1, result.position$1, result.location$1, result.source$1)
}
function $f_Lamf_core_validation_ValidationResultProcessor__findLevel__T__Lamf_core_validation_EffectiveValidations__T__T($thiz, id, validations, level) {
  return (validations.info$1.get__O__s_Option(id).isDefined__Z() ? $m_Lamf_core_validation_SeverityLevels$().INFO$1 : (validations.warning$1.get__O__s_Option(id).isDefined__Z() ? $m_Lamf_core_validation_SeverityLevels$().WARNING$1 : (validations.violation$1.get__O__s_Option(id).isDefined__Z() ? $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1 : $m_Lamf_core_validation_SeverityLevels$().unapply__T__T(level))))
}
function $is_Lamf_core_validation_core_ValidationReport(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_validation_core_ValidationReport)))
}
function $as_Lamf_core_validation_core_ValidationReport(obj) {
  return (($is_Lamf_core_validation_core_ValidationReport(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.core.ValidationReport"))
}
function $isArrayOf_Lamf_core_validation_core_ValidationReport(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_core_ValidationReport)))
}
function $asArrayOf_Lamf_core_validation_core_ValidationReport(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_core_ValidationReport(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.core.ValidationReport;", depth))
}
function $is_Lamf_core_validation_core_ValidationResult(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_validation_core_ValidationResult)))
}
function $as_Lamf_core_validation_core_ValidationResult(obj) {
  return (($is_Lamf_core_validation_core_ValidationResult(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.core.ValidationResult"))
}
function $isArrayOf_Lamf_core_validation_core_ValidationResult(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_core_ValidationResult)))
}
function $asArrayOf_Lamf_core_validation_core_ValidationResult(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_core_ValidationResult(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.core.ValidationResult;", depth))
}
function $is_Lamf_internal_reference_ReferenceResolver(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_internal_reference_ReferenceResolver)))
}
function $as_Lamf_internal_reference_ReferenceResolver(obj) {
  return (($is_Lamf_internal_reference_ReferenceResolver(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.internal.reference.ReferenceResolver"))
}
function $isArrayOf_Lamf_internal_reference_ReferenceResolver(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_internal_reference_ReferenceResolver)))
}
function $asArrayOf_Lamf_internal_reference_ReferenceResolver(obj, depth) {
  return (($isArrayOf_Lamf_internal_reference_ReferenceResolver(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.internal.reference.ReferenceResolver;", depth))
}
function $is_Lamf_internal_resource_ResourceLoader(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_internal_resource_ResourceLoader)))
}
function $as_Lamf_internal_resource_ResourceLoader(obj) {
  return (($is_Lamf_internal_resource_ResourceLoader(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.internal.resource.ResourceLoader"))
}
function $isArrayOf_Lamf_internal_resource_ResourceLoader(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_internal_resource_ResourceLoader)))
}
function $asArrayOf_Lamf_internal_resource_ResourceLoader(obj, depth) {
  return (($isArrayOf_Lamf_internal_resource_ResourceLoader(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.internal.resource.ResourceLoader;", depth))
}
function $f_Lamf_plugins_document_graph_emitter_CommonEmitter__extractDeclarationsAndReferencesToContext__s_Option__s_Option__Lamf_core_parser_Annotations__Lamf_plugins_document_graph_emitter_EmissionContext__Lamf_plugins_document_graph_emitter_EmissionContext($thiz, declaresEntry, referencesEntry, annotations, ctx) {
  if (declaresEntry.isEmpty__Z()) {
    var this$1 = $m_s_None$()
  } else {
    var arg1 = declaresEntry.get__O();
    var x$1 = $as_Lamf_core_parser_FieldEntry(arg1);
    var this$1 = new $c_s_Some().init___O($as_Lamf_core_model_domain_AmfArray(x$1.value$1.value$1).values$1)
  };
  var declaredElements = $as_sc_Iterable((this$1.isEmpty__Z() ? $m_sci_Nil$() : this$1.get__O()));
  if (referencesEntry.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1$1 = referencesEntry.get__O();
    var x$2 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    var this$2 = new $c_s_Some().init___O($as_Lamf_core_model_domain_AmfArray(x$2.value$1.value$1).values$1)
  };
  var referencedElements = $as_sc_Iterable((this$2.isEmpty__Z() ? $m_sci_Nil$() : this$2.get__O()));
  var this$3 = annotations.find__jl_Class__s_Option($d_Lamf_core_annotations_Declares.getClassOf());
  if (this$3.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1$2 = this$3.get__O();
    var x$3 = $as_Lamf_core_annotations_Declares(arg1$2);
    var this$4 = new $c_s_Some().init___O(x$3.declares$1)
  };
  var declaredIds = $as_sc_Seq((this$4.isEmpty__Z() ? $m_sci_Nil$() : this$4.get__O()));
  var this$5 = annotations.find__jl_Class__s_Option($d_Lamf_core_annotations_References.getClassOf());
  if (this$5.isEmpty__Z()) {
    var this$6 = $m_s_None$()
  } else {
    var arg1$3 = this$5.get__O();
    var x$4 = $as_Lamf_core_annotations_References(arg1$3);
    var this$6 = new $c_s_Some().init___O(x$4.references$1)
  };
  var referencedIds = $as_sc_Seq((this$6.isEmpty__Z() ? $m_sci_Nil$() : this$6.get__O()));
  var this$7 = $m_sc_Seq$();
  ctx.registerDeclaredAndReferencedFromAnnotations__sc_Seq__Lamf_plugins_document_graph_emitter_EmissionContext($as_sc_Seq(declaredIds.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(referencedIds, this$7.ReusableCBFInstance$2)));
  ctx.$$plus$plus__sc_Iterable__Lamf_plugins_document_graph_emitter_EmissionContext(declaredElements);
  return ctx.addReferences__sc_Iterable__Lamf_plugins_document_graph_emitter_EmissionContext(referencedElements)
}
function $f_Lamf_plugins_document_graph_emitter_CommonEmitter__createTypeNode__Lorg_yaml_builder_DocBuilder$Entry__sci_List__Lamf_plugins_document_graph_emitter_EmissionContext__V($thiz, b, types, ctx) {
  b.entry__T__F1__V("@type", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, types$1, ctx$1) {
    return (function(x$6$2) {
      var x$6 = $as_Lorg_yaml_builder_DocBuilder$Part(x$6$2);
      x$6.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, types$1$1, ctx$1$1) {
        return (function(b$2) {
          var b$1 = $as_Lorg_yaml_builder_DocBuilder$Part(b$2);
          var this$1 = $as_sci_List($f_sc_SeqLike__distinct__O(types$1$1));
          var these = this$1;
          while ((!these.isEmpty__Z())) {
            var arg1 = these.head__O();
            var t = $as_T(arg1);
            var content = ctx$1$1.emitIri__T__T(t);
            b$1.$$plus$eq__T__V(content);
            these = $as_sci_List(these.tail__O())
          }
        })
      })($this, types$1, ctx$1)))
    })
  })($thiz, types, ctx)))
}
function $f_Lamf_plugins_document_graph_emitter_CommonEmitter__createTypeNode__Lorg_yaml_builder_DocBuilder$Entry__Lamf_core_metamodel_Obj__Lamf_plugins_document_graph_emitter_EmissionContext__V($thiz, b, obj, ctx) {
  var types = $f_Lamf_plugins_document_graph_emitter_CommonEmitter__getTypesAsIris__Lamf_core_metamodel_Obj__sci_List($thiz, obj);
  $f_Lamf_plugins_document_graph_emitter_CommonEmitter__createTypeNode__Lorg_yaml_builder_DocBuilder$Entry__sci_List__Lamf_plugins_document_graph_emitter_EmissionContext__V($thiz, b, types, ctx)
}
function $f_Lamf_plugins_document_graph_emitter_CommonEmitter__sourceMapIdFor__T__T($thiz, id) {
  return ($m_sjsr_RuntimeString$().endsWith__T__T__Z(id, "/") ? (id + "source-map") : ((($uI(id.indexOf("#")) !== (-1)) || (($uI(id.length) >= 0) && ($as_T(id.substring(0, $uI("null".length))) === "null"))) ? (id + "/source-map") : (id + "#/source-map")))
}
function $f_Lamf_plugins_document_graph_emitter_CommonEmitter__getTypesAsIris__Lamf_core_metamodel_Obj__sci_List($thiz, obj) {
  var this$2 = obj.type__sci_List();
  var f = (function($this) {
    return (function(x$5$2) {
      var x$5 = $as_Lamf_core_vocabulary_ValueType(x$5$2);
      return x$5.iri__T()
    })
  })($thiz);
  var this$1 = $m_sci_List$();
  var bf = this$1.ReusableCBFInstance$2;
  if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
    if ((this$2 === $m_sci_Nil$())) {
      var jsx$1 = $m_sci_Nil$()
    } else {
      var arg1 = this$2.head__O();
      var h = new $c_sci_$colon$colon().init___O__sci_List(f(arg1), $m_sci_Nil$());
      var t = h;
      var rest = $as_sci_List(this$2.tail__O());
      while ((rest !== $m_sci_Nil$())) {
        var arg1$1 = rest.head__O();
        var nx = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$1), $m_sci_Nil$());
        t.tl$5 = nx;
        t = nx;
        rest = $as_sci_List(rest.tail__O())
      };
      var jsx$1 = h
    }
  } else {
    var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$2, bf);
    var these = this$2;
    while ((!these.isEmpty__Z())) {
      var arg1$2 = these.head__O();
      b.$$plus$eq__O__scm_Builder(f(arg1$2));
      these = $as_sci_List(these.tail__O())
    };
    var jsx$1 = b.result__O()
  };
  return $as_sci_List(jsx$1)
}
function $f_Lamf_plugins_document_graph_emitter_CommonEmitter__getMetaModelFields__Lamf_core_model_domain_AmfObject__Lamf_core_metamodel_Obj__sc_Seq($thiz, element, obj) {
  var fields = $m_Lamf_plugins_document_graph_MetaModelHelper$().fieldsFrom__Lamf_core_metamodel_Obj__sc_Seq(obj);
  if ($is_Lamf_core_model_domain_ExternalSourceElement(element)) {
    var x2 = $as_Lamf_core_model_domain_ExternalSourceElement(element);
    if ($f_Lamf_core_model_domain_ExternalSourceElement__isLinkToSource__Z(x2)) {
      return $as_sc_Seq(fields.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(f$2) {
          var f = $as_Lamf_core_metamodel_Field(f$2);
          var x$2 = $m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1;
          return (!((f === null) ? (x$2 === null) : f.equals__O__Z(x$2)))
        })
      })($thiz))))
    }
  };
  return fields
}
function $f_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata__$$init$__V($thiz) {
  $thiz.id$und$eq__s_Option__V($m_s_None$());
  $thiz.isDeclaration$und$eq__Z__V(false);
  $thiz.isReference$und$eq__Z__V(false);
  $thiz.isExternal$und$eq__Z__V(false)
}
function $is_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_document_graph_emitter_flattened_utils_Metadata)))
}
function $as_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata(obj) {
  return (($is_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.graph.emitter.flattened.utils.Metadata"))
}
function $isArrayOf_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_graph_emitter_flattened_utils_Metadata)))
}
function $asArrayOf_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.graph.emitter.flattened.utils.Metadata;", depth))
}
function $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__retrieveId__Lorg_yaml_model_YMap__Lamf_core_parser_ParserContext__s_Option($thiz, map, ctx) {
  var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("@id");
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    var this$2 = entry.value$2;
    var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
    return new $c_s_Some().init___O($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv)).text$3)
  } else {
    var this$3 = ctx.eh$1;
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().MissingIdInNode$1;
    var message = ("No @id declaration on node " + map);
    var prop = $m_s_None$();
    var l = map.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$3, specification, "", prop, message, l);
    return $m_s_None$()
  }
}
function $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__contentOfNode__Lorg_yaml_model_YNode__s_Option($thiz, n) {
  return new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(n).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YMapYRead$())
}
function $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__nodeIsOfType__Lorg_yaml_model_YNode__Lamf_core_metamodel_Obj__Lamf_plugins_document_graph_parser_GraphParserContext__Z($thiz, node, obj, ctx) {
  var x1 = node.value__Lorg_yaml_model_YValue();
  if ((x1 instanceof $c_Lorg_yaml_model_YMap)) {
    var x2 = $as_Lorg_yaml_model_YMap(x1);
    var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(x2).key__T__s_Option("@type");
    if ((!this$2.isEmpty__Z())) {
      var arg1 = this$2.get__O();
      var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
      var this$3 = entry.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
      var jsx$2 = $as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, ctx)).nodes$3;
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x$1$2) {
          var x$1 = $as_Lorg_yaml_model_YNode(x$1$2);
          var xo = x$1.asScalar__s_Option();
          return xo.toList__sci_List()
        })
      })($thiz));
      var this$5 = $m_sc_IndexedSeq$();
      var types = $as_sc_IndexedSeq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBF$6));
      return types.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, ctx$1, obj$1) {
        return (function(type$2) {
          var type = $as_Lorg_yaml_model_YScalar(type$2);
          var typeIri = $as_Lamf_plugins_document_graph_parser_GraphContextHelper(this$2$1).expandUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T(type.text$3, ctx$1);
          var this$7 = obj$1.type__sci_List();
          var f = (function($this$1) {
            return (function(x$2$2) {
              var x$2 = $as_Lamf_core_vocabulary_ValueType(x$2$2);
              return x$2.iri__T()
            })
          })(this$2$1);
          var this$6 = $m_sci_List$();
          var bf = this$6.ReusableCBFInstance$2;
          if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
            if ((this$7 === $m_sci_Nil$())) {
              var jsx$3 = $m_sci_Nil$()
            } else {
              var arg1$1 = this$7.head__O();
              var h = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$1), $m_sci_Nil$());
              var t = h;
              var rest = $as_sci_List(this$7.tail__O());
              while ((rest !== $m_sci_Nil$())) {
                var arg1$2 = rest.head__O();
                var nx = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$2), $m_sci_Nil$());
                t.tl$5 = nx;
                t = nx;
                rest = $as_sci_List(rest.tail__O())
              };
              var jsx$3 = h
            }
          } else {
            var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$7, bf);
            var these = this$7;
            while ((!these.isEmpty__Z())) {
              var arg1$3 = these.head__O();
              b.$$plus$eq__O__scm_Builder(f(arg1$3));
              these = $as_sci_List(these.tail__O())
            };
            var jsx$3 = b.result__O()
          };
          var this$8 = $as_sc_LinearSeqOptimized(jsx$3);
          return $f_sc_LinearSeqOptimized__contains__O__Z(this$8, typeIri)
        })
      })($thiz, ctx, obj)))
    } else {
      return false
    }
  } else {
    return false
  }
}
function $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__ts__Lorg_yaml_model_YMap__T__Lamf_plugins_document_graph_parser_GraphParserContext__sc_Seq($thiz, map, id, ctx) {
  var jsx$3 = $m_sc_Seq$();
  var array = ["Document", "Fragment", "Module", "Unit"];
  var jsx$2 = $as_sc_TraversableLike(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(docElement$2) {
      var docElement = $as_T(docElement$2);
      var this$3 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
      return new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, docElement).iri__T()
    })
  })($thiz));
  var this$5 = $m_sc_Seq$();
  var namespaces = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2));
  var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, ctx$1) {
    return (function(x$3$2) {
      var x$3 = $as_T(x$3$2);
      return $as_Lamf_plugins_document_graph_parser_GraphContextHelper(this$2$1).compactUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T(x$3, ctx$1)
    })
  })($thiz, ctx));
  var this$6 = $m_sc_Seq$();
  var jsx$4 = $as_sc_GenTraversableOnce(namespaces.map__F1__scg_CanBuildFrom__O(jsx$5, this$6.ReusableCBFInstance$2));
  var this$7 = $m_sc_Seq$();
  var documentTypesSet = $as_sc_TraversableOnce(namespaces.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$7.ReusableCBFInstance$2)).toSet__sci_Set();
  var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("@type");
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    var node = entry.value$2;
    var this$10 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$SeqNodeYRead$());
    var jsx$7 = $as_sc_TraversableLike((this$10.isEmpty__Z() ? $m_sci_Nil$() : this$10.get__O()));
    var jsx$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
      return (function(v$2) {
        var v = $as_Lorg_yaml_model_YNode(v$2);
        var this$12 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(v).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lamf_core_parser_package$YScalarYRead$());
        if (this$12.isEmpty__Z()) {
          var xo = $m_s_None$()
        } else {
          var arg1 = this$12.get__O();
          var x$4 = $as_Lorg_yaml_model_YScalar(arg1);
          var xo = new $c_s_Some().init___O(x$4.text$3)
        };
        return xo.toList__sci_List()
      })
    })($thiz));
    var this$14 = $m_sc_Seq$();
    var allTypes = $as_sc_Seq(jsx$7.flatMap__F1__scg_CanBuildFrom__O(jsx$6, this$14.ReusableCBFInstance$2));
    var nonDocumentTypes = $as_sc_Seq(allTypes.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1, documentTypesSet$1) {
      return (function(t$2) {
        var t = $as_T(t$2);
        return (!documentTypesSet$1.contains__O__Z(t))
      })
    })($thiz, documentTypesSet))));
    var documentTypes = $as_sc_Seq($as_sc_SeqLike(allTypes.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1, documentTypesSet$2) {
      return (function(t$3$2) {
        var t$3 = $as_T(t$3$2);
        return documentTypesSet$2.contains__O__Z(t$3)
      })
    })($thiz, documentTypesSet)))).sorted__s_math_Ordering__O($m_s_math_Ordering$String$()));
    var this$15 = $m_sc_Seq$();
    return $as_sc_Seq(nonDocumentTypes.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(documentTypes, this$15.ReusableCBFInstance$2))
  } else {
    var this$16 = ctx.eh$1;
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().MissingTypeInNode$1;
    var message = ("No @type declaration on node " + map);
    var prop = $m_s_None$();
    var l = map.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$16, specification, id, prop, message, l);
    return $m_sci_Nil$()
  }
}
function $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__retrieveSources__T__Lorg_yaml_model_YMap__Lamf_plugins_document_graph_parser_GraphParserContext__Lamf_core_model_document_SourceMap($thiz, id, map, ctx) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option($as_Lamf_plugins_document_graph_parser_GraphContextHelper($thiz).compactUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T($m_Lamf_core_metamodel_domain_DomainElementModel$().Sources$1.value$1.iri__T(), ctx));
  if (this$2.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var t = $m_Lamf_core_metamodel_document_SourceMapModel$();
    var node = entry.value$2;
    var srcNode = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__value__Lamf_core_metamodel_Type__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode($thiz, t, node);
    var this$3 = $thiz.contentOfNode__Lorg_yaml_model_YNode__s_Option(srcNode);
    if (this$3.isEmpty__Z()) {
      var this$4 = $m_s_None$()
    } else {
      var arg1$1 = this$3.get__O();
      var x$5 = $as_Lorg_yaml_model_YMap(arg1$1);
      var this$4 = new $c_s_Some().init___O($f_Lamf_plugins_document_graph_parser_GraphParserHelpers__parseSourceNode__pLamf_plugins_document_graph_parser_GraphParserHelpers__Lorg_yaml_model_YMap__Lamf_plugins_document_graph_parser_GraphParserContext__Lamf_core_model_document_SourceMap($thiz, x$5, ctx))
    }
  };
  return $as_Lamf_core_model_document_SourceMap((this$4.isEmpty__Z() ? $m_Lamf_core_model_document_SourceMap$().empty$1 : this$4.get__O()))
}
function $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations($thiz, nodes, sources, key) {
  $m_Lamf_core_parser_Annotations$();
  var result = new $c_Lamf_core_parser_Annotations().init___();
  var this$2 = sources.annotations$1;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$2)) {
    var this$3 = sources.annotations$1;
    var this$4 = this$3.elems$5;
    var this$5 = new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$4);
    while (this$5.hasNext__Z()) {
      var arg1 = this$5.next__O();
      var x0$1 = $as_T2(arg1);
      matchEnd4$2: {
        if ((x0$1 !== null)) {
          var annotation = $as_T(x0$1.$$und1__O());
          var values = $as_scm_ListMap(x0$1.$$und2__O());
          if ((values !== null)) {
            matchEnd4: {
              var o7 = $m_Lamf_core_model_domain_Annotation$().unapply__T__s_Option(annotation);
              if ((!o7.isEmpty__Z())) {
                var deserialize = $as_F2(o7.get__O());
                if ($f_sc_MapLike__contains__O__Z(values, key)) {
                  var this$6 = $as_s_Option(deserialize.apply__O__O__O($f_sc_MapLike__apply__O__O(values, key), nodes));
                  if ((!this$6.isEmpty__Z())) {
                    var arg1$1 = this$6.get__O();
                    var x$6 = $as_Lamf_core_model_domain_Annotation(arg1$1);
                    result.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(x$6)
                  };
                  break matchEnd4
                }
              }
            };
            break matchEnd4$2
          }
        };
        throw new $c_s_MatchError().init___O(x0$1)
      }
    }
  };
  return result
}
function $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__value__Lamf_core_metamodel_Type__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode($thiz, t, node) {
  var x1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Seq$1;
  if ((x === x1)) {
    if ((t instanceof $c_Lamf_core_metamodel_Type$Array)) {
      return node
    } else {
      var conversion = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
      var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
      var node$1 = $as_Lorg_yaml_model_YNode($as_sc_IterableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).head__O());
      return $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__value__Lamf_core_metamodel_Type__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode($thiz, t, node$1)
    }
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x$3 === x1)) {
      var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv$1 = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
      var m = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$1, iv$1));
      var x$5 = $m_Lamf_core_metamodel_Type$Iri$();
      if (x$5.equals__O__Z(t)) {
        return $as_Lorg_yaml_model_YMapEntry(new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(m).key__T__s_Option("@id").get__O()).value$2
      } else {
        var x$7 = $m_Lamf_core_metamodel_Type$Str$();
        if (x$7.equals__O__Z(t)) {
          var jsx$1 = true
        } else {
          var x$9 = $m_Lamf_core_metamodel_Type$RegExp$();
          if (x$9.equals__O__Z(t)) {
            var jsx$1 = true
          } else {
            var x$11 = $m_Lamf_core_metamodel_Type$Bool$();
            if (x$11.equals__O__Z(t)) {
              var jsx$1 = true
            } else {
              var x$13 = $m_Lamf_core_metamodel_Type$Int$();
              if (x$13.equals__O__Z(t)) {
                var jsx$1 = true
              } else {
                var x$15 = $m_Lamf_core_metamodel_Type$Any$();
                var jsx$1 = (x$15 === t)
              }
            }
          }
        };
        if (jsx$1) {
          return $as_Lorg_yaml_model_YMapEntry(new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(m).key__T__s_Option("@value").get__O()).value$2
        } else {
          return node
        }
      }
    } else {
      return node
    }
  }
}
function $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__parseSourceNode__pLamf_plugins_document_graph_parser_GraphParserHelpers__Lorg_yaml_model_YMap__Lamf_plugins_document_graph_parser_GraphParserContext__Lamf_core_model_document_SourceMap($thiz, map, ctx) {
  var result = $m_Lamf_core_model_document_SourceMap$().apply__Lamf_core_model_document_SourceMap();
  map.entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ctx$1, result$1) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var node = entry.key$2;
      var this$2 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lamf_core_parser_package$YScalarYRead$());
      if (this$2.isEmpty__Z()) {
        var this$3 = $m_s_None$()
      } else {
        var arg1 = this$2.get__O();
        var value = $as_Lorg_yaml_model_YScalar(arg1);
        var this$3 = new $c_s_Some().init___O($as_Lamf_plugins_document_graph_parser_GraphContextHelper($this).expandUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T(value.text$3, ctx$1))
      };
      if ((!this$3.isEmpty__Z())) {
        var arg1$1 = this$3.get__O();
        var x0$1 = $as_T(arg1$1);
        matchEnd4: {
          var o7 = $this.AnnotationName__Lamf_plugins_document_graph_parser_GraphParserHelpers$AnnotationName$().unapply__T__s_Option(x0$1);
          if ((!o7.isEmpty__Z())) {
            var annotation = $as_T(o7.get__O());
            var consumer = result$1.annotation__T__F2(annotation);
            var this$4 = entry.value$2;
            var conversion = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
            $as_sc_IterableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, ctx$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, ctx$2, consumer$1) {
              return (function(e$2) {
                var e = $as_Lorg_yaml_model_YNode(e$2);
                var this$5 = $this$1.contentOfNode__Lorg_yaml_model_YNode__s_Option(e);
                if ((!this$5.isEmpty__Z())) {
                  var arg1$2 = this$5.get__O();
                  var element = $as_Lorg_yaml_model_YMap(arg1$2);
                  var k = $as_Lorg_yaml_model_YMapEntry(new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(element).key__T__s_Option($as_Lamf_plugins_document_graph_parser_GraphContextHelper($this$1).compactUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T($m_Lamf_core_metamodel_document_SourceMapModel$().Element$1.value$1.iri__T(), ctx$2)).get__O());
                  var v = $as_Lorg_yaml_model_YMapEntry(new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(element).key__T__s_Option($as_Lamf_plugins_document_graph_parser_GraphContextHelper($this$1).compactUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T($m_Lamf_core_metamodel_document_SourceMapModel$().Value$1.value$1.iri__T(), ctx$2)).get__O());
                  var t = $m_Lamf_core_metamodel_document_SourceMapModel$().Element$1.type$1;
                  var node$1 = k.value$2;
                  var this$8 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__value__Lamf_core_metamodel_Type__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode($this$1, t, node$1);
                  var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
                  var jsx$1 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$8, conversion$1, ctx$2)).text$3;
                  var t$1 = $m_Lamf_core_metamodel_document_SourceMapModel$().Value$1.type$1;
                  var node$2 = v.value$2;
                  var this$9 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__value__Lamf_core_metamodel_Type__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode($this$1, t$1, node$2);
                  var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
                  consumer$1.apply__O__O__O(jsx$1, $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$9, conversion$2, ctx$2)).text$3)
                }
              })
            })($this, ctx$1, consumer)));
            break matchEnd4
          }
        }
      }
    })
  })($thiz, ctx, result)));
  return result
}
function $f_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters__externalEmitters__Lamf_core_emitter_SpecOrdering__sc_Seq($thiz, ordering) {
  var this$1 = $thiz.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect();
  if ($f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(this$1).nonEmpty__Z()) {
    var jsx$1 = $m_sc_Seq$();
    var array = [new $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$6().init___Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters__Lamf_core_emitter_SpecOrdering($thiz, ordering)];
    return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  } else {
    return $m_sci_Nil$()
  }
}
function $f_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters__nodeMappingDeclarationEmitters__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sci_Map__sc_Seq($thiz, dialect, ordering, aliases) {
  var jsx$2 = $as_sc_Seq(dialect.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Declares$1));
  var jsx$1 = new $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anonfun$7().init___Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters($thiz);
  var this$1 = $m_sc_Seq$();
  var nodeMappingDeclarations = $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  if (nodeMappingDeclarations.nonEmpty__Z()) {
    var jsx$3 = $m_sc_Seq$();
    var array = [new $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$7().init___Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters__sc_Seq__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sci_Map($thiz, nodeMappingDeclarations, dialect, ordering, aliases)];
    return $as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  } else {
    return $m_sci_Nil$()
  }
}
function $f_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters__collectAliases__sci_Map($thiz) {
  var this$1 = $thiz.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect();
  var this$2 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$1);
  var thiz = $as_T((this$2.isEmpty__Z() ? $thiz.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect().id$1 : this$2.get__O()));
  var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "/", 0);
  var this$5 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
  var vocabFile = $as_T($f_sc_IndexedSeqOptimized__last__O(this$5));
  var this$6 = $thiz.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect();
  var this$7 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$6);
  var thiz$1 = $as_T((this$7.isEmpty__Z() ? $thiz.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect().id$1 : this$7.get__O()));
  var vocabFilePrefix = $as_T(thiz$1.split(vocabFile).join(""));
  var this$10 = $thiz.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect().annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_Aliases.getClassOf());
  if (this$10.isEmpty__Z()) {
    var this$14 = $m_s_None$()
  } else {
    var arg1 = this$10.get__O();
    var aliases = $as_Lamf_core_annotations_Aliases(arg1);
    var this$13 = aliases.aliases$1;
    var z = $m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$());
    var op = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
      return (function(x0$1$2, x1$1$2) {
        var x0$1 = $as_sci_Map(x0$1$2);
        var x1$1 = $as_T2(x1$1$2);
        var x1 = new $c_T2().init___O__O(x0$1, x1$1);
        var acc = $as_sci_Map(x1.$$und1$f);
        var p2 = $as_T2(x1.$$und2$f);
        if ((p2 !== null)) {
          var alias = $as_T(p2.$$und1__O());
          var p3 = $as_T2(p2.$$und2__O());
          if ((p3 !== null)) {
            var id = $as_T(p3.$$und1__O());
            return acc.$$plus__T2__sci_Map(new $c_T2().init___O__O(id, alias))
          }
        };
        throw new $c_s_MatchError().init___O(x1)
      })
    })($thiz));
    var this$14 = new $c_s_Some().init___O($as_sci_Map($f_sc_TraversableOnce__foldLeft__O__F2__O(this$13, z, op)))
  };
  var maps = $as_sci_Map((this$14.isEmpty__Z() ? $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())) : this$14.get__O()));
  var idCounter = new $c_Lamf_plugins_document_vocabularies_emitters_common_IdCounter().init___();
  var this$15 = $thiz.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect();
  var dialectReferences = $as_sci_Map($as_sc_Seq(this$15.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().References$1)).foldLeft__O__F2__O($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$5$1, vocabFilePrefix$1, maps$1, idCounter$1) {
    return (function(x0$2$2, x1$2$2) {
      var x0$2 = $as_sci_Map(x0$2$2);
      var x1$2 = $as_Lamf_core_model_document_BaseUnit(x1$2$2);
      var x1$3 = new $c_T2().init___O__O(x0$2, x1$2);
      var acc$1 = $as_sci_Map(x1$3.$$und1$f);
      var m = $as_Lamf_core_model_document_BaseUnit(x1$3.$$und2$f);
      if ((acc$1 !== null)) {
        if ($is_Lamf_core_model_document_DeclaresModel(m)) {
          var this$16 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(m);
          if ((!this$16.isEmpty__Z())) {
            var arg1$1 = this$16.get__O();
            var x$38 = $as_T(arg1$1);
            var jsx$1 = ($uI(x$38.indexOf(vocabFilePrefix$1)) !== (-1))
          } else {
            var jsx$1 = false
          };
          if (jsx$1) {
            var this$20 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(m);
            var thiz$2 = $as_T((this$20.isEmpty__Z() ? m.id__T() : this$20.get__O()));
            var importLocation = $as_T(thiz$2.split(vocabFilePrefix$1).join(""))
          } else {
            var this$23 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(m);
            var thiz$3 = $as_T((this$23.isEmpty__Z() ? m.id__T() : this$23.get__O()));
            var importLocation = $as_T(thiz$3.split("file://").join(""))
          };
          if ((m instanceof $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary)) {
            var x2 = $as_Lamf_plugins_document_vocabularies_model_document_Vocabulary(m);
            var this$26 = $as_Lamf_core_model_StrField(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Base$1));
            var this$27 = this$26.option$1;
            var aliasKey = $as_T((this$27.isEmpty__Z() ? null : this$27.get__O()))
          } else {
            var aliasKey = m.id__T()
          };
          if (maps$1.get__O__s_Option(aliasKey).isDefined__Z()) {
            var alias$1 = $as_T(maps$1.apply__O__O(aliasKey));
            var y = new $c_T2().init___O__O(alias$1, importLocation);
            return acc$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(aliasKey, y))
          } else {
            var nextAlias = idCounter$1.genId__T__T("uses_");
            var y$1 = new $c_T2().init___O__O(nextAlias, importLocation);
            return acc$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(aliasKey, y$1))
          }
        }
      };
      var acc$2 = $as_sci_Map(x1$3.$$und1$f);
      if ((acc$2 !== null)) {
        return acc$2
      };
      throw new $c_s_MatchError().init___O(x1$3)
    })
  })($thiz, vocabFilePrefix, maps, idCounter))));
  var this$32 = $thiz.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect();
  return $as_sci_Map($f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(this$32).foldLeft__O__F2__O(dialectReferences, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$6$1) {
    return (function(x0$3$2, x1$3$2) {
      var x0$3 = $as_sci_Map(x0$3$2);
      var x1$3$1 = $as_Lamf_plugins_document_vocabularies_model_domain_External(x1$3$2);
      var x1$4 = new $c_T2().init___O__O(x0$3, x1$3$1);
      var acc$3 = $as_sci_Map(x1$4.$$und1$f);
      var e = $as_Lamf_plugins_document_vocabularies_model_domain_External(x1$4.$$und2$f);
      if ((acc$3 !== null)) {
        if ((e !== null)) {
          var this$33 = $as_Lamf_core_model_StrField(e.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().Base$1));
          var this$34 = this$33.option$1;
          var self = $as_T((this$34.isEmpty__Z() ? null : this$34.get__O()));
          var this$36 = $as_Lamf_core_model_StrField(e.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().DisplayName$1));
          var this$37 = this$36.option$1;
          var y$2 = new $c_T2().init___O__O($as_T((this$37.isEmpty__Z() ? null : this$37.get__O())), "");
          return acc$3.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, y$2))
        }
      };
      throw new $c_s_MatchError().init___O(x1$4)
    })
  })($thiz))))
}
function $f_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters__rootLevelEmitters__Lamf_core_emitter_SpecOrdering__sc_Seq($thiz, ordering) {
  var jsx$5 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter().init___Lamf_core_model_document_BaseUnit__Lamf_core_emitter_SpecOrdering__sci_Map($thiz.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect(), ordering, $thiz.aliases__sci_Map())];
  var jsx$4 = $as_sc_TraversableLike(jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  var dialect = $thiz.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect();
  var aliases = $thiz.aliases__sci_Map();
  var jsx$3 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters__nodeMappingDeclarationEmitters__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sci_Map__sc_Seq($thiz, dialect, ordering, aliases);
  var this$3 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$3.ReusableCBFInstance$2));
  var jsx$1 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters__externalEmitters__Lamf_core_emitter_SpecOrdering__sc_Seq($thiz, ordering);
  var this$4 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2))
}
function $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position($thiz, element, field) {
  var this$1 = element.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option(field);
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$3 = $as_Lamf_core_parser_FieldEntry(arg1);
    var this$3 = new $c_Lamf_plugins_document_vocabularies_emitters_dialects_FieldEntryImplicit$FieldEntryWithPosition().init___Lamf_core_parser_FieldEntry(x$3).startPosition__s_Option()
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
}
function $f_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__findNodeInRegistry__T__s_Option($thiz, nodeMappingId) {
  return $m_Lamf_plugins_document_vocabularies_AMLPlugin$().apply__Lamf_plugins_document_vocabularies_AMLPlugin().registry$2.findNode__T__s_Option(nodeMappingId)
}
function $f_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__maybeFindNodeMappingById__T__s_Option($thiz, nodeMappingId) {
  var this$1 = $thiz.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect();
  var this$2 = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Declares$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, nodeMappingId$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_domain_DomainElement(x0$1$2);
      if ($is_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x0$1)) {
        var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x0$1);
        return (x2.id__T() === nodeMappingId$1)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })($thiz, nodeMappingId)));
  if (this$2.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var nodeMapping = $as_Lamf_core_model_domain_DomainElement(arg1);
    var this$3 = new $c_s_Some().init___O(new $c_T2().init___O__O($thiz.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect(), nodeMapping))
  };
  if (this$3.isEmpty__Z()) {
    var this$4 = $thiz.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect();
    var jsx$2 = $as_sc_Seq(this$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().References$1));
    var jsx$1 = new $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$1().init___Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__T($thiz, nodeMappingId);
    var this$5 = $m_sc_Seq$();
    var this$6 = $as_sc_TraversableOnce(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2));
    var pf = new $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$2().init___Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper($thiz);
    var inDialectMapping = $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$6, pf)
  } else {
    var inDialectMapping = this$3
  };
  return (inDialectMapping.isEmpty__Z() ? $f_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__findNodeInRegistry__T__s_Option($thiz, nodeMappingId) : inDialectMapping)
}
function $f_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__findNodeMappingById__T__T2($thiz, nodeMappingId) {
  var this$1 = $f_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__maybeFindNodeMappingById__T__s_Option($thiz, nodeMappingId);
  if (this$1.isEmpty__Z()) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot find node mapping " + nodeMappingId)))
  };
  return $as_T2(this$1.get__O())
}
function $f_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__externalEmitters__Lamf_plugins_document_vocabularies_model_document_ExternalContext__Lamf_core_emitter_SpecOrdering__sc_Seq($thiz, model, ordering) {
  if ($f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(model).nonEmpty__Z()) {
    var jsx$1 = $m_sc_Seq$();
    var array = [new $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anon$1().init___Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_vocabularies_model_document_ExternalContext($thiz, ordering, model)];
    return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  } else {
    return $m_sci_Nil$()
  }
}
function $f_Lamf_plugins_document_vocabularies_emitters_vocabularies_AliasMapper__aliasFor__T__sci_Map__T($thiz, id, aliasMapping) {
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  if ((id === new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "guid").iri__T())) {
    return "guid"
  } else {
    var s = $m_Lamf_core_vocabulary_Namespace$().Xsd$1.base$1;
    if (($uI(id.indexOf(s)) !== (-1))) {
      var regex = $m_Lamf_core_vocabulary_Namespace$().Xsd$1.base$1;
      var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(id, regex, 0);
      var this$8 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
      var x1 = $as_T($f_sc_IndexedSeqOptimized__last__O(this$8));
      return ((x1 === "anyURI") ? "uri" : ((x1 === "anyType") ? "any" : x1))
    } else {
      var this$9 = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(aliasMapping);
      var this$10 = this$9.$$outer$4.keysIterator__sc_Iterator();
      inlinereturn$17: {
        while (this$10.hasNext__Z()) {
          var a = this$10.next__O();
          var k = $as_T(a);
          if (($uI(id.indexOf(k)) !== (-1))) {
            var x1$2 = new $c_s_Some().init___O(a);
            break inlinereturn$17
          }
        };
        var x1$2 = $m_s_None$()
      };
      if ((x1$2 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1$2);
        var k$3 = $as_T(x2.value$2);
        var alias = $as_T(aliasMapping.apply__O__O(k$3));
        var replacement = (alias + ".");
        return $as_T(id.split(k$3).join(replacement))
      } else {
        var x = $m_s_None$();
        if ((x === x1$2)) {
          var xs$1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(id, "#", 0);
          var this$18 = new $c_scm_ArrayOps$ofRef().init___AO(xs$1);
          var thiz = $as_T($f_sc_IndexedSeqOptimized__last__O(this$18));
          var xs$2 = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "/", 0);
          var this$21 = new $c_scm_ArrayOps$ofRef().init___AO(xs$2);
          return $as_T($f_sc_IndexedSeqOptimized__last__O(this$21))
        } else {
          throw new $c_s_MatchError().init___O(x1$2)
        }
      }
    }
  }
}
function $f_Lamf_plugins_document_vocabularies_emitters_vocabularies_AliasMapper__buildAliasMapping__Lamf_plugins_document_vocabularies_model_document_Vocabulary__sci_Map($thiz, vocabulary) {
  var elem = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var aliasMapping = new $c_sr_ObjectRef().init___O(elem);
  $f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(vocabulary).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, aliasMapping$1) {
    return (function(external$2) {
      var external = $as_Lamf_plugins_document_vocabularies_model_domain_External(external$2);
      var jsx$1 = $as_sci_Map(aliasMapping$1.elem$1);
      var this$2 = $as_Lamf_core_model_StrField(external.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().Base$1));
      var this$3 = this$2.option$1;
      var self = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
      var this$5 = $as_Lamf_core_model_StrField(external.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().DisplayName$1));
      var this$6 = this$5.option$1;
      var y = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
      aliasMapping$1.elem$1 = jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, y))
    })
  })($thiz, aliasMapping)));
  $as_sc_Seq(vocabulary.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Imports$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, aliasMapping$2) {
    return (function(imported$2) {
      var imported = $as_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference(imported$2);
      var jsx$2 = $as_sci_Map(aliasMapping$2.elem$1);
      var this$8 = $as_Lamf_core_model_StrField(imported.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$().Base$1));
      var this$9 = this$8.option$1;
      var self$1 = $as_T((this$9.isEmpty__Z() ? null : this$9.get__O()));
      var this$11 = $as_Lamf_core_model_StrField(imported.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$().Alias$1));
      var this$12 = this$11.option$1;
      var y$1 = $as_T((this$12.isEmpty__Z() ? null : this$12.get__O()));
      aliasMapping$2.elem$1 = jsx$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$1, y$1))
    })
  })($thiz, aliasMapping)));
  return $as_sci_Map(aliasMapping.elem$1)
}
function $f_Lamf_plugins_document_vocabularies_metamodel_domain_MergeableMappingModel__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  $thiz.amf$plugins$document$vocabularies$metamodel$domain$MergeableMappingModel$$undsetter$und$MergePolicy$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "mergePolicy"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "merge policy", "Indication of how to merge this graph node when applying a patch document", $m_sci_Nil$()), true));
  var array = ["insert", "delete", "update", "upsert", "ignore", "fail"];
  if (($uI(array.length) === 0)) {
    var jsx$2 = $m_sci_Set$EmptySet$()
  } else {
    var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      b.$$plus$eq__O__scm_SetBuilder(arg1);
      i = ((1 + i) | 0)
    };
    var jsx$2 = b.elems$1
  };
  $thiz.amf$plugins$document$vocabularies$metamodel$domain$MergeableMappingModel$$undsetter$und$ALLOWED$undMERGE$undPOLICY$und$eq__sci_Set__V($as_sci_Set(jsx$2))
}
function $f_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappableModel__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  $thiz.amf$plugins$document$vocabularies$metamodel$domain$NodeMappableModel$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "name"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "name", "Name of the node mappable element", $m_sci_Nil$()), true))
}
function $f_Lamf_plugins_document_vocabularies_metamodel_domain_NodeWithDiscriminatorModel__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  $thiz.amf$plugins$document$vocabularies$metamodel$domain$NodeWithDiscriminatorModel$$undsetter$und$TypeDiscriminator$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "typeDiscriminatorMap"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "type discriminator map", "Information about the discriminator values in the source AST for the property mapping", $m_sci_Nil$()), true));
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  $thiz.amf$plugins$document$vocabularies$metamodel$domain$NodeWithDiscriminatorModel$$undsetter$und$TypeDiscriminatorName$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "typeDiscriminatorName"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "type discriminator name", "Information about the field in the source AST to be used as discrimintaro in the property mapping", $m_sci_Nil$()), true))
}
function $f_Lamf_plugins_document_vocabularies_model_document_ComposedInstancesSupport__$$init$__V($thiz) {
  $thiz.composedDialects$und$eq__sci_Map__V($as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())))
}
function $f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq($thiz) {
  return $as_sc_Seq($as_Lamf_core_model_domain_AmfObject($thiz).fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$().Externals$1))
}
function $is_Lamf_plugins_document_vocabularies_model_document_ExternalContext(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_document_vocabularies_model_document_ExternalContext)))
}
function $as_Lamf_plugins_document_vocabularies_model_document_ExternalContext(obj) {
  return (($is_Lamf_plugins_document_vocabularies_model_document_ExternalContext(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.document.ExternalContext"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_document_ExternalContext(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_document_ExternalContext)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_document_ExternalContext(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_document_ExternalContext(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.document.ExternalContext;", depth))
}
function $f_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer__findNodeMapping__T__s_Option($thiz, mappingId) {
  var x1 = $as_Lamf_core_model_document_DeclaresModel($thiz).declares__sc_Seq().find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, mappingId$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_domain_DomainElement(x$1$2);
      return (x$1.id__T() === mappingId$1)
    })
  })($thiz, mappingId)));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var mapping = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    if ((mapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
      var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(mapping);
      return new $c_s_Some().init___O(x3)
    }
  };
  var jsx$6 = $as_Lamf_core_model_document_BaseUnit($thiz).references__sc_Seq();
  var jsx$5 = new $c_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer$$anonfun$findNodeMapping$2().init___Lamf_plugins_document_vocabularies_model_document_MappingDeclarer($thiz);
  var this$1 = $m_sc_Seq$();
  var jsx$4 = $as_sc_TraversableLike(jsx$6.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$5, this$1.ReusableCBFInstance$2));
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, mappingId$2) {
    return (function(dec$2) {
      var dec = $as_Lamf_core_model_document_BaseUnit(dec$2);
      var this$3 = $as_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer(dec);
      return $f_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer__findNodeMapping__T__s_Option(this$3, mappingId$2)
    })
  })($thiz, mappingId));
  var this$4 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike($as_sc_TraversableLike(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$4.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x$2$2) {
      var x$2 = $as_s_Option(x$2$2);
      return x$2.isDefined__Z()
    })
  })($thiz))));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
    return (function(x$3$2) {
      var x$3 = $as_s_Option(x$3$2);
      return $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x$3.get__O())
    })
  })($thiz));
  var this$5 = $m_sc_Seq$();
  return $as_sc_TraversableLike(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2)).headOption__s_Option()
}
function $is_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_document_vocabularies_model_document_MappingDeclarer)))
}
function $as_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer(obj) {
  return (($is_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.document.MappingDeclarer"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_document_MappingDeclarer)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.document.MappingDeclarer;", depth))
}
function $f_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser__parseAnnotations__Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations__Lamf_core_parser_ParserContext__O($thiz, ast, node, declarations, ctx) {
  var this$20 = ast.map$3;
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ctx$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var k = $as_Lorg_yaml_model_YNode(x0$1.$$und1__O());
        var v = $as_Lorg_yaml_model_YNode(x0$1.$$und2__O());
        var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var key = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(k, conversion, ctx$1));
        if (((($uI(key.length) >= 0) && ($as_T(key.substring(0, $uI("(".length))) === "(")) && $m_sjsr_RuntimeString$().endsWith__T__T__Z(key, ")"))) {
          var thiz = $as_T(key.split("(").join(""));
          var base = $as_T(thiz.split(")").join(""));
          var x1$2 = $m_sjsr_RuntimeString$().split__T__T__I__AT(base, "\\.", 0);
          var o8 = $m_s_Array$().unapplySeq__O__s_Option(x1$2);
          if (((!o8.isEmpty__Z()) && ((o8.get__O() !== null) && ($as_sc_SeqLike(o8.get__O()).lengthCompare__I__I(2) === 0)))) {
            var prefix = $as_T($as_sc_SeqLike(o8.get__O()).apply__I__O(0));
            var suffix = $as_T($as_sc_SeqLike(o8.get__O()).apply__I__O(1));
            return new $c_s_Some().init___O(new $c_T3().init___O__O__O(new $c_T2().init___O__O(new $c_s_Some().init___O(prefix), suffix), key, v))
          };
          var o10 = $m_s_Array$().unapplySeq__O__s_Option(x1$2);
          if (((!o10.isEmpty__Z()) && ((o10.get__O() !== null) && ($as_sc_SeqLike(o10.get__O()).lengthCompare__I__I(1) === 0)))) {
            var suffix$2 = $as_T($as_sc_SeqLike(o10.get__O()).apply__I__O(0));
            return new $c_s_Some().init___O(new $c_T3().init___O__O__O(new $c_T2().init___O__O($m_s_None$(), suffix$2), key, v))
          };
          return $m_s_None$()
        } else if ((($uI(key.length) >= 0) && ($as_T(key.substring(0, $uI("x-".length))) === "x-"))) {
          var base$2 = $as_T(key.split("x-").join(""));
          var x1$3 = $m_sjsr_RuntimeString$().split__T__T__I__AT(base$2, "-", 0);
          var o8$2 = $m_s_Array$().unapplySeq__O__s_Option(x1$3);
          if (((!o8$2.isEmpty__Z()) && ((o8$2.get__O() !== null) && ($as_sc_SeqLike(o8$2.get__O()).lengthCompare__I__I(2) === 0)))) {
            var prefix$2 = $as_T($as_sc_SeqLike(o8$2.get__O()).apply__I__O(0));
            var suffix$3 = $as_T($as_sc_SeqLike(o8$2.get__O()).apply__I__O(1));
            return new $c_s_Some().init___O(new $c_T3().init___O__O__O(new $c_T2().init___O__O(new $c_s_Some().init___O(prefix$2), suffix$3), key, v))
          };
          var o10$2 = $m_s_Array$().unapplySeq__O__s_Option(x1$3);
          if (((!o10$2.isEmpty__Z()) && ((o10$2.get__O() !== null) && ($as_sc_SeqLike(o10$2.get__O()).lengthCompare__I__I(1) === 0)))) {
            var suffix$4 = $as_T($as_sc_SeqLike(o10$2.get__O()).apply__I__O(0));
            return new $c_s_Some().init___O(new $c_T3().init___O__O__O(new $c_T2().init___O__O($m_s_None$(), suffix$4), key, v))
          };
          return $m_s_None$()
        } else {
          return $m_s_None$()
        }
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })($thiz, ctx));
  var this$19 = $m_sci_Iterable$();
  var bf = this$19.ReusableCBFInstance$2;
  var jsx$2 = $as_sc_TraversableLike($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$20, f, bf));
  var jsx$1 = new $c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$1().init___Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser($thiz);
  var this$21 = $m_sci_Iterable$();
  var parsedAnnotationProperties = $as_sc_Iterable(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$21.ReusableCBFInstance$2));
  var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, declarations$1, node$1, ctx$2) {
    return (function(x0$2$2) {
      var x0$2 = $as_T3(x0$2$2);
      if ((x0$2 !== null)) {
        var p2 = $as_T2(x0$2.$$und1$1);
        var k$1 = $as_T(x0$2.$$und2$1);
        var v$1 = $as_Lorg_yaml_model_YNode(x0$2.$$und3$1);
        if ((p2 !== null)) {
          var prefix$1 = $as_s_Option(p2.$$und1__O());
          var suffix$1 = $as_T(p2.$$und2__O());
          var x1$2$1 = declarations$1.resolveExternalNamespace__s_Option__T__s_util_Try(prefix$1, suffix$1);
          if ((x1$2$1 instanceof $c_s_util_Success)) {
            var x2 = $as_s_util_Success(x1$2$1);
            var propertyId = $as_T(x2.value$2);
            var jsx$6 = node$1.id__T();
            if (prefix$1.isEmpty__Z()) {
              var this$22 = $m_s_None$()
            } else {
              var arg1 = prefix$1.get__O();
              var x$1 = $as_T(arg1);
              var this$22 = new $c_s_Some().init___O((x$1 + "/"))
            };
            var id = ((("" + jsx$6) + (this$22.isEmpty__Z() ? "/" : this$22.get__O())) + suffix$1);
            var parsedAnnotation = new $c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser().init___Lorg_yaml_model_YNode__s_Option__Lamf_core_utils_package$IdCounter__Lamf_core_utils_package$AliasCounter__Lamf_core_parser_ParserContext(v$1, new $c_s_Some().init___O(id), new $c_Lamf_core_utils_package$IdCounter().init___(), new $c_Lamf_core_utils_package$AliasCounter().init___I__J(0, $m_Lamf_core_utils_package$AliasCounter$().apply$default$2__J()), ctx$2).parse__Lamf_core_model_domain_DataNode();
            var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(v$1);
            var this$27 = new $c_Lamf_core_model_domain_extensions_CustomDomainProperty().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
            var this$29 = $as_Lamf_core_model_domain_NamedDomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$27, propertyId));
            $m_Lamf_core_parser_Annotations$();
            var a = new $c_Lamf_core_parser_Annotations().init___();
            var property = $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$29, k$1, a));
            $m_Lamf_core_parser_Annotations$();
            var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
            var this$33 = new $c_Lamf_core_model_domain_extensions_DomainExtension().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
            var this$34 = $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$33, id));
            var field = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1;
            var this$35 = $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$34, field, parsedAnnotation));
            var field$1 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().DefinedBy$1;
            var this$36 = $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$35, field$1, property));
            var field$2 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1;
            var this$37 = $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$36, field$2, k$1));
            var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(v$1);
            var extension = $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$37, other));
            return new $c_s_Some().init___O(extension)
          } else if ((x1$2$1 instanceof $c_s_util_Failure)) {
            var x3 = $as_s_util_Failure(x1$2$1);
            var ex = x3.exception$2;
            var x1$3$1 = declarations$1.usedVocabs$2.get__O__s_Option((prefix$1.isEmpty__Z() ? "" : prefix$1.get__O()));
            if ((x1$3$1 instanceof $c_s_Some)) {
              var x2$2 = $as_s_Some(x1$3$1);
              var vocabulary = $as_Lamf_plugins_document_vocabularies_model_document_Vocabulary(x2$2.value$2);
              var jsx$8 = node$1.id__T();
              var jsx$7 = (($m_sjsr_RuntimeString$().endsWith__T__T__Z(node$1.id__T(), "/") || $m_sjsr_RuntimeString$().endsWith__T__T__Z(node$1.id__T(), "#")) ? "" : "/");
              if (prefix$1.isEmpty__Z()) {
                var this$38 = $m_s_None$()
              } else {
                var arg1$1 = prefix$1.get__O();
                var x$2 = $as_T(arg1$1);
                var this$38 = new $c_s_Some().init___O((x$2 + "/"))
              };
              var id$2 = (((jsx$8 + jsx$7) + (this$38.isEmpty__Z() ? "/" : this$38.get__O())) + suffix$1);
              var parsedAnnotation$2 = new $c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser().init___Lorg_yaml_model_YNode__s_Option__Lamf_core_utils_package$IdCounter__Lamf_core_utils_package$AliasCounter__Lamf_core_parser_ParserContext(v$1, new $c_s_Some().init___O(id$2), new $c_Lamf_core_utils_package$IdCounter().init___(), new $c_Lamf_core_utils_package$AliasCounter().init___I__J(0, $m_Lamf_core_utils_package$AliasCounter$().apply$default$2__J()), ctx$2).parse__Lamf_core_model_domain_DataNode();
              var this$41 = $as_Lamf_core_model_StrField(vocabulary.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Base$1));
              var this$42 = this$41.option$1;
              var base$1 = $as_T((this$42.isEmpty__Z() ? null : this$42.get__O()));
              var propertyId$2 = (($m_sjsr_RuntimeString$().endsWith__T__T__Z(base$1, "#") || $m_sjsr_RuntimeString$().endsWith__T__T__Z(base$1, "/")) ? (("" + base$1) + suffix$1) : ((base$1 + "/") + suffix$1));
              var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(v$1);
              var this$45 = new $c_Lamf_core_model_domain_extensions_CustomDomainProperty().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$2);
              var qual$1 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$45, propertyId$2));
              $m_Lamf_core_parser_Annotations$();
              var x$2$3 = new $c_Lamf_core_parser_Annotations().init___();
              var property$2 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, k$1, x$2$3));
              $m_Lamf_core_parser_Annotations$();
              var annotations$3 = new $c_Lamf_core_parser_Annotations().init___();
              var this$50 = new $c_Lamf_core_model_domain_extensions_DomainExtension().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$3);
              var this$51 = $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$50, id$2));
              var field$3 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1;
              var this$52 = $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$51, field$3, parsedAnnotation$2));
              var field$4 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().DefinedBy$1;
              var this$53 = $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$52, field$4, property$2));
              var field$5 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1;
              var this$54 = $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$53, field$5, k$1));
              var other$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(v$1);
              var extension$2 = $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$54, other$1));
              return new $c_s_Some().init___O(extension$2)
            } else {
              var x = $m_s_None$();
              if ((x === x1$3$1)) {
                var this$55 = ctx$2.eh$1;
                var specification = $m_Lamf_validation_DialectValidations$().MissingVocabulary$1;
                var node$2 = node$1.id__T();
                var message = ex.getMessage__T();
                var prop = $m_s_None$();
                var l = v$1.location$1;
                $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$55, specification, node$2, prop, message, l);
                return $m_s_None$()
              } else {
                throw new $c_s_MatchError().init___O(x1$3$1)
              }
            }
          } else {
            throw new $c_s_MatchError().init___O(x1$2$1)
          }
        }
      };
      throw new $c_s_MatchError().init___O(x0$2)
    })
  })($thiz, declarations, node, ctx));
  var this$56 = $m_sc_Iterable$();
  var jsx$4 = $as_sc_TraversableLike(parsedAnnotationProperties.map__F1__scg_CanBuildFrom__O(jsx$5, this$56.ReusableCBFInstance$2));
  var jsx$3 = new $c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$2().init___Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser($thiz);
  var this$57 = $m_sc_Iterable$();
  var parsedExtensions = $as_sc_Iterable(jsx$4.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$3, this$57.ReusableCBFInstance$2));
  if (parsedExtensions.nonEmpty__Z()) {
    var extensions = parsedExtensions.toSeq__sc_Seq();
    var field$6 = $m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field();
    return $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(node, field$6, extensions))
  } else {
    return (void 0)
  }
}
function $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__missingPropertyViolation__T__T__T__Lorg_yaml_model_YPart__V($thiz, id, property, nodeType, ast) {
  var this$1 = $as_Lamf_core_parser_ParserContext($thiz).eh$1;
  var specification = $m_Lamf_validation_DialectValidations$().MissingPropertySpecification$1;
  var message = (((("Property: '" + property) + "' mandatory in a ") + nodeType) + " node");
  var prop = $m_s_None$();
  var l = ast.location$1;
  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, id, prop, message, l)
}
function $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__inconsistentPropertyRangeValueViolation__T__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__T__Lorg_yaml_model_YNode__V($thiz, node, property, expected, found, valueNode) {
  var this$9 = $as_Lamf_core_parser_ParserContext($thiz).eh$1;
  var specification = $m_Lamf_validation_DialectValidations$().InconsistentPropertyRangeValueSpecification$1;
  var this$1 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
  var this$2 = this$1.option$1;
  var property$1 = new $c_s_Some().init___O($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())));
  var this$3 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
  var this$4 = this$3.option$1;
  var jsx$1 = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
  var this$5 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
  var this$6 = this$5.option$1;
  var message = (((((((("Cannot find expected range for property " + jsx$1) + " (") + $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()))) + "). Found '") + found) + "', expected '") + expected) + "'");
  var jsx$2 = $m_Lamf_core_parser_Range$();
  var this$7 = valueNode.location$1;
  var lexical = new $c_s_Some().init___O(new $c_Lamf_core_annotations_LexicalInformation().init___Lamf_core_parser_Range(jsx$2.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$7.lineFrom$1, this$7.columnFrom$1, this$7.lineTo$1, this$7.columnTo$1))));
  var str = valueNode.location$1.sourceName$1;
  var location = new $c_Lamf_core_utils_package$AmfStrings().init___T(str).option__s_Option();
  this$9.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property$1, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
}
function $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__missingFragmentViolation__T__T__Lorg_yaml_model_YPart__V($thiz, fragment, node, ast) {
  var this$1 = $as_Lamf_core_parser_ParserContext($thiz).eh$1;
  var specification = $m_Lamf_validation_DialectValidations$().MissingFragmentSpecification$1;
  var message = ("Cannot find fragment " + fragment);
  var prop = $m_s_None$();
  var l = ast.location$1;
  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, node, prop, message, l)
}
function $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__closedNodeViolation__T__T__T__Lorg_yaml_model_YPart__V($thiz, id, property, nodeType, ast) {
  var this$1 = $as_Lamf_core_parser_ParserContext($thiz).eh$1;
  var specification = $m_Lamf_validation_DialectValidations$().ClosedShapeSpecification$1;
  var message = (((("Property: '" + property) + "' not supported in a ") + nodeType) + " node");
  var prop = $m_s_None$();
  var l = ast.location$1;
  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, id, prop, message, l)
}
function $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__differentTermsInMapKey__T__T__T__Lamf_core_parser_Annotations__V($thiz, node, field, label, annotations) {
  var this$2 = $as_Lamf_core_parser_ParserContext($thiz).eh$1;
  var specification = $m_Lamf_validation_DialectValidations$().DifferentTermsInMapKey$1;
  var property = new $c_s_Some().init___O(field);
  var message = (("Cannot find property " + label) + " in mapping range");
  var lexical = annotations.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  var this$1 = annotations.find__jl_Class__s_Option($d_Lamf_core_annotations_SourceLocation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var location = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$3 = $as_Lamf_core_annotations_SourceLocation(arg1);
    var location = new $c_s_Some().init___O(x$3.location$1)
  };
  this$2.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
}
function $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__missingPropertyKeyViolation__T__T__T__Lamf_core_parser_Annotations__V($thiz, node, field, label, annotations) {
  var this$2 = $as_Lamf_core_parser_ParserContext($thiz).eh$1;
  var specification = $m_Lamf_validation_DialectValidations$().MissingPropertyRangeSpecification$1;
  var property = new $c_s_Some().init___O(field);
  var message = (("Cannot find property " + label) + " in mapping range");
  var lexical = annotations.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  var this$1 = annotations.find__jl_Class__s_Option($d_Lamf_core_annotations_SourceLocation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var location = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$2 = $as_Lamf_core_annotations_SourceLocation(arg1);
    var location = new $c_s_Some().init___O(x$2.location$1)
  };
  this$2.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
}
function $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__missingClassTermWarning__T__T__Lorg_yaml_model_YPart__V($thiz, term, node, ast) {
  var this$1 = $as_Lamf_core_parser_ParserContext($thiz).eh$1;
  var specification = $m_Lamf_validation_DialectValidations$().MissingClassTermSpecification$1;
  var message = ("Cannot find class vocabulary term " + term);
  var property = $m_s_None$();
  var location = ast.location$1;
  $f_Lamf_core_errorhandling_ErrorHandler__warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, node, property, message, location)
}
function $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__missingPropertyRangeViolation__T__T__Lamf_core_parser_Annotations__V($thiz, term, node, annotations) {
  var this$2 = $as_Lamf_core_parser_ParserContext($thiz).eh$1;
  var specification = $m_Lamf_validation_DialectValidations$().MissingPropertyRangeSpecification$1;
  var property = new $c_s_Some().init___O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().ObjectRange$1.value$1.iri__T());
  var message = ("Cannot find property range term " + term);
  var lexical = annotations.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  var this$1 = annotations.find__jl_Class__s_Option($d_Lamf_core_annotations_SourceLocation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var location = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_Lamf_core_annotations_SourceLocation(arg1);
    var location = new $c_s_Some().init___O(x$1.location$1)
  };
  this$2.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
}
function $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__missingPropertyTermWarning__T__T__Lorg_yaml_model_YPart__V($thiz, term, node, ast) {
  var this$1 = $as_Lamf_core_parser_ParserContext($thiz).eh$1;
  var specification = $m_Lamf_validation_DialectValidations$().MissingPropertyTermSpecification$1;
  var message = ("Cannot find property vocabulary term " + term);
  var property = $m_s_None$();
  var location = ast.location$1;
  $f_Lamf_core_errorhandling_ErrorHandler__warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, node, property, message, location)
}
function $is_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter)))
}
function $as_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter(obj) {
  return (($is_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.parser.common.SyntaxErrorReporter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.parser.common.SyntaxErrorReporter;", depth))
}
function $f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__isInclude__pLamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__Lorg_yaml_model_YNode__Z($thiz, node) {
  var x = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x$2 = $m_Lorg_yaml_model_YType$().Include$1;
  return (x === x$2)
}
function $f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__closedNode__T__T__Lorg_yaml_model_YMap__V($thiz, nodeType, id, map) {
  if ((nodeType === "dialect")) {
    var allowedProps = $thiz.dialect$2
  } else if ((nodeType === "library")) {
    var allowedProps = $thiz.library$2
  } else if ((nodeType === "fragment")) {
    var allowedProps = $thiz.fragment$2
  } else if ((nodeType === "nodeMapping")) {
    var allowedProps = $thiz.nodeMapping$2
  } else if ((nodeType === "propertyMapping")) {
    var allowedProps = $thiz.propertyMapping$2
  } else if ((nodeType === "documentsMapping")) {
    var allowedProps = $thiz.documentsMapping$2
  } else {
    if ((nodeType !== "documentsMappingOptions")) {
      throw new $c_s_MatchError().init___O(nodeType)
    };
    var allowedProps = $thiz.documentsMappingOptions$2
  };
  var this$1 = map.map$3;
  var this$3 = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(this$1);
  var this$2 = $m_sci_Set$();
  var bf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$2);
  var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$3, bf);
  var this$4 = this$3.$$outer$4.keysIterator__sc_Iterator();
  while (this$4.hasNext__Z()) {
    var arg1 = this$4.next__O();
    var x$6 = $as_Lorg_yaml_model_YNode(arg1);
    var conversion = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
    var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
    b.$$plus$eq__O__scm_Builder($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(x$6, conversion, iv)).text$3)
  };
  $as_sc_IterableLike(b.result__O()).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, allowedProps$1, id$1, nodeType$1, map$1) {
    return (function(property$2) {
      var property = $as_T(property$2);
      if ((!$f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__isAnnotation__pLamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__T__Z(this$2$1, property))) {
        var x1 = allowedProps$1.get__O__s_Option(property);
        if ((!(x1 instanceof $c_s_Some))) {
          var x = $m_s_None$();
          if ((x === x1)) {
            var this$5 = $as_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter(this$2$1);
            $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__closedNodeViolation__T__T__T__Lorg_yaml_model_YPart__V(this$5, id$1, property, nodeType$1, map$1)
          } else {
            throw new $c_s_MatchError().init___O(x1)
          }
        }
      }
    })
  })($thiz, allowedProps, id, nodeType, map)));
  allowedProps.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, map$2, id$2, nodeType$2) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var propName = $as_T(x0$1.$$und1__O());
        var mandatory = $uZ(x0$1.$$und2__O());
        var this$6 = map$2.map$3;
        var this$8 = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(this$6);
        var this$7 = $m_sci_Set$();
        var bf$1 = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$7);
        var b$1 = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$8, bf$1);
        var this$9 = this$8.$$outer$4.keysIterator__sc_Iterator();
        while (this$9.hasNext__Z()) {
          var arg1$1 = this$9.next__O();
          var x$7 = $as_Lorg_yaml_model_YNode(arg1$1);
          var conversion$1 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
          var iv$1 = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
          b$1.$$plus$eq__O__scm_Builder($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(x$7, conversion$1, iv$1)).text$3)
        };
        var props = $as_sci_Set(b$1.result__O());
        if (mandatory) {
          if ((!props.contains__O__Z(propName))) {
            var this$10 = $as_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter(this$3$1);
            $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__missingPropertyViolation__T__T__T__Lorg_yaml_model_YPart__V(this$10, id$2, propName, nodeType$2, map$2)
          }
        }
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })($thiz, map, id, nodeType)))
}
function $f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__$$init$__V($thiz) {
  var array = [new $c_T2().init___O__O("$dialect", false), new $c_T2().init___O__O("dialect", true), new $c_T2().init___O__O("version", true), new $c_T2().init___O__O("usage", false), new $c_T2().init___O__O("external", false), new $c_T2().init___O__O("uses", false), new $c_T2().init___O__O("nodeMappings", false), new $c_T2().init___O__O("documents", false)];
  var this$20 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$20.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  $thiz.dialect$2 = $as_sci_Map(this$20.elems$1);
  var array$1 = [new $c_T2().init___O__O("usage", false), new $c_T2().init___O__O("external", false), new $c_T2().init___O__O("uses", false), new $c_T2().init___O__O("nodeMappings", false)];
  var this$32 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i$1 = 0;
  var len$1 = $uI(array$1.length);
  while ((i$1 < len$1)) {
    var index$1 = i$1;
    var arg1$1 = array$1[index$1];
    this$32.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1$1));
    i$1 = ((1 + i$1) | 0)
  };
  $thiz.library$2 = $as_sci_Map(this$32.elems$1);
  var array$2 = [new $c_T2().init___O__O("classTerm", false), new $c_T2().init___O__O("mapping", false), new $c_T2().init___O__O("idProperty", false), new $c_T2().init___O__O("idTemplate", false), new $c_T2().init___O__O("patch", false), new $c_T2().init___O__O("extends", false)];
  var this$48 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i$2 = 0;
  var len$2 = $uI(array$2.length);
  while ((i$2 < len$2)) {
    var index$2 = i$2;
    var arg1$2 = array$2[index$2];
    this$48.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1$2));
    i$2 = ((1 + i$2) | 0)
  };
  $thiz.nodeMapping$2 = $as_sci_Map(this$48.elems$1);
  var array$3 = [new $c_T2().init___O__O("usage", false), new $c_T2().init___O__O("external", false), new $c_T2().init___O__O("uses", false)];
  var this$58 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i$3 = 0;
  var len$3 = $uI(array$3.length);
  while ((i$3 < len$3)) {
    var index$3 = i$3;
    var arg1$3 = array$3[index$3];
    this$58.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1$3));
    i$3 = ((1 + i$3) | 0)
  };
  $thiz.fragment$2 = $as_sci_MapLike(this$58.elems$1).$$plus$plus__sc_GenTraversableOnce__sci_Map($thiz.nodeMapping$2);
  var array$4 = [new $c_T2().init___O__O("propertyTerm", false), new $c_T2().init___O__O("range", true), new $c_T2().init___O__O("mapKey", false), new $c_T2().init___O__O("mapValue", false), new $c_T2().init___O__O("mapTermKey", false), new $c_T2().init___O__O("mapTermValue", false), new $c_T2().init___O__O("isLink", false), new $c_T2().init___O__O("mandatory", false), new $c_T2().init___O__O("pattern", false), new $c_T2().init___O__O("sorted", false), new $c_T2().init___O__O("minimum", false), new $c_T2().init___O__O("maximum", false), new $c_T2().init___O__O("allowMultiple", false), new $c_T2().init___O__O("enum", false), new $c_T2().init___O__O("typeDiscriminatorName", false), new $c_T2().init___O__O("typeDiscriminator", false), new $c_T2().init___O__O("unique", false), new $c_T2().init___O__O("patch", false)];
  var this$98 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i$4 = 0;
  var len$4 = $uI(array$4.length);
  while ((i$4 < len$4)) {
    var index$4 = i$4;
    var arg1$4 = array$4[index$4];
    this$98.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1$4));
    i$4 = ((1 + i$4) | 0)
  };
  $thiz.propertyMapping$2 = $as_sci_Map(this$98.elems$1);
  var array$5 = [new $c_T2().init___O__O("root", false), new $c_T2().init___O__O("fragments", false), new $c_T2().init___O__O("library", false), new $c_T2().init___O__O("options", false)];
  var this$110 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i$5 = 0;
  var len$5 = $uI(array$5.length);
  while ((i$5 < len$5)) {
    var index$5 = i$5;
    var arg1$5 = array$5[index$5];
    this$110.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1$5));
    i$5 = ((1 + i$5) | 0)
  };
  $thiz.documentsMapping$2 = $as_sci_Map(this$110.elems$1);
  var array$6 = [new $c_T2().init___O__O("selfEncoded", false), new $c_T2().init___O__O("declarationsPath", false), new $c_T2().init___O__O("keyProperty", false), new $c_T2().init___O__O("referenceStyle", false)];
  var this$122 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i$6 = 0;
  var len$6 = $uI(array$6.length);
  while ((i$6 < len$6)) {
    var index$6 = i$6;
    var arg1$6 = array$6[index$6];
    this$122.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1$6));
    i$6 = ((1 + i$6) | 0)
  };
  $thiz.documentsMappingOptions$2 = $as_sci_Map(this$122.elems$1)
}
function $f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__link__Lorg_yaml_model_YNode__s_util_Either($thiz, node) {
  if ($f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__isInclude__pLamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__Lorg_yaml_model_YNode__Z($thiz, node)) {
    $m_s_package$();
    var conversion = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
    var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
    var value = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).text$3;
    return new $c_s_util_Left().init___O(value)
  } else {
    $m_s_package$();
    return new $c_s_util_Right().init___O(node)
  }
}
function $f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__isAnnotation__pLamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__T__Z($thiz, property) {
  return (((($uI(property.length) >= 0) && ($as_T(property.substring(0, $uI("(".length))) === "(")) && $m_sjsr_RuntimeString$().endsWith__T__T__Z(property, ")")) || (($uI(property.length) >= 0) && ($as_T(property.substring(0, $uI("x-".length))) === "x-")))
}
function $f_Lamf_plugins_document_vocabularies_parser_instances_NodeMappableHelper__allNodeMappingIds__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__sci_Set($thiz, mapping) {
  if ((mapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(mapping);
    var array = [x2.id$1];
    if (($uI(array.length) === 0)) {
      var jsx$1 = $m_sci_Set$EmptySet$()
    } else {
      var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
      var i = 0;
      var len = $uI(array.length);
      while ((i < len)) {
        var index = i;
        var arg1 = array[index];
        b.$$plus$eq__O__scm_SetBuilder(arg1);
        i = ((1 + i) | 0)
      };
      var jsx$1 = b.elems$1
    };
    return $as_sci_Set(jsx$1)
  } else if ((mapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping)) {
    var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(mapping);
    var jsx$3 = $as_sc_Seq(x3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1));
    var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$1$2) {
        var x$1 = $as_Lamf_core_model_StrField(x$1$2);
        var this$4 = x$1.option$1;
        return $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()))
      })
    })($thiz));
    var this$5 = $m_sc_Seq$();
    return $as_sc_TraversableOnce(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$5.ReusableCBFInstance$2)).toSet__sci_Set()
  } else {
    throw new $c_s_MatchError().init___O(mapping)
  }
}
function $f_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularySyntax__closedNode__T__T__Lorg_yaml_model_YMap__V($thiz, nodeType, id, map) {
  if ((nodeType === "vocabulary")) {
    var allowedProps = $thiz.vocabulary$2
  } else if ((nodeType === "classTerm")) {
    var allowedProps = $thiz.classTerm$2
  } else {
    if ((nodeType !== "propertyTerm")) {
      throw new $c_s_MatchError().init___O(nodeType)
    };
    var allowedProps = $thiz.propertyTerm$2
  };
  var this$1 = map.map$3;
  var this$3 = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(this$1);
  var this$2 = $m_sci_Set$();
  var bf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$2);
  var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$3, bf);
  var this$4 = this$3.$$outer$4.keysIterator__sc_Iterator();
  while (this$4.hasNext__Z()) {
    var arg1 = this$4.next__O();
    var x$1 = $as_Lorg_yaml_model_YNode(arg1);
    var conversion = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
    var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
    b.$$plus$eq__O__scm_Builder($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(x$1, conversion, iv)).text$3)
  };
  $as_sc_IterableLike(b.result__O()).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, allowedProps$1, id$1, nodeType$1, map$1) {
    return (function(property$2) {
      var property = $as_T(property$2);
      var x1 = allowedProps$1.get__O__s_Option(property);
      if ((!(x1 instanceof $c_s_Some))) {
        var x = $m_s_None$();
        if ((x === x1)) {
          var this$5 = $as_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter(this$2$1);
          $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__closedNodeViolation__T__T__T__Lorg_yaml_model_YPart__V(this$5, id$1, property, nodeType$1, map$1)
        } else {
          throw new $c_s_MatchError().init___O(x1)
        }
      }
    })
  })($thiz, allowedProps, id, nodeType, map)))
}
function $f_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularySyntax__$$init$__V($thiz) {
  var array = [new $c_T2().init___O__O("$dialect", "string"), new $c_T2().init___O__O("base", "string"), new $c_T2().init___O__O("usage", "string"), new $c_T2().init___O__O("vocabulary", "string"), new $c_T2().init___O__O("uses", "libraries"), new $c_T2().init___O__O("external", "libraries"), new $c_T2().init___O__O("classTerms", "ClassTerm[]"), new $c_T2().init___O__O("propertyTerms", "PropertyTerm[]")];
  var this$20 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$20.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  $thiz.vocabulary$2 = $as_sci_Map(this$20.elems$1);
  var array$1 = [new $c_T2().init___O__O("displayName", "string"), new $c_T2().init___O__O("description", "string"), new $c_T2().init___O__O("properties", "string[]"), new $c_T2().init___O__O("extends", "string[]")];
  var this$32 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i$1 = 0;
  var len$1 = $uI(array$1.length);
  while ((i$1 < len$1)) {
    var index$1 = i$1;
    var arg1$1 = array$1[index$1];
    this$32.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1$1));
    i$1 = ((1 + i$1) | 0)
  };
  $thiz.classTerm$2 = $as_sci_Map(this$32.elems$1);
  var array$2 = [new $c_T2().init___O__O("displayName", "string"), new $c_T2().init___O__O("description", "string"), new $c_T2().init___O__O("range", "string[]"), new $c_T2().init___O__O("extends", "string[]")];
  var this$44 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i$2 = 0;
  var len$2 = $uI(array$2.length);
  while ((i$2 < len$2)) {
    var index$2 = i$2;
    var arg1$2 = array$2[index$2];
    this$44.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1$2));
    i$2 = ((1 + i$2) | 0)
  };
  $thiz.propertyTerm$2 = $as_sci_Map(this$44.elems$1)
}
function $f_Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor__dialect__Lamf_core_Root__s_Option($thiz, root) {
  var x1 = root.parsed$1;
  if ((x1 instanceof $c_Lamf_core_parser_SyamlParsedDocument)) {
    var x2 = $as_Lamf_core_parser_SyamlParsedDocument(x1);
    var document = x2.document$2;
    return $f_Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor__dialectForDoc__pLamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor__Lorg_yaml_model_YDocument__s_Option($thiz, document)
  } else {
    return $m_s_None$()
  }
}
function $f_Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor__dialectForDoc__pLamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor__Lorg_yaml_model_YDocument__s_Option($thiz, document) {
  var node = document.node$2;
  var this$2 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YMapYRead$());
  if (this$2.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var x$1 = $as_Lorg_yaml_model_YMap(arg1);
    var this$3 = new $c_s_Some().init___O(x$1.entries$3)
  };
  var this$4 = $as_sc_TraversableOnce((this$3.isEmpty__Z() ? $m_sci_Nil$() : this$3.get__O()));
  var pf = new $c_Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor$$anonfun$dialectForDoc$3().init___Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor($thiz);
  var this$5 = $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$4, pf);
  if (this$5.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1$1 = this$5.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var this$6 = e.value$2.asScalar__s_Option();
    if (this$6.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1$2 = this$6.get__O();
      var x$3 = $as_Lorg_yaml_model_YScalar(arg1$2);
      return new $c_s_Some().init___O(x$3.text$3)
    }
  }
}
function $f_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor__containsVersion__pLamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor__Lorg_yaml_model_YDocument__Lamf_plugins_document_vocabularies_model_document_Dialect__Z($thiz, document, d) {
  var node = document.node$2;
  var this$2 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YMapYRead$());
  if (this$2.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var x$5 = $as_Lorg_yaml_model_YMap(arg1);
    var this$3 = new $c_s_Some().init___O(x$5.entries$3)
  };
  var this$4 = $as_sc_TraversableOnce((this$3.isEmpty__Z() ? $m_sci_Nil$() : this$3.get__O()));
  var pf = new $c_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor$$anonfun$containsVersion$3().init___Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor__Lamf_plugins_document_vocabularies_model_document_Dialect($thiz, d);
  var this$5 = $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$4, pf);
  if ((!this$5.isEmpty__Z())) {
    var arg1$1 = this$5.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var this$6 = e.value$2.asScalar__s_Option();
    if ((!this$6.isEmpty__Z())) {
      var arg1$2 = this$6.get__O();
      var x$6 = $as_Lorg_yaml_model_YScalar(arg1$2);
      var jsx$1 = x$6.text$3;
      var this$7 = $as_Lamf_core_model_StrField(d.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Version$1));
      var this$8 = this$7.option$1;
      return (jsx$1 === $as_T((this$8.isEmpty__Z() ? null : this$8.get__O())))
    } else {
      return false
    }
  } else {
    return false
  }
}
function $f_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor__dialectInKey__Lamf_core_Root__Lamf_plugins_document_vocabularies_DialectsRegistry__s_Option($thiz, root, registry) {
  var x1 = root.parsed$1;
  if ((x1 instanceof $c_Lamf_core_parser_SyamlParsedDocument)) {
    var x2 = $as_Lamf_core_parser_SyamlParsedDocument(x1);
    var root$1 = x2.document$2;
    return $f_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor__dialectByKeyProperty__Lorg_yaml_model_YDocument__Lamf_plugins_document_vocabularies_DialectsRegistry__s_Option($thiz, root$1, registry)
  } else {
    return $m_s_None$()
  }
}
function $f_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor__dialectByKeyProperty__Lorg_yaml_model_YDocument__Lamf_plugins_document_vocabularies_DialectsRegistry__s_Option($thiz, root, registry) {
  var this$1 = registry.map$1;
  var this$2 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$1);
  var this$3 = this$2.$$outer$3.valuesIterator__sc_Iterator();
  while (this$3.hasNext__Z()) {
    var a = this$3.next__O();
    var d = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(a);
    var this$4 = $m_s_Option$().apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(d.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1)));
    if ((!this$4.isEmpty__Z())) {
      var arg1 = this$4.get__O();
      var x$4 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(arg1);
      var this$5 = $as_Lamf_core_model_BoolField(x$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().KeyProperty$1));
      var jsx$1 = $f_Lamf_core_model_BoolField__value__Z(this$5)
    } else {
      var jsx$1 = false
    };
    if ((jsx$1 && $f_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor__containsVersion__pLamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor__Lorg_yaml_model_YDocument__Lamf_plugins_document_vocabularies_model_document_Dialect__Z($thiz, root, d))) {
      return new $c_s_Some().init___O(a)
    }
  };
  return $m_s_None$()
}
function $f_Lamf_plugins_document_webapi_contexts_emitter_oas_CompactEmissionContext__$$init$__V($thiz) {
  var this$2 = new $c_sci_StringOps().init___T("^[^/]+$");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  $thiz.nameRegex$3 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  $thiz.definitionsQueue$3 = new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue().init___scm_Queue__scm_Map__Lamf_plugins_document_webapi_contexts_emitter_oas_CompactEmissionContext(new $c_scm_Queue().init___(), $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $thiz);
  $thiz.forceEmission$3 = $m_s_None$()
}
function $f_Lamf_plugins_document_webapi_contexts_emitter_oas_OasCompactEmitterFactory__recursiveShapeEmitter__F3($thiz) {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(shape$2, ordering$2, list$2) {
      var shape = $as_Lamf_core_model_domain_RecursiveShape(shape$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      var list = $as_sc_Seq(list$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasRecursiveShapeEmitter().init___Lamf_core_model_domain_RecursiveShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(shape, ordering, list, $this.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext())
    })
  })($thiz))
}
function $f_Lamf_plugins_document_webapi_contexts_emitter_oas_OasCompactEmitterFactory__declaredTypesEmitter__F3($thiz) {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(types$2, references$2, ordering$2) {
      var types = $as_sc_Seq(types$2);
      var references = $as_sc_Seq(references$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters().init___sc_Seq__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(types, references, ordering, $this.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext())
    })
  })($thiz))
}
function $f_Lamf_plugins_document_webapi_contexts_emitter_oas_OasCompactEmitterFactory__typeEmitters__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq($thiz, shape, ordering, ignored, references, pointer, schemaPath) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(shape, ordering, ignored, references, pointer, schemaPath, $thiz.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext()).emitters__sc_Seq()
}
function $f_Lamf_plugins_document_webapi_parser_OasTypeDefStringValueMatcher__matchFormat__Lamf_plugins_domain_shapes_models_TypeDef__s_Option($thiz, typeDef) {
  var x = $m_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$();
  if ((x === typeDef)) {
    return new $c_s_Some().init___O("byte")
  } else {
    var x$3 = $m_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$();
    if ((x$3 === typeDef)) {
      return new $c_s_Some().init___O("binary")
    } else {
      var x$5 = $m_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$();
      if ((x$5 === typeDef)) {
        return new $c_s_Some().init___O("password")
      } else {
        var x$7 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$();
        if ((x$7 === typeDef)) {
          return new $c_s_Some().init___O("date-time")
        } else {
          var x$9 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$();
          if ((x$9 === typeDef)) {
            return new $c_s_Some().init___O("date-time-only")
          } else {
            var x$11 = $m_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$();
            if ((x$11 === typeDef)) {
              return new $c_s_Some().init___O("time-only")
            } else {
              var x$13 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$();
              if ((x$13 === typeDef)) {
                return new $c_s_Some().init___O("date-only")
              } else {
                var x$15 = $m_Lamf_plugins_domain_shapes_models_TypeDef$LongType$();
                if ((x$15 === typeDef)) {
                  return new $c_s_Some().init___O("int64")
                } else {
                  var x$17 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$();
                  if ((x$17 === typeDef)) {
                    return new $c_s_Some().init___O("double")
                  } else {
                    return $m_s_None$()
                  }
                }
              }
            }
          }
        }
      }
    }
  }
}
function $f_Lamf_plugins_document_webapi_parser_OasTypeDefStringValueMatcher__matchType__Lamf_plugins_domain_shapes_models_TypeDef__T($thiz, typeDef) {
  var x = $m_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$();
  if ((x === typeDef)) {
    return "string"
  } else {
    var x$3 = $m_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$();
    if ((x$3 === typeDef)) {
      return "string"
    } else {
      var x$5 = $m_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$();
      if ((x$5 === typeDef)) {
        return "string"
      } else {
        var x$7 = $m_Lamf_plugins_domain_shapes_models_TypeDef$StrType$();
        if ((x$7 === typeDef)) {
          return "string"
        } else {
          var x$9 = $m_Lamf_plugins_domain_shapes_models_TypeDef$IntType$();
          if ((x$9 === typeDef)) {
            return "integer"
          } else {
            var x$11 = $m_Lamf_plugins_domain_shapes_models_TypeDef$LongType$();
            if ((x$11 === typeDef)) {
              return "integer"
            } else {
              var x$13 = $m_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$();
              if ((x$13 === typeDef)) {
                return "number"
              } else {
                var x$15 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$();
                if ((x$15 === typeDef)) {
                  return "number"
                } else {
                  var x$17 = $m_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$();
                  if ((x$17 === typeDef)) {
                    return "boolean"
                  } else {
                    var x$19 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$();
                    if ((x$19 === typeDef)) {
                      return "string"
                    } else {
                      var x$21 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$();
                      if ((x$21 === typeDef)) {
                        return "string"
                      } else {
                        var x$23 = $m_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$();
                        if ((x$23 === typeDef)) {
                          return "string"
                        } else {
                          var x$25 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$();
                          if ((x$25 === typeDef)) {
                            return "string"
                          } else {
                            var x$27 = $m_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$();
                            if ((x$27 === typeDef)) {
                              return "array"
                            } else {
                              var x$29 = $m_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$();
                              if ((x$29 === typeDef)) {
                                return "object"
                              } else {
                                var x$31 = $m_Lamf_plugins_domain_shapes_models_TypeDef$FileType$();
                                if ((x$31 === typeDef)) {
                                  return "file"
                                } else {
                                  var x$33 = $m_Lamf_plugins_domain_shapes_models_TypeDef$NilType$();
                                  if ((x$33 === typeDef)) {
                                    return "null"
                                  } else {
                                    var x$35 = $m_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$();
                                    if ((x$35 === typeDef)) {
                                      return "number"
                                    } else {
                                      var x$37 = $m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$();
                                      if ((x$37 === typeDef)) {
                                        throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_RuntimeException().init___T("Undefined type def"))
                                      } else {
                                        throw new $c_s_MatchError().init___O(typeDef)
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }
}
function $is_Lamf_plugins_document_webapi_parser_RamlFragment(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_document_webapi_parser_RamlFragment)))
}
function $as_Lamf_plugins_document_webapi_parser_RamlFragment(obj) {
  return (($is_Lamf_plugins_document_webapi_parser_RamlFragment(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.RamlFragment"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_RamlFragment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_RamlFragment)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_RamlFragment(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_RamlFragment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.RamlFragment;", depth))
}
function $is_Lamf_plugins_document_webapi_parser_spec_async_MessageType(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_document_webapi_parser_spec_async_MessageType)))
}
function $as_Lamf_plugins_document_webapi_parser_spec_async_MessageType(obj) {
  return (($is_Lamf_plugins_document_webapi_parser_spec_async_MessageType(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.MessageType"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_MessageType(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_MessageType)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_MessageType(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_MessageType(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.MessageType;", depth))
}
function $is_Lamf_plugins_document_webapi_parser_spec_async_parser_Finder(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_document_webapi_parser_spec_async_parser_Finder)))
}
function $as_Lamf_plugins_document_webapi_parser_spec_async_parser_Finder(obj) {
  return (($is_Lamf_plugins_document_webapi_parser_spec_async_parser_Finder(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.parser.Finder"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_Finder(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_parser_Finder)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_Finder(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_Finder(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.parser.Finder;", depth))
}
function $f_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__checkBalancedParams__T__Lorg_yaml_model_YNode__T__T__Lamf_plugins_document_webapi_contexts_WebApiContext__V($thiz, path, value, node, property, ctx) {
  var this$2 = new $c_sci_StringOps().init___T("\\{[^\\}]*\\{");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  var pattern1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  var this$5 = new $c_sci_StringOps().init___T("\\}[^\\{]*\\}");
  var groupNames$1 = $m_sci_Nil$();
  var $$this$1 = this$5.repr$1;
  var pattern2 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this$1, groupNames$1);
  var this$7 = pattern1.findFirstMatchIn__jl_CharSequence__s_Option(path);
  if (this$7.isDefined__Z()) {
    var jsx$1 = true
  } else {
    var this$8 = pattern2.findFirstMatchIn__jl_CharSequence__s_Option(path);
    var jsx$1 = this$8.isDefined__Z()
  };
  if (jsx$1) {
    var this$9 = ctx.eh$1;
    var spec = $m_Lamf_validations_ParserSideValidations$().PathTemplateUnbalancedParameters$1;
    var prop = new $c_s_Some().init___O(property);
    var l = value.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$9, spec, node, prop, "Invalid path template syntax", l)
  }
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_ExampleParser__parseExamples__Lamf_plugins_domain_shapes_models_AnyShape__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext__V($thiz, shape, map, options, ctx) {
  new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser().init___Lorg_yaml_model_YMap__T__T__Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext(map, "example", "examples", shape, options.checkScalar__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions(shape), ctx).parse__V()
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$CommonScalarParsingLogic__setValue__pLamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$CommonScalarParsingLogic__T__Lorg_yaml_model_YMap__Lamf_core_metamodel_Field__Lamf_core_model_domain_Shape__V($thiz, key, map, field, shape) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option(key);
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var node = entry.value$2;
    var iv = $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser().ctx$2;
    var value = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
    var value$1 = value.text__Lamf_core_model_domain_AmfScalar();
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(shape, field, value$1, annotations)
  }
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$CommonScalarParsingLogic__parseScalar__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_domain_shapes_models_TypeDef($thiz, map, shape, typeDef) {
  var x = $m_Lamf_plugins_domain_shapes_models_TypeDef$StrType$();
  if ((x === typeDef)) {
    var jsx$1 = true
  } else {
    var x$3 = $m_Lamf_plugins_domain_shapes_models_TypeDef$FileType$();
    var jsx$1 = (x$3 === typeDef)
  };
  if (jsx$1) {
    var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var this$2 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser();
    var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Pattern$1;
    var iv = $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser().ctx$2;
    jsx$2.key__T__F1__V("pattern", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$2, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(shape));
    var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var this$4 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser();
    var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MinLength$1;
    var iv$1 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser().ctx$2;
    jsx$3.key__T__F1__V("minLength", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$4, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(shape));
    var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var this$6 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser();
    var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MaxLength$1;
    var iv$2 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser().ctx$2;
    jsx$4.key__T__F1__V("maxLength", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$6, field$2, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(shape))
  } else if ($f_Lamf_plugins_domain_shapes_models_TypeDef__isNumber__Z(typeDef)) {
    var field$3 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Minimum$1;
    $f_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$CommonScalarParsingLogic__setValue__pLamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$CommonScalarParsingLogic__T__Lorg_yaml_model_YMap__Lamf_core_metamodel_Field__Lamf_core_model_domain_Shape__V($thiz, "minimum", map, field$3, shape);
    var field$4 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Maximum$1;
    $f_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$CommonScalarParsingLogic__setValue__pLamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$CommonScalarParsingLogic__T__Lorg_yaml_model_YMap__Lamf_core_metamodel_Field__Lamf_core_model_domain_Shape__V($thiz, "maximum", map, field$4, shape);
    var jsx$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var this$8 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser();
    var field$5 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MultipleOf$1;
    var iv$3 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser().ctx$2;
    jsx$5.key__T__F1__V("multipleOf", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$8, field$5, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(shape));
    var x$5 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser().version$2;
    var x$6 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$();
    if (((x$5 !== null) && x$5.equals__O__Z(x$6))) {
      $f_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$CommonScalarParsingLogic__parseNumericExclusive__pLamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$CommonScalarParsingLogic__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape__V($thiz, map, shape)
    } else {
      var jsx$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
      var this$10 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser();
      var field$6 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().ExclusiveMinimum$1;
      var iv$4 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser().ctx$2;
      jsx$6.key__T__F1__V("exclusiveMinimum", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$10, field$6, iv$4).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(shape));
      var jsx$7 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
      var this$12 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser();
      var field$7 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().ExclusiveMaximum$1;
      var iv$5 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser().ctx$2;
      jsx$7.key__T__F1__V("exclusiveMaximum", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$12, field$7, iv$5).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(shape))
    }
  };
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType().init___Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_document_webapi_contexts_WebApiContext(shape, typeDef, $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser().ctx$2).parse__Lorg_yaml_model_YMap__Lamf_plugins_domain_shapes_models_TypeDef(map)
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$CommonScalarParsingLogic__parseNumericExclusive__pLamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$CommonScalarParsingLogic__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape__V($thiz, map, shape) {
  if (new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("exclusiveMinimum").isDefined__Z()) {
    var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Minimum$1;
    $f_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$CommonScalarParsingLogic__setValue__pLamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$CommonScalarParsingLogic__T__Lorg_yaml_model_YMap__Lamf_core_metamodel_Field__Lamf_core_model_domain_Shape__V($thiz, "exclusiveMinimum", map, field, shape);
    var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().ExclusiveMinimum$1;
    var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(true, new $c_Lamf_core_parser_Annotations().init___());
    $m_Lamf_core_parser_Annotations$();
    var annotation = new $c_Lamf_core_annotations_SynthesizedField().init___();
    var annotations = new $c_Lamf_core_parser_Annotations().init___().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(annotation);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(shape, field$1, value, annotations)
  };
  if (new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("exclusiveMaximum").isDefined__Z()) {
    var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Maximum$1;
    $f_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$CommonScalarParsingLogic__setValue__pLamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$CommonScalarParsingLogic__T__Lorg_yaml_model_YMap__Lamf_core_metamodel_Field__Lamf_core_model_domain_Shape__V($thiz, "exclusiveMaximum", map, field$2, shape);
    var field$3 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().ExclusiveMaximum$1;
    var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(true, new $c_Lamf_core_parser_Annotations().init___());
    $m_Lamf_core_parser_Annotations$();
    var annotation$1 = new $c_Lamf_core_annotations_SynthesizedField().init___();
    var annotations$1 = new $c_Lamf_core_parser_Annotations().init___().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(annotation$1);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(shape, field$3, value$1, annotations$1)
  }
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementShapeParser__parse__Lamf_plugins_domain_shapes_models_AnyShape($thiz) {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape.call($thiz);
  var map = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser($thiz).map__Lorg_yaml_model_YMap();
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$2 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$DataArrangementShapeParser$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser();
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MinItems$1;
  var iv = $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$DataArrangementShapeParser$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser().ctx$2;
  jsx$1.key__T__F1__V("minItems", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$2, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField($as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser($thiz).shape__Lamf_plugins_domain_shapes_models_AnyShape()));
  var map$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser($thiz).map__Lorg_yaml_model_YMap();
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var this$4 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$DataArrangementShapeParser$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser();
  var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MaxItems$1;
  var iv$1 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$DataArrangementShapeParser$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser().ctx$2;
  jsx$2.key__T__F1__V("maxItems", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$4, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField($as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser($thiz).shape__Lamf_plugins_domain_shapes_models_AnyShape()));
  var map$2 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser($thiz).map__Lorg_yaml_model_YMap();
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var this$6 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$DataArrangementShapeParser$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser();
  var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().UniqueItems$1;
  var iv$2 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$DataArrangementShapeParser$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser().ctx$2;
  jsx$3.key__T__F1__V("uniqueItems", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$6, field$2, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField($as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser($thiz).shape__Lamf_plugins_domain_shapes_models_AnyShape()));
  var x = $thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$DataArrangementShapeParser$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser().version$2;
  var x$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$();
  if (((x !== null) && x.equals__O__Z(x$2))) {
    new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__T__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape($thiz.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$DataArrangementShapeParser$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(), "contains", $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Contains$1, $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser($thiz).map__Lorg_yaml_model_YMap(), $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser($thiz).shape__Lamf_plugins_domain_shapes_models_AnyShape()).parse__V()
  };
  return $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser($thiz).shape__Lamf_plugins_domain_shapes_models_AnyShape()
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$CommonScalarParsingLogic__parseOASFields__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape__V($thiz, map, shape) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("pattern");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
    var iv = $thiz.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser().ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
    var regex = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv));
    var thiz = regex;
    if ((!(($uI(thiz.length) >= 0) && ($as_T(thiz.substring(0, $uI("^".length))) === "^")))) {
      regex = ("^" + regex)
    };
    if ((!$m_sjsr_RuntimeString$().endsWith__T__T__Z(regex, "$"))) {
      regex = (regex + "$")
    };
    $m_Lorg_yaml_model_YNode$();
    var str = regex;
    var node = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    var iv$1 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser().ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
    var this$12 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv$1);
    var qual$1 = this$12.text__Lamf_core_model_domain_AmfScalar();
    var x$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    var x$2 = qual$1.value$1;
    var pattern = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(x$2, x$1);
    var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Pattern$1;
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(shape, field, pattern, annotations)
  };
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$14 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser();
  var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MinLength$1;
  var iv$2 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser().ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$1.key__T__F1__V("minLength", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$14, field$1, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(shape).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$16 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser();
  var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MaxLength$1;
  var iv$3 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser().ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$2.key__T__F1__V("maxLength", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$16, field$2, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(shape).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var jsx$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T("exclusiveMinimum").asRamlAnnotation__T();
  var this$19 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser();
  var field$3 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().ExclusiveMinimum$1;
  var iv$4 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser().ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$4.key__T__F1__V(jsx$3, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$19, field$3, iv$4).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(shape));
  var jsx$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var jsx$5 = new $c_Lamf_core_utils_package$AmfStrings().init___T("exclusiveMaximum").asRamlAnnotation__T();
  var this$22 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser();
  var field$4 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().ExclusiveMaximum$1;
  var iv$5 = $thiz.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser().ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$6.key__T__F1__V(jsx$5, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$22, field$4, iv$5).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(shape))
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$SchemaUsageRestrictions__emptyObjectType__Lamf_core_model_domain_Shape__Z($thiz, shape) {
  if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_NodeShape(shape);
    return $as_sc_Seq(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1)).isEmpty__Z()
  } else {
    return false
  }
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$SchemaUsageRestrictions__emptyArrayType__Lamf_core_model_domain_Shape__Z($thiz, shape) {
  if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(shape);
    return $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1))).isEmpty__Z()
  } else {
    return false
  }
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$SchemaUsageRestrictions__checkSchemaInProperty__sc_Seq__s_Option__Lamf_core_parser_Range__V($thiz, elements, location, entryRange) {
  elements.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, entryRange$1, location$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_domain_AmfElement(x0$1$2);
      matchEnd5: {
        if ((x0$1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
          var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x0$1);
          if ((x2.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.getClassOf()) || x2.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema.getClassOf()))) {
            $this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$SchemaUsageRestrictions$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser().ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V($m_Lamf_validations_ParserSideValidations$().JsonSchemaInheratinaceWarningSpecification$1, x2.id$1, new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1.value$1.iri__T()), "Invalid reference to JSON Schema", new $c_s_Some().init___O(new $c_Lamf_core_annotations_LexicalInformation().init___Lamf_core_parser_Range(entryRange$1)), (location$1.isEmpty__Z() ? $f_Lamf_core_model_domain_ExternalSourceElement__location__s_Option(x2) : location$1));
            break matchEnd5
          }
        };
        if ((x0$1 instanceof $c_Lamf_plugins_domain_shapes_models_SchemaShape)) {
          var x3 = $as_Lamf_plugins_domain_shapes_models_SchemaShape(x0$1);
          var this$1 = $this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$SchemaUsageRestrictions$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser().ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1;
          var specification = $m_Lamf_validations_ParserSideValidations$().XmlSchemaInheratinaceWarningSpecification$1;
          var node = x3.id$1;
          var property = new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1.value$1.iri__T());
          var lexical = new $c_s_Some().init___O(new $c_Lamf_core_annotations_LexicalInformation().init___Lamf_core_parser_Range(entryRange$1));
          var location$2 = (location$1.isEmpty__Z() ? $f_Lamf_core_model_domain_ExternalSourceElement__location__s_Option(x3) : location$1);
          this$1.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "Invalid reference to XML Schema", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location$2);
          break matchEnd5
        }
      }
    })
  })($thiz, entryRange, location)))
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$SchemaUsageRestrictions__emptyScalarType__Lamf_core_model_domain_Shape__Z($thiz, shape) {
  if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(shape);
    return $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1)).option$1.isEmpty__Z()
  } else {
    return false
  }
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$SchemaUsageRestrictions__checkSchemaInheritance__Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_parser_Range__V($thiz, base, elements, entryRange) {
  var x = base.meta__Lamf_core_metamodel_Obj();
  var x$2 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$();
  if (((((!((x !== null) && (x === x$2))) && (!$f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$SchemaUsageRestrictions__emptyObjectType__Lamf_core_model_domain_Shape__Z($thiz, base))) && (!$f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$SchemaUsageRestrictions__emptyScalarType__Lamf_core_model_domain_Shape__Z($thiz, base))) && (!$f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$SchemaUsageRestrictions__emptyArrayType__Lamf_core_model_domain_Shape__Z($thiz, base)))) {
    elements.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, entryRange$1, base$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_model_domain_AmfElement(x0$1$2);
        matchEnd5: {
          if ((x0$1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
            var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x0$1);
            if ((x2.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.getClassOf()) || x2.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema.getClassOf()))) {
              $this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$SchemaUsageRestrictions$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser().ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V($m_Lamf_validations_ParserSideValidations$().JsonSchemaInheratinaceWarningSpecification$1, x2.id$1, new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1.value$1.iri__T()), "Inheritance from JSON Schema", new $c_s_Some().init___O(new $c_Lamf_core_annotations_LexicalInformation().init___Lamf_core_parser_Range(entryRange$1)), base$1.location__s_Option());
              break matchEnd5
            }
          };
          if ((x0$1 instanceof $c_Lamf_plugins_domain_shapes_models_SchemaShape)) {
            var x3 = $as_Lamf_plugins_domain_shapes_models_SchemaShape(x0$1);
            var this$1 = $this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$SchemaUsageRestrictions$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser().ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1;
            var specification = $m_Lamf_validations_ParserSideValidations$().XmlSchemaInheratinaceWarningSpecification$1;
            var node = x3.id$1;
            var property = new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1.value$1.iri__T());
            var lexical = new $c_s_Some().init___O(new $c_Lamf_core_annotations_LexicalInformation().init___Lamf_core_parser_Range(entryRange$1));
            var location = base$1.location__s_Option();
            this$1.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "Inheritance from XML Schema", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
            break matchEnd5
          }
        }
      })
    })($thiz, entryRange, base)))
  }
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax__isTypeExpression__T__Z($thiz, str) {
  try {
    var x = $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$().matchType__Lamf_plugins_document_webapi_parser_TypeName__Lamf_plugins_domain_shapes_models_TypeDef__Z__Lamf_plugins_domain_shapes_models_TypeDef(new $c_Lamf_plugins_document_webapi_parser_TypeName().init___T__s_Option(str, $m_s_None$()), $m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$(), ($m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$(), false));
    var x$2 = $m_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$();
    return ((x !== null) && (x === x$2))
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 instanceof $c_jl_Exception)) {
      return false
    } else {
      throw e
    }
  }
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax__parseWellKnownTypeRef__T__Lamf_core_model_domain_Shape($thiz, ramlType) {
  if (((ramlType === "nil") || ((ramlType === "") || (ramlType === "null")))) {
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    return new $c_Lamf_plugins_domain_shapes_models_NilShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
  } else if ((ramlType === "any")) {
    $m_Lamf_core_parser_Annotations$();
    var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
    var fields = new $c_Lamf_core_parser_Fields().init___();
    return new $c_Lamf_plugins_domain_shapes_models_AnyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations$1)
  } else if (((ramlType === "string") || ((ramlType === "integer") || ((ramlType === "number") || ((ramlType === "boolean") || ((ramlType === "datetime") || ((ramlType === "datetime-only") || ((ramlType === "time-only") || (ramlType === "date-only"))))))))) {
    $m_Lamf_core_parser_Annotations$();
    var annotations$2 = new $c_Lamf_core_parser_Annotations().init___();
    var this$11 = new $c_Lamf_plugins_domain_shapes_models_ScalarShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$2);
    var dataType = $m_Lamf_core_model_DataType$().apply__T__T(ramlType);
    var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
    return $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$11, field, dataType))
  } else if ((ramlType === "array")) {
    $m_Lamf_core_parser_Annotations$();
    var annotations$3 = new $c_Lamf_core_parser_Annotations().init___();
    return new $c_Lamf_plugins_domain_shapes_models_ArrayShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$3)
  } else if ((ramlType === "object")) {
    $m_Lamf_core_parser_Annotations$();
    var annotations$4 = new $c_Lamf_core_parser_Annotations().init___();
    return new $c_Lamf_plugins_domain_shapes_models_NodeShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$4)
  } else if ((ramlType === "union")) {
    $m_Lamf_core_parser_Annotations$();
    var annotations$5 = new $c_Lamf_core_parser_Annotations().init___();
    return new $c_Lamf_plugins_domain_shapes_models_UnionShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$5)
  } else if ((ramlType === "file")) {
    $m_Lamf_core_parser_Annotations$();
    var annotations$6 = new $c_Lamf_core_parser_Annotations().init___();
    return new $c_Lamf_plugins_domain_shapes_models_FileShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$6)
  } else {
    throw new $c_s_MatchError().init___O(ramlType)
  }
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax__wellKnownType__T__Z__Z($thiz, str, isRef) {
  if ((!(((((($uI(str.indexOf("|")) > (-1)) || ($uI(str.indexOf("[")) > (-1))) || ($uI(str.indexOf("{")) > (-1))) || ($uI(str.indexOf("]")) > (-1))) || ($uI(str.indexOf("}")) > (-1))) || ((($uI(str.length) >= 0) && ($as_T(str.substring(0, $uI("<<".length))) === "<<")) && $m_sjsr_RuntimeString$().endsWith__T__T__Z(str, ">>"))))) {
    var x = $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$().matchType__Lamf_plugins_document_webapi_parser_TypeName__Lamf_plugins_domain_shapes_models_TypeDef__Z__Lamf_plugins_domain_shapes_models_TypeDef(new $c_Lamf_plugins_document_webapi_parser_TypeName().init___T__s_Option(str, $m_s_None$()), $m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$(), isRef);
    var x$2 = $m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$();
    return (!((x !== null) && (x === x$2)))
  } else {
    return false
  }
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter__emitExamples__Lamf_plugins_domain_shapes_models_AnyShape__scm_ListBuffer__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__V($thiz, shape, results, ordering, references, spec) {
  var this$1 = shape.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Examples$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    var x1 = spec.filterLocal__sc_Seq__sc_Seq($as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1))).partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(e$2) {
        var e = $as_Lamf_plugins_domain_shapes_models_Example(e$2);
        var this$2 = e.fields$1.fieldsMeta__sci_List();
        var elem = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Name$1;
        if ((!$f_sc_LinearSeqOptimized__contains__O__Z(this$2, elem))) {
          return (!$f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(e).isDefined__Z())
        } else {
          return false
        }
      })
    })($thiz)));
    if ((x1 === null)) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var anonymous = $as_sc_Seq(x1.$$und1__O());
    var named = $as_sc_Seq(x1.$$und2__O());
    var jsx$2 = $as_Lamf_core_model_domain_AmfArray(f.value$1.value$1).values$1;
    var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter($thiz);
    var this$3 = $m_sc_Seq$();
    var examples = spec.filterLocal__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2)));
    if (((examples.size__I() === 1) && named.isEmpty__Z())) {
      var this$4 = anonymous.headOption__s_Option();
      if ((!this$4.isEmpty__Z())) {
        var arg1$1 = this$4.get__O();
        var a = $as_Lamf_plugins_domain_shapes_models_Example(arg1$1);
        results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter().init___T__Lamf_plugins_domain_shapes_models_Example__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("example", a, ordering, spec))
      }
    } else {
      var idCounter = new $c_Lamf_core_utils_package$IdCounter().init___();
      anonymous.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, idCounter$1) {
        return (function(e$3$2) {
          var e$3 = $as_Lamf_plugins_domain_shapes_models_Example(e$3$2);
          var name = idCounter$1.genId__T__T("generated");
          $m_Lamf_core_parser_Annotations$();
          var annotation = new $c_Lamf_core_annotations_SynthesizedField().init___();
          var a$1 = new $c_Lamf_core_parser_Annotations().init___().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(annotation);
          return $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(e$3, name, a$1))
        })
      })($thiz, idCounter)));
      results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("examples", examples, ordering, references, spec))
    }
  }
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlCommonOASFieldsEmitter__emitOASFields__Lamf_core_parser_Fields__scm_ListBuffer__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__V($thiz, fs, result, spec) {
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MinLength$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("minLength", f, $m_s_None$(), spec)))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MaxLength$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("maxLength", f$3, $m_s_None$(), spec)))
  };
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().ExclusiveMinimum$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1$2 = this$5.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("exclusiveMinimum").asRamlAnnotation__T(), f$4, $m_s_None$())))
  };
  var this$8 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().ExclusiveMaximum$1);
  if ((!this$8.isEmpty__Z())) {
    var arg1$3 = this$8.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("exclusiveMaximum").asRamlAnnotation__T(), f$5, $m_s_None$())))
  }
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlCommonOASFieldsEmitter__processRamlPattern__Lamf_core_parser_FieldEntry__Lamf_core_parser_FieldEntry($thiz, f) {
  var rawRegex = $as_T($as_Lamf_core_model_domain_AmfScalar(f.value$1.value$1).value$1);
  var thiz = rawRegex;
  if ((($uI(thiz.length) >= 0) && ($as_T(thiz.substring(0, $uI("^".length))) === "^"))) {
    var x = rawRegex;
    var this$7 = new $c_sci_StringOps().init___T(x);
    var $$this = this$7.repr$1;
    var until = $uI($$this.length);
    rawRegex = $m_sci_StringOps$().slice$extension__T__I__I__T(this$7.repr$1, 1, until)
  };
  if ($m_sjsr_RuntimeString$().endsWith__T__T__Z(rawRegex, "$")) {
    var x$1 = rawRegex;
    var this$11 = new $c_sci_StringOps().init___T(x$1);
    rawRegex = $as_T($f_sc_IndexedSeqOptimized__dropRight__I__O(this$11, 1))
  };
  var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(rawRegex, new $c_Lamf_core_parser_Annotations().init___());
  var annotations = f.value$1.annotations$1;
  var x$1$1 = new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value, annotations);
  var x$2 = f.field$1;
  return new $c_Lamf_core_parser_FieldEntry().init___Lamf_core_metamodel_Field__Lamf_core_parser_Value(x$2, x$1$1)
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFormatTranslator__checkRamlFormats__T__T($thiz, format) {
  return ((format === "date-only") ? "date" : ((format === "time-only") ? "time" : ((format === "datetime-only") ? "date-time" : ((format === "datetime") ? "date-time" : ((format === "rfc3339") ? "date-time" : format)))))
}
function $f_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeDeclarationsHelper__parseTypeDeclarations__Lorg_yaml_model_YMap__T__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__V($thiz, map, typesPrefix, ctx) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword = $thiz.definitionsKey__T();
  var this$3 = this$2.key__T__s_Option(keyword);
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, ctx)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ctx$1, typesPrefix$1) {
      return (function(e$2) {
        var e = $as_Lorg_yaml_model_YMapEntry(e$2);
        var this$5 = e.key$2;
        var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
        var typeName = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion$1, ctx$1)).text$3;
        var x1 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(e, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, typeName$1, e$1, typesPrefix$1$1) {
          return (function(shape$2) {
            var shape = $as_Lamf_core_model_domain_Shape(shape$2);
            var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Name$1;
            var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(typeName$1, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(e$1.key$2.value__Lorg_yaml_model_YValue()));
            var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(e$1.key$2);
            $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(shape, field, value, annotations);
            shape.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(typesPrefix$1$1, shape.adopted$default$2__sc_Seq())
          })
        })($this, typeName, e, typesPrefix$1)), ctx$1).parse__s_Option();
        if ((x1 instanceof $c_s_Some)) {
          var x2 = $as_s_Some(x1);
          var shape$3 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x2.value$2);
          var jsx$1 = ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations();
          var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
          return jsx$1.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(shape$3, annotation)))
        } else {
          var x = $m_s_None$();
          if ((x === x1)) {
            var this$9 = ctx$1.eh$1;
            var specification = $m_Lamf_validations_ParserSideValidations$().UnableToParseShape$1;
            $m_Lamf_core_parser_Annotations$();
            var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
            var qual$1 = new $c_Lamf_plugins_domain_shapes_models_NodeShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
            var x$2$2 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
            var node = qual$1.adopted__T__sc_Seq__Lamf_plugins_domain_shapes_models_NodeShape(typesPrefix$1, x$2$2).id$1;
            var message = ("Error parsing shape at " + typeName);
            var prop = $m_s_None$();
            var l = e.location$1;
            $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$9, specification, node, prop, message, l);
            return (void 0)
          } else {
            throw new $c_s_MatchError().init___O(x1)
          }
        }
      })
    })($thiz, ctx, typesPrefix)))
  }
}
function $is_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeExampleEmitters(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeExampleEmitters)))
}
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeExampleEmitters(obj) {
  return (($is_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeExampleEmitters(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasLikeExampleEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeExampleEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeExampleEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeExampleEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeExampleEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.OasLikeExampleEmitters;", depth))
}
function $f_Lamf_plugins_document_webapi_parser_spec_raml_Raml10BaseSpecParser__parseSecuritySchemeDeclarations__Lorg_yaml_model_YMap__T__V($thiz, map, parent) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("securitySchemes");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = e.value$2;
    var x1 = this$4.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x === x1)) {
      var this$5 = e.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = $thiz.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
      $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$1) {
        return (function(entry$2) {
          var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
          var jsx$1 = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations();
          var this$7 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser($this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().securitySchemeParser__F2().apply__O__O__O(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, entry$1, parent$1$1) {
            return (function(scheme$2) {
              var scheme = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(scheme$2);
              var this$6 = entry$1.key$2;
              var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
              var iv$1 = $this$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
              var name = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion$1, iv$1)).text$3;
              var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Name$1;
              var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(name, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$1.key$2.value__Lorg_yaml_model_YValue()));
              var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$1.key$2);
              $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(scheme, field, value, annotations);
              return scheme.adopted__T__sc_Seq__Lamf_plugins_domain_webapi_models_security_SecurityScheme(parent$1$1, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())))
            })
          })($this, entry, parent$1)))).parse__Lamf_plugins_domain_webapi_models_security_SecurityScheme();
          var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
          return jsx$1.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$7, annotation)))
        })
      })($thiz, parent)))
    } else {
      var x$3 = $m_Lorg_yaml_model_YType$().Null$1;
      if ((!(x$3 === x1))) {
        var this$8 = $thiz.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().InvalidSecuredByType$1;
        var message = (("Invalid type " + x1) + " for 'securitySchemes' node.");
        var ast = e.value$2;
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$8, specification, parent, prop, message, l)
      }
    }
  }
}
function $is_Lamf_plugins_document_webapi_resolution_stages_Branch(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_document_webapi_resolution_stages_Branch)))
}
function $as_Lamf_plugins_document_webapi_resolution_stages_Branch(obj) {
  return (($is_Lamf_plugins_document_webapi_resolution_stages_Branch(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.resolution.stages.Branch"))
}
function $isArrayOf_Lamf_plugins_document_webapi_resolution_stages_Branch(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_resolution_stages_Branch)))
}
function $asArrayOf_Lamf_plugins_document_webapi_resolution_stages_Branch(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_resolution_stages_Branch(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.resolution.stages.Branch;", depth))
}
function $f_Lamf_plugins_document_webapi_resolution_stages_InnerAdoption__adoptInner__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_document_webapi_resolution_stages_IdTracker__Lamf_core_model_domain_AmfElement($thiz, id, target, idTracker) {
  if (idTracker.notTracking__T__Z(id)) {
    idTracker.knownIds$1.$$plus$eq__O__scm_SetLike(id);
    if ((target instanceof $c_Lamf_core_model_domain_AmfArray)) {
      var x2 = $as_Lamf_core_model_domain_AmfArray(target);
      var jsx$2 = x2.values$1;
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, id$1, idTracker$1) {
        return (function(x$1$2) {
          var x$1 = $as_Lamf_core_model_domain_AmfElement(x$1$2);
          return $f_Lamf_plugins_document_webapi_resolution_stages_InnerAdoption__adoptInner__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_document_webapi_resolution_stages_IdTracker__Lamf_core_model_domain_AmfElement($this, id$1, x$1, idTracker$1)
        })
      })($thiz, id, idTracker));
      var this$1 = $m_sc_Seq$();
      return new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)), x2.annotations$1)
    } else if ((target instanceof $c_Lamf_core_model_domain_DataNode)) {
      var x3 = $as_Lamf_core_model_domain_DataNode(target);
      return $m_Lamf_core_model_domain_DataNodeOps$().adoptTree__T__Lamf_core_model_domain_DataNode__Lamf_core_model_domain_DataNode(id, x3)
    } else if ($is_Lamf_core_model_domain_DomainElement(target)) {
      var x4 = $as_Lamf_core_model_domain_DomainElement(target);
      x4.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(id, x4.adopted$default$2__sc_Seq());
      var this$3 = x4.fields__Lamf_core_parser_Fields();
      var fn = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, x4$1, idTracker$2) {
        return (function(x0$1$2) {
          var x0$1 = $as_T2(x0$1$2);
          if ((x0$1 !== null)) {
            var value = $as_Lamf_core_parser_Value(x0$1.$$und2__O());
            var id$2 = x4$1.id__T();
            var target$1 = value.value$1;
            $f_Lamf_plugins_document_webapi_resolution_stages_InnerAdoption__adoptInner__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_document_webapi_resolution_stages_IdTracker__Lamf_core_model_domain_AmfElement(this$2, id$2, target$1, idTracker$2)
          } else {
            throw new $c_s_MatchError().init___O(x0$1)
          }
        })
      })($thiz, x4, idTracker));
      this$3.fs$1.foreach__F1__V(fn);
      return x4
    } else {
      return target
    }
  } else {
    return target
  }
}
function $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$GenericValidations__emailValidation__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation($thiz, owlClass, owlProperty) {
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns, "pattern");
  var this$4 = new $c_sci_StringOps().init___T("^[a-zA-Z0-9\\.!#$%&'*+/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$");
  var x$4 = $f_sci_StringLike__stripMargin__C__T(this$4, 124);
  var x$6 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$1 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$8 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$1, "path");
  var x$10 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  return $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$6, "", owlClass, owlProperty, x$8, x$3, x$4, "", "Field 'email' must be in the format of an email address", x$10)
}
function $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$GenericValidations__urlValidation__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation($thiz, owlClass, owlProperty) {
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$4 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns, "pattern");
  var this$4 = new $c_sci_StringOps().init___T("^((https?|ftp|file)://)?[-a-zA-Z0-9()+&@#/%?=~_|!:,.;]*[-a-zA-Z0-9()+&@#/%=~_|]$");
  var x$5 = $f_sci_StringLike__stripMargin__C__T(this$4, 124);
  var x$6 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$1 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$7 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$1, "path");
  var x$10 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  return $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$6, "Must be in the format of a URL", owlClass, owlProperty, x$7, x$4, x$5, "", "", x$10)
}
function $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$GenericValidations__uriValidation__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation($thiz, owlClass, owlProperty) {
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$4 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns, "pattern");
  var this$4 = new $c_sci_StringOps().init___T("^\\w+:(\\/?\\/?)[^\\s]+$");
  var x$5 = $f_sci_StringLike__stripMargin__C__T(this$4, 124);
  var x$6 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$1 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$7 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$1, "path");
  var x$10 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  return $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$6, "Must be in the format of a URI", owlClass, owlProperty, x$7, x$4, x$5, "", "", x$10)
}
function $f_Lamf_plugins_document_webapi_validation_ImportUtils__validationId__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation__T($thiz, validation) {
  var x1 = validation.uri$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var s = $as_T(x2.value$2);
    return $m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType($as_T(s.trim())).iri__T()
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var s$1 = validation.owlClass$1;
      var classPostfix = $f_Lamf_plugins_document_webapi_validation_ImportUtils__postfix__T__T__T($thiz, s$1, "domain");
      var s$2 = validation.owlProperty$1;
      var propertyPostfix = $f_Lamf_plugins_document_webapi_validation_ImportUtils__postfix__T__T__T($thiz, s$2, "property");
      var s$3 = validation.constraint$1;
      var constraint = $f_Lamf_plugins_document_webapi_validation_ImportUtils__postfix__T__T__T($thiz, s$3, "constraint");
      return (((((("" + $m_Lamf_core_vocabulary_Namespace$().AmfParser$1.base$1) + classPostfix) + "-") + $as_T(propertyPostfix.trim())) + "-") + $as_T(constraint.trim()))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
}
function $f_Lamf_plugins_document_webapi_validation_ImportUtils__postfix__T__T__T($thiz, s, $default) {
  if ((s !== null)) {
    var this$2 = new $c_sci_StringOps().init___T(s);
    if ($f_sc_TraversableOnce__nonEmpty__Z(this$2)) {
      if (($uI(s.indexOf("#")) > (-1))) {
        var thiz = $m_sjsr_RuntimeString$().split__T__T__I__AT(s, "#", 0).get(1);
        return $as_T(thiz.trim())
      } else if ((($uI(s.indexOf("/")) === (-1)) && ($uI(s.indexOf(":")) !== (-1)))) {
        var thiz$1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(s, ":", 0).get(1);
        return $as_T(thiz$1.trim())
      } else {
        var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(s, "/", 0);
        var this$15 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
        var thiz$2 = $as_T($f_sc_IndexedSeqOptimized__last__O(this$15));
        return $as_T(thiz$2.trim())
      }
    }
  };
  return $default
}
function $f_Lamf_plugins_document_webapi_validation_runtimeexpression_ExpressionValidator__validate__T__Z($thiz, text) {
  if ((($uI(text.length) >= 0) && ($as_T(text.substring(0, $uI("$".length))) === "$"))) {
    return $thiz.expression__T__Z(text)
  } else {
    var this$7 = new $c_sci_StringOps().init___T("\\{.*?\\}");
    var groupNames = $m_sci_Nil$();
    var $$this = this$7.repr$1;
    var expressions = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames).findAllIn__jl_CharSequence__s_util_matching_Regex$MatchIterator(text);
    var res = true;
    while ((res && expressions.hasNext__Z())) {
      var arg1 = expressions.next__T();
      var this$10 = new $c_sci_StringOps().init___T(arg1);
      var x = $as_T($f_sc_IndexedSeqOptimized__init__O(this$10));
      var this$12 = new $c_sci_StringOps().init___T(x);
      res = $thiz.expression__T__Z($as_T($f_sc_IndexedSeqOptimized__tail__O(this$12)))
    };
    return res
  }
}
function $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__nodeIsValid__Z($thiz) {
  var x1 = $thiz.value__T();
  var o7 = $thiz.rx__s_util_matching_Regex().unapplySeq__jl_CharSequence__s_Option(x1);
  if ((!o7.isEmpty__Z())) {
    if ((o7.get__O() !== null)) {
      var this$1 = $as_sc_LinearSeqOptimized(o7.get__O());
      var jsx$1 = ($f_sc_LinearSeqOptimized__lengthCompare__I__I(this$1, 1) === 0)
    } else {
      var jsx$1 = false
    }
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return true
  };
  return false
}
function $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__next__s_Option($thiz) {
  var thiz = $thiz.extraValue__T();
  if ((thiz === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  if ((thiz === "")) {
    return $m_s_None$()
  } else {
    var this$2 = $thiz.followedBy__sc_Seq().find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(rp$2) {
        var rp = $as_F1(rp$2);
        return $as_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken(rp.apply__O__O($this.extraValue__T())).nodeIsValid__Z()
      })
    })($thiz)));
    if (this$2.isEmpty__Z()) {
      var this$3 = $m_s_None$()
    } else {
      var arg1 = this$2.get__O();
      var rp$3 = $as_F1(arg1);
      var this$3 = new $c_s_Some().init___O($as_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken(rp$3.apply__O__O($thiz.extraValue__T())))
    };
    return new $c_s_Some().init___O((this$3.isEmpty__Z() ? new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken().init___T($thiz.extraValue__T()) : this$3.get__O()))
  }
}
function $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__completelyValid__Z($thiz) {
  if ($thiz.followedBy__sc_Seq().isEmpty__Z()) {
    return $thiz.nodeIsValid__Z()
  } else {
    var this$1 = $thiz.next__s_Option();
    if ((!this$1.isEmpty__Z())) {
      var arg1 = this$1.get__O();
      var x$1 = $as_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken(arg1);
      return x$1.completelyValid__Z()
    } else {
      return false
    }
  }
}
function $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__extraValue__T($thiz) {
  var x1 = $thiz.value__T();
  var o7 = $thiz.rx__s_util_matching_Regex().unapplySeq__jl_CharSequence__s_Option(x1);
  if ((!o7.isEmpty__Z())) {
    if ((o7.get__O() !== null)) {
      var this$1 = $as_sc_LinearSeqOptimized(o7.get__O());
      var jsx$1 = ($f_sc_LinearSeqOptimized__lengthCompare__I__I(this$1, 1) === 0)
    } else {
      var jsx$1 = false
    }
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var e = $as_T($as_sc_LinearSeqOptimized(o7.get__O()).apply__I__O(0));
    var x = $thiz.value__T();
    var this$3 = new $c_sci_StringOps().init___T(x);
    return $f_sci_StringLike__stripPrefix__T__T(this$3, e)
  };
  return $thiz.value__T()
}
function $is_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken)))
}
function $as_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken(obj) {
  return (($is_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runtimeexpression.RuntimeParsingToken"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runtimeexpression.RuntimeParsingToken;", depth))
}
function $f_Lamf_plugins_domain_shapes_metamodel_CommonShapeFields__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  $thiz.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$Pattern$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "pattern"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "pattern", "Pattern constraint", $m_sci_Nil$()), true));
  var jsx$2 = $m_Lamf_core_metamodel_Type$Int$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  $thiz.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$MinLength$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "minLength"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "min. length", "Minimum lenght constraint", $m_sci_Nil$()), true));
  var jsx$3 = $m_Lamf_core_metamodel_Type$Int$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  $thiz.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$MaxLength$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "maxLength"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "max. length", "Maximum length constraint", $m_sci_Nil$()), true));
  var jsx$4 = $m_Lamf_core_metamodel_Type$Double$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  $thiz.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$Minimum$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "minInclusive"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "min. inclusive", "Minimum inclusive constraint", $m_sci_Nil$()), true));
  var jsx$5 = $m_Lamf_core_metamodel_Type$Double$();
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  $thiz.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$Maximum$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "maxInclusive"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "max. inclusive", "Maximum inclusive constraint", $m_sci_Nil$()), true));
  var jsx$6 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  $thiz.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$ExclusiveMinimum$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$6, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "minExclusive"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "min. exclusive", "Minimum exclusive constraint", $m_sci_Nil$()), true));
  var jsx$7 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$19 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  $thiz.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$ExclusiveMaximum$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$7, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$19, "maxExclusive"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "max. exclusive", "Maximum exclusive constraint", $m_sci_Nil$()), true));
  var jsx$8 = $m_Lamf_core_metamodel_Type$Str$();
  var this$22 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  $thiz.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$Format$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$8, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$22, "format"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "format", "Format constraint", $m_sci_Nil$()), true));
  var jsx$9 = $m_Lamf_core_metamodel_Type$Double$();
  var this$25 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  $thiz.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$MultipleOf$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$9, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$25, "multipleOf"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "multiple of", "Multiple of constraint", $m_sci_Nil$()), true));
  $m_sci_List$();
  var array = [$thiz.Pattern__Lamf_core_metamodel_Field(), $thiz.MinLength__Lamf_core_metamodel_Field(), $thiz.MaxLength__Lamf_core_metamodel_Field(), $thiz.Minimum__Lamf_core_metamodel_Field(), $thiz.Maximum__Lamf_core_metamodel_Field(), $thiz.ExclusiveMinimum__Lamf_core_metamodel_Field(), $thiz.ExclusiveMaximum__Lamf_core_metamodel_Field(), $thiz.Format__Lamf_core_metamodel_Field(), $thiz.MultipleOf__Lamf_core_metamodel_Field()];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$31 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$31);
    i = (((-1) + i) | 0)
  };
  $thiz.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$commonOASFields$und$eq__sci_List__V(result)
}
function $f_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  $thiz.amf$plugins$domain$shapes$metamodel$common$DocumentationField$$undsetter$und$Documentation$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "documentation"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "documentation", "Documentation for a particular part of the model", $m_sci_Nil$()), true))
}
function $f_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField__$$init$__V($thiz) {
  var jsx$1 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$());
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  $thiz.amf$plugins$domain$shapes$metamodel$common$ExamplesField$$undsetter$und$Examples$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "examples"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "examples", "Examples for a particular domain element", $m_sci_Nil$()), true))
}
function $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__minimum__Lamf_core_model_DoubleField($thiz) {
  return $as_Lamf_core_model_DoubleField($as_Lamf_core_model_domain_AmfObject($thiz).fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Minimum$1))
}
function $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__format__Lamf_core_model_StrField($thiz) {
  return $as_Lamf_core_model_StrField($as_Lamf_core_model_domain_AmfObject($thiz).fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Format$1))
}
function $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__multipleOf__Lamf_core_model_DoubleField($thiz) {
  return $as_Lamf_core_model_DoubleField($as_Lamf_core_model_domain_AmfObject($thiz).fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MultipleOf$1))
}
function $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__exclusiveMinimum__Lamf_core_model_BoolField($thiz) {
  return $as_Lamf_core_model_BoolField($as_Lamf_core_model_domain_AmfObject($thiz).fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().ExclusiveMinimum$1))
}
function $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__minLength__Lamf_core_model_IntField($thiz) {
  return $as_Lamf_core_model_IntField($as_Lamf_core_model_domain_AmfObject($thiz).fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MinLength$1))
}
function $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__exclusiveMaximum__Lamf_core_model_BoolField($thiz) {
  return $as_Lamf_core_model_BoolField($as_Lamf_core_model_domain_AmfObject($thiz).fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().ExclusiveMaximum$1))
}
function $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__maxLength__Lamf_core_model_IntField($thiz) {
  return $as_Lamf_core_model_IntField($as_Lamf_core_model_domain_AmfObject($thiz).fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MaxLength$1))
}
function $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__maximum__Lamf_core_model_DoubleField($thiz) {
  return $as_Lamf_core_model_DoubleField($as_Lamf_core_model_domain_AmfObject($thiz).fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Maximum$1))
}
function $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__pattern__Lamf_core_model_StrField($thiz) {
  return $as_Lamf_core_model_StrField($as_Lamf_core_model_domain_AmfObject($thiz).fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Pattern$1))
}
function $f_Lamf_plugins_domain_shapes_models_InheritanceChain__linkSubType__Lamf_plugins_domain_shapes_models_AnyShape__V($thiz, shape) {
  $f_Lamf_plugins_domain_shapes_models_InheritanceChain__addSubType__Lamf_core_model_domain_Shape__V($thiz, shape);
  var shape$1 = $as_Lamf_core_model_domain_Shape($thiz);
  $f_Lamf_plugins_domain_shapes_models_InheritanceChain__addSuperType__Lamf_core_model_domain_Shape__V(shape, shape$1)
}
function $f_Lamf_plugins_domain_shapes_models_InheritanceChain__addSuperType__Lamf_core_model_domain_Shape__V($thiz, shape) {
  var x1 = $thiz.superTypes$2.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, shape$1) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_model_domain_Shape(x$2$2);
      return (x$2.id$1 === shape$1.id$1)
    })
  })($thiz, shape)));
  if ((!(x1 instanceof $c_s_Some))) {
    var jsx$3 = $thiz.superTypes$2;
    var jsx$2 = $m_sc_Seq$();
    var array = [shape];
    var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$3 = $m_scm_Seq$();
    $thiz.superTypes$2 = $as_scm_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))
  }
}
function $f_Lamf_plugins_domain_shapes_models_InheritanceChain__addSubType__Lamf_core_model_domain_Shape__V($thiz, shape) {
  var x1 = $thiz.subTypes$2.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, shape$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_domain_Shape(x$1$2);
      return (x$1.id$1 === shape$1.id$1)
    })
  })($thiz, shape)));
  if ((!(x1 instanceof $c_s_Some))) {
    var jsx$3 = $thiz.subTypes$2;
    var jsx$2 = $m_sc_Seq$();
    var array = [shape];
    var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$3 = $m_scm_Seq$();
    $thiz.subTypes$2 = $as_scm_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))
  }
}
function $f_Lamf_plugins_domain_shapes_models_InheritanceChain__$$init$__V($thiz) {
  $thiz.subTypes$2 = $as_scm_Seq($m_scm_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $thiz.superTypes$2 = $as_scm_Seq($m_scm_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $thiz.inheritedIds$2 = $as_scm_Seq($m_scm_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
}
function $is_Lamf_plugins_domain_shapes_models_InheritanceChain(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_domain_shapes_models_InheritanceChain)))
}
function $as_Lamf_plugins_domain_shapes_models_InheritanceChain(obj) {
  return (($is_Lamf_plugins_domain_shapes_models_InheritanceChain(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.models.InheritanceChain"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_models_InheritanceChain(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_models_InheritanceChain)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_models_InheritanceChain(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_models_InheritanceChain(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.models.InheritanceChain;", depth))
}
function $is_Lamf_plugins_domain_shapes_models_ScalarType(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_domain_shapes_models_ScalarType)))
}
function $as_Lamf_plugins_domain_shapes_models_ScalarType(obj) {
  return (($is_Lamf_plugins_domain_shapes_models_ScalarType(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.models.ScalarType"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_models_ScalarType(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_models_ScalarType)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_models_ScalarType(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_models_ScalarType(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.models.ScalarType;", depth))
}
function $f_Lamf_plugins_domain_shapes_models_ShapeHelper__setDefaultStrValue__Lorg_yaml_model_YMapEntry__V($thiz, entry) {
  var x1 = entry.value$2.asScalar__s_Option();
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var s = $as_Lorg_yaml_model_YScalar(x2.value$2);
    var str = s.text$3
  } else {
    var this$1 = $m_Lorg_yaml_render_YamlRender$();
    var part = entry.value$2;
    var str = this$1.render__Lorg_yaml_model_YPart__Z__T(part, false)
  };
  var this$3 = $as_Lamf_core_model_domain_AmfObject($thiz);
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().DefaultValueString$1;
  var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(str, new $c_Lamf_core_parser_Annotations().init___());
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$3, field, value, annotations)
}
function $f_Lamf_plugins_domain_shapes_models_ShapeHelpers__cloneAllExamples__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__V($thiz, cloned, s) {
  matchEnd5: {
    if ((cloned instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
      var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(cloned);
      if ((s instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
        var x3 = $as_Lamf_plugins_domain_shapes_models_AnyShape(s);
        var jsx$2 = $as_sc_Seq(x3.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1));
        var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(e$2) {
            var e = $as_Lamf_plugins_domain_shapes_models_Example(e$2);
            return $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_Linkable__copyElement__Lamf_core_model_domain_Linkable(e))
          })
        })($thiz));
        var this$1 = $m_sc_Seq$();
        var examples = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
        var field = $m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1;
        $as_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(x2, field, examples));
        break matchEnd5
      }
    }
  }
}
function $f_Lamf_plugins_domain_shapes_models_ShapeHelpers__cloneShape__s_Option__s_Option__Lamf_core_traversal_ModelTraversalRegistry__Z__Lamf_core_model_domain_Shape($thiz, recursionErrorHandler, withRecursionBase, traversal, cloneExamples) {
  var id = $as_Lamf_core_model_domain_AmfObject($thiz).id__T();
  if (traversal.currentPath$1.contains__O__Z(id)) {
    var this$1 = $as_Lamf_core_model_domain_NamedDomainElement($thiz);
    var this$2 = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(this$1.nameField__Lamf_core_metamodel_Field()));
    var this$3 = this$2.option$1;
    var name = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
    var link = $as_Lamf_core_model_domain_Linkable($thiz);
    return $f_Lamf_plugins_domain_shapes_models_ShapeHelpers__buildFixPoint__s_Option__T__Lamf_core_model_domain_Linkable__s_Option__Lamf_core_model_domain_RecursiveShape($thiz, withRecursionBase, name, link, recursionErrorHandler)
  } else {
    var x1 = $as_Lamf_core_model_domain_Shape($thiz);
    if ((x1 !== null)) {
      var this$4 = $as_Lamf_core_model_domain_Linkable($thiz);
      var jsx$1 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$4).isDefined__Z()
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var this$5 = $as_Lamf_core_model_domain_NamedDomainElement($thiz);
      var this$6 = $as_Lamf_core_model_StrField(this$5.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(this$5.nameField__Lamf_core_metamodel_Field()));
      var this$7 = this$6.option$1;
      var name$1 = $as_T((this$7.isEmpty__Z() ? null : this$7.get__O()));
      var link$1 = $as_Lamf_core_model_domain_Linkable($thiz);
      var cloned = $f_Lamf_plugins_domain_shapes_models_ShapeHelpers__buildFixPoint__s_Option__T__Lamf_core_model_domain_Linkable__s_Option__Lamf_core_model_domain_RecursiveShape($thiz, withRecursionBase, name$1, link$1, recursionErrorHandler)
    } else if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
      var annotations = $as_Lamf_core_model_domain_AmfElement($thiz).annotations__Lamf_core_parser_Annotations();
      var cloned = new $c_Lamf_plugins_domain_shapes_models_UnionShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
    } else if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
      var annotations$1 = $as_Lamf_core_model_domain_AmfElement($thiz).annotations__Lamf_core_parser_Annotations();
      var cloned = new $c_Lamf_plugins_domain_shapes_models_ScalarShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1)
    } else if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
      var annotations$2 = $as_Lamf_core_model_domain_AmfElement($thiz).annotations__Lamf_core_parser_Annotations();
      var cloned = new $c_Lamf_plugins_domain_shapes_models_ArrayShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$2)
    } else if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_MatrixShape)) {
      var annotations$3 = $as_Lamf_core_model_domain_AmfElement($thiz).annotations__Lamf_core_parser_Annotations();
      var cloned = new $c_Lamf_plugins_domain_shapes_models_MatrixShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$3)
    } else if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_TupleShape)) {
      var annotations$4 = $as_Lamf_core_model_domain_AmfElement($thiz).annotations__Lamf_core_parser_Annotations();
      var cloned = new $c_Lamf_plugins_domain_shapes_models_TupleShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$4)
    } else if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_FileShape)) {
      var annotations$5 = $as_Lamf_core_model_domain_AmfElement($thiz).annotations__Lamf_core_parser_Annotations();
      var cloned = new $c_Lamf_plugins_domain_shapes_models_FileShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$5)
    } else if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_NilShape)) {
      var annotations$6 = $as_Lamf_core_model_domain_AmfElement($thiz).annotations__Lamf_core_parser_Annotations();
      var cloned = new $c_Lamf_plugins_domain_shapes_models_NilShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$6)
    } else if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
      var annotations$7 = $as_Lamf_core_model_domain_AmfElement($thiz).annotations__Lamf_core_parser_Annotations();
      var cloned = new $c_Lamf_plugins_domain_shapes_models_NodeShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$7)
    } else if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_SchemaShape)) {
      var annotations$8 = $as_Lamf_core_model_domain_AmfElement($thiz).annotations__Lamf_core_parser_Annotations();
      var cloned = new $c_Lamf_plugins_domain_shapes_models_SchemaShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$8)
    } else if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_UnresolvedShape)) {
      var x2 = $as_Lamf_plugins_domain_shapes_models_UnresolvedShape(x1);
      var annots = x2.annotations$2;
      var reference = x2.reference$3;
      var parser = x2.fatherExtensionParser$3;
      var cloned = new $c_Lamf_plugins_domain_shapes_models_UnresolvedShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations__T__s_Option__s_Option__Z(new $c_Lamf_core_parser_Fields().init___(), annots, reference, parser, $m_s_None$(), true)
    } else {
      if ((!(x1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape))) {
        throw new $c_s_MatchError().init___O(x1)
      };
      var annotations$9 = $as_Lamf_core_model_domain_AmfElement($thiz).annotations__Lamf_core_parser_Annotations();
      var fields = new $c_Lamf_core_parser_Fields().init___();
      var cloned = new $c_Lamf_plugins_domain_shapes_models_AnyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations$9)
    };
    cloned.id$1 = $as_Lamf_core_model_domain_AmfObject($thiz).id__T();
    $as_Lamf_core_model_domain_Shape($thiz).copyFields__s_Option__Lamf_core_model_domain_Shape__s_Option__Lamf_core_traversal_ModelTraversalRegistry__V(recursionErrorHandler, cloned, withRecursionBase, traversal.$$plus__T__Lamf_core_traversal_ModelTraversalRegistry($as_Lamf_core_model_domain_AmfObject($thiz).id__T()));
    if ((cloned instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
      var annotation = new $c_Lamf_core_annotations_ExplicitField().init___();
      $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(cloned, annotation)
    };
    if (cloneExamples) {
      var s = $as_Lamf_core_model_domain_Shape($thiz);
      $f_Lamf_plugins_domain_shapes_models_ShapeHelpers__cloneAllExamples__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__V($thiz, cloned, s)
    };
    return cloned
  }
}
function $f_Lamf_plugins_domain_shapes_models_ShapeHelpers__buildFixPoint__s_Option__T__Lamf_core_model_domain_Linkable__s_Option__Lamf_core_model_domain_RecursiveShape($thiz, id, name, link, recursionErrorHandler) {
  if ((recursionErrorHandler.isDefined__Z() && $as_Lamf_core_model_BoolField(link.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1)).option$1.isEmpty__Z())) {
    var this$1 = $as_Lamf_core_errorhandling_ErrorHandler(recursionErrorHandler.get__O());
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().RecursiveShapeSpecification$1;
    var node = link.id__T();
    var property = $m_s_None$();
    var lexical = link.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var location = link.location__s_Option();
    this$1.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "Error recursive shape", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
  };
  var fixPointId = $as_T((id.isEmpty__Z() ? link.id__T() : id.get__O()));
  var this$2 = $m_Lamf_core_model_domain_RecursiveShape$().apply__Lamf_core_model_domain_Linkable__Lamf_core_model_domain_RecursiveShape(link);
  var field = $m_Lamf_core_metamodel_domain_RecursiveShapeModel$().FixPoint$1;
  return $as_Lamf_core_model_domain_RecursiveShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$2, field, fixPointId))
}
function $f_Lamf_plugins_domain_shapes_models_ShapeHelpers__externalSourceID__s_Option($thiz) {
  var x1 = $as_Lamf_core_model_domain_Shape($thiz);
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x1);
    return $as_Lamf_core_model_StrField(x2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().ReferenceId$1)).option$1
  } else {
    return $m_s_None$()
  }
}
function $f_Lamf_plugins_domain_shapes_models_ShapeHelpers__fromExternalSource__Z($thiz) {
  var x1 = $as_Lamf_core_model_domain_Shape($thiz);
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x1);
    return $as_Lamf_core_model_StrField(x2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().ReferenceId$1)).option$1.isDefined__Z()
  } else {
    return false
  }
}
function $is_Lamf_plugins_domain_shapes_models_ShapeHelpers(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_domain_shapes_models_ShapeHelpers)))
}
function $as_Lamf_plugins_domain_shapes_models_ShapeHelpers(obj) {
  return (($is_Lamf_plugins_domain_shapes_models_ShapeHelpers(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.models.ShapeHelpers"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_models_ShapeHelpers(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_models_ShapeHelpers)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_models_ShapeHelpers(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_models_ShapeHelpers(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.models.ShapeHelpers;", depth))
}
function $f_Lamf_plugins_domain_shapes_models_TypeDef__isScalar__Z($thiz) {
  return $is_Lamf_plugins_domain_shapes_models_ScalarType($thiz)
}
function $f_Lamf_plugins_domain_shapes_models_TypeDef__isNumber__Z($thiz) {
  var x = $m_Lamf_plugins_domain_shapes_models_TypeDef$IntType$();
  if ((x === $thiz)) {
    return true
  } else {
    var x$3 = $m_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$();
    if ((x$3 === $thiz)) {
      return true
    } else {
      var x$5 = $m_Lamf_plugins_domain_shapes_models_TypeDef$LongType$();
      if ((x$5 === $thiz)) {
        return true
      } else {
        var x$7 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$();
        if ((x$7 === $thiz)) {
          return true
        } else {
          var x$9 = $m_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$();
          return (x$9 === $thiz)
        }
      }
    }
  }
}
function $f_Lamf_plugins_domain_shapes_models_TypeDef__isDate__Z($thiz) {
  var x = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$();
  if ((x === $thiz)) {
    return true
  } else {
    var x$3 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$();
    if ((x$3 === $thiz)) {
      return true
    } else {
      var x$5 = $m_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$();
      if ((x$5 === $thiz)) {
        return true
      } else {
        var x$7 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$();
        return (x$7 === $thiz)
      }
    }
  }
}
function $f_Lamf_plugins_domain_shapes_models_TypeDef__isNil__Z($thiz) {
  var x = $m_Lamf_plugins_domain_shapes_models_TypeDef$NilType$();
  return (x === $thiz)
}
function $is_Lamf_plugins_domain_shapes_models_TypeDef(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_domain_shapes_models_TypeDef)))
}
function $as_Lamf_plugins_domain_shapes_models_TypeDef(obj) {
  return (($is_Lamf_plugins_domain_shapes_models_TypeDef(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.models.TypeDef"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_models_TypeDef(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_models_TypeDef)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_models_TypeDef(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_models_TypeDef(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.models.TypeDef;", depth))
}
function $f_Lamf_plugins_domain_shapes_resolution_stages_merge_KeyCriteria__hasKey__Lamf_core_model_domain_AmfElement__Z($thiz, element) {
  return $thiz.getKeyFor__Lamf_core_model_domain_AmfElement__s_Option(element).isDefined__Z()
}
function $f_Lamf_plugins_domain_shapes_resolution_stages_merge_KeyCriteria__hasKeysForAll__Lamf_core_model_domain_AmfArray__Z($thiz, array) {
  return array.values$1.forall__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(element$2) {
      var element = $as_Lamf_core_model_domain_AmfElement(element$2);
      return $f_Lamf_plugins_domain_shapes_resolution_stages_merge_KeyCriteria__hasKey__Lamf_core_model_domain_AmfElement__Z($this, element)
    })
  })($thiz)))
}
function $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNarrow__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement($thiz, field, derivedValue, superValue) {
  var x = $m_Lamf_core_metamodel_domain_ShapeModel$().Name$1;
  if (((x === null) ? (field === null) : x.equals__O__Z(field))) {
    var derivedStrValue = $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__stringValue__Lamf_core_model_domain_AmfElement__s_Option($thiz, derivedValue);
    var superStrValue = $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__stringValue__Lamf_core_model_domain_AmfElement__s_Option($thiz, superValue);
    if (superStrValue.isDefined__Z()) {
      if (derivedStrValue.isEmpty__Z()) {
        var jsx$1 = true
      } else {
        var x$3 = derivedStrValue.get__O();
        var jsx$1 = ((x$3 !== null) && $objectEquals(x$3, "schema"))
      }
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return superValue
    } else {
      return derivedValue
    }
  } else {
    var x$5 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MinProperties$1;
    if (((x$5 === null) ? (field === null) : x$5.equals__O__Z(field))) {
      var property = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MinProperties$1.value$1.iri__T());
      var lexicalInformation = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      var location = derivedValue.location__s_Option();
      if ($f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericComparison__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__s_Option__Z($thiz, "<=", superValue, derivedValue, property, lexicalInformation, location)) {
        var property$1 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MinProperties$1.value$1.iri__T());
        var lexicalInfo = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
        return $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericRestriction__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__Lamf_core_model_domain_AmfElement($thiz, "max", superValue, derivedValue, property$1, lexicalInfo)
      } else {
        throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("Resolution error: sub type has a weaker constraint for min-properties than base type for minProperties", new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MinProperties$1.value$1.iri__T()), derivedValue.location__s_Option(), derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), false)
      }
    } else {
      var x$7 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MaxProperties$1;
      if (((x$7 === null) ? (field === null) : x$7.equals__O__Z(field))) {
        var property$2 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MaxProperties$1.value$1.iri__T());
        var lexicalInformation$1 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
        var location$1 = derivedValue.location__s_Option();
        if ($f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericComparison__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__s_Option__Z($thiz, ">=", superValue, derivedValue, property$2, lexicalInformation$1, location$1)) {
          var property$3 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MaxProperties$1.value$1.iri__T());
          var lexicalInfo$1 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
          return $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericRestriction__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__Lamf_core_model_domain_AmfElement($thiz, "min", superValue, derivedValue, property$3, lexicalInfo$1)
        } else {
          throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("Resolution error: sub type has a weaker constraint for max-properties than base type for maxProperties", new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MaxProperties$1.value$1.iri__T()), derivedValue.location__s_Option(), derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), false)
        }
      } else {
        var x$9 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MinLength$1;
        if (((x$9 === null) ? (field === null) : x$9.equals__O__Z(field))) {
          var property$4 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MinLength$1.value$1.iri__T());
          var lexicalInformation$2 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
          var location$2 = derivedValue.location__s_Option();
          if ($f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericComparison__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__s_Option__Z($thiz, "<=", superValue, derivedValue, property$4, lexicalInformation$2, location$2)) {
            var property$5 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MinLength$1.value$1.iri__T());
            var lexicalInfo$2 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
            return $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericRestriction__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__Lamf_core_model_domain_AmfElement($thiz, "max", superValue, derivedValue, property$5, lexicalInfo$2)
          } else {
            throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("Resolution error: sub type has a weaker constraint for min-length than base type for maxProperties", new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MinLength$1.value$1.iri__T()), derivedValue.location__s_Option(), derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), false)
          }
        } else {
          var x$11 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MaxLength$1;
          if (((x$11 === null) ? (field === null) : x$11.equals__O__Z(field))) {
            var property$6 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MaxLength$1.value$1.iri__T());
            var lexicalInformation$3 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
            var location$3 = derivedValue.location__s_Option();
            if ($f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericComparison__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__s_Option__Z($thiz, ">=", superValue, derivedValue, property$6, lexicalInformation$3, location$3)) {
              var property$7 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MaxLength$1.value$1.iri__T());
              var lexicalInfo$3 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
              return $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericRestriction__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__Lamf_core_model_domain_AmfElement($thiz, "min", superValue, derivedValue, property$7, lexicalInfo$3)
            } else {
              throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("Resolution error: sub type has a weaker constraint for max-length than base type for maxProperties", new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MaxLength$1.value$1.iri__T()), derivedValue.location__s_Option(), derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), false)
            }
          } else {
            var x$13 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Minimum$1;
            if (((x$13 === null) ? (field === null) : x$13.equals__O__Z(field))) {
              var property$8 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Minimum$1.value$1.iri__T());
              var lexicalInformation$4 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
              var location$4 = derivedValue.location__s_Option();
              if ($f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericComparison__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__s_Option__Z($thiz, "<=", superValue, derivedValue, property$8, lexicalInformation$4, location$4)) {
                var property$9 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Minimum$1.value$1.iri__T());
                var lexicalInfo$4 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
                return $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericRestriction__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__Lamf_core_model_domain_AmfElement($thiz, "max", superValue, derivedValue, property$9, lexicalInfo$4)
              } else {
                throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("Resolution error: sub type has a weaker constraint for min-minimum than base type for minimum", new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Minimum$1.value$1.iri__T()), derivedValue.location__s_Option(), derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), false)
              }
            } else {
              var x$15 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Maximum$1;
              if (((x$15 === null) ? (field === null) : x$15.equals__O__Z(field))) {
                var property$10 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Maximum$1.value$1.iri__T());
                var lexicalInformation$5 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
                var location$5 = derivedValue.location__s_Option();
                if ($f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericComparison__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__s_Option__Z($thiz, ">=", superValue, derivedValue, property$10, lexicalInformation$5, location$5)) {
                  var property$11 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Maximum$1.value$1.iri__T());
                  var lexicalInfo$5 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
                  return $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericRestriction__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__Lamf_core_model_domain_AmfElement($thiz, "min", superValue, derivedValue, property$11, lexicalInfo$5)
                } else {
                  throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("Resolution error: sub type has a weaker constraint for maximum than base type for maximum", new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Maximum$1.value$1.iri__T()), derivedValue.location__s_Option(), derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), false)
                }
              } else {
                var x$17 = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MinItems$1;
                if (((x$17 === null) ? (field === null) : x$17.equals__O__Z(field))) {
                  var property$12 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MinItems$1.value$1.iri__T());
                  var lexicalInformation$6 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
                  var location$6 = derivedValue.location__s_Option();
                  if ($f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericComparison__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__s_Option__Z($thiz, "<=", superValue, derivedValue, property$12, lexicalInformation$6, location$6)) {
                    var property$13 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MinItems$1.value$1.iri__T());
                    var lexicalInfo$6 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
                    return $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericRestriction__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__Lamf_core_model_domain_AmfElement($thiz, "max", superValue, derivedValue, property$13, lexicalInfo$6)
                  } else {
                    throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("Resolution error: sub type has a weaker constraint for minItems than base type for minItems", new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MinItems$1.value$1.iri__T()), derivedValue.location__s_Option(), derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), true)
                  }
                } else {
                  var x$19 = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MaxItems$1;
                  if (((x$19 === null) ? (field === null) : x$19.equals__O__Z(field))) {
                    var property$14 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MaxItems$1.value$1.iri__T());
                    var lexicalInformation$7 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
                    var location$7 = derivedValue.location__s_Option();
                    if ($f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericComparison__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__s_Option__Z($thiz, ">=", superValue, derivedValue, property$14, lexicalInformation$7, location$7)) {
                      var property$15 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MaxItems$1.value$1.iri__T());
                      var lexicalInfo$7 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
                      return $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericRestriction__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__Lamf_core_model_domain_AmfElement($thiz, "min", superValue, derivedValue, property$15, lexicalInfo$7)
                    } else {
                      throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("Resolution error: sub type has a weaker constraint for maxItems than base type for maxItems", new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MaxItems$1.value$1.iri__T()), derivedValue.location__s_Option(), derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), false)
                    }
                  } else {
                    var x$21 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Format$1;
                    if (((x$21 === null) ? (field === null) : x$21.equals__O__Z(field))) {
                      var property$16 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Format$1.value$1.iri__T());
                      var position = derivedValue.location__s_Option();
                      var lexicalInfo$8 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
                      if ($f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeStringEquality__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__s_Option__Z($thiz, superValue, derivedValue, property$16, position, lexicalInfo$8)) {
                        return derivedValue
                      } else {
                        throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("different values for format constraint", new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Format$1.value$1.iri__T()), derivedValue.location__s_Option(), derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), false)
                      }
                    } else {
                      var x$23 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Pattern$1;
                      if (((x$23 === null) ? (field === null) : x$23.equals__O__Z(field))) {
                        var property$17 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Pattern$1.value$1.iri__T());
                        var position$1 = derivedValue.location__s_Option();
                        var lexicalInfo$9 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
                        if ($f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeStringEquality__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__s_Option__Z($thiz, superValue, derivedValue, property$17, position$1, lexicalInfo$9)) {
                          return derivedValue
                        } else {
                          throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("different values for pattern constraint", new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Pattern$1.value$1.iri__T()), derivedValue.location__s_Option(), derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), false)
                        }
                      } else {
                        var x$25 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Discriminator$1;
                        if (((x$25 === null) ? (field === null) : x$25.equals__O__Z(field))) {
                          var property$18 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Discriminator$1.value$1.iri__T());
                          var position$2 = derivedValue.location__s_Option();
                          var lexicalInfo$10 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
                          if ((!$f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeStringEquality__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__s_Option__Z($thiz, superValue, derivedValue, property$18, position$2, lexicalInfo$10))) {
                            return derivedValue
                          } else {
                            throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("shape has same discriminator value as parent", new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Discriminator$1.value$1.iri__T()), derivedValue.location__s_Option(), derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), false)
                          }
                        } else {
                          var x$27 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().DiscriminatorValue$1;
                          if (((x$27 === null) ? (field === null) : x$27.equals__O__Z(field))) {
                            var property$19 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().DiscriminatorValue$1.value$1.iri__T());
                            var position$3 = derivedValue.location__s_Option();
                            var lexicalInfo$11 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
                            if ((!$f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeStringEquality__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__s_Option__Z($thiz, superValue, derivedValue, property$19, position$3, lexicalInfo$11))) {
                              return derivedValue
                            } else {
                              throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("shape has same discriminator value as parent", new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().DiscriminatorValue$1.value$1.iri__T()), derivedValue.location__s_Option(), derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), false)
                            }
                          } else {
                            var x$29 = $m_Lamf_core_metamodel_domain_ShapeModel$().Values$1;
                            if (((x$29 === null) ? (field === null) : x$29.equals__O__Z(field))) {
                              var derivedEnumeration = $as_Lamf_core_model_domain_AmfArray(derivedValue).values$1;
                              var superEnumeration = $as_Lamf_core_model_domain_AmfArray(superValue).values$1;
                              var annotations = derivedValue.annotations__Lamf_core_parser_Annotations();
                              $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeEnum__sc_Seq__sc_Seq__Lamf_core_parser_Annotations__V($thiz, derivedEnumeration, superEnumeration, annotations);
                              return derivedValue
                            } else {
                              var x$31 = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().UniqueItems$1;
                              if (((x$31 === null) ? (field === null) : x$31.equals__O__Z(field))) {
                                var property$20 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().UniqueItems$1.value$1.iri__T());
                                var lexicalInformaiton = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
                                if ($f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeBooleanComparison__Z__Z__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__Z($thiz, true, true, superValue, derivedValue, property$20, lexicalInformaiton)) {
                                  var jsx$3 = true
                                } else {
                                  var property$21 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().UniqueItems$1.value$1.iri__T());
                                  var lexicalInformaiton$1 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
                                  var jsx$3 = $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeBooleanComparison__Z__Z__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__Z($thiz, false, false, superValue, derivedValue, property$21, lexicalInformaiton$1)
                                };
                                if (jsx$3) {
                                  var jsx$2 = true
                                } else {
                                  var property$22 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().UniqueItems$1.value$1.iri__T());
                                  var lexicalInformaiton$2 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
                                  var jsx$2 = $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeBooleanComparison__Z__Z__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__Z($thiz, false, true, superValue, derivedValue, property$22, lexicalInformaiton$2)
                                };
                                if (jsx$2) {
                                  return derivedValue
                                } else {
                                  throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("different values for unique items constraint", new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().UniqueItems$1.value$1.iri__T()), derivedValue.location__s_Option(), derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), false)
                                }
                              } else {
                                var x$33 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1;
                                if (((x$33 === null) ? (field === null) : x$33.equals__O__Z(field))) {
                                  var property$23 = new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1.value$1.iri__T());
                                  var lexicalInformation$8 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
                                  var location$8 = derivedValue.location__s_Option();
                                  if ($f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericComparison__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__s_Option__Z($thiz, "<=", superValue, derivedValue, property$23, lexicalInformation$8, location$8)) {
                                    var property$24 = new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1.value$1.iri__T());
                                    var lexicalInfo$12 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
                                    return $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericRestriction__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__Lamf_core_model_domain_AmfElement($thiz, "max", superValue, derivedValue, property$24, lexicalInfo$12)
                                  } else {
                                    throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("Resolution error: sub type has a weaker constraint for minCount than base type for minCount", new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1.value$1.iri__T()), derivedValue.location__s_Option(), derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), false)
                                  }
                                } else {
                                  var x$35 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MaxCount$1;
                                  if (((x$35 === null) ? (field === null) : x$35.equals__O__Z(field))) {
                                    var property$25 = new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MaxCount$1.value$1.iri__T());
                                    var lexicalInformation$9 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
                                    var location$9 = derivedValue.location__s_Option();
                                    if ($f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericComparison__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__s_Option__Z($thiz, ">=", superValue, derivedValue, property$25, lexicalInformation$9, location$9)) {
                                      var property$26 = new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MaxCount$1.value$1.iri__T());
                                      var lexicalInfo$13 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
                                      return $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericRestriction__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__Lamf_core_model_domain_AmfElement($thiz, "min", superValue, derivedValue, property$26, lexicalInfo$13)
                                    } else {
                                      throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("Resolution error: sub type has a weaker constraint for maxCount than base type for maxCount", new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MaxCount$1.value$1.iri__T()), derivedValue.location__s_Option(), derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), false)
                                    }
                                  } else {
                                    var x$37 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Path$1;
                                    if (((x$37 === null) ? (field === null) : x$37.equals__O__Z(field))) {
                                      var property$27 = new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Path$1.value$1.iri__T());
                                      var position$4 = derivedValue.location__s_Option();
                                      var lexicalInfo$14 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
                                      if ($f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeStringEquality__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__s_Option__Z($thiz, superValue, derivedValue, property$27, position$4, lexicalInfo$14)) {
                                        return derivedValue
                                      } else {
                                        throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("different values for discriminator value path", new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Path$1.value$1.iri__T()), derivedValue.location__s_Option(), derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), false)
                                      }
                                    } else {
                                      var x$39 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1;
                                      if (((x$39 === null) ? (field === null) : x$39.equals__O__Z(field))) {
                                        var property$28 = new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1.value$1.iri__T());
                                        var position$5 = derivedValue.location__s_Option();
                                        var lexicalInfo$15 = derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
                                        if ($f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeStringEquality__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__s_Option__Z($thiz, superValue, derivedValue, property$28, position$5, lexicalInfo$15)) {
                                          return derivedValue
                                        } else {
                                          throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("different values for discriminator value range", new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1.value$1.iri__T()), derivedValue.location__s_Option(), derivedValue.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), false)
                                        }
                                      } else {
                                        return derivedValue
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }
}
function $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericComparison__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__s_Option__Z($thiz, comparison, lvalue, rvalue, property, lexicalInformation, location) {
  if ((lvalue instanceof $c_Lamf_core_model_domain_AmfScalar)) {
    var x2 = $as_Lamf_core_model_domain_AmfScalar(lvalue);
    if ((($m_s_Option$().apply__O__s_Option(x2.value$1).isDefined__Z() && (rvalue instanceof $c_Lamf_core_model_domain_AmfScalar)) && $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_AmfScalar(rvalue).value$1).isDefined__Z())) {
      var lnum = x2.toNumber__jl_Number();
      var rnum = $as_Lamf_core_model_domain_AmfScalar(rvalue).toNumber__jl_Number();
      if ((comparison === "<=")) {
        return ($numberIntValue(lnum) <= $numberIntValue(rnum))
      } else if ((comparison === ">=")) {
        return ($numberIntValue(lnum) >= $numberIntValue(rnum))
      } else {
        throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z(("Unknown numeric comparison " + comparison), property, location, lexicalInformation, false)
      }
    }
  };
  throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("Cannot compare non numeric or missing values", property, location, lexicalInformation, false)
}
function $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__restrictShape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape($thiz, restriction, shape) {
  shape.id$1 = restriction.id$1;
  var this$1 = restriction.fields__Lamf_core_parser_Fields();
  var fn = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, shape$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var field = $as_Lamf_core_metamodel_Field(x0$1.$$und1__O());
        var derivedValue = $as_Lamf_core_parser_Value(x0$1.$$und2__O());
        var x$2 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Inherits$1;
        if ((!((field === null) ? (x$2 === null) : field.equals__O__Z(x$2)))) {
          var x1$2 = $m_s_Option$().apply__O__s_Option(shape$1.fields__Lamf_core_parser_Fields().getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value(field));
          if ((x1$2 instanceof $c_s_Some)) {
            var x2 = $as_s_Some(x1$2);
            var superValue = $as_Lamf_core_parser_Value(x2.value$2);
            var derivedValue$1 = derivedValue.value$1;
            var superValue$1 = superValue.value$1;
            var value = $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNarrow__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement($this, field, derivedValue$1, superValue$1);
            $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(shape$1, field, value)
          } else {
            var x$3 = $m_s_None$();
            if ((!(x$3 === x1$2))) {
              throw new $c_s_MatchError().init___O(x1$2)
            };
            shape$1.fields__Lamf_core_parser_Fields().setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(field, derivedValue.value$1, derivedValue.annotations$1)
          }
        }
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })($thiz, shape));
  this$1.fs$1.foreach__F1__V(fn);
  return shape
}
function $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeEnum__sc_Seq__sc_Seq__Lamf_core_parser_Annotations__V($thiz, derivedEnumeration, superEnumeration, annotations) {
  if ((derivedEnumeration.nonEmpty__Z() && superEnumeration.nonEmpty__Z())) {
    var headOption = derivedEnumeration.headOption__s_Option();
    if ((!headOption.isEmpty__Z())) {
      var arg1 = headOption.get__O();
      var h = $as_Lamf_core_model_domain_AmfElement(arg1);
      var this$1 = superEnumeration.headOption__s_Option();
      if ((!this$1.isEmpty__Z())) {
        var arg1$1 = this$1.get__O();
        var x$1 = $as_Lamf_core_model_domain_AmfElement(arg1$1);
        var x = $objectGetClass(x$1);
        var x$2 = $objectGetClass(h);
        var jsx$1 = (!(x === x$2))
      } else {
        var jsx$1 = false
      }
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var this$2 = derivedEnumeration.head__O();
      var jsx$6 = $objectGetClass(this$2);
      var this$3 = superEnumeration.head__O();
      var jsx$5 = $objectGetClass(this$3);
      var jsx$4 = new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_ShapeModel$().Values$1.value$1.iri__T());
      if (headOption.isEmpty__Z()) {
        var jsx$3 = $m_s_None$()
      } else {
        var arg1$2 = headOption.get__O();
        var x$2$1 = $as_Lamf_core_model_domain_AmfElement(arg1$2);
        var jsx$3 = x$2$1.location__s_Option()
      };
      if (headOption.isEmpty__Z()) {
        var jsx$2 = $m_s_None$()
      } else {
        var arg1$3 = headOption.get__O();
        var x$3 = $as_Lamf_core_model_domain_AmfElement(arg1$3);
        var jsx$2 = x$3.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf())
      };
      throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z((((("Values in subtype enumeration are from different class '" + jsx$6) + "' of the super type enumeration '") + jsx$5) + "'"), jsx$4, jsx$3, jsx$2, false)
    };
    matchEnd6: {
      $m_sc_Seq$();
      var o9 = new $c_s_Some().init___O(derivedEnumeration);
      if ((((o9.value$2 !== null) && ($as_sc_SeqLike(o9.value$2).lengthCompare__I__I(1) === 0)) && ($as_sc_SeqLike(o9.value$2).apply__I__O(0) instanceof $c_Lamf_core_model_domain_ScalarNode))) {
        var jsx$7 = new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation$$anonfun$1().init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation($thiz);
        var this$5 = $m_sc_Seq$();
        var superScalars = $as_sc_Seq(superEnumeration.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$7, this$5.ReusableCBFInstance$2));
        derivedEnumeration.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, superScalars$1, ds) {
          return (function(e$2) {
            var e = $as_Lamf_core_model_domain_ScalarNode(e$2);
            var this$6 = $as_Lamf_core_model_StrField(e.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1));
            var this$7 = this$6.option$1;
            if ((!superScalars$1.contains__O__Z($as_T((this$7.isEmpty__Z() ? null : this$7.get__O()))))) {
              var jsx$8 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
                return (function(x$4$2) {
                  var x$4 = $as_Lamf_core_model_domain_ScalarNode(x$4$2);
                  return $as_Lamf_core_model_StrField(x$4.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1))
                })
              })(this$4$1));
              var this$8 = $m_sc_Seq$();
              throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z((((("Values in subtype enumeration (" + $as_sc_TraversableOnce(ds.map__F1__scg_CanBuildFrom__O(jsx$8, this$8.ReusableCBFInstance$2)).mkString__T__T(",")) + ") not found in the supertype enumeration (") + superScalars$1.mkString__T__T(",")) + ")"), new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_ShapeModel$().Values$1.value$1.iri__T()), $f_Lamf_core_model_domain_AmfElement__location__s_Option(e), e.annotations$2.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), false)
            }
          })
        })($thiz, superScalars, derivedEnumeration)));
        break matchEnd6
      }
    }
  }
}
function $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNarrowRestrictions__sc_Seq__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_model_domain_Shape($thiz, fields, baseShape, superShape, filteredFields) {
  fields.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, filteredFields$1, baseShape$1, superShape$1) {
    return (function(f$2) {
      var f = $as_Lamf_core_metamodel_Field(f$2);
      if ((!filteredFields$1.contains__O__Z(f))) {
        var baseValue = $m_s_Option$().apply__O__s_Option(baseShape$1.fields__Lamf_core_parser_Fields().getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value(f));
        var superValue = $m_s_Option$().apply__O__s_Option(superShape$1.fields__Lamf_core_parser_Fields().getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value(f));
        var rc6 = false;
        var x2 = null;
        if ((baseValue instanceof $c_s_Some)) {
          rc6 = true;
          x2 = $as_s_Some(baseValue);
          var bvalue = $as_Lamf_core_parser_Value(x2.value$2);
          if (superValue.isEmpty__Z()) {
            var value = bvalue.value$1;
            var annotations = bvalue.annotations$1;
            return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(baseShape$1, f, value, annotations)
          }
        };
        var x = $m_s_None$();
        if (((x === baseValue) && superValue.isDefined__Z())) {
          var finalAnnotations = $m_Lamf_core_parser_Annotations$().apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations($as_Lamf_core_parser_Value(superValue.get__O()).annotations$1);
          if ($this.keepEditingInfo$1) {
            $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__inheritAnnotations__Lamf_core_parser_Annotations__Lamf_core_model_domain_Shape__Lamf_core_parser_Annotations($this, finalAnnotations, superShape$1)
          };
          return baseShape$1.fields__Lamf_core_parser_Fields().setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(f, $as_Lamf_core_parser_Value(superValue.get__O()).value$1, finalAnnotations)
        };
        if (rc6) {
          var bvalue$2 = $as_Lamf_core_parser_Value(x2.value$2);
          if (superValue.isDefined__Z()) {
            var finalAnnotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(bvalue$2.annotations$1);
            var derivedValue = bvalue$2.value$1;
            var superValue$1 = $as_Lamf_core_parser_Value(superValue.get__O()).value$1;
            var finalValue = $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNarrow__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement($this, f, derivedValue, superValue$1);
            var x$4 = bvalue$2.value$1;
            if (((!((finalValue === null) ? (x$4 === null) : finalValue.equals__O__Z(x$4))) && $this.keepEditingInfo$1)) {
              $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__inheritAnnotations__Lamf_core_parser_Annotations__Lamf_core_model_domain_Shape__Lamf_core_parser_Annotations($this, finalAnnotations$2, superShape$1)
            };
            var effective = $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(finalValue, finalAnnotations$2);
            return baseShape$1.fields__Lamf_core_parser_Fields().setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(f, effective, finalAnnotations$2)
          }
        };
        return (void 0)
      } else {
        return (void 0)
      }
    })
  })($thiz, filteredFields, baseShape, superShape)));
  return baseShape
}
function $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNumericRestriction__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__Lamf_core_model_domain_AmfElement($thiz, comparison, lvalue, rvalue, property, lexicalInfo) {
  if ((lvalue instanceof $c_Lamf_core_model_domain_AmfScalar)) {
    var x2 = $as_Lamf_core_model_domain_AmfScalar(lvalue);
    if ((($m_s_Option$().apply__O__s_Option(x2.value$1).isDefined__Z() && (rvalue instanceof $c_Lamf_core_model_domain_AmfScalar)) && $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_AmfScalar(rvalue).value$1).isDefined__Z())) {
      var lnum = x2.toNumber__jl_Number();
      var rnum = $as_Lamf_core_model_domain_AmfScalar(rvalue).toNumber__jl_Number();
      if ((comparison === "max")) {
        return (($numberIntValue(lnum) <= $numberIntValue(rnum)) ? rvalue : lvalue)
      } else if ((comparison === "min")) {
        return (($numberIntValue(lnum) >= $numberIntValue(rnum)) ? rvalue : lvalue)
      } else {
        throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z(("Unknown numeric comparison " + comparison), $m_s_None$(), $m_s_None$(), $m_s_None$(), false)
      }
    }
  };
  throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("Cannot compare non numeric or missing values", $m_s_None$(), $m_s_None$(), $m_s_None$(), false)
}
function $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeStringEquality__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__s_Option__Z($thiz, lvalue, rvalue, property, position, lexicalInfo) {
  if ((lvalue instanceof $c_Lamf_core_model_domain_AmfScalar)) {
    var x2 = $as_Lamf_core_model_domain_AmfScalar(lvalue);
    if ((($m_s_Option$().apply__O__s_Option(x2.value$1).isDefined__Z() && (rvalue instanceof $c_Lamf_core_model_domain_AmfScalar)) && $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_AmfScalar(rvalue).value$1).isDefined__Z())) {
      var lstr = x2.toString__T();
      var rstr = $as_Lamf_core_model_domain_AmfScalar(rvalue).toString__T();
      return (lstr === rstr)
    }
  };
  throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("Cannot compare non numeric or missing values", property, position, lexicalInfo, false)
}
function $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__stringValue__Lamf_core_model_domain_AmfElement__s_Option($thiz, value) {
  if ((value instanceof $c_Lamf_core_model_domain_AmfScalar)) {
    var x2 = $as_Lamf_core_model_domain_AmfScalar(value);
    if ((($m_s_Option$().apply__O__s_Option(x2.value$1).isDefined__Z() && (value instanceof $c_Lamf_core_model_domain_AmfScalar)) && $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_AmfScalar(value).value$1).isDefined__Z())) {
      return new $c_s_Some().init___O(x2.toString__T())
    }
  };
  return $m_s_None$()
}
function $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__inheritAnnotations__Lamf_core_parser_Annotations__Lamf_core_model_domain_Shape__Lamf_core_parser_Annotations($thiz, annotations, from) {
  if ((!annotations.contains__jl_Class__Z($d_Lamf_core_annotations_InheritanceProvenance.getClassOf()))) {
    annotations.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_InheritanceProvenance().init___T(from.id$1))
  };
  return annotations
}
function $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeBooleanComparison__Z__Z__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__s_Option__s_Option__Z($thiz, lcomparison, rcomparison, lvalue, rvalue, property, lexicalInformaiton) {
  if ((lvalue instanceof $c_Lamf_core_model_domain_AmfScalar)) {
    var x2 = $as_Lamf_core_model_domain_AmfScalar(lvalue);
    if ((($m_s_Option$().apply__O__s_Option(x2.value$1).isDefined__Z() && (rvalue instanceof $c_Lamf_core_model_domain_AmfScalar)) && $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_AmfScalar(rvalue).value$1).isDefined__Z())) {
      var lbool = x2.toBool__Z();
      var rbool = $as_Lamf_core_model_domain_AmfScalar(rvalue).toBool__Z();
      return ((lbool === lcomparison) && (rbool === rcomparison))
    }
  };
  throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("Cannot compare non boolean or missing values", $m_s_None$(), $m_s_None$(), $m_s_None$(), false)
}
function $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeNormalizer__normalize__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape($thiz, shape) {
  var this$1 = $thiz.context__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext().cache$1;
  var id = shape.id$1;
  var x1 = this$1.cache$1.get__O__s_Option(id);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var s = $as_Lamf_core_model_domain_Shape(x2.value$2);
    return s
  } else {
    return $thiz.normalizeAction__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(shape)
  }
}
function $f_Lamf_plugins_domain_webapi_metamodel_AbstractModel__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  $thiz.amf$plugins$domain$webapi$metamodel$AbstractModel$$undsetter$und$IsAbstract$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "isAbstract"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "isAbstract", "Defines a model as abstract", $m_sci_Nil$()), true))
}
function $f_Lamf_plugins_domain_webapi_metamodel_ParametersFieldModel__$$init$__V($thiz) {
  var jsx$1 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$());
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  $thiz.amf$plugins$domain$webapi$metamodel$ParametersFieldModel$$undsetter$und$Headers$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "header"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "header", "Parameter passed as a header to an operation for communication models", $m_sci_Nil$()), true));
  var jsx$2 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$());
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  $thiz.amf$plugins$domain$webapi$metamodel$ParametersFieldModel$$undsetter$und$QueryParameters$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "parameter"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "parameter", "Parameters associated to the communication model", $m_sci_Nil$()), true));
  var jsx$3 = $m_Lamf_core_metamodel_domain_ShapeModel$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  $thiz.amf$plugins$domain$webapi$metamodel$ParametersFieldModel$$undsetter$und$QueryString$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "queryString"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "query string", "Query string for the communication model", $m_sci_Nil$()), true));
  var jsx$4 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$());
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  $thiz.amf$plugins$domain$webapi$metamodel$ParametersFieldModel$$undsetter$und$UriParameters$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "uriParameter"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "uri parameter", "", $m_sci_Nil$()), true))
}
function $f_Lamf_plugins_domain_webapi_metamodel_TagsModel__$$init$__V($thiz) {
  var jsx$1 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_TagModel$());
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  $thiz.amf$plugins$domain$webapi$metamodel$TagsModel$$undsetter$und$Tags$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "tag"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "tag", "Additionally custom tagged information", $m_sci_Nil$()), true))
}
function $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_domain_ShapeModel$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  $thiz.amf$plugins$domain$webapi$metamodel$bindings$BindingHeaders$$undsetter$und$Headers$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "headers"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "headers", "A Schema object containing the definitions for HTTP-specific headers", $m_sci_Nil$()), true))
}
function $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_domain_ShapeModel$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  $thiz.amf$plugins$domain$webapi$metamodel$bindings$BindingQuery$$undsetter$und$Query$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "query"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "query", "A Schema object containing the definitions for each query parameter", $m_sci_Nil$()), true))
}
function $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingType__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  $thiz.amf$plugins$domain$webapi$metamodel$bindings$BindingType$$undsetter$und$Type$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "type"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "type", "binding for a corresponding known type", $m_sci_Nil$()), true))
}
function $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  $thiz.amf$plugins$domain$webapi$metamodel$bindings$BindingVersion$$undsetter$und$BindingVersion$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "bindingVersion"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "bindingVersion", "The version of this binding", $m_sci_Nil$()), true))
}
function $is_Lamf_plugins_domain_webapi_models_DocumentedElement(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_domain_webapi_models_DocumentedElement)))
}
function $as_Lamf_plugins_domain_webapi_models_DocumentedElement(obj) {
  return (($is_Lamf_plugins_domain_webapi_models_DocumentedElement(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.DocumentedElement"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_DocumentedElement(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_DocumentedElement)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_DocumentedElement(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_DocumentedElement(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.DocumentedElement;", depth))
}
function $f_Lamf_plugins_domain_webapi_models_ExtensibleWebApiDomainElement__withResourceType__T__Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType($thiz, name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var jsx$2 = $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2);
  var jsx$1 = $as_Lamf_core_model_domain_AmfObject($thiz).id__T();
  var this$6 = new $c_Lamf_core_utils_package$AmfStrings().init___T(name);
  var this$7 = this$6.platform$1;
  var url = this$6.str$1;
  var result = $as_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType(jsx$2.withId__T__Lamf_core_model_domain_AmfObject(((jsx$1 + "/resourceType/") + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$7, url))));
  var this$8 = $as_Lamf_core_model_domain_AmfObject($thiz);
  var field = $m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field();
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$8, field, result);
  return result
}
function $f_Lamf_plugins_domain_webapi_models_ExtensibleWebApiDomainElement__withTrait__T__Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait($thiz, name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var jsx$2 = $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2);
  var jsx$1 = $as_Lamf_core_model_domain_AmfObject($thiz).id__T();
  var this$6 = new $c_Lamf_core_utils_package$AmfStrings().init___T(name);
  var this$7 = this$6.platform$1;
  var url = this$6.str$1;
  var result = $as_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait(jsx$2.withId__T__Lamf_core_model_domain_AmfObject(((jsx$1 + "/trait/") + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$7, url))));
  var this$8 = $as_Lamf_core_model_domain_AmfObject($thiz);
  var field = $m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field();
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$8, field, result);
  return result
}
function $is_Lamf_plugins_domain_webapi_models_Key(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_domain_webapi_models_Key)))
}
function $as_Lamf_plugins_domain_webapi_models_Key(obj) {
  return (($is_Lamf_plugins_domain_webapi_models_Key(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.Key"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_Key(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_Key)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_Key(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_Key(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.Key;", depth))
}
function $is_Lamf_plugins_domain_webapi_models_SchemaContainer(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_domain_webapi_models_SchemaContainer)))
}
function $as_Lamf_plugins_domain_webapi_models_SchemaContainer(obj) {
  return (($is_Lamf_plugins_domain_webapi_models_SchemaContainer(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.SchemaContainer"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_SchemaContainer(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_SchemaContainer)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_SchemaContainer(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_SchemaContainer(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.SchemaContainer;", depth))
}
function $is_Lamf_plugins_domain_webapi_models_ServerContainer(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_domain_webapi_models_ServerContainer)))
}
function $as_Lamf_plugins_domain_webapi_models_ServerContainer(obj) {
  return (($is_Lamf_plugins_domain_webapi_models_ServerContainer(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.ServerContainer"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_ServerContainer(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_ServerContainer)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_ServerContainer(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_ServerContainer(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.ServerContainer;", depth))
}
function $is_Lamf_plugins_domain_webapi_models_security_WithSettings(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_domain_webapi_models_security_WithSettings)))
}
function $as_Lamf_plugins_domain_webapi_models_security_WithSettings(obj) {
  return (($is_Lamf_plugins_domain_webapi_models_security_WithSettings(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.security.WithSettings"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_security_WithSettings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_security_WithSettings)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_security_WithSettings(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_security_WithSettings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.security.WithSettings;", depth))
}
function $f_Lamf_plugins_domain_webapi_resolution_stages_common_ExamplePropagationHelper__trackExamplesOf__Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement__Lamf_core_model_domain_Shape__V($thiz, exemplified, shape) {
  if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(shape);
    $as_sc_Seq(exemplified.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x2$1, exemplified$1) {
      return (function(example$2) {
        var example = $as_Lamf_plugins_domain_shapes_models_Example(example$2);
        if ((!$as_sc_Seq(x2$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, example$1) {
          return (function(x$1$2) {
            var x$1 = $as_Lamf_plugins_domain_shapes_models_Example(x$1$2);
            return (x$1.id$1 === example$1.id$1)
          })
        })($this, example))))) {
          var annotation = $m_Lamf_core_annotations_TrackedElement$().apply__T__Lamf_core_annotations_TrackedElement(exemplified$1.id__T());
          $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(example, annotation);
          var jsx$3 = $as_sc_Seq(x2$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1));
          var jsx$2 = $m_sc_Seq$();
          var array = [example];
          var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
          var this$3 = $m_sc_Seq$();
          var examples = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
          var field = $m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1;
          $as_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(x2$1, field, examples));
          exemplified$1.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)
        }
      })
    })($thiz, x2, exemplified)))
  }
}
function $f_Lamf_plugins_features_validation_Validations__all__T__sci_Map($thiz, lvl) {
  var jsx$3 = $m_Lamf_ProfileNames$().specProfiles__sc_Seq();
  var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, lvl$1) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_ProfileName(x$2$2);
      return new $c_T2().init___O__O(x$2, lvl$1)
    })
  })($thiz, lvl));
  var this$3 = $m_sc_Seq$();
  var jsx$1 = $as_sc_TraversableOnce(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$3.ReusableCBFInstance$2)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2);
  var self = $m_Lamf_AmlProfile$();
  return jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, lvl))
}
function $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification($thiz, id, message, ramlMessage, oasMessage) {
  var this$1 = $thiz.namespace__Lamf_core_vocabulary_Namespace();
  var jsx$10 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, id).iri__T();
  var jsx$9 = $m_sc_Seq$();
  var array = [$thiz.specification__T()];
  var jsx$8 = $as_sc_Seq(jsx$9.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$8 = new $c_scm_ListBuffer().init___();
  var jsx$7 = this$8.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$12 = new $c_scm_ListBuffer().init___();
  var jsx$6 = this$12.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$16 = new $c_scm_ListBuffer().init___();
  var jsx$5 = this$16.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$20 = new $c_scm_ListBuffer().init___();
  var jsx$4 = this$20.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$24 = new $c_scm_ListBuffer().init___();
  var jsx$3 = this$24.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var jsx$2 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$29 = new $c_scm_ListBuffer().init___();
  var jsx$1 = this$29.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$33 = new $c_scm_ListBuffer().init___();
  return new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(jsx$10, message, ramlMessage, oasMessage, jsx$8, jsx$7, jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, jsx$1, this$33.toList__sci_List(), ($m_Lamf_core_validation_core_ValidationSpecification$(), $m_s_None$()), ($m_Lamf_core_validation_core_ValidationSpecification$(), $m_s_None$()), ($m_Lamf_core_validation_core_ValidationSpecification$(), $m_s_None$()), ($m_Lamf_core_validation_core_ValidationSpecification$(), $m_s_None$()), ($m_Lamf_core_validation_core_ValidationSpecification$(), $m_s_None$()), ($m_Lamf_core_validation_core_ValidationSpecification$(), $m_s_None$()))
}
function $f_Lamf_plugins_features_validation_model_DialectWrapper__extractStrings__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__sc_Seq($thiz, node, property) {
  var this$1 = node.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping();
  var this$4 = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, property$1) {
    return (function(x$5$2) {
      var x$5 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$5$2);
      var this$2 = $as_Lamf_core_model_StrField(x$5.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
      var this$3 = this$2.option$1;
      return ($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())) === property$1)
    })
  })($thiz, property)));
  if (this$4.isEmpty__Z()) {
    var this$6 = $m_s_None$()
  } else {
    var arg1 = this$4.get__O();
    var p = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(arg1);
    var jsx$2 = node.literalProperties__Lamf_core_metamodel_Field__sc_Seq(p.toField__Lamf_core_metamodel_Field());
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
      return (function(x$6$2) {
        return $objectToString(x$6$2)
      })
    })($thiz));
    var this$5 = $m_sc_Seq$();
    var this$6 = new $c_s_Some().init___O($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2)))
  };
  return $as_sc_Seq((this$6.isEmpty__Z() ? $m_sci_Nil$() : this$6.get__O()))
}
function $f_Lamf_plugins_features_validation_model_DialectWrapper__mandatory__T__s_Option__O($thiz, message, x) {
  if ((x instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x);
    var e = x2.value$2;
    return e
  } else {
    var x$2 = $m_s_None$();
    if ((x$2 === x)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T((("Missing mandatory property '" + message) + "'")))
    } else {
      throw new $c_s_MatchError().init___O(x)
    }
  }
}
function $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option($thiz, node, property) {
  var this$1 = node.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping();
  var this$4 = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, property$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$1$2);
      var this$2 = $as_Lamf_core_model_StrField(x$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
      var this$3 = this$2.option$1;
      return ($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())) === property$1)
    })
  })($thiz, property)));
  if (this$4.isEmpty__Z()) {
    var this$5 = $m_s_None$()
  } else {
    var arg1 = this$4.get__O();
    var p = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(arg1);
    var this$5 = node.literalProperty__Lamf_core_metamodel_Field__s_Option(p.toField__Lamf_core_metamodel_Field())
  };
  if (this$5.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1$1 = this$5.get__O();
    return new $c_s_Some().init___O($objectToString(arg1$1))
  }
}
function $f_Lamf_plugins_features_validation_model_DialectWrapper__expand__T__scm_Map__T($thiz, value, prefixes) {
  var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(value, "\\.", 0);
  var this$3 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
  var valuePrefix = $as_T($f_sc_IndexedSeqOptimized__head__O(this$3));
  var x1 = prefixes.get__O__s_Option(valuePrefix);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var uri = $as_T(x2.value$2);
    var target = (valuePrefix + ".");
    return $as_T(value.split(target).join(uri))
  } else {
    return value
  }
}
function $f_Lamf_plugins_features_validation_model_DialectWrapper__prefixes__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__scm_Map($thiz, node) {
  var prefixMap = $as_scm_Map($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var this$1 = node.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping();
  var this$4 = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$10$2) {
      var x$10 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$10$2);
      var this$2 = $as_Lamf_core_model_StrField(x$10.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
      var this$3 = this$2.option$1;
      return ($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())) === "prefixes")
    })
  })($thiz)));
  if (this$4.isEmpty__Z()) {
    var x1 = $m_s_None$()
  } else {
    var arg1 = this$4.get__O();
    var x$11 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(arg1);
    var x1 = new $c_s_Some().init___O(x$11.toField__Lamf_core_metamodel_Field())
  };
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var prefixesProperty = $as_Lamf_core_metamodel_Field(x2.value$2);
    node.objectCollectionProperty__Lamf_core_metamodel_Field__sc_Seq(prefixesProperty).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, prefixMap$1) {
      return (function(prefixEntity$2) {
        var prefixEntity = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(prefixEntity$2);
        var this$5 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this$3$1, prefixEntity, "prefix");
        var prefix = $as_T((this$5.isEmpty__Z() ? "" : this$5.get__O()));
        var this$6 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this$3$1, prefixEntity, "uri");
        var prefixUri = $as_T((this$6.isEmpty__Z() ? "" : this$6.get__O()));
        return prefixMap$1.put__O__O__s_Option(prefix, prefixUri)
      })
    })($thiz, prefixMap)))
  };
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ns$1;
  var iterTable = this$7.table$5;
  var idx = $f_scm_HashTable__scala$collection$mutable$HashTable$$lastPopulatedIndex__I(this$7);
  var es = iterTable.get(idx);
  while ((es !== null)) {
    var next = $as_scm_HashEntry(es.next__O());
    var arg1$1 = es;
    var e = $as_scm_DefaultEntry(arg1$1);
    var _1 = e.key$1;
    var _2 = e.value$1;
    var p = $as_T(_1);
    var v = $as_Lamf_core_vocabulary_Namespace(_2);
    var x1$2 = prefixMap.get__O__s_Option(p);
    if ((!(x1$2 instanceof $c_s_Some))) {
      prefixMap.put__O__O__s_Option(p, v.base$1)
    };
    es = next;
    while (((es === null) && (idx > 0))) {
      idx = (((-1) + idx) | 0);
      es = iterTable.get(idx)
    }
  };
  return prefixMap
}
function $f_Lamf_plugins_features_validation_model_DialectWrapper__mapIndexedEntities__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__F2__sc_Seq($thiz, node, property, f) {
  var this$1 = node.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping();
  var this$4 = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, property$1) {
    return (function(x$8$2) {
      var x$8 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$8$2);
      var this$2 = $as_Lamf_core_model_StrField(x$8.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
      var this$3 = this$2.option$1;
      return ($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())) === property$1)
    })
  })($thiz, property)));
  if (this$4.isEmpty__Z()) {
    var this$7 = $m_s_None$()
  } else {
    var arg1 = this$4.get__O();
    var p = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(arg1);
    var jsx$3 = node.objectCollectionProperty__Lamf_core_metamodel_Field__sc_Seq(p.toField__Lamf_core_metamodel_Field());
    var this$5 = $m_sc_Seq$();
    var jsx$2 = $as_sc_TraversableLike(jsx$3.zipWithIndex__scg_CanBuildFrom__O(this$5.ReusableCBFInstance$2));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, f$2) {
      return (function(x0$1$2) {
        var x0$1 = $as_T2(x0$1$2);
        if ((x0$1 !== null)) {
          var dialectDomainElement = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x0$1.$$und1__O());
          var i = x0$1.$$und2$mcI$sp__I();
          return f$2.apply__O__O__O(dialectDomainElement, i)
        } else {
          throw new $c_s_MatchError().init___O(x0$1)
        }
      })
    })($thiz, f));
    var this$6 = $m_sc_Seq$();
    var this$7 = new $c_s_Some().init___O($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2)))
  };
  return $as_sc_Seq((this$7.isEmpty__Z() ? $m_sci_Nil$() : this$7.get__O()))
}
function $f_Lamf_plugins_features_validation_model_DialectWrapper__extractInt__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option($thiz, node, property) {
  var this$1 = node.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping();
  var this$4 = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, property$1) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$3$2);
      var this$2 = $as_Lamf_core_model_StrField(x$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
      var this$3 = this$2.option$1;
      return ($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())) === property$1)
    })
  })($thiz, property)));
  if (this$4.isEmpty__Z()) {
    var this$5 = $m_s_None$()
  } else {
    var arg1 = this$4.get__O();
    var p = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(arg1);
    var this$5 = node.literalProperty__Lamf_core_metamodel_Field__s_Option(p.toField__Lamf_core_metamodel_Field())
  };
  if (this$5.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1$1 = this$5.get__O();
    return new $c_s_Some().init___O($uI(arg1$1))
  }
}
function $f_Lamf_plugins_features_validation_model_DialectWrapper__mapEntities__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__F1__sc_Seq($thiz, node, property, f) {
  var this$1 = node.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping();
  var this$4 = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, property$1) {
    return (function(x$7$2) {
      var x$7 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$7$2);
      var this$2 = $as_Lamf_core_model_StrField(x$7.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
      var this$3 = this$2.option$1;
      return ($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())) === property$1)
    })
  })($thiz, property)));
  if (this$4.isEmpty__Z()) {
    var this$6 = $m_s_None$()
  } else {
    var arg1 = this$4.get__O();
    var p = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(arg1);
    var jsx$1 = node.objectCollectionProperty__Lamf_core_metamodel_Field__sc_Seq(p.toField__Lamf_core_metamodel_Field());
    var this$5 = $m_sc_Seq$();
    var this$6 = new $c_s_Some().init___O($as_sc_Seq(jsx$1.map__F1__scg_CanBuildFrom__O(f, this$5.ReusableCBFInstance$2)))
  };
  return $as_sc_Seq((this$6.isEmpty__Z() ? $m_sci_Nil$() : this$6.get__O()))
}
function $f_Lorg_mulesoft_common_io_Output__append__O__C__V($thiz, w, c) {
  $thiz.append__O__jl_CharSequence__V(w, $as_T($g.String.fromCharCode(c)))
}
function $is_Lorg_mulesoft_common_parse_ParseError(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lorg_mulesoft_common_parse_ParseError)))
}
function $as_Lorg_mulesoft_common_parse_ParseError(obj) {
  return (($is_Lorg_mulesoft_common_parse_ParseError(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "org.mulesoft.common.parse.ParseError"))
}
function $isArrayOf_Lorg_mulesoft_common_parse_ParseError(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_mulesoft_common_parse_ParseError)))
}
function $asArrayOf_Lorg_mulesoft_common_parse_ParseError(obj, depth) {
  return (($isArrayOf_Lorg_mulesoft_common_parse_ParseError(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.mulesoft.common.parse.ParseError;", depth))
}
function $is_Lorg_mulesoft_lexer_LexerInput$Mark(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lorg_mulesoft_lexer_LexerInput$Mark)))
}
function $as_Lorg_mulesoft_lexer_LexerInput$Mark(obj) {
  return (($is_Lorg_mulesoft_lexer_LexerInput$Mark(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "org.mulesoft.lexer.LexerInput$Mark"))
}
function $isArrayOf_Lorg_mulesoft_lexer_LexerInput$Mark(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_mulesoft_lexer_LexerInput$Mark)))
}
function $asArrayOf_Lorg_mulesoft_lexer_LexerInput$Mark(obj, depth) {
  return (($isArrayOf_Lorg_mulesoft_lexer_LexerInput$Mark(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.mulesoft.lexer.LexerInput$Mark;", depth))
}
function $f_Lorg_yaml_builder_JsonOutputBuilder$LifeCycle__$$init$__V($thiz) {
  $thiz.org$yaml$builder$JsonOutputBuilder$LifeCycle$$start$und$eq__Z__V(true);
  $thiz.org$yaml$builder$JsonOutputBuilder$LifeCycle$$newLineOnStart$und$eq__Z__V(false)
}
function $f_Lorg_yaml_builder_JsonOutputBuilder$LifeCycle__execute__F1__V($thiz, f) {
  $thiz.org$yaml$builder$JsonOutputBuilder$LifeCycle$$newLineOnStart$und$eq__Z__V(true);
  f.apply__O__O($thiz);
  if (((!$thiz.org$yaml$builder$JsonOutputBuilder$LifeCycle$$start__Z()) && $thiz.org$yaml$builder$JsonOutputBuilder$LifeCycle$$newLineOnStart__Z())) {
    $thiz.org$yaml$builder$JsonOutputBuilder$LifeCycle$$$outer__Lorg_yaml_builder_JsonOutputBuilder().dedent__V();
    $thiz.org$yaml$builder$JsonOutputBuilder$LifeCycle$$$outer__Lorg_yaml_builder_JsonOutputBuilder().newLine__V()
  }
}
function $f_Lorg_yaml_builder_JsonOutputBuilder$LifeCycle__before__V($thiz) {
  if ($thiz.org$yaml$builder$JsonOutputBuilder$LifeCycle$$start__Z()) {
    if ($thiz.org$yaml$builder$JsonOutputBuilder$LifeCycle$$newLineOnStart__Z()) {
      $thiz.org$yaml$builder$JsonOutputBuilder$LifeCycle$$$outer__Lorg_yaml_builder_JsonOutputBuilder().indent__V();
      $thiz.org$yaml$builder$JsonOutputBuilder$LifeCycle$$$outer__Lorg_yaml_builder_JsonOutputBuilder().newLine__V()
    };
    $thiz.org$yaml$builder$JsonOutputBuilder$LifeCycle$$start$und$eq__Z__V(false)
  } else {
    var this$1 = $thiz.org$yaml$builder$JsonOutputBuilder$LifeCycle$$$outer__Lorg_yaml_builder_JsonOutputBuilder();
    var w = this$1.writer$2;
    var this$3 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(w);
    var o = $thiz.org$yaml$builder$JsonOutputBuilder$LifeCycle$$$outer__Lorg_yaml_builder_JsonOutputBuilder().org$yaml$builder$JsonOutputBuilder$$evidence$1$f;
    o.append__O__C__V(this$3.w$1, 44);
    $thiz.org$yaml$builder$JsonOutputBuilder$LifeCycle$$$outer__Lorg_yaml_builder_JsonOutputBuilder().newLine__V()
  }
}
function $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z($thiz, b) {
  return (($thiz === b) || $thiz.equals__O__Z(b))
}
function $f_Lorg_yaml_parser_YParser__document__Lorg_yaml_model_YDocument($thiz) {
  var this$1 = $thiz.documents__sc_IndexedSeq().headOption__s_Option();
  return $as_Lorg_yaml_model_YDocument((this$1.isEmpty__Z() ? $m_Lorg_yaml_model_YDocument$().fromNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YDocument($m_Lorg_yaml_model_YNode$().Null$1) : this$1.get__O()))
}
function $f_Lscopt_Read__tokensToRead__I($thiz) {
  return (($thiz.arity__I() === 0) ? 0 : 1)
}
function $f_Lscopt_platform$PlatformReadInstances__$$init$__V($thiz) {
  $m_Lscopt_Read$();
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_T(x$1$2);
      return new $c_Ljava_net_URI().init___T(x$1)
    })
  })($thiz));
  $thiz.uriRead$1 = new $c_Lscopt_Read$$anon$2().init___F1(f)
}
/** @constructor */
function $c_O() {
  /*<skip>*/
}
/** @constructor */
function $h_O() {
  /*<skip>*/
}
$h_O.prototype = $c_O.prototype;
$c_O.prototype.init___ = (function() {
  return this
});
$c_O.prototype.equals__O__Z = (function(that) {
  return (this === that)
});
$c_O.prototype.toString__T = (function() {
  var jsx$2 = $objectGetClass(this).getName__T();
  var i = this.hashCode__I();
  var x = $uD((i >>> 0));
  var jsx$1 = x.toString(16);
  return ((jsx$2 + "@") + $as_T(jsx$1))
});
$c_O.prototype.hashCode__I = (function() {
  return $systemIdentityHashCode(this)
});
$c_O.prototype.toString = (function() {
  return this.toString__T()
});
function $is_O(obj) {
  return (obj !== null)
}
function $as_O(obj) {
  return obj
}
function $isArrayOf_O(obj, depth) {
  var data = (obj && obj.$classData);
  if ((!data)) {
    return false
  } else {
    var arrayDepth = (data.arrayDepth || 0);
    return ((!(arrayDepth < depth)) && ((arrayDepth > depth) || (!data.arrayBase.isPrimitive)))
  }
}
function $asArrayOf_O(obj, depth) {
  return (($isArrayOf_O(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.Object;", depth))
}
var $d_O = new $TypeData().initClass({
  O: 0
}, false, "java.lang.Object", {
  O: 1
}, (void 0), (void 0), $is_O, $isArrayOf_O);
$c_O.prototype.$classData = $d_O;
function $is_jl_CharSequence(obj) {
  return ((!(!((obj && obj.$classData) && obj.$classData.ancestors.jl_CharSequence))) || ((typeof obj) === "string"))
}
function $as_jl_CharSequence(obj) {
  return (($is_jl_CharSequence(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "java.lang.CharSequence"))
}
function $isArrayOf_jl_CharSequence(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_CharSequence)))
}
function $asArrayOf_jl_CharSequence(obj, depth) {
  return (($isArrayOf_jl_CharSequence(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.CharSequence;", depth))
}
function $is_jl_Comparable(obj) {
  return ((((!(!((obj && obj.$classData) && obj.$classData.ancestors.jl_Comparable))) || ((typeof obj) === "string")) || ((typeof obj) === "number")) || ((typeof obj) === "boolean"))
}
function $as_jl_Comparable(obj) {
  return (($is_jl_Comparable(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "java.lang.Comparable"))
}
function $isArrayOf_jl_Comparable(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_Comparable)))
}
function $asArrayOf_jl_Comparable(obj, depth) {
  return (($isArrayOf_jl_Comparable(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.Comparable;", depth))
}
function $is_jl_Runnable(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.jl_Runnable)))
}
function $as_jl_Runnable(obj) {
  return (($is_jl_Runnable(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "java.lang.Runnable"))
}
function $isArrayOf_jl_Runnable(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_Runnable)))
}
function $asArrayOf_jl_Runnable(obj, depth) {
  return (($isArrayOf_jl_Runnable(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.Runnable;", depth))
}
function $is_ju_Formattable(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.ju_Formattable)))
}
function $as_ju_Formattable(obj) {
  return (($is_ju_Formattable(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "java.util.Formattable"))
}
function $isArrayOf_ju_Formattable(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.ju_Formattable)))
}
function $asArrayOf_ju_Formattable(obj, depth) {
  return (($isArrayOf_ju_Formattable(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.util.Formattable;", depth))
}
function $f_s_Proxy__equals__O__Z($thiz, that) {
  return ((that !== null) && (((that === $thiz) || (that === $thiz.self__O())) || $objectEquals(that, $thiz.self__O())))
}
function $f_s_Proxy__toString__T($thiz) {
  return ("" + $thiz.self__O())
}
function $is_s_concurrent_BlockContext(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.s_concurrent_BlockContext)))
}
function $as_s_concurrent_BlockContext(obj) {
  return (($is_s_concurrent_BlockContext(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.concurrent.BlockContext"))
}
function $isArrayOf_s_concurrent_BlockContext(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_concurrent_BlockContext)))
}
function $asArrayOf_s_concurrent_BlockContext(obj, depth) {
  return (($isArrayOf_s_concurrent_BlockContext(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.concurrent.BlockContext;", depth))
}
function $is_s_concurrent_OnCompleteRunnable(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.s_concurrent_OnCompleteRunnable)))
}
function $as_s_concurrent_OnCompleteRunnable(obj) {
  return (($is_s_concurrent_OnCompleteRunnable(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.concurrent.OnCompleteRunnable"))
}
function $isArrayOf_s_concurrent_OnCompleteRunnable(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_concurrent_OnCompleteRunnable)))
}
function $asArrayOf_s_concurrent_OnCompleteRunnable(obj, depth) {
  return (($isArrayOf_s_concurrent_OnCompleteRunnable(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.concurrent.OnCompleteRunnable;", depth))
}
function $f_s_concurrent_Promise__failure__jl_Throwable__s_concurrent_Promise($thiz, cause) {
  var result = new $c_s_util_Failure().init___jl_Throwable(cause);
  return $f_s_concurrent_Promise__complete__s_util_Try__s_concurrent_Promise($thiz, result)
}
function $f_s_concurrent_Promise__tryCompleteWith__s_concurrent_Future__s_concurrent_Promise($thiz, other) {
  if ((other !== $thiz)) {
    other.onComplete__F1__s_concurrent_ExecutionContext__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$1$2) {
        var x$1 = $as_s_util_Try(x$1$2);
        return $this.tryComplete__s_util_Try__Z(x$1)
      })
    })($thiz)), $m_s_concurrent_Future$InternalCallbackExecutor$())
  };
  return $thiz
}
function $f_s_concurrent_Promise__complete__s_util_Try__s_concurrent_Promise($thiz, result) {
  if ($thiz.tryComplete__s_util_Try__Z(result)) {
    return $thiz
  } else {
    throw new $c_jl_IllegalStateException().init___T("Promise already completed.")
  }
}
function $f_s_concurrent_Promise__success__O__s_concurrent_Promise($thiz, value) {
  var result = new $c_s_util_Success().init___O(value);
  return $f_s_concurrent_Promise__complete__s_util_Try__s_concurrent_Promise($thiz, result)
}
function $f_s_math_ScalaNumericAnyConversions__unifiedPrimitiveEquals__O__Z($thiz, x) {
  if ((x instanceof $c_jl_Character)) {
    if ((x === null)) {
      var x2 = 0
    } else {
      var this$2 = $as_jl_Character(x);
      var x2 = this$2.value$1
    };
    return ($thiz.isValidChar__Z() && ($thiz.intValue__I() === x2))
  } else if ($isByte(x)) {
    var x3 = $uB(x);
    return ($thiz.isValidByte__Z() && ($thiz.byteValue__B() === x3))
  } else if ($isShort(x)) {
    var x4 = $uS(x);
    return ($thiz.isValidShort__Z() && ($thiz.shortValue__S() === x4))
  } else if ($isInt(x)) {
    var x5 = $uI(x);
    return ($thiz.isValidInt__Z() && ($thiz.intValue__I() === x5))
  } else if ((x instanceof $c_sjsr_RuntimeLong)) {
    var t = $uJ(x);
    var lo = t.lo$2;
    var hi = t.hi$2;
    var t$1 = $thiz.longValue__J();
    var lo$1 = t$1.lo$2;
    var hi$1 = t$1.hi$2;
    return ((lo$1 === lo) && (hi$1 === hi))
  } else if ($isFloat(x)) {
    var x7 = $uF(x);
    return ($thiz.floatValue__F() === x7)
  } else if (((typeof x) === "number")) {
    var x8 = $uD(x);
    return ($thiz.doubleValue__D() === x8)
  } else {
    return false
  }
}
function $f_s_math_ScalaNumericAnyConversions__unifiedPrimitiveHashcode__I($thiz) {
  var t = $thiz.longValue__J();
  var lo = t.lo$2;
  var hi = t.hi$2;
  return ((((hi === (-1)) ? (((-2147483648) ^ lo) >= 0) : (hi > (-1))) && ((hi === 0) ? (((-2147483648) ^ lo) <= (-1)) : (hi < 0))) ? lo : $m_sr_Statics$().longHash__J__I(new $c_sjsr_RuntimeLong().init___I__I(lo, hi)))
}
function $f_s_util_control_NoStackTrace__fillInStackTrace__jl_Throwable($thiz) {
  var this$1 = $m_s_util_control_NoStackTrace$();
  if (this$1.$$undnoSuppression$1) {
    return $c_jl_Throwable.prototype.fillInStackTrace__jl_Throwable.call($thiz)
  } else {
    return $as_jl_Throwable($thiz)
  }
}
function $f_s_util_matching_Regex$MatchData__matched__T($thiz) {
  return (($thiz.start__I() >= 0) ? $objectToString($charSequenceSubSequence($thiz.source__jl_CharSequence(), $thiz.start__I(), $thiz.end__I())) : null)
}
function $f_s_util_matching_Regex$MatchData__group__I__T($thiz, i) {
  return (($thiz.start__I__I(i) >= 0) ? $objectToString($charSequenceSubSequence($thiz.source__jl_CharSequence(), $thiz.start__I__I(i), $thiz.end__I__I(i))) : null)
}
function $f_s_util_matching_Regex$Replacement__replaced__T($thiz) {
  var newsb = new $c_jl_StringBuffer().init___jl_CharSequence($thiz.scala$util$matching$Regex$Replacement$$sb$2);
  $thiz.matcher__ju_regex_Matcher().appendTail__jl_StringBuffer__jl_StringBuffer(newsb);
  return newsb.toString__T()
}
function $is_sc_GenTraversableOnce(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_GenTraversableOnce)))
}
function $as_sc_GenTraversableOnce(obj) {
  return (($is_sc_GenTraversableOnce(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.GenTraversableOnce"))
}
function $isArrayOf_sc_GenTraversableOnce(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_GenTraversableOnce)))
}
function $asArrayOf_sc_GenTraversableOnce(obj, depth) {
  return (($isArrayOf_sc_GenTraversableOnce(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.GenTraversableOnce;", depth))
}
function $f_sc_ViewMkString__mkString__T__T__T__T($thiz, start, sep, end) {
  var this$1 = $f_sc_ViewMkString__thisSeq__sc_Seq($thiz).addString__scm_StringBuilder__T__T__T__scm_StringBuilder(new $c_scm_StringBuilder().init___(), start, sep, end);
  return this$1.underlying$5.java$lang$StringBuilder$$content$f
}
function $f_sc_ViewMkString__addString__scm_StringBuilder__T__T__T__scm_StringBuilder($thiz, b, start, sep, end) {
  var first = new $c_sr_BooleanRef().init___Z(true);
  b.append__T__scm_StringBuilder(start);
  $as_scg_GenericTraversableTemplate($thiz).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, first$1, b$1, sep$1) {
    return (function(x$2) {
      if (first$1.elem$1) {
        first$1.elem$1 = false
      } else {
        b$1.append__T__scm_StringBuilder(sep$1)
      };
      return b$1.append__O__scm_StringBuilder(x$2)
    })
  })($thiz, first, b, sep)));
  b.append__T__scm_StringBuilder(end);
  return b
}
function $f_sc_ViewMkString__thisSeq__sc_Seq($thiz) {
  return new $c_scm_ArrayBuffer().init___().$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuffer($as_sc_TraversableOnce($thiz))
}
function $f_scg_Shrinkable__$$minus$minus$eq__sc_TraversableOnce__scg_Shrinkable($thiz, xs) {
  xs.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(elem$2) {
      return $this.$$minus$eq__O__scg_Shrinkable(elem$2)
    })
  })($thiz)));
  return $thiz
}
function $f_scg_Sorted__hasAll__sc_Iterator__Z($thiz, j) {
  var i = $as_sc_SortedSet($thiz).iterator__sc_Iterator();
  if ($f_sc_Iterator__isEmpty__Z(i)) {
    return $f_sc_Iterator__isEmpty__Z(j)
  };
  var $in = i.next__O();
  while (j.hasNext__Z()) {
    var jn = j.next__O();
    while (true) {
      var k1 = $in;
      var n = $thiz.ordering$1.compare__O__O__I(jn, k1);
      if ((n !== 0)) {
        if ((n < 0)) {
          var jsx$1;
          return false
        } else if ((!i.hasNext__Z())) {
          var jsx$1;
          return false
        } else {
          var jsx$1 = true
        }
      } else {
        var jsx$1 = false
      };
      if (jsx$1) {
        $in = i.next__O()
      } else {
        break
      }
    }
  };
  return true
}
function $f_scg_Subtractable__$$minus$minus__sc_GenTraversableOnce__scg_Subtractable($thiz, xs) {
  var x$1 = $thiz.repr__scg_Subtractable();
  return $as_scg_Subtractable(xs.seq__sc_TraversableOnce().$$div$colon__O__F2__O(x$1, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(x$2$2, x$3$2) {
      var x$2 = $as_scg_Subtractable(x$2$2);
      return x$2.$$minus__O__scg_Subtractable(x$3$2)
    })
  })($thiz))))
}
function $is_scg_Subtractable(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.scg_Subtractable)))
}
function $as_scg_Subtractable(obj) {
  return (($is_scg_Subtractable(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.generic.Subtractable"))
}
function $isArrayOf_scg_Subtractable(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scg_Subtractable)))
}
function $asArrayOf_scg_Subtractable(obj, depth) {
  return (($isArrayOf_scg_Subtractable(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.generic.Subtractable;", depth))
}
function $f_sci_VectorPointer__copyOf__AO__AO($thiz, a) {
  var copy = $newArrayObject($d_O.getArrayOf(), [a.u.length]);
  $systemArraycopy(a, 0, copy, 0, a.u.length);
  return copy
}
function $f_sci_VectorPointer__gotoNextBlockStart__I__I__V($thiz, index, xor) {
  if ((xor < 1024)) {
    $thiz.display0$und$eq__AO__V($asArrayOf_O($thiz.display1__AO().get((31 & ((index >>> 5) | 0))), 1))
  } else if ((xor < 32768)) {
    $thiz.display1$und$eq__AO__V($asArrayOf_O($thiz.display2__AO().get((31 & ((index >>> 10) | 0))), 1));
    $thiz.display0$und$eq__AO__V($asArrayOf_O($thiz.display1__AO().get(0), 1))
  } else if ((xor < 1048576)) {
    $thiz.display2$und$eq__AO__V($asArrayOf_O($thiz.display3__AO().get((31 & ((index >>> 15) | 0))), 1));
    $thiz.display1$und$eq__AO__V($asArrayOf_O($thiz.display2__AO().get(0), 1));
    $thiz.display0$und$eq__AO__V($asArrayOf_O($thiz.display1__AO().get(0), 1))
  } else if ((xor < 33554432)) {
    $thiz.display3$und$eq__AO__V($asArrayOf_O($thiz.display4__AO().get((31 & ((index >>> 20) | 0))), 1));
    $thiz.display2$und$eq__AO__V($asArrayOf_O($thiz.display3__AO().get(0), 1));
    $thiz.display1$und$eq__AO__V($asArrayOf_O($thiz.display2__AO().get(0), 1));
    $thiz.display0$und$eq__AO__V($asArrayOf_O($thiz.display1__AO().get(0), 1))
  } else if ((xor < 1073741824)) {
    $thiz.display4$und$eq__AO__V($asArrayOf_O($thiz.display5__AO().get((31 & ((index >>> 25) | 0))), 1));
    $thiz.display3$und$eq__AO__V($asArrayOf_O($thiz.display4__AO().get(0), 1));
    $thiz.display2$und$eq__AO__V($asArrayOf_O($thiz.display3__AO().get(0), 1));
    $thiz.display1$und$eq__AO__V($asArrayOf_O($thiz.display2__AO().get(0), 1));
    $thiz.display0$und$eq__AO__V($asArrayOf_O($thiz.display1__AO().get(0), 1))
  } else {
    throw new $c_jl_IllegalArgumentException().init___()
  }
}
function $f_sci_VectorPointer__gotoFreshPosWritable1__I__I__I__V($thiz, oldIndex, newIndex, xor) {
  $f_sci_VectorPointer__stabilize__I__V($thiz, oldIndex);
  $f_sci_VectorPointer__gotoFreshPosWritable0__I__I__I__V($thiz, oldIndex, newIndex, xor)
}
function $f_sci_VectorPointer__getElem__I__I__O($thiz, index, xor) {
  if ((xor < 32)) {
    return $thiz.display0__AO().get((31 & index))
  } else if ((xor < 1024)) {
    return $asArrayOf_O($thiz.display1__AO().get((31 & ((index >>> 5) | 0))), 1).get((31 & index))
  } else if ((xor < 32768)) {
    return $asArrayOf_O($asArrayOf_O($thiz.display2__AO().get((31 & ((index >>> 10) | 0))), 1).get((31 & ((index >>> 5) | 0))), 1).get((31 & index))
  } else if ((xor < 1048576)) {
    return $asArrayOf_O($asArrayOf_O($asArrayOf_O($thiz.display3__AO().get((31 & ((index >>> 15) | 0))), 1).get((31 & ((index >>> 10) | 0))), 1).get((31 & ((index >>> 5) | 0))), 1).get((31 & index))
  } else if ((xor < 33554432)) {
    return $asArrayOf_O($asArrayOf_O($asArrayOf_O($asArrayOf_O($thiz.display4__AO().get((31 & ((index >>> 20) | 0))), 1).get((31 & ((index >>> 15) | 0))), 1).get((31 & ((index >>> 10) | 0))), 1).get((31 & ((index >>> 5) | 0))), 1).get((31 & index))
  } else if ((xor < 1073741824)) {
    return $asArrayOf_O($asArrayOf_O($asArrayOf_O($asArrayOf_O($asArrayOf_O($thiz.display5__AO().get((31 & ((index >>> 25) | 0))), 1).get((31 & ((index >>> 20) | 0))), 1).get((31 & ((index >>> 15) | 0))), 1).get((31 & ((index >>> 10) | 0))), 1).get((31 & ((index >>> 5) | 0))), 1).get((31 & index))
  } else {
    throw new $c_jl_IllegalArgumentException().init___()
  }
}
function $f_sci_VectorPointer__gotoFreshPosWritable0__I__I__I__V($thiz, oldIndex, newIndex, xor) {
  if ((!(xor < 32))) {
    if ((xor < 1024)) {
      if (($thiz.depth__I() === 1)) {
        $thiz.display1$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
        $thiz.display1__AO().set((31 & ((oldIndex >>> 5) | 0)), $thiz.display0__AO());
        $thiz.depth$und$eq__I__V(((1 + $thiz.depth__I()) | 0))
      };
      $thiz.display0$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]))
    } else if ((xor < 32768)) {
      if (($thiz.depth__I() === 2)) {
        $thiz.display2$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
        $thiz.display2__AO().set((31 & ((oldIndex >>> 10) | 0)), $thiz.display1__AO());
        $thiz.depth$und$eq__I__V(((1 + $thiz.depth__I()) | 0))
      };
      $thiz.display1$und$eq__AO__V($asArrayOf_O($thiz.display2__AO().get((31 & ((newIndex >>> 10) | 0))), 1));
      if (($thiz.display1__AO() === null)) {
        $thiz.display1$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]))
      };
      $thiz.display0$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]))
    } else if ((xor < 1048576)) {
      if (($thiz.depth__I() === 3)) {
        $thiz.display3$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
        $thiz.display3__AO().set((31 & ((oldIndex >>> 15) | 0)), $thiz.display2__AO());
        $thiz.depth$und$eq__I__V(((1 + $thiz.depth__I()) | 0))
      };
      $thiz.display2$und$eq__AO__V($asArrayOf_O($thiz.display3__AO().get((31 & ((newIndex >>> 15) | 0))), 1));
      if (($thiz.display2__AO() === null)) {
        $thiz.display2$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]))
      };
      $thiz.display1$und$eq__AO__V($asArrayOf_O($thiz.display2__AO().get((31 & ((newIndex >>> 10) | 0))), 1));
      if (($thiz.display1__AO() === null)) {
        $thiz.display1$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]))
      };
      $thiz.display0$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]))
    } else if ((xor < 33554432)) {
      if (($thiz.depth__I() === 4)) {
        $thiz.display4$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
        $thiz.display4__AO().set((31 & ((oldIndex >>> 20) | 0)), $thiz.display3__AO());
        $thiz.depth$und$eq__I__V(((1 + $thiz.depth__I()) | 0))
      };
      $thiz.display3$und$eq__AO__V($asArrayOf_O($thiz.display4__AO().get((31 & ((newIndex >>> 20) | 0))), 1));
      if (($thiz.display3__AO() === null)) {
        $thiz.display3$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]))
      };
      $thiz.display2$und$eq__AO__V($asArrayOf_O($thiz.display3__AO().get((31 & ((newIndex >>> 15) | 0))), 1));
      if (($thiz.display2__AO() === null)) {
        $thiz.display2$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]))
      };
      $thiz.display1$und$eq__AO__V($asArrayOf_O($thiz.display2__AO().get((31 & ((newIndex >>> 10) | 0))), 1));
      if (($thiz.display1__AO() === null)) {
        $thiz.display1$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]))
      };
      $thiz.display0$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]))
    } else if ((xor < 1073741824)) {
      if (($thiz.depth__I() === 5)) {
        $thiz.display5$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
        $thiz.display5__AO().set((31 & ((oldIndex >>> 25) | 0)), $thiz.display4__AO());
        $thiz.depth$und$eq__I__V(((1 + $thiz.depth__I()) | 0))
      };
      $thiz.display4$und$eq__AO__V($asArrayOf_O($thiz.display5__AO().get((31 & ((newIndex >>> 25) | 0))), 1));
      if (($thiz.display4__AO() === null)) {
        $thiz.display4$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]))
      };
      $thiz.display3$und$eq__AO__V($asArrayOf_O($thiz.display4__AO().get((31 & ((newIndex >>> 20) | 0))), 1));
      if (($thiz.display3__AO() === null)) {
        $thiz.display3$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]))
      };
      $thiz.display2$und$eq__AO__V($asArrayOf_O($thiz.display3__AO().get((31 & ((newIndex >>> 15) | 0))), 1));
      if (($thiz.display2__AO() === null)) {
        $thiz.display2$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]))
      };
      $thiz.display1$und$eq__AO__V($asArrayOf_O($thiz.display2__AO().get((31 & ((newIndex >>> 10) | 0))), 1));
      if (($thiz.display1__AO() === null)) {
        $thiz.display1$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]))
      };
      $thiz.display0$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]))
    } else {
      throw new $c_jl_IllegalArgumentException().init___()
    }
  }
}
function $f_sci_VectorPointer__gotoPosWritable1__I__I__I__V($thiz, oldIndex, newIndex, xor) {
  if ((xor < 32)) {
    var a = $thiz.display0__AO();
    $thiz.display0$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a))
  } else if ((xor < 1024)) {
    var a$1 = $thiz.display1__AO();
    $thiz.display1$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$1));
    $thiz.display1__AO().set((31 & ((oldIndex >>> 5) | 0)), $thiz.display0__AO());
    var array = $thiz.display1__AO();
    var index = (31 & ((newIndex >>> 5) | 0));
    $thiz.display0$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array, index))
  } else if ((xor < 32768)) {
    var a$2 = $thiz.display1__AO();
    $thiz.display1$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$2));
    var a$3 = $thiz.display2__AO();
    $thiz.display2$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$3));
    $thiz.display1__AO().set((31 & ((oldIndex >>> 5) | 0)), $thiz.display0__AO());
    $thiz.display2__AO().set((31 & ((oldIndex >>> 10) | 0)), $thiz.display1__AO());
    var array$1 = $thiz.display2__AO();
    var index$1 = (31 & ((newIndex >>> 10) | 0));
    $thiz.display1$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$1, index$1));
    var array$2 = $thiz.display1__AO();
    var index$2 = (31 & ((newIndex >>> 5) | 0));
    $thiz.display0$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$2, index$2))
  } else if ((xor < 1048576)) {
    var a$4 = $thiz.display1__AO();
    $thiz.display1$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$4));
    var a$5 = $thiz.display2__AO();
    $thiz.display2$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$5));
    var a$6 = $thiz.display3__AO();
    $thiz.display3$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$6));
    $thiz.display1__AO().set((31 & ((oldIndex >>> 5) | 0)), $thiz.display0__AO());
    $thiz.display2__AO().set((31 & ((oldIndex >>> 10) | 0)), $thiz.display1__AO());
    $thiz.display3__AO().set((31 & ((oldIndex >>> 15) | 0)), $thiz.display2__AO());
    var array$3 = $thiz.display3__AO();
    var index$3 = (31 & ((newIndex >>> 15) | 0));
    $thiz.display2$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$3, index$3));
    var array$4 = $thiz.display2__AO();
    var index$4 = (31 & ((newIndex >>> 10) | 0));
    $thiz.display1$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$4, index$4));
    var array$5 = $thiz.display1__AO();
    var index$5 = (31 & ((newIndex >>> 5) | 0));
    $thiz.display0$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$5, index$5))
  } else if ((xor < 33554432)) {
    var a$7 = $thiz.display1__AO();
    $thiz.display1$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$7));
    var a$8 = $thiz.display2__AO();
    $thiz.display2$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$8));
    var a$9 = $thiz.display3__AO();
    $thiz.display3$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$9));
    var a$10 = $thiz.display4__AO();
    $thiz.display4$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$10));
    $thiz.display1__AO().set((31 & ((oldIndex >>> 5) | 0)), $thiz.display0__AO());
    $thiz.display2__AO().set((31 & ((oldIndex >>> 10) | 0)), $thiz.display1__AO());
    $thiz.display3__AO().set((31 & ((oldIndex >>> 15) | 0)), $thiz.display2__AO());
    $thiz.display4__AO().set((31 & ((oldIndex >>> 20) | 0)), $thiz.display3__AO());
    var array$6 = $thiz.display4__AO();
    var index$6 = (31 & ((newIndex >>> 20) | 0));
    $thiz.display3$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$6, index$6));
    var array$7 = $thiz.display3__AO();
    var index$7 = (31 & ((newIndex >>> 15) | 0));
    $thiz.display2$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$7, index$7));
    var array$8 = $thiz.display2__AO();
    var index$8 = (31 & ((newIndex >>> 10) | 0));
    $thiz.display1$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$8, index$8));
    var array$9 = $thiz.display1__AO();
    var index$9 = (31 & ((newIndex >>> 5) | 0));
    $thiz.display0$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$9, index$9))
  } else if ((xor < 1073741824)) {
    var a$11 = $thiz.display1__AO();
    $thiz.display1$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$11));
    var a$12 = $thiz.display2__AO();
    $thiz.display2$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$12));
    var a$13 = $thiz.display3__AO();
    $thiz.display3$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$13));
    var a$14 = $thiz.display4__AO();
    $thiz.display4$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$14));
    var a$15 = $thiz.display5__AO();
    $thiz.display5$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$15));
    $thiz.display1__AO().set((31 & ((oldIndex >>> 5) | 0)), $thiz.display0__AO());
    $thiz.display2__AO().set((31 & ((oldIndex >>> 10) | 0)), $thiz.display1__AO());
    $thiz.display3__AO().set((31 & ((oldIndex >>> 15) | 0)), $thiz.display2__AO());
    $thiz.display4__AO().set((31 & ((oldIndex >>> 20) | 0)), $thiz.display3__AO());
    $thiz.display5__AO().set((31 & ((oldIndex >>> 25) | 0)), $thiz.display4__AO());
    var array$10 = $thiz.display5__AO();
    var index$10 = (31 & ((newIndex >>> 25) | 0));
    $thiz.display4$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$10, index$10));
    var array$11 = $thiz.display4__AO();
    var index$11 = (31 & ((newIndex >>> 20) | 0));
    $thiz.display3$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$11, index$11));
    var array$12 = $thiz.display3__AO();
    var index$12 = (31 & ((newIndex >>> 15) | 0));
    $thiz.display2$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$12, index$12));
    var array$13 = $thiz.display2__AO();
    var index$13 = (31 & ((newIndex >>> 10) | 0));
    $thiz.display1$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$13, index$13));
    var array$14 = $thiz.display1__AO();
    var index$14 = (31 & ((newIndex >>> 5) | 0));
    $thiz.display0$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$14, index$14))
  } else {
    throw new $c_jl_IllegalArgumentException().init___()
  }
}
function $f_sci_VectorPointer__copyRange__AO__I__I__AO($thiz, array, oldLeft, newLeft) {
  var elems = $newArrayObject($d_O.getArrayOf(), [32]);
  $systemArraycopy(array, oldLeft, elems, newLeft, ((32 - ((newLeft > oldLeft) ? newLeft : oldLeft)) | 0));
  return elems
}
function $f_sci_VectorPointer__gotoPos__I__I__V($thiz, index, xor) {
  if ((!(xor < 32))) {
    if ((xor < 1024)) {
      $thiz.display0$und$eq__AO__V($asArrayOf_O($thiz.display1__AO().get((31 & ((index >>> 5) | 0))), 1))
    } else if ((xor < 32768)) {
      $thiz.display1$und$eq__AO__V($asArrayOf_O($thiz.display2__AO().get((31 & ((index >>> 10) | 0))), 1));
      $thiz.display0$und$eq__AO__V($asArrayOf_O($thiz.display1__AO().get((31 & ((index >>> 5) | 0))), 1))
    } else if ((xor < 1048576)) {
      $thiz.display2$und$eq__AO__V($asArrayOf_O($thiz.display3__AO().get((31 & ((index >>> 15) | 0))), 1));
      $thiz.display1$und$eq__AO__V($asArrayOf_O($thiz.display2__AO().get((31 & ((index >>> 10) | 0))), 1));
      $thiz.display0$und$eq__AO__V($asArrayOf_O($thiz.display1__AO().get((31 & ((index >>> 5) | 0))), 1))
    } else if ((xor < 33554432)) {
      $thiz.display3$und$eq__AO__V($asArrayOf_O($thiz.display4__AO().get((31 & ((index >>> 20) | 0))), 1));
      $thiz.display2$und$eq__AO__V($asArrayOf_O($thiz.display3__AO().get((31 & ((index >>> 15) | 0))), 1));
      $thiz.display1$und$eq__AO__V($asArrayOf_O($thiz.display2__AO().get((31 & ((index >>> 10) | 0))), 1));
      $thiz.display0$und$eq__AO__V($asArrayOf_O($thiz.display1__AO().get((31 & ((index >>> 5) | 0))), 1))
    } else if ((xor < 1073741824)) {
      $thiz.display4$und$eq__AO__V($asArrayOf_O($thiz.display5__AO().get((31 & ((index >>> 25) | 0))), 1));
      $thiz.display3$und$eq__AO__V($asArrayOf_O($thiz.display4__AO().get((31 & ((index >>> 20) | 0))), 1));
      $thiz.display2$und$eq__AO__V($asArrayOf_O($thiz.display3__AO().get((31 & ((index >>> 15) | 0))), 1));
      $thiz.display1$und$eq__AO__V($asArrayOf_O($thiz.display2__AO().get((31 & ((index >>> 10) | 0))), 1));
      $thiz.display0$und$eq__AO__V($asArrayOf_O($thiz.display1__AO().get((31 & ((index >>> 5) | 0))), 1))
    } else {
      throw new $c_jl_IllegalArgumentException().init___()
    }
  }
}
function $f_sci_VectorPointer__gotoPosWritable0__I__I__V($thiz, newIndex, xor) {
  var x1 = (((-1) + $thiz.depth__I()) | 0);
  switch (x1) {
    case 5: {
      var a = $thiz.display5__AO();
      $thiz.display5$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a));
      var array = $thiz.display5__AO();
      var index = (31 & ((newIndex >>> 25) | 0));
      $thiz.display4$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array, index));
      var array$1 = $thiz.display4__AO();
      var index$1 = (31 & ((newIndex >>> 20) | 0));
      $thiz.display3$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$1, index$1));
      var array$2 = $thiz.display3__AO();
      var index$2 = (31 & ((newIndex >>> 15) | 0));
      $thiz.display2$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$2, index$2));
      var array$3 = $thiz.display2__AO();
      var index$3 = (31 & ((newIndex >>> 10) | 0));
      $thiz.display1$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$3, index$3));
      var array$4 = $thiz.display1__AO();
      var index$4 = (31 & ((newIndex >>> 5) | 0));
      $thiz.display0$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$4, index$4));
      break
    }
    case 4: {
      var a$1 = $thiz.display4__AO();
      $thiz.display4$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$1));
      var array$5 = $thiz.display4__AO();
      var index$5 = (31 & ((newIndex >>> 20) | 0));
      $thiz.display3$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$5, index$5));
      var array$6 = $thiz.display3__AO();
      var index$6 = (31 & ((newIndex >>> 15) | 0));
      $thiz.display2$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$6, index$6));
      var array$7 = $thiz.display2__AO();
      var index$7 = (31 & ((newIndex >>> 10) | 0));
      $thiz.display1$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$7, index$7));
      var array$8 = $thiz.display1__AO();
      var index$8 = (31 & ((newIndex >>> 5) | 0));
      $thiz.display0$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$8, index$8));
      break
    }
    case 3: {
      var a$2 = $thiz.display3__AO();
      $thiz.display3$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$2));
      var array$9 = $thiz.display3__AO();
      var index$9 = (31 & ((newIndex >>> 15) | 0));
      $thiz.display2$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$9, index$9));
      var array$10 = $thiz.display2__AO();
      var index$10 = (31 & ((newIndex >>> 10) | 0));
      $thiz.display1$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$10, index$10));
      var array$11 = $thiz.display1__AO();
      var index$11 = (31 & ((newIndex >>> 5) | 0));
      $thiz.display0$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$11, index$11));
      break
    }
    case 2: {
      var a$3 = $thiz.display2__AO();
      $thiz.display2$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$3));
      var array$12 = $thiz.display2__AO();
      var index$12 = (31 & ((newIndex >>> 10) | 0));
      $thiz.display1$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$12, index$12));
      var array$13 = $thiz.display1__AO();
      var index$13 = (31 & ((newIndex >>> 5) | 0));
      $thiz.display0$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$13, index$13));
      break
    }
    case 1: {
      var a$4 = $thiz.display1__AO();
      $thiz.display1$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$4));
      var array$14 = $thiz.display1__AO();
      var index$14 = (31 & ((newIndex >>> 5) | 0));
      $thiz.display0$und$eq__AO__V($f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array$14, index$14));
      break
    }
    case 0: {
      var a$5 = $thiz.display0__AO();
      $thiz.display0$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$5));
      break
    }
    default: {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
}
function $f_sci_VectorPointer__stabilize__I__V($thiz, index) {
  var x1 = (((-1) + $thiz.depth__I()) | 0);
  switch (x1) {
    case 5: {
      var a = $thiz.display5__AO();
      $thiz.display5$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a));
      var a$1 = $thiz.display4__AO();
      $thiz.display4$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$1));
      var a$2 = $thiz.display3__AO();
      $thiz.display3$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$2));
      var a$3 = $thiz.display2__AO();
      $thiz.display2$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$3));
      var a$4 = $thiz.display1__AO();
      $thiz.display1$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$4));
      $thiz.display5__AO().set((31 & ((index >>> 25) | 0)), $thiz.display4__AO());
      $thiz.display4__AO().set((31 & ((index >>> 20) | 0)), $thiz.display3__AO());
      $thiz.display3__AO().set((31 & ((index >>> 15) | 0)), $thiz.display2__AO());
      $thiz.display2__AO().set((31 & ((index >>> 10) | 0)), $thiz.display1__AO());
      $thiz.display1__AO().set((31 & ((index >>> 5) | 0)), $thiz.display0__AO());
      break
    }
    case 4: {
      var a$5 = $thiz.display4__AO();
      $thiz.display4$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$5));
      var a$6 = $thiz.display3__AO();
      $thiz.display3$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$6));
      var a$7 = $thiz.display2__AO();
      $thiz.display2$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$7));
      var a$8 = $thiz.display1__AO();
      $thiz.display1$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$8));
      $thiz.display4__AO().set((31 & ((index >>> 20) | 0)), $thiz.display3__AO());
      $thiz.display3__AO().set((31 & ((index >>> 15) | 0)), $thiz.display2__AO());
      $thiz.display2__AO().set((31 & ((index >>> 10) | 0)), $thiz.display1__AO());
      $thiz.display1__AO().set((31 & ((index >>> 5) | 0)), $thiz.display0__AO());
      break
    }
    case 3: {
      var a$9 = $thiz.display3__AO();
      $thiz.display3$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$9));
      var a$10 = $thiz.display2__AO();
      $thiz.display2$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$10));
      var a$11 = $thiz.display1__AO();
      $thiz.display1$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$11));
      $thiz.display3__AO().set((31 & ((index >>> 15) | 0)), $thiz.display2__AO());
      $thiz.display2__AO().set((31 & ((index >>> 10) | 0)), $thiz.display1__AO());
      $thiz.display1__AO().set((31 & ((index >>> 5) | 0)), $thiz.display0__AO());
      break
    }
    case 2: {
      var a$12 = $thiz.display2__AO();
      $thiz.display2$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$12));
      var a$13 = $thiz.display1__AO();
      $thiz.display1$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$13));
      $thiz.display2__AO().set((31 & ((index >>> 10) | 0)), $thiz.display1__AO());
      $thiz.display1__AO().set((31 & ((index >>> 5) | 0)), $thiz.display0__AO());
      break
    }
    case 1: {
      var a$14 = $thiz.display1__AO();
      $thiz.display1$und$eq__AO__V($f_sci_VectorPointer__copyOf__AO__AO($thiz, a$14));
      $thiz.display1__AO().set((31 & ((index >>> 5) | 0)), $thiz.display0__AO());
      break
    }
    case 0: {
      break
    }
    default: {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
}
function $f_sci_VectorPointer__nullSlotAndCopy__AO__I__AO($thiz, array, index) {
  var x = array.get(index);
  array.set(index, null);
  var a = $asArrayOf_O(x, 1);
  return $f_sci_VectorPointer__copyOf__AO__AO($thiz, a)
}
function $f_sci_VectorPointer__initFrom__sci_VectorPointer__I__V($thiz, that, depth) {
  $thiz.depth$und$eq__I__V(depth);
  var x1 = (((-1) + depth) | 0);
  switch (x1) {
    case (-1): {
      break
    }
    case 0: {
      $thiz.display0$und$eq__AO__V(that.display0__AO());
      break
    }
    case 1: {
      $thiz.display1$und$eq__AO__V(that.display1__AO());
      $thiz.display0$und$eq__AO__V(that.display0__AO());
      break
    }
    case 2: {
      $thiz.display2$und$eq__AO__V(that.display2__AO());
      $thiz.display1$und$eq__AO__V(that.display1__AO());
      $thiz.display0$und$eq__AO__V(that.display0__AO());
      break
    }
    case 3: {
      $thiz.display3$und$eq__AO__V(that.display3__AO());
      $thiz.display2$und$eq__AO__V(that.display2__AO());
      $thiz.display1$und$eq__AO__V(that.display1__AO());
      $thiz.display0$und$eq__AO__V(that.display0__AO());
      break
    }
    case 4: {
      $thiz.display4$und$eq__AO__V(that.display4__AO());
      $thiz.display3$und$eq__AO__V(that.display3__AO());
      $thiz.display2$und$eq__AO__V(that.display2__AO());
      $thiz.display1$und$eq__AO__V(that.display1__AO());
      $thiz.display0$und$eq__AO__V(that.display0__AO());
      break
    }
    case 5: {
      $thiz.display5$und$eq__AO__V(that.display5__AO());
      $thiz.display4$und$eq__AO__V(that.display4__AO());
      $thiz.display3$und$eq__AO__V(that.display3__AO());
      $thiz.display2$und$eq__AO__V(that.display2__AO());
      $thiz.display1$und$eq__AO__V(that.display1__AO());
      $thiz.display0$und$eq__AO__V(that.display0__AO());
      break
    }
    default: {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
}
function $f_sci_VectorPointer__gotoNextBlockStartWritable__I__I__V($thiz, index, xor) {
  if ((xor < 1024)) {
    if (($thiz.depth__I() === 1)) {
      $thiz.display1$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
      $thiz.display1__AO().set(0, $thiz.display0__AO());
      $thiz.depth$und$eq__I__V(((1 + $thiz.depth__I()) | 0))
    };
    $thiz.display0$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
    $thiz.display1__AO().set((31 & ((index >>> 5) | 0)), $thiz.display0__AO())
  } else if ((xor < 32768)) {
    if (($thiz.depth__I() === 2)) {
      $thiz.display2$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
      $thiz.display2__AO().set(0, $thiz.display1__AO());
      $thiz.depth$und$eq__I__V(((1 + $thiz.depth__I()) | 0))
    };
    $thiz.display0$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
    $thiz.display1$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
    $thiz.display1__AO().set((31 & ((index >>> 5) | 0)), $thiz.display0__AO());
    $thiz.display2__AO().set((31 & ((index >>> 10) | 0)), $thiz.display1__AO())
  } else if ((xor < 1048576)) {
    if (($thiz.depth__I() === 3)) {
      $thiz.display3$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
      $thiz.display3__AO().set(0, $thiz.display2__AO());
      $thiz.depth$und$eq__I__V(((1 + $thiz.depth__I()) | 0))
    };
    $thiz.display0$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
    $thiz.display1$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
    $thiz.display2$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
    $thiz.display1__AO().set((31 & ((index >>> 5) | 0)), $thiz.display0__AO());
    $thiz.display2__AO().set((31 & ((index >>> 10) | 0)), $thiz.display1__AO());
    $thiz.display3__AO().set((31 & ((index >>> 15) | 0)), $thiz.display2__AO())
  } else if ((xor < 33554432)) {
    if (($thiz.depth__I() === 4)) {
      $thiz.display4$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
      $thiz.display4__AO().set(0, $thiz.display3__AO());
      $thiz.depth$und$eq__I__V(((1 + $thiz.depth__I()) | 0))
    };
    $thiz.display0$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
    $thiz.display1$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
    $thiz.display2$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
    $thiz.display3$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
    $thiz.display1__AO().set((31 & ((index >>> 5) | 0)), $thiz.display0__AO());
    $thiz.display2__AO().set((31 & ((index >>> 10) | 0)), $thiz.display1__AO());
    $thiz.display3__AO().set((31 & ((index >>> 15) | 0)), $thiz.display2__AO());
    $thiz.display4__AO().set((31 & ((index >>> 20) | 0)), $thiz.display3__AO())
  } else if ((xor < 1073741824)) {
    if (($thiz.depth__I() === 5)) {
      $thiz.display5$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
      $thiz.display5__AO().set(0, $thiz.display4__AO());
      $thiz.depth$und$eq__I__V(((1 + $thiz.depth__I()) | 0))
    };
    $thiz.display0$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
    $thiz.display1$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
    $thiz.display2$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
    $thiz.display3$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
    $thiz.display4$und$eq__AO__V($newArrayObject($d_O.getArrayOf(), [32]));
    $thiz.display1__AO().set((31 & ((index >>> 5) | 0)), $thiz.display0__AO());
    $thiz.display2__AO().set((31 & ((index >>> 10) | 0)), $thiz.display1__AO());
    $thiz.display3__AO().set((31 & ((index >>> 15) | 0)), $thiz.display2__AO());
    $thiz.display4__AO().set((31 & ((index >>> 20) | 0)), $thiz.display3__AO());
    $thiz.display5__AO().set((31 & ((index >>> 25) | 0)), $thiz.display4__AO())
  } else {
    throw new $c_jl_IllegalArgumentException().init___()
  }
}
function $f_scm_FlatHashTable$HashUtils__elemToEntry__O__O($thiz, elem) {
  return ((elem === null) ? $m_scm_FlatHashTable$NullSentinel$() : elem)
}
function $f_scm_FlatHashTable$HashUtils__entryToElem__O__O($thiz, entry) {
  return ((entry === $m_scm_FlatHashTable$NullSentinel$()) ? null : entry)
}
function $f_scm_FlatHashTable$HashUtils__improve__I__I__I($thiz, hcode, seed) {
  var i = $m_s_util_hashing_package$().byteswap32__I__I(hcode);
  return (((i >>> seed) | 0) | (i << ((-seed) | 0)))
}
function $is_scm_HashEntry(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.scm_HashEntry)))
}
function $as_scm_HashEntry(obj) {
  return (($is_scm_HashEntry(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.HashEntry"))
}
function $isArrayOf_scm_HashEntry(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_HashEntry)))
}
function $asArrayOf_scm_HashEntry(obj, depth) {
  return (($isArrayOf_scm_HashEntry(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.HashEntry;", depth))
}
var $d_scm_HashEntry = new $TypeData().initClass({
  scm_HashEntry: 0
}, true, "scala.collection.mutable.HashEntry", {
  scm_HashEntry: 1
});
function $f_scm_HashTable$HashUtils__improve__I__I__I($thiz, hcode, seed) {
  var i = $m_s_util_hashing_package$().byteswap32__I__I(hcode);
  return (((i >>> seed) | 0) | (i << ((-seed) | 0)))
}
/** @constructor */
function $c_Lamf_MessageStyles$() {
  $c_O.call(this);
  this.RAML$1 = null;
  this.OAS$1 = null;
  this.ASYNC$1 = null;
  this.AMF$1 = null
}
$c_Lamf_MessageStyles$.prototype = new $h_O();
$c_Lamf_MessageStyles$.prototype.constructor = $c_Lamf_MessageStyles$;
/** @constructor */
function $h_Lamf_MessageStyles$() {
  /*<skip>*/
}
$h_Lamf_MessageStyles$.prototype = $c_Lamf_MessageStyles$.prototype;
$c_Lamf_MessageStyles$.prototype.init___ = (function() {
  $n_Lamf_MessageStyles$ = this;
  this.RAML$1 = $m_Lamf_RAMLStyle$();
  this.OAS$1 = $m_Lamf_OASStyle$();
  this.ASYNC$1 = $m_Lamf_AsyncStyle$();
  this.AMF$1 = $m_Lamf_AMFStyle$();
  return this
});
$c_Lamf_MessageStyles$.prototype.$$js$exported$prop$AMF__O = (function() {
  return this.AMF$1
});
$c_Lamf_MessageStyles$.prototype.$$js$exported$prop$ASYNC__O = (function() {
  return this.ASYNC$1
});
$c_Lamf_MessageStyles$.prototype.$$js$exported$prop$OAS__O = (function() {
  return this.OAS$1
});
$c_Lamf_MessageStyles$.prototype.$$js$exported$prop$RAML__O = (function() {
  return this.RAML$1
});
Object.defineProperty($c_Lamf_MessageStyles$.prototype, "AMF", {
  "get": (function() {
    return this.$$js$exported$prop$AMF__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_MessageStyles$.prototype, "ASYNC", {
  "get": (function() {
    return this.$$js$exported$prop$ASYNC__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_MessageStyles$.prototype, "OAS", {
  "get": (function() {
    return this.$$js$exported$prop$OAS__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_MessageStyles$.prototype, "RAML", {
  "get": (function() {
    return this.$$js$exported$prop$RAML__O()
  }),
  "configurable": true
});
var $d_Lamf_MessageStyles$ = new $TypeData().initClass({
  Lamf_MessageStyles$: 0
}, false, "amf.MessageStyles$", {
  Lamf_MessageStyles$: 1,
  O: 1
});
$c_Lamf_MessageStyles$.prototype.$classData = $d_Lamf_MessageStyles$;
var $n_Lamf_MessageStyles$ = (void 0);
function $m_Lamf_MessageStyles$() {
  if ((!$n_Lamf_MessageStyles$)) {
    $n_Lamf_MessageStyles$ = new $c_Lamf_MessageStyles$().init___()
  };
  return $n_Lamf_MessageStyles$
}
/** @constructor */
function $c_Lamf_ProfileNames$() {
  $c_O.call(this);
  this.specProfiles$1 = null;
  this.AMF$1 = null;
  this.OAS$1 = null;
  this.OAS20$1 = null;
  this.OAS30$1 = null;
  this.RAML$1 = null;
  this.RAML10$1 = null;
  this.RAML08$1 = null;
  this.ASYNC$1 = null;
  this.ASYNC20$1 = null;
  this.AML$1 = null;
  this.PAYLOAD$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_ProfileNames$.prototype = new $h_O();
$c_Lamf_ProfileNames$.prototype.constructor = $c_Lamf_ProfileNames$;
/** @constructor */
function $h_Lamf_ProfileNames$() {
  /*<skip>*/
}
$h_Lamf_ProfileNames$.prototype = $c_Lamf_ProfileNames$.prototype;
$c_Lamf_ProfileNames$.prototype.init___ = (function() {
  $n_Lamf_ProfileNames$ = this;
  this.AMF$1 = $m_Lamf_AmfProfile$();
  this.OAS$1 = $m_Lamf_OasProfile$();
  this.OAS20$1 = $m_Lamf_Oas20Profile$();
  this.OAS30$1 = $m_Lamf_Oas30Profile$();
  this.RAML$1 = $m_Lamf_RamlProfile$();
  this.RAML10$1 = $m_Lamf_Raml10Profile$();
  this.RAML08$1 = $m_Lamf_Raml08Profile$();
  this.ASYNC$1 = $m_Lamf_AsyncProfile$();
  this.ASYNC20$1 = $m_Lamf_Async20Profile$();
  this.AML$1 = $m_Lamf_AmlProfile$();
  this.PAYLOAD$1 = $m_Lamf_PayloadProfile$();
  return this
});
$c_Lamf_ProfileNames$.prototype.$$js$exported$prop$AMF__O = (function() {
  return this.AMF$1
});
$c_Lamf_ProfileNames$.prototype.$$js$exported$prop$AML__O = (function() {
  return this.AML$1
});
$c_Lamf_ProfileNames$.prototype.$$js$exported$prop$ASYNC__O = (function() {
  return this.ASYNC$1
});
$c_Lamf_ProfileNames$.prototype.$$js$exported$prop$PAYLOAD__O = (function() {
  return this.PAYLOAD$1
});
$c_Lamf_ProfileNames$.prototype.$$js$exported$prop$OAS20__O = (function() {
  return this.OAS20$1
});
$c_Lamf_ProfileNames$.prototype.specProfiles$lzycompute__p1__sc_Seq = (function() {
  if ((!this.bitmap$0$1)) {
    var jsx$1 = $m_sc_Seq$();
    var array = [$m_Lamf_AmfProfile$(), $m_Lamf_OasProfile$(), $m_Lamf_Oas20Profile$(), $m_Lamf_Oas30Profile$(), $m_Lamf_RamlProfile$(), $m_Lamf_Raml08Profile$(), $m_Lamf_Raml10Profile$(), $m_Lamf_AsyncProfile$(), $m_Lamf_Async20Profile$()];
    this.specProfiles$1 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
    this.bitmap$0$1 = true
  };
  return this.specProfiles$1
});
$c_Lamf_ProfileNames$.prototype.$$js$exported$prop$RAML08__O = (function() {
  return this.RAML08$1
});
$c_Lamf_ProfileNames$.prototype.$$js$exported$prop$OAS30__O = (function() {
  return this.OAS30$1
});
$c_Lamf_ProfileNames$.prototype.$$js$exported$prop$ASYNC20__O = (function() {
  return this.ASYNC20$1
});
$c_Lamf_ProfileNames$.prototype.specProfiles__sc_Seq = (function() {
  return ((!this.bitmap$0$1) ? this.specProfiles$lzycompute__p1__sc_Seq() : this.specProfiles$1)
});
$c_Lamf_ProfileNames$.prototype.$$js$exported$prop$RAML10__O = (function() {
  return this.RAML10$1
});
$c_Lamf_ProfileNames$.prototype.$$js$exported$prop$OAS__O = (function() {
  return this.OAS$1
});
$c_Lamf_ProfileNames$.prototype.$$js$exported$prop$RAML__O = (function() {
  return this.RAML$1
});
$c_Lamf_ProfileNames$.prototype.$$js$exported$prop$specProfiles__O = (function() {
  return this.specProfiles__sc_Seq()
});
Object.defineProperty($c_Lamf_ProfileNames$.prototype, "specProfiles", {
  "get": (function() {
    return this.$$js$exported$prop$specProfiles__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_ProfileNames$.prototype, "PAYLOAD", {
  "get": (function() {
    return this.$$js$exported$prop$PAYLOAD__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_ProfileNames$.prototype, "AML", {
  "get": (function() {
    return this.$$js$exported$prop$AML__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_ProfileNames$.prototype, "ASYNC20", {
  "get": (function() {
    return this.$$js$exported$prop$ASYNC20__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_ProfileNames$.prototype, "ASYNC", {
  "get": (function() {
    return this.$$js$exported$prop$ASYNC__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_ProfileNames$.prototype, "RAML08", {
  "get": (function() {
    return this.$$js$exported$prop$RAML08__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_ProfileNames$.prototype, "RAML10", {
  "get": (function() {
    return this.$$js$exported$prop$RAML10__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_ProfileNames$.prototype, "RAML", {
  "get": (function() {
    return this.$$js$exported$prop$RAML__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_ProfileNames$.prototype, "OAS30", {
  "get": (function() {
    return this.$$js$exported$prop$OAS30__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_ProfileNames$.prototype, "OAS20", {
  "get": (function() {
    return this.$$js$exported$prop$OAS20__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_ProfileNames$.prototype, "OAS", {
  "get": (function() {
    return this.$$js$exported$prop$OAS__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_ProfileNames$.prototype, "AMF", {
  "get": (function() {
    return this.$$js$exported$prop$AMF__O()
  }),
  "configurable": true
});
var $d_Lamf_ProfileNames$ = new $TypeData().initClass({
  Lamf_ProfileNames$: 0
}, false, "amf.ProfileNames$", {
  Lamf_ProfileNames$: 1,
  O: 1
});
$c_Lamf_ProfileNames$.prototype.$classData = $d_Lamf_ProfileNames$;
var $n_Lamf_ProfileNames$ = (void 0);
function $m_Lamf_ProfileNames$() {
  if ((!$n_Lamf_ProfileNames$)) {
    $n_Lamf_ProfileNames$ = new $c_Lamf_ProfileNames$().init___()
  };
  return $n_Lamf_ProfileNames$
}
/** @constructor */
function $c_Lamf_client_CoreWrapper$() {
  $c_O.call(this)
}
$c_Lamf_client_CoreWrapper$.prototype = new $h_O();
$c_Lamf_client_CoreWrapper$.prototype.constructor = $c_Lamf_client_CoreWrapper$;
/** @constructor */
function $h_Lamf_client_CoreWrapper$() {
  /*<skip>*/
}
$h_Lamf_client_CoreWrapper$.prototype = $c_Lamf_client_CoreWrapper$.prototype;
$c_Lamf_client_CoreWrapper$.prototype.$$js$exported$meth$loadValidationProfile__T__Lamf_client_environment_Environment__O = (function(url, env) {
  $m_Lamf_Core$();
  return $m_Lamf_client_validate_Validator$().loadValidationProfile__T__Lamf_client_environment_Environment__sjs_js_Promise(url, env)
});
$c_Lamf_client_CoreWrapper$.prototype.init___ = (function() {
  return this
});
$c_Lamf_client_CoreWrapper$.prototype.$$js$exported$meth$validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__O = (function(model, profileName, messageStyle, env) {
  $m_Lamf_Core$();
  return $m_Lamf_client_validate_Validator$().validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__Z__sjs_js_Promise(model, profileName, messageStyle, env, false)
});
$c_Lamf_client_CoreWrapper$.prototype.$$js$exported$meth$registerPayloadPlugin__Lamf_client_plugins_ClientAMFPayloadValidationPlugin__O = (function(plugin) {
  this.registerPayloadPlugin__Lamf_client_plugins_ClientAMFPayloadValidationPlugin__V(plugin)
});
$c_Lamf_client_CoreWrapper$.prototype.$$js$exported$meth$generator__T__T__O = (function(vendor, mediaType) {
  $m_Lamf_Core$();
  return new $c_Lamf_client_render_Renderer().init___T__T__s_Option(vendor, mediaType, $m_s_None$())
});
$c_Lamf_client_CoreWrapper$.prototype.$$js$exported$meth$init__O = (function() {
  return $m_Lamf_Core$().init__sjs_js_Promise()
});
$c_Lamf_client_CoreWrapper$.prototype.$$js$exported$meth$parser__T__T__O = (function(vendor, mediaType) {
  $m_Lamf_Core$();
  return new $c_Lamf_client_parse_Parser().init___T__T__s_Option(vendor, mediaType, $m_s_None$())
});
$c_Lamf_client_CoreWrapper$.prototype.$$js$exported$meth$validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__O = (function(model, profileName, messageStyle) {
  $m_Lamf_Core$();
  var env = $m_Lamf_client_environment_DefaultEnvironment$().apply__Lamf_client_environment_Environment();
  return $m_Lamf_client_validate_Validator$().validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__Z__sjs_js_Promise(model, profileName, messageStyle, env, false)
});
$c_Lamf_client_CoreWrapper$.prototype.$$js$exported$meth$validate$default$3__Lamf_MessageStyle = (function() {
  return $m_Lamf_AMFStyle$()
});
$c_Lamf_client_CoreWrapper$.prototype.$$js$exported$meth$loadValidationProfile__T__O = (function(url) {
  $m_Lamf_Core$();
  var env = $m_Lamf_client_environment_DefaultEnvironment$().apply__Lamf_client_environment_Environment();
  return $m_Lamf_client_validate_Validator$().loadValidationProfile__T__Lamf_client_environment_Environment__sjs_js_Promise(url, env)
});
$c_Lamf_client_CoreWrapper$.prototype.$$js$exported$meth$registerNamespace__T__T__O = (function(alias, prefix) {
  return $m_Lamf_Core$().registerNamespace__T__T__Z(alias, prefix)
});
$c_Lamf_client_CoreWrapper$.prototype.$$js$exported$meth$registerPlugin__Lamf_client_plugins_AMFPlugin__O = (function(plugin) {
  $m_Lamf_Core$();
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V(plugin)
});
$c_Lamf_client_CoreWrapper$.prototype.registerPayloadPlugin__Lamf_client_plugins_ClientAMFPayloadValidationPlugin__V = (function(plugin) {
  $m_Lamf_Core$();
  var plugin$1 = new $c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2().init___Lamf_client_plugins_ClientAMFPayloadValidationPlugin(plugin);
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V(plugin$1)
});
$c_Lamf_client_CoreWrapper$.prototype.$$js$exported$meth$emitShapesGraph__Lamf_ProfileName__O = (function(profileName) {
  $m_Lamf_Core$();
  var this$3 = $m_Lamf_core_services_RuntimeValidator$();
  return this$3.validator__p1__Lamf_core_services_RuntimeValidator().emitShapesGraph__Lamf_ProfileName__T(profileName)
});
$c_Lamf_client_CoreWrapper$.prototype.$$js$exported$meth$resolver__T__O = (function(vendor) {
  $m_Lamf_Core$();
  return new $c_Lamf_client_resolve_Resolver().init___T(vendor)
});
$c_Lamf_client_CoreWrapper$.prototype.registerPayloadPlugin = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$registerPayloadPlugin__Lamf_client_plugins_ClientAMFPayloadValidationPlugin__O(prep)
});
$c_Lamf_client_CoreWrapper$.prototype.registerPlugin = (function(arg) {
  var prep = $as_Lamf_client_plugins_AMFPlugin(arg);
  return this.$$js$exported$meth$registerPlugin__Lamf_client_plugins_AMFPlugin__O(prep)
});
$c_Lamf_client_CoreWrapper$.prototype.registerNamespace = (function(arg, arg$2) {
  var prep = $as_T(arg);
  var prep$2 = $as_T(arg$2);
  return this.$$js$exported$meth$registerNamespace__T__T__O(prep, prep$2)
});
$c_Lamf_client_CoreWrapper$.prototype.emitShapesGraph = (function(arg) {
  var prep = $as_Lamf_ProfileName(arg);
  return this.$$js$exported$meth$emitShapesGraph__Lamf_ProfileName__O(prep)
});
$c_Lamf_client_CoreWrapper$.prototype.loadValidationProfile = (function(arg) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 1;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      var prep = $as_T(arg);
      return this.$$js$exported$meth$loadValidationProfile__T__O(prep);
      break
    }
    case 1: {
      var prep$2 = $as_T(arg);
      var prep$3 = $as_Lamf_client_environment_Environment(rest[0]);
      return this.$$js$exported$meth$loadValidationProfile__T__Lamf_client_environment_Environment__O(prep$2, prep$3);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_CoreWrapper$.prototype.validate = (function(arg, arg$2) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 2;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 2: {
      var prep = $as_Lamf_client_model_document_BaseUnit(arg);
      var prep$2 = $as_Lamf_ProfileName(arg$2);
      var prep$3 = $as_Lamf_MessageStyle(rest[0]);
      var prep$4 = $as_Lamf_client_environment_Environment(rest[1]);
      return this.$$js$exported$meth$validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__O(prep, prep$2, prep$3, prep$4);
      break
    }
    case 1:
    case 0: {
      var prep$5 = $as_Lamf_client_model_document_BaseUnit(arg);
      var prep$6 = $as_Lamf_ProfileName(arg$2);
      var prep$7 = ((rest[0] === (void 0)) ? this.$$js$exported$meth$validate$default$3__Lamf_MessageStyle() : $as_Lamf_MessageStyle(rest[0]));
      return this.$$js$exported$meth$validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__O(prep$5, prep$6, prep$7);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_CoreWrapper$.prototype.resolver = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$resolver__T__O(prep)
});
$c_Lamf_client_CoreWrapper$.prototype.generator = (function(arg, arg$2) {
  var prep = $as_T(arg);
  var prep$2 = $as_T(arg$2);
  return this.$$js$exported$meth$generator__T__T__O(prep, prep$2)
});
$c_Lamf_client_CoreWrapper$.prototype.parser = (function(arg, arg$2) {
  var prep = $as_T(arg);
  var prep$2 = $as_T(arg$2);
  return this.$$js$exported$meth$parser__T__T__O(prep, prep$2)
});
$c_Lamf_client_CoreWrapper$.prototype.init = (function() {
  return this.$$js$exported$meth$init__O()
});
var $d_Lamf_client_CoreWrapper$ = new $TypeData().initClass({
  Lamf_client_CoreWrapper$: 0
}, false, "amf.client.CoreWrapper$", {
  Lamf_client_CoreWrapper$: 1,
  O: 1
});
$c_Lamf_client_CoreWrapper$.prototype.$classData = $d_Lamf_client_CoreWrapper$;
var $n_Lamf_client_CoreWrapper$ = (void 0);
function $m_Lamf_client_CoreWrapper$() {
  if ((!$n_Lamf_client_CoreWrapper$)) {
    $n_Lamf_client_CoreWrapper$ = new $c_Lamf_client_CoreWrapper$().init___()
  };
  return $n_Lamf_client_CoreWrapper$
}
/** @constructor */
function $c_Lamf_client_DocumentPluginsWrapper$() {
  $c_O.call(this);
  this.WebApi$1 = null;
  this.Vocabularies$1 = null
}
$c_Lamf_client_DocumentPluginsWrapper$.prototype = new $h_O();
$c_Lamf_client_DocumentPluginsWrapper$.prototype.constructor = $c_Lamf_client_DocumentPluginsWrapper$;
/** @constructor */
function $h_Lamf_client_DocumentPluginsWrapper$() {
  /*<skip>*/
}
$h_Lamf_client_DocumentPluginsWrapper$.prototype = $c_Lamf_client_DocumentPluginsWrapper$.prototype;
$c_Lamf_client_DocumentPluginsWrapper$.prototype.init___ = (function() {
  $n_Lamf_client_DocumentPluginsWrapper$ = this;
  this.WebApi$1 = $m_Lamf_plugins_document_WebApi$();
  this.Vocabularies$1 = $m_Lamf_plugins_document_Vocabularies$();
  return this
});
$c_Lamf_client_DocumentPluginsWrapper$.prototype.$$js$exported$prop$Vocabularies__O = (function() {
  return this.Vocabularies$1
});
$c_Lamf_client_DocumentPluginsWrapper$.prototype.$$js$exported$prop$WebApi__O = (function() {
  return this.WebApi$1
});
Object.defineProperty($c_Lamf_client_DocumentPluginsWrapper$.prototype, "Vocabularies", {
  "get": (function() {
    return this.$$js$exported$prop$Vocabularies__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_DocumentPluginsWrapper$.prototype, "WebApi", {
  "get": (function() {
    return this.$$js$exported$prop$WebApi__O()
  }),
  "configurable": true
});
var $d_Lamf_client_DocumentPluginsWrapper$ = new $TypeData().initClass({
  Lamf_client_DocumentPluginsWrapper$: 0
}, false, "amf.client.DocumentPluginsWrapper$", {
  Lamf_client_DocumentPluginsWrapper$: 1,
  O: 1
});
$c_Lamf_client_DocumentPluginsWrapper$.prototype.$classData = $d_Lamf_client_DocumentPluginsWrapper$;
var $n_Lamf_client_DocumentPluginsWrapper$ = (void 0);
function $m_Lamf_client_DocumentPluginsWrapper$() {
  if ((!$n_Lamf_client_DocumentPluginsWrapper$)) {
    $n_Lamf_client_DocumentPluginsWrapper$ = new $c_Lamf_client_DocumentPluginsWrapper$().init___()
  };
  return $n_Lamf_client_DocumentPluginsWrapper$
}
/** @constructor */
function $c_Lamf_client_FeaturesPluginsWrapper$() {
  $c_O.call(this);
  this.AMFValidation$1 = null
}
$c_Lamf_client_FeaturesPluginsWrapper$.prototype = new $h_O();
$c_Lamf_client_FeaturesPluginsWrapper$.prototype.constructor = $c_Lamf_client_FeaturesPluginsWrapper$;
/** @constructor */
function $h_Lamf_client_FeaturesPluginsWrapper$() {
  /*<skip>*/
}
$h_Lamf_client_FeaturesPluginsWrapper$.prototype = $c_Lamf_client_FeaturesPluginsWrapper$.prototype;
$c_Lamf_client_FeaturesPluginsWrapper$.prototype.init___ = (function() {
  $n_Lamf_client_FeaturesPluginsWrapper$ = this;
  this.AMFValidation$1 = $m_Lamf_plugins_features_AMFValidation$();
  return this
});
$c_Lamf_client_FeaturesPluginsWrapper$.prototype.$$js$exported$prop$AMFValidation__O = (function() {
  return this.AMFValidation$1
});
Object.defineProperty($c_Lamf_client_FeaturesPluginsWrapper$.prototype, "AMFValidation", {
  "get": (function() {
    return this.$$js$exported$prop$AMFValidation__O()
  }),
  "configurable": true
});
var $d_Lamf_client_FeaturesPluginsWrapper$ = new $TypeData().initClass({
  Lamf_client_FeaturesPluginsWrapper$: 0
}, false, "amf.client.FeaturesPluginsWrapper$", {
  Lamf_client_FeaturesPluginsWrapper$: 1,
  O: 1
});
$c_Lamf_client_FeaturesPluginsWrapper$.prototype.$classData = $d_Lamf_client_FeaturesPluginsWrapper$;
var $n_Lamf_client_FeaturesPluginsWrapper$ = (void 0);
function $m_Lamf_client_FeaturesPluginsWrapper$() {
  if ((!$n_Lamf_client_FeaturesPluginsWrapper$)) {
    $n_Lamf_client_FeaturesPluginsWrapper$ = new $c_Lamf_client_FeaturesPluginsWrapper$().init___()
  };
  return $n_Lamf_client_FeaturesPluginsWrapper$
}
/** @constructor */
function $c_Lamf_client_PluginsWrapper$() {
  $c_O.call(this);
  this.document$1 = null;
  this.features$1 = null
}
$c_Lamf_client_PluginsWrapper$.prototype = new $h_O();
$c_Lamf_client_PluginsWrapper$.prototype.constructor = $c_Lamf_client_PluginsWrapper$;
/** @constructor */
function $h_Lamf_client_PluginsWrapper$() {
  /*<skip>*/
}
$h_Lamf_client_PluginsWrapper$.prototype = $c_Lamf_client_PluginsWrapper$.prototype;
$c_Lamf_client_PluginsWrapper$.prototype.init___ = (function() {
  $n_Lamf_client_PluginsWrapper$ = this;
  this.document$1 = $m_Lamf_client_DocumentPluginsWrapper$();
  this.features$1 = $m_Lamf_client_FeaturesPluginsWrapper$();
  return this
});
$c_Lamf_client_PluginsWrapper$.prototype.$$js$exported$prop$features__O = (function() {
  return this.features$1
});
$c_Lamf_client_PluginsWrapper$.prototype.$$js$exported$prop$document__O = (function() {
  return this.document$1
});
Object.defineProperty($c_Lamf_client_PluginsWrapper$.prototype, "features", {
  "get": (function() {
    return this.$$js$exported$prop$features__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_PluginsWrapper$.prototype, "document", {
  "get": (function() {
    return this.$$js$exported$prop$document__O()
  }),
  "configurable": true
});
var $d_Lamf_client_PluginsWrapper$ = new $TypeData().initClass({
  Lamf_client_PluginsWrapper$: 0
}, false, "amf.client.PluginsWrapper$", {
  Lamf_client_PluginsWrapper$: 1,
  O: 1
});
$c_Lamf_client_PluginsWrapper$.prototype.$classData = $d_Lamf_client_PluginsWrapper$;
var $n_Lamf_client_PluginsWrapper$ = (void 0);
function $m_Lamf_client_PluginsWrapper$() {
  if ((!$n_Lamf_client_PluginsWrapper$)) {
    $n_Lamf_client_PluginsWrapper$ = new $c_Lamf_client_PluginsWrapper$().init___()
  };
  return $n_Lamf_client_PluginsWrapper$
}
/** @constructor */
function $c_Lamf_client_commands_CmdLineParser$() {
  $c_O.call(this);
  this.parser$1 = null
}
$c_Lamf_client_commands_CmdLineParser$.prototype = new $h_O();
$c_Lamf_client_commands_CmdLineParser$.prototype.constructor = $c_Lamf_client_commands_CmdLineParser$;
/** @constructor */
function $h_Lamf_client_commands_CmdLineParser$() {
  /*<skip>*/
}
$h_Lamf_client_commands_CmdLineParser$.prototype = $c_Lamf_client_commands_CmdLineParser$.prototype;
$c_Lamf_client_commands_CmdLineParser$.prototype.init___ = (function() {
  $n_Lamf_client_commands_CmdLineParser$ = this;
  this.parser$1 = new $c_Lamf_client_commands_CmdLineParser$$anon$1().init___();
  return this
});
$c_Lamf_client_commands_CmdLineParser$.prototype.parse__AT__s_Option = (function(args) {
  var jsx$10 = this.parser$1;
  var jsx$9 = $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray(args);
  var jsx$8 = $m_s_None$();
  var jsx$7 = $m_s_None$();
  var jsx$6 = $m_s_None$();
  var jsx$5 = $m_s_None$();
  var jsx$4 = $m_s_None$();
  var jsx$3 = $m_s_None$();
  var jsx$2 = $m_s_None$();
  var jsx$1 = $m_s_None$();
  var this$10 = $m_Lamf_AmfProfile$();
  return jsx$10.parse__sc_Seq__O__s_Option(jsx$9, new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(jsx$8, jsx$7, jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, false, false, true, false, jsx$1, this$10.p$1, $m_s_None$(), false, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), $m_Lamf_core_client_StdOutWriter$(), $m_Lamf_core_client_StdErrWriter$(), $m_Lamf_core_client_RuntimeProc$()))
});
$c_Lamf_client_commands_CmdLineParser$.prototype.knownSpec__T__Z = (function(f) {
  var this$1 = $m_Lamf_RamlProfile$();
  if ((this$1.p$1 === f)) {
    var jsx$6 = true
  } else {
    var this$2 = $m_Lamf_Raml10Profile$();
    var jsx$6 = (this$2.p$1 === f)
  };
  if (jsx$6) {
    var jsx$5 = true
  } else {
    var this$3 = $m_Lamf_Raml08Profile$();
    var jsx$5 = (this$3.p$1 === f)
  };
  if (jsx$5) {
    var jsx$4 = true
  } else {
    var this$4 = $m_Lamf_Oas30Profile$();
    var jsx$4 = (this$4.p$1 === f)
  };
  if (jsx$4) {
    var jsx$3 = true
  } else {
    var this$5 = $m_Lamf_Oas20Profile$();
    var jsx$3 = (this$5.p$1 === f)
  };
  if (jsx$3) {
    var jsx$2 = true
  } else {
    var this$6 = $m_Lamf_OasProfile$();
    var jsx$2 = (this$6.p$1 === f)
  };
  if (jsx$2) {
    var jsx$1 = true
  } else {
    var this$7 = $m_Lamf_AmfProfile$();
    var jsx$1 = (this$7.p$1 === f)
  };
  if (jsx$1) {
    return true
  } else {
    return ($m_Lamf_core_remote_Aml$().name$1 === f)
  }
});
var $d_Lamf_client_commands_CmdLineParser$ = new $TypeData().initClass({
  Lamf_client_commands_CmdLineParser$: 0
}, false, "amf.client.commands.CmdLineParser$", {
  Lamf_client_commands_CmdLineParser$: 1,
  O: 1
});
$c_Lamf_client_commands_CmdLineParser$.prototype.$classData = $d_Lamf_client_commands_CmdLineParser$;
var $n_Lamf_client_commands_CmdLineParser$ = (void 0);
function $m_Lamf_client_commands_CmdLineParser$() {
  if ((!$n_Lamf_client_commands_CmdLineParser$)) {
    $n_Lamf_client_commands_CmdLineParser$ = new $c_Lamf_client_commands_CmdLineParser$().init___()
  };
  return $n_Lamf_client_commands_CmdLineParser$
}
/** @constructor */
function $c_Lamf_client_convert_CollectionConverter$ClientListOps() {
  $c_O.call(this);
  this.from$1 = null;
  this.m$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CollectionConverter$ClientListOps.prototype = new $h_O();
$c_Lamf_client_convert_CollectionConverter$ClientListOps.prototype.constructor = $c_Lamf_client_convert_CollectionConverter$ClientListOps;
/** @constructor */
function $h_Lamf_client_convert_CollectionConverter$ClientListOps() {
  /*<skip>*/
}
$h_Lamf_client_convert_CollectionConverter$ClientListOps.prototype = $c_Lamf_client_convert_CollectionConverter$ClientListOps.prototype;
$c_Lamf_client_convert_CollectionConverter$ClientListOps.prototype.init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher = (function($$outer, from, m) {
  this.from$1 = from;
  this.m$1 = m;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_CollectionConverter$ClientListOps.prototype.asInternal__sc_Seq = (function() {
  var this$1 = this.$$outer$1;
  var from = this.from$1;
  var m = this.m$1;
  return $f_Lamf_client_convert_CoreBaseClientConverter__asInternalSeq__sjs_js_Array__Lamf_client_convert_ClientInternalMatcher__sc_Seq(this$1, from, m)
});
var $d_Lamf_client_convert_CollectionConverter$ClientListOps = new $TypeData().initClass({
  Lamf_client_convert_CollectionConverter$ClientListOps: 0
}, false, "amf.client.convert.CollectionConverter$ClientListOps", {
  Lamf_client_convert_CollectionConverter$ClientListOps: 1,
  O: 1
});
$c_Lamf_client_convert_CollectionConverter$ClientListOps.prototype.$classData = $d_Lamf_client_convert_CollectionConverter$ClientListOps;
/** @constructor */
function $c_Lamf_client_convert_CollectionConverter$ClientListOpsWithEC() {
  $c_O.call(this);
  this.from$1 = null;
  this.m$1 = null;
  this.executionContext$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CollectionConverter$ClientListOpsWithEC.prototype = new $h_O();
$c_Lamf_client_convert_CollectionConverter$ClientListOpsWithEC.prototype.constructor = $c_Lamf_client_convert_CollectionConverter$ClientListOpsWithEC;
/** @constructor */
function $h_Lamf_client_convert_CollectionConverter$ClientListOpsWithEC() {
  /*<skip>*/
}
$h_Lamf_client_convert_CollectionConverter$ClientListOpsWithEC.prototype = $c_Lamf_client_convert_CollectionConverter$ClientListOpsWithEC.prototype;
$c_Lamf_client_convert_CollectionConverter$ClientListOpsWithEC.prototype.asInternal__sc_Seq = (function() {
  var this$1 = this.$$outer$1;
  var from = this.from$1;
  var m = this.m$1;
  var executionContext = this.executionContext$1;
  return $f_Lamf_client_convert_CoreBaseClientConverter__asInternalSeqWithEC__sjs_js_Array__Lamf_client_convert_ClientInternalMatcherWithEC__s_concurrent_ExecutionContext__sc_Seq(this$1, from, m, executionContext)
});
$c_Lamf_client_convert_CollectionConverter$ClientListOpsWithEC.prototype.init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcherWithEC__s_concurrent_ExecutionContext = (function($$outer, from, m, executionContext) {
  this.from$1 = from;
  this.m$1 = m;
  this.executionContext$1 = executionContext;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_CollectionConverter$ClientListOpsWithEC = new $TypeData().initClass({
  Lamf_client_convert_CollectionConverter$ClientListOpsWithEC: 0
}, false, "amf.client.convert.CollectionConverter$ClientListOpsWithEC", {
  Lamf_client_convert_CollectionConverter$ClientListOpsWithEC: 1,
  O: 1
});
$c_Lamf_client_convert_CollectionConverter$ClientListOpsWithEC.prototype.$classData = $d_Lamf_client_convert_CollectionConverter$ClientListOpsWithEC;
/** @constructor */
function $c_Lamf_client_convert_CollectionConverter$ClientMapOps() {
  $c_O.call(this);
  this.from$1 = null;
  this.m$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CollectionConverter$ClientMapOps.prototype = new $h_O();
$c_Lamf_client_convert_CollectionConverter$ClientMapOps.prototype.constructor = $c_Lamf_client_convert_CollectionConverter$ClientMapOps;
/** @constructor */
function $h_Lamf_client_convert_CollectionConverter$ClientMapOps() {
  /*<skip>*/
}
$h_Lamf_client_convert_CollectionConverter$ClientMapOps.prototype = $c_Lamf_client_convert_CollectionConverter$ClientMapOps.prototype;
$c_Lamf_client_convert_CollectionConverter$ClientMapOps.prototype.init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher = (function($$outer, from, m) {
  this.from$1 = from;
  this.m$1 = m;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_CollectionConverter$ClientMapOps.prototype.asInternal__sci_Map = (function() {
  var this$1 = this.$$outer$1;
  var from = this.from$1;
  var m = this.m$1;
  return $f_Lamf_client_convert_CoreBaseClientConverter__asInternalMap__sjs_js_Dictionary__Lamf_client_convert_ClientInternalMatcher__sci_Map(this$1, from, m)
});
var $d_Lamf_client_convert_CollectionConverter$ClientMapOps = new $TypeData().initClass({
  Lamf_client_convert_CollectionConverter$ClientMapOps: 0
}, false, "amf.client.convert.CollectionConverter$ClientMapOps", {
  Lamf_client_convert_CollectionConverter$ClientMapOps: 1,
  O: 1
});
$c_Lamf_client_convert_CollectionConverter$ClientMapOps.prototype.$classData = $d_Lamf_client_convert_CollectionConverter$ClientMapOps;
/** @constructor */
function $c_Lamf_client_convert_CollectionConverter$ClientOptionOps() {
  $c_O.call(this);
  this.from$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CollectionConverter$ClientOptionOps.prototype = new $h_O();
$c_Lamf_client_convert_CollectionConverter$ClientOptionOps.prototype.constructor = $c_Lamf_client_convert_CollectionConverter$ClientOptionOps;
/** @constructor */
function $h_Lamf_client_convert_CollectionConverter$ClientOptionOps() {
  /*<skip>*/
}
$h_Lamf_client_convert_CollectionConverter$ClientOptionOps.prototype = $c_Lamf_client_convert_CollectionConverter$ClientOptionOps.prototype;
$c_Lamf_client_convert_CollectionConverter$ClientOptionOps.prototype.toScala__s_Option = (function() {
  var this$1 = this.$$outer$1;
  var from = this.from$1;
  return $f_Lamf_client_convert_CoreBaseClientConverter__toScalaOption__sjs_js_UndefOr__s_Option(this$1, from)
});
$c_Lamf_client_convert_CollectionConverter$ClientOptionOps.prototype.init___Lamf_client_convert_CollectionConverter__O = (function($$outer, from) {
  this.from$1 = from;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_CollectionConverter$ClientOptionOps = new $TypeData().initClass({
  Lamf_client_convert_CollectionConverter$ClientOptionOps: 0
}, false, "amf.client.convert.CollectionConverter$ClientOptionOps", {
  Lamf_client_convert_CollectionConverter$ClientOptionOps: 1,
  O: 1
});
$c_Lamf_client_convert_CollectionConverter$ClientOptionOps.prototype.$classData = $d_Lamf_client_convert_CollectionConverter$ClientOptionOps;
/** @constructor */
function $c_Lamf_client_convert_CollectionConverter$InternalImmutableMapOps() {
  $c_O.call(this);
  this.from$1 = null;
  this.m$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CollectionConverter$InternalImmutableMapOps.prototype = new $h_O();
$c_Lamf_client_convert_CollectionConverter$InternalImmutableMapOps.prototype.constructor = $c_Lamf_client_convert_CollectionConverter$InternalImmutableMapOps;
/** @constructor */
function $h_Lamf_client_convert_CollectionConverter$InternalImmutableMapOps() {
  /*<skip>*/
}
$h_Lamf_client_convert_CollectionConverter$InternalImmutableMapOps.prototype = $c_Lamf_client_convert_CollectionConverter$InternalImmutableMapOps.prototype;
$c_Lamf_client_convert_CollectionConverter$InternalImmutableMapOps.prototype.init___Lamf_client_convert_CollectionConverter__sci_Map__Lamf_client_convert_InternalClientMatcher = (function($$outer, from, m) {
  this.from$1 = from;
  this.m$1 = m;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_CollectionConverter$InternalImmutableMapOps.prototype.asClient__O = (function() {
  var this$1 = this.$$outer$1;
  var from = this.from$1;
  var m = this.m$1;
  return $f_Lamf_client_convert_CoreBaseClientConverter__asClientImmutableMap__sci_Map__Lamf_client_convert_InternalClientMatcher__sjs_js_Dictionary(this$1, from, m)
});
var $d_Lamf_client_convert_CollectionConverter$InternalImmutableMapOps = new $TypeData().initClass({
  Lamf_client_convert_CollectionConverter$InternalImmutableMapOps: 0
}, false, "amf.client.convert.CollectionConverter$InternalImmutableMapOps", {
  Lamf_client_convert_CollectionConverter$InternalImmutableMapOps: 1,
  O: 1
});
$c_Lamf_client_convert_CollectionConverter$InternalImmutableMapOps.prototype.$classData = $d_Lamf_client_convert_CollectionConverter$InternalImmutableMapOps;
/** @constructor */
function $c_Lamf_client_convert_CollectionConverter$InternalMapOps() {
  $c_O.call(this);
  this.from$1 = null;
  this.m$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CollectionConverter$InternalMapOps.prototype = new $h_O();
$c_Lamf_client_convert_CollectionConverter$InternalMapOps.prototype.constructor = $c_Lamf_client_convert_CollectionConverter$InternalMapOps;
/** @constructor */
function $h_Lamf_client_convert_CollectionConverter$InternalMapOps() {
  /*<skip>*/
}
$h_Lamf_client_convert_CollectionConverter$InternalMapOps.prototype = $c_Lamf_client_convert_CollectionConverter$InternalMapOps.prototype;
$c_Lamf_client_convert_CollectionConverter$InternalMapOps.prototype.init___Lamf_client_convert_CollectionConverter__scm_Map__Lamf_client_convert_InternalClientMatcher = (function($$outer, from, m) {
  this.from$1 = from;
  this.m$1 = m;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_CollectionConverter$InternalMapOps.prototype.asClient__O = (function() {
  var this$1 = this.$$outer$1;
  var from = this.from$1;
  var m = this.m$1;
  return $f_Lamf_client_convert_CoreBaseClientConverter__asClientMap__scm_Map__Lamf_client_convert_InternalClientMatcher__sjs_js_Dictionary(this$1, from, m)
});
var $d_Lamf_client_convert_CollectionConverter$InternalMapOps = new $TypeData().initClass({
  Lamf_client_convert_CollectionConverter$InternalMapOps: 0
}, false, "amf.client.convert.CollectionConverter$InternalMapOps", {
  Lamf_client_convert_CollectionConverter$InternalMapOps: 1,
  O: 1
});
$c_Lamf_client_convert_CollectionConverter$InternalMapOps.prototype.$classData = $d_Lamf_client_convert_CollectionConverter$InternalMapOps;
/** @constructor */
function $c_Lamf_client_convert_CollectionConverter$InternalOptionOps() {
  $c_O.call(this);
  this.from$1 = null;
  this.m$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CollectionConverter$InternalOptionOps.prototype = new $h_O();
$c_Lamf_client_convert_CollectionConverter$InternalOptionOps.prototype.constructor = $c_Lamf_client_convert_CollectionConverter$InternalOptionOps;
/** @constructor */
function $h_Lamf_client_convert_CollectionConverter$InternalOptionOps() {
  /*<skip>*/
}
$h_Lamf_client_convert_CollectionConverter$InternalOptionOps.prototype = $c_Lamf_client_convert_CollectionConverter$InternalOptionOps.prototype;
$c_Lamf_client_convert_CollectionConverter$InternalOptionOps.prototype.init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher = (function($$outer, from, m) {
  this.from$1 = from;
  this.m$1 = m;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_CollectionConverter$InternalOptionOps.prototype.asClient__O = (function() {
  var this$1 = this.$$outer$1;
  var from = this.from$1;
  var m = this.m$1;
  return $f_Lamf_client_convert_CoreBaseClientConverter__asClientOption__s_Option__Lamf_client_convert_InternalClientMatcher__sjs_js_UndefOr(this$1, from, m)
});
var $d_Lamf_client_convert_CollectionConverter$InternalOptionOps = new $TypeData().initClass({
  Lamf_client_convert_CollectionConverter$InternalOptionOps: 0
}, false, "amf.client.convert.CollectionConverter$InternalOptionOps", {
  Lamf_client_convert_CollectionConverter$InternalOptionOps: 1,
  O: 1
});
$c_Lamf_client_convert_CollectionConverter$InternalOptionOps.prototype.$classData = $d_Lamf_client_convert_CollectionConverter$InternalOptionOps;
/** @constructor */
function $c_Lamf_client_convert_CollectionConverter$InternalOptionOpsWithEC() {
  $c_O.call(this);
  this.from$1 = null;
  this.m$1 = null;
  this.executionContext$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CollectionConverter$InternalOptionOpsWithEC.prototype = new $h_O();
$c_Lamf_client_convert_CollectionConverter$InternalOptionOpsWithEC.prototype.constructor = $c_Lamf_client_convert_CollectionConverter$InternalOptionOpsWithEC;
/** @constructor */
function $h_Lamf_client_convert_CollectionConverter$InternalOptionOpsWithEC() {
  /*<skip>*/
}
$h_Lamf_client_convert_CollectionConverter$InternalOptionOpsWithEC.prototype = $c_Lamf_client_convert_CollectionConverter$InternalOptionOpsWithEC.prototype;
$c_Lamf_client_convert_CollectionConverter$InternalOptionOpsWithEC.prototype.init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcherWithEC__s_concurrent_ExecutionContext = (function($$outer, from, m, executionContext) {
  this.from$1 = from;
  this.m$1 = m;
  this.executionContext$1 = executionContext;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_CollectionConverter$InternalOptionOpsWithEC.prototype.asClient__O = (function() {
  var this$1 = this.$$outer$1;
  var from = this.from$1;
  var m = this.m$1;
  var executionContext = this.executionContext$1;
  return $f_Lamf_client_convert_CoreBaseClientConverter__asClientOptionWithEC__s_Option__Lamf_client_convert_InternalClientMatcherWithEC__s_concurrent_ExecutionContext__sjs_js_UndefOr(this$1, from, m, executionContext)
});
var $d_Lamf_client_convert_CollectionConverter$InternalOptionOpsWithEC = new $TypeData().initClass({
  Lamf_client_convert_CollectionConverter$InternalOptionOpsWithEC: 0
}, false, "amf.client.convert.CollectionConverter$InternalOptionOpsWithEC", {
  Lamf_client_convert_CollectionConverter$InternalOptionOpsWithEC: 1,
  O: 1
});
$c_Lamf_client_convert_CollectionConverter$InternalOptionOpsWithEC.prototype.$classData = $d_Lamf_client_convert_CollectionConverter$InternalOptionOpsWithEC;
/** @constructor */
function $c_Lamf_client_convert_CollectionConverter$InternalSeqOps() {
  $c_O.call(this);
  this.from$1 = null;
  this.m$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CollectionConverter$InternalSeqOps.prototype = new $h_O();
$c_Lamf_client_convert_CollectionConverter$InternalSeqOps.prototype.constructor = $c_Lamf_client_convert_CollectionConverter$InternalSeqOps;
/** @constructor */
function $h_Lamf_client_convert_CollectionConverter$InternalSeqOps() {
  /*<skip>*/
}
$h_Lamf_client_convert_CollectionConverter$InternalSeqOps.prototype = $c_Lamf_client_convert_CollectionConverter$InternalSeqOps.prototype;
$c_Lamf_client_convert_CollectionConverter$InternalSeqOps.prototype.asClient__O = (function() {
  var this$1 = this.$$outer$1;
  var from = this.from$1;
  var m = this.m$1;
  return $f_Lamf_client_convert_CoreBaseClientConverter__asClientList__sc_Seq__Lamf_client_convert_InternalClientMatcher__sjs_js_Array(this$1, from, m)
});
$c_Lamf_client_convert_CollectionConverter$InternalSeqOps.prototype.init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher = (function($$outer, from, m) {
  this.from$1 = from;
  this.m$1 = m;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_CollectionConverter$InternalSeqOps = new $TypeData().initClass({
  Lamf_client_convert_CollectionConverter$InternalSeqOps: 0
}, false, "amf.client.convert.CollectionConverter$InternalSeqOps", {
  Lamf_client_convert_CollectionConverter$InternalSeqOps: 1,
  O: 1
});
$c_Lamf_client_convert_CollectionConverter$InternalSeqOps.prototype.$classData = $d_Lamf_client_convert_CollectionConverter$InternalSeqOps;
/** @constructor */
function $c_Lamf_client_convert_CollectionConverter$InternalSeqOpsWithEC() {
  $c_O.call(this);
  this.from$1 = null;
  this.m$1 = null;
  this.executionContext$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CollectionConverter$InternalSeqOpsWithEC.prototype = new $h_O();
$c_Lamf_client_convert_CollectionConverter$InternalSeqOpsWithEC.prototype.constructor = $c_Lamf_client_convert_CollectionConverter$InternalSeqOpsWithEC;
/** @constructor */
function $h_Lamf_client_convert_CollectionConverter$InternalSeqOpsWithEC() {
  /*<skip>*/
}
$h_Lamf_client_convert_CollectionConverter$InternalSeqOpsWithEC.prototype = $c_Lamf_client_convert_CollectionConverter$InternalSeqOpsWithEC.prototype;
$c_Lamf_client_convert_CollectionConverter$InternalSeqOpsWithEC.prototype.init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcherWithEC__s_concurrent_ExecutionContext = (function($$outer, from, m, executionContext) {
  this.from$1 = from;
  this.m$1 = m;
  this.executionContext$1 = executionContext;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_CollectionConverter$InternalSeqOpsWithEC.prototype.asClient__O = (function() {
  var this$1 = this.$$outer$1;
  var from = this.from$1;
  var m = this.m$1;
  var executionContext = this.executionContext$1;
  return $f_Lamf_client_convert_CoreBaseClientConverter__asClientListWithEC__sc_Seq__Lamf_client_convert_InternalClientMatcherWithEC__s_concurrent_ExecutionContext__sjs_js_Array(this$1, from, m, executionContext)
});
var $d_Lamf_client_convert_CollectionConverter$InternalSeqOpsWithEC = new $TypeData().initClass({
  Lamf_client_convert_CollectionConverter$InternalSeqOpsWithEC: 0
}, false, "amf.client.convert.CollectionConverter$InternalSeqOpsWithEC", {
  Lamf_client_convert_CollectionConverter$InternalSeqOpsWithEC: 1,
  O: 1
});
$c_Lamf_client_convert_CollectionConverter$InternalSeqOpsWithEC.prototype.$classData = $d_Lamf_client_convert_CollectionConverter$InternalSeqOpsWithEC;
/** @constructor */
function $c_Lamf_client_convert_CoreRegister$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_CoreRegister$.prototype = new $h_O();
$c_Lamf_client_convert_CoreRegister$.prototype.constructor = $c_Lamf_client_convert_CoreRegister$;
/** @constructor */
function $h_Lamf_client_convert_CoreRegister$() {
  /*<skip>*/
}
$h_Lamf_client_convert_CoreRegister$.prototype = $c_Lamf_client_convert_CoreRegister$.prototype;
$c_Lamf_client_convert_CoreRegister$.prototype.init___ = (function() {
  return this
});
$c_Lamf_client_convert_CoreRegister$.prototype.register__Lamf_core_remote_Platform__V = (function(platform) {
  var model = $m_Lamf_core_metamodel_document_ModuleModel$();
  var builder = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_domain_AmfObject(x0$1$2);
      if ((x0$1 instanceof $c_Lamf_core_model_document_Module)) {
        var x2 = $as_Lamf_core_model_document_Module(x0$1);
        return new $c_Lamf_client_model_document_Module().init___Lamf_core_model_document_Module(x2)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model, builder);
  var model$1 = $m_Lamf_core_metamodel_document_DocumentModel$();
  var builder$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x0$2$2) {
      var x0$2 = $as_Lamf_core_model_domain_AmfObject(x0$2$2);
      if ((x0$2 instanceof $c_Lamf_core_model_document_Document)) {
        var x2$1 = $as_Lamf_core_model_document_Document(x0$2);
        return new $c_Lamf_client_model_document_Document().init___Lamf_core_model_document_Document(x2$1)
      } else {
        throw new $c_s_MatchError().init___O(x0$2)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$1, builder$1);
  var model$2 = $m_Lamf_core_metamodel_document_FragmentModel$();
  var builder$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3) {
    return (function(x0$3$2) {
      var x0$3 = $as_Lamf_core_model_domain_AmfObject(x0$3$2);
      if ($is_Lamf_core_model_document_Fragment(x0$3)) {
        var x2$2 = $as_Lamf_core_model_document_Fragment(x0$3);
        return new $c_Lamf_client_model_document_Fragment().init___Lamf_core_model_document_Fragment(x2$2)
      } else {
        throw new $c_s_MatchError().init___O(x0$3)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$2, builder$2);
  var model$3 = $m_Lamf_core_metamodel_document_ExternalFragmentModel$();
  var builder$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4) {
    return (function(x0$4$2) {
      var x0$4 = $as_Lamf_core_model_domain_AmfObject(x0$4$2);
      if ((x0$4 instanceof $c_Lamf_core_model_document_ExternalFragment)) {
        var x2$3 = $as_Lamf_core_model_document_ExternalFragment(x0$4);
        return new $c_Lamf_client_model_document_ExternalFragment().init___Lamf_core_model_document_ExternalFragment(x2$3)
      } else {
        throw new $c_s_MatchError().init___O(x0$4)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$3, builder$3);
  var model$4 = $m_Lamf_core_metamodel_domain_ExternalDomainElementModel$();
  var builder$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5) {
    return (function(x0$5$2) {
      var x0$5 = $as_Lamf_core_model_domain_AmfObject(x0$5$2);
      if ((x0$5 instanceof $c_Lamf_core_model_domain_ExternalDomainElement)) {
        var x2$4 = $as_Lamf_core_model_domain_ExternalDomainElement(x0$5);
        return new $c_Lamf_client_model_domain_ExternalDomainElement().init___Lamf_core_model_domain_ExternalDomainElement(x2$4)
      } else {
        throw new $c_s_MatchError().init___O(x0$5)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$4, builder$4);
  var model$5 = $m_Lamf_core_metamodel_domain_DomainElementModel$();
  var builder$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6) {
    return (function(x0$6$2) {
      var x0$6 = $as_Lamf_core_model_domain_AmfObject(x0$6$2);
      if ($is_Lamf_core_model_domain_DomainElement(x0$6)) {
        var x2$5 = $as_Lamf_core_model_domain_DomainElement(x0$6);
        $m_Lamf_client_convert_CoreClientConverters$();
        var m = $m_Lamf_client_convert_CoreClientConverters$().DomainElementMatcher__Lamf_client_convert_DomainElementConverter$DomainElementMatcher$();
        return m.asClient__Lamf_core_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(x2$5)
      } else {
        throw new $c_s_MatchError().init___O(x0$6)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$5, builder$5);
  var model$6 = $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$();
  var builder$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$7) {
    return (function(x0$7$2) {
      var x0$7 = $as_Lamf_core_model_domain_AmfObject(x0$7$2);
      if ((x0$7 instanceof $c_Lamf_core_model_domain_extensions_CustomDomainProperty)) {
        var x2$6 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(x0$7);
        return new $c_Lamf_client_model_domain_CustomDomainProperty().init___Lamf_core_model_domain_extensions_CustomDomainProperty(x2$6)
      } else {
        throw new $c_s_MatchError().init___O(x0$7)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$6, builder$6);
  var model$7 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$();
  var builder$7 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$8) {
    return (function(x0$8$2) {
      var x0$8 = $as_Lamf_core_model_domain_AmfObject(x0$8$2);
      if ((x0$8 instanceof $c_Lamf_core_model_domain_extensions_DomainExtension)) {
        var x2$7 = $as_Lamf_core_model_domain_extensions_DomainExtension(x0$8);
        return new $c_Lamf_client_model_domain_DomainExtension().init___Lamf_core_model_domain_extensions_DomainExtension(x2$7)
      } else {
        throw new $c_s_MatchError().init___O(x0$8)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$7, builder$7);
  var model$8 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$();
  var builder$8 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$9) {
    return (function(x0$9$2) {
      var x0$9 = $as_Lamf_core_model_domain_AmfObject(x0$9$2);
      if ((x0$9 instanceof $c_Lamf_core_model_domain_extensions_PropertyShape)) {
        var x2$8 = $as_Lamf_core_model_domain_extensions_PropertyShape(x0$9);
        return new $c_Lamf_client_model_domain_PropertyShape().init___Lamf_core_model_domain_extensions_PropertyShape(x2$8)
      } else {
        throw new $c_s_MatchError().init___O(x0$9)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$8, builder$8);
  var model$9 = $m_Lamf_core_metamodel_domain_ObjectNodeModel$();
  var builder$9 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$10) {
    return (function(x0$10$2) {
      var x0$10 = $as_Lamf_core_model_domain_AmfObject(x0$10$2);
      if ((x0$10 instanceof $c_Lamf_core_model_domain_ObjectNode)) {
        var x2$9 = $as_Lamf_core_model_domain_ObjectNode(x0$10);
        $m_Lamf_client_convert_CoreClientConverters$().ObjectNodeMatcher__Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$();
        return new $c_Lamf_client_model_domain_ObjectNode().init___Lamf_core_model_domain_ObjectNode(x2$9)
      } else {
        throw new $c_s_MatchError().init___O(x0$10)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$9, builder$9);
  var model$10 = $m_Lamf_core_metamodel_domain_ScalarNodeModel$();
  var builder$10 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$11$1) {
    return (function(x0$11$2) {
      var x0$11 = $as_Lamf_core_model_domain_AmfObject(x0$11$2);
      if ((x0$11 instanceof $c_Lamf_core_model_domain_ScalarNode)) {
        var x2$10 = $as_Lamf_core_model_domain_ScalarNode(x0$11);
        $m_Lamf_client_convert_CoreClientConverters$().ScalarNodeMatcher__Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$();
        return new $c_Lamf_client_model_domain_ScalarNode().init___Lamf_core_model_domain_ScalarNode(x2$10)
      } else {
        throw new $c_s_MatchError().init___O(x0$11)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$10, builder$10);
  var model$11 = $m_Lamf_core_metamodel_domain_ArrayNodeModel$();
  var builder$11 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$12$1) {
    return (function(x0$12$2) {
      var x0$12 = $as_Lamf_core_model_domain_AmfObject(x0$12$2);
      if ((x0$12 instanceof $c_Lamf_core_model_domain_ArrayNode)) {
        var x2$11 = $as_Lamf_core_model_domain_ArrayNode(x0$12);
        $m_Lamf_client_convert_CoreClientConverters$().ArrayNodeMatcher__Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$();
        return new $c_Lamf_client_model_domain_ArrayNode().init___Lamf_core_model_domain_ArrayNode(x2$11)
      } else {
        throw new $c_s_MatchError().init___O(x0$12)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$11, builder$11);
  var model$12 = $m_Lamf_core_metamodel_domain_DataNodeModel$();
  var builder$12 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$13$1) {
    return (function(x0$13$2) {
      var x0$13 = $as_Lamf_core_model_domain_AmfObject(x0$13$2);
      if ((x0$13 instanceof $c_Lamf_core_model_domain_DataNode)) {
        var x2$12 = $as_Lamf_core_model_domain_DataNode(x0$13);
        return $m_Lamf_client_convert_CoreClientConverters$().DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$().asClient__Lamf_core_model_domain_DataNode__Lamf_client_model_domain_DataNode(x2$12)
      } else {
        throw new $c_s_MatchError().init___O(x0$13)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$12, builder$12);
  var model$13 = $m_Lamf_core_metamodel_domain_templates_VariableValueModel$();
  var builder$13 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$14) {
    return (function(x0$14$2) {
      var x0$14 = $as_Lamf_core_model_domain_AmfObject(x0$14$2);
      if ((x0$14 instanceof $c_Lamf_core_model_domain_templates_VariableValue)) {
        var x2$13 = $as_Lamf_core_model_domain_templates_VariableValue(x0$14);
        return new $c_Lamf_client_model_domain_VariableValue().init___Lamf_core_model_domain_templates_VariableValue(x2$13)
      } else {
        throw new $c_s_MatchError().init___O(x0$14)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$13, builder$13)
});
var $d_Lamf_client_convert_CoreRegister$ = new $TypeData().initClass({
  Lamf_client_convert_CoreRegister$: 0
}, false, "amf.client.convert.CoreRegister$", {
  Lamf_client_convert_CoreRegister$: 1,
  O: 1
});
$c_Lamf_client_convert_CoreRegister$.prototype.$classData = $d_Lamf_client_convert_CoreRegister$;
var $n_Lamf_client_convert_CoreRegister$ = (void 0);
function $m_Lamf_client_convert_CoreRegister$() {
  if ((!$n_Lamf_client_convert_CoreRegister$)) {
    $n_Lamf_client_convert_CoreRegister$ = new $c_Lamf_client_convert_CoreRegister$().init___()
  };
  return $n_Lamf_client_convert_CoreRegister$
}
/** @constructor */
function $c_Lamf_client_convert_FutureConverter$ClientFutureOps() {
  $c_O.call(this);
  this.from$1 = null;
  this.m$1 = null;
  this.executionContext$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_client_convert_FutureConverter$ClientFutureOps.prototype = new $h_O();
$c_Lamf_client_convert_FutureConverter$ClientFutureOps.prototype.constructor = $c_Lamf_client_convert_FutureConverter$ClientFutureOps;
/** @constructor */
function $h_Lamf_client_convert_FutureConverter$ClientFutureOps() {
  /*<skip>*/
}
$h_Lamf_client_convert_FutureConverter$ClientFutureOps.prototype = $c_Lamf_client_convert_FutureConverter$ClientFutureOps.prototype;
$c_Lamf_client_convert_FutureConverter$ClientFutureOps.prototype.asInternal__s_concurrent_Future = (function() {
  var this$1 = this.$$outer$1;
  var from = this.from$1;
  var matcher = this.m$1;
  var executionContext = this.executionContext$1;
  return $f_Lamf_client_convert_CoreBaseClientConverter__asInternalFuture__sjs_js_Promise__Lamf_client_convert_ClientInternalMatcher__s_concurrent_ExecutionContext__s_concurrent_Future(this$1, from, matcher, executionContext)
});
$c_Lamf_client_convert_FutureConverter$ClientFutureOps.prototype.init___Lamf_client_convert_FutureConverter__O__Lamf_client_convert_ClientInternalMatcher__s_concurrent_ExecutionContext = (function($$outer, from, m, executionContext) {
  this.from$1 = from;
  this.m$1 = m;
  this.executionContext$1 = executionContext;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_FutureConverter$ClientFutureOps = new $TypeData().initClass({
  Lamf_client_convert_FutureConverter$ClientFutureOps: 0
}, false, "amf.client.convert.FutureConverter$ClientFutureOps", {
  Lamf_client_convert_FutureConverter$ClientFutureOps: 1,
  O: 1
});
$c_Lamf_client_convert_FutureConverter$ClientFutureOps.prototype.$classData = $d_Lamf_client_convert_FutureConverter$ClientFutureOps;
/** @constructor */
function $c_Lamf_client_convert_FutureConverter$InternalFutureOps() {
  $c_O.call(this);
  this.from$1 = null;
  this.m$1 = null;
  this.executionContext$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_client_convert_FutureConverter$InternalFutureOps.prototype = new $h_O();
$c_Lamf_client_convert_FutureConverter$InternalFutureOps.prototype.constructor = $c_Lamf_client_convert_FutureConverter$InternalFutureOps;
/** @constructor */
function $h_Lamf_client_convert_FutureConverter$InternalFutureOps() {
  /*<skip>*/
}
$h_Lamf_client_convert_FutureConverter$InternalFutureOps.prototype = $c_Lamf_client_convert_FutureConverter$InternalFutureOps.prototype;
$c_Lamf_client_convert_FutureConverter$InternalFutureOps.prototype.asClient__O = (function() {
  var this$1 = this.$$outer$1;
  var from = this.from$1.map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(from$2) {
      return $this.m$1.asClient__O__O(from$2)
    })
  })(this)), this.executionContext$1);
  var executionContext = this.executionContext$1;
  return $f_Lamf_client_convert_CoreBaseClientConverter__asClientFuture__s_concurrent_Future__s_concurrent_ExecutionContext__sjs_js_Promise(this$1, from, executionContext)
});
$c_Lamf_client_convert_FutureConverter$InternalFutureOps.prototype.init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext = (function($$outer, from, m, executionContext) {
  this.from$1 = from;
  this.m$1 = m;
  this.executionContext$1 = executionContext;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_FutureConverter$InternalFutureOps = new $TypeData().initClass({
  Lamf_client_convert_FutureConverter$InternalFutureOps: 0
}, false, "amf.client.convert.FutureConverter$InternalFutureOps", {
  Lamf_client_convert_FutureConverter$InternalFutureOps: 1,
  O: 1
});
$c_Lamf_client_convert_FutureConverter$InternalFutureOps.prototype.$classData = $d_Lamf_client_convert_FutureConverter$InternalFutureOps;
/** @constructor */
function $c_Lamf_client_convert_WebApiRegister$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_WebApiRegister$.prototype = new $h_O();
$c_Lamf_client_convert_WebApiRegister$.prototype.constructor = $c_Lamf_client_convert_WebApiRegister$;
/** @constructor */
function $h_Lamf_client_convert_WebApiRegister$() {
  /*<skip>*/
}
$h_Lamf_client_convert_WebApiRegister$.prototype = $c_Lamf_client_convert_WebApiRegister$.prototype;
$c_Lamf_client_convert_WebApiRegister$.prototype.init___ = (function() {
  return this
});
$c_Lamf_client_convert_WebApiRegister$.prototype.register__Lamf_core_remote_Platform__V = (function(platform) {
  var model = $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$();
  var builder = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_domain_AmfObject(x0$1$2);
      if ((x0$1 instanceof $c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment)) {
        var x2 = $as_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment(x0$1);
        return new $c_Lamf_client_model_document_AnnotationTypeDeclaration().init___Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment(x2)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model, builder);
  var model$1 = $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$();
  var builder$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x0$2$2) {
      var x0$2 = $as_Lamf_core_model_domain_AmfObject(x0$2$2);
      if ((x0$2 instanceof $c_Lamf_plugins_document_webapi_model_DataTypeFragment)) {
        var x2$1 = $as_Lamf_plugins_document_webapi_model_DataTypeFragment(x0$2);
        return new $c_Lamf_client_model_document_DataType().init___Lamf_plugins_document_webapi_model_DataTypeFragment(x2$1)
      } else {
        throw new $c_s_MatchError().init___O(x0$2)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$1, builder$1);
  var model$2 = $m_Lamf_core_metamodel_document_PayloadFragmentModel$();
  var builder$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3) {
    return (function(x0$3$2) {
      var x0$3 = $as_Lamf_core_model_domain_AmfObject(x0$3$2);
      if ((x0$3 instanceof $c_Lamf_core_model_document_PayloadFragment)) {
        var x2$2 = $as_Lamf_core_model_document_PayloadFragment(x0$3);
        return new $c_Lamf_client_model_document_PayloadFragment().init___Lamf_core_model_document_PayloadFragment(x2$2)
      } else {
        throw new $c_s_MatchError().init___O(x0$3)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$2, builder$2);
  var model$3 = $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$();
  var builder$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4) {
    return (function(x0$4$2) {
      var x0$4 = $as_Lamf_core_model_domain_AmfObject(x0$4$2);
      if ((x0$4 instanceof $c_Lamf_plugins_document_webapi_model_DocumentationItemFragment)) {
        var x2$3 = $as_Lamf_plugins_document_webapi_model_DocumentationItemFragment(x0$4);
        return new $c_Lamf_client_model_document_DocumentationItem().init___Lamf_plugins_document_webapi_model_DocumentationItemFragment(x2$3)
      } else {
        throw new $c_s_MatchError().init___O(x0$4)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$3, builder$3);
  var model$4 = $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$();
  var builder$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5) {
    return (function(x0$5$2) {
      var x0$5 = $as_Lamf_core_model_domain_AmfObject(x0$5$2);
      if ((x0$5 instanceof $c_Lamf_plugins_document_webapi_model_NamedExampleFragment)) {
        var x2$4 = $as_Lamf_plugins_document_webapi_model_NamedExampleFragment(x0$5);
        return new $c_Lamf_client_model_document_NamedExample().init___Lamf_plugins_document_webapi_model_NamedExampleFragment(x2$4)
      } else {
        throw new $c_s_MatchError().init___O(x0$5)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$4, builder$4);
  var model$5 = $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$();
  var builder$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6) {
    return (function(x0$6$2) {
      var x0$6 = $as_Lamf_core_model_domain_AmfObject(x0$6$2);
      if ((x0$6 instanceof $c_Lamf_plugins_document_webapi_model_ResourceTypeFragment)) {
        var x2$5 = $as_Lamf_plugins_document_webapi_model_ResourceTypeFragment(x0$6);
        return new $c_Lamf_client_model_document_ResourceTypeFragment().init___Lamf_plugins_document_webapi_model_ResourceTypeFragment(x2$5)
      } else {
        throw new $c_s_MatchError().init___O(x0$6)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$5, builder$5);
  var model$6 = $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$();
  var builder$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$7) {
    return (function(x0$7$2) {
      var x0$7 = $as_Lamf_core_model_domain_AmfObject(x0$7$2);
      if ((x0$7 instanceof $c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment)) {
        var x2$6 = $as_Lamf_plugins_document_webapi_model_SecuritySchemeFragment(x0$7);
        return new $c_Lamf_client_model_document_SecuritySchemeFragment().init___Lamf_plugins_document_webapi_model_SecuritySchemeFragment(x2$6)
      } else {
        throw new $c_s_MatchError().init___O(x0$7)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$6, builder$6);
  var model$7 = $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$();
  var builder$7 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$8) {
    return (function(x0$8$2) {
      var x0$8 = $as_Lamf_core_model_domain_AmfObject(x0$8$2);
      if ((x0$8 instanceof $c_Lamf_plugins_document_webapi_model_TraitFragment)) {
        var x2$7 = $as_Lamf_plugins_document_webapi_model_TraitFragment(x0$8);
        return new $c_Lamf_client_model_document_TraitFragment().init___Lamf_plugins_document_webapi_model_TraitFragment(x2$7)
      } else {
        throw new $c_s_MatchError().init___O(x0$8)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$7, builder$7);
  var model$8 = $m_Lamf_plugins_document_webapi_metamodel_ExtensionModel$();
  var builder$8 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$9) {
    return (function(x0$9$2) {
      var x0$9 = $as_Lamf_core_model_domain_AmfObject(x0$9$2);
      if ((x0$9 instanceof $c_Lamf_plugins_document_webapi_model_Extension)) {
        var x2$8 = $as_Lamf_plugins_document_webapi_model_Extension(x0$9);
        return new $c_Lamf_client_model_document_Extension().init___Lamf_plugins_document_webapi_model_Extension(x2$8)
      } else {
        throw new $c_s_MatchError().init___O(x0$9)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$8, builder$8);
  var model$9 = $m_Lamf_plugins_document_webapi_metamodel_OverlayModel$();
  var builder$9 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$10) {
    return (function(x0$10$2) {
      var x0$10 = $as_Lamf_core_model_domain_AmfObject(x0$10$2);
      if ((x0$10 instanceof $c_Lamf_plugins_document_webapi_model_Overlay)) {
        var x2$9 = $as_Lamf_plugins_document_webapi_model_Overlay(x0$10);
        return new $c_Lamf_client_model_document_Overlay().init___Lamf_plugins_document_webapi_model_Overlay(x2$9)
      } else {
        throw new $c_s_MatchError().init___O(x0$10)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$9, builder$9);
  var model$10 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$();
  var builder$10 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$11) {
    return (function(x0$11$2) {
      var x0$11 = $as_Lamf_core_model_domain_AmfObject(x0$11$2);
      if ((x0$11 instanceof $c_Lamf_plugins_domain_webapi_models_EndPoint)) {
        var x2$10 = $as_Lamf_plugins_domain_webapi_models_EndPoint(x0$11);
        return new $c_Lamf_client_model_domain_EndPoint().init___Lamf_plugins_domain_webapi_models_EndPoint(x2$10)
      } else {
        throw new $c_s_MatchError().init___O(x0$11)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$10, builder$10);
  var model$11 = $m_Lamf_plugins_domain_webapi_metamodel_LicenseModel$();
  var builder$11 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$12) {
    return (function(x0$12$2) {
      var x0$12 = $as_Lamf_core_model_domain_AmfObject(x0$12$2);
      if ((x0$12 instanceof $c_Lamf_plugins_domain_webapi_models_License)) {
        var x2$11 = $as_Lamf_plugins_domain_webapi_models_License(x0$12);
        return new $c_Lamf_client_model_domain_License().init___Lamf_plugins_domain_webapi_models_License(x2$11)
      } else {
        throw new $c_s_MatchError().init___O(x0$12)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$11, builder$11);
  var model$12 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$();
  var builder$12 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$13) {
    return (function(x0$13$2) {
      var x0$13 = $as_Lamf_core_model_domain_AmfObject(x0$13$2);
      if ((x0$13 instanceof $c_Lamf_plugins_domain_webapi_models_Operation)) {
        var x2$12 = $as_Lamf_plugins_domain_webapi_models_Operation(x0$13);
        return new $c_Lamf_client_model_domain_Operation().init___Lamf_plugins_domain_webapi_models_Operation(x2$12)
      } else {
        throw new $c_s_MatchError().init___O(x0$13)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$12, builder$12);
  var model$13 = $m_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$();
  var builder$13 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$14) {
    return (function(x0$14$2) {
      var x0$14 = $as_Lamf_core_model_domain_AmfObject(x0$14$2);
      if ((x0$14 instanceof $c_Lamf_plugins_domain_webapi_models_Organization)) {
        var x2$13 = $as_Lamf_plugins_domain_webapi_models_Organization(x0$14);
        return new $c_Lamf_client_model_domain_Organization().init___Lamf_plugins_domain_webapi_models_Organization(x2$13)
      } else {
        throw new $c_s_MatchError().init___O(x0$14)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$13, builder$13);
  var model$14 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$();
  var builder$14 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$15) {
    return (function(x0$15$2) {
      var x0$15 = $as_Lamf_core_model_domain_AmfObject(x0$15$2);
      if ((x0$15 instanceof $c_Lamf_plugins_domain_webapi_models_Parameter)) {
        var x2$14 = $as_Lamf_plugins_domain_webapi_models_Parameter(x0$15);
        return new $c_Lamf_client_model_domain_Parameter().init___Lamf_plugins_domain_webapi_models_Parameter(x2$14)
      } else {
        throw new $c_s_MatchError().init___O(x0$15)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$14, builder$14);
  var model$15 = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$();
  var builder$15 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$16) {
    return (function(x0$16$2) {
      var x0$16 = $as_Lamf_core_model_domain_AmfObject(x0$16$2);
      if ((x0$16 instanceof $c_Lamf_plugins_domain_webapi_models_Server)) {
        var x2$15 = $as_Lamf_plugins_domain_webapi_models_Server(x0$16);
        return new $c_Lamf_client_model_domain_Server().init___Lamf_plugins_domain_webapi_models_Server(x2$15)
      } else {
        throw new $c_s_MatchError().init___O(x0$16)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$15, builder$15);
  var model$16 = $m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$();
  var builder$16 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$17) {
    return (function(x0$17$2) {
      var x0$17 = $as_Lamf_core_model_domain_AmfObject(x0$17$2);
      if ((x0$17 instanceof $c_Lamf_plugins_domain_webapi_models_Callback)) {
        var x2$16 = $as_Lamf_plugins_domain_webapi_models_Callback(x0$17);
        return new $c_Lamf_client_model_domain_Callback().init___Lamf_plugins_domain_webapi_models_Callback(x2$16)
      } else {
        throw new $c_s_MatchError().init___O(x0$17)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$16, builder$16);
  var model$17 = $m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$();
  var builder$17 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$18) {
    return (function(x0$18$2) {
      var x0$18 = $as_Lamf_core_model_domain_AmfObject(x0$18$2);
      if ((x0$18 instanceof $c_Lamf_plugins_domain_webapi_models_Encoding)) {
        var x2$17 = $as_Lamf_plugins_domain_webapi_models_Encoding(x0$18);
        return new $c_Lamf_client_model_domain_Encoding().init___Lamf_plugins_domain_webapi_models_Encoding(x2$17)
      } else {
        throw new $c_s_MatchError().init___O(x0$18)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$17, builder$17);
  var model$18 = $m_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$();
  var builder$18 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$19) {
    return (function(x0$19$2) {
      var x0$19 = $as_Lamf_core_model_domain_AmfObject(x0$19$2);
      if ((x0$19 instanceof $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType)) {
        var x2$18 = $as_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType(x0$19);
        return new $c_Lamf_client_model_domain_ParametrizedResourceType().init___Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType(x2$18)
      } else {
        throw new $c_s_MatchError().init___O(x0$19)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$18, builder$18);
  var model$19 = $m_Lamf_plugins_domain_webapi_metamodel_TagModel$();
  var builder$19 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$20) {
    return (function(x0$20$2) {
      var x0$20 = $as_Lamf_core_model_domain_AmfObject(x0$20$2);
      if ((x0$20 instanceof $c_Lamf_plugins_domain_webapi_models_Tag)) {
        var x2$19 = $as_Lamf_plugins_domain_webapi_models_Tag(x0$20);
        return new $c_Lamf_client_model_domain_Tag().init___Lamf_plugins_domain_webapi_models_Tag(x2$19)
      } else {
        throw new $c_s_MatchError().init___O(x0$20)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$19, builder$19);
  var model$20 = $m_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$();
  var builder$20 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$21) {
    return (function(x0$21$2) {
      var x0$21 = $as_Lamf_core_model_domain_AmfObject(x0$21$2);
      if ((x0$21 instanceof $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait)) {
        var x2$20 = $as_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait(x0$21);
        return new $c_Lamf_client_model_domain_ParametrizedTrait().init___Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait(x2$20)
      } else {
        throw new $c_s_MatchError().init___O(x0$21)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$20, builder$20);
  var model$21 = $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$();
  var builder$21 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$22) {
    return (function(x0$22$2) {
      var x0$22 = $as_Lamf_core_model_domain_AmfObject(x0$22$2);
      if ((x0$22 instanceof $c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme)) {
        var x2$21 = $as_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme(x0$22);
        return new $c_Lamf_client_model_domain_ParametrizedSecurityScheme().init___Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme(x2$21)
      } else {
        throw new $c_s_MatchError().init___O(x0$22)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$21, builder$21);
  var model$22 = $m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$();
  var builder$22 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$23) {
    return (function(x0$23$2) {
      var x0$23 = $as_Lamf_core_model_domain_AmfObject(x0$23$2);
      if ((x0$23 instanceof $c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement)) {
        var x2$22 = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(x0$23);
        return new $c_Lamf_client_model_domain_SecurityRequirement().init___Lamf_plugins_domain_webapi_models_security_SecurityRequirement(x2$22)
      } else {
        throw new $c_s_MatchError().init___O(x0$23)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$22, builder$22);
  var model$23 = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$();
  var builder$23 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$24) {
    return (function(x0$24$2) {
      var x0$24 = $as_Lamf_core_model_domain_AmfObject(x0$24$2);
      if ((x0$24 instanceof $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme)) {
        var x2$23 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(x0$24);
        return new $c_Lamf_client_model_domain_SecurityScheme().init___Lamf_plugins_domain_webapi_models_security_SecurityScheme(x2$23)
      } else {
        throw new $c_s_MatchError().init___O(x0$24)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$23, builder$23);
  var model$24 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$();
  var builder$24 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$25) {
    return (function(x0$25$2) {
      var x0$25 = $as_Lamf_core_model_domain_AmfObject(x0$25$2);
      if ((x0$25 instanceof $c_Lamf_plugins_domain_webapi_models_Payload)) {
        var x2$24 = $as_Lamf_plugins_domain_webapi_models_Payload(x0$25);
        return new $c_Lamf_client_model_domain_Payload().init___Lamf_plugins_domain_webapi_models_Payload(x2$24)
      } else {
        throw new $c_s_MatchError().init___O(x0$25)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$24, builder$24);
  var model$25 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$();
  var builder$25 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$26) {
    return (function(x0$26$2) {
      var x0$26 = $as_Lamf_core_model_domain_AmfObject(x0$26$2);
      if ((x0$26 instanceof $c_Lamf_plugins_domain_webapi_models_Request)) {
        var x2$25 = $as_Lamf_plugins_domain_webapi_models_Request(x0$26);
        return new $c_Lamf_client_model_domain_Request().init___Lamf_plugins_domain_webapi_models_Request(x2$25)
      } else {
        throw new $c_s_MatchError().init___O(x0$26)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$25, builder$25);
  var model$26 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$();
  var builder$26 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$27) {
    return (function(x0$27$2) {
      var x0$27 = $as_Lamf_core_model_domain_AmfObject(x0$27$2);
      if ((x0$27 instanceof $c_Lamf_plugins_domain_webapi_models_Response)) {
        var x2$26 = $as_Lamf_plugins_domain_webapi_models_Response(x0$27);
        return new $c_Lamf_client_model_domain_Response().init___Lamf_plugins_domain_webapi_models_Response(x2$26)
      } else {
        throw new $c_s_MatchError().init___O(x0$27)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$26, builder$26);
  var model$27 = $m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$();
  var builder$27 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$28) {
    return (function(x0$28$2) {
      var x0$28 = $as_Lamf_core_model_domain_AmfObject(x0$28$2);
      if ((x0$28 instanceof $c_Lamf_plugins_domain_webapi_models_security_Scope)) {
        var x2$27 = $as_Lamf_plugins_domain_webapi_models_security_Scope(x0$28);
        return new $c_Lamf_client_model_domain_Scope().init___Lamf_plugins_domain_webapi_models_security_Scope(x2$27)
      } else {
        throw new $c_s_MatchError().init___O(x0$28)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$27, builder$27);
  var model$28 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$();
  var builder$28 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$29) {
    return (function(x0$29$2) {
      var x0$29 = $as_Lamf_core_model_domain_AmfObject(x0$29$2);
      if ((x0$29 instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow)) {
        var x2$28 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow(x0$29);
        return new $c_Lamf_client_model_domain_OAuth2Flow().init___Lamf_plugins_domain_webapi_models_security_OAuth2Flow(x2$28)
      } else {
        throw new $c_s_MatchError().init___O(x0$29)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$28, builder$28);
  var model$29 = $m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$();
  var builder$29 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$30) {
    return (function(x0$30$2) {
      var x0$30 = $as_Lamf_core_model_domain_AmfObject(x0$30$2);
      if ((x0$30 instanceof $c_Lamf_plugins_domain_webapi_models_security_Settings)) {
        var x2$29 = $as_Lamf_plugins_domain_webapi_models_security_Settings(x0$30);
        return new $c_Lamf_client_model_domain_Settings().init___Lamf_plugins_domain_webapi_models_security_Settings(x2$29)
      } else {
        throw new $c_s_MatchError().init___O(x0$30)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$29, builder$29);
  var model$30 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$();
  var builder$30 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$31) {
    return (function(x0$31$2) {
      var x0$31 = $as_Lamf_core_model_domain_AmfObject(x0$31$2);
      if ((x0$31 instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)) {
        var x2$30 = $as_Lamf_plugins_domain_webapi_models_WebApi(x0$31);
        return new $c_Lamf_client_model_domain_WebApi().init___Lamf_plugins_domain_webapi_models_WebApi(x2$30)
      } else {
        throw new $c_s_MatchError().init___O(x0$31)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$30, builder$30);
  var model$31 = $m_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$();
  var builder$31 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$32) {
    return (function(x0$32$2) {
      var x0$32 = $as_Lamf_core_model_domain_AmfObject(x0$32$2);
      if ((x0$32 instanceof $c_Lamf_plugins_domain_webapi_models_templates_Trait)) {
        var x2$31 = $as_Lamf_plugins_domain_webapi_models_templates_Trait(x0$32);
        return new $c_Lamf_client_model_domain_Trait().init___Lamf_plugins_domain_webapi_models_templates_Trait(x2$31)
      } else {
        throw new $c_s_MatchError().init___O(x0$32)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$31, builder$31);
  var model$32 = $m_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$();
  var builder$32 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$33) {
    return (function(x0$33$2) {
      var x0$33 = $as_Lamf_core_model_domain_AmfObject(x0$33$2);
      if ((x0$33 instanceof $c_Lamf_plugins_domain_webapi_models_templates_ResourceType)) {
        var x2$32 = $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(x0$33);
        return new $c_Lamf_client_model_domain_ResourceType().init___Lamf_plugins_domain_webapi_models_templates_ResourceType(x2$32)
      } else {
        throw new $c_s_MatchError().init___O(x0$33)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$32, builder$32);
  var model$33 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$();
  var builder$33 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$34) {
    return (function(x0$34$2) {
      var x0$34 = $as_Lamf_core_model_domain_AmfObject(x0$34$2);
      if ((x0$34 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
        var x2$33 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x0$34);
        return new $c_Lamf_client_model_domain_AnyShape().init___Lamf_plugins_domain_shapes_models_AnyShape(x2$33)
      } else {
        throw new $c_s_MatchError().init___O(x0$34)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$33, builder$33);
  var model$34 = $m_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$();
  var builder$34 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$35) {
    return (function(x0$35$2) {
      var x0$35 = $as_Lamf_core_model_domain_AmfObject(x0$35$2);
      if ((x0$35 instanceof $c_Lamf_plugins_domain_shapes_models_NilShape)) {
        var x2$34 = $as_Lamf_plugins_domain_shapes_models_NilShape(x0$35);
        return new $c_Lamf_client_model_domain_NilShape().init___Lamf_plugins_domain_shapes_models_NilShape(x2$34)
      } else {
        throw new $c_s_MatchError().init___O(x0$35)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$34, builder$34);
  var model$35 = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$();
  var builder$35 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$36) {
    return (function(x0$36$2) {
      var x0$36 = $as_Lamf_core_model_domain_AmfObject(x0$36$2);
      if ((x0$36 instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
        var x2$35 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(x0$36);
        return new $c_Lamf_client_model_domain_ArrayShape().init___Lamf_plugins_domain_shapes_models_ArrayShape(x2$35)
      } else {
        throw new $c_s_MatchError().init___O(x0$36)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$35, builder$35);
  var model$36 = $m_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$();
  var builder$36 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$37) {
    return (function(x0$37$2) {
      var x0$37 = $as_Lamf_core_model_domain_AmfObject(x0$37$2);
      if ((x0$37 instanceof $c_Lamf_plugins_domain_shapes_models_MatrixShape)) {
        var x2$36 = $as_Lamf_plugins_domain_shapes_models_MatrixShape(x0$37);
        return new $c_Lamf_client_model_domain_MatrixShape().init___Lamf_plugins_domain_shapes_models_ArrayShape(x2$36.toArrayShape__Lamf_plugins_domain_shapes_models_ArrayShape())
      } else {
        throw new $c_s_MatchError().init___O(x0$37)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$36, builder$36);
  var model$37 = $m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$();
  var builder$37 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$38) {
    return (function(x0$38$2) {
      var x0$38 = $as_Lamf_core_model_domain_AmfObject(x0$38$2);
      if ((x0$38 instanceof $c_Lamf_plugins_domain_shapes_models_TupleShape)) {
        var x2$37 = $as_Lamf_plugins_domain_shapes_models_TupleShape(x0$38);
        return new $c_Lamf_client_model_domain_TupleShape().init___Lamf_plugins_domain_shapes_models_TupleShape(x2$37)
      } else {
        throw new $c_s_MatchError().init___O(x0$38)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$37, builder$37);
  var model$38 = $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$();
  var builder$38 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$39) {
    return (function(x0$39$2) {
      var x0$39 = $as_Lamf_core_model_domain_AmfObject(x0$39$2);
      if ((x0$39 instanceof $c_Lamf_plugins_domain_shapes_models_CreativeWork)) {
        var x2$38 = $as_Lamf_plugins_domain_shapes_models_CreativeWork(x0$39);
        return new $c_Lamf_client_model_domain_CreativeWork().init___Lamf_plugins_domain_shapes_models_CreativeWork(x2$38)
      } else {
        throw new $c_s_MatchError().init___O(x0$39)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$38, builder$38);
  var model$39 = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$();
  var builder$39 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$40) {
    return (function(x0$40$2) {
      var x0$40 = $as_Lamf_core_model_domain_AmfObject(x0$40$2);
      if ((x0$40 instanceof $c_Lamf_plugins_domain_shapes_models_Example)) {
        var x2$39 = $as_Lamf_plugins_domain_shapes_models_Example(x0$40);
        return new $c_Lamf_client_model_domain_Example().init___Lamf_plugins_domain_shapes_models_Example(x2$39)
      } else {
        throw new $c_s_MatchError().init___O(x0$40)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$39, builder$39);
  var model$40 = $m_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$();
  var builder$40 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$41) {
    return (function(x0$41$2) {
      var x0$41 = $as_Lamf_core_model_domain_AmfObject(x0$41$2);
      if ((x0$41 instanceof $c_Lamf_plugins_domain_shapes_models_FileShape)) {
        var x2$40 = $as_Lamf_plugins_domain_shapes_models_FileShape(x0$41);
        return new $c_Lamf_client_model_domain_FileShape().init___Lamf_plugins_domain_shapes_models_FileShape(x2$40)
      } else {
        throw new $c_s_MatchError().init___O(x0$41)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$40, builder$40);
  var model$41 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$();
  var builder$41 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$42) {
    return (function(x0$42$2) {
      var x0$42 = $as_Lamf_core_model_domain_AmfObject(x0$42$2);
      if ((x0$42 instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
        var x2$41 = $as_Lamf_plugins_domain_shapes_models_NodeShape(x0$42);
        return new $c_Lamf_client_model_domain_NodeShape().init___Lamf_plugins_domain_shapes_models_NodeShape(x2$41)
      } else {
        throw new $c_s_MatchError().init___O(x0$42)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$41, builder$41);
  var model$42 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$();
  var builder$42 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$43) {
    return (function(x0$43$2) {
      var x0$43 = $as_Lamf_core_model_domain_AmfObject(x0$43$2);
      if ((x0$43 instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
        var x2$42 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(x0$43);
        return new $c_Lamf_client_model_domain_ScalarShape().init___Lamf_plugins_domain_shapes_models_ScalarShape(x2$42)
      } else {
        throw new $c_s_MatchError().init___O(x0$43)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$42, builder$42);
  var model$43 = $m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$();
  var builder$43 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$44) {
    return (function(x0$44$2) {
      var x0$44 = $as_Lamf_core_model_domain_AmfObject(x0$44$2);
      if ((x0$44 instanceof $c_Lamf_plugins_domain_shapes_models_SchemaShape)) {
        var x2$43 = $as_Lamf_plugins_domain_shapes_models_SchemaShape(x0$44);
        return new $c_Lamf_client_model_domain_SchemaShape().init___Lamf_plugins_domain_shapes_models_SchemaShape(x2$43)
      } else {
        throw new $c_s_MatchError().init___O(x0$44)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$43, builder$43);
  var model$44 = $m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$();
  var builder$44 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$45) {
    return (function(x0$45$2) {
      var x0$45 = $as_Lamf_core_model_domain_AmfObject(x0$45$2);
      if ((x0$45 instanceof $c_Lamf_plugins_domain_shapes_models_XMLSerializer)) {
        var x2$44 = $as_Lamf_plugins_domain_shapes_models_XMLSerializer(x0$45);
        return new $c_Lamf_client_model_domain_XMLSerializer().init___Lamf_plugins_domain_shapes_models_XMLSerializer(x2$44)
      } else {
        throw new $c_s_MatchError().init___O(x0$45)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$44, builder$44);
  var model$45 = $m_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$();
  var builder$45 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$46) {
    return (function(x0$46$2) {
      var x0$46 = $as_Lamf_core_model_domain_AmfObject(x0$46$2);
      if ((x0$46 instanceof $c_Lamf_plugins_domain_shapes_models_PropertyDependencies)) {
        var x2$45 = $as_Lamf_plugins_domain_shapes_models_PropertyDependencies(x0$46);
        return new $c_Lamf_client_model_domain_PropertyDependencies().init___Lamf_plugins_domain_shapes_models_PropertyDependencies(x2$45)
      } else {
        throw new $c_s_MatchError().init___O(x0$46)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$45, builder$45);
  var model$46 = $m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$();
  var builder$46 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$47) {
    return (function(x0$47$2) {
      var x0$47 = $as_Lamf_core_model_domain_AmfObject(x0$47$2);
      if ((x0$47 instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
        var x2$46 = $as_Lamf_plugins_domain_shapes_models_UnionShape(x0$47);
        return new $c_Lamf_client_model_domain_UnionShape().init___Lamf_plugins_domain_shapes_models_UnionShape(x2$46)
      } else {
        throw new $c_s_MatchError().init___O(x0$47)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$46, builder$46);
  var model$47 = $m_Lamf_core_metamodel_domain_RecursiveShapeModel$();
  var builder$47 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$48) {
    return (function(x0$48$2) {
      var x0$48 = $as_Lamf_core_model_domain_AmfObject(x0$48$2);
      if ((x0$48 instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
        var x2$47 = $as_Lamf_core_model_domain_RecursiveShape(x0$48);
        return new $c_Lamf_client_model_domain_RecursiveShape().init___Lamf_core_model_domain_RecursiveShape(x2$47)
      } else {
        throw new $c_s_MatchError().init___O(x0$48)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$47, builder$47);
  var model$48 = $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$();
  var builder$48 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$49) {
    return (function(x0$49$2) {
      var x0$49 = $as_Lamf_core_model_domain_AmfObject(x0$49$2);
      if ((x0$49 instanceof $c_Lamf_plugins_domain_webapi_models_TemplatedLink)) {
        var x2$48 = $as_Lamf_plugins_domain_webapi_models_TemplatedLink(x0$49);
        return new $c_Lamf_client_model_domain_TemplatedLink().init___Lamf_plugins_domain_webapi_models_TemplatedLink(x2$48)
      } else {
        throw new $c_s_MatchError().init___O(x0$49)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$48, builder$48);
  var model$49 = $m_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$();
  var builder$49 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$50) {
    return (function(x0$50$2) {
      var x0$50 = $as_Lamf_core_model_domain_AmfObject(x0$50$2);
      if ((x0$50 instanceof $c_Lamf_plugins_domain_webapi_models_IriTemplateMapping)) {
        var x2$49 = $as_Lamf_plugins_domain_webapi_models_IriTemplateMapping(x0$50);
        return new $c_Lamf_client_model_domain_IriTemplateMapping().init___Lamf_plugins_domain_webapi_models_IriTemplateMapping(x2$49)
      } else {
        throw new $c_s_MatchError().init___O(x0$50)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$49, builder$49);
  var model$50 = $m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$();
  var builder$50 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$51) {
    return (function(x0$51$2) {
      var x0$51 = $as_Lamf_core_model_domain_AmfObject(x0$51$2);
      if ((x0$51 instanceof $c_Lamf_plugins_domain_webapi_models_CorrelationId)) {
        var x2$50 = $as_Lamf_plugins_domain_webapi_models_CorrelationId(x0$51);
        return new $c_Lamf_client_model_domain_CorrelationId().init___Lamf_plugins_domain_webapi_models_CorrelationId(x2$50)
      } else {
        throw new $c_s_MatchError().init___O(x0$51)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$50, builder$50);
  var model$51 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$();
  var builder$51 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$52) {
    return (function(x0$52$2) {
      var x0$52 = $as_Lamf_core_model_domain_AmfObject(x0$52$2);
      if ((x0$52 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding)) {
        var x2$51 = $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding(x0$52);
        return new $c_Lamf_client_model_domain_Amqp091ChannelBinding().init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding(x2$51)
      } else {
        throw new $c_s_MatchError().init___O(x0$52)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$51, builder$51);
  var model$52 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$();
  var builder$52 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$53) {
    return (function(x0$53$2) {
      var x0$53 = $as_Lamf_core_model_domain_AmfObject(x0$53$2);
      if ((x0$53 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings)) {
        var x2$52 = $as_Lamf_plugins_domain_webapi_models_bindings_OperationBindings(x0$53);
        return new $c_Lamf_client_model_domain_OperationBindings().init___Lamf_plugins_domain_webapi_models_bindings_OperationBindings(x2$52)
      } else {
        throw new $c_s_MatchError().init___O(x0$53)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$52, builder$52);
  var model$53 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$();
  var builder$53 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$54) {
    return (function(x0$54$2) {
      var x0$54 = $as_Lamf_core_model_domain_AmfObject(x0$54$2);
      if ((x0$54 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings)) {
        var x2$53 = $as_Lamf_plugins_domain_webapi_models_bindings_ServerBindings(x0$54);
        return new $c_Lamf_client_model_domain_ServerBindings().init___Lamf_plugins_domain_webapi_models_bindings_ServerBindings(x2$53)
      } else {
        throw new $c_s_MatchError().init___O(x0$54)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$53, builder$53);
  var model$54 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$();
  var builder$54 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$55) {
    return (function(x0$55$2) {
      var x0$55 = $as_Lamf_core_model_domain_AmfObject(x0$55$2);
      if ((x0$55 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings)) {
        var x2$54 = $as_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings(x0$55);
        return new $c_Lamf_client_model_domain_ChannelBindings().init___Lamf_plugins_domain_webapi_models_bindings_ChannelBindings(x2$54)
      } else {
        throw new $c_s_MatchError().init___O(x0$55)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$54, builder$54);
  var model$55 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$();
  var builder$55 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$56) {
    return (function(x0$56$2) {
      var x0$56 = $as_Lamf_core_model_domain_AmfObject(x0$56$2);
      if ((x0$56 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings)) {
        var x2$55 = $as_Lamf_plugins_domain_webapi_models_bindings_MessageBindings(x0$56);
        return new $c_Lamf_client_model_domain_MessageBindings().init___Lamf_plugins_domain_webapi_models_bindings_MessageBindings(x2$55)
      } else {
        throw new $c_s_MatchError().init___O(x0$56)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$55, builder$55);
  var model$56 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$();
  var builder$56 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$57) {
    return (function(x0$57$2) {
      var x0$57 = $as_Lamf_core_model_domain_AmfObject(x0$57$2);
      if ((x0$57 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange)) {
        var x2$56 = $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange(x0$57);
        return new $c_Lamf_client_model_domain_Amqp091ChannelExchange().init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange(x2$56)
      } else {
        throw new $c_s_MatchError().init___O(x0$57)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$56, builder$56);
  var model$57 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$();
  var builder$57 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$58) {
    return (function(x0$58$2) {
      var x0$58 = $as_Lamf_core_model_domain_AmfObject(x0$58$2);
      if ((x0$58 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue)) {
        var x2$57 = $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue(x0$58);
        return new $c_Lamf_client_model_domain_Amqp091Queue().init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue(x2$57)
      } else {
        throw new $c_s_MatchError().init___O(x0$58)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$57, builder$57);
  var model$58 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$();
  var builder$58 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$59) {
    return (function(x0$59$2) {
      var x0$59 = $as_Lamf_core_model_domain_AmfObject(x0$59$2);
      if ((x0$59 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding)) {
        var x2$58 = $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding(x0$59);
        return new $c_Lamf_client_model_domain_Amqp091MessageBinding().init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding(x2$58)
      } else {
        throw new $c_s_MatchError().init___O(x0$59)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$58, builder$58);
  var model$59 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$();
  var builder$59 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$60) {
    return (function(x0$60$2) {
      var x0$60 = $as_Lamf_core_model_domain_AmfObject(x0$60$2);
      if ((x0$60 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding)) {
        var x2$59 = $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding(x0$60);
        return new $c_Lamf_client_model_domain_Amqp091OperationBinding().init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding(x2$59)
      } else {
        throw new $c_s_MatchError().init___O(x0$60)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$59, builder$59);
  var model$60 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$();
  var builder$60 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$61) {
    return (function(x0$61$2) {
      var x0$61 = $as_Lamf_core_model_domain_AmfObject(x0$61$2);
      if ((x0$61 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding)) {
        var x2$60 = $as_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding(x0$61);
        return new $c_Lamf_client_model_domain_HttpMessageBinding().init___Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding(x2$60)
      } else {
        throw new $c_s_MatchError().init___O(x0$61)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$60, builder$60);
  var model$61 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$();
  var builder$61 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$62) {
    return (function(x0$62$2) {
      var x0$62 = $as_Lamf_core_model_domain_AmfObject(x0$62$2);
      if ((x0$62 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding)) {
        var x2$61 = $as_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding(x0$62);
        return new $c_Lamf_client_model_domain_HttpOperationBinding().init___Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding(x2$61)
      } else {
        throw new $c_s_MatchError().init___O(x0$62)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$61, builder$61);
  var model$62 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$();
  var builder$62 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$63) {
    return (function(x0$63$2) {
      var x0$63 = $as_Lamf_core_model_domain_AmfObject(x0$63$2);
      if ((x0$63 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding)) {
        var x2$62 = $as_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding(x0$63);
        return new $c_Lamf_client_model_domain_KafkaMessageBinding().init___Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding(x2$62)
      } else {
        throw new $c_s_MatchError().init___O(x0$63)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$62, builder$62);
  var model$63 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$();
  var builder$63 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$64) {
    return (function(x0$64$2) {
      var x0$64 = $as_Lamf_core_model_domain_AmfObject(x0$64$2);
      if ((x0$64 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding)) {
        var x2$63 = $as_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding(x0$64);
        return new $c_Lamf_client_model_domain_KafkaOperationBinding().init___Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding(x2$63)
      } else {
        throw new $c_s_MatchError().init___O(x0$64)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$63, builder$63);
  var model$64 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$();
  var builder$64 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$65) {
    return (function(x0$65$2) {
      var x0$65 = $as_Lamf_core_model_domain_AmfObject(x0$65$2);
      if ((x0$65 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding)) {
        var x2$64 = $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding(x0$65);
        return new $c_Lamf_client_model_domain_MqttMessageBinding().init___Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding(x2$64)
      } else {
        throw new $c_s_MatchError().init___O(x0$65)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$64, builder$64);
  var model$65 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$();
  var builder$65 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$66) {
    return (function(x0$66$2) {
      var x0$66 = $as_Lamf_core_model_domain_AmfObject(x0$66$2);
      if ((x0$66 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding)) {
        var x2$65 = $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding(x0$66);
        return new $c_Lamf_client_model_domain_MqttOperationBinding().init___Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding(x2$65)
      } else {
        throw new $c_s_MatchError().init___O(x0$66)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$65, builder$65);
  var model$66 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$();
  var builder$66 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$67) {
    return (function(x0$67$2) {
      var x0$67 = $as_Lamf_core_model_domain_AmfObject(x0$67$2);
      if ((x0$67 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding)) {
        var x2$66 = $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding(x0$67);
        return new $c_Lamf_client_model_domain_MqttServerBinding().init___Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding(x2$66)
      } else {
        throw new $c_s_MatchError().init___O(x0$67)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$66, builder$66);
  var model$67 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$();
  var builder$67 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$68) {
    return (function(x0$68$2) {
      var x0$68 = $as_Lamf_core_model_domain_AmfObject(x0$68$2);
      if ((x0$68 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill)) {
        var x2$67 = $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill(x0$68);
        return new $c_Lamf_client_model_domain_MqttServerLastWill().init___Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill(x2$67)
      } else {
        throw new $c_s_MatchError().init___O(x0$68)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$67, builder$67);
  var model$68 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$();
  var builder$68 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$69) {
    return (function(x0$69$2) {
      var x0$69 = $as_Lamf_core_model_domain_AmfObject(x0$69$2);
      if ((x0$69 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding)) {
        var x2$68 = $as_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding(x0$69);
        return new $c_Lamf_client_model_domain_WebSocketsChannelBinding().init___Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding(x2$68)
      } else {
        throw new $c_s_MatchError().init___O(x0$69)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$68, builder$68);
  var model$69 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$();
  var builder$69 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$70) {
    return (function(x0$70$2) {
      var x0$70 = $as_Lamf_core_model_domain_AmfObject(x0$70$2);
      if ((x0$70 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding)) {
        var x2$69 = $as_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding(x0$70);
        return new $c_Lamf_client_model_domain_DynamicBinding().init___Lamf_plugins_domain_webapi_models_bindings_DynamicBinding(x2$69)
      } else {
        throw new $c_s_MatchError().init___O(x0$70)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$69, builder$69);
  var model$70 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$();
  var builder$70 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$71) {
    return (function(x0$71$2) {
      var x0$71 = $as_Lamf_core_model_domain_AmfObject(x0$71$2);
      if ((x0$71 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding)) {
        var x2$70 = $as_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding(x0$71);
        return new $c_Lamf_client_model_domain_EmptyBinding().init___Lamf_plugins_domain_webapi_models_bindings_EmptyBinding(x2$70)
      } else {
        throw new $c_s_MatchError().init___O(x0$71)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$70, builder$70);
  var v = $m_Lamf_plugins_features_validation_CoreValidations$().validations$1;
  var l = $m_Lamf_plugins_features_validation_CoreValidations$().levels$1;
  $f_Lamf_core_remote_Platform__registerValidations__sc_Seq__sci_Map__V(platform, v, l);
  var v$1 = $m_Lamf_validation_DialectValidations$().validations$1;
  var l$1 = $m_Lamf_validation_DialectValidations$().levels$1;
  $f_Lamf_core_remote_Platform__registerValidations__sc_Seq__sci_Map__V(platform, v$1, l$1);
  var v$2 = $m_Lamf_validations_ParserSideValidations$().validations$1;
  var l$2 = $m_Lamf_validations_ParserSideValidations$().levels$1;
  $f_Lamf_core_remote_Platform__registerValidations__sc_Seq__sci_Map__V(platform, v$2, l$2);
  var v$3 = $m_Lamf_validations_PayloadValidations$().validations$1;
  var l$3 = $m_Lamf_validations_PayloadValidations$().levels$1;
  $f_Lamf_core_remote_Platform__registerValidations__sc_Seq__sci_Map__V(platform, v$3, l$3);
  var v$4 = $m_Lamf_validations_RenderSideValidations$().validations$1;
  var l$4 = $m_Lamf_validations_RenderSideValidations$().levels$1;
  $f_Lamf_core_remote_Platform__registerValidations__sc_Seq__sci_Map__V(platform, v$4, l$4);
  var v$5 = $m_Lamf_validations_ResolutionSideValidations$().validations$1;
  var l$5 = $m_Lamf_validations_ResolutionSideValidations$().levels$1;
  $f_Lamf_core_remote_Platform__registerValidations__sc_Seq__sci_Map__V(platform, v$5, l$5);
  $m_Lamf_Core$();
  var plugin = $m_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$();
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V(plugin)
});
var $d_Lamf_client_convert_WebApiRegister$ = new $TypeData().initClass({
  Lamf_client_convert_WebApiRegister$: 0
}, false, "amf.client.convert.WebApiRegister$", {
  Lamf_client_convert_WebApiRegister$: 1,
  O: 1
});
$c_Lamf_client_convert_WebApiRegister$.prototype.$classData = $d_Lamf_client_convert_WebApiRegister$;
var $n_Lamf_client_convert_WebApiRegister$ = (void 0);
function $m_Lamf_client_convert_WebApiRegister$() {
  if ((!$n_Lamf_client_convert_WebApiRegister$)) {
    $n_Lamf_client_convert_WebApiRegister$ = new $c_Lamf_client_convert_WebApiRegister$().init___()
  };
  return $n_Lamf_client_convert_WebApiRegister$
}
/** @constructor */
function $c_Lamf_client_execution_BaseExecutionEnvironment() {
  $c_O.call(this);
  this.$$undinternal$1 = null
}
$c_Lamf_client_execution_BaseExecutionEnvironment.prototype = new $h_O();
$c_Lamf_client_execution_BaseExecutionEnvironment.prototype.constructor = $c_Lamf_client_execution_BaseExecutionEnvironment;
/** @constructor */
function $h_Lamf_client_execution_BaseExecutionEnvironment() {
  /*<skip>*/
}
$h_Lamf_client_execution_BaseExecutionEnvironment.prototype = $c_Lamf_client_execution_BaseExecutionEnvironment.prototype;
$c_Lamf_client_execution_BaseExecutionEnvironment.prototype.init___Lamf_core_execution_ExecutionEnvironment = (function(_internal) {
  this.$$undinternal$1 = _internal;
  return this
});
function $as_Lamf_client_execution_BaseExecutionEnvironment(obj) {
  return (((obj instanceof $c_Lamf_client_execution_BaseExecutionEnvironment) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.execution.BaseExecutionEnvironment"))
}
function $isArrayOf_Lamf_client_execution_BaseExecutionEnvironment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_execution_BaseExecutionEnvironment)))
}
function $asArrayOf_Lamf_client_execution_BaseExecutionEnvironment(obj, depth) {
  return (($isArrayOf_Lamf_client_execution_BaseExecutionEnvironment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.execution.BaseExecutionEnvironment;", depth))
}
/** @constructor */
function $c_Lamf_client_execution_DefaultExecutionEnvironment$() {
  $c_O.call(this)
}
$c_Lamf_client_execution_DefaultExecutionEnvironment$.prototype = new $h_O();
$c_Lamf_client_execution_DefaultExecutionEnvironment$.prototype.constructor = $c_Lamf_client_execution_DefaultExecutionEnvironment$;
/** @constructor */
function $h_Lamf_client_execution_DefaultExecutionEnvironment$() {
  /*<skip>*/
}
$h_Lamf_client_execution_DefaultExecutionEnvironment$.prototype = $c_Lamf_client_execution_DefaultExecutionEnvironment$.prototype;
$c_Lamf_client_execution_DefaultExecutionEnvironment$.prototype.init___ = (function() {
  return this
});
$c_Lamf_client_execution_DefaultExecutionEnvironment$.prototype.$$js$exported$meth$apply__O = (function() {
  return new $c_Lamf_client_execution_ExecutionEnvironment().init___()
});
$c_Lamf_client_execution_DefaultExecutionEnvironment$.prototype.apply = (function() {
  return this.$$js$exported$meth$apply__O()
});
var $d_Lamf_client_execution_DefaultExecutionEnvironment$ = new $TypeData().initClass({
  Lamf_client_execution_DefaultExecutionEnvironment$: 0
}, false, "amf.client.execution.DefaultExecutionEnvironment$", {
  Lamf_client_execution_DefaultExecutionEnvironment$: 1,
  O: 1
});
$c_Lamf_client_execution_DefaultExecutionEnvironment$.prototype.$classData = $d_Lamf_client_execution_DefaultExecutionEnvironment$;
var $n_Lamf_client_execution_DefaultExecutionEnvironment$ = (void 0);
function $m_Lamf_client_execution_DefaultExecutionEnvironment$() {
  if ((!$n_Lamf_client_execution_DefaultExecutionEnvironment$)) {
    $n_Lamf_client_execution_DefaultExecutionEnvironment$ = new $c_Lamf_client_execution_DefaultExecutionEnvironment$().init___()
  };
  return $n_Lamf_client_execution_DefaultExecutionEnvironment$
}
/** @constructor */
function $c_Lamf_client_handler_ErrorHandler$() {
  $c_O.call(this)
}
$c_Lamf_client_handler_ErrorHandler$.prototype = new $h_O();
$c_Lamf_client_handler_ErrorHandler$.prototype.constructor = $c_Lamf_client_handler_ErrorHandler$;
/** @constructor */
function $h_Lamf_client_handler_ErrorHandler$() {
  /*<skip>*/
}
$h_Lamf_client_handler_ErrorHandler$.prototype = $c_Lamf_client_handler_ErrorHandler$.prototype;
$c_Lamf_client_handler_ErrorHandler$.prototype.init___ = (function() {
  return this
});
$c_Lamf_client_handler_ErrorHandler$.prototype.$$js$exported$meth$handler__Lamf_client_handler_JsErrorHandler__O = (function(obj) {
  return this.handler__Lamf_client_handler_JsErrorHandler__Lamf_client_resolve_ClientErrorHandler(obj)
});
$c_Lamf_client_handler_ErrorHandler$.prototype.handler__Lamf_client_handler_JsErrorHandler__Lamf_client_resolve_ClientErrorHandler = (function(obj) {
  return new $c_Lamf_client_handler_ErrorHandler$$$Lambda$1().init___O((function($this, obj$1) {
    return (function(id$2, node$2, property$2, message$2, range$2, level$2, location$2) {
      var id = $as_T(id$2);
      var node = $as_T(node$2);
      var message = $as_T(message$2);
      var level = $as_T(level$2);
      obj$1.reportConstraint(id, node, property$2, message, range$2, level, location$2)
    })
  })(this, obj))
});
$c_Lamf_client_handler_ErrorHandler$.prototype.handler = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$handler__Lamf_client_handler_JsErrorHandler__O(prep)
});
var $d_Lamf_client_handler_ErrorHandler$ = new $TypeData().initClass({
  Lamf_client_handler_ErrorHandler$: 0
}, false, "amf.client.handler.ErrorHandler$", {
  Lamf_client_handler_ErrorHandler$: 1,
  O: 1
});
$c_Lamf_client_handler_ErrorHandler$.prototype.$classData = $d_Lamf_client_handler_ErrorHandler$;
var $n_Lamf_client_handler_ErrorHandler$ = (void 0);
function $m_Lamf_client_handler_ErrorHandler$() {
  if ((!$n_Lamf_client_handler_ErrorHandler$)) {
    $n_Lamf_client_handler_ErrorHandler$ = new $c_Lamf_client_handler_ErrorHandler$().init___()
  };
  return $n_Lamf_client_handler_ErrorHandler$
}
function $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var from = $thiz.$$undinternal__Lamf_core_model_domain_AmfObject().annotations__Lamf_core_parser_Annotations();
  $m_Lamf_client_convert_CoreClientConverters$().AnnotationsFieldMatcher__Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$();
  return new $c_Lamf_client_model_Annotations().init___Lamf_core_parser_Annotations(from)
}
function $is_Lamf_client_model_AmfObjectWrapper(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_client_model_AmfObjectWrapper)))
}
function $as_Lamf_client_model_AmfObjectWrapper(obj) {
  return (($is_Lamf_client_model_AmfObjectWrapper(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.AmfObjectWrapper"))
}
function $isArrayOf_Lamf_client_model_AmfObjectWrapper(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_AmfObjectWrapper)))
}
function $asArrayOf_Lamf_client_model_AmfObjectWrapper(obj, depth) {
  return (($isArrayOf_Lamf_client_model_AmfObjectWrapper(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.AmfObjectWrapper;", depth))
}
/** @constructor */
function $c_Lamf_client_model_DataTypes$() {
  $c_O.call(this);
  this.String$1 = null;
  this.Integer$1 = null;
  this.Number$1 = null;
  this.Long$1 = null;
  this.Double$1 = null;
  this.Float$1 = null;
  this.Decimal$1 = null;
  this.Boolean$1 = null;
  this.Date$1 = null;
  this.Time$1 = null;
  this.DateTime$1 = null;
  this.DateTimeOnly$1 = null;
  this.File$1 = null;
  this.Byte$1 = null;
  this.Binary$1 = null;
  this.Password$1 = null;
  this.Any$1 = null;
  this.AnyUri$1 = null;
  this.Nil$1 = null
}
$c_Lamf_client_model_DataTypes$.prototype = new $h_O();
$c_Lamf_client_model_DataTypes$.prototype.constructor = $c_Lamf_client_model_DataTypes$;
/** @constructor */
function $h_Lamf_client_model_DataTypes$() {
  /*<skip>*/
}
$h_Lamf_client_model_DataTypes$.prototype = $c_Lamf_client_model_DataTypes$.prototype;
$c_Lamf_client_model_DataTypes$.prototype.init___ = (function() {
  $n_Lamf_client_model_DataTypes$ = this;
  this.String$1 = $m_Lamf_core_model_DataType$().String$1;
  this.Integer$1 = $m_Lamf_core_model_DataType$().Integer$1;
  this.Number$1 = $m_Lamf_core_model_DataType$().Number$1;
  this.Long$1 = $m_Lamf_core_model_DataType$().Long$1;
  this.Double$1 = $m_Lamf_core_model_DataType$().Double$1;
  this.Float$1 = $m_Lamf_core_model_DataType$().Float$1;
  this.Decimal$1 = $m_Lamf_core_model_DataType$().Decimal$1;
  this.Boolean$1 = $m_Lamf_core_model_DataType$().Boolean$1;
  this.Date$1 = $m_Lamf_core_model_DataType$().Date$1;
  this.Time$1 = $m_Lamf_core_model_DataType$().Time$1;
  this.DateTime$1 = $m_Lamf_core_model_DataType$().DateTime$1;
  this.DateTimeOnly$1 = $m_Lamf_core_model_DataType$().DateTimeOnly$1;
  this.File$1 = $m_Lamf_core_model_DataType$().File$1;
  this.Byte$1 = $m_Lamf_core_model_DataType$().Byte$1;
  this.Binary$1 = $m_Lamf_core_model_DataType$().Binary$1;
  this.Password$1 = $m_Lamf_core_model_DataType$().Password$1;
  this.Any$1 = $m_Lamf_core_model_DataType$().Any$1;
  this.AnyUri$1 = $m_Lamf_core_model_DataType$().AnyUri$1;
  this.Nil$1 = $m_Lamf_core_model_DataType$().Nil$1;
  return this
});
$c_Lamf_client_model_DataTypes$.prototype.$$js$exported$prop$AnyUri__O = (function() {
  return this.AnyUri$1
});
$c_Lamf_client_model_DataTypes$.prototype.$$js$exported$prop$Binary__O = (function() {
  return this.Binary$1
});
$c_Lamf_client_model_DataTypes$.prototype.$$js$exported$prop$Long__O = (function() {
  return this.Long$1
});
$c_Lamf_client_model_DataTypes$.prototype.$$js$exported$prop$Boolean__O = (function() {
  return this.Boolean$1
});
$c_Lamf_client_model_DataTypes$.prototype.$$js$exported$prop$File__O = (function() {
  return this.File$1
});
$c_Lamf_client_model_DataTypes$.prototype.$$js$exported$prop$Password__O = (function() {
  return this.Password$1
});
$c_Lamf_client_model_DataTypes$.prototype.$$js$exported$prop$Time__O = (function() {
  return this.Time$1
});
$c_Lamf_client_model_DataTypes$.prototype.$$js$exported$prop$Date__O = (function() {
  return this.Date$1
});
$c_Lamf_client_model_DataTypes$.prototype.$$js$exported$prop$Byte__O = (function() {
  return this.Byte$1
});
$c_Lamf_client_model_DataTypes$.prototype.$$js$exported$prop$Number__O = (function() {
  return this.Number$1
});
$c_Lamf_client_model_DataTypes$.prototype.$$js$exported$prop$Float__O = (function() {
  return this.Float$1
});
$c_Lamf_client_model_DataTypes$.prototype.$$js$exported$prop$Nil__O = (function() {
  return this.Nil$1
});
$c_Lamf_client_model_DataTypes$.prototype.$$js$exported$prop$Double__O = (function() {
  return this.Double$1
});
$c_Lamf_client_model_DataTypes$.prototype.$$js$exported$prop$DateTimeOnly__O = (function() {
  return this.DateTimeOnly$1
});
$c_Lamf_client_model_DataTypes$.prototype.$$js$exported$prop$DateTime__O = (function() {
  return this.DateTime$1
});
$c_Lamf_client_model_DataTypes$.prototype.$$js$exported$prop$String__O = (function() {
  return this.String$1
});
$c_Lamf_client_model_DataTypes$.prototype.$$js$exported$prop$Decimal__O = (function() {
  return this.Decimal$1
});
$c_Lamf_client_model_DataTypes$.prototype.$$js$exported$prop$Integer__O = (function() {
  return this.Integer$1
});
$c_Lamf_client_model_DataTypes$.prototype.$$js$exported$prop$Any__O = (function() {
  return this.Any$1
});
Object.defineProperty($c_Lamf_client_model_DataTypes$.prototype, "Nil", {
  "get": (function() {
    return this.$$js$exported$prop$Nil__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_DataTypes$.prototype, "AnyUri", {
  "get": (function() {
    return this.$$js$exported$prop$AnyUri__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_DataTypes$.prototype, "Any", {
  "get": (function() {
    return this.$$js$exported$prop$Any__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_DataTypes$.prototype, "Password", {
  "get": (function() {
    return this.$$js$exported$prop$Password__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_DataTypes$.prototype, "Binary", {
  "get": (function() {
    return this.$$js$exported$prop$Binary__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_DataTypes$.prototype, "Byte", {
  "get": (function() {
    return this.$$js$exported$prop$Byte__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_DataTypes$.prototype, "File", {
  "get": (function() {
    return this.$$js$exported$prop$File__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_DataTypes$.prototype, "DateTimeOnly", {
  "get": (function() {
    return this.$$js$exported$prop$DateTimeOnly__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_DataTypes$.prototype, "DateTime", {
  "get": (function() {
    return this.$$js$exported$prop$DateTime__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_DataTypes$.prototype, "Time", {
  "get": (function() {
    return this.$$js$exported$prop$Time__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_DataTypes$.prototype, "Date", {
  "get": (function() {
    return this.$$js$exported$prop$Date__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_DataTypes$.prototype, "Boolean", {
  "get": (function() {
    return this.$$js$exported$prop$Boolean__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_DataTypes$.prototype, "Decimal", {
  "get": (function() {
    return this.$$js$exported$prop$Decimal__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_DataTypes$.prototype, "Float", {
  "get": (function() {
    return this.$$js$exported$prop$Float__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_DataTypes$.prototype, "Double", {
  "get": (function() {
    return this.$$js$exported$prop$Double__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_DataTypes$.prototype, "Long", {
  "get": (function() {
    return this.$$js$exported$prop$Long__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_DataTypes$.prototype, "Number", {
  "get": (function() {
    return this.$$js$exported$prop$Number__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_DataTypes$.prototype, "Integer", {
  "get": (function() {
    return this.$$js$exported$prop$Integer__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_DataTypes$.prototype, "String", {
  "get": (function() {
    return this.$$js$exported$prop$String__O()
  }),
  "configurable": true
});
var $d_Lamf_client_model_DataTypes$ = new $TypeData().initClass({
  Lamf_client_model_DataTypes$: 0
}, false, "amf.client.model.DataTypes$", {
  Lamf_client_model_DataTypes$: 1,
  O: 1
});
$c_Lamf_client_model_DataTypes$.prototype.$classData = $d_Lamf_client_model_DataTypes$;
var $n_Lamf_client_model_DataTypes$ = (void 0);
function $m_Lamf_client_model_DataTypes$() {
  if ((!$n_Lamf_client_model_DataTypes$)) {
    $n_Lamf_client_model_DataTypes$ = new $c_Lamf_client_model_DataTypes$().init___()
  };
  return $n_Lamf_client_model_DataTypes$
}
/** @constructor */
function $c_Lamf_client_parse_DefaultParserErrorHandler$() {
  $c_O.call(this)
}
$c_Lamf_client_parse_DefaultParserErrorHandler$.prototype = new $h_O();
$c_Lamf_client_parse_DefaultParserErrorHandler$.prototype.constructor = $c_Lamf_client_parse_DefaultParserErrorHandler$;
/** @constructor */
function $h_Lamf_client_parse_DefaultParserErrorHandler$() {
  /*<skip>*/
}
$h_Lamf_client_parse_DefaultParserErrorHandler$.prototype = $c_Lamf_client_parse_DefaultParserErrorHandler$.prototype;
$c_Lamf_client_parse_DefaultParserErrorHandler$.prototype.init___ = (function() {
  return this
});
$c_Lamf_client_parse_DefaultParserErrorHandler$.prototype.fromErrorHandler__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_errorhandler_AmfParserErrorHandler = (function(errorHandler) {
  if ($is_Lamf_core_parser_errorhandler_AmfParserErrorHandler(errorHandler)) {
    var x2 = $as_Lamf_core_parser_errorhandler_AmfParserErrorHandler(errorHandler);
    return x2
  } else if ($is_Lamf_core_errorhandling_AmfResultErrorHandler(errorHandler)) {
    var x3 = $as_Lamf_core_errorhandling_AmfResultErrorHandler(errorHandler);
    return new $c_Lamf_client_parse_DefaultParserErrorHandler$$anon$1().init___Lamf_core_errorhandling_AmfResultErrorHandler(x3)
  } else if ((errorHandler !== null)) {
    return new $c_Lamf_client_parse_DefaultParserErrorHandler$$anon$2().init___Lamf_core_errorhandling_ErrorHandler(errorHandler)
  } else {
    throw new $c_s_MatchError().init___O(errorHandler)
  }
});
var $d_Lamf_client_parse_DefaultParserErrorHandler$ = new $TypeData().initClass({
  Lamf_client_parse_DefaultParserErrorHandler$: 0
}, false, "amf.client.parse.DefaultParserErrorHandler$", {
  Lamf_client_parse_DefaultParserErrorHandler$: 1,
  O: 1
});
$c_Lamf_client_parse_DefaultParserErrorHandler$.prototype.$classData = $d_Lamf_client_parse_DefaultParserErrorHandler$;
var $n_Lamf_client_parse_DefaultParserErrorHandler$ = (void 0);
function $m_Lamf_client_parse_DefaultParserErrorHandler$() {
  if ((!$n_Lamf_client_parse_DefaultParserErrorHandler$)) {
    $n_Lamf_client_parse_DefaultParserErrorHandler$ = new $c_Lamf_client_parse_DefaultParserErrorHandler$().init___()
  };
  return $n_Lamf_client_parse_DefaultParserErrorHandler$
}
/** @constructor */
function $c_Lamf_client_parse_Parser() {
  $c_O.call(this);
  this.vendor$1 = null;
  this.mediaType$1 = null;
  this.env$1 = null;
  this.parsedModel$1 = null;
  this.executionEnvironment$1 = null;
  this.executionContext$1 = null;
  this.DEFAULT$undDOCUMENT$undURL$1 = null
}
$c_Lamf_client_parse_Parser.prototype = new $h_O();
$c_Lamf_client_parse_Parser.prototype.constructor = $c_Lamf_client_parse_Parser;
/** @constructor */
function $h_Lamf_client_parse_Parser() {
  /*<skip>*/
}
$h_Lamf_client_parse_Parser.prototype = $c_Lamf_client_parse_Parser.prototype;
$c_Lamf_client_parse_Parser.prototype.$$js$exported$meth$parseFileAsync__T__O = (function(url) {
  return this.parseFileAsync__T__sjs_js_Promise(url)
});
$c_Lamf_client_parse_Parser.prototype.$$js$exported$meth$reportValidation__Lamf_ProfileName__O = (function(profile) {
  return this.report__p1__Lamf_ProfileName__Lamf_MessageStyle__sjs_js_Promise(profile, $m_Lamf_RAMLStyle$())
});
$c_Lamf_client_parse_Parser.prototype.$$js$exported$meth$parseFileAsync__T__Lamf_core_client_ParsingOptions__O = (function(url, options) {
  return this.parseFileAsync__T__Lamf_core_client_ParsingOptions__sjs_js_Promise(url, options)
});
$c_Lamf_client_parse_Parser.prototype.$$js$exported$meth$parseStringAsync__T__T__Lamf_core_client_ParsingOptions__O = (function(url, stream, options) {
  return this.parseStringAsync__T__T__Lamf_core_client_ParsingOptions__sjs_js_Promise(url, stream, options)
});
$c_Lamf_client_parse_Parser.prototype.parseStringAsync__T__T__Lamf_core_client_ParsingOptions__sjs_js_Promise = (function(url, stream, options) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.parseAsync__T__s_Option__Lamf_core_client_ParsingOptions__s_concurrent_Future(url, new $c_s_Some().init___O(this.fromStream__p1__T__T__Lamf_internal_resource_ResourceLoader(url, stream)), options);
  var m = $m_Lamf_client_convert_CoreClientConverters$().BaseUnitMatcher__Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$();
  var executionContext = this.executionContext$1;
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$1, from, m, executionContext).asClient__O()
});
$c_Lamf_client_parse_Parser.prototype.parseStringAsync__T__Lamf_core_client_ParsingOptions__sjs_js_Promise = (function(stream, options) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.parseAsync__T__s_Option__Lamf_core_client_ParsingOptions__s_concurrent_Future(this.DEFAULT$undDOCUMENT$undURL$1, new $c_s_Some().init___O(this.fromStream__p1__T__T__Lamf_internal_resource_ResourceLoader(this.DEFAULT$undDOCUMENT$undURL$1, stream)), options);
  var m = $m_Lamf_client_convert_CoreClientConverters$().BaseUnitMatcher__Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$();
  var executionContext = this.executionContext$1;
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$1, from, m, executionContext).asClient__O()
});
$c_Lamf_client_parse_Parser.prototype.parseAsync__T__s_Option__Lamf_core_client_ParsingOptions__s_concurrent_Future = (function(url, loader, parsingOptions) {
  var e = this.internalEnv__p1__Lamf_internal_environment_Environment();
  if (loader.isEmpty__Z()) {
    var this$1 = $m_s_None$()
  } else {
    var arg1 = loader.get__O();
    var loader$2 = $as_Lamf_internal_resource_ResourceLoader(arg1);
    var this$1 = new $c_s_Some().init___O(e.add__Lamf_internal_resource_ResourceLoader__Lamf_internal_environment_Environment(loader$2))
  };
  var environment = $as_Lamf_internal_environment_Environment((this$1.isEmpty__Z() ? e : this$1.get__O()));
  var x$2 = $m_s_Option$().apply__O__s_Option(this.mediaType$1);
  var x$3 = new $c_s_Some().init___O(this.vendor$1);
  var x$4 = $m_Lamf_core_remote_Context$().apply__Lamf_core_remote_Platform__Lamf_core_remote_Context($m_Lamf_client_convert_CoreClientConverters$().platform$1);
  var x$6 = new $c_Lamf_core_remote_Cache().init___();
  var x$8 = new $c_Lamf_client_parse_DefaultParserErrorHandler().init___I($m_Lamf_core_AMFCompilerRunCount$().nextRun__I());
  $m_Lamf_core_services_RuntimeCompiler$();
  var x$9 = $m_Lamf_core_parser_UnspecifiedReference$();
  $m_Lamf_core_services_RuntimeCompiler$();
  var x$10 = $m_s_None$();
  return $m_Lamf_core_services_RuntimeCompiler$().apply__T__s_Option__s_Option__Lamf_core_remote_Context__Lamf_core_remote_Cache__Lamf_core_parser_ReferenceKind__s_Option__Lamf_internal_environment_Environment__Lamf_core_client_ParsingOptions__Lamf_core_parser_errorhandler_AmfParserErrorHandler__s_concurrent_ExecutionContext__s_concurrent_Future(url, x$2, x$3, x$4, x$6, x$9, x$10, environment, parsingOptions, x$8, this.executionContext$1).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(model$2) {
      var model = $as_Lamf_core_model_document_BaseUnit(model$2);
      this$3$1.parsedModel$1 = new $c_s_Some().init___O(model);
      return model
    })
  })(this)), this.executionContext$1)
});
$c_Lamf_client_parse_Parser.prototype.$$js$exported$meth$reportCustomValidation__Lamf_ProfileName__T__O = (function(profile, customProfilePath) {
  return this.reportCustomValidationImplementation__p1__Lamf_ProfileName__T__sjs_js_Promise(profile, customProfilePath)
});
$c_Lamf_client_parse_Parser.prototype.reportCustomValidationImplementation__p1__Lamf_ProfileName__T__sjs_js_Promise = (function(profileName, customProfilePath) {
  var x1 = this.parsedModel$1;
  if ((!(x1 instanceof $c_s_Some))) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Cannot validate without parsed model"))
  };
  var x2 = $as_s_Some(x1);
  var model = $as_Lamf_core_model_document_BaseUnit(x2.value$2);
  var x$2 = $m_Lamf_core_errorhandling_UnhandledErrorHandler$();
  $m_Lamf_core_services_RuntimeValidator$();
  var x$3 = $m_Lamf_internal_environment_Environment$().apply__Lamf_internal_environment_Environment();
  var result = $m_Lamf_core_services_RuntimeValidator$().loadValidationProfile__T__Lamf_internal_environment_Environment__Lamf_core_errorhandling_ErrorHandler__s_concurrent_Future(customProfilePath, x$3, x$2).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, model$1, profileName$1) {
    return (function(_$2) {
      $as_Lamf_ProfileName(_$2);
      var x$6 = $this.internalEnv__p1__Lamf_internal_environment_Environment();
      $m_Lamf_core_services_RuntimeValidator$();
      var x$7 = $m_Lamf_AMFStyle$();
      $m_Lamf_core_services_RuntimeValidator$();
      var x$8 = false;
      return $m_Lamf_core_services_RuntimeValidator$().apply__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_internal_environment_Environment__Z__s_concurrent_Future(model$1, profileName$1, x$7, x$6, x$8).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
        return (function(report$2) {
          var report = $as_Lamf_core_validation_AMFValidationReport(report$2);
          return report
        })
      })($this)), $this.executionContext$1)
    })
  })(this, model, profileName)), this.executionContext$1);
  var this$3 = $m_Lamf_client_convert_CoreClientConverters$();
  var m = $m_Lamf_client_convert_CoreClientConverters$().ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$();
  var executionContext = this.executionContext$1;
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$3, result, m, executionContext).asClient__O()
});
$c_Lamf_client_parse_Parser.prototype.parseFileAsync__T__Lamf_core_client_ParsingOptions__sjs_js_Promise = (function(url, options) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var x$3 = $m_s_None$();
  var from = this.parseAsync__T__s_Option__Lamf_core_client_ParsingOptions__s_concurrent_Future(url, x$3, options);
  var m = $m_Lamf_client_convert_CoreClientConverters$().BaseUnitMatcher__Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$();
  var executionContext = this.executionContext$1;
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$1, from, m, executionContext).asClient__O()
});
$c_Lamf_client_parse_Parser.prototype.report__p1__Lamf_ProfileName__Lamf_MessageStyle__sjs_js_Promise = (function(profileName, messageStyle) {
  var this$1 = this.parsedModel$1;
  if (this$1.isEmpty__Z()) {
    var x1 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_Lamf_core_model_document_BaseUnit(arg1);
    var this$2 = $m_Lamf_core_services_RuntimeValidator$();
    var env = this.internalEnv__p1__Lamf_internal_environment_Environment();
    var executionEnvironment = this.executionEnvironment$1;
    var x1 = new $c_s_Some().init___O(this$2.validator__p1__Lamf_core_services_RuntimeValidator().validate__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(x$1, profileName, messageStyle, env, false, executionEnvironment))
  };
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var validation = $as_s_concurrent_Future(x2.value$2);
    var result = validation
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var result = $m_s_concurrent_Future$().failed__jl_Throwable__s_concurrent_Future(new $c_jl_Exception().init___T("No parsed model or current validation found, cannot validate"))
  };
  var this$3 = $m_Lamf_client_convert_CoreClientConverters$();
  var m = $m_Lamf_client_convert_CoreClientConverters$().ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$();
  var executionContext = this.executionContext$1;
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$3, result, m, executionContext).asClient__O()
});
$c_Lamf_client_parse_Parser.prototype.fromStream__p1__T__T__Lamf_internal_resource_ResourceLoader = (function(url, stream) {
  return new $c_Lamf_internal_resource_StringResourceLoader().init___T__T($m_Lamf_client_convert_CoreClientConverters$().platform$1.resolvePath__T__T(url), stream)
});
$c_Lamf_client_parse_Parser.prototype.$$js$exported$meth$parseStringAsync__T__T__O = (function(url, stream) {
  return this.parseStringAsync__T__T__sjs_js_Promise(url, stream)
});
$c_Lamf_client_parse_Parser.prototype.$$js$exported$meth$parseStringAsync__T__Lamf_core_client_ParsingOptions__O = (function(stream, options) {
  return this.parseStringAsync__T__Lamf_core_client_ParsingOptions__sjs_js_Promise(stream, options)
});
$c_Lamf_client_parse_Parser.prototype.parseStringAsync__T__T__sjs_js_Promise = (function(url, stream) {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.parseAsync__T__s_Option__Lamf_core_client_ParsingOptions__s_concurrent_Future(url, new $c_s_Some().init___O(this.fromStream__p1__T__T__Lamf_internal_resource_ResourceLoader(url, stream)), new $c_Lamf_core_client_ParsingOptions().init___());
  var m = $m_Lamf_client_convert_CoreClientConverters$().BaseUnitMatcher__Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$();
  var executionContext = this.executionContext$1;
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$2, from, m, executionContext).asClient__O()
});
$c_Lamf_client_parse_Parser.prototype.internalEnv__p1__Lamf_internal_environment_Environment = (function() {
  var this$1 = this.env$1;
  return $as_Lamf_client_environment_Environment((this$1.isEmpty__Z() ? $m_Lamf_client_environment_DefaultEnvironment$().apply__Lamf_client_execution_BaseExecutionEnvironment__Lamf_client_environment_Environment(this.executionEnvironment$1) : this$1.get__O())).$$undinternal$1
});
$c_Lamf_client_parse_Parser.prototype.parseStringAsync__T__sjs_js_Promise = (function(stream) {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.parseAsync__T__s_Option__Lamf_core_client_ParsingOptions__s_concurrent_Future(this.DEFAULT$undDOCUMENT$undURL$1, new $c_s_Some().init___O(this.fromStream__p1__T__T__Lamf_internal_resource_ResourceLoader(this.DEFAULT$undDOCUMENT$undURL$1, stream)), new $c_Lamf_core_client_ParsingOptions().init___());
  var m = $m_Lamf_client_convert_CoreClientConverters$().BaseUnitMatcher__Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$();
  var executionContext = this.executionContext$1;
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$2, from, m, executionContext).asClient__O()
});
$c_Lamf_client_parse_Parser.prototype.$$js$exported$meth$parseStringAsync__T__O = (function(stream) {
  return this.parseStringAsync__T__sjs_js_Promise(stream)
});
$c_Lamf_client_parse_Parser.prototype.parseFileAsync__T__sjs_js_Promise = (function(url) {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.parseAsync__T__s_Option__Lamf_core_client_ParsingOptions__s_concurrent_Future(url, $m_s_None$(), new $c_Lamf_core_client_ParsingOptions().init___());
  var m = $m_Lamf_client_convert_CoreClientConverters$().BaseUnitMatcher__Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$();
  var executionContext = this.executionContext$1;
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$2, from, m, executionContext).asClient__O()
});
$c_Lamf_client_parse_Parser.prototype.init___T__T__s_Option = (function(vendor, mediaType, env) {
  this.vendor$1 = vendor;
  this.mediaType$1 = mediaType;
  this.env$1 = env;
  this.parsedModel$1 = $m_s_None$();
  if ((env instanceof $c_s_Some)) {
    var x2 = $as_s_Some(env);
    var environment = $as_Lamf_client_environment_Environment(x2.value$2);
    var jsx$1 = environment.executionEnvironment__Lamf_client_execution_BaseExecutionEnvironment()
  } else {
    var x = $m_s_None$();
    if ((x === env)) {
      var this$1 = $m_Lamf_client_convert_CoreClientConverters$().platform$1;
      var jsx$1 = this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment()
    } else {
      var jsx$1;
      throw new $c_s_MatchError().init___O(env)
    }
  };
  this.executionEnvironment$1 = jsx$1;
  var this$2 = this.executionEnvironment$1;
  this.executionContext$1 = this$2.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  this.DEFAULT$undDOCUMENT$undURL$1 = "http://a.ml/amf/default_document";
  return this
});
$c_Lamf_client_parse_Parser.prototype.$$js$exported$meth$reportValidation__Lamf_ProfileName__Lamf_MessageStyle__O = (function(profile, messageStyle) {
  return this.report__p1__Lamf_ProfileName__Lamf_MessageStyle__sjs_js_Promise(profile, messageStyle)
});
$c_Lamf_client_parse_Parser.prototype.reportCustomValidation = (function(arg, arg$2) {
  var prep = $as_Lamf_ProfileName(arg);
  var prep$2 = $as_T(arg$2);
  return this.$$js$exported$meth$reportCustomValidation__Lamf_ProfileName__T__O(prep, prep$2)
});
$c_Lamf_client_parse_Parser.prototype.reportValidation = (function(arg) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 1;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      var prep = $as_Lamf_ProfileName(arg);
      return this.$$js$exported$meth$reportValidation__Lamf_ProfileName__O(prep);
      break
    }
    case 1: {
      var prep$2 = $as_Lamf_ProfileName(arg);
      var prep$3 = $as_Lamf_MessageStyle(rest[0]);
      return this.$$js$exported$meth$reportValidation__Lamf_ProfileName__Lamf_MessageStyle__O(prep$2, prep$3);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_parse_Parser.prototype.parseStringAsync = (function(arg) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 1;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      if ($is_T(rest[0])) {
        var prep$3 = $as_T(arg);
        var prep$4 = $as_T(rest[0]);
        return this.$$js$exported$meth$parseStringAsync__T__T__O(prep$3, prep$4)
      } else if ((rest[0] instanceof $c_Lamf_core_client_ParsingOptions)) {
        var prep = $as_T(arg);
        var prep$2 = $as_Lamf_core_client_ParsingOptions(rest[0]);
        return this.$$js$exported$meth$parseStringAsync__T__Lamf_core_client_ParsingOptions__O(prep, prep$2)
      } else {
        throw "No matching overload"
      };
      break
    }
    case 2: {
      var prep$5 = $as_T(arg);
      var prep$6 = $as_T(rest[0]);
      var prep$7 = $as_Lamf_core_client_ParsingOptions(rest[1]);
      return this.$$js$exported$meth$parseStringAsync__T__T__Lamf_core_client_ParsingOptions__O(prep$5, prep$6, prep$7);
      break
    }
    case 0: {
      var prep$8 = $as_T(arg);
      return this.$$js$exported$meth$parseStringAsync__T__O(prep$8);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_parse_Parser.prototype.parseFileAsync = (function(arg) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 1;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_T(arg);
      var prep$2 = $as_Lamf_core_client_ParsingOptions(rest[0]);
      return this.$$js$exported$meth$parseFileAsync__T__Lamf_core_client_ParsingOptions__O(prep, prep$2);
      break
    }
    case 0: {
      var prep$3 = $as_T(arg);
      return this.$$js$exported$meth$parseFileAsync__T__O(prep$3);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
var $d_Lamf_client_parse_Parser = new $TypeData().initClass({
  Lamf_client_parse_Parser: 0
}, false, "amf.client.parse.Parser", {
  Lamf_client_parse_Parser: 1,
  O: 1
});
$c_Lamf_client_parse_Parser.prototype.$classData = $d_Lamf_client_parse_Parser;
/** @constructor */
function $c_Lamf_client_plugins_AMFDocumentPluginSettings$PluginPriorities$() {
  $c_O.call(this);
  this.high$1 = 0;
  this.default$1 = 0;
  this.low$1 = 0
}
$c_Lamf_client_plugins_AMFDocumentPluginSettings$PluginPriorities$.prototype = new $h_O();
$c_Lamf_client_plugins_AMFDocumentPluginSettings$PluginPriorities$.prototype.constructor = $c_Lamf_client_plugins_AMFDocumentPluginSettings$PluginPriorities$;
/** @constructor */
function $h_Lamf_client_plugins_AMFDocumentPluginSettings$PluginPriorities$() {
  /*<skip>*/
}
$h_Lamf_client_plugins_AMFDocumentPluginSettings$PluginPriorities$.prototype = $c_Lamf_client_plugins_AMFDocumentPluginSettings$PluginPriorities$.prototype;
$c_Lamf_client_plugins_AMFDocumentPluginSettings$PluginPriorities$.prototype.init___ = (function() {
  this.high$1 = 0;
  this.default$1 = 5;
  this.low$1 = 10;
  return this
});
var $d_Lamf_client_plugins_AMFDocumentPluginSettings$PluginPriorities$ = new $TypeData().initClass({
  Lamf_client_plugins_AMFDocumentPluginSettings$PluginPriorities$: 0
}, false, "amf.client.plugins.AMFDocumentPluginSettings$PluginPriorities$", {
  Lamf_client_plugins_AMFDocumentPluginSettings$PluginPriorities$: 1,
  O: 1
});
$c_Lamf_client_plugins_AMFDocumentPluginSettings$PluginPriorities$.prototype.$classData = $d_Lamf_client_plugins_AMFDocumentPluginSettings$PluginPriorities$;
var $n_Lamf_client_plugins_AMFDocumentPluginSettings$PluginPriorities$ = (void 0);
function $m_Lamf_client_plugins_AMFDocumentPluginSettings$PluginPriorities$() {
  if ((!$n_Lamf_client_plugins_AMFDocumentPluginSettings$PluginPriorities$)) {
    $n_Lamf_client_plugins_AMFDocumentPluginSettings$PluginPriorities$ = new $c_Lamf_client_plugins_AMFDocumentPluginSettings$PluginPriorities$().init___()
  };
  return $n_Lamf_client_plugins_AMFDocumentPluginSettings$PluginPriorities$
}
function $is_Lamf_client_plugins_AMFFeaturePlugin(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_client_plugins_AMFFeaturePlugin)))
}
function $as_Lamf_client_plugins_AMFFeaturePlugin(obj) {
  return (($is_Lamf_client_plugins_AMFFeaturePlugin(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.plugins.AMFFeaturePlugin"))
}
function $isArrayOf_Lamf_client_plugins_AMFFeaturePlugin(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_plugins_AMFFeaturePlugin)))
}
function $asArrayOf_Lamf_client_plugins_AMFFeaturePlugin(obj, depth) {
  return (($isArrayOf_Lamf_client_plugins_AMFFeaturePlugin(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.plugins.AMFFeaturePlugin;", depth))
}
/** @constructor */
function $c_Lamf_client_plugins_ValidationMode$() {
  $c_O.call(this);
  this.StrictValidationMode$1 = null;
  this.ScalarRelaxedValidationMode$1 = null
}
$c_Lamf_client_plugins_ValidationMode$.prototype = new $h_O();
$c_Lamf_client_plugins_ValidationMode$.prototype.constructor = $c_Lamf_client_plugins_ValidationMode$;
/** @constructor */
function $h_Lamf_client_plugins_ValidationMode$() {
  /*<skip>*/
}
$h_Lamf_client_plugins_ValidationMode$.prototype = $c_Lamf_client_plugins_ValidationMode$.prototype;
$c_Lamf_client_plugins_ValidationMode$.prototype.init___ = (function() {
  $n_Lamf_client_plugins_ValidationMode$ = this;
  this.StrictValidationMode$1 = $m_Lamf_client_plugins_StrictValidationMode$();
  this.ScalarRelaxedValidationMode$1 = $m_Lamf_client_plugins_ScalarRelaxedValidationMode$();
  return this
});
$c_Lamf_client_plugins_ValidationMode$.prototype.$$js$exported$prop$ScalarRelaxedValidationMode__O = (function() {
  return this.ScalarRelaxedValidationMode$1
});
$c_Lamf_client_plugins_ValidationMode$.prototype.$$js$exported$prop$StrictValidationMode__O = (function() {
  return this.StrictValidationMode$1
});
Object.defineProperty($c_Lamf_client_plugins_ValidationMode$.prototype, "ScalarRelaxedValidationMode", {
  "get": (function() {
    return this.$$js$exported$prop$ScalarRelaxedValidationMode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_plugins_ValidationMode$.prototype, "StrictValidationMode", {
  "get": (function() {
    return this.$$js$exported$prop$StrictValidationMode__O()
  }),
  "configurable": true
});
var $d_Lamf_client_plugins_ValidationMode$ = new $TypeData().initClass({
  Lamf_client_plugins_ValidationMode$: 0
}, false, "amf.client.plugins.ValidationMode$", {
  Lamf_client_plugins_ValidationMode$: 1,
  O: 1
});
$c_Lamf_client_plugins_ValidationMode$.prototype.$classData = $d_Lamf_client_plugins_ValidationMode$;
var $n_Lamf_client_plugins_ValidationMode$ = (void 0);
function $m_Lamf_client_plugins_ValidationMode$() {
  if ((!$n_Lamf_client_plugins_ValidationMode$)) {
    $n_Lamf_client_plugins_ValidationMode$ = new $c_Lamf_client_plugins_ValidationMode$().init___()
  };
  return $n_Lamf_client_plugins_ValidationMode$
}
/** @constructor */
function $c_Lamf_client_registry_DialectRegistry$() {
  $c_O.call(this)
}
$c_Lamf_client_registry_DialectRegistry$.prototype = new $h_O();
$c_Lamf_client_registry_DialectRegistry$.prototype.constructor = $c_Lamf_client_registry_DialectRegistry$;
/** @constructor */
function $h_Lamf_client_registry_DialectRegistry$() {
  /*<skip>*/
}
$h_Lamf_client_registry_DialectRegistry$.prototype = $c_Lamf_client_registry_DialectRegistry$.prototype;
$c_Lamf_client_registry_DialectRegistry$.prototype.init___ = (function() {
  return this
});
$c_Lamf_client_registry_DialectRegistry$.prototype.resolveDialect__Lamf_client_model_document_Dialect__Lamf_client_model_document_Dialect = (function(dialect) {
  return new $c_Lamf_client_model_document_Dialect().init___Lamf_plugins_document_vocabularies_model_document_Dialect($m_Lamf_plugins_document_vocabularies_AMLPlugin$().registry$2.resolveDialect__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_plugins_document_vocabularies_model_document_Dialect(dialect.$$undinternal$1))
});
$c_Lamf_client_registry_DialectRegistry$.prototype.$$js$exported$meth$dialecByHeader__T__O = (function(header) {
  return this.dialecByHeader__T__Lamf_client_model_document_Dialect(header)
});
$c_Lamf_client_registry_DialectRegistry$.prototype.$$js$exported$meth$register__Lamf_client_model_document_Dialect__O = (function(dialect) {
  return this.register__Lamf_client_model_document_Dialect__Lamf_client_registry_DialectRegistry$(dialect)
});
$c_Lamf_client_registry_DialectRegistry$.prototype.dialecByHeader__T__Lamf_client_model_document_Dialect = (function(header) {
  var this$1 = $m_Lamf_plugins_document_vocabularies_AMLPlugin$().registry$2;
  var this$2 = this$1.map$1.get__O__s_Option(header);
  if (this$2.isEmpty__Z()) {
    var result = $m_s_None$()
  } else {
    var v1 = this$2.get__O();
    var _internal = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(v1);
    var result = new $c_s_Some().init___O(new $c_Lamf_client_model_document_Dialect().init___Lamf_plugins_document_vocabularies_model_document_Dialect(_internal))
  };
  return $as_Lamf_client_model_document_Dialect((result.isEmpty__Z() ? null : result.get__O()))
});
$c_Lamf_client_registry_DialectRegistry$.prototype.register__Lamf_client_model_document_Dialect__Lamf_client_registry_DialectRegistry$ = (function(dialect) {
  $m_Lamf_plugins_document_vocabularies_AMLPlugin$().registry$2.register__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_plugins_document_vocabularies_DialectsRegistry(dialect.$$undinternal$1);
  return this
});
$c_Lamf_client_registry_DialectRegistry$.prototype.$$js$exported$meth$resolveDialect__Lamf_client_model_document_Dialect__O = (function(dialect) {
  return this.resolveDialect__Lamf_client_model_document_Dialect__Lamf_client_model_document_Dialect(dialect)
});
$c_Lamf_client_registry_DialectRegistry$.prototype.dialecByHeader = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$dialecByHeader__T__O(prep)
});
$c_Lamf_client_registry_DialectRegistry$.prototype.resolveDialect = (function(arg) {
  var prep = $as_Lamf_client_model_document_Dialect(arg);
  return this.$$js$exported$meth$resolveDialect__Lamf_client_model_document_Dialect__O(prep)
});
$c_Lamf_client_registry_DialectRegistry$.prototype.register = (function(arg) {
  var prep = $as_Lamf_client_model_document_Dialect(arg);
  return this.$$js$exported$meth$register__Lamf_client_model_document_Dialect__O(prep)
});
var $d_Lamf_client_registry_DialectRegistry$ = new $TypeData().initClass({
  Lamf_client_registry_DialectRegistry$: 0
}, false, "amf.client.registry.DialectRegistry$", {
  Lamf_client_registry_DialectRegistry$: 1,
  O: 1
});
$c_Lamf_client_registry_DialectRegistry$.prototype.$classData = $d_Lamf_client_registry_DialectRegistry$;
var $n_Lamf_client_registry_DialectRegistry$ = (void 0);
function $m_Lamf_client_registry_DialectRegistry$() {
  if ((!$n_Lamf_client_registry_DialectRegistry$)) {
    $n_Lamf_client_registry_DialectRegistry$ = new $c_Lamf_client_registry_DialectRegistry$().init___()
  };
  return $n_Lamf_client_registry_DialectRegistry$
}
/** @constructor */
function $c_Lamf_client_render_JSONSchemaVersions$() {
  $c_O.call(this);
  this.UNSPECIFIED$1 = null;
  this.DRAFT$und04$1 = null;
  this.DRAFT$und07$1 = null
}
$c_Lamf_client_render_JSONSchemaVersions$.prototype = new $h_O();
$c_Lamf_client_render_JSONSchemaVersions$.prototype.constructor = $c_Lamf_client_render_JSONSchemaVersions$;
/** @constructor */
function $h_Lamf_client_render_JSONSchemaVersions$() {
  /*<skip>*/
}
$h_Lamf_client_render_JSONSchemaVersions$.prototype = $c_Lamf_client_render_JSONSchemaVersions$.prototype;
$c_Lamf_client_render_JSONSchemaVersions$.prototype.init___ = (function() {
  $n_Lamf_client_render_JSONSchemaVersions$ = this;
  this.UNSPECIFIED$1 = $m_Lamf_client_render_Unspecified$();
  this.DRAFT$und04$1 = $m_Lamf_client_render_JsonSchemaDraft4$();
  this.DRAFT$und07$1 = $m_Lamf_client_render_JsonSchemaDraft7$();
  return this
});
$c_Lamf_client_render_JSONSchemaVersions$.prototype.$$js$exported$prop$DRAFT$und04__O = (function() {
  return this.DRAFT$und04$1
});
$c_Lamf_client_render_JSONSchemaVersions$.prototype.$$js$exported$prop$DRAFT$und07__O = (function() {
  return this.DRAFT$und07$1
});
$c_Lamf_client_render_JSONSchemaVersions$.prototype.$$js$exported$prop$UNSPECIFIED__O = (function() {
  return this.UNSPECIFIED$1
});
Object.defineProperty($c_Lamf_client_render_JSONSchemaVersions$.prototype, "DRAFT_07", {
  "get": (function() {
    return this.$$js$exported$prop$DRAFT$und07__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_JSONSchemaVersions$.prototype, "DRAFT_04", {
  "get": (function() {
    return this.$$js$exported$prop$DRAFT$und04__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_JSONSchemaVersions$.prototype, "UNSPECIFIED", {
  "get": (function() {
    return this.$$js$exported$prop$UNSPECIFIED__O()
  }),
  "configurable": true
});
var $d_Lamf_client_render_JSONSchemaVersions$ = new $TypeData().initClass({
  Lamf_client_render_JSONSchemaVersions$: 0
}, false, "amf.client.render.JSONSchemaVersions$", {
  Lamf_client_render_JSONSchemaVersions$: 1,
  O: 1
});
$c_Lamf_client_render_JSONSchemaVersions$.prototype.$classData = $d_Lamf_client_render_JSONSchemaVersions$;
var $n_Lamf_client_render_JSONSchemaVersions$ = (void 0);
function $m_Lamf_client_render_JSONSchemaVersions$() {
  if ((!$n_Lamf_client_render_JSONSchemaVersions$)) {
    $n_Lamf_client_render_JSONSchemaVersions$ = new $c_Lamf_client_render_JSONSchemaVersions$().init___()
  };
  return $n_Lamf_client_render_JSONSchemaVersions$
}
/** @constructor */
function $c_Lamf_client_render_RenderOptions() {
  $c_O.call(this);
  this.sources$1 = false;
  this.compactUris$1 = false;
  this.amfJsonLdSerialization$1 = false;
  this.prettyPrint$1 = false;
  this.flattenedJsonLd$1 = false;
  this.eh$1 = null;
  this.emitNodeIds$1 = false
}
$c_Lamf_client_render_RenderOptions.prototype = new $h_O();
$c_Lamf_client_render_RenderOptions.prototype.constructor = $c_Lamf_client_render_RenderOptions;
/** @constructor */
function $h_Lamf_client_render_RenderOptions() {
  /*<skip>*/
}
$h_Lamf_client_render_RenderOptions.prototype = $c_Lamf_client_render_RenderOptions.prototype;
$c_Lamf_client_render_RenderOptions.prototype.init___ = (function() {
  this.sources$1 = false;
  this.compactUris$1 = false;
  this.amfJsonLdSerialization$1 = true;
  this.prettyPrint$1 = false;
  this.flattenedJsonLd$1 = false;
  var from = $m_Lamf_core_errorhandling_UnhandledErrorHandler$();
  this.eh$1 = $m_Lamf_client_resolve_ClientErrorHandlerConverter$().convertToClient__Lamf_core_errorhandling_ErrorHandler__Lamf_client_resolve_ClientErrorHandler(from);
  this.emitNodeIds$1 = false;
  return this
});
$c_Lamf_client_render_RenderOptions.prototype.$$js$exported$prop$isAmfJsonLdSerilization__O = (function() {
  return this.amfJsonLdSerialization$1
});
$c_Lamf_client_render_RenderOptions.prototype.withoutAmfJsonLdSerialization__Lamf_client_render_RenderOptions = (function() {
  this.amfJsonLdSerialization$1 = false;
  return this
});
$c_Lamf_client_render_RenderOptions.prototype.$$js$exported$prop$withoutSourceMaps__O = (function() {
  return this.withoutSourceMaps__Lamf_client_render_RenderOptions()
});
$c_Lamf_client_render_RenderOptions.prototype.$$js$exported$prop$withFlattenedJsonLd__O = (function() {
  return this.withFlattenedJsonLd__Lamf_client_render_RenderOptions()
});
$c_Lamf_client_render_RenderOptions.prototype.withoutSourceMaps__Lamf_client_render_RenderOptions = (function() {
  this.sources$1 = false;
  return this
});
$c_Lamf_client_render_RenderOptions.prototype.$$js$exported$prop$withSourceMaps__O = (function() {
  return this.withSourceMaps__Lamf_client_render_RenderOptions()
});
$c_Lamf_client_render_RenderOptions.prototype.$$js$exported$prop$isPrettyPrint__O = (function() {
  return this.prettyPrint$1
});
$c_Lamf_client_render_RenderOptions.prototype.$$js$exported$prop$withNodeIds__O = (function() {
  return this.withNodeIds__Lamf_client_render_RenderOptions()
});
$c_Lamf_client_render_RenderOptions.prototype.$$js$exported$prop$errorHandler__O = (function() {
  return this.eh$1
});
$c_Lamf_client_render_RenderOptions.prototype.$$js$exported$meth$withErrorHandler__Lamf_client_resolve_ClientErrorHandler__O = (function(errorHandler) {
  return this.withErrorHandler__Lamf_client_resolve_ClientErrorHandler__Lamf_client_render_RenderOptions(errorHandler)
});
$c_Lamf_client_render_RenderOptions.prototype.$$js$exported$prop$isEmitNodeIds__O = (function() {
  return this.emitNodeIds$1
});
$c_Lamf_client_render_RenderOptions.prototype.withCompactUris__Lamf_client_render_RenderOptions = (function() {
  this.compactUris$1 = true;
  return this
});
$c_Lamf_client_render_RenderOptions.prototype.$$js$exported$prop$isWithSourceMaps__O = (function() {
  return this.sources$1
});
$c_Lamf_client_render_RenderOptions.prototype.withPrettyPrint__Lamf_client_render_RenderOptions = (function() {
  this.prettyPrint$1 = true;
  return this
});
$c_Lamf_client_render_RenderOptions.prototype.withFlattenedJsonLd__Lamf_client_render_RenderOptions = (function() {
  this.flattenedJsonLd$1 = true;
  return this
});
$c_Lamf_client_render_RenderOptions.prototype.withSourceMaps__Lamf_client_render_RenderOptions = (function() {
  this.sources$1 = true;
  return this
});
$c_Lamf_client_render_RenderOptions.prototype.withNodeIds__Lamf_client_render_RenderOptions = (function() {
  this.emitNodeIds$1 = true;
  return this
});
$c_Lamf_client_render_RenderOptions.prototype.$$js$exported$prop$withoutPrettyPrint__O = (function() {
  return this.withoutPrettyPrint__Lamf_client_render_RenderOptions()
});
$c_Lamf_client_render_RenderOptions.prototype.withErrorHandler__Lamf_client_resolve_ClientErrorHandler__Lamf_client_render_RenderOptions = (function(errorHandler) {
  this.eh$1 = errorHandler;
  return this
});
$c_Lamf_client_render_RenderOptions.prototype.$$js$exported$prop$withoutCompactUris__O = (function() {
  return this.withoutCompactUris__Lamf_client_render_RenderOptions()
});
$c_Lamf_client_render_RenderOptions.prototype.$$js$exported$prop$isWithCompactUris__O = (function() {
  return this.compactUris$1
});
$c_Lamf_client_render_RenderOptions.prototype.$$js$exported$prop$withPrettyPrint__O = (function() {
  return this.withPrettyPrint__Lamf_client_render_RenderOptions()
});
$c_Lamf_client_render_RenderOptions.prototype.withoutCompactUris__Lamf_client_render_RenderOptions = (function() {
  this.compactUris$1 = false;
  return this
});
$c_Lamf_client_render_RenderOptions.prototype.$$js$exported$prop$withCompactUris__O = (function() {
  return this.withCompactUris__Lamf_client_render_RenderOptions()
});
$c_Lamf_client_render_RenderOptions.prototype.$$js$exported$prop$withoutAmfJsonLdSerialization__O = (function() {
  return this.withoutAmfJsonLdSerialization__Lamf_client_render_RenderOptions()
});
$c_Lamf_client_render_RenderOptions.prototype.withoutPrettyPrint__Lamf_client_render_RenderOptions = (function() {
  this.prettyPrint$1 = false;
  return this
});
$c_Lamf_client_render_RenderOptions.prototype.$$js$exported$prop$withAmfJsonLdSerialization__O = (function() {
  return this.withAmfJsonLdSerialization__Lamf_client_render_RenderOptions()
});
$c_Lamf_client_render_RenderOptions.prototype.$$js$exported$prop$isFlattenedJsonLd__O = (function() {
  return this.flattenedJsonLd$1
});
$c_Lamf_client_render_RenderOptions.prototype.withAmfJsonLdSerialization__Lamf_client_render_RenderOptions = (function() {
  this.amfJsonLdSerialization$1 = true;
  return this
});
$c_Lamf_client_render_RenderOptions.prototype.withoutFlattenedJsonLd__Lamf_client_render_RenderOptions = (function() {
  this.flattenedJsonLd$1 = false;
  return this
});
$c_Lamf_client_render_RenderOptions.prototype.$$js$exported$prop$withoutFlattenedJsonLd__O = (function() {
  return this.withoutFlattenedJsonLd__Lamf_client_render_RenderOptions()
});
Object.defineProperty($c_Lamf_client_render_RenderOptions.prototype, "isEmitNodeIds", {
  "get": (function() {
    return this.$$js$exported$prop$isEmitNodeIds__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_RenderOptions.prototype, "isPrettyPrint", {
  "get": (function() {
    return this.$$js$exported$prop$isPrettyPrint__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_RenderOptions.prototype, "errorHandler", {
  "get": (function() {
    return this.$$js$exported$prop$errorHandler__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_RenderOptions.prototype, "isAmfJsonLdSerilization", {
  "get": (function() {
    return this.$$js$exported$prop$isAmfJsonLdSerilization__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_RenderOptions.prototype, "isWithSourceMaps", {
  "get": (function() {
    return this.$$js$exported$prop$isWithSourceMaps__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_RenderOptions.prototype, "isWithCompactUris", {
  "get": (function() {
    return this.$$js$exported$prop$isWithCompactUris__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_RenderOptions.prototype, "withNodeIds", {
  "get": (function() {
    return this.$$js$exported$prop$withNodeIds__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_RenderOptions.prototype, "withAmfJsonLdSerialization", {
  "get": (function() {
    return this.$$js$exported$prop$withAmfJsonLdSerialization__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_RenderOptions.prototype, "withoutAmfJsonLdSerialization", {
  "get": (function() {
    return this.$$js$exported$prop$withoutAmfJsonLdSerialization__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_RenderOptions.prototype, "isFlattenedJsonLd", {
  "get": (function() {
    return this.$$js$exported$prop$isFlattenedJsonLd__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_RenderOptions.prototype, "withoutFlattenedJsonLd", {
  "get": (function() {
    return this.$$js$exported$prop$withoutFlattenedJsonLd__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_RenderOptions.prototype, "withFlattenedJsonLd", {
  "get": (function() {
    return this.$$js$exported$prop$withFlattenedJsonLd__O()
  }),
  "configurable": true
});
$c_Lamf_client_render_RenderOptions.prototype.withErrorHandler = (function(arg) {
  var prep = $as_Lamf_client_resolve_ClientErrorHandler(arg);
  return this.$$js$exported$meth$withErrorHandler__Lamf_client_resolve_ClientErrorHandler__O(prep)
});
Object.defineProperty($c_Lamf_client_render_RenderOptions.prototype, "withoutCompactUris", {
  "get": (function() {
    return this.$$js$exported$prop$withoutCompactUris__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_RenderOptions.prototype, "withCompactUris", {
  "get": (function() {
    return this.$$js$exported$prop$withCompactUris__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_RenderOptions.prototype, "withoutSourceMaps", {
  "get": (function() {
    return this.$$js$exported$prop$withoutSourceMaps__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_RenderOptions.prototype, "withSourceMaps", {
  "get": (function() {
    return this.$$js$exported$prop$withSourceMaps__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_RenderOptions.prototype, "withoutPrettyPrint", {
  "get": (function() {
    return this.$$js$exported$prop$withoutPrettyPrint__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_RenderOptions.prototype, "withPrettyPrint", {
  "get": (function() {
    return this.$$js$exported$prop$withPrettyPrint__O()
  }),
  "configurable": true
});
function $as_Lamf_client_render_RenderOptions(obj) {
  return (((obj instanceof $c_Lamf_client_render_RenderOptions) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.render.RenderOptions"))
}
function $isArrayOf_Lamf_client_render_RenderOptions(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_render_RenderOptions)))
}
function $asArrayOf_Lamf_client_render_RenderOptions(obj, depth) {
  return (($isArrayOf_Lamf_client_render_RenderOptions(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.render.RenderOptions;", depth))
}
var $d_Lamf_client_render_RenderOptions = new $TypeData().initClass({
  Lamf_client_render_RenderOptions: 0
}, false, "amf.client.render.RenderOptions", {
  Lamf_client_render_RenderOptions: 1,
  O: 1
});
$c_Lamf_client_render_RenderOptions.prototype.$classData = $d_Lamf_client_render_RenderOptions;
/** @constructor */
function $c_Lamf_client_render_ShapeRenderOptions() {
  $c_O.call(this);
  this.documentation$1 = false;
  this.compactedEmission$1 = false;
  this.schema$1 = null;
  this.eh$1 = null
}
$c_Lamf_client_render_ShapeRenderOptions.prototype = new $h_O();
$c_Lamf_client_render_ShapeRenderOptions.prototype.constructor = $c_Lamf_client_render_ShapeRenderOptions;
/** @constructor */
function $h_Lamf_client_render_ShapeRenderOptions() {
  /*<skip>*/
}
$h_Lamf_client_render_ShapeRenderOptions.prototype = $c_Lamf_client_render_ShapeRenderOptions.prototype;
$c_Lamf_client_render_ShapeRenderOptions.prototype.init___ = (function() {
  this.documentation$1 = true;
  this.compactedEmission$1 = false;
  this.schema$1 = $m_Lamf_client_render_JSONSchemaVersions$().UNSPECIFIED$1;
  var from = $m_Lamf_core_errorhandling_UnhandledErrorHandler$();
  this.eh$1 = $m_Lamf_client_resolve_ClientErrorHandlerConverter$().convertToClient__Lamf_core_errorhandling_ErrorHandler__Lamf_client_resolve_ClientErrorHandler(from);
  return this
});
$c_Lamf_client_render_ShapeRenderOptions.prototype.withErrorHandler__Lamf_client_resolve_ClientErrorHandler__Lamf_client_render_ShapeRenderOptions = (function(errorHandler) {
  this.eh$1 = errorHandler;
  return this
});
$c_Lamf_client_render_ShapeRenderOptions.prototype.$$js$exported$meth$withSchemaVersion__Lamf_client_render_JSONSchemaVersion__O = (function(version) {
  return this.withSchemaVersion__Lamf_client_render_JSONSchemaVersion__Lamf_client_render_ShapeRenderOptions(version)
});
$c_Lamf_client_render_ShapeRenderOptions.prototype.$$js$exported$prop$errorHandler__O = (function() {
  return this.eh$1
});
$c_Lamf_client_render_ShapeRenderOptions.prototype.$$js$exported$meth$withErrorHandler__Lamf_client_resolve_ClientErrorHandler__O = (function(errorHandler) {
  return this.withErrorHandler__Lamf_client_resolve_ClientErrorHandler__Lamf_client_render_ShapeRenderOptions(errorHandler)
});
$c_Lamf_client_render_ShapeRenderOptions.prototype.$$js$exported$prop$isWithCompactedEmission__O = (function() {
  return this.compactedEmission$1
});
$c_Lamf_client_render_ShapeRenderOptions.prototype.withCompactedEmission__Lamf_client_render_ShapeRenderOptions = (function() {
  this.compactedEmission$1 = true;
  return this
});
$c_Lamf_client_render_ShapeRenderOptions.prototype.$$js$exported$prop$schemaVersion__O = (function() {
  return this.schema$1
});
$c_Lamf_client_render_ShapeRenderOptions.prototype.$$js$exported$prop$withCompactedEmission__O = (function() {
  return this.withCompactedEmission__Lamf_client_render_ShapeRenderOptions()
});
$c_Lamf_client_render_ShapeRenderOptions.prototype.$$js$exported$prop$isWithDocumentation__O = (function() {
  return this.documentation$1
});
$c_Lamf_client_render_ShapeRenderOptions.prototype.withoutDocumentation__Lamf_client_render_ShapeRenderOptions = (function() {
  this.documentation$1 = false;
  return this
});
$c_Lamf_client_render_ShapeRenderOptions.prototype.$$js$exported$prop$withoutDocumentation__O = (function() {
  return this.withoutDocumentation__Lamf_client_render_ShapeRenderOptions()
});
$c_Lamf_client_render_ShapeRenderOptions.prototype.withSchemaVersion__Lamf_client_render_JSONSchemaVersion__Lamf_client_render_ShapeRenderOptions = (function(version) {
  this.schema$1 = version;
  return this
});
Object.defineProperty($c_Lamf_client_render_ShapeRenderOptions.prototype, "schemaVersion", {
  "get": (function() {
    return this.$$js$exported$prop$schemaVersion__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_ShapeRenderOptions.prototype, "isWithCompactedEmission", {
  "get": (function() {
    return this.$$js$exported$prop$isWithCompactedEmission__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_ShapeRenderOptions.prototype, "isWithDocumentation", {
  "get": (function() {
    return this.$$js$exported$prop$isWithDocumentation__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_ShapeRenderOptions.prototype, "errorHandler", {
  "get": (function() {
    return this.$$js$exported$prop$errorHandler__O()
  }),
  "configurable": true
});
$c_Lamf_client_render_ShapeRenderOptions.prototype.withSchemaVersion = (function(arg) {
  var prep = $as_Lamf_client_render_JSONSchemaVersion(arg);
  return this.$$js$exported$meth$withSchemaVersion__Lamf_client_render_JSONSchemaVersion__O(prep)
});
$c_Lamf_client_render_ShapeRenderOptions.prototype.withErrorHandler = (function(arg) {
  var prep = $as_Lamf_client_resolve_ClientErrorHandler(arg);
  return this.$$js$exported$meth$withErrorHandler__Lamf_client_resolve_ClientErrorHandler__O(prep)
});
Object.defineProperty($c_Lamf_client_render_ShapeRenderOptions.prototype, "withCompactedEmission", {
  "get": (function() {
    return this.$$js$exported$prop$withCompactedEmission__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_render_ShapeRenderOptions.prototype, "withoutDocumentation", {
  "get": (function() {
    return this.$$js$exported$prop$withoutDocumentation__O()
  }),
  "configurable": true
});
function $as_Lamf_client_render_ShapeRenderOptions(obj) {
  return (((obj instanceof $c_Lamf_client_render_ShapeRenderOptions) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.render.ShapeRenderOptions"))
}
function $isArrayOf_Lamf_client_render_ShapeRenderOptions(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_render_ShapeRenderOptions)))
}
function $asArrayOf_Lamf_client_render_ShapeRenderOptions(obj, depth) {
  return (($isArrayOf_Lamf_client_render_ShapeRenderOptions(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.render.ShapeRenderOptions;", depth))
}
var $d_Lamf_client_render_ShapeRenderOptions = new $TypeData().initClass({
  Lamf_client_render_ShapeRenderOptions: 0
}, false, "amf.client.render.ShapeRenderOptions", {
  Lamf_client_render_ShapeRenderOptions: 1,
  O: 1
});
$c_Lamf_client_render_ShapeRenderOptions.prototype.$classData = $d_Lamf_client_render_ShapeRenderOptions;
/** @constructor */
function $c_Lamf_client_resolve_ClientErrorHandlerConverter$() {
  $c_O.call(this)
}
$c_Lamf_client_resolve_ClientErrorHandlerConverter$.prototype = new $h_O();
$c_Lamf_client_resolve_ClientErrorHandlerConverter$.prototype.constructor = $c_Lamf_client_resolve_ClientErrorHandlerConverter$;
/** @constructor */
function $h_Lamf_client_resolve_ClientErrorHandlerConverter$() {
  /*<skip>*/
}
$h_Lamf_client_resolve_ClientErrorHandlerConverter$.prototype = $c_Lamf_client_resolve_ClientErrorHandlerConverter$.prototype;
$c_Lamf_client_resolve_ClientErrorHandlerConverter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_client_resolve_ClientErrorHandlerConverter$.prototype.amf$client$resolve$ClientErrorHandlerConverter$$$anonfun$convert$1__T__T__s_Option__T__s_Option__T__s_Option__Lamf_client_resolve_ClientErrorHandler__V = (function(id, node, property, message, range, level, location, clientErrorHandler$1) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var m = $m_Lamf_client_convert_CoreClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  var jsx$2 = new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$1, property, m).asClient__O();
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var m$1 = $m_Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$();
  var jsx$1 = new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$2, range, m$1).asClient__O();
  var this$3 = $m_Lamf_client_convert_CoreClientConverters$();
  var m$2 = $m_Lamf_client_convert_CoreClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  clientErrorHandler$1.reportConstraint__T__T__sjs_js_UndefOr__T__sjs_js_UndefOr__T__sjs_js_UndefOr__V(id, node, jsx$2, message, jsx$1, level, new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$3, location, m$2).asClient__O())
});
$c_Lamf_client_resolve_ClientErrorHandlerConverter$.prototype.convertToClient__Lamf_core_errorhandling_ErrorHandler__Lamf_client_resolve_ClientErrorHandler = (function(errorHandler) {
  return new $c_Lamf_client_resolve_ClientErrorHandlerConverter$$$Lambda$1().init___O((function($this, errorHandler$1) {
    return (function(id$2, node$2, property$2, message$2, range$2, level$2, location$2) {
      var id = $as_T(id$2);
      var node = $as_T(node$2);
      var message = $as_T(message$2);
      var level = $as_T(level$2);
      var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
      var jsx$2 = new $c_Lamf_client_convert_CollectionConverter$ClientOptionOps().init___Lamf_client_convert_CollectionConverter__O(this$1, property$2).toScala__s_Option();
      var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
      var this$3 = new $c_Lamf_client_convert_CollectionConverter$ClientOptionOps().init___Lamf_client_convert_CollectionConverter__O(this$2, range$2).toScala__s_Option();
      if (this$3.isEmpty__Z()) {
        var jsx$1 = $m_s_None$()
      } else {
        var arg1 = this$3.get__O();
        var from = $as_Lamf_core_parser_Range(arg1);
        var jsx$1 = new $c_s_Some().init___O(new $c_Lamf_core_annotations_LexicalInformation().init___Lamf_core_parser_Range(from))
      };
      var this$5 = $m_Lamf_client_convert_CoreClientConverters$();
      errorHandler$1.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(id, node, jsx$2, message, jsx$1, level, new $c_Lamf_client_convert_CollectionConverter$ClientOptionOps().init___Lamf_client_convert_CollectionConverter__O(this$5, location$2).toScala__s_Option())
    })
  })(this, errorHandler))
});
var $d_Lamf_client_resolve_ClientErrorHandlerConverter$ = new $TypeData().initClass({
  Lamf_client_resolve_ClientErrorHandlerConverter$: 0
}, false, "amf.client.resolve.ClientErrorHandlerConverter$", {
  Lamf_client_resolve_ClientErrorHandlerConverter$: 1,
  O: 1
});
$c_Lamf_client_resolve_ClientErrorHandlerConverter$.prototype.$classData = $d_Lamf_client_resolve_ClientErrorHandlerConverter$;
var $n_Lamf_client_resolve_ClientErrorHandlerConverter$ = (void 0);
function $m_Lamf_client_resolve_ClientErrorHandlerConverter$() {
  if ((!$n_Lamf_client_resolve_ClientErrorHandlerConverter$)) {
    $n_Lamf_client_resolve_ClientErrorHandlerConverter$ = new $c_Lamf_client_resolve_ClientErrorHandlerConverter$().init___()
  };
  return $n_Lamf_client_resolve_ClientErrorHandlerConverter$
}
/** @constructor */
function $c_Lamf_client_resolve_Resolver() {
  $c_O.call(this);
  this.vendor$1 = null
}
$c_Lamf_client_resolve_Resolver.prototype = new $h_O();
$c_Lamf_client_resolve_Resolver.prototype.constructor = $c_Lamf_client_resolve_Resolver;
/** @constructor */
function $h_Lamf_client_resolve_Resolver() {
  /*<skip>*/
}
$h_Lamf_client_resolve_Resolver.prototype = $c_Lamf_client_resolve_Resolver.prototype;
$c_Lamf_client_resolve_Resolver.prototype.$$js$exported$meth$resolve__Lamf_client_model_document_BaseUnit__T__O = (function(unit, pipeline) {
  return this.resolve__Lamf_client_model_document_BaseUnit__T__Lamf_client_model_document_BaseUnit(unit, pipeline)
});
$c_Lamf_client_resolve_Resolver.prototype.$$js$exported$meth$resolve__Lamf_client_model_document_BaseUnit__O = (function(unit) {
  return this.resolve__Lamf_client_model_document_BaseUnit__T__Lamf_client_model_document_BaseUnit(unit, $m_Lamf_core_resolution_pipelines_ResolutionPipeline$().DEFAULT$undPIPELINE$1)
});
$c_Lamf_client_resolve_Resolver.prototype.resolve__Lamf_client_model_document_BaseUnit__T__Lamf_client_model_document_BaseUnit = (function(unit, pipeline) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$2 = $m_Lamf_core_services_RuntimeResolver$();
  var vendor = this.vendor$1;
  $m_Lamf_client_convert_CoreClientConverters$();
  $m_Lamf_client_convert_CoreClientConverters$().BaseUnitMatcher__Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$();
  var unit$1 = unit.$$undinternal__Lamf_core_model_document_BaseUnit();
  var from = this$2.resolve__T__Lamf_core_model_document_BaseUnit__T__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(vendor, unit$1, pipeline, $f_Lamf_core_model_document_BaseUnit__errorHandler__Lamf_core_errorhandling_ErrorHandler(unit$1));
  var m$1 = $m_Lamf_client_convert_CoreClientConverters$().BaseUnitMatcher__Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$();
  return m$1.asClient__Lamf_core_model_document_BaseUnit__Lamf_client_model_document_BaseUnit(from)
});
$c_Lamf_client_resolve_Resolver.prototype.$$js$exported$meth$resolve__Lamf_client_model_document_BaseUnit__T__Lamf_client_resolve_ClientErrorHandler__O = (function(unit, pipeline, errorHandler) {
  return this.resolve__Lamf_client_model_document_BaseUnit__T__Lamf_client_resolve_ClientErrorHandler__Lamf_client_model_document_BaseUnit(unit, pipeline, errorHandler)
});
$c_Lamf_client_resolve_Resolver.prototype.resolve__Lamf_client_model_document_BaseUnit__T__Lamf_client_resolve_ClientErrorHandler__Lamf_client_model_document_BaseUnit = (function(unit, pipeline, errorHandler) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var from = $m_Lamf_core_services_RuntimeResolver$().resolve__T__Lamf_core_model_document_BaseUnit__T__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(this.vendor$1, ($m_Lamf_client_convert_CoreClientConverters$(), $m_Lamf_client_convert_CoreClientConverters$().BaseUnitMatcher__Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$(), unit.$$undinternal__Lamf_core_model_document_BaseUnit()), pipeline, ($m_Lamf_client_convert_CoreClientConverters$(), new $c_Lamf_client_resolve_ClientErrorHandlerConverter$$anonfun$convert$2().init___Lamf_client_resolve_ClientErrorHandler(errorHandler)));
  var m$2 = $m_Lamf_client_convert_CoreClientConverters$().BaseUnitMatcher__Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$();
  return m$2.asClient__Lamf_core_model_document_BaseUnit__Lamf_client_model_document_BaseUnit(from)
});
$c_Lamf_client_resolve_Resolver.prototype.init___T = (function(vendor) {
  this.vendor$1 = vendor;
  return this
});
$c_Lamf_client_resolve_Resolver.prototype.resolve = (function(arg) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 1;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_client_model_document_BaseUnit(arg);
      var prep$2 = $as_T(rest[0]);
      return this.$$js$exported$meth$resolve__Lamf_client_model_document_BaseUnit__T__O(prep, prep$2);
      break
    }
    case 0: {
      var prep$3 = $as_Lamf_client_model_document_BaseUnit(arg);
      return this.$$js$exported$meth$resolve__Lamf_client_model_document_BaseUnit__O(prep$3);
      break
    }
    case 2: {
      var prep$4 = $as_Lamf_client_model_document_BaseUnit(arg);
      var prep$5 = $as_T(rest[0]);
      var prep$6 = $as_Lamf_client_resolve_ClientErrorHandler(rest[1]);
      return this.$$js$exported$meth$resolve__Lamf_client_model_document_BaseUnit__T__Lamf_client_resolve_ClientErrorHandler__O(prep$4, prep$5, prep$6);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
var $d_Lamf_client_resolve_Resolver = new $TypeData().initClass({
  Lamf_client_resolve_Resolver: 0
}, false, "amf.client.resolve.Resolver", {
  Lamf_client_resolve_Resolver: 1,
  O: 1
});
$c_Lamf_client_resolve_Resolver.prototype.$classData = $d_Lamf_client_resolve_Resolver;
function $f_Lamf_client_resource_BaseFileResourceLoader__fetch__T__sjs_js_Promise($thiz, resource) {
  var this$2 = new $c_sci_StringOps().init___T(resource);
  var prefix = $m_Lamf_core_remote_File$().FILE$undPROTOCOL$1;
  return $thiz.fetchFile__T__sjs_js_Promise($f_sci_StringLike__stripPrefix__T__T(this$2, prefix))
}
function $f_Lamf_client_resource_BaseFileResourceLoader__accepts__T__Z($thiz, resource) {
  var o8 = $m_Lamf_core_remote_File$().unapply__T__s_Option(resource);
  if ((!o8.isEmpty__Z())) {
    return true
  };
  return false
}
/** @constructor */
function $c_Lamf_client_validate_PayloadParsingResult() {
  $c_O.call(this);
  this.$$undinternal$1 = null
}
$c_Lamf_client_validate_PayloadParsingResult.prototype = new $h_O();
$c_Lamf_client_validate_PayloadParsingResult.prototype.constructor = $c_Lamf_client_validate_PayloadParsingResult;
/** @constructor */
function $h_Lamf_client_validate_PayloadParsingResult() {
  /*<skip>*/
}
$h_Lamf_client_validate_PayloadParsingResult.prototype = $c_Lamf_client_validate_PayloadParsingResult.prototype;
$c_Lamf_client_validate_PayloadParsingResult.prototype.init___Lamf_core_validation_PayloadParsingResult = (function(_internal) {
  this.$$undinternal$1 = _internal;
  return this
});
$c_Lamf_client_validate_PayloadParsingResult.prototype.$$js$exported$prop$fragment__O = (function() {
  return this.fragment__Lamf_client_model_document_PayloadFragment()
});
$c_Lamf_client_validate_PayloadParsingResult.prototype.init___Lamf_client_model_document_PayloadFragment__sjs_js_Array = (function(fragment, results) {
  var jsx$1 = $as_Lamf_core_model_document_PayloadFragment(fragment.$$undinternal$1);
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var m = $m_Lamf_client_convert_CoreClientConverters$().ValidationResultMatcher__Lamf_client_convert_ValidationConverter$ValidationResultMatcher$();
  $c_Lamf_client_validate_PayloadParsingResult.prototype.init___Lamf_core_validation_PayloadParsingResult.call(this, new $c_Lamf_core_validation_PayloadParsingResult().init___Lamf_core_model_document_PayloadFragment__sci_List(jsx$1, new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, results, m).asInternal__sc_Seq().toList__sci_List()));
  return this
});
$c_Lamf_client_validate_PayloadParsingResult.prototype.results__sjs_js_Array = (function() {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal$1.results$1;
  var m = $m_Lamf_client_convert_CoreClientConverters$().ValidationResultMatcher__Lamf_client_convert_ValidationConverter$ValidationResultMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
});
$c_Lamf_client_validate_PayloadParsingResult.prototype.$$js$exported$prop$results__O = (function() {
  return this.results__sjs_js_Array()
});
$c_Lamf_client_validate_PayloadParsingResult.prototype.fragment__Lamf_client_model_document_PayloadFragment = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal$1.fragment$1;
  var m = $m_Lamf_client_convert_CoreClientConverters$().PayloadFragmentMatcher__Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$();
  return m.asClient__Lamf_core_model_document_PayloadFragment__Lamf_client_model_document_PayloadFragment(from)
});
Object.defineProperty($c_Lamf_client_validate_PayloadParsingResult.prototype, "results", {
  "get": (function() {
    return this.$$js$exported$prop$results__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_validate_PayloadParsingResult.prototype, "fragment", {
  "get": (function() {
    return this.$$js$exported$prop$fragment__O()
  }),
  "configurable": true
});
var $d_Lamf_client_validate_PayloadParsingResult = new $TypeData().initClass({
  Lamf_client_validate_PayloadParsingResult: 0
}, false, "amf.client.validate.PayloadParsingResult", {
  Lamf_client_validate_PayloadParsingResult: 1,
  O: 1
});
$c_Lamf_client_validate_PayloadParsingResult.prototype.$classData = $d_Lamf_client_validate_PayloadParsingResult;
/** @constructor */
function $c_Lamf_client_validate_PayloadValidator() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.exec$1 = null;
  this.executionContext$1 = null
}
$c_Lamf_client_validate_PayloadValidator.prototype = new $h_O();
$c_Lamf_client_validate_PayloadValidator.prototype.constructor = $c_Lamf_client_validate_PayloadValidator;
/** @constructor */
function $h_Lamf_client_validate_PayloadValidator() {
  /*<skip>*/
}
$h_Lamf_client_validate_PayloadValidator.prototype = $c_Lamf_client_validate_PayloadValidator.prototype;
$c_Lamf_client_validate_PayloadValidator.prototype.$$js$exported$meth$isValid__T__T__O = (function(mediaType, payload) {
  return this.isValid__T__T__sjs_js_Promise(mediaType, payload)
});
$c_Lamf_client_validate_PayloadValidator.prototype.validate__Lamf_client_model_document_PayloadFragment__sjs_js_Promise = (function(payloadFragment) {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal$1.validate__Lamf_core_model_document_PayloadFragment__s_concurrent_ExecutionContext__s_concurrent_Future(($m_Lamf_client_convert_CoreClientConverters$(), $m_Lamf_client_convert_CoreClientConverters$().PayloadFragmentMatcher__Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$(), $as_Lamf_core_model_document_PayloadFragment(payloadFragment.$$undinternal$1)), this.executionContext$1);
  var m$1 = $m_Lamf_client_convert_CoreClientConverters$().ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$();
  var executionContext = this.executionContext$1;
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$2, from, m$1, executionContext).asClient__O()
});
$c_Lamf_client_validate_PayloadValidator.prototype.init___Lamf_core_validation_PayloadValidator__Lamf_client_execution_BaseExecutionEnvironment = (function(_internal, exec) {
  this.$$undinternal$1 = _internal;
  this.exec$1 = exec;
  this.executionContext$1 = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  return this
});
$c_Lamf_client_validate_PayloadValidator.prototype.$$js$exported$meth$syncValidate__T__T__O = (function(mediaType, payload) {
  return this.syncValidate__T__T__Lamf_client_validate_ValidationReport(mediaType, payload)
});
$c_Lamf_client_validate_PayloadValidator.prototype.isValid__T__T__sjs_js_Promise = (function(mediaType, payload) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal$1.isValid__T__T__s_concurrent_ExecutionContext__s_concurrent_Future(mediaType, payload, this.executionContext$1);
  var m = $m_Lamf_client_convert_CoreClientConverters$().BooleanMatcher__Lamf_client_convert_CoreBaseConverter$BooleanMatcher$();
  var executionContext = this.executionContext$1;
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$1, from, m, executionContext).asClient__O()
});
$c_Lamf_client_validate_PayloadValidator.prototype.validate__T__T__sjs_js_Promise = (function(mediaType, payload) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal$1.validate__T__T__s_concurrent_ExecutionContext__s_concurrent_Future(mediaType, payload, this.executionContext$1);
  var m = $m_Lamf_client_convert_CoreClientConverters$().ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$();
  var executionContext = this.executionContext$1;
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$1, from, m, executionContext).asClient__O()
});
$c_Lamf_client_validate_PayloadValidator.prototype.$$js$exported$meth$validate__T__T__O = (function(mediaType, payload) {
  return this.validate__T__T__sjs_js_Promise(mediaType, payload)
});
$c_Lamf_client_validate_PayloadValidator.prototype.$$js$exported$meth$validate__Lamf_client_model_document_PayloadFragment__O = (function(payloadFragment) {
  return this.validate__Lamf_client_model_document_PayloadFragment__sjs_js_Promise(payloadFragment)
});
$c_Lamf_client_validate_PayloadValidator.prototype.syncValidate__T__T__Lamf_client_validate_ValidationReport = (function(mediaType, payload) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal$1.syncValidate__T__T__Lamf_core_validation_AMFValidationReport(mediaType, payload);
  $m_Lamf_client_convert_CoreClientConverters$().ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$();
  return new $c_Lamf_client_validate_ValidationReport().init___Lamf_core_validation_AMFValidationReport(from)
});
$c_Lamf_client_validate_PayloadValidator.prototype.syncValidate = (function(arg, arg$2) {
  var prep = $as_T(arg);
  var prep$2 = $as_T(arg$2);
  return this.$$js$exported$meth$syncValidate__T__T__O(prep, prep$2)
});
$c_Lamf_client_validate_PayloadValidator.prototype.validate = (function(arg) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 1;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      var prep = $as_Lamf_client_model_document_PayloadFragment(arg);
      return this.$$js$exported$meth$validate__Lamf_client_model_document_PayloadFragment__O(prep);
      break
    }
    case 1: {
      var prep$2 = $as_T(arg);
      var prep$3 = $as_T(rest[0]);
      return this.$$js$exported$meth$validate__T__T__O(prep$2, prep$3);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_validate_PayloadValidator.prototype.isValid = (function(arg, arg$2) {
  var prep = $as_T(arg);
  var prep$2 = $as_T(arg$2);
  return this.$$js$exported$meth$isValid__T__T__O(prep, prep$2)
});
function $as_Lamf_client_validate_PayloadValidator(obj) {
  return (((obj instanceof $c_Lamf_client_validate_PayloadValidator) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.validate.PayloadValidator"))
}
function $isArrayOf_Lamf_client_validate_PayloadValidator(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_validate_PayloadValidator)))
}
function $asArrayOf_Lamf_client_validate_PayloadValidator(obj, depth) {
  return (($isArrayOf_Lamf_client_validate_PayloadValidator(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.validate.PayloadValidator;", depth))
}
var $d_Lamf_client_validate_PayloadValidator = new $TypeData().initClass({
  Lamf_client_validate_PayloadValidator: 0
}, false, "amf.client.validate.PayloadValidator", {
  Lamf_client_validate_PayloadValidator: 1,
  O: 1
});
$c_Lamf_client_validate_PayloadValidator.prototype.$classData = $d_Lamf_client_validate_PayloadValidator;
/** @constructor */
function $c_Lamf_client_validate_ValidationReport() {
  $c_O.call(this);
  this.$$undinternal$1 = null
}
$c_Lamf_client_validate_ValidationReport.prototype = new $h_O();
$c_Lamf_client_validate_ValidationReport.prototype.constructor = $c_Lamf_client_validate_ValidationReport;
/** @constructor */
function $h_Lamf_client_validate_ValidationReport() {
  /*<skip>*/
}
$h_Lamf_client_validate_ValidationReport.prototype = $c_Lamf_client_validate_ValidationReport.prototype;
$c_Lamf_client_validate_ValidationReport.prototype.init___Z__T__Lamf_ProfileName__sjs_js_Array = (function(conforms, model, profile, results) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var m = $m_Lamf_client_convert_CoreClientConverters$().ValidationResultMatcher__Lamf_client_convert_ValidationConverter$ValidationResultMatcher$();
  $c_Lamf_client_validate_ValidationReport.prototype.init___Lamf_core_validation_AMFValidationReport.call(this, new $c_Lamf_core_validation_AMFValidationReport().init___Z__T__Lamf_ProfileName__sc_Seq(conforms, model, profile, new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, results, m).asInternal__sc_Seq()));
  return this
});
$c_Lamf_client_validate_ValidationReport.prototype.$$js$exported$meth$toString__I__O = (function(max) {
  return this.$$undinternal$1.toString__I__T(max)
});
$c_Lamf_client_validate_ValidationReport.prototype.init___Lamf_core_validation_AMFValidationReport = (function(_internal) {
  this.$$undinternal$1 = _internal;
  return this
});
$c_Lamf_client_validate_ValidationReport.prototype.$$js$exported$meth$toString__O = (function() {
  var this$1 = this.$$undinternal$1;
  return this$1.toString__I__T(this$1.DefaultMax$1)
});
$c_Lamf_client_validate_ValidationReport.prototype.toString__T = (function() {
  var this$1 = this.$$undinternal$1;
  return this$1.toString__I__T(this$1.DefaultMax$1)
});
$c_Lamf_client_validate_ValidationReport.prototype.results__sjs_js_Array = (function() {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal$1.results$1;
  var m = $m_Lamf_client_convert_CoreClientConverters$().ValidationResultMatcher__Lamf_client_convert_ValidationConverter$ValidationResultMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
});
$c_Lamf_client_validate_ValidationReport.prototype.$$js$exported$prop$results__O = (function() {
  return this.results__sjs_js_Array()
});
$c_Lamf_client_validate_ValidationReport.prototype.$$js$exported$prop$conforms__O = (function() {
  return this.$$undinternal$1.conforms$1
});
$c_Lamf_client_validate_ValidationReport.prototype.$$js$exported$prop$model__O = (function() {
  return this.$$undinternal$1.model$1
});
$c_Lamf_client_validate_ValidationReport.prototype.$$js$exported$prop$profile__O = (function() {
  return this.$$undinternal$1.profile$1
});
$c_Lamf_client_validate_ValidationReport.prototype.toString = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $uI(rest[0]);
      return this.$$js$exported$meth$toString__I__O(prep);
      break
    }
    case 0: {
      return this.$$js$exported$meth$toString__O();
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
Object.defineProperty($c_Lamf_client_validate_ValidationReport.prototype, "results", {
  "get": (function() {
    return this.$$js$exported$prop$results__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_validate_ValidationReport.prototype, "profile", {
  "get": (function() {
    return this.$$js$exported$prop$profile__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_validate_ValidationReport.prototype, "model", {
  "get": (function() {
    return this.$$js$exported$prop$model__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_validate_ValidationReport.prototype, "conforms", {
  "get": (function() {
    return this.$$js$exported$prop$conforms__O()
  }),
  "configurable": true
});
function $as_Lamf_client_validate_ValidationReport(obj) {
  return (((obj instanceof $c_Lamf_client_validate_ValidationReport) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.validate.ValidationReport"))
}
function $isArrayOf_Lamf_client_validate_ValidationReport(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_validate_ValidationReport)))
}
function $asArrayOf_Lamf_client_validate_ValidationReport(obj, depth) {
  return (($isArrayOf_Lamf_client_validate_ValidationReport(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.validate.ValidationReport;", depth))
}
var $d_Lamf_client_validate_ValidationReport = new $TypeData().initClass({
  Lamf_client_validate_ValidationReport: 0
}, false, "amf.client.validate.ValidationReport", {
  Lamf_client_validate_ValidationReport: 1,
  O: 1
});
$c_Lamf_client_validate_ValidationReport.prototype.$classData = $d_Lamf_client_validate_ValidationReport;
/** @constructor */
function $c_Lamf_client_validate_ValidationResult() {
  $c_O.call(this);
  this.$$undinternal$1 = null
}
$c_Lamf_client_validate_ValidationResult.prototype = new $h_O();
$c_Lamf_client_validate_ValidationResult.prototype.constructor = $c_Lamf_client_validate_ValidationResult;
/** @constructor */
function $h_Lamf_client_validate_ValidationResult() {
  /*<skip>*/
}
$h_Lamf_client_validate_ValidationResult.prototype = $c_Lamf_client_validate_ValidationResult.prototype;
$c_Lamf_client_validate_ValidationResult.prototype.$$js$exported$prop$validationId__O = (function() {
  return this.$$undinternal$1.validationId$1
});
$c_Lamf_client_validate_ValidationResult.prototype.$$js$exported$prop$location__O = (function() {
  return this.location__sjs_js_UndefOr()
});
$c_Lamf_client_validate_ValidationResult.prototype.$$js$exported$prop$targetProperty__O = (function() {
  return this.targetProperty__T()
});
$c_Lamf_client_validate_ValidationResult.prototype.$$js$exported$prop$position__O = (function() {
  return this.position__Lamf_core_parser_Range()
});
$c_Lamf_client_validate_ValidationResult.prototype.position__Lamf_core_parser_Range = (function() {
  var x1 = this.$$undinternal$1.position$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var lexical = $as_Lamf_core_annotations_LexicalInformation(x2.value$2);
    return lexical.range__Lamf_core_parser_Range()
  } else {
    return $m_Lamf_core_parser_Range$NONE$()
  }
});
$c_Lamf_client_validate_ValidationResult.prototype.$$js$exported$prop$message__O = (function() {
  return this.$$undinternal$1.message$1
});
$c_Lamf_client_validate_ValidationResult.prototype.$$js$exported$prop$targetNode__O = (function() {
  return this.$$undinternal$1.targetNode$1
});
$c_Lamf_client_validate_ValidationResult.prototype.$$js$exported$prop$source__O = (function() {
  return this.$$undinternal$1.source$1
});
$c_Lamf_client_validate_ValidationResult.prototype.init___T__T__T__T__T__Lamf_core_parser_Range__T = (function(message, level, targetNode, targetProperty, validationId, position, location) {
  var targetProperty$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T(targetProperty).option__s_Option();
  var position$1 = new $c_s_Some().init___O(new $c_Lamf_core_annotations_LexicalInformation().init___Lamf_core_parser_Range(position));
  var location$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T(location).option__s_Option();
  $c_Lamf_client_validate_ValidationResult.prototype.init___Lamf_core_validation_AMFValidationResult.call(this, new $c_Lamf_core_validation_AMFValidationResult().init___T__T__T__s_Option__T__s_Option__s_Option__O(message, level, targetNode, targetProperty$1, validationId, position$1, location$1, null));
  return this
});
$c_Lamf_client_validate_ValidationResult.prototype.init___Lamf_core_validation_AMFValidationResult = (function(_internal) {
  this.$$undinternal$1 = _internal;
  return this
});
$c_Lamf_client_validate_ValidationResult.prototype.targetProperty__T = (function() {
  var this$1 = this.$$undinternal$1.targetProperty$1;
  return $as_T((this$1.isEmpty__Z() ? null : this$1.get__O()))
});
$c_Lamf_client_validate_ValidationResult.prototype.location__sjs_js_UndefOr = (function() {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal$1.location$1;
  var m = $m_Lamf_client_convert_CoreClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
});
$c_Lamf_client_validate_ValidationResult.prototype.$$js$exported$prop$level__O = (function() {
  return this.$$undinternal$1.level$1
});
Object.defineProperty($c_Lamf_client_validate_ValidationResult.prototype, "location", {
  "get": (function() {
    return this.$$js$exported$prop$location__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_validate_ValidationResult.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_validate_ValidationResult.prototype, "source", {
  "get": (function() {
    return this.$$js$exported$prop$source__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_validate_ValidationResult.prototype, "validationId", {
  "get": (function() {
    return this.$$js$exported$prop$validationId__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_validate_ValidationResult.prototype, "targetProperty", {
  "get": (function() {
    return this.$$js$exported$prop$targetProperty__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_validate_ValidationResult.prototype, "targetNode", {
  "get": (function() {
    return this.$$js$exported$prop$targetNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_validate_ValidationResult.prototype, "level", {
  "get": (function() {
    return this.$$js$exported$prop$level__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_validate_ValidationResult.prototype, "message", {
  "get": (function() {
    return this.$$js$exported$prop$message__O()
  }),
  "configurable": true
});
function $as_Lamf_client_validate_ValidationResult(obj) {
  return (((obj instanceof $c_Lamf_client_validate_ValidationResult) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.validate.ValidationResult"))
}
function $isArrayOf_Lamf_client_validate_ValidationResult(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_validate_ValidationResult)))
}
function $asArrayOf_Lamf_client_validate_ValidationResult(obj, depth) {
  return (($isArrayOf_Lamf_client_validate_ValidationResult(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.validate.ValidationResult;", depth))
}
var $d_Lamf_client_validate_ValidationResult = new $TypeData().initClass({
  Lamf_client_validate_ValidationResult: 0
}, false, "amf.client.validate.ValidationResult", {
  Lamf_client_validate_ValidationResult: 1,
  O: 1
});
$c_Lamf_client_validate_ValidationResult.prototype.$classData = $d_Lamf_client_validate_ValidationResult;
/** @constructor */
function $c_Lamf_client_validate_Validator$() {
  $c_O.call(this)
}
$c_Lamf_client_validate_Validator$.prototype = new $h_O();
$c_Lamf_client_validate_Validator$.prototype.constructor = $c_Lamf_client_validate_Validator$;
/** @constructor */
function $h_Lamf_client_validate_Validator$() {
  /*<skip>*/
}
$h_Lamf_client_validate_Validator$.prototype = $c_Lamf_client_validate_Validator$.prototype;
$c_Lamf_client_validate_Validator$.prototype.$$js$exported$meth$loadValidationProfile__T__Lamf_client_environment_Environment__O = (function(url, env) {
  return this.loadValidationProfile__T__Lamf_client_environment_Environment__sjs_js_Promise(url, env)
});
$c_Lamf_client_validate_Validator$.prototype.init___ = (function() {
  return this
});
$c_Lamf_client_validate_Validator$.prototype.validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__Z__sjs_js_Promise = (function(model, profileName, messageStyle, env, resolved) {
  var this$1 = env.executionEnvironment__Lamf_client_execution_BaseExecutionEnvironment();
  var executionContext = this$1.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  var this$3 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$2 = $m_Lamf_core_services_RuntimeValidator$();
  var model$1 = model.$$undinternal__Lamf_core_model_document_BaseUnit();
  var env$1 = env.$$undinternal$1;
  var executionEnvironment = env.executionEnvironment__Lamf_client_execution_BaseExecutionEnvironment();
  var from = this$2.validator__p1__Lamf_core_services_RuntimeValidator().validate__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(model$1, profileName, messageStyle, env$1, resolved, executionEnvironment).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(report$2) {
      var report = $as_Lamf_core_validation_AMFValidationReport(report$2);
      return report
    })
  })(this)), executionContext);
  var m = $m_Lamf_client_convert_CoreClientConverters$().ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$();
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$3, from, m, executionContext).asClient__O()
});
$c_Lamf_client_validate_Validator$.prototype.loadValidationProfile__T__Lamf_client_environment_Environment__sjs_js_Promise = (function(url, env) {
  var this$1 = env.executionEnvironment__Lamf_client_execution_BaseExecutionEnvironment();
  var executionContext = this$1.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  var this$3 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$2 = $m_Lamf_core_services_RuntimeValidator$();
  var env$1 = env.$$undinternal$1;
  var errorHandler = $m_Lamf_core_errorhandling_UnhandledErrorHandler$();
  var executionEnvironment = env.executionEnvironment__Lamf_client_execution_BaseExecutionEnvironment();
  var from = this$2.validator__p1__Lamf_core_services_RuntimeValidator().loadValidationProfile__T__Lamf_internal_environment_Environment__Lamf_core_errorhandling_ErrorHandler__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(url, env$1, errorHandler, executionEnvironment);
  var m = $m_Lamf_client_convert_CoreClientConverters$().ProfileNameMatcher__Lamf_client_convert_CoreBaseConverter$ProfileNameMatcher$();
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$3, from, m, executionContext).asClient__O()
});
$c_Lamf_client_validate_Validator$.prototype.$$js$exported$meth$validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__Z__O = (function(model, profileName, messageStyle, env, resolved) {
  return this.validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__Z__sjs_js_Promise(model, profileName, messageStyle, env, resolved)
});
$c_Lamf_client_validate_Validator$.prototype.$$js$exported$meth$validate$default$3__Lamf_MessageStyle = (function() {
  return $m_Lamf_AMFStyle$()
});
$c_Lamf_client_validate_Validator$.prototype.$$js$exported$meth$validate$default$4__Lamf_client_environment_Environment = (function() {
  return $m_Lamf_client_environment_DefaultEnvironment$().apply__Lamf_client_environment_Environment()
});
$c_Lamf_client_validate_Validator$.prototype.$$js$exported$meth$validate$default$5__Z = (function() {
  return false
});
$c_Lamf_client_validate_Validator$.prototype.$$js$exported$meth$emitShapesGraph__Lamf_ProfileName__O = (function(profileName) {
  var this$1 = $m_Lamf_core_services_RuntimeValidator$();
  return this$1.validator__p1__Lamf_core_services_RuntimeValidator().emitShapesGraph__Lamf_ProfileName__T(profileName)
});
$c_Lamf_client_validate_Validator$.prototype.$$js$exported$meth$loadValidationProfile$default$2__Lamf_client_environment_Environment = (function() {
  return $m_Lamf_client_environment_DefaultEnvironment$().apply__Lamf_client_environment_Environment()
});
$c_Lamf_client_validate_Validator$.prototype.emitShapesGraph = (function(arg) {
  var prep = $as_Lamf_ProfileName(arg);
  return this.$$js$exported$meth$emitShapesGraph__Lamf_ProfileName__O(prep)
});
$c_Lamf_client_validate_Validator$.prototype.loadValidationProfile = (function(arg) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 1;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = $as_T(arg);
  var prep$2 = ((rest[0] === (void 0)) ? this.$$js$exported$meth$loadValidationProfile$default$2__Lamf_client_environment_Environment() : $as_Lamf_client_environment_Environment(rest[0]));
  return this.$$js$exported$meth$loadValidationProfile__T__Lamf_client_environment_Environment__O(prep, prep$2)
});
$c_Lamf_client_validate_Validator$.prototype.validate = (function(arg, arg$2) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 2;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = $as_Lamf_client_model_document_BaseUnit(arg);
  var prep$2 = $as_Lamf_ProfileName(arg$2);
  var prep$3 = ((rest[0] === (void 0)) ? this.$$js$exported$meth$validate$default$3__Lamf_MessageStyle() : $as_Lamf_MessageStyle(rest[0]));
  var prep$4 = ((rest[1] === (void 0)) ? this.$$js$exported$meth$validate$default$4__Lamf_client_environment_Environment() : $as_Lamf_client_environment_Environment(rest[1]));
  var prep$5 = ((rest[2] === (void 0)) ? this.$$js$exported$meth$validate$default$5__Z() : $uZ(rest[2]));
  return this.$$js$exported$meth$validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__Z__O(prep, prep$2, prep$3, prep$4, prep$5)
});
var $d_Lamf_client_validate_Validator$ = new $TypeData().initClass({
  Lamf_client_validate_Validator$: 0
}, false, "amf.client.validate.Validator$", {
  Lamf_client_validate_Validator$: 1,
  O: 1
});
$c_Lamf_client_validate_Validator$.prototype.$classData = $d_Lamf_client_validate_Validator$;
var $n_Lamf_client_validate_Validator$ = (void 0);
function $m_Lamf_client_validate_Validator$() {
  if ((!$n_Lamf_client_validate_Validator$)) {
    $n_Lamf_client_validate_Validator$ = new $c_Lamf_client_validate_Validator$().init___()
  };
  return $n_Lamf_client_validate_Validator$
}
/** @constructor */
function $c_Lamf_core_AMF$() {
  $c_O.call(this);
  this.initializedPlugins$1 = null
}
$c_Lamf_core_AMF$.prototype = new $h_O();
$c_Lamf_core_AMF$.prototype.constructor = $c_Lamf_core_AMF$;
/** @constructor */
function $h_Lamf_core_AMF$() {
  /*<skip>*/
}
$h_Lamf_core_AMF$.prototype = $c_Lamf_core_AMF$.prototype;
$c_Lamf_core_AMF$.prototype.init___ = (function() {
  $n_Lamf_core_AMF$ = this;
  var array = [$m_Lamf_plugins_syntax_SYamlSyntaxPlugin$().ID$2, $m_Lamf_plugins_document_graph_AMFGraphPlugin$().ID$2, $m_Lamf_plugins_syntax_SYamlSyntaxPlugin$().ID$2];
  if (($uI(array.length) === 0)) {
    var jsx$1 = new $c_scm_HashSet().init___()
  } else {
    var b = new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_HashSet().init___());
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      b.$$plus$eq__O__scm_GrowingBuilder(arg1);
      i = ((1 + i) | 0)
    };
    var jsx$1 = $as_sc_GenTraversable(b.elems$1)
  };
  this.initializedPlugins$1 = $as_scm_Set(jsx$1);
  return this
});
$c_Lamf_core_AMF$.prototype.init__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  $m_Lamf_core_AMFCompiler$().init__s_concurrent_ExecutionContext__V(executionContext);
  $m_Lamf_core_AMFSerializer$().init__s_concurrent_ExecutionContext__V(executionContext);
  var registeredSYamlPlugin = $m_Lamf_plugins_syntax_SYamlSyntaxPlugin$().init__s_concurrent_ExecutionContext__s_concurrent_Future(executionContext);
  var registeredAMFGraphPlugin = $m_Lamf_plugins_document_graph_AMFGraphPlugin$().init__s_concurrent_ExecutionContext__s_concurrent_Future(executionContext);
  var jsx$3 = $m_s_concurrent_Future$();
  var jsx$2 = $m_sc_Seq$();
  var array = [registeredSYamlPlugin, registeredAMFGraphPlugin];
  var jsx$1 = $as_sc_TraversableOnce(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  var this$3 = $m_sc_Seq$();
  return jsx$3.sequence__sc_TraversableOnce__scg_CanBuildFrom__s_concurrent_ExecutionContext__s_concurrent_Future(jsx$1, this$3.ReusableCBFInstance$2, executionContext).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, executionContext$1) {
    return (function(x$1$2) {
      $as_sc_Seq(x$1$2);
      return $m_Lamf_core_AMF$().processInitializations__sc_Seq__s_concurrent_ExecutionContext__s_concurrent_Future($m_Lamf_core_registries_AMFPluginsRegistry$().plugins__sc_Iterable().toSeq__sc_Seq(), executionContext$1)
    })
  })(this, executionContext)), executionContext).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$2$2) {
      $asUnit(x$2$2);
      $m_Lamf_core_registries_AMFPluginsRegistry$().registerSyntaxPlugin__Lamf_client_plugins_AMFSyntaxPlugin__V($m_Lamf_plugins_syntax_SYamlSyntaxPlugin$());
      $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_graph_AMFGraphPlugin$())
    })
  })(this)), executionContext)
});
$c_Lamf_core_AMF$.prototype.registerPlugin__Lamf_client_plugins_AMFPlugin__V = (function(plugin) {
  if ((plugin instanceof $c_Lamf_client_plugins_AMFSyntaxPlugin)) {
    var x2 = $as_Lamf_client_plugins_AMFSyntaxPlugin(plugin);
    $m_Lamf_core_registries_AMFPluginsRegistry$().registerSyntaxPlugin__Lamf_client_plugins_AMFSyntaxPlugin__V(x2)
  } else if ((plugin instanceof $c_Lamf_client_plugins_AMFDocumentPlugin)) {
    var x3 = $as_Lamf_client_plugins_AMFDocumentPlugin(plugin);
    $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V(x3)
  } else if ((plugin instanceof $c_Lamf_client_plugins_AMFDomainPlugin)) {
    var x4 = $as_Lamf_client_plugins_AMFDomainPlugin(plugin);
    $m_Lamf_core_registries_AMFPluginsRegistry$().registerDomainPlugin__Lamf_client_plugins_AMFDomainPlugin__V(x4)
  } else if ($is_Lamf_client_plugins_AMFFeaturePlugin(plugin)) {
    var x5 = $as_Lamf_client_plugins_AMFFeaturePlugin(plugin);
    $m_Lamf_core_registries_AMFPluginsRegistry$().registerFeaturePlugin__Lamf_client_plugins_AMFFeaturePlugin__V(x5)
  } else if ($is_Lamf_core_validation_AMFPayloadValidationPlugin(plugin)) {
    var x6 = $as_Lamf_core_validation_AMFPayloadValidationPlugin(plugin);
    $m_Lamf_core_registries_AMFPluginsRegistry$().registerPayloadValidationPlugin__Lamf_core_validation_AMFPayloadValidationPlugin__V(x6)
  } else {
    throw new $c_s_MatchError().init___O(plugin)
  }
});
$c_Lamf_core_AMF$.prototype.processInitializations__sc_Seq__s_concurrent_ExecutionContext__s_concurrent_Future = (function(plugins, executionContext) {
  _processInitializations: while (true) {
    if (plugins.isEmpty__Z()) {
      return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
        return (function() {
          return (void 0)
        })
      })(this)), executionContext)
    } else {
      var nextPlugin = $as_Lamf_client_plugins_AMFPlugin(plugins.head__O());
      if (this.initializedPlugins$1.contains__O__Z(nextPlugin.ID__T())) {
        plugins = $as_sc_Seq(plugins.tail__O());
        continue _processInitializations
      } else {
        var notInitializedYet = $as_sc_Seq(nextPlugin.dependencies__sc_Seq().filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
          return (function(plugin$2) {
            var plugin = $as_Lamf_client_plugins_AMFPlugin(plugin$2);
            return (!$m_Lamf_core_AMF$().initializedPlugins$1.contains__O__Z(plugin.ID__T()))
          })
        })(this))));
        return this.processInitializations__sc_Seq__s_concurrent_ExecutionContext__s_concurrent_Future(notInitializedYet, executionContext).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3, nextPlugin$1, executionContext$1) {
          return (function(x$3$2) {
            $asUnit(x$3$2);
            return nextPlugin$1.init__s_concurrent_ExecutionContext__s_concurrent_Future(executionContext$1).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, nextPlugin$1$1) {
              return (function(x$4$2) {
                $as_Lamf_client_plugins_AMFPlugin(x$4$2);
                return $as_scm_Set($m_Lamf_core_AMF$().initializedPlugins$1.$$plus$eq__O__scm_SetLike(nextPlugin$1$1.ID__T()))
              })
            })(this$3, nextPlugin$1)), executionContext$1)
          })
        })(this, nextPlugin, executionContext)), executionContext).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4, plugins$1, executionContext$2) {
          return (function(x$5$2) {
            $as_scm_Set(x$5$2);
            return $m_Lamf_core_AMF$().processInitializations__sc_Seq__s_concurrent_ExecutionContext__s_concurrent_Future($as_sc_Seq(plugins$1.tail__O()), executionContext$2)
          })
        })(this, plugins, executionContext)), executionContext)
      }
    }
  }
});
var $d_Lamf_core_AMF$ = new $TypeData().initClass({
  Lamf_core_AMF$: 0
}, false, "amf.core.AMF$", {
  Lamf_core_AMF$: 1,
  O: 1
});
$c_Lamf_core_AMF$.prototype.$classData = $d_Lamf_core_AMF$;
var $n_Lamf_core_AMF$ = (void 0);
function $m_Lamf_core_AMF$() {
  if ((!$n_Lamf_core_AMF$)) {
    $n_Lamf_core_AMF$ = new $c_Lamf_core_AMF$().init___()
  };
  return $n_Lamf_core_AMF$
}
/** @constructor */
function $c_Lamf_core_AMFCompiler() {
  $c_O.call(this);
  this.compilerContext$1 = null;
  this.mediaType$1 = null;
  this.vendor$1 = null;
  this.referenceKind$1 = null;
  this.parsingOptions$1 = null
}
$c_Lamf_core_AMFCompiler.prototype = new $h_O();
$c_Lamf_core_AMFCompiler.prototype.constructor = $c_Lamf_core_AMFCompiler;
/** @constructor */
function $h_Lamf_core_AMFCompiler() {
  /*<skip>*/
}
$h_Lamf_core_AMFCompiler.prototype = $c_Lamf_core_AMFCompiler.prototype;
$c_Lamf_core_AMFCompiler.prototype.parseDomain__p1__Lamf_core_Root__s_concurrent_ExecutionContext__s_concurrent_Future = (function(document, executionContext) {
  this.compilerContext$1.logForFile__T__V("AMFCompiler#parseDomain: parsing domain");
  var this$1 = this.vendor$1;
  if (this$1.isEmpty__Z()) {
    var domainPluginOption = $m_Lamf_core_registries_AMFPluginsRegistry$().documentPluginForMediaType__T__sc_Seq(document.mediatype$1).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, document$1) {
      return (function(x$9$2) {
        var x$9 = $as_Lamf_client_plugins_AMFDocumentPlugin(x$9$2);
        return x$9.canParse__Lamf_core_Root__Z(document$1)
      })
    })(this, document)))
  } else {
    var arg1 = this$1.get__O();
    var x$10 = $as_T(arg1);
    var domainPluginOption = $m_Lamf_core_registries_AMFPluginsRegistry$().documentPluginForVendor__T__sc_Seq(x$10).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, document$1$1) {
      return (function(x$11$2) {
        var x$11 = $as_Lamf_client_plugins_AMFDocumentPlugin(x$11$2);
        return x$11.canParse__Lamf_core_Root__Z(document$1$1)
      })
    })(this, document)))
  };
  var rc6 = false;
  var x3 = null;
  matchEnd7: {
    var futureDocument;
    if ((domainPluginOption instanceof $c_s_Some)) {
      var x2 = $as_s_Some(domainPluginOption);
      var domainPlugin = $as_Lamf_client_plugins_AMFDocumentPlugin(x2.value$2);
      this.compilerContext$1.logForFile__T__V(("AMFCompiler#parseSyntax: parsing domain plugin " + domainPlugin.ID__T()));
      var futureDocument = this.parseReferences__p1__Lamf_core_Root__Lamf_client_plugins_AMFDocumentPlugin__s_concurrent_ExecutionContext__s_concurrent_Future(document, domainPlugin, executionContext).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3, domainPlugin$1, document$2) {
        return (function(documentWithReferences$2) {
          var documentWithReferences = $as_Lamf_core_Root(documentWithReferences$2);
          var newCtx = this$3.compilerContext$1.parserContext$1.copyWithSonsReferences__Lamf_core_parser_ParserContext();
          var x1 = domainPlugin$1.parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option(documentWithReferences, newCtx, this$3.compilerContext$1.platform__Lamf_core_remote_Platform(), this$3.parsingOptions$1);
          if ((x1 instanceof $c_s_Some)) {
            var x2$1 = $as_s_Some(x1);
            var baseUnit = $as_Lamf_core_model_document_BaseUnit(x2$1.value$2);
            if ((document$2.location$1 === this$3.compilerContext$1.fileContext$1.root__T())) {
              var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Root$1;
              $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(baseUnit, field, true))
            };
            var raw = document$2.raw$1;
            var bu = $f_Lamf_core_model_document_BaseUnit__withRaw__T__Lamf_core_model_document_BaseUnit(baseUnit, raw);
            return new $c_Lamf_core_TaggedReferences$BuReferenceTagger().init___Lamf_core_model_document_BaseUnit(bu).tagReferences__Lamf_core_Root__Lamf_core_model_document_BaseUnit(documentWithReferences)
          } else {
            var x = $m_s_None$();
            if ((x === x1)) {
              $m_Lamf_core_parser_Annotations$();
              var annotations = new $c_Lamf_core_parser_Annotations().init___();
              var this$7 = new $c_Lamf_core_model_document_ExternalFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
              var value = document$2.location$1;
              var this$8 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$7, value));
              var location = document$2.location$1;
              var field$1 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
              var this$14 = $as_Lamf_core_model_document_EncodesModel($as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$8, field$1, location)));
              $m_Lamf_core_parser_Annotations$();
              var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
              var this$12 = new $c_Lamf_core_model_domain_ExternalDomainElement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
              var text = document$2.raw$1;
              var field$2 = $m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1;
              var this$13 = $as_Lamf_core_model_domain_ExternalDomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$12, field$2, text));
              var mediaType = document$2.mediatype$1;
              var field$3 = $m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().MediaType$1;
              var encoded = $as_Lamf_core_model_domain_ExternalDomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$13, field$3, mediaType));
              var field$4 = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
              return $as_Lamf_core_model_document_BaseUnit($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$14, field$4, encoded)))
            } else {
              throw new $c_s_MatchError().init___O(x1)
            }
          }
        })
      })(this, domainPlugin, document)), executionContext);
      break matchEnd7
    };
    var x$1 = $m_s_None$();
    if ((x$1 === domainPluginOption)) {
      rc6 = true;
      x3 = domainPluginOption;
      if (this.vendor$1.isDefined__Z()) {
        throw new $c_Lamf_core_exception_UnsupportedVendorException().init___T($as_T(this.vendor$1.get__O()))
      }
    };
    if (rc6) {
      var futureDocument = $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$4$1, document$3) {
        return (function() {
          this$4$1.compilerContext$1.logForFile__T__V("AMFCompiler#parseSyntax: parsing domain NO PLUGIN");
          $m_Lamf_core_parser_Annotations$();
          var annotations$2 = new $c_Lamf_core_parser_Annotations().init___();
          var this$18 = new $c_Lamf_core_model_document_ExternalFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$2);
          var location$1 = document$3.location$1;
          var field$5 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
          var this$19 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$18, field$5, location$1));
          var value$1 = document$3.location$1;
          var this$25 = $as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$19, value$1));
          $m_Lamf_core_parser_Annotations$();
          var annotations$3 = new $c_Lamf_core_parser_Annotations().init___();
          var this$23 = new $c_Lamf_core_model_domain_ExternalDomainElement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$3);
          var text$1 = document$3.raw$1;
          var field$6 = $m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1;
          var this$24 = $as_Lamf_core_model_domain_ExternalDomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$23, field$6, text$1));
          var mediaType$1 = document$3.mediatype$1;
          var field$7 = $m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().MediaType$1;
          var encoded$1 = $as_Lamf_core_model_domain_ExternalDomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$24, field$7, mediaType$1));
          var field$8 = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
          return $as_Lamf_core_model_document_ExternalFragment($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$25, field$8, encoded$1)))
        })
      })(this, document)), executionContext);
      break matchEnd7
    };
    throw new $c_s_MatchError().init___O(domainPluginOption)
  };
  return futureDocument.map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1) {
    return (function(baseUnit$2) {
      var baseUnit$1 = $as_Lamf_core_model_document_BaseUnit(baseUnit$2);
      var parserRun = this$5$1.compilerContext$1.parserRun$1;
      $f_Lamf_core_model_document_BaseUnit__withRunNumber__I__Lamf_core_model_document_BaseUnit(baseUnit$1, parserRun);
      this$5$1.compilerContext$1.logForFile__T__V("AMFCompiler#parseDomain: model ready");
      $as_Lamf_core_model_document_BaseUnit($m_Lamf_core_registries_AMFPluginsRegistry$().featurePlugins__sc_Seq().foldLeft__O__F2__O(baseUnit$1, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this$2) {
        return (function(x0$1$2, x1$1$2) {
          var x0$1 = $as_Lamf_core_model_document_BaseUnit(x0$1$2);
          $as_Lamf_client_plugins_AMFFeaturePlugin(x1$1$2);
          return x0$1
        })
      })(this$5$1))));
      return baseUnit$1
    })
  })(this)), executionContext)
});
$c_Lamf_core_AMFCompiler.prototype.parseReferences__p1__Lamf_core_Root__Lamf_client_plugins_AMFDocumentPlugin__s_concurrent_ExecutionContext__s_concurrent_Future = (function(root, domainPlugin, executionContext) {
  var handler = domainPlugin.referenceHandler__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_ReferenceHandler(this.compilerContext$1.parserContext$1.eh$1);
  var refs = handler.collect__Lamf_core_parser_ParsedDocument__Lamf_core_parser_ParserContext__Lamf_core_parser_ReferenceCollector(root.parsed$1, this.compilerContext$1.parserContext$1);
  this.compilerContext$1.logForFile__T__V((("AMFCompiler#parseReferences: " + refs.toReferences__sc_Seq().size__I()) + " references found"));
  var jsx$7 = $as_sc_TraversableLike(refs.toReferences__sc_Seq().filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$12$2) {
      var x$12 = $as_Lamf_core_parser_Reference(x$12$2);
      return x$12.isRemote__Z()
    })
  })(this))));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, domainPlugin$1, executionContext$1, handler$1) {
    return (function(link$2) {
      var link = $as_Lamf_core_parser_Reference(link$2);
      var jsx$3 = link.refs$1;
      var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
        return (function(x$13$2) {
          var x$13 = $as_Lamf_core_parser_RefContainer(x$13$2);
          return x$13.node$1
        })
      })(this$2));
      var this$1 = $m_sc_Seq$();
      var nodes = $as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$1.ReusableCBFInstance$2));
      return link.resolve__Lamf_core_CompilerContext__sc_Seq__Z__s_concurrent_ExecutionContext__s_concurrent_Future(this$2.compilerContext$1, nodes, domainPlugin$1.allowRecursiveReferences__Z(), executionContext$1).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, domainPlugin$2, nodes$1, link$1, handler$1$1, executionContext$3) {
        return (function(x0$1$2) {
          var x0$1 = $as_Lamf_core_parser_ReferenceResolutionResult(x0$1$2);
          if ((x0$1 !== null)) {
            var p3 = x0$1.unit$1;
            if ((p3 instanceof $c_s_Some)) {
              var x4 = $as_s_Some(p3);
              var unit = $as_Lamf_core_model_document_BaseUnit(x4.value$2);
              var jsx$6 = $f_Lamf_core_model_document_BaseUnit__sourceVendor__s_Option(unit);
              var jsx$5 = domainPlugin$2.vendors__sc_Seq();
              var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2) {
                return (function(name$2) {
                  var name = $as_T(name$2);
                  return $m_Lamf_core_remote_Vendor$().apply__T__Lamf_core_remote_Vendor(name)
                })
              })(this$2$1));
              var this$3 = $m_sc_Seq$();
              this$2$1.verifyMatchingVendor__p1__s_Option__sc_Seq__sc_Seq__V(jsx$6, $as_sc_Seq(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$4, this$3.ReusableCBFInstance$2)), nodes$1);
              this$2$1.verifyValidFragment__s_Option__sc_Seq__V($f_Lamf_core_model_document_BaseUnit__sourceVendor__s_Option(unit), link$1.refs$1);
              var reference = new $c_Lamf_core_parser_ParsedReference().init___Lamf_core_model_document_BaseUnit__Lamf_core_parser_Reference__s_Option(unit, link$1, $m_s_None$());
              return handler$1$1.update__Lamf_core_parser_ParsedReference__Lamf_core_CompilerContext__s_concurrent_ExecutionContext__s_concurrent_Future(reference, this$2$1.compilerContext$1, executionContext$3).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$2) {
                return (function(x$14$2) {
                  var x$14 = $as_Lamf_core_parser_ParsedReference(x$14$2);
                  return new $c_s_Some().init___O(x$14)
                })
              })(this$2$1)), executionContext$3)
            }
          };
          if ((x0$1 !== null)) {
            var p5 = x0$1.exception$1;
            if ((p5 instanceof $c_s_Some)) {
              var x7 = $as_s_Some(p5);
              var e = $as_jl_Throwable(x7.value$2);
              if ((e instanceof $c_Lamf_core_exception_CyclicReferenceException)) {
                var x2 = $as_Lamf_core_exception_CyclicReferenceException(e);
                if ((!domainPlugin$2.allowRecursiveReferences__Z())) {
                  this$2$1.compilerContext$1.violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lorg_yaml_model_YPart__V($m_Lamf_plugins_features_validation_CoreValidations$().CycleReferenceError$1, link$1.url$1, x2.s$1, $as_Lamf_core_parser_RefContainer(link$1.refs$1.head__O()).node$1);
                  return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$3$1) {
                    return (function() {
                      return $m_s_None$()
                    })
                  })(this$2$1)), executionContext$3)
                }
              };
              if ((!link$1.isInferred__Z())) {
                nodes$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, link$1$1, e$1) {
                  return (function(x$15$2) {
                    var x$15 = $as_Lorg_yaml_model_YNode(x$15$2);
                    this$4$1.compilerContext$1.violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lorg_yaml_model_YPart__V($m_Lamf_plugins_features_validation_CoreValidations$().UnresolvedReference$1, link$1$1.url$1, e$1.getMessage__T(), x$15)
                  })
                })(this$2$1, link$1, e)))
              };
              return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$5) {
                return (function() {
                  return $m_s_None$()
                })
              })(this$2$1)), executionContext$3)
            }
          };
          return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$6) {
            return (function() {
              return $m_s_None$()
            })
          })(this$2$1)), executionContext$3)
        })
      })(this$2, domainPlugin$1, nodes, link, handler$1, executionContext$1)), executionContext$1)
    })
  })(this, domainPlugin, executionContext, handler));
  var this$7 = $m_sc_Seq$();
  var parsed = $as_sc_Seq(jsx$7.map__F1__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
  var jsx$8 = $m_s_concurrent_Future$();
  var this$8 = $m_sc_Seq$();
  return jsx$8.sequence__sc_TraversableOnce__scg_CanBuildFrom__s_concurrent_ExecutionContext__s_concurrent_Future(parsed, this$8.ReusableCBFInstance$2, executionContext).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$2, root$1) {
    return (function(rs$2) {
      var rs = $as_sc_Seq(rs$2);
      var x$1 = $as_sc_Seq(rs.flatten__F1__sc_GenTraversable(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3) {
        return (function(xo$2) {
          var xo = $as_s_Option(xo$2);
          return xo.toList__sci_List()
        })
      })(this$3$2))));
      var x$2 = root$1.parsed$1;
      var x$3 = root$1.location$1;
      var x$4 = root$1.mediatype$1;
      var x$5 = root$1.referenceKind$1;
      var x$6 = root$1.raw$1;
      return new $c_Lamf_core_Root().init___Lamf_core_parser_ParsedDocument__T__T__sc_Seq__Lamf_core_parser_ReferenceKind__T(x$2, x$3, x$4, x$1, x$5, x$6)
    })
  })(this, root)), executionContext)
});
$c_Lamf_core_AMFCompiler.prototype.compile__p1__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  return this.resolve__p1__s_concurrent_ExecutionContext__s_concurrent_Future(executionContext).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(input$2) {
      var input = $as_Lamf_client_remote_Content(input$2);
      return $this.parseSyntax__p1__Lamf_client_remote_Content__s_util_Either(input)
    })
  })(this)), executionContext).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, executionContext$1) {
    return (function(parsed$2) {
      var parsed = $as_s_util_Either(parsed$2);
      return this$2.parseDomain__p1__s_util_Either__s_concurrent_ExecutionContext__s_concurrent_Future(parsed, executionContext$1)
    })
  })(this, executionContext)), executionContext)
});
$c_Lamf_core_AMFCompiler.prototype.parseExternalFragment__Lamf_client_remote_Content__s_concurrent_ExecutionContext__s_concurrent_Future = (function(content, executionContext) {
  return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, content$1) {
    return (function() {
      $m_Lamf_core_parser_Annotations$();
      var annotations = new $c_Lamf_core_parser_Annotations().init___();
      var this$4 = new $c_Lamf_core_model_domain_ExternalDomainElement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
      var value = (content$1.url$1 + "#/");
      var this$5 = $as_Lamf_core_model_domain_ExternalDomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value));
      var text = content$1.stream$1.toString__T();
      var field = $m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1;
      var result = $as_Lamf_core_model_domain_ExternalDomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$5, field, text));
      var this$6 = content$1.mime$1;
      if ((!this$6.isEmpty__Z())) {
        var arg1 = this$6.get__O();
        var mime = $as_T(arg1);
        var field$1 = $m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().MediaType$1;
        $as_Lamf_core_model_domain_ExternalDomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(result, field$1, mime))
      };
      $m_Lamf_core_parser_Annotations$();
      var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
      var this$10 = new $c_Lamf_core_model_document_ExternalFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
      var location = content$1.url$1;
      var field$2 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
      var this$11 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$10, field$2, location));
      var value$1 = content$1.url$1;
      var this$12 = $as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$11, value$1));
      var field$3 = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
      var this$13 = $as_Lamf_core_model_document_BaseUnit($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$12, field$3, result)));
      var location$1 = content$1.url$1;
      var field$4 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
      var this$14 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$13, field$4, location$1));
      var parserRun = $this.compilerContext$1.parserRun$1;
      return $f_Lamf_core_model_document_BaseUnit__withRunNumber__I__Lamf_core_model_document_BaseUnit(this$14, parserRun)
    })
  })(this, content)), executionContext)
});
$c_Lamf_core_AMFCompiler.prototype.verifyMatchingVendor__p1__s_Option__sc_Seq__sc_Seq__V = (function(refVendor, rootVendors, nodes) {
  matchEnd4: {
    if ((refVendor instanceof $c_s_Some)) {
      var x2 = $as_s_Some(refVendor);
      var v = $as_Lamf_core_remote_Vendor(x2.value$2);
      if ((!rootVendors.contains__O__Z(v))) {
        nodes.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(x$16$2) {
            var x$16 = $as_Lorg_yaml_model_YNode(x$16$2);
            var this$1 = $this.compilerContext$1;
            var id = $m_Lamf_plugins_features_validation_CoreValidations$().InvalidCrossSpec$1;
            this$1.violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lorg_yaml_model_YPart__V(id, "", "Cannot reference fragments of another spec", x$16)
          })
        })(this)));
        break matchEnd4
      }
    }
  }
});
$c_Lamf_core_AMFCompiler.prototype.parseDomain__p1__s_util_Either__s_concurrent_ExecutionContext__s_concurrent_Future = (function(parsed, executionContext) {
  if ((parsed instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(parsed);
    var content = $as_Lamf_client_remote_Content(x2.value$2);
    var x1$2 = this.mediaType$1;
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var mime = $as_T(x2$2.value$2);
      var this$1 = this.compilerContext$1.fileContext$1.history$1;
      if (($f_sc_LinearSeqOptimized__length__I(this$1) === 1)) {
        throw new $c_Lamf_core_exception_UnsupportedMediaTypeException().init___T(mime)
      }
    };
    return this.parseExternalFragment__Lamf_client_remote_Content__s_concurrent_ExecutionContext__s_concurrent_Future(content, executionContext)
  } else if ((parsed instanceof $c_s_util_Right)) {
    var x3 = $as_s_util_Right(parsed);
    var document = $as_Lamf_core_Root(x3.value$2);
    return this.parseDomain__p1__Lamf_core_Root__s_concurrent_ExecutionContext__s_concurrent_Future(document, executionContext)
  } else {
    throw new $c_s_MatchError().init___O(parsed)
  }
});
$c_Lamf_core_AMFCompiler.prototype.autodetectSyntax__jl_CharSequence__s_Option = (function(stream) {
  if (((($charSequenceLength(stream) > 2) && ($charSequenceCharAt(stream, 0) === 35)) && ($charSequenceCharAt(stream, 1) === 37))) {
    $m_Lamf_core_benchmark_ExecutionLog$().log__T__Lamf_core_benchmark_ExecutionLog$("AMFCompiler#autodetectSyntax: auto detected application/yaml media type");
    return new $c_s_Some().init___O("application/yaml")
  } else {
    this.compilerContext$1.platform__Lamf_core_remote_Platform();
    var x = $objectToString(stream);
    var this$3 = new $c_sci_StringOps().init___T(x);
    var $$this = this$3.repr$1;
    var len = $uI($$this.length);
    var i = 0;
    while (true) {
      if ((i < len)) {
        var arg1 = this$3.apply__I__O(i);
        if ((arg1 === null)) {
          var c = 0
        } else {
          var this$7 = $as_jl_Character(arg1);
          var c = this$7.value$1
        };
        var jsx$1 = (!((((c !== 10) && (c !== 9)) && (c !== 13)) && (c !== 32)))
      } else {
        var jsx$1 = false
      };
      if (jsx$1) {
        i = ((1 + i) | 0)
      } else {
        break
      }
    };
    var i$1 = i;
    var $$this$1 = this$3.repr$1;
    if ((i$1 < $uI($$this$1.length))) {
      var x1 = new $c_s_Some().init___O(this$3.apply__I__O(i$1))
    } else {
      var x1 = $m_s_None$()
    };
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var c$1 = x2.value$2;
      if ((c$1 === null)) {
        var c$3 = 0
      } else {
        var this$11 = $as_jl_Character(c$1);
        var c$3 = this$11.value$1
      };
      if (((c$3 === 123) || (c$3 === 91))) {
        $m_Lamf_core_benchmark_ExecutionLog$().log__T__Lamf_core_benchmark_ExecutionLog$("AMFCompiler#autodetectSyntax: auto detected application/json media type");
        return new $c_s_Some().init___O("application/json")
      }
    };
    return $m_s_None$()
  }
});
$c_Lamf_core_AMFCompiler.prototype.resolve__p1__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  var this$1 = this.compilerContext$1;
  var this$2 = this$1.platform__Lamf_core_remote_Platform();
  var url = this$1.location$1;
  var env = this$1.environment$1;
  return $f_Lamf_core_remote_Platform__resolve__T__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future(this$2, url, env, executionContext)
});
$c_Lamf_core_AMFCompiler.prototype.init___Lamf_core_CompilerContext__s_Option__s_Option__Lamf_core_parser_ReferenceKind__Lamf_core_client_ParsingOptions = (function(compilerContext, mediaType, vendor, referenceKind, parsingOptions) {
  this.compilerContext$1 = compilerContext;
  this.mediaType$1 = mediaType;
  this.vendor$1 = vendor;
  this.referenceKind$1 = referenceKind;
  this.parsingOptions$1 = parsingOptions;
  return this
});
$c_Lamf_core_AMFCompiler.prototype.parseSyntax__p1__Lamf_client_remote_Content__s_util_Either = (function(input) {
  this.compilerContext$1.logForFile__T__V("AMFCompiler#parseSyntax: parsing syntax");
  var content = $as_Lamf_client_remote_Content($m_Lamf_core_registries_AMFPluginsRegistry$().featurePlugins__sc_Seq().foldLeft__O__F2__O(input, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(x0$1$2, x1$1$2) {
      var x0$1 = $as_Lamf_client_remote_Content(x0$1$2);
      $as_Lamf_client_plugins_AMFFeaturePlugin(x1$1$2);
      return x0$1
    })
  })(this))));
  var this$1 = this.mediaType$1;
  if (this$1.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var mime = $as_T(arg1);
    var this$2 = $m_Lamf_core_registries_AMFPluginsRegistry$().syntaxPluginForMediaType__T__s_Option(mime);
    if (this$2.isEmpty__Z()) {
      var this$3 = $m_s_None$()
    } else {
      var arg1$1 = this$2.get__O();
      var x$1 = $as_Lamf_client_plugins_AMFSyntaxPlugin(arg1$1);
      var this$3 = x$1.parse__T__jl_CharSequence__Lamf_core_parser_ParserContext__Lamf_core_client_ParsingOptions__s_Option(mime, content.stream$1, this.compilerContext$1.parserContext$1, this.parsingOptions$1)
    };
    if (this$3.isEmpty__Z()) {
      var this$4 = $m_s_None$()
    } else {
      var arg1$2 = this$3.get__O();
      var x$2 = $as_Lamf_core_parser_ParsedDocument(arg1$2);
      var this$4 = new $c_s_Some().init___O(new $c_T2().init___O__O(mime, x$2))
    }
  };
  if (this$4.isEmpty__Z()) {
    var x1 = this.mediaType$1;
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$5 = content.mime$1;
      if (this$5.isEmpty__Z()) {
        var this$8 = $m_s_None$()
      } else {
        var arg1$3 = this$5.get__O();
        var mime$1 = $as_T(arg1$3);
        var this$6 = $m_Lamf_core_registries_AMFPluginsRegistry$().syntaxPluginForMediaType__T__s_Option(mime$1);
        if (this$6.isEmpty__Z()) {
          var this$7 = $m_s_None$()
        } else {
          var arg1$4 = this$6.get__O();
          var x$3 = $as_Lamf_client_plugins_AMFSyntaxPlugin(arg1$4);
          var this$7 = x$3.parse__T__jl_CharSequence__Lamf_core_parser_ParserContext__Lamf_core_client_ParsingOptions__s_Option(mime$1, content.stream$1, this.compilerContext$1.parserContext$1, this.parsingOptions$1)
        };
        if (this$7.isEmpty__Z()) {
          var this$8 = $m_s_None$()
        } else {
          var arg1$5 = this$7.get__O();
          var x$4 = $as_Lamf_core_parser_ParsedDocument(arg1$5);
          var this$8 = new $c_s_Some().init___O(new $c_T2().init___O__O(mime$1, x$4))
        }
      };
      if (this$8.isEmpty__Z()) {
        var this$9 = $m_Lamf_core_remote_FileMediaType$();
        var path = content.url$1;
        var this$10 = $f_Lamf_core_remote_FileMediaType__extension__T__s_Option(this$9, path);
        if (this$10.isEmpty__Z()) {
          var this$12 = $m_s_None$()
        } else {
          var arg1$6 = this$10.get__O();
          var extension = $as_T(arg1$6);
          var this$11 = $m_Lamf_core_remote_FileMediaType$();
          var this$12 = $f_Lamf_core_remote_FileMediaType__mimeFromExtension__T__s_Option(this$11, extension)
        };
        if (this$12.isEmpty__Z()) {
          var this$15 = $m_s_None$()
        } else {
          var arg1$7 = this$12.get__O();
          var infered = $as_T(arg1$7);
          var this$13 = $m_Lamf_core_registries_AMFPluginsRegistry$().syntaxPluginForMediaType__T__s_Option(infered);
          if (this$13.isEmpty__Z()) {
            var this$14 = $m_s_None$()
          } else {
            var arg1$8 = this$13.get__O();
            var x$5 = $as_Lamf_client_plugins_AMFSyntaxPlugin(arg1$8);
            var this$14 = x$5.parse__T__jl_CharSequence__Lamf_core_parser_ParserContext__Lamf_core_client_ParsingOptions__s_Option(infered, content.stream$1, this.compilerContext$1.parserContext$1, this.parsingOptions$1)
          };
          if (this$14.isEmpty__Z()) {
            var this$15 = $m_s_None$()
          } else {
            var arg1$9 = this$14.get__O();
            var x$6 = $as_Lamf_core_parser_ParsedDocument(arg1$9);
            var this$15 = new $c_s_Some().init___O(new $c_T2().init___O__O(infered, x$6))
          }
        }
      } else {
        var this$15 = this$8
      };
      if (this$15.isEmpty__Z()) {
        var this$16 = this.autodetectSyntax__jl_CharSequence__s_Option(content.stream$1);
        if (this$16.isEmpty__Z()) {
          var parsed = $m_s_None$()
        } else {
          var arg1$10 = this$16.get__O();
          var infered$1 = $as_T(arg1$10);
          var this$17 = $m_Lamf_core_registries_AMFPluginsRegistry$().syntaxPluginForMediaType__T__s_Option(infered$1);
          if (this$17.isEmpty__Z()) {
            var this$18 = $m_s_None$()
          } else {
            var arg1$11 = this$17.get__O();
            var x$7 = $as_Lamf_client_plugins_AMFSyntaxPlugin(arg1$11);
            var this$18 = x$7.parse__T__jl_CharSequence__Lamf_core_parser_ParserContext__Lamf_core_client_ParsingOptions__s_Option(infered$1, content.stream$1, this.compilerContext$1.parserContext$1, this.parsingOptions$1)
          };
          if (this$18.isEmpty__Z()) {
            var parsed = $m_s_None$()
          } else {
            var arg1$12 = this$18.get__O();
            var x$8 = $as_Lamf_core_parser_ParsedDocument(arg1$12);
            var parsed = new $c_s_Some().init___O(new $c_T2().init___O__O(infered$1, x$8))
          }
        }
      } else {
        var parsed = this$15
      }
    } else {
      var parsed = $m_s_None$()
    }
  } else {
    var parsed = this$4
  };
  if ((parsed instanceof $c_s_Some)) {
    var x2 = $as_s_Some(parsed);
    var p3 = $as_T2(x2.value$2);
    if ((p3 !== null)) {
      var effective = $as_T(p3.$$und1__O());
      var document = $as_Lamf_core_parser_ParsedDocument(p3.$$und2__O());
      var doc = $as_Lamf_core_parser_ParsedDocument($m_Lamf_core_registries_AMFPluginsRegistry$().featurePlugins__sc_Seq().foldLeft__O__F2__O(document, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$4$1) {
        return (function(x0$2$2, x1$2$2) {
          var x0$2 = $as_Lamf_core_parser_ParsedDocument(x0$2$2);
          $as_Lamf_client_plugins_AMFFeaturePlugin(x1$2$2);
          return x0$2
        })
      })(this))));
      $m_s_package$();
      var value = $m_Lamf_core_Root$().apply__Lamf_core_parser_ParsedDocument__T__T__sc_Seq__Lamf_core_parser_ReferenceKind__T__Lamf_core_Root(doc, content.url$1, effective, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), this.referenceKind$1, content.stream$1.toString__T());
      return new $c_s_util_Right().init___O(value)
    }
  };
  var x$9 = $m_s_None$();
  if ((x$9 === parsed)) {
    $m_s_package$();
    return new $c_s_util_Left().init___O(content)
  };
  throw new $c_s_MatchError().init___O(parsed)
});
$c_Lamf_core_AMFCompiler.prototype.verifyValidFragment__s_Option__sc_Seq__V = (function(refVendor, refs) {
  matchEnd4: {
    if ((refVendor instanceof $c_s_Some)) {
      var x2 = $as_s_Some(refVendor);
      var v = $as_Lamf_core_remote_Vendor(x2.value$2);
      if ($f_Lamf_core_remote_Vendor__isRaml__Z(v)) {
        refs.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(r$2) {
            var r = $as_Lamf_core_parser_RefContainer(r$2);
            if (r.fragment$1.isDefined__Z()) {
              var this$1 = $this.compilerContext$1;
              var id = $m_Lamf_plugins_features_validation_CoreValidations$().InvalidFragmentRef$1;
              var ast = r.node$1;
              this$1.violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lorg_yaml_model_YPart__V(id, "", "Cannot use reference with # in a RAML fragment", ast)
            }
          })
        })(this)));
        break matchEnd4
      }
    }
  }
});
$c_Lamf_core_AMFCompiler.prototype.build__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  this.compilerContext$1.logForFile__T__V("AMFCompiler#build: Building");
  if (this.compilerContext$1.hasCycles__Z()) {
    return $m_s_concurrent_Future$().failed__jl_Throwable__s_concurrent_Future(new $c_Lamf_core_exception_CyclicReferenceException().init___sci_List(this.compilerContext$1.fileContext$1.history$1))
  } else {
    var this$1 = this.compilerContext$1;
    var f = (function($this, executionContext$1) {
      return (function() {
        $this.compilerContext$1.logForFile__T__V("AMFCompiler#build: compiling");
        return $this.compile__p1__s_concurrent_ExecutionContext__s_concurrent_Future(executionContext$1)
      })
    })(this, executionContext);
    var this$2 = this$1.cache$1;
    var url = this$1.location$1;
    var context = this$1.fileContext$1;
    var executionContext$2 = this$1.executionContext$1;
    var this$3 = this$2.beforeLast__sci_List__s_Option(context.history$1);
    if ((!this$3.isEmpty__Z())) {
      var arg1 = this$3.get__O();
      var from = $as_T(arg1);
      this$2.addFromToEdge__T__T__V(from, url)
    };
    var x1 = this$2.findCycles__T__sci_List__s_Option(url, $m_sci_Nil$());
    if ((x1 instanceof $c_s_Some)) {
      return ($as_s_concurrent_Future(this$2.cache$1.apply__O__O(url)).isCompleted__Z() ? $as_s_concurrent_Future(this$2.cache$1.apply__O__O(url)) : (this$2.cache$1.remove__O__s_Option(url), $as_s_concurrent_Future(f()).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, url$1, executionContext$3) {
        return (function(res$2) {
          var res = $as_Lamf_core_model_document_BaseUnit(res$2);
          var value = $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this$1, res$1) {
            return (function() {
              return res$1
            })
          })(this$2$1, res)), executionContext$3);
          this$2$1.cache$1.update__O__O__V(url$1, value);
          return res
        })
      })(this$2, url, executionContext$2)), executionContext$2)))
    } else {
      var x1$2 = this$2.cache$1.get__O__s_Option(url);
      if ((x1$2 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1$2);
        var value$1 = $as_s_concurrent_Future(x2.value$2);
        return value$1
      } else {
        var x = $m_s_None$();
        if ((x === x1$2)) {
          var futureUnit = $as_s_concurrent_Future(f());
          this$2.cache$1.update__O__O__V(url, futureUnit);
          return futureUnit
        } else {
          throw new $c_s_MatchError().init___O(x1$2)
        }
      }
    }
  }
});
var $d_Lamf_core_AMFCompiler = new $TypeData().initClass({
  Lamf_core_AMFCompiler: 0
}, false, "amf.core.AMFCompiler", {
  Lamf_core_AMFCompiler: 1,
  O: 1
});
$c_Lamf_core_AMFCompiler.prototype.$classData = $d_Lamf_core_AMFCompiler;
/** @constructor */
function $c_Lamf_core_AMFCompiler$() {
  $c_O.call(this)
}
$c_Lamf_core_AMFCompiler$.prototype = new $h_O();
$c_Lamf_core_AMFCompiler$.prototype.constructor = $c_Lamf_core_AMFCompiler$;
/** @constructor */
function $h_Lamf_core_AMFCompiler$() {
  /*<skip>*/
}
$h_Lamf_core_AMFCompiler$.prototype = $c_Lamf_core_AMFCompiler$.prototype;
$c_Lamf_core_AMFCompiler$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_AMFCompiler$.prototype.init__s_concurrent_ExecutionContext__V = (function(executionContext) {
  $m_Lamf_core_services_RuntimeCompiler$().register__Lamf_core_services_RuntimeCompiler__V(new $c_Lamf_core_AMFCompiler$$$Lambda$1().init___O((function($this, executionContext$1) {
    return (function(compilerContext$2, mediaType$2, vendor$2, referenceKind$2, parsingOptions$2) {
      var compilerContext = $as_Lamf_core_CompilerContext(compilerContext$2);
      var mediaType = $as_s_Option(mediaType$2);
      var vendor = $as_s_Option(vendor$2);
      var referenceKind = $as_Lamf_core_parser_ReferenceKind(referenceKind$2);
      var parsingOptions = $as_Lamf_core_client_ParsingOptions(parsingOptions$2);
      return new $c_Lamf_core_AMFCompiler().init___Lamf_core_CompilerContext__s_Option__s_Option__Lamf_core_parser_ReferenceKind__Lamf_core_client_ParsingOptions(compilerContext, mediaType, vendor, referenceKind, parsingOptions).build__s_concurrent_ExecutionContext__s_concurrent_Future(executionContext$1)
    })
  })(this, executionContext)))
});
var $d_Lamf_core_AMFCompiler$ = new $TypeData().initClass({
  Lamf_core_AMFCompiler$: 0
}, false, "amf.core.AMFCompiler$", {
  Lamf_core_AMFCompiler$: 1,
  O: 1
});
$c_Lamf_core_AMFCompiler$.prototype.$classData = $d_Lamf_core_AMFCompiler$;
var $n_Lamf_core_AMFCompiler$ = (void 0);
function $m_Lamf_core_AMFCompiler$() {
  if ((!$n_Lamf_core_AMFCompiler$)) {
    $n_Lamf_core_AMFCompiler$ = new $c_Lamf_core_AMFCompiler$().init___()
  };
  return $n_Lamf_core_AMFCompiler$
}
/** @constructor */
function $c_Lamf_core_AMFCompilerRunCount$() {
  $c_O.call(this);
  this.NONE$1 = 0;
  this.count$1 = 0
}
$c_Lamf_core_AMFCompilerRunCount$.prototype = new $h_O();
$c_Lamf_core_AMFCompilerRunCount$.prototype.constructor = $c_Lamf_core_AMFCompilerRunCount$;
/** @constructor */
function $h_Lamf_core_AMFCompilerRunCount$() {
  /*<skip>*/
}
$h_Lamf_core_AMFCompilerRunCount$.prototype = $c_Lamf_core_AMFCompilerRunCount$.prototype;
$c_Lamf_core_AMFCompilerRunCount$.prototype.init___ = (function() {
  this.NONE$1 = (-1);
  this.count$1 = 0;
  return this
});
$c_Lamf_core_AMFCompilerRunCount$.prototype.nextRun__I = (function() {
  this.count$1 = ((1 + this.count$1) | 0);
  return this.count$1
});
var $d_Lamf_core_AMFCompilerRunCount$ = new $TypeData().initClass({
  Lamf_core_AMFCompilerRunCount$: 0
}, false, "amf.core.AMFCompilerRunCount$", {
  Lamf_core_AMFCompilerRunCount$: 1,
  O: 1
});
$c_Lamf_core_AMFCompilerRunCount$.prototype.$classData = $d_Lamf_core_AMFCompilerRunCount$;
var $n_Lamf_core_AMFCompilerRunCount$ = (void 0);
function $m_Lamf_core_AMFCompilerRunCount$() {
  if ((!$n_Lamf_core_AMFCompilerRunCount$)) {
    $n_Lamf_core_AMFCompilerRunCount$ = new $c_Lamf_core_AMFCompilerRunCount$().init___()
  };
  return $n_Lamf_core_AMFCompilerRunCount$
}
/** @constructor */
function $c_Lamf_core_AMFSerializer() {
  $c_O.call(this);
  this.unit$1 = null;
  this.mediaType$1 = null;
  this.vendor$1 = null;
  this.options$1 = null;
  this.shapeOptions$1 = null
}
$c_Lamf_core_AMFSerializer.prototype = new $h_O();
$c_Lamf_core_AMFSerializer.prototype.constructor = $c_Lamf_core_AMFSerializer;
/** @constructor */
function $h_Lamf_core_AMFSerializer() {
  /*<skip>*/
}
$h_Lamf_core_AMFSerializer.prototype = $c_Lamf_core_AMFSerializer.prototype;
$c_Lamf_core_AMFSerializer.prototype.amf$core$AMFSerializer$$render__T = (function() {
  var w = new $c_Ljava_io_StringWriter().init___();
  this.render__p1__O__Lorg_mulesoft_common_io_Output__V(w, $m_Lorg_mulesoft_common_io_Output$OutputWriter$());
  return w.toString__T()
});
$c_Lamf_core_AMFSerializer.prototype.renderToString__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executor) {
  return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
    return (function() {
      return $this.amf$core$AMFSerializer$$render__T()
    })
  })(this)), executor)
});
$c_Lamf_core_AMFSerializer.prototype.parseRdf__p1__O__Lorg_mulesoft_common_io_Output__V = (function(writer, evidence$3) {
  var x1 = $m_Lamf_plugins_document_graph_AMFGraphPlugin$().platform$2.rdfFramework__s_Option();
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var r = $as_Lamf_core_rdf_RdfFramework(x2.value$2);
    var unit = this.unit$1;
    var options = this.options$1;
    var d = new $c_Lamf_core_rdf_RdfModelDocument().init___Lamf_core_rdf_RdfModel($f_Lamf_core_rdf_RdfFramework__unitToRdfModel__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__Lamf_core_rdf_RdfModel(r, unit, options));
    $m_Lamf_plugins_syntax_RdfSyntaxPlugin$().unparse__T__Lamf_core_parser_ParsedDocument__O__Lorg_mulesoft_common_io_Output__s_Option(this.mediaType$1, d, writer, evidence$3)
  }
});
$c_Lamf_core_AMFSerializer.prototype.init___Lamf_core_model_document_BaseUnit__T__T__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions = (function(unit, mediaType, vendor, options, shapeOptions) {
  this.unit$1 = unit;
  this.mediaType$1 = mediaType;
  this.vendor$1 = vendor;
  this.options$1 = options;
  this.shapeOptions$1 = shapeOptions;
  return this
});
$c_Lamf_core_AMFSerializer.prototype.renderToWriter__O__Lorg_mulesoft_common_io_Output__s_concurrent_ExecutionContext__s_concurrent_Future = (function(writer, evidence$1, executor) {
  return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, writer$1, evidence$1$1) {
    return (function() {
      $this.render__p1__O__Lorg_mulesoft_common_io_Output__V(writer$1, evidence$1$1)
    })
  })(this, writer, evidence$1)), executor)
});
$c_Lamf_core_AMFSerializer.prototype.renderToFile__Lamf_core_remote_Platform__T__s_concurrent_ExecutionContext__s_concurrent_Future = (function(remote, path, executor) {
  return this.renderToString__s_concurrent_ExecutionContext__s_concurrent_Future(executor).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, remote$1, path$1, executor$1) {
    return (function(x$1$2) {
      var x$1 = $as_T(x$1$2);
      $f_Lamf_core_remote_Platform__write__T__T__s_concurrent_ExecutionContext__s_concurrent_Future(remote$1, path$1, x$1, executor$1)
    })
  })(this, remote, path, executor)), executor)
});
$c_Lamf_core_AMFSerializer.prototype.render__p1__O__Lorg_mulesoft_common_io_Output__V = (function(writer, evidence$2) {
  var jsx$3 = $m_Lamf_core_benchmark_ExecutionLog$();
  var jsx$2 = this.mediaType$1;
  var jsx$1 = this.vendor$1;
  var this$1 = this.unit$1;
  jsx$3.log__T__Lamf_core_benchmark_ExecutionLog$(((((("AMFSerializer#render: Rendering to " + jsx$2) + " (") + jsx$1) + " file) ") + $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$1)));
  if ((this.vendor$1 === $m_Lamf_core_remote_Vendor$().AMF$1.name__T())) {
    var this$2 = this.options$1;
    if ((!this$2.amf$core$emitter$RenderOptions$$amfJsonLdSerialization$1)) {
      this.parseRdf__p1__O__Lorg_mulesoft_common_io_Output__V(writer, evidence$2)
    } else {
      var this$3 = this.options$1;
      var prettyPrint = this$3.amf$core$emitter$RenderOptions$$prettyPrint$1;
      var b = new $c_Lorg_yaml_builder_JsonOutputBuilder().init___O__Z__Lorg_mulesoft_common_io_Output(writer, prettyPrint, evidence$2);
      var this$5 = this.options$1;
      if (this$5.amf$core$emitter$RenderOptions$$flattenedJsonLd$1) {
        $m_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$().emit__Lamf_core_model_document_BaseUnit__Lorg_yaml_builder_DocBuilder__Lamf_core_emitter_RenderOptions__Z(this.unit$1, b, this.options$1)
      } else {
        $m_Lamf_plugins_document_graph_emitter_JsonLdEmitter$().emit__Lamf_core_model_document_BaseUnit__Lorg_yaml_builder_DocBuilder__Lamf_core_emitter_RenderOptions__Z(this.unit$1, b, this.options$1)
      }
    };
    return (void 0)
  };
  var ast = this.renderAsYDocument__Lamf_core_parser_SyamlParsedDocument();
  var x1 = $m_Lamf_core_registries_AMFPluginsRegistry$().syntaxPluginForMediaType__T__s_Option(this.mediaType$1);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var syntaxPlugin = $as_Lamf_client_plugins_AMFSyntaxPlugin(x2.value$2);
    syntaxPlugin.unparse__T__Lamf_core_parser_ParsedDocument__O__Lorg_mulesoft_common_io_Output__s_Option(this.mediaType$1, ast, writer, evidence$2)
  } else {
    var x = $m_s_None$();
    if (((x === x1) && (this.unit$1 instanceof $c_Lamf_core_model_document_ExternalFragment))) {
      var this$11 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(writer);
      var this$7 = $as_Lamf_core_model_document_ExternalFragment(this.unit$1);
      var this$8 = $as_Lamf_core_model_domain_ExternalDomainElement($as_Lamf_core_model_domain_DomainElement(this$7.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)));
      var this$9 = $as_Lamf_core_model_StrField(this$8.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1));
      var this$10 = this$9.option$1;
      var s = $as_T((this$10.isEmpty__Z() ? null : this$10.get__O()));
      evidence$2.append__O__jl_CharSequence__V(this$11.w$1, s)
    } else {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(((("Unsupported media type " + this.mediaType$1) + " and vendor ") + this.vendor$1)))
    }
  }
});
$c_Lamf_core_AMFSerializer.prototype.renderAsYDocument__Lamf_core_parser_SyamlParsedDocument = (function() {
  var domainPlugin = this.getDomainPlugin__p1__Lamf_client_plugins_AMFDocumentPlugin();
  var builder = new $c_Lorg_yaml_builder_YDocumentBuilder().init___();
  if (domainPlugin.emit__Lamf_core_model_document_BaseUnit__Lorg_yaml_builder_DocBuilder__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__Z(this.unit$1, builder, this.options$1, this.shapeOptions$1)) {
    return new $c_Lamf_core_parser_SyamlParsedDocument().init___Lorg_yaml_model_YDocument__s_Option($as_Lorg_yaml_model_YDocument($as_Lorg_yaml_model_YPart(builder.$$unddocument$2.get__O())), $m_s_None$())
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(((("Error unparsing syntax " + this.mediaType$1) + " with domain plugin ") + domainPlugin.ID__T())))
  }
});
$c_Lamf_core_AMFSerializer.prototype.findDomainPlugin__s_Option = (function() {
  var x1 = $m_Lamf_core_registries_AMFPluginsRegistry$().documentPluginForVendor__T__sc_Seq(this.vendor$1).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(plugin$2) {
      var plugin = $as_Lamf_client_plugins_AMFDocumentPlugin(plugin$2);
      return (plugin.documentSyntaxes__sc_Seq().contains__O__Z($this.mediaType$1) && plugin.canUnparse__Lamf_core_model_document_BaseUnit__Z($this.unit$1))
    })
  })(this)));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var domainPlugin = $as_Lamf_client_plugins_AMFDocumentPlugin(x2.value$2);
    return new $c_s_Some().init___O(domainPlugin)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return $m_Lamf_core_registries_AMFPluginsRegistry$().documentPluginForMediaType__T__sc_Seq(this.mediaType$1).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
        return (function(x$2$2$2) {
          var x$2$2 = $as_Lamf_client_plugins_AMFDocumentPlugin(x$2$2$2);
          return x$2$2.canUnparse__Lamf_core_model_document_BaseUnit__Z(this$2.unit$1)
        })
      })(this)))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_core_AMFSerializer.prototype.getDomainPlugin__p1__Lamf_client_plugins_AMFDocumentPlugin = (function() {
  var this$1 = this.findDomainPlugin__s_Option();
  if (this$1.isEmpty__Z()) {
    var jsx$1 = $m_sjsr_package$();
    var this$2 = this.unit$1;
    throw jsx$1.unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(((((("Cannot serialize domain model '" + $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$2)) + "' for detected media type ") + this.mediaType$1) + " and vendor ") + this.vendor$1)))
  };
  return $as_Lamf_client_plugins_AMFDocumentPlugin(this$1.get__O())
});
$c_Lamf_core_AMFSerializer.prototype.renderToBuilder__Lorg_yaml_builder_DocBuilder__s_concurrent_ExecutionContext__s_concurrent_Future = (function(builder, executor) {
  return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, builder$1) {
    return (function() {
      if (($this.vendor$1 === $m_Lamf_core_remote_Vendor$().AMF$1.name__T())) {
        var this$1 = $this.options$1;
        if (this$1.amf$core$emitter$RenderOptions$$flattenedJsonLd$1) {
          $m_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$().emit__Lamf_core_model_document_BaseUnit__Lorg_yaml_builder_DocBuilder__Lamf_core_emitter_RenderOptions__Z($this.unit$1, builder$1, $this.options$1)
        } else {
          $m_Lamf_plugins_document_graph_emitter_JsonLdEmitter$().emit__Lamf_core_model_document_BaseUnit__Lorg_yaml_builder_DocBuilder__Lamf_core_emitter_RenderOptions__Z($this.unit$1, builder$1, $this.options$1)
        }
      }
    })
  })(this, builder)), executor)
});
var $d_Lamf_core_AMFSerializer = new $TypeData().initClass({
  Lamf_core_AMFSerializer: 0
}, false, "amf.core.AMFSerializer", {
  Lamf_core_AMFSerializer: 1,
  O: 1
});
$c_Lamf_core_AMFSerializer.prototype.$classData = $d_Lamf_core_AMFSerializer;
/** @constructor */
function $c_Lamf_core_AMFSerializer$() {
  $c_O.call(this)
}
$c_Lamf_core_AMFSerializer$.prototype = new $h_O();
$c_Lamf_core_AMFSerializer$.prototype.constructor = $c_Lamf_core_AMFSerializer$;
/** @constructor */
function $h_Lamf_core_AMFSerializer$() {
  /*<skip>*/
}
$h_Lamf_core_AMFSerializer$.prototype = $c_Lamf_core_AMFSerializer$.prototype;
$c_Lamf_core_AMFSerializer$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_AMFSerializer$.prototype.init__s_concurrent_ExecutionContext__V = (function(executionContext) {
  $m_Lamf_core_services_RuntimeSerializer$().register__Lamf_core_services_RuntimeSerializer__V(new $c_Lamf_core_AMFSerializer$$anon$1().init___s_concurrent_ExecutionContext(executionContext))
});
var $d_Lamf_core_AMFSerializer$ = new $TypeData().initClass({
  Lamf_core_AMFSerializer$: 0
}, false, "amf.core.AMFSerializer$", {
  Lamf_core_AMFSerializer$: 1,
  O: 1
});
$c_Lamf_core_AMFSerializer$.prototype.$classData = $d_Lamf_core_AMFSerializer$;
var $n_Lamf_core_AMFSerializer$ = (void 0);
function $m_Lamf_core_AMFSerializer$() {
  if ((!$n_Lamf_core_AMFSerializer$)) {
    $n_Lamf_core_AMFSerializer$ = new $c_Lamf_core_AMFSerializer$().init___()
  };
  return $n_Lamf_core_AMFSerializer$
}
/** @constructor */
function $c_Lamf_core_CompilerContext() {
  $c_O.call(this);
  this.hasCycles$1 = false;
  this.platform$1 = null;
  this.url$1 = null;
  this.path$1 = null;
  this.parserContext$1 = null;
  this.fileContext$1 = null;
  this.cache$1 = null;
  this.environment$1 = null;
  this.executionContext$1 = null;
  this.location$1 = null;
  this.parserRun$1 = 0;
  this.bitmap$0$1 = 0
}
$c_Lamf_core_CompilerContext.prototype = new $h_O();
$c_Lamf_core_CompilerContext.prototype.constructor = $c_Lamf_core_CompilerContext;
/** @constructor */
function $h_Lamf_core_CompilerContext() {
  /*<skip>*/
}
$h_Lamf_core_CompilerContext.prototype = $c_Lamf_core_CompilerContext.prototype;
$c_Lamf_core_CompilerContext.prototype.logForFile__T__V = (function(message) {
  $m_Lamf_core_benchmark_ExecutionLog$().log__T__Lamf_core_benchmark_ExecutionLog$(((message + " in ") + this.url$1))
});
$c_Lamf_core_CompilerContext.prototype.init___T__T__Lamf_core_parser_ParserContext__Lamf_core_remote_Context__Lamf_core_remote_Cache__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext = (function(url, path, parserContext, fileContext, cache, environment, executionContext) {
  this.url$1 = url;
  this.path$1 = path;
  this.parserContext$1 = parserContext;
  this.fileContext$1 = fileContext;
  this.cache$1 = cache;
  this.environment$1 = environment;
  this.executionContext$1 = executionContext;
  this.location$1 = fileContext.current__T();
  this.parserRun$1 = parserContext.parserRun$1;
  return this
});
$c_Lamf_core_CompilerContext.prototype.platform__Lamf_core_remote_Platform = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.platform$lzycompute__p1__Lamf_core_remote_Platform() : this.platform$1)
});
$c_Lamf_core_CompilerContext.prototype.forReference__T__Z__s_concurrent_ExecutionContext__Lamf_core_CompilerContext = (function(url, withNormalizedUri, executionContext) {
  return new $c_Lamf_core_CompilerContextBuilder().init___T__Lamf_core_remote_Platform__Lamf_core_parser_errorhandler_ParserErrorHandler(url, this.fileContext$1.platform$1, this.parserContext$1.eh$1).withCache__Lamf_core_remote_Cache__Lamf_core_CompilerContextBuilder(this.cache$1).withEnvironment__Lamf_internal_environment_Environment__Lamf_core_CompilerContextBuilder(this.environment$1).withBaseParserContext__Lamf_core_parser_ParserContext__Lamf_core_CompilerContextBuilder(this.parserContext$1).withFileContext__Lamf_core_remote_Context__Lamf_core_CompilerContextBuilder(this.fileContext$1).withNormalizedUri__Z__Lamf_core_CompilerContextBuilder(withNormalizedUri).build__s_concurrent_ExecutionContext__Lamf_core_CompilerContext(executionContext)
});
$c_Lamf_core_CompilerContext.prototype.hasCycles__Z = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.hasCycles$lzycompute__p1__Z() : this.hasCycles$1)
});
$c_Lamf_core_CompilerContext.prototype.violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lorg_yaml_model_YPart__V = (function(id, node, message, ast) {
  var this$1 = this.parserContext$1.eh$1;
  var prop = $m_s_None$();
  var l = ast.location$1;
  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, id, node, prop, message, l)
});
$c_Lamf_core_CompilerContext.prototype.hasCycles$lzycompute__p1__Z = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.hasCycles$1 = this.fileContext$1.hasCycles__Z();
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.hasCycles$1
});
$c_Lamf_core_CompilerContext.prototype.platform$lzycompute__p1__Lamf_core_remote_Platform = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.platform$1 = this.fileContext$1.platform$1;
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.platform$1
});
$c_Lamf_core_CompilerContext.prototype.resolvePath__T__T = (function(url) {
  var jsx$1 = this.fileContext$1;
  var this$1 = this.fileContext$1.platform$1;
  return jsx$1.resolve__T__T($f_Lamf_core_remote_JsPlatform__normalizePath__T__T(this$1, url))
});
function $as_Lamf_core_CompilerContext(obj) {
  return (((obj instanceof $c_Lamf_core_CompilerContext) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.CompilerContext"))
}
function $isArrayOf_Lamf_core_CompilerContext(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_CompilerContext)))
}
function $asArrayOf_Lamf_core_CompilerContext(obj, depth) {
  return (($isArrayOf_Lamf_core_CompilerContext(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.CompilerContext;", depth))
}
var $d_Lamf_core_CompilerContext = new $TypeData().initClass({
  Lamf_core_CompilerContext: 0
}, false, "amf.core.CompilerContext", {
  Lamf_core_CompilerContext: 1,
  O: 1
});
$c_Lamf_core_CompilerContext.prototype.$classData = $d_Lamf_core_CompilerContext;
/** @constructor */
function $c_Lamf_core_CompilerContextBuilder() {
  $c_O.call(this);
  this.url$1 = null;
  this.eh$1 = null;
  this.fileContext$1 = null;
  this.givenContent$1 = null;
  this.cache$1 = null;
  this.environment$1 = null;
  this.normalizeUri$1 = false;
  this.path$1 = null
}
$c_Lamf_core_CompilerContextBuilder.prototype = new $h_O();
$c_Lamf_core_CompilerContextBuilder.prototype.constructor = $c_Lamf_core_CompilerContextBuilder;
/** @constructor */
function $h_Lamf_core_CompilerContextBuilder() {
  /*<skip>*/
}
$h_Lamf_core_CompilerContextBuilder.prototype = $c_Lamf_core_CompilerContextBuilder.prototype;
$c_Lamf_core_CompilerContextBuilder.prototype.withEnvironment__Lamf_internal_environment_Environment__Lamf_core_CompilerContextBuilder = (function(environment) {
  this.environment$1 = environment;
  return this
});
$c_Lamf_core_CompilerContextBuilder.prototype.withBaseParserContext__Lamf_core_parser_ParserContext__Lamf_core_CompilerContextBuilder = (function(parserContext) {
  this.givenContent$1 = new $c_s_Some().init___O(parserContext);
  return this
});
$c_Lamf_core_CompilerContextBuilder.prototype.init___T__Lamf_core_remote_Platform__Lamf_core_parser_errorhandler_ParserErrorHandler = (function(url, platform, eh) {
  this.url$1 = url;
  this.eh$1 = eh;
  this.fileContext$1 = $m_Lamf_core_remote_Context$().apply__Lamf_core_remote_Platform__Lamf_core_remote_Context(platform);
  this.givenContent$1 = $m_s_None$();
  this.cache$1 = new $c_Lamf_core_remote_Cache().init___();
  this.environment$1 = $m_Lamf_internal_environment_Environment$().apply__Lamf_internal_environment_Environment();
  this.normalizeUri$1 = true;
  this.path$1 = this.liftedTree1$1__p1__T();
  return this
});
$c_Lamf_core_CompilerContextBuilder.prototype.build__s_concurrent_ExecutionContext__Lamf_core_CompilerContext = (function(executionContext) {
  var fc = this.buildFileContext__p1__Lamf_core_remote_Context();
  return new $c_Lamf_core_CompilerContext().init___T__T__Lamf_core_parser_ParserContext__Lamf_core_remote_Context__Lamf_core_remote_Cache__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext(this.url$1, this.path$1, this.buildParserContext__p1__Lamf_core_remote_Context__Lamf_core_parser_ParserContext(fc), fc, this.cache$1, this.environment$1, executionContext)
});
$c_Lamf_core_CompilerContextBuilder.prototype.buildFileContext__p1__Lamf_core_remote_Context = (function() {
  var uriToUpdate = (this.normalizeUri$1 ? this.path$1 : this.url$1);
  return this.fileContext$1.update__T__Lamf_core_remote_Context(uriToUpdate)
});
$c_Lamf_core_CompilerContextBuilder.prototype.withFileContext__Lamf_core_remote_Context__Lamf_core_CompilerContextBuilder = (function(fc) {
  this.fileContext$1 = fc;
  return this
});
$c_Lamf_core_CompilerContextBuilder.prototype.liftedTree1$1__p1__T = (function() {
  try {
    var str = this.url$1;
    var this$2 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
    var this$3 = this$2.platform$1;
    var url = this$2.str$1;
    return $f_Lamf_core_remote_JsPlatform__normalizePath__T__T(this$3, url)
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 instanceof $c_Ljava_net_URISyntaxException)) {
      var e$4 = $as_Ljava_net_URISyntaxException(e$2);
      var this$4 = this.eh$1;
      var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UriSyntaxError$1;
      var node = this.url$1;
      var message = e$4.s$1;
      var property = $m_s_None$();
      var lexical = $m_s_None$();
      var location = $m_s_None$();
      this$4.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
      return this.url$1
    } else if ((e$2 instanceof $c_jl_Exception)) {
      var e$3 = $as_jl_Exception(e$2);
      throw new $c_Lamf_core_remote_PathResolutionError().init___T(e$3.getMessage__T())
    } else {
      throw e
    }
  }
});
$c_Lamf_core_CompilerContextBuilder.prototype.buildParserContext__p1__Lamf_core_remote_Context__Lamf_core_parser_ParserContext = (function(fc) {
  var rc6 = false;
  var x2 = null;
  var x1 = this.givenContent$1;
  if ((x1 instanceof $c_s_Some)) {
    rc6 = true;
    x2 = $as_s_Some(x1);
    var given = $as_Lamf_core_parser_ParserContext(x2.value$2);
    var this$1 = given.rootContextDocument$1;
    var that = fc.current__T();
    if ((this$1 === that)) {
      return given
    }
  };
  if (rc6) {
    var given$2 = $as_Lamf_core_parser_ParserContext(x2.value$2);
    return given$2.forLocation__T__Lamf_core_parser_ParserContext(fc.current__T())
  };
  var x = $m_s_None$();
  if ((x === x1)) {
    var x$1 = fc.current__T();
    var x$2$2 = this.eh$1;
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$5 = new $c_scm_ListBuffer().init___();
    var x$3 = this$5.toList__sci_List();
    var x$4 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$12 = new $c_scm_ListBuffer().init___();
    var x$5 = new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$12.toList__sci_List());
    return new $c_Lamf_core_parser_ParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext(x$1, x$3, x$4, x$2$2, x$5)
  };
  throw new $c_s_MatchError().init___O(x1)
});
$c_Lamf_core_CompilerContextBuilder.prototype.withNormalizedUri__Z__Lamf_core_CompilerContextBuilder = (function(normalizeUri) {
  this.normalizeUri$1 = normalizeUri;
  return this
});
$c_Lamf_core_CompilerContextBuilder.prototype.withCache__Lamf_core_remote_Cache__Lamf_core_CompilerContextBuilder = (function(cache) {
  this.cache$1 = cache;
  return this
});
var $d_Lamf_core_CompilerContextBuilder = new $TypeData().initClass({
  Lamf_core_CompilerContextBuilder: 0
}, false, "amf.core.CompilerContextBuilder", {
  Lamf_core_CompilerContextBuilder: 1,
  O: 1
});
$c_Lamf_core_CompilerContextBuilder.prototype.$classData = $d_Lamf_core_CompilerContextBuilder;
/** @constructor */
function $c_Lamf_core_TaggedReferences$() {
  $c_O.call(this)
}
$c_Lamf_core_TaggedReferences$.prototype = new $h_O();
$c_Lamf_core_TaggedReferences$.prototype.constructor = $c_Lamf_core_TaggedReferences$;
/** @constructor */
function $h_Lamf_core_TaggedReferences$() {
  /*<skip>*/
}
$h_Lamf_core_TaggedReferences$.prototype = $c_Lamf_core_TaggedReferences$.prototype;
$c_Lamf_core_TaggedReferences$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_TaggedReferences$.prototype.taggedReferences__T__Lamf_core_parser_Reference__sci_Map = (function(location, r) {
  var jsx$2 = r.refs$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, location$1) {
    return (function(rfs$2) {
      var rfs = $as_Lamf_core_parser_RefContainer(rfs$2);
      var y = rfs.reduceToLocation__Lamf_core_parser_Range();
      return new $c_T2().init___O__O(location$1, y)
    })
  })(this, location));
  var this$3 = $m_sc_Seq$();
  return $as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2)
});
var $d_Lamf_core_TaggedReferences$ = new $TypeData().initClass({
  Lamf_core_TaggedReferences$: 0
}, false, "amf.core.TaggedReferences$", {
  Lamf_core_TaggedReferences$: 1,
  O: 1
});
$c_Lamf_core_TaggedReferences$.prototype.$classData = $d_Lamf_core_TaggedReferences$;
var $n_Lamf_core_TaggedReferences$ = (void 0);
function $m_Lamf_core_TaggedReferences$() {
  if ((!$n_Lamf_core_TaggedReferences$)) {
    $n_Lamf_core_TaggedReferences$ = new $c_Lamf_core_TaggedReferences$().init___()
  };
  return $n_Lamf_core_TaggedReferences$
}
/** @constructor */
function $c_Lamf_core_TaggedReferences$BuReferenceTagger() {
  $c_O.call(this);
  this.bu$1 = null
}
$c_Lamf_core_TaggedReferences$BuReferenceTagger.prototype = new $h_O();
$c_Lamf_core_TaggedReferences$BuReferenceTagger.prototype.constructor = $c_Lamf_core_TaggedReferences$BuReferenceTagger;
/** @constructor */
function $h_Lamf_core_TaggedReferences$BuReferenceTagger() {
  /*<skip>*/
}
$h_Lamf_core_TaggedReferences$BuReferenceTagger.prototype = $c_Lamf_core_TaggedReferences$BuReferenceTagger.prototype;
$c_Lamf_core_TaggedReferences$BuReferenceTagger.prototype.init___Lamf_core_model_document_BaseUnit = (function(bu) {
  this.bu$1 = bu;
  return this
});
$c_Lamf_core_TaggedReferences$BuReferenceTagger.prototype.tagReferences__Lamf_core_Root__Lamf_core_model_document_BaseUnit = (function(root) {
  var jsx$3 = root.references$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(r$2) {
      var r = $as_Lamf_core_parser_ParsedReference(r$2);
      var jsx$2 = $m_Lamf_core_TaggedReferences$();
      var this$1 = r.unit$1;
      var this$2 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$1);
      return jsx$2.taggedReferences__T__Lamf_core_parser_Reference__sci_Map($as_T((this$2.isEmpty__Z() ? r.unit$1.id__T() : this$2.get__O())), r.origin$1)
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  var t = $as_sc_TraversableOnce(jsx$3.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2);
  var targets = new $c_Lamf_core_annotations_ReferenceTargets().init___sci_Map(t);
  var this$4 = this.bu$1;
  return $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$4, targets))
});
$c_Lamf_core_TaggedReferences$BuReferenceTagger.prototype.tagReference__T__Lamf_core_parser_Reference__Lamf_core_model_document_BaseUnit = (function(location, r) {
  var x1 = this.bu$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_ReferenceTargets.getClassOf());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var rt = $as_Lamf_core_annotations_ReferenceTargets(x2.value$2);
    this.bu$1.annotations__Lamf_core_parser_Annotations().reject__F1__Lamf_core_parser_Annotations(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$1$2) {
        var x$1 = $as_Lamf_core_model_domain_Annotation(x$1$2);
        return (x$1 instanceof $c_Lamf_core_annotations_ReferenceTargets)
      })
    })(this)));
    var rta = rt.$$plus$plus__sci_Map__Lamf_core_annotations_ReferenceTargets($m_Lamf_core_TaggedReferences$().taggedReferences__T__Lamf_core_parser_Reference__sci_Map(location, r))
  } else {
    var rta = new $c_Lamf_core_annotations_ReferenceTargets().init___sci_Map($m_Lamf_core_TaggedReferences$().taggedReferences__T__Lamf_core_parser_Reference__sci_Map(location, r))
  };
  var this$1 = this.bu$1;
  return $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$1, rta))
});
var $d_Lamf_core_TaggedReferences$BuReferenceTagger = new $TypeData().initClass({
  Lamf_core_TaggedReferences$BuReferenceTagger: 0
}, false, "amf.core.TaggedReferences$BuReferenceTagger", {
  Lamf_core_TaggedReferences$BuReferenceTagger: 1,
  O: 1
});
$c_Lamf_core_TaggedReferences$BuReferenceTagger.prototype.$classData = $d_Lamf_core_TaggedReferences$BuReferenceTagger;
/** @constructor */
function $c_Lamf_core_annotations_AliasDeclaration$() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_AliasDeclaration$.prototype = new $h_O();
$c_Lamf_core_annotations_AliasDeclaration$.prototype.constructor = $c_Lamf_core_annotations_AliasDeclaration$;
/** @constructor */
function $h_Lamf_core_annotations_AliasDeclaration$() {
  /*<skip>*/
}
$h_Lamf_core_annotations_AliasDeclaration$.prototype = $c_Lamf_core_annotations_AliasDeclaration$.prototype;
$c_Lamf_core_annotations_AliasDeclaration$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_AliasDeclaration$.prototype.apply__Lamf_core_model_document_BaseUnit__T__T__T__V = (function(base, aliasName, referenceId, relativeUrl) {
  var alias = new $c_T2().init___O__O(aliasName, new $c_T2().init___O__O(referenceId, relativeUrl));
  var x1 = base.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_Aliases.getClassOf());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var aliases = $as_Lamf_core_annotations_Aliases(x2.value$2);
    base.annotations__Lamf_core_parser_Annotations().reject__F1__Lamf_core_parser_Annotations(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$3$2) {
        var x$3 = $as_Lamf_core_model_domain_Annotation(x$3$2);
        return (x$3 instanceof $c_Lamf_core_annotations_Aliases)
      })
    })(this)));
    var aliases$1 = $as_sci_Set(aliases.aliases$1.$$plus__O__sc_Set(alias));
    var annotation = new $c_Lamf_core_annotations_Aliases().init___sci_Set(aliases$1);
    $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(base, annotation)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var array = [alias];
      if (($uI(array.length) === 0)) {
        var jsx$1 = $m_sci_Set$EmptySet$()
      } else {
        var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
        var i = 0;
        var len = $uI(array.length);
        while ((i < len)) {
          var index = i;
          var arg1 = array[index];
          b.$$plus$eq__O__scm_SetBuilder(arg1);
          i = ((1 + i) | 0)
        };
        var jsx$1 = b.elems$1
      };
      var annotation$1 = new $c_Lamf_core_annotations_Aliases().init___sci_Set($as_sci_Set(jsx$1));
      $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(base, annotation$1)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
var $d_Lamf_core_annotations_AliasDeclaration$ = new $TypeData().initClass({
  Lamf_core_annotations_AliasDeclaration$: 0
}, false, "amf.core.annotations.AliasDeclaration$", {
  Lamf_core_annotations_AliasDeclaration$: 1,
  O: 1
});
$c_Lamf_core_annotations_AliasDeclaration$.prototype.$classData = $d_Lamf_core_annotations_AliasDeclaration$;
var $n_Lamf_core_annotations_AliasDeclaration$ = (void 0);
function $m_Lamf_core_annotations_AliasDeclaration$() {
  if ((!$n_Lamf_core_annotations_AliasDeclaration$)) {
    $n_Lamf_core_annotations_AliasDeclaration$ = new $c_Lamf_core_annotations_AliasDeclaration$().init___()
  };
  return $n_Lamf_core_annotations_AliasDeclaration$
}
/** @constructor */
function $c_Lamf_core_benchmark_ExecutionLog$() {
  $c_O.call(this);
  this.executionContext$1 = null;
  this.executions$1 = null;
  this.current$1 = null;
  this.stagesSeq$1 = null;
  this.stagesStartTime$1 = null;
  this.stagesEndTime$1 = null
}
$c_Lamf_core_benchmark_ExecutionLog$.prototype = new $h_O();
$c_Lamf_core_benchmark_ExecutionLog$.prototype.constructor = $c_Lamf_core_benchmark_ExecutionLog$;
/** @constructor */
function $h_Lamf_core_benchmark_ExecutionLog$() {
  /*<skip>*/
}
$h_Lamf_core_benchmark_ExecutionLog$.prototype = $c_Lamf_core_benchmark_ExecutionLog$.prototype;
$c_Lamf_core_benchmark_ExecutionLog$.prototype.init___ = (function() {
  $n_Lamf_core_benchmark_ExecutionLog$ = this;
  this.executionContext$1 = $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext();
  this.executions$1 = $m_sci_Nil$();
  this.current$1 = $m_s_None$();
  this.stagesSeq$1 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  this.stagesStartTime$1 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.stagesEndTime$1 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  return this
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.$$js$exported$meth$startStage__T__O = (function(name) {
  this.startStage__T__V(name)
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.$$js$exported$prop$stagesStartTime__sci_Map__O = (function(x$1) {
  this.stagesStartTime$1 = x$1
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.$$js$exported$prop$stagesSeq__sc_Seq__O = (function(x$1) {
  this.stagesSeq$1 = x$1
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.$$js$exported$meth$log__T__O = (function(stage) {
  return this.log__T__Lamf_core_benchmark_ExecutionLog$(stage)
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.$$js$exported$meth$start__O = (function() {
  return this.start__Lamf_core_benchmark_ExecutionLog$()
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.$$js$exported$prop$stagesSeq__O = (function() {
  return this.stagesSeq$1
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.withStage__T__F0__O = (function(name, fn) {
  this.startStage__T__V(name);
  var x1 = fn.apply__O();
  if ($is_s_concurrent_Future(x1)) {
    var adapted = $as_s_concurrent_Future(x1).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, name$1) {
      return (function(r$2) {
        $m_Lamf_core_benchmark_ExecutionLog$().endStage__T__V(name$1);
        return r$2
      })
    })(this, name)), this.executionContext$1);
    return adapted
  } else {
    this.endStage__T__V(name);
    return x1
  }
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.$$js$exported$meth$withStage__T__F0__O = (function(name, fn) {
  return this.withStage__T__F0__O(name, fn)
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.finish__Lamf_core_benchmark_ExecutionLog$ = (function() {
  var this$1 = this.current$1;
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var execution = $as_Lamf_core_benchmark_Execution(arg1);
    var jsx$4 = $m_Lamf_core_benchmark_ExecutionLog$();
    var jsx$3 = $m_Lamf_core_benchmark_ExecutionLog$().executions$1;
    var jsx$2 = $m_sc_Seq$();
    var array = [execution.finish__Lamf_core_benchmark_Execution()];
    var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$4 = $m_sc_Seq$();
    jsx$4.executions$1 = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2))
  };
  this.current$1 = $m_s_None$();
  return this
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.collectStages__sc_Seq__I__Z__sc_Seq = (function(remaining, level, isOpen) {
  var x1 = remaining.headOption__s_Option();
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var stage_timestamp = $as_T(x2.value$2);
    var parts = $m_sjsr_RuntimeString$().split__T__T__I__AT(stage_timestamp, "::SEP::", 0);
    var elem = parts.get(0);
    var stage = new $c_sr_ObjectRef().init___O(elem);
    var status = parts.get(1);
    if ((status === "start")) {
      var newLevel = (isOpen ? ((2 + level) | 0) : level);
      var nested = $as_sc_Seq($as_sc_IterableLike(remaining.tail__O()).takeWhile__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, stage$1) {
        return (function(x$3$2) {
          var x$3 = $as_T(x$3$2);
          var prefix = ($as_T(stage$1.elem$1) + "::SEP::end");
          return (!(($uI(x$3.length) >= 0) && ($as_T(x$3.substring(0, $uI(prefix.length))) === prefix)))
        })
      })(this, stage))));
      var nestedMessages = this.collectStages__sc_Seq__I__Z__sc_Seq(nested, newLevel, true);
      var remainingTraces = $as_sc_Seq($as_sc_TraversableLike($as_sc_TraversableLike(remaining.tail__O()).dropWhile__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, stage$2) {
        return (function(t$2) {
          var t = $as_T(t$2);
          var prefix$1 = ($as_T(stage$2.elem$1) + "::SEP::end");
          return (!(($uI(t.length) >= 0) && ($as_T(t.substring(0, $uI(prefix$1.length))) === prefix$1)))
        })
      })(this, stage)))).tail__O());
      var remainingMessages = this.collectStages__sc_Seq__I__Z__sc_Seq(remainingTraces, level, true);
      var t$1 = $uJ(this.stagesEndTime$1.apply__O__O($as_T(stage.elem$1)));
      var lo = t$1.lo$2;
      var hi = t$1.hi$2;
      var b = $uJ(this.stagesStartTime$1.apply__O__O($as_T(stage.elem$1)));
      var bhi = b.hi$2;
      var lo$1 = ((lo - b.lo$2) | 0);
      var hi$1 = ((((-2147483648) ^ lo$1) > ((-2147483648) ^ lo)) ? (((-1) + ((hi - bhi) | 0)) | 0) : ((hi - bhi) | 0));
      var this$15 = new $c_sci_StringOps().init___T(" ");
      var x = $f_sci_StringLike__$$times__I__T(this$15, level);
      var this$18 = new $c_sci_StringOps().init___T(x);
      var x$1 = ((("| [" + new $c_sjsr_RuntimeLong().init___I__I(lo$1, hi$1)) + " ms] ") + $as_T(stage.elem$1));
      var that = new $c_sci_StringOps().init___T(x$1);
      var bf = $m_s_Predef$().StringCanBuildFrom$2;
      var stageMessage = $as_T($f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this$18, that, bf));
      var jsx$3 = $m_sc_Seq$();
      var array = [stageMessage];
      var jsx$2 = $as_sc_TraversableLike(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
      var this$21 = $m_sc_Seq$();
      var jsx$1 = $as_sc_TraversableLike(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(nestedMessages, this$21.ReusableCBFInstance$2));
      var this$22 = $m_sc_Seq$();
      return $as_sc_Seq(jsx$1.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(remainingMessages, this$22.ReusableCBFInstance$2))
    } else if ((status === "end")) {
      return $m_sci_Nil$()
    } else {
      throw new $c_s_MatchError().init___O(status)
    }
  } else {
    var x$2 = $m_s_None$();
    if ((x$2 === x1)) {
      return $m_sci_Nil$()
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.$$js$exported$prop$executions__O = (function() {
  return this.executions$1
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.$$js$exported$meth$printStages__O = (function() {
  this.printStages__V()
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.printStages__V = (function() {
  this.collectStages__sc_Seq__I__Z__sc_Seq(this.stagesSeq$1, 0, false).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(stageMessage$2) {
      var stageMessage = $as_T(stageMessage$2);
      $m_jl_System$().err$1.println__T__V(stageMessage)
    })
  })(this)))
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.$$js$exported$meth$finish__O = (function() {
  return this.finish__Lamf_core_benchmark_ExecutionLog$()
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.$$js$exported$prop$stagesStartTime__O = (function() {
  return this.stagesStartTime$1
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.$$js$exported$prop$stagesEndTime__O = (function() {
  return this.stagesEndTime$1
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.log__T__Lamf_core_benchmark_ExecutionLog$ = (function(stage) {
  var this$1 = this.current$1;
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var execution = $as_Lamf_core_benchmark_Execution(arg1);
    var t = new $c_ju_Date().init___().getTime__J();
    var lo = t.lo$2;
    var hi = t.hi$2;
    $m_Lamf_core_benchmark_ExecutionLog$().current$1 = new $c_s_Some().init___O(execution.log__T__J__Lamf_core_benchmark_Execution(stage, new $c_sjsr_RuntimeLong().init___I__I(lo, hi)))
  };
  return this
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.$$js$exported$prop$current__O = (function() {
  return this.current$1
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.$$js$exported$meth$buildReport__O = (function() {
  this.buildReport__V()
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.endStage__T__V = (function(name) {
  var this$1 = this.current$1;
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    $as_Lamf_core_benchmark_Execution(arg1);
    var jsx$2 = $m_Lamf_core_benchmark_ExecutionLog$();
    var jsx$1 = $m_Lamf_core_benchmark_ExecutionLog$().stagesEndTime$1;
    var t = new $c_ju_Date().init___().getTime__J();
    var lo = t.lo$2;
    var hi = t.hi$2;
    jsx$2.stagesEndTime$1 = jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(name, new $c_sjsr_RuntimeLong().init___I__I(lo, hi)));
    var jsx$6 = $m_Lamf_core_benchmark_ExecutionLog$();
    var jsx$5 = $m_Lamf_core_benchmark_ExecutionLog$().stagesSeq$1;
    var jsx$4 = $m_sc_Seq$();
    var array = [(name + "::SEP::end")];
    var jsx$3 = jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$6 = $m_sc_Seq$();
    jsx$6.stagesSeq$1 = $as_sc_Seq(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$6.ReusableCBFInstance$2))
  }
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.$$js$exported$prop$executions__sc_Seq__O = (function(x$1) {
  this.executions$1 = x$1
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.$$js$exported$prop$current__s_Option__O = (function(x$1) {
  this.current$1 = x$1
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.buildReport__V = (function() {
  var jsx$1 = this.executions$1;
  var this$1 = $m_sc_Seq$();
  $as_sc_IterableLike(jsx$1.zipWithIndex__scg_CanBuildFrom__O(this$1.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var execution = $as_Lamf_core_benchmark_Execution(x0$1.$$und1__O());
        var i = x0$1.$$und2$mcI$sp__I();
        var t = execution.startTime$1;
        var lo = t.lo$2;
        var hi = t.hi$2;
        var prev = new $c_sr_LongRef().init___J(new $c_sjsr_RuntimeLong().init___I__I(lo, hi));
        var jsx$2 = $m_jl_System$().err$1;
        var t$1 = execution.endTime$1;
        var lo$1 = t$1.lo$2;
        var hi$1 = t$1.hi$2;
        var b = execution.startTime$1;
        var bhi = b.hi$2;
        var lo$2 = ((lo$1 - b.lo$2) | 0);
        var hi$2 = ((((-2147483648) ^ lo$2) > ((-2147483648) ^ lo$1)) ? (((-1) + ((hi$1 - bhi) | 0)) | 0) : ((hi$1 - bhi) | 0));
        jsx$2.println__T__V((((("---- Run " + i) + " (") + new $c_sjsr_RuntimeLong().init___I__I(lo$2, hi$2)) + " ms) ----\n"));
        execution.logs$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, prev$1) {
          return (function(log$2) {
            var log = $as_Lamf_core_benchmark_Log(log$2);
            var jsx$3 = $m_jl_System$().err$1;
            var t$2 = log.time$1;
            var lo$3 = t$2.lo$2;
            var hi$3 = t$2.hi$2;
            var b$1 = prev$1.elem$1;
            var bhi$1 = b$1.hi$2;
            var lo$4 = ((lo$3 - b$1.lo$2) | 0);
            var hi$4 = ((((-2147483648) ^ lo$4) > ((-2147483648) ^ lo$3)) ? (((-1) + ((hi$3 - bhi$1) | 0)) | 0) : ((hi$3 - bhi$1) | 0));
            jsx$3.println__T__V(((("   (" + new $c_sjsr_RuntimeLong().init___I__I(lo$4, hi$4)) + " ms) ") + log.stage$1));
            prev$1.elem$1 = log.time$1
          })
        })($this, prev)));
        var jsx$4 = $m_jl_System$().err$1;
        var t$3 = execution.endTime$1;
        var lo$5 = t$3.lo$2;
        var hi$5 = t$3.hi$2;
        var b$2 = prev.elem$1;
        var bhi$2 = b$2.hi$2;
        var lo$6 = ((lo$5 - b$2.lo$2) | 0);
        var hi$6 = ((((-2147483648) ^ lo$6) > ((-2147483648) ^ lo$5)) ? (((-1) + ((hi$5 - bhi$2) | 0)) | 0) : ((hi$5 - bhi$2) | 0));
        jsx$4.println__T__V((("   (" + new $c_sjsr_RuntimeLong().init___I__I(lo$6, hi$6)) + " ms) Finished"));
        $m_jl_System$().err$1.println__T__V("\n\n\n")
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this)))
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.start__Lamf_core_benchmark_ExecutionLog$ = (function() {
  var this$1 = this.current$1;
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var execution = $as_Lamf_core_benchmark_Execution(arg1);
    var jsx$4 = $m_Lamf_core_benchmark_ExecutionLog$();
    var jsx$3 = $m_Lamf_core_benchmark_ExecutionLog$().executions$1;
    var jsx$2 = $m_sc_Seq$();
    var array = [execution.finish__Lamf_core_benchmark_Execution()];
    var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$4 = $m_sc_Seq$();
    jsx$4.executions$1 = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2))
  };
  var t = new $c_ju_Date().init___().getTime__J();
  var lo = t.lo$2;
  var hi = t.hi$2;
  this.current$1 = new $c_s_Some().init___O(new $c_Lamf_core_benchmark_Execution().init___J__J__sc_Seq(new $c_sjsr_RuntimeLong().init___I__I(lo, hi), new $c_sjsr_RuntimeLong().init___I__I(lo, hi), $m_sci_Nil$()));
  return this
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.$$js$exported$prop$stagesEndTime__sci_Map__O = (function(x$1) {
  this.stagesEndTime$1 = x$1
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.startStage__T__V = (function(name) {
  var this$1 = this.current$1;
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    $as_Lamf_core_benchmark_Execution(arg1);
    var jsx$2 = $m_Lamf_core_benchmark_ExecutionLog$();
    var jsx$1 = $m_Lamf_core_benchmark_ExecutionLog$().stagesStartTime$1;
    var t = new $c_ju_Date().init___().getTime__J();
    var lo = t.lo$2;
    var hi = t.hi$2;
    jsx$2.stagesStartTime$1 = jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(name, new $c_sjsr_RuntimeLong().init___I__I(lo, hi)));
    var jsx$6 = $m_Lamf_core_benchmark_ExecutionLog$();
    var jsx$5 = $m_Lamf_core_benchmark_ExecutionLog$().stagesSeq$1;
    var jsx$4 = $m_sc_Seq$();
    var array = [(name + "::SEP::start")];
    var jsx$3 = jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$6 = $m_sc_Seq$();
    jsx$6.stagesSeq$1 = $as_sc_Seq(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$6.ReusableCBFInstance$2))
  }
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.$$js$exported$meth$endStage__T__O = (function(name) {
  this.endStage__T__V(name)
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.$$js$exported$prop$executionContext__O = (function() {
  return this.executionContext$1
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.buildReport = (function() {
  return this.$$js$exported$meth$buildReport__O()
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.finish = (function() {
  return this.$$js$exported$meth$finish__O()
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.start = (function() {
  return this.$$js$exported$meth$start__O()
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.log = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$log__T__O(prep)
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.printStages = (function() {
  return this.$$js$exported$meth$printStages__O()
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.withStage = (function(arg, arg$2) {
  var prep = $as_T(arg);
  var prep$2 = $as_F0(arg$2);
  return this.$$js$exported$meth$withStage__T__F0__O(prep, prep$2)
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.endStage = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$endStage__T__O(prep)
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.startStage = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$startStage__T__O(prep)
});
Object.defineProperty($c_Lamf_core_benchmark_ExecutionLog$.prototype, "stagesEndTime", {
  "get": (function() {
    return this.$$js$exported$prop$stagesEndTime__O()
  }),
  "set": (function(arg) {
    var prep = $as_sci_Map(arg);
    this.$$js$exported$prop$stagesEndTime__sci_Map__O(prep)
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_core_benchmark_ExecutionLog$.prototype, "stagesStartTime", {
  "get": (function() {
    return this.$$js$exported$prop$stagesStartTime__O()
  }),
  "set": (function(arg) {
    var prep = $as_sci_Map(arg);
    this.$$js$exported$prop$stagesStartTime__sci_Map__O(prep)
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_core_benchmark_ExecutionLog$.prototype, "stagesSeq", {
  "get": (function() {
    return this.$$js$exported$prop$stagesSeq__O()
  }),
  "set": (function(arg) {
    var prep = $as_sc_Seq(arg);
    this.$$js$exported$prop$stagesSeq__sc_Seq__O(prep)
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_core_benchmark_ExecutionLog$.prototype, "current", {
  "get": (function() {
    return this.$$js$exported$prop$current__O()
  }),
  "set": (function(arg) {
    var prep = $as_s_Option(arg);
    this.$$js$exported$prop$current__s_Option__O(prep)
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_core_benchmark_ExecutionLog$.prototype, "executions", {
  "get": (function() {
    return this.$$js$exported$prop$executions__O()
  }),
  "set": (function(arg) {
    var prep = $as_sc_Seq(arg);
    this.$$js$exported$prop$executions__sc_Seq__O(prep)
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_core_benchmark_ExecutionLog$.prototype, "executionContext", {
  "get": (function() {
    return this.$$js$exported$prop$executionContext__O()
  }),
  "configurable": true
});
var $d_Lamf_core_benchmark_ExecutionLog$ = new $TypeData().initClass({
  Lamf_core_benchmark_ExecutionLog$: 0
}, false, "amf.core.benchmark.ExecutionLog$", {
  Lamf_core_benchmark_ExecutionLog$: 1,
  O: 1
});
$c_Lamf_core_benchmark_ExecutionLog$.prototype.$classData = $d_Lamf_core_benchmark_ExecutionLog$;
var $n_Lamf_core_benchmark_ExecutionLog$ = (void 0);
function $m_Lamf_core_benchmark_ExecutionLog$() {
  if ((!$n_Lamf_core_benchmark_ExecutionLog$)) {
    $n_Lamf_core_benchmark_ExecutionLog$ = new $c_Lamf_core_benchmark_ExecutionLog$().init___()
  };
  return $n_Lamf_core_benchmark_ExecutionLog$
}
/** @constructor */
function $c_Lamf_core_client_ExitCodes$() {
  $c_O.call(this);
  this.Success$1 = 0;
  this.WrongInvocation$1 = 0;
  this.FailingValidation$1 = 0;
  this.Exception$1 = 0
}
$c_Lamf_core_client_ExitCodes$.prototype = new $h_O();
$c_Lamf_core_client_ExitCodes$.prototype.constructor = $c_Lamf_core_client_ExitCodes$;
/** @constructor */
function $h_Lamf_core_client_ExitCodes$() {
  /*<skip>*/
}
$h_Lamf_core_client_ExitCodes$.prototype = $c_Lamf_core_client_ExitCodes$.prototype;
$c_Lamf_core_client_ExitCodes$.prototype.init___ = (function() {
  this.Success$1 = 0;
  this.WrongInvocation$1 = (-1);
  this.FailingValidation$1 = (-2);
  this.Exception$1 = (-3);
  return this
});
var $d_Lamf_core_client_ExitCodes$ = new $TypeData().initClass({
  Lamf_core_client_ExitCodes$: 0
}, false, "amf.core.client.ExitCodes$", {
  Lamf_core_client_ExitCodes$: 1,
  O: 1
});
$c_Lamf_core_client_ExitCodes$.prototype.$classData = $d_Lamf_core_client_ExitCodes$;
var $n_Lamf_core_client_ExitCodes$ = (void 0);
function $m_Lamf_core_client_ExitCodes$() {
  if ((!$n_Lamf_core_client_ExitCodes$)) {
    $n_Lamf_core_client_ExitCodes$ = new $c_Lamf_core_client_ExitCodes$().init___()
  };
  return $n_Lamf_core_client_ExitCodes$
}
/** @constructor */
function $c_Lamf_core_client_ParsingOptions() {
  $c_O.call(this);
  this.amfJsonLdSerialization$1 = false;
  this.baseUnitUrl$1 = null;
  this.maxYamlReferences$1 = null
}
$c_Lamf_core_client_ParsingOptions.prototype = new $h_O();
$c_Lamf_core_client_ParsingOptions.prototype.constructor = $c_Lamf_core_client_ParsingOptions;
/** @constructor */
function $h_Lamf_core_client_ParsingOptions() {
  /*<skip>*/
}
$h_Lamf_core_client_ParsingOptions.prototype = $c_Lamf_core_client_ParsingOptions.prototype;
$c_Lamf_core_client_ParsingOptions.prototype.init___ = (function() {
  this.amfJsonLdSerialization$1 = true;
  this.baseUnitUrl$1 = $m_s_None$();
  this.maxYamlReferences$1 = $m_s_None$();
  return this
});
$c_Lamf_core_client_ParsingOptions.prototype.$$js$exported$prop$isAmfJsonLdSerilization__O = (function() {
  return this.amfJsonLdSerialization$1
});
$c_Lamf_core_client_ParsingOptions.prototype.withBaseUnitUrl__T__Lamf_core_client_ParsingOptions = (function(baseUnit) {
  this.baseUnitUrl$1 = new $c_s_Some().init___O(baseUnit);
  return this
});
$c_Lamf_core_client_ParsingOptions.prototype.setMaxYamlReferences__J__Lamf_core_client_ParsingOptions = (function(value) {
  this.maxYamlReferences$1 = new $c_s_Some().init___O(value);
  return this
});
$c_Lamf_core_client_ParsingOptions.prototype.$$js$exported$meth$withBaseUnitUrl__T__O = (function(baseUnit) {
  return this.withBaseUnitUrl__T__Lamf_core_client_ParsingOptions(baseUnit)
});
$c_Lamf_core_client_ParsingOptions.prototype.withAmfJsonLdSerialization__Lamf_core_client_ParsingOptions = (function() {
  this.amfJsonLdSerialization$1 = true;
  return this
});
$c_Lamf_core_client_ParsingOptions.prototype.$$js$exported$prop$definedBaseUrl__O = (function() {
  return this.baseUnitUrl$1
});
$c_Lamf_core_client_ParsingOptions.prototype.withoutBaseUnitUrl__Lamf_core_client_ParsingOptions = (function() {
  this.baseUnitUrl$1 = $m_s_None$();
  return this
});
$c_Lamf_core_client_ParsingOptions.prototype.$$js$exported$meth$setMaxYamlReferences__J__O = (function(value) {
  return this.setMaxYamlReferences__J__Lamf_core_client_ParsingOptions(value)
});
$c_Lamf_core_client_ParsingOptions.prototype.$$js$exported$prop$withoutAmfJsonLdSerialization__O = (function() {
  return this.withoutAmfJsonLdSerialization__Lamf_core_client_ParsingOptions()
});
$c_Lamf_core_client_ParsingOptions.prototype.$$js$exported$meth$withoutBaseUnitUrl__O = (function() {
  return this.withoutBaseUnitUrl__Lamf_core_client_ParsingOptions()
});
$c_Lamf_core_client_ParsingOptions.prototype.$$js$exported$prop$withAmfJsonLdSerialization__O = (function() {
  return this.withAmfJsonLdSerialization__Lamf_core_client_ParsingOptions()
});
$c_Lamf_core_client_ParsingOptions.prototype.withoutAmfJsonLdSerialization__Lamf_core_client_ParsingOptions = (function() {
  this.amfJsonLdSerialization$1 = false;
  return this
});
$c_Lamf_core_client_ParsingOptions.prototype.$$js$exported$prop$getMaxYamlReferences__O = (function() {
  return this.maxYamlReferences$1
});
Object.defineProperty($c_Lamf_core_client_ParsingOptions.prototype, "getMaxYamlReferences", {
  "get": (function() {
    return this.$$js$exported$prop$getMaxYamlReferences__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_core_client_ParsingOptions.prototype, "definedBaseUrl", {
  "get": (function() {
    return this.$$js$exported$prop$definedBaseUrl__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_core_client_ParsingOptions.prototype, "isAmfJsonLdSerilization", {
  "get": (function() {
    return this.$$js$exported$prop$isAmfJsonLdSerilization__O()
  }),
  "configurable": true
});
$c_Lamf_core_client_ParsingOptions.prototype.setMaxYamlReferences = (function(arg) {
  var prep = $uJ(arg);
  return this.$$js$exported$meth$setMaxYamlReferences__J__O(prep)
});
$c_Lamf_core_client_ParsingOptions.prototype.withoutBaseUnitUrl = (function() {
  return this.$$js$exported$meth$withoutBaseUnitUrl__O()
});
$c_Lamf_core_client_ParsingOptions.prototype.withBaseUnitUrl = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withBaseUnitUrl__T__O(prep)
});
Object.defineProperty($c_Lamf_core_client_ParsingOptions.prototype, "withAmfJsonLdSerialization", {
  "get": (function() {
    return this.$$js$exported$prop$withAmfJsonLdSerialization__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_core_client_ParsingOptions.prototype, "withoutAmfJsonLdSerialization", {
  "get": (function() {
    return this.$$js$exported$prop$withoutAmfJsonLdSerialization__O()
  }),
  "configurable": true
});
function $as_Lamf_core_client_ParsingOptions(obj) {
  return (((obj instanceof $c_Lamf_core_client_ParsingOptions) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.client.ParsingOptions"))
}
function $isArrayOf_Lamf_core_client_ParsingOptions(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_client_ParsingOptions)))
}
function $asArrayOf_Lamf_core_client_ParsingOptions(obj, depth) {
  return (($isArrayOf_Lamf_core_client_ParsingOptions(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.client.ParsingOptions;", depth))
}
var $d_Lamf_core_client_ParsingOptions = new $TypeData().initClass({
  Lamf_core_client_ParsingOptions: 0
}, false, "amf.core.client.ParsingOptions", {
  Lamf_core_client_ParsingOptions: 1,
  O: 1
});
$c_Lamf_core_client_ParsingOptions.prototype.$classData = $d_Lamf_core_client_ParsingOptions;
/** @constructor */
function $c_Lamf_core_client_Proc() {
  $c_O.call(this)
}
$c_Lamf_core_client_Proc.prototype = new $h_O();
$c_Lamf_core_client_Proc.prototype.constructor = $c_Lamf_core_client_Proc;
/** @constructor */
function $h_Lamf_core_client_Proc() {
  /*<skip>*/
}
$h_Lamf_core_client_Proc.prototype = $c_Lamf_core_client_Proc.prototype;
/** @constructor */
function $c_Lamf_core_client_ProcWriter() {
  $c_O.call(this)
}
$c_Lamf_core_client_ProcWriter.prototype = new $h_O();
$c_Lamf_core_client_ProcWriter.prototype.constructor = $c_Lamf_core_client_ProcWriter;
/** @constructor */
function $h_Lamf_core_client_ProcWriter() {
  /*<skip>*/
}
$h_Lamf_core_client_ProcWriter.prototype = $c_Lamf_core_client_ProcWriter.prototype;
/** @constructor */
function $c_Lamf_core_emitter_BaseEmitters_package$() {
  $c_O.call(this)
}
$c_Lamf_core_emitter_BaseEmitters_package$.prototype = new $h_O();
$c_Lamf_core_emitter_BaseEmitters_package$.prototype.constructor = $c_Lamf_core_emitter_BaseEmitters_package$;
/** @constructor */
function $h_Lamf_core_emitter_BaseEmitters_package$() {
  /*<skip>*/
}
$h_Lamf_core_emitter_BaseEmitters_package$.prototype = $c_Lamf_core_emitter_BaseEmitters_package$.prototype;
$c_Lamf_core_emitter_BaseEmitters_package$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_emitter_BaseEmitters_package$.prototype.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(emitters, b) {
  emitters.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$1) {
    return (function(e$2) {
      var e = $as_Lamf_core_emitter_EntryEmitter(e$2);
      e.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$1)
    })
  })(this, b)))
});
$c_Lamf_core_emitter_BaseEmitters_package$.prototype.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position = (function(annotations, clazz) {
  var this$1 = annotations.amf$core$parser$Annotations$$annotations$1;
  var this$2 = this$1.scala$collection$mutable$ListBuffer$$start$6;
  inlinereturn$6: {
    var these = this$2;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      if (clazz.isInstance__O__Z(arg1)) {
        var this$3 = new $c_s_Some().init___O(these.head__O());
        break inlinereturn$6
      };
      these = $as_sc_LinearSeqOptimized(these.tail__O())
    };
    var this$3 = $m_s_None$()
  };
  if (this$3.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1$1 = this$3.get__O();
    var x$1 = $as_Lamf_core_model_domain_Annotation(arg1$1);
    var this$4 = new $c_s_Some().init___O(x$1)
  };
  if (this$4.isEmpty__Z()) {
    var this$5 = $m_s_None$()
  } else {
    var arg1$2 = this$4.get__O();
    var x$2 = $as_Lamf_core_annotations_LexicalInformation(arg1$2);
    var this$5 = new $c_s_Some().init___O(x$2.range__Lamf_core_parser_Range().start$1)
  };
  return $as_Lamf_core_parser_Position((this$5.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$5.get__O()))
});
$c_Lamf_core_emitter_BaseEmitters_package$.prototype.raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V = (function(b, content, tag) {
  var node = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YScalar$().apply__O__Lorg_yaml_model_YScalar(content), tag);
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer(node)
});
$c_Lamf_core_emitter_BaseEmitters_package$.prototype.link__Lorg_yaml_model_YDocument$PartBuilder__T__V = (function(b, id) {
  var jsx$1 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@id");
  $m_Lorg_yaml_model_YNode$();
  var str = $as_T(id.trim());
  var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_core_emitter_BaseEmitters_package$.prototype.traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V = (function(emitters, b) {
  emitters.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$1) {
    return (function(e$2) {
      var e = $as_Lamf_core_emitter_PartEmitter(e$2);
      e.emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$1)
    })
  })(this, b)))
});
var $d_Lamf_core_emitter_BaseEmitters_package$ = new $TypeData().initClass({
  Lamf_core_emitter_BaseEmitters_package$: 0
}, false, "amf.core.emitter.BaseEmitters.package$", {
  Lamf_core_emitter_BaseEmitters_package$: 1,
  O: 1
});
$c_Lamf_core_emitter_BaseEmitters_package$.prototype.$classData = $d_Lamf_core_emitter_BaseEmitters_package$;
var $n_Lamf_core_emitter_BaseEmitters_package$ = (void 0);
function $m_Lamf_core_emitter_BaseEmitters_package$() {
  if ((!$n_Lamf_core_emitter_BaseEmitters_package$)) {
    $n_Lamf_core_emitter_BaseEmitters_package$ = new $c_Lamf_core_emitter_BaseEmitters_package$().init___()
  };
  return $n_Lamf_core_emitter_BaseEmitters_package$
}
/** @constructor */
function $c_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$() {
  $c_O.call(this)
}
$c_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$.prototype = new $h_O();
$c_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$.prototype.constructor = $c_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$;
/** @constructor */
function $h_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$() {
  /*<skip>*/
}
$h_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$.prototype = $c_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$.prototype;
$c_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$.prototype.apply__T__Lamf_core_metamodel_Field__O__Lamf_core_parser_Annotations__Lamf_core_emitter_BaseEmitters_package$ValueEmitter = (function(key, f, value, annotations) {
  var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
  return new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(key, new $c_Lamf_core_parser_FieldEntry().init___Lamf_core_metamodel_Field__Lamf_core_parser_Value(f, new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value$1, annotations)), $m_s_None$())
});
var $d_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$ = new $TypeData().initClass({
  Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$: 0
}, false, "amf.core.emitter.BaseEmitters.package$RawValueEmitter$", {
  Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$: 1,
  O: 1
});
$c_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$.prototype.$classData = $d_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$;
var $n_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$ = (void 0);
function $m_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$() {
  if ((!$n_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$)) {
    $n_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$ = new $c_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$().init___()
  };
  return $n_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$
}
function $is_Lamf_core_emitter_EntryEmitter(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_emitter_EntryEmitter)))
}
function $as_Lamf_core_emitter_EntryEmitter(obj) {
  return (($is_Lamf_core_emitter_EntryEmitter(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.emitter.EntryEmitter"))
}
function $isArrayOf_Lamf_core_emitter_EntryEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_emitter_EntryEmitter)))
}
function $asArrayOf_Lamf_core_emitter_EntryEmitter(obj, depth) {
  return (($isArrayOf_Lamf_core_emitter_EntryEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.emitter.EntryEmitter;", depth))
}
function $is_Lamf_core_emitter_PartEmitter(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_emitter_PartEmitter)))
}
function $as_Lamf_core_emitter_PartEmitter(obj) {
  return (($is_Lamf_core_emitter_PartEmitter(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.emitter.PartEmitter"))
}
function $isArrayOf_Lamf_core_emitter_PartEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_emitter_PartEmitter)))
}
function $asArrayOf_Lamf_core_emitter_PartEmitter(obj, depth) {
  return (($isArrayOf_Lamf_core_emitter_PartEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.emitter.PartEmitter;", depth))
}
/** @constructor */
function $c_Lamf_core_emitter_RenderOptions() {
  $c_O.call(this);
  this.amf$core$emitter$RenderOptions$$sources$1 = false;
  this.amf$core$emitter$RenderOptions$$compactUris$1 = false;
  this.rawSourceMaps$1 = false;
  this.validating$1 = false;
  this.filterFields$1 = null;
  this.amf$core$emitter$RenderOptions$$amfJsonLdSerialization$1 = false;
  this.useJsonLdEmitter$1 = false;
  this.amf$core$emitter$RenderOptions$$flattenedJsonLd$1 = false;
  this.eh$1 = null;
  this.amf$core$emitter$RenderOptions$$prettyPrint$1 = false;
  this.emitNodeIds$1 = false
}
$c_Lamf_core_emitter_RenderOptions.prototype = new $h_O();
$c_Lamf_core_emitter_RenderOptions.prototype.constructor = $c_Lamf_core_emitter_RenderOptions;
/** @constructor */
function $h_Lamf_core_emitter_RenderOptions() {
  /*<skip>*/
}
$h_Lamf_core_emitter_RenderOptions.prototype = $c_Lamf_core_emitter_RenderOptions.prototype;
$c_Lamf_core_emitter_RenderOptions.prototype.init___ = (function() {
  this.amf$core$emitter$RenderOptions$$sources$1 = false;
  this.amf$core$emitter$RenderOptions$$compactUris$1 = false;
  this.rawSourceMaps$1 = false;
  this.validating$1 = false;
  this.filterFields$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      $as_Lamf_core_metamodel_Field(x$1$2);
      return false
    })
  })(this));
  this.amf$core$emitter$RenderOptions$$amfJsonLdSerialization$1 = true;
  this.useJsonLdEmitter$1 = false;
  this.amf$core$emitter$RenderOptions$$flattenedJsonLd$1 = false;
  this.eh$1 = $m_Lamf_core_errorhandling_UnhandledErrorHandler$();
  this.amf$core$emitter$RenderOptions$$prettyPrint$1 = false;
  this.emitNodeIds$1 = false;
  return this
});
$c_Lamf_core_emitter_RenderOptions.prototype.withCompactUris__Lamf_core_emitter_RenderOptions = (function() {
  this.amf$core$emitter$RenderOptions$$compactUris$1 = true;
  return this
});
$c_Lamf_core_emitter_RenderOptions.prototype.withSourceMaps__Lamf_core_emitter_RenderOptions = (function() {
  this.amf$core$emitter$RenderOptions$$sources$1 = true;
  return this
});
$c_Lamf_core_emitter_RenderOptions.prototype.renderField__Lamf_core_metamodel_Field__Z = (function(field) {
  return (!$uZ(this.filterFields$1.apply__O__O(field)))
});
$c_Lamf_core_emitter_RenderOptions.prototype.withValidation__Lamf_core_emitter_RenderOptions = (function() {
  this.validating$1 = true;
  return this
});
$c_Lamf_core_emitter_RenderOptions.prototype.withErrorHandler__Lamf_core_errorhandling_ErrorHandler__Lamf_core_emitter_RenderOptions = (function(errorHandler) {
  this.eh$1 = errorHandler;
  return this
});
var $d_Lamf_core_emitter_RenderOptions = new $TypeData().initClass({
  Lamf_core_emitter_RenderOptions: 0
}, false, "amf.core.emitter.RenderOptions", {
  Lamf_core_emitter_RenderOptions: 1,
  O: 1
});
$c_Lamf_core_emitter_RenderOptions.prototype.$classData = $d_Lamf_core_emitter_RenderOptions;
/** @constructor */
function $c_Lamf_core_emitter_RenderOptions$() {
  $c_O.call(this)
}
$c_Lamf_core_emitter_RenderOptions$.prototype = new $h_O();
$c_Lamf_core_emitter_RenderOptions$.prototype.constructor = $c_Lamf_core_emitter_RenderOptions$;
/** @constructor */
function $h_Lamf_core_emitter_RenderOptions$() {
  /*<skip>*/
}
$h_Lamf_core_emitter_RenderOptions$.prototype = $c_Lamf_core_emitter_RenderOptions$.prototype;
$c_Lamf_core_emitter_RenderOptions$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_emitter_RenderOptions$.prototype.apply__Lamf_client_render_RenderOptions__Lamf_core_emitter_RenderOptions = (function(client) {
  var opts = new $c_Lamf_core_emitter_RenderOptions().init___();
  opts.amf$core$emitter$RenderOptions$$sources$1 = client.sources$1;
  opts.amf$core$emitter$RenderOptions$$amfJsonLdSerialization$1 = client.amfJsonLdSerialization$1;
  opts.amf$core$emitter$RenderOptions$$compactUris$1 = client.compactUris$1;
  var from = client.eh$1;
  opts.withErrorHandler__Lamf_core_errorhandling_ErrorHandler__Lamf_core_emitter_RenderOptions(new $c_Lamf_client_resolve_ClientErrorHandlerConverter$$anonfun$convert$2().init___Lamf_client_resolve_ClientErrorHandler(from));
  opts.amf$core$emitter$RenderOptions$$prettyPrint$1 = client.prettyPrint$1;
  opts.amf$core$emitter$RenderOptions$$flattenedJsonLd$1 = client.flattenedJsonLd$1;
  return opts
});
var $d_Lamf_core_emitter_RenderOptions$ = new $TypeData().initClass({
  Lamf_core_emitter_RenderOptions$: 0
}, false, "amf.core.emitter.RenderOptions$", {
  Lamf_core_emitter_RenderOptions$: 1,
  O: 1
});
$c_Lamf_core_emitter_RenderOptions$.prototype.$classData = $d_Lamf_core_emitter_RenderOptions$;
var $n_Lamf_core_emitter_RenderOptions$ = (void 0);
function $m_Lamf_core_emitter_RenderOptions$() {
  if ((!$n_Lamf_core_emitter_RenderOptions$)) {
    $n_Lamf_core_emitter_RenderOptions$ = new $c_Lamf_core_emitter_RenderOptions$().init___()
  };
  return $n_Lamf_core_emitter_RenderOptions$
}
/** @constructor */
function $c_Lamf_core_emitter_ShapeRenderOptions() {
  $c_O.call(this);
  this.amf$core$emitter$ShapeRenderOptions$$documentation$1 = false;
  this.amf$core$emitter$ShapeRenderOptions$$compactedEmission$1 = false;
  this.schema$1 = null;
  this.amf$core$emitter$ShapeRenderOptions$$eh$1 = null
}
$c_Lamf_core_emitter_ShapeRenderOptions.prototype = new $h_O();
$c_Lamf_core_emitter_ShapeRenderOptions.prototype.constructor = $c_Lamf_core_emitter_ShapeRenderOptions;
/** @constructor */
function $h_Lamf_core_emitter_ShapeRenderOptions() {
  /*<skip>*/
}
$h_Lamf_core_emitter_ShapeRenderOptions.prototype = $c_Lamf_core_emitter_ShapeRenderOptions.prototype;
$c_Lamf_core_emitter_ShapeRenderOptions.prototype.init___ = (function() {
  this.amf$core$emitter$ShapeRenderOptions$$documentation$1 = true;
  this.amf$core$emitter$ShapeRenderOptions$$compactedEmission$1 = false;
  this.schema$1 = $m_Lamf_client_render_JSONSchemaVersions$().UNSPECIFIED$1;
  this.amf$core$emitter$ShapeRenderOptions$$eh$1 = $m_Lamf_core_errorhandling_UnhandledErrorHandler$();
  return this
});
$c_Lamf_core_emitter_ShapeRenderOptions.prototype.withoutDocumentation__Lamf_core_emitter_ShapeRenderOptions = (function() {
  this.amf$core$emitter$ShapeRenderOptions$$documentation$1 = false;
  return this
});
$c_Lamf_core_emitter_ShapeRenderOptions.prototype.withCompactedEmission__Lamf_core_emitter_ShapeRenderOptions = (function() {
  this.amf$core$emitter$ShapeRenderOptions$$compactedEmission$1 = true;
  return this
});
$c_Lamf_core_emitter_ShapeRenderOptions.prototype.withSchemaVersion__Lamf_client_render_JSONSchemaVersion__Lamf_core_emitter_ShapeRenderOptions = (function(version) {
  this.schema$1 = version;
  return this
});
var $d_Lamf_core_emitter_ShapeRenderOptions = new $TypeData().initClass({
  Lamf_core_emitter_ShapeRenderOptions: 0
}, false, "amf.core.emitter.ShapeRenderOptions", {
  Lamf_core_emitter_ShapeRenderOptions: 1,
  O: 1
});
$c_Lamf_core_emitter_ShapeRenderOptions.prototype.$classData = $d_Lamf_core_emitter_ShapeRenderOptions;
/** @constructor */
function $c_Lamf_core_emitter_ShapeRenderOptions$() {
  $c_O.call(this)
}
$c_Lamf_core_emitter_ShapeRenderOptions$.prototype = new $h_O();
$c_Lamf_core_emitter_ShapeRenderOptions$.prototype.constructor = $c_Lamf_core_emitter_ShapeRenderOptions$;
/** @constructor */
function $h_Lamf_core_emitter_ShapeRenderOptions$() {
  /*<skip>*/
}
$h_Lamf_core_emitter_ShapeRenderOptions$.prototype = $c_Lamf_core_emitter_ShapeRenderOptions$.prototype;
$c_Lamf_core_emitter_ShapeRenderOptions$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_emitter_ShapeRenderOptions$.prototype.apply__Lamf_client_render_ShapeRenderOptions__Lamf_core_emitter_ShapeRenderOptions = (function(client) {
  var opts = new $c_Lamf_core_emitter_ShapeRenderOptions().init___();
  opts.amf$core$emitter$ShapeRenderOptions$$documentation$1 = client.documentation$1;
  opts.amf$core$emitter$ShapeRenderOptions$$compactedEmission$1 = client.compactedEmission$1;
  var from = client.eh$1;
  opts.amf$core$emitter$ShapeRenderOptions$$eh$1 = new $c_Lamf_client_resolve_ClientErrorHandlerConverter$$anonfun$convert$2().init___Lamf_client_resolve_ClientErrorHandler(from);
  opts.withSchemaVersion__Lamf_client_render_JSONSchemaVersion__Lamf_core_emitter_ShapeRenderOptions(client.schema$1);
  return opts
});
var $d_Lamf_core_emitter_ShapeRenderOptions$ = new $TypeData().initClass({
  Lamf_core_emitter_ShapeRenderOptions$: 0
}, false, "amf.core.emitter.ShapeRenderOptions$", {
  Lamf_core_emitter_ShapeRenderOptions$: 1,
  O: 1
});
$c_Lamf_core_emitter_ShapeRenderOptions$.prototype.$classData = $d_Lamf_core_emitter_ShapeRenderOptions$;
var $n_Lamf_core_emitter_ShapeRenderOptions$ = (void 0);
function $m_Lamf_core_emitter_ShapeRenderOptions$() {
  if ((!$n_Lamf_core_emitter_ShapeRenderOptions$)) {
    $n_Lamf_core_emitter_ShapeRenderOptions$ = new $c_Lamf_core_emitter_ShapeRenderOptions$().init___()
  };
  return $n_Lamf_core_emitter_ShapeRenderOptions$
}
/** @constructor */
function $c_Lamf_core_errorhandling_AmfReportBuilder() {
  $c_O.call(this);
  this.model$1 = null;
  this.profileName$1 = null
}
$c_Lamf_core_errorhandling_AmfReportBuilder.prototype = new $h_O();
$c_Lamf_core_errorhandling_AmfReportBuilder.prototype.constructor = $c_Lamf_core_errorhandling_AmfReportBuilder;
/** @constructor */
function $h_Lamf_core_errorhandling_AmfReportBuilder() {
  /*<skip>*/
}
$h_Lamf_core_errorhandling_AmfReportBuilder.prototype = $c_Lamf_core_errorhandling_AmfReportBuilder.prototype;
$c_Lamf_core_errorhandling_AmfReportBuilder.prototype.buildReport__sc_Seq__Lamf_core_validation_AMFValidationReport = (function(results) {
  return new $c_Lamf_core_validation_AMFValidationReport().init___Z__T__Lamf_ProfileName__sc_Seq((!results.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_validation_AMFValidationResult(x$1$2);
      return (x$1.level$1 === $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1)
    })
  })(this)))), this.model$1.id__T(), this.profileName$1, results)
});
$c_Lamf_core_errorhandling_AmfReportBuilder.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_ProfileName = (function(model, profileName) {
  this.model$1 = model;
  this.profileName$1 = profileName;
  return this
});
function $f_Lamf_core_errorhandling_AmfResultErrorHandler__reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V($thiz, id, node, property, message, lexical, level, location) {
  $thiz.handlerAmfResult__Lamf_core_validation_AMFValidationResult__Z(new $c_Lamf_core_validation_AMFValidationResult().init___T__T__T__s_Option__T__s_Option__s_Option__O(message, level, node, property, id, lexical, location, $thiz))
}
function $is_Lamf_core_errorhandling_AmfResultErrorHandler(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_errorhandling_AmfResultErrorHandler)))
}
function $as_Lamf_core_errorhandling_AmfResultErrorHandler(obj) {
  return (($is_Lamf_core_errorhandling_AmfResultErrorHandler(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.errorhandling.AmfResultErrorHandler"))
}
function $isArrayOf_Lamf_core_errorhandling_AmfResultErrorHandler(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_errorhandling_AmfResultErrorHandler)))
}
function $asArrayOf_Lamf_core_errorhandling_AmfResultErrorHandler(obj, depth) {
  return (($isArrayOf_Lamf_core_errorhandling_AmfResultErrorHandler(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.errorhandling.AmfResultErrorHandler;", depth))
}
/** @constructor */
function $c_Lamf_core_errorhandling_StaticErrorCollector$() {
  $c_O.call(this);
  this.errorsForUnitCount$1 = null
}
$c_Lamf_core_errorhandling_StaticErrorCollector$.prototype = new $h_O();
$c_Lamf_core_errorhandling_StaticErrorCollector$.prototype.constructor = $c_Lamf_core_errorhandling_StaticErrorCollector$;
/** @constructor */
function $h_Lamf_core_errorhandling_StaticErrorCollector$() {
  /*<skip>*/
}
$h_Lamf_core_errorhandling_StaticErrorCollector$.prototype = $c_Lamf_core_errorhandling_StaticErrorCollector$.prototype;
$c_Lamf_core_errorhandling_StaticErrorCollector$.prototype.init___ = (function() {
  $n_Lamf_core_errorhandling_StaticErrorCollector$ = this;
  this.errorsForUnitCount$1 = new $c_scm_HashMap().init___();
  return this
});
$c_Lamf_core_errorhandling_StaticErrorCollector$.prototype.getRun__I__sc_Seq = (function(parserRun) {
  var this$1 = this.errorsForUnitCount$1;
  var x1 = this$1.get__O__s_Option(parserRun);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var v = x2.value$2;
    var jsx$1 = v
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var jsx$1 = $m_sci_Nil$()
  };
  return $as_sc_Seq(jsx$1)
});
$c_Lamf_core_errorhandling_StaticErrorCollector$.prototype.collect__Lamf_core_validation_AMFValidationResult__I__V = (function(result, parserRun) {
  var x1 = this.errorsForUnitCount$1.get__O__s_Option(parserRun);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var seq = $as_sc_Seq(x2.value$2);
    var jsx$1 = this.errorsForUnitCount$1;
    var this$1 = $m_sc_Seq$();
    jsx$1.update__O__O__V(parserRun, seq.$$plus$colon__O__scg_CanBuildFrom__O(result, this$1.ReusableCBFInstance$2))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var jsx$3 = this.errorsForUnitCount$1;
      var jsx$2 = $m_sc_Seq$();
      var array = [result];
      jsx$3.put__O__O__s_Option(parserRun, jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
var $d_Lamf_core_errorhandling_StaticErrorCollector$ = new $TypeData().initClass({
  Lamf_core_errorhandling_StaticErrorCollector$: 0
}, false, "amf.core.errorhandling.StaticErrorCollector$", {
  Lamf_core_errorhandling_StaticErrorCollector$: 1,
  O: 1
});
$c_Lamf_core_errorhandling_StaticErrorCollector$.prototype.$classData = $d_Lamf_core_errorhandling_StaticErrorCollector$;
var $n_Lamf_core_errorhandling_StaticErrorCollector$ = (void 0);
function $m_Lamf_core_errorhandling_StaticErrorCollector$() {
  if ((!$n_Lamf_core_errorhandling_StaticErrorCollector$)) {
    $n_Lamf_core_errorhandling_StaticErrorCollector$ = new $c_Lamf_core_errorhandling_StaticErrorCollector$().init___()
  };
  return $n_Lamf_core_errorhandling_StaticErrorCollector$
}
function $f_Lamf_core_errorhandling_UnhandledErrorHandler__reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V($thiz, id, node, property, message, lexical, level, location) {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(((((((((("  Message: " + message) + "\n  Target: ") + node) + "\nProperty: ") + (property.isEmpty__Z() ? "" : property.get__O())) + "\n  Position: ") + lexical) + "\n at location: ") + location)))
}
function $f_Lamf_core_metamodel_Obj__$$init$__V($thiz) {
  $thiz.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V(new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()))
}
function $is_Lamf_core_metamodel_Obj(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_metamodel_Obj)))
}
function $as_Lamf_core_metamodel_Obj(obj) {
  return (($is_Lamf_core_metamodel_Obj(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.metamodel.Obj"))
}
function $isArrayOf_Lamf_core_metamodel_Obj(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_metamodel_Obj)))
}
function $asArrayOf_Lamf_core_metamodel_Obj(obj, depth) {
  return (($isArrayOf_Lamf_core_metamodel_Obj(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.metamodel.Obj;", depth))
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_ExternalModelVocabularies$() {
  $c_O.call(this);
  this.Shacl$1 = null;
  this.Rdfs$1 = null;
  this.Rdf$1 = null;
  this.Owl$1 = null;
  this.all$1 = null
}
$c_Lamf_core_metamodel_domain_ExternalModelVocabularies$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_ExternalModelVocabularies$.prototype.constructor = $c_Lamf_core_metamodel_domain_ExternalModelVocabularies$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_ExternalModelVocabularies$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_ExternalModelVocabularies$.prototype = $c_Lamf_core_metamodel_domain_ExternalModelVocabularies$.prototype;
$c_Lamf_core_metamodel_domain_ExternalModelVocabularies$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_ExternalModelVocabularies$ = this;
  this.Shacl$1 = new $c_Lamf_core_metamodel_domain_ModelVocabulary().init___T__T__T__T("shacl", $m_Lamf_core_vocabulary_Namespace$().Shacl$1.base$1, "SHACL vocabulary", "shacl.yaml");
  this.Rdfs$1 = new $c_Lamf_core_metamodel_domain_ModelVocabulary().init___T__T__T__T("rdfs", $m_Lamf_core_vocabulary_Namespace$().Rdfs$1.base$1, "RDFS vocabulary", "rdfs.yaml");
  this.Rdf$1 = new $c_Lamf_core_metamodel_domain_ModelVocabulary().init___T__T__T__T("rdf", $m_Lamf_core_vocabulary_Namespace$().Rdf$1.base$1, "RDF vocabulary", "rdf.yaml");
  this.Owl$1 = new $c_Lamf_core_metamodel_domain_ModelVocabulary().init___T__T__T__T("owl", $m_Lamf_core_vocabulary_Namespace$().Owl$1.base$1, "OWL2 vocabulary", "owl.yaml");
  var jsx$1 = $m_sc_Seq$();
  var array = [this.Shacl$1, this.Rdfs$1, this.Rdf$1, this.Owl$1];
  this.all$1 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
var $d_Lamf_core_metamodel_domain_ExternalModelVocabularies$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_ExternalModelVocabularies$: 0
}, false, "amf.core.metamodel.domain.ExternalModelVocabularies$", {
  Lamf_core_metamodel_domain_ExternalModelVocabularies$: 1,
  O: 1
});
$c_Lamf_core_metamodel_domain_ExternalModelVocabularies$.prototype.$classData = $d_Lamf_core_metamodel_domain_ExternalModelVocabularies$;
var $n_Lamf_core_metamodel_domain_ExternalModelVocabularies$ = (void 0);
function $m_Lamf_core_metamodel_domain_ExternalModelVocabularies$() {
  if ((!$n_Lamf_core_metamodel_domain_ExternalModelVocabularies$)) {
    $n_Lamf_core_metamodel_domain_ExternalModelVocabularies$ = new $c_Lamf_core_metamodel_domain_ExternalModelVocabularies$().init___()
  };
  return $n_Lamf_core_metamodel_domain_ExternalModelVocabularies$
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_ModelVocabularies$() {
  $c_O.call(this);
  this.Parser$1 = null;
  this.AmlDoc$1 = null;
  this.ApiContract$1 = null;
  this.ApiBinding$1 = null;
  this.Core$1 = null;
  this.Shapes$1 = null;
  this.Data$1 = null;
  this.Meta$1 = null;
  this.Security$1 = null;
  this.all$1 = null
}
$c_Lamf_core_metamodel_domain_ModelVocabularies$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_ModelVocabularies$.prototype.constructor = $c_Lamf_core_metamodel_domain_ModelVocabularies$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_ModelVocabularies$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_ModelVocabularies$.prototype = $c_Lamf_core_metamodel_domain_ModelVocabularies$.prototype;
$c_Lamf_core_metamodel_domain_ModelVocabularies$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_ModelVocabularies$ = this;
  this.Parser$1 = new $c_Lamf_core_metamodel_domain_ModelVocabulary().init___T__T__T__T("parser", $m_Lamf_core_vocabulary_Namespace$().AmfParser$1.base$1, "Internal namespace", "");
  this.AmlDoc$1 = new $c_Lamf_core_metamodel_domain_ModelVocabulary().init___T__T__T__T("doc", $m_Lamf_core_vocabulary_Namespace$().Document$1.base$1, "Document Model vocabulary for AMF. The Document Model defines the basic modular units where domain descriptions can be encoded.", "aml_doc.yaml");
  this.ApiContract$1 = new $c_Lamf_core_metamodel_domain_ModelVocabulary().init___T__T__T__T("apiContract", $m_Lamf_core_vocabulary_Namespace$().ApiContract$1.base$1, "API contract vocabulary", "api_contract.yaml");
  this.ApiBinding$1 = new $c_Lamf_core_metamodel_domain_ModelVocabulary().init___T__T__T__T("apiBinding", $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1.base$1, "API binding vocabulary", "api_binding.yaml");
  this.Core$1 = new $c_Lamf_core_metamodel_domain_ModelVocabulary().init___T__T__T__T("core", $m_Lamf_core_vocabulary_Namespace$().Core$1.base$1, "Core vocabulary with common classes and properties", "core.yaml");
  this.Shapes$1 = new $c_Lamf_core_metamodel_domain_ModelVocabulary().init___T__T__T__T("shapes", $m_Lamf_core_vocabulary_Namespace$().Shapes$1.base$1, "Vocabulary defining data shapes, used as an extension to SHACL", "data_shapes.yaml");
  this.Data$1 = new $c_Lamf_core_metamodel_domain_ModelVocabulary().init___T__T__T__T("data", $m_Lamf_core_vocabulary_Namespace$().Data$1.base$1, "Vocabulary defining a default set of classes to map data structures composed of recursive records of fields,\nlike the ones used in JSON or YAML into a RDF graph.\nThey can be validated using data shapes.", "data_model.yaml");
  this.Meta$1 = new $c_Lamf_core_metamodel_domain_ModelVocabulary().init___T__T__T__T("meta", $m_Lamf_core_vocabulary_Namespace$().Meta$1.base$1, "Vocabulary containing meta-definitions", "aml_meta.yaml");
  this.Security$1 = new $c_Lamf_core_metamodel_domain_ModelVocabulary().init___T__T__T__T("security", $m_Lamf_core_vocabulary_Namespace$().Security$1.base$1, "Vocabulary for HTTP security information", "security.yaml");
  var jsx$1 = $m_sc_Seq$();
  var array = [this.AmlDoc$1, this.Core$1, this.ApiContract$1, this.ApiBinding$1, this.Shapes$1, this.Data$1, this.Security$1, this.Meta$1];
  this.all$1 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
var $d_Lamf_core_metamodel_domain_ModelVocabularies$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_ModelVocabularies$: 0
}, false, "amf.core.metamodel.domain.ModelVocabularies$", {
  Lamf_core_metamodel_domain_ModelVocabularies$: 1,
  O: 1
});
$c_Lamf_core_metamodel_domain_ModelVocabularies$.prototype.$classData = $d_Lamf_core_metamodel_domain_ModelVocabularies$;
var $n_Lamf_core_metamodel_domain_ModelVocabularies$ = (void 0);
function $m_Lamf_core_metamodel_domain_ModelVocabularies$() {
  if ((!$n_Lamf_core_metamodel_domain_ModelVocabularies$)) {
    $n_Lamf_core_metamodel_domain_ModelVocabularies$ = new $c_Lamf_core_metamodel_domain_ModelVocabularies$().init___()
  };
  return $n_Lamf_core_metamodel_domain_ModelVocabularies$
}
/** @constructor */
function $c_Lamf_core_model_DataType$() {
  $c_O.call(this);
  this.String$1 = null;
  this.Integer$1 = null;
  this.Number$1 = null;
  this.Long$1 = null;
  this.Double$1 = null;
  this.Float$1 = null;
  this.Decimal$1 = null;
  this.Boolean$1 = null;
  this.Date$1 = null;
  this.Time$1 = null;
  this.DateTime$1 = null;
  this.DateTimeOnly$1 = null;
  this.Duration$1 = null;
  this.File$1 = null;
  this.Byte$1 = null;
  this.Binary$1 = null;
  this.Password$1 = null;
  this.Any$1 = null;
  this.AnyUri$1 = null;
  this.Link$1 = null;
  this.Nil$1 = null
}
$c_Lamf_core_model_DataType$.prototype = new $h_O();
$c_Lamf_core_model_DataType$.prototype.constructor = $c_Lamf_core_model_DataType$;
/** @constructor */
function $h_Lamf_core_model_DataType$() {
  /*<skip>*/
}
$h_Lamf_core_model_DataType$.prototype = $c_Lamf_core_model_DataType$.prototype;
$c_Lamf_core_model_DataType$.prototype.init___ = (function() {
  $n_Lamf_core_model_DataType$ = this;
  this.String$1 = ($m_Lamf_core_vocabulary_Namespace$().Xsd$1.base$1 + "string");
  this.Integer$1 = ($m_Lamf_core_vocabulary_Namespace$().Xsd$1.base$1 + "integer");
  this.Number$1 = ($m_Lamf_core_vocabulary_Namespace$().Shapes$1.base$1 + "number");
  this.Long$1 = ($m_Lamf_core_vocabulary_Namespace$().Xsd$1.base$1 + "long");
  this.Double$1 = ($m_Lamf_core_vocabulary_Namespace$().Xsd$1.base$1 + "double");
  this.Float$1 = ($m_Lamf_core_vocabulary_Namespace$().Xsd$1.base$1 + "float");
  this.Decimal$1 = ($m_Lamf_core_vocabulary_Namespace$().Xsd$1.base$1 + "decimal");
  this.Boolean$1 = ($m_Lamf_core_vocabulary_Namespace$().Xsd$1.base$1 + "boolean");
  this.Date$1 = ($m_Lamf_core_vocabulary_Namespace$().Xsd$1.base$1 + "date");
  this.Time$1 = ($m_Lamf_core_vocabulary_Namespace$().Xsd$1.base$1 + "time");
  this.DateTime$1 = ($m_Lamf_core_vocabulary_Namespace$().Xsd$1.base$1 + "dateTime");
  this.DateTimeOnly$1 = ($m_Lamf_core_vocabulary_Namespace$().Shapes$1.base$1 + "dateTimeOnly");
  this.Duration$1 = ($m_Lamf_core_vocabulary_Namespace$().Xsd$1.base$1 + "duration");
  this.File$1 = ($m_Lamf_core_vocabulary_Namespace$().Shapes$1.base$1 + "file");
  this.Byte$1 = ($m_Lamf_core_vocabulary_Namespace$().Xsd$1.base$1 + "byte");
  this.Binary$1 = ($m_Lamf_core_vocabulary_Namespace$().Xsd$1.base$1 + "base64Binary");
  this.Password$1 = ($m_Lamf_core_vocabulary_Namespace$().Shapes$1.base$1 + "password");
  this.Any$1 = ($m_Lamf_core_vocabulary_Namespace$().Xsd$1.base$1 + "anyType");
  this.AnyUri$1 = ($m_Lamf_core_vocabulary_Namespace$().Xsd$1.base$1 + "anyURI");
  this.Link$1 = ($m_Lamf_core_vocabulary_Namespace$().Shapes$1.base$1 + "link");
  this.Nil$1 = ($m_Lamf_core_vocabulary_Namespace$().Xsd$1.base$1 + "nil");
  return this
});
$c_Lamf_core_model_DataType$.prototype.apply__T__T = (function(dataType) {
  return ((dataType === "string") ? this.String$1 : ((dataType === "integer") ? this.Integer$1 : ((dataType === "number") ? this.Number$1 : ((dataType === "long") ? this.Long$1 : ((dataType === "double") ? this.Double$1 : ((dataType === "float") ? this.Float$1 : ((dataType === "decimal") ? this.Decimal$1 : ((dataType === "boolean") ? this.Boolean$1 : (((dataType === "date") || (dataType === "date-only")) ? this.Date$1 : (((dataType === "time") || (dataType === "time-only")) ? this.Time$1 : (((dataType === "dateTime") || (dataType === "datetime")) ? this.DateTime$1 : (((dataType === "dateTimeOnly") || (dataType === "datetime-only")) ? this.DateTimeOnly$1 : ((dataType === "file") ? this.File$1 : ((dataType === "byte") ? this.Byte$1 : ((dataType === "base64Binary") ? this.Binary$1 : ((dataType === "password") ? this.Password$1 : (((dataType === "anyType") || (dataType === "any")) ? this.Any$1 : (((dataType === "anyUri") || (dataType === "uri")) ? this.AnyUri$1 : ((dataType === "nil") ? this.Nil$1 : (("" + $m_Lamf_core_vocabulary_Namespace$().Xsd$1.base$1) + dataType))))))))))))))))))))
});
var $d_Lamf_core_model_DataType$ = new $TypeData().initClass({
  Lamf_core_model_DataType$: 0
}, false, "amf.core.model.DataType$", {
  Lamf_core_model_DataType$: 1,
  O: 1
});
$c_Lamf_core_model_DataType$.prototype.$classData = $d_Lamf_core_model_DataType$;
var $n_Lamf_core_model_DataType$ = (void 0);
function $m_Lamf_core_model_DataType$() {
  if ((!$n_Lamf_core_model_DataType$)) {
    $n_Lamf_core_model_DataType$ = new $c_Lamf_core_model_DataType$().init___()
  };
  return $n_Lamf_core_model_DataType$
}
/** @constructor */
function $c_Lamf_core_model_document_SourceMap() {
  $c_O.call(this);
  this.annotations$1 = null;
  this.eternals$1 = null
}
$c_Lamf_core_model_document_SourceMap.prototype = new $h_O();
$c_Lamf_core_model_document_SourceMap.prototype.constructor = $c_Lamf_core_model_document_SourceMap;
/** @constructor */
function $h_Lamf_core_model_document_SourceMap() {
  /*<skip>*/
}
$h_Lamf_core_model_document_SourceMap.prototype = $c_Lamf_core_model_document_SourceMap.prototype;
$c_Lamf_core_model_document_SourceMap.prototype.property__T__Lamf_core_parser_Value__V = (function(element, value) {
  value.annotations$1.serializables__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, element$1) {
    return (function(a$2) {
      var a = $as_Lamf_core_model_domain_SerializableAnnotation(a$2);
      var y = a.value__T();
      var tuple = new $c_T2().init___O__O(element$1, y);
      var x1 = $this.annotations$1.get__O__s_Option(a.name__T());
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var values = $as_scm_ListMap(x2.value$2);
        return values.$$plus$eq__T2__scm_ListMap(tuple)
      } else {
        var x = $m_s_None$();
        if ((x === x1)) {
          var jsx$1 = $this.annotations$1;
          var self = a.name__T();
          var array = [tuple];
          var this$7 = new $c_scm_ListMap().init___();
          var i = 0;
          var len = $uI(array.length);
          while ((i < len)) {
            var index = i;
            var arg1 = array[index];
            this$7.$$plus$eq__T2__scm_ListMap($as_T2(arg1));
            i = ((1 + i) | 0)
          };
          return jsx$1.$$plus$eq__T2__scm_ListMap(new $c_T2().init___O__O(self, this$7))
        } else {
          throw new $c_s_MatchError().init___O(x1)
        }
      }
    })
  })(this, element)));
  value.annotations$1.eternals__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, element$2) {
    return (function(e$2) {
      var e = $as_Lamf_core_model_domain_EternalSerializedAnnotation(e$2);
      var y$1 = e.value__T();
      var tuple$1 = new $c_T2().init___O__O(element$2, y$1);
      var x1$1 = this$2$1.eternals$1.get__O__s_Option(e.name__T());
      if ((x1$1 instanceof $c_s_Some)) {
        var x2$1 = $as_s_Some(x1$1);
        var values$1 = $as_scm_ListMap(x2$1.value$2);
        return values$1.$$plus$eq__T2__scm_ListMap(tuple$1)
      } else {
        var x$1 = $m_s_None$();
        if ((x$1 === x1$1)) {
          var jsx$2 = this$2$1.eternals$1;
          var self$1 = e.name__T();
          var array$1 = [tuple$1];
          var this$15 = new $c_scm_ListMap().init___();
          var i$1 = 0;
          var len$1 = $uI(array$1.length);
          while ((i$1 < len$1)) {
            var index$1 = i$1;
            var arg1$1 = array$1[index$1];
            this$15.$$plus$eq__T2__scm_ListMap($as_T2(arg1$1));
            i$1 = ((1 + i$1) | 0)
          };
          return jsx$2.$$plus$eq__T2__scm_ListMap(new $c_T2().init___O__O(self$1, this$15))
        } else {
          throw new $c_s_MatchError().init___O(x1$1)
        }
      }
    })
  })(this, element)))
});
$c_Lamf_core_model_document_SourceMap.prototype.init___scm_ListMap__scm_ListMap = (function(annotations, eternals) {
  this.annotations$1 = annotations;
  this.eternals$1 = eternals;
  return this
});
$c_Lamf_core_model_document_SourceMap.prototype.annotation__T__F2 = (function(annotation) {
  var this$1 = this.annotations$1.get__O__s_Option(annotation);
  var x1 = (this$1.isEmpty__Z() ? this.eternals$1.get__O__s_Option(annotation) : this$1);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var values = $as_scm_ListMap(x2.value$2);
    var map = values
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var values$2 = $as_scm_ListMap($m_scm_ListMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    this.annotations$1.$$plus$eq__T2__scm_ListMap(new $c_T2().init___O__O(annotation, values$2));
    var map = values$2
  };
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$2$1, map$1) {
    return (function(key$2, value$2) {
      var key = $as_T(key$2);
      var value = $as_T(value$2);
      $f_scm_MapLike__update__O__O__V(map$1, key, value)
    })
  })(this, map))
});
function $as_Lamf_core_model_document_SourceMap(obj) {
  return (((obj instanceof $c_Lamf_core_model_document_SourceMap) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.document.SourceMap"))
}
function $isArrayOf_Lamf_core_model_document_SourceMap(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_document_SourceMap)))
}
function $asArrayOf_Lamf_core_model_document_SourceMap(obj, depth) {
  return (($isArrayOf_Lamf_core_model_document_SourceMap(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.document.SourceMap;", depth))
}
var $d_Lamf_core_model_document_SourceMap = new $TypeData().initClass({
  Lamf_core_model_document_SourceMap: 0
}, false, "amf.core.model.document.SourceMap", {
  Lamf_core_model_document_SourceMap: 1,
  O: 1
});
$c_Lamf_core_model_document_SourceMap.prototype.$classData = $d_Lamf_core_model_document_SourceMap;
/** @constructor */
function $c_Lamf_core_model_document_SourceMap$() {
  $c_O.call(this);
  this.empty$1 = null
}
$c_Lamf_core_model_document_SourceMap$.prototype = new $h_O();
$c_Lamf_core_model_document_SourceMap$.prototype.constructor = $c_Lamf_core_model_document_SourceMap$;
/** @constructor */
function $h_Lamf_core_model_document_SourceMap$() {
  /*<skip>*/
}
$h_Lamf_core_model_document_SourceMap$.prototype = $c_Lamf_core_model_document_SourceMap$.prototype;
$c_Lamf_core_model_document_SourceMap$.prototype.init___ = (function() {
  $n_Lamf_core_model_document_SourceMap$ = this;
  this.empty$1 = new $c_Lamf_core_model_document_SourceMap().init___scm_ListMap__scm_ListMap(new $c_scm_ListMap().init___(), new $c_scm_ListMap().init___());
  return this
});
$c_Lamf_core_model_document_SourceMap$.prototype.apply__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_document_SourceMap = (function(id, element) {
  var map = $m_Lamf_core_model_document_SourceMap$().apply__Lamf_core_model_document_SourceMap();
  element.annotations__Lamf_core_parser_Annotations().serializables__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, map$1, id$1) {
    return (function(a$2) {
      var a = $as_Lamf_core_model_domain_SerializableAnnotation(a$2);
      var jsx$1 = map$1.annotations$1;
      var self = a.name__T();
      var y = a.value__T();
      var array = [new $c_T2().init___O__O(id$1, y)];
      var this$7 = new $c_scm_ListMap().init___();
      var i = 0;
      var len = $uI(array.length);
      while ((i < len)) {
        var index = i;
        var arg1 = array[index];
        this$7.$$plus$eq__T2__scm_ListMap($as_T2(arg1));
        i = ((1 + i) | 0)
      };
      return jsx$1.$$plus$eq__T2__scm_ListMap(new $c_T2().init___O__O(self, this$7))
    })
  })(this, map, id)));
  element.annotations__Lamf_core_parser_Annotations().eternals__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, map$2, id$2) {
    return (function(e$2) {
      var e = $as_Lamf_core_model_domain_EternalSerializedAnnotation(e$2);
      var jsx$2 = map$2.eternals$1;
      var self$1 = e.name__T();
      var y$1 = e.value__T();
      var array$1 = [new $c_T2().init___O__O(id$2, y$1)];
      var this$15 = new $c_scm_ListMap().init___();
      var i$1 = 0;
      var len$1 = $uI(array$1.length);
      while ((i$1 < len$1)) {
        var index$1 = i$1;
        var arg1$1 = array$1[index$1];
        this$15.$$plus$eq__T2__scm_ListMap($as_T2(arg1$1));
        i$1 = ((1 + i$1) | 0)
      };
      return jsx$2.$$plus$eq__T2__scm_ListMap(new $c_T2().init___O__O(self$1, this$15))
    })
  })(this, map, id)));
  return map
});
$c_Lamf_core_model_document_SourceMap$.prototype.apply__Lamf_core_model_document_SourceMap = (function() {
  return new $c_Lamf_core_model_document_SourceMap().init___scm_ListMap__scm_ListMap($as_scm_ListMap($m_scm_ListMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), new $c_scm_ListMap().init___())
});
var $d_Lamf_core_model_document_SourceMap$ = new $TypeData().initClass({
  Lamf_core_model_document_SourceMap$: 0
}, false, "amf.core.model.document.SourceMap$", {
  Lamf_core_model_document_SourceMap$: 1,
  O: 1
});
$c_Lamf_core_model_document_SourceMap$.prototype.$classData = $d_Lamf_core_model_document_SourceMap$;
var $n_Lamf_core_model_document_SourceMap$ = (void 0);
function $m_Lamf_core_model_document_SourceMap$() {
  if ((!$n_Lamf_core_model_document_SourceMap$)) {
    $n_Lamf_core_model_document_SourceMap$ = new $c_Lamf_core_model_document_SourceMap$().init___()
  };
  return $n_Lamf_core_model_document_SourceMap$
}
function $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject($thiz, field, values) {
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_T(x$1$2);
      return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(x$1, new $c_Lamf_core_parser_Annotations().init___())
    })
  })($thiz));
  var this$2 = $m_sc_Seq$();
  var values$1 = $as_sc_Seq(values.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  return $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject($thiz, field, values$1)
}
function $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject($thiz, parent) {
  return $thiz.withId__T__Lamf_core_model_domain_AmfObject((("" + parent) + $thiz.componentId__T()))
}
function $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__D__Lamf_core_model_domain_AmfObject($thiz, field, value) {
  var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, new $c_Lamf_core_parser_Annotations().init___());
  return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject($thiz, field, value$1)
}
function $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject($thiz, field, value) {
  var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, new $c_Lamf_core_parser_Annotations().init___());
  return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject($thiz, field, value$1)
}
function $f_Lamf_core_model_domain_AmfObject__replaceSlashes$1__pLamf_core_model_domain_AmfObject__T__T($thiz, value) {
  return (($uI(value.indexOf("//")) !== (-1)) ? $as_T(value.split("//").join("/")) : value)
}
function $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject($thiz, value) {
  var idx = $uI(value.indexOf("://"));
  if ((idx === (-1))) {
    var jsx$1 = $f_Lamf_core_model_domain_AmfObject__replaceSlashes$1__pLamf_core_model_domain_AmfObject__T__T($thiz, value)
  } else {
    var n = ((3 + idx) | 0);
    var jsx$2 = $as_T(value.substring(0, n));
    var value$1 = $as_T(value.substring(n));
    var jsx$1 = (("" + jsx$2) + $f_Lamf_core_model_domain_AmfObject__replaceSlashes$1__pLamf_core_model_domain_AmfObject__T__T($thiz, value$1))
  };
  $thiz.id$und$eq__T__V(jsx$1);
  return $thiz
}
function $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject($thiz, field, value) {
  var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, new $c_Lamf_core_parser_Annotations().init___());
  return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject($thiz, field, value$1)
}
function $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject($thiz, field, values) {
  $thiz.fields__Lamf_core_parser_Fields().set__T__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($thiz.id__T(), field, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(values, new $c_Lamf_core_parser_Annotations().init___()), ($thiz.fields__Lamf_core_parser_Fields(), $m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
  return $thiz
}
function $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject($thiz, field, values, annotations) {
  $thiz.fields__Lamf_core_parser_Fields().setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(field, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(values, new $c_Lamf_core_parser_Annotations().init___()), annotations);
  return $thiz
}
function $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject($thiz, field, values, annotations) {
  $thiz.fields__Lamf_core_parser_Fields().set__T__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($thiz.id__T(), field, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(values, new $c_Lamf_core_parser_Annotations().init___()), annotations);
  return $thiz
}
function $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject($thiz, field, values) {
  $thiz.fields__Lamf_core_parser_Fields().setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(field, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(values, new $c_Lamf_core_parser_Annotations().init___()), ($thiz.fields__Lamf_core_parser_Fields(), $m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
  return $thiz
}
function $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject($thiz, field, value) {
  $thiz.fields__Lamf_core_parser_Fields().set__T__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($thiz.id__T(), field, value, ($thiz.fields__Lamf_core_parser_Fields(), $m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
  return $thiz
}
function $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject($thiz, field, value) {
  $thiz.fields__Lamf_core_parser_Fields().add__T__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Fields($thiz.id__T(), field, value);
  return $thiz
}
function $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject($thiz, branch) {
  var x1 = branch.get__O__s_Option($thiz);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var me = $as_Lamf_core_model_domain_AmfObject(x2.value$2);
    if (($as_Lamf_core_vocabulary_ValueType(me.meta__Lamf_core_metamodel_Obj().type__sci_List().head__O()).iri__T() === $as_Lamf_core_vocabulary_ValueType($thiz.meta__Lamf_core_metamodel_Obj().type__sci_List().head__O()).iri__T())) {
      return me
    }
  };
  var obj = $as_Lamf_core_metamodel_ModelDefaultBuilder($thiz.meta__Lamf_core_metamodel_Obj()).modelInstance__Lamf_core_model_domain_AmfObject();
  obj.id$und$eq__T__V($thiz.id__T());
  obj.annotations__Lamf_core_parser_Annotations().$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations($thiz.annotations__Lamf_core_parser_Annotations());
  branch.put__O__O__s_Option($thiz, obj);
  $thiz.fields__Lamf_core_parser_Fields().cloneFields__scm_Map__Lamf_core_parser_Fields(branch).into__Lamf_core_parser_Fields__V(obj.fields__Lamf_core_parser_Fields());
  return obj
}
function $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject($thiz, field, value, annotations) {
  $thiz.fields__Lamf_core_parser_Fields().set__T__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($thiz.id__T(), field, value, annotations);
  return $thiz
}
function $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject($thiz, field, value) {
  var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, new $c_Lamf_core_parser_Annotations().init___());
  return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject($thiz, field, value$1)
}
function $is_Lamf_core_model_domain_AmfObject(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_domain_AmfObject)))
}
function $as_Lamf_core_model_domain_AmfObject(obj) {
  return (($is_Lamf_core_model_domain_AmfObject(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.AmfObject"))
}
function $isArrayOf_Lamf_core_model_domain_AmfObject(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_AmfObject)))
}
function $asArrayOf_Lamf_core_model_domain_AmfObject(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_AmfObject(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.AmfObject;", depth))
}
/** @constructor */
function $c_Lamf_core_model_domain_Annotation$() {
  $c_O.call(this)
}
$c_Lamf_core_model_domain_Annotation$.prototype = new $h_O();
$c_Lamf_core_model_domain_Annotation$.prototype.constructor = $c_Lamf_core_model_domain_Annotation$;
/** @constructor */
function $h_Lamf_core_model_domain_Annotation$() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_Annotation$.prototype = $c_Lamf_core_model_domain_Annotation$.prototype;
$c_Lamf_core_model_domain_Annotation$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_model_domain_Annotation$.prototype.unapply__T__s_Option = (function(annotation) {
  var x1 = $m_Lamf_core_registries_AMFDomainRegistry$().annotationsRegistry$1.get__O__s_Option(annotation);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var annotationLoader = $as_Lamf_core_model_domain_AnnotationGraphLoader(x2.value$2);
    return new $c_s_Some().init___O(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this, annotationLoader$1) {
      return (function(annotatedValue$2, objects$2) {
        var annotatedValue = $as_T(annotatedValue$2);
        var objects = $as_sci_Map(objects$2);
        return annotationLoader$1.unparse__T__sci_Map__s_Option(annotatedValue, objects)
      })
    })(this, annotationLoader)))
  } else {
    return $m_s_None$()
  }
});
var $d_Lamf_core_model_domain_Annotation$ = new $TypeData().initClass({
  Lamf_core_model_domain_Annotation$: 0
}, false, "amf.core.model.domain.Annotation$", {
  Lamf_core_model_domain_Annotation$: 1,
  O: 1
});
$c_Lamf_core_model_domain_Annotation$.prototype.$classData = $d_Lamf_core_model_domain_Annotation$;
var $n_Lamf_core_model_domain_Annotation$ = (void 0);
function $m_Lamf_core_model_domain_Annotation$() {
  if ((!$n_Lamf_core_model_domain_Annotation$)) {
    $n_Lamf_core_model_domain_Annotation$ = new $c_Lamf_core_model_domain_Annotation$().init___()
  };
  return $n_Lamf_core_model_domain_Annotation$
}
/** @constructor */
function $c_Lamf_core_model_domain_ArrayNode$() {
  $c_O.call(this);
  this.builderType$1 = null
}
$c_Lamf_core_model_domain_ArrayNode$.prototype = new $h_O();
$c_Lamf_core_model_domain_ArrayNode$.prototype.constructor = $c_Lamf_core_model_domain_ArrayNode$;
/** @constructor */
function $h_Lamf_core_model_domain_ArrayNode$() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_ArrayNode$.prototype = $c_Lamf_core_model_domain_ArrayNode$.prototype;
$c_Lamf_core_model_domain_ArrayNode$.prototype.init___ = (function() {
  $n_Lamf_core_model_domain_ArrayNode$ = this;
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
  this.builderType$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "Array");
  return this
});
var $d_Lamf_core_model_domain_ArrayNode$ = new $TypeData().initClass({
  Lamf_core_model_domain_ArrayNode$: 0
}, false, "amf.core.model.domain.ArrayNode$", {
  Lamf_core_model_domain_ArrayNode$: 1,
  O: 1
});
$c_Lamf_core_model_domain_ArrayNode$.prototype.$classData = $d_Lamf_core_model_domain_ArrayNode$;
var $n_Lamf_core_model_domain_ArrayNode$ = (void 0);
function $m_Lamf_core_model_domain_ArrayNode$() {
  if ((!$n_Lamf_core_model_domain_ArrayNode$)) {
    $n_Lamf_core_model_domain_ArrayNode$ = new $c_Lamf_core_model_domain_ArrayNode$().init___()
  };
  return $n_Lamf_core_model_domain_ArrayNode$
}
/** @constructor */
function $c_Lamf_core_model_domain_DataNodeOps$() {
  $c_O.call(this)
}
$c_Lamf_core_model_domain_DataNodeOps$.prototype = new $h_O();
$c_Lamf_core_model_domain_DataNodeOps$.prototype.constructor = $c_Lamf_core_model_domain_DataNodeOps$;
/** @constructor */
function $h_Lamf_core_model_domain_DataNodeOps$() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_DataNodeOps$.prototype = $c_Lamf_core_model_domain_DataNodeOps$.prototype;
$c_Lamf_core_model_domain_DataNodeOps$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_model_domain_DataNodeOps$.prototype.adoptTree__T__Lamf_core_model_domain_DataNode__Lamf_core_model_domain_DataNode = (function(id, node) {
  node.forceAdopted__T__Lamf_core_model_domain_DataNode(id);
  if ((node instanceof $c_Lamf_core_model_domain_ArrayNode)) {
    var x2 = $as_Lamf_core_model_domain_ArrayNode(node);
    $as_sc_Seq(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ArrayNodeModel$().Member$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x2$1) {
      return (function(x$2$2) {
        var x$2 = $as_Lamf_core_model_domain_DataNode(x$2$2);
        return $m_Lamf_core_model_domain_DataNodeOps$().adoptTree__T__Lamf_core_model_domain_DataNode__Lamf_core_model_domain_DataNode(x2$1.id$1, x$2)
      })
    })(this, x2)))
  } else if ((node instanceof $c_Lamf_core_model_domain_ObjectNode)) {
    var x3 = $as_Lamf_core_model_domain_ObjectNode(node);
    var jsx$2 = x3.propertyFields__sc_Iterable();
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, x3$1) {
      return (function(f$2) {
        var f = $as_Lamf_core_metamodel_Field(f$2);
        return $as_Lamf_core_model_domain_DataNode(x3$1.fields$2.field__Lamf_core_metamodel_Field__O(f))
      })
    })(this, x3));
    var this$1 = $m_sc_Iterable$();
    $as_sc_IterableLike(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3, x3$2) {
      return (function(e$2) {
        var e = $as_Lamf_core_model_domain_DataNode(e$2);
        return $m_Lamf_core_model_domain_DataNodeOps$().adoptTree__T__Lamf_core_model_domain_DataNode__Lamf_core_model_domain_DataNode(x3$2.id$1, e)
      })
    })(this, x3)))
  };
  return node
});
var $d_Lamf_core_model_domain_DataNodeOps$ = new $TypeData().initClass({
  Lamf_core_model_domain_DataNodeOps$: 0
}, false, "amf.core.model.domain.DataNodeOps$", {
  Lamf_core_model_domain_DataNodeOps$: 1,
  O: 1
});
$c_Lamf_core_model_domain_DataNodeOps$.prototype.$classData = $d_Lamf_core_model_domain_DataNodeOps$;
var $n_Lamf_core_model_domain_DataNodeOps$ = (void 0);
function $m_Lamf_core_model_domain_DataNodeOps$() {
  if ((!$n_Lamf_core_model_domain_DataNodeOps$)) {
    $n_Lamf_core_model_domain_DataNodeOps$ = new $c_Lamf_core_model_domain_DataNodeOps$().init___()
  };
  return $n_Lamf_core_model_domain_DataNodeOps$
}
/** @constructor */
function $c_Lamf_core_model_domain_LinkNode$() {
  $c_O.call(this);
  this.builderType$1 = null
}
$c_Lamf_core_model_domain_LinkNode$.prototype = new $h_O();
$c_Lamf_core_model_domain_LinkNode$.prototype.constructor = $c_Lamf_core_model_domain_LinkNode$;
/** @constructor */
function $h_Lamf_core_model_domain_LinkNode$() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_LinkNode$.prototype = $c_Lamf_core_model_domain_LinkNode$.prototype;
$c_Lamf_core_model_domain_LinkNode$.prototype.init___ = (function() {
  $n_Lamf_core_model_domain_LinkNode$ = this;
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
  this.builderType$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "Link");
  return this
});
$c_Lamf_core_model_domain_LinkNode$.prototype.apply__T__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_LinkNode = (function(alias, value, annotations) {
  var linkNode = new $c_Lamf_core_model_domain_LinkNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_core_metamodel_domain_LinkNodeModel$().Value$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(linkNode, field, value);
  var field$1 = $m_Lamf_core_metamodel_domain_LinkNodeModel$().Alias$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(linkNode, field$1, alias);
  return linkNode
});
var $d_Lamf_core_model_domain_LinkNode$ = new $TypeData().initClass({
  Lamf_core_model_domain_LinkNode$: 0
}, false, "amf.core.model.domain.LinkNode$", {
  Lamf_core_model_domain_LinkNode$: 1,
  O: 1
});
$c_Lamf_core_model_domain_LinkNode$.prototype.$classData = $d_Lamf_core_model_domain_LinkNode$;
var $n_Lamf_core_model_domain_LinkNode$ = (void 0);
function $m_Lamf_core_model_domain_LinkNode$() {
  if ((!$n_Lamf_core_model_domain_LinkNode$)) {
    $n_Lamf_core_model_domain_LinkNode$ = new $c_Lamf_core_model_domain_LinkNode$().init___()
  };
  return $n_Lamf_core_model_domain_LinkNode$
}
/** @constructor */
function $c_Lamf_core_model_domain_ObjectNode$() {
  $c_O.call(this);
  this.builderType$1 = null
}
$c_Lamf_core_model_domain_ObjectNode$.prototype = new $h_O();
$c_Lamf_core_model_domain_ObjectNode$.prototype.constructor = $c_Lamf_core_model_domain_ObjectNode$;
/** @constructor */
function $h_Lamf_core_model_domain_ObjectNode$() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_ObjectNode$.prototype = $c_Lamf_core_model_domain_ObjectNode$.prototype;
$c_Lamf_core_model_domain_ObjectNode$.prototype.init___ = (function() {
  $n_Lamf_core_model_domain_ObjectNode$ = this;
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
  this.builderType$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "Object");
  return this
});
var $d_Lamf_core_model_domain_ObjectNode$ = new $TypeData().initClass({
  Lamf_core_model_domain_ObjectNode$: 0
}, false, "amf.core.model.domain.ObjectNode$", {
  Lamf_core_model_domain_ObjectNode$: 1,
  O: 1
});
$c_Lamf_core_model_domain_ObjectNode$.prototype.$classData = $d_Lamf_core_model_domain_ObjectNode$;
var $n_Lamf_core_model_domain_ObjectNode$ = (void 0);
function $m_Lamf_core_model_domain_ObjectNode$() {
  if ((!$n_Lamf_core_model_domain_ObjectNode$)) {
    $n_Lamf_core_model_domain_ObjectNode$ = new $c_Lamf_core_model_domain_ObjectNode$().init___()
  };
  return $n_Lamf_core_model_domain_ObjectNode$
}
function $is_Lamf_core_model_domain_PerpetualAnnotation(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_domain_PerpetualAnnotation)))
}
function $as_Lamf_core_model_domain_PerpetualAnnotation(obj) {
  return (($is_Lamf_core_model_domain_PerpetualAnnotation(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.PerpetualAnnotation"))
}
function $isArrayOf_Lamf_core_model_domain_PerpetualAnnotation(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_PerpetualAnnotation)))
}
function $asArrayOf_Lamf_core_model_domain_PerpetualAnnotation(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_PerpetualAnnotation(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.PerpetualAnnotation;", depth))
}
/** @constructor */
function $c_Lamf_core_model_domain_RecursiveShape$() {
  $c_O.call(this)
}
$c_Lamf_core_model_domain_RecursiveShape$.prototype = new $h_O();
$c_Lamf_core_model_domain_RecursiveShape$.prototype.constructor = $c_Lamf_core_model_domain_RecursiveShape$;
/** @constructor */
function $h_Lamf_core_model_domain_RecursiveShape$() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_RecursiveShape$.prototype = $c_Lamf_core_model_domain_RecursiveShape$.prototype;
$c_Lamf_core_model_domain_RecursiveShape$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_model_domain_RecursiveShape$.prototype.apply__Lamf_core_model_domain_Shape__Lamf_core_model_domain_RecursiveShape = (function(shape) {
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var annotations = shape.annotations__Lamf_core_parser_Annotations();
  var qual$1 = new $c_Lamf_core_model_domain_RecursiveShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var this$2 = $as_Lamf_core_model_StrField(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
  var x$1 = $as_T((this$2.isEmpty__Z() ? "default-recursion" : this$2.get__O()));
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var qual$2 = $as_Lamf_core_model_domain_RecursiveShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, x$1, x$2));
  var x$3 = shape.id$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$5 = $as_Lamf_core_model_domain_Linkable($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$2, x$3));
  var this$4 = $as_Lamf_core_model_BoolField(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1));
  var recursive = $f_Lamf_core_model_BoolField__value__Z(this$4);
  var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1;
  var this$6 = $as_Lamf_core_model_domain_RecursiveShape($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$5, field, recursive)));
  var shapeId = shape.id$1;
  var field$1 = $m_Lamf_core_metamodel_domain_RecursiveShapeModel$().FixPoint$1;
  return $as_Lamf_core_model_domain_RecursiveShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$6, field$1, shapeId)).withFixpointTarget__Lamf_core_model_domain_Shape__Lamf_core_model_domain_RecursiveShape(shape)
});
$c_Lamf_core_model_domain_RecursiveShape$.prototype.apply__Lamf_core_model_domain_Linkable__Lamf_core_model_domain_RecursiveShape = (function(l) {
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var annotations = l.annotations__Lamf_core_parser_Annotations();
  var qual$1 = new $c_Lamf_core_model_domain_RecursiveShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var x$1 = l.id__T();
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$3 = $as_Lamf_core_model_domain_Linkable($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
  var this$2 = $as_Lamf_core_model_BoolField(l.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1));
  var recursive = $f_Lamf_core_model_BoolField__value__Z(this$2);
  var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1;
  var this$4 = $as_Lamf_core_model_domain_RecursiveShape($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$3, field, recursive)));
  var shapeId = l.id__T();
  var field$1 = $m_Lamf_core_metamodel_domain_RecursiveShapeModel$().FixPoint$1;
  return $as_Lamf_core_model_domain_RecursiveShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field$1, shapeId)).withFixpointTarget__Lamf_core_model_domain_Shape__Lamf_core_model_domain_RecursiveShape($as_Lamf_core_model_domain_Shape(l.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(l.effectiveLinkTarget$default$1__sc_Seq())))
});
var $d_Lamf_core_model_domain_RecursiveShape$ = new $TypeData().initClass({
  Lamf_core_model_domain_RecursiveShape$: 0
}, false, "amf.core.model.domain.RecursiveShape$", {
  Lamf_core_model_domain_RecursiveShape$: 1,
  O: 1
});
$c_Lamf_core_model_domain_RecursiveShape$.prototype.$classData = $d_Lamf_core_model_domain_RecursiveShape$;
var $n_Lamf_core_model_domain_RecursiveShape$ = (void 0);
function $m_Lamf_core_model_domain_RecursiveShape$() {
  if ((!$n_Lamf_core_model_domain_RecursiveShape$)) {
    $n_Lamf_core_model_domain_RecursiveShape$ = new $c_Lamf_core_model_domain_RecursiveShape$().init___()
  };
  return $n_Lamf_core_model_domain_RecursiveShape$
}
function $is_Lamf_core_model_domain_ResolvableAnnotation(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_domain_ResolvableAnnotation)))
}
function $as_Lamf_core_model_domain_ResolvableAnnotation(obj) {
  return (($is_Lamf_core_model_domain_ResolvableAnnotation(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.ResolvableAnnotation"))
}
function $isArrayOf_Lamf_core_model_domain_ResolvableAnnotation(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_ResolvableAnnotation)))
}
function $asArrayOf_Lamf_core_model_domain_ResolvableAnnotation(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_ResolvableAnnotation(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.ResolvableAnnotation;", depth))
}
/** @constructor */
function $c_Lamf_core_model_domain_ScalarNode$() {
  $c_O.call(this);
  this.string$1 = null;
  this.integer$1 = null;
  this.number$1 = null;
  this.long$1 = null;
  this.double$1 = null;
  this.float$1 = null;
  this.decimal$1 = null;
  this.boolean$1 = null;
  this.date$1 = null;
  this.time$1 = null;
  this.dateTime$1 = null;
  this.dateTimeOnly$1 = null;
  this.file$1 = null;
  this.byte$1 = null;
  this.base64Binary$1 = null;
  this.password$1 = null;
  this.anyType$1 = null;
  this.anyURI$1 = null;
  this.nil$1 = null
}
$c_Lamf_core_model_domain_ScalarNode$.prototype = new $h_O();
$c_Lamf_core_model_domain_ScalarNode$.prototype.constructor = $c_Lamf_core_model_domain_ScalarNode$;
/** @constructor */
function $h_Lamf_core_model_domain_ScalarNode$() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_ScalarNode$.prototype = $c_Lamf_core_model_domain_ScalarNode$.prototype;
$c_Lamf_core_model_domain_ScalarNode$.prototype.init___ = (function() {
  $n_Lamf_core_model_domain_ScalarNode$ = this;
  this.string$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_core_model_DataType$().String$1, $m_Lamf_core_parser_Annotations$().empty$1);
  this.integer$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_core_model_DataType$().Integer$1, $m_Lamf_core_parser_Annotations$().empty$1);
  this.number$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_core_model_DataType$().Number$1, $m_Lamf_core_parser_Annotations$().empty$1);
  this.long$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_core_model_DataType$().Long$1, $m_Lamf_core_parser_Annotations$().empty$1);
  this.double$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_core_model_DataType$().Double$1, $m_Lamf_core_parser_Annotations$().empty$1);
  this.float$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_core_model_DataType$().Float$1, $m_Lamf_core_parser_Annotations$().empty$1);
  this.decimal$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_core_model_DataType$().Decimal$1, $m_Lamf_core_parser_Annotations$().empty$1);
  this.boolean$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_core_model_DataType$().Boolean$1, $m_Lamf_core_parser_Annotations$().empty$1);
  this.date$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_core_model_DataType$().Date$1, $m_Lamf_core_parser_Annotations$().empty$1);
  this.time$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_core_model_DataType$().Time$1, $m_Lamf_core_parser_Annotations$().empty$1);
  this.dateTime$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_core_model_DataType$().DateTime$1, $m_Lamf_core_parser_Annotations$().empty$1);
  this.dateTimeOnly$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_core_model_DataType$().DateTimeOnly$1, $m_Lamf_core_parser_Annotations$().empty$1);
  this.file$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_core_model_DataType$().File$1, $m_Lamf_core_parser_Annotations$().empty$1);
  this.byte$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_core_model_DataType$().Byte$1, $m_Lamf_core_parser_Annotations$().empty$1);
  this.base64Binary$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_core_model_DataType$().Binary$1, $m_Lamf_core_parser_Annotations$().empty$1);
  this.password$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_core_model_DataType$().Password$1, $m_Lamf_core_parser_Annotations$().empty$1);
  this.anyType$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_core_model_DataType$().Any$1, $m_Lamf_core_parser_Annotations$().empty$1);
  this.anyURI$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_core_model_DataType$().AnyUri$1, $m_Lamf_core_parser_Annotations$().empty$1);
  this.nil$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_core_model_DataType$().Nil$1, $m_Lamf_core_parser_Annotations$().empty$1);
  return this
});
$c_Lamf_core_model_domain_ScalarNode$.prototype.apply__T__s_Option__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode = (function(value, dataType, annotations) {
  var scalar = new $c_Lamf_core_model_domain_ScalarNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  if ((!dataType.isEmpty__Z())) {
    var arg1 = dataType.get__O();
    var d = $as_T(arg1);
    annotations.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ScalarType().init___T(d));
    scalar.withDataType__T__Lamf_core_model_domain_ScalarNode(d)
  };
  var field = $m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1;
  var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, annotations);
  return $as_Lamf_core_model_domain_ScalarNode($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(scalar, field, value$1))
});
$c_Lamf_core_model_domain_ScalarNode$.prototype.forDataType__T__Lamf_core_model_domain_AmfScalar = (function(dataTypeUri) {
  return (($m_Lamf_core_model_DataType$().String$1 === dataTypeUri) ? this.string$1 : (($m_Lamf_core_model_DataType$().Integer$1 === dataTypeUri) ? this.integer$1 : (($m_Lamf_core_model_DataType$().Number$1 === dataTypeUri) ? this.number$1 : (($m_Lamf_core_model_DataType$().Long$1 === dataTypeUri) ? this.long$1 : (($m_Lamf_core_model_DataType$().Double$1 === dataTypeUri) ? this.double$1 : (($m_Lamf_core_model_DataType$().Float$1 === dataTypeUri) ? this.float$1 : (($m_Lamf_core_model_DataType$().Decimal$1 === dataTypeUri) ? this.decimal$1 : (($m_Lamf_core_model_DataType$().Boolean$1 === dataTypeUri) ? this.boolean$1 : (($m_Lamf_core_model_DataType$().Date$1 === dataTypeUri) ? this.date$1 : (($m_Lamf_core_model_DataType$().Time$1 === dataTypeUri) ? this.time$1 : (($m_Lamf_core_model_DataType$().DateTime$1 === dataTypeUri) ? this.dateTime$1 : (($m_Lamf_core_model_DataType$().DateTimeOnly$1 === dataTypeUri) ? this.dateTimeOnly$1 : (($m_Lamf_core_model_DataType$().File$1 === dataTypeUri) ? this.file$1 : (($m_Lamf_core_model_DataType$().Byte$1 === dataTypeUri) ? this.byte$1 : (($m_Lamf_core_model_DataType$().Binary$1 === dataTypeUri) ? this.base64Binary$1 : (($m_Lamf_core_model_DataType$().Password$1 === dataTypeUri) ? this.password$1 : (($m_Lamf_core_model_DataType$().Any$1 === dataTypeUri) ? this.anyType$1 : (($m_Lamf_core_model_DataType$().AnyUri$1 === dataTypeUri) ? this.anyURI$1 : (($m_Lamf_core_model_DataType$().Nil$1 === dataTypeUri) ? this.nil$1 : new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(dataTypeUri, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___())))))))))))))))))))))
});
var $d_Lamf_core_model_domain_ScalarNode$ = new $TypeData().initClass({
  Lamf_core_model_domain_ScalarNode$: 0
}, false, "amf.core.model.domain.ScalarNode$", {
  Lamf_core_model_domain_ScalarNode$: 1,
  O: 1
});
$c_Lamf_core_model_domain_ScalarNode$.prototype.$classData = $d_Lamf_core_model_domain_ScalarNode$;
var $n_Lamf_core_model_domain_ScalarNode$ = (void 0);
function $m_Lamf_core_model_domain_ScalarNode$() {
  if ((!$n_Lamf_core_model_domain_ScalarNode$)) {
    $n_Lamf_core_model_domain_ScalarNode$ = new $c_Lamf_core_model_domain_ScalarNode$().init___()
  };
  return $n_Lamf_core_model_domain_ScalarNode$
}
function $is_Lamf_core_model_domain_SerializableAnnotation(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_domain_SerializableAnnotation)))
}
function $as_Lamf_core_model_domain_SerializableAnnotation(obj) {
  return (($is_Lamf_core_model_domain_SerializableAnnotation(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.SerializableAnnotation"))
}
function $isArrayOf_Lamf_core_model_domain_SerializableAnnotation(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_SerializableAnnotation)))
}
function $asArrayOf_Lamf_core_model_domain_SerializableAnnotation(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_SerializableAnnotation(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.SerializableAnnotation;", depth))
}
/** @constructor */
function $c_Lamf_core_parser_Annotations() {
  $c_O.call(this);
  this.amf$core$parser$Annotations$$annotations$1 = null
}
$c_Lamf_core_parser_Annotations.prototype = new $h_O();
$c_Lamf_core_parser_Annotations.prototype.constructor = $c_Lamf_core_parser_Annotations;
/** @constructor */
function $h_Lamf_core_parser_Annotations() {
  /*<skip>*/
}
$h_Lamf_core_parser_Annotations.prototype = $c_Lamf_core_parser_Annotations.prototype;
$c_Lamf_core_parser_Annotations.prototype.init___ = (function() {
  this.amf$core$parser$Annotations$$annotations$1 = new $c_scm_ListBuffer().init___();
  return this
});
$c_Lamf_core_parser_Annotations.prototype.$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations = (function(other) {
  return this.$$plus$plus$eq__sc_TraversableOnce__Lamf_core_parser_Annotations(other.amf$core$parser$Annotations$$annotations$1)
});
$c_Lamf_core_parser_Annotations.prototype.reject__F1__Lamf_core_parser_Annotations = (function(p) {
  var this$1 = this.amf$core$parser$Annotations$$annotations$1;
  var f = (function($this, p$1) {
    return (function(a$2) {
      var a = $as_Lamf_core_model_domain_Annotation(a$2);
      return (!$uZ(p$1.apply__O__O(a)))
    })
  })(this, p);
  if ((this$1 instanceof $c_sci_List)) {
    var x2 = $as_sci_List(this$1);
    var l = x2;
    var l$1 = l;
    x: {
      var result;
      _noneIn: while (true) {
        if (l$1.isEmpty__Z()) {
          var result = $m_sci_Nil$();
          break
        } else {
          var h = l$1.head__O();
          var t = $as_sci_List(l$1.tail__O());
          if (($uZ(f(h)) === false)) {
            l$1 = t;
            continue _noneIn
          };
          var start = l$1;
          var remaining = t;
          var remaining$1 = remaining;
          _allIn: while (true) {
            if (remaining$1.isEmpty__Z()) {
              var result = start;
              break x
            } else {
              var x$2 = remaining$1.head__O();
              if (($uZ(f(x$2)) !== false)) {
                remaining$1 = $as_sci_List(remaining$1.tail__O());
                continue _allIn
              };
              var firstMiss = remaining$1;
              var newHead = new $c_sci_$colon$colon().init___O__sci_List(start.head__O(), $m_sci_Nil$());
              var toProcess = $as_sci_List(start.tail__O());
              var currentLast = newHead;
              while ((toProcess !== firstMiss)) {
                var newElem = new $c_sci_$colon$colon().init___O__sci_List(toProcess.head__O(), $m_sci_Nil$());
                currentLast.tl$5 = newElem;
                currentLast = newElem;
                toProcess = $as_sci_List(toProcess.tail__O())
              };
              var next = $as_sci_List(firstMiss.tail__O());
              var nextToCopy = next;
              while ((!next.isEmpty__Z())) {
                var head = next.head__O();
                if (($uZ(f(head)) !== false)) {
                  next = $as_sci_List(next.tail__O())
                } else {
                  while ((nextToCopy !== next)) {
                    var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy.head__O(), $m_sci_Nil$());
                    currentLast.tl$5 = newElem$2;
                    currentLast = newElem$2;
                    nextToCopy = $as_sci_List(nextToCopy.tail__O())
                  };
                  nextToCopy = $as_sci_List(next.tail__O());
                  next = $as_sci_List(next.tail__O())
                }
              };
              if ((!nextToCopy.isEmpty__Z())) {
                currentLast.tl$5 = nextToCopy
              };
              var result = newHead;
              break x
            }
          }
        }
      }
    };
    var jsx$1 = result
  } else {
    $m_scm_ListBuffer$();
    var b = new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_ListBuffer().init___());
    var this$3 = this$1.scala$collection$mutable$ListBuffer$$start$6;
    var these = this$3;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      if (($uZ(f(arg1)) !== false)) {
        b.$$plus$eq__O__scm_GrowingBuilder(arg1)
      };
      these = $as_sci_List(these.tail__O())
    };
    var jsx$1 = b.elems$1
  };
  this.amf$core$parser$Annotations$$annotations$1 = $as_scm_ListBuffer(jsx$1);
  return this
});
$c_Lamf_core_parser_Annotations.prototype.contains__jl_Class__Z = (function(clazz) {
  var this$1 = this.amf$core$parser$Annotations$$annotations$1;
  var this$2 = this$1.scala$collection$mutable$ListBuffer$$start$6;
  var these = this$2;
  while ((!these.isEmpty__Z())) {
    var arg1 = these.head__O();
    var x$3 = $as_Lamf_core_model_domain_Annotation(arg1);
    if (clazz.isInstance__O__Z(x$3)) {
      return true
    };
    these = $as_sc_LinearSeqOptimized(these.tail__O())
  };
  return false
});
$c_Lamf_core_parser_Annotations.prototype.find__jl_Class__s_Option = (function(clazz) {
  var this$1 = this.amf$core$parser$Annotations$$annotations$1;
  var this$2 = this$1.scala$collection$mutable$ListBuffer$$start$6;
  inlinereturn$6: {
    var these = this$2;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      var x$2 = $as_Lamf_core_model_domain_Annotation(arg1);
      if (clazz.isInstance__O__Z(x$2)) {
        var this$3 = new $c_s_Some().init___O(these.head__O());
        break inlinereturn$6
      };
      these = $as_sc_LinearSeqOptimized(these.tail__O())
    };
    var this$3 = $m_s_None$()
  };
  if (this$3.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1$1 = this$3.get__O();
    var x$1 = $as_Lamf_core_model_domain_Annotation(arg1$1);
    return new $c_s_Some().init___O(x$1)
  }
});
$c_Lamf_core_parser_Annotations.prototype.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations = (function(annotation) {
  this.amf$core$parser$Annotations$$annotations$1.$$plus$eq__O__scm_ListBuffer(annotation);
  return this
});
$c_Lamf_core_parser_Annotations.prototype.$$plus$plus$eq__sc_TraversableOnce__Lamf_core_parser_Annotations = (function(other) {
  this.amf$core$parser$Annotations$$annotations$1.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(other);
  return this
});
$c_Lamf_core_parser_Annotations.prototype.serializables__sc_Seq = (function() {
  var pf = new $c_Lamf_core_parser_Annotations$$anonfun$serializables$1().init___Lamf_core_parser_Annotations(this);
  var this$2 = this.amf$core$parser$Annotations$$annotations$1;
  var this$1 = $m_scm_ListBuffer$();
  var bf = this$1.ReusableCBFInstance$2;
  return $as_sc_Seq($f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this$2, pf, bf))
});
$c_Lamf_core_parser_Annotations.prototype.eternals__sc_Seq = (function() {
  var pf = new $c_Lamf_core_parser_Annotations$$anonfun$eternals$1().init___Lamf_core_parser_Annotations(this);
  var this$2 = this.amf$core$parser$Annotations$$annotations$1;
  var this$1 = $m_scm_ListBuffer$();
  var bf = this$1.ReusableCBFInstance$2;
  return $as_sc_Seq($f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this$2, pf, bf))
});
$c_Lamf_core_parser_Annotations.prototype.sourceLocation__Lorg_mulesoft_lexer_SourceLocation = (function() {
  var this$1 = this.find__jl_Class__s_Option($d_Lamf_core_annotations_SourceLocation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$4 = $as_Lamf_core_annotations_SourceLocation(arg1);
    var this$2 = new $c_s_Some().init___O(x$4.location$1)
  };
  var sourceName = $as_T((this$2.isEmpty__Z() ? "" : this$2.get__O()));
  var this$3 = this.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  if (this$3.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1$1 = this$3.get__O();
    var r = $as_Lamf_core_annotations_LexicalInformation(arg1$1);
    var this$4 = new $c_s_Some().init___O($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(r.range__Lamf_core_parser_Range().start$1.line$1, r.range__Lamf_core_parser_Range().start$1.column$1, r.range__Lamf_core_parser_Range().end$1.line$1, r.range__Lamf_core_parser_Range().end$1.column$1))
  };
  var range = $as_Lorg_mulesoft_lexer_InputRange((this$4.isEmpty__Z() ? $m_Lorg_mulesoft_lexer_InputRange$().Zero$1 : this$4.get__O()));
  $m_Lorg_mulesoft_lexer_SourceLocation$();
  return new $c_Lorg_mulesoft_lexer_SourceLocation().init___T__I__I__I__I__I__I(sourceName, 0, 0, range.lineFrom$1, range.columnFrom$1, range.lineTo$1, range.columnTo$1)
});
function $as_Lamf_core_parser_Annotations(obj) {
  return (((obj instanceof $c_Lamf_core_parser_Annotations) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.Annotations"))
}
function $isArrayOf_Lamf_core_parser_Annotations(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_Annotations)))
}
function $asArrayOf_Lamf_core_parser_Annotations(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_Annotations(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.Annotations;", depth))
}
var $d_Lamf_core_parser_Annotations = new $TypeData().initClass({
  Lamf_core_parser_Annotations: 0
}, false, "amf.core.parser.Annotations", {
  Lamf_core_parser_Annotations: 1,
  O: 1
});
$c_Lamf_core_parser_Annotations.prototype.$classData = $d_Lamf_core_parser_Annotations;
/** @constructor */
function $c_Lamf_core_parser_Annotations$() {
  $c_O.call(this);
  this.empty$1 = null
}
$c_Lamf_core_parser_Annotations$.prototype = new $h_O();
$c_Lamf_core_parser_Annotations$.prototype.constructor = $c_Lamf_core_parser_Annotations$;
/** @constructor */
function $h_Lamf_core_parser_Annotations$() {
  /*<skip>*/
}
$h_Lamf_core_parser_Annotations$.prototype = $c_Lamf_core_parser_Annotations$.prototype;
$c_Lamf_core_parser_Annotations$.prototype.init___ = (function() {
  $n_Lamf_core_parser_Annotations$ = this;
  this.empty$1 = new $c_Lamf_core_parser_Annotations$$anon$1().init___();
  return this
});
$c_Lamf_core_parser_Annotations$.prototype.apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations = (function(ast) {
  var jsx$3 = new $c_Lamf_core_parser_Annotations().init___();
  var jsx$1 = $m_Lamf_core_parser_Range$();
  var this$1 = ast.location$1;
  var array = [new $c_Lamf_core_annotations_LexicalInformation().init___Lamf_core_parser_Range(jsx$1.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$1.lineFrom$1, this$1.columnFrom$1, this$1.lineTo$1, this$1.columnTo$1))), new $c_Lamf_core_annotations_SourceAST().init___Lorg_yaml_model_YPart(ast), new $c_Lamf_core_annotations_SourceLocation().init___T(ast.location$1.sourceName$1)];
  if (($uI(array.length) === 0)) {
    var jsx$2 = $m_sci_Set$EmptySet$()
  } else {
    var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      b.$$plus$eq__O__scm_SetBuilder(arg1);
      i = ((1 + i) | 0)
    };
    var jsx$2 = b.elems$1
  };
  var annotations = jsx$3.$$plus$plus$eq__sc_TraversableOnce__Lamf_core_parser_Annotations($as_sc_TraversableOnce(jsx$2));
  if ((ast instanceof $c_Lorg_yaml_model_YNode)) {
    var x2 = $as_Lorg_yaml_model_YNode(ast);
    return annotations.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SourceNode().init___Lorg_yaml_model_YNode(x2))
  } else if ((ast instanceof $c_Lorg_yaml_model_YMapEntry)) {
    var x3 = $as_Lorg_yaml_model_YMapEntry(ast);
    return annotations.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SourceNode().init___Lorg_yaml_model_YNode(x3.value$2))
  } else {
    return annotations
  }
});
$c_Lamf_core_parser_Annotations$.prototype.apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations = (function(annotations) {
  var result = new $c_Lamf_core_parser_Annotations().init___();
  result.amf$core$parser$Annotations$$annotations$1.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(annotations.amf$core$parser$Annotations$$annotations$1);
  return result
});
$c_Lamf_core_parser_Annotations$.prototype.valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations = (function(node) {
  return this.apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(node.value__Lorg_yaml_model_YValue()).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SourceNode().init___Lorg_yaml_model_YNode(node))
});
var $d_Lamf_core_parser_Annotations$ = new $TypeData().initClass({
  Lamf_core_parser_Annotations$: 0
}, false, "amf.core.parser.Annotations$", {
  Lamf_core_parser_Annotations$: 1,
  O: 1
});
$c_Lamf_core_parser_Annotations$.prototype.$classData = $d_Lamf_core_parser_Annotations$;
var $n_Lamf_core_parser_Annotations$ = (void 0);
function $m_Lamf_core_parser_Annotations$() {
  if ((!$n_Lamf_core_parser_Annotations$)) {
    $n_Lamf_core_parser_Annotations$ = new $c_Lamf_core_parser_Annotations$().init___()
  };
  return $n_Lamf_core_parser_Annotations$
}
/** @constructor */
function $c_Lamf_core_parser_Declarations() {
  $c_O.call(this);
  this.ErrorCustomDomainProperty$module$1 = null;
  this.libraries$1 = null;
  this.fragments$1 = null;
  this.annotations$1 = null;
  this.errorHandler$1 = null;
  this.futureDeclarations$1 = null;
  this.promotedFragments$1 = null
}
$c_Lamf_core_parser_Declarations.prototype = new $h_O();
$c_Lamf_core_parser_Declarations.prototype.constructor = $c_Lamf_core_parser_Declarations;
/** @constructor */
function $h_Lamf_core_parser_Declarations() {
  /*<skip>*/
}
$h_Lamf_core_parser_Declarations.prototype = $c_Lamf_core_parser_Declarations.prototype;
$c_Lamf_core_parser_Declarations.prototype.findEquivalent__Lamf_core_model_domain_DomainElement__s_Option = (function(element) {
  if ((element instanceof $c_Lamf_core_model_domain_extensions_CustomDomainProperty)) {
    var x2 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(element);
    var this$1 = $as_Lamf_core_model_StrField(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Name$1));
    var this$2 = this$1.option$1;
    return this.findAnnotation__T__Lamf_core_parser_SearchScope$Scope__s_Option($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())), $m_Lamf_core_parser_SearchScope$All$())
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_core_parser_Declarations.prototype.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_core_parser_Declarations = (function(element) {
  if ((element instanceof $c_Lamf_core_model_domain_extensions_CustomDomainProperty)) {
    var x2 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(element);
    var jsx$1 = this.annotations$1;
    var this$1 = $as_Lamf_core_model_StrField(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Name$1));
    var this$2 = this$1.option$1;
    var self = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
    this.annotations$1 = jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, x2))
  } else {
    throw new $c_s_MatchError().init___O(element)
  };
  return this
});
$c_Lamf_core_parser_Declarations.prototype.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, map, scope) {
  var x = $m_Lamf_core_parser_SearchScope$All$();
  if ((x === scope)) {
    var this$1 = this.inRef$1__p1__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, map, scope);
    if (this$1.isEmpty__Z()) {
      var this$2 = this.fragments$1.get__O__s_Option(key);
      if (this$2.isEmpty__Z()) {
        return $m_s_None$()
      } else {
        var arg1 = this$2.get__O();
        var x$3 = $as_Lamf_core_parser_FragmentRef(arg1);
        return new $c_s_Some().init___O(x$3.encoded$1)
      }
    } else {
      return this$1
    }
  } else {
    var x$3$1 = $m_Lamf_core_parser_SearchScope$Fragments$();
    if ((x$3$1 === scope)) {
      var this$3 = this.fragments$1.get__O__s_Option(key);
      if (this$3.isEmpty__Z()) {
        return $m_s_None$()
      } else {
        var arg1$1 = this$3.get__O();
        var x$4$2 = $as_Lamf_core_parser_FragmentRef(arg1$1);
        return new $c_s_Some().init___O(x$4$2.encoded$1)
      }
    } else {
      var x$5 = $m_Lamf_core_parser_SearchScope$Named$();
      if ((x$5 === scope)) {
        return this.inRef$1__p1__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, map, scope)
      } else {
        throw new $c_s_MatchError().init___O(scope)
      }
    }
  }
});
$c_Lamf_core_parser_Declarations.prototype.error__T__Lorg_yaml_model_YPart__V = (function(message, ast) {
  var this$1 = this.errorHandler$1;
  var specification = $m_Lamf_plugins_features_validation_CoreValidations$().DeclarationNotFound$1;
  var prop = $m_s_None$();
  var l = ast.location$1;
  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, "", prop, message, l)
});
$c_Lamf_core_parser_Declarations.prototype.declarables__sc_Seq = (function() {
  var this$1 = this.annotations$1;
  var this$2 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$1);
  return this$2.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream()
});
$c_Lamf_core_parser_Declarations.prototype.findAnnotation__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, scope) {
  var this$1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_parser_Declarations(x$1$2);
      return x$1.annotations$1
    })
  })(this)), scope);
  var pf = new $c_Lamf_core_parser_Declarations$$anonfun$findAnnotation$2().init___Lamf_core_parser_Declarations(this);
  if ((!this$1.isEmpty__Z())) {
    var this$2 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$1.get__O();
    return this$2.apply__O__s_Option(v1)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_core_parser_Declarations.prototype.init___sci_Map__sci_Map__sci_Map__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations = (function(libraries, fragments, annotations, errorHandler, futureDeclarations) {
  this.libraries$1 = libraries;
  this.fragments$1 = fragments;
  this.annotations$1 = annotations;
  this.errorHandler$1 = errorHandler;
  this.futureDeclarations$1 = futureDeclarations;
  this.promotedFragments$1 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  return this
});
$c_Lamf_core_parser_Declarations.prototype.inRef$1__p1__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key$1, map$1, scope$1) {
  var fqn = $m_Lamf_core_utils_package$QName$().apply__T__Lamf_core_utils_package$QName(key$1);
  if (fqn.isQualified$1) {
    var this$1 = this.libraries$1.get__O__s_Option(fqn.qualification$1);
    if (this$1.isEmpty__Z()) {
      var result = $m_s_None$()
    } else {
      var arg1 = this$1.get__O();
      var x$2 = $as_Lamf_core_parser_Declarations(arg1);
      var result = x$2.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(fqn.name$1, map$1, scope$1)
    }
  } else {
    var result = $m_s_None$()
  };
  return (result.isEmpty__Z() ? $as_sc_MapLike(map$1.apply__O__O(this)).get__O__s_Option(key$1) : result)
});
function $as_Lamf_core_parser_Declarations(obj) {
  return (((obj instanceof $c_Lamf_core_parser_Declarations) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.Declarations"))
}
function $isArrayOf_Lamf_core_parser_Declarations(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_Declarations)))
}
function $asArrayOf_Lamf_core_parser_Declarations(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_Declarations(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.Declarations;", depth))
}
/** @constructor */
function $c_Lamf_core_parser_Fields() {
  $c_O.call(this);
  this.StrFieldImpl$module$1 = null;
  this.BoolFieldImpl$module$1 = null;
  this.IntFieldImpl$module$1 = null;
  this.DoubleFieldImpl$module$1 = null;
  this.AnyFieldImpl$module$1 = null;
  this.fs$1 = null
}
$c_Lamf_core_parser_Fields.prototype = new $h_O();
$c_Lamf_core_parser_Fields.prototype.constructor = $c_Lamf_core_parser_Fields;
/** @constructor */
function $h_Lamf_core_parser_Fields() {
  /*<skip>*/
}
$h_Lamf_core_parser_Fields.prototype = $c_Lamf_core_parser_Fields.prototype;
$c_Lamf_core_parser_Fields.prototype.set__T__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields = (function(id, field, value, annotations) {
  if ((field.value$1.iri__T() === "http://a.ml/vocabularies/document#declares")) {
    this.adopt__p1__T__Lamf_core_model_domain_AmfElement__V((id + "#/declarations"), value)
  } else {
    this.adopt__p1__T__Lamf_core_model_domain_AmfElement__V(id, value)
  };
  var jsx$1 = this.fs$1;
  var y = new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value, annotations);
  this.fs$1 = jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(field, y));
  return this
});
$c_Lamf_core_parser_Fields.prototype.$$qmark__Lamf_core_metamodel_Field__s_Option = (function(field) {
  var this$1 = this.fs$1.get__O__s_Option(field);
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$5 = $as_Lamf_core_parser_Value(arg1);
    return new $c_s_Some().init___O(x$5.value$1)
  }
});
$c_Lamf_core_parser_Fields.prototype.init___ = (function() {
  this.fs$1 = $as_sci_Map($m_sci_ListMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  return this
});
$c_Lamf_core_parser_Fields.prototype.typed$1__p1__Lamf_core_metamodel_Type__Lamf_core_model_domain_AmfElement__Lamf_core_metamodel_Field__O = (function(t, e, f$1) {
  if ((e instanceof $c_Lamf_core_model_domain_AmfScalar)) {
    var x2 = $as_Lamf_core_model_domain_AmfScalar(e);
    var x = $m_Lamf_core_metamodel_Type$Str$();
    if (x.equals__O__Z(t)) {
      var jsx$1 = true
    } else {
      var x$3 = $m_Lamf_core_metamodel_Type$Iri$();
      var jsx$1 = x$3.equals__O__Z(t)
    };
    if (jsx$1) {
      return new $c_Lamf_core_parser_Fields$StrFieldImpl().init___Lamf_core_parser_Fields__Lamf_core_model_domain_AmfScalar__Lamf_core_metamodel_Field(this, x2, f$1)
    } else {
      var x$5 = $m_Lamf_core_metamodel_Type$Bool$();
      if (x$5.equals__O__Z(t)) {
        return new $c_Lamf_core_parser_Fields$BoolFieldImpl().init___Lamf_core_parser_Fields__Lamf_core_model_domain_AmfScalar__Lamf_core_metamodel_Field(this, x2, f$1)
      } else {
        var x$7 = $m_Lamf_core_metamodel_Type$Int$();
        if (x$7.equals__O__Z(t)) {
          return new $c_Lamf_core_parser_Fields$IntFieldImpl().init___Lamf_core_parser_Fields__Lamf_core_model_domain_AmfScalar__Lamf_core_metamodel_Field(this, x2, f$1)
        } else {
          var x$9 = $m_Lamf_core_metamodel_Type$Float$();
          if (x$9.equals__O__Z(t)) {
            return new $c_Lamf_core_parser_Fields$DoubleFieldImpl().init___Lamf_core_parser_Fields__Lamf_core_model_domain_AmfScalar__Lamf_core_metamodel_Field(this, x2, f$1)
          } else {
            var x$11 = $m_Lamf_core_metamodel_Type$Double$();
            if (x$11.equals__O__Z(t)) {
              return new $c_Lamf_core_parser_Fields$DoubleFieldImpl().init___Lamf_core_parser_Fields__Lamf_core_model_domain_AmfScalar__Lamf_core_metamodel_Field(this, x2, f$1)
            } else {
              var x$13 = $m_Lamf_core_metamodel_Type$Any$();
              if ((x$13 === t)) {
                return new $c_Lamf_core_parser_Fields$AnyFieldImpl().init___Lamf_core_parser_Fields__Lamf_core_model_domain_AmfScalar__Lamf_core_metamodel_Field(this, x2, f$1)
              } else {
                throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T((((("Invalid value '" + x2) + "' of type '") + t) + "'")))
              }
            }
          }
        }
      }
    }
  } else if ($is_Lamf_core_model_domain_AmfObject(e)) {
    var x3 = $as_Lamf_core_model_domain_AmfObject(e);
    if ($is_Lamf_core_metamodel_Obj(t)) {
      return x3
    } else {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T((((("Invalid value '" + x3) + "' of type '") + t) + "'")))
    }
  } else if ((e instanceof $c_Lamf_core_model_domain_AmfArray)) {
    var x4 = $as_Lamf_core_model_domain_AmfArray(e);
    if ((t instanceof $c_Lamf_core_metamodel_Type$ArrayLike)) {
      var x2$2 = $as_Lamf_core_metamodel_Type$ArrayLike(t);
      var o8 = new $c_s_Some().init___O(x2$2.element__Lamf_core_metamodel_Type());
      var element = $as_Lamf_core_metamodel_Type(o8.value$2);
      var jsx$3 = x4.values$1;
      var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, element$1, f$1$1) {
        return (function(x$3$2$2) {
          var x$3$2 = $as_Lamf_core_model_domain_AmfElement(x$3$2$2);
          return $this.typed$1__p1__Lamf_core_metamodel_Type__Lamf_core_model_domain_AmfElement__Lamf_core_metamodel_Field__O(element$1, x$3$2, f$1$1)
        })
      })(this, element, f$1));
      var this$2 = $m_sc_Seq$();
      return jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$2.ReusableCBFInstance$2)
    } else {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T((((("Invalid value '" + x4) + "' of type '") + t) + "'")))
    }
  } else {
    throw new $c_s_MatchError().init___O(e)
  }
});
$c_Lamf_core_parser_Fields.prototype.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields = (function(field) {
  this.fs$1 = $as_sci_Map(this.fs$1.$$minus__O__sc_Map(field));
  return this
});
$c_Lamf_core_parser_Fields.prototype.rawAny__p1__Lamf_core_model_domain_AmfElement__O = (function(element) {
  if ((element instanceof $c_Lamf_core_model_domain_AmfArray)) {
    var x2 = $as_Lamf_core_model_domain_AmfArray(element);
    var values = x2.values$1;
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(element$2$2) {
        var element$2 = $as_Lamf_core_model_domain_AmfElement(element$2$2);
        return $this.rawAny__p1__Lamf_core_model_domain_AmfElement__O(element$2)
      })
    })(this));
    var this$1 = $m_sc_Seq$();
    return values.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)
  } else if ((element instanceof $c_Lamf_core_model_domain_AmfScalar)) {
    var x4 = $as_Lamf_core_model_domain_AmfScalar(element);
    var value = x4.value$1;
    return value
  } else {
    return element
  }
});
$c_Lamf_core_parser_Fields.prototype.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields = (function(field, value, annotations) {
  var jsx$1 = this.fs$1;
  var y = new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value, annotations);
  this.fs$1 = jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(field, y));
  return this
});
$c_Lamf_core_parser_Fields.prototype.adopt__p1__T__Lamf_core_model_domain_AmfElement__V = (function(id, value) {
  if ($is_Lamf_core_model_domain_AmfObject(value)) {
    var x2 = $as_Lamf_core_model_domain_AmfObject(value);
    x2.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(id, x2.adopted$default$2__sc_Seq())
  } else if ((value instanceof $c_Lamf_core_model_domain_AmfArray)) {
    var x3 = $as_Lamf_core_model_domain_AmfArray(value);
    x3.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, id$1) {
      return (function(x$6$2) {
        var x$6 = $as_Lamf_core_model_domain_AmfElement(x$6$2);
        $this.adopt__p1__T__Lamf_core_model_domain_AmfElement__V(id$1, x$6)
      })
    })(this, id)))
  }
});
$c_Lamf_core_parser_Fields.prototype.apply__Lamf_core_metamodel_Field__O = (function(field) {
  return this.rawAny__p1__Lamf_core_model_domain_AmfElement__O(this.get__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement(field))
});
$c_Lamf_core_parser_Fields.prototype.entryJsonld__Lamf_core_metamodel_Field__s_Option = (function(f) {
  return (f.jsonldField$1 ? this.entry__Lamf_core_metamodel_Field__s_Option(f) : $m_s_None$())
});
$c_Lamf_core_parser_Fields.prototype.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value = (function(field) {
  var this$1 = this.fs$1.get__O__s_Option(field);
  return $as_Lamf_core_parser_Value((this$1.isEmpty__Z() ? null : this$1.get__O()))
});
$c_Lamf_core_parser_Fields.prototype.remove__T__Lamf_core_parser_Fields = (function(uri) {
  var this$1 = this.fs$1;
  var this$2 = this$1.iterator__sc_Iterator();
  inlinereturn$3: {
    while (this$2.hasNext__Z()) {
      var a = this$2.next__O();
      var t = $as_T2(a);
      var this$3 = $as_Lamf_core_metamodel_Field(t.$$und1__O()).value$1.iri__T();
      if ((this$3 === uri)) {
        var this$4 = new $c_s_Some().init___O(a);
        break inlinereturn$3
      }
    };
    var this$4 = $m_s_None$()
  };
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var t$3 = $as_T2(arg1);
    this.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($as_Lamf_core_metamodel_Field(t$3.$$und1__O()))
  };
  return this
});
$c_Lamf_core_parser_Fields.prototype.into__Lamf_core_parser_Fields__V = (function(other) {
  other.fs$1 = other.fs$1.$$plus$plus__sc_GenTraversableOnce__sci_Map(this.fs$1)
});
$c_Lamf_core_parser_Fields.prototype.empty$1__p1__Lamf_core_metamodel_Field__O = (function(f$1) {
  var x1 = f$1.type$1;
  var x = $m_Lamf_core_metamodel_Type$Str$();
  if (x.equals__O__Z(x1)) {
    var jsx$1 = true
  } else {
    var x$3 = $m_Lamf_core_metamodel_Type$Iri$();
    var jsx$1 = x$3.equals__O__Z(x1)
  };
  if (jsx$1) {
    return new $c_Lamf_core_parser_Fields$StrFieldImpl().init___Lamf_core_parser_Fields__s_Option__Lamf_core_parser_Annotations__Lamf_core_metamodel_Field(this, $m_s_None$(), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()), f$1)
  } else {
    var x$5 = $m_Lamf_core_metamodel_Type$Bool$();
    if (x$5.equals__O__Z(x1)) {
      return new $c_Lamf_core_parser_Fields$BoolFieldImpl().init___Lamf_core_parser_Fields__s_Option__Lamf_core_parser_Annotations__Lamf_core_metamodel_Field(this, $m_s_None$(), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()), f$1)
    } else {
      var x$7 = $m_Lamf_core_metamodel_Type$Int$();
      if (x$7.equals__O__Z(x1)) {
        return new $c_Lamf_core_parser_Fields$IntFieldImpl().init___Lamf_core_parser_Fields__s_Option__Lamf_core_parser_Annotations__Lamf_core_metamodel_Field(this, $m_s_None$(), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()), f$1)
      } else {
        var x$9 = $m_Lamf_core_metamodel_Type$Float$();
        if (x$9.equals__O__Z(x1)) {
          return new $c_Lamf_core_parser_Fields$DoubleFieldImpl().init___Lamf_core_parser_Fields__s_Option__Lamf_core_parser_Annotations__Lamf_core_metamodel_Field(this, $m_s_None$(), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()), f$1)
        } else {
          var x$11 = $m_Lamf_core_metamodel_Type$Double$();
          if (x$11.equals__O__Z(x1)) {
            return new $c_Lamf_core_parser_Fields$DoubleFieldImpl().init___Lamf_core_parser_Fields__s_Option__Lamf_core_parser_Annotations__Lamf_core_metamodel_Field(this, $m_s_None$(), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()), f$1)
          } else {
            var x$13 = $m_Lamf_core_metamodel_Type$Any$();
            if ((x$13 === x1)) {
              return new $c_Lamf_core_parser_Fields$AnyFieldImpl().init___Lamf_core_parser_Fields__s_Option__Lamf_core_parser_Annotations__Lamf_core_metamodel_Field(this, $m_s_None$(), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()), f$1)
            } else if ((x1 instanceof $c_Lamf_core_metamodel_Type$ArrayLike)) {
              var x2 = $as_Lamf_core_metamodel_Type$ArrayLike(x1);
              new $c_s_Some().init___O(x2.element__Lamf_core_metamodel_Type());
              return $m_sci_Nil$()
            } else if ($is_Lamf_core_metamodel_Obj(x1)) {
              return null
            } else {
              throw new $c_s_MatchError().init___O(x1)
            }
          }
        }
      }
    }
  }
});
$c_Lamf_core_parser_Fields.prototype.get__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement = (function(field) {
  var x1 = this.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value(field);
  var o8 = $m_Lamf_core_parser_Value$().unapply__Lamf_core_parser_Value__s_Option(x1);
  if ((!o8.isEmpty__Z())) {
    var value = $as_Lamf_core_model_domain_AmfElement($as_T2(o8.get__O()).$$und1__O());
    return value
  };
  return this.$default__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement(field)
});
$c_Lamf_core_parser_Fields.prototype.entry__Lamf_core_metamodel_Field__s_Option = (function(f) {
  var x1 = this.fs$1.get__O__s_Option(f);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var value = $as_Lamf_core_parser_Value(x2.value$2);
    return new $c_s_Some().init___O(new $c_Lamf_core_parser_FieldEntry().init___Lamf_core_metamodel_Field__Lamf_core_parser_Value(f, value))
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_core_parser_Fields.prototype.copy__Lamf_core_parser_Fields = (function() {
  var copied = new $c_Lamf_core_parser_Fields().init___();
  this.fs$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, copied$1) {
    return (function(x$11$2) {
      var x$11 = $as_T2(x$11$2);
      copied$1.fs$1 = copied$1.fs$1.$$plus__T2__sci_Map(x$11)
    })
  })(this, copied)));
  return copied
});
$c_Lamf_core_parser_Fields.prototype.$default__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement = (function(field) {
  var this$1 = $m_s_Option$().apply__O__s_Option(field.type$1);
  if (this$1.isEmpty__Z()) {
    var jsx$1 = true
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_Lamf_core_metamodel_Type(arg1);
    var jsx$1 = (x$1 instanceof $c_Lamf_core_metamodel_Type$Array)
  };
  if (jsx$1) {
    var this$2 = this$1
  } else {
    var this$2 = $m_s_None$()
  };
  if (this$2.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1$1 = this$2.get__O();
    $as_Lamf_core_metamodel_Type(arg1$1);
    var this$4 = new $c_s_Some().init___O(new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($m_sci_Nil$(), new $c_Lamf_core_parser_Annotations().init___()))
  };
  return $as_Lamf_core_model_domain_AmfElement((this$4.isEmpty__Z() ? null : this$4.get__O()))
});
$c_Lamf_core_parser_Fields.prototype.add__T__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Fields = (function(id, field, value) {
  this.adopt__p1__T__Lamf_core_model_domain_AmfElement__V(id, value);
  var x1 = this.$$qmark__Lamf_core_metamodel_Field__s_Option(field);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var array = $as_Lamf_core_model_domain_AmfArray(x2.value$2);
    array.$$plus$eq__Lamf_core_model_domain_AmfElement__V(value);
    return this
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var jsx$1 = $m_sc_Seq$();
      var array$1 = [value];
      return this.set__T__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(id, field, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1))), new $c_Lamf_core_parser_Annotations().init___()), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_core_parser_Fields.prototype.cloneFields__scm_Map__Lamf_core_parser_Fields = (function(branch) {
  var cloned = new $c_Lamf_core_parser_Fields().init___();
  this.fs$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, cloned$1, branch$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var field = $as_Lamf_core_metamodel_Field(x0$1.$$und1__O());
        var value = $as_Lamf_core_parser_Value(x0$1.$$und2__O());
        var jsx$1 = cloned$1.fs$1;
        var y = value.cloneValue__scm_Map__Lamf_core_parser_Value(branch$1);
        cloned$1.fs$1 = jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(field, y))
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, cloned, branch)));
  return cloned
});
$c_Lamf_core_parser_Fields.prototype.field__Lamf_core_metamodel_Field__O = (function(f) {
  var this$1 = this.fs$1.get__O__s_Option(f);
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var v = $as_Lamf_core_parser_Value(arg1);
    var this$2 = new $c_s_Some().init___O(this.typed$1__p1__Lamf_core_metamodel_Type__Lamf_core_model_domain_AmfElement__Lamf_core_metamodel_Field__O(f.type$1, v.value$1, f))
  };
  if (this$2.isEmpty__Z()) {
    return this.empty$1__p1__Lamf_core_metamodel_Field__O(f)
  } else {
    var arg1$1 = this$2.get__O();
    return arg1$1
  }
});
$c_Lamf_core_parser_Fields.prototype.fieldsMeta__sci_List = (function() {
  var this$1 = this.fs$1;
  var this$2 = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(this$1);
  var this$3 = $m_sci_List$();
  var cbf = this$3.ReusableCBFInstance$2;
  return $as_sci_List($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this$2, cbf))
});
$c_Lamf_core_parser_Fields.prototype.filter__F1__Lamf_core_parser_Fields = (function(fn) {
  this.fs$1 = $as_sci_Map(this.fs$1.filter__F1__O(fn));
  return this
});
function $as_Lamf_core_parser_Fields(obj) {
  return (((obj instanceof $c_Lamf_core_parser_Fields) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.Fields"))
}
function $isArrayOf_Lamf_core_parser_Fields(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_Fields)))
}
function $asArrayOf_Lamf_core_parser_Fields(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_Fields(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.Fields;", depth))
}
var $d_Lamf_core_parser_Fields = new $TypeData().initClass({
  Lamf_core_parser_Fields: 0
}, false, "amf.core.parser.Fields", {
  Lamf_core_parser_Fields: 1,
  O: 1
});
$c_Lamf_core_parser_Fields.prototype.$classData = $d_Lamf_core_parser_Fields;
/** @constructor */
function $c_Lamf_core_parser_ParsedDocument() {
  $c_O.call(this)
}
$c_Lamf_core_parser_ParsedDocument.prototype = new $h_O();
$c_Lamf_core_parser_ParsedDocument.prototype.constructor = $c_Lamf_core_parser_ParsedDocument;
/** @constructor */
function $h_Lamf_core_parser_ParsedDocument() {
  /*<skip>*/
}
$h_Lamf_core_parser_ParsedDocument.prototype = $c_Lamf_core_parser_ParsedDocument.prototype;
$c_Lamf_core_parser_ParsedDocument.prototype.comment__s_Option = (function() {
  return $m_s_None$()
});
function $as_Lamf_core_parser_ParsedDocument(obj) {
  return (((obj instanceof $c_Lamf_core_parser_ParsedDocument) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.ParsedDocument"))
}
function $isArrayOf_Lamf_core_parser_ParsedDocument(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_ParsedDocument)))
}
function $asArrayOf_Lamf_core_parser_ParsedDocument(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_ParsedDocument(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.ParsedDocument;", depth))
}
/** @constructor */
function $c_Lamf_core_parser_ReferenceFragmentPartition$() {
  $c_O.call(this)
}
$c_Lamf_core_parser_ReferenceFragmentPartition$.prototype = new $h_O();
$c_Lamf_core_parser_ReferenceFragmentPartition$.prototype.constructor = $c_Lamf_core_parser_ReferenceFragmentPartition$;
/** @constructor */
function $h_Lamf_core_parser_ReferenceFragmentPartition$() {
  /*<skip>*/
}
$h_Lamf_core_parser_ReferenceFragmentPartition$.prototype = $c_Lamf_core_parser_ReferenceFragmentPartition$.prototype;
$c_Lamf_core_parser_ReferenceFragmentPartition$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_parser_ReferenceFragmentPartition$.prototype.apply__T__T2 = (function(url) {
  if (this.isExternalReference__p1__T__Z(url)) {
    var x1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(url, "#", 0);
    var o9 = $m_s_Array$().unapplySeq__O__s_Option(x1);
    if (((!o9.isEmpty__Z()) && ((o9.get__O() !== null) && ($as_sc_SeqLike(o9.get__O()).lengthCompare__I__I(1) === 0)))) {
      var basePath = $as_T($as_sc_SeqLike(o9.get__O()).apply__I__O(0));
      if ($m_sjsr_RuntimeString$().endsWith__T__T__Z(basePath, "#")) {
        var endIndex = (((-2) + $uI(basePath.length)) | 0);
        return new $c_T2().init___O__O($as_T(basePath.substring(0, endIndex)), $m_s_None$())
      }
    };
    var o11 = $m_s_Array$().unapplySeq__O__s_Option(x1);
    if (((!o11.isEmpty__Z()) && ((o11.get__O() !== null) && ($as_sc_SeqLike(o11.get__O()).lengthCompare__I__I(1) === 0)))) {
      var basePath$2 = $as_T($as_sc_SeqLike(o11.get__O()).apply__I__O(0));
      return new $c_T2().init___O__O(basePath$2, $m_s_None$())
    };
    var o13 = $m_s_Array$().unapplySeq__O__s_Option(x1);
    if (((!o13.isEmpty__Z()) && ((o13.get__O() !== null) && ($as_sc_SeqLike(o13.get__O()).lengthCompare__I__I(2) === 0)))) {
      var basePath$3 = $as_T($as_sc_SeqLike(o13.get__O()).apply__I__O(0));
      var localPath = $as_T($as_sc_SeqLike(o13.get__O()).apply__I__O(1));
      return new $c_T2().init___O__O(basePath$3, new $c_s_Some().init___O(localPath))
    };
    var jsx$1 = $uI(url.length);
    var this$7 = new $c_scm_ArrayOps$ofRef().init___AO(x1);
    var thiz = $as_T($f_sc_IndexedSeqOptimized__last__O(this$7));
    var endIndex$1 = (((((-1) + jsx$1) | 0) - $uI(thiz.length)) | 0);
    var str = $as_T(url.substring(0, endIndex$1));
    var this$12 = new $c_scm_ArrayOps$ofRef().init___AO(x1);
    return new $c_T2().init___O__O(str, new $c_s_Some().init___O($f_sc_IndexedSeqOptimized__last__O(this$12)))
  } else {
    return new $c_T2().init___O__O(url, $m_s_None$())
  }
});
$c_Lamf_core_parser_ReferenceFragmentPartition$.prototype.isExternalReference__p1__T__Z = (function(referenceLocator) {
  var thiz = new $c_Lamf_core_utils_package$AmfStrings().init___T(referenceLocator).normalizeUrl__T();
  var prefix = $m_Lamf_core_remote_File$().FILE$undPROTOCOL$1;
  if ((($uI(thiz.length) >= 0) && ($as_T(thiz.substring(0, $uI(prefix.length))) === prefix))) {
    var jsx$2 = true
  } else {
    var prefix$1 = $m_Lamf_core_remote_HttpParts$().HTTPS$undPROTOCOL$1;
    var jsx$2 = (($uI(referenceLocator.length) >= 0) && ($as_T(referenceLocator.substring(0, $uI(prefix$1.length))) === prefix$1))
  };
  if (jsx$2) {
    var jsx$1 = true
  } else {
    var prefix$2 = $m_Lamf_core_remote_HttpParts$().HTTP$undPROTOCOL$1;
    var jsx$1 = (($uI(referenceLocator.length) >= 0) && ($as_T(referenceLocator.substring(0, $uI(prefix$2.length))) === prefix$2))
  };
  if (jsx$1) {
    return (!(($uI(referenceLocator.length) >= 0) && ($as_T(referenceLocator.substring(0, $uI("#".length))) === "#")))
  } else {
    return false
  }
});
var $d_Lamf_core_parser_ReferenceFragmentPartition$ = new $TypeData().initClass({
  Lamf_core_parser_ReferenceFragmentPartition$: 0
}, false, "amf.core.parser.ReferenceFragmentPartition$", {
  Lamf_core_parser_ReferenceFragmentPartition$: 1,
  O: 1
});
$c_Lamf_core_parser_ReferenceFragmentPartition$.prototype.$classData = $d_Lamf_core_parser_ReferenceFragmentPartition$;
var $n_Lamf_core_parser_ReferenceFragmentPartition$ = (void 0);
function $m_Lamf_core_parser_ReferenceFragmentPartition$() {
  if ((!$n_Lamf_core_parser_ReferenceFragmentPartition$)) {
    $n_Lamf_core_parser_ReferenceFragmentPartition$ = new $c_Lamf_core_parser_ReferenceFragmentPartition$().init___()
  };
  return $n_Lamf_core_parser_ReferenceFragmentPartition$
}
function $is_Lamf_core_parser_ScalarNode(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_parser_ScalarNode)))
}
function $as_Lamf_core_parser_ScalarNode(obj) {
  return (($is_Lamf_core_parser_ScalarNode(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.ScalarNode"))
}
function $isArrayOf_Lamf_core_parser_ScalarNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_ScalarNode)))
}
function $asArrayOf_Lamf_core_parser_ScalarNode(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_ScalarNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.ScalarNode;", depth))
}
/** @constructor */
function $c_Lamf_core_parser_Value() {
  $c_O.call(this);
  this.value$1 = null;
  this.annotations$1 = null
}
$c_Lamf_core_parser_Value.prototype = new $h_O();
$c_Lamf_core_parser_Value.prototype.constructor = $c_Lamf_core_parser_Value;
/** @constructor */
function $h_Lamf_core_parser_Value() {
  /*<skip>*/
}
$h_Lamf_core_parser_Value.prototype = $c_Lamf_core_parser_Value.prototype;
$c_Lamf_core_parser_Value.prototype.toString__T = (function() {
  return this.value$1.toString__T()
});
$c_Lamf_core_parser_Value.prototype.cloneValue__scm_Map__Lamf_core_parser_Value = (function(branch) {
  var value = this.value$1.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement(branch);
  var this$1 = this.annotations$1;
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(this$1);
  return new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value, annotations)
});
$c_Lamf_core_parser_Value.prototype.checkUnresolved__V = (function() {
  var x1 = this.value$1;
  matchEnd5: {
    if ($is_Lamf_core_model_domain_Linkable(x1)) {
      var x2 = $as_Lamf_core_model_domain_Linkable(x1);
      if (x2.isUnresolved__Z()) {
        var resolve = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x2$1) {
          return (function(resolved$2) {
            var resolved = $as_Lamf_core_model_domain_Linkable(resolved$2);
            if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x2$1).isDefined__Z()) {
              $this.value$1 = resolved
            } else {
              var jsx$2 = x2$1.refName__T();
              var jsx$1 = x2$1.annotations__Lamf_core_parser_Annotations();
              var this$1 = $as_Lamf_core_model_BoolField(x2$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1)).option$1;
              $this.value$1 = $as_Lamf_core_model_domain_AmfElement(resolved.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(jsx$2, jsx$1, x2$1, $uZ((this$1.isEmpty__Z() ? false : this$1.get__O()))))
            };
            var x1$1 = $this.value$1;
            if ((x1$1 instanceof $c_Lamf_core_model_domain_Shape)) {
              var x2$2 = $as_Lamf_core_model_domain_Shape(x1$1);
              var syntax = new $c_s_Some().init___O(x2$2.ramlSyntaxKey__T())
            } else {
              var syntax = $m_s_None$()
            };
            x2$1.afterResolve__s_Option__T__V(syntax, resolved.id__T())
          })
        })(this, x2));
        $f_Lamf_core_model_domain_Linkable__toFutureRef__F1__V(x2, resolve);
        break matchEnd5
      }
    };
    if ((x1 instanceof $c_Lamf_core_model_domain_AmfArray)) {
      var x3 = $as_Lamf_core_model_domain_AmfArray(x1);
      x3.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
        return (function(x0$1$2) {
          var x0$1 = $as_Lamf_core_model_domain_AmfElement(x0$1$2);
          matchEnd4: {
            if ($is_Lamf_core_model_domain_Linkable(x0$1)) {
              var x2$3 = $as_Lamf_core_model_domain_Linkable(x0$1);
              if (x2$3.isUnresolved__Z()) {
                var resolve$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, x2$4) {
                  return (function(resolved$2$1) {
                    var resolved$1 = $as_Lamf_core_model_domain_Linkable(resolved$2$1);
                    var unresolved = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
                    var jsx$7 = $as_Lamf_core_model_domain_AmfArray($this$1.value$1);
                    var jsx$6 = $as_Lamf_core_model_domain_AmfArray($this$1.value$1).values$1;
                    var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, x2$2$1, resolved$3, unresolved$1) {
                      return (function(element$2) {
                        var element = $as_Lamf_core_model_domain_AmfElement(element$2);
                        if (((element === null) ? (x2$2$1 === null) : element.equals__O__Z(x2$2$1))) {
                          if ((resolved$3 instanceof $c_Lamf_core_model_domain_Shape)) {
                            var x2$5 = $as_Lamf_core_model_domain_Shape(resolved$3);
                            var syntax$1 = new $c_s_Some().init___O(x2$5.ramlSyntaxKey__T())
                          } else {
                            var syntax$1 = $m_s_None$()
                          };
                          var self = $as_Lamf_core_model_domain_Linkable(element);
                          unresolved$1.$$plus$eq__O__scm_ListBuffer(new $c_T2().init___O__O(self, syntax$1));
                          var jsx$5 = x2$2$1.refName__T();
                          var jsx$4 = x2$2$1.annotations__Lamf_core_parser_Annotations();
                          var this$5 = $as_Lamf_core_model_BoolField(x2$2$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1)).option$1;
                          return $as_Lamf_core_model_domain_AmfElement(resolved$3.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(jsx$5, jsx$4, element, $uZ((this$5.isEmpty__Z() ? false : this$5.get__O()))))
                        } else {
                          return element
                        }
                      })
                    })($this$1, x2$4, resolved$1, unresolved));
                    var this$6 = $m_sc_Seq$();
                    jsx$7.values$1 = $as_sc_Seq(jsx$6.map__F1__scg_CanBuildFrom__O(jsx$3, this$6.ReusableCBFInstance$2));
                    var this$7 = unresolved.scala$collection$mutable$ListBuffer$$start$6;
                    var these = this$7;
                    while ((!these.isEmpty__Z())) {
                      var arg1 = these.head__O();
                      var x0$2 = $as_T2(arg1);
                      if ((x0$2 !== null)) {
                        var ur = $as_Lamf_core_model_domain_Linkable(x0$2.$$und1__O());
                        var key = $as_s_Option(x0$2.$$und2__O());
                        ur.afterResolve__s_Option__T__V(key, resolved$1.id__T())
                      } else {
                        throw new $c_s_MatchError().init___O(x0$2)
                      };
                      these = $as_sci_List(these.tail__O())
                    }
                  })
                })(this$2, x2$3));
                $f_Lamf_core_model_domain_Linkable__toFutureRef__F1__V(x2$3, resolve$1);
                break matchEnd4
              }
            }
          }
        })
      })(this)));
      break matchEnd5
    }
  }
});
$c_Lamf_core_parser_Value.prototype.init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations = (function(value, annotations) {
  this.value$1 = value;
  this.annotations$1 = annotations;
  this.checkUnresolved__V();
  return this
});
function $as_Lamf_core_parser_Value(obj) {
  return (((obj instanceof $c_Lamf_core_parser_Value) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.Value"))
}
function $isArrayOf_Lamf_core_parser_Value(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_Value)))
}
function $asArrayOf_Lamf_core_parser_Value(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_Value(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.Value;", depth))
}
var $d_Lamf_core_parser_Value = new $TypeData().initClass({
  Lamf_core_parser_Value: 0
}, false, "amf.core.parser.Value", {
  Lamf_core_parser_Value: 1,
  O: 1
});
$c_Lamf_core_parser_Value.prototype.$classData = $d_Lamf_core_parser_Value;
/** @constructor */
function $c_Lamf_core_parser_Value$() {
  $c_O.call(this)
}
$c_Lamf_core_parser_Value$.prototype = new $h_O();
$c_Lamf_core_parser_Value$.prototype.constructor = $c_Lamf_core_parser_Value$;
/** @constructor */
function $h_Lamf_core_parser_Value$() {
  /*<skip>*/
}
$h_Lamf_core_parser_Value$.prototype = $c_Lamf_core_parser_Value$.prototype;
$c_Lamf_core_parser_Value$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_parser_Value$.prototype.unapply__Lamf_core_parser_Value__s_Option = (function(link) {
  return ($m_s_Option$().apply__O__s_Option(link).isDefined__Z() ? new $c_s_Some().init___O(new $c_T2().init___O__O(link.value$1, link.annotations$1)) : $m_s_None$())
});
var $d_Lamf_core_parser_Value$ = new $TypeData().initClass({
  Lamf_core_parser_Value$: 0
}, false, "amf.core.parser.Value$", {
  Lamf_core_parser_Value$: 1,
  O: 1
});
$c_Lamf_core_parser_Value$.prototype.$classData = $d_Lamf_core_parser_Value$;
var $n_Lamf_core_parser_Value$ = (void 0);
function $m_Lamf_core_parser_Value$() {
  if ((!$n_Lamf_core_parser_Value$)) {
    $n_Lamf_core_parser_Value$ = new $c_Lamf_core_parser_Value$().init___()
  };
  return $n_Lamf_core_parser_Value$
}
/** @constructor */
function $c_Lamf_core_parser_package$YMapOps() {
  $c_O.call(this);
  this.map$1 = null
}
$c_Lamf_core_parser_package$YMapOps.prototype = new $h_O();
$c_Lamf_core_parser_package$YMapOps.prototype.constructor = $c_Lamf_core_parser_package$YMapOps;
/** @constructor */
function $h_Lamf_core_parser_package$YMapOps() {
  /*<skip>*/
}
$h_Lamf_core_parser_package$YMapOps.prototype = $c_Lamf_core_parser_package$YMapOps.prototype;
$c_Lamf_core_parser_package$YMapOps.prototype.regex__T__sc_Iterable = (function(expression) {
  var this$2 = new $c_sci_StringOps().init___T(expression);
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  var path = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  return $as_sc_Iterable(this.map$1.entries$3.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, path$1) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var x1 = entry.key$2.value__Lorg_yaml_model_YValue();
      if ((x1 instanceof $c_Lorg_yaml_model_YScalar)) {
        var x2 = $as_Lorg_yaml_model_YScalar(x1);
        var this$4 = path$1.unapplySeq__jl_CharSequence__s_Option(x2.text$3);
        return this$4.isDefined__Z()
      } else {
        return false
      }
    })
  })(this, path))))
});
$c_Lamf_core_parser_package$YMapOps.prototype.key__T__s_Option = (function(keyword) {
  return this.map$1.entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, keyword$1) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var x1 = entry.key$2.value__Lorg_yaml_model_YValue();
      if ((x1 instanceof $c_Lorg_yaml_model_YScalar)) {
        var x2 = $as_Lorg_yaml_model_YScalar(x1);
        return (x2.text$3 === keyword$1)
      } else {
        return false
      }
    })
  })(this, keyword)))
});
$c_Lamf_core_parser_package$YMapOps.prototype.init___Lorg_yaml_model_YMap = (function(map) {
  this.map$1 = map;
  return this
});
$c_Lamf_core_parser_package$YMapOps.prototype.key__T__F1__V = (function(keyword, fn) {
  var this$1 = this.key__T__s_Option(keyword);
  if ((!this$1.isEmpty__Z())) {
    fn.apply__O__O(this$1.get__O())
  }
});
var $d_Lamf_core_parser_package$YMapOps = new $TypeData().initClass({
  Lamf_core_parser_package$YMapOps: 0
}, false, "amf.core.parser.package$YMapOps", {
  Lamf_core_parser_package$YMapOps: 1,
  O: 1
});
$c_Lamf_core_parser_package$YMapOps.prototype.$classData = $d_Lamf_core_parser_package$YMapOps;
/** @constructor */
function $c_Lamf_core_parser_package$YNodeLikeOps() {
  $c_O.call(this);
  this.node$1 = null
}
$c_Lamf_core_parser_package$YNodeLikeOps.prototype = new $h_O();
$c_Lamf_core_parser_package$YNodeLikeOps.prototype.constructor = $c_Lamf_core_parser_package$YNodeLikeOps;
/** @constructor */
function $h_Lamf_core_parser_package$YNodeLikeOps() {
  /*<skip>*/
}
$h_Lamf_core_parser_package$YNodeLikeOps.prototype = $c_Lamf_core_parser_package$YNodeLikeOps.prototype;
$c_Lamf_core_parser_package$YNodeLikeOps.prototype.toOption__Lorg_yaml_convert_YRead__s_Option = (function(conversion) {
  return this.node$1.to__Lorg_yaml_convert_YRead__s_util_Either(conversion).toOption__s_Option()
});
$c_Lamf_core_parser_package$YNodeLikeOps.prototype.init___Lorg_yaml_model_YNodeLike = (function(node) {
  this.node$1 = node;
  return this
});
var $d_Lamf_core_parser_package$YNodeLikeOps = new $TypeData().initClass({
  Lamf_core_parser_package$YNodeLikeOps: 0
}, false, "amf.core.parser.package$YNodeLikeOps", {
  Lamf_core_parser_package$YNodeLikeOps: 1,
  O: 1
});
$c_Lamf_core_parser_package$YNodeLikeOps.prototype.$classData = $d_Lamf_core_parser_package$YNodeLikeOps;
/** @constructor */
function $c_Lamf_core_rdf_PropertyObject() {
  $c_O.call(this);
  this.value$1 = null
}
$c_Lamf_core_rdf_PropertyObject.prototype = new $h_O();
$c_Lamf_core_rdf_PropertyObject.prototype.constructor = $c_Lamf_core_rdf_PropertyObject;
/** @constructor */
function $h_Lamf_core_rdf_PropertyObject() {
  /*<skip>*/
}
$h_Lamf_core_rdf_PropertyObject.prototype = $c_Lamf_core_rdf_PropertyObject.prototype;
$c_Lamf_core_rdf_PropertyObject.prototype.init___T = (function(value) {
  this.value$1 = value;
  return this
});
function $as_Lamf_core_rdf_PropertyObject(obj) {
  return (((obj instanceof $c_Lamf_core_rdf_PropertyObject) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.rdf.PropertyObject"))
}
function $isArrayOf_Lamf_core_rdf_PropertyObject(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_rdf_PropertyObject)))
}
function $asArrayOf_Lamf_core_rdf_PropertyObject(obj, depth) {
  return (($isArrayOf_Lamf_core_rdf_PropertyObject(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.rdf.PropertyObject;", depth))
}
/** @constructor */
function $c_Lamf_core_rdf_RdfModel() {
  $c_O.call(this);
  this.anonCounter$1 = 0
}
$c_Lamf_core_rdf_RdfModel.prototype = new $h_O();
$c_Lamf_core_rdf_RdfModel.prototype.constructor = $c_Lamf_core_rdf_RdfModel;
/** @constructor */
function $h_Lamf_core_rdf_RdfModel() {
  /*<skip>*/
}
$h_Lamf_core_rdf_RdfModel.prototype = $c_Lamf_core_rdf_RdfModel.prototype;
$c_Lamf_core_rdf_RdfModel.prototype.init___ = (function() {
  this.anonCounter$1 = 0;
  return this
});
function $as_Lamf_core_rdf_RdfModel(obj) {
  return (((obj instanceof $c_Lamf_core_rdf_RdfModel) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.rdf.RdfModel"))
}
function $isArrayOf_Lamf_core_rdf_RdfModel(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_rdf_RdfModel)))
}
function $asArrayOf_Lamf_core_rdf_RdfModel(obj, depth) {
  return (($isArrayOf_Lamf_core_rdf_RdfModel(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.rdf.RdfModel;", depth))
}
/** @constructor */
function $c_Lamf_core_rdf_RdfModelParser$() {
  $c_O.call(this)
}
$c_Lamf_core_rdf_RdfModelParser$.prototype = new $h_O();
$c_Lamf_core_rdf_RdfModelParser$.prototype.constructor = $c_Lamf_core_rdf_RdfModelParser$;
/** @constructor */
function $h_Lamf_core_rdf_RdfModelParser$() {
  /*<skip>*/
}
$h_Lamf_core_rdf_RdfModelParser$.prototype = $c_Lamf_core_rdf_RdfModelParser$.prototype;
$c_Lamf_core_rdf_RdfModelParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_rdf_RdfModelParser$.prototype.apply__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext__Lamf_core_rdf_RdfModelParser = (function(errorHandler, plugins) {
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$4 = new $c_scm_ListBuffer().init___();
  var x$4 = this$4.toList__sci_List();
  var x$5 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
  return new $c_Lamf_core_rdf_RdfModelParser().init___Lamf_core_rdf_RdfParserContext(new $c_Lamf_core_rdf_RdfParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext("", x$4, x$5, errorHandler, plugins))
});
var $d_Lamf_core_rdf_RdfModelParser$ = new $TypeData().initClass({
  Lamf_core_rdf_RdfModelParser$: 0
}, false, "amf.core.rdf.RdfModelParser$", {
  Lamf_core_rdf_RdfModelParser$: 1,
  O: 1
});
$c_Lamf_core_rdf_RdfModelParser$.prototype.$classData = $d_Lamf_core_rdf_RdfModelParser$;
var $n_Lamf_core_rdf_RdfModelParser$ = (void 0);
function $m_Lamf_core_rdf_RdfModelParser$() {
  if ((!$n_Lamf_core_rdf_RdfModelParser$)) {
    $n_Lamf_core_rdf_RdfModelParser$ = new $c_Lamf_core_rdf_RdfModelParser$().init___()
  };
  return $n_Lamf_core_rdf_RdfModelParser$
}
/** @constructor */
function $c_Lamf_core_rdf_RecursionControl() {
  $c_O.call(this);
  this.visited$1 = null
}
$c_Lamf_core_rdf_RecursionControl.prototype = new $h_O();
$c_Lamf_core_rdf_RecursionControl.prototype.constructor = $c_Lamf_core_rdf_RecursionControl;
/** @constructor */
function $h_Lamf_core_rdf_RecursionControl() {
  /*<skip>*/
}
$h_Lamf_core_rdf_RecursionControl.prototype = $c_Lamf_core_rdf_RecursionControl.prototype;
$c_Lamf_core_rdf_RecursionControl.prototype.init___sci_Set = (function(visited) {
  this.visited$1 = visited;
  return this
});
$c_Lamf_core_rdf_RecursionControl.prototype.visited__Lamf_core_rdf_Node__V = (function(node) {
  this.visited$1 = $as_sci_Set(this.visited$1.$$plus__O__sc_Set(node.subject$1))
});
var $d_Lamf_core_rdf_RecursionControl = new $TypeData().initClass({
  Lamf_core_rdf_RecursionControl: 0
}, false, "amf.core.rdf.RecursionControl", {
  Lamf_core_rdf_RecursionControl: 1,
  O: 1
});
$c_Lamf_core_rdf_RecursionControl.prototype.$classData = $d_Lamf_core_rdf_RecursionControl;
/** @constructor */
function $c_Lamf_core_rdf_converter_StringIriUriRegexParser$() {
  $c_O.call(this)
}
$c_Lamf_core_rdf_converter_StringIriUriRegexParser$.prototype = new $h_O();
$c_Lamf_core_rdf_converter_StringIriUriRegexParser$.prototype.constructor = $c_Lamf_core_rdf_converter_StringIriUriRegexParser$;
/** @constructor */
function $h_Lamf_core_rdf_converter_StringIriUriRegexParser$() {
  /*<skip>*/
}
$h_Lamf_core_rdf_converter_StringIriUriRegexParser$.prototype = $c_Lamf_core_rdf_converter_StringIriUriRegexParser$.prototype;
$c_Lamf_core_rdf_converter_StringIriUriRegexParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_rdf_converter_StringIriUriRegexParser$.prototype.parse__Lamf_core_rdf_PropertyObject__Lamf_core_model_domain_AmfScalar = (function(property) {
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(("" + property.value__T()), new $c_Lamf_core_parser_Annotations().init___())
});
var $d_Lamf_core_rdf_converter_StringIriUriRegexParser$ = new $TypeData().initClass({
  Lamf_core_rdf_converter_StringIriUriRegexParser$: 0
}, false, "amf.core.rdf.converter.StringIriUriRegexParser$", {
  Lamf_core_rdf_converter_StringIriUriRegexParser$: 1,
  O: 1
});
$c_Lamf_core_rdf_converter_StringIriUriRegexParser$.prototype.$classData = $d_Lamf_core_rdf_converter_StringIriUriRegexParser$;
var $n_Lamf_core_rdf_converter_StringIriUriRegexParser$ = (void 0);
function $m_Lamf_core_rdf_converter_StringIriUriRegexParser$() {
  if ((!$n_Lamf_core_rdf_converter_StringIriUriRegexParser$)) {
    $n_Lamf_core_rdf_converter_StringIriUriRegexParser$ = new $c_Lamf_core_rdf_converter_StringIriUriRegexParser$().init___()
  };
  return $n_Lamf_core_rdf_converter_StringIriUriRegexParser$
}
/** @constructor */
function $c_Lamf_core_rdf_graph_NodeFinder() {
  $c_O.call(this);
  this.graph$1 = null
}
$c_Lamf_core_rdf_graph_NodeFinder.prototype = new $h_O();
$c_Lamf_core_rdf_graph_NodeFinder.prototype.constructor = $c_Lamf_core_rdf_graph_NodeFinder;
/** @constructor */
function $h_Lamf_core_rdf_graph_NodeFinder() {
  /*<skip>*/
}
$h_Lamf_core_rdf_graph_NodeFinder.prototype = $c_Lamf_core_rdf_graph_NodeFinder.prototype;
$c_Lamf_core_rdf_graph_NodeFinder.prototype.init___Lamf_core_rdf_RdfModel = (function(graph) {
  this.graph$1 = graph;
  return this
});
$c_Lamf_core_rdf_graph_NodeFinder.prototype.findLink__Lamf_core_rdf_PropertyObject__s_Option = (function(property) {
  if ((property instanceof $c_Lamf_core_rdf_Uri)) {
    var x2 = $as_Lamf_core_rdf_Uri(property);
    var v = x2.value$1;
    return this.graph$1.findNode__T__s_Option(v)
  } else {
    return $m_s_None$()
  }
});
var $d_Lamf_core_rdf_graph_NodeFinder = new $TypeData().initClass({
  Lamf_core_rdf_graph_NodeFinder: 0
}, false, "amf.core.rdf.graph.NodeFinder", {
  Lamf_core_rdf_graph_NodeFinder: 1,
  O: 1
});
$c_Lamf_core_rdf_graph_NodeFinder.prototype.$classData = $d_Lamf_core_rdf_graph_NodeFinder;
/** @constructor */
function $c_Lamf_core_rdf_helper_DefaultNodeClassSorter() {
  $c_O.call(this);
  this.deferredTypesSet$1 = null
}
$c_Lamf_core_rdf_helper_DefaultNodeClassSorter.prototype = new $h_O();
$c_Lamf_core_rdf_helper_DefaultNodeClassSorter.prototype.constructor = $c_Lamf_core_rdf_helper_DefaultNodeClassSorter;
/** @constructor */
function $h_Lamf_core_rdf_helper_DefaultNodeClassSorter() {
  /*<skip>*/
}
$h_Lamf_core_rdf_helper_DefaultNodeClassSorter.prototype = $c_Lamf_core_rdf_helper_DefaultNodeClassSorter.prototype;
$c_Lamf_core_rdf_helper_DefaultNodeClassSorter.prototype.init___ = (function() {
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var jsx$5 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "Document").iri__T();
  var this$3 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var jsx$4 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "Fragment").iri__T();
  var this$5 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var jsx$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$5, "Module").iri__T();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var jsx$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "Unit").iri__T();
  var this$9 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var jsx$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$9, "Shape").iri__T();
  var this$11 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var array = [jsx$5, jsx$4, jsx$3, jsx$2, jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$11, "Shape").iri__T()];
  if (($uI(array.length) === 0)) {
    var jsx$6 = $m_sci_Set$EmptySet$()
  } else {
    var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      b.$$plus$eq__O__scm_SetBuilder(arg1);
      i = ((1 + i) | 0)
    };
    var jsx$6 = b.elems$1
  };
  this.deferredTypesSet$1 = $as_sci_Set(jsx$6);
  return this
});
$c_Lamf_core_rdf_helper_DefaultNodeClassSorter.prototype.sortedClassesOf__Lamf_core_rdf_Node__sc_Seq = (function(node) {
  var x1 = node.classes$1.partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(elem$2) {
      var elem = $as_T(elem$2);
      return $this.deferredTypesSet$1.contains__O__Z(elem)
    })
  })(this)));
  if ((x1 !== null)) {
    var deferred = $as_sc_Seq(x1.$$und1__O());
    var others = $as_sc_Seq(x1.$$und2__O());
    var jsx$1 = $as_sc_GenTraversableOnce(deferred.sorted__s_math_Ordering__O($m_s_math_Ordering$String$()));
    var this$1 = $m_sc_Seq$();
    return $as_sc_Seq(others.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
var $d_Lamf_core_rdf_helper_DefaultNodeClassSorter = new $TypeData().initClass({
  Lamf_core_rdf_helper_DefaultNodeClassSorter: 0
}, false, "amf.core.rdf.helper.DefaultNodeClassSorter", {
  Lamf_core_rdf_helper_DefaultNodeClassSorter: 1,
  O: 1
});
$c_Lamf_core_rdf_helper_DefaultNodeClassSorter.prototype.$classData = $d_Lamf_core_rdf_helper_DefaultNodeClassSorter;
/** @constructor */
function $c_Lamf_core_rdf_helper_PluginEntitiesFacade() {
  $c_O.call(this);
  this.ctx$1 = null;
  this.cache$1 = null;
  this.sorter$1 = null
}
$c_Lamf_core_rdf_helper_PluginEntitiesFacade.prototype = new $h_O();
$c_Lamf_core_rdf_helper_PluginEntitiesFacade.prototype.constructor = $c_Lamf_core_rdf_helper_PluginEntitiesFacade;
/** @constructor */
function $h_Lamf_core_rdf_helper_PluginEntitiesFacade() {
  /*<skip>*/
}
$h_Lamf_core_rdf_helper_PluginEntitiesFacade.prototype = $c_Lamf_core_rdf_helper_PluginEntitiesFacade.prototype;
$c_Lamf_core_rdf_helper_PluginEntitiesFacade.prototype.findType__p1__T__s_Option = (function(type) {
  var this$1 = this.cache$1.get__O__s_Option(type);
  if (this$1.isEmpty__Z()) {
    var x1 = this.ctx$1.plugins$1.findType__T__s_Option(type);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var obj = $as_Lamf_core_metamodel_Obj(x2.value$2);
      this.cache$1.update__O__O__V(type, obj);
      return new $c_s_Some().init___O(obj)
    } else {
      var x = $m_s_None$();
      if ((!(x === x1))) {
        throw new $c_s_MatchError().init___O(x1)
      };
      return $m_s_None$()
    }
  } else {
    return this$1
  }
});
$c_Lamf_core_rdf_helper_PluginEntitiesFacade.prototype.buildType__Lamf_core_metamodel_Obj__F1 = (function(type) {
  return this.ctx$1.plugins$1.buildType__Lamf_core_metamodel_Obj__F1(type)
});
$c_Lamf_core_rdf_helper_PluginEntitiesFacade.prototype.init___Lamf_core_parser_ParserContext = (function(ctx) {
  this.ctx$1 = ctx;
  this.cache$1 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.sorter$1 = new $c_Lamf_core_rdf_helper_DefaultNodeClassSorter().init___();
  return this
});
$c_Lamf_core_rdf_helper_PluginEntitiesFacade.prototype.isUnitModel__p1__Lamf_core_metamodel_Obj__Z = (function(typeModel) {
  return ((($is_Lamf_core_metamodel_document_DocumentModel(typeModel) || $is_Lamf_core_model_document_EncodesModel(typeModel)) || $is_Lamf_core_model_document_DeclaresModel(typeModel)) || $is_Lamf_core_metamodel_document_BaseUnitModel(typeModel))
});
$c_Lamf_core_rdf_helper_PluginEntitiesFacade.prototype.retrieveType__T__Lamf_core_rdf_Node__Z__s_Option = (function(id, node, findBaseUnit) {
  var types = this.sorter$1.sortedClassesOf__Lamf_core_rdf_Node__sc_Seq(node);
  var this$1 = types.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, findBaseUnit$1) {
    return (function(t$2) {
      var t = $as_T(t$2);
      var maybeFoundType = $this.findType__p1__T__s_Option(t);
      var rc5 = false;
      var x2 = null;
      if ((maybeFoundType instanceof $c_s_Some)) {
        rc5 = true;
        x2 = $as_s_Some(maybeFoundType);
        var typeModel = $as_Lamf_core_metamodel_Obj(x2.value$2);
        if (((!findBaseUnit$1) && (!$this.isUnitModel__p1__Lamf_core_metamodel_Obj__Z(typeModel)))) {
          return true
        }
      };
      if (rc5) {
        var typeModel$2 = $as_Lamf_core_metamodel_Obj(x2.value$2);
        if ((findBaseUnit$1 && $this.isUnitModel__p1__Lamf_core_metamodel_Obj__Z(typeModel$2))) {
          return true
        }
      };
      return false
    })
  })(this, findBaseUnit)));
  var foundType = (this$1.isEmpty__Z() ? types.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
    return (function(x$1$2) {
      var x$1 = $as_T(x$1$2);
      return $this$1.findType__p1__T__s_Option(x$1).isDefined__Z()
    })
  })(this))) : this$1);
  if ((foundType instanceof $c_s_Some)) {
    var x2$1 = $as_s_Some(foundType);
    var t$3 = $as_T(x2$1.value$2);
    return this.findType__p1__T__s_Option(t$3)
  } else {
    var x = $m_s_None$();
    if ((x === foundType)) {
      var this$2 = this.ctx$1.eh$1;
      var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnableToParseNode$1;
      var message = ("Error parsing JSON-LD node, unknown @types " + types);
      var location = this.ctx$1.rootContextDocument$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__T__V(this$2, specification, id, message, location);
      return $m_s_None$()
    } else {
      throw new $c_s_MatchError().init___O(foundType)
    }
  }
});
var $d_Lamf_core_rdf_helper_PluginEntitiesFacade = new $TypeData().initClass({
  Lamf_core_rdf_helper_PluginEntitiesFacade: 0
}, false, "amf.core.rdf.helper.PluginEntitiesFacade", {
  Lamf_core_rdf_helper_PluginEntitiesFacade: 1,
  O: 1
});
$c_Lamf_core_rdf_helper_PluginEntitiesFacade.prototype.$classData = $d_Lamf_core_rdf_helper_PluginEntitiesFacade;
/** @constructor */
function $c_Lamf_core_rdf_parsers_AnnotationName$() {
  $c_O.call(this)
}
$c_Lamf_core_rdf_parsers_AnnotationName$.prototype = new $h_O();
$c_Lamf_core_rdf_parsers_AnnotationName$.prototype.constructor = $c_Lamf_core_rdf_parsers_AnnotationName$;
/** @constructor */
function $h_Lamf_core_rdf_parsers_AnnotationName$() {
  /*<skip>*/
}
$h_Lamf_core_rdf_parsers_AnnotationName$.prototype = $c_Lamf_core_rdf_parsers_AnnotationName$.prototype;
$c_Lamf_core_rdf_parsers_AnnotationName$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_rdf_parsers_AnnotationName$.prototype.unapply__T__s_Option = (function(uri) {
  var prefix = $m_Lamf_core_vocabulary_Namespace$().SourceMaps$1.base$1;
  if ((($uI(uri.length) >= 0) && ($as_T(uri.substring(0, $uI(prefix.length))) === prefix))) {
    var beginIndex = ((1 + $uI(uri.indexOf("#"))) | 0);
    return new $c_s_Some().init___O($as_T(uri.substring(beginIndex)))
  } else {
    return $m_s_None$()
  }
});
var $d_Lamf_core_rdf_parsers_AnnotationName$ = new $TypeData().initClass({
  Lamf_core_rdf_parsers_AnnotationName$: 0
}, false, "amf.core.rdf.parsers.AnnotationName$", {
  Lamf_core_rdf_parsers_AnnotationName$: 1,
  O: 1
});
$c_Lamf_core_rdf_parsers_AnnotationName$.prototype.$classData = $d_Lamf_core_rdf_parsers_AnnotationName$;
var $n_Lamf_core_rdf_parsers_AnnotationName$ = (void 0);
function $m_Lamf_core_rdf_parsers_AnnotationName$() {
  if ((!$n_Lamf_core_rdf_parsers_AnnotationName$)) {
    $n_Lamf_core_rdf_parsers_AnnotationName$ = new $c_Lamf_core_rdf_parsers_AnnotationName$().init___()
  };
  return $n_Lamf_core_rdf_parsers_AnnotationName$
}
/** @constructor */
function $c_Lamf_core_rdf_parsers_DynamicLiteralParser$() {
  $c_O.call(this)
}
$c_Lamf_core_rdf_parsers_DynamicLiteralParser$.prototype = new $h_O();
$c_Lamf_core_rdf_parsers_DynamicLiteralParser$.prototype.constructor = $c_Lamf_core_rdf_parsers_DynamicLiteralParser$;
/** @constructor */
function $h_Lamf_core_rdf_parsers_DynamicLiteralParser$() {
  /*<skip>*/
}
$h_Lamf_core_rdf_parsers_DynamicLiteralParser$.prototype = $c_Lamf_core_rdf_parsers_DynamicLiteralParser$.prototype;
$c_Lamf_core_rdf_parsers_DynamicLiteralParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_rdf_parsers_DynamicLiteralParser$.prototype.parse__Lamf_core_rdf_Literal__Lamf_core_model_domain_ScalarNode = (function(l) {
  var this$1 = $m_Lamf_core_model_domain_ScalarNode$();
  var dataType = $m_s_None$();
  var result = this$1.apply__T__s_Option__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode("", dataType, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
  var this$3 = l.literalType$2;
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var t = $as_T(arg1);
    result.withDataType__T__Lamf_core_model_domain_ScalarNode(t)
  };
  var v = l.value$1;
  result.withValue__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode(v, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
  return result
});
var $d_Lamf_core_rdf_parsers_DynamicLiteralParser$ = new $TypeData().initClass({
  Lamf_core_rdf_parsers_DynamicLiteralParser$: 0
}, false, "amf.core.rdf.parsers.DynamicLiteralParser$", {
  Lamf_core_rdf_parsers_DynamicLiteralParser$: 1,
  O: 1
});
$c_Lamf_core_rdf_parsers_DynamicLiteralParser$.prototype.$classData = $d_Lamf_core_rdf_parsers_DynamicLiteralParser$;
var $n_Lamf_core_rdf_parsers_DynamicLiteralParser$ = (void 0);
function $m_Lamf_core_rdf_parsers_DynamicLiteralParser$() {
  if ((!$n_Lamf_core_rdf_parsers_DynamicLiteralParser$)) {
    $n_Lamf_core_rdf_parsers_DynamicLiteralParser$ = new $c_Lamf_core_rdf_parsers_DynamicLiteralParser$().init___()
  };
  return $n_Lamf_core_rdf_parsers_DynamicLiteralParser$
}
/** @constructor */
function $c_Lamf_core_rdf_parsers_SourceNodeParser() {
  $c_O.call(this);
  this.linkFinder$1 = null
}
$c_Lamf_core_rdf_parsers_SourceNodeParser.prototype = new $h_O();
$c_Lamf_core_rdf_parsers_SourceNodeParser.prototype.constructor = $c_Lamf_core_rdf_parsers_SourceNodeParser;
/** @constructor */
function $h_Lamf_core_rdf_parsers_SourceNodeParser() {
  /*<skip>*/
}
$h_Lamf_core_rdf_parsers_SourceNodeParser.prototype = $c_Lamf_core_rdf_parsers_SourceNodeParser.prototype;
$c_Lamf_core_rdf_parsers_SourceNodeParser.prototype.parse__Lamf_core_rdf_Node__Lamf_core_model_document_SourceMap = (function(node) {
  var result = $m_Lamf_core_model_document_SourceMap$().apply__Lamf_core_model_document_SourceMap();
  node.getKeys__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, result$1, node$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T(x0$1$2);
      matchEnd4$2: {
        var o7 = $m_Lamf_core_rdf_parsers_AnnotationName$().unapply__T__s_Option(x0$1);
        if ((!o7.isEmpty__Z())) {
          var annotation = $as_T(o7.get__O());
          var consumer = result$1.annotation__T__F2(annotation);
          var x1$2 = node$1.getProperties__T__s_Option(x0$1);
          if ((x1$2 instanceof $c_s_Some)) {
            var x2 = $as_s_Some(x1$2);
            var properties = $as_sc_Seq(x2.value$2);
            properties.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, consumer$1) {
              return (function(property$2) {
                var property = $as_Lamf_core_rdf_PropertyObject(property$2);
                var x1 = $this$1.linkFinder$1.findLink__Lamf_core_rdf_PropertyObject__s_Option(property);
                if ((x1 instanceof $c_s_Some)) {
                  var x2$1 = $as_s_Some(x1);
                  var linkedNode = $as_Lamf_core_rdf_Node(x2$1.value$2);
                  var k = $as_Lamf_core_rdf_PropertyObject($as_sc_IterableLike(linkedNode.getProperties__T__s_Option($m_Lamf_core_metamodel_document_SourceMapModel$().Element$1.value$1.iri__T()).get__O()).head__O());
                  var v = $as_Lamf_core_rdf_PropertyObject($as_sc_IterableLike(linkedNode.getProperties__T__s_Option($m_Lamf_core_metamodel_document_SourceMapModel$().Value$1.value$1.iri__T()).get__O()).head__O());
                  $asUnit(consumer$1.apply__O__O__O(k.value__T(), v.value__T()))
                }
              })
            })($this, consumer)))
          };
          break matchEnd4$2
        }
      }
    })
  })(this, result, node)));
  return result
});
$c_Lamf_core_rdf_parsers_SourceNodeParser.prototype.init___Lamf_core_rdf_graph_NodeFinder = (function(linkFinder) {
  this.linkFinder$1 = linkFinder;
  return this
});
var $d_Lamf_core_rdf_parsers_SourceNodeParser = new $TypeData().initClass({
  Lamf_core_rdf_parsers_SourceNodeParser: 0
}, false, "amf.core.rdf.parsers.SourceNodeParser", {
  Lamf_core_rdf_parsers_SourceNodeParser: 1,
  O: 1
});
$c_Lamf_core_rdf_parsers_SourceNodeParser.prototype.$classData = $d_Lamf_core_rdf_parsers_SourceNodeParser;
/** @constructor */
function $c_Lamf_core_rdf_parsers_SourcesRetriever() {
  $c_O.call(this);
  this.linkFinder$1 = null
}
$c_Lamf_core_rdf_parsers_SourcesRetriever.prototype = new $h_O();
$c_Lamf_core_rdf_parsers_SourcesRetriever.prototype.constructor = $c_Lamf_core_rdf_parsers_SourcesRetriever;
/** @constructor */
function $h_Lamf_core_rdf_parsers_SourcesRetriever() {
  /*<skip>*/
}
$h_Lamf_core_rdf_parsers_SourcesRetriever.prototype = $c_Lamf_core_rdf_parsers_SourcesRetriever.prototype;
$c_Lamf_core_rdf_parsers_SourcesRetriever.prototype.init___Lamf_core_rdf_graph_NodeFinder = (function(linkFinder) {
  this.linkFinder$1 = linkFinder;
  return this
});
$c_Lamf_core_rdf_parsers_SourcesRetriever.prototype.retrieve__Lamf_core_rdf_Node__Lamf_core_model_document_SourceMap = (function(node) {
  var this$1 = node.getProperties__T__s_Option($m_Lamf_core_metamodel_domain_DomainElementModel$().Sources$1.value$1.iri__T());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var properties = $as_sc_Seq(arg1);
    if (properties.nonEmpty__Z()) {
      var x1 = this.linkFinder$1.findLink__Lamf_core_rdf_PropertyObject__s_Option($as_Lamf_core_rdf_PropertyObject(properties.head__O()));
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var sourceNode = $as_Lamf_core_rdf_Node(x2.value$2);
        var this$2 = new $c_s_Some().init___O(new $c_Lamf_core_rdf_parsers_SourceNodeParser().init___Lamf_core_rdf_graph_NodeFinder(this.linkFinder$1).parse__Lamf_core_rdf_Node__Lamf_core_model_document_SourceMap(sourceNode))
      } else {
        var this$2 = $m_s_None$()
      }
    } else {
      var this$2 = $m_s_None$()
    }
  };
  return $as_Lamf_core_model_document_SourceMap((this$2.isEmpty__Z() ? $m_Lamf_core_model_document_SourceMap$().empty$1 : this$2.get__O()))
});
var $d_Lamf_core_rdf_parsers_SourcesRetriever = new $TypeData().initClass({
  Lamf_core_rdf_parsers_SourcesRetriever: 0
}, false, "amf.core.rdf.parsers.SourcesRetriever", {
  Lamf_core_rdf_parsers_SourcesRetriever: 1,
  O: 1
});
$c_Lamf_core_rdf_parsers_SourcesRetriever.prototype.$classData = $d_Lamf_core_rdf_parsers_SourcesRetriever;
/** @constructor */
function $c_Lamf_core_registries_AMFDomainRegistry$() {
  $c_O.call(this);
  this.annotationsRegistry$1 = null;
  this.metadataRegistry$1 = null;
  this.metadataResolverRegistry$1 = null
}
$c_Lamf_core_registries_AMFDomainRegistry$.prototype = new $h_O();
$c_Lamf_core_registries_AMFDomainRegistry$.prototype.constructor = $c_Lamf_core_registries_AMFDomainRegistry$;
/** @constructor */
function $h_Lamf_core_registries_AMFDomainRegistry$() {
  /*<skip>*/
}
$h_Lamf_core_registries_AMFDomainRegistry$.prototype = $c_Lamf_core_registries_AMFDomainRegistry$.prototype;
$c_Lamf_core_registries_AMFDomainRegistry$.prototype.init___ = (function() {
  $n_Lamf_core_registries_AMFDomainRegistry$ = this;
  this.annotationsRegistry$1 = this.map__p1__I__sci_Map__scm_HashMap(1024, $m_Lamf_core_plugin_CorePlugin$().serializableAnnotations__sci_Map());
  var jsx$2 = $m_Lamf_core_plugin_CorePlugin$().modelEntities__sc_Seq();
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(t$2) {
      var t = $as_Lamf_core_metamodel_Obj(t$2);
      var self = $m_Lamf_core_registries_AMFDomainRegistry$().defaultIri__Lamf_core_metamodel_Obj__T(t);
      return new $c_T2().init___O__O(self, t)
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  this.metadataRegistry$1 = this.map__p1__I__sci_Map__scm_HashMap(1024, $as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2));
  $m_scm_ListBuffer$();
  var this$5 = new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_ListBuffer().init___());
  this.metadataResolverRegistry$1 = $as_scm_ListBuffer($as_sc_GenTraversable(this$5.elems$1));
  return this
});
$c_Lamf_core_registries_AMFDomainRegistry$.prototype.registerModelEntityResolver__Lamf_core_registries_AMFDomainEntityResolver__V = (function(resolver) {
  var this$3 = this.metadataResolverRegistry$1;
  var array = [resolver];
  var elems = new $c_sjs_js_WrappedArray().init___sjs_js_Array(array);
  this$3.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(elems)
});
$c_Lamf_core_registries_AMFDomainRegistry$.prototype.map__p1__I__sci_Map__scm_HashMap = (function(size, elems) {
  var r = new $c_Lamf_core_registries_AMFDomainRegistry$$anon$1().init___();
  return $as_scm_HashMap($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(r, elems))
});
$c_Lamf_core_registries_AMFDomainRegistry$.prototype.buildType__Lamf_core_metamodel_Obj__s_Option = (function(modelType) {
  var this$1 = this.metadataResolverRegistry$1;
  return $as_sc_TraversableLike($as_sci_Stream($as_sc_TraversableLike(this$1.scala$collection$mutable$ListBuffer$$start$6.toStream__sci_Stream().map__F1__scg_CanBuildFrom__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, modelType$1) {
    return (function(x$4$2) {
      var x$4 = $as_Lamf_core_registries_AMFDomainEntityResolver(x$4$2);
      return x$4.buildType__Lamf_core_metamodel_Obj__s_Option(modelType$1)
    })
  })(this, modelType)), ($m_sci_Stream$(), new $c_sci_Stream$StreamCanBuildFrom().init___()))).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$5$2) {
      var x$5 = $as_s_Option(x$5$2);
      return x$5.isDefined__Z()
    })
  })(this)))).map__F1__scg_CanBuildFrom__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3) {
    return (function(x$6$2) {
      var x$6 = $as_s_Option(x$6$2);
      return $as_F1(x$6.get__O())
    })
  })(this)), ($m_sci_Stream$(), new $c_sci_Stream$StreamCanBuildFrom().init___()))).headOption__s_Option()
});
$c_Lamf_core_registries_AMFDomainRegistry$.prototype.findType__T__s_Option = (function(typeString) {
  var this$1 = this.metadataResolverRegistry$1;
  return $as_sc_TraversableLike($as_sci_Stream($as_sc_TraversableLike(this$1.scala$collection$mutable$ListBuffer$$start$6.toStream__sci_Stream().map__F1__scg_CanBuildFrom__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, typeString$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_registries_AMFDomainEntityResolver(x$1$2);
      return x$1.findType__T__s_Option(typeString$1)
    })
  })(this, typeString)), ($m_sci_Stream$(), new $c_sci_Stream$StreamCanBuildFrom().init___()))).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$2$2) {
      var x$2 = $as_s_Option(x$2$2);
      return x$2.isDefined__Z()
    })
  })(this)))).map__F1__scg_CanBuildFrom__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3) {
    return (function(x$3$2) {
      var x$3 = $as_s_Option(x$3$2);
      return $as_Lamf_core_metamodel_Obj(x$3.get__O())
    })
  })(this)), ($m_sci_Stream$(), new $c_sci_Stream$StreamCanBuildFrom().init___()))).headOption__s_Option()
});
$c_Lamf_core_registries_AMFDomainRegistry$.prototype.registerModelEntity__Lamf_core_metamodel_Obj__s_Option = (function(entity) {
  return this.metadataRegistry$1.put__O__O__s_Option(this.defaultIri__Lamf_core_metamodel_Obj__T(entity), entity)
});
$c_Lamf_core_registries_AMFDomainRegistry$.prototype.defaultIri__Lamf_core_metamodel_Obj__T = (function(metadata) {
  return $as_Lamf_core_vocabulary_ValueType(metadata.type__sci_List().head__O()).iri__T()
});
var $d_Lamf_core_registries_AMFDomainRegistry$ = new $TypeData().initClass({
  Lamf_core_registries_AMFDomainRegistry$: 0
}, false, "amf.core.registries.AMFDomainRegistry$", {
  Lamf_core_registries_AMFDomainRegistry$: 1,
  O: 1
});
$c_Lamf_core_registries_AMFDomainRegistry$.prototype.$classData = $d_Lamf_core_registries_AMFDomainRegistry$;
var $n_Lamf_core_registries_AMFDomainRegistry$ = (void 0);
function $m_Lamf_core_registries_AMFDomainRegistry$() {
  if ((!$n_Lamf_core_registries_AMFDomainRegistry$)) {
    $n_Lamf_core_registries_AMFDomainRegistry$ = new $c_Lamf_core_registries_AMFDomainRegistry$().init___()
  };
  return $n_Lamf_core_registries_AMFDomainRegistry$
}
/** @constructor */
function $c_Lamf_core_registries_AMFPluginsRegistry$() {
  $c_O.call(this);
  this.syntaxPluginIDRegistry$1 = null;
  this.syntaxPluginRegistry$1 = null;
  this.documentPluginRegistry$1 = null;
  this.documentPluginIDRegistry$1 = null;
  this.documentPluginVendorsRegistry$1 = null;
  this.domainPluginRegistry$1 = null;
  this.featurePluginIDRegistry$1 = null;
  this.featurePlugin$1 = null;
  this.payloadValidationPluginRegistry$1 = null;
  this.payloadValidationPluginIDRegistry$1 = null
}
$c_Lamf_core_registries_AMFPluginsRegistry$.prototype = new $h_O();
$c_Lamf_core_registries_AMFPluginsRegistry$.prototype.constructor = $c_Lamf_core_registries_AMFPluginsRegistry$;
/** @constructor */
function $h_Lamf_core_registries_AMFPluginsRegistry$() {
  /*<skip>*/
}
$h_Lamf_core_registries_AMFPluginsRegistry$.prototype = $c_Lamf_core_registries_AMFPluginsRegistry$.prototype;
$c_Lamf_core_registries_AMFPluginsRegistry$.prototype.init___ = (function() {
  $n_Lamf_core_registries_AMFPluginsRegistry$ = this;
  this.syntaxPluginIDRegistry$1 = $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.syntaxPluginRegistry$1 = $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.documentPluginRegistry$1 = $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.documentPluginIDRegistry$1 = $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.documentPluginVendorsRegistry$1 = $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.domainPluginRegistry$1 = $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.featurePluginIDRegistry$1 = $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.featurePlugin$1 = $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.payloadValidationPluginRegistry$1 = $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.payloadValidationPluginIDRegistry$1 = $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  return this
});
$c_Lamf_core_registries_AMFPluginsRegistry$.prototype.cleanMediaType__T__T = (function(mediaType) {
  if (($uI(mediaType.indexOf(";")) !== (-1))) {
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(mediaType, ";", 0);
    var this$6 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    return $as_T($f_sc_IndexedSeqOptimized__head__O(this$6))
  } else {
    return mediaType
  }
});
$c_Lamf_core_registries_AMFPluginsRegistry$.prototype.simpleMediaType__T__T = (function(mediaType) {
  var x1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(mediaType, "/", 0);
  var o8 = $m_s_Array$().unapplySeq__O__s_Option(x1);
  if (((!o8.isEmpty__Z()) && ((o8.get__O() !== null) && ($as_sc_SeqLike(o8.get__O()).lengthCompare__I__I(2) === 0)))) {
    var main = $as_T($as_sc_SeqLike(o8.get__O()).apply__I__O(0));
    var sub = $as_T($as_sc_SeqLike(o8.get__O()).apply__I__O(1));
    if (($uI(sub.indexOf("+")) > (-1))) {
      var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(sub, "\\+", 0);
      var this$6 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
      return ((main + "/") + $f_sc_IndexedSeqOptimized__last__O(this$6))
    }
  };
  var o10 = $m_s_Array$().unapplySeq__O__s_Option(x1);
  if (((!o10.isEmpty__Z()) && ((o10.get__O() !== null) && ($as_sc_SeqLike(o10.get__O()).lengthCompare__I__I(2) === 0)))) {
    var main$2 = $as_T($as_sc_SeqLike(o10.get__O()).apply__I__O(0));
    var sub$2 = $as_T($as_sc_SeqLike(o10.get__O()).apply__I__O(1));
    if (($uI(sub$2.indexOf(".")) > (-1))) {
      var xs$1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(sub$2, "\\.", 0);
      var this$11 = new $c_scm_ArrayOps$ofRef().init___AO(xs$1);
      return ((main$2 + "/") + $f_sc_IndexedSeqOptimized__last__O(this$11))
    }
  };
  return mediaType
});
$c_Lamf_core_registries_AMFPluginsRegistry$.prototype.registerDependencies__Lamf_client_plugins_AMFPlugin__V = (function(plugin) {
  plugin.dependencies__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_client_plugins_AMFPlugin(x0$1$2);
      if ((x0$1 instanceof $c_Lamf_client_plugins_AMFDomainPlugin)) {
        var x2 = $as_Lamf_client_plugins_AMFDomainPlugin(x0$1);
        $m_Lamf_core_registries_AMFPluginsRegistry$().registerDomainPlugin__Lamf_client_plugins_AMFDomainPlugin__V(x2)
      } else if ((x0$1 instanceof $c_Lamf_client_plugins_AMFDocumentPlugin)) {
        var x3 = $as_Lamf_client_plugins_AMFDocumentPlugin(x0$1);
        $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V(x3)
      } else if ((x0$1 instanceof $c_Lamf_client_plugins_AMFSyntaxPlugin)) {
        var x4 = $as_Lamf_client_plugins_AMFSyntaxPlugin(x0$1);
        $m_Lamf_core_registries_AMFPluginsRegistry$().registerSyntaxPlugin__Lamf_client_plugins_AMFSyntaxPlugin__V(x4)
      }
    })
  })(this)))
});
$c_Lamf_core_registries_AMFPluginsRegistry$.prototype.registerSyntaxPlugin__Lamf_client_plugins_AMFSyntaxPlugin__V = (function(syntaxPlugin) {
  var x1 = this.syntaxPluginIDRegistry$1.get__O__s_Option(syntaxPlugin.ID__T());
  if ((!(x1 instanceof $c_s_Some))) {
    var x = $m_s_None$();
    if ((x === x1)) {
      this.syntaxPluginIDRegistry$1.put__O__O__s_Option(syntaxPlugin.ID__T(), syntaxPlugin);
      syntaxPlugin.supportedMediaTypes__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, syntaxPlugin$1) {
        return (function(mediaType$2) {
          var mediaType = $as_T(mediaType$2);
          var rc6 = false;
          var x2 = null;
          var x1$1 = $m_Lamf_core_registries_AMFPluginsRegistry$().syntaxPluginRegistry$1.get__O__s_Option(mediaType);
          if ((x1$1 instanceof $c_s_Some)) {
            rc6 = true;
            x2 = $as_s_Some(x1$1);
            var plugin = $as_Lamf_client_plugins_AMFSyntaxPlugin(x2.value$2);
            if ((plugin.ID__T() === syntaxPlugin$1.ID__T())) {
              return (void 0)
            }
          };
          var x$1 = $m_s_None$();
          if ((x$1 === x1$1)) {
            return $m_Lamf_core_registries_AMFPluginsRegistry$().syntaxPluginRegistry$1.put__O__O__s_Option(mediaType, syntaxPlugin$1)
          };
          if (rc6) {
            var plugin$2 = $as_Lamf_client_plugins_AMFSyntaxPlugin(x2.value$2);
            throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T((((((("Cannot register " + syntaxPlugin$1.ID__T()) + " for media type ") + mediaType) + ", ") + plugin$2.ID__T()) + " already registered")))
          };
          throw new $c_s_MatchError().init___O(x1$1)
        })
      })(this, syntaxPlugin)));
      this.registerDependencies__Lamf_client_plugins_AMFPlugin__V(syntaxPlugin)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_core_registries_AMFPluginsRegistry$.prototype.registerDomainPlugin__Lamf_client_plugins_AMFDomainPlugin__V = (function(domainPlugin) {
  var x1 = this.domainPluginRegistry$1.get__O__s_Option(domainPlugin.ID__T());
  if ((!(x1 instanceof $c_s_Some))) {
    var x = $m_s_None$();
    if ((x === x1)) {
      domainPlugin.serializableAnnotations__sci_Map().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x0$1$2) {
          var x0$1 = $as_T2(x0$1$2);
          if ((x0$1 !== null)) {
            var name = $as_T(x0$1.$$und1__O());
            var unloader = $as_Lamf_core_model_domain_AnnotationGraphLoader(x0$1.$$und2__O());
            var this$1 = $m_Lamf_core_registries_AMFDomainRegistry$();
            return this$1.annotationsRegistry$1.put__O__O__s_Option(name, unloader)
          } else {
            throw new $c_s_MatchError().init___O(x0$1)
          }
        })
      })(this)));
      this.domainPluginRegistry$1.put__O__O__s_Option(domainPlugin.ID__T(), domainPlugin);
      domainPlugin.modelEntities__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
        return (function(entity$2) {
          var entity = $as_Lamf_core_metamodel_Obj(entity$2);
          return $m_Lamf_core_registries_AMFDomainRegistry$().registerModelEntity__Lamf_core_metamodel_Obj__s_Option(entity)
        })
      })(this)));
      this.registerDependencies__Lamf_client_plugins_AMFPlugin__V(domainPlugin)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_core_registries_AMFPluginsRegistry$.prototype.documentPluginForVendor__T__sc_Seq = (function(vendor) {
  var this$1 = this.documentPluginVendorsRegistry$1;
  var x1 = this$1.get__O__s_Option(vendor);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var v = x2.value$2;
    var jsx$1 = v
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var jsx$1 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
  };
  return $as_sc_Seq($as_sc_SeqLike(jsx$1).sortBy__F1__s_math_Ordering__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_client_plugins_AMFDocumentPlugin(x$2$2);
      return x$2.priority__I()
    })
  })(this)), $m_s_math_Ordering$Int$()))
});
$c_Lamf_core_registries_AMFPluginsRegistry$.prototype.plugins__sc_Iterable = (function() {
  var this$1 = this.syntaxPluginIDRegistry$1;
  var this$4 = new $c_scm_HashMap$$anon$2().init___scm_HashMap(this$1);
  var this$2 = this.documentPluginIDRegistry$1;
  var that = new $c_scm_HashMap$$anon$2().init___scm_HashMap(this$2);
  var this$3 = $m_sc_Iterable$();
  var bf = this$3.ReusableCBFInstance$2;
  var jsx$4 = $as_sc_TraversableLike($f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this$4, that, bf));
  var this$5 = this.domainPluginRegistry$1;
  var jsx$3 = new $c_scm_HashMap$$anon$2().init___scm_HashMap(this$5);
  var this$6 = $m_sc_Iterable$();
  var jsx$2 = $as_sc_TraversableLike(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$6.ReusableCBFInstance$2));
  var this$7 = this.featurePluginIDRegistry$1;
  var jsx$1 = new $c_scm_HashMap$$anon$2().init___scm_HashMap(this$7);
  var this$8 = $m_sc_Iterable$();
  return $as_sc_Iterable(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$8.ReusableCBFInstance$2))
});
$c_Lamf_core_registries_AMFPluginsRegistry$.prototype.dataNodeValidatorPluginForMediaType__T__sc_Seq = (function(mediaType) {
  var this$1 = this.payloadValidationPluginRegistry$1;
  var x1 = this$1.get__O__s_Option(mediaType);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var v = x2.value$2;
    var jsx$1 = v
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var jsx$1 = $m_sci_Nil$()
  };
  return $as_sc_Seq(jsx$1)
});
$c_Lamf_core_registries_AMFPluginsRegistry$.prototype.syntaxPluginForMediaType__T__s_Option = (function(mediaType) {
  var normalizedMediaType = this.cleanMediaType__T__T(mediaType);
  var x1 = this.syntaxPluginRegistry$1.get__O__s_Option(mediaType);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var plugin = $as_Lamf_client_plugins_AMFSyntaxPlugin(x2.value$2);
    return new $c_s_Some().init___O(plugin)
  } else {
    return this.syntaxPluginRegistry$1.get__O__s_Option(this.simpleMediaType__T__T(normalizedMediaType))
  }
});
$c_Lamf_core_registries_AMFPluginsRegistry$.prototype.registerFeaturePlugin__Lamf_client_plugins_AMFFeaturePlugin__V = (function(featurePlugin) {
  var x1 = this.featurePluginIDRegistry$1.get__O__s_Option(featurePlugin.ID$1);
  if ((!(x1 instanceof $c_s_Some))) {
    var x = $m_s_None$();
    if ((x === x1)) {
      this.featurePluginIDRegistry$1.put__O__O__s_Option(featurePlugin.ID$1, featurePlugin);
      this.registerDependencies__Lamf_client_plugins_AMFPlugin__V(featurePlugin)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_core_registries_AMFPluginsRegistry$.prototype.featurePlugins__sc_Seq = (function() {
  var this$1 = this.featurePluginIDRegistry$1;
  var this$2 = new $c_scm_HashMap$$anon$2().init___scm_HashMap(this$1);
  return this$2.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream()
});
$c_Lamf_core_registries_AMFPluginsRegistry$.prototype.registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V = (function(documentPlugin) {
  var x1 = this.documentPluginIDRegistry$1.get__O__s_Option(documentPlugin.ID__T());
  if ((!(x1 instanceof $c_s_Some))) {
    var x = $m_s_None$();
    if ((x === x1)) {
      this.documentPluginIDRegistry$1.put__O__O__s_Option(documentPlugin.ID__T(), documentPlugin);
      documentPlugin.serializableAnnotations__sci_Map().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x0$1$2) {
          var x0$1 = $as_T2(x0$1$2);
          if ((x0$1 !== null)) {
            var name = $as_T(x0$1.$$und1__O());
            var unloader = $as_Lamf_core_model_domain_AnnotationGraphLoader(x0$1.$$und2__O());
            var this$1 = $m_Lamf_core_registries_AMFDomainRegistry$();
            return this$1.annotationsRegistry$1.put__O__O__s_Option(name, unloader)
          } else {
            throw new $c_s_MatchError().init___O(x0$1)
          }
        })
      })(this)));
      documentPlugin.documentSyntaxes__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, documentPlugin$1) {
        return (function(mediaType$2) {
          var mediaType = $as_T(mediaType$2);
          var this$3 = $m_Lamf_core_registries_AMFPluginsRegistry$().documentPluginRegistry$1;
          var x1$1 = this$3.get__O__s_Option(mediaType);
          if ((x1$1 instanceof $c_s_Some)) {
            var x2 = $as_s_Some(x1$1);
            var v = x2.value$2;
            var jsx$1 = v
          } else {
            var x$1 = $m_s_None$();
            if ((!(x$1 === x1$1))) {
              throw new $c_s_MatchError().init___O(x1$1)
            };
            var jsx$1 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
          };
          var plugins = $as_sc_Seq(jsx$1);
          var jsx$4 = $m_Lamf_core_registries_AMFPluginsRegistry$().documentPluginRegistry$1;
          var jsx$3 = $m_sc_Seq$();
          var array = [documentPlugin$1];
          var jsx$2 = jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
          var this$6 = $m_sc_Seq$();
          return jsx$4.put__O__O__s_Option(mediaType, plugins.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$6.ReusableCBFInstance$2))
        })
      })(this, documentPlugin)));
      documentPlugin.vendors__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, documentPlugin$2) {
        return (function(vendor$2) {
          var vendor = $as_T(vendor$2);
          var this$7 = $m_Lamf_core_registries_AMFPluginsRegistry$().documentPluginVendorsRegistry$1;
          var x1$2 = this$7.get__O__s_Option(vendor);
          if ((x1$2 instanceof $c_s_Some)) {
            var x2$1 = $as_s_Some(x1$2);
            var v$1 = x2$1.value$2;
            var jsx$5 = v$1
          } else {
            var x$2 = $m_s_None$();
            if ((!(x$2 === x1$2))) {
              throw new $c_s_MatchError().init___O(x1$2)
            };
            var jsx$5 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
          };
          var plugins$1 = $as_sc_Seq(jsx$5);
          var jsx$8 = $m_Lamf_core_registries_AMFPluginsRegistry$().documentPluginVendorsRegistry$1;
          var jsx$7 = $m_sc_Seq$();
          var array$1 = [documentPlugin$2];
          var jsx$6 = jsx$7.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
          var this$10 = $m_sc_Seq$();
          return jsx$8.put__O__O__s_Option(vendor, plugins$1.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$6, this$10.ReusableCBFInstance$2))
        })
      })(this, documentPlugin)));
      documentPlugin.modelEntities__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
        return (function(entity$2) {
          var entity = $as_Lamf_core_metamodel_Obj(entity$2);
          return $m_Lamf_core_registries_AMFDomainRegistry$().registerModelEntity__Lamf_core_metamodel_Obj__s_Option(entity)
        })
      })(this)));
      var this$11 = documentPlugin.modelEntitiesResolver__s_Option();
      if ((!this$11.isEmpty__Z())) {
        var arg1 = this$11.get__O();
        var resolver = $as_Lamf_core_registries_AMFDomainEntityResolver(arg1);
        $m_Lamf_core_registries_AMFDomainRegistry$().registerModelEntityResolver__Lamf_core_registries_AMFDomainEntityResolver__V(resolver)
      };
      this.registerDependencies__Lamf_client_plugins_AMFPlugin__V(documentPlugin)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_core_registries_AMFPluginsRegistry$.prototype.documentPluginForMediaType__T__sc_Seq = (function(mediaType) {
  var this$1 = this.documentPluginRegistry$1;
  var x1 = this$1.get__O__s_Option(mediaType);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var v = x2.value$2;
    var jsx$1 = v
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var jsx$1 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
  };
  return $as_sc_Seq($as_sc_SeqLike(jsx$1).sortBy__F1__s_math_Ordering__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_client_plugins_AMFDocumentPlugin(x$1$2);
      return x$1.priority__I()
    })
  })(this)), $m_s_math_Ordering$Int$()))
});
$c_Lamf_core_registries_AMFPluginsRegistry$.prototype.registerPayloadValidationPlugin__Lamf_core_validation_AMFPayloadValidationPlugin__V = (function(validationPlugin) {
  var x1 = this.payloadValidationPluginIDRegistry$1.get__O__s_Option(validationPlugin.ID__T());
  if ((!(x1 instanceof $c_s_Some))) {
    var x = $m_s_None$();
    if ((x === x1)) {
      validationPlugin.payloadMediaType__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, validationPlugin$1) {
        return (function(mt$2) {
          var mt = $as_T(mt$2);
          var rc7 = false;
          var x2 = null;
          var x1$1 = $m_Lamf_core_registries_AMFPluginsRegistry$().payloadValidationPluginRegistry$1.get__O__s_Option(mt);
          matchEnd8: {
            if ((x1$1 instanceof $c_s_Some)) {
              rc7 = true;
              x2 = $as_s_Some(x1$1);
              var list = $as_sc_Seq(x2.value$2);
              if ((!list.contains__O__Z(validationPlugin$1))) {
                var this$2 = $m_Lamf_core_registries_AMFPluginsRegistry$().payloadValidationPluginRegistry$1;
                var this$1 = $m_sc_Seq$();
                var value = list.$$colon$plus__O__scg_CanBuildFrom__O(validationPlugin$1, this$1.ReusableCBFInstance$2);
                this$2.put__O__O__s_Option(mt, value);
                var this$3 = $m_Lamf_core_registries_AMFPluginsRegistry$().payloadValidationPluginIDRegistry$1;
                var key = validationPlugin$1.ID__T();
                this$3.put__O__O__s_Option(key, validationPlugin$1);
                break matchEnd8
              }
            };
            var x$1 = $m_s_None$();
            if ((x$1 === x1$1)) {
              var this$6 = $m_Lamf_core_registries_AMFPluginsRegistry$().payloadValidationPluginRegistry$1;
              var jsx$1 = $m_sc_Seq$();
              var array = [validationPlugin$1];
              var value$1 = jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
              this$6.put__O__O__s_Option(mt, value$1);
              var this$7 = $m_Lamf_core_registries_AMFPluginsRegistry$().payloadValidationPluginIDRegistry$1;
              var key$1 = validationPlugin$1.ID__T();
              this$7.put__O__O__s_Option(key$1, validationPlugin$1);
              break matchEnd8
            };
            if (rc7) {
              break matchEnd8
            };
            throw new $c_s_MatchError().init___O(x1$1)
          }
        })
      })(this, validationPlugin)))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
var $d_Lamf_core_registries_AMFPluginsRegistry$ = new $TypeData().initClass({
  Lamf_core_registries_AMFPluginsRegistry$: 0
}, false, "amf.core.registries.AMFPluginsRegistry$", {
  Lamf_core_registries_AMFPluginsRegistry$: 1,
  O: 1
});
$c_Lamf_core_registries_AMFPluginsRegistry$.prototype.$classData = $d_Lamf_core_registries_AMFPluginsRegistry$;
var $n_Lamf_core_registries_AMFPluginsRegistry$ = (void 0);
function $m_Lamf_core_registries_AMFPluginsRegistry$() {
  if ((!$n_Lamf_core_registries_AMFPluginsRegistry$)) {
    $n_Lamf_core_registries_AMFPluginsRegistry$ = new $c_Lamf_core_registries_AMFPluginsRegistry$().init___()
  };
  return $n_Lamf_core_registries_AMFPluginsRegistry$
}
/** @constructor */
function $c_Lamf_core_remote_Absolute$() {
  $c_O.call(this)
}
$c_Lamf_core_remote_Absolute$.prototype = new $h_O();
$c_Lamf_core_remote_Absolute$.prototype.constructor = $c_Lamf_core_remote_Absolute$;
/** @constructor */
function $h_Lamf_core_remote_Absolute$() {
  /*<skip>*/
}
$h_Lamf_core_remote_Absolute$.prototype = $c_Lamf_core_remote_Absolute$.prototype;
$c_Lamf_core_remote_Absolute$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_remote_Absolute$.prototype.unapply__T__s_Option = (function(url) {
  return (($uI(url.indexOf(":")) !== (-1)) ? new $c_s_Some().init___O(url) : $m_s_None$())
});
var $d_Lamf_core_remote_Absolute$ = new $TypeData().initClass({
  Lamf_core_remote_Absolute$: 0
}, false, "amf.core.remote.Absolute$", {
  Lamf_core_remote_Absolute$: 1,
  O: 1
});
$c_Lamf_core_remote_Absolute$.prototype.$classData = $d_Lamf_core_remote_Absolute$;
var $n_Lamf_core_remote_Absolute$ = (void 0);
function $m_Lamf_core_remote_Absolute$() {
  if ((!$n_Lamf_core_remote_Absolute$)) {
    $n_Lamf_core_remote_Absolute$ = new $c_Lamf_core_remote_Absolute$().init___()
  };
  return $n_Lamf_core_remote_Absolute$
}
function $f_Lamf_core_remote_Async__$$init$__V($thiz) {
  var thiz = ("ASYNC " + $thiz.version__T());
  $thiz.amf$core$remote$Async$$undsetter$und$name$und$eq__T__V($as_T(thiz.trim()))
}
function $is_Lamf_core_remote_Async(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_remote_Async)))
}
function $as_Lamf_core_remote_Async(obj) {
  return (($is_Lamf_core_remote_Async(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.remote.Async"))
}
function $isArrayOf_Lamf_core_remote_Async(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_remote_Async)))
}
function $asArrayOf_Lamf_core_remote_Async(obj, depth) {
  return (($isArrayOf_Lamf_core_remote_Async(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.remote.Async;", depth))
}
/** @constructor */
function $c_Lamf_core_remote_Cache() {
  $c_O.call(this);
  this.cache$1 = null;
  this.dependencyGraph$1 = null
}
$c_Lamf_core_remote_Cache.prototype = new $h_O();
$c_Lamf_core_remote_Cache.prototype.constructor = $c_Lamf_core_remote_Cache;
/** @constructor */
function $h_Lamf_core_remote_Cache() {
  /*<skip>*/
}
$h_Lamf_core_remote_Cache.prototype = $c_Lamf_core_remote_Cache.prototype;
$c_Lamf_core_remote_Cache.prototype.addFromToEdge__T__T__V = (function(from, to) {
  var this$1 = this.dependencyGraph$1;
  var x1 = this$1.get__O__s_Option(to);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var v = x2.value$2;
    var jsx$1 = v
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var jsx$1 = $as_sci_Set($m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
  };
  var fromNodes = $as_sci_Set(jsx$1);
  this.dependencyGraph$1.update__O__O__V(to, fromNodes.$$plus__O__sc_Set(from))
});
$c_Lamf_core_remote_Cache.prototype.init___ = (function() {
  this.cache$1 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.dependencyGraph$1 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  return this
});
$c_Lamf_core_remote_Cache.prototype.findCycles__T__sci_List__s_Option = (function(node, acc) {
  $m_sci_List$();
  var array = [node];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$1 = result;
  var this$5 = $m_sci_List$();
  var fullPath = $as_sci_List(acc.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2));
  var jsx$2 = $f_sc_LinearSeqOptimized__length__I(fullPath);
  var this$6 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$6);
  if ((jsx$2 !== $as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(fullPath, cbf)).size__I())) {
    return new $c_s_Some().init___O(fullPath)
  } else {
    var this$7 = this.dependencyGraph$1;
    var x1 = this$7.get__O__s_Option(node);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var v = x2.value$2;
      var jsx$3 = v
    } else {
      var x$1 = $m_s_None$();
      if ((!(x$1 === x1))) {
        throw new $c_s_MatchError().init___O(x1)
      };
      var jsx$3 = $as_sci_Set($m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
    };
    var sources = $as_sci_Set(jsx$3);
    var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, fullPath$1) {
      return (function(source$2) {
        var source = $as_T(source$2);
        return this$2$1.findCycles__T__sci_List__s_Option(source, fullPath$1)
      })
    })(this, fullPath));
    var this$8 = $m_sci_Set$();
    var bf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$8);
    var maybeCycles = $as_sci_Set($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(sources, f, bf));
    var this$9 = maybeCycles.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
      return (function(x$1$2) {
        var x$1$1 = $as_s_Option(x$1$2);
        return x$1$1.isDefined__Z()
      })
    })(this)));
    if (this$9.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var x$2 = this$9.get__O();
      return $as_s_Option(x$2)
    }
  }
});
$c_Lamf_core_remote_Cache.prototype.beforeLast__sci_List__s_Option = (function(elms) {
  var lastTwo = elms.takeRight__I__sci_List(2);
  return (($f_sc_LinearSeqOptimized__length__I(lastTwo) === 2) ? $f_sc_TraversableLike__headOption__s_Option(lastTwo) : $m_s_None$())
});
var $d_Lamf_core_remote_Cache = new $TypeData().initClass({
  Lamf_core_remote_Cache: 0
}, false, "amf.core.remote.Cache", {
  Lamf_core_remote_Cache: 1,
  O: 1
});
$c_Lamf_core_remote_Cache.prototype.$classData = $d_Lamf_core_remote_Cache;
/** @constructor */
function $c_Lamf_core_remote_Context() {
  $c_O.call(this);
  this.platform$1 = null;
  this.history$1 = null;
  this.mappings$1 = null
}
$c_Lamf_core_remote_Context.prototype = new $h_O();
$c_Lamf_core_remote_Context.prototype.constructor = $c_Lamf_core_remote_Context;
/** @constructor */
function $h_Lamf_core_remote_Context() {
  /*<skip>*/
}
$h_Lamf_core_remote_Context.prototype = $c_Lamf_core_remote_Context.prototype;
$c_Lamf_core_remote_Context.prototype.concatWithoutDuplicateSlash__p1__T__T__T = (function(prefix, url) {
  var this$2 = new $c_sci_StringOps().init___T(prefix);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$2)) {
    var this$4 = new $c_sci_StringOps().init___T(prefix);
    var c = $f_sc_IndexedSeqOptimized__last__O(this$4);
    if ((c === null)) {
      var jsx$4 = 0
    } else {
      var this$6 = $as_jl_Character(c);
      var jsx$4 = this$6.value$1
    };
    var jsx$3 = (jsx$4 === 47)
  } else {
    var jsx$3 = false
  };
  if (jsx$3) {
    var this$8 = new $c_sci_StringOps().init___T(url);
    var jsx$2 = $f_sc_TraversableOnce__nonEmpty__Z(this$8)
  } else {
    var jsx$2 = false
  };
  if (jsx$2) {
    var this$10 = new $c_sci_StringOps().init___T(url);
    var c$1 = $f_sc_IndexedSeqOptimized__head__O(this$10);
    if ((c$1 === null)) {
      var jsx$5 = 0
    } else {
      var this$12 = $as_jl_Character(c$1);
      var jsx$5 = this$12.value$1
    };
    var jsx$1 = (jsx$5 === 47)
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var this$14 = new $c_sci_StringOps().init___T(url);
    var $$this = this$14.repr$1;
    var until = $uI($$this.length);
    return (("" + prefix) + $m_sci_StringOps$().slice$extension__T__I__I__T(this$14.repr$1, 1, until))
  } else {
    return (("" + prefix) + url)
  }
});
$c_Lamf_core_remote_Context.prototype.current__T = (function() {
  if (this.history$1.isEmpty__Z()) {
    return ""
  } else {
    var this$1 = this.history$1;
    return $as_T($f_sc_LinearSeqOptimized__last__O(this$1))
  }
});
$c_Lamf_core_remote_Context.prototype.update__T__Lamf_core_remote_Context = (function(url) {
  return $m_Lamf_core_remote_Context$().amf$core$remote$Context$$apply__Lamf_core_remote_Platform__sci_List__T__sci_Map__Lamf_core_remote_Context(this.platform$1, this.history$1, this.resolve__T__T(url), this.mappings$1)
});
$c_Lamf_core_remote_Context.prototype.resolve__T__T = (function(url) {
  try {
    return this.applyMapping__p1__T__T(this.platform$1.resolvePath__T__T(this.resolvePathAccordingToRelativeness__p1__T__T(url)))
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 instanceof $c_jl_Exception)) {
      var e$3 = $as_jl_Exception(e$2);
      throw new $c_Lamf_core_remote_PathResolutionError().init___T(((("url: " + url) + " - ") + e$3.getMessage__T()))
    } else {
      throw e
    }
  }
});
$c_Lamf_core_remote_Context.prototype.resolvePathAccordingToRelativeness__p1__T__T = (function(url) {
  matchEnd9: {
    var prefix;
    var o12 = $m_Lamf_core_remote_Absolute$().unapply__T__s_Option(url);
    if ((!o12.isEmpty__Z())) {
      var prefix = "";
      break matchEnd9
    };
    var o14 = $m_Lamf_core_remote_RelativeToRoot$().unapply__T__s_Option(url);
    if ((!o14.isEmpty__Z())) {
      var prefix = $m_Lamf_core_remote_Context$().amf$core$remote$Context$$stripFile__T__T__T(this.root__T(), this.platform$1.operativeSystem__T());
      break matchEnd9
    };
    new $c_s_Some().init___O(url);
    var prefix = $m_Lamf_core_remote_Context$().amf$core$remote$Context$$stripFile__T__T__T(this.current__T(), this.platform$1.operativeSystem__T())
  };
  return this.concatWithoutDuplicateSlash__p1__T__T__T(prefix, url)
});
$c_Lamf_core_remote_Context.prototype.hasCycles__Z = (function() {
  var this$1 = this.history$1;
  var elem$1 = 0;
  elem$1 = 0;
  var these = this$1;
  while ((!these.isEmpty__Z())) {
    var arg1 = these.head__O();
    var x$1 = $as_T(arg1);
    var that = this.current__T();
    if ((x$1 === that)) {
      elem$1 = ((1 + elem$1) | 0)
    };
    these = $as_sci_List(these.tail__O())
  };
  return (elem$1 === 2)
});
$c_Lamf_core_remote_Context.prototype.root__T = (function() {
  return (this.history$1.isEmpty__Z() ? "" : $as_T(this.history$1.head__O()))
});
$c_Lamf_core_remote_Context.prototype.init___Lamf_core_remote_Platform__sci_List__sci_Map = (function(platform, history, mappings) {
  this.platform$1 = platform;
  this.history$1 = history;
  this.mappings$1 = mappings;
  return this
});
$c_Lamf_core_remote_Context.prototype.applyMapping__p1__T__T = (function(path) {
  var this$1 = this.mappings$1;
  var this$2 = this$1.iterator__sc_Iterator();
  inlinereturn$3: {
    while (this$2.hasNext__Z()) {
      var a = this$2.next__O();
      var m = $as_T2(a);
      var prefix = $as_T(m.$$und1__O());
      if ((($uI(path.length) >= 0) && ($as_T(path.substring(0, $uI(prefix.length))) === prefix))) {
        var this$8 = new $c_s_Some().init___O(a);
        break inlinereturn$3
      }
    };
    var this$8 = $m_s_None$()
  };
  if (this$8.isEmpty__Z()) {
    return path
  } else {
    var arg1 = this$8.get__O();
    var m$3 = $as_T2(arg1);
    var target = $as_jl_CharSequence(m$3.$$und1__O());
    var replacement = $as_jl_CharSequence(m$3.$$und2__O());
    return $as_T(path.split($objectToString(target)).join($objectToString(replacement)))
  }
});
var $d_Lamf_core_remote_Context = new $TypeData().initClass({
  Lamf_core_remote_Context: 0
}, false, "amf.core.remote.Context", {
  Lamf_core_remote_Context: 1,
  O: 1
});
$c_Lamf_core_remote_Context.prototype.$classData = $d_Lamf_core_remote_Context;
/** @constructor */
function $c_Lamf_core_remote_Context$() {
  $c_O.call(this)
}
$c_Lamf_core_remote_Context$.prototype = new $h_O();
$c_Lamf_core_remote_Context$.prototype.constructor = $c_Lamf_core_remote_Context$;
/** @constructor */
function $h_Lamf_core_remote_Context$() {
  /*<skip>*/
}
$h_Lamf_core_remote_Context$.prototype = $c_Lamf_core_remote_Context$.prototype;
$c_Lamf_core_remote_Context$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_remote_Context$.prototype.amf$core$remote$Context$$apply__Lamf_core_remote_Platform__sci_List__T__sci_Map__Lamf_core_remote_Context = (function(platform, history, currentResolved, mapping) {
  var this$1 = $m_sci_List$();
  var bf = this$1.ReusableCBFInstance$2;
  return new $c_Lamf_core_remote_Context().init___Lamf_core_remote_Platform__sci_List__sci_Map(platform, $as_sci_List($f_sc_SeqLike__$$colon$plus__O__scg_CanBuildFrom__O(history, currentResolved, bf)), mapping)
});
$c_Lamf_core_remote_Context$.prototype.amf$core$remote$Context$$stripFile__T__T__T = (function(url, so) {
  var this$4 = new $c_sci_StringOps().init___T(url);
  var elem = new $c_jl_Character().init___C(92);
  if ($f_sc_SeqLike__contains__O__Z(this$4, elem)) {
    var containsBackSlash = (so === "win")
  } else {
    var containsBackSlash = false
  };
  var this$8 = new $c_sci_StringOps().init___T(url);
  var elem$1 = new $c_jl_Character().init___C(47);
  var containsForwardSlash = $f_sc_SeqLike__contains__O__Z(this$8, elem$1);
  if (((!containsBackSlash) && (!containsForwardSlash))) {
    return ""
  };
  var sep = (containsBackSlash ? 92 : 47);
  var this$10 = new $c_sci_StringOps().init___T(url);
  var xs = $f_sci_StringLike__split__C__AT(this$10, sep);
  var this$12 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
  var x = $as_T($f_sc_IndexedSeqOptimized__last__O(this$12));
  var this$16 = new $c_sci_StringOps().init___T(x);
  var elem$2 = new $c_jl_Character().init___C(46);
  var lastPieceHasExtension = $f_sc_SeqLike__contains__O__Z(this$16, elem$2);
  if (lastPieceHasExtension) {
    var endIndex = ((1 + $m_sjsr_RuntimeString$().lastIndexOf__T__I__I(url, sep)) | 0);
    return $as_T(url.substring(0, endIndex))
  } else {
    return ((!$m_sjsr_RuntimeString$().endsWith__T__T__Z(url, $as_T($g.String.fromCharCode(sep)))) ? (("" + url) + new $c_jl_Character().init___C(sep)) : url)
  }
});
$c_Lamf_core_remote_Context$.prototype.apply__Lamf_core_remote_Platform__Lamf_core_remote_Context = (function(platform) {
  return $m_Lamf_core_remote_Context$().apply__Lamf_core_remote_Platform__T__sci_Map__Lamf_core_remote_Context(platform, "", $m_sci_Map$EmptyMap$())
});
$c_Lamf_core_remote_Context$.prototype.apply__Lamf_core_remote_Platform__T__sci_Map__Lamf_core_remote_Context = (function(platform, root, mapping) {
  var this$1 = $m_s_Option$().apply__O__s_Option(root);
  if (this$1.isEmpty__Z()) {
    var jsx$1 = true
  } else {
    var arg1 = this$1.get__O();
    var x$2 = $as_T(arg1);
    var this$3 = new $c_sci_StringOps().init___T(x$2);
    var jsx$1 = $f_sc_TraversableOnce__nonEmpty__Z(this$3)
  };
  if (jsx$1) {
    var this$4 = this$1
  } else {
    var this$4 = $m_s_None$()
  };
  if (this$4.isEmpty__Z()) {
    var this$9 = $m_s_None$()
  } else {
    var arg1$1 = this$4.get__O();
    var x$3 = $as_T(arg1$1);
    $m_sci_List$();
    var array = [x$3];
    var i = (((-1) + $uI(array.length)) | 0);
    var result = $m_sci_Nil$();
    while ((i >= 0)) {
      var this$8 = result;
      var index = i;
      var x = array[index];
      result = new $c_sci_$colon$colon().init___O__sci_List(x, this$8);
      i = (((-1) + i) | 0)
    };
    var this$9 = new $c_s_Some().init___O(result)
  };
  return new $c_Lamf_core_remote_Context().init___Lamf_core_remote_Platform__sci_List__sci_Map(platform, $as_sci_List((this$9.isEmpty__Z() ? $m_sci_Nil$() : this$9.get__O())), mapping)
});
var $d_Lamf_core_remote_Context$ = new $TypeData().initClass({
  Lamf_core_remote_Context$: 0
}, false, "amf.core.remote.Context$", {
  Lamf_core_remote_Context$: 1,
  O: 1
});
$c_Lamf_core_remote_Context$.prototype.$classData = $d_Lamf_core_remote_Context$;
var $n_Lamf_core_remote_Context$ = (void 0);
function $m_Lamf_core_remote_Context$() {
  if ((!$n_Lamf_core_remote_Context$)) {
    $n_Lamf_core_remote_Context$ = new $c_Lamf_core_remote_Context$().init___()
  };
  return $n_Lamf_core_remote_Context$
}
/** @constructor */
function $c_Lamf_core_remote_File$() {
  $c_O.call(this);
  this.FILE$undPROTOCOL$1 = null
}
$c_Lamf_core_remote_File$.prototype = new $h_O();
$c_Lamf_core_remote_File$.prototype.constructor = $c_Lamf_core_remote_File$;
/** @constructor */
function $h_Lamf_core_remote_File$() {
  /*<skip>*/
}
$h_Lamf_core_remote_File$.prototype = $c_Lamf_core_remote_File$.prototype;
$c_Lamf_core_remote_File$.prototype.init___ = (function() {
  this.FILE$undPROTOCOL$1 = "file://";
  return this
});
$c_Lamf_core_remote_File$.prototype.unapply__T__s_Option = (function(url) {
  var prefix = this.FILE$undPROTOCOL$1;
  if ((($uI(url.length) >= 0) && ($as_T(url.substring(0, $uI(prefix.length))) === prefix))) {
    var this$7 = new $c_sci_StringOps().init___T(url);
    var prefix$1 = this.FILE$undPROTOCOL$1;
    var path = $f_sci_StringLike__stripPrefix__T__T(this$7, prefix$1);
    return new $c_s_Some().init___O(path)
  } else {
    return $m_s_None$()
  }
});
var $d_Lamf_core_remote_File$ = new $TypeData().initClass({
  Lamf_core_remote_File$: 0
}, false, "amf.core.remote.File$", {
  Lamf_core_remote_File$: 1,
  O: 1
});
$c_Lamf_core_remote_File$.prototype.$classData = $d_Lamf_core_remote_File$;
var $n_Lamf_core_remote_File$ = (void 0);
function $m_Lamf_core_remote_File$() {
  if ((!$n_Lamf_core_remote_File$)) {
    $n_Lamf_core_remote_File$ = new $c_Lamf_core_remote_File$().init___()
  };
  return $n_Lamf_core_remote_File$
}
/** @constructor */
function $c_Lamf_core_remote_HttpParts$() {
  $c_O.call(this);
  this.HTTP$undPROTOCOL$1 = null;
  this.HTTPS$undPROTOCOL$1 = null
}
$c_Lamf_core_remote_HttpParts$.prototype = new $h_O();
$c_Lamf_core_remote_HttpParts$.prototype.constructor = $c_Lamf_core_remote_HttpParts$;
/** @constructor */
function $h_Lamf_core_remote_HttpParts$() {
  /*<skip>*/
}
$h_Lamf_core_remote_HttpParts$.prototype = $c_Lamf_core_remote_HttpParts$.prototype;
$c_Lamf_core_remote_HttpParts$.prototype.init___ = (function() {
  this.HTTP$undPROTOCOL$1 = "http://";
  this.HTTPS$undPROTOCOL$1 = "https://";
  return this
});
$c_Lamf_core_remote_HttpParts$.prototype.unapply__T__s_Option = (function(uri) {
  var prefix = this.HTTP$undPROTOCOL$1;
  if ((($uI(uri.length) >= 0) && ($as_T(uri.substring(0, $uI(prefix.length))) === prefix))) {
    var jsx$1 = true
  } else {
    var prefix$1 = this.HTTPS$undPROTOCOL$1;
    var jsx$1 = (($uI(uri.length) >= 0) && ($as_T(uri.substring(0, $uI(prefix$1.length))) === prefix$1))
  };
  if (jsx$1) {
    var endIndex = ((3 + $uI(uri.indexOf("://"))) | 0);
    var protocol = $as_T(uri.substring(0, endIndex));
    var this$16 = new $c_sci_StringOps().init___T(uri);
    var rightOfProtocol = $f_sci_StringLike__stripPrefix__T__T(this$16, protocol);
    if (($uI(rightOfProtocol.indexOf("/")) !== (-1))) {
      var endIndex$1 = $uI(rightOfProtocol.indexOf("/"));
      var host = $as_T(rightOfProtocol.substring(0, endIndex$1))
    } else {
      var host = rightOfProtocol
    };
    var path = $as_T(rightOfProtocol.split(host).join(""));
    return new $c_s_Some().init___O(new $c_T3().init___O__O__O(protocol, host, path))
  } else {
    return $m_s_None$()
  }
});
var $d_Lamf_core_remote_HttpParts$ = new $TypeData().initClass({
  Lamf_core_remote_HttpParts$: 0
}, false, "amf.core.remote.HttpParts$", {
  Lamf_core_remote_HttpParts$: 1,
  O: 1
});
$c_Lamf_core_remote_HttpParts$.prototype.$classData = $d_Lamf_core_remote_HttpParts$;
var $n_Lamf_core_remote_HttpParts$ = (void 0);
function $m_Lamf_core_remote_HttpParts$() {
  if ((!$n_Lamf_core_remote_HttpParts$)) {
    $n_Lamf_core_remote_HttpParts$ = new $c_Lamf_core_remote_HttpParts$().init___()
  };
  return $n_Lamf_core_remote_HttpParts$
}
/** @constructor */
function $c_Lamf_core_remote_Mimes$() {
  $c_O.call(this);
  this.TEXT$divYAML$1 = null;
  this.TEXT$divX$minusYAML$1 = null;
  this.TEXT$divVND$u002EYAML$1 = null;
  this.APPLICATION$divJSON$1 = null;
  this.APPLICATION$divYAML$1 = null;
  this.APPLICATION$divX$minusYAML$1 = null;
  this.APPLICATION$divRAML$plusYAML$1 = null;
  this.APPLICATION$divRAML$plusJSON$1 = null;
  this.APPLICATION$divRAML$1 = null;
  this.APPLICATION$divOPENAPI$plusJSON$1 = null;
  this.APPLICATION$divSWAGGER$plusJSON$1 = null;
  this.APPLICATION$divOPENAPI$plusYAML$1 = null;
  this.APPLICATION$divSWAGGER$plusYAML$1 = null;
  this.APPLICATION$divOPENAPI$1 = null;
  this.APPLICATION$divSWAGGER$1 = null;
  this.APPLICATION$divASYNCAPI$plusJSON$1 = null;
  this.APPLICATION$divASYNC$plusJSON$1 = null;
  this.APPLICATION$divASYNCAPI$plusYAML$1 = null;
  this.APPLICATION$divASYNC$plusYAML$1 = null;
  this.APPLICATION$divASYNCAPI$1 = null;
  this.APPLICATION$divASYNC$1 = null;
  this.APPLICATION$divLD$plusJSONLD$1 = null
}
$c_Lamf_core_remote_Mimes$.prototype = new $h_O();
$c_Lamf_core_remote_Mimes$.prototype.constructor = $c_Lamf_core_remote_Mimes$;
/** @constructor */
function $h_Lamf_core_remote_Mimes$() {
  /*<skip>*/
}
$h_Lamf_core_remote_Mimes$.prototype = $c_Lamf_core_remote_Mimes$.prototype;
$c_Lamf_core_remote_Mimes$.prototype.init___ = (function() {
  this.TEXT$divYAML$1 = "text/yaml";
  this.TEXT$divX$minusYAML$1 = "text/x-yaml";
  this.TEXT$divVND$u002EYAML$1 = "text/vnd.yaml";
  this.APPLICATION$divJSON$1 = "application/json";
  this.APPLICATION$divYAML$1 = "application/yaml";
  this.APPLICATION$divX$minusYAML$1 = "application/x-yaml";
  this.APPLICATION$divRAML$plusYAML$1 = "application/raml+yaml";
  this.APPLICATION$divRAML$plusJSON$1 = "application/raml+json";
  this.APPLICATION$divRAML$1 = "application/raml";
  this.APPLICATION$divOPENAPI$plusJSON$1 = "application/openapi+json";
  this.APPLICATION$divSWAGGER$plusJSON$1 = "application/swagger+json";
  this.APPLICATION$divOPENAPI$plusYAML$1 = "application/openapi+yaml";
  this.APPLICATION$divSWAGGER$plusYAML$1 = "application/swagger+yaml";
  this.APPLICATION$divOPENAPI$1 = "application/openapi";
  this.APPLICATION$divSWAGGER$1 = "application/swagger";
  this.APPLICATION$divASYNCAPI$plusJSON$1 = "application/asyncapi+json";
  this.APPLICATION$divASYNC$plusJSON$1 = "application/async+json";
  this.APPLICATION$divASYNCAPI$plusYAML$1 = "application/asyncapi+yaml";
  this.APPLICATION$divASYNC$plusYAML$1 = "application/async+yaml";
  this.APPLICATION$divASYNCAPI$1 = "application/asyncapi";
  this.APPLICATION$divASYNC$1 = "application/async";
  this.APPLICATION$divLD$plusJSONLD$1 = "application/ld+json";
  return this
});
var $d_Lamf_core_remote_Mimes$ = new $TypeData().initClass({
  Lamf_core_remote_Mimes$: 0
}, false, "amf.core.remote.Mimes$", {
  Lamf_core_remote_Mimes$: 1,
  O: 1
});
$c_Lamf_core_remote_Mimes$.prototype.$classData = $d_Lamf_core_remote_Mimes$;
var $n_Lamf_core_remote_Mimes$ = (void 0);
function $m_Lamf_core_remote_Mimes$() {
  if ((!$n_Lamf_core_remote_Mimes$)) {
    $n_Lamf_core_remote_Mimes$ = new $c_Lamf_core_remote_Mimes$().init___()
  };
  return $n_Lamf_core_remote_Mimes$
}
function $f_Lamf_core_remote_Oas__$$init$__V($thiz) {
  var thiz = ("OAS " + $thiz.version__T());
  $thiz.amf$core$remote$Oas$$undsetter$und$name$und$eq__T__V($as_T(thiz.trim()))
}
function $is_Lamf_core_remote_Oas(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_remote_Oas)))
}
function $as_Lamf_core_remote_Oas(obj) {
  return (($is_Lamf_core_remote_Oas(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.remote.Oas"))
}
function $isArrayOf_Lamf_core_remote_Oas(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_remote_Oas)))
}
function $asArrayOf_Lamf_core_remote_Oas(obj, depth) {
  return (($isArrayOf_Lamf_core_remote_Oas(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.remote.Oas;", depth))
}
function $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option($thiz, model, builder) {
  return $thiz.wrappersRegistry__scm_HashMap().put__O__O__s_Option($as_Lamf_core_vocabulary_ValueType(model.type__sci_List().head__O()).iri__T(), builder)
}
function $f_Lamf_core_remote_Platform__wrapFn__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper($thiz, entity) {
  if ($is_Lamf_core_model_domain_DomainElement(entity)) {
    var x2 = $as_Lamf_core_model_domain_DomainElement(entity);
    var this$1 = $thiz.wrappersRegistryFn__scm_HashMap();
    var this$2 = new $c_scm_HashMap$$anon$1().init___scm_HashMap(this$1);
    var this$3 = this$2.$$outer$4.keysIterator__sc_Iterator();
    inlinereturn$7: {
      while (this$3.hasNext__Z()) {
        var a = this$3.next__O();
        var p = $as_F1(a);
        if ($uZ(p.apply__O__O(x2.meta__Lamf_core_metamodel_Obj()))) {
          var x1$2 = new $c_s_Some().init___O(a);
          break inlinereturn$7
        }
      };
      var x1$2 = $m_s_None$()
    };
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var k = $as_F1(x2$2.value$2);
      return $as_Lamf_client_model_AmfObjectWrapper($as_F1($thiz.wrappersRegistryFn__scm_HashMap().apply__O__O(k)).apply__O__O(x2))
    } else {
      var x = $m_s_None$();
      if ((x === x1$2)) {
        throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot find builder for object meta " + x2.meta__Lamf_core_metamodel_Obj())))
      } else {
        throw new $c_s_MatchError().init___O(x1$2)
      }
    }
  } else if ($is_Lamf_core_model_document_BaseUnit(entity)) {
    var x3 = $as_Lamf_core_model_document_BaseUnit(entity);
    var this$4 = $thiz.wrappersRegistryFn__scm_HashMap();
    var this$5 = new $c_scm_HashMap$$anon$1().init___scm_HashMap(this$4);
    var this$6 = this$5.$$outer$4.keysIterator__sc_Iterator();
    inlinereturn$20: {
      while (this$6.hasNext__Z()) {
        var a$1 = this$6.next__O();
        var p$3 = $as_F1(a$1);
        if ($uZ(p$3.apply__O__O(x3.meta__Lamf_core_metamodel_Obj()))) {
          var x1$3 = new $c_s_Some().init___O(a$1);
          break inlinereturn$20
        }
      };
      var x1$3 = $m_s_None$()
    };
    if ((x1$3 instanceof $c_s_Some)) {
      var x2$3 = $as_s_Some(x1$3);
      var k$2 = $as_F1(x2$3.value$2);
      return $as_Lamf_client_model_AmfObjectWrapper($as_F1($thiz.wrappersRegistryFn__scm_HashMap().apply__O__O(k$2)).apply__O__O(x3))
    } else {
      var x$3 = $m_s_None$();
      if ((x$3 === x1$3)) {
        throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot find builder for object meta " + x3.meta__Lamf_core_metamodel_Obj())))
      } else {
        throw new $c_s_MatchError().init___O(x1$3)
      }
    }
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot build object of type " + entity)))
  }
}
function $f_Lamf_core_remote_Platform__safeDecodeURIComponent__T__s_util_Either($thiz, url) {
  try {
    $m_s_package$();
    var value = $f_Lamf_core_remote_JsPlatform__decodeURIComponent__T__T($thiz, url);
    return new $c_s_util_Right().init___O(value)
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      $m_s_package$();
      return new $c_s_util_Left().init___O(url)
    } else {
      throw e
    }
  }
}
function $f_Lamf_core_remote_Platform__fixFilePrefix__T__T($thiz, res) {
  return (((($uI(res.length) >= 0) && ($as_T(res.substring(0, $uI("file://".length))) === "file://")) || (($uI(res.length) >= 0) && ($as_T(res.substring(0, $uI("file:///".length))) === "file:///"))) ? res : ((($uI(res.length) >= 0) && ($as_T(res.substring(0, $uI("file:/".length))) === "file:/")) ? $as_T(res.split("file:/").join("file:///")) : res))
}
function $f_Lamf_core_remote_Platform__$$init$__V($thiz) {
  $thiz.testingCommandLine$und$eq__Z__V(false);
  $thiz.amf$core$remote$Platform$$undsetter$und$wrappersRegistry$und$eq__scm_HashMap__V(new $c_scm_HashMap().init___());
  $thiz.amf$core$remote$Platform$$undsetter$und$wrappersRegistryFn$und$eq__scm_HashMap__V(new $c_scm_HashMap().init___());
  $thiz.amf$core$remote$Platform$$undsetter$und$validations$und$eq__scm_Set__V(new $c_scm_HashSet().init___());
  $thiz.amf$core$remote$Platform$$undsetter$und$levels$und$eq__scm_Map__V(new $c_scm_HashMap().init___());
  $thiz.rdfFramework$und$eq__s_Option__V($m_s_None$())
}
function $f_Lamf_core_remote_Platform__registerValidations__sc_Seq__sci_Map__V($thiz, v, l) {
  var this$1 = $thiz.validations__scm_Set();
  $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$1, v);
  var this$2 = $thiz.levels__scm_Map();
  $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$2, l)
}
function $f_Lamf_core_remote_Platform__resolve__T__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future($thiz, url, env, executionContext) {
  var loaders = $as_sc_Seq(env.loaders$1.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, url$1) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_internal_resource_ResourceLoader(x$3$2);
      return x$3.accepts__T__Z(url$1)
    })
  })($thiz, url))));
  return $f_Lamf_core_remote_Platform__amf$core$remote$Platform$$loaderConcat__T__sc_Seq__s_concurrent_ExecutionContext__s_concurrent_Future($thiz, url, loaders, executionContext)
}
function $f_Lamf_core_remote_Platform__writeFile__T__T__s_concurrent_ExecutionContext__s_concurrent_Future($thiz, path, content, executionContext) {
  var qual$1 = $thiz.fs__Lorg_mulesoft_common_io_FileSystem().asyncFile__T__Lorg_mulesoft_common_io_AsyncFile(path);
  return qual$1.write__jl_CharSequence__T__s_concurrent_ExecutionContext__s_concurrent_Future(content, "UTF-8", executionContext)
}
function $f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper($thiz, entity) {
  if ($is_Lamf_core_model_domain_DomainElement(entity)) {
    var x2 = $as_Lamf_core_model_domain_DomainElement(entity);
    var x1$2 = $thiz.wrappersRegistry__scm_HashMap().get__O__s_Option($as_Lamf_core_vocabulary_ValueType(x2.meta__Lamf_core_metamodel_Obj().type__sci_List().head__O()).iri__T());
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var builder = $as_F1(x2$2.value$2);
      return $as_Lamf_client_model_AmfObjectWrapper(builder.apply__O__O(entity))
    } else {
      var x = $m_s_None$();
      if ((x === x1$2)) {
        return $f_Lamf_core_remote_Platform__wrapFn__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper($thiz, x2)
      } else {
        throw new $c_s_MatchError().init___O(x1$2)
      }
    }
  } else if ($is_Lamf_core_model_document_BaseUnit(entity)) {
    var x3 = $as_Lamf_core_model_document_BaseUnit(entity);
    var x1$3 = $thiz.wrappersRegistry__scm_HashMap().get__O__s_Option($as_Lamf_core_vocabulary_ValueType(x3.meta__Lamf_core_metamodel_Obj().type__sci_List().head__O()).iri__T());
    if ((x1$3 instanceof $c_s_Some)) {
      var x2$3 = $as_s_Some(x1$3);
      var builder$2 = $as_F1(x2$3.value$2);
      return $as_Lamf_client_model_AmfObjectWrapper(builder$2.apply__O__O(entity))
    } else {
      var x$3 = $m_s_None$();
      if ((x$3 === x1$3)) {
        return $f_Lamf_core_remote_Platform__wrapFn__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper($thiz, x3)
      } else {
        throw new $c_s_MatchError().init___O(x1$3)
      }
    }
  } else {
    return ((entity === null) ? null : $f_Lamf_core_remote_Platform__wrapFn__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper($thiz, entity))
  }
}
function $f_Lamf_core_remote_Platform__write__T__T__s_concurrent_ExecutionContext__s_concurrent_Future($thiz, url, content, executionContext) {
  var o7 = $m_Lamf_core_remote_File$().unapply__T__s_Option(url);
  if ((!o7.isEmpty__Z())) {
    var path = $as_T(o7.get__O());
    return $f_Lamf_core_remote_Platform__writeFile__T__T__s_concurrent_ExecutionContext__s_concurrent_Future($thiz, path, content, executionContext)
  };
  return $m_s_concurrent_Future$().failed__jl_Throwable__s_concurrent_Future(new $c_jl_Exception().init___T(("Unsupported write operation: " + url)))
}
function $f_Lamf_core_remote_Platform__amf$core$remote$Platform$$loaderConcat__T__sc_Seq__s_concurrent_ExecutionContext__s_concurrent_Future($thiz, url, loaders, executionContext) {
  var rc8 = false;
  var x2 = null;
  var x1 = loaders.toList__sci_List();
  var x = $m_sci_Nil$();
  if (x.equals__O__Z(x1)) {
    throw new $c_Lamf_core_remote_UnsupportedUrlScheme().init___T(url)
  };
  if ((x1 instanceof $c_sci_$colon$colon)) {
    rc8 = true;
    x2 = $as_sci_$colon$colon(x1);
    var head = $as_Lamf_internal_resource_ResourceLoader(x2.head$5);
    var p3 = x2.tl$5;
    var x$3 = $m_sci_Nil$();
    if (x$3.equals__O__Z(p3)) {
      return head.fetch__T__s_concurrent_Future(url)
    }
  };
  if (rc8) {
    var head$2 = $as_Lamf_internal_resource_ResourceLoader(x2.head$5);
    var tail = x2.tl$5;
    return head$2.fetch__T__s_concurrent_Future(url).recoverWith__s_PartialFunction__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_Lamf_core_remote_Platform$$anonfun$amf$core$remote$Platform$$loaderConcat$1().init___Lamf_core_remote_Platform__T__sci_List__s_concurrent_ExecutionContext($thiz, url, tail, executionContext), executionContext)
  };
  throw new $c_s_MatchError().init___O(x1)
}
function $f_Lamf_core_remote_Raml__$$init$__V($thiz) {
  var thiz = ("RAML " + $thiz.version__T());
  $thiz.amf$core$remote$Raml$$undsetter$und$name$und$eq__T__V($as_T(thiz.trim()))
}
function $is_Lamf_core_remote_Raml(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_remote_Raml)))
}
function $as_Lamf_core_remote_Raml(obj) {
  return (($is_Lamf_core_remote_Raml(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.remote.Raml"))
}
function $isArrayOf_Lamf_core_remote_Raml(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_remote_Raml)))
}
function $asArrayOf_Lamf_core_remote_Raml(obj, depth) {
  return (($isArrayOf_Lamf_core_remote_Raml(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.remote.Raml;", depth))
}
/** @constructor */
function $c_Lamf_core_remote_RelativeToRoot$() {
  $c_O.call(this)
}
$c_Lamf_core_remote_RelativeToRoot$.prototype = new $h_O();
$c_Lamf_core_remote_RelativeToRoot$.prototype.constructor = $c_Lamf_core_remote_RelativeToRoot$;
/** @constructor */
function $h_Lamf_core_remote_RelativeToRoot$() {
  /*<skip>*/
}
$h_Lamf_core_remote_RelativeToRoot$.prototype = $c_Lamf_core_remote_RelativeToRoot$.prototype;
$c_Lamf_core_remote_RelativeToRoot$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_remote_RelativeToRoot$.prototype.unapply__T__s_Option = (function(url) {
  return ((($uI(url.length) >= 0) && ($as_T(url.substring(0, $uI("/".length))) === "/")) ? new $c_s_Some().init___O(url) : $m_s_None$())
});
var $d_Lamf_core_remote_RelativeToRoot$ = new $TypeData().initClass({
  Lamf_core_remote_RelativeToRoot$: 0
}, false, "amf.core.remote.RelativeToRoot$", {
  Lamf_core_remote_RelativeToRoot$: 1,
  O: 1
});
$c_Lamf_core_remote_RelativeToRoot$.prototype.$classData = $d_Lamf_core_remote_RelativeToRoot$;
var $n_Lamf_core_remote_RelativeToRoot$ = (void 0);
function $m_Lamf_core_remote_RelativeToRoot$() {
  if ((!$n_Lamf_core_remote_RelativeToRoot$)) {
    $n_Lamf_core_remote_RelativeToRoot$ = new $c_Lamf_core_remote_RelativeToRoot$().init___()
  };
  return $n_Lamf_core_remote_RelativeToRoot$
}
/** @constructor */
function $c_Lamf_core_remote_Syntax$() {
  $c_O.call(this);
  this.yamlMimes$1 = null;
  this.jsonMimes$1 = null
}
$c_Lamf_core_remote_Syntax$.prototype = new $h_O();
$c_Lamf_core_remote_Syntax$.prototype.constructor = $c_Lamf_core_remote_Syntax$;
/** @constructor */
function $h_Lamf_core_remote_Syntax$() {
  /*<skip>*/
}
$h_Lamf_core_remote_Syntax$.prototype = $c_Lamf_core_remote_Syntax$.prototype;
$c_Lamf_core_remote_Syntax$.prototype.init___ = (function() {
  $n_Lamf_core_remote_Syntax$ = this;
  var array = [$m_Lamf_core_remote_Mimes$().TEXT$divYAML$1, $m_Lamf_core_remote_Mimes$().TEXT$divX$minusYAML$1, $m_Lamf_core_remote_Mimes$().TEXT$divVND$u002EYAML$1, $m_Lamf_core_remote_Mimes$().APPLICATION$divYAML$1, $m_Lamf_core_remote_Mimes$().APPLICATION$divX$minusYAML$1, $m_Lamf_core_remote_Mimes$().APPLICATION$divRAML$plusYAML$1, $m_Lamf_core_remote_Mimes$().APPLICATION$divOPENAPI$plusYAML$1, $m_Lamf_core_remote_Mimes$().APPLICATION$divSWAGGER$plusYAML$1, $m_Lamf_core_remote_Mimes$().APPLICATION$divASYNCAPI$plusYAML$1, $m_Lamf_core_remote_Mimes$().APPLICATION$divASYNC$plusYAML$1];
  if (($uI(array.length) === 0)) {
    var jsx$1 = $m_sci_Set$EmptySet$()
  } else {
    var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      b.$$plus$eq__O__scm_SetBuilder(arg1);
      i = ((1 + i) | 0)
    };
    var jsx$1 = b.elems$1
  };
  this.yamlMimes$1 = $as_sci_Set(jsx$1);
  var array$1 = [$m_Lamf_core_remote_Mimes$().APPLICATION$divJSON$1, $m_Lamf_core_remote_Mimes$().APPLICATION$divRAML$plusJSON$1, $m_Lamf_core_remote_Mimes$().APPLICATION$divOPENAPI$plusJSON$1, $m_Lamf_core_remote_Mimes$().APPLICATION$divSWAGGER$plusJSON$1, $m_Lamf_core_remote_Mimes$().APPLICATION$divASYNCAPI$plusJSON$1, $m_Lamf_core_remote_Mimes$().APPLICATION$divASYNC$plusJSON$1];
  if (($uI(array$1.length) === 0)) {
    var jsx$2 = $m_sci_Set$EmptySet$()
  } else {
    var b$1 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$1 = 0;
    var len$1 = $uI(array$1.length);
    while ((i$1 < len$1)) {
      var index$1 = i$1;
      var arg1$1 = array$1[index$1];
      b$1.$$plus$eq__O__scm_SetBuilder(arg1$1);
      i$1 = ((1 + i$1) | 0)
    };
    var jsx$2 = b$1.elems$1
  };
  this.jsonMimes$1 = $as_sci_Set(jsx$2);
  return this
});
$c_Lamf_core_remote_Syntax$.prototype.unapply__s_Option__s_Option = (function(mime) {
  var rc5 = false;
  var x2 = null;
  if ((mime instanceof $c_s_Some)) {
    rc5 = true;
    x2 = $as_s_Some(mime);
    var m = $as_T(x2.value$2);
    if (this.yamlMimes$1.contains__O__Z(m)) {
      return new $c_s_Some().init___O($m_Lamf_core_remote_Syntax$Yaml$())
    }
  };
  if (rc5) {
    var m$2 = $as_T(x2.value$2);
    if (this.jsonMimes$1.contains__O__Z(m$2)) {
      return new $c_s_Some().init___O($m_Lamf_core_remote_Syntax$Json$())
    }
  };
  return $m_s_None$()
});
var $d_Lamf_core_remote_Syntax$ = new $TypeData().initClass({
  Lamf_core_remote_Syntax$: 0
}, false, "amf.core.remote.Syntax$", {
  Lamf_core_remote_Syntax$: 1,
  O: 1
});
$c_Lamf_core_remote_Syntax$.prototype.$classData = $d_Lamf_core_remote_Syntax$;
var $n_Lamf_core_remote_Syntax$ = (void 0);
function $m_Lamf_core_remote_Syntax$() {
  if ((!$n_Lamf_core_remote_Syntax$)) {
    $n_Lamf_core_remote_Syntax$ = new $c_Lamf_core_remote_Syntax$().init___()
  };
  return $n_Lamf_core_remote_Syntax$
}
/** @constructor */
function $c_Lamf_core_remote_Vendor$() {
  $c_O.call(this);
  this.RAML$1 = null;
  this.RAML08$1 = null;
  this.RAML10$1 = null;
  this.OAS$1 = null;
  this.OAS20$1 = null;
  this.OAS30$1 = null;
  this.ASYNC$1 = null;
  this.ASYNC20$1 = null;
  this.AMF$1 = null;
  this.PAYLOAD$1 = null;
  this.AML$1 = null
}
$c_Lamf_core_remote_Vendor$.prototype = new $h_O();
$c_Lamf_core_remote_Vendor$.prototype.constructor = $c_Lamf_core_remote_Vendor$;
/** @constructor */
function $h_Lamf_core_remote_Vendor$() {
  /*<skip>*/
}
$h_Lamf_core_remote_Vendor$.prototype = $c_Lamf_core_remote_Vendor$.prototype;
$c_Lamf_core_remote_Vendor$.prototype.init___ = (function() {
  $n_Lamf_core_remote_Vendor$ = this;
  this.RAML$1 = $m_Lamf_core_remote_Raml$();
  this.RAML08$1 = $m_Lamf_core_remote_Raml08$();
  this.RAML10$1 = $m_Lamf_core_remote_Raml10$();
  this.OAS$1 = $m_Lamf_core_remote_Oas$();
  this.OAS20$1 = $m_Lamf_core_remote_Oas20$();
  this.OAS30$1 = $m_Lamf_core_remote_Oas30$();
  this.ASYNC$1 = $m_Lamf_core_remote_AsyncApi$();
  this.ASYNC20$1 = $m_Lamf_core_remote_AsyncApi20$();
  this.AMF$1 = $m_Lamf_core_remote_Amf$();
  this.PAYLOAD$1 = $m_Lamf_core_remote_Payload$();
  this.AML$1 = $m_Lamf_core_remote_Aml$();
  return this
});
$c_Lamf_core_remote_Vendor$.prototype.unapply__T__s_Option = (function(name) {
  return (($m_Lamf_core_remote_Raml10$().name$1 === name) ? new $c_s_Some().init___O($m_Lamf_core_remote_Raml10$()) : (($m_Lamf_core_remote_Raml08$().name$1 === name) ? new $c_s_Some().init___O($m_Lamf_core_remote_Raml08$()) : (($m_Lamf_core_remote_Raml$().name$1 === name) ? new $c_s_Some().init___O($m_Lamf_core_remote_Raml$()) : (($m_Lamf_core_remote_Oas20$().name$1 === name) ? new $c_s_Some().init___O($m_Lamf_core_remote_Oas20$()) : (($m_Lamf_core_remote_Oas30$().name$1 === name) ? new $c_s_Some().init___O($m_Lamf_core_remote_Oas30$()) : (($m_Lamf_core_remote_Oas$().name$1 === name) ? new $c_s_Some().init___O($m_Lamf_core_remote_Oas$()) : (($m_Lamf_core_remote_AsyncApi$().name$1 === name) ? new $c_s_Some().init___O($m_Lamf_core_remote_AsyncApi$()) : (($m_Lamf_core_remote_AsyncApi20$().name$1 === name) ? new $c_s_Some().init___O($m_Lamf_core_remote_AsyncApi20$()) : (($m_Lamf_core_remote_Amf$().name$1 === name) ? new $c_s_Some().init___O($m_Lamf_core_remote_Amf$()) : (($m_Lamf_core_remote_Payload$().name$1 === name) ? new $c_s_Some().init___O($m_Lamf_core_remote_Payload$()) : (($m_Lamf_core_remote_Aml$().name$1 === name) ? new $c_s_Some().init___O($m_Lamf_core_remote_Aml$()) : $m_s_None$())))))))))))
});
$c_Lamf_core_remote_Vendor$.prototype.apply__T__Lamf_core_remote_Vendor = (function(name) {
  var o7 = $m_Lamf_core_remote_Vendor$().unapply__T__s_Option(name);
  if ((!o7.isEmpty__Z())) {
    var vendor = $as_Lamf_core_remote_Vendor(o7.get__O());
    return vendor
  };
  return new $c_Lamf_core_remote_UnknowVendor().init___T(name)
});
var $d_Lamf_core_remote_Vendor$ = new $TypeData().initClass({
  Lamf_core_remote_Vendor$: 0
}, false, "amf.core.remote.Vendor$", {
  Lamf_core_remote_Vendor$: 1,
  O: 1
});
$c_Lamf_core_remote_Vendor$.prototype.$classData = $d_Lamf_core_remote_Vendor$;
var $n_Lamf_core_remote_Vendor$ = (void 0);
function $m_Lamf_core_remote_Vendor$() {
  if ((!$n_Lamf_core_remote_Vendor$)) {
    $n_Lamf_core_remote_Vendor$ = new $c_Lamf_core_remote_Vendor$().init___()
  };
  return $n_Lamf_core_remote_Vendor$
}
/** @constructor */
function $c_Lamf_core_resolution_VariableReplacer$() {
  $c_O.call(this);
  this.Transformations$1 = null;
  this.TransformationsRegex$1 = null;
  this.VariableRegex$1 = null
}
$c_Lamf_core_resolution_VariableReplacer$.prototype = new $h_O();
$c_Lamf_core_resolution_VariableReplacer$.prototype.constructor = $c_Lamf_core_resolution_VariableReplacer$;
/** @constructor */
function $h_Lamf_core_resolution_VariableReplacer$() {
  /*<skip>*/
}
$h_Lamf_core_resolution_VariableReplacer$.prototype = $c_Lamf_core_resolution_VariableReplacer$.prototype;
$c_Lamf_core_resolution_VariableReplacer$.prototype.init___ = (function() {
  $n_Lamf_core_resolution_VariableReplacer$ = this;
  this.Transformations$1 = "singularize|pluralize|uppercase|lowercase|lowercamelcase|uppercamelcase|lowerunderscorecase|upperunderscorecase|lowerhyphencase|upperhyphencase";
  var x = this.Transformations$1;
  var this$2 = new $c_sci_StringOps().init___T(x);
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.TransformationsRegex$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  var x$1 = (("<<\\s*([^<<>>|\\s]+)((?:\\s*\\|\\s*!(?:" + this.Transformations$1) + ")\\s*)*)>>");
  var this$5 = new $c_sci_StringOps().init___T(x$1);
  var groupNames$1 = $m_sci_Nil$();
  var $$this$1 = this$5.repr$1;
  this.VariableRegex$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this$1, groupNames$1);
  return this
});
$c_Lamf_core_resolution_VariableReplacer$.prototype.replaceVariablesInKey__T__sci_Set__F1__T = (function(key, values, errorFunction) {
  var this$1 = this.VariableRegex$1;
  var this$2 = new $c_s_util_matching_Regex$MatchIterator().init___jl_CharSequence__s_util_matching_Regex__sc_Seq(key, this$1, this$1.scala$util$matching$Regex$$groupNames$f);
  var it = new $c_s_util_matching_Regex$MatchIterator$$anon$4().init___s_util_matching_Regex$MatchIterator(this$2);
  while (it.hasNext__Z()) {
    var arg1 = it.next__s_util_matching_Regex$Match();
    var jsx$1 = $m_Lamf_core_resolution_VariableReplacer$();
    var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(v$2) {
        var v = $as_Lamf_core_model_domain_templates_Variable(v$2);
        var self = v.name$1;
        var y = v.value$1;
        return new $c_T2().init___O__O(self, y)
      })
    })(this));
    var this$5 = $m_sci_Set$();
    var bf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$5);
    var rs = jsx$1.replaceMatch__p1__sci_Map__Z__Z__s_util_matching_Regex$Match__F1__T($as_sc_TraversableOnce($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(values, f, bf)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2), true, true, arg1, errorFunction);
    it.matcher__ju_regex_Matcher().appendReplacement__jl_StringBuffer__T__ju_regex_Matcher(it.scala$util$matching$Regex$Replacement$$sb$2, rs)
  };
  return $f_s_util_matching_Regex$Replacement__replaced__T(it)
});
$c_Lamf_core_resolution_VariableReplacer$.prototype.variableTransformation__F1__T__T__T = (function(errorFunction, value, transformation) {
  if ((transformation === "singularize")) {
    return ($m_Lamf_core_utils_InflectorBase$(), new $c_Lamf_core_utils_InflectorBase$Inflector().init___T(value)).singularize__T()
  } else if ((transformation === "pluralize")) {
    return ($m_Lamf_core_utils_InflectorBase$(), new $c_Lamf_core_utils_InflectorBase$Inflector().init___T(value)).pluralize__T()
  } else if ((transformation === "uppercase")) {
    return $as_T(value.toUpperCase())
  } else if ((transformation === "lowercase")) {
    return $as_T(value.toLowerCase())
  } else if ((transformation === "lowercamelcase")) {
    $m_Lamf_core_utils_InflectorBase$();
    $m_Lamf_core_utils_InflectorBase$();
    var qual$1 = new $c_Lamf_core_utils_InflectorBase$Inflector().init___T(value);
    var word = qual$1.camelize__Z__T(false);
    return new $c_Lamf_core_utils_InflectorBase$Inflector().init___T(word).decapitalize__T()
  } else if ((transformation === "uppercamelcase")) {
    $m_Lamf_core_utils_InflectorBase$();
    var qual$2 = new $c_Lamf_core_utils_InflectorBase$Inflector().init___T(value);
    var x = qual$2.camelize__Z__T(false);
    var this$9 = new $c_sci_StringOps().init___T(x);
    return $f_sci_StringLike__capitalize__T(this$9)
  } else if ((transformation === "lowerunderscorecase")) {
    $m_Lamf_core_utils_InflectorBase$();
    var qual$3 = new $c_Lamf_core_utils_InflectorBase$Inflector().init___T(value);
    var thiz = qual$3.camelToScoreSing__T__T("_");
    return $as_T(thiz.toLowerCase())
  } else if ((transformation === "upperunderscorecase")) {
    $m_Lamf_core_utils_InflectorBase$();
    var qual$4 = new $c_Lamf_core_utils_InflectorBase$Inflector().init___T(value);
    var thiz$1 = qual$4.camelToScoreSing__T__T("_");
    return $as_T(thiz$1.toUpperCase())
  } else if ((transformation === "lowerhyphencase")) {
    var thiz$2 = ($m_Lamf_core_utils_InflectorBase$(), new $c_Lamf_core_utils_InflectorBase$Inflector().init___T(value)).camelToScoreSing__T__T("-");
    return $as_T(thiz$2.toLowerCase())
  } else if ((transformation === "upperhyphencase")) {
    var thiz$3 = ($m_Lamf_core_utils_InflectorBase$(), new $c_Lamf_core_utils_InflectorBase$Inflector().init___T(value)).camelToScoreSing__T__T("-");
    return $as_T(thiz$3.toUpperCase())
  } else {
    errorFunction.apply__O__O((((("Transformation '" + transformation) + "' on '") + value) + "' is not valid."));
    return value
  }
});
$c_Lamf_core_resolution_VariableReplacer$.prototype.replaceMatch__p1__sci_Map__Z__Z__s_util_matching_Regex$Match__F1__T = (function(values, strict, isKey, m, errorFunction) {
  var nameWithChevrons = $f_s_util_matching_Regex$MatchData__group__I__T(m, 0);
  var name = $f_s_util_matching_Regex$MatchData__group__I__T(m, 1);
  var elem$1 = false;
  elem$1 = false;
  var this$2 = values.get__O__s_Option(name);
  if (this$2.isEmpty__Z()) {
    var textOption = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var x0$1 = $as_Lamf_core_model_domain_DataNode(arg1);
    if ((x0$1 instanceof $c_Lamf_core_model_domain_ScalarNode)) {
      var x2 = $as_Lamf_core_model_domain_ScalarNode(x0$1);
      var this$3 = x2.annotations$2.find__jl_Class__s_Option($d_Lamf_core_annotations_SourceAST.getClassOf());
      if (this$3.isEmpty__Z()) {
        var xo = $m_s_None$()
      } else {
        var arg1$1 = this$3.get__O();
        var x$6 = $as_Lamf_core_annotations_SourceAST(arg1$1);
        var xo = new $c_s_Some().init___O(x$6.ast$1)
      };
      var this$5 = xo.toList__sci_List();
      var pf = new $c_Lamf_core_resolution_VariableReplacer$$anonfun$$nestedInanonfun$replaceMatch$1$1().init___Z__Z__F1__T(isKey, strict, errorFunction, name);
      var this$6 = $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$5, pf);
      if (this$6.isEmpty__Z()) {
        var this$7 = $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1)).option$1;
        if ((!this$7.isEmpty__Z())) {
          var arg1$2 = this$7.get__O();
          var x$7 = $as_T(arg1$2);
          if ((x$7 === null)) {
            throw new $c_jl_NullPointerException().init___()
          };
          var jsx$1 = $m_ju_regex_Pattern$().matches__T__jl_CharSequence__Z(" *", x$7)
        } else {
          var jsx$1 = false
        };
        if (((jsx$1 && isKey) && strict)) {
          errorFunction.apply__O__O((("Variable '" + name) + "' cannot have an empty value"));
          elem$1 = true;
          var textOption = $m_s_None$()
        } else {
          var textOption = $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1)).option$1
        }
      } else {
        var textOption = this$6
      }
    } else if ((x0$1 instanceof $c_Lamf_core_resolution_stages_helpers_ResolvedLinkNode)) {
      var x3 = $as_Lamf_core_resolution_stages_helpers_ResolvedLinkNode(x0$1);
      var this$9 = x3.source$3;
      var textOption = $as_Lamf_core_model_StrField(this$9.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkNodeModel$().Alias$1)).option$1
    } else {
      errorFunction.apply__O__O(((("Variable '" + name) + "' cannot be replaced with type ") + $objectGetClass(x0$1).getName__T()));
      var textOption = $m_s_None$()
    }
  };
  if (textOption.isEmpty__Z()) {
    var this$14 = $m_s_None$()
  } else {
    var arg1$3 = textOption.get__O();
    var text = $as_T(arg1$3);
    var this$10 = $m_s_Option$().apply__O__s_Option($f_s_util_matching_Regex$MatchData__group__I__T(m, 2));
    if (this$10.isEmpty__Z()) {
      var this$13 = $m_s_None$()
    } else {
      var arg1$4 = this$10.get__O();
      var transformations = $as_T(arg1$4);
      var this$11 = $m_Lamf_core_resolution_VariableReplacer$().TransformationsRegex$1.findAllIn__jl_CharSequence__s_util_matching_Regex$MatchIterator(transformations);
      var elem$1$1 = null;
      elem$1$1 = text;
      while (this$11.hasNext__Z()) {
        var arg1$5 = this$11.next__T();
        var arg1$6 = elem$1$1;
        var value = $as_T(arg1$6);
        elem$1$1 = $m_Lamf_core_resolution_VariableReplacer$().variableTransformation__F1__T__T__T(errorFunction, value, arg1$5)
      };
      var this$13 = new $c_s_Some().init___O($as_T(elem$1$1))
    };
    var this$14 = (this$13.isEmpty__Z() ? new $c_s_Some().init___O(text) : this$13)
  };
  var thiz = $as_T((this$14.isEmpty__Z() ? ((strict && (!elem$1)) ? (errorFunction.apply__O__O((("Cannot find variable '" + name) + "'.")), nameWithChevrons) : nameWithChevrons) : this$14.get__O()));
  var replacement = $as_T(thiz.split("$").join("\\$"));
  return $m_ju_regex_Matcher$().quoteReplacement__T__T(replacement)
});
$c_Lamf_core_resolution_VariableReplacer$.prototype.replaceNodeVariables__Lamf_core_model_domain_ScalarNode__sci_Set__F1__Lamf_core_model_domain_DataNode = (function(s, values, errorFunction) {
  var this$1 = $as_Lamf_core_model_StrField(s.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1));
  var this$2 = this$1.option$1;
  var thiz = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  var x1 = $as_T(thiz.trim());
  var o7 = this.VariableRegex$1.unapplySeq__jl_CharSequence__s_Option(x1);
  if ((!o7.isEmpty__Z())) {
    if ((o7.get__O() !== null)) {
      var this$4 = $as_sc_LinearSeqOptimized(o7.get__O());
      var jsx$1 = ($f_sc_LinearSeqOptimized__lengthCompare__I__I(this$4, 2) === 0)
    } else {
      var jsx$1 = false
    }
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var name = $as_T($as_sc_LinearSeqOptimized(o7.get__O()).apply__I__O(0));
    var transformations = $as_T($as_sc_LinearSeqOptimized(o7.get__O()).apply__I__O(1));
    var rc17 = false;
    var x2 = null;
    var x1$2 = values.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, name$1) {
      return (function(x$1$2) {
        var x$1 = $as_Lamf_core_model_domain_templates_Variable(x$1$2);
        return (x$1.name$1 === name$1)
      })
    })(this, name)));
    if ((x1$2 instanceof $c_s_Some)) {
      rc17 = true;
      x2 = $as_s_Some(x1$2);
      var p3 = $as_Lamf_core_model_domain_templates_Variable(x2.value$2);
      if ((p3 !== null)) {
        var scalar = p3.value$1;
        if ((scalar instanceof $c_Lamf_core_model_domain_ScalarNode)) {
          var x13 = $as_Lamf_core_model_domain_ScalarNode(scalar);
          if ($as_Lamf_core_model_StrField(x13.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().DataType$1)).option$1.isEmpty__Z()) {
            var jsx$2 = true
          } else {
            var this$5 = $as_Lamf_core_model_StrField(x13.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().DataType$1));
            var this$6 = this$5.option$1;
            var thiz$1 = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
            var jsx$2 = ($uI(thiz$1.indexOf("#string")) !== (-1))
          };
          if (jsx$2) {
            var this$12 = this.VariableRegex$1;
            var this$10 = $as_Lamf_core_model_StrField(s.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1));
            var this$11 = this$10.option$1;
            var target = $as_T((this$11.isEmpty__Z() ? null : this$11.get__O()));
            var this$13 = new $c_s_util_matching_Regex$MatchIterator().init___jl_CharSequence__s_util_matching_Regex__sc_Seq(target, this$12, this$12.scala$util$matching$Regex$$groupNames$f);
            var it = new $c_s_util_matching_Regex$MatchIterator$$anon$4().init___s_util_matching_Regex$MatchIterator(this$13);
            while (it.hasNext__Z()) {
              var arg1 = it.next__s_util_matching_Regex$Match();
              var jsx$3 = $m_Lamf_core_resolution_VariableReplacer$();
              var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
                return (function(v$2) {
                  var v = $as_Lamf_core_model_domain_templates_Variable(v$2);
                  var self = v.name$1;
                  var y = v.value$1;
                  return new $c_T2().init___O__O(self, y)
                })
              })(this));
              var this$16 = $m_sci_Set$();
              var bf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$16);
              var rs = jsx$3.replaceMatch__p1__sci_Map__Z__Z__s_util_matching_Regex$Match__F1__T($as_sc_TraversableOnce($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(values, f, bf)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2), false, false, arg1, errorFunction);
              it.matcher__ju_regex_Matcher().appendReplacement__jl_StringBuffer__T__ju_regex_Matcher(it.scala$util$matching$Regex$Replacement$$sb$2, rs)
            };
            var v$1 = $f_s_util_matching_Regex$Replacement__replaced__T(it);
            s.withValue__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode(v$1, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
            return s
          }
        }
      }
    };
    if (rc17) {
      var this$19 = new $c_sci_StringOps().init___T(transformations);
      var jsx$4 = $f_sc_TraversableOnce__nonEmpty__Z(this$19)
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      errorFunction.apply__O__O((((("Cannot apply transformations '" + transformations) + "' to variable '") + name) + "'."));
      return s
    };
    if (rc17) {
      var p8 = $as_Lamf_core_model_domain_templates_Variable(x2.value$2);
      if ((p8 !== null)) {
        var scalar$2 = p8.value$1;
        if ((scalar$2 instanceof $c_Lamf_core_model_domain_ScalarNode)) {
          var x14 = $as_Lamf_core_model_domain_ScalarNode(scalar$2);
          return x14
        }
      }
    };
    if (rc17) {
      var p11 = $as_Lamf_core_model_domain_templates_Variable(x2.value$2);
      if ((p11 !== null)) {
        var node = p11.value$1;
        return node
      }
    };
    var x = $m_s_None$();
    if ((x === x1$2)) {
      if (s.annotations$2.find__jl_Class__s_Option($d_Lamf_core_annotations_ErrorRegistered.getClassOf()).isEmpty__Z()) {
        errorFunction.apply__O__O((("Cannot find variable '" + name) + "'."));
        s.annotations$2.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ErrorRegistered().init___())
      };
      return s
    };
    throw new $c_s_MatchError().init___O(x1$2)
  };
  var this$20 = $as_Lamf_core_model_StrField(s.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1)).option$1;
  if ((!this$20.isEmpty__Z())) {
    var arg1$1 = this$20.get__O();
    var v$3 = $as_T(arg1$1);
    var this$21 = $m_Lamf_core_resolution_VariableReplacer$().VariableRegex$1;
    var this$22 = new $c_s_util_matching_Regex$MatchIterator().init___jl_CharSequence__s_util_matching_Regex__sc_Seq(v$3, this$21, this$21.scala$util$matching$Regex$$groupNames$f);
    var it$1 = new $c_s_util_matching_Regex$MatchIterator$$anon$4().init___s_util_matching_Regex$MatchIterator(this$22);
    while (it$1.hasNext__Z()) {
      var arg1$2 = it$1.next__s_util_matching_Regex$Match();
      var jsx$5 = $m_Lamf_core_resolution_VariableReplacer$();
      var f$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2) {
        return (function(v$2$1) {
          var v$4 = $as_Lamf_core_model_domain_templates_Variable(v$2$1);
          var self$1 = v$4.name$1;
          var y$1 = v$4.value$1;
          return new $c_T2().init___O__O(self$1, y$1)
        })
      })(this));
      var this$25 = $m_sci_Set$();
      var bf$1 = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$25);
      var rs$1 = jsx$5.replaceMatch__p1__sci_Map__Z__Z__s_util_matching_Regex$Match__F1__T($as_sc_TraversableOnce($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(values, f$1, bf$1)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2), false, false, arg1$2, errorFunction);
      it$1.matcher__ju_regex_Matcher().appendReplacement__jl_StringBuffer__T__ju_regex_Matcher(it$1.scala$util$matching$Regex$Replacement$$sb$2, rs$1)
    };
    var v$5 = $f_s_util_matching_Regex$Replacement__replaced__T(it$1);
    s.withValue__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode(v$5, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
  };
  return s
});
var $d_Lamf_core_resolution_VariableReplacer$ = new $TypeData().initClass({
  Lamf_core_resolution_VariableReplacer$: 0
}, false, "amf.core.resolution.VariableReplacer$", {
  Lamf_core_resolution_VariableReplacer$: 1,
  O: 1
});
$c_Lamf_core_resolution_VariableReplacer$.prototype.$classData = $d_Lamf_core_resolution_VariableReplacer$;
var $n_Lamf_core_resolution_VariableReplacer$ = (void 0);
function $m_Lamf_core_resolution_VariableReplacer$() {
  if ((!$n_Lamf_core_resolution_VariableReplacer$)) {
    $n_Lamf_core_resolution_VariableReplacer$ = new $c_Lamf_core_resolution_VariableReplacer$().init___()
  };
  return $n_Lamf_core_resolution_VariableReplacer$
}
/** @constructor */
function $c_Lamf_core_resolution_pipelines_ResolutionPipeline() {
  $c_O.call(this);
  this.eh$1 = null;
  this.errorHandler$1 = null
}
$c_Lamf_core_resolution_pipelines_ResolutionPipeline.prototype = new $h_O();
$c_Lamf_core_resolution_pipelines_ResolutionPipeline.prototype.constructor = $c_Lamf_core_resolution_pipelines_ResolutionPipeline;
/** @constructor */
function $h_Lamf_core_resolution_pipelines_ResolutionPipeline() {
  /*<skip>*/
}
$h_Lamf_core_resolution_pipelines_ResolutionPipeline.prototype = $c_Lamf_core_resolution_pipelines_ResolutionPipeline.prototype;
$c_Lamf_core_resolution_pipelines_ResolutionPipeline.prototype.step__Lamf_core_model_document_BaseUnit__Lamf_core_resolution_stages_ResolutionStage__Lamf_core_model_document_BaseUnit = (function(unit, stage) {
  $m_Lamf_core_benchmark_ExecutionLog$().log__T__Lamf_core_benchmark_ExecutionLog$(("ResolutionPipeline#step: applying resolution stage " + $objectGetClass(stage).getName__T()));
  var resolved = stage.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit);
  $m_Lamf_core_benchmark_ExecutionLog$().log__T__Lamf_core_benchmark_ExecutionLog$(("ResolutionPipeline#step: finished applying stage " + $objectGetClass(stage).getName__T()));
  return resolved
});
$c_Lamf_core_resolution_pipelines_ResolutionPipeline.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  var jsx$2 = $m_Lamf_core_benchmark_ExecutionLog$();
  var jsx$1 = $objectGetClass(this).getName__T();
  var this$1 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(model);
  jsx$2.log__T__Lamf_core_benchmark_ExecutionLog$(((jsx$1 + "#resolve: resolving ") + (this$1.isEmpty__Z() ? "" : this$1.get__O())));
  var m = new $c_sr_ObjectRef().init___O(model);
  this.steps__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, m$1) {
    return (function(s$2) {
      var s = $as_Lamf_core_resolution_stages_ResolutionStage(s$2);
      m$1.elem$1 = this$2$1.step__Lamf_core_model_document_BaseUnit__Lamf_core_resolution_stages_ResolutionStage__Lamf_core_model_document_BaseUnit($as_Lamf_core_model_document_BaseUnit(m$1.elem$1), s)
    })
  })(this, m)));
  var jsx$4 = $m_Lamf_core_benchmark_ExecutionLog$();
  var jsx$3 = $objectGetClass(this).getName__T();
  var this$3 = $as_Lamf_core_model_document_BaseUnit(m.elem$1);
  var this$4 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$3);
  jsx$4.log__T__Lamf_core_benchmark_ExecutionLog$(((jsx$3 + "#resolve: resolved model ") + (this$4.isEmpty__Z() ? "" : this$4.get__O())));
  return $as_Lamf_core_model_document_BaseUnit(m.elem$1)
});
$c_Lamf_core_resolution_pipelines_ResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(eh) {
  this.eh$1 = eh;
  this.errorHandler$1 = eh;
  return this
});
/** @constructor */
function $c_Lamf_core_resolution_pipelines_ResolutionPipeline$() {
  $c_O.call(this);
  this.DEFAULT$undPIPELINE$1 = null;
  this.EDITING$undPIPELINE$1 = null;
  this.COMPATIBILITY$undPIPELINE$1 = null;
  this.CACHE$undPIPELINE$1 = null
}
$c_Lamf_core_resolution_pipelines_ResolutionPipeline$.prototype = new $h_O();
$c_Lamf_core_resolution_pipelines_ResolutionPipeline$.prototype.constructor = $c_Lamf_core_resolution_pipelines_ResolutionPipeline$;
/** @constructor */
function $h_Lamf_core_resolution_pipelines_ResolutionPipeline$() {
  /*<skip>*/
}
$h_Lamf_core_resolution_pipelines_ResolutionPipeline$.prototype = $c_Lamf_core_resolution_pipelines_ResolutionPipeline$.prototype;
$c_Lamf_core_resolution_pipelines_ResolutionPipeline$.prototype.init___ = (function() {
  this.DEFAULT$undPIPELINE$1 = "default";
  this.EDITING$undPIPELINE$1 = "editing";
  this.COMPATIBILITY$undPIPELINE$1 = "compatibility";
  this.CACHE$undPIPELINE$1 = "cache";
  return this
});
$c_Lamf_core_resolution_pipelines_ResolutionPipeline$.prototype.$$js$exported$prop$CACHE$undPIPELINE__O = (function() {
  return this.CACHE$undPIPELINE$1
});
$c_Lamf_core_resolution_pipelines_ResolutionPipeline$.prototype.$$js$exported$prop$DEFAULT$undPIPELINE__O = (function() {
  return this.DEFAULT$undPIPELINE$1
});
$c_Lamf_core_resolution_pipelines_ResolutionPipeline$.prototype.$$js$exported$prop$COMPATIBILITY$undPIPELINE__O = (function() {
  return this.COMPATIBILITY$undPIPELINE$1
});
$c_Lamf_core_resolution_pipelines_ResolutionPipeline$.prototype.$$js$exported$prop$EDITING$undPIPELINE__O = (function() {
  return this.EDITING$undPIPELINE$1
});
Object.defineProperty($c_Lamf_core_resolution_pipelines_ResolutionPipeline$.prototype, "CACHE_PIPELINE", {
  "get": (function() {
    return this.$$js$exported$prop$CACHE$undPIPELINE__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_core_resolution_pipelines_ResolutionPipeline$.prototype, "COMPATIBILITY_PIPELINE", {
  "get": (function() {
    return this.$$js$exported$prop$COMPATIBILITY$undPIPELINE__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_core_resolution_pipelines_ResolutionPipeline$.prototype, "EDITING_PIPELINE", {
  "get": (function() {
    return this.$$js$exported$prop$EDITING$undPIPELINE__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_core_resolution_pipelines_ResolutionPipeline$.prototype, "DEFAULT_PIPELINE", {
  "get": (function() {
    return this.$$js$exported$prop$DEFAULT$undPIPELINE__O()
  }),
  "configurable": true
});
var $d_Lamf_core_resolution_pipelines_ResolutionPipeline$ = new $TypeData().initClass({
  Lamf_core_resolution_pipelines_ResolutionPipeline$: 0
}, false, "amf.core.resolution.pipelines.ResolutionPipeline$", {
  Lamf_core_resolution_pipelines_ResolutionPipeline$: 1,
  O: 1
});
$c_Lamf_core_resolution_pipelines_ResolutionPipeline$.prototype.$classData = $d_Lamf_core_resolution_pipelines_ResolutionPipeline$;
var $n_Lamf_core_resolution_pipelines_ResolutionPipeline$ = (void 0);
function $m_Lamf_core_resolution_pipelines_ResolutionPipeline$() {
  if ((!$n_Lamf_core_resolution_pipelines_ResolutionPipeline$)) {
    $n_Lamf_core_resolution_pipelines_ResolutionPipeline$ = new $c_Lamf_core_resolution_pipelines_ResolutionPipeline$().init___()
  };
  return $n_Lamf_core_resolution_pipelines_ResolutionPipeline$
}
/** @constructor */
function $c_Lamf_core_resolution_stages_ResolutionStage() {
  $c_O.call(this);
  this.errorHandler$1 = null
}
$c_Lamf_core_resolution_stages_ResolutionStage.prototype = new $h_O();
$c_Lamf_core_resolution_stages_ResolutionStage.prototype.constructor = $c_Lamf_core_resolution_stages_ResolutionStage;
/** @constructor */
function $h_Lamf_core_resolution_stages_ResolutionStage() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_ResolutionStage.prototype = $c_Lamf_core_resolution_stages_ResolutionStage.prototype;
$c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  this.errorHandler$1 = errorHandler;
  return this
});
function $as_Lamf_core_resolution_stages_ResolutionStage(obj) {
  return (((obj instanceof $c_Lamf_core_resolution_stages_ResolutionStage) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.resolution.stages.ResolutionStage"))
}
function $isArrayOf_Lamf_core_resolution_stages_ResolutionStage(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_resolution_stages_ResolutionStage)))
}
function $asArrayOf_Lamf_core_resolution_stages_ResolutionStage(obj, depth) {
  return (($isArrayOf_Lamf_core_resolution_stages_ResolutionStage(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.resolution.stages.ResolutionStage;", depth))
}
/** @constructor */
function $c_Lamf_core_resolution_stages_elements_resolution_ElementStageTransformer() {
  $c_O.call(this)
}
$c_Lamf_core_resolution_stages_elements_resolution_ElementStageTransformer.prototype = new $h_O();
$c_Lamf_core_resolution_stages_elements_resolution_ElementStageTransformer.prototype.constructor = $c_Lamf_core_resolution_stages_elements_resolution_ElementStageTransformer;
/** @constructor */
function $h_Lamf_core_resolution_stages_elements_resolution_ElementStageTransformer() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_elements_resolution_ElementStageTransformer.prototype = $c_Lamf_core_resolution_stages_elements_resolution_ElementStageTransformer.prototype;
/** @constructor */
function $c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$() {
  $c_O.call(this);
  this.VALID$undDECLARATION$undCONDITION$1 = null;
  this.ASSERT$undDIFFERENT$1 = null
}
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$.prototype = new $h_O();
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$.prototype.constructor = $c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$;
/** @constructor */
function $h_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$.prototype = $c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$.prototype;
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$.prototype.init___ = (function() {
  $n_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$ = this;
  this.VALID$undDECLARATION$undCONDITION$1 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(link$2, target$2) {
      var link = $as_Lamf_core_model_domain_Linkable(link$2);
      var target = $as_Lamf_core_model_domain_DomainElement(target$2);
      return (link.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf()) && (!$is_Lamf_core_annotations_ErrorDeclaration(target)))
    })
  })(this));
  this.ASSERT$undDIFFERENT$1 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$2) {
    return (function(link$3$2, target$3$2) {
      var link$3 = $as_Lamf_core_model_domain_Linkable(link$3$2);
      var target$3 = $as_Lamf_core_model_domain_DomainElement(target$3$2);
      return ((!((link$3 === null) ? (target$3 === null) : link$3.equals__O__Z(target$3))) && (link$3.id__T() !== target$3.id__T()))
    })
  })(this));
  return this
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$.prototype.$$lessinit$greater$default$5__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(d$2, x$1$2) {
      var d = $as_Lamf_core_model_domain_DomainElement(d$2);
      $as_Lamf_core_model_domain_Linkable(x$1$2);
      return d
    })
  })(this))
});
var $d_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$ = new $TypeData().initClass({
  Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$: 0
}, false, "amf.core.resolution.stages.elements.resolution.ReferenceResolution$", {
  Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$: 1,
  O: 1
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$.prototype.$classData = $d_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$;
var $n_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$ = (void 0);
function $m_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$() {
  if ((!$n_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$)) {
    $n_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$ = new $c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$().init___()
  };
  return $n_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$
}
/** @constructor */
function $c_Lamf_core_resolution_stages_helpers_LinkNodeResolver$() {
  $c_O.call(this)
}
$c_Lamf_core_resolution_stages_helpers_LinkNodeResolver$.prototype = new $h_O();
$c_Lamf_core_resolution_stages_helpers_LinkNodeResolver$.prototype.constructor = $c_Lamf_core_resolution_stages_helpers_LinkNodeResolver$;
/** @constructor */
function $h_Lamf_core_resolution_stages_helpers_LinkNodeResolver$() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_helpers_LinkNodeResolver$.prototype = $c_Lamf_core_resolution_stages_helpers_LinkNodeResolver$.prototype;
$c_Lamf_core_resolution_stages_helpers_LinkNodeResolver$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_resolution_stages_helpers_LinkNodeResolver$.prototype.resolveDynamicLink__Lamf_core_model_domain_LinkNode__s_Option__Z__s_Option = (function(l, modelResolver, keepEditingInfo) {
  if ((l instanceof $c_Lamf_core_resolution_stages_helpers_ResolvedLinkNode)) {
    var x2 = $as_Lamf_core_resolution_stages_helpers_ResolvedLinkNode(l);
    return new $c_s_Some().init___O(x2)
  } else {
    var this$1 = $as_Lamf_core_model_StrField(l.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkNodeModel$().Value$1)).option$1;
    if (this$1.isEmpty__Z()) {
      var x1$2 = $m_s_None$()
    } else {
      var arg1 = this$1.get__O();
      var f = $as_T(arg1);
      if (modelResolver.isEmpty__Z()) {
        var x1$2 = $m_s_None$()
      } else {
        var arg1$1 = modelResolver.get__O();
        var mr = $as_Lamf_core_resolution_stages_helpers_ModelReferenceResolver(arg1$1);
        var x1$2 = mr.findFragment__T__s_Option(f)
      }
    };
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var elem = $as_Lamf_core_model_domain_DomainElement(x2$2.value$2);
      var this$2 = new $c_Lamf_core_resolution_stages_helpers_ResolvedLinkNode().init___Lamf_core_model_domain_LinkNode__Lamf_core_model_domain_DomainElement(l, elem);
      var value = l.id$1;
      var resolved = $as_Lamf_core_resolution_stages_helpers_ResolvedLinkNode($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$2, value));
      if (keepEditingInfo) {
        resolved.annotations$2.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ResolvedLinkAnnotation().init___T(l.id$1));
        var this$3 = l.linkedDomainElement$2;
        if ((!this$3.isEmpty__Z())) {
          var arg1$2 = this$3.get__O();
          var element = $as_Lamf_core_model_domain_DomainElement(arg1$2);
          new $c_s_Some().init___O(resolved.annotations$2.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ResolvedLinkTargetAnnotation().init___T(element.id__T())))
        }
      };
      resolved.annotations$2.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ResolvedInheritance().init___());
      if (elem.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf())) {
        resolved.annotations$2.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_DeclaredElement().init___())
      };
      return new $c_s_Some().init___O(resolved)
    } else {
      var x = $m_s_None$();
      if (((x === x1$2) && l.linkedDomainElement$2.isDefined__Z())) {
        var this$4 = new $c_Lamf_core_resolution_stages_helpers_ResolvedLinkNode().init___Lamf_core_model_domain_LinkNode__Lamf_core_model_domain_DomainElement(l, $as_Lamf_core_model_domain_DomainElement(l.linkedDomainElement$2.get__O()));
        var value$1 = l.id$1;
        var resolved$2 = $as_Lamf_core_resolution_stages_helpers_ResolvedLinkNode($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value$1));
        if (keepEditingInfo) {
          resolved$2.annotations$2.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ResolvedLinkAnnotation().init___T(l.id$1));
          var this$5 = l.linkedDomainElement$2;
          if ((!this$5.isEmpty__Z())) {
            var arg1$3 = this$5.get__O();
            var element$3 = $as_Lamf_core_model_domain_DomainElement(arg1$3);
            new $c_s_Some().init___O(resolved$2.annotations$2.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ResolvedLinkTargetAnnotation().init___T(element$3.id__T())))
          }
        };
        if (l.annotations$2.contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf())) {
          resolved$2.annotations$2.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_DeclaredElement().init___())
        };
        resolved$2.annotations$2.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ResolvedInheritance().init___());
        return new $c_s_Some().init___O(resolved$2)
      } else {
        return new $c_s_Some().init___O(l)
      }
    }
  }
});
var $d_Lamf_core_resolution_stages_helpers_LinkNodeResolver$ = new $TypeData().initClass({
  Lamf_core_resolution_stages_helpers_LinkNodeResolver$: 0
}, false, "amf.core.resolution.stages.helpers.LinkNodeResolver$", {
  Lamf_core_resolution_stages_helpers_LinkNodeResolver$: 1,
  O: 1
});
$c_Lamf_core_resolution_stages_helpers_LinkNodeResolver$.prototype.$classData = $d_Lamf_core_resolution_stages_helpers_LinkNodeResolver$;
var $n_Lamf_core_resolution_stages_helpers_LinkNodeResolver$ = (void 0);
function $m_Lamf_core_resolution_stages_helpers_LinkNodeResolver$() {
  if ((!$n_Lamf_core_resolution_stages_helpers_LinkNodeResolver$)) {
    $n_Lamf_core_resolution_stages_helpers_LinkNodeResolver$ = new $c_Lamf_core_resolution_stages_helpers_LinkNodeResolver$().init___()
  };
  return $n_Lamf_core_resolution_stages_helpers_LinkNodeResolver$
}
/** @constructor */
function $c_Lamf_core_resolution_stages_helpers_ModelReferenceResolver() {
  $c_O.call(this);
  this.model$1 = null
}
$c_Lamf_core_resolution_stages_helpers_ModelReferenceResolver.prototype = new $h_O();
$c_Lamf_core_resolution_stages_helpers_ModelReferenceResolver.prototype.constructor = $c_Lamf_core_resolution_stages_helpers_ModelReferenceResolver;
/** @constructor */
function $h_Lamf_core_resolution_stages_helpers_ModelReferenceResolver() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_helpers_ModelReferenceResolver.prototype = $c_Lamf_core_resolution_stages_helpers_ModelReferenceResolver.prototype;
$c_Lamf_core_resolution_stages_helpers_ModelReferenceResolver.prototype.init___Lamf_core_model_document_BaseUnit = (function(model) {
  this.model$1 = model;
  return this
});
$c_Lamf_core_resolution_stages_helpers_ModelReferenceResolver.prototype.findFragment__T__s_Option = (function(url) {
  var x1 = this.model$1;
  if ($is_Lamf_core_model_document_EncodesModel(x1)) {
    var this$1 = this.model$1;
    var this$2 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$1);
    if ((!this$2.isEmpty__Z())) {
      var arg1 = this$2.get__O();
      var x$1 = $as_T(arg1);
      var jsx$1 = (x$1 === url)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return new $c_s_Some().init___O($as_Lamf_core_model_document_EncodesModel(x1).encodes__Lamf_core_model_domain_DomainElement())
    }
  };
  var this$3 = this.model$1;
  var this$4 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$3);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var x$2 = $as_T(arg1$1);
    var jsx$2 = (x$2 === url)
  } else {
    var jsx$2 = false
  };
  if (jsx$2) {
    return $m_s_None$()
  };
  var jsx$4 = this.model$1.references__sc_Seq();
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_core_model_document_BaseUnit(x$3$2);
      return new $c_Lamf_core_resolution_stages_helpers_ModelReferenceResolver().init___Lamf_core_model_document_BaseUnit(x$3)
    })
  })(this));
  var this$5 = $m_sc_Seq$();
  var remaining = $as_sc_Seq(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$5.ReusableCBFInstance$2));
  var result = $m_s_None$();
  while (remaining.nonEmpty__Z()) {
    var x1$2 = $as_Lamf_core_resolution_stages_helpers_ModelReferenceResolver(remaining.head__O()).findFragment__T__s_Option(url);
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      result = x2$2;
      remaining = $m_sci_Nil$()
    } else {
      remaining = $as_sc_Seq(remaining.tail__O())
    }
  };
  return result
});
function $as_Lamf_core_resolution_stages_helpers_ModelReferenceResolver(obj) {
  return (((obj instanceof $c_Lamf_core_resolution_stages_helpers_ModelReferenceResolver) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.resolution.stages.helpers.ModelReferenceResolver"))
}
function $isArrayOf_Lamf_core_resolution_stages_helpers_ModelReferenceResolver(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_resolution_stages_helpers_ModelReferenceResolver)))
}
function $asArrayOf_Lamf_core_resolution_stages_helpers_ModelReferenceResolver(obj, depth) {
  return (($isArrayOf_Lamf_core_resolution_stages_helpers_ModelReferenceResolver(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.resolution.stages.helpers.ModelReferenceResolver;", depth))
}
var $d_Lamf_core_resolution_stages_helpers_ModelReferenceResolver = new $TypeData().initClass({
  Lamf_core_resolution_stages_helpers_ModelReferenceResolver: 0
}, false, "amf.core.resolution.stages.helpers.ModelReferenceResolver", {
  Lamf_core_resolution_stages_helpers_ModelReferenceResolver: 1,
  O: 1
});
$c_Lamf_core_resolution_stages_helpers_ModelReferenceResolver.prototype.$classData = $d_Lamf_core_resolution_stages_helpers_ModelReferenceResolver;
/** @constructor */
function $c_Lamf_core_services_RuntimeCompiler$() {
  $c_O.call(this);
  this.compiler$1 = null
}
$c_Lamf_core_services_RuntimeCompiler$.prototype = new $h_O();
$c_Lamf_core_services_RuntimeCompiler$.prototype.constructor = $c_Lamf_core_services_RuntimeCompiler$;
/** @constructor */
function $h_Lamf_core_services_RuntimeCompiler$() {
  /*<skip>*/
}
$h_Lamf_core_services_RuntimeCompiler$.prototype = $c_Lamf_core_services_RuntimeCompiler$.prototype;
$c_Lamf_core_services_RuntimeCompiler$.prototype.init___ = (function() {
  $n_Lamf_core_services_RuntimeCompiler$ = this;
  this.compiler$1 = $m_s_None$();
  return this
});
$c_Lamf_core_services_RuntimeCompiler$.prototype.register__Lamf_core_services_RuntimeCompiler__V = (function(runtimeCompiler) {
  this.compiler$1 = new $c_s_Some().init___O(runtimeCompiler)
});
$c_Lamf_core_services_RuntimeCompiler$.prototype.forContext__Lamf_core_CompilerContext__s_Option__s_Option__Lamf_core_parser_ReferenceKind__Lamf_core_client_ParsingOptions__s_concurrent_ExecutionContext__s_concurrent_Future = (function(compilerContext, mediaType, vendor, referenceKind, parsingOptions, executionContext) {
  var x1 = this.compiler$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var runtimeCompiler = $as_Lamf_core_services_RuntimeCompiler(x2.value$2);
    $m_Lamf_core_registries_AMFPluginsRegistry$().featurePlugins__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, compilerContext$1, mediaType$1) {
      return (function(x$2$2) {
        $as_Lamf_client_plugins_AMFFeaturePlugin(x$2$2)
      })
    })(this, compilerContext, mediaType)));
    return runtimeCompiler.build__Lamf_core_CompilerContext__s_Option__s_Option__Lamf_core_parser_ReferenceKind__Lamf_core_client_ParsingOptions__s_concurrent_Future(compilerContext, mediaType, vendor, referenceKind, parsingOptions).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, compilerContext$2) {
      return (function(parsedUnit$2) {
        var parsedUnit = $as_Lamf_core_model_document_BaseUnit(parsedUnit$2);
        return $as_Lamf_core_model_document_BaseUnit($m_Lamf_core_registries_AMFPluginsRegistry$().featurePlugins__sc_Seq().foldLeft__O__F2__O(parsedUnit, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this$1, compilerContext$1$1) {
          return (function(x0$1$2, x1$1$2) {
            var x0$1 = $as_Lamf_core_model_document_BaseUnit(x0$1$2);
            $as_Lamf_client_plugins_AMFFeaturePlugin(x1$1$2);
            return x0$1
          })
        })(this$2, compilerContext$2))))
      })
    })(this, compilerContext)), executionContext)
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("No registered runtime compiler"))
  }
});
$c_Lamf_core_services_RuntimeCompiler$.prototype.apply__T__s_Option__s_Option__Lamf_core_remote_Context__Lamf_core_remote_Cache__Lamf_core_parser_ReferenceKind__s_Option__Lamf_internal_environment_Environment__Lamf_core_client_ParsingOptions__Lamf_core_parser_errorhandler_AmfParserErrorHandler__s_concurrent_ExecutionContext__s_concurrent_Future = (function(url, mediaType, vendor, base, cache, referenceKind, ctx, env, parsingOptions, errorHandler, executionContext) {
  var context = new $c_Lamf_core_CompilerContextBuilder().init___T__Lamf_core_remote_Platform__Lamf_core_parser_errorhandler_ParserErrorHandler(url, base.platform$1, errorHandler).withCache__Lamf_core_remote_Cache__Lamf_core_CompilerContextBuilder(cache).withEnvironment__Lamf_internal_environment_Environment__Lamf_core_CompilerContextBuilder(env).withFileContext__Lamf_core_remote_Context__Lamf_core_CompilerContextBuilder(base).build__s_concurrent_ExecutionContext__Lamf_core_CompilerContext(executionContext);
  var x1 = this.compiler$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var runtimeCompiler = $as_Lamf_core_services_RuntimeCompiler(x2.value$2);
    $m_Lamf_core_registries_AMFPluginsRegistry$().featurePlugins__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, url$1, mediaType$1) {
      return (function(x$1$2) {
        $as_Lamf_client_plugins_AMFFeaturePlugin(x$1$2)
      })
    })(this, url, mediaType)));
    return runtimeCompiler.build__Lamf_core_CompilerContext__s_Option__s_Option__Lamf_core_parser_ReferenceKind__Lamf_core_client_ParsingOptions__s_concurrent_Future(context, mediaType, vendor, referenceKind, parsingOptions).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, url$2) {
      return (function(parsedUnit$2) {
        var parsedUnit = $as_Lamf_core_model_document_BaseUnit(parsedUnit$2);
        return $as_Lamf_core_model_document_BaseUnit($m_Lamf_core_registries_AMFPluginsRegistry$().featurePlugins__sc_Seq().foldLeft__O__F2__O(parsedUnit, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this$1, url$1$1) {
          return (function(x0$1$2, x1$1$2) {
            var x0$1 = $as_Lamf_core_model_document_BaseUnit(x0$1$2);
            $as_Lamf_client_plugins_AMFFeaturePlugin(x1$1$2);
            return x0$1
          })
        })(this$2, url$2))))
      })
    })(this, url)), executionContext)
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("No registered runtime compiler"))
  }
});
var $d_Lamf_core_services_RuntimeCompiler$ = new $TypeData().initClass({
  Lamf_core_services_RuntimeCompiler$: 0
}, false, "amf.core.services.RuntimeCompiler$", {
  Lamf_core_services_RuntimeCompiler$: 1,
  O: 1
});
$c_Lamf_core_services_RuntimeCompiler$.prototype.$classData = $d_Lamf_core_services_RuntimeCompiler$;
var $n_Lamf_core_services_RuntimeCompiler$ = (void 0);
function $m_Lamf_core_services_RuntimeCompiler$() {
  if ((!$n_Lamf_core_services_RuntimeCompiler$)) {
    $n_Lamf_core_services_RuntimeCompiler$ = new $c_Lamf_core_services_RuntimeCompiler$().init___()
  };
  return $n_Lamf_core_services_RuntimeCompiler$
}
/** @constructor */
function $c_Lamf_core_services_RuntimeResolver$() {
  $c_O.call(this)
}
$c_Lamf_core_services_RuntimeResolver$.prototype = new $h_O();
$c_Lamf_core_services_RuntimeResolver$.prototype.constructor = $c_Lamf_core_services_RuntimeResolver$;
/** @constructor */
function $h_Lamf_core_services_RuntimeResolver$() {
  /*<skip>*/
}
$h_Lamf_core_services_RuntimeResolver$.prototype = $c_Lamf_core_services_RuntimeResolver$.prototype;
$c_Lamf_core_services_RuntimeResolver$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_services_RuntimeResolver$.prototype.resolve__T__Lamf_core_model_document_BaseUnit__T__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit = (function(vendor, unit, pipelineId, errorHandler) {
  var this$1 = $m_Lamf_core_registries_AMFPluginsRegistry$();
  var x1 = this$1.documentPluginIDRegistry$1.get__O__s_Option(vendor);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var documentPlugin = $as_Lamf_client_plugins_AMFDocumentPlugin(x2.value$2);
    var plugin = new $c_s_Some().init___O(documentPlugin)
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var plugin = $m_Lamf_core_registries_AMFPluginsRegistry$().documentPluginForVendor__T__sc_Seq(vendor).headOption__s_Option()
  };
  if ((plugin instanceof $c_s_Some)) {
    var x2$2 = $as_s_Some(plugin);
    var documentPlugin$2 = $as_Lamf_client_plugins_AMFDocumentPlugin(x2$2.value$2);
    if ((documentPlugin$2 !== null)) {
      return documentPlugin$2.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_errorhandling_ErrorHandler__T__Lamf_core_model_document_BaseUnit(unit, errorHandler, pipelineId)
    }
  };
  var x$3 = $m_s_None$();
  if ((x$3 === plugin)) {
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
    var node = unit.id__T();
    var property = $m_s_None$();
    var message = ((("Cannot find domain plugin for vendor " + vendor) + " to resolve unit ") + $f_Lamf_core_model_document_BaseUnit__location__s_Option(unit));
    var lexical = unit.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var location = $f_Lamf_core_model_document_BaseUnit__location__s_Option(unit);
    errorHandler.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
    return unit
  };
  throw new $c_s_MatchError().init___O(plugin)
});
var $d_Lamf_core_services_RuntimeResolver$ = new $TypeData().initClass({
  Lamf_core_services_RuntimeResolver$: 0
}, false, "amf.core.services.RuntimeResolver$", {
  Lamf_core_services_RuntimeResolver$: 1,
  O: 1
});
$c_Lamf_core_services_RuntimeResolver$.prototype.$classData = $d_Lamf_core_services_RuntimeResolver$;
var $n_Lamf_core_services_RuntimeResolver$ = (void 0);
function $m_Lamf_core_services_RuntimeResolver$() {
  if ((!$n_Lamf_core_services_RuntimeResolver$)) {
    $n_Lamf_core_services_RuntimeResolver$ = new $c_Lamf_core_services_RuntimeResolver$().init___()
  };
  return $n_Lamf_core_services_RuntimeResolver$
}
/** @constructor */
function $c_Lamf_core_services_RuntimeSerializer$() {
  $c_O.call(this);
  this.serializer$1 = null
}
$c_Lamf_core_services_RuntimeSerializer$.prototype = new $h_O();
$c_Lamf_core_services_RuntimeSerializer$.prototype.constructor = $c_Lamf_core_services_RuntimeSerializer$;
/** @constructor */
function $h_Lamf_core_services_RuntimeSerializer$() {
  /*<skip>*/
}
$h_Lamf_core_services_RuntimeSerializer$.prototype = $c_Lamf_core_services_RuntimeSerializer$.prototype;
$c_Lamf_core_services_RuntimeSerializer$.prototype.init___ = (function() {
  $n_Lamf_core_services_RuntimeSerializer$ = this;
  this.serializer$1 = $m_s_None$();
  return this
});
$c_Lamf_core_services_RuntimeSerializer$.prototype.apply__Lamf_core_model_document_BaseUnit__T__T__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__T = (function(unit, mediaType, vendor, options, shapeOptions) {
  var x1 = this.serializer$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var runtimeSerializer = $as_Lamf_core_services_RuntimeSerializer(x2.value$2);
    return runtimeSerializer.dump__Lamf_core_model_document_BaseUnit__T__T__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__T(unit, mediaType, vendor, options, shapeOptions)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("No registered runtime serializer"))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_core_services_RuntimeSerializer$.prototype.dumpToFile__Lamf_core_remote_Platform__T__Lamf_core_model_document_BaseUnit__T__T__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__s_concurrent_Future = (function(platform, file, unit, mediaType, vendor, options, shapeOptions) {
  var x1 = this.serializer$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var runtimeSerializer = $as_Lamf_core_services_RuntimeSerializer(x2.value$2);
    return runtimeSerializer.dumpToFile__Lamf_core_remote_Platform__T__Lamf_core_model_document_BaseUnit__T__T__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__s_concurrent_Future(platform, file, unit, mediaType, vendor, options, shapeOptions)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("No registered runtime serializer"))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_core_services_RuntimeSerializer$.prototype.register__Lamf_core_services_RuntimeSerializer__V = (function(runtimeSerializer) {
  this.serializer$1 = new $c_s_Some().init___O(runtimeSerializer)
});
var $d_Lamf_core_services_RuntimeSerializer$ = new $TypeData().initClass({
  Lamf_core_services_RuntimeSerializer$: 0
}, false, "amf.core.services.RuntimeSerializer$", {
  Lamf_core_services_RuntimeSerializer$: 1,
  O: 1
});
$c_Lamf_core_services_RuntimeSerializer$.prototype.$classData = $d_Lamf_core_services_RuntimeSerializer$;
var $n_Lamf_core_services_RuntimeSerializer$ = (void 0);
function $m_Lamf_core_services_RuntimeSerializer$() {
  if ((!$n_Lamf_core_services_RuntimeSerializer$)) {
    $n_Lamf_core_services_RuntimeSerializer$ = new $c_Lamf_core_services_RuntimeSerializer$().init___()
  };
  return $n_Lamf_core_services_RuntimeSerializer$
}
function $is_Lamf_core_services_RuntimeValidator(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_services_RuntimeValidator)))
}
function $as_Lamf_core_services_RuntimeValidator(obj) {
  return (($is_Lamf_core_services_RuntimeValidator(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.services.RuntimeValidator"))
}
function $isArrayOf_Lamf_core_services_RuntimeValidator(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_services_RuntimeValidator)))
}
function $asArrayOf_Lamf_core_services_RuntimeValidator(obj, depth) {
  return (($isArrayOf_Lamf_core_services_RuntimeValidator(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.services.RuntimeValidator;", depth))
}
/** @constructor */
function $c_Lamf_core_services_RuntimeValidator$() {
  $c_O.call(this);
  this.validatorOption$1 = null
}
$c_Lamf_core_services_RuntimeValidator$.prototype = new $h_O();
$c_Lamf_core_services_RuntimeValidator$.prototype.constructor = $c_Lamf_core_services_RuntimeValidator$;
/** @constructor */
function $h_Lamf_core_services_RuntimeValidator$() {
  /*<skip>*/
}
$h_Lamf_core_services_RuntimeValidator$.prototype = $c_Lamf_core_services_RuntimeValidator$.prototype;
$c_Lamf_core_services_RuntimeValidator$.prototype.init___ = (function() {
  $n_Lamf_core_services_RuntimeValidator$ = this;
  this.validatorOption$1 = $m_s_None$();
  return this
});
$c_Lamf_core_services_RuntimeValidator$.prototype.loadValidationProfile__T__Lamf_internal_environment_Environment__Lamf_core_errorhandling_ErrorHandler__s_concurrent_Future = (function(validationProfilePath, env, errorHandler) {
  var qual$1 = this.validator__p1__Lamf_core_services_RuntimeValidator();
  var this$1 = qual$1.platform$1;
  var x$4 = this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  return qual$1.loadValidationProfile__T__Lamf_internal_environment_Environment__Lamf_core_errorhandling_ErrorHandler__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(validationProfilePath, env, errorHandler, x$4)
});
$c_Lamf_core_services_RuntimeValidator$.prototype.register__Lamf_core_services_RuntimeValidator__V = (function(runtimeValidator) {
  this.validatorOption$1 = new $c_s_Some().init___O(runtimeValidator)
});
$c_Lamf_core_services_RuntimeValidator$.prototype.apply__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_internal_environment_Environment__Z__s_concurrent_Future = (function(model, profileName, messageStyle, env, resolved) {
  var qual$1 = this.validator__p1__Lamf_core_services_RuntimeValidator();
  var this$1 = qual$1.platform$1;
  var x$6 = this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  return qual$1.validate__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(model, profileName, messageStyle, env, resolved, x$6)
});
$c_Lamf_core_services_RuntimeValidator$.prototype.validator__p1__Lamf_core_services_RuntimeValidator = (function() {
  var x1 = this.validatorOption$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var runtimeValidator = $as_Lamf_core_services_RuntimeValidator(x2.value$2);
    return runtimeValidator
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("No registered runtime validator"))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
var $d_Lamf_core_services_RuntimeValidator$ = new $TypeData().initClass({
  Lamf_core_services_RuntimeValidator$: 0
}, false, "amf.core.services.RuntimeValidator$", {
  Lamf_core_services_RuntimeValidator$: 1,
  O: 1
});
$c_Lamf_core_services_RuntimeValidator$.prototype.$classData = $d_Lamf_core_services_RuntimeValidator$;
var $n_Lamf_core_services_RuntimeValidator$ = (void 0);
function $m_Lamf_core_services_RuntimeValidator$() {
  if ((!$n_Lamf_core_services_RuntimeValidator$)) {
    $n_Lamf_core_services_RuntimeValidator$ = new $c_Lamf_core_services_RuntimeValidator$().init___()
  };
  return $n_Lamf_core_services_RuntimeValidator$
}
/** @constructor */
function $c_Lamf_core_services_ValidationOptions() {
  $c_O.call(this);
  this.filterFields$1 = null;
  this.messageStyle$1 = null;
  this.level$1 = null
}
$c_Lamf_core_services_ValidationOptions.prototype = new $h_O();
$c_Lamf_core_services_ValidationOptions.prototype.constructor = $c_Lamf_core_services_ValidationOptions;
/** @constructor */
function $h_Lamf_core_services_ValidationOptions() {
  /*<skip>*/
}
$h_Lamf_core_services_ValidationOptions.prototype = $c_Lamf_core_services_ValidationOptions.prototype;
$c_Lamf_core_services_ValidationOptions.prototype.init___ = (function() {
  this.filterFields$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      $as_Lamf_core_metamodel_Field(x$1$2);
      return false
    })
  })(this));
  this.messageStyle$1 = $m_Lamf_AMFStyle$();
  this.level$1 = "partial";
  return this
});
$c_Lamf_core_services_ValidationOptions.prototype.withFullValidation__Lamf_core_services_ValidationOptions = (function() {
  this.level$1 = "full";
  return this
});
$c_Lamf_core_services_ValidationOptions.prototype.isPartialValidation__Z = (function() {
  return (this.level$1 === "partial")
});
$c_Lamf_core_services_ValidationOptions.prototype.withPartialValidation__Lamf_core_services_ValidationOptions = (function() {
  this.level$1 = "partial";
  return this
});
$c_Lamf_core_services_ValidationOptions.prototype.withMessageStyle__Lamf_MessageStyle__Lamf_core_services_ValidationOptions = (function(style) {
  this.messageStyle$1 = style;
  return this
});
var $d_Lamf_core_services_ValidationOptions = new $TypeData().initClass({
  Lamf_core_services_ValidationOptions: 0
}, false, "amf.core.services.ValidationOptions", {
  Lamf_core_services_ValidationOptions: 1,
  O: 1
});
$c_Lamf_core_services_ValidationOptions.prototype.$classData = $d_Lamf_core_services_ValidationOptions;
/** @constructor */
function $c_Lamf_core_traversal_TransformationTraversal() {
  $c_O.call(this);
  this.transformation$1 = null
}
$c_Lamf_core_traversal_TransformationTraversal.prototype = new $h_O();
$c_Lamf_core_traversal_TransformationTraversal.prototype.constructor = $c_Lamf_core_traversal_TransformationTraversal;
/** @constructor */
function $h_Lamf_core_traversal_TransformationTraversal() {
  /*<skip>*/
}
$h_Lamf_core_traversal_TransformationTraversal.prototype = $c_Lamf_core_traversal_TransformationTraversal.prototype;
$c_Lamf_core_traversal_TransformationTraversal.prototype.traverseObjectEntry__Lamf_core_model_domain_AmfObject__Lamf_core_traversal_TraversalPath__Lamf_core_parser_FieldEntry__O = (function(element, traversalPath, fieldEntry) {
  if ((fieldEntry === null)) {
    throw new $c_s_MatchError().init___O(fieldEntry)
  };
  var field = fieldEntry.field$1;
  var value = fieldEntry.value$1;
  var rc8 = false;
  var x2 = null;
  var x1$2 = $m_s_Option$().apply__O__s_Option(this.traverse__Lamf_core_model_domain_AmfObject__Lamf_core_traversal_TraversalPath__Lamf_core_model_domain_AmfObject($as_Lamf_core_model_domain_AmfObject(fieldEntry.value$1.value$1), traversalPath));
  if ((x1$2 instanceof $c_s_Some)) {
    rc8 = true;
    x2 = $as_s_Some(x1$2);
    var transformedValue = $as_Lamf_core_model_domain_AmfObject(x2.value$2);
    if ((transformedValue !== null)) {
      return element.fields__Lamf_core_parser_Fields().setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(field, transformedValue, this.lexicalAnnotationsOf__p1__Lamf_core_parser_Value__Lamf_core_parser_Annotations(value))
    }
  };
  if (rc8) {
    return (void 0)
  };
  var x = $m_s_None$();
  if ((x === x1$2)) {
    return element.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields(field)
  };
  throw new $c_s_MatchError().init___O(x1$2)
});
$c_Lamf_core_traversal_TransformationTraversal.prototype.getSortedFieldsOf__Lamf_core_model_domain_AmfObject__sc_Iterable = (function(element) {
  if ($is_Lamf_core_model_document_DeclaresModel(element)) {
    var x2 = $as_Lamf_core_model_document_DeclaresModel(element);
    var this$1 = x2.fields__Lamf_core_parser_Fields();
    var this$4 = this$1.fs$1;
    var this$2 = $m_Lamf_core_parser_FieldEntry$();
    var f = $f_F2__tupled__F1(this$2);
    var this$3 = $m_sci_Iterable$();
    var bf = this$3.ReusableCBFInstance$2;
    return $as_sc_Iterable($as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$4, f, bf)).toSeq__sc_Seq().sorted__s_math_Ordering__O(new $c_Lamf_core_traversal_DeclaresModelFieldOrdering().init___()))
  } else if ($is_Lamf_core_model_document_BaseUnit(element)) {
    var x3 = $as_Lamf_core_model_document_BaseUnit(element);
    var this$5 = x3.fields__Lamf_core_parser_Fields();
    var this$8 = this$5.fs$1;
    var this$6 = $m_Lamf_core_parser_FieldEntry$();
    var f$1 = $f_F2__tupled__F1(this$6);
    var this$7 = $m_sci_Iterable$();
    var bf$1 = this$7.ReusableCBFInstance$2;
    return $as_sc_Iterable($as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$8, f$1, bf$1)).toSeq__sc_Seq().sorted__s_math_Ordering__O(new $c_Lamf_core_traversal_BaseUnitFieldOrdering().init___()))
  } else {
    var this$9 = element.fields__Lamf_core_parser_Fields();
    var this$12 = this$9.fs$1;
    var this$10 = $m_Lamf_core_parser_FieldEntry$();
    var f$2 = $f_F2__tupled__F1(this$10);
    var this$11 = $m_sci_Iterable$();
    var bf$2 = this$11.ReusableCBFInstance$2;
    return $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$12, f$2, bf$2))
  }
});
$c_Lamf_core_traversal_TransformationTraversal.prototype.init___Lamf_core_traversal_TransformationData = (function(transformation) {
  this.transformation$1 = transformation;
  return this
});
$c_Lamf_core_traversal_TransformationTraversal.prototype.lexicalAnnotationsOf__p1__Lamf_core_parser_Value__Lamf_core_parser_Annotations = (function(value) {
  var this$1 = value.annotations$1;
  var f = (function($this) {
    return (function(a$2) {
      var a = $as_Lamf_core_model_domain_Annotation(a$2);
      return (((a instanceof $c_Lamf_core_annotations_LexicalInformation) || (a instanceof $c_Lamf_core_annotations_SourceAST)) || (a instanceof $c_Lamf_core_annotations_SourceNode))
    })
  })(this);
  $m_Lamf_core_parser_Annotations$();
  var jsx$2 = new $c_Lamf_core_parser_Annotations().init___();
  var this$3 = this$1.amf$core$parser$Annotations$$annotations$1;
  if ((this$3 instanceof $c_sci_List)) {
    var x2 = $as_sci_List(this$3);
    var l = x2;
    var l$1 = l;
    x: {
      var result;
      _noneIn: while (true) {
        if (l$1.isEmpty__Z()) {
          var result = $m_sci_Nil$();
          break
        } else {
          var h = l$1.head__O();
          var t = $as_sci_List(l$1.tail__O());
          if (($uZ(f(h)) === false)) {
            l$1 = t;
            continue _noneIn
          };
          var start = l$1;
          var remaining = t;
          var remaining$1 = remaining;
          _allIn: while (true) {
            if (remaining$1.isEmpty__Z()) {
              var result = start;
              break x
            } else {
              var x$2 = remaining$1.head__O();
              if (($uZ(f(x$2)) !== false)) {
                remaining$1 = $as_sci_List(remaining$1.tail__O());
                continue _allIn
              };
              var firstMiss = remaining$1;
              var newHead = new $c_sci_$colon$colon().init___O__sci_List(start.head__O(), $m_sci_Nil$());
              var toProcess = $as_sci_List(start.tail__O());
              var currentLast = newHead;
              while ((toProcess !== firstMiss)) {
                var newElem = new $c_sci_$colon$colon().init___O__sci_List(toProcess.head__O(), $m_sci_Nil$());
                currentLast.tl$5 = newElem;
                currentLast = newElem;
                toProcess = $as_sci_List(toProcess.tail__O())
              };
              var next = $as_sci_List(firstMiss.tail__O());
              var nextToCopy = next;
              while ((!next.isEmpty__Z())) {
                var head = next.head__O();
                if (($uZ(f(head)) !== false)) {
                  next = $as_sci_List(next.tail__O())
                } else {
                  while ((nextToCopy !== next)) {
                    var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy.head__O(), $m_sci_Nil$());
                    currentLast.tl$5 = newElem$2;
                    currentLast = newElem$2;
                    nextToCopy = $as_sci_List(nextToCopy.tail__O())
                  };
                  nextToCopy = $as_sci_List(next.tail__O());
                  next = $as_sci_List(next.tail__O())
                }
              };
              if ((!nextToCopy.isEmpty__Z())) {
                currentLast.tl$5 = nextToCopy
              };
              var result = newHead;
              break x
            }
          }
        }
      }
    };
    var jsx$1 = result
  } else {
    $m_scm_ListBuffer$();
    var b = new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_ListBuffer().init___());
    var this$5 = this$3.scala$collection$mutable$ListBuffer$$start$6;
    var these = this$5;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      if (($uZ(f(arg1)) !== false)) {
        b.$$plus$eq__O__scm_GrowingBuilder(arg1)
      };
      these = $as_sci_List(these.tail__O())
    };
    var jsx$1 = b.elems$1
  };
  return jsx$2.$$plus$plus$eq__sc_TraversableOnce__Lamf_core_parser_Annotations($as_sc_TraversableOnce(jsx$1))
});
$c_Lamf_core_traversal_TransformationTraversal.prototype.traverse__Lamf_core_model_domain_AmfObject__Lamf_core_traversal_TraversalPath__Lamf_core_model_domain_AmfObject = (function(element, traversalPath) {
  return ((!traversalPath.traversed$1.contains__O__Z(element.id__T())) ? this.traverseElement__Lamf_core_model_domain_AmfObject__Lamf_core_traversal_TraversalPath__Lamf_core_model_domain_AmfObject(element, traversalPath) : element)
});
$c_Lamf_core_traversal_TransformationTraversal.prototype.traverseElement__Lamf_core_model_domain_AmfObject__Lamf_core_traversal_TraversalPath__Lamf_core_model_domain_AmfObject = (function(element, traversalPath) {
  if ($uZ(this.transformation$1.predicate$1.apply__O__O(element))) {
    var x1 = $as_s_Option(this.transformation$1.transformation$1.apply__O__O__O(element, false));
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var transformed = $as_Lamf_core_model_domain_AmfObject(x2.value$2);
      if ((transformed !== null)) {
        return transformed
      }
    };
    return $as_Lamf_core_model_domain_AmfObject((x1.isEmpty__Z() ? null : x1.get__O()))
  } else {
    traversalPath.traversed$1.add__O__Z(element.id__T());
    var effectiveFields = this.getSortedFieldsOf__Lamf_core_model_domain_AmfObject__sc_Iterable(element);
    effectiveFields.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, element$1, traversalPath$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_parser_FieldEntry(x0$1$2);
        if ((x0$1 !== null)) {
          var value = x0$1.value$1;
          if ($is_Lamf_core_model_domain_AmfObject(value.value$1)) {
            return $this.traverseObjectEntry__Lamf_core_model_domain_AmfObject__Lamf_core_traversal_TraversalPath__Lamf_core_parser_FieldEntry__O(element$1, traversalPath$1, x0$1)
          }
        };
        if ((x0$1 !== null)) {
          var value$2 = x0$1.value$1;
          if ((value$2.value$1 instanceof $c_Lamf_core_model_domain_AmfArray)) {
            return $this.traverseArrayEntry__Lamf_core_model_domain_AmfObject__Lamf_core_traversal_TraversalPath__Lamf_core_parser_FieldEntry__Lamf_core_parser_Fields(element$1, traversalPath$1, x0$1)
          }
        }
      })
    })(this, element, traversalPath)));
    return element
  }
});
$c_Lamf_core_traversal_TransformationTraversal.prototype.traverseArrayEntry__Lamf_core_model_domain_AmfObject__Lamf_core_traversal_TraversalPath__Lamf_core_parser_FieldEntry__Lamf_core_parser_Fields = (function(element, traversalPath, fieldEntry) {
  if ((fieldEntry === null)) {
    throw new $c_s_MatchError().init___O(fieldEntry)
  };
  var field = fieldEntry.field$1;
  var value = fieldEntry.value$1;
  var jsx$4 = $as_Lamf_core_model_domain_AmfArray(fieldEntry.value$1.value$1).values$1;
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, traversalPath$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_domain_AmfElement(x0$1$2);
      if ($is_Lamf_core_model_domain_AmfObject(x0$1)) {
        var x2 = $as_Lamf_core_model_domain_AmfObject(x0$1);
        var transformedValue = $this.traverse__Lamf_core_model_domain_AmfObject__Lamf_core_traversal_TraversalPath__Lamf_core_model_domain_AmfObject(x2, traversalPath$1);
        return new $c_s_Some().init___O(transformedValue)
      } else {
        return new $c_s_Some().init___O(x0$1)
      }
    })
  })(this, traversalPath));
  var this$1 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike($as_sc_TraversableLike(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$1.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$3$2) {
      var x$3 = $as_s_Some(x$3$2);
      return x$3.isDefined__Z()
    })
  })(this))));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3) {
    return (function(x$4$2) {
      var x$4 = $as_s_Some(x$4$2);
      return $as_Lamf_core_model_domain_AmfElement(x$4.value$2)
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  var newElements = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2));
  return element.fields__Lamf_core_parser_Fields().setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(field, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(newElements, new $c_Lamf_core_parser_Annotations().init___()), value.annotations$1)
});
var $d_Lamf_core_traversal_TransformationTraversal = new $TypeData().initClass({
  Lamf_core_traversal_TransformationTraversal: 0
}, false, "amf.core.traversal.TransformationTraversal", {
  Lamf_core_traversal_TransformationTraversal: 1,
  O: 1
});
$c_Lamf_core_traversal_TransformationTraversal.prototype.$classData = $d_Lamf_core_traversal_TransformationTraversal;
/** @constructor */
function $c_Lamf_core_unsafe_PlatformBuilder$() {
  $c_O.call(this);
  this.platform$1 = null
}
$c_Lamf_core_unsafe_PlatformBuilder$.prototype = new $h_O();
$c_Lamf_core_unsafe_PlatformBuilder$.prototype.constructor = $c_Lamf_core_unsafe_PlatformBuilder$;
/** @constructor */
function $h_Lamf_core_unsafe_PlatformBuilder$() {
  /*<skip>*/
}
$h_Lamf_core_unsafe_PlatformBuilder$.prototype = $c_Lamf_core_unsafe_PlatformBuilder$.prototype;
$c_Lamf_core_unsafe_PlatformBuilder$.prototype.init___ = (function() {
  $n_Lamf_core_unsafe_PlatformBuilder$ = this;
  this.platform$1 = (this.isBrowser__p1__Z() ? new $c_Lamf_core_remote_browser_JsBrowserPlatform().init___() : new $c_Lamf_core_remote_server_JsServerPlatform().init___());
  return this
});
$c_Lamf_core_unsafe_PlatformBuilder$.prototype.isBrowser__p1__Z = (function() {
  var v = $g.document;
  return (!(v === (void 0)))
});
var $d_Lamf_core_unsafe_PlatformBuilder$ = new $TypeData().initClass({
  Lamf_core_unsafe_PlatformBuilder$: 0
}, false, "amf.core.unsafe.PlatformBuilder$", {
  Lamf_core_unsafe_PlatformBuilder$: 1,
  O: 1
});
$c_Lamf_core_unsafe_PlatformBuilder$.prototype.$classData = $d_Lamf_core_unsafe_PlatformBuilder$;
var $n_Lamf_core_unsafe_PlatformBuilder$ = (void 0);
function $m_Lamf_core_unsafe_PlatformBuilder$() {
  if ((!$n_Lamf_core_unsafe_PlatformBuilder$)) {
    $n_Lamf_core_unsafe_PlatformBuilder$ = new $c_Lamf_core_unsafe_PlatformBuilder$().init___()
  };
  return $n_Lamf_core_unsafe_PlatformBuilder$
}
/** @constructor */
function $c_Lamf_core_utils_InflectorBase$() {
  $c_O.call(this);
  this.amf$core$utils$InflectorBase$$singulars$1 = null;
  this.amf$core$utils$InflectorBase$$plurals$1 = null;
  this.amf$core$utils$InflectorBase$$irregulars$1 = null;
  this.amf$core$utils$InflectorBase$$uncountables$1 = null
}
$c_Lamf_core_utils_InflectorBase$.prototype = new $h_O();
$c_Lamf_core_utils_InflectorBase$.prototype.constructor = $c_Lamf_core_utils_InflectorBase$;
/** @constructor */
function $h_Lamf_core_utils_InflectorBase$() {
  /*<skip>*/
}
$h_Lamf_core_utils_InflectorBase$.prototype = $c_Lamf_core_utils_InflectorBase$.prototype;
$c_Lamf_core_utils_InflectorBase$.prototype.init___ = (function() {
  $n_Lamf_core_utils_InflectorBase$ = this;
  this.amf$core$utils$InflectorBase$$singulars$1 = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  this.amf$core$utils$InflectorBase$$plurals$1 = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  this.amf$core$utils$InflectorBase$$irregulars$1 = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  this.addPlural__p1__T__T__V("(ax|test)is$", "$1es");
  this.addPlural__p1__T__T__V("(octop|vir)us$", "$1i");
  this.addPlural__p1__T__T__V("(alias|status)$", "$1es");
  this.addPlural__p1__T__T__V("(bu)s$", "$1ses");
  this.addPlural__p1__T__T__V("(buffal|tomat)o$", "$1oes");
  this.addPlural__p1__T__T__V("([ti])um$", "$1a");
  this.addPlural__p1__T__T__V("sis$", "ses");
  this.addPlural__p1__T__T__V("(?:([^f])fe|([lr])f)$", "$1$2ves");
  this.addPlural__p1__T__T__V("(hive)$", "$1s");
  this.addPlural__p1__T__T__V("([^aeiouy]|qu)y$", "$1ies");
  this.addPlural__p1__T__T__V("(x|ch|ss|sh)$", "$1es");
  this.addPlural__p1__T__T__V("(matr|vert|ind)(?:ix|ex)$", "$1ices");
  this.addPlural__p1__T__T__V("([m|l])ouse$", "$1ice");
  this.addPlural__p1__T__T__V("^(ox)$", "$1en");
  this.addPlural__p1__T__T__V("(quiz)$", "$1zes");
  this.addPlural__p1__T__T__V("s$", "s");
  this.addPlural__p1__T__T__V("$", "s");
  this.addSingular__p1__T__T__V("(n)ews$", "$1ews");
  this.addSingular__p1__T__T__V("([ti])a$", "$1um");
  this.addSingular__p1__T__T__V("((a)naly|(b)a|(d)iagno|(p)arenthe|(p)rogno|(s)ynop|(t)he)ses$", "$1sis");
  this.addSingular__p1__T__T__V("((a)naly|(b)a|(d)iagno|(p)arenthe|(p)rogno|(s)ynop|(t)he)sis$", "$1sis");
  this.addSingular__p1__T__T__V("(^analy)ses$", "$1sis");
  this.addSingular__p1__T__T__V("([^f])ves$", "$1fe");
  this.addSingular__p1__T__T__V("(hive)s$", "$1");
  this.addSingular__p1__T__T__V("(tive)s$", "$1");
  this.addSingular__p1__T__T__V("([lr])ves$", "$1f");
  this.addSingular__p1__T__T__V("([^aeiouy]|qu)ies$", "$1y");
  this.addSingular__p1__T__T__V("(s)eries$", "$1eries");
  this.addSingular__p1__T__T__V("(m)ovies$", "$1ovie");
  this.addSingular__p1__T__T__V("(x|ch|ss|sh)es$", "$1");
  this.addSingular__p1__T__T__V("([m|l])ice$", "$1ouse");
  this.addSingular__p1__T__T__V("(bus)es$", "$1");
  this.addSingular__p1__T__T__V("(bus)$", "$1");
  this.addSingular__p1__T__T__V("(o)es$", "$1");
  this.addSingular__p1__T__T__V("(shoe)s$", "$1");
  this.addSingular__p1__T__T__V("(cris|ax|test)es$", "$1is");
  this.addSingular__p1__T__T__V("(cris|ax|test)is$", "$1is");
  this.addSingular__p1__T__T__V("(octop|vir)i$", "$1us");
  this.addSingular__p1__T__T__V("(alias|status)es$", "$1");
  this.addSingular__p1__T__T__V("(alias|status)$", "$1");
  this.addSingular__p1__T__T__V("^(ox)en", "$1");
  this.addSingular__p1__T__T__V("(vert|ind)ices$", "$1ex");
  this.addSingular__p1__T__T__V("(matr)ices$", "$1ix");
  this.addSingular__p1__T__T__V("(quiz)zes$", "$1");
  this.addSingular__p1__T__T__V("(database)s$", "$1");
  this.addSingular__p1__T__T__V("s$", "");
  this.addIrregular__p1__T__T__V("person", "people");
  this.addIrregular__p1__T__T__V("man", "men");
  this.addIrregular__p1__T__T__V("child", "children");
  this.addIrregular__p1__T__T__V("sex", "sexes");
  this.addIrregular__p1__T__T__V("move", "moves");
  this.addIrregular__p1__T__T__V("foot", "feet");
  this.addIrregular__p1__T__T__V("tooth", "teeth");
  this.addIrregular__p1__T__T__V("initiative", "initiatives");
  $m_sci_List$();
  var array = ["equipment", "information", "rice", "money", "species", "series", "fish", "sheep"];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  this.amf$core$utils$InflectorBase$$uncountables$1 = result;
  return this
});
$c_Lamf_core_utils_InflectorBase$.prototype.addPlural__p1__T__T__V = (function(rule, replacement) {
  this.amf$core$utils$InflectorBase$$plurals$1.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_utils_InflectorBase$Container().init___T__T(rule, replacement))
});
$c_Lamf_core_utils_InflectorBase$.prototype.addSingular__p1__T__T__V = (function(rule, replacement) {
  this.amf$core$utils$InflectorBase$$singulars$1.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_utils_InflectorBase$Container().init___T__T(rule, replacement))
});
$c_Lamf_core_utils_InflectorBase$.prototype.addIrregular__p1__T__T__V = (function(rule, replacement) {
  this.amf$core$utils$InflectorBase$$irregulars$1.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_utils_InflectorBase$Container().init___T__T(rule, replacement))
});
var $d_Lamf_core_utils_InflectorBase$ = new $TypeData().initClass({
  Lamf_core_utils_InflectorBase$: 0
}, false, "amf.core.utils.InflectorBase$", {
  Lamf_core_utils_InflectorBase$: 1,
  O: 1
});
$c_Lamf_core_utils_InflectorBase$.prototype.$classData = $d_Lamf_core_utils_InflectorBase$;
var $n_Lamf_core_utils_InflectorBase$ = (void 0);
function $m_Lamf_core_utils_InflectorBase$() {
  if ((!$n_Lamf_core_utils_InflectorBase$)) {
    $n_Lamf_core_utils_InflectorBase$ = new $c_Lamf_core_utils_InflectorBase$().init___()
  };
  return $n_Lamf_core_utils_InflectorBase$
}
/** @constructor */
function $c_Lamf_core_utils_InflectorBase$Inflector() {
  $c_O.call(this);
  this.word$1 = null
}
$c_Lamf_core_utils_InflectorBase$Inflector.prototype = new $h_O();
$c_Lamf_core_utils_InflectorBase$Inflector.prototype.constructor = $c_Lamf_core_utils_InflectorBase$Inflector;
/** @constructor */
function $h_Lamf_core_utils_InflectorBase$Inflector() {
  /*<skip>*/
}
$h_Lamf_core_utils_InflectorBase$Inflector.prototype = $c_Lamf_core_utils_InflectorBase$Inflector.prototype;
$c_Lamf_core_utils_InflectorBase$Inflector.prototype.gsub__p1__T__T__T__s_Option = (function(word, rule, replacement) {
  var pattern = $m_ju_regex_Pattern$().compile__T__I__ju_regex_Pattern(rule, 2);
  var matcher = new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(pattern, word, 0, $uI(word.length));
  return (matcher.find__Z() ? new $c_s_Some().init___O(matcher.replaceFirst__T__T(replacement)) : $m_s_None$())
});
$c_Lamf_core_utils_InflectorBase$Inflector.prototype.camelize__Z__T = (function(capitalizeFirstChar) {
  var thiz = this.word$1;
  var split = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "(_|-|\\s)+", 0);
  if ((split.u.length === 0)) {
    if ((split.u.length === 0)) {
      throw new $c_jl_UnsupportedOperationException().init___T("empty.tail")
    };
    var until = split.u.length;
    var x = ((until > 0) ? until : 0);
    var y = split.u.length;
    var hi = ((x < y) ? x : y);
    var x$1 = (((-1) + hi) | 0);
    var size = ((x$1 > 0) ? x$1 : 0);
    var result = $m_jl_reflect_Array$().newInstance__jl_Class__I__O($objectGetClass(split).getComponentType__jl_Class(), size);
    if ((size > 0)) {
      $m_s_Array$().copy__O__I__O__I__I__V(split, 1, result, 0, size)
    };
    var jsx$1 = result
  } else {
    var until$1 = split.u.length;
    var x$2 = ((until$1 > 0) ? until$1 : 0);
    var y$1 = split.u.length;
    var hi$1 = ((x$2 < y$1) ? x$2 : y$1);
    var x$3 = (((-1) + hi$1) | 0);
    var size$1 = ((x$3 > 0) ? x$3 : 0);
    var result$1 = $m_jl_reflect_Array$().newInstance__jl_Class__I__O($objectGetClass(split).getComponentType__jl_Class(), size$1);
    if ((size$1 > 0)) {
      $m_s_Array$().copy__O__I__O__I__I__V(split, 1, result$1, 0, size$1)
    };
    var jsx$1 = result$1
  };
  var xs = $asArrayOf_O(jsx$1, 1);
  var elems$2 = null;
  elems$2 = [];
  var x1 = xs.u.length;
  switch (x1) {
    case (-1): {
      break
    }
  };
  var i = 0;
  var len = xs.u.length;
  while ((i < len)) {
    var index = i;
    var arg1 = xs.get(index);
    var x$4 = $as_T(arg1);
    var this$32 = new $c_sci_StringOps().init___T(x$4);
    var c = $f_sc_IndexedSeqOptimized__head__O(this$32);
    if ((c === null)) {
      var c$1 = 0
    } else {
      var this$34 = $as_jl_Character(c);
      var c$1 = this$34.value$1
    };
    var c$2 = $m_jl_Character$().toUpperCase__C__C(c$1);
    var jsx$2 = new $c_jl_Character().init___C(c$2);
    var this$40 = new $c_sci_StringOps().init___T(x$4);
    var elem = (("" + jsx$2) + $as_T($f_sc_IndexedSeqOptimized__tail__O(this$40)));
    elems$2.push(elem);
    i = ((1 + i) | 0)
  };
  var tail = $makeNativeArrayWrapper($d_T.getArrayOf(), elems$2);
  if (capitalizeFirstChar) {
    var this$42 = new $c_scm_ArrayOps$ofRef().init___AO(split);
    var x$5 = $as_T($f_sc_IndexedSeqOptimized__head__O(this$42));
    var this$44 = new $c_sci_StringOps().init___T(x$5);
    var jsx$3 = $f_sci_StringLike__capitalize__T(this$44);
    var b = new $c_scm_StringBuilder().init___();
    var elem$1 = false;
    elem$1 = true;
    b.append__T__scm_StringBuilder("");
    var i$1 = 0;
    var len$1 = tail.u.length;
    while ((i$1 < len$1)) {
      var index$1 = i$1;
      var arg1$1 = tail.get(index$1);
      if (elem$1) {
        b.append__O__scm_StringBuilder(arg1$1);
        elem$1 = false
      } else {
        b.append__T__scm_StringBuilder("");
        b.append__O__scm_StringBuilder(arg1$1)
      };
      i$1 = ((1 + i$1) | 0)
    };
    b.append__T__scm_StringBuilder("");
    return (("" + jsx$3) + b.underlying$5.java$lang$StringBuilder$$content$f)
  } else {
    var this$50 = new $c_scm_ArrayOps$ofRef().init___AO(split);
    var jsx$4 = $as_T($f_sc_IndexedSeqOptimized__head__O(this$50));
    var b$1 = new $c_scm_StringBuilder().init___();
    var elem$1$1 = false;
    elem$1$1 = true;
    b$1.append__T__scm_StringBuilder("");
    var i$2 = 0;
    var len$2 = tail.u.length;
    while ((i$2 < len$2)) {
      var index$2 = i$2;
      var arg1$2 = tail.get(index$2);
      if (elem$1$1) {
        b$1.append__O__scm_StringBuilder(arg1$2);
        elem$1$1 = false
      } else {
        b$1.append__T__scm_StringBuilder("");
        b$1.append__O__scm_StringBuilder(arg1$2)
      };
      i$2 = ((1 + i$2) | 0)
    };
    b$1.append__T__scm_StringBuilder("");
    return (("" + jsx$4) + b$1.underlying$5.java$lang$StringBuilder$$content$f)
  }
});
$c_Lamf_core_utils_InflectorBase$Inflector.prototype.pluralize__T = (function() {
  var this$1 = $m_Lamf_core_utils_InflectorBase$().amf$core$utils$InflectorBase$$uncountables$1;
  var elem = this.word$1;
  if ($f_sc_LinearSeqOptimized__contains__O__Z(this$1, elem)) {
    return this.word$1
  } else {
    var this$2 = $m_Lamf_core_utils_InflectorBase$().amf$core$utils$InflectorBase$$irregulars$1;
    var this$3 = this$2.scala$collection$mutable$ListBuffer$$start$6;
    inlinereturn$6: {
      var these = this$3;
      while ((!these.isEmpty__Z())) {
        var arg1 = these.head__O();
        var i = $as_Lamf_core_utils_InflectorBase$Container(arg1);
        var thiz = i.rule$1;
        var that = this.word$1;
        if (($as_T(thiz.toLowerCase()) === ((that === null) ? null : $as_T(that.toLowerCase())))) {
          var this$7 = new $c_s_Some().init___O(these.head__O());
          break inlinereturn$6
        };
        these = $as_sc_LinearSeqOptimized(these.tail__O())
      };
      var this$7 = $m_s_None$()
    };
    if (this$7.isEmpty__Z()) {
      var this$8 = $m_s_None$()
    } else {
      var arg1$1 = this$7.get__O();
      var x$1 = $as_Lamf_core_utils_InflectorBase$Container(arg1$1);
      var this$8 = new $c_s_Some().init___O(x$1.replacement$1)
    };
    var this$9 = (this$8.isEmpty__Z() ? this.findGSubInList__p1__sc_Seq__T__s_Option($m_Lamf_core_utils_InflectorBase$().amf$core$utils$InflectorBase$$plurals$1, this.word$1) : this$8);
    return $as_T((this$9.isEmpty__Z() ? this.word$1 : this$9.get__O()))
  }
});
$c_Lamf_core_utils_InflectorBase$Inflector.prototype.camelToScoreSing__T__T = (function(sign) {
  var upper = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var thiz = this.word$1;
  var bytes = $m_sjsr_RuntimeString$().getBytes__T__Ljava_nio_charset_Charset__AB(thiz, $m_Ljava_nio_charset_UTF$und8$());
  var i = 0;
  var len = bytes.u.length;
  while ((i < len)) {
    var idx = i;
    var arg1 = bytes.get(idx);
    var b = $uB(arg1);
    if (((b < 97) || (b > 122))) {
      var len$1 = bytes.u.length;
      var i$1 = 0;
      while (true) {
        if ((i$1 < len$1)) {
          var idx$1 = i$1;
          var arg1$1 = bytes.get(idx$1);
          var jsx$1 = (!$m_sr_BoxesRunTime$().equals__O__O__Z(b, arg1$1))
        } else {
          var jsx$1 = false
        };
        if (jsx$1) {
          i$1 = ((1 + i$1) | 0)
        } else {
          break
        }
      };
      var n = i$1;
      var x = ((n >= bytes.u.length) ? (-1) : n);
      upper.$$plus$eq__O__scm_ListBuffer(x)
    };
    i = ((1 + i) | 0)
  };
  var b$3 = new $c_jl_StringBuffer().init___T(this.word$1);
  var this$14 = upper.scala$collection$mutable$ListBuffer$$start$6;
  var these = this$14;
  while ((!these.isEmpty__Z())) {
    var arg1$2 = these.head__O();
    var index = $asInt(arg1$2);
    b$3.insert__I__T__jl_StringBuffer($uI(index), sign);
    these = $as_sci_List(these.tail__O())
  };
  var thiz$1 = b$3.toString__T();
  return $as_T(thiz$1.toLowerCase())
});
$c_Lamf_core_utils_InflectorBase$Inflector.prototype.findGSubInList__p1__sc_Seq__T__s_Option = (function(list, word) {
  var this$1 = list.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, word$1) {
    return (function(p$2) {
      var p = $as_Lamf_core_utils_InflectorBase$Container(p$2);
      return $this.gsub__p1__T__T__T__s_Option(word$1, p.rule$1, p.replacement$1).isDefined__Z()
    })
  })(this, word)));
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var p$3 = $as_Lamf_core_utils_InflectorBase$Container(arg1);
    return this.gsub__p1__T__T__T__s_Option(word, p$3.rule$1, p$3.replacement$1)
  }
});
$c_Lamf_core_utils_InflectorBase$Inflector.prototype.init___T = (function(word) {
  this.word$1 = word;
  return this
});
$c_Lamf_core_utils_InflectorBase$Inflector.prototype.decapitalize__T = (function() {
  var x = this.word$1;
  var this$2 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$2)) {
    var c = $m_sjsr_RuntimeString$().toCharArray__T__AC(this.word$1);
    var this$4 = new $c_scm_ArrayOps$ofChar().init___AC(c);
    var c$1 = $f_sc_IndexedSeqOptimized__head__O(this$4);
    if ((c$1 === null)) {
      var c$2 = 0
    } else {
      var this$6 = $as_jl_Character(c$1);
      var c$2 = this$6.value$1
    };
    var c$3 = $m_jl_Character$().toLowerCase__C__C(c$2);
    var jsx$2 = new $c_jl_Character().init___C(c$3);
    if ((c.u.length === 0)) {
      if ((c.u.length === 0)) {
        throw new $c_jl_UnsupportedOperationException().init___T("empty.tail")
      };
      var until = c.u.length;
      var x$1 = ((until > 0) ? until : 0);
      var y = c.u.length;
      var hi = ((x$1 < y) ? x$1 : y);
      var x$2 = (((-1) + hi) | 0);
      var size = ((x$2 > 0) ? x$2 : 0);
      var result = $m_jl_reflect_Array$().newInstance__jl_Class__I__O($objectGetClass(c).getComponentType__jl_Class(), size);
      if ((size > 0)) {
        $m_s_Array$().copy__O__I__O__I__I__V(c, 1, result, 0, size)
      };
      var jsx$1 = result
    } else {
      var until$1 = c.u.length;
      var x$3 = ((until$1 > 0) ? until$1 : 0);
      var y$1 = c.u.length;
      var hi$1 = ((x$3 < y$1) ? x$3 : y$1);
      var x$4 = (((-1) + hi$1) | 0);
      var size$1 = ((x$4 > 0) ? x$4 : 0);
      var result$1 = $m_jl_reflect_Array$().newInstance__jl_Class__I__O($objectGetClass(c).getComponentType__jl_Class(), size$1);
      if ((size$1 > 0)) {
        $m_s_Array$().copy__O__I__O__I__I__V(c, 1, result$1, 0, size$1)
      };
      var jsx$1 = result$1
    };
    var xs = $asArrayOf_C(jsx$1, 1);
    var b = new $c_scm_StringBuilder().init___();
    var elem$1 = false;
    elem$1 = true;
    b.append__T__scm_StringBuilder("");
    var i = 0;
    var len = xs.u.length;
    while ((i < len)) {
      var idx = i;
      var c$4 = xs.get(idx);
      var arg1 = new $c_jl_Character().init___C(c$4);
      if (elem$1) {
        b.append__O__scm_StringBuilder(arg1);
        elem$1 = false
      } else {
        b.append__T__scm_StringBuilder("");
        b.append__O__scm_StringBuilder(arg1)
      };
      i = ((1 + i) | 0)
    };
    b.append__T__scm_StringBuilder("");
    return (("" + jsx$2) + b.underlying$5.java$lang$StringBuilder$$content$f)
  } else {
    return this.word$1
  }
});
$c_Lamf_core_utils_InflectorBase$Inflector.prototype.singularize__T = (function() {
  var this$1 = $m_Lamf_core_utils_InflectorBase$().amf$core$utils$InflectorBase$$uncountables$1;
  var elem = this.word$1;
  if ($f_sc_LinearSeqOptimized__contains__O__Z(this$1, elem)) {
    return this.word$1
  } else {
    var this$2 = $m_Lamf_core_utils_InflectorBase$().amf$core$utils$InflectorBase$$irregulars$1;
    var this$3 = this$2.scala$collection$mutable$ListBuffer$$start$6;
    inlinereturn$6: {
      var these = this$3;
      while ((!these.isEmpty__Z())) {
        var arg1 = these.head__O();
        var i = $as_Lamf_core_utils_InflectorBase$Container(arg1);
        var thiz = i.replacement$1;
        var that = this.word$1;
        if (($as_T(thiz.toLowerCase()) === ((that === null) ? null : $as_T(that.toLowerCase())))) {
          var this$7 = new $c_s_Some().init___O(these.head__O());
          break inlinereturn$6
        };
        these = $as_sc_LinearSeqOptimized(these.tail__O())
      };
      var this$7 = $m_s_None$()
    };
    if (this$7.isEmpty__Z()) {
      var this$8 = $m_s_None$()
    } else {
      var arg1$1 = this$7.get__O();
      var x$2 = $as_Lamf_core_utils_InflectorBase$Container(arg1$1);
      var this$8 = new $c_s_Some().init___O(x$2.rule$1)
    };
    var this$9 = (this$8.isEmpty__Z() ? this.findGSubInList__p1__sc_Seq__T__s_Option($m_Lamf_core_utils_InflectorBase$().amf$core$utils$InflectorBase$$singulars$1, this.word$1) : this$8);
    return $as_T((this$9.isEmpty__Z() ? this.word$1 : this$9.get__O()))
  }
});
var $d_Lamf_core_utils_InflectorBase$Inflector = new $TypeData().initClass({
  Lamf_core_utils_InflectorBase$Inflector: 0
}, false, "amf.core.utils.InflectorBase$Inflector", {
  Lamf_core_utils_InflectorBase$Inflector: 1,
  O: 1
});
$c_Lamf_core_utils_InflectorBase$Inflector.prototype.$classData = $d_Lamf_core_utils_InflectorBase$Inflector;
/** @constructor */
function $c_Lamf_core_utils_Lazy() {
  $c_O.call(this);
  this.producer$1 = null;
  this.value$1 = null
}
$c_Lamf_core_utils_Lazy.prototype = new $h_O();
$c_Lamf_core_utils_Lazy.prototype.constructor = $c_Lamf_core_utils_Lazy;
/** @constructor */
function $h_Lamf_core_utils_Lazy() {
  /*<skip>*/
}
$h_Lamf_core_utils_Lazy.prototype = $c_Lamf_core_utils_Lazy.prototype;
$c_Lamf_core_utils_Lazy.prototype.init___F0 = (function(producer) {
  this.producer$1 = producer;
  this.value$1 = $m_s_None$();
  return this
});
$c_Lamf_core_utils_Lazy.prototype.getOrCreate__O = (function() {
  var this$1 = this.value$1;
  var ifEmpty = this.producer$1;
  if (this$1.isEmpty__Z()) {
    var jsx$1 = ifEmpty.apply__O()
  } else {
    var arg1 = this$1.get__O();
    var jsx$1 = arg1
  };
  this.value$1 = new $c_s_Some().init___O(jsx$1);
  return this.value$1.get__O()
});
var $d_Lamf_core_utils_Lazy = new $TypeData().initClass({
  Lamf_core_utils_Lazy: 0
}, false, "amf.core.utils.Lazy", {
  Lamf_core_utils_Lazy: 1,
  O: 1
});
$c_Lamf_core_utils_Lazy.prototype.$classData = $d_Lamf_core_utils_Lazy;
/** @constructor */
function $c_Lamf_core_utils_TSort$() {
  $c_O.call(this)
}
$c_Lamf_core_utils_TSort$.prototype = new $h_O();
$c_Lamf_core_utils_TSort$.prototype.constructor = $c_Lamf_core_utils_TSort$;
/** @constructor */
function $h_Lamf_core_utils_TSort$() {
  /*<skip>*/
}
$h_Lamf_core_utils_TSort$.prototype = $c_Lamf_core_utils_TSort$.prototype;
$c_Lamf_core_utils_TSort$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_utils_TSort$.prototype.tsort__sci_Map__sc_Iterable__s_util_Either = (function(preds, done) {
  _tsort: while (true) {
    var this$1 = preds;
    var p = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x0$1$2) {
        var x0$1 = $as_T2(x0$1$2);
        if ((x0$1 !== null)) {
          var ps = $as_sci_Set(x0$1.$$und2__O());
          return ps.isEmpty__Z()
        } else {
          throw new $c_s_MatchError().init___O(x0$1)
        }
      })
    })(this));
    var x1 = $f_sc_TraversableLike__partition__F1__T2(this$1, p);
    if ((x1 === null)) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var noPreds = $as_sci_Map(x1.$$und1__O());
    var hasPreds = $as_sci_Map(x1.$$und2__O());
    if (noPreds.isEmpty__Z()) {
      if (hasPreds.isEmpty__Z()) {
        $m_s_package$();
        var value = done;
        return new $c_s_util_Right().init___O(value)
      } else {
        $m_s_package$();
        var jsx$2 = done;
        var jsx$1 = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(hasPreds);
        var this$3 = $m_sc_Iterable$();
        var value$1 = jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2);
        return new $c_s_util_Left().init___O(value$1)
      }
    } else {
      var found = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(noPreds);
      var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, found$1) {
        return (function(x$2$2) {
          var x$2 = $as_sci_Set(x$2$2);
          return $as_sci_Set($f_scg_Subtractable__$$minus$minus__sc_GenTraversableOnce__scg_Subtractable(x$2, found$1))
        })
      })(this, found));
      var temp$preds = new $c_sci_MapLike$$anon$2().init___sci_MapLike__F1(hasPreds, f);
      var jsx$3 = done;
      var this$5 = $m_sc_Iterable$();
      var temp$done = $as_sc_Iterable(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(found, this$5.ReusableCBFInstance$2));
      preds = temp$preds;
      done = temp$done;
      continue _tsort
    }
  }
});
var $d_Lamf_core_utils_TSort$ = new $TypeData().initClass({
  Lamf_core_utils_TSort$: 0
}, false, "amf.core.utils.TSort$", {
  Lamf_core_utils_TSort$: 1,
  O: 1
});
$c_Lamf_core_utils_TSort$.prototype.$classData = $d_Lamf_core_utils_TSort$;
var $n_Lamf_core_utils_TSort$ = (void 0);
function $m_Lamf_core_utils_TSort$() {
  if ((!$n_Lamf_core_utils_TSort$)) {
    $n_Lamf_core_utils_TSort$ = new $c_Lamf_core_utils_TSort$().init___()
  };
  return $n_Lamf_core_utils_TSort$
}
/** @constructor */
function $c_Lamf_core_utils_package$IdCounter() {
  $c_O.call(this);
  this.c$1 = 0
}
$c_Lamf_core_utils_package$IdCounter.prototype = new $h_O();
$c_Lamf_core_utils_package$IdCounter.prototype.constructor = $c_Lamf_core_utils_package$IdCounter;
/** @constructor */
function $h_Lamf_core_utils_package$IdCounter() {
  /*<skip>*/
}
$h_Lamf_core_utils_package$IdCounter.prototype = $c_Lamf_core_utils_package$IdCounter.prototype;
$c_Lamf_core_utils_package$IdCounter.prototype.init___ = (function() {
  this.c$1 = 0;
  return this
});
$c_Lamf_core_utils_package$IdCounter.prototype.genId__T__T = (function(id) {
  this.c$1 = ((1 + this.c$1) | 0);
  return ((id + "_") + this.c$1)
});
var $d_Lamf_core_utils_package$IdCounter = new $TypeData().initClass({
  Lamf_core_utils_package$IdCounter: 0
}, false, "amf.core.utils.package$IdCounter", {
  Lamf_core_utils_package$IdCounter: 1,
  O: 1
});
$c_Lamf_core_utils_package$IdCounter.prototype.$classData = $d_Lamf_core_utils_package$IdCounter;
/** @constructor */
function $c_Lamf_core_utils_package$MediaTypeMatcher$() {
  $c_O.call(this)
}
$c_Lamf_core_utils_package$MediaTypeMatcher$.prototype = new $h_O();
$c_Lamf_core_utils_package$MediaTypeMatcher$.prototype.constructor = $c_Lamf_core_utils_package$MediaTypeMatcher$;
/** @constructor */
function $h_Lamf_core_utils_package$MediaTypeMatcher$() {
  /*<skip>*/
}
$h_Lamf_core_utils_package$MediaTypeMatcher$.prototype = $c_Lamf_core_utils_package$MediaTypeMatcher$.prototype;
$c_Lamf_core_utils_package$MediaTypeMatcher$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_utils_package$MediaTypeMatcher$.prototype.isXml$extension__T__Z = (function($$this) {
  var thiz = $as_T($$this.trim());
  return (($uI(thiz.length) >= 0) && ($as_T(thiz.substring(0, $uI("<".length))) === "<"))
});
$c_Lamf_core_utils_package$MediaTypeMatcher$.prototype.guessMediaType$extension__T__Z__T = (function($$this, isScalar) {
  return (($m_Lamf_core_utils_package$MediaTypeMatcher$().isXml$extension__T__Z($$this) && (!isScalar)) ? "application/xml" : (($m_Lamf_core_utils_package$MediaTypeMatcher$().isJson$extension__T__Z($$this) && (!isScalar)) ? "application/json" : "text/vnd.yaml"))
});
$c_Lamf_core_utils_package$MediaTypeMatcher$.prototype.isJson$extension__T__Z = (function($$this) {
  var thiz = $as_T($$this.trim());
  if ((($uI(thiz.length) >= 0) && ($as_T(thiz.substring(0, $uI("{".length))) === "{"))) {
    return true
  } else {
    return (($uI($$this.length) >= 0) && ($as_T($$this.substring(0, $uI("[".length))) === "["))
  }
});
var $d_Lamf_core_utils_package$MediaTypeMatcher$ = new $TypeData().initClass({
  Lamf_core_utils_package$MediaTypeMatcher$: 0
}, false, "amf.core.utils.package$MediaTypeMatcher$", {
  Lamf_core_utils_package$MediaTypeMatcher$: 1,
  O: 1
});
$c_Lamf_core_utils_package$MediaTypeMatcher$.prototype.$classData = $d_Lamf_core_utils_package$MediaTypeMatcher$;
var $n_Lamf_core_utils_package$MediaTypeMatcher$ = (void 0);
function $m_Lamf_core_utils_package$MediaTypeMatcher$() {
  if ((!$n_Lamf_core_utils_package$MediaTypeMatcher$)) {
    $n_Lamf_core_utils_package$MediaTypeMatcher$ = new $c_Lamf_core_utils_package$MediaTypeMatcher$().init___()
  };
  return $n_Lamf_core_utils_package$MediaTypeMatcher$
}
/** @constructor */
function $c_Lamf_core_utils_package$RegexConverter() {
  $c_O.call(this);
  this.str$1 = null
}
$c_Lamf_core_utils_package$RegexConverter.prototype = new $h_O();
$c_Lamf_core_utils_package$RegexConverter.prototype.constructor = $c_Lamf_core_utils_package$RegexConverter;
/** @constructor */
function $h_Lamf_core_utils_package$RegexConverter() {
  /*<skip>*/
}
$h_Lamf_core_utils_package$RegexConverter.prototype = $c_Lamf_core_utils_package$RegexConverter.prototype;
$c_Lamf_core_utils_package$RegexConverter.prototype.init___T = (function(str) {
  this.str$1 = str;
  return this
});
var $d_Lamf_core_utils_package$RegexConverter = new $TypeData().initClass({
  Lamf_core_utils_package$RegexConverter: 0
}, false, "amf.core.utils.package$RegexConverter", {
  Lamf_core_utils_package$RegexConverter: 1,
  O: 1
});
$c_Lamf_core_utils_package$RegexConverter.prototype.$classData = $d_Lamf_core_utils_package$RegexConverter;
/** @constructor */
function $c_Lamf_core_utils_package$SimpleCounter() {
  $c_O.call(this);
  this.current$1 = 0
}
$c_Lamf_core_utils_package$SimpleCounter.prototype = new $h_O();
$c_Lamf_core_utils_package$SimpleCounter.prototype.constructor = $c_Lamf_core_utils_package$SimpleCounter;
/** @constructor */
function $h_Lamf_core_utils_package$SimpleCounter() {
  /*<skip>*/
}
$h_Lamf_core_utils_package$SimpleCounter.prototype = $c_Lamf_core_utils_package$SimpleCounter.prototype;
$c_Lamf_core_utils_package$SimpleCounter.prototype.init___ = (function() {
  this.current$1 = (-1);
  return this
});
$c_Lamf_core_utils_package$SimpleCounter.prototype.next__I = (function() {
  this.current$1 = ((1 + this.current$1) | 0);
  return this.current$1
});
var $d_Lamf_core_utils_package$SimpleCounter = new $TypeData().initClass({
  Lamf_core_utils_package$SimpleCounter: 0
}, false, "amf.core.utils.package$SimpleCounter", {
  Lamf_core_utils_package$SimpleCounter: 1,
  O: 1
});
$c_Lamf_core_utils_package$SimpleCounter.prototype.$classData = $d_Lamf_core_utils_package$SimpleCounter;
/** @constructor */
function $c_Lamf_core_utils_package$TemplateUri$() {
  $c_O.call(this);
  this.varPattern$1 = null
}
$c_Lamf_core_utils_package$TemplateUri$.prototype = new $h_O();
$c_Lamf_core_utils_package$TemplateUri$.prototype.constructor = $c_Lamf_core_utils_package$TemplateUri$;
/** @constructor */
function $h_Lamf_core_utils_package$TemplateUri$() {
  /*<skip>*/
}
$h_Lamf_core_utils_package$TemplateUri$.prototype = $c_Lamf_core_utils_package$TemplateUri$.prototype;
$c_Lamf_core_utils_package$TemplateUri$.prototype.init___ = (function() {
  $n_Lamf_core_utils_package$TemplateUri$ = this;
  var this$2 = new $c_sci_StringOps().init___T("\\{(.[^{]*)\\}");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.varPattern$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  return this
});
$c_Lamf_core_utils_package$TemplateUri$.prototype.invalidMsg__T__T = (function(uri) {
  return (("'" + uri) + "' is not a valid template uri.")
});
$c_Lamf_core_utils_package$TemplateUri$.prototype.isValid__T__Z = (function(chars) {
  var this$2 = new $c_sci_StringOps().init___T(chars);
  return this.isBalanced$1__p1__sci_List__I__Z($f_sc_IndexedSeqOptimized__toList__sci_List(this$2), 0)
});
$c_Lamf_core_utils_package$TemplateUri$.prototype.isBalanced$1__p1__sci_List__I__Z = (function(cs, level) {
  _isBalanced: while (true) {
    var rc16 = false;
    var x2 = null;
    var x1 = cs;
    var x$2 = $m_sci_Nil$();
    if (x$2.equals__O__Z(x1)) {
      return (level === 0)
    };
    if ((x1 instanceof $c_sci_$colon$colon)) {
      rc16 = true;
      x2 = $as_sci_$colon$colon(x1);
      var c = x2.head$5;
      if ((c === null)) {
        var p3 = 0
      } else {
        var this$2 = $as_jl_Character(c);
        var p3 = this$2.value$1
      };
      if (((p3 === 125) && (level < 1))) {
        return false
      }
    };
    if (rc16) {
      var c$1 = x2.head$5;
      if ((c$1 === null)) {
        var p6 = 0
      } else {
        var this$4 = $as_jl_Character(c$1);
        var p6 = this$4.value$1
      };
      var xs = x2.tl$5;
      if ((p6 === 125)) {
        var temp$level = (((-1) + level) | 0);
        cs = xs;
        level = temp$level;
        continue _isBalanced
      }
    };
    if (rc16) {
      var c$2 = x2.head$5;
      if ((c$2 === null)) {
        var p8 = 0
      } else {
        var this$6 = $as_jl_Character(c$2);
        var p8 = this$6.value$1
      };
      var xs$2 = x2.tl$5;
      if ((p8 === 123)) {
        var temp$level$2 = ((1 + level) | 0);
        cs = xs$2;
        level = temp$level$2;
        continue _isBalanced
      }
    };
    if (rc16) {
      var xs$3 = x2.tl$5;
      cs = xs$3;
      continue _isBalanced
    };
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_core_utils_package$TemplateUri$.prototype.variables__T__sc_Seq = (function(path) {
  var this$1 = this.varPattern$1.findAllIn__jl_CharSequence__s_util_matching_Regex$MatchIterator(path);
  var jsx$2 = $f_sc_Iterator__toStream__sci_Stream(this$1);
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(v$2) {
      var v = $as_T(v$2);
      var thiz = $as_T(v.split("{").join(""));
      return $as_T(thiz.split("}").join(""))
    })
  })(this));
  var this$6 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2))
});
var $d_Lamf_core_utils_package$TemplateUri$ = new $TypeData().initClass({
  Lamf_core_utils_package$TemplateUri$: 0
}, false, "amf.core.utils.package$TemplateUri$", {
  Lamf_core_utils_package$TemplateUri$: 1,
  O: 1
});
$c_Lamf_core_utils_package$TemplateUri$.prototype.$classData = $d_Lamf_core_utils_package$TemplateUri$;
var $n_Lamf_core_utils_package$TemplateUri$ = (void 0);
function $m_Lamf_core_utils_package$TemplateUri$() {
  if ((!$n_Lamf_core_utils_package$TemplateUri$)) {
    $n_Lamf_core_utils_package$TemplateUri$ = new $c_Lamf_core_utils_package$TemplateUri$().init___()
  };
  return $n_Lamf_core_utils_package$TemplateUri$
}
function $is_Lamf_core_validation_AMFPayloadValidationPlugin(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_validation_AMFPayloadValidationPlugin)))
}
function $as_Lamf_core_validation_AMFPayloadValidationPlugin(obj) {
  return (($is_Lamf_core_validation_AMFPayloadValidationPlugin(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.AMFPayloadValidationPlugin"))
}
function $isArrayOf_Lamf_core_validation_AMFPayloadValidationPlugin(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_AMFPayloadValidationPlugin)))
}
function $asArrayOf_Lamf_core_validation_AMFPayloadValidationPlugin(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_AMFPayloadValidationPlugin(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.AMFPayloadValidationPlugin;", depth))
}
/** @constructor */
function $c_Lamf_core_validation_EffectiveValidations() {
  $c_O.call(this);
  this.effective$1 = null;
  this.info$1 = null;
  this.warning$1 = null;
  this.violation$1 = null;
  this.all$1 = null
}
$c_Lamf_core_validation_EffectiveValidations.prototype = new $h_O();
$c_Lamf_core_validation_EffectiveValidations.prototype.constructor = $c_Lamf_core_validation_EffectiveValidations;
/** @constructor */
function $h_Lamf_core_validation_EffectiveValidations() {
  /*<skip>*/
}
$h_Lamf_core_validation_EffectiveValidations.prototype = $c_Lamf_core_validation_EffectiveValidations.prototype;
$c_Lamf_core_validation_EffectiveValidations.prototype.update__Lamf_core_validation_core_ValidationSpecification__O = (function(other) {
  var x1 = this.all$1.get__O__s_Option(other.name$1);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var added = $as_Lamf_core_validation_core_ValidationSpecification(x2.value$2);
    var this$1 = this.all$1;
    var key = other.name$1;
    var value = other.withTargets__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_ValidationSpecification(added);
    this$1.put__O__O__s_Option(key, value);
    return (void 0)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$4 = this.all$1;
      var self = other.name$1;
      var e = $as_scm_DefaultEntry($f_scm_HashTable__findOrAddEntry__O__O__scm_HashEntry(this$4, self, other));
      if ((e !== null)) {
        e.value$1 = other
      };
      return this$4
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_core_validation_EffectiveValidations.prototype.init___scm_HashMap__scm_HashMap__scm_HashMap__scm_HashMap__scm_HashMap = (function(effective, info, warning, violation, all) {
  this.effective$1 = effective;
  this.info$1 = info;
  this.warning$1 = warning;
  this.violation$1 = violation;
  this.all$1 = all;
  return this
});
$c_Lamf_core_validation_EffectiveValidations.prototype.someEffective__Lamf_core_validation_core_ValidationProfile__Lamf_core_validation_EffectiveValidations = (function(profile) {
  profile.validations$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(other$2) {
      var other = $as_Lamf_core_validation_core_ValidationSpecification(other$2);
      return $this.update__Lamf_core_validation_core_ValidationSpecification__O(other)
    })
  })(this)));
  profile.infoLevel$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, profile$1) {
    return (function(id$2) {
      var id = $as_T(id$2);
      var validation = this$2.setLevel__p1__T__T__Lamf_core_validation_core_ValidationSpecification(id, $m_Lamf_core_validation_SeverityLevels$().INFO$1);
      this$2.setNested__Lamf_core_validation_core_ValidationProfile__Lamf_core_validation_core_ValidationSpecification__V(profile$1, validation)
    })
  })(this, profile)));
  profile.warningLevel$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3, profile$2) {
    return (function(id$3$2) {
      var id$3 = $as_T(id$3$2);
      var validation$1 = this$3.setLevel__p1__T__T__Lamf_core_validation_core_ValidationSpecification(id$3, $m_Lamf_core_validation_SeverityLevels$().WARNING$1);
      this$3.setNested__Lamf_core_validation_core_ValidationProfile__Lamf_core_validation_core_ValidationSpecification__V(profile$2, validation$1)
    })
  })(this, profile)));
  profile.violationLevel$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4, profile$3) {
    return (function(id$4$2) {
      var id$4 = $as_T(id$4$2);
      var validation$2 = this$4.setLevel__p1__T__T__Lamf_core_validation_core_ValidationSpecification(id$4, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1);
      this$4.setNested__Lamf_core_validation_core_ValidationProfile__Lamf_core_validation_core_ValidationSpecification__V(profile$3, validation$2)
    })
  })(this, profile)));
  profile.disabled$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5) {
    return (function(id$5$2) {
      var id$5 = $as_T(id$5$2);
      var validationName = ((((!(($uI(id$5.length) >= 0) && ($as_T(id$5.substring(0, $uI("http://".length))) === "http://"))) && (!(($uI(id$5.length) >= 0) && ($as_T(id$5.substring(0, $uI("https://".length))) === "https://")))) && (!(($uI(id$5.length) >= 0) && ($as_T(id$5.substring(0, $uI("file:/".length))) === "file:/")))) ? $m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType($as_T(id$5.split(".").join(":"))).iri__T() : id$5);
      return this$5.effective$1.remove__O__s_Option(validationName)
    })
  })(this)));
  return this
});
$c_Lamf_core_validation_EffectiveValidations.prototype.setNested__Lamf_core_validation_core_ValidationProfile__Lamf_core_validation_core_ValidationSpecification__V = (function(profile, validation) {
  $as_sc_IterableLike(profile.validations$1.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, validation$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_validation_core_ValidationSpecification(x$1$2);
      return x$1.nested$1.contains__O__Z(validation$1.name$1)
    })
  })(this, validation)))).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(nestedValidation$2) {
      var nestedValidation = $as_Lamf_core_validation_core_ValidationSpecification(nestedValidation$2);
      return this$2.effective$1.put__O__O__s_Option(nestedValidation.id$1, nestedValidation)
    })
  })(this)))
});
$c_Lamf_core_validation_EffectiveValidations.prototype.setLevel__p1__T__T__Lamf_core_validation_core_ValidationSpecification = (function(id, targetLevel) {
  var validationName = ((((!(($uI(id.length) >= 0) && ($as_T(id.substring(0, $uI("http://".length))) === "http://"))) && (!(($uI(id.length) >= 0) && ($as_T(id.substring(0, $uI("https://".length))) === "https://")))) && (!(($uI(id.length) >= 0) && ($as_T(id.substring(0, $uI("file:/".length))) === "file:/")))) ? $m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType($as_T(id.split(".").join(":"))).iri__T() : id);
  var x1 = this.all$1.get__O__s_Option(validationName);
  var x = $m_s_None$();
  if ((x === x1)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(((("Cannot enable with " + targetLevel) + " level unknown validation ") + validationName)))
  } else if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var validation = $as_Lamf_core_validation_core_ValidationSpecification(x2.value$2);
    this.info$1.remove__O__s_Option(validationName);
    this.warning$1.remove__O__s_Option(validationName);
    this.violation$1.remove__O__s_Option(validationName);
    if (($m_Lamf_core_validation_SeverityLevels$().INFO$1 === targetLevel)) {
      var this$20 = this.info$1;
      var e = $as_scm_DefaultEntry($f_scm_HashTable__findOrAddEntry__O__O__scm_HashEntry(this$20, validationName, validation));
      if ((e !== null)) {
        e.value$1 = validation
      }
    } else if (($m_Lamf_core_validation_SeverityLevels$().WARNING$1 === targetLevel)) {
      var this$23 = this.warning$1;
      var e$1 = $as_scm_DefaultEntry($f_scm_HashTable__findOrAddEntry__O__O__scm_HashEntry(this$23, validationName, validation));
      if ((e$1 !== null)) {
        e$1.value$1 = validation
      }
    } else if (($m_Lamf_core_validation_SeverityLevels$().VIOLATION$1 === targetLevel)) {
      var this$26 = this.violation$1;
      var e$2 = $as_scm_DefaultEntry($f_scm_HashTable__findOrAddEntry__O__O__scm_HashEntry(this$26, validationName, validation));
      if ((e$2 !== null)) {
        e$2.value$1 = validation
      }
    } else {
      throw new $c_s_MatchError().init___O(targetLevel)
    };
    var this$29 = this.effective$1;
    var e$3 = $as_scm_DefaultEntry($f_scm_HashTable__findOrAddEntry__O__O__scm_HashEntry(this$29, validationName, validation));
    if ((e$3 !== null)) {
      e$3.value$1 = validation
    };
    return validation
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
function $as_Lamf_core_validation_EffectiveValidations(obj) {
  return (((obj instanceof $c_Lamf_core_validation_EffectiveValidations) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.EffectiveValidations"))
}
function $isArrayOf_Lamf_core_validation_EffectiveValidations(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_EffectiveValidations)))
}
function $asArrayOf_Lamf_core_validation_EffectiveValidations(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_EffectiveValidations(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.EffectiveValidations;", depth))
}
var $d_Lamf_core_validation_EffectiveValidations = new $TypeData().initClass({
  Lamf_core_validation_EffectiveValidations: 0
}, false, "amf.core.validation.EffectiveValidations", {
  Lamf_core_validation_EffectiveValidations: 1,
  O: 1
});
$c_Lamf_core_validation_EffectiveValidations.prototype.$classData = $d_Lamf_core_validation_EffectiveValidations;
/** @constructor */
function $c_Lamf_core_validation_SeverityLevels$() {
  $c_O.call(this);
  this.WARNING$1 = null;
  this.INFO$1 = null;
  this.VIOLATION$1 = null
}
$c_Lamf_core_validation_SeverityLevels$.prototype = new $h_O();
$c_Lamf_core_validation_SeverityLevels$.prototype.constructor = $c_Lamf_core_validation_SeverityLevels$;
/** @constructor */
function $h_Lamf_core_validation_SeverityLevels$() {
  /*<skip>*/
}
$h_Lamf_core_validation_SeverityLevels$.prototype = $c_Lamf_core_validation_SeverityLevels$.prototype;
$c_Lamf_core_validation_SeverityLevels$.prototype.init___ = (function() {
  this.WARNING$1 = "Warning";
  this.INFO$1 = "Info";
  this.VIOLATION$1 = "Violation";
  return this
});
$c_Lamf_core_validation_SeverityLevels$.prototype.$$js$exported$prop$VIOLATION__O = (function() {
  return this.VIOLATION$1
});
$c_Lamf_core_validation_SeverityLevels$.prototype.$$js$exported$prop$INFO__O = (function() {
  return this.INFO$1
});
$c_Lamf_core_validation_SeverityLevels$.prototype.$$js$exported$meth$unapply__T__O = (function(arg) {
  return this.unapply__T__T(arg)
});
$c_Lamf_core_validation_SeverityLevels$.prototype.$$js$exported$prop$WARNING__O = (function() {
  return this.WARNING$1
});
$c_Lamf_core_validation_SeverityLevels$.prototype.unapply__T__T = (function(arg) {
  return ((this.WARNING$1 === arg) ? this.WARNING$1 : ((this.INFO$1 === arg) ? this.INFO$1 : this.VIOLATION$1))
});
$c_Lamf_core_validation_SeverityLevels$.prototype.unapply = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$unapply__T__O(prep)
});
Object.defineProperty($c_Lamf_core_validation_SeverityLevels$.prototype, "VIOLATION", {
  "get": (function() {
    return this.$$js$exported$prop$VIOLATION__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_core_validation_SeverityLevels$.prototype, "INFO", {
  "get": (function() {
    return this.$$js$exported$prop$INFO__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_core_validation_SeverityLevels$.prototype, "WARNING", {
  "get": (function() {
    return this.$$js$exported$prop$WARNING__O()
  }),
  "configurable": true
});
var $d_Lamf_core_validation_SeverityLevels$ = new $TypeData().initClass({
  Lamf_core_validation_SeverityLevels$: 0
}, false, "amf.core.validation.SeverityLevels$", {
  Lamf_core_validation_SeverityLevels$: 1,
  O: 1
});
$c_Lamf_core_validation_SeverityLevels$.prototype.$classData = $d_Lamf_core_validation_SeverityLevels$;
var $n_Lamf_core_validation_SeverityLevels$ = (void 0);
function $m_Lamf_core_validation_SeverityLevels$() {
  if ((!$n_Lamf_core_validation_SeverityLevels$)) {
    $n_Lamf_core_validation_SeverityLevels$ = new $c_Lamf_core_validation_SeverityLevels$().init___()
  };
  return $n_Lamf_core_validation_SeverityLevels$
}
/** @constructor */
function $c_Lamf_core_validation_core_ValidationReport$() {
  $c_O.call(this)
}
$c_Lamf_core_validation_core_ValidationReport$.prototype = new $h_O();
$c_Lamf_core_validation_core_ValidationReport$.prototype.constructor = $c_Lamf_core_validation_core_ValidationReport$;
/** @constructor */
function $h_Lamf_core_validation_core_ValidationReport$() {
  /*<skip>*/
}
$h_Lamf_core_validation_core_ValidationReport$.prototype = $c_Lamf_core_validation_core_ValidationReport$.prototype;
$c_Lamf_core_validation_core_ValidationReport$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_validation_core_ValidationReport$.prototype.displayString__Lamf_core_validation_core_ValidationReport__T = (function(report) {
  var elem = (("Conforms? " + report.conforms__Z()) + "\n");
  var elem$1 = null;
  elem$1 = elem;
  var jsx$1 = $as_T(elem$1);
  var this$2 = report.results__sci_List();
  elem$1 = ((jsx$1 + ("Number of results: " + $f_sc_LinearSeqOptimized__length__I(this$2))) + "\n");
  var this$3 = report.results__sci_List();
  var these = this$3;
  while ((!these.isEmpty__Z())) {
    var arg1 = these.head__O();
    var result = $as_Lamf_core_validation_core_ValidationResult(arg1);
    elem$1 = (($as_T(elem$1) + ("\n- Source: " + result.sourceShape__T())) + "\n");
    elem$1 = (($as_T(elem$1) + ("  Path: " + result.path__T())) + "\n");
    elem$1 = (($as_T(elem$1) + ("  Focus node: " + result.focusNode__T())) + "\n");
    elem$1 = (($as_T(elem$1) + ("  Constraint: " + result.sourceConstraintComponent__T())) + "\n");
    elem$1 = (($as_T(elem$1) + ("  Message: " + result.message__s_Option())) + "\n");
    elem$1 = (($as_T(elem$1) + ("  Severity: " + result.severity__T())) + "\n");
    these = $as_sci_List(these.tail__O())
  };
  return $as_T(elem$1)
});
var $d_Lamf_core_validation_core_ValidationReport$ = new $TypeData().initClass({
  Lamf_core_validation_core_ValidationReport$: 0
}, false, "amf.core.validation.core.ValidationReport$", {
  Lamf_core_validation_core_ValidationReport$: 1,
  O: 1
});
$c_Lamf_core_validation_core_ValidationReport$.prototype.$classData = $d_Lamf_core_validation_core_ValidationReport$;
var $n_Lamf_core_validation_core_ValidationReport$ = (void 0);
function $m_Lamf_core_validation_core_ValidationReport$() {
  if ((!$n_Lamf_core_validation_core_ValidationReport$)) {
    $n_Lamf_core_validation_core_ValidationReport$ = new $c_Lamf_core_validation_core_ValidationReport$().init___()
  };
  return $n_Lamf_core_validation_core_ValidationReport$
}
/** @constructor */
function $c_Lamf_core_validation_model_PropertyPath() {
  $c_O.call(this)
}
$c_Lamf_core_validation_model_PropertyPath.prototype = new $h_O();
$c_Lamf_core_validation_model_PropertyPath.prototype.constructor = $c_Lamf_core_validation_model_PropertyPath;
/** @constructor */
function $h_Lamf_core_validation_model_PropertyPath() {
  /*<skip>*/
}
$h_Lamf_core_validation_model_PropertyPath.prototype = $c_Lamf_core_validation_model_PropertyPath.prototype;
function $as_Lamf_core_validation_model_PropertyPath(obj) {
  return (((obj instanceof $c_Lamf_core_validation_model_PropertyPath) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.model.PropertyPath"))
}
function $isArrayOf_Lamf_core_validation_model_PropertyPath(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_model_PropertyPath)))
}
function $asArrayOf_Lamf_core_validation_model_PropertyPath(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_model_PropertyPath(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.model.PropertyPath;", depth))
}
/** @constructor */
function $c_Lamf_core_validation_model_PropertyPathParser$() {
  $c_O.call(this)
}
$c_Lamf_core_validation_model_PropertyPathParser$.prototype = new $h_O();
$c_Lamf_core_validation_model_PropertyPathParser$.prototype.constructor = $c_Lamf_core_validation_model_PropertyPathParser$;
/** @constructor */
function $h_Lamf_core_validation_model_PropertyPathParser$() {
  /*<skip>*/
}
$h_Lamf_core_validation_model_PropertyPathParser$.prototype = $c_Lamf_core_validation_model_PropertyPathParser$.prototype;
$c_Lamf_core_validation_model_PropertyPathParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_validation_model_PropertyPathParser$.prototype.flat__sci_List__sci_List = (function(es) {
  var f = (function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_validation_model_PropertyPath(x0$1$2);
      if ((x0$1 instanceof $c_Lamf_core_validation_model_SequencePath)) {
        var x2 = $as_Lamf_core_validation_model_SequencePath(x0$1);
        var this$1 = x2.elements$2;
        if (($f_sc_LinearSeqOptimized__length__I(this$1) === 1)) {
          return $as_Lamf_core_validation_model_PropertyPath(x2.elements$2.head__O())
        }
      };
      if ((x0$1 instanceof $c_Lamf_core_validation_model_AlternatePath)) {
        var x3 = $as_Lamf_core_validation_model_AlternatePath(x0$1);
        var this$2 = x3.elements$2;
        if (($f_sc_LinearSeqOptimized__length__I(this$2) === 1)) {
          return $as_Lamf_core_validation_model_PropertyPath(x3.elements$2.head__O())
        }
      };
      return x0$1
    })
  })(this);
  var this$3 = $m_sci_List$();
  var bf = this$3.ReusableCBFInstance$2;
  if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
    if ((es === $m_sci_Nil$())) {
      var jsx$1 = $m_sci_Nil$()
    } else {
      var arg1 = es.head__O();
      var h = new $c_sci_$colon$colon().init___O__sci_List(f(arg1), $m_sci_Nil$());
      var t = h;
      var rest = $as_sci_List(es.tail__O());
      while ((rest !== $m_sci_Nil$())) {
        var arg1$1 = rest.head__O();
        var nx = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$1), $m_sci_Nil$());
        t.tl$5 = nx;
        t = nx;
        rest = $as_sci_List(rest.tail__O())
      };
      var jsx$1 = h
    }
  } else {
    var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(es, bf);
    var these = es;
    while ((!these.isEmpty__Z())) {
      var arg1$2 = these.head__O();
      b.$$plus$eq__O__scm_Builder(f(arg1$2));
      these = $as_sci_List(these.tail__O())
    };
    var jsx$1 = b.result__O()
  };
  var m = $as_sci_List(jsx$1);
  return m.reverse__sci_List()
});
$c_Lamf_core_validation_model_PropertyPathParser$.prototype.expand__sci_List__F1__sci_List = (function(p, expander) {
  var x = $m_sci_Nil$();
  if (x.equals__O__Z(p)) {
    return $m_sci_Nil$()
  } else if ((p instanceof $c_sci_$colon$colon)) {
    var x2 = $as_sci_$colon$colon(p);
    var e = $as_Lamf_core_validation_model_PredicatePath(x2.head$5);
    var rest = x2.tl$5;
    var property = $as_T(expander.apply__O__O(e.property$2));
    var inverse = e.inverse$2;
    var zeroOrMore = e.zeroOrMore$2;
    var x$25 = new $c_Lamf_core_validation_model_PredicatePath().init___T__Z__Z(property, inverse, zeroOrMore);
    return new $c_sci_$colon$colon().init___O__sci_List(x$25, rest)
  } else {
    throw new $c_s_MatchError().init___O(p)
  }
});
$c_Lamf_core_validation_model_PropertyPathParser$.prototype.reduce__sci_List__Lamf_core_validation_model_PropertyPath = (function(stack) {
  if ((stack instanceof $c_sci_$colon$colon)) {
    var x2 = $as_sci_$colon$colon(stack);
    var et = $as_Lamf_core_validation_model_PropertyPath(x2.head$5);
    var p3 = x2.tl$5;
    if ((et !== null)) {
      var x = $m_sci_Nil$();
      if (x.equals__O__Z(p3)) {
        return et
      }
    }
  };
  if ((stack !== null)) {
    return new $c_Lamf_core_validation_model_AlternatePath().init___sci_List(this.flat__sci_List__sci_List(stack))
  };
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Unknown reduction state processing property path " + stack)))
});
$c_Lamf_core_validation_model_PropertyPathParser$.prototype.apply__T__F1__Lamf_core_validation_model_PropertyPath = (function(path, expander) {
  return ((((($uI(path.length) >= 0) && ($as_T(path.substring(0, $uI("file://".length))) === "file://")) || (($uI(path.length) >= 0) && ($as_T(path.substring(0, $uI("http://".length))) === "http://"))) || (($uI(path.length) >= 0) && ($as_T(path.substring(0, $uI("https://".length))) === "https://"))) ? new $c_Lamf_core_validation_model_PredicatePath().init___T__Z__Z($as_T(expander.apply__O__O(path)), false, false) : ((((((($uI(path.indexOf("/")) !== (-1)) || ($uI(path.indexOf("|")) !== (-1))) || ($uI(path.indexOf("^")) !== (-1))) || ($uI(path.indexOf("*")) !== (-1))) || ($uI(path.indexOf("(")) !== (-1))) || ($uI(path.indexOf(")")) !== (-1))) ? this.parse__T__F1__Lamf_core_validation_model_PropertyPath(path, expander) : new $c_Lamf_core_validation_model_PredicatePath().init___T__Z__Z($as_T(expander.apply__O__O(path)), false, false)))
});
$c_Lamf_core_validation_model_PropertyPathParser$.prototype.parse__T__F1__Lamf_core_validation_model_PropertyPath = (function(source, expander) {
  var path = $as_T(source.split(" ").join(""));
  var elem = new $c_Lamf_core_validation_model_PredicatePath().init___T__Z__Z("", false, false);
  var current = new $c_sr_ObjectRef().init___O(elem);
  var empty = new $c_sr_BooleanRef().init___Z(true);
  var elem$1 = $m_sci_Nil$();
  var stack = new $c_sr_ObjectRef().init___O(elem$1);
  var this$8 = new $c_sci_StringOps().init___T(path);
  var this$7 = $m_s_Predef$();
  var bf = new $c_s_LowPriorityImplicits$$anon$4().init___s_LowPriorityImplicits(this$7);
  $as_sc_TraversableLike($f_sc_IndexedSeqOptimized__zipWithIndex__scg_CanBuildFrom__O(this$8, bf)).withFilter__F1__scg_FilterMonadic(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(check$ifrefutable$1$2) {
      var check$ifrefutable$1 = $as_T2(check$ifrefutable$1$2);
      return (check$ifrefutable$1 !== null)
    })
  })(this))).map__F1__scg_CanBuildFrom__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, current$1, empty$1, stack$1, expander$1, path$1) {
    return (function(x$20$2) {
      var x$20 = $as_T2(x$20$2);
      if ((x$20 !== null)) {
        var c = x$20.$$und1__O();
        if ((c === null)) {
          var c$1 = 0
        } else {
          var this$10 = $as_jl_Character(c);
          var c$1 = this$10.value$1
        };
        var i = x$20.$$und2$mcI$sp__I();
        if (($as_Lamf_core_validation_model_PredicatePath(current$1.elem$1).property$2 === "")) {
          empty$1.elem$1 = true
        } else {
          empty$1.elem$1 = false
        };
        if (empty$1.elem$1) {
          var currentList = $m_sci_Nil$()
        } else {
          $m_sci_List$();
          var array = [$as_Lamf_core_validation_model_PredicatePath(current$1.elem$1)];
          var i$1 = (((-1) + $uI(array.length)) | 0);
          var result = $m_sci_Nil$();
          while ((i$1 >= 0)) {
            var this$14 = result;
            var index = i$1;
            var x = array[index];
            result = new $c_sci_$colon$colon().init___O__sci_List(x, this$14);
            i$1 = (((-1) + i$1) | 0)
          };
          var currentList = result
        };
        switch (c$1) {
          case 47: {
            var rc6 = false;
            var x2 = null;
            var x1$3 = $as_sci_List(stack$1.elem$1);
            matchEnd7: {
              if ((x1$3 instanceof $c_sci_$colon$colon)) {
                rc6 = true;
                x2 = $as_sci_$colon$colon(x1$3);
                var s = $as_Lamf_core_validation_model_PropertyPath(x2.head$5);
                var rest = x2.tl$5;
                if ((s instanceof $c_Lamf_core_validation_model_SequencePath)) {
                  var x4 = $as_Lamf_core_validation_model_SequencePath(s);
                  var jsx$2 = x4.elements$2;
                  var jsx$1 = $m_Lamf_core_validation_model_PropertyPathParser$().expand__sci_List__F1__sci_List(currentList, expander$1);
                  var this$15 = $m_sci_List$();
                  var elements = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$15.ReusableCBFInstance$2));
                  var x$1 = new $c_Lamf_core_validation_model_SequencePath().init___sci_List(elements);
                  stack$1.elem$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, rest);
                  break matchEnd7
                }
              };
              if ((!empty$1.elem$1)) {
                var x$2 = new $c_Lamf_core_validation_model_SequencePath().init___sci_List($m_Lamf_core_validation_model_PropertyPathParser$().expand__sci_List__F1__sci_List(currentList, expander$1));
                var this$16 = $as_sci_List(stack$1.elem$1);
                stack$1.elem$1 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$16);
                break matchEnd7
              };
              if (rc6) {
                var e = $as_Lamf_core_validation_model_PropertyPath(x2.head$5);
                var rest$2 = x2.tl$5;
                if (empty$1.elem$1) {
                  $m_sci_List$();
                  var array$1 = [e];
                  var i$2 = (((-1) + $uI(array$1.length)) | 0);
                  var result$1 = $m_sci_Nil$();
                  while ((i$2 >= 0)) {
                    var this$20 = result$1;
                    var index$1 = i$2;
                    var x$3 = array$1[index$1];
                    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$20);
                    i$2 = (((-1) + i$2) | 0)
                  };
                  var jsx$4 = result$1;
                  var jsx$3 = $m_Lamf_core_validation_model_PropertyPathParser$().expand__sci_List__F1__sci_List(currentList, expander$1);
                  var this$21 = $m_sci_List$();
                  var x$3$1 = new $c_Lamf_core_validation_model_SequencePath().init___sci_List($as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$21.ReusableCBFInstance$2)));
                  stack$1.elem$1 = new $c_sci_$colon$colon().init___O__sci_List(x$3$1, rest$2);
                  break matchEnd7
                }
              };
              throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Syntax error leading / at path or group, index: " + i)))
            };
            current$1.elem$1 = new $c_Lamf_core_validation_model_PredicatePath().init___T__Z__Z("", false, false);
            break
          }
          case 124: {
            var rc6$2 = false;
            var x2$2 = null;
            var x1$4 = $as_sci_List(stack$1.elem$1);
            matchEnd7$2: {
              if ((x1$4 instanceof $c_sci_$colon$colon)) {
                rc6$2 = true;
                x2$2 = $as_sci_$colon$colon(x1$4);
                var s$2 = $as_Lamf_core_validation_model_PropertyPath(x2$2.head$5);
                var rest$3 = x2$2.tl$5;
                if ((s$2 instanceof $c_Lamf_core_validation_model_SequencePath)) {
                  var x4$2 = $as_Lamf_core_validation_model_SequencePath(s$2);
                  var x$5 = new $c_Lamf_core_validation_model_SequencePath().init___sci_List($m_sci_Nil$());
                  var jsx$6 = x4$2.elements$2;
                  var jsx$5 = $m_Lamf_core_validation_model_PropertyPathParser$().expand__sci_List__F1__sci_List(currentList, expander$1);
                  var this$23 = $m_sci_List$();
                  var elements$1 = $as_sci_List(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$5, this$23.ReusableCBFInstance$2));
                  var x$4 = new $c_Lamf_core_validation_model_SequencePath().init___sci_List(elements$1);
                  var this$24 = new $c_sci_$colon$colon().init___O__sci_List(x$4, rest$3);
                  stack$1.elem$1 = new $c_sci_$colon$colon().init___O__sci_List(x$5, this$24);
                  break matchEnd7$2
                }
              };
              if ((!empty$1.elem$1)) {
                var x$7 = new $c_Lamf_core_validation_model_SequencePath().init___sci_List($m_sci_Nil$());
                var x$6 = new $c_Lamf_core_validation_model_AlternatePath().init___sci_List($m_Lamf_core_validation_model_PropertyPathParser$().expand__sci_List__F1__sci_List(currentList, expander$1));
                var this$26 = $as_sci_List(stack$1.elem$1);
                var this$27 = new $c_sci_$colon$colon().init___O__sci_List(x$6, this$26);
                stack$1.elem$1 = new $c_sci_$colon$colon().init___O__sci_List(x$7, this$27);
                break matchEnd7$2
              };
              if (rc6$2) {
                var e$2 = $as_Lamf_core_validation_model_PropertyPath(x2$2.head$5);
                var rest$4 = x2$2.tl$5;
                if (empty$1.elem$1) {
                  $m_sci_List$();
                  var array$2 = [e$2];
                  var i$3 = (((-1) + $uI(array$2.length)) | 0);
                  var result$2 = $m_sci_Nil$();
                  while ((i$3 >= 0)) {
                    var this$31 = result$2;
                    var index$2 = i$3;
                    var x$8 = array$2[index$2];
                    result$2 = new $c_sci_$colon$colon().init___O__sci_List(x$8, this$31);
                    i$3 = (((-1) + i$3) | 0)
                  };
                  var jsx$8 = result$2;
                  var jsx$7 = $m_Lamf_core_validation_model_PropertyPathParser$().expand__sci_List__F1__sci_List(currentList, expander$1);
                  var this$32 = $m_sci_List$();
                  var x$8$1 = new $c_Lamf_core_validation_model_AlternatePath().init___sci_List($as_sci_List(jsx$8.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$7, this$32.ReusableCBFInstance$2)));
                  stack$1.elem$1 = new $c_sci_$colon$colon().init___O__sci_List(x$8$1, rest$4);
                  break matchEnd7$2
                }
              };
              throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(((("Unexpected alternate state in stack at " + new $c_jl_Character().init___C(c$1)) + " in position ") + i)))
            };
            current$1.elem$1 = new $c_Lamf_core_validation_model_PredicatePath().init___T__Z__Z("", false, false);
            break
          }
          case 94: {
            var qual$1 = $as_Lamf_core_validation_model_PredicatePath(current$1.elem$1);
            var x$2$2 = qual$1.property$2;
            var x$3$2 = qual$1.zeroOrMore$2;
            current$1.elem$1 = new $c_Lamf_core_validation_model_PredicatePath().init___T__Z__Z(x$2$2, true, x$3$2);
            break
          }
          case 42: {
            var qual$2 = $as_Lamf_core_validation_model_PredicatePath(current$1.elem$1);
            var x$5$2 = qual$2.property$2;
            var x$6$2 = qual$2.inverse$2;
            current$1.elem$1 = new $c_Lamf_core_validation_model_PredicatePath().init___T__Z__Z(x$5$2, x$6$2, true);
            break
          }
          case 40: {
            var rc7 = false;
            var x2$3 = null;
            var x1$5 = $as_sci_List(stack$1.elem$1);
            matchEnd8: {
              if ((x1$5 instanceof $c_sci_$colon$colon)) {
                rc7 = true;
                x2$3 = $as_sci_$colon$colon(x1$5);
                var s$3 = $as_Lamf_core_validation_model_PropertyPath(x2$3.head$5);
                var rest$5 = x2$3.tl$5;
                if ((s$3 instanceof $c_Lamf_core_validation_model_SequencePath)) {
                  var x4$3 = $as_Lamf_core_validation_model_SequencePath(s$3);
                  var x$10 = new $c_Lamf_core_validation_model_OpenGroup().init___();
                  var jsx$10 = x4$3.elements$2;
                  var jsx$9 = $m_Lamf_core_validation_model_PropertyPathParser$().expand__sci_List__F1__sci_List(currentList, expander$1);
                  var this$35 = $m_sci_List$();
                  var elements$2 = $as_sci_List(jsx$10.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$9, this$35.ReusableCBFInstance$2));
                  var x$9 = new $c_Lamf_core_validation_model_SequencePath().init___sci_List(elements$2);
                  var this$36 = new $c_sci_$colon$colon().init___O__sci_List(x$9, rest$5);
                  stack$1.elem$1 = new $c_sci_$colon$colon().init___O__sci_List(x$10, this$36);
                  break matchEnd8
                }
              };
              if (rc7) {
                var a = $as_Lamf_core_validation_model_PropertyPath(x2$3.head$5);
                var rest$6 = x2$3.tl$5;
                if ((a instanceof $c_Lamf_core_validation_model_AlternatePath)) {
                  var x5 = $as_Lamf_core_validation_model_AlternatePath(a);
                  var x$12 = new $c_Lamf_core_validation_model_OpenGroup().init___();
                  var jsx$12 = x5.elements$2;
                  var jsx$11 = $m_Lamf_core_validation_model_PropertyPathParser$().expand__sci_List__F1__sci_List(currentList, expander$1);
                  var this$37 = $m_sci_List$();
                  var elements$3 = $as_sci_List(jsx$12.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$11, this$37.ReusableCBFInstance$2));
                  var x$11 = new $c_Lamf_core_validation_model_AlternatePath().init___sci_List(elements$3);
                  var this$38 = new $c_sci_$colon$colon().init___O__sci_List(x$11, rest$6);
                  stack$1.elem$1 = new $c_sci_$colon$colon().init___O__sci_List(x$12, this$38);
                  break matchEnd8
                }
              };
              var x$13 = new $c_Lamf_core_validation_model_OpenGroup().init___();
              var this$39 = $as_sci_List(stack$1.elem$1);
              stack$1.elem$1 = new $c_sci_$colon$colon().init___O__sci_List(x$13, this$39)
            };
            current$1.elem$1 = new $c_Lamf_core_validation_model_PredicatePath().init___T__Z__Z("", false, false);
            break
          }
          case 41: {
            var rc9 = false;
            var x2$4 = null;
            var x1$6 = $as_sci_List(stack$1.elem$1);
            matchEnd10: {
              if ((x1$6 instanceof $c_sci_$colon$colon)) {
                rc9 = true;
                x2$4 = $as_sci_$colon$colon(x1$6);
                var s$4 = $as_Lamf_core_validation_model_PropertyPath(x2$4.head$5);
                var rest$7 = x2$4.tl$5;
                if ((s$4 instanceof $c_Lamf_core_validation_model_SequencePath)) {
                  var x5$2 = $as_Lamf_core_validation_model_SequencePath(s$4);
                  var jsx$14 = x5$2.elements$2;
                  var jsx$13 = $m_Lamf_core_validation_model_PropertyPathParser$().expand__sci_List__F1__sci_List(currentList, expander$1);
                  var this$40 = $m_sci_List$();
                  var elements$4 = $as_sci_List(jsx$14.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$13, this$40.ReusableCBFInstance$2));
                  var x$14 = new $c_Lamf_core_validation_model_SequencePath().init___sci_List(elements$4);
                  stack$1.elem$1 = new $c_sci_$colon$colon().init___O__sci_List(x$14, rest$7);
                  break matchEnd10
                }
              };
              if (rc9) {
                var a$2 = $as_Lamf_core_validation_model_PropertyPath(x2$4.head$5);
                var rest$8 = x2$4.tl$5;
                if ((a$2 instanceof $c_Lamf_core_validation_model_AlternatePath)) {
                  var x6 = $as_Lamf_core_validation_model_AlternatePath(a$2);
                  var jsx$16 = x6.elements$2;
                  var jsx$15 = $m_Lamf_core_validation_model_PropertyPathParser$().expand__sci_List__F1__sci_List(currentList, expander$1);
                  var this$41 = $m_sci_List$();
                  var elements$5 = $as_sci_List(jsx$16.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$15, this$41.ReusableCBFInstance$2));
                  var x$15 = new $c_Lamf_core_validation_model_AlternatePath().init___sci_List(elements$5);
                  stack$1.elem$1 = new $c_sci_$colon$colon().init___O__sci_List(x$15, rest$8);
                  break matchEnd10
                }
              };
              if (rc9) {
                var og = $as_Lamf_core_validation_model_PropertyPath(x2$4.head$5);
                var rest$9 = x2$4.tl$5;
                if ((og instanceof $c_Lamf_core_validation_model_OpenGroup)) {
                  var x7 = $as_Lamf_core_validation_model_OpenGroup(og);
                  var x$17 = new $c_Lamf_core_validation_model_SequencePath().init___sci_List($m_Lamf_core_validation_model_PropertyPathParser$().expand__sci_List__F1__sci_List(currentList, expander$1));
                  var this$42 = new $c_sci_$colon$colon().init___O__sci_List(x7, rest$9);
                  stack$1.elem$1 = new $c_sci_$colon$colon().init___O__sci_List(x$17, this$42);
                  break matchEnd10
                }
              };
              throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(((((("Property path parsing error '" + path$1) + "' at position ") + i) + " ')', unknown token in stack: ") + x1$6)))
            };
            current$1.elem$1 = new $c_Lamf_core_validation_model_PredicatePath().init___T__Z__Z("", false, false);
            var this$43 = $as_sci_List(stack$1.elem$1);
            var b = new $c_scm_ListBuffer().init___();
            var these = this$43;
            while (true) {
              if ((!these.isEmpty__Z())) {
                var arg1 = these.head__O();
                var e$3 = $as_Lamf_core_validation_model_PropertyPath(arg1);
                var jsx$17 = (!(e$3 instanceof $c_Lamf_core_validation_model_OpenGroup))
              } else {
                var jsx$17 = false
              };
              if (jsx$17) {
                b.$$plus$eq__O__scm_ListBuffer(these.head__O());
                these = $as_sci_List(these.tail__O())
              } else {
                break
              }
            };
            var group = b.toList__sci_List();
            var this$44 = $as_sci_List(stack$1.elem$1);
            var xs = this$44;
            var jsx$18;
            _loop: while (true) {
              if (xs.isEmpty__Z()) {
                var jsx$19 = true
              } else {
                var arg1$1 = xs.head__O();
                var e$4 = $as_Lamf_core_validation_model_PropertyPath(arg1$1);
                var jsx$19 = (!(!(e$4 instanceof $c_Lamf_core_validation_model_OpenGroup)))
              };
              if ((!jsx$19)) {
                xs = $as_sci_List(xs.tail__O());
                continue _loop
              };
              var jsx$18 = xs;
              break
            };
            var rest$10 = jsx$18.drop__I__sci_List(1);
            var nextElement = $m_Lamf_core_validation_model_PropertyPathParser$().reduce__sci_List__Lamf_core_validation_model_PropertyPath(group);
            matchEnd5: {
              var jsx$20;
              if ((rest$10 instanceof $c_sci_$colon$colon)) {
                var x2$5 = $as_sci_$colon$colon(rest$10);
                var es = $as_Lamf_core_validation_model_PropertyPath(x2$5.head$5);
                var rest$11 = x2$5.tl$5;
                if ((es instanceof $c_Lamf_core_validation_model_SequencePath)) {
                  var x3 = $as_Lamf_core_validation_model_SequencePath(es);
                  var jsx$22 = x3.elements$2;
                  $m_sci_List$();
                  var array$3 = [nextElement];
                  var i$4 = (((-1) + $uI(array$3.length)) | 0);
                  var result$3 = $m_sci_Nil$();
                  while ((i$4 >= 0)) {
                    var this$48 = result$3;
                    var index$3 = i$4;
                    var x$16 = array$3[index$3];
                    result$3 = new $c_sci_$colon$colon().init___O__sci_List(x$16, this$48);
                    i$4 = (((-1) + i$4) | 0)
                  };
                  var jsx$21 = result$3;
                  var this$49 = $m_sci_List$();
                  var elements$6 = $as_sci_List(jsx$22.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$21, this$49.ReusableCBFInstance$2));
                  var x$18 = new $c_Lamf_core_validation_model_SequencePath().init___sci_List(elements$6);
                  var jsx$20 = new $c_sci_$colon$colon().init___O__sci_List(x$18, rest$11);
                  break matchEnd5
                }
              };
              var jsx$20 = new $c_sci_$colon$colon().init___O__sci_List(nextElement, rest$10)
            };
            stack$1.elem$1 = jsx$20;
            break
          }
          default: {
            var qual$3 = $as_Lamf_core_validation_model_PredicatePath(current$1.elem$1);
            var x$7$2 = (("" + $as_Lamf_core_validation_model_PredicatePath(current$1.elem$1).property$2) + new $c_jl_Character().init___C(c$1));
            var x$8$2 = qual$3.inverse$2;
            var x$9$2 = qual$3.zeroOrMore$2;
            current$1.elem$1 = new $c_Lamf_core_validation_model_PredicatePath().init___T__Z__Z(x$7$2, x$8$2, x$9$2)
          }
        }
      } else {
        throw new $c_s_MatchError().init___O(x$20)
      }
    })
  })(this, current, empty, stack, expander, path)), ($m_sci_IndexedSeq$(), $m_sc_IndexedSeq$().ReusableCBF$6));
  if (($as_Lamf_core_validation_model_PredicatePath(current.elem$1).property$2 === "")) {
    empty.elem$1 = true
  } else {
    empty.elem$1 = false
  };
  if (empty.elem$1) {
    var currentList$1 = $m_sci_Nil$()
  } else {
    $m_sci_List$();
    var array$4 = [$as_Lamf_core_validation_model_PredicatePath(current.elem$1)];
    var i$5 = (((-1) + $uI(array$4.length)) | 0);
    var result$4 = $m_sci_Nil$();
    while ((i$5 >= 0)) {
      var this$56 = result$4;
      var index$4 = i$5;
      var x$19 = array$4[index$4];
      result$4 = new $c_sci_$colon$colon().init___O__sci_List(x$19, this$56);
      i$5 = (((-1) + i$5) | 0)
    };
    var currentList$1 = result$4
  };
  var rc10 = false;
  var x2$1 = null;
  var x1 = $as_sci_List(stack.elem$1);
  matchEnd11: {
    var result$5;
    if ((x1 instanceof $c_sci_$colon$colon)) {
      rc10 = true;
      x2$1 = $as_sci_$colon$colon(x1);
      var s$1 = $as_Lamf_core_validation_model_PropertyPath(x2$1.head$5);
      var rest$1 = x2$1.tl$5;
      if ((s$1 instanceof $c_Lamf_core_validation_model_SequencePath)) {
        var x5$1 = $as_Lamf_core_validation_model_SequencePath(s$1);
        var jsx$24 = x5$1.elements$2;
        var jsx$23 = this.expand__sci_List__F1__sci_List(currentList$1, expander);
        var this$57 = $m_sci_List$();
        var elements$7 = $as_sci_List(jsx$24.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$23, this$57.ReusableCBFInstance$2));
        var x$21 = new $c_Lamf_core_validation_model_SequencePath().init___sci_List(elements$7);
        var result$5 = this.reduce__sci_List__Lamf_core_validation_model_PropertyPath(new $c_sci_$colon$colon().init___O__sci_List(x$21, rest$1));
        break matchEnd11
      }
    };
    if (rc10) {
      var a$1 = $as_Lamf_core_validation_model_PropertyPath(x2$1.head$5);
      var rest$2$1 = x2$1.tl$5;
      if ((a$1 instanceof $c_Lamf_core_validation_model_AlternatePath)) {
        var x6$1 = $as_Lamf_core_validation_model_AlternatePath(a$1);
        var jsx$26 = x6$1.elements$2;
        var jsx$25 = this.expand__sci_List__F1__sci_List(currentList$1, expander);
        var this$58 = $m_sci_List$();
        var elements$8 = $as_sci_List(jsx$26.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$25, this$58.ReusableCBFInstance$2));
        var x$22 = new $c_Lamf_core_validation_model_AlternatePath().init___sci_List(elements$8);
        var result$5 = this.reduce__sci_List__Lamf_core_validation_model_PropertyPath(new $c_sci_$colon$colon().init___O__sci_List(x$22, rest$2$1));
        break matchEnd11
      }
    };
    if (rc10) {
      var og$1 = $as_Lamf_core_validation_model_PropertyPath(x2$1.head$5);
      var rest$3$1 = x2$1.tl$5;
      if ((og$1 instanceof $c_Lamf_core_validation_model_OpenGroup)) {
        var x7$1 = $as_Lamf_core_validation_model_OpenGroup(og$1);
        var x$24 = new $c_Lamf_core_validation_model_SequencePath().init___sci_List(this.expand__sci_List__F1__sci_List(currentList$1, expander));
        var this$59 = new $c_sci_$colon$colon().init___O__sci_List(x7$1, rest$3$1);
        var result$5 = this.reduce__sci_List__Lamf_core_validation_model_PropertyPath(new $c_sci_$colon$colon().init___O__sci_List(x$24, this$59));
        break matchEnd11
      }
    };
    var x$23 = $m_sci_Nil$();
    if (x$23.equals__O__Z(x1)) {
      var result$5 = $as_Lamf_core_validation_model_PropertyPath(this.expand__sci_List__F1__sci_List(currentList$1, expander).head__O());
      break matchEnd11
    };
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Property path parsing error unexpected reduction in group found invalid stack " + $as_sci_List(stack.elem$1))))
  };
  if ((result$5 instanceof $c_Lamf_core_validation_model_SequencePath)) {
    var x2$2$1 = $as_Lamf_core_validation_model_SequencePath(result$5);
    var this$60 = x2$2$1.elements$2;
    if (($f_sc_LinearSeqOptimized__length__I(this$60) === 1)) {
      return $as_Lamf_core_validation_model_PropertyPath(x2$2$1.elements$2.head__O())
    }
  };
  return result$5
});
var $d_Lamf_core_validation_model_PropertyPathParser$ = new $TypeData().initClass({
  Lamf_core_validation_model_PropertyPathParser$: 0
}, false, "amf.core.validation.model.PropertyPathParser$", {
  Lamf_core_validation_model_PropertyPathParser$: 1,
  O: 1
});
$c_Lamf_core_validation_model_PropertyPathParser$.prototype.$classData = $d_Lamf_core_validation_model_PropertyPathParser$;
var $n_Lamf_core_validation_model_PropertyPathParser$ = (void 0);
function $m_Lamf_core_validation_model_PropertyPathParser$() {
  if ((!$n_Lamf_core_validation_model_PropertyPathParser$)) {
    $n_Lamf_core_validation_model_PropertyPathParser$ = new $c_Lamf_core_validation_model_PropertyPathParser$().init___()
  };
  return $n_Lamf_core_validation_model_PropertyPathParser$
}
/** @constructor */
function $c_Lamf_core_vocabulary_Namespace$XsdTypes$() {
  $c_O.call(this);
  this.xsdString$1 = null;
  this.xsdInteger$1 = null;
  this.xsdFloat$1 = null;
  this.amlNumber$1 = null;
  this.amlLink$1 = null;
  this.xsdDouble$1 = null;
  this.xsdBoolean$1 = null;
  this.xsdNil$1 = null;
  this.xsdUri$1 = null;
  this.xsdAnyType$1 = null;
  this.amlAnyNode$1 = null
}
$c_Lamf_core_vocabulary_Namespace$XsdTypes$.prototype = new $h_O();
$c_Lamf_core_vocabulary_Namespace$XsdTypes$.prototype.constructor = $c_Lamf_core_vocabulary_Namespace$XsdTypes$;
/** @constructor */
function $h_Lamf_core_vocabulary_Namespace$XsdTypes$() {
  /*<skip>*/
}
$h_Lamf_core_vocabulary_Namespace$XsdTypes$.prototype = $c_Lamf_core_vocabulary_Namespace$XsdTypes$.prototype;
$c_Lamf_core_vocabulary_Namespace$XsdTypes$.prototype.init___ = (function() {
  $n_Lamf_core_vocabulary_Namespace$XsdTypes$ = this;
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Xsd$1;
  this.xsdString$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "string");
  var this$3 = $m_Lamf_core_vocabulary_Namespace$().Xsd$1;
  this.xsdInteger$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "integer");
  var this$5 = $m_Lamf_core_vocabulary_Namespace$().Xsd$1;
  this.xsdFloat$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$5, "float");
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.amlNumber$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "number");
  var this$9 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.amlLink$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$9, "link");
  var this$11 = $m_Lamf_core_vocabulary_Namespace$().Xsd$1;
  this.xsdDouble$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$11, "double");
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().Xsd$1;
  this.xsdBoolean$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "boolean");
  var this$15 = $m_Lamf_core_vocabulary_Namespace$().Xsd$1;
  this.xsdNil$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$15, "nil");
  var this$17 = $m_Lamf_core_vocabulary_Namespace$().Xsd$1;
  this.xsdUri$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$17, "anyURI");
  var this$19 = $m_Lamf_core_vocabulary_Namespace$().Xsd$1;
  this.xsdAnyType$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$19, "anyType");
  var this$21 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.amlAnyNode$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$21, "anyNode");
  return this
});
var $d_Lamf_core_vocabulary_Namespace$XsdTypes$ = new $TypeData().initClass({
  Lamf_core_vocabulary_Namespace$XsdTypes$: 0
}, false, "amf.core.vocabulary.Namespace$XsdTypes$", {
  Lamf_core_vocabulary_Namespace$XsdTypes$: 1,
  O: 1
});
$c_Lamf_core_vocabulary_Namespace$XsdTypes$.prototype.$classData = $d_Lamf_core_vocabulary_Namespace$XsdTypes$;
var $n_Lamf_core_vocabulary_Namespace$XsdTypes$ = (void 0);
function $m_Lamf_core_vocabulary_Namespace$XsdTypes$() {
  if ((!$n_Lamf_core_vocabulary_Namespace$XsdTypes$)) {
    $n_Lamf_core_vocabulary_Namespace$XsdTypes$ = new $c_Lamf_core_vocabulary_Namespace$XsdTypes$().init___()
  };
  return $n_Lamf_core_vocabulary_Namespace$XsdTypes$
}
/** @constructor */
function $c_Lamf_plugins_document_graph_MetaModelHelper$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_graph_MetaModelHelper$.prototype = new $h_O();
$c_Lamf_plugins_document_graph_MetaModelHelper$.prototype.constructor = $c_Lamf_plugins_document_graph_MetaModelHelper$;
/** @constructor */
function $h_Lamf_plugins_document_graph_MetaModelHelper$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_MetaModelHelper$.prototype = $c_Lamf_plugins_document_graph_MetaModelHelper$.prototype;
$c_Lamf_plugins_document_graph_MetaModelHelper$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_graph_MetaModelHelper$.prototype.fieldsFrom__Lamf_core_metamodel_Obj__sc_Seq = (function(obj) {
  if ($is_Lamf_core_metamodel_domain_ShapeModel(obj)) {
    var jsx$1 = $m_sc_Seq$();
    var array = [$m_Lamf_core_metamodel_domain_ShapeModel$().CustomShapePropertyDefinitions__Lamf_core_metamodel_Field(), $m_Lamf_core_metamodel_domain_ShapeModel$().CustomShapeProperties__Lamf_core_metamodel_Field()];
    var lazyShapeFields = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  } else {
    var lazyShapeFields = $m_sci_Nil$()
  };
  var jsx$2 = obj.fields__sci_List();
  var this$3 = $m_sci_List$();
  return $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(lazyShapeFields, this$3.ReusableCBFInstance$2))
});
var $d_Lamf_plugins_document_graph_MetaModelHelper$ = new $TypeData().initClass({
  Lamf_plugins_document_graph_MetaModelHelper$: 0
}, false, "amf.plugins.document.graph.MetaModelHelper$", {
  Lamf_plugins_document_graph_MetaModelHelper$: 1,
  O: 1
});
$c_Lamf_plugins_document_graph_MetaModelHelper$.prototype.$classData = $d_Lamf_plugins_document_graph_MetaModelHelper$;
var $n_Lamf_plugins_document_graph_MetaModelHelper$ = (void 0);
function $m_Lamf_plugins_document_graph_MetaModelHelper$() {
  if ((!$n_Lamf_plugins_document_graph_MetaModelHelper$)) {
    $n_Lamf_plugins_document_graph_MetaModelHelper$ = new $c_Lamf_plugins_document_graph_MetaModelHelper$().init___()
  };
  return $n_Lamf_plugins_document_graph_MetaModelHelper$
}
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_EmissionContext() {
  $c_O.call(this);
  this.prefixes$1 = null;
  this.base$1 = null;
  this.options$1 = null;
  this.emittingDeclarations$1 = false;
  this.emittingReferences$1 = false;
  this.counter$1 = 0;
  this.declarations$1 = null;
  this.references$1 = null;
  this.normalizedReferenceShapes$1 = null;
  this.validToExtract$1 = null;
  this.typeCount$1 = null
}
$c_Lamf_plugins_document_graph_emitter_EmissionContext.prototype = new $h_O();
$c_Lamf_plugins_document_graph_emitter_EmissionContext.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_EmissionContext;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_EmissionContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_EmissionContext.prototype = $c_Lamf_plugins_document_graph_emitter_EmissionContext.prototype;
$c_Lamf_plugins_document_graph_emitter_EmissionContext.prototype.$$plus$plus__sc_Iterable__Lamf_plugins_document_graph_emitter_EmissionContext = (function(elements) {
  var this$1 = this.declarations$1;
  $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$1, elements);
  return this
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext.prototype.emittingEncodes__Z = (function() {
  return ((!this.emittingDeclarations$1) && (!this.emittingReferences$1))
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext.prototype.init___scm_Map__T__Lamf_core_emitter_RenderOptions__Z__Z = (function(prefixes, base, options, emittingDeclarations, emittingReferences) {
  this.prefixes$1 = prefixes;
  this.base$1 = base;
  this.options$1 = options;
  this.emittingDeclarations$1 = emittingDeclarations;
  this.emittingReferences$1 = emittingReferences;
  this.counter$1 = 1;
  this.declarations$1 = new $c_scm_LinkedHashSet().init___();
  this.references$1 = new $c_scm_LinkedHashSet().init___();
  this.normalizedReferenceShapes$1 = new $c_scm_LinkedHashSet().init___();
  this.validToExtract$1 = new $c_scm_LinkedHashSet().init___();
  this.typeCount$1 = new $c_Lamf_core_utils_package$IdCounter().init___();
  return this
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext.prototype.$$plus__Lamf_core_model_domain_AmfElement__Lamf_plugins_document_graph_emitter_EmissionContext = (function(element) {
  this.declarations$1.$$plus$eq__O__scm_LinkedHashSet(element);
  return this
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext.prototype.baseParent__p1__T = (function() {
  var thiz = this.base$1;
  var idx = $uI(thiz.lastIndexOf("/"));
  var thiz$1 = this.base$1;
  return $as_T(thiz$1.substring(0, idx))
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext.prototype.isInReferencedShapes__Lamf_core_model_domain_AmfElement__Z = (function(e) {
  if ($is_Lamf_core_model_domain_DomainElement(e)) {
    var x2 = $as_Lamf_core_model_domain_DomainElement(e);
    return this.normalizedReferenceShapes$1.contains__O__Z(x2)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext.prototype.canBeExtractedToDeclares__Lamf_core_model_domain_AmfElement__Z = (function(e) {
  if ($is_Lamf_core_model_domain_DomainElement(e)) {
    var x2 = $as_Lamf_core_model_domain_DomainElement(e);
    return this.validToExtract$1.contains__O__Z(x2.id__T())
  } else {
    return false
  }
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext.prototype.emitContext__Lorg_yaml_builder_DocBuilder$Entry__V = (function(b) {
  var this$1 = this.options$1;
  if (this$1.amf$core$emitter$RenderOptions$$compactUris$1) {
    b.entry__T__F1__V("@context", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$1$2) {
        var x$1 = $as_Lorg_yaml_builder_DocBuilder$Part(x$1$2);
        x$1.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
          return (function(b$2) {
            var b$1 = $as_Lorg_yaml_builder_DocBuilder$Entry(b$2);
            b$1.entry__T__T__V("@base", $this$1.base$1);
            $this$1.prefixes$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, b$3) {
              return (function(x0$1$2) {
                var x0$1 = $as_T2(x0$1$2);
                if ((x0$1 !== null)) {
                  var p = $as_T(x0$1.$$und1__O());
                  var v = $as_T(x0$1.$$und2__O());
                  b$3.entry__T__T__V(p, v)
                } else {
                  throw new $c_s_MatchError().init___O(x0$1)
                }
              })
            })($this$1, b$1)))
          })
        })($this)))
      })
    })(this)))
  }
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext.prototype.addReferences__sc_Iterable__Lamf_plugins_document_graph_emitter_EmissionContext = (function(elements) {
  var this$1 = this.references$1;
  $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$1, elements);
  var this$4 = this.normalizedReferenceShapes$1;
  var this$3 = this.references$1;
  var pf = new $c_Lamf_plugins_document_graph_emitter_EmissionContext$$anonfun$addReferences$1().init___Lamf_plugins_document_graph_emitter_EmissionContext(this);
  var this$2 = $m_scm_LinkedHashSet$();
  var bf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$2);
  var xs = $as_sc_TraversableOnce($as_scg_GenericTraversableTemplate($f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this$3, pf, bf)).flatten__F1__sc_GenTraversable($m_s_Predef$().singleton$und$less$colon$less$2));
  $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$4, xs);
  return this
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext.prototype.registerDeclaredAndReferencedFromAnnotations__sc_Seq__Lamf_plugins_document_graph_emitter_EmissionContext = (function(ids) {
  var this$1 = this.validToExtract$1;
  $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$1, ids);
  return this
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext.prototype.emittingReferences__Z__Lamf_plugins_document_graph_emitter_EmissionContext = (function(r) {
  this.emittingReferences$1 = r;
  return this
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext.prototype.emitIri__T__T = (function(uri) {
  var this$1 = this.options$1;
  if (this$1.amf$core$emitter$RenderOptions$$compactUris$1) {
    return $m_Lamf_core_vocabulary_Namespace$().compactAndCollect__T__scm_Map__T(uri, this.prefixes$1)
  } else {
    return uri
  }
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext.prototype.emitId__T__T = (function(uri) {
  var this$1 = this.options$1;
  if (this$1.amf$core$emitter$RenderOptions$$compactUris$1) {
    var prefix = this.base$1;
    if ((($uI(uri.length) >= 0) && ($as_T(uri.substring(0, $uI(prefix.length))) === prefix))) {
      var target = this.base$1;
      return $as_T(uri.split(target).join(""))
    } else {
      var prefix$1 = this.baseParent__p1__T();
      if ((($uI(uri.length) >= 0) && ($as_T(uri.substring(0, $uI(prefix$1.length))) === prefix$1))) {
        var target$1 = (this.baseParent__p1__T() + "/");
        return $as_T(uri.split(target$1).join("./"))
      } else {
        return uri
      }
    }
  } else {
    return uri
  }
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext.prototype.canGenerateLink__Lamf_core_model_domain_AmfElement__Z = (function(e) {
  return (this.emittingEncodes__Z() && ((this.declarations$1.contains__O__Z(e) || this.isInReferencedShapes__Lamf_core_model_domain_AmfElement__Z(e)) || this.canBeExtractedToDeclares__Lamf_core_model_domain_AmfElement__Z(e)))
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext.prototype.emittingDeclarations__Z__Lamf_plugins_document_graph_emitter_EmissionContext = (function(d) {
  this.emittingDeclarations$1 = d;
  return this
});
var $d_Lamf_plugins_document_graph_emitter_EmissionContext = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_EmissionContext: 0
}, false, "amf.plugins.document.graph.emitter.EmissionContext", {
  Lamf_plugins_document_graph_emitter_EmissionContext: 1,
  O: 1
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_EmissionContext;
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_EmissionContext$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_graph_emitter_EmissionContext$.prototype = new $h_O();
$c_Lamf_plugins_document_graph_emitter_EmissionContext$.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_EmissionContext$;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_EmissionContext$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_EmissionContext$.prototype = $c_Lamf_plugins_document_graph_emitter_EmissionContext$.prototype;
$c_Lamf_plugins_document_graph_emitter_EmissionContext$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext$.prototype.apply__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__Lamf_plugins_document_graph_emitter_EmissionContext = (function(unit, options) {
  return new $c_Lamf_plugins_document_graph_emitter_EmissionContext().init___scm_Map__T__Lamf_core_emitter_RenderOptions__Z__Z($as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), unit.id__T(), options, false, false)
});
var $d_Lamf_plugins_document_graph_emitter_EmissionContext$ = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_EmissionContext$: 0
}, false, "amf.plugins.document.graph.emitter.EmissionContext$", {
  Lamf_plugins_document_graph_emitter_EmissionContext$: 1,
  O: 1
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext$.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_EmissionContext$;
var $n_Lamf_plugins_document_graph_emitter_EmissionContext$ = (void 0);
function $m_Lamf_plugins_document_graph_emitter_EmissionContext$() {
  if ((!$n_Lamf_plugins_document_graph_emitter_EmissionContext$)) {
    $n_Lamf_plugins_document_graph_emitter_EmissionContext$ = new $c_Lamf_plugins_document_graph_emitter_EmissionContext$().init___()
  };
  return $n_Lamf_plugins_document_graph_emitter_EmissionContext$
}
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext$.prototype = new $h_O();
$c_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext$.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext$;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext$.prototype = $c_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext$.prototype;
$c_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext$.prototype.apply__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__Lamf_plugins_document_graph_emitter_FlattenedEmissionContext = (function(unit, options) {
  return new $c_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext().init___scm_Map__T__Lamf_core_emitter_RenderOptions__Z($as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), unit.id__T(), options, false)
});
var $d_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext$ = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_FlattenedEmissionContext$: 0
}, false, "amf.plugins.document.graph.emitter.FlattenedEmissionContext$", {
  Lamf_plugins_document_graph_emitter_FlattenedEmissionContext$: 1,
  O: 1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext$.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext$;
var $n_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext$ = (void 0);
function $m_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext$() {
  if ((!$n_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext$)) {
    $n_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext$ = new $c_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext$().init___()
  };
  return $n_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext$
}
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$.prototype = new $h_O();
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$.prototype = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$.prototype;
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$.prototype.emit__Lamf_core_model_document_BaseUnit__Lorg_yaml_builder_DocBuilder__Lamf_core_emitter_RenderOptions__Z = (function(unit, builder, renderOptions) {
  var ctx = $m_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext$().apply__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__Lamf_plugins_document_graph_emitter_FlattenedEmissionContext(unit, renderOptions);
  new $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter().init___Lorg_yaml_builder_DocBuilder__Lamf_core_emitter_RenderOptions__Lamf_plugins_document_graph_emitter_EmissionContext(builder, renderOptions, ctx).root__Lamf_core_model_document_BaseUnit__V(unit);
  return true
});
var $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$ = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$: 0
}, false, "amf.plugins.document.graph.emitter.FlattenedJsonLdEmitter$", {
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$: 1,
  O: 1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$;
var $n_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$ = (void 0);
function $m_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$() {
  if ((!$n_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$)) {
    $n_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$ = new $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$().init___()
  };
  return $n_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$
}
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_JsonLdEmitter$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter$.prototype = new $h_O();
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter$.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_JsonLdEmitter$;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_JsonLdEmitter$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_JsonLdEmitter$.prototype = $c_Lamf_plugins_document_graph_emitter_JsonLdEmitter$.prototype;
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter$.prototype.emit__Lamf_core_model_document_BaseUnit__Lorg_yaml_builder_DocBuilder__Lamf_core_emitter_RenderOptions__Z = (function(unit, builder, renderOptions) {
  var ctx = $m_Lamf_plugins_document_graph_emitter_EmissionContext$().apply__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__Lamf_plugins_document_graph_emitter_EmissionContext(unit, renderOptions);
  new $c_Lamf_plugins_document_graph_emitter_JsonLdEmitter().init___Lorg_yaml_builder_DocBuilder__Lamf_core_emitter_RenderOptions__Lamf_plugins_document_graph_emitter_EmissionContext(builder, renderOptions, ctx).root__Lamf_core_model_document_BaseUnit__V(unit);
  return true
});
var $d_Lamf_plugins_document_graph_emitter_JsonLdEmitter$ = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_JsonLdEmitter$: 0
}, false, "amf.plugins.document.graph.emitter.JsonLdEmitter$", {
  Lamf_plugins_document_graph_emitter_JsonLdEmitter$: 1,
  O: 1
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter$.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_JsonLdEmitter$;
var $n_Lamf_plugins_document_graph_emitter_JsonLdEmitter$ = (void 0);
function $m_Lamf_plugins_document_graph_emitter_JsonLdEmitter$() {
  if ((!$n_Lamf_plugins_document_graph_emitter_JsonLdEmitter$)) {
    $n_Lamf_plugins_document_graph_emitter_JsonLdEmitter$ = new $c_Lamf_plugins_document_graph_emitter_JsonLdEmitter$().init___()
  };
  return $n_Lamf_plugins_document_graph_emitter_JsonLdEmitter$
}
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_flattened_utils_Emission() {
  $c_O.call(this);
  this.fn$1 = null
}
$c_Lamf_plugins_document_graph_emitter_flattened_utils_Emission.prototype = new $h_O();
$c_Lamf_plugins_document_graph_emitter_flattened_utils_Emission.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_flattened_utils_Emission;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_flattened_utils_Emission() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_flattened_utils_Emission.prototype = $c_Lamf_plugins_document_graph_emitter_flattened_utils_Emission.prototype;
$c_Lamf_plugins_document_graph_emitter_flattened_utils_Emission.prototype.init___F1 = (function(fn) {
  this.fn$1 = fn;
  return this
});
function $as_Lamf_plugins_document_graph_emitter_flattened_utils_Emission(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_graph_emitter_flattened_utils_Emission) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.graph.emitter.flattened.utils.Emission"))
}
function $isArrayOf_Lamf_plugins_document_graph_emitter_flattened_utils_Emission(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_graph_emitter_flattened_utils_Emission)))
}
function $asArrayOf_Lamf_plugins_document_graph_emitter_flattened_utils_Emission(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_graph_emitter_flattened_utils_Emission(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.graph.emitter.flattened.utils.Emission;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$.prototype = new $h_O();
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$.prototype.constructor = $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$;
/** @constructor */
function $h_Lamf_plugins_document_graph_parser_ExpandedGraphParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_parser_ExpandedGraphParser$.prototype = $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$.prototype;
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$.prototype.canParse__Lamf_core_parser_SyamlParsedDocument__Z = (function(document) {
  var node = document.document$2.node$2;
  var jsx$1 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node);
  var reader = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var this$3 = $m_sc_IndexedSeq$();
  var bf = this$3.ReusableCBF$6;
  var maybeMaps = jsx$1.toOption__Lorg_yaml_convert_YRead__s_Option(new $c_Lorg_yaml_convert_YRead$$anon$1().init___scg_CanBuildFrom__Lorg_yaml_convert_YRead(bf, reader));
  if (maybeMaps.isEmpty__Z()) {
    var maybeMap = $m_s_None$()
  } else {
    var arg1 = maybeMaps.get__O();
    var s = $as_sc_Seq(arg1);
    var maybeMap = s.headOption__s_Option()
  };
  if ((maybeMap instanceof $c_s_Some)) {
    var x2 = $as_s_Some(maybeMap);
    var m = $as_Lorg_yaml_model_YMap(x2.value$2);
    if ((m !== null)) {
      var toDocumentNamespace = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
        return (function(a$2) {
          var a = $as_T(a$2);
          var this$4 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
          return new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, a).iri__T()
        })
      })(this));
      var jsx$3 = $m_sc_Seq$();
      var array = ["encodes", "declares", "references"];
      var jsx$2 = $as_sc_TraversableLike(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
      var this$8 = $m_sc_Seq$();
      var keys = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(toDocumentNamespace, this$8.ReusableCBFInstance$2));
      var jsx$5 = $m_sc_Seq$();
      var array$1 = ["Document", "Fragment", "Module", "Unit"];
      var jsx$4 = $as_sc_TraversableLike(jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)));
      var this$11 = $m_sc_Seq$();
      var types = $as_sc_Seq(jsx$4.map__F1__scg_CanBuildFrom__O(toDocumentNamespace, this$11.ReusableCBFInstance$2));
      var jsx$7 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
        return (function(uri$2) {
          var uri = $as_T(uri$2);
          return $m_Lamf_core_vocabulary_Namespace$().compact__T__T(uri)
        })
      })(this));
      var this$12 = $m_sc_Seq$();
      var jsx$6 = $as_sc_GenTraversableOnce(keys.map__F1__scg_CanBuildFrom__O(jsx$7, this$12.ReusableCBFInstance$2));
      var this$13 = $m_sc_Seq$();
      var acceptedKeys = $as_sc_Seq(keys.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$6, this$13.ReusableCBFInstance$2));
      var jsx$9 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
        return (function(uri$3$2) {
          var uri$3 = $as_T(uri$3$2);
          return $m_Lamf_core_vocabulary_Namespace$().compact__T__T(uri$3)
        })
      })(this));
      var this$14 = $m_sc_Seq$();
      var jsx$8 = $as_sc_GenTraversableOnce(types.map__F1__scg_CanBuildFrom__O(jsx$9, this$14.ReusableCBFInstance$2));
      var this$15 = $m_sc_Seq$();
      var acceptedTypes = $as_sc_Seq(types.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$8, this$15.ReusableCBFInstance$2));
      if (acceptedKeys.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1, x3) {
        return (function(x$19$2) {
          var x$19 = $as_T(x$19$2);
          return new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(x3).key__T__s_Option(x$19).isDefined__Z()
        })
      })(this, m)))) {
        return true
      } else {
        var this$18 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(m).key__T__s_Option("@type");
        if ((!this$18.isEmpty__Z())) {
          var arg1$1 = this$18.get__O();
          var typesEntry = $as_Lorg_yaml_model_YMapEntry(arg1$1);
          var this$19 = typesEntry.value$2;
          var conversion = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
          var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
          var jsx$11 = $as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$19, conversion, iv)).nodes$3;
          var jsx$10 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
            return (function(node$2) {
              var node$1 = $as_Lorg_yaml_model_YNode(node$2);
              var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
              var iv$1 = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
              return $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node$1, conversion$1, iv$1)).value$3
            })
          })(this));
          var this$20 = $m_sc_IndexedSeq$();
          var retrievedTypes = $as_sc_IndexedSeq(jsx$11.map__F1__scg_CanBuildFrom__O(jsx$10, this$20.ReusableCBF$6));
          return $as_sc_TraversableOnce(acceptedTypes.intersect__sc_GenSeq__O(retrievedTypes)).nonEmpty__Z()
        } else {
          return false
        }
      }
    }
  };
  return false
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$.prototype.apply__Lamf_plugins_document_graph_parser_ExpandedGraphParser = (function() {
  var x$1 = new $c_Lamf_client_parse_DefaultParserErrorHandler().init___I($m_Lamf_core_AMFCompilerRunCount$().nextRun__I());
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$5 = new $c_scm_ListBuffer().init___();
  var x$3 = this$5.toList__sci_List();
  var x$4 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
  var x$5 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$6 = $m_s_None$();
  return new $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser().init___Lamf_plugins_document_graph_parser_GraphParserContext(new $c_Lamf_plugins_document_graph_parser_GraphParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_AmfParserErrorHandler__scm_Map__s_Option("", x$3, x$4, x$1, x$5, x$6))
});
var $d_Lamf_plugins_document_graph_parser_ExpandedGraphParser$ = new $TypeData().initClass({
  Lamf_plugins_document_graph_parser_ExpandedGraphParser$: 0
}, false, "amf.plugins.document.graph.parser.ExpandedGraphParser$", {
  Lamf_plugins_document_graph_parser_ExpandedGraphParser$: 1,
  O: 1
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$.prototype.$classData = $d_Lamf_plugins_document_graph_parser_ExpandedGraphParser$;
var $n_Lamf_plugins_document_graph_parser_ExpandedGraphParser$ = (void 0);
function $m_Lamf_plugins_document_graph_parser_ExpandedGraphParser$() {
  if ((!$n_Lamf_plugins_document_graph_parser_ExpandedGraphParser$)) {
    $n_Lamf_plugins_document_graph_parser_ExpandedGraphParser$ = new $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$().init___()
  };
  return $n_Lamf_plugins_document_graph_parser_ExpandedGraphParser$
}
/** @constructor */
function $c_Lamf_plugins_document_graph_parser_GraphContextHelper() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_graph_parser_GraphContextHelper.prototype = new $h_O();
$c_Lamf_plugins_document_graph_parser_GraphContextHelper.prototype.constructor = $c_Lamf_plugins_document_graph_parser_GraphContextHelper;
/** @constructor */
function $h_Lamf_plugins_document_graph_parser_GraphContextHelper() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_parser_GraphContextHelper.prototype = $c_Lamf_plugins_document_graph_parser_GraphContextHelper.prototype;
$c_Lamf_plugins_document_graph_parser_GraphContextHelper.prototype.baseParent__p1__T__T = (function(base) {
  var idx = $uI(base.lastIndexOf("/"));
  return $as_T(base.substring(0, idx))
});
$c_Lamf_plugins_document_graph_parser_GraphContextHelper.prototype.buildContextMap__Lorg_yaml_model_YNode__sci_Map = (function(contextNode) {
  var x1 = contextNode.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
    var m = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(contextNode, conversion, iv));
    var jsx$2 = m.entries$3;
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(entry$2) {
        var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
        var xo = $this.parseKeyValue__Lorg_yaml_model_YMapEntry__s_Option(entry);
        return xo.toList__sci_List()
      })
    })(this));
    var this$2 = $m_sc_IndexedSeq$();
    return $as_sc_TraversableOnce(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBF$6)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2)
  } else {
    return $m_sci_Map$EmptyMap$()
  }
});
$c_Lamf_plugins_document_graph_parser_GraphContextHelper.prototype.transformIdFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T = (function(id, ctx) {
  var this$1 = ctx.baseId$2;
  if (this$1.isEmpty__Z()) {
    var prefixOption = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var base = $as_T(arg1);
    var prefixOption = new $c_s_Some().init___O(((($uI(id.length) >= 0) && ($as_T(id.substring(0, $uI("./".length))) === "./")) ? (this.baseParent__p1__T__T(base) + "/") : base))
  };
  var prefix = $as_T((prefixOption.isEmpty__Z() ? "" : prefixOption.get__O()));
  return (("" + prefix) + id)
});
$c_Lamf_plugins_document_graph_parser_GraphContextHelper.prototype.expandUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T = (function(iri, ctx) {
  var this$1 = ctx.compactUris$2;
  var this$2 = this$1.iterator__sc_Iterator();
  inlinereturn$3: {
    while (this$2.hasNext__Z()) {
      var a = this$2.next__O();
      var x0$1 = $as_T2(a);
      if ((x0$1 === null)) {
        throw new $c_s_MatchError().init___O(x0$1)
      };
      var key = $as_T(x0$1.$$und1__O());
      if ((($uI(iri.length) >= 0) && ($as_T(iri.substring(0, $uI(key.length))) === key))) {
        var x1 = new $c_s_Some().init___O(a);
        break inlinereturn$3
      }
    };
    var x1 = $m_s_None$()
  };
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var p3 = $as_T2(x2.value$2);
    if ((p3 !== null)) {
      var key$1 = $as_T(p3.$$und1__O());
      var value = $as_T(p3.$$und2__O());
      var target = (("" + key$1) + new $c_jl_Character().init___C(58));
      return $as_T(iri.split(target).join(value))
    }
  };
  var x = $m_s_None$();
  if ((x === x1)) {
    return iri
  };
  throw new $c_s_MatchError().init___O(x1)
});
$c_Lamf_plugins_document_graph_parser_GraphContextHelper.prototype.compactUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T = (function(iri, ctx) {
  var this$1 = ctx.compactUris$2;
  var this$2 = this$1.iterator__sc_Iterator();
  inlinereturn$3: {
    while (this$2.hasNext__Z()) {
      var a = this$2.next__O();
      var x0$1 = $as_T2(a);
      if ((x0$1 === null)) {
        throw new $c_s_MatchError().init___O(x0$1)
      };
      var value = $as_T(x0$1.$$und2__O());
      if ((($uI(iri.length) >= 0) && ($as_T(iri.substring(0, $uI(value.length))) === value))) {
        var x1 = new $c_s_Some().init___O(a);
        break inlinereturn$3
      }
    };
    var x1 = $m_s_None$()
  };
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var p3 = $as_T2(x2.value$2);
    if ((p3 !== null)) {
      var key = $as_T(p3.$$und1__O());
      var value$1 = $as_T(p3.$$und2__O());
      var replacement = (("" + key) + new $c_jl_Character().init___C(58));
      return $as_T(iri.split(value$1).join(replacement))
    }
  };
  var x = $m_s_None$();
  if ((x === x1)) {
    return iri
  };
  throw new $c_s_MatchError().init___O(x1)
});
$c_Lamf_plugins_document_graph_parser_GraphContextHelper.prototype.parseCompactUris__Lorg_yaml_model_YNode__Lamf_plugins_document_graph_parser_GraphParserContext__V = (function(contextNode, ctx) {
  var this$1 = ctx.compactUris$2;
  var xs = this.buildContextMap__Lorg_yaml_model_YNode__sci_Map(contextNode);
  $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$1, xs);
  var this$2 = ctx.compactUris$2;
  var this$3 = this$2.iterator__sc_Iterator();
  inlinereturn$4: {
    while (this$3.hasNext__Z()) {
      var a = this$3.next__O();
      var x0$1 = $as_T2(a);
      if ((x0$1 === null)) {
        throw new $c_s_MatchError().init___O(x0$1)
      };
      var key = $as_T(x0$1.$$und1__O());
      if ((key === "@base")) {
        var this$4 = new $c_s_Some().init___O(a);
        break inlinereturn$4
      }
    };
    var this$4 = $m_s_None$()
  };
  if (this$4.isEmpty__Z()) {
    var jsx$1 = $m_s_None$()
  } else {
    var arg1 = this$4.get__O();
    var x0$2 = $as_T2(arg1);
    if ((x0$2 === null)) {
      throw new $c_s_MatchError().init___O(x0$2)
    };
    var value = $as_T(x0$2.$$und2__O());
    var jsx$1 = new $c_s_Some().init___O(value)
  };
  ctx.baseId$2 = jsx$1
});
$c_Lamf_plugins_document_graph_parser_GraphContextHelper.prototype.parseKeyValue__Lorg_yaml_model_YMapEntry__s_Option = (function(entry) {
  var this$1 = entry.key$2;
  var _1 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var this$2 = entry.value$2;
  var _2 = this$2.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Str$1;
  if ((x === _1)) {
    var x$3 = $m_Lorg_yaml_model_YType$().Str$1;
    var jsx$1 = (x$3 === _2)
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var this$3 = entry.key$2;
    var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
    var self = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv)).text$3;
    var this$5 = entry.value$2;
    var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv$1 = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
    var y = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion$1, iv$1)).text$3;
    return new $c_s_Some().init___O(new $c_T2().init___O__O(self, y))
  } else {
    return $m_s_None$()
  }
});
function $as_Lamf_plugins_document_graph_parser_GraphContextHelper(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_graph_parser_GraphContextHelper) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.graph.parser.GraphContextHelper"))
}
function $isArrayOf_Lamf_plugins_document_graph_parser_GraphContextHelper(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_graph_parser_GraphContextHelper)))
}
function $asArrayOf_Lamf_plugins_document_graph_parser_GraphContextHelper(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_graph_parser_GraphContextHelper(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.graph.parser.GraphContextHelper;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_graph_parser_GraphParserHelpers$AnnotationName$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_graph_parser_GraphParserHelpers$AnnotationName$.prototype = new $h_O();
$c_Lamf_plugins_document_graph_parser_GraphParserHelpers$AnnotationName$.prototype.constructor = $c_Lamf_plugins_document_graph_parser_GraphParserHelpers$AnnotationName$;
/** @constructor */
function $h_Lamf_plugins_document_graph_parser_GraphParserHelpers$AnnotationName$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_parser_GraphParserHelpers$AnnotationName$.prototype = $c_Lamf_plugins_document_graph_parser_GraphParserHelpers$AnnotationName$.prototype;
$c_Lamf_plugins_document_graph_parser_GraphParserHelpers$AnnotationName$.prototype.unapply__T__s_Option = (function(uri) {
  var prefix = $m_Lamf_core_vocabulary_Namespace$().SourceMaps$1.base$1;
  if ((($uI(uri.length) >= 0) && ($as_T(uri.substring(0, $uI(prefix.length))) === prefix))) {
    var beginIndex = ((1 + $uI(uri.indexOf("#"))) | 0);
    return new $c_s_Some().init___O($as_T(uri.substring(beginIndex)))
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_graph_parser_GraphParserHelpers$AnnotationName$.prototype.init___Lamf_plugins_document_graph_parser_GraphParserHelpers = (function($$outer) {
  return this
});
var $d_Lamf_plugins_document_graph_parser_GraphParserHelpers$AnnotationName$ = new $TypeData().initClass({
  Lamf_plugins_document_graph_parser_GraphParserHelpers$AnnotationName$: 0
}, false, "amf.plugins.document.graph.parser.GraphParserHelpers$AnnotationName$", {
  Lamf_plugins_document_graph_parser_GraphParserHelpers$AnnotationName$: 1,
  O: 1
});
$c_Lamf_plugins_document_graph_parser_GraphParserHelpers$AnnotationName$.prototype.$classData = $d_Lamf_plugins_document_graph_parser_GraphParserHelpers$AnnotationName$;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_common_IdCounter() {
  $c_O.call(this);
  this.c$1 = 0
}
$c_Lamf_plugins_document_vocabularies_emitters_common_IdCounter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_common_IdCounter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_common_IdCounter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_common_IdCounter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_common_IdCounter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_common_IdCounter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_common_IdCounter.prototype.init___ = (function() {
  this.c$1 = 0;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_common_IdCounter.prototype.genId__T__T = (function(id) {
  this.c$1 = ((1 + this.c$1) | 0);
  return ((id + "_") + this.c$1)
});
var $d_Lamf_plugins_document_vocabularies_emitters_common_IdCounter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_common_IdCounter: 0
}, false, "amf.plugins.document.vocabularies.emitters.common.IdCounter", {
  Lamf_plugins_document_vocabularies_emitters_common_IdCounter: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_common_IdCounter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_common_IdCounter;
function $f_Lamf_plugins_document_vocabularies_emitters_dialects_AliasesConsumer__aliasFor__T__s_Option($thiz, id) {
  if ($m_s_Option$().apply__O__s_Option(id).isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var x1 = $f_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__maybeFindNodeMappingById__T__s_Option($thiz, id);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var p3 = $as_T2(x2.value$2);
      if ((p3 !== null)) {
        var nodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(p3.$$und2__O());
        if ((nodeMapping !== null)) {
          var prefix = $thiz.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect().id$1;
          if ((($uI(id.length) >= 0) && ($as_T(id.substring(0, $uI(prefix.length))) === prefix))) {
            var this$6 = $as_Lamf_core_model_StrField(nodeMapping.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(nodeMapping.Name__Lamf_core_metamodel_Field()));
            var this$7 = this$6.option$1;
            return new $c_s_Some().init___O($as_T((this$7.isEmpty__Z() ? null : this$7.get__O())))
          } else {
            var this$8 = $thiz.aliases__sci_Map();
            var this$9 = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(this$8);
            var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
            var this$11 = this$9.$$outer$4.keysIterator__sc_Iterator();
            while (this$11.hasNext__Z()) {
              var arg1 = this$11.next__O();
              var x$1 = $as_T(arg1);
              if ((($uI(id.indexOf(x$1)) !== (-1)) !== false)) {
                b.$$plus$eq__O__scm_SetBuilder(arg1)
              }
            };
            var matchingAliases = $as_sci_Set(b.elems$1);
            var this$15 = $m_sci_List$();
            var cbf = this$15.ReusableCBFInstance$2;
            var this$16 = $as_sci_List($f_sc_TraversableLike__to__scg_CanBuildFrom__O(matchingAliases, cbf));
            var ord = $m_s_math_Ordering$String$();
            var this$17 = $as_sci_List($f_sc_SeqLike__sorted__s_math_Ordering__O(this$16, ord)).reverse__sci_List();
            var this$18 = $f_sc_TraversableLike__headOption__s_Option(this$17);
            if (this$18.isEmpty__Z()) {
              var this$21 = $m_s_None$()
            } else {
              var arg1$1 = this$18.get__O();
              var key = $as_T(arg1$1);
              var alias = $as_T($as_T2($thiz.aliases__sci_Map().apply__O__O(key)).$$und1__O());
              var this$19 = $as_Lamf_core_model_StrField(nodeMapping.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(nodeMapping.Name__Lamf_core_metamodel_Field()));
              var this$20 = this$19.option$1;
              var this$21 = new $c_s_Some().init___O(((alias + ".") + $as_T((this$20.isEmpty__Z() ? null : this$20.get__O()))))
            };
            if (this$21.isEmpty__Z()) {
              var this$22 = $as_Lamf_core_model_StrField(nodeMapping.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(nodeMapping.Name__Lamf_core_metamodel_Field()));
              var this$23 = this$22.option$1;
              return new $c_s_Some().init___O($as_T((this$23.isEmpty__Z() ? null : this$23.get__O())))
            } else {
              return this$21
            }
          }
        }
      }
    };
    var prefix$1 = $thiz.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect().id$1;
    if ((($uI(id.length) >= 0) && ($as_T(id.substring(0, $uI(prefix$1.length))) === prefix$1))) {
      var regex = $thiz.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect().id$1;
      var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(id, regex, 0);
      var this$31 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
      var thiz = $as_T($f_sc_IndexedSeqOptimized__last__O(this$31));
      return new $c_s_Some().init___O($as_T(thiz.split("/declarations/").join("")))
    } else {
      var this$34 = $thiz.aliases__sci_Map();
      var this$35 = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(this$34);
      var this$36 = this$35.$$outer$4.keysIterator__sc_Iterator();
      inlinereturn$105: {
        while (this$36.hasNext__Z()) {
          var a = this$36.next__O();
          var x$2 = $as_T(a);
          if (($uI(id.indexOf(x$2)) !== (-1))) {
            var this$40 = new $c_s_Some().init___O(a);
            break inlinereturn$105
          }
        };
        var this$40 = $m_s_None$()
      };
      if (this$40.isEmpty__Z()) {
        return $m_s_None$()
      } else {
        var arg1$2 = this$40.get__O();
        var key$3 = $as_T(arg1$2);
        var alias$1 = $as_T($as_T2($thiz.aliases__sci_Map().apply__O__O(key$3)).$$und1__O());
        var xs$1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(id, key$3, 0);
        var this$43 = new $c_scm_ArrayOps$ofRef().init___AO(xs$1);
        var x1$1 = $as_T($f_sc_IndexedSeqOptimized__last__O(this$43));
        var postfix = (($uI(x1$1.indexOf("/declarations/")) !== (-1)) ? $as_T(x1$1.split("/declarations/").join("")) : x1$1);
        if ((($uI(postfix.length) >= 0) && ($as_T(postfix.substring(0, $uI("#".length))) === "#"))) {
          var this$55 = new $c_sci_StringOps().init___T(postfix);
          var $$this = this$55.repr$1;
          var until = $uI($$this.length);
          var jsx$1 = ((alias$1 + ".") + $m_sci_StringOps$().slice$extension__T__I__I__T(this$55.repr$1, 1, until))
        } else {
          var jsx$1 = ((alias$1 + ".") + postfix)
        };
        return new $c_s_Some().init___O(jsx$1)
      }
    }
  }
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_FieldEntryImplicit$FieldEntryWithPosition() {
  $c_O.call(this);
  this.entry$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FieldEntryImplicit$FieldEntryWithPosition.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FieldEntryImplicit$FieldEntryWithPosition.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_FieldEntryImplicit$FieldEntryWithPosition;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_FieldEntryImplicit$FieldEntryWithPosition() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_FieldEntryImplicit$FieldEntryWithPosition.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_FieldEntryImplicit$FieldEntryWithPosition.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FieldEntryImplicit$FieldEntryWithPosition.prototype.startPosition__s_Option = (function() {
  var this$1 = this.entry$1.value$1.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$50 = $as_Lamf_core_annotations_LexicalInformation(arg1);
    return new $c_s_Some().init___O(x$50.range__Lamf_core_parser_Range().start$1)
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FieldEntryImplicit$FieldEntryWithPosition.prototype.init___Lamf_core_parser_FieldEntry = (function(entry) {
  this.entry$1 = entry;
  return this
});
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_FieldEntryImplicit$FieldEntryWithPosition = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_FieldEntryImplicit$FieldEntryWithPosition: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.FieldEntryImplicit$FieldEntryWithPosition", {
  Lamf_plugins_document_vocabularies_emitters_dialects_FieldEntryImplicit$FieldEntryWithPosition: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FieldEntryImplicit$FieldEntryWithPosition.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_FieldEntryImplicit$FieldEntryWithPosition;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$() {
  $c_O.call(this);
  this.DeclarationName$1 = null;
  this.Abstract$1 = null
}
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$ = this;
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.DeclarationName$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "declarationName"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$6 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.Abstract$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$6, "abstract"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true);
  return this
});
var $d_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$: 0
}, false, "amf.plugins.document.vocabularies.metamodel.domain.DialectDomainElementModel$", {
  Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$;
var $n_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$() {
  if ((!$n_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$)) {
    $n_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$ = new $c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$
}
function $f_Lamf_plugins_document_vocabularies_model_domain_MergeableMapping__mergePolicy__Lamf_core_model_StrField($thiz) {
  return $as_Lamf_core_model_StrField($as_Lamf_core_model_domain_AmfObject($thiz).fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($thiz.MergePolicy__Lamf_core_metamodel_Field()))
}
function $f_Lamf_plugins_document_vocabularies_model_domain_MergeableMapping__withMergePolicy__T__Lamf_plugins_document_vocabularies_model_domain_MergeableMapping($thiz, mergePolicy) {
  if ($thiz.ALLOWED$undMERGE$undPOLICY__sci_Set().contains__O__Z(mergePolicy)) {
    var this$1 = $as_Lamf_core_model_domain_AmfObject($thiz);
    var field = $thiz.MergePolicy__Lamf_core_metamodel_Field();
    return $as_Lamf_plugins_document_vocabularies_model_domain_MergeableMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, mergePolicy))
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T((("Unknown merging policy: '" + mergePolicy) + "'")))
  }
}
function $is_Lamf_plugins_document_vocabularies_model_domain_MergeableMapping(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_document_vocabularies_model_domain_MergeableMapping)))
}
function $as_Lamf_plugins_document_vocabularies_model_domain_MergeableMapping(obj) {
  return (($is_Lamf_plugins_document_vocabularies_model_domain_MergeableMapping(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.domain.MergeableMapping"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_domain_MergeableMapping(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_domain_MergeableMapping)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_domain_MergeableMapping(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_domain_MergeableMapping(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.domain.MergeableMapping;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$.prototype.apply__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_NodeMapping = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
var $d_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_NodeMapping$: 0
}, false, "amf.plugins.document.vocabularies.model.domain.NodeMapping$", {
  Lamf_plugins_document_vocabularies_model_domain_NodeMapping$: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$;
var $n_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$() {
  if ((!$n_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$)) {
    $n_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$ = new $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification.prototype;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts() {
  $c_O.call(this);
  this.target$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts.prototype = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts.prototype;
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts.prototype.setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser = (function(f) {
  return new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectScalarValueEntryParser().init___Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(f, this.target$1, this.ctx$1)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts.prototype.init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext = (function(target, ctx) {
  this.target$1 = target;
  this.ctx$1 = ctx;
  return this
});
var $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts: 0
}, false, "amf.plugins.document.vocabularies.parser.dialects.DialectAstOps$DialectScalarValueEntryParserOpts", {
  Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser() {
  $c_O.call(this);
  this.ctx$1 = null
}
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser.prototype = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser.prototype;
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser.prototype.init___Lamf_plugins_document_vocabularies_parser_dialects_DialectContext = (function(ctx) {
  this.ctx$1 = ctx;
  return this
});
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$() {
  $c_O.call(this);
  this.VocabularyHeader$1 = null;
  this.DialectHeader$1 = null;
  this.DialectLibraryHeader$1 = null;
  this.DialectFragmentHeader$1 = null
}
$c_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$.prototype = $c_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$.prototype;
$c_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$.prototype.init___ = (function() {
  this.VocabularyHeader$1 = "%Vocabulary1.0";
  this.DialectHeader$1 = "%Dialect1.0";
  this.DialectLibraryHeader$1 = "%Library/Dialect1.0";
  this.DialectFragmentHeader$1 = "%NodeMapping/Dialect1.0";
  return this
});
var $d_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$: 0
}, false, "amf.plugins.document.vocabularies.plugin.headers.ExtensionHeader$", {
  Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$;
var $n_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$() {
  if ((!$n_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$)) {
    $n_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$ = new $c_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_JsonSchemaParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_JsonSchemaParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_JsonSchemaParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_JsonSchemaParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_JsonSchemaParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_JsonSchemaParser$.prototype = $c_Lamf_plugins_document_webapi_JsonSchemaParser$.prototype;
$c_Lamf_plugins_document_webapi_JsonSchemaParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_JsonSchemaParser$.prototype.getRaw__p1__Lamf_core_model_document_Fragment__T = (function(inputFragment) {
  if ((inputFragment instanceof $c_Lamf_core_model_document_ExternalFragment)) {
    var x2 = $as_Lamf_core_model_document_ExternalFragment(inputFragment);
    var this$1 = $as_Lamf_core_model_domain_ExternalDomainElement($as_Lamf_core_model_domain_DomainElement(x2.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)));
    var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1));
    var this$3 = this$2.option$1;
    return $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()))
  } else if ((inputFragment instanceof $c_Lamf_core_model_document_RecursiveUnit)) {
    var x3 = $as_Lamf_core_model_document_RecursiveUnit(inputFragment);
    return $as_T(x3.raw$1.get__O())
  } else {
    return ""
  }
});
$c_Lamf_plugins_document_webapi_JsonSchemaParser$.prototype.isYaml__p1__T__Z = (function(location) {
  return ($m_sjsr_RuntimeString$().endsWith__T__T__Z(location, ".yaml") || $m_sjsr_RuntimeString$().endsWith__T__T__Z(location, ".yml"))
});
$c_Lamf_plugins_document_webapi_JsonSchemaParser$.prototype.apply__Lamf_core_model_document_Fragment__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_YParser = (function(fragment, errorHandler) {
  var this$1 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(fragment);
  var location = $as_T((this$1.isEmpty__Z() ? "" : this$1.get__O()));
  if (this.isYaml__p1__T__Z(location)) {
    return $m_Lorg_yaml_parser_YamlParser$().apply__jl_CharSequence__T__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_YamlParser(this.getRaw__p1__Lamf_core_model_document_Fragment__T(fragment), location, errorHandler)
  } else {
    var jsx$2 = $m_Lorg_yaml_parser_JsonParser$();
    var jsx$1 = this.getRaw__p1__Lamf_core_model_document_Fragment__T(fragment);
    var this$2 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(fragment);
    return jsx$2.withSource__jl_CharSequence__T__Lorg_mulesoft_lexer_Position__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_JsonParser(jsx$1, $as_T((this$2.isEmpty__Z() ? "" : this$2.get__O())), $m_Lorg_mulesoft_lexer_Position$().Zero$1, errorHandler)
  }
});
var $d_Lamf_plugins_document_webapi_JsonSchemaParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_JsonSchemaParser$: 0
}, false, "amf.plugins.document.webapi.JsonSchemaParser$", {
  Lamf_plugins_document_webapi_JsonSchemaParser$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_JsonSchemaParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_JsonSchemaParser$;
var $n_Lamf_plugins_document_webapi_JsonSchemaParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_JsonSchemaParser$() {
  if ((!$n_Lamf_plugins_document_webapi_JsonSchemaParser$)) {
    $n_Lamf_plugins_document_webapi_JsonSchemaParser$ = new $c_Lamf_plugins_document_webapi_JsonSchemaParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_JsonSchemaParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_SpecEmitterContext() {
  $c_O.call(this);
  this.eh$1 = null;
  this.refEmitter$1 = null;
  this.options$1 = null;
  this.emittingDeclarations$1 = false
}
$c_Lamf_plugins_document_webapi_contexts_SpecEmitterContext.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_contexts_SpecEmitterContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_SpecEmitterContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_SpecEmitterContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_SpecEmitterContext.prototype = $c_Lamf_plugins_document_webapi_contexts_SpecEmitterContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_SpecEmitterContext.prototype.oasTypePropertyEmitter__T__Lamf_core_model_domain_Shape__Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter = (function(typeName, shape) {
  var x1 = shape.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo.getClassOf());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var lexicalInfo = $as_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo(x2.value$2);
    return new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", typeName, $m_Lorg_yaml_model_YType$().Str$1, lexicalInfo.range$1.start$1)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", typeName, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$())
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_contexts_SpecEmitterContext.prototype.options__Lamf_core_emitter_ShapeRenderOptions = (function() {
  return this.options$1
});
$c_Lamf_plugins_document_webapi_contexts_SpecEmitterContext.prototype.ref__Lorg_yaml_model_YDocument$PartBuilder__T__V = (function(b, url) {
  this.refEmitter$1.ref__T__Lorg_yaml_model_YDocument$PartBuilder__V(url, b)
});
$c_Lamf_plugins_document_webapi_contexts_SpecEmitterContext.prototype.eh__Lamf_core_errorhandling_ErrorHandler = (function() {
  return this.eh$1
});
$c_Lamf_plugins_document_webapi_contexts_SpecEmitterContext.prototype.ramlTypePropertyEmitter__T__Lamf_core_model_domain_Shape__s_Option = (function(typeName, shape) {
  var x1 = shape.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Inherits$1);
  var x = $m_s_None$();
  if ((x === x1)) {
    if ((typeName === "union")) {
      var this$1 = $as_Lamf_plugins_domain_shapes_models_UnionShape(shape);
      var jsx$1 = $as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1)).nonEmpty__Z()
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return $m_s_None$()
    } else {
      var x1$2 = shape.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo.getClassOf());
      if ((x1$2 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1$2);
        var lexicalInfo = $as_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo(x2.value$2);
        return new $c_s_Some().init___O(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", typeName, $m_Lorg_yaml_model_YType$().Str$1, lexicalInfo.range$1.start$1))
      } else {
        return $m_s_None$()
      }
    }
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_contexts_SpecEmitterContext.prototype.filterLocal__sc_Seq__sc_Seq = (function(elements) {
  return ((!this.emittingDeclarations$1) ? elements : $as_sc_Seq(elements.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_domain_DomainElement(x$1$2);
      return (!$f_Lamf_core_model_domain_AmfElement__fromLocal__Z(x$1))
    })
  })(this)))))
});
$c_Lamf_plugins_document_webapi_contexts_SpecEmitterContext.prototype.externalLink__Lamf_core_model_domain_Linkable__sc_Seq__s_Option = (function(link, refs) {
  var x1 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(link);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var element = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    var linkTarget = element.id__T();
    return refs.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, linkTarget$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_model_document_BaseUnit(x0$1$2);
        return ($is_Lamf_core_model_document_EncodesModel(x0$1) ? ($as_Lamf_core_model_document_EncodesModel(x0$1).encodes__Lamf_core_model_domain_DomainElement().id__T() === linkTarget$1) : ($is_Lamf_core_model_document_DeclaresModel(x0$1) && $as_Lamf_core_model_document_DeclaresModel(x0$1).declares__sc_Seq().exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, linkTarget$1$1) {
          return (function(x$2$2) {
            var x$2 = $as_Lamf_core_model_domain_DomainElement(x$2$2);
            return (x$2.id__T() === linkTarget$1$1)
          })
        })($this, linkTarget$1)))))
      })
    })(this, linkTarget)))
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_contexts_SpecEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions = (function(eh, refEmitter, options) {
  this.eh$1 = eh;
  this.refEmitter$1 = refEmitter;
  this.options$1 = options;
  this.emittingDeclarations$1 = false;
  return this
});
function $f_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory__tagToReferenceEmitter__F3($thiz) {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(target$2, label$2, references$2) {
      var target = $as_Lamf_core_model_domain_DomainElement(target$2);
      var label = $as_s_Option(label$2);
      var references = $as_sc_Seq(references$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter().init___Lamf_core_model_domain_DomainElement__s_Option__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(target, label, references, $this.spec__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext())
    })
  })($thiz))
}
function $f_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory__declaredTypesEmitter__F3($thiz) {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(types$2, references$2, ordering$2) {
      var types = $as_sc_Seq(types$2);
      var references = $as_sc_Seq(references$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters().init___sc_Seq__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(types, references, ordering, $this.spec__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext())
    })
  })($thiz))
}
function $f_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory__securityRequirementEmitter__F2($thiz) {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(requirement$2, ordering$2) {
      var requirement = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(requirement$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter().init___Lamf_plugins_domain_webapi_models_security_SecurityRequirement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(requirement, ordering, $this.spec__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext())
    })
  })($thiz))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$.prototype.apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter = (function(key, f, mediaType, spec) {
  var this$1 = f.value$1.value$1.annotations__Lamf_core_parser_Annotations();
  var pf = new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$$anonfun$1().init___();
  var this$3 = this$1.amf$core$parser$Annotations$$annotations$1;
  var this$2 = $m_scm_ListBuffer$();
  var bf = this$2.ReusableCBFInstance$2;
  var extensions = $as_sc_Seq($f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this$3, pf, bf));
  if (extensions.nonEmpty__Z()) {
    var x = spec.vendor__Lamf_core_remote_Vendor();
    var x$2 = $m_Lamf_core_remote_Raml10$();
    var jsx$1 = ((x !== null) && (x === x$2))
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$2$2$2) {
        var x$2$2 = $as_Lamf_core_annotations_DomainExtensionAnnotation(x$2$2$2);
        return x$2$2.extension$1
      })
    })(this));
    var this$4 = $m_sc_Seq$();
    return new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter().init___T__Lamf_core_parser_FieldEntry__sc_Seq__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(key, f, $as_sc_Seq(extensions.map__F1__scg_CanBuildFrom__O(jsx$2, this$4.ReusableCBFInstance$2)), mediaType, spec)
  } else {
    return new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(key, f, mediaType)
  }
});
var $d_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.raml.RamlScalarEmitter$", {
  Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$;
var $n_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$ = (void 0);
function $m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$() {
  if ((!$n_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$)) {
    $n_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$ = new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().init___()
  };
  return $n_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex() {
  $c_O.call(this);
  this.root$1 = null;
  this.refsCounter$1 = null;
  this.ctx$1 = null;
  this.index$1 = null
}
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex.prototype.init__V = (function() {
  var this$1 = this.root$1;
  var evidence$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var x1 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$1, evidence$2);
  if ((x1 instanceof $c_s_util_Right)) {
    var x2 = $as_s_util_Right(x1);
    var value = $as_Lorg_yaml_model_YMap(x2.value$2);
    this.indexMap__p1__Lorg_yaml_model_YMap__V(value)
  }
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex.prototype.index__p1__T__Lorg_yaml_model_YNode__T__s_Option__V = (function(key, node, path, lastId) {
  if (this.refsCounter$1.exceedsThreshold__Lorg_yaml_model_YNode__Z(node)) {
    var this$1 = this.ctx$1;
    var violationId = $m_Lamf_validations_ParserSideValidations$().ExeededMaxYamlReferences$1;
    var node$1 = $as_T((lastId.isEmpty__Z() ? "" : lastId.get__O()));
    var this$2 = this$1.eh$1;
    var location = this$1.rootContextDocument$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__T__V(this$2, violationId, node$1, "Exceeded maximum yaml references threshold", location)
  } else {
    if ((!lastId.isEmpty__Z())) {
      var arg1 = lastId.get__O();
      var li = $as_T(arg1);
      this.index$1.put__O__O__s_Option(((li + "/") + key), node)
    };
    var this$4 = new $c_sci_StringOps().init___T(path);
    if ($f_sc_TraversableOnce__nonEmpty__Z(this$4)) {
      var newPath = ((path + "/") + key)
    } else {
      var newPath = key
    };
    this.index$1.put__O__O__s_Option(newPath, node);
    var x1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x === x1)) {
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = this.ctx$1;
      var m = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv));
      var this$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(m).key__T__s_Option("id");
      var this$8 = (this$6.isEmpty__Z() ? new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(m).key__T__s_Option("$id") : this$6);
      if (this$8.isEmpty__Z()) {
        var idOpt = $m_s_None$()
      } else {
        var arg1$1 = this$8.get__O();
        var x$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
        var this$9 = x$3.value$2.asScalar__s_Option();
        if (this$9.isEmpty__Z()) {
          var idOpt = $m_s_None$()
        } else {
          var arg1$2 = this$9.get__O();
          var x$4 = $as_Lorg_yaml_model_YScalar(arg1$2);
          var idOpt = new $c_s_Some().init___O(x$4.text$3)
        }
      };
      if (idOpt.isEmpty__Z()) {
        var newId$3 = $m_s_None$()
      } else {
        var arg1$3 = idOpt.get__O();
        var newId = $as_T(arg1$3);
        var newId$3 = new $c_s_Some().init___O(((($uI(newId.length) >= 0) && ($as_T(newId.substring(0, $uI("#".length))) === "#")) ? (("" + $as_T((lastId.isEmpty__Z() ? "" : lastId.get__O()))) + newId) : newId))
      };
      if ((!newId$3.isEmpty__Z())) {
        var arg1$4 = newId$3.get__O();
        var x$5 = $as_T(arg1$4);
        this.index$1.put__O__O__s_Option(x$5, node)
      };
      this.indexMap__p1__T__s_Option__Lorg_yaml_model_YMap__V(newPath, newId$3, m)
    } else {
      var x$4$1 = $m_Lorg_yaml_model_YType$().Seq$1;
      if ((x$4$1 === x1)) {
        var conversion$1 = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
        var iv$1 = this.ctx$1;
        var s = $as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$1, iv$1));
        this.indexSequence__p1__T__s_Option__Lorg_yaml_model_YSequence__V(newPath, lastId, s)
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex.prototype.init___Lorg_yaml_model_YNode__Lamf_core_utils_package$AliasCounter__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(root, refsCounter, ctx) {
  this.root$1 = root;
  this.refsCounter$1 = refsCounter;
  this.ctx$1 = ctx;
  this.index$1 = new $c_scm_HashMap().init___();
  this.init__V();
  return this
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex.prototype.indexSequence__p1__T__s_Option__Lorg_yaml_model_YSequence__V = (function(path, lastId, seq) {
  var jsx$1 = seq.nodes$3;
  var this$1 = $m_sc_IndexedSeq$();
  $as_sc_IterableLike(jsx$1.zipWithIndex__scg_CanBuildFrom__O(this$1.ReusableCBF$6)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, path$1, lastId$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var n = $as_Lorg_yaml_model_YNode(x0$1.$$und1__O());
        var i = x0$1.$$und2$mcI$sp__I();
        $this.index__p1__T__Lorg_yaml_model_YNode__T__s_Option__V(("" + i), n, path$1, lastId$1)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, path, lastId)))
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex.prototype.indexMap__p1__Lorg_yaml_model_YMap__V = (function(m) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(m).key__T__s_Option("id");
  var this$4 = (this$2.isEmpty__Z() ? new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(m).key__T__s_Option("$id") : this$2);
  if (this$4.isEmpty__Z()) {
    var idOpt = $m_s_None$()
  } else {
    var arg1 = this$4.get__O();
    var x$1 = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$5 = x$1.value$2.asScalar__s_Option();
    if (this$5.isEmpty__Z()) {
      var idOpt = $m_s_None$()
    } else {
      var arg1$1 = this$5.get__O();
      var x$2 = $as_Lorg_yaml_model_YScalar(arg1$1);
      var idOpt = new $c_s_Some().init___O(x$2.text$3)
    }
  };
  if ((!idOpt.isEmpty__Z())) {
    var arg1$2 = idOpt.get__O();
    var id = $as_T(arg1$2);
    this.index$1.put__O__O__s_Option(id, ($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(m, $m_Lorg_yaml_model_YType$().Map$1)))
  };
  this.index$1.put__O__O__s_Option("/", ($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(m, $m_Lorg_yaml_model_YType$().Map$1)));
  $as_sc_IterableLike(m.entries$3.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
    return (function(e$2) {
      var e = $as_Lorg_yaml_model_YMapEntry(e$2);
      var this$10 = e.value$2.asScalar__s_Option();
      if ((!this$10.isEmpty__Z())) {
        var arg1$3 = this$10.get__O();
        var p = $as_Lorg_yaml_model_YScalar(arg1$3);
        var jsx$1 = ((p.text$3 === "id") || (p.text$3 === "$id"))
      } else {
        var jsx$1 = false
      };
      return (!jsx$1)
    })
  })(this)))).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1, idOpt$1) {
    return (function(e$3$2) {
      var e$3 = $as_Lorg_yaml_model_YMapEntry(e$3$2);
      var this$11 = e$3.key$2;
      var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv = this$5$1.ctx$1;
      this$5$1.index__p1__T__Lorg_yaml_model_YNode__T__s_Option__V($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$11, conversion, iv)).text$3, e$3.value$2, "", idOpt$1)
    })
  })(this, idOpt)))
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex.prototype.indexMap__p1__T__s_Option__Lorg_yaml_model_YMap__V = (function(path, lastId, map) {
  $as_sc_IterableLike(map.entries$3.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(e$2) {
      var e = $as_Lorg_yaml_model_YMapEntry(e$2);
      var this$1 = e.value$2.asScalar__s_Option();
      if ((!this$1.isEmpty__Z())) {
        var arg1 = this$1.get__O();
        var p = $as_Lorg_yaml_model_YScalar(arg1);
        var jsx$1 = ((p.text$3 === "id") || (p.text$3 === "$id"))
      } else {
        var jsx$1 = false
      };
      return (!jsx$1)
    })
  })(this)))).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, path$1, lastId$1) {
    return (function(e$3$2) {
      var e$3 = $as_Lorg_yaml_model_YMapEntry(e$3$2);
      var this$3 = e$3.key$2;
      var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv = this$2.ctx$1;
      this$2.index__p1__T__Lorg_yaml_model_YNode__T__s_Option__V($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv)).text$3, e$3.value$2, path$1, lastId$1)
    })
  })(this, path, lastId)))
});
function $as_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.parser.oas.JsonSchemaAstIndex"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.parser.oas.JsonSchemaAstIndex;", depth))
}
var $d_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex: 0
}, false, "amf.plugins.document.webapi.contexts.parser.oas.JsonSchemaAstIndex", {
  Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex$.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex$.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex$.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex$.prototype.apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex = (function(root, ctx) {
  var jsx$1 = $m_Lamf_core_utils_package$AliasCounter$();
  var this$1 = ctx.options$2;
  return new $c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex().init___Lorg_yaml_model_YNode__Lamf_core_utils_package$AliasCounter__Lamf_plugins_document_webapi_contexts_WebApiContext(root, jsx$1.apply__s_Option__Lamf_core_utils_package$AliasCounter(this$1.maxYamlReferences$1), ctx)
});
var $d_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex$: 0
}, false, "amf.plugins.document.webapi.contexts.parser.oas.JsonSchemaAstIndex$", {
  Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex$.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex$;
var $n_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex$ = (void 0);
function $m_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex$() {
  if ((!$n_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex$)) {
    $n_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex$ = new $c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex$().init___()
  };
  return $n_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_AsyncHeader() {
  $c_O.call(this);
  this.key$1 = null;
  this.value$1 = null
}
$c_Lamf_plugins_document_webapi_parser_AsyncHeader.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_AsyncHeader.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_AsyncHeader;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_AsyncHeader() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_AsyncHeader.prototype = $c_Lamf_plugins_document_webapi_parser_AsyncHeader.prototype;
$c_Lamf_plugins_document_webapi_parser_AsyncHeader.prototype.init___T__T = (function(key, value) {
  this.key$1 = key;
  this.value$1 = value;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_AsyncHeader(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_AsyncHeader) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.AsyncHeader"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_AsyncHeader(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_AsyncHeader)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_AsyncHeader(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_AsyncHeader(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.AsyncHeader;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_AsyncHeader$() {
  $c_O.call(this);
  this.async$1 = null
}
$c_Lamf_plugins_document_webapi_parser_AsyncHeader$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_AsyncHeader$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_AsyncHeader$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_AsyncHeader$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_AsyncHeader$.prototype = $c_Lamf_plugins_document_webapi_parser_AsyncHeader$.prototype;
$c_Lamf_plugins_document_webapi_parser_AsyncHeader$.prototype.init___ = (function() {
  this.async$1 = "asyncapi";
  return this
});
$c_Lamf_plugins_document_webapi_parser_AsyncHeader$.prototype.apply__T__s_Option = (function(text) {
  return (($m_Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$().value$1 === text) ? new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$()) : $m_s_None$())
});
$c_Lamf_plugins_document_webapi_parser_AsyncHeader$.prototype.apply__Lamf_core_Root__s_Option = (function(root) {
  var x1 = root.parsed$1;
  if ((x1 instanceof $c_Lamf_core_parser_SyamlParsedDocument)) {
    var x2 = $as_Lamf_core_parser_SyamlParsedDocument(x1);
    var this$1 = x2.document$2;
    var evidence$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var x1$2 = this$1.obj__Lorg_yaml_model_YObj().to__Lorg_yaml_convert_YRead__s_util_Either(evidence$1);
    if ((x1$2 instanceof $c_s_util_Right)) {
      var x2$2 = $as_s_util_Right(x1$2);
      var map = $as_Lorg_yaml_model_YMap(x2$2.value$2);
      var this$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(this.async$1);
      if (this$3.isEmpty__Z()) {
        return $m_s_None$()
      } else {
        var arg1 = this$3.get__O();
        var extension = $as_Lorg_yaml_model_YMapEntry(arg1);
        var jsx$1 = $m_Lamf_plugins_document_webapi_parser_AsyncHeader$();
        var node = extension.value$2;
        var this$5 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$StringYRead$());
        return jsx$1.apply__T__s_Option($as_T((this$5.isEmpty__Z() ? "" : this$5.get__O())))
      }
    } else if ((x1$2 instanceof $c_s_util_Left)) {
      return $m_s_None$()
    } else {
      throw new $c_s_MatchError().init___O(x1$2)
    }
  } else {
    return $m_s_None$()
  }
});
var $d_Lamf_plugins_document_webapi_parser_AsyncHeader$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_AsyncHeader$: 0
}, false, "amf.plugins.document.webapi.parser.AsyncHeader$", {
  Lamf_plugins_document_webapi_parser_AsyncHeader$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_AsyncHeader$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_AsyncHeader$;
var $n_Lamf_plugins_document_webapi_parser_AsyncHeader$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_AsyncHeader$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_AsyncHeader$)) {
    $n_Lamf_plugins_document_webapi_parser_AsyncHeader$ = new $c_Lamf_plugins_document_webapi_parser_AsyncHeader$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_AsyncHeader$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_OasHeader() {
  $c_O.call(this);
  this.key$1 = null;
  this.value$1 = null
}
$c_Lamf_plugins_document_webapi_parser_OasHeader.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_OasHeader.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_OasHeader;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_OasHeader() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_OasHeader.prototype = $c_Lamf_plugins_document_webapi_parser_OasHeader.prototype;
$c_Lamf_plugins_document_webapi_parser_OasHeader.prototype.init___T__T = (function(key, value) {
  this.key$1 = key;
  this.value$1 = value;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_OasHeader(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_OasHeader) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.OasHeader"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_OasHeader(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_OasHeader)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_OasHeader(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_OasHeader(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.OasHeader;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_OasHeader$() {
  $c_O.call(this);
  this.extensionName$1 = null;
  this.extensionType$1 = null;
  this.swagger$1 = null;
  this.openapi$1 = null
}
$c_Lamf_plugins_document_webapi_parser_OasHeader$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_OasHeader$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_OasHeader$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_OasHeader$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_OasHeader$.prototype = $c_Lamf_plugins_document_webapi_parser_OasHeader$.prototype;
$c_Lamf_plugins_document_webapi_parser_OasHeader$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_parser_OasHeader$ = this;
  this.extensionName$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T("fragmentType").asOasExtension__T();
  this.extensionType$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T("extensionType").asOasExtension__T();
  this.swagger$1 = "swagger";
  this.openapi$1 = "openapi";
  return this
});
$c_Lamf_plugins_document_webapi_parser_OasHeader$.prototype.apply__T__s_Option = (function(text) {
  var x = $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$().value$1;
  var this$2 = new $c_sci_StringOps().init___T(x);
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  var oas30 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  if (($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$().value$1 === text)) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$())
  };
  var o18 = oas30.unapplySeq__jl_CharSequence__s_Option(text);
  if ((!o18.isEmpty__Z())) {
    if ((o18.get__O() !== null)) {
      var this$4 = $as_sc_LinearSeqOptimized(o18.get__O());
      var jsx$1 = ($f_sc_LinearSeqOptimized__lengthCompare__I__I(this$4, 0) === 0)
    } else {
      var jsx$1 = false
    }
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$())
  };
  if (($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$().value$1 === text)) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$())
  };
  if (($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$().value$1 === text)) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$())
  };
  if (($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$().value$1 === text)) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$())
  };
  if (($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$().value$1 === text)) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$())
  };
  if (($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$().value$1 === text)) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$())
  };
  if (($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$().value$1 === text)) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$())
  };
  if (($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$().value$1 === text)) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$())
  };
  if (($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$().value$1 === text)) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$())
  };
  if (($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$().value$1 === text)) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$())
  };
  return $m_s_None$()
});
$c_Lamf_plugins_document_webapi_parser_OasHeader$.prototype.apply__Lamf_core_Root__s_Option = (function(root) {
  var x1 = root.parsed$1;
  if ((x1 instanceof $c_Lamf_core_parser_SyamlParsedDocument)) {
    var x2 = $as_Lamf_core_parser_SyamlParsedDocument(x1);
    var this$1 = x2.document$2;
    var evidence$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var x1$2 = this$1.obj__Lorg_yaml_model_YObj().to__Lorg_yaml_convert_YRead__s_util_Either(evidence$1);
    if ((x1$2 instanceof $c_s_util_Right)) {
      var x2$2 = $as_s_util_Right(x1$2);
      var map = $as_Lorg_yaml_model_YMap(x2$2.value$2);
      var this$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(this.extensionName$1);
      var this$5 = (this$3.isEmpty__Z() ? new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option($m_Lamf_plugins_document_webapi_parser_OasHeader$().extensionType$1) : this$3);
      var this$7 = (this$5.isEmpty__Z() ? new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option($m_Lamf_plugins_document_webapi_parser_OasHeader$().swagger$1) : this$5);
      var this$9 = (this$7.isEmpty__Z() ? new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option($m_Lamf_plugins_document_webapi_parser_OasHeader$().openapi$1) : this$7);
      if (this$9.isEmpty__Z()) {
        return $m_s_None$()
      } else {
        var arg1 = this$9.get__O();
        var extension = $as_Lorg_yaml_model_YMapEntry(arg1);
        var jsx$1 = $m_Lamf_plugins_document_webapi_parser_OasHeader$();
        var node = extension.value$2;
        var this$11 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$StringYRead$());
        return jsx$1.apply__T__s_Option($as_T((this$11.isEmpty__Z() ? "" : this$11.get__O())))
      }
    } else if ((x1$2 instanceof $c_s_util_Left)) {
      return $m_s_None$()
    } else {
      throw new $c_s_MatchError().init___O(x1$2)
    }
  } else {
    return $m_s_None$()
  }
});
var $d_Lamf_plugins_document_webapi_parser_OasHeader$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_OasHeader$: 0
}, false, "amf.plugins.document.webapi.parser.OasHeader$", {
  Lamf_plugins_document_webapi_parser_OasHeader$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_OasHeader$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_OasHeader$;
var $n_Lamf_plugins_document_webapi_parser_OasHeader$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_OasHeader$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_OasHeader$)) {
    $n_Lamf_plugins_document_webapi_parser_OasHeader$ = new $c_Lamf_plugins_document_webapi_parser_OasHeader$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_OasHeader$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$() {
  $c_O.call(this);
  this.knownFormats$1 = null
}
$c_Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$.prototype = $c_Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$.prototype;
$c_Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$ = this;
  var array = ["time-only", "date-only", "date-time", "date-time-only", "password", "byte", "binary", "int32", "int64", "long", "float"];
  if (($uI(array.length) === 0)) {
    var jsx$1 = $m_sci_Set$EmptySet$()
  } else {
    var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      b.$$plus$eq__O__scm_SetBuilder(arg1);
      i = ((1 + i) | 0)
    };
    var jsx$1 = b.elems$1
  };
  this.knownFormats$1 = $as_sci_Set(jsx$1);
  return this
});
$c_Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$.prototype.matchType__T__T__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_domain_shapes_models_TypeDef = (function(ramlType, format, $default) {
  return ((ramlType === "string") ? ((format === "time-only") ? $m_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$() : ((format === "date") ? $m_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$() : ((format === "date-only") ? $m_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$() : ((format === "date-time") ? $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$() : ((format === "date-time-only") ? $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$() : ((format === "password") ? $m_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$() : ((format === "byte") ? $m_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$() : ((format === "binary") ? $m_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$() : $m_Lamf_plugins_domain_shapes_models_TypeDef$StrType$())))))))) : ((ramlType === "null") ? $m_Lamf_plugins_domain_shapes_models_TypeDef$NilType$() : ((ramlType === "integer") ? ((format === "int64") ? $m_Lamf_plugins_domain_shapes_models_TypeDef$LongType$() : $m_Lamf_plugins_domain_shapes_models_TypeDef$IntType$()) : ((ramlType === "number") ? ((format === "float") ? $m_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$() : ((format === "double") ? $m_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$() : $m_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$())) : ((ramlType === "boolean") ? $m_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$() : ((ramlType === "object") ? $m_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$() : ((ramlType === "array") ? $m_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$() : ((ramlType === "file") ? $m_Lamf_plugins_domain_shapes_models_TypeDef$FileType$() : $default))))))))
});
var $d_Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$: 0
}, false, "amf.plugins.document.webapi.parser.OasTypeDefMatcher$", {
  Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$;
var $n_Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$)) {
    $n_Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$ = new $c_Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_PayloadParser() {
  $c_O.call(this);
  this.document$1 = null;
  this.location$1 = null;
  this.mediaType$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_PayloadParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_PayloadParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_PayloadParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_PayloadParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_PayloadParser.prototype = $c_Lamf_plugins_document_webapi_parser_PayloadParser.prototype;
$c_Lamf_plugins_document_webapi_parser_PayloadParser.prototype.parseUnit__Lamf_core_model_document_PayloadFragment = (function() {
  var payload = this.parseNode__p1__T__Lorg_yaml_model_YNode__Lamf_core_model_domain_DataNode(this.location$1, this.document$1.node$2);
  var qual$1 = $m_Lamf_core_model_document_PayloadFragment$().apply__Lamf_core_model_domain_DataNode__T__Lamf_core_model_document_PayloadFragment(payload, this.mediaType$1);
  var x$1 = this.location$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var parsedDocument = $as_Lamf_core_model_document_PayloadFragment($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
  return parsedDocument
});
$c_Lamf_plugins_document_webapi_parser_PayloadParser.prototype.init___Lorg_yaml_model_YDocument__T__T__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(document, location, mediaType, ctx) {
  this.document$1 = document;
  this.location$1 = location;
  this.mediaType$1 = mediaType;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_PayloadParser.prototype.parseNode__p1__T__Lorg_yaml_model_YNode__Lamf_core_model_domain_DataNode = (function(parent, node) {
  var x$2 = new $c_s_Some().init___O(parent);
  var x$3 = new $c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables().init___();
  return $m_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser(node, x$3, x$2, this.ctx$1).parse__Lamf_core_model_domain_DataNode()
});
var $d_Lamf_plugins_document_webapi_parser_PayloadParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_PayloadParser: 0
}, false, "amf.plugins.document.webapi.parser.PayloadParser", {
  Lamf_plugins_document_webapi_parser_PayloadParser: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_PayloadParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_PayloadParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$.prototype = $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$.prototype;
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$.prototype.fromText__p1__T__s_Option = (function(text) {
  var this$1 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$().asRegExp__s_util_matching_Regex().pattern$1;
  if (new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$1, text, 0, $uI(text.length)).matches__Z()) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$())
  } else {
    var this$3 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$().asRegExp__s_util_matching_Regex().pattern$1;
    if (new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$3, text, 0, $uI(text.length)).matches__Z()) {
      return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$())
    } else {
      var this$5 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$().asRegExp__s_util_matching_Regex().pattern$1;
      if (new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$5, text, 0, $uI(text.length)).matches__Z()) {
        return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$())
      } else {
        var this$7 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$().asRegExp__s_util_matching_Regex().pattern$1;
        if (new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$7, text, 0, $uI(text.length)).matches__Z()) {
          return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$())
        } else {
          var this$9 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$().asRegExp__s_util_matching_Regex().pattern$1;
          if (new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$9, text, 0, $uI(text.length)).matches__Z()) {
            return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$())
          } else {
            var this$11 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$().asRegExp__s_util_matching_Regex().pattern$1;
            if (new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$11, text, 0, $uI(text.length)).matches__Z()) {
              return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$())
            } else {
              var this$13 = $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$().asRegExp__s_util_matching_Regex().pattern$1;
              if (new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$13, text, 0, $uI(text.length)).matches__Z()) {
                return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$())
              } else {
                var this$15 = $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$().asRegExp__s_util_matching_Regex().pattern$1;
                if (new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$15, text, 0, $uI(text.length)).matches__Z()) {
                  return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$())
                } else {
                  var this$17 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$().asRegExp__s_util_matching_Regex().pattern$1;
                  if (new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$17, text, 0, $uI(text.length)).matches__Z()) {
                    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$())
                  } else {
                    var this$19 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$().asRegExp__s_util_matching_Regex().pattern$1;
                    if (new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$19, text, 0, $uI(text.length)).matches__Z()) {
                      return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$())
                    } else {
                      return $m_s_None$()
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$.prototype.fromRoot__Lamf_core_Root__s_Option = (function(root) {
  var x1 = root.parsed$1;
  if ((x1 instanceof $c_Lamf_core_parser_SyamlParsedDocument)) {
    var x2 = $as_Lamf_core_parser_SyamlParsedDocument(x1);
    var this$1 = x2.comment$2;
    if (this$1.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1 = this$1.get__O();
      var text = $as_T(arg1);
      return $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$().fromText__p1__T__s_Option(text)
    }
  } else {
    return $m_s_None$()
  }
});
var $d_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_RamlFragmentHeader$: 0
}, false, "amf.plugins.document.webapi.parser.RamlFragmentHeader$", {
  Lamf_plugins_document_webapi_parser_RamlFragmentHeader$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$;
var $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$)) {
    $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$ = new $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$.prototype = $c_Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$.prototype;
$c_Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$.prototype.beautify__T__T = (function(shape) {
  return ((shape === "annotation") ? "annotation" : ((shape === "anyShape") ? "any" : ((shape === "arrayShape") ? "array" : ((shape === "dateScalarShape") ? "date" : ((shape === "unresolvedShape") ? "unresolved" : ((shape === "endPoint") ? "endpoint" : ((shape === "example") ? "example" : ((shape === "fileShape") ? "file" : ((shape === "module") ? "library" : ((shape === "nodeShape") ? "object" : ((shape === "numberScalarShape") ? "number" : ((shape === "operation") ? "operation" : ((shape === "resourceType") ? "resource type" : ((shape === "response") ? "response" : ((shape === "schemaShape") ? "schema" : ((shape === "securitySchema") ? "security schema" : ((shape === "shape") ? "shape" : ((shape === "stringScalarShape") ? "string" : ((shape === "trait") ? "trait" : ((shape === "unionShape") ? "union" : ((shape === "userDocumentation") ? "documentation" : ((shape === "webApi") ? "root" : ((shape === "xmlSerialization") ? "xml" : shape)))))))))))))))))))))))
});
var $d_Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$: 0
}, false, "amf.plugins.document.webapi.parser.RamlShapeTypeBeautifier$", {
  Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$;
var $n_Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$)) {
    $n_Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$ = new $c_Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$() {
  $c_O.call(this);
  this.knownFormats$1 = null
}
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$.prototype = $c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$.prototype;
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$ = this;
  var array = ["byte", "binary", "password", "int", "int8", "int16", "int32", "int64", "long", "double", "float"];
  if (($uI(array.length) === 0)) {
    var jsx$1 = $m_sci_Set$EmptySet$()
  } else {
    var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      b.$$plus$eq__O__scm_SetBuilder(arg1);
      i = ((1 + i) | 0)
    };
    var jsx$1 = b.elems$1
  };
  this.knownFormats$1 = $as_sci_Set(jsx$1);
  return this
});
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$.prototype.matchType__Lamf_plugins_document_webapi_parser_TypeName__Lamf_plugins_domain_shapes_models_TypeDef__Z__Lamf_plugins_domain_shapes_models_TypeDef = (function(typeName, $default, isRef) {
  if ((typeName === null)) {
    throw new $c_s_MatchError().init___O(typeName)
  };
  var ramlType = typeName.typeDef$1;
  var format = typeName.format$1;
  var o28 = $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$().unapply__T__s_Option(ramlType);
  if (((!o28.isEmpty__Z()) && (!isRef))) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$()
  };
  var o30 = $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$().unapply__T__s_Option(ramlType);
  if (((!o30.isEmpty__Z()) && (!isRef))) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$()
  };
  var o32 = $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$().unapply__T__s_Option(ramlType);
  if (((!o32.isEmpty__Z()) && (!isRef))) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$()
  };
  if (((ramlType === "nil") || ((ramlType === "") || (ramlType === "null")))) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$NilType$()
  };
  if ((ramlType === "any")) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$()
  };
  if ((ramlType === "string")) {
    var rc12 = false;
    var x2 = null;
    if ((format instanceof $c_s_Some)) {
      rc12 = true;
      x2 = $as_s_Some(format);
      var p3 = $as_T(x2.value$2);
      if ((p3 === "byte")) {
        return $m_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$()
      }
    };
    if (rc12) {
      var p5 = $as_T(x2.value$2);
      if ((p5 === "binary")) {
        return $m_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$()
      }
    };
    if (rc12) {
      var p7 = $as_T(x2.value$2);
      if ((p7 === "password")) {
        return $m_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$()
      }
    };
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$StrType$()
  };
  if ((ramlType === "number")) {
    var rc27 = false;
    var x2$2 = null;
    if ((format instanceof $c_s_Some)) {
      rc27 = true;
      x2$2 = $as_s_Some(format);
      var p3$2 = $as_T(x2$2.value$2);
      if ((p3$2 === "int")) {
        return $m_Lamf_plugins_domain_shapes_models_TypeDef$IntType$()
      }
    };
    if (rc27) {
      var p5$2 = $as_T(x2$2.value$2);
      if ((p5$2 === "int8")) {
        return $m_Lamf_plugins_domain_shapes_models_TypeDef$IntType$()
      }
    };
    if (rc27) {
      var p7$2 = $as_T(x2$2.value$2);
      if ((p7$2 === "int16")) {
        return $m_Lamf_plugins_domain_shapes_models_TypeDef$IntType$()
      }
    };
    if (rc27) {
      var p9 = $as_T(x2$2.value$2);
      if ((p9 === "int32")) {
        return $m_Lamf_plugins_domain_shapes_models_TypeDef$IntType$()
      }
    };
    if (rc27) {
      var p11 = $as_T(x2$2.value$2);
      if ((p11 === "int64")) {
        return $m_Lamf_plugins_domain_shapes_models_TypeDef$LongType$()
      }
    };
    if (rc27) {
      var p13 = $as_T(x2$2.value$2);
      if ((p13 === "long")) {
        return $m_Lamf_plugins_domain_shapes_models_TypeDef$LongType$()
      }
    };
    if (rc27) {
      var p15 = $as_T(x2$2.value$2);
      if ((p15 === "float")) {
        return $m_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$()
      }
    };
    if (rc27) {
      var p17 = $as_T(x2$2.value$2);
      if ((p17 === "double")) {
        return $m_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$()
      }
    };
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$()
  };
  if ((ramlType === "integer")) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$IntType$()
  };
  if ((ramlType === "boolean")) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$()
  };
  if ((ramlType === "datetime")) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$()
  };
  if ((ramlType === "datetime-only")) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$()
  };
  if ((ramlType === "time-only")) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$()
  };
  if ((ramlType === "date-only")) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$()
  };
  if ((ramlType === "array")) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$()
  };
  if ((ramlType === "object")) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$()
  };
  if ((ramlType === "union")) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$()
  };
  if ((ramlType === "file")) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$FileType$()
  };
  return $default
});
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$.prototype.match08Type__T__s_Option = (function(value) {
  return ((value === "number") ? new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$()) : ((value === "integer") ? new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$IntType$()) : ((value === "date") ? new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$()) : ((value === "boolean") ? new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$()) : ((value === "file") ? new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$FileType$()) : ((value === "string") ? new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$StrType$()) : $m_s_None$()))))))
});
var $d_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$: 0
}, false, "amf.plugins.document.webapi.parser.RamlTypeDefMatcher$", {
  Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$;
var $n_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$)) {
    $n_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$ = new $c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$.prototype = $c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$.prototype;
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$.prototype.unapply__T__s_Option = (function(str) {
  $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$();
  var s = $as_T(str.trim());
  var trimed = $m_sjsr_RuntimeString$().replaceAll__T__T__T__T(s, "^(\\s+|[\ufeff-\uffff])", "");
  return (((($uI(trimed.length) >= 0) && ($as_T(trimed.substring(0, $uI("[".length))) === "[")) || (($uI(trimed.length) >= 0) && ($as_T(trimed.substring(0, $uI("{".length))) === "{"))) ? new $c_s_Some().init___O(str) : $m_s_None$())
});
var $d_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$: 0
}, false, "amf.plugins.document.webapi.parser.RamlTypeDefMatcher$JSONSchema$", {
  Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$;
var $n_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$)) {
    $n_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$ = new $c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$.prototype = $c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$.prototype;
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$.prototype.unapply__T__s_Option = (function(str) {
  $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$();
  var s = $as_T(str.trim());
  var trimed = $m_sjsr_RuntimeString$().replaceAll__T__T__T__T(s, "^(\\s+|[\ufeff-\uffff])", "");
  return ((((((($uI(trimed.indexOf("[]")) !== (-1)) && (!(($uI(trimed.length) >= 0) && ($as_T(trimed.substring(0, $uI("[".length))) === "[")))) && $m_sjsr_RuntimeString$().endsWith__T__T__Z(trimed, "]")) || ($uI(trimed.indexOf("|")) !== (-1))) || ($uI(trimed.indexOf("(")) !== (-1))) || ($uI(trimed.indexOf(")")) !== (-1))) ? new $c_s_Some().init___O(str) : $m_s_None$())
});
var $d_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$: 0
}, false, "amf.plugins.document.webapi.parser.RamlTypeDefMatcher$TypeExpression$", {
  Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$;
var $n_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$)) {
    $n_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$ = new $c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$.prototype = $c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$.prototype;
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$.prototype.unapply__T__s_Option = (function(str) {
  $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$();
  var trimed = $m_sjsr_RuntimeString$().replaceAll__T__T__T__T(str, "^(\\s+|[\ufeff-\uffff])", "");
  return (((($uI(trimed.length) >= 0) && ($as_T(trimed.substring(0, $uI("<".length))) === "<")) && (!((($uI(trimed.length) >= 0) && ($as_T(trimed.substring(0, $uI("<<".length))) === "<<")) && $m_sjsr_RuntimeString$().endsWith__T__T__Z(trimed, ">>")))) ? new $c_s_Some().init___O(str) : $m_s_None$())
});
var $d_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$: 0
}, false, "amf.plugins.document.webapi.parser.RamlTypeDefMatcher$XMLSchema$", {
  Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$;
var $n_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$)) {
    $n_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$ = new $c_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$.prototype = $c_Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$.prototype;
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$.prototype.matchType__Lamf_plugins_domain_shapes_models_TypeDef__s_Option__Lamf_plugins_document_webapi_parser_TypeName = (function(typeDef, format) {
  var x = $m_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$();
  if ((x === typeDef)) {
    return $m_Lamf_plugins_document_webapi_parser_TypeName$().apply__T__T__Lamf_plugins_document_webapi_parser_TypeName("string", "byte")
  } else {
    var x$3 = $m_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$();
    if ((x$3 === typeDef)) {
      return $m_Lamf_plugins_document_webapi_parser_TypeName$().apply__T__T__Lamf_plugins_document_webapi_parser_TypeName("string", "binary")
    } else {
      var x$5 = $m_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$();
      if ((x$5 === typeDef)) {
        return $m_Lamf_plugins_document_webapi_parser_TypeName$().apply__T__T__Lamf_plugins_document_webapi_parser_TypeName("string", "password")
      } else {
        var x$7 = $m_Lamf_plugins_domain_shapes_models_TypeDef$StrType$();
        if ((x$7 === typeDef)) {
          return new $c_Lamf_plugins_document_webapi_parser_TypeName().init___T__s_Option("string", $m_s_None$())
        } else {
          var x$9 = $m_Lamf_plugins_domain_shapes_models_TypeDef$IntType$();
          if ((x$9 === typeDef)) {
            var rc15 = false;
            var x2 = null;
            if ((format instanceof $c_s_Some)) {
              rc15 = true;
              x2 = $as_s_Some(format);
              var p3 = $as_T(x2.value$2);
              if ((p3 === "int")) {
                return $m_Lamf_plugins_document_webapi_parser_TypeName$().apply__T__T__Lamf_plugins_document_webapi_parser_TypeName("number", "int")
              }
            };
            if (rc15) {
              var p5 = $as_T(x2.value$2);
              if ((p5 === "int8")) {
                return $m_Lamf_plugins_document_webapi_parser_TypeName$().apply__T__T__Lamf_plugins_document_webapi_parser_TypeName("number", "int8")
              }
            };
            if (rc15) {
              var p7 = $as_T(x2.value$2);
              if ((p7 === "int16")) {
                return $m_Lamf_plugins_document_webapi_parser_TypeName$().apply__T__T__Lamf_plugins_document_webapi_parser_TypeName("number", "int16")
              }
            };
            if (rc15) {
              var p9 = $as_T(x2.value$2);
              if ((p9 === "int32")) {
                return $m_Lamf_plugins_document_webapi_parser_TypeName$().apply__T__T__Lamf_plugins_document_webapi_parser_TypeName("number", "int32")
              }
            };
            return new $c_Lamf_plugins_document_webapi_parser_TypeName().init___T__s_Option("integer", $m_s_None$())
          } else {
            var x$11 = $m_Lamf_plugins_domain_shapes_models_TypeDef$LongType$();
            if ((x$11 === typeDef)) {
              var rc9 = false;
              var x2$2 = null;
              if ((format instanceof $c_s_Some)) {
                rc9 = true;
                x2$2 = $as_s_Some(format);
                var p3$2 = $as_T(x2$2.value$2);
                if ((p3$2 === "int64")) {
                  return $m_Lamf_plugins_document_webapi_parser_TypeName$().apply__T__T__Lamf_plugins_document_webapi_parser_TypeName("number", "int64")
                }
              };
              if (rc9) {
                var p5$2 = $as_T(x2$2.value$2);
                if ((p5$2 === "long")) {
                  return $m_Lamf_plugins_document_webapi_parser_TypeName$().apply__T__T__Lamf_plugins_document_webapi_parser_TypeName("number", "long")
                }
              };
              return $m_Lamf_plugins_document_webapi_parser_TypeName$().apply__T__T__Lamf_plugins_document_webapi_parser_TypeName("integer", "long")
            } else {
              var x$13 = $m_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$();
              if ((x$13 === typeDef)) {
                return $m_Lamf_plugins_document_webapi_parser_TypeName$().apply__T__T__Lamf_plugins_document_webapi_parser_TypeName("number", "float")
              } else {
                var x$15 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$();
                if ((x$15 === typeDef)) {
                  return $m_Lamf_plugins_document_webapi_parser_TypeName$().apply__T__T__Lamf_plugins_document_webapi_parser_TypeName("number", "double")
                } else {
                  var x$17 = $m_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$();
                  if ((x$17 === typeDef)) {
                    return new $c_Lamf_plugins_document_webapi_parser_TypeName().init___T__s_Option("boolean", $m_s_None$())
                  } else {
                    var x$19 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$();
                    if ((x$19 === typeDef)) {
                      return new $c_Lamf_plugins_document_webapi_parser_TypeName().init___T__s_Option("datetime", $m_s_None$())
                    } else {
                      var x$21 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$();
                      if ((x$21 === typeDef)) {
                        return new $c_Lamf_plugins_document_webapi_parser_TypeName().init___T__s_Option("datetime-only", $m_s_None$())
                      } else {
                        var x$23 = $m_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$();
                        if ((x$23 === typeDef)) {
                          return new $c_Lamf_plugins_document_webapi_parser_TypeName().init___T__s_Option("time-only", $m_s_None$())
                        } else {
                          var x$25 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$();
                          if ((x$25 === typeDef)) {
                            return new $c_Lamf_plugins_document_webapi_parser_TypeName().init___T__s_Option("date-only", $m_s_None$())
                          } else {
                            var x$27 = $m_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$();
                            if ((x$27 === typeDef)) {
                              return new $c_Lamf_plugins_document_webapi_parser_TypeName().init___T__s_Option("array", $m_s_None$())
                            } else {
                              var x$29 = $m_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$();
                              if ((x$29 === typeDef)) {
                                return new $c_Lamf_plugins_document_webapi_parser_TypeName().init___T__s_Option("object", $m_s_None$())
                              } else {
                                var x$31 = $m_Lamf_plugins_domain_shapes_models_TypeDef$FileType$();
                                if ((x$31 === typeDef)) {
                                  return new $c_Lamf_plugins_document_webapi_parser_TypeName().init___T__s_Option("file", $m_s_None$())
                                } else {
                                  var x$33 = $m_Lamf_plugins_domain_shapes_models_TypeDef$NilType$();
                                  if ((x$33 === typeDef)) {
                                    return new $c_Lamf_plugins_document_webapi_parser_TypeName().init___T__s_Option("nil", $m_s_None$())
                                  } else {
                                    var x$35 = $m_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$();
                                    if ((x$35 === typeDef)) {
                                      return new $c_Lamf_plugins_document_webapi_parser_TypeName().init___T__s_Option("number", $m_s_None$())
                                    } else {
                                      var x$37 = $m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$();
                                      if ((x$37 === typeDef)) {
                                        throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_RuntimeException().init___T("Undefined type def"))
                                      } else {
                                        throw new $c_s_MatchError().init___O(typeDef)
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }
});
var $d_Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$: 0
}, false, "amf.plugins.document.webapi.parser.RamlTypeDefStringValueMatcher$", {
  Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$;
var $n_Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$)) {
    $n_Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$ = new $c_Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter() {
  $c_O.call(this);
  this.protocol$1 = null;
  this.domain$1 = null;
  this.path$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter.prototype.init___T__T__T = (function(protocol, domain, path) {
  this.protocol$1 = protocol;
  this.domain$1 = domain;
  this.path$1 = path;
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.BaseUriSplitter", {
  Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter$.prototype.apply__T__Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter = (function(s) {
  var this$1 = $m_s_Option$().apply__O__s_Option(s);
  if (this$1.isEmpty__Z()) {
    return new $c_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter().init___T__T__T("", "", "")
  } else {
    var arg1 = this$1.get__O();
    var s$2 = $as_T(arg1);
    var tail = "";
    var host = "";
    if (($uI(s$2.indexOf("://")) !== (-1))) {
      var splittedOne = $m_sjsr_RuntimeString$().split__T__T__I__AT(s$2, "://", 0);
      var this$7 = new $c_scm_ArrayOps$ofRef().init___AO(splittedOne);
      host = $as_T($f_sc_IndexedSeqOptimized__head__O(this$7));
      tail = splittedOne.get(1)
    } else {
      tail = s$2
    };
    var thiz = tail;
    var firstSlashIndex = $uI(thiz.indexOf("/"));
    var domain = "";
    var path = "";
    if ((firstSlashIndex > (-1))) {
      var thiz$1 = tail;
      domain = $as_T(thiz$1.substring(0, firstSlashIndex));
      var thiz$2 = tail;
      path = $as_T(thiz$2.substring(firstSlashIndex))
    } else {
      domain = tail
    };
    return new $c_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter().init___T__T__T(host, domain, path)
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter$: 0
}, false, "amf.plugins.document.webapi.parser.spec.BaseUriSplitter$", {
  Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter$;
var $n_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter$ = new $c_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations$.prototype.apply__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations = (function(d) {
  var declarations = new $c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations().init___sci_Map__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations($as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())), d.alias__s_Option(), d.errorHandler__Lamf_core_errorhandling_ErrorHandler(), d.futureDeclarations__Lamf_core_parser_FutureDeclarations());
  declarations.libs$2 = d.libs$2;
  declarations.frags$2 = d.frags$2;
  declarations.shapes$2 = d.shapes$2;
  declarations.anns$2 = d.anns$2;
  declarations.resourceTypes$2 = d.resourceTypes$2;
  declarations.parameters$2 = d.parameters$2;
  declarations.payloads$2 = d.payloads$2;
  declarations.traits$2 = d.traits$2;
  declarations.securitySchemes$2 = d.securitySchemes$2;
  declarations.responses$2 = d.responses$2;
  return declarations
});
var $d_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations$: 0
}, false, "amf.plugins.document.webapi.parser.spec.OasWebApiDeclarations$", {
  Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations$;
var $n_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations$ = new $c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$.prototype.apply__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations = (function(d) {
  var declarations = new $c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().init___sci_Map__sci_Map__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations($as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())), d.alias__s_Option(), d.errorHandler__Lamf_core_errorhandling_ErrorHandler(), d.futureDeclarations__Lamf_core_parser_FutureDeclarations());
  declarations.libs$2 = d.libs$2;
  declarations.frags$2 = d.frags$2;
  declarations.shapes$2 = d.shapes$2;
  declarations.anns$2 = d.anns$2;
  declarations.resourceTypes$2 = d.resourceTypes$2;
  declarations.parameters$2 = d.parameters$2;
  declarations.payloads$2 = d.payloads$2;
  declarations.traits$2 = d.traits$2;
  declarations.securitySchemes$2 = d.securitySchemes$2;
  declarations.responses$2 = d.responses$2;
  return declarations
});
var $d_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$: 0
}, false, "amf.plugins.document.webapi.parser.spec.RamlWebApiDeclarations$", {
  Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$;
var $n_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$ = new $c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$.prototype.apply__sc_Seq__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function(declarations, errorHandler, futureDeclarations) {
  var x$1 = $m_s_None$();
  var x$4 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$5 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$6 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$7 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$8 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$9 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$10 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$11 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$12 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$13 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$14 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$15 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$16 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$17 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$18 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$19 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$20 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$21 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$22 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$23 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$24 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$25 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$26 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$27 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var result = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations().init___s_Option__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations__sci_Map(x$1, x$4, x$5, x$6, x$7, x$8, x$9, x$10, x$11, x$12, x$13, x$14, x$15, x$16, x$17, x$18, x$19, x$20, x$21, x$22, x$23, x$24, x$25, x$26, errorHandler, futureDeclarations, x$27);
  declarations.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, result$1) {
    return (function(x$28$2) {
      var x$28 = $as_Lamf_core_model_domain_DomainElement(x$28$2);
      return result$1.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$28)
    })
  })(this, result)));
  return result
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$;
var $n_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter() {
  $c_O.call(this);
  this.WebApiEmitter$module$1 = null;
  this.document$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter.prototype.retrieveWebApi__p1__Lamf_plugins_domain_webapi_models_WebApi = (function() {
  var x1 = this.document$1;
  if ((x1 instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(x1);
    return $as_Lamf_plugins_domain_webapi_models_WebApi(x2.encodes__Lamf_core_model_domain_DomainElement())
  } else {
    var this$3 = this.spec$1.eh$1;
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
    var node = this.document$1.id__T();
    var property = $m_s_None$();
    var this$1 = this.document$1;
    var lexical = this$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var this$2 = this.document$1;
    var location = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$2);
    this$3.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "BaseUnit doesn't encode a WebApi.", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    return new $c_Lamf_plugins_domain_webapi_models_WebApi().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter.prototype.emitWebApi__Lamf_core_emitter_SpecOrdering__sc_Seq = (function(ordering) {
  var model = this.retrieveWebApi__p1__Lamf_plugins_domain_webapi_models_WebApi();
  var this$1 = model.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_SourceVendor.getClassOf());
  if (this$1.isEmpty__Z()) {
    var vendor = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_Lamf_core_annotations_SourceVendor(arg1);
    var vendor = new $c_s_Some().init___O(x$1.vendor$1)
  };
  var api = new $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter().init___Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter__Lamf_plugins_domain_webapi_models_WebApi__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq(this, model, ordering, vendor, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
  return api.emitters$1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter.prototype.wrapDeclarations__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq = (function(emitters, ordering) {
  var jsx$1 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper().init___sc_Seq__Lamf_core_emitter_SpecOrdering(emitters, ordering)];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter.prototype.emitDocument__Lorg_yaml_model_YDocument = (function() {
  var doc = $as_Lamf_core_model_document_Document(this.document$1);
  var ordering = $m_Lamf_core_emitter_SpecOrdering$().ordering__Lamf_core_remote_Vendor__Lamf_core_parser_Annotations__Lamf_core_emitter_SpecOrdering($m_Lamf_core_remote_AsyncApi20$(), doc.encodes__Lamf_core_model_domain_DomainElement().annotations__Lamf_core_parser_Annotations());
  var declares = this.wrapDeclarations__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters().init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext($as_sc_Seq(doc.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().Declares$1)), ordering, this.document$1.references__sc_Seq(), this.spec$1).emitters$1, ordering);
  var api = this.emitWebApi__Lamf_core_emitter_SpecOrdering__sc_Seq(ordering);
  var this$2 = $m_Lorg_yaml_model_YDocument$().apply__T__Lorg_yaml_model_YDocument$WithComment("");
  var b = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(this$2.org$yaml$model$YDocument$WithComment$$sourceName$f);
  var x = this$2.comment$1;
  var this$4 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$4)) {
    b.comment__T__V(this$2.comment$1)
  };
  var jsx$2 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  this.versionEntry__Lorg_yaml_model_YDocument$EntryBuilder__V(b$1);
  var jsx$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$6 = $m_sc_Seq$();
  jsx$1.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(ordering.sorted__sc_Seq__sc_Seq($as_sc_Seq(api.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(declares, this$6.ReusableCBFInstance$2))), b$1);
  jsx$2.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  return new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this$2.org$yaml$model$YDocument$WithComment$$sourceName$f), b.builder$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter.prototype.versionEntry__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  b.updateDynamic__T__Lorg_yaml_model_YNode__V("asyncapi", $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YScalar$().apply__O__Lorg_yaml_model_YScalar("2.0.0"), $m_Lorg_yaml_model_YType$().Str$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterContext = (function(document, spec) {
  this.document$1 = document;
  this.spec$1 = spec;
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.AsyncApi20DocumentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$.prototype.messageType__T__s_Option = (function(messageType) {
  return ((messageType === "publish") ? new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_spec_async_Publish$()) : ((messageType === "subscribe") ? new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$()) : $m_s_None$()))
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.AsyncHelper$", {
  Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$;
var $n_Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$ = new $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySettingsEmitter() {
  $c_O.call(this);
  this.settings$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySettingsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySettingsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySettingsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySettingsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySettingsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySettingsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySettingsEmitter.prototype.emittersFor__p1__Lamf_plugins_domain_webapi_models_security_Settings__sc_Seq = (function(settings) {
  if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_HttpSettings)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_security_HttpSettings(settings);
    var particularEmitters = new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters().init___Lamf_plugins_domain_webapi_models_security_HttpSettings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x2, this.ordering$1, this.spec$1).emitters__sc_Seq()
  } else if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings)) {
    var x3 = $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(settings);
    var particularEmitters = new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters().init___Lamf_plugins_domain_webapi_models_security_ApiKeySettings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x3, this.ordering$1, this.spec$1).emitters__sc_Seq()
  } else if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings)) {
    var x4 = $as_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(settings);
    var particularEmitters = new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters().init___Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x4, this.ordering$1, this.spec$1).emitters__sc_Seq()
  } else if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings)) {
    var x5 = $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(settings);
    var particularEmitters = new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters().init___Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x5, this.ordering$1, this.spec$1).emitters__sc_Seq()
  } else if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings)) {
    var x6 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(settings);
    var particularEmitters = new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters().init___Lamf_plugins_domain_webapi_models_security_OAuth2Settings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x6, this.ordering$1, this.spec$1).emitters__sc_Seq()
  } else {
    var particularEmitters = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
  };
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(settings, this.ordering$1, this.spec$1).emitters__sc_Seq();
  var this$1 = $m_sc_Seq$();
  var result = $as_sc_Seq(particularEmitters.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  return this.ordering$1.sorted__sc_Seq__sc_Seq(result)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySettingsEmitter.prototype.emitters__sc_Seq = (function() {
  return this.emittersFor__p1__Lamf_plugins_domain_webapi_models_security_Settings__sc_Seq(this.settings$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySettingsEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_Settings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(settings, ordering, spec) {
  this.settings$1 = settings;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySettingsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySettingsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncSecuritySettingsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySettingsEmitter: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySettingsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySettingsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser() {
  $c_O.call(this);
  this.entryOrNode$1 = null;
  this.name$1 = null;
  this.map$1 = null;
  this.adopt$1 = null;
  this.version$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser.prototype.parse__s_Option = (function() {
  var x1 = this.version$1;
  return ((x1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion) ? $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$().apply__s_util_Either__T__F1__Z__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(this.entryOrNode$1, this.name$1, this.adopt$1, false, $m_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$(), $m_Lamf_plugins_document_webapi_parser_spec_package$().toRaml__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this.ctx$1)).parse__s_Option() : new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser().init___s_util_Either__T__Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(this.entryOrNode$1, this.name$1, this.map$1, this.adopt$1, this.version$1, this.ctx$1).parse__s_Option())
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser.prototype.init___s_util_Either__T__Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function(entryOrNode, name, map, adopt, version, ctx) {
  this.entryOrNode$1 = entryOrNode;
  this.name$1 = name;
  this.map$1 = map;
  this.adopt$1 = adopt;
  this.version$1 = version;
  this.ctx$1 = ctx;
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncApiTypeParser", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$.prototype.apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser = (function(entry, adopt, version, ctx) {
  $m_s_package$();
  var jsx$2 = new $c_s_util_Left().init___O(entry);
  var this$2 = entry.key$2;
  var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
  var jsx$1 = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, ctx));
  var this$3 = entry.value$2;
  var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  return new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser().init___s_util_Either__T__Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(jsx$2, jsx$1, $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion$1, ctx)), adopt, version, ctx)
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncApiTypeParser$", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$.prototype.apply__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__s_Option__Z__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser = (function(entryLike, parent, messageType, isTrait, ctx) {
  var populator = (isTrait ? new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator().init___Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(ctx) : new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator().init___T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(parent, ctx));
  var finder = (isTrait ? new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder().init___Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(ctx) : new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder().init___Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(ctx));
  return new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser().init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__s_Option__Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator__Lamf_plugins_document_webapi_parser_spec_async_parser_Finder__Z__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(entryLike, parent, messageType, populator, $as_Lamf_plugins_document_webapi_parser_spec_async_parser_Finder(finder), isTrait, ctx)
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncMessageParser$", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$.prototype.apply__Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser = (function(entry, producer, isTrait, ctx) {
  return (isTrait ? new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationTraitParser().init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(entry, producer, ctx) : new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteOperationParser().init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(entry, producer, ctx))
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncOperationParser$", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$() {
  $c_O.call(this);
  this.async20Schema$1 = null;
  this.oas30Schema$1 = null;
  this.draft7JsonSchema$1 = null;
  this.avroSchema$1 = null;
  this.ramlSchema$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$ = this;
  $m_sci_List$();
  var array = ["application/vnd.aai.asyncapi;version=2.0.0", "application/vnd.aai.asyncapi+json;version=2.0.0", "application/vnd.aai.asyncapi+yaml;version=2.0.0"];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  this.async20Schema$1 = result;
  $m_sci_List$();
  var array$1 = ["application/vnd.oai.openapi;version=3.0.0", "application/vnd.oai.openapi+json;version=3.0.0", "application/vnd.oai.openapi+yaml;version=3.0.0"];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$8 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$8);
    i$1 = (((-1) + i$1) | 0)
  };
  this.oas30Schema$1 = result$1;
  $m_sci_List$();
  var array$2 = ["application/schema+json;version=draft-07", "application/schema+yaml;version=draft-07"];
  var i$2 = (((-1) + $uI(array$2.length)) | 0);
  var result$2 = $m_sci_Nil$();
  while ((i$2 >= 0)) {
    var this$12 = result$2;
    var index$2 = i$2;
    var x$2 = array$2[index$2];
    result$2 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$12);
    i$2 = (((-1) + i$2) | 0)
  };
  this.draft7JsonSchema$1 = result$2;
  $m_sci_List$();
  var array$3 = ["application/vnd.apache.avro;version=1.9.0", "application/vnd.apache.avro+json;version=1.9.0", "application/vnd.apache.avro+yaml;version=1.9.0"];
  var i$3 = (((-1) + $uI(array$3.length)) | 0);
  var result$3 = $m_sci_Nil$();
  while ((i$3 >= 0)) {
    var this$16 = result$3;
    var index$3 = i$3;
    var x$3 = array$3[index$3];
    result$3 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$16);
    i$3 = (((-1) + i$3) | 0)
  };
  this.avroSchema$1 = result$3;
  $m_sci_List$();
  var array$4 = ["application/vnd.rai.raml;version=1.0", "application/vnd.rai.raml+json;version=1.0", "application/vnd.rai.raml+yaml;version=1.0", "application/vnd.rai.raml+xml;version=1.0"];
  var i$4 = (((-1) + $uI(array$4.length)) | 0);
  var result$4 = $m_sci_Nil$();
  while ((i$4 >= 0)) {
    var this$20 = result$4;
    var index$4 = i$4;
    var x$4 = array$4[index$4];
    result$4 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$20);
    i$4 = (((-1) + i$4) | 0)
  };
  this.ramlSchema$1 = result$4;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$.prototype.getSchemaVersion__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion = (function(value, errorHandler) {
  var rc5 = false;
  var x2 = null;
  if ((value instanceof $c_s_Some)) {
    rc5 = true;
    x2 = $as_s_Some(value);
    var format = $as_T(x2.value$2);
    var this$1 = this.oas30Schema$1;
    if ($f_sc_LinearSeqOptimized__contains__O__Z(this$1, format)) {
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion().init___T__Lamf_core_errorhandling_ErrorHandler("schema", errorHandler)
    }
  };
  if (rc5) {
    var format$2 = $as_T(x2.value$2);
    var this$3 = this.ramlSchema$1;
    if ($f_sc_LinearSeqOptimized__contains__O__Z(this$3, format$2)) {
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion().init___()
    }
  };
  return $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$()
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$.prototype.getSchemaVersion__Lamf_plugins_domain_webapi_models_Payload__Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion = (function(payload, errorHandler) {
  var this$1 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_StrField(payload.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().SchemaMediaType$1)));
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_model_StrField(arg1);
    var this$2 = f.option$1;
    var this$3 = new $c_s_Some().init___O($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())))
  };
  var value = (this$3.isEmpty__Z() ? $m_s_None$() : this$3);
  return this.getSchemaVersion__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion(value, errorHandler)
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncSchemaFormats$", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$;
var $n_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$ = new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser() {
  $c_O.call(this);
  this.node$1 = null;
  this.refsCounter$1 = null;
  this.parameters$1 = null;
  this.parent$1 = null;
  this.idCounter$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser.prototype.parseObject__Lorg_yaml_model_YMap__Lamf_core_model_domain_DataNode = (function(value) {
  $m_Lamf_core_model_domain_ObjectNode$();
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(value);
  var this$3 = new $c_Lamf_core_model_domain_ObjectNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var name = this.idCounter$1.genId__T__T("object");
  var field = $m_Lamf_core_metamodel_domain_DataNodeModel$().Name$1;
  var node = $as_Lamf_core_model_domain_ObjectNode($as_Lamf_core_model_domain_DataNode($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$3, field, name)));
  var this$4 = this.parent$1;
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var p = $as_T(arg1);
    $as_Lamf_core_model_domain_ObjectNode(node.adopted__T__sc_Seq__Lamf_core_model_domain_DataNode(p, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))))
  };
  var jsx$2 = value.entries$3;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, node$1) {
    return (function(ast$2) {
      var ast = $as_Lorg_yaml_model_YMapEntry(ast$2);
      var this$5 = ast.key$2;
      var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv = this$2$1.ctx$1;
      var key = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv)).text$3;
      this$2$1.parameters$1.parseVariables__T__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables(key);
      var value$1 = ast.value$2;
      var propertyAnnotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
      var propertyNode = new $c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser().init___Lorg_yaml_model_YNode__Lamf_core_utils_package$AliasCounter__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_WebApiContext(value$1, this$2$1.refsCounter$1, this$2$1.parameters$1, new $c_s_Some().init___O(node$1.id$1), this$2$1.idCounter$1, this$2$1.ctx$1).parse__Lamf_core_model_domain_DataNode().forceAdopted__T__Lamf_core_model_domain_DataNode(node$1.id$1);
      return node$1.addProperty__T__Lamf_core_model_domain_DataNode__Lamf_core_parser_Annotations__Lamf_core_model_domain_ObjectNode(key, propertyNode, propertyAnnotations)
    })
  })(this, node));
  var this$6 = $m_sc_IndexedSeq$();
  jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBF$6);
  return node
});
$c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser.prototype.parseArray__sc_Seq__Lorg_yaml_model_YPart__Lamf_core_model_domain_DataNode = (function(seq, ast) {
  $m_Lamf_core_model_domain_ArrayNode$();
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  var this$3 = new $c_Lamf_core_model_domain_ArrayNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var name = this.idCounter$1.genId__T__T("array");
  var field = $m_Lamf_core_metamodel_domain_DataNodeModel$().Name$1;
  var node = $as_Lamf_core_model_domain_ArrayNode($as_Lamf_core_model_domain_DataNode($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$3, field, name)));
  var this$4 = this.parent$1;
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var p = $as_T(arg1);
    $as_Lamf_core_model_domain_ArrayNode(node.adopted__T__sc_Seq__Lamf_core_model_domain_DataNode(p, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))))
  };
  var members = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, members$1, node$1) {
    return (function(v$2) {
      var v = $as_Lorg_yaml_model_YNode(v$2);
      return members$1.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser().init___Lorg_yaml_model_YNode__Lamf_core_utils_package$AliasCounter__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_WebApiContext(v, this$2$1.refsCounter$1, this$2$1.parameters$1, new $c_s_Some().init___O(node$1.id$1), this$2$1.idCounter$1, this$2$1.ctx$1).parse__Lamf_core_model_domain_DataNode().forceAdopted__T__Lamf_core_model_domain_DataNode(node$1.id$1))
    })
  })(this, members, node));
  var this$5 = $m_sc_Seq$();
  seq.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2);
  node.withMembers__sc_Seq__Lamf_core_model_domain_ArrayNode(members);
  return node
});
$c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser.prototype.parse__Lamf_core_model_domain_DataNode = (function() {
  if (this.refsCounter$1.exceedsThreshold__Lorg_yaml_model_YNode__Z(this.node$1)) {
    var this$2 = this.ctx$1;
    var violationId = $m_Lamf_validations_ParserSideValidations$().ExeededMaxYamlReferences$1;
    var this$1 = this.parent$1;
    var node = $as_T((this$1.isEmpty__Z() ? "" : this$1.get__O()));
    var this$3 = this$2.eh$1;
    var location = this$2.rootContextDocument$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__T__V(this$3, violationId, node, "Exceeded maximum yaml references threshold", location);
    $m_Lamf_core_model_domain_ObjectNode$();
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    return new $c_Lamf_core_model_domain_ObjectNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
  } else {
    var x1 = this.node$1.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Seq$1;
    if ((x === x1)) {
      var this$7 = this.node$1;
      var conversion = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
      var iv = this.ctx$1;
      return this.parseArray__sc_Seq__Lorg_yaml_model_YPart__Lamf_core_model_domain_DataNode($as_sc_Seq($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$7, conversion, iv)), this.node$1)
    } else {
      var x$3 = $m_Lorg_yaml_model_YType$().Map$1;
      if ((x$3 === x1)) {
        var this$8 = this.node$1;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv$1 = this.ctx$1;
        return this.parseObject__Lorg_yaml_model_YMap__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$8, conversion$1, iv$1)))
      } else {
        return new $c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser().init___Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_WebApiContext(this.parameters$1, this.parent$1, this.idCounter$1, this.ctx$1).parse__Lorg_yaml_model_YNode__Lamf_core_model_domain_DataNode(this.node$1)
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser.prototype.init___Lorg_yaml_model_YNode__Lamf_core_utils_package$AliasCounter__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(node, refsCounter, parameters, parent, idCounter, ctx) {
  this.node$1 = node;
  this.refsCounter$1 = refsCounter;
  this.parameters$1 = parameters;
  this.parent$1 = parent;
  this.idCounter$1 = idCounter;
  this.ctx$1 = ctx;
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.DataNodeParser", {
  Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$.prototype.apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser = (function(node, parameters, parent, idCounter, ctx) {
  var jsx$1 = $m_Lamf_core_utils_package$AliasCounter$();
  var this$1 = ctx.options$2;
  return new $c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser().init___Lorg_yaml_model_YNode__Lamf_core_utils_package$AliasCounter__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_WebApiContext(node, jsx$1.apply__s_Option__Lamf_core_utils_package$AliasCounter(this$1.maxYamlReferences$1), parameters, parent, idCounter, ctx)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$.prototype.apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser = (function(node, parameters, parent, ctx) {
  var jsx$1 = $m_Lamf_core_utils_package$AliasCounter$();
  var this$1 = ctx.options$2;
  return new $c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser().init___Lorg_yaml_model_YNode__Lamf_core_utils_package$AliasCounter__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_WebApiContext(node, jsx$1.apply__s_Option__Lamf_core_utils_package$AliasCounter(this$1.maxYamlReferences$1), parameters, parent, new $c_Lamf_core_utils_package$IdCounter().init___(), ctx)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$.prototype.parse__s_Option__Lamf_core_utils_package$IdCounter__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_core_model_domain_DataNode = (function(parent, idCounter, node, ctx) {
  var jsx$1 = $m_Lamf_core_utils_package$AliasCounter$();
  var this$1 = ctx.options$2;
  var x$2 = jsx$1.apply__s_Option__Lamf_core_utils_package$AliasCounter(this$1.maxYamlReferences$1);
  var x$5 = new $c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables().init___();
  return new $c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser().init___Lorg_yaml_model_YNode__Lamf_core_utils_package$AliasCounter__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_WebApiContext(node, x$2, x$5, parent, idCounter, ctx).parse__Lamf_core_model_domain_DataNode()
});
var $d_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.DataNodeParser$", {
  Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$
}
function $f_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer__fixNameIfNeeded__pLamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_domain_shapes_models_AnyShape($thiz, element) {
  element.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot().init___());
  if ($as_Lamf_core_model_StrField(element.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1.isEmpty__Z()) {
    var this$1 = $c_Lamf_core_model_domain_Shape.prototype.copyShape__Lamf_core_model_domain_Shape.call(element);
    var value = element.id$1;
    var qual$1 = $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$1, value));
    $m_Lamf_core_parser_Annotations$();
    var x$2 = new $c_Lamf_core_parser_Annotations().init___();
    return $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, "root", x$2))
  } else {
    var this$3 = $as_Lamf_core_model_StrField(element.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
    var this$4 = this$3.option$1;
    var thiz = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
    if ((thiz === null)) {
      throw new $c_jl_NullPointerException().init___()
    };
    if ($m_ju_regex_Pattern$().matches__T__jl_CharSequence__Z(".*/.*", thiz)) {
      var this$6 = $c_Lamf_core_model_domain_Shape.prototype.copyShape__Lamf_core_model_domain_Shape.call(element);
      var value$1 = element.id$1;
      var qual$2 = $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$6, value$1));
      $m_Lamf_core_parser_Annotations$();
      var x$4 = new $c_Lamf_core_parser_Annotations().init___();
      return $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$2, "root", x$4))
    } else {
      return element
    }
  }
}
function $f_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer__generateJsonSchema__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_ShapeRenderOptions__Lamf_client_execution_BaseExecutionEnvironment__T($thiz, element, options, exec) {
  var executionContext = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  $m_Lamf_core_AMFSerializer$().init__s_concurrent_ExecutionContext__V(executionContext);
  var originalId = element.id$1;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$6 = new $c_Lamf_core_model_document_Document().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var jsx$1 = $m_sc_Seq$();
  var array = [$f_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer__fixNameIfNeeded__pLamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_domain_shapes_models_AnyShape($thiz, element)];
  var declarations = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  var field = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
  var document = $as_Lamf_core_model_document_Document($as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$6, field, declarations)));
  var x$3 = $m_Lamf_core_remote_JsonSchema$().name$1;
  $m_Lamf_core_services_RuntimeSerializer$();
  var x$5 = new $c_Lamf_core_emitter_RenderOptions().init___();
  var jsonSchema = $m_Lamf_core_services_RuntimeSerializer$().apply__Lamf_core_model_document_BaseUnit__T__T__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__T(document, "application/schema+json", x$3, x$5, options);
  $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(element, originalId);
  element.annotations__Lamf_core_parser_Annotations().reject__F1__Lamf_core_parser_Annotations(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(a$2) {
      var a = $as_Lamf_core_model_domain_Annotation(a$2);
      return (((a instanceof $c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema) || (a instanceof $c_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema)) || (a instanceof $c_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot))
    })
  })($thiz)));
  element.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema().init___T(jsonSchema));
  return jsonSchema
}
function $f_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer__toJsonSchema__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_client_execution_BaseExecutionEnvironment__T($thiz, element, exec) {
  var x1 = element.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.getClassOf());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var a = $as_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema(x2.value$2);
    return a.rawText$1
  } else {
    var x1$2 = element.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema.getClassOf());
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var g = $as_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema(x2$2.value$2);
      return g.rawText$1
    } else {
      var x$3 = new $c_Lamf_core_emitter_ShapeRenderOptions().init___();
      return $f_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer__generateJsonSchema__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_ShapeRenderOptions__Lamf_client_execution_BaseExecutionEnvironment__T($thiz, element, x$3, exec)
    }
  }
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_MapArrayNode$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_common_MapArrayNode$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_MapArrayNode$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_MapArrayNode$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_MapArrayNode$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_MapArrayNode$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_MapArrayNode$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_MapArrayNode$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_MapArrayNode$.prototype.apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_core_parser_ArrayNode = (function(node, iv) {
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  return new $c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode().init___Lorg_yaml_model_YMap__Lorg_yaml_model_IllegalTypeHandler($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)), iv.eh$1)
});
var $d_Lamf_plugins_document_webapi_parser_spec_common_MapArrayNode$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_MapArrayNode$: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.MapArrayNode$", {
  Lamf_plugins_document_webapi_parser_spec_common_MapArrayNode$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_MapArrayNode$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_MapArrayNode$;
var $n_Lamf_plugins_document_webapi_parser_spec_common_MapArrayNode$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_common_MapArrayNode$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_common_MapArrayNode$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_common_MapArrayNode$ = new $c_Lamf_plugins_document_webapi_parser_spec_common_MapArrayNode$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_common_MapArrayNode$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$() {
  $c_O.call(this);
  this.authorizationUrl$1 = null;
  this.tokenUrl$1 = null;
  this.refreshUrl$1 = null;
  this.scopes$1 = null;
  this.requiredFieldsPerFlow$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ = this;
  this.authorizationUrl$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField().init___T__Lamf_core_metamodel_Field("authorizationUrl", $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1);
  this.tokenUrl$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField().init___T__Lamf_core_metamodel_Field("tokenUrl", $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1);
  this.refreshUrl$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField().init___T__Lamf_core_metamodel_Field("refreshUrl", $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().RefreshUri$1);
  this.scopes$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField().init___T__Lamf_core_metamodel_Field("scopes", $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Scopes$1);
  var jsx$6 = $m_sc_Seq$();
  $m_sci_List$();
  var array = [this.authorizationUrl$1, this.scopes$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$5 = new $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow().init___T__sci_List("implicit", result);
  $m_sci_List$();
  var array$1 = [this.tokenUrl$1, this.scopes$1];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$8 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$8);
    i$1 = (((-1) + i$1) | 0)
  };
  var jsx$4 = new $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow().init___T__sci_List("password", result$1);
  $m_sci_List$();
  var array$2 = [this.tokenUrl$1, this.scopes$1];
  var i$2 = (((-1) + $uI(array$2.length)) | 0);
  var result$2 = $m_sci_Nil$();
  while ((i$2 >= 0)) {
    var this$12 = result$2;
    var index$2 = i$2;
    var x$2 = array$2[index$2];
    result$2 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$12);
    i$2 = (((-1) + i$2) | 0)
  };
  var jsx$3 = new $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow().init___T__sci_List("clientCredentials", result$2);
  $m_sci_List$();
  var array$3 = [this.authorizationUrl$1, this.tokenUrl$1, this.scopes$1];
  var i$3 = (((-1) + $uI(array$3.length)) | 0);
  var result$3 = $m_sci_Nil$();
  while ((i$3 >= 0)) {
    var this$16 = result$3;
    var index$3 = i$3;
    var x$3 = array$3[index$3];
    result$3 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$16);
    i$3 = (((-1) + i$3) | 0)
  };
  var array$4 = [jsx$5, jsx$4, jsx$3, new $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow().init___T__sci_List("authorizationCode", result$3)];
  var jsx$2 = $as_sc_TraversableLike(jsx$6.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$4)));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$1) {
      var x$4 = $as_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow(x$2$1);
      return new $c_T2().init___O__O(x$4.name$1, x$4)
    })
  })(this));
  var this$19 = $m_sc_Seq$();
  this.requiredFieldsPerFlow$1 = $as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$19.ReusableCBFInstance$2)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$.prototype.validateFlowFields__Lamf_plugins_domain_webapi_models_security_OAuth2Flow__Lamf_core_errorhandling_ErrorHandler__V = (function(flow, errorHandler) {
  var this$1 = $as_Lamf_core_model_StrField(flow.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Flow$1));
  var this$2 = this$1.option$1;
  var flowName = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  var requiredFlowsOption = this.requiredFieldsPerFlow$1.get__O__s_Option(flowName);
  if (requiredFlowsOption.isDefined__Z()) {
    var this$3 = $as_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow(requiredFlowsOption.get__O()).requiredFields$1;
    var f = (function($this, flow$1) {
      return (function(flowField$2) {
        var flowField = $as_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField(flowField$2);
        return flow$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option(flowField.field$1).isEmpty__Z()
      })
    })(this, flow);
    if ((this$3 !== null)) {
      var l = this$3;
      var l$1 = l;
      x: {
        var result;
        _noneIn: while (true) {
          if (l$1.isEmpty__Z()) {
            var result = $m_sci_Nil$();
            break
          } else {
            var h = l$1.head__O();
            var t = $as_sci_List(l$1.tail__O());
            if (($uZ(f(h)) === false)) {
              l$1 = t;
              continue _noneIn
            };
            var start = l$1;
            var remaining = t;
            var remaining$1 = remaining;
            _allIn: while (true) {
              if (remaining$1.isEmpty__Z()) {
                var result = start;
                break x
              } else {
                var x$2 = remaining$1.head__O();
                if (($uZ(f(x$2)) !== false)) {
                  remaining$1 = $as_sci_List(remaining$1.tail__O());
                  continue _allIn
                };
                var firstMiss = remaining$1;
                var newHead = new $c_sci_$colon$colon().init___O__sci_List(start.head__O(), $m_sci_Nil$());
                var toProcess = $as_sci_List(start.tail__O());
                var currentLast = newHead;
                while ((toProcess !== firstMiss)) {
                  var newElem = new $c_sci_$colon$colon().init___O__sci_List(toProcess.head__O(), $m_sci_Nil$());
                  currentLast.tl$5 = newElem;
                  currentLast = newElem;
                  toProcess = $as_sci_List(toProcess.tail__O())
                };
                var next = $as_sci_List(firstMiss.tail__O());
                var nextToCopy = next;
                while ((!next.isEmpty__Z())) {
                  var head = next.head__O();
                  if (($uZ(f(head)) !== false)) {
                    next = $as_sci_List(next.tail__O())
                  } else {
                    while ((nextToCopy !== next)) {
                      var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy.head__O(), $m_sci_Nil$());
                      currentLast.tl$5 = newElem$2;
                      currentLast = newElem$2;
                      nextToCopy = $as_sci_List(nextToCopy.tail__O())
                    };
                    nextToCopy = $as_sci_List(next.tail__O());
                    next = $as_sci_List(next.tail__O())
                  }
                };
                if ((!nextToCopy.isEmpty__Z())) {
                  currentLast.tl$5 = nextToCopy
                };
                var result = newHead;
                break x
              }
            }
          }
        }
      };
      var missingFields = result
    } else {
      $m_sci_List$();
      var b = new $c_scm_ListBuffer().init___();
      var these = this$3;
      while ((!these.isEmpty__Z())) {
        var arg1 = these.head__O();
        if (($uZ(f(arg1)) !== false)) {
          b.$$plus$eq__O__scm_ListBuffer(arg1)
        };
        these = $as_sci_List(these.tail__O())
      };
      var missingFields = b.toList__sci_List()
    };
    var these$1 = missingFields;
    while ((!these$1.isEmpty__Z())) {
      var arg1$1 = these$1.head__O();
      var flowField$3 = $as_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField(arg1$1);
      var specification = $m_Lamf_validations_ParserSideValidations$().MissingOAuthFlowField$1;
      var node = flow.id$1;
      var message = (((("Missing " + flowField$3.name$1) + " for ") + flowName) + " flow");
      var property = $m_s_None$();
      var lexical = $m_s_None$();
      var location = $m_s_None$();
      errorHandler.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
      these$1 = $as_sci_List(these$1.tail__O())
    }
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.OAuth2FlowValidations$", {
  Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$;
var $n_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ = new $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$
}
function $f_Lamf_plugins_document_webapi_parser_spec_common_PayloadSerializer__toJson__Lamf_plugins_domain_shapes_models_Example__Lamf_client_execution_BaseExecutionEnvironment__T($thiz, example, exec) {
  var executionContext = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  var rc9 = false;
  var x2 = null;
  var this$1 = $as_Lamf_core_model_StrField(example.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1)).option$1;
  if (this$1.isEmpty__Z()) {
    var x1 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_T(arg1);
    var x1 = new $c_s_Some().init___O($m_Lamf_core_utils_package$MediaTypeMatcher$().guessMediaType$extension__T__Z__T(x$1, false))
  };
  if ((x1 instanceof $c_s_Some)) {
    rc9 = true;
    x2 = $as_s_Some(x1);
    var p3 = $as_T(x2.value$2);
    if ((p3 === "application/json")) {
      var this$3 = $as_Lamf_core_model_StrField(example.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1));
      var this$4 = this$3.option$1;
      return $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()))
    }
  };
  if (rc9) {
    var p5 = $as_T(x2.value$2);
    if ((p5 === "application/xml")) {
      return ""
    }
  };
  var dataNode = $as_Lamf_core_model_domain_DataNode(example.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1));
  return $f_Lamf_plugins_document_webapi_parser_spec_common_PayloadSerializer__dump__pLamf_plugins_document_webapi_parser_spec_common_PayloadSerializer__Lamf_core_model_domain_DataNode__s_concurrent_ExecutionContext__T($thiz, dataNode, executionContext)
}
function $f_Lamf_plugins_document_webapi_parser_spec_common_PayloadSerializer__dump__pLamf_plugins_document_webapi_parser_spec_common_PayloadSerializer__Lamf_core_model_domain_DataNode__s_concurrent_ExecutionContext__T($thiz, dataNode, executionContext) {
  $m_Lamf_core_AMFSerializer$().init__s_concurrent_ExecutionContext__V(executionContext);
  return $m_Lamf_core_services_RuntimeSerializer$().apply__Lamf_core_model_document_BaseUnit__T__T__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__T($m_Lamf_core_model_document_PayloadFragment$().apply__Lamf_core_model_domain_DataNode__T__Lamf_core_model_document_PayloadFragment(dataNode, "application/json"), "application/payload+json", $m_Lamf_core_remote_Payload$().name$1, ($m_Lamf_core_services_RuntimeSerializer$(), new $c_Lamf_core_emitter_RenderOptions().init___()), ($m_Lamf_core_services_RuntimeSerializer$(), new $c_Lamf_core_emitter_ShapeRenderOptions().init___()))
}
function $f_Lamf_plugins_document_webapi_parser_spec_common_PayloadSerializer__toYaml__Lamf_plugins_domain_shapes_models_Example__Lamf_client_execution_BaseExecutionEnvironment__T($thiz, example, exec) {
  var executionContext = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  var rc11 = false;
  var x2 = null;
  var this$1 = $as_Lamf_core_model_StrField(example.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1)).option$1;
  if (this$1.isEmpty__Z()) {
    var x1 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$2 = $as_T(arg1);
    var x1 = new $c_s_Some().init___O($m_Lamf_core_utils_package$MediaTypeMatcher$().guessMediaType$extension__T__Z__T(x$2, false))
  };
  if ((x1 instanceof $c_s_Some)) {
    rc11 = true;
    x2 = $as_s_Some(x1);
    var p3 = $as_T(x2.value$2);
    if ((p3 === "application/json")) {
      var dataNode = $as_Lamf_core_model_domain_DataNode(example.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1));
      return $f_Lamf_plugins_document_webapi_parser_spec_common_PayloadSerializer__dump__pLamf_plugins_document_webapi_parser_spec_common_PayloadSerializer__Lamf_core_model_domain_DataNode__s_concurrent_ExecutionContext__T($thiz, dataNode, executionContext)
    }
  };
  if (rc11) {
    var p5 = $as_T(x2.value$2);
    if ((p5 === "application/xml")) {
      return ""
    }
  };
  if (rc11) {
    var this$3 = $as_Lamf_core_model_StrField(example.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1));
    var this$4 = this$3.option$1;
    return $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()))
  };
  var dataNode$1 = $as_Lamf_core_model_domain_DataNode(example.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1));
  return $f_Lamf_plugins_document_webapi_parser_spec_common_PayloadSerializer__dump__pLamf_plugins_document_webapi_parser_spec_common_PayloadSerializer__Lamf_core_model_domain_DataNode__s_concurrent_ExecutionContext__T($thiz, dataNode$1, executionContext)
}
function $f_Lamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer__toRamlDatatype__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_client_execution_BaseExecutionEnvironment__T($thiz, element, exec) {
  var x1 = element.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype.getClassOf());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var a = $as_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype(x2.value$2);
    return a.rawText$1
  } else {
    var x1$2 = element.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype.getClassOf());
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var g = $as_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype(x2$2.value$2);
      return g.rawText$1
    } else {
      return $f_Lamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer__generateRamlDatatype__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_client_execution_BaseExecutionEnvironment__T($thiz, element, exec)
    }
  }
}
function $f_Lamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer__fixNameIfNeeded__pLamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_domain_shapes_models_AnyShape($thiz, element) {
  if ($as_Lamf_core_model_StrField(element.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1.isEmpty__Z()) {
    var this$1 = $c_Lamf_core_model_domain_Shape.prototype.copyShape__Lamf_core_model_domain_Shape.call(element);
    var value = element.id$1;
    var qual$1 = $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$1, value));
    $m_Lamf_core_parser_Annotations$();
    var x$2 = new $c_Lamf_core_parser_Annotations().init___();
    return $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, "Root", x$2))
  } else {
    var this$3 = $as_Lamf_core_model_StrField(element.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
    var this$4 = this$3.option$1;
    var thiz = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
    if ((thiz === null)) {
      throw new $c_jl_NullPointerException().init___()
    };
    if ($m_ju_regex_Pattern$().matches__T__jl_CharSequence__Z("type", thiz)) {
      var this$6 = $c_Lamf_core_model_domain_Shape.prototype.copyShape__Lamf_core_model_domain_Shape.call(element);
      var value$1 = element.id$1;
      var qual$2 = $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$6, value$1));
      $m_Lamf_core_parser_Annotations$();
      var x$4 = new $c_Lamf_core_parser_Annotations().init___();
      return $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$2, "Root", x$4))
    } else {
      return element
    }
  }
}
function $f_Lamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer__generateRamlDatatype__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_client_execution_BaseExecutionEnvironment__T($thiz, element, exec) {
  var executionContext = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  $m_Lamf_core_AMFSerializer$().init__s_concurrent_ExecutionContext__V(executionContext);
  var jsx$1 = $m_Lamf_core_services_RuntimeSerializer$();
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_core_model_document_Module().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var element$1 = $f_Lamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer__fixNameIfNeeded__pLamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_domain_shapes_models_AnyShape($thiz, element);
  var field = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
  var ramlDatatype = jsx$1.apply__Lamf_core_model_document_BaseUnit__T__T__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__T($as_Lamf_core_model_document_BaseUnit($as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$4, field, element$1))), "application/raml", $m_Lamf_core_remote_Raml10$().name$1, ($m_Lamf_core_services_RuntimeSerializer$(), new $c_Lamf_core_emitter_RenderOptions().init___()), ($m_Lamf_core_services_RuntimeSerializer$(), new $c_Lamf_core_emitter_ShapeRenderOptions().init___()));
  element.annotations__Lamf_core_parser_Annotations().reject__F1__Lamf_core_parser_Annotations(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_domain_Annotation(x$1$2);
      return (x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype)
    })
  })($thiz)));
  element.annotations__Lamf_core_parser_Annotations().reject__F1__Lamf_core_parser_Annotations(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_model_domain_Annotation(x$2$2);
      return (x$2 instanceof $c_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype)
    })
  })($thiz)));
  element.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype().init___T(ramlDatatype));
  return ramlDatatype
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$.prototype.unexpected__p1__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__V = (function(key, iv) {
  var this$1 = iv.eh$1;
  var specification = $m_Lamf_validations_ParserSideValidations$().UnexpectedRamlScalarKey$1;
  var message = (("Unexpected key '" + key) + "'. Options are 'value' or annotations \\(.+\\)");
  var prop = $m_s_None$();
  var l = key.location$1;
  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, "", prop, message, l)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$.prototype.apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_core_parser_ScalarNode = (function(node, iv) {
  var x1 = node.value__Lorg_yaml_model_YValue();
  if ((x1 instanceof $c_Lorg_yaml_model_YMap)) {
    var x2 = $as_Lorg_yaml_model_YMap(x1);
    return this.createScalarValuedNode__p1__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode(x2, iv)
  } else {
    return new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$.prototype.createScalarValuedNode__p1__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode = (function(obj, iv) {
  var elem = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var values = new $c_sr_ObjectRef().init___O(elem);
  obj.entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, values$1, iv$1) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var x1 = entry.key$2.value__Lorg_yaml_model_YValue();
      if ((x1 instanceof $c_Lorg_yaml_model_YScalar)) {
        var x2 = $as_Lorg_yaml_model_YScalar(x1);
        var x1$2 = x2.text$3;
        return ((x1$2 === "value") ? $as_scm_ListBuffer(values$1.elem$1).$$plus$eq__O__scm_ListBuffer(entry) : ($m_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$().isRamlAnnotation__T__Z(x1$2) ? (void 0) : ($m_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$().unexpected__p1__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__V(entry.key$2, iv$1), (void 0))))
      } else {
        $m_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$().unexpected__p1__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__V(entry.key$2, iv$1);
        return (void 0)
      }
    })
  })(this, values, iv)));
  if ($as_scm_ListBuffer(values.elem$1).nonEmpty__Z()) {
    var this$2 = $as_scm_ListBuffer(values.elem$1);
    var this$3 = $as_scg_TraversableForwarder($f_sc_TraversableLike__tail__O(this$2));
    var this$4 = this$3.scala$collection$mutable$ListBuffer$$start$6;
    var these = this$4;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      var d = $as_Lorg_yaml_model_YMapEntry(arg1);
      var this$5 = iv.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().DuplicatedPropertySpecification$1;
      var prop = $m_s_None$();
      var l = d.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$5, specification, "", prop, "Duplicated key 'value'.", l);
      these = $as_sci_List(these.tail__O())
    }
  };
  var this$6 = $as_scm_ListBuffer(values.elem$1);
  var this$7 = this$6.scala$collection$mutable$ListBuffer$$start$6;
  var this$8 = $f_sc_TraversableLike__headOption__s_Option(this$7);
  if (this$8.isEmpty__Z()) {
    var this$10 = $m_s_None$()
  } else {
    var arg1$1 = this$8.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var node = entry$3.value$2;
    var this$10 = new $c_s_Some().init___O(new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv))
  };
  if (this$10.isEmpty__Z()) {
    var node$1 = $m_Lorg_yaml_model_YNode$().Empty$1;
    var jsx$1 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$1, iv)
  } else {
    var jsx$1 = this$10.get__O()
  };
  return new $c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode().init___Lorg_yaml_model_YMap__Lamf_core_parser_ScalarNode__Lamf_plugins_document_webapi_contexts_WebApiContext(obj, $as_Lamf_core_parser_ScalarNode(jsx$1), iv)
});
var $d_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.RamlScalarNode$", {
  Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$;
var $n_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$ = new $c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$.prototype.apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_core_parser_ArrayNode = (function(node, iv) {
  var x1 = node.value__Lorg_yaml_model_YValue();
  return ((x1 instanceof $c_Lorg_yaml_model_YSequence) ? new $c_Lamf_core_parser_DefaultArrayNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv) : new $c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode().init___Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext(node, iv))
});
var $d_Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.SingleArrayNode$", {
  Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$;
var $n_Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$ = new $c_Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps() {
  $c_O.call(this);
  this.field$1 = null;
  this.iv$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps.prototype.$in__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$Target__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField = (function(target) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$Target__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this.$$outer$1, target, this.field$1, this.iv$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps.prototype.init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext = (function($$outer, field, iv) {
  this.field$1 = field;
  this.iv$1 = iv;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps.prototype.$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField = (function(elem) {
  return this.$in__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$Target__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_model_domain_DomainElement(this.$$outer$1, elem))
});
var $d_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.SpecParserOps$FieldOps", {
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$() {
  $c_O.call(this);
  this.ramlKnownAnnotations$1 = null;
  this.oasKnownAnnotations$1 = null;
  this.amfPrefix$1 = null;
  this.ramlAnnotation$1 = null;
  this.oasAnnotation$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$ = this;
  var array = ["baseUriParameters", "termsOfService", "parameters", "binding", "contact", "externalDocs", "license", "baseUriParameters", "oasDeprecated", "summary", "defaultResponse", "payloads", "readOnly", "dependencies", "tuple", "format", "exclusiveMaximum", "exclusiveMinimum", "consumes", "produces", "flow", "examples", "responses", "additionalProperties", "collectionFormat", "tags", "url", "serverDescription", "servers", "xor", "and", "or", "not", "minimum", "maximum", "recursive", "pattern", "multipleOf", "xone", "callbacks"];
  if (($uI(array.length) === 0)) {
    var jsx$1 = $m_sci_Set$EmptySet$()
  } else {
    var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      b.$$plus$eq__O__scm_SetBuilder(arg1);
      i = ((1 + i) | 0)
    };
    var jsx$1 = b.elems$1
  };
  this.ramlKnownAnnotations$1 = $as_sci_Set(jsx$1);
  var array$1 = ["baseUriParameters", "annotationTypes", "requestPayloads", "responsePayloads", "uses", "mediaType", "traits", "resourceTypes", "is", "type", "extensionType", "fragmentType", "usage", "title", "userDocumentation", "description", "displayName", "extends", "describedBy", "discriminatorValue", "settings", "securitySchemes", "queryParameters", "queryString", "examples", "fileTypes", "schema", "serverDescription", "servers", "consumes", "produces", "schemes", "parameters", "facets", "merge", "union", "security", "required", "example", "examples"];
  if (($uI(array$1.length) === 0)) {
    var jsx$2 = $m_sci_Set$EmptySet$()
  } else {
    var b$1 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$1 = 0;
    var len$1 = $uI(array$1.length);
    while ((i$1 < len$1)) {
      var index$1 = i$1;
      var arg1$1 = array$1[index$1];
      b$1.$$plus$eq__O__scm_SetBuilder(arg1$1);
      i$1 = ((1 + i$1) | 0)
    };
    var jsx$2 = b$1.elems$1
  };
  this.oasKnownAnnotations$1 = $as_sci_Set(jsx$2);
  this.amfPrefix$1 = "amf-";
  var this$8 = new $c_sci_StringOps().init___T("^\\((.+)\\)$");
  var groupNames = $m_sci_Nil$();
  var $$this = this$8.repr$1;
  this.ramlAnnotation$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  var this$11 = new $c_sci_StringOps().init___T("^[xX]-(.+)");
  var groupNames$1 = $m_sci_Nil$();
  var $$this$1 = this$11.repr$1;
  this.oasAnnotation$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this$1, groupNames$1);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$.prototype.isRamlAnnotation__T__Z = (function(field) {
  var o8 = this.ramlAnnotation$1.unapplySeq__jl_CharSequence__s_Option(field);
  if ((!o8.isEmpty__Z())) {
    if ((o8.get__O() !== null)) {
      var this$1 = $as_sc_LinearSeqOptimized(o8.get__O());
      var jsx$1 = ($f_sc_LinearSeqOptimized__lengthCompare__I__I(this$1, 1) === 0)
    } else {
      var jsx$1 = false
    }
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return true
  };
  return false
});
$c_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$.prototype.resolveAnnotation__T__s_Option = (function(field) {
  var o8 = this.ramlAnnotation$1.unapplySeq__jl_CharSequence__s_Option(field);
  if ((!o8.isEmpty__Z())) {
    if ((o8.get__O() !== null)) {
      var this$1 = $as_sc_LinearSeqOptimized(o8.get__O());
      var jsx$1 = ($f_sc_LinearSeqOptimized__lengthCompare__I__I(this$1, 1) === 0)
    } else {
      var jsx$1 = false
    }
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var value = $as_T($as_sc_LinearSeqOptimized(o8.get__O()).apply__I__O(0));
    if (this.notContains__p1__sci_Set__T__Z(this.ramlKnownAnnotations$1, value)) {
      return new $c_s_Some().init___O(value)
    }
  };
  var o10 = this.oasAnnotation$1.unapplySeq__jl_CharSequence__s_Option(field);
  if ((!o10.isEmpty__Z())) {
    if ((o10.get__O() !== null)) {
      var this$2 = $as_sc_LinearSeqOptimized(o10.get__O());
      var jsx$2 = ($f_sc_LinearSeqOptimized__lengthCompare__I__I(this$2, 1) === 0)
    } else {
      var jsx$2 = false
    }
  } else {
    var jsx$2 = false
  };
  if (jsx$2) {
    var value$2 = $as_T($as_sc_LinearSeqOptimized(o10.get__O()).apply__I__O(0));
    if (this.notContains__p1__sci_Set__T__Z(this.oasKnownAnnotations$1, value$2)) {
      return new $c_s_Some().init___O(value$2)
    }
  };
  return $m_s_None$()
});
$c_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$.prototype.isOasAnnotation__T__Z = (function(field) {
  var o8 = this.oasAnnotation$1.unapplySeq__jl_CharSequence__s_Option(field);
  if ((!o8.isEmpty__Z())) {
    if ((o8.get__O() !== null)) {
      var this$1 = $as_sc_LinearSeqOptimized(o8.get__O());
      var jsx$1 = ($f_sc_LinearSeqOptimized__lengthCompare__I__I(this$1, 1) === 0)
    } else {
      var jsx$1 = false
    }
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return true
  };
  return false
});
$c_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$.prototype.notContains__p1__sci_Set__T__Z = (function(annotations, value) {
  var this$2 = new $c_sci_StringOps().init___T(value);
  var prefix = this.amfPrefix$1;
  return (!annotations.contains__O__Z($f_sci_StringLike__stripPrefix__T__T(this$2, prefix)))
});
var $d_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.WellKnownAnnotation$", {
  Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$;
var $n_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$ = new $c_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$.prototype.validateTag__p1__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__V = (function(node, ctx) {
  var tagText = node.tag__Lorg_yaml_model_YTag().text$3;
  var x1 = $m_Lorg_yaml_model_YType$().apply__T__Lorg_yaml_model_YType(tagText);
  var x = $m_Lorg_yaml_model_YType$().Unknown$1;
  if ((x === x1)) {
    var jsx$1 = true
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Timestamp$1;
    var jsx$1 = (x$3 === x1)
  };
  if (jsx$1) {
    var this$1 = ctx.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().UnknownYamlTag$1;
    var message = (("Unknown tag '" + tagText) + "', must be allowed by json schema ruleset");
    var ast = node.tag__Lorg_yaml_model_YTag();
    var prop = $m_s_None$();
    var l = ast.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, "", prop, message, l)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$.prototype.validate__Lamf_core_Root__Lamf_plugins_document_webapi_contexts_WebApiContext__V = (function(root, ctx) {
  var x1 = $m_Lamf_core_remote_Syntax$().unapply__s_Option__s_Option(new $c_s_Some().init___O(root.mediatype$1));
  matchEnd10: {
    var jsx$1;
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var p3 = $as_Lamf_core_remote_Syntax$Syntax(x2.value$2);
      var x = $m_Lamf_core_remote_Syntax$Yaml$();
      if ((x === p3)) {
        var jsx$1 = true;
        break matchEnd10
      }
    };
    var x$3 = $m_s_None$();
    if ((x$3 === x1)) {
      var jsx$1 = true;
      break matchEnd10
    };
    var jsx$1 = false
  };
  if (jsx$1) {
    var this$1 = $as_Lamf_core_parser_SyamlParsedDocument(root.parsed$1).document$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var node = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, ctx));
    var this$4 = new $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator().init___Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(node, $m_Lorg_yaml_model_YType$().Map$1)), ctx);
    while (true) {
      var this$5 = this$4.buffer$1;
      if ($f_sc_TraversableOnce__nonEmpty__Z(this$5)) {
        var arg1 = this$4.next__Lorg_yaml_model_YNode();
        $m_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$().validateTag__p1__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__V(arg1, ctx)
      } else {
        break
      }
    }
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.YamlTagValidator$", {
  Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$;
var $n_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$ = new $c_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter() {
  $c_O.call(this);
  this.property$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null;
  this.fs$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter.prototype.init___Lamf_core_model_domain_extensions_CustomDomainProperty__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(property, ordering, spec) {
  this.property$1 = property;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  this.fs$1 = property.fields$1;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter.prototype.emitters__s_util_Either = (function() {
  var rc10 = false;
  var x2 = null;
  var x1 = this.shapeEmitters__sc_Seq().toList__sci_List();
  if ((x1 instanceof $c_sci_$colon$colon)) {
    rc10 = true;
    x2 = $as_sci_$colon$colon(x1);
    var head = $as_Lamf_core_emitter_Emitter(x2.head$5);
    if ($is_Lamf_core_emitter_EntryEmitter(head)) {
      var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      var this$1 = this.fs$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().DisplayName$1);
      if ((!this$1.isEmpty__Z())) {
        var arg1 = this$1.get__O();
        var f = $as_Lamf_core_parser_FieldEntry(arg1);
        new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("displayName", f, $m_s_None$())))
      };
      var this$3 = this.fs$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Description$1);
      if ((!this$3.isEmpty__Z())) {
        var arg1$1 = this$3.get__O();
        var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
        new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f$3, $m_s_None$())))
      };
      var this$5 = this.fs$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Domain$1);
      if ((!this$5.isEmpty__Z())) {
        var arg1$2 = this$5.get__O();
        var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
        var jsx$2 = $as_Lamf_core_model_domain_AmfArray(f$4.value$1.value$1).scalars__sc_Seq();
        var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(s$2) {
            var s = $as_Lamf_core_model_domain_AmfScalar(s$2);
            var x1$1 = $m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().uriToRaml$1.get__O__s_Option(s.toString__T());
            if ((x1$1 instanceof $c_s_Some)) {
              var x2$1 = $as_s_Some(x1$1);
              var identifier = $as_T(x2$1.value$2);
              return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(identifier, s.annotations$1)
            } else {
              var x = $m_s_None$();
              if ((x === x1$1)) {
                return s
              } else {
                throw new $c_s_MatchError().init___O(x1$1)
              }
            }
          })
        })(this));
        var this$6 = $m_sc_Seq$();
        var scalars = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2));
        var finalArray = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(scalars, $as_Lamf_core_model_domain_AmfArray(f$4.value$1.value$1).annotations$1);
        var jsx$3 = f$4.field$1;
        var annotations = f$4.value$1.annotations$1;
        var finalFieldEntry = new $c_Lamf_core_parser_FieldEntry().init___Lamf_core_metamodel_Field__Lamf_core_parser_Value(jsx$3, new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(finalArray, annotations));
        new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType("allowedTargets", finalFieldEntry, this.ordering$1, false, $m_Lorg_yaml_model_YType$().Str$1)))
      };
      var jsx$5 = this.shapeEmitters__sc_Seq();
      var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
        return (function(x$15$2) {
          var x$15 = $as_Lamf_core_emitter_Emitter(x$15$2);
          return $as_Lamf_core_emitter_EntryEmitter(x$15)
        })
      })(this));
      var this$9 = $m_sc_Seq$();
      result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer($as_sc_TraversableOnce(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$4, this$9.ReusableCBFInstance$2)));
      result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.property$1, this.ordering$1, this.spec$1).emitters__sc_Seq());
      $m_s_package$();
      return new $c_s_util_Left().init___O(result)
    }
  };
  if (rc10) {
    var head$2 = $as_Lamf_core_emitter_Emitter(x2.head$5);
    var p4 = x2.tl$5;
    if ($is_Lamf_core_emitter_PartEmitter(head$2)) {
      var x6 = $as_Lamf_core_emitter_PartEmitter(head$2);
      var x$1 = $m_sci_Nil$();
      if (x$1.equals__O__Z(p4)) {
        $m_s_package$();
        return new $c_s_util_Right().init___O(x6)
      }
    }
  };
  var x$3 = $m_sci_Nil$();
  if (x$3.equals__O__Z(x1)) {
    $m_s_package$();
    var value = $m_sci_Nil$();
    return new $c_s_util_Left().init___O(value)
  };
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("IllegalTypeDeclarations found: " + x1)))
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.AnnotationTypeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.AnnotationTypeEmitter;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_AsyncDeclaredTypesEmitters$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AsyncDeclaredTypesEmitters$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AsyncDeclaredTypesEmitters$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_AsyncDeclaredTypesEmitters$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_AsyncDeclaredTypesEmitters$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_AsyncDeclaredTypesEmitters$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_AsyncDeclaredTypesEmitters$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AsyncDeclaredTypesEmitters$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AsyncDeclaredTypesEmitters$.prototype.obtainEmitter__sc_Seq__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext__Lamf_core_emitter_EntryEmitter = (function(types, references, ordering, spec) {
  var x$1 = spec.eh__Lamf_core_errorhandling_ErrorHandler();
  var x$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$();
  var x$3 = $m_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$();
  var x$4 = new $c_Lamf_core_emitter_ShapeRenderOptions().init___();
  var newCtx = new $c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion(x$1, x$3, x$4, x$2);
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters().init___sc_Seq__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(types, references, ordering, newCtx)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_AsyncDeclaredTypesEmitters$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_AsyncDeclaredTypesEmitters$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.AsyncDeclaredTypesEmitters$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_AsyncDeclaredTypesEmitters$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AsyncDeclaredTypesEmitters$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_AsyncDeclaredTypesEmitters$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_AsyncDeclaredTypesEmitters$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_AsyncDeclaredTypesEmitters$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_AsyncDeclaredTypesEmitters$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_AsyncDeclaredTypesEmitters$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AsyncDeclaredTypesEmitters$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_AsyncDeclaredTypesEmitters$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$.prototype.apply__T__T__Lamf_plugins_document_webapi_contexts_WebApiContext__F1 = (function(parentId, enumType, ctx) {
  var enumParentId = (parentId + "/enum");
  if (($m_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$().SCALAR$undENUM$1 === enumType)) {
    var x$1 = new $c_s_Some().init___O(enumParentId);
    var x$2 = new $c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables().init___();
    var x$3 = new $c_Lamf_core_utils_package$IdCounter().init___();
    var eta$0$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser().init___Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_WebApiContext(x$2, x$1, x$3, ctx);
    return new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, eta$0$1$1) {
      return (function(node$2) {
        var node = $as_Lorg_yaml_model_YNode(node$2);
        return eta$0$1$1.parse__Lorg_yaml_model_YNode__Lamf_core_model_domain_DataNode(node)
      })
    })(this, eta$0$1))
  } else {
    var eta$0$2 = new $c_s_Some().init___O(enumParentId);
    var eta$1$1 = new $c_Lamf_core_utils_package$IdCounter().init___();
    return new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, eta$0$2$1, eta$1$1$1, ctx$1) {
      return (function(node$3$2) {
        var node$3 = $as_Lorg_yaml_model_YNode(node$3$2);
        return $m_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$().parse__s_Option__Lamf_core_utils_package$IdCounter__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_core_model_domain_DataNode(eta$0$2$1, eta$1$1$1, node$3, ctx$1)
      })
    })(this, eta$0$2, eta$1$1, ctx))
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.CommonEnumParser$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType.prototype;
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.DefaultType"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.DefaultType;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$() {
  $c_O.call(this);
  this.SCALAR$undENUM$1 = null;
  this.UNKNOWN$undENUM$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$.prototype.init___ = (function() {
  this.SCALAR$undENUM$1 = "SCALAR_ENUM";
  this.UNKNOWN$undENUM$1 = "UNKNOWN_ENUM";
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.EnumParsing$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$() {
  $c_O.call(this);
  this.VALID$undNUMBER$undFORMATS$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$ = this;
  $m_sci_List$();
  var array = ["int", "int8", "int16", "int32", "int64", "long", "float", "double"];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  this.VALID$undNUMBER$undFORMATS$1 = result;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$.prototype.isValid__T__Lamf_plugins_domain_shapes_models_TypeDef__Z = (function(format, typeDef) {
  if ($f_Lamf_plugins_domain_shapes_models_TypeDef__isNumber__Z(typeDef)) {
    var x = $m_Lamf_plugins_domain_shapes_models_TypeDef$IntType$();
    if ((x === typeDef)) {
      $m_sci_List$();
      var array = ["int", "int8", "int16", "int32", "int64", "long"];
      var i = (((-1) + $uI(array.length)) | 0);
      var result = $m_sci_Nil$();
      while ((i >= 0)) {
        var this$4 = result;
        var index = i;
        var x$1 = array[index];
        result = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$4);
        i = (((-1) + i) | 0)
      };
      var this$5 = result;
      var jsx$1 = (!$f_sc_LinearSeqOptimized__contains__O__Z(this$5, format))
    } else {
      var jsx$1 = false
    };
    if ((!jsx$1)) {
      var x$3 = $m_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$();
      if ((!((x$3 === typeDef) && (format === "double")))) {
        var x$5 = $m_Lamf_plugins_domain_shapes_models_TypeDef$LongType$();
        if ((x$5 === typeDef)) {
          $m_sci_List$();
          var array$1 = ["double", "float"];
          var i$1 = (((-1) + $uI(array$1.length)) | 0);
          var result$1 = $m_sci_Nil$();
          while ((i$1 >= 0)) {
            var this$9 = result$1;
            var index$1 = i$1;
            var x$2 = array$1[index$1];
            result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$9);
            i$1 = (((-1) + i$1) | 0)
          };
          var this$10 = result$1;
          var jsx$2 = $f_sc_LinearSeqOptimized__contains__O__Z(this$10, format)
        } else {
          var jsx$2 = false
        };
        if ((!jsx$2)) {
          var this$11 = this.VALID$undNUMBER$undFORMATS$1;
          return $f_sc_LinearSeqOptimized__contains__O__Z(this$11, format)
        } else {
          return false
        }
      } else {
        return false
      }
    } else {
      return false
    }
  } else {
    var this$12 = this.VALID$undNUMBER$undFORMATS$1;
    return (!$f_sc_LinearSeqOptimized__contains__O__Z(this$12, format))
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.FormatValidator$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion() {
  $c_O.call(this);
  this.name$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion.prototype.init___T = (function(name) {
  this.name$1 = name;
  return this
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion$.prototype.fromClientOptions__Lamf_client_render_JSONSchemaVersion__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion = (function(schema) {
  var x = $m_Lamf_client_render_JSONSchemaVersions$().DRAFT$und07$1;
  if ((x === schema)) {
    return $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$()
  } else {
    return $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$()
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.JSONSchemaVersion$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.name$1 = null;
  this.nameAnnotations$1 = null;
  this.ast$1 = null;
  this.adopt$1 = null;
  this.version$1 = null;
  this.ctx$1 = null;
  this.REF$undKEY$1 = null;
  this.oas2DeclarationRegex$1 = null;
  this.oas3DeclarationRegex$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser.prototype.promoteParsedShape__p1__T__T__T__Lamf_plugins_domain_shapes_models_AnyShape__s_Option = (function(ref, text, fullRef, jsonSchemaShape) {
  var promotedShape = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations().promoteExternaltoDataTypeFragment__T__T__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(text, fullRef, jsonSchemaShape);
  var this$1 = $as_Lamf_plugins_domain_shapes_models_AnyShape(promotedShape.link__T__Lamf_core_parser_Annotations__O(text, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.ast$1).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ExternalFragmentRef().init___T(ref))));
  var name = this.name$1;
  var a = this.nameAnnotations$1;
  var this$2 = $as_Lamf_core_model_domain_Linkable($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$1, name, a));
  var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1;
  return new $c_s_Some().init___O($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$2, field, true)))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser.prototype.findDeclarationAndParse__p1__Lorg_yaml_model_YMapEntry__s_Option = (function(e) {
  $m_Lorg_yaml_model_YNode$();
  var node = e.value$2;
  var iv = this.ctx$1;
  var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
  var ref = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv));
  var strippedPrefixRef = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().stripDefinitionsPrefix__T__Lamf_plugins_document_webapi_contexts_WebApiContext__T(ref, this.ctx$1);
  var x1 = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations().findType__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option(strippedPrefixRef, $m_Lamf_core_parser_SearchScope$All$(), (this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations(), $m_s_None$()));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var s = $as_Lamf_plugins_domain_shapes_models_AnyShape(x2.value$2);
    return this.createLinkToDeclaration__p1__T__Lamf_plugins_domain_shapes_models_AnyShape__s_Some(strippedPrefixRef, s)
  } else {
    var x1$2 = this.ctx$1.findLocalJSONPath__T__s_Option(ref);
    matchEnd7: {
      var referencedShape;
      if ((x1$2 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$2);
        var p3 = $as_T2(x2$2.value$2);
        if ((p3 !== null)) {
          var referencedShape = this.searchLocalJsonSchema__p1__T__T__Lorg_yaml_model_YMapEntry__s_Option(ref, (this.ctx$1.linkTypes__Z() ? strippedPrefixRef : ref), e);
          break matchEnd7
        }
      };
      var referencedShape = this.searchRemoteJsonSchema__p1__T__T__Lorg_yaml_model_YMapEntry__s_Option(ref, (this.ctx$1.linkTypes__Z() ? strippedPrefixRef : ref), e)
    };
    if ((!referencedShape.isEmpty__Z())) {
      var arg1 = referencedShape.get__O();
      var s$2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1);
      this.safeAdoption__Lamf_plugins_domain_shapes_models_AnyShape__V(s$2)
    };
    return referencedShape
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser.prototype.isDeclaration__p1__T__Z = (function(ref) {
  var x1 = this.ctx$1;
  if ((x1 instanceof $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext)) {
    var regex = this.oas2DeclarationRegex$1;
    if ((ref === null)) {
      throw new $c_jl_NullPointerException().init___()
    };
    var jsx$1 = $m_ju_regex_Pattern$().matches__T__jl_CharSequence__Z(regex, ref)
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return true
  } else if ((x1 instanceof $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext)) {
    var regex$1 = this.oas3DeclarationRegex$1;
    if ((ref === null)) {
      throw new $c_jl_NullPointerException().init___()
    };
    return $m_ju_regex_Pattern$().matches__T__jl_CharSequence__Z(regex$1, ref)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser.prototype.createLinkToParsedShape__p1__T__Lamf_plugins_domain_shapes_models_AnyShape__s_Some = (function(ref, shape) {
  var annots = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.ast$1);
  var this$1 = $as_Lamf_plugins_domain_shapes_models_AnyShape(shape.link__T__Lamf_core_parser_Annotations__O(ref, annots));
  var name = this.name$1;
  var a = this.nameAnnotations$1;
  var this$2 = $as_Lamf_core_model_domain_Linkable($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$1, name, a));
  var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1;
  var copied = $as_Lamf_plugins_domain_shapes_models_AnyShape($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$2, field, true)));
  this.adopt$1.apply__O__O(copied);
  return new $c_s_Some().init___O(copied)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser.prototype.init___Lorg_yaml_model_YMap__T__Lamf_core_parser_Annotations__Lorg_yaml_model_YPart__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function(map, name, nameAnnotations, ast, adopt, version, ctx) {
  this.map$1 = map;
  this.name$1 = name;
  this.nameAnnotations$1 = nameAnnotations;
  this.ast$1 = ast;
  this.adopt$1 = adopt;
  this.version$1 = version;
  this.ctx$1 = ctx;
  this.REF$undKEY$1 = "$ref";
  this.oas2DeclarationRegex$1 = "^(\\#\\/definitions\\/){1}([^/\\n])+$";
  this.oas3DeclarationRegex$1 = "^(\\#\\/components\\/){1}((schemas|parameters|securitySchemes|requestBodies|responses|headers|examples|links|callbacks){1}\\/){1}([^/\\n])+";
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser.prototype.searchRemoteJsonSchema__p1__T__T__Lorg_yaml_model_YMapEntry__s_Option = (function(ref, text, e) {
  var fullRef = this.ctx$1.resolvedPath__T__T__T(this.ctx$1.rootContextDocument$1, ref);
  var rc6 = false;
  var x2 = null;
  var x1 = this.ctx$1.findJsonSchema__T__s_Option(fullRef);
  if ((x1 instanceof $c_s_Some)) {
    rc6 = true;
    x2 = $as_s_Some(x1);
    var u = $as_Lamf_plugins_domain_shapes_models_AnyShape(x2.value$2);
    if ((u instanceof $c_Lamf_plugins_domain_shapes_models_UnresolvedShape)) {
      var x4 = $as_Lamf_plugins_domain_shapes_models_UnresolvedShape(u);
      return this.copyUnresolvedShape__p1__T__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_shapes_models_UnresolvedShape__s_Some(ref, fullRef, e, x4)
    }
  };
  if (rc6) {
    var shape = $as_Lamf_plugins_domain_shapes_models_AnyShape(x2.value$2);
    return this.createLinkToParsedShape__p1__T__Lamf_plugins_domain_shapes_models_AnyShape__s_Some(ref, shape)
  };
  var this$1 = this.ctx$1.jsonSchemaRefGuide$2;
  var fileUrl = this$1.context$1.resolvedPath__T__T__T(this$1.currentLoc$1, ref);
  var x1$2 = this.parseRemoteSchema__p1__T__s_Option(ref);
  var x = $m_s_None$();
  if ((x === x1$2)) {
    var ctx = this.ctx$1;
    var qual$1 = $m_Lamf_plugins_domain_shapes_models_UnresolvedShape$().apply__T__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_UnresolvedShape(fileUrl, e);
    $m_Lamf_core_parser_Annotations$();
    var x$2 = new $c_Lamf_core_parser_Annotations().init___();
    var this$4 = $as_Lamf_core_model_domain_Linkable($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, fileUrl, x$2).withId__T__Lamf_core_model_domain_AmfObject(fileUrl));
    var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1;
    var tmpShape = $as_Lamf_plugins_domain_shapes_models_UnresolvedShape($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$4, field, true)));
    $f_Lamf_core_model_domain_Linkable__unresolved__T__Lorg_yaml_model_YPart__T__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(tmpShape, fileUrl, e, "warning", ctx);
    $f_Lamf_core_parser_UnresolvedReference__withContext__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(tmpShape, ctx);
    this.adopt$1.apply__O__O(tmpShape);
    ctx.registerJsonSchema__T__Lamf_plugins_domain_shapes_models_AnyShape__V(fileUrl, tmpShape);
    var ctx$1 = this.ctx$1;
    var this$5 = $as_Lamf_core_model_domain_Linkable($f_Lamf_core_model_domain_Linkable__unresolved__T__Lorg_yaml_model_YPart__T__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(tmpShape, text, e, "warning", ctx$1));
    var field$1 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1;
    $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$5, field$1, true));
    return new $c_s_Some().init___O(tmpShape)
  } else if ((x1$2 instanceof $c_s_Some)) {
    var x2$2 = $as_s_Some(x1$2);
    var jsonSchemaShape = $as_Lamf_plugins_domain_shapes_models_AnyShape(x2$2.value$2);
    jsonSchemaShape.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape().init___Lorg_yaml_model_YMapEntry(e));
    return (this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations().fragments$1.contains__O__Z(text) ? this.promoteParsedShape__p1__T__T__T__Lamf_plugins_domain_shapes_models_AnyShape__s_Option(ref, text, fullRef, jsonSchemaShape) : new $c_s_Some().init___O(jsonSchemaShape))
  } else {
    throw new $c_s_MatchError().init___O(x1$2)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser.prototype.parse__s_Option = (function() {
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(this.REF$undKEY$1);
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$3 = e.value$2;
    var x1 = this$3.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Null$1;
    if ((x === x1)) {
      return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_AnyShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_AnyShape(e))
    } else {
      return this.findDeclarationAndParse__p1__Lorg_yaml_model_YMapEntry__s_Option(e)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser.prototype.createLinkToDeclaration__p1__T__Lamf_plugins_domain_shapes_models_AnyShape__s_Some = (function(label, s) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_AnyShape(s.link__T__Lamf_core_parser_Annotations__O(label, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.ast$1)));
  var name = this.name$1;
  var a = this.nameAnnotations$1;
  var this$2 = $as_Lamf_core_model_domain_Linkable($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$1, name, a));
  var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1;
  var link = $as_Lamf_plugins_domain_shapes_models_AnyShape($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$2, field, true)));
  this.adopt$1.apply__O__O(link);
  return new $c_s_Some().init___O(link)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser.prototype.searchLocalJsonSchema__p1__T__T__Lorg_yaml_model_YMapEntry__s_Option = (function(r, t, e) {
  if (this.ctx$1.linkTypes__Z()) {
    var x1_$_$$und1$f = r;
    var x1_$_$$und2$f = t
  } else {
    var fullref = this.ctx$1.resolvedPath__T__T__T(this.ctx$1.rootContextDocument$1, r);
    var x1_$_$$und1$f = fullref;
    var x1_$_$$und2$f = fullref
  };
  var ref = $as_T(x1_$_$$und1$f);
  var text = $as_T(x1_$_$$und2$f);
  var x1$2 = this.ctx$1.findJsonSchema__T__s_Option(ref);
  if ((x1$2 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1$2);
    var s = $as_Lamf_plugins_domain_shapes_models_AnyShape(x2.value$2);
    var annots = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.ast$1);
    var this$2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(s.link__T__Lamf_core_parser_Annotations__O(ref, annots));
    var name = this.name$1;
    $m_Lamf_core_parser_Annotations$();
    var a = new $c_Lamf_core_parser_Annotations().init___();
    var this$3 = $as_Lamf_core_model_domain_Linkable($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$2, name, a));
    var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1;
    var copied = $as_Lamf_plugins_domain_shapes_models_AnyShape($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$3, field, true)));
    return new $c_s_Some().init___O(copied)
  } else {
    var x = $m_s_None$();
    if ((x === x1$2)) {
      var this$5 = $m_Lamf_plugins_domain_shapes_models_UnresolvedShape$().apply__T__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_UnresolvedShape(ref, this.map$1);
      $m_Lamf_core_parser_Annotations$();
      var a$1 = new $c_Lamf_core_parser_Annotations().init___();
      var this$6 = $as_Lamf_core_model_domain_Linkable($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$5, text, a$1));
      var field$1 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1;
      var tmpShape = $as_Lamf_plugins_domain_shapes_models_UnresolvedShape($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$6, field$1, true)));
      var ctx = this.ctx$1;
      $f_Lamf_core_model_domain_Linkable__unresolved__T__Lorg_yaml_model_YPart__T__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(tmpShape, text, e, "warning", ctx);
      var c = this.ctx$1;
      $f_Lamf_core_parser_UnresolvedReference__withContext__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(tmpShape, c);
      this.adopt$1.apply__O__O(tmpShape);
      if (((this.isOasContext__p1__Z() && this.isDeclaration__p1__T__Z(ref)) && this.ctx$1.isMainFileContext__Z())) {
        var this$7 = $m_Lamf_plugins_domain_shapes_models_AnyShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_AnyShape(this.ast$1);
        var name$1 = this.name$1;
        var a$2 = this.nameAnnotations$1;
        var shape = $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$7, name$1, a$2));
        var this$8 = $as_Lamf_core_model_domain_Linkable($f_Lamf_core_model_domain_Linkable__withLinkTarget__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(shape, tmpShape));
        var field$2 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1;
        $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$8, field$2, text));
        this.adopt$1.apply__O__O(shape);
        return new $c_s_Some().init___O(shape)
      } else {
        this.ctx$1.registerJsonSchema__T__Lamf_plugins_domain_shapes_models_AnyShape__V(ref, tmpShape);
        var x1$3 = this.ctx$1.findLocalJSONPath__T__s_Option(r);
        if ((x1$3 instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(x1$3);
          var p3 = $as_T2(x2$2.value$2);
          if ((p3 !== null)) {
            var shapeNode = $as_Lorg_yaml_model_YNode(p3.$$und2__O());
            var jsx$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$();
            var jsx$1 = $m_Lorg_yaml_model_YMapEntry$();
            $m_Lorg_yaml_model_YNode$();
            var str = this.name$1;
            var this$10 = jsx$2.apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(jsx$1.apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry($m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str), shapeNode), this.adopt$1, this.version$1, this.ctx$1).parse__s_Option();
            if (this$10.isEmpty__Z()) {
              var this$14 = $m_s_None$()
            } else {
              var arg1 = this$10.get__O();
              var shape$2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1);
              var this$11 = this.ctx$1.futureDeclarations$1;
              $f_Lamf_core_parser_FutureDeclarations__resolveRef__T__Lamf_core_model_domain_Linkable__V(this$11, text, shape$2);
              this.ctx$1.registerJsonSchema__T__Lamf_plugins_domain_shapes_models_AnyShape__V(ref, shape$2);
              if ((this.ctx$1.linkTypes__Z() || (ref === "#"))) {
                var this$13 = $as_Lamf_plugins_domain_shapes_models_AnyShape(shape$2.link__T__Lamf_core_parser_Annotations__O(text, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.ast$1)));
                var name$2 = this.name$1;
                $m_Lamf_core_parser_Annotations$();
                var a$3 = new $c_Lamf_core_parser_Annotations().init___();
                var jsx$3 = $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$13, name$2, a$3))
              } else {
                var jsx$3 = shape$2
              };
              var this$14 = new $c_s_Some().init___O(jsx$3)
            };
            return (this$14.isEmpty__Z() ? new $c_s_Some().init___O(tmpShape) : this$14)
          }
        };
        var x$3 = $m_s_None$();
        if ((x$3 === x1$3)) {
          return new $c_s_Some().init___O(tmpShape)
        };
        throw new $c_s_MatchError().init___O(x1$3)
      }
    } else {
      throw new $c_s_MatchError().init___O(x1$2)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser.prototype.copyUnresolvedShape__p1__T__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_shapes_models_UnresolvedShape__s_Some = (function(ref, fullRef, entry, unresolved) {
  var annots = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.ast$1);
  var this$1 = unresolved.annotations$2;
  var this$2 = unresolved.copyShape__Lamf_core_parser_Annotations__Lamf_core_model_domain_Shape(annots.$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations($m_Lamf_core_parser_Annotations$().apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(this$1)));
  var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1;
  var copied = $as_Lamf_plugins_domain_shapes_models_UnresolvedShape($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$2, field, ref)));
  var ctx = this.ctx$1;
  $f_Lamf_core_model_domain_Linkable__unresolved__T__Lorg_yaml_model_YPart__T__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(copied, fullRef, entry, "warning", ctx);
  this.adopt$1.apply__O__O(copied);
  return new $c_s_Some().init___O(copied)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser.prototype.safeAdoption__Lamf_plugins_domain_shapes_models_AnyShape__V = (function(s) {
  var oldId = $m_s_Option$().apply__O__s_Option(s.id$1);
  this.adopt$1.apply__O__O(s);
  matchEnd4: {
    if ((s !== null)) {
      if (($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(s).isDefined__Z() && (s.id$1 === s.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(s.effectiveLinkTarget$default$1__sc_Seq()).id__T()))) {
        if ((!oldId.isEmpty__Z())) {
          var arg1 = oldId.get__O();
          var x$2 = $as_T(arg1);
          s.id$1 = x$2
        };
        break matchEnd4
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser.prototype.isOasContext__p1__Z = (function() {
  var x1 = this.ctx$1;
  return ((x1 instanceof $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext) || (x1 instanceof $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser.prototype.parseRemoteSchema__p1__T__s_Option = (function(fullRef) {
  var this$1 = this.ctx$1.parseRemoteJSONPath__T__s_Option(fullRef);
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var shape = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1);
    this.ctx$1.registerJsonSchema__T__Lamf_plugins_domain_shapes_models_AnyShape__V(fullRef, shape);
    var this$2 = this.ctx$1.futureDeclarations$1;
    $f_Lamf_core_parser_FutureDeclarations__resolveRef__T__Lamf_core_model_domain_Linkable__V(this$2, fullRef, shape);
    return new $c_s_Some().init___O(shape)
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasRefParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser() {
  $c_O.call(this);
  this.dataNodeParser$1 = null;
  this.enumParser$1 = null;
  this.ctx$1 = null;
  this.bitmap$0$1 = 0;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser.prototype.dataNodeParser$lzycompute__p1__F1 = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    var eta$0$1 = new $c_s_Some().init___O(this.shape__Lamf_core_model_domain_Shape().id$1);
    var eta$1$1 = new $c_Lamf_core_utils_package$IdCounter().init___();
    this.dataNodeParser$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, eta$0$1$1, eta$1$1$1) {
      return (function(node$2) {
        var node = $as_Lorg_yaml_model_YNode(node$2);
        return $m_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$().parse__s_Option__Lamf_core_utils_package$IdCounter__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_core_model_domain_DataNode(eta$0$1$1, eta$1$1$1, node, $this.ctx$1)
      })
    })(this, eta$0$1, eta$1$1));
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.dataNodeParser$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser.prototype.dataNodeParser__F1 = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.dataNodeParser$lzycompute__p1__F1() : this.dataNodeParser$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser.prototype.parse__Lamf_core_model_domain_Shape = (function() {
  var map = this.map__Lorg_yaml_model_YMap();
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$2 = this.$$outer$1;
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().DisplayName$1;
  var iv = this.ctx$1;
  jsx$1.key__T__F1__V("title", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$2, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape__Lamf_core_model_domain_Shape()));
  var map$1 = this.map__Lorg_yaml_model_YMap();
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var this$4 = this.$$outer$1;
  var field$1 = $m_Lamf_core_metamodel_domain_ShapeModel$().Description$1;
  var iv$1 = this.ctx$1;
  jsx$2.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$4, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape__Lamf_core_model_domain_Shape()));
  var map$2 = this.map__Lorg_yaml_model_YMap();
  var this$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var this$7 = this$6.key__T__s_Option("default");
  if ((!this$7.isEmpty__Z())) {
    var arg1 = this$7.get__O();
    var node = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$8 = this.shape__Lamf_core_model_domain_Shape();
    $f_Lamf_plugins_domain_shapes_models_ShapeHelper__setDefaultStrValue__Lorg_yaml_model_YMapEntry__V(this$8, node);
    var this$9 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser().init___Lorg_yaml_model_YNode__T__Z__Z__Z__Lamf_plugins_document_webapi_contexts_WebApiContext(node.value$2, this.shape__Lamf_core_model_domain_Shape().id$1, false, false, false, this.ctx$1).parse__Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult().dataNode$1;
    if ((!this$9.isEmpty__Z())) {
      var arg1$1 = this$9.get__O();
      var dn = $as_Lamf_core_model_domain_DataNode(arg1$1);
      var this$10 = this.shape__Lamf_core_model_domain_Shape();
      var field$2 = $m_Lamf_core_metamodel_domain_ShapeModel$().Default$1;
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(node);
      $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$10, field$2, dn, annotations))
    }
  };
  var map$3 = this.map__Lorg_yaml_model_YMap();
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3);
  var this$12 = this.$$outer$1;
  var field$3 = $m_Lamf_core_metamodel_domain_ShapeModel$().Values$1;
  var iv$2 = this.ctx$1;
  jsx$3.key__T__F1__V("enum", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$12, field$3, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape__Lamf_core_model_domain_Shape()).using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.enumParser__F1()));
  var map$4 = this.map__Lorg_yaml_model_YMap();
  var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$4);
  var this$14 = this.$$outer$1;
  var field$4 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Documentation$1;
  var iv$3 = this.ctx$1;
  jsx$4.key__T__F1__V("externalDocs", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$14, field$4, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape__Lamf_core_model_domain_Shape()).using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$30$2) {
      var x$30 = $as_Lorg_yaml_model_YNode(x$30$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$().parse__Lorg_yaml_model_YNode__T__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_domain_shapes_models_CreativeWork(x$30, this$2$1.shape__Lamf_core_model_domain_Shape().id$1, this$2$1.ctx$1)
    })
  })(this))));
  var map$5 = this.map__Lorg_yaml_model_YMap();
  var jsx$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$5);
  var this$16 = this.$$outer$1;
  var field$5 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().XMLSerialization$1;
  var iv$4 = this.ctx$1;
  var jsx$5 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$16, field$5, iv$4).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape__Lamf_core_model_domain_Shape());
  var this$17 = this.shape__Lamf_core_model_domain_Shape();
  var this$18 = $as_Lamf_core_model_StrField(this$17.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
  var this$19 = this$18.option$1;
  var eta$0$1 = $as_T((this$19.isEmpty__Z() ? null : this$19.get__O()));
  jsx$6.key__T__F1__V("xml", jsx$5.using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, eta$0$1$1) {
    return (function(node$3$2) {
      var node$3 = $as_Lorg_yaml_model_YNode(node$3$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser$().parse__T__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_domain_shapes_models_XMLSerializer(eta$0$1$1, node$3, this$3$1.ctx$1)
    })
  })(this, eta$0$1))));
  var map$6 = this.map__Lorg_yaml_model_YMap();
  var this$22 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$6);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("facets").asOasExtension__T();
  var this$23 = this$22.key__T__s_Option(keyword);
  if ((!this$23.isEmpty__Z())) {
    var arg1$2 = this$23.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var jsx$7 = this.$$outer$1;
    var this$24 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$5 = this.ctx$1;
    new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lorg_yaml_model_YMap__F1__sci_Map__Z(jsx$7, $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$24, conversion, iv$5)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(name$2) {
        var name = $as_T(name$2);
        return $this.shape__Lamf_core_model_domain_Shape().withCustomShapePropertyDefinition__T__Lamf_core_model_domain_extensions_PropertyShape(name)
      })
    })(this)), $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())), (this.$$outer$1.PropertiesParser__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser$(), false)).parse__sc_Seq()
  };
  var map$7 = this.map__Lorg_yaml_model_YMap();
  var this$26 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$7);
  var this$27 = this$26.key__T__s_Option("type");
  if ((!this$27.isEmpty__Z())) {
    var arg1$3 = this$27.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
    var jsx$9 = this.shape__Lamf_core_model_domain_Shape().annotations__Lamf_core_parser_Annotations();
    var jsx$8 = $m_Lamf_core_parser_Range$();
    var this$28 = entry$3.key$2;
    var this$29 = this$28.location$1;
    jsx$9.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo().init___Lamf_core_parser_Range(jsx$8.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$29.lineFrom$1, this$29.columnFrom$1, this$29.lineTo$1, this$29.columnTo$1))))
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape(this.$$outer$1, this.map__Lorg_yaml_model_YMap(), this.shape__Lamf_core_model_domain_Shape()).parse__V();
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape(this.$$outer$1, this.map__Lorg_yaml_model_YMap(), this.shape__Lamf_core_model_domain_Shape()).parse__V();
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape(this.$$outer$1, this.map__Lorg_yaml_model_YMap(), this.shape__Lamf_core_model_domain_Shape()).parse__V();
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__T__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape(this.$$outer$1, "not", $m_Lamf_core_metamodel_domain_ShapeModel$().Not$1, this.map__Lorg_yaml_model_YMap(), this.shape__Lamf_core_model_domain_Shape()).parse__V();
  var map$8 = this.map__Lorg_yaml_model_YMap();
  var jsx$10 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$8);
  var this$31 = this.$$outer$1;
  var field$6 = $m_Lamf_core_metamodel_domain_ShapeModel$().ReadOnly$1;
  var iv$6 = this.ctx$1;
  jsx$10.key__T__F1__V("readOnly", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$31, field$6, iv$6).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape__Lamf_core_model_domain_Shape()));
  if ((this.$$outer$1.version$2 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion)) {
    var jsx$11 = true
  } else {
    var x = this.$$outer$1.version$2;
    var x$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$();
    var jsx$11 = ((x !== null) && x.equals__O__Z(x$2))
  };
  if (jsx$11) {
    var map$9 = this.map__Lorg_yaml_model_YMap();
    var jsx$12 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$9);
    var this$33 = this.$$outer$1;
    var field$7 = $m_Lamf_core_metamodel_domain_ShapeModel$().WriteOnly$1;
    var iv$7 = this.ctx$1;
    jsx$12.key__T__F1__V("writeOnly", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$33, field$7, iv$7).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape__Lamf_core_model_domain_Shape()));
    var map$10 = this.map__Lorg_yaml_model_YMap();
    var jsx$13 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$10);
    var this$35 = this.$$outer$1;
    var field$8 = $m_Lamf_core_metamodel_domain_ShapeModel$().Deprecated$1;
    var iv$8 = this.ctx$1;
    jsx$13.key__T__F1__V("deprecated", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$35, field$8, iv$8).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape__Lamf_core_model_domain_Shape()))
  };
  var x$3 = this.$$outer$1.version$2;
  var x$4 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$();
  if (((x$3 !== null) && x$3.equals__O__Z(x$4))) {
    this.parseDraft7Fields__p1__V()
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(this.shape__Lamf_core_model_domain_Shape(), this.map__Lorg_yaml_model_YMap(), $m_sci_Nil$(), this.ctx$1).parse__V();
  var map$11 = this.map__Lorg_yaml_model_YMap();
  var this$38 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$11);
  var this$39 = this$38.key__T__s_Option("id");
  if ((!this$39.isEmpty__Z())) {
    var arg1$4 = this$39.get__O();
    var node$4 = $as_Lorg_yaml_model_YMapEntry(arg1$4);
    var jsx$14 = this.shape__Lamf_core_model_domain_Shape().annotations__Lamf_core_parser_Annotations();
    var this$40 = node$4.value$2;
    var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv$9 = this.ctx$1;
    jsx$14.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_JSONSchemaId().init___T($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$40, conversion$1, iv$9)).text$3))
  };
  return this.shape__Lamf_core_model_domain_Shape()
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser.prototype.parseDraft7Fields__p1__V = (function() {
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__T__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape(this.$$outer$1, "if", $m_Lamf_core_metamodel_domain_ShapeModel$().If$1, this.map__Lorg_yaml_model_YMap(), this.shape__Lamf_core_model_domain_Shape()).parse__V();
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__T__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape(this.$$outer$1, "then", $m_Lamf_core_metamodel_domain_ShapeModel$().Then$1, this.map__Lorg_yaml_model_YMap(), this.shape__Lamf_core_model_domain_Shape()).parse__V();
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__T__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape(this.$$outer$1, "else", $m_Lamf_core_metamodel_domain_ShapeModel$().Else$1, this.map__Lorg_yaml_model_YMap(), this.shape__Lamf_core_model_domain_Shape()).parse__V();
  var map = this.map__Lorg_yaml_model_YMap();
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$2 = this.$$outer$1;
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Values$1;
  var iv = this.ctx$1;
  jsx$1.key__T__F1__V("const", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$2, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape__Lamf_core_model_domain_Shape()).using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.dataNodeParser__F1()).allowingSingleValue__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField())
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_document_webapi_contexts_WebApiContext = (function($$outer, ctx) {
  this.ctx$1 = ctx;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser.prototype.enumParser$lzycompute__p1__F1 = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.enumParser$1 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$().apply__T__T__Lamf_plugins_document_webapi_contexts_WebApiContext__F1(this.shape__Lamf_core_model_domain_Shape().id$1, $m_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$().UNKNOWN$undENUM$1, this.ctx$1);
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.enumParser$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser.prototype.enumParser__F1 = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.enumParser$lzycompute__p1__F1() : this.enumParser$1)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$ShapeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$ShapeParser;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetection$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetection$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetection$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetection$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetection$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetection$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetection$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetection$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetection$.prototype.apply__Lorg_yaml_model_YNode__T__s_Option__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__s_Option = (function(node, parent, format, defaultType, ctx) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector().init___T__s_Option__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(parent, format, defaultType, false, ctx).detect__Lorg_yaml_model_YNode__s_Option(node)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetection$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetection$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeDetection$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetection$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetection$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetection$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetection$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetection$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetection$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetection$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetection$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetection$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$InheritsTypeDetecter$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$InheritsTypeDetecter$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$InheritsTypeDetecter$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$InheritsTypeDetecter$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$InheritsTypeDetecter$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$InheritsTypeDetecter$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$InheritsTypeDetecter$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$InheritsTypeDetecter$.prototype.apply__sci_List__Lorg_yaml_model_YPart__s_Option = (function(inheritsTypes, ast) {
  var x = $m_sci_Nil$();
  if (x.equals__O__Z(inheritsTypes)) {
    return $m_s_None$()
  };
  if ((inheritsTypes instanceof $c_sci_$colon$colon)) {
    var x2 = $as_sci_$colon$colon(inheritsTypes);
    var head = $as_Lamf_plugins_domain_shapes_models_TypeDef(x2.head$5);
    var p3 = x2.tl$5;
    var x$3 = $m_sci_Nil$();
    if (x$3.equals__O__Z(p3)) {
      return new $c_s_Some().init___O(head)
    }
  };
  var f = (function($this) {
    return (function(x$6$2) {
      var x$6 = $as_Lamf_plugins_domain_shapes_models_TypeDef(x$6$2);
      var x$2 = $m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$();
      return (!((x$6 !== null) && (x$6 === x$2)))
    })
  })(this);
  if ((inheritsTypes !== null)) {
    var l = inheritsTypes;
    var l$1 = l;
    x: {
      var result;
      _noneIn: while (true) {
        if (l$1.isEmpty__Z()) {
          var result = $m_sci_Nil$();
          break
        } else {
          var h = l$1.head__O();
          var t = $as_sci_List(l$1.tail__O());
          if (($uZ(f(h)) === false)) {
            l$1 = t;
            continue _noneIn
          };
          var start = l$1;
          var remaining = t;
          var remaining$1 = remaining;
          _allIn: while (true) {
            if (remaining$1.isEmpty__Z()) {
              var result = start;
              break x
            } else {
              var x$2$1 = remaining$1.head__O();
              if (($uZ(f(x$2$1)) !== false)) {
                remaining$1 = $as_sci_List(remaining$1.tail__O());
                continue _allIn
              };
              var firstMiss = remaining$1;
              var newHead = new $c_sci_$colon$colon().init___O__sci_List(start.head__O(), $m_sci_Nil$());
              var toProcess = $as_sci_List(start.tail__O());
              var currentLast = newHead;
              while ((toProcess !== firstMiss)) {
                var newElem = new $c_sci_$colon$colon().init___O__sci_List(toProcess.head__O(), $m_sci_Nil$());
                currentLast.tl$5 = newElem;
                currentLast = newElem;
                toProcess = $as_sci_List(toProcess.tail__O())
              };
              var next = $as_sci_List(firstMiss.tail__O());
              var nextToCopy = next;
              while ((!next.isEmpty__Z())) {
                var head$1 = next.head__O();
                if (($uZ(f(head$1)) !== false)) {
                  next = $as_sci_List(next.tail__O())
                } else {
                  while ((nextToCopy !== next)) {
                    var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy.head__O(), $m_sci_Nil$());
                    currentLast.tl$5 = newElem$2;
                    currentLast = newElem$2;
                    nextToCopy = $as_sci_List(nextToCopy.tail__O())
                  };
                  nextToCopy = $as_sci_List(next.tail__O());
                  next = $as_sci_List(next.tail__O())
                }
              };
              if ((!nextToCopy.isEmpty__Z())) {
                currentLast.tl$5 = nextToCopy
              };
              var result = newHead;
              break x
            }
          }
        }
      }
    };
    var definedTypes = result
  } else {
    $m_sci_List$();
    var b = new $c_scm_ListBuffer().init___();
    var these = inheritsTypes;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      if (($uZ(f(arg1)) !== false)) {
        b.$$plus$eq__O__scm_ListBuffer(arg1)
      };
      these = $as_sci_List(these.tail__O())
    };
    var definedTypes = b.toList__sci_List()
  };
  if (definedTypes.isEmpty__Z()) {
    return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$())
  } else {
    var head$2 = $f_sc_TraversableLike__headOption__s_Option(definedTypes);
    var elem$1 = 0;
    elem$1 = 0;
    var these$1 = definedTypes;
    while ((!these$1.isEmpty__Z())) {
      var arg1$1 = these$1.head__O();
      var x$7 = $as_Lamf_plugins_domain_shapes_models_TypeDef(arg1$1);
      var that = head$2.get__O();
      if ((x$7 === that)) {
        elem$1 = ((1 + elem$1) | 0)
      };
      these$1 = $as_sci_List(these$1.tail__O())
    };
    if ((elem$1 !== $f_sc_LinearSeqOptimized__length__I(definedTypes))) {
      var this$3 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeDetector$$ctx$f.eh$1;
      var specification = $m_Lamf_validations_ResolutionSideValidations$().InvalidTypeInheritanceErrorSpecification$1;
      var node = this.$$outer$1.parent$1;
      var prop = $m_s_None$();
      var l$2 = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$3, specification, node, prop, "Can't inherit from more than one class type", l$2);
      return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$())
    } else {
      return head$2
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$InheritsTypeDetecter$.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$InheritsTypeDetecter$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$InheritsTypeDetecter$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeDetector$InheritsTypeDetecter$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$InheritsTypeDetecter$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$InheritsTypeDetecter$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$InheritsTypeDetecter$;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$() {
  $c_O.call(this);
  this.InheritsUnionMatcher$module$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$.prototype.InheritsUnionMatcher$lzycompute$1__p1__V = (function() {
  if ((this.InheritsUnionMatcher$module$1 === null)) {
    this.InheritsUnionMatcher$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher$().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$.prototype.InheritsUnionMatcher__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher$ = (function() {
  if ((this.InheritsUnionMatcher$module$1 === null)) {
    this.InheritsUnionMatcher$lzycompute$1__p1__V()
  };
  return this.InheritsUnionMatcher$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$.prototype.apply__Lamf_core_model_domain_Shape__Lorg_yaml_model_YNode__Z__Lamf_core_parser_ParserContext__s_Option = (function(shape, part, plainUnion, ctx) {
  _apply: while (true) {
    var x1 = shape;
    var this$1 = shape;
    if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1).isDefined__Z()) {
      var rc7 = false;
      var x2 = null;
      var this$2 = shape;
      var x1$2 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2);
      if ((x1$2 instanceof $c_s_Some)) {
        rc7 = true;
        x2 = $as_s_Some(x1$2);
        var linkedShape = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
        if ((linkedShape instanceof $c_Lamf_core_model_domain_Shape)) {
          var x4 = $as_Lamf_core_model_domain_Shape(linkedShape);
          var x$3 = shape;
          if (((x4 === null) ? (x$3 === null) : x4.equals__O__Z(x$3))) {
            return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$())
          }
        }
      };
      if (rc7) {
        var linkedShape$2 = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
        if ((linkedShape$2 instanceof $c_Lamf_core_model_domain_Shape)) {
          var x5 = $as_Lamf_core_model_domain_Shape(linkedShape$2);
          shape = x5;
          continue _apply
        }
      };
      var this$3 = ctx.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidTypeDefinition$1;
      var node = shape.id$1;
      var prop = $m_s_None$();
      var l = part.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$3, specification, node, prop, "Found reference to domain element different of Shape when shape was expected", l);
      return $m_s_None$()
    } else if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_NilShape)) {
      return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$NilType$())
    } else if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
      var x3 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(x1);
      var jsx$2 = $m_Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$();
      var jsx$1 = $m_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$();
      var this$4 = $as_Lamf_core_model_StrField(x3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1));
      var this$5 = this$4.option$1;
      var x1$3 = jsx$2.matchType__Lamf_plugins_domain_shapes_models_TypeDef__s_Option__Lamf_plugins_document_webapi_parser_TypeName(jsx$1.typeDef__T__Lamf_plugins_domain_shapes_models_TypeDef($as_T((this$5.isEmpty__Z() ? null : this$5.get__O()))), $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__format__Lamf_core_model_StrField(x3).option$1);
      if ((x1$3 === null)) {
        throw new $c_s_MatchError().init___O(x1$3)
      };
      var typeDef = x1$3.typeDef$1;
      var format = x1$3.format$1;
      return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$().matchType__Lamf_plugins_document_webapi_parser_TypeName__Lamf_plugins_domain_shapes_models_TypeDef__Z__Lamf_plugins_domain_shapes_models_TypeDef(new $c_Lamf_plugins_document_webapi_parser_TypeName().init___T__s_Option(typeDef, format), ($m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$(), $m_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$()), ($m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$(), false)))
    } else if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
      var x4$2 = $as_Lamf_plugins_domain_shapes_models_UnionShape(x1);
      return (plainUnion ? this.InheritsUnionMatcher__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher$().apply__Lamf_plugins_domain_shapes_models_UnionShape__Lorg_yaml_model_YNode__Lamf_core_parser_ParserContext__s_Option(x4$2, part, ctx) : new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$()))
    } else {
      return ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape) ? new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$()) : ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape) ? new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$()) : ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_MatrixShape) ? new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$()) : ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape) ? new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$()) : $m_s_None$()))))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$.prototype.findEventualShapes__p1__Lorg_yaml_model_YMap__sc_Seq = (function(map) {
  var this$1 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeDetector$$ctx$f.syntax__Lamf_plugins_document_webapi_parser_spec_SpecSyntax().nodes__sci_Map();
  var p = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(k$2) {
      var k = $as_T(k$2);
      return ($m_sjsr_RuntimeString$().endsWith__T__T__Z(k, "Shape") && (k !== "schemaShape"))
    })
  })(this));
  var shapesNodes = new $c_sci_MapLike$$anon$1().init___sci_MapLike__F1(this$1, p);
  var elem = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var possibles = new $c_sr_ObjectRef().init___O(elem);
  map.entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, shapesNodes$1, possibles$1) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var locals = $as_sci_Map(shapesNodes$1.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, entry$1) {
        return (function(value$2) {
          var value = $as_T2(value$2);
          var this$3 = $as_sc_GenSetLike(value.$$und2__O());
          var elem$1 = entry$1.key$2.toString__T();
          return this$3.contains__O__Z(elem$1)
        })
      })(this$2$1, entry))));
      if ($f_sc_TraversableOnce__nonEmpty__Z(locals)) {
        if ($as_sc_Seq(possibles$1.elem$1).isEmpty__Z()) {
          var this$4 = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(locals);
          possibles$1.elem$1 = $f_sc_SetLike__toSeq__sc_Seq(this$4)
        } else {
          var this$5 = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(locals);
          var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
          var this$7 = this$5.$$outer$4.keysIterator__sc_Iterator();
          while (this$7.hasNext__Z()) {
            var arg1 = this$7.next__O();
            var k$1 = $as_T(arg1);
            if (($as_sc_Seq(possibles$1.elem$1).contains__O__Z(k$1) !== false)) {
              b.$$plus$eq__O__scm_SetBuilder(arg1)
            }
          };
          possibles$1.elem$1 = b.elems$1.toSeq__sc_Seq()
        }
      }
    })
  })(this, shapesNodes, possibles)));
  return $as_sc_Seq($as_sc_Seq(possibles.elem$1).distinct__O())
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$.prototype.fetchByRamlSyntax__Lorg_yaml_model_YMap__s_Option = (function(map) {
  var defs = this.findEventualShapes__p1__Lorg_yaml_model_YMap__sc_Seq(map).toList__sci_List();
  var jsx$2 = $m_s_Option$();
  var rc12 = false;
  var x8 = null;
  var rc13 = false;
  var x2 = null;
  var f = (function($this) {
    return (function(x$9$2) {
      var x$9 = $as_T(x$9$2);
      return (x$9 !== "shape")
    })
  })(this);
  if ((defs !== null)) {
    var l = defs;
    var l$1 = l;
    x: {
      var result;
      _noneIn: while (true) {
        if (l$1.isEmpty__Z()) {
          var result = $m_sci_Nil$();
          break
        } else {
          var h = l$1.head__O();
          var t = $as_sci_List(l$1.tail__O());
          if (($uZ(f(h)) === false)) {
            l$1 = t;
            continue _noneIn
          };
          var start = l$1;
          var remaining = t;
          var remaining$1 = remaining;
          _allIn: while (true) {
            if (remaining$1.isEmpty__Z()) {
              var result = start;
              break x
            } else {
              var x$2 = remaining$1.head__O();
              if (($uZ(f(x$2)) !== false)) {
                remaining$1 = $as_sci_List(remaining$1.tail__O());
                continue _allIn
              };
              var firstMiss = remaining$1;
              var newHead = new $c_sci_$colon$colon().init___O__sci_List(start.head__O(), $m_sci_Nil$());
              var toProcess = $as_sci_List(start.tail__O());
              var currentLast = newHead;
              while ((toProcess !== firstMiss)) {
                var newElem = new $c_sci_$colon$colon().init___O__sci_List(toProcess.head__O(), $m_sci_Nil$());
                currentLast.tl$5 = newElem;
                currentLast = newElem;
                toProcess = $as_sci_List(toProcess.tail__O())
              };
              var next = $as_sci_List(firstMiss.tail__O());
              var nextToCopy = next;
              while ((!next.isEmpty__Z())) {
                var head = next.head__O();
                if (($uZ(f(head)) !== false)) {
                  next = $as_sci_List(next.tail__O())
                } else {
                  while ((nextToCopy !== next)) {
                    var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy.head__O(), $m_sci_Nil$());
                    currentLast.tl$5 = newElem$2;
                    currentLast = newElem$2;
                    nextToCopy = $as_sci_List(nextToCopy.tail__O())
                  };
                  nextToCopy = $as_sci_List(next.tail__O());
                  next = $as_sci_List(next.tail__O())
                }
              };
              if ((!nextToCopy.isEmpty__Z())) {
                currentLast.tl$5 = nextToCopy
              };
              var result = newHead;
              break x
            }
          }
        }
      }
    };
    var x1 = result
  } else {
    $m_sci_List$();
    var b = new $c_scm_ListBuffer().init___();
    var these = defs;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      if (($uZ(f(arg1)) !== false)) {
        b.$$plus$eq__O__scm_ListBuffer(arg1)
      };
      these = $as_sci_List(these.tail__O())
    };
    var x1 = b.toList__sci_List()
  };
  matchEnd14: {
    var jsx$1;
    var x = $m_sci_Nil$();
    if (x.equals__O__Z(x1)) {
      rc12 = true;
      x8 = x1;
      if ($f_sc_LinearSeqOptimized__contains__O__Z(defs, "shape")) {
        var jsx$1 = $m_Lamf_plugins_domain_shapes_models_TypeDef$StrType$();
        break matchEnd14
      }
    };
    if ((rc12 && (!$f_sc_LinearSeqOptimized__contains__O__Z(defs, "shape")))) {
      var jsx$1 = this.$$outer$1.defaultType$1.typeDef__Lamf_plugins_domain_shapes_models_TypeDef();
      break matchEnd14
    };
    if ((x1 instanceof $c_sci_$colon$colon)) {
      rc13 = true;
      x2 = $as_sci_$colon$colon(x1);
      var head$1 = $as_T(x2.head$5);
      var p3 = x2.tl$5;
      var x$3 = $m_sci_Nil$();
      if (x$3.equals__O__Z(p3)) {
        if ((head$1 === "nodeShape")) {
          var jsx$1 = $m_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$();
          break matchEnd14
        } else if ((head$1 === "arrayShape")) {
          var jsx$1 = $m_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$();
          break matchEnd14
        } else if ((head$1 === "stringScalarShape")) {
          var jsx$1 = $m_Lamf_plugins_domain_shapes_models_TypeDef$StrType$();
          break matchEnd14
        } else if ((head$1 === "numberScalarShape")) {
          var jsx$1 = $m_Lamf_plugins_domain_shapes_models_TypeDef$IntType$();
          break matchEnd14
        } else {
          if ((head$1 !== "fileShape")) {
            throw new $c_s_MatchError().init___O(head$1)
          };
          var jsx$1 = $m_Lamf_plugins_domain_shapes_models_TypeDef$FileType$();
          break matchEnd14
        }
      }
    };
    if (rc13) {
      var tail = x2.tl$5;
      if (($f_sc_TraversableOnce__nonEmpty__Z(tail) && new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("type").isDefined__Z())) {
        var jsx$1 = $m_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$();
        break matchEnd14
      }
    };
    if (rc13) {
      var tail$2 = x2.tl$5;
      if ($f_sc_TraversableOnce__nonEmpty__Z(tail$2)) {
        var jsx$1 = $m_Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$();
        break matchEnd14
      }
    };
    throw new $c_s_MatchError().init___O(x1)
  };
  return jsx$2.apply__O__s_Option(jsx$1)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeDetector$ShapeClassTypeDefMatcher$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParserAnnotations$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParserAnnotations$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParserAnnotations$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParserAnnotations$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParserAnnotations$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParserAnnotations$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParserAnnotations$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParserAnnotations$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParserAnnotations$.prototype.apply__T__Lorg_yaml_model_YMap__Lamf_core_Root__Lamf_plugins_document_webapi_contexts_WebApiContext__T2 = (function(key, map, root, ctx) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var tmp = new $c_Lamf_core_model_document_Document().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var declarations = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser().init___Lamf_core_model_document_BaseUnit__T__Lorg_yaml_model_YMap__sc_Seq__Lamf_plugins_document_webapi_contexts_WebApiContext(tmp, key, map, root.references$1, ctx).parse__T__Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations(root.location$1);
  return new $c_T2().init___O__O(declarations, tmp.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_Aliases.getClassOf()))
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParserAnnotations$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParserAnnotations$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.ReferencesParserAnnotations$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParserAnnotations$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParserAnnotations$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParserAnnotations$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParserAnnotations$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParserAnnotations$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParserAnnotations$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParserAnnotations$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParserAnnotations$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParserAnnotations$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$.prototype.convert__Lamf_plugins_domain_shapes_models_TypeDef__Lorg_yaml_model_YType = (function(datatype) {
  var x = $m_Lamf_plugins_domain_shapes_models_TypeDef$IntType$();
  if ((x === datatype)) {
    return $m_Lorg_yaml_model_YType$().Int$1
  } else {
    return $m_Lorg_yaml_model_YType$().Float$1
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$.prototype.convert__s_Option__Lorg_yaml_model_YType = (function(datatype) {
  return this.convert__Lamf_plugins_domain_shapes_models_TypeDef__Lorg_yaml_model_YType($as_Lamf_plugins_domain_shapes_models_TypeDef((datatype.isEmpty__Z() ? $m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$() : datatype.get__O())))
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.NumberTypeToYTypeConverter$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__build__pLamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__D__T__Lamf_core_metamodel_Field__scm_ListBuffer__V($thiz, value, constraint, f, result) {
  var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, new $c_Lamf_core_parser_Annotations().init___());
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(constraint, new $c_Lamf_core_parser_FieldEntry().init___Lamf_core_metamodel_Field__Lamf_core_parser_Value(f, new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value$1, annotations)), new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$().convert__s_Option__Lorg_yaml_model_YType($thiz.typeDef__s_Option()))))
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__emitFormatRanges__Lamf_core_parser_Fields__scm_ListBuffer__V($thiz, fs, result) {
  var this$1 = $thiz.typeDef__s_Option();
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var x$1 = $as_Lamf_plugins_domain_shapes_models_TypeDef(arg1);
    var jsx$1 = $f_Lamf_plugins_domain_shapes_models_TypeDef__isNumber__Z(x$1)
  } else {
    var jsx$1 = false
  };
  if ((jsx$1 && ($thiz.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext() instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext))) {
    var x1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Format$1);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var fe = $as_Lamf_core_parser_FieldEntry(x2.value$2);
      var this$2 = fe.value$1;
      var format = this$2.value$1.toString__T();
      var minMax = ((format === "int8") ? new $c_s_Some().init___O(new $c_s_Tuple2$mcDD$sp().init___D__D((-128.0), 127.0)) : ((format === "int16") ? new $c_s_Some().init___O(new $c_s_Tuple2$mcDD$sp().init___D__D((-32768.0), 32767.0)) : ((format === "int32") ? new $c_s_Some().init___O(new $c_s_Tuple2$mcDD$sp().init___D__D((-2.147483648E9), 2.147483647E9)) : ((format === "int64") ? new $c_s_Some().init___O(new $c_s_Tuple2$mcDD$sp().init___D__D((-9.223372036854776E18), 9.223372036854776E18)) : $m_s_None$()))));
      var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Minimum$1);
      if (this$3.isEmpty__Z()) {
        if ((!minMax.isEmpty__Z())) {
          var arg1$1 = minMax.get__O();
          var m = $as_T2(arg1$1);
          var min = m.$$und1$mcD$sp__D();
          var f = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Minimum$1;
          $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__build__pLamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__D__T__Lamf_core_metamodel_Field__scm_ListBuffer__V($thiz, min, "minimum", f, result)
        }
      } else {
        var arg1$2 = this$3.get__O();
        var f$1 = $as_Lamf_core_parser_FieldEntry(arg1$2);
        $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__emitMin__pLamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__Lamf_core_parser_FieldEntry__scm_ListBuffer__Z__scm_ListBuffer($thiz, f$1, result, false)
      };
      var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Maximum$1);
      if (this$4.isEmpty__Z()) {
        if ((!minMax.isEmpty__Z())) {
          var arg1$3 = minMax.get__O();
          var m$1 = $as_T2(arg1$3);
          var max = m$1.$$und2$mcD$sp__D();
          var f$2 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Maximum$1;
          $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__build__pLamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__D__T__Lamf_core_metamodel_Field__scm_ListBuffer__V($thiz, max, "maximum", f$2, result)
        }
      } else {
        var arg1$4 = this$4.get__O();
        var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$4);
        $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__emitMax__pLamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__Lamf_core_parser_FieldEntry__scm_ListBuffer__Z__scm_ListBuffer($thiz, f$3, result, false)
      }
    } else {
      $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__emitMinAndMax__pLamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__Lamf_core_parser_Fields__scm_ListBuffer__V($thiz, fs, result)
    }
  } else {
    var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Format$1);
    if ((!this$5.isEmpty__Z())) {
      var arg1$5 = this$5.get__O();
      var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$5);
      var jsx$3 = $m_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$();
      var jsx$2 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Format$1;
      var format$1 = $as_Lamf_core_model_domain_AmfScalar(f$4.value$1.value$1).toString__T();
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(jsx$3.apply__T__Lamf_core_metamodel_Field__O__Lamf_core_parser_Annotations__Lamf_core_emitter_BaseEmitters_package$ValueEmitter("format", jsx$2, $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFormatTranslator__checkRamlFormats__T__T($thiz, format$1), f$4.value$1.annotations$1)))
    };
    $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__emitMinAndMax__pLamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__Lamf_core_parser_Fields__scm_ListBuffer__V($thiz, fs, result)
  }
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__emitMax__pLamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__Lamf_core_parser_FieldEntry__scm_ListBuffer__Z__scm_ListBuffer($thiz, f, result, isExclusive) {
  return result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option((isExclusive ? "exclusiveMaximum" : "maximum"), f, new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$().convert__s_Option__Lorg_yaml_model_YType($thiz.typeDef__s_Option()))))
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__emitMin__pLamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__Lamf_core_parser_FieldEntry__scm_ListBuffer__Z__scm_ListBuffer($thiz, f, result, isExclusive) {
  return result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option((isExclusive ? "exclusiveMinimum" : "minimum"), f, new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$().convert__s_Option__Lorg_yaml_model_YType($thiz.typeDef__s_Option()))))
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__emitCommonFields__Lamf_core_parser_Fields__scm_ListBuffer__V($thiz, fs, result) {
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Pattern$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("pattern", f, $m_s_None$())))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MinLength$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("minLength", f$3, $m_s_None$())))
  };
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MaxLength$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1$2 = this$5.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("maxLength", f$4, $m_s_None$())))
  };
  $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__emitFormatRanges__Lamf_core_parser_Fields__scm_ListBuffer__V($thiz, fs, result);
  var x = $thiz.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext().schemaVersion__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion();
  var x$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$();
  if ((!((x !== null) && x.equals__O__Z(x$2)))) {
    var this$7 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().ExclusiveMinimum$1);
    if ((!this$7.isEmpty__Z())) {
      var arg1$3 = this$7.get__O();
      var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("exclusiveMinimum", f$5, $m_s_None$())))
    };
    var this$9 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().ExclusiveMaximum$1);
    if ((!this$9.isEmpty__Z())) {
      var arg1$4 = this$9.get__O();
      var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$4);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("exclusiveMaximum", f$6, $m_s_None$())))
    }
  };
  var this$11 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MultipleOf$1);
  if ((!this$11.isEmpty__Z())) {
    var arg1$5 = this$11.get__O();
    var f$7 = $as_Lamf_core_parser_FieldEntry(arg1$5);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("multipleOf", f$7, new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$().convert__s_Option__Lorg_yaml_model_YType($thiz.typeDef__s_Option())))))
  }
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__emitMinAndMax__pLamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__Lamf_core_parser_Fields__scm_ListBuffer__V($thiz, fs, result) {
  var x = $thiz.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext().schemaVersion__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion();
  var x$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$();
  if (((x !== null) && x.equals__O__Z(x$2))) {
    var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Minimum$1);
    if ((!this$1.isEmpty__Z())) {
      var arg1 = this$1.get__O();
      var x$2$2 = $as_Lamf_core_parser_FieldEntry(arg1);
      var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().ExclusiveMinimum$1);
      if ((!this$2.isEmpty__Z())) {
        var arg1$1 = this$2.get__O();
        var x$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
        var isExclusive = $as_Lamf_core_model_domain_AmfScalar(x$3.value$1.value$1).toBool__Z()
      } else {
        var isExclusive = false
      };
      $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__emitMin__pLamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__Lamf_core_parser_FieldEntry__scm_ListBuffer__Z__scm_ListBuffer($thiz, x$2$2, result, isExclusive)
    };
    var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Maximum$1);
    if ((!this$3.isEmpty__Z())) {
      var arg1$2 = this$3.get__O();
      var x$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
      var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().ExclusiveMaximum$1);
      if ((!this$4.isEmpty__Z())) {
        var arg1$3 = this$4.get__O();
        var x$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
        var isExclusive$1 = $as_Lamf_core_model_domain_AmfScalar(x$5.value$1.value$1).toBool__Z()
      } else {
        var isExclusive$1 = false
      };
      $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__emitMax__pLamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__Lamf_core_parser_FieldEntry__scm_ListBuffer__Z__scm_ListBuffer($thiz, x$4, result, isExclusive$1)
    }
  } else {
    var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Minimum$1);
    if ((!this$5.isEmpty__Z())) {
      var arg1$4 = this$5.get__O();
      var x$6 = $as_Lamf_core_parser_FieldEntry(arg1$4);
      $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__emitMin__pLamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__Lamf_core_parser_FieldEntry__scm_ListBuffer__Z__scm_ListBuffer($thiz, x$6, result, false)
    };
    var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Maximum$1);
    if ((!this$6.isEmpty__Z())) {
      var arg1$5 = this$6.get__O();
      var x$7 = $as_Lamf_core_parser_FieldEntry(arg1$5);
      $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__emitMax__pLamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__Lamf_core_parser_FieldEntry__scm_ListBuffer__Z__scm_ListBuffer($thiz, x$7, result, false)
    }
  }
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.pointer$1 = null;
  this.schemaPath$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeEmitter.prototype.emitters__sc_Seq = (function() {
  var this$1 = this.spec$1.options__Lamf_core_emitter_ShapeRenderOptions();
  var emitDocumentation = this$1.amf$core$emitter$ShapeRenderOptions$$documentation$1;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var fs = this.shape$1.fields__Lamf_core_parser_Fields();
  if (emitDocumentation) {
    var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ShapeModel$().DisplayName$1);
    if ((!this$2.isEmpty__Z())) {
      var arg1 = this$2.get__O();
      var f = $as_Lamf_core_parser_FieldEntry(arg1);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("title", f, $m_s_None$())))
    };
    var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ShapeModel$().Description$1);
    if ((!this$4.isEmpty__Z())) {
      var arg1$1 = this$4.get__O();
      var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f$3, $m_s_None$())))
    };
    var x1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ShapeModel$().Default$1);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var f$4 = $as_Lamf_core_parser_FieldEntry(x2.value$2);
      var this$6 = this.shape$1;
      var x$2 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler($as_Lamf_core_model_domain_DataNode(this$6.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Default$1)), this.ordering$1, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler());
      var this$8 = $m_Lamf_core_emitter_BaseEmitters_package$();
      var annotations = f$4.value$1.annotations$1;
      var x$3 = this$8.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf());
      var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position("default", x$2, x$4, x$3))
    } else {
      var x = $m_s_None$();
      if ((x === x1)) {
        var this$10 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ShapeModel$().DefaultValueString$1);
        if ((!this$10.isEmpty__Z())) {
          var arg1$2 = this$10.get__O();
          var dv = $as_Lamf_core_parser_FieldEntry(arg1$2);
          new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("default", dv, $m_s_None$())))
        }
      } else {
        throw new $c_s_MatchError().init___O(x1)
      }
    };
    var this$12 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Documentation$1);
    if ((!this$12.isEmpty__Z())) {
      var arg1$3 = this$12.get__O();
      var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter().init___T__Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("externalDocs", $as_Lamf_plugins_domain_shapes_models_CreativeWork(f$5.value$1.value$1), this.ordering$1, this.spec$1)))
    }
  };
  var this$13 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ShapeModel$().Values$1);
  if ((!this$13.isEmpty__Z())) {
    var arg1$4 = this$13.get__O();
    var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter().init___T__Lamf_core_parser_Value__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("enum", f$6.value$1, this.ordering$1, this.spec$1)))
  };
  var this$14 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().XMLSerialization$1);
  if ((!this$14.isEmpty__Z())) {
    var arg1$5 = this$14.get__O();
    var f$7 = $as_Lamf_core_parser_FieldEntry(arg1$5);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("xml", f$7, this.ordering$1, this.spec$1)))
  };
  this.emitNullable__scm_ListBuffer__V(result);
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.shape$1, this.ordering$1, this.spec$1).emitters__sc_Seq());
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.shape$1, this.ordering$1, this.spec$1).emitters__sc_Seq());
  var this$15 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ShapeModel$().CustomShapePropertyDefinitions__Lamf_core_metamodel_Field());
  if ((!this$15.isEmpty__Z())) {
    var arg1$6 = this$15.get__O();
    var f$8 = $as_Lamf_core_parser_FieldEntry(arg1$6);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory().customFacetsEmitter__F3().apply__O__O__O__O(f$8, this.ordering$1, this.references$1)))
  };
  var jsx$2 = $m_s_Option$();
  var this$16 = this.shape$1;
  if (jsx$2.apply__O__s_Option($as_sc_Seq(this$16.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().And$1))).isDefined__Z()) {
    var this$17 = this.shape$1;
    var jsx$1 = $as_sc_Seq(this$17.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().And$1)).nonEmpty__Z()
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.shape$1, this.ordering$1, this.references$1, this.pointer$1, this.schemaPath$1, this.spec$1))
  };
  var jsx$4 = $m_s_Option$();
  var this$18 = this.shape$1;
  if (jsx$4.apply__O__s_Option($as_sc_Seq(this$18.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Or$1))).isDefined__Z()) {
    var this$19 = this.shape$1;
    var jsx$3 = $as_sc_Seq(this$19.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Or$1)).nonEmpty__Z()
  } else {
    var jsx$3 = false
  };
  if (jsx$3) {
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.shape$1, this.ordering$1, this.references$1, this.pointer$1, this.schemaPath$1, this.spec$1))
  };
  var jsx$6 = $m_s_Option$();
  var this$20 = this.shape$1;
  if (jsx$6.apply__O__s_Option($as_sc_Seq(this$20.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Xone$1))).isDefined__Z()) {
    var this$21 = this.shape$1;
    var jsx$5 = $as_sc_Seq(this$21.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Xone$1)).nonEmpty__Z()
  } else {
    var jsx$5 = false
  };
  if (jsx$5) {
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.shape$1, this.ordering$1, this.references$1, this.pointer$1, this.schemaPath$1, this.spec$1))
  };
  var jsx$7 = $m_s_Option$();
  var this$22 = this.shape$1;
  if (jsx$7.apply__O__s_Option($as_Lamf_core_model_domain_Shape(this$22.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Not$1))).isDefined__Z()) {
    var this$23 = this.shape$1;
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter().init___T__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext("not", $as_Lamf_core_model_domain_Shape(this$23.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Not$1)), this.ordering$1, this.references$1, this.pointer$1, this.schemaPath$1, this.spec$1))
  };
  var this$24 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ShapeModel$().ReadOnly$1);
  if ((!this$24.isEmpty__Z())) {
    var arg1$7 = this$24.get__O();
    var fe = $as_Lamf_core_parser_FieldEntry(arg1$7);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("readOnly", fe, $m_s_None$())))
  };
  if ((this.spec$1.schemaVersion__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion() instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion)) {
    var jsx$8 = true
  } else {
    var x$6 = this.spec$1.schemaVersion__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion();
    var x$7 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$();
    var jsx$8 = ((x$6 !== null) && x$6.equals__O__Z(x$7))
  };
  if (jsx$8) {
    var this$26 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ShapeModel$().Deprecated$1);
    if ((!this$26.isEmpty__Z())) {
      var arg1$8 = this$26.get__O();
      var f$9 = $as_Lamf_core_parser_FieldEntry(arg1$8);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("deprecated", f$9, $m_s_None$())))
    };
    var this$28 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ShapeModel$().WriteOnly$1);
    if ((!this$28.isEmpty__Z())) {
      var arg1$9 = this$28.get__O();
      var fe$3 = $as_Lamf_core_parser_FieldEntry(arg1$9);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("writeOnly", fe$3, $m_s_None$())))
    }
  };
  var x$8 = this.spec$1.schemaVersion__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion();
  var x$9 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$();
  if (((x$8 !== null) && x$8.equals__O__Z(x$9))) {
    var jsx$9 = $m_s_Option$();
    var this$30 = this.shape$1;
    if (jsx$9.apply__O__s_Option($as_Lamf_core_model_domain_Shape(this$30.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().If$1))).isDefined__Z()) {
      var this$31 = this.shape$1;
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter().init___T__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext("if", $as_Lamf_core_model_domain_Shape(this$31.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().If$1)), this.ordering$1, this.references$1, this.pointer$1, this.schemaPath$1, this.spec$1))
    };
    var jsx$10 = $m_s_Option$();
    var this$32 = this.shape$1;
    if (jsx$10.apply__O__s_Option($as_Lamf_core_model_domain_Shape(this$32.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Then$1))).isDefined__Z()) {
      var this$33 = this.shape$1;
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter().init___T__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext("then", $as_Lamf_core_model_domain_Shape(this$33.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Then$1)), this.ordering$1, this.references$1, this.pointer$1, this.schemaPath$1, this.spec$1))
    };
    var jsx$11 = $m_s_Option$();
    var this$34 = this.shape$1;
    if (jsx$11.apply__O__s_Option($as_Lamf_core_model_domain_Shape(this$34.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().If$1))).isDefined__Z()) {
      var this$35 = this.shape$1;
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter().init___T__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext("else", $as_Lamf_core_model_domain_Shape(this$35.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Else$1)), this.ordering$1, this.references$1, this.pointer$1, this.schemaPath$1, this.spec$1))
    }
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeEmitter.prototype.emitNullable__scm_ListBuffer__V = (function(result) {
  var x1 = this.shape$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_NilUnion.getClassOf());
  matchEnd5: {
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var p3 = $as_Lamf_core_annotations_NilUnion(x2.value$2);
      if ((p3 !== null)) {
        var rangeString = p3.position$1;
        var jsx$2 = $m_Lamf_core_metamodel_Type$Bool$();
        var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
        var jsx$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "nullable"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "nullable", "This field can accept a null value", $m_sci_Nil$()), true);
        var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(true, new $c_Lamf_core_parser_Annotations().init___());
        $m_Lamf_core_parser_Annotations$();
        var annotation = $m_Lamf_core_annotations_LexicalInformation$().apply__T__Lamf_core_annotations_LexicalInformation(rangeString);
        var annotations = new $c_Lamf_core_parser_Annotations().init___().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(annotation);
        result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("nullable", new $c_Lamf_core_parser_FieldEntry().init___Lamf_core_metamodel_Field__Lamf_core_parser_Value(jsx$1, new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value, annotations)), $m_s_None$()));
        break matchEnd5
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(shape, ordering, references, pointer, schemaPath, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.pointer$1 = pointer;
  this.schemaPath$1 = schemaPath;
  this.spec$1 = spec;
  return this
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.ignored$1 = null;
  this.references$1 = null;
  this.spec$1 = null;
  this.$$undemitters$1 = null;
  this.$$undemitter$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector.prototype.emitter__sc_Seq__sc_Seq__s_util_Either = (function(pointer, schemaPath) {
  var x1 = this.$$undemitter$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var em = $as_s_util_Either(x2.value$2);
    return em
  } else {
    var x1$2 = this.emitters__sc_Seq__sc_Seq__sc_Seq(pointer, schemaPath);
    matchEnd5: {
      var jsx$1;
      $m_sc_Seq$();
      var o8 = new $c_s_Some().init___O(x1$2);
      if (((o8.value$2 !== null) && ($as_sc_SeqLike(o8.value$2).lengthCompare__I__I(1) === 0))) {
        var p = $as_Lamf_core_emitter_Emitter($as_sc_SeqLike(o8.value$2).apply__I__O(0));
        if ($is_Lamf_core_emitter_PartEmitter(p)) {
          var x3 = $as_Lamf_core_emitter_PartEmitter(p);
          $m_s_package$();
          var jsx$1 = new $c_s_util_Left().init___O(x3);
          break matchEnd5
        }
      };
      if (x1$2.forall__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x$1$2) {
          var x$1 = $as_Lamf_core_emitter_Emitter(x$1$2);
          return $is_Lamf_core_emitter_EntryEmitter(x$1)
        })
      })(this)))) {
        $m_s_package$();
        var jsx$2 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector$$anonfun$emitter$2().init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector(this);
        var this$3 = $m_sc_Seq$();
        var value = x1$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$2, this$3.ReusableCBFInstance$2);
        var jsx$1 = new $c_s_util_Right().init___O(value);
        break matchEnd5
      };
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("IllegalTypeDeclarations found: " + x1$2)))
    };
    this.$$undemitter$1 = new $c_s_Some().init___O(jsx$1);
    return $as_s_util_Either(this.$$undemitter$1.get__O())
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector.prototype.emitters__sc_Seq__sc_Seq__sc_Seq = (function(pointer, schemaPath) {
  var x1 = this.$$undemitters$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var ems = $as_sc_Seq(x2.value$2);
    return ems
  } else {
    this.$$undemitters$1 = new $c_s_Some().init___O(this.ordering$1.sorted__sc_Seq__sc_Seq(this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory().typeEmitters__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq(this.shape$1, this.ordering$1, this.ignored$1, this.references$1, pointer, schemaPath)));
    return $as_sc_Seq(this.$$undemitters$1.get__O())
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(shape, ordering, ignored, references, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.ignored$1 = ignored;
  this.references$1 = references;
  this.spec$1 = spec;
  this.$$undemitters$1 = $m_s_None$();
  this.$$undemitter$1 = $m_s_None$();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector.prototype.getEmitters__sc_Seq = (function() {
  var this$1 = this.$$undemitters$1;
  return $as_sc_Seq((this$1.isEmpty__Z() ? $m_sci_Nil$() : this$1.get__O()))
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null;
  this.typeEmitted$1 = false;
  this.valuesTag$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter.prototype.emitters__sc_Seq = (function() {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var fs = this.shape$1.fields__Lamf_core_parser_Fields();
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ShapeModel$().DisplayName$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("displayName", f, $m_s_None$(), this.spec$1)))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ShapeModel$().Description$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("description", f$3, $m_s_None$(), this.spec$1)))
  };
  var x1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ShapeModel$().Default$1);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var f$4 = $as_Lamf_core_parser_FieldEntry(x2.value$2);
    var this$5 = this.shape$1;
    var jsx$3 = $as_Lamf_core_model_domain_DataNode(this$5.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Default$1));
    var jsx$2 = this.ordering$1;
    var jsx$1 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var this$7 = this.spec$1;
    var x$2 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler(jsx$3, jsx$2, false, jsx$1, this$7.eh$1);
    var this$8 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = f$4.value$1.annotations$1;
    var x$3 = this$8.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position("default", x$2, x$4, x$3))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$10 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ShapeModel$().DefaultValueString$1);
      if ((!this$10.isEmpty__Z())) {
        var arg1$2 = this$10.get__O();
        var dv = $as_Lamf_core_parser_FieldEntry(arg1$2);
        new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("default", dv, $m_s_None$())))
      }
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  var this$12 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ShapeModel$().Values$1);
  if ((!this$12.isEmpty__Z())) {
    var arg1$3 = this$12.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter().init___T__Lamf_core_parser_Value__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("enum", f$5.value$1, this.ordering$1, this.spec$1)))
  };
  var this$13 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Documentation$1);
  if ((!this$13.isEmpty__Z())) {
    var arg1$4 = this$13.get__O();
    var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter().init___T__Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(new $c_Lamf_core_utils_package$AmfStrings().init___T("externalDocs").asRamlAnnotation__T(), $as_Lamf_plugins_domain_shapes_models_CreativeWork(f$6.value$1.value$1), this.ordering$1, this.spec$1)))
  };
  var this$15 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().ReadOnly$1);
  if ((!this$15.isEmpty__Z())) {
    var arg1$5 = this$15.get__O();
    var fe = $as_Lamf_core_parser_FieldEntry(arg1$5);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("readOnly").asRamlAnnotation__T(), fe, $m_s_None$())))
  };
  var this$18 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().XMLSerialization$1);
  if ((!this$18.isEmpty__Z())) {
    var arg1$6 = this$18.get__O();
    var f$7 = $as_Lamf_core_parser_FieldEntry(arg1$6);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("xml", f$7, this.ordering$1, this.spec$1)))
  };
  var this$19 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ShapeModel$().CustomShapePropertyDefinitions__Lamf_core_metamodel_Field());
  if ((!this$19.isEmpty__Z())) {
    var arg1$7 = this$19.get__O();
    var f$8 = $as_Lamf_core_parser_FieldEntry(arg1$7);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory().customFacetsEmitter__F3().apply__O__O__O__O(f$8, this.ordering$1, this.references$1)))
  };
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.shape$1, this.ordering$1, this.spec$1).emitters__sc_Seq());
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.shape$1, this.ordering$1, this.spec$1).emitters__sc_Seq());
  var this$20 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1);
  if (this$20.isEmpty__Z()) {
    var this$21 = this.typeName__s_Option();
    if ((!this$21.isEmpty__Z())) {
      var arg1$8 = this$21.get__O();
      var value = $as_T(arg1$8);
      var x1$1 = this.spec$1.ramlTypePropertyEmitter__T__Lamf_core_model_domain_Shape__s_Option(value, this.shape$1);
      if ((x1$1 instanceof $c_s_Some)) {
        var x2$1 = $as_s_Some(x1$1);
        var emitter = $as_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter(x2$1.value$2);
        this.typeEmitted$1 = true;
        result.$$plus$eq__O__scm_ListBuffer(emitter)
      } else {
        var x$1 = $m_s_None$();
        if ((x$1 === x1$1)) {
          this.typeEmitted$1 = false
        } else {
          throw new $c_s_MatchError().init___O(x1$1)
        }
      }
    }
  } else {
    var arg1$9 = this$20.get__O();
    var f$9 = $as_Lamf_core_parser_FieldEntry(arg1$9);
    var jsx$5 = $as_Lamf_core_model_domain_AmfArray(f$9.value$1.value$1).values$1;
    var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$1$2) {
        var x$1$1 = $as_Lamf_core_model_domain_AmfElement(x$1$2);
        return $as_Lamf_core_model_domain_Shape(x$1$1)
      })
    })(this));
    var this$22 = $m_sc_Seq$();
    var this$23 = $as_sc_TraversableOnce(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$4, this$22.ReusableCBFInstance$2));
    var pf = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter(this);
    var x1$2 = $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$23, pf);
    matchEnd5: {
      if ((x1$2 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$2);
        var r = $as_Lamf_core_model_domain_RecursiveShape(x2$2.value$2);
        if ((r !== null)) {
          this.typeEmitted$1 = true;
          result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter().init___Lamf_core_model_domain_RecursiveShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(r, this.ordering$1, this.references$1, this.spec$1).emitters__sc_Seq());
          break matchEnd5
        }
      };
      this.typeEmitted$1 = true;
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(f$9, this.ordering$1, this.references$1, this.spec$1))
    }
  };
  var jsx$7 = $m_s_Option$();
  var this$24 = this.shape$1;
  if (jsx$7.apply__O__s_Option($as_sc_Seq(this$24.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().And$1))).isDefined__Z()) {
    var this$25 = this.shape$1;
    var jsx$6 = $as_sc_Seq(this$25.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().And$1)).nonEmpty__Z()
  } else {
    var jsx$6 = false
  };
  if (jsx$6) {
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(this.shape$1, this.ordering$1, this.references$1, this.spec$1))
  };
  var jsx$9 = $m_s_Option$();
  var this$26 = this.shape$1;
  if (jsx$9.apply__O__s_Option($as_sc_Seq(this$26.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Or$1))).isDefined__Z()) {
    var this$27 = this.shape$1;
    var jsx$8 = $as_sc_Seq(this$27.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Or$1)).nonEmpty__Z()
  } else {
    var jsx$8 = false
  };
  if (jsx$8) {
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(this.shape$1, this.ordering$1, this.references$1, this.spec$1))
  };
  var jsx$11 = $m_s_Option$();
  var this$28 = this.shape$1;
  if (jsx$11.apply__O__s_Option($as_sc_Seq(this$28.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Xone$1))).isDefined__Z()) {
    var this$29 = this.shape$1;
    var jsx$10 = $as_sc_Seq(this$29.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Xone$1)).nonEmpty__Z()
  } else {
    var jsx$10 = false
  };
  if (jsx$10) {
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(this.shape$1, this.ordering$1, this.references$1, this.spec$1))
  };
  var jsx$12 = $m_s_Option$();
  var this$30 = this.shape$1;
  if (jsx$12.apply__O__s_Option($as_Lamf_core_model_domain_Shape(this$30.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Not$1))).isDefined__Z()) {
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(this.shape$1, this.ordering$1, this.references$1, this.spec$1))
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(shape, ordering, references, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  this.typeEmitted$1 = false;
  this.valuesTag$1 = $m_Lorg_yaml_model_YType$().Str$1;
  return this
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$.prototype.isSimpleScalar__p1__Lamf_plugins_domain_shapes_models_ScalarShape__Z = (function(scalar) {
  var this$1 = scalar.fields$2;
  var this$4 = this$1.fs$1;
  var this$2 = $m_Lamf_core_parser_FieldEntry$();
  var f = $f_F2__tupled__F1(this$2);
  var this$3 = $m_sci_Iterable$();
  var bf = this$3.ReusableCBFInstance$2;
  if (($as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$4, f, bf)).size__I() <= 2)) {
    var this$5 = scalar.fields$2;
    var this$8 = this$5.fs$1;
    var this$6 = $m_Lamf_core_parser_FieldEntry$();
    var f$1 = $f_F2__tupled__F1(this$6);
    var this$7 = $m_sci_Iterable$();
    var bf$1 = this$7.ReusableCBFInstance$2;
    var jsx$2 = $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$8, f$1, bf$1));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$1$2) {
        var x$1 = $as_Lamf_core_parser_FieldEntry(x$1$2);
        return x$1.field$1
      })
    })(this));
    var this$9 = $m_sc_Iterable$();
    return $as_sc_IterableLike(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$9.ReusableCBFInstance$2)).forall__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(f$2) {
        var f$3 = $as_Lamf_core_metamodel_Field(f$2);
        var x$2 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Name$1;
        if (((f$3 === null) ? (x$2 === null) : f$3.equals__O__Z(x$2))) {
          return true
        } else {
          var x$4 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
          return ((f$3 === null) ? (x$4 === null) : f$3.equals__O__Z(x$4))
        }
      })
    })(this)))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$.prototype.inlinedEmission__Lamf_plugins_domain_shapes_models_UnionShape__s_Option = (function(shape) {
  var nonLocalReturnKey1 = new $c_O().init___();
  try {
    var jsx$4 = $as_sc_Seq(shape.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, nonLocalReturnKey1$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_model_domain_Shape(x0$1$2);
        if ((x0$1 instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
          var x2 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(x0$1);
          if ($m_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$().isSimpleScalar__p1__Lamf_plugins_domain_shapes_models_ScalarShape__Z(x2)) {
            var jsx$3 = $m_Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$();
            var jsx$2 = $m_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$();
            var this$1 = $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1));
            var this$2 = this$1.option$1;
            var typeName = jsx$3.matchType__Lamf_plugins_domain_shapes_models_TypeDef__s_Option__Lamf_plugins_document_webapi_parser_TypeName(jsx$2.typeDef__T__Lamf_plugins_domain_shapes_models_TypeDef($as_T((this$2.isEmpty__Z() ? null : this$2.get__O()))), $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__format__Lamf_core_model_StrField(x2).option$1);
            var this$3 = typeName.format$1;
            return $as_T((this$3.isEmpty__Z() ? typeName.typeDef$1 : this$3.get__O()))
          }
        };
        if ((x0$1 !== null)) {
          if (($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x0$1).isDefined__Z() && $as_Lamf_core_model_StrField(x0$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1.isDefined__Z())) {
            var this$4 = $as_Lamf_core_model_StrField(x0$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1));
            var this$5 = this$4.option$1;
            return $as_T((this$5.isEmpty__Z() ? null : this$5.get__O()))
          }
        };
        if ((x0$1 instanceof $c_Lamf_plugins_domain_shapes_models_NilShape)) {
          var x4 = $as_Lamf_plugins_domain_shapes_models_NilShape(x0$1);
          var this$6 = x4.fields$2;
          var this$9 = this$6.fs$1;
          var this$7 = $m_Lamf_core_parser_FieldEntry$();
          var f = $f_F2__tupled__F1(this$7);
          var this$8 = $m_sci_Iterable$();
          var bf = this$8.ReusableCBFInstance$2;
          if ($as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$9, f, bf)).isEmpty__Z()) {
            return "nil"
          }
        };
        if ((x0$1 instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
          var x5 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(x0$1);
          var this$10 = x5.fields$2;
          var this$13 = this$10.fs$1;
          var this$11 = $m_Lamf_core_parser_FieldEntry$();
          var f$1 = $f_F2__tupled__F1(this$11);
          var this$12 = $m_sci_Iterable$();
          var bf$1 = this$12.ReusableCBFInstance$2;
          if ($as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$13, f$1, bf$1)).isEmpty__Z()) {
            return "array"
          }
        };
        if ((x0$1 instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
          var x6 = $as_Lamf_plugins_domain_shapes_models_NodeShape(x0$1);
          var this$14 = x6.fields$2;
          var this$17 = this$14.fs$1;
          var this$15 = $m_Lamf_core_parser_FieldEntry$();
          var f$2 = $f_F2__tupled__F1(this$15);
          var this$16 = $m_sci_Iterable$();
          var bf$2 = this$16.ReusableCBFInstance$2;
          if ($as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$17, f$2, bf$2)).isEmpty__Z()) {
            return "object"
          }
        };
        if ((x0$1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
          var x7 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x0$1);
          var this$18 = x7.fields__Lamf_core_parser_Fields();
          var this$21 = this$18.fs$1;
          var this$19 = $m_Lamf_core_parser_FieldEntry$();
          var f$3 = $f_F2__tupled__F1(this$19);
          var this$20 = $m_sci_Iterable$();
          var bf$3 = this$20.ReusableCBFInstance$2;
          if ($as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$21, f$3, bf$3)).isEmpty__Z()) {
            return "any"
          }
        };
        throw new $c_sr_NonLocalReturnControl().init___O__O(nonLocalReturnKey1$1, $m_s_None$())
      })
    })(this, nonLocalReturnKey1));
    var this$22 = $m_sc_Seq$();
    var union = $as_sc_Seq(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$1, this$22.ReusableCBFInstance$2));
    return new $c_s_Some().init___O(union.mkString__T__T(" | "))
  } catch (e) {
    if ((e instanceof $c_sr_NonLocalReturnControl)) {
      var ex = $as_sr_NonLocalReturnControl(e);
      if ((ex.key$2 === nonLocalReturnKey1)) {
        return $as_s_Option(ex.value__O())
      } else {
        throw ex
      }
    } else {
      throw e
    }
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlUnionEmitterHelper$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$.prototype.apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser = (function(node, ctx) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser().init___Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext(node, $m_Lamf_plugins_document_webapi_parser_spec_package$().toOas__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(ctx))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$.prototype.parse__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_domain_webapi_models_License = (function(node, ctx) {
  return $m_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser(node, ctx).parse__Lamf_plugins_domain_webapi_models_License()
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.LicenseParser$", {
  Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter() {
  $c_O.call(this);
  this.element$1 = null;
  this.ast$1 = null;
  this.isFormData$1 = false;
  this.isBody$1 = false;
  this.paramOption$1 = null;
  this.domainElement$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter.prototype.invalids__s_Option = (function() {
  var this$1 = this.paramOption$1;
  if (this$1.isEmpty__Z()) {
    var jsx$1 = true
  } else {
    var arg1 = this$1.get__O();
    var p = $as_Lamf_plugins_domain_webapi_models_Parameter(arg1);
    var this$2 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
    if ((!$f_Lamf_core_model_ValueField__is__O__Z(this$2, "query"))) {
      var this$3 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
      var jsx$3 = (!$f_Lamf_core_model_ValueField__is__O__Z(this$3, "header"))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var this$4 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
      var jsx$2 = (!$f_Lamf_core_model_ValueField__is__O__Z(this$4, "path"))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var this$5 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
      var jsx$1 = (!$f_Lamf_core_model_ValueField__is__O__Z(this$5, "cookie"))
    } else {
      var jsx$1 = false
    }
  };
  if (jsx$1) {
    return this$1
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter.prototype.body__s_Option = (function() {
  if ((!this.isFormData$1)) {
    var this$1 = this.element$1;
    return new $c_s_util_Either$RightProjection().init___s_util_Either(this$1).toOption__s_Option()
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter.prototype.formData__s_Option = (function() {
  if (this.isFormData$1) {
    var this$1 = this.element$1;
    return new $c_s_util_Either$RightProjection().init___s_util_Either(this$1).toOption__s_Option()
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter.prototype.header__s_Option = (function() {
  var this$1 = this.paramOption$1;
  if (this$1.isEmpty__Z()) {
    var jsx$1 = true
  } else {
    var arg1 = this$1.get__O();
    var x$7 = $as_Lamf_plugins_domain_webapi_models_Parameter(arg1);
    var this$2 = $as_Lamf_core_model_StrField(x$7.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
    var jsx$1 = $f_Lamf_core_model_ValueField__is__O__Z(this$2, "header")
  };
  if (jsx$1) {
    return this$1
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter.prototype.init___s_util_Either__s_Option = (function(element, ast) {
  this.element$1 = element;
  this.ast$1 = ast;
  var this$1 = new $c_s_util_Either$RightProjection().init___s_util_Either(element).toOption__s_Option();
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var p = $as_Lamf_plugins_domain_webapi_models_Payload(arg1);
    if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(p).isDefined__Z()) {
      var links = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      var jsx$2 = $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(p, links).annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_plugins_document_webapi_annotations_FormBodyParameter.getClassOf())
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var jsx$1 = true
    } else {
      var jsx$1 = p.annotations$1.contains__jl_Class__Z($d_Lamf_plugins_document_webapi_annotations_FormBodyParameter.getClassOf())
    }
  } else {
    var jsx$1 = false
  };
  this.isFormData$1 = jsx$1;
  this.isBody$1 = (element.isRight__Z() && (!this.isFormData$1));
  this.paramOption$1 = new $c_s_util_Either$LeftProjection().init___s_util_Either(element).toOption__s_Option();
  if ((element instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(element);
    var p$3 = $as_Lamf_plugins_domain_webapi_models_Parameter(x2.value$2);
    var jsx$3 = p$3
  } else if ((element instanceof $c_s_util_Right)) {
    var x3 = $as_s_util_Right(element);
    var p$4 = $as_Lamf_plugins_domain_webapi_models_Payload(x3.value$2);
    var jsx$3 = p$4
  } else {
    var jsx$3;
    throw new $c_s_MatchError().init___O(element)
  };
  this.domainElement$1 = jsx$3;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter.prototype.query__s_Option = (function() {
  var this$1 = this.paramOption$1;
  if (this$1.isEmpty__Z()) {
    var jsx$1 = true
  } else {
    var arg1 = this$1.get__O();
    var x$5 = $as_Lamf_plugins_domain_webapi_models_Parameter(arg1);
    var this$2 = $as_Lamf_core_model_StrField(x$5.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
    var jsx$1 = $f_Lamf_core_model_ValueField__is__O__Z(this$2, "query")
  };
  if (jsx$1) {
    return this$1
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter.prototype.path__s_Option = (function() {
  var this$1 = this.paramOption$1;
  if (this$1.isEmpty__Z()) {
    var jsx$1 = true
  } else {
    var arg1 = this$1.get__O();
    var x$6 = $as_Lamf_plugins_domain_webapi_models_Parameter(arg1);
    var this$2 = $as_Lamf_core_model_StrField(x$6.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
    var jsx$1 = $f_Lamf_core_model_ValueField__is__O__Z(this$2, "path")
  };
  if (jsx$1) {
    return this$1
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter.prototype.cookie__s_Option = (function() {
  var this$1 = this.paramOption$1;
  if (this$1.isEmpty__Z()) {
    var jsx$1 = true
  } else {
    var arg1 = this$1.get__O();
    var x$8 = $as_Lamf_plugins_domain_webapi_models_Parameter(arg1);
    var this$2 = $as_Lamf_core_model_StrField(x$8.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
    var jsx$1 = $f_Lamf_core_model_ValueField__is__O__Z(this$2, "cookie")
  };
  if (jsx$1) {
    return this$1
  } else {
    return $m_s_None$()
  }
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasParameter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasParameter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasParameter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasParameter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasParameter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasParameter: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$.prototype.apply__Lamf_plugins_domain_webapi_models_Payload__s_Option__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter = (function(payload, ast) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter().init___s_util_Either__s_Option(($m_s_package$(), new $c_s_util_Right().init___O(payload)), ast)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$.prototype.apply__Lamf_plugins_domain_webapi_models_Parameter__s_Option__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter = (function(parameter, ast) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter().init___s_util_Either__s_Option(($m_s_package$(), new $c_s_util_Left().init___O(parameter)), ast)
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasParameter$", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$;
var $n_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$ = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter() {
  $c_O.call(this);
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter.prototype.init___Lamf_core_model_domain_DomainElement__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(elem, f, ordering, references, spec) {
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter.prototype.asExtension__T__sc_Seq__scm_ListBuffer__V = (function(key, servers, result) {
  if (servers.nonEmpty__Z()) {
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(key, servers, this.ordering$1, this.spec$1))
  }
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$.prototype.apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser = (function(node, ctx) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser().init___Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext(node, $m_Lamf_plugins_document_webapi_parser_spec_package$().toOas__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(ctx))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$.prototype.parse__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_domain_webapi_models_Organization = (function(node, ctx) {
  return $m_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser(node, ctx).parse__Lamf_plugins_domain_webapi_models_Organization()
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OrganizationParser$", {
  Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$.prototype.linkToDeclared__p1__Lamf_core_model_domain_Shape__Z = (function(s) {
  return ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(s).isDefined__Z() && s.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf()))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$.prototype.simpleInheritsLink__p1__Lamf_core_model_domain_Shape__Z = (function(s) {
  var x1 = $as_sc_Seq(s.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1));
  $m_sc_Seq$();
  var o7 = new $c_s_Some().init___O(x1);
  if (((o7.value$2 !== null) && ($as_sc_SeqLike(o7.value$2).lengthCompare__I__I(1) === 0))) {
    var simple = $as_Lamf_core_model_domain_Shape($as_sc_SeqLike(o7.value$2).apply__I__O(0));
    return ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(simple).isDefined__Z() || simple.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf()))
  };
  return false
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$.prototype.ramlAutoGeneratedAnnotation__Lamf_core_model_domain_Shape__V = (function(s) {
  if (((!this.linkToDeclared__p1__Lamf_core_model_domain_Shape__Z(s)) && (!this.simpleInheritsLink__p1__Lamf_core_model_domain_Shape__Z(s)))) {
    var annotation = new $c_Lamf_core_annotations_AutoGeneratedName().init___();
    $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(s, annotation)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$.prototype.oasAutoGeneratedAnnotation__Lamf_core_model_domain_Shape__V = (function(s) {
  if ((!$f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(s).isDefined__Z())) {
    var jsx$1 = true
  } else if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(s).isDefined__Z()) {
    var this$1 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(s);
    if ((!this$1.isEmpty__Z())) {
      var arg1 = this$1.get__O();
      var x$1 = $as_Lamf_core_model_domain_DomainElement(arg1);
      var jsx$2 = x$1.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf())
    } else {
      var jsx$2 = false
    };
    var jsx$1 = (!jsx$2)
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var annotation = new $c_Lamf_core_annotations_AutoGeneratedName().init___();
    $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(s, annotation)
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.ParsingHelpers$", {
  Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$;
var $n_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$ = new $c_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$.prototype.parse__F1__Z__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_domain_webapi_models_Parameter = (function(adopted, parseOptional, node, ctx) {
  var this$1 = $m_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$().parse__F1__Z__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_domain_webapi_models_Parameter(adopted, parseOptional, node, ctx);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
  return $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, "header"))
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlHeaderParser$", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$.prototype.parse__F1__Z__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_domain_webapi_models_Parameter = (function(adopted, parseOptional, node, ctx) {
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var head = $as_Lorg_yaml_model_YMapEntry($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, ctx)).entries$3.head__O());
  return $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser(ctx.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().parameterParser__F3().apply__O__O__O__O(head, adopted, parseOptional)).parse__Lamf_plugins_domain_webapi_models_Parameter()
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlParameterParser$", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser() {
  $c_O.call(this);
  this.entry$1 = null;
  this.producer$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(entry, producer, parseOptional, ctx) {
  this.entry$1 = entry;
  this.producer$1 = producer;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser.prototype.parse__Lamf_plugins_domain_webapi_models_Payload = (function() {
  var jsx$1 = this.producer$1;
  $m_Lorg_yaml_model_YNode$();
  var node = this.entry$1.key$2;
  var iv = this.ctx$1;
  var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
  var this$2 = $as_Lamf_core_model_domain_AmfElement(jsx$1.apply__O__O(new $c_s_Some().init___O($as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)))));
  var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1);
  return $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$2, other))
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlPayloadParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlPayloadParser;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlQueryParameterParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlQueryParameterParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlQueryParameterParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlQueryParameterParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlQueryParameterParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlQueryParameterParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlQueryParameterParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlQueryParameterParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlQueryParameterParser$.prototype.parse__F1__Z__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_domain_webapi_models_Parameter = (function(adopted, parseOptional, node, ctx) {
  var this$1 = $m_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser$().parse__F1__Z__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_domain_webapi_models_Parameter(adopted, parseOptional, node, ctx);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
  return $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, "query"))
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlQueryParameterParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlQueryParameterParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlQueryParameterParser$", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlQueryParameterParser$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlQueryParameterParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlQueryParameterParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_domain_RamlQueryParameterParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_domain_RamlQueryParameterParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_domain_RamlQueryParameterParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_domain_RamlQueryParameterParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlQueryParameterParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_domain_RamlQueryParameterParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$.prototype.apply__Lorg_yaml_model_YNode__F1__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_domain_TagsParser = (function(map, adopt, ctx) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser().init___Lorg_yaml_model_YNode__F1__Lamf_plugins_document_webapi_contexts_WebApiContext(map, adopt, $m_Lamf_plugins_document_webapi_parser_spec_package$().toOas__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(ctx))
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.TagsParser$", {
  Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$() {
  $c_O.call(this);
  this.Http$1 = null;
  this.WebSockets$1 = null;
  this.Kafka$1 = null;
  this.Amqp$1 = null;
  this.Amqp1$1 = null;
  this.Mqtt$1 = null;
  this.Mqtt5$1 = null;
  this.Nats$1 = null;
  this.Jms$1 = null;
  this.Sns$1 = null;
  this.Sqs$1 = null;
  this.Stomp$1 = null;
  this.Redis$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$.prototype.init___ = (function() {
  this.Http$1 = "http";
  this.WebSockets$1 = "ws";
  this.Kafka$1 = "kafka";
  this.Amqp$1 = "amqp";
  this.Amqp1$1 = "amqp1";
  this.Mqtt$1 = "mqtt";
  this.Mqtt5$1 = "mqtt5";
  this.Nats$1 = "nats";
  this.Jms$1 = "jms";
  this.Sns$1 = "sns";
  this.Sqs$1 = "sqs";
  this.Stomp$1 = "stomp";
  this.Redis$1 = "redis";
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.binding.Bindings$", {
  Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$;
var $n_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$ = new $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$() {
  $c_O.call(this);
  this.amf$plugins$document$webapi$parser$spec$oas$OasLikeSecuritySchemeTypeMappings$$OAuth20$1 = null;
  this.amf$plugins$document$webapi$parser$spec$oas$OasLikeSecuritySchemeTypeMappings$$ApiKeyOas$1 = null;
  this.amf$plugins$document$webapi$parser$spec$oas$OasLikeSecuritySchemeTypeMappings$$Http$1 = null;
  this.amf$plugins$document$webapi$parser$spec$oas$OasLikeSecuritySchemeTypeMappings$$OpenIdConnect$1 = null;
  this.amf$plugins$document$webapi$parser$spec$oas$OasLikeSecuritySchemeTypeMappings$$BasicAuth$1 = null;
  this.mappings$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$ = this;
  this.amf$plugins$document$webapi$parser$spec$oas$OasLikeSecuritySchemeTypeMappings$$OAuth20$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType().init___T("oauth2");
  this.amf$plugins$document$webapi$parser$spec$oas$OasLikeSecuritySchemeTypeMappings$$ApiKeyOas$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType().init___T("apiKey");
  this.amf$plugins$document$webapi$parser$spec$oas$OasLikeSecuritySchemeTypeMappings$$Http$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType().init___T("http");
  this.amf$plugins$document$webapi$parser$spec$oas$OasLikeSecuritySchemeTypeMappings$$OpenIdConnect$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType().init___T("openIdConnect");
  this.amf$plugins$document$webapi$parser$spec$oas$OasLikeSecuritySchemeTypeMappings$$BasicAuth$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType().init___T("basic");
  var self = $m_Lamf_core_remote_Vendor$().OAS20$1;
  var y = $m_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$();
  var jsx$1 = new $c_T2().init___O__O(self, y);
  var self$1 = $m_Lamf_core_remote_Vendor$().OAS30$1;
  var y$1 = $m_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$();
  var array = [jsx$1, new $c_T2().init___O__O(self$1, y$1)];
  var this$8 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$8.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  this.mappings$1 = $as_sci_Map(this$8.elems$1);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$.prototype.validTypesFor__Lamf_core_remote_Vendor__sci_Set = (function(vendor) {
  return $as_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings(this.mappings$1.apply__O__O(vendor)).validTypes__sci_Set()
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$.prototype.mapsTo__Lamf_core_remote_Vendor__T__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType = (function(vendor, text) {
  return $as_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings(this.mappings$1.apply__O__O(vendor)).mapsTo__T__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType(text)
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasLikeSecuritySchemeTypeMappings$", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$;
var $n_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$ = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings() {
  $c_O.call(this);
  this.vendor$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings.prototype.validTypes__sci_Set = (function() {
  var this$1 = this.types__sci_Map();
  return new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(this$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings.prototype.init___Lamf_core_remote_Vendor = (function(vendor) {
  this.vendor$1 = vendor;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasLikeSecuritySchemeTypeMappings$SchemeMappings"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasLikeSecuritySchemeTypeMappings$SchemeMappings;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType() {
  $c_O.call(this);
  this.text$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType.prototype.init___T = (function(text) {
  this.text$1 = text;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.SecuritySchemeType"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.SecuritySchemeType;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters$.prototype.apply__Z__s_Option__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext__Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters = (function(isHeader, exampleOption, ordering, extensions, references, spec) {
  var label = (isHeader ? new $c_Lamf_core_utils_package$AmfStrings().init___T("example").asOasExtension__T() : "example");
  return new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters().init___T__s_Option__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(label, exampleOption, ordering, extensions, references, spec)
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters$: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasExampleEmitters$", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters$;
var $n_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters$ = new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter() {
  $c_O.call(this);
  this.securityScheme$1 = null;
  this.mappedType$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter.prototype.emitters__sc_Seq = (function() {
  var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var fs = this.securityScheme$1.fields$1;
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    var x$2 = this.mappedType$1.text__T();
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = f.value$1.annotations$1;
    var x$3 = this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
    results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", x$2, x$4, x$3))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().DisplayName$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("displayName").asOasExtension__T(), f$3, $m_s_None$())))
  };
  var this$7 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Description$1);
  if ((!this$7.isEmpty__Z())) {
    var arg1$2 = this$7.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f$4, $m_s_None$())))
  };
  var jsx$4 = new $c_Lamf_core_utils_package$AmfStrings().init___T("describedBy").asOasExtension__T();
  var jsx$3 = this.securityScheme$1;
  var jsx$2 = this.ordering$1;
  var jsx$1 = $m_sci_Nil$();
  var spec = this.spec$1;
  results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter().init___T__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(jsx$4, jsx$3, jsx$2, jsx$1, new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(spec.eh__Lamf_core_errorhandling_ErrorHandler(), spec.refEmitter$1, new $c_Lamf_core_emitter_ShapeRenderOptions().init___())));
  this.emitSettings__scm_ListBuffer__Lamf_core_parser_Fields__V(results, fs);
  return this.ordering$1.sorted__sc_Seq__sc_Seq(results)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(securityScheme, mappedType, ordering, spec) {
  this.securityScheme$1 = securityScheme;
  this.mappedType$1 = mappedType;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter.prototype.emitSettings__scm_ListBuffer__Lamf_core_parser_Fields__V = (function(results, fs) {
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    results.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(f, this.ordering$1, this.spec$1).emitters__sc_Seq())
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasSecuritySchemeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_package$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_package$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_package$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_package$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_package$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_package$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_package$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_package$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_package$.prototype.toRamlDeclarations__p1__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations = (function(ds) {
  if ((ds instanceof $c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations)) {
    var x2 = $as_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations(ds);
    return x2
  } else {
    return $m_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$().apply__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations(ds)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_package$.prototype.toOas__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(ctx) {
  var x1 = ctx.vendor__Lamf_core_remote_Vendor();
  var x = $m_Lamf_core_remote_Vendor$().OAS30$1;
  if ((x === x1)) {
    return new $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__Lamf_core_client_ParsingOptions(ctx.rootContextDocument$1, ctx.refs$1, ctx, new $c_s_Some().init___O(this.toOasDeclarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations(ctx.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations())), ctx.options$2)
  } else {
    return new $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__Lamf_core_client_ParsingOptions(ctx.rootContextDocument$1, ctx.refs$1, ctx, new $c_s_Some().init___O(this.toOasDeclarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations(ctx.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations())), ctx.options$2)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_package$.prototype.toOasDeclarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations = (function(ds) {
  if ((ds instanceof $c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations)) {
    var x2 = $as_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations(ds);
    return x2
  } else {
    return $m_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations$().apply__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations(ds)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_package$.prototype.toRaml__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(ctx) {
  var x$1 = ctx.rootContextDocument$1;
  var x$2 = ctx.refs$1;
  var x$4 = new $c_s_Some().init___O(this.toRamlDeclarations__p1__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations(ctx.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations()));
  var x$5 = ctx.options$2;
  var x$6 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2;
  return new $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions(x$1, x$2, ctx, x$4, x$6, x$5)
});
$c_Lamf_plugins_document_webapi_parser_spec_package$.prototype.toJsonSchema__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext = (function(ctx) {
  return new $c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__Lamf_core_client_ParsingOptions(ctx.rootContextDocument$1, ctx.refs$1, ctx, new $c_s_Some().init___O(this.toOasDeclarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations(ctx.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations())), ctx.options$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_package$.prototype.toJsonSchema__T__sc_Seq__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(root, refs, ctx) {
  return new $c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__Lamf_core_client_ParsingOptions(root, refs, ctx, new $c_s_Some().init___O(this.toOasDeclarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations(ctx.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations())), ctx.options$2)
});
var $d_Lamf_plugins_document_webapi_parser_spec_package$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_package$: 0
}, false, "amf.plugins.document.webapi.parser.spec.package$", {
  Lamf_plugins_document_webapi_parser_spec_package$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_package$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_package$;
var $n_Lamf_plugins_document_webapi_parser_spec_package$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_package$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_package$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_package$ = new $c_Lamf_plugins_document_webapi_parser_spec_package$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_package$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$() {
  $c_O.call(this);
  this.oas2DefinitionsPrefix$1 = null;
  this.oas3DefinitionsPrefix$1 = null;
  this.oas3ComponentsPrefix$1 = null;
  this.parameterDefinitionsPrefix$1 = null;
  this.responsesDefinitionsPrefix$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$.prototype.init___ = (function() {
  this.oas2DefinitionsPrefix$1 = "#/definitions/";
  this.oas3DefinitionsPrefix$1 = "#/components/schemas/";
  this.oas3ComponentsPrefix$1 = "#/components/";
  this.parameterDefinitionsPrefix$1 = "#/parameters/";
  this.responsesDefinitionsPrefix$1 = "#/responses/";
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$.prototype.appendPrefix__p1__T__T__T = (function(prefix, url) {
  return (("" + prefix) + url)
});
$c_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$.prototype.stripParameterDefinitionsPrefix__T__Lamf_plugins_document_webapi_contexts_WebApiContext__T = (function(url, ctx) {
  var x = ctx.vendor__Lamf_core_remote_Vendor();
  var x$2 = $m_Lamf_core_remote_Vendor$().OAS30$1;
  if ((x === x$2)) {
    return this.stripOas3ComponentsPrefix__T__T__T(url, "parameters")
  } else {
    var this$2 = new $c_sci_StringOps().init___T(url);
    var prefix = this.parameterDefinitionsPrefix$1;
    return $f_sci_StringLike__stripPrefix__T__T(this$2, prefix)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$.prototype.appendParameterDefinitionsPrefix__T__Z__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__T = (function(url, asHeader, spec) {
  return ((spec.factory__Lamf_plugins_document_webapi_contexts_SpecEmitterFactory() instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory) ? this.appendOas3ComponentsPrefix__T__T__T(url, "parameters") : this.appendPrefix__p1__T__T__T(this.parameterDefinitionsPrefix$1, url))
});
$c_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$.prototype.stripResponsesDefinitionsPrefix__T__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext__T = (function(url, ctx) {
  var x = ctx.vendor__Lamf_core_remote_Vendor();
  var x$2 = $m_Lamf_core_remote_Vendor$().OAS30$1;
  if ((x === x$2)) {
    return this.stripOas3ComponentsPrefix__T__T__T(url, "responses")
  } else {
    var this$2 = new $c_sci_StringOps().init___T(url);
    var prefix = this.responsesDefinitionsPrefix$1;
    return $f_sci_StringLike__stripPrefix__T__T(this$2, prefix)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$.prototype.appendResponsesDefinitionsPrefix__T__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__T = (function(url, spec) {
  return ((spec.factory__Lamf_plugins_document_webapi_contexts_SpecEmitterFactory() instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory) ? this.appendOas3ComponentsPrefix__T__T__T(url, "responses") : this.appendPrefix__p1__T__T__T(this.responsesDefinitionsPrefix$1, url))
});
$c_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$.prototype.stripDefinitionsPrefix__T__Lamf_plugins_document_webapi_contexts_WebApiContext__T = (function(url, ctx) {
  var x = ctx.vendor__Lamf_core_remote_Vendor();
  var x$2 = $m_Lamf_core_remote_Vendor$().OAS30$1;
  if ((x === x$2)) {
    var jsx$1 = true
  } else {
    var x$3 = ctx.vendor__Lamf_core_remote_Vendor();
    var x$4 = $m_Lamf_core_remote_Vendor$().ASYNC20$1;
    var jsx$1 = (x$3 === x$4)
  };
  if (jsx$1) {
    var this$2 = new $c_sci_StringOps().init___T(url);
    var prefix = this.oas3DefinitionsPrefix$1;
    return $f_sci_StringLike__stripPrefix__T__T(this$2, prefix)
  } else {
    var this$4 = new $c_sci_StringOps().init___T(url);
    var prefix$1 = this.oas2DefinitionsPrefix$1;
    return $f_sci_StringLike__stripPrefix__T__T(this$4, prefix$1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$.prototype.appendOas3ComponentsPrefix__T__T__T = (function(url, fieldName) {
  return this.appendPrefix__p1__T__T__T(((("" + this.oas3ComponentsPrefix$1) + fieldName) + "/"), url)
});
$c_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$.prototype.appendDefinitionsPrefix__T__s_Option__T = (function(url, vendor) {
  matchEnd12: {
    var jsx$1;
    if ((vendor instanceof $c_s_Some)) {
      var x2 = $as_s_Some(vendor);
      var p3 = $as_Lamf_core_remote_Vendor(x2.value$2);
      var x = $m_Lamf_core_remote_Vendor$().OAS30$1;
      if ((x === p3)) {
        var jsx$1 = true;
        break matchEnd12
      }
    };
    if ((vendor instanceof $c_s_Some)) {
      var x4 = $as_s_Some(vendor);
      var p5 = $as_Lamf_core_remote_Vendor(x4.value$2);
      var x$3 = $m_Lamf_core_remote_Vendor$().ASYNC20$1;
      if ((x$3 === p5)) {
        var jsx$1 = true;
        break matchEnd12
      }
    };
    var jsx$1 = false
  };
  if (jsx$1) {
    var prefix = this.oas3DefinitionsPrefix$1;
    if ((!(($uI(url.length) >= 0) && ($as_T(url.substring(0, $uI(prefix.length))) === prefix)))) {
      return this.appendPrefix__p1__T__T__T(this.oas3DefinitionsPrefix$1, url)
    } else {
      return url
    }
  } else {
    var prefix$1 = this.oas2DefinitionsPrefix$1;
    if ((!(($uI(url.length) >= 0) && ($as_T(url.substring(0, $uI(prefix$1.length))) === prefix$1)))) {
      return this.appendPrefix__p1__T__T__T(this.oas2DefinitionsPrefix$1, url)
    } else {
      return url
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$.prototype.stripOas3ComponentsPrefix__T__T__T = (function(url, fieldName) {
  var this$2 = new $c_sci_StringOps().init___T(url);
  var prefix = ((("" + this.oas3ComponentsPrefix$1) + fieldName) + "/");
  return $f_sci_StringLike__stripPrefix__T__T(this$2, prefix)
});
var $d_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$: 0
}, false, "amf.plugins.document.webapi.parser.spec.package$OasDefinitions$", {
  Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$;
var $n_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$ = new $c_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter() {
  $c_O.call(this);
  this.DocumentationItemFragmentEmitter$module$1 = null;
  this.DataTypeFragmentEmitter$module$1 = null;
  this.AnnotationFragmentEmitter$module$1 = null;
  this.SecuritySchemeFragmentEmitter$module$1 = null;
  this.ResourceTypeFragmentEmitter$module$1 = null;
  this.TraitFragmentEmitter$module$1 = null;
  this.FragmentNamedExampleEmitter$module$1 = null;
  this.fragment$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter.prototype.emitFragment__Lorg_yaml_model_YDocument = (function() {
  var ordering = $m_Lamf_core_emitter_SpecOrdering$().ordering__Lamf_core_remote_Vendor__Lamf_core_parser_Annotations__Lamf_core_emitter_SpecOrdering($m_Lamf_core_remote_Raml$(), this.fragment$1.encodes__Lamf_core_model_domain_DomainElement().annotations__Lamf_core_parser_Annotations());
  var x1 = this.fragment$1;
  if ((x1 instanceof $c_Lamf_plugins_document_webapi_model_DocumentationItemFragment)) {
    var x2 = $as_Lamf_plugins_document_webapi_model_DocumentationItemFragment(x1);
    var typeEmitter = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter__Lamf_plugins_document_webapi_model_DocumentationItemFragment__Lamf_core_emitter_SpecOrdering(this, x2, ordering)
  } else if ((x1 instanceof $c_Lamf_plugins_document_webapi_model_DataTypeFragment)) {
    var x3 = $as_Lamf_plugins_document_webapi_model_DataTypeFragment(x1);
    var typeEmitter = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter__Lamf_plugins_document_webapi_model_DataTypeFragment__Lamf_core_emitter_SpecOrdering(this, x3, ordering)
  } else if ((x1 instanceof $c_Lamf_plugins_document_webapi_model_NamedExampleFragment)) {
    var x4 = $as_Lamf_plugins_document_webapi_model_NamedExampleFragment(x1);
    var typeEmitter = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter__Lamf_plugins_document_webapi_model_NamedExampleFragment__Lamf_core_emitter_SpecOrdering(this, x4, ordering)
  } else if ((x1 instanceof $c_Lamf_plugins_document_webapi_model_ResourceTypeFragment)) {
    var x5 = $as_Lamf_plugins_document_webapi_model_ResourceTypeFragment(x1);
    var this$1 = this.spec$1;
    var typeEmitter = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter__Lamf_plugins_document_webapi_model_ResourceTypeFragment__Lamf_core_emitter_SpecOrdering__Lamf_core_errorhandling_ErrorHandler(this, x5, ordering, this$1.eh$1)
  } else if ((x1 instanceof $c_Lamf_plugins_document_webapi_model_TraitFragment)) {
    var x6 = $as_Lamf_plugins_document_webapi_model_TraitFragment(x1);
    var this$2 = this.spec$1;
    var typeEmitter = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter__Lamf_plugins_document_webapi_model_TraitFragment__Lamf_core_emitter_SpecOrdering__Lamf_core_errorhandling_ErrorHandler(this, x6, ordering, this$2.eh$1)
  } else if ((x1 instanceof $c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment)) {
    var x7 = $as_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment(x1);
    var typeEmitter = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter__Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment__Lamf_core_emitter_SpecOrdering(this, x7, ordering)
  } else {
    if ((!(x1 instanceof $c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment))) {
      throw new $c_jl_UnsupportedOperationException().init___T(("Unsupported fragment type: " + this.fragment$1))
    };
    var x8 = $as_Lamf_plugins_document_webapi_model_SecuritySchemeFragment(x1);
    var typeEmitter = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter__Lamf_plugins_document_webapi_model_SecuritySchemeFragment__Lamf_core_emitter_SpecOrdering(this, x8, ordering)
  };
  var this$3 = this.fragment$1.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1);
  if (this$3.isEmpty__Z()) {
    var usage = $m_s_None$()
  } else {
    var arg1 = this$3.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    var usage = new $c_s_Some().init___O(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("usage", f, $m_s_None$()))
  };
  var jsx$1 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter().init___Lamf_core_model_document_BaseUnit__Lamf_core_emitter_SpecOrdering(this.fragment$1, ordering)];
  var references = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  var this$8 = $m_Lorg_yaml_model_YDocument$().apply__T__Lorg_yaml_model_YDocument$WithComment("");
  var b = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(this$8.org$yaml$model$YDocument$WithComment$$sourceName$f);
  var x = this$8.comment$1;
  var this$10 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$10)) {
    b.comment__T__V(this$8.comment$1)
  };
  b.comment__T__V(typeEmitter.header__Lamf_plugins_document_webapi_parser_RamlHeader().text$1);
  var jsx$6 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$5 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$12 = this.fragment$1;
  var jsx$4 = typeEmitter.emitters__sc_Seq__sc_Seq($as_sc_Seq(this$12.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().References$1)));
  var jsx$3 = usage.toList__sci_List();
  var this$14 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$14.ReusableCBFInstance$2));
  var this$15 = $m_sc_Seq$();
  jsx$5.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(ordering.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(references, this$15.ReusableCBFInstance$2))), b$1);
  jsx$6.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  return new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this$8.org$yaml$model$YDocument$WithComment$$sourceName$f), b.builder$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter.prototype.init___Lamf_core_model_document_Fragment__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(fragment, spec) {
  this.fragment$1 = fragment;
  this.spec$1 = spec;
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters() {
  $c_O.call(this);
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(doc, ordering, spec) {
  this.spec$1 = spec;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlRootLevelEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlRootLevelEmitters;", depth))
}
function $f_Lamf_plugins_document_webapi_parser_spec_raml_RamlSyntax__$$init$__V($thiz) {
  var array = ["title", "content"];
  if (($uI(array.length) === 0)) {
    var y = $m_sci_Set$EmptySet$()
  } else {
    var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      b.$$plus$eq__O__scm_SetBuilder(arg1);
      i = ((1 + i) | 0)
    };
    var y = b.elems$1
  };
  var jsx$3 = new $c_T2().init___O__O("userDocumentation", y);
  var array$1 = ["displayName", "description", "headers", "body"];
  if (($uI(array$1.length) === 0)) {
    var y$1 = $m_sci_Set$EmptySet$()
  } else {
    var b$1 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$1 = 0;
    var len$1 = $uI(array$1.length);
    while ((i$1 < len$1)) {
      var index$1 = i$1;
      var arg1$1 = array$1[index$1];
      b$1.$$plus$eq__O__scm_SetBuilder(arg1$1);
      i$1 = ((1 + i$1) | 0)
    };
    var y$1 = b$1.elems$1
  };
  var jsx$2 = new $c_T2().init___O__O("response", y$1);
  var array$2 = ["type", "displayName", "description", "describedBy", "settings"];
  if (($uI(array$2.length) === 0)) {
    var y$2 = $m_sci_Set$EmptySet$()
  } else {
    var b$2 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$2 = 0;
    var len$2 = $uI(array$2.length);
    while ((i$2 < len$2)) {
      var index$2 = i$2;
      var arg1$2 = array$2[index$2];
      b$2.$$plus$eq__O__scm_SetBuilder(arg1$2);
      i$2 = ((1 + i$2) | 0)
    };
    var y$2 = b$2.elems$1
  };
  var jsx$1 = new $c_T2().init___O__O("securitySchema", y$2);
  var array$3 = ["headers", "queryParameters", "queryString", "responses"];
  if (($uI(array$3.length) === 0)) {
    var y$3 = $m_sci_Set$EmptySet$()
  } else {
    var b$3 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$3 = 0;
    var len$3 = $uI(array$3.length);
    while ((i$3 < len$3)) {
      var index$3 = i$3;
      var arg1$3 = array$3[index$3];
      b$3.$$plus$eq__O__scm_SetBuilder(arg1$3);
      i$3 = ((1 + i$3) | 0)
    };
    var y$3 = b$3.elems$1
  };
  var array$4 = [jsx$3, jsx$2, jsx$1, new $c_T2().init___O__O("describedBy", y$3)];
  var this$24 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i$4 = 0;
  var len$4 = $uI(array$4.length);
  while ((i$4 < len$4)) {
    var index$4 = i$4;
    var arg1$4 = array$4[index$4];
    this$24.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1$4));
    i$4 = ((1 + i$4) | 0)
  };
  $thiz.amf$plugins$document$webapi$parser$spec$raml$RamlSyntax$$undsetter$und$commonNodes$und$eq__sci_Map__V($as_sci_Map(this$24.elems$1))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser() {
  $c_O.call(this);
  this.adopt$1 = null;
  this.i$1 = 0;
  this.ast$1 = null;
  this.checking$1 = false;
  this.expression$1 = null;
  this.ctx$1 = null;
  this.parsedShape$1 = null;
  this.acc$1 = null;
  this.parsingArray$1 = false;
  this.part$1 = null;
  this.x$1$1 = null;
  this.lexical$1 = null;
  this.location$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.acceptUnionShape__p1__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_parser_Fields = (function(shape, union) {
  if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_UnionShape(shape);
    var jsx$2 = $as_sc_Seq(union.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1));
    var jsx$1 = $as_sc_Seq(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1));
    var this$1 = $m_sc_Seq$();
    return this.setUnionField__p1__Lamf_plugins_domain_shapes_models_UnionShape__sc_Seq__Lamf_core_parser_Fields(union, $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)))
  } else {
    var jsx$5 = $as_sc_Seq(union.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1));
    var jsx$4 = $m_sc_Seq$();
    var array = [shape];
    var jsx$3 = jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$4 = $m_sc_Seq$();
    return this.setUnionField__p1__Lamf_plugins_domain_shapes_models_UnionShape__sc_Seq__Lamf_core_parser_Fields(union, $as_sc_Seq(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$4.ReusableCBFInstance$2)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.extractNewLexicalAnnotations__p1__T__T__s_Option__Lamf_core_parser_Annotations = (function(name, expression, part) {
  if ((part instanceof $c_s_Some)) {
    var x2 = $as_s_Some(part);
    var p = $as_Lorg_yaml_model_YPart(x2.value$2);
    if ((p instanceof $c_Lorg_yaml_model_YScalar)) {
      var x3 = $as_Lorg_yaml_model_YScalar(p);
      var wholeLine = x3.text$3;
      var endIndex = (($uI(wholeLine.length) - $uI(expression.length)) | 0);
      var prevLine = $as_T(wholeLine.substring(0, endIndex));
      var this$5 = x3.location$1;
      var lineFrom = $m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$5.lineFrom$1, this$5.columnFrom$1, this$5.lineTo$1, this$5.columnTo$1).lineFrom$1;
      var this$6 = x3.location$1;
      var jsx$3 = $m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$6.lineFrom$1, this$6.columnFrom$1, this$6.lineTo$1, this$6.columnTo$1).columnFrom$1;
      var jsx$2 = $uI(prevLine.length);
      var this$9 = new $c_sci_StringOps().init___T(expression);
      var $$this = this$9.repr$1;
      var len = $uI($$this.length);
      var i = 0;
      while (true) {
        if ((i < len)) {
          var arg1 = this$9.apply__I__O(i);
          if ((arg1 === null)) {
            var x$2 = 0
          } else {
            var this$13 = $as_jl_Character(arg1);
            var x$2 = this$13.value$1
          };
          var this$16 = $m_jl_Character$();
          var jsx$1 = this$16.isWhitespace__I__Z(x$2)
        } else {
          var jsx$1 = false
        };
        if (jsx$1) {
          i = ((1 + i) | 0)
        } else {
          break
        }
      };
      var columnFrom = ((((jsx$3 + jsx$2) | 0) + i) | 0);
      $m_Lamf_core_parser_Annotations$();
      var annotation = new $c_Lamf_core_annotations_LexicalInformation().init___Lamf_core_parser_Range($m_Lamf_core_parser_Range$().apply__Lamf_core_parser_Position__I__Lamf_core_parser_Range(new $c_Lamf_core_parser_Position().init___I__I(lineFrom, columnFrom), $uI(name.length)));
      return new $c_Lamf_core_parser_Annotations().init___().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(annotation)
    }
  };
  $m_Lamf_core_parser_Annotations$();
  return new $c_Lamf_core_parser_Annotations().init___()
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.processParse__p1__sc_Seq__Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult = (function(input) {
  this.processChars__p1__V();
  return new $c_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult().init___s_Option__sc_Seq(this.parsedShape$1, input)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.acceptShape__p1__s_Option__V = (function(maybeShape) {
  if ((!maybeShape.isEmpty__Z())) {
    var arg1 = maybeShape.get__O();
    var x0$1 = $as_Lamf_core_model_domain_Shape(arg1);
    matchEnd4: {
      if ((x0$1 instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
        var x2 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(x0$1);
        if (this.isEmptyArray__Lamf_plugins_domain_shapes_models_DataArrangementShape__Z(x2)) {
          var op = this.parsedShape$1;
          var this$1 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser$OptionImpl().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser__s_Option(this, op);
          if (this$1.op$1.isEmpty__Z()) {
            this.parsedShape$1 = new $c_s_Some().init___O(x2)
          };
          var op$1 = this$1.op$1;
          var this$2 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser$OptionImpl().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser__s_Option(this, op$1);
          var this$3 = this$2.op$1;
          if ((!this$3.isEmpty__Z())) {
            var arg1$1 = this$3.get__O();
            var x0$2 = $as_Lamf_core_model_domain_Shape(arg1$1);
            if ((x0$2 instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
              var x2$1 = $as_Lamf_plugins_domain_shapes_models_UnionShape(x0$2);
              var jsx$1 = $as_sc_Seq(x2$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1));
              var this$4 = $m_sc_Seq$();
              var elements = $as_sc_Seq(jsx$1.$$colon$plus__O__scg_CanBuildFrom__O(x2, this$4.ReusableCBFInstance$2));
              var field = $m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1;
              $as_Lamf_plugins_domain_shapes_models_UnionShape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(x2$1, field, elements))
            } else {
              this.parsedShape$1 = new $c_s_Some().init___O(this.fillEmptyArray__p1__Lamf_plugins_domain_shapes_models_DataArrangementShape__Lamf_plugins_domain_shapes_models_DataArrangementShape(x2))
            }
          };
          this$2.op$1;
          break matchEnd4
        }
      };
      var op$2 = this.parsedShape$1;
      var this$5 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser$OptionImpl().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser__s_Option(this, op$2);
      if (this$5.op$1.isEmpty__Z()) {
        this.parsedShape$1 = new $c_s_Some().init___O(x0$1)
      };
      var op$3 = this$5.op$1;
      var this$6 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser$OptionImpl().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser__s_Option(this, op$3);
      var this$7 = this$6.op$1;
      if ((!this$7.isEmpty__Z())) {
        var arg1$2 = this$7.get__O();
        var x0$3 = $as_Lamf_core_model_domain_Shape(arg1$2);
        if ((x0$3 instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
          var x2$2 = $as_Lamf_plugins_domain_shapes_models_UnionShape(x0$3);
          this.acceptUnionShape__p1__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_parser_Fields(x0$1, x2$2)
        } else {
          this.addParseTypeViolation__p1__Lamf_core_model_domain_Shape__V(x0$1)
        }
      };
      this$6.op$1
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.addParseTypeViolation__p1__Lamf_core_model_domain_Shape__V = (function(shape) {
  var this$1 = this.ctx$1.eh$1;
  var specification = $m_Lamf_validations_ParserSideValidations$().InvalidTypeExpression$1;
  var node = shape.id$1;
  var property = $m_s_None$();
  var message = ("Error parsing type expression, cannot accept type " + shape);
  var lexical = this.lexical$1;
  var location = this.location$1;
  this$1.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.fillEmptyArray__p1__Lamf_plugins_domain_shapes_models_DataArrangementShape__Lamf_plugins_domain_shapes_models_DataArrangementShape = (function(arrangement) {
  var this$1 = this.parsedShape$1;
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var shape = $as_Lamf_core_model_domain_Shape(arg1);
    var this$2 = this.addItem__p1__Lamf_plugins_domain_shapes_models_DataArrangementShape__Lamf_core_model_domain_Shape__s_Option(arrangement, shape)
  };
  return $as_Lamf_plugins_domain_shapes_models_DataArrangementShape((this$2.isEmpty__Z() ? arrangement : this$2.get__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.validateContentAndIds__p1__Lamf_core_model_domain_Shape__V = (function(t) {
  this.ensureNotEmptyArray__p1__Lamf_core_model_domain_Shape__V(t);
  this.ensureAnyOfNamesAndIds__p1__Lamf_core_model_domain_Shape__V(t)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.parse__s_Option = (function() {
  var op = this.parseInput__sc_Seq__Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult($m_s_Predef$().wrapString__T__sci_WrappedString(this.expression$1)).result$1;
  var this$1 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser$OptionImpl().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser__s_Option(this, op);
  var this$2 = this$1.op$1;
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var shape = $as_Lamf_core_model_domain_Shape(arg1);
    this.validateAndAnnotate__p1__T__Lamf_core_model_domain_Shape__V(this.expression$1, shape)
  };
  return this$1.op$1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.addItem__p1__Lamf_plugins_domain_shapes_models_DataArrangementShape__Lamf_core_model_domain_Shape__s_Option = (function(arrangementShape, shape) {
  _addItem: while (true) {
    var x1 = arrangementShape;
    if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
      var x2 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(x1);
      if (((shape instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape) || (shape instanceof $c_Lamf_plugins_domain_shapes_models_MatrixShape))) {
        arrangementShape = x2.toMatrixShape__Lamf_plugins_domain_shapes_models_MatrixShape();
        continue _addItem
      } else {
        return new $c_s_Some().init___O(x2.withItems__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_ArrayShape(shape))
      }
    } else if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_MatrixShape)) {
      var x3 = $as_Lamf_plugins_domain_shapes_models_MatrixShape(x1);
      if (((shape instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape) || (shape instanceof $c_Lamf_plugins_domain_shapes_models_MatrixShape))) {
        var field = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1;
        return new $c_s_Some().init___O($as_Lamf_plugins_domain_shapes_models_MatrixShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(x3, field, shape)))
      } else {
        return $m_s_None$()
      }
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.checkEmptyValueViolation__p1__V = (function() {
  var thiz = this.acc$1;
  if ((thiz === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  if (((thiz === "") && this.parsedShape$1.isEmpty__Z())) {
    var this$2 = this.ctx$1.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().InvalidTypeExpression$1;
    var property = $m_s_None$();
    var lexical = this.lexical$1;
    var location = this.location$1;
    this$2.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, "", property, "Syntax error, cannot parse Union with empty values", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.parseUnion__p1__sc_Seq__Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult = (function(input) {
  this.checkEmptyValueViolation__p1__V();
  this.processChars__p1__V();
  this.parsedShape$1 = new $c_s_Some().init___O(this.toUnion__p1__s_Option__Lamf_core_model_domain_Shape(this.parsedShape$1));
  var result = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser().init___F1__I__s_Option__Z__T__Lamf_plugins_document_webapi_contexts_WebApiContext(this.adopt$1, ((1 + this.i$1) | 0), this.ast$1, this.checking$1, $as_sc_TraversableOnce(input.tail__O()).mkString__T(), this.ctx$1).parseInput__sc_Seq__Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult($as_sc_Seq(input.tail__O()));
  this.acceptShape__p1__s_Option__V(result.result$1);
  return this.parseInput__sc_Seq__Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult(result.remaining$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.adoptShape__p1__Lamf_core_model_domain_Shape__V = (function(shape) {
  var x1 = $as_Lamf_core_model_StrField(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
  matchEnd5: {
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var s = $as_T(x2.value$2);
      if ((s === "schema")) {
        var arg1 = this.i$1;
        var result = ("schema-" + arg1);
        this.i$1 = ((1 + this.i$1) | 0);
        $m_Lamf_core_parser_Annotations$();
        var a = new $c_Lamf_core_parser_Annotations().init___();
        $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, result, a);
        this.adopt$1.apply__O__O(shape);
        $m_Lamf_core_parser_Annotations$();
        var a$1 = new $c_Lamf_core_parser_Annotations().init___();
        $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, "schema", a$1);
        break matchEnd5
      }
    };
    var x = $m_s_None$();
    if ((x === x1)) {
      var arg1$1 = this.i$1;
      var result$1 = ("scalar-expression-" + arg1$1);
      this.i$1 = ((1 + this.i$1) | 0);
      $m_Lamf_core_parser_Annotations$();
      var a$2 = new $c_Lamf_core_parser_Annotations().init___();
      $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, result$1, a$2);
      this.adopt$1.apply__O__O(shape);
      var this$4 = $as_Lamf_core_model_StrField(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
      this$4.$$outer$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields(this$4.field$1);
      break matchEnd5
    };
    $asUnit(this.adopt$1.apply__O__O(shape))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.isEmptyArrangement__p1__Lamf_core_model_domain_Shape__Z = (function(t) {
  if ((t instanceof $c_Lamf_plugins_domain_shapes_models_DataArrangementShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_DataArrangementShape(t);
    return this.isEmptyArray__Lamf_plugins_domain_shapes_models_DataArrangementShape__Z(x2)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.setUnionField__p1__Lamf_plugins_domain_shapes_models_UnionShape__sc_Seq__Lamf_core_parser_Fields = (function(union, newAnyOf) {
  union.fields$2.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1);
  return union.fields$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(newAnyOf, new $c_Lamf_core_parser_Annotations().init___()), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.init___F1__I__s_Option__Z__T__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(adopt, i, ast, checking, expression, ctx) {
  this.adopt$1 = adopt;
  this.i$1 = i;
  this.ast$1 = ast;
  this.checking$1 = checking;
  this.expression$1 = expression;
  this.ctx$1 = ctx;
  this.parsedShape$1 = $m_s_None$();
  this.acc$1 = "";
  this.parsingArray$1 = false;
  if (ast.isEmpty__Z()) {
    var jsx$1 = $m_s_None$()
  } else {
    var arg1 = ast.get__O();
    var x0$1 = $as_Lorg_yaml_model_YPart(arg1);
    if ((x0$1 instanceof $c_Lorg_yaml_model_YMapEntry)) {
      var x2 = $as_Lorg_yaml_model_YMapEntry(x0$1);
      var jsx$2 = x2.value$2.value__Lorg_yaml_model_YValue()
    } else if ((x0$1 instanceof $c_Lorg_yaml_model_YNode)) {
      var x3 = $as_Lorg_yaml_model_YNode(x0$1);
      var jsx$2 = x3.value__Lorg_yaml_model_YValue()
    } else if ((x0$1 instanceof $c_Lorg_yaml_model_YScalar)) {
      var x4 = $as_Lorg_yaml_model_YScalar(x0$1);
      var jsx$2 = x4
    } else {
      var jsx$2;
      throw new $c_s_MatchError().init___O(x0$1)
    };
    var jsx$1 = new $c_s_Some().init___O(jsx$2)
  };
  this.part$1 = jsx$1;
  var this$1 = this.part$1;
  if (this$1.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1$1 = this$1.get__O();
    var p = $as_Lorg_yaml_model_YPart(arg1$1);
    var jsx$4 = $m_Lamf_core_parser_Range$();
    var this$2 = p.location$1;
    var jsx$3 = new $c_s_Some().init___O(new $c_Lamf_core_annotations_LexicalInformation().init___Lamf_core_parser_Range(jsx$4.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$2.lineFrom$1, this$2.columnFrom$1, this$2.lineTo$1, this$2.columnTo$1))));
    var str = p.location$1.sourceName$1;
    var this$4 = new $c_s_Some().init___O(new $c_T2().init___O__O(jsx$3, new $c_Lamf_core_utils_package$AmfStrings().init___T(str).option__s_Option()))
  };
  var x1 = $as_T2((this$4.isEmpty__Z() ? new $c_T2().init___O__O($m_s_None$(), $m_s_None$()) : this$4.get__O()));
  if ((x1 !== null)) {
    var lexical = $as_s_Option(x1.$$und1__O());
    var location = $as_s_Option(x1.$$und2__O());
    var jsx$5 = new $c_T2().init___O__O(lexical, location)
  } else {
    var jsx$5;
    throw new $c_s_MatchError().init___O(x1)
  };
  this.x$1$1 = jsx$5;
  this.lexical$1 = $as_s_Option(this.x$1$1.$$und1__O());
  this.location$1 = $as_s_Option(this.x$1$1.$$und2__O());
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.processChars__p1__V = (function() {
  var x = this.acc$1;
  var this$2 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$2)) {
    var x1 = this.acc$1;
    if ((x1 === "nil")) {
      $m_Lamf_core_parser_Annotations$();
      var annotations = new $c_Lamf_core_parser_Annotations().init___();
      var shape$2 = new $c_Lamf_plugins_domain_shapes_models_NilShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
    } else if ((x1 === "any")) {
      $m_Lamf_core_parser_Annotations$();
      var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
      var fields = new $c_Lamf_core_parser_Fields().init___();
      var shape$2 = new $c_Lamf_plugins_domain_shapes_models_AnyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations$1)
    } else if ((x1 === "file")) {
      $m_Lamf_core_parser_Annotations$();
      var annotations$2 = new $c_Lamf_core_parser_Annotations().init___();
      var shape$2 = new $c_Lamf_plugins_domain_shapes_models_FileShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$2)
    } else if ((x1 === "object")) {
      $m_Lamf_core_parser_Annotations$();
      var annotations$3 = new $c_Lamf_core_parser_Annotations().init___();
      var shape$2 = new $c_Lamf_plugins_domain_shapes_models_NodeShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$3)
    } else if ((x1 === "array")) {
      $m_Lamf_core_parser_Annotations$();
      var annotations$4 = new $c_Lamf_core_parser_Annotations().init___();
      var shape$2 = new $c_Lamf_plugins_domain_shapes_models_ArrayShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$4)
    } else if (((x1 === "string") || ((x1 === "integer") || ((x1 === "number") || ((x1 === "boolean") || ((x1 === "datetime") || ((x1 === "datetime-only") || ((x1 === "time-only") || (x1 === "date-only"))))))))) {
      $m_Lamf_core_parser_Annotations$();
      var annotations$5 = new $c_Lamf_core_parser_Annotations().init___();
      var this$22 = new $c_Lamf_plugins_domain_shapes_models_ScalarShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$5);
      var dataType = $m_Lamf_core_model_DataType$().apply__T__T(this.acc$1);
      var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
      var shape$2 = $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$22, field, dataType))
    } else {
      var x1$2 = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations().findType__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option(x1, $m_Lamf_core_parser_SearchScope$Named$(), (this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(), $m_s_None$()));
      if ((x1$2 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1$2);
        var s = $as_Lamf_plugins_domain_shapes_models_AnyShape(x2.value$2);
        var newShape = $as_Lamf_core_model_domain_Shape(s.link__T__Lamf_core_parser_Annotations__O(x1, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___())));
        var annotations$6 = this.extractNewLexicalAnnotations__p1__T__T__s_Option__Lamf_core_parser_Annotations(x1, this.expression$1, this.part$1);
        newShape.annotations__Lamf_core_parser_Annotations().$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(annotations$6);
        var shape$2 = newShape
      } else {
        var qual$1 = $m_Lamf_plugins_domain_shapes_models_UnresolvedShape$().apply__T__s_Option__Lamf_plugins_domain_shapes_models_UnresolvedShape(x1, this.part$1);
        $m_Lamf_core_parser_Annotations$();
        var x$2 = new $c_Lamf_core_parser_Annotations().init___();
        var shape = $as_Lamf_plugins_domain_shapes_models_UnresolvedShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, x1, x$2));
        var c = this.ctx$1;
        $f_Lamf_core_parser_UnresolvedReference__withContext__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(shape, c);
        this.adopt$1.apply__O__O(shape);
        if ((!this.checking$1)) {
          var this$26 = this.part$1;
          var refAst = $as_Lorg_yaml_model_YPart((this$26.isEmpty__Z() ? $m_Lorg_yaml_model_YNode$().Null$1 : this$26.get__O()));
          var ctx = this.ctx$1;
          $f_Lamf_core_model_domain_Linkable__unresolved__T__Lorg_yaml_model_YPart__T__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(shape, x1, refAst, "error", ctx)
        };
        var shape$2 = shape
      }
    };
    var op = $m_s_Option$().apply__O__s_Option(shape$2.id$1);
    var this$27 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser$OptionImpl().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser__s_Option(this, op);
    if (this$27.op$1.isEmpty__Z()) {
      this.adoptShape__p1__Lamf_core_model_domain_Shape__V(shape$2)
    };
    this.acc$1 = "";
    this.acceptShape__p1__s_Option__V(new $c_s_Some().init___O(shape$2))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.validateAndAnnotate__p1__T__Lamf_core_model_domain_Shape__V = (function(expression, shape) {
  this.validateContentAndIds__p1__Lamf_core_model_domain_Shape__V(shape);
  this.addAnnotations__p1__T__Lamf_core_model_domain_Shape__V(expression, shape)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.parseInput__sc_Seq__Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult = (function(input) {
  var this$1 = input.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$9 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    if ((arg1 === null)) {
      var x0$1 = 0
    } else {
      var this$3 = $as_jl_Character(arg1);
      var x0$1 = this$3.value$1
    };
    var this$6 = $m_jl_Character$();
    if (this$6.isWhitespace__I__Z(x0$1)) {
      var jsx$1 = this.parseInput__sc_Seq__Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult($as_sc_Seq(input.tail__O()))
    } else if ((x0$1 === 41)) {
      var jsx$1 = this.processParse__p1__sc_Seq__Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult($as_sc_Seq(input.tail__O()))
    } else if ((x0$1 === 40)) {
      this.processChars__p1__V();
      var jsx$1 = this.parseNext__p1__sc_Seq__Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult(input)
    } else if ((x0$1 === 124)) {
      var jsx$1 = this.parseUnion__p1__sc_Seq__Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult(input)
    } else if ((x0$1 === 91)) {
      var jsx$1 = this.parseOpenArray__p1__sc_Seq__Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult(input)
    } else if ((x0$1 === 93)) {
      var jsx$1 = this.parseCloseArray__p1__sc_Seq__Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult(input)
    } else {
      this.acc$1 = (("" + this.acc$1) + new $c_jl_Character().init___C(x0$1));
      var jsx$1 = this.parseInput__sc_Seq__Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult($as_sc_Seq(input.tail__O()))
    };
    var this$9 = new $c_s_Some().init___O(jsx$1)
  };
  if (this$9.isEmpty__Z()) {
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$12 = new $c_scm_ListBuffer().init___();
    var jsx$2 = this.processParse__p1__sc_Seq__Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult(this$12.toList__sci_List())
  } else {
    var jsx$2 = this$9.get__O()
  };
  return $as_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult(jsx$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.parseCloseArray__p1__sc_Seq__Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult = (function(input) {
  if ((!this.parsingArray$1)) {
    var this$1 = this.ctx$1.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().InvalidTypeExpression$1;
    var property = $m_s_None$();
    var lexical = this.lexical$1;
    var location = this.location$1;
    this$1.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, "", property, "Syntax error, Not matching ]", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
  };
  this.parsingArray$1 = false;
  this.parsedShape$1 = new $c_s_Some().init___O(this.toArray__p1__Lamf_core_model_domain_Shape());
  return this.parseInput__sc_Seq__Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult($as_sc_Seq(input.tail__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.parseOpenArray__p1__sc_Seq__Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult = (function(input) {
  this.processChars__p1__V();
  if (this.parsingArray$1) {
    var this$1 = this.ctx$1.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().InvalidTypeExpression$1;
    var property = $m_s_None$();
    var lexical = this.lexical$1;
    var location = this.location$1;
    this$1.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, "", property, "Syntax error, duplicated [", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
  };
  this.parsingArray$1 = true;
  return this.parseInput__sc_Seq__Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult($as_sc_Seq(input.tail__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.toUnion__p1__s_Option__Lamf_core_model_domain_Shape = (function(maybeShape) {
  var rc7 = false;
  var x2 = null;
  var x = $m_s_None$();
  if ((x === maybeShape)) {
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var union = new $c_Lamf_plugins_domain_shapes_models_UnionShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
    this.adopt$1.apply__O__O(union);
    var this$4 = this.ctx$1.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().InvalidTypeExpression$1;
    var node = union.id$1;
    var property = $m_s_None$();
    var lexical = this.lexical$1;
    var location = this.location$1;
    this$4.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "Syntax error, cannot create empty Union", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
    return union
  };
  if ((maybeShape instanceof $c_s_Some)) {
    rc7 = true;
    x2 = $as_s_Some(maybeShape);
    var u = $as_Lamf_core_model_domain_Shape(x2.value$2);
    if ((u instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
      var x5 = $as_Lamf_plugins_domain_shapes_models_UnionShape(u);
      return x5
    }
  };
  if (rc7) {
    var shape = $as_Lamf_core_model_domain_Shape(x2.value$2);
    $m_Lamf_core_parser_Annotations$();
    var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
    var union$2 = new $c_Lamf_plugins_domain_shapes_models_UnionShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
    this.adopt$1.apply__O__O(union$2);
    var field = $m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1;
    var jsx$1 = $m_sc_Seq$();
    var array = [shape];
    var values = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
    return $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(union$2, field, values))
  };
  throw new $c_s_MatchError().init___O(maybeShape)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.toArray__p1__Lamf_core_model_domain_Shape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var array = new $c_Lamf_plugins_domain_shapes_models_ArrayShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  this.adopt$1.apply__O__O(array);
  var rc9 = false;
  var x2 = null;
  var x1 = this.parsedShape$1;
  var x = $m_s_None$();
  if ((x === x1)) {
    return array
  };
  if ((x1 instanceof $c_s_Some)) {
    rc9 = true;
    x2 = $as_s_Some(x1);
    var a = $as_Lamf_core_model_domain_Shape(x2.value$2);
    if ((a instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
      var x6 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(a);
      $m_Lamf_core_parser_Annotations$();
      var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
      var this$7 = new $c_Lamf_plugins_domain_shapes_models_MatrixShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
      var value = array.id$1;
      var this$8 = $as_Lamf_plugins_domain_shapes_models_MatrixShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$7, value));
      var field = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1;
      return $as_Lamf_plugins_domain_shapes_models_MatrixShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$8, field, x6))
    }
  };
  if (rc9) {
    var a$2 = $as_Lamf_core_model_domain_Shape(x2.value$2);
    if ((a$2 instanceof $c_Lamf_plugins_domain_shapes_models_MatrixShape)) {
      var x7 = $as_Lamf_plugins_domain_shapes_models_MatrixShape(a$2);
      $m_Lamf_core_parser_Annotations$();
      var annotations$2 = new $c_Lamf_core_parser_Annotations().init___();
      var this$12 = new $c_Lamf_plugins_domain_shapes_models_MatrixShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$2);
      var value$1 = array.id$1;
      var this$13 = $as_Lamf_plugins_domain_shapes_models_MatrixShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$12, value$1));
      var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1;
      return $as_Lamf_plugins_domain_shapes_models_MatrixShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$13, field$1, x7))
    }
  };
  if (rc9) {
    var other = $as_Lamf_core_model_domain_Shape(x2.value$2);
    return array.withItems__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_ArrayShape(other)
  };
  throw new $c_s_MatchError().init___O(x1)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.ensureNotEmptyArray__p1__Lamf_core_model_domain_Shape__V = (function(t) {
  if (this.isEmptyArrangement__p1__Lamf_core_model_domain_Shape__Z(t)) {
    var this$1 = this.ctx$1.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().InvalidTypeExpression$1;
    var node = t.id$1;
    var property = $m_s_None$();
    var lexical = this.lexical$1;
    var location = this.location$1;
    this$1.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "Syntax error, generating empty array", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.parseNext__p1__sc_Seq__Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult = (function(input) {
  var result = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser().init___F1__I__s_Option__Z__T__Lamf_plugins_document_webapi_contexts_WebApiContext(this.adopt$1, ((1 + this.i$1) | 0), this.ast$1, this.checking$1, $as_sc_TraversableOnce(input.tail__O()).mkString__T(), this.ctx$1).parseInput__sc_Seq__Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult($as_sc_Seq(input.tail__O()));
  this.acceptShape__p1__s_Option__V(result.result$1);
  return this.parseInput__sc_Seq__Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult(result.remaining$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.addAnnotations__p1__T__Lamf_core_model_domain_Shape__V = (function(expression, t) {
  t.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression().init___T(expression));
  var this$1 = this.ast$1;
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var p = $as_Lorg_yaml_model_YPart(arg1);
    t.annotations__Lamf_core_parser_Annotations().$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations($m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(p))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.isEmptyArray__Lamf_plugins_domain_shapes_models_DataArrangementShape__Z = (function(shape) {
  var rc7 = false;
  var x2 = null;
  var rc8 = false;
  var x4 = null;
  if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
    rc7 = true;
    x2 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(shape);
    var this$1 = x2;
    if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1).isDefined__Z()) {
      var this$3 = x2;
      var links = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      var jsx$1 = ($f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this$3, links) instanceof $c_Lamf_plugins_domain_shapes_models_DataArrangementShape)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var this$5 = x2;
      var links$1 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      return this.isEmptyArray__Lamf_plugins_domain_shapes_models_DataArrangementShape__Z($as_Lamf_plugins_domain_shapes_models_DataArrangementShape($f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this$5, links$1)))
    }
  };
  if (rc7) {
    var this$6 = x2;
    if ($as_sc_Seq(this$6.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).isEmpty__Z()) {
      var jsx$2 = $m_s_Option$();
      var this$7 = x2;
      return jsx$2.apply__O__s_Option($as_Lamf_core_model_domain_Shape(this$7.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1))).isEmpty__Z()
    } else {
      return false
    }
  };
  if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_MatrixShape)) {
    rc8 = true;
    x4 = $as_Lamf_plugins_domain_shapes_models_MatrixShape(shape);
    var this$8 = x4;
    if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$8).isDefined__Z()) {
      var this$10 = x4;
      var links$2 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      var jsx$3 = ($f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this$10, links$2) instanceof $c_Lamf_plugins_domain_shapes_models_DataArrangementShape)
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var this$12 = x4;
      var links$3 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      return this.isEmptyArray__Lamf_plugins_domain_shapes_models_DataArrangementShape__Z($as_Lamf_plugins_domain_shapes_models_DataArrangementShape($f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this$12, links$3)))
    }
  };
  if (rc8) {
    var this$13 = x4;
    return this.isEmptyArray__Lamf_plugins_domain_shapes_models_DataArrangementShape__Z($as_Lamf_plugins_domain_shapes_models_DataArrangementShape($as_Lamf_core_model_domain_Shape(this$13.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1))))
  };
  return false
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.ensureAnyOfNamesAndIds__p1__Lamf_core_model_domain_Shape__V = (function(t) {
  if ((t instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_UnionShape(t);
    var arrayCounter = new $c_Lamf_core_utils_package$SimpleCounter().init___();
    var idCounter = new $c_Lamf_core_utils_package$SimpleCounter().init___();
    $as_sc_Seq(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, arrayCounter$1, x2$1, idCounter$1) {
      return (function(x$2) {
        var x = $as_Lamf_core_model_domain_Shape(x$2);
        matchEnd4: {
          if ((x instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
            var x2$2 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(x);
            if ($as_Lamf_core_model_StrField(x2$2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1.isEmpty__Z()) {
              var name = ("array_" + arrayCounter$1.next__I());
              $m_Lamf_core_parser_Annotations$();
              var a = new $c_Lamf_core_parser_Annotations().init___();
              $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(x2$2, name, a);
              break matchEnd4
            }
          }
        };
        return ((!$f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x).isDefined__Z()) ? x.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(((x2$1.id$1 + "_") + idCounter$1.next__I()), x.adopted$default$2__sc_Seq()) : (void 0))
      })
    })(this, arrayCounter, x2, idCounter)))
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlTypeExpressionParser", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser$OptionImpl() {
  $c_O.call(this);
  this.op$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser$OptionImpl.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser$OptionImpl.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser$OptionImpl;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser$OptionImpl() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser$OptionImpl.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser$OptionImpl.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser$OptionImpl.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser__s_Option = (function($$outer, op) {
  this.op$1 = op;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser$OptionImpl = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser$OptionImpl: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlTypeExpressionParser$OptionImpl", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser$OptionImpl: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser$OptionImpl.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser$OptionImpl;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter() {
  $c_O.call(this);
  this.securityScheme$1 = null;
  this.references$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter.prototype.emitSupportedHttpAuthTypes__p1__Lamf_core_parser_FieldEntry__Lamf_plugins_domain_webapi_models_security_Settings__scm_ListBuffer = (function(typeField, settings) {
  var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = settings.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$().Scheme$1);
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x = $as_Lamf_core_parser_FieldEntry(arg1);
    var this$2 = new $c_s_Some().init___O($as_Lamf_core_model_domain_AmfScalar(x.value$1.value$1).toString__T())
  };
  var x1 = $as_T((this$2.isEmpty__Z() ? "" : this$2.get__O()));
  var resultantType = ((x1 === "basic") ? "Basic Authentication" : ((x1 === "digest") ? "Digest Authentication" : ""));
  var this$3 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = typeField.value$1.annotations$1;
  var x$3 = this$3.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf());
  var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
  return results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", resultantType, x$4, x$3))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter.prototype.emitters__sc_Seq = (function() {
  var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var fs = this.securityScheme$1.fields$1;
  this.emitType__p1__scm_ListBuffer__Lamf_plugins_domain_webapi_models_security_SecurityScheme__V(results, this.securityScheme$1);
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().DisplayName$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(results.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("displayName", f, $m_s_None$(), this.spec$1)))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Description$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(results.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("description", f$3, $m_s_None$(), this.spec$1)))
  };
  results.$$plus$eq__O__scm_ListBuffer(this.describedByEmitter__F4().apply__O__O__O__O__O("describedBy", this.securityScheme$1, this.ordering$1, this.references$1));
  if (((!this.isHttpBasicAuth__p1__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Z(this.securityScheme$1)) && (!this.isHttpDigestAuth__p1__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Z(this.securityScheme$1)))) {
    var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1);
    if ((!this$5.isEmpty__Z())) {
      var arg1$2 = this$5.get__O();
      var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
      new $c_s_Some().init___O(results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(f$4, this.ordering$1, this.spec$1)))
    }
  };
  return results
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter.prototype.emitType__p1__scm_ListBuffer__Lamf_plugins_domain_webapi_models_security_SecurityScheme__V = (function(results, securityScheme) {
  var this$1 = securityScheme.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var x0$1 = $as_Lamf_core_parser_FieldEntry(arg1);
    if (($as_Lamf_core_model_domain_AmfScalar(x0$1.value$1.value$1).toString__T() === "Api Key")) {
      var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
      var annotations = x0$1.value$1.annotations$1;
      var x$3 = this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf());
      var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
      results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", "x-apiKey", x$4, x$3))
    } else if ((this.isHttpBasicAuth__p1__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Z(securityScheme) || this.isHttpDigestAuth__p1__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Z(securityScheme))) {
      results.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(this.emitSupportedHttpAuthTypes__p1__Lamf_core_parser_FieldEntry__Lamf_plugins_domain_webapi_models_security_Settings__scm_ListBuffer(x0$1, $as_Lamf_plugins_domain_webapi_models_security_Settings(securityScheme.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1))))
    } else {
      results.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("type", x0$1, $m_s_None$(), this.spec$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter.prototype.hasHttpAuthScheme__p1__T__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Z = (function(scheme, securityScheme) {
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_Settings(securityScheme.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1)).fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$().Scheme$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var s = $as_Lamf_core_parser_FieldEntry(arg1);
    return ($as_Lamf_core_model_domain_AmfScalar(s.value$1.value$1).toString__T() === scheme)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter.prototype.isHttpAuth__p1__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Z = (function(securityScheme) {
  var this$1 = $as_Lamf_core_model_StrField(securityScheme.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1));
  var this$2 = this$1.option$1;
  return ($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())) === "http")
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(securityScheme, references, ordering, spec) {
  this.securityScheme$1 = securityScheme;
  this.references$1 = references;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter.prototype.isHttpBasicAuth__p1__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Z = (function(securityScheme) {
  return (this.isHttpAuth__p1__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Z(securityScheme) && this.hasHttpAuthScheme__p1__T__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Z("basic", securityScheme))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter.prototype.isHttpDigestAuth__p1__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Z = (function(securityScheme) {
  return (this.isHttpAuth__p1__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Z(securityScheme) && this.hasHttpAuthScheme__p1__T__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Z("digest", securityScheme))
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.emitters.RamlSecuritySchemeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.emitters.RamlSecuritySchemeEmitter;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline$.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline$.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline$.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline$.prototype.apply__Lamf_ProfileName__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(profile, unit) {
  var x = $m_Lamf_Oas30Profile$();
  if (x.equals__O__Z(profile)) {
    var pipeline = new $c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ValidationResolutionPipeline().init___Lamf_core_errorhandling_ErrorHandler($f_Lamf_core_model_document_BaseUnit__errorHandler__Lamf_core_errorhandling_ErrorHandler(unit))
  } else {
    var x$3 = $m_Lamf_Async20Profile$();
    if (x$3.equals__O__Z(profile)) {
      var pipeline = new $c_Lamf_plugins_document_webapi_resolution_pipelines_Async20ValidationResolutionPipeline().init___Lamf_core_errorhandling_ErrorHandler($f_Lamf_core_model_document_BaseUnit__errorHandler__Lamf_core_errorhandling_ErrorHandler(unit))
    } else {
      var pipeline = new $c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline().init___Lamf_ProfileName__Lamf_core_errorhandling_ErrorHandler(profile, $f_Lamf_core_model_document_BaseUnit__errorHandler__Lamf_core_errorhandling_ErrorHandler(unit))
    }
  };
  return pipeline.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit)
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline$: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.ValidationResolutionPipeline$", {
  Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline$.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline$;
var $n_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline$ = (void 0);
function $m_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline$() {
  if ((!$n_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline$)) {
    $n_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline$ = new $c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline$().init___()
  };
  return $n_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder() {
  $c_O.call(this);
  this.element$1 = null;
  this.refsCounter$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder.prototype.buildEntry__p1__Lorg_yaml_model_YMapEntry__Lamf_core_model_domain_ElementTree = (function(entry) {
  var sons = this.buildNode__p1__Lorg_yaml_model_YNode__sc_Seq(entry.value$2);
  return new $c_Lamf_core_model_domain_ElementTree().init___T__sc_Seq(entry.key$2.toString__T(), sons)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder.prototype.init___Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage__Lamf_core_model_domain_DomainElement = (function($$outer, element) {
  this.element$1 = element;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.refsCounter$1 = new $c_Lamf_core_utils_package$AliasCounter().init___I__J(0, $m_Lamf_core_utils_package$AliasCounter$().apply$default$2__J());
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder.prototype.build__Lamf_core_model_domain_ElementTree = (function() {
  var this$1 = this.element$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_SourceAST.getClassOf());
  if (this$1.isEmpty__Z()) {
    var xo = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$6 = $as_Lamf_core_annotations_SourceAST(arg1);
    var xo = new $c_s_Some().init___O(x$6.ast$1)
  };
  var this$3 = xo.toList__sci_List();
  var pf = new $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder$$anonfun$1().init___Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder(this);
  var x1 = $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$3, pf);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    var node = entry.value$2
  } else {
    var node = this.astFromEmition__Lorg_yaml_model_YNode()
  };
  return new $c_Lamf_core_model_domain_ElementTree().init___T__sc_Seq(this.rootKey__T(), this.buildNode__p1__Lorg_yaml_model_YNode__sc_Seq(node))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder.prototype.buildNode__p1__Lorg_yaml_model_YNode__sc_Seq = (function(node) {
  if (this.refsCounter$1.exceedsThreshold__Lorg_yaml_model_YNode__Z(node)) {
    var this$1 = this.$$outer$1;
    var this$2 = this$1.errorHandler$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().ExeededMaxYamlReferences$1;
    var property = $m_s_None$();
    var lexical = $m_s_None$();
    var location = $m_s_None$();
    this$2.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, "", property, "Exceeded maximum yaml references threshold", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
    return $m_sci_Nil$()
  } else {
    var x1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x === x1)) {
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
      var jsx$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).entries$3;
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(entry$2) {
          var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
          return $this.buildEntry__p1__Lorg_yaml_model_YMapEntry__Lamf_core_model_domain_ElementTree(entry)
        })
      })(this));
      var this$3 = $m_sc_IndexedSeq$();
      return $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBF$6))
    } else {
      var x$3 = $m_Lorg_yaml_model_YType$().Seq$1;
      if ((x$3 === x1)) {
        var conversion$1 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
        var iv$1 = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
        var jsx$4 = $as_sc_TraversableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$1, iv$1));
        var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
          return (function(node$2$2) {
            var node$2 = $as_Lorg_yaml_model_YNode(node$2$2);
            return this$2$1.buildNode__p1__Lorg_yaml_model_YNode__sc_Seq(node$2)
          })
        })(this));
        var this$4 = $m_sc_Seq$();
        return $as_sc_Seq(jsx$4.flatMap__F1__scg_CanBuildFrom__O(jsx$3, this$4.ReusableCBFInstance$2))
      } else {
        return $m_sci_Nil$()
      }
    }
  }
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions.prototype;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$() {
  $c_O.call(this);
  this.unrestricted$1 = null;
  this.onlyFunctionalField$1 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$ = this;
  this.unrestricted$1 = new $c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$2().init___();
  this.onlyFunctionalField$1 = new $c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$3().init___();
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$: 0
}, false, "amf.plugins.document.webapi.resolution.stages.MergingRestrictions$", {
  Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$;
var $n_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$ = (void 0);
function $m_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$() {
  if ((!$n_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$)) {
    $n_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$ = new $c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$().init___()
  };
  return $n_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$() {
  $c_O.call(this);
  this.dataType$1 = null;
  this.minCount$1 = null;
  this.string$1 = null;
  this.boolean$1 = null;
  this.integer$1 = null;
  this.schemaRequiredInParameter$1 = null;
  this.map$1 = null
}
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_AMFRawValidations$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_AMFRawValidations$.prototype = $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$.prototype;
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$ = this;
  var ns = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.dataType$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns, "datatype");
  var ns$1 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.minCount$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$1, "minCount");
  this.string$1 = $m_Lamf_core_vocabulary_Namespace$XsdTypes$().xsdString$1.iri__T();
  this.boolean$1 = $m_Lamf_core_vocabulary_Namespace$XsdTypes$().xsdBoolean$1.iri__T();
  this.integer$1 = $m_Lamf_core_vocabulary_Namespace$XsdTypes$().xsdInteger$1.iri__T();
  var name = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().doc$1.displayName$1;
  var ns$2 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$2, name);
  var ns$3 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$3, "schema");
  var x$3 = this.minCount$1;
  var x$7 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$4 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$9 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$4, "path");
  var x$10 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  this.schemaRequiredInParameter$1 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$7, "", x$1, x$2, x$9, x$3, "1", "RAML Type information is mandatory for parameters", "Schema/type information required for Parameter objects", x$10);
  var self = $m_Lamf_AmfProfile$();
  var y = this.forProfile__p1__Lamf_ProfileName__sc_Seq($m_Lamf_AmfProfile$());
  var jsx$7 = new $c_T2().init___O__O(self, y);
  var self$1 = $m_Lamf_Raml10Profile$();
  var y$1 = this.forProfile__p1__Lamf_ProfileName__sc_Seq($m_Lamf_Raml10Profile$());
  var jsx$6 = new $c_T2().init___O__O(self$1, y$1);
  var self$2 = $m_Lamf_Raml08Profile$();
  var y$2 = this.forProfile__p1__Lamf_ProfileName__sc_Seq($m_Lamf_Raml08Profile$());
  var jsx$5 = new $c_T2().init___O__O(self$2, y$2);
  var self$3 = $m_Lamf_RamlProfile$();
  var y$3 = this.forProfile__p1__Lamf_ProfileName__sc_Seq($m_Lamf_RamlProfile$());
  var jsx$4 = new $c_T2().init___O__O(self$3, y$3);
  var self$4 = $m_Lamf_Oas20Profile$();
  var y$4 = this.forProfile__p1__Lamf_ProfileName__sc_Seq($m_Lamf_Oas20Profile$());
  var jsx$3 = new $c_T2().init___O__O(self$4, y$4);
  var self$5 = $m_Lamf_Oas30Profile$();
  var y$5 = this.forProfile__p1__Lamf_ProfileName__sc_Seq($m_Lamf_Oas30Profile$());
  var jsx$2 = new $c_T2().init___O__O(self$5, y$5);
  var self$6 = $m_Lamf_OasProfile$();
  var y$6 = this.forProfile__p1__Lamf_ProfileName__sc_Seq($m_Lamf_OasProfile$());
  var jsx$1 = new $c_T2().init___O__O(self$6, y$6);
  var self$7 = $m_Lamf_Async20Profile$();
  var y$7 = this.forProfile__p1__Lamf_ProfileName__sc_Seq($m_Lamf_Async20Profile$());
  var array = [jsx$7, jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, jsx$1, new $c_T2().init___O__O(self$7, y$7)];
  var this$29 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$29.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  this.map$1 = $as_sci_Map(this$29.elems$1);
  return this
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$.prototype.amfParser__T__s_Option = (function(name) {
  var ns = $m_Lamf_core_vocabulary_Namespace$().AmfParser$1;
  return new $c_s_Some().init___O(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns, name))
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$.prototype.forProfile__p1__Lamf_ProfileName__sc_Seq = (function(p) {
  var x = $m_Lamf_Raml10Profile$();
  if (x.equals__O__Z(p)) {
    var jsx$1 = true
  } else {
    var x$3 = $m_Lamf_RamlProfile$();
    var jsx$1 = x$3.equals__O__Z(p)
  };
  if (jsx$1) {
    var this$1 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$();
    return this$1.result__p1__sc_Seq()
  } else {
    var x$5 = $m_Lamf_Raml08Profile$();
    if (x$5.equals__O__Z(p)) {
      var this$2 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$();
      return this$2.result__p1__sc_Seq()
    } else {
      var x$7 = $m_Lamf_OasProfile$();
      if (x$7.equals__O__Z(p)) {
        var jsx$2 = true
      } else {
        var x$9 = $m_Lamf_Oas20Profile$();
        var jsx$2 = x$9.equals__O__Z(p)
      };
      if (jsx$2) {
        var this$3 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$();
        return this$3.result__p1__sc_Seq()
      } else {
        var x$11 = $m_Lamf_Oas30Profile$();
        if (x$11.equals__O__Z(p)) {
          var this$4 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$();
          return this$4.result__p1__sc_Seq()
        } else {
          var x$13 = $m_Lamf_Async20Profile$();
          if (x$13.equals__O__Z(p)) {
            var this$5 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$();
            return this$5.result__p1__sc_Seq()
          } else {
            var x$15 = $m_Lamf_AmfProfile$();
            if (x$15.equals__O__Z(p)) {
              var this$6 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$();
              return this$6.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result__sc_Seq()
            } else {
              return $m_sci_Nil$()
            }
          }
        }
      }
    }
  }
});
var $d_Lamf_plugins_document_webapi_validation_AMFRawValidations$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_AMFRawValidations$: 0
}, false, "amf.plugins.document.webapi.validation.AMFRawValidations$", {
  Lamf_plugins_document_webapi_validation_AMFRawValidations$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_AMFRawValidations$;
var $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_AMFRawValidations$)) {
    $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$ = new $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation() {
  $c_O.call(this);
  this.uri$1 = null;
  this.message$1 = null;
  this.owlClass$1 = null;
  this.owlProperty$1 = null;
  this.target$1 = null;
  this.constraint$1 = null;
  this.value$1 = null;
  this.ramlErrorMessage$1 = null;
  this.openApiErrorMessage$1 = null;
  this.severity$1 = null
}
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation.prototype = $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation.prototype;
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation.prototype.init___s_Option__s_Option__T__T__T__T__T__T__T__T = (function(uri, message, owlClass, owlProperty, target, constraint, value, ramlErrorMessage, openApiErrorMessage, severity) {
  this.uri$1 = uri;
  this.message$1 = message;
  this.owlClass$1 = owlClass;
  this.owlProperty$1 = owlProperty;
  this.target$1 = target;
  this.constraint$1 = constraint;
  this.value$1 = value;
  this.ramlErrorMessage$1 = ramlErrorMessage;
  this.openApiErrorMessage$1 = openApiErrorMessage;
  this.severity$1 = severity;
  return this
});
function $as_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.AMFRawValidations$AMFValidation"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.AMFRawValidations$AMFValidation;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation: 0
}, false, "amf.plugins.document.webapi.validation.AMFRawValidations$AMFValidation", {
  Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$.prototype = $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$.prototype;
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$.prototype.optional__T__s_Option = (function(s) {
  if ((s === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  if ((s === "")) {
    return $m_s_None$()
  } else {
    return new $c_s_Some().init___O($as_T(s.trim()))
  }
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$.prototype.adaptValue__T__T__T = (function(constraint, value) {
  return ($m_sjsr_RuntimeString$().endsWith__T__T__Z(constraint, "pattern") ? value : $m_Lamf_core_vocabulary_Namespace$().uri__T__Lamf_core_vocabulary_ValueType(value).iri__T())
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$.prototype.apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation = (function(uri, message, owlClass, owlProperty, target, constraint, value, ramlErrorMessage, openApiErrorMessage, severity) {
  if ((message === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  if ((message !== "")) {
    if ((ramlErrorMessage === null)) {
      throw new $c_jl_NullPointerException().init___()
    };
    var jsx$1 = (ramlErrorMessage === "")
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    if ((openApiErrorMessage === null)) {
      throw new $c_jl_NullPointerException().init___()
    };
    var sameMessage = (openApiErrorMessage === "")
  } else {
    var sameMessage = false
  };
  if (uri.isEmpty__Z()) {
    var jsx$2 = $m_s_None$()
  } else {
    var arg1 = uri.get__O();
    var x$2 = $as_Lamf_core_vocabulary_ValueType(arg1);
    var jsx$2 = new $c_s_Some().init___O(x$2.iri__T())
  };
  return new $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation().init___s_Option__s_Option__T__T__T__T__T__T__T__T(jsx$2, this.optional__T__s_Option(message), owlClass.iri__T(), owlProperty.iri__T(), target.iri__T(), constraint.iri__T(), this.adaptValue__T__T__T(constraint.iri__T(), value), (sameMessage ? message : ramlErrorMessage), (sameMessage ? message : openApiErrorMessage), severity)
});
var $d_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$: 0
}, false, "amf.plugins.document.webapi.validation.AMFRawValidations$AMFValidation$", {
  Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$;
var $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$)) {
    $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$ = new $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$
}
function $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfProfileValidations__amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result__sc_Seq($thiz) {
  var jsx$74 = $m_sc_Seq$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns, "DomainElement");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$1, "name");
  var x$3 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$4 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$7 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$2 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$9 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$2, "path");
  var x$10 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$73 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$7, "", x$1, x$2, x$9, x$3, x$4, "Title and names must be string", "Names must be string", x$10);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$3 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$11 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$3, "Parameter");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$4 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$12 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$4, "paramName");
  var x$13 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("mandatory-header-name-pattern");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$5 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$14 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$5, "mandatoryHeaderNamePattern");
  var x$17 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$6 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$19 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$6, "path");
  var jsx$72 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$13, "", x$11, x$12, x$19, x$14, "0", "Header name must comply RFC-7230", "Header name must comply RFC-7230", x$17);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$7 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var x$21 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$7, "DomainElement");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$8 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$22 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$8, "description");
  var x$23 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$24 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$27 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$9 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$29 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$9, "path");
  var x$30 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$71 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$27, "", x$21, x$22, x$29, x$23, x$24, "Descriptions must be strings", "Description must be strings", x$30);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$10 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$31 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$10, "WebAPI");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$11 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$32 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$11, "name");
  var x$33 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  var x$37 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$12 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$39 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$12, "path");
  var x$40 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$70 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$37, "", x$31, x$32, x$39, x$33, "1", "API title is mandatory", "Info object 'title' must be a single value", x$40);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$13 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$41 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$13, "WebAPI");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$14 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$42 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$14, "scheme");
  var x$43 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$44 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$47 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$15 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$49 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$15, "path");
  var x$50 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$69 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$47, "", x$41, x$42, x$49, x$43, x$44, "API BaseUri scheme information must be a string", "Swagger object 'schemes' must be a string", x$50);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$16 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$51 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$16, "WebAPI");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$17 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$52 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$17, "scheme");
  var x$53 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$54 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$57 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$18 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$59 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$18, "path");
  var x$60 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$68 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$57, "", x$51, x$52, x$59, x$53, x$54, "API BaseUri scheme information must be a string", "Swagger object 'schemes' must be a string", x$60);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$19 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$61 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$19, "WebAPI");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$20 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$62 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$20, "accepts");
  var x$63 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$64 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$67 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$21 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$69 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$21, "path");
  var x$70 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$67 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$67, "", x$61, x$62, x$69, x$63, x$64, "Default media types must contain strings", "Field 'consumes' must contain strings", x$70);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$22 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$71 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$22, "WebAPI");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$23 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$72 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$23, "accepts");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$24 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$73 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$24, "pattern");
  var x$77 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$25 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$79 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$25, "path");
  var x$80 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$66 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$77, "", x$71, x$72, x$79, x$73, "^(([-\\w]+|[*]{1})\\/([-+.\\w]+|[*]{1}))(\\s*;\\s*\\w+=[-+\\w.]+)*$", "Default media types must be valid", "Field 'produces' must be valid", x$80);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$26 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$81 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$26, "WebAPI");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$27 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$82 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$27, "mediaType");
  var x$83 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$84 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$87 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$28 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$89 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$28, "path");
  var x$90 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$65 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$87, "", x$81, x$82, x$89, x$83, x$84, "Default media types must be string", "Field 'produces' must contain strings", x$90);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$29 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$91 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$29, "WebAPI");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$30 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$92 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$30, "version");
  var x$93 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$94 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$97 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$31 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$99 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$31, "path");
  var x$100 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$64 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$97, "", x$91, x$92, x$99, x$93, x$94, "API version must be a string", "Info object 'version' must be string", x$100);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$32 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$101 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$32, "WebAPI");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$33 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$102 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$33, "termsOfService");
  var x$103 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$104 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$107 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$34 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$109 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$34, "path");
  var x$110 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$63 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$107, "", x$101, x$102, x$109, x$103, x$104, "API terms of service must be a string", "Info object 'termsOfService' must be string", x$110);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$35 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$111 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$35, "Organization");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$36 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$112 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$36, "email");
  var x$113 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$114 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$117 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$37 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$119 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$37, "path");
  var x$120 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$62 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$117, "", x$111, x$112, x$119, x$113, x$114, "API provider email must be a string", "Contact object 'email' must be a string", x$120);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$38 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$121 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$38, "EndPoint");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$39 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$122 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$39, "path");
  var x$123 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$124 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$127 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$40 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$129 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$40, "path");
  var x$130 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$61 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$127, "", x$121, x$122, x$129, x$123, x$124, "Resource path must be a string", "PathItem object path must be a string", x$130);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$41 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$132 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$41, "Operation");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$42 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$133 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$42, "guiSummary");
  var x$134 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$135 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$136 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$43 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$137 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$43, "path");
  var x$140 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$60 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$136, "Methods' summary information must be a string", x$132, x$133, x$137, x$134, x$135, "", "", x$140);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$44 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$142 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$44, "Operation");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$45 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var x$143 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$45, "deprecated");
  var x$144 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$145 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().boolean$1;
  var x$146 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$46 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$147 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$46, "path");
  var x$150 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$59 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$146, "Methods' deprecated must be a boolean", x$142, x$143, x$147, x$144, x$145, "", "", x$150);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$47 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$151 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$47, "Operation");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$48 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$152 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$48, "scheme");
  var x$153 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$154 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$157 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$49 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$159 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$49, "path");
  var x$160 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$58 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$157, "", x$151, x$152, x$159, x$153, x$154, "Protocols must contain strings", "Schemes must contain strings", x$160);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$50 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$161 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$50, "Operation");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$51 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$162 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$51, "accepts");
  var x$163 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$164 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$167 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$52 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$169 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$52, "path");
  var x$170 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$57 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$167, "", x$161, x$162, x$169, x$163, x$164, "Method default media types consumed must be strings", "Operation object 'consumes' must be strings", x$170);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$53 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$171 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$53, "Response");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$54 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$172 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$54, "statusCode");
  var x$173 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$174 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$177 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$55 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$179 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$55, "path");
  var x$180 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$56 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$177, "", x$171, x$172, x$179, x$173, x$174, "Status code for a Response must be a string", "Status code for a Response object must be a string", x$180);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var name = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().doc$1.displayName$1;
  var ns$56 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$181 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$56, name);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$57 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$182 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$57, "name");
  var x$183 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  var x$187 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$58 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$189 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$58, "path");
  var x$190 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$55 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$187, "", x$181, x$182, x$189, x$183, "1", "Parameter information must have a name", "Parameter object must have a name property", x$190);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var name$1 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().doc$1.displayName$1;
  var ns$59 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$191 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$59, name$1);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$60 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$192 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$60, "required");
  var x$193 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$194 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().boolean$1;
  var x$197 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$61 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$199 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$61, "path");
  var x$200 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$54 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$197, "", x$191, x$192, x$199, x$193, x$194, "Information about required parameters must be a boolean value", "Required property of a Parameter object must be boolean", x$200);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var name$2 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().doc$1.displayName$1;
  var ns$62 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$201 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$62, name$2);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$63 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$202 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$63, "binding");
  var x$203 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$204 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$207 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$64 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$209 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$64, "path");
  var x$210 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$53 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$207, "", x$201, x$202, x$209, x$203, x$204, "Information about the binding of the parameter is mandatory", "'in' property of a Parameter object must be a string", x$210);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var name$3 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().doc$1.displayName$1;
  var ns$65 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$211 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$65, name$3);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$66 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$212 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$66, "binding");
  var x$213 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  var x$217 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$67 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$219 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$67, "path");
  var x$220 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$52 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$217, "", x$211, x$212, x$219, x$213, "1", "Binding information for a parameter is mandatory", "'in' property of a Parameter object is mandatory", x$220);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$68 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$221 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$68, "Payload");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$69 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$222 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$69, "mediaType");
  var x$223 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$224 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$227 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$70 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$229 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$70, "path");
  var x$230 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$51 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$227, "", x$221, x$222, x$229, x$223, x$224, "Method default media types must be strings", "Operation object 'produces' must be strings", x$230);
  var x$231 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("xml-wrapped-scalar");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$71 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$233 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$71, "ScalarShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$72 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$234 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$72, "xmlSerialization");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$73 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$235 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$73, "xmlWrappedScalar");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$74 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$236 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$74, "path");
  var x$240 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$50 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$231, "XML property 'wrapped' must be false for scalar types", x$233, x$234, x$236, x$235, "0", "", "", x$240);
  var x$241 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("xml-non-scalar-attribute");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$75 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$243 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$75, "Shape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$76 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$244 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$76, "xmlSerialization");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$77 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$245 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$77, "xmlNonScalarAttribute");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$78 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$246 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$78, "path");
  var x$250 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$49 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$241, "XML property 'attribute' must be false for non-scalar types", x$243, x$244, x$246, x$245, "0", "", "", x$250);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$79 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$252 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$79, "XMLSerializer");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$80 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$253 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$80, "xmlAtribute");
  var x$254 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$255 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().boolean$1;
  var x$256 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$81 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$257 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$81, "path");
  var x$260 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$48 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$256, "XML attribute serialisation info must be boolean", x$252, x$253, x$257, x$254, x$255, "", "", x$260);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$82 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$262 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$82, "XMLSerializer");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$83 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$263 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$83, "xmlWrapped");
  var x$264 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$265 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().boolean$1;
  var x$266 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$84 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$267 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$84, "path");
  var x$270 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$47 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$266, "XML wrapping serialisation info must be boolean", x$262, x$263, x$267, x$264, x$265, "", "", x$270);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$85 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$272 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$85, "XMLSerializer");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$86 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$273 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$86, "xmlName");
  var x$274 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$275 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$276 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$87 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$277 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$87, "path");
  var x$280 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$46 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$276, "XML name serialisation info must be string", x$272, x$273, x$277, x$274, x$275, "", "", x$280);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$88 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$282 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$88, "XMLSerializer");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$89 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$283 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$89, "xmlNamespace");
  var x$284 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$285 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$286 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$90 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$287 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$90, "path");
  var x$290 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$45 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$286, "XML namespace serialisation info must be string", x$282, x$283, x$287, x$284, x$285, "", "", x$290);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$91 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$292 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$91, "XMLSerializer");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$92 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$293 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$92, "xmlPrefix");
  var x$294 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$295 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$296 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$93 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$297 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$93, "path");
  var x$300 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$44 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$296, "XML prefix serialisation info must be string", x$292, x$293, x$297, x$294, x$295, "", "", x$300);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$94 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$301 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$94, "ObjectShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$95 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$302 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$95, "minProperties");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$96 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$303 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$96, "minInclusive");
  var x$306 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$97 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$308 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$97, "path");
  var x$310 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$43 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$306, "", x$301, x$302, x$308, x$303, "0", "minProperties for a RAML Object type cannot be negative", "minProperties for a Schema object cannot be negative", x$310);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$98 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$311 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$98, "ObjectShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$99 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$312 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$99, "minProperties");
  var x$313 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$314 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().integer$1;
  var x$317 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$100 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$319 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$100, "path");
  var x$320 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$42 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$317, "", x$311, x$312, x$319, x$313, x$314, "minProperties for a RAML Object type must be an integer", "minProperties for a Schema object must be an integer", x$320);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$101 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$321 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$101, "ObjectShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$102 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$322 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$102, "maxProperties");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$103 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$323 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$103, "minInclusive");
  var x$326 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$104 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$328 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$104, "path");
  var x$330 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$41 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$326, "", x$321, x$322, x$328, x$323, "0", "maxProperties for a RAML Object type cannot be negative", "maxProperties for a Schema object cannot be negative", x$330);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$105 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$331 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$105, "ObjectShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$106 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$332 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$106, "maxProperties");
  var x$333 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$334 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().integer$1;
  var x$337 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$107 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$339 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$107, "path");
  var x$340 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$40 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$337, "", x$331, x$332, x$339, x$333, x$334, "maxProperties for a RAML Object type must be an integer", "maxProperties for a Schema object must be an integer", x$340);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$108 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$341 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$108, "ObjectShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$109 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$342 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$109, "closed");
  var x$343 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$344 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().boolean$1;
  var x$347 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$110 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$349 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$110, "path");
  var x$350 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$39 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$347, "", x$341, x$342, x$349, x$343, x$344, "additionalProperties for a RAML Object type must be a boolean", "additionalProperties for a Schema object must be a boolean", x$350);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$111 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$351 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$111, "ObjectShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$112 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$352 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$112, "discriminator");
  var x$353 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$354 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$357 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$113 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$359 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$113, "path");
  var x$360 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$38 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$357, "", x$351, x$352, x$359, x$353, x$354, "discriminator for RAML Object type must be a string value", "discriminator for a Schema object must be a string value", x$360);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$114 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$361 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$114, "ObjectShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$115 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$362 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$115, "discriminatorValue");
  var x$363 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$364 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$367 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$116 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$369 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$116, "path");
  var x$370 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$37 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$367, "", x$361, x$362, x$369, x$363, x$364, "x-discriminatorValue for RAML Object type must be a string value", "discriminatorValue for a Schema object must be a string value", x$370);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$117 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$371 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$117, "ObjectShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$118 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$372 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$118, "readOnly");
  var x$373 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$374 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().boolean$1;
  var x$377 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$119 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$379 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$119, "path");
  var x$380 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$36 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$377, "", x$371, x$372, x$379, x$373, x$374, "(readOnly) for a RAML Object type must be a boolean", "readOnly for a Schema object must be a boolean", x$380);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$120 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$381 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$120, "ArrayShape");
  var x$382 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  var x$383 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$384 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().integer$1;
  var x$387 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$121 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$389 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$121, "path");
  var x$390 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$35 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$387, "", x$381, x$382, x$389, x$383, x$384, "minItems for a RAML Array type must be an integer", "minItems of a Schema object of type 'array' must be an integer", x$390);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$122 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$391 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$122, "ArrayShape");
  var x$392 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$123 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$393 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$123, "minInclusive");
  var x$396 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$124 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$398 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$124, "path");
  var x$400 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$34 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$396, "", x$391, x$392, x$398, x$393, "0", "maxItems for a RAML Array type must be greater than 0", "maxItems of a Schema object of type 'array' must be greater than 0", x$400);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$125 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$401 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$125, "ArrayShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$126 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$402 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$126, "maxCount");
  var x$403 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$404 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().integer$1;
  var x$407 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$127 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$409 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$127, "path");
  var x$410 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$33 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$407, "", x$401, x$402, x$409, x$403, x$404, "maxItems for a RAML Array type must be an integer", "maxItems of a Schema object of type 'array' must be an integer", x$410);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$128 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$411 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$128, "ArrayShape");
  var x$412 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$129 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$413 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$129, "minInclusive");
  var x$416 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$130 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$418 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$130, "path");
  var x$420 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$32 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$416, "", x$411, x$412, x$418, x$413, "0", "minItems for a RAML Array type must be greater than 0", "minItems of a Schema object of type 'array' must be greater than 0", x$420);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$131 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$421 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$131, "ArrayShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$132 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$422 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$132, "maxCount");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$133 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$423 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$133, "minInclusive");
  var x$426 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$134 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$428 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$134, "path");
  var x$430 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$31 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$426, "", x$421, x$422, x$428, x$423, "0", "maxItems for a RAML Array type must be greater than 0", "maxItems of a Schema object of type 'array' must be greater than 0", x$430);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$135 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$431 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$135, "ArrayShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$136 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$432 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$136, "uniqueItems");
  var x$433 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$434 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().boolean$1;
  var x$437 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$137 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$439 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$137, "path");
  var x$440 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$30 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$437, "", x$431, x$432, x$439, x$433, x$434, "uniqueItems for a RAML Array type must be a boolean", "uniqueItems of a Schema object of type 'array' must be a boolean", x$440);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$138 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$441 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$138, "ScalarShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$139 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$442 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$139, "pattern");
  var x$443 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$444 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$447 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$140 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$449 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$140, "path");
  var x$450 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$29 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$447, "", x$441, x$442, x$449, x$443, x$444, "pattern facet for a RAML scalar type must be a string", "pattern for scalar Schema object of scalar type must be a string", x$450);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$141 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$451 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$141, "ScalarShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$142 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$452 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$142, "minLength");
  var x$453 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$454 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().integer$1;
  var x$457 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$143 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$459 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$143, "path");
  var x$460 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$28 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$457, "", x$451, x$452, x$459, x$453, x$454, "minLength facet for a RAML scalar type must be a integer", "minLength for scalar Schema object of scalar type must be a integer", x$460);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$144 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$461 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$144, "ScalarShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$145 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$462 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$145, "maxLength");
  var x$463 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$464 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().integer$1;
  var x$467 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$146 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$469 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$146, "path");
  var x$470 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$27 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$467, "", x$461, x$462, x$469, x$463, x$464, "maxLength facet for a RAML scalar type must be a integer", "maxLength for scalar Schema object of scalar type must be a integer", x$470);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$147 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$471 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$147, "ScalarShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$148 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$472 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$148, "minInclusive");
  var x$473 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$477 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$149 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$479 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$149, "path");
  var x$480 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$26 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$477, "", x$471, x$472, x$479, x$473, "xsd:double", "minimum facet for a RAML scalar type must be a number", "minimum for scalar Schema object of scalar type must be a integer", x$480);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$150 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$481 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$150, "ScalarShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$151 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$482 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$151, "maxInclusive");
  var x$483 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$487 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$152 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$489 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$152, "path");
  var x$490 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$25 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$487, "", x$481, x$482, x$489, x$483, "xsd:double", "maximum facet for a RAML scalar type must be a number", "maximum for scalar Schema object of scalar type must be a integer", x$490);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$153 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$491 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$153, "ScalarShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$154 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$492 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$154, "minExclusive");
  var x$493 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$494 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().boolean$1;
  var x$497 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$155 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$499 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$155, "path");
  var x$500 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$24 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$497, "", x$491, x$492, x$499, x$493, x$494, "x-exclusiveMinimum facet for a RAML scalar type must be a boolean", "exclusiveMinimum for scalar Schema object of scalar type must be a boolean", x$500);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$156 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$501 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$156, "ScalarShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$157 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$502 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$157, "maxExclusive");
  var x$503 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$504 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().boolean$1;
  var x$507 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$158 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$509 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$158, "path");
  var x$510 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$23 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$507, "", x$501, x$502, x$509, x$503, x$504, "x-exclusiveMaximum facet for a RAML scalar type must be a boolean", "exclusiveMaximum for scalar Schema object of scalar type must be a boolean", x$510);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$159 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$512 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$159, "ScalarShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$160 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$513 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$160, "minLength");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$161 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$514 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$161, "minInclusive");
  var x$515 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$162 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$516 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$162, "path");
  var x$520 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$22 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$515, "Min length facet should be greater or equal than 0", x$512, x$513, x$516, x$514, "0", "", "", x$520);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$163 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$522 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$163, "ScalarShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$164 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$523 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$164, "maxLength");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$165 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$524 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$165, "minInclusive");
  var x$525 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$166 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$526 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$166, "path");
  var x$530 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$21 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$525, "Max length facet should be greater or equal than 0", x$522, x$523, x$526, x$524, "0", "", "", x$530);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$167 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$532 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$167, "FileShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$168 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$533 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$168, "minLength");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$169 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$534 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$169, "minInclusive");
  var x$535 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$170 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$536 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$170, "path");
  var x$540 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$20 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$535, "Min length facet should be greater or equal than 0", x$532, x$533, x$536, x$534, "0", "", "", x$540);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$171 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$542 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$171, "FileShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$172 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$543 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$172, "maxLength");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$173 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$544 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$173, "minInclusive");
  var x$545 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$174 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$546 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$174, "path");
  var x$550 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$19 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$545, "Max length facet should be greater or equal than 0", x$542, x$543, x$546, x$544, "0", "", "", x$550);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$175 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$551 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$175, "ScalarShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$176 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$552 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$176, "format");
  var x$553 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$554 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$557 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$177 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$559 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$177, "path");
  var x$560 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$18 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$557, "", x$551, x$552, x$559, x$553, x$554, "format facet for a RAML scalar type must be a string", "format for scalar Schema object of scalar type must be a string", x$560);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$178 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$561 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$178, "ScalarShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$179 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$562 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$179, "multipleOf");
  var x$563 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$567 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$180 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$569 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$180, "path");
  var x$570 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$17 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$567, "", x$561, x$562, x$569, x$563, "xsd:double", "multipleOf facet for a RAML scalar type must be a number", "multipleOf for scalar Schema object of scalar type must be a number", x$570);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$181 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$571 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$181, "ScalarShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$182 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$572 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$182, "multipleOf");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$183 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$573 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$183, "minExclusive");
  var x$576 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$184 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$578 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$184, "path");
  var x$580 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$16 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$576, "", x$571, x$572, x$578, x$573, "0", "multipleOf facet for a RAML scalar type must be greater than 0", "multipleOf for scalar Schema object of scalar type must be greater than 0", x$580);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$185 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$581 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$185, "ScalarShape");
  var x$582 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$583 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  var x$587 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$186 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$589 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$186, "path");
  var x$590 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$15 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$587, "", x$581, x$582, x$589, x$583, "1", "type information for a RAML scalar is required", "type information fo a Schema object of scalar type is required", x$590);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$187 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$591 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$187, "Tag");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$188 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$592 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$188, "name");
  var x$593 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  var x$597 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$189 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$599 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$189, "path");
  var x$600 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$14 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$597, "", x$591, x$592, x$599, x$593, "1", "Tag must have a name", "Tag object must have a name property", x$600);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$190 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$601 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$190, "Server");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$191 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$602 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$191, "urlTemplate");
  var x$603 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$604 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$607 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$192 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$609 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$192, "path");
  var x$610 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$13 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$607, "", x$601, x$602, x$609, x$603, x$604, "API baseUri host information must be a string", "Swagger object 'host' and 'basePath' must be a string", x$610);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$193 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$612 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$193, "Server");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$194 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$613 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$194, "description");
  var x$614 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().dataType$1;
  var x$615 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().string$1;
  var x$616 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$195 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$617 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$195, "path");
  var x$620 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$12 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$616, "Server 'description' property must be a string", x$612, x$613, x$617, x$614, x$615, "", "", x$620);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$196 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$622 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$196, "Server");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$197 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$623 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$197, "urlTemplate");
  var x$624 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  var x$626 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$198 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$627 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$198, "path");
  var x$630 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$11 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$626, "Server must have an 'url' property", x$622, x$623, x$627, x$624, "1", "", "", x$630);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$199 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var x$632 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$199, "SecurityScheme");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$200 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var x$633 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$200, "type");
  var x$634 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  var x$636 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$201 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$637 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$201, "path");
  var x$640 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$10 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$636, "Security scheme type is mandatory", x$632, x$633, x$637, x$634, "1", "", "", x$640);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$202 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var x$642 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$202, "SecurityScheme");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$203 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var x$643 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$203, "type");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$204 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$644 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$204, "pattern");
  var x$646 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$205 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$647 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$205, "path");
  var x$650 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$9 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$646, "Security scheme type should be one of the supported ones", x$642, x$643, x$647, x$644, "^OAuth\\s1.0|OAuth\\s2.0|Basic\\sAuthentication|Digest\\sAuthentication|Pass\\sThrough|Api\\sKey|http|openIdConnect|userPassword|X509|symmetricEncryption|asymmetricEncryption|x-.+$", "", "", x$650);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$206 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var x$652 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$206, "SecurityScheme");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$207 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var x$653 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$207, "type");
  var x$654 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  var x$656 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$208 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$657 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$208, "path");
  var x$660 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$8 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$656, "Type is mandatory in a Security Scheme Object", x$652, x$653, x$657, x$654, "1", "", "", x$660);
  var jsx$7 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$();
  var jsx$6 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("strict-url-strinzgs");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$209 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var jsx$5 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$209, "DomainElement");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$210 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var jsx$4 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$210, "url");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$211 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var jsx$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$211, "targetObjectsOf");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$212 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var jsx$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$212, "nodeKind");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$213 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var jsx$1 = jsx$7.apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(jsx$6, "URLs in values mapped to core:url must be valid", jsx$5, jsx$4, jsx$3, jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$213, "IRI").iri__T(), "URLs must be valid", "URLs must be valid", $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1);
  var x$661 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("pattern-validation");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$214 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$663 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$214, "ScalarShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$215 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$664 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$215, "pattern");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$216 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$665 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$216, "patternValidation");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$217 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$666 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$217, "path");
  var x$670 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var array = [jsx$73, jsx$72, jsx$71, jsx$70, jsx$69, jsx$68, jsx$67, jsx$66, jsx$65, jsx$64, jsx$63, jsx$62, jsx$61, jsx$60, jsx$59, jsx$58, jsx$57, jsx$56, jsx$55, jsx$54, jsx$53, jsx$52, jsx$51, jsx$50, jsx$49, jsx$48, jsx$47, jsx$46, jsx$45, jsx$44, jsx$43, jsx$42, jsx$41, jsx$40, jsx$39, jsx$38, jsx$37, jsx$36, jsx$35, jsx$34, jsx$33, jsx$32, jsx$31, jsx$30, jsx$29, jsx$28, jsx$27, jsx$26, jsx$25, jsx$24, jsx$23, jsx$22, jsx$21, jsx$20, jsx$19, jsx$18, jsx$17, jsx$16, jsx$15, jsx$14, jsx$13, jsx$12, jsx$11, jsx$10, jsx$9, jsx$8, jsx$1, $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$661, "Pattern is not valid", x$663, x$664, x$666, x$665, "0", "", "", x$670)];
  return $as_sc_Seq(jsx$74.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector() {
  $c_O.call(this);
  this.model$1 = null
}
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector.prototype = $c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector.prototype;
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector.prototype.findExtensionsWithTypes__sc_Seq = (function() {
  var this$2 = this.model$1;
  var strategy = $m_Lamf_core_traversal_iterator_AmfElementStrategy$();
  var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
  var this$3 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(this$2, strategy, fieldsFilter);
  var pf = new $c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1().init___Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector(this);
  var travs = new $c_sc_Iterator$$anon$13().init___sc_Iterator__s_PartialFunction(this$3, pf);
  var ev = $m_s_Predef$().singleton$und$less$colon$less$2;
  var this$5 = new $c_sc_TraversableOnce$MonadOps().init___sc_TraversableOnce(travs);
  var this$6 = this$5.trav$1.toIterator__sc_Iterator();
  var this$7 = new $c_sc_TraversableOnce$FlattenOps().init___sc_TraversableOnce(new $c_sc_Iterator$$anon$10().init___sc_Iterator__F1(this$6, ev));
  var this$8 = new $c_sc_TraversableOnce$FlattenOps$$anon$2().init___sc_TraversableOnce$FlattenOps(this$7);
  return $f_sc_Iterator__toStream__sci_Stream(this$8)
});
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_core_remote_Platform = (function(model, platform) {
  this.model$1 = model;
  return this
});
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector.prototype.collect__sc_Seq = (function() {
  var domainExtensionsWithTypes = this.findExtensionsWithTypes__sc_Seq();
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(extension$2) {
      var extension = $as_Lamf_core_model_domain_extensions_Extension(extension$2);
      var extensionPayload = $as_Lamf_core_model_domain_DataNode(extension.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1));
      var extensionShape = extension.obtainSchema__Lamf_core_model_domain_Shape();
      var fragment = $m_Lamf_core_model_document_PayloadFragment$().apply__Lamf_core_model_domain_DataNode__T__Lamf_core_model_document_PayloadFragment(extensionPayload, "application/yaml");
      return new $c_Lamf_core_validation_ValidationCandidate().init___Lamf_core_model_domain_Shape__Lamf_core_model_document_PayloadFragment(extensionShape, fragment)
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  return $as_sc_Seq(domainExtensionsWithTypes.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))
});
var $d_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector: 0
}, false, "amf.plugins.document.webapi.validation.ExtensionsCandidatesCollector", {
  Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$.prototype = $c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$.prototype;
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$.prototype.apply__Lamf_core_model_document_BaseUnit__Lamf_core_remote_Platform__sc_Seq = (function(model, platform) {
  return new $c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector().init___Lamf_core_model_document_BaseUnit__Lamf_core_remote_Platform(model, platform).collect__sc_Seq()
});
var $d_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$: 0
}, false, "amf.plugins.document.webapi.validation.ExtensionsCandidatesCollector$", {
  Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$;
var $n_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$)) {
    $n_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$ = new $c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_JsCustomValidations$() {
  $c_O.call(this);
  this.functions$1 = null
}
$c_Lamf_plugins_document_webapi_validation_JsCustomValidations$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_JsCustomValidations$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_JsCustomValidations$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_JsCustomValidations$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_JsCustomValidations$.prototype = $c_Lamf_plugins_document_webapi_validation_JsCustomValidations$.prototype;
$c_Lamf_plugins_document_webapi_validation_JsCustomValidations$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_validation_JsCustomValidations$ = this;
  var this$3 = new $c_sci_StringOps().init___T("|function(shape) {\n         |  var pattern = shape[\"shacl:pattern\"];\n         |  try {\n         |    if(pattern) new RegExp(pattern);\n         |    return true;\n         |  } catch(e) {\n         |    return false;\n         |  }\n         |}\n      ");
  var y = $f_sci_StringLike__stripMargin__C__T(this$3, 124);
  var jsx$10 = new $c_T2().init___O__O("patternValidation", y);
  var this$7 = new $c_sci_StringOps().init___T("\n        |function(shape) {\n        |  var protocolsArray = shape[\"apiContract:scheme\"];\n        |  return !Array.isArray(protocolsArray) || protocolsArray.length > 0;\n        |}\n      ");
  var y$1 = $f_sci_StringLike__stripMargin__C__T(this$7, 124);
  var jsx$9 = new $c_T2().init___O__O("nonEmptyListOfProtocols", y$1);
  var this$11 = new $c_sci_StringOps().init___T("\n        |function(shape) {\n        |  return true;\n        |}\n      ");
  var y$2 = $f_sci_StringLike__stripMargin__C__T(this$11, 124);
  var jsx$8 = new $c_T2().init___O__O("requiredFlowsInOAuth2", y$2);
  var this$15 = new $c_sci_StringOps().init___T("\n        |function(shape) {\n        |  return true;\n        |}\n      ");
  var y$3 = $f_sci_StringLike__stripMargin__C__T(this$15, 124);
  var jsx$7 = new $c_T2().init___O__O("requiredOpenIdConnectUrl", y$3);
  var this$19 = new $c_sci_StringOps().init___T("\n        |function(shape) {\n        |  return true;\n        |}\n      ");
  var y$4 = $f_sci_StringLike__stripMargin__C__T(this$19, 124);
  var jsx$6 = new $c_T2().init___O__O("validCallbackExpression", y$4);
  var this$23 = new $c_sci_StringOps().init___T("\n        |function(shape) {\n        |  return true;\n        |}\n      ");
  var y$5 = $f_sci_StringLike__stripMargin__C__T(this$23, 124);
  var jsx$5 = new $c_T2().init___O__O("validLinkRequestBody", y$5);
  var this$27 = new $c_sci_StringOps().init___T("\n        |function(shape) {\n        |  return true;\n        |}\n      ");
  var y$6 = $f_sci_StringLike__stripMargin__C__T(this$27, 124);
  var jsx$4 = new $c_T2().init___O__O("validLinkParameterExpressions", y$6);
  var this$31 = new $c_sci_StringOps().init___T("\n        |function(shape) {\n        |  return true;\n        |}\n      ");
  var y$7 = $f_sci_StringLike__stripMargin__C__T(this$31, 124);
  var jsx$3 = new $c_T2().init___O__O("headerParamNameMustBeAscii", y$7);
  var this$35 = new $c_sci_StringOps().init___T("\n        |function(shape) {\n        |  return true;\n        |}\n      ");
  var y$8 = $f_sci_StringLike__stripMargin__C__T(this$35, 124);
  var jsx$2 = new $c_T2().init___O__O("mandatoryHeadersObjectNode", y$8);
  var this$39 = new $c_sci_StringOps().init___T("\n        |function(shape) {\n        |  return true;\n        |}\n      ");
  var y$9 = $f_sci_StringLike__stripMargin__C__T(this$39, 124);
  var jsx$1 = new $c_T2().init___O__O("mandatoryHeaderNamePattern", y$9);
  var this$43 = new $c_sci_StringOps().init___T("\n        |function(shape) {\n        |  return true;\n        |}\n      ");
  var y$10 = $f_sci_StringLike__stripMargin__C__T(this$43, 124);
  var array = [jsx$10, jsx$9, jsx$8, jsx$7, jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, jsx$1, new $c_T2().init___O__O("mandatoryHeaderBindingNamePattern", y$10)];
  var this$48 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$48.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  this.functions$1 = $as_sci_Map(this$48.elems$1);
  return this
});
var $d_Lamf_plugins_document_webapi_validation_JsCustomValidations$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_JsCustomValidations$: 0
}, false, "amf.plugins.document.webapi.validation.JsCustomValidations$", {
  Lamf_plugins_document_webapi_validation_JsCustomValidations$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_validation_JsCustomValidations$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_JsCustomValidations$;
var $n_Lamf_plugins_document_webapi_validation_JsCustomValidations$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_JsCustomValidations$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_JsCustomValidations$)) {
    $n_Lamf_plugins_document_webapi_validation_JsCustomValidations$ = new $c_Lamf_plugins_document_webapi_validation_JsCustomValidations$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_JsCustomValidations$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector() {
  $c_O.call(this);
  this.DataNodeCollectedElement$module$1 = null;
  this.StringCollectedElement$module$1 = null;
  this.model$1 = null;
  this.idCounter$1 = null
}
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector.prototype = $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector.prototype;
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector.prototype.init___Lamf_core_model_document_BaseUnit = (function(model) {
  this.model$1 = model;
  this.idCounter$1 = new $c_Lamf_core_utils_package$IdCounter().init___();
  return this
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector.prototype.getDefault__p1__Lamf_core_model_domain_Shape__s_Option = (function(shape) {
  var this$1 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_DataNode(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Default$1)));
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var d = $as_Lamf_core_model_domain_DataNode(arg1);
    var jsx$1 = d.id$1;
    var this$2 = $as_Lamf_core_model_StrField(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().DefaultValueString$1)).option$1;
    var this$3 = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement().init___Lamf_plugins_document_webapi_validation_PayloadsInApiCollector__Lamf_core_model_domain_DataNode__T__T__Lamf_core_parser_Annotations(this, d, jsx$1, $as_T((this$2.isEmpty__Z() ? "" : this$2.get__O())), d.annotations__Lamf_core_parser_Annotations()))
  };
  if (this$3.isEmpty__Z()) {
    var this$4 = $as_Lamf_core_model_StrField(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().DefaultValueString$1)).option$1;
    if (this$4.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1$1 = this$4.get__O();
      var s = $as_T(arg1$1);
      return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement().init___Lamf_plugins_document_webapi_validation_PayloadsInApiCollector__T__T__Lamf_core_parser_Annotations(this, shape.id$1, s, $as_Lamf_core_model_StrField(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().DefaultValueString$1)).annotations$1))
    }
  } else {
    return this$3
  }
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector.prototype.anyShapeRestrictions__p1__sc_Seq = (function() {
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Values$1, $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Inherits$1, $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Or$1, $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().And$1, $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Xone$1, $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Not$1];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector.prototype.findCandidates__sc_Seq = (function() {
  var results = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var shapes = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var this$3 = this.model$1;
  var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
  var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
  var this$4 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(this$3, strategy, fieldsFilter);
  while (this$4.hasNext__Z()) {
    var arg1 = this$4.next__Lamf_core_model_domain_AmfElement();
    var rc6 = false;
    var x2 = null;
    matchEnd7: {
      if ((arg1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
        rc6 = true;
        x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1);
        var x = x2.meta__Lamf_plugins_domain_shapes_metamodel_AnyShapeModel();
        var x$2 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$();
        if ((((x !== null) && (x === x$2)) && (!this.anyShapeRestrictions__p1__sc_Seq().exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x2$1) {
          return (function(f$2) {
            var f = $as_Lamf_core_metamodel_Field(f$2);
            var this$5 = x2$1.fields__Lamf_core_parser_Fields();
            return this$5.fs$1.contains__O__Z(f)
          })
        })(this, x2)))))) {
          break matchEnd7
        }
      };
      if ((rc6 && results.keys__sc_Iterable().exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, x2$2) {
        return (function(x$1$2) {
          var x$1 = $as_T(x$1$2);
          var that = x2$2.id$1;
          return (x$1 === that)
        })
      })(this, x2))))) {
        var currentExamples = $as_sc_Seq(results.apply__O__O(x2.id$1));
        var this$6 = x2;
        $as_sc_Seq(this$6.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, currentExamples$1, results$1, x2$3) {
          return (function(e$2) {
            var e = $as_Lamf_plugins_domain_shapes_models_Example(e$2);
            if ((!currentExamples$1.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, e$1) {
              return (function(x$2$2) {
                var x$2$1 = $as_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement(x$2$2);
                var this$7 = x$2$1.id__T();
                var that$1 = e$1.id$1;
                return (this$7 === that$1)
              })
            })(this$3$1, e))))) {
              matchEnd5: {
                if ((e !== null)) {
                  var this$8 = e.fields$1;
                  var f$1 = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1;
                  if (this$8.fs$1.contains__O__Z(f$1)) {
                    var this$9 = $as_Lamf_core_model_BoolField(e.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Strict$1)).option$1;
                    var jsx$1 = $uZ((this$9.isEmpty__Z() || this$9.get__O()))
                  } else {
                    var jsx$1 = false
                  };
                  if ((jsx$1 && (!currentExamples$1.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$2, x2$4) {
                    return (function(x$3$2) {
                      var x$3 = $as_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement(x$3$2);
                      var this$10 = x$3.id__T();
                      var that$2 = x2$4.id$1;
                      return (this$10 === that$2)
                    })
                  })(this$3$1, e)))))) {
                    var jsx$5 = x2$3.id$1;
                    var jsx$4 = $as_Lamf_core_model_domain_DataNode(e.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1));
                    var jsx$3 = e.id$1;
                    var this$11 = $as_Lamf_core_model_StrField(e.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1));
                    var this$12 = this$11.option$1;
                    var jsx$2 = new $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement().init___Lamf_plugins_document_webapi_validation_PayloadsInApiCollector__Lamf_core_model_domain_DataNode__T__T__Lamf_core_parser_Annotations(this$3$1, jsx$4, jsx$3, $as_T((this$12.isEmpty__Z() ? null : this$12.get__O())), e.annotations$1);
                    var this$13 = $m_sc_Seq$();
                    results$1.update__O__O__V(jsx$5, currentExamples$1.$$colon$plus__O__scg_CanBuildFrom__O(jsx$2, this$13.ReusableCBFInstance$2));
                    break matchEnd5
                  }
                };
                if ((e !== null)) {
                  var this$14 = e.fields$1;
                  var f$3 = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Raw$1;
                  if (this$14.fs$1.contains__O__Z(f$3)) {
                    var this$15 = $as_Lamf_core_model_BoolField(e.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Strict$1)).option$1;
                    var jsx$6 = $uZ((this$15.isEmpty__Z() || this$15.get__O()))
                  } else {
                    var jsx$6 = false
                  };
                  if ((jsx$6 && (!currentExamples$1.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1, x3) {
                    return (function(x$4$2) {
                      var x$4 = $as_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement(x$4$2);
                      var this$16 = x$4.id__T();
                      var that$3 = x3.id$1;
                      return (this$16 === that$3)
                    })
                  })(this$3$1, e)))))) {
                    var jsx$9 = x2$3.id$1;
                    var jsx$8 = e.id$1;
                    var this$17 = $as_Lamf_core_model_StrField(e.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1));
                    var this$18 = this$17.option$1;
                    var jsx$7 = new $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement().init___Lamf_plugins_document_webapi_validation_PayloadsInApiCollector__T__T__Lamf_core_parser_Annotations(this$3$1, jsx$8, $as_T((this$18.isEmpty__Z() ? null : this$18.get__O())), e.annotations$1);
                    var this$19 = $m_sc_Seq$();
                    results$1.update__O__O__V(jsx$9, currentExamples$1.$$colon$plus__O__scg_CanBuildFrom__O(jsx$7, this$19.ReusableCBFInstance$2));
                    break matchEnd5
                  }
                }
              }
            }
          })
        })(this, currentExamples, results, x2)));
        var jsx$12 = x2.id$1;
        var jsx$11 = $as_sc_TraversableLike(results.apply__O__O(x2.id$1));
        var xo = this.getDefault__p1__Lamf_core_model_domain_Shape__s_Option(x2);
        var jsx$10 = xo.toList__sci_List();
        var this$21 = $m_sc_Seq$();
        results.update__O__O__V(jsx$12, jsx$11.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$10, this$21.ReusableCBFInstance$2));
        break matchEnd7
      };
      if (rc6) {
        var this$22 = x2;
        var jsx$14 = $as_sc_Seq(this$22.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1));
        var jsx$13 = new $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$$anonfun$1().init___Lamf_plugins_document_webapi_validation_PayloadsInApiCollector(this);
        var this$23 = $m_sc_Seq$();
        var examples = $as_sc_Seq(jsx$14.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$13, this$23.ReusableCBFInstance$2));
        if (examples.nonEmpty__Z()) {
          var jsx$16 = x2.id$1;
          var xo$1 = this.getDefault__p1__Lamf_core_model_domain_Shape__s_Option(x2);
          var jsx$15 = xo$1.toList__sci_List();
          var this$25 = $m_sc_Seq$();
          results.put__O__O__s_Option(jsx$16, examples.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$15, this$25.ReusableCBFInstance$2));
          shapes.put__O__O__s_Option(x2.id$1, x2);
          break matchEnd7
        } else {
          var x1$2 = this.getDefault__p1__Lamf_core_model_domain_Shape__s_Option(x2);
          if ((x1$2 instanceof $c_s_Some)) {
            var x2$2$1 = $as_s_Some(x1$2);
            var ei = $as_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement(x2$2$1.value$2);
            var jsx$18 = x2.id$1;
            var jsx$17 = $m_sc_Seq$();
            var array = [ei];
            results.put__O__O__s_Option(jsx$18, jsx$17.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
            shapes.put__O__O__s_Option(x2.id$1, x2);
            break matchEnd7
          } else {
            var x$3$1 = $m_s_None$();
            if ((x$3$1 === x1$2)) {
              var this$28 = x2;
              var jsx$19 = $as_sc_Seq(this$28.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Values$1)).nonEmpty__Z()
            } else {
              var jsx$19 = false
            };
            if (jsx$19) {
              shapes.put__O__O__s_Option(x2.id$1, x2);
              results.put__O__O__s_Option(x2.id$1, $m_sci_Nil$());
              break matchEnd7
            } else {
              break matchEnd7
            }
          }
        }
      }
    }
  };
  var f$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$2, shapes$1) {
    return (function(x0$2$2) {
      var x0$2 = $as_T2(x0$2$2);
      if ((x0$2 !== null)) {
        var id = $as_T(x0$2.$$und1__O());
        var e$3 = $as_sc_Seq(x0$2.$$und2__O());
        var shape = $as_Lamf_core_model_domain_Shape(shapes$1.apply__O__O(id));
        if (e$3.isEmpty__Z()) {
          var jsx$20 = $m_sc_Seq$();
          var array$1 = [new $c_Lamf_core_validation_ValidationCandidate().init___Lamf_core_model_domain_Shape__Lamf_core_model_document_PayloadFragment(shape, new $c_Lamf_core_model_document_PayloadFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___())).withMediaType__T__Lamf_core_model_document_PayloadFragment($m_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$().defaultMediaTypeFor__Lamf_core_model_domain_DataNode__T($as_Lamf_core_model_domain_DataNode($as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Values$1)).head__O()))))];
          return $as_sc_Seq(jsx$20.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)))
        } else {
          var jsx$21 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, shape$1) {
            return (function(encodes$2) {
              var encodes = $as_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement(encodes$2);
              return new $c_Lamf_core_validation_ValidationCandidate().init___Lamf_core_model_domain_Shape__Lamf_core_model_document_PayloadFragment(shape$1, $this$2.buildFragment__p1__Lamf_core_model_domain_Shape__Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement__Lamf_core_model_document_PayloadFragment(shape$1, encodes))
            })
          })(this$2$2, shape));
          var this$35 = $m_sc_Seq$();
          return $as_sc_Seq(e$3.map__F1__scg_CanBuildFrom__O(jsx$21, this$35.ReusableCBFInstance$2))
        }
      } else {
        throw new $c_s_MatchError().init___O(x0$2)
      }
    })
  })(this, shapes));
  var this$36 = $m_scm_Iterable$();
  var bf = this$36.ReusableCBFInstance$2;
  var seq = $as_sc_TraversableOnce($f_sc_TraversableLike__flatMap__F1__scg_CanBuildFrom__O(results, f$4, bf)).toSeq__sc_Seq();
  return seq
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector.prototype.buildFragment__p1__Lamf_core_model_domain_Shape__Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement__Lamf_core_model_document_PayloadFragment = (function(shape, collectedElement) {
  if ((collectedElement instanceof $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement)) {
    var x2 = $as_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement(collectedElement);
    var fragment = $m_Lamf_core_model_document_PayloadFragment$().apply__Lamf_core_model_domain_DataNode__T__Lamf_core_model_document_PayloadFragment(x2.dataNode$2, "text/vnd.yaml")
  } else {
    if ((!(collectedElement instanceof $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement))) {
      throw new $c_s_MatchError().init___O(collectedElement)
    };
    var x3 = $as_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement(collectedElement);
    var jsx$3 = $m_Lamf_core_model_document_PayloadFragment$();
    var jsx$2 = $m_Lamf_core_model_domain_ScalarNode$().apply__T__s_Option__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode(x3.raw$1, $m_s_None$(), x3.a$1);
    var jsx$1 = $m_Lamf_core_utils_package$MediaTypeMatcher$();
    var content = x3.raw$1;
    var fragment = jsx$3.apply__Lamf_core_model_domain_DataNode__T__Lamf_core_model_document_PayloadFragment(jsx$2, jsx$1.guessMediaType$extension__T__Z__T(content, (shape instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)))
  };
  var this$2 = $as_Lamf_core_model_domain_DataNode(fragment.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().Encodes$1));
  var value = collectedElement.id__T();
  $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$2, value);
  return fragment
});
var $d_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_PayloadsInApiCollector: 0
}, false, "amf.plugins.document.webapi.validation.PayloadsInApiCollector", {
  Lamf_plugins_document_webapi_validation_PayloadsInApiCollector: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$.prototype = $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$.prototype;
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$.prototype.apply__Lamf_core_model_document_BaseUnit__sc_Seq = (function(model) {
  var this$1 = new $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector().init___Lamf_core_model_document_BaseUnit(model);
  return this$1.findCandidates__sc_Seq()
});
var $d_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$: 0
}, false, "amf.plugins.document.webapi.validation.PayloadsInApiCollector$", {
  Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$;
var $n_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$)) {
    $n_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$ = new $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement() {
  $c_O.call(this);
  this.id$1 = null;
  this.raw$1 = null;
  this.a$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement.prototype = $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement.prototype;
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement.prototype.init___Lamf_plugins_document_webapi_validation_PayloadsInApiCollector__T__T__Lamf_core_parser_Annotations = (function($$outer, id, raw, a) {
  this.id$1 = id;
  this.raw$1 = raw;
  this.a$1 = a;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
function $as_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.PayloadsInApiCollector$CollectedElement"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.PayloadsInApiCollector$CollectedElement;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector() {
  $c_O.call(this);
  this.model$1 = null
}
$c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector.prototype = $c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector.prototype;
$c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector.prototype.toFacetsDefinitionShape__Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_model_domain_Shape = (function(shape, facetDefinitions) {
  if ((facetDefinitions.length__I() === 1)) {
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var this$4 = new $c_Lamf_plugins_domain_shapes_models_NodeShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
    var value = (shape.id$1 + "Shape");
    var facetsShape = $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value));
    var properties = $as_sc_MapLike(facetDefinitions.head__O()).values__sc_Iterable().toSeq__sc_Seq();
    var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1;
    return $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(facetsShape, field, properties))
  } else {
    $m_Lamf_core_parser_Annotations$();
    var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
    var this$8 = new $c_Lamf_plugins_domain_shapes_models_UnionShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
    var value$1 = (shape.id$1 + "Shape");
    var facetsShape$2 = $as_Lamf_plugins_domain_shapes_models_UnionShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$8, value$1));
    var counter = new $c_sr_IntRef().init___I(0);
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, shape$1, counter$1) {
      return (function(facetsMap$2) {
        var facetsMap = $as_sci_Map(facetsMap$2);
        $m_Lamf_core_parser_Annotations$();
        var annotations$2 = new $c_Lamf_core_parser_Annotations().init___();
        var this$13 = new $c_Lamf_plugins_domain_shapes_models_NodeShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$2);
        var value$2 = ((shape$1.id$1 + "Shape") + counter$1.elem$1);
        var facetsUnionShape = $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$13, value$2));
        counter$1.elem$1 = ((1 + counter$1.elem$1) | 0);
        var this$14 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(facetsMap);
        var properties$1 = this$14.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream();
        var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1;
        return $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(facetsUnionShape, field$1, properties$1))
      })
    })(this, shape, counter));
    var this$15 = $m_sc_Seq$();
    var anyOfShapes = $as_sc_Seq(facetDefinitions.map__F1__scg_CanBuildFrom__O(jsx$1, this$15.ReusableCBFInstance$2));
    var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1;
    return $as_Lamf_plugins_domain_shapes_models_UnionShape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(facetsShape$2, field$2, anyOfShapes))
  }
});
$c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector.prototype.findShapesWithFacets__sc_Seq = (function() {
  var jsx$5 = $m_sc_Seq$();
  var jsx$4 = $as_Lamf_core_vocabulary_ValueType($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().type$1.head__O()).iri__T();
  var jsx$3 = $as_Lamf_core_vocabulary_ValueType($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().type$1.head__O()).iri__T();
  var jsx$2 = $as_Lamf_core_vocabulary_ValueType($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().type$1.head__O()).iri__T();
  var jsx$1 = $as_Lamf_core_vocabulary_ValueType($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().type$1.head__O()).iri__T();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var array = [jsx$4, jsx$3, jsx$2, jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "DomainProperty").iri__T()];
  var typesWithShapes = $as_sc_Seq(jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  var this$7 = this.model$1;
  var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
  var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
  var this$8 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(this$7, strategy, fieldsFilter);
  var pf = new $c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$$anonfun$1().init___Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector__sc_Seq(this, typesWithShapes);
  var this$9 = new $c_sc_Iterator$$anon$13().init___sc_Iterator__s_PartialFunction(this$8, pf);
  var encodedShapes = $f_sc_Iterator__toStream__sci_Stream(this$9);
  var x1 = this.model$1;
  if ($is_Lamf_core_model_document_DeclaresModel(x1)) {
    var jsx$7 = $as_sc_TraversableLike($as_Lamf_core_model_document_DeclaresModel(x1).declares__sc_Seq().filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$2$2) {
        var x$2 = $as_Lamf_core_model_domain_DomainElement(x$2$2);
        return (x$2 instanceof $c_Lamf_core_model_domain_Shape)
      })
    })(this))));
    var jsx$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(x$3$2) {
        var x$3 = $as_Lamf_core_model_domain_DomainElement(x$3$2);
        return $as_Lamf_core_model_domain_Shape(x$3)
      })
    })(this));
    var this$10 = $m_sc_Seq$();
    var declaredShapes = $as_sc_Seq(jsx$7.map__F1__scg_CanBuildFrom__O(jsx$6, this$10.ReusableCBFInstance$2))
  } else {
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$13 = new $c_scm_ListBuffer().init___();
    var declaredShapes = this$13.toList__sci_List()
  };
  var this$14 = $m_sc_Seq$();
  var elements = $as_sc_Seq(encodedShapes.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(declaredShapes, this$14.ReusableCBFInstance$2));
  var jsx$10 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_domain_DomainElement(x0$1$2);
      if ((x0$1 instanceof $c_Lamf_plugins_domain_webapi_models_Payload)) {
        var x2 = $as_Lamf_plugins_domain_webapi_models_Payload(x0$1);
        var x1$2 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1)));
        if ((x1$2 instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(x1$2);
          var shape = $as_Lamf_core_model_domain_Shape(x2$2.value$2);
          return new $c_s_Some().init___O(new $c_T2().init___O__O(shape, shape.collectCustomShapePropertyDefinitions__Z__scm_Set__sc_Seq(true, $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())))))
        } else {
          return $m_s_None$()
        }
      } else if ((x0$1 instanceof $c_Lamf_plugins_domain_webapi_models_Parameter)) {
        var x3 = $as_Lamf_plugins_domain_webapi_models_Parameter(x0$1);
        var x1$3 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(x3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1)));
        if ((x1$3 instanceof $c_s_Some)) {
          var x2$3 = $as_s_Some(x1$3);
          var shape$2 = $as_Lamf_core_model_domain_Shape(x2$3.value$2);
          return new $c_s_Some().init___O(new $c_T2().init___O__O(shape$2, shape$2.collectCustomShapePropertyDefinitions__Z__scm_Set__sc_Seq(true, $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())))))
        } else {
          return $m_s_None$()
        }
      } else if ((x0$1 instanceof $c_Lamf_plugins_domain_webapi_models_Request)) {
        var x4 = $as_Lamf_plugins_domain_webapi_models_Request(x0$1);
        var x1$4 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(x4.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryString$1)));
        if ((x1$4 instanceof $c_s_Some)) {
          var x2$4 = $as_s_Some(x1$4);
          var shape$3 = $as_Lamf_core_model_domain_Shape(x2$4.value$2);
          return new $c_s_Some().init___O(new $c_T2().init___O__O(shape$3, shape$3.collectCustomShapePropertyDefinitions__Z__scm_Set__sc_Seq(true, $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())))))
        } else {
          return $m_s_None$()
        }
      } else if ((x0$1 instanceof $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme)) {
        var x5 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(x0$1);
        var x1$5 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(x5.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().QueryString$1)));
        if ((x1$5 instanceof $c_s_Some)) {
          var x2$5 = $as_s_Some(x1$5);
          var shape$4 = $as_Lamf_core_model_domain_Shape(x2$5.value$2);
          return new $c_s_Some().init___O(new $c_T2().init___O__O(shape$4, shape$4.collectCustomShapePropertyDefinitions__Z__scm_Set__sc_Seq(true, $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())))))
        } else {
          return $m_s_None$()
        }
      } else if ((x0$1 instanceof $c_Lamf_core_model_domain_extensions_CustomDomainProperty)) {
        var x6 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(x0$1);
        var x1$6 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(x6.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Schema$1)));
        if ((x1$6 instanceof $c_s_Some)) {
          var x2$6 = $as_s_Some(x1$6);
          var shape$5 = $as_Lamf_core_model_domain_Shape(x2$6.value$2);
          return new $c_s_Some().init___O(new $c_T2().init___O__O(shape$5, shape$5.collectCustomShapePropertyDefinitions__Z__scm_Set__sc_Seq(true, $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())))))
        } else {
          return $m_s_None$()
        }
      } else if ((x0$1 instanceof $c_Lamf_core_model_domain_Shape)) {
        var x7 = $as_Lamf_core_model_domain_Shape(x0$1);
        return new $c_s_Some().init___O(new $c_T2().init___O__O(x7, x7.collectCustomShapePropertyDefinitions__Z__scm_Set__sc_Seq(true, $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())))))
      } else {
        return $m_s_None$()
      }
    })
  })(this));
  var this$15 = $m_sc_Seq$();
  var jsx$9 = $as_sc_TraversableLike($as_sc_TraversableLike(elements.map__F1__scg_CanBuildFrom__O(jsx$10, this$15.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
    return (function(x0$2$2) {
      var x0$2 = $as_s_Option(x0$2$2);
      if ((x0$2 instanceof $c_s_Some)) {
        var x2$1 = $as_s_Some(x0$2);
        var p3 = $as_T2(x2$1.value$2);
        if ((p3 !== null)) {
          var shape$1 = $as_Lamf_core_model_domain_Shape(p3.$$und1__O());
          var facetDefinitions = $as_sc_Seq(p3.$$und2__O());
          if (((shape$1 !== null) && (facetDefinitions !== null))) {
            return facetDefinitions.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
              return (function(x$4$2) {
                var x$4 = $as_sci_Map(x$4$2);
                return $f_sc_TraversableOnce__nonEmpty__Z(x$4)
              })
            })(this$4$1)))
          }
        }
      };
      return false
    })
  })(this))));
  var jsx$8 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1) {
    return (function(x$5$2) {
      var x$5 = $as_s_Option(x$5$2);
      return $as_T2(x$5.get__O())
    })
  })(this));
  var this$16 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$9.map__F1__scg_CanBuildFrom__O(jsx$8, this$16.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_core_remote_Platform = (function(model, platform) {
  this.model$1 = model;
  return this
});
$c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector.prototype.toFacetsPayload__Lamf_core_model_domain_Shape__Lamf_core_model_domain_DataNode = (function(shape) {
  $m_Lamf_core_model_domain_ObjectNode$();
  var annotations = shape.annotations__Lamf_core_parser_Annotations();
  var this$3 = new $c_Lamf_core_model_domain_ObjectNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = shape.id$1;
  var payload = $as_Lamf_core_model_domain_ObjectNode($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$3, value));
  $as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().CustomShapeProperties__Lamf_core_metamodel_Field())).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, payload$1) {
    return (function(extension$2) {
      var extension = $as_Lamf_core_model_domain_extensions_ShapeExtension(extension$2);
      var this$4 = $as_Lamf_core_model_domain_extensions_PropertyShape(extension.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$().DefinedBy$1));
      var this$5 = $as_Lamf_core_model_StrField(this$4.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
      var this$6 = this$5.option$1;
      return payload$1.addProperty__T__Lamf_core_model_domain_DataNode__Lamf_core_parser_Annotations__Lamf_core_model_domain_ObjectNode($as_T((this$6.isEmpty__Z() ? null : this$6.get__O())), $as_Lamf_core_model_domain_DataNode(extension.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)), extension.annotations$1)
    })
  })(this, payload)));
  return payload
});
$c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector.prototype.collect__sc_Seq = (function() {
  var shapesWithFacets = this.findShapesWithFacets__sc_Seq();
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var shape = $as_Lamf_core_model_domain_Shape(x0$1.$$und1__O());
        var facetDefinitions = $as_sc_Seq(x0$1.$$und2__O());
        if ((shape !== null)) {
          if ((facetDefinitions !== null)) {
            var effectiveShape = (($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(shape).isDefined__Z() && $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(shape).isDefined__Z()) ? $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(shape).get__O()) : shape);
            var facetsPayload = $this.toFacetsPayload__Lamf_core_model_domain_Shape__Lamf_core_model_domain_DataNode(effectiveShape);
            var facetsShape = $this.toFacetsDefinitionShape__Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_model_domain_Shape(effectiveShape, facetDefinitions);
            var fragment = $m_Lamf_core_model_document_PayloadFragment$().apply__Lamf_core_model_domain_DataNode__T__Lamf_core_model_document_PayloadFragment(facetsPayload, "application/yaml");
            return new $c_Lamf_core_validation_ValidationCandidate().init___Lamf_core_model_domain_Shape__Lamf_core_model_document_PayloadFragment(facetsShape, fragment)
          }
        }
      };
      throw new $c_s_MatchError().init___O(x0$1)
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  return $as_sc_Seq(shapesWithFacets.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))
});
var $d_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector: 0
}, false, "amf.plugins.document.webapi.validation.ShapeFacetsCandidatesCollector", {
  Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$.prototype = $c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$.prototype;
$c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$.prototype.apply__Lamf_core_model_document_BaseUnit__Lamf_core_remote_Platform__sc_Seq = (function(model, platform) {
  return new $c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector().init___Lamf_core_model_document_BaseUnit__Lamf_core_remote_Platform(model, platform).collect__sc_Seq()
});
var $d_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$: 0
}, false, "amf.plugins.document.webapi.validation.ShapeFacetsCandidatesCollector$", {
  Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$;
var $n_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$)) {
    $n_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$ = new $c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$
}
function $f_Lamf_plugins_document_webapi_validation_WebApiValidations__validationRequestsForBaseUnit__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_validation_EffectiveValidations__Lamf_MessageStyle__Lamf_core_remote_Platform__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future($thiz, unit, profile, validations, messageStyle, platform, env, resolved, exec) {
  var baseUnit = (resolved ? unit : $m_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline$().apply__Lamf_ProfileName__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(profile, unit));
  $m_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner$();
  var validationContext = new $c_Lamf_plugins_document_webapi_validation_runner_ValidationContext().init___Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_remote_Platform__Lamf_MessageStyle__Lamf_core_validation_EffectiveValidations__Lamf_internal_environment_Environment(baseUnit, profile, platform, messageStyle, validations, env);
  return new $c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner().init___Lamf_plugins_document_webapi_validation_runner_ValidationContext__Lamf_client_execution_BaseExecutionEnvironment(validationContext, exec).runSteps__s_concurrent_Future()
}
function $f_Lamf_plugins_document_webapi_validation_WebApiValidations__$$init$__V($thiz) {
  $thiz.aggregatedReport$und$eq__sci_List__V($m_sci_Nil$());
  var this$1 = $m_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$().profiles__sci_List();
  var z = $m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$());
  var acc = z;
  var these = this$1;
  while ((!these.isEmpty__Z())) {
    var arg1 = acc;
    var arg2 = these.head__O();
    var x0$1 = $as_sci_Map(arg1);
    var x1$1 = $as_Lamf_core_validation_core_ValidationProfile(arg2);
    var this$2 = x1$1.name$1;
    acc = x0$1.updated__O__O__sci_Map(this$2.p$1, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, profile) {
      return (function() {
        return profile
      })
    })($thiz, x1$1)));
    these = $as_sc_LinearSeqOptimized(these.tail__O())
  };
  $thiz.amf$plugins$document$webapi$validation$WebApiValidations$$undsetter$und$defaultValidationProfiles$und$eq__sci_Map__V($as_sci_Map(acc))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_complexShaclCustomValidations$() {
  $c_O.call(this);
  this.xmlWrappedScalar$1 = null;
  this.xmlNonScalarAttribute$1 = null;
  this.fileParameterMustBeInFormData$1 = null;
  this.pathParameterRequiredProperty$1 = null;
  this.exampleMutuallyExclusiveFields$1 = null;
  this.minimumMaximumValidation$1 = null;
  this.minMaxItemsValidation$1 = null;
  this.minMaxLengthValidation$1 = null;
  this.minMaxPropertiesValidation$1 = null;
  this.defintions$1 = null
}
$c_Lamf_plugins_document_webapi_validation_complexShaclCustomValidations$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_complexShaclCustomValidations$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_complexShaclCustomValidations$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_complexShaclCustomValidations$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_complexShaclCustomValidations$.prototype = $c_Lamf_plugins_document_webapi_validation_complexShaclCustomValidations$.prototype;
$c_Lamf_plugins_document_webapi_validation_complexShaclCustomValidations$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_validation_complexShaclCustomValidations$ = this;
  $m_sci_List$();
  var x$3 = new $c_s_Some().init___O("XML property 'wrapped' must be false for scalar types");
  var x$4 = new $c_s_Some().init___O("XML property 'wrapped' must be false for scalar types");
  $m_sci_List$();
  var array = ["http://a.ml/vocabularies/shapes#ScalarShape"];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var x$5 = result;
  $m_sci_List$();
  var array$1 = ["http://a.ml/vocabularies/amf/parser#xml-wrapped-scalar_or_0", "http://a.ml/vocabularies/amf/parser#xml-wrapped-scalar_or_1"];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$8 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$8);
    i$1 = (((-1) + i$1) | 0)
  };
  var x$6 = result$1;
  var x$7 = new $c_s_Some().init___O("xmlWrappedScalar");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$12 = new $c_scm_ListBuffer().init___();
  var x$8 = this$12.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$16 = new $c_scm_ListBuffer().init___();
  var x$9 = this$16.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$20 = new $c_scm_ListBuffer().init___();
  var x$10 = this$20.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$24 = new $c_scm_ListBuffer().init___();
  var x$11 = this$24.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$12 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$29 = new $c_scm_ListBuffer().init___();
  var x$13 = this$29.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$33 = new $c_scm_ListBuffer().init___();
  var x$14 = this$33.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$15 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$16 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$17 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$18 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$19 = $m_s_None$();
  var jsx$9 = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#xml-wrapped-scalar", "XML property 'wrapped' must be false for scalar types", x$3, x$4, x$8, x$5, x$9, x$6, x$10, x$11, x$12, x$13, x$14, x$15, x$16, x$17, x$18, x$7, x$19);
  $m_scm_ArrayBuffer$();
  var x$22 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#xml-wrapped-scalar_or_0_raml-shapes.xmlSerialization_node");
  var x$23 = $m_s_None$();
  var x$24 = $m_s_None$();
  var x$25 = $m_s_None$();
  var x$26 = $m_s_None$();
  var x$27 = $m_s_None$();
  var x$28 = $m_s_None$();
  var x$29 = $m_s_None$();
  var x$30 = $m_s_None$();
  var x$31 = $m_s_None$();
  var x$32 = $m_s_None$();
  var x$33 = $m_s_None$();
  var x$34 = $m_s_None$();
  var x$35 = $m_s_None$();
  var x$36 = $m_s_None$();
  var x$37 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$57 = new $c_scm_ListBuffer().init___();
  var x$38 = this$57.toList__sci_List();
  var x$39 = $m_s_None$();
  var x$40 = $m_s_None$();
  var x$41 = $m_s_None$();
  var x$42 = $m_s_None$();
  var x$43 = $m_s_None$();
  var x$44 = $m_s_None$();
  var x$45 = $m_s_None$();
  var x$46 = $m_s_None$();
  var x$47 = $m_s_None$();
  var array$2 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("raml-shapes.xmlSerialization", "raml-shapes.xmlSerialization", x$23, x$24, x$25, x$26, x$27, x$28, x$29, x$30, x$31, x$32, x$33, x$34, x$35, x$22, x$36, x$37, x$38, x$39, x$40, x$41, x$42, x$43, x$44, x$45, x$46, x$47)];
  if (($uI(array$2.length) === 0)) {
    var this$70 = new $c_scm_ArrayBuffer().init___();
    var x$50 = this$70
  } else {
    var b = new $c_scm_ArrayBuffer().init___();
    var n = $uI(array$2.length);
    var n$1 = ((b.size0$6 + n) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b, n$1);
    var xs = b.array$6;
    var start = b.size0$6;
    var i$2 = 0;
    var j = start;
    var x$2 = $uI(array$2.length);
    var x$20 = ((x$2 < n) ? x$2 : n);
    var that = ((xs.u.length - start) | 0);
    var end = ((x$20 < that) ? x$20 : that);
    while ((i$2 < end)) {
      var jsx$7 = j;
      var index$2 = i$2;
      xs.set(jsx$7, array$2[index$2]);
      i$2 = ((1 + i$2) | 0);
      j = ((1 + j) | 0)
    };
    b.size0$6 = ((b.size0$6 + n) | 0);
    var x$50 = b
  };
  var x$51 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#xml-wrapped-scalar");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$52 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$53 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$84 = new $c_scm_ListBuffer().init___();
  var x$54 = this$84.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$88 = new $c_scm_ListBuffer().init___();
  var x$55 = this$88.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$92 = new $c_scm_ListBuffer().init___();
  var x$56 = this$92.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$96 = new $c_scm_ListBuffer().init___();
  var x$57 = this$96.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$100 = new $c_scm_ListBuffer().init___();
  var x$58 = this$100.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$104 = new $c_scm_ListBuffer().init___();
  var x$59 = this$104.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$60 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$109 = new $c_scm_ListBuffer().init___();
  var x$61 = this$109.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$62 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$63 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$64 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$65 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$66 = $m_s_None$();
  var jsx$8 = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#xml-wrapped-scalar_or_0", "XML property 'wrapped' must be false for scalar types", x$52, x$53, x$54, x$55, x$56, x$57, x$58, x$59, x$60, x$50, x$61, x$62, x$63, x$64, x$51, x$65, x$66);
  $m_scm_ArrayBuffer$();
  var x$69 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#xml-wrapped-scalar_or_1_raml-shapes.xmlSerialization_node");
  var x$70 = $m_s_None$();
  var x$71 = $m_s_None$();
  var x$72 = $m_s_None$();
  var x$73 = $m_s_None$();
  var x$74 = $m_s_None$();
  var x$75 = $m_s_None$();
  var x$76 = $m_s_None$();
  var x$77 = $m_s_None$();
  var x$78 = $m_s_None$();
  var x$79 = $m_s_None$();
  var x$80 = $m_s_None$();
  var x$81 = $m_s_None$();
  var x$82 = $m_s_None$();
  var x$83 = $m_s_None$();
  var x$84 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$133 = new $c_scm_ListBuffer().init___();
  var x$85 = this$133.toList__sci_List();
  var x$86 = $m_s_None$();
  var x$87 = $m_s_None$();
  var x$88 = $m_s_None$();
  var x$89 = $m_s_None$();
  var x$90 = $m_s_None$();
  var x$91 = $m_s_None$();
  var x$92 = $m_s_None$();
  var x$93 = $m_s_None$();
  var x$94 = $m_s_None$();
  var array$3 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("raml-shapes.xmlSerialization", "raml-shapes.xmlSerialization", x$70, x$71, x$72, x$73, x$74, x$75, x$76, x$77, x$78, x$79, x$80, x$81, x$82, x$69, x$83, x$84, x$85, x$86, x$87, x$88, x$89, x$90, x$91, x$92, x$93, x$94)];
  if (($uI(array$3.length) === 0)) {
    var this$146 = new $c_scm_ArrayBuffer().init___();
    var x$97 = this$146
  } else {
    var b$1 = new $c_scm_ArrayBuffer().init___();
    var n$2 = $uI(array$3.length);
    var n$3 = ((b$1.size0$6 + n$2) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$1, n$3);
    var xs$1 = b$1.array$6;
    var start$1 = b$1.size0$6;
    var i$3 = 0;
    var j$1 = start$1;
    var x$21 = $uI(array$3.length);
    var x$48 = ((x$21 < n$2) ? x$21 : n$2);
    var that$1 = ((xs$1.u.length - start$1) | 0);
    var end$1 = ((x$48 < that$1) ? x$48 : that$1);
    while ((i$3 < end$1)) {
      var jsx$5 = j$1;
      var index$3 = i$3;
      xs$1.set(jsx$5, array$3[index$3]);
      i$3 = ((1 + i$3) | 0);
      j$1 = ((1 + j$1) | 0)
    };
    b$1.size0$6 = ((b$1.size0$6 + n$2) | 0);
    var x$97 = b$1
  };
  var x$98 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#xml-wrapped-scalar");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$99 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$100 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$160 = new $c_scm_ListBuffer().init___();
  var x$101 = this$160.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$164 = new $c_scm_ListBuffer().init___();
  var x$102 = this$164.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$168 = new $c_scm_ListBuffer().init___();
  var x$103 = this$168.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$172 = new $c_scm_ListBuffer().init___();
  var x$104 = this$172.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$176 = new $c_scm_ListBuffer().init___();
  var x$105 = this$176.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$180 = new $c_scm_ListBuffer().init___();
  var x$106 = this$180.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$107 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$185 = new $c_scm_ListBuffer().init___();
  var x$108 = this$185.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$109 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$110 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$111 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$112 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$113 = $m_s_None$();
  var jsx$6 = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#xml-wrapped-scalar_or_1", "XML property 'wrapped' must be false for scalar types", x$99, x$100, x$101, x$102, x$103, x$104, x$105, x$106, x$107, x$97, x$108, x$109, x$110, x$111, x$98, x$112, x$113);
  $m_scm_ArrayBuffer$();
  $m_scm_ArrayBuffer$();
  var array$4 = ["false"];
  if (($uI(array$4.length) === 0)) {
    var this$194 = new $c_scm_ArrayBuffer().init___();
    var x$116 = this$194
  } else {
    var b$2 = new $c_scm_ArrayBuffer().init___();
    var n$4 = $uI(array$4.length);
    var n$5 = ((b$2.size0$6 + n$4) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$2, n$5);
    var xs$2 = b$2.array$6;
    var start$2 = b$2.size0$6;
    var i$4 = 0;
    var j$2 = start$2;
    var x$49 = $uI(array$4.length);
    var x$67 = ((x$49 < n$4) ? x$49 : n$4);
    var that$2 = ((xs$2.u.length - start$2) | 0);
    var end$2 = ((x$67 < that$2) ? x$67 : that$2);
    while ((i$4 < end$2)) {
      var jsx$2 = j$2;
      var index$4 = i$4;
      xs$2.set(jsx$2, array$4[index$4]);
      i$4 = ((1 + i$4) | 0);
      j$2 = ((1 + j$2) | 0)
    };
    b$2.size0$6 = ((b$2.size0$6 + n$4) | 0);
    var x$116 = b$2
  };
  var x$117 = $m_s_None$();
  var x$118 = $m_s_None$();
  var x$119 = $m_s_None$();
  var x$120 = $m_s_None$();
  var x$121 = $m_s_None$();
  var x$122 = $m_s_None$();
  var x$123 = $m_s_None$();
  var x$124 = $m_s_None$();
  var x$125 = $m_s_None$();
  var x$126 = $m_s_None$();
  var x$127 = $m_s_None$();
  var x$128 = $m_s_None$();
  var x$129 = $m_s_None$();
  var x$130 = $m_s_None$();
  var x$131 = $m_s_None$();
  var x$132 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var x$133 = $m_s_None$();
  var x$134 = $m_s_None$();
  var x$135 = $m_s_None$();
  var x$136 = $m_s_None$();
  var x$137 = $m_s_None$();
  var x$138 = $m_s_None$();
  var x$139 = $m_s_None$();
  var x$140 = $m_s_None$();
  var x$141 = $m_s_None$();
  var array$5 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("raml-shapes.xmlWrapped", "raml-shapes.xmlWrapped", x$117, x$118, x$119, x$120, x$121, x$122, x$123, x$124, x$125, x$126, x$127, x$128, x$129, x$130, x$131, x$132, x$116, x$133, x$134, x$135, x$136, x$137, x$138, x$139, x$140, x$141)];
  if (($uI(array$5.length) === 0)) {
    var this$231 = new $c_scm_ArrayBuffer().init___();
    var x$144 = this$231
  } else {
    var b$3 = new $c_scm_ArrayBuffer().init___();
    var n$6 = $uI(array$5.length);
    var n$7 = ((b$3.size0$6 + n$6) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$3, n$7);
    var xs$3 = b$3.array$6;
    var start$3 = b$3.size0$6;
    var i$5 = 0;
    var j$3 = start$3;
    var x$68 = $uI(array$5.length);
    var x$95 = ((x$68 < n$6) ? x$68 : n$6);
    var that$3 = ((xs$3.u.length - start$3) | 0);
    var end$3 = ((x$95 < that$3) ? x$95 : that$3);
    while ((i$5 < end$3)) {
      var jsx$3 = j$3;
      var index$5 = i$5;
      xs$3.set(jsx$3, array$5[index$5]);
      i$5 = ((1 + i$5) | 0);
      j$3 = ((1 + j$3) | 0)
    };
    b$3.size0$6 = ((b$3.size0$6 + n$6) | 0);
    var x$144 = b$3
  };
  var x$145 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#xml-wrapped-scalar");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$146 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$147 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$245 = new $c_scm_ListBuffer().init___();
  var x$148 = this$245.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$249 = new $c_scm_ListBuffer().init___();
  var x$149 = this$249.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$253 = new $c_scm_ListBuffer().init___();
  var x$150 = this$253.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$257 = new $c_scm_ListBuffer().init___();
  var x$151 = this$257.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$261 = new $c_scm_ListBuffer().init___();
  var x$152 = this$261.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$265 = new $c_scm_ListBuffer().init___();
  var x$153 = this$265.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$154 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$270 = new $c_scm_ListBuffer().init___();
  var x$155 = this$270.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$156 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$157 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$158 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$159 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$160 = $m_s_None$();
  var jsx$4 = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#xml-wrapped-scalar_or_0_raml-shapes.xmlSerialization_node", "XML property 'wrapped' must be false for scalar types", x$146, x$147, x$148, x$149, x$150, x$151, x$152, x$153, x$154, x$144, x$155, x$156, x$157, x$158, x$145, x$159, x$160);
  $m_scm_ArrayBuffer$();
  var x$163 = new $c_s_Some().init___O("0");
  var x$164 = $m_s_None$();
  var x$165 = $m_s_None$();
  var x$166 = $m_s_None$();
  var x$167 = $m_s_None$();
  var x$168 = $m_s_None$();
  var x$169 = $m_s_None$();
  var x$170 = $m_s_None$();
  var x$171 = $m_s_None$();
  var x$172 = $m_s_None$();
  var x$173 = $m_s_None$();
  var x$174 = $m_s_None$();
  var x$175 = $m_s_None$();
  var x$176 = $m_s_None$();
  var x$177 = $m_s_None$();
  var x$178 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$294 = new $c_scm_ListBuffer().init___();
  var x$179 = this$294.toList__sci_List();
  var x$180 = $m_s_None$();
  var x$181 = $m_s_None$();
  var x$182 = $m_s_None$();
  var x$183 = $m_s_None$();
  var x$184 = $m_s_None$();
  var x$185 = $m_s_None$();
  var x$186 = $m_s_None$();
  var x$187 = $m_s_None$();
  var x$188 = $m_s_None$();
  var array$6 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("raml-shapes.xmlWrapped", "raml-shapes.xmlWrapped", x$164, x$165, x$166, x$167, x$163, x$168, x$169, x$170, x$171, x$172, x$173, x$174, x$175, x$176, x$177, x$178, x$179, x$180, x$181, x$182, x$183, x$184, x$185, x$186, x$187, x$188)];
  if (($uI(array$6.length) === 0)) {
    var this$307 = new $c_scm_ArrayBuffer().init___();
    var x$191 = this$307
  } else {
    var b$4 = new $c_scm_ArrayBuffer().init___();
    var n$8 = $uI(array$6.length);
    var n$9 = ((b$4.size0$6 + n$8) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$4, n$9);
    var xs$4 = b$4.array$6;
    var start$4 = b$4.size0$6;
    var i$6 = 0;
    var j$4 = start$4;
    var x$96 = $uI(array$6.length);
    var x$114 = ((x$96 < n$8) ? x$96 : n$8);
    var that$4 = ((xs$4.u.length - start$4) | 0);
    var end$4 = ((x$114 < that$4) ? x$114 : that$4);
    while ((i$6 < end$4)) {
      var jsx$1 = j$4;
      var index$6 = i$6;
      xs$4.set(jsx$1, array$6[index$6]);
      i$6 = ((1 + i$6) | 0);
      j$4 = ((1 + j$4) | 0)
    };
    b$4.size0$6 = ((b$4.size0$6 + n$8) | 0);
    var x$191 = b$4
  };
  var x$192 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#xml-wrapped-scalar");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$193 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$194 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$321 = new $c_scm_ListBuffer().init___();
  var x$195 = this$321.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$325 = new $c_scm_ListBuffer().init___();
  var x$196 = this$325.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$329 = new $c_scm_ListBuffer().init___();
  var x$197 = this$329.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$333 = new $c_scm_ListBuffer().init___();
  var x$198 = this$333.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$337 = new $c_scm_ListBuffer().init___();
  var x$199 = this$337.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$341 = new $c_scm_ListBuffer().init___();
  var x$200 = this$341.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$201 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$346 = new $c_scm_ListBuffer().init___();
  var x$202 = this$346.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$203 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$204 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$205 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$206 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$207 = $m_s_None$();
  var array$7 = [jsx$9, jsx$8, jsx$6, jsx$4, new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#xml-wrapped-scalar_or_1_raml-shapes.xmlSerialization_node", "XML property 'wrapped' must be false for scalar types", x$193, x$194, x$195, x$196, x$197, x$198, x$199, x$200, x$201, x$191, x$202, x$203, x$204, x$205, x$192, x$206, x$207)];
  var i$7 = (((-1) + $uI(array$7.length)) | 0);
  var result$2 = $m_sci_Nil$();
  while ((i$7 >= 0)) {
    var this$355 = result$2;
    var index$7 = i$7;
    var x$115 = array$7[index$7];
    result$2 = new $c_sci_$colon$colon().init___O__sci_List(x$115, this$355);
    i$7 = (((-1) + i$7) | 0)
  };
  this.xmlWrappedScalar$1 = result$2;
  $m_sci_List$();
  var x$210 = new $c_s_Some().init___O("XML property 'attribute' must be false for non-scalar types");
  var x$211 = new $c_s_Some().init___O("XML property 'attribute' must be false for non-scalar types");
  $m_sci_List$();
  var array$8 = ["http://www.w3.org/ns/shacl#Shape"];
  var i$8 = (((-1) + $uI(array$8.length)) | 0);
  var result$3 = $m_sci_Nil$();
  while ((i$8 >= 0)) {
    var this$359 = result$3;
    var index$8 = i$8;
    var x$142 = array$8[index$8];
    result$3 = new $c_sci_$colon$colon().init___O__sci_List(x$142, this$359);
    i$8 = (((-1) + i$8) | 0)
  };
  var x$212 = result$3;
  $m_sci_List$();
  var array$9 = ["http://a.ml/vocabularies/amf/parser#xml-non-scalar-attribute_or_0", "http://a.ml/vocabularies/amf/parser#xml-non-scalar-attribute_or_1", "http://a.ml/vocabularies/amf/parser#xml-non-scalar-attribute_or_2"];
  var i$9 = (((-1) + $uI(array$9.length)) | 0);
  var result$4 = $m_sci_Nil$();
  while ((i$9 >= 0)) {
    var this$363 = result$4;
    var index$9 = i$9;
    var x$143 = array$9[index$9];
    result$4 = new $c_sci_$colon$colon().init___O__sci_List(x$143, this$363);
    i$9 = (((-1) + i$9) | 0)
  };
  var x$213 = result$4;
  var x$214 = new $c_s_Some().init___O("xmlNonScalarAttribute");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$367 = new $c_scm_ListBuffer().init___();
  var x$215 = this$367.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$371 = new $c_scm_ListBuffer().init___();
  var x$216 = this$371.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$375 = new $c_scm_ListBuffer().init___();
  var x$217 = this$375.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$379 = new $c_scm_ListBuffer().init___();
  var x$218 = this$379.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$219 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$384 = new $c_scm_ListBuffer().init___();
  var x$220 = this$384.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$388 = new $c_scm_ListBuffer().init___();
  var x$221 = this$388.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$222 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$223 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$224 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$225 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$226 = $m_s_None$();
  var jsx$20 = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#xml-non-scalar-attribute", "XML property 'attribute' must be false for non-scalar types", x$210, x$211, x$215, x$212, x$216, x$213, x$217, x$218, x$219, x$220, x$221, x$222, x$223, x$224, x$225, x$214, x$226);
  var x$257 = new $c_s_Some().init___O("XML property 'attribute' must be false for non-scalar types");
  var x$258 = new $c_s_Some().init___O("XML property 'attribute' must be false for non-scalar types");
  var x$259 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#xml-non-scalar-attribute");
  $m_scm_ArrayBuffer$();
  var x$229 = new $c_s_Some().init___O("http://a.ml/vocabularies/shapes#ScalarShape");
  var x$230 = $m_s_None$();
  var x$231 = $m_s_None$();
  var x$232 = $m_s_None$();
  var x$233 = $m_s_None$();
  var x$234 = $m_s_None$();
  var x$235 = $m_s_None$();
  var x$236 = $m_s_None$();
  var x$237 = $m_s_None$();
  var x$238 = $m_s_None$();
  var x$239 = $m_s_None$();
  var x$240 = $m_s_None$();
  var x$241 = $m_s_None$();
  var x$242 = $m_s_None$();
  var x$243 = $m_s_None$();
  var x$244 = $m_s_None$();
  var x$245 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$413 = new $c_scm_ListBuffer().init___();
  var x$246 = this$413.toList__sci_List();
  var x$247 = $m_s_None$();
  var x$248 = $m_s_None$();
  var x$249 = $m_s_None$();
  var x$250 = $m_s_None$();
  var x$251 = $m_s_None$();
  var x$252 = $m_s_None$();
  var x$253 = $m_s_None$();
  var x$254 = $m_s_None$();
  var array$10 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("rdf.type", "rdf.type", x$230, x$231, x$232, x$233, x$234, x$235, x$236, x$237, x$238, x$239, x$240, x$241, x$242, x$243, x$244, x$245, x$246, x$247, x$248, x$249, x$250, x$229, x$251, x$252, x$253, x$254)];
  if (($uI(array$10.length) === 0)) {
    var this$425 = new $c_scm_ArrayBuffer().init___();
    var x$260 = this$425
  } else {
    var b$5 = new $c_scm_ArrayBuffer().init___();
    var n$10 = $uI(array$10.length);
    var n$11 = ((b$5.size0$6 + n$10) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$5, n$11);
    var xs$5 = b$5.array$6;
    var start$5 = b$5.size0$6;
    var i$10 = 0;
    var j$5 = start$5;
    var x$161 = $uI(array$10.length);
    var x$162 = ((x$161 < n$10) ? x$161 : n$10);
    var that$5 = ((xs$5.u.length - start$5) | 0);
    var end$5 = ((x$162 < that$5) ? x$162 : that$5);
    while ((i$10 < end$5)) {
      var jsx$18 = j$5;
      var index$10 = i$10;
      xs$5.set(jsx$18, array$10[index$10]);
      i$10 = ((1 + i$10) | 0);
      j$5 = ((1 + j$5) | 0)
    };
    b$5.size0$6 = ((b$5.size0$6 + n$10) | 0);
    var x$260 = b$5
  };
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$437 = new $c_scm_ListBuffer().init___();
  var x$261 = this$437.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$441 = new $c_scm_ListBuffer().init___();
  var x$262 = this$441.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$445 = new $c_scm_ListBuffer().init___();
  var x$263 = this$445.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$449 = new $c_scm_ListBuffer().init___();
  var x$264 = this$449.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$453 = new $c_scm_ListBuffer().init___();
  var x$265 = this$453.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$457 = new $c_scm_ListBuffer().init___();
  var x$266 = this$457.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$267 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$462 = new $c_scm_ListBuffer().init___();
  var x$268 = this$462.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$269 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$270 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$271 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$272 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$273 = $m_s_None$();
  var jsx$19 = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#xml-non-scalar-attribute_or_0", "XML property 'attribute' must be false for non-scalar types", x$257, x$258, x$261, x$262, x$263, x$264, x$265, x$266, x$267, x$260, x$268, x$269, x$270, x$271, x$259, x$272, x$273);
  var x$304 = new $c_s_Some().init___O("XML property 'attribute' must be false for non-scalar types");
  var x$305 = new $c_s_Some().init___O("XML property 'attribute' must be false for non-scalar types");
  $m_scm_ArrayBuffer$();
  var x$276 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#xml-non-scalar-attribute_or_1_raml-shapes.xmlSerialization_node");
  var x$277 = $m_s_None$();
  var x$278 = $m_s_None$();
  var x$279 = $m_s_None$();
  var x$280 = $m_s_None$();
  var x$281 = $m_s_None$();
  var x$282 = $m_s_None$();
  var x$283 = $m_s_None$();
  var x$284 = $m_s_None$();
  var x$285 = $m_s_None$();
  var x$286 = $m_s_None$();
  var x$287 = $m_s_None$();
  var x$288 = $m_s_None$();
  var x$289 = $m_s_None$();
  var x$290 = $m_s_None$();
  var x$291 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$486 = new $c_scm_ListBuffer().init___();
  var x$292 = this$486.toList__sci_List();
  var x$293 = $m_s_None$();
  var x$294 = $m_s_None$();
  var x$295 = $m_s_None$();
  var x$296 = $m_s_None$();
  var x$297 = $m_s_None$();
  var x$298 = $m_s_None$();
  var x$299 = $m_s_None$();
  var x$300 = $m_s_None$();
  var x$301 = $m_s_None$();
  var array$11 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("raml-shapes.xmlSerialization", "raml-shapes.xmlSerialization", x$277, x$278, x$279, x$280, x$281, x$282, x$283, x$284, x$285, x$286, x$287, x$288, x$289, x$276, x$290, x$291, x$292, x$293, x$294, x$295, x$296, x$297, x$298, x$299, x$300, x$301)];
  if (($uI(array$11.length) === 0)) {
    var this$499 = new $c_scm_ArrayBuffer().init___();
    var x$306 = this$499
  } else {
    var b$6 = new $c_scm_ArrayBuffer().init___();
    var n$12 = $uI(array$11.length);
    var n$13 = ((b$6.size0$6 + n$12) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$6, n$13);
    var xs$6 = b$6.array$6;
    var start$6 = b$6.size0$6;
    var i$11 = 0;
    var j$6 = start$6;
    var x$189 = $uI(array$11.length);
    var x$190 = ((x$189 < n$12) ? x$189 : n$12);
    var that$6 = ((xs$6.u.length - start$6) | 0);
    var end$6 = ((x$190 < that$6) ? x$190 : that$6);
    while ((i$11 < end$6)) {
      var jsx$16 = j$6;
      var index$11 = i$11;
      xs$6.set(jsx$16, array$11[index$11]);
      i$11 = ((1 + i$11) | 0);
      j$6 = ((1 + j$6) | 0)
    };
    b$6.size0$6 = ((b$6.size0$6 + n$12) | 0);
    var x$306 = b$6
  };
  var x$307 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#xml-non-scalar-attribute");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$511 = new $c_scm_ListBuffer().init___();
  var x$308 = this$511.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$515 = new $c_scm_ListBuffer().init___();
  var x$309 = this$515.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$519 = new $c_scm_ListBuffer().init___();
  var x$310 = this$519.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$523 = new $c_scm_ListBuffer().init___();
  var x$311 = this$523.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$527 = new $c_scm_ListBuffer().init___();
  var x$312 = this$527.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$531 = new $c_scm_ListBuffer().init___();
  var x$313 = this$531.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$314 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$536 = new $c_scm_ListBuffer().init___();
  var x$315 = this$536.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$316 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$317 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$318 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$319 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$320 = $m_s_None$();
  var jsx$17 = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#xml-non-scalar-attribute_or_1", "XML property 'attribute' must be false for non-scalar types", x$304, x$305, x$308, x$309, x$310, x$311, x$312, x$313, x$314, x$306, x$315, x$316, x$317, x$318, x$307, x$319, x$320);
  var x$351 = new $c_s_Some().init___O("XML property 'attribute' must be false for non-scalar types");
  var x$352 = new $c_s_Some().init___O("XML property 'attribute' must be false for non-scalar types");
  $m_scm_ArrayBuffer$();
  var x$323 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#xml-non-scalar-attribute_or_2_raml-shapes.xmlSerialization_node");
  var x$324 = $m_s_None$();
  var x$325 = $m_s_None$();
  var x$326 = $m_s_None$();
  var x$327 = $m_s_None$();
  var x$328 = $m_s_None$();
  var x$329 = $m_s_None$();
  var x$330 = $m_s_None$();
  var x$331 = $m_s_None$();
  var x$332 = $m_s_None$();
  var x$333 = $m_s_None$();
  var x$334 = $m_s_None$();
  var x$335 = $m_s_None$();
  var x$336 = $m_s_None$();
  var x$337 = $m_s_None$();
  var x$338 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$560 = new $c_scm_ListBuffer().init___();
  var x$339 = this$560.toList__sci_List();
  var x$340 = $m_s_None$();
  var x$341 = $m_s_None$();
  var x$342 = $m_s_None$();
  var x$343 = $m_s_None$();
  var x$344 = $m_s_None$();
  var x$345 = $m_s_None$();
  var x$346 = $m_s_None$();
  var x$347 = $m_s_None$();
  var x$348 = $m_s_None$();
  var array$12 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("raml-shapes.xmlSerialization", "raml-shapes.xmlSerialization", x$324, x$325, x$326, x$327, x$328, x$329, x$330, x$331, x$332, x$333, x$334, x$335, x$336, x$323, x$337, x$338, x$339, x$340, x$341, x$342, x$343, x$344, x$345, x$346, x$347, x$348)];
  if (($uI(array$12.length) === 0)) {
    var this$573 = new $c_scm_ArrayBuffer().init___();
    var x$353 = this$573
  } else {
    var b$7 = new $c_scm_ArrayBuffer().init___();
    var n$14 = $uI(array$12.length);
    var n$15 = ((b$7.size0$6 + n$14) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$7, n$15);
    var xs$7 = b$7.array$6;
    var start$7 = b$7.size0$6;
    var i$12 = 0;
    var j$7 = start$7;
    var x$208 = $uI(array$12.length);
    var x$209 = ((x$208 < n$14) ? x$208 : n$14);
    var that$7 = ((xs$7.u.length - start$7) | 0);
    var end$7 = ((x$209 < that$7) ? x$209 : that$7);
    while ((i$12 < end$7)) {
      var jsx$14 = j$7;
      var index$12 = i$12;
      xs$7.set(jsx$14, array$12[index$12]);
      i$12 = ((1 + i$12) | 0);
      j$7 = ((1 + j$7) | 0)
    };
    b$7.size0$6 = ((b$7.size0$6 + n$14) | 0);
    var x$353 = b$7
  };
  var x$354 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#xml-non-scalar-attribute");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$585 = new $c_scm_ListBuffer().init___();
  var x$355 = this$585.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$589 = new $c_scm_ListBuffer().init___();
  var x$356 = this$589.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$593 = new $c_scm_ListBuffer().init___();
  var x$357 = this$593.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$597 = new $c_scm_ListBuffer().init___();
  var x$358 = this$597.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$601 = new $c_scm_ListBuffer().init___();
  var x$359 = this$601.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$605 = new $c_scm_ListBuffer().init___();
  var x$360 = this$605.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$361 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$610 = new $c_scm_ListBuffer().init___();
  var x$362 = this$610.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$363 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$364 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$365 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$366 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$367 = $m_s_None$();
  var jsx$15 = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#xml-non-scalar-attribute_or_2", "XML property 'attribute' must be false for non-scalar types", x$351, x$352, x$355, x$356, x$357, x$358, x$359, x$360, x$361, x$353, x$362, x$363, x$364, x$365, x$354, x$366, x$367);
  var x$398 = new $c_s_Some().init___O("XML property 'attribute' must be false for non-scalar types");
  var x$399 = new $c_s_Some().init___O("XML property 'attribute' must be false for non-scalar types");
  $m_scm_ArrayBuffer$();
  var x$370 = new $c_s_Some().init___O("0");
  var x$371 = $m_s_None$();
  var x$372 = $m_s_None$();
  var x$373 = $m_s_None$();
  var x$374 = $m_s_None$();
  var x$375 = $m_s_None$();
  var x$376 = $m_s_None$();
  var x$377 = $m_s_None$();
  var x$378 = $m_s_None$();
  var x$379 = $m_s_None$();
  var x$380 = $m_s_None$();
  var x$381 = $m_s_None$();
  var x$382 = $m_s_None$();
  var x$383 = $m_s_None$();
  var x$384 = $m_s_None$();
  var x$385 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$634 = new $c_scm_ListBuffer().init___();
  var x$386 = this$634.toList__sci_List();
  var x$387 = $m_s_None$();
  var x$388 = $m_s_None$();
  var x$389 = $m_s_None$();
  var x$390 = $m_s_None$();
  var x$391 = $m_s_None$();
  var x$392 = $m_s_None$();
  var x$393 = $m_s_None$();
  var x$394 = $m_s_None$();
  var x$395 = $m_s_None$();
  var array$13 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("raml-shapes.xmlAttribute", "raml-shapes.xmlAttribute", x$371, x$372, x$373, x$374, x$370, x$375, x$376, x$377, x$378, x$379, x$380, x$381, x$382, x$383, x$384, x$385, x$386, x$387, x$388, x$389, x$390, x$391, x$392, x$393, x$394, x$395)];
  if (($uI(array$13.length) === 0)) {
    var this$647 = new $c_scm_ArrayBuffer().init___();
    var x$400 = this$647
  } else {
    var b$8 = new $c_scm_ArrayBuffer().init___();
    var n$16 = $uI(array$13.length);
    var n$17 = ((b$8.size0$6 + n$16) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$8, n$17);
    var xs$8 = b$8.array$6;
    var start$8 = b$8.size0$6;
    var i$13 = 0;
    var j$8 = start$8;
    var x$227 = $uI(array$13.length);
    var x$228 = ((x$227 < n$16) ? x$227 : n$16);
    var that$8 = ((xs$8.u.length - start$8) | 0);
    var end$8 = ((x$228 < that$8) ? x$228 : that$8);
    while ((i$13 < end$8)) {
      var jsx$12 = j$8;
      var index$13 = i$13;
      xs$8.set(jsx$12, array$13[index$13]);
      i$13 = ((1 + i$13) | 0);
      j$8 = ((1 + j$8) | 0)
    };
    b$8.size0$6 = ((b$8.size0$6 + n$16) | 0);
    var x$400 = b$8
  };
  var x$401 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#xml-non-scalar-attribute");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$659 = new $c_scm_ListBuffer().init___();
  var x$402 = this$659.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$663 = new $c_scm_ListBuffer().init___();
  var x$403 = this$663.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$667 = new $c_scm_ListBuffer().init___();
  var x$404 = this$667.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$671 = new $c_scm_ListBuffer().init___();
  var x$405 = this$671.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$675 = new $c_scm_ListBuffer().init___();
  var x$406 = this$675.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$679 = new $c_scm_ListBuffer().init___();
  var x$407 = this$679.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$408 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$684 = new $c_scm_ListBuffer().init___();
  var x$409 = this$684.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$410 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$411 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$412 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$413 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$414 = $m_s_None$();
  var jsx$13 = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#xml-non-scalar-attribute_or_1_raml-shapes.xmlSerialization_node", "XML property 'attribute' must be false for non-scalar types", x$398, x$399, x$402, x$403, x$404, x$405, x$406, x$407, x$408, x$400, x$409, x$410, x$411, x$412, x$401, x$413, x$414);
  var x$445 = new $c_s_Some().init___O("XML property 'attribute' must be false for non-scalar types");
  var x$446 = new $c_s_Some().init___O("XML property 'attribute' must be false for non-scalar types");
  $m_scm_ArrayBuffer$();
  $m_scm_ArrayBuffer$();
  var array$14 = ["false"];
  if (($uI(array$14.length) === 0)) {
    var this$693 = new $c_scm_ArrayBuffer().init___();
    var x$417 = this$693
  } else {
    var b$9 = new $c_scm_ArrayBuffer().init___();
    var n$18 = $uI(array$14.length);
    var n$19 = ((b$9.size0$6 + n$18) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$9, n$19);
    var xs$9 = b$9.array$6;
    var start$9 = b$9.size0$6;
    var i$14 = 0;
    var j$9 = start$9;
    var x$255 = $uI(array$14.length);
    var x$256 = ((x$255 < n$18) ? x$255 : n$18);
    var that$9 = ((xs$9.u.length - start$9) | 0);
    var end$9 = ((x$256 < that$9) ? x$256 : that$9);
    while ((i$14 < end$9)) {
      var jsx$10 = j$9;
      var index$14 = i$14;
      xs$9.set(jsx$10, array$14[index$14]);
      i$14 = ((1 + i$14) | 0);
      j$9 = ((1 + j$9) | 0)
    };
    b$9.size0$6 = ((b$9.size0$6 + n$18) | 0);
    var x$417 = b$9
  };
  var x$418 = $m_s_None$();
  var x$419 = $m_s_None$();
  var x$420 = $m_s_None$();
  var x$421 = $m_s_None$();
  var x$422 = $m_s_None$();
  var x$423 = $m_s_None$();
  var x$424 = $m_s_None$();
  var x$425 = $m_s_None$();
  var x$426 = $m_s_None$();
  var x$427 = $m_s_None$();
  var x$428 = $m_s_None$();
  var x$429 = $m_s_None$();
  var x$430 = $m_s_None$();
  var x$431 = $m_s_None$();
  var x$432 = $m_s_None$();
  var x$433 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var x$434 = $m_s_None$();
  var x$435 = $m_s_None$();
  var x$436 = $m_s_None$();
  var x$437 = $m_s_None$();
  var x$438 = $m_s_None$();
  var x$439 = $m_s_None$();
  var x$440 = $m_s_None$();
  var x$441 = $m_s_None$();
  var x$442 = $m_s_None$();
  var array$15 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("raml-shapes.xmlAttribute", "raml-shapes.xmlAttribute", x$418, x$419, x$420, x$421, x$422, x$423, x$424, x$425, x$426, x$427, x$428, x$429, x$430, x$431, x$432, x$433, x$417, x$434, x$435, x$436, x$437, x$438, x$439, x$440, x$441, x$442)];
  if (($uI(array$15.length) === 0)) {
    var this$730 = new $c_scm_ArrayBuffer().init___();
    var x$447 = this$730
  } else {
    var b$10 = new $c_scm_ArrayBuffer().init___();
    var n$20 = $uI(array$15.length);
    var n$21 = ((b$10.size0$6 + n$20) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$10, n$21);
    var xs$10 = b$10.array$6;
    var start$10 = b$10.size0$6;
    var i$15 = 0;
    var j$10 = start$10;
    var x$274 = $uI(array$15.length);
    var x$275 = ((x$274 < n$20) ? x$274 : n$20);
    var that$10 = ((xs$10.u.length - start$10) | 0);
    var end$10 = ((x$275 < that$10) ? x$275 : that$10);
    while ((i$15 < end$10)) {
      var jsx$11 = j$10;
      var index$15 = i$15;
      xs$10.set(jsx$11, array$15[index$15]);
      i$15 = ((1 + i$15) | 0);
      j$10 = ((1 + j$10) | 0)
    };
    b$10.size0$6 = ((b$10.size0$6 + n$20) | 0);
    var x$447 = b$10
  };
  var x$448 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#xml-non-scalar-attribute");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$742 = new $c_scm_ListBuffer().init___();
  var x$449 = this$742.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$746 = new $c_scm_ListBuffer().init___();
  var x$450 = this$746.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$750 = new $c_scm_ListBuffer().init___();
  var x$451 = this$750.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$754 = new $c_scm_ListBuffer().init___();
  var x$452 = this$754.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$758 = new $c_scm_ListBuffer().init___();
  var x$453 = this$758.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$762 = new $c_scm_ListBuffer().init___();
  var x$454 = this$762.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$455 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$767 = new $c_scm_ListBuffer().init___();
  var x$456 = this$767.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$457 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$458 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$459 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$460 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$461 = $m_s_None$();
  var array$16 = [jsx$20, jsx$19, jsx$17, jsx$15, jsx$13, new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#xml-non-scalar-attribute_or_2_raml-shapes.xmlSerialization_node", "XML property 'attribute' must be false for non-scalar types", x$445, x$446, x$449, x$450, x$451, x$452, x$453, x$454, x$455, x$447, x$456, x$457, x$458, x$459, x$448, x$460, x$461)];
  var i$16 = (((-1) + $uI(array$16.length)) | 0);
  var result$5 = $m_sci_Nil$();
  while ((i$16 >= 0)) {
    var this$776 = result$5;
    var index$16 = i$16;
    var x$302 = array$16[index$16];
    result$5 = new $c_sci_$colon$colon().init___O__sci_List(x$302, this$776);
    i$16 = (((-1) + i$16) | 0)
  };
  this.xmlNonScalarAttribute$1 = result$5;
  $m_sci_List$();
  var x$464 = new $c_s_Some().init___O("Parameter of type file must set property 'in' to formData");
  var x$465 = new $c_s_Some().init___O("Parameter of type file must set property 'in' to formData");
  $m_sci_List$();
  var array$17 = ["http://a.ml/vocabularies/apiContract#Parameter"];
  var i$17 = (((-1) + $uI(array$17.length)) | 0);
  var result$6 = $m_sci_Nil$();
  while ((i$17 >= 0)) {
    var this$780 = result$6;
    var index$17 = i$17;
    var x$303 = array$17[index$17];
    result$6 = new $c_sci_$colon$colon().init___O__sci_List(x$303, this$780);
    i$17 = (((-1) + i$17) | 0)
  };
  var x$466 = result$6;
  $m_sci_List$();
  var array$18 = ["http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data_or_0", "http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data_or_1"];
  var i$18 = (((-1) + $uI(array$18.length)) | 0);
  var result$7 = $m_sci_Nil$();
  while ((i$18 >= 0)) {
    var this$784 = result$7;
    var index$18 = i$18;
    var x$321 = array$18[index$18];
    result$7 = new $c_sci_$colon$colon().init___O__sci_List(x$321, this$784);
    i$18 = (((-1) + i$18) | 0)
  };
  var x$467 = result$7;
  var x$468 = new $c_s_Some().init___O("fileParameterMustBeInFormData");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$788 = new $c_scm_ListBuffer().init___();
  var x$469 = this$788.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$792 = new $c_scm_ListBuffer().init___();
  var x$470 = this$792.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$796 = new $c_scm_ListBuffer().init___();
  var x$471 = this$796.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$800 = new $c_scm_ListBuffer().init___();
  var x$472 = this$800.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$473 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$805 = new $c_scm_ListBuffer().init___();
  var x$474 = this$805.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$809 = new $c_scm_ListBuffer().init___();
  var x$475 = this$809.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$476 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$477 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$478 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$479 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$480 = $m_s_None$();
  var jsx$31 = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data", "Parameter of type file must set property 'in' to formData", x$464, x$465, x$469, x$466, x$470, x$467, x$471, x$472, x$473, x$474, x$475, x$476, x$477, x$478, x$479, x$468, x$480);
  var x$483 = new $c_s_Some().init___O("Parameter of type file must set property 'in' to formData");
  var x$484 = new $c_s_Some().init___O("Parameter of type file must set property 'in' to formData");
  var x$485 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data_or_0_not");
  var x$486 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$818 = new $c_scm_ListBuffer().init___();
  var x$487 = this$818.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$822 = new $c_scm_ListBuffer().init___();
  var x$488 = this$822.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$826 = new $c_scm_ListBuffer().init___();
  var x$489 = this$826.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$830 = new $c_scm_ListBuffer().init___();
  var x$490 = this$830.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$834 = new $c_scm_ListBuffer().init___();
  var x$491 = this$834.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$838 = new $c_scm_ListBuffer().init___();
  var x$492 = this$838.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$842 = new $c_scm_ListBuffer().init___();
  var x$493 = this$842.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$846 = new $c_scm_ListBuffer().init___();
  var x$494 = this$846.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$495 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$496 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$497 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$498 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$499 = $m_s_None$();
  var jsx$30 = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data_or_0", "Parameter of type file must set property 'in' to formData", x$483, x$484, x$487, x$488, x$489, x$490, x$491, x$492, x$485, x$493, x$494, x$495, x$496, x$497, x$486, x$498, x$499);
  var x$502 = new $c_s_Some().init___O("Parameter of type file must set property 'in' to formData");
  var x$503 = new $c_s_Some().init___O("Parameter of type file must set property 'in' to formData");
  $m_sci_List$();
  var array$19 = ["http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data_or_1_and_0", "http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data_or_1_and_1"];
  var i$19 = (((-1) + $uI(array$19.length)) | 0);
  var result$8 = $m_sci_Nil$();
  while ((i$19 >= 0)) {
    var this$855 = result$8;
    var index$19 = i$19;
    var x$322 = array$19[index$19];
    result$8 = new $c_sci_$colon$colon().init___O__sci_List(x$322, this$855);
    i$19 = (((-1) + i$19) | 0)
  };
  var x$504 = result$8;
  var x$505 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$859 = new $c_scm_ListBuffer().init___();
  var x$506 = this$859.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$863 = new $c_scm_ListBuffer().init___();
  var x$507 = this$863.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$867 = new $c_scm_ListBuffer().init___();
  var x$508 = this$867.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$871 = new $c_scm_ListBuffer().init___();
  var x$509 = this$871.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$875 = new $c_scm_ListBuffer().init___();
  var x$510 = this$875.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$511 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$880 = new $c_scm_ListBuffer().init___();
  var x$512 = this$880.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$884 = new $c_scm_ListBuffer().init___();
  var x$513 = this$884.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$514 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$515 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$516 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$517 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$518 = $m_s_None$();
  var jsx$29 = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data_or_1", "Parameter of type file must set property 'in' to formData", x$502, x$503, x$506, x$507, x$508, x$509, x$504, x$510, x$511, x$512, x$513, x$514, x$515, x$516, x$505, x$517, x$518);
  var x$549 = new $c_s_Some().init___O("Parameter of type file must set property 'in' to formData");
  var x$550 = new $c_s_Some().init___O("Parameter of type file must set property 'in' to formData");
  $m_scm_ArrayBuffer$();
  var x$521 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data_or_0_not_raml-shapes.schema_node");
  var x$522 = $m_s_None$();
  var x$523 = $m_s_None$();
  var x$524 = $m_s_None$();
  var x$525 = $m_s_None$();
  var x$526 = $m_s_None$();
  var x$527 = $m_s_None$();
  var x$528 = $m_s_None$();
  var x$529 = $m_s_None$();
  var x$530 = $m_s_None$();
  var x$531 = $m_s_None$();
  var x$532 = $m_s_None$();
  var x$533 = $m_s_None$();
  var x$534 = $m_s_None$();
  var x$535 = $m_s_None$();
  var x$536 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$908 = new $c_scm_ListBuffer().init___();
  var x$537 = this$908.toList__sci_List();
  var x$538 = $m_s_None$();
  var x$539 = $m_s_None$();
  var x$540 = $m_s_None$();
  var x$541 = $m_s_None$();
  var x$542 = $m_s_None$();
  var x$543 = $m_s_None$();
  var x$544 = $m_s_None$();
  var x$545 = $m_s_None$();
  var x$546 = $m_s_None$();
  var array$20 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/shapes#schema", "raml-shapes.schema", x$522, x$523, x$524, x$525, x$526, x$527, x$528, x$529, x$530, x$531, x$532, x$533, x$534, x$521, x$535, x$536, x$537, x$538, x$539, x$540, x$541, x$542, x$543, x$544, x$545, x$546)];
  if (($uI(array$20.length) === 0)) {
    var this$921 = new $c_scm_ArrayBuffer().init___();
    var x$551 = this$921
  } else {
    var b$11 = new $c_scm_ArrayBuffer().init___();
    var n$22 = $uI(array$20.length);
    var n$23 = ((b$11.size0$6 + n$22) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$11, n$23);
    var xs$11 = b$11.array$6;
    var start$11 = b$11.size0$6;
    var i$20 = 0;
    var j$11 = start$11;
    var x$349 = $uI(array$20.length);
    var x$350 = ((x$349 < n$22) ? x$349 : n$22);
    var that$11 = ((xs$11.u.length - start$11) | 0);
    var end$11 = ((x$350 < that$11) ? x$350 : that$11);
    while ((i$20 < end$11)) {
      var jsx$27 = j$11;
      var index$20 = i$20;
      xs$11.set(jsx$27, array$20[index$20]);
      i$20 = ((1 + i$20) | 0);
      j$11 = ((1 + j$11) | 0)
    };
    b$11.size0$6 = ((b$11.size0$6 + n$22) | 0);
    var x$551 = b$11
  };
  var x$552 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$933 = new $c_scm_ListBuffer().init___();
  var x$553 = this$933.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$937 = new $c_scm_ListBuffer().init___();
  var x$554 = this$937.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$941 = new $c_scm_ListBuffer().init___();
  var x$555 = this$941.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$945 = new $c_scm_ListBuffer().init___();
  var x$556 = this$945.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$949 = new $c_scm_ListBuffer().init___();
  var x$557 = this$949.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$953 = new $c_scm_ListBuffer().init___();
  var x$558 = this$953.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$559 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$958 = new $c_scm_ListBuffer().init___();
  var x$560 = this$958.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$561 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$562 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$563 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$564 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$565 = $m_s_None$();
  var jsx$28 = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data_or_0_not", "Parameter of type file must set property 'in' to formData", x$549, x$550, x$553, x$554, x$555, x$556, x$557, x$558, x$559, x$551, x$560, x$561, x$562, x$563, x$552, x$564, x$565);
  var x$596 = new $c_s_Some().init___O("Parameter of type file must set property 'in' to formData");
  var x$597 = new $c_s_Some().init___O("Parameter of type file must set property 'in' to formData");
  $m_sci_List$();
  var x$568 = new $c_s_Some().init___O("http://a.ml/vocabularies/shapes#FileShape");
  var x$569 = $m_s_None$();
  var x$570 = $m_s_None$();
  var x$571 = $m_s_None$();
  var x$572 = $m_s_None$();
  var x$573 = $m_s_None$();
  var x$574 = $m_s_None$();
  var x$575 = $m_s_None$();
  var x$576 = $m_s_None$();
  var x$577 = $m_s_None$();
  var x$578 = $m_s_None$();
  var x$579 = $m_s_None$();
  var x$580 = $m_s_None$();
  var x$581 = $m_s_None$();
  var x$582 = $m_s_None$();
  var x$583 = $m_s_None$();
  var x$584 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$983 = new $c_scm_ListBuffer().init___();
  var x$585 = this$983.toList__sci_List();
  var x$586 = $m_s_None$();
  var x$587 = $m_s_None$();
  var x$588 = $m_s_None$();
  var x$589 = $m_s_None$();
  var x$590 = $m_s_None$();
  var x$591 = $m_s_None$();
  var x$592 = $m_s_None$();
  var x$593 = $m_s_None$();
  var array$21 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://www.w3.org/1999/02/22-rdf-syntax-ns#type", "rdf.type_0", x$569, x$570, x$571, x$572, x$573, x$574, x$575, x$576, x$577, x$578, x$579, x$580, x$581, x$582, x$583, x$584, x$585, x$586, x$587, x$588, x$589, x$568, x$590, x$591, x$592, x$593)];
  var i$21 = (((-1) + $uI(array$21.length)) | 0);
  var result$9 = $m_sci_Nil$();
  while ((i$21 >= 0)) {
    var this$995 = result$9;
    var index$21 = i$21;
    var x$368 = array$21[index$21];
    result$9 = new $c_sci_$colon$colon().init___O__sci_List(x$368, this$995);
    i$21 = (((-1) + i$21) | 0)
  };
  var x$598 = result$9;
  var x$599 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$999 = new $c_scm_ListBuffer().init___();
  var x$600 = this$999.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1003 = new $c_scm_ListBuffer().init___();
  var x$601 = this$1003.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1007 = new $c_scm_ListBuffer().init___();
  var x$602 = this$1007.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1011 = new $c_scm_ListBuffer().init___();
  var x$603 = this$1011.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1015 = new $c_scm_ListBuffer().init___();
  var x$604 = this$1015.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1019 = new $c_scm_ListBuffer().init___();
  var x$605 = this$1019.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$606 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1024 = new $c_scm_ListBuffer().init___();
  var x$607 = this$1024.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$608 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$609 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$610 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$611 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$612 = $m_s_None$();
  var jsx$26 = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data_or_0_not_raml-shapes.schema_node", "Parameter of type file must set property 'in' to formData", x$596, x$597, x$600, x$601, x$602, x$603, x$604, x$605, x$606, x$598, x$607, x$608, x$609, x$610, x$599, x$611, x$612);
  var x$643 = new $c_s_Some().init___O("Parameter of type file must set property 'in' to formData");
  var x$644 = new $c_s_Some().init___O("Parameter of type file must set property 'in' to formData");
  $m_scm_ArrayBuffer$();
  $m_scm_ArrayBuffer$();
  var array$22 = ["formData"];
  if (($uI(array$22.length) === 0)) {
    var this$1033 = new $c_scm_ArrayBuffer().init___();
    var x$615 = this$1033
  } else {
    var b$12 = new $c_scm_ArrayBuffer().init___();
    var n$24 = $uI(array$22.length);
    var n$25 = ((b$12.size0$6 + n$24) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$12, n$25);
    var xs$12 = b$12.array$6;
    var start$12 = b$12.size0$6;
    var i$22 = 0;
    var j$12 = start$12;
    var x$369 = $uI(array$22.length);
    var x$396 = ((x$369 < n$24) ? x$369 : n$24);
    var that$12 = ((xs$12.u.length - start$12) | 0);
    var end$12 = ((x$396 < that$12) ? x$396 : that$12);
    while ((i$22 < end$12)) {
      var jsx$23 = j$12;
      var index$22 = i$22;
      xs$12.set(jsx$23, array$22[index$22]);
      i$22 = ((1 + i$22) | 0);
      j$12 = ((1 + j$12) | 0)
    };
    b$12.size0$6 = ((b$12.size0$6 + n$24) | 0);
    var x$615 = b$12
  };
  var x$616 = $m_s_None$();
  var x$617 = $m_s_None$();
  var x$618 = $m_s_None$();
  var x$619 = $m_s_None$();
  var x$620 = $m_s_None$();
  var x$621 = $m_s_None$();
  var x$622 = $m_s_None$();
  var x$623 = $m_s_None$();
  var x$624 = $m_s_None$();
  var x$625 = $m_s_None$();
  var x$626 = $m_s_None$();
  var x$627 = $m_s_None$();
  var x$628 = $m_s_None$();
  var x$629 = $m_s_None$();
  var x$630 = $m_s_None$();
  var x$631 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var x$632 = $m_s_None$();
  var x$633 = $m_s_None$();
  var x$634 = $m_s_None$();
  var x$635 = $m_s_None$();
  var x$636 = $m_s_None$();
  var x$637 = $m_s_None$();
  var x$638 = $m_s_None$();
  var x$639 = $m_s_None$();
  var x$640 = $m_s_None$();
  var array$23 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/apiContract#binding", "apiContract.binding", x$616, x$617, x$618, x$619, x$620, x$621, x$622, x$623, x$624, x$625, x$626, x$627, x$628, x$629, x$630, x$631, x$615, x$632, x$633, x$634, x$635, x$636, x$637, x$638, x$639, x$640)];
  if (($uI(array$23.length) === 0)) {
    var this$1070 = new $c_scm_ArrayBuffer().init___();
    var x$645 = this$1070
  } else {
    var b$13 = new $c_scm_ArrayBuffer().init___();
    var n$26 = $uI(array$23.length);
    var n$27 = ((b$13.size0$6 + n$26) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$13, n$27);
    var xs$13 = b$13.array$6;
    var start$13 = b$13.size0$6;
    var i$23 = 0;
    var j$13 = start$13;
    var x$397 = $uI(array$23.length);
    var x$415 = ((x$397 < n$26) ? x$397 : n$26);
    var that$13 = ((xs$13.u.length - start$13) | 0);
    var end$13 = ((x$415 < that$13) ? x$415 : that$13);
    while ((i$23 < end$13)) {
      var jsx$24 = j$13;
      var index$23 = i$23;
      xs$13.set(jsx$24, array$23[index$23]);
      i$23 = ((1 + i$23) | 0);
      j$13 = ((1 + j$13) | 0)
    };
    b$13.size0$6 = ((b$13.size0$6 + n$26) | 0);
    var x$645 = b$13
  };
  var x$646 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1082 = new $c_scm_ListBuffer().init___();
  var x$647 = this$1082.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1086 = new $c_scm_ListBuffer().init___();
  var x$648 = this$1086.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1090 = new $c_scm_ListBuffer().init___();
  var x$649 = this$1090.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1094 = new $c_scm_ListBuffer().init___();
  var x$650 = this$1094.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1098 = new $c_scm_ListBuffer().init___();
  var x$651 = this$1098.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1102 = new $c_scm_ListBuffer().init___();
  var x$652 = this$1102.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$653 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1107 = new $c_scm_ListBuffer().init___();
  var x$654 = this$1107.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$655 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$656 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$657 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$658 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$659 = $m_s_None$();
  var jsx$25 = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data_or_1_and_0", "Parameter of type file must set property 'in' to formData", x$643, x$644, x$647, x$648, x$649, x$650, x$651, x$652, x$653, x$645, x$654, x$655, x$656, x$657, x$646, x$658, x$659);
  var x$690 = new $c_s_Some().init___O("Parameter of type file must set property 'in' to formData");
  var x$691 = new $c_s_Some().init___O("Parameter of type file must set property 'in' to formData");
  $m_scm_ArrayBuffer$();
  var x$662 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data_or_1_and_1_raml-shapes.schema_node");
  var x$663 = $m_s_None$();
  var x$664 = $m_s_None$();
  var x$665 = $m_s_None$();
  var x$666 = $m_s_None$();
  var x$667 = $m_s_None$();
  var x$668 = $m_s_None$();
  var x$669 = $m_s_None$();
  var x$670 = $m_s_None$();
  var x$671 = $m_s_None$();
  var x$672 = $m_s_None$();
  var x$673 = $m_s_None$();
  var x$674 = $m_s_None$();
  var x$675 = $m_s_None$();
  var x$676 = $m_s_None$();
  var x$677 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1131 = new $c_scm_ListBuffer().init___();
  var x$678 = this$1131.toList__sci_List();
  var x$679 = $m_s_None$();
  var x$680 = $m_s_None$();
  var x$681 = $m_s_None$();
  var x$682 = $m_s_None$();
  var x$683 = $m_s_None$();
  var x$684 = $m_s_None$();
  var x$685 = $m_s_None$();
  var x$686 = $m_s_None$();
  var x$687 = $m_s_None$();
  var array$24 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/shapes#schema", "raml-shapes.schema", x$663, x$664, x$665, x$666, x$667, x$668, x$669, x$670, x$671, x$672, x$673, x$674, x$675, x$662, x$676, x$677, x$678, x$679, x$680, x$681, x$682, x$683, x$684, x$685, x$686, x$687)];
  if (($uI(array$24.length) === 0)) {
    var this$1144 = new $c_scm_ArrayBuffer().init___();
    var x$692 = this$1144
  } else {
    var b$14 = new $c_scm_ArrayBuffer().init___();
    var n$28 = $uI(array$24.length);
    var n$29 = ((b$14.size0$6 + n$28) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$14, n$29);
    var xs$14 = b$14.array$6;
    var start$14 = b$14.size0$6;
    var i$24 = 0;
    var j$14 = start$14;
    var x$416 = $uI(array$24.length);
    var x$443 = ((x$416 < n$28) ? x$416 : n$28);
    var that$14 = ((xs$14.u.length - start$14) | 0);
    var end$14 = ((x$443 < that$14) ? x$443 : that$14);
    while ((i$24 < end$14)) {
      var jsx$21 = j$14;
      var index$24 = i$24;
      xs$14.set(jsx$21, array$24[index$24]);
      i$24 = ((1 + i$24) | 0);
      j$14 = ((1 + j$14) | 0)
    };
    b$14.size0$6 = ((b$14.size0$6 + n$28) | 0);
    var x$692 = b$14
  };
  var x$693 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1156 = new $c_scm_ListBuffer().init___();
  var x$694 = this$1156.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1160 = new $c_scm_ListBuffer().init___();
  var x$695 = this$1160.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1164 = new $c_scm_ListBuffer().init___();
  var x$696 = this$1164.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1168 = new $c_scm_ListBuffer().init___();
  var x$697 = this$1168.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1172 = new $c_scm_ListBuffer().init___();
  var x$698 = this$1172.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1176 = new $c_scm_ListBuffer().init___();
  var x$699 = this$1176.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$700 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1181 = new $c_scm_ListBuffer().init___();
  var x$701 = this$1181.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$702 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$703 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$704 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$705 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$706 = $m_s_None$();
  var jsx$22 = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data_or_1_and_1", "Parameter of type file must set property 'in' to formData", x$690, x$691, x$694, x$695, x$696, x$697, x$698, x$699, x$700, x$692, x$701, x$702, x$703, x$704, x$693, x$705, x$706);
  var x$737 = new $c_s_Some().init___O("Parameter of type file must set property 'in' to formData");
  var x$738 = new $c_s_Some().init___O("Parameter of type file must set property 'in' to formData");
  $m_sci_List$();
  var x$709 = new $c_s_Some().init___O("http://a.ml/vocabularies/shapes#FileShape");
  var x$710 = $m_s_None$();
  var x$711 = $m_s_None$();
  var x$712 = $m_s_None$();
  var x$713 = $m_s_None$();
  var x$714 = $m_s_None$();
  var x$715 = $m_s_None$();
  var x$716 = $m_s_None$();
  var x$717 = $m_s_None$();
  var x$718 = $m_s_None$();
  var x$719 = $m_s_None$();
  var x$720 = $m_s_None$();
  var x$721 = $m_s_None$();
  var x$722 = $m_s_None$();
  var x$723 = $m_s_None$();
  var x$724 = $m_s_None$();
  var x$725 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1206 = new $c_scm_ListBuffer().init___();
  var x$726 = this$1206.toList__sci_List();
  var x$727 = $m_s_None$();
  var x$728 = $m_s_None$();
  var x$729 = $m_s_None$();
  var x$730 = $m_s_None$();
  var x$731 = $m_s_None$();
  var x$732 = $m_s_None$();
  var x$733 = $m_s_None$();
  var x$734 = $m_s_None$();
  var array$25 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://www.w3.org/1999/02/22-rdf-syntax-ns#type", "rdf.type_0", x$710, x$711, x$712, x$713, x$714, x$715, x$716, x$717, x$718, x$719, x$720, x$721, x$722, x$723, x$724, x$725, x$726, x$727, x$728, x$729, x$730, x$709, x$731, x$732, x$733, x$734)];
  var i$25 = (((-1) + $uI(array$25.length)) | 0);
  var result$10 = $m_sci_Nil$();
  while ((i$25 >= 0)) {
    var this$1218 = result$10;
    var index$25 = i$25;
    var x$444 = array$25[index$25];
    result$10 = new $c_sci_$colon$colon().init___O__sci_List(x$444, this$1218);
    i$25 = (((-1) + i$25) | 0)
  };
  var x$739 = result$10;
  var x$740 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1222 = new $c_scm_ListBuffer().init___();
  var x$741 = this$1222.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1226 = new $c_scm_ListBuffer().init___();
  var x$742 = this$1226.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1230 = new $c_scm_ListBuffer().init___();
  var x$743 = this$1230.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1234 = new $c_scm_ListBuffer().init___();
  var x$744 = this$1234.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1238 = new $c_scm_ListBuffer().init___();
  var x$745 = this$1238.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1242 = new $c_scm_ListBuffer().init___();
  var x$746 = this$1242.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$747 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1247 = new $c_scm_ListBuffer().init___();
  var x$748 = this$1247.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$749 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$750 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$751 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$752 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$753 = $m_s_None$();
  var array$26 = [jsx$31, jsx$30, jsx$29, jsx$28, jsx$26, jsx$25, jsx$22, new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#file-parameter-in-form-data_or_1_and_1_raml-shapes.schema_node", "Parameter of type file must set property 'in' to formData", x$737, x$738, x$741, x$742, x$743, x$744, x$745, x$746, x$747, x$739, x$748, x$749, x$750, x$751, x$740, x$752, x$753)];
  var i$26 = (((-1) + $uI(array$26.length)) | 0);
  var result$11 = $m_sci_Nil$();
  while ((i$26 >= 0)) {
    var this$1256 = result$11;
    var index$26 = i$26;
    var x$462 = array$26[index$26];
    result$11 = new $c_sci_$colon$colon().init___O__sci_List(x$462, this$1256);
    i$26 = (((-1) + i$26) | 0)
  };
  this.fileParameterMustBeInFormData$1 = result$11;
  $m_sci_List$();
  var x$756 = new $c_s_Some().init___O("Path parameters must have the required property set to true");
  var x$757 = new $c_s_Some().init___O("Path parameters must have the required property set to true");
  $m_sci_List$();
  var array$27 = ["http://a.ml/vocabularies/apiContract#Parameter"];
  var i$27 = (((-1) + $uI(array$27.length)) | 0);
  var result$12 = $m_sci_Nil$();
  while ((i$27 >= 0)) {
    var this$1260 = result$12;
    var index$27 = i$27;
    var x$463 = array$27[index$27];
    result$12 = new $c_sci_$colon$colon().init___O__sci_List(x$463, this$1260);
    i$27 = (((-1) + i$27) | 0)
  };
  var x$758 = result$12;
  $m_sci_List$();
  var array$28 = ["http://a.ml/vocabularies/amf/parser#path-parameter-required_or_0", "http://a.ml/vocabularies/amf/parser#path-parameter-required_or_1"];
  var i$28 = (((-1) + $uI(array$28.length)) | 0);
  var result$13 = $m_sci_Nil$();
  while ((i$28 >= 0)) {
    var this$1264 = result$13;
    var index$28 = i$28;
    var x$481 = array$28[index$28];
    result$13 = new $c_sci_$colon$colon().init___O__sci_List(x$481, this$1264);
    i$28 = (((-1) + i$28) | 0)
  };
  var x$759 = result$13;
  var x$760 = new $c_s_Some().init___O("pathParameterRequiredProperty");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1268 = new $c_scm_ListBuffer().init___();
  var x$761 = this$1268.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1272 = new $c_scm_ListBuffer().init___();
  var x$762 = this$1272.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1276 = new $c_scm_ListBuffer().init___();
  var x$763 = this$1276.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1280 = new $c_scm_ListBuffer().init___();
  var x$764 = this$1280.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$765 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1285 = new $c_scm_ListBuffer().init___();
  var x$766 = this$1285.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1289 = new $c_scm_ListBuffer().init___();
  var x$767 = this$1289.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$768 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$769 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$770 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$771 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$772 = $m_s_None$();
  var jsx$38 = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#path-parameter-required", "Path parameters must have the required property set to true", x$756, x$757, x$761, x$758, x$762, x$759, x$763, x$764, x$765, x$766, x$767, x$768, x$769, x$770, x$771, x$760, x$772);
  var x$775 = new $c_s_Some().init___O("Path parameters must have the required property set to true");
  var x$776 = new $c_s_Some().init___O("Path parameters must have the required property set to true");
  var x$777 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#path-parameter-required_or_0_not");
  var x$778 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#path-parameter-required");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1298 = new $c_scm_ListBuffer().init___();
  var x$779 = this$1298.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1302 = new $c_scm_ListBuffer().init___();
  var x$780 = this$1302.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1306 = new $c_scm_ListBuffer().init___();
  var x$781 = this$1306.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1310 = new $c_scm_ListBuffer().init___();
  var x$782 = this$1310.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1314 = new $c_scm_ListBuffer().init___();
  var x$783 = this$1314.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1318 = new $c_scm_ListBuffer().init___();
  var x$784 = this$1318.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1322 = new $c_scm_ListBuffer().init___();
  var x$785 = this$1322.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1326 = new $c_scm_ListBuffer().init___();
  var x$786 = this$1326.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$787 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$788 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$789 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$790 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$791 = $m_s_None$();
  var jsx$37 = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#path-parameter-required_or_0", "Path parameters must have the required property set to true", x$775, x$776, x$779, x$780, x$781, x$782, x$783, x$784, x$777, x$785, x$786, x$787, x$788, x$789, x$778, x$790, x$791);
  var x$822 = new $c_s_Some().init___O("Path parameters must have the required property set to true");
  var x$823 = new $c_s_Some().init___O("Path parameters must have the required property set to true");
  $m_scm_ArrayBuffer$();
  $m_scm_ArrayBuffer$();
  var array$29 = ["true"];
  if (($uI(array$29.length) === 0)) {
    var this$1335 = new $c_scm_ArrayBuffer().init___();
    var x$794 = this$1335
  } else {
    var b$15 = new $c_scm_ArrayBuffer().init___();
    var n$30 = $uI(array$29.length);
    var n$31 = ((b$15.size0$6 + n$30) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$15, n$31);
    var xs$15 = b$15.array$6;
    var start$15 = b$15.size0$6;
    var i$29 = 0;
    var j$15 = start$15;
    var x$482 = $uI(array$29.length);
    var x$500 = ((x$482 < n$30) ? x$482 : n$30);
    var that$15 = ((xs$15.u.length - start$15) | 0);
    var end$15 = ((x$500 < that$15) ? x$500 : that$15);
    while ((i$29 < end$15)) {
      var jsx$34 = j$15;
      var index$29 = i$29;
      xs$15.set(jsx$34, array$29[index$29]);
      i$29 = ((1 + i$29) | 0);
      j$15 = ((1 + j$15) | 0)
    };
    b$15.size0$6 = ((b$15.size0$6 + n$30) | 0);
    var x$794 = b$15
  };
  var x$795 = $m_s_None$();
  var x$796 = $m_s_None$();
  var x$797 = $m_s_None$();
  var x$798 = $m_s_None$();
  var x$799 = $m_s_None$();
  var x$800 = $m_s_None$();
  var x$801 = $m_s_None$();
  var x$802 = $m_s_None$();
  var x$803 = $m_s_None$();
  var x$804 = $m_s_None$();
  var x$805 = $m_s_None$();
  var x$806 = $m_s_None$();
  var x$807 = $m_s_None$();
  var x$808 = $m_s_None$();
  var x$809 = $m_s_None$();
  var x$810 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var x$811 = $m_s_None$();
  var x$812 = $m_s_None$();
  var x$813 = $m_s_None$();
  var x$814 = $m_s_None$();
  var x$815 = $m_s_None$();
  var x$816 = $m_s_None$();
  var x$817 = $m_s_None$();
  var x$818 = $m_s_None$();
  var x$819 = $m_s_None$();
  var array$30 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/apiContract#required", "apiContract.required", x$795, x$796, x$797, x$798, x$799, x$800, x$801, x$802, x$803, x$804, x$805, x$806, x$807, x$808, x$809, x$810, x$794, x$811, x$812, x$813, x$814, x$815, x$816, x$817, x$818, x$819)];
  if (($uI(array$30.length) === 0)) {
    var this$1372 = new $c_scm_ArrayBuffer().init___();
    var x$824 = this$1372
  } else {
    var b$16 = new $c_scm_ArrayBuffer().init___();
    var n$32 = $uI(array$30.length);
    var n$33 = ((b$16.size0$6 + n$32) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$16, n$33);
    var xs$16 = b$16.array$6;
    var start$16 = b$16.size0$6;
    var i$30 = 0;
    var j$16 = start$16;
    var x$501 = $uI(array$30.length);
    var x$519 = ((x$501 < n$32) ? x$501 : n$32);
    var that$16 = ((xs$16.u.length - start$16) | 0);
    var end$16 = ((x$519 < that$16) ? x$519 : that$16);
    while ((i$30 < end$16)) {
      var jsx$35 = j$16;
      var index$30 = i$30;
      xs$16.set(jsx$35, array$30[index$30]);
      i$30 = ((1 + i$30) | 0);
      j$16 = ((1 + j$16) | 0)
    };
    b$16.size0$6 = ((b$16.size0$6 + n$32) | 0);
    var x$824 = b$16
  };
  var x$825 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#path-parameter-required");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1384 = new $c_scm_ListBuffer().init___();
  var x$826 = this$1384.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1388 = new $c_scm_ListBuffer().init___();
  var x$827 = this$1388.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1392 = new $c_scm_ListBuffer().init___();
  var x$828 = this$1392.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1396 = new $c_scm_ListBuffer().init___();
  var x$829 = this$1396.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1400 = new $c_scm_ListBuffer().init___();
  var x$830 = this$1400.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1404 = new $c_scm_ListBuffer().init___();
  var x$831 = this$1404.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$832 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1409 = new $c_scm_ListBuffer().init___();
  var x$833 = this$1409.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$834 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$835 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$836 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$837 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$838 = $m_s_None$();
  var jsx$36 = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#path-parameter-required_or_1", "Path parameters must have the required property set to true", x$822, x$823, x$826, x$827, x$828, x$829, x$830, x$831, x$832, x$824, x$833, x$834, x$835, x$836, x$825, x$837, x$838);
  var x$869 = new $c_s_Some().init___O("Path parameters must have the required property set to true");
  var x$870 = new $c_s_Some().init___O("Path parameters must have the required property set to true");
  $m_scm_ArrayBuffer$();
  $m_scm_ArrayBuffer$();
  var array$31 = ["path"];
  if (($uI(array$31.length) === 0)) {
    var this$1418 = new $c_scm_ArrayBuffer().init___();
    var x$841 = this$1418
  } else {
    var b$17 = new $c_scm_ArrayBuffer().init___();
    var n$34 = $uI(array$31.length);
    var n$35 = ((b$17.size0$6 + n$34) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$17, n$35);
    var xs$17 = b$17.array$6;
    var start$17 = b$17.size0$6;
    var i$31 = 0;
    var j$17 = start$17;
    var x$520 = $uI(array$31.length);
    var x$547 = ((x$520 < n$34) ? x$520 : n$34);
    var that$17 = ((xs$17.u.length - start$17) | 0);
    var end$17 = ((x$547 < that$17) ? x$547 : that$17);
    while ((i$31 < end$17)) {
      var jsx$32 = j$17;
      var index$31 = i$31;
      xs$17.set(jsx$32, array$31[index$31]);
      i$31 = ((1 + i$31) | 0);
      j$17 = ((1 + j$17) | 0)
    };
    b$17.size0$6 = ((b$17.size0$6 + n$34) | 0);
    var x$841 = b$17
  };
  var x$842 = $m_s_None$();
  var x$843 = $m_s_None$();
  var x$844 = $m_s_None$();
  var x$845 = $m_s_None$();
  var x$846 = $m_s_None$();
  var x$847 = $m_s_None$();
  var x$848 = $m_s_None$();
  var x$849 = $m_s_None$();
  var x$850 = $m_s_None$();
  var x$851 = $m_s_None$();
  var x$852 = $m_s_None$();
  var x$853 = $m_s_None$();
  var x$854 = $m_s_None$();
  var x$855 = $m_s_None$();
  var x$856 = $m_s_None$();
  var x$857 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var x$858 = $m_s_None$();
  var x$859 = $m_s_None$();
  var x$860 = $m_s_None$();
  var x$861 = $m_s_None$();
  var x$862 = $m_s_None$();
  var x$863 = $m_s_None$();
  var x$864 = $m_s_None$();
  var x$865 = $m_s_None$();
  var x$866 = $m_s_None$();
  var array$32 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("apiContract:binding", "apiContract:binding", x$842, x$843, x$844, x$845, x$846, x$847, x$848, x$849, x$850, x$851, x$852, x$853, x$854, x$855, x$856, x$857, x$841, x$858, x$859, x$860, x$861, x$862, x$863, x$864, x$865, x$866)];
  if (($uI(array$32.length) === 0)) {
    var this$1455 = new $c_scm_ArrayBuffer().init___();
    var x$871 = this$1455
  } else {
    var b$18 = new $c_scm_ArrayBuffer().init___();
    var n$36 = $uI(array$32.length);
    var n$37 = ((b$18.size0$6 + n$36) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$18, n$37);
    var xs$18 = b$18.array$6;
    var start$18 = b$18.size0$6;
    var i$32 = 0;
    var j$18 = start$18;
    var x$548 = $uI(array$32.length);
    var x$566 = ((x$548 < n$36) ? x$548 : n$36);
    var that$18 = ((xs$18.u.length - start$18) | 0);
    var end$18 = ((x$566 < that$18) ? x$566 : that$18);
    while ((i$32 < end$18)) {
      var jsx$33 = j$18;
      var index$32 = i$32;
      xs$18.set(jsx$33, array$32[index$32]);
      i$32 = ((1 + i$32) | 0);
      j$18 = ((1 + j$18) | 0)
    };
    b$18.size0$6 = ((b$18.size0$6 + n$36) | 0);
    var x$871 = b$18
  };
  var x$872 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#path-parameter-required");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1467 = new $c_scm_ListBuffer().init___();
  var x$873 = this$1467.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1471 = new $c_scm_ListBuffer().init___();
  var x$874 = this$1471.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1475 = new $c_scm_ListBuffer().init___();
  var x$875 = this$1475.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1479 = new $c_scm_ListBuffer().init___();
  var x$876 = this$1479.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1483 = new $c_scm_ListBuffer().init___();
  var x$877 = this$1483.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1487 = new $c_scm_ListBuffer().init___();
  var x$878 = this$1487.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$879 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1492 = new $c_scm_ListBuffer().init___();
  var x$880 = this$1492.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$881 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$882 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$883 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$884 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$885 = $m_s_None$();
  var array$33 = [jsx$38, jsx$37, jsx$36, new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#path-parameter-required_or_0_not", "Path parameters must have the required property set to true", x$869, x$870, x$873, x$874, x$875, x$876, x$877, x$878, x$879, x$871, x$880, x$881, x$882, x$883, x$872, x$884, x$885)];
  var i$33 = (((-1) + $uI(array$33.length)) | 0);
  var result$14 = $m_sci_Nil$();
  while ((i$33 >= 0)) {
    var this$1501 = result$14;
    var index$33 = i$33;
    var x$567 = array$33[index$33];
    result$14 = new $c_sci_$colon$colon().init___O__sci_List(x$567, this$1501);
    i$33 = (((-1) + i$33) | 0)
  };
  this.pathParameterRequiredProperty$1 = result$14;
  $m_sci_List$();
  $m_sci_List$();
  var array$34 = ["http://a.ml/vocabularies/apiContract#Example"];
  var i$34 = (((-1) + $uI(array$34.length)) | 0);
  var result$15 = $m_sci_Nil$();
  while ((i$34 >= 0)) {
    var this$1505 = result$15;
    var index$34 = i$34;
    var x$594 = array$34[index$34];
    result$15 = new $c_sci_$colon$colon().init___O__sci_List(x$594, this$1505);
    i$34 = (((-1) + i$34) | 0)
  };
  var x$888 = result$15;
  var x$889 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#example-mutually-exclusive-fields_not");
  var x$890 = new $c_s_Some().init___O("exampleMutuallyExclusiveFields");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$891 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$892 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1511 = new $c_scm_ListBuffer().init___();
  var x$893 = this$1511.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1515 = new $c_scm_ListBuffer().init___();
  var x$894 = this$1515.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1519 = new $c_scm_ListBuffer().init___();
  var x$895 = this$1519.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1523 = new $c_scm_ListBuffer().init___();
  var x$896 = this$1523.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1527 = new $c_scm_ListBuffer().init___();
  var x$897 = this$1527.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1531 = new $c_scm_ListBuffer().init___();
  var x$898 = this$1531.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1535 = new $c_scm_ListBuffer().init___();
  var x$899 = this$1535.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$900 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$901 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$902 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$903 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$904 = $m_s_None$();
  var jsx$41 = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#example-mutually-exclusive-fields", "Example 'value' and 'externalValue' fields are mutually exclusive", x$891, x$892, x$893, x$888, x$894, x$895, x$896, x$897, x$889, x$898, x$899, x$900, x$901, x$902, x$903, x$890, x$904);
  $m_scm_ArrayBuffer$();
  var x$907 = new $c_s_Some().init___O("1");
  var x$908 = $m_s_None$();
  var x$909 = $m_s_None$();
  var x$910 = $m_s_None$();
  var x$911 = $m_s_None$();
  var x$912 = $m_s_None$();
  var x$913 = $m_s_None$();
  var x$914 = $m_s_None$();
  var x$915 = $m_s_None$();
  var x$916 = $m_s_None$();
  var x$917 = $m_s_None$();
  var x$918 = $m_s_None$();
  var x$919 = $m_s_None$();
  var x$920 = $m_s_None$();
  var x$921 = $m_s_None$();
  var x$922 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1559 = new $c_scm_ListBuffer().init___();
  var x$923 = this$1559.toList__sci_List();
  var x$924 = $m_s_None$();
  var x$925 = $m_s_None$();
  var x$926 = $m_s_None$();
  var x$927 = $m_s_None$();
  var x$928 = $m_s_None$();
  var x$929 = $m_s_None$();
  var x$930 = $m_s_None$();
  var x$931 = $m_s_None$();
  var x$932 = $m_s_None$();
  var jsx$39 = new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/document#externalValue", "doc.externalValue", x$908, x$909, x$910, x$911, x$912, x$907, x$913, x$914, x$915, x$916, x$917, x$918, x$919, x$920, x$921, x$922, x$923, x$924, x$925, x$926, x$927, x$928, x$929, x$930, x$931, x$932);
  var x$935 = new $c_s_Some().init___O("1");
  var x$936 = $m_s_None$();
  var x$937 = $m_s_None$();
  var x$938 = $m_s_None$();
  var x$939 = $m_s_None$();
  var x$940 = $m_s_None$();
  var x$941 = $m_s_None$();
  var x$942 = $m_s_None$();
  var x$943 = $m_s_None$();
  var x$944 = $m_s_None$();
  var x$945 = $m_s_None$();
  var x$946 = $m_s_None$();
  var x$947 = $m_s_None$();
  var x$948 = $m_s_None$();
  var x$949 = $m_s_None$();
  var x$950 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1587 = new $c_scm_ListBuffer().init___();
  var x$951 = this$1587.toList__sci_List();
  var x$952 = $m_s_None$();
  var x$953 = $m_s_None$();
  var x$954 = $m_s_None$();
  var x$955 = $m_s_None$();
  var x$956 = $m_s_None$();
  var x$957 = $m_s_None$();
  var x$958 = $m_s_None$();
  var x$959 = $m_s_None$();
  var x$960 = $m_s_None$();
  var array$35 = [jsx$39, new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/document#structuredValue", "doc.structuredValue", x$936, x$937, x$938, x$939, x$940, x$935, x$941, x$942, x$943, x$944, x$945, x$946, x$947, x$948, x$949, x$950, x$951, x$952, x$953, x$954, x$955, x$956, x$957, x$958, x$959, x$960)];
  if (($uI(array$35.length) === 0)) {
    var this$1600 = new $c_scm_ArrayBuffer().init___();
    var x$963 = this$1600
  } else {
    var b$19 = new $c_scm_ArrayBuffer().init___();
    var n$38 = $uI(array$35.length);
    var n$39 = ((b$19.size0$6 + n$38) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$19, n$39);
    var xs$19 = b$19.array$6;
    var start$19 = b$19.size0$6;
    var i$35 = 0;
    var j$19 = start$19;
    var x$595 = $uI(array$35.length);
    var x$613 = ((x$595 < n$38) ? x$595 : n$38);
    var that$19 = ((xs$19.u.length - start$19) | 0);
    var end$19 = ((x$613 < that$19) ? x$613 : that$19);
    while ((i$35 < end$19)) {
      var jsx$40 = j$19;
      var index$35 = i$35;
      xs$19.set(jsx$40, array$35[index$35]);
      i$35 = ((1 + i$35) | 0);
      j$19 = ((1 + j$19) | 0)
    };
    b$19.size0$6 = ((b$19.size0$6 + n$38) | 0);
    var x$963 = b$19
  };
  var x$964 = new $c_s_Some().init___O("http://a.ml/vocabularies/amf/parser#example-mutually-exclusive-fields");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$965 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$966 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1614 = new $c_scm_ListBuffer().init___();
  var x$967 = this$1614.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1618 = new $c_scm_ListBuffer().init___();
  var x$968 = this$1618.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1622 = new $c_scm_ListBuffer().init___();
  var x$969 = this$1622.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1626 = new $c_scm_ListBuffer().init___();
  var x$970 = this$1626.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1630 = new $c_scm_ListBuffer().init___();
  var x$971 = this$1630.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1634 = new $c_scm_ListBuffer().init___();
  var x$972 = this$1634.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$973 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1639 = new $c_scm_ListBuffer().init___();
  var x$974 = this$1639.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$975 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$976 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$977 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$978 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$979 = $m_s_None$();
  var array$36 = [jsx$41, new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#example-mutually-exclusive-fields_not", "Example 'value' and 'externalValue' fields are mutually exclusive", x$965, x$966, x$967, x$968, x$969, x$970, x$971, x$972, x$973, x$963, x$974, x$975, x$976, x$977, x$964, x$978, x$979)];
  var i$36 = (((-1) + $uI(array$36.length)) | 0);
  var result$16 = $m_sci_Nil$();
  while ((i$36 >= 0)) {
    var this$1648 = result$16;
    var index$36 = i$36;
    var x$614 = array$36[index$36];
    result$16 = new $c_sci_$colon$colon().init___O__sci_List(x$614, this$1648);
    i$36 = (((-1) + i$36) | 0)
  };
  this.exampleMutuallyExclusiveFields$1 = result$16;
  $m_sci_List$();
  var x$1010 = new $c_s_Some().init___O("Maximum must be greater than or equal to minimum");
  var x$1011 = new $c_s_Some().init___O("Maximum must be greater than or equal to minimum");
  $m_sci_List$();
  var array$37 = ["http://a.ml/vocabularies/shapes#ScalarShape"];
  var i$37 = (((-1) + $uI(array$37.length)) | 0);
  var result$17 = $m_sci_Nil$();
  while ((i$37 >= 0)) {
    var this$1652 = result$17;
    var index$37 = i$37;
    var x$641 = array$37[index$37];
    result$17 = new $c_sci_$colon$colon().init___O__sci_List(x$641, this$1652);
    i$37 = (((-1) + i$37) | 0)
  };
  var x$1012 = result$17;
  $m_scm_ArrayBuffer$();
  var x$982 = new $c_s_Some().init___O("http://www.w3.org/ns/shacl#maxInclusive");
  var x$983 = $m_s_None$();
  var x$984 = $m_s_None$();
  var x$985 = $m_s_None$();
  var x$986 = $m_s_None$();
  var x$987 = $m_s_None$();
  var x$988 = $m_s_None$();
  var x$989 = $m_s_None$();
  var x$990 = $m_s_None$();
  var x$991 = $m_s_None$();
  var x$992 = $m_s_None$();
  var x$993 = $m_s_None$();
  var x$994 = $m_s_None$();
  var x$995 = $m_s_None$();
  var x$996 = $m_s_None$();
  var x$997 = $m_s_None$();
  var x$998 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1672 = new $c_scm_ListBuffer().init___();
  var x$999 = this$1672.toList__sci_List();
  var x$1000 = $m_s_None$();
  var x$1001 = $m_s_None$();
  var x$1002 = $m_s_None$();
  var x$1003 = $m_s_None$();
  var x$1004 = $m_s_None$();
  var x$1005 = $m_s_None$();
  var x$1006 = $m_s_None$();
  var x$1007 = $m_s_None$();
  var array$38 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://www.w3.org/ns/shacl#minInclusive", "shacl.minInclusive", x$983, x$984, x$985, x$986, x$987, x$988, x$989, x$990, x$991, x$992, x$993, x$994, x$995, x$996, x$997, x$998, x$999, x$1000, x$1001, x$1002, x$1003, x$1004, x$1005, x$1006, x$1007, x$982)];
  if (($uI(array$38.length) === 0)) {
    var this$1684 = new $c_scm_ArrayBuffer().init___();
    var x$1013 = this$1684
  } else {
    var b$20 = new $c_scm_ArrayBuffer().init___();
    var n$40 = $uI(array$38.length);
    var n$41 = ((b$20.size0$6 + n$40) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$20, n$41);
    var xs$20 = b$20.array$6;
    var start$20 = b$20.size0$6;
    var i$38 = 0;
    var j$20 = start$20;
    var x$642 = $uI(array$38.length);
    var x$660 = ((x$642 < n$40) ? x$642 : n$40);
    var that$20 = ((xs$20.u.length - start$20) | 0);
    var end$20 = ((x$660 < that$20) ? x$660 : that$20);
    while ((i$38 < end$20)) {
      var jsx$42 = j$20;
      var index$38 = i$38;
      xs$20.set(jsx$42, array$38[index$38]);
      i$38 = ((1 + i$38) | 0);
      j$20 = ((1 + j$20) | 0)
    };
    b$20.size0$6 = ((b$20.size0$6 + n$40) | 0);
    var x$1013 = b$20
  };
  var x$1014 = new $c_s_Some().init___O("minimumMaximumValidation");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1696 = new $c_scm_ListBuffer().init___();
  var x$1015 = this$1696.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1700 = new $c_scm_ListBuffer().init___();
  var x$1016 = this$1700.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1704 = new $c_scm_ListBuffer().init___();
  var x$1017 = this$1704.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1708 = new $c_scm_ListBuffer().init___();
  var x$1018 = this$1708.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1712 = new $c_scm_ListBuffer().init___();
  var x$1019 = this$1712.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1020 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1717 = new $c_scm_ListBuffer().init___();
  var x$1021 = this$1717.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1022 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1023 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1024 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1025 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1026 = $m_s_None$();
  var array$39 = [new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#min-max-inclusive", "Maximum must be greater than or equal to minimum", x$1010, x$1011, x$1015, x$1012, x$1016, x$1017, x$1018, x$1019, x$1020, x$1013, x$1021, x$1022, x$1023, x$1024, x$1025, x$1014, x$1026)];
  var i$39 = (((-1) + $uI(array$39.length)) | 0);
  var result$18 = $m_sci_Nil$();
  while ((i$39 >= 0)) {
    var this$1726 = result$18;
    var index$39 = i$39;
    var x$661 = array$39[index$39];
    result$18 = new $c_sci_$colon$colon().init___O__sci_List(x$661, this$1726);
    i$39 = (((-1) + i$39) | 0)
  };
  this.minimumMaximumValidation$1 = result$18;
  $m_sci_List$();
  var x$1057 = new $c_s_Some().init___O("MaxItems must be greater than or equal to minItems");
  var x$1058 = new $c_s_Some().init___O("MaxItems must be greater than or equal to minItems");
  $m_sci_List$();
  var array$40 = ["http://a.ml/vocabularies/shapes#ArrayShape"];
  var i$40 = (((-1) + $uI(array$40.length)) | 0);
  var result$19 = $m_sci_Nil$();
  while ((i$40 >= 0)) {
    var this$1730 = result$19;
    var index$40 = i$40;
    var x$688 = array$40[index$40];
    result$19 = new $c_sci_$colon$colon().init___O__sci_List(x$688, this$1730);
    i$40 = (((-1) + i$40) | 0)
  };
  var x$1059 = result$19;
  $m_scm_ArrayBuffer$();
  var x$1029 = new $c_s_Some().init___O("http://www.w3.org/ns/shacl#maxCount");
  var x$1030 = $m_s_None$();
  var x$1031 = $m_s_None$();
  var x$1032 = $m_s_None$();
  var x$1033 = $m_s_None$();
  var x$1034 = $m_s_None$();
  var x$1035 = $m_s_None$();
  var x$1036 = $m_s_None$();
  var x$1037 = $m_s_None$();
  var x$1038 = $m_s_None$();
  var x$1039 = $m_s_None$();
  var x$1040 = $m_s_None$();
  var x$1041 = $m_s_None$();
  var x$1042 = $m_s_None$();
  var x$1043 = $m_s_None$();
  var x$1044 = $m_s_None$();
  var x$1045 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1750 = new $c_scm_ListBuffer().init___();
  var x$1046 = this$1750.toList__sci_List();
  var x$1047 = $m_s_None$();
  var x$1048 = $m_s_None$();
  var x$1049 = $m_s_None$();
  var x$1050 = $m_s_None$();
  var x$1051 = $m_s_None$();
  var x$1052 = $m_s_None$();
  var x$1053 = $m_s_None$();
  var x$1054 = $m_s_None$();
  var array$41 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://www.w3.org/ns/shacl#minCount", "shacl.minCount", x$1030, x$1031, x$1032, x$1033, x$1034, x$1035, x$1036, x$1037, x$1038, x$1039, x$1040, x$1041, x$1042, x$1043, x$1044, x$1045, x$1046, x$1047, x$1048, x$1049, x$1050, x$1051, x$1052, x$1053, x$1054, x$1029)];
  if (($uI(array$41.length) === 0)) {
    var this$1762 = new $c_scm_ArrayBuffer().init___();
    var x$1060 = this$1762
  } else {
    var b$21 = new $c_scm_ArrayBuffer().init___();
    var n$42 = $uI(array$41.length);
    var n$43 = ((b$21.size0$6 + n$42) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$21, n$43);
    var xs$21 = b$21.array$6;
    var start$21 = b$21.size0$6;
    var i$41 = 0;
    var j$21 = start$21;
    var x$689 = $uI(array$41.length);
    var x$707 = ((x$689 < n$42) ? x$689 : n$42);
    var that$21 = ((xs$21.u.length - start$21) | 0);
    var end$21 = ((x$707 < that$21) ? x$707 : that$21);
    while ((i$41 < end$21)) {
      var jsx$43 = j$21;
      var index$41 = i$41;
      xs$21.set(jsx$43, array$41[index$41]);
      i$41 = ((1 + i$41) | 0);
      j$21 = ((1 + j$21) | 0)
    };
    b$21.size0$6 = ((b$21.size0$6 + n$42) | 0);
    var x$1060 = b$21
  };
  var x$1061 = new $c_s_Some().init___O("minMaxItemsValidation");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1774 = new $c_scm_ListBuffer().init___();
  var x$1062 = this$1774.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1778 = new $c_scm_ListBuffer().init___();
  var x$1063 = this$1778.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1782 = new $c_scm_ListBuffer().init___();
  var x$1064 = this$1782.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1786 = new $c_scm_ListBuffer().init___();
  var x$1065 = this$1786.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1790 = new $c_scm_ListBuffer().init___();
  var x$1066 = this$1790.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1067 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1795 = new $c_scm_ListBuffer().init___();
  var x$1068 = this$1795.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1069 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1070 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1071 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1072 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1073 = $m_s_None$();
  var array$42 = [new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#min-max-items", "MaxItems must be greater than or equal to minItems", x$1057, x$1058, x$1062, x$1059, x$1063, x$1064, x$1065, x$1066, x$1067, x$1060, x$1068, x$1069, x$1070, x$1071, x$1072, x$1061, x$1073)];
  var i$42 = (((-1) + $uI(array$42.length)) | 0);
  var result$20 = $m_sci_Nil$();
  while ((i$42 >= 0)) {
    var this$1804 = result$20;
    var index$42 = i$42;
    var x$708 = array$42[index$42];
    result$20 = new $c_sci_$colon$colon().init___O__sci_List(x$708, this$1804);
    i$42 = (((-1) + i$42) | 0)
  };
  this.minMaxItemsValidation$1 = result$20;
  $m_sci_List$();
  var x$1104 = new $c_s_Some().init___O("MaxLength must be greater than or equal to minLength");
  var x$1105 = new $c_s_Some().init___O("MaxLength must be greater than or equal to minLength");
  $m_sci_List$();
  var array$43 = ["http://a.ml/vocabularies/shapes#Shape"];
  var i$43 = (((-1) + $uI(array$43.length)) | 0);
  var result$21 = $m_sci_Nil$();
  while ((i$43 >= 0)) {
    var this$1808 = result$21;
    var index$43 = i$43;
    var x$735 = array$43[index$43];
    result$21 = new $c_sci_$colon$colon().init___O__sci_List(x$735, this$1808);
    i$43 = (((-1) + i$43) | 0)
  };
  var x$1106 = result$21;
  $m_scm_ArrayBuffer$();
  var x$1076 = new $c_s_Some().init___O("http://www.w3.org/ns/shacl#maxLength");
  var x$1077 = $m_s_None$();
  var x$1078 = $m_s_None$();
  var x$1079 = $m_s_None$();
  var x$1080 = $m_s_None$();
  var x$1081 = $m_s_None$();
  var x$1082 = $m_s_None$();
  var x$1083 = $m_s_None$();
  var x$1084 = $m_s_None$();
  var x$1085 = $m_s_None$();
  var x$1086 = $m_s_None$();
  var x$1087 = $m_s_None$();
  var x$1088 = $m_s_None$();
  var x$1089 = $m_s_None$();
  var x$1090 = $m_s_None$();
  var x$1091 = $m_s_None$();
  var x$1092 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1828 = new $c_scm_ListBuffer().init___();
  var x$1093 = this$1828.toList__sci_List();
  var x$1094 = $m_s_None$();
  var x$1095 = $m_s_None$();
  var x$1096 = $m_s_None$();
  var x$1097 = $m_s_None$();
  var x$1098 = $m_s_None$();
  var x$1099 = $m_s_None$();
  var x$1100 = $m_s_None$();
  var x$1101 = $m_s_None$();
  var array$44 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://www.w3.org/ns/shacl#minLength", "shacl.minLength", x$1077, x$1078, x$1079, x$1080, x$1081, x$1082, x$1083, x$1084, x$1085, x$1086, x$1087, x$1088, x$1089, x$1090, x$1091, x$1092, x$1093, x$1094, x$1095, x$1096, x$1097, x$1098, x$1099, x$1100, x$1101, x$1076)];
  if (($uI(array$44.length) === 0)) {
    var this$1840 = new $c_scm_ArrayBuffer().init___();
    var x$1107 = this$1840
  } else {
    var b$22 = new $c_scm_ArrayBuffer().init___();
    var n$44 = $uI(array$44.length);
    var n$45 = ((b$22.size0$6 + n$44) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$22, n$45);
    var xs$22 = b$22.array$6;
    var start$22 = b$22.size0$6;
    var i$44 = 0;
    var j$22 = start$22;
    var x$736 = $uI(array$44.length);
    var x$754 = ((x$736 < n$44) ? x$736 : n$44);
    var that$22 = ((xs$22.u.length - start$22) | 0);
    var end$22 = ((x$754 < that$22) ? x$754 : that$22);
    while ((i$44 < end$22)) {
      var jsx$44 = j$22;
      var index$44 = i$44;
      xs$22.set(jsx$44, array$44[index$44]);
      i$44 = ((1 + i$44) | 0);
      j$22 = ((1 + j$22) | 0)
    };
    b$22.size0$6 = ((b$22.size0$6 + n$44) | 0);
    var x$1107 = b$22
  };
  var x$1108 = new $c_s_Some().init___O("minMaxLengthValidation");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1852 = new $c_scm_ListBuffer().init___();
  var x$1109 = this$1852.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1856 = new $c_scm_ListBuffer().init___();
  var x$1110 = this$1856.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1860 = new $c_scm_ListBuffer().init___();
  var x$1111 = this$1860.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1864 = new $c_scm_ListBuffer().init___();
  var x$1112 = this$1864.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1868 = new $c_scm_ListBuffer().init___();
  var x$1113 = this$1868.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1114 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1873 = new $c_scm_ListBuffer().init___();
  var x$1115 = this$1873.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1116 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1117 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1118 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1119 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1120 = $m_s_None$();
  var array$45 = [new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#min-max-length", "MaxItems must be greater than or equal to minItems", x$1104, x$1105, x$1109, x$1106, x$1110, x$1111, x$1112, x$1113, x$1114, x$1107, x$1115, x$1116, x$1117, x$1118, x$1119, x$1108, x$1120)];
  var i$45 = (((-1) + $uI(array$45.length)) | 0);
  var result$22 = $m_sci_Nil$();
  while ((i$45 >= 0)) {
    var this$1882 = result$22;
    var index$45 = i$45;
    var x$755 = array$45[index$45];
    result$22 = new $c_sci_$colon$colon().init___O__sci_List(x$755, this$1882);
    i$45 = (((-1) + i$45) | 0)
  };
  this.minMaxLengthValidation$1 = result$22;
  $m_sci_List$();
  var x$1151 = new $c_s_Some().init___O("MaxProperties must be greater than or equal to minProperties");
  var x$1152 = new $c_s_Some().init___O("MaxProperties must be greater than or equal to minProperties");
  $m_sci_List$();
  var array$46 = ["http://www.w3.org/ns/shacl#NodeShape"];
  var i$46 = (((-1) + $uI(array$46.length)) | 0);
  var result$23 = $m_sci_Nil$();
  while ((i$46 >= 0)) {
    var this$1886 = result$23;
    var index$46 = i$46;
    var x$773 = array$46[index$46];
    result$23 = new $c_sci_$colon$colon().init___O__sci_List(x$773, this$1886);
    i$46 = (((-1) + i$46) | 0)
  };
  var x$1153 = result$23;
  $m_scm_ArrayBuffer$();
  var x$1123 = new $c_s_Some().init___O("http://a.ml/vocabularies/shapes#maxProperties");
  var x$1124 = $m_s_None$();
  var x$1125 = $m_s_None$();
  var x$1126 = $m_s_None$();
  var x$1127 = $m_s_None$();
  var x$1128 = $m_s_None$();
  var x$1129 = $m_s_None$();
  var x$1130 = $m_s_None$();
  var x$1131 = $m_s_None$();
  var x$1132 = $m_s_None$();
  var x$1133 = $m_s_None$();
  var x$1134 = $m_s_None$();
  var x$1135 = $m_s_None$();
  var x$1136 = $m_s_None$();
  var x$1137 = $m_s_None$();
  var x$1138 = $m_s_None$();
  var x$1139 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1906 = new $c_scm_ListBuffer().init___();
  var x$1140 = this$1906.toList__sci_List();
  var x$1141 = $m_s_None$();
  var x$1142 = $m_s_None$();
  var x$1143 = $m_s_None$();
  var x$1144 = $m_s_None$();
  var x$1145 = $m_s_None$();
  var x$1146 = $m_s_None$();
  var x$1147 = $m_s_None$();
  var x$1148 = $m_s_None$();
  var array$47 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/shapes#minProperties", "shapes.minProperties", x$1124, x$1125, x$1126, x$1127, x$1128, x$1129, x$1130, x$1131, x$1132, x$1133, x$1134, x$1135, x$1136, x$1137, x$1138, x$1139, x$1140, x$1141, x$1142, x$1143, x$1144, x$1145, x$1146, x$1147, x$1148, x$1123)];
  if (($uI(array$47.length) === 0)) {
    var this$1918 = new $c_scm_ArrayBuffer().init___();
    var x$1154 = this$1918
  } else {
    var b$23 = new $c_scm_ArrayBuffer().init___();
    var n$46 = $uI(array$47.length);
    var n$47 = ((b$23.size0$6 + n$46) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(b$23, n$47);
    var xs$23 = b$23.array$6;
    var start$23 = b$23.size0$6;
    var i$47 = 0;
    var j$23 = start$23;
    var x$774 = $uI(array$47.length);
    var x$792 = ((x$774 < n$46) ? x$774 : n$46);
    var that$23 = ((xs$23.u.length - start$23) | 0);
    var end$23 = ((x$792 < that$23) ? x$792 : that$23);
    while ((i$47 < end$23)) {
      var jsx$45 = j$23;
      var index$47 = i$47;
      xs$23.set(jsx$45, array$47[index$47]);
      i$47 = ((1 + i$47) | 0);
      j$23 = ((1 + j$23) | 0)
    };
    b$23.size0$6 = ((b$23.size0$6 + n$46) | 0);
    var x$1154 = b$23
  };
  var x$1155 = new $c_s_Some().init___O("minMaxPropertiesValidation");
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1930 = new $c_scm_ListBuffer().init___();
  var x$1156 = this$1930.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1934 = new $c_scm_ListBuffer().init___();
  var x$1157 = this$1934.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1938 = new $c_scm_ListBuffer().init___();
  var x$1158 = this$1938.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1942 = new $c_scm_ListBuffer().init___();
  var x$1159 = this$1942.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1946 = new $c_scm_ListBuffer().init___();
  var x$1160 = this$1946.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1161 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$1951 = new $c_scm_ListBuffer().init___();
  var x$1162 = this$1951.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1163 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1164 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1165 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1166 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$1167 = $m_s_None$();
  var array$48 = [new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option("http://a.ml/vocabularies/amf/parser#min-max-properties", "MaxProperties must be greater than or equal to minProperties", x$1151, x$1152, x$1156, x$1153, x$1157, x$1158, x$1159, x$1160, x$1161, x$1154, x$1162, x$1163, x$1164, x$1165, x$1166, x$1155, x$1167)];
  var i$48 = (((-1) + $uI(array$48.length)) | 0);
  var result$24 = $m_sci_Nil$();
  while ((i$48 >= 0)) {
    var this$1960 = result$24;
    var index$48 = i$48;
    var x$793 = array$48[index$48];
    result$24 = new $c_sci_$colon$colon().init___O__sci_List(x$793, this$1960);
    i$48 = (((-1) + i$48) | 0)
  };
  this.minMaxPropertiesValidation$1 = result$24;
  var y = this.xmlWrappedScalar$1;
  var jsx$53 = new $c_T2().init___O__O("xmlWrappedScalar", y);
  var y$1 = this.xmlNonScalarAttribute$1;
  var jsx$52 = new $c_T2().init___O__O("xmlNonScalarAttribute", y$1);
  var y$2 = this.fileParameterMustBeInFormData$1;
  var jsx$51 = new $c_T2().init___O__O("fileParameterMustBeInFormData", y$2);
  var y$3 = this.pathParameterRequiredProperty$1;
  var jsx$50 = new $c_T2().init___O__O("pathParameterRequiredProperty", y$3);
  var y$4 = this.exampleMutuallyExclusiveFields$1;
  var jsx$49 = new $c_T2().init___O__O("exampleMutuallyExclusiveFields", y$4);
  var y$5 = this.minimumMaximumValidation$1;
  var jsx$48 = new $c_T2().init___O__O("minimumMaximumValidation", y$5);
  var y$6 = this.minMaxItemsValidation$1;
  var jsx$47 = new $c_T2().init___O__O("minMaxItemsValidation", y$6);
  var y$7 = this.minMaxLengthValidation$1;
  var jsx$46 = new $c_T2().init___O__O("minMaxLengthValidation", y$7);
  var y$8 = this.minMaxPropertiesValidation$1;
  var array$49 = [jsx$53, jsx$52, jsx$51, jsx$50, jsx$49, jsx$48, jsx$47, jsx$46, new $c_T2().init___O__O("minMaxPropertiesValidation", y$8)];
  var this$1982 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i$49 = 0;
  var len = $uI(array$49.length);
  while ((i$49 < len)) {
    var index$49 = i$49;
    var arg1 = array$49[index$49];
    this$1982.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i$49 = ((1 + i$49) | 0)
  };
  this.defintions$1 = $as_sci_Map(this$1982.elems$1);
  return this
});
var $d_Lamf_plugins_document_webapi_validation_complexShaclCustomValidations$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_complexShaclCustomValidations$: 0
}, false, "amf.plugins.document.webapi.validation.complexShaclCustomValidations$", {
  Lamf_plugins_document_webapi_validation_complexShaclCustomValidations$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_validation_complexShaclCustomValidations$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_complexShaclCustomValidations$;
var $n_Lamf_plugins_document_webapi_validation_complexShaclCustomValidations$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_complexShaclCustomValidations$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_complexShaclCustomValidations$)) {
    $n_Lamf_plugins_document_webapi_validation_complexShaclCustomValidations$ = new $c_Lamf_plugins_document_webapi_validation_complexShaclCustomValidations$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_complexShaclCustomValidations$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_remote_AjvValidator$() {
  $c_O.call(this);
  this.options$1 = null;
  this.fastOptions$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_remote_AjvValidator$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_remote_AjvValidator$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_remote_AjvValidator$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_remote_AjvValidator$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_remote_AjvValidator$.prototype = $c_Lamf_plugins_document_webapi_validation_remote_AjvValidator$.prototype;
$c_Lamf_plugins_document_webapi_validation_remote_AjvValidator$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_remote_AjvValidator$.prototype.options__p1__sjs_js_Object = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.options$lzycompute__p1__sjs_js_Object() : this.options$1)
});
$c_Lamf_plugins_document_webapi_validation_remote_AjvValidator$.prototype.nativeAjv__sjs_js_Dynamic = (function() {
  var v = $g.Ajv;
  if ((v === (void 0))) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Cannot find global Ajv object"))
  } else {
    return $g.Ajv
  }
});
$c_Lamf_plugins_document_webapi_validation_remote_AjvValidator$.prototype.options$lzycompute__p1__sjs_js_Object = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.options$1 = $g.JSON.parse("{\"schemaId\":\"auto\", \"unknownFormats\": \"ignore\", \"allErrors\": true, \"validateSchema\": false, \"multipleOfPrecision\": 6}");
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.options$1
});
$c_Lamf_plugins_document_webapi_validation_remote_AjvValidator$.prototype.fast__Lamf_plugins_document_webapi_validation_remote_Ajv = (function() {
  var ajv = new (this.nativeAjv__sjs_js_Dynamic())(this.fastOptions__p1__sjs_js_Object()).addMetaSchema($m_Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$().instance__sjs_js_Object());
  return this.setValidators__p1__Lamf_plugins_document_webapi_validation_remote_Ajv__Lamf_plugins_document_webapi_validation_remote_Ajv(ajv)
});
$c_Lamf_plugins_document_webapi_validation_remote_AjvValidator$.prototype.setValidators__p1__Lamf_plugins_document_webapi_validation_remote_Ajv__Lamf_plugins_document_webapi_validation_remote_Ajv = (function(ajv) {
  return ajv.addFormat("RFC2616", "^(Mon|Tue|Wed|Thu|Fri|Sat|Sun), (0[1-9]|[12][0-9]|3[01]) (Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) ([0-9]{4}) ([01][0-9]|2[0-3]):([0-5][0-9]):([0-5][0-9]|60) (GMT)$").addFormat("rfc2616", "^(Mon|Tue|Wed|Thu|Fri|Sat|Sun), (0[1-9]|[12][0-9]|3[01]) (Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) ([0-9]{4}) ([01][0-9]|2[0-3]):([0-5][0-9]):([0-5][0-9]|60) (GMT)$").addFormat("date-time-only", "^([0-9]+)-(0[1-9]|1[012])-(0[1-9]|[12][0-9]|3[01])[Tt]([01][0-9]|2[0-3]):([0-5][0-9]):([0-5][0-9]|60)(\\.[0-9]+)?$").addFormat("date", "^([0-9]+)-(0[1-9]|1[012])-(0[1-9]|[12][0-9]|3[01])$")
});
$c_Lamf_plugins_document_webapi_validation_remote_AjvValidator$.prototype.fastOptions$lzycompute__p1__sjs_js_Object = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.fastOptions$1 = $g.JSON.parse("{\"schemaId\":\"auto\", \"unknownFormats\": \"ignore\", \"allErrors\": false, \"validateSchema\": false, \"multipleOfPrecision\": 6}");
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.fastOptions$1
});
$c_Lamf_plugins_document_webapi_validation_remote_AjvValidator$.prototype.apply__Lamf_plugins_document_webapi_validation_remote_Ajv = (function() {
  var ajv = new (this.nativeAjv__sjs_js_Dynamic())(this.options__p1__sjs_js_Object()).addMetaSchema($m_Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$().instance__sjs_js_Object());
  return this.setValidators__p1__Lamf_plugins_document_webapi_validation_remote_Ajv__Lamf_plugins_document_webapi_validation_remote_Ajv(ajv)
});
$c_Lamf_plugins_document_webapi_validation_remote_AjvValidator$.prototype.fastOptions__p1__sjs_js_Object = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.fastOptions$lzycompute__p1__sjs_js_Object() : this.fastOptions$1)
});
var $d_Lamf_plugins_document_webapi_validation_remote_AjvValidator$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_remote_AjvValidator$: 0
}, false, "amf.plugins.document.webapi.validation.remote.AjvValidator$", {
  Lamf_plugins_document_webapi_validation_remote_AjvValidator$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_validation_remote_AjvValidator$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_remote_AjvValidator$;
var $n_Lamf_plugins_document_webapi_validation_remote_AjvValidator$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_remote_AjvValidator$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_remote_AjvValidator$)) {
    $n_Lamf_plugins_document_webapi_validation_remote_AjvValidator$ = new $c_Lamf_plugins_document_webapi_validation_remote_AjvValidator$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_remote_AjvValidator$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$() {
  $c_O.call(this);
  this.instance$1 = null;
  this.text$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$.prototype = $c_Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$.prototype;
$c_Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$.prototype.init___ = (function() {
  this.text$1 = "{\"id\":\"http://json-schema.org/draft-04/schema#\",\"$schema\":\"http://json-schema.org/draft-04/schema#\",\"description\":\"Core schema meta-schema\",\"definitions\":{\"schemaArray\":{\"type\":\"array\",\"minItems\":1,\"items\":{\"$ref\":\"#\"}},\"positiveInteger\":{\"type\":\"integer\",\"minimum\":0},\"positiveIntegerDefault0\":{\"allOf\":[{\"$ref\":\"#/definitions/positiveInteger\"},{\"default\":0}]},\"simpleTypes\":{\"enum\":[\"array\",\"boolean\",\"integer\",\"null\",\"number\",\"object\",\"string\"]},\"stringArray\":{\"type\":\"array\",\"items\":{\"type\":\"string\"},\"minItems\":1,\"uniqueItems\":true}},\"type\":\"object\",\"properties\":{\"id\":{\"type\":\"string\",\"format\":\"uri\"},\"$schema\":{\"type\":\"string\",\"format\":\"uri\"},\"title\":{\"type\":\"string\"},\"description\":{\"type\":\"string\"},\"default\":{},\"multipleOf\":{\"type\":\"number\",\"minimum\":0,\"exclusiveMinimum\":true},\"maximum\":{\"type\":\"number\"},\"exclusiveMaximum\":{\"type\":\"boolean\",\"default\":false},\"minimum\":{\"type\":\"number\"},\"exclusiveMinimum\":{\"type\":\"boolean\",\"default\":false},\"maxLength\":{\"$ref\":\"#/definitions/positiveInteger\"},\"minLength\":{\"$ref\":\"#/definitions/positiveIntegerDefault0\"},\"pattern\":{\"type\":\"string\",\"format\":\"regex\"},\"additionalItems\":{\"anyOf\":[{\"type\":\"boolean\"},{\"$ref\":\"#\"}],\"default\":{}},\"items\":{\"anyOf\":[{\"$ref\":\"#\"},{\"$ref\":\"#/definitions/schemaArray\"}],\"default\":{}},\"maxItems\":{\"$ref\":\"#/definitions/positiveInteger\"},\"minItems\":{\"$ref\":\"#/definitions/positiveIntegerDefault0\"},\"uniqueItems\":{\"type\":\"boolean\",\"default\":false},\"maxProperties\":{\"$ref\":\"#/definitions/positiveInteger\"},\"minProperties\":{\"$ref\":\"#/definitions/positiveIntegerDefault0\"},\"required\":{\"$ref\":\"#/definitions/stringArray\"},\"additionalProperties\":{\"anyOf\":[{\"type\":\"boolean\"},{\"$ref\":\"#\"}],\"default\":{}},\"definitions\":{\"type\":\"object\",\"additionalProperties\":{\"$ref\":\"#\"},\"default\":{}},\"properties\":{\"type\":\"object\",\"additionalProperties\":{\"$ref\":\"#\"},\"default\":{}},\"patternProperties\":{\"type\":\"object\",\"additionalProperties\":{\"$ref\":\"#\"},\"default\":{}},\"dependencies\":{\"type\":\"object\",\"additionalProperties\":{\"anyOf\":[{\"$ref\":\"#\"},{\"$ref\":\"#/definitions/stringArray\"}]}},\"enum\":{\"type\":\"array\",\"minItems\":1,\"uniqueItems\":true},\"type\":{\"anyOf\":[{\"$ref\":\"#/definitions/simpleTypes\"},{\"type\":\"array\",\"items\":{\"$ref\":\"#/definitions/simpleTypes\"},\"minItems\":1,\"uniqueItems\":true}]},\"allOf\":{\"$ref\":\"#/definitions/schemaArray\"},\"anyOf\":{\"$ref\":\"#/definitions/schemaArray\"},\"oneOf\":{\"$ref\":\"#/definitions/schemaArray\"},\"not\":{\"$ref\":\"#\"}},\"dependencies\":{\"exclusiveMaximum\":[\"maximum\"],\"exclusiveMinimum\":[\"minimum\"]},\"default\":{}}";
  return this
});
$c_Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$.prototype.instance__sjs_js_Object = (function() {
  return ((!this.bitmap$0$1) ? this.instance$lzycompute__p1__sjs_js_Object() : this.instance$1)
});
$c_Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$.prototype.instance$lzycompute__p1__sjs_js_Object = (function() {
  if ((!this.bitmap$0$1)) {
    this.instance$1 = $g.JSON.parse(this.text$1);
    this.bitmap$0$1 = true
  };
  return this.instance$1
});
var $d_Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$: 0
}, false, "amf.plugins.document.webapi.validation.remote.Draft4MetaSchema$", {
  Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$;
var $n_Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$)) {
    $n_Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$ = new $c_Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_remote_Draft4MetaSchema$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_remote_LazyAjv$() {
  $c_O.call(this);
  this.default$1 = null;
  this.fast$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_remote_LazyAjv$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_remote_LazyAjv$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_remote_LazyAjv$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_remote_LazyAjv$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_remote_LazyAjv$.prototype = $c_Lamf_plugins_document_webapi_validation_remote_LazyAjv$.prototype;
$c_Lamf_plugins_document_webapi_validation_remote_LazyAjv$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_remote_LazyAjv$.prototype.fast__Lamf_plugins_document_webapi_validation_remote_Ajv = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.fast$lzycompute__p1__Lamf_plugins_document_webapi_validation_remote_Ajv() : this.fast$1)
});
$c_Lamf_plugins_document_webapi_validation_remote_LazyAjv$.prototype.fast$lzycompute__p1__Lamf_plugins_document_webapi_validation_remote_Ajv = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.fast$1 = $m_Lamf_plugins_document_webapi_validation_remote_AjvValidator$().fast__Lamf_plugins_document_webapi_validation_remote_Ajv();
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.fast$1
});
$c_Lamf_plugins_document_webapi_validation_remote_LazyAjv$.prototype.default$lzycompute__p1__Lamf_plugins_document_webapi_validation_remote_Ajv = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.default$1 = $m_Lamf_plugins_document_webapi_validation_remote_AjvValidator$().apply__Lamf_plugins_document_webapi_validation_remote_Ajv();
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.default$1
});
$c_Lamf_plugins_document_webapi_validation_remote_LazyAjv$.prototype.$default__Lamf_plugins_document_webapi_validation_remote_Ajv = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.default$lzycompute__p1__Lamf_plugins_document_webapi_validation_remote_Ajv() : this.default$1)
});
var $d_Lamf_plugins_document_webapi_validation_remote_LazyAjv$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_remote_LazyAjv$: 0
}, false, "amf.plugins.document.webapi.validation.remote.LazyAjv$", {
  Lamf_plugins_document_webapi_validation_remote_LazyAjv$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_validation_remote_LazyAjv$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_remote_LazyAjv$;
var $n_Lamf_plugins_document_webapi_validation_remote_LazyAjv$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_remote_LazyAjv$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_remote_LazyAjv$)) {
    $n_Lamf_plugins_document_webapi_validation_remote_LazyAjv$ = new $c_Lamf_plugins_document_webapi_validation_remote_LazyAjv$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_remote_LazyAjv$
}
function $f_Lamf_plugins_document_webapi_validation_remote_ReportValidationProcessor__processResults__sc_Seq__Lamf_core_validation_AMFValidationReport($thiz, r) {
  return new $c_Lamf_core_validation_AMFValidationReport().init___Z__T__Lamf_ProfileName__sc_Seq((!r.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_validation_AMFValidationResult(x$2$2);
      return (x$2.level$1 === $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1)
    })
  })($thiz)))), "http://test.com/payload#validations", $thiz.profileName$1, r)
}
function $f_Lamf_plugins_document_webapi_validation_remote_ReportValidationProcessor__processCommonException__jl_Throwable__s_Option__sc_Seq($thiz, r, element) {
  if ((r instanceof $c_Lamf_plugins_document_webapi_validation_remote_UnknownDiscriminator)) {
    var x2 = $as_Lamf_plugins_document_webapi_validation_remote_UnknownDiscriminator(r);
    var jsx$1 = $m_sc_Seq$();
    var level = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    if (element.isEmpty__Z()) {
      var this$1 = $m_s_None$()
    } else {
      var arg1 = element.get__O();
      var x$3 = $as_Lamf_core_model_domain_DomainElement(arg1);
      var this$1 = new $c_s_Some().init___O(x$3.id__T())
    };
    var targetNode = $as_T((this$1.isEmpty__Z() ? "" : this$1.get__O()));
    var targetProperty = $m_s_None$();
    var validationId = $m_Lamf_validations_PayloadValidations$().ExampleValidationErrorSpecification$1.id$1;
    if (element.isEmpty__Z()) {
      var position = $m_s_None$()
    } else {
      var arg1$1 = element.get__O();
      var x$4 = $as_Lamf_core_model_domain_DomainElement(arg1$1);
      var position = x$4.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf())
    };
    if (element.isEmpty__Z()) {
      var location = $m_s_None$()
    } else {
      var arg1$2 = element.get__O();
      var x$5 = $as_Lamf_core_model_domain_DomainElement(arg1$2);
      var location = x$5.location__s_Option()
    };
    var array = [new $c_Lamf_core_validation_AMFValidationResult().init___T__T__T__s_Option__T__s_Option__s_Option__O("Unknown discriminator value", level, targetNode, targetProperty, validationId, position, location, x2)];
    return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  } else if ((r instanceof $c_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject)) {
    var x3 = $as_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject(r);
    var jsx$2 = $m_sc_Seq$();
    var level$1 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    if (element.isEmpty__Z()) {
      var this$5 = $m_s_None$()
    } else {
      var arg1$3 = element.get__O();
      var x$6 = $as_Lamf_core_model_domain_DomainElement(arg1$3);
      var this$5 = new $c_s_Some().init___O(x$6.id__T())
    };
    var targetNode$1 = $as_T((this$5.isEmpty__Z() ? "" : this$5.get__O()));
    var targetProperty$1 = $m_s_None$();
    var validationId$1 = $m_Lamf_validations_PayloadValidations$().ExampleValidationErrorSpecification$1.id$1;
    if (element.isEmpty__Z()) {
      var position$1 = $m_s_None$()
    } else {
      var arg1$4 = element.get__O();
      var x$7 = $as_Lamf_core_model_domain_DomainElement(arg1$4);
      var position$1 = x$7.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf())
    };
    if (element.isEmpty__Z()) {
      var location$1 = $m_s_None$()
    } else {
      var arg1$5 = element.get__O();
      var x$8 = $as_Lamf_core_model_domain_DomainElement(arg1$5);
      var location$1 = x$8.location__s_Option()
    };
    var array$1 = [new $c_Lamf_core_validation_AMFValidationResult().init___T__T__T__s_Option__T__s_Option__s_Option__O("Unsupported chars in string value (probably a binary file)", level$1, targetNode$1, targetProperty$1, validationId$1, position$1, location$1, x3)];
    return $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)))
  } else {
    return $m_sci_Nil$()
  }
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$.prototype = $c_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$.prototype;
$c_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$.prototype.unionWithString__p1__Lamf_core_model_domain_Shape__Z = (function(shape) {
  if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_UnionShape(shape);
    return $as_sc_Seq(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1)).exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(shape$2$2) {
        var shape$2 = $as_Lamf_core_model_domain_Shape(shape$2$2);
        return $m_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$().isString__p1__Lamf_core_model_domain_Shape__Z(shape$2)
      })
    })(this)))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$.prototype.isString__p1__Lamf_core_model_domain_Shape__Z = (function(shape) {
  if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(shape);
    var this$1 = $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1)).option$1;
    if ((!this$1.isEmpty__Z())) {
      var arg1 = this$1.get__O();
      var x$5 = $as_T(arg1);
      var that = $m_Lamf_core_model_DataType$().String$1;
      return (x$5 === that)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$.prototype.apply__Lamf_core_model_document_PayloadFragment__Lamf_core_model_domain_Shape__Lamf_core_model_document_PayloadFragment = (function(fragment, shape) {
  if ((this.isString__p1__Lamf_core_model_domain_Shape__Z(shape) || this.unionWithString__p1__Lamf_core_model_domain_Shape__Z(shape))) {
    var x1 = $as_Lamf_core_model_domain_DataNode(fragment.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().Encodes$1));
    if ((x1 instanceof $c_Lamf_core_model_domain_ScalarNode)) {
      var x2 = $as_Lamf_core_model_domain_ScalarNode(x1);
      var this$1 = $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().DataType$1)).option$1;
      if ((!this$1.isEmpty__Z())) {
        var arg1 = this$1.get__O();
        var x$4 = $as_T(arg1);
        var that = $m_Lamf_core_model_DataType$().String$1;
        var jsx$1 = (x$4 === that)
      } else {
        var jsx$1 = false
      };
      if ((!jsx$1)) {
        var jsx$4 = $m_Lamf_core_model_document_PayloadFragment$();
        var jsx$3 = $m_Lamf_core_model_domain_ScalarNode$();
        var this$2 = $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1));
        var this$3 = this$2.option$1;
        var jsx$2 = jsx$3.apply__T__s_Option__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())), new $c_s_Some().init___O($m_Lamf_core_model_DataType$().String$1), x2.annotations$2);
        var this$4 = $as_Lamf_core_model_StrField(fragment.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().MediaType$1));
        var this$5 = this$4.option$1;
        return jsx$4.apply__Lamf_core_model_domain_DataNode__T__Lamf_core_model_document_PayloadFragment(jsx$2, $as_T((this$5.isEmpty__Z() ? null : this$5.get__O())))
      }
    };
    return fragment
  } else {
    return fragment
  }
});
var $d_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$: 0
}, false, "amf.plugins.document.webapi.validation.remote.ScalarPayloadForParam$", {
  Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$;
var $n_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$)) {
    $n_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$ = new $c_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$
}
function $f_Lamf_plugins_document_webapi_validation_runner_steps_ValidationStep__run__Lamf_plugins_document_webapi_validation_runner_ResultContainer__s_concurrent_ExecutionContext__s_concurrent_Future($thiz, previous, executionContext) {
  return $thiz.validate__s_concurrent_Future().map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, previous$1) {
    return (function(nrc$2) {
      var nrc = $as_sc_Seq(nrc$2);
      var jsx$1 = previous$1.results$1;
      var this$1 = $m_sc_Seq$();
      return new $c_Lamf_plugins_document_webapi_validation_runner_ResultContainer().init___sc_Seq($as_sc_Seq(jsx$1.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(nrc, this$1.ReusableCBFInstance$2)))
    })
  })($thiz, previous)), executionContext)
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$() {
  $c_O.call(this);
  this.webapi$1 = null;
  this.documentationItem$1 = null;
  this.endpoint$1 = null;
  this.operation$1 = null;
  this.response$1 = null;
  this.request$1 = null;
  this.payload$1 = null;
  this.shape$1 = null;
  this.example$1 = null;
  this.resourceType$1 = null;
  this.trait$1 = null;
  this.securityScheme$1 = null;
  this.securitySettings$1 = null;
  this.customDomainProperty$1 = null;
  this.library$1 = null;
  this.overlay$1 = null;
  this.extension$1 = null;
  this.uriToRaml$1 = null;
  this.ramlToUri$1 = null
}
$c_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$.prototype.constructor = $c_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$.prototype = $c_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$.prototype;
$c_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$ = this;
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.webapi$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "WebAPI").iri__T();
  var this$3 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.documentationItem$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "DocumentationItem").iri__T();
  var this$5 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.endpoint$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$5, "EndPoint").iri__T();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.operation$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "Operation").iri__T();
  var this$9 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.response$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$9, "Response").iri__T();
  var this$11 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.request$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$11, "Request").iri__T();
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.payload$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "Payload").iri__T();
  var this$15 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.shape$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$15, "Shape").iri__T();
  var this$17 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.example$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$17, "Example").iri__T();
  var this$19 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.resourceType$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$19, "ResourceType").iri__T();
  var this$21 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.trait$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$21, "Trait").iri__T();
  var this$23 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.securityScheme$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$23, "SecurityScheme").iri__T();
  var this$25 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.securitySettings$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$25, "SecuritySettings").iri__T();
  var this$27 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  this.customDomainProperty$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$27, "CustomDomainProperty").iri__T();
  var this$29 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  this.library$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$29, "Module").iri__T();
  var this$31 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  this.overlay$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$31, "AbstractDocument").iri__T();
  var this$33 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  this.extension$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$33, "PartialDocument").iri__T();
  var self = this.webapi$1;
  var jsx$16 = new $c_T2().init___O__O(self, "API");
  var self$1 = this.documentationItem$1;
  var jsx$15 = new $c_T2().init___O__O(self$1, "DocumentationItem");
  var self$2 = this.endpoint$1;
  var jsx$14 = new $c_T2().init___O__O(self$2, "Resource");
  var self$3 = this.operation$1;
  var jsx$13 = new $c_T2().init___O__O(self$3, "Method");
  var self$4 = this.response$1;
  var jsx$12 = new $c_T2().init___O__O(self$4, "Response");
  var self$5 = this.request$1;
  var jsx$11 = new $c_T2().init___O__O(self$5, "RequestBody");
  var self$6 = this.payload$1;
  var jsx$10 = new $c_T2().init___O__O(self$6, "ResponseBody");
  var self$7 = this.shape$1;
  var jsx$9 = new $c_T2().init___O__O(self$7, "TypeDeclaration");
  var self$8 = this.example$1;
  var jsx$8 = new $c_T2().init___O__O(self$8, "Example");
  var self$9 = this.resourceType$1;
  var jsx$7 = new $c_T2().init___O__O(self$9, "ResourceType");
  var self$10 = this.trait$1;
  var jsx$6 = new $c_T2().init___O__O(self$10, "Trait");
  var self$11 = this.securityScheme$1;
  var jsx$5 = new $c_T2().init___O__O(self$11, "SecurityScheme");
  var self$12 = this.securitySettings$1;
  var jsx$4 = new $c_T2().init___O__O(self$12, "SecuritySchemeSettings");
  var self$13 = this.customDomainProperty$1;
  var jsx$3 = new $c_T2().init___O__O(self$13, "AnnotationType");
  var self$14 = this.library$1;
  var jsx$2 = new $c_T2().init___O__O(self$14, "Library");
  var self$15 = this.overlay$1;
  var jsx$1 = new $c_T2().init___O__O(self$15, "Overlay");
  var self$16 = this.extension$1;
  var array = [jsx$16, jsx$15, jsx$14, jsx$13, jsx$12, jsx$11, jsx$10, jsx$9, jsx$8, jsx$7, jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, jsx$1, new $c_T2().init___O__O(self$16, "Extension")];
  var this$72 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$72.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  this.uriToRaml$1 = $as_sci_Map(this$72.elems$1);
  var this$76 = this.uriToRaml$1;
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var k = $as_T(x0$1.$$und1__O());
        var v = $as_T(x0$1.$$und2__O());
        return new $c_T2().init___O__O(v, k)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this));
  var this$75 = $m_sci_Map$();
  var bf = new $c_scg_GenMapFactory$MapCanBuildFrom().init___scg_GenMapFactory(this$75);
  this.ramlToUri$1 = $as_sci_Map($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$76, f, bf));
  return this
});
var $d_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$: 0
}, false, "amf.plugins.document.webapi.vocabulary.VocabularyMappings$", {
  Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$.prototype.$classData = $d_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$;
var $n_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$ = (void 0);
function $m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$() {
  if ((!$n_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$)) {
    $n_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$ = new $c_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().init___()
  };
  return $n_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$
}
/** @constructor */
function $c_Lamf_plugins_domain_VocabulariesRegister$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_VocabulariesRegister$.prototype = new $h_O();
$c_Lamf_plugins_domain_VocabulariesRegister$.prototype.constructor = $c_Lamf_plugins_domain_VocabulariesRegister$;
/** @constructor */
function $h_Lamf_plugins_domain_VocabulariesRegister$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_VocabulariesRegister$.prototype = $c_Lamf_plugins_domain_VocabulariesRegister$.prototype;
$c_Lamf_plugins_domain_VocabulariesRegister$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_VocabulariesRegister$.prototype.register__Lamf_core_remote_Platform__V = (function(platform) {
  var p = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2) {
      var x = $as_Lamf_core_metamodel_Obj(x$2);
      return (x instanceof $c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel)
    })
  })(this));
  var builder = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_domain_AmfObject(x0$1$2);
      if ((x0$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
        var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x0$1);
        return new $c_Lamf_client_model_domain_DialectDomainElement().init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this));
  platform.wrappersRegistryFn__scm_HashMap().put__O__O__s_Option(p, builder);
  var model = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$();
  var builder$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3) {
    return (function(x0$2$2) {
      var x0$2 = $as_Lamf_core_model_domain_AmfObject(x0$2$2);
      if ((x0$2 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm)) {
        var x2$1 = $as_Lamf_plugins_document_vocabularies_model_domain_ClassTerm(x0$2);
        return new $c_Lamf_client_model_domain_ClassTerm().init___Lamf_plugins_document_vocabularies_model_domain_ClassTerm(x2$1)
      } else {
        throw new $c_s_MatchError().init___O(x0$2)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model, builder$1);
  var model$1 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$();
  var builder$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4) {
    return (function(x0$3$2) {
      var x0$3 = $as_Lamf_core_model_domain_AmfObject(x0$3$2);
      if ((x0$3 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_External)) {
        var x2$2 = $as_Lamf_plugins_document_vocabularies_model_domain_External(x0$3);
        return new $c_Lamf_client_model_domain_External().init___Lamf_plugins_document_vocabularies_model_domain_External(x2$2)
      } else {
        throw new $c_s_MatchError().init___O(x0$3)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$1, builder$2);
  var model$2 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$();
  var builder$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5) {
    return (function(x0$4$2) {
      var x0$4 = $as_Lamf_core_model_domain_AmfObject(x0$4$2);
      if ((x0$4 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
        var x2$3 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x0$4);
        return new $c_Lamf_client_model_domain_NodeMapping().init___Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x2$3)
      } else {
        throw new $c_s_MatchError().init___O(x0$4)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$2, builder$3);
  var model$3 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$();
  var builder$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6) {
    return (function(x0$5$2) {
      var x0$5 = $as_Lamf_core_model_domain_AmfObject(x0$5$2);
      if ((x0$5 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping)) {
        var x2$4 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x0$5);
        return new $c_Lamf_client_model_domain_PropertyMapping().init___Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x2$4)
      } else {
        throw new $c_s_MatchError().init___O(x0$5)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$3, builder$4);
  var model$4 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$();
  var builder$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$7) {
    return (function(x0$6$2) {
      var x0$6 = $as_Lamf_core_model_domain_AmfObject(x0$6$2);
      if ((x0$6 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm)) {
        var x2$5 = $as_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm(x0$6);
        return new $c_Lamf_client_model_domain_ObjectPropertyTerm().init___Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm(x2$5)
      } else {
        throw new $c_s_MatchError().init___O(x0$6)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$4, builder$5);
  var model$5 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$();
  var builder$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$8) {
    return (function(x0$7$2) {
      var x0$7 = $as_Lamf_core_model_domain_AmfObject(x0$7$2);
      if ((x0$7 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping)) {
        var x2$6 = $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(x0$7);
        return new $c_Lamf_client_model_domain_UnionNodeMapping().init___Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(x2$6)
      } else {
        throw new $c_s_MatchError().init___O(x0$7)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$5, builder$6);
  var model$6 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$();
  var builder$7 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$9) {
    return (function(x0$8$2) {
      var x0$8 = $as_Lamf_core_model_domain_AmfObject(x0$8$2);
      if ((x0$8 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm)) {
        var x2$7 = $as_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm(x0$8);
        return new $c_Lamf_client_model_domain_DatatypePropertyTerm().init___Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm(x2$7)
      } else {
        throw new $c_s_MatchError().init___O(x0$8)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$6, builder$7);
  var model$7 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$();
  var builder$8 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$10) {
    return (function(x0$9$2) {
      var x0$9 = $as_Lamf_core_model_domain_AmfObject(x0$9$2);
      if ((x0$9 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping)) {
        var x2$8 = $as_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping(x0$9);
        return new $c_Lamf_client_model_domain_PublicNodeMapping().init___Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping(x2$8)
      } else {
        throw new $c_s_MatchError().init___O(x0$9)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$7, builder$8);
  var model$8 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$();
  var builder$9 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$11) {
    return (function(x0$10$2) {
      var x0$10 = $as_Lamf_core_model_domain_AmfObject(x0$10$2);
      if ((x0$10 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping)) {
        var x2$9 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(x0$10);
        return new $c_Lamf_client_model_domain_DocumentMapping().init___Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(x2$9)
      } else {
        throw new $c_s_MatchError().init___O(x0$10)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$8, builder$9);
  var model$9 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$();
  var builder$10 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$12) {
    return (function(x0$11$2) {
      var x0$11 = $as_Lamf_core_model_domain_AmfObject(x0$11$2);
      if ((x0$11 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel)) {
        var x2$10 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(x0$11);
        return new $c_Lamf_client_model_domain_DocumentsModel().init___Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(x2$10)
      } else {
        throw new $c_s_MatchError().init___O(x0$11)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$9, builder$10);
  var model$10 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$();
  var builder$11 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$13) {
    return (function(x0$12$2) {
      var x0$12 = $as_Lamf_core_model_domain_AmfObject(x0$12$2);
      if ((x0$12 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference)) {
        var x2$11 = $as_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference(x0$12);
        return new $c_Lamf_client_model_domain_VocabularyReference().init___Lamf_plugins_document_vocabularies_model_domain_VocabularyReference(x2$11)
      } else {
        throw new $c_s_MatchError().init___O(x0$12)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$10, builder$11);
  var model$11 = $m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$();
  var builder$12 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$14) {
    return (function(x0$13$2) {
      var x0$13 = $as_Lamf_core_model_domain_AmfObject(x0$13$2);
      if ((x0$13 instanceof $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary)) {
        var x2$12 = $as_Lamf_plugins_document_vocabularies_model_document_Vocabulary(x0$13);
        return new $c_Lamf_client_model_document_Vocabulary().init___Lamf_plugins_document_vocabularies_model_document_Vocabulary(x2$12)
      } else {
        throw new $c_s_MatchError().init___O(x0$13)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$11, builder$12);
  var model$12 = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$();
  var builder$13 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$15) {
    return (function(x0$14$2) {
      var x0$14 = $as_Lamf_core_model_domain_AmfObject(x0$14$2);
      if ((x0$14 instanceof $c_Lamf_plugins_document_vocabularies_model_document_Dialect)) {
        var x2$13 = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(x0$14);
        return new $c_Lamf_client_model_document_Dialect().init___Lamf_plugins_document_vocabularies_model_document_Dialect(x2$13)
      } else {
        throw new $c_s_MatchError().init___O(x0$14)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$12, builder$13);
  var model$13 = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$();
  var builder$14 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$16) {
    return (function(x0$15$2) {
      var x0$15 = $as_Lamf_core_model_domain_AmfObject(x0$15$2);
      if ((x0$15 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectFragment)) {
        var x2$14 = $as_Lamf_plugins_document_vocabularies_model_document_DialectFragment(x0$15);
        return new $c_Lamf_client_model_document_DialectFragment().init___Lamf_plugins_document_vocabularies_model_document_DialectFragment(x2$14)
      } else {
        throw new $c_s_MatchError().init___O(x0$15)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$13, builder$14);
  var model$14 = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$();
  var builder$15 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$17) {
    return (function(x0$16$2) {
      var x0$16 = $as_Lamf_core_model_domain_AmfObject(x0$16$2);
      if ((x0$16 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary)) {
        var x2$15 = $as_Lamf_plugins_document_vocabularies_model_document_DialectLibrary(x0$16);
        return new $c_Lamf_client_model_document_DialectLibrary().init___Lamf_plugins_document_vocabularies_model_document_DialectLibrary(x2$15)
      } else {
        throw new $c_s_MatchError().init___O(x0$16)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$14, builder$15);
  var model$15 = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$();
  var builder$16 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$18) {
    return (function(x0$17$2) {
      var x0$17 = $as_Lamf_core_model_domain_AmfObject(x0$17$2);
      if ((x0$17 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstance)) {
        var x2$16 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstance(x0$17);
        return new $c_Lamf_client_model_document_DialectInstance().init___Lamf_plugins_document_vocabularies_model_document_DialectInstance(x2$16)
      } else {
        throw new $c_s_MatchError().init___O(x0$17)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$15, builder$16);
  var model$16 = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$();
  var builder$17 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$19) {
    return (function(x0$18$2) {
      var x0$18 = $as_Lamf_core_model_domain_AmfObject(x0$18$2);
      if ((x0$18 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment)) {
        var x2$17 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment(x0$18);
        return new $c_Lamf_client_model_document_DialectInstanceFragment().init___Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment(x2$17)
      } else {
        throw new $c_s_MatchError().init___O(x0$18)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$16, builder$17);
  var model$17 = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$();
  var builder$18 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$20) {
    return (function(x0$19$2) {
      var x0$19 = $as_Lamf_core_model_domain_AmfObject(x0$19$2);
      if ((x0$19 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary)) {
        var x2$18 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary(x0$19);
        return new $c_Lamf_client_model_document_DialectInstanceLibrary().init___Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary(x2$18)
      } else {
        throw new $c_s_MatchError().init___O(x0$19)
      }
    })
  })(this));
  $f_Lamf_core_remote_Platform__registerWrapper__Lamf_core_metamodel_Obj__F1__s_Option(platform, model$17, builder$18);
  $m_Lamf_Core$();
  var plugin = $m_Lamf_plugins_document_vocabularies_AMLPlugin$();
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V(plugin)
});
var $d_Lamf_plugins_domain_VocabulariesRegister$ = new $TypeData().initClass({
  Lamf_plugins_domain_VocabulariesRegister$: 0
}, false, "amf.plugins.domain.VocabulariesRegister$", {
  Lamf_plugins_domain_VocabulariesRegister$: 1,
  O: 1
});
$c_Lamf_plugins_domain_VocabulariesRegister$.prototype.$classData = $d_Lamf_plugins_domain_VocabulariesRegister$;
var $n_Lamf_plugins_domain_VocabulariesRegister$ = (void 0);
function $m_Lamf_plugins_domain_VocabulariesRegister$() {
  if ((!$n_Lamf_plugins_domain_VocabulariesRegister$)) {
    $n_Lamf_plugins_domain_VocabulariesRegister$ = new $c_Lamf_plugins_domain_VocabulariesRegister$().init___()
  };
  return $n_Lamf_plugins_domain_VocabulariesRegister$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_AnyShape$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_AnyShape$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_AnyShape$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_AnyShape$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_AnyShape$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_AnyShape$.prototype = $c_Lamf_plugins_domain_shapes_models_AnyShape$.prototype;
$c_Lamf_plugins_domain_shapes_models_AnyShape$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_models_AnyShape$.prototype.apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_AnyShape = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_shapes_models_AnyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
var $d_Lamf_plugins_domain_shapes_models_AnyShape$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_AnyShape$: 0
}, false, "amf.plugins.domain.shapes.models.AnyShape$", {
  Lamf_plugins_domain_shapes_models_AnyShape$: 1,
  O: 1
});
$c_Lamf_plugins_domain_shapes_models_AnyShape$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_AnyShape$;
var $n_Lamf_plugins_domain_shapes_models_AnyShape$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_AnyShape$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_AnyShape$)) {
    $n_Lamf_plugins_domain_shapes_models_AnyShape$ = new $c_Lamf_plugins_domain_shapes_models_AnyShape$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_AnyShape$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_CreativeWork$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_CreativeWork$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_CreativeWork$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_CreativeWork$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_CreativeWork$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_CreativeWork$.prototype = $c_Lamf_plugins_domain_shapes_models_CreativeWork$.prototype;
$c_Lamf_plugins_domain_shapes_models_CreativeWork$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork$.prototype.apply__Lorg_yaml_model_YNode__Lamf_plugins_domain_shapes_models_CreativeWork = (function(node) {
  var annotations = $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(node);
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_shapes_models_CreativeWork().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
var $d_Lamf_plugins_domain_shapes_models_CreativeWork$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_CreativeWork$: 0
}, false, "amf.plugins.domain.shapes.models.CreativeWork$", {
  Lamf_plugins_domain_shapes_models_CreativeWork$: 1,
  O: 1
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_CreativeWork$;
var $n_Lamf_plugins_domain_shapes_models_CreativeWork$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_CreativeWork$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_CreativeWork$)) {
    $n_Lamf_plugins_domain_shapes_models_CreativeWork$ = new $c_Lamf_plugins_domain_shapes_models_CreativeWork$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_CreativeWork$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_Example$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_Example$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_Example$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_Example$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_Example$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_Example$.prototype = $c_Lamf_plugins_domain_shapes_models_Example$.prototype;
$c_Lamf_plugins_domain_shapes_models_Example$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_models_Example$.prototype.apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_Example = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_shapes_models_Example().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
var $d_Lamf_plugins_domain_shapes_models_Example$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_Example$: 0
}, false, "amf.plugins.domain.shapes.models.Example$", {
  Lamf_plugins_domain_shapes_models_Example$: 1,
  O: 1
});
$c_Lamf_plugins_domain_shapes_models_Example$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_Example$;
var $n_Lamf_plugins_domain_shapes_models_Example$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_Example$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_Example$)) {
    $n_Lamf_plugins_domain_shapes_models_Example$ = new $c_Lamf_plugins_domain_shapes_models_Example$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_Example$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_ExampleTracking$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_ExampleTracking$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_ExampleTracking$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_ExampleTracking$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_ExampleTracking$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_ExampleTracking$.prototype = $c_Lamf_plugins_domain_shapes_models_ExampleTracking$.prototype;
$c_Lamf_plugins_domain_shapes_models_ExampleTracking$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_models_ExampleTracking$.prototype.replaceTracking__Lamf_core_model_domain_Shape__T__T__Lamf_core_model_domain_Shape = (function(shape, newId, mustExistId) {
  if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(shape);
    $as_sc_Seq(x2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, newId$1, mustExistId$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_plugins_domain_shapes_models_Example(x0$1$2);
        if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x0$1).isDefined__Z()) {
          return x0$1.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations($m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracked__T__Lamf_plugins_domain_shapes_models_Example__s_Option__Lamf_core_annotations_TrackedElement(newId$1, x0$1, new $c_s_Some().init___O(mustExistId$1)))
        } else {
          var this$1 = x0$1.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_TrackedElement.getClassOf());
          if (this$1.isEmpty__Z()) {
            var jsx$1 = true
          } else {
            var arg1 = this$1.get__O();
            var x$2 = $as_Lamf_core_annotations_TrackedElement(arg1);
            var jsx$1 = x$2.parents$1.contains__O__Z(mustExistId$1)
          };
          if (jsx$1) {
            var this$2 = this$1
          } else {
            var this$2 = $m_s_None$()
          };
          if ((!this$2.isEmpty__Z())) {
            var arg1$1 = this$2.get__O();
            $as_Lamf_core_annotations_TrackedElement(arg1$1);
            x0$1.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations($m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracked__T__Lamf_plugins_domain_shapes_models_Example__s_Option__Lamf_core_annotations_TrackedElement(newId$1, x0$1, $m_s_None$()))
          };
          return (void 0)
        }
      })
    })(this, newId, mustExistId)))
  };
  return shape
});
$c_Lamf_plugins_domain_shapes_models_ExampleTracking$.prototype.tracked__T__Lamf_plugins_domain_shapes_models_Example__s_Option__Lamf_core_annotations_TrackedElement = (function(parent, e, remove) {
  var this$1 = e.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_TrackedElement.getClassOf());
  if (this$1.isEmpty__Z()) {
    return $m_Lamf_core_annotations_TrackedElement$().apply__T__Lamf_core_annotations_TrackedElement(parent)
  } else {
    var arg1 = this$1.get__O();
    var t = $as_Lamf_core_annotations_TrackedElement(arg1);
    e.annotations$1.reject__F1__Lamf_core_parser_Annotations(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$4$2) {
        var x$4 = $as_Lamf_core_model_domain_Annotation(x$4$2);
        return (x$4 instanceof $c_Lamf_core_annotations_TrackedElement)
      })
    })(this)));
    return new $c_Lamf_core_annotations_TrackedElement().init___sci_Set($as_sci_Set(t.parents$1.$$plus__O__sc_Set(parent).$$minus$minus__sc_GenTraversableOnce__scg_Subtractable(remove.toList__sci_List())))
  }
});
$c_Lamf_plugins_domain_shapes_models_ExampleTracking$.prototype.removeTracking__Lamf_core_model_domain_Shape__T__V = (function(shape, id) {
  if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(shape);
    $as_sc_Seq(x2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, id$1) {
      return (function(e$2) {
        var e = $as_Lamf_plugins_domain_shapes_models_Example(e$2);
        var this$1 = e.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_TrackedElement.getClassOf());
        if ((!this$1.isEmpty__Z())) {
          var arg1 = this$1.get__O();
          var te = $as_Lamf_core_annotations_TrackedElement(arg1);
          e.annotations$1.reject__F1__Lamf_core_parser_Annotations(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
            return (function(x$1$2) {
              var x$1 = $as_Lamf_core_model_domain_Annotation(x$1$2);
              return (x$1 instanceof $c_Lamf_core_annotations_TrackedElement)
            })
          })($this)));
          e.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_TrackedElement().init___sci_Set($as_sci_Set(te.parents$1.$$minus__O__sc_Set(id$1))))
        }
      })
    })(this, id)))
  }
});
$c_Lamf_plugins_domain_shapes_models_ExampleTracking$.prototype.tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape = (function(shape, parent, remove) {
  if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(shape);
    $as_sc_Seq(x2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$1, remove$1) {
      return (function(e$2) {
        var e = $as_Lamf_plugins_domain_shapes_models_Example(e$2);
        return e.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations($m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracked__T__Lamf_plugins_domain_shapes_models_Example__s_Option__Lamf_core_annotations_TrackedElement(parent$1, e, remove$1))
      })
    })(this, parent, remove)))
  };
  return shape
});
var $d_Lamf_plugins_domain_shapes_models_ExampleTracking$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_ExampleTracking$: 0
}, false, "amf.plugins.domain.shapes.models.ExampleTracking$", {
  Lamf_plugins_domain_shapes_models_ExampleTracking$: 1,
  O: 1
});
$c_Lamf_plugins_domain_shapes_models_ExampleTracking$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_ExampleTracking$;
var $n_Lamf_plugins_domain_shapes_models_ExampleTracking$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_ExampleTracking$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_ExampleTracking$)) {
    $n_Lamf_plugins_domain_shapes_models_ExampleTracking$ = new $c_Lamf_plugins_domain_shapes_models_ExampleTracking$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_ExampleTracking$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$.prototype.constructor = $c_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$.prototype = $c_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$.prototype;
$c_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$.prototype.type08Def__T__Lamf_plugins_domain_shapes_models_TypeDef = (function(iri) {
  if ((iri === $m_Lamf_core_model_DataType$().String$1)) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$StrType$()
  } else if ((iri === $m_Lamf_core_model_DataType$().Integer$1)) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$IntType$()
  } else if ((iri === $m_Lamf_core_model_DataType$().Float$1)) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$()
  } else if ((iri === $m_Lamf_core_model_DataType$().Number$1)) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$()
  } else if ((iri === $m_Lamf_core_model_DataType$().Boolean$1)) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$()
  } else if ((iri === $m_Lamf_core_model_DataType$().DateTime$1)) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$()
  } else if ((iri === $m_Lamf_core_model_DataType$().File$1)) {
    return $m_Lamf_plugins_domain_shapes_models_TypeDef$FileType$()
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_RuntimeException().init___T(("Unknown mapping: " + iri)))
  }
});
$c_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$.prototype.typeDef08__T__T = (function(iri) {
  if ((iri === $m_Lamf_core_model_DataType$().String$1)) {
    return "string"
  } else if ((iri === $m_Lamf_core_model_DataType$().Integer$1)) {
    return "integer"
  } else if ((iri === $m_Lamf_core_model_DataType$().Number$1)) {
    return "number"
  } else if ((iri === $m_Lamf_core_model_DataType$().Float$1)) {
    return "number"
  } else if ((iri === $m_Lamf_core_model_DataType$().Double$1)) {
    return "number"
  } else if ((iri === $m_Lamf_core_model_DataType$().Boolean$1)) {
    return "boolean"
  } else if ((iri === $m_Lamf_core_model_DataType$().DateTime$1)) {
    return "date"
  } else if ((iri === $m_Lamf_core_model_DataType$().File$1)) {
    return "file"
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_RuntimeException().init___T(("Unknown mapping: " + iri)))
  }
});
$c_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$.prototype.typeDef__T__Lamf_plugins_domain_shapes_models_TypeDef = (function(iri) {
  return ((iri === $m_Lamf_core_model_DataType$().String$1) ? $m_Lamf_plugins_domain_shapes_models_TypeDef$StrType$() : ((iri === $m_Lamf_core_model_DataType$().Integer$1) ? $m_Lamf_plugins_domain_shapes_models_TypeDef$IntType$() : ((iri === $m_Lamf_core_model_DataType$().Long$1) ? $m_Lamf_plugins_domain_shapes_models_TypeDef$LongType$() : ((iri === $m_Lamf_core_model_DataType$().Float$1) ? $m_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$() : ((iri === $m_Lamf_core_model_DataType$().Double$1) ? $m_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$() : ((iri === $m_Lamf_core_model_DataType$().Number$1) ? $m_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$() : ((iri === $m_Lamf_core_model_DataType$().Boolean$1) ? $m_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$() : ((iri === $m_Lamf_core_model_DataType$().DateTime$1) ? $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$() : ((iri === $m_Lamf_core_model_DataType$().DateTimeOnly$1) ? $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$() : ((iri === $m_Lamf_core_model_DataType$().Time$1) ? $m_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$() : ((iri === $m_Lamf_core_model_DataType$().Date$1) ? $m_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$() : ((iri === $m_Lamf_core_model_DataType$().Byte$1) ? $m_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$() : ((iri === $m_Lamf_core_model_DataType$().Binary$1) ? $m_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$() : ((iri === $m_Lamf_core_model_DataType$().Password$1) ? $m_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$() : ((iri === $m_Lamf_core_model_DataType$().Nil$1) ? $m_Lamf_plugins_domain_shapes_models_TypeDef$NilType$() : $m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$())))))))))))))))
});
var $d_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$: 0
}, false, "amf.plugins.domain.shapes.parser.TypeDefXsdMapping$", {
  Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$: 1,
  O: 1
});
$c_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$.prototype.$classData = $d_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$;
var $n_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$ = (void 0);
function $m_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$() {
  if ((!$n_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$)) {
    $n_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$ = new $c_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_parser_TypeDefYTypeMapping$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_parser_TypeDefYTypeMapping$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_parser_TypeDefYTypeMapping$.prototype.constructor = $c_Lamf_plugins_domain_shapes_parser_TypeDefYTypeMapping$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_parser_TypeDefYTypeMapping$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_parser_TypeDefYTypeMapping$.prototype = $c_Lamf_plugins_domain_shapes_parser_TypeDefYTypeMapping$.prototype;
$c_Lamf_plugins_domain_shapes_parser_TypeDefYTypeMapping$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_parser_TypeDefYTypeMapping$.prototype.apply__Lamf_plugins_domain_shapes_models_TypeDef__Lorg_yaml_model_YType = (function(typeDef) {
  var x = $m_Lamf_plugins_domain_shapes_models_TypeDef$IntType$();
  if ((x === typeDef)) {
    var jsx$1 = true
  } else {
    var x$3 = $m_Lamf_plugins_domain_shapes_models_TypeDef$LongType$();
    if ((x$3 === typeDef)) {
      var jsx$1 = true
    } else {
      var x$5 = $m_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$();
      if ((x$5 === typeDef)) {
        var jsx$1 = true
      } else {
        var x$7 = $m_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$();
        var jsx$1 = (x$7 === typeDef)
      }
    }
  };
  if (jsx$1) {
    return $m_Lorg_yaml_model_YType$().Int$1
  } else {
    var x$9 = $m_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$();
    if ((x$9 === typeDef)) {
      var jsx$2 = true
    } else {
      var x$11 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$();
      if ((x$11 === typeDef)) {
        var jsx$2 = true
      } else {
        var x$13 = $m_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$();
        var jsx$2 = (x$13 === typeDef)
      }
    };
    if (jsx$2) {
      return $m_Lorg_yaml_model_YType$().Float$1
    } else {
      var x$15 = $m_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$();
      if ((x$15 === typeDef)) {
        return $m_Lorg_yaml_model_YType$().Bool$1
      } else {
        var x$17 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$();
        if ((x$17 === typeDef)) {
          var jsx$3 = true
        } else {
          var x$19 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$();
          if ((x$19 === typeDef)) {
            var jsx$3 = true
          } else {
            var x$21 = $m_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$();
            if ((x$21 === typeDef)) {
              var jsx$3 = true
            } else {
              var x$23 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$();
              var jsx$3 = (x$23 === typeDef)
            }
          }
        };
        if (jsx$3) {
          return $m_Lorg_yaml_model_YType$().Timestamp$1
        } else {
          return $m_Lorg_yaml_model_YType$().Str$1
        }
      }
    }
  }
});
var $d_Lamf_plugins_domain_shapes_parser_TypeDefYTypeMapping$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_parser_TypeDefYTypeMapping$: 0
}, false, "amf.plugins.domain.shapes.parser.TypeDefYTypeMapping$", {
  Lamf_plugins_domain_shapes_parser_TypeDefYTypeMapping$: 1,
  O: 1
});
$c_Lamf_plugins_domain_shapes_parser_TypeDefYTypeMapping$.prototype.$classData = $d_Lamf_plugins_domain_shapes_parser_TypeDefYTypeMapping$;
var $n_Lamf_plugins_domain_shapes_parser_TypeDefYTypeMapping$ = (void 0);
function $m_Lamf_plugins_domain_shapes_parser_TypeDefYTypeMapping$() {
  if ((!$n_Lamf_plugins_domain_shapes_parser_TypeDefYTypeMapping$)) {
    $n_Lamf_plugins_domain_shapes_parser_TypeDefYTypeMapping$ = new $c_Lamf_plugins_domain_shapes_parser_TypeDefYTypeMapping$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_parser_TypeDefYTypeMapping$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$.prototype.constructor = $c_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$.prototype = $c_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$.prototype;
$c_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$.prototype.xsd__Lamf_plugins_domain_shapes_models_TypeDef__T = (function(typeDef) {
  var x = $m_Lamf_plugins_domain_shapes_models_TypeDef$StrType$();
  if ((x === typeDef)) {
    return $m_Lamf_core_model_DataType$().String$1
  } else {
    var x$3 = $m_Lamf_plugins_domain_shapes_models_TypeDef$IntType$();
    if ((x$3 === typeDef)) {
      return $m_Lamf_core_model_DataType$().Integer$1
    } else {
      var x$5 = $m_Lamf_plugins_domain_shapes_models_TypeDef$LongType$();
      if ((x$5 === typeDef)) {
        return $m_Lamf_core_model_DataType$().Long$1
      } else {
        var x$7 = $m_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$();
        if ((x$7 === typeDef)) {
          return $m_Lamf_core_model_DataType$().Float$1
        } else {
          var x$9 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$();
          if ((x$9 === typeDef)) {
            return $m_Lamf_core_model_DataType$().Double$1
          } else {
            var x$11 = $m_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$();
            if ((x$11 === typeDef)) {
              return $m_Lamf_core_model_DataType$().Number$1
            } else {
              var x$13 = $m_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$();
              if ((x$13 === typeDef)) {
                return $m_Lamf_core_model_DataType$().Boolean$1
              } else {
                var x$15 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$();
                if ((x$15 === typeDef)) {
                  return $m_Lamf_core_model_DataType$().DateTime$1
                } else {
                  var x$17 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$();
                  if ((x$17 === typeDef)) {
                    return $m_Lamf_core_model_DataType$().DateTimeOnly$1
                  } else {
                    var x$19 = $m_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$();
                    if ((x$19 === typeDef)) {
                      return $m_Lamf_core_model_DataType$().Time$1
                    } else {
                      var x$21 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$();
                      if ((x$21 === typeDef)) {
                        return $m_Lamf_core_model_DataType$().Date$1
                      } else {
                        var x$23 = $m_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$();
                        if ((x$23 === typeDef)) {
                          return $m_Lamf_core_model_DataType$().Byte$1
                        } else {
                          var x$25 = $m_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$();
                          if ((x$25 === typeDef)) {
                            return $m_Lamf_core_model_DataType$().Binary$1
                          } else {
                            var x$27 = $m_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$();
                            if ((x$27 === typeDef)) {
                              return $m_Lamf_core_model_DataType$().Password$1
                            } else {
                              throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_RuntimeException().init___T("Unknown mapping"))
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }
});
$c_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$.prototype.xsdFromString__T__T2 = (function(text) {
  return ((text === "string") ? new $c_T2().init___O__O(new $c_s_Some().init___O($m_Lamf_core_model_DataType$().String$1), new $c_s_Some().init___O("")) : (((text === "number") || ((text === "float") || (text === "double"))) ? new $c_T2().init___O__O(new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Number$1), new $c_s_Some().init___O("")) : ((text === "integer") ? new $c_T2().init___O__O(new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Integer$1), new $c_s_Some().init___O("")) : ((text === "date") ? new $c_T2().init___O__O(new $c_s_Some().init___O($m_Lamf_core_model_DataType$().DateTime$1), new $c_s_Some().init___O("RFC2616")) : ((text === "boolean") ? new $c_T2().init___O__O(new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Boolean$1), new $c_s_Some().init___O("")) : ((text === "file") ? new $c_T2().init___O__O(new $c_s_Some().init___O($m_Lamf_core_model_DataType$().File$1), new $c_s_Some().init___O("")) : new $c_T2().init___O__O($m_s_None$(), $m_s_None$())))))))
});
var $d_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$: 0
}, false, "amf.plugins.domain.shapes.parser.XsdTypeDefMapping$", {
  Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$: 1,
  O: 1
});
$c_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$.prototype.$classData = $d_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$;
var $n_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$ = (void 0);
function $m_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$() {
  if ((!$n_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$)) {
    $n_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$ = new $c_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_recursion_RecursionErrorRegister() {
  $c_O.call(this);
  this.errorHandler$1 = null;
  this.errorRegister$1 = null
}
$c_Lamf_plugins_domain_shapes_resolution_stages_recursion_RecursionErrorRegister.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_resolution_stages_recursion_RecursionErrorRegister.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_recursion_RecursionErrorRegister;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_recursion_RecursionErrorRegister() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_recursion_RecursionErrorRegister.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_recursion_RecursionErrorRegister.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_recursion_RecursionErrorRegister.prototype.buildRecursion__p1__s_Option__Lamf_core_model_domain_Shape__Lamf_core_model_domain_RecursiveShape = (function(base, s) {
  var fixPointId = $as_T((base.isEmpty__Z() ? s.id$1 : base.get__O()));
  var this$1 = $m_Lamf_core_model_domain_RecursiveShape$().apply__Lamf_core_model_domain_Shape__Lamf_core_model_domain_RecursiveShape(s);
  var field = $m_Lamf_core_metamodel_domain_RecursiveShapeModel$().FixPoint$1;
  var r = $as_Lamf_core_model_domain_RecursiveShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, fixPointId));
  return r
});
$c_Lamf_plugins_domain_shapes_resolution_stages_recursion_RecursionErrorRegister.prototype.recursionAndError__Lamf_core_model_domain_Shape__s_Option__Lamf_core_model_domain_Shape__Lamf_core_traversal_ModelTraversalRegistry__Lamf_core_model_domain_RecursiveShape = (function(root, base, s, traversal) {
  var recursion = this.buildRecursion__p1__s_Option__Lamf_core_model_domain_Shape__Lamf_core_model_domain_RecursiveShape(base, s);
  return this.recursionError__Lamf_core_model_domain_Shape__Lamf_core_model_domain_RecursiveShape__Lamf_core_traversal_ModelTraversalRegistry__s_Option__Lamf_core_model_domain_RecursiveShape(root, recursion, traversal, new $c_s_Some().init___O(root.id$1))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_recursion_RecursionErrorRegister.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  this.errorHandler$1 = errorHandler;
  this.errorRegister$1 = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_recursion_RecursionErrorRegister.prototype.recursionError__Lamf_core_model_domain_Shape__Lamf_core_model_domain_RecursiveShape__Lamf_core_traversal_ModelTraversalRegistry__s_Option__Lamf_core_model_domain_RecursiveShape = (function(original, r, traversal, checkId) {
  var this$1 = this.errorRegister$1;
  var elem = r.id$1;
  var this$2 = this$1.scala$collection$mutable$ListBuffer$$start$6;
  var canRegister = (!$f_sc_LinearSeqOptimized__contains__O__Z(this$2, elem));
  var this$3 = $as_Lamf_core_model_BoolField(r.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1)).option$1;
  if ((((!$uZ((this$3.isEmpty__Z() ? false : this$3.get__O()))) && (!traversal.avoidError__Lamf_core_model_domain_RecursiveShape__s_Option__Z(r, checkId))) && canRegister)) {
    var this$4 = this.errorHandler$1;
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().RecursiveShapeSpecification$1;
    var node = original.id$1;
    var property = $m_s_None$();
    var lexical = original.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var location = original.location__s_Option();
    this$4.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "Error recursive shape", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
    this.errorRegister$1.$$plus$eq__O__scm_ListBuffer(r.id$1)
  } else if (traversal.avoidError__Lamf_core_model_domain_RecursiveShape__s_Option__Z(r, checkId)) {
    var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1;
    $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(r, field, true))
  };
  return r
});
var $d_Lamf_plugins_domain_shapes_resolution_stages_recursion_RecursionErrorRegister = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_recursion_RecursionErrorRegister: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.recursion.RecursionErrorRegister", {
  Lamf_plugins_domain_shapes_resolution_stages_recursion_RecursionErrorRegister: 1,
  O: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_recursion_RecursionErrorRegister.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_recursion_RecursionErrorRegister;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter() {
  $c_O.call(this);
  this.any$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter.prototype.init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster__Lamf_plugins_domain_shapes_models_AnyShape = (function($$outer, any) {
  this.any$1 = any;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter.prototype.toArrayShape__Lamf_plugins_domain_shapes_models_ArrayShape = (function() {
  var this$1 = new $c_Lamf_plugins_domain_shapes_models_ArrayShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(this.any$1.fields__Lamf_core_parser_Fields(), this.any$1.annotations__Lamf_core_parser_Annotations());
  var value = this.any$1.id$1;
  return $as_Lamf_plugins_domain_shapes_models_ArrayShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$1, value))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter.prototype.toUnionShape__Lamf_plugins_domain_shapes_models_UnionShape = (function() {
  var this$1 = new $c_Lamf_plugins_domain_shapes_models_UnionShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(this.any$1.fields__Lamf_core_parser_Fields(), this.any$1.annotations__Lamf_core_parser_Annotations());
  var value = this.any$1.id$1;
  return $as_Lamf_plugins_domain_shapes_models_UnionShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$1, value))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter.prototype.toSchemaShape__Lamf_plugins_domain_shapes_models_SchemaShape = (function() {
  var this$1 = new $c_Lamf_plugins_domain_shapes_models_SchemaShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(this.any$1.fields__Lamf_core_parser_Fields(), this.any$1.annotations__Lamf_core_parser_Annotations());
  var value = this.any$1.id$1;
  return $as_Lamf_plugins_domain_shapes_models_SchemaShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$1, value))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter.prototype.toScalarShape__Lamf_plugins_domain_shapes_models_ScalarShape = (function() {
  var this$1 = new $c_Lamf_plugins_domain_shapes_models_ScalarShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(this.any$1.fields__Lamf_core_parser_Fields(), this.any$1.annotations__Lamf_core_parser_Annotations());
  var value = this.any$1.id$1;
  return $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$1, value))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter.prototype.toFileShape__Lamf_plugins_domain_shapes_models_FileShape = (function() {
  var this$1 = new $c_Lamf_plugins_domain_shapes_models_FileShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(this.any$1.fields__Lamf_core_parser_Fields(), this.any$1.annotations__Lamf_core_parser_Annotations());
  var value = this.any$1.id$1;
  return $as_Lamf_plugins_domain_shapes_models_FileShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$1, value))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter.prototype.toNodeShape__Lamf_plugins_domain_shapes_models_NodeShape = (function() {
  var this$1 = new $c_Lamf_plugins_domain_shapes_models_NodeShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(this.any$1.fields__Lamf_core_parser_Fields(), this.any$1.annotations__Lamf_core_parser_Annotations());
  var value = this.any$1.id$1;
  return $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$1, value))
});
var $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.AnyShapeAdjuster$AnyShapeConverter", {
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter: 1,
  O: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext() {
  $c_O.call(this);
  this.errorHandler$1 = null;
  this.keepEditingInfo$1 = false;
  this.profile$1 = null;
  this.cache$1 = null;
  this.isRaml08$1 = false;
  this.minShapeClass$1 = null
}
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext.prototype.minShape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape = (function(derivedShape, superShape) {
  try {
    return this.minShapeClass$1.computeMinShape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(derivedShape, superShape)
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 instanceof $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError)) {
      var e$3 = $as_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError(e$2);
      var this$2 = this.errorHandler$1;
      var specification = $m_Lamf_validations_ResolutionSideValidations$().InvalidTypeInheritanceWarningSpecification$1;
      var node = derivedShape.id$1;
      var this$1 = e$3.property$3;
      var property = (this$1.isEmpty__Z() ? new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1.value$1.iri__T()) : this$1);
      var message = e$3.s$1;
      var lexical = e$3.position$3;
      var location = e$3.location$3;
      this$2.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
      return derivedShape
    } else if ((e$2 !== null)) {
      var this$3 = this.errorHandler$1;
      var specification$1 = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
      var node$1 = derivedShape.id$1;
      var property$1 = new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1.value$1.iri__T());
      var message$1 = e$2.getMessage__T();
      var lexical$1 = derivedShape.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      var location$1 = derivedShape.location__s_Option();
      this$3.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification$1.id$1, node$1, property$1, message$1, lexical$1, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location$1);
      return derivedShape
    } else {
      throw e
    }
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Z__Lamf_ProfileName__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache = (function(errorHandler, keepEditingInfo, profile, cache) {
  this.errorHandler$1 = errorHandler;
  this.keepEditingInfo$1 = keepEditingInfo;
  this.profile$1 = profile;
  this.cache$1 = cache;
  this.isRaml08$1 = profile.equals__O__Z($m_Lamf_Raml08Profile$());
  this.minShapeClass$1 = new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm().init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext(this);
  return this
});
var $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.NormalizationContext", {
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext: 1,
  O: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$.prototype.constructor = $c_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$.prototype = $c_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$.prototype;
$c_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$.prototype.validateAll__sc_Seq__T__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future = (function(candidates, severity, env, executionContext) {
  return this.validateEnums__p1__sc_Seq__T__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future(candidates, severity, env, executionContext).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, candidates$1, severity$1, env$1, executionContext$1) {
    return (function(r$2) {
      var r = $as_Lamf_core_validation_AMFValidationReport(r$2);
      return ((!r.conforms$1) ? $m_s_concurrent_Future$().successful__O__s_concurrent_Future(r) : $m_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$().validateAll__sc_Seq__T__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future($as_sc_Seq(candidates$1.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
        return (function(x$1$2) {
          var x$1 = $as_Lamf_core_validation_ValidationCandidate(x$1$2);
          var this$1 = x$1.payload$1.fields$1;
          var f = $m_Lamf_core_metamodel_document_PayloadFragmentModel$().Encodes$1;
          return this$1.fs$1.contains__O__Z(f)
        })
      })($this)))), severity$1, env$1, executionContext$1))
    })
  })(this, candidates, severity, env, executionContext)), executionContext)
});
$c_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$.prototype.defaultMediaTypeFor__Lamf_core_model_domain_DataNode__T = (function(dataNode) {
  if ((dataNode instanceof $c_Lamf_core_model_domain_ScalarNode)) {
    var x2 = $as_Lamf_core_model_domain_ScalarNode(dataNode);
    var this$1 = $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1)).option$1;
    if ((!this$1.isEmpty__Z())) {
      var arg1 = this$1.get__O();
      var x$3 = $as_T(arg1);
      var jsx$1 = $m_Lamf_core_utils_package$MediaTypeMatcher$().isXml$extension__T__Z(x$3)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return "application/xml"
    }
  };
  return "application/json"
});
$c_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$.prototype.validateEnums__p1__sc_Seq__T__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future = (function(validationCandidates, severity, env, executionContext) {
  var this$1 = validationCandidates.groupBy__F1__sci_Map(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_validation_ValidationCandidate(x$2$2);
      return x$2.shape$1
    })
  })(this)));
  var this$3 = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(this$1);
  $m_sc_Iterable$();
  var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
  var this$5 = this$3.$$outer$4.keysIterator__sc_Iterator();
  while (this$5.hasNext__Z()) {
    var arg1 = this$5.next__O();
    var x0$1 = $as_Lamf_core_model_domain_Shape(arg1);
    matchEnd4: {
      var jsx$1;
      if ((x0$1 !== null)) {
        if ($as_sc_Seq(x0$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Values$1)).nonEmpty__Z()) {
          var jsx$3 = $as_sc_Seq(x0$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Values$1));
          var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, x2) {
            return (function(v$2) {
              var v = $as_Lamf_core_model_domain_DataNode(v$2);
              return new $c_Lamf_core_validation_ValidationCandidate().init___Lamf_core_model_domain_Shape__Lamf_core_model_document_PayloadFragment(x2, $m_Lamf_core_model_document_PayloadFragment$().apply__Lamf_core_model_domain_DataNode__T__Lamf_core_model_document_PayloadFragment(v, $m_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$().defaultMediaTypeFor__Lamf_core_model_domain_DataNode__T(v)))
            })
          })(this, x0$1));
          var this$6 = $m_sc_Seq$();
          var jsx$1 = $as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$6.ReusableCBFInstance$2));
          break matchEnd4
        }
      };
      var jsx$1 = $m_sci_Nil$()
    };
    var xs = jsx$1.seq__sc_TraversableOnce();
    $as_scm_Builder($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(b, xs))
  };
  var enumsCandidates = b.elems$1;
  return $m_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$().validateAll__sc_Seq__T__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future(enumsCandidates.toSeq__sc_Seq(), severity, env, executionContext)
});
var $d_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$: 0
}, false, "amf.plugins.domain.shapes.validation.ShapesNodesValidator$", {
  Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$: 1,
  O: 1
});
$c_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$.prototype.$classData = $d_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$;
var $n_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$ = (void 0);
function $m_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$() {
  if ((!$n_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$)) {
    $n_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$ = new $c_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_Parameter$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_models_Parameter$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_Parameter$.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_Parameter$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_Parameter$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_Parameter$.prototype = $c_Lamf_plugins_domain_webapi_models_Parameter$.prototype;
$c_Lamf_plugins_domain_webapi_models_Parameter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_models_Parameter$.prototype.apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_Parameter = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  return new $c_Lamf_plugins_domain_webapi_models_Parameter().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_domain_webapi_models_Parameter$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_Parameter$: 0
}, false, "amf.plugins.domain.webapi.models.Parameter$", {
  Lamf_plugins_domain_webapi_models_Parameter$: 1,
  O: 1
});
$c_Lamf_plugins_domain_webapi_models_Parameter$.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_Parameter$;
var $n_Lamf_plugins_domain_webapi_models_Parameter$ = (void 0);
function $m_Lamf_plugins_domain_webapi_models_Parameter$() {
  if ((!$n_Lamf_plugins_domain_webapi_models_Parameter$)) {
    $n_Lamf_plugins_domain_webapi_models_Parameter$ = new $c_Lamf_plugins_domain_webapi_models_Parameter$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_models_Parameter$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_Request$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_models_Request$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_Request$.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_Request$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_Request$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_Request$.prototype = $c_Lamf_plugins_domain_webapi_models_Request$.prototype;
$c_Lamf_plugins_domain_webapi_models_Request$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_models_Request$.prototype.apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_Request = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  return new $c_Lamf_plugins_domain_webapi_models_Request().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_domain_webapi_models_Request$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_Request$: 0
}, false, "amf.plugins.domain.webapi.models.Request$", {
  Lamf_plugins_domain_webapi_models_Request$: 1,
  O: 1
});
$c_Lamf_plugins_domain_webapi_models_Request$.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_Request$;
var $n_Lamf_plugins_domain_webapi_models_Request$ = (void 0);
function $m_Lamf_plugins_domain_webapi_models_Request$() {
  if ((!$n_Lamf_plugins_domain_webapi_models_Request$)) {
    $n_Lamf_plugins_domain_webapi_models_Request$ = new $c_Lamf_plugins_domain_webapi_models_Request$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_models_Request$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_Response$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_models_Response$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_Response$.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_Response$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_Response$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_Response$.prototype = $c_Lamf_plugins_domain_webapi_models_Response$.prototype;
$c_Lamf_plugins_domain_webapi_models_Response$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_models_Response$.prototype.apply__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_Response = (function(entry) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  return new $c_Lamf_plugins_domain_webapi_models_Response().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_domain_webapi_models_Response$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_Response$: 0
}, false, "amf.plugins.domain.webapi.models.Response$", {
  Lamf_plugins_domain_webapi_models_Response$: 1,
  O: 1
});
$c_Lamf_plugins_domain_webapi_models_Response$.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_Response$;
var $n_Lamf_plugins_domain_webapi_models_Response$ = (void 0);
function $m_Lamf_plugins_domain_webapi_models_Response$() {
  if ((!$n_Lamf_plugins_domain_webapi_models_Response$)) {
    $n_Lamf_plugins_domain_webapi_models_Response$ = new $c_Lamf_plugins_domain_webapi_models_Response$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_models_Response$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme$.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_security_SecurityScheme$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_security_SecurityScheme$.prototype = $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme$.prototype;
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme$.prototype.apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_security_SecurityScheme = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
var $d_Lamf_plugins_domain_webapi_models_security_SecurityScheme$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_security_SecurityScheme$: 0
}, false, "amf.plugins.domain.webapi.models.security.SecurityScheme$", {
  Lamf_plugins_domain_webapi_models_security_SecurityScheme$: 1,
  O: 1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme$.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_security_SecurityScheme$;
var $n_Lamf_plugins_domain_webapi_models_security_SecurityScheme$ = (void 0);
function $m_Lamf_plugins_domain_webapi_models_security_SecurityScheme$() {
  if ((!$n_Lamf_plugins_domain_webapi_models_security_SecurityScheme$)) {
    $n_Lamf_plugins_domain_webapi_models_security_SecurityScheme$ = new $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_models_security_SecurityScheme$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_templates_ResourceType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_models_templates_ResourceType$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_templates_ResourceType$.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_templates_ResourceType$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_templates_ResourceType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_templates_ResourceType$.prototype = $c_Lamf_plugins_domain_webapi_models_templates_ResourceType$.prototype;
$c_Lamf_plugins_domain_webapi_models_templates_ResourceType$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_models_templates_ResourceType$.prototype.apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_templates_ResourceType = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_templates_ResourceType().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
var $d_Lamf_plugins_domain_webapi_models_templates_ResourceType$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_templates_ResourceType$: 0
}, false, "amf.plugins.domain.webapi.models.templates.ResourceType$", {
  Lamf_plugins_domain_webapi_models_templates_ResourceType$: 1,
  O: 1
});
$c_Lamf_plugins_domain_webapi_models_templates_ResourceType$.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_templates_ResourceType$;
var $n_Lamf_plugins_domain_webapi_models_templates_ResourceType$ = (void 0);
function $m_Lamf_plugins_domain_webapi_models_templates_ResourceType$() {
  if ((!$n_Lamf_plugins_domain_webapi_models_templates_ResourceType$)) {
    $n_Lamf_plugins_domain_webapi_models_templates_ResourceType$ = new $c_Lamf_plugins_domain_webapi_models_templates_ResourceType$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_models_templates_ResourceType$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_templates_Trait$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_models_templates_Trait$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_templates_Trait$.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_templates_Trait$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_templates_Trait$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_templates_Trait$.prototype = $c_Lamf_plugins_domain_webapi_models_templates_Trait$.prototype;
$c_Lamf_plugins_domain_webapi_models_templates_Trait$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_models_templates_Trait$.prototype.apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_templates_Trait = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_templates_Trait().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
var $d_Lamf_plugins_domain_webapi_models_templates_Trait$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_templates_Trait$: 0
}, false, "amf.plugins.domain.webapi.models.templates.Trait$", {
  Lamf_plugins_domain_webapi_models_templates_Trait$: 1,
  O: 1
});
$c_Lamf_plugins_domain_webapi_models_templates_Trait$.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_templates_Trait$;
var $n_Lamf_plugins_domain_webapi_models_templates_Trait$ = (void 0);
function $m_Lamf_plugins_domain_webapi_models_templates_Trait$() {
  if ((!$n_Lamf_plugins_domain_webapi_models_templates_Trait$)) {
    $n_Lamf_plugins_domain_webapi_models_templates_Trait$ = new $c_Lamf_plugins_domain_webapi_models_templates_Trait$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_models_templates_Trait$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$.prototype = $c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$.prototype;
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$.prototype.entryAsOperation__Lamf_ProfileName__Lamf_core_model_document_BaseUnit__T__T__Z__Lorg_yaml_model_YMapEntry__Lamf_core_parser_Annotations__scm_Map__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_domain_webapi_models_Operation = (function(profile, unit, name, extensionId, keepEditingInfo, entry, annotations, referencesCollector, context, errorHandler) {
  var ctx = $as_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext((context.isEmpty__Z() ? $m_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$().custom__Lamf_ProfileName__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(profile) : context.get__O()));
  var this$1 = entry.value$2;
  this.addDeclarations__p1__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_core_model_document_BaseUnit__T__V(ctx, unit, this$1.location$1.sourceName$1);
  referencesCollector.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, ctx$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var alias = $as_T(x0$1.$$und1__O());
        var ref = $as_Lamf_core_model_domain_DomainElement(x0$1.$$und2__O());
        var jsx$2 = ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations();
        var jsx$1 = ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().fragments$1;
        var y = new $c_Lamf_core_parser_FragmentRef().init___Lamf_core_model_domain_DomainElement__s_Option(ref, $m_s_None$());
        jsx$2.fragments$1 = jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(alias, y))
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, ctx)));
  var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(name, "\\.", 0);
  var until = (((-1) + xs.u.length) | 0);
  var x = ((until > 0) ? until : 0);
  var y$1 = xs.u.length;
  var hi = ((x < y$1) ? x : y$1);
  var size = ((hi > 0) ? hi : 0);
  var result = $m_jl_reflect_Array$().newInstance__jl_Class__I__O($objectGetClass(xs).getComponentType__jl_Class(), size);
  if ((size > 0)) {
    $m_s_Array$().copy__O__I__O__I__I__V(xs, 0, result, 0, size)
  };
  var pathElements = $asArrayOf_T(result, 1);
  var adaptedDeclarations = ctx.findDeclarations__sc_Seq__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations($m_s_Predef$().wrapRefArray__AO__scm_WrappedArray(pathElements), ctx.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations());
  var arg1 = ctx.clone__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(ctx.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().merge__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations(adaptedDeclarations));
  arg1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().resourceTypes$2.$$plus$plus__sc_GenTraversableOnce__sci_Map(arg1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().traits$2).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ctx$2) {
    return (function(e$2) {
      var e = $as_T2(e$2);
      return ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations($as_Lamf_core_model_domain_DomainElement(e.$$und2__O()))
    })
  })(this, ctx)));
  arg1.contextType$3 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().TRAIT$2;
  var operation = $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser(arg1.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().operationParser__F3().apply__O__O__O__O(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, extensionId$1) {
    return (function(x$5$2) {
      $as_T(x$5$2);
      $m_Lamf_core_parser_Annotations$();
      var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
      var this$21 = new $c_Lamf_plugins_domain_webapi_models_Operation().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
      var value = (extensionId$1 + "/applied");
      return $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$21, value))
    })
  })(this, extensionId)), true)).parse__Lamf_plugins_domain_webapi_models_Operation();
  if (keepEditingInfo) {
    this.annotateExtensionId__p1__Lamf_core_model_domain_DomainElement__T__s_Option__V(operation, extensionId, this.findUnitLocationOfElement__T__Lamf_core_model_document_BaseUnit__s_Option(extensionId, unit))
  };
  return $as_Lamf_plugins_domain_webapi_models_Operation(new $c_Lamf_core_resolution_stages_ReferenceResolutionStage().init___Z__Lamf_core_errorhandling_ErrorHandler(keepEditingInfo, errorHandler).resolveDomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(operation))
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$.prototype.asEndpoint__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_model_domain_DataNode__Lamf_core_parser_Annotations__T__T__s_Option__Z__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_domain_webapi_models_EndPoint = (function(unit, profile, node, rtAnnotations, name, extensionId, extensionLocation, keepEditingInfo, context, errorHandler) {
  var ctx = $as_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext((context.isEmpty__Z() ? $m_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$().custom__Lamf_ProfileName__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(profile) : context.get__O()));
  var referencesCollector = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var this$1 = $f_Lamf_core_model_domain_AmfElement__location__s_Option(node);
  var sourceName = $as_T((this$1.isEmpty__Z() ? "" : this$1.get__O()));
  var this$3 = new $c_Lorg_yaml_model_YDocument$WithComment().init___T__T("", sourceName);
  var b = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(this$3.org$yaml$model$YDocument$WithComment$$sourceName$f);
  var x = this$3.comment$1;
  var this$5 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$5)) {
    b.comment__T__V(this$3.comment$1)
  };
  var jsx$5 = b.builder$1;
  var sourceName$1 = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
  var jsx$3 = $m_Lorg_yaml_model_YNode$();
  var jsx$2 = $m_Lorg_yaml_model_YScalar$();
  var jsx$1 = $m_Lorg_yaml_model_YType$().Str$1;
  var this$7 = rtAnnotations.find__jl_Class__s_Option($d_Lamf_core_annotations_SourceAST.getClassOf());
  if (this$7.isEmpty__Z()) {
    var xo = $m_s_None$()
  } else {
    var arg1 = this$7.get__O();
    var x$8 = $as_Lamf_core_annotations_SourceAST(arg1);
    var xo = new $c_s_Some().init___O(x$8.ast$1)
  };
  var this$9 = xo.toList__sci_List();
  var pf = new $c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asEndpoint$3$1().init___();
  var this$10 = $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$9, pf);
  var key = jsx$3.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(jsx$2.withLocation__T__Lorg_yaml_model_YType__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_YScalar(name, jsx$1, $as_Lamf_core_parser_Annotations((this$10.isEmpty__Z() ? rtAnnotations : this$10.get__O())).sourceLocation__Lorg_mulesoft_lexer_SourceLocation()), $m_Lorg_yaml_model_YType$().Str$1);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler(node, (rtAnnotations.contains__jl_Class__Z($d_Lamf_core_annotations_LexicalInformation.getClassOf()) ? $m_Lamf_core_emitter_SpecOrdering$Lexical$() : $m_Lamf_core_emitter_SpecOrdering$Default$()), true, referencesCollector, ctx.eh$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
  var this$13 = v.builder$1;
  var array = [key];
  if ((this$13.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$13.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$13, newSize);
  var len$1 = this$13.size0$6;
  var src = this$13.array$6;
  var dest = this$13.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$13.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x$1 = $uI(array.length);
  var x$2 = ((x$1 < len$2) ? x$1 : len$2);
  var that = xs.u.length;
  var end = ((x$2 < that) ? x$2 : that);
  while ((i < end)) {
    var jsx$4 = j;
    var index = i;
    xs.set(jsx$4, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$13.size0$6 = newSize;
  b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1));
  jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1));
  var document = new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this$3.org$yaml$model$YDocument$WithComment$$sourceName$f), b.builder$1);
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
  var entry = $as_Lorg_yaml_model_YMapEntry($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(document, conversion, iv)).entries$3.head__O());
  return this.entryAsEndpoint__Lamf_ProfileName__Lamf_core_model_document_BaseUnit__Lamf_core_model_domain_DataNode__T__T__Z__Lorg_yaml_model_YMapEntry__Lamf_core_parser_Annotations__Lamf_core_errorhandling_ErrorHandler__s_Option__scm_Map__s_Option__Lamf_plugins_domain_webapi_models_EndPoint(profile, unit, node, name, extensionId, keepEditingInfo, entry, node.annotations__Lamf_core_parser_Annotations(), errorHandler, extensionLocation, referencesCollector, context)
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$.prototype.addDeclarations__p1__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_core_model_document_BaseUnit__T__V = (function(ctx, root, sourceName) {
  var this$1 = this.getDeclaringUnit__p1__sci_List__T__s_Option(root.references__sc_Seq().toList__sci_List(), sourceName);
  var declaringUnit = $as_Lamf_core_model_document_BaseUnit((this$1.isEmpty__Z() ? root : this$1.get__O()));
  var jsx$2 = this.extractFilteredDeclarations__p1__Lamf_core_model_document_BaseUnit__F1__sc_Seq(declaringUnit, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$15$2) {
      var x$15 = $as_Lamf_core_model_domain_DomainElement(x$15$2);
      return (x$15 instanceof $c_Lamf_core_model_document_Module)
    })
  })(this)));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3, declaringUnit$1) {
    return (function(x$16$2) {
      var x$16 = $as_Lamf_core_model_domain_DomainElement(x$16$2);
      return new $c_T2().init___O__O(x$16, declaringUnit$1)
    })
  })(this, declaringUnit));
  var this$4 = $m_sc_Seq$();
  var libraries = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2));
  var jsx$4 = this.extractFilteredDeclarations__p1__Lamf_core_model_document_BaseUnit__F1__sc_Seq(root, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
    return (function(x$17$2) {
      var x$17 = $as_Lamf_core_model_domain_DomainElement(x$17$2);
      return (!(x$17 instanceof $c_Lamf_core_model_document_Module))
    })
  })(this)));
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5, root$1) {
    return (function(x$18$2) {
      var x$18 = $as_Lamf_core_model_domain_DomainElement(x$18$2);
      return new $c_T2().init___O__O(x$18, root$1)
    })
  })(this, root));
  var this$6 = $m_sc_Seq$();
  var otherDeclarations = $as_sc_Seq(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$6.ReusableCBFInstance$2));
  var this$7 = $m_sc_Seq$();
  $as_sc_IterableLike(libraries.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(otherDeclarations, this$7.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1, ctx$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var declaration = $as_Lamf_core_model_domain_DomainElement(x0$1.$$und1__O());
        var unit = $as_Lamf_core_model_document_BaseUnit(x0$1.$$und2__O());
        ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(declaration);
        $m_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$().processDeclaration__p1__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_core_model_document_BaseUnit__V(declaration, ctx$1, unit)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, ctx)));
  if ((!((declaringUnit === null) ? (root === null) : declaringUnit.equals__O__Z(root)))) {
    this.processRefsToDeclarations__p1__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_core_model_document_BaseUnit__V(ctx, root)
  };
  this.processRefsToDeclarations__p1__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_core_model_document_BaseUnit__V(ctx, declaringUnit)
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$.prototype.extractFilteredDeclarations__p1__Lamf_core_model_document_BaseUnit__F1__sc_Seq = (function(unit, filterCondition) {
  return ($is_Lamf_core_model_document_DeclaresModel(unit) ? $as_sc_Seq($as_Lamf_core_model_document_DeclaresModel(unit).declares__sc_Seq().filter__F1__O(filterCondition)) : $m_sci_Nil$())
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$.prototype.sourceNameMatch__p1__Lamf_core_model_domain_AmfElement__T__Z = (function(f, sourceName) {
  var this$1 = f.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_SourceLocation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var jsx$1 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$14 = $as_Lamf_core_annotations_SourceLocation(arg1);
    var jsx$1 = new $c_s_Some().init___O(x$14.location$1)
  };
  return jsx$1.contains__O__Z(sourceName)
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$.prototype.getDeclaringUnit__p1__sci_List__T__s_Option = (function(refs, sourceName) {
  _getDeclaringUnit: while (true) {
    var rc10 = false;
    var x2 = null;
    var x1 = refs;
    if ((x1 instanceof $c_sci_$colon$colon)) {
      rc10 = true;
      x2 = $as_sci_$colon$colon(x1);
      var f = $as_Lamf_core_model_document_BaseUnit(x2.head$5);
      if ($is_Lamf_core_model_document_Fragment(f)) {
        var x7 = $as_Lamf_core_model_document_Fragment(f);
        if (this.sourceNameMatch__p1__Lamf_core_model_domain_AmfElement__T__Z(x7, sourceName)) {
          return new $c_s_Some().init___O(x7)
        }
      }
    };
    if (rc10) {
      var m = $as_Lamf_core_model_document_BaseUnit(x2.head$5);
      if ((m instanceof $c_Lamf_core_model_document_Module)) {
        var x8 = $as_Lamf_core_model_document_Module(m);
        if (this.sourceNameMatch__p1__Lamf_core_model_domain_AmfElement__T__Z(x8, sourceName)) {
          return new $c_s_Some().init___O(x8)
        }
      }
    };
    if (rc10) {
      var unit = $as_Lamf_core_model_document_BaseUnit(x2.head$5);
      var tail = x2.tl$5;
      var x1$2 = this.getDeclaringUnit__p1__sci_List__T__s_Option(tail, sourceName);
      if ((x1$2 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$2);
        return x2$2
      } else {
        refs = unit.references__sc_Seq().toList__sci_List();
        continue _getDeclaringUnit
      }
    };
    return $m_s_None$()
  }
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$.prototype.processDeclaration__p1__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_core_model_document_BaseUnit__V = (function(declaration, nestedCtx, model) {
  var x1 = declaration.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity.getClassOf());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var resolvedNamedEntity = $as_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity(x2.value$2);
    var this$1 = resolvedNamedEntity.vals$1;
    var iterTable = this$1.table$5;
    var idx = $f_scm_HashTable__scala$collection$mutable$HashTable$$lastPopulatedIndex__I(this$1);
    var es = iterTable.get(idx);
    while ((es !== null)) {
      var next = $as_scm_HashEntry(es.next__O());
      var arg1 = es;
      var e = $as_scm_DefaultEntry(arg1);
      var _2 = e.value$1;
      var namedEntities = $as_sc_Seq(_2);
      var inContext = namedEntities.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, model$2) {
        return (function(entity$2) {
          var entity = $as_Lamf_core_model_domain_NamedDomainElement(entity$2);
          if ((entity !== null)) {
            var thiz = entity.id__T();
            var this$2 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(model$2);
            var s = $as_jl_CharSequence((this$2.isEmpty__Z() ? "" : this$2.get__O()));
            var str = $objectToString(s);
            return ($uI(thiz.indexOf(str)) !== (-1))
          } else {
            return false
          }
        })
      })(this, model)));
      nestedCtx.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(declaration);
      matchEnd4: {
        if ($is_Lamf_core_model_domain_NamedDomainElement(declaration)) {
          var x2$1 = $as_Lamf_core_model_domain_NamedDomainElement(declaration);
          if (inContext.isDefined__Z()) {
            var this$6 = $as_Lamf_core_model_domain_NamedDomainElement(inContext.get__O());
            var this$7 = $as_Lamf_core_model_StrField(this$6.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(this$6.nameField__Lamf_core_metamodel_Field()));
            var this$8 = this$7.option$1;
            var localName = $as_T((this$8.isEmpty__Z() ? null : this$8.get__O()));
            var this$9 = $as_Lamf_core_model_StrField(x2$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(x2$1.nameField__Lamf_core_metamodel_Field()));
            var this$10 = this$9.option$1;
            var realName = $as_T((this$10.isEmpty__Z() ? null : this$10.get__O()));
            $m_Lamf_core_parser_Annotations$();
            var a = new $c_Lamf_core_parser_Annotations().init___();
            $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(x2$1, localName, a);
            nestedCtx.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(declaration);
            $m_Lamf_core_parser_Annotations$();
            var a$1 = new $c_Lamf_core_parser_Annotations().init___();
            $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(x2$1, realName, a$1);
            break matchEnd4
          }
        }
      };
      es = next;
      while (((es === null) && (idx > 0))) {
        idx = (((-1) + idx) | 0);
        es = iterTable.get(idx)
      }
    }
  } else {
    nestedCtx.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(declaration)
  }
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$.prototype.processRefsToDeclarations__p1__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_core_model_document_BaseUnit__V = (function(ctx, model) {
  model.references__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ctx$1, model$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_document_BaseUnit(x0$1$2);
      var rc6 = false;
      var x2 = null;
      if ($is_Lamf_core_model_document_Fragment(x0$1)) {
        rc6 = true;
        x2 = $as_Lamf_core_model_document_Fragment(x0$1);
        if (((!(x2 instanceof $c_Lamf_plugins_document_webapi_model_ResourceTypeFragment)) && (!(x2 instanceof $c_Lamf_plugins_document_webapi_model_TraitFragment)))) {
          var this$3 = ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations();
          var this$1 = x2;
          var this$2 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$1);
          var x2$1 = x2;
          var _1 = (this$2.isEmpty__Z() ? x2$1.id__T() : this$2.get__O());
          var _2 = x2;
          var url = $as_T(_1);
          var jsx$1 = this$3.fragments$1;
          var y = new $c_Lamf_core_parser_FragmentRef().init___Lamf_core_model_domain_DomainElement__s_Option(_2.encodes__Lamf_core_model_domain_DomainElement(), $f_Lamf_core_model_document_BaseUnit__location__s_Option(_2));
          this$3.fragments$1 = jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(url, y));
          return this$3
        }
      };
      if ($is_Lamf_core_model_document_DeclaresModel(x0$1)) {
        var this$6 = model$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_Aliases.getClassOf());
        $as_Lamf_core_annotations_Aliases((this$6.isEmpty__Z() ? new $c_Lamf_core_annotations_Aliases().init___sci_Set($as_sci_Set($m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))) : this$6.get__O())).aliases$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, x3, ctx$6) {
          return (function(x0$2$2) {
            var x0$2 = $as_T2(x0$2$2);
            matchEnd5: {
              if ((x0$2 !== null)) {
                var alias = $as_T(x0$2.$$und1__O());
                var p2 = $as_T2(x0$2.$$und2__O());
                if ((p2 !== null)) {
                  var fullUrl = $as_T(p2.$$und1__O());
                  if ((x3.id__T() === fullUrl)) {
                    var jsx$2 = $m_sci_Nil$();
                    var x$1 = ctx$6.eh$1;
                    $m_sc_Seq$();
                    $m_sci_Seq$();
                    var this$10 = new $c_scm_ListBuffer().init___();
                    var x$3 = this$10.toList__sci_List();
                    var x$4 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
                    $m_sc_Seq$();
                    $m_sci_Seq$();
                    var this$17 = new $c_scm_ListBuffer().init___();
                    var x$5 = new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$17.toList__sci_List());
                    var nestedCtx = new $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions("", jsx$2, new $c_Lamf_core_parser_ParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext("", x$3, x$4, x$1, x$5), $m_s_None$(), $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2, new $c_Lamf_core_client_ParsingOptions().init___());
                    $as_Lamf_core_model_document_DeclaresModel(x3).declares__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, nestedCtx$1, x3$2) {
                      return (function(declaration$2) {
                        var declaration = $as_Lamf_core_model_domain_DomainElement(declaration$2);
                        $m_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$().processDeclaration__p1__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_core_model_document_BaseUnit__V(declaration, nestedCtx$1, x3$2)
                      })
                    })(this$3$1, nestedCtx, x3)));
                    var jsx$4 = ctx$6.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations();
                    var jsx$3 = ctx$6.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().libraries$1;
                    var y$1 = nestedCtx.declarations$3;
                    jsx$4.libraries$1 = jsx$3.$$plus__T2__sci_Map(new $c_T2().init___O__O(alias, y$1));
                    break matchEnd5
                  } else {
                    break matchEnd5
                  }
                }
              };
              throw new $c_s_MatchError().init___O(x0$2)
            }
          })
        })($this, x0$1, ctx$1)));
        return (void 0)
      };
      if (rc6) {
        return (void 0)
      };
      var this$24 = ctx$1.eh$1;
      var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
      var target = $m_s_None$();
      var node = x0$1.id__T();
      var lexical = x0$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      var location = $f_Lamf_core_model_document_BaseUnit__location__s_Option(x0$1);
      this$24.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, target, "Error resolving nested declaration, found something that is not a library or a fragment", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
      return x0$1
    })
  })(this, ctx, model)))
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$.prototype.annotateExtensionId__p1__Lamf_core_model_domain_DomainElement__T__s_Option__V = (function(point, extensionId, extensionLocation) {
  var annotation = new $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance().init___T__s_Option(extensionId, extensionLocation);
  var this$1 = point.fields__Lamf_core_parser_Fields();
  var this$4 = this$1.fs$1;
  var this$2 = $m_Lamf_core_parser_FieldEntry$();
  var f = $f_F2__tupled__F1(this$2);
  var this$3 = $m_sci_Iterable$();
  var bf = this$3.ReusableCBFInstance$2;
  var this$5 = $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$4, f, bf)).headOption__s_Option();
  if ((!this$5.isEmpty__Z())) {
    var arg1 = this$5.get__O();
    var x$12 = $as_Lamf_core_parser_FieldEntry(arg1);
    var this$6 = x$12.value$1.annotations$1;
    var pf = new $c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$annotateExtensionId$1$1().init___();
    var this$8 = this$6.amf$core$parser$Annotations$$annotations$1;
    var this$7 = $m_scm_ListBuffer$();
    var bf$1 = this$7.ReusableCBFInstance$2;
    var jsx$1 = $as_sc_Seq($f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this$8, pf, bf$1)).exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, extensionId$3) {
      return (function(x$13$2) {
        var x$13 = $as_Lamf_plugins_document_webapi_annotations_ExtensionProvenance(x$13$2);
        return (x$13.baseId$1 === extensionId$3)
      })
    })(this, extensionId)))
  } else {
    var jsx$1 = false
  };
  if ((!jsx$1)) {
    var this$9 = point.fields__Lamf_core_parser_Fields();
    var this$12 = this$9.fs$1;
    var this$10 = $m_Lamf_core_parser_FieldEntry$();
    var f$1 = $f_F2__tupled__F1(this$10);
    var this$11 = $m_sci_Iterable$();
    var bf$2 = this$11.ReusableCBFInstance$2;
    $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$12, f$1, bf$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, annotation$1, extensionId$1, extensionLocation$1) {
      return (function(field$2) {
        var field = $as_Lamf_core_parser_FieldEntry(field$2);
        field.value$1.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(annotation$1);
        var x1 = field.value$1.value$1;
        if ($is_Lamf_core_model_domain_DomainElement(x1)) {
          var x2 = $as_Lamf_core_model_domain_DomainElement(x1);
          $m_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$().annotateExtensionId__p1__Lamf_core_model_domain_DomainElement__T__s_Option__V(x2, extensionId$1, extensionLocation$1);
          return (void 0)
        } else if ((x1 instanceof $c_Lamf_core_model_domain_AmfArray)) {
          var x3 = $as_Lamf_core_model_domain_AmfArray(x1);
          x3.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, annotation$1$1, extensionId$3$1, extensionLocation$1$1) {
            return (function(x0$1$2) {
              var x0$1 = $as_Lamf_core_model_domain_AmfElement(x0$1$2);
              if ($is_Lamf_core_model_domain_DomainElement(x0$1)) {
                var x2$1 = $as_Lamf_core_model_domain_DomainElement(x0$1);
                x2$1.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(annotation$1$1);
                $m_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$().annotateExtensionId__p1__Lamf_core_model_domain_DomainElement__T__s_Option__V(x2$1, extensionId$3$1, extensionLocation$1$1);
                return (void 0)
              } else {
                return x0$1.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(annotation$1$1)
              }
            })
          })(this$2$1, annotation$1, extensionId$1, extensionLocation$1)));
          return (void 0)
        } else {
          return x1.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(annotation$1)
        }
      })
    })(this, annotation, extensionId, extensionLocation)))
  }
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$.prototype.custom__Lamf_ProfileName__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(profile) {
  var x = $m_Lamf_Raml08Profile$();
  if (x.equals__O__Z(profile)) {
    return new $c_Lamf_plugins_domain_webapi_resolution_CustomRaml08WebApiContext().init___()
  } else {
    return new $c_Lamf_plugins_domain_webapi_resolution_CustomRaml10WebApiContext().init___()
  }
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$.prototype.findUnitLocationOfElement__T__Lamf_core_model_document_BaseUnit__s_Option = (function(elementId, unit) {
  var this$1 = unit.references__sc_Seq();
  var pf = new $c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$findUnitLocationOfElement$1().init___T(elementId);
  return $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$1, pf)
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$.prototype.asOperation__Lamf_ProfileName__Lamf_core_model_domain_DataNode__Lamf_core_model_document_BaseUnit__T__Lamf_core_parser_Annotations__T__s_Option__Z__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_domain_webapi_models_Operation = (function(profile, node, unit, name, trAnnotations, extensionId, extensionLocation, keepEditingInfo, context, errorHandler) {
  var ctx = $as_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext((context.isEmpty__Z() ? $m_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$().custom__Lamf_ProfileName__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(profile) : context.get__O()));
  var referencesCollector = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var this$1 = $f_Lamf_core_model_domain_AmfElement__location__s_Option(node);
  var sourceName = $as_T((this$1.isEmpty__Z() ? "" : this$1.get__O()));
  var this$3 = new $c_Lorg_yaml_model_YDocument$WithComment().init___T__T("", sourceName);
  var b = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(this$3.org$yaml$model$YDocument$WithComment$$sourceName$f);
  var x = this$3.comment$1;
  var this$5 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$5)) {
    b.comment__T__V(this$3.comment$1)
  };
  var jsx$5 = b.builder$1;
  var sourceName$1 = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
  var jsx$3 = $m_Lorg_yaml_model_YNode$();
  var jsx$2 = $m_Lorg_yaml_model_YScalar$();
  var jsx$1 = $m_Lorg_yaml_model_YType$().Str$1;
  var this$7 = trAnnotations.find__jl_Class__s_Option($d_Lamf_core_annotations_SourceAST.getClassOf());
  if (this$7.isEmpty__Z()) {
    var xo = $m_s_None$()
  } else {
    var arg1 = this$7.get__O();
    var x$3 = $as_Lamf_core_annotations_SourceAST(arg1);
    var xo = new $c_s_Some().init___O(x$3.ast$1)
  };
  var this$9 = xo.toList__sci_List();
  var pf = new $c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asOperation$3$1().init___();
  var this$10 = $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$9, pf);
  var key = jsx$3.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(jsx$2.withLocation__T__Lorg_yaml_model_YType__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_YScalar(name, jsx$1, $as_Lamf_core_parser_Annotations((this$10.isEmpty__Z() ? trAnnotations : this$10.get__O())).sourceLocation__Lorg_mulesoft_lexer_SourceLocation()), $m_Lorg_yaml_model_YType$().Str$1);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler(node, (trAnnotations.contains__jl_Class__Z($d_Lamf_core_annotations_LexicalInformation.getClassOf()) ? $m_Lamf_core_emitter_SpecOrdering$Lexical$() : $m_Lamf_core_emitter_SpecOrdering$Default$()), true, referencesCollector, ctx.eh$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
  var this$13 = v.builder$1;
  var array = [key];
  if ((this$13.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$13.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$13, newSize);
  var len$1 = this$13.size0$6;
  var src = this$13.array$6;
  var dest = this$13.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$13.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x$1 = $uI(array.length);
  var x$2 = ((x$1 < len$2) ? x$1 : len$2);
  var that = xs.u.length;
  var end = ((x$2 < that) ? x$2 : that);
  while ((i < end)) {
    var jsx$4 = j;
    var index = i;
    xs.set(jsx$4, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$13.size0$6 = newSize;
  b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1));
  jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1));
  var document = new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this$3.org$yaml$model$YDocument$WithComment$$sourceName$f), b.builder$1);
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
  var entry = $as_Lorg_yaml_model_YMapEntry($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(document, conversion, iv)).entries$3.head__O());
  return this.entryAsOperation__Lamf_ProfileName__Lamf_core_model_document_BaseUnit__T__T__Z__Lorg_yaml_model_YMapEntry__Lamf_core_parser_Annotations__scm_Map__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_domain_webapi_models_Operation(profile, unit, name, extensionId, keepEditingInfo, entry, node.annotations__Lamf_core_parser_Annotations(), referencesCollector, context, errorHandler)
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$.prototype.entryAsEndpoint__Lamf_ProfileName__Lamf_core_model_document_BaseUnit__Lamf_core_model_domain_DataNode__T__T__Z__Lorg_yaml_model_YMapEntry__Lamf_core_parser_Annotations__Lamf_core_errorhandling_ErrorHandler__s_Option__scm_Map__s_Option__Lamf_plugins_domain_webapi_models_EndPoint = (function(profile, unit, node, name, extensionId, keepEditingInfo, entry, annotations, errorHandler, extensionLocation, referencesCollector, context) {
  var ctx = $as_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext((context.isEmpty__Z() ? $m_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$().custom__Lamf_ProfileName__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(profile) : context.get__O()));
  var collector = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  this.addDeclarations__p1__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_core_model_document_BaseUnit__T__V(ctx, unit, entry.location$1.sourceName$1);
  referencesCollector.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, ctx$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var alias = $as_T(x0$1.$$und1__O());
        var ref = $as_Lamf_core_model_domain_DomainElement(x0$1.$$und2__O());
        var jsx$2 = ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations();
        var jsx$1 = ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().fragments$1;
        var y = new $c_Lamf_core_parser_FragmentRef().init___Lamf_core_model_domain_DomainElement__s_Option(ref, $m_s_None$());
        jsx$2.fragments$1 = jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(alias, y))
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, ctx)));
  var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(name, "\\.", 0);
  var until = (((-1) + xs.u.length) | 0);
  var x = ((until > 0) ? until : 0);
  var y$1 = xs.u.length;
  var hi = ((x < y$1) ? x : y$1);
  var size = ((hi > 0) ? hi : 0);
  var result = $m_jl_reflect_Array$().newInstance__jl_Class__I__O($objectGetClass(xs).getComponentType__jl_Class(), size);
  if ((size > 0)) {
    $m_s_Array$().copy__O__I__O__I__I__V(xs, 0, result, 0, size)
  };
  var pathElements = $asArrayOf_T(result, 1);
  var adaptedDeclarations = ctx.findDeclarations__sc_Seq__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations($m_s_Predef$().wrapRefArray__AO__scm_WrappedArray(pathElements), ctx.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations());
  var arg1 = ctx.clone__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(ctx.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().merge__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations(adaptedDeclarations));
  arg1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().resourceTypes$2.$$plus$plus__sc_GenTraversableOnce__sci_Map(arg1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().traits$2).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ctx$4) {
    return (function(e$2) {
      var e = $as_T2(e$2);
      return ctx$4.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations($as_Lamf_core_model_domain_DomainElement(e.$$und2__O()))
    })
  })(this, ctx)));
  arg1.contextType$3 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().RESOURCE$undTYPE$2;
  $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser(arg1.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().endPointParser__F5().apply__O__O__O__O__O__O(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, extensionId$2) {
    return (function(x$10$2) {
      $as_T(x$10$2);
      $m_Lamf_core_parser_Annotations$();
      var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
      var fields = new $c_Lamf_core_parser_Fields().init___();
      var this$20 = new $c_Lamf_plugins_domain_webapi_models_EndPoint().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations$1);
      var value = (extensionId$2 + "/applied");
      return $as_Lamf_plugins_domain_webapi_models_EndPoint($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$20, value))
    })
  })(this, extensionId)), $m_s_None$(), collector, true)).parse__V();
  var this$21 = ctx.operationContexts$3;
  var xs$1 = arg1.operationContexts$3;
  $as_scm_Map($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$21, xs$1));
  var x1 = collector.toList__sci_List();
  if ((x1 instanceof $c_sci_$colon$colon)) {
    var x2 = $as_sci_$colon$colon(x1);
    var element = $as_Lamf_plugins_domain_webapi_models_EndPoint(x2.head$5);
    if (keepEditingInfo) {
      this.annotateExtensionId__p1__Lamf_core_model_domain_DomainElement__T__s_Option__V(element, extensionId, extensionLocation)
    };
    return $as_Lamf_plugins_domain_webapi_models_EndPoint(new $c_Lamf_core_resolution_stages_ReferenceResolutionStage().init___Z__Lamf_core_errorhandling_ErrorHandler(keepEditingInfo, errorHandler).resolveDomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(element))
  } else {
    var x$1 = $m_sci_Nil$();
    if (x$1.equals__O__Z(x1)) {
      var specification = $m_Lamf_validations_ResolutionSideValidations$().ParseResourceTypeFail$1;
      var property = $m_s_None$();
      var message = (("Couldn't parse an endpoint from resourceType '" + name) + "'.");
      var lexical = node.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      var location = $f_Lamf_core_model_domain_AmfElement__location__s_Option(node);
      errorHandler.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, extensionId, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
      return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint().init___T__Lorg_yaml_model_YPart(node.id$1, entry)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
var $d_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_ExtendsHelper$: 0
}, false, "amf.plugins.domain.webapi.resolution.ExtendsHelper$", {
  Lamf_plugins_domain_webapi_resolution_ExtendsHelper$: 1,
  O: 1
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$;
var $n_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$ = (void 0);
function $m_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$() {
  if ((!$n_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$)) {
    $n_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$ = new $c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$.prototype.merge__Lamf_core_model_domain_DataNode__Lamf_core_model_domain_DataNode__V = (function(existing, overlay) {
  matchEnd9: {
    if ((existing instanceof $c_Lamf_core_model_domain_ScalarNode)) {
      var x2 = $as_Lamf_core_model_domain_ScalarNode(existing);
      if ((overlay instanceof $c_Lamf_core_model_domain_ScalarNode)) {
        var x3 = $as_Lamf_core_model_domain_ScalarNode(overlay);
        var this$1 = $as_Lamf_core_model_StrField(x3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1));
        var this$2 = this$1.option$1;
        x2.withValue__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())), $as_Lamf_core_model_StrField(x3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1)).annotations$1);
        var this$3 = $as_Lamf_core_model_StrField(x3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().DataType$1));
        var this$4 = this$3.option$1;
        x2.withDataType__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode($as_T((this$4.isEmpty__Z() ? null : this$4.get__O())), $as_Lamf_core_model_StrField(x3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().DataType$1)).annotations$1);
        break matchEnd9
      }
    };
    if ((existing instanceof $c_Lamf_core_model_domain_ObjectNode)) {
      var x4 = $as_Lamf_core_model_domain_ObjectNode(existing);
      if ((overlay instanceof $c_Lamf_core_model_domain_ObjectNode)) {
        var x5 = $as_Lamf_core_model_domain_ObjectNode(overlay);
        this.mergeObjectNode__Lamf_core_model_domain_ObjectNode__Lamf_core_model_domain_ObjectNode__V(x4, x5);
        break matchEnd9
      }
    };
    if ((existing instanceof $c_Lamf_core_model_domain_ArrayNode)) {
      var x6 = $as_Lamf_core_model_domain_ArrayNode(existing);
      if ((overlay instanceof $c_Lamf_core_model_domain_ArrayNode)) {
        var x7 = $as_Lamf_core_model_domain_ArrayNode(overlay);
        this.mergeArrayNode__p1__Lamf_core_model_domain_ArrayNode__Lamf_core_model_domain_ArrayNode__V(x6, x7);
        break matchEnd9
      }
    }
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$.prototype.mergeArrayNode__p1__Lamf_core_model_domain_ArrayNode__Lamf_core_model_domain_ArrayNode__V = (function(main, other) {
  var jsx$2 = $as_sc_Seq(main.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ArrayNodeModel$().Member$1));
  var jsx$1 = new $c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$$anonfun$1().init___();
  var this$1 = $m_sc_Seq$();
  var existing = $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  $as_sc_Seq(other.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ArrayNodeModel$().Member$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, existing$1, main$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_domain_DataNode(x0$1$2);
      if ((x0$1 instanceof $c_Lamf_core_model_domain_ScalarNode)) {
        var x2 = $as_Lamf_core_model_domain_ScalarNode(x0$1);
        return ((!existing$1.contains__O__Z($as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1)))) ? main$1.addMember__Lamf_core_model_domain_DataNode__sc_Seq(x2) : (void 0))
      } else {
        return main$1.addMember__Lamf_core_model_domain_DataNode__sc_Seq($m_Lamf_core_model_domain_DataNodeOps$().adoptTree__T__Lamf_core_model_domain_DataNode__Lamf_core_model_domain_DataNode(main$1.id$1, x0$1))
      }
    })
  })(this, existing, main)))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$.prototype.mergeObjectNode__Lamf_core_model_domain_ObjectNode__Lamf_core_model_domain_ObjectNode__V = (function(left, right) {
  var jsx$2 = right.propertyFields__sc_Iterable();
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, right$1) {
    return (function(f$2) {
      var f = $as_Lamf_core_metamodel_Field(f$2);
      return new $c_T2().init___O__O(f, right$1.fields$2.apply__Lamf_core_metamodel_Field__O(f))
    })
  })(this, right));
  var this$1 = $m_sc_Iterable$();
  $as_sc_TraversableLike(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).withFilter__F1__scg_FilterMonadic(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(check$ifrefutable$1$2) {
      var check$ifrefutable$1 = $as_T2(check$ifrefutable$1$2);
      return (check$ifrefutable$1 !== null)
    })
  })(this))).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3, left$1, right$2) {
    return (function(x$8$2) {
      var x$8 = $as_T2(x$8$2);
      if ((x$8 !== null)) {
        var key = $as_Lamf_core_metamodel_Field(x$8.$$und1__O());
        var value = $as_Lamf_core_model_domain_DataNode(x$8.$$und2__O());
        var this$4 = left$1.fields$2;
        var x1$2 = this$4.fs$1.get__O__s_Option(key);
        if ((x1$2 instanceof $c_s_Some)) {
          var x2 = $as_s_Some(x1$2);
          var p3 = $as_Lamf_core_parser_Value(x2.value$2);
          var o12 = $m_Lamf_core_parser_Value$().unapply__Lamf_core_parser_Value__s_Option(p3);
          if ((!o12.isEmpty__Z())) {
            var property = $as_Lamf_core_model_domain_AmfElement($as_T2(o12.get__O()).$$und1__O());
            if ((property instanceof $c_Lamf_core_model_domain_DataNode)) {
              var x6 = $as_Lamf_core_model_domain_DataNode(property);
              $m_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$().merge__Lamf_core_model_domain_DataNode__Lamf_core_model_domain_DataNode__V(x6, value);
              return (void 0)
            }
          }
        };
        var x = $m_s_None$();
        if ((x === x1$2)) {
          return left$1.addPropertyByField__Lamf_core_metamodel_Field__Lamf_core_model_domain_DataNode__Lamf_core_parser_Annotations__Lamf_core_model_domain_ObjectNode(key, $m_Lamf_core_model_domain_DataNodeOps$().adoptTree__T__Lamf_core_model_domain_DataNode__Lamf_core_model_domain_DataNode(left$1.id$1, value), right$2.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value(key).annotations$1)
        };
        throw new $c_s_MatchError().init___O(x1$2)
      } else {
        throw new $c_s_MatchError().init___O(x$8)
      }
    })
  })(this, left, right)))
});
var $d_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.DataNodeMerging$", {
  Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$: 1,
  O: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$;
var $n_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$ = (void 0);
function $m_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$() {
  if ((!$n_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$)) {
    $n_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$ = new $c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$() {
  $c_O.call(this);
  this.reportedMissingParameters$1 = null
}
$c_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$ = this;
  this.reportedMissingParameters$1 = new $c_scm_HashMap().init___();
  return this
});
$c_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$.prototype.validate__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_errorhandling_ErrorHandler__V = (function(main, other, errorHandler) {
  matchEnd9: {
    if ((main instanceof $c_Lamf_plugins_domain_webapi_models_Request)) {
      var x2 = $as_Lamf_plugins_domain_webapi_models_Request(main);
      if ((other instanceof $c_Lamf_plugins_domain_webapi_models_Request)) {
        var x3 = $as_Lamf_plugins_domain_webapi_models_Request(other);
        this.validatePayloads__p1__Lamf_core_model_domain_DomainElement__Lamf_core_errorhandling_ErrorHandler__sc_Seq__sc_Seq__V(main, errorHandler, $as_sc_Seq(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1)), $as_sc_Seq(x3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1)));
        break matchEnd9
      }
    };
    if ((main instanceof $c_Lamf_plugins_domain_webapi_models_Response)) {
      var x4 = $as_Lamf_plugins_domain_webapi_models_Response(main);
      if ((other instanceof $c_Lamf_plugins_domain_webapi_models_Response)) {
        var x5 = $as_Lamf_plugins_domain_webapi_models_Response(other);
        this.validatePayloads__p1__Lamf_core_model_domain_DomainElement__Lamf_core_errorhandling_ErrorHandler__sc_Seq__sc_Seq__V(main, errorHandler, $as_sc_Seq(x4.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1)), $as_sc_Seq(x5.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1)));
        break matchEnd9
      }
    };
    if ((main instanceof $c_Lamf_plugins_domain_webapi_models_EndPoint)) {
      var x6 = $as_Lamf_plugins_domain_webapi_models_EndPoint(main);
      if ((other instanceof $c_Lamf_plugins_domain_webapi_models_EndPoint)) {
        var x7 = $as_Lamf_plugins_domain_webapi_models_EndPoint(other);
        this.validateEndpoints__p1__Lamf_core_model_domain_DomainElement__Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_domain_webapi_models_EndPoint__V(main, errorHandler, x6, x7);
        break matchEnd9
      }
    }
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$.prototype.validateEndpoints__p1__Lamf_core_model_domain_DomainElement__Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_domain_webapi_models_EndPoint__V = (function(main, errorHandler, m, o) {
  var jsx$1 = $m_Lamf_core_utils_package$TemplateUri$();
  var this$1 = $as_Lamf_core_model_StrField(m.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1));
  var this$2 = this$1.option$1;
  var pathParams = jsx$1.variables__T__sc_Seq($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())));
  var checkParameter = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this, m$1, pathParams$1, errorHandler$1) {
    return (function(p$2, isOperation$2) {
      var p = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2);
      var isOperation = $uZ(isOperation$2);
      var maybeReported = $m_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$().reportedMissingParameters$1.get__O__s_Option(m$1.id$1);
      if ((maybeReported instanceof $c_s_Some)) {
        var x2 = $as_s_Some(maybeReported);
        var alreadyReported = $as_sc_Seq(x2.value$2);
        var reported = alreadyReported.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, p$1) {
          return (function(x$9$2) {
            var x$9 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$9$2);
            var this$3 = $as_Lamf_core_model_StrField(x$9.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
            var this$4 = this$3.option$1;
            var jsx$2 = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
            var this$5 = $as_Lamf_core_model_StrField(p$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
            var this$6 = this$5.option$1;
            return (jsx$2 === $as_T((this$6.isEmpty__Z() ? null : this$6.get__O())))
          })
        })($this, p)))
      } else {
        var reported = false
      };
      var this$7 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1)).option$1;
      if ((!this$7.isEmpty__Z())) {
        var arg1 = this$7.get__O();
        var n = $as_T(arg1);
        var jsx$3 = pathParams$1.contains__O__Z(n)
      } else {
        var jsx$3 = false
      };
      var unused = (!jsx$3);
      if (((!reported) && unused)) {
        var jsx$6 = $m_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$().reportedMissingParameters$1;
        var self = m$1.id$1;
        var this$9 = $m_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$().reportedMissingParameters$1;
        var key = m$1.id$1;
        var x1 = this$9.get__O__s_Option(key);
        if ((x1 instanceof $c_s_Some)) {
          var x2$1 = $as_s_Some(x1);
          var v = x2$1.value$2;
          var jsx$5 = v
        } else {
          var x = $m_s_None$();
          if ((!(x === x1))) {
            throw new $c_s_MatchError().init___O(x1)
          };
          $m_sc_Seq$();
          $m_sci_Seq$();
          var this$12 = new $c_scm_ListBuffer().init___();
          var jsx$5 = this$12.toList__sci_List()
        };
        var jsx$4 = $as_sc_SeqLike(jsx$5);
        var this$13 = $m_sc_Seq$();
        var y = jsx$4.$$colon$plus__O__scg_CanBuildFrom__O(p, this$13.ReusableCBFInstance$2);
        jsx$6.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(self, y));
        if (isOperation) {
          var this$15 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
          var this$16 = this$15.option$1;
          var message = ("Unused operation uri parameter " + $as_T((this$16.isEmpty__Z() ? null : this$16.get__O())))
        } else {
          var this$17 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
          var this$18 = this$17.option$1;
          var message = ("Unused uri parameter " + $as_T((this$18.isEmpty__Z() ? null : this$18.get__O())))
        };
        errorHandler$1.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V($m_Lamf_validations_ParserSideValidations$().UnusedBaseUriParameter$1, p.id$1, $m_s_None$(), message, p.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), $f_Lamf_core_model_domain_AmfElement__location__s_Option(p))
      }
    })
  })(this, m, pathParams, errorHandler));
  $as_sc_Seq(o.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, checkParameter$1) {
    return (function(x$10$2) {
      var x$10 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$10$2);
      checkParameter$1.apply__O__O__O(x$10, false)
    })
  })(this, checkParameter)));
  var jsx$10 = $as_sc_Seq(o.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1));
  var jsx$9 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(o$2$2) {
      var o$2 = $as_Lamf_plugins_domain_webapi_models_Operation(o$2$2);
      var xo = $m_s_Option$().apply__O__s_Option(o$2.request__Lamf_plugins_domain_webapi_models_Request());
      return xo.toList__sci_List()
    })
  })(this));
  var this$20 = $m_sc_Seq$();
  var jsx$8 = $as_sc_TraversableLike(jsx$10.flatMap__F1__scg_CanBuildFrom__O(jsx$9, this$20.ReusableCBFInstance$2));
  var jsx$7 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
    return (function(x$11$2) {
      var x$11 = $as_Lamf_plugins_domain_webapi_models_Request(x$11$2);
      return $as_sc_Seq(x$11.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().UriParameters$1))
    })
  })(this));
  var this$21 = $m_sc_Seq$();
  $as_sc_IterableLike(jsx$8.flatMap__F1__scg_CanBuildFrom__O(jsx$7, this$21.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1, checkParameter$2) {
    return (function(x$12$2) {
      var x$12 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$12$2);
      checkParameter$2.apply__O__O__O(x$12, true)
    })
  })(this, checkParameter)))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$.prototype.validatePayloads__p1__Lamf_core_model_domain_DomainElement__Lamf_core_errorhandling_ErrorHandler__sc_Seq__sc_Seq__V = (function(main, errorHandler, m, o) {
  var f = (function($this) {
    return (function(payloads$2) {
      var payloads = $as_sc_Seq(payloads$2);
      return (payloads.nonEmpty__Z() && payloads.forall__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
        return (function(payload$2) {
          var payload = $as_Lamf_plugins_domain_webapi_models_Payload(payload$2);
          return ((payload !== null) && (!payload.annotations$1.contains__jl_Class__Z($d_Lamf_plugins_document_webapi_annotations_EmptyPayload.getClassOf())))
        })
      })($this))))
    })
  })(this);
  var shouldReviseBoth = ($uZ(f(m)) && $uZ(f(o)));
  if (shouldReviseBoth) {
    var mainPayloadsDefineMediaType = m.forall__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
      return (function(payload$2$1) {
        var payload$1 = $as_Lamf_plugins_domain_webapi_models_Payload(payload$2$1);
        return $as_Lamf_core_model_StrField(payload$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1)).option$1.isDefined__Z()
      })
    })(this)));
    var otherPayloadsDefineMediaType = o.forall__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3) {
      return (function(payload$3$2) {
        var payload$3 = $as_Lamf_plugins_domain_webapi_models_Payload(payload$3$2);
        return $as_Lamf_core_model_StrField(payload$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1)).option$1.isDefined__Z()
      })
    })(this)));
    if ((mainPayloadsDefineMediaType !== otherPayloadsDefineMediaType)) {
      var specification = $m_Lamf_validations_ResolutionSideValidations$().UnequalMediaTypeDefinitionsInExtendsPayloads$1;
      var node = main.id__T();
      var property = $m_s_None$();
      var message = $m_Lamf_validations_ResolutionSideValidations$().UnequalMediaTypeDefinitionsInExtendsPayloads$1.message$1;
      var lexical = main.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      var location = main.location__s_Option();
      errorHandler.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
    }
  }
});
var $d_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.MergingValidator$", {
  Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$: 1,
  O: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$;
var $n_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$ = (void 0);
function $m_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$() {
  if ((!$n_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$)) {
    $n_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$ = new $c_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$
}
/** @constructor */
function $c_Lamf_plugins_features_AMFValidation$() {
  $c_O.call(this)
}
$c_Lamf_plugins_features_AMFValidation$.prototype = new $h_O();
$c_Lamf_plugins_features_AMFValidation$.prototype.constructor = $c_Lamf_plugins_features_AMFValidation$;
/** @constructor */
function $h_Lamf_plugins_features_AMFValidation$() {
  /*<skip>*/
}
$h_Lamf_plugins_features_AMFValidation$.prototype = $c_Lamf_plugins_features_AMFValidation$.prototype;
$c_Lamf_plugins_features_AMFValidation$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_features_AMFValidation$.prototype.$$js$exported$meth$register__O = (function() {
  $m_Lamf_Core$();
  var plugin = $m_Lamf_plugins_features_validation_AMFValidatorPlugin$();
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V(plugin)
});
$c_Lamf_plugins_features_AMFValidation$.prototype.register = (function() {
  return this.$$js$exported$meth$register__O()
});
var $d_Lamf_plugins_features_AMFValidation$ = new $TypeData().initClass({
  Lamf_plugins_features_AMFValidation$: 0
}, false, "amf.plugins.features.AMFValidation$", {
  Lamf_plugins_features_AMFValidation$: 1,
  O: 1
});
$c_Lamf_plugins_features_AMFValidation$.prototype.$classData = $d_Lamf_plugins_features_AMFValidation$;
var $n_Lamf_plugins_features_AMFValidation$ = (void 0);
function $m_Lamf_plugins_features_AMFValidation$() {
  if ((!$n_Lamf_plugins_features_AMFValidation$)) {
    $n_Lamf_plugins_features_AMFValidation$ = new $c_Lamf_plugins_features_AMFValidation$().init___()
  };
  return $n_Lamf_plugins_features_AMFValidation$
}
/** @constructor */
function $c_Lamf_plugins_features_validation_CustomShaclValidator() {
  $c_O.call(this);
  this.model$1 = null;
  this.validations$1 = null;
  this.customFunctions$1 = null;
  this.options$1 = null;
  this.executionContext$1 = null;
  this.validationReport$1 = null
}
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype = new $h_O();
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.constructor = $c_Lamf_plugins_features_validation_CustomShaclValidator;
/** @constructor */
function $h_Lamf_plugins_features_validation_CustomShaclValidator() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_CustomShaclValidator.prototype = $c_Lamf_plugins_features_validation_CustomShaclValidator.prototype;
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_FunctionConstraint__T__Lamf_core_parser_Annotations__s_Option__V = (function(validationSpecification, functionConstraint, id, annotations, propertyPath) {
  var jsx$2 = this.validationReport$1;
  var x1 = this.options$1.messageStyle$1;
  var x = $m_Lamf_RAMLStyle$();
  if ((x === x1)) {
    var this$1 = validationSpecification.ramlMessage$1;
    var jsx$1 = (this$1.isEmpty__Z() ? new $c_s_Some().init___O(validationSpecification.message$1) : this$1)
  } else {
    var x$3 = $m_Lamf_OASStyle$();
    if ((x$3 === x1)) {
      var this$2 = validationSpecification.oasMessage$1;
      var jsx$1 = (this$2.isEmpty__Z() ? new $c_s_Some().init___O(validationSpecification.message$1) : this$2)
    } else {
      var jsx$1 = new $c_s_Some().init___O(validationSpecification.message$1)
    }
  };
  jsx$2.registerResult__Lamf_core_validation_core_ValidationResult__V(new $c_Lamf_plugins_features_validation_CustomValidationResult().init___s_Option__T__T__T__T__T(jsx$1, $as_T((propertyPath.isEmpty__Z() ? "" : propertyPath.get__O())), validationSpecification.id$1, id, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, validationSpecification.id$1))
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.extractPredicateValue__T__Lamf_core_model_domain_DomainElement__s_Option = (function(predicate, element) {
  var this$1 = element.meta__Lamf_core_metamodel_Obj().fields__sci_List();
  inlinereturn$1: {
    var these = this$1;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      var f = $as_Lamf_core_metamodel_Field(arg1);
      if ((f.value$1.iri__T() === predicate)) {
        var x1 = new $c_s_Some().init___O(these.head__O());
        break inlinereturn$1
      };
      these = $as_sc_LinearSeqOptimized(these.tail__O())
    };
    var x1 = $m_s_None$()
  };
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var f$3 = $as_Lamf_core_metamodel_Field(x2.value$2);
    var rc5 = false;
    var x2$2 = null;
    var x1$2 = $m_s_Option$().apply__O__s_Option(element.fields__Lamf_core_parser_Fields().getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value(f$3));
    if ((x1$2 instanceof $c_s_Some)) {
      rc5 = true;
      x2$2 = $as_s_Some(x1$2);
      var value = $as_Lamf_core_parser_Value(x2$2.value$2);
      if ((value.value$1 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
        return new $c_s_Some().init___O(new $c_T3().init___O__O__O(value.annotations$1, value.value$1, new $c_s_Some().init___O(this.amfScalarToScala__Lamf_core_model_domain_AmfScalar__O($as_Lamf_core_model_domain_AmfScalar(value.value$1)))))
      }
    };
    if (rc5) {
      var value$2 = $as_Lamf_core_parser_Value(x2$2.value$2);
      return new $c_s_Some().init___O(new $c_T3().init___O__O__O(value$2.annotations$1, value$2.value$1, $m_s_None$()))
    };
    return $m_s_None$()
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.matchingClass__Lamf_core_validation_core_ValidationSpecification__sc_Seq__Z = (function(specification, classes) {
  return specification.targetClass$1.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, classes$1) {
    return (function(elem$2) {
      return classes$1.contains__O__Z(elem$2)
    })
  })(this, classes)))
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.validate__Lamf_core_validation_core_ValidationSpecification__Lamf_core_model_domain_DomainElement__V = (function(validationSpecification, element) {
  var x1 = validationSpecification.closed$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var closed = $uZ(x2.value$2);
    this.validateClosed__Lamf_core_validation_core_ValidationSpecification__Lamf_core_model_domain_DomainElement__Z__V(validationSpecification, element, closed)
  };
  var x1$2 = validationSpecification.custom$1;
  if ((x1$2 instanceof $c_s_Some)) {
    this.validateCustom__Lamf_core_validation_core_ValidationSpecification__Lamf_core_model_domain_DomainElement__V(validationSpecification, element)
  };
  var x1$3 = validationSpecification.functionConstraint$1;
  if ((x1$3 instanceof $c_s_Some)) {
    this.validateFunctionConstraint__Lamf_core_validation_core_ValidationSpecification__Lamf_core_model_domain_DomainElement__V(validationSpecification, element)
  };
  var x1$4 = validationSpecification.replacesFunctionConstraint$1;
  if ((x1$4 instanceof $c_s_Some)) {
    var x2$2 = $as_s_Some(x1$4);
    var functionConstraintName = $as_T(x2$2.value$2);
    var x$1 = new $c_s_Some().init___O(validationSpecification.message$1);
    var x$2 = new $c_s_Some().init___O(functionConstraintName);
    var x$3 = $m_s_None$();
    var x$4 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var x$5 = $m_s_None$();
    var x$6 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var x$7 = new $c_s_Some().init___O(new $c_Lamf_core_validation_core_FunctionConstraint().init___s_Option__s_Option__sc_Seq__s_Option__sc_Seq__s_Option(x$1, x$3, x$4, x$5, x$6, x$2));
    var x$8 = validationSpecification.name$1;
    var x$9 = validationSpecification.message$1;
    var x$10 = validationSpecification.ramlMessage$1;
    var x$11 = validationSpecification.oasMessage$1;
    var x$12 = validationSpecification.targetInstance$1;
    var x$13 = validationSpecification.targetClass$1;
    var x$14 = validationSpecification.targetObject$1;
    var x$15 = validationSpecification.unionConstraints$1;
    var x$16 = validationSpecification.andConstraints$1;
    var x$17 = validationSpecification.xoneConstraints$1;
    var x$18 = validationSpecification.notConstraint$1;
    var x$19 = validationSpecification.propertyConstraints$1;
    var x$20 = validationSpecification.nodeConstraints$1;
    var x$21 = validationSpecification.closed$1;
    var x$22 = validationSpecification.custom$1;
    var x$23 = validationSpecification.nested$1;
    var x$24 = validationSpecification.replacesFunctionConstraint$1;
    var x$25 = validationSpecification.query$1;
    this.validateFunctionConstraint__Lamf_core_validation_core_ValidationSpecification__Lamf_core_model_domain_DomainElement__V(new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$8, x$9, x$10, x$11, x$12, x$13, x$14, x$15, x$16, x$17, x$18, x$19, x$20, x$21, x$7, x$22, x$23, x$24, x$25), element)
  } else {
    validationSpecification.propertyConstraints$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, validationSpecification$1, element$1) {
      return (function(propertyConstraint$2) {
        var propertyConstraint = $as_Lamf_core_validation_core_PropertyConstraint(propertyConstraint$2);
        $this.validatePropertyConstraint__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V(validationSpecification$1, propertyConstraint, element$1)
      })
    })(this, validationSpecification, element)))
  }
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.validatePattern__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V = (function(validationSpecification, propertyConstraint, parentElement) {
  var rc14 = false;
  var x2 = null;
  var x1 = this.extractPredicateValue__T__Lamf_core_model_domain_DomainElement__s_Option(propertyConstraint.ramlPropertyId$1, parentElement);
  matchEnd15: {
    if ((x1 instanceof $c_s_Some)) {
      rc14 = true;
      x2 = $as_s_Some(x1);
      var p3 = $as_T3(x2.value$2);
      if ((p3 !== null)) {
        var scalar = $as_Lamf_core_model_domain_AmfElement(p3.$$und2$1);
        var p5 = $as_s_Option(p3.$$und3$1);
        if ((scalar instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x11 = $as_Lamf_core_model_domain_AmfScalar(scalar);
          if ((p5 instanceof $c_s_Some)) {
            var x6 = $as_s_Some(p5);
            var value = x6.value$2;
            if ($m_s_Option$().apply__O__s_Option(value).isDefined__Z()) {
              var x = $as_T(propertyConstraint.pattern$1.get__O());
              var this$2 = new $c_sci_StringOps().init___T(x);
              var groupNames = $m_sci_Nil$();
              var $$this = this$2.repr$1;
              var jsx$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames).findFirstIn__jl_CharSequence__s_Option($objectToString(value)).isEmpty__Z()
            } else {
              var jsx$1 = false
            };
            if (jsx$1) {
              this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x11.annotations$1);
              break matchEnd15
            } else {
              break matchEnd15
            }
          }
        }
      }
    };
    if (rc14) {
      var p8 = $as_T3(x2.value$2);
      if ((p8 !== null)) {
        var arr = $as_Lamf_core_model_domain_AmfElement(p8.$$und2$1);
        if ((arr instanceof $c_Lamf_core_model_domain_AmfArray)) {
          var x12 = $as_Lamf_core_model_domain_AmfArray(arr);
          x12.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, propertyConstraint$1, validationSpecification$1, parentElement$1) {
            return (function(x0$1$2) {
              var x0$1 = $as_Lamf_core_model_domain_AmfElement(x0$1$2);
              if ((x0$1 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
                var x2$1 = $as_Lamf_core_model_domain_AmfScalar(x0$1);
                if ($m_s_Option$().apply__O__s_Option(x2$1).isDefined__Z()) {
                  var x$1 = $as_T(propertyConstraint$1.pattern$1.get__O());
                  var this$5 = new $c_sci_StringOps().init___T(x$1);
                  var groupNames$1 = $m_sci_Nil$();
                  var $$this$1 = this$5.repr$1;
                  var jsx$2 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this$1, groupNames$1).findFirstIn__jl_CharSequence__s_Option(x2$1.toString__T()).isEmpty__Z()
                } else {
                  var jsx$2 = false
                };
                if (jsx$2) {
                  $this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification$1, propertyConstraint$1, parentElement$1.id__T(), x2$1.annotations$1)
                }
              }
            })
          })(this, propertyConstraint, validationSpecification, parentElement)));
          break matchEnd15
        }
      }
    }
  }
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.validateFunctionConstraint__Lamf_core_validation_core_ValidationSpecification__Lamf_core_model_domain_DomainElement__V = (function(validationSpecification, element) {
  var functionConstraint = $as_Lamf_core_validation_core_FunctionConstraint(validationSpecification.functionConstraint$1.get__O());
  var this$1 = functionConstraint.internalFunction$1;
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var name = $as_T(arg1);
    var validationFunction = this.getFunctionForName__T__F2(name);
    var onViolation = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, validationSpecification$3, functionConstraint$1, element$4) {
      return (function(propertyInfo$2) {
        var propertyInfo = $as_s_Option(propertyInfo$2);
        matchEnd6: {
          if ((propertyInfo instanceof $c_s_Some)) {
            var x2 = $as_s_Some(propertyInfo);
            var p3 = $as_T2(x2.value$2);
            if ((p3 !== null)) {
              var field = $as_Lamf_core_metamodel_Field(p3.$$und2__O());
              $this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_FunctionConstraint__T__Lamf_core_parser_Annotations__s_Option__V(validationSpecification$3, functionConstraint$1, element$4.id__T(), element$4.annotations__Lamf_core_parser_Annotations(), new $c_s_Some().init___O(field.value$1.iri__T()));
              break matchEnd6
            }
          };
          $this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_FunctionConstraint__T__Lamf_core_parser_Annotations__s_Option__V(validationSpecification$3, functionConstraint$1, element$4.id__T(), element$4.annotations__Lamf_core_parser_Annotations(), $m_s_None$())
        }
      })
    })(this, validationSpecification, functionConstraint, element));
    validationFunction.apply__O__O__O(element, onViolation)
  }
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_core_validation_EffectiveValidations__sci_Map__Lamf_core_services_ValidationOptions__s_concurrent_ExecutionContext = (function(model, validations, customFunctions, options, executionContext) {
  this.model$1 = model;
  this.validations$1 = validations;
  this.customFunctions$1 = customFunctions;
  this.options$1 = options;
  this.executionContext$1 = executionContext;
  this.validationReport$1 = new $c_Lamf_plugins_features_validation_CustomValidationReport().init___sci_List($m_sci_Nil$());
  return this
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.validateMinInclusive__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V = (function(validationSpecification, propertyConstraint, parentElement) {
  var rc31 = false;
  var x2 = null;
  var x1 = this.extractPredicateValue__T__Lamf_core_model_domain_DomainElement__s_Option(propertyConstraint.ramlPropertyId$1, parentElement);
  matchEnd32: {
    if ((x1 instanceof $c_s_Some)) {
      rc31 = true;
      x2 = $as_s_Some(x1);
      var p3 = $as_T3(x2.value$2);
      if ((p3 !== null)) {
        var scalar = $as_Lamf_core_model_domain_AmfElement(p3.$$und2$1);
        var p5 = $as_s_Option(p3.$$und3$1);
        if ((scalar instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x22 = $as_Lamf_core_model_domain_AmfScalar(scalar);
          if ((p5 instanceof $c_s_Some)) {
            var x6 = $as_s_Some(p5);
            var value = x6.value$2;
            if ((value instanceof $c_sjsr_RuntimeLong)) {
              var t = $uJ(value);
              var lo = t.lo$2;
              var hi = t.hi$2;
              var thiz = $as_T(propertyConstraint.minInclusive$1.get__O());
              if (($uI(thiz.indexOf(".")) !== (-1))) {
                var x = $as_T(propertyConstraint.minInclusive$1.get__O());
                var this$5 = new $c_sci_StringOps().init___T(x);
                var jsx$1 = $m_jl_Double$();
                var $$this = this$5.repr$1;
                if ((!(jsx$1.parseDouble__T__D($$this) <= $m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toDouble__I__I__D(lo, hi)))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x22.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              } else {
                var x$1 = $as_T(propertyConstraint.minInclusive$1.get__O());
                var this$8 = new $c_sci_StringOps().init___T(x$1);
                var this$10 = $m_jl_Long$();
                var $$this$1 = this$8.repr$1;
                var t$1 = this$10.parseLong__T__I__J($$this$1, 10);
                var lo$1 = t$1.lo$2;
                var hi$1 = t$1.hi$2;
                if ((!((hi$1 === hi) ? (((-2147483648) ^ lo$1) <= ((-2147483648) ^ lo)) : (hi$1 < hi)))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x22.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              }
            }
          }
        }
      }
    };
    if (rc31) {
      var p8 = $as_T3(x2.value$2);
      if ((p8 !== null)) {
        var scalar$2 = $as_Lamf_core_model_domain_AmfElement(p8.$$und2$1);
        var p10 = $as_s_Option(p8.$$und3$1);
        if ((scalar$2 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x24 = $as_Lamf_core_model_domain_AmfScalar(scalar$2);
          if ((p10 instanceof $c_s_Some)) {
            var x11 = $as_s_Some(p10);
            var value$2 = x11.value$2;
            if ($isInt(value$2)) {
              var x25 = $asInt(value$2);
              var thiz$1 = $as_T(propertyConstraint.minInclusive$1.get__O());
              if (($uI(thiz$1.indexOf(".")) !== (-1))) {
                var x$2 = $as_T(propertyConstraint.minInclusive$1.get__O());
                var this$15 = new $c_sci_StringOps().init___T(x$2);
                var jsx$2 = $m_jl_Double$();
                var $$this$2 = this$15.repr$1;
                if ((!(jsx$2.parseDouble__T__D($$this$2) <= $uI(x25)))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x24.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              } else {
                var x$3 = $as_T(propertyConstraint.minInclusive$1.get__O());
                var this$19 = new $c_sci_StringOps().init___T(x$3);
                var this$21 = $m_jl_Integer$();
                var $$this$3 = this$19.repr$1;
                if ((!(this$21.parseInt__T__I__I($$this$3, 10) <= $uI(x25)))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x24.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              }
            }
          }
        }
      }
    };
    if (rc31) {
      var p13 = $as_T3(x2.value$2);
      if ((p13 !== null)) {
        var scalar$3 = $as_Lamf_core_model_domain_AmfElement(p13.$$und2$1);
        var p15 = $as_s_Option(p13.$$und3$1);
        if ((scalar$3 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x26 = $as_Lamf_core_model_domain_AmfScalar(scalar$3);
          if ((p15 instanceof $c_s_Some)) {
            var x16 = $as_s_Some(p15);
            var value$3 = x16.value$2;
            if ($isFloat(value$3)) {
              var x27 = $uF(value$3);
              var thiz$2 = $as_T(propertyConstraint.minInclusive$1.get__O());
              if (($uI(thiz$2.indexOf(".")) !== (-1))) {
                var x$4 = $as_T(propertyConstraint.minInclusive$1.get__O());
                var this$27 = new $c_sci_StringOps().init___T(x$4);
                var jsx$3 = $m_jl_Double$();
                var $$this$4 = this$27.repr$1;
                if ((!(jsx$3.parseDouble__T__D($$this$4) <= x27))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x26.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              } else {
                var x$5 = $as_T(propertyConstraint.minInclusive$1.get__O());
                var this$30 = new $c_sci_StringOps().init___T(x$5);
                var $$this$5 = this$30.repr$1;
                if ((!($fround($m_jl_Double$().parseDouble__T__D($$this$5)) <= x27))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x26.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              }
            }
          }
        }
      }
    };
    if (rc31) {
      var p18 = $as_T3(x2.value$2);
      if ((p18 !== null)) {
        var scalar$4 = $as_Lamf_core_model_domain_AmfElement(p18.$$und2$1);
        var p20 = $as_s_Option(p18.$$und3$1);
        if ((scalar$4 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x28 = $as_Lamf_core_model_domain_AmfScalar(scalar$4);
          if ((p20 instanceof $c_s_Some)) {
            var x21 = $as_s_Some(p20);
            var value$4 = x21.value$2;
            if (((typeof value$4) === "number")) {
              var x29 = $uD(value$4);
              var thiz$3 = $as_T(propertyConstraint.minInclusive$1.get__O());
              if (($uI(thiz$3.indexOf(".")) !== (-1))) {
                var x$6 = $as_T(propertyConstraint.minInclusive$1.get__O());
                var this$37 = new $c_sci_StringOps().init___T(x$6);
                var jsx$4 = $m_jl_Double$();
                var $$this$6 = this$37.repr$1;
                if ((!(jsx$4.parseDouble__T__D($$this$6) <= x29))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x28.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              } else {
                var x$7 = $as_T(propertyConstraint.minInclusive$1.get__O());
                var this$40 = new $c_sci_StringOps().init___T(x$7);
                var $$this$7 = this$40.repr$1;
                if ((!($fround($m_jl_Double$().parseDouble__T__D($$this$7)) <= x29))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x28.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              }
            }
          }
        }
      }
    }
  }
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.validateMaxInclusive__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V = (function(validationSpecification, propertyConstraint, parentElement) {
  var rc31 = false;
  var x2 = null;
  var x1 = this.extractPredicateValue__T__Lamf_core_model_domain_DomainElement__s_Option(propertyConstraint.ramlPropertyId$1, parentElement);
  matchEnd32: {
    if ((x1 instanceof $c_s_Some)) {
      rc31 = true;
      x2 = $as_s_Some(x1);
      var p3 = $as_T3(x2.value$2);
      if ((p3 !== null)) {
        var scalar = $as_Lamf_core_model_domain_AmfElement(p3.$$und2$1);
        var p5 = $as_s_Option(p3.$$und3$1);
        if ((scalar instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x22 = $as_Lamf_core_model_domain_AmfScalar(scalar);
          if ((p5 instanceof $c_s_Some)) {
            var x6 = $as_s_Some(p5);
            var value = x6.value$2;
            if ((value instanceof $c_sjsr_RuntimeLong)) {
              var t = $uJ(value);
              var lo = t.lo$2;
              var hi = t.hi$2;
              var thiz = $as_T(propertyConstraint.maxInclusive$1.get__O());
              if (($uI(thiz.indexOf(".")) !== (-1))) {
                var x = $as_T(propertyConstraint.maxInclusive$1.get__O());
                var this$5 = new $c_sci_StringOps().init___T(x);
                var jsx$1 = $m_jl_Double$();
                var $$this = this$5.repr$1;
                if ((!(jsx$1.parseDouble__T__D($$this) >= $m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toDouble__I__I__D(lo, hi)))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x22.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              } else {
                var x$1 = $as_T(propertyConstraint.maxInclusive$1.get__O());
                var this$8 = new $c_sci_StringOps().init___T(x$1);
                var this$10 = $m_jl_Long$();
                var $$this$1 = this$8.repr$1;
                var t$1 = this$10.parseLong__T__I__J($$this$1, 10);
                var lo$1 = t$1.lo$2;
                var hi$1 = t$1.hi$2;
                if ((!((hi$1 === hi) ? (((-2147483648) ^ lo$1) >= ((-2147483648) ^ lo)) : (hi$1 > hi)))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x22.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              }
            }
          }
        }
      }
    };
    if (rc31) {
      var p8 = $as_T3(x2.value$2);
      if ((p8 !== null)) {
        var scalar$2 = $as_Lamf_core_model_domain_AmfElement(p8.$$und2$1);
        var p10 = $as_s_Option(p8.$$und3$1);
        if ((scalar$2 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x24 = $as_Lamf_core_model_domain_AmfScalar(scalar$2);
          if ((p10 instanceof $c_s_Some)) {
            var x11 = $as_s_Some(p10);
            var value$2 = x11.value$2;
            if ($isInt(value$2)) {
              var x25 = $asInt(value$2);
              var thiz$1 = $as_T(propertyConstraint.maxInclusive$1.get__O());
              if (($uI(thiz$1.indexOf(".")) !== (-1))) {
                var x$2 = $as_T(propertyConstraint.maxInclusive$1.get__O());
                var this$15 = new $c_sci_StringOps().init___T(x$2);
                var jsx$2 = $m_jl_Double$();
                var $$this$2 = this$15.repr$1;
                if ((!(jsx$2.parseDouble__T__D($$this$2) >= $uI(x25)))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x24.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              } else {
                var x$3 = $as_T(propertyConstraint.maxInclusive$1.get__O());
                var this$19 = new $c_sci_StringOps().init___T(x$3);
                var this$21 = $m_jl_Integer$();
                var $$this$3 = this$19.repr$1;
                if ((!(this$21.parseInt__T__I__I($$this$3, 10) >= $uI(x25)))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x24.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              }
            }
          }
        }
      }
    };
    if (rc31) {
      var p13 = $as_T3(x2.value$2);
      if ((p13 !== null)) {
        var scalar$3 = $as_Lamf_core_model_domain_AmfElement(p13.$$und2$1);
        var p15 = $as_s_Option(p13.$$und3$1);
        if ((scalar$3 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x26 = $as_Lamf_core_model_domain_AmfScalar(scalar$3);
          if ((p15 instanceof $c_s_Some)) {
            var x16 = $as_s_Some(p15);
            var value$3 = x16.value$2;
            if ($isFloat(value$3)) {
              var x27 = $uF(value$3);
              var thiz$2 = $as_T(propertyConstraint.maxInclusive$1.get__O());
              if (($uI(thiz$2.indexOf(".")) !== (-1))) {
                var x$4 = $as_T(propertyConstraint.maxInclusive$1.get__O());
                var this$27 = new $c_sci_StringOps().init___T(x$4);
                var jsx$3 = $m_jl_Double$();
                var $$this$4 = this$27.repr$1;
                if ((!(jsx$3.parseDouble__T__D($$this$4) >= x27))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x26.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              } else {
                var x$5 = $as_T(propertyConstraint.maxInclusive$1.get__O());
                var this$30 = new $c_sci_StringOps().init___T(x$5);
                var $$this$5 = this$30.repr$1;
                if ((!($fround($m_jl_Double$().parseDouble__T__D($$this$5)) >= x27))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x26.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              }
            }
          }
        }
      }
    };
    if (rc31) {
      var p18 = $as_T3(x2.value$2);
      if ((p18 !== null)) {
        var scalar$4 = $as_Lamf_core_model_domain_AmfElement(p18.$$und2$1);
        var p20 = $as_s_Option(p18.$$und3$1);
        if ((scalar$4 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x28 = $as_Lamf_core_model_domain_AmfScalar(scalar$4);
          if ((p20 instanceof $c_s_Some)) {
            var x21 = $as_s_Some(p20);
            var value$4 = x21.value$2;
            if (((typeof value$4) === "number")) {
              var x29 = $uD(value$4);
              var thiz$3 = $as_T(propertyConstraint.maxInclusive$1.get__O());
              if (($uI(thiz$3.indexOf(".")) !== (-1))) {
                var x$6 = $as_T(propertyConstraint.maxInclusive$1.get__O());
                var this$37 = new $c_sci_StringOps().init___T(x$6);
                var jsx$4 = $m_jl_Double$();
                var $$this$6 = this$37.repr$1;
                if ((!(jsx$4.parseDouble__T__D($$this$6) >= x29))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x28.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              } else {
                var x$7 = $as_T(propertyConstraint.maxInclusive$1.get__O());
                var this$40 = new $c_sci_StringOps().init___T(x$7);
                var $$this$7 = this$40.repr$1;
                if ((!($fround($m_jl_Double$().parseDouble__T__D($$this$7)) >= x29))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x28.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              }
            }
          }
        }
      }
    }
  }
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.validateClosed__Lamf_core_validation_core_ValidationSpecification__Lamf_core_model_domain_DomainElement__Z__V = (function(validationSpecification, element, closed) {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Closed constraint not supported yet: " + validationSpecification.id$1)))
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.validatePropertyConstraint__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V = (function(validationSpecification, propertyConstraint, element) {
  var x1 = propertyConstraint.node$1;
  if ((x1 instanceof $c_s_Some)) {
    this.validatePropertyNode__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V(validationSpecification, propertyConstraint, element)
  };
  var x1$2 = propertyConstraint.maxCount$1;
  if ((x1$2 instanceof $c_s_Some)) {
    this.validateMaxCount__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V(validationSpecification, propertyConstraint, element)
  };
  var x1$3 = propertyConstraint.minCount$1;
  if ((x1$3 instanceof $c_s_Some)) {
    this.validateMinCount__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V(validationSpecification, propertyConstraint, element)
  };
  var x1$4 = propertyConstraint.maxLength$1;
  if ((x1$4 instanceof $c_s_Some)) {
    this.validateMaxLength__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V(validationSpecification, propertyConstraint, element)
  };
  var x1$5 = propertyConstraint.minLength$1;
  if ((x1$5 instanceof $c_s_Some)) {
    this.validateMinLength__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V(validationSpecification, propertyConstraint, element)
  };
  var x1$6 = propertyConstraint.in$1;
  matchEnd7: {
    var x = $m_sci_Nil$();
    if (x.equals__O__Z(x1$6)) {
      break matchEnd7
    };
    $m_sc_Seq$();
    var o11 = new $c_s_Some().init___O(x1$6);
    if (((o11.value$2 !== null) && ($as_sc_SeqLike(o11.value$2).lengthCompare__I__I(1) === 0))) {
      this.validateIn__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V(validationSpecification, propertyConstraint, element);
      break matchEnd7
    };
    if ((x1$6 instanceof $c_scm_WrappedArray)) {
      this.validateIn__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V(validationSpecification, propertyConstraint, element);
      break matchEnd7
    };
    throw new $c_s_MatchError().init___O(x1$6)
  };
  var x1$7 = propertyConstraint.maxExclusive$1;
  if ((x1$7 instanceof $c_s_Some)) {
    this.validateMaxExclusive__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V(validationSpecification, propertyConstraint, element)
  };
  var x1$8 = propertyConstraint.minExclusive$1;
  if ((x1$8 instanceof $c_s_Some)) {
    this.validateMinExclusive__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V(validationSpecification, propertyConstraint, element)
  };
  var x1$9 = propertyConstraint.maxInclusive$1;
  if ((x1$9 instanceof $c_s_Some)) {
    this.validateMaxInclusive__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V(validationSpecification, propertyConstraint, element)
  };
  var x1$10 = propertyConstraint.minInclusive$1;
  if ((x1$10 instanceof $c_s_Some)) {
    this.validateMinInclusive__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V(validationSpecification, propertyConstraint, element)
  };
  var x1$11 = propertyConstraint.pattern$1;
  if ((x1$11 instanceof $c_s_Some)) {
    this.validatePattern__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V(validationSpecification, propertyConstraint, element)
  };
  var x1$12 = propertyConstraint.datatype$1;
  if ((x1$12 instanceof $c_s_Some)) {
    this.validateDataType__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V(validationSpecification, propertyConstraint, element)
  };
  var x1$13 = propertyConstraint.class$1;
  var x$3 = $m_sci_Nil$();
  if ((!x$3.equals__O__Z(x1$13))) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("class property constraint not supported yet " + validationSpecification.id$1)))
  };
  if (propertyConstraint.custom$1.isDefined__Z()) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("custom property constraint not supported yet " + validationSpecification.id$1)))
  };
  if (propertyConstraint.customRdf$1.isDefined__Z()) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("customRdf property constraint not supported yet " + validationSpecification.id$1)))
  };
  if (propertyConstraint.multipleOf$1.isDefined__Z()) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("multipleOf property constraint not supported yet " + validationSpecification.id$1)))
  };
  if (propertyConstraint.patternedProperty$1.isDefined__Z()) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("patternedProperty property constraint not supported yet " + validationSpecification.id$1)))
  }
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.validateIn__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V = (function(validationSpecification, propertyConstraint, parentElement) {
  var rc16 = false;
  var x2 = null;
  var x1 = this.extractPredicateValue__T__Lamf_core_model_domain_DomainElement__s_Option(propertyConstraint.ramlPropertyId$1, parentElement);
  matchEnd17: {
    if ((x1 instanceof $c_s_Some)) {
      rc16 = true;
      x2 = $as_s_Some(x1);
      var p3 = $as_T3(x2.value$2);
      if ((p3 !== null)) {
        var p6 = $as_s_Option(p3.$$und3$1);
        if (((p3.$$und2$1 instanceof $c_Lamf_core_model_domain_AmfScalar) && (p6 instanceof $c_s_Some))) {
          var x7 = $as_s_Some(p6);
          var value = x7.value$2;
          if ($is_T(value)) {
            var x13 = $as_T(value);
            if ((!propertyConstraint.in$1.contains__O__Z(x13))) {
              this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), parentElement.annotations__Lamf_core_parser_Annotations());
              (void 0)
            } else {
              (void 0)
            };
            break matchEnd17
          }
        }
      }
    };
    if (rc16) {
      var p9 = $as_T3(x2.value$2);
      if ((p9 !== null)) {
        var arr = $as_Lamf_core_model_domain_AmfElement(p9.$$und2$1);
        if ((arr instanceof $c_Lamf_core_model_domain_AmfArray)) {
          var x14 = $as_Lamf_core_model_domain_AmfArray(arr);
          x14.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, propertyConstraint$1, validationSpecification$1, parentElement$1) {
            return (function(x0$1$2) {
              var x0$1 = $as_Lamf_core_model_domain_AmfElement(x0$1$2);
              if ((x0$1 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
                var x2$1 = $as_Lamf_core_model_domain_AmfScalar(x0$1);
                if ((!propertyConstraint$1.in$1.contains__O__Z($as_T(x2$1.value$1)))) {
                  $this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification$1, propertyConstraint$1, parentElement$1.id__T(), parentElement$1.annotations__Lamf_core_parser_Annotations())
                }
              }
            })
          })(this, propertyConstraint, validationSpecification, parentElement)));
          break matchEnd17
        }
      }
    }
  }
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.run__s_concurrent_Future = (function() {
  var this$3 = this.model$1;
  var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
  var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
  var this$4 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(this$3, strategy, fieldsFilter);
  while (this$4.hasNext__Z()) {
    var arg1 = this$4.next__Lamf_core_model_domain_AmfElement();
    if ($is_Lamf_core_model_domain_DomainElement(arg1)) {
      var x2 = $as_Lamf_core_model_domain_DomainElement(arg1);
      this.validateIdentityTransformation__Lamf_core_model_domain_DomainElement__V(x2)
    }
  };
  return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$2$1) {
    return (function() {
      return this$2$1.validationReport$1
    })
  })(this)), this.executionContext$1)
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.amfScalarToScala__Lamf_core_model_domain_AmfScalar__O = (function(scalar) {
  var x1 = scalar.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_SourceAST.getClassOf());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var ast = $as_Lamf_core_annotations_SourceAST(x2.value$2);
    if ((ast !== null)) {
      var x1$2 = ast.ast$1;
      if ((x1$2 instanceof $c_Lorg_yaml_model_YScalar)) {
        var x2$2 = $as_Lorg_yaml_model_YScalar(x1$2);
        return x2$2.value$3
      } else {
        return scalar.value$1
      }
    }
  };
  var x = $m_s_None$();
  if ((x === x1)) {
    return scalar.value$1
  };
  throw new $c_s_MatchError().init___O(x1)
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.validateMinLength__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V = (function(validationSpecification, propertyConstraint, parentElement) {
  var rc16 = false;
  var x2 = null;
  var x1 = this.extractPredicateValue__T__Lamf_core_model_domain_DomainElement__s_Option(propertyConstraint.ramlPropertyId$1, parentElement);
  matchEnd17: {
    if ((x1 instanceof $c_s_Some)) {
      rc16 = true;
      x2 = $as_s_Some(x1);
      var p3 = $as_T3(x2.value$2);
      if ((p3 !== null)) {
        var scalar = $as_Lamf_core_model_domain_AmfElement(p3.$$und2$1);
        var p5 = $as_s_Option(p3.$$und3$1);
        if ((scalar instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x12 = $as_Lamf_core_model_domain_AmfScalar(scalar);
          if ((p5 instanceof $c_s_Some)) {
            var x6 = $as_s_Some(p5);
            var value = x6.value$2;
            if ($is_T(value)) {
              var x13 = $as_T(value);
              var x = $as_T(propertyConstraint.minLength$1.get__O());
              var this$2 = new $c_sci_StringOps().init___T(x);
              var this$4 = $m_jl_Integer$();
              var $$this = this$2.repr$1;
              if ((!(this$4.parseInt__T__I__I($$this, 10) <= $uI(x13.length)))) {
                this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x12.annotations$1);
                break matchEnd17
              } else {
                break matchEnd17
              }
            }
          }
        }
      }
    };
    if (rc16) {
      var p8 = $as_T3(x2.value$2);
      if ((p8 !== null)) {
        var scalar$2 = $as_Lamf_core_model_domain_AmfElement(p8.$$und2$1);
        var p10 = $as_s_Option(p8.$$und3$1);
        if ((scalar$2 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x14 = $as_Lamf_core_model_domain_AmfScalar(scalar$2);
          if ((p10 instanceof $c_s_Some)) {
            var x11 = $as_s_Some(p10);
            var x$1 = x11.value$2;
            if ($m_s_Option$().apply__O__s_Option(x$1).isEmpty__Z()) {
              var x$2 = $as_T(propertyConstraint.minLength$1.get__O());
              var this$7 = new $c_sci_StringOps().init___T(x$2);
              var this$9 = $m_jl_Integer$();
              var $$this$1 = this$7.repr$1;
              if ((!(this$9.parseInt__T__I__I($$this$1, 10) <= 0))) {
                this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x14.annotations$1);
                break matchEnd17
              } else {
                break matchEnd17
              }
            }
          }
        }
      }
    }
  }
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.validateMaxCount__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V = (function(validationSpecification, propertyConstraint, parentElement) {
  var rc13 = false;
  var x2 = null;
  var x1 = this.extractPredicateValue__T__Lamf_core_model_domain_DomainElement__s_Option(propertyConstraint.ramlPropertyId$1, parentElement);
  matchEnd14: {
    if ((x1 instanceof $c_s_Some)) {
      rc13 = true;
      x2 = $as_s_Some(x1);
      var p3 = $as_T3(x2.value$2);
      if ((p3 !== null)) {
        var arr = $as_Lamf_core_model_domain_AmfElement(p3.$$und2$1);
        if ((arr instanceof $c_Lamf_core_model_domain_AmfArray)) {
          var x10 = $as_Lamf_core_model_domain_AmfArray(arr);
          var jsx$1 = x10.values$1.length__I();
          var x = $as_T(propertyConstraint.maxCount$1.get__O());
          var this$2 = new $c_sci_StringOps().init___T(x);
          var this$4 = $m_jl_Integer$();
          var $$this = this$2.repr$1;
          if ((!(jsx$1 <= this$4.parseInt__T__I__I($$this, 10)))) {
            this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x10.annotations$1);
            break matchEnd14
          } else {
            break matchEnd14
          }
        }
      }
    };
    if (rc13) {
      var p7 = $as_T3(x2.value$2);
      if ((p7 !== null)) {
        var x$1 = $as_Lamf_core_model_domain_AmfElement(p7.$$und2$1);
        if ((x$1 !== null)) {
          var x$2 = $as_T(propertyConstraint.maxCount$1.get__O());
          var this$6 = new $c_sci_StringOps().init___T(x$2);
          var this$8 = $m_jl_Integer$();
          var $$this$1 = this$6.repr$1;
          if ((!(this$8.parseInt__T__I__I($$this$1, 10) >= 1))) {
            this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x$1.annotations__Lamf_core_parser_Annotations());
            break matchEnd14
          } else {
            break matchEnd14
          }
        }
      }
    }
  }
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.validateIdentityTransformation__Lamf_core_model_domain_DomainElement__V = (function(element) {
  var this$1 = this.validations$1.effective$1;
  var iterTable = this$1.table$5;
  var idx = $f_scm_HashTable__scala$collection$mutable$HashTable$$lastPopulatedIndex__I(this$1);
  var es = iterTable.get(idx);
  while ((es !== null)) {
    var next = $as_scm_HashEntry(es.next__O());
    var arg1 = es;
    var e = $as_scm_DefaultEntry(arg1);
    var _2 = e.value$1;
    var specification = $as_Lamf_core_validation_core_ValidationSpecification(_2);
    var this$3 = element.meta__Lamf_core_metamodel_Obj().type__sci_List();
    var f = (function($this) {
      return (function(x$2$2) {
        var x$2 = $as_Lamf_core_vocabulary_ValueType(x$2$2);
        return x$2.iri__T()
      })
    })(this);
    var this$2 = $m_sci_List$();
    var bf = this$2.ReusableCBFInstance$2;
    if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
      if ((this$3 === $m_sci_Nil$())) {
        var jsx$1 = $m_sci_Nil$()
      } else {
        var arg1$1 = this$3.head__O();
        var h = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$1), $m_sci_Nil$());
        var t = h;
        var rest = $as_sci_List(this$3.tail__O());
        while ((rest !== $m_sci_Nil$())) {
          var arg1$2 = rest.head__O();
          var nx = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$2), $m_sci_Nil$());
          t.tl$5 = nx;
          t = nx;
          rest = $as_sci_List(rest.tail__O())
        };
        var jsx$1 = h
      }
    } else {
      var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$3, bf);
      var these = this$3;
      while ((!these.isEmpty__Z())) {
        var arg1$3 = these.head__O();
        b.$$plus$eq__O__scm_Builder(f(arg1$3));
        these = $as_sci_List(these.tail__O())
      };
      var jsx$1 = b.result__O()
    };
    var classes = $as_sci_List(jsx$1);
    if ((this.matchingClass__Lamf_core_validation_core_ValidationSpecification__sc_Seq__Z(specification, classes) || specification.targetInstance$1.contains__O__Z(element.id__T()))) {
      this.validate__Lamf_core_validation_core_ValidationSpecification__Lamf_core_model_domain_DomainElement__V(specification, element)
    };
    this.validateObjectsOf__Lamf_core_validation_core_ValidationSpecification__Lamf_core_model_domain_DomainElement__V(specification, element);
    es = next;
    while (((es === null) && (idx > 0))) {
      idx = (((-1) + idx) | 0);
      es = iterTable.get(idx)
    }
  }
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.validateNodeConstraint__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_NodeConstraint__Lamf_core_model_domain_DomainElement__V = (function(validationSpecification, nodeConstraint, element) {
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var nodeKindIri = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "nodeKind").iri__T();
  var this$3 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var shaclIri = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "IRI").iri__T();
  var x1 = nodeConstraint.constraint$1;
  if ((x1 === nodeKindIri)) {
    var x1$2 = nodeConstraint.value$1;
    if ((x1$2 !== shaclIri)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Not supported node constraint range " + x1$2)))
    };
    validationSpecification.targetObject$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, element$1, validationSpecification$1) {
      return (function(targetObject$2) {
        var targetObject = $as_T(targetObject$2);
        var x1$1 = $this.extractPredicateValue__T__Lamf_core_model_domain_DomainElement__s_Option(targetObject, element$1);
        matchEnd10: {
          if ((x1$1 instanceof $c_s_Some)) {
            var x2 = $as_s_Some(x1$1);
            var p3 = $as_T3(x2.value$2);
            if ((p3 !== null)) {
              var scalar = $as_Lamf_core_model_domain_AmfElement(p3.$$und2$1);
              var p5 = $as_s_Option(p3.$$und3$1);
              if ((scalar instanceof $c_Lamf_core_model_domain_AmfScalar)) {
                var x7 = $as_Lamf_core_model_domain_AmfScalar(scalar);
                if ((p5 instanceof $c_s_Some)) {
                  var x6 = $as_s_Some(p5);
                  var value = x6.value$2;
                  if ($is_T(value)) {
                    var x8 = $as_T(value);
                    if (($uI(x8.indexOf("://")) === (-1))) {
                      $this.reportFailure__Lamf_core_validation_core_ValidationSpecification__T__Lamf_core_parser_Annotations__V(validationSpecification$1, element$1.id__T(), x7.annotations$1);
                      (void 0)
                    } else {
                      (void 0)
                    };
                    break matchEnd10
                  }
                }
              }
            }
          }
        }
      })
    })(this, element, validationSpecification)))
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Not supported node constraint " + x1)))
  }
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.validateObjectsOf__Lamf_core_validation_core_ValidationSpecification__Lamf_core_model_domain_DomainElement__V = (function(validationSpecification, element) {
  validationSpecification.targetObject$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, element$1, validationSpecification$1) {
    return (function(property$2) {
      var property = $as_T(property$2);
      var x1 = $this.findFieldTarget__Lamf_core_model_domain_DomainElement__T__s_Option(element$1, property);
      matchEnd8: {
        if ((x1 instanceof $c_s_Some)) {
          var x2 = $as_s_Some(x1);
          var p3 = $as_T2(x2.value$2);
          if ((p3 !== null)) {
            var objectsOf = $as_sc_Seq(p3.$$und2__O());
            if (((p3.$$und1__O() !== null) && (objectsOf instanceof $c_Lamf_core_model_domain_AmfArray))) {
              var x6 = $as_Lamf_core_model_domain_AmfArray(objectsOf);
              $as_sc_IterableLike(x6).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, validationSpecification$1$1) {
                return (function(x0$1$2) {
                  var x0$1 = $as_Lamf_core_model_domain_AmfElement(x0$1$2);
                  if ($is_Lamf_core_model_domain_DomainElement(x0$1)) {
                    var x2$1 = $as_Lamf_core_model_domain_DomainElement(x0$1);
                    validationSpecification$1$1.nodeConstraints$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, validationSpecification$1$2, x2$2) {
                      return (function(nodeConstraint$2) {
                        var nodeConstraint = $as_Lamf_core_validation_core_NodeConstraint(nodeConstraint$2);
                        $this$2.validateNodeConstraint__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_NodeConstraint__Lamf_core_model_domain_DomainElement__V(validationSpecification$1$2, nodeConstraint, x2$2)
                      })
                    })($this$1, validationSpecification$1$1, x2$1)))
                  }
                })
              })($this, validationSpecification$1)));
              break matchEnd8
            }
          }
        }
      }
    })
  })(this, element, validationSpecification)))
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.validateMinExclusive__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V = (function(validationSpecification, propertyConstraint, parentElement) {
  var rc31 = false;
  var x2 = null;
  var x1 = this.extractPredicateValue__T__Lamf_core_model_domain_DomainElement__s_Option(propertyConstraint.ramlPropertyId$1, parentElement);
  matchEnd32: {
    if ((x1 instanceof $c_s_Some)) {
      rc31 = true;
      x2 = $as_s_Some(x1);
      var p3 = $as_T3(x2.value$2);
      if ((p3 !== null)) {
        var scalar = $as_Lamf_core_model_domain_AmfElement(p3.$$und2$1);
        var p5 = $as_s_Option(p3.$$und3$1);
        if ((scalar instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x22 = $as_Lamf_core_model_domain_AmfScalar(scalar);
          if ((p5 instanceof $c_s_Some)) {
            var x6 = $as_s_Some(p5);
            var value = x6.value$2;
            if ((value instanceof $c_sjsr_RuntimeLong)) {
              var t = $uJ(value);
              var lo = t.lo$2;
              var hi = t.hi$2;
              var thiz = $as_T(propertyConstraint.minExclusive$1.get__O());
              if (($uI(thiz.indexOf(".")) !== (-1))) {
                var x = $as_T(propertyConstraint.minExclusive$1.get__O());
                var this$5 = new $c_sci_StringOps().init___T(x);
                var jsx$1 = $m_jl_Double$();
                var $$this = this$5.repr$1;
                if ((!(jsx$1.parseDouble__T__D($$this) < $m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toDouble__I__I__D(lo, hi)))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x22.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              } else {
                var x$1 = $as_T(propertyConstraint.minExclusive$1.get__O());
                var this$8 = new $c_sci_StringOps().init___T(x$1);
                var this$10 = $m_jl_Long$();
                var $$this$1 = this$8.repr$1;
                var t$1 = this$10.parseLong__T__I__J($$this$1, 10);
                var lo$1 = t$1.lo$2;
                var hi$1 = t$1.hi$2;
                if ((!((hi$1 === hi) ? (((-2147483648) ^ lo$1) < ((-2147483648) ^ lo)) : (hi$1 < hi)))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x22.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              }
            }
          }
        }
      }
    };
    if (rc31) {
      var p8 = $as_T3(x2.value$2);
      if ((p8 !== null)) {
        var scalar$2 = $as_Lamf_core_model_domain_AmfElement(p8.$$und2$1);
        var p10 = $as_s_Option(p8.$$und3$1);
        if ((scalar$2 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x24 = $as_Lamf_core_model_domain_AmfScalar(scalar$2);
          if ((p10 instanceof $c_s_Some)) {
            var x11 = $as_s_Some(p10);
            var value$2 = x11.value$2;
            if ($isInt(value$2)) {
              var x25 = $asInt(value$2);
              var thiz$1 = $as_T(propertyConstraint.minExclusive$1.get__O());
              if (($uI(thiz$1.indexOf(".")) !== (-1))) {
                var x$2 = $as_T(propertyConstraint.minExclusive$1.get__O());
                var this$15 = new $c_sci_StringOps().init___T(x$2);
                var jsx$2 = $m_jl_Double$();
                var $$this$2 = this$15.repr$1;
                if ((!(jsx$2.parseDouble__T__D($$this$2) < $uI(x25)))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x24.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              } else {
                var x$3 = $as_T(propertyConstraint.minExclusive$1.get__O());
                var this$19 = new $c_sci_StringOps().init___T(x$3);
                var this$21 = $m_jl_Integer$();
                var $$this$3 = this$19.repr$1;
                if ((!(this$21.parseInt__T__I__I($$this$3, 10) < $uI(x25)))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x24.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              }
            }
          }
        }
      }
    };
    if (rc31) {
      var p13 = $as_T3(x2.value$2);
      if ((p13 !== null)) {
        var scalar$3 = $as_Lamf_core_model_domain_AmfElement(p13.$$und2$1);
        var p15 = $as_s_Option(p13.$$und3$1);
        if ((scalar$3 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x26 = $as_Lamf_core_model_domain_AmfScalar(scalar$3);
          if ((p15 instanceof $c_s_Some)) {
            var x16 = $as_s_Some(p15);
            var value$3 = x16.value$2;
            if ($isFloat(value$3)) {
              var x27 = $uF(value$3);
              var thiz$2 = $as_T(propertyConstraint.minExclusive$1.get__O());
              if (($uI(thiz$2.indexOf(".")) !== (-1))) {
                var x$4 = $as_T(propertyConstraint.minExclusive$1.get__O());
                var this$27 = new $c_sci_StringOps().init___T(x$4);
                var jsx$3 = $m_jl_Double$();
                var $$this$4 = this$27.repr$1;
                if ((!(jsx$3.parseDouble__T__D($$this$4) < x27))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x26.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              } else {
                var x$5 = $as_T(propertyConstraint.minExclusive$1.get__O());
                var this$30 = new $c_sci_StringOps().init___T(x$5);
                var $$this$5 = this$30.repr$1;
                if ((!($fround($m_jl_Double$().parseDouble__T__D($$this$5)) < x27))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x26.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              }
            }
          }
        }
      }
    };
    if (rc31) {
      var p18 = $as_T3(x2.value$2);
      if ((p18 !== null)) {
        var scalar$4 = $as_Lamf_core_model_domain_AmfElement(p18.$$und2$1);
        var p20 = $as_s_Option(p18.$$und3$1);
        if ((scalar$4 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x28 = $as_Lamf_core_model_domain_AmfScalar(scalar$4);
          if ((p20 instanceof $c_s_Some)) {
            var x21 = $as_s_Some(p20);
            var value$4 = x21.value$2;
            if (((typeof value$4) === "number")) {
              var x29 = $uD(value$4);
              var thiz$3 = $as_T(propertyConstraint.minExclusive$1.get__O());
              if (($uI(thiz$3.indexOf(".")) !== (-1))) {
                var x$6 = $as_T(propertyConstraint.minExclusive$1.get__O());
                var this$37 = new $c_sci_StringOps().init___T(x$6);
                var jsx$4 = $m_jl_Double$();
                var $$this$6 = this$37.repr$1;
                if ((!(jsx$4.parseDouble__T__D($$this$6) < x29))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x28.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              } else {
                var x$7 = $as_T(propertyConstraint.minExclusive$1.get__O());
                var this$40 = new $c_sci_StringOps().init___T(x$7);
                var $$this$7 = this$40.repr$1;
                if ((!($fround($m_jl_Double$().parseDouble__T__D($$this$7)) < x29))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x28.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              }
            }
          }
        }
      }
    }
  }
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.reportFailure__Lamf_core_validation_core_ValidationSpecification__T__Lamf_core_parser_Annotations__V = (function(validationSpecification, id, annotations) {
  var jsx$2 = this.validationReport$1;
  var x1 = this.options$1.messageStyle$1;
  var x = $m_Lamf_RAMLStyle$();
  if ((x === x1)) {
    var this$1 = validationSpecification.ramlMessage$1;
    var jsx$1 = (this$1.isEmpty__Z() ? new $c_s_Some().init___O(validationSpecification.message$1) : this$1)
  } else {
    var x$3 = $m_Lamf_OASStyle$();
    if ((x$3 === x1)) {
      var this$2 = validationSpecification.oasMessage$1;
      var jsx$1 = (this$2.isEmpty__Z() ? new $c_s_Some().init___O(validationSpecification.message$1) : this$2)
    } else {
      var jsx$1 = new $c_s_Some().init___O(validationSpecification.message$1)
    }
  };
  jsx$2.registerResult__Lamf_core_validation_core_ValidationResult__V(new $c_Lamf_plugins_features_validation_CustomValidationResult().init___s_Option__T__T__T__T__T(jsx$1, "", validationSpecification.id$1, id, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, validationSpecification.id$1))
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.validateMaxExclusive__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V = (function(validationSpecification, propertyConstraint, parentElement) {
  var rc31 = false;
  var x2 = null;
  var x1 = this.extractPredicateValue__T__Lamf_core_model_domain_DomainElement__s_Option(propertyConstraint.ramlPropertyId$1, parentElement);
  matchEnd32: {
    if ((x1 instanceof $c_s_Some)) {
      rc31 = true;
      x2 = $as_s_Some(x1);
      var p3 = $as_T3(x2.value$2);
      if ((p3 !== null)) {
        var scalar = $as_Lamf_core_model_domain_AmfElement(p3.$$und2$1);
        var p5 = $as_s_Option(p3.$$und3$1);
        if ((scalar instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x22 = $as_Lamf_core_model_domain_AmfScalar(scalar);
          if ((p5 instanceof $c_s_Some)) {
            var x6 = $as_s_Some(p5);
            var value = x6.value$2;
            if ((value instanceof $c_sjsr_RuntimeLong)) {
              var t = $uJ(value);
              var lo = t.lo$2;
              var hi = t.hi$2;
              var thiz = $as_T(propertyConstraint.maxExclusive$1.get__O());
              if (($uI(thiz.indexOf(".")) !== (-1))) {
                var x = $as_T(propertyConstraint.maxExclusive$1.get__O());
                var this$5 = new $c_sci_StringOps().init___T(x);
                var jsx$1 = $m_jl_Double$();
                var $$this = this$5.repr$1;
                if ((!(jsx$1.parseDouble__T__D($$this) > $m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toDouble__I__I__D(lo, hi)))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x22.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              } else {
                var x$1 = $as_T(propertyConstraint.maxExclusive$1.get__O());
                var this$8 = new $c_sci_StringOps().init___T(x$1);
                var this$10 = $m_jl_Long$();
                var $$this$1 = this$8.repr$1;
                var t$1 = this$10.parseLong__T__I__J($$this$1, 10);
                var lo$1 = t$1.lo$2;
                var hi$1 = t$1.hi$2;
                if ((!((hi$1 === hi) ? (((-2147483648) ^ lo$1) > ((-2147483648) ^ lo)) : (hi$1 > hi)))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x22.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              }
            }
          }
        }
      }
    };
    if (rc31) {
      var p8 = $as_T3(x2.value$2);
      if ((p8 !== null)) {
        var scalar$2 = $as_Lamf_core_model_domain_AmfElement(p8.$$und2$1);
        var p10 = $as_s_Option(p8.$$und3$1);
        if ((scalar$2 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x24 = $as_Lamf_core_model_domain_AmfScalar(scalar$2);
          if ((p10 instanceof $c_s_Some)) {
            var x11 = $as_s_Some(p10);
            var value$2 = x11.value$2;
            if ($isInt(value$2)) {
              var x25 = $asInt(value$2);
              var thiz$1 = $as_T(propertyConstraint.maxExclusive$1.get__O());
              if (($uI(thiz$1.indexOf(".")) !== (-1))) {
                var x$2 = $as_T(propertyConstraint.maxExclusive$1.get__O());
                var this$15 = new $c_sci_StringOps().init___T(x$2);
                var jsx$2 = $m_jl_Double$();
                var $$this$2 = this$15.repr$1;
                if ((!(jsx$2.parseDouble__T__D($$this$2) > $uI(x25)))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x24.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              } else {
                var x$3 = $as_T(propertyConstraint.maxExclusive$1.get__O());
                var this$19 = new $c_sci_StringOps().init___T(x$3);
                var this$21 = $m_jl_Integer$();
                var $$this$3 = this$19.repr$1;
                if ((!(this$21.parseInt__T__I__I($$this$3, 10) > $uI(x25)))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x24.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              }
            }
          }
        }
      }
    };
    if (rc31) {
      var p13 = $as_T3(x2.value$2);
      if ((p13 !== null)) {
        var scalar$3 = $as_Lamf_core_model_domain_AmfElement(p13.$$und2$1);
        var p15 = $as_s_Option(p13.$$und3$1);
        if ((scalar$3 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x26 = $as_Lamf_core_model_domain_AmfScalar(scalar$3);
          if ((p15 instanceof $c_s_Some)) {
            var x16 = $as_s_Some(p15);
            var value$3 = x16.value$2;
            if ($isFloat(value$3)) {
              var x27 = $uF(value$3);
              var thiz$2 = $as_T(propertyConstraint.maxExclusive$1.get__O());
              if (($uI(thiz$2.indexOf(".")) !== (-1))) {
                var x$4 = $as_T(propertyConstraint.maxExclusive$1.get__O());
                var this$27 = new $c_sci_StringOps().init___T(x$4);
                var jsx$3 = $m_jl_Double$();
                var $$this$4 = this$27.repr$1;
                if ((!(jsx$3.parseDouble__T__D($$this$4) > x27))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x26.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              } else {
                var x$5 = $as_T(propertyConstraint.maxExclusive$1.get__O());
                var this$30 = new $c_sci_StringOps().init___T(x$5);
                var $$this$5 = this$30.repr$1;
                if ((!($fround($m_jl_Double$().parseDouble__T__D($$this$5)) > x27))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x26.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              }
            }
          }
        }
      }
    };
    if (rc31) {
      var p18 = $as_T3(x2.value$2);
      if ((p18 !== null)) {
        var scalar$4 = $as_Lamf_core_model_domain_AmfElement(p18.$$und2$1);
        var p20 = $as_s_Option(p18.$$und3$1);
        if ((scalar$4 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x28 = $as_Lamf_core_model_domain_AmfScalar(scalar$4);
          if ((p20 instanceof $c_s_Some)) {
            var x21 = $as_s_Some(p20);
            var value$4 = x21.value$2;
            if (((typeof value$4) === "number")) {
              var x29 = $uD(value$4);
              var thiz$3 = $as_T(propertyConstraint.maxExclusive$1.get__O());
              if (($uI(thiz$3.indexOf(".")) !== (-1))) {
                var x$6 = $as_T(propertyConstraint.maxExclusive$1.get__O());
                var this$37 = new $c_sci_StringOps().init___T(x$6);
                var jsx$4 = $m_jl_Double$();
                var $$this$6 = this$37.repr$1;
                if ((!(jsx$4.parseDouble__T__D($$this$6) > x29))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x28.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              } else {
                var x$7 = $as_T(propertyConstraint.maxExclusive$1.get__O());
                var this$40 = new $c_sci_StringOps().init___T(x$7);
                var $$this$7 = this$40.repr$1;
                if ((!($fround($m_jl_Double$().parseDouble__T__D($$this$7)) > x29))) {
                  this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x28.annotations$1);
                  break matchEnd32
                } else {
                  break matchEnd32
                }
              }
            }
          }
        }
      }
    }
  }
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.validateMaxLength__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V = (function(validationSpecification, propertyConstraint, parentElement) {
  var x1 = this.extractPredicateValue__T__Lamf_core_model_domain_DomainElement__s_Option(propertyConstraint.ramlPropertyId$1, parentElement);
  matchEnd10: {
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var p3 = $as_T3(x2.value$2);
      if ((p3 !== null)) {
        var scalar = $as_Lamf_core_model_domain_AmfElement(p3.$$und2$1);
        var p5 = $as_s_Option(p3.$$und3$1);
        if ((scalar instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x7 = $as_Lamf_core_model_domain_AmfScalar(scalar);
          if ((p5 instanceof $c_s_Some)) {
            var x6 = $as_s_Some(p5);
            var value = x6.value$2;
            if ($is_T(value)) {
              var x8 = $as_T(value);
              var x = $as_T(propertyConstraint.maxLength$1.get__O());
              var this$2 = new $c_sci_StringOps().init___T(x);
              var this$4 = $m_jl_Integer$();
              var $$this = this$2.repr$1;
              if ((!(this$4.parseInt__T__I__I($$this, 10) > $uI(x8.length)))) {
                this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x7.annotations$1);
                break matchEnd10
              } else {
                break matchEnd10
              }
            }
          }
        }
      }
    }
  }
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.validateMinCount__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V = (function(validationSpecification, propertyConstraint, parentElement) {
  var rc18 = false;
  var x2 = null;
  var x1 = this.extractPredicateValue__T__Lamf_core_model_domain_DomainElement__s_Option(propertyConstraint.ramlPropertyId$1, parentElement);
  matchEnd19: {
    if ((x1 instanceof $c_s_Some)) {
      rc18 = true;
      x2 = $as_s_Some(x1);
      var p3 = $as_T3(x2.value$2);
      if ((p3 !== null)) {
        var arr = $as_Lamf_core_model_domain_AmfElement(p3.$$und2$1);
        if ((arr instanceof $c_Lamf_core_model_domain_AmfArray)) {
          var x14 = $as_Lamf_core_model_domain_AmfArray(arr);
          var jsx$1 = x14.values$1.length__I();
          var x = $as_T(propertyConstraint.minCount$1.get__O());
          var this$2 = new $c_sci_StringOps().init___T(x);
          var this$4 = $m_jl_Integer$();
          var $$this = this$2.repr$1;
          if ((!(jsx$1 >= this$4.parseInt__T__I__I($$this, 10)))) {
            this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x14.annotations$1);
            break matchEnd19
          } else {
            break matchEnd19
          }
        }
      }
    };
    if (rc18) {
      var p7 = $as_T3(x2.value$2);
      if ((p7 !== null)) {
        var x$1 = $as_Lamf_core_model_domain_AmfElement(p7.$$und2$1);
        if ((x$1 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x15 = $as_Lamf_core_model_domain_AmfScalar(x$1);
          var x$2 = $as_T(propertyConstraint.minCount$1.get__O());
          var this$6 = new $c_sci_StringOps().init___T(x$2);
          var this$8 = $m_jl_Integer$();
          var $$this$1 = this$6.repr$1;
          if ((!(this$8.parseInt__T__I__I($$this$1, 10) <= 1))) {
            this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x15.annotations$1);
            break matchEnd19
          } else {
            break matchEnd19
          }
        }
      }
    };
    if (rc18) {
      var p11 = $as_T3(x2.value$2);
      if ((p11 !== null)) {
        var x$2$1 = $as_Lamf_core_model_domain_AmfElement(p11.$$und2$1);
        if ($is_Lamf_core_model_domain_AmfObject(x$2$1)) {
          var x16 = $as_Lamf_core_model_domain_AmfObject(x$2$1);
          var x$3 = $as_T(propertyConstraint.minCount$1.get__O());
          var this$10 = new $c_sci_StringOps().init___T(x$3);
          var this$12 = $m_jl_Integer$();
          var $$this$2 = this$10.repr$1;
          if ((!(this$12.parseInt__T__I__I($$this$2, 10) <= 1))) {
            this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x16.annotations__Lamf_core_parser_Annotations());
            break matchEnd19
          } else {
            break matchEnd19
          }
        }
      }
    };
    if ((!propertyConstraint.minCount$1.contains__O__Z("0"))) {
      this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), parentElement.annotations__Lamf_core_parser_Annotations());
      (void 0)
    } else {
      (void 0)
    }
  }
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.getFunctionForName__T__F2 = (function(name) {
  var x1 = this.customFunctions$1.get__O__s_Option(name);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var validationFunction = $as_F2(x2.value$2);
    return validationFunction
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Custom function validations not supported in customm SHACL validator: " + name)))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.validateCustom__Lamf_core_validation_core_ValidationSpecification__Lamf_core_model_domain_DomainElement__V = (function(validationSpecification, element) {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Arbitray SHACL validations not supported in custom SHACL validator: " + validationSpecification.id$1)))
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.validatePropertyNode__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V = (function(validationSpecification, propertyConstraint, parentElement) {
  if ($m_sjsr_RuntimeString$().endsWith__T__T__Z($as_T(propertyConstraint.node$1.get__O()), "NonEmptyList")) {
    var x1 = this.extractPredicateValue__T__Lamf_core_model_domain_DomainElement__s_Option(propertyConstraint.ramlPropertyId$1, parentElement);
    matchEnd8: {
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var p3 = $as_T3(x2.value$2);
        if ((p3 !== null)) {
          var arr = $as_Lamf_core_model_domain_AmfElement(p3.$$und2$1);
          if ((arr instanceof $c_Lamf_core_model_domain_AmfArray)) {
            var x6 = $as_Lamf_core_model_domain_AmfArray(arr);
            if (x6.values$1.isEmpty__Z()) {
              this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification, propertyConstraint, parentElement.id__T(), x6.annotations$1);
              (void 0)
            } else {
              (void 0)
            };
            break matchEnd8
          }
        }
      }
    }
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Unsupported property node value " + propertyConstraint.node$1.get__O())))
  }
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V = (function(validationSpecification, propertyConstraint, id, annotations) {
  var jsx$2 = this.validationReport$1;
  var x1 = this.options$1.messageStyle$1;
  var x = $m_Lamf_RAMLStyle$();
  if ((x === x1)) {
    var this$1 = validationSpecification.ramlMessage$1;
    var jsx$1 = (this$1.isEmpty__Z() ? new $c_s_Some().init___O(validationSpecification.message$1) : this$1)
  } else {
    var x$3 = $m_Lamf_OASStyle$();
    if ((x$3 === x1)) {
      var this$2 = validationSpecification.oasMessage$1;
      var jsx$1 = (this$2.isEmpty__Z() ? new $c_s_Some().init___O(validationSpecification.message$1) : this$2)
    } else {
      var jsx$1 = new $c_s_Some().init___O(validationSpecification.message$1)
    }
  };
  jsx$2.registerResult__Lamf_core_validation_core_ValidationResult__V(new $c_Lamf_plugins_features_validation_CustomValidationResult().init___s_Option__T__T__T__T__T(jsx$1, propertyConstraint.ramlPropertyId$1, validationSpecification.id$1, id, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, validationSpecification.id$1))
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.findFieldTarget__Lamf_core_model_domain_DomainElement__T__s_Option = (function(element, property) {
  var this$1 = element.meta__Lamf_core_metamodel_Obj().fields__sci_List();
  inlinereturn$1: {
    var these = this$1;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      var x$3 = $as_Lamf_core_metamodel_Field(arg1);
      if ((x$3.value$1.iri__T() === property)) {
        var x1 = new $c_s_Some().init___O(these.head__O());
        break inlinereturn$1
      };
      these = $as_sc_LinearSeqOptimized(these.tail__O())
    };
    var x1 = $m_s_None$()
  };
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var field = $as_Lamf_core_metamodel_Field(x2.value$2);
    var x1$2 = $m_s_Option$().apply__O__s_Option(element.fields__Lamf_core_parser_Fields().getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value(field));
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var value = $as_Lamf_core_parser_Value(x2$2.value$2);
      var x1$3 = value.value$1;
      if ((x1$3 instanceof $c_Lamf_core_model_domain_AmfArray)) {
        var x2$3 = $as_Lamf_core_model_domain_AmfArray(x1$3);
        return new $c_s_Some().init___O(new $c_T2().init___O__O(value.annotations$1, x2$3.values$1))
      } else if ((x1$3 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
        var x3 = $as_Lamf_core_model_domain_AmfScalar(x1$3);
        var jsx$2 = value.annotations$1;
        var jsx$1 = $m_sc_Seq$();
        var array = [x3];
        return new $c_s_Some().init___O(new $c_T2().init___O__O(jsx$2, jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))))
      } else if ($is_Lamf_core_model_domain_AmfObject(x1$3)) {
        var x4 = $as_Lamf_core_model_domain_AmfObject(x1$3);
        var jsx$4 = value.annotations$1;
        var jsx$3 = $m_sc_Seq$();
        var array$1 = [x4];
        return new $c_s_Some().init___O(new $c_T2().init___O__O(jsx$4, jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1))))
      } else {
        return new $c_s_Some().init___O(new $c_T2().init___O__O(value.annotations$1, $m_sci_Nil$()))
      }
    } else {
      return $m_s_None$()
    }
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.validateDataType__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__Lamf_core_model_domain_DomainElement__V = (function(validationSpecification, propertyConstraint, parentElement) {
  var xsdString = $m_Lamf_core_model_DataType$().String$1;
  var xsdBoolean = $m_Lamf_core_model_DataType$().Boolean$1;
  var xsdInteger = $m_Lamf_core_model_DataType$().Integer$1;
  var xsdDouble = $m_Lamf_core_model_DataType$().Double$1;
  var x1 = this.extractPredicateValue__T__Lamf_core_model_domain_DomainElement__s_Option(propertyConstraint.ramlPropertyId$1, parentElement);
  matchEnd7: {
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var p3 = $as_T3(x2.value$2);
      if ((p3 !== null)) {
        var element = $as_Lamf_core_model_domain_AmfElement(p3.$$und2$1);
        if ((element instanceof $c_Lamf_core_model_domain_AmfArray)) {
          var x2$2 = $as_Lamf_core_model_domain_AmfArray(element);
          var elements = x2$2.values$1
        } else {
          var jsx$1 = $m_sc_Seq$();
          var array = [element];
          var elements = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
        };
        elements.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, propertyConstraint$1, xsdString$1, xsdBoolean$1, validationSpecification$1, parentElement$1, xsdInteger$1, xsdDouble$1) {
          return (function(element$2$2) {
            var element$2 = $as_Lamf_core_model_domain_AmfElement(element$2$2);
            if ((element$2 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
              var x2$1 = $as_Lamf_core_model_domain_AmfScalar(element$2);
              var maybeScalarValue = new $c_s_Some().init___O($this.amfScalarToScala__Lamf_core_model_domain_AmfScalar__O(x2$1))
            } else {
              var maybeScalarValue = $m_s_None$()
            };
            var rc8 = false;
            var x2$2$1 = null;
            var x1$2 = propertyConstraint$1.datatype$1;
            matchEnd9: {
              if ((x1$2 instanceof $c_s_Some)) {
                rc8 = true;
                x2$2$1 = $as_s_Some(x1$2);
                var s = $as_T(x2$2$1.value$2);
                if ((s === xsdString$1)) {
                  break matchEnd9
                }
              };
              if (rc8) {
                var s$2 = $as_T(x2$2$1.value$2);
                if ((s$2 === xsdBoolean$1)) {
                  matchEnd6: {
                    if ((maybeScalarValue instanceof $c_s_Some)) {
                      var x2$3 = $as_s_Some(maybeScalarValue);
                      if (((typeof x2$3.value$2) === "boolean")) {
                        break matchEnd6
                      }
                    };
                    $this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification$1, propertyConstraint$1, parentElement$1.id__T(), $as_Lamf_core_model_domain_AmfScalar(element$2).annotations$1)
                  };
                  break matchEnd9
                }
              };
              if (rc8) {
                var s$3 = $as_T(x2$2$1.value$2);
                if ((s$3 === xsdInteger$1)) {
                  var rc9 = false;
                  var x2$4 = null;
                  matchEnd10: {
                    if ((maybeScalarValue instanceof $c_s_Some)) {
                      rc9 = true;
                      x2$4 = $as_s_Some(maybeScalarValue);
                      if ($isInt(x2$4.value$2)) {
                        break matchEnd10
                      }
                    };
                    if ((rc9 && (x2$4.value$2 instanceof $c_sjsr_RuntimeLong))) {
                      break matchEnd10
                    };
                    $this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification$1, propertyConstraint$1, parentElement$1.id__T(), $as_Lamf_core_model_domain_AmfScalar(element$2).annotations$1)
                  };
                  break matchEnd9
                }
              };
              if (rc8) {
                var s$4 = $as_T(x2$2$1.value$2);
                if ((s$4 === xsdDouble$1)) {
                  var rc15 = false;
                  var x2$5 = null;
                  matchEnd16: {
                    if ((maybeScalarValue instanceof $c_s_Some)) {
                      rc15 = true;
                      x2$5 = $as_s_Some(maybeScalarValue);
                      if ($isInt(x2$5.value$2)) {
                        break matchEnd16
                      }
                    };
                    if ((rc15 && (x2$5.value$2 instanceof $c_sjsr_RuntimeLong))) {
                      break matchEnd16
                    };
                    if ((rc15 && ((typeof x2$5.value$2) === "number"))) {
                      break matchEnd16
                    };
                    if ((rc15 && $isFloat(x2$5.value$2))) {
                      break matchEnd16
                    };
                    $this.reportFailure__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_PropertyConstraint__T__Lamf_core_parser_Annotations__V(validationSpecification$1, propertyConstraint$1, parentElement$1.id__T(), $as_Lamf_core_model_domain_AmfScalar(element$2).annotations$1)
                  };
                  break matchEnd9
                }
              };
              if (rc8) {
                var other = $as_T(x2$2$1.value$2);
                throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T((("Data type '" + other) + "' for sh:datatype property constraint not supported yet")))
              }
            }
          })
        })(this, propertyConstraint, xsdString, xsdBoolean, validationSpecification, parentElement, xsdInteger, xsdDouble)));
        break matchEnd7
      }
    }
  }
});
var $d_Lamf_plugins_features_validation_CustomShaclValidator = new $TypeData().initClass({
  Lamf_plugins_features_validation_CustomShaclValidator: 0
}, false, "amf.plugins.features.validation.CustomShaclValidator", {
  Lamf_plugins_features_validation_CustomShaclValidator: 1,
  O: 1
});
$c_Lamf_plugins_features_validation_CustomShaclValidator.prototype.$classData = $d_Lamf_plugins_features_validation_CustomShaclValidator;
/** @constructor */
function $c_Lamf_plugins_features_validation_JSUtils$() {
  $c_O.call(this)
}
$c_Lamf_plugins_features_validation_JSUtils$.prototype = new $h_O();
$c_Lamf_plugins_features_validation_JSUtils$.prototype.constructor = $c_Lamf_plugins_features_validation_JSUtils$;
/** @constructor */
function $h_Lamf_plugins_features_validation_JSUtils$() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_JSUtils$.prototype = $c_Lamf_plugins_features_validation_JSUtils$.prototype;
$c_Lamf_plugins_features_validation_JSUtils$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_features_validation_JSUtils$.prototype.$default__sjs_js_Dynamic__O__O = (function(x, $default) {
  return ((x === (void 0)) ? $default : ($m_s_Option$().apply__O__s_Option(x).isEmpty__Z() ? $default : x))
});
$c_Lamf_plugins_features_validation_JSUtils$.prototype.maybe__sjs_js_Dynamic__s_Option = (function(obj) {
  return ((obj === (void 0)) ? $m_s_None$() : ($m_s_Option$().apply__O__s_Option(obj).isEmpty__Z() ? $m_s_None$() : new $c_s_Some().init___O(obj)))
});
var $d_Lamf_plugins_features_validation_JSUtils$ = new $TypeData().initClass({
  Lamf_plugins_features_validation_JSUtils$: 0
}, false, "amf.plugins.features.validation.JSUtils$", {
  Lamf_plugins_features_validation_JSUtils$: 1,
  O: 1
});
$c_Lamf_plugins_features_validation_JSUtils$.prototype.$classData = $d_Lamf_plugins_features_validation_JSUtils$;
var $n_Lamf_plugins_features_validation_JSUtils$ = (void 0);
function $m_Lamf_plugins_features_validation_JSUtils$() {
  if ((!$n_Lamf_plugins_features_validation_JSUtils$)) {
    $n_Lamf_plugins_features_validation_JSUtils$ = new $c_Lamf_plugins_features_validation_JSUtils$().init___()
  };
  return $n_Lamf_plugins_features_validation_JSUtils$
}
/** @constructor */
function $c_Lamf_plugins_features_validation_ParserSideValidationProfiler$() {
  $c_O.call(this);
  this.cache$1 = null
}
$c_Lamf_plugins_features_validation_ParserSideValidationProfiler$.prototype = new $h_O();
$c_Lamf_plugins_features_validation_ParserSideValidationProfiler$.prototype.constructor = $c_Lamf_plugins_features_validation_ParserSideValidationProfiler$;
/** @constructor */
function $h_Lamf_plugins_features_validation_ParserSideValidationProfiler$() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_ParserSideValidationProfiler$.prototype = $c_Lamf_plugins_features_validation_ParserSideValidationProfiler$.prototype;
$c_Lamf_plugins_features_validation_ParserSideValidationProfiler$.prototype.init___ = (function() {
  $n_Lamf_plugins_features_validation_ParserSideValidationProfiler$ = this;
  this.cache$1 = new $c_scm_HashMap().init___();
  return this
});
$c_Lamf_plugins_features_validation_ParserSideValidationProfiler$.prototype.computeProfile__p1__Lamf_ProfileName__Lamf_core_validation_core_ValidationProfile = (function(profile) {
  var this$1 = $m_Lamf_plugins_features_validation_Validations$().validations$1;
  var f = (function($this, profile$1) {
    return (function(v$2) {
      var v = $as_Lamf_core_validation_core_ValidationSpecification(v$2);
      return ($m_Lamf_plugins_features_validation_Validations$().level__T__Lamf_ProfileName__T(v.id$1, profile$1) === $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1)
    })
  })(this, profile);
  if ((this$1 !== null)) {
    var l = this$1;
    var l$1 = l;
    x: {
      var result;
      _noneIn: while (true) {
        if (l$1.isEmpty__Z()) {
          var result = $m_sci_Nil$();
          break
        } else {
          var h = l$1.head__O();
          var t = $as_sci_List(l$1.tail__O());
          if (($uZ(f(h)) === false)) {
            l$1 = t;
            continue _noneIn
          };
          var start = l$1;
          var remaining = t;
          var remaining$1 = remaining;
          _allIn: while (true) {
            if (remaining$1.isEmpty__Z()) {
              var result = start;
              break x
            } else {
              var x$2 = remaining$1.head__O();
              if (($uZ(f(x$2)) !== false)) {
                remaining$1 = $as_sci_List(remaining$1.tail__O());
                continue _allIn
              };
              var firstMiss = remaining$1;
              var newHead = new $c_sci_$colon$colon().init___O__sci_List(start.head__O(), $m_sci_Nil$());
              var toProcess = $as_sci_List(start.tail__O());
              var currentLast = newHead;
              while ((toProcess !== firstMiss)) {
                var newElem = new $c_sci_$colon$colon().init___O__sci_List(toProcess.head__O(), $m_sci_Nil$());
                currentLast.tl$5 = newElem;
                currentLast = newElem;
                toProcess = $as_sci_List(toProcess.tail__O())
              };
              var next = $as_sci_List(firstMiss.tail__O());
              var nextToCopy = next;
              while ((!next.isEmpty__Z())) {
                var head = next.head__O();
                if (($uZ(f(head)) !== false)) {
                  next = $as_sci_List(next.tail__O())
                } else {
                  while ((nextToCopy !== next)) {
                    var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy.head__O(), $m_sci_Nil$());
                    currentLast.tl$5 = newElem$2;
                    currentLast = newElem$2;
                    nextToCopy = $as_sci_List(nextToCopy.tail__O())
                  };
                  nextToCopy = $as_sci_List(next.tail__O());
                  next = $as_sci_List(next.tail__O())
                }
              };
              if ((!nextToCopy.isEmpty__Z())) {
                currentLast.tl$5 = nextToCopy
              };
              var result = newHead;
              break x
            }
          }
        }
      }
    };
    var this$4 = result
  } else {
    $m_sci_List$();
    var b = new $c_scm_ListBuffer().init___();
    var these = this$1;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      if (($uZ(f(arg1)) !== false)) {
        b.$$plus$eq__O__scm_ListBuffer(arg1)
      };
      these = $as_sci_List(these.tail__O())
    };
    var this$4 = b.toList__sci_List()
  };
  var f$1 = (function(this$2$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_validation_core_ValidationSpecification(x$1$2);
      return x$1.name$1
    })
  })(this);
  var this$3 = $m_sci_List$();
  var bf = this$3.ReusableCBFInstance$2;
  if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
    if ((this$4 === $m_sci_Nil$())) {
      var jsx$1 = $m_sci_Nil$()
    } else {
      var arg1$1 = this$4.head__O();
      var h$1 = new $c_sci_$colon$colon().init___O__sci_List(f$1(arg1$1), $m_sci_Nil$());
      var t$1 = h$1;
      var rest = $as_sci_List(this$4.tail__O());
      while ((rest !== $m_sci_Nil$())) {
        var arg1$2 = rest.head__O();
        var nx = new $c_sci_$colon$colon().init___O__sci_List(f$1(arg1$2), $m_sci_Nil$());
        t$1.tl$5 = nx;
        t$1 = nx;
        rest = $as_sci_List(rest.tail__O())
      };
      var jsx$1 = h$1
    }
  } else {
    var b$1 = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$4, bf);
    var these$1 = this$4;
    while ((!these$1.isEmpty__Z())) {
      var arg1$3 = these$1.head__O();
      b$1.$$plus$eq__O__scm_Builder(f$1(arg1$3));
      these$1 = $as_sci_List(these$1.tail__O())
    };
    var jsx$1 = b$1.result__O()
  };
  var violationParserSideValidations = $as_sci_List(jsx$1);
  var this$5 = $m_Lamf_plugins_features_validation_Validations$().validations$1;
  var f$2 = (function(this$3$1, profile$2) {
    return (function(v$3$2) {
      var v$3 = $as_Lamf_core_validation_core_ValidationSpecification(v$3$2);
      return ($m_Lamf_plugins_features_validation_Validations$().level__T__Lamf_ProfileName__T(v$3.id$1, profile$2) === $m_Lamf_core_validation_SeverityLevels$().INFO$1)
    })
  })(this, profile);
  if ((this$5 !== null)) {
    var l$2 = this$5;
    var l$3 = l$2;
    x$2: {
      var result$1;
      _noneIn$1: while (true) {
        if (l$3.isEmpty__Z()) {
          var result$1 = $m_sci_Nil$();
          break
        } else {
          var h$2 = l$3.head__O();
          var t$2 = $as_sci_List(l$3.tail__O());
          if (($uZ(f$2(h$2)) === false)) {
            l$3 = t$2;
            continue _noneIn$1
          };
          var start$1 = l$3;
          var remaining$2 = t$2;
          var remaining$3 = remaining$2;
          _allIn$1: while (true) {
            if (remaining$3.isEmpty__Z()) {
              var result$1 = start$1;
              break x$2
            } else {
              var x$2$1 = remaining$3.head__O();
              if (($uZ(f$2(x$2$1)) !== false)) {
                remaining$3 = $as_sci_List(remaining$3.tail__O());
                continue _allIn$1
              };
              var firstMiss$1 = remaining$3;
              var newHead$1 = new $c_sci_$colon$colon().init___O__sci_List(start$1.head__O(), $m_sci_Nil$());
              var toProcess$1 = $as_sci_List(start$1.tail__O());
              var currentLast$1 = newHead$1;
              while ((toProcess$1 !== firstMiss$1)) {
                var newElem$1 = new $c_sci_$colon$colon().init___O__sci_List(toProcess$1.head__O(), $m_sci_Nil$());
                currentLast$1.tl$5 = newElem$1;
                currentLast$1 = newElem$1;
                toProcess$1 = $as_sci_List(toProcess$1.tail__O())
              };
              var next$1 = $as_sci_List(firstMiss$1.tail__O());
              var nextToCopy$1 = next$1;
              while ((!next$1.isEmpty__Z())) {
                var head$1 = next$1.head__O();
                if (($uZ(f$2(head$1)) !== false)) {
                  next$1 = $as_sci_List(next$1.tail__O())
                } else {
                  while ((nextToCopy$1 !== next$1)) {
                    var newElem$2$1 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy$1.head__O(), $m_sci_Nil$());
                    currentLast$1.tl$5 = newElem$2$1;
                    currentLast$1 = newElem$2$1;
                    nextToCopy$1 = $as_sci_List(nextToCopy$1.tail__O())
                  };
                  nextToCopy$1 = $as_sci_List(next$1.tail__O());
                  next$1 = $as_sci_List(next$1.tail__O())
                }
              };
              if ((!nextToCopy$1.isEmpty__Z())) {
                currentLast$1.tl$5 = nextToCopy$1
              };
              var result$1 = newHead$1;
              break x$2
            }
          }
        }
      }
    };
    var this$8 = result$1
  } else {
    $m_sci_List$();
    var b$2 = new $c_scm_ListBuffer().init___();
    var these$2 = this$5;
    while ((!these$2.isEmpty__Z())) {
      var arg1$4 = these$2.head__O();
      if (($uZ(f$2(arg1$4)) !== false)) {
        b$2.$$plus$eq__O__scm_ListBuffer(arg1$4)
      };
      these$2 = $as_sci_List(these$2.tail__O())
    };
    var this$8 = b$2.toList__sci_List()
  };
  var f$3 = (function(this$4$1) {
    return (function(x$2$2) {
      var x$2$3 = $as_Lamf_core_validation_core_ValidationSpecification(x$2$2);
      return x$2$3.name$1
    })
  })(this);
  var this$7 = $m_sci_List$();
  var bf$1 = this$7.ReusableCBFInstance$2;
  if ((bf$1 === $m_sci_List$().ReusableCBFInstance$2)) {
    if ((this$8 === $m_sci_Nil$())) {
      var jsx$2 = $m_sci_Nil$()
    } else {
      var arg1$5 = this$8.head__O();
      var h$3 = new $c_sci_$colon$colon().init___O__sci_List(f$3(arg1$5), $m_sci_Nil$());
      var t$3 = h$3;
      var rest$1 = $as_sci_List(this$8.tail__O());
      while ((rest$1 !== $m_sci_Nil$())) {
        var arg1$6 = rest$1.head__O();
        var nx$1 = new $c_sci_$colon$colon().init___O__sci_List(f$3(arg1$6), $m_sci_Nil$());
        t$3.tl$5 = nx$1;
        t$3 = nx$1;
        rest$1 = $as_sci_List(rest$1.tail__O())
      };
      var jsx$2 = h$3
    }
  } else {
    var b$3 = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$8, bf$1);
    var these$3 = this$8;
    while ((!these$3.isEmpty__Z())) {
      var arg1$7 = these$3.head__O();
      b$3.$$plus$eq__O__scm_Builder(f$3(arg1$7));
      these$3 = $as_sci_List(these$3.tail__O())
    };
    var jsx$2 = b$3.result__O()
  };
  var infoParserSideValidations = $as_sci_List(jsx$2);
  var this$9 = $m_Lamf_plugins_features_validation_Validations$().validations$1;
  var f$4 = (function(this$5$1, profile$3) {
    return (function(v$4$2) {
      var v$4 = $as_Lamf_core_validation_core_ValidationSpecification(v$4$2);
      return ($m_Lamf_plugins_features_validation_Validations$().level__T__Lamf_ProfileName__T(v$4.id$1, profile$3) === $m_Lamf_core_validation_SeverityLevels$().WARNING$1)
    })
  })(this, profile);
  if ((this$9 !== null)) {
    var l$4 = this$9;
    var l$5 = l$4;
    x$4: {
      var result$2;
      _noneIn$2: while (true) {
        if (l$5.isEmpty__Z()) {
          var result$2 = $m_sci_Nil$();
          break
        } else {
          var h$4 = l$5.head__O();
          var t$4 = $as_sci_List(l$5.tail__O());
          if (($uZ(f$4(h$4)) === false)) {
            l$5 = t$4;
            continue _noneIn$2
          };
          var start$2 = l$5;
          var remaining$4 = t$4;
          var remaining$5 = remaining$4;
          _allIn$2: while (true) {
            if (remaining$5.isEmpty__Z()) {
              var result$2 = start$2;
              break x$4
            } else {
              var x$2$4 = remaining$5.head__O();
              if (($uZ(f$4(x$2$4)) !== false)) {
                remaining$5 = $as_sci_List(remaining$5.tail__O());
                continue _allIn$2
              };
              var firstMiss$2 = remaining$5;
              var newHead$2 = new $c_sci_$colon$colon().init___O__sci_List(start$2.head__O(), $m_sci_Nil$());
              var toProcess$2 = $as_sci_List(start$2.tail__O());
              var currentLast$2 = newHead$2;
              while ((toProcess$2 !== firstMiss$2)) {
                var newElem$3 = new $c_sci_$colon$colon().init___O__sci_List(toProcess$2.head__O(), $m_sci_Nil$());
                currentLast$2.tl$5 = newElem$3;
                currentLast$2 = newElem$3;
                toProcess$2 = $as_sci_List(toProcess$2.tail__O())
              };
              var next$2 = $as_sci_List(firstMiss$2.tail__O());
              var nextToCopy$2 = next$2;
              while ((!next$2.isEmpty__Z())) {
                var head$2 = next$2.head__O();
                if (($uZ(f$4(head$2)) !== false)) {
                  next$2 = $as_sci_List(next$2.tail__O())
                } else {
                  while ((nextToCopy$2 !== next$2)) {
                    var newElem$2$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy$2.head__O(), $m_sci_Nil$());
                    currentLast$2.tl$5 = newElem$2$2;
                    currentLast$2 = newElem$2$2;
                    nextToCopy$2 = $as_sci_List(nextToCopy$2.tail__O())
                  };
                  nextToCopy$2 = $as_sci_List(next$2.tail__O());
                  next$2 = $as_sci_List(next$2.tail__O())
                }
              };
              if ((!nextToCopy$2.isEmpty__Z())) {
                currentLast$2.tl$5 = nextToCopy$2
              };
              var result$2 = newHead$2;
              break x$4
            }
          }
        }
      }
    };
    var this$12 = result$2
  } else {
    $m_sci_List$();
    var b$4 = new $c_scm_ListBuffer().init___();
    var these$4 = this$9;
    while ((!these$4.isEmpty__Z())) {
      var arg1$8 = these$4.head__O();
      if (($uZ(f$4(arg1$8)) !== false)) {
        b$4.$$plus$eq__O__scm_ListBuffer(arg1$8)
      };
      these$4 = $as_sci_List(these$4.tail__O())
    };
    var this$12 = b$4.toList__sci_List()
  };
  var f$5 = (function(this$6$1) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_core_validation_core_ValidationSpecification(x$3$2);
      return x$3.name$1
    })
  })(this);
  var this$11 = $m_sci_List$();
  var bf$2 = this$11.ReusableCBFInstance$2;
  if ((bf$2 === $m_sci_List$().ReusableCBFInstance$2)) {
    if ((this$12 === $m_sci_Nil$())) {
      var jsx$3 = $m_sci_Nil$()
    } else {
      var arg1$9 = this$12.head__O();
      var h$5 = new $c_sci_$colon$colon().init___O__sci_List(f$5(arg1$9), $m_sci_Nil$());
      var t$5 = h$5;
      var rest$2 = $as_sci_List(this$12.tail__O());
      while ((rest$2 !== $m_sci_Nil$())) {
        var arg1$10 = rest$2.head__O();
        var nx$2 = new $c_sci_$colon$colon().init___O__sci_List(f$5(arg1$10), $m_sci_Nil$());
        t$5.tl$5 = nx$2;
        t$5 = nx$2;
        rest$2 = $as_sci_List(rest$2.tail__O())
      };
      var jsx$3 = h$5
    }
  } else {
    var b$5 = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$12, bf$2);
    var these$5 = this$12;
    while ((!these$5.isEmpty__Z())) {
      var arg1$11 = these$5.head__O();
      b$5.$$plus$eq__O__scm_Builder(f$5(arg1$11));
      these$5 = $as_sci_List(these$5.tail__O())
    };
    var jsx$3 = b$5.result__O()
  };
  var warningParserSideValidations = $as_sci_List(jsx$3);
  var x$1$3 = $m_Lamf_ProfileName$().apply__T__Lamf_ProfileName("Parser side AMF Validation");
  var x$2$3$1 = $m_s_None$();
  var x$6 = $m_Lamf_plugins_features_validation_Validations$().validations$1;
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$16 = new $c_scm_ListBuffer().init___();
  var x$7 = this$16.toList__sci_List();
  var x$8 = new $c_scm_HashMap().init___();
  return new $c_Lamf_core_validation_core_ValidationProfile().init___Lamf_ProfileName__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__scm_Map(x$1$3, x$2$3$1, violationParserSideValidations, infoParserSideValidations, warningParserSideValidations, x$7, x$6, x$8)
});
$c_Lamf_plugins_features_validation_ParserSideValidationProfiler$.prototype.parserSideValidationsProfile__Lamf_ProfileName__Lamf_core_validation_core_ValidationProfile = (function(profile) {
  var x1 = this.cache$1.get__O__s_Option(profile);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var vp = $as_Lamf_core_validation_core_ValidationProfile(x2.value$2);
    return vp
  } else {
    var vp$2 = this.computeProfile__p1__Lamf_ProfileName__Lamf_core_validation_core_ValidationProfile(profile);
    this.cache$1.put__O__O__s_Option(profile, vp$2);
    return vp$2
  }
});
var $d_Lamf_plugins_features_validation_ParserSideValidationProfiler$ = new $TypeData().initClass({
  Lamf_plugins_features_validation_ParserSideValidationProfiler$: 0
}, false, "amf.plugins.features.validation.ParserSideValidationProfiler$", {
  Lamf_plugins_features_validation_ParserSideValidationProfiler$: 1,
  O: 1
});
$c_Lamf_plugins_features_validation_ParserSideValidationProfiler$.prototype.$classData = $d_Lamf_plugins_features_validation_ParserSideValidationProfiler$;
var $n_Lamf_plugins_features_validation_ParserSideValidationProfiler$ = (void 0);
function $m_Lamf_plugins_features_validation_ParserSideValidationProfiler$() {
  if ((!$n_Lamf_plugins_features_validation_ParserSideValidationProfiler$)) {
    $n_Lamf_plugins_features_validation_ParserSideValidationProfiler$ = new $c_Lamf_plugins_features_validation_ParserSideValidationProfiler$().init___()
  };
  return $n_Lamf_plugins_features_validation_ParserSideValidationProfiler$
}
/** @constructor */
function $c_Lamf_plugins_features_validation_PlatformValidator$() {
  $c_O.call(this);
  this.instance$1 = null
}
$c_Lamf_plugins_features_validation_PlatformValidator$.prototype = new $h_O();
$c_Lamf_plugins_features_validation_PlatformValidator$.prototype.constructor = $c_Lamf_plugins_features_validation_PlatformValidator$;
/** @constructor */
function $h_Lamf_plugins_features_validation_PlatformValidator$() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_PlatformValidator$.prototype = $c_Lamf_plugins_features_validation_PlatformValidator$.prototype;
$c_Lamf_plugins_features_validation_PlatformValidator$.prototype.init___ = (function() {
  $n_Lamf_plugins_features_validation_PlatformValidator$ = this;
  this.instance$1 = new $c_Lamf_plugins_features_validation_SHACLValidator().init___();
  return this
});
var $d_Lamf_plugins_features_validation_PlatformValidator$ = new $TypeData().initClass({
  Lamf_plugins_features_validation_PlatformValidator$: 0
}, false, "amf.plugins.features.validation.PlatformValidator$", {
  Lamf_plugins_features_validation_PlatformValidator$: 1,
  O: 1
});
$c_Lamf_plugins_features_validation_PlatformValidator$.prototype.$classData = $d_Lamf_plugins_features_validation_PlatformValidator$;
var $n_Lamf_plugins_features_validation_PlatformValidator$ = (void 0);
function $m_Lamf_plugins_features_validation_PlatformValidator$() {
  if ((!$n_Lamf_plugins_features_validation_PlatformValidator$)) {
    $n_Lamf_plugins_features_validation_PlatformValidator$ = new $c_Lamf_plugins_features_validation_PlatformValidator$().init___()
  };
  return $n_Lamf_plugins_features_validation_PlatformValidator$
}
/** @constructor */
function $c_Lamf_plugins_features_validation_RDF$() {
  $c_O.call(this);
  this.instance$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_features_validation_RDF$.prototype = new $h_O();
$c_Lamf_plugins_features_validation_RDF$.prototype.constructor = $c_Lamf_plugins_features_validation_RDF$;
/** @constructor */
function $h_Lamf_plugins_features_validation_RDF$() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_RDF$.prototype = $c_Lamf_plugins_features_validation_RDF$.prototype;
$c_Lamf_plugins_features_validation_RDF$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_features_validation_RDF$.prototype.instance$lzycompute__p1__sjs_js_Dynamic = (function() {
  if ((!this.bitmap$0$1)) {
    var v = $g.GlobalSHACLValidator;
    if ((v === (void 0))) {
      var jsx$1;
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Cannot find global SHACLValidator object"))
    } else {
      var jsx$1 = $g.GlobalSHACLValidator.$rdf
    };
    this.instance$1 = jsx$1;
    this.bitmap$0$1 = true
  };
  return this.instance$1
});
$c_Lamf_plugins_features_validation_RDF$.prototype.instance__sjs_js_Dynamic = (function() {
  return ((!this.bitmap$0$1) ? this.instance$lzycompute__p1__sjs_js_Dynamic() : this.instance$1)
});
var $d_Lamf_plugins_features_validation_RDF$ = new $TypeData().initClass({
  Lamf_plugins_features_validation_RDF$: 0
}, false, "amf.plugins.features.validation.RDF$", {
  Lamf_plugins_features_validation_RDF$: 1,
  O: 1
});
$c_Lamf_plugins_features_validation_RDF$.prototype.$classData = $d_Lamf_plugins_features_validation_RDF$;
var $n_Lamf_plugins_features_validation_RDF$ = (void 0);
function $m_Lamf_plugins_features_validation_RDF$() {
  if ((!$n_Lamf_plugins_features_validation_RDF$)) {
    $n_Lamf_plugins_features_validation_RDF$ = new $c_Lamf_plugins_features_validation_RDF$().init___()
  };
  return $n_Lamf_plugins_features_validation_RDF$
}
/** @constructor */
function $c_Lamf_plugins_features_validation_RdflibRdfModel$() {
  $c_O.call(this)
}
$c_Lamf_plugins_features_validation_RdflibRdfModel$.prototype = new $h_O();
$c_Lamf_plugins_features_validation_RdflibRdfModel$.prototype.constructor = $c_Lamf_plugins_features_validation_RdflibRdfModel$;
/** @constructor */
function $h_Lamf_plugins_features_validation_RdflibRdfModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_RdflibRdfModel$.prototype = $c_Lamf_plugins_features_validation_RdflibRdfModel$.prototype;
$c_Lamf_plugins_features_validation_RdflibRdfModel$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_features_validation_RdflibRdfModel$.prototype.$$lessinit$greater$default$1__sjs_js_Dynamic = (function() {
  return $m_Lamf_plugins_features_validation_RDF$().instance__sjs_js_Dynamic().graph()
});
var $d_Lamf_plugins_features_validation_RdflibRdfModel$ = new $TypeData().initClass({
  Lamf_plugins_features_validation_RdflibRdfModel$: 0
}, false, "amf.plugins.features.validation.RdflibRdfModel$", {
  Lamf_plugins_features_validation_RdflibRdfModel$: 1,
  O: 1
});
$c_Lamf_plugins_features_validation_RdflibRdfModel$.prototype.$classData = $d_Lamf_plugins_features_validation_RdflibRdfModel$;
var $n_Lamf_plugins_features_validation_RdflibRdfModel$ = (void 0);
function $m_Lamf_plugins_features_validation_RdflibRdfModel$() {
  if ((!$n_Lamf_plugins_features_validation_RdflibRdfModel$)) {
    $n_Lamf_plugins_features_validation_RdflibRdfModel$ = new $c_Lamf_plugins_features_validation_RdflibRdfModel$().init___()
  };
  return $n_Lamf_plugins_features_validation_RdflibRdfModel$
}
/** @constructor */
function $c_Lamf_plugins_features_validation_emitters_JSLibraryEmitter() {
  $c_O.call(this);
  this.profile$1 = null;
  this.preamble$1 = null
}
$c_Lamf_plugins_features_validation_emitters_JSLibraryEmitter.prototype = new $h_O();
$c_Lamf_plugins_features_validation_emitters_JSLibraryEmitter.prototype.constructor = $c_Lamf_plugins_features_validation_emitters_JSLibraryEmitter;
/** @constructor */
function $h_Lamf_plugins_features_validation_emitters_JSLibraryEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_emitters_JSLibraryEmitter.prototype = $c_Lamf_plugins_features_validation_emitters_JSLibraryEmitter.prototype;
$c_Lamf_plugins_features_validation_emitters_JSLibraryEmitter.prototype.composeText__sc_Seq__T = (function(validations) {
  var elem = this.preamble$1;
  var text = new $c_sr_ObjectRef().init___O(elem);
  validations.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, text$1) {
    return (function(validation$2) {
      var validation = $as_Lamf_core_validation_core_ValidationSpecification(validation$2);
      var constraint = $as_Lamf_core_validation_core_FunctionConstraint(validation.functionConstraint$1.get__O());
      if (constraint.parameters$1.nonEmpty__Z()) {
        var jsx$2 = constraint.parameters$1;
        var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
          return (function(param$2) {
            var param = $as_Lamf_core_validation_core_FunctionConstraintParameter(param$2);
            var thiz = param.path__T();
            var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "#", 0);
            var this$4 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
            return ("$" + $f_sc_IndexedSeqOptimized__last__O(this$4))
          })
        })($this));
        var this$5 = $m_sc_Seq$();
        var additionalParams = ("," + $as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2)).mkString__T__T(","))
      } else {
        var additionalParams = ""
      };
      var jsx$3 = $as_T(text$1.elem$1);
      var x = (((((((("\n        |\n        |function " + constraint.computeFunctionName__T__T(validation.id$1)) + "($this, $value ") + additionalParams) + ") {\n        |  var innerFn = ") + constraint.code$1.get__O()) + ";\n        |  var input = amfFindNode($this, {});\n        |  // print(JSON.stringify(input))\n        |  try {\n        |    return innerFn(input, $value ") + additionalParams) + ");\n        |  } catch(e) {\n        |    return false;\n        |  }\n        |}\n        |\n      ");
      var this$7 = new $c_sci_StringOps().init___T(x);
      text$1.elem$1 = (("" + jsx$3) + $f_sci_StringLike__stripMargin__C__T(this$7, 124))
    })
  })(this, text)));
  return $as_T(text.elem$1)
});
$c_Lamf_plugins_features_validation_emitters_JSLibraryEmitter.prototype.init___s_Option = (function(profile) {
  this.profile$1 = profile;
  var x = (("\n       |function amfExtractLiteral(v){\n       |    if(v.datatype == null || v.datatype.value === \"http://www.w3.org/2001/XMLSchema#string\") {\n       |        return v.value;\n       |    } else if(v.datatype.value === \"http://www.w3.org/2001/XMLSchema#integer\") {\n       |        return parseInt(v.value);\n       |    } else if(v.datatype.value === \"http://www.w3.org/2001/XMLSchema#float\") {\n       |        return parseFloat(v.value);\n       |    } else if(v.datatype.value === \"http://www.w3.org/2001/XMLSchema#double\") {\n       |        return v.value;\n       |    } else if(v.datatype.value === \"http://www.w3.org/2001/XMLSchema#boolean\") {\n       |        return v.value === \"true\";\n       |    } else {\n       |        return v.value;\n       |    }\n       |}\n       |\n       |function amfCompactProperty(prop) {\n       |    var prefixes = " + this.prefixes__T()) + ";\n       |    for (var p in prefixes) {\n       |        if (prop.indexOf(prefixes[p]) === 0) {\n       |            return p + \":\" + prop.replace(prefixes[p], \"\")\n       |        }\n       |    }\n       |\n       |    return prop;\n       |}\n       |\n       |function amfFindNode(node, cache) {\n       |    var acc = {\"@id\": amfCompactProperty(node.value)};\n       |    var pairs = $data.query().match(node, \"?p\", \"?o\");\n       |    cache[node.value] = acc;\n       |    for(var pair = pairs.nextSolution(); pair; pair = pairs.nextSolution()) {\n       |        var prop = amfCompactProperty(pair.p.value);\n       |        if (pair.p.value === \"http://www.w3.org/1999/02/22-rdf-syntax-ns#type\") {\n       |            prop = \"@type\"\n       |        }\n       |\n       |        var value = acc[prop] || [];\n       |        acc[prop] = value;\n       |        if(prop === \"@type\") {\n       |            value.push(amfCompactProperty(pair.o.value));\n       |        } else if(pair.o.termType === \"BlankNode\" || pair.o.termType === \"NamedNode\") {\n       |            value.push(cache[pair.o.value] || amfFindNode(pair.o, cache));\n       |        } else if (pair.o.termType === \"Literal\"){\n       |          value.push(amfExtractLiteral(pair.o));\n       |        }\n       |    }\n       |\n       |    return acc;\n       |}\n       |\n       |function path(node, path) {\n       |  var acc = [node]\n       |  if (node.constructor === Array) {\n       |    acc = node;\n       |  }\n       |  var paths = path.replace(new RegExp(\" \",\"g\"), \"\").split(\"/\") || [];\n       |  for (var i=0; i<paths.length; i++) {\n       |    var nextPath = paths[i];\n       |    var newAcc = [];\n       |    for (var j=0; j<acc.length; j++) {\n       |      var nextNode = acc[j];\n       |      newAcc = newAcc.concat(nextNode[nextPath] || [])\n       |    }\n       |    acc = newAcc;\n       |  }\n       |\n       |  return acc;\n       |}\n       |\n       |function value(node, propertyPath, value) {\n       |  var values = path(node, propertyPath);\n       |  for (var i=0; i<values.length; i++) {\n       |    if (values[i] === value)\n       |      return true;\n       |  }\n       |  return false;\n       |}\n       |\n       |function filterByPropertyValue(nodes, propertyPath, val) {\n       |  var acc = [];\n       |  for (var i=0; i<nodes.length; i++) {\n       |    if (value(nodes[i], propertyPath, val)) {\n       |      acc.push(nodes[i]);\n       |    }\n       |  }\n       |  return acc;\n       |}\n       |\n       |\n       |\n       |function isModelType(node, type) {\n       |  if (node == null) {\n       |    return false;\n       |  }\n       |  if (node.constructor === Array && node.length == 1) {\n       |    node = node[0]\n       |  }\n       |  var types = node['@type'] || [];\n       |  for(var i=0; i<types.length; i++) {\n       |    if (types[i] === type) {\n       |      return true;\n       |    }\n       |  }\n       |\n       |  return false;\n       |}\n       |\n       |if (typeof(console) === \"undefined\") {\n       |  console = {\n       |    log: function(x) { print(x) }\n       |  };\n       |}\n       |\n       |if (typeof(accumulators) == \"undefined\") {\n       |  accumulators = {};\n       |}\n       |for (var p in accumulators) {\n       |  delete accumulators[p];\n       |}\n    ");
  var this$2 = new $c_sci_StringOps().init___T(x);
  this.preamble$1 = $f_sci_StringLike__stripMargin__C__T(this$2, 124);
  return this
});
$c_Lamf_plugins_features_validation_emitters_JSLibraryEmitter.prototype.prefixes__T = (function() {
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ns$1;
  var f = (function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var prefix = $as_T(x0$1.$$und1__O());
        return ((prefix !== "schema-org") && (prefix !== "raml-http"))
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this);
  if ((this$1 instanceof $c_sci_List)) {
    var x2 = $as_sci_List(this$1);
    var l = x2;
    var l$1 = l;
    x: {
      var result;
      _noneIn: while (true) {
        if (l$1.isEmpty__Z()) {
          var result = $m_sci_Nil$();
          break
        } else {
          var h = l$1.head__O();
          var t = $as_sci_List(l$1.tail__O());
          if (($uZ(f(h)) === false)) {
            l$1 = t;
            continue _noneIn
          };
          var start = l$1;
          var remaining = t;
          var remaining$1 = remaining;
          _allIn: while (true) {
            if (remaining$1.isEmpty__Z()) {
              var result = start;
              break x
            } else {
              var x$2 = remaining$1.head__O();
              if (($uZ(f(x$2)) !== false)) {
                remaining$1 = $as_sci_List(remaining$1.tail__O());
                continue _allIn
              };
              var firstMiss = remaining$1;
              var newHead = new $c_sci_$colon$colon().init___O__sci_List(start.head__O(), $m_sci_Nil$());
              var toProcess = $as_sci_List(start.tail__O());
              var currentLast = newHead;
              while ((toProcess !== firstMiss)) {
                var newElem = new $c_sci_$colon$colon().init___O__sci_List(toProcess.head__O(), $m_sci_Nil$());
                currentLast.tl$5 = newElem;
                currentLast = newElem;
                toProcess = $as_sci_List(toProcess.tail__O())
              };
              var next = $as_sci_List(firstMiss.tail__O());
              var nextToCopy = next;
              while ((!next.isEmpty__Z())) {
                var head = next.head__O();
                if (($uZ(f(head)) !== false)) {
                  next = $as_sci_List(next.tail__O())
                } else {
                  while ((nextToCopy !== next)) {
                    var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy.head__O(), $m_sci_Nil$());
                    currentLast.tl$5 = newElem$2;
                    currentLast = newElem$2;
                    nextToCopy = $as_sci_List(nextToCopy.tail__O())
                  };
                  nextToCopy = $as_sci_List(next.tail__O());
                  next = $as_sci_List(next.tail__O())
                }
              };
              if ((!nextToCopy.isEmpty__Z())) {
                currentLast.tl$5 = nextToCopy
              };
              var result = newHead;
              break x
            }
          }
        }
      }
    };
    var jsx$1 = result
  } else {
    var b = new $c_scm_HashMap().init___();
    var iterTable = this$1.table$5;
    var idx = $f_scm_HashTable__scala$collection$mutable$HashTable$$lastPopulatedIndex__I(this$1);
    var es = iterTable.get(idx);
    while ((es !== null)) {
      var next$1 = $as_scm_HashEntry(es.next__O());
      var arg1 = es;
      var e = $as_scm_DefaultEntry(arg1);
      var arg1$1 = new $c_T2().init___O__O(e.key$1, e.value$1);
      if (($uZ(f(arg1$1)) !== false)) {
        b.$$plus$eq__T2__scm_HashMap(arg1$1)
      };
      es = next$1;
      while (((es === null) && (idx > 0))) {
        idx = (((-1) + idx) | 0);
        es = iterTable.get(idx)
      }
    };
    var jsx$1 = b
  };
  var namespaces = $as_scm_HashMap(jsx$1);
  var x1 = this.profile$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2$1 = $as_s_Some(x1);
    var prof = $as_Lamf_core_validation_core_ValidationProfile(x2$1.value$2);
    var customNamespaces = prof.prefixes$1
  } else {
    var customNamespaces = $as_sc_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()))
  };
  var this$3 = $m_scm_HashMap$();
  var bf = new $c_scg_GenMapFactory$MapCanBuildFrom().init___scg_GenMapFactory(this$3);
  var b$1 = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(namespaces, bf);
  var iterTable$1 = namespaces.table$5;
  var idx$1 = $f_scm_HashTable__scala$collection$mutable$HashTable$$lastPopulatedIndex__I(namespaces);
  var es$1 = iterTable$1.get(idx$1);
  while ((es$1 !== null)) {
    var next$2 = $as_scm_HashEntry(es$1.next__O());
    var arg1$2 = es$1;
    var e$1 = $as_scm_DefaultEntry(arg1$2);
    var _1 = e$1.key$1;
    var _2 = e$1.value$1;
    var prefix$1 = $as_T(_1);
    var ns = $as_Lamf_core_vocabulary_Namespace(_2);
    b$1.$$plus$eq__O__scm_Builder(new $c_T2().init___O__O(prefix$1, ns.base$1));
    es$1 = next$2;
    while (((es$1 === null) && (idx$1 > 0))) {
      idx$1 = (((-1) + idx$1) | 0);
      es$1 = iterTable$1.get(idx$1)
    }
  };
  var this$5 = $as_scm_MapLike(b$1.result__O());
  var f$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x0$3$2) {
      var x0$3 = $as_T2(x0$3$2);
      if ((x0$3 !== null)) {
        var prefix$2 = $as_T(x0$3.$$und1__O());
        var ns$1 = $as_T(x0$3.$$und2__O());
        return new $c_T2().init___O__O(prefix$2, ns$1)
      } else {
        throw new $c_s_MatchError().init___O(x0$3)
      }
    })
  })(this));
  var this$4 = $m_sc_Map$();
  var bf$1 = new $c_scg_GenMapFactory$MapCanBuildFrom().init___scg_GenMapFactory(this$4);
  var xs = $as_sc_GenTraversableOnce($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(customNamespaces, f$1, bf$1));
  var this$6 = $as_scm_Map($as_scg_Growable(this$5.empty__sc_Map()).$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$5));
  var xs$1 = xs.seq__sc_TraversableOnce();
  var allNamespaces = $as_scm_Map($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$6, xs$1));
  var f$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
    return (function(x0$4$2) {
      var x0$4 = $as_T2(x0$4$2);
      if ((x0$4 !== null)) {
        var prefix$3 = $as_T(x0$4.$$und1__O());
        var ns$2 = $as_T(x0$4.$$und2__O());
        return (((("  \"" + prefix$3) + "\": \"") + ns$2) + "\"")
      } else {
        throw new $c_s_MatchError().init___O(x0$4)
      }
    })
  })(this));
  var this$7 = $m_scm_Iterable$();
  var bf$2 = this$7.ReusableCBFInstance$2;
  return (("{\n" + $as_sc_TraversableOnce($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(allNamespaces, f$2, bf$2)).mkString__T__T(",\n")) + "}")
});
$c_Lamf_plugins_features_validation_emitters_JSLibraryEmitter.prototype.emitJS__sc_Seq__s_Option = (function(validations) {
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(validation$2) {
      var validation = $as_Lamf_core_validation_core_ValidationSpecification(validation$2);
      var this$1 = validation.functionConstraint$1;
      if (this$1.isEmpty__Z()) {
        var xo = $m_s_None$()
      } else {
        var arg1 = this$1.get__O();
        var functionConstraint = $as_Lamf_core_validation_core_FunctionConstraint(arg1);
        var this$2 = functionConstraint.code$1;
        if (this$2.isEmpty__Z()) {
          var xo = $m_s_None$()
        } else {
          var arg1$1 = this$2.get__O();
          $as_T(arg1$1);
          var xo = new $c_s_Some().init___O(validation)
        }
      };
      return xo.toList__sci_List()
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  var constraints = $as_sc_Seq(validations.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2));
  return (constraints.isEmpty__Z() ? $m_s_None$() : new $c_s_Some().init___O(this.composeText__sc_Seq__T(constraints)))
});
var $d_Lamf_plugins_features_validation_emitters_JSLibraryEmitter = new $TypeData().initClass({
  Lamf_plugins_features_validation_emitters_JSLibraryEmitter: 0
}, false, "amf.plugins.features.validation.emitters.JSLibraryEmitter", {
  Lamf_plugins_features_validation_emitters_JSLibraryEmitter: 1,
  O: 1
});
$c_Lamf_plugins_features_validation_emitters_JSLibraryEmitter.prototype.$classData = $d_Lamf_plugins_features_validation_emitters_JSLibraryEmitter;
/** @constructor */
function $c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter() {
  $c_O.call(this);
  this.targetProfile$1 = null;
  this.jsValidatorEmitters$1 = null;
  this.jsConstraintEmitters$1 = null
}
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype = new $h_O();
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype.constructor = $c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter;
/** @constructor */
function $h_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype = $c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype;
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype.emitConstraint__p1__Lorg_yaml_model_YDocument$PartBuilder__T__Lamf_core_validation_core_PropertyConstraint__V = (function(b, constraintId, constraint) {
  if ($m_s_Option$().apply__O__s_Option(constraint.ramlPropertyId$1).isDefined__Z()) {
    var jsx$22 = b.builder$1;
    var sourceName = b.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@id");
    $m_Lorg_yaml_model_YNode$();
    var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(constraintId);
    b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value);
    if (constraint.path$1.isDefined__Z()) {
      this.assertPropertyPath__Lorg_yaml_model_YDocument$EntryBuilder__T__Lamf_core_validation_core_PropertyConstraint__V(b$1, constraintId, constraint)
    } else {
      $m_Lorg_yaml_model_YNode$();
      var this$4 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      var str = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "path").iri__T();
      var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
      var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
      $m_Lamf_core_emitter_BaseEmitters_package$().link__Lorg_yaml_model_YDocument$PartBuilder__T__V(v, this.expandRamlId__p1__T__T(constraint.ramlPropertyId$1));
      var this$9 = v.builder$1;
      var array = [key$1];
      if ((this$9.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len = $uI(array.length);
      var newSize = ((this$9.size0$6 + len) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$9, newSize);
      var len$1 = this$9.size0$6;
      var src = this$9.array$6;
      var dest = this$9.array$6;
      $systemArraycopy(src, 0, dest, len, len$1);
      var xs = this$9.array$6;
      var len$2 = xs.u.length;
      var i = 0;
      var j = 0;
      var x = $uI(array.length);
      var x$1 = ((x < len$2) ? x : len$2);
      var that = xs.u.length;
      var end = ((x$1 < that) ? x$1 : that);
      while ((i < end)) {
        var jsx$1 = j;
        var index = i;
        xs.set(jsx$1, array[index]);
        i = ((1 + i) | 0);
        j = ((1 + j) | 0)
      };
      this$9.size0$6 = newSize;
      b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
    };
    var this$20 = constraint.maxCount$1;
    if ((!this$20.isEmpty__Z())) {
      var arg1 = this$20.get__O();
      var x$28 = $as_T(arg1);
      this.genPropertyConstraintValue__p1__Lorg_yaml_model_YDocument$EntryBuilder__T__T__s_Option__V(b$1, "maxCount", x$28, new $c_s_Some().init___O(constraint))
    };
    var this$21 = constraint.minCount$1;
    if ((!this$21.isEmpty__Z())) {
      var arg1$1 = this$21.get__O();
      var x$29 = $as_T(arg1$1);
      this.genPropertyConstraintValue__p1__Lorg_yaml_model_YDocument$EntryBuilder__T__T__s_Option__V(b$1, "minCount", x$29, new $c_s_Some().init___O(constraint))
    };
    var this$22 = constraint.maxLength$1;
    if ((!this$22.isEmpty__Z())) {
      var arg1$2 = this$22.get__O();
      var x$30 = $as_T(arg1$2);
      this.genPropertyConstraintValue__p1__Lorg_yaml_model_YDocument$EntryBuilder__T__T__s_Option__V(b$1, "maxLength", x$30, new $c_s_Some().init___O(constraint))
    };
    var this$23 = constraint.minLength$1;
    if ((!this$23.isEmpty__Z())) {
      var arg1$3 = this$23.get__O();
      var x$31 = $as_T(arg1$3);
      this.genPropertyConstraintValue__p1__Lorg_yaml_model_YDocument$EntryBuilder__T__T__s_Option__V(b$1, "minLength", x$31, new $c_s_Some().init___O(constraint))
    };
    var this$24 = constraint.maxExclusive$1;
    if ((!this$24.isEmpty__Z())) {
      var arg1$4 = this$24.get__O();
      var x$32 = $as_T(arg1$4);
      this.genNumericPropertyConstraintValue__p1__Lorg_yaml_model_YDocument$EntryBuilder__T__T__s_Option__V(b$1, "maxExclusive", x$32, new $c_s_Some().init___O(constraint))
    };
    var this$25 = constraint.minExclusive$1;
    if ((!this$25.isEmpty__Z())) {
      var arg1$5 = this$25.get__O();
      var x$33 = $as_T(arg1$5);
      this.genNumericPropertyConstraintValue__p1__Lorg_yaml_model_YDocument$EntryBuilder__T__T__s_Option__V(b$1, "minExclusive", x$33, new $c_s_Some().init___O(constraint))
    };
    var this$26 = constraint.maxInclusive$1;
    if ((!this$26.isEmpty__Z())) {
      var arg1$6 = this$26.get__O();
      var x$34 = $as_T(arg1$6);
      this.genNumericPropertyConstraintValue__p1__Lorg_yaml_model_YDocument$EntryBuilder__T__T__s_Option__V(b$1, "maxInclusive", x$34, new $c_s_Some().init___O(constraint))
    };
    var this$27 = constraint.minInclusive$1;
    if ((!this$27.isEmpty__Z())) {
      var arg1$7 = this$27.get__O();
      var x$35 = $as_T(arg1$7);
      this.genNumericPropertyConstraintValue__p1__Lorg_yaml_model_YDocument$EntryBuilder__T__T__s_Option__V(b$1, "minInclusive", x$35, new $c_s_Some().init___O(constraint))
    };
    if (constraint.atLeast$1.isDefined__Z()) {
      var this$28 = $as_T2(constraint.atLeast$1.get__O()).$$und1$mcI$sp__I();
      this.genNumericPropertyConstraintValue__p1__Lorg_yaml_model_YDocument$EntryBuilder__T__T__s_Option__V(b$1, "qualifiedMinCount", ("" + this$28), new $c_s_Some().init___O(constraint));
      $m_Lorg_yaml_model_YNode$();
      var this$30 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      var str$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$30, "qualifiedValueShape").iri__T();
      var key$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
      var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
      $m_Lamf_core_emitter_BaseEmitters_package$().link__Lorg_yaml_model_YDocument$PartBuilder__T__V(v$1, $as_T($as_T2(constraint.atLeast$1.get__O()).$$und2__O()));
      var this$35 = v$1.builder$1;
      var array$1 = [key$2];
      if ((this$35.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$3 = $uI(array$1.length);
      var newSize$1 = ((this$35.size0$6 + len$3) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$35, newSize$1);
      var len$4 = this$35.size0$6;
      var src$1 = this$35.array$6;
      var dest$1 = this$35.array$6;
      $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
      var xs$1 = this$35.array$6;
      var len$5 = xs$1.u.length;
      var i$1 = 0;
      var j$1 = 0;
      var x$2 = $uI(array$1.length);
      var x$3 = ((x$2 < len$5) ? x$2 : len$5);
      var that$1 = xs$1.u.length;
      var end$1 = ((x$3 < that$1) ? x$3 : that$1);
      while ((i$1 < end$1)) {
        var jsx$2 = j$1;
        var index$1 = i$1;
        xs$1.set(jsx$2, array$1[index$1]);
        i$1 = ((1 + i$1) | 0);
        j$1 = ((1 + j$1) | 0)
      };
      this$35.size0$6 = newSize$1;
      b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1))
    };
    if (constraint.atMost$1.isDefined__Z()) {
      var this$46 = $as_T2(constraint.atLeast$1.get__O()).$$und1$mcI$sp__I();
      this.genNumericPropertyConstraintValue__p1__Lorg_yaml_model_YDocument$EntryBuilder__T__T__s_Option__V(b$1, "qualifiedMaxCount", ("" + this$46), new $c_s_Some().init___O(constraint));
      $m_Lorg_yaml_model_YNode$();
      var this$48 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      var str$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$48, "qualifiedValueShape").iri__T();
      var key$3 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$2);
      var v$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
      $m_Lamf_core_emitter_BaseEmitters_package$().link__Lorg_yaml_model_YDocument$PartBuilder__T__V(v$2, $as_T($as_T2(constraint.atLeast$1.get__O()).$$und2__O()));
      var this$53 = v$2.builder$1;
      var array$2 = [key$3];
      if ((this$53.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$6 = $uI(array$2.length);
      var newSize$2 = ((this$53.size0$6 + len$6) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$53, newSize$2);
      var len$7 = this$53.size0$6;
      var src$2 = this$53.array$6;
      var dest$2 = this$53.array$6;
      $systemArraycopy(src$2, 0, dest$2, len$6, len$7);
      var xs$2 = this$53.array$6;
      var len$8 = xs$2.u.length;
      var i$2 = 0;
      var j$2 = 0;
      var x$4 = $uI(array$2.length);
      var x$5 = ((x$4 < len$8) ? x$4 : len$8);
      var that$2 = xs$2.u.length;
      var end$2 = ((x$5 < that$2) ? x$5 : that$2);
      while ((i$2 < end$2)) {
        var jsx$3 = j$2;
        var index$2 = i$2;
        xs$2.set(jsx$3, array$2[index$2]);
        i$2 = ((1 + i$2) | 0);
        j$2 = ((1 + j$2) | 0)
      };
      this$53.size0$6 = newSize$2;
      b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$2.builder$1))
    };
    if (constraint.equalToProperty$1.isDefined__Z()) {
      $m_Lorg_yaml_model_YNode$();
      var this$64 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      var str$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$64, "equals").iri__T();
      var key$4 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$3);
      var v$3 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
      $m_Lamf_core_emitter_BaseEmitters_package$().link__Lorg_yaml_model_YDocument$PartBuilder__T__V(v$3, $as_T(constraint.equalToProperty$1.get__O()));
      var this$69 = v$3.builder$1;
      var array$3 = [key$4];
      if ((this$69.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$9 = $uI(array$3.length);
      var newSize$3 = ((this$69.size0$6 + len$9) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$69, newSize$3);
      var len$10 = this$69.size0$6;
      var src$3 = this$69.array$6;
      var dest$3 = this$69.array$6;
      $systemArraycopy(src$3, 0, dest$3, len$9, len$10);
      var xs$3 = this$69.array$6;
      var len$11 = xs$3.u.length;
      var i$3 = 0;
      var j$3 = 0;
      var x$6 = $uI(array$3.length);
      var x$7 = ((x$6 < len$11) ? x$6 : len$11);
      var that$3 = xs$3.u.length;
      var end$3 = ((x$7 < that$3) ? x$7 : that$3);
      while ((i$3 < end$3)) {
        var jsx$4 = j$3;
        var index$3 = i$3;
        xs$3.set(jsx$4, array$3[index$3]);
        i$3 = ((1 + i$3) | 0);
        j$3 = ((1 + j$3) | 0)
      };
      this$69.size0$6 = newSize$3;
      b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$3.builder$1))
    };
    if (constraint.disjointWithProperty$1.isDefined__Z()) {
      $m_Lorg_yaml_model_YNode$();
      var this$80 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      var str$4 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$80, "disjoint").iri__T();
      var key$5 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$4);
      var v$4 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
      $m_Lamf_core_emitter_BaseEmitters_package$().link__Lorg_yaml_model_YDocument$PartBuilder__T__V(v$4, $as_T(constraint.disjointWithProperty$1.get__O()));
      var this$85 = v$4.builder$1;
      var array$4 = [key$5];
      if ((this$85.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$12 = $uI(array$4.length);
      var newSize$4 = ((this$85.size0$6 + len$12) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$85, newSize$4);
      var len$13 = this$85.size0$6;
      var src$4 = this$85.array$6;
      var dest$4 = this$85.array$6;
      $systemArraycopy(src$4, 0, dest$4, len$12, len$13);
      var xs$4 = this$85.array$6;
      var len$14 = xs$4.u.length;
      var i$4 = 0;
      var j$4 = 0;
      var x$8 = $uI(array$4.length);
      var x$9 = ((x$8 < len$14) ? x$8 : len$14);
      var that$4 = xs$4.u.length;
      var end$4 = ((x$9 < that$4) ? x$9 : that$4);
      while ((i$4 < end$4)) {
        var jsx$5 = j$4;
        var index$4 = i$4;
        xs$4.set(jsx$5, array$4[index$4]);
        i$4 = ((1 + i$4) | 0);
        j$4 = ((1 + j$4) | 0)
      };
      this$85.size0$6 = newSize$4;
      b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$4.builder$1))
    };
    if (constraint.lessThanProperty$1.isDefined__Z()) {
      $m_Lorg_yaml_model_YNode$();
      var this$96 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      var str$5 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$96, "lessThan").iri__T();
      var key$6 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$5);
      var v$5 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
      $m_Lamf_core_emitter_BaseEmitters_package$().link__Lorg_yaml_model_YDocument$PartBuilder__T__V(v$5, $as_T(constraint.lessThanProperty$1.get__O()));
      var this$101 = v$5.builder$1;
      var array$5 = [key$6];
      if ((this$101.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$15 = $uI(array$5.length);
      var newSize$5 = ((this$101.size0$6 + len$15) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$101, newSize$5);
      var len$16 = this$101.size0$6;
      var src$5 = this$101.array$6;
      var dest$5 = this$101.array$6;
      $systemArraycopy(src$5, 0, dest$5, len$15, len$16);
      var xs$5 = this$101.array$6;
      var len$17 = xs$5.u.length;
      var i$5 = 0;
      var j$5 = 0;
      var x$10 = $uI(array$5.length);
      var x$11 = ((x$10 < len$17) ? x$10 : len$17);
      var that$5 = xs$5.u.length;
      var end$5 = ((x$11 < that$5) ? x$11 : that$5);
      while ((i$5 < end$5)) {
        var jsx$6 = j$5;
        var index$5 = i$5;
        xs$5.set(jsx$6, array$5[index$5]);
        i$5 = ((1 + i$5) | 0);
        j$5 = ((1 + j$5) | 0)
      };
      this$101.size0$6 = newSize$5;
      b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$5.builder$1))
    };
    if (constraint.lessThanOrEqualsToProperty$1.isDefined__Z()) {
      $m_Lorg_yaml_model_YNode$();
      var this$112 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      var str$6 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$112, "lessThanOrEquals").iri__T();
      var key$7 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$6);
      var v$6 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
      $m_Lamf_core_emitter_BaseEmitters_package$().link__Lorg_yaml_model_YDocument$PartBuilder__T__V(v$6, $as_T(constraint.lessThanOrEqualsToProperty$1.get__O()));
      var this$117 = v$6.builder$1;
      var array$6 = [key$7];
      if ((this$117.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$18 = $uI(array$6.length);
      var newSize$6 = ((this$117.size0$6 + len$18) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$117, newSize$6);
      var len$19 = this$117.size0$6;
      var src$6 = this$117.array$6;
      var dest$6 = this$117.array$6;
      $systemArraycopy(src$6, 0, dest$6, len$18, len$19);
      var xs$6 = this$117.array$6;
      var len$20 = xs$6.u.length;
      var i$6 = 0;
      var j$6 = 0;
      var x$12 = $uI(array$6.length);
      var x$13 = ((x$12 < len$20) ? x$12 : len$20);
      var that$6 = xs$6.u.length;
      var end$6 = ((x$13 < that$6) ? x$13 : that$6);
      while ((i$6 < end$6)) {
        var jsx$7 = j$6;
        var index$6 = i$6;
        xs$6.set(jsx$7, array$6[index$6]);
        i$6 = ((1 + i$6) | 0);
        j$6 = ((1 + j$6) | 0)
      };
      this$117.size0$6 = newSize$6;
      b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$6.builder$1))
    };
    var this$128 = constraint.multipleOf$1;
    if ((!this$128.isEmpty__Z())) {
      var arg1$8 = this$128.get__O();
      var x$42 = $as_T(arg1$8);
      var this$129 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
      this.genCustomPropertyConstraintValue__p1__Lorg_yaml_model_YDocument$EntryBuilder__T__T__V(b$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$129, "multipleOfValidationParam").iri__T(), x$42)
    };
    var this$131 = constraint.pattern$1;
    if ((!this$131.isEmpty__Z())) {
      var arg1$9 = this$131.get__O();
      var v$7 = $as_T(arg1$9);
      this.genPropertyConstraintValue__p1__Lorg_yaml_model_YDocument$EntryBuilder__T__T__s_Option__V(b$1, "pattern", v$7, $m_s_None$())
    };
    var this$132 = constraint.node$1;
    if ((!this$132.isEmpty__Z())) {
      var arg1$10 = this$132.get__O();
      var x$43 = $as_T(arg1$10);
      this.genPropertyConstraintValue__p1__Lorg_yaml_model_YDocument$EntryBuilder__T__T__s_Option__V(b$1, "node", x$43, $m_s_None$())
    };
    var this$133 = constraint.value$1;
    if ((!this$133.isEmpty__Z())) {
      var arg1$11 = this$133.get__O();
      var x$44 = $as_T(arg1$11);
      this.genPropertyConstraintValue__p1__Lorg_yaml_model_YDocument$EntryBuilder__T__T__s_Option__V(b$1, "hasValue", x$44, new $c_s_Some().init___O(constraint))
    };
    var this$134 = constraint.datatype$1;
    if ((!this$134.isEmpty__Z())) {
      var arg1$12 = this$134.get__O();
      var v$3$1 = $as_T(arg1$12);
      if (((!$m_sjsr_RuntimeString$().endsWith__T__T__Z(v$3$1, "#float")) && (!$m_sjsr_RuntimeString$().endsWith__T__T__Z(v$3$1, "#number")))) {
        $m_Lorg_yaml_model_YNode$();
        var this$135 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        var str$7 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$135, "datatype").iri__T();
        var key$8 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$7);
        var v$8 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
        $m_Lamf_core_emitter_BaseEmitters_package$().link__Lorg_yaml_model_YDocument$PartBuilder__T__V(v$8, v$3$1);
        var this$140 = v$8.builder$1;
        var array$7 = [key$8];
        if ((this$140.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len$21 = $uI(array$7.length);
        var newSize$7 = ((this$140.size0$6 + len$21) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$140, newSize$7);
        var len$22 = this$140.size0$6;
        var src$7 = this$140.array$6;
        var dest$7 = this$140.array$6;
        $systemArraycopy(src$7, 0, dest$7, len$21, len$22);
        var xs$7 = this$140.array$6;
        var len$23 = xs$7.u.length;
        var i$7 = 0;
        var j$7 = 0;
        var x$14 = $uI(array$7.length);
        var x$15 = ((x$14 < len$23) ? x$14 : len$23);
        var that$7 = xs$7.u.length;
        var end$7 = ((x$15 < that$7) ? x$15 : that$7);
        while ((i$7 < end$7)) {
          var jsx$8 = j$7;
          var index$7 = i$7;
          xs$7.set(jsx$8, array$7[index$7]);
          i$7 = ((1 + i$7) | 0);
          j$7 = ((1 + j$7) | 0)
        };
        this$140.size0$6 = newSize$7;
        b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$8.builder$1))
      }
    };
    if (constraint.class$1.nonEmpty__Z()) {
      if ((constraint.class$1.length__I() === 1)) {
        $m_Lorg_yaml_model_YNode$();
        var this$151 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        var str$8 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$151, "class").iri__T();
        var key$9 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$8);
        var v$9 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
        $m_Lamf_core_emitter_BaseEmitters_package$().link__Lorg_yaml_model_YDocument$PartBuilder__T__V(v$9, $as_T(constraint.class$1.head__O()));
        var this$156 = v$9.builder$1;
        var array$8 = [key$9];
        if ((this$156.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len$24 = $uI(array$8.length);
        var newSize$8 = ((this$156.size0$6 + len$24) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$156, newSize$8);
        var len$25 = this$156.size0$6;
        var src$8 = this$156.array$6;
        var dest$8 = this$156.array$6;
        $systemArraycopy(src$8, 0, dest$8, len$24, len$25);
        var xs$8 = this$156.array$6;
        var len$26 = xs$8.u.length;
        var i$8 = 0;
        var j$8 = 0;
        var x$16 = $uI(array$8.length);
        var x$17 = ((x$16 < len$26) ? x$16 : len$26);
        var that$8 = xs$8.u.length;
        var end$8 = ((x$17 < that$8) ? x$17 : that$8);
        while ((i$8 < end$8)) {
          var jsx$9 = j$8;
          var index$8 = i$8;
          xs$8.set(jsx$9, array$8[index$8]);
          i$8 = ((1 + i$8) | 0);
          j$8 = ((1 + j$8) | 0)
        };
        this$156.size0$6 = newSize$8;
        b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$9.builder$1))
      } else {
        $m_Lorg_yaml_model_YNode$();
        var this$167 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        var str$9 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$167, "or").iri__T();
        var key$10 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$9);
        var v$10 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
        var jsx$15 = v$10.builder$1;
        var sourceName$1 = v$10.sourceName$2;
        var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
        $m_Lorg_yaml_model_YNode$();
        var key$11 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@list");
        var v$11 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$2.sourceName$2);
        var jsx$13 = v$11.builder$1;
        var sourceName$2 = v$11.sourceName$2;
        var b$3 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$2);
        constraint.class$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, l) {
          return (function(v$2$1) {
            var v$12 = $as_T(v$2$1);
            var jsx$11 = l.builder$1;
            var sourceName$3 = l.sourceName$2;
            var b$4 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$3);
            $m_Lorg_yaml_model_YNode$();
            var this$174 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
            var str$10 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$174, "class").iri__T();
            var key$12 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$10);
            var v$13 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$4.sourceName$2);
            $m_Lamf_core_emitter_BaseEmitters_package$().link__Lorg_yaml_model_YDocument$PartBuilder__T__V(v$13, v$12);
            var this$179 = v$13.builder$1;
            var array$9 = [key$12];
            if ((this$179.size0$6 < 0)) {
              throw new $c_jl_IndexOutOfBoundsException().init___T("0")
            };
            var len$27 = $uI(array$9.length);
            var newSize$9 = ((this$179.size0$6 + len$27) | 0);
            $f_scm_ResizableArray__ensureSize__I__V(this$179, newSize$9);
            var len$28 = this$179.size0$6;
            var src$9 = this$179.array$6;
            var dest$9 = this$179.array$6;
            $systemArraycopy(src$9, 0, dest$9, len$27, len$28);
            var xs$9 = this$179.array$6;
            var len$29 = xs$9.u.length;
            var i$9 = 0;
            var j$9 = 0;
            var x$18 = $uI(array$9.length);
            var x$19 = ((x$18 < len$29) ? x$18 : len$29);
            var that$9 = xs$9.u.length;
            var end$9 = ((x$19 < that$9) ? x$19 : that$9);
            while ((i$9 < end$9)) {
              var jsx$10 = j$9;
              var index$9 = i$9;
              xs$9.set(jsx$10, array$9[index$9]);
              i$9 = ((1 + i$9) | 0);
              j$9 = ((1 + j$9) | 0)
            };
            this$179.size0$6 = newSize$9;
            b$4.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$13.builder$1));
            jsx$11.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$4.builder$1, sourceName$3), $m_Lorg_yaml_model_YType$().Map$1))
          })
        })(this, b$3)));
        var jsx$12 = $m_Lorg_yaml_model_YNode$();
        $m_Lorg_yaml_model_YSequence$();
        var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$2);
        var parts = b$3.builder$1;
        var node = jsx$12.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
        jsx$13.$$plus$eq__O__scm_ArrayBuffer(node);
        var this$193 = v$11.builder$1;
        var array$10 = [key$11];
        if ((this$193.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len$30 = $uI(array$10.length);
        var newSize$10 = ((this$193.size0$6 + len$30) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$193, newSize$10);
        var len$31 = this$193.size0$6;
        var src$10 = this$193.array$6;
        var dest$10 = this$193.array$6;
        $systemArraycopy(src$10, 0, dest$10, len$30, len$31);
        var xs$10 = this$193.array$6;
        var len$32 = xs$10.u.length;
        var i$10 = 0;
        var j$10 = 0;
        var x$20 = $uI(array$10.length);
        var x$21 = ((x$20 < len$32) ? x$20 : len$32);
        var that$10 = xs$10.u.length;
        var end$10 = ((x$21 < that$10) ? x$21 : that$10);
        while ((i$10 < end$10)) {
          var jsx$14 = j$10;
          var index$10 = i$10;
          xs$10.set(jsx$14, array$10[index$10]);
          i$10 = ((1 + i$10) | 0);
          j$10 = ((1 + j$10) | 0)
        };
        this$193.size0$6 = newSize$10;
        b$2.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$11.builder$1));
        jsx$15.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1));
        var this$206 = v$10.builder$1;
        var array$11 = [key$10];
        if ((this$206.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len$33 = $uI(array$11.length);
        var newSize$11 = ((this$206.size0$6 + len$33) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$206, newSize$11);
        var len$34 = this$206.size0$6;
        var src$11 = this$206.array$6;
        var dest$11 = this$206.array$6;
        $systemArraycopy(src$11, 0, dest$11, len$33, len$34);
        var xs$11 = this$206.array$6;
        var len$35 = xs$11.u.length;
        var i$11 = 0;
        var j$11 = 0;
        var x$22 = $uI(array$11.length);
        var x$23 = ((x$22 < len$35) ? x$22 : len$35);
        var that$11 = xs$11.u.length;
        var end$11 = ((x$23 < that$11) ? x$23 : that$11);
        while ((i$11 < end$11)) {
          var jsx$16 = j$11;
          var index$11 = i$11;
          xs$11.set(jsx$16, array$11[index$11]);
          i$11 = ((1 + i$11) | 0);
          j$11 = ((1 + j$11) | 0)
        };
        this$206.size0$6 = newSize$11;
        b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$10.builder$1))
      }
    };
    var this$217 = constraint.custom$1;
    if ((!this$217.isEmpty__Z())) {
      var arg1$13 = this$217.get__O();
      var builder = $as_F2(arg1$13);
      builder.apply__O__O__O(b$1, constraintId)
    };
    if (constraint.in$1.nonEmpty__Z()) {
      $m_Lorg_yaml_model_YNode$();
      var this$218 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      var str$11 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$218, "in").iri__T();
      var key$13 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$11);
      var v$14 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
      var jsx$20 = v$14.builder$1;
      var sourceName$4 = v$14.sourceName$2;
      var b$5 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$4);
      $m_Lorg_yaml_model_YNode$();
      var key$14 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@list");
      var v$15 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$5.sourceName$2);
      var jsx$18 = v$15.builder$1;
      var sourceName$5 = v$15.sourceName$2;
      var b$6 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$5);
      constraint.in$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, b$7) {
        return (function(x$55$2) {
          var x$55 = $as_T(x$55$2);
          $this$1.amf$plugins$features$validation$emitters$ValidationJSONLDEmitter$$genValue__Lorg_yaml_model_YDocument$PartBuilder__T__s_Option__V(b$7, x$55, $m_s_None$())
        })
      })(this, b$6)));
      var jsx$17 = $m_Lorg_yaml_model_YNode$();
      $m_Lorg_yaml_model_YSequence$();
      var loc$1 = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$5);
      var parts$1 = b$6.builder$1;
      var node$1 = jsx$17.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc$1, parts$1), $m_Lorg_yaml_model_YType$().Seq$1);
      jsx$18.$$plus$eq__O__scm_ArrayBuffer(node$1);
      var this$227 = v$15.builder$1;
      var array$12 = [key$14];
      if ((this$227.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$36 = $uI(array$12.length);
      var newSize$12 = ((this$227.size0$6 + len$36) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$227, newSize$12);
      var len$37 = this$227.size0$6;
      var src$12 = this$227.array$6;
      var dest$12 = this$227.array$6;
      $systemArraycopy(src$12, 0, dest$12, len$36, len$37);
      var xs$12 = this$227.array$6;
      var len$38 = xs$12.u.length;
      var i$12 = 0;
      var j$12 = 0;
      var x$24 = $uI(array$12.length);
      var x$25 = ((x$24 < len$38) ? x$24 : len$38);
      var that$12 = xs$12.u.length;
      var end$12 = ((x$25 < that$12) ? x$25 : that$12);
      while ((i$12 < end$12)) {
        var jsx$19 = j$12;
        var index$12 = i$12;
        xs$12.set(jsx$19, array$12[index$12]);
        i$12 = ((1 + i$12) | 0);
        j$12 = ((1 + j$12) | 0)
      };
      this$227.size0$6 = newSize$12;
      b$5.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$15.builder$1));
      jsx$20.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$5.builder$1, sourceName$4), $m_Lorg_yaml_model_YType$().Map$1));
      var this$240 = v$14.builder$1;
      var array$13 = [key$13];
      if ((this$240.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$39 = $uI(array$13.length);
      var newSize$13 = ((this$240.size0$6 + len$39) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$240, newSize$13);
      var len$40 = this$240.size0$6;
      var src$13 = this$240.array$6;
      var dest$13 = this$240.array$6;
      $systemArraycopy(src$13, 0, dest$13, len$39, len$40);
      var xs$13 = this$240.array$6;
      var len$41 = xs$13.u.length;
      var i$13 = 0;
      var j$13 = 0;
      var x$26 = $uI(array$13.length);
      var x$27 = ((x$26 < len$41) ? x$26 : len$41);
      var that$13 = xs$13.u.length;
      var end$13 = ((x$27 < that$13) ? x$27 : that$13);
      while ((i$13 < end$13)) {
        var jsx$21 = j$13;
        var index$13 = i$13;
        xs$13.set(jsx$21, array$13[index$13]);
        i$13 = ((1 + i$13) | 0);
        j$13 = ((1 + j$13) | 0)
      };
      this$240.size0$6 = newSize$13;
      b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$14.builder$1))
    };
    jsx$22.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  }
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype.isPropertyConstraintUri__p1__T__Z = (function(name) {
  return ((((($uI(name.length) >= 0) && ($as_T(name.substring(0, $uI("http://".length))) === "http://")) || (($uI(name.length) >= 0) && ($as_T(name.substring(0, $uI("https://".length))) === "https://"))) || (($uI(name.length) >= 0) && ($as_T(name.substring(0, $uI("file:".length))) === "file:"))) && ($uI(name.indexOf("/prop")) > (-1)))
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype.genJSValidator__p1__T__Lamf_core_validation_core_FunctionConstraint__scm_ListBuffer = (function(validationId, f) {
  var validatorId = f.validatorId__T__T(validationId);
  return this.jsValidatorEmitters$1.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$2().init___Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter__Lamf_core_validation_core_FunctionConstraint__T__T(this, f, validatorId, validationId))
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype.emitValidation__p1__Lorg_yaml_model_YDocument$PartBuilder__Lamf_core_validation_core_ValidationSpecification__V = (function(b, validation) {
  var validationId = validation.id$1;
  var jsx$41 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@id");
  $m_Lorg_yaml_model_YNode$();
  var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(validationId);
  b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value);
  $m_Lorg_yaml_model_YNode$();
  var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@type");
  $m_Lorg_yaml_model_YNode$();
  var this$5 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var str = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$5, "NodeShape").iri__T();
  var value$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$1, value$1);
  var x1 = this.targetProfile$1;
  var x = $m_Lamf_RamlProfile$();
  if (x.equals__O__Z(x1)) {
    var jsx$1 = true
  } else {
    var x$3 = $m_Lamf_Raml08Profile$();
    var jsx$1 = x$3.equals__O__Z(x1)
  };
  if (jsx$1) {
    var this$8 = validation.ramlMessage$1;
    var message = $as_T((this$8.isEmpty__Z() ? validation.message$1 : this$8.get__O()))
  } else {
    var x$5 = $m_Lamf_OasProfile$();
    if (x$5.equals__O__Z(x1)) {
      var this$9 = validation.oasMessage$1;
      var message = $as_T((this$9.isEmpty__Z() ? validation.message$1 : this$9.get__O()))
    } else {
      var message = validation.message$1
    }
  };
  if ((message !== "")) {
    $m_Lorg_yaml_model_YNode$();
    var this$10 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var str$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "message").iri__T();
    var key$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
    this.amf$plugins$features$validation$emitters$ValidationJSONLDEmitter$$genValue__Lorg_yaml_model_YDocument$PartBuilder__T__s_Option__V(v, message, $m_s_None$());
    var this$15 = v.builder$1;
    var array = [key$2];
    if ((this$15.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$15.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$15, newSize);
    var len$1 = this$15.size0$6;
    var src = this$15.array$6;
    var dest = this$15.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$15.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x$1 = $uI(array.length);
    var x$2 = ((x$1 < len$2) ? x$1 : len$2);
    var that = xs.u.length;
    var end = ((x$2 < that) ? x$2 : that);
    while ((i < end)) {
      var jsx$2 = j;
      var index = i;
      xs.set(jsx$2, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$15.size0$6 = newSize;
    b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  };
  if (validation.targetInstance$1.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var this$26 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var str$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$26, "targetNode").iri__T();
    var key$3 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$2);
    var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
    var jsx$4 = v$1.builder$1;
    var sourceName$1 = v$1.sourceName$2;
    var b$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$1);
    $as_sc_IterableLike(validation.targetInstance$1.distinct__O()).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, p) {
      return (function(ti$2) {
        var ti = $as_T(ti$2);
        $m_Lamf_core_emitter_BaseEmitters_package$().link__Lorg_yaml_model_YDocument$PartBuilder__T__V(p, $this.expandRamlId__p1__T__T(ti))
      })
    })(this, b$2)));
    var jsx$3 = $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YSequence$();
    var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$1);
    var parts = b$2.builder$1;
    var node = jsx$3.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
    jsx$4.$$plus$eq__O__scm_ArrayBuffer(node);
    var this$33 = v$1.builder$1;
    var array$1 = [key$3];
    if ((this$33.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$3 = $uI(array$1.length);
    var newSize$1 = ((this$33.size0$6 + len$3) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$33, newSize$1);
    var len$4 = this$33.size0$6;
    var src$1 = this$33.array$6;
    var dest$1 = this$33.array$6;
    $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
    var xs$1 = this$33.array$6;
    var len$5 = xs$1.u.length;
    var i$1 = 0;
    var j$1 = 0;
    var x$4 = $uI(array$1.length);
    var x$6 = ((x$4 < len$5) ? x$4 : len$5);
    var that$1 = xs$1.u.length;
    var end$1 = ((x$6 < that$1) ? x$6 : that$1);
    while ((i$1 < end$1)) {
      var jsx$5 = j$1;
      var index$1 = i$1;
      xs$1.set(jsx$5, array$1[index$1]);
      i$1 = ((1 + i$1) | 0);
      j$1 = ((1 + j$1) | 0)
    };
    this$33.size0$6 = newSize$1;
    b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1))
  };
  if (validation.targetClass$1.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var this$44 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var str$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$44, "targetClass").iri__T();
    var key$4 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$3);
    var v$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
    var jsx$7 = v$2.builder$1;
    var sourceName$2 = v$2.sourceName$2;
    var b$3 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$2);
    validation.targetClass$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, p$1) {
      return (function(tc$2) {
        var tc = $as_T(tc$2);
        $m_Lamf_core_emitter_BaseEmitters_package$().link__Lorg_yaml_model_YDocument$PartBuilder__T__V(p$1, $this$1.expandRamlId__p1__T__T(tc))
      })
    })(this, b$3)));
    var jsx$6 = $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YSequence$();
    var loc$1 = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$2);
    var parts$1 = b$3.builder$1;
    var node$1 = jsx$6.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc$1, parts$1), $m_Lorg_yaml_model_YType$().Seq$1);
    jsx$7.$$plus$eq__O__scm_ArrayBuffer(node$1);
    var this$51 = v$2.builder$1;
    var array$2 = [key$4];
    if ((this$51.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$6 = $uI(array$2.length);
    var newSize$2 = ((this$51.size0$6 + len$6) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$51, newSize$2);
    var len$7 = this$51.size0$6;
    var src$2 = this$51.array$6;
    var dest$2 = this$51.array$6;
    $systemArraycopy(src$2, 0, dest$2, len$6, len$7);
    var xs$2 = this$51.array$6;
    var len$8 = xs$2.u.length;
    var i$2 = 0;
    var j$2 = 0;
    var x$7 = $uI(array$2.length);
    var x$8 = ((x$7 < len$8) ? x$7 : len$8);
    var that$2 = xs$2.u.length;
    var end$2 = ((x$8 < that$2) ? x$8 : that$2);
    while ((i$2 < end$2)) {
      var jsx$8 = j$2;
      var index$2 = i$2;
      xs$2.set(jsx$8, array$2[index$2]);
      i$2 = ((1 + i$2) | 0);
      j$2 = ((1 + j$2) | 0)
    };
    this$51.size0$6 = newSize$2;
    b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$2.builder$1))
  };
  var this$62 = validation.closed$1;
  if ((!this$62.isEmpty__Z())) {
    var arg1 = this$62.get__O();
    var closedShape = $uZ(arg1);
    if (closedShape) {
      $m_Lorg_yaml_model_YNode$();
      var this$63 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      var str$4 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$63, "closed").iri__T();
      var key$5 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$4);
      var v$3 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
      this.amf$plugins$features$validation$emitters$ValidationJSONLDEmitter$$genValue__Lorg_yaml_model_YDocument$PartBuilder__T__s_Option__V(v$3, ("" + closedShape), $m_s_None$());
      var this$69 = v$3.builder$1;
      var array$3 = [key$5];
      if ((this$69.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$9 = $uI(array$3.length);
      var newSize$3 = ((this$69.size0$6 + len$9) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$69, newSize$3);
      var len$10 = this$69.size0$6;
      var src$3 = this$69.array$6;
      var dest$3 = this$69.array$6;
      $systemArraycopy(src$3, 0, dest$3, len$9, len$10);
      var xs$3 = this$69.array$6;
      var len$11 = xs$3.u.length;
      var i$3 = 0;
      var j$3 = 0;
      var x$9 = $uI(array$3.length);
      var x$10 = ((x$9 < len$11) ? x$9 : len$11);
      var that$3 = xs$3.u.length;
      var end$3 = ((x$10 < that$3) ? x$10 : that$3);
      while ((i$3 < end$3)) {
        var jsx$9 = j$3;
        var index$3 = i$3;
        xs$3.set(jsx$9, array$3[index$3]);
        i$3 = ((1 + i$3) | 0);
        j$3 = ((1 + j$3) | 0)
      };
      this$69.size0$6 = newSize$3;
      b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$3.builder$1))
    };
    new $c_s_Some().init___O((void 0))
  };
  if (validation.targetObject$1.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var this$80 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var str$5 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$80, "targetObjectsOf").iri__T();
    var key$6 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$5);
    var v$4 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
    var jsx$11 = v$4.builder$1;
    var sourceName$3 = v$4.sourceName$2;
    var b$4 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$3);
    validation.targetObject$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, p$2) {
      return (function(to$2) {
        var to = $as_T(to$2);
        $m_Lamf_core_emitter_BaseEmitters_package$().link__Lorg_yaml_model_YDocument$PartBuilder__T__V(p$2, $this$2.expandRamlId__p1__T__T(to))
      })
    })(this, b$4)));
    var jsx$10 = $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YSequence$();
    var loc$2 = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$3);
    var parts$2 = b$4.builder$1;
    var node$2 = jsx$10.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc$2, parts$2), $m_Lorg_yaml_model_YType$().Seq$1);
    jsx$11.$$plus$eq__O__scm_ArrayBuffer(node$2);
    var this$87 = v$4.builder$1;
    var array$4 = [key$6];
    if ((this$87.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$12 = $uI(array$4.length);
    var newSize$4 = ((this$87.size0$6 + len$12) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$87, newSize$4);
    var len$13 = this$87.size0$6;
    var src$4 = this$87.array$6;
    var dest$4 = this$87.array$6;
    $systemArraycopy(src$4, 0, dest$4, len$12, len$13);
    var xs$4 = this$87.array$6;
    var len$14 = xs$4.u.length;
    var i$4 = 0;
    var j$4 = 0;
    var x$11 = $uI(array$4.length);
    var x$12 = ((x$11 < len$14) ? x$11 : len$14);
    var that$4 = xs$4.u.length;
    var end$4 = ((x$12 < that$4) ? x$12 : that$4);
    while ((i$4 < end$4)) {
      var jsx$12 = j$4;
      var index$4 = i$4;
      xs$4.set(jsx$12, array$4[index$4]);
      i$4 = ((1 + i$4) | 0);
      j$4 = ((1 + j$4) | 0)
    };
    this$87.size0$6 = newSize$4;
    b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$4.builder$1))
  };
  if (validation.unionConstraints$1.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var this$98 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var str$6 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$98, "or").iri__T();
    var key$7 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$6);
    var v$5 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
    var jsx$16 = v$5.builder$1;
    var sourceName$4 = v$5.sourceName$2;
    var b$5 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$4);
    $m_Lorg_yaml_model_YNode$();
    var key$8 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@list");
    var v$6 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$5.sourceName$2);
    var jsx$14 = v$6.builder$1;
    var sourceName$5 = v$6.sourceName$2;
    var b$6 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$5);
    validation.unionConstraints$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, l) {
      return (function(v$2$1) {
        var v$7 = $as_T(v$2$1);
        $m_Lamf_core_emitter_BaseEmitters_package$().link__Lorg_yaml_model_YDocument$PartBuilder__T__V(l, v$7)
      })
    })(this, b$6)));
    var jsx$13 = $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YSequence$();
    var loc$3 = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$5);
    var parts$3 = b$6.builder$1;
    var node$3 = jsx$13.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc$3, parts$3), $m_Lorg_yaml_model_YType$().Seq$1);
    jsx$14.$$plus$eq__O__scm_ArrayBuffer(node$3);
    var this$107 = v$6.builder$1;
    var array$5 = [key$8];
    if ((this$107.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$15 = $uI(array$5.length);
    var newSize$5 = ((this$107.size0$6 + len$15) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$107, newSize$5);
    var len$16 = this$107.size0$6;
    var src$5 = this$107.array$6;
    var dest$5 = this$107.array$6;
    $systemArraycopy(src$5, 0, dest$5, len$15, len$16);
    var xs$5 = this$107.array$6;
    var len$17 = xs$5.u.length;
    var i$5 = 0;
    var j$5 = 0;
    var x$13 = $uI(array$5.length);
    var x$14 = ((x$13 < len$17) ? x$13 : len$17);
    var that$5 = xs$5.u.length;
    var end$5 = ((x$14 < that$5) ? x$14 : that$5);
    while ((i$5 < end$5)) {
      var jsx$15 = j$5;
      var index$5 = i$5;
      xs$5.set(jsx$15, array$5[index$5]);
      i$5 = ((1 + i$5) | 0);
      j$5 = ((1 + j$5) | 0)
    };
    this$107.size0$6 = newSize$5;
    b$5.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$6.builder$1));
    jsx$16.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$5.builder$1, sourceName$4), $m_Lorg_yaml_model_YType$().Map$1));
    var this$120 = v$5.builder$1;
    var array$6 = [key$7];
    if ((this$120.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$18 = $uI(array$6.length);
    var newSize$6 = ((this$120.size0$6 + len$18) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$120, newSize$6);
    var len$19 = this$120.size0$6;
    var src$6 = this$120.array$6;
    var dest$6 = this$120.array$6;
    $systemArraycopy(src$6, 0, dest$6, len$18, len$19);
    var xs$6 = this$120.array$6;
    var len$20 = xs$6.u.length;
    var i$6 = 0;
    var j$6 = 0;
    var x$15 = $uI(array$6.length);
    var x$16 = ((x$15 < len$20) ? x$15 : len$20);
    var that$6 = xs$6.u.length;
    var end$6 = ((x$16 < that$6) ? x$16 : that$6);
    while ((i$6 < end$6)) {
      var jsx$17 = j$6;
      var index$6 = i$6;
      xs$6.set(jsx$17, array$6[index$6]);
      i$6 = ((1 + i$6) | 0);
      j$6 = ((1 + j$6) | 0)
    };
    this$120.size0$6 = newSize$6;
    b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$5.builder$1))
  };
  if (validation.andConstraints$1.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var this$131 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var str$7 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$131, "and").iri__T();
    var key$9 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$7);
    var v$8 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
    var jsx$21 = v$8.builder$1;
    var sourceName$6 = v$8.sourceName$2;
    var b$7 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$6);
    $m_Lorg_yaml_model_YNode$();
    var key$10 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@list");
    var v$9 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$7.sourceName$2);
    var jsx$19 = v$9.builder$1;
    var sourceName$7 = v$9.sourceName$2;
    var b$8 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$7);
    validation.andConstraints$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$4, l$1) {
      return (function(v$2$2) {
        var v$10 = $as_T(v$2$2);
        $m_Lamf_core_emitter_BaseEmitters_package$().link__Lorg_yaml_model_YDocument$PartBuilder__T__V(l$1, v$10)
      })
    })(this, b$8)));
    var jsx$18 = $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YSequence$();
    var loc$4 = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$7);
    var parts$4 = b$8.builder$1;
    var node$4 = jsx$18.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc$4, parts$4), $m_Lorg_yaml_model_YType$().Seq$1);
    jsx$19.$$plus$eq__O__scm_ArrayBuffer(node$4);
    var this$140 = v$9.builder$1;
    var array$7 = [key$10];
    if ((this$140.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$21 = $uI(array$7.length);
    var newSize$7 = ((this$140.size0$6 + len$21) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$140, newSize$7);
    var len$22 = this$140.size0$6;
    var src$7 = this$140.array$6;
    var dest$7 = this$140.array$6;
    $systemArraycopy(src$7, 0, dest$7, len$21, len$22);
    var xs$7 = this$140.array$6;
    var len$23 = xs$7.u.length;
    var i$7 = 0;
    var j$7 = 0;
    var x$17 = $uI(array$7.length);
    var x$18 = ((x$17 < len$23) ? x$17 : len$23);
    var that$7 = xs$7.u.length;
    var end$7 = ((x$18 < that$7) ? x$18 : that$7);
    while ((i$7 < end$7)) {
      var jsx$20 = j$7;
      var index$7 = i$7;
      xs$7.set(jsx$20, array$7[index$7]);
      i$7 = ((1 + i$7) | 0);
      j$7 = ((1 + j$7) | 0)
    };
    this$140.size0$6 = newSize$7;
    b$7.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$9.builder$1));
    jsx$21.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$7.builder$1, sourceName$6), $m_Lorg_yaml_model_YType$().Map$1));
    var this$153 = v$8.builder$1;
    var array$8 = [key$9];
    if ((this$153.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$24 = $uI(array$8.length);
    var newSize$8 = ((this$153.size0$6 + len$24) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$153, newSize$8);
    var len$25 = this$153.size0$6;
    var src$8 = this$153.array$6;
    var dest$8 = this$153.array$6;
    $systemArraycopy(src$8, 0, dest$8, len$24, len$25);
    var xs$8 = this$153.array$6;
    var len$26 = xs$8.u.length;
    var i$8 = 0;
    var j$8 = 0;
    var x$19 = $uI(array$8.length);
    var x$20 = ((x$19 < len$26) ? x$19 : len$26);
    var that$8 = xs$8.u.length;
    var end$8 = ((x$20 < that$8) ? x$20 : that$8);
    while ((i$8 < end$8)) {
      var jsx$22 = j$8;
      var index$8 = i$8;
      xs$8.set(jsx$22, array$8[index$8]);
      i$8 = ((1 + i$8) | 0);
      j$8 = ((1 + j$8) | 0)
    };
    this$153.size0$6 = newSize$8;
    b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$8.builder$1))
  };
  if (validation.xoneConstraints$1.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var this$164 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var str$8 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$164, "xone").iri__T();
    var key$11 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$8);
    var v$11 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
    var jsx$26 = v$11.builder$1;
    var sourceName$8 = v$11.sourceName$2;
    var b$9 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$8);
    $m_Lorg_yaml_model_YNode$();
    var key$12 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@list");
    var v$12 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$9.sourceName$2);
    var jsx$24 = v$12.builder$1;
    var sourceName$9 = v$12.sourceName$2;
    var b$10 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$9);
    validation.xoneConstraints$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$5, l$2) {
      return (function(v$2$3) {
        var v$13 = $as_T(v$2$3);
        $m_Lamf_core_emitter_BaseEmitters_package$().link__Lorg_yaml_model_YDocument$PartBuilder__T__V(l$2, v$13)
      })
    })(this, b$10)));
    var jsx$23 = $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YSequence$();
    var loc$5 = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$9);
    var parts$5 = b$10.builder$1;
    var node$5 = jsx$23.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc$5, parts$5), $m_Lorg_yaml_model_YType$().Seq$1);
    jsx$24.$$plus$eq__O__scm_ArrayBuffer(node$5);
    var this$173 = v$12.builder$1;
    var array$9 = [key$12];
    if ((this$173.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$27 = $uI(array$9.length);
    var newSize$9 = ((this$173.size0$6 + len$27) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$173, newSize$9);
    var len$28 = this$173.size0$6;
    var src$9 = this$173.array$6;
    var dest$9 = this$173.array$6;
    $systemArraycopy(src$9, 0, dest$9, len$27, len$28);
    var xs$9 = this$173.array$6;
    var len$29 = xs$9.u.length;
    var i$9 = 0;
    var j$9 = 0;
    var x$21 = $uI(array$9.length);
    var x$22 = ((x$21 < len$29) ? x$21 : len$29);
    var that$9 = xs$9.u.length;
    var end$9 = ((x$22 < that$9) ? x$22 : that$9);
    while ((i$9 < end$9)) {
      var jsx$25 = j$9;
      var index$9 = i$9;
      xs$9.set(jsx$25, array$9[index$9]);
      i$9 = ((1 + i$9) | 0);
      j$9 = ((1 + j$9) | 0)
    };
    this$173.size0$6 = newSize$9;
    b$9.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$12.builder$1));
    jsx$26.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$9.builder$1, sourceName$8), $m_Lorg_yaml_model_YType$().Map$1));
    var this$186 = v$11.builder$1;
    var array$10 = [key$11];
    if ((this$186.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$30 = $uI(array$10.length);
    var newSize$10 = ((this$186.size0$6 + len$30) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$186, newSize$10);
    var len$31 = this$186.size0$6;
    var src$10 = this$186.array$6;
    var dest$10 = this$186.array$6;
    $systemArraycopy(src$10, 0, dest$10, len$30, len$31);
    var xs$10 = this$186.array$6;
    var len$32 = xs$10.u.length;
    var i$10 = 0;
    var j$10 = 0;
    var x$23 = $uI(array$10.length);
    var x$24 = ((x$23 < len$32) ? x$23 : len$32);
    var that$10 = xs$10.u.length;
    var end$10 = ((x$24 < that$10) ? x$24 : that$10);
    while ((i$10 < end$10)) {
      var jsx$27 = j$10;
      var index$10 = i$10;
      xs$10.set(jsx$27, array$10[index$10]);
      i$10 = ((1 + i$10) | 0);
      j$10 = ((1 + j$10) | 0)
    };
    this$186.size0$6 = newSize$10;
    b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$11.builder$1))
  };
  if (validation.notConstraint$1.isDefined__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var this$197 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var str$9 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$197, "not").iri__T();
    var key$13 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$9);
    var v$14 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
    var jsx$29 = v$14.builder$1;
    var sourceName$10 = v$14.sourceName$2;
    var b$11 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$10);
    $m_Lamf_core_emitter_BaseEmitters_package$().link__Lorg_yaml_model_YDocument$PartBuilder__T__V(b$11, $as_T(validation.notConstraint$1.get__O()));
    var jsx$28 = $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YSequence$();
    var loc$6 = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$10);
    var parts$6 = b$11.builder$1;
    var node$6 = jsx$28.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc$6, parts$6), $m_Lorg_yaml_model_YType$().Seq$1);
    jsx$29.$$plus$eq__O__scm_ArrayBuffer(node$6);
    var this$204 = v$14.builder$1;
    var array$11 = [key$13];
    if ((this$204.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$33 = $uI(array$11.length);
    var newSize$11 = ((this$204.size0$6 + len$33) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$204, newSize$11);
    var len$34 = this$204.size0$6;
    var src$11 = this$204.array$6;
    var dest$11 = this$204.array$6;
    $systemArraycopy(src$11, 0, dest$11, len$33, len$34);
    var xs$11 = this$204.array$6;
    var len$35 = xs$11.u.length;
    var i$11 = 0;
    var j$11 = 0;
    var x$25 = $uI(array$11.length);
    var x$26 = ((x$25 < len$35) ? x$25 : len$35);
    var that$11 = xs$11.u.length;
    var end$11 = ((x$26 < that$11) ? x$26 : that$11);
    while ((i$11 < end$11)) {
      var jsx$30 = j$11;
      var index$11 = i$11;
      xs$11.set(jsx$30, array$11[index$11]);
      i$11 = ((1 + i$11) | 0);
      j$11 = ((1 + j$11) | 0)
    };
    this$204.size0$6 = newSize$11;
    b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$14.builder$1))
  };
  var x1$2 = validation.functionConstraint$1;
  if ((x1$2 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1$2);
    var f = $as_Lamf_core_validation_core_FunctionConstraint(x2.value$2);
    this.emitFunctionConstraint__p1__Lorg_yaml_model_YDocument$EntryBuilder__T__Lamf_core_validation_core_FunctionConstraint__V(b$1, validationId, f)
  };
  var this$215 = validation.nodeConstraints$1.groupBy__F1__sci_Map(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$12$1) {
    return (function(x$20$2) {
      var x$20$1 = $as_Lamf_core_validation_core_NodeConstraint(x$20$2);
      return x$20$1.constraint$1
    })
  })(this)));
  var p$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$13$1) {
    return (function(check$ifrefutable$1$2) {
      var check$ifrefutable$1 = $as_T2(check$ifrefutable$1$2);
      return (check$ifrefutable$1 !== null)
    })
  })(this));
  var jsx$35 = new $c_sc_TraversableLike$WithFilter().init___sc_TraversableLike__F1(this$215, p$3);
  var jsx$31 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$14$1, p$4) {
    return (function(x$22$2) {
      var x$22$1 = $as_T2(x$22$2);
      if ((x$22$1 !== null)) {
        var constraint = $as_T(x$22$1.$$und1__O());
        var values = $as_sc_Seq(x$22$1.$$und2__O());
        $m_Lorg_yaml_model_YNode$();
        var str$10 = $m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType(constraint).iri__T();
        var key$14 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$10);
        var v$15 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(p$4.sourceName$2);
        var jsx$33 = v$15.builder$1;
        var sourceName$11 = v$15.sourceName$2;
        var b$12 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$11);
        values.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$6, b$13) {
          return (function(v$2$4) {
            var v$16 = $as_Lamf_core_validation_core_NodeConstraint(v$2$4);
            $m_Lamf_core_emitter_BaseEmitters_package$().link__Lorg_yaml_model_YDocument$PartBuilder__T__V(b$13, $m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType(v$16.value$1).iri__T())
          })
        })(this$14$1, b$12)));
        var jsx$32 = $m_Lorg_yaml_model_YNode$();
        $m_Lorg_yaml_model_YSequence$();
        var loc$7 = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$11);
        var parts$7 = b$12.builder$1;
        var node$7 = jsx$32.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc$7, parts$7), $m_Lorg_yaml_model_YType$().Seq$1);
        jsx$33.$$plus$eq__O__scm_ArrayBuffer(node$7);
        var this$221 = v$15.builder$1;
        var array$12 = [key$14];
        if ((this$221.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len$36 = $uI(array$12.length);
        var newSize$12 = ((this$221.size0$6 + len$36) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$221, newSize$12);
        var len$37 = this$221.size0$6;
        var src$12 = this$221.array$6;
        var dest$12 = this$221.array$6;
        $systemArraycopy(src$12, 0, dest$12, len$36, len$37);
        var xs$12 = this$221.array$6;
        var len$38 = xs$12.u.length;
        var i$12 = 0;
        var j$12 = 0;
        var x$27 = $uI(array$12.length);
        var x$28 = ((x$27 < len$38) ? x$27 : len$38);
        var that$12 = xs$12.u.length;
        var end$12 = ((x$28 < that$12) ? x$28 : that$12);
        while ((i$12 < end$12)) {
          var jsx$34 = j$12;
          var index$12 = i$12;
          xs$12.set(jsx$34, array$12[index$12]);
          i$12 = ((1 + i$12) | 0);
          j$12 = ((1 + j$12) | 0)
        };
        this$221.size0$6 = newSize$12;
        p$4.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$15.builder$1))
      } else {
        throw new $c_s_MatchError().init___O(x$22$1)
      }
    })
  })(this, b$1));
  var this$232 = $m_sci_Iterable$();
  jsx$35.map__F1__scg_CanBuildFrom__O(jsx$31, this$232.ReusableCBFInstance$2);
  if (validation.propertyConstraints$1.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var this$233 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var str$11 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$233, "property").iri__T();
    var key$15 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$11);
    var v$17 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
    var jsx$39 = v$17.builder$1;
    var sourceName$12 = v$17.sourceName$2;
    var b$14 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$12);
    var jsx$37 = validation.propertyConstraints$1;
    var jsx$36 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$7, b$15, validationId$1) {
      return (function(constraint$2) {
        var constraint$1 = $as_Lamf_core_validation_core_PropertyConstraint(constraint$2);
        if ($this$7.isPropertyConstraintUri__p1__T__Z(constraint$1.name$1)) {
          $this$7.emitConstraint__p1__Lorg_yaml_model_YDocument$PartBuilder__T__Lamf_core_validation_core_PropertyConstraint__V(b$15, constraint$1.name$1, constraint$1)
        } else {
          var thiz = constraint$1.name$1;
          if (($uI(thiz.indexOf("#")) > (-1))) {
            var thiz$1 = constraint$1.name$1;
            var xs$13 = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz$1, "#", 0);
            var this$241 = new $c_scm_ArrayOps$ofRef().init___AO(xs$13);
            var thiz$2 = $as_T($f_sc_IndexedSeqOptimized__last__O(this$241));
            var constraintSegment = $as_T(thiz$2.split(".").join("-"))
          } else {
            var thiz$3 = constraint$1.name$1;
            var constraintSegment = $as_T(thiz$3.split(".").join("-"))
          };
          $this$7.emitConstraint__p1__Lorg_yaml_model_YDocument$PartBuilder__T__Lamf_core_validation_core_PropertyConstraint__V(b$15, ((validationId$1 + "/prop/") + constraintSegment), constraint$1)
        }
      })
    })(this, b$14, validationId));
    var this$246 = $m_sc_Seq$();
    jsx$37.map__F1__scg_CanBuildFrom__O(jsx$36, this$246.ReusableCBFInstance$2);
    var jsx$38 = $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YSequence$();
    var loc$8 = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$12);
    var parts$8 = b$14.builder$1;
    var node$8 = jsx$38.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc$8, parts$8), $m_Lorg_yaml_model_YType$().Seq$1);
    jsx$39.$$plus$eq__O__scm_ArrayBuffer(node$8);
    var this$250 = v$17.builder$1;
    var array$13 = [key$15];
    if ((this$250.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$39 = $uI(array$13.length);
    var newSize$13 = ((this$250.size0$6 + len$39) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$250, newSize$13);
    var len$40 = this$250.size0$6;
    var src$13 = this$250.array$6;
    var dest$13 = this$250.array$6;
    $systemArraycopy(src$13, 0, dest$13, len$39, len$40);
    var xs$14 = this$250.array$6;
    var len$41 = xs$14.u.length;
    var i$13 = 0;
    var j$13 = 0;
    var x$29 = $uI(array$13.length);
    var x$30 = ((x$29 < len$41) ? x$29 : len$41);
    var that$13 = xs$14.u.length;
    var end$13 = ((x$30 < that$13) ? x$30 : that$13);
    while ((i$13 < end$13)) {
      var jsx$40 = j$13;
      var index$13 = i$13;
      xs$14.set(jsx$40, array$13[index$13]);
      i$13 = ((1 + i$13) | 0);
      j$13 = ((1 + j$13) | 0)
    };
    this$250.size0$6 = newSize$13;
    b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$17.builder$1))
  };
  jsx$41.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype.genCustomPropertyConstraintValue__p1__Lorg_yaml_model_YDocument$EntryBuilder__T__T__V = (function(b, constraintIri, value) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(constraintIri);
  $m_Lorg_yaml_model_YNode$();
  var value$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(value);
  b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value$1)
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype.genNonEmptyList__p1__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$13 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@type");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
  var jsx$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$3 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  jsx$1.raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(v, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "NodeShape").iri__T(), $m_Lorg_yaml_model_YType$().Str$1);
  var this$8 = v.builder$1;
  var array = [key];
  if ((this$8.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$8.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$8, newSize);
  var len$1 = this$8.size0$6;
  var src = this$8.array$6;
  var dest = this$8.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$8.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$8.size0$6 = newSize;
  b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1));
  $m_Lorg_yaml_model_YNode$();
  var this$19 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var str = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$19, "message").iri__T();
  var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
  $m_Lamf_core_emitter_BaseEmitters_package$().raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(v$1, "List cannot be empty", $m_Lorg_yaml_model_YType$().Str$1);
  var this$25 = v$1.builder$1;
  var array$1 = [key$1];
  if ((this$25.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len$3 = $uI(array$1.length);
  var newSize$1 = ((this$25.size0$6 + len$3) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$25, newSize$1);
  var len$4 = this$25.size0$6;
  var src$1 = this$25.array$6;
  var dest$1 = this$25.array$6;
  $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
  var xs$1 = this$25.array$6;
  var len$5 = xs$1.u.length;
  var i$1 = 0;
  var j$1 = 0;
  var x$2 = $uI(array$1.length);
  var x$3 = ((x$2 < len$5) ? x$2 : len$5);
  var that$1 = xs$1.u.length;
  var end$1 = ((x$3 < that$1) ? x$3 : that$1);
  while ((i$1 < end$1)) {
    var jsx$3 = j$1;
    var index$1 = i$1;
    xs$1.set(jsx$3, array$1[index$1]);
    i$1 = ((1 + i$1) | 0);
    j$1 = ((1 + j$1) | 0)
  };
  this$25.size0$6 = newSize$1;
  b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1));
  $m_Lorg_yaml_model_YNode$();
  var this$36 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var str$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$36, "property").iri__T();
  var key$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
  var v$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
  var jsx$11 = v$2.builder$1;
  var sourceName$1 = v$2.sourceName$2;
  var b$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$1);
  var jsx$9 = b$2.builder$1;
  var sourceName$2 = b$2.sourceName$2;
  var b$3 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$2);
  $m_Lorg_yaml_model_YNode$();
  var this$41 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var str$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$41, "path").iri__T();
  var key$3 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$2);
  var v$3 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$3.sourceName$2);
  var jsx$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$44 = $m_Lamf_core_vocabulary_Namespace$().Rdfs$1;
  jsx$4.link__Lorg_yaml_model_YDocument$PartBuilder__T__V(v$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$44, "_1").iri__T());
  var this$48 = v$3.builder$1;
  var array$2 = [key$3];
  if ((this$48.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len$6 = $uI(array$2.length);
  var newSize$2 = ((this$48.size0$6 + len$6) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$48, newSize$2);
  var len$7 = this$48.size0$6;
  var src$2 = this$48.array$6;
  var dest$2 = this$48.array$6;
  $systemArraycopy(src$2, 0, dest$2, len$6, len$7);
  var xs$2 = this$48.array$6;
  var len$8 = xs$2.u.length;
  var i$2 = 0;
  var j$2 = 0;
  var x$4 = $uI(array$2.length);
  var x$5 = ((x$4 < len$8) ? x$4 : len$8);
  var that$2 = xs$2.u.length;
  var end$2 = ((x$5 < that$2) ? x$5 : that$2);
  while ((i$2 < end$2)) {
    var jsx$5 = j$2;
    var index$2 = i$2;
    xs$2.set(jsx$5, array$2[index$2]);
    i$2 = ((1 + i$2) | 0);
    j$2 = ((1 + j$2) | 0)
  };
  this$48.size0$6 = newSize$2;
  b$3.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$3.builder$1));
  $m_Lorg_yaml_model_YNode$();
  var this$59 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var str$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$59, "minCount").iri__T();
  var key$4 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$3);
  var v$4 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$3.sourceName$2);
  var jsx$7 = v$4.builder$1;
  var sourceName$3 = v$4.sourceName$2;
  var b$4 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$3);
  $m_Lorg_yaml_model_YNode$();
  var key$5 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@value");
  var v$5 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$4.sourceName$2);
  $m_Lamf_core_emitter_BaseEmitters_package$().raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(v$5, "1", $m_Lorg_yaml_model_YType$().Int$1);
  var this$66 = v$5.builder$1;
  var array$3 = [key$5];
  if ((this$66.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len$9 = $uI(array$3.length);
  var newSize$3 = ((this$66.size0$6 + len$9) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$66, newSize$3);
  var len$10 = this$66.size0$6;
  var src$3 = this$66.array$6;
  var dest$3 = this$66.array$6;
  $systemArraycopy(src$3, 0, dest$3, len$9, len$10);
  var xs$3 = this$66.array$6;
  var len$11 = xs$3.u.length;
  var i$3 = 0;
  var j$3 = 0;
  var x$6 = $uI(array$3.length);
  var x$7 = ((x$6 < len$11) ? x$6 : len$11);
  var that$3 = xs$3.u.length;
  var end$3 = ((x$7 < that$3) ? x$7 : that$3);
  while ((i$3 < end$3)) {
    var jsx$6 = j$3;
    var index$3 = i$3;
    xs$3.set(jsx$6, array$3[index$3]);
    i$3 = ((1 + i$3) | 0);
    j$3 = ((1 + j$3) | 0)
  };
  this$66.size0$6 = newSize$3;
  b$4.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$5.builder$1));
  jsx$7.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$4.builder$1, sourceName$3), $m_Lorg_yaml_model_YType$().Map$1));
  var this$79 = v$4.builder$1;
  var array$4 = [key$4];
  if ((this$79.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len$12 = $uI(array$4.length);
  var newSize$4 = ((this$79.size0$6 + len$12) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$79, newSize$4);
  var len$13 = this$79.size0$6;
  var src$4 = this$79.array$6;
  var dest$4 = this$79.array$6;
  $systemArraycopy(src$4, 0, dest$4, len$12, len$13);
  var xs$4 = this$79.array$6;
  var len$14 = xs$4.u.length;
  var i$4 = 0;
  var j$4 = 0;
  var x$8 = $uI(array$4.length);
  var x$9 = ((x$8 < len$14) ? x$8 : len$14);
  var that$4 = xs$4.u.length;
  var end$4 = ((x$9 < that$4) ? x$9 : that$4);
  while ((i$4 < end$4)) {
    var jsx$8 = j$4;
    var index$4 = i$4;
    xs$4.set(jsx$8, array$4[index$4]);
    i$4 = ((1 + i$4) | 0);
    j$4 = ((1 + j$4) | 0)
  };
  this$79.size0$6 = newSize$4;
  b$3.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$4.builder$1));
  jsx$9.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$3.builder$1, sourceName$2), $m_Lorg_yaml_model_YType$().Map$1));
  var jsx$10 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$1);
  var parts = b$2.builder$1;
  var node = jsx$10.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$11.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$93 = v$2.builder$1;
  var array$5 = [key$2];
  if ((this$93.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len$15 = $uI(array$5.length);
  var newSize$5 = ((this$93.size0$6 + len$15) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$93, newSize$5);
  var len$16 = this$93.size0$6;
  var src$5 = this$93.array$6;
  var dest$5 = this$93.array$6;
  $systemArraycopy(src$5, 0, dest$5, len$15, len$16);
  var xs$5 = this$93.array$6;
  var len$17 = xs$5.u.length;
  var i$5 = 0;
  var j$5 = 0;
  var x$10 = $uI(array$5.length);
  var x$11 = ((x$10 < len$17) ? x$10 : len$17);
  var that$5 = xs$5.u.length;
  var end$5 = ((x$11 < that$5) ? x$11 : that$5);
  while ((i$5 < end$5)) {
    var jsx$12 = j$5;
    var index$5 = i$5;
    xs$5.set(jsx$12, array$5[index$5]);
    i$5 = ((1 + i$5) | 0);
    j$5 = ((1 + j$5) | 0)
  };
  this$93.size0$6 = newSize$5;
  b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$2.builder$1));
  jsx$13.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype.assertPropertyPath__Lorg_yaml_model_YDocument$EntryBuilder__T__Lamf_core_validation_core_PropertyConstraint__V = (function(b, constraintId, constraint) {
  var parsedPath = $as_Lamf_core_validation_model_PropertyPath(constraint.path$1.get__O());
  $m_Lorg_yaml_model_YNode$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var str = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "path").iri__T();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  this.emitPath__Lorg_yaml_model_YDocument$PartBuilder__T__Lamf_core_validation_model_PropertyPath__V(v, (constraintId + "_path"), parsedPath);
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype.expandRamlId__p1__T__T = (function(s) {
  if ((((($uI(s.length) >= 0) && ($as_T(s.substring(0, $uI("http://".length))) === "http://")) || (($uI(s.length) >= 0) && ($as_T(s.substring(0, $uI("https://".length))) === "https://"))) || (($uI(s.length) >= 0) && ($as_T(s.substring(0, $uI("file:".length))) === "file:")))) {
    return $as_T(s.trim())
  } else {
    var thiz = $m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType($as_T(s.split(".").join(":"))).iri__T();
    return $as_T(thiz.trim())
  }
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype.genNumericPropertyConstraintValue__p1__Lorg_yaml_model_YDocument$EntryBuilder__T__T__s_Option__V = (function(b, constraintName, value, constraint) {
  var rc7 = false;
  var x2 = null;
  if (constraint.isEmpty__Z()) {
    var x1 = $m_s_None$()
  } else {
    var arg1 = constraint.get__O();
    var x$88 = $as_Lamf_core_validation_core_PropertyConstraint(arg1);
    var x1 = x$88.datatype$1
  };
  matchEnd8: {
    if ((x1 instanceof $c_s_Some)) {
      rc7 = true;
      x2 = $as_s_Some(x1);
      var scalarType = $as_T(x2.value$2);
      var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
      if (((scalarType === new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "number").iri__T()) || (scalarType === $m_Lamf_core_model_DataType$().Double$1))) {
        $m_Lorg_yaml_model_YNode$();
        var this$3 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        var str = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, constraintName).iri__T();
        var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
        var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
        var this$7 = new $c_sci_StringOps().init___T(value);
        var jsx$1 = $m_jl_Double$();
        var $$this = this$7.repr$1;
        var this$9 = jsx$1.parseDouble__T__D($$this);
        this.amf$plugins$features$validation$emitters$ValidationJSONLDEmitter$$genValue__Lorg_yaml_model_YDocument$PartBuilder__T__s_Option__V(v, ("" + this$9), new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Double$1));
        var this$13 = v.builder$1;
        var array = [key];
        if ((this$13.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len = $uI(array.length);
        var newSize = ((this$13.size0$6 + len) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$13, newSize);
        var len$1 = this$13.size0$6;
        var src = this$13.array$6;
        var dest = this$13.array$6;
        $systemArraycopy(src, 0, dest, len, len$1);
        var xs = this$13.array$6;
        var len$2 = xs.u.length;
        var i = 0;
        var j = 0;
        var x = $uI(array.length);
        var x$1 = ((x < len$2) ? x : len$2);
        var that = xs.u.length;
        var end = ((x$1 < that) ? x$1 : that);
        while ((i < end)) {
          var jsx$2 = j;
          var index = i;
          xs.set(jsx$2, array[index]);
          i = ((1 + i) | 0);
          j = ((1 + j) | 0)
        };
        this$13.size0$6 = newSize;
        b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1));
        break matchEnd8
      }
    };
    var x$2 = $m_s_None$();
    if ((x$2 === x1)) {
      $m_Lorg_yaml_model_YNode$();
      var this$24 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      var str$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$24, constraintName).iri__T();
      var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
      var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
      var this$28 = new $c_sci_StringOps().init___T(value);
      var jsx$3 = $m_jl_Double$();
      var $$this$1 = this$28.repr$1;
      var this$30 = jsx$3.parseDouble__T__D($$this$1);
      this.amf$plugins$features$validation$emitters$ValidationJSONLDEmitter$$genValue__Lorg_yaml_model_YDocument$PartBuilder__T__s_Option__V(v$1, ("" + this$30), new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Double$1));
      var this$34 = v$1.builder$1;
      var array$1 = [key$1];
      if ((this$34.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$3 = $uI(array$1.length);
      var newSize$1 = ((this$34.size0$6 + len$3) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$34, newSize$1);
      var len$4 = this$34.size0$6;
      var src$1 = this$34.array$6;
      var dest$1 = this$34.array$6;
      $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
      var xs$1 = this$34.array$6;
      var len$5 = xs$1.u.length;
      var i$1 = 0;
      var j$1 = 0;
      var x$3 = $uI(array$1.length);
      var x$4 = ((x$3 < len$5) ? x$3 : len$5);
      var that$1 = xs$1.u.length;
      var end$1 = ((x$4 < that$1) ? x$4 : that$1);
      while ((i$1 < end$1)) {
        var jsx$4 = j$1;
        var index$1 = i$1;
        xs$1.set(jsx$4, array$1[index$1]);
        i$1 = ((1 + i$1) | 0);
        j$1 = ((1 + j$1) | 0)
      };
      this$34.size0$6 = newSize$1;
      b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1));
      break matchEnd8
    };
    if (rc7) {
      var scalarType$2 = $as_T(x2.value$2);
      if ((scalarType$2 === $m_Lamf_core_model_DataType$().Float$1)) {
        $m_Lorg_yaml_model_YNode$();
        var this$45 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        var str$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$45, constraintName).iri__T();
        var key$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$2);
        var v$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
        var this$49 = new $c_sci_StringOps().init___T(value);
        var jsx$5 = $m_jl_Double$();
        var $$this$2 = this$49.repr$1;
        var this$51 = jsx$5.parseDouble__T__D($$this$2);
        this.amf$plugins$features$validation$emitters$ValidationJSONLDEmitter$$genValue__Lorg_yaml_model_YDocument$PartBuilder__T__s_Option__V(v$2, ("" + this$51), new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Float$1));
        var this$55 = v$2.builder$1;
        var array$2 = [key$2];
        if ((this$55.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len$6 = $uI(array$2.length);
        var newSize$2 = ((this$55.size0$6 + len$6) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$55, newSize$2);
        var len$7 = this$55.size0$6;
        var src$2 = this$55.array$6;
        var dest$2 = this$55.array$6;
        $systemArraycopy(src$2, 0, dest$2, len$6, len$7);
        var xs$2 = this$55.array$6;
        var len$8 = xs$2.u.length;
        var i$2 = 0;
        var j$2 = 0;
        var x$5 = $uI(array$2.length);
        var x$6 = ((x$5 < len$8) ? x$5 : len$8);
        var that$2 = xs$2.u.length;
        var end$2 = ((x$6 < that$2) ? x$6 : that$2);
        while ((i$2 < end$2)) {
          var jsx$6 = j$2;
          var index$2 = i$2;
          xs$2.set(jsx$6, array$2[index$2]);
          i$2 = ((1 + i$2) | 0);
          j$2 = ((1 + j$2) | 0)
        };
        this$55.size0$6 = newSize$2;
        b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$2.builder$1));
        break matchEnd8
      }
    };
    if (rc7) {
      var scalarType$3 = $as_T(x2.value$2);
      if ((scalarType$3 === $m_Lamf_core_model_DataType$().Integer$1)) {
        $m_Lorg_yaml_model_YNode$();
        var this$66 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        var str$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$66, constraintName).iri__T();
        var key$3 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$3);
        var v$3 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
        var this$70 = new $c_sci_StringOps().init___T(value);
        var jsx$7 = $m_jl_Double$();
        var $$this$3 = this$70.repr$1;
        var x$7 = jsx$7.parseDouble__T__D($$this$3);
        var this$76 = $doubleToInt($uD($g.Math.floor(x$7)));
        this.amf$plugins$features$validation$emitters$ValidationJSONLDEmitter$$genValue__Lorg_yaml_model_YDocument$PartBuilder__T__s_Option__V(v$3, ("" + this$76), new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Integer$1));
        var this$80 = v$3.builder$1;
        var array$3 = [key$3];
        if ((this$80.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len$9 = $uI(array$3.length);
        var newSize$3 = ((this$80.size0$6 + len$9) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$80, newSize$3);
        var len$10 = this$80.size0$6;
        var src$3 = this$80.array$6;
        var dest$3 = this$80.array$6;
        $systemArraycopy(src$3, 0, dest$3, len$9, len$10);
        var xs$3 = this$80.array$6;
        var len$11 = xs$3.u.length;
        var i$3 = 0;
        var j$3 = 0;
        var x$8 = $uI(array$3.length);
        var x$9 = ((x$8 < len$11) ? x$8 : len$11);
        var that$3 = xs$3.u.length;
        var end$3 = ((x$9 < that$3) ? x$9 : that$3);
        while ((i$3 < end$3)) {
          var jsx$8 = j$3;
          var index$3 = i$3;
          xs$3.set(jsx$8, array$3[index$3]);
          i$3 = ((1 + i$3) | 0);
          j$3 = ((1 + j$3) | 0)
        };
        this$80.size0$6 = newSize$3;
        b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$3.builder$1));
        break matchEnd8
      }
    };
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype.emitFunctionConstraint__p1__Lorg_yaml_model_YDocument$EntryBuilder__T__Lamf_core_validation_core_FunctionConstraint__V = (function(b, validationId, f) {
  this.genJSValidator__p1__T__Lamf_core_validation_core_FunctionConstraint__scm_ListBuffer(validationId, f);
  this.genJSConstraint__p1__T__Lamf_core_validation_core_FunctionConstraint__scm_ListBuffer(validationId, f);
  $m_Lorg_yaml_model_YNode$();
  var str = f.validatorPath__T__T(validationId);
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  this.amf$plugins$features$validation$emitters$ValidationJSONLDEmitter$$genValue__Lorg_yaml_model_YDocument$PartBuilder__T__s_Option__V(v, "true", $m_s_None$());
  var this$4 = v.builder$1;
  var array = [key];
  if ((this$4.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$4.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$4, newSize);
  var len$1 = this$4.size0$6;
  var src = this$4.array$6;
  var dest = this$4.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$4.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$4.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype.genPropertyConstraintValue__p1__Lorg_yaml_model_YDocument$EntryBuilder__T__T__s_Option__V = (function(b, constraintName, value, constraint) {
  var rc7 = false;
  var x2 = null;
  if (constraint.isEmpty__Z()) {
    var x1 = $m_s_None$()
  } else {
    var arg1 = constraint.get__O();
    var x$79 = $as_Lamf_core_validation_core_PropertyConstraint(arg1);
    var x1 = x$79.datatype$1
  };
  matchEnd8: {
    if ((x1 instanceof $c_s_Some)) {
      rc7 = true;
      x2 = $as_s_Some(x1);
      var scalarType = $as_T(x2.value$2);
      var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
      if ((scalarType === new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "number").iri__T())) {
        $m_Lorg_yaml_model_YNode$();
        var this$3 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        var str = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "or").iri__T();
        var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
        var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
        var jsx$10 = v.builder$1;
        var sourceName = v.sourceName$2;
        var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
        $m_Lorg_yaml_model_YNode$();
        var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@list");
        var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
        var jsx$8 = v$1.builder$1;
        var sourceName$1 = v$1.sourceName$2;
        var b$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$1);
        var jsx$3 = b$2.builder$1;
        var sourceName$2 = b$2.sourceName$2;
        var b$3 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$2);
        $m_Lorg_yaml_model_YNode$();
        var this$10 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        var str$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, constraintName).iri__T();
        var key$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
        var v$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$3.sourceName$2);
        var this$14 = new $c_sci_StringOps().init___T(value);
        var jsx$1 = $m_jl_Double$();
        var $$this = this$14.repr$1;
        var x = jsx$1.parseDouble__T__D($$this);
        var this$20 = $doubleToInt($uD($g.Math.floor(x)));
        this.amf$plugins$features$validation$emitters$ValidationJSONLDEmitter$$genValue__Lorg_yaml_model_YDocument$PartBuilder__T__s_Option__V(v$2, ("" + this$20), new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Integer$1));
        var this$24 = v$2.builder$1;
        var array = [key$2];
        if ((this$24.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len = $uI(array.length);
        var newSize = ((this$24.size0$6 + len) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$24, newSize);
        var len$1 = this$24.size0$6;
        var src = this$24.array$6;
        var dest = this$24.array$6;
        $systemArraycopy(src, 0, dest, len, len$1);
        var xs = this$24.array$6;
        var len$2 = xs.u.length;
        var i = 0;
        var j = 0;
        var x$1 = $uI(array.length);
        var x$2 = ((x$1 < len$2) ? x$1 : len$2);
        var that = xs.u.length;
        var end = ((x$2 < that) ? x$2 : that);
        while ((i < end)) {
          var jsx$2 = j;
          var index = i;
          xs.set(jsx$2, array[index]);
          i = ((1 + i) | 0);
          j = ((1 + j) | 0)
        };
        this$24.size0$6 = newSize;
        b$3.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$2.builder$1));
        jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$3.builder$1, sourceName$2), $m_Lorg_yaml_model_YType$().Map$1));
        var jsx$6 = b$2.builder$1;
        var sourceName$3 = b$2.sourceName$2;
        var b$4 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$3);
        $m_Lorg_yaml_model_YNode$();
        var this$36 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        var str$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$36, constraintName).iri__T();
        var key$3 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$2);
        var v$3 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$4.sourceName$2);
        var this$40 = new $c_sci_StringOps().init___T(value);
        var jsx$4 = $m_jl_Double$();
        var $$this$1 = this$40.repr$1;
        var this$42 = jsx$4.parseDouble__T__D($$this$1);
        this.amf$plugins$features$validation$emitters$ValidationJSONLDEmitter$$genValue__Lorg_yaml_model_YDocument$PartBuilder__T__s_Option__V(v$3, ("" + this$42), new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Double$1));
        var this$46 = v$3.builder$1;
        var array$1 = [key$3];
        if ((this$46.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len$3 = $uI(array$1.length);
        var newSize$1 = ((this$46.size0$6 + len$3) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$46, newSize$1);
        var len$4 = this$46.size0$6;
        var src$1 = this$46.array$6;
        var dest$1 = this$46.array$6;
        $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
        var xs$1 = this$46.array$6;
        var len$5 = xs$1.u.length;
        var i$1 = 0;
        var j$1 = 0;
        var x$3 = $uI(array$1.length);
        var x$4 = ((x$3 < len$5) ? x$3 : len$5);
        var that$1 = xs$1.u.length;
        var end$1 = ((x$4 < that$1) ? x$4 : that$1);
        while ((i$1 < end$1)) {
          var jsx$5 = j$1;
          var index$1 = i$1;
          xs$1.set(jsx$5, array$1[index$1]);
          i$1 = ((1 + i$1) | 0);
          j$1 = ((1 + j$1) | 0)
        };
        this$46.size0$6 = newSize$1;
        b$4.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$3.builder$1));
        jsx$6.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$4.builder$1, sourceName$3), $m_Lorg_yaml_model_YType$().Map$1));
        var jsx$7 = $m_Lorg_yaml_model_YNode$();
        $m_Lorg_yaml_model_YSequence$();
        var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$1);
        var parts = b$2.builder$1;
        var node = jsx$7.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
        jsx$8.$$plus$eq__O__scm_ArrayBuffer(node);
        var this$60 = v$1.builder$1;
        var array$2 = [key$1];
        if ((this$60.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len$6 = $uI(array$2.length);
        var newSize$2 = ((this$60.size0$6 + len$6) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$60, newSize$2);
        var len$7 = this$60.size0$6;
        var src$2 = this$60.array$6;
        var dest$2 = this$60.array$6;
        $systemArraycopy(src$2, 0, dest$2, len$6, len$7);
        var xs$2 = this$60.array$6;
        var len$8 = xs$2.u.length;
        var i$2 = 0;
        var j$2 = 0;
        var x$5 = $uI(array$2.length);
        var x$6 = ((x$5 < len$8) ? x$5 : len$8);
        var that$2 = xs$2.u.length;
        var end$2 = ((x$6 < that$2) ? x$6 : that$2);
        while ((i$2 < end$2)) {
          var jsx$9 = j$2;
          var index$2 = i$2;
          xs$2.set(jsx$9, array$2[index$2]);
          i$2 = ((1 + i$2) | 0);
          j$2 = ((1 + j$2) | 0)
        };
        this$60.size0$6 = newSize$2;
        b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1));
        jsx$10.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
        var this$73 = v.builder$1;
        var array$3 = [key];
        if ((this$73.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len$9 = $uI(array$3.length);
        var newSize$3 = ((this$73.size0$6 + len$9) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$73, newSize$3);
        var len$10 = this$73.size0$6;
        var src$3 = this$73.array$6;
        var dest$3 = this$73.array$6;
        $systemArraycopy(src$3, 0, dest$3, len$9, len$10);
        var xs$3 = this$73.array$6;
        var len$11 = xs$3.u.length;
        var i$3 = 0;
        var j$3 = 0;
        var x$7 = $uI(array$3.length);
        var x$8 = ((x$7 < len$11) ? x$7 : len$11);
        var that$3 = xs$3.u.length;
        var end$3 = ((x$8 < that$3) ? x$8 : that$3);
        while ((i$3 < end$3)) {
          var jsx$11 = j$3;
          var index$3 = i$3;
          xs$3.set(jsx$11, array$3[index$3]);
          i$3 = ((1 + i$3) | 0);
          j$3 = ((1 + j$3) | 0)
        };
        this$73.size0$6 = newSize$3;
        b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1));
        break matchEnd8
      }
    };
    if (rc7) {
      $m_Lorg_yaml_model_YNode$();
      var this$84 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      var str$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$84, constraintName).iri__T();
      var key$4 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$3);
      var v$4 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
      if (constraint.isEmpty__Z()) {
        var jsx$12 = $m_s_None$()
      } else {
        var arg1$1 = constraint.get__O();
        var x$86 = $as_Lamf_core_validation_core_PropertyConstraint(arg1$1);
        var jsx$12 = x$86.datatype$1
      };
      this.amf$plugins$features$validation$emitters$ValidationJSONLDEmitter$$genValue__Lorg_yaml_model_YDocument$PartBuilder__T__s_Option__V(v$4, value, jsx$12);
      var this$89 = v$4.builder$1;
      var array$4 = [key$4];
      if ((this$89.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$12 = $uI(array$4.length);
      var newSize$4 = ((this$89.size0$6 + len$12) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$89, newSize$4);
      var len$13 = this$89.size0$6;
      var src$4 = this$89.array$6;
      var dest$4 = this$89.array$6;
      $systemArraycopy(src$4, 0, dest$4, len$12, len$13);
      var xs$4 = this$89.array$6;
      var len$14 = xs$4.u.length;
      var i$4 = 0;
      var j$4 = 0;
      var x$9 = $uI(array$4.length);
      var x$10 = ((x$9 < len$14) ? x$9 : len$14);
      var that$4 = xs$4.u.length;
      var end$4 = ((x$10 < that$4) ? x$10 : that$4);
      while ((i$4 < end$4)) {
        var jsx$13 = j$4;
        var index$4 = i$4;
        xs$4.set(jsx$13, array$4[index$4]);
        i$4 = ((1 + i$4) | 0);
        j$4 = ((1 + j$4) | 0)
      };
      this$89.size0$6 = newSize$4;
      b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$4.builder$1));
      break matchEnd8
    };
    var x$11 = $m_s_None$();
    if ((x$11 === x1)) {
      $m_Lorg_yaml_model_YNode$();
      var this$100 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      var str$4 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$100, constraintName).iri__T();
      var key$5 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$4);
      var v$5 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
      this.amf$plugins$features$validation$emitters$ValidationJSONLDEmitter$$genValue__Lorg_yaml_model_YDocument$PartBuilder__T__s_Option__V(v$5, value, $m_s_None$());
      var this$105 = v$5.builder$1;
      var array$5 = [key$5];
      if ((this$105.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$15 = $uI(array$5.length);
      var newSize$5 = ((this$105.size0$6 + len$15) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$105, newSize$5);
      var len$16 = this$105.size0$6;
      var src$5 = this$105.array$6;
      var dest$5 = this$105.array$6;
      $systemArraycopy(src$5, 0, dest$5, len$15, len$16);
      var xs$5 = this$105.array$6;
      var len$17 = xs$5.u.length;
      var i$5 = 0;
      var j$5 = 0;
      var x$12 = $uI(array$5.length);
      var x$13 = ((x$12 < len$17) ? x$12 : len$17);
      var that$5 = xs$5.u.length;
      var end$5 = ((x$13 < that$5) ? x$13 : that$5);
      while ((i$5 < end$5)) {
        var jsx$14 = j$5;
        var index$5 = i$5;
        xs$5.set(jsx$14, array$5[index$5]);
        i$5 = ((1 + i$5) | 0);
        j$5 = ((1 + j$5) | 0)
      };
      this$105.size0$6 = newSize$5;
      b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$5.builder$1));
      break matchEnd8
    };
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype.init___Lamf_ProfileName = (function(targetProfile) {
  this.targetProfile$1 = targetProfile;
  this.jsValidatorEmitters$1 = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  this.jsConstraintEmitters$1 = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  return this
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype.emitJSONLDAST__p1__sc_Seq__Lorg_yaml_model_YDocument = (function(validations) {
  var this$2 = $m_Lorg_yaml_model_YDocument$().apply__T__Lorg_yaml_model_YDocument$WithComment("");
  var b = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(this$2.org$yaml$model$YDocument$WithComment$$sourceName$f);
  var x = this$2.comment$1;
  var this$4 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$4)) {
    b.comment__T__V(this$2.comment$1)
  };
  var jsx$2 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  validations.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$2) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_validation_core_ValidationSpecification(x$2$2);
      $this.emitValidation__p1__Lorg_yaml_model_YDocument$PartBuilder__Lamf_core_validation_core_ValidationSpecification__V(b$2, x$2)
    })
  })(this, b$1)));
  var this$6 = this.jsValidatorEmitters$1;
  var this$7 = this$6.scala$collection$mutable$ListBuffer$$start$6;
  var these = this$7;
  while ((!these.isEmpty__Z())) {
    var arg1 = these.head__O();
    var x$3 = $as_Lamf_core_emitter_PartEmitter(arg1);
    x$3.emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$1);
    these = $as_sci_List(these.tail__O())
  };
  var this$8 = this.jsConstraintEmitters$1;
  var this$9 = this$8.scala$collection$mutable$ListBuffer$$start$6;
  var these$1 = this$9;
  while ((!these$1.isEmpty__Z())) {
    var arg1$1 = these$1.head__O();
    var x$4 = $as_Lamf_core_emitter_PartEmitter(arg1$1);
    x$4.emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$1);
    these$1 = $as_sci_List(these$1.tail__O())
  };
  var jsx$1 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$2.$$plus$eq__O__scm_ArrayBuffer(node);
  return new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this$2.org$yaml$model$YDocument$WithComment$$sourceName$f), b.builder$1)
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype.emitJSON__sc_Seq__T = (function(validations) {
  var this$1 = $m_Lorg_yaml_render_JsonRender$();
  var doc = this.emitJSONLDAST__p1__sc_Seq__Lorg_yaml_model_YDocument(validations);
  return this$1.render__Lorg_yaml_model_YDocument__I__Lorg_yaml_render_JsonRenderOptions__T(doc, 0, new $c_Lorg_yaml_render_JsonRenderOptions().init___())
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype.emitPath__Lorg_yaml_model_YDocument$PartBuilder__T__Lamf_core_validation_model_PropertyPath__V = (function(b, base, parsedPath) {
  var rc20 = false;
  var x2 = null;
  matchEnd21: {
    if ((parsedPath instanceof $c_Lamf_core_validation_model_PredicatePath)) {
      rc20 = true;
      x2 = $as_Lamf_core_validation_model_PredicatePath(parsedPath);
      var p = x2.property$2;
      var p3 = x2.inverse$2;
      var p4 = x2.zeroOrMore$2;
      if (((p3 === true) && (p4 === false))) {
        var uri = (base + "_inv");
        var jsx$2 = b.builder$1;
        var sourceName = b.sourceName$2;
        var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
        $m_Lorg_yaml_model_YNode$();
        var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@id");
        $m_Lorg_yaml_model_YNode$();
        var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(uri);
        b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value);
        $m_Lorg_yaml_model_YNode$();
        var this$4 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        var str = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "inversePath").iri__T();
        var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
        var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
        this.amf$plugins$features$validation$emitters$ValidationJSONLDEmitter$$genValue__Lorg_yaml_model_YDocument$PartBuilder__T__s_Option__V(v, p, $m_s_None$());
        var this$9 = v.builder$1;
        var array = [key$1];
        if ((this$9.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len = $uI(array.length);
        var newSize = ((this$9.size0$6 + len) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$9, newSize);
        var len$1 = this$9.size0$6;
        var src = this$9.array$6;
        var dest = this$9.array$6;
        $systemArraycopy(src, 0, dest, len, len$1);
        var xs = this$9.array$6;
        var len$2 = xs.u.length;
        var i = 0;
        var j = 0;
        var x = $uI(array.length);
        var x$1 = ((x < len$2) ? x : len$2);
        var that = xs.u.length;
        var end = ((x$1 < that) ? x$1 : that);
        while ((i < end)) {
          var jsx$1 = j;
          var index = i;
          xs.set(jsx$1, array[index]);
          i = ((1 + i) | 0);
          j = ((1 + j) | 0)
        };
        this$9.size0$6 = newSize;
        b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1));
        jsx$2.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
        break matchEnd21
      }
    };
    if (rc20) {
      var p$2 = x2.property$2;
      var p6 = x2.inverse$2;
      var p7 = x2.zeroOrMore$2;
      if (((p6 === false) && (p7 === true))) {
        var uri$2 = (base + "_neg");
        var jsx$4 = b.builder$1;
        var sourceName$1 = b.sourceName$2;
        var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
        $m_Lorg_yaml_model_YNode$();
        var key$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@id");
        $m_Lorg_yaml_model_YNode$();
        var value$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(uri$2);
        b$2.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$2, value$1);
        $m_Lorg_yaml_model_YNode$();
        var this$23 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        var str$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$23, "zerOrMorePath").iri__T();
        var key$3 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
        var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$2.sourceName$2);
        this.amf$plugins$features$validation$emitters$ValidationJSONLDEmitter$$genValue__Lorg_yaml_model_YDocument$PartBuilder__T__s_Option__V(v$1, p$2, $m_s_None$());
        var this$28 = v$1.builder$1;
        var array$1 = [key$3];
        if ((this$28.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len$3 = $uI(array$1.length);
        var newSize$1 = ((this$28.size0$6 + len$3) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$28, newSize$1);
        var len$4 = this$28.size0$6;
        var src$1 = this$28.array$6;
        var dest$1 = this$28.array$6;
        $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
        var xs$1 = this$28.array$6;
        var len$5 = xs$1.u.length;
        var i$1 = 0;
        var j$1 = 0;
        var x$2 = $uI(array$1.length);
        var x$3 = ((x$2 < len$5) ? x$2 : len$5);
        var that$1 = xs$1.u.length;
        var end$1 = ((x$3 < that$1) ? x$3 : that$1);
        while ((i$1 < end$1)) {
          var jsx$3 = j$1;
          var index$1 = i$1;
          xs$1.set(jsx$3, array$1[index$1]);
          i$1 = ((1 + i$1) | 0);
          j$1 = ((1 + j$1) | 0)
        };
        this$28.size0$6 = newSize$1;
        b$2.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1));
        jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1));
        break matchEnd21
      }
    };
    if (rc20) {
      var p$3 = x2.property$2;
      var p9 = x2.inverse$2;
      var p10 = x2.zeroOrMore$2;
      if (((p9 === false) && (p10 === false))) {
        $m_Lamf_core_emitter_BaseEmitters_package$().link__Lorg_yaml_model_YDocument$PartBuilder__T__V(b, p$3);
        break matchEnd21
      }
    };
    if ((parsedPath instanceof $c_Lamf_core_validation_model_SequencePath)) {
      var x11 = $as_Lamf_core_validation_model_SequencePath(parsedPath);
      var elements = x11.elements$2;
      var uri$3 = (base + "_seq");
      var jsx$8 = b.builder$1;
      var sourceName$2 = b.sourceName$2;
      var b$3 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$2);
      $m_Lorg_yaml_model_YNode$();
      var key$4 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@list");
      var v$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$3.sourceName$2);
      var jsx$6 = v$2.builder$1;
      var sourceName$3 = v$2.sourceName$2;
      var b$4 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$3);
      var this$42 = $m_sci_List$();
      var bf = this$42.ReusableCBFInstance$2;
      var this$43 = $as_sci_List($f_sc_IterableLike__zipWithIndex__scg_CanBuildFrom__O(elements, bf));
      var these = this$43;
      while ((!these.isEmpty__Z())) {
        var arg1 = these.head__O();
        var x0$1 = $as_T2(arg1);
        if ((x0$1 !== null)) {
          var e = $as_Lamf_core_validation_model_PropertyPath(x0$1.$$und1__O());
          var i$2 = x0$1.$$und2$mcI$sp__I();
          this.emitPath__Lorg_yaml_model_YDocument$PartBuilder__T__Lamf_core_validation_model_PropertyPath__V(b$4, (uri$3 + i$2), e)
        } else {
          throw new $c_s_MatchError().init___O(x0$1)
        };
        these = $as_sci_List(these.tail__O())
      };
      var jsx$5 = $m_Lorg_yaml_model_YNode$();
      $m_Lorg_yaml_model_YSequence$();
      var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$3);
      var parts = b$4.builder$1;
      var node = jsx$5.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
      jsx$6.$$plus$eq__O__scm_ArrayBuffer(node);
      var this$47 = v$2.builder$1;
      var array$2 = [key$4];
      if ((this$47.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$6 = $uI(array$2.length);
      var newSize$2 = ((this$47.size0$6 + len$6) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$47, newSize$2);
      var len$7 = this$47.size0$6;
      var src$2 = this$47.array$6;
      var dest$2 = this$47.array$6;
      $systemArraycopy(src$2, 0, dest$2, len$6, len$7);
      var xs$2 = this$47.array$6;
      var len$8 = xs$2.u.length;
      var i$3 = 0;
      var j$2 = 0;
      var x$4 = $uI(array$2.length);
      var x$5 = ((x$4 < len$8) ? x$4 : len$8);
      var that$2 = xs$2.u.length;
      var end$2 = ((x$5 < that$2) ? x$5 : that$2);
      while ((i$3 < end$2)) {
        var jsx$7 = j$2;
        var index$2 = i$3;
        xs$2.set(jsx$7, array$2[index$2]);
        i$3 = ((1 + i$3) | 0);
        j$2 = ((1 + j$2) | 0)
      };
      this$47.size0$6 = newSize$2;
      b$3.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$2.builder$1));
      jsx$8.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$3.builder$1, sourceName$2), $m_Lorg_yaml_model_YType$().Map$1));
      break matchEnd21
    };
    if ((parsedPath instanceof $c_Lamf_core_validation_model_AlternatePath)) {
      var x12 = $as_Lamf_core_validation_model_AlternatePath(parsedPath);
      var elements$2 = x12.elements$2;
      var uri$4 = (base + "_alt");
      var jsx$14 = b.builder$1;
      var sourceName$4 = b.sourceName$2;
      var b$5 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$4);
      $m_Lorg_yaml_model_YNode$();
      var this$59 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      var str$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$59, "alternativePath").iri__T();
      var key$5 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$2);
      var v$3 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$5.sourceName$2);
      var jsx$12 = v$3.builder$1;
      var sourceName$5 = v$3.sourceName$2;
      var b$6 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$5);
      $m_Lorg_yaml_model_YNode$();
      var key$6 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@list");
      var v$4 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$6.sourceName$2);
      var jsx$10 = v$4.builder$1;
      var sourceName$6 = v$4.sourceName$2;
      var b$7 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$6);
      var this$65 = $m_sci_List$();
      var bf$1 = this$65.ReusableCBFInstance$2;
      var this$66 = $as_sci_List($f_sc_IterableLike__zipWithIndex__scg_CanBuildFrom__O(elements$2, bf$1));
      var these$1 = this$66;
      while ((!these$1.isEmpty__Z())) {
        var arg1$1 = these$1.head__O();
        var x0$2 = $as_T2(arg1$1);
        if ((x0$2 !== null)) {
          var e$1 = $as_Lamf_core_validation_model_PropertyPath(x0$2.$$und1__O());
          var i$4 = x0$2.$$und2$mcI$sp__I();
          this.emitPath__Lorg_yaml_model_YDocument$PartBuilder__T__Lamf_core_validation_model_PropertyPath__V(b$7, (uri$4 + i$4), e$1)
        } else {
          throw new $c_s_MatchError().init___O(x0$2)
        };
        these$1 = $as_sci_List(these$1.tail__O())
      };
      var jsx$9 = $m_Lorg_yaml_model_YNode$();
      $m_Lorg_yaml_model_YSequence$();
      var loc$1 = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$6);
      var parts$1 = b$7.builder$1;
      var node$1 = jsx$9.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc$1, parts$1), $m_Lorg_yaml_model_YType$().Seq$1);
      jsx$10.$$plus$eq__O__scm_ArrayBuffer(node$1);
      var this$70 = v$4.builder$1;
      var array$3 = [key$6];
      if ((this$70.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$9 = $uI(array$3.length);
      var newSize$3 = ((this$70.size0$6 + len$9) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$70, newSize$3);
      var len$10 = this$70.size0$6;
      var src$3 = this$70.array$6;
      var dest$3 = this$70.array$6;
      $systemArraycopy(src$3, 0, dest$3, len$9, len$10);
      var xs$3 = this$70.array$6;
      var len$11 = xs$3.u.length;
      var i$5 = 0;
      var j$3 = 0;
      var x$6 = $uI(array$3.length);
      var x$7 = ((x$6 < len$11) ? x$6 : len$11);
      var that$3 = xs$3.u.length;
      var end$3 = ((x$7 < that$3) ? x$7 : that$3);
      while ((i$5 < end$3)) {
        var jsx$11 = j$3;
        var index$3 = i$5;
        xs$3.set(jsx$11, array$3[index$3]);
        i$5 = ((1 + i$5) | 0);
        j$3 = ((1 + j$3) | 0)
      };
      this$70.size0$6 = newSize$3;
      b$6.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$4.builder$1));
      jsx$12.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$6.builder$1, sourceName$5), $m_Lorg_yaml_model_YType$().Map$1));
      var this$83 = v$3.builder$1;
      var array$4 = [key$5];
      if ((this$83.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$12 = $uI(array$4.length);
      var newSize$4 = ((this$83.size0$6 + len$12) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$83, newSize$4);
      var len$13 = this$83.size0$6;
      var src$4 = this$83.array$6;
      var dest$4 = this$83.array$6;
      $systemArraycopy(src$4, 0, dest$4, len$12, len$13);
      var xs$4 = this$83.array$6;
      var len$14 = xs$4.u.length;
      var i$6 = 0;
      var j$4 = 0;
      var x$8 = $uI(array$4.length);
      var x$9 = ((x$8 < len$14) ? x$8 : len$14);
      var that$4 = xs$4.u.length;
      var end$4 = ((x$9 < that$4) ? x$9 : that$4);
      while ((i$6 < end$4)) {
        var jsx$13 = j$4;
        var index$4 = i$6;
        xs$4.set(jsx$13, array$4[index$4]);
        i$6 = ((1 + i$6) | 0);
        j$4 = ((1 + j$4) | 0)
      };
      this$83.size0$6 = newSize$4;
      b$5.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$3.builder$1));
      jsx$14.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$5.builder$1, sourceName$4), $m_Lorg_yaml_model_YType$().Map$1));
      break matchEnd21
    };
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot emit path, unsupported type of path token " + parsedPath)))
  }
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype.amf$plugins$features$validation$emitters$ValidationJSONLDEmitter$$genValue__Lorg_yaml_model_YDocument$PartBuilder__T__s_Option__V = (function(b, s, dType) {
  if ((dType instanceof $c_s_Some)) {
    var x2 = $as_s_Some(dType);
    var dt = $as_T(x2.value$2);
    var jsx$1 = b.builder$1;
    var sourceName = b.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@value");
    $m_Lorg_yaml_model_YNode$();
    var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(s);
    b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value);
    $m_Lorg_yaml_model_YNode$();
    var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@type");
    $m_Lorg_yaml_model_YNode$();
    var value$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(dt);
    b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$1, value$1);
    jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  } else {
    var x = $m_s_None$();
    if ((x === dType)) {
      if ((s === null)) {
        throw new $c_jl_NullPointerException().init___()
      };
      if ($m_ju_regex_Pattern$().matches__T__jl_CharSequence__Z("^-?[1-9]\\d*$|^0$", s)) {
        var jsx$3 = b.builder$1;
        var sourceName$1 = b.sourceName$2;
        var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
        $m_Lorg_yaml_model_YNode$();
        var key$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@value");
        var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$2.sourceName$2);
        $m_Lamf_core_emitter_BaseEmitters_package$().raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(v, s, $m_Lorg_yaml_model_YType$().Int$1);
        var this$11 = v.builder$1;
        var array = [key$2];
        if ((this$11.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len = $uI(array.length);
        var newSize = ((this$11.size0$6 + len) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$11, newSize);
        var len$1 = this$11.size0$6;
        var src = this$11.array$6;
        var dest = this$11.array$6;
        $systemArraycopy(src, 0, dest, len, len$1);
        var xs = this$11.array$6;
        var len$2 = xs.u.length;
        var i = 0;
        var j = 0;
        var x$1 = $uI(array.length);
        var x$2 = ((x$1 < len$2) ? x$1 : len$2);
        var that = xs.u.length;
        var end = ((x$2 < that) ? x$2 : that);
        while ((i < end)) {
          var jsx$2 = j;
          var index = i;
          xs.set(jsx$2, array[index]);
          i = ((1 + i) | 0);
          j = ((1 + j) | 0)
        };
        this$11.size0$6 = newSize;
        b$2.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1));
        jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1))
      } else if (((s === "true") || (s === "false"))) {
        var jsx$5 = b.builder$1;
        var sourceName$2 = b.sourceName$2;
        var b$3 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$2);
        $m_Lorg_yaml_model_YNode$();
        var key$3 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@value");
        var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$3.sourceName$2);
        $m_Lamf_core_emitter_BaseEmitters_package$().raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(v$1, s, $m_Lorg_yaml_model_YType$().Bool$1);
        var this$26 = v$1.builder$1;
        var array$1 = [key$3];
        if ((this$26.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len$3 = $uI(array$1.length);
        var newSize$1 = ((this$26.size0$6 + len$3) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$26, newSize$1);
        var len$4 = this$26.size0$6;
        var src$1 = this$26.array$6;
        var dest$1 = this$26.array$6;
        $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
        var xs$1 = this$26.array$6;
        var len$5 = xs$1.u.length;
        var i$1 = 0;
        var j$1 = 0;
        var x$3 = $uI(array$1.length);
        var x$4 = ((x$3 < len$5) ? x$3 : len$5);
        var that$1 = xs$1.u.length;
        var end$1 = ((x$4 < that$1) ? x$4 : that$1);
        while ((i$1 < end$1)) {
          var jsx$4 = j$1;
          var index$1 = i$1;
          xs$1.set(jsx$4, array$1[index$1]);
          i$1 = ((1 + i$1) | 0);
          j$1 = ((1 + j$1) | 0)
        };
        this$26.size0$6 = newSize$1;
        b$3.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1));
        jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$3.builder$1, sourceName$2), $m_Lorg_yaml_model_YType$().Map$1))
      } else if (($m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType(s).iri__T() === $m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType("amf-parser:NonEmptyList").iri__T())) {
        this.genNonEmptyList__p1__Lorg_yaml_model_YDocument$PartBuilder__V(b)
      } else if ((((($uI(s.length) >= 0) && ($as_T(s.substring(0, $uI("http://".length))) === "http://")) || (($uI(s.length) >= 0) && ($as_T(s.substring(0, $uI("https://".length))) === "https://"))) || (($uI(s.length) >= 0) && ($as_T(s.substring(0, $uI("file:".length))) === "file:")))) {
        $m_Lamf_core_emitter_BaseEmitters_package$().link__Lorg_yaml_model_YDocument$PartBuilder__T__V(b, s)
      } else {
        var jsx$6 = b.builder$1;
        var sourceName$3 = b.sourceName$2;
        var b$4 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$3);
        $m_Lorg_yaml_model_YNode$();
        var key$4 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@value");
        $m_Lorg_yaml_model_YNode$();
        var value$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(s);
        b$4.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$4, value$2);
        jsx$6.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$4.builder$1, sourceName$3), $m_Lorg_yaml_model_YType$().Map$1))
      }
    } else {
      throw new $c_s_MatchError().init___O(dType)
    }
  }
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype.genJSConstraint__p1__T__Lamf_core_validation_core_FunctionConstraint__scm_ListBuffer = (function(validationId, f) {
  var constraintId = f.constraintId__T__T(validationId);
  var validatorId = f.validatorId__T__T(validationId);
  var validatorPath = f.validatorPath__T__T(validationId);
  return this.jsConstraintEmitters$1.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$1().init___Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter__T__Lamf_core_validation_core_FunctionConstraint__T__T(this, constraintId, f, validatorPath, validatorId))
});
var $d_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter = new $TypeData().initClass({
  Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter: 0
}, false, "amf.plugins.features.validation.emitters.ValidationJSONLDEmitter", {
  Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter: 1,
  O: 1
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter.prototype.$classData = $d_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter;
/** @constructor */
function $c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$() {
  $c_O.call(this)
}
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$.prototype = new $h_O();
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$.prototype.constructor = $c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$;
/** @constructor */
function $h_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$.prototype = $c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$.prototype;
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$.prototype.validationLibraryUrl__T = (function() {
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().AmfParser$1;
  return new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "validationLibrary.js").iri__T()
});
var $d_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$ = new $TypeData().initClass({
  Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$: 0
}, false, "amf.plugins.features.validation.emitters.ValidationJSONLDEmitter$", {
  Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$: 1,
  O: 1
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$.prototype.$classData = $d_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$;
var $n_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$ = (void 0);
function $m_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$() {
  if ((!$n_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$)) {
    $n_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$ = new $c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$().init___()
  };
  return $n_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$
}
/** @constructor */
function $c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter() {
  $c_O.call(this);
  this.targetProfile$1 = null;
  this.rdfModel$1 = null;
  this.defaultJSLibraryUrl$1 = null
}
$c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype = new $h_O();
$c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype.constructor = $c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter;
/** @constructor */
function $h_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype = $c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype;
$c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype.genValue__p1__T__T__T__s_Option__V = (function(subject, property, s, dType) {
  if ((dType instanceof $c_s_Some)) {
    var x2 = $as_s_Some(dType);
    var dt = $as_T(x2.value$2);
    this.rdfModel$1.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(subject, property, s, new $c_s_Some().init___O(dt))
  } else {
    var x = $m_s_None$();
    if ((x === dType)) {
      if ((s === null)) {
        throw new $c_jl_NullPointerException().init___()
      };
      if ($m_ju_regex_Pattern$().matches__T__jl_CharSequence__Z("^-?[1-9]\\d*$|^0$", s)) {
        this.rdfModel$1.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(subject, property, s, new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Long$1))
      } else if (((s === "true") || (s === "false"))) {
        this.rdfModel$1.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(subject, property, s, new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Boolean$1))
      } else if (($m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType(s).iri__T() === $m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType("amf-parser:NonEmptyList").iri__T())) {
        this.genNonEmptyList__p1__T__T__V(subject, property)
      } else if ((((($uI(s.length) >= 0) && ($as_T(s.substring(0, $uI("http://".length))) === "http://")) || (($uI(s.length) >= 0) && ($as_T(s.substring(0, $uI("https://".length))) === "https://"))) || (($uI(s.length) >= 0) && ($as_T(s.substring(0, $uI("file:".length))) === "file:")))) {
        this.link__T__T__T__Lamf_core_rdf_RdfModel(subject, property, s)
      } else {
        this.rdfModel$1.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(subject, property, s, $m_s_None$())
      }
    } else {
      throw new $c_s_MatchError().init___O(dType)
    }
  }
});
$c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype.isPropertyConstraintUri__p1__T__Z = (function(name) {
  return ((((($uI(name.length) >= 0) && ($as_T(name.substring(0, $uI("http://".length))) === "http://")) || (($uI(name.length) >= 0) && ($as_T(name.substring(0, $uI("https://".length))) === "https://"))) || (($uI(name.length) >= 0) && ($as_T(name.substring(0, $uI("file:".length))) === "file:"))) && ($uI(name.indexOf("/prop")) > (-1)))
});
$c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype.emitValidation__p1__Lamf_core_validation_core_ValidationSpecification__V = (function(validation) {
  var validationId = validation.id$1;
  var jsx$2 = this.rdfModel$1;
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
  var jsx$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "type").iri__T();
  var this$3 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  jsx$2.addTriple__T__T__T__Lamf_core_rdf_RdfModel(validationId, jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "NodeShape").iri__T());
  var x1 = this.targetProfile$1;
  var x = $m_Lamf_RamlProfile$();
  if (x.equals__O__Z(x1)) {
    var jsx$3 = true
  } else {
    var x$3 = $m_Lamf_Raml08Profile$();
    var jsx$3 = x$3.equals__O__Z(x1)
  };
  if (jsx$3) {
    var this$5 = validation.ramlMessage$1;
    var message = $as_T((this$5.isEmpty__Z() ? validation.message$1 : this$5.get__O()))
  } else {
    var x$5 = $m_Lamf_OasProfile$();
    if (x$5.equals__O__Z(x1)) {
      var this$6 = validation.oasMessage$1;
      var message = $as_T((this$6.isEmpty__Z() ? validation.message$1 : this$6.get__O()))
    } else {
      var message = validation.message$1
    }
  };
  if ((message !== "")) {
    var this$7 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    this.genValue__p1__T__T__T__s_Option__V(validationId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "message").iri__T(), message, $m_s_None$())
  };
  if (validation.targetInstance$1.nonEmpty__Z()) {
    $as_sc_IterableLike(validation.targetInstance$1.distinct__O()).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, validationId$1) {
      return (function(ti$2) {
        var ti = $as_T(ti$2);
        var this$9 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        return this$3$1.link__T__T__T__Lamf_core_rdf_RdfModel(validationId$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$9, "targetNode").iri__T(), this$3$1.expandRamlId__p1__T__T(ti))
      })
    })(this, validationId)))
  };
  if (validation.targetClass$1.nonEmpty__Z()) {
    validation.targetClass$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, validationId$2) {
      return (function(tc$2) {
        var tc = $as_T(tc$2);
        var this$11 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        return this$4$1.link__T__T__T__Lamf_core_rdf_RdfModel(validationId$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$11, "targetClass").iri__T(), this$4$1.expandRamlId__p1__T__T(tc))
      })
    })(this, validationId)))
  };
  var this$13 = validation.closed$1;
  if ((!this$13.isEmpty__Z())) {
    var arg1 = this$13.get__O();
    var closedShape = $uZ(arg1);
    if (closedShape) {
      var this$14 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      this.genValue__p1__T__T__T__s_Option__V(validationId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$14, "closed").iri__T(), ("" + closedShape), $m_s_None$())
    };
    new $c_s_Some().init___O((void 0))
  };
  if (validation.targetObject$1.nonEmpty__Z()) {
    validation.targetObject$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1, validationId$3) {
      return (function(to$2) {
        var to = $as_T(to$2);
        var this$17 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        return this$6$1.link__T__T__T__Lamf_core_rdf_RdfModel(validationId$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$17, "targetObjectsOf").iri__T(), this$6$1.expandRamlId__p1__T__T(to))
      })
    })(this, validationId)))
  };
  if (validation.unionConstraints$1.nonEmpty__Z()) {
    var unionConstraintListId = this.emitList__sc_Seq__F3__T(validation.unionConstraints$1, new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function(this$7$1) {
      return (function(subject$2, property$2, objId$2) {
        var subject = $as_T(subject$2);
        var property = $as_T(property$2);
        var objId = $as_T(objId$2);
        this$7$1.link__T__T__T__Lamf_core_rdf_RdfModel(subject, property, objId)
      })
    })(this)));
    var jsx$4 = this.rdfModel$1;
    var this$19 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    jsx$4.addTriple__T__T__T__Lamf_core_rdf_RdfModel(validationId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$19, "or").iri__T(), unionConstraintListId)
  };
  if (validation.andConstraints$1.nonEmpty__Z()) {
    var andConstraintListId = this.emitList__sc_Seq__F3__T(validation.andConstraints$1, new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function(this$8$1) {
      return (function(subject$3$2, property$3$2, objId$3$2) {
        var subject$3 = $as_T(subject$3$2);
        var property$3 = $as_T(property$3$2);
        var objId$3 = $as_T(objId$3$2);
        this$8$1.link__T__T__T__Lamf_core_rdf_RdfModel(subject$3, property$3, objId$3)
      })
    })(this)));
    var jsx$5 = this.rdfModel$1;
    var this$21 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    jsx$5.addTriple__T__T__T__Lamf_core_rdf_RdfModel(validationId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$21, "and").iri__T(), andConstraintListId)
  };
  if (validation.xoneConstraints$1.nonEmpty__Z()) {
    var xoneConstraintListId = this.emitList__sc_Seq__F3__T(validation.xoneConstraints$1, new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function(this$9$1) {
      return (function(subject$4$2, property$4$2, objId$4$2) {
        var subject$4 = $as_T(subject$4$2);
        var property$4 = $as_T(property$4$2);
        var objId$4 = $as_T(objId$4$2);
        this$9$1.link__T__T__T__Lamf_core_rdf_RdfModel(subject$4, property$4, objId$4)
      })
    })(this)));
    var jsx$6 = this.rdfModel$1;
    var this$23 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    jsx$6.addTriple__T__T__T__Lamf_core_rdf_RdfModel(validationId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$23, "xone").iri__T(), xoneConstraintListId)
  };
  if (validation.notConstraint$1.isDefined__Z()) {
    var this$25 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    this.link__T__T__T__Lamf_core_rdf_RdfModel(validationId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$25, "not").iri__T(), $as_T(validation.notConstraint$1.get__O()))
  };
  if (validation.query$1.isDefined__Z()) {
    var queryValidationId = (validationId + "/query");
    var this$27 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    this.link__T__T__T__Lamf_core_rdf_RdfModel(validationId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$27, "sparql").iri__T(), queryValidationId);
    var jsx$7 = this.rdfModel$1;
    var this$29 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    jsx$7.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(queryValidationId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$29, "message").iri__T(), validation.message$1, new $c_s_Some().init___O($m_Lamf_core_model_DataType$().String$1));
    var jsx$8 = this.rdfModel$1;
    var this$31 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    jsx$8.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(queryValidationId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$31, "select").iri__T(), $as_Lamf_core_validation_core_QueryConstraint(validation.query$1.get__O()).query$1, new $c_s_Some().init___O($m_Lamf_core_model_DataType$().String$1));
    var ontologyId = (validationId + "/query/ontology");
    var jsx$9 = this.rdfModel$1;
    var this$33 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    jsx$9.addTriple__T__T__T__Lamf_core_rdf_RdfModel(queryValidationId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$33, "prefixes").iri__T(), ontologyId);
    $as_Lamf_core_validation_core_QueryConstraint(validation.query$1.get__O()).prefixes$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$10$1, ontologyId$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_T2(x0$1$2);
        if ((x0$1 !== null)) {
          var alias = $as_T(x0$1.$$und1__O());
          var ns = $as_T(x0$1.$$und2__O());
          var declarationId = this$10$1.rdfModel$1.nextAnonId__T();
          var jsx$10 = this$10$1.rdfModel$1;
          var this$35 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
          jsx$10.addTriple__T__T__T__Lamf_core_rdf_RdfModel(ontologyId$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$35, "declare").iri__T(), declarationId);
          var jsx$11 = this$10$1.rdfModel$1;
          var this$37 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
          jsx$11.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(declarationId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$37, "prefix").iri__T(), alias, new $c_s_Some().init___O($m_Lamf_core_model_DataType$().AnyUri$1));
          var jsx$12 = this$10$1.rdfModel$1;
          var this$39 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
          return jsx$12.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(declarationId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$39, "namespace").iri__T(), ns, new $c_s_Some().init___O($m_Lamf_core_model_DataType$().String$1))
        } else {
          throw new $c_s_MatchError().init___O(x0$1)
        }
      })
    })(this, ontologyId)))
  };
  var x1$2 = validation.functionConstraint$1;
  if ((x1$2 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1$2);
    var f = $as_Lamf_core_validation_core_FunctionConstraint(x2.value$2);
    this.emitFunctionConstraint__p1__T__Lamf_core_validation_core_FunctionConstraint__V(validationId, f)
  };
  var this$41 = validation.nodeConstraints$1.groupBy__F1__sci_Map(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$11$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_validation_core_NodeConstraint(x$1$2);
      return x$1.constraint$1
    })
  })(this)));
  var p = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$12$1) {
    return (function(check$ifrefutable$1$2) {
      var check$ifrefutable$1 = $as_T2(check$ifrefutable$1$2);
      return (check$ifrefutable$1 !== null)
    })
  })(this));
  var jsx$14 = new $c_sc_TraversableLike$WithFilter().init___sc_TraversableLike__F1(this$41, p);
  var jsx$13 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$13$1, validationId$4) {
    return (function(x$2$2$2) {
      var x$2$2 = $as_T2(x$2$2$2);
      if ((x$2$2 !== null)) {
        var constraint = $as_T(x$2$2.$$und1__O());
        var values = $as_sc_Seq(x$2$2.$$und2__O());
        values.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, validationId$1$1, constraint$1) {
          return (function(v$2) {
            var v = $as_Lamf_core_validation_core_NodeConstraint(v$2);
            return $this.link__T__T__T__Lamf_core_rdf_RdfModel(validationId$1$1, $m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType(constraint$1).iri__T(), $m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType(v.value$1).iri__T())
          })
        })(this$13$1, validationId$4, constraint)))
      } else {
        throw new $c_s_MatchError().init___O(x$2$2)
      }
    })
  })(this, validationId));
  var this$42 = $m_sci_Iterable$();
  jsx$14.map__F1__scg_CanBuildFrom__O(jsx$13, this$42.ReusableCBFInstance$2);
  if (validation.propertyConstraints$1.nonEmpty__Z()) {
    var jsx$19 = validation.propertyConstraints$1;
    var this$43 = $m_sc_Seq$();
    var jsx$18 = $as_sc_TraversableLike(jsx$19.zipWithIndex__scg_CanBuildFrom__O(this$43.ReusableCBFInstance$2)).withFilter__F1__scg_FilterMonadic(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$14$1) {
      return (function(check$ifrefutable$2$2) {
        var check$ifrefutable$2 = $as_T2(check$ifrefutable$2$2);
        return (check$ifrefutable$2 !== null)
      })
    })(this)));
    var jsx$15 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$15$1, validationId$5) {
      return (function(x$3$2$2) {
        var x$3$2 = $as_T2(x$3$2$2);
        if ((x$3$2 !== null)) {
          var constraint$2 = $as_Lamf_core_validation_core_PropertyConstraint(x$3$2.$$und1__O());
          var i = x$3$2.$$und2$mcI$sp__I();
          if ((constraint$2.path$1.isEmpty__Z() && this$15$1.isPropertyConstraintUri__p1__T__Z(constraint$2.name$1))) {
            var jsx$16 = this$15$1.rdfModel$1;
            var this$44 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
            jsx$16.addTriple__T__T__T__Lamf_core_rdf_RdfModel(validationId$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$44, "property").iri__T(), constraint$2.name$1);
            this$15$1.emitConstraint__p1__T__Lamf_core_validation_core_PropertyConstraint__V(constraint$2.name$1, constraint$2)
          } else {
            var constraintId = ((validationId$5 + "/prop/") + i);
            var jsx$17 = this$15$1.rdfModel$1;
            var this$46 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
            jsx$17.addTriple__T__T__T__Lamf_core_rdf_RdfModel(validationId$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$46, "property").iri__T(), constraintId);
            this$15$1.emitConstraint__p1__T__Lamf_core_validation_core_PropertyConstraint__V(constraintId, constraint$2)
          }
        } else {
          throw new $c_s_MatchError().init___O(x$3$2)
        }
      })
    })(this, validationId));
    var this$48 = $m_sc_Seq$();
    jsx$18.map__F1__scg_CanBuildFrom__O(jsx$15, this$48.ReusableCBFInstance$2)
  }
});
$c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype.init___Lamf_ProfileName__Lamf_core_rdf_RdfModel__T = (function(targetProfile, rdfModel, defaultJSLibraryUrl) {
  this.targetProfile$1 = targetProfile;
  this.rdfModel$1 = rdfModel;
  this.defaultJSLibraryUrl$1 = defaultJSLibraryUrl;
  return this
});
$c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype.expandRamlId__p1__T__T = (function(s) {
  if ((((($uI(s.length) >= 0) && ($as_T(s.substring(0, $uI("http://".length))) === "http://")) || (($uI(s.length) >= 0) && ($as_T(s.substring(0, $uI("https://".length))) === "https://"))) || (($uI(s.length) >= 0) && ($as_T(s.substring(0, $uI("file:".length))) === "file:")))) {
    return $as_T(s.trim())
  } else {
    var thiz = $m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType($as_T(s.split(".").join(":"))).iri__T();
    return $as_T(thiz.trim())
  }
});
$c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype.emitAnonList__sc_Seq__F3__T = (function(listValues, generator) {
  var elem = this.rdfModel$1.nextAnonId__T();
  var listId = new $c_sr_ObjectRef().init___O(elem);
  var origListId = $as_T(listId.elem$1);
  var totalElements = listValues.length__I();
  var this$2 = $m_sc_Seq$();
  $as_sc_IterableLike(listValues.zipWithIndex__scg_CanBuildFrom__O(this$2.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, generator$1, listId$1, totalElements$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var value = $as_T(x0$1.$$und1__O());
        var i = x0$1.$$und2$mcI$sp__I();
        var jsx$1 = $as_T(listId$1.elem$1);
        var this$3 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
        generator$1.apply__O__O__O__O(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "first").iri__T(), value);
        if ((i < (((-1) + totalElements$1) | 0))) {
          var nextListId = $this.rdfModel$1.nextAnonId__T();
          var jsx$2 = $as_T(listId$1.elem$1);
          var this$5 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
          $this.link__T__T__T__Lamf_core_rdf_RdfModel(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$5, "rest").iri__T(), nextListId);
          listId$1.elem$1 = nextListId;
          return (void 0)
        } else {
          var jsx$4 = $as_T(listId$1.elem$1);
          var this$7 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
          var jsx$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "rest").iri__T();
          var this$9 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
          return $this.link__T__T__T__Lamf_core_rdf_RdfModel(jsx$4, jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$9, "nil").iri__T())
        }
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, generator, listId, totalElements)));
  return origListId
});
$c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype.emitList__sc_Seq__F3__T = (function(listValues, generator) {
  var baseListId = this.rdfModel$1.nextAnonId__T();
  var listId = new $c_sr_ObjectRef().init___O(baseListId);
  var origListId = $as_T(listId.elem$1);
  var totalElements = listValues.length__I();
  var this$2 = $m_sc_Seq$();
  $as_sc_IterableLike(listValues.zipWithIndex__scg_CanBuildFrom__O(this$2.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, generator$1, listId$1, totalElements$1, baseListId$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var value = $as_T(x0$1.$$und1__O());
        var i = x0$1.$$und2$mcI$sp__I();
        var jsx$1 = $as_T(listId$1.elem$1);
        var this$3 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
        generator$1.apply__O__O__O__O(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "first").iri__T(), value);
        if ((i < (((-1) + totalElements$1) | 0))) {
          var nextListId = ((baseListId$1 + "_") + i);
          var jsx$2 = $as_T(listId$1.elem$1);
          var this$5 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
          $this.link__T__T__T__Lamf_core_rdf_RdfModel(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$5, "rest").iri__T(), nextListId);
          listId$1.elem$1 = nextListId;
          return (void 0)
        } else {
          var jsx$4 = $as_T(listId$1.elem$1);
          var this$7 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
          var jsx$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "rest").iri__T();
          var this$9 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
          return $this.link__T__T__T__Lamf_core_rdf_RdfModel(jsx$4, jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$9, "nil").iri__T())
        }
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, generator, listId, totalElements, baseListId)));
  return origListId
});
$c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype.assertPropertyPath__T__Lamf_core_validation_core_PropertyConstraint__V = (function(constraintId, constraint) {
  var parsedPath = $as_Lamf_core_validation_model_PropertyPath(constraint.path$1.get__O());
  var pathId = this.buildPath__T__Lamf_core_validation_model_PropertyPath__T((constraintId + "_path"), parsedPath);
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.link__T__T__T__Lamf_core_rdf_RdfModel(constraintId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "path").iri__T(), pathId)
});
$c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype.emit__sc_Seq__V = (function(validations) {
  validations.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(validation$2) {
      var validation = $as_Lamf_core_validation_core_ValidationSpecification(validation$2);
      $this.emitValidation__p1__Lamf_core_validation_core_ValidationSpecification__V(validation)
    })
  })(this)))
});
$c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype.buildPath__T__Lamf_core_validation_model_PropertyPath__T = (function(base, parsedPath) {
  var rc20 = false;
  var x2 = null;
  if ((parsedPath instanceof $c_Lamf_core_validation_model_PredicatePath)) {
    rc20 = true;
    x2 = $as_Lamf_core_validation_model_PredicatePath(parsedPath);
    var p = x2.property$2;
    var p3 = x2.inverse$2;
    var p4 = x2.zeroOrMore$2;
    if (((p3 === false) && (p4 === false))) {
      return p
    }
  };
  if (rc20) {
    var p$2 = x2.property$2;
    var p6 = x2.inverse$2;
    var p7 = x2.zeroOrMore$2;
    if (((p6 === true) && (p7 === false))) {
      var uri = (base + "_neg");
      var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      this.link__T__T__T__Lamf_core_rdf_RdfModel(uri, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "inversePath").iri__T(), p$2);
      return uri
    }
  };
  if (rc20) {
    var p$3 = x2.property$2;
    var p9 = x2.inverse$2;
    var p10 = x2.zeroOrMore$2;
    if (((p9 === false) && (p10 === true))) {
      var uri$2 = (base + "_neg");
      var this$3 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      this.link__T__T__T__Lamf_core_rdf_RdfModel(uri$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "zeroOrMorePath").iri__T(), p$3);
      return uri$2
    }
  };
  if ((parsedPath instanceof $c_Lamf_core_validation_model_SequencePath)) {
    var x11 = $as_Lamf_core_validation_model_SequencePath(parsedPath);
    var elements = x11.elements$2;
    var uri$3 = (base + "_seq");
    var this$5 = $m_sci_List$();
    var bf = this$5.ReusableCBFInstance$2;
    var this$7 = $as_sci_List($f_sc_IterableLike__zipWithIndex__scg_CanBuildFrom__O(elements, bf));
    var f = (function($this, uri$3$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_T2(x0$1$2);
        if ((x0$1 !== null)) {
          var path = $as_Lamf_core_validation_model_PropertyPath(x0$1.$$und1__O());
          var i = x0$1.$$und2$mcI$sp__I();
          return $this.buildPath__T__Lamf_core_validation_model_PropertyPath__T((("" + uri$3$1) + i), path)
        } else {
          throw new $c_s_MatchError().init___O(x0$1)
        }
      })
    })(this, uri$3);
    var this$6 = $m_sci_List$();
    var bf$1 = this$6.ReusableCBFInstance$2;
    if ((bf$1 === $m_sci_List$().ReusableCBFInstance$2)) {
      if ((this$7 === $m_sci_Nil$())) {
        var jsx$1 = $m_sci_Nil$()
      } else {
        var arg1 = this$7.head__O();
        var h = new $c_sci_$colon$colon().init___O__sci_List(f(arg1), $m_sci_Nil$());
        var t = h;
        var rest = $as_sci_List(this$7.tail__O());
        while ((rest !== $m_sci_Nil$())) {
          var arg1$1 = rest.head__O();
          var nx = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$1), $m_sci_Nil$());
          t.tl$5 = nx;
          t = nx;
          rest = $as_sci_List(rest.tail__O())
        };
        var jsx$1 = h
      }
    } else {
      var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$7, bf$1);
      var these = this$7;
      while ((!these.isEmpty__Z())) {
        var arg1$2 = these.head__O();
        b.$$plus$eq__O__scm_Builder(f(arg1$2));
        these = $as_sci_List(these.tail__O())
      };
      var jsx$1 = b.result__O()
    };
    var nestedIds = $as_sci_List(jsx$1);
    return this.emitAnonList__sc_Seq__F3__T(nestedIds, new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function(this$2$1) {
      return (function(subject$2, property$2, objId$2) {
        var subject = $as_T(subject$2);
        var property = $as_T(property$2);
        var objId = $as_T(objId$2);
        this$2$1.link__T__T__T__Lamf_core_rdf_RdfModel(subject, property, objId)
      })
    })(this)))
  };
  if ((parsedPath instanceof $c_Lamf_core_validation_model_AlternatePath)) {
    var x12 = $as_Lamf_core_validation_model_AlternatePath(parsedPath);
    var elements$2 = x12.elements$2;
    var uri$4 = (base + "_alt");
    var this$8 = $m_sci_List$();
    var bf$2 = this$8.ReusableCBFInstance$2;
    var this$10 = $as_sci_List($f_sc_IterableLike__zipWithIndex__scg_CanBuildFrom__O(elements$2, bf$2));
    var f$1 = (function(this$3$1, uri$4$1) {
      return (function(x0$2$2) {
        var x0$2 = $as_T2(x0$2$2);
        if ((x0$2 !== null)) {
          var path$1 = $as_Lamf_core_validation_model_PropertyPath(x0$2.$$und1__O());
          var i$1 = x0$2.$$und2$mcI$sp__I();
          return this$3$1.buildPath__T__Lamf_core_validation_model_PropertyPath__T((("" + uri$4$1) + i$1), path$1)
        } else {
          throw new $c_s_MatchError().init___O(x0$2)
        }
      })
    })(this, uri$4);
    var this$9 = $m_sci_List$();
    var bf$3 = this$9.ReusableCBFInstance$2;
    if ((bf$3 === $m_sci_List$().ReusableCBFInstance$2)) {
      if ((this$10 === $m_sci_Nil$())) {
        var jsx$2 = $m_sci_Nil$()
      } else {
        var arg1$3 = this$10.head__O();
        var h$1 = new $c_sci_$colon$colon().init___O__sci_List(f$1(arg1$3), $m_sci_Nil$());
        var t$1 = h$1;
        var rest$1 = $as_sci_List(this$10.tail__O());
        while ((rest$1 !== $m_sci_Nil$())) {
          var arg1$4 = rest$1.head__O();
          var nx$1 = new $c_sci_$colon$colon().init___O__sci_List(f$1(arg1$4), $m_sci_Nil$());
          t$1.tl$5 = nx$1;
          t$1 = nx$1;
          rest$1 = $as_sci_List(rest$1.tail__O())
        };
        var jsx$2 = h$1
      }
    } else {
      var b$1 = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$10, bf$3);
      var these$1 = this$10;
      while ((!these$1.isEmpty__Z())) {
        var arg1$5 = these$1.head__O();
        b$1.$$plus$eq__O__scm_Builder(f$1(arg1$5));
        these$1 = $as_sci_List(these$1.tail__O())
      };
      var jsx$2 = b$1.result__O()
    };
    var nestedIds$2 = $as_sci_List(jsx$2);
    var listId = this.emitAnonList__sc_Seq__F3__T(nestedIds$2, new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function(this$4$1) {
      return (function(subject$3$2, property$3$2, objId$3$2) {
        var subject$3 = $as_T(subject$3$2);
        var property$3 = $as_T(property$3$2);
        var objId$3 = $as_T(objId$3$2);
        this$4$1.link__T__T__T__Lamf_core_rdf_RdfModel(subject$3, property$3, objId$3)
      })
    })(this)));
    var altId = this.rdfModel$1.nextAnonId__T();
    var this$11 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    this.link__T__T__T__Lamf_core_rdf_RdfModel(altId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$11, "alternativePath").iri__T(), listId);
    return altId
  };
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannote emit path, unsupported type of path token " + parsedPath)))
});
$c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype.link__T__T__T__Lamf_core_rdf_RdfModel = (function(subject, property, objId) {
  return this.rdfModel$1.addTriple__T__T__T__Lamf_core_rdf_RdfModel(subject, property, objId)
});
$c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype.genNumericPropertyConstraintValue__p1__T__T__T__s_Option__V = (function(constraintId, constraintName, value, constraint) {
  var rc7 = false;
  var x2 = null;
  if (constraint.isEmpty__Z()) {
    var x1 = $m_s_None$()
  } else {
    var arg1 = constraint.get__O();
    var x$17 = $as_Lamf_core_validation_core_PropertyConstraint(arg1);
    var x1 = x$17.datatype$1
  };
  matchEnd8: {
    if ((x1 instanceof $c_s_Some)) {
      rc7 = true;
      x2 = $as_s_Some(x1);
      var scalarType = $as_T(x2.value$2);
      if (((scalarType === $m_Lamf_core_model_DataType$().Number$1) || (scalarType === $m_Lamf_core_model_DataType$().Double$1))) {
        var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        var jsx$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, constraintName).iri__T();
        var this$4 = new $c_sci_StringOps().init___T(value);
        var jsx$1 = $m_jl_Double$();
        var $$this = this$4.repr$1;
        var this$6 = jsx$1.parseDouble__T__D($$this);
        this.genValue__p1__T__T__T__s_Option__V(constraintId, jsx$2, ("" + this$6), new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Double$1));
        break matchEnd8
      }
    };
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$8 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      var jsx$4 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$8, constraintName).iri__T();
      var this$11 = new $c_sci_StringOps().init___T(value);
      var jsx$3 = $m_jl_Double$();
      var $$this$1 = this$11.repr$1;
      var this$13 = jsx$3.parseDouble__T__D($$this$1);
      this.genValue__p1__T__T__T__s_Option__V(constraintId, jsx$4, ("" + this$13), new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Double$1));
      break matchEnd8
    };
    if (rc7) {
      var scalarType$2 = $as_T(x2.value$2);
      if ((scalarType$2 === $m_Lamf_core_model_DataType$().Float$1)) {
        var this$15 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        var jsx$6 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$15, constraintName).iri__T();
        var this$18 = new $c_sci_StringOps().init___T(value);
        var jsx$5 = $m_jl_Double$();
        var $$this$2 = this$18.repr$1;
        var this$20 = jsx$5.parseDouble__T__D($$this$2);
        this.genValue__p1__T__T__T__s_Option__V(constraintId, jsx$6, ("" + this$20), new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Float$1));
        break matchEnd8
      }
    };
    if (rc7) {
      var scalarType$3 = $as_T(x2.value$2);
      if ((scalarType$3 === $m_Lamf_core_model_DataType$().Integer$1)) {
        var jsx$7 = true
      } else {
        var this$22 = $m_Lamf_core_vocabulary_Namespace$().Xsd$1;
        var jsx$7 = (scalarType$3 === new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$22, "long").iri__T())
      };
      if (jsx$7) {
        var this$24 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        var jsx$9 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$24, constraintName).iri__T();
        var this$27 = new $c_sci_StringOps().init___T(value);
        var jsx$8 = $m_jl_Double$();
        var $$this$3 = this$27.repr$1;
        var x$1 = jsx$8.parseDouble__T__D($$this$3);
        var this$33 = $doubleToInt($uD($g.Math.floor(x$1)));
        this.genValue__p1__T__T__T__s_Option__V(constraintId, jsx$9, ("" + this$33), new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Long$1));
        break matchEnd8
      }
    }
  }
});
$c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype.genNonEmptyList__p1__T__T__V = (function(subject, property) {
  var listId = this.rdfModel$1.nextAnonId__T();
  var listIdConstraint = (listId + "_c");
  var jsx$2 = this.rdfModel$1;
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
  var jsx$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "type").iri__T();
  var this$3 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  jsx$2.addTriple__T__T__T__Lamf_core_rdf_RdfModel(listId, jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "NodeShape").iri__T());
  var jsx$3 = this.rdfModel$1;
  var this$5 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  jsx$3.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(listId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$5, "message").iri__T(), "List cannot be empty", $m_s_None$());
  var jsx$4 = this.rdfModel$1;
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  jsx$4.addTriple__T__T__T__Lamf_core_rdf_RdfModel(listId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "property").iri__T(), listIdConstraint);
  var jsx$6 = this.rdfModel$1;
  var this$9 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var jsx$5 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$9, "path").iri__T();
  var this$11 = $m_Lamf_core_vocabulary_Namespace$().Rdfs$1;
  jsx$6.addTriple__T__T__T__Lamf_core_rdf_RdfModel(listIdConstraint, jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$11, "_1").iri__T());
  var jsx$7 = this.rdfModel$1;
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  jsx$7.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(listIdConstraint, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "minCount").iri__T(), "1", new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Integer$1))
});
$c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype.emitConstraint__p1__T__Lamf_core_validation_core_PropertyConstraint__V = (function(constraintId, constraint) {
  if ($m_s_Option$().apply__O__s_Option(constraint.ramlPropertyId$1).isDefined__Z()) {
    if (constraint.path$1.isDefined__Z()) {
      this.assertPropertyPath__T__Lamf_core_validation_core_PropertyConstraint__V(constraintId, constraint)
    } else {
      var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      this.link__T__T__T__Lamf_core_rdf_RdfModel(constraintId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "path").iri__T(), this.expandRamlId__p1__T__T(constraint.ramlPropertyId$1))
    };
    var this$3 = constraint.maxCount$1;
    if ((!this$3.isEmpty__Z())) {
      var arg1 = this$3.get__O();
      var x$4 = $as_T(arg1);
      this.genPropertyConstraintValue__p1__T__T__T__s_Option__V(constraintId, "maxCount", x$4, new $c_s_Some().init___O(constraint))
    };
    var this$4 = constraint.minCount$1;
    if ((!this$4.isEmpty__Z())) {
      var arg1$1 = this$4.get__O();
      var x$5 = $as_T(arg1$1);
      this.genPropertyConstraintValue__p1__T__T__T__s_Option__V(constraintId, "minCount", x$5, new $c_s_Some().init___O(constraint))
    };
    var this$5 = constraint.maxLength$1;
    if ((!this$5.isEmpty__Z())) {
      var arg1$2 = this$5.get__O();
      var x$6 = $as_T(arg1$2);
      this.genPropertyConstraintValue__p1__T__T__T__s_Option__V(constraintId, "maxLength", x$6, new $c_s_Some().init___O(constraint))
    };
    var this$6 = constraint.minLength$1;
    if ((!this$6.isEmpty__Z())) {
      var arg1$3 = this$6.get__O();
      var x$7 = $as_T(arg1$3);
      this.genPropertyConstraintValue__p1__T__T__T__s_Option__V(constraintId, "minLength", x$7, new $c_s_Some().init___O(constraint))
    };
    var this$7 = constraint.maxExclusive$1;
    if ((!this$7.isEmpty__Z())) {
      var arg1$4 = this$7.get__O();
      var x$8 = $as_T(arg1$4);
      this.genNumericPropertyConstraintValue__p1__T__T__T__s_Option__V(constraintId, "maxExclusive", x$8, new $c_s_Some().init___O(constraint))
    };
    var this$8 = constraint.minExclusive$1;
    if ((!this$8.isEmpty__Z())) {
      var arg1$5 = this$8.get__O();
      var x$9 = $as_T(arg1$5);
      this.genNumericPropertyConstraintValue__p1__T__T__T__s_Option__V(constraintId, "minExclusive", x$9, new $c_s_Some().init___O(constraint))
    };
    var this$9 = constraint.maxInclusive$1;
    if ((!this$9.isEmpty__Z())) {
      var arg1$6 = this$9.get__O();
      var x$10 = $as_T(arg1$6);
      this.genNumericPropertyConstraintValue__p1__T__T__T__s_Option__V(constraintId, "maxInclusive", x$10, new $c_s_Some().init___O(constraint))
    };
    var this$10 = constraint.minInclusive$1;
    if ((!this$10.isEmpty__Z())) {
      var arg1$7 = this$10.get__O();
      var x$11 = $as_T(arg1$7);
      this.genNumericPropertyConstraintValue__p1__T__T__T__s_Option__V(constraintId, "minInclusive", x$11, new $c_s_Some().init___O(constraint))
    };
    var this$11 = constraint.multipleOf$1;
    if ((!this$11.isEmpty__Z())) {
      var arg1$8 = this$11.get__O();
      var x$12 = $as_T(arg1$8);
      var this$12 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
      var constraintIri = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$12, "multipleOfValidationParam").iri__T();
      this.genValue__p1__T__T__T__s_Option__V(constraintId, constraintIri, x$12, $m_s_None$())
    };
    var this$14 = constraint.pattern$1;
    if ((!this$14.isEmpty__Z())) {
      var arg1$9 = this$14.get__O();
      var v = $as_T(arg1$9);
      this.genPropertyConstraintValue__p1__T__T__T__s_Option__V(constraintId, "pattern", v, $m_s_None$())
    };
    var this$15 = constraint.node$1;
    if ((!this$15.isEmpty__Z())) {
      var arg1$10 = this$15.get__O();
      var x$13 = $as_T(arg1$10);
      this.genPropertyConstraintValue__p1__T__T__T__s_Option__V(constraintId, "node", x$13, $m_s_None$())
    };
    var this$16 = constraint.value$1;
    if ((!this$16.isEmpty__Z())) {
      var arg1$11 = this$16.get__O();
      var x$14 = $as_T(arg1$11);
      this.genPropertyConstraintValue__p1__T__T__T__s_Option__V(constraintId, "hasValue", x$14, new $c_s_Some().init___O(constraint))
    };
    if (constraint.atLeast$1.isDefined__Z()) {
      var jsx$2 = this.rdfModel$1;
      var this$17 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      var jsx$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$17, "qualifiedMinCount").iri__T();
      var this$19 = $as_T2(constraint.atLeast$1.get__O()).$$und1$mcI$sp__I();
      var this$21 = $m_Lamf_core_vocabulary_Namespace$().Xsd$1;
      jsx$2.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(constraintId, jsx$1, ("" + this$19), new $c_s_Some().init___O(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$21, "integer").iri__T()));
      var this$23 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      this.link__T__T__T__Lamf_core_rdf_RdfModel(constraintId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$23, "qualifiedValueShape").iri__T(), $as_T($as_T2(constraint.atLeast$1.get__O()).$$und2__O()))
    };
    if (constraint.atMost$1.isDefined__Z()) {
      var jsx$4 = this.rdfModel$1;
      var this$25 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      var jsx$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$25, "qualifiedMaxCount").iri__T();
      var this$27 = $as_T2(constraint.atMost$1.get__O()).$$und1$mcI$sp__I();
      var this$29 = $m_Lamf_core_vocabulary_Namespace$().Xsd$1;
      jsx$4.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(constraintId, jsx$3, ("" + this$27), new $c_s_Some().init___O(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$29, "integer").iri__T()));
      var this$31 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      this.link__T__T__T__Lamf_core_rdf_RdfModel(constraintId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$31, "qualifiedValueShape").iri__T(), $as_T($as_T2(constraint.atMost$1.get__O()).$$und2__O()))
    };
    if (constraint.equalToProperty$1.isDefined__Z()) {
      var this$33 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      this.link__T__T__T__Lamf_core_rdf_RdfModel(constraintId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$33, "equals").iri__T(), $as_T(constraint.equalToProperty$1.get__O()))
    };
    if (constraint.disjointWithProperty$1.isDefined__Z()) {
      var this$35 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      this.link__T__T__T__Lamf_core_rdf_RdfModel(constraintId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$35, "disjoint").iri__T(), $as_T(constraint.disjointWithProperty$1.get__O()))
    };
    if (constraint.lessThanProperty$1.isDefined__Z()) {
      var this$37 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      this.link__T__T__T__Lamf_core_rdf_RdfModel(constraintId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$37, "lessThan").iri__T(), $as_T(constraint.lessThanProperty$1.get__O()))
    };
    if (constraint.lessThanOrEqualsToProperty$1.isDefined__Z()) {
      var this$39 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      this.link__T__T__T__Lamf_core_rdf_RdfModel(constraintId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$39, "lessThanOrEquals").iri__T(), $as_T(constraint.lessThanOrEqualsToProperty$1.get__O()))
    };
    var this$41 = constraint.datatype$1;
    if ((!this$41.isEmpty__Z())) {
      var arg1$12 = this$41.get__O();
      var v$3 = $as_T(arg1$12);
      if ($m_sjsr_RuntimeString$().endsWith__T__T__Z(v$3, "#integer")) {
        var this$42 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        this.link__T__T__T__Lamf_core_rdf_RdfModel(constraintId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$42, "datatype").iri__T(), $m_Lamf_core_model_DataType$().Long$1)
      } else if (((!$m_sjsr_RuntimeString$().endsWith__T__T__Z(v$3, "#float")) && (!$m_sjsr_RuntimeString$().endsWith__T__T__Z(v$3, "#number")))) {
        var this$44 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        this.link__T__T__T__Lamf_core_rdf_RdfModel(constraintId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$44, "datatype").iri__T(), v$3)
      }
    };
    if (constraint.class$1.nonEmpty__Z()) {
      if ((constraint.class$1.length__I() === 1)) {
        var this$46 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        this.link__T__T__T__Lamf_core_rdf_RdfModel(constraintId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$46, "class").iri__T(), $as_T(constraint.class$1.head__O()))
      } else {
        var classListId = this.emitList__sc_Seq__F3__T(constraint.class$1, new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function(this$14$1) {
          return (function(subject$2, property$2, objId$2) {
            var subject = $as_T(subject$2);
            var property = $as_T(property$2);
            var objId = $as_T(objId$2);
            this$14$1.link__T__T__T__Lamf_core_rdf_RdfModel(subject, property, objId)
          })
        })(this)));
        var jsx$5 = this.rdfModel$1;
        var this$48 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        jsx$5.addTriple__T__T__T__Lamf_core_rdf_RdfModel(constraintId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$48, "or").iri__T(), classListId)
      }
    };
    var this$50 = constraint.customRdf$1;
    if ((!this$50.isEmpty__Z())) {
      var arg1$13 = this$50.get__O();
      var builder = $as_F2(arg1$13);
      builder.apply__O__O__O(this.rdfModel$1, constraintId)
    };
    if (constraint.in$1.nonEmpty__Z()) {
      var inListId = this.emitList__sc_Seq__F3__T(constraint.in$1, new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function(this$16$1, constraint$1) {
        return (function(s$2, p$2, o$2) {
          var s = $as_T(s$2);
          var p = $as_T(p$2);
          var o = $as_T(o$2);
          this$16$1.genValue__p1__T__T__T__s_Option__V(s, p, o, constraint$1.datatype$1)
        })
      })(this, constraint)));
      var this$51 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      this.link__T__T__T__Lamf_core_rdf_RdfModel(constraintId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$51, "in").iri__T(), inListId)
    }
  }
});
$c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype.emitFunctionConstraint__p1__T__Lamf_core_validation_core_FunctionConstraint__V = (function(validationId, f) {
  this.genJSValidator__p1__T__Lamf_core_validation_core_FunctionConstraint__V(validationId, f);
  this.genJSConstraint__p1__T__Lamf_core_validation_core_FunctionConstraint__Lamf_core_rdf_RdfModel(validationId, f);
  this.genValue__p1__T__T__T__s_Option__V(validationId, f.validatorPath__T__T(validationId), "true", $m_s_None$())
});
$c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype.genPropertyConstraintValue__p1__T__T__T__s_Option__V = (function(constraintId, constraintName, value, constraint) {
  var rc7 = false;
  var x2 = null;
  if (constraint.isEmpty__Z()) {
    var x1 = $m_s_None$()
  } else {
    var arg1 = constraint.get__O();
    var x$15 = $as_Lamf_core_validation_core_PropertyConstraint(arg1);
    var x1 = x$15.datatype$1
  };
  matchEnd8: {
    if ((x1 instanceof $c_s_Some)) {
      rc7 = true;
      x2 = $as_s_Some(x1);
      var scalarType = $as_T(x2.value$2);
      var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
      if ((scalarType === new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "number").iri__T())) {
        var orConstraintListId = (constraintId + "_ointdoub1");
        var nextConstraintListId = (constraintId + "_ointdoub2");
        var jsx$1 = this.rdfModel$1;
        var this$3 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        jsx$1.addTriple__T__T__T__Lamf_core_rdf_RdfModel(constraintId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "or").iri__T(), orConstraintListId);
        var this$5 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
        this.link__T__T__T__Lamf_core_rdf_RdfModel(orConstraintListId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$5, "first").iri__T(), (orConstraintListId + "_v"));
        var this$7 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        var jsx$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, constraintName).iri__T();
        var this$10 = new $c_sci_StringOps().init___T(value);
        var jsx$2 = $m_jl_Double$();
        var $$this = this$10.repr$1;
        var x = jsx$2.parseDouble__T__D($$this);
        var this$16 = $doubleToInt($uD($g.Math.floor(x)));
        this.genValue__p1__T__T__T__s_Option__V((orConstraintListId + "_v"), jsx$3, ("" + this$16), new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Long$1));
        var this$18 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
        this.link__T__T__T__Lamf_core_rdf_RdfModel(orConstraintListId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$18, "rest").iri__T(), nextConstraintListId);
        var this$20 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
        this.link__T__T__T__Lamf_core_rdf_RdfModel(nextConstraintListId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$20, "first").iri__T(), (nextConstraintListId + "_v"));
        var this$22 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        var jsx$5 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$22, constraintName).iri__T();
        var this$25 = new $c_sci_StringOps().init___T(value);
        var jsx$4 = $m_jl_Double$();
        var $$this$1 = this$25.repr$1;
        var this$27 = jsx$4.parseDouble__T__D($$this$1);
        this.genValue__p1__T__T__T__s_Option__V((nextConstraintListId + "_v"), jsx$5, ("" + this$27), new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Double$1));
        var this$29 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
        var jsx$6 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$29, "rest").iri__T();
        var this$31 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
        this.link__T__T__T__Lamf_core_rdf_RdfModel(nextConstraintListId, jsx$6, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$31, "nil").iri__T());
        break matchEnd8
      }
    };
    if (rc7) {
      var this$33 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      var jsx$8 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$33, constraintName).iri__T();
      if (constraint.isEmpty__Z()) {
        var jsx$7 = $m_s_None$()
      } else {
        var arg1$1 = constraint.get__O();
        var x$16 = $as_Lamf_core_validation_core_PropertyConstraint(arg1$1);
        var jsx$7 = x$16.datatype$1
      };
      this.genValue__p1__T__T__T__s_Option__V(constraintId, jsx$8, value, jsx$7);
      break matchEnd8
    };
    var x$1 = $m_s_None$();
    if ((x$1 === x1)) {
      var this$35 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      this.genValue__p1__T__T__T__s_Option__V(constraintId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$35, constraintName).iri__T(), value, $m_s_None$());
      break matchEnd8
    };
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype.genJSValidator__p1__T__Lamf_core_validation_core_FunctionConstraint__V = (function(validationId, f) {
  var validatorId = f.validatorId__T__T(validationId);
  var jsx$2 = this.rdfModel$1;
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
  var jsx$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "type").iri__T();
  var this$3 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  jsx$2.addTriple__T__T__T__Lamf_core_rdf_RdfModel(validatorId, jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "JSValidator").iri__T());
  var this$5 = f.message$1;
  if ((!this$5.isEmpty__Z())) {
    var arg1 = this$5.get__O();
    var msg = $as_T(arg1);
    var this$6 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    this.genValue__p1__T__T__T__s_Option__V(validatorId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$6, "message").iri__T(), msg, $m_s_None$())
  };
  var libraryUrl = (validatorId + "_url");
  var this$8 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.link__T__T__T__Lamf_core_rdf_RdfModel(validatorId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$8, "jsLibrary").iri__T(), libraryUrl);
  var x1 = f.functionName$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var fnName = $as_T(x2.value$2);
    f.libraries$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, libraryUrl$1) {
      return (function(library$2) {
        var library = $as_T(library$2);
        var jsx$3 = this$2$1.rdfModel$1;
        var this$10 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        return jsx$3.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(libraryUrl$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "jsLibraryURL").iri__T(), library, new $c_s_Some().init___O("http://www.w3.org/2001/XMLSchema#anyUri"))
      })
    })(this, libraryUrl)));
    var this$12 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    this.genValue__p1__T__T__T__s_Option__V(validatorId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$12, "jsFunctionName").iri__T(), fnName, $m_s_None$())
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var x1$2 = f.code$1;
      if ((!(x1$2 instanceof $c_s_Some))) {
        throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Cannot emit validator without JS code or JS function name"))
      };
      var jsx$6 = $m_sc_Seq$();
      var array = [this.defaultJSLibraryUrl$1];
      var jsx$5 = $as_sc_TraversableLike(jsx$6.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
      var jsx$4 = f.libraries$1;
      var this$16 = $m_sc_Seq$();
      $as_sc_IterableLike(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$16.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, libraryUrl$2) {
        return (function(library$3$2) {
          var library$3 = $as_T(library$3$2);
          var jsx$7 = this$3$1.rdfModel$1;
          var this$17 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
          return jsx$7.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(libraryUrl$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$17, "jsLibraryURL").iri__T(), library$3, new $c_s_Some().init___O("http://www.w3.org/2001/XMLSchema#anyUri"))
        })
      })(this, libraryUrl)));
      var this$19 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      this.genValue__p1__T__T__T__s_Option__V(validatorId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$19, "jsFunctionName").iri__T(), f.computeFunctionName__T__T(validationId), $m_s_None$())
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype.genJSConstraint__p1__T__Lamf_core_validation_core_FunctionConstraint__Lamf_core_rdf_RdfModel = (function(validationId, f) {
  var constraintId = f.constraintId__T__T(validationId);
  var validatorId = f.validatorId__T__T(validationId);
  var validatorPath = f.validatorPath__T__T(validationId);
  var jsx$2 = this.rdfModel$1;
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
  var jsx$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "type").iri__T();
  var this$3 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  jsx$2.addTriple__T__T__T__Lamf_core_rdf_RdfModel(constraintId, jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "ConstraintComponent").iri__T());
  var this$5 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.link__T__T__T__Lamf_core_rdf_RdfModel(constraintId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$5, "validator").iri__T(), validatorId);
  if (f.parameters$1.nonEmpty__Z()) {
    var parameterId = (constraintId + "_param");
    var this$7 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    this.link__T__T__T__Lamf_core_rdf_RdfModel(constraintId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "parameter").iri__T(), parameterId);
    var this$9 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    this.link__T__T__T__Lamf_core_rdf_RdfModel(parameterId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$9, "path").iri__T(), $as_Lamf_core_validation_core_FunctionConstraintParameter(f.parameters$1.head__O()).path__T());
    var this$11 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    return this.link__T__T__T__Lamf_core_rdf_RdfModel(parameterId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$11, "datatype").iri__T(), $as_Lamf_core_validation_core_FunctionConstraintParameter(f.parameters$1.head__O()).datatype__T())
  } else {
    var parameterId$2 = (constraintId + "_param");
    var this$13 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    this.link__T__T__T__Lamf_core_rdf_RdfModel(constraintId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "parameter").iri__T(), parameterId$2);
    var this$15 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    this.link__T__T__T__Lamf_core_rdf_RdfModel(parameterId$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$15, "path").iri__T(), validatorPath);
    var this$17 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    return this.link__T__T__T__Lamf_core_rdf_RdfModel(parameterId$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$17, "datatype").iri__T(), $m_Lamf_core_model_DataType$().Boolean$1)
  }
});
var $d_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter = new $TypeData().initClass({
  Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter: 0
}, false, "amf.plugins.features.validation.emitters.ValidationRdfModelEmitter", {
  Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter: 1,
  O: 1
});
$c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter.prototype.$classData = $d_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter;
/** @constructor */
function $c_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$() {
  $c_O.call(this)
}
$c_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$.prototype = new $h_O();
$c_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$.prototype.constructor = $c_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$;
/** @constructor */
function $h_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$.prototype = $c_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$.prototype;
$c_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$.prototype.emitViolation__p1__Lorg_yaml_model_YDocument$PartBuilder__T__V = (function(b, severity) {
  var jsx$1 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@id");
  $m_Lorg_yaml_model_YNode$();
  if (($m_Lamf_core_validation_SeverityLevels$().INFO$1 === severity)) {
    var str = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().shacl__T__T("Info")
  } else if (($m_Lamf_core_validation_SeverityLevels$().WARNING$1 === severity)) {
    var str = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().shacl__T__T("Warning")
  } else {
    if (($m_Lamf_core_validation_SeverityLevels$().VIOLATION$1 !== severity)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Unknown severity level " + severity)))
    };
    var str = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().shacl__T__T("Violation")
  };
  var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$.prototype.emitResult__p1__Lorg_yaml_model_YDocument$PartBuilder__Lamf_core_validation_AMFValidationResult__V = (function(b, result) {
  var jsx$9 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@type");
  $m_Lorg_yaml_model_YNode$();
  var str = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().shacl__T__T("ValidationResult");
  var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value);
  $m_Lorg_yaml_model_YNode$();
  var str$1 = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().shacl__T__T("resultSeverity");
  var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
  $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().emitViolation__p1__Lorg_yaml_model_YDocument$PartBuilder__T__V(v, result.level$1);
  var this$7 = v.builder$1;
  var array = [key$1];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1));
  $m_Lorg_yaml_model_YNode$();
  var str$2 = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().shacl__T__T("focusNode");
  var key$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$2);
  var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
  var jsx$2 = v$1.builder$1;
  var sourceName$1 = v$1.sourceName$2;
  var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
  $m_Lorg_yaml_model_YNode$();
  var key$3 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@id");
  $m_Lorg_yaml_model_YNode$();
  var str$3 = result.targetNode$1;
  var value$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$3);
  b$2.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$3, value$1);
  jsx$2.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1));
  var this$24 = v$1.builder$1;
  var array$1 = [key$2];
  if ((this$24.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len$3 = $uI(array$1.length);
  var newSize$1 = ((this$24.size0$6 + len$3) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$24, newSize$1);
  var len$4 = this$24.size0$6;
  var src$1 = this$24.array$6;
  var dest$1 = this$24.array$6;
  $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
  var xs$1 = this$24.array$6;
  var len$5 = xs$1.u.length;
  var i$1 = 0;
  var j$1 = 0;
  var x$2 = $uI(array$1.length);
  var x$3 = ((x$2 < len$5) ? x$2 : len$5);
  var that$1 = xs$1.u.length;
  var end$1 = ((x$3 < that$1) ? x$3 : that$1);
  while ((i$1 < end$1)) {
    var jsx$3 = j$1;
    var index$1 = i$1;
    xs$1.set(jsx$3, array$1[index$1]);
    i$1 = ((1 + i$1) | 0);
    j$1 = ((1 + j$1) | 0)
  };
  this$24.size0$6 = newSize$1;
  b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1));
  var this$35 = result.targetProperty$1;
  if ((!this$35.isEmpty__Z())) {
    var arg1 = this$35.get__O();
    var x0$1 = $as_T(arg1);
    if ((x0$1 !== "")) {
      $m_Lorg_yaml_model_YNode$();
      var str$4 = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().shacl__T__T("resultPath");
      var key$4 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$4);
      var v$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
      var jsx$4 = v$2.builder$1;
      var sourceName$2 = v$2.sourceName$2;
      var b$3 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$2);
      $m_Lorg_yaml_model_YNode$();
      var key$5 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@id");
      $m_Lorg_yaml_model_YNode$();
      var value$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(x0$1);
      b$3.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$5, value$2);
      jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$3.builder$1, sourceName$2), $m_Lorg_yaml_model_YType$().Map$1));
      var this$42 = v$2.builder$1;
      var array$2 = [key$4];
      if ((this$42.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$6 = $uI(array$2.length);
      var newSize$2 = ((this$42.size0$6 + len$6) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$42, newSize$2);
      var len$7 = this$42.size0$6;
      var src$2 = this$42.array$6;
      var dest$2 = this$42.array$6;
      $systemArraycopy(src$2, 0, dest$2, len$6, len$7);
      var xs$2 = this$42.array$6;
      var len$8 = xs$2.u.length;
      var i$2 = 0;
      var j$2 = 0;
      var x$4 = $uI(array$2.length);
      var x$5 = ((x$4 < len$8) ? x$4 : len$8);
      var that$2 = xs$2.u.length;
      var end$2 = ((x$5 < that$2) ? x$5 : that$2);
      while ((i$2 < end$2)) {
        var jsx$5 = j$2;
        var index$2 = i$2;
        xs$2.set(jsx$5, array$2[index$2]);
        i$2 = ((1 + i$2) | 0);
        j$2 = ((1 + j$2) | 0)
      };
      this$42.size0$6 = newSize$2;
      b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$2.builder$1))
    }
  };
  $m_Lorg_yaml_model_YNode$();
  var str$5 = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().shacl__T__T("resultMessage");
  var key$6 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$5);
  $m_Lorg_yaml_model_YNode$();
  var str$6 = result.message$1;
  var value$3 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$6);
  b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$6, value$3);
  $m_Lorg_yaml_model_YNode$();
  var str$7 = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().shacl__T__T("sourceShape");
  var key$7 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$7);
  var v$3 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
  var jsx$6 = v$3.builder$1;
  var sourceName$3 = v$3.sourceName$2;
  var b$4 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$3);
  $m_Lorg_yaml_model_YNode$();
  var key$8 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@id");
  $m_Lorg_yaml_model_YNode$();
  var str$8 = result.validationId$1;
  var value$4 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$8);
  b$4.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$8, value$4);
  jsx$6.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$4.builder$1, sourceName$3), $m_Lorg_yaml_model_YType$().Map$1));
  var this$61 = v$3.builder$1;
  var array$3 = [key$7];
  if ((this$61.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len$9 = $uI(array$3.length);
  var newSize$3 = ((this$61.size0$6 + len$9) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$61, newSize$3);
  var len$10 = this$61.size0$6;
  var src$3 = this$61.array$6;
  var dest$3 = this$61.array$6;
  $systemArraycopy(src$3, 0, dest$3, len$9, len$10);
  var xs$3 = this$61.array$6;
  var len$11 = xs$3.u.length;
  var i$3 = 0;
  var j$3 = 0;
  var x$6 = $uI(array$3.length);
  var x$7 = ((x$6 < len$11) ? x$6 : len$11);
  var that$3 = xs$3.u.length;
  var end$3 = ((x$7 < that$3) ? x$7 : that$3);
  while ((i$3 < end$3)) {
    var jsx$7 = j$3;
    var index$3 = i$3;
    xs$3.set(jsx$7, array$3[index$3]);
    i$3 = ((1 + i$3) | 0);
    j$3 = ((1 + j$3) | 0)
  };
  this$61.size0$6 = newSize$3;
  b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$3.builder$1));
  var this$72 = result.position$1;
  if ((!this$72.isEmpty__Z())) {
    var arg1$1 = this$72.get__O();
    var pos = $as_Lamf_core_annotations_LexicalInformation(arg1$1);
    $m_Lorg_yaml_model_YNode$();
    var str$9 = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().amfParser__T__T("lexicalPosition");
    var key$9 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$9);
    var v$4 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
    $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().emitPosition__Lorg_yaml_model_YDocument$PartBuilder__Lamf_core_annotations_LexicalInformation__V(v$4, pos);
    var this$76 = v$4.builder$1;
    var array$4 = [key$9];
    if ((this$76.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$12 = $uI(array$4.length);
    var newSize$4 = ((this$76.size0$6 + len$12) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$76, newSize$4);
    var len$13 = this$76.size0$6;
    var src$4 = this$76.array$6;
    var dest$4 = this$76.array$6;
    $systemArraycopy(src$4, 0, dest$4, len$12, len$13);
    var xs$4 = this$76.array$6;
    var len$14 = xs$4.u.length;
    var i$4 = 0;
    var j$4 = 0;
    var x$8 = $uI(array$4.length);
    var x$9 = ((x$8 < len$14) ? x$8 : len$14);
    var that$4 = xs$4.u.length;
    var end$4 = ((x$9 < that$4) ? x$9 : that$4);
    while ((i$4 < end$4)) {
      var jsx$8 = j$4;
      var index$4 = i$4;
      xs$4.set(jsx$8, array$4[index$4]);
      i$4 = ((1 + i$4) | 0);
      j$4 = ((1 + j$4) | 0)
    };
    this$76.size0$6 = newSize$4;
    b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$4.builder$1))
  };
  jsx$9.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$.prototype.emitJSONLDAST__Lamf_core_validation_AMFValidationReport__Lorg_yaml_model_YDocument = (function(report) {
  var this$2 = $m_Lorg_yaml_model_YDocument$().apply__T__Lorg_yaml_model_YDocument$WithComment("");
  var b = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(this$2.org$yaml$model$YDocument$WithComment$$sourceName$f);
  var x = this$2.comment$1;
  var this$4 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$4)) {
    b.comment__T__V(this$2.comment$1)
  };
  var jsx$7 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@type");
  $m_Lorg_yaml_model_YNode$();
  var str = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().shacl__T__T("ValidationReport");
  var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value);
  $m_Lorg_yaml_model_YNode$();
  var str$1 = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().shacl__T__T("conforms");
  var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
  var jsx$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$9 = report.conforms$1;
  jsx$1.raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(v, ("" + this$9), $m_Lorg_yaml_model_YType$().Bool$1);
  var this$13 = v.builder$1;
  var array = [key$1];
  if ((this$13.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$13.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$13, newSize);
  var len$1 = this$13.size0$6;
  var src = this$13.array$6;
  var dest = this$13.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$13.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x$1 = $uI(array.length);
  var x$2 = ((x$1 < len$2) ? x$1 : len$2);
  var that = xs.u.length;
  var end = ((x$2 < that) ? x$2 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$13.size0$6 = newSize;
  b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1));
  if (report.results$1.nonEmpty__Z()) {
    var jsx$3 = report.results$1;
    var this$24 = $m_s_math_Ordering$();
    var evidence$1 = $m_s_Predef$().singleton$und$less$colon$less$2;
    var sorted = $as_sc_Seq(jsx$3.sorted__s_math_Ordering__O(new $c_s_math_LowPriorityOrderingImplicits$$anon$3().init___s_math_LowPriorityOrderingImplicits__F1(this$24, evidence$1)));
    $m_Lorg_yaml_model_YNode$();
    var str$2 = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().shacl__T__T("result");
    var key$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$2);
    var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
    var jsx$5 = v$1.builder$1;
    var sourceName$1 = v$1.sourceName$2;
    var b$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$1);
    sorted.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$3) {
      return (function(x$4$2) {
        var x$4 = $as_Lamf_core_validation_AMFValidationResult(x$4$2);
        $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().emitResult__p1__Lorg_yaml_model_YDocument$PartBuilder__Lamf_core_validation_AMFValidationResult__V(b$3, x$4)
      })
    })(this, b$2)));
    var jsx$4 = $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YSequence$();
    var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$1);
    var parts = b$2.builder$1;
    var node = jsx$4.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
    jsx$5.$$plus$eq__O__scm_ArrayBuffer(node);
    var this$30 = v$1.builder$1;
    var array$1 = [key$2];
    if ((this$30.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$3 = $uI(array$1.length);
    var newSize$1 = ((this$30.size0$6 + len$3) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$30, newSize$1);
    var len$4 = this$30.size0$6;
    var src$1 = this$30.array$6;
    var dest$1 = this$30.array$6;
    $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
    var xs$1 = this$30.array$6;
    var len$5 = xs$1.u.length;
    var i$1 = 0;
    var j$1 = 0;
    var x$3 = $uI(array$1.length);
    var x$5 = ((x$3 < len$5) ? x$3 : len$5);
    var that$1 = xs$1.u.length;
    var end$1 = ((x$5 < that$1) ? x$5 : that$1);
    while ((i$1 < end$1)) {
      var jsx$6 = j$1;
      var index$1 = i$1;
      xs$1.set(jsx$6, array$1[index$1]);
      i$1 = ((1 + i$1) | 0);
      j$1 = ((1 + j$1) | 0)
    };
    this$30.size0$6 = newSize$1;
    b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1))
  };
  jsx$7.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  return new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this$2.org$yaml$model$YDocument$WithComment$$sourceName$f), b.builder$1)
});
$c_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$.prototype.amfParser__T__T = (function(postfix) {
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().AmfParser$1;
  return new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, postfix).iri__T()
});
$c_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$.prototype.shacl__T__T = (function(postfix) {
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  return new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, postfix).iri__T()
});
$c_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$.prototype.emitJSON__Lamf_core_validation_AMFValidationReport__T = (function(report) {
  var this$1 = $m_Lorg_yaml_render_JsonRender$();
  var doc = this.emitJSONLDAST__Lamf_core_validation_AMFValidationReport__Lorg_yaml_model_YDocument(report);
  return this$1.render__Lorg_yaml_model_YDocument__I__Lorg_yaml_render_JsonRenderOptions__T(doc, 0, new $c_Lorg_yaml_render_JsonRenderOptions().init___())
});
$c_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$.prototype.emitPosition__Lorg_yaml_model_YDocument$PartBuilder__Lamf_core_annotations_LexicalInformation__V = (function(b, pos) {
  var jsx$13 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@type");
  $m_Lorg_yaml_model_YNode$();
  var str = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().amfParser__T__T("Position");
  var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value);
  $m_Lorg_yaml_model_YNode$();
  var str$1 = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().amfParser__T__T("start");
  var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
  var jsx$5 = v.builder$1;
  var sourceName$1 = v.sourceName$2;
  var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
  $m_Lorg_yaml_model_YNode$();
  var key$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@type");
  $m_Lorg_yaml_model_YNode$();
  var str$2 = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().amfParser__T__T("Location");
  var value$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$2);
  b$2.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$2, value$1);
  $m_Lorg_yaml_model_YNode$();
  var str$3 = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().amfParser__T__T("line");
  var key$3 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$3);
  var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$2.sourceName$2);
  var jsx$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$9 = pos.range__Lamf_core_parser_Range().start$1.line$1;
  jsx$1.raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(v$1, ("" + this$9), $m_Lorg_yaml_model_YType$().Int$1);
  var this$13 = v$1.builder$1;
  var array = [key$3];
  if ((this$13.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$13.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$13, newSize);
  var len$1 = this$13.size0$6;
  var src = this$13.array$6;
  var dest = this$13.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$13.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$13.size0$6 = newSize;
  b$2.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1));
  $m_Lorg_yaml_model_YNode$();
  var str$4 = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().amfParser__T__T("column");
  var key$4 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$4);
  var v$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$2.sourceName$2);
  var jsx$3 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$25 = pos.range__Lamf_core_parser_Range().start$1.column$1;
  jsx$3.raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(v$2, ("" + this$25), $m_Lorg_yaml_model_YType$().Int$1);
  var this$29 = v$2.builder$1;
  var array$1 = [key$4];
  if ((this$29.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len$3 = $uI(array$1.length);
  var newSize$1 = ((this$29.size0$6 + len$3) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$29, newSize$1);
  var len$4 = this$29.size0$6;
  var src$1 = this$29.array$6;
  var dest$1 = this$29.array$6;
  $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
  var xs$1 = this$29.array$6;
  var len$5 = xs$1.u.length;
  var i$1 = 0;
  var j$1 = 0;
  var x$2 = $uI(array$1.length);
  var x$3 = ((x$2 < len$5) ? x$2 : len$5);
  var that$1 = xs$1.u.length;
  var end$1 = ((x$3 < that$1) ? x$3 : that$1);
  while ((i$1 < end$1)) {
    var jsx$4 = j$1;
    var index$1 = i$1;
    xs$1.set(jsx$4, array$1[index$1]);
    i$1 = ((1 + i$1) | 0);
    j$1 = ((1 + j$1) | 0)
  };
  this$29.size0$6 = newSize$1;
  b$2.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$2.builder$1));
  jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1));
  var this$42 = v.builder$1;
  var array$2 = [key$1];
  if ((this$42.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len$6 = $uI(array$2.length);
  var newSize$2 = ((this$42.size0$6 + len$6) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$42, newSize$2);
  var len$7 = this$42.size0$6;
  var src$2 = this$42.array$6;
  var dest$2 = this$42.array$6;
  $systemArraycopy(src$2, 0, dest$2, len$6, len$7);
  var xs$2 = this$42.array$6;
  var len$8 = xs$2.u.length;
  var i$2 = 0;
  var j$2 = 0;
  var x$4 = $uI(array$2.length);
  var x$5 = ((x$4 < len$8) ? x$4 : len$8);
  var that$2 = xs$2.u.length;
  var end$2 = ((x$5 < that$2) ? x$5 : that$2);
  while ((i$2 < end$2)) {
    var jsx$6 = j$2;
    var index$2 = i$2;
    xs$2.set(jsx$6, array$2[index$2]);
    i$2 = ((1 + i$2) | 0);
    j$2 = ((1 + j$2) | 0)
  };
  this$42.size0$6 = newSize$2;
  b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1));
  $m_Lorg_yaml_model_YNode$();
  var str$5 = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().amfParser__T__T("end");
  var key$5 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$5);
  var v$3 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
  var jsx$11 = v$3.builder$1;
  var sourceName$2 = v$3.sourceName$2;
  var b$3 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$2);
  $m_Lorg_yaml_model_YNode$();
  var key$6 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@type");
  $m_Lorg_yaml_model_YNode$();
  var str$6 = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().amfParser__T__T("Location");
  var value$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$6);
  b$3.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$6, value$2);
  $m_Lorg_yaml_model_YNode$();
  var str$7 = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().amfParser__T__T("line");
  var key$7 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$7);
  var v$4 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$3.sourceName$2);
  var jsx$7 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$58 = pos.range__Lamf_core_parser_Range().end$1.line$1;
  jsx$7.raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(v$4, ("" + this$58), $m_Lorg_yaml_model_YType$().Int$1);
  var this$62 = v$4.builder$1;
  var array$3 = [key$7];
  if ((this$62.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len$9 = $uI(array$3.length);
  var newSize$3 = ((this$62.size0$6 + len$9) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$62, newSize$3);
  var len$10 = this$62.size0$6;
  var src$3 = this$62.array$6;
  var dest$3 = this$62.array$6;
  $systemArraycopy(src$3, 0, dest$3, len$9, len$10);
  var xs$3 = this$62.array$6;
  var len$11 = xs$3.u.length;
  var i$3 = 0;
  var j$3 = 0;
  var x$6 = $uI(array$3.length);
  var x$7 = ((x$6 < len$11) ? x$6 : len$11);
  var that$3 = xs$3.u.length;
  var end$3 = ((x$7 < that$3) ? x$7 : that$3);
  while ((i$3 < end$3)) {
    var jsx$8 = j$3;
    var index$3 = i$3;
    xs$3.set(jsx$8, array$3[index$3]);
    i$3 = ((1 + i$3) | 0);
    j$3 = ((1 + j$3) | 0)
  };
  this$62.size0$6 = newSize$3;
  b$3.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$4.builder$1));
  $m_Lorg_yaml_model_YNode$();
  var str$8 = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().amfParser__T__T("column");
  var key$8 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$8);
  var v$5 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$3.sourceName$2);
  var jsx$9 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$74 = pos.range__Lamf_core_parser_Range().end$1.column$1;
  jsx$9.raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(v$5, ("" + this$74), $m_Lorg_yaml_model_YType$().Int$1);
  var this$78 = v$5.builder$1;
  var array$4 = [key$8];
  if ((this$78.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len$12 = $uI(array$4.length);
  var newSize$4 = ((this$78.size0$6 + len$12) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$78, newSize$4);
  var len$13 = this$78.size0$6;
  var src$4 = this$78.array$6;
  var dest$4 = this$78.array$6;
  $systemArraycopy(src$4, 0, dest$4, len$12, len$13);
  var xs$4 = this$78.array$6;
  var len$14 = xs$4.u.length;
  var i$4 = 0;
  var j$4 = 0;
  var x$8 = $uI(array$4.length);
  var x$9 = ((x$8 < len$14) ? x$8 : len$14);
  var that$4 = xs$4.u.length;
  var end$4 = ((x$9 < that$4) ? x$9 : that$4);
  while ((i$4 < end$4)) {
    var jsx$10 = j$4;
    var index$4 = i$4;
    xs$4.set(jsx$10, array$4[index$4]);
    i$4 = ((1 + i$4) | 0);
    j$4 = ((1 + j$4) | 0)
  };
  this$78.size0$6 = newSize$4;
  b$3.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$5.builder$1));
  jsx$11.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$3.builder$1, sourceName$2), $m_Lorg_yaml_model_YType$().Map$1));
  var this$91 = v$3.builder$1;
  var array$5 = [key$5];
  if ((this$91.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len$15 = $uI(array$5.length);
  var newSize$5 = ((this$91.size0$6 + len$15) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$91, newSize$5);
  var len$16 = this$91.size0$6;
  var src$5 = this$91.array$6;
  var dest$5 = this$91.array$6;
  $systemArraycopy(src$5, 0, dest$5, len$15, len$16);
  var xs$5 = this$91.array$6;
  var len$17 = xs$5.u.length;
  var i$5 = 0;
  var j$5 = 0;
  var x$10 = $uI(array$5.length);
  var x$11 = ((x$10 < len$17) ? x$10 : len$17);
  var that$5 = xs$5.u.length;
  var end$5 = ((x$11 < that$5) ? x$11 : that$5);
  while ((i$5 < end$5)) {
    var jsx$12 = j$5;
    var index$5 = i$5;
    xs$5.set(jsx$12, array$5[index$5]);
    i$5 = ((1 + i$5) | 0);
    j$5 = ((1 + j$5) | 0)
  };
  this$91.size0$6 = newSize$5;
  b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$3.builder$1));
  jsx$13.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
var $d_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$ = new $TypeData().initClass({
  Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$: 0
}, false, "amf.plugins.features.validation.emitters.ValidationReportJSONLDEmitter$", {
  Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$: 1,
  O: 1
});
$c_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$.prototype.$classData = $d_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$;
var $n_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$ = (void 0);
function $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$() {
  if ((!$n_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$)) {
    $n_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$ = new $c_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().init___()
  };
  return $n_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$
}
/** @constructor */
function $c_Lamf_plugins_features_validation_model_ValidationDialectText$() {
  $c_O.call(this)
}
$c_Lamf_plugins_features_validation_model_ValidationDialectText$.prototype = new $h_O();
$c_Lamf_plugins_features_validation_model_ValidationDialectText$.prototype.constructor = $c_Lamf_plugins_features_validation_model_ValidationDialectText$;
/** @constructor */
function $h_Lamf_plugins_features_validation_model_ValidationDialectText$() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_model_ValidationDialectText$.prototype = $c_Lamf_plugins_features_validation_model_ValidationDialectText$.prototype;
$c_Lamf_plugins_features_validation_model_ValidationDialectText$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_features_validation_model_ValidationDialectText$.prototype.text__T = (function() {
  var this$2 = new $c_sci_StringOps().init___T("\n      |#%Dialect 1.0\n      |\n      |dialect: Validation Profile\n      |version: 1.0\n      |usage: Dialect to describe validations over RAML documents\n      |external:\n      |  schema-org: \"http://schema.org/\"\n      |  shacl: \"http://www.w3.org/ns/shacl#\"\n      |  validation: \"http://a.ml/vocabularies/amf-validation#\"\n      |nodeMappings:\n      |  functionConstraintNode:\n      |    classTerm: shacl.JSConstraint\n      |    mapping:\n      |      message:\n      |        propertyTerm: shacl.message\n      |        range: string\n      |      code:\n      |        range: string\n      |        propertyTerm: validation.jsCode\n      |        #pattern: '^function\\(.+\\)\\s*\\{.+\\}$'\n      |      libraries:\n      |        propertyTerm: shacl.jsLibrary\n      |        range: string\n      |        allowMultiple: true\n      |      functionName:\n      |        propertyTerm: shacl.jsFunctionName\n      |        range: string\n      |  propertyConstraintNode:\n      |    classTerm: shacl.PropertyShape\n      |    mapping:\n      |      message:\n      |        propertyTerm: shacl.message\n      |        range: string\n      |      name:\n      |        propertyTerm: validation.ramlPropertyId\n      |        mandatory: true\n      |        range: string\n      |      pattern:\n      |        propertyTerm: shacl.pattern\n      |        range: string\n      |      maxCount:\n      |        propertyTerm: shacl.maxCount\n      |        range: integer\n      |      minCount:\n      |        propertyTerm: shacl.minCount\n      |        range: integer\n      |      minExclusive:\n      |        propertyTerm: shacl.minExclusive\n      |        range: number\n      |      maxExclusive:\n      |        propertyTerm: shacl.maxExclusive\n      |        range: number\n      |      minInclusive:\n      |        propertyTerm: shacl.minInclusive\n      |        range: number\n      |      maxInclusive:\n      |        propertyTerm: shacl.maxInclusive\n      |        range: number\n      |      datatype:\n      |         propertyTerm: shacl.datatype\n      |         range: string\n      |      in:\n      |        propertyTerm: shacl.in\n      |        allowMultiple: true\n      |        range: any\n      |      nested:\n      |        propertyTerm: shacl.node\n      |        range: [ shapeValidationNode, queryValidationNode, functionValidationNode, xoneShapeValidationNode, orShapeValidationNode, notShapeValidationNode, andShapeValidationNode]\n      |      atLeast:\n      |        propertyTerm: shacl.atLeastNode\n      |        range: qualifiedShapeValidationNode\n      |      atMost:\n      |        propertyTerm: shacl.atMostNode\n      |        range: qualifiedShapeValidationNode\n      |      equalsToProperty:\n      |        propertyTerm: shacl.equals\n      |        range: string\n      |      disjointWithProperty:\n      |        propertyTerm: shacl.disjoint\n      |        range: string\n      |      lessThanProperty:\n      |        propertyTerm: shacl.lessThan\n      |        range: string\n      |      lessThanOrEqualsToProperty:\n      |        propertyTerm: shacl.lessThanOrEquals\n      |        range: string\n      |  functionValidationNode:\n      |    classTerm: validation.FunctionValidation\n      |    mapping:\n      |      name:\n      |        propertyTerm: schema-org.name\n      |        range: string\n      |      message:\n      |        propertyTerm: shacl.message\n      |        range: string\n      |      targetClass:\n      |        propertyTerm: validation.ramlClassId\n      |        range: string\n      |        allowMultiple: true\n      |      functionConstraint:\n      |        mandatory: true\n      |        propertyTerm: shacl.js\n      |        range: functionConstraintNode\n      |  qualifiedShapeValidationNode:\n      |    classTerm: validation.QualifiedShapevalidationNode\n      |    mapping:\n      |      count:\n      |        propertyTerm: shacl.count\n      |        range: integer\n      |        mandatory: true\n      |      validation:\n      |        propertyTerm: shacl.valueShape\n      |        range: [ shapeValidationNode, queryValidationNode, functionValidationNode, xoneShapeValidationNode, orShapeValidationNode, notShapeValidationNode, andShapeValidationNode]\n      |        mandatory: true\n      |  shapeValidationNode:\n      |    classTerm: validation.ShapeValidation\n      |    mapping:\n      |      name:\n      |        propertyTerm: schema-org.name\n      |        range: string\n      |      message:\n      |        propertyTerm: shacl.message\n      |        range: string\n      |      targetClass:\n      |        propertyTerm: validation.ramlClassId\n      |        range: string\n      |        allowMultiple: true\n      |      classConstraints:\n      |        propertyTerm: shacl.class\n      |        range: string\n      |        allowMultiple: true\n      |      propertyConstraints:\n      |        mandatory: true\n      |        propertyTerm: shacl.property\n      |        mapKey: name\n      |        range: propertyConstraintNode\n      |  andShapeValidationNode:\n      |    classTerm: validation.AndShapeValidation\n      |    mapping:\n      |      name:\n      |        propertyTerm: schema-org.name\n      |        range: string\n      |      message:\n      |        propertyTerm: shacl.message\n      |        range: string\n      |      targetClass:\n      |        propertyTerm: validation.ramlClassId\n      |        range: string\n      |        allowMultiple: true\n      |      and:\n      |        propertyTerm: shacl.and\n      |        range: [ shapeValidationNode, queryValidationNode, functionValidationNode, xoneShapeValidationNode, orShapeValidationNode, notShapeValidationNode, andShapeValidationNode]\n      |        allowMultiple: true\n      |  notShapeValidationNode:\n      |    classTerm: validation.NotShapeValidation\n      |    mapping:\n      |      name:\n      |        propertyTerm: schema-org.name\n      |        range: string\n      |      message:\n      |        propertyTerm: shacl.message\n      |        range: string\n      |      targetClass:\n      |        propertyTerm: validation.ramlClassId\n      |        range: string\n      |        allowMultiple: true\n      |      not:\n      |        propertyTerm: shacl.not\n      |        range: [ shapeValidationNode, queryValidationNode, functionValidationNode, xoneShapeValidationNode, orShapeValidationNode, notShapeValidationNode, andShapeValidationNode]\n      |  orShapeValidationNode:\n      |    classTerm: validation.OrShapeValidation\n      |    mapping:\n      |      name:\n      |        propertyTerm: schema-org.name\n      |        range: string\n      |      message:\n      |        propertyTerm: shacl.message\n      |        range: string\n      |      targetClass:\n      |        propertyTerm: validation.ramlClassId\n      |        range: string\n      |        allowMultiple: true\n      |      or:\n      |        propertyTerm: shacl.or\n      |        range: [ shapeValidationNode, queryValidationNode, functionValidationNode, xoneShapeValidationNode, orShapeValidationNode, notShapeValidationNode, andShapeValidationNode]\n      |        allowMultiple: true\n      |  xoneShapeValidationNode:\n      |    classTerm: validation.XoneShapeValidation\n      |    mapping:\n      |      name:\n      |        propertyTerm: schema-org.name\n      |        range: string\n      |      message:\n      |        propertyTerm: shacl.message\n      |        range: string\n      |      targetClass:\n      |        propertyTerm: validation.ramlClassId\n      |        range: string\n      |        allowMultiple: true\n      |      xone:\n      |        propertyTerm: shacl.xone\n      |        range: [ shapeValidationNode, queryValidationNode, functionValidationNode, xoneShapeValidationNode, orShapeValidationNode, notShapeValidationNode, andShapeValidationNode]\n      |        allowMultiple: true\n      |  queryValidationNode:\n      |    classTerm: validation.QueryValidation\n      |    mapping:\n      |      name:\n      |        propertyTerm: schema-org.name\n      |        range: string\n      |      message:\n      |        propertyTerm: shacl.message\n      |        range: string\n      |      targetClass:\n      |        propertyTerm: validation.ramlClassId\n      |        range: string\n      |        allowMultiple: true\n      |      query:\n      |        mandatory: true\n      |        propertyTerm: validation.targetQuery\n      |        range: string\n      |  ramlPrefixNode:\n      |    classTerm: validation.RamlPrefix\n      |    mapping:\n      |      prefix:\n      |        propertyTerm: validation.ramlPrefixName\n      |        range: string\n      |      uri:\n      |        propertyTerm: validation.ramlPrefixUri\n      |        range: string\n      |\n      |  profileNode:\n      |    classTerm: validation.Profile\n      |    mapping:\n      |      prefixes:\n      |        propertyTerm: validation.ramlPrefixes\n      |        mapKey: prefix\n      |        mapValue: uri\n      |        range: ramlPrefixNode\n      |      profile:\n      |        propertyTerm: schema-org.name\n      |        mandatory: true\n      |        range: string\n      |      description:\n      |        propertyTerm: schema-org.description\n      |        range: string\n      |      extends:\n      |        propertyTerm: validation.extendsProfile\n      |        range: string\n      |      violation:\n      |        propertyTerm: validation.setSeverityViolation\n      |        range: string\n      |        allowMultiple: true\n      |      info:\n      |        propertyTerm: validation.setSeverityInfo\n      |        range: string\n      |        allowMultiple: true\n      |      warning:\n      |        propertyTerm: validation.setSeverityWarning\n      |        range: string\n      |        allowMultiple: true\n      |      disabled:\n      |        propertyTerm: validation.disableValidation\n      |        range: string\n      |        allowMultiple: true\n      |      validations:\n      |        propertyTerm: validation.validations\n      |        mapKey: name\n      |        range: [ shapeValidationNode, queryValidationNode, functionValidationNode, xoneShapeValidationNode, orShapeValidationNode, notShapeValidationNode, andShapeValidationNode]\n\n      |  validationShapesUnion:\n      |    union:\n      |      - shapeValidationNode\n      |      - queryValidationNode\n      |      - xoneShapeValidationNode\n      |      - orShapeValidationNode\n      |      - notShapeValidationNode\n      |      - andShapeValidationNode\n      |\n      |documents:\n      |  fragments:\n      |    encodes:\n      |      ShapeValidation: queryValidationNode\n      |      FunctionValidation: functionValidationNode\n      |\n      |  library:\n      |    declares:\n      |      validations: validationShapesUnion\n      |      functions: functionValidationNode\n      |\n      |  root:\n      |    encodes: profileNode\n    ");
  return $f_sci_StringLike__stripMargin__C__T(this$2, 124)
});
var $d_Lamf_plugins_features_validation_model_ValidationDialectText$ = new $TypeData().initClass({
  Lamf_plugins_features_validation_model_ValidationDialectText$: 0
}, false, "amf.plugins.features.validation.model.ValidationDialectText$", {
  Lamf_plugins_features_validation_model_ValidationDialectText$: 1,
  O: 1
});
$c_Lamf_plugins_features_validation_model_ValidationDialectText$.prototype.$classData = $d_Lamf_plugins_features_validation_model_ValidationDialectText$;
var $n_Lamf_plugins_features_validation_model_ValidationDialectText$ = (void 0);
function $m_Lamf_plugins_features_validation_model_ValidationDialectText$() {
  if ((!$n_Lamf_plugins_features_validation_model_ValidationDialectText$)) {
    $n_Lamf_plugins_features_validation_model_ValidationDialectText$ = new $c_Lamf_plugins_features_validation_model_ValidationDialectText$().init___()
  };
  return $n_Lamf_plugins_features_validation_model_ValidationDialectText$
}
/** @constructor */
function $c_Lamf_validations_CustomShaclFunctions$() {
  $c_O.call(this);
  this.functions$1 = null
}
$c_Lamf_validations_CustomShaclFunctions$.prototype = new $h_O();
$c_Lamf_validations_CustomShaclFunctions$.prototype.constructor = $c_Lamf_validations_CustomShaclFunctions$;
/** @constructor */
function $h_Lamf_validations_CustomShaclFunctions$() {
  /*<skip>*/
}
$h_Lamf_validations_CustomShaclFunctions$.prototype = $c_Lamf_validations_CustomShaclFunctions$.prototype;
$c_Lamf_validations_CustomShaclFunctions$.prototype.init___ = (function() {
  $n_Lamf_validations_CustomShaclFunctions$ = this;
  var y = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(element$2, violation$2) {
      var element = $as_Lamf_core_model_domain_DomainElement(element$2);
      var violation = $as_F1(violation$2);
      var this$2 = element.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1);
      if (this$2.isEmpty__Z()) {
        var optBindingValue = $m_s_None$()
      } else {
        var arg1 = this$2.get__O();
        var x$1 = $as_Lamf_core_model_domain_AmfScalar(arg1);
        var optBindingValue = new $c_s_Some().init___O(x$1.value$1)
      };
      var this$3 = element.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1);
      if (this$3.isEmpty__Z()) {
        var optRequiredValue = $m_s_None$()
      } else {
        var arg1$1 = this$3.get__O();
        var x$2 = $as_Lamf_core_model_domain_AmfScalar(arg1$1);
        var optRequiredValue = new $c_s_Some().init___O(x$2.value$1)
      };
      matchEnd20: {
        var jsx$33;
        if ((optBindingValue instanceof $c_s_Some)) {
          var x4 = $as_s_Some(optBindingValue);
          var p5 = x4.value$2;
          if (((p5 === "path") && (optRequiredValue instanceof $c_s_Some))) {
            var x6 = $as_s_Some(optRequiredValue);
            var p7 = x6.value$2;
            if ($m_sr_BoxesRunTime$().equals__O__O__Z(false, p7)) {
              var jsx$33 = true;
              break matchEnd20
            }
          }
        };
        if ((optBindingValue instanceof $c_s_Some)) {
          var x10 = $as_s_Some(optBindingValue);
          var p11 = x10.value$2;
          if ((p11 === "path")) {
            var x = $m_s_None$();
            var jsx$34 = (x === optRequiredValue)
          } else {
            var jsx$34 = false
          };
          if (jsx$34) {
            var jsx$33 = true;
            break matchEnd20
          }
        };
        var jsx$33 = false
      };
      if (jsx$33) {
        $asUnit(violation.apply__O__O($m_s_None$()))
      }
    })
  })(this));
  var jsx$35 = new $c_T2().init___O__O("pathParameterRequiredProperty", y);
  var y$1 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$2$1) {
    return (function(element$3$2, violation$3$2) {
      var element$3 = $as_Lamf_core_model_domain_DomainElement(element$3$2);
      var violation$3 = $as_F1(violation$3$2);
      var this$6 = element$3.fields__Lamf_core_parser_Fields();
      var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1;
      var this$7 = this$6.fs$1.get__O__s_Option(field);
      if ((!this$7.isEmpty__Z())) {
        var arg1$2 = this$7.get__O();
        var field$1 = $as_Lamf_core_parser_Value(arg1$2);
        var x1 = field$1.value$1;
        if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_FileShape)) {
          var this$8 = element$3.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1);
          if (this$8.isEmpty__Z()) {
            var optBindingValue$1 = $m_s_None$()
          } else {
            var arg1$3 = this$8.get__O();
            var x$3 = $as_Lamf_core_model_domain_AmfScalar(arg1$3);
            var optBindingValue$1 = new $c_s_Some().init___O(x$3.value$1)
          };
          if (optBindingValue$1.isEmpty__Z()) {
            var jsx$31 = true
          } else {
            var x$4 = optBindingValue$1.get__O();
            var jsx$31 = (!((x$4 !== null) && $objectEquals(x$4, "formData")))
          };
          if (jsx$31) {
            violation$3.apply__O__O($m_s_None$())
          }
        }
      }
    })
  })(this));
  var jsx$32 = new $c_T2().init___O__O("fileParameterMustBeInFormData", y$1);
  var y$2 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$3$1) {
    return (function(element$4$2, violation$4$2) {
      var element$4 = $as_Lamf_core_model_domain_DomainElement(element$4$2);
      var violation$4 = $as_F1(violation$4$2);
      var this$11 = element$4.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Minimum$1);
      if ((!this$11.isEmpty__Z())) {
        var arg1$4 = this$11.get__O();
        var minInclusive = $as_Lamf_core_model_domain_AmfScalar(arg1$4);
        var this$12 = element$4.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Maximum$1);
        if (this$12.isEmpty__Z()) {
          /*<skip>*/
        } else {
          var arg1$5 = this$12.get__O();
          var maxInclusive = $as_Lamf_core_model_domain_AmfScalar(arg1$5);
          var x$5 = minInclusive.toString__T();
          var this$14 = new $c_sci_StringOps().init___T(x$5);
          var jsx$28 = $m_jl_Double$();
          var $$this = this$14.repr$1;
          var minValue = jsx$28.parseDouble__T__D($$this);
          var x$6 = maxInclusive.toString__T();
          var this$17 = new $c_sci_StringOps().init___T(x$6);
          var jsx$29 = $m_jl_Double$();
          var $$this$1 = this$17.repr$1;
          var maxValue = jsx$29.parseDouble__T__D($$this$1);
          if ((minValue > maxValue)) {
            violation$4.apply__O__O($m_s_None$())
          };
          new $c_s_Some().init___O((void 0))
        }
      }
    })
  })(this));
  var jsx$30 = new $c_T2().init___O__O("minimumMaximumValidation", y$2);
  var y$3 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$4$1) {
    return (function(element$5$2, violation$5$2) {
      var element$5 = $as_Lamf_core_model_domain_DomainElement(element$5$2);
      var violation$5 = $as_F1(violation$5$2);
      var this$21 = element$5.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MinItems$1);
      if ((!this$21.isEmpty__Z())) {
        var arg1$6 = this$21.get__O();
        var minInclusive$1 = $as_Lamf_core_model_domain_AmfScalar(arg1$6);
        var this$22 = element$5.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MaxItems$1);
        if (this$22.isEmpty__Z()) {
          /*<skip>*/
        } else {
          var arg1$7 = this$22.get__O();
          var maxInclusive$1 = $as_Lamf_core_model_domain_AmfScalar(arg1$7);
          var x$7 = minInclusive$1.toString__T();
          var this$24 = new $c_sci_StringOps().init___T(x$7);
          var jsx$25 = $m_jl_Double$();
          var $$this$2 = this$24.repr$1;
          var minValue$1 = jsx$25.parseDouble__T__D($$this$2);
          var x$8 = maxInclusive$1.toString__T();
          var this$27 = new $c_sci_StringOps().init___T(x$8);
          var jsx$26 = $m_jl_Double$();
          var $$this$3 = this$27.repr$1;
          var maxValue$1 = jsx$26.parseDouble__T__D($$this$3);
          if ((minValue$1 > maxValue$1)) {
            violation$5.apply__O__O($m_s_None$())
          };
          new $c_s_Some().init___O((void 0))
        }
      }
    })
  })(this));
  var jsx$27 = new $c_T2().init___O__O("minMaxItemsValidation", y$3);
  var y$4 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$5$1) {
    return (function(element$6$2, violation$6$2) {
      var element$6 = $as_Lamf_core_model_domain_DomainElement(element$6$2);
      var violation$6 = $as_F1(violation$6$2);
      var this$31 = element$6.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MinProperties$1);
      if ((!this$31.isEmpty__Z())) {
        var arg1$8 = this$31.get__O();
        var minInclusive$2 = $as_Lamf_core_model_domain_AmfScalar(arg1$8);
        var this$32 = element$6.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MaxProperties$1);
        if (this$32.isEmpty__Z()) {
          /*<skip>*/
        } else {
          var arg1$9 = this$32.get__O();
          var maxInclusive$2 = $as_Lamf_core_model_domain_AmfScalar(arg1$9);
          var x$9 = minInclusive$2.toString__T();
          var this$34 = new $c_sci_StringOps().init___T(x$9);
          var jsx$22 = $m_jl_Double$();
          var $$this$4 = this$34.repr$1;
          var minValue$2 = jsx$22.parseDouble__T__D($$this$4);
          var x$10 = maxInclusive$2.toString__T();
          var this$37 = new $c_sci_StringOps().init___T(x$10);
          var jsx$23 = $m_jl_Double$();
          var $$this$5 = this$37.repr$1;
          var maxValue$2 = jsx$23.parseDouble__T__D($$this$5);
          if ((minValue$2 > maxValue$2)) {
            violation$6.apply__O__O($m_s_None$())
          };
          new $c_s_Some().init___O((void 0))
        }
      }
    })
  })(this));
  var jsx$24 = new $c_T2().init___O__O("minMaxPropertiesValidation", y$4);
  var y$5 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$6$1) {
    return (function(element$7$2, violation$7$2) {
      var element$7 = $as_Lamf_core_model_domain_DomainElement(element$7$2);
      var violation$7 = $as_F1(violation$7$2);
      var this$41 = element$7.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MinLength$1);
      if ((!this$41.isEmpty__Z())) {
        var arg1$10 = this$41.get__O();
        var minInclusive$3 = $as_Lamf_core_model_domain_AmfScalar(arg1$10);
        var this$42 = element$7.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MaxLength$1);
        if (this$42.isEmpty__Z()) {
          /*<skip>*/
        } else {
          var arg1$11 = this$42.get__O();
          var maxInclusive$3 = $as_Lamf_core_model_domain_AmfScalar(arg1$11);
          var x$11 = $objectToString(minInclusive$3.value$1);
          var this$44 = new $c_sci_StringOps().init___T(x$11);
          var jsx$19 = $m_jl_Double$();
          var $$this$6 = this$44.repr$1;
          var minValue$3 = jsx$19.parseDouble__T__D($$this$6);
          var x$12 = $objectToString(maxInclusive$3.value$1);
          var this$47 = new $c_sci_StringOps().init___T(x$12);
          var jsx$20 = $m_jl_Double$();
          var $$this$7 = this$47.repr$1;
          var maxValue$3 = jsx$20.parseDouble__T__D($$this$7);
          if ((minValue$3 > maxValue$3)) {
            violation$7.apply__O__O($m_s_None$())
          };
          new $c_s_Some().init___O((void 0))
        }
      }
    })
  })(this));
  var jsx$21 = new $c_T2().init___O__O("minMaxLengthValidation", y$5);
  var y$6 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$7$1) {
    return (function(element$8$2, violation$8$2) {
      var element$8 = $as_Lamf_core_model_domain_DomainElement(element$8$2);
      var violation$8 = $as_F1(violation$8$2);
      if ((element$8 instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
        var x2 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(element$8);
        var x1$2 = x2.fields$2.$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().XMLSerialization$1);
        if ((x1$2 instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(x1$2);
          var xmlSerialization = $as_Lamf_core_model_domain_DomainElement(x2$2.value$2);
          var this$51 = xmlSerialization.fields__Lamf_core_parser_Fields();
          var this$54 = this$51.fs$1;
          var this$52 = $m_Lamf_core_parser_FieldEntry$();
          var f = $f_F2__tupled__F1(this$52);
          var this$53 = $m_sci_Iterable$();
          var bf = this$53.ReusableCBFInstance$2;
          var this$55 = $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$54, f, bf)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
            return (function(f$2) {
              var f$1 = $as_Lamf_core_parser_FieldEntry(f$2);
              return $m_sjsr_RuntimeString$().endsWith__T__T__Z(f$1.field$1.value$1.iri__T(), "xmlWrapped")
            })
          })(this$7$1)));
          if ((!this$55.isEmpty__Z())) {
            var arg1$12 = this$55.get__O();
            var isWrappedEntry = $as_Lamf_core_parser_FieldEntry(arg1$12);
            var isWrapped = $as_Lamf_core_model_domain_AmfScalar(isWrappedEntry.value$1.value$1).toBool__Z();
            if (isWrapped) {
              violation$8.apply__O__O($m_s_None$())
            }
          }
        }
      }
    })
  })(this));
  var jsx$18 = new $c_T2().init___O__O("xmlWrappedScalar", y$6);
  var y$7 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$8$1) {
    return (function(element$9$2, violation$9$2) {
      var element$9 = $as_Lamf_core_model_domain_DomainElement(element$9$2);
      var violation$9 = $as_F1(violation$9$2);
      var this$58 = element$9.fields__Lamf_core_parser_Fields();
      var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().XMLSerialization$1;
      var x1$1 = this$58.fs$1.get__O__s_Option(field$2);
      if ((x1$1 instanceof $c_s_Some)) {
        var x2$1 = $as_s_Some(x1$1);
        var xmlSerialization$1 = $as_Lamf_core_parser_Value(x2$1.value$2);
        var x1$2$1 = xmlSerialization$1.value$1;
        if ($is_Lamf_core_model_domain_DomainElement(x1$2$1)) {
          var x2$2$1 = $as_Lamf_core_model_domain_DomainElement(x1$2$1);
          var xmlAttribute = x2$2$1.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Attribute$1);
          if ((!xmlAttribute.isEmpty__Z())) {
            var arg1$13 = xmlAttribute.get__O();
            var attributeScalar = $as_Lamf_core_model_domain_AmfScalar(arg1$13);
            var isAttribute = attributeScalar.toBool__Z();
            var this$59 = element$9.meta__Lamf_core_metamodel_Obj().type__sci_List();
            inlinereturn$131: {
              var these = this$59;
              while ((!these.isEmpty__Z())) {
                var arg1$14 = these.head__O();
                var x$4$1 = $as_Lamf_core_vocabulary_ValueType(arg1$14);
                if ((x$4$1.name$1 === "ScalarShape")) {
                  var jsx$16 = true;
                  break inlinereturn$131
                };
                these = $as_sc_LinearSeqOptimized(these.tail__O())
              };
              var jsx$16 = false
            };
            var isNonScalar = (!jsx$16);
            if ((isAttribute && isNonScalar)) {
              violation$9.apply__O__O($m_s_None$())
            }
          }
        }
      } else {
        var x$2$1 = $m_s_None$();
        if ((!(x$2$1 === x1$1))) {
          throw new $c_s_MatchError().init___O(x1$1)
        }
      }
    })
  })(this));
  var jsx$17 = new $c_T2().init___O__O("xmlNonScalarAttribute", y$7);
  var y$8 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$9$1) {
    return (function(element$10$2, violation$10$2) {
      var element$10 = $as_Lamf_core_model_domain_DomainElement(element$10$2);
      var violation$10 = $as_F1(violation$10$2);
      var this$62 = element$10.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Pattern$1);
      if ((!this$62.isEmpty__Z())) {
        var arg1$15 = this$62.get__O();
        var pattern = $as_Lamf_core_model_domain_AmfScalar(arg1$15);
        try {
          var this$65 = $m_ju_regex_Pattern$();
          var str = pattern.toString__T();
          var this$64 = new $c_Lamf_core_utils_package$RegexConverter().init___T(str);
          var regex = $m_sjsr_RuntimeString$().replaceAll__T__T__T__T(this$64.str$1, "\\[\\^\\]", "[\\\\S\\\\s]");
          this$65.compile__T__I__ju_regex_Pattern(regex, 0)
        } catch (e) {
          var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
          if ((e$2 !== null)) {
            violation$10.apply__O__O($m_s_None$())
          } else {
            throw e
          }
        }
      }
    })
  })(this));
  var jsx$15 = new $c_T2().init___O__O("patternValidation", y$8);
  var y$9 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$10$1) {
    return (function(element$11$2, violation$11$2) {
      var element$11 = $as_Lamf_core_model_domain_DomainElement(element$11$2);
      var violation$11 = $as_F1(violation$11$2);
      var this$68 = element$11.fields__Lamf_core_parser_Fields();
      var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Schemes$1;
      var maybeValue = this$68.fs$1.get__O__s_Option(field$3);
      if (maybeValue.isEmpty__Z()) {
        var this$69 = $m_s_None$()
      } else {
        var arg1$16 = maybeValue.get__O();
        var x$5$1 = $as_Lamf_core_parser_Value(arg1$16);
        var this$69 = new $c_s_Some().init___O(x$5$1.value$1)
      };
      if ((!this$69.isEmpty__Z())) {
        var arg1$17 = this$69.get__O();
        var x0$1 = $as_Lamf_core_model_domain_AmfElement(arg1$17);
        matchEnd5: {
          if ((x0$1 instanceof $c_Lamf_core_model_domain_AmfArray)) {
            var x2$3 = $as_Lamf_core_model_domain_AmfArray(x0$1);
            var elements = x2$3.values$1;
            if (elements.isEmpty__Z()) {
              $asUnit(violation$11.apply__O__O(new $c_s_Some().init___O(new $c_T2().init___O__O(($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()), $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Schemes$1))));
              break matchEnd5
            }
          }
        }
      }
    })
  })(this));
  var jsx$14 = new $c_T2().init___O__O("nonEmptyListOfProtocols", y$9);
  var y$10 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$11$1) {
    return (function(element$12$2, violation$12$2) {
      var element$12 = $as_Lamf_core_model_domain_DomainElement(element$12$2);
      var violation$12 = $as_F1(violation$12$2);
      var this$73 = element$12.fields__Lamf_core_parser_Fields();
      var field$4 = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1;
      var this$74 = this$73.fs$1.get__O__s_Option(field$4);
      if ((!this$74.isEmpty__Z())) {
        var arg1$18 = this$74.get__O();
        $as_Lamf_core_parser_Value(arg1$18);
        var this$75 = element$12.fields__Lamf_core_parser_Fields();
        var field$5 = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().ExternalValue$1;
        var this$76 = this$75.fs$1.get__O__s_Option(field$5);
        if (this$76.isEmpty__Z()) {
          /*<skip>*/
        } else {
          var arg1$19 = this$76.get__O();
          $as_Lamf_core_parser_Value(arg1$19);
          violation$12.apply__O__O($m_s_None$());
          new $c_s_Some().init___O((void 0))
        }
      }
    })
  })(this));
  var jsx$13 = new $c_T2().init___O__O("exampleMutuallyExclusiveFields", y$10);
  var y$11 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$12$1) {
    return (function(element$13$2, violation$13$2) {
      var element$13 = $as_Lamf_core_model_domain_DomainElement(element$13$2);
      var violation$13 = $as_F1(violation$13$2);
      var this$79 = element$13.fields__Lamf_core_parser_Fields();
      var field$6 = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1;
      var this$80 = this$79.fs$1.get__O__s_Option(field$6);
      if (this$80.isEmpty__Z()) {
        var this$81 = $m_s_None$()
      } else {
        var arg1$20 = this$80.get__O();
        var x$6$1 = $as_Lamf_core_parser_Value(arg1$20);
        var this$81 = new $c_s_Some().init___O(x$6$1.value$1)
      };
      if ((!this$81.isEmpty__Z())) {
        var arg1$21 = this$81.get__O();
        var x0$2 = $as_Lamf_core_model_domain_AmfElement(arg1$21);
        if ((x0$2 instanceof $c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings)) {
          var x2$4 = $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(x0$2);
          var fields = x2$4.fields$1;
          var f$3 = $m_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$().Url$1;
          if ((!fields.fs$1.contains__O__Z(f$3))) {
            $asUnit(violation$13.apply__O__O($m_s_None$()))
          }
        }
      }
    })
  })(this));
  var jsx$12 = new $c_T2().init___O__O("requiredOpenIdConnectUrl", y$11);
  var y$12 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$13$1) {
    return (function(element$14$2, violation$14$2) {
      var element$14 = $as_Lamf_core_model_domain_DomainElement(element$14$2);
      var violation$14 = $as_F1(violation$14$2);
      var this$84 = element$14.fields__Lamf_core_parser_Fields();
      var field$7 = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1;
      var this$85 = this$84.fs$1.get__O__s_Option(field$7);
      if (this$85.isEmpty__Z()) {
        var this$86 = $m_s_None$()
      } else {
        var arg1$22 = this$85.get__O();
        var x$7$1 = $as_Lamf_core_parser_Value(arg1$22);
        var this$86 = new $c_s_Some().init___O(x$7$1.value$1)
      };
      if ((!this$86.isEmpty__Z())) {
        var arg1$23 = this$86.get__O();
        var x0$3 = $as_Lamf_core_model_domain_AmfElement(arg1$23);
        if ((x0$3 instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings)) {
          var x2$5 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(x0$3);
          var fields$1 = x2$5.fields$1;
          var f$4 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1;
          if ((!fields$1.fs$1.contains__O__Z(f$4))) {
            $asUnit(violation$14.apply__O__O($m_s_None$()))
          }
        }
      }
    })
  })(this));
  var jsx$11 = new $c_T2().init___O__O("requiredFlowsInOAuth2", y$12);
  var y$13 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$14$1) {
    return (function(callback$2, violation$15$2) {
      var callback = $as_Lamf_core_model_domain_DomainElement(callback$2);
      var violation$15 = $as_F1(violation$15$2);
      var this$89 = callback.fields__Lamf_core_parser_Fields();
      var field$8 = $m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$().Expression$1;
      var this$90 = this$89.fs$1.get__O__s_Option(field$8);
      if (this$90.isEmpty__Z()) {
        var optExpression = $m_s_None$()
      } else {
        var arg1$24 = this$90.get__O();
        var x$8$1 = $as_Lamf_core_parser_Value(arg1$24);
        var optExpression = new $c_s_Some().init___O(x$8$1.value$1)
      };
      $m_Lamf_validations_CustomShaclFunctions$();
      if ((!optExpression.isEmpty__Z())) {
        var arg1$25 = optExpression.get__O();
        var x0$1$1 = $as_Lamf_core_model_domain_AmfElement(arg1$25);
        if ((x0$1$1 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x2$6 = $as_Lamf_core_model_domain_AmfScalar(x0$1$1);
          var this$92 = $m_Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$();
          var text = x2$6.toString__T();
          if ((!$f_Lamf_plugins_document_webapi_validation_runtimeexpression_ExpressionValidator__validate__T__Z(this$92, text))) {
            violation$15.apply__O__O(new $c_s_Some().init___O(new $c_T2().init___O__O(($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()), $m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$().Expression$1)))
          }
        }
      }
    })
  })(this));
  var jsx$10 = new $c_T2().init___O__O("validCallbackExpression", y$13);
  var y$14 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$15$1) {
    return (function(link$2, violation$16$2) {
      var link = $as_Lamf_core_model_domain_DomainElement(link$2);
      var violation$16 = $as_F1(violation$16$2);
      var this$96 = link.fields__Lamf_core_parser_Fields();
      var field$9 = $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().RequestBody$1;
      var this$97 = this$96.fs$1.get__O__s_Option(field$9);
      if (this$97.isEmpty__Z()) {
        var optExpression$1 = $m_s_None$()
      } else {
        var arg1$26 = this$97.get__O();
        var x$9$1 = $as_Lamf_core_parser_Value(arg1$26);
        var optExpression$1 = new $c_s_Some().init___O(x$9$1.value$1)
      };
      $m_Lamf_validations_CustomShaclFunctions$();
      if ((!optExpression$1.isEmpty__Z())) {
        var arg1$27 = optExpression$1.get__O();
        var x0$1$2 = $as_Lamf_core_model_domain_AmfElement(arg1$27);
        if ((x0$1$2 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x2$7 = $as_Lamf_core_model_domain_AmfScalar(x0$1$2);
          var this$99 = $m_Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$();
          var text$1 = x2$7.toString__T();
          if ((!$f_Lamf_plugins_document_webapi_validation_runtimeexpression_ExpressionValidator__validate__T__Z(this$99, text$1))) {
            violation$16.apply__O__O(new $c_s_Some().init___O(new $c_T2().init___O__O(($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()), $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().RequestBody$1)))
          }
        }
      }
    })
  })(this));
  var jsx$9 = new $c_T2().init___O__O("validLinkRequestBody", y$14);
  var y$15 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$16$1) {
    return (function(link$3$2, violation$17$2) {
      var link$3 = $as_Lamf_core_model_domain_DomainElement(link$3$2);
      var violation$17 = $as_F1(violation$17$2);
      var maybeArray = link$3.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Mapping$1);
      if ((!maybeArray.isEmpty__Z())) {
        var arg1$28 = maybeArray.get__O();
        var array = $as_Lamf_core_model_domain_AmfArray(arg1$28);
        array.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, violation$15$1) {
          return (function(x0$4$2) {
            var x0$4 = $as_Lamf_core_model_domain_AmfElement(x0$4$2);
            if ((x0$4 instanceof $c_Lamf_plugins_domain_webapi_models_IriTemplateMapping)) {
              var x2$8 = $as_Lamf_plugins_domain_webapi_models_IriTemplateMapping(x0$4);
              var this$103 = x2$8.fields$1;
              var field$10 = $m_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$().LinkExpression$1;
              var this$104 = this$103.fs$1.get__O__s_Option(field$10);
              if (this$104.isEmpty__Z()) {
                var optExpression$2 = $m_s_None$()
              } else {
                var arg1$29 = this$104.get__O();
                var x$10$1 = $as_Lamf_core_parser_Value(arg1$29);
                var optExpression$2 = new $c_s_Some().init___O(x$10$1.value$1)
              };
              $m_Lamf_validations_CustomShaclFunctions$();
              if ((!optExpression$2.isEmpty__Z())) {
                var arg1$30 = optExpression$2.get__O();
                var x0$1$3 = $as_Lamf_core_model_domain_AmfElement(arg1$30);
                if ((x0$1$3 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
                  var x2$9 = $as_Lamf_core_model_domain_AmfScalar(x0$1$3);
                  var this$106 = $m_Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$();
                  var text$2 = x2$9.toString__T();
                  if ((!$f_Lamf_plugins_document_webapi_validation_runtimeexpression_ExpressionValidator__validate__T__Z(this$106, text$2))) {
                    violation$15$1.apply__O__O(new $c_s_Some().init___O(new $c_T2().init___O__O(($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()), $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Mapping$1)))
                  }
                }
              }
            }
          })
        })(this$16$1, violation$17)))
      }
    })
  })(this));
  var jsx$8 = new $c_T2().init___O__O("validLinkParameterExpressions", y$15);
  var y$16 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$17$1) {
    return (function(link$4$2, violation$18$2) {
      var link$4 = $as_Lamf_core_model_domain_DomainElement(link$4$2);
      var violation$18 = $as_F1(violation$18$2);
      var this$110 = link$4.fields__Lamf_core_parser_Fields();
      var field$11 = $m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$().Location$1;
      var this$111 = this$110.fs$1.get__O__s_Option(field$11);
      if (this$111.isEmpty__Z()) {
        var optExpression$3 = $m_s_None$()
      } else {
        var arg1$31 = this$111.get__O();
        var x$11$1 = $as_Lamf_core_parser_Value(arg1$31);
        var optExpression$3 = new $c_s_Some().init___O(x$11$1.value$1)
      };
      $m_Lamf_validations_CustomShaclFunctions$();
      if ((!optExpression$3.isEmpty__Z())) {
        var arg1$32 = optExpression$3.get__O();
        var x0$1$4 = $as_Lamf_core_model_domain_AmfElement(arg1$32);
        if ((x0$1$4 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x2$10 = $as_Lamf_core_model_domain_AmfScalar(x0$1$4);
          if ((!$m_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$().expression__T__Z(x2$10.toString__T()))) {
            violation$18.apply__O__O(new $c_s_Some().init___O(new $c_T2().init___O__O(($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()), $m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$().Location$1)))
          }
        }
      }
    })
  })(this));
  var jsx$7 = new $c_T2().init___O__O("validCorrelationIdLocation", y$16);
  var y$17 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$18$1) {
    return (function(link$5$2, violation$19$2) {
      var link$5 = $as_Lamf_core_model_domain_DomainElement(link$5$2);
      var violation$19 = $as_F1(violation$19$2);
      var this$116 = link$5.fields__Lamf_core_parser_Fields();
      var field$12 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
      var location = this$116.fs$1.get__O__s_Option(field$12);
      if ((!location.isEmpty__Z())) {
        var arg1$33 = location.get__O();
        var x$12$1 = $as_Lamf_core_parser_Value(arg1$33);
        var jsx$5 = (!x$12$1.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_SynthesizedField.getClassOf()))
      } else {
        var jsx$5 = false
      };
      if (jsx$5) {
        $m_Lamf_validations_CustomShaclFunctions$();
        if (location.isEmpty__Z()) {
          var exp = $m_s_None$()
        } else {
          var arg1$34 = location.get__O();
          var x$13$1 = $as_Lamf_core_parser_Value(arg1$34);
          var exp = new $c_s_Some().init___O(x$13$1.value$1)
        };
        if ((!exp.isEmpty__Z())) {
          var arg1$35 = exp.get__O();
          var x0$1$5 = $as_Lamf_core_model_domain_AmfElement(arg1$35);
          if ((x0$1$5 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
            var x2$11 = $as_Lamf_core_model_domain_AmfScalar(x0$1$5);
            if ((!$m_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$().expression__T__Z(x2$11.toString__T()))) {
              violation$19.apply__O__O(new $c_s_Some().init___O(new $c_T2().init___O__O(($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()), $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1)))
            }
          }
        }
      }
    })
  })(this));
  var jsx$6 = new $c_T2().init___O__O("validParameterLocation", y$17);
  var y$18 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$19$1) {
    return (function(element$15$2, violation$20$2) {
      var element$15 = $as_Lamf_core_model_domain_DomainElement(element$15$2);
      var violation$20 = $as_F1(violation$20$2);
      var this$121 = element$15.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$().Headers$1);
      if ((!this$121.isEmpty__Z())) {
        var arg1$36 = this$121.get__O();
        var headerElement = $as_Lamf_core_model_domain_AmfElement(arg1$36);
        var isObjectAndHasProperties = $m_Lamf_validations_CustomShaclFunctions$().validateObjectAndHasProperties__p1__Lamf_core_model_domain_AmfElement__Z(headerElement);
        if ((!isObjectAndHasProperties)) {
          violation$20.apply__O__O($m_s_None$())
        };
        new $c_s_Some().init___O((void 0))
      }
    })
  })(this));
  var jsx$4 = new $c_T2().init___O__O("mandatoryHeadersObjectNodeWithPropertiesFacet", y$18);
  var y$19 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$20$1) {
    return (function(element$16$2, violation$21$2) {
      var element$16 = $as_Lamf_core_model_domain_DomainElement(element$16$2);
      var violation$21 = $as_F1(violation$21$2);
      var this$124 = element$16.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$().Query$1);
      if ((!this$124.isEmpty__Z())) {
        var arg1$37 = this$124.get__O();
        var queryElement = $as_Lamf_core_model_domain_AmfElement(arg1$37);
        var isObjectAndHasProperties$1 = $m_Lamf_validations_CustomShaclFunctions$().validateObjectAndHasProperties__p1__Lamf_core_model_domain_AmfElement__Z(queryElement);
        if ((!isObjectAndHasProperties$1)) {
          violation$21.apply__O__O($m_s_None$())
        };
        new $c_s_Some().init___O((void 0))
      }
    })
  })(this));
  var jsx$3 = new $c_T2().init___O__O("mandatoryQueryObjectNodeWithPropertiesFacet", y$19);
  var y$20 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$21$1) {
    return (function(element$17$2, violation$22$2) {
      var element$17 = $as_Lamf_core_model_domain_DomainElement(element$17$2);
      var violation$22 = $as_F1(violation$22$2);
      var this$127 = element$17.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Headers$1);
      if ((!this$127.isEmpty__Z())) {
        var arg1$38 = this$127.get__O();
        var headerElement$1 = $as_Lamf_core_model_domain_AmfArray(arg1$38);
        var this$128 = headerElement$1.values$1.headOption__s_Option();
        if (this$128.isEmpty__Z()) {
          /*<skip>*/
        } else {
          var arg1$39 = this$128.get__O();
          var header = $as_Lamf_core_model_domain_AmfElement(arg1$39);
          if ((header instanceof $c_Lamf_plugins_domain_webapi_models_Parameter)) {
            var x2$12 = $as_Lamf_plugins_domain_webapi_models_Parameter(header);
            var x1$2$2 = $as_Lamf_core_model_domain_Shape(x2$12.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1));
            if ((x1$2$2 instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
              /*<skip>*/
            } else {
              $asUnit(violation$22.apply__O__O($m_s_None$()))
            }
          } else {
            throw new $c_s_MatchError().init___O(header)
          };
          new $c_s_Some().init___O((void 0))
        }
      }
    })
  })(this));
  var jsx$2 = new $c_T2().init___O__O("mandatoryHeadersObjectNode", y$20);
  var y$21 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$22$1) {
    return (function(element$18$2, violation$23$2) {
      var element$18 = $as_Lamf_core_model_domain_DomainElement(element$18$2);
      var violation$23 = $as_F1(violation$23$2);
      var this$131 = element$18.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().ParameterName$1);
      if ((!this$131.isEmpty__Z())) {
        var arg1$40 = this$131.get__O();
        var headerName = $as_Lamf_core_model_domain_AmfScalar(arg1$40);
        var this$132 = element$18.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1);
        if (this$132.isEmpty__Z()) {
          /*<skip>*/
        } else {
          var arg1$41 = this$132.get__O();
          var binding = $as_Lamf_core_model_domain_AmfScalar(arg1$41);
          var x1$3 = binding.toString__T();
          if (((x1$3 === "header") && $m_Lamf_validations_CustomShaclFunctions$().isInvalidHttpHeaderName__p1__T__Z(headerName.toString__T()))) {
            $asUnit(violation$23.apply__O__O($m_s_None$()))
          };
          new $c_s_Some().init___O((void 0))
        }
      }
    })
  })(this));
  var jsx$1 = new $c_T2().init___O__O("mandatoryHeaderNamePattern", y$21);
  var y$22 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$23$1) {
    return (function(element$19$2, violation$24$2) {
      var element$19 = $as_Lamf_core_model_domain_DomainElement(element$19$2);
      var violation$24 = $as_F1(violation$24$2);
      var this$135 = element$19.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$().Headers$1);
      if ((!this$135.isEmpty__Z())) {
        var arg1$42 = this$135.get__O();
        var header$1 = $as_Lamf_core_model_domain_Shape(arg1$42);
        if ((header$1 instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
          var x2$13 = $as_Lamf_plugins_domain_shapes_models_NodeShape(header$1);
          $as_sc_Seq(x2$13.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, violation$22$1) {
            return (function(p$2) {
              var p = $as_Lamf_core_model_domain_extensions_PropertyShape(p$2);
              var x1$4 = $as_Lamf_core_model_StrField(p.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
              matchEnd4: {
                if ((x1$4 instanceof $c_s_Some)) {
                  var x2$14 = $as_s_Some(x1$4);
                  var name = $as_T(x2$14.value$2);
                  if ($m_Lamf_validations_CustomShaclFunctions$().isInvalidHttpHeaderName__p1__T__Z(name)) {
                    $asUnit(violation$22$1.apply__O__O(new $c_s_Some().init___O(new $c_T2().init___O__O($as_Lamf_core_model_StrField(p.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).annotations$1, $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Name$1))));
                    break matchEnd4
                  }
                }
              }
            })
          })(this$23$1, violation$24)))
        };
        new $c_s_Some().init___O((void 0))
      }
    })
  })(this));
  var array$1 = [jsx$35, jsx$32, jsx$30, jsx$27, jsx$24, jsx$21, jsx$18, jsx$17, jsx$15, jsx$14, jsx$13, jsx$12, jsx$11, jsx$10, jsx$9, jsx$8, jsx$7, jsx$6, jsx$4, jsx$3, jsx$2, jsx$1, new $c_T2().init___O__O("mandatoryHeaderBindingNamePattern", y$22)];
  var this$140 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array$1.length);
  while ((i < len)) {
    var index = i;
    var arg1$43 = array$1[index];
    this$140.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1$43));
    i = ((1 + i) | 0)
  };
  this.functions$1 = $as_sci_Map(this$140.elems$1);
  return this
});
$c_Lamf_validations_CustomShaclFunctions$.prototype.isInvalidHttpHeaderName__p1__T__Z = (function(name) {
  if ((name === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  return (!$m_ju_regex_Pattern$().matches__T__jl_CharSequence__Z("^[!#$%&'*\\+\\-\\.^\\_\\`\\|\\~0-9a-zA-Z]+$", name))
});
$c_Lamf_validations_CustomShaclFunctions$.prototype.validateObjectAndHasProperties__p1__Lamf_core_model_domain_AmfElement__Z = (function(element) {
  if ((element instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_NodeShape(element);
    if ($as_sc_Seq(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1)).exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(p$2) {
        var p = $as_Lamf_core_model_domain_extensions_PropertyShape(p$2);
        return $as_Lamf_core_model_StrField(p.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().PatternName$1)).option$1.isEmpty__Z()
      })
    })(this)))) {
      return true
    } else {
      var this$1 = x2.fields$2;
      var f = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1;
      return this$1.fs$1.contains__O__Z(f)
    }
  } else {
    return false
  }
});
var $d_Lamf_validations_CustomShaclFunctions$ = new $TypeData().initClass({
  Lamf_validations_CustomShaclFunctions$: 0
}, false, "amf.validations.CustomShaclFunctions$", {
  Lamf_validations_CustomShaclFunctions$: 1,
  O: 1
});
$c_Lamf_validations_CustomShaclFunctions$.prototype.$classData = $d_Lamf_validations_CustomShaclFunctions$;
var $n_Lamf_validations_CustomShaclFunctions$ = (void 0);
function $m_Lamf_validations_CustomShaclFunctions$() {
  if ((!$n_Lamf_validations_CustomShaclFunctions$)) {
    $n_Lamf_validations_CustomShaclFunctions$ = new $c_Lamf_validations_CustomShaclFunctions$().init___()
  };
  return $n_Lamf_validations_CustomShaclFunctions$
}
function $is_Ljava_io_Closeable(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Ljava_io_Closeable)))
}
function $as_Ljava_io_Closeable(obj) {
  return (($is_Ljava_io_Closeable(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "java.io.Closeable"))
}
function $isArrayOf_Ljava_io_Closeable(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Ljava_io_Closeable)))
}
function $asArrayOf_Ljava_io_Closeable(obj, depth) {
  return (($isArrayOf_Ljava_io_Closeable(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.io.Closeable;", depth))
}
/** @constructor */
function $c_Ljava_math_BigInteger$QuotAndRem() {
  $c_O.call(this);
  this.quot$1 = null;
  this.rem$1 = null
}
$c_Ljava_math_BigInteger$QuotAndRem.prototype = new $h_O();
$c_Ljava_math_BigInteger$QuotAndRem.prototype.constructor = $c_Ljava_math_BigInteger$QuotAndRem;
/** @constructor */
function $h_Ljava_math_BigInteger$QuotAndRem() {
  /*<skip>*/
}
$h_Ljava_math_BigInteger$QuotAndRem.prototype = $c_Ljava_math_BigInteger$QuotAndRem.prototype;
$c_Ljava_math_BigInteger$QuotAndRem.prototype.toArray__ALjava_math_BigInteger = (function() {
  return $makeNativeArrayWrapper($d_Ljava_math_BigInteger.getArrayOf(), [this.quot$1, this.rem$1])
});
$c_Ljava_math_BigInteger$QuotAndRem.prototype.init___Ljava_math_BigInteger__Ljava_math_BigInteger = (function(quot, rem) {
  this.quot$1 = quot;
  this.rem$1 = rem;
  return this
});
var $d_Ljava_math_BigInteger$QuotAndRem = new $TypeData().initClass({
  Ljava_math_BigInteger$QuotAndRem: 0
}, false, "java.math.BigInteger$QuotAndRem", {
  Ljava_math_BigInteger$QuotAndRem: 1,
  O: 1
});
$c_Ljava_math_BigInteger$QuotAndRem.prototype.$classData = $d_Ljava_math_BigInteger$QuotAndRem;
/** @constructor */
function $c_Ljava_math_BitLevel$() {
  $c_O.call(this)
}
$c_Ljava_math_BitLevel$.prototype = new $h_O();
$c_Ljava_math_BitLevel$.prototype.constructor = $c_Ljava_math_BitLevel$;
/** @constructor */
function $h_Ljava_math_BitLevel$() {
  /*<skip>*/
}
$h_Ljava_math_BitLevel$.prototype = $c_Ljava_math_BitLevel$.prototype;
$c_Ljava_math_BitLevel$.prototype.init___ = (function() {
  return this
});
$c_Ljava_math_BitLevel$.prototype.shiftLeftOneBit__AI__AI__I__V = (function(result, source, srcLen) {
  var elem$1 = 0;
  elem$1 = 0;
  var i = 0;
  while ((i < srcLen)) {
    var arg1 = i;
    var iVal = source.get(arg1);
    result.set(arg1, ((iVal << 1) | elem$1));
    elem$1 = ((iVal >>> 31) | 0);
    i = ((1 + i) | 0)
  };
  if ((elem$1 !== 0)) {
    result.set(srcLen, elem$1)
  }
});
$c_Ljava_math_BitLevel$.prototype.shiftLeft__Ljava_math_BigInteger__I__Ljava_math_BigInteger = (function(source, count) {
  var intCount = (count >> 5);
  var andCount = (31 & count);
  var offset = ((andCount === 0) ? 0 : 1);
  var resLength = ((((source.numberLength$2 + intCount) | 0) + offset) | 0);
  var resDigits = $newArrayObject($d_I.getArrayOf(), [resLength]);
  this.shiftLeft__AI__AI__I__I__V(resDigits, source.digits$2, intCount, andCount);
  var result = new $c_Ljava_math_BigInteger().init___I__I__AI(source.sign$2, resLength, resDigits);
  result.cutOffLeadingZeroes__V();
  return result
});
$c_Ljava_math_BitLevel$.prototype.shiftRight__Ljava_math_BigInteger__I__Ljava_math_BigInteger = (function(source, count) {
  var intCount = (count >> 5);
  var andCount = (31 & count);
  if ((intCount >= source.numberLength$2)) {
    return ((source.sign$2 < 0) ? $m_Ljava_math_BigInteger$().MINUS$undONE$1 : $m_Ljava_math_BigInteger$().ZERO$1)
  } else {
    var resLength = ((source.numberLength$2 - intCount) | 0);
    var resDigits = $newArrayObject($d_I.getArrayOf(), [((1 + resLength) | 0)]);
    this.shiftRight__AI__I__AI__I__I__Z(resDigits, resLength, source.digits$2, intCount, andCount);
    if ((source.sign$2 < 0)) {
      var i = 0;
      while (((i < intCount) && (source.digits$2.get(i) === 0))) {
        i = ((1 + i) | 0)
      };
      var cmp = ((source.digits$2.get(i) << ((32 - andCount) | 0)) !== 0);
      if (((i < intCount) || ((andCount > 0) && cmp))) {
        i = 0;
        while (((i < resLength) && (resDigits.get(i) === (-1)))) {
          resDigits.set(i, 0);
          i = ((1 + i) | 0)
        };
        if ((i === resLength)) {
          resLength = ((1 + resLength) | 0)
        };
        var ev$1 = i;
        resDigits.set(ev$1, ((1 + resDigits.get(ev$1)) | 0))
      }
    };
    var result = new $c_Ljava_math_BigInteger().init___I__I__AI(source.sign$2, resLength, resDigits);
    result.cutOffLeadingZeroes__V();
    return result
  }
});
$c_Ljava_math_BitLevel$.prototype.shiftLeftOneBit__Ljava_math_BigInteger__Ljava_math_BigInteger = (function(source) {
  var srcLen = source.numberLength$2;
  var resLen = ((1 + srcLen) | 0);
  var resDigits = $newArrayObject($d_I.getArrayOf(), [resLen]);
  this.shiftLeftOneBit__AI__AI__I__V(resDigits, source.digits$2, srcLen);
  var result = new $c_Ljava_math_BigInteger().init___I__I__AI(source.sign$2, resLen, resDigits);
  result.cutOffLeadingZeroes__V();
  return result
});
$c_Ljava_math_BitLevel$.prototype.bitLength__Ljava_math_BigInteger__I = (function(bi) {
  if ((bi.sign$2 === 0)) {
    return 0
  } else {
    var bLength = (bi.numberLength$2 << 5);
    var highDigit = bi.digits$2.get((((-1) + bi.numberLength$2) | 0));
    if ((bi.sign$2 < 0)) {
      var i = bi.getFirstNonzeroDigit__I();
      if ((i === (((-1) + bi.numberLength$2) | 0))) {
        highDigit = (((-1) + highDigit) | 0)
      }
    };
    bLength = ((bLength - $clz32(highDigit)) | 0);
    return bLength
  }
});
$c_Ljava_math_BitLevel$.prototype.shiftRight__AI__I__AI__I__I__Z = (function(result, resultLen, source, intCount, count) {
  var i = 0;
  var allZero = true;
  while ((i < intCount)) {
    allZero = (!(!(allZero & (source.get(i) === 0))));
    i = ((1 + i) | 0)
  };
  if ((count === 0)) {
    $systemArraycopy(source, intCount, result, 0, resultLen)
  } else {
    var leftShiftCount = ((32 - count) | 0);
    allZero = (!(!(allZero & ((source.get(i) << leftShiftCount) === 0))));
    i = 0;
    while ((i < (((-1) + resultLen) | 0))) {
      result.set(i, (((source.get(((i + intCount) | 0)) >>> count) | 0) | (source.get(((1 + ((i + intCount) | 0)) | 0)) << leftShiftCount)));
      i = ((1 + i) | 0)
    };
    result.set(i, ((source.get(((i + intCount) | 0)) >>> count) | 0));
    i = ((1 + i) | 0)
  };
  return allZero
});
$c_Ljava_math_BitLevel$.prototype.shiftLeft__AI__AI__I__I__V = (function(result, source, intCount, count) {
  if ((count === 0)) {
    $systemArraycopy(source, 0, result, intCount, ((result.u.length - intCount) | 0))
  } else {
    var rightShiftCount = ((32 - count) | 0);
    result.set((((-1) + result.u.length) | 0), 0);
    var i = (((-1) + result.u.length) | 0);
    while ((i > intCount)) {
      var ev$1 = i;
      result.set(ev$1, (result.get(ev$1) | ((source.get((((-1) + ((i - intCount) | 0)) | 0)) >>> rightShiftCount) | 0)));
      result.set((((-1) + i) | 0), (source.get((((-1) + ((i - intCount) | 0)) | 0)) << count));
      i = (((-1) + i) | 0)
    }
  };
  var i$1 = 0;
  while ((i$1 < intCount)) {
    var arg1 = i$1;
    result.set(arg1, 0);
    i$1 = ((1 + i$1) | 0)
  }
});
var $d_Ljava_math_BitLevel$ = new $TypeData().initClass({
  Ljava_math_BitLevel$: 0
}, false, "java.math.BitLevel$", {
  Ljava_math_BitLevel$: 1,
  O: 1
});
$c_Ljava_math_BitLevel$.prototype.$classData = $d_Ljava_math_BitLevel$;
var $n_Ljava_math_BitLevel$ = (void 0);
function $m_Ljava_math_BitLevel$() {
  if ((!$n_Ljava_math_BitLevel$)) {
    $n_Ljava_math_BitLevel$ = new $c_Ljava_math_BitLevel$().init___()
  };
  return $n_Ljava_math_BitLevel$
}
/** @constructor */
function $c_Ljava_math_Conversion$() {
  $c_O.call(this);
  this.DigitFitInInt$1 = null;
  this.BigRadices$1 = null
}
$c_Ljava_math_Conversion$.prototype = new $h_O();
$c_Ljava_math_Conversion$.prototype.constructor = $c_Ljava_math_Conversion$;
/** @constructor */
function $h_Ljava_math_Conversion$() {
  /*<skip>*/
}
$h_Ljava_math_Conversion$.prototype = $c_Ljava_math_Conversion$.prototype;
$c_Ljava_math_Conversion$.prototype.init___ = (function() {
  $n_Ljava_math_Conversion$ = this;
  this.DigitFitInInt$1 = $makeNativeArrayWrapper($d_I.getArrayOf(), [(-1), (-1), 31, 19, 15, 13, 11, 11, 10, 9, 9, 8, 8, 8, 8, 7, 7, 7, 7, 7, 7, 7, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 5]);
  this.BigRadices$1 = $makeNativeArrayWrapper($d_I.getArrayOf(), [(-2147483648), 1162261467, 1073741824, 1220703125, 362797056, 1977326743, 1073741824, 387420489, 1000000000, 214358881, 429981696, 815730721, 1475789056, 170859375, 268435456, 410338673, 612220032, 893871739, 1280000000, 1801088541, 113379904, 148035889, 191102976, 244140625, 308915776, 387420489, 481890304, 594823321, 729000000, 887503681, 1073741824, 1291467969, 1544804416, 1838265625, 60466176]);
  return this
});
$c_Ljava_math_Conversion$.prototype.toDecimalScaledString__J__I__T = (function(value, scale) {
  if (((value.lo$2 === 0) && (value.hi$2 === 0))) {
    switch (scale) {
      case 0: {
        return "0";
        break
      }
      case 1: {
        return "0.0";
        break
      }
      case 2: {
        return "0.00";
        break
      }
      case 3: {
        return "0.000";
        break
      }
      case 4: {
        return "0.0000";
        break
      }
      case 5: {
        return "0.00000";
        break
      }
      case 6: {
        return "0.000000";
        break
      }
      default: {
        if ((scale === (-2147483648))) {
          var scaleVal = "2147483648"
        } else {
          var i = ((-scale) | 0);
          var scaleVal = ("" + i)
        };
        var result = ((scale < 0) ? "0E+" : "0E");
        return (result + scaleVal)
      }
    }
  } else {
    var ahi = value.hi$2;
    var negNumber = (ahi < 0);
    var elem$1 = null;
    elem$1 = "";
    var currentChar = 18;
    if (negNumber) {
      var lo = value.lo$2;
      var hi = value.hi$2;
      var lo$1 = ((-lo) | 0);
      var hi$1 = ((lo !== 0) ? (~hi) : ((-hi) | 0));
      var x_$_lo$2 = lo$1;
      var x_$_hi$2 = hi$1;
      var t = new $c_sjsr_RuntimeLong().init___I__I(x_$_lo$2, x_$_hi$2)
    } else {
      var t = value
    };
    var lo$2 = t.lo$2;
    var hi$2 = t.hi$2;
    var v_$_lo$2 = lo$2;
    var v_$_hi$2 = hi$2;
    while (true) {
      var prev_$_lo$2 = v_$_lo$2;
      var prev_$_hi$2 = v_$_hi$2;
      var this$5_$_lo$2 = v_$_lo$2;
      var this$5_$_hi$2 = v_$_hi$2;
      var this$6 = $m_sjsr_RuntimeLong$();
      var lo$3 = this$6.divideImpl__I__I__I__I__I(this$5_$_lo$2, this$5_$_hi$2, 10, 0);
      var hi$3 = this$6.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
      var jsx$1_$_lo$2 = lo$3;
      var jsx$1_$_hi$2 = hi$3;
      v_$_lo$2 = jsx$1_$_lo$2;
      v_$_hi$2 = jsx$1_$_hi$2;
      currentChar = (((-1) + currentChar) | 0);
      var b_$_lo$2 = v_$_lo$2;
      var b_$_hi$2 = v_$_hi$2;
      var blo = b_$_lo$2;
      var b0 = (65535 & blo);
      var b1 = ((blo >>> 16) | 0);
      var a0b0 = $imul(10, b0);
      var a0b1 = $imul(10, b1);
      var lo$4 = ((a0b0 + (a0b1 << 16)) | 0);
      var c1part = ((((a0b0 >>> 16) | 0) + a0b1) | 0);
      var hi$4 = (($imul(10, b_$_hi$2) + ((c1part >>> 16) | 0)) | 0);
      var alo = prev_$_lo$2;
      var ahi$1 = prev_$_hi$2;
      var lo$5 = ((alo - lo$4) | 0);
      elem$1 = (("" + lo$5) + $as_T(elem$1));
      var this$9_$_lo$2 = v_$_lo$2;
      var this$9_$_hi$2 = v_$_hi$2;
      if ((!((this$9_$_lo$2 === 0) && (this$9_$_hi$2 === 0)))) {
        /*<skip>*/
      } else {
        break
      }
    };
    var exponent = (((-1) + ((((18 - currentChar) | 0) - scale) | 0)) | 0);
    if (((scale > 0) && (exponent >= (-6)))) {
      var index = ((1 + exponent) | 0);
      if ((index > 0)) {
        var thiz = $as_T(elem$1);
        var jsx$2 = $as_T(thiz.substring(0, index));
        var thiz$1 = $as_T(elem$1);
        elem$1 = ((jsx$2 + ".") + $as_T(thiz$1.substring(index)))
      } else {
        var end = ((-index) | 0);
        var i$1 = 0;
        while ((i$1 < end)) {
          var arg1 = i$1;
          elem$1 = ("0" + $as_T(elem$1));
          i$1 = ((1 + i$1) | 0)
        };
        elem$1 = ("0." + $as_T(elem$1))
      }
    } else if ((scale !== 0)) {
      var result1 = ("" + exponent);
      if ((exponent > 0)) {
        result1 = ("+" + result1)
      };
      result1 = ("E" + result1);
      if ((((18 - currentChar) | 0) > 1)) {
        var thiz$2 = $as_T(elem$1);
        var jsx$3 = $as_T(thiz$2.substring(0, 1));
        var thiz$3 = $as_T(elem$1);
        elem$1 = (((jsx$3 + ".") + $as_T(thiz$3.substring(1))) + result1)
      } else {
        elem$1 = (("" + $as_T(elem$1)) + result1)
      }
    };
    return (negNumber ? ("-" + $as_T(elem$1)) : $as_T(elem$1))
  }
});
$c_Ljava_math_Conversion$.prototype.dropLeadingZeros__p1__T__T = (function(s) {
  var zeroPrefixLength = 0;
  var len = $uI(s.length);
  while (true) {
    if ((zeroPrefixLength < len)) {
      var index = zeroPrefixLength;
      var jsx$1 = ((65535 & $uI(s.charCodeAt(index))) === 48)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      zeroPrefixLength = ((1 + zeroPrefixLength) | 0)
    } else {
      break
    }
  };
  var beginIndex = zeroPrefixLength;
  return $as_T(s.substring(beginIndex))
});
$c_Ljava_math_Conversion$.prototype.toDecimalScaledString__Ljava_math_BigInteger__T = (function(bi) {
  var sign = bi.sign$2;
  var numberLength = bi.numberLength$2;
  var digits = bi.digits$2;
  if ((sign === 0)) {
    return "0"
  } else if ((numberLength === 1)) {
    var i = digits.get(0);
    var x = $uD((i >>> 0));
    var jsx$1 = x.toString(10);
    var absStr = $as_T(jsx$1);
    return ((sign < 0) ? ("-" + absStr) : absStr)
  } else {
    var result = "";
    var temp = $newArrayObject($d_I.getArrayOf(), [numberLength]);
    var tempLen = numberLength;
    $systemArraycopy(digits, 0, temp, 0, tempLen);
    do {
      var rem = 0;
      var i$1 = (((-1) + tempLen) | 0);
      while ((i$1 >= 0)) {
        var value = rem;
        var value$1 = temp.get(i$1);
        var this$6 = $m_sjsr_RuntimeLong$();
        var lo = this$6.divideUnsignedImpl__I__I__I__I__I(value$1, value, 1000000000, 0);
        temp.set(i$1, lo);
        var hi$3 = (lo >> 31);
        var b0 = (65535 & lo);
        var b1 = ((lo >>> 16) | 0);
        var a0b0 = $imul(51712, b0);
        var a1b0 = $imul(15258, b0);
        var a0b1 = $imul(51712, b1);
        var lo$1 = ((a0b0 + (((a1b0 + a0b1) | 0) << 16)) | 0);
        var c1part = ((((a0b0 >>> 16) | 0) + a0b1) | 0);
        var hi$4 = (((((($imul(1000000000, hi$3) + $imul(15258, b1)) | 0) + ((c1part >>> 16) | 0)) | 0) + (((((65535 & c1part) + a1b0) | 0) >>> 16) | 0)) | 0);
        var lo$2 = ((value$1 - lo$1) | 0);
        rem = lo$2;
        i$1 = (((-1) + i$1) | 0)
      };
      var this$8 = rem;
      var remStr = ("" + this$8);
      var beginIndex = $uI(remStr.length);
      var padding = $as_T("000000000".substring(beginIndex));
      result = ((padding + remStr) + result);
      while (((tempLen !== 0) && (temp.get((((-1) + tempLen) | 0)) === 0))) {
        tempLen = (((-1) + tempLen) | 0)
      }
    } while ((tempLen !== 0));
    result = this.dropLeadingZeros__p1__T__T(result);
    return ((sign < 0) ? ("-" + result) : result)
  }
});
var $d_Ljava_math_Conversion$ = new $TypeData().initClass({
  Ljava_math_Conversion$: 0
}, false, "java.math.Conversion$", {
  Ljava_math_Conversion$: 1,
  O: 1
});
$c_Ljava_math_Conversion$.prototype.$classData = $d_Ljava_math_Conversion$;
var $n_Ljava_math_Conversion$ = (void 0);
function $m_Ljava_math_Conversion$() {
  if ((!$n_Ljava_math_Conversion$)) {
    $n_Ljava_math_Conversion$ = new $c_Ljava_math_Conversion$().init___()
  };
  return $n_Ljava_math_Conversion$
}
/** @constructor */
function $c_Ljava_math_Division$() {
  $c_O.call(this)
}
$c_Ljava_math_Division$.prototype = new $h_O();
$c_Ljava_math_Division$.prototype.constructor = $c_Ljava_math_Division$;
/** @constructor */
function $h_Ljava_math_Division$() {
  /*<skip>*/
}
$h_Ljava_math_Division$.prototype = $c_Ljava_math_Division$.prototype;
$c_Ljava_math_Division$.prototype.init___ = (function() {
  return this
});
$c_Ljava_math_Division$.prototype.divide__AI__I__AI__I__AI__I__AI = (function(quot, quotLength, a, aLength, b, bLength) {
  var normA = $newArrayObject($d_I.getArrayOf(), [((1 + aLength) | 0)]);
  var normB = $newArrayObject($d_I.getArrayOf(), [((1 + bLength) | 0)]);
  var divisorShift = $clz32(b.get((((-1) + bLength) | 0)));
  if ((divisorShift !== 0)) {
    $m_Ljava_math_BitLevel$().shiftLeft__AI__AI__I__I__V(normB, b, 0, divisorShift);
    $m_Ljava_math_BitLevel$().shiftLeft__AI__AI__I__I__V(normA, a, 0, divisorShift)
  } else {
    $systemArraycopy(a, 0, normA, 0, aLength);
    $systemArraycopy(b, 0, normB, 0, bLength)
  };
  var firstDivisorDigit = normB.get((((-1) + bLength) | 0));
  var i = (((-1) + quotLength) | 0);
  var elem$1 = 0;
  elem$1 = aLength;
  while ((i >= 0)) {
    var elem$1$1 = 0;
    elem$1$1 = 0;
    if ((normA.get(elem$1) === firstDivisorDigit)) {
      elem$1$1 = (-1)
    } else {
      var value = normA.get(elem$1);
      var value$1 = normA.get((((-1) + elem$1) | 0));
      var this$4 = $m_sjsr_RuntimeLong$();
      var lo = this$4.divideUnsignedImpl__I__I__I__I__I(value$1, value, firstDivisorDigit, 0);
      var hi$3 = this$4.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
      elem$1$1 = lo;
      var a0 = (65535 & lo);
      var a1 = ((lo >>> 16) | 0);
      var b0 = (65535 & firstDivisorDigit);
      var b1 = ((firstDivisorDigit >>> 16) | 0);
      var a0b0 = $imul(a0, b0);
      var a1b0 = $imul(a1, b0);
      var a0b1 = $imul(a0, b1);
      var lo$1 = ((a0b0 + (((a1b0 + a0b1) | 0) << 16)) | 0);
      var c1part = ((((a0b0 >>> 16) | 0) + a0b1) | 0);
      var hi$4 = (((((($imul(hi$3, firstDivisorDigit) + $imul(a1, b1)) | 0) + ((c1part >>> 16) | 0)) | 0) + (((((65535 & c1part) + a1b0) | 0) >>> 16) | 0)) | 0);
      var lo$2 = ((value$1 - lo$1) | 0);
      var elem$1$2 = 0;
      elem$1$2 = lo$2;
      if ((elem$1$1 !== 0)) {
        elem$1$1 = ((1 + elem$1$1) | 0);
        _loop: while (true) {
          elem$1$1 = (((-1) + elem$1$1) | 0);
          var value$2 = elem$1$1;
          var value$3 = normB.get((((-2) + bLength) | 0));
          var a0$1 = (65535 & value$2);
          var a1$1 = ((value$2 >>> 16) | 0);
          var b0$1 = (65535 & value$3);
          var b1$1 = ((value$3 >>> 16) | 0);
          var a0b0$1 = $imul(a0$1, b0$1);
          var a1b0$1 = $imul(a1$1, b0$1);
          var a0b1$1 = $imul(a0$1, b1$1);
          var lo$3 = ((a0b0$1 + (((a1b0$1 + a0b1$1) | 0) << 16)) | 0);
          var c1part$1 = ((((a0b0$1 >>> 16) | 0) + a0b1$1) | 0);
          var hi$8 = (((($imul(a1$1, b1$1) + ((c1part$1 >>> 16) | 0)) | 0) + (((((65535 & c1part$1) + a1b0$1) | 0) >>> 16) | 0)) | 0);
          var value$4 = elem$1$2;
          var value$5 = normA.get((((-2) + elem$1) | 0));
          var value$6 = elem$1$2;
          var lo$4 = ((value$6 + firstDivisorDigit) | 0);
          var hi$13 = ((((-2147483648) ^ lo$4) < ((-2147483648) ^ value$6)) ? 1 : 0);
          if ((hi$13 === 0)) {
            elem$1$2 = lo$4;
            var hi$14 = ((-2147483648) ^ hi$8);
            var hi$15 = ((-2147483648) ^ value$4);
            if (((hi$14 === hi$15) ? (((-2147483648) ^ lo$3) > ((-2147483648) ^ value$5)) : (hi$14 > hi$15))) {
              continue _loop
            }
          };
          break
        }
      }
    };
    if ((elem$1$1 !== 0)) {
      var borrow = $m_Ljava_math_Division$().multiplyAndSubtract__AI__I__AI__I__I__I(normA, ((elem$1 - bLength) | 0), normB, bLength, elem$1$1);
      if ((borrow !== 0)) {
        elem$1$1 = (((-1) + elem$1$1) | 0);
        var elem$1$3_$_lo$2 = 0;
        var elem$1$3_$_hi$2 = 0;
        var jsx$1_$_lo$2 = 0;
        var jsx$1_$_hi$2 = 0;
        elem$1$3_$_lo$2 = jsx$1_$_lo$2;
        elem$1$3_$_hi$2 = jsx$1_$_hi$2;
        var i$1 = 0;
        while ((i$1 < bLength)) {
          var arg1 = i$1;
          var this$13_$_lo$2 = elem$1$3_$_lo$2;
          var this$13_$_hi$2 = elem$1$3_$_hi$2;
          var value$7 = normA.get(((((elem$1 - bLength) | 0) + arg1) | 0));
          var value$8 = normB.get(arg1);
          var lo$5 = ((value$7 + value$8) | 0);
          var hi$18 = ((((-2147483648) ^ lo$5) < ((-2147483648) ^ value$7)) ? 1 : 0);
          var alo = this$13_$_lo$2;
          var ahi = this$13_$_hi$2;
          var lo$6 = ((alo + lo$5) | 0);
          var hi$19 = ((((-2147483648) ^ lo$6) < ((-2147483648) ^ alo)) ? ((1 + ((ahi + hi$18) | 0)) | 0) : ((ahi + hi$18) | 0));
          var jsx$2_$_lo$2 = lo$6;
          var jsx$2_$_hi$2 = hi$19;
          elem$1$3_$_lo$2 = jsx$2_$_lo$2;
          elem$1$3_$_hi$2 = jsx$2_$_hi$2;
          var jsx$3 = elem$1;
          var this$15_$_lo$2 = elem$1$3_$_lo$2;
          var this$15_$_hi$2 = elem$1$3_$_hi$2;
          normA.set(((((jsx$3 - bLength) | 0) + arg1) | 0), this$15_$_lo$2);
          var this$16_$_lo$2 = elem$1$3_$_lo$2;
          var this$16_$_hi$2 = elem$1$3_$_hi$2;
          var lo$7 = this$16_$_hi$2;
          var jsx$4_$_lo$2 = lo$7;
          var jsx$4_$_hi$2 = 0;
          elem$1$3_$_lo$2 = jsx$4_$_lo$2;
          elem$1$3_$_hi$2 = jsx$4_$_hi$2;
          i$1 = ((1 + i$1) | 0)
        }
      }
    };
    if ((quot !== null)) {
      quot.set(i, elem$1$1)
    };
    elem$1 = (((-1) + elem$1) | 0);
    i = (((-1) + i) | 0)
  };
  return ((divisorShift !== 0) ? ($m_Ljava_math_BitLevel$().shiftRight__AI__I__AI__I__I__Z(normB, bLength, normA, 0, divisorShift), normB) : ($systemArraycopy(normA, 0, normB, 0, bLength), normA))
});
$c_Ljava_math_Division$.prototype.divideAndRemainderByInteger__Ljava_math_BigInteger__I__I__Ljava_math_BigInteger$QuotAndRem = (function(bi, divisor, divisorSign) {
  var valDigits = bi.digits$2;
  var valLen = bi.numberLength$2;
  var valSign = bi.sign$2;
  if ((valLen === 1)) {
    var valDigit = valDigits.get(0);
    var n = ($uD((valDigit >>> 0)) / $uD((divisor >>> 0)));
    var value = $uI((n | 0));
    var quo_$_lo$2 = value;
    var quo_$_hi$2 = 0;
    var n$1 = ($uD((valDigit >>> 0)) % $uD((divisor >>> 0)));
    var value$1 = $uI((n$1 | 0));
    var rem_$_lo$2 = value$1;
    var rem_$_hi$2 = 0;
    if ((valSign !== divisorSign)) {
      var this$11_$_lo$2 = quo_$_lo$2;
      var this$11_$_hi$2 = quo_$_hi$2;
      var lo = this$11_$_lo$2;
      var hi$2 = this$11_$_hi$2;
      var lo$1 = ((-lo) | 0);
      var hi$3 = ((lo !== 0) ? (~hi$2) : ((-hi$2) | 0));
      var jsx$1_$_lo$2 = lo$1;
      var jsx$1_$_hi$2 = hi$3;
      quo_$_lo$2 = jsx$1_$_lo$2;
      quo_$_hi$2 = jsx$1_$_hi$2
    };
    if ((valSign < 0)) {
      var this$14_$_lo$2 = rem_$_lo$2;
      var this$14_$_hi$2 = rem_$_hi$2;
      var lo$2 = this$14_$_lo$2;
      var hi$4 = this$14_$_hi$2;
      var lo$3 = ((-lo$2) | 0);
      var hi$5 = ((lo$2 !== 0) ? (~hi$4) : ((-hi$4) | 0));
      var jsx$2_$_lo$2 = lo$3;
      var jsx$2_$_hi$2 = hi$5;
      rem_$_lo$2 = jsx$2_$_lo$2;
      rem_$_hi$2 = jsx$2_$_hi$2
    };
    return new $c_Ljava_math_BigInteger$QuotAndRem().init___Ljava_math_BigInteger__Ljava_math_BigInteger($m_Ljava_math_BigInteger$().valueOf__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(quo_$_lo$2, quo_$_hi$2)), $m_Ljava_math_BigInteger$().valueOf__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(rem_$_lo$2, rem_$_hi$2)))
  } else {
    var quotientSign = ((valSign === divisorSign) ? 1 : (-1));
    var quotientDigits = $newArrayObject($d_I.getArrayOf(), [valLen]);
    var div = this.divideArrayByInt__AI__AI__I__I__I(quotientDigits, valDigits, valLen, divisor);
    var remainderDigits = $makeNativeArrayWrapper($d_I.getArrayOf(), [div]);
    var result0 = new $c_Ljava_math_BigInteger().init___I__I__AI(quotientSign, valLen, quotientDigits);
    var result1 = new $c_Ljava_math_BigInteger().init___I__I__AI(valSign, 1, remainderDigits);
    result0.cutOffLeadingZeroes__V();
    result1.cutOffLeadingZeroes__V();
    return new $c_Ljava_math_BigInteger$QuotAndRem().init___Ljava_math_BigInteger__Ljava_math_BigInteger(result0, result1)
  }
});
$c_Ljava_math_Division$.prototype.multiplyAndSubtract__AI__I__AI__I__I__I = (function(a, start, b, bLen, c) {
  var elem$1 = 0;
  elem$1 = 0;
  var elem$1$1 = 0;
  elem$1$1 = 0;
  var i = 0;
  while ((i < bLen)) {
    var arg1 = i;
    $m_Ljava_math_Multiplication$();
    var a$1 = b.get(arg1);
    var c$1 = elem$1;
    var a0 = (65535 & a$1);
    var a1 = ((a$1 >>> 16) | 0);
    var b0 = (65535 & c);
    var b1 = ((c >>> 16) | 0);
    var a0b0 = $imul(a0, b0);
    var a1b0 = $imul(a1, b0);
    var a0b1 = $imul(a0, b1);
    var lo = ((a0b0 + (((a1b0 + a0b1) | 0) << 16)) | 0);
    var c1part = ((((a0b0 >>> 16) | 0) + a0b1) | 0);
    var hi$2 = (((($imul(a1, b1) + ((c1part >>> 16) | 0)) | 0) + (((((65535 & c1part) + a1b0) | 0) >>> 16) | 0)) | 0);
    var lo$1 = ((lo + c$1) | 0);
    var hi$4 = ((((-2147483648) ^ lo$1) < ((-2147483648) ^ lo)) ? ((1 + hi$2) | 0) : hi$2);
    var value = a.get(((start + arg1) | 0));
    var lo$2 = ((value - lo$1) | 0);
    var hi$6 = ((((-2147483648) ^ lo$2) > ((-2147483648) ^ value)) ? (-1) : 0);
    var value$1 = elem$1$1;
    var hi$7 = (value$1 >> 31);
    var lo$3 = ((lo$2 + value$1) | 0);
    var hi$8 = ((((-2147483648) ^ lo$3) < ((-2147483648) ^ lo$2)) ? ((1 + ((hi$6 + hi$7) | 0)) | 0) : ((hi$6 + hi$7) | 0));
    a.set(((start + arg1) | 0), lo$3);
    elem$1$1 = hi$8;
    elem$1 = hi$4;
    i = ((1 + i) | 0)
  };
  var value$2 = a.get(((start + bLen) | 0));
  var value$3 = elem$1;
  var lo$4 = ((value$2 - value$3) | 0);
  var hi$13 = ((((-2147483648) ^ lo$4) > ((-2147483648) ^ value$2)) ? (-1) : 0);
  var value$4 = elem$1$1;
  var hi$14 = (value$4 >> 31);
  var lo$5 = ((lo$4 + value$4) | 0);
  var hi$15 = ((((-2147483648) ^ lo$5) < ((-2147483648) ^ lo$4)) ? ((1 + ((hi$13 + hi$14) | 0)) | 0) : ((hi$13 + hi$14) | 0));
  a.set(((start + bLen) | 0), lo$5);
  return hi$15
});
$c_Ljava_math_Division$.prototype.divideArrayByInt__AI__AI__I__I__I = (function(dest, src, srcLength, divisor) {
  var rem = 0;
  var i = (((-1) + srcLength) | 0);
  while ((i >= 0)) {
    var value = rem;
    var value$1 = src.get(i);
    var this$1 = $m_sjsr_RuntimeLong$();
    var lo = this$1.divideUnsignedImpl__I__I__I__I__I(value$1, value, divisor, 0);
    var hi$3 = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
    var a0 = (65535 & lo);
    var a1 = ((lo >>> 16) | 0);
    var b0 = (65535 & divisor);
    var b1 = ((divisor >>> 16) | 0);
    var a0b0 = $imul(a0, b0);
    var a1b0 = $imul(a1, b0);
    var a0b1 = $imul(a0, b1);
    var lo$1 = ((a0b0 + (((a1b0 + a0b1) | 0) << 16)) | 0);
    var c1part = ((((a0b0 >>> 16) | 0) + a0b1) | 0);
    var hi$4 = (((((($imul(hi$3, divisor) + $imul(a1, b1)) | 0) + ((c1part >>> 16) | 0)) | 0) + (((((65535 & c1part) + a1b0) | 0) >>> 16) | 0)) | 0);
    var lo$2 = ((value$1 - lo$1) | 0);
    rem = lo$2;
    dest.set(i, lo);
    i = (((-1) + i) | 0)
  };
  return rem
});
var $d_Ljava_math_Division$ = new $TypeData().initClass({
  Ljava_math_Division$: 0
}, false, "java.math.Division$", {
  Ljava_math_Division$: 1,
  O: 1
});
$c_Ljava_math_Division$.prototype.$classData = $d_Ljava_math_Division$;
var $n_Ljava_math_Division$ = (void 0);
function $m_Ljava_math_Division$() {
  if ((!$n_Ljava_math_Division$)) {
    $n_Ljava_math_Division$ = new $c_Ljava_math_Division$().init___()
  };
  return $n_Ljava_math_Division$
}
/** @constructor */
function $c_Ljava_math_Elementary$() {
  $c_O.call(this)
}
$c_Ljava_math_Elementary$.prototype = new $h_O();
$c_Ljava_math_Elementary$.prototype.constructor = $c_Ljava_math_Elementary$;
/** @constructor */
function $h_Ljava_math_Elementary$() {
  /*<skip>*/
}
$h_Ljava_math_Elementary$.prototype = $c_Ljava_math_Elementary$.prototype;
$c_Ljava_math_Elementary$.prototype.init___ = (function() {
  return this
});
$c_Ljava_math_Elementary$.prototype.subtract__p1__AI__I__AI__I__AI = (function(a, aSize, b, bSize) {
  var res = $newArrayObject($d_I.getArrayOf(), [aSize]);
  this.subtract__p1__AI__AI__I__AI__I__V(res, a, aSize, b, bSize);
  return res
});
$c_Ljava_math_Elementary$.prototype.compareArrays__AI__AI__I__I = (function(a, b, size) {
  var i = (((-1) + size) | 0);
  while (((i >= 0) && (a.get(i) === b.get(i)))) {
    i = (((-1) + i) | 0)
  };
  if ((i < 0)) {
    return 0
  } else {
    var value = a.get(i);
    var value$1 = b.get(i);
    if ((((-2147483648) ^ value) < ((-2147483648) ^ value$1))) {
      return (-1)
    } else {
      return 1
    }
  }
});
$c_Ljava_math_Elementary$.prototype.inplaceAdd__AI__I__I__I = (function(a, aSize, addend) {
  var carry = addend;
  var i = 0;
  while (((carry !== 0) && (i < aSize))) {
    var value = carry;
    var value$1 = a.get(i);
    var lo = ((value + value$1) | 0);
    var hi$2 = ((((-2147483648) ^ lo) < ((-2147483648) ^ value)) ? 1 : 0);
    a.set(i, lo);
    carry = hi$2;
    i = ((1 + i) | 0)
  };
  return carry
});
$c_Ljava_math_Elementary$.prototype.add__p1__AI__I__AI__I__AI = (function(a, aSize, b, bSize) {
  var res = $newArrayObject($d_I.getArrayOf(), [((1 + aSize) | 0)]);
  this.add__p1__AI__AI__I__AI__I__V(res, a, aSize, b, bSize);
  return res
});
$c_Ljava_math_Elementary$.prototype.add__Ljava_math_BigInteger__Ljava_math_BigInteger__Ljava_math_BigInteger = (function(op1, op2) {
  var op1Sign = op1.sign$2;
  var op2Sign = op2.sign$2;
  var op1Len = op1.numberLength$2;
  var op2Len = op2.numberLength$2;
  if ((op1Sign === 0)) {
    return op2
  } else if ((op2Sign === 0)) {
    return op1
  } else if ((((op1Len + op2Len) | 0) === 2)) {
    var value = op1.digits$2.get(0);
    var value$1 = op2.digits$2.get(0);
    if ((op1Sign === op2Sign)) {
      var lo = ((value + value$1) | 0);
      var hi$2 = ((((-2147483648) ^ lo) < ((-2147483648) ^ value)) ? 1 : 0);
      return ((hi$2 === 0) ? new $c_Ljava_math_BigInteger().init___I__I(op1Sign, lo) : new $c_Ljava_math_BigInteger().init___I__I__AI(op1Sign, 2, $makeNativeArrayWrapper($d_I.getArrayOf(), [lo, hi$2])))
    } else {
      var jsx$1 = $m_Ljava_math_BigInteger$();
      if ((op1Sign < 0)) {
        var lo$1 = ((value$1 - value) | 0);
        var hi$3 = ((((-2147483648) ^ lo$1) > ((-2147483648) ^ value$1)) ? (-1) : 0);
        var x_$_lo$2 = lo$1;
        var x_$_hi$2 = hi$3
      } else {
        var lo$2 = ((value - value$1) | 0);
        var hi$4 = ((((-2147483648) ^ lo$2) > ((-2147483648) ^ value)) ? (-1) : 0);
        var x_$_lo$2 = lo$2;
        var x_$_hi$2 = hi$4
      };
      return jsx$1.valueOf__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(x_$_lo$2, x_$_hi$2))
    }
  } else {
    if ((op1Sign === op2Sign)) {
      var res$2 = ((op1Len >= op2Len) ? this.add__p1__AI__I__AI__I__AI(op1.digits$2, op1Len, op2.digits$2, op2Len) : this.add__p1__AI__I__AI__I__AI(op2.digits$2, op2Len, op1.digits$2, op1Len));
      var x1_$_$$und1$f = op1Sign;
      var x1_$_$$und2$f = res$2
    } else {
      var cmp = ((op1Len !== op2Len) ? ((op1Len > op2Len) ? 1 : (-1)) : this.compareArrays__AI__AI__I__I(op1.digits$2, op2.digits$2, op1Len));
      if ((cmp === 0)) {
        return $m_Ljava_math_BigInteger$().ZERO$1
      };
      if ((cmp === 1)) {
        var _2 = this.subtract__p1__AI__I__AI__I__AI(op1.digits$2, op1Len, op2.digits$2, op2Len);
        var x1_$_$$und1$f = op1Sign;
        var x1_$_$$und2$f = _2
      } else {
        var _2$1 = this.subtract__p1__AI__I__AI__I__AI(op2.digits$2, op2Len, op1.digits$2, op1Len);
        var x1_$_$$und1$f = op2Sign;
        var x1_$_$$und2$f = _2$1
      }
    };
    var resSign = $uI(x1_$_$$und1$f);
    var resDigits = $asArrayOf_I(x1_$_$$und2$f, 1);
    var res$3 = new $c_Ljava_math_BigInteger().init___I__I__AI(resSign, resDigits.u.length, resDigits);
    res$3.cutOffLeadingZeroes__V();
    return res$3
  }
});
$c_Ljava_math_Elementary$.prototype.subtract__Ljava_math_BigInteger__Ljava_math_BigInteger__Ljava_math_BigInteger = (function(op1, op2) {
  var op1Sign = op1.sign$2;
  var op2Sign = op2.sign$2;
  var op1Len = op1.numberLength$2;
  var op2Len = op2.numberLength$2;
  if ((op2Sign === 0)) {
    return op1
  } else if ((op1Sign === 0)) {
    return op2.negate__Ljava_math_BigInteger()
  } else if ((((op1Len + op2Len) | 0) === 2)) {
    var value = op1.digits$2.get(0);
    var a_$_lo$2 = value;
    var a_$_hi$2 = 0;
    var value$1 = op2.digits$2.get(0);
    var b_$_lo$2 = value$1;
    var b_$_hi$2 = 0;
    if ((op1Sign < 0)) {
      var this$1_$_lo$2 = a_$_lo$2;
      var this$1_$_hi$2 = a_$_hi$2;
      var lo = this$1_$_lo$2;
      var hi$2 = this$1_$_hi$2;
      var lo$1 = ((-lo) | 0);
      var hi$3 = ((lo !== 0) ? (~hi$2) : ((-hi$2) | 0));
      var jsx$1_$_lo$2 = lo$1;
      var jsx$1_$_hi$2 = hi$3;
      a_$_lo$2 = jsx$1_$_lo$2;
      a_$_hi$2 = jsx$1_$_hi$2
    };
    if ((op2Sign < 0)) {
      var this$4_$_lo$2 = b_$_lo$2;
      var this$4_$_hi$2 = b_$_hi$2;
      var lo$2 = this$4_$_lo$2;
      var hi$4 = this$4_$_hi$2;
      var lo$3 = ((-lo$2) | 0);
      var hi$5 = ((lo$2 !== 0) ? (~hi$4) : ((-hi$4) | 0));
      var jsx$2_$_lo$2 = lo$3;
      var jsx$2_$_hi$2 = hi$5;
      b_$_lo$2 = jsx$2_$_lo$2;
      b_$_hi$2 = jsx$2_$_hi$2
    };
    var jsx$3 = $m_Ljava_math_BigInteger$();
    var this$7_$_lo$2 = a_$_lo$2;
    var this$7_$_hi$2 = a_$_hi$2;
    var b$1_$_lo$2 = b_$_lo$2;
    var b$1_$_hi$2 = b_$_hi$2;
    var alo = this$7_$_lo$2;
    var ahi = this$7_$_hi$2;
    var bhi = b$1_$_hi$2;
    var lo$4 = ((alo - b$1_$_lo$2) | 0);
    var hi$6 = ((((-2147483648) ^ lo$4) > ((-2147483648) ^ alo)) ? (((-1) + ((ahi - bhi) | 0)) | 0) : ((ahi - bhi) | 0));
    return jsx$3.valueOf__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(lo$4, hi$6))
  } else {
    var cmp = ((op1Len !== op2Len) ? ((op1Len > op2Len) ? 1 : (-1)) : $m_Ljava_math_Elementary$().compareArrays__AI__AI__I__I(op1.digits$2, op2.digits$2, op1Len));
    if (((op1Sign === op2Sign) && (cmp === 0))) {
      return $m_Ljava_math_BigInteger$().ZERO$1
    };
    if ((cmp === (-1))) {
      var res = ((op1Sign === op2Sign) ? this.subtract__p1__AI__I__AI__I__AI(op2.digits$2, op2Len, op1.digits$2, op1Len) : this.add__p1__AI__I__AI__I__AI(op2.digits$2, op2Len, op1.digits$2, op1Len));
      var _1 = ((-op2Sign) | 0);
      var x1_$_$$und1$f = _1;
      var x1_$_$$und2$f = res
    } else if ((op1Sign === op2Sign)) {
      var _2 = this.subtract__p1__AI__I__AI__I__AI(op1.digits$2, op1Len, op2.digits$2, op2Len);
      var x1_$_$$und1$f = op1Sign;
      var x1_$_$$und2$f = _2
    } else {
      var _2$1 = this.add__p1__AI__I__AI__I__AI(op1.digits$2, op1Len, op2.digits$2, op2Len);
      var x1_$_$$und1$f = op1Sign;
      var x1_$_$$und2$f = _2$1
    };
    var resSign = $uI(x1_$_$$und1$f);
    var resDigits = $asArrayOf_I(x1_$_$$und2$f, 1);
    var res$2 = new $c_Ljava_math_BigInteger().init___I__I__AI(resSign, resDigits.u.length, resDigits);
    res$2.cutOffLeadingZeroes__V();
    return res$2
  }
});
$c_Ljava_math_Elementary$.prototype.subtract__p1__AI__AI__I__AI__I__V = (function(res, a, aSize, b, bSize) {
  var i = 0;
  var borrow = 0;
  while ((i < bSize)) {
    var value = a.get(i);
    var value$1 = b.get(i);
    var lo = ((value - value$1) | 0);
    var hi$2 = ((((-2147483648) ^ lo) > ((-2147483648) ^ value)) ? (-1) : 0);
    var value$2 = borrow;
    var hi$3 = (value$2 >> 31);
    var lo$1 = ((lo + value$2) | 0);
    var hi$4 = ((((-2147483648) ^ lo$1) < ((-2147483648) ^ lo)) ? ((1 + ((hi$2 + hi$3) | 0)) | 0) : ((hi$2 + hi$3) | 0));
    res.set(i, lo$1);
    borrow = hi$4;
    i = ((1 + i) | 0)
  };
  while ((i < aSize)) {
    var value$3 = a.get(i);
    var value$4 = borrow;
    var hi$7 = (value$4 >> 31);
    var lo$2 = ((value$3 + value$4) | 0);
    var hi$8 = ((((-2147483648) ^ lo$2) < ((-2147483648) ^ value$3)) ? ((1 + hi$7) | 0) : hi$7);
    res.set(i, lo$2);
    borrow = hi$8;
    i = ((1 + i) | 0)
  }
});
$c_Ljava_math_Elementary$.prototype.add__p1__AI__AI__I__AI__I__V = (function(res, a, aSize, b, bSize) {
  var i = 1;
  var value = a.get(0);
  var value$1 = b.get(0);
  var lo = ((value + value$1) | 0);
  var hi$2 = ((((-2147483648) ^ lo) < ((-2147483648) ^ value)) ? 1 : 0);
  res.set(0, lo);
  var carry = hi$2;
  if ((aSize >= bSize)) {
    while ((i < bSize)) {
      var value$2 = a.get(i);
      var value$3 = b.get(i);
      var lo$1 = ((value$2 + value$3) | 0);
      var hi$6 = ((((-2147483648) ^ lo$1) < ((-2147483648) ^ value$2)) ? 1 : 0);
      var value$4 = carry;
      var lo$2 = ((lo$1 + value$4) | 0);
      var hi$8 = ((((-2147483648) ^ lo$2) < ((-2147483648) ^ lo$1)) ? ((1 + hi$6) | 0) : hi$6);
      res.set(i, lo$2);
      carry = hi$8;
      i = ((1 + i) | 0)
    };
    while ((i < aSize)) {
      var value$5 = a.get(i);
      var value$6 = carry;
      var lo$3 = ((value$5 + value$6) | 0);
      var hi$12 = ((((-2147483648) ^ lo$3) < ((-2147483648) ^ value$5)) ? 1 : 0);
      res.set(i, lo$3);
      carry = hi$12;
      i = ((1 + i) | 0)
    }
  } else {
    while ((i < aSize)) {
      var value$7 = a.get(i);
      var value$8 = b.get(i);
      var lo$4 = ((value$7 + value$8) | 0);
      var hi$16 = ((((-2147483648) ^ lo$4) < ((-2147483648) ^ value$7)) ? 1 : 0);
      var value$9 = carry;
      var lo$5 = ((lo$4 + value$9) | 0);
      var hi$18 = ((((-2147483648) ^ lo$5) < ((-2147483648) ^ lo$4)) ? ((1 + hi$16) | 0) : hi$16);
      res.set(i, lo$5);
      carry = hi$18;
      i = ((1 + i) | 0)
    };
    while ((i < bSize)) {
      var value$10 = b.get(i);
      var value$11 = carry;
      var lo$6 = ((value$10 + value$11) | 0);
      var hi$22 = ((((-2147483648) ^ lo$6) < ((-2147483648) ^ value$10)) ? 1 : 0);
      res.set(i, lo$6);
      carry = hi$22;
      i = ((1 + i) | 0)
    }
  };
  if ((carry !== 0)) {
    res.set(i, carry)
  }
});
var $d_Ljava_math_Elementary$ = new $TypeData().initClass({
  Ljava_math_Elementary$: 0
}, false, "java.math.Elementary$", {
  Ljava_math_Elementary$: 1,
  O: 1
});
$c_Ljava_math_Elementary$.prototype.$classData = $d_Ljava_math_Elementary$;
var $n_Ljava_math_Elementary$ = (void 0);
function $m_Ljava_math_Elementary$() {
  if ((!$n_Ljava_math_Elementary$)) {
    $n_Ljava_math_Elementary$ = new $c_Ljava_math_Elementary$().init___()
  };
  return $n_Ljava_math_Elementary$
}
/** @constructor */
function $c_Ljava_math_MathContext() {
  $c_O.call(this);
  this.precision$1 = 0;
  this.roundingMode$1 = null
}
$c_Ljava_math_MathContext.prototype = new $h_O();
$c_Ljava_math_MathContext.prototype.constructor = $c_Ljava_math_MathContext;
/** @constructor */
function $h_Ljava_math_MathContext() {
  /*<skip>*/
}
$h_Ljava_math_MathContext.prototype = $c_Ljava_math_MathContext.prototype;
$c_Ljava_math_MathContext.prototype.equals__O__Z = (function(x) {
  if ((x instanceof $c_Ljava_math_MathContext)) {
    var x2 = $as_Ljava_math_MathContext(x);
    if ((this.precision$1 === x2.precision$1)) {
      var x$2 = this.roundingMode$1;
      var x$3 = x2.roundingMode$1;
      return (x$2 === x$3)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Ljava_math_MathContext.prototype.toString__T = (function() {
  return ((("precision=" + this.precision$1) + " roundingMode=") + this.roundingMode$1)
});
$c_Ljava_math_MathContext.prototype.init___I__Ljava_math_RoundingMode = (function(setPrecision, setRoundingMode) {
  this.precision$1 = setPrecision;
  this.roundingMode$1 = setRoundingMode;
  return this
});
$c_Ljava_math_MathContext.prototype.hashCode__I = (function() {
  return ((this.precision$1 << 3) | this.roundingMode$1.$$undordinal$1)
});
function $as_Ljava_math_MathContext(obj) {
  return (((obj instanceof $c_Ljava_math_MathContext) || (obj === null)) ? obj : $throwClassCastException(obj, "java.math.MathContext"))
}
function $isArrayOf_Ljava_math_MathContext(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Ljava_math_MathContext)))
}
function $asArrayOf_Ljava_math_MathContext(obj, depth) {
  return (($isArrayOf_Ljava_math_MathContext(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.math.MathContext;", depth))
}
var $d_Ljava_math_MathContext = new $TypeData().initClass({
  Ljava_math_MathContext: 0
}, false, "java.math.MathContext", {
  Ljava_math_MathContext: 1,
  O: 1
});
$c_Ljava_math_MathContext.prototype.$classData = $d_Ljava_math_MathContext;
/** @constructor */
function $c_Ljava_math_MathContext$() {
  $c_O.call(this);
  this.DECIMAL128$1 = null;
  this.DECIMAL32$1 = null;
  this.DECIMAL64$1 = null;
  this.UNLIMITED$1 = null
}
$c_Ljava_math_MathContext$.prototype = new $h_O();
$c_Ljava_math_MathContext$.prototype.constructor = $c_Ljava_math_MathContext$;
/** @constructor */
function $h_Ljava_math_MathContext$() {
  /*<skip>*/
}
$h_Ljava_math_MathContext$.prototype = $c_Ljava_math_MathContext$.prototype;
$c_Ljava_math_MathContext$.prototype.init___ = (function() {
  $n_Ljava_math_MathContext$ = this;
  $m_Ljava_math_MathContext$();
  var roundingMode = $m_Ljava_math_RoundingMode$().HALF$undEVEN$1;
  this.DECIMAL128$1 = new $c_Ljava_math_MathContext().init___I__Ljava_math_RoundingMode(34, roundingMode);
  $m_Ljava_math_MathContext$();
  var roundingMode$1 = $m_Ljava_math_RoundingMode$().HALF$undEVEN$1;
  this.DECIMAL32$1 = new $c_Ljava_math_MathContext().init___I__Ljava_math_RoundingMode(7, roundingMode$1);
  $m_Ljava_math_MathContext$();
  var roundingMode$2 = $m_Ljava_math_RoundingMode$().HALF$undEVEN$1;
  this.DECIMAL64$1 = new $c_Ljava_math_MathContext().init___I__Ljava_math_RoundingMode(16, roundingMode$2);
  $m_Ljava_math_MathContext$();
  var roundingMode$3 = $m_Ljava_math_RoundingMode$().HALF$undUP$1;
  this.UNLIMITED$1 = new $c_Ljava_math_MathContext().init___I__Ljava_math_RoundingMode(0, roundingMode$3);
  return this
});
var $d_Ljava_math_MathContext$ = new $TypeData().initClass({
  Ljava_math_MathContext$: 0
}, false, "java.math.MathContext$", {
  Ljava_math_MathContext$: 1,
  O: 1
});
$c_Ljava_math_MathContext$.prototype.$classData = $d_Ljava_math_MathContext$;
var $n_Ljava_math_MathContext$ = (void 0);
function $m_Ljava_math_MathContext$() {
  if ((!$n_Ljava_math_MathContext$)) {
    $n_Ljava_math_MathContext$ = new $c_Ljava_math_MathContext$().init___()
  };
  return $n_Ljava_math_MathContext$
}
/** @constructor */
function $c_Ljava_math_Multiplication$() {
  $c_O.call(this);
  this.TenPows$1 = null;
  this.FivePows$1 = null;
  this.BigTenPows$1 = null;
  this.BigFivePows$1 = null
}
$c_Ljava_math_Multiplication$.prototype = new $h_O();
$c_Ljava_math_Multiplication$.prototype.constructor = $c_Ljava_math_Multiplication$;
/** @constructor */
function $h_Ljava_math_Multiplication$() {
  /*<skip>*/
}
$h_Ljava_math_Multiplication$.prototype = $c_Ljava_math_Multiplication$.prototype;
$c_Ljava_math_Multiplication$.prototype.multiplyPAP__Ljava_math_BigInteger__Ljava_math_BigInteger__Ljava_math_BigInteger = (function(a, b) {
  var aLen = a.numberLength$2;
  var bLen = b.numberLength$2;
  var resLength = ((aLen + bLen) | 0);
  var resSign = ((a.sign$2 !== b.sign$2) ? (-1) : 1);
  if ((resLength === 2)) {
    var a$1 = a.digits$2.get(0);
    var b$1 = b.digits$2.get(0);
    var a0 = (65535 & a$1);
    var a1 = ((a$1 >>> 16) | 0);
    var b0 = (65535 & b$1);
    var b1 = ((b$1 >>> 16) | 0);
    var a0b0 = $imul(a0, b0);
    var a1b0 = $imul(a1, b0);
    var a0b1 = $imul(a0, b1);
    var lo = ((a0b0 + (((a1b0 + a0b1) | 0) << 16)) | 0);
    var c1part = ((((a0b0 >>> 16) | 0) + a0b1) | 0);
    var hi$2 = (((($imul(a1, b1) + ((c1part >>> 16) | 0)) | 0) + (((((65535 & c1part) + a1b0) | 0) >>> 16) | 0)) | 0);
    return ((hi$2 === 0) ? new $c_Ljava_math_BigInteger().init___I__I(resSign, lo) : new $c_Ljava_math_BigInteger().init___I__I__AI(resSign, 2, $makeNativeArrayWrapper($d_I.getArrayOf(), [lo, hi$2])))
  } else {
    var aDigits = a.digits$2;
    var bDigits = b.digits$2;
    var resDigits = $newArrayObject($d_I.getArrayOf(), [resLength]);
    this.multArraysPAP__AI__I__AI__I__AI__V(aDigits, aLen, bDigits, bLen, resDigits);
    var result = new $c_Ljava_math_BigInteger().init___I__I__AI(resSign, resLength, resDigits);
    result.cutOffLeadingZeroes__V();
    return result
  }
});
$c_Ljava_math_Multiplication$.prototype.init___ = (function() {
  $n_Ljava_math_Multiplication$ = this;
  this.TenPows$1 = this.newArrayOfPows__p1__I__I__AI(10, 10);
  this.FivePows$1 = this.newArrayOfPows__p1__I__I__AI(14, 5);
  this.BigTenPows$1 = $newArrayObject($d_Ljava_math_BigInteger.getArrayOf(), [32]);
  this.BigFivePows$1 = $newArrayObject($d_Ljava_math_BigInteger.getArrayOf(), [32]);
  this.initialiseArrays__p1__V();
  return this
});
$c_Ljava_math_Multiplication$.prototype.square__AI__I__AI__AI = (function(a, aLen, res) {
  var elem$1 = 0;
  elem$1 = 0;
  var i = 0;
  while ((i < aLen)) {
    var arg1 = i;
    elem$1 = 0;
    var __self = ((1 + arg1) | 0);
    var i$1 = __self;
    while ((i$1 < aLen)) {
      var arg1$1 = i$1;
      $m_Ljava_math_Multiplication$();
      var a$1 = a.get(arg1);
      var b = a.get(arg1$1);
      var c = res.get(((arg1 + arg1$1) | 0));
      var d = elem$1;
      var a0 = (65535 & a$1);
      var a1 = ((a$1 >>> 16) | 0);
      var b0 = (65535 & b);
      var b1 = ((b >>> 16) | 0);
      var a0b0 = $imul(a0, b0);
      var a1b0 = $imul(a1, b0);
      var a0b1 = $imul(a0, b1);
      var lo = ((a0b0 + (((a1b0 + a0b1) | 0) << 16)) | 0);
      var c1part = ((((a0b0 >>> 16) | 0) + a0b1) | 0);
      var hi$2 = (((($imul(a1, b1) + ((c1part >>> 16) | 0)) | 0) + (((((65535 & c1part) + a1b0) | 0) >>> 16) | 0)) | 0);
      var lo$1 = ((lo + c) | 0);
      var hi$4 = ((((-2147483648) ^ lo$1) < ((-2147483648) ^ lo)) ? ((1 + hi$2) | 0) : hi$2);
      var lo$2 = ((lo$1 + d) | 0);
      var hi$6 = ((((-2147483648) ^ lo$2) < ((-2147483648) ^ lo$1)) ? ((1 + hi$4) | 0) : hi$4);
      res.set(((arg1 + arg1$1) | 0), lo$2);
      elem$1 = hi$6;
      i$1 = ((1 + i$1) | 0)
    };
    res.set(((arg1 + aLen) | 0), elem$1);
    i = ((1 + i) | 0)
  };
  $m_Ljava_math_BitLevel$().shiftLeftOneBit__AI__AI__I__V(res, res, (aLen << 1));
  elem$1 = 0;
  var i$3 = 0;
  var index = 0;
  while ((i$3 < aLen)) {
    var a$2 = a.get(i$3);
    var b$1 = a.get(i$3);
    var c$1 = res.get(index);
    var d$1 = elem$1;
    var a0$1 = (65535 & a$2);
    var a1$1 = ((a$2 >>> 16) | 0);
    var b0$1 = (65535 & b$1);
    var b1$1 = ((b$1 >>> 16) | 0);
    var a0b0$1 = $imul(a0$1, b0$1);
    var a1b0$1 = $imul(a1$1, b0$1);
    var a0b1$1 = $imul(a0$1, b1$1);
    var lo$3 = ((a0b0$1 + (((a1b0$1 + a0b1$1) | 0) << 16)) | 0);
    var c1part$1 = ((((a0b0$1 >>> 16) | 0) + a0b1$1) | 0);
    var hi$9 = (((($imul(a1$1, b1$1) + ((c1part$1 >>> 16) | 0)) | 0) + (((((65535 & c1part$1) + a1b0$1) | 0) >>> 16) | 0)) | 0);
    var lo$4 = ((lo$3 + c$1) | 0);
    var hi$11 = ((((-2147483648) ^ lo$4) < ((-2147483648) ^ lo$3)) ? ((1 + hi$9) | 0) : hi$9);
    var lo$5 = ((lo$4 + d$1) | 0);
    var hi$13 = ((((-2147483648) ^ lo$5) < ((-2147483648) ^ lo$4)) ? ((1 + hi$11) | 0) : hi$11);
    res.set(index, lo$5);
    index = ((1 + index) | 0);
    var value = res.get(index);
    var lo$6 = ((hi$13 + value) | 0);
    var hi$15 = ((((-2147483648) ^ lo$6) < ((-2147483648) ^ hi$13)) ? 1 : 0);
    res.set(index, lo$6);
    elem$1 = hi$15;
    i$3 = ((1 + i$3) | 0);
    index = ((1 + index) | 0)
  };
  return res
});
$c_Ljava_math_Multiplication$.prototype.pow__Ljava_math_BigInteger__I__Ljava_math_BigInteger = (function(base, exponent) {
  var exp = exponent;
  var res = $m_Ljava_math_BigInteger$().ONE$1;
  var acc = base;
  _loop: while (true) {
    if ((exp > 1)) {
      var res2 = (((1 & exp) !== 0) ? res.multiply__Ljava_math_BigInteger__Ljava_math_BigInteger(acc) : res);
      if ((acc.numberLength$2 === 1)) {
        var acc2 = acc.multiply__Ljava_math_BigInteger__Ljava_math_BigInteger(acc)
      } else {
        var a = $newArrayObject($d_I.getArrayOf(), [(acc.numberLength$2 << 1)]);
        var sq = this.square__AI__I__AI__AI(acc.digits$2, acc.numberLength$2, a);
        var acc2 = new $c_Ljava_math_BigInteger().init___I__AI(1, sq)
      };
      var temp$exp = (exp >> 1);
      exp = temp$exp;
      res = res2;
      acc = acc2;
      continue _loop
    } else {
      return res.multiply__Ljava_math_BigInteger__Ljava_math_BigInteger(acc)
    }
  }
});
$c_Ljava_math_Multiplication$.prototype.multPAP__p1__AI__AI__AI__I__I__V = (function(a, b, t, aLen, bLen) {
  if (((a === b) && (aLen === bLen))) {
    this.square__AI__I__AI__AI(a, aLen, t)
  } else {
    var i = 0;
    while ((i < aLen)) {
      var arg1 = i;
      var elem$1 = 0;
      elem$1 = 0;
      var aI = a.get(arg1);
      var i$1 = 0;
      while ((i$1 < bLen)) {
        var arg1$1 = i$1;
        $m_Ljava_math_Multiplication$();
        var b$1 = b.get(arg1$1);
        var c = t.get(((arg1 + arg1$1) | 0));
        var d = elem$1;
        var a0 = (65535 & aI);
        var a1 = ((aI >>> 16) | 0);
        var b0 = (65535 & b$1);
        var b1 = ((b$1 >>> 16) | 0);
        var a0b0 = $imul(a0, b0);
        var a1b0 = $imul(a1, b0);
        var a0b1 = $imul(a0, b1);
        var lo = ((a0b0 + (((a1b0 + a0b1) | 0) << 16)) | 0);
        var c1part = ((((a0b0 >>> 16) | 0) + a0b1) | 0);
        var hi$2 = (((($imul(a1, b1) + ((c1part >>> 16) | 0)) | 0) + (((((65535 & c1part) + a1b0) | 0) >>> 16) | 0)) | 0);
        var lo$1 = ((lo + c) | 0);
        var hi$4 = ((((-2147483648) ^ lo$1) < ((-2147483648) ^ lo)) ? ((1 + hi$2) | 0) : hi$2);
        var lo$2 = ((lo$1 + d) | 0);
        var hi$6 = ((((-2147483648) ^ lo$2) < ((-2147483648) ^ lo$1)) ? ((1 + hi$4) | 0) : hi$4);
        t.set(((arg1 + arg1$1) | 0), lo$2);
        elem$1 = hi$6;
        i$1 = ((1 + i$1) | 0)
      };
      t.set(((arg1 + bLen) | 0), elem$1);
      i = ((1 + i) | 0)
    }
  }
});
$c_Ljava_math_Multiplication$.prototype.initialiseArrays__p1__V = (function() {
  var elem$1_$_lo$2 = 0;
  var elem$1_$_hi$2 = 0;
  var jsx$1_$_lo$2 = 1;
  var jsx$1_$_hi$2 = 0;
  elem$1_$_lo$2 = jsx$1_$_lo$2;
  elem$1_$_hi$2 = jsx$1_$_hi$2;
  var i = 0;
  while ((i < 32)) {
    var arg1 = i;
    if ((arg1 <= 18)) {
      $m_Ljava_math_Multiplication$().BigFivePows$1.set(arg1, $m_Ljava_math_BigInteger$().valueOf__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(elem$1_$_lo$2, elem$1_$_hi$2)));
      var jsx$3 = $m_Ljava_math_Multiplication$().BigTenPows$1;
      var jsx$2 = $m_Ljava_math_BigInteger$();
      var this$4_$_lo$2 = elem$1_$_lo$2;
      var this$4_$_hi$2 = elem$1_$_hi$2;
      var lo = (((32 & arg1) === 0) ? (this$4_$_lo$2 << arg1) : 0);
      var hi = (((32 & arg1) === 0) ? (((((this$4_$_lo$2 >>> 1) | 0) >>> ((31 - arg1) | 0)) | 0) | (this$4_$_hi$2 << arg1)) : (this$4_$_lo$2 << arg1));
      jsx$3.set(arg1, jsx$2.valueOf__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(lo, hi)));
      var b_$_lo$2 = elem$1_$_lo$2;
      var b_$_hi$2 = elem$1_$_hi$2;
      var blo = b_$_lo$2;
      var b0 = (65535 & blo);
      var b1 = ((blo >>> 16) | 0);
      var a0b0 = $imul(5, b0);
      var a0b1 = $imul(5, b1);
      var lo$1 = ((a0b0 + (a0b1 << 16)) | 0);
      var c1part = ((((a0b0 >>> 16) | 0) + a0b1) | 0);
      var hi$1 = (($imul(5, b_$_hi$2) + ((c1part >>> 16) | 0)) | 0);
      var jsx$4_$_lo$2 = lo$1;
      var jsx$4_$_hi$2 = hi$1;
      elem$1_$_lo$2 = jsx$4_$_lo$2;
      elem$1_$_hi$2 = jsx$4_$_hi$2
    } else {
      $m_Ljava_math_Multiplication$().BigFivePows$1.set(arg1, $m_Ljava_math_Multiplication$().BigFivePows$1.get((((-1) + arg1) | 0)).multiply__Ljava_math_BigInteger__Ljava_math_BigInteger($m_Ljava_math_Multiplication$().BigFivePows$1.get(1)));
      $m_Ljava_math_Multiplication$().BigTenPows$1.set(arg1, $m_Ljava_math_Multiplication$().BigTenPows$1.get((((-1) + arg1) | 0)).multiply__Ljava_math_BigInteger__Ljava_math_BigInteger($m_Ljava_math_BigInteger$().TEN$1))
    };
    i = ((1 + i) | 0)
  }
});
$c_Ljava_math_Multiplication$.prototype.newArrayOfPows__p1__I__I__AI = (function(len, pow) {
  var elems$2 = null;
  elems$2 = [];
  if ((len > 0)) {
    var acc = 1;
    var i = 1;
    var elem = acc;
    var unboxedElem = ((elem === null) ? 0 : elem);
    elems$2.push(unboxedElem);
    while ((i < len)) {
      var arg1 = acc;
      var x$2 = $uI(arg1);
      acc = $imul(x$2, pow);
      i = ((1 + i) | 0);
      var elem$1 = acc;
      var unboxedElem$1 = ((elem$1 === null) ? 0 : elem$1);
      elems$2.push(unboxedElem$1)
    }
  };
  return $makeNativeArrayWrapper($d_I.getArrayOf(), elems$2)
});
$c_Ljava_math_Multiplication$.prototype.karatsuba__Ljava_math_BigInteger__Ljava_math_BigInteger__Ljava_math_BigInteger = (function(val1, val2) {
  if ((val2.numberLength$2 > val1.numberLength$2)) {
    var x1_$_$$und1$f = val2;
    var x1_$_$$und2$f = val1
  } else {
    var x1_$_$$und1$f = val1;
    var x1_$_$$und2$f = val2
  };
  var op1 = $as_Ljava_math_BigInteger(x1_$_$$und1$f);
  var op2 = $as_Ljava_math_BigInteger(x1_$_$$und2$f);
  if ((op2.numberLength$2 < 63)) {
    return this.multiplyPAP__Ljava_math_BigInteger__Ljava_math_BigInteger__Ljava_math_BigInteger(op1, op2)
  } else {
    var ndiv2 = (((-2) & op1.numberLength$2) << 4);
    var upperOp1 = op1.shiftRight__I__Ljava_math_BigInteger(ndiv2);
    var upperOp2 = op2.shiftRight__I__Ljava_math_BigInteger(ndiv2);
    var bi = upperOp1.shiftLeft__I__Ljava_math_BigInteger(ndiv2);
    var lowerOp1 = $m_Ljava_math_Elementary$().subtract__Ljava_math_BigInteger__Ljava_math_BigInteger__Ljava_math_BigInteger(op1, bi);
    var bi$1 = upperOp2.shiftLeft__I__Ljava_math_BigInteger(ndiv2);
    var lowerOp2 = $m_Ljava_math_Elementary$().subtract__Ljava_math_BigInteger__Ljava_math_BigInteger__Ljava_math_BigInteger(op2, bi$1);
    var upper = this.karatsuba__Ljava_math_BigInteger__Ljava_math_BigInteger__Ljava_math_BigInteger(upperOp1, upperOp2);
    var lower = this.karatsuba__Ljava_math_BigInteger__Ljava_math_BigInteger__Ljava_math_BigInteger(lowerOp1, lowerOp2);
    var middle = this.karatsuba__Ljava_math_BigInteger__Ljava_math_BigInteger__Ljava_math_BigInteger($m_Ljava_math_Elementary$().subtract__Ljava_math_BigInteger__Ljava_math_BigInteger__Ljava_math_BigInteger(upperOp1, lowerOp1), $m_Ljava_math_Elementary$().subtract__Ljava_math_BigInteger__Ljava_math_BigInteger__Ljava_math_BigInteger(lowerOp2, upperOp2));
    var this$1 = middle;
    var bi$2 = upper;
    var this$2 = $m_Ljava_math_Elementary$().add__Ljava_math_BigInteger__Ljava_math_BigInteger__Ljava_math_BigInteger(this$1, bi$2);
    middle = $m_Ljava_math_Elementary$().add__Ljava_math_BigInteger__Ljava_math_BigInteger__Ljava_math_BigInteger(this$2, lower);
    middle = middle.shiftLeft__I__Ljava_math_BigInteger(ndiv2);
    upper = upper.shiftLeft__I__Ljava_math_BigInteger((ndiv2 << 1));
    var this$3 = upper;
    var bi$3 = middle;
    var this$4 = $m_Ljava_math_Elementary$().add__Ljava_math_BigInteger__Ljava_math_BigInteger__Ljava_math_BigInteger(this$3, bi$3);
    return $m_Ljava_math_Elementary$().add__Ljava_math_BigInteger__Ljava_math_BigInteger__Ljava_math_BigInteger(this$4, lower)
  }
});
$c_Ljava_math_Multiplication$.prototype.multiplyByInt__p1__AI__AI__I__I__I = (function(res, a, aSize, factor) {
  var elem$1 = 0;
  elem$1 = 0;
  var i = 0;
  while ((i < aSize)) {
    var arg1 = i;
    $m_Ljava_math_Multiplication$();
    var a$1 = a.get(arg1);
    var c = elem$1;
    var a0 = (65535 & a$1);
    var a1 = ((a$1 >>> 16) | 0);
    var b0 = (65535 & factor);
    var b1 = ((factor >>> 16) | 0);
    var a0b0 = $imul(a0, b0);
    var a1b0 = $imul(a1, b0);
    var a0b1 = $imul(a0, b1);
    var lo = ((a0b0 + (((a1b0 + a0b1) | 0) << 16)) | 0);
    var c1part = ((((a0b0 >>> 16) | 0) + a0b1) | 0);
    var hi$2 = (((($imul(a1, b1) + ((c1part >>> 16) | 0)) | 0) + (((((65535 & c1part) + a1b0) | 0) >>> 16) | 0)) | 0);
    var lo$1 = ((lo + c) | 0);
    var hi$4 = ((((-2147483648) ^ lo$1) < ((-2147483648) ^ lo)) ? ((1 + hi$2) | 0) : hi$2);
    res.set(arg1, lo$1);
    elem$1 = hi$4;
    i = ((1 + i) | 0)
  };
  return elem$1
});
$c_Ljava_math_Multiplication$.prototype.multArraysPAP__AI__I__AI__I__AI__V = (function(aDigits, aLen, bDigits, bLen, resDigits) {
  if ((!((aLen === 0) || (bLen === 0)))) {
    if ((aLen === 1)) {
      resDigits.set(bLen, this.multiplyByInt__p1__AI__AI__I__I__I(resDigits, bDigits, bLen, aDigits.get(0)))
    } else if ((bLen === 1)) {
      resDigits.set(aLen, this.multiplyByInt__p1__AI__AI__I__I__I(resDigits, aDigits, aLen, bDigits.get(0)))
    } else {
      this.multPAP__p1__AI__AI__AI__I__I__V(aDigits, bDigits, resDigits, aLen, bLen)
    }
  }
});
$c_Ljava_math_Multiplication$.prototype.powerOf10__J__Ljava_math_BigInteger = (function(exp) {
  var value = this.BigTenPows$1.u.length;
  var hi = (value >> 31);
  var ahi = exp.hi$2;
  if (((ahi === hi) ? (((-2147483648) ^ exp.lo$2) < ((-2147483648) ^ value)) : (ahi < hi))) {
    return this.BigTenPows$1.get(exp.lo$2)
  } else {
    var ahi$1 = exp.hi$2;
    if (((ahi$1 === 0) ? (((-2147483648) ^ exp.lo$2) <= (-2147483598)) : (ahi$1 < 0))) {
      return $m_Ljava_math_BigInteger$().TEN$1.pow__I__Ljava_math_BigInteger(exp.lo$2)
    } else {
      var ahi$2 = exp.hi$2;
      if (((ahi$2 === 0) ? (((-2147483648) ^ exp.lo$2) <= (-1)) : (ahi$2 < 0))) {
        return this.BigFivePows$1.get(1).pow__I__Ljava_math_BigInteger(exp.lo$2).shiftLeft__I__Ljava_math_BigInteger(exp.lo$2)
      } else {
        var powerOfFive = this.BigFivePows$1.get(1).pow__I__Ljava_math_BigInteger(2147483647);
        var res = powerOfFive;
        var bhi = exp.hi$2;
        var lo = (((-2147483647) + exp.lo$2) | 0);
        var hi$1 = ((((-2147483648) ^ lo) < 1) ? bhi : (((-1) + bhi) | 0));
        var longExp_$_lo$2 = lo;
        var longExp_$_hi$2 = hi$1;
        var this$2 = $m_sjsr_RuntimeLong$();
        var lo$1 = this$2.remainderImpl__I__I__I__I__I(exp.lo$2, exp.hi$2, 2147483647, 0);
        while (true) {
          var this$3_$_lo$2 = longExp_$_lo$2;
          var this$3_$_hi$2 = longExp_$_hi$2;
          var ahi$3 = this$3_$_hi$2;
          if (((ahi$3 === 0) ? (((-2147483648) ^ this$3_$_lo$2) > (-1)) : (ahi$3 > 0))) {
            res = res.multiply__Ljava_math_BigInteger__Ljava_math_BigInteger(powerOfFive);
            var b_$_lo$2 = longExp_$_lo$2;
            var b_$_hi$2 = longExp_$_hi$2;
            var bhi$1 = b_$_hi$2;
            var lo$2 = (((-2147483647) + b_$_lo$2) | 0);
            var hi$3 = ((((-2147483648) ^ lo$2) < 1) ? bhi$1 : (((-1) + bhi$1) | 0));
            var jsx$1_$_lo$2 = lo$2;
            var jsx$1_$_hi$2 = hi$3;
            longExp_$_lo$2 = jsx$1_$_lo$2;
            longExp_$_hi$2 = jsx$1_$_hi$2
          } else {
            break
          }
        };
        res = res.multiply__Ljava_math_BigInteger__Ljava_math_BigInteger(this.BigFivePows$1.get(1).pow__I__Ljava_math_BigInteger(lo$1));
        res = res.shiftLeft__I__Ljava_math_BigInteger(2147483647);
        var bhi$2 = exp.hi$2;
        var lo$3 = (((-2147483647) + exp.lo$2) | 0);
        var hi$4 = ((((-2147483648) ^ lo$3) < 1) ? bhi$2 : (((-1) + bhi$2) | 0));
        var jsx$2_$_lo$2 = lo$3;
        var jsx$2_$_hi$2 = hi$4;
        longExp_$_lo$2 = jsx$2_$_lo$2;
        longExp_$_hi$2 = jsx$2_$_hi$2;
        while (true) {
          var this$6_$_lo$2 = longExp_$_lo$2;
          var this$6_$_hi$2 = longExp_$_hi$2;
          var ahi$4 = this$6_$_hi$2;
          if (((ahi$4 === 0) ? (((-2147483648) ^ this$6_$_lo$2) > (-1)) : (ahi$4 > 0))) {
            res = res.shiftLeft__I__Ljava_math_BigInteger(2147483647);
            var b$1_$_lo$2 = longExp_$_lo$2;
            var b$1_$_hi$2 = longExp_$_hi$2;
            var bhi$3 = b$1_$_hi$2;
            var lo$4 = (((-2147483647) + b$1_$_lo$2) | 0);
            var hi$5 = ((((-2147483648) ^ lo$4) < 1) ? bhi$3 : (((-1) + bhi$3) | 0));
            var jsx$3_$_lo$2 = lo$4;
            var jsx$3_$_hi$2 = hi$5;
            longExp_$_lo$2 = jsx$3_$_lo$2;
            longExp_$_hi$2 = jsx$3_$_hi$2
          } else {
            break
          }
        };
        return res.shiftLeft__I__Ljava_math_BigInteger(lo$1)
      }
    }
  }
});
var $d_Ljava_math_Multiplication$ = new $TypeData().initClass({
  Ljava_math_Multiplication$: 0
}, false, "java.math.Multiplication$", {
  Ljava_math_Multiplication$: 1,
  O: 1
});
$c_Ljava_math_Multiplication$.prototype.$classData = $d_Ljava_math_Multiplication$;
var $n_Ljava_math_Multiplication$ = (void 0);
function $m_Ljava_math_Multiplication$() {
  if ((!$n_Ljava_math_Multiplication$)) {
    $n_Ljava_math_Multiplication$ = new $c_Ljava_math_Multiplication$().init___()
  };
  return $n_Ljava_math_Multiplication$
}
/** @constructor */
function $c_Ljava_nio_Buffer() {
  $c_O.call(this);
  this.$$undcapacity$1 = 0;
  this.$$undlimit$1 = 0;
  this.java$nio$Buffer$$$undposition$1 = 0;
  this.$$undmark$1 = 0
}
$c_Ljava_nio_Buffer.prototype = new $h_O();
$c_Ljava_nio_Buffer.prototype.constructor = $c_Ljava_nio_Buffer;
/** @constructor */
function $h_Ljava_nio_Buffer() {
  /*<skip>*/
}
$h_Ljava_nio_Buffer.prototype = $c_Ljava_nio_Buffer.prototype;
$c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer = (function(newPosition) {
  if (((newPosition < 0) || (newPosition > this.$$undlimit$1))) {
    throw new $c_jl_IllegalArgumentException().init___()
  };
  this.java$nio$Buffer$$$undposition$1 = newPosition;
  if ((this.$$undmark$1 > newPosition)) {
    this.$$undmark$1 = (-1)
  };
  return this
});
$c_Ljava_nio_Buffer.prototype.toString__T = (function() {
  return ((((((($objectGetClass(this).getName__T() + "[pos=") + this.java$nio$Buffer$$$undposition$1) + " lim=") + this.$$undlimit$1) + " cap=") + this.$$undcapacity$1) + "]")
});
$c_Ljava_nio_Buffer.prototype.flip__Ljava_nio_Buffer = (function() {
  this.$$undmark$1 = (-1);
  this.$$undlimit$1 = this.java$nio$Buffer$$$undposition$1;
  this.java$nio$Buffer$$$undposition$1 = 0;
  return this
});
$c_Ljava_nio_Buffer.prototype.clear__Ljava_nio_Buffer = (function() {
  this.$$undmark$1 = (-1);
  this.java$nio$Buffer$$$undposition$1 = 0;
  this.$$undlimit$1 = this.$$undcapacity$1;
  return this
});
$c_Ljava_nio_Buffer.prototype.limit__I__Ljava_nio_Buffer = (function(newLimit) {
  if (((newLimit < 0) || (newLimit > this.$$undcapacity$1))) {
    throw new $c_jl_IllegalArgumentException().init___()
  };
  this.$$undlimit$1 = newLimit;
  if ((this.java$nio$Buffer$$$undposition$1 > newLimit)) {
    this.java$nio$Buffer$$$undposition$1 = newLimit;
    if ((this.$$undmark$1 > newLimit)) {
      this.$$undmark$1 = (-1)
    }
  };
  return this
});
$c_Ljava_nio_Buffer.prototype.init___I = (function(_capacity) {
  this.$$undcapacity$1 = _capacity;
  this.$$undlimit$1 = this.$$undcapacity$1;
  this.java$nio$Buffer$$$undposition$1 = 0;
  this.$$undmark$1 = (-1);
  return this
});
/** @constructor */
function $c_Ljava_nio_ByteBuffer$() {
  $c_O.call(this)
}
$c_Ljava_nio_ByteBuffer$.prototype = new $h_O();
$c_Ljava_nio_ByteBuffer$.prototype.constructor = $c_Ljava_nio_ByteBuffer$;
/** @constructor */
function $h_Ljava_nio_ByteBuffer$() {
  /*<skip>*/
}
$h_Ljava_nio_ByteBuffer$.prototype = $c_Ljava_nio_ByteBuffer$.prototype;
$c_Ljava_nio_ByteBuffer$.prototype.init___ = (function() {
  return this
});
$c_Ljava_nio_ByteBuffer$.prototype.allocate__I__Ljava_nio_ByteBuffer = (function(capacity) {
  var array = $newArrayObject($d_B.getArrayOf(), [capacity]);
  var length = array.u.length;
  return $m_Ljava_nio_HeapByteBuffer$().wrap__AB__I__I__I__I__Z__Ljava_nio_ByteBuffer(array, 0, array.u.length, 0, length, false)
});
var $d_Ljava_nio_ByteBuffer$ = new $TypeData().initClass({
  Ljava_nio_ByteBuffer$: 0
}, false, "java.nio.ByteBuffer$", {
  Ljava_nio_ByteBuffer$: 1,
  O: 1
});
$c_Ljava_nio_ByteBuffer$.prototype.$classData = $d_Ljava_nio_ByteBuffer$;
var $n_Ljava_nio_ByteBuffer$ = (void 0);
function $m_Ljava_nio_ByteBuffer$() {
  if ((!$n_Ljava_nio_ByteBuffer$)) {
    $n_Ljava_nio_ByteBuffer$ = new $c_Ljava_nio_ByteBuffer$().init___()
  };
  return $n_Ljava_nio_ByteBuffer$
}
/** @constructor */
function $c_Ljava_nio_CharBuffer$() {
  $c_O.call(this)
}
$c_Ljava_nio_CharBuffer$.prototype = new $h_O();
$c_Ljava_nio_CharBuffer$.prototype.constructor = $c_Ljava_nio_CharBuffer$;
/** @constructor */
function $h_Ljava_nio_CharBuffer$() {
  /*<skip>*/
}
$h_Ljava_nio_CharBuffer$.prototype = $c_Ljava_nio_CharBuffer$.prototype;
$c_Ljava_nio_CharBuffer$.prototype.init___ = (function() {
  return this
});
$c_Ljava_nio_CharBuffer$.prototype.wrap__jl_CharSequence__I__I__Ljava_nio_CharBuffer = (function(csq, start, end) {
  return $m_Ljava_nio_StringCharBuffer$().wrap__jl_CharSequence__I__I__I__I__Ljava_nio_CharBuffer(csq, 0, $charSequenceLength(csq), start, ((end - start) | 0))
});
$c_Ljava_nio_CharBuffer$.prototype.allocate__I__Ljava_nio_CharBuffer = (function(capacity) {
  var array = $newArrayObject($d_C.getArrayOf(), [capacity]);
  var length = array.u.length;
  var capacity$1 = array.u.length;
  if (((capacity$1 < 0) || (capacity$1 > array.u.length))) {
    throw new $c_jl_IndexOutOfBoundsException().init___()
  };
  if (((length < 0) || (length > capacity$1))) {
    throw new $c_jl_IndexOutOfBoundsException().init___()
  };
  return new $c_Ljava_nio_HeapCharBuffer().init___I__AC__I__I__I__Z(capacity$1, array, 0, 0, length, false)
});
var $d_Ljava_nio_CharBuffer$ = new $TypeData().initClass({
  Ljava_nio_CharBuffer$: 0
}, false, "java.nio.CharBuffer$", {
  Ljava_nio_CharBuffer$: 1,
  O: 1
});
$c_Ljava_nio_CharBuffer$.prototype.$classData = $d_Ljava_nio_CharBuffer$;
var $n_Ljava_nio_CharBuffer$ = (void 0);
function $m_Ljava_nio_CharBuffer$() {
  if ((!$n_Ljava_nio_CharBuffer$)) {
    $n_Ljava_nio_CharBuffer$ = new $c_Ljava_nio_CharBuffer$().init___()
  };
  return $n_Ljava_nio_CharBuffer$
}
/** @constructor */
function $c_Ljava_nio_HeapByteBuffer$() {
  $c_O.call(this)
}
$c_Ljava_nio_HeapByteBuffer$.prototype = new $h_O();
$c_Ljava_nio_HeapByteBuffer$.prototype.constructor = $c_Ljava_nio_HeapByteBuffer$;
/** @constructor */
function $h_Ljava_nio_HeapByteBuffer$() {
  /*<skip>*/
}
$h_Ljava_nio_HeapByteBuffer$.prototype = $c_Ljava_nio_HeapByteBuffer$.prototype;
$c_Ljava_nio_HeapByteBuffer$.prototype.init___ = (function() {
  return this
});
$c_Ljava_nio_HeapByteBuffer$.prototype.wrap__AB__I__I__I__I__Z__Ljava_nio_ByteBuffer = (function(array, arrayOffset, capacity, initialPosition, initialLength, isReadOnly) {
  if ((((arrayOffset < 0) || (capacity < 0)) || (((arrayOffset + capacity) | 0) > array.u.length))) {
    throw new $c_jl_IndexOutOfBoundsException().init___()
  };
  var initialLimit = ((initialPosition + initialLength) | 0);
  if ((((initialPosition < 0) || (initialLength < 0)) || (initialLimit > capacity))) {
    throw new $c_jl_IndexOutOfBoundsException().init___()
  };
  return new $c_Ljava_nio_HeapByteBuffer().init___I__AB__I__I__I__Z(capacity, array, arrayOffset, initialPosition, initialLimit, isReadOnly)
});
var $d_Ljava_nio_HeapByteBuffer$ = new $TypeData().initClass({
  Ljava_nio_HeapByteBuffer$: 0
}, false, "java.nio.HeapByteBuffer$", {
  Ljava_nio_HeapByteBuffer$: 1,
  O: 1
});
$c_Ljava_nio_HeapByteBuffer$.prototype.$classData = $d_Ljava_nio_HeapByteBuffer$;
var $n_Ljava_nio_HeapByteBuffer$ = (void 0);
function $m_Ljava_nio_HeapByteBuffer$() {
  if ((!$n_Ljava_nio_HeapByteBuffer$)) {
    $n_Ljava_nio_HeapByteBuffer$ = new $c_Ljava_nio_HeapByteBuffer$().init___()
  };
  return $n_Ljava_nio_HeapByteBuffer$
}
/** @constructor */
function $c_Ljava_nio_StringCharBuffer$() {
  $c_O.call(this)
}
$c_Ljava_nio_StringCharBuffer$.prototype = new $h_O();
$c_Ljava_nio_StringCharBuffer$.prototype.constructor = $c_Ljava_nio_StringCharBuffer$;
/** @constructor */
function $h_Ljava_nio_StringCharBuffer$() {
  /*<skip>*/
}
$h_Ljava_nio_StringCharBuffer$.prototype = $c_Ljava_nio_StringCharBuffer$.prototype;
$c_Ljava_nio_StringCharBuffer$.prototype.init___ = (function() {
  return this
});
$c_Ljava_nio_StringCharBuffer$.prototype.wrap__jl_CharSequence__I__I__I__I__Ljava_nio_CharBuffer = (function(csq, csqOffset, capacity, initialPosition, initialLength) {
  if ((((csqOffset < 0) || (capacity < 0)) || (((csqOffset + capacity) | 0) > $charSequenceLength(csq)))) {
    throw new $c_jl_IndexOutOfBoundsException().init___()
  };
  var initialLimit = ((initialPosition + initialLength) | 0);
  if ((((initialPosition < 0) || (initialLength < 0)) || (initialLimit > capacity))) {
    throw new $c_jl_IndexOutOfBoundsException().init___()
  };
  return new $c_Ljava_nio_StringCharBuffer().init___I__jl_CharSequence__I__I__I(capacity, csq, csqOffset, initialPosition, initialLimit)
});
var $d_Ljava_nio_StringCharBuffer$ = new $TypeData().initClass({
  Ljava_nio_StringCharBuffer$: 0
}, false, "java.nio.StringCharBuffer$", {
  Ljava_nio_StringCharBuffer$: 1,
  O: 1
});
$c_Ljava_nio_StringCharBuffer$.prototype.$classData = $d_Ljava_nio_StringCharBuffer$;
var $n_Ljava_nio_StringCharBuffer$ = (void 0);
function $m_Ljava_nio_StringCharBuffer$() {
  if ((!$n_Ljava_nio_StringCharBuffer$)) {
    $n_Ljava_nio_StringCharBuffer$ = new $c_Ljava_nio_StringCharBuffer$().init___()
  };
  return $n_Ljava_nio_StringCharBuffer$
}
/** @constructor */
function $c_Ljava_nio_charset_CharsetDecoder() {
  $c_O.call(this);
  this.cs$1 = null;
  this.$$undaverageCharsPerByte$1 = 0.0;
  this.$$undmaxCharsPerByte$1 = 0.0;
  this.$$undreplacement$1 = null;
  this.$$undmalformedInputAction$1 = null;
  this.$$undunmappableCharacterAction$1 = null;
  this.status$1 = 0
}
$c_Ljava_nio_charset_CharsetDecoder.prototype = new $h_O();
$c_Ljava_nio_charset_CharsetDecoder.prototype.constructor = $c_Ljava_nio_charset_CharsetDecoder;
/** @constructor */
function $h_Ljava_nio_charset_CharsetDecoder() {
  /*<skip>*/
}
$h_Ljava_nio_charset_CharsetDecoder.prototype = $c_Ljava_nio_charset_CharsetDecoder.prototype;
$c_Ljava_nio_charset_CharsetDecoder.prototype.decode__Ljava_nio_ByteBuffer__Ljava_nio_CharBuffer__Z__Ljava_nio_charset_CoderResult = (function($in, out, endOfInput) {
  if (((this.status$1 === 4) || ((!endOfInput) && (this.status$1 === 3)))) {
    throw new $c_jl_IllegalStateException().init___()
  };
  this.status$1 = (endOfInput ? 3 : 2);
  _loop: while (true) {
    try {
      var result1 = this.decodeLoop__Ljava_nio_ByteBuffer__Ljava_nio_CharBuffer__Ljava_nio_charset_CoderResult($in, out)
    } catch (e) {
      var result1;
      if ((e instanceof $c_Ljava_nio_BufferOverflowException)) {
        var ex$2 = $as_Ljava_nio_BufferOverflowException(e);
        throw new $c_Ljava_nio_charset_CoderMalfunctionError().init___jl_Exception(ex$2)
      } else if ((e instanceof $c_Ljava_nio_BufferUnderflowException)) {
        var ex = $as_Ljava_nio_BufferUnderflowException(e);
        throw new $c_Ljava_nio_charset_CoderMalfunctionError().init___jl_Exception(ex)
      } else {
        throw e
      }
    };
    if ((result1.java$nio$charset$CoderResult$$kind$f === 0)) {
      var remaining = (($in.$$undlimit$1 - $in.java$nio$Buffer$$$undposition$1) | 0);
      if ((endOfInput && (remaining > 0))) {
        var this$1 = $m_Ljava_nio_charset_CoderResult$();
        switch (remaining) {
          case 1: {
            var result2 = this$1.java$nio$charset$CoderResult$$Malformed1$1;
            break
          }
          case 2: {
            var result2 = this$1.java$nio$charset$CoderResult$$Malformed2$1;
            break
          }
          case 3: {
            var result2 = this$1.java$nio$charset$CoderResult$$Malformed3$1;
            break
          }
          case 4: {
            var result2 = this$1.java$nio$charset$CoderResult$$Malformed4$1;
            break
          }
          default: {
            var result2 = this$1.java$nio$charset$CoderResult$$malformedForLengthImpl__I__Ljava_nio_charset_CoderResult(remaining)
          }
        }
      } else {
        var result2 = result1
      }
    } else {
      var result2 = result1
    };
    if (((result2.java$nio$charset$CoderResult$$kind$f === 0) || (result2.java$nio$charset$CoderResult$$kind$f === 1))) {
      return result2
    } else {
      var action = ((result2.java$nio$charset$CoderResult$$kind$f === 3) ? this.$$undunmappableCharacterAction$1 : this.$$undmalformedInputAction$1);
      var x$2 = $m_Ljava_nio_charset_CodingErrorAction$().REPLACE$1;
      if ((x$2 === action)) {
        var jsx$2 = out.$$undlimit$1;
        var jsx$1 = out.java$nio$Buffer$$$undposition$1;
        var thiz = this.$$undreplacement$1;
        if ((((jsx$2 - jsx$1) | 0) < $uI(thiz.length))) {
          return $m_Ljava_nio_charset_CoderResult$().OVERFLOW$1
        } else {
          out.put__T__Ljava_nio_CharBuffer(this.$$undreplacement$1);
          var jsx$3 = $in.java$nio$Buffer$$$undposition$1;
          var l = result2.java$nio$charset$CoderResult$$$undlength$f;
          if ((l < 0)) {
            throw new $c_jl_UnsupportedOperationException().init___()
          };
          var newPosition = ((jsx$3 + l) | 0);
          $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition);
          continue _loop
        }
      } else {
        var x$4 = $m_Ljava_nio_charset_CodingErrorAction$().REPORT$1;
        if ((x$4 === action)) {
          return result2
        } else {
          var x$6 = $m_Ljava_nio_charset_CodingErrorAction$().IGNORE$1;
          if ((x$6 === action)) {
            var jsx$4 = $in.java$nio$Buffer$$$undposition$1;
            var l$1 = result2.java$nio$charset$CoderResult$$$undlength$f;
            if ((l$1 < 0)) {
              throw new $c_jl_UnsupportedOperationException().init___()
            };
            var newPosition$1 = ((jsx$4 + l$1) | 0);
            $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition$1);
            continue _loop
          } else {
            throw new $c_s_MatchError().init___O(action)
          }
        }
      }
    }
  }
});
$c_Ljava_nio_charset_CharsetDecoder.prototype.reset__Ljava_nio_charset_CharsetDecoder = (function() {
  this.status$1 = 1;
  return this
});
$c_Ljava_nio_charset_CharsetDecoder.prototype.onMalformedInput__Ljava_nio_charset_CodingErrorAction__Ljava_nio_charset_CharsetDecoder = (function(newAction) {
  if ((newAction === null)) {
    throw new $c_jl_IllegalArgumentException().init___T("null CodingErrorAction")
  };
  this.$$undmalformedInputAction$1 = newAction;
  return this
});
$c_Ljava_nio_charset_CharsetDecoder.prototype.onUnmappableCharacter__Ljava_nio_charset_CodingErrorAction__Ljava_nio_charset_CharsetDecoder = (function(newAction) {
  if ((newAction === null)) {
    throw new $c_jl_IllegalArgumentException().init___T("null CodingErrorAction")
  };
  this.$$undunmappableCharacterAction$1 = newAction;
  return this
});
$c_Ljava_nio_charset_CharsetDecoder.prototype.init___Ljava_nio_charset_Charset__F__F = (function(cs, _averageCharsPerByte, _maxCharsPerByte) {
  this.cs$1 = cs;
  this.$$undaverageCharsPerByte$1 = _averageCharsPerByte;
  this.$$undmaxCharsPerByte$1 = _maxCharsPerByte;
  this.$$undreplacement$1 = "\ufffd";
  this.$$undmalformedInputAction$1 = $m_Ljava_nio_charset_CodingErrorAction$().REPORT$1;
  this.$$undunmappableCharacterAction$1 = $m_Ljava_nio_charset_CodingErrorAction$().REPORT$1;
  this.status$1 = 1;
  return this
});
/** @constructor */
function $c_Ljava_nio_charset_CharsetEncoder() {
  $c_O.call(this);
  this.cs$1 = null;
  this.$$undaverageBytesPerChar$1 = 0.0;
  this.$$undmaxBytesPerChar$1 = 0.0;
  this.$$undreplacement$1 = null;
  this.$$undmalformedInputAction$1 = null;
  this.$$undunmappableCharacterAction$1 = null;
  this.status$1 = 0
}
$c_Ljava_nio_charset_CharsetEncoder.prototype = new $h_O();
$c_Ljava_nio_charset_CharsetEncoder.prototype.constructor = $c_Ljava_nio_charset_CharsetEncoder;
/** @constructor */
function $h_Ljava_nio_charset_CharsetEncoder() {
  /*<skip>*/
}
$h_Ljava_nio_charset_CharsetEncoder.prototype = $c_Ljava_nio_charset_CharsetEncoder.prototype;
$c_Ljava_nio_charset_CharsetEncoder.prototype.grow$1__p1__Ljava_nio_ByteBuffer__Ljava_nio_ByteBuffer = (function(out) {
  if ((out.$$undcapacity$1 === 0)) {
    return $m_Ljava_nio_ByteBuffer$().allocate__I__Ljava_nio_ByteBuffer(1)
  } else {
    var result = $m_Ljava_nio_ByteBuffer$().allocate__I__Ljava_nio_ByteBuffer((out.$$undcapacity$1 << 1));
    $c_Ljava_nio_Buffer.prototype.flip__Ljava_nio_Buffer.call(out);
    result.put__Ljava_nio_ByteBuffer__Ljava_nio_ByteBuffer(out);
    return result
  }
});
$c_Ljava_nio_charset_CharsetEncoder.prototype.onUnmappableCharacter__Ljava_nio_charset_CodingErrorAction__Ljava_nio_charset_CharsetEncoder = (function(newAction) {
  if ((newAction === null)) {
    throw new $c_jl_IllegalArgumentException().init___T("null CodingErrorAction")
  };
  this.$$undunmappableCharacterAction$1 = newAction;
  return this
});
$c_Ljava_nio_charset_CharsetEncoder.prototype.encode__Ljava_nio_CharBuffer__Ljava_nio_ByteBuffer__Z__Ljava_nio_charset_CoderResult = (function($in, out, endOfInput) {
  if (((this.status$1 === 3) || ((!endOfInput) && (this.status$1 === 2)))) {
    throw new $c_jl_IllegalStateException().init___()
  };
  this.status$1 = (endOfInput ? 2 : 1);
  _loop: while (true) {
    try {
      var result1 = this.encodeLoop__Ljava_nio_CharBuffer__Ljava_nio_ByteBuffer__Ljava_nio_charset_CoderResult($in, out)
    } catch (e) {
      var result1;
      if ((e instanceof $c_Ljava_nio_BufferOverflowException)) {
        var ex$2 = $as_Ljava_nio_BufferOverflowException(e);
        throw new $c_Ljava_nio_charset_CoderMalfunctionError().init___jl_Exception(ex$2)
      } else if ((e instanceof $c_Ljava_nio_BufferUnderflowException)) {
        var ex = $as_Ljava_nio_BufferUnderflowException(e);
        throw new $c_Ljava_nio_charset_CoderMalfunctionError().init___jl_Exception(ex)
      } else {
        throw e
      }
    };
    if ((result1.java$nio$charset$CoderResult$$kind$f === 0)) {
      var remaining = (($in.$$undlimit$1 - $in.java$nio$Buffer$$$undposition$1) | 0);
      if ((endOfInput && (remaining > 0))) {
        var this$1 = $m_Ljava_nio_charset_CoderResult$();
        switch (remaining) {
          case 1: {
            var result2 = this$1.java$nio$charset$CoderResult$$Malformed1$1;
            break
          }
          case 2: {
            var result2 = this$1.java$nio$charset$CoderResult$$Malformed2$1;
            break
          }
          case 3: {
            var result2 = this$1.java$nio$charset$CoderResult$$Malformed3$1;
            break
          }
          case 4: {
            var result2 = this$1.java$nio$charset$CoderResult$$Malformed4$1;
            break
          }
          default: {
            var result2 = this$1.java$nio$charset$CoderResult$$malformedForLengthImpl__I__Ljava_nio_charset_CoderResult(remaining)
          }
        }
      } else {
        var result2 = result1
      }
    } else {
      var result2 = result1
    };
    if (((result2.java$nio$charset$CoderResult$$kind$f === 0) || (result2.java$nio$charset$CoderResult$$kind$f === 1))) {
      return result2
    } else {
      var action = ((result2.java$nio$charset$CoderResult$$kind$f === 3) ? this.$$undunmappableCharacterAction$1 : this.$$undmalformedInputAction$1);
      var x$2 = $m_Ljava_nio_charset_CodingErrorAction$().REPLACE$1;
      if ((x$2 === action)) {
        if ((((out.$$undlimit$1 - out.java$nio$Buffer$$$undposition$1) | 0) < this.$$undreplacement$1.u.length)) {
          return $m_Ljava_nio_charset_CoderResult$().OVERFLOW$1
        } else {
          var src = this.$$undreplacement$1;
          out.put__AB__I__I__Ljava_nio_ByteBuffer(src, 0, src.u.length);
          var jsx$1 = $in.java$nio$Buffer$$$undposition$1;
          var l = result2.java$nio$charset$CoderResult$$$undlength$f;
          if ((l < 0)) {
            throw new $c_jl_UnsupportedOperationException().init___()
          };
          var newPosition = ((jsx$1 + l) | 0);
          $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition);
          continue _loop
        }
      } else {
        var x$4 = $m_Ljava_nio_charset_CodingErrorAction$().REPORT$1;
        if ((x$4 === action)) {
          return result2
        } else {
          var x$6 = $m_Ljava_nio_charset_CodingErrorAction$().IGNORE$1;
          if ((x$6 === action)) {
            var jsx$2 = $in.java$nio$Buffer$$$undposition$1;
            var l$1 = result2.java$nio$charset$CoderResult$$$undlength$f;
            if ((l$1 < 0)) {
              throw new $c_jl_UnsupportedOperationException().init___()
            };
            var newPosition$1 = ((jsx$2 + l$1) | 0);
            $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition$1);
            continue _loop
          } else {
            throw new $c_s_MatchError().init___O(action)
          }
        }
      }
    }
  }
});
$c_Ljava_nio_charset_CharsetEncoder.prototype.flush__Ljava_nio_ByteBuffer__Ljava_nio_charset_CoderResult = (function(out) {
  var x1 = this.status$1;
  switch (x1) {
    case 2: {
      var result = $m_Ljava_nio_charset_CoderResult$().UNDERFLOW$1;
      if ((result.java$nio$charset$CoderResult$$kind$f === 0)) {
        this.status$1 = 3
      };
      return result;
      break
    }
    case 3: {
      return $m_Ljava_nio_charset_CoderResult$().UNDERFLOW$1;
      break
    }
    default: {
      throw new $c_jl_IllegalStateException().init___()
    }
  }
});
$c_Ljava_nio_charset_CharsetEncoder.prototype.encode__Ljava_nio_CharBuffer__Ljava_nio_ByteBuffer = (function($in) {
  if (((($in.$$undlimit$1 - $in.java$nio$Buffer$$$undposition$1) | 0) === 0)) {
    return $m_Ljava_nio_ByteBuffer$().allocate__I__Ljava_nio_ByteBuffer(0)
  } else {
    this.reset__Ljava_nio_charset_CharsetEncoder();
    var initLength = $doubleToInt($fround(($fround((($in.$$undlimit$1 - $in.java$nio$Buffer$$$undposition$1) | 0)) * this.$$undaverageBytesPerChar$1)));
    var out = $m_Ljava_nio_ByteBuffer$().allocate__I__Ljava_nio_ByteBuffer(initLength);
    var out$1;
    _loopEncode: while (true) {
      var result = this.encode__Ljava_nio_CharBuffer__Ljava_nio_ByteBuffer__Z__Ljava_nio_charset_CoderResult($in, out, true);
      if ((result.java$nio$charset$CoderResult$$kind$f !== 0)) {
        if ((result.java$nio$charset$CoderResult$$kind$f === 1)) {
          out = this.grow$1__p1__Ljava_nio_ByteBuffer__Ljava_nio_ByteBuffer(out);
          continue _loopEncode
        };
        result.throwException__V();
        throw new $c_jl_AssertionError().init___O("should not get here")
      };
      if (($in.java$nio$Buffer$$$undposition$1 !== $in.$$undlimit$1)) {
        throw new $c_jl_AssertionError().init___()
      };
      var out$1 = out;
      break
    };
    var out$2;
    _loopFlush: while (true) {
      var result$1 = this.flush__Ljava_nio_ByteBuffer__Ljava_nio_charset_CoderResult(out$1);
      if ((result$1.java$nio$charset$CoderResult$$kind$f !== 0)) {
        if ((result$1.java$nio$charset$CoderResult$$kind$f === 1)) {
          out$1 = this.grow$1__p1__Ljava_nio_ByteBuffer__Ljava_nio_ByteBuffer(out$1);
          continue _loopFlush
        };
        result$1.throwException__V();
        throw new $c_jl_AssertionError().init___O("should not get here")
      };
      var out$2 = out$1;
      break
    };
    $c_Ljava_nio_Buffer.prototype.flip__Ljava_nio_Buffer.call(out$2);
    return out$2
  }
});
$c_Ljava_nio_charset_CharsetEncoder.prototype.init___Ljava_nio_charset_Charset__F__F = (function(cs, _averageBytesPerChar, _maxBytesPerChar) {
  $c_Ljava_nio_charset_CharsetEncoder.prototype.init___Ljava_nio_charset_Charset__F__F__AB.call(this, cs, _averageBytesPerChar, _maxBytesPerChar, $makeNativeArrayWrapper($d_B.getArrayOf(), [63]));
  return this
});
$c_Ljava_nio_charset_CharsetEncoder.prototype.init___Ljava_nio_charset_Charset__F__F__AB = (function(cs, _averageBytesPerChar, _maxBytesPerChar, _replacement) {
  this.cs$1 = cs;
  this.$$undaverageBytesPerChar$1 = _averageBytesPerChar;
  this.$$undmaxBytesPerChar$1 = _maxBytesPerChar;
  this.$$undreplacement$1 = _replacement;
  this.$$undmalformedInputAction$1 = $m_Ljava_nio_charset_CodingErrorAction$().REPORT$1;
  this.$$undunmappableCharacterAction$1 = $m_Ljava_nio_charset_CodingErrorAction$().REPORT$1;
  this.status$1 = 0;
  return this
});
$c_Ljava_nio_charset_CharsetEncoder.prototype.onMalformedInput__Ljava_nio_charset_CodingErrorAction__Ljava_nio_charset_CharsetEncoder = (function(newAction) {
  if ((newAction === null)) {
    throw new $c_jl_IllegalArgumentException().init___T("null CodingErrorAction")
  };
  this.$$undmalformedInputAction$1 = newAction;
  return this
});
$c_Ljava_nio_charset_CharsetEncoder.prototype.reset__Ljava_nio_charset_CharsetEncoder = (function() {
  this.status$1 = 0;
  return this
});
/** @constructor */
function $c_Ljava_nio_charset_CoderResult() {
  $c_O.call(this);
  this.java$nio$charset$CoderResult$$kind$f = 0;
  this.java$nio$charset$CoderResult$$$undlength$f = 0
}
$c_Ljava_nio_charset_CoderResult.prototype = new $h_O();
$c_Ljava_nio_charset_CoderResult.prototype.constructor = $c_Ljava_nio_charset_CoderResult;
/** @constructor */
function $h_Ljava_nio_charset_CoderResult() {
  /*<skip>*/
}
$h_Ljava_nio_charset_CoderResult.prototype = $c_Ljava_nio_charset_CoderResult.prototype;
$c_Ljava_nio_charset_CoderResult.prototype.init___I__I = (function(kind, _length) {
  this.java$nio$charset$CoderResult$$kind$f = kind;
  this.java$nio$charset$CoderResult$$$undlength$f = _length;
  return this
});
$c_Ljava_nio_charset_CoderResult.prototype.throwException__V = (function() {
  var x1 = this.java$nio$charset$CoderResult$$kind$f;
  switch (x1) {
    case 1: {
      throw new $c_Ljava_nio_BufferOverflowException().init___();
      break
    }
    case 0: {
      throw new $c_Ljava_nio_BufferUnderflowException().init___();
      break
    }
    case 2: {
      throw new $c_Ljava_nio_charset_MalformedInputException().init___I(this.java$nio$charset$CoderResult$$$undlength$f);
      break
    }
    case 3: {
      throw new $c_Ljava_nio_charset_UnmappableCharacterException().init___I(this.java$nio$charset$CoderResult$$$undlength$f);
      break
    }
    default: {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
function $as_Ljava_nio_charset_CoderResult(obj) {
  return (((obj instanceof $c_Ljava_nio_charset_CoderResult) || (obj === null)) ? obj : $throwClassCastException(obj, "java.nio.charset.CoderResult"))
}
function $isArrayOf_Ljava_nio_charset_CoderResult(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Ljava_nio_charset_CoderResult)))
}
function $asArrayOf_Ljava_nio_charset_CoderResult(obj, depth) {
  return (($isArrayOf_Ljava_nio_charset_CoderResult(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.nio.charset.CoderResult;", depth))
}
var $d_Ljava_nio_charset_CoderResult = new $TypeData().initClass({
  Ljava_nio_charset_CoderResult: 0
}, false, "java.nio.charset.CoderResult", {
  Ljava_nio_charset_CoderResult: 1,
  O: 1
});
$c_Ljava_nio_charset_CoderResult.prototype.$classData = $d_Ljava_nio_charset_CoderResult;
/** @constructor */
function $c_Ljava_nio_charset_CoderResult$() {
  $c_O.call(this);
  this.OVERFLOW$1 = null;
  this.UNDERFLOW$1 = null;
  this.java$nio$charset$CoderResult$$Malformed1$1 = null;
  this.java$nio$charset$CoderResult$$Malformed2$1 = null;
  this.java$nio$charset$CoderResult$$Malformed3$1 = null;
  this.java$nio$charset$CoderResult$$Malformed4$1 = null;
  this.uniqueMalformed$1 = null;
  this.java$nio$charset$CoderResult$$Unmappable1$1 = null;
  this.java$nio$charset$CoderResult$$Unmappable2$1 = null;
  this.java$nio$charset$CoderResult$$Unmappable3$1 = null;
  this.java$nio$charset$CoderResult$$Unmappable4$1 = null;
  this.uniqueUnmappable$1 = null
}
$c_Ljava_nio_charset_CoderResult$.prototype = new $h_O();
$c_Ljava_nio_charset_CoderResult$.prototype.constructor = $c_Ljava_nio_charset_CoderResult$;
/** @constructor */
function $h_Ljava_nio_charset_CoderResult$() {
  /*<skip>*/
}
$h_Ljava_nio_charset_CoderResult$.prototype = $c_Ljava_nio_charset_CoderResult$.prototype;
$c_Ljava_nio_charset_CoderResult$.prototype.init___ = (function() {
  $n_Ljava_nio_charset_CoderResult$ = this;
  this.OVERFLOW$1 = new $c_Ljava_nio_charset_CoderResult().init___I__I(1, (-1));
  this.UNDERFLOW$1 = new $c_Ljava_nio_charset_CoderResult().init___I__I(0, (-1));
  this.java$nio$charset$CoderResult$$Malformed1$1 = new $c_Ljava_nio_charset_CoderResult().init___I__I(2, 1);
  this.java$nio$charset$CoderResult$$Malformed2$1 = new $c_Ljava_nio_charset_CoderResult().init___I__I(2, 2);
  this.java$nio$charset$CoderResult$$Malformed3$1 = new $c_Ljava_nio_charset_CoderResult().init___I__I(2, 3);
  this.java$nio$charset$CoderResult$$Malformed4$1 = new $c_Ljava_nio_charset_CoderResult().init___I__I(2, 4);
  this.uniqueMalformed$1 = [];
  this.java$nio$charset$CoderResult$$Unmappable1$1 = new $c_Ljava_nio_charset_CoderResult().init___I__I(3, 1);
  this.java$nio$charset$CoderResult$$Unmappable2$1 = new $c_Ljava_nio_charset_CoderResult().init___I__I(3, 2);
  this.java$nio$charset$CoderResult$$Unmappable3$1 = new $c_Ljava_nio_charset_CoderResult().init___I__I(3, 3);
  this.java$nio$charset$CoderResult$$Unmappable4$1 = new $c_Ljava_nio_charset_CoderResult().init___I__I(3, 4);
  this.uniqueUnmappable$1 = [];
  return this
});
$c_Ljava_nio_charset_CoderResult$.prototype.java$nio$charset$CoderResult$$malformedForLengthImpl__I__Ljava_nio_charset_CoderResult = (function(length) {
  var value = this.uniqueMalformed$1[length];
  if ((value === (void 0))) {
    var result = new $c_Ljava_nio_charset_CoderResult().init___I__I(2, length);
    $m_Ljava_nio_charset_CoderResult$().uniqueMalformed$1[length] = result;
    return result
  } else {
    var result$1 = $as_Ljava_nio_charset_CoderResult(value);
    return result$1
  }
});
var $d_Ljava_nio_charset_CoderResult$ = new $TypeData().initClass({
  Ljava_nio_charset_CoderResult$: 0
}, false, "java.nio.charset.CoderResult$", {
  Ljava_nio_charset_CoderResult$: 1,
  O: 1
});
$c_Ljava_nio_charset_CoderResult$.prototype.$classData = $d_Ljava_nio_charset_CoderResult$;
var $n_Ljava_nio_charset_CoderResult$ = (void 0);
function $m_Ljava_nio_charset_CoderResult$() {
  if ((!$n_Ljava_nio_charset_CoderResult$)) {
    $n_Ljava_nio_charset_CoderResult$ = new $c_Ljava_nio_charset_CoderResult$().init___()
  };
  return $n_Ljava_nio_charset_CoderResult$
}
/** @constructor */
function $c_Ljava_nio_charset_CodingErrorAction() {
  $c_O.call(this);
  this.name$1 = null
}
$c_Ljava_nio_charset_CodingErrorAction.prototype = new $h_O();
$c_Ljava_nio_charset_CodingErrorAction.prototype.constructor = $c_Ljava_nio_charset_CodingErrorAction;
/** @constructor */
function $h_Ljava_nio_charset_CodingErrorAction() {
  /*<skip>*/
}
$h_Ljava_nio_charset_CodingErrorAction.prototype = $c_Ljava_nio_charset_CodingErrorAction.prototype;
$c_Ljava_nio_charset_CodingErrorAction.prototype.toString__T = (function() {
  return this.name$1
});
$c_Ljava_nio_charset_CodingErrorAction.prototype.init___T = (function(name) {
  this.name$1 = name;
  return this
});
var $d_Ljava_nio_charset_CodingErrorAction = new $TypeData().initClass({
  Ljava_nio_charset_CodingErrorAction: 0
}, false, "java.nio.charset.CodingErrorAction", {
  Ljava_nio_charset_CodingErrorAction: 1,
  O: 1
});
$c_Ljava_nio_charset_CodingErrorAction.prototype.$classData = $d_Ljava_nio_charset_CodingErrorAction;
/** @constructor */
function $c_Ljava_nio_charset_CodingErrorAction$() {
  $c_O.call(this);
  this.IGNORE$1 = null;
  this.REPLACE$1 = null;
  this.REPORT$1 = null
}
$c_Ljava_nio_charset_CodingErrorAction$.prototype = new $h_O();
$c_Ljava_nio_charset_CodingErrorAction$.prototype.constructor = $c_Ljava_nio_charset_CodingErrorAction$;
/** @constructor */
function $h_Ljava_nio_charset_CodingErrorAction$() {
  /*<skip>*/
}
$h_Ljava_nio_charset_CodingErrorAction$.prototype = $c_Ljava_nio_charset_CodingErrorAction$.prototype;
$c_Ljava_nio_charset_CodingErrorAction$.prototype.init___ = (function() {
  $n_Ljava_nio_charset_CodingErrorAction$ = this;
  this.IGNORE$1 = new $c_Ljava_nio_charset_CodingErrorAction().init___T("IGNORE");
  this.REPLACE$1 = new $c_Ljava_nio_charset_CodingErrorAction().init___T("REPLACE");
  this.REPORT$1 = new $c_Ljava_nio_charset_CodingErrorAction().init___T("REPORT");
  return this
});
var $d_Ljava_nio_charset_CodingErrorAction$ = new $TypeData().initClass({
  Ljava_nio_charset_CodingErrorAction$: 0
}, false, "java.nio.charset.CodingErrorAction$", {
  Ljava_nio_charset_CodingErrorAction$: 1,
  O: 1
});
$c_Ljava_nio_charset_CodingErrorAction$.prototype.$classData = $d_Ljava_nio_charset_CodingErrorAction$;
var $n_Ljava_nio_charset_CodingErrorAction$ = (void 0);
function $m_Ljava_nio_charset_CodingErrorAction$() {
  if ((!$n_Ljava_nio_charset_CodingErrorAction$)) {
    $n_Ljava_nio_charset_CodingErrorAction$ = new $c_Ljava_nio_charset_CodingErrorAction$().init___()
  };
  return $n_Ljava_nio_charset_CodingErrorAction$
}
/** @constructor */
function $c_Lorg_mulesoft_common_core_package$() {
  $c_O.call(this)
}
$c_Lorg_mulesoft_common_core_package$.prototype = new $h_O();
$c_Lorg_mulesoft_common_core_package$.prototype.constructor = $c_Lorg_mulesoft_common_core_package$;
/** @constructor */
function $h_Lorg_mulesoft_common_core_package$() {
  /*<skip>*/
}
$h_Lorg_mulesoft_common_core_package$.prototype = $c_Lorg_mulesoft_common_core_package$.prototype;
$c_Lorg_mulesoft_common_core_package$.prototype.init___ = (function() {
  return this
});
$c_Lorg_mulesoft_common_core_package$.prototype.org$mulesoft$common$core$package$$decodeUnicodeChar__T__I__I__Z__T = (function(str, from, to, ignoreErrors) {
  var nonLocalReturnKey1 = new $c_O().init___();
  try {
    var elem$1 = 0;
    elem$1 = 0;
    var isEmpty$4 = (from >= to);
    var scala$collection$immutable$Range$$lastElement$4 = (((-1) + to) | 0);
    if ((!isEmpty$4)) {
      var i = from;
      while (true) {
        var v1 = i;
        if ((v1 < $uI(str.length))) {
          var this$10 = $m_jl_Character$();
          var ch = (65535 & $uI(str.charCodeAt(v1)));
          var n = this$10.digitWithValidRadix__I__I__I(ch, 16)
        } else {
          var n = (-1)
        };
        if ((n === (-1))) {
          if (ignoreErrors) {
            var b = $uI(str.length);
            var endIndex = ((to < b) ? to : b);
            throw new $c_sr_NonLocalReturnControl().init___O__O(nonLocalReturnKey1, $as_T(str.substring(v1, endIndex)))
          };
          throw new $c_jl_IllegalArgumentException().init___T(("Malformed unicode encoding: " + str))
        };
        elem$1 = ((elem$1 << 4) | n);
        if ((i === scala$collection$immutable$Range$$lastElement$4)) {
          break
        };
        i = ((1 + i) | 0)
      }
    };
    var this$15 = $m_sjsr_RuntimeString$();
    var value$1 = $m_jl_Character$().toChars__I__AC(elem$1);
    return this$15.newString__AC__I__I__T(value$1, 0, value$1.u.length)
  } catch (e) {
    if ((e instanceof $c_sr_NonLocalReturnControl)) {
      var ex = $as_sr_NonLocalReturnControl(e);
      if ((ex.key$2 === nonLocalReturnKey1)) {
        return $as_T(ex.value__O())
      } else {
        throw ex
      }
    } else {
      throw e
    }
  }
});
var $d_Lorg_mulesoft_common_core_package$ = new $TypeData().initClass({
  Lorg_mulesoft_common_core_package$: 0
}, false, "org.mulesoft.common.core.package$", {
  Lorg_mulesoft_common_core_package$: 1,
  O: 1
});
$c_Lorg_mulesoft_common_core_package$.prototype.$classData = $d_Lorg_mulesoft_common_core_package$;
var $n_Lorg_mulesoft_common_core_package$ = (void 0);
function $m_Lorg_mulesoft_common_core_package$() {
  if ((!$n_Lorg_mulesoft_common_core_package$)) {
    $n_Lorg_mulesoft_common_core_package$ = new $c_Lorg_mulesoft_common_core_package$().init___()
  };
  return $n_Lorg_mulesoft_common_core_package$
}
/** @constructor */
function $c_Lorg_mulesoft_common_core_package$Chars$() {
  $c_O.call(this)
}
$c_Lorg_mulesoft_common_core_package$Chars$.prototype = new $h_O();
$c_Lorg_mulesoft_common_core_package$Chars$.prototype.constructor = $c_Lorg_mulesoft_common_core_package$Chars$;
/** @constructor */
function $h_Lorg_mulesoft_common_core_package$Chars$() {
  /*<skip>*/
}
$h_Lorg_mulesoft_common_core_package$Chars$.prototype = $c_Lorg_mulesoft_common_core_package$Chars$.prototype;
$c_Lorg_mulesoft_common_core_package$Chars$.prototype.init___ = (function() {
  return this
});
$c_Lorg_mulesoft_common_core_package$Chars$.prototype.toHexString$extension__C__T = (function($$this) {
  var x = $uD(($$this >>> 0));
  var jsx$1 = x.toString(16);
  var thiz = $as_T(jsx$1);
  return $as_T(thiz.toUpperCase())
});
var $d_Lorg_mulesoft_common_core_package$Chars$ = new $TypeData().initClass({
  Lorg_mulesoft_common_core_package$Chars$: 0
}, false, "org.mulesoft.common.core.package$Chars$", {
  Lorg_mulesoft_common_core_package$Chars$: 1,
  O: 1
});
$c_Lorg_mulesoft_common_core_package$Chars$.prototype.$classData = $d_Lorg_mulesoft_common_core_package$Chars$;
var $n_Lorg_mulesoft_common_core_package$Chars$ = (void 0);
function $m_Lorg_mulesoft_common_core_package$Chars$() {
  if ((!$n_Lorg_mulesoft_common_core_package$Chars$)) {
    $n_Lorg_mulesoft_common_core_package$Chars$ = new $c_Lorg_mulesoft_common_core_package$Chars$().init___()
  };
  return $n_Lorg_mulesoft_common_core_package$Chars$
}
/** @constructor */
function $c_Lorg_mulesoft_common_core_package$Strings$() {
  $c_O.call(this)
}
$c_Lorg_mulesoft_common_core_package$Strings$.prototype = new $h_O();
$c_Lorg_mulesoft_common_core_package$Strings$.prototype.constructor = $c_Lorg_mulesoft_common_core_package$Strings$;
/** @constructor */
function $h_Lorg_mulesoft_common_core_package$Strings$() {
  /*<skip>*/
}
$h_Lorg_mulesoft_common_core_package$Strings$.prototype = $c_Lorg_mulesoft_common_core_package$Strings$.prototype;
$c_Lorg_mulesoft_common_core_package$Strings$.prototype.init___ = (function() {
  return this
});
$c_Lorg_mulesoft_common_core_package$Strings$.prototype.isNullOrEmpty$extension__T__Z = (function($$this) {
  if (($$this === null)) {
    return true
  } else {
    if (($$this === null)) {
      throw new $c_jl_NullPointerException().init___()
    };
    return ($$this === "")
  }
});
$c_Lorg_mulesoft_common_core_package$Strings$.prototype.stripSpaces$extension__T__T = (function($$this) {
  if ($m_Lorg_mulesoft_common_core_package$Strings$().isNullOrEmpty$extension__T__Z($$this)) {
    return $$this
  } else {
    var this$5 = new $c_sci_StringOps().init___T($$this);
    var elem = new $c_jl_Character().init___C(32);
    if ((!$f_sc_SeqLike__contains__O__Z(this$5, elem))) {
      return $$this
    } else {
      var len = $uI($$this.length);
      var result = new $c_scm_StringBuilder().init___I(len);
      var i = 0;
      while ((i < len)) {
        var index = i;
        var c = (65535 & $uI($$this.charCodeAt(index)));
        if ((c !== 32)) {
          result.append__C__scm_StringBuilder(c)
        };
        i = ((1 + i) | 0)
      };
      return result.underlying$5.java$lang$StringBuilder$$content$f
    }
  }
});
$c_Lorg_mulesoft_common_core_package$Strings$.prototype.firstEscaped$extension__T__I = (function($$this) {
  if (($$this === null)) {
    return (-1)
  } else {
    var i = 0;
    var length = $uI($$this.length);
    while ((i < length)) {
      var index = i;
      var chr = (65535 & $uI($$this.charCodeAt(index)));
      if (((((chr < 32) || (chr >= 127)) || (chr === 92)) || (chr === 34))) {
        return i
      };
      i = ((1 + i) | 0)
    };
    return (-1)
  }
});
$c_Lorg_mulesoft_common_core_package$Strings$.prototype.decode$extension1__T__Z__T = (function($$this, ignoreErrors) {
  if (($$this === null)) {
    return $$this
  };
  var length = $uI($$this.length);
  if ((length === 0)) {
    return $$this
  };
  var buffer = new $c_scm_StringBuilder().init___I(length);
  var i = 0;
  while ((i < length)) {
    var index = i;
    var chr = (65535 & $uI($$this.charCodeAt(index)));
    i = ((1 + i) | 0);
    if (((chr !== 92) || (i >= length))) {
      buffer.append__C__scm_StringBuilder(chr)
    } else {
      var index$1 = i;
      var chr$2 = (65535 & $uI($$this.charCodeAt(index$1)));
      i = ((1 + i) | 0);
      switch (chr$2) {
        case 85: {
          i = ((8 + i) | 0);
          var jsx$1 = $m_Lorg_mulesoft_common_core_package$().org$mulesoft$common$core$package$$decodeUnicodeChar__T__I__I__Z__T($$this, (((-8) + i) | 0), i, ignoreErrors);
          break
        }
        case 117: {
          i = ((4 + i) | 0);
          var jsx$1 = $m_Lorg_mulesoft_common_core_package$().org$mulesoft$common$core$package$$decodeUnicodeChar__T__I__I__Z__T($$this, (((-4) + i) | 0), i, ignoreErrors);
          break
        }
        case 120: {
          i = ((2 + i) | 0);
          var jsx$1 = $m_Lorg_mulesoft_common_core_package$().org$mulesoft$common$core$package$$decodeUnicodeChar__T__I__I__Z__T($$this, (((-2) + i) | 0), i, ignoreErrors);
          break
        }
        case 116: {
          var jsx$1 = "\t";
          break
        }
        case 114: {
          var jsx$1 = "\r";
          break
        }
        case 110: {
          var jsx$1 = "\n";
          break
        }
        case 102: {
          var jsx$1 = "\f";
          break
        }
        case 97: {
          var jsx$1 = new $c_jl_Character().init___C(7);
          break
        }
        case 98: {
          var jsx$1 = "\b";
          break
        }
        case 118: {
          var jsx$1 = "\v";
          break
        }
        case 101: {
          var jsx$1 = new $c_jl_Character().init___C(27);
          break
        }
        case 48: {
          var jsx$1 = new $c_jl_Character().init___C(0);
          break
        }
        case 78: {
          var jsx$1 = "\u0085";
          break
        }
        case 95: {
          var jsx$1 = "\u00a0";
          break
        }
        case 76: {
          var jsx$1 = "\u2028";
          break
        }
        case 80: {
          var jsx$1 = "\u2029";
          break
        }
        default: {
          var jsx$1 = $as_T($g.String.fromCharCode(chr$2))
        }
      };
      buffer.append__O__scm_StringBuilder(jsx$1)
    }
  };
  return buffer.underlying$5.java$lang$StringBuilder$$content$f
});
$c_Lorg_mulesoft_common_core_package$Strings$.prototype.notNull$extension__T__T = (function($$this) {
  return (($$this === null) ? "" : $$this)
});
$c_Lorg_mulesoft_common_core_package$Strings$.prototype.encode$extension1__T__Z__T = (function($$this, encodeNonAscii) {
  var f = $m_Lorg_mulesoft_common_core_package$Strings$().firstEscaped$extension__T__I($$this);
  if ((f === (-1))) {
    return $$this
  } else {
    var out = new $c_scm_StringBuilder().init___I(($uI($$this.length) << 1));
    var endIndex = f;
    out.$$plus$plus$eq__T__scm_StringBuilder($as_T($$this.substring(0, endIndex)));
    while ((f < $uI($$this.length))) {
      var index = f;
      var ch = (65535 & $uI($$this.charCodeAt(index)));
      if ((ch < 32)) {
        out.$$plus$eq__C__scm_StringBuilder(92);
        switch (ch) {
          case 8: {
            out.$$plus$eq__C__scm_StringBuilder(98);
            break
          }
          case 10: {
            out.$$plus$eq__C__scm_StringBuilder(110);
            break
          }
          case 9: {
            out.$$plus$eq__C__scm_StringBuilder(116);
            break
          }
          case 12: {
            out.$$plus$eq__C__scm_StringBuilder(102);
            break
          }
          case 13: {
            out.$$plus$eq__C__scm_StringBuilder(114);
            break
          }
          case 0: {
            out.$$plus$eq__C__scm_StringBuilder(48);
            break
          }
          default: {
            out.$$plus$plus$eq__T__scm_StringBuilder((("u00" + ((ch > 15) ? "" : "0")) + $m_Lorg_mulesoft_common_core_package$Chars$().toHexString$extension__C__T(ch)))
          }
        }
      } else if ((ch < 127)) {
        if (((ch === 34) || (ch === 92))) {
          out.$$plus$eq__C__scm_StringBuilder(92)
        };
        out.$$plus$eq__C__scm_StringBuilder(ch)
      } else if (encodeNonAscii) {
        out.$$plus$plus$eq__T__scm_StringBuilder("\\u");
        if ((ch <= 4095)) {
          if ((ch > 255)) {
            out.$$plus$eq__C__scm_StringBuilder(48)
          } else {
            out.$$plus$plus$eq__T__scm_StringBuilder("00")
          }
        };
        out.$$plus$plus$eq__T__scm_StringBuilder($m_Lorg_mulesoft_common_core_package$Chars$().toHexString$extension__C__T(ch))
      } else {
        out.$$plus$eq__C__scm_StringBuilder(ch)
      };
      f = ((1 + f) | 0)
    };
    return out.underlying$5.java$lang$StringBuilder$$content$f
  }
});
var $d_Lorg_mulesoft_common_core_package$Strings$ = new $TypeData().initClass({
  Lorg_mulesoft_common_core_package$Strings$: 0
}, false, "org.mulesoft.common.core.package$Strings$", {
  Lorg_mulesoft_common_core_package$Strings$: 1,
  O: 1
});
$c_Lorg_mulesoft_common_core_package$Strings$.prototype.$classData = $d_Lorg_mulesoft_common_core_package$Strings$;
var $n_Lorg_mulesoft_common_core_package$Strings$ = (void 0);
function $m_Lorg_mulesoft_common_core_package$Strings$() {
  if ((!$n_Lorg_mulesoft_common_core_package$Strings$)) {
    $n_Lorg_mulesoft_common_core_package$Strings$ = new $c_Lorg_mulesoft_common_core_package$Strings$().init___()
  };
  return $n_Lorg_mulesoft_common_core_package$Strings$
}
/** @constructor */
function $c_Lorg_mulesoft_common_io_Output$OutputOps() {
  $c_O.call(this);
  this.w$1 = null
}
$c_Lorg_mulesoft_common_io_Output$OutputOps.prototype = new $h_O();
$c_Lorg_mulesoft_common_io_Output$OutputOps.prototype.constructor = $c_Lorg_mulesoft_common_io_Output$OutputOps;
/** @constructor */
function $h_Lorg_mulesoft_common_io_Output$OutputOps() {
  /*<skip>*/
}
$h_Lorg_mulesoft_common_io_Output$OutputOps.prototype = $c_Lorg_mulesoft_common_io_Output$OutputOps.prototype;
$c_Lorg_mulesoft_common_io_Output$OutputOps.prototype.init___O = (function(w) {
  this.w$1 = w;
  return this
});
var $d_Lorg_mulesoft_common_io_Output$OutputOps = new $TypeData().initClass({
  Lorg_mulesoft_common_io_Output$OutputOps: 0
}, false, "org.mulesoft.common.io.Output$OutputOps", {
  Lorg_mulesoft_common_io_Output$OutputOps: 1,
  O: 1
});
$c_Lorg_mulesoft_common_io_Output$OutputOps.prototype.$classData = $d_Lorg_mulesoft_common_io_Output$OutputOps;
/** @constructor */
function $c_Lorg_mulesoft_common_parse_ParseError$() {
  $c_O.call(this)
}
$c_Lorg_mulesoft_common_parse_ParseError$.prototype = new $h_O();
$c_Lorg_mulesoft_common_parse_ParseError$.prototype.constructor = $c_Lorg_mulesoft_common_parse_ParseError$;
/** @constructor */
function $h_Lorg_mulesoft_common_parse_ParseError$() {
  /*<skip>*/
}
$h_Lorg_mulesoft_common_parse_ParseError$.prototype = $c_Lorg_mulesoft_common_parse_ParseError$.prototype;
$c_Lorg_mulesoft_common_parse_ParseError$.prototype.init___ = (function() {
  return this
});
$c_Lorg_mulesoft_common_parse_ParseError$.prototype.formatError__T__T__s_util_Either = (function(value, msg) {
  $m_s_package$();
  var value$1 = new $c_Lorg_mulesoft_common_parse_FormatError().init___T__T(value, msg);
  return new $c_s_util_Left().init___O(value$1)
});
var $d_Lorg_mulesoft_common_parse_ParseError$ = new $TypeData().initClass({
  Lorg_mulesoft_common_parse_ParseError$: 0
}, false, "org.mulesoft.common.parse.ParseError$", {
  Lorg_mulesoft_common_parse_ParseError$: 1,
  O: 1
});
$c_Lorg_mulesoft_common_parse_ParseError$.prototype.$classData = $d_Lorg_mulesoft_common_parse_ParseError$;
var $n_Lorg_mulesoft_common_parse_ParseError$ = (void 0);
function $m_Lorg_mulesoft_common_parse_ParseError$() {
  if ((!$n_Lorg_mulesoft_common_parse_ParseError$)) {
    $n_Lorg_mulesoft_common_parse_ParseError$ = new $c_Lorg_mulesoft_common_parse_ParseError$().init___()
  };
  return $n_Lorg_mulesoft_common_parse_ParseError$
}
/** @constructor */
function $c_Lorg_mulesoft_common_time_package$DateTimes$() {
  $c_O.call(this)
}
$c_Lorg_mulesoft_common_time_package$DateTimes$.prototype = new $h_O();
$c_Lorg_mulesoft_common_time_package$DateTimes$.prototype.constructor = $c_Lorg_mulesoft_common_time_package$DateTimes$;
/** @constructor */
function $h_Lorg_mulesoft_common_time_package$DateTimes$() {
  /*<skip>*/
}
$h_Lorg_mulesoft_common_time_package$DateTimes$.prototype = $c_Lorg_mulesoft_common_time_package$DateTimes$.prototype;
$c_Lorg_mulesoft_common_time_package$DateTimes$.prototype.init___ = (function() {
  return this
});
$c_Lorg_mulesoft_common_time_package$DateTimes$.prototype.toJsDate$extension__Lorg_mulesoft_common_time_SimpleDateTime__sjs_js_Date = (function($$this) {
  var this$1 = $$this.timeOfDay$1;
  var t = $as_Lorg_mulesoft_common_time_TimeOfDay((this$1.isEmpty__Z() ? $m_Lorg_mulesoft_common_time_SimpleDateTime$().ZeroTime$1 : this$1.get__O()));
  var nano = ((t.nano$1 / 1000000) | 0);
  var x1 = $$this.zoneOffset$1;
  var x = $m_s_None$();
  if ((x === x1)) {
    return new $g.Date($$this.year$1, (((-1) + $$this.month$1) | 0), $$this.day$1, t.hour$1, t.minute$1, t.second$1, nano)
  } else if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var tz = $uI(x2.value$2);
    var s = ($uD($g.Date.UTC($$this.year$1, (((-1) + $$this.month$1) | 0), $$this.day$1, t.hour$1, t.minute$1, t.second$1, nano)) + $imul(1000, tz));
    return new $g.Date(s)
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lorg_mulesoft_common_time_package$DateTimes$.prototype.toDate$extension__Lorg_mulesoft_common_time_SimpleDateTime__ju_Date = (function($$this) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var value = $uD($m_Lorg_mulesoft_common_time_package$DateTimes$().toJsDate$extension__Lorg_mulesoft_common_time_SimpleDateTime__sjs_js_Date($$this).getTime());
  var lo = this$1.scala$scalajs$runtime$RuntimeLong$$fromDoubleImpl__D__I(value);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_ju_Date().init___J(new $c_sjsr_RuntimeLong().init___I__I(lo, hi))
});
var $d_Lorg_mulesoft_common_time_package$DateTimes$ = new $TypeData().initClass({
  Lorg_mulesoft_common_time_package$DateTimes$: 0
}, false, "org.mulesoft.common.time.package$DateTimes$", {
  Lorg_mulesoft_common_time_package$DateTimes$: 1,
  O: 1
});
$c_Lorg_mulesoft_common_time_package$DateTimes$.prototype.$classData = $d_Lorg_mulesoft_common_time_package$DateTimes$;
var $n_Lorg_mulesoft_common_time_package$DateTimes$ = (void 0);
function $m_Lorg_mulesoft_common_time_package$DateTimes$() {
  if ((!$n_Lorg_mulesoft_common_time_package$DateTimes$)) {
    $n_Lorg_mulesoft_common_time_package$DateTimes$ = new $c_Lorg_mulesoft_common_time_package$DateTimes$().init___()
  };
  return $n_Lorg_mulesoft_common_time_package$DateTimes$
}
/** @constructor */
function $c_Lorg_mulesoft_lexer_CharSequenceLexerInput$() {
  $c_O.call(this)
}
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput$.prototype = new $h_O();
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput$.prototype.constructor = $c_Lorg_mulesoft_lexer_CharSequenceLexerInput$;
/** @constructor */
function $h_Lorg_mulesoft_lexer_CharSequenceLexerInput$() {
  /*<skip>*/
}
$h_Lorg_mulesoft_lexer_CharSequenceLexerInput$.prototype = $c_Lorg_mulesoft_lexer_CharSequenceLexerInput$.prototype;
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput$.prototype.init___ = (function() {
  return this
});
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput$.prototype.apply__jl_CharSequence__I__I__T__Lorg_mulesoft_lexer_CharSequenceLexerInput = (function(data, startOffset, endOffset, sourceName) {
  var a = $charSequenceLength(data);
  return new $c_Lorg_mulesoft_lexer_CharSequenceLexerInput().init___jl_CharSequence__I__I__T(data, startOffset, ((a < endOffset) ? a : endOffset), sourceName)
});
var $d_Lorg_mulesoft_lexer_CharSequenceLexerInput$ = new $TypeData().initClass({
  Lorg_mulesoft_lexer_CharSequenceLexerInput$: 0
}, false, "org.mulesoft.lexer.CharSequenceLexerInput$", {
  Lorg_mulesoft_lexer_CharSequenceLexerInput$: 1,
  O: 1
});
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput$.prototype.$classData = $d_Lorg_mulesoft_lexer_CharSequenceLexerInput$;
var $n_Lorg_mulesoft_lexer_CharSequenceLexerInput$ = (void 0);
function $m_Lorg_mulesoft_lexer_CharSequenceLexerInput$() {
  if ((!$n_Lorg_mulesoft_lexer_CharSequenceLexerInput$)) {
    $n_Lorg_mulesoft_lexer_CharSequenceLexerInput$ = new $c_Lorg_mulesoft_lexer_CharSequenceLexerInput$().init___()
  };
  return $n_Lorg_mulesoft_lexer_CharSequenceLexerInput$
}
/** @constructor */
function $c_Lorg_mulesoft_lexer_LexerInput$() {
  $c_O.call(this);
  this.EofChar$1 = 0
}
$c_Lorg_mulesoft_lexer_LexerInput$.prototype = new $h_O();
$c_Lorg_mulesoft_lexer_LexerInput$.prototype.constructor = $c_Lorg_mulesoft_lexer_LexerInput$;
/** @constructor */
function $h_Lorg_mulesoft_lexer_LexerInput$() {
  /*<skip>*/
}
$h_Lorg_mulesoft_lexer_LexerInput$.prototype = $c_Lorg_mulesoft_lexer_LexerInput$.prototype;
$c_Lorg_mulesoft_lexer_LexerInput$.prototype.init___ = (function() {
  this.EofChar$1 = (-1);
  return this
});
var $d_Lorg_mulesoft_lexer_LexerInput$ = new $TypeData().initClass({
  Lorg_mulesoft_lexer_LexerInput$: 0
}, false, "org.mulesoft.lexer.LexerInput$", {
  Lorg_mulesoft_lexer_LexerInput$: 1,
  O: 1
});
$c_Lorg_mulesoft_lexer_LexerInput$.prototype.$classData = $d_Lorg_mulesoft_lexer_LexerInput$;
var $n_Lorg_mulesoft_lexer_LexerInput$ = (void 0);
function $m_Lorg_mulesoft_lexer_LexerInput$() {
  if ((!$n_Lorg_mulesoft_lexer_LexerInput$)) {
    $n_Lorg_mulesoft_lexer_LexerInput$ = new $c_Lorg_mulesoft_lexer_LexerInput$().init___()
  };
  return $n_Lorg_mulesoft_lexer_LexerInput$
}
/** @constructor */
function $c_Lorg_mulesoft_lexer_Position$() {
  $c_O.call(this);
  this.Zero$1 = null
}
$c_Lorg_mulesoft_lexer_Position$.prototype = new $h_O();
$c_Lorg_mulesoft_lexer_Position$.prototype.constructor = $c_Lorg_mulesoft_lexer_Position$;
/** @constructor */
function $h_Lorg_mulesoft_lexer_Position$() {
  /*<skip>*/
}
$h_Lorg_mulesoft_lexer_Position$.prototype = $c_Lorg_mulesoft_lexer_Position$.prototype;
$c_Lorg_mulesoft_lexer_Position$.prototype.init___ = (function() {
  $n_Lorg_mulesoft_lexer_Position$ = this;
  this.Zero$1 = new $c_Lorg_mulesoft_lexer_Position().init___I__I__I(0, 0, 0);
  return this
});
$c_Lorg_mulesoft_lexer_Position$.prototype.apply__I__I__I__Lorg_mulesoft_lexer_Position = (function(line, column, offset) {
  return ((((line === 0) && (column === 0)) && (offset === 0)) ? this.Zero$1 : new $c_Lorg_mulesoft_lexer_Position().init___I__I__I(line, column, offset))
});
var $d_Lorg_mulesoft_lexer_Position$ = new $TypeData().initClass({
  Lorg_mulesoft_lexer_Position$: 0
}, false, "org.mulesoft.lexer.Position$", {
  Lorg_mulesoft_lexer_Position$: 1,
  O: 1
});
$c_Lorg_mulesoft_lexer_Position$.prototype.$classData = $d_Lorg_mulesoft_lexer_Position$;
var $n_Lorg_mulesoft_lexer_Position$ = (void 0);
function $m_Lorg_mulesoft_lexer_Position$() {
  if ((!$n_Lorg_mulesoft_lexer_Position$)) {
    $n_Lorg_mulesoft_lexer_Position$ = new $c_Lorg_mulesoft_lexer_Position$().init___()
  };
  return $n_Lorg_mulesoft_lexer_Position$
}
/** @constructor */
function $c_Lorg_mulesoft_lexer_Queue() {
  $c_O.call(this);
  this.buffer$1 = null;
  this.head$1 = 0;
  this.tail$1 = 0
}
$c_Lorg_mulesoft_lexer_Queue.prototype = new $h_O();
$c_Lorg_mulesoft_lexer_Queue.prototype.constructor = $c_Lorg_mulesoft_lexer_Queue;
/** @constructor */
function $h_Lorg_mulesoft_lexer_Queue() {
  /*<skip>*/
}
$h_Lorg_mulesoft_lexer_Queue.prototype = $c_Lorg_mulesoft_lexer_Queue.prototype;
$c_Lorg_mulesoft_lexer_Queue.prototype.init___ = (function() {
  this.buffer$1 = new $c_scm_ArrayBuffer().init___I(10000);
  this.head$1 = 0;
  this.tail$1 = 0;
  return this
});
$c_Lorg_mulesoft_lexer_Queue.prototype.reduceTo__I__V = (function(newSize) {
  this.tail$1 = ((this.head$1 + newSize) | 0)
});
$c_Lorg_mulesoft_lexer_Queue.prototype.dequeue__O = (function() {
  this.head$1 = ((1 + this.head$1) | 0);
  var this$1 = this.buffer$1;
  var idx = (((-1) + this.head$1) | 0);
  return $f_scm_ResizableArray__apply__I__O(this$1, idx)
});
$c_Lorg_mulesoft_lexer_Queue.prototype.isEmpty__Z = (function() {
  return (this.tail$1 <= this.head$1)
});
$c_Lorg_mulesoft_lexer_Queue.prototype.$$plus$eq__O__Lorg_mulesoft_lexer_Queue = (function(t) {
  var this$1 = this.buffer$1;
  if ((this$1.size0$6 <= this.tail$1)) {
    this.buffer$1.$$plus$eq__O__scm_ArrayBuffer(t)
  } else {
    var this$2 = this.buffer$1;
    var idx = this.tail$1;
    $f_scm_ResizableArray__update__I__O__V(this$2, idx, t)
  };
  this.tail$1 = ((1 + this.tail$1) | 0);
  return this
});
$c_Lorg_mulesoft_lexer_Queue.prototype.size__I = (function() {
  return ((this.tail$1 - this.head$1) | 0)
});
var $d_Lorg_mulesoft_lexer_Queue = new $TypeData().initClass({
  Lorg_mulesoft_lexer_Queue: 0
}, false, "org.mulesoft.lexer.Queue", {
  Lorg_mulesoft_lexer_Queue: 1,
  O: 1
});
$c_Lorg_mulesoft_lexer_Queue.prototype.$classData = $d_Lorg_mulesoft_lexer_Queue;
/** @constructor */
function $c_Lorg_mulesoft_lexer_Token() {
  $c_O.call(this);
  this.name$1 = null;
  this.abbreviation$1 = null
}
$c_Lorg_mulesoft_lexer_Token.prototype = new $h_O();
$c_Lorg_mulesoft_lexer_Token.prototype.constructor = $c_Lorg_mulesoft_lexer_Token;
/** @constructor */
function $h_Lorg_mulesoft_lexer_Token() {
  /*<skip>*/
}
$h_Lorg_mulesoft_lexer_Token.prototype = $c_Lorg_mulesoft_lexer_Token.prototype;
$c_Lorg_mulesoft_lexer_Token.prototype.init___T__T = (function(name, abbreviation) {
  this.name$1 = name;
  this.abbreviation$1 = abbreviation;
  return this
});
$c_Lorg_mulesoft_lexer_Token.prototype.toString__T = (function() {
  return this.name$1
});
/** @constructor */
function $c_Lorg_scalajs_dom_ext_Ajax$() {
  $c_O.call(this)
}
$c_Lorg_scalajs_dom_ext_Ajax$.prototype = new $h_O();
$c_Lorg_scalajs_dom_ext_Ajax$.prototype.constructor = $c_Lorg_scalajs_dom_ext_Ajax$;
/** @constructor */
function $h_Lorg_scalajs_dom_ext_Ajax$() {
  /*<skip>*/
}
$h_Lorg_scalajs_dom_ext_Ajax$.prototype = $c_Lorg_scalajs_dom_ext_Ajax$.prototype;
$c_Lorg_scalajs_dom_ext_Ajax$.prototype.init___ = (function() {
  return this
});
$c_Lorg_scalajs_dom_ext_Ajax$.prototype.org$scalajs$dom$ext$Ajax$$$anonfun$apply$1__Lorg_scalajs_dom_raw_Event__Lorg_scalajs_dom_raw_XMLHttpRequest__s_concurrent_Promise__O = (function(e, req$1, promise$1) {
  if (($uI(req$1.readyState) === 4)) {
    if (((($uI(req$1.status) >= 200) && ($uI(req$1.status) < 300)) || ($uI(req$1.status) === 304))) {
      return $f_s_concurrent_Promise__success__O__s_concurrent_Promise(promise$1, req$1)
    } else {
      var cause = new $c_Lorg_scalajs_dom_ext_AjaxException().init___Lorg_scalajs_dom_raw_XMLHttpRequest(req$1);
      return $f_s_concurrent_Promise__failure__jl_Throwable__s_concurrent_Promise(promise$1, cause)
    }
  } else {
    return (void 0)
  }
});
$c_Lorg_scalajs_dom_ext_Ajax$.prototype.apply__T__T__Lorg_scalajs_dom_ext_Ajax$InputData__I__sci_Map__Z__T__s_concurrent_Future = (function(method, url, data, timeout, headers, withCredentials, responseType) {
  var req = new $g.XMLHttpRequest();
  var promise = new $c_s_concurrent_impl_Promise$DefaultPromise().init___();
  req.onreadystatechange = (function(req$1, promise$1) {
    return (function(arg1$2) {
      return $m_Lorg_scalajs_dom_ext_Ajax$().org$scalajs$dom$ext$Ajax$$$anonfun$apply$1__Lorg_scalajs_dom_raw_Event__Lorg_scalajs_dom_raw_XMLHttpRequest__s_concurrent_Promise__O(arg1$2, req$1, promise$1)
    })
  })(req, promise);
  req.open(method, url);
  req.responseType = responseType;
  req.timeout = timeout;
  req.withCredentials = withCredentials;
  headers.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, req$2) {
    return (function(x$2) {
      var x = $as_T2(x$2);
      req$2.setRequestHeader($as_T(x.$$und1__O()), $as_T(x.$$und2__O()))
    })
  })(this, req)));
  if ((data === null)) {
    req.send()
  } else {
    req.send(data)
  };
  return promise
});
var $d_Lorg_scalajs_dom_ext_Ajax$ = new $TypeData().initClass({
  Lorg_scalajs_dom_ext_Ajax$: 0
}, false, "org.scalajs.dom.ext.Ajax$", {
  Lorg_scalajs_dom_ext_Ajax$: 1,
  O: 1
});
$c_Lorg_scalajs_dom_ext_Ajax$.prototype.$classData = $d_Lorg_scalajs_dom_ext_Ajax$;
var $n_Lorg_scalajs_dom_ext_Ajax$ = (void 0);
function $m_Lorg_scalajs_dom_ext_Ajax$() {
  if ((!$n_Lorg_scalajs_dom_ext_Ajax$)) {
    $n_Lorg_scalajs_dom_ext_Ajax$ = new $c_Lorg_scalajs_dom_ext_Ajax$().init___()
  };
  return $n_Lorg_scalajs_dom_ext_Ajax$
}
/** @constructor */
function $c_Lorg_yaml_builder_DocBuilder() {
  $c_O.call(this)
}
$c_Lorg_yaml_builder_DocBuilder.prototype = new $h_O();
$c_Lorg_yaml_builder_DocBuilder.prototype.constructor = $c_Lorg_yaml_builder_DocBuilder;
/** @constructor */
function $h_Lorg_yaml_builder_DocBuilder() {
  /*<skip>*/
}
$h_Lorg_yaml_builder_DocBuilder.prototype = $c_Lorg_yaml_builder_DocBuilder.prototype;
function $as_Lorg_yaml_builder_DocBuilder(obj) {
  return (((obj instanceof $c_Lorg_yaml_builder_DocBuilder) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.builder.DocBuilder"))
}
function $isArrayOf_Lorg_yaml_builder_DocBuilder(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_builder_DocBuilder)))
}
function $asArrayOf_Lorg_yaml_builder_DocBuilder(obj, depth) {
  return (($isArrayOf_Lorg_yaml_builder_DocBuilder(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.builder.DocBuilder;", depth))
}
/** @constructor */
function $c_Lorg_yaml_builder_DocBuilder$Entry() {
  $c_O.call(this)
}
$c_Lorg_yaml_builder_DocBuilder$Entry.prototype = new $h_O();
$c_Lorg_yaml_builder_DocBuilder$Entry.prototype.constructor = $c_Lorg_yaml_builder_DocBuilder$Entry;
/** @constructor */
function $h_Lorg_yaml_builder_DocBuilder$Entry() {
  /*<skip>*/
}
$h_Lorg_yaml_builder_DocBuilder$Entry.prototype = $c_Lorg_yaml_builder_DocBuilder$Entry.prototype;
$c_Lorg_yaml_builder_DocBuilder$Entry.prototype.entry__T__T__V = (function(key, str) {
  this.entry__T__Lorg_yaml_builder_DocBuilder$Scalar__V(key, new $c_Lorg_yaml_builder_DocBuilder$Scalar().init___Lorg_yaml_builder_DocBuilder$SType__O($m_Lorg_yaml_builder_DocBuilder$SType$Str$(), str))
});
function $as_Lorg_yaml_builder_DocBuilder$Entry(obj) {
  return (((obj instanceof $c_Lorg_yaml_builder_DocBuilder$Entry) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.builder.DocBuilder$Entry"))
}
function $isArrayOf_Lorg_yaml_builder_DocBuilder$Entry(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_builder_DocBuilder$Entry)))
}
function $asArrayOf_Lorg_yaml_builder_DocBuilder$Entry(obj, depth) {
  return (($isArrayOf_Lorg_yaml_builder_DocBuilder$Entry(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.builder.DocBuilder$Entry;", depth))
}
/** @constructor */
function $c_Lorg_yaml_builder_DocBuilder$Part() {
  $c_O.call(this)
}
$c_Lorg_yaml_builder_DocBuilder$Part.prototype = new $h_O();
$c_Lorg_yaml_builder_DocBuilder$Part.prototype.constructor = $c_Lorg_yaml_builder_DocBuilder$Part;
/** @constructor */
function $h_Lorg_yaml_builder_DocBuilder$Part() {
  /*<skip>*/
}
$h_Lorg_yaml_builder_DocBuilder$Part.prototype = $c_Lorg_yaml_builder_DocBuilder$Part.prototype;
$c_Lorg_yaml_builder_DocBuilder$Part.prototype.$$plus$eq__T__V = (function(str) {
  this.$$plus$eq__Lorg_yaml_builder_DocBuilder$Scalar__V(new $c_Lorg_yaml_builder_DocBuilder$Scalar().init___Lorg_yaml_builder_DocBuilder$SType__O($m_Lorg_yaml_builder_DocBuilder$SType$Str$(), str))
});
function $as_Lorg_yaml_builder_DocBuilder$Part(obj) {
  return (((obj instanceof $c_Lorg_yaml_builder_DocBuilder$Part) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.builder.DocBuilder$Part"))
}
function $isArrayOf_Lorg_yaml_builder_DocBuilder$Part(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_builder_DocBuilder$Part)))
}
function $asArrayOf_Lorg_yaml_builder_DocBuilder$Part(obj, depth) {
  return (($isArrayOf_Lorg_yaml_builder_DocBuilder$Part(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.builder.DocBuilder$Part;", depth))
}
/** @constructor */
function $c_Lorg_yaml_convert_YRead$() {
  $c_O.call(this)
}
$c_Lorg_yaml_convert_YRead$.prototype = new $h_O();
$c_Lorg_yaml_convert_YRead$.prototype.constructor = $c_Lorg_yaml_convert_YRead$;
/** @constructor */
function $h_Lorg_yaml_convert_YRead$() {
  /*<skip>*/
}
$h_Lorg_yaml_convert_YRead$.prototype = $c_Lorg_yaml_convert_YRead$.prototype;
$c_Lorg_yaml_convert_YRead$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_convert_YRead$.prototype.error__Lorg_yaml_model_YNode__T__s_util_Left = (function(node, err) {
  $m_s_package$();
  var err$2 = new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, err$1) {
    return (function() {
      return err$1
    })
  })(this, err));
  var value = new $c_Lorg_yaml_model_YError().init___Lorg_yaml_model_YNodeLike__F0(node, err$2);
  return new $c_s_util_Left().init___O(value)
});
var $d_Lorg_yaml_convert_YRead$ = new $TypeData().initClass({
  Lorg_yaml_convert_YRead$: 0
}, false, "org.yaml.convert.YRead$", {
  Lorg_yaml_convert_YRead$: 1,
  O: 1
});
$c_Lorg_yaml_convert_YRead$.prototype.$classData = $d_Lorg_yaml_convert_YRead$;
var $n_Lorg_yaml_convert_YRead$ = (void 0);
function $m_Lorg_yaml_convert_YRead$() {
  if ((!$n_Lorg_yaml_convert_YRead$)) {
    $n_Lorg_yaml_convert_YRead$ = new $c_Lorg_yaml_convert_YRead$().init___()
  };
  return $n_Lorg_yaml_convert_YRead$
}
/** @constructor */
function $c_Lorg_yaml_lexer_JsonLexer$() {
  $c_O.call(this)
}
$c_Lorg_yaml_lexer_JsonLexer$.prototype = new $h_O();
$c_Lorg_yaml_lexer_JsonLexer$.prototype.constructor = $c_Lorg_yaml_lexer_JsonLexer$;
/** @constructor */
function $h_Lorg_yaml_lexer_JsonLexer$() {
  /*<skip>*/
}
$h_Lorg_yaml_lexer_JsonLexer$.prototype = $c_Lorg_yaml_lexer_JsonLexer$.prototype;
$c_Lorg_yaml_lexer_JsonLexer$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_lexer_JsonLexer$.prototype.apply__jl_CharSequence__T__Lorg_mulesoft_lexer_Position__Lorg_yaml_lexer_JsonLexer = (function(cs, sourceName, positionOffset) {
  return new $c_Lorg_yaml_lexer_JsonLexer().init___Lorg_mulesoft_lexer_LexerInput__Lorg_mulesoft_lexer_Position($m_Lorg_mulesoft_lexer_CharSequenceLexerInput$().apply__jl_CharSequence__I__I__T__Lorg_mulesoft_lexer_CharSequenceLexerInput(cs, 0, 2147483647, sourceName), positionOffset)
});
$c_Lorg_yaml_lexer_JsonLexer$.prototype.apply__jl_CharSequence__Lorg_yaml_lexer_JsonLexer = (function(cs) {
  return new $c_Lorg_yaml_lexer_JsonLexer().init___Lorg_mulesoft_lexer_LexerInput__Lorg_mulesoft_lexer_Position($m_Lorg_mulesoft_lexer_CharSequenceLexerInput$().apply__jl_CharSequence__I__I__T__Lorg_mulesoft_lexer_CharSequenceLexerInput(cs, 0, 2147483647, ""), $m_Lorg_mulesoft_lexer_Position$().Zero$1)
});
$c_Lorg_yaml_lexer_JsonLexer$.prototype.org$yaml$lexer$JsonLexer$$isDigit__I__Z = (function(c) {
  return ((c >= 48) && (c <= 57))
});
$c_Lorg_yaml_lexer_JsonLexer$.prototype.org$yaml$lexer$JsonLexer$$isWhitespace__I__Z = (function(c) {
  return (((c === 32) || (c === 9)) || (c === 13))
});
var $d_Lorg_yaml_lexer_JsonLexer$ = new $TypeData().initClass({
  Lorg_yaml_lexer_JsonLexer$: 0
}, false, "org.yaml.lexer.JsonLexer$", {
  Lorg_yaml_lexer_JsonLexer$: 1,
  O: 1
});
$c_Lorg_yaml_lexer_JsonLexer$.prototype.$classData = $d_Lorg_yaml_lexer_JsonLexer$;
var $n_Lorg_yaml_lexer_JsonLexer$ = (void 0);
function $m_Lorg_yaml_lexer_JsonLexer$() {
  if ((!$n_Lorg_yaml_lexer_JsonLexer$)) {
    $n_Lorg_yaml_lexer_JsonLexer$ = new $c_Lorg_yaml_lexer_JsonLexer$().init___()
  };
  return $n_Lorg_yaml_lexer_JsonLexer$
}
/** @constructor */
function $c_Lorg_yaml_lexer_YamlCharRules$() {
  $c_O.call(this)
}
$c_Lorg_yaml_lexer_YamlCharRules$.prototype = new $h_O();
$c_Lorg_yaml_lexer_YamlCharRules$.prototype.constructor = $c_Lorg_yaml_lexer_YamlCharRules$;
/** @constructor */
function $h_Lorg_yaml_lexer_YamlCharRules$() {
  /*<skip>*/
}
$h_Lorg_yaml_lexer_YamlCharRules$.prototype = $c_Lorg_yaml_lexer_YamlCharRules$.prototype;
$c_Lorg_yaml_lexer_YamlCharRules$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_lexer_YamlCharRules$.prototype.isIndicator__I__Z = (function(c) {
  return ($m_sjsr_RuntimeString$().indexOf__T__I__I("-?:,[]{}#&*!|>'\"%@ `", c) !== (-1))
});
$c_Lorg_yaml_lexer_YamlCharRules$.prototype.isFlowIndicator__I__Z = (function(chr) {
  return (((((chr === 91) || (chr === 93)) || (chr === 123)) || (chr === 125)) || (chr === 44))
});
$c_Lorg_yaml_lexer_YamlCharRules$.prototype.isWhite__I__Z = (function(c) {
  return ((c === 32) || (c === 9))
});
$c_Lorg_yaml_lexer_YamlCharRules$.prototype.isCPrintable__I__Z = (function(c) {
  return ((((((((c === 9) || (c === 10)) || (c === 13)) || ((c >= 32) && (c <= 126))) || (c === 133)) || ((c >= 160) && (c <= 55295))) || ((c >= 57344) && (c <= 65533))) || ((c >= 65536) && (c <= 1114111)))
});
$c_Lorg_yaml_lexer_YamlCharRules$.prototype.isBreakOrEof__I__Z = (function(c) {
  return (((c === 10) || (c === 13)) || (c === $m_Lorg_mulesoft_lexer_LexerInput$().EofChar$1))
});
$c_Lorg_yaml_lexer_YamlCharRules$.prototype.isBBreak__I__Z = (function(c) {
  return ((c === 10) || (c === 13))
});
$c_Lorg_yaml_lexer_YamlCharRules$.prototype.isWordChar__I__Z = (function(c) {
  return ((((c >= 48) && (c <= 57)) || (((c >= 65) && (c <= 90)) || ((c >= 97) && (c <= 122)))) || (c === 45))
});
$c_Lorg_yaml_lexer_YamlCharRules$.prototype.isNsChar__I__Z = (function(c) {
  return ((((((c > 32) && (c <= 126)) || (c === 133)) || ((c >= 160) && (c <= 55295))) || ((c >= 57344) && (c <= 65533))) || ((c >= 65536) && (c <= 1114111)))
});
$c_Lorg_yaml_lexer_YamlCharRules$.prototype.escapeSeq__I__I = (function(c) {
  switch (c) {
    case 48: {
      return 0;
      break
    }
    case 97: {
      return 7;
      break
    }
    case 98: {
      return 11;
      break
    }
    case 116:
    case 9: {
      return 9;
      break
    }
    case 110: {
      return 10;
      break
    }
    case 118: {
      return 11;
      break
    }
    case 102: {
      return 12;
      break
    }
    case 114: {
      return 13;
      break
    }
    case 101: {
      return 27;
      break
    }
    case 32: {
      return 32;
      break
    }
    case 34: {
      return 34;
      break
    }
    case 47: {
      return 47;
      break
    }
    case 92: {
      return 92;
      break
    }
    case 78: {
      return 133;
      break
    }
    case 95: {
      return 160;
      break
    }
    case 76: {
      return 8232;
      break
    }
    case 80: {
      return 8233;
      break
    }
    case 120: {
      return 120;
      break
    }
    case 117: {
      return 117;
      break
    }
    case 85: {
      return 85;
      break
    }
    default: {
      return (-1)
    }
  }
});
$c_Lorg_yaml_lexer_YamlCharRules$.prototype.isNBChar__I__Z = (function(c) {
  return ((((((c === 9) || ((c >= 32) && (c <= 126))) || (c === 133)) || ((c >= 160) && (c <= 55295))) || ((c >= 57344) && (c <= 65533))) || ((c >= 65536) && (c <= 1114111)))
});
var $d_Lorg_yaml_lexer_YamlCharRules$ = new $TypeData().initClass({
  Lorg_yaml_lexer_YamlCharRules$: 0
}, false, "org.yaml.lexer.YamlCharRules$", {
  Lorg_yaml_lexer_YamlCharRules$: 1,
  O: 1
});
$c_Lorg_yaml_lexer_YamlCharRules$.prototype.$classData = $d_Lorg_yaml_lexer_YamlCharRules$;
var $n_Lorg_yaml_lexer_YamlCharRules$ = (void 0);
function $m_Lorg_yaml_lexer_YamlCharRules$() {
  if ((!$n_Lorg_yaml_lexer_YamlCharRules$)) {
    $n_Lorg_yaml_lexer_YamlCharRules$ = new $c_Lorg_yaml_lexer_YamlCharRules$().init___()
  };
  return $n_Lorg_yaml_lexer_YamlCharRules$
}
/** @constructor */
function $c_Lorg_yaml_lexer_YamlContext() {
  $c_O.call(this)
}
$c_Lorg_yaml_lexer_YamlContext.prototype = new $h_O();
$c_Lorg_yaml_lexer_YamlContext.prototype.constructor = $c_Lorg_yaml_lexer_YamlContext;
/** @constructor */
function $h_Lorg_yaml_lexer_YamlContext() {
  /*<skip>*/
}
$h_Lorg_yaml_lexer_YamlContext.prototype = $c_Lorg_yaml_lexer_YamlContext.prototype;
/** @constructor */
function $c_Lorg_yaml_lexer_YamlLexer$() {
  $c_O.call(this)
}
$c_Lorg_yaml_lexer_YamlLexer$.prototype = new $h_O();
$c_Lorg_yaml_lexer_YamlLexer$.prototype.constructor = $c_Lorg_yaml_lexer_YamlLexer$;
/** @constructor */
function $h_Lorg_yaml_lexer_YamlLexer$() {
  /*<skip>*/
}
$h_Lorg_yaml_lexer_YamlLexer$.prototype = $c_Lorg_yaml_lexer_YamlLexer$.prototype;
$c_Lorg_yaml_lexer_YamlLexer$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_lexer_YamlLexer$.prototype.apply__jl_CharSequence__T__Lorg_yaml_lexer_YamlLexer = (function(cs, sourceName) {
  return new $c_Lorg_yaml_lexer_YamlLexer().init___Lorg_mulesoft_lexer_LexerInput__Lorg_mulesoft_lexer_Position($m_Lorg_mulesoft_lexer_CharSequenceLexerInput$().apply__jl_CharSequence__I__I__T__Lorg_mulesoft_lexer_CharSequenceLexerInput(cs, 0, 2147483647, sourceName), $m_Lorg_mulesoft_lexer_Position$().Zero$1)
});
$c_Lorg_yaml_lexer_YamlLexer$.prototype.apply__jl_CharSequence__Lorg_yaml_lexer_YamlLexer = (function(cs) {
  return new $c_Lorg_yaml_lexer_YamlLexer().init___Lorg_mulesoft_lexer_LexerInput__Lorg_mulesoft_lexer_Position($m_Lorg_mulesoft_lexer_CharSequenceLexerInput$().apply__jl_CharSequence__I__I__T__Lorg_mulesoft_lexer_CharSequenceLexerInput(cs, 0, 2147483647, ""), $m_Lorg_mulesoft_lexer_Position$().Zero$1)
});
var $d_Lorg_yaml_lexer_YamlLexer$ = new $TypeData().initClass({
  Lorg_yaml_lexer_YamlLexer$: 0
}, false, "org.yaml.lexer.YamlLexer$", {
  Lorg_yaml_lexer_YamlLexer$: 1,
  O: 1
});
$c_Lorg_yaml_lexer_YamlLexer$.prototype.$classData = $d_Lorg_yaml_lexer_YamlLexer$;
var $n_Lorg_yaml_lexer_YamlLexer$ = (void 0);
function $m_Lorg_yaml_lexer_YamlLexer$() {
  if ((!$n_Lorg_yaml_lexer_YamlLexer$)) {
    $n_Lorg_yaml_lexer_YamlLexer$ = new $c_Lorg_yaml_lexer_YamlLexer$().init___()
  };
  return $n_Lorg_yaml_lexer_YamlLexer$
}
/** @constructor */
function $c_Lorg_yaml_lexer_YamlToken$() {
  $c_O.call(this);
  this.org$yaml$lexer$YamlToken$$tokens$1 = null;
  this.BeginAnchor$1 = null;
  this.EndAnchor$1 = null;
  this.LineBreak$1 = null;
  this.BeginComment$1 = null;
  this.EndComment$1 = null;
  this.BeginDirective$1 = null;
  this.EndDirective$1 = null;
  this.BeginEscape$1 = null;
  this.EndEscape$1 = null;
  this.BeginTag$1 = null;
  this.EndTag$1 = null;
  this.BeginHandle$1 = null;
  this.EndHandle$1 = null;
  this.Indicator$1 = null;
  this.Indent$1 = null;
  this.DirectivesEnd$1 = null;
  this.DocumentEnd$1 = null;
  this.LineFeed$1 = null;
  this.LineFold$1 = null;
  this.BeginNode$1 = null;
  this.EndNode$1 = null;
  this.BeginDocument$1 = null;
  this.EndDocument$1 = null;
  this.BeginProperties$1 = null;
  this.EndProperties$1 = null;
  this.BeginAlias$1 = null;
  this.EndAlias$1 = null;
  this.BeginSequence$1 = null;
  this.EndSequence$1 = null;
  this.BeginMapping$1 = null;
  this.EndMapping$1 = null;
  this.BeginScalar$1 = null;
  this.EndScalar$1 = null;
  this.Text$1 = null;
  this.MetaText$1 = null;
  this.Bom$1 = null;
  this.WhiteSpace$1 = null;
  this.BeginPair$1 = null;
  this.EndPair$1 = null;
  this.EndStream$1 = null;
  this.BeginStream$1 = null;
  this.Error$1 = null;
  this.UnParsed$1 = null
}
$c_Lorg_yaml_lexer_YamlToken$.prototype = new $h_O();
$c_Lorg_yaml_lexer_YamlToken$.prototype.constructor = $c_Lorg_yaml_lexer_YamlToken$;
/** @constructor */
function $h_Lorg_yaml_lexer_YamlToken$() {
  /*<skip>*/
}
$h_Lorg_yaml_lexer_YamlToken$.prototype = $c_Lorg_yaml_lexer_YamlToken$.prototype;
$c_Lorg_yaml_lexer_YamlToken$.prototype.init___ = (function() {
  $n_Lorg_yaml_lexer_YamlToken$ = this;
  this.org$yaml$lexer$YamlToken$$tokens$1 = new $c_scm_HashMap().init___();
  this.BeginAnchor$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("BeginAnchor", "A");
  this.EndAnchor$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("EndAnchor", "a");
  this.LineBreak$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("LineBreak", "b");
  this.BeginComment$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("BeginComment", "C");
  this.EndComment$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("EndComment", "c");
  this.BeginDirective$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("BeginDirective", "D");
  this.EndDirective$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("EndDirective", "d");
  this.BeginEscape$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("BeginEscape", "E");
  this.EndEscape$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("EndScape", "e");
  this.BeginTag$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("BeginTag", "G");
  this.EndTag$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("EndTag", "g");
  this.BeginHandle$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("BeginHandle", "H");
  this.EndHandle$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("EndHandle", "h");
  this.Indicator$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("Indicator", "I");
  this.Indent$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("Indent", "i");
  this.DirectivesEnd$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("DirectivesEnd", "K");
  this.DocumentEnd$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("DocumentEnd", "k");
  this.LineFeed$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("LineFeed", "L");
  this.LineFold$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("LineFold", "l");
  this.BeginNode$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("BeginNode", "N");
  this.EndNode$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("EndNode", "n");
  this.BeginDocument$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("BeginDocument", "O");
  this.EndDocument$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("EndDocument", "o");
  this.BeginProperties$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("BeginProperties", "P");
  this.EndProperties$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("EndProperties", "p");
  this.BeginAlias$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("BeginAlias", "R");
  this.EndAlias$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("EndAlias", "r");
  this.BeginSequence$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("BeginSequence", "Q");
  this.EndSequence$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("EndSequence", "q");
  this.BeginMapping$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("BeginMapping", "M");
  this.EndMapping$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("EndMapping", "m");
  this.BeginScalar$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("BeginScalar", "S");
  this.EndScalar$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("EndScalar", "s");
  this.Text$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("Text", "T");
  this.MetaText$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("MetaText", "t");
  this.Bom$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("Bom", "U");
  this.WhiteSpace$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("WhiteSpace", "w");
  this.BeginPair$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("BeginPair", "X");
  this.EndPair$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("EndPair", "x");
  this.EndStream$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("EndStream", "");
  this.BeginStream$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("BeginStream", "");
  this.Error$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("Error", "!");
  this.UnParsed$1 = new $c_Lorg_yaml_lexer_YamlToken().init___T__T("UnParsed", "-");
  return this
});
var $d_Lorg_yaml_lexer_YamlToken$ = new $TypeData().initClass({
  Lorg_yaml_lexer_YamlToken$: 0
}, false, "org.yaml.lexer.YamlToken$", {
  Lorg_yaml_lexer_YamlToken$: 1,
  O: 1
});
$c_Lorg_yaml_lexer_YamlToken$.prototype.$classData = $d_Lorg_yaml_lexer_YamlToken$;
var $n_Lorg_yaml_lexer_YamlToken$ = (void 0);
function $m_Lorg_yaml_lexer_YamlToken$() {
  if ((!$n_Lorg_yaml_lexer_YamlToken$)) {
    $n_Lorg_yaml_lexer_YamlToken$ = new $c_Lorg_yaml_lexer_YamlToken$().init___()
  };
  return $n_Lorg_yaml_lexer_YamlToken$
}
/** @constructor */
function $c_Lorg_yaml_model_IllegalTypeHandler$() {
  $c_O.call(this);
  this.illegalValueHandler$1 = null;
  this.returnDefault$1 = null
}
$c_Lorg_yaml_model_IllegalTypeHandler$.prototype = new $h_O();
$c_Lorg_yaml_model_IllegalTypeHandler$.prototype.constructor = $c_Lorg_yaml_model_IllegalTypeHandler$;
/** @constructor */
function $h_Lorg_yaml_model_IllegalTypeHandler$() {
  /*<skip>*/
}
$h_Lorg_yaml_model_IllegalTypeHandler$.prototype = $c_Lorg_yaml_model_IllegalTypeHandler$.prototype;
$c_Lorg_yaml_model_IllegalTypeHandler$.prototype.init___ = (function() {
  $n_Lorg_yaml_model_IllegalTypeHandler$ = this;
  $m_Lorg_yaml_model_IllegalTypeHandler$();
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(e$2) {
      var e = $as_Lorg_yaml_model_YError(e$2);
      e.throwIt__sr_Nothing$()
    })
  })(this));
  this.illegalValueHandler$1 = new $c_Lorg_yaml_model_IllegalTypeHandler$$anon$1().init___F1(f);
  $m_Lorg_yaml_model_IllegalTypeHandler$();
  var f$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$1$2) {
      $as_Lorg_yaml_model_YError(x$1$2)
    })
  })(this));
  this.returnDefault$1 = new $c_Lorg_yaml_model_IllegalTypeHandler$$anon$1().init___F1(f$1);
  return this
});
var $d_Lorg_yaml_model_IllegalTypeHandler$ = new $TypeData().initClass({
  Lorg_yaml_model_IllegalTypeHandler$: 0
}, false, "org.yaml.model.IllegalTypeHandler$", {
  Lorg_yaml_model_IllegalTypeHandler$: 1,
  O: 1
});
$c_Lorg_yaml_model_IllegalTypeHandler$.prototype.$classData = $d_Lorg_yaml_model_IllegalTypeHandler$;
var $n_Lorg_yaml_model_IllegalTypeHandler$ = (void 0);
function $m_Lorg_yaml_model_IllegalTypeHandler$() {
  if ((!$n_Lorg_yaml_model_IllegalTypeHandler$)) {
    $n_Lorg_yaml_model_IllegalTypeHandler$ = new $c_Lorg_yaml_model_IllegalTypeHandler$().init___()
  };
  return $n_Lorg_yaml_model_IllegalTypeHandler$
}
/** @constructor */
function $c_Lorg_yaml_model_ParseErrorHandler$() {
  $c_O.call(this);
  this.parseErrorHandler$1 = null;
  this.ignoreErrors$1 = null
}
$c_Lorg_yaml_model_ParseErrorHandler$.prototype = new $h_O();
$c_Lorg_yaml_model_ParseErrorHandler$.prototype.constructor = $c_Lorg_yaml_model_ParseErrorHandler$;
/** @constructor */
function $h_Lorg_yaml_model_ParseErrorHandler$() {
  /*<skip>*/
}
$h_Lorg_yaml_model_ParseErrorHandler$.prototype = $c_Lorg_yaml_model_ParseErrorHandler$.prototype;
$c_Lorg_yaml_model_ParseErrorHandler$.prototype.init___ = (function() {
  $n_Lorg_yaml_model_ParseErrorHandler$ = this;
  this.parseErrorHandler$1 = $m_Lorg_yaml_model_ParseErrorHandler$().apply__F2__Lorg_yaml_model_ParseErrorHandler(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(loc$2, e$2) {
      var loc = $as_Lorg_mulesoft_lexer_SourceLocation(loc$2);
      var e = $as_Lorg_yaml_model_SyamlException(e$2);
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_RuntimeException().init___T__jl_Throwable(((((e.s$1 + " at ") + loc.sourceName$1) + ": ") + $m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(loc.lineFrom$1, loc.columnFrom$1, loc.lineTo$1, loc.columnTo$1)), e))
    })
  })(this)));
  this.ignoreErrors$1 = new $c_Lorg_yaml_model_ParseErrorHandler$$$Lambda$2().init___O((function(this$2) {
    return (function(x$1$2, x$2$2) {
      $as_Lorg_mulesoft_lexer_SourceLocation(x$1$2);
      $as_Lorg_yaml_model_SyamlException(x$2$2)
    })
  })(this));
  return this
});
$c_Lorg_yaml_model_ParseErrorHandler$.prototype.apply__F2__Lorg_yaml_model_ParseErrorHandler = (function(f) {
  return new $c_Lorg_yaml_model_ParseErrorHandler$$$Lambda$1().init___O((function($this, f$1) {
    return (function(node$2, e$2) {
      var node = $as_Lorg_mulesoft_lexer_SourceLocation(node$2);
      var e = $as_Lorg_yaml_model_SyamlException(e$2);
      f$1.apply__O__O__O(node, e)
    })
  })(this, f))
});
var $d_Lorg_yaml_model_ParseErrorHandler$ = new $TypeData().initClass({
  Lorg_yaml_model_ParseErrorHandler$: 0
}, false, "org.yaml.model.ParseErrorHandler$", {
  Lorg_yaml_model_ParseErrorHandler$: 1,
  O: 1
});
$c_Lorg_yaml_model_ParseErrorHandler$.prototype.$classData = $d_Lorg_yaml_model_ParseErrorHandler$;
var $n_Lorg_yaml_model_ParseErrorHandler$ = (void 0);
function $m_Lorg_yaml_model_ParseErrorHandler$() {
  if ((!$n_Lorg_yaml_model_ParseErrorHandler$)) {
    $n_Lorg_yaml_model_ParseErrorHandler$ = new $c_Lorg_yaml_model_ParseErrorHandler$().init___()
  };
  return $n_Lorg_yaml_model_ParseErrorHandler$
}
function $f_Lorg_yaml_model_QuotedMark__markText__T__T($thiz, text) {
  var c = $thiz.encodeChar__C();
  var jsx$2 = new $c_jl_Character().init___C(c);
  var jsx$1 = $m_Lorg_mulesoft_common_core_package$Strings$().encode$extension1__T__Z__T(text, true);
  var c$1 = $thiz.encodeChar__C();
  return ((("" + jsx$2) + jsx$1) + new $c_jl_Character().init___C(c$1))
}
function $is_Lorg_yaml_model_QuotedMark(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lorg_yaml_model_QuotedMark)))
}
function $as_Lorg_yaml_model_QuotedMark(obj) {
  return (($is_Lorg_yaml_model_QuotedMark(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.QuotedMark"))
}
function $isArrayOf_Lorg_yaml_model_QuotedMark(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_QuotedMark)))
}
function $asArrayOf_Lorg_yaml_model_QuotedMark(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_QuotedMark(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.QuotedMark;", depth))
}
/** @constructor */
function $c_Lorg_yaml_model_ScalarMark$() {
  $c_O.call(this)
}
$c_Lorg_yaml_model_ScalarMark$.prototype = new $h_O();
$c_Lorg_yaml_model_ScalarMark$.prototype.constructor = $c_Lorg_yaml_model_ScalarMark$;
/** @constructor */
function $h_Lorg_yaml_model_ScalarMark$() {
  /*<skip>*/
}
$h_Lorg_yaml_model_ScalarMark$.prototype = $c_Lorg_yaml_model_ScalarMark$.prototype;
$c_Lorg_yaml_model_ScalarMark$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_model_ScalarMark$.prototype.apply__T__Lorg_yaml_model_ScalarMark = (function(mark) {
  return ((mark === "\"") ? $m_Lorg_yaml_model_DoubleQuoteMark$() : ((mark === "'") ? $m_Lorg_yaml_model_SingleQuoteMark$() : ((mark === "|") ? $m_Lorg_yaml_model_MultilineMark$() : ((mark === ">") ? $m_Lorg_yaml_model_FoldedMark$() : ((mark === "") ? $m_Lorg_yaml_model_NoMark$() : $m_Lorg_yaml_model_UnknownMark$())))))
});
var $d_Lorg_yaml_model_ScalarMark$ = new $TypeData().initClass({
  Lorg_yaml_model_ScalarMark$: 0
}, false, "org.yaml.model.ScalarMark$", {
  Lorg_yaml_model_ScalarMark$: 1,
  O: 1
});
$c_Lorg_yaml_model_ScalarMark$.prototype.$classData = $d_Lorg_yaml_model_ScalarMark$;
var $n_Lorg_yaml_model_ScalarMark$ = (void 0);
function $m_Lorg_yaml_model_ScalarMark$() {
  if ((!$n_Lorg_yaml_model_ScalarMark$)) {
    $n_Lorg_yaml_model_ScalarMark$ = new $c_Lorg_yaml_model_ScalarMark$().init___()
  };
  return $n_Lorg_yaml_model_ScalarMark$
}
/** @constructor */
function $c_Lorg_yaml_model_YDocument$() {
  $c_O.call(this)
}
$c_Lorg_yaml_model_YDocument$.prototype = new $h_O();
$c_Lorg_yaml_model_YDocument$.prototype.constructor = $c_Lorg_yaml_model_YDocument$;
/** @constructor */
function $h_Lorg_yaml_model_YDocument$() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YDocument$.prototype = $c_Lorg_yaml_model_YDocument$.prototype;
$c_Lorg_yaml_model_YDocument$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_model_YDocument$.prototype.apply__Lorg_yaml_model_YNode__T__Lorg_yaml_model_YDocument = (function(mainNode, sourceName) {
  var this$1 = $m_Lorg_yaml_model_YDocument$().apply__T__T__Lorg_yaml_model_YDocument$WithComment("", sourceName);
  return this$1.org$yaml$model$YDocument$WithComment$$createDoc__Lorg_yaml_model_YNode__Lorg_yaml_model_YDocument(mainNode)
});
$c_Lorg_yaml_model_YDocument$.prototype.apply__T__Lorg_yaml_model_YDocument$WithComment = (function(headComment) {
  return new $c_Lorg_yaml_model_YDocument$WithComment().init___T__T(((headComment === null) ? "" : headComment), "")
});
$c_Lorg_yaml_model_YDocument$.prototype.apply__sc_IndexedSeq__T__Lorg_yaml_model_YDocument = (function(children, sourceName) {
  return new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName), children)
});
$c_Lorg_yaml_model_YDocument$.prototype.fromNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YDocument = (function(node) {
  var this$1 = $m_Lorg_yaml_model_YDocument$().apply__T__T__Lorg_yaml_model_YDocument$WithComment("", node.location$1.sourceName$1);
  return this$1.org$yaml$model$YDocument$WithComment$$createDoc__Lorg_yaml_model_YNode__Lorg_yaml_model_YDocument(node)
});
$c_Lorg_yaml_model_YDocument$.prototype.apply__T__T__Lorg_yaml_model_YDocument$WithComment = (function(headComment, sourceName) {
  return new $c_Lorg_yaml_model_YDocument$WithComment().init___T__T(((headComment === null) ? "" : headComment), sourceName)
});
var $d_Lorg_yaml_model_YDocument$ = new $TypeData().initClass({
  Lorg_yaml_model_YDocument$: 0
}, false, "org.yaml.model.YDocument$", {
  Lorg_yaml_model_YDocument$: 1,
  O: 1
});
$c_Lorg_yaml_model_YDocument$.prototype.$classData = $d_Lorg_yaml_model_YDocument$;
var $n_Lorg_yaml_model_YDocument$ = (void 0);
function $m_Lorg_yaml_model_YDocument$() {
  if ((!$n_Lorg_yaml_model_YDocument$)) {
    $n_Lorg_yaml_model_YDocument$ = new $c_Lorg_yaml_model_YDocument$().init___()
  };
  return $n_Lorg_yaml_model_YDocument$
}
/** @constructor */
function $c_Lorg_yaml_model_YDocument$BaseBuilder() {
  $c_O.call(this);
  this.builder$1 = null
}
$c_Lorg_yaml_model_YDocument$BaseBuilder.prototype = new $h_O();
$c_Lorg_yaml_model_YDocument$BaseBuilder.prototype.constructor = $c_Lorg_yaml_model_YDocument$BaseBuilder;
/** @constructor */
function $h_Lorg_yaml_model_YDocument$BaseBuilder() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YDocument$BaseBuilder.prototype = $c_Lorg_yaml_model_YDocument$BaseBuilder.prototype;
$c_Lorg_yaml_model_YDocument$BaseBuilder.prototype.init___ = (function() {
  this.builder$1 = new $c_scm_ArrayBuffer().init___();
  return this
});
$c_Lorg_yaml_model_YDocument$BaseBuilder.prototype.comment__T__V = (function(text) {
  var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(text, "\n", 0);
  var i = 0;
  var len = xs.u.length;
  while ((i < len)) {
    var index = i;
    var arg1 = xs.get(index);
    var line = $as_T(arg1);
    var jsx$2 = this.builder$1;
    var jsx$1 = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this.sourceName__T());
    $m_s_package$();
    $m_sci_IndexedSeq$();
    $m_sci_Vector$();
    var this$9 = new $c_sci_VectorBuilder().init___();
    jsx$2.$$plus$eq__O__scm_ArrayBuffer(new $c_Lorg_yaml_model_YComment().init___T__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(line, jsx$1, this$9.result__sci_Vector()));
    i = ((1 + i) | 0)
  }
});
/** @constructor */
function $c_Lorg_yaml_model_YDocument$WithComment() {
  $c_O.call(this);
  this.obj$module$1 = null;
  this.comment$1 = null;
  this.org$yaml$model$YDocument$WithComment$$sourceName$f = null
}
$c_Lorg_yaml_model_YDocument$WithComment.prototype = new $h_O();
$c_Lorg_yaml_model_YDocument$WithComment.prototype.constructor = $c_Lorg_yaml_model_YDocument$WithComment;
/** @constructor */
function $h_Lorg_yaml_model_YDocument$WithComment() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YDocument$WithComment.prototype = $c_Lorg_yaml_model_YDocument$WithComment.prototype;
$c_Lorg_yaml_model_YDocument$WithComment.prototype.init___T__T = (function(comment, sourceName) {
  this.comment$1 = comment;
  this.org$yaml$model$YDocument$WithComment$$sourceName$f = sourceName;
  return this
});
$c_Lorg_yaml_model_YDocument$WithComment.prototype.org$yaml$model$YDocument$WithComment$$createDoc__Lorg_yaml_model_YNode__Lorg_yaml_model_YDocument = (function(mainNode) {
  var jsx$5 = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this.org$yaml$model$YDocument$WithComment$$sourceName$f);
  var thiz = this.comment$1;
  if ((thiz === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  if ((thiz === "")) {
    var jsx$1 = $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray($makeNativeArrayWrapper($d_Lorg_yaml_model_YNode.getArrayOf(), [mainNode]))
  } else {
    var jsx$4 = $m_s_Predef$();
    var jsx$3 = this.comment$1;
    var jsx$2 = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this.org$yaml$model$YDocument$WithComment$$sourceName$f);
    $m_s_package$();
    $m_sci_IndexedSeq$();
    $m_sci_Vector$();
    var this$6 = new $c_sci_VectorBuilder().init___();
    var jsx$1 = jsx$4.wrapRefArray__AO__scm_WrappedArray($makeNativeArrayWrapper($d_Lorg_yaml_model_YPart.getArrayOf(), [new $c_Lorg_yaml_model_YComment().init___T__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(jsx$3, jsx$2, this$6.result__sci_Vector()), mainNode]))
  };
  return new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(jsx$5, jsx$1)
});
var $d_Lorg_yaml_model_YDocument$WithComment = new $TypeData().initClass({
  Lorg_yaml_model_YDocument$WithComment: 0
}, false, "org.yaml.model.YDocument$WithComment", {
  Lorg_yaml_model_YDocument$WithComment: 1,
  O: 1
});
$c_Lorg_yaml_model_YDocument$WithComment.prototype.$classData = $d_Lorg_yaml_model_YDocument$WithComment;
/** @constructor */
function $c_Lorg_yaml_model_YError() {
  $c_O.call(this);
  this.node$1 = null;
  this.err$1 = null
}
$c_Lorg_yaml_model_YError.prototype = new $h_O();
$c_Lorg_yaml_model_YError.prototype.constructor = $c_Lorg_yaml_model_YError;
/** @constructor */
function $h_Lorg_yaml_model_YError() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YError.prototype = $c_Lorg_yaml_model_YError.prototype;
$c_Lorg_yaml_model_YError.prototype.error__T = (function() {
  return $as_T(this.err$1.apply__O())
});
$c_Lorg_yaml_model_YError.prototype.toString__T = (function() {
  return ((this.error__T() + "@") + this.node$1)
});
$c_Lorg_yaml_model_YError.prototype.init___Lorg_yaml_model_YNodeLike__F0 = (function(node, err) {
  this.node$1 = node;
  this.err$1 = err;
  return this
});
$c_Lorg_yaml_model_YError.prototype.throwIt__sr_Nothing$ = (function() {
  throw new $c_Lorg_yaml_model_YException().init___Lorg_yaml_model_YError(this)
});
function $as_Lorg_yaml_model_YError(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YError) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YError"))
}
function $isArrayOf_Lorg_yaml_model_YError(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YError)))
}
function $asArrayOf_Lorg_yaml_model_YError(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YError(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YError;", depth))
}
var $d_Lorg_yaml_model_YError = new $TypeData().initClass({
  Lorg_yaml_model_YError: 0
}, false, "org.yaml.model.YError", {
  Lorg_yaml_model_YError: 1,
  O: 1
});
$c_Lorg_yaml_model_YError.prototype.$classData = $d_Lorg_yaml_model_YError;
/** @constructor */
function $c_Lorg_yaml_model_YMap$() {
  $c_O.call(this);
  this.empty$1 = null
}
$c_Lorg_yaml_model_YMap$.prototype = new $h_O();
$c_Lorg_yaml_model_YMap$.prototype.constructor = $c_Lorg_yaml_model_YMap$;
/** @constructor */
function $h_Lorg_yaml_model_YMap$() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YMap$.prototype = $c_Lorg_yaml_model_YMap$.prototype;
$c_Lorg_yaml_model_YMap$.prototype.init___ = (function() {
  $n_Lorg_yaml_model_YMap$ = this;
  var jsx$1 = $m_Lorg_yaml_model_YMap$();
  $m_s_package$();
  $m_sci_IndexedSeq$();
  $m_sci_Vector$();
  var this$4 = new $c_sci_VectorBuilder().init___();
  this.empty$1 = jsx$1.apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(this$4.result__sci_Vector(), "");
  return this
});
$c_Lorg_yaml_model_YMap$.prototype.apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap = (function(c, sourceName) {
  return new $c_Lorg_yaml_model_YMap().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName), c)
});
var $d_Lorg_yaml_model_YMap$ = new $TypeData().initClass({
  Lorg_yaml_model_YMap$: 0
}, false, "org.yaml.model.YMap$", {
  Lorg_yaml_model_YMap$: 1,
  O: 1
});
$c_Lorg_yaml_model_YMap$.prototype.$classData = $d_Lorg_yaml_model_YMap$;
var $n_Lorg_yaml_model_YMap$ = (void 0);
function $m_Lorg_yaml_model_YMap$() {
  if ((!$n_Lorg_yaml_model_YMap$)) {
    $n_Lorg_yaml_model_YMap$ = new $c_Lorg_yaml_model_YMap$().init___()
  };
  return $n_Lorg_yaml_model_YMap$
}
/** @constructor */
function $c_Lorg_yaml_model_YMapEntry$() {
  $c_O.call(this)
}
$c_Lorg_yaml_model_YMapEntry$.prototype = new $h_O();
$c_Lorg_yaml_model_YMapEntry$.prototype.constructor = $c_Lorg_yaml_model_YMapEntry$;
/** @constructor */
function $h_Lorg_yaml_model_YMapEntry$() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YMapEntry$.prototype = $c_Lorg_yaml_model_YMapEntry$.prototype;
$c_Lorg_yaml_model_YMapEntry$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_model_YMapEntry$.prototype.apply__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq__Lorg_yaml_model_YMapEntry = (function(location, parts) {
  var jsx$1 = new $c_Lorg_yaml_model_YMapEntry$$anonfun$3().init___();
  var this$1 = $m_sc_IndexedSeq$();
  var kv = $as_sc_IndexedSeq(parts.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBF$6));
  return new $c_Lorg_yaml_model_YMapEntry().init___Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($as_Lorg_yaml_model_YNode(kv.apply__I__O(0)), $as_Lorg_yaml_model_YNode(kv.apply__I__O(1)), location, parts)
});
$c_Lorg_yaml_model_YMapEntry$.prototype.apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry = (function(parts) {
  var jsx$1 = new $c_Lorg_yaml_model_YMapEntry$$anonfun$2().init___();
  var this$1 = $m_sc_IndexedSeq$();
  var kv = $as_sc_IndexedSeq(parts.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBF$6));
  var jsx$4 = $as_Lorg_yaml_model_YNode(kv.apply__I__O(0));
  var jsx$3 = $as_Lorg_yaml_model_YNode(kv.apply__I__O(1));
  var jsx$2 = $m_Lorg_mulesoft_lexer_SourceLocation$();
  var this$2 = $as_Lorg_yaml_model_YPart(kv.apply__I__O(0));
  return new $c_Lorg_yaml_model_YMapEntry().init___Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(jsx$4, jsx$3, jsx$2.apply__T__Lorg_mulesoft_lexer_SourceLocation(this$2.location$1.sourceName$1), parts)
});
$c_Lorg_yaml_model_YMapEntry$.prototype.apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry = (function(k, v) {
  return new $c_Lorg_yaml_model_YMapEntry().init___Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(k, v, $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(k.location$1.sourceName$1), $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray($makeNativeArrayWrapper($d_Lorg_yaml_model_YNode.getArrayOf(), [k, v])))
});
var $d_Lorg_yaml_model_YMapEntry$ = new $TypeData().initClass({
  Lorg_yaml_model_YMapEntry$: 0
}, false, "org.yaml.model.YMapEntry$", {
  Lorg_yaml_model_YMapEntry$: 1,
  O: 1
});
$c_Lorg_yaml_model_YMapEntry$.prototype.$classData = $d_Lorg_yaml_model_YMapEntry$;
var $n_Lorg_yaml_model_YMapEntry$ = (void 0);
function $m_Lorg_yaml_model_YMapEntry$() {
  if ((!$n_Lorg_yaml_model_YMapEntry$)) {
    $n_Lorg_yaml_model_YMapEntry$ = new $c_Lorg_yaml_model_YMapEntry$().init___()
  };
  return $n_Lorg_yaml_model_YMapEntry$
}
/** @constructor */
function $c_Lorg_yaml_model_YNode$() {
  $c_O.call(this);
  this.Null$1 = null;
  this.Empty$1 = null;
  this.org$yaml$model$YNode$$noParts$1 = null
}
$c_Lorg_yaml_model_YNode$.prototype = new $h_O();
$c_Lorg_yaml_model_YNode$.prototype.constructor = $c_Lorg_yaml_model_YNode$;
/** @constructor */
function $h_Lorg_yaml_model_YNode$() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YNode$.prototype = $c_Lorg_yaml_model_YNode$.prototype;
$c_Lorg_yaml_model_YNode$.prototype.init___ = (function() {
  $n_Lorg_yaml_model_YNode$ = this;
  this.Null$1 = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YScalar$().Null$1, $m_Lorg_yaml_model_YType$().Null$1);
  var jsx$1 = $m_Lorg_yaml_model_YNode$();
  var x$3 = $m_Lorg_mulesoft_lexer_SourceLocation$().Unknown$1;
  $m_Lorg_yaml_model_YScalar$();
  var x$4 = $m_Lorg_yaml_model_NoMark$();
  $m_Lorg_yaml_model_YScalar$();
  $m_s_package$();
  $m_sci_IndexedSeq$();
  $m_sci_Vector$();
  var this$6 = new $c_sci_VectorBuilder().init___();
  var x$5 = this$6.result__sci_Vector();
  this.Empty$1 = jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YScalar().init___O__T__Lorg_yaml_model_ScalarMark__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(null, "", x$4, x$3, x$5), $m_Lorg_yaml_model_YType$().Null$1);
  $m_s_package$();
  $m_sci_IndexedSeq$();
  $m_sci_Vector$();
  var this$10 = new $c_sci_VectorBuilder().init___();
  this.org$yaml$model$YNode$$noParts$1 = this$10.result__sci_Vector();
  return this
});
$c_Lorg_yaml_model_YNode$.prototype.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YTag__s_Option__sc_IndexedSeq__T__Lorg_yaml_model_YNode = (function(v, t, a, cs, sourceName) {
  return new $c_Lorg_yaml_model_YNodePlain().init___Lorg_yaml_model_YValue__Lorg_yaml_model_YTag__s_Option__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(v, t, a, $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName), ((cs === null) ? $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray($makeNativeArrayWrapper($d_Lorg_yaml_model_YValue.getArrayOf(), [v])) : cs))
});
$c_Lorg_yaml_model_YNode$.prototype.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode = (function(value, tt) {
  var x$2 = tt.org$yaml$model$YType$$tag$und$1;
  var x$3 = value.location$1.sourceName$1;
  $m_Lorg_yaml_model_YNode$();
  var x$4 = $m_s_None$();
  $m_Lorg_yaml_model_YNode$();
  var x$5 = null;
  return $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YTag__s_Option__sc_IndexedSeq__T__Lorg_yaml_model_YNode(value, x$2, x$4, x$5, x$3)
});
$c_Lorg_yaml_model_YNode$.prototype.apply__T__Lorg_yaml_model_YNode = (function(text) {
  return $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YScalar$().apply__O__T__Lorg_yaml_model_YScalar(text, ""), $m_Lorg_yaml_model_YType$().Str$1)
});
$c_Lorg_yaml_model_YNode$.prototype.apply__J__Lorg_yaml_model_YNode = (function($long) {
  return $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YScalar$().apply__O__T__Lorg_yaml_model_YScalar($long, ""), $m_Lorg_yaml_model_YType$().Int$1)
});
$c_Lorg_yaml_model_YNode$.prototype.include__T__T__Lorg_yaml_model_YNode$MutRef = (function(uri, sourceName) {
  var v = $m_Lorg_yaml_model_YScalar$().apply__O__T__Lorg_yaml_model_YScalar(uri, sourceName);
  var this$1 = $m_Lorg_yaml_model_YType$().Include$1;
  var t = this$1.org$yaml$model$YType$$tag$und$1;
  return new $c_Lorg_yaml_model_YNode$MutRef().init___Lorg_yaml_model_YValue__Lorg_yaml_model_YTag__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(v, t, $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName), $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray($makeNativeArrayWrapper($d_Lorg_yaml_model_YPart.getArrayOf(), [t, v])))
});
$c_Lorg_yaml_model_YNode$.prototype.apply__Z__Lorg_yaml_model_YNode = (function(bool) {
  return $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YScalar$().apply__O__T__Lorg_yaml_model_YScalar(bool, ""), $m_Lorg_yaml_model_YType$().Bool$1)
});
$c_Lorg_yaml_model_YNode$.prototype.apply__T__T__Lorg_yaml_model_YNode = (function(text, sourceName) {
  return $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YScalar$().apply__O__T__Lorg_yaml_model_YScalar(text, sourceName), $m_Lorg_yaml_model_YType$().Str$1)
});
$c_Lorg_yaml_model_YNode$.prototype.apply__D__Lorg_yaml_model_YNode = (function($double) {
  return $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YScalar$().apply__O__T__Lorg_yaml_model_YScalar($double, ""), $m_Lorg_yaml_model_YType$().Float$1)
});
var $d_Lorg_yaml_model_YNode$ = new $TypeData().initClass({
  Lorg_yaml_model_YNode$: 0
}, false, "org.yaml.model.YNode$", {
  Lorg_yaml_model_YNode$: 1,
  O: 1
});
$c_Lorg_yaml_model_YNode$.prototype.$classData = $d_Lorg_yaml_model_YNode$;
var $n_Lorg_yaml_model_YNode$ = (void 0);
function $m_Lorg_yaml_model_YNode$() {
  if ((!$n_Lorg_yaml_model_YNode$)) {
    $n_Lorg_yaml_model_YNode$ = new $c_Lorg_yaml_model_YNode$().init___()
  };
  return $n_Lorg_yaml_model_YNode$
}
function $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either($thiz, evidence$2) {
  return evidence$2.read__Lorg_yaml_model_YNode__s_util_Either($thiz.thisNode__Lorg_yaml_model_YNode())
}
function $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O($thiz, conversion, iv) {
  var x1 = $thiz.to__Lorg_yaml_convert_YRead__s_util_Either(conversion);
  if ((x1 instanceof $c_s_util_Right)) {
    var x2 = $as_s_util_Right(x1);
    var value = x2.value$2;
    return value
  } else if ((x1 instanceof $c_s_util_Left)) {
    var x3 = $as_s_util_Left(x1);
    var err = $as_Lorg_yaml_model_YError(x3.value$2);
    return iv.handle__Lorg_yaml_model_YError__O__O(err, conversion.defaultValue__O())
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
}
function $f_Lorg_yaml_model_YNodeLike__asOption__Lorg_yaml_convert_YRead__s_Option($thiz, evidence$1) {
  return $thiz.to__Lorg_yaml_convert_YRead__s_util_Either(evidence$1).toOption__s_Option()
}
function $is_Lorg_yaml_model_YNodeLike(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lorg_yaml_model_YNodeLike)))
}
function $as_Lorg_yaml_model_YNodeLike(obj) {
  return (($is_Lorg_yaml_model_YNodeLike(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YNodeLike"))
}
function $isArrayOf_Lorg_yaml_model_YNodeLike(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YNodeLike)))
}
function $asArrayOf_Lorg_yaml_model_YNodeLike(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YNodeLike(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YNodeLike;", depth))
}
/** @constructor */
function $c_Lorg_yaml_model_YNonContent$() {
  $c_O.call(this)
}
$c_Lorg_yaml_model_YNonContent$.prototype = new $h_O();
$c_Lorg_yaml_model_YNonContent$.prototype.constructor = $c_Lorg_yaml_model_YNonContent$;
/** @constructor */
function $h_Lorg_yaml_model_YNonContent$() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YNonContent$.prototype = $c_Lorg_yaml_model_YNonContent$.prototype;
$c_Lorg_yaml_model_YNonContent$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_model_YNonContent$.prototype.apply__sc_IndexedSeq__Lorg_yaml_model_YNonContent = (function(tokens) {
  return new $c_Lorg_yaml_model_YNonContent().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($as_Lorg_mulesoft_lexer_AstToken(tokens.head__O()).range$1.to__Lorg_mulesoft_lexer_SourceLocation__Lorg_mulesoft_lexer_SourceLocation($as_Lorg_mulesoft_lexer_AstToken(tokens.last__O()).range$1), tokens)
});
var $d_Lorg_yaml_model_YNonContent$ = new $TypeData().initClass({
  Lorg_yaml_model_YNonContent$: 0
}, false, "org.yaml.model.YNonContent$", {
  Lorg_yaml_model_YNonContent$: 1,
  O: 1
});
$c_Lorg_yaml_model_YNonContent$.prototype.$classData = $d_Lorg_yaml_model_YNonContent$;
var $n_Lorg_yaml_model_YNonContent$ = (void 0);
function $m_Lorg_yaml_model_YNonContent$() {
  if ((!$n_Lorg_yaml_model_YNonContent$)) {
    $n_Lorg_yaml_model_YNonContent$ = new $c_Lorg_yaml_model_YNonContent$().init___()
  };
  return $n_Lorg_yaml_model_YNonContent$
}
/** @constructor */
function $c_Lorg_yaml_model_YPart() {
  $c_O.call(this);
  this.children$1 = null;
  this.location$1 = null
}
$c_Lorg_yaml_model_YPart.prototype = new $h_O();
$c_Lorg_yaml_model_YPart.prototype.constructor = $c_Lorg_yaml_model_YPart;
/** @constructor */
function $h_Lorg_yaml_model_YPart() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YPart.prototype = $c_Lorg_yaml_model_YPart.prototype;
$c_Lorg_yaml_model_YPart.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq = (function(_location, children) {
  this.children$1 = children;
  this.location$1 = $m_Lorg_yaml_model_YPart$().locationOf__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq__Lorg_mulesoft_lexer_SourceLocation(_location, children);
  return this
});
function $as_Lorg_yaml_model_YPart(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YPart) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YPart"))
}
function $isArrayOf_Lorg_yaml_model_YPart(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YPart)))
}
function $asArrayOf_Lorg_yaml_model_YPart(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YPart(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YPart;", depth))
}
var $d_Lorg_yaml_model_YPart = new $TypeData().initClass({
  Lorg_yaml_model_YPart: 0
}, false, "org.yaml.model.YPart", {
  Lorg_yaml_model_YPart: 1,
  O: 1
});
$c_Lorg_yaml_model_YPart.prototype.$classData = $d_Lorg_yaml_model_YPart;
/** @constructor */
function $c_Lorg_yaml_model_YPart$() {
  $c_O.call(this)
}
$c_Lorg_yaml_model_YPart$.prototype = new $h_O();
$c_Lorg_yaml_model_YPart$.prototype.constructor = $c_Lorg_yaml_model_YPart$;
/** @constructor */
function $h_Lorg_yaml_model_YPart$() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YPart$.prototype = $c_Lorg_yaml_model_YPart$.prototype;
$c_Lorg_yaml_model_YPart$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_model_YPart$.prototype.locationOf__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq__Lorg_mulesoft_lexer_SourceLocation = (function(location, parts) {
  if ((parts.isEmpty__Z() || (!location.isZero__Z()))) {
    return location
  } else {
    var x$2 = $m_Lorg_mulesoft_lexer_SourceLocation$().Unknown$1;
    if (((location === null) ? (x$2 === null) : location.equals__O__Z(x$2))) {
      return $as_Lorg_yaml_model_YPart(parts.head__O()).location$1.to__Lorg_mulesoft_lexer_SourceLocation__Lorg_mulesoft_lexer_SourceLocation($as_Lorg_yaml_model_YPart(parts.last__O()).location$1)
    } else {
      var jsx$3 = $m_Lorg_mulesoft_lexer_SourceLocation$();
      var jsx$2 = location.sourceName$1;
      var this$1 = $as_Lorg_yaml_model_YPart(parts.head__O()).location$1;
      var jsx$1 = $m_Lorg_mulesoft_lexer_Position$().apply__I__I__I__Lorg_mulesoft_lexer_Position(this$1.lineFrom$1, this$1.columnFrom$1, this$1.offsetFrom$1);
      var this$2 = $as_Lorg_yaml_model_YPart(parts.last__O()).location$1;
      return jsx$3.apply__T__Lorg_mulesoft_lexer_Position__Lorg_mulesoft_lexer_Position__Lorg_mulesoft_lexer_SourceLocation(jsx$2, jsx$1, $m_Lorg_mulesoft_lexer_Position$().apply__I__I__I__Lorg_mulesoft_lexer_Position(this$2.lineTo$1, this$2.columnTo$1, this$2.offsetTo$1))
    }
  }
});
var $d_Lorg_yaml_model_YPart$ = new $TypeData().initClass({
  Lorg_yaml_model_YPart$: 0
}, false, "org.yaml.model.YPart$", {
  Lorg_yaml_model_YPart$: 1,
  O: 1
});
$c_Lorg_yaml_model_YPart$.prototype.$classData = $d_Lorg_yaml_model_YPart$;
var $n_Lorg_yaml_model_YPart$ = (void 0);
function $m_Lorg_yaml_model_YPart$() {
  if ((!$n_Lorg_yaml_model_YPart$)) {
    $n_Lorg_yaml_model_YPart$ = new $c_Lorg_yaml_model_YPart$().init___()
  };
  return $n_Lorg_yaml_model_YPart$
}
/** @constructor */
function $c_Lorg_yaml_model_YScalar$() {
  $c_O.call(this);
  this.Null$1 = null
}
$c_Lorg_yaml_model_YScalar$.prototype = new $h_O();
$c_Lorg_yaml_model_YScalar$.prototype.constructor = $c_Lorg_yaml_model_YScalar$;
/** @constructor */
function $h_Lorg_yaml_model_YScalar$() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YScalar$.prototype = $c_Lorg_yaml_model_YScalar$.prototype;
$c_Lorg_yaml_model_YScalar$.prototype.init___ = (function() {
  $n_Lorg_yaml_model_YScalar$ = this;
  var x$3 = $m_Lorg_mulesoft_lexer_SourceLocation$().Unknown$1;
  $m_Lorg_yaml_model_YScalar$();
  var x$4 = $m_Lorg_yaml_model_NoMark$();
  $m_Lorg_yaml_model_YScalar$();
  $m_s_package$();
  $m_sci_IndexedSeq$();
  $m_sci_Vector$();
  var this$6 = new $c_sci_VectorBuilder().init___();
  var x$5 = this$6.result__sci_Vector();
  this.Null$1 = new $c_Lorg_yaml_model_YScalar().init___O__T__Lorg_yaml_model_ScalarMark__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(null, "null", x$4, x$3, x$5);
  return this
});
$c_Lorg_yaml_model_YScalar$.prototype.apply__O__T__Lorg_yaml_model_YScalar = (function(value, sourceName) {
  var x$2 = ("" + value);
  var x$3 = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  $m_Lorg_yaml_model_YScalar$();
  var x$4 = $m_Lorg_yaml_model_NoMark$();
  $m_Lorg_yaml_model_YScalar$();
  $m_s_package$();
  $m_sci_IndexedSeq$();
  $m_sci_Vector$();
  var this$7 = new $c_sci_VectorBuilder().init___();
  var x$5 = this$7.result__sci_Vector();
  return new $c_Lorg_yaml_model_YScalar().init___O__T__Lorg_yaml_model_ScalarMark__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(value, x$2, x$4, x$3, x$5)
});
$c_Lorg_yaml_model_YScalar$.prototype.withLocation__T__Lorg_yaml_model_YType__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_YScalar = (function(text, tag, loc) {
  var r = $m_Lorg_yaml_parser_ScalarParser$().parse__T__Lorg_yaml_model_ScalarMark__Lorg_yaml_model_YTag__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_ParserResult(text, $m_Lorg_yaml_model_NoMark$(), tag.org$yaml$model$YType$$tag$und$1, loc, $m_Lorg_yaml_model_ParseErrorHandler$().parseErrorHandler$1);
  var jsx$2 = r.value$1;
  var jsx$1 = $m_Lorg_yaml_model_NoMark$();
  $m_s_package$();
  $m_sci_IndexedSeq$();
  $m_sci_Vector$();
  var this$4 = new $c_sci_VectorBuilder().init___();
  return new $c_Lorg_yaml_model_YScalar().init___O__T__Lorg_yaml_model_ScalarMark__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(jsx$2, text, jsx$1, loc, this$4.result__sci_Vector())
});
$c_Lorg_yaml_model_YScalar$.prototype.apply__O__Lorg_yaml_model_YScalar = (function(value) {
  var x$2 = ("" + value);
  var x$3 = $m_Lorg_mulesoft_lexer_SourceLocation$().Unknown$1;
  $m_Lorg_yaml_model_YScalar$();
  var x$4 = $m_Lorg_yaml_model_NoMark$();
  $m_Lorg_yaml_model_YScalar$();
  $m_s_package$();
  $m_sci_IndexedSeq$();
  $m_sci_Vector$();
  var this$7 = new $c_sci_VectorBuilder().init___();
  var x$5 = this$7.result__sci_Vector();
  return new $c_Lorg_yaml_model_YScalar().init___O__T__Lorg_yaml_model_ScalarMark__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(value, x$2, x$4, x$3, x$5)
});
var $d_Lorg_yaml_model_YScalar$ = new $TypeData().initClass({
  Lorg_yaml_model_YScalar$: 0
}, false, "org.yaml.model.YScalar$", {
  Lorg_yaml_model_YScalar$: 1,
  O: 1
});
$c_Lorg_yaml_model_YScalar$.prototype.$classData = $d_Lorg_yaml_model_YScalar$;
var $n_Lorg_yaml_model_YScalar$ = (void 0);
function $m_Lorg_yaml_model_YScalar$() {
  if ((!$n_Lorg_yaml_model_YScalar$)) {
    $n_Lorg_yaml_model_YScalar$ = new $c_Lorg_yaml_model_YScalar$().init___()
  };
  return $n_Lorg_yaml_model_YScalar$
}
/** @constructor */
function $c_Lorg_yaml_model_YSequence$() {
  $c_O.call(this);
  this.empty$1 = null
}
$c_Lorg_yaml_model_YSequence$.prototype = new $h_O();
$c_Lorg_yaml_model_YSequence$.prototype.constructor = $c_Lorg_yaml_model_YSequence$;
/** @constructor */
function $h_Lorg_yaml_model_YSequence$() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YSequence$.prototype = $c_Lorg_yaml_model_YSequence$.prototype;
$c_Lorg_yaml_model_YSequence$.prototype.init___ = (function() {
  $n_Lorg_yaml_model_YSequence$ = this;
  var jsx$1 = $m_Lorg_mulesoft_lexer_SourceLocation$().Unknown$1;
  $m_s_package$();
  $m_sci_IndexedSeq$();
  $m_sci_Vector$();
  var this$4 = new $c_sci_VectorBuilder().init___();
  this.empty$1 = new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(jsx$1, this$4.result__sci_Vector());
  return this
});
var $d_Lorg_yaml_model_YSequence$ = new $TypeData().initClass({
  Lorg_yaml_model_YSequence$: 0
}, false, "org.yaml.model.YSequence$", {
  Lorg_yaml_model_YSequence$: 1,
  O: 1
});
$c_Lorg_yaml_model_YSequence$.prototype.$classData = $d_Lorg_yaml_model_YSequence$;
var $n_Lorg_yaml_model_YSequence$ = (void 0);
function $m_Lorg_yaml_model_YSequence$() {
  if ((!$n_Lorg_yaml_model_YSequence$)) {
    $n_Lorg_yaml_model_YSequence$ = new $c_Lorg_yaml_model_YSequence$().init___()
  };
  return $n_Lorg_yaml_model_YSequence$
}
/** @constructor */
function $c_Lorg_yaml_model_YTag$() {
  $c_O.call(this)
}
$c_Lorg_yaml_model_YTag$.prototype = new $h_O();
$c_Lorg_yaml_model_YTag$.prototype.constructor = $c_Lorg_yaml_model_YTag$;
/** @constructor */
function $h_Lorg_yaml_model_YTag$() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YTag$.prototype = $c_Lorg_yaml_model_YTag$.prototype;
$c_Lorg_yaml_model_YTag$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_model_YTag$.prototype.apply__T__Lorg_yaml_model_YType__Lorg_yaml_model_YTag = (function(tag, tagType) {
  var jsx$1 = $m_Lorg_mulesoft_lexer_SourceLocation$().Unknown$1;
  $m_s_package$();
  $m_sci_IndexedSeq$();
  $m_sci_Vector$();
  var this$4 = new $c_sci_VectorBuilder().init___();
  return new $c_Lorg_yaml_model_YTag().init___T__Lorg_yaml_model_YType__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(tag, tagType, jsx$1, this$4.result__sci_Vector())
});
$c_Lorg_yaml_model_YTag$.prototype.apply__T__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq__Lorg_yaml_model_YTag = (function(tag, loc, ts) {
  return new $c_Lorg_yaml_model_YTag().init___T__Lorg_yaml_model_YType__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(tag, $m_Lorg_yaml_model_YType$().apply__T__Lorg_yaml_model_YType(tag), loc, ts)
});
var $d_Lorg_yaml_model_YTag$ = new $TypeData().initClass({
  Lorg_yaml_model_YTag$: 0
}, false, "org.yaml.model.YTag$", {
  Lorg_yaml_model_YTag$: 1,
  O: 1
});
$c_Lorg_yaml_model_YTag$.prototype.$classData = $d_Lorg_yaml_model_YTag$;
var $n_Lorg_yaml_model_YTag$ = (void 0);
function $m_Lorg_yaml_model_YTag$() {
  if ((!$n_Lorg_yaml_model_YTag$)) {
    $n_Lorg_yaml_model_YTag$ = new $c_Lorg_yaml_model_YTag$().init___()
  };
  return $n_Lorg_yaml_model_YTag$
}
/** @constructor */
function $c_Lorg_yaml_model_YType() {
  $c_O.call(this);
  this.synthesized$1 = false;
  this.org$yaml$model$YType$$tag$und$1 = null
}
$c_Lorg_yaml_model_YType.prototype = new $h_O();
$c_Lorg_yaml_model_YType.prototype.constructor = $c_Lorg_yaml_model_YType;
/** @constructor */
function $h_Lorg_yaml_model_YType() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YType.prototype = $c_Lorg_yaml_model_YType.prototype;
$c_Lorg_yaml_model_YType.prototype.toString__T = (function() {
  return this.org$yaml$model$YType$$tag$und$1.text$3
});
$c_Lorg_yaml_model_YType.prototype.init___Z = (function(synthesized) {
  this.synthesized$1 = synthesized;
  return this
});
function $as_Lorg_yaml_model_YType(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YType) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YType"))
}
function $isArrayOf_Lorg_yaml_model_YType(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YType)))
}
function $asArrayOf_Lorg_yaml_model_YType(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YType(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YType;", depth))
}
var $d_Lorg_yaml_model_YType = new $TypeData().initClass({
  Lorg_yaml_model_YType: 0
}, false, "org.yaml.model.YType", {
  Lorg_yaml_model_YType: 1,
  O: 1
});
$c_Lorg_yaml_model_YType.prototype.$classData = $d_Lorg_yaml_model_YType;
/** @constructor */
function $c_Lorg_yaml_model_YType$() {
  $c_O.call(this);
  this.knownTypes$1 = null;
  this.Seq$1 = null;
  this.Map$1 = null;
  this.Str$1 = null;
  this.Float$1 = null;
  this.Int$1 = null;
  this.Bool$1 = null;
  this.Timestamp$1 = null;
  this.Null$1 = null;
  this.Unknown$1 = null;
  this.Empty$1 = null;
  this.Include$1 = null
}
$c_Lorg_yaml_model_YType$.prototype = new $h_O();
$c_Lorg_yaml_model_YType$.prototype.constructor = $c_Lorg_yaml_model_YType$;
/** @constructor */
function $h_Lorg_yaml_model_YType$() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YType$.prototype = $c_Lorg_yaml_model_YType$.prototype;
$c_Lorg_yaml_model_YType$.prototype.init___ = (function() {
  $n_Lorg_yaml_model_YType$ = this;
  this.knownTypes$1 = new $c_scm_HashMap().init___();
  this.Seq$1 = this.forName__p1__T__Z__Lorg_yaml_model_YType("!!seq", true);
  this.Map$1 = this.forName__p1__T__Z__Lorg_yaml_model_YType("!!map", true);
  this.Str$1 = this.forName__p1__T__Z__Lorg_yaml_model_YType("!!str", true);
  this.Float$1 = this.forName__p1__T__Z__Lorg_yaml_model_YType("!!float", true);
  this.Int$1 = this.forName__p1__T__Z__Lorg_yaml_model_YType("!!int", true);
  this.Bool$1 = this.forName__p1__T__Z__Lorg_yaml_model_YType("!!bool", true);
  this.Timestamp$1 = this.forName__p1__T__Z__Lorg_yaml_model_YType("!!timestamp", true);
  this.Null$1 = this.forName__p1__T__Z__Lorg_yaml_model_YType("!!null", true);
  this.Unknown$1 = this.forName__p1__T__Z__Lorg_yaml_model_YType("?", true);
  this.Empty$1 = this.forName__p1__T__Z__Lorg_yaml_model_YType("!", true);
  this.Include$1 = this.forName__p1__T__Z__Lorg_yaml_model_YType("!include", false);
  return this
});
$c_Lorg_yaml_model_YType$.prototype.apply__T__Lorg_yaml_model_YType = (function(tag) {
  var this$1 = this.knownTypes$1;
  var x1 = this$1.get__O__s_Option(tag);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var v = x2.value$2;
    var jsx$1 = v
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var jsx$1 = $m_Lorg_yaml_model_YType$().Unknown$1
  };
  return $as_Lorg_yaml_model_YType(jsx$1)
});
$c_Lorg_yaml_model_YType$.prototype.forName__p1__T__Z__Lorg_yaml_model_YType = (function(tagName, synthesized) {
  var t = new $c_Lorg_yaml_model_YType().init___Z(synthesized);
  t.org$yaml$model$YType$$tag$und$1 = $m_Lorg_yaml_model_YTag$().apply__T__Lorg_yaml_model_YType__Lorg_yaml_model_YTag(tagName, t);
  this.knownTypes$1.put__O__O__s_Option(tagName, t);
  return t
});
var $d_Lorg_yaml_model_YType$ = new $TypeData().initClass({
  Lorg_yaml_model_YType$: 0
}, false, "org.yaml.model.YType$", {
  Lorg_yaml_model_YType$: 1,
  O: 1
});
$c_Lorg_yaml_model_YType$.prototype.$classData = $d_Lorg_yaml_model_YType$;
var $n_Lorg_yaml_model_YType$ = (void 0);
function $m_Lorg_yaml_model_YType$() {
  if ((!$n_Lorg_yaml_model_YType$)) {
    $n_Lorg_yaml_model_YType$ = new $c_Lorg_yaml_model_YType$().init___()
  };
  return $n_Lorg_yaml_model_YType$
}
/** @constructor */
function $c_Lorg_yaml_parser_JsonParser$() {
  $c_O.call(this)
}
$c_Lorg_yaml_parser_JsonParser$.prototype = new $h_O();
$c_Lorg_yaml_parser_JsonParser$.prototype.constructor = $c_Lorg_yaml_parser_JsonParser$;
/** @constructor */
function $h_Lorg_yaml_parser_JsonParser$() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_JsonParser$.prototype = $c_Lorg_yaml_parser_JsonParser$.prototype;
$c_Lorg_yaml_parser_JsonParser$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_parser_JsonParser$.prototype.apply__jl_CharSequence__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_JsonParser = (function(s, eh) {
  return new $c_Lorg_yaml_parser_JsonParser().init___Lorg_yaml_lexer_JsonLexer__Lorg_yaml_model_ParseErrorHandler($m_Lorg_yaml_lexer_JsonLexer$().apply__jl_CharSequence__Lorg_yaml_lexer_JsonLexer(s), eh)
});
$c_Lorg_yaml_parser_JsonParser$.prototype.withSource__jl_CharSequence__T__Lorg_mulesoft_lexer_Position__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_JsonParser = (function(s, sourceName, positionOffset, eh) {
  return new $c_Lorg_yaml_parser_JsonParser().init___Lorg_yaml_lexer_JsonLexer__Lorg_yaml_model_ParseErrorHandler($m_Lorg_yaml_lexer_JsonLexer$().apply__jl_CharSequence__T__Lorg_mulesoft_lexer_Position__Lorg_yaml_lexer_JsonLexer(s, sourceName, positionOffset), eh)
});
var $d_Lorg_yaml_parser_JsonParser$ = new $TypeData().initClass({
  Lorg_yaml_parser_JsonParser$: 0
}, false, "org.yaml.parser.JsonParser$", {
  Lorg_yaml_parser_JsonParser$: 1,
  O: 1
});
$c_Lorg_yaml_parser_JsonParser$.prototype.$classData = $d_Lorg_yaml_parser_JsonParser$;
var $n_Lorg_yaml_parser_JsonParser$ = (void 0);
function $m_Lorg_yaml_parser_JsonParser$() {
  if ((!$n_Lorg_yaml_parser_JsonParser$)) {
    $n_Lorg_yaml_parser_JsonParser$ = new $c_Lorg_yaml_parser_JsonParser$().init___()
  };
  return $n_Lorg_yaml_parser_JsonParser$
}
/** @constructor */
function $c_Lorg_yaml_parser_JsonParser$JsonBuilder() {
  $c_O.call(this);
  this.first$1 = null;
  this.tokens$1 = null;
  this.parts$1 = null;
  this.value$1 = null;
  this.$$outer$1 = null
}
$c_Lorg_yaml_parser_JsonParser$JsonBuilder.prototype = new $h_O();
$c_Lorg_yaml_parser_JsonParser$JsonBuilder.prototype.constructor = $c_Lorg_yaml_parser_JsonParser$JsonBuilder;
/** @constructor */
function $h_Lorg_yaml_parser_JsonParser$JsonBuilder() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_JsonParser$JsonBuilder.prototype = $c_Lorg_yaml_parser_JsonParser$JsonBuilder.prototype;
$c_Lorg_yaml_parser_JsonParser$JsonBuilder.prototype.location__Lorg_mulesoft_lexer_SourceLocation = (function() {
  var jsx$1 = this.first$1;
  var this$1 = this.$$outer$1.lexer$1;
  return jsx$1.to__Lorg_mulesoft_lexer_SourceLocation__Lorg_mulesoft_lexer_SourceLocation(this$1.$$undtokenData$1.range$1)
});
$c_Lorg_yaml_parser_JsonParser$JsonBuilder.prototype.append__V = (function() {
  var this$1 = this.$$outer$1.lexer$1;
  var jsx$1 = this$1.$$undtokenData$1;
  var this$2 = this.$$outer$1.lexer$1;
  this.append__Lorg_mulesoft_lexer_TokenData__T__V(jsx$1, $objectToString(this$2.tokenText__Lorg_mulesoft_lexer_TokenData__jl_CharSequence(this$2.$$undtokenData$1)))
});
$c_Lorg_yaml_parser_JsonParser$JsonBuilder.prototype.buildTokens__Lorg_mulesoft_lexer_TokenData__sc_IndexedSeq = (function(td) {
  if ((td !== null)) {
    this.append__Lorg_mulesoft_lexer_TokenData__T__V(td, "")
  };
  var this$1 = this.tokens$1;
  if ($f_sc_IndexedSeqOptimized__isEmpty__Z(this$1)) {
    $m_s_package$();
    $m_sci_IndexedSeq$();
    $m_sci_Vector$();
    var this$5 = new $c_sci_VectorBuilder().init___();
    return this$5.result__sci_Vector()
  } else {
    var this$7 = this.tokens$1;
    var len = this$7.size0$6;
    var result = $newArrayObject($d_Lorg_mulesoft_lexer_AstToken.getArrayOf(), [len]);
    $f_sc_TraversableOnce__copyToArray__O__I__V(this$7, result, 0);
    var this$8 = this.tokens$1;
    $f_scm_ResizableArray__reduceToSize__I__V(this$8, 0);
    return $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray(result)
  }
});
$c_Lorg_yaml_parser_JsonParser$JsonBuilder.prototype.buildParts__ALorg_yaml_model_YPart = (function() {
  this.addNonContent__V();
  var this$1 = this.parts$1;
  if ($f_sc_IndexedSeqOptimized__isEmpty__Z(this$1)) {
    return $newArrayObject($d_Lorg_yaml_model_YPart.getArrayOf(), [0])
  } else {
    var this$5 = this.parts$1;
    var len = this$5.size0$6;
    var result = $newArrayObject($d_Lorg_yaml_model_YPart.getArrayOf(), [len]);
    $f_sc_TraversableOnce__copyToArray__O__I__V(this$5, result, 0);
    var this$6 = this.parts$1;
    $f_scm_ResizableArray__reduceToSize__I__V(this$6, 0);
    return result
  }
});
$c_Lorg_yaml_parser_JsonParser$JsonBuilder.prototype.init___Lorg_yaml_parser_JsonParser = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  var this$1 = $$outer.lexer$1;
  this.first$1 = this$1.$$undtokenData$1.range$1;
  this.tokens$1 = new $c_scm_ArrayBuffer().init___();
  this.parts$1 = new $c_scm_ArrayBuffer().init___();
  return this
});
$c_Lorg_yaml_parser_JsonParser$JsonBuilder.prototype.append__Lorg_mulesoft_lexer_TokenData__T__V = (function(td, text) {
  if (this.$$outer$1.org$yaml$parser$JsonParser$$keepTokens$1) {
    this.tokens$1.$$plus$eq__O__scm_ArrayBuffer(new $c_Lorg_mulesoft_lexer_AstToken().init___Lorg_mulesoft_lexer_Token__T__Lorg_mulesoft_lexer_SourceLocation(td.token$1, text, td.range$1))
  }
});
$c_Lorg_yaml_parser_JsonParser$JsonBuilder.prototype.addNonContent__V = (function() {
  var this$1 = this.tokens$1;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$1)) {
    var content = new $c_Lorg_yaml_model_YNonContent().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(this.location__Lorg_mulesoft_lexer_SourceLocation(), this.buildTokens__Lorg_mulesoft_lexer_TokenData__sc_IndexedSeq(null));
    this.parts$1.$$plus$eq__O__scm_ArrayBuffer(content)
  }
});
function $as_Lorg_yaml_parser_JsonParser$JsonBuilder(obj) {
  return (((obj instanceof $c_Lorg_yaml_parser_JsonParser$JsonBuilder) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.parser.JsonParser$JsonBuilder"))
}
function $isArrayOf_Lorg_yaml_parser_JsonParser$JsonBuilder(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_parser_JsonParser$JsonBuilder)))
}
function $asArrayOf_Lorg_yaml_parser_JsonParser$JsonBuilder(obj, depth) {
  return (($isArrayOf_Lorg_yaml_parser_JsonParser$JsonBuilder(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.parser.JsonParser$JsonBuilder;", depth))
}
var $d_Lorg_yaml_parser_JsonParser$JsonBuilder = new $TypeData().initClass({
  Lorg_yaml_parser_JsonParser$JsonBuilder: 0
}, false, "org.yaml.parser.JsonParser$JsonBuilder", {
  Lorg_yaml_parser_JsonParser$JsonBuilder: 1,
  O: 1
});
$c_Lorg_yaml_parser_JsonParser$JsonBuilder.prototype.$classData = $d_Lorg_yaml_parser_JsonParser$JsonBuilder;
/** @constructor */
function $c_Lorg_yaml_parser_ScalarParser() {
  $c_O.call(this);
  this.text$1 = null;
  this.yType$1 = null
}
$c_Lorg_yaml_parser_ScalarParser.prototype = new $h_O();
$c_Lorg_yaml_parser_ScalarParser.prototype.constructor = $c_Lorg_yaml_parser_ScalarParser;
/** @constructor */
function $h_Lorg_yaml_parser_ScalarParser() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_ScalarParser.prototype = $c_Lorg_yaml_parser_ScalarParser.prototype;
$c_Lorg_yaml_parser_ScalarParser.prototype.init___T__Lorg_yaml_model_YType = (function(text, yType) {
  this.text$1 = text;
  this.yType$1 = yType;
  return this
});
$c_Lorg_yaml_parser_ScalarParser.prototype.parse__s_util_Either = (function() {
  try {
    var x1 = this.text$1;
    if ((((x1 === "") || ((x1 === "null") || ((x1 === "Null") || ((x1 === "NULL") || (x1 === "~"))))) && this.typeIs__p1__Lorg_yaml_model_YType__Z($m_Lorg_yaml_model_YType$().Null$1))) {
      this.yType$1 = $m_Lorg_yaml_model_YType$().Null$1;
      $m_s_package$();
      return new $c_s_util_Right().init___O(null)
    };
    if ((((x1 === "true") || ((x1 === "True") || (x1 === "TRUE"))) && this.typeIs__p1__Lorg_yaml_model_YType__Z($m_Lorg_yaml_model_YType$().Bool$1))) {
      this.yType$1 = $m_Lorg_yaml_model_YType$().Bool$1;
      $m_s_package$();
      return new $c_s_util_Right().init___O(true)
    };
    if ((((x1 === "false") || ((x1 === "False") || (x1 === "FALSE"))) && this.typeIs__p1__Lorg_yaml_model_YType__Z($m_Lorg_yaml_model_YType$().Bool$1))) {
      this.yType$1 = $m_Lorg_yaml_model_YType$().Bool$1;
      $m_s_package$();
      return new $c_s_util_Right().init___O(false)
    };
    var o46 = $m_Lorg_yaml_parser_ScalarParser$().org$yaml$parser$ScalarParser$$intRegex$1.unapplySeq__jl_CharSequence__s_Option(x1);
    if ((!o46.isEmpty__Z())) {
      if ((o46.get__O() !== null)) {
        var this$4 = $as_sc_LinearSeqOptimized(o46.get__O());
        var jsx$2 = ($f_sc_LinearSeqOptimized__lengthCompare__I__I(this$4, 0) === 0)
      } else {
        var jsx$2 = false
      };
      if (jsx$2) {
        var jsx$1 = this.typeIs__p1__Lorg_yaml_model_YType__Z($m_Lorg_yaml_model_YType$().Int$1)
      } else {
        var jsx$1 = false
      }
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      this.yType$1 = $m_Lorg_yaml_model_YType$().Int$1;
      try {
        $m_s_package$();
        var x = this.text$1;
        var this$6 = new $c_sci_StringOps().init___T(x);
        var this$8 = $m_jl_Long$();
        var $$this = this$6.repr$1;
        var t = this$8.parseLong__T__I__J($$this, 10);
        var lo = t.lo$2;
        var hi = t.hi$2;
        return new $c_s_util_Right().init___O(new $c_sjsr_RuntimeLong().init___I__I(lo, hi))
      } catch (e) {
        var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
        if ((e$2 instanceof $c_jl_NumberFormatException)) {
          $m_s_package$();
          var this$10 = $m_s_package$().BigInt__s_math_BigInt$().apply__T__s_math_BigInt(this.text$1);
          var this$11 = this$10.bigInteger$3;
          var value = $m_jl_Double$().parseDouble__T__D($m_Ljava_math_Conversion$().toDecimalScaledString__Ljava_math_BigInteger__T(this$11));
          return new $c_s_util_Right().init___O(value)
        } else if ((e$2 instanceof $c_jl_Exception)) {
          var e$3 = $as_jl_Exception(e$2);
          $m_s_package$();
          var value$1 = new $c_Lorg_yaml_model_ParseException().init___Lorg_yaml_model_YType__T__jl_Exception(this.yType$1, this.text$1, e$3);
          return new $c_s_util_Left().init___O(value$1)
        } else {
          throw e
        }
      }
    };
    var o48 = $m_Lorg_yaml_parser_ScalarParser$().org$yaml$parser$ScalarParser$$hexRegex$1.unapplySeq__jl_CharSequence__s_Option(x1);
    if ((!o48.isEmpty__Z())) {
      if ((o48.get__O() !== null)) {
        var this$14 = $as_sc_LinearSeqOptimized(o48.get__O());
        var jsx$3 = ($f_sc_LinearSeqOptimized__lengthCompare__I__I(this$14, 1) === 0)
      } else {
        var jsx$3 = false
      }
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var s = $as_T($as_sc_LinearSeqOptimized(o48.get__O()).apply__I__O(0));
      if (this.typeIs__p1__Lorg_yaml_model_YType__Z($m_Lorg_yaml_model_YType$().Int$1)) {
        this.yType$1 = $m_Lorg_yaml_model_YType$().Int$1;
        $m_s_package$();
        var t$1 = $m_jl_Long$().parseLong__T__I__J(s, 16);
        var lo$1 = t$1.lo$2;
        var hi$1 = t$1.hi$2;
        return new $c_s_util_Right().init___O(new $c_sjsr_RuntimeLong().init___I__I(lo$1, hi$1))
      }
    };
    var o50 = $m_Lorg_yaml_parser_ScalarParser$().org$yaml$parser$ScalarParser$$octRegex$1.unapplySeq__jl_CharSequence__s_Option(x1);
    if ((!o50.isEmpty__Z())) {
      if ((o50.get__O() !== null)) {
        var this$16 = $as_sc_LinearSeqOptimized(o50.get__O());
        var jsx$4 = ($f_sc_LinearSeqOptimized__lengthCompare__I__I(this$16, 1) === 0)
      } else {
        var jsx$4 = false
      }
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      var s$2 = $as_T($as_sc_LinearSeqOptimized(o50.get__O()).apply__I__O(0));
      if (this.typeIs__p1__Lorg_yaml_model_YType__Z($m_Lorg_yaml_model_YType$().Int$1)) {
        this.yType$1 = $m_Lorg_yaml_model_YType$().Int$1;
        $m_s_package$();
        var t$2 = $m_jl_Long$().parseLong__T__I__J(s$2, 8);
        var lo$2 = t$2.lo$2;
        var hi$2 = t$2.hi$2;
        return new $c_s_util_Right().init___O(new $c_sjsr_RuntimeLong().init___I__I(lo$2, hi$2))
      }
    };
    var o52 = $m_Lorg_yaml_parser_ScalarParser$().org$yaml$parser$ScalarParser$$floatRegex$1.unapplySeq__jl_CharSequence__s_Option(x1);
    if ((!o52.isEmpty__Z())) {
      if ((o52.get__O() !== null)) {
        var this$18 = $as_sc_LinearSeqOptimized(o52.get__O());
        var jsx$6 = ($f_sc_LinearSeqOptimized__lengthCompare__I__I(this$18, 0) === 0)
      } else {
        var jsx$6 = false
      };
      if (jsx$6) {
        var jsx$5 = this.typeIs__p1__Lorg_yaml_model_YType__Z($m_Lorg_yaml_model_YType$().Float$1)
      } else {
        var jsx$5 = false
      }
    } else {
      var jsx$5 = false
    };
    if (jsx$5) {
      this.yType$1 = $m_Lorg_yaml_model_YType$().Float$1;
      $m_s_package$();
      var x$1 = this.text$1;
      var this$20 = new $c_sci_StringOps().init___T(x$1);
      var jsx$7 = $m_jl_Double$();
      var $$this$1 = this$20.repr$1;
      var value$2 = jsx$7.parseDouble__T__D($$this$1);
      return new $c_s_util_Right().init___O(value$2)
    };
    var o54 = $m_Lorg_yaml_parser_ScalarParser$().org$yaml$parser$ScalarParser$$infinity$1.unapplySeq__jl_CharSequence__s_Option(x1);
    if ((!o54.isEmpty__Z())) {
      if ((o54.get__O() !== null)) {
        var this$23 = $as_sc_LinearSeqOptimized(o54.get__O());
        var jsx$8 = ($f_sc_LinearSeqOptimized__lengthCompare__I__I(this$23, 1) === 0)
      } else {
        var jsx$8 = false
      }
    } else {
      var jsx$8 = false
    };
    if (jsx$8) {
      var s$3 = $as_T($as_sc_LinearSeqOptimized(o54.get__O()).apply__I__O(0));
      if (this.typeIs__p1__Lorg_yaml_model_YType__Z($m_Lorg_yaml_model_YType$().Float$1)) {
        this.yType$1 = $m_Lorg_yaml_model_YType$().Float$1;
        $m_s_package$();
        var value$3 = ((s$3 === "-") ? (-Infinity) : Infinity);
        return new $c_s_util_Right().init___O(value$3)
      }
    };
    if ((((x1 === ".nan") || ((x1 === ".NaN") || (x1 === ".NAN"))) && this.typeIs__p1__Lorg_yaml_model_YType__Z($m_Lorg_yaml_model_YType$().Float$1))) {
      this.yType$1 = $m_Lorg_yaml_model_YType$().Float$1;
      $m_s_package$();
      return new $c_s_util_Right().init___O((NaN))
    };
    var o62 = $m_Lorg_mulesoft_common_time_SimpleDateTime$().unapply__T__s_Option(x1);
    if ((!o62.isEmpty__Z())) {
      var dateTime = $as_Lorg_mulesoft_common_time_SimpleDateTime(o62.get__O());
      if (this.typeIs__p1__Lorg_yaml_model_YType__Z($m_Lorg_yaml_model_YType$().Timestamp$1)) {
        this.yType$1 = $m_Lorg_yaml_model_YType$().Timestamp$1;
        $m_s_package$();
        return new $c_s_util_Right().init___O(dateTime)
      }
    };
    var x$2 = this.yType$1;
    var x$2$1 = $m_Lorg_yaml_model_YType$().Unknown$1;
    if ((x$2 === x$2$1)) {
      this.yType$1 = $m_Lorg_yaml_model_YType$().Str$1;
      $m_s_package$();
      var value$4 = this.text$1;
      return new $c_s_util_Right().init___O(value$4)
    };
    var x$3 = this.yType$1;
    var x$4 = $m_Lorg_yaml_model_YType$().Null$1;
    if ((x$3 === x$4)) {
      var jsx$12 = true
    } else {
      var x$5 = this.yType$1;
      var x$6 = $m_Lorg_yaml_model_YType$().Bool$1;
      var jsx$12 = (x$5 === x$6)
    };
    if (jsx$12) {
      var jsx$11 = true
    } else {
      var x$7 = this.yType$1;
      var x$8 = $m_Lorg_yaml_model_YType$().Int$1;
      var jsx$11 = (x$7 === x$8)
    };
    if (jsx$11) {
      var jsx$10 = true
    } else {
      var x$9 = this.yType$1;
      var x$10 = $m_Lorg_yaml_model_YType$().Float$1;
      var jsx$10 = (x$9 === x$10)
    };
    if (jsx$10) {
      var jsx$9 = true
    } else {
      var x$11 = this.yType$1;
      var x$12 = $m_Lorg_yaml_model_YType$().Timestamp$1;
      var jsx$9 = (x$11 === x$12)
    };
    if (jsx$9) {
      $m_s_package$();
      var value$5 = new $c_Lorg_yaml_model_ParseException().init___Lorg_yaml_model_YType__T__jl_Exception(this.yType$1, this.text$1, null);
      return new $c_s_util_Left().init___O(value$5)
    };
    $m_s_package$();
    var value$6 = this.text$1;
    return new $c_s_util_Right().init___O(value$6)
  } catch (e$4) {
    var e$5 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e$4);
    if ((e$5 instanceof $c_jl_Exception)) {
      var e$6 = $as_jl_Exception(e$5);
      $m_s_package$();
      var value$7 = new $c_Lorg_yaml_model_ParseException().init___Lorg_yaml_model_YType__T__jl_Exception(this.yType$1, this.text$1, e$6);
      return new $c_s_util_Left().init___O(value$7)
    } else {
      throw e$4
    }
  }
});
$c_Lorg_yaml_parser_ScalarParser.prototype.typeIs__p1__Lorg_yaml_model_YType__Z = (function(t) {
  var x = this.yType$1;
  var x$2 = $m_Lorg_yaml_model_YType$().Unknown$1;
  if ((x === x$2)) {
    return true
  } else {
    var x$3 = this.yType$1;
    return (x$3 === t)
  }
});
var $d_Lorg_yaml_parser_ScalarParser = new $TypeData().initClass({
  Lorg_yaml_parser_ScalarParser: 0
}, false, "org.yaml.parser.ScalarParser", {
  Lorg_yaml_parser_ScalarParser: 1,
  O: 1
});
$c_Lorg_yaml_parser_ScalarParser.prototype.$classData = $d_Lorg_yaml_parser_ScalarParser;
/** @constructor */
function $c_Lorg_yaml_parser_ScalarParser$() {
  $c_O.call(this);
  this.org$yaml$parser$ScalarParser$$intRegex$1 = null;
  this.org$yaml$parser$ScalarParser$$octRegex$1 = null;
  this.org$yaml$parser$ScalarParser$$hexRegex$1 = null;
  this.org$yaml$parser$ScalarParser$$floatRegex$1 = null;
  this.org$yaml$parser$ScalarParser$$infinity$1 = null;
  this.NullTokens$1 = null;
  this.BoolTokens$1 = null
}
$c_Lorg_yaml_parser_ScalarParser$.prototype = new $h_O();
$c_Lorg_yaml_parser_ScalarParser$.prototype.constructor = $c_Lorg_yaml_parser_ScalarParser$;
/** @constructor */
function $h_Lorg_yaml_parser_ScalarParser$() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_ScalarParser$.prototype = $c_Lorg_yaml_parser_ScalarParser$.prototype;
$c_Lorg_yaml_parser_ScalarParser$.prototype.init___ = (function() {
  $n_Lorg_yaml_parser_ScalarParser$ = this;
  var this$2 = new $c_sci_StringOps().init___T("[-+]?\\d+");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.org$yaml$parser$ScalarParser$$intRegex$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  var this$5 = new $c_sci_StringOps().init___T("0o([0-7]+)");
  var groupNames$1 = $m_sci_Nil$();
  var $$this$1 = this$5.repr$1;
  this.org$yaml$parser$ScalarParser$$octRegex$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this$1, groupNames$1);
  var this$8 = new $c_sci_StringOps().init___T("0x([0-9a-fA-F]+)");
  var groupNames$2 = $m_sci_Nil$();
  var $$this$2 = this$8.repr$1;
  this.org$yaml$parser$ScalarParser$$hexRegex$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this$2, groupNames$2);
  var this$11 = new $c_sci_StringOps().init___T("-?(?:0|[1-9]\\d*)(?:\\.\\d*)?(?:[eE][-+]?\\d+)?");
  var groupNames$3 = $m_sci_Nil$();
  var $$this$3 = this$11.repr$1;
  this.org$yaml$parser$ScalarParser$$floatRegex$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this$3, groupNames$3);
  var this$14 = new $c_sci_StringOps().init___T("([-+])?(?:\\.inf|\\.Inf|\\.INF)");
  var groupNames$4 = $m_sci_Nil$();
  var $$this$4 = this$14.repr$1;
  this.org$yaml$parser$ScalarParser$$infinity$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this$4, groupNames$4);
  var array = ["", "null", "Null", "NULL", "~"];
  if (($uI(array.length) === 0)) {
    var jsx$1 = $m_sci_Set$EmptySet$()
  } else {
    var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      b.$$plus$eq__O__scm_SetBuilder(arg1);
      i = ((1 + i) | 0)
    };
    var jsx$1 = b.elems$1
  };
  this.NullTokens$1 = $as_sci_Set(jsx$1);
  var array$1 = ["true", "True", "TRUE", "false", "False", "FALSE"];
  if (($uI(array$1.length) === 0)) {
    var jsx$2 = $m_sci_Set$EmptySet$()
  } else {
    var b$1 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$1 = 0;
    var len$1 = $uI(array$1.length);
    while ((i$1 < len$1)) {
      var index$1 = i$1;
      var arg1$1 = array$1[index$1];
      b$1.$$plus$eq__O__scm_SetBuilder(arg1$1);
      i$1 = ((1 + i$1) | 0)
    };
    var jsx$2 = b$1.elems$1
  };
  this.BoolTokens$1 = $as_sci_Set(jsx$2);
  return this
});
$c_Lorg_yaml_parser_ScalarParser$.prototype.parseInt__p1__T__O = (function(text) {
  try {
    var this$1 = $m_jl_Long$();
    return this$1.parseLong__T__I__J(text, 10)
  } catch (e) {
    if ((e instanceof $c_jl_NumberFormatException)) {
      var this$3 = new $c_sci_StringOps().init___T(text);
      var jsx$1 = $m_jl_Double$();
      var $$this = this$3.repr$1;
      return jsx$1.parseDouble__T__D($$this)
    } else {
      throw e
    }
  }
});
$c_Lorg_yaml_parser_ScalarParser$.prototype.guessType__p1__T__Lorg_yaml_parser_ParserResult = (function(text) {
  var l = $uI(text.length);
  if ((l === 0)) {
    return $m_Lorg_yaml_parser_ParserResult$().Null$1
  } else {
    var c = (65535 & $uI(text.charCodeAt(0)));
    switch (c) {
      case 110:
      case 78:
      case 126: {
        if (this.NullTokens$1.contains__O__Z(text)) {
          return $m_Lorg_yaml_parser_ParserResult$().Null$1
        } else {
          $m_Lorg_yaml_parser_ParserResult$();
          $m_Lorg_yaml_parser_ParserResult$();
          var tagType = $m_Lorg_yaml_model_YType$().Str$1;
          return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tagType.org$yaml$model$YType$$tag$und$1, text)
        };
        break
      }
      case 116:
      case 84:
      case 102:
      case 70: {
        if (this.BoolTokens$1.contains__O__Z(text)) {
          $m_Lorg_yaml_parser_ParserResult$();
          var this$8 = new $c_sci_StringOps().init___T(text);
          var $$this = this$8.repr$1;
          var value = $f_sci_StringLike__parseBoolean__psci_StringLike__T__Z(this$8, $$this);
          $m_Lorg_yaml_parser_ParserResult$();
          var tagType$1 = $m_Lorg_yaml_model_YType$().Bool$1;
          return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tagType$1.org$yaml$model$YType$$tag$und$1, value)
        } else {
          $m_Lorg_yaml_parser_ParserResult$();
          $m_Lorg_yaml_parser_ParserResult$();
          var tagType$2 = $m_Lorg_yaml_model_YType$().Str$1;
          return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tagType$2.org$yaml$model$YType$$tag$und$1, text)
        };
        break
      }
      case 46: {
        if (($as_T(text.toLowerCase()) === $as_T(".nan".toLowerCase()))) {
          $m_Lorg_yaml_parser_ParserResult$();
          $m_Lorg_yaml_parser_ParserResult$();
          var tagType$3 = $m_Lorg_yaml_model_YType$().Float$1;
          return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tagType$3.org$yaml$model$YType$$tag$und$1, (NaN))
        } else if (($as_T(text.toLowerCase()) === $as_T(".inf".toLowerCase()))) {
          $m_Lorg_yaml_parser_ParserResult$();
          $m_Lorg_yaml_parser_ParserResult$();
          var tagType$4 = $m_Lorg_yaml_model_YType$().Float$1;
          return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tagType$4.org$yaml$model$YType$$tag$und$1, Infinity)
        } else {
          $m_Lorg_yaml_parser_ParserResult$();
          $m_Lorg_yaml_parser_ParserResult$();
          var tagType$5 = $m_Lorg_yaml_model_YType$().Str$1;
          return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tagType$5.org$yaml$model$YType$$tag$und$1, text)
        };
        break
      }
      case 45: {
        if (($as_T(text.toLowerCase()) === $as_T("-.inf".toLowerCase()))) {
          $m_Lorg_yaml_parser_ParserResult$();
          $m_Lorg_yaml_parser_ParserResult$();
          var tagType$6 = $m_Lorg_yaml_model_YType$().Float$1;
          return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tagType$6.org$yaml$model$YType$$tag$und$1, (-Infinity))
        } else {
          return this.guessNumber__p1__T__Z__Lorg_yaml_parser_ParserResult(text, false)
        };
        break
      }
      case 43: {
        if (($as_T(text.toLowerCase()) === $as_T("+.inf".toLowerCase()))) {
          $m_Lorg_yaml_parser_ParserResult$();
          $m_Lorg_yaml_parser_ParserResult$();
          var tagType$7 = $m_Lorg_yaml_model_YType$().Float$1;
          return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tagType$7.org$yaml$model$YType$$tag$und$1, Infinity)
        } else {
          return this.guessNumber__p1__T__Z__Lorg_yaml_parser_ParserResult(text, false)
        };
        break
      }
      case 48: {
        if ((l === 1)) {
          $m_Lorg_yaml_parser_ParserResult$();
          $m_Lorg_yaml_parser_ParserResult$();
          var tagType$8 = $m_Lorg_yaml_model_YType$().Int$1;
          return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tagType$8.org$yaml$model$YType$$tag$und$1, $m_sjsr_RuntimeLong$().Zero__sjsr_RuntimeLong())
        } else {
          return (((65535 & $uI(text.charCodeAt(1))) === 111) ? this.parseFromBase__p1__T__I__Lorg_yaml_parser_ParserResult(text, 8) : (((65535 & $uI(text.charCodeAt(1))) === 120) ? this.parseFromBase__p1__T__I__Lorg_yaml_parser_ParserResult(text, 16) : this.guessNumber__p1__T__Z__Lorg_yaml_parser_ParserResult(text, true)))
        };
        break
      }
      case 49:
      case 50:
      case 51:
      case 52:
      case 53:
      case 54:
      case 55:
      case 56:
      case 57: {
        return this.guessNumber__p1__T__Z__Lorg_yaml_parser_ParserResult(text, true);
        break
      }
      default: {
        $m_Lorg_yaml_parser_ParserResult$();
        $m_Lorg_yaml_parser_ParserResult$();
        var tagType$9 = $m_Lorg_yaml_model_YType$().Str$1;
        return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tagType$9.org$yaml$model$YType$$tag$und$1, text)
      }
    }
  }
});
$c_Lorg_yaml_parser_ScalarParser$.prototype.guessNumber__p1__T__Z__Lorg_yaml_parser_ParserResult = (function(text, tryDateTime) {
  var o8 = this.org$yaml$parser$ScalarParser$$intRegex$1.unapplySeq__jl_CharSequence__s_Option(text);
  if ((!o8.isEmpty__Z())) {
    if ((o8.get__O() !== null)) {
      var this$1 = $as_sc_LinearSeqOptimized(o8.get__O());
      var jsx$1 = ($f_sc_LinearSeqOptimized__lengthCompare__I__I(this$1, 0) === 0)
    } else {
      var jsx$1 = false
    }
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    $m_Lorg_yaml_parser_ParserResult$();
    var tagType = $m_Lorg_yaml_model_YType$().Int$1;
    var value = this.parseInt__p1__T__O(text);
    return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tagType.org$yaml$model$YType$$tag$und$1, value)
  };
  var o10 = this.org$yaml$parser$ScalarParser$$floatRegex$1.unapplySeq__jl_CharSequence__s_Option(text);
  if ((!o10.isEmpty__Z())) {
    if ((o10.get__O() !== null)) {
      var this$3 = $as_sc_LinearSeqOptimized(o10.get__O());
      var jsx$2 = ($f_sc_LinearSeqOptimized__lengthCompare__I__I(this$3, 0) === 0)
    } else {
      var jsx$2 = false
    }
  } else {
    var jsx$2 = false
  };
  if (jsx$2) {
    $m_Lorg_yaml_parser_ParserResult$();
    var this$5 = new $c_sci_StringOps().init___T(text);
    var jsx$3 = $m_jl_Double$();
    var $$this = this$5.repr$1;
    var value$1 = jsx$3.parseDouble__T__D($$this);
    $m_Lorg_yaml_parser_ParserResult$();
    var tagType$1 = $m_Lorg_yaml_model_YType$().Float$1;
    return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tagType$1.org$yaml$model$YType$$tag$und$1, value$1)
  };
  if (tryDateTime) {
    var x1$2 = $m_Lorg_mulesoft_common_time_SimpleDateTime$().parse__T__s_util_Either(text);
    if ((x1$2 instanceof $c_s_util_Right)) {
      var x2 = $as_s_util_Right(x1$2);
      var dt = $as_Lorg_mulesoft_common_time_SimpleDateTime(x2.value$2);
      $m_Lorg_yaml_parser_ParserResult$();
      $m_Lorg_yaml_parser_ParserResult$();
      var tagType$2 = $m_Lorg_yaml_model_YType$().Timestamp$1;
      return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tagType$2.org$yaml$model$YType$$tag$und$1, dt)
    } else {
      $m_Lorg_yaml_parser_ParserResult$();
      $m_Lorg_yaml_parser_ParserResult$();
      var tagType$3 = $m_Lorg_yaml_model_YType$().Str$1;
      return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tagType$3.org$yaml$model$YType$$tag$und$1, text)
    }
  } else {
    $m_Lorg_yaml_parser_ParserResult$();
    $m_Lorg_yaml_parser_ParserResult$();
    var tagType$4 = $m_Lorg_yaml_model_YType$().Str$1;
    return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tagType$4.org$yaml$model$YType$$tag$und$1, text)
  }
});
$c_Lorg_yaml_parser_ScalarParser$.prototype.parse__T__Lorg_yaml_model_ScalarMark__Lorg_yaml_model_YTag__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_ParserResult = (function(text, scalarMark, tag, loc, eh) {
  try {
    if ((tag === null)) {
      return this.guessType__p1__T__Lorg_yaml_model_ScalarMark__Lorg_yaml_parser_ParserResult(text, scalarMark)
    } else if (tag.isUnknown__Z()) {
      var pr = this.guessType__p1__T__Lorg_yaml_model_ScalarMark__Lorg_yaml_parser_ParserResult(text, scalarMark);
      return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tag.withTag__Lorg_yaml_model_YType__Lorg_yaml_model_YTag(pr.tag$1.tagType$3), pr.value$1)
    } else {
      return (tag.isEmpty__Z() ? new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tag.withTag__Lorg_yaml_model_YType__Lorg_yaml_model_YTag($m_Lorg_yaml_model_YType$().Str$1), text) : this.parseForType__p1__Lorg_yaml_model_YTag__T__Lorg_yaml_parser_ParserResult(tag, text))
    }
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 instanceof $c_Lorg_yaml_model_ParseException)) {
      var pe = $as_Lorg_yaml_model_ParseException(e$2);
      eh.handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V(loc, pe);
      $m_Lorg_yaml_parser_ParserResult$();
      $m_Lorg_yaml_parser_ParserResult$();
      var tagType = $m_Lorg_yaml_model_YType$().Str$1;
      return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tagType.org$yaml$model$YType$$tag$und$1, text)
    } else if ((e$2 instanceof $c_jl_Exception)) {
      var e$3 = $as_jl_Exception(e$2);
      eh.handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V(loc, new $c_Lorg_yaml_model_ParseException().init___Lorg_yaml_model_YType__T__jl_Exception(tag.tagType$3, text, e$3));
      $m_Lorg_yaml_parser_ParserResult$();
      $m_Lorg_yaml_parser_ParserResult$();
      var tagType$1 = $m_Lorg_yaml_model_YType$().Str$1;
      return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tagType$1.org$yaml$model$YType$$tag$und$1, text)
    } else {
      throw e
    }
  }
});
$c_Lorg_yaml_parser_ScalarParser$.prototype.guessType__p1__T__Lorg_yaml_model_ScalarMark__Lorg_yaml_parser_ParserResult = (function(text, scalarMark) {
  var x = $m_Lorg_yaml_model_NoMark$();
  if ((x === scalarMark)) {
    return this.guessType__p1__T__Lorg_yaml_parser_ParserResult(text)
  } else {
    var x$3 = $m_Lorg_yaml_model_SingleQuoteMark$();
    if ((x$3 === scalarMark)) {
      var this$1 = $m_Lorg_yaml_model_YType$().Str$1;
      return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(this$1.org$yaml$model$YType$$tag$und$1, $as_T(text.split("''").join("'")))
    } else {
      var this$4 = $m_Lorg_yaml_model_YType$().Str$1;
      return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(this$4.org$yaml$model$YType$$tag$und$1, text)
    }
  }
});
$c_Lorg_yaml_parser_ScalarParser$.prototype.parseForType__p1__Lorg_yaml_model_YTag__T__Lorg_yaml_parser_ParserResult = (function(tag, text) {
  var x1 = tag.tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Bool$1;
  if ((x === x1)) {
    var this$2 = new $c_sci_StringOps().init___T(text);
    var $$this = this$2.repr$1;
    var jsx$1 = $f_sci_StringLike__parseBoolean__psci_StringLike__T__Z(this$2, $$this)
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Null$1;
    if (((x$3 === x1) && this.NullTokens$1.contains__O__Z(text))) {
      var jsx$1 = null
    } else {
      var x$5 = $m_Lorg_yaml_model_YType$().Float$1;
      if ((x$5 === x1)) {
        var this$5 = new $c_sci_StringOps().init___T(text);
        var jsx$2 = $m_jl_Double$();
        var $$this$1 = this$5.repr$1;
        var jsx$1 = jsx$2.parseDouble__T__D($$this$1)
      } else {
        var x$7 = $m_Lorg_yaml_model_YType$().Timestamp$1;
        if ((x$7 === x1)) {
          var jsx$1 = this.parseDateTime__p1__T__Lorg_mulesoft_common_time_SimpleDateTime(text)
        } else {
          var x$9 = $m_Lorg_yaml_model_YType$().Str$1;
          if ((x$9 === x1)) {
            var jsx$1 = text
          } else {
            var x$11 = $m_Lorg_yaml_model_YType$().Int$1;
            if ((x$11 === x1)) {
              var jsx$1 = ((($uI(text.length) >= 0) && ($as_T(text.substring(0, $uI("0o".length))) === "0o")) ? $m_jl_Long$().parseLong__T__I__J(text, 8) : ((($uI(text.length) >= 0) && ($as_T(text.substring(0, $uI("0x".length))) === "0x")) ? $m_jl_Long$().parseLong__T__I__J(text, 16) : this.parseInt__p1__T__O(text)))
            } else {
              var jsx$1 = text
            }
          }
        }
      }
    }
  };
  return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tag, jsx$1)
});
$c_Lorg_yaml_parser_ScalarParser$.prototype.parseFromBase__p1__T__I__Lorg_yaml_parser_ParserResult = (function(text, base) {
  try {
    $m_Lorg_yaml_parser_ParserResult$();
    var t = $m_jl_Long$().parseLong__T__I__J($as_T(text.substring(2)), base);
    var lo = t.lo$2;
    var hi = t.hi$2;
    $m_Lorg_yaml_parser_ParserResult$();
    var tagType = $m_Lorg_yaml_model_YType$().Int$1;
    return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tagType.org$yaml$model$YType$$tag$und$1, new $c_sjsr_RuntimeLong().init___I__I(lo, hi))
  } catch (e) {
    if ((e instanceof $c_jl_NumberFormatException)) {
      $m_Lorg_yaml_parser_ParserResult$();
      $m_Lorg_yaml_parser_ParserResult$();
      var tagType$1 = $m_Lorg_yaml_model_YType$().Str$1;
      return new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(tagType$1.org$yaml$model$YType$$tag$und$1, text)
    } else {
      throw e
    }
  }
});
$c_Lorg_yaml_parser_ScalarParser$.prototype.parseDateTime__p1__T__Lorg_mulesoft_common_time_SimpleDateTime = (function(text) {
  var x1 = $m_Lorg_mulesoft_common_time_SimpleDateTime$().parse__T__s_util_Either(text);
  if ((x1 instanceof $c_s_util_Right)) {
    var x2 = $as_s_util_Right(x1);
    var dt = $as_Lorg_mulesoft_common_time_SimpleDateTime(x2.value$2);
    return dt
  } else if ((x1 instanceof $c_s_util_Left)) {
    var x3 = $as_s_util_Left(x1);
    var e = $as_Lorg_mulesoft_common_parse_ParseError(x3.value$2);
    throw new $c_Lorg_mulesoft_common_parse_ParseException().init___Lorg_mulesoft_common_parse_ParseError(e)
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
var $d_Lorg_yaml_parser_ScalarParser$ = new $TypeData().initClass({
  Lorg_yaml_parser_ScalarParser$: 0
}, false, "org.yaml.parser.ScalarParser$", {
  Lorg_yaml_parser_ScalarParser$: 1,
  O: 1
});
$c_Lorg_yaml_parser_ScalarParser$.prototype.$classData = $d_Lorg_yaml_parser_ScalarParser$;
var $n_Lorg_yaml_parser_ScalarParser$ = (void 0);
function $m_Lorg_yaml_parser_ScalarParser$() {
  if ((!$n_Lorg_yaml_parser_ScalarParser$)) {
    $n_Lorg_yaml_parser_ScalarParser$ = new $c_Lorg_yaml_parser_ScalarParser$().init___()
  };
  return $n_Lorg_yaml_parser_ScalarParser$
}
/** @constructor */
function $c_Lorg_yaml_parser_YamlLoader() {
  $c_O.call(this);
  this.YamlBuilder$module$1 = null;
  this.lexer$1 = null;
  this.keepTokens$1 = false;
  this.includeTag$1 = null;
  this.eh$1 = null;
  this.org$yaml$parser$YamlLoader$$aliases$1 = null;
  this.stack$1 = null
}
$c_Lorg_yaml_parser_YamlLoader.prototype = new $h_O();
$c_Lorg_yaml_parser_YamlLoader.prototype.constructor = $c_Lorg_yaml_parser_YamlLoader;
/** @constructor */
function $h_Lorg_yaml_parser_YamlLoader() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_YamlLoader.prototype = $c_Lorg_yaml_parser_YamlLoader.prototype;
$c_Lorg_yaml_parser_YamlLoader.prototype.org$yaml$parser$YamlLoader$$YamlBuilder__Lorg_yaml_parser_YamlLoader$YamlBuilder$ = (function() {
  if ((this.YamlBuilder$module$1 === null)) {
    this.YamlBuilder$lzycompute$1__p1__V()
  };
  return this.YamlBuilder$module$1
});
$c_Lorg_yaml_parser_YamlLoader.prototype.push__p1__Lorg_yaml_parser_YamlLoader$YamlBuilder__V = (function(e) {
  var this$1 = this.stack$1;
  $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$1.list$1.head__O()).addNonContent__V();
  this.stack$1.push__Lorg_yaml_parser_YamlLoader$YamlBuilder__V(e)
});
$c_Lorg_yaml_parser_YamlLoader.prototype.parse__sc_IndexedSeq = (function() {
  this.stack$1.push__Lorg_yaml_parser_YamlLoader$YamlBuilder__V(new $c_Lorg_yaml_parser_YamlLoader$YamlBuilder().init___Lorg_yaml_parser_YamlLoader__Lorg_mulesoft_lexer_SourceLocation(this, this.org$yaml$parser$YamlLoader$$YamlBuilder__Lorg_yaml_parser_YamlLoader$YamlBuilder$().$$lessinit$greater$default$1__Lorg_mulesoft_lexer_SourceLocation()));
  while (true) {
    var this$1 = this.lexer$1;
    var x = this$1.$$undtokenData$1.token$1;
    var x$2 = $m_Lorg_yaml_lexer_YamlToken$().EndStream$1;
    if ((!(x === x$2))) {
      this.process__p1__V();
      this.lexer$1.advance__V()
    } else {
      break
    }
  };
  return $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray(this.stack$1.pop__Lorg_yaml_parser_YamlLoader$YamlBuilder().buildParts__ALorg_yaml_model_YPart())
});
$c_Lorg_yaml_parser_YamlLoader.prototype.org$yaml$parser$YamlLoader$$duplicates__ALorg_yaml_model_YPart__V = (function(parts) {
  var keys = $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var i = 0;
  var len = parts.u.length;
  while ((i < len)) {
    var index = i;
    var arg1 = parts.get(index);
    var part = $as_Lorg_yaml_model_YPart(arg1);
    if ((part instanceof $c_Lorg_yaml_model_YMapEntry)) {
      var x2 = $as_Lorg_yaml_model_YMapEntry(part);
      var x1$2 = x2.key$2.value__Lorg_yaml_model_YValue();
      if ((x1$2 instanceof $c_Lorg_yaml_model_YScalar)) {
        var x2$2 = $as_Lorg_yaml_model_YScalar(x1$2);
        var key = x2$2.text$3;
        if ((!keys.add__O__Z(key))) {
          this.eh$1.handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V(x2.key$2.location$1, new $c_Lorg_yaml_model_DuplicateKeyException().init___T__jl_Exception(key, null))
        }
      }
    };
    i = ((1 + i) | 0)
  }
});
$c_Lorg_yaml_parser_YamlLoader.prototype.init___Lorg_yaml_lexer_YamlLexer__Z__T__Lorg_yaml_model_ParseErrorHandler = (function(lexer, keepTokens, includeTag, eh) {
  this.lexer$1 = lexer;
  this.keepTokens$1 = keepTokens;
  this.includeTag$1 = includeTag;
  this.eh$1 = eh;
  this.org$yaml$parser$YamlLoader$$aliases$1 = new $c_scm_HashMap().init___();
  this.stack$1 = new $c_Lorg_yaml_parser_YamlLoader$Stack().init___Lorg_yaml_parser_YamlLoader(this);
  return this
});
$c_Lorg_yaml_parser_YamlLoader.prototype.YamlBuilder$lzycompute$1__p1__V = (function() {
  if ((this.YamlBuilder$module$1 === null)) {
    this.YamlBuilder$module$1 = new $c_Lorg_yaml_parser_YamlLoader$YamlBuilder$().init___Lorg_yaml_parser_YamlLoader(this)
  }
});
$c_Lorg_yaml_parser_YamlLoader.prototype.org$yaml$parser$YamlLoader$$pop__Lorg_yaml_model_YPart__V = (function(part) {
  this.stack$1.pop__Lorg_yaml_parser_YamlLoader$YamlBuilder();
  var this$1 = this.stack$1;
  $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$1.list$1.head__O()).parts$1.$$plus$eq__O__scm_ArrayBuffer(part)
});
$c_Lorg_yaml_parser_YamlLoader.prototype.process__p1__V = (function() {
  var this$1 = this.lexer$1;
  var x1 = $as_Lorg_yaml_lexer_YamlToken(this$1.$$undtokenData$1.token$1);
  var x = $m_Lorg_yaml_lexer_YamlToken$().BeginDocument$1;
  if ((x === x1)) {
    this.push__p1__Lorg_yaml_parser_YamlLoader$YamlBuilder__V(new $c_Lorg_yaml_parser_YamlLoader$DocBuilder().init___Lorg_yaml_parser_YamlLoader(this))
  } else {
    var x$3 = $m_Lorg_yaml_lexer_YamlToken$().BeginNode$1;
    if ((x$3 === x1)) {
      this.push__p1__Lorg_yaml_parser_YamlLoader$YamlBuilder__V(new $c_Lorg_yaml_parser_YamlLoader$NodeBuilder().init___Lorg_yaml_parser_YamlLoader(this))
    } else {
      var x$5 = $m_Lorg_yaml_lexer_YamlToken$().BeginScalar$1;
      if ((x$5 === x1)) {
        var this$2 = this.stack$1;
        this.push__p1__Lorg_yaml_parser_YamlLoader$YamlBuilder__V(new $c_Lorg_yaml_parser_YamlLoader$ScalarBuilder().init___Lorg_yaml_parser_YamlLoader__Lorg_yaml_model_YTag(this, $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$2.list$1.head__O()).tag$1))
      } else {
        var x$7 = $m_Lorg_yaml_lexer_YamlToken$().BeginSequence$1;
        if ((x$7 === x1)) {
          this.push__p1__Lorg_yaml_parser_YamlLoader$YamlBuilder__V(new $c_Lorg_yaml_parser_YamlLoader$SeqBuilder().init___Lorg_yaml_parser_YamlLoader(this))
        } else {
          var x$9 = $m_Lorg_yaml_lexer_YamlToken$().BeginPair$1;
          if ((x$9 === x1)) {
            this.push__p1__Lorg_yaml_parser_YamlLoader$YamlBuilder__V(new $c_Lorg_yaml_parser_YamlLoader$PairBuilder().init___Lorg_yaml_parser_YamlLoader(this))
          } else {
            var x$11 = $m_Lorg_yaml_lexer_YamlToken$().BeginMapping$1;
            if ((x$11 === x1)) {
              this.push__p1__Lorg_yaml_parser_YamlLoader$YamlBuilder__V(new $c_Lorg_yaml_parser_YamlLoader$MapBuilder().init___Lorg_yaml_parser_YamlLoader(this))
            } else {
              var x$13 = $m_Lorg_yaml_lexer_YamlToken$().BeginDirective$1;
              if ((x$13 === x1)) {
                this.push__p1__Lorg_yaml_parser_YamlLoader$YamlBuilder__V(new $c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder().init___Lorg_yaml_parser_YamlLoader(this))
              } else {
                var x$15 = $m_Lorg_yaml_lexer_YamlToken$().BeginComment$1;
                if ((x$15 === x1)) {
                  this.push__p1__Lorg_yaml_parser_YamlLoader$YamlBuilder__V(new $c_Lorg_yaml_parser_YamlLoader$CommentBuilder().init___Lorg_yaml_parser_YamlLoader(this))
                } else {
                  var x$17 = $m_Lorg_yaml_lexer_YamlToken$().BeginAlias$1;
                  if ((x$17 === x1)) {
                    this.push__p1__Lorg_yaml_parser_YamlLoader$YamlBuilder__V(new $c_Lorg_yaml_parser_YamlLoader$AliasBuilder().init___Lorg_yaml_parser_YamlLoader(this))
                  } else {
                    var x$19 = $m_Lorg_yaml_lexer_YamlToken$().BeginAnchor$1;
                    if ((x$19 === x1)) {
                      this.push__p1__Lorg_yaml_parser_YamlLoader$YamlBuilder__V(new $c_Lorg_yaml_parser_YamlLoader$AnchorBuilder().init___Lorg_yaml_parser_YamlLoader(this))
                    } else {
                      var x$21 = $m_Lorg_yaml_lexer_YamlToken$().BeginTag$1;
                      if ((x$21 === x1)) {
                        this.push__p1__Lorg_yaml_parser_YamlLoader$YamlBuilder__V(new $c_Lorg_yaml_parser_YamlLoader$TagBuilder().init___Lorg_yaml_parser_YamlLoader(this))
                      } else {
                        var x$23 = $m_Lorg_yaml_lexer_YamlToken$().EndScalar$1;
                        if ((x$23 === x1)) {
                          var jsx$1 = true
                        } else {
                          var x$25 = $m_Lorg_yaml_lexer_YamlToken$().EndDirective$1;
                          if ((x$25 === x1)) {
                            var jsx$1 = true
                          } else {
                            var x$27 = $m_Lorg_yaml_lexer_YamlToken$().EndMapping$1;
                            if ((x$27 === x1)) {
                              var jsx$1 = true
                            } else {
                              var x$29 = $m_Lorg_yaml_lexer_YamlToken$().EndSequence$1;
                              if ((x$29 === x1)) {
                                var jsx$1 = true
                              } else {
                                var x$31 = $m_Lorg_yaml_lexer_YamlToken$().EndDocument$1;
                                if ((x$31 === x1)) {
                                  var jsx$1 = true
                                } else {
                                  var x$33 = $m_Lorg_yaml_lexer_YamlToken$().EndNode$1;
                                  if ((x$33 === x1)) {
                                    var jsx$1 = true
                                  } else {
                                    var x$35 = $m_Lorg_yaml_lexer_YamlToken$().EndPair$1;
                                    if ((x$35 === x1)) {
                                      var jsx$1 = true
                                    } else {
                                      var x$37 = $m_Lorg_yaml_lexer_YamlToken$().EndComment$1;
                                      if ((x$37 === x1)) {
                                        var jsx$1 = true
                                      } else {
                                        var x$39 = $m_Lorg_yaml_lexer_YamlToken$().EndAlias$1;
                                        if ((x$39 === x1)) {
                                          var jsx$1 = true
                                        } else {
                                          var x$41 = $m_Lorg_yaml_lexer_YamlToken$().EndAnchor$1;
                                          if ((x$41 === x1)) {
                                            var jsx$1 = true
                                          } else {
                                            var x$43 = $m_Lorg_yaml_lexer_YamlToken$().EndTag$1;
                                            var jsx$1 = (x$43 === x1)
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        };
                        if (jsx$1) {
                          var this$3 = this.stack$1;
                          $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$3.list$1.head__O()).create__V();
                          return (void 0)
                        } else {
                          var x$45 = $m_Lorg_yaml_lexer_YamlToken$().Text$1;
                          if ((x$45 === x1)) {
                            var this$4 = this.stack$1;
                            var jsx$2 = $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$4.list$1.head__O());
                            var this$5 = this.lexer$1;
                            jsx$2.appendText__jl_CharSequence__V(this$5.tokenText__Lorg_mulesoft_lexer_TokenData__jl_CharSequence(this$5.$$undtokenData$1))
                          } else {
                            var x$47 = $m_Lorg_yaml_lexer_YamlToken$().LineFold$1;
                            if ((x$47 === x1)) {
                              var this$6 = this.stack$1;
                              $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$6.list$1.head__O()).appendText__jl_CharSequence__V(" ")
                            } else {
                              var x$49 = $m_Lorg_yaml_lexer_YamlToken$().LineFeed$1;
                              if ((x$49 === x1)) {
                                var this$7 = this.stack$1;
                                $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$7.list$1.head__O()).appendText__jl_CharSequence__V("\n")
                              } else {
                                var x$51 = $m_Lorg_yaml_lexer_YamlToken$().BeginEscape$1;
                                if ((x$51 === x1)) {
                                  var this$8 = this.stack$1;
                                  $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$8.list$1.head__O()).escaping$1 = true
                                } else {
                                  var x$53 = $m_Lorg_yaml_lexer_YamlToken$().BeginHandle$1;
                                  if ((x$53 === x1)) {
                                    var this$9 = this.stack$1;
                                    $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$9.list$1.head__O()).inHandle$1 = true
                                  } else {
                                    var x$55 = $m_Lorg_yaml_lexer_YamlToken$().EndHandle$1;
                                    if ((x$55 === x1)) {
                                      var this$10 = this.stack$1;
                                      $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$10.list$1.head__O()).inHandle$1 = false
                                    } else {
                                      var x$57 = $m_Lorg_yaml_lexer_YamlToken$().MetaText$1;
                                      if ((x$57 === x1)) {
                                        var this$11 = this.stack$1;
                                        $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$11.list$1.head__O()).appendMetaText__V()
                                      } else {
                                        var x$59 = $m_Lorg_yaml_lexer_YamlToken$().Indicator$1;
                                        if ((x$59 === x1)) {
                                          var this$12 = this.stack$1;
                                          $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$12.list$1.head__O()).processIndicator__V()
                                        } else {
                                          var x$61 = $m_Lorg_yaml_lexer_YamlToken$().EndEscape$1;
                                          if ((x$61 === x1)) {
                                            var this$13 = this.stack$1;
                                            $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$13.list$1.head__O()).endEscape__V()
                                          } else {
                                            var x$63 = $m_Lorg_yaml_lexer_YamlToken$().LineBreak$1;
                                            if ((x$63 === x1)) {
                                              var this$14 = this.stack$1;
                                              $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$14.list$1.head__O()).processLineBreak__V()
                                            } else {
                                              var x$65 = $m_Lorg_yaml_lexer_YamlToken$().WhiteSpace$1;
                                              if ((x$65 === x1)) {
                                                var this$15 = this.stack$1;
                                                $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$15.list$1.head__O()).processWhitSpace__V()
                                              } else {
                                                var x$67 = $m_Lorg_yaml_lexer_YamlToken$().Error$1;
                                                if ((x$67 === x1)) {
                                                  var jsx$4 = this.eh$1;
                                                  var this$16 = this.lexer$1;
                                                  var jsx$3 = this$16.$$undtokenData$1.range$1;
                                                  var this$17 = this.lexer$1;
                                                  jsx$4.handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V(jsx$3, new $c_Lorg_yaml_model_LexerException().init___T__jl_Exception($objectToString(this$17.tokenText__Lorg_mulesoft_lexer_TokenData__jl_CharSequence(this$17.$$undtokenData$1)), null))
                                                }
                                              }
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  };
  var this$18 = this.stack$1;
  $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$18.list$1.head__O()).addCurrentToken__V()
});
var $d_Lorg_yaml_parser_YamlLoader = new $TypeData().initClass({
  Lorg_yaml_parser_YamlLoader: 0
}, false, "org.yaml.parser.YamlLoader", {
  Lorg_yaml_parser_YamlLoader: 1,
  O: 1
});
$c_Lorg_yaml_parser_YamlLoader.prototype.$classData = $d_Lorg_yaml_parser_YamlLoader;
/** @constructor */
function $c_Lorg_yaml_parser_YamlLoader$Stack() {
  $c_O.call(this);
  this.list$1 = null;
  this.$$outer$1 = null
}
$c_Lorg_yaml_parser_YamlLoader$Stack.prototype = new $h_O();
$c_Lorg_yaml_parser_YamlLoader$Stack.prototype.constructor = $c_Lorg_yaml_parser_YamlLoader$Stack;
/** @constructor */
function $h_Lorg_yaml_parser_YamlLoader$Stack() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_YamlLoader$Stack.prototype = $c_Lorg_yaml_parser_YamlLoader$Stack.prototype;
$c_Lorg_yaml_parser_YamlLoader$Stack.prototype.push__Lorg_yaml_parser_YamlLoader$YamlBuilder__V = (function(e) {
  var this$1 = this.list$1;
  this.list$1 = new $c_sci_$colon$colon().init___O__sci_List(e, this$1)
});
$c_Lorg_yaml_parser_YamlLoader$Stack.prototype.init___Lorg_yaml_parser_YamlLoader = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  $m_sci_List$();
  var array = [new $c_Lorg_yaml_parser_YamlLoader$YamlBuilder().init___Lorg_yaml_parser_YamlLoader__Lorg_mulesoft_lexer_SourceLocation($$outer, $$outer.org$yaml$parser$YamlLoader$$YamlBuilder__Lorg_yaml_parser_YamlLoader$YamlBuilder$().$$lessinit$greater$default$1__Lorg_mulesoft_lexer_SourceLocation())];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  this.list$1 = result;
  return this
});
$c_Lorg_yaml_parser_YamlLoader$Stack.prototype.pop__Lorg_yaml_parser_YamlLoader$YamlBuilder = (function() {
  var r = $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this.list$1.head__O());
  this.list$1 = $as_sci_List(this.list$1.tail__O());
  return r
});
var $d_Lorg_yaml_parser_YamlLoader$Stack = new $TypeData().initClass({
  Lorg_yaml_parser_YamlLoader$Stack: 0
}, false, "org.yaml.parser.YamlLoader$Stack", {
  Lorg_yaml_parser_YamlLoader$Stack: 1,
  O: 1
});
$c_Lorg_yaml_parser_YamlLoader$Stack.prototype.$classData = $d_Lorg_yaml_parser_YamlLoader$Stack;
/** @constructor */
function $c_Lorg_yaml_parser_YamlLoader$YamlBuilder() {
  $c_O.call(this);
  this.first$1 = null;
  this.tokens$1 = null;
  this.parts$1 = null;
  this.metaTextBuilder$1 = null;
  this.escaping$1 = false;
  this.inHandle$1 = false;
  this.value$1 = null;
  this.anchor$1 = null;
  this.alias$1 = null;
  this.tag$1 = null;
  this.$$outer$1 = null
}
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype = new $h_O();
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.constructor = $c_Lorg_yaml_parser_YamlLoader$YamlBuilder;
/** @constructor */
function $h_Lorg_yaml_parser_YamlLoader$YamlBuilder() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype = $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype;
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.location__Lorg_mulesoft_lexer_SourceLocation = (function() {
  var jsx$1 = this.first$1;
  var this$1 = this.$$outer$1.lexer$1;
  return jsx$1.to__Lorg_mulesoft_lexer_SourceLocation__Lorg_mulesoft_lexer_SourceLocation(this$1.$$undtokenData$1.range$1)
});
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.appendText__jl_CharSequence__V = (function(txt) {
  /*<skip>*/
});
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.appendMetaText__V = (function() {
  var jsx$1 = this.metaTextBuilder$1;
  var this$1 = this.$$outer$1.lexer$1;
  jsx$1.append__O__scm_StringBuilder(this$1.tokenText__Lorg_mulesoft_lexer_TokenData__jl_CharSequence(this$1.$$undtokenData$1))
});
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.init___Lorg_yaml_parser_YamlLoader__Lorg_mulesoft_lexer_SourceLocation = (function($$outer, first) {
  this.first$1 = first;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.tokens$1 = new $c_scm_ArrayBuffer().init___();
  this.parts$1 = new $c_scm_ArrayBuffer().init___();
  this.metaTextBuilder$1 = new $c_scm_StringBuilder().init___();
  this.escaping$1 = false;
  this.inHandle$1 = false;
  this.anchor$1 = $m_s_None$();
  this.alias$1 = "";
  return this
});
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.buildParts__ALorg_yaml_model_YPart = (function() {
  this.addCurrentToken__V();
  this.addNonContent__V();
  var parts = this.parts$1;
  if ($f_sc_IndexedSeqOptimized__isEmpty__Z(parts)) {
    return $newArrayObject($d_Lorg_yaml_model_YPart.getArrayOf(), [0])
  } else {
    var len = parts.size0$6;
    var result = $newArrayObject($d_Lorg_yaml_model_YPart.getArrayOf(), [len]);
    $f_sc_TraversableOnce__copyToArray__O__I__V(parts, result, 0);
    $f_scm_ResizableArray__reduceToSize__I__V(parts, 0);
    return result
  }
});
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.setValue__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__V = (function(v, defaultType) {
  this.value$1 = v;
  if ((this.tag$1 === null)) {
    this.tag$1 = defaultType.org$yaml$model$YType$$tag$und$1
  } else {
    var x = this.tag$1.tagType$3;
    var x$2 = $m_Lorg_yaml_model_YType$().Empty$1;
    if ((x === x$2)) {
      this.tag$1 = this.tag$1.withTag__Lorg_yaml_model_YType__Lorg_yaml_model_YTag(defaultType)
    }
  }
});
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.buildTokens__sc_IndexedSeq = (function() {
  var jsx$2 = $m_s_Predef$();
  var parts = this.tokens$1;
  if ($f_sc_IndexedSeqOptimized__isEmpty__Z(parts)) {
    var jsx$1 = $newArrayObject($d_Lorg_mulesoft_lexer_AstToken.getArrayOf(), [0])
  } else {
    var len = parts.size0$6;
    var result = $newArrayObject($d_Lorg_mulesoft_lexer_AstToken.getArrayOf(), [len]);
    $f_sc_TraversableOnce__copyToArray__O__I__V(parts, result, 0);
    $f_scm_ResizableArray__reduceToSize__I__V(parts, 0);
    var jsx$1 = result
  };
  return jsx$2.wrapRefArray__AO__scm_WrappedArray(jsx$1)
});
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.addCurrentToken__V = (function() {
  var this$1 = this.$$outer$1.lexer$1;
  var td = this$1.$$undtokenData$1;
  if (this.$$outer$1.keepTokens$1) {
    var x = td.token$1;
    var x$2 = $m_Lorg_yaml_lexer_YamlToken$().EndStream$1;
    var jsx$1 = (!(x === x$2))
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var jsx$3 = this.tokens$1;
    var jsx$2 = td.token$1;
    var this$2 = this.$$outer$1.lexer$1;
    jsx$3.$$plus$eq__O__scm_ArrayBuffer(new $c_Lorg_mulesoft_lexer_AstToken().init___Lorg_mulesoft_lexer_Token__T__Lorg_mulesoft_lexer_SourceLocation(jsx$2, $objectToString(this$2.tokenText__Lorg_mulesoft_lexer_TokenData__jl_CharSequence(this$2.$$undtokenData$1)), td.range$1))
  }
});
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.endEscape__V = (function() {
  var jsx$1 = $m_Lorg_mulesoft_common_core_package$Strings$();
  var this$1 = this.metaTextBuilder$1;
  var str = this$1.underlying$5.java$lang$StringBuilder$$content$f;
  this.appendText__jl_CharSequence__V(jsx$1.decode$extension1__T__Z__T(str, true));
  var this$3 = this.metaTextBuilder$1;
  this$3.underlying$5.setLength__I__V(0);
  this.escaping$1 = false
});
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.processLineBreak__V = (function() {
  if (this.escaping$1) {
    var this$1 = this.$$outer$1;
    var this$2 = this$1.stack$1;
    var this$3 = $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$2.list$1.head__O()).metaTextBuilder$1;
    this$3.underlying$5.setLength__I__V(0)
  }
});
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.create__V = (function() {
  /*<skip>*/
});
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.addNonContent__V = (function() {
  var this$1 = this.tokens$1;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$1)) {
    var jsx$4 = this.parts$1;
    var jsx$3 = $m_Lorg_yaml_model_YNonContent$();
    var jsx$2 = $m_s_Predef$();
    var parts = this.tokens$1;
    if ($f_sc_IndexedSeqOptimized__isEmpty__Z(parts)) {
      var jsx$1 = $newArrayObject($d_Lorg_mulesoft_lexer_AstToken.getArrayOf(), [0])
    } else {
      var len = parts.size0$6;
      var result = $newArrayObject($d_Lorg_mulesoft_lexer_AstToken.getArrayOf(), [len]);
      $f_sc_TraversableOnce__copyToArray__O__I__V(parts, result, 0);
      $f_scm_ResizableArray__reduceToSize__I__V(parts, 0);
      var jsx$1 = result
    };
    jsx$4.$$plus$eq__O__scm_ArrayBuffer(jsx$3.apply__sc_IndexedSeq__Lorg_yaml_model_YNonContent(jsx$2.wrapRefArray__AO__scm_WrappedArray(jsx$1)))
  }
});
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.setValue__Lorg_yaml_model_YValue__Lorg_yaml_model_YTag__V = (function(v, t) {
  this.value$1 = v;
  this.tag$1 = t
});
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.processWhitSpace__V = (function() {
  /*<skip>*/
});
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.processIndicator__V = (function() {
  if ((this.escaping$1 || this.inHandle$1)) {
    var jsx$1 = this.metaTextBuilder$1;
    var this$1 = this.$$outer$1.lexer$1;
    jsx$1.append__O__scm_StringBuilder(this$1.tokenText__Lorg_mulesoft_lexer_TokenData__jl_CharSequence(this$1.$$undtokenData$1))
  }
});
function $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(obj) {
  return (((obj instanceof $c_Lorg_yaml_parser_YamlLoader$YamlBuilder) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.parser.YamlLoader$YamlBuilder"))
}
function $isArrayOf_Lorg_yaml_parser_YamlLoader$YamlBuilder(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_parser_YamlLoader$YamlBuilder)))
}
function $asArrayOf_Lorg_yaml_parser_YamlLoader$YamlBuilder(obj, depth) {
  return (($isArrayOf_Lorg_yaml_parser_YamlLoader$YamlBuilder(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.parser.YamlLoader$YamlBuilder;", depth))
}
var $d_Lorg_yaml_parser_YamlLoader$YamlBuilder = new $TypeData().initClass({
  Lorg_yaml_parser_YamlLoader$YamlBuilder: 0
}, false, "org.yaml.parser.YamlLoader$YamlBuilder", {
  Lorg_yaml_parser_YamlLoader$YamlBuilder: 1,
  O: 1
});
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.$classData = $d_Lorg_yaml_parser_YamlLoader$YamlBuilder;
/** @constructor */
function $c_Lorg_yaml_parser_YamlLoader$YamlBuilder$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder$.prototype = new $h_O();
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder$.prototype.constructor = $c_Lorg_yaml_parser_YamlLoader$YamlBuilder$;
/** @constructor */
function $h_Lorg_yaml_parser_YamlLoader$YamlBuilder$() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_YamlLoader$YamlBuilder$.prototype = $c_Lorg_yaml_parser_YamlLoader$YamlBuilder$.prototype;
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder$.prototype.init___Lorg_yaml_parser_YamlLoader = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder$.prototype.$$lessinit$greater$default$1__Lorg_mulesoft_lexer_SourceLocation = (function() {
  var this$1 = this.$$outer$1.lexer$1;
  return this$1.$$undtokenData$1.range$1
});
var $d_Lorg_yaml_parser_YamlLoader$YamlBuilder$ = new $TypeData().initClass({
  Lorg_yaml_parser_YamlLoader$YamlBuilder$: 0
}, false, "org.yaml.parser.YamlLoader$YamlBuilder$", {
  Lorg_yaml_parser_YamlLoader$YamlBuilder$: 1,
  O: 1
});
$c_Lorg_yaml_parser_YamlLoader$YamlBuilder$.prototype.$classData = $d_Lorg_yaml_parser_YamlLoader$YamlBuilder$;
/** @constructor */
function $c_Lorg_yaml_parser_YamlParser$() {
  $c_O.call(this)
}
$c_Lorg_yaml_parser_YamlParser$.prototype = new $h_O();
$c_Lorg_yaml_parser_YamlParser$.prototype.constructor = $c_Lorg_yaml_parser_YamlParser$;
/** @constructor */
function $h_Lorg_yaml_parser_YamlParser$() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_YamlParser$.prototype = $c_Lorg_yaml_parser_YamlParser$.prototype;
$c_Lorg_yaml_parser_YamlParser$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_parser_YamlParser$.prototype.apply__jl_CharSequence__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_YamlParser = (function(s, eh) {
  var lexer = $m_Lorg_yaml_lexer_YamlLexer$().apply__jl_CharSequence__Lorg_yaml_lexer_YamlLexer(s);
  return new $c_Lorg_yaml_parser_YamlParser().init___Lorg_yaml_lexer_YamlLexer__Lorg_yaml_model_ParseErrorHandler(lexer, eh)
});
$c_Lorg_yaml_parser_YamlParser$.prototype.apply__jl_CharSequence__T__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_YamlParser = (function(s, sourceName, eh) {
  var lexer = $m_Lorg_yaml_lexer_YamlLexer$().apply__jl_CharSequence__T__Lorg_yaml_lexer_YamlLexer(s, sourceName);
  return new $c_Lorg_yaml_parser_YamlParser().init___Lorg_yaml_lexer_YamlLexer__Lorg_yaml_model_ParseErrorHandler(lexer, eh)
});
var $d_Lorg_yaml_parser_YamlParser$ = new $TypeData().initClass({
  Lorg_yaml_parser_YamlParser$: 0
}, false, "org.yaml.parser.YamlParser$", {
  Lorg_yaml_parser_YamlParser$: 1,
  O: 1
});
$c_Lorg_yaml_parser_YamlParser$.prototype.$classData = $d_Lorg_yaml_parser_YamlParser$;
var $n_Lorg_yaml_parser_YamlParser$ = (void 0);
function $m_Lorg_yaml_parser_YamlParser$() {
  if ((!$n_Lorg_yaml_parser_YamlParser$)) {
    $n_Lorg_yaml_parser_YamlParser$ = new $c_Lorg_yaml_parser_YamlParser$().init___()
  };
  return $n_Lorg_yaml_parser_YamlParser$
}
/** @constructor */
function $c_Lorg_yaml_render_JsonRender() {
  $c_O.call(this);
  this.writer$1 = null;
  this.options$1 = null;
  this.evidence$1$1 = null;
  this.indentation$1 = 0
}
$c_Lorg_yaml_render_JsonRender.prototype = new $h_O();
$c_Lorg_yaml_render_JsonRender.prototype.constructor = $c_Lorg_yaml_render_JsonRender;
/** @constructor */
function $h_Lorg_yaml_render_JsonRender() {
  /*<skip>*/
}
$h_Lorg_yaml_render_JsonRender.prototype = $c_Lorg_yaml_render_JsonRender.prototype;
$c_Lorg_yaml_render_JsonRender.prototype.dedent__p1__V = (function() {
  var jsx$1 = this.indentation$1;
  var this$1 = this.options$1;
  this.indentation$1 = ((jsx$1 - this$1.indentSize$1) | 0)
});
$c_Lorg_yaml_render_JsonRender.prototype.renderScalar__p1__Lorg_yaml_model_YType__Lorg_yaml_model_YScalar__V = (function(t, scalar) {
  var x = $m_Lorg_yaml_model_YType$().Int$1;
  if ((x === t)) {
    var jsx$2 = true
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Bool$1;
    var jsx$2 = (x$3 === t)
  };
  if (jsx$2) {
    var jsx$1 = $objectToString(scalar.value$3)
  } else {
    var x$5 = $m_Lorg_yaml_model_YType$().Float$1;
    if ((x$5 === t)) {
      var s = $objectToString(scalar.value$3);
      if (($m_sjsr_RuntimeString$().indexOf__T__I__I(s, 46) === (-1))) {
        var this$4 = new $c_sci_StringOps().init___T(s);
        var elem = new $c_jl_Character().init___C(101);
        var jsx$4 = (!$f_sc_SeqLike__contains__O__Z(this$4, elem))
      } else {
        var jsx$4 = false
      };
      if (jsx$4) {
        var this$8 = new $c_sci_StringOps().init___T(s);
        var elem$1 = new $c_jl_Character().init___C(69);
        var jsx$3 = (!$f_sc_SeqLike__contains__O__Z(this$8, elem$1))
      } else {
        var jsx$3 = false
      };
      if (jsx$3) {
        var jsx$1 = (s + ".0")
      } else {
        var jsx$1 = s
      }
    } else {
      var x$7 = $m_Lorg_yaml_model_YType$().Null$1;
      if ((x$7 === t)) {
        var jsx$1 = "null"
      } else {
        var x1$2 = scalar.value$3;
        if ($is_T(x1$2)) {
          var x2 = $as_T(x1$2);
          var jsx$6 = new $c_jl_Character().init___C(34);
          var jsx$5 = $m_Lorg_mulesoft_common_core_package$Strings$();
          var this$12 = this.options$1;
          var jsx$1 = ((("" + jsx$6) + jsx$5.encode$extension1__T__Z__T(x2, this$12.encodeNonAscii$1)) + new $c_jl_Character().init___C(34))
        } else {
          var jsx$1 = ((("" + new $c_jl_Character().init___C(34)) + scalar.text$3) + new $c_jl_Character().init___C(34))
        }
      }
    }
  };
  this.org$yaml$render$JsonRender$$render__T__Lorg_yaml_render_JsonRender(jsx$1)
});
$c_Lorg_yaml_render_JsonRender.prototype.toString__T = (function() {
  return $objectToString(this.writer$1)
});
$c_Lorg_yaml_render_JsonRender.prototype.renderIndent__p1__Lorg_yaml_render_JsonRender = (function() {
  if ((this.indentation$1 > 0)) {
    var this$1 = this.options$1;
    if (this$1.insertSpaces$1) {
      var w = this.writer$1;
      var this$5 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(w);
      var this$4 = new $c_sci_StringOps().init___T(" ");
      var n = this.indentation$1;
      var s = $f_sci_StringLike__$$times__I__T(this$4, n);
      var o = this.evidence$1$1;
      o.append__O__jl_CharSequence__V(this$5.w$1, s)
    } else {
      var w$1 = this.writer$1;
      var this$10 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(w$1);
      var this$9 = new $c_sci_StringOps().init___T("\t");
      var jsx$1 = this.indentation$1;
      var this$8 = this.options$1;
      var n$1 = ((jsx$1 / this$8.indentSize$1) | 0);
      var s$1 = $f_sci_StringLike__$$times__I__T(this$9, n$1);
      var o$1 = this.evidence$1$1;
      o$1.append__O__jl_CharSequence__V(this$10.w$1, s$1)
    }
  };
  return this
});
$c_Lorg_yaml_render_JsonRender.prototype.renderMap__p1__Lorg_yaml_model_YMap__Lorg_yaml_render_JsonRender = (function(map) {
  if (map.entries$3.isEmpty__Z()) {
    return this.org$yaml$render$JsonRender$$render__T__Lorg_yaml_render_JsonRender("{}")
  } else {
    this.org$yaml$render$JsonRender$$render__T__Lorg_yaml_render_JsonRender("{\n");
    this.indent__p1__V();
    var total = map.entries$3.size__I();
    var c = 0;
    while ((c < total)) {
      var entry = $as_Lorg_yaml_model_YMapEntry(map.entries$3.apply__I__O(c));
      this.renderIndent__p1__Lorg_yaml_render_JsonRender().renderEntry__p1__Lorg_yaml_model_YMapEntry__Lorg_yaml_render_JsonRender(entry).org$yaml$render$JsonRender$$render__T__Lorg_yaml_render_JsonRender(((c < (((-1) + total) | 0)) ? ",\n" : "\n"));
      c = ((1 + c) | 0)
    };
    this.dedent__p1__V();
    return this.renderIndent__p1__Lorg_yaml_render_JsonRender().org$yaml$render$JsonRender$$render__T__Lorg_yaml_render_JsonRender("}")
  }
});
$c_Lorg_yaml_render_JsonRender.prototype.renderSeq__p1__Lorg_yaml_model_YSequence__Lorg_yaml_render_JsonRender = (function(seq) {
  if (seq.nodes$3.isEmpty__Z()) {
    return this.org$yaml$render$JsonRender$$render__T__Lorg_yaml_render_JsonRender("[]")
  } else {
    this.org$yaml$render$JsonRender$$render__T__Lorg_yaml_render_JsonRender("[\n");
    this.indent__p1__V();
    var total = seq.nodes$3.size__I();
    var c = 0;
    while ((c < total)) {
      var node = $as_Lorg_yaml_model_YNode(seq.nodes$3.apply__I__O(c));
      this.renderIndent__p1__Lorg_yaml_render_JsonRender().org$yaml$render$JsonRender$$render__Lorg_yaml_model_YNode__Lorg_yaml_render_JsonRender(node).org$yaml$render$JsonRender$$render__T__Lorg_yaml_render_JsonRender(((c < (((-1) + total) | 0)) ? ",\n" : "\n"));
      c = ((1 + c) | 0)
    };
    this.dedent__p1__V();
    return this.renderIndent__p1__Lorg_yaml_render_JsonRender().org$yaml$render$JsonRender$$render__T__Lorg_yaml_render_JsonRender("]")
  }
});
$c_Lorg_yaml_render_JsonRender.prototype.init___O__I__Lorg_yaml_render_JsonRenderOptions__Lorg_mulesoft_common_io_Output = (function(writer, initialIndentation, options, evidence$1) {
  this.writer$1 = writer;
  this.options$1 = options;
  this.evidence$1$1 = evidence$1;
  this.indentation$1 = initialIndentation;
  return this
});
$c_Lorg_yaml_render_JsonRender.prototype.renderEntry__p1__Lorg_yaml_model_YMapEntry__Lorg_yaml_render_JsonRender = (function(entry) {
  return this.org$yaml$render$JsonRender$$render__Lorg_yaml_model_YNode__Lorg_yaml_render_JsonRender(entry.key$2).org$yaml$render$JsonRender$$render__T__Lorg_yaml_render_JsonRender(": ").org$yaml$render$JsonRender$$render__Lorg_yaml_model_YNode__Lorg_yaml_render_JsonRender(entry.value$2)
});
$c_Lorg_yaml_render_JsonRender.prototype.org$yaml$render$JsonRender$$render__T__Lorg_yaml_render_JsonRender = (function(value) {
  var w = this.writer$1;
  var this$2 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(w);
  var o = this.evidence$1$1;
  o.append__O__jl_CharSequence__V(this$2.w$1, value);
  return this
});
$c_Lorg_yaml_render_JsonRender.prototype.indent__p1__V = (function() {
  var jsx$1 = this.indentation$1;
  var this$1 = this.options$1;
  this.indentation$1 = ((jsx$1 + this$1.indentSize$1) | 0)
});
$c_Lorg_yaml_render_JsonRender.prototype.org$yaml$render$JsonRender$$render__Lorg_yaml_model_YNode__Lorg_yaml_render_JsonRender = (function(node) {
  var x1 = node.value__Lorg_yaml_model_YValue();
  if ((x1 instanceof $c_Lorg_yaml_model_YMap)) {
    var x2 = $as_Lorg_yaml_model_YMap(x1);
    this.renderMap__p1__Lorg_yaml_model_YMap__Lorg_yaml_render_JsonRender(x2)
  } else if ((x1 instanceof $c_Lorg_yaml_model_YSequence)) {
    var x3 = $as_Lorg_yaml_model_YSequence(x1);
    this.renderSeq__p1__Lorg_yaml_model_YSequence__Lorg_yaml_render_JsonRender(x3)
  } else if ((x1 instanceof $c_Lorg_yaml_model_YScalar)) {
    var x4 = $as_Lorg_yaml_model_YScalar(x1);
    this.renderScalar__p1__Lorg_yaml_model_YType__Lorg_yaml_model_YScalar__V(node.tag__Lorg_yaml_model_YTag().tagType$3, x4)
  } else {
    throw new $c_s_MatchError().init___O(x1)
  };
  return this
});
var $d_Lorg_yaml_render_JsonRender = new $TypeData().initClass({
  Lorg_yaml_render_JsonRender: 0
}, false, "org.yaml.render.JsonRender", {
  Lorg_yaml_render_JsonRender: 1,
  O: 1
});
$c_Lorg_yaml_render_JsonRender.prototype.$classData = $d_Lorg_yaml_render_JsonRender;
/** @constructor */
function $c_Lorg_yaml_render_JsonRender$() {
  $c_O.call(this)
}
$c_Lorg_yaml_render_JsonRender$.prototype = new $h_O();
$c_Lorg_yaml_render_JsonRender$.prototype.constructor = $c_Lorg_yaml_render_JsonRender$;
/** @constructor */
function $h_Lorg_yaml_render_JsonRender$() {
  /*<skip>*/
}
$h_Lorg_yaml_render_JsonRender$.prototype = $c_Lorg_yaml_render_JsonRender$.prototype;
$c_Lorg_yaml_render_JsonRender$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_render_JsonRender$.prototype.render__Lorg_yaml_model_YDocument__O__I__Lorg_yaml_render_JsonRenderOptions__Lorg_mulesoft_common_io_Output__V = (function(doc, writer, indentation, options, evidence$2) {
  try {
    var builder = new $c_Lorg_yaml_render_JsonRender().init___O__I__Lorg_yaml_render_JsonRenderOptions__Lorg_mulesoft_common_io_Output(writer, indentation, options, evidence$2);
    builder.org$yaml$render$JsonRender$$render__Lorg_yaml_model_YNode__Lorg_yaml_render_JsonRender(doc.node$2).org$yaml$render$JsonRender$$render__T__Lorg_yaml_render_JsonRender("\n")
  } finally {
    var this$2 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(writer);
    evidence$2.flush__O__V(this$2.w$1)
  }
});
$c_Lorg_yaml_render_JsonRender$.prototype.render__Lorg_yaml_model_YDocument__I__Lorg_yaml_render_JsonRenderOptions__T = (function(doc, indentation, options) {
  var s = new $c_Ljava_io_StringWriter().init___();
  this.render__Lorg_yaml_model_YDocument__O__I__Lorg_yaml_render_JsonRenderOptions__Lorg_mulesoft_common_io_Output__V(doc, s, indentation, options, $m_Lorg_mulesoft_common_io_Output$OutputWriter$());
  return s.toString__T()
});
var $d_Lorg_yaml_render_JsonRender$ = new $TypeData().initClass({
  Lorg_yaml_render_JsonRender$: 0
}, false, "org.yaml.render.JsonRender$", {
  Lorg_yaml_render_JsonRender$: 1,
  O: 1
});
$c_Lorg_yaml_render_JsonRender$.prototype.$classData = $d_Lorg_yaml_render_JsonRender$;
var $n_Lorg_yaml_render_JsonRender$ = (void 0);
function $m_Lorg_yaml_render_JsonRender$() {
  if ((!$n_Lorg_yaml_render_JsonRender$)) {
    $n_Lorg_yaml_render_JsonRender$ = new $c_Lorg_yaml_render_JsonRender$().init___()
  };
  return $n_Lorg_yaml_render_JsonRender$
}
/** @constructor */
function $c_Lorg_yaml_render_ScalarRender$() {
  $c_O.call(this)
}
$c_Lorg_yaml_render_ScalarRender$.prototype = new $h_O();
$c_Lorg_yaml_render_ScalarRender$.prototype.constructor = $c_Lorg_yaml_render_ScalarRender$;
/** @constructor */
function $h_Lorg_yaml_render_ScalarRender$() {
  /*<skip>*/
}
$h_Lorg_yaml_render_ScalarRender$.prototype = $c_Lorg_yaml_render_ScalarRender$.prototype;
$c_Lorg_yaml_render_ScalarRender$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_render_ScalarRender$.prototype.renderAsLiteral__p1__T__T__I__jl_CharSequence = (function(text, firstLineComment, indentation) {
  var builder = new $c_scm_StringBuilder().init___();
  var ind = ((indentation < 0) ? 2 : ((2 + indentation) | 0));
  builder.$$plus$eq__C__scm_StringBuilder(124);
  var l = $uI(text.length);
  var this$3 = new $c_sci_StringOps().init___T(text);
  var c = $f_sc_IndexedSeqOptimized__head__O(this$3);
  if ((c === null)) {
    var jsx$1 = 0
  } else {
    var this$5 = $as_jl_Character(c);
    var jsx$1 = this$5.value$1
  };
  if ((jsx$1 === 32)) {
    builder.$$plus$plus$eq__T__scm_StringBuilder(("" + ind))
  };
  var index = (((-1) + l) | 0);
  if (((65535 & $uI(text.charCodeAt(index))) !== 10)) {
    builder.$$plus$eq__C__scm_StringBuilder(45)
  } else {
    if ((l > 1)) {
      var index$1 = (((-2) + l) | 0);
      var jsx$2 = ((65535 & $uI(text.charCodeAt(index$1))) === 10)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      builder.$$plus$eq__C__scm_StringBuilder(43)
    }
  };
  builder.$$plus$plus$eq__T__scm_StringBuilder(firstLineComment);
  var start = 0;
  var end = 0;
  do {
    end = $m_sjsr_RuntimeString$().indexOf__T__I__I__I(text, 10, start);
    if ((end === (-1))) {
      var beginIndex = start;
      var str = $as_T(text.substring(beginIndex))
    } else {
      var beginIndex$1 = start;
      var endIndex = end;
      var str = $as_T(text.substring(beginIndex$1, endIndex))
    };
    builder.$$plus$eq__C__scm_StringBuilder(10);
    var this$18 = new $c_sci_StringOps().init___T(str);
    if ($f_sc_TraversableOnce__nonEmpty__Z(this$18)) {
      var isEmpty$4 = (ind <= 0);
      var scala$collection$immutable$Range$$lastElement$4 = (((-1) + ind) | 0);
      if ((!isEmpty$4)) {
        var i = 0;
        while (true) {
          var arg1 = i;
          builder.$$plus$eq__C__scm_StringBuilder(32);
          if ((i === scala$collection$immutable$Range$$lastElement$4)) {
            break
          };
          i = ((1 + i) | 0)
        }
      };
      builder.$$plus$plus$eq__T__scm_StringBuilder(str)
    };
    start = ((1 + end) | 0)
  } while ((end !== (-1)));
  return builder
});
$c_Lorg_yaml_render_ScalarRender$.prototype.renderScalar__T__Z__Lorg_yaml_model_ScalarMark__I__T__Z__jl_CharSequence = (function(text, mustBeString, mark, indentation, firstLineComment, isCoreSchema) {
  var x1 = this.analyzeScalar__T__Lorg_yaml_model_ScalarMark__Z__Z__Lorg_yaml_model_ScalarMark(text, mark, mustBeString, isCoreSchema);
  var x = $m_Lorg_yaml_model_NoMark$();
  if ((x === x1)) {
    return text
  } else {
    var x$3 = $m_Lorg_yaml_model_DoubleQuoteMark$();
    if ((x$3 === x1)) {
      return ((("" + new $c_jl_Character().init___C(34)) + $m_Lorg_mulesoft_common_core_package$Strings$().encode$extension1__T__Z__T(text, true)) + new $c_jl_Character().init___C(34))
    } else {
      var x$5 = $m_Lorg_yaml_model_SingleQuoteMark$();
      if ((x$5 === x1)) {
        return (("'" + $as_T(text.split("\n").join("\n\n"))) + "'")
      } else {
        var x$7 = $m_Lorg_yaml_model_MultilineMark$();
        if ((x$7 === x1)) {
          return this.renderAsLiteral__p1__T__T__I__jl_CharSequence(text, firstLineComment, indentation)
        } else {
          throw new $c_s_MatchError().init___O(x1)
        }
      }
    }
  }
});
$c_Lorg_yaml_render_ScalarRender$.prototype.analyzeScalar__T__Lorg_yaml_model_ScalarMark__Z__Z__Lorg_yaml_model_ScalarMark = (function(text, mark, mustBeString, isCoreSchema) {
  var x$2 = $m_Lorg_yaml_model_DoubleQuoteMark$();
  if (((mark !== null) && (mark === x$2))) {
    var jsx$1 = true
  } else {
    var x$4 = $m_Lorg_yaml_model_SingleQuoteMark$();
    var jsx$1 = ((mark !== null) && (mark === x$4))
  };
  if (jsx$1) {
    return mark
  };
  var l = $uI(text.length);
  if ((l === 0)) {
    return ((mustBeString || (!mark.plain__Z())) ? $m_Lorg_yaml_model_DoubleQuoteMark$() : $m_Lorg_yaml_model_NoMark$())
  };
  var this$3 = new $c_sci_StringOps().init___T(text);
  var c = $f_sc_IndexedSeqOptimized__head__O(this$3);
  if ((c === null)) {
    var jsx$2 = 0
  } else {
    var this$5 = $as_jl_Character(c);
    var jsx$2 = this$5.value$1
  };
  if (((jsx$2 === 32) || $m_sjsr_RuntimeString$().endsWith__T__T__Z(text, "\n\n"))) {
    return $m_Lorg_yaml_model_DoubleQuoteMark$()
  };
  var oneLine = true;
  var allSpaces = true;
  var noTabs = true;
  var flowChar = false;
  var iterator = new $c_Lorg_yaml_render_ScalarRender$ScalarIterator().init___T(text);
  do {
    var x1 = iterator.current$1;
    switch (x1) {
      case 10: {
        oneLine = false;
        break
      }
      case 9: {
        noTabs = false;
        break
      }
      case 13: {
        return $m_Lorg_yaml_model_DoubleQuoteMark$();
        break
      }
      default: {
        if ((!$m_Lorg_yaml_lexer_YamlCharRules$().isCPrintable__I__Z(iterator.current$1))) {
          return $m_Lorg_yaml_model_DoubleQuoteMark$()
        } else if (iterator.shouldQuote__Z()) {
          flowChar = true
        } else {
          allSpaces = false
        }
      }
    }
  } while (iterator.advance__Z());
  if (oneLine) {
    if (flowChar) {
      return $m_Lorg_yaml_model_DoubleQuoteMark$()
    } else {
      if ((mark.plain__Z() && noTabs)) {
        var this$7 = new $c_sci_StringOps().init___T(text);
        var c$1 = $f_sc_IndexedSeqOptimized__last__O(this$7);
        if ((c$1 === null)) {
          var jsx$4 = 0
        } else {
          var this$9 = $as_jl_Character(c$1);
          var jsx$4 = this$9.value$1
        };
        var jsx$3 = (jsx$4 !== 32)
      } else {
        var jsx$3 = false
      };
      if (jsx$3) {
        if ((!mustBeString)) {
          return $m_Lorg_yaml_model_NoMark$()
        } else {
          $m_Lorg_yaml_parser_ScalarParser$();
          var sp = new $c_Lorg_yaml_parser_ScalarParser().init___T__Lorg_yaml_model_YType(text, $m_Lorg_yaml_model_YType$().Unknown$1);
          sp.parse__s_util_Either();
          var x$5 = sp.yType$1;
          var x$6 = $m_Lorg_yaml_model_YType$().Str$1;
          if ((x$5 === x$6)) {
            var jsx$5 = true
          } else if (isCoreSchema) {
            var x$7 = sp.yType$1;
            var x$8 = $m_Lorg_yaml_model_YType$().Timestamp$1;
            var jsx$5 = (x$7 === x$8)
          } else {
            var jsx$5 = false
          };
          if (jsx$5) {
            return $m_Lorg_yaml_model_NoMark$()
          } else {
            return $m_Lorg_yaml_model_DoubleQuoteMark$()
          }
        }
      } else {
        return $m_Lorg_yaml_model_DoubleQuoteMark$()
      }
    }
  } else {
    return (allSpaces ? $m_Lorg_yaml_model_DoubleQuoteMark$() : $m_Lorg_yaml_model_MultilineMark$())
  }
});
var $d_Lorg_yaml_render_ScalarRender$ = new $TypeData().initClass({
  Lorg_yaml_render_ScalarRender$: 0
}, false, "org.yaml.render.ScalarRender$", {
  Lorg_yaml_render_ScalarRender$: 1,
  O: 1
});
$c_Lorg_yaml_render_ScalarRender$.prototype.$classData = $d_Lorg_yaml_render_ScalarRender$;
var $n_Lorg_yaml_render_ScalarRender$ = (void 0);
function $m_Lorg_yaml_render_ScalarRender$() {
  if ((!$n_Lorg_yaml_render_ScalarRender$)) {
    $n_Lorg_yaml_render_ScalarRender$ = new $c_Lorg_yaml_render_ScalarRender$().init___()
  };
  return $n_Lorg_yaml_render_ScalarRender$
}
/** @constructor */
function $c_Lorg_yaml_render_ScalarRender$ScalarIterator() {
  $c_O.call(this);
  this.text$1 = null;
  this.c$1 = 0;
  this.current$1 = 0;
  this.until$1 = 0
}
$c_Lorg_yaml_render_ScalarRender$ScalarIterator.prototype = new $h_O();
$c_Lorg_yaml_render_ScalarRender$ScalarIterator.prototype.constructor = $c_Lorg_yaml_render_ScalarRender$ScalarIterator;
/** @constructor */
function $h_Lorg_yaml_render_ScalarRender$ScalarIterator() {
  /*<skip>*/
}
$h_Lorg_yaml_render_ScalarRender$ScalarIterator.prototype = $c_Lorg_yaml_render_ScalarRender$ScalarIterator.prototype;
$c_Lorg_yaml_render_ScalarRender$ScalarIterator.prototype.next__C = (function() {
  if (this.isLast__Z()) {
    return 0
  } else {
    var x = this.text$1;
    var index = ((1 + this.c$1) | 0);
    return (65535 & $uI(x.charCodeAt(index)))
  }
});
$c_Lorg_yaml_render_ScalarRender$ScalarIterator.prototype.previous__C = (function() {
  if (this.isFirst__Z()) {
    return 0
  } else {
    var x = this.text$1;
    var index = (((-1) + this.c$1) | 0);
    return (65535 & $uI(x.charCodeAt(index)))
  }
});
$c_Lorg_yaml_render_ScalarRender$ScalarIterator.prototype.isLast__Z = (function() {
  return (this.c$1 === this.until$1)
});
$c_Lorg_yaml_render_ScalarRender$ScalarIterator.prototype.isFirst__Z = (function() {
  return (this.c$1 === 0)
});
$c_Lorg_yaml_render_ScalarRender$ScalarIterator.prototype.init___T = (function(text) {
  this.text$1 = text;
  this.c$1 = 0;
  var this$2 = new $c_sci_StringOps().init___T(text);
  var c = $f_sc_IndexedSeqOptimized__head__O(this$2);
  if ((c === null)) {
    var jsx$1 = 0
  } else {
    var this$4 = $as_jl_Character(c);
    var jsx$1 = this$4.value$1
  };
  this.current$1 = jsx$1;
  this.until$1 = (((-1) + $uI(text.length)) | 0);
  return this
});
$c_Lorg_yaml_render_ScalarRender$ScalarIterator.prototype.shouldQuote__Z = (function() {
  if (this.isFirst__Z()) {
    var x1 = this.current$1;
    switch (x1) {
      case 63:
      case 58:
      case 45: {
        var c = this.next__C();
        var this$3 = $m_jl_Character$();
        if (this$3.isSpaceChar__I__Z(c)) {
          return true
        } else {
          return (this.next__C() === 92)
        };
        break
      }
      default: {
        return $m_Lorg_yaml_lexer_YamlCharRules$().isIndicator__I__Z(this.current$1)
      }
    }
  } else {
    var x1$2 = this.current$1;
    switch (x1$2) {
      case 35: {
        var c$1 = this.previous__C();
        var this$6 = $m_jl_Character$();
        if (this$6.isSpaceChar__I__Z(c$1)) {
          return true
        } else {
          return (this.previous__C() === 92)
        };
        break
      }
      case 58: {
        if (this.isLast__Z()) {
          var jsx$1 = true
        } else {
          var c$2 = this.next__C();
          var this$9 = $m_jl_Character$();
          var jsx$1 = this$9.isSpaceChar__I__Z(c$2)
        };
        if (jsx$1) {
          return true
        } else {
          return (this.next__C() === 92)
        };
        break
      }
      default: {
        return false
      }
    }
  }
});
$c_Lorg_yaml_render_ScalarRender$ScalarIterator.prototype.advance__Z = (function() {
  if ((!this.isLast__Z())) {
    this.c$1 = ((1 + this.c$1) | 0);
    var x = this.text$1;
    var index = this.c$1;
    this.current$1 = (65535 & $uI(x.charCodeAt(index)));
    return true
  } else {
    return false
  }
});
var $d_Lorg_yaml_render_ScalarRender$ScalarIterator = new $TypeData().initClass({
  Lorg_yaml_render_ScalarRender$ScalarIterator: 0
}, false, "org.yaml.render.ScalarRender$ScalarIterator", {
  Lorg_yaml_render_ScalarRender$ScalarIterator: 1,
  O: 1
});
$c_Lorg_yaml_render_ScalarRender$ScalarIterator.prototype.$classData = $d_Lorg_yaml_render_ScalarRender$ScalarIterator;
/** @constructor */
function $c_Lorg_yaml_render_YamlRender() {
  $c_O.call(this);
  this.writer$1 = null;
  this.expandReferences$1 = false;
  this.options$1 = null;
  this.evidence$1$1 = null;
  this.buffer$1 = null;
  this.indentation$1 = 0;
  this.hasDirectives$1 = false;
  this.endDocument$1 = false
}
$c_Lorg_yaml_render_YamlRender.prototype = new $h_O();
$c_Lorg_yaml_render_YamlRender.prototype.constructor = $c_Lorg_yaml_render_YamlRender;
/** @constructor */
function $h_Lorg_yaml_render_YamlRender() {
  /*<skip>*/
}
$h_Lorg_yaml_render_YamlRender.prototype = $c_Lorg_yaml_render_YamlRender.prototype;
$c_Lorg_yaml_render_YamlRender.prototype.print__p1__T__Lorg_yaml_render_YamlRender = (function(value) {
  this.buffer$1.append__T__scm_StringBuilder(value);
  return this
});
$c_Lorg_yaml_render_YamlRender.prototype.flushBuffer__p1__V = (function() {
  var this$1 = this.buffer$1;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$1)) {
    var w = this.writer$1;
    var this$4 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(w);
    var this$3 = this.buffer$1;
    var s = this$3.underlying$5.java$lang$StringBuilder$$content$f;
    var o = this.evidence$1$1;
    o.append__O__jl_CharSequence__V(this$4.w$1, s);
    var this$5 = this.buffer$1;
    this$5.underlying$5.setLength__I__V(0)
  }
});
$c_Lorg_yaml_render_YamlRender.prototype.render__p1__Lorg_yaml_model_YPart__s_Option__Lorg_yaml_render_YamlRender = (function(part, yType) {
  this.checkEndDocument__p1__Lorg_yaml_model_YPart__O(part);
  if ((part instanceof $c_Lorg_yaml_model_YComment)) {
    var x2 = $as_Lorg_yaml_model_YComment(part);
    this.renderComment__p1__T__sc_IndexedSeq__O(x2.metaText$4, x2.tokens$2)
  } else if ((part instanceof $c_Lorg_yaml_model_YNonContent)) {
    var x3 = $as_Lorg_yaml_model_YNonContent(part);
    x3.tokens$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(t$2) {
        var t = $as_Lorg_mulesoft_lexer_AstToken(t$2);
        $this.print__p1__T__Lorg_yaml_render_YamlRender(t.text$1)
      })
    })(this)))
  } else if ((part instanceof $c_Lorg_yaml_model_YDocument)) {
    var x4 = $as_Lorg_yaml_model_YDocument(part);
    this.renderDocument__p1__sc_IndexedSeq__V(x4.children$1)
  } else if ((part instanceof $c_Lorg_yaml_model_YDirective)) {
    var x5 = $as_Lorg_yaml_model_YDirective(part);
    this.renderDirective__p1__Lorg_yaml_model_YDirective__V(x5)
  } else if ((part instanceof $c_Lorg_yaml_model_YSequence)) {
    var x6 = $as_Lorg_yaml_model_YSequence(part);
    this.renderSeq__p1__Lorg_yaml_model_YSequence__V(x6)
  } else if ((part instanceof $c_Lorg_yaml_model_YMap)) {
    var x7 = $as_Lorg_yaml_model_YMap(part);
    this.renderMap__p1__Lorg_yaml_model_YMap__V(x7)
  } else if ((part instanceof $c_Lorg_yaml_model_YMapEntry)) {
    var x8 = $as_Lorg_yaml_model_YMapEntry(part);
    this.doRenderParts__p1__sc_IndexedSeq__s_Option__V(x8.children$1, $m_s_None$())
  } else if ((part instanceof $c_Lorg_yaml_model_YScalar)) {
    var x9 = $as_Lorg_yaml_model_YScalar(part);
    this.renderScalar__p1__Lorg_yaml_model_YScalar__Z__V(x9, yType.contains__O__Z($m_Lorg_yaml_model_YType$().Str$1))
  } else if ((part instanceof $c_Lorg_yaml_model_YTag)) {
    var x10 = $as_Lorg_yaml_model_YTag(part);
    this.renderTag__p1__Lorg_yaml_model_YTag__O(x10)
  } else if ((part instanceof $c_Lorg_yaml_model_YAnchor)) {
    var x11 = $as_Lorg_yaml_model_YAnchor(part);
    this.renderAnchor__p1__Lorg_yaml_model_YAnchor__O(x11)
  } else if ((part instanceof $c_Lorg_yaml_model_YNode)) {
    var x12 = $as_Lorg_yaml_model_YNode(part);
    this.renderNode__p1__Lorg_yaml_model_YNode__V(x12)
  } else {
    throw new $c_s_MatchError().init___O(part)
  };
  return this
});
$c_Lorg_yaml_render_YamlRender.prototype.renderTokens__p1__sc_IndexedSeq__Z = (function(tks) {
  var hasTokens = $f_sc_TraversableOnce__nonEmpty__Z(tks);
  if (hasTokens) {
    tks.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(t$2) {
        var t = $as_Lorg_mulesoft_lexer_AstToken(t$2);
        $this.print__p1__T__Lorg_yaml_render_YamlRender(t.text$1)
      })
    })(this)))
  };
  return hasTokens
});
$c_Lorg_yaml_render_YamlRender.prototype.renderMapEntry__p1__Lorg_yaml_model_YMapEntry__V = (function(e) {
  var key = e.key$2;
  var x1 = key.value__Lorg_yaml_model_YValue();
  if ((x1 instanceof $c_Lorg_yaml_model_YScalar)) {
    var x2 = $as_Lorg_yaml_model_YScalar(x1);
    this.renderTag__p1__Lorg_yaml_model_YTag__O(key.tag__Lorg_yaml_model_YTag());
    var this$1 = key.anchor__s_Option();
    if ((!this$1.isEmpty__Z())) {
      var arg1 = this$1.get__O();
      var r = $as_Lorg_yaml_model_YAnchor(arg1);
      this.render__p1__Lorg_yaml_model_YPart__s_Option__Lorg_yaml_render_YamlRender(r, $m_s_None$())
    };
    var thiz = x2.text$3;
    if (($uI(thiz.indexOf("\n")) !== (-1))) {
      var jsx$1 = new $c_jl_Character().init___C(34);
      var str = x2.text$3;
      this.print__p1__T__Lorg_yaml_render_YamlRender(((("" + jsx$1) + $m_Lorg_mulesoft_common_core_package$Strings$().encode$extension1__T__Z__T(str, true)) + new $c_jl_Character().init___C(34)))
    } else {
      var x = key.tag__Lorg_yaml_model_YTag().tagType$3;
      var x$2 = $m_Lorg_yaml_model_YType$().Str$1;
      if ((x === x$2)) {
        var mustBeString = key.tag__Lorg_yaml_model_YTag().synthesized__Z()
      } else {
        var mustBeString = false
      };
      this.renderScalar__p1__Lorg_yaml_model_YScalar__Z__V(x2, mustBeString)
    };
    this.print__p1__T__Lorg_yaml_render_YamlRender(": ")
  } else {
    var qual$1 = this.print__p1__T__Lorg_yaml_render_YamlRender("?");
    var x$2$2 = $m_s_None$();
    qual$1.render__p1__Lorg_yaml_model_YPart__s_Option__Lorg_yaml_render_YamlRender(key, x$2$2).println__p1__Lorg_yaml_render_YamlRender().renderIndent__p1__Lorg_yaml_render_YamlRender().print__p1__T__Lorg_yaml_render_YamlRender(": ")
  };
  var value = e.value$2;
  var x1$2 = $as_sc_TraversableLike($as_sc_TraversableLike($as_sc_TraversableLike(e.children$1.dropWhile__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, key$1) {
    return (function(x$2$3$2) {
      var x$2$3 = $as_Lorg_yaml_model_YPart(x$2$3$2);
      return (x$2$3 !== key$1)
    })
  })(this, key)))).tail__O()).dropWhile__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(c$2) {
      var c = $as_Lorg_yaml_model_YPart(c$2);
      if ((c instanceof $c_Lorg_yaml_model_YNonContent)) {
        var this$11 = $as_Lorg_yaml_model_YNonContent(c).tokens$2.headOption__s_Option();
        if ((!this$11.isEmpty__Z())) {
          var arg1$1 = this$11.get__O();
          var t = $as_Lorg_mulesoft_lexer_AstToken(arg1$1);
          return (t.text$1 === ":")
        } else {
          return false
        }
      } else {
        return false
      }
    })
  })(this)))).span__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, value$1) {
    return (function(x$3$2) {
      var x$3 = $as_Lorg_yaml_model_YPart(x$3$2);
      return (x$3 !== value$1)
    })
  })(this, value)));
  if ((x1$2 === null)) {
    throw new $c_s_MatchError().init___O(x1$2)
  };
  var before = $as_sc_IndexedSeq(x1$2.$$und1__O());
  var tail = $as_sc_IndexedSeq(x1$2.$$und2__O());
  var after = $as_sc_IndexedSeq(tail.tail__O());
  this.indent__p1__V();
  before.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1) {
    return (function(c$3$2) {
      var c$3 = $as_Lorg_yaml_model_YPart(c$3$2);
      return this$5$1.render__p1__Lorg_yaml_model_YPart__s_Option__Lorg_yaml_render_YamlRender(c$3, $m_s_None$()).renderIndent__p1__Lorg_yaml_render_YamlRender()
    })
  })(this)));
  this.dedent__p1__V();
  var x$5 = value.tag__Lorg_yaml_model_YTag().tagType$3;
  var x$6 = $m_Lorg_yaml_model_YType$().Null$1;
  if ((!(x$5 === x$6))) {
    var jsx$2 = true
  } else {
    var x$1 = value.toString__T();
    var this$13 = new $c_sci_StringOps().init___T(x$1);
    var jsx$2 = $f_sc_TraversableOnce__nonEmpty__Z(this$13)
  };
  if (jsx$2) {
    this.render__p1__Lorg_yaml_model_YPart__s_Option__Lorg_yaml_render_YamlRender(value, $m_s_None$())
  };
  if ($f_sc_TraversableOnce__nonEmpty__Z(after)) {
    this.render__p1__Lorg_yaml_model_YPart__s_Option__Lorg_yaml_render_YamlRender($as_Lorg_yaml_model_YPart(after.head__O()), $m_s_None$());
    this.indent__p1__V();
    $as_sc_IterableLike(after.tail__O()).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1) {
      return (function(c$4$2) {
        var c$4 = $as_Lorg_yaml_model_YPart(c$4$2);
        var qual$2 = this$6$1.renderIndent__p1__Lorg_yaml_render_YamlRender();
        var x$4 = $m_s_None$();
        return qual$2.render__p1__Lorg_yaml_model_YPart__s_Option__Lorg_yaml_render_YamlRender(c$4, x$4)
      })
    })(this)));
    this.dedent__p1__V()
  }
});
$c_Lorg_yaml_render_YamlRender.prototype.renderTag__p1__Lorg_yaml_model_YTag__O = (function(t) {
  return (((!this.renderTokens__p1__sc_IndexedSeq__Z(t.tokens$2)) && (!t.synthesized__Z())) ? this.print__p1__T__Lorg_yaml_render_YamlRender((t.text$3 + " ")) : (void 0))
});
$c_Lorg_yaml_render_YamlRender.prototype.doRenderParts__p1__sc_IndexedSeq__s_Option__V = (function(children, yType) {
  children.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, yType$1) {
    return (function(x$5$2) {
      var x$5 = $as_Lorg_yaml_model_YPart(x$5$2);
      return $this.render__p1__Lorg_yaml_model_YPart__s_Option__Lorg_yaml_render_YamlRender(x$5, yType$1)
    })
  })(this, yType)))
});
$c_Lorg_yaml_render_YamlRender.prototype.renderSeq__p1__Lorg_yaml_model_YSequence__V = (function(seq) {
  if ((!this.renderParts__p1__Lorg_yaml_model_YPart__Z(seq))) {
    if (seq.nodes$3.isEmpty__Z()) {
      this.print__p1__T__Lorg_yaml_render_YamlRender("[]")
    } else {
      this.indent__p1__V();
      seq.children$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(e$2) {
          var e = $as_Lorg_yaml_model_YPart(e$2);
          if ((e instanceof $c_Lorg_yaml_model_YNode)) {
            var x2 = $as_Lorg_yaml_model_YNode(e);
            var qual$1 = $this.println__p1__Lorg_yaml_render_YamlRender().renderIndent__p1__Lorg_yaml_render_YamlRender().print__p1__T__Lorg_yaml_render_YamlRender("- ");
            var x$2 = $m_s_None$();
            return qual$1.render__p1__Lorg_yaml_model_YPart__s_Option__Lorg_yaml_render_YamlRender(x2, x$2)
          } else if ((e instanceof $c_Lorg_yaml_model_YComment)) {
            var x3 = $as_Lorg_yaml_model_YComment(e);
            return $this.render__p1__Lorg_yaml_model_YPart__s_Option__Lorg_yaml_render_YamlRender(x3, $m_s_None$())
          } else {
            return (void 0)
          }
        })
      })(this)));
      this.dedent__p1__V()
    }
  }
});
$c_Lorg_yaml_render_YamlRender.prototype.dedent__p1__V = (function() {
  var jsx$1 = this.indentation$1;
  var this$1 = this.options$1;
  this.indentation$1 = ((jsx$1 - this$1.indentSize$1) | 0)
});
$c_Lorg_yaml_render_YamlRender.prototype.init___O__Z__I__Lorg_yaml_render_YamlRenderOptions__Lorg_mulesoft_common_io_Output = (function(writer, expandReferences, initialIndentation, options, evidence$1) {
  this.writer$1 = writer;
  this.expandReferences$1 = expandReferences;
  this.options$1 = options;
  this.evidence$1$1 = evidence$1;
  this.buffer$1 = new $c_scm_StringBuilder().init___();
  this.indentation$1 = ((initialIndentation - options.indentSize$1) | 0);
  this.hasDirectives$1 = false;
  this.endDocument$1 = false;
  return this
});
$c_Lorg_yaml_render_YamlRender.prototype.renderDocument__p1__sc_IndexedSeq__V = (function(parts) {
  this.doRenderParts__p1__sc_IndexedSeq__s_Option__V(parts, $m_s_None$());
  this.println__p1__Lorg_yaml_render_YamlRender();
  this.endDocument$1 = true
});
$c_Lorg_yaml_render_YamlRender.prototype.renderDirective__p1__Lorg_yaml_model_YDirective__V = (function(d) {
  if ((!this.renderParts__p1__Lorg_yaml_model_YPart__Z(d))) {
    this.print__p1__T__Lorg_yaml_render_YamlRender(d.toString__T()).println__p1__Lorg_yaml_render_YamlRender()
  };
  this.hasDirectives$1 = true
});
$c_Lorg_yaml_render_YamlRender.prototype.renderParts__p1__Lorg_yaml_model_YPart__Z = (function(parts) {
  var nodes = parts.children$1;
  var hasTokens = ($f_sc_TraversableOnce__nonEmpty__Z(nodes) && (nodes.head__O() instanceof $c_Lorg_yaml_model_YNonContent));
  if (hasTokens) {
    this.doRenderParts__p1__sc_IndexedSeq__s_Option__V(nodes, $m_s_None$())
  };
  return hasTokens
});
$c_Lorg_yaml_render_YamlRender.prototype.checkEndDocument__p1__Lorg_yaml_model_YPart__O = (function(part) {
  if (this.endDocument$1) {
    this.endDocument$1 = false;
    this.print__p1__T__Lorg_yaml_render_YamlRender("...\n");
    if ((part instanceof $c_Lorg_yaml_model_YDocument)) {
      var x2 = $as_Lorg_yaml_model_YDocument(part);
      var x = x2.tagType$2;
      var x$2 = $m_Lorg_yaml_model_YType$().Null$1;
      if ((x === x$2)) {
        return this.print__p1__T__Lorg_yaml_render_YamlRender("---\n")
      }
    };
    return (void 0)
  } else {
    return (void 0)
  }
});
$c_Lorg_yaml_render_YamlRender.prototype.renderParts__sc_Seq__V = (function(parts) {
  parts.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lorg_yaml_model_YPart(x$1$2);
      return $this.render__p1__Lorg_yaml_model_YPart__s_Option__Lorg_yaml_render_YamlRender(x$1, $m_s_None$())
    })
  })(this)));
  this.flushBuffer__p1__V()
});
$c_Lorg_yaml_render_YamlRender.prototype.renderNode__p1__Lorg_yaml_model_YNode__V = (function(n) {
  if (((this.expandReferences$1 && (n instanceof $c_Lorg_yaml_model_YNode$Ref)) || (!this.renderParts__p1__Lorg_yaml_model_YPart__Z(n)))) {
    if (this.hasDirectives$1) {
      this.print__p1__T__Lorg_yaml_render_YamlRender("---\n");
      this.hasDirectives$1 = false
    };
    matchEnd5: {
      if ((n instanceof $c_Lorg_yaml_model_YNode$Alias)) {
        var x2 = $as_Lorg_yaml_model_YNode$Alias(n);
        if (this.expandReferences$1) {
          this.render__p1__Lorg_yaml_model_YPart__s_Option__Lorg_yaml_render_YamlRender(x2.target$4, $m_s_None$());
          (void 0)
        } else {
          this.print__p1__T__Lorg_yaml_render_YamlRender(x2.toString__T());
          (void 0)
        };
        break matchEnd5
      };
      if ((n instanceof $c_Lorg_yaml_model_YNode$MutRef)) {
        var x3 = $as_Lorg_yaml_model_YNode$MutRef(n);
        if ((this.expandReferences$1 && x3.target$4.isDefined__Z())) {
          this.render__p1__Lorg_yaml_model_YPart__s_Option__Lorg_yaml_render_YamlRender($as_Lorg_yaml_model_YPart(x3.target$4.get__O()), $m_s_None$());
          break matchEnd5
        }
      };
      var jsx$1 = n.children$1;
      var x = n.tag__Lorg_yaml_model_YTag();
      var this$1 = $m_Lorg_yaml_model_YType$().Str$1;
      var x$2 = this$1.org$yaml$model$YType$$tag$und$1;
      this.doRenderParts__p1__sc_IndexedSeq__s_Option__V(jsx$1, ((x === x$2) ? new $c_s_Some().init___O($m_Lorg_yaml_model_YType$().Str$1) : $m_s_None$()))
    }
  }
});
$c_Lorg_yaml_render_YamlRender.prototype.renderAnchor__p1__Lorg_yaml_model_YAnchor__O = (function(anchor) {
  return ((!this.renderTokens__p1__sc_IndexedSeq__Z(anchor.tokens$2)) ? this.print__p1__T__Lorg_yaml_render_YamlRender($m_s_Predef$any2stringadd$().$$plus$extension__O__T__T(anchor, " ")) : (void 0))
});
$c_Lorg_yaml_render_YamlRender.prototype.println__p1__Lorg_yaml_render_YamlRender = (function() {
  var this$1 = this.buffer$1;
  if ($f_sc_IndexedSeqOptimized__isEmpty__Z(this$1)) {
    return this
  } else {
    var this$2 = this.buffer$1;
    var last = (((-1) + this$2.underlying$5.length__I()) | 0);
    if ((last >= 0)) {
      var this$3 = this.buffer$1;
      var c = this$3.underlying$5.charAt__I__C(last);
      var this$6 = $m_jl_Character$();
      var jsx$1 = this$6.isWhitespace__I__Z(c)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var this$7 = this.buffer$1;
      this$7.underlying$5.setLength__I__V(last)
    };
    this.buffer$1.append__C__scm_StringBuilder(10);
    this.flushBuffer__p1__V();
    return this
  }
});
$c_Lorg_yaml_render_YamlRender.prototype.renderIndent__p1__Lorg_yaml_render_YamlRender = (function() {
  var this$2 = new $c_sci_StringOps().init___T(" ");
  var n = this.indentation$1;
  this.print__p1__T__Lorg_yaml_render_YamlRender($f_sci_StringLike__$$times__I__T(this$2, n));
  return this
});
$c_Lorg_yaml_render_YamlRender.prototype.renderScalar__p1__Lorg_yaml_model_YScalar__Z__V = (function(scalar, mustBeString) {
  if ((!this.renderParts__p1__Lorg_yaml_model_YPart__Z(scalar))) {
    var jsx$4 = $m_Lorg_yaml_render_ScalarRender$();
    var jsx$3 = scalar.text$3;
    var jsx$2 = scalar.mark$3;
    var jsx$1 = this.indentation$1;
    var this$1 = scalar.children$1;
    var pf = new $c_Lorg_yaml_render_YamlRender$$anonfun$1().init___Lorg_yaml_render_YamlRender(this);
    var this$2 = $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$1, pf);
    var str = jsx$4.renderScalar__T__Z__Lorg_yaml_model_ScalarMark__I__T__Z__jl_CharSequence(jsx$3, mustBeString, jsx$2, jsx$1, $as_T((this$2.isEmpty__Z() ? "" : this$2.get__O())), true);
    this.print__p1__T__Lorg_yaml_render_YamlRender($objectToString(str))
  }
});
$c_Lorg_yaml_render_YamlRender.prototype.renderMap__p1__Lorg_yaml_model_YMap__V = (function(map) {
  if ((!this.renderParts__p1__Lorg_yaml_model_YPart__Z(map))) {
    if (map.entries$3.isEmpty__Z()) {
      this.print__p1__T__Lorg_yaml_render_YamlRender("{}")
    } else {
      this.indent__p1__V();
      map.entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(e$2) {
          var e = $as_Lorg_yaml_model_YMapEntry(e$2);
          $this.println__p1__Lorg_yaml_render_YamlRender().renderIndent__p1__Lorg_yaml_render_YamlRender().renderMapEntry__p1__Lorg_yaml_model_YMapEntry__V(e)
        })
      })(this)));
      this.dedent__p1__V()
    }
  }
});
$c_Lorg_yaml_render_YamlRender.prototype.renderComment__p1__T__sc_IndexedSeq__O = (function(text, tks) {
  if ((!this.renderTokens__p1__sc_IndexedSeq__Z(tks))) {
    var this$1 = this.buffer$1;
    if ($f_sc_TraversableOnce__nonEmpty__Z(this$1)) {
      var this$2 = this.buffer$1;
      var c = $f_sc_IndexedSeqOptimized__last__O(this$2);
      if ((c === null)) {
        var c$1 = 0
      } else {
        var this$4 = $as_jl_Character(c);
        var c$1 = this$4.value$1
      };
      var this$7 = $m_jl_Character$();
      var jsx$1 = (!this$7.isWhitespace__I__Z(c$1))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      this.print__p1__T__Lorg_yaml_render_YamlRender(" ")
    };
    return this.print__p1__T__Lorg_yaml_render_YamlRender(("#" + text)).println__p1__Lorg_yaml_render_YamlRender()
  } else {
    return (void 0)
  }
});
$c_Lorg_yaml_render_YamlRender.prototype.indent__p1__V = (function() {
  var jsx$1 = this.indentation$1;
  var this$1 = this.options$1;
  this.indentation$1 = ((jsx$1 + this$1.indentSize$1) | 0)
});
var $d_Lorg_yaml_render_YamlRender = new $TypeData().initClass({
  Lorg_yaml_render_YamlRender: 0
}, false, "org.yaml.render.YamlRender", {
  Lorg_yaml_render_YamlRender: 1,
  O: 1
});
$c_Lorg_yaml_render_YamlRender.prototype.$classData = $d_Lorg_yaml_render_YamlRender;
/** @constructor */
function $c_Lorg_yaml_render_YamlRender$() {
  $c_O.call(this)
}
$c_Lorg_yaml_render_YamlRender$.prototype = new $h_O();
$c_Lorg_yaml_render_YamlRender$.prototype.constructor = $c_Lorg_yaml_render_YamlRender$;
/** @constructor */
function $h_Lorg_yaml_render_YamlRender$() {
  /*<skip>*/
}
$h_Lorg_yaml_render_YamlRender$.prototype = $c_Lorg_yaml_render_YamlRender$.prototype;
$c_Lorg_yaml_render_YamlRender$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_render_YamlRender$.prototype.render__O__sc_Seq__Z__I__Lorg_yaml_render_YamlRenderOptions__Lorg_mulesoft_common_io_Output__V = (function(writer, parts, expandReferences, indentation, options, evidence$2) {
  new $c_Lorg_yaml_render_YamlRender().init___O__Z__I__Lorg_yaml_render_YamlRenderOptions__Lorg_mulesoft_common_io_Output(writer, expandReferences, indentation, options, evidence$2).renderParts__sc_Seq__V(parts)
});
$c_Lorg_yaml_render_YamlRender$.prototype.render__O__Lorg_yaml_model_YPart__Z__Lorg_mulesoft_common_io_Output__V = (function(writer, part, expandReferences, evidence$6) {
  var jsx$1 = $m_sc_Seq$();
  var array = [part];
  var parts = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  this.render__O__sc_Seq__Z__I__Lorg_yaml_render_YamlRenderOptions__Lorg_mulesoft_common_io_Output__V(writer, parts, expandReferences, 0, new $c_Lorg_yaml_render_YamlRenderOptions().init___(), evidence$6)
});
$c_Lorg_yaml_render_YamlRender$.prototype.render__Lorg_yaml_model_YPart__Z__T = (function(part, expandReferences) {
  var s = new $c_Ljava_io_StringWriter().init___();
  this.render__O__Lorg_yaml_model_YPart__Z__Lorg_mulesoft_common_io_Output__V(s, part, expandReferences, $m_Lorg_mulesoft_common_io_Output$OutputWriter$());
  return s.toString__T()
});
var $d_Lorg_yaml_render_YamlRender$ = new $TypeData().initClass({
  Lorg_yaml_render_YamlRender$: 0
}, false, "org.yaml.render.YamlRender$", {
  Lorg_yaml_render_YamlRender$: 1,
  O: 1
});
$c_Lorg_yaml_render_YamlRender$.prototype.$classData = $d_Lorg_yaml_render_YamlRender$;
var $n_Lorg_yaml_render_YamlRender$ = (void 0);
function $m_Lorg_yaml_render_YamlRender$() {
  if ((!$n_Lorg_yaml_render_YamlRender$)) {
    $n_Lorg_yaml_render_YamlRender$ = new $c_Lorg_yaml_render_YamlRender$().init___()
  };
  return $n_Lorg_yaml_render_YamlRender$
}
/** @constructor */
function $c_Lscopt_OptionDef() {
  $c_O.call(this);
  this.$$undparser$1 = null;
  this.$$undid$1 = 0;
  this.$$undkind$1 = null;
  this.$$undname$1 = null;
  this.$$undshortOpt$1 = null;
  this.$$undkeyName$1 = null;
  this.$$undvalueName$1 = null;
  this.$$unddesc$1 = null;
  this.$$undaction$1 = null;
  this.$$undvalidations$1 = null;
  this.$$undconfigValidations$1 = null;
  this.$$undparentId$1 = null;
  this.$$undminOccurs$1 = 0;
  this.$$undmaxOccurs$1 = 0;
  this.$$undisHidden$1 = false;
  this.$$undfallback$1 = null;
  this.evidence$13$1 = null;
  this.kind$1 = null;
  this.id$1 = 0;
  this.name$1 = null
}
$c_Lscopt_OptionDef.prototype = new $h_O();
$c_Lscopt_OptionDef.prototype.constructor = $c_Lscopt_OptionDef;
/** @constructor */
function $h_Lscopt_OptionDef() {
  /*<skip>*/
}
$h_Lscopt_OptionDef.prototype = $c_Lscopt_OptionDef.prototype;
$c_Lscopt_OptionDef.prototype.token__I__sc_Seq__s_Option = (function(i, args) {
  if ((i >= args.length__I())) {
    var jsx$1 = true
  } else {
    var x = this.kind$1;
    var x$2 = $m_Lscopt_Opt$();
    var jsx$1 = (!((x !== null) && (x === x$2)))
  };
  if (jsx$1) {
    return $m_s_None$()
  } else {
    return new $c_s_Some().init___O(args.apply__I__O(i))
  }
});
$c_Lscopt_OptionDef.prototype.copy__Lscopt_OptionParser__I__Lscopt_OptionDefKind__T__s_Option__s_Option__s_Option__T__F2__sc_Seq__sc_Seq__s_Option__I__I__Z__s_Option__Lscopt_OptionDef = (function(_parser, _id, _kind, _name, _shortOpt, _keyName, _valueName, _desc, _action, _validations, _configValidations, _parentId, _minOccurs, _maxOccurs, _isHidden, _fallback) {
  return new $c_Lscopt_OptionDef().init___Lscopt_OptionParser__I__Lscopt_OptionDefKind__T__s_Option__s_Option__s_Option__T__F2__sc_Seq__sc_Seq__s_Option__I__I__Z__s_Option__Lscopt_Read(_parser, _id, _kind, _name, _shortOpt, _keyName, _valueName, _desc, _action, _validations, _configValidations, _parentId, _minOccurs, _maxOccurs, _isHidden, _fallback, this.evidence$13$1)
});
$c_Lscopt_OptionDef.prototype.validate__F1__Lscopt_OptionDef = (function(f) {
  var jsx$2 = this.$$undparser$1;
  var jsx$1 = this.$$undvalidations$1;
  var this$1 = $m_sc_Seq$();
  var x$187 = $as_sc_Seq(jsx$1.$$colon$plus__O__scg_CanBuildFrom__O(f, this$1.ReusableCBFInstance$2));
  var x$188 = this.$$undparser$1;
  var x$189 = this.$$undid$1;
  var x$190 = this.$$undkind$1;
  var x$191 = this.$$undname$1;
  var x$192 = this.$$undshortOpt$1;
  var x$193 = this.$$undkeyName$1;
  var x$194 = this.$$undvalueName$1;
  var x$195 = this.$$unddesc$1;
  var x$196 = this.$$undaction$1;
  var x$197 = this.$$undconfigValidations$1;
  var x$198 = this.$$undparentId$1;
  var x$199 = this.$$undminOccurs$1;
  var x$200 = this.$$undmaxOccurs$1;
  var x$201 = this.$$undisHidden$1;
  var x$202 = this.$$undfallback$1;
  return jsx$2.updateOption__Lscopt_OptionDef__Lscopt_Read__Lscopt_OptionDef(this.copy__Lscopt_OptionParser__I__Lscopt_OptionDefKind__T__s_Option__s_Option__s_Option__T__F2__sc_Seq__sc_Seq__s_Option__I__I__Z__s_Option__Lscopt_OptionDef(x$188, x$189, x$190, x$191, x$192, x$193, x$194, x$195, x$196, x$187, x$197, x$198, x$199, x$200, x$201, x$202), this.evidence$13$1)
});
$c_Lscopt_OptionDef.prototype.applyArgument__T__O__s_util_Either = (function(arg, config) {
  try {
    var x = this.read__p1__Lscopt_Read().reads__F1().apply__O__O(arg);
    var x1 = $m_Lscopt_Validation$().validateValue__sc_Seq__O__s_util_Either(this.$$undvalidations$1, x);
    if ((x1 instanceof $c_s_util_Right)) {
      $m_s_package$();
      var value = this.$$undaction$1.apply__O__O__O(x, config);
      return new $c_s_util_Right().init___O(value)
    } else if ((x1 instanceof $c_s_util_Left)) {
      var x4 = $as_s_util_Left(x1);
      var xs = $as_sc_Seq(x4.value$2);
      $m_s_package$();
      return new $c_s_util_Left().init___O(xs)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      $m_Lscopt_platform$();
      var x$1 = this.shortDescription__T();
      var this$4 = new $c_sci_StringOps().init___T(x$1);
      var desc = $f_sci_StringLike__capitalize__T(this$4);
      var catchExpr$1 = new $c_Lscopt_platform$$anonfun$applyArgumentExHandler$1().init___T__T(desc, arg);
      if (catchExpr$1.isDefinedAt__jl_Throwable__Z(e$2)) {
        var $default = $m_s_PartialFunction$().empty$undpf$1;
        return $as_s_util_Either(catchExpr$1.applyOrElse__jl_Throwable__F1__O(e$2, $default))
      } else {
        throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(e$2)
      }
    } else {
      throw e
    }
  }
});
$c_Lscopt_OptionDef.prototype.tokensToRead__I__sc_Seq__I = (function(i, args) {
  if ((i >= args.length__I())) {
    var jsx$1 = true
  } else {
    var x = this.kind$1;
    var x$2 = $m_Lscopt_Opt$();
    var jsx$1 = (!((x !== null) && (x === x$2)))
  };
  if (jsx$1) {
    return 0
  } else {
    var x1 = $as_T(args.apply__I__O(i));
    return ((this.longOptTokens__T__I(x1) > 0) ? this.longOptTokens__T__I(x1) : ((this.shortOptTokens__T__I(x1) > 0) ? this.shortOptTokens__T__I(x1) : 0))
  }
});
$c_Lscopt_OptionDef.prototype.toString__T = (function() {
  return this.fullName__T()
});
$c_Lscopt_OptionDef.prototype.action__F2__Lscopt_OptionDef = (function(f) {
  var jsx$1 = this.$$undparser$1;
  var x$59 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this, f$1) {
    return (function(a$2, c$2) {
      return f$1.apply__O__O__O(a$2, $this.$$undaction$1.apply__O__O__O(a$2, c$2))
    })
  })(this, f));
  var x$60 = this.$$undparser$1;
  var x$61 = this.$$undid$1;
  var x$62 = this.$$undkind$1;
  var x$63 = this.$$undname$1;
  var x$64 = this.$$undshortOpt$1;
  var x$65 = this.$$undkeyName$1;
  var x$66 = this.$$undvalueName$1;
  var x$67 = this.$$unddesc$1;
  var x$68 = this.$$undvalidations$1;
  var x$69 = this.$$undconfigValidations$1;
  var x$70 = this.$$undparentId$1;
  var x$71 = this.$$undminOccurs$1;
  var x$72 = this.$$undmaxOccurs$1;
  var x$73 = this.$$undisHidden$1;
  var x$74 = this.$$undfallback$1;
  return jsx$1.updateOption__Lscopt_OptionDef__Lscopt_Read__Lscopt_OptionDef(this.copy__Lscopt_OptionParser__I__Lscopt_OptionDefKind__T__s_Option__s_Option__s_Option__T__F2__sc_Seq__sc_Seq__s_Option__I__I__Z__s_Option__Lscopt_OptionDef(x$60, x$61, x$62, x$63, x$64, x$65, x$66, x$67, x$59, x$68, x$69, x$70, x$71, x$72, x$73, x$74), this.evidence$13$1)
});
$c_Lscopt_OptionDef.prototype.argName__T = (function() {
  var x1 = this.kind$1;
  var x = $m_Lscopt_Arg$();
  if (((x === x1) && (this.$$undminOccurs$1 === 0))) {
    return (("[" + this.fullName__T()) + "]")
  } else {
    return this.fullName__T()
  }
});
$c_Lscopt_OptionDef.prototype.keyValueString__T = (function() {
  var this$1 = this.$$undkeyName$1;
  return (($as_T((this$1.isEmpty__Z() ? $m_Lscopt_OptionDef$().defaultKeyName$1 : this$1.get__O())) + "=") + this.valueString__T())
});
$c_Lscopt_OptionDef.prototype.text__T__Lscopt_OptionDef = (function(x) {
  var jsx$1 = this.$$undparser$1;
  var x$140 = this.$$undparser$1;
  var x$141 = this.$$undid$1;
  var x$142 = this.$$undkind$1;
  var x$143 = this.$$undname$1;
  var x$144 = this.$$undshortOpt$1;
  var x$145 = this.$$undkeyName$1;
  var x$146 = this.$$undvalueName$1;
  var x$147 = this.$$undaction$1;
  var x$148 = this.$$undvalidations$1;
  var x$149 = this.$$undconfigValidations$1;
  var x$150 = this.$$undparentId$1;
  var x$151 = this.$$undminOccurs$1;
  var x$152 = this.$$undmaxOccurs$1;
  var x$153 = this.$$undisHidden$1;
  var x$154 = this.$$undfallback$1;
  return jsx$1.updateOption__Lscopt_OptionDef__Lscopt_Read__Lscopt_OptionDef(this.copy__Lscopt_OptionParser__I__Lscopt_OptionDefKind__T__s_Option__s_Option__s_Option__T__F2__sc_Seq__sc_Seq__s_Option__I__I__Z__s_Option__Lscopt_OptionDef(x$140, x$141, x$142, x$143, x$144, x$145, x$146, x, x$147, x$148, x$149, x$150, x$151, x$152, x$153, x$154), this.evidence$13$1)
});
$c_Lscopt_OptionDef.prototype.minOccurs__I__Lscopt_OptionDef = (function(n) {
  var jsx$1 = this.$$undparser$1;
  var x$108 = this.$$undparser$1;
  var x$109 = this.$$undid$1;
  var x$110 = this.$$undkind$1;
  var x$111 = this.$$undname$1;
  var x$112 = this.$$undshortOpt$1;
  var x$113 = this.$$undkeyName$1;
  var x$114 = this.$$undvalueName$1;
  var x$115 = this.$$unddesc$1;
  var x$116 = this.$$undaction$1;
  var x$117 = this.$$undvalidations$1;
  var x$118 = this.$$undconfigValidations$1;
  var x$119 = this.$$undparentId$1;
  var x$120 = this.$$undmaxOccurs$1;
  var x$121 = this.$$undisHidden$1;
  var x$122 = this.$$undfallback$1;
  return jsx$1.updateOption__Lscopt_OptionDef__Lscopt_Read__Lscopt_OptionDef(this.copy__Lscopt_OptionParser__I__Lscopt_OptionDefKind__T__s_Option__s_Option__s_Option__T__F2__sc_Seq__sc_Seq__s_Option__I__I__Z__s_Option__Lscopt_OptionDef(x$108, x$109, x$110, x$111, x$112, x$113, x$114, x$115, x$116, x$117, x$118, x$119, n, x$120, x$121, x$122), this.evidence$13$1)
});
$c_Lscopt_OptionDef.prototype.usage__T = (function() {
  var rc11 = false;
  var x7 = null;
  var x1 = this.kind$1;
  var x = $m_Lscopt_Head$();
  if ((x === x1)) {
    var jsx$1 = true
  } else {
    var x$3 = $m_Lscopt_Note$();
    if ((x$3 === x1)) {
      var jsx$1 = true
    } else {
      var x$5 = $m_Lscopt_Check$();
      var jsx$1 = (x$5 === x1)
    }
  };
  if (jsx$1) {
    return this.$$unddesc$1
  };
  var x$7 = $m_Lscopt_Cmd$();
  if ((x$7 === x1)) {
    return ((("Command: " + this.$$undparser$1.commandExample__s_Option__T(new $c_s_Some().init___O(this))) + $m_Lscopt_OptionDef$().NL$1) + this.$$unddesc$1)
  };
  var x$9 = $m_Lscopt_Arg$();
  if ((x$9 === x1)) {
    return (((("" + $m_Lscopt_OptionDef$().WW$1) + this.name$1) + $m_Lscopt_OptionDef$().NLTB$1) + this.$$unddesc$1)
  };
  var x$11 = $m_Lscopt_Opt$();
  if ((x$11 === x1)) {
    rc11 = true;
    x7 = x1;
    if ((this.read__p1__Lscopt_Read().arity__I() === 2)) {
      var jsx$2 = $m_Lscopt_OptionDef$().WW$1;
      var this$1 = this.$$undshortOpt$1;
      if (this$1.isEmpty__Z()) {
        var this$2 = $m_s_None$()
      } else {
        var arg1 = this$1.get__O();
        var o = $as_T(arg1);
        var this$2 = new $c_s_Some().init___O((((("-" + o) + ":") + this.keyValueString__T()) + " | "))
      };
      return ((((((("" + jsx$2) + (this$2.isEmpty__Z() ? "" : this$2.get__O())) + this.fullName__T()) + ":") + this.keyValueString__T()) + $m_Lscopt_OptionDef$().NLTB$1) + this.$$unddesc$1)
    }
  };
  if ((rc11 && (this.read__p1__Lscopt_Read().arity__I() === 1))) {
    var jsx$3 = $m_Lscopt_OptionDef$().WW$1;
    var this$3 = this.$$undshortOpt$1;
    if (this$3.isEmpty__Z()) {
      var this$4 = $m_s_None$()
    } else {
      var arg1$1 = this$3.get__O();
      var o$3 = $as_T(arg1$1);
      var this$4 = new $c_s_Some().init___O((((("-" + o$3) + " ") + this.valueString__T()) + " | "))
    };
    return ((((((("" + jsx$3) + (this$4.isEmpty__Z() ? "" : this$4.get__O())) + this.fullName__T()) + " ") + this.valueString__T()) + $m_Lscopt_OptionDef$().NLTB$1) + this.$$unddesc$1)
  };
  if (rc11) {
    var jsx$4 = $m_Lscopt_OptionDef$().WW$1;
    var this$5 = this.$$undshortOpt$1;
    if (this$5.isEmpty__Z()) {
      var this$6 = $m_s_None$()
    } else {
      var arg1$2 = this$5.get__O();
      var o$4 = $as_T(arg1$2);
      var this$6 = new $c_s_Some().init___O((("-" + o$4) + " | "))
    };
    return ((((("" + jsx$4) + (this$6.isEmpty__Z() ? "" : this$6.get__O())) + this.fullName__T()) + $m_Lscopt_OptionDef$().NLTB$1) + this.$$unddesc$1)
  };
  throw new $c_s_MatchError().init___O(x1)
});
$c_Lscopt_OptionDef.prototype.init___Lscopt_OptionParser__I__Lscopt_OptionDefKind__T__s_Option__s_Option__s_Option__T__F2__sc_Seq__sc_Seq__s_Option__I__I__Z__s_Option__Lscopt_Read = (function(_parser, _id, _kind, _name, _shortOpt, _keyName, _valueName, _desc, _action, _validations, _configValidations, _parentId, _minOccurs, _maxOccurs, _isHidden, _fallback, evidence$13) {
  this.$$undparser$1 = _parser;
  this.$$undid$1 = _id;
  this.$$undkind$1 = _kind;
  this.$$undname$1 = _name;
  this.$$undshortOpt$1 = _shortOpt;
  this.$$undkeyName$1 = _keyName;
  this.$$undvalueName$1 = _valueName;
  this.$$unddesc$1 = _desc;
  this.$$undaction$1 = _action;
  this.$$undvalidations$1 = _validations;
  this.$$undconfigValidations$1 = _configValidations;
  this.$$undparentId$1 = _parentId;
  this.$$undminOccurs$1 = _minOccurs;
  this.$$undmaxOccurs$1 = _maxOccurs;
  this.$$undisHidden$1 = _isHidden;
  this.$$undfallback$1 = _fallback;
  this.evidence$13$1 = evidence$13;
  this.kind$1 = _kind;
  this.id$1 = _id;
  this.name$1 = _name;
  return this
});
$c_Lscopt_OptionDef.prototype.shortDescription__T = (function() {
  var x1 = this.kind$1;
  var x = $m_Lscopt_Opt$();
  if ((x === x1)) {
    return ("option " + this.fullName__T())
  } else {
    var x$3 = $m_Lscopt_Cmd$();
    if ((x$3 === x1)) {
      return ("command " + this.fullName__T())
    } else {
      return ("argument " + this.fullName__T())
    }
  }
});
$c_Lscopt_OptionDef.prototype.abbr__T__Lscopt_OptionDef = (function(x) {
  var jsx$1 = this.$$undparser$1;
  var x$91 = new $c_s_Some().init___O(x);
  var x$92 = this.$$undparser$1;
  var x$93 = this.$$undid$1;
  var x$94 = this.$$undkind$1;
  var x$95 = this.$$undname$1;
  var x$96 = this.$$undkeyName$1;
  var x$97 = this.$$undvalueName$1;
  var x$98 = this.$$unddesc$1;
  var x$99 = this.$$undaction$1;
  var x$100 = this.$$undvalidations$1;
  var x$101 = this.$$undconfigValidations$1;
  var x$102 = this.$$undparentId$1;
  var x$103 = this.$$undminOccurs$1;
  var x$104 = this.$$undmaxOccurs$1;
  var x$105 = this.$$undisHidden$1;
  var x$106 = this.$$undfallback$1;
  return jsx$1.updateOption__Lscopt_OptionDef__Lscopt_Read__Lscopt_OptionDef(this.copy__Lscopt_OptionParser__I__Lscopt_OptionDefKind__T__s_Option__s_Option__s_Option__T__F2__sc_Seq__sc_Seq__s_Option__I__I__Z__s_Option__Lscopt_OptionDef(x$92, x$93, x$94, x$95, x$91, x$96, x$97, x$98, x$99, x$100, x$101, x$102, x$103, x$104, x$105, x$106), this.evidence$13$1)
});
$c_Lscopt_OptionDef.prototype.valueString__T = (function() {
  var this$1 = this.$$undvalueName$1;
  return $as_T((this$1.isEmpty__Z() ? $m_Lscopt_OptionDef$().defaultValueName$1 : this$1.get__O()))
});
$c_Lscopt_OptionDef.prototype.shortOptOrBlank__T = (function() {
  var this$1 = this.$$undshortOpt$1;
  return $as_T((this$1.isEmpty__Z() ? "" : this$1.get__O()))
});
$c_Lscopt_OptionDef.prototype.usageColumn1__T = (function() {
  var rc11 = false;
  var x7 = null;
  var x1 = this.kind$1;
  var x = $m_Lscopt_Head$();
  if ((x === x1)) {
    var jsx$1 = true
  } else {
    var x$3 = $m_Lscopt_Note$();
    if ((x$3 === x1)) {
      var jsx$1 = true
    } else {
      var x$5 = $m_Lscopt_Check$();
      var jsx$1 = (x$5 === x1)
    }
  };
  if (jsx$1) {
    return ""
  };
  var x$7 = $m_Lscopt_Cmd$();
  if ((x$7 === x1)) {
    return (("Command: " + this.$$undparser$1.commandExample__s_Option__T(new $c_s_Some().init___O(this))) + $m_Lscopt_OptionDef$().NL$1)
  };
  var x$9 = $m_Lscopt_Arg$();
  if ((x$9 === x1)) {
    return (("" + $m_Lscopt_OptionDef$().WW$1) + this.name$1)
  };
  var x$11 = $m_Lscopt_Opt$();
  if ((x$11 === x1)) {
    rc11 = true;
    x7 = x1;
    if ((this.read__p1__Lscopt_Read().arity__I() === 2)) {
      var jsx$2 = $m_Lscopt_OptionDef$().WW$1;
      var this$1 = this.$$undshortOpt$1;
      if (this$1.isEmpty__Z()) {
        var this$2 = $m_s_None$()
      } else {
        var arg1 = this$1.get__O();
        var o = $as_T(arg1);
        var this$2 = new $c_s_Some().init___O((("-" + o) + ", "))
      };
      return ((((("" + jsx$2) + (this$2.isEmpty__Z() ? "" : this$2.get__O())) + this.fullName__T()) + ":") + this.keyValueString__T())
    }
  };
  if ((rc11 && (this.read__p1__Lscopt_Read().arity__I() === 1))) {
    var jsx$3 = $m_Lscopt_OptionDef$().WW$1;
    var this$3 = this.$$undshortOpt$1;
    if (this$3.isEmpty__Z()) {
      var this$4 = $m_s_None$()
    } else {
      var arg1$1 = this$3.get__O();
      var o$3 = $as_T(arg1$1);
      var this$4 = new $c_s_Some().init___O((("-" + o$3) + ", "))
    };
    return ((((("" + jsx$3) + (this$4.isEmpty__Z() ? "" : this$4.get__O())) + this.fullName__T()) + " ") + this.valueString__T())
  };
  if (rc11) {
    var jsx$4 = $m_Lscopt_OptionDef$().WW$1;
    var this$5 = this.$$undshortOpt$1;
    if (this$5.isEmpty__Z()) {
      var this$6 = $m_s_None$()
    } else {
      var arg1$2 = this$5.get__O();
      var o$4 = $as_T(arg1$2);
      var this$6 = new $c_s_Some().init___O((("-" + o$4) + ", "))
    };
    return ((("" + jsx$4) + (this$6.isEmpty__Z() ? "" : this$6.get__O())) + this.fullName__T())
  };
  throw new $c_s_MatchError().init___O(x1)
});
$c_Lscopt_OptionDef.prototype.usageTwoColumn__I__T = (function(col1Length) {
  var rc11 = false;
  var x7 = null;
  var x1 = this.kind$1;
  var x = $m_Lscopt_Head$();
  if ((x === x1)) {
    var jsx$1 = true
  } else {
    var x$3 = $m_Lscopt_Note$();
    if ((x$3 === x1)) {
      var jsx$1 = true
    } else {
      var x$5 = $m_Lscopt_Check$();
      var jsx$1 = (x$5 === x1)
    }
  };
  if (jsx$1) {
    return this.$$unddesc$1
  };
  var x$7 = $m_Lscopt_Cmd$();
  if ((x$7 === x1)) {
    return (("" + this.usageColumn1__T()) + this.$$unddesc$1)
  };
  var x$9 = $m_Lscopt_Arg$();
  if ((x$9 === x1)) {
    return (("" + this.spaceToDesc$1__p1__T__I__T((("" + this.usageColumn1__T()) + $m_Lscopt_OptionDef$().WW$1), col1Length)) + this.$$unddesc$1)
  };
  var x$11 = $m_Lscopt_Opt$();
  if ((x$11 === x1)) {
    rc11 = true;
    x7 = x1;
    if ((this.read__p1__Lscopt_Read().arity__I() === 2)) {
      return (("" + this.spaceToDesc$1__p1__T__I__T((("" + this.usageColumn1__T()) + $m_Lscopt_OptionDef$().WW$1), col1Length)) + this.$$unddesc$1)
    }
  };
  if ((rc11 && (this.read__p1__Lscopt_Read().arity__I() === 1))) {
    return (("" + this.spaceToDesc$1__p1__T__I__T((("" + this.usageColumn1__T()) + $m_Lscopt_OptionDef$().WW$1), col1Length)) + this.$$unddesc$1)
  };
  if (rc11) {
    return (("" + this.spaceToDesc$1__p1__T__I__T((("" + this.usageColumn1__T()) + $m_Lscopt_OptionDef$().WW$1), col1Length)) + this.$$unddesc$1)
  };
  throw new $c_s_MatchError().init___O(x1)
});
$c_Lscopt_OptionDef.prototype.longOptTokens__T__I = (function(arg) {
  if ((arg === this.fullName__T())) {
    var this$1 = this.read__p1__Lscopt_Read();
    return ((1 + $f_Lscopt_Read__tokensToRead__I(this$1)) | 0)
  } else {
    var prefix = (this.fullName__T() + ":");
    if ((($uI(arg.length) >= 0) && ($as_T(arg.substring(0, $uI(prefix.length))) === prefix))) {
      var jsx$1 = true
    } else {
      var prefix$1 = (this.fullName__T() + "=");
      var jsx$1 = (($uI(arg.length) >= 0) && ($as_T(arg.substring(0, $uI(prefix$1.length))) === prefix$1))
    };
    if (jsx$1) {
      return 1
    } else {
      return 0
    }
  }
});
$c_Lscopt_OptionDef.prototype.valueName__T__Lscopt_OptionDef = (function(x) {
  var jsx$1 = this.$$undparser$1;
  var x$155 = new $c_s_Some().init___O(x);
  var x$156 = this.$$undparser$1;
  var x$157 = this.$$undid$1;
  var x$158 = this.$$undkind$1;
  var x$159 = this.$$undname$1;
  var x$160 = this.$$undshortOpt$1;
  var x$161 = this.$$undkeyName$1;
  var x$162 = this.$$unddesc$1;
  var x$163 = this.$$undaction$1;
  var x$164 = this.$$undvalidations$1;
  var x$165 = this.$$undconfigValidations$1;
  var x$166 = this.$$undparentId$1;
  var x$167 = this.$$undminOccurs$1;
  var x$168 = this.$$undmaxOccurs$1;
  var x$169 = this.$$undisHidden$1;
  var x$170 = this.$$undfallback$1;
  return jsx$1.updateOption__Lscopt_OptionDef__Lscopt_Read__Lscopt_OptionDef(this.copy__Lscopt_OptionParser__I__Lscopt_OptionDefKind__T__s_Option__s_Option__s_Option__T__F2__sc_Seq__sc_Seq__s_Option__I__I__Z__s_Option__Lscopt_OptionDef(x$156, x$157, x$158, x$159, x$160, x$161, x$155, x$162, x$163, x$164, x$165, x$166, x$167, x$168, x$169, x$170), this.evidence$13$1)
});
$c_Lscopt_OptionDef.prototype.parent__Lscopt_OptionDef__Lscopt_OptionDef = (function(x) {
  var jsx$1 = this.$$undparser$1;
  var x$235 = new $c_s_Some().init___O(x.id$1);
  var x$236 = this.$$undparser$1;
  var x$237 = this.$$undid$1;
  var x$238 = this.$$undkind$1;
  var x$239 = this.$$undname$1;
  var x$240 = this.$$undshortOpt$1;
  var x$241 = this.$$undkeyName$1;
  var x$242 = this.$$undvalueName$1;
  var x$243 = this.$$unddesc$1;
  var x$244 = this.$$undaction$1;
  var x$245 = this.$$undvalidations$1;
  var x$246 = this.$$undconfigValidations$1;
  var x$247 = this.$$undminOccurs$1;
  var x$248 = this.$$undmaxOccurs$1;
  var x$249 = this.$$undisHidden$1;
  var x$250 = this.$$undfallback$1;
  return jsx$1.updateOption__Lscopt_OptionDef__Lscopt_Read__Lscopt_OptionDef(this.copy__Lscopt_OptionParser__I__Lscopt_OptionDefKind__T__s_Option__s_Option__s_Option__T__F2__sc_Seq__sc_Seq__s_Option__I__I__Z__s_Option__Lscopt_OptionDef(x$236, x$237, x$238, x$239, x$240, x$241, x$242, x$243, x$244, x$245, x$246, x$235, x$247, x$248, x$249, x$250), this.evidence$13$1)
});
$c_Lscopt_OptionDef.prototype.validateConfig__F1__Lscopt_OptionDef = (function(f) {
  var jsx$2 = this.$$undparser$1;
  var jsx$1 = this.$$undconfigValidations$1;
  var this$1 = $m_sc_Seq$();
  var x$43 = $as_sc_Seq(jsx$1.$$colon$plus__O__scg_CanBuildFrom__O(f, this$1.ReusableCBFInstance$2));
  var x$44 = this.$$undparser$1;
  var x$45 = this.$$undid$1;
  var x$46 = this.$$undkind$1;
  var x$47 = this.$$undname$1;
  var x$48 = this.$$undshortOpt$1;
  var x$49 = this.$$undkeyName$1;
  var x$50 = this.$$undvalueName$1;
  var x$51 = this.$$unddesc$1;
  var x$52 = this.$$undaction$1;
  var x$53 = this.$$undvalidations$1;
  var x$54 = this.$$undparentId$1;
  var x$55 = this.$$undminOccurs$1;
  var x$56 = this.$$undmaxOccurs$1;
  var x$57 = this.$$undisHidden$1;
  var x$58 = this.$$undfallback$1;
  return jsx$2.updateOption__Lscopt_OptionDef__Lscopt_Read__Lscopt_OptionDef(this.copy__Lscopt_OptionParser__I__Lscopt_OptionDefKind__T__s_Option__s_Option__s_Option__T__F2__sc_Seq__sc_Seq__s_Option__I__I__Z__s_Option__Lscopt_OptionDef(x$44, x$45, x$46, x$47, x$48, x$49, x$50, x$51, x$52, x$53, x$43, x$54, x$55, x$56, x$57, x$58), this.evidence$13$1)
});
$c_Lscopt_OptionDef.prototype.fullName__T = (function() {
  var x1 = this.kind$1;
  var x = $m_Lscopt_Opt$();
  if ((x === x1)) {
    return ("--" + this.name$1)
  } else {
    return this.name$1
  }
});
$c_Lscopt_OptionDef.prototype.maxOccurs__I__Lscopt_OptionDef = (function(n) {
  var jsx$1 = this.$$undparser$1;
  var x$124 = this.$$undparser$1;
  var x$125 = this.$$undid$1;
  var x$126 = this.$$undkind$1;
  var x$127 = this.$$undname$1;
  var x$128 = this.$$undshortOpt$1;
  var x$129 = this.$$undkeyName$1;
  var x$130 = this.$$undvalueName$1;
  var x$131 = this.$$unddesc$1;
  var x$132 = this.$$undaction$1;
  var x$133 = this.$$undvalidations$1;
  var x$134 = this.$$undconfigValidations$1;
  var x$135 = this.$$undparentId$1;
  var x$136 = this.$$undminOccurs$1;
  var x$137 = this.$$undisHidden$1;
  var x$138 = this.$$undfallback$1;
  return jsx$1.updateOption__Lscopt_OptionDef__Lscopt_Read__Lscopt_OptionDef(this.copy__Lscopt_OptionParser__I__Lscopt_OptionDefKind__T__s_Option__s_Option__s_Option__T__F2__sc_Seq__sc_Seq__s_Option__I__I__Z__s_Option__Lscopt_OptionDef(x$124, x$125, x$126, x$127, x$128, x$129, x$130, x$131, x$132, x$133, x$134, x$135, x$136, n, x$137, x$138), this.evidence$13$1)
});
$c_Lscopt_OptionDef.prototype.hasParent__Z = (function() {
  return this.$$undparentId$1.isDefined__Z()
});
$c_Lscopt_OptionDef.prototype.init___Lscopt_OptionParser__Lscopt_OptionDefKind__T__Lscopt_Read = (function(parser, kind, name, evidence$14) {
  var this$1 = $m_Lscopt_OptionDef$();
  var this$2 = this$1.atomic$1;
  var newValue = ((1 + this$2.java$util$concurrent$atomic$AtomicInteger$$value$f) | 0);
  this$2.java$util$concurrent$atomic$AtomicInteger$$value$f = newValue;
  $c_Lscopt_OptionDef.prototype.init___Lscopt_OptionParser__I__Lscopt_OptionDefKind__T__s_Option__s_Option__s_Option__T__F2__sc_Seq__sc_Seq__s_Option__I__I__Z__s_Option__Lscopt_Read.call(this, parser, newValue, kind, name, $m_s_None$(), $m_s_None$(), $m_s_None$(), "", new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(a$2, c$2) {
    return c$2
  })), $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), $m_s_None$(), 0, 1, false, $m_s_None$(), evidence$14);
  return this
});
$c_Lscopt_OptionDef.prototype.spaceToDesc$1__p1__T__I__T = (function(str, col1Length$1) {
  if (($uI(str.length) <= col1Length$1)) {
    var this$4 = new $c_sci_StringOps().init___T(" ");
    var n = ((col1Length$1 - $uI(str.length)) | 0);
    return (("" + str) + $f_sci_StringLike__$$times__I__T(this$4, n))
  } else {
    var this$7 = new $c_sci_StringOps().init___T(str);
    var thiz = $m_Lscopt_OptionDef$().WW$1;
    var n$1 = $uI(thiz.length);
    var jsx$2 = $as_T($f_sc_IndexedSeqOptimized__dropRight__I__O(this$7, n$1));
    var jsx$1 = $m_Lscopt_OptionDef$().NL$1;
    var this$9 = new $c_sci_StringOps().init___T(" ");
    return ((("" + jsx$2) + jsx$1) + $f_sci_StringLike__$$times__I__T(this$9, col1Length$1))
  }
});
$c_Lscopt_OptionDef.prototype.shortOptTokens__T__I = (function(arg) {
  var rc6 = false;
  var x2 = null;
  var x1 = this.$$undshortOpt$1;
  if ((x1 instanceof $c_s_Some)) {
    rc6 = true;
    x2 = $as_s_Some(x1);
    if ((arg === ("-" + this.shortOptOrBlank__T()))) {
      var this$1 = this.read__p1__Lscopt_Read();
      return ((1 + $f_Lscopt_Read__tokensToRead__I(this$1)) | 0)
    }
  };
  if (rc6) {
    var prefix = (("-" + this.shortOptOrBlank__T()) + ":");
    var jsx$1 = (($uI(arg.length) >= 0) && ($as_T(arg.substring(0, $uI(prefix.length))) === prefix))
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return 1
  };
  if (rc6) {
    var prefix$1 = (("-" + this.shortOptOrBlank__T()) + "=");
    var jsx$2 = (($uI(arg.length) >= 0) && ($as_T(arg.substring(0, $uI(prefix$1.length))) === prefix$1))
  } else {
    var jsx$2 = false
  };
  if (jsx$2) {
    return 1
  };
  return 0
});
$c_Lscopt_OptionDef.prototype.read__p1__Lscopt_Read = (function() {
  var e = this.evidence$13$1;
  return e
});
$c_Lscopt_OptionDef.prototype.hasFallback__Z = (function() {
  return this.$$undfallback$1.isDefined__Z()
});
$c_Lscopt_OptionDef.prototype.apply__I__sc_Seq__s_util_Either = (function(i, args) {
  if ((i >= args.length__I())) {
    var jsx$1 = true
  } else {
    var x = this.kind$1;
    var x$2 = $m_Lscopt_Opt$();
    var jsx$1 = (!((x !== null) && (x === x$2)))
  };
  if (jsx$1) {
    $m_s_package$();
    return new $c_s_util_Left().init___O("Option does not match")
  } else {
    var x1 = $as_T(args.apply__I__O(i));
    if (((this.longOptTokens__T__I(x1) === 2) || (this.shortOptTokens__T__I(x1) === 2))) {
      var this$2 = this.token__I__sc_Seq__s_Option(((1 + i) | 0), args);
      if (this$2.isEmpty__Z()) {
        var this$4 = $m_s_None$()
      } else {
        var arg1 = this$2.get__O();
        var x$42 = $as_T(arg1);
        $m_s_package$();
        var this$4 = new $c_s_Some().init___O(new $c_s_util_Right().init___O(x$42))
      };
      if (this$4.isEmpty__Z()) {
        $m_s_package$();
        var value = ("Missing value after " + x1);
        var jsx$2 = new $c_s_util_Left().init___O(value)
      } else {
        var jsx$2 = this$4.get__O()
      };
      return $as_s_util_Either(jsx$2)
    } else {
      if ((this.longOptTokens__T__I(x1) === 1)) {
        var this$6 = this.read__p1__Lscopt_Read();
        var jsx$3 = ($f_Lscopt_Read__tokensToRead__I(this$6) === 1)
      } else {
        var jsx$3 = false
      };
      if (jsx$3) {
        $m_s_package$();
        var this$9 = new $c_sci_StringOps().init___T(x1);
        var thiz = (this.fullName__T() + ":");
        var n = $uI(thiz.length);
        var $$this = this$9.repr$1;
        var until = $uI($$this.length);
        var value$1 = $m_sci_StringOps$().slice$extension__T__I__I__T(this$9.repr$1, n, until);
        return new $c_s_util_Right().init___O(value$1)
      } else {
        if ((this.shortOptTokens__T__I(x1) === 1)) {
          var this$13 = this.read__p1__Lscopt_Read();
          var jsx$4 = ($f_Lscopt_Read__tokensToRead__I(this$13) === 1)
        } else {
          var jsx$4 = false
        };
        if (jsx$4) {
          $m_s_package$();
          var this$16 = new $c_sci_StringOps().init___T(x1);
          var thiz$1 = (("-" + this.shortOptOrBlank__T()) + ":");
          var n$1 = $uI(thiz$1.length);
          var $$this$1 = this$16.repr$1;
          var until$1 = $uI($$this$1.length);
          var value$2 = $m_sci_StringOps$().slice$extension__T__I__I__T(this$16.repr$1, n$1, until$1);
          return new $c_s_util_Right().init___O(value$2)
        } else {
          $m_s_package$();
          return new $c_s_util_Right().init___O("")
        }
      }
    }
  }
});
$c_Lscopt_OptionDef.prototype.getFallback__O = (function() {
  return $as_F0(this.$$undfallback$1.get__O()).apply__O()
});
function $as_Lscopt_OptionDef(obj) {
  return (((obj instanceof $c_Lscopt_OptionDef) || (obj === null)) ? obj : $throwClassCastException(obj, "scopt.OptionDef"))
}
function $isArrayOf_Lscopt_OptionDef(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lscopt_OptionDef)))
}
function $asArrayOf_Lscopt_OptionDef(obj, depth) {
  return (($isArrayOf_Lscopt_OptionDef(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscopt.OptionDef;", depth))
}
var $d_Lscopt_OptionDef = new $TypeData().initClass({
  Lscopt_OptionDef: 0
}, false, "scopt.OptionDef", {
  Lscopt_OptionDef: 1,
  O: 1
});
$c_Lscopt_OptionDef.prototype.$classData = $d_Lscopt_OptionDef;
/** @constructor */
function $c_Lscopt_OptionDef$() {
  $c_O.call(this);
  this.UNBOUNDED$1 = 0;
  this.NL$1 = null;
  this.WW$1 = null;
  this.TB$1 = null;
  this.NLTB$1 = null;
  this.NLNL$1 = null;
  this.column1MaxLength$1 = 0;
  this.defaultKeyName$1 = null;
  this.defaultValueName$1 = null;
  this.atomic$1 = null
}
$c_Lscopt_OptionDef$.prototype = new $h_O();
$c_Lscopt_OptionDef$.prototype.constructor = $c_Lscopt_OptionDef$;
/** @constructor */
function $h_Lscopt_OptionDef$() {
  /*<skip>*/
}
$h_Lscopt_OptionDef$.prototype = $c_Lscopt_OptionDef$.prototype;
$c_Lscopt_OptionDef$.prototype.init___ = (function() {
  $n_Lscopt_OptionDef$ = this;
  this.UNBOUNDED$1 = 2147483647;
  this.NL$1 = $m_Lscopt_platform$().$$undNL$1;
  this.WW$1 = "  ";
  this.TB$1 = "        ";
  this.NLTB$1 = (("" + this.NL$1) + this.TB$1);
  this.NLNL$1 = (("" + this.NL$1) + this.NL$1);
  var thiz = this.WW$1;
  this.column1MaxLength$1 = ((25 + $uI(thiz.length)) | 0);
  this.defaultKeyName$1 = "<key>";
  this.defaultValueName$1 = "<value>";
  this.atomic$1 = new $c_ju_concurrent_atomic_AtomicInteger().init___();
  return this
});
var $d_Lscopt_OptionDef$ = new $TypeData().initClass({
  Lscopt_OptionDef$: 0
}, false, "scopt.OptionDef$", {
  Lscopt_OptionDef$: 1,
  O: 1
});
$c_Lscopt_OptionDef$.prototype.$classData = $d_Lscopt_OptionDef$;
var $n_Lscopt_OptionDef$ = (void 0);
function $m_Lscopt_OptionDef$() {
  if ((!$n_Lscopt_OptionDef$)) {
    $n_Lscopt_OptionDef$ = new $c_Lscopt_OptionDef$().init___()
  };
  return $n_Lscopt_OptionDef$
}
/** @constructor */
function $c_Lscopt_OptionParser() {
  $c_O.call(this);
  this.programName$1 = null;
  this.options$1 = null;
  this.helpOptions$1 = null
}
$c_Lscopt_OptionParser.prototype = new $h_O();
$c_Lscopt_OptionParser.prototype.constructor = $c_Lscopt_OptionParser;
/** @constructor */
function $h_Lscopt_OptionParser() {
  /*<skip>*/
}
$h_Lscopt_OptionParser.prototype = $c_Lscopt_OptionParser.prototype;
$c_Lscopt_OptionParser.prototype.optionsForRender__sci_List = (function() {
  var this$1 = this.options$1;
  var f = (function($this) {
    return (function(o$2) {
      var o = $as_Lscopt_OptionDef(o$2);
      var x = o.kind$1;
      var x$2 = $m_Lscopt_Head$();
      if ((!((x !== null) && (x === x$2)))) {
        var x$3 = o.kind$1;
        var x$4 = $m_Lscopt_Check$();
        var jsx$1 = (!((x$3 !== null) && (x$3 === x$4)))
      } else {
        var jsx$1 = false
      };
      if (jsx$1) {
        return (!o.$$undisHidden$1)
      } else {
        return false
      }
    })
  })(this);
  if ((this$1 instanceof $c_sci_List)) {
    var x2 = $as_sci_List(this$1);
    var l = x2;
    var l$1 = l;
    x: {
      var result;
      _noneIn: while (true) {
        if (l$1.isEmpty__Z()) {
          var result = $m_sci_Nil$();
          break
        } else {
          var h = l$1.head__O();
          var t = $as_sci_List(l$1.tail__O());
          if (($uZ(f(h)) === false)) {
            l$1 = t;
            continue _noneIn
          };
          var start = l$1;
          var remaining = t;
          var remaining$1 = remaining;
          _allIn: while (true) {
            if (remaining$1.isEmpty__Z()) {
              var result = start;
              break x
            } else {
              var x$2$1 = remaining$1.head__O();
              if (($uZ(f(x$2$1)) !== false)) {
                remaining$1 = $as_sci_List(remaining$1.tail__O());
                continue _allIn
              };
              var firstMiss = remaining$1;
              var newHead = new $c_sci_$colon$colon().init___O__sci_List(start.head__O(), $m_sci_Nil$());
              var toProcess = $as_sci_List(start.tail__O());
              var currentLast = newHead;
              while ((toProcess !== firstMiss)) {
                var newElem = new $c_sci_$colon$colon().init___O__sci_List(toProcess.head__O(), $m_sci_Nil$());
                currentLast.tl$5 = newElem;
                currentLast = newElem;
                toProcess = $as_sci_List(toProcess.tail__O())
              };
              var next = $as_sci_List(firstMiss.tail__O());
              var nextToCopy = next;
              while ((!next.isEmpty__Z())) {
                var head = next.head__O();
                if (($uZ(f(head)) !== false)) {
                  next = $as_sci_List(next.tail__O())
                } else {
                  while ((nextToCopy !== next)) {
                    var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy.head__O(), $m_sci_Nil$());
                    currentLast.tl$5 = newElem$2;
                    currentLast = newElem$2;
                    nextToCopy = $as_sci_List(nextToCopy.tail__O())
                  };
                  nextToCopy = $as_sci_List(next.tail__O());
                  next = $as_sci_List(next.tail__O())
                }
              };
              if ((!nextToCopy.isEmpty__Z())) {
                currentLast.tl$5 = nextToCopy
              };
              var result = newHead;
              break x
            }
          }
        }
      }
    };
    var jsx$2 = result
  } else {
    $m_scm_ListBuffer$();
    var b = new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_ListBuffer().init___());
    var this$3 = this$1.scala$collection$mutable$ListBuffer$$start$6;
    var these = this$3;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      if (($uZ(f(arg1)) !== false)) {
        b.$$plus$eq__O__scm_GrowingBuilder(arg1)
      };
      these = $as_sci_List(these.tail__O())
    };
    var jsx$2 = b.elems$1
  };
  var unsorted = $as_scm_ListBuffer(jsx$2);
  $m_scm_ListBuffer$();
  var l$2 = new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_ListBuffer().init___());
  $m_scm_ListBuffer$();
  var r = new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_ListBuffer().init___());
  var this$6 = unsorted.scala$collection$mutable$ListBuffer$$start$6;
  var these$1 = this$6;
  while ((!these$1.isEmpty__Z())) {
    var arg1$1 = these$1.head__O();
    var x$16 = $as_Lscopt_OptionDef(arg1$1);
    if (x$16.hasParent__Z()) {
      var this$7 = l$2
    } else {
      var this$7 = r
    };
    this$7.$$plus$eq__O__scm_GrowingBuilder(arg1$1);
    these$1 = $as_sci_List(these$1.tail__O())
  };
  var _1 = l$2.elems$1;
  var _2 = r.elems$1;
  var p = $as_scm_ListBuffer(_1);
  var np = $as_scm_ListBuffer(_2);
  var this$8 = $as_scm_BufferLike($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var _1$1 = $as_scm_Buffer(this$8.clone__scm_Buffer().$$plus$plus$eq__sc_TraversableOnce__scg_Growable(p));
  var this$9 = $as_scm_BufferLike($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var _2$1 = $as_scm_Buffer(this$9.clone__scm_Buffer().$$plus$plus$eq__sc_TraversableOnce__scg_Growable(np));
  var remaining$2 = $as_scm_ListBuffer(_1$1);
  var sorted = $as_scm_ListBuffer(_2$1);
  var elem$1 = false;
  elem$1 = true;
  while (((!remaining$2.isEmpty__Z()) && elem$1)) {
    elem$1 = false;
    var this$11 = sorted.scala$collection$mutable$ListBuffer$$start$6;
    var these$2 = this$11;
    while ((!these$2.isEmpty__Z())) {
      var arg1$2 = these$2.head__O();
      var parent = $as_Lscopt_OptionDef(arg1$2);
      var f$1 = (function($this$1, parent$1) {
        return (function(x$18$2) {
          var x$18 = $as_Lscopt_OptionDef(x$18$2);
          var x$1 = x$18.$$undparentId$1;
          var x$2$2 = new $c_s_Some().init___O(parent$1.id$1);
          return ((x$1 !== null) && x$1.equals__O__Z(x$2$2))
        })
      })(this, parent);
      if ((remaining$2 instanceof $c_sci_List)) {
        var x2$1 = $as_sci_List(remaining$2);
        var l$3 = x2$1;
        var l$4 = l$3;
        x$2: {
          var result$1;
          _noneIn$1: while (true) {
            if (l$4.isEmpty__Z()) {
              var result$1 = $m_sci_Nil$();
              break
            } else {
              var h$1 = l$4.head__O();
              var t$1 = $as_sci_List(l$4.tail__O());
              if (($uZ(f$1(h$1)) === false)) {
                l$4 = t$1;
                continue _noneIn$1
              };
              var start$1 = l$4;
              var remaining$3 = t$1;
              var remaining$4 = remaining$3;
              _allIn$1: while (true) {
                if (remaining$4.isEmpty__Z()) {
                  var result$1 = start$1;
                  break x$2
                } else {
                  var x$2$3 = remaining$4.head__O();
                  if (($uZ(f$1(x$2$3)) !== false)) {
                    remaining$4 = $as_sci_List(remaining$4.tail__O());
                    continue _allIn$1
                  };
                  var firstMiss$1 = remaining$4;
                  var newHead$1 = new $c_sci_$colon$colon().init___O__sci_List(start$1.head__O(), $m_sci_Nil$());
                  var toProcess$1 = $as_sci_List(start$1.tail__O());
                  var currentLast$1 = newHead$1;
                  while ((toProcess$1 !== firstMiss$1)) {
                    var newElem$1 = new $c_sci_$colon$colon().init___O__sci_List(toProcess$1.head__O(), $m_sci_Nil$());
                    currentLast$1.tl$5 = newElem$1;
                    currentLast$1 = newElem$1;
                    toProcess$1 = $as_sci_List(toProcess$1.tail__O())
                  };
                  var next$1 = $as_sci_List(firstMiss$1.tail__O());
                  var nextToCopy$1 = next$1;
                  while ((!next$1.isEmpty__Z())) {
                    var head$1 = next$1.head__O();
                    if (($uZ(f$1(head$1)) !== false)) {
                      next$1 = $as_sci_List(next$1.tail__O())
                    } else {
                      while ((nextToCopy$1 !== next$1)) {
                        var newElem$2$1 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy$1.head__O(), $m_sci_Nil$());
                        currentLast$1.tl$5 = newElem$2$1;
                        currentLast$1 = newElem$2$1;
                        nextToCopy$1 = $as_sci_List(nextToCopy$1.tail__O())
                      };
                      nextToCopy$1 = $as_sci_List(next$1.tail__O());
                      next$1 = $as_sci_List(next$1.tail__O())
                    }
                  };
                  if ((!nextToCopy$1.isEmpty__Z())) {
                    currentLast$1.tl$5 = nextToCopy$1
                  };
                  var result$1 = newHead$1;
                  break x$2
                }
              }
            }
          }
        };
        var jsx$3 = result$1
      } else {
        $m_scm_ListBuffer$();
        var b$1 = new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_ListBuffer().init___());
        var this$13 = remaining$2.scala$collection$mutable$ListBuffer$$start$6;
        var these$3 = this$13;
        while ((!these$3.isEmpty__Z())) {
          var arg1$3 = these$3.head__O();
          if (($uZ(f$1(arg1$3)) !== false)) {
            b$1.$$plus$eq__O__scm_GrowingBuilder(arg1$3)
          };
          these$3 = $as_sci_List(these$3.tail__O())
        };
        var jsx$3 = b$1.elems$1
      };
      var childrenOfThisParent = $as_scm_ListBuffer(jsx$3);
      if (childrenOfThisParent.nonEmpty__Z()) {
        $f_scg_Shrinkable__$$minus$minus$eq__sc_TraversableOnce__scg_Shrinkable(remaining$2, childrenOfThisParent);
        var this$14 = sorted.scala$collection$mutable$ListBuffer$$start$6;
        sorted.insertAll__I__sc_Traversable__V(((1 + $f_sc_GenSeqLike__indexOf__O__I__I(this$14, parent, 0)) | 0), childrenOfThisParent);
        elem$1 = true
      };
      these$2 = $as_sci_List(these$2.tail__O())
    }
  };
  return sorted.toList__sci_List()
});
$c_Lscopt_OptionParser.prototype.checks__sc_Seq = (function() {
  var this$1 = this.options$1;
  var this$2 = this$1.scala$collection$mutable$ListBuffer$$start$6;
  var f = (function($this) {
    return (function(x$29$2) {
      var x$29 = $as_Lscopt_OptionDef(x$29$2);
      var x = x$29.kind$1;
      var x$2 = $m_Lscopt_Check$();
      return ((x !== null) && (x === x$2))
    })
  })(this);
  if ((this$2 !== null)) {
    var l = this$2;
    var l$1 = l;
    x: {
      var result;
      _noneIn: while (true) {
        if (l$1.isEmpty__Z()) {
          var result = $m_sci_Nil$();
          break
        } else {
          var h = l$1.head__O();
          var t = $as_sci_List(l$1.tail__O());
          if (($uZ(f(h)) === false)) {
            l$1 = t;
            continue _noneIn
          };
          var start = l$1;
          var remaining = t;
          var remaining$1 = remaining;
          _allIn: while (true) {
            if (remaining$1.isEmpty__Z()) {
              var result = start;
              break x
            } else {
              var x$2$1 = remaining$1.head__O();
              if (($uZ(f(x$2$1)) !== false)) {
                remaining$1 = $as_sci_List(remaining$1.tail__O());
                continue _allIn
              };
              var firstMiss = remaining$1;
              var newHead = new $c_sci_$colon$colon().init___O__sci_List(start.head__O(), $m_sci_Nil$());
              var toProcess = $as_sci_List(start.tail__O());
              var currentLast = newHead;
              while ((toProcess !== firstMiss)) {
                var newElem = new $c_sci_$colon$colon().init___O__sci_List(toProcess.head__O(), $m_sci_Nil$());
                currentLast.tl$5 = newElem;
                currentLast = newElem;
                toProcess = $as_sci_List(toProcess.tail__O())
              };
              var next = $as_sci_List(firstMiss.tail__O());
              var nextToCopy = next;
              while ((!next.isEmpty__Z())) {
                var head = next.head__O();
                if (($uZ(f(head)) !== false)) {
                  next = $as_sci_List(next.tail__O())
                } else {
                  while ((nextToCopy !== next)) {
                    var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy.head__O(), $m_sci_Nil$());
                    currentLast.tl$5 = newElem$2;
                    currentLast = newElem$2;
                    nextToCopy = $as_sci_List(nextToCopy.tail__O())
                  };
                  nextToCopy = $as_sci_List(next.tail__O());
                  next = $as_sci_List(next.tail__O())
                }
              };
              if ((!nextToCopy.isEmpty__Z())) {
                currentLast.tl$5 = nextToCopy
              };
              var result = newHead;
              break x
            }
          }
        }
      }
    };
    return result
  } else {
    $m_sci_List$();
    var b = new $c_scm_ListBuffer().init___();
    var these = this$2;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      if (($uZ(f(arg1)) !== false)) {
        b.$$plus$eq__O__scm_ListBuffer(arg1)
      };
      these = $as_sci_List(these.tail__O())
    };
    return b.toList__sci_List()
  }
});
$c_Lscopt_OptionParser.prototype.reportError__T__V = (function(msg) {
  var this$1 = $m_s_Console$();
  $as_Ljava_io_PrintStream(this$1.errVar$2.v$1).println__T__V(("Error: " + msg))
});
$c_Lscopt_OptionParser.prototype.heads__sc_Seq = (function() {
  var this$1 = this.options$1;
  var this$2 = this$1.scala$collection$mutable$ListBuffer$$start$6;
  var f = (function($this) {
    return (function(x$26$2) {
      var x$26 = $as_Lscopt_OptionDef(x$26$2);
      var x = x$26.kind$1;
      var x$2 = $m_Lscopt_Head$();
      return ((x !== null) && (x === x$2))
    })
  })(this);
  if ((this$2 !== null)) {
    var l = this$2;
    var l$1 = l;
    x: {
      var result;
      _noneIn: while (true) {
        if (l$1.isEmpty__Z()) {
          var result = $m_sci_Nil$();
          break
        } else {
          var h = l$1.head__O();
          var t = $as_sci_List(l$1.tail__O());
          if (($uZ(f(h)) === false)) {
            l$1 = t;
            continue _noneIn
          };
          var start = l$1;
          var remaining = t;
          var remaining$1 = remaining;
          _allIn: while (true) {
            if (remaining$1.isEmpty__Z()) {
              var result = start;
              break x
            } else {
              var x$2$1 = remaining$1.head__O();
              if (($uZ(f(x$2$1)) !== false)) {
                remaining$1 = $as_sci_List(remaining$1.tail__O());
                continue _allIn
              };
              var firstMiss = remaining$1;
              var newHead = new $c_sci_$colon$colon().init___O__sci_List(start.head__O(), $m_sci_Nil$());
              var toProcess = $as_sci_List(start.tail__O());
              var currentLast = newHead;
              while ((toProcess !== firstMiss)) {
                var newElem = new $c_sci_$colon$colon().init___O__sci_List(toProcess.head__O(), $m_sci_Nil$());
                currentLast.tl$5 = newElem;
                currentLast = newElem;
                toProcess = $as_sci_List(toProcess.tail__O())
              };
              var next = $as_sci_List(firstMiss.tail__O());
              var nextToCopy = next;
              while ((!next.isEmpty__Z())) {
                var head = next.head__O();
                if (($uZ(f(head)) !== false)) {
                  next = $as_sci_List(next.tail__O())
                } else {
                  while ((nextToCopy !== next)) {
                    var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy.head__O(), $m_sci_Nil$());
                    currentLast.tl$5 = newElem$2;
                    currentLast = newElem$2;
                    nextToCopy = $as_sci_List(nextToCopy.tail__O())
                  };
                  nextToCopy = $as_sci_List(next.tail__O());
                  next = $as_sci_List(next.tail__O())
                }
              };
              if ((!nextToCopy.isEmpty__Z())) {
                currentLast.tl$5 = nextToCopy
              };
              var result = newHead;
              break x
            }
          }
        }
      }
    };
    return result
  } else {
    $m_sci_List$();
    var b = new $c_scm_ListBuffer().init___();
    var these = this$2;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      if (($uZ(f(arg1)) !== false)) {
        b.$$plus$eq__O__scm_ListBuffer(arg1)
      };
      these = $as_sci_List(these.tail__O())
    };
    return b.toList__sci_List()
  }
});
$c_Lscopt_OptionParser.prototype.oxford$1__p1__sci_List__T = (function(xs) {
  if ((xs instanceof $c_sci_$colon$colon)) {
    var x2 = $as_sci_$colon$colon(xs);
    var a = $as_T(x2.head$5);
    var p3 = x2.tl$5;
    if ((p3 instanceof $c_sci_$colon$colon)) {
      var x4 = $as_sci_$colon$colon(p3);
      var b = $as_T(x4.head$5);
      var p5 = x4.tl$5;
      var x = $m_sci_Nil$();
      if (x.equals__O__Z(p5)) {
        return ((a + " or ") + b)
      }
    }
  };
  var this$3 = $f_sc_LinearSeqOptimized__dropRight__I__sc_LinearSeqOptimized(xs, 2);
  var this$1 = xs.takeRight__I__sci_List(2);
  var elem = $f_sc_TraversableOnce__mkString__T__T__T__T(this$1, "", ", or ", "");
  var this$2 = $m_sci_List$();
  var bf = this$2.ReusableCBFInstance$2;
  return $as_sc_TraversableOnce($f_sc_SeqLike__$$colon$plus__O__scg_CanBuildFrom__O(this$3, elem, bf)).mkString__T__T(", ")
});
$c_Lscopt_OptionParser.prototype.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef = (function(kind, name, evidence$11) {
  return this.updateOption__Lscopt_OptionDef__Lscopt_Read__Lscopt_OptionDef(new $c_Lscopt_OptionDef().init___Lscopt_OptionParser__Lscopt_OptionDefKind__T__Lscopt_Read(this, kind, name, evidence$11), evidence$11)
});
$c_Lscopt_OptionParser.prototype.parse__sc_Seq__O__s_Option = (function(args, init) {
  var elem$1 = 0;
  elem$1 = 0;
  var this$2 = $as_scm_BufferLike($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var xs = $as_sc_GenTraversableOnce(this.nonArgs__sc_Seq().filterNot__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$31$2) {
      var x$31 = $as_Lscopt_OptionDef(x$31$2);
      return x$31.hasParent__Z()
    })
  })(this))));
  var pendingOptions = $as_scm_ListBuffer($as_scm_Buffer(this$2.clone__scm_Buffer().$$plus$plus$eq__sc_TraversableOnce__scg_Growable(xs.seq__sc_TraversableOnce())));
  var this$3 = $as_scm_BufferLike($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var xs$1 = $as_sc_GenTraversableOnce(this.arguments__sc_Seq().filterNot__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$32$2) {
      var x$32 = $as_Lscopt_OptionDef(x$32$2);
      return x$32.hasParent__Z()
    })
  })(this))));
  var pendingArgs = $as_scm_ListBuffer($as_scm_Buffer(this$3.clone__scm_Buffer().$$plus$plus$eq__sc_TraversableOnce__scg_Growable(xs$1.seq__sc_TraversableOnce())));
  var this$4 = $as_scm_BufferLike($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var xs$2 = $as_sc_GenTraversableOnce(this.commands__sc_Seq().filterNot__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x$33$2) {
      var x$33 = $as_Lscopt_OptionDef(x$33$2);
      return x$33.hasParent__Z()
    })
  })(this))));
  var pendingCommands = $as_scm_ListBuffer($as_scm_Buffer(this$4.clone__scm_Buffer().$$plus$plus$eq__sc_TraversableOnce__scg_Growable(xs$2.seq__sc_TraversableOnce())));
  var occurrences = $as_scm_Map($m_scm_ListMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())).withDefaultValue__O__scm_Map(0);
  var elem$1$1 = null;
  elem$1$1 = init;
  var elem$1$2 = false;
  elem$1$2 = false;
  while ((elem$1 < args.length__I())) {
    var this$7 = pendingOptions.scala$collection$mutable$ListBuffer$$start$6;
    inlinereturn$17: {
      var these = this$7;
      while ((!these.isEmpty__Z())) {
        var arg1 = these.head__O();
        var x$38 = $as_Lscopt_OptionDef(arg1);
        if ((x$38.tokensToRead__I__sc_Seq__I(elem$1, args) > 0)) {
          var x1 = new $c_s_Some().init___O(these.head__O());
          break inlinereturn$17
        };
        these = $as_sc_LinearSeqOptimized(these.tail__O())
      };
      var x1 = $m_s_None$()
    };
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var option = $as_Lscopt_OptionDef(x2.value$2);
      this.handleOccurrence$1__p1__Lscopt_OptionDef__scm_ListBuffer__scm_Map__V(option, pendingOptions, occurrences);
      var x1$2 = option.apply__I__sc_Seq__s_util_Either(elem$1, args);
      if ((x1$2 instanceof $c_s_util_Right)) {
        var x2$2 = $as_s_util_Right(x1$2);
        var v = $as_T(x2$2.value$2);
        var x1$1 = option.applyArgument__T__O__s_util_Either(v, elem$1$1);
        if ((x1$1 instanceof $c_s_util_Right)) {
          var x2$1 = $as_s_util_Right(x1$1);
          var c = x2$1.value$2;
          elem$1$1 = c;
          this.pushChildren$1__p1__Lscopt_OptionDef__scm_ListBuffer__scm_ListBuffer__scm_ListBuffer__V(option, pendingOptions, pendingArgs, pendingCommands)
        } else if ((x1$1 instanceof $c_s_util_Left)) {
          var x3 = $as_s_util_Left(x1$1);
          var xs$3 = $as_sc_Seq(x3.value$2);
          elem$1$2 = true;
          xs$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
            return (function(msg$2) {
              var msg = $as_T(msg$2);
              $this$1.reportError__T__V(msg)
            })
          })(this)))
        } else {
          throw new $c_s_MatchError().init___O(x1$1)
        }
      } else if ((x1$2 instanceof $c_s_util_Left)) {
        var x3$1 = $as_s_util_Left(x1$2);
        var outOfBounds = $as_T(x3$1.value$2);
        elem$1$2 = true;
        this.reportError__T__V(outOfBounds)
      } else {
        throw new $c_s_MatchError().init___O(x1$2)
      };
      if ((option.tokensToRead__I__sc_Seq__I(elem$1, args) > 1)) {
        elem$1 = ((elem$1 + (((-1) + option.tokensToRead__I__sc_Seq__I(elem$1, args)) | 0)) | 0)
      }
    } else {
      var x = $m_s_None$();
      if ((x === x1)) {
        var x1$3 = $as_T(args.apply__I__O(elem$1));
        if ((($uI(x1$3.length) >= 0) && ($as_T(x1$3.substring(0, $uI("--".length))) === "--"))) {
          var msg$1 = ("Unknown option " + x1$3);
          elem$1$2 = true;
          this.reportError__T__V(msg$1)
        } else if ((($uI(x1$3.length) >= 0) && ($as_T(x1$3.substring(0, $uI("-".length))) === "-"))) {
          if ((x1$3 === "-")) {
            var msg$3 = ("Unknown option " + x1$3);
            elem$1$2 = true;
            this.reportError__T__V(msg$3)
          } else {
            var this$19 = new $c_sci_StringOps().init___T(x1$3);
            var $$this = this$19.repr$1;
            var until = $uI($$this.length);
            var g0 = $m_sci_StringOps$().slice$extension__T__I__I__T(this$19.repr$1, 1, until);
            _handleShortOptions: while (true) {
              var x$1 = g0;
              var this$24 = new $c_sci_StringOps().init___T(x$1);
              var $$this$1 = this$24.repr$1;
              var end = (((-1) + $uI($$this$1.length)) | 0);
              var isEmpty$4 = (end < 0);
              if (isEmpty$4) {
                var scala$collection$immutable$Range$$numRangeElements$4 = 0
              } else {
                var hi = (end >> 31);
                var lo = ((1 + end) | 0);
                var hi$1 = ((lo === 0) ? ((1 + hi) | 0) : hi);
                var scala$collection$immutable$Range$$numRangeElements$4 = (((hi$1 === 0) ? (((-2147483648) ^ lo) > (-1)) : (hi$1 > 0)) ? (-1) : lo)
              };
              var g0$1 = g0;
              $m_sci_IndexedSeq$();
              $m_sc_IndexedSeq$();
              $m_sci_IndexedSeq$();
              $m_sci_Vector$();
              var b = new $c_sci_VectorBuilder().init___();
              if ((scala$collection$immutable$Range$$numRangeElements$4 < 0)) {
                $m_sci_Range$().scala$collection$immutable$Range$$fail__I__I__I__Z__sr_Nothing$(0, end, 1, true)
              };
              switch (scala$collection$immutable$Range$$numRangeElements$4) {
                case (-1): {
                  break
                }
              };
              if ((!isEmpty$4)) {
                var i = 0;
                while (true) {
                  var arg1$1 = i;
                  var this$34 = new $c_sci_StringOps().init___T(g0$1);
                  var $$this$2 = this$34.repr$1;
                  var endIndex = (($uI($$this$2.length) - arg1$1) | 0);
                  var elem = $as_T(g0$1.substring(0, endIndex));
                  b.$$plus$eq__O__sci_VectorBuilder(elem);
                  if ((i === end)) {
                    break
                  };
                  i = ((1 + i) | 0)
                }
              };
              var gs = b.result__sci_Vector();
              $m_sci_IndexedSeq$();
              $m_sc_IndexedSeq$();
              $m_sci_Vector$();
              var b$1 = new $c_sci_VectorBuilder().init___();
              var this$41 = gs.iterator__sci_VectorIterator();
              while (this$41.$$undhasNext$2) {
                var arg1$2 = this$41.next__O();
                var g = $as_T(arg1$2);
                var this$42 = $m_scm_ListBuffer$();
                var bf$2 = this$42.ReusableCBFInstance$2;
                var b$2 = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(pendingOptions, bf$2);
                var this$43 = pendingOptions.scala$collection$mutable$ListBuffer$$start$6;
                var these$1 = this$43;
                while ((!these$1.isEmpty__Z())) {
                  var arg1$3 = these$1.head__O();
                  var x$35 = $as_Lscopt_OptionDef(arg1$3);
                  b$2.$$plus$eq__O__scm_Builder(new $c_T2().init___O__O(g, x$35));
                  these$1 = $as_sci_List(these$1.tail__O())
                };
                var this$44 = $as_scm_ListBuffer(b$2.result__O());
                $as_sci_VectorBuilder($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(b$1, this$44))
              };
              var this$45 = b$1.result__sci_Vector();
              var this$46 = this$45.iterator__sci_VectorIterator();
              inlinereturn$160: {
                while (this$46.$$undhasNext$2) {
                  var a = this$46.next__O();
                  var x0$4 = $as_T2(a);
                  if ((x0$4 === null)) {
                    throw new $c_s_MatchError().init___O(x0$4)
                  };
                  var g$1 = $as_T(x0$4.$$und1__O());
                  var opt = $as_Lscopt_OptionDef(x0$4.$$und2__O());
                  if ((opt.shortOptTokens__T__I(("-" + g$1)) === 1)) {
                    var x1$4 = new $c_s_Some().init___O(a);
                    break inlinereturn$160
                  }
                };
                var x1$4 = $m_s_None$()
              };
              if ((x1$4 instanceof $c_s_Some)) {
                var x2$3 = $as_s_Some(x1$4);
                var p = $as_T2(x2$3.value$2);
                if ((p === null)) {
                  throw new $c_s_MatchError().init___O(p)
                };
                var g$3 = $as_T(p.$$und1__O());
                var option$1 = $as_Lscopt_OptionDef(p.$$und2__O());
                this.handleOccurrence$1__p1__Lscopt_OptionDef__scm_ListBuffer__scm_Map__V(option$1, pendingOptions, occurrences);
                var x1$5 = option$1.applyArgument__T__O__s_util_Either("", elem$1$1);
                if ((x1$5 instanceof $c_s_util_Right)) {
                  var x2$4 = $as_s_util_Right(x1$5);
                  var c$1 = x2$4.value$2;
                  elem$1$1 = c$1;
                  this.pushChildren$1__p1__Lscopt_OptionDef__scm_ListBuffer__scm_ListBuffer__scm_ListBuffer__V(option$1, pendingOptions, pendingArgs, pendingCommands)
                } else if ((x1$5 instanceof $c_s_util_Left)) {
                  var x3$2 = $as_s_util_Left(x1$5);
                  var xs$4 = $as_sc_Seq(x3$2.value$2);
                  elem$1$2 = true;
                  xs$4.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2) {
                    return (function(msg$2$1) {
                      var msg$4 = $as_T(msg$2$1);
                      $this$2.reportError__T__V(msg$4)
                    })
                  })(this)))
                } else {
                  throw new $c_s_MatchError().init___O(x1$5)
                };
                var x$2 = g0;
                var this$52 = new $c_sci_StringOps().init___T(x$2);
                var this$49 = new $c_sci_StringOps().init___T(g$3);
                var $$this$3 = this$49.repr$1;
                var n = $uI($$this$3.length);
                var $$this$4 = this$52.repr$1;
                var until$1 = $uI($$this$4.length);
                var x$2$1 = $m_sci_StringOps$().slice$extension__T__I__I__T(this$52.repr$1, n, until$1);
                if ((!((x$2$1 !== null) && (x$2$1 === "")))) {
                  var x$3 = g0;
                  var this$60 = new $c_sci_StringOps().init___T(x$3);
                  var this$57 = new $c_sci_StringOps().init___T(g$3);
                  var $$this$5 = this$57.repr$1;
                  var n$1 = $uI($$this$5.length);
                  var $$this$6 = this$60.repr$1;
                  var until$2 = $uI($$this$6.length);
                  g0 = $m_sci_StringOps$().slice$extension__T__I__I__T(this$60.repr$1, n$1, until$2);
                  continue _handleShortOptions
                }
              } else {
                var x$4 = $m_s_None$();
                if ((!(x$4 === x1$4))) {
                  throw new $c_s_MatchError().init___O(x1$4)
                };
                var msg$5 = ("Unknown option -" + g0);
                elem$1$2 = true;
                this.reportError__T__V(msg$5)
              };
              break
            }
          }
        } else if (this.findCommand$1__p1__T__scm_ListBuffer__s_Option(x1$3, pendingCommands).isDefined__Z()) {
          var cmd = $as_Lscopt_OptionDef(this.findCommand$1__p1__T__scm_ListBuffer__s_Option(x1$3, pendingCommands).get__O());
          this.handleOccurrence$1__p1__Lscopt_OptionDef__scm_ListBuffer__scm_Map__V(cmd, pendingCommands, occurrences);
          var x1$6 = cmd.applyArgument__T__O__s_util_Either("", elem$1$1);
          if ((x1$6 instanceof $c_s_util_Right)) {
            var x2$5 = $as_s_util_Right(x1$6);
            var c$2 = x2$5.value$2;
            elem$1$1 = c$2;
            this.pushChildren$1__p1__Lscopt_OptionDef__scm_ListBuffer__scm_ListBuffer__scm_ListBuffer__V(cmd, pendingOptions, pendingArgs, pendingCommands)
          } else if ((x1$6 instanceof $c_s_util_Left)) {
            var x3$3 = $as_s_util_Left(x1$6);
            var xs$5 = $as_sc_Seq(x3$3.value$2);
            elem$1$2 = true;
            xs$5.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3) {
              return (function(msg$2$2) {
                var msg$6 = $as_T(msg$2$2);
                $this$3.reportError__T__V(msg$6)
              })
            })(this)))
          } else {
            throw new $c_s_MatchError().init___O(x1$6)
          }
        } else if (pendingArgs.isEmpty__Z()) {
          var msg$7 = (("Unknown argument '" + x1$3) + "'");
          elem$1$2 = true;
          this.reportError__T__V(msg$7)
        } else {
          var first = $as_Lscopt_OptionDef(pendingArgs.scala$collection$mutable$ListBuffer$$start$6.head__O());
          this.handleOccurrence$1__p1__Lscopt_OptionDef__scm_ListBuffer__scm_Map__V(first, pendingArgs, occurrences);
          var x1$7 = first.applyArgument__T__O__s_util_Either(x1$3, elem$1$1);
          if ((x1$7 instanceof $c_s_util_Right)) {
            var x2$6 = $as_s_util_Right(x1$7);
            var c$3 = x2$6.value$2;
            elem$1$1 = c$3;
            this.pushChildren$1__p1__Lscopt_OptionDef__scm_ListBuffer__scm_ListBuffer__scm_ListBuffer__V(first, pendingOptions, pendingArgs, pendingCommands)
          } else if ((x1$7 instanceof $c_s_util_Left)) {
            var x3$4 = $as_s_util_Left(x1$7);
            var xs$6 = $as_sc_Seq(x3$4.value$2);
            elem$1$2 = true;
            xs$6.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$4) {
              return (function(msg$2$3) {
                var msg$8 = $as_T(msg$2$3);
                $this$4.reportError__T__V(msg$8)
              })
            })(this)))
          } else {
            throw new $c_s_MatchError().init___O(x1$7)
          }
        }
      } else {
        throw new $c_s_MatchError().init___O(x1)
      }
    };
    elem$1 = ((1 + elem$1) | 0)
  };
  var f = (function(this$5$1) {
    return (function(x$39$2) {
      var x$39 = $as_Lscopt_OptionDef(x$39$2);
      return x$39.hasFallback__Z()
    })
  })(this);
  if ((pendingOptions instanceof $c_sci_List)) {
    var x2$7 = $as_sci_List(pendingOptions);
    var l = x2$7;
    var l$1 = l;
    x$1: {
      var result;
      _noneIn: while (true) {
        if (l$1.isEmpty__Z()) {
          var result = $m_sci_Nil$();
          break
        } else {
          var h = l$1.head__O();
          var t = $as_sci_List(l$1.tail__O());
          if (($uZ(f(h)) === false)) {
            l$1 = t;
            continue _noneIn
          };
          var start = l$1;
          var remaining = t;
          var remaining$1 = remaining;
          _allIn: while (true) {
            if (remaining$1.isEmpty__Z()) {
              var result = start;
              break x$1
            } else {
              var x$2$2 = remaining$1.head__O();
              if (($uZ(f(x$2$2)) !== false)) {
                remaining$1 = $as_sci_List(remaining$1.tail__O());
                continue _allIn
              };
              var firstMiss = remaining$1;
              var newHead = new $c_sci_$colon$colon().init___O__sci_List(start.head__O(), $m_sci_Nil$());
              var toProcess = $as_sci_List(start.tail__O());
              var currentLast = newHead;
              while ((toProcess !== firstMiss)) {
                var newElem = new $c_sci_$colon$colon().init___O__sci_List(toProcess.head__O(), $m_sci_Nil$());
                currentLast.tl$5 = newElem;
                currentLast = newElem;
                toProcess = $as_sci_List(toProcess.tail__O())
              };
              var next = $as_sci_List(firstMiss.tail__O());
              var nextToCopy = next;
              while ((!next.isEmpty__Z())) {
                var head = next.head__O();
                if (($uZ(f(head)) !== false)) {
                  next = $as_sci_List(next.tail__O())
                } else {
                  while ((nextToCopy !== next)) {
                    var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy.head__O(), $m_sci_Nil$());
                    currentLast.tl$5 = newElem$2;
                    currentLast = newElem$2;
                    nextToCopy = $as_sci_List(nextToCopy.tail__O())
                  };
                  nextToCopy = $as_sci_List(next.tail__O());
                  next = $as_sci_List(next.tail__O())
                }
              };
              if ((!nextToCopy.isEmpty__Z())) {
                currentLast.tl$5 = nextToCopy
              };
              var result = newHead;
              break x$1
            }
          }
        }
      }
    };
    var jsx$1 = result
  } else {
    $m_scm_ListBuffer$();
    var b$3 = new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_ListBuffer().init___());
    var this$64 = pendingOptions.scala$collection$mutable$ListBuffer$$start$6;
    var these$2 = this$64;
    while ((!these$2.isEmpty__Z())) {
      var arg1$4 = these$2.head__O();
      if (($uZ(f(arg1$4)) !== false)) {
        b$3.$$plus$eq__O__scm_GrowingBuilder(arg1$4)
      };
      these$2 = $as_sci_List(these$2.tail__O())
    };
    var jsx$1 = b$3.elems$1
  };
  var this$65 = $as_scg_TraversableForwarder(jsx$1);
  var this$66 = this$65.scala$collection$mutable$ListBuffer$$start$6;
  var these$3 = this$66;
  while ((!these$3.isEmpty__Z())) {
    var arg1$5 = these$3.head__O();
    var opt$1 = $as_Lscopt_OptionDef(arg1$5);
    var fallback = opt$1.getFallback__O();
    if ((fallback !== null)) {
      this.handleOccurrence$1__p1__Lscopt_OptionDef__scm_ListBuffer__scm_Map__V(opt$1, pendingOptions, occurrences);
      var arg = $objectToString(fallback);
      var x1$8 = opt$1.applyArgument__T__O__s_util_Either(arg, elem$1$1);
      if ((x1$8 instanceof $c_s_util_Right)) {
        var x2$8 = $as_s_util_Right(x1$8);
        var c$4 = x2$8.value$2;
        elem$1$1 = c$4;
        this.pushChildren$1__p1__Lscopt_OptionDef__scm_ListBuffer__scm_ListBuffer__scm_ListBuffer__V(opt$1, pendingOptions, pendingArgs, pendingCommands)
      } else if ((x1$8 instanceof $c_s_util_Left)) {
        var x3$5 = $as_s_util_Left(x1$8);
        var xs$7 = $as_sc_Seq(x3$5.value$2);
        elem$1$2 = true;
        xs$7.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$5) {
          return (function(msg$2$4) {
            var msg$9 = $as_T(msg$2$4);
            $this$5.reportError__T__V(msg$9)
          })
        })(this)))
      } else {
        throw new $c_s_MatchError().init___O(x1$8)
      }
    };
    these$3 = $as_sci_List(these$3.tail__O())
  };
  var f$1 = (function(this$7$1, occurrences$1) {
    return (function(opt$3$2) {
      var opt$3 = $as_Lscopt_OptionDef(opt$3$2);
      return (opt$3.$$undminOccurs$1 > $uI(occurrences$1.apply__O__O(opt$3)))
    })
  })(this, occurrences);
  if ((pendingOptions instanceof $c_sci_List)) {
    var x2$9 = $as_sci_List(pendingOptions);
    var l$2 = x2$9;
    var l$3 = l$2;
    x$3: {
      var result$1;
      _noneIn$1: while (true) {
        if (l$3.isEmpty__Z()) {
          var result$1 = $m_sci_Nil$();
          break
        } else {
          var h$1 = l$3.head__O();
          var t$1 = $as_sci_List(l$3.tail__O());
          if (($uZ(f$1(h$1)) === false)) {
            l$3 = t$1;
            continue _noneIn$1
          };
          var start$1 = l$3;
          var remaining$2 = t$1;
          var remaining$3 = remaining$2;
          _allIn$1: while (true) {
            if (remaining$3.isEmpty__Z()) {
              var result$1 = start$1;
              break x$3
            } else {
              var x$2$3 = remaining$3.head__O();
              if (($uZ(f$1(x$2$3)) !== false)) {
                remaining$3 = $as_sci_List(remaining$3.tail__O());
                continue _allIn$1
              };
              var firstMiss$1 = remaining$3;
              var newHead$1 = new $c_sci_$colon$colon().init___O__sci_List(start$1.head__O(), $m_sci_Nil$());
              var toProcess$1 = $as_sci_List(start$1.tail__O());
              var currentLast$1 = newHead$1;
              while ((toProcess$1 !== firstMiss$1)) {
                var newElem$1 = new $c_sci_$colon$colon().init___O__sci_List(toProcess$1.head__O(), $m_sci_Nil$());
                currentLast$1.tl$5 = newElem$1;
                currentLast$1 = newElem$1;
                toProcess$1 = $as_sci_List(toProcess$1.tail__O())
              };
              var next$1 = $as_sci_List(firstMiss$1.tail__O());
              var nextToCopy$1 = next$1;
              while ((!next$1.isEmpty__Z())) {
                var head$1 = next$1.head__O();
                if (($uZ(f$1(head$1)) !== false)) {
                  next$1 = $as_sci_List(next$1.tail__O())
                } else {
                  while ((nextToCopy$1 !== next$1)) {
                    var newElem$2$1 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy$1.head__O(), $m_sci_Nil$());
                    currentLast$1.tl$5 = newElem$2$1;
                    currentLast$1 = newElem$2$1;
                    nextToCopy$1 = $as_sci_List(nextToCopy$1.tail__O())
                  };
                  nextToCopy$1 = $as_sci_List(next$1.tail__O());
                  next$1 = $as_sci_List(next$1.tail__O())
                }
              };
              if ((!nextToCopy$1.isEmpty__Z())) {
                currentLast$1.tl$5 = nextToCopy$1
              };
              var result$1 = newHead$1;
              break x$3
            }
          }
        }
      }
    };
    var jsx$2 = result$1
  } else {
    $m_scm_ListBuffer$();
    var b$4 = new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_ListBuffer().init___());
    var this$68 = pendingOptions.scala$collection$mutable$ListBuffer$$start$6;
    var these$4 = this$68;
    while ((!these$4.isEmpty__Z())) {
      var arg1$6 = these$4.head__O();
      if (($uZ(f$1(arg1$6)) !== false)) {
        b$4.$$plus$eq__O__scm_GrowingBuilder(arg1$6)
      };
      these$4 = $as_sci_List(these$4.tail__O())
    };
    var jsx$2 = b$4.elems$1
  };
  var this$69 = $as_scg_TraversableForwarder(jsx$2);
  var this$70 = this$69.scala$collection$mutable$ListBuffer$$start$6;
  var these$5 = this$70;
  while ((!these$5.isEmpty__Z())) {
    var arg1$7 = these$5.head__O();
    var opt$4 = $as_Lscopt_OptionDef(arg1$7);
    if ((opt$4.$$undminOccurs$1 === 1)) {
      this.reportError__T__V(("Missing " + opt$4.shortDescription__T()))
    } else {
      var x$5 = opt$4.shortDescription__T();
      var this$72 = new $c_sci_StringOps().init___T(x$5);
      this.reportError__T__V(((($f_sci_StringLike__capitalize__T(this$72) + " must be given ") + opt$4.$$undminOccurs$1) + " times"))
    };
    elem$1$2 = true;
    these$5 = $as_sci_List(these$5.tail__O())
  };
  var f$2 = (function(this$9$1, occurrences$2) {
    return (function(arg$2) {
      var arg$1 = $as_Lscopt_OptionDef(arg$2);
      return (arg$1.$$undminOccurs$1 > $uI(occurrences$2.apply__O__O(arg$1)))
    })
  })(this, occurrences);
  if ((pendingArgs instanceof $c_sci_List)) {
    var x2$10 = $as_sci_List(pendingArgs);
    var l$4 = x2$10;
    var l$5 = l$4;
    x$5: {
      var result$2;
      _noneIn$2: while (true) {
        if (l$5.isEmpty__Z()) {
          var result$2 = $m_sci_Nil$();
          break
        } else {
          var h$2 = l$5.head__O();
          var t$2 = $as_sci_List(l$5.tail__O());
          if (($uZ(f$2(h$2)) === false)) {
            l$5 = t$2;
            continue _noneIn$2
          };
          var start$2 = l$5;
          var remaining$4 = t$2;
          var remaining$5 = remaining$4;
          _allIn$2: while (true) {
            if (remaining$5.isEmpty__Z()) {
              var result$2 = start$2;
              break x$5
            } else {
              var x$2$4 = remaining$5.head__O();
              if (($uZ(f$2(x$2$4)) !== false)) {
                remaining$5 = $as_sci_List(remaining$5.tail__O());
                continue _allIn$2
              };
              var firstMiss$2 = remaining$5;
              var newHead$2 = new $c_sci_$colon$colon().init___O__sci_List(start$2.head__O(), $m_sci_Nil$());
              var toProcess$2 = $as_sci_List(start$2.tail__O());
              var currentLast$2 = newHead$2;
              while ((toProcess$2 !== firstMiss$2)) {
                var newElem$3 = new $c_sci_$colon$colon().init___O__sci_List(toProcess$2.head__O(), $m_sci_Nil$());
                currentLast$2.tl$5 = newElem$3;
                currentLast$2 = newElem$3;
                toProcess$2 = $as_sci_List(toProcess$2.tail__O())
              };
              var next$2 = $as_sci_List(firstMiss$2.tail__O());
              var nextToCopy$2 = next$2;
              while ((!next$2.isEmpty__Z())) {
                var head$2 = next$2.head__O();
                if (($uZ(f$2(head$2)) !== false)) {
                  next$2 = $as_sci_List(next$2.tail__O())
                } else {
                  while ((nextToCopy$2 !== next$2)) {
                    var newElem$2$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy$2.head__O(), $m_sci_Nil$());
                    currentLast$2.tl$5 = newElem$2$2;
                    currentLast$2 = newElem$2$2;
                    nextToCopy$2 = $as_sci_List(nextToCopy$2.tail__O())
                  };
                  nextToCopy$2 = $as_sci_List(next$2.tail__O());
                  next$2 = $as_sci_List(next$2.tail__O())
                }
              };
              if ((!nextToCopy$2.isEmpty__Z())) {
                currentLast$2.tl$5 = nextToCopy$2
              };
              var result$2 = newHead$2;
              break x$5
            }
          }
        }
      }
    };
    var jsx$3 = result$2
  } else {
    $m_scm_ListBuffer$();
    var b$5 = new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_ListBuffer().init___());
    var this$74 = pendingArgs.scala$collection$mutable$ListBuffer$$start$6;
    var these$6 = this$74;
    while ((!these$6.isEmpty__Z())) {
      var arg1$8 = these$6.head__O();
      if (($uZ(f$2(arg1$8)) !== false)) {
        b$5.$$plus$eq__O__scm_GrowingBuilder(arg1$8)
      };
      these$6 = $as_sci_List(these$6.tail__O())
    };
    var jsx$3 = b$5.elems$1
  };
  var this$75 = $as_scg_TraversableForwarder(jsx$3);
  var this$76 = this$75.scala$collection$mutable$ListBuffer$$start$6;
  var these$7 = this$76;
  while ((!these$7.isEmpty__Z())) {
    var arg1$9 = these$7.head__O();
    var arg$3 = $as_Lscopt_OptionDef(arg1$9);
    if ((arg$3.$$undminOccurs$1 === 1)) {
      this.reportError__T__V(("Missing " + arg$3.shortDescription__T()))
    } else {
      var x$7 = arg$3.shortDescription__T();
      var this$78 = new $c_sci_StringOps().init___T(x$7);
      this.reportError__T__V(((($f_sci_StringLike__capitalize__T(this$78) + "' must be given ") + arg$3.$$undminOccurs$1) + " times"))
    };
    elem$1$2 = true;
    these$7 = $as_sci_List(these$7.tail__O())
  };
  var c$5 = elem$1$1;
  var jsx$6 = $m_Lscopt_Validation$();
  var jsx$5 = this.checks__sc_Seq();
  var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$6) {
    return (function(x$37$2) {
      var x$37 = $as_Lscopt_OptionDef(x$37$2);
      return x$37.$$undconfigValidations$1
    })
  })(this));
  var this$79 = $m_sc_Seq$();
  var x1$9 = jsx$6.validateValue__sc_Seq__O__s_util_Either($as_sc_Seq(jsx$5.flatMap__F1__scg_CanBuildFrom__O(jsx$4, this$79.ReusableCBFInstance$2)), c$5);
  if ((!(x1$9 instanceof $c_s_util_Right))) {
    if ((x1$9 instanceof $c_s_util_Left)) {
      var x3$6 = $as_s_util_Left(x1$9);
      var xs$8 = $as_sc_Seq(x3$6.value$2);
      elem$1$2 = true;
      xs$8.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$2) {
        return (function(msg$2$5) {
          var msg$10 = $as_T(msg$2$5);
          this$2$2.reportError__T__V(msg$10)
        })
      })(this)))
    } else {
      throw new $c_s_MatchError().init___O(x1$9)
    }
  };
  if (elem$1$2) {
    if (this.helpOptions$1.isEmpty__Z()) {
      var this$80 = $m_s_Console$();
      $as_Ljava_io_PrintStream(this$80.errVar$2.v$1).println__T__V(this.renderUsage__Lscopt_RenderingMode__T($m_Lscopt_RenderingMode$TwoColumns$()))
    } else {
      this.showTryHelp__V()
    };
    return $m_s_None$()
  } else {
    return new $c_s_Some().init___O(elem$1$1)
  }
});
$c_Lscopt_OptionParser.prototype.checkConfig__F1__Lscopt_OptionDef = (function(f) {
  return this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Check$(), "", $m_Lscopt_Read$().unitRead$1).validateConfig__F1__Lscopt_OptionDef(f)
});
$c_Lscopt_OptionParser.prototype.commandExample__s_Option__T = (function(cmd) {
  var text = new $c_scm_ListBuffer().init___();
  if (cmd.isEmpty__Z()) {
    var this$1 = $m_s_None$()
  } else {
    var arg1 = cmd.get__O();
    var cmd$2 = $as_Lscopt_OptionDef(arg1);
    var this$1 = new $c_s_Some().init___O(this.commandName__Lscopt_OptionDef__T(cmd$2))
  };
  text.$$plus$eq__O__scm_ListBuffer((this$1.isEmpty__Z() ? this.programName$1 : this$1.get__O()));
  if (cmd.isEmpty__Z()) {
    var parentId = $m_s_None$()
  } else {
    var arg1$1 = cmd.get__O();
    var x$19 = $as_Lscopt_OptionDef(arg1$1);
    var parentId = new $c_s_Some().init___O(x$19.id$1)
  };
  var cs = $as_sc_Seq(this.commands__sc_Seq().filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4, parentId$1) {
    return (function(x$20$2) {
      var x$20 = $as_Lscopt_OptionDef(x$20$2);
      var x = x$20.$$undparentId$1;
      return ((x === null) ? (parentId$1 === null) : x.equals__O__Z(parentId$1))
    })
  })(this, parentId))));
  if (cs.nonEmpty__Z()) {
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5) {
      return (function(x$21$2) {
        var x$21 = $as_Lscopt_OptionDef(x$21$2);
        return x$21.name$1
      })
    })(this));
    var this$2 = $m_sc_Seq$();
    text.$$plus$eq__O__scm_ListBuffer($as_sc_TraversableOnce(cs.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2)).mkString__T__T__T__T("[", "|", "]"))
  };
  var this$3 = this.options$1;
  var this$6 = this$3.scala$collection$mutable$ListBuffer$$start$6;
  var f = (function(this$6$1, parentId$2) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lscopt_OptionDef(x0$1$2);
      var x$1 = x0$1.kind$1;
      var x$2 = $m_Lscopt_Opt$();
      if (((x$1 !== null) && (x$1 === x$2))) {
        var x$3 = x0$1.$$undparentId$1;
        return ((x$3 === null) ? (parentId$2 === null) : x$3.equals__O__Z(parentId$2))
      } else {
        return false
      }
    })
  })(this, parentId);
  if ((this$6 !== null)) {
    var l = this$6;
    var l$1 = l;
    x: {
      var result;
      _noneIn: while (true) {
        if (l$1.isEmpty__Z()) {
          var result = $m_sci_Nil$();
          break
        } else {
          var h = l$1.head__O();
          var t = $as_sci_List(l$1.tail__O());
          if (($uZ(f(h)) === false)) {
            l$1 = t;
            continue _noneIn
          };
          var start = l$1;
          var remaining = t;
          var remaining$1 = remaining;
          _allIn: while (true) {
            if (remaining$1.isEmpty__Z()) {
              var result = start;
              break x
            } else {
              var x$2$1 = remaining$1.head__O();
              if (($uZ(f(x$2$1)) !== false)) {
                remaining$1 = $as_sci_List(remaining$1.tail__O());
                continue _allIn
              };
              var firstMiss = remaining$1;
              var newHead = new $c_sci_$colon$colon().init___O__sci_List(start.head__O(), $m_sci_Nil$());
              var toProcess = $as_sci_List(start.tail__O());
              var currentLast = newHead;
              while ((toProcess !== firstMiss)) {
                var newElem = new $c_sci_$colon$colon().init___O__sci_List(toProcess.head__O(), $m_sci_Nil$());
                currentLast.tl$5 = newElem;
                currentLast = newElem;
                toProcess = $as_sci_List(toProcess.tail__O())
              };
              var next = $as_sci_List(firstMiss.tail__O());
              var nextToCopy = next;
              while ((!next.isEmpty__Z())) {
                var head = next.head__O();
                if (($uZ(f(head)) !== false)) {
                  next = $as_sci_List(next.tail__O())
                } else {
                  while ((nextToCopy !== next)) {
                    var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy.head__O(), $m_sci_Nil$());
                    currentLast.tl$5 = newElem$2;
                    currentLast = newElem$2;
                    nextToCopy = $as_sci_List(nextToCopy.tail__O())
                  };
                  nextToCopy = $as_sci_List(next.tail__O());
                  next = $as_sci_List(next.tail__O())
                }
              };
              if ((!nextToCopy.isEmpty__Z())) {
                currentLast.tl$5 = nextToCopy
              };
              var result = newHead;
              break x
            }
          }
        }
      }
    };
    var os = result
  } else {
    $m_sci_List$();
    var b = new $c_scm_ListBuffer().init___();
    var these = this$6;
    while ((!these.isEmpty__Z())) {
      var arg1$2 = these.head__O();
      if (($uZ(f(arg1$2)) !== false)) {
        b.$$plus$eq__O__scm_ListBuffer(arg1$2)
      };
      these = $as_sci_List(these.tail__O())
    };
    var os = b.toList__sci_List()
  };
  var as = $as_sc_Seq(this.arguments__sc_Seq().filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$7$1, parentId$3) {
    return (function(x$22$2) {
      var x$22 = $as_Lscopt_OptionDef(x$22$2);
      var x$4 = x$22.$$undparentId$1;
      return ((x$4 === null) ? (parentId$3 === null) : x$4.equals__O__Z(parentId$3))
    })
  })(this, parentId))));
  if ($f_sc_TraversableOnce__nonEmpty__Z(os)) {
    text.$$plus$eq__O__scm_ListBuffer("[options]")
  };
  if (cs.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$8) {
    return (function(x0$2$2) {
      var x0$2 = $as_Lscopt_OptionDef(x0$2$2);
      return this$8.arguments__sc_Seq().exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x1) {
        return (function(x$23$2) {
          var x$23 = $as_Lscopt_OptionDef(x$23$2);
          var x$5 = x$23.$$undparentId$1;
          var x$2$2 = new $c_s_Some().init___O(x1.id$1);
          return ((x$5 !== null) && x$5.equals__O__Z(x$2$2))
        })
      })(this$8, x0$2)))
    })
  })(this)))) {
    text.$$plus$eq__O__scm_ListBuffer("<args>...")
  } else if (as.nonEmpty__Z()) {
    var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$9) {
      return (function(x$24$2) {
        var x$24 = $as_Lscopt_OptionDef(x$24$2);
        return x$24.argName__T()
      })
    })(this));
    var this$10 = $m_sc_Seq$();
    text.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer($as_sc_TraversableOnce(as.map__F1__scg_CanBuildFrom__O(jsx$2, this$10.ReusableCBFInstance$2)))
  };
  var this$11 = text.scala$collection$mutable$ListBuffer$$start$6;
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this$11, "", " ", "")
});
$c_Lscopt_OptionParser.prototype.commandName__Lscopt_OptionDef__T = (function(cmd) {
  var this$1 = cmd.$$undparentId$1;
  if (this$1.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x = $uI(arg1);
    var this$2 = this.commands__sc_Seq().find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x$1) {
      return (function(x$25$2) {
        var x$25 = $as_Lscopt_OptionDef(x$25$2);
        return (x$25.id$1 === x$1)
      })
    })(this, x)));
    if (this$2.isEmpty__Z()) {
      var this$3 = $m_s_None$()
    } else {
      var arg1$1 = this$2.get__O();
      var cmd$1 = $as_Lscopt_OptionDef(arg1$1);
      var this$3 = new $c_s_Some().init___O(this.commandName__Lscopt_OptionDef__T(cmd$1))
    };
    var this$4 = new $c_s_Some().init___O(($as_T((this$3.isEmpty__Z() ? "" : this$3.get__O())) + " "))
  };
  return (("" + $as_T((this$4.isEmpty__Z() ? "" : this$4.get__O()))) + cmd.name$1)
});
$c_Lscopt_OptionParser.prototype.commands__sc_Seq = (function() {
  var this$1 = this.options$1;
  var this$2 = this$1.scala$collection$mutable$ListBuffer$$start$6;
  var f = (function($this) {
    return (function(x$28$2) {
      var x$28 = $as_Lscopt_OptionDef(x$28$2);
      var x = x$28.kind$1;
      var x$2 = $m_Lscopt_Cmd$();
      return ((x !== null) && (x === x$2))
    })
  })(this);
  if ((this$2 !== null)) {
    var l = this$2;
    var l$1 = l;
    x: {
      var result;
      _noneIn: while (true) {
        if (l$1.isEmpty__Z()) {
          var result = $m_sci_Nil$();
          break
        } else {
          var h = l$1.head__O();
          var t = $as_sci_List(l$1.tail__O());
          if (($uZ(f(h)) === false)) {
            l$1 = t;
            continue _noneIn
          };
          var start = l$1;
          var remaining = t;
          var remaining$1 = remaining;
          _allIn: while (true) {
            if (remaining$1.isEmpty__Z()) {
              var result = start;
              break x
            } else {
              var x$2$1 = remaining$1.head__O();
              if (($uZ(f(x$2$1)) !== false)) {
                remaining$1 = $as_sci_List(remaining$1.tail__O());
                continue _allIn
              };
              var firstMiss = remaining$1;
              var newHead = new $c_sci_$colon$colon().init___O__sci_List(start.head__O(), $m_sci_Nil$());
              var toProcess = $as_sci_List(start.tail__O());
              var currentLast = newHead;
              while ((toProcess !== firstMiss)) {
                var newElem = new $c_sci_$colon$colon().init___O__sci_List(toProcess.head__O(), $m_sci_Nil$());
                currentLast.tl$5 = newElem;
                currentLast = newElem;
                toProcess = $as_sci_List(toProcess.tail__O())
              };
              var next = $as_sci_List(firstMiss.tail__O());
              var nextToCopy = next;
              while ((!next.isEmpty__Z())) {
                var head = next.head__O();
                if (($uZ(f(head)) !== false)) {
                  next = $as_sci_List(next.tail__O())
                } else {
                  while ((nextToCopy !== next)) {
                    var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy.head__O(), $m_sci_Nil$());
                    currentLast.tl$5 = newElem$2;
                    currentLast = newElem$2;
                    nextToCopy = $as_sci_List(nextToCopy.tail__O())
                  };
                  nextToCopy = $as_sci_List(next.tail__O());
                  next = $as_sci_List(next.tail__O())
                }
              };
              if ((!nextToCopy.isEmpty__Z())) {
                currentLast.tl$5 = nextToCopy
              };
              var result = newHead;
              break x
            }
          }
        }
      }
    };
    return result
  } else {
    $m_sci_List$();
    var b = new $c_scm_ListBuffer().init___();
    var these = this$2;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      if (($uZ(f(arg1)) !== false)) {
        b.$$plus$eq__O__scm_ListBuffer(arg1)
      };
      these = $as_sci_List(these.tail__O())
    };
    return b.toList__sci_List()
  }
});
$c_Lscopt_OptionParser.prototype.pushChildren$1__p1__Lscopt_OptionDef__scm_ListBuffer__scm_ListBuffer__scm_ListBuffer__V = (function(opt, pendingOptions$1, pendingArgs$1, pendingCommands$1) {
  pendingCommands$1.clear__V();
  pendingOptions$1.insertAll__I__sc_Traversable__V(0, $as_sc_Traversable(this.nonArgs__sc_Seq().filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, pendingOptions$1$1, opt$1) {
    return (function(x$2) {
      var x = $as_Lscopt_OptionDef(x$2);
      var x$2$1 = x.$$undparentId$1;
      var x$3 = new $c_s_Some().init___O(opt$1.id$1);
      if (((x$2$1 !== null) && x$2$1.equals__O__Z(x$3))) {
        var this$1 = pendingOptions$1$1.scala$collection$mutable$ListBuffer$$start$6;
        return (!$f_sc_LinearSeqOptimized__contains__O__Z(this$1, x))
      } else {
        return false
      }
    })
  })(this, pendingOptions$1, opt)))));
  pendingArgs$1.insertAll__I__sc_Traversable__V(0, $as_sc_Traversable(this.arguments__sc_Seq().filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, pendingArgs$1$1, opt$2) {
    return (function(x$3$2) {
      var x$3$1 = $as_Lscopt_OptionDef(x$3$2);
      var x$2$2 = x$3$1.$$undparentId$1;
      var x$3$3 = new $c_s_Some().init___O(opt$2.id$1);
      if (((x$2$2 !== null) && x$2$2.equals__O__Z(x$3$3))) {
        var this$3 = pendingArgs$1$1.scala$collection$mutable$ListBuffer$$start$6;
        return (!$f_sc_LinearSeqOptimized__contains__O__Z(this$3, x$3$1))
      } else {
        return false
      }
    })
  })(this, pendingArgs$1, opt)))));
  pendingCommands$1.insertAll__I__sc_Traversable__V(0, $as_sc_Traversable(this.commands__sc_Seq().filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, pendingCommands$1$1, opt$3) {
    return (function(x$4$2) {
      var x$4 = $as_Lscopt_OptionDef(x$4$2);
      var x$2$3 = x$4.$$undparentId$1;
      var x$3$4 = new $c_s_Some().init___O(opt$3.id$1);
      if (((x$2$3 !== null) && x$2$3.equals__O__Z(x$3$4))) {
        var this$4 = pendingCommands$1$1.scala$collection$mutable$ListBuffer$$start$6;
        return (!$f_sc_LinearSeqOptimized__contains__O__Z(this$4, x$4))
      } else {
        return false
      }
    })
  })(this, pendingCommands$1, opt)))))
});
$c_Lscopt_OptionParser.prototype.findCommand$1__p1__T__scm_ListBuffer__s_Option = (function(cmd, pendingCommands$1) {
  var this$1 = pendingCommands$1.scala$collection$mutable$ListBuffer$$start$6;
  var these = this$1;
  while ((!these.isEmpty__Z())) {
    var arg1 = these.head__O();
    var x$34 = $as_Lscopt_OptionDef(arg1);
    if ((x$34.name$1 === cmd)) {
      return new $c_s_Some().init___O(these.head__O())
    };
    these = $as_sc_LinearSeqOptimized(these.tail__O())
  };
  return $m_s_None$()
});
$c_Lscopt_OptionParser.prototype.showTryHelp__V = (function() {
  var this$1 = $m_s_Console$();
  var jsx$2 = $as_Ljava_io_PrintStream(this$1.errVar$2.v$1);
  var this$3 = this.helpOptions$1.toList__sci_List();
  var f = (function($this) {
    return (function(x$11$2) {
      var x$11 = $as_Lscopt_OptionDef(x$11$2);
      return x$11.fullName__T()
    })
  })(this);
  var this$2 = $m_sci_List$();
  var bf = this$2.ReusableCBFInstance$2;
  if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
    if ((this$3 === $m_sci_Nil$())) {
      var jsx$1 = $m_sci_Nil$()
    } else {
      var arg1 = this$3.head__O();
      var h = new $c_sci_$colon$colon().init___O__sci_List(f(arg1), $m_sci_Nil$());
      var t = h;
      var rest = $as_sci_List(this$3.tail__O());
      while ((rest !== $m_sci_Nil$())) {
        var arg1$1 = rest.head__O();
        var nx = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$1), $m_sci_Nil$());
        t.tl$5 = nx;
        t = nx;
        rest = $as_sci_List(rest.tail__O())
      };
      var jsx$1 = h
    }
  } else {
    var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$3, bf);
    var these = this$3;
    while ((!these.isEmpty__Z())) {
      var arg1$2 = these.head__O();
      b.$$plus$eq__O__scm_Builder(f(arg1$2));
      these = $as_sci_List(these.tail__O())
    };
    var jsx$1 = b.result__O()
  };
  jsx$2.println__T__V((("Try " + this.oxford$1__p1__sci_List__T($as_sci_List(jsx$1))) + " for more information."))
});
$c_Lscopt_OptionParser.prototype.handleOccurrence$1__p1__Lscopt_OptionDef__scm_ListBuffer__scm_Map__V = (function(opt, pending, occurrences$1) {
  occurrences$1.update__O__O__V(opt, ((1 + $uI(occurrences$1.apply__O__O(opt))) | 0));
  if (($uI(occurrences$1.apply__O__O(opt)) >= opt.$$undmaxOccurs$1)) {
    pending.$$minus$eq__O__scm_ListBuffer(opt)
  }
});
$c_Lscopt_OptionParser.prototype.renderTwoColumnsUsage__T = (function() {
  var xs = this.optionsForRender__sci_List();
  var x$1 = $m_Lscopt_OptionDef$().column1MaxLength$1;
  var f = (function($this) {
    return (function(x$14$2) {
      var x$14 = $as_Lscopt_OptionDef(x$14$2);
      var thiz = x$14.usageColumn1__T();
      var jsx$1 = $uI(thiz.length);
      var thiz$1 = $m_Lscopt_OptionDef$().WW$1;
      return ((jsx$1 + $uI(thiz$1.length)) | 0)
    })
  })(this);
  var this$3 = $m_sci_List$();
  var bf = this$3.ReusableCBFInstance$2;
  if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
    if ((xs === $m_sci_Nil$())) {
      var jsx$2 = $m_sci_Nil$()
    } else {
      var arg1 = xs.head__O();
      var h = new $c_sci_$colon$colon().init___O__sci_List(f(arg1), $m_sci_Nil$());
      var t = h;
      var rest = $as_sci_List(xs.tail__O());
      while ((rest !== $m_sci_Nil$())) {
        var arg1$1 = rest.head__O();
        var nx = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$1), $m_sci_Nil$());
        t.tl$5 = nx;
        t = nx;
        rest = $as_sci_List(rest.tail__O())
      };
      var jsx$2 = h
    }
  } else {
    var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(xs, bf);
    var these = xs;
    while ((!these.isEmpty__Z())) {
      var arg1$2 = these.head__O();
      b.$$plus$eq__O__scm_Builder(f(arg1$2));
      these = $as_sci_List(these.tail__O())
    };
    var jsx$2 = b.result__O()
  };
  var x1 = $as_sci_List(jsx$2);
  var x = $m_sci_Nil$();
  if (x.equals__O__Z(x1)) {
    var y = 0
  } else {
    var cmp = $m_s_math_Ordering$Int$();
    var y = $uI($f_sc_TraversableOnce__max__s_math_Ordering__O(x1, cmp))
  };
  var col1Len = ((x$1 < y) ? x$1 : y);
  var f$1 = (function(this$2$1, col1Len$1) {
    return (function(x$15$2) {
      var x$15 = $as_Lscopt_OptionDef(x$15$2);
      return x$15.usageTwoColumn__I__T(col1Len$1)
    })
  })(this, col1Len);
  var this$6 = $m_sci_List$();
  var bf$1 = this$6.ReusableCBFInstance$2;
  if ((bf$1 === $m_sci_List$().ReusableCBFInstance$2)) {
    if ((xs === $m_sci_Nil$())) {
      var jsx$3 = $m_sci_Nil$()
    } else {
      var arg1$3 = xs.head__O();
      var h$1 = new $c_sci_$colon$colon().init___O__sci_List(f$1(arg1$3), $m_sci_Nil$());
      var t$1 = h$1;
      var rest$1 = $as_sci_List(xs.tail__O());
      while ((rest$1 !== $m_sci_Nil$())) {
        var arg1$4 = rest$1.head__O();
        var nx$1 = new $c_sci_$colon$colon().init___O__sci_List(f$1(arg1$4), $m_sci_Nil$());
        t$1.tl$5 = nx$1;
        t$1 = nx$1;
        rest$1 = $as_sci_List(rest$1.tail__O())
      };
      var jsx$3 = h$1
    }
  } else {
    var b$1 = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(xs, bf$1);
    var these$1 = xs;
    while ((!these$1.isEmpty__Z())) {
      var arg1$5 = these$1.head__O();
      b$1.$$plus$eq__O__scm_Builder(f$1(arg1$5));
      these$1 = $as_sci_List(these$1.tail__O())
    };
    var jsx$3 = b$1.result__O()
  };
  var descriptions = $as_sci_List(jsx$3);
  var jsx$6 = ((this.header__T() === "") ? "" : (("" + this.header__T()) + $m_Lscopt_OptionDef$().NL$1));
  var jsx$5 = this.commandExample__s_Option__T($m_s_None$());
  var jsx$4 = $m_Lscopt_OptionDef$().NLNL$1;
  var sep = $m_Lscopt_OptionDef$().NL$1;
  return ((((jsx$6 + "Usage: ") + jsx$5) + jsx$4) + $f_sc_TraversableOnce__mkString__T__T__T__T(descriptions, "", sep, ""))
});
$c_Lscopt_OptionParser.prototype.header__T = (function() {
  var jsx$2 = this.heads__sc_Seq();
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$12$2) {
      var x$12 = $as_Lscopt_OptionDef(x$12$2);
      return x$12.usage__T()
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  return $as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).mkString__T__T($m_Lscopt_OptionDef$().NL$1)
});
$c_Lscopt_OptionParser.prototype.init___T = (function(programName) {
  this.programName$1 = programName;
  this.options$1 = new $c_scm_ListBuffer().init___();
  this.helpOptions$1 = new $c_scm_ListBuffer().init___();
  return this
});
$c_Lscopt_OptionParser.prototype.renderOneColumnUsage__T = (function() {
  var this$2 = this.optionsForRender__sci_List();
  var f = (function($this) {
    return (function(x$13$2) {
      var x$13 = $as_Lscopt_OptionDef(x$13$2);
      return x$13.usage__T()
    })
  })(this);
  var this$1 = $m_sci_List$();
  var bf = this$1.ReusableCBFInstance$2;
  if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
    if ((this$2 === $m_sci_Nil$())) {
      var jsx$1 = $m_sci_Nil$()
    } else {
      var arg1 = this$2.head__O();
      var h = new $c_sci_$colon$colon().init___O__sci_List(f(arg1), $m_sci_Nil$());
      var t = h;
      var rest = $as_sci_List(this$2.tail__O());
      while ((rest !== $m_sci_Nil$())) {
        var arg1$1 = rest.head__O();
        var nx = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$1), $m_sci_Nil$());
        t.tl$5 = nx;
        t = nx;
        rest = $as_sci_List(rest.tail__O())
      };
      var jsx$1 = h
    }
  } else {
    var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$2, bf);
    var these = this$2;
    while ((!these.isEmpty__Z())) {
      var arg1$2 = these.head__O();
      b.$$plus$eq__O__scm_Builder(f(arg1$2));
      these = $as_sci_List(these.tail__O())
    };
    var jsx$1 = b.result__O()
  };
  var descriptions = $as_sci_List(jsx$1);
  var jsx$4 = ((this.header__T() === "") ? "" : (("" + this.header__T()) + $m_Lscopt_OptionDef$().NL$1));
  var jsx$3 = this.commandExample__s_Option__T($m_s_None$());
  var jsx$2 = $m_Lscopt_OptionDef$().NLNL$1;
  var sep = $m_Lscopt_OptionDef$().NL$1;
  return ((((jsx$4 + "Usage: ") + jsx$3) + jsx$2) + $f_sc_TraversableOnce__mkString__T__T__T__T(descriptions, "", sep, ""))
});
$c_Lscopt_OptionParser.prototype.arguments__sc_Seq = (function() {
  var this$1 = this.options$1;
  var this$2 = this$1.scala$collection$mutable$ListBuffer$$start$6;
  var f = (function($this) {
    return (function(x$27$2) {
      var x$27 = $as_Lscopt_OptionDef(x$27$2);
      var x = x$27.kind$1;
      var x$2 = $m_Lscopt_Arg$();
      return ((x !== null) && (x === x$2))
    })
  })(this);
  if ((this$2 !== null)) {
    var l = this$2;
    var l$1 = l;
    x: {
      var result;
      _noneIn: while (true) {
        if (l$1.isEmpty__Z()) {
          var result = $m_sci_Nil$();
          break
        } else {
          var h = l$1.head__O();
          var t = $as_sci_List(l$1.tail__O());
          if (($uZ(f(h)) === false)) {
            l$1 = t;
            continue _noneIn
          };
          var start = l$1;
          var remaining = t;
          var remaining$1 = remaining;
          _allIn: while (true) {
            if (remaining$1.isEmpty__Z()) {
              var result = start;
              break x
            } else {
              var x$2$1 = remaining$1.head__O();
              if (($uZ(f(x$2$1)) !== false)) {
                remaining$1 = $as_sci_List(remaining$1.tail__O());
                continue _allIn
              };
              var firstMiss = remaining$1;
              var newHead = new $c_sci_$colon$colon().init___O__sci_List(start.head__O(), $m_sci_Nil$());
              var toProcess = $as_sci_List(start.tail__O());
              var currentLast = newHead;
              while ((toProcess !== firstMiss)) {
                var newElem = new $c_sci_$colon$colon().init___O__sci_List(toProcess.head__O(), $m_sci_Nil$());
                currentLast.tl$5 = newElem;
                currentLast = newElem;
                toProcess = $as_sci_List(toProcess.tail__O())
              };
              var next = $as_sci_List(firstMiss.tail__O());
              var nextToCopy = next;
              while ((!next.isEmpty__Z())) {
                var head = next.head__O();
                if (($uZ(f(head)) !== false)) {
                  next = $as_sci_List(next.tail__O())
                } else {
                  while ((nextToCopy !== next)) {
                    var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy.head__O(), $m_sci_Nil$());
                    currentLast.tl$5 = newElem$2;
                    currentLast = newElem$2;
                    nextToCopy = $as_sci_List(nextToCopy.tail__O())
                  };
                  nextToCopy = $as_sci_List(next.tail__O());
                  next = $as_sci_List(next.tail__O())
                }
              };
              if ((!nextToCopy.isEmpty__Z())) {
                currentLast.tl$5 = nextToCopy
              };
              var result = newHead;
              break x
            }
          }
        }
      }
    };
    return result
  } else {
    $m_sci_List$();
    var b = new $c_scm_ListBuffer().init___();
    var these = this$2;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      if (($uZ(f(arg1)) !== false)) {
        b.$$plus$eq__O__scm_ListBuffer(arg1)
      };
      these = $as_sci_List(these.tail__O())
    };
    return b.toList__sci_List()
  }
});
$c_Lscopt_OptionParser.prototype.nonArgs__sc_Seq = (function() {
  var this$1 = this.options$1;
  var this$2 = this$1.scala$collection$mutable$ListBuffer$$start$6;
  var f = (function($this) {
    return (function(x0$3$2) {
      var x0$3 = $as_Lscopt_OptionDef(x0$3$2);
      var x = x0$3.kind$1;
      var x$2 = $m_Lscopt_Opt$();
      if (((x !== null) && (x === x$2))) {
        return true
      } else {
        var x$3 = x0$3.kind$1;
        var x$4 = $m_Lscopt_Note$();
        return ((x$3 !== null) && (x$3 === x$4))
      }
    })
  })(this);
  if ((this$2 !== null)) {
    var l = this$2;
    var l$1 = l;
    x: {
      var result;
      _noneIn: while (true) {
        if (l$1.isEmpty__Z()) {
          var result = $m_sci_Nil$();
          break
        } else {
          var h = l$1.head__O();
          var t = $as_sci_List(l$1.tail__O());
          if (($uZ(f(h)) === false)) {
            l$1 = t;
            continue _noneIn
          };
          var start = l$1;
          var remaining = t;
          var remaining$1 = remaining;
          _allIn: while (true) {
            if (remaining$1.isEmpty__Z()) {
              var result = start;
              break x
            } else {
              var x$2$1 = remaining$1.head__O();
              if (($uZ(f(x$2$1)) !== false)) {
                remaining$1 = $as_sci_List(remaining$1.tail__O());
                continue _allIn
              };
              var firstMiss = remaining$1;
              var newHead = new $c_sci_$colon$colon().init___O__sci_List(start.head__O(), $m_sci_Nil$());
              var toProcess = $as_sci_List(start.tail__O());
              var currentLast = newHead;
              while ((toProcess !== firstMiss)) {
                var newElem = new $c_sci_$colon$colon().init___O__sci_List(toProcess.head__O(), $m_sci_Nil$());
                currentLast.tl$5 = newElem;
                currentLast = newElem;
                toProcess = $as_sci_List(toProcess.tail__O())
              };
              var next = $as_sci_List(firstMiss.tail__O());
              var nextToCopy = next;
              while ((!next.isEmpty__Z())) {
                var head = next.head__O();
                if (($uZ(f(head)) !== false)) {
                  next = $as_sci_List(next.tail__O())
                } else {
                  while ((nextToCopy !== next)) {
                    var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy.head__O(), $m_sci_Nil$());
                    currentLast.tl$5 = newElem$2;
                    currentLast = newElem$2;
                    nextToCopy = $as_sci_List(nextToCopy.tail__O())
                  };
                  nextToCopy = $as_sci_List(next.tail__O());
                  next = $as_sci_List(next.tail__O())
                }
              };
              if ((!nextToCopy.isEmpty__Z())) {
                currentLast.tl$5 = nextToCopy
              };
              var result = newHead;
              break x
            }
          }
        }
      }
    };
    return result
  } else {
    $m_sci_List$();
    var b = new $c_scm_ListBuffer().init___();
    var these = this$2;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      if (($uZ(f(arg1)) !== false)) {
        b.$$plus$eq__O__scm_ListBuffer(arg1)
      };
      these = $as_sci_List(these.tail__O())
    };
    return b.toList__sci_List()
  }
});
$c_Lscopt_OptionParser.prototype.updateOption__Lscopt_OptionDef__Lscopt_Read__Lscopt_OptionDef = (function(option, evidence$12) {
  var this$1 = this.options$1;
  var this$2 = this$1.scala$collection$mutable$ListBuffer$$start$6;
  inlinereturn$7: {
    var i = 0;
    var these = this$2.drop__I__sci_List(0);
    while (true) {
      var this$5 = these;
      if ($f_sc_TraversableOnce__nonEmpty__Z(this$5)) {
        var arg1 = these.head__O();
        var x$30 = $as_Lscopt_OptionDef(arg1);
        if ((x$30.id$1 === option.id$1)) {
          var idx = i;
          break inlinereturn$7
        };
        i = ((1 + i) | 0);
        these = $as_sc_LinearSeqOptimized(these.tail__O())
      } else {
        break
      }
    };
    var idx = (-1)
  };
  if ((idx > (-1))) {
    this.options$1.update__I__O__V(idx, option)
  } else {
    this.options$1.$$plus$eq__O__scm_ListBuffer(option)
  };
  return option
});
$c_Lscopt_OptionParser.prototype.arg__T__Lscopt_Read__Lscopt_OptionDef = (function(name, evidence$10) {
  var this$1 = this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Arg$(), name, evidence$10);
  return this$1.minOccurs__I__Lscopt_OptionDef(1)
});
$c_Lscopt_OptionParser.prototype.renderUsage__Lscopt_RenderingMode__T = (function(mode) {
  var x = $m_Lscopt_RenderingMode$OneColumn$();
  if ((x === mode)) {
    return this.renderOneColumnUsage__T()
  } else {
    var x$3 = $m_Lscopt_RenderingMode$TwoColumns$();
    if ((x$3 === mode)) {
      return this.renderTwoColumnsUsage__T()
    } else {
      throw new $c_s_MatchError().init___O(mode)
    }
  }
});
/** @constructor */
function $c_Lscopt_Validation$() {
  $c_O.call(this)
}
$c_Lscopt_Validation$.prototype = new $h_O();
$c_Lscopt_Validation$.prototype.constructor = $c_Lscopt_Validation$;
/** @constructor */
function $h_Lscopt_Validation$() {
  /*<skip>*/
}
$h_Lscopt_Validation$.prototype = $c_Lscopt_Validation$.prototype;
$c_Lscopt_Validation$.prototype.init___ = (function() {
  return this
});
$c_Lscopt_Validation$.prototype.validateValue__sc_Seq__O__s_util_Either = (function(vs, value) {
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, value$1) {
    return (function(x$9$2) {
      var x$9 = $as_F1(x$9$2);
      return $as_s_util_Either(x$9.apply__O__O(value$1))
    })
  })(this, value));
  var this$1 = $m_sc_Seq$();
  var results = $as_sc_Seq(vs.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  $m_Lscopt_OptionDef$();
  $m_s_package$();
  var x$10 = new $c_s_util_Right().init___O((void 0));
  return $as_s_util_Either(results.$$div$colon__O__F2__O(x$10, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$2$1) {
    return (function(acc$2, r$2) {
      var acc = $as_s_util_Either(acc$2);
      var r = $as_s_util_Either(r$2);
      if ((acc instanceof $c_s_util_Right)) {
        var jsx$3 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
      } else {
        if ((!(acc instanceof $c_s_util_Left))) {
          throw new $c_s_MatchError().init___O(acc)
        };
        var x4 = $as_s_util_Left(acc);
        var xs = $as_sc_Seq(x4.value$2);
        var jsx$3 = xs
      };
      if ((r instanceof $c_s_util_Right)) {
        var jsx$2 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
      } else {
        if ((!(r instanceof $c_s_util_Left))) {
          throw new $c_s_MatchError().init___O(r)
        };
        var x4$2 = $as_s_util_Left(r);
        var x = $as_T(x4$2.value$2);
        var jsx$2 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array([x])))
      };
      var this$4 = $m_sc_Seq$();
      var x1$3 = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$4.ReusableCBFInstance$2));
      $m_sc_Seq$();
      var o7 = new $c_s_Some().init___O(x1$3);
      if (((o7.value$2 !== null) && ($as_sc_SeqLike(o7.value$2).lengthCompare__I__I(0) === 0))) {
        return acc
      };
      $m_s_package$();
      return new $c_s_util_Left().init___O(x1$3)
    })
  })(this))))
});
var $d_Lscopt_Validation$ = new $TypeData().initClass({
  Lscopt_Validation$: 0
}, false, "scopt.Validation$", {
  Lscopt_Validation$: 1,
  O: 1
});
$c_Lscopt_Validation$.prototype.$classData = $d_Lscopt_Validation$;
var $n_Lscopt_Validation$ = (void 0);
function $m_Lscopt_Validation$() {
  if ((!$n_Lscopt_Validation$)) {
    $n_Lscopt_Validation$ = new $c_Lscopt_Validation$().init___()
  };
  return $n_Lscopt_Validation$
}
/** @constructor */
function $c_Lscopt_platform$() {
  $c_O.call(this);
  this.$$undNL$1 = null
}
$c_Lscopt_platform$.prototype = new $h_O();
$c_Lscopt_platform$.prototype.constructor = $c_Lscopt_platform$;
/** @constructor */
function $h_Lscopt_platform$() {
  /*<skip>*/
}
$h_Lscopt_platform$.prototype = $c_Lscopt_platform$.prototype;
$c_Lscopt_platform$.prototype.init___ = (function() {
  $n_Lscopt_platform$ = this;
  this.$$undNL$1 = $as_T($i_os.EOL);
  return this
});
var $d_Lscopt_platform$ = new $TypeData().initClass({
  Lscopt_platform$: 0
}, false, "scopt.platform$", {
  Lscopt_platform$: 1,
  O: 1
});
$c_Lscopt_platform$.prototype.$classData = $d_Lscopt_platform$;
var $n_Lscopt_platform$ = (void 0);
function $m_Lscopt_platform$() {
  if ((!$n_Lscopt_platform$)) {
    $n_Lscopt_platform$ = new $c_Lscopt_platform$().init___()
  };
  return $n_Lscopt_platform$
}
/** @constructor */
function $c_jl_Class() {
  $c_O.call(this);
  this.data$1 = null
}
$c_jl_Class.prototype = new $h_O();
$c_jl_Class.prototype.constructor = $c_jl_Class;
/** @constructor */
function $h_jl_Class() {
  /*<skip>*/
}
$h_jl_Class.prototype = $c_jl_Class.prototype;
$c_jl_Class.prototype.getName__T = (function() {
  return $as_T(this.data$1.name)
});
$c_jl_Class.prototype.getComponentType__jl_Class = (function() {
  return $as_jl_Class(this.data$1.getComponentType())
});
$c_jl_Class.prototype.isPrimitive__Z = (function() {
  return $uZ(this.data$1.isPrimitive)
});
$c_jl_Class.prototype.toString__T = (function() {
  return ((this.isInterface__Z() ? "interface " : (this.isPrimitive__Z() ? "" : "class ")) + this.getName__T())
});
$c_jl_Class.prototype.isAssignableFrom__jl_Class__Z = (function(that) {
  return ((this.isPrimitive__Z() || that.isPrimitive__Z()) ? ((this === that) || ((this === $d_S.getClassOf()) ? (that === $d_B.getClassOf()) : ((this === $d_I.getClassOf()) ? ((that === $d_B.getClassOf()) || (that === $d_S.getClassOf())) : ((this === $d_F.getClassOf()) ? (((that === $d_B.getClassOf()) || (that === $d_S.getClassOf())) || (that === $d_I.getClassOf())) : ((this === $d_D.getClassOf()) && ((((that === $d_B.getClassOf()) || (that === $d_S.getClassOf())) || (that === $d_I.getClassOf())) || (that === $d_F.getClassOf()))))))) : this.isInstance__O__Z(that.getFakeInstance__p1__O()))
});
$c_jl_Class.prototype.isInstance__O__Z = (function(obj) {
  return $uZ(this.data$1.isInstance(obj))
});
$c_jl_Class.prototype.init___jl_ScalaJSClassData = (function(data) {
  this.data$1 = data;
  return this
});
$c_jl_Class.prototype.getFakeInstance__p1__O = (function() {
  return this.data$1.getFakeInstance()
});
$c_jl_Class.prototype.newArrayOfThisClass__sjs_js_Array__O = (function(dimensions) {
  return this.data$1.newArrayOfThisClass(dimensions)
});
$c_jl_Class.prototype.getSimpleName__T = (function() {
  var name = $as_T(this.data$1.name);
  var idx = (((-1) + $uI(name.length)) | 0);
  while (true) {
    if ((idx >= 0)) {
      var index = idx;
      var jsx$1 = ((65535 & $uI(name.charCodeAt(index))) === 36)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      idx = (((-1) + idx) | 0)
    } else {
      break
    }
  };
  while (true) {
    if ((idx >= 0)) {
      var index$1 = idx;
      var currChar = (65535 & $uI(name.charCodeAt(index$1)));
      var jsx$2 = ((currChar !== 46) && (currChar !== 36))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      idx = (((-1) + idx) | 0)
    } else {
      break
    }
  };
  var beginIndex = ((1 + idx) | 0);
  return $as_T(name.substring(beginIndex))
});
$c_jl_Class.prototype.isArray__Z = (function() {
  return $uZ(this.data$1.isArrayClass)
});
$c_jl_Class.prototype.isInterface__Z = (function() {
  return $uZ(this.data$1.isInterface)
});
function $as_jl_Class(obj) {
  return (((obj instanceof $c_jl_Class) || (obj === null)) ? obj : $throwClassCastException(obj, "java.lang.Class"))
}
function $isArrayOf_jl_Class(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_Class)))
}
function $asArrayOf_jl_Class(obj, depth) {
  return (($isArrayOf_jl_Class(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.Class;", depth))
}
var $d_jl_Class = new $TypeData().initClass({
  jl_Class: 0
}, false, "java.lang.Class", {
  jl_Class: 1,
  O: 1
});
$c_jl_Class.prototype.$classData = $d_jl_Class;
/** @constructor */
function $c_jl_Long$StringRadixInfo() {
  $c_O.call(this);
  this.chunkLength$1 = 0;
  this.radixPowLength$1 = $m_sjsr_RuntimeLong$().Zero__sjsr_RuntimeLong();
  this.paddingZeros$1 = null;
  this.overflowBarrier$1 = $m_sjsr_RuntimeLong$().Zero__sjsr_RuntimeLong()
}
$c_jl_Long$StringRadixInfo.prototype = new $h_O();
$c_jl_Long$StringRadixInfo.prototype.constructor = $c_jl_Long$StringRadixInfo;
/** @constructor */
function $h_jl_Long$StringRadixInfo() {
  /*<skip>*/
}
$h_jl_Long$StringRadixInfo.prototype = $c_jl_Long$StringRadixInfo.prototype;
$c_jl_Long$StringRadixInfo.prototype.init___I__J__T__J = (function(chunkLength, radixPowLength, paddingZeros, overflowBarrier) {
  this.chunkLength$1 = chunkLength;
  this.radixPowLength$1 = radixPowLength;
  this.paddingZeros$1 = paddingZeros;
  this.overflowBarrier$1 = overflowBarrier;
  return this
});
function $as_jl_Long$StringRadixInfo(obj) {
  return (((obj instanceof $c_jl_Long$StringRadixInfo) || (obj === null)) ? obj : $throwClassCastException(obj, "java.lang.Long$StringRadixInfo"))
}
function $isArrayOf_jl_Long$StringRadixInfo(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_Long$StringRadixInfo)))
}
function $asArrayOf_jl_Long$StringRadixInfo(obj, depth) {
  return (($isArrayOf_jl_Long$StringRadixInfo(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.Long$StringRadixInfo;", depth))
}
var $d_jl_Long$StringRadixInfo = new $TypeData().initClass({
  jl_Long$StringRadixInfo: 0
}, false, "java.lang.Long$StringRadixInfo", {
  jl_Long$StringRadixInfo: 1,
  O: 1
});
$c_jl_Long$StringRadixInfo.prototype.$classData = $d_jl_Long$StringRadixInfo;
/** @constructor */
function $c_jl_Runtime() {
  $c_O.call(this)
}
$c_jl_Runtime.prototype = new $h_O();
$c_jl_Runtime.prototype.constructor = $c_jl_Runtime;
/** @constructor */
function $h_jl_Runtime() {
  /*<skip>*/
}
$h_jl_Runtime.prototype = $c_jl_Runtime.prototype;
$c_jl_Runtime.prototype.init___ = (function() {
  return this
});
$c_jl_Runtime.prototype.halt__I__V = (function(status) {
  var envInfo = $env;
  var value = envInfo.exitFunction;
  if ((value === (void 0))) {
    throw new $c_jl_SecurityException().init___T("Cannot terminate a JavaScript program. Define a JavaScript function `__ScalaJSEnv.exitFunction` to be called on exit.")
  } else {
    value(status);
    throw new $c_jl_IllegalStateException().init___T("__ScalaJSEnv.exitFunction returned")
  }
});
var $d_jl_Runtime = new $TypeData().initClass({
  jl_Runtime: 0
}, false, "java.lang.Runtime", {
  jl_Runtime: 1,
  O: 1
});
$c_jl_Runtime.prototype.$classData = $d_jl_Runtime;
/** @constructor */
function $c_jl_Runtime$() {
  $c_O.call(this);
  this.currentRuntime$1 = null
}
$c_jl_Runtime$.prototype = new $h_O();
$c_jl_Runtime$.prototype.constructor = $c_jl_Runtime$;
/** @constructor */
function $h_jl_Runtime$() {
  /*<skip>*/
}
$h_jl_Runtime$.prototype = $c_jl_Runtime$.prototype;
$c_jl_Runtime$.prototype.init___ = (function() {
  $n_jl_Runtime$ = this;
  this.currentRuntime$1 = new $c_jl_Runtime().init___();
  return this
});
var $d_jl_Runtime$ = new $TypeData().initClass({
  jl_Runtime$: 0
}, false, "java.lang.Runtime$", {
  jl_Runtime$: 1,
  O: 1
});
$c_jl_Runtime$.prototype.$classData = $d_jl_Runtime$;
var $n_jl_Runtime$ = (void 0);
function $m_jl_Runtime$() {
  if ((!$n_jl_Runtime$)) {
    $n_jl_Runtime$ = new $c_jl_Runtime$().init___()
  };
  return $n_jl_Runtime$
}
/** @constructor */
function $c_jl_System$() {
  $c_O.call(this);
  this.out$1 = null;
  this.err$1 = null;
  this.in$1 = null;
  this.getHighPrecisionTime$1 = null
}
$c_jl_System$.prototype = new $h_O();
$c_jl_System$.prototype.constructor = $c_jl_System$;
/** @constructor */
function $h_jl_System$() {
  /*<skip>*/
}
$h_jl_System$.prototype = $c_jl_System$.prototype;
$c_jl_System$.prototype.init___ = (function() {
  $n_jl_System$ = this;
  this.out$1 = new $c_jl_JSConsoleBasedPrintStream().init___Z(false);
  this.err$1 = new $c_jl_JSConsoleBasedPrintStream().init___Z(true);
  this.in$1 = null;
  var x = $g.performance;
  if ($uZ((!(!x)))) {
    var x$1 = $g.performance.now;
    if ($uZ((!(!x$1)))) {
      var jsx$1 = (function() {
        return $m_jl_System$().java$lang$System$$$anonfun$getHighPrecisionTime$1__D()
      })
    } else {
      var x$2 = $g.performance.webkitNow;
      if ($uZ((!(!x$2)))) {
        var jsx$1 = (function() {
          return $m_jl_System$().java$lang$System$$$anonfun$getHighPrecisionTime$2__D()
        })
      } else {
        var jsx$1 = (function() {
          return $m_jl_System$().java$lang$System$$$anonfun$getHighPrecisionTime$3__D()
        })
      }
    }
  } else {
    var jsx$1 = (function() {
      return $m_jl_System$().java$lang$System$$$anonfun$getHighPrecisionTime$4__D()
    })
  };
  this.getHighPrecisionTime$1 = jsx$1;
  return this
});
$c_jl_System$.prototype.java$lang$System$$$anonfun$getHighPrecisionTime$3__D = (function() {
  return $uD(new $g.Date().getTime())
});
$c_jl_System$.prototype.java$lang$System$$$anonfun$getHighPrecisionTime$1__D = (function() {
  return $uD($g.performance.now())
});
$c_jl_System$.prototype.java$lang$System$$$anonfun$getHighPrecisionTime$4__D = (function() {
  return $uD(new $g.Date().getTime())
});
$c_jl_System$.prototype.java$lang$System$$$anonfun$getHighPrecisionTime$2__D = (function() {
  return $uD($g.performance.webkitNow())
});
var $d_jl_System$ = new $TypeData().initClass({
  jl_System$: 0
}, false, "java.lang.System$", {
  jl_System$: 1,
  O: 1
});
$c_jl_System$.prototype.$classData = $d_jl_System$;
var $n_jl_System$ = (void 0);
function $m_jl_System$() {
  if ((!$n_jl_System$)) {
    $n_jl_System$ = new $c_jl_System$().init___()
  };
  return $n_jl_System$
}
/** @constructor */
function $c_jl_Thread$() {
  $c_O.call(this);
  this.SingleThread$1 = null
}
$c_jl_Thread$.prototype = new $h_O();
$c_jl_Thread$.prototype.constructor = $c_jl_Thread$;
/** @constructor */
function $h_jl_Thread$() {
  /*<skip>*/
}
$h_jl_Thread$.prototype = $c_jl_Thread$.prototype;
$c_jl_Thread$.prototype.init___ = (function() {
  $n_jl_Thread$ = this;
  this.SingleThread$1 = new $c_jl_Thread().init___sr_BoxedUnit((void 0));
  return this
});
var $d_jl_Thread$ = new $TypeData().initClass({
  jl_Thread$: 0
}, false, "java.lang.Thread$", {
  jl_Thread$: 1,
  O: 1
});
$c_jl_Thread$.prototype.$classData = $d_jl_Thread$;
var $n_jl_Thread$ = (void 0);
function $m_jl_Thread$() {
  if ((!$n_jl_Thread$)) {
    $n_jl_Thread$ = new $c_jl_Thread$().init___()
  };
  return $n_jl_Thread$
}
/** @constructor */
function $c_jl_ThreadLocal() {
  $c_O.call(this);
  this.hasValue$1 = false;
  this.v$1 = null
}
$c_jl_ThreadLocal.prototype = new $h_O();
$c_jl_ThreadLocal.prototype.constructor = $c_jl_ThreadLocal;
/** @constructor */
function $h_jl_ThreadLocal() {
  /*<skip>*/
}
$h_jl_ThreadLocal.prototype = $c_jl_ThreadLocal.prototype;
$c_jl_ThreadLocal.prototype.init___ = (function() {
  this.hasValue$1 = false;
  return this
});
$c_jl_ThreadLocal.prototype.remove__V = (function() {
  this.hasValue$1 = false;
  this.v$1 = null
});
$c_jl_ThreadLocal.prototype.get__O = (function() {
  if ((!this.hasValue$1)) {
    this.set__O__V(null)
  };
  return this.v$1
});
$c_jl_ThreadLocal.prototype.set__O__V = (function(o) {
  this.v$1 = o;
  this.hasValue$1 = true
});
var $d_jl_ThreadLocal = new $TypeData().initClass({
  jl_ThreadLocal: 0
}, false, "java.lang.ThreadLocal", {
  jl_ThreadLocal: 1,
  O: 1
});
$c_jl_ThreadLocal.prototype.$classData = $d_jl_ThreadLocal;
/** @constructor */
function $c_jl_reflect_Array$() {
  $c_O.call(this)
}
$c_jl_reflect_Array$.prototype = new $h_O();
$c_jl_reflect_Array$.prototype.constructor = $c_jl_reflect_Array$;
/** @constructor */
function $h_jl_reflect_Array$() {
  /*<skip>*/
}
$h_jl_reflect_Array$.prototype = $c_jl_reflect_Array$.prototype;
$c_jl_reflect_Array$.prototype.init___ = (function() {
  return this
});
$c_jl_reflect_Array$.prototype.newInstance__jl_Class__I__O = (function(componentType, length) {
  return componentType.newArrayOfThisClass__sjs_js_Array__O([length])
});
var $d_jl_reflect_Array$ = new $TypeData().initClass({
  jl_reflect_Array$: 0
}, false, "java.lang.reflect.Array$", {
  jl_reflect_Array$: 1,
  O: 1
});
$c_jl_reflect_Array$.prototype.$classData = $d_jl_reflect_Array$;
var $n_jl_reflect_Array$ = (void 0);
function $m_jl_reflect_Array$() {
  if ((!$n_jl_reflect_Array$)) {
    $n_jl_reflect_Array$ = new $c_jl_reflect_Array$().init___()
  };
  return $n_jl_reflect_Array$
}
/** @constructor */
function $c_ju_Arrays$() {
  $c_O.call(this)
}
$c_ju_Arrays$.prototype = new $h_O();
$c_ju_Arrays$.prototype.constructor = $c_ju_Arrays$;
/** @constructor */
function $h_ju_Arrays$() {
  /*<skip>*/
}
$h_ju_Arrays$.prototype = $c_ju_Arrays$.prototype;
$c_ju_Arrays$.prototype.init___ = (function() {
  return this
});
$c_ju_Arrays$.prototype.binarySearch__AJ__J__I = (function(a, key) {
  var startIndex = 0;
  var endIndex = a.u.length;
  _binarySearchImpl: while (true) {
    if ((startIndex === endIndex)) {
      return (((-1) - startIndex) | 0)
    } else {
      var mid = ((((startIndex + endIndex) | 0) >>> 1) | 0);
      var elem = a.get(mid);
      var t = $uJ(elem);
      var lo = t.lo$2;
      var hi = t.hi$2;
      var ahi = key.hi$2;
      if (((ahi === hi) ? (((-2147483648) ^ key.lo$2) < ((-2147483648) ^ lo)) : (ahi < hi))) {
        endIndex = mid;
        continue _binarySearchImpl
      } else if ($m_sr_BoxesRunTime$().equals__O__O__Z(key, elem)) {
        return mid
      } else {
        startIndex = ((1 + mid) | 0);
        continue _binarySearchImpl
      }
    }
  }
});
$c_ju_Arrays$.prototype.equals__AD__AD__Z = (function(a, b) {
  if ((a === b)) {
    return true
  };
  if (((a === null) || (b === null))) {
    return false
  };
  var len = a.u.length;
  if ((b.u.length !== len)) {
    return false
  };
  var i = 0;
  while ((i !== len)) {
    if ((!$m_sr_BoxesRunTime$().equals__O__O__Z(a.get(i), b.get(i)))) {
      return false
    };
    i = ((1 + i) | 0)
  };
  return true
});
$c_ju_Arrays$.prototype.equals__AI__AI__Z = (function(a, b) {
  if ((a === b)) {
    return true
  };
  if (((a === null) || (b === null))) {
    return false
  };
  var len = a.u.length;
  if ((b.u.length !== len)) {
    return false
  };
  var i = 0;
  while ((i !== len)) {
    if ((!$m_sr_BoxesRunTime$().equals__O__O__Z(a.get(i), b.get(i)))) {
      return false
    };
    i = ((1 + i) | 0)
  };
  return true
});
$c_ju_Arrays$.prototype.equals__AF__AF__Z = (function(a, b) {
  if ((a === b)) {
    return true
  };
  if (((a === null) || (b === null))) {
    return false
  };
  var len = a.u.length;
  if ((b.u.length !== len)) {
    return false
  };
  var i = 0;
  while ((i !== len)) {
    if ((!$m_sr_BoxesRunTime$().equals__O__O__Z(a.get(i), b.get(i)))) {
      return false
    };
    i = ((1 + i) | 0)
  };
  return true
});
$c_ju_Arrays$.prototype.equals__AJ__AJ__Z = (function(a, b) {
  if ((a === b)) {
    return true
  };
  if (((a === null) || (b === null))) {
    return false
  };
  var len = a.u.length;
  if ((b.u.length !== len)) {
    return false
  };
  var i = 0;
  while ((i !== len)) {
    if ((!$m_sr_BoxesRunTime$().equals__O__O__Z(a.get(i), b.get(i)))) {
      return false
    };
    i = ((1 + i) | 0)
  };
  return true
});
$c_ju_Arrays$.prototype.binarySearch__AI__I__I = (function(a, key) {
  var startIndex = 0;
  var endIndex = a.u.length;
  _binarySearchImpl: while (true) {
    if ((startIndex === endIndex)) {
      return (((-1) - startIndex) | 0)
    } else {
      var mid = ((((startIndex + endIndex) | 0) >>> 1) | 0);
      var elem = a.get(mid);
      if ((key < elem)) {
        endIndex = mid;
        continue _binarySearchImpl
      } else if ($m_sr_BoxesRunTime$().equals__O__O__Z(key, elem)) {
        return mid
      } else {
        startIndex = ((1 + mid) | 0);
        continue _binarySearchImpl
      }
    }
  }
});
$c_ju_Arrays$.prototype.equals__AB__AB__Z = (function(a, b) {
  if ((a === b)) {
    return true
  };
  if (((a === null) || (b === null))) {
    return false
  };
  var len = a.u.length;
  if ((b.u.length !== len)) {
    return false
  };
  var i = 0;
  while ((i !== len)) {
    if ((!$m_sr_BoxesRunTime$().equals__O__O__Z(a.get(i), b.get(i)))) {
      return false
    };
    i = ((1 + i) | 0)
  };
  return true
});
$c_ju_Arrays$.prototype.equals__AZ__AZ__Z = (function(a, b) {
  if ((a === b)) {
    return true
  };
  if (((a === null) || (b === null))) {
    return false
  };
  var len = a.u.length;
  if ((b.u.length !== len)) {
    return false
  };
  var i = 0;
  while ((i !== len)) {
    if ((!$m_sr_BoxesRunTime$().equals__O__O__Z(a.get(i), b.get(i)))) {
      return false
    };
    i = ((1 + i) | 0)
  };
  return true
});
$c_ju_Arrays$.prototype.java$util$Arrays$$insertionSortAnyRef__AO__I__I__s_math_Ordering__V = (function(a, start, end, ord) {
  var n = ((end - start) | 0);
  if ((n >= 2)) {
    if ((ord.compare__O__O__I(a.get(start), a.get(((1 + start) | 0))) > 0)) {
      var temp = a.get(start);
      a.set(start, a.get(((1 + start) | 0)));
      a.set(((1 + start) | 0), temp)
    };
    var m = 2;
    while ((m < n)) {
      var next = a.get(((start + m) | 0));
      if ((ord.compare__O__O__I(next, a.get((((-1) + ((start + m) | 0)) | 0))) < 0)) {
        var iA = start;
        var iB = (((-1) + ((start + m) | 0)) | 0);
        while ((((iB - iA) | 0) > 1)) {
          var ix = ((((iA + iB) | 0) >>> 1) | 0);
          if ((ord.compare__O__O__I(next, a.get(ix)) < 0)) {
            iB = ix
          } else {
            iA = ix
          }
        };
        var ix$2 = ((iA + ((ord.compare__O__O__I(next, a.get(iA)) < 0) ? 0 : 1)) | 0);
        var i = ((start + m) | 0);
        while ((i > ix$2)) {
          a.set(i, a.get((((-1) + i) | 0)));
          i = (((-1) + i) | 0)
        };
        a.set(ix$2, next)
      };
      m = ((1 + m) | 0)
    }
  }
});
$c_ju_Arrays$.prototype.fill__AI__I__V = (function(a, value) {
  var toIndex = a.u.length;
  var i = 0;
  while ((i !== toIndex)) {
    a.set(i, value);
    i = ((1 + i) | 0)
  }
});
$c_ju_Arrays$.prototype.equals__AC__AC__Z = (function(a, b) {
  if ((a === b)) {
    return true
  };
  if (((a === null) || (b === null))) {
    return false
  };
  var len = a.u.length;
  if ((b.u.length !== len)) {
    return false
  };
  var i = 0;
  while ((i !== len)) {
    if ((!$m_sr_BoxesRunTime$().equals__O__O__Z(new $c_jl_Character().init___C(a.get(i)), new $c_jl_Character().init___C(b.get(i))))) {
      return false
    };
    i = ((1 + i) | 0)
  };
  return true
});
$c_ju_Arrays$.prototype.equals__AS__AS__Z = (function(a, b) {
  if ((a === b)) {
    return true
  };
  if (((a === null) || (b === null))) {
    return false
  };
  var len = a.u.length;
  if ((b.u.length !== len)) {
    return false
  };
  var i = 0;
  while ((i !== len)) {
    if ((!$m_sr_BoxesRunTime$().equals__O__O__Z(a.get(i), b.get(i)))) {
      return false
    };
    i = ((1 + i) | 0)
  };
  return true
});
$c_ju_Arrays$.prototype.sort__AO__ju_Comparator__V = (function(array, comparator) {
  var ord = new $c_ju_Arrays$$anon$3().init___ju_Comparator(comparator);
  var end = array.u.length;
  if ((end > 16)) {
    this.java$util$Arrays$$stableSplitMergeAnyRef__AO__AO__I__I__s_math_Ordering__V(array, $newArrayObject($d_O.getArrayOf(), [array.u.length]), 0, end, ord)
  } else {
    this.java$util$Arrays$$insertionSortAnyRef__AO__I__I__s_math_Ordering__V(array, 0, end, ord)
  }
});
$c_ju_Arrays$.prototype.java$util$Arrays$$stableSplitMergeAnyRef__AO__AO__I__I__s_math_Ordering__V = (function(a, temp, start, end, ord) {
  var length = ((end - start) | 0);
  if ((length > 16)) {
    var middle = ((start + ((length / 2) | 0)) | 0);
    this.java$util$Arrays$$stableSplitMergeAnyRef__AO__AO__I__I__s_math_Ordering__V(a, temp, start, middle, ord);
    this.java$util$Arrays$$stableSplitMergeAnyRef__AO__AO__I__I__s_math_Ordering__V(a, temp, middle, end, ord);
    var outIndex = start;
    var leftInIndex = start;
    var rightInIndex = middle;
    while ((outIndex < end)) {
      if (((leftInIndex < middle) && ((rightInIndex >= end) || ord.lteq__O__O__Z(a.get(leftInIndex), a.get(rightInIndex))))) {
        temp.set(outIndex, a.get(leftInIndex));
        leftInIndex = ((1 + leftInIndex) | 0)
      } else {
        temp.set(outIndex, a.get(rightInIndex));
        rightInIndex = ((1 + rightInIndex) | 0)
      };
      outIndex = ((1 + outIndex) | 0)
    };
    $systemArraycopy(temp, start, a, start, length)
  } else {
    this.java$util$Arrays$$insertionSortAnyRef__AO__I__I__s_math_Ordering__V(a, start, end, ord)
  }
});
var $d_ju_Arrays$ = new $TypeData().initClass({
  ju_Arrays$: 0
}, false, "java.util.Arrays$", {
  ju_Arrays$: 1,
  O: 1
});
$c_ju_Arrays$.prototype.$classData = $d_ju_Arrays$;
var $n_ju_Arrays$ = (void 0);
function $m_ju_Arrays$() {
  if ((!$n_ju_Arrays$)) {
    $n_ju_Arrays$ = new $c_ju_Arrays$().init___()
  };
  return $n_ju_Arrays$
}
/** @constructor */
function $c_ju_Formatter$() {
  $c_O.call(this);
  this.java$util$Formatter$$FormatSpecifier$1 = null
}
$c_ju_Formatter$.prototype = new $h_O();
$c_ju_Formatter$.prototype.constructor = $c_ju_Formatter$;
/** @constructor */
function $h_ju_Formatter$() {
  /*<skip>*/
}
$h_ju_Formatter$.prototype = $c_ju_Formatter$.prototype;
$c_ju_Formatter$.prototype.init___ = (function() {
  $n_ju_Formatter$ = this;
  this.java$util$Formatter$$FormatSpecifier$1 = new $g.RegExp("(?:(\\d+)\\$)?([-#+ 0,\\(<]*)(\\d+)?(?:\\.(\\d+))?[%A-Za-z]", "g");
  return this
});
var $d_ju_Formatter$ = new $TypeData().initClass({
  ju_Formatter$: 0
}, false, "java.util.Formatter$", {
  ju_Formatter$: 1,
  O: 1
});
$c_ju_Formatter$.prototype.$classData = $d_ju_Formatter$;
var $n_ju_Formatter$ = (void 0);
function $m_ju_Formatter$() {
  if ((!$n_ju_Formatter$)) {
    $n_ju_Formatter$ = new $c_ju_Formatter$().init___()
  };
  return $n_ju_Formatter$
}
/** @constructor */
function $c_ju_regex_GroupStartMapper() {
  $c_O.call(this);
  this.pattern$1 = null;
  this.flags$1 = null;
  this.node$1 = null;
  this.groupCount$1 = 0;
  this.allMatchingRegex$1 = null
}
$c_ju_regex_GroupStartMapper.prototype = new $h_O();
$c_ju_regex_GroupStartMapper.prototype.constructor = $c_ju_regex_GroupStartMapper;
/** @constructor */
function $h_ju_regex_GroupStartMapper() {
  /*<skip>*/
}
$h_ju_regex_GroupStartMapper.prototype = $c_ju_regex_GroupStartMapper.prototype;
$c_ju_regex_GroupStartMapper.prototype.apply__T__I__sjs_js_Array = (function(string, start) {
  this.allMatchingRegex$1.lastIndex = start;
  var allMatchResult = this.allMatchingRegex$1.exec(string);
  if ((allMatchResult === null)) {
    throw new $c_jl_AssertionError().init___O((((((("[Internal error] Executed '" + this.allMatchingRegex$1) + "' on ") + ((("'" + string) + "' at position ") + start)) + ", got an error.\n") + ((("Original pattern '" + this.pattern$1) + "' with flags '") + this.flags$1)) + "' did match however."))
  };
  var len = ((1 + this.groupCount$1) | 0);
  var groupStartMap = new $g.Array(len);
  var i = 0;
  while ((i !== len)) {
    groupStartMap[i] = (-1);
    i = ((1 + i) | 0)
  };
  this.node$1.propagateFromStart__sjs_js_RegExp$ExecResult__sjs_js_Array__I__I(allMatchResult, groupStartMap, start);
  return groupStartMap
});
$c_ju_regex_GroupStartMapper.prototype.init___T__T__ju_regex_GroupStartMapper$Node__I__sjs_js_RegExp = (function(pattern, flags, node, groupCount, allMatchingRegex) {
  this.pattern$1 = pattern;
  this.flags$1 = flags;
  this.node$1 = node;
  this.groupCount$1 = groupCount;
  this.allMatchingRegex$1 = allMatchingRegex;
  return this
});
var $d_ju_regex_GroupStartMapper = new $TypeData().initClass({
  ju_regex_GroupStartMapper: 0
}, false, "java.util.regex.GroupStartMapper", {
  ju_regex_GroupStartMapper: 1,
  O: 1
});
$c_ju_regex_GroupStartMapper.prototype.$classData = $d_ju_regex_GroupStartMapper;
/** @constructor */
function $c_ju_regex_GroupStartMapper$() {
  $c_O.call(this)
}
$c_ju_regex_GroupStartMapper$.prototype = new $h_O();
$c_ju_regex_GroupStartMapper$.prototype.constructor = $c_ju_regex_GroupStartMapper$;
/** @constructor */
function $h_ju_regex_GroupStartMapper$() {
  /*<skip>*/
}
$h_ju_regex_GroupStartMapper$.prototype = $c_ju_regex_GroupStartMapper$.prototype;
$c_ju_regex_GroupStartMapper$.prototype.init___ = (function() {
  return this
});
$c_ju_regex_GroupStartMapper$.prototype.apply__T__T__ju_regex_GroupStartMapper = (function(pattern, flags) {
  var parser = new $c_ju_regex_GroupStartMapper$Parser().init___T(pattern);
  var node = parser.parseInsideParensAndClosingParen__p1__ju_regex_GroupStartMapper$Node();
  node.setNewGroup__I__I(1);
  var allMatchingRegex = new $g.RegExp(node.buildRegex__sjs_js_Array__T(parser.groupNodeMap$1), flags);
  return new $c_ju_regex_GroupStartMapper().init___T__T__ju_regex_GroupStartMapper$Node__I__sjs_js_RegExp(pattern, flags, node, parser.parsedGroupCount__I(), allMatchingRegex)
});
var $d_ju_regex_GroupStartMapper$ = new $TypeData().initClass({
  ju_regex_GroupStartMapper$: 0
}, false, "java.util.regex.GroupStartMapper$", {
  ju_regex_GroupStartMapper$: 1,
  O: 1
});
$c_ju_regex_GroupStartMapper$.prototype.$classData = $d_ju_regex_GroupStartMapper$;
var $n_ju_regex_GroupStartMapper$ = (void 0);
function $m_ju_regex_GroupStartMapper$() {
  if ((!$n_ju_regex_GroupStartMapper$)) {
    $n_ju_regex_GroupStartMapper$ = new $c_ju_regex_GroupStartMapper$().init___()
  };
  return $n_ju_regex_GroupStartMapper$
}
/** @constructor */
function $c_ju_regex_GroupStartMapper$Node() {
  $c_O.call(this);
  this.newGroup$1 = 0
}
$c_ju_regex_GroupStartMapper$Node.prototype = new $h_O();
$c_ju_regex_GroupStartMapper$Node.prototype.constructor = $c_ju_regex_GroupStartMapper$Node;
/** @constructor */
function $h_ju_regex_GroupStartMapper$Node() {
  /*<skip>*/
}
$h_ju_regex_GroupStartMapper$Node.prototype = $c_ju_regex_GroupStartMapper$Node.prototype;
$c_ju_regex_GroupStartMapper$Node.prototype.propagateFromStart__sjs_js_RegExp$ExecResult__sjs_js_Array__I__I = (function(matchResult, groupStartMap, start) {
  var value = matchResult[this.newGroup$1];
  if ((value === (void 0))) {
    var end = (-1)
  } else {
    var matched = $as_T(value);
    var end = ((start + $uI(matched.length)) | 0)
  };
  this.propagate__sjs_js_RegExp$ExecResult__sjs_js_Array__I__I__V(matchResult, groupStartMap, start, end);
  return end
});
$c_ju_regex_GroupStartMapper$Node.prototype.propagateFromEnd__sjs_js_RegExp$ExecResult__sjs_js_Array__I__I = (function(matchResult, groupStartMap, end) {
  var value = matchResult[this.newGroup$1];
  if ((value === (void 0))) {
    var start = (-1)
  } else {
    var matched = $as_T(value);
    var start = ((end - $uI(matched.length)) | 0)
  };
  this.propagate__sjs_js_RegExp$ExecResult__sjs_js_Array__I__I__V(matchResult, groupStartMap, start, end);
  return start
});
$c_ju_regex_GroupStartMapper$Node.prototype.setNewGroup__I__I = (function(newGroupIndex) {
  this.newGroup$1 = newGroupIndex;
  return ((1 + newGroupIndex) | 0)
});
function $as_ju_regex_GroupStartMapper$Node(obj) {
  return (((obj instanceof $c_ju_regex_GroupStartMapper$Node) || (obj === null)) ? obj : $throwClassCastException(obj, "java.util.regex.GroupStartMapper$Node"))
}
function $isArrayOf_ju_regex_GroupStartMapper$Node(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.ju_regex_GroupStartMapper$Node)))
}
function $asArrayOf_ju_regex_GroupStartMapper$Node(obj, depth) {
  return (($isArrayOf_ju_regex_GroupStartMapper$Node(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.util.regex.GroupStartMapper$Node;", depth))
}
/** @constructor */
function $c_ju_regex_GroupStartMapper$Parser() {
  $c_O.call(this);
  this.pattern$1 = null;
  this.pIndex$1 = 0;
  this.groupNodeMap$1 = null
}
$c_ju_regex_GroupStartMapper$Parser.prototype = new $h_O();
$c_ju_regex_GroupStartMapper$Parser.prototype.constructor = $c_ju_regex_GroupStartMapper$Parser;
/** @constructor */
function $h_ju_regex_GroupStartMapper$Parser() {
  /*<skip>*/
}
$h_ju_regex_GroupStartMapper$Parser.prototype = $c_ju_regex_GroupStartMapper$Parser.prototype;
$c_ju_regex_GroupStartMapper$Parser.prototype.completeSequence$1__p1__sjs_js_Array__ju_regex_GroupStartMapper$Node = (function(sequence) {
  var x1 = $uI(sequence.length);
  switch (x1) {
    case 0: {
      return new $c_ju_regex_GroupStartMapper$LeafRegexNode().init___T("");
      break
    }
    case 1: {
      return $as_ju_regex_GroupStartMapper$Node(sequence[0]);
      break
    }
    default: {
      return new $c_ju_regex_GroupStartMapper$SequenceNode().init___sjs_js_Array(sequence)
    }
  }
});
$c_ju_regex_GroupStartMapper$Parser.prototype.parsedGroupCount__I = (function() {
  return (((-1) + $uI(this.groupNodeMap$1.length)) | 0)
});
$c_ju_regex_GroupStartMapper$Parser.prototype.loop$1__p1__I__I = (function(pIndex) {
  _loop: while (true) {
    var thiz = this.pattern$1;
    var index = pIndex;
    var x1 = (65535 & $uI(thiz.charCodeAt(index)));
    switch (x1) {
      case 92: {
        pIndex = ((2 + pIndex) | 0);
        continue _loop;
        break
      }
      case 93: {
        return ((1 + pIndex) | 0);
        break
      }
      default: {
        pIndex = ((1 + pIndex) | 0);
        continue _loop
      }
    }
  }
});
$c_ju_regex_GroupStartMapper$Parser.prototype.init___T = (function(pattern0) {
  this.pattern$1 = (("" + pattern0) + new $c_jl_Character().init___C(41));
  this.pIndex$1 = 0;
  this.groupNodeMap$1 = [null];
  return this
});
$c_ju_regex_GroupStartMapper$Parser.prototype.parseInsideParensAndClosingParen__p1__ju_regex_GroupStartMapper$Node = (function() {
  var alternatives = [];
  var sequence = [];
  while (true) {
    var thiz = this.pattern$1;
    var index = this.pIndex$1;
    var x1 = (65535 & $uI(thiz.charCodeAt(index)));
    switch (x1) {
      case 124: {
        alternatives.push(this.completeSequence$1__p1__sjs_js_Array__ju_regex_GroupStartMapper$Node(sequence));
        sequence = [];
        this.pIndex$1 = ((1 + this.pIndex$1) | 0);
        var baseNode = null;
        break
      }
      case 41: {
        var baseNode;
        this.pIndex$1 = ((1 + this.pIndex$1) | 0);
        var lastAlternative = this.completeSequence$1__p1__sjs_js_Array__ju_regex_GroupStartMapper$Node(sequence);
        if (($uI(alternatives.length) === 0)) {
          return lastAlternative
        } else {
          alternatives.push(lastAlternative);
          return new $c_ju_regex_GroupStartMapper$AlternativesNode().init___sjs_js_Array(alternatives)
        };
        break
      }
      case 40: {
        var thiz$1 = this.pattern$1;
        var beginIndex = ((1 + this.pIndex$1) | 0);
        var endIndex = ((3 + this.pIndex$1) | 0);
        var indicator = $as_T(thiz$1.substring(beginIndex, endIndex));
        if (((indicator === "?=") || (indicator === "?!"))) {
          this.pIndex$1 = ((3 + this.pIndex$1) | 0);
          var inner = this.parseInsideParensAndClosingParen__p1__ju_regex_GroupStartMapper$Node();
          var baseNode = new $c_ju_regex_GroupStartMapper$ZeroLengthTestNode().init___T__ju_regex_GroupStartMapper$Node(indicator, inner)
        } else if ((indicator === "?:")) {
          this.pIndex$1 = ((3 + this.pIndex$1) | 0);
          var inner$2 = this.parseInsideParensAndClosingParen__p1__ju_regex_GroupStartMapper$Node();
          var baseNode = inner$2
        } else {
          this.pIndex$1 = ((1 + this.pIndex$1) | 0);
          var groupIndex = $uI(this.groupNodeMap$1.length);
          this.groupNodeMap$1.push(null);
          var inner$3 = this.parseInsideParensAndClosingParen__p1__ju_regex_GroupStartMapper$Node();
          var groupNode = new $c_ju_regex_GroupStartMapper$GroupNode().init___I__ju_regex_GroupStartMapper$Node(groupIndex, inner$3);
          this.groupNodeMap$1[groupIndex] = groupNode;
          var baseNode = groupNode
        };
        break
      }
      case 92: {
        var thiz$2 = this.pattern$1;
        var index$1 = ((1 + this.pIndex$1) | 0);
        var c = (65535 & $uI(thiz$2.charCodeAt(index$1)));
        if (((c >= 48) && (c <= 57))) {
          var startIndex = this.pIndex$1;
          this.pIndex$1 = ((2 + this.pIndex$1) | 0);
          while (true) {
            var thiz$3 = this.pattern$1;
            var index$2 = this.pIndex$1;
            var c$1 = (65535 & $uI(thiz$3.charCodeAt(index$2)));
            if (((c$1 >= 48) && (c$1 <= 57))) {
              this.pIndex$1 = ((1 + this.pIndex$1) | 0)
            } else {
              break
            }
          };
          var this$8 = $m_jl_Integer$();
          var thiz$4 = this.pattern$1;
          var beginIndex$1 = ((1 + startIndex) | 0);
          var endIndex$1 = this.pIndex$1;
          var s = $as_T(thiz$4.substring(beginIndex$1, endIndex$1));
          var baseNode = new $c_ju_regex_GroupStartMapper$BackReferenceNode().init___I(this$8.parseInt__T__I__I(s, 10))
        } else {
          var thiz$5 = this.pattern$1;
          var beginIndex$2 = this.pIndex$1;
          var endIndex$2 = ((2 + this.pIndex$1) | 0);
          var e = $as_T(thiz$5.substring(beginIndex$2, endIndex$2));
          this.pIndex$1 = ((2 + this.pIndex$1) | 0);
          var baseNode = new $c_ju_regex_GroupStartMapper$LeafRegexNode().init___T(e)
        };
        break
      }
      case 91: {
        var startIndex$2 = this.pIndex$1;
        this.pIndex$1 = this.loop$1__p1__I__I(((1 + startIndex$2) | 0));
        var thiz$6 = this.pattern$1;
        var endIndex$3 = this.pIndex$1;
        var regex = $as_T(thiz$6.substring(startIndex$2, endIndex$3));
        var baseNode = new $c_ju_regex_GroupStartMapper$LeafRegexNode().init___T(regex);
        break
      }
      default: {
        var thiz$7 = this.pattern$1;
        var beginIndex$3 = this.pIndex$1;
        var endIndex$4 = ((1 + this.pIndex$1) | 0);
        var e$2 = $as_T(thiz$7.substring(beginIndex$3, endIndex$4));
        this.pIndex$1 = ((1 + this.pIndex$1) | 0);
        var baseNode = new $c_ju_regex_GroupStartMapper$LeafRegexNode().init___T(e$2)
      }
    };
    if ((baseNode !== null)) {
      var thiz$8 = this.pattern$1;
      var index$3 = this.pIndex$1;
      var x1$2 = (65535 & $uI(thiz$8.charCodeAt(index$3)));
      switch (x1$2) {
        case 43:
        case 42:
        case 63: {
          var startIndex$3 = this.pIndex$1;
          var thiz$9 = this.pattern$1;
          var index$4 = ((1 + startIndex$3) | 0);
          if (((65535 & $uI(thiz$9.charCodeAt(index$4))) === 63)) {
            this.pIndex$1 = ((2 + this.pIndex$1) | 0)
          } else {
            this.pIndex$1 = ((1 + this.pIndex$1) | 0)
          };
          var thiz$10 = this.pattern$1;
          var endIndex$5 = this.pIndex$1;
          var repeater = $as_T(thiz$10.substring(startIndex$3, endIndex$5));
          $uI(sequence.push(new $c_ju_regex_GroupStartMapper$RepeatedNode().init___ju_regex_GroupStartMapper$Node__T(baseNode, repeater)));
          break
        }
        case 123: {
          var startIndex$4 = this.pIndex$1;
          var thiz$11 = this.pattern$1;
          var fromIndex = ((1 + startIndex$4) | 0);
          this.pIndex$1 = ((1 + $uI(thiz$11.indexOf("}", fromIndex))) | 0);
          var thiz$12 = this.pattern$1;
          var index$5 = this.pIndex$1;
          if (((65535 & $uI(thiz$12.charCodeAt(index$5))) === 63)) {
            this.pIndex$1 = ((1 + this.pIndex$1) | 0)
          };
          var thiz$13 = this.pattern$1;
          var endIndex$6 = this.pIndex$1;
          var repeater$2 = $as_T(thiz$13.substring(startIndex$4, endIndex$6));
          $uI(sequence.push(new $c_ju_regex_GroupStartMapper$RepeatedNode().init___ju_regex_GroupStartMapper$Node__T(baseNode, repeater$2)));
          break
        }
        default: {
          var sequenceLen = $uI(sequence.length);
          if ((((sequenceLen !== 0) && (baseNode instanceof $c_ju_regex_GroupStartMapper$LeafRegexNode)) && (sequence[(((-1) + sequenceLen) | 0)] instanceof $c_ju_regex_GroupStartMapper$LeafRegexNode))) {
            var fused = new $c_ju_regex_GroupStartMapper$LeafRegexNode().init___T((("" + $as_ju_regex_GroupStartMapper$LeafRegexNode(sequence[(((-1) + sequenceLen) | 0)]).regex$2) + $as_ju_regex_GroupStartMapper$LeafRegexNode(baseNode).regex$2));
            sequence[(((-1) + sequenceLen) | 0)] = fused
          } else {
            $uI(sequence.push(baseNode))
          }
        }
      }
    }
  }
});
var $d_ju_regex_GroupStartMapper$Parser = new $TypeData().initClass({
  ju_regex_GroupStartMapper$Parser: 0
}, false, "java.util.regex.GroupStartMapper$Parser", {
  ju_regex_GroupStartMapper$Parser: 1,
  O: 1
});
$c_ju_regex_GroupStartMapper$Parser.prototype.$classData = $d_ju_regex_GroupStartMapper$Parser;
/** @constructor */
function $c_ju_regex_Matcher$() {
  $c_O.call(this)
}
$c_ju_regex_Matcher$.prototype = new $h_O();
$c_ju_regex_Matcher$.prototype.constructor = $c_ju_regex_Matcher$;
/** @constructor */
function $h_ju_regex_Matcher$() {
  /*<skip>*/
}
$h_ju_regex_Matcher$.prototype = $c_ju_regex_Matcher$.prototype;
$c_ju_regex_Matcher$.prototype.init___ = (function() {
  return this
});
$c_ju_regex_Matcher$.prototype.java$util$regex$Matcher$$getGroupCount__sjs_js_RegExp$ExecResult__ju_regex_Pattern__I = (function(lastMatch, pattern) {
  return ((lastMatch !== null) ? (((-1) + $uI(lastMatch.length)) | 0) : pattern.groupCount__I())
});
$c_ju_regex_Matcher$.prototype.quoteReplacement__T__T = (function(s) {
  var result = "";
  var i = 0;
  while ((i < $uI(s.length))) {
    var index = i;
    var c = (65535 & $uI(s.charCodeAt(index)));
    var jsx$2 = result;
    switch (c) {
      case 92:
      case 36: {
        var jsx$1 = ("\\" + new $c_jl_Character().init___C(c));
        break
      }
      default: {
        var jsx$1 = new $c_jl_Character().init___C(c)
      }
    };
    result = (("" + jsx$2) + jsx$1);
    i = ((1 + i) | 0)
  };
  return result
});
var $d_ju_regex_Matcher$ = new $TypeData().initClass({
  ju_regex_Matcher$: 0
}, false, "java.util.regex.Matcher$", {
  ju_regex_Matcher$: 1,
  O: 1
});
$c_ju_regex_Matcher$.prototype.$classData = $d_ju_regex_Matcher$;
var $n_ju_regex_Matcher$ = (void 0);
function $m_ju_regex_Matcher$() {
  if ((!$n_ju_regex_Matcher$)) {
    $n_ju_regex_Matcher$ = new $c_ju_regex_Matcher$().init___()
  };
  return $n_ju_regex_Matcher$
}
/** @constructor */
function $c_s_DeprecatedConsole() {
  $c_O.call(this)
}
$c_s_DeprecatedConsole.prototype = new $h_O();
$c_s_DeprecatedConsole.prototype.constructor = $c_s_DeprecatedConsole;
/** @constructor */
function $h_s_DeprecatedConsole() {
  /*<skip>*/
}
$h_s_DeprecatedConsole.prototype = $c_s_DeprecatedConsole.prototype;
/** @constructor */
function $c_s_FallbackArrayBuilding() {
  $c_O.call(this)
}
$c_s_FallbackArrayBuilding.prototype = new $h_O();
$c_s_FallbackArrayBuilding.prototype.constructor = $c_s_FallbackArrayBuilding;
/** @constructor */
function $h_s_FallbackArrayBuilding() {
  /*<skip>*/
}
$h_s_FallbackArrayBuilding.prototype = $c_s_FallbackArrayBuilding.prototype;
/** @constructor */
function $c_s_LowPriorityImplicits() {
  $c_O.call(this)
}
$c_s_LowPriorityImplicits.prototype = new $h_O();
$c_s_LowPriorityImplicits.prototype.constructor = $c_s_LowPriorityImplicits;
/** @constructor */
function $h_s_LowPriorityImplicits() {
  /*<skip>*/
}
$h_s_LowPriorityImplicits.prototype = $c_s_LowPriorityImplicits.prototype;
$c_s_LowPriorityImplicits.prototype.wrapRefArray__AO__scm_WrappedArray = (function(xs) {
  if ((xs === null)) {
    return null
  } else if ((xs.u.length === 0)) {
    var this$1 = $m_scm_WrappedArray$();
    return this$1.EmptyWrappedArray$1
  } else {
    return new $c_scm_WrappedArray$ofRef().init___AO(xs)
  }
});
$c_s_LowPriorityImplicits.prototype.unwrapString__sci_WrappedString__T = (function(ws) {
  return ((ws !== null) ? ws.self$4 : null)
});
$c_s_LowPriorityImplicits.prototype.wrapString__T__sci_WrappedString = (function(s) {
  return ((s !== null) ? new $c_sci_WrappedString().init___T(s) : null)
});
function $f_s_PartialFunction__runWith__F1__F1($thiz, action) {
  return new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, action$1) {
    return (function(x$2) {
      var z = $this.applyOrElse__O__F1__O(x$2, $m_s_PartialFunction$().scala$PartialFunction$$fallback$undpf$f);
      return ((!$m_s_PartialFunction$().scala$PartialFunction$$fallbackOccurred__O__Z(z)) && (action$1.apply__O__O(z), true))
    })
  })($thiz, action))
}
function $f_s_PartialFunction__applyOrElse__O__F1__O($thiz, x, $default) {
  return ($thiz.isDefinedAt__O__Z(x) ? $thiz.apply__O__O(x) : $default.apply__O__O(x))
}
/** @constructor */
function $c_s_PartialFunction$() {
  $c_O.call(this);
  this.scala$PartialFunction$$fallback$undpf$f = null;
  this.scala$PartialFunction$$constFalse$f = null;
  this.empty$undpf$1 = null
}
$c_s_PartialFunction$.prototype = new $h_O();
$c_s_PartialFunction$.prototype.constructor = $c_s_PartialFunction$;
/** @constructor */
function $h_s_PartialFunction$() {
  /*<skip>*/
}
$h_s_PartialFunction$.prototype = $c_s_PartialFunction$.prototype;
$c_s_PartialFunction$.prototype.init___ = (function() {
  $n_s_PartialFunction$ = this;
  this.scala$PartialFunction$$fallback$undpf$f = new $c_s_PartialFunction$$anonfun$1().init___();
  this.scala$PartialFunction$$constFalse$f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      return false
    })
  })(this));
  this.empty$undpf$1 = new $c_s_PartialFunction$$anon$1().init___();
  return this
});
$c_s_PartialFunction$.prototype.scala$PartialFunction$$fallbackOccurred__O__Z = (function(x) {
  return (this.scala$PartialFunction$$fallback$undpf$f === x)
});
var $d_s_PartialFunction$ = new $TypeData().initClass({
  s_PartialFunction$: 0
}, false, "scala.PartialFunction$", {
  s_PartialFunction$: 1,
  O: 1
});
$c_s_PartialFunction$.prototype.$classData = $d_s_PartialFunction$;
var $n_s_PartialFunction$ = (void 0);
function $m_s_PartialFunction$() {
  if ((!$n_s_PartialFunction$)) {
    $n_s_PartialFunction$ = new $c_s_PartialFunction$().init___()
  };
  return $n_s_PartialFunction$
}
/** @constructor */
function $c_s_Predef$DummyImplicit() {
  $c_O.call(this)
}
$c_s_Predef$DummyImplicit.prototype = new $h_O();
$c_s_Predef$DummyImplicit.prototype.constructor = $c_s_Predef$DummyImplicit;
/** @constructor */
function $h_s_Predef$DummyImplicit() {
  /*<skip>*/
}
$h_s_Predef$DummyImplicit.prototype = $c_s_Predef$DummyImplicit.prototype;
$c_s_Predef$DummyImplicit.prototype.init___ = (function() {
  return this
});
var $d_s_Predef$DummyImplicit = new $TypeData().initClass({
  s_Predef$DummyImplicit: 0
}, false, "scala.Predef$DummyImplicit", {
  s_Predef$DummyImplicit: 1,
  O: 1
});
$c_s_Predef$DummyImplicit.prototype.$classData = $d_s_Predef$DummyImplicit;
/** @constructor */
function $c_s_Predef$any2stringadd$() {
  $c_O.call(this)
}
$c_s_Predef$any2stringadd$.prototype = new $h_O();
$c_s_Predef$any2stringadd$.prototype.constructor = $c_s_Predef$any2stringadd$;
/** @constructor */
function $h_s_Predef$any2stringadd$() {
  /*<skip>*/
}
$h_s_Predef$any2stringadd$.prototype = $c_s_Predef$any2stringadd$.prototype;
$c_s_Predef$any2stringadd$.prototype.init___ = (function() {
  return this
});
$c_s_Predef$any2stringadd$.prototype.$$plus$extension__O__T__T = (function($$this, other) {
  return (("" + $$this) + other)
});
var $d_s_Predef$any2stringadd$ = new $TypeData().initClass({
  s_Predef$any2stringadd$: 0
}, false, "scala.Predef$any2stringadd$", {
  s_Predef$any2stringadd$: 1,
  O: 1
});
$c_s_Predef$any2stringadd$.prototype.$classData = $d_s_Predef$any2stringadd$;
var $n_s_Predef$any2stringadd$ = (void 0);
function $m_s_Predef$any2stringadd$() {
  if ((!$n_s_Predef$any2stringadd$)) {
    $n_s_Predef$any2stringadd$ = new $c_s_Predef$any2stringadd$().init___()
  };
  return $n_s_Predef$any2stringadd$
}
function $f_s_concurrent_BatchingExecutor__batchable__jl_Runnable__Z($thiz, runnable) {
  return $is_s_concurrent_OnCompleteRunnable(runnable)
}
function $f_s_concurrent_BatchingExecutor__execute__jl_Runnable__V($thiz, runnable) {
  if ($f_s_concurrent_BatchingExecutor__batchable__jl_Runnable__Z($thiz, runnable)) {
    var x1 = $as_sci_List($thiz.scala$concurrent$BatchingExecutor$$$undtasksLocal$1.get__O());
    if ((x1 === null)) {
      var this$1 = $m_sci_Nil$();
      var r = new $c_s_concurrent_BatchingExecutor$Batch().init___s_concurrent_BatchingExecutor__sci_List($thiz, new $c_sci_$colon$colon().init___O__sci_List(runnable, this$1));
      r.run__V()
    } else {
      $thiz.scala$concurrent$BatchingExecutor$$$undtasksLocal$1.set__O__V(new $c_sci_$colon$colon().init___O__sci_List(runnable, x1))
    }
  } else {
    runnable.run__V()
  }
}
/** @constructor */
function $c_s_concurrent_BlockContext$() {
  $c_O.call(this);
  this.contextLocal$1 = null
}
$c_s_concurrent_BlockContext$.prototype = new $h_O();
$c_s_concurrent_BlockContext$.prototype.constructor = $c_s_concurrent_BlockContext$;
/** @constructor */
function $h_s_concurrent_BlockContext$() {
  /*<skip>*/
}
$h_s_concurrent_BlockContext$.prototype = $c_s_concurrent_BlockContext$.prototype;
$c_s_concurrent_BlockContext$.prototype.init___ = (function() {
  $n_s_concurrent_BlockContext$ = this;
  this.contextLocal$1 = new $c_jl_ThreadLocal().init___();
  return this
});
$c_s_concurrent_BlockContext$.prototype.current__s_concurrent_BlockContext = (function() {
  var x1 = $as_s_concurrent_BlockContext(this.contextLocal$1.get__O());
  if ((x1 === null)) {
    var x1$2 = $m_jl_Thread$().SingleThread$1;
    return ($is_s_concurrent_BlockContext(x1$2) ? $as_s_concurrent_BlockContext(x1$2) : $m_s_concurrent_BlockContext$DefaultBlockContext$())
  } else {
    return x1
  }
});
var $d_s_concurrent_BlockContext$ = new $TypeData().initClass({
  s_concurrent_BlockContext$: 0
}, false, "scala.concurrent.BlockContext$", {
  s_concurrent_BlockContext$: 1,
  O: 1
});
$c_s_concurrent_BlockContext$.prototype.$classData = $d_s_concurrent_BlockContext$;
var $n_s_concurrent_BlockContext$ = (void 0);
function $m_s_concurrent_BlockContext$() {
  if ((!$n_s_concurrent_BlockContext$)) {
    $n_s_concurrent_BlockContext$ = new $c_s_concurrent_BlockContext$().init___()
  };
  return $n_s_concurrent_BlockContext$
}
/** @constructor */
function $c_s_concurrent_ExecutionContext$Implicits$() {
  $c_O.call(this);
  this.global$1 = null;
  this.bitmap$0$1 = false
}
$c_s_concurrent_ExecutionContext$Implicits$.prototype = new $h_O();
$c_s_concurrent_ExecutionContext$Implicits$.prototype.constructor = $c_s_concurrent_ExecutionContext$Implicits$;
/** @constructor */
function $h_s_concurrent_ExecutionContext$Implicits$() {
  /*<skip>*/
}
$h_s_concurrent_ExecutionContext$Implicits$.prototype = $c_s_concurrent_ExecutionContext$Implicits$.prototype;
$c_s_concurrent_ExecutionContext$Implicits$.prototype.init___ = (function() {
  return this
});
$c_s_concurrent_ExecutionContext$Implicits$.prototype.global$lzycompute__p1__s_concurrent_ExecutionContext = (function() {
  if ((!this.bitmap$0$1)) {
    this.global$1 = $m_sjs_concurrent_JSExecutionContext$().queue$1;
    this.bitmap$0$1 = true
  };
  return this.global$1
});
$c_s_concurrent_ExecutionContext$Implicits$.prototype.global__s_concurrent_ExecutionContext = (function() {
  return ((!this.bitmap$0$1) ? this.global$lzycompute__p1__s_concurrent_ExecutionContext() : this.global$1)
});
var $d_s_concurrent_ExecutionContext$Implicits$ = new $TypeData().initClass({
  s_concurrent_ExecutionContext$Implicits$: 0
}, false, "scala.concurrent.ExecutionContext$Implicits$", {
  s_concurrent_ExecutionContext$Implicits$: 1,
  O: 1
});
$c_s_concurrent_ExecutionContext$Implicits$.prototype.$classData = $d_s_concurrent_ExecutionContext$Implicits$;
var $n_s_concurrent_ExecutionContext$Implicits$ = (void 0);
function $m_s_concurrent_ExecutionContext$Implicits$() {
  if ((!$n_s_concurrent_ExecutionContext$Implicits$)) {
    $n_s_concurrent_ExecutionContext$Implicits$ = new $c_s_concurrent_ExecutionContext$Implicits$().init___()
  };
  return $n_s_concurrent_ExecutionContext$Implicits$
}
function $f_s_concurrent_Future__foreach__F1__s_concurrent_ExecutionContext__V($thiz, f, executor) {
  $thiz.onComplete__F1__s_concurrent_ExecutionContext__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, f$1) {
    return (function(x$1$2) {
      var x$1 = $as_s_util_Try(x$1$2);
      x$1.foreach__F1__V(f$1)
    })
  })($thiz, f)), executor)
}
function $f_s_concurrent_Future__flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future($thiz, f, executor) {
  var f$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, f$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_s_util_Try(x0$1$2);
      if ((x0$1 instanceof $c_s_util_Success)) {
        var x2 = $as_s_util_Success(x0$1);
        var s = x2.value$2;
        return $as_s_concurrent_Future(f$1.apply__O__O(s))
      } else if ((x0$1 instanceof $c_s_util_Failure)) {
        return $this
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })($thiz, f));
  return $f_s_concurrent_impl_Promise__transformWith__F1__s_concurrent_ExecutionContext__s_concurrent_Future($thiz, f$2, executor)
}
function $f_s_concurrent_Future__map__F1__s_concurrent_ExecutionContext__s_concurrent_Future($thiz, f, executor) {
  var f$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, f$1) {
    return (function(x$2$2) {
      var x$2 = $as_s_util_Try(x$2$2);
      return x$2.map__F1__s_util_Try(f$1)
    })
  })($thiz, f));
  return $f_s_concurrent_impl_Promise__transform__F1__s_concurrent_ExecutionContext__s_concurrent_Future($thiz, f$2, executor)
}
function $f_s_concurrent_Future__zipWith__s_concurrent_Future__F2__s_concurrent_ExecutionContext__s_concurrent_Future($thiz, that, f, executor) {
  return $thiz.flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, that$1, f$1, executor$1) {
    return (function(r1$2) {
      return that$1.map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, f$5, r1) {
        return (function(r2$2) {
          return f$5.apply__O__O__O(r1, r2$2)
        })
      })($this, f$1, r1$2)), executor$1)
    })
  })($thiz, that, f, executor)), $m_s_concurrent_Future$InternalCallbackExecutor$())
}
function $f_s_concurrent_Future__recover__s_PartialFunction__s_concurrent_ExecutionContext__s_concurrent_Future($thiz, pf, executor) {
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, pf$1) {
    return (function(x$3$2) {
      var x$3 = $as_s_util_Try(x$3$2);
      return x$3.recover__s_PartialFunction__s_util_Try(pf$1)
    })
  })($thiz, pf));
  return $f_s_concurrent_impl_Promise__transform__F1__s_concurrent_ExecutionContext__s_concurrent_Future($thiz, f, executor)
}
function $f_s_concurrent_Future__recoverWith__s_PartialFunction__s_concurrent_ExecutionContext__s_concurrent_Future($thiz, pf, executor) {
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, pf$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_s_util_Try(x0$1$2);
      if ((x0$1 instanceof $c_s_util_Failure)) {
        var x2 = $as_s_util_Failure(x0$1);
        var t = x2.exception$2;
        return $as_s_concurrent_Future(pf$1.applyOrElse__O__F1__O(t, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
          return (function(x$4$2) {
            $as_jl_Throwable(x$4$2);
            return $this$1
          })
        })($this))))
      } else if ((x0$1 instanceof $c_s_util_Success)) {
        return $this
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })($thiz, pf));
  return $f_s_concurrent_impl_Promise__transformWith__F1__s_concurrent_ExecutionContext__s_concurrent_Future($thiz, f, executor)
}
function $f_s_concurrent_Future__failed__s_concurrent_Future($thiz) {
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_s_util_Try(x0$1$2);
      if ((x0$1 instanceof $c_s_util_Failure)) {
        var x2 = $as_s_util_Failure(x0$1);
        var t = x2.exception$2;
        return new $c_s_util_Success().init___O(t)
      } else if ((x0$1 instanceof $c_s_util_Success)) {
        return new $c_s_util_Failure().init___jl_Throwable(new $c_ju_NoSuchElementException().init___T("Future.failed not completed with a throwable."))
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })($thiz));
  var executor = $m_s_concurrent_Future$InternalCallbackExecutor$();
  return $f_s_concurrent_impl_Promise__transform__F1__s_concurrent_ExecutionContext__s_concurrent_Future($thiz, f, executor)
}
function $is_s_concurrent_Future(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.s_concurrent_Future)))
}
function $as_s_concurrent_Future(obj) {
  return (($is_s_concurrent_Future(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.concurrent.Future"))
}
function $isArrayOf_s_concurrent_Future(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_concurrent_Future)))
}
function $asArrayOf_s_concurrent_Future(obj, depth) {
  return (($isArrayOf_s_concurrent_Future(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.concurrent.Future;", depth))
}
/** @constructor */
function $c_s_concurrent_Future$() {
  $c_O.call(this);
  this.toBoxed$1 = null;
  this.unit$1 = null
}
$c_s_concurrent_Future$.prototype = new $h_O();
$c_s_concurrent_Future$.prototype.constructor = $c_s_concurrent_Future$;
/** @constructor */
function $h_s_concurrent_Future$() {
  /*<skip>*/
}
$h_s_concurrent_Future$.prototype = $c_s_concurrent_Future$.prototype;
$c_s_concurrent_Future$.prototype.init___ = (function() {
  $n_s_concurrent_Future$ = this;
  var array = [new $c_T2().init___O__O($d_Z.getClassOf(), $d_jl_Boolean.getClassOf()), new $c_T2().init___O__O($d_B.getClassOf(), $d_jl_Byte.getClassOf()), new $c_T2().init___O__O($d_C.getClassOf(), $d_jl_Character.getClassOf()), new $c_T2().init___O__O($d_S.getClassOf(), $d_jl_Short.getClassOf()), new $c_T2().init___O__O($d_I.getClassOf(), $d_jl_Integer.getClassOf()), new $c_T2().init___O__O($d_J.getClassOf(), $d_jl_Long.getClassOf()), new $c_T2().init___O__O($d_F.getClassOf(), $d_jl_Float.getClassOf()), new $c_T2().init___O__O($d_D.getClassOf(), $d_jl_Double.getClassOf()), new $c_T2().init___O__O($d_V.getClassOf(), $d_sr_BoxedUnit.getClassOf())];
  var this$22 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$22.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  this.toBoxed$1 = $as_sci_Map(this$22.elems$1);
  this.unit$1 = this.successful__O__s_concurrent_Future((void 0));
  return this
});
$c_s_concurrent_Future$.prototype.sequence__sc_TraversableOnce__scg_CanBuildFrom__s_concurrent_ExecutionContext__s_concurrent_Future = (function($in, cbf, executor) {
  return $as_s_concurrent_Future($in.foldLeft__O__F2__O(this.successful__O__s_concurrent_Future(cbf.apply__O__scm_Builder($in)), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this, executor$1) {
    return (function(fr$2, fa$2) {
      var fr = $as_s_concurrent_Future(fr$2);
      var fa = $as_s_concurrent_Future(fa$2);
      return fr.zipWith__s_concurrent_Future__F2__s_concurrent_ExecutionContext__s_concurrent_Future(fa, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this$1) {
        return (function(x$6$2, x$7$2) {
          var x$6 = $as_scm_Builder(x$6$2);
          return x$6.$$plus$eq__O__scm_Builder(x$7$2)
        })
      })($this)), executor$1)
    })
  })(this, executor)))).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$8$2) {
      var x$8 = $as_scm_Builder(x$8$2);
      return $as_sc_TraversableOnce(x$8.result__O())
    })
  })(this)), $m_s_concurrent_Future$InternalCallbackExecutor$())
});
$c_s_concurrent_Future$.prototype.successful__O__s_concurrent_Future = (function(result) {
  var this$1 = $m_s_concurrent_Promise$().successful__O__s_concurrent_Promise(result);
  return this$1
});
$c_s_concurrent_Future$.prototype.apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future = (function(body, executor) {
  return this.unit$1.map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, body$1) {
    return (function(x$5$2) {
      $asUnit(x$5$2);
      return body$1.apply__O()
    })
  })(this, body)), executor)
});
$c_s_concurrent_Future$.prototype.failed__jl_Throwable__s_concurrent_Future = (function(exception) {
  var this$1 = $m_s_concurrent_Promise$().failed__jl_Throwable__s_concurrent_Promise(exception);
  return this$1
});
var $d_s_concurrent_Future$ = new $TypeData().initClass({
  s_concurrent_Future$: 0
}, false, "scala.concurrent.Future$", {
  s_concurrent_Future$: 1,
  O: 1
});
$c_s_concurrent_Future$.prototype.$classData = $d_s_concurrent_Future$;
var $n_s_concurrent_Future$ = (void 0);
function $m_s_concurrent_Future$() {
  if ((!$n_s_concurrent_Future$)) {
    $n_s_concurrent_Future$ = new $c_s_concurrent_Future$().init___()
  };
  return $n_s_concurrent_Future$
}
/** @constructor */
function $c_s_concurrent_Promise$() {
  $c_O.call(this)
}
$c_s_concurrent_Promise$.prototype = new $h_O();
$c_s_concurrent_Promise$.prototype.constructor = $c_s_concurrent_Promise$;
/** @constructor */
function $h_s_concurrent_Promise$() {
  /*<skip>*/
}
$h_s_concurrent_Promise$.prototype = $c_s_concurrent_Promise$.prototype;
$c_s_concurrent_Promise$.prototype.init___ = (function() {
  return this
});
$c_s_concurrent_Promise$.prototype.successful__O__s_concurrent_Promise = (function(result) {
  var result$1 = new $c_s_util_Success().init___O(result);
  return $m_s_concurrent_impl_Promise$KeptPromise$().apply__s_util_Try__s_concurrent_Promise(result$1)
});
$c_s_concurrent_Promise$.prototype.failed__jl_Throwable__s_concurrent_Promise = (function(exception) {
  var result = new $c_s_util_Failure().init___jl_Throwable(exception);
  return $m_s_concurrent_impl_Promise$KeptPromise$().apply__s_util_Try__s_concurrent_Promise(result)
});
var $d_s_concurrent_Promise$ = new $TypeData().initClass({
  s_concurrent_Promise$: 0
}, false, "scala.concurrent.Promise$", {
  s_concurrent_Promise$: 1,
  O: 1
});
$c_s_concurrent_Promise$.prototype.$classData = $d_s_concurrent_Promise$;
var $n_s_concurrent_Promise$ = (void 0);
function $m_s_concurrent_Promise$() {
  if ((!$n_s_concurrent_Promise$)) {
    $n_s_concurrent_Promise$ = new $c_s_concurrent_Promise$().init___()
  };
  return $n_s_concurrent_Promise$
}
/** @constructor */
function $c_s_concurrent_impl_Promise$() {
  $c_O.call(this)
}
$c_s_concurrent_impl_Promise$.prototype = new $h_O();
$c_s_concurrent_impl_Promise$.prototype.constructor = $c_s_concurrent_impl_Promise$;
/** @constructor */
function $h_s_concurrent_impl_Promise$() {
  /*<skip>*/
}
$h_s_concurrent_impl_Promise$.prototype = $c_s_concurrent_impl_Promise$.prototype;
$c_s_concurrent_impl_Promise$.prototype.init___ = (function() {
  return this
});
$c_s_concurrent_impl_Promise$.prototype.scala$concurrent$impl$Promise$$resolveTry__s_util_Try__s_util_Try = (function(source) {
  if ((source instanceof $c_s_util_Failure)) {
    var x2 = $as_s_util_Failure(source);
    var t = x2.exception$2;
    return this.resolver__p1__jl_Throwable__s_util_Try(t)
  } else {
    return source
  }
});
$c_s_concurrent_impl_Promise$.prototype.resolver__p1__jl_Throwable__s_util_Try = (function(throwable) {
  if ((throwable instanceof $c_sr_NonLocalReturnControl)) {
    var x2 = $as_sr_NonLocalReturnControl(throwable);
    return new $c_s_util_Success().init___O(x2.value__O())
  } else if ($is_s_util_control_ControlThrowable(throwable)) {
    var x3 = $as_s_util_control_ControlThrowable(throwable);
    return new $c_s_util_Failure().init___jl_Throwable(new $c_ju_concurrent_ExecutionException().init___T__jl_Throwable("Boxed ControlThrowable", $as_jl_Throwable(x3)))
  } else if ((throwable instanceof $c_jl_InterruptedException)) {
    var x4 = $as_jl_InterruptedException(throwable);
    return new $c_s_util_Failure().init___jl_Throwable(new $c_ju_concurrent_ExecutionException().init___T__jl_Throwable("Boxed InterruptedException", x4))
  } else if ((throwable instanceof $c_jl_Error)) {
    var x5 = $as_jl_Error(throwable);
    return new $c_s_util_Failure().init___jl_Throwable(new $c_ju_concurrent_ExecutionException().init___T__jl_Throwable("Boxed Error", x5))
  } else {
    return new $c_s_util_Failure().init___jl_Throwable(throwable)
  }
});
var $d_s_concurrent_impl_Promise$ = new $TypeData().initClass({
  s_concurrent_impl_Promise$: 0
}, false, "scala.concurrent.impl.Promise$", {
  s_concurrent_impl_Promise$: 1,
  O: 1
});
$c_s_concurrent_impl_Promise$.prototype.$classData = $d_s_concurrent_impl_Promise$;
var $n_s_concurrent_impl_Promise$ = (void 0);
function $m_s_concurrent_impl_Promise$() {
  if ((!$n_s_concurrent_impl_Promise$)) {
    $n_s_concurrent_impl_Promise$ = new $c_s_concurrent_impl_Promise$().init___()
  };
  return $n_s_concurrent_impl_Promise$
}
/** @constructor */
function $c_s_concurrent_impl_Promise$KeptPromise$() {
  $c_O.call(this)
}
$c_s_concurrent_impl_Promise$KeptPromise$.prototype = new $h_O();
$c_s_concurrent_impl_Promise$KeptPromise$.prototype.constructor = $c_s_concurrent_impl_Promise$KeptPromise$;
/** @constructor */
function $h_s_concurrent_impl_Promise$KeptPromise$() {
  /*<skip>*/
}
$h_s_concurrent_impl_Promise$KeptPromise$.prototype = $c_s_concurrent_impl_Promise$KeptPromise$.prototype;
$c_s_concurrent_impl_Promise$KeptPromise$.prototype.init___ = (function() {
  return this
});
$c_s_concurrent_impl_Promise$KeptPromise$.prototype.apply__s_util_Try__s_concurrent_Promise = (function(result) {
  var x1 = $m_s_concurrent_impl_Promise$().scala$concurrent$impl$Promise$$resolveTry__s_util_Try__s_util_Try(result);
  if ((x1 instanceof $c_s_util_Success)) {
    var x2 = $as_s_util_Success(x1);
    return new $c_s_concurrent_impl_Promise$KeptPromise$Successful().init___s_util_Success(x2)
  } else if ((x1 instanceof $c_s_util_Failure)) {
    var x4 = $as_s_util_Failure(x1);
    return new $c_s_concurrent_impl_Promise$KeptPromise$Failed().init___s_util_Failure(x4)
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
var $d_s_concurrent_impl_Promise$KeptPromise$ = new $TypeData().initClass({
  s_concurrent_impl_Promise$KeptPromise$: 0
}, false, "scala.concurrent.impl.Promise$KeptPromise$", {
  s_concurrent_impl_Promise$KeptPromise$: 1,
  O: 1
});
$c_s_concurrent_impl_Promise$KeptPromise$.prototype.$classData = $d_s_concurrent_impl_Promise$KeptPromise$;
var $n_s_concurrent_impl_Promise$KeptPromise$ = (void 0);
function $m_s_concurrent_impl_Promise$KeptPromise$() {
  if ((!$n_s_concurrent_impl_Promise$KeptPromise$)) {
    $n_s_concurrent_impl_Promise$KeptPromise$ = new $c_s_concurrent_impl_Promise$KeptPromise$().init___()
  };
  return $n_s_concurrent_impl_Promise$KeptPromise$
}
function $f_s_math_Ordered__$$less$eq__O__Z($thiz, that) {
  return ($thiz.compare__O__I(that) <= 0)
}
function $f_s_math_Ordered__$$greater$eq__O__Z($thiz, that) {
  return ($thiz.compare__O__I(that) >= 0)
}
/** @constructor */
function $c_s_math_Ordered$() {
  $c_O.call(this)
}
$c_s_math_Ordered$.prototype = new $h_O();
$c_s_math_Ordered$.prototype.constructor = $c_s_math_Ordered$;
/** @constructor */
function $h_s_math_Ordered$() {
  /*<skip>*/
}
$h_s_math_Ordered$.prototype = $c_s_math_Ordered$.prototype;
$c_s_math_Ordered$.prototype.init___ = (function() {
  return this
});
var $d_s_math_Ordered$ = new $TypeData().initClass({
  s_math_Ordered$: 0
}, false, "scala.math.Ordered$", {
  s_math_Ordered$: 1,
  O: 1
});
$c_s_math_Ordered$.prototype.$classData = $d_s_math_Ordered$;
var $n_s_math_Ordered$ = (void 0);
function $m_s_math_Ordered$() {
  if ((!$n_s_math_Ordered$)) {
    $n_s_math_Ordered$ = new $c_s_math_Ordered$().init___()
  };
  return $n_s_math_Ordered$
}
/** @constructor */
function $c_s_package$() {
  $c_O.call(this);
  this.BigDecimal$1 = null;
  this.BigInt$1 = null;
  this.AnyRef$1 = null;
  this.Traversable$1 = null;
  this.Iterable$1 = null;
  this.Seq$1 = null;
  this.IndexedSeq$1 = null;
  this.Iterator$1 = null;
  this.List$1 = null;
  this.Nil$1 = null;
  this.$$colon$colon$1 = null;
  this.$$plus$colon$1 = null;
  this.$$colon$plus$1 = null;
  this.Stream$1 = null;
  this.$$hash$colon$colon$1 = null;
  this.Vector$1 = null;
  this.StringBuilder$1 = null;
  this.Range$1 = null;
  this.Equiv$1 = null;
  this.Fractional$1 = null;
  this.Integral$1 = null;
  this.Numeric$1 = null;
  this.Ordered$1 = null;
  this.Ordering$1 = null;
  this.Either$1 = null;
  this.Left$1 = null;
  this.Right$1 = null;
  this.bitmap$0$1 = 0
}
$c_s_package$.prototype = new $h_O();
$c_s_package$.prototype.constructor = $c_s_package$;
/** @constructor */
function $h_s_package$() {
  /*<skip>*/
}
$h_s_package$.prototype = $c_s_package$.prototype;
$c_s_package$.prototype.init___ = (function() {
  $n_s_package$ = this;
  this.AnyRef$1 = new $c_s_package$$anon$1().init___();
  this.Traversable$1 = $m_sc_Traversable$();
  this.Iterable$1 = $m_sc_Iterable$();
  this.Seq$1 = $m_sc_Seq$();
  this.IndexedSeq$1 = $m_sc_IndexedSeq$();
  this.Iterator$1 = $m_sc_Iterator$();
  this.List$1 = $m_sci_List$();
  this.Nil$1 = $m_sci_Nil$();
  this.$$colon$colon$1 = $m_sci_$colon$colon$();
  this.$$plus$colon$1 = $m_sc_$plus$colon$();
  this.$$colon$plus$1 = $m_sc_$colon$plus$();
  this.Stream$1 = $m_sci_Stream$();
  this.$$hash$colon$colon$1 = $m_sci_Stream$$hash$colon$colon$();
  this.Vector$1 = $m_sci_Vector$();
  this.StringBuilder$1 = $m_scm_StringBuilder$();
  this.Range$1 = $m_sci_Range$();
  this.Equiv$1 = $m_s_math_Equiv$();
  this.Fractional$1 = $m_s_math_Fractional$();
  this.Integral$1 = $m_s_math_Integral$();
  this.Numeric$1 = $m_s_math_Numeric$();
  this.Ordered$1 = $m_s_math_Ordered$();
  this.Ordering$1 = $m_s_math_Ordering$();
  this.Either$1 = $m_s_util_Either$();
  this.Left$1 = $m_s_util_Left$();
  this.Right$1 = $m_s_util_Right$();
  return this
});
$c_s_package$.prototype.BigInt__s_math_BigInt$ = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.BigInt$lzycompute__p1__s_math_BigInt$() : this.BigInt$1)
});
$c_s_package$.prototype.BigInt$lzycompute__p1__s_math_BigInt$ = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.BigInt$1 = $m_s_math_BigInt$();
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.BigInt$1
});
$c_s_package$.prototype.BigDecimal__s_math_BigDecimal$ = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.BigDecimal$lzycompute__p1__s_math_BigDecimal$() : this.BigDecimal$1)
});
$c_s_package$.prototype.BigDecimal$lzycompute__p1__s_math_BigDecimal$ = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.BigDecimal$1 = $m_s_math_BigDecimal$();
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.BigDecimal$1
});
var $d_s_package$ = new $TypeData().initClass({
  s_package$: 0
}, false, "scala.package$", {
  s_package$: 1,
  O: 1
});
$c_s_package$.prototype.$classData = $d_s_package$;
var $n_s_package$ = (void 0);
function $m_s_package$() {
  if ((!$n_s_package$)) {
    $n_s_package$ = new $c_s_package$().init___()
  };
  return $n_s_package$
}
/** @constructor */
function $c_s_reflect_ClassManifestFactory$() {
  $c_O.call(this);
  this.Byte$1 = null;
  this.Short$1 = null;
  this.Char$1 = null;
  this.Int$1 = null;
  this.Long$1 = null;
  this.Float$1 = null;
  this.Double$1 = null;
  this.Boolean$1 = null;
  this.Unit$1 = null;
  this.Any$1 = null;
  this.Object$1 = null;
  this.AnyVal$1 = null;
  this.Nothing$1 = null;
  this.Null$1 = null
}
$c_s_reflect_ClassManifestFactory$.prototype = new $h_O();
$c_s_reflect_ClassManifestFactory$.prototype.constructor = $c_s_reflect_ClassManifestFactory$;
/** @constructor */
function $h_s_reflect_ClassManifestFactory$() {
  /*<skip>*/
}
$h_s_reflect_ClassManifestFactory$.prototype = $c_s_reflect_ClassManifestFactory$.prototype;
$c_s_reflect_ClassManifestFactory$.prototype.init___ = (function() {
  $n_s_reflect_ClassManifestFactory$ = this;
  this.Byte$1 = $m_s_reflect_ManifestFactory$ByteManifest$();
  this.Short$1 = $m_s_reflect_ManifestFactory$ShortManifest$();
  this.Char$1 = $m_s_reflect_ManifestFactory$CharManifest$();
  this.Int$1 = $m_s_reflect_ManifestFactory$IntManifest$();
  this.Long$1 = $m_s_reflect_ManifestFactory$LongManifest$();
  this.Float$1 = $m_s_reflect_ManifestFactory$FloatManifest$();
  this.Double$1 = $m_s_reflect_ManifestFactory$DoubleManifest$();
  this.Boolean$1 = $m_s_reflect_ManifestFactory$BooleanManifest$();
  this.Unit$1 = $m_s_reflect_ManifestFactory$UnitManifest$();
  this.Any$1 = $m_s_reflect_ManifestFactory$AnyManifest$();
  this.Object$1 = $m_s_reflect_ManifestFactory$ObjectManifest$();
  this.AnyVal$1 = $m_s_reflect_ManifestFactory$AnyValManifest$();
  this.Nothing$1 = $m_s_reflect_ManifestFactory$NothingManifest$();
  this.Null$1 = $m_s_reflect_ManifestFactory$NullManifest$();
  return this
});
var $d_s_reflect_ClassManifestFactory$ = new $TypeData().initClass({
  s_reflect_ClassManifestFactory$: 0
}, false, "scala.reflect.ClassManifestFactory$", {
  s_reflect_ClassManifestFactory$: 1,
  O: 1
});
$c_s_reflect_ClassManifestFactory$.prototype.$classData = $d_s_reflect_ClassManifestFactory$;
var $n_s_reflect_ClassManifestFactory$ = (void 0);
function $m_s_reflect_ClassManifestFactory$() {
  if ((!$n_s_reflect_ClassManifestFactory$)) {
    $n_s_reflect_ClassManifestFactory$ = new $c_s_reflect_ClassManifestFactory$().init___()
  };
  return $n_s_reflect_ClassManifestFactory$
}
/** @constructor */
function $c_s_reflect_ManifestFactory$() {
  $c_O.call(this)
}
$c_s_reflect_ManifestFactory$.prototype = new $h_O();
$c_s_reflect_ManifestFactory$.prototype.constructor = $c_s_reflect_ManifestFactory$;
/** @constructor */
function $h_s_reflect_ManifestFactory$() {
  /*<skip>*/
}
$h_s_reflect_ManifestFactory$.prototype = $c_s_reflect_ManifestFactory$.prototype;
$c_s_reflect_ManifestFactory$.prototype.init___ = (function() {
  return this
});
var $d_s_reflect_ManifestFactory$ = new $TypeData().initClass({
  s_reflect_ManifestFactory$: 0
}, false, "scala.reflect.ManifestFactory$", {
  s_reflect_ManifestFactory$: 1,
  O: 1
});
$c_s_reflect_ManifestFactory$.prototype.$classData = $d_s_reflect_ManifestFactory$;
var $n_s_reflect_ManifestFactory$ = (void 0);
function $m_s_reflect_ManifestFactory$() {
  if ((!$n_s_reflect_ManifestFactory$)) {
    $n_s_reflect_ManifestFactory$ = new $c_s_reflect_ManifestFactory$().init___()
  };
  return $n_s_reflect_ManifestFactory$
}
/** @constructor */
function $c_s_reflect_package$() {
  $c_O.call(this);
  this.ClassManifest$1 = null;
  this.Manifest$1 = null
}
$c_s_reflect_package$.prototype = new $h_O();
$c_s_reflect_package$.prototype.constructor = $c_s_reflect_package$;
/** @constructor */
function $h_s_reflect_package$() {
  /*<skip>*/
}
$h_s_reflect_package$.prototype = $c_s_reflect_package$.prototype;
$c_s_reflect_package$.prototype.init___ = (function() {
  $n_s_reflect_package$ = this;
  this.ClassManifest$1 = $m_s_reflect_ClassManifestFactory$();
  this.Manifest$1 = $m_s_reflect_ManifestFactory$();
  return this
});
var $d_s_reflect_package$ = new $TypeData().initClass({
  s_reflect_package$: 0
}, false, "scala.reflect.package$", {
  s_reflect_package$: 1,
  O: 1
});
$c_s_reflect_package$.prototype.$classData = $d_s_reflect_package$;
var $n_s_reflect_package$ = (void 0);
function $m_s_reflect_package$() {
  if ((!$n_s_reflect_package$)) {
    $n_s_reflect_package$ = new $c_s_reflect_package$().init___()
  };
  return $n_s_reflect_package$
}
/** @constructor */
function $c_s_util_DynamicVariable() {
  $c_O.call(this);
  this.v$1 = null
}
$c_s_util_DynamicVariable.prototype = new $h_O();
$c_s_util_DynamicVariable.prototype.constructor = $c_s_util_DynamicVariable;
/** @constructor */
function $h_s_util_DynamicVariable() {
  /*<skip>*/
}
$h_s_util_DynamicVariable.prototype = $c_s_util_DynamicVariable.prototype;
$c_s_util_DynamicVariable.prototype.toString__T = (function() {
  return (("DynamicVariable(" + this.v$1) + ")")
});
$c_s_util_DynamicVariable.prototype.init___O = (function(init) {
  this.v$1 = init;
  return this
});
var $d_s_util_DynamicVariable = new $TypeData().initClass({
  s_util_DynamicVariable: 0
}, false, "scala.util.DynamicVariable", {
  s_util_DynamicVariable: 1,
  O: 1
});
$c_s_util_DynamicVariable.prototype.$classData = $d_s_util_DynamicVariable;
/** @constructor */
function $c_s_util_control_Breaks() {
  $c_O.call(this);
  this.scala$util$control$Breaks$$breakException$1 = null
}
$c_s_util_control_Breaks.prototype = new $h_O();
$c_s_util_control_Breaks.prototype.constructor = $c_s_util_control_Breaks;
/** @constructor */
function $h_s_util_control_Breaks() {
  /*<skip>*/
}
$h_s_util_control_Breaks.prototype = $c_s_util_control_Breaks.prototype;
$c_s_util_control_Breaks.prototype.init___ = (function() {
  this.scala$util$control$Breaks$$breakException$1 = new $c_s_util_control_BreakControl().init___();
  return this
});
var $d_s_util_control_Breaks = new $TypeData().initClass({
  s_util_control_Breaks: 0
}, false, "scala.util.control.Breaks", {
  s_util_control_Breaks: 1,
  O: 1
});
$c_s_util_control_Breaks.prototype.$classData = $d_s_util_control_Breaks;
function $is_s_util_control_ControlThrowable(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.s_util_control_ControlThrowable)))
}
function $as_s_util_control_ControlThrowable(obj) {
  return (($is_s_util_control_ControlThrowable(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.util.control.ControlThrowable"))
}
function $isArrayOf_s_util_control_ControlThrowable(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_util_control_ControlThrowable)))
}
function $asArrayOf_s_util_control_ControlThrowable(obj, depth) {
  return (($isArrayOf_s_util_control_ControlThrowable(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.util.control.ControlThrowable;", depth))
}
/** @constructor */
function $c_s_util_control_NonFatal$() {
  $c_O.call(this)
}
$c_s_util_control_NonFatal$.prototype = new $h_O();
$c_s_util_control_NonFatal$.prototype.constructor = $c_s_util_control_NonFatal$;
/** @constructor */
function $h_s_util_control_NonFatal$() {
  /*<skip>*/
}
$h_s_util_control_NonFatal$.prototype = $c_s_util_control_NonFatal$.prototype;
$c_s_util_control_NonFatal$.prototype.init___ = (function() {
  return this
});
$c_s_util_control_NonFatal$.prototype.apply__jl_Throwable__Z = (function(t) {
  return (!((t instanceof $c_jl_VirtualMachineError) || ((t instanceof $c_jl_ThreadDeath) || ((t instanceof $c_jl_InterruptedException) || ((t instanceof $c_jl_LinkageError) || $is_s_util_control_ControlThrowable(t))))))
});
$c_s_util_control_NonFatal$.prototype.unapply__jl_Throwable__s_Option = (function(t) {
  return (this.apply__jl_Throwable__Z(t) ? new $c_s_Some().init___O(t) : $m_s_None$())
});
var $d_s_util_control_NonFatal$ = new $TypeData().initClass({
  s_util_control_NonFatal$: 0
}, false, "scala.util.control.NonFatal$", {
  s_util_control_NonFatal$: 1,
  O: 1
});
$c_s_util_control_NonFatal$.prototype.$classData = $d_s_util_control_NonFatal$;
var $n_s_util_control_NonFatal$ = (void 0);
function $m_s_util_control_NonFatal$() {
  if ((!$n_s_util_control_NonFatal$)) {
    $n_s_util_control_NonFatal$ = new $c_s_util_control_NonFatal$().init___()
  };
  return $n_s_util_control_NonFatal$
}
/** @constructor */
function $c_s_util_hashing_MurmurHash3() {
  $c_O.call(this)
}
$c_s_util_hashing_MurmurHash3.prototype = new $h_O();
$c_s_util_hashing_MurmurHash3.prototype.constructor = $c_s_util_hashing_MurmurHash3;
/** @constructor */
function $h_s_util_hashing_MurmurHash3() {
  /*<skip>*/
}
$h_s_util_hashing_MurmurHash3.prototype = $c_s_util_hashing_MurmurHash3.prototype;
$c_s_util_hashing_MurmurHash3.prototype.arrayHash$mVc$sp__Asr_BoxedUnit__I__I = (function(a, seed) {
  var h = seed;
  var i = 0;
  while ((i < a.u.length)) {
    h = this.mix__I__I__I(h, 0);
    i = ((1 + i) | 0)
  };
  return this.finalizeHash__I__I__I(h, a.u.length)
});
$c_s_util_hashing_MurmurHash3.prototype.mixLast__I__I__I = (function(hash, data) {
  var k = data;
  k = $imul((-862048943), k);
  var i = k;
  k = ((i << 15) | ((i >>> 17) | 0));
  k = $imul(461845907, k);
  return (hash ^ k)
});
$c_s_util_hashing_MurmurHash3.prototype.arrayHash$mDc$sp__AD__I__I = (function(a, seed) {
  var h = seed;
  var i = 0;
  while ((i < a.u.length)) {
    h = this.mix__I__I__I(h, $m_sr_Statics$().doubleHash__D__I(a.get(i)));
    i = ((1 + i) | 0)
  };
  return this.finalizeHash__I__I__I(h, a.u.length)
});
$c_s_util_hashing_MurmurHash3.prototype.arrayHash$mJc$sp__AJ__I__I = (function(a, seed) {
  var h = seed;
  var i = 0;
  while ((i < a.u.length)) {
    h = this.mix__I__I__I(h, $m_sr_Statics$().longHash__J__I(a.get(i)));
    i = ((1 + i) | 0)
  };
  return this.finalizeHash__I__I__I(h, a.u.length)
});
$c_s_util_hashing_MurmurHash3.prototype.arrayHash$mZc$sp__AZ__I__I = (function(a, seed) {
  var h = seed;
  var i = 0;
  while ((i < a.u.length)) {
    h = this.mix__I__I__I(h, (a.get(i) ? 1231 : 1237));
    i = ((1 + i) | 0)
  };
  return this.finalizeHash__I__I__I(h, a.u.length)
});
$c_s_util_hashing_MurmurHash3.prototype.arrayHash$mBc$sp__AB__I__I = (function(a, seed) {
  var h = seed;
  var i = 0;
  while ((i < a.u.length)) {
    h = this.mix__I__I__I(h, a.get(i));
    i = ((1 + i) | 0)
  };
  return this.finalizeHash__I__I__I(h, a.u.length)
});
$c_s_util_hashing_MurmurHash3.prototype.mix__I__I__I = (function(hash, data) {
  var h = this.mixLast__I__I__I(hash, data);
  var i = h;
  h = ((i << 13) | ((i >>> 19) | 0));
  return (((-430675100) + $imul(5, h)) | 0)
});
$c_s_util_hashing_MurmurHash3.prototype.avalanche__p1__I__I = (function(hash) {
  var h = hash;
  h = (h ^ ((h >>> 16) | 0));
  h = $imul((-2048144789), h);
  h = (h ^ ((h >>> 13) | 0));
  h = $imul((-1028477387), h);
  h = (h ^ ((h >>> 16) | 0));
  return h
});
$c_s_util_hashing_MurmurHash3.prototype.arrayHash$mSc$sp__AS__I__I = (function(a, seed) {
  var h = seed;
  var i = 0;
  while ((i < a.u.length)) {
    h = this.mix__I__I__I(h, a.get(i));
    i = ((1 + i) | 0)
  };
  return this.finalizeHash__I__I__I(h, a.u.length)
});
$c_s_util_hashing_MurmurHash3.prototype.arrayHash__O__I__I = (function(a, seed) {
  var h = seed;
  var i = 0;
  while ((i < $m_sr_ScalaRunTime$().array$undlength__O__I(a))) {
    h = this.mix__I__I__I(h, $m_sr_Statics$().anyHash__O__I($m_sr_ScalaRunTime$().array$undapply__O__I__O(a, i)));
    i = ((1 + i) | 0)
  };
  return this.finalizeHash__I__I__I(h, $m_sr_ScalaRunTime$().array$undlength__O__I(a))
});
$c_s_util_hashing_MurmurHash3.prototype.productHash__s_Product__I__I = (function(x, seed) {
  var arr = x.productArity__I();
  if ((arr === 0)) {
    var this$1 = x.productPrefix__T();
    return $m_sjsr_RuntimeString$().hashCode__T__I(this$1)
  } else {
    var h = seed;
    var i = 0;
    while ((i < arr)) {
      h = this.mix__I__I__I(h, $m_sr_Statics$().anyHash__O__I(x.productElement__I__O(i)));
      i = ((1 + i) | 0)
    };
    return this.finalizeHash__I__I__I(h, arr)
  }
});
$c_s_util_hashing_MurmurHash3.prototype.unorderedHash__sc_TraversableOnce__I__I = (function(xs, seed) {
  var a = new $c_sr_IntRef().init___I(0);
  var b = new $c_sr_IntRef().init___I(0);
  var n = new $c_sr_IntRef().init___I(0);
  var c = new $c_sr_IntRef().init___I(1);
  xs.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, a$1, b$1, c$1, n$1) {
    return (function(x$2) {
      var h = $m_sr_Statics$().anyHash__O__I(x$2);
      a$1.elem$1 = ((a$1.elem$1 + h) | 0);
      b$1.elem$1 = (b$1.elem$1 ^ h);
      if ((h !== 0)) {
        c$1.elem$1 = $imul(c$1.elem$1, h)
      };
      n$1.elem$1 = ((1 + n$1.elem$1) | 0)
    })
  })(this, a, b, c, n)));
  var h$1 = seed;
  h$1 = this.mix__I__I__I(h$1, a.elem$1);
  h$1 = this.mix__I__I__I(h$1, b.elem$1);
  h$1 = this.mixLast__I__I__I(h$1, c.elem$1);
  return this.finalizeHash__I__I__I(h$1, n.elem$1)
});
$c_s_util_hashing_MurmurHash3.prototype.arrayHash$mCc$sp__AC__I__I = (function(a, seed) {
  var h = seed;
  var i = 0;
  while ((i < a.u.length)) {
    h = this.mix__I__I__I(h, a.get(i));
    i = ((1 + i) | 0)
  };
  return this.finalizeHash__I__I__I(h, a.u.length)
});
$c_s_util_hashing_MurmurHash3.prototype.arrayHash$mFc$sp__AF__I__I = (function(a, seed) {
  var h = seed;
  var i = 0;
  while ((i < a.u.length)) {
    var jsx$1 = h;
    var this$1 = $m_sr_Statics$();
    var fv = a.get(i);
    h = this.mix__I__I__I(jsx$1, this$1.doubleHash__D__I(fv));
    i = ((1 + i) | 0)
  };
  return this.finalizeHash__I__I__I(h, a.u.length)
});
$c_s_util_hashing_MurmurHash3.prototype.finalizeHash__I__I__I = (function(hash, length) {
  return this.avalanche__p1__I__I((hash ^ length))
});
$c_s_util_hashing_MurmurHash3.prototype.arrayHash$mIc$sp__AI__I__I = (function(a, seed) {
  var h = seed;
  var i = 0;
  while ((i < a.u.length)) {
    h = this.mix__I__I__I(h, a.get(i));
    i = ((1 + i) | 0)
  };
  return this.finalizeHash__I__I__I(h, a.u.length)
});
$c_s_util_hashing_MurmurHash3.prototype.orderedHash__sc_TraversableOnce__I__I = (function(xs, seed) {
  var n = new $c_sr_IntRef().init___I(0);
  var h = new $c_sr_IntRef().init___I(seed);
  xs.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, h$1, n$1) {
    return (function(x$2) {
      h$1.elem$1 = $this.mix__I__I__I(h$1.elem$1, $m_sr_Statics$().anyHash__O__I(x$2));
      n$1.elem$1 = ((1 + n$1.elem$1) | 0)
    })
  })(this, h, n)));
  return this.finalizeHash__I__I__I(h.elem$1, n.elem$1)
});
$c_s_util_hashing_MurmurHash3.prototype.listHash__sci_List__I__I = (function(xs, seed) {
  var n = 0;
  var h = seed;
  var elems = xs;
  while ((!elems.isEmpty__Z())) {
    var head = elems.head__O();
    var tail = $as_sci_List(elems.tail__O());
    h = this.mix__I__I__I(h, $m_sr_Statics$().anyHash__O__I(head));
    n = ((1 + n) | 0);
    elems = tail
  };
  return this.finalizeHash__I__I__I(h, n)
});
/** @constructor */
function $c_s_util_hashing_package$() {
  $c_O.call(this)
}
$c_s_util_hashing_package$.prototype = new $h_O();
$c_s_util_hashing_package$.prototype.constructor = $c_s_util_hashing_package$;
/** @constructor */
function $h_s_util_hashing_package$() {
  /*<skip>*/
}
$h_s_util_hashing_package$.prototype = $c_s_util_hashing_package$.prototype;
$c_s_util_hashing_package$.prototype.init___ = (function() {
  return this
});
$c_s_util_hashing_package$.prototype.byteswap32__I__I = (function(v) {
  var hc = $imul((-1640532531), v);
  hc = $m_jl_Integer$().reverseBytes__I__I(hc);
  return $imul((-1640532531), hc)
});
var $d_s_util_hashing_package$ = new $TypeData().initClass({
  s_util_hashing_package$: 0
}, false, "scala.util.hashing.package$", {
  s_util_hashing_package$: 1,
  O: 1
});
$c_s_util_hashing_package$.prototype.$classData = $d_s_util_hashing_package$;
var $n_s_util_hashing_package$ = (void 0);
function $m_s_util_hashing_package$() {
  if ((!$n_s_util_hashing_package$)) {
    $n_s_util_hashing_package$ = new $c_s_util_hashing_package$().init___()
  };
  return $n_s_util_hashing_package$
}
/** @constructor */
function $c_sc_$colon$plus$() {
  $c_O.call(this)
}
$c_sc_$colon$plus$.prototype = new $h_O();
$c_sc_$colon$plus$.prototype.constructor = $c_sc_$colon$plus$;
/** @constructor */
function $h_sc_$colon$plus$() {
  /*<skip>*/
}
$h_sc_$colon$plus$.prototype = $c_sc_$colon$plus$.prototype;
$c_sc_$colon$plus$.prototype.init___ = (function() {
  return this
});
var $d_sc_$colon$plus$ = new $TypeData().initClass({
  sc_$colon$plus$: 0
}, false, "scala.collection.$colon$plus$", {
  sc_$colon$plus$: 1,
  O: 1
});
$c_sc_$colon$plus$.prototype.$classData = $d_sc_$colon$plus$;
var $n_sc_$colon$plus$ = (void 0);
function $m_sc_$colon$plus$() {
  if ((!$n_sc_$colon$plus$)) {
    $n_sc_$colon$plus$ = new $c_sc_$colon$plus$().init___()
  };
  return $n_sc_$colon$plus$
}
/** @constructor */
function $c_sc_$plus$colon$() {
  $c_O.call(this)
}
$c_sc_$plus$colon$.prototype = new $h_O();
$c_sc_$plus$colon$.prototype.constructor = $c_sc_$plus$colon$;
/** @constructor */
function $h_sc_$plus$colon$() {
  /*<skip>*/
}
$h_sc_$plus$colon$.prototype = $c_sc_$plus$colon$.prototype;
$c_sc_$plus$colon$.prototype.init___ = (function() {
  return this
});
var $d_sc_$plus$colon$ = new $TypeData().initClass({
  sc_$plus$colon$: 0
}, false, "scala.collection.$plus$colon$", {
  sc_$plus$colon$: 1,
  O: 1
});
$c_sc_$plus$colon$.prototype.$classData = $d_sc_$plus$colon$;
var $n_sc_$plus$colon$ = (void 0);
function $m_sc_$plus$colon$() {
  if ((!$n_sc_$plus$colon$)) {
    $n_sc_$plus$colon$ = new $c_sc_$plus$colon$().init___()
  };
  return $n_sc_$plus$colon$
}
/** @constructor */
function $c_sc_Iterator$() {
  $c_O.call(this);
  this.empty$1 = null
}
$c_sc_Iterator$.prototype = new $h_O();
$c_sc_Iterator$.prototype.constructor = $c_sc_Iterator$;
/** @constructor */
function $h_sc_Iterator$() {
  /*<skip>*/
}
$h_sc_Iterator$.prototype = $c_sc_Iterator$.prototype;
$c_sc_Iterator$.prototype.init___ = (function() {
  $n_sc_Iterator$ = this;
  this.empty$1 = new $c_sc_Iterator$$anon$2().init___();
  return this
});
var $d_sc_Iterator$ = new $TypeData().initClass({
  sc_Iterator$: 0
}, false, "scala.collection.Iterator$", {
  sc_Iterator$: 1,
  O: 1
});
$c_sc_Iterator$.prototype.$classData = $d_sc_Iterator$;
var $n_sc_Iterator$ = (void 0);
function $m_sc_Iterator$() {
  if ((!$n_sc_Iterator$)) {
    $n_sc_Iterator$ = new $c_sc_Iterator$().init___()
  };
  return $n_sc_Iterator$
}
/** @constructor */
function $c_sc_Iterator$ConcatIteratorCell() {
  $c_O.call(this);
  this.head$1 = null;
  this.tail$1 = null
}
$c_sc_Iterator$ConcatIteratorCell.prototype = new $h_O();
$c_sc_Iterator$ConcatIteratorCell.prototype.constructor = $c_sc_Iterator$ConcatIteratorCell;
/** @constructor */
function $h_sc_Iterator$ConcatIteratorCell() {
  /*<skip>*/
}
$h_sc_Iterator$ConcatIteratorCell.prototype = $c_sc_Iterator$ConcatIteratorCell.prototype;
$c_sc_Iterator$ConcatIteratorCell.prototype.headIterator__sc_Iterator = (function() {
  return $as_sc_GenTraversableOnce(this.head$1.apply__O()).toIterator__sc_Iterator()
});
$c_sc_Iterator$ConcatIteratorCell.prototype.init___F0__sc_Iterator$ConcatIteratorCell = (function(head, tail) {
  this.head$1 = head;
  this.tail$1 = tail;
  return this
});
var $d_sc_Iterator$ConcatIteratorCell = new $TypeData().initClass({
  sc_Iterator$ConcatIteratorCell: 0
}, false, "scala.collection.Iterator$ConcatIteratorCell", {
  sc_Iterator$ConcatIteratorCell: 1,
  O: 1
});
$c_sc_Iterator$ConcatIteratorCell.prototype.$classData = $d_sc_Iterator$ConcatIteratorCell;
function $f_sc_TraversableOnce__copyToArray__O__I__V($thiz, xs, start) {
  $thiz.copyToArray__O__I__I__V(xs, start, (($m_sr_ScalaRunTime$().array$undlength__O__I(xs) - start) | 0))
}
function $f_sc_TraversableOnce__to__scg_CanBuildFrom__O($thiz, cbf) {
  var b = cbf.apply__scm_Builder();
  b.$$plus$plus$eq__sc_TraversableOnce__scg_Growable($thiz.seq__sc_TraversableOnce());
  return b.result__O()
}
function $f_sc_TraversableOnce__mkString__T__T__T__T($thiz, start, sep, end) {
  var this$1 = $thiz.addString__scm_StringBuilder__T__T__T__scm_StringBuilder(new $c_scm_StringBuilder().init___(), start, sep, end);
  return this$1.underlying$5.java$lang$StringBuilder$$content$f
}
function $f_sc_TraversableOnce__foldLeft__O__F2__O($thiz, z, op) {
  var result = new $c_sr_ObjectRef().init___O(z);
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, result$1, op$1) {
    return (function(x$2) {
      result$1.elem$1 = op$1.apply__O__O__O(result$1.elem$1, x$2)
    })
  })($thiz, result, op)));
  return result.elem$1
}
function $f_sc_TraversableOnce__size__I($thiz) {
  var result = new $c_sr_IntRef().init___I(0);
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, result$1) {
    return (function(x$2) {
      result$1.elem$1 = ((1 + result$1.elem$1) | 0)
    })
  })($thiz, result)));
  return result.elem$1
}
function $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option($thiz, pf) {
  var nonLocalReturnKey1 = new $c_O().init___();
  try {
    if ($is_sc_Iterator($thiz)) {
      var x2 = $as_sc_Iterator($thiz);
      var i = x2
    } else {
      if ((!$is_sc_GenIterable($thiz))) {
        $thiz.foreach__F1__V(pf.runWith__F1__F1(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, nonLocalReturnKey1$1) {
          return (function(b$2) {
            throw new $c_sr_NonLocalReturnControl().init___O__O(nonLocalReturnKey1$1, new $c_s_Some().init___O(b$2))
          })
        })($thiz, nonLocalReturnKey1))));
        return $m_s_None$()
      };
      var i = $thiz.toIterator__sc_Iterator()
    };
    var sentinel = new $c_sc_TraversableOnce$$anon$1().init___sc_TraversableOnce($thiz);
    while (i.hasNext__Z()) {
      var x = pf.applyOrElse__O__F1__O(i.next__O(), sentinel);
      if ((x !== sentinel)) {
        return new $c_s_Some().init___O(x)
      }
    };
    return $m_s_None$()
  } catch (e) {
    if ((e instanceof $c_sr_NonLocalReturnControl)) {
      var ex = $as_sr_NonLocalReturnControl(e);
      if ((ex.key$2 === nonLocalReturnKey1)) {
        return $as_s_Option(ex.value__O())
      } else {
        throw ex
      }
    } else {
      throw e
    }
  }
}
function $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder($thiz, b, start, sep, end) {
  var first = new $c_sr_BooleanRef().init___Z(true);
  b.append__T__scm_StringBuilder(start);
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, first$1, b$1, sep$1) {
    return (function(x$2) {
      if (first$1.elem$1) {
        b$1.append__O__scm_StringBuilder(x$2);
        first$1.elem$1 = false;
        return (void 0)
      } else {
        b$1.append__T__scm_StringBuilder(sep$1);
        return b$1.append__O__scm_StringBuilder(x$2)
      }
    })
  })($thiz, first, b, sep)));
  b.append__T__scm_StringBuilder(end);
  return b
}
function $f_sc_TraversableOnce__max__s_math_Ordering__O($thiz, cmp) {
  if ($thiz.isEmpty__Z()) {
    throw new $c_jl_UnsupportedOperationException().init___T("empty.max")
  };
  return $thiz.reduceLeft__F2__O(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this, cmp$1) {
    return (function(x$2, y$2) {
      return (cmp$1.gteq__O__O__Z(x$2, y$2) ? x$2 : y$2)
    })
  })($thiz, cmp)))
}
function $f_sc_TraversableOnce__toArray__s_reflect_ClassTag__O($thiz, evidence$1) {
  if ($thiz.isTraversableAgain__Z()) {
    var result = evidence$1.newArray__I__O($thiz.size__I());
    $thiz.copyToArray__O__I__V(result, 0);
    return result
  } else {
    return $thiz.toBuffer__scm_Buffer().toArray__s_reflect_ClassTag__O(evidence$1)
  }
}
function $f_sc_TraversableOnce__nonEmpty__Z($thiz) {
  return (!$thiz.isEmpty__Z())
}
function $f_sc_TraversableOnce__reduceLeft__F2__O($thiz, op) {
  if ($thiz.isEmpty__Z()) {
    throw new $c_jl_UnsupportedOperationException().init___T("empty.reduceLeft")
  };
  var first = new $c_sr_BooleanRef().init___Z(true);
  var acc = new $c_sr_ObjectRef().init___O(0);
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, first$1, acc$1, op$1) {
    return (function(x$2) {
      if (first$1.elem$1) {
        acc$1.elem$1 = x$2;
        first$1.elem$1 = false
      } else {
        acc$1.elem$1 = op$1.apply__O__O__O(acc$1.elem$1, x$2)
      }
    })
  })($thiz, first, acc, op)));
  return acc.elem$1
}
function $is_sc_TraversableOnce(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_TraversableOnce)))
}
function $as_sc_TraversableOnce(obj) {
  return (($is_sc_TraversableOnce(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.TraversableOnce"))
}
function $isArrayOf_sc_TraversableOnce(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_TraversableOnce)))
}
function $asArrayOf_sc_TraversableOnce(obj, depth) {
  return (($isArrayOf_sc_TraversableOnce(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.TraversableOnce;", depth))
}
/** @constructor */
function $c_sc_TraversableOnce$FlattenOps() {
  $c_O.call(this);
  this.scala$collection$TraversableOnce$FlattenOps$$travs$f = null
}
$c_sc_TraversableOnce$FlattenOps.prototype = new $h_O();
$c_sc_TraversableOnce$FlattenOps.prototype.constructor = $c_sc_TraversableOnce$FlattenOps;
/** @constructor */
function $h_sc_TraversableOnce$FlattenOps() {
  /*<skip>*/
}
$h_sc_TraversableOnce$FlattenOps.prototype = $c_sc_TraversableOnce$FlattenOps.prototype;
$c_sc_TraversableOnce$FlattenOps.prototype.init___sc_TraversableOnce = (function(travs) {
  this.scala$collection$TraversableOnce$FlattenOps$$travs$f = travs;
  return this
});
var $d_sc_TraversableOnce$FlattenOps = new $TypeData().initClass({
  sc_TraversableOnce$FlattenOps: 0
}, false, "scala.collection.TraversableOnce$FlattenOps", {
  sc_TraversableOnce$FlattenOps: 1,
  O: 1
});
$c_sc_TraversableOnce$FlattenOps.prototype.$classData = $d_sc_TraversableOnce$FlattenOps;
/** @constructor */
function $c_sc_TraversableOnce$MonadOps() {
  $c_O.call(this);
  this.trav$1 = null
}
$c_sc_TraversableOnce$MonadOps.prototype = new $h_O();
$c_sc_TraversableOnce$MonadOps.prototype.constructor = $c_sc_TraversableOnce$MonadOps;
/** @constructor */
function $h_sc_TraversableOnce$MonadOps() {
  /*<skip>*/
}
$h_sc_TraversableOnce$MonadOps.prototype = $c_sc_TraversableOnce$MonadOps.prototype;
$c_sc_TraversableOnce$MonadOps.prototype.init___sc_TraversableOnce = (function(trav) {
  this.trav$1 = trav;
  return this
});
var $d_sc_TraversableOnce$MonadOps = new $TypeData().initClass({
  sc_TraversableOnce$MonadOps: 0
}, false, "scala.collection.TraversableOnce$MonadOps", {
  sc_TraversableOnce$MonadOps: 1,
  O: 1
});
$c_sc_TraversableOnce$MonadOps.prototype.$classData = $d_sc_TraversableOnce$MonadOps;
/** @constructor */
function $c_scg_GenMapFactory() {
  $c_O.call(this)
}
$c_scg_GenMapFactory.prototype = new $h_O();
$c_scg_GenMapFactory.prototype.constructor = $c_scg_GenMapFactory;
/** @constructor */
function $h_scg_GenMapFactory() {
  /*<skip>*/
}
$h_scg_GenMapFactory.prototype = $c_scg_GenMapFactory.prototype;
$c_scg_GenMapFactory.prototype.apply__sc_Seq__sc_GenMap = (function(elems) {
  return $as_sc_GenMap($as_scm_Builder(this.newBuilder__scm_Builder().$$plus$plus$eq__sc_TraversableOnce__scg_Growable(elems)).result__O())
});
$c_scg_GenMapFactory.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_MapBuilder().init___sc_GenMap(this.empty__sc_GenMap())
});
/** @constructor */
function $c_scg_GenericCompanion() {
  $c_O.call(this)
}
$c_scg_GenericCompanion.prototype = new $h_O();
$c_scg_GenericCompanion.prototype.constructor = $c_scg_GenericCompanion;
/** @constructor */
function $h_scg_GenericCompanion() {
  /*<skip>*/
}
$h_scg_GenericCompanion.prototype = $c_scg_GenericCompanion.prototype;
$c_scg_GenericCompanion.prototype.apply__sc_Seq__sc_GenTraversable = (function(elems) {
  if (elems.isEmpty__Z()) {
    return this.empty__sc_GenTraversable()
  } else {
    var b = this.newBuilder__scm_Builder();
    b.$$plus$plus$eq__sc_TraversableOnce__scg_Growable(elems);
    return $as_sc_GenTraversable(b.result__O())
  }
});
$c_scg_GenericCompanion.prototype.empty__sc_GenTraversable = (function() {
  return $as_sc_GenTraversable(this.newBuilder__scm_Builder().result__O())
});
function $f_scg_GenericTraversableTemplate__flatten__F1__sc_GenTraversable($thiz, asTraversable) {
  var b = $thiz.companion__scg_GenericCompanion().newBuilder__scm_Builder();
  $as_sc_GenTraversableOnce($thiz).seq__sc_TraversableOnce().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$1, asTraversable$1) {
    return (function(xs$2) {
      return $as_scm_Builder(b$1.$$plus$plus$eq__sc_TraversableOnce__scg_Growable($as_sc_GenTraversableOnce(asTraversable$1.apply__O__O(xs$2)).seq__sc_TraversableOnce()))
    })
  })($thiz, b, asTraversable)));
  return $as_sc_GenTraversable(b.result__O())
}
function $is_scg_GenericTraversableTemplate(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.scg_GenericTraversableTemplate)))
}
function $as_scg_GenericTraversableTemplate(obj) {
  return (($is_scg_GenericTraversableTemplate(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.generic.GenericTraversableTemplate"))
}
function $isArrayOf_scg_GenericTraversableTemplate(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scg_GenericTraversableTemplate)))
}
function $asArrayOf_scg_GenericTraversableTemplate(obj, depth) {
  return (($isArrayOf_scg_GenericTraversableTemplate(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.generic.GenericTraversableTemplate;", depth))
}
function $f_scg_Growable__loop$1__pscg_Growable__sc_LinearSeq__V($thiz, xs) {
  _loop: while (true) {
    var this$1 = xs;
    if ($f_sc_TraversableOnce__nonEmpty__Z(this$1)) {
      $thiz.$$plus$eq__O__scg_Growable(xs.head__O());
      xs = $as_sc_LinearSeq(xs.tail__O());
      continue _loop
    };
    break
  }
}
function $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable($thiz, xs) {
  if ($is_sc_LinearSeq(xs)) {
    var x2 = $as_sc_LinearSeq(xs);
    var xs$1 = x2;
    $f_scg_Growable__loop$1__pscg_Growable__sc_LinearSeq__V($thiz, xs$1)
  } else {
    xs.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(elem$2) {
        return $this.$$plus$eq__O__scg_Growable(elem$2)
      })
    })($thiz)))
  };
  return $thiz
}
function $is_scg_Growable(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.scg_Growable)))
}
function $as_scg_Growable(obj) {
  return (($is_scg_Growable(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.generic.Growable"))
}
function $isArrayOf_scg_Growable(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scg_Growable)))
}
function $asArrayOf_scg_Growable(obj, depth) {
  return (($isArrayOf_scg_Growable(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.generic.Growable;", depth))
}
/** @constructor */
function $c_scg_SliceInterval() {
  $c_O.call(this);
  this.from$1 = 0;
  this.until$1 = 0
}
$c_scg_SliceInterval.prototype = new $h_O();
$c_scg_SliceInterval.prototype.constructor = $c_scg_SliceInterval;
/** @constructor */
function $h_scg_SliceInterval() {
  /*<skip>*/
}
$h_scg_SliceInterval.prototype = $c_scg_SliceInterval.prototype;
$c_scg_SliceInterval.prototype.width__I = (function() {
  return ((this.until$1 - this.from$1) | 0)
});
$c_scg_SliceInterval.prototype.init___I__I = (function(from, until) {
  this.from$1 = from;
  this.until$1 = until;
  return this
});
var $d_scg_SliceInterval = new $TypeData().initClass({
  scg_SliceInterval: 0
}, false, "scala.collection.generic.SliceInterval", {
  scg_SliceInterval: 1,
  O: 1
});
$c_scg_SliceInterval.prototype.$classData = $d_scg_SliceInterval;
/** @constructor */
function $c_scg_SliceInterval$() {
  $c_O.call(this)
}
$c_scg_SliceInterval$.prototype = new $h_O();
$c_scg_SliceInterval$.prototype.constructor = $c_scg_SliceInterval$;
/** @constructor */
function $h_scg_SliceInterval$() {
  /*<skip>*/
}
$h_scg_SliceInterval$.prototype = $c_scg_SliceInterval$.prototype;
$c_scg_SliceInterval$.prototype.init___ = (function() {
  return this
});
$c_scg_SliceInterval$.prototype.apply__I__I__scg_SliceInterval = (function(from, until) {
  var lo = ((from > 0) ? from : 0);
  var hi = ((until > 0) ? until : 0);
  return ((hi <= lo) ? new $c_scg_SliceInterval().init___I__I(lo, lo) : new $c_scg_SliceInterval().init___I__I(lo, hi))
});
var $d_scg_SliceInterval$ = new $TypeData().initClass({
  scg_SliceInterval$: 0
}, false, "scala.collection.generic.SliceInterval$", {
  scg_SliceInterval$: 1,
  O: 1
});
$c_scg_SliceInterval$.prototype.$classData = $d_scg_SliceInterval$;
var $n_scg_SliceInterval$ = (void 0);
function $m_scg_SliceInterval$() {
  if ((!$n_scg_SliceInterval$)) {
    $n_scg_SliceInterval$ = new $c_scg_SliceInterval$().init___()
  };
  return $n_scg_SliceInterval$
}
/** @constructor */
function $c_scg_SortedSetFactory() {
  $c_O.call(this)
}
$c_scg_SortedSetFactory.prototype = new $h_O();
$c_scg_SortedSetFactory.prototype.constructor = $c_scg_SortedSetFactory;
/** @constructor */
function $h_scg_SortedSetFactory() {
  /*<skip>*/
}
$h_scg_SortedSetFactory.prototype = $c_scg_SortedSetFactory.prototype;
$c_scg_SortedSetFactory.prototype.apply__sc_Seq__s_math_Ordering__sc_SortedSet = (function(elems, ord) {
  return $as_sc_SortedSet($as_scm_Builder(this.newBuilder__s_math_Ordering__scm_Builder(ord).$$plus$plus$eq__sc_TraversableOnce__scg_Growable(elems)).result__O())
});
/** @constructor */
function $c_sci_HashMap$Merger() {
  $c_O.call(this)
}
$c_sci_HashMap$Merger.prototype = new $h_O();
$c_sci_HashMap$Merger.prototype.constructor = $c_sci_HashMap$Merger;
/** @constructor */
function $h_sci_HashMap$Merger() {
  /*<skip>*/
}
$h_sci_HashMap$Merger.prototype = $c_sci_HashMap$Merger.prototype;
/** @constructor */
function $c_sci_RedBlackTree$() {
  $c_O.call(this)
}
$c_sci_RedBlackTree$.prototype = new $h_O();
$c_sci_RedBlackTree$.prototype.constructor = $c_sci_RedBlackTree$;
/** @constructor */
function $h_sci_RedBlackTree$() {
  /*<skip>*/
}
$h_sci_RedBlackTree$.prototype = $c_sci_RedBlackTree$.prototype;
$c_sci_RedBlackTree$.prototype.balance$1__p1__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree = (function(x, xv, tl, tr) {
  if ((tl instanceof $c_sci_RedBlackTree$RedTree)) {
    if ((tr instanceof $c_sci_RedBlackTree$RedTree)) {
      var left = tl.black__sci_RedBlackTree$Tree();
      var right = tr.black__sci_RedBlackTree$Tree();
      return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(x, xv, left, right)
    } else {
      var tree = tl.left$1;
      if ((tree instanceof $c_sci_RedBlackTree$RedTree)) {
        var key = tl.key$1;
        var value = tl.value$1;
        var left$2 = tl.left$1.black__sci_RedBlackTree$Tree();
        var left$1 = tl.right$1;
        var right$1 = new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(x, xv, left$1, tr);
        return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key, value, left$2, right$1)
      } else {
        var tree$1 = tl.right$1;
        if ((tree$1 instanceof $c_sci_RedBlackTree$RedTree)) {
          var key$2 = tl.right$1.key$1;
          var value$2 = tl.right$1.value$1;
          var key$1 = tl.key$1;
          var value$1 = tl.value$1;
          var left$3 = tl.left$1;
          var right$2 = tl.right$1.left$1;
          var left$5 = new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$1, value$1, left$3, right$2);
          var left$4 = tl.right$1.right$1;
          var right$3 = new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(x, xv, left$4, tr);
          return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$2, value$2, left$5, right$3)
        } else {
          return new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(x, xv, tl, tr)
        }
      }
    }
  } else if ((tr instanceof $c_sci_RedBlackTree$RedTree)) {
    var tree$2 = tr.right$1;
    if ((tree$2 instanceof $c_sci_RedBlackTree$RedTree)) {
      var key$3 = tr.key$1;
      var value$3 = tr.value$1;
      var right$4 = tr.left$1;
      var left$6 = new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(x, xv, tl, right$4);
      var right$5 = tr.right$1.black__sci_RedBlackTree$Tree();
      return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$3, value$3, left$6, right$5)
    } else {
      var tree$3 = tr.left$1;
      if ((tree$3 instanceof $c_sci_RedBlackTree$RedTree)) {
        var key$5 = tr.left$1.key$1;
        var value$5 = tr.left$1.value$1;
        var right$6 = tr.left$1.left$1;
        var left$8 = new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(x, xv, tl, right$6);
        var key$4 = tr.key$1;
        var value$4 = tr.value$1;
        var left$7 = tr.left$1.right$1;
        var right$7 = tr.right$1;
        var right$8 = new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$4, value$4, left$7, right$7);
        return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$5, value$5, left$8, right$8)
      } else {
        return new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(x, xv, tl, tr)
      }
    }
  } else {
    return new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(x, xv, tl, tr)
  }
});
$c_sci_RedBlackTree$.prototype.subl$1__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree = (function(t) {
  if ((t instanceof $c_sci_RedBlackTree$BlackTree)) {
    return t.red__sci_RedBlackTree$Tree()
  } else {
    throw new $c_jl_IllegalStateException().init___T(("Defect: invariance violation; expected black, got " + t))
  }
});
$c_sci_RedBlackTree$.prototype.init___ = (function() {
  return this
});
$c_sci_RedBlackTree$.prototype.blacken__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree = (function(t) {
  return ((t === null) ? null : t.black__sci_RedBlackTree$Tree())
});
$c_sci_RedBlackTree$.prototype.count__sci_RedBlackTree$Tree__I = (function(tree) {
  return ((tree === null) ? 0 : tree.count$1)
});
$c_sci_RedBlackTree$.prototype.isEmpty__sci_RedBlackTree$Tree__Z = (function(tree) {
  return (tree === null)
});
$c_sci_RedBlackTree$.prototype.foreachKey__sci_RedBlackTree$Tree__F1__V = (function(tree, f) {
  if ((tree !== null)) {
    this.$$undforeachKey__p1__sci_RedBlackTree$Tree__F1__V(tree, f)
  }
});
$c_sci_RedBlackTree$.prototype.delLeft$1__p1__sci_RedBlackTree$Tree__O__s_math_Ordering__sci_RedBlackTree$Tree = (function(tree$1, k$1, ordering$1) {
  var tree = tree$1.left$1;
  if ((tree instanceof $c_sci_RedBlackTree$BlackTree)) {
    return this.balLeft$1__p1__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(tree$1.key$1, tree$1.value$1, this.del__p1__sci_RedBlackTree$Tree__O__s_math_Ordering__sci_RedBlackTree$Tree(tree$1.left$1, k$1, ordering$1), tree$1.right$1)
  } else {
    var key = tree$1.key$1;
    var value = tree$1.value$1;
    var left = this.del__p1__sci_RedBlackTree$Tree__O__s_math_Ordering__sci_RedBlackTree$Tree(tree$1.left$1, k$1, ordering$1);
    var right = tree$1.right$1;
    return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key, value, left, right)
  }
});
$c_sci_RedBlackTree$.prototype.drop__sci_RedBlackTree$Tree__I__s_math_Ordering__sci_RedBlackTree$Tree = (function(tree, n, evidence$10) {
  return this.blacken__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(this.doDrop__p1__sci_RedBlackTree$Tree__I__sci_RedBlackTree$Tree(tree, n))
});
$c_sci_RedBlackTree$.prototype.take__sci_RedBlackTree$Tree__I__s_math_Ordering__sci_RedBlackTree$Tree = (function(tree, n, evidence$11) {
  return this.blacken__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(this.doTake__p1__sci_RedBlackTree$Tree__I__sci_RedBlackTree$Tree(tree, n))
});
$c_sci_RedBlackTree$.prototype.updNth__p1__sci_RedBlackTree$Tree__I__O__O__Z__sci_RedBlackTree$Tree = (function(tree, idx, k, v, overwrite) {
  if ((tree === null)) {
    return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(k, v, null, null)
  } else {
    var rank = ((1 + this.count__sci_RedBlackTree$Tree__I(tree.left$1)) | 0);
    return ((idx < rank) ? this.balanceLeft__p1__Z__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree((tree instanceof $c_sci_RedBlackTree$BlackTree), tree.key$1, tree.value$1, this.updNth__p1__sci_RedBlackTree$Tree__I__O__O__Z__sci_RedBlackTree$Tree(tree.left$1, idx, k, v, overwrite), tree.right$1) : ((idx > rank) ? this.balanceRight__p1__Z__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree((tree instanceof $c_sci_RedBlackTree$BlackTree), tree.key$1, tree.value$1, tree.left$1, this.updNth__p1__sci_RedBlackTree$Tree__I__O__O__Z__sci_RedBlackTree$Tree(tree.right$1, ((idx - rank) | 0), k, v, overwrite)) : (overwrite ? this.mkTree__p1__Z__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree((tree instanceof $c_sci_RedBlackTree$BlackTree), k, v, tree.left$1, tree.right$1) : tree)))
  }
});
$c_sci_RedBlackTree$.prototype.append$1__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree = (function(tl, tr) {
  if ((tl === null)) {
    return tr
  } else if ((tr === null)) {
    return tl
  } else if (((tl instanceof $c_sci_RedBlackTree$RedTree) && (tr instanceof $c_sci_RedBlackTree$RedTree))) {
    var bc = this.append$1__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(tl.right$1, tr.left$1);
    if ((bc instanceof $c_sci_RedBlackTree$RedTree)) {
      var key$2 = bc.key$1;
      var value$2 = bc.value$1;
      var key = tl.key$1;
      var value = tl.value$1;
      var left = tl.left$1;
      var right = bc.left$1;
      var left$2 = new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key, value, left, right);
      var key$1 = tr.key$1;
      var value$1 = tr.value$1;
      var left$1 = bc.right$1;
      var right$1 = tr.right$1;
      var right$2 = new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$1, value$1, left$1, right$1);
      return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$2, value$2, left$2, right$2)
    } else {
      var key$4 = tl.key$1;
      var value$4 = tl.value$1;
      var left$3 = tl.left$1;
      var key$3 = tr.key$1;
      var value$3 = tr.value$1;
      var right$3 = tr.right$1;
      var right$4 = new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$3, value$3, bc, right$3);
      return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$4, value$4, left$3, right$4)
    }
  } else if (((tl instanceof $c_sci_RedBlackTree$BlackTree) && (tr instanceof $c_sci_RedBlackTree$BlackTree))) {
    var bc$2 = this.append$1__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(tl.right$1, tr.left$1);
    if ((bc$2 instanceof $c_sci_RedBlackTree$RedTree)) {
      var key$7 = bc$2.key$1;
      var value$7 = bc$2.value$1;
      var key$5 = tl.key$1;
      var value$5 = tl.value$1;
      var left$4 = tl.left$1;
      var right$5 = bc$2.left$1;
      var left$6 = new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$5, value$5, left$4, right$5);
      var key$6 = tr.key$1;
      var value$6 = tr.value$1;
      var left$5 = bc$2.right$1;
      var right$6 = tr.right$1;
      var right$7 = new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$6, value$6, left$5, right$6);
      return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$7, value$7, left$6, right$7)
    } else {
      var jsx$3 = tl.key$1;
      var jsx$2 = tl.value$1;
      var jsx$1 = tl.left$1;
      var key$8 = tr.key$1;
      var value$8 = tr.value$1;
      var right$8 = tr.right$1;
      return this.balLeft$1__p1__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(jsx$3, jsx$2, jsx$1, new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$8, value$8, bc$2, right$8))
    }
  } else if ((tr instanceof $c_sci_RedBlackTree$RedTree)) {
    var key$9 = tr.key$1;
    var value$9 = tr.value$1;
    var left$7 = this.append$1__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(tl, tr.left$1);
    var right$9 = tr.right$1;
    return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$9, value$9, left$7, right$9)
  } else if ((tl instanceof $c_sci_RedBlackTree$RedTree)) {
    var key$10 = tl.key$1;
    var value$10 = tl.value$1;
    var left$8 = tl.left$1;
    var right$10 = this.append$1__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(tl.right$1, tr);
    return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$10, value$10, left$8, right$10)
  } else {
    throw new $c_jl_IllegalStateException().init___T(((("unmatched tree on append: " + tl) + ", ") + tr))
  }
});
$c_sci_RedBlackTree$.prototype.smallest__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree = (function(tree) {
  if ((tree === null)) {
    throw new $c_ju_NoSuchElementException().init___T("empty map")
  };
  var result = tree;
  while ((result.left$1 !== null)) {
    result = result.left$1
  };
  return result
});
$c_sci_RedBlackTree$.prototype.upd__p1__sci_RedBlackTree$Tree__O__O__Z__s_math_Ordering__sci_RedBlackTree$Tree = (function(tree, k, v, overwrite, ordering) {
  if ((tree === null)) {
    return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(k, v, null, null)
  } else {
    var cmp = ordering.compare__O__O__I(k, tree.key$1);
    return ((cmp < 0) ? this.balanceLeft__p1__Z__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree((tree instanceof $c_sci_RedBlackTree$BlackTree), tree.key$1, tree.value$1, this.upd__p1__sci_RedBlackTree$Tree__O__O__Z__s_math_Ordering__sci_RedBlackTree$Tree(tree.left$1, k, v, overwrite, ordering), tree.right$1) : ((cmp > 0) ? this.balanceRight__p1__Z__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree((tree instanceof $c_sci_RedBlackTree$BlackTree), tree.key$1, tree.value$1, tree.left$1, this.upd__p1__sci_RedBlackTree$Tree__O__O__Z__s_math_Ordering__sci_RedBlackTree$Tree(tree.right$1, k, v, overwrite, ordering)) : ((overwrite || (!$m_sr_BoxesRunTime$().equals__O__O__Z(k, tree.key$1))) ? this.mkTree__p1__Z__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree((tree instanceof $c_sci_RedBlackTree$BlackTree), k, v, tree.left$1, tree.right$1) : tree)))
  }
});
$c_sci_RedBlackTree$.prototype.doDrop__p1__sci_RedBlackTree$Tree__I__sci_RedBlackTree$Tree = (function(tree, n) {
  if ((n <= 0)) {
    return tree
  };
  if ((n >= this.count__sci_RedBlackTree$Tree__I(tree))) {
    return null
  };
  var count = this.count__sci_RedBlackTree$Tree__I(tree.left$1);
  if ((n > count)) {
    return this.doDrop__p1__sci_RedBlackTree$Tree__I__sci_RedBlackTree$Tree(tree.right$1, (((-1) + ((n - count) | 0)) | 0))
  };
  var newLeft = this.doDrop__p1__sci_RedBlackTree$Tree__I__sci_RedBlackTree$Tree(tree.left$1, n);
  return ((newLeft === tree.left$1) ? tree : ((newLeft === null) ? this.updNth__p1__sci_RedBlackTree$Tree__I__O__O__Z__sci_RedBlackTree$Tree(tree.right$1, (((-1) + ((n - count) | 0)) | 0), tree.key$1, tree.value$1, false) : this.rebalance__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(tree, newLeft, tree.right$1)))
});
$c_sci_RedBlackTree$.prototype.findDepth$1__p1__sci_RedBlackTree$NList__I__sci_RedBlackTree$NList = (function(zipper, depth) {
  _findDepth: while (true) {
    if ((zipper === null)) {
      throw new $c_jl_IllegalStateException().init___T("Defect: unexpected empty zipper while computing range")
    } else {
      var tree = $as_sci_RedBlackTree$Tree(zipper.head$1);
      if ((tree instanceof $c_sci_RedBlackTree$BlackTree)) {
        if ((depth === 1)) {
          return zipper
        } else {
          var temp$zipper = zipper.tail$1;
          var temp$depth = (((-1) + depth) | 0);
          zipper = temp$zipper;
          depth = temp$depth;
          continue _findDepth
        }
      } else {
        zipper = zipper.tail$1;
        continue _findDepth
      }
    }
  }
});
$c_sci_RedBlackTree$.prototype.$delete__sci_RedBlackTree$Tree__O__s_math_Ordering__sci_RedBlackTree$Tree = (function(tree, k, evidence$4) {
  return this.blacken__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(this.del__p1__sci_RedBlackTree$Tree__O__s_math_Ordering__sci_RedBlackTree$Tree(tree, k, evidence$4))
});
$c_sci_RedBlackTree$.prototype.delRight$1__p1__sci_RedBlackTree$Tree__O__s_math_Ordering__sci_RedBlackTree$Tree = (function(tree$1, k$1, ordering$1) {
  var tree = tree$1.right$1;
  if ((tree instanceof $c_sci_RedBlackTree$BlackTree)) {
    return this.balRight$1__p1__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(tree$1.key$1, tree$1.value$1, tree$1.left$1, this.del__p1__sci_RedBlackTree$Tree__O__s_math_Ordering__sci_RedBlackTree$Tree(tree$1.right$1, k$1, ordering$1))
  } else {
    var key = tree$1.key$1;
    var value = tree$1.value$1;
    var left = tree$1.left$1;
    var right = this.del__p1__sci_RedBlackTree$Tree__O__s_math_Ordering__sci_RedBlackTree$Tree(tree$1.right$1, k$1, ordering$1);
    return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key, value, left, right)
  }
});
$c_sci_RedBlackTree$.prototype.balRight$1__p1__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree = (function(x, xv, tl, tr) {
  if ((tr instanceof $c_sci_RedBlackTree$RedTree)) {
    var right = tr.black__sci_RedBlackTree$Tree();
    return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(x, xv, tl, right)
  } else if ((tl instanceof $c_sci_RedBlackTree$BlackTree)) {
    return this.balance$1__p1__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(x, xv, tl.red__sci_RedBlackTree$Tree(), tr)
  } else {
    if ((tl instanceof $c_sci_RedBlackTree$RedTree)) {
      var tree = tl.right$1;
      var jsx$1 = (tree instanceof $c_sci_RedBlackTree$BlackTree)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var key = tl.right$1.key$1;
      var value = tl.right$1.value$1;
      var left$1 = this.balance$1__p1__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(tl.key$1, tl.value$1, this.subl$1__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(tl.left$1), tl.right$1.left$1);
      var left = tl.right$1.right$1;
      var right$1 = new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(x, xv, left, tr);
      return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key, value, left$1, right$1)
    } else {
      throw new $c_jl_IllegalStateException().init___T("Defect: invariance violation")
    }
  }
});
$c_sci_RedBlackTree$.prototype.rebalance__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree = (function(tree, newLeft, newRight) {
  var blkNewLeft = this.blacken__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(newLeft);
  var blkNewRight = this.blacken__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(newRight);
  var x1 = this.unzipBoth$1__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$NList__sci_RedBlackTree$NList__I__T4(blkNewLeft, blkNewRight, null, null, 0);
  if ((x1 === null)) {
    throw new $c_s_MatchError().init___O(x1)
  };
  var zipper = $as_sci_RedBlackTree$NList(x1.$$und1$1);
  var levelled = $uZ(x1.$$und2$1);
  var leftMost = $uZ(x1.$$und3$1);
  var smallerDepth = $uI(x1.$$und4$1);
  if (levelled) {
    var key = tree.key$1;
    var value = tree.value$1;
    return new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key, value, blkNewLeft, blkNewRight)
  } else {
    var zipFrom = this.findDepth$1__p1__sci_RedBlackTree$NList__I__sci_RedBlackTree$NList(zipper, smallerDepth);
    if (leftMost) {
      var key$1 = tree.key$1;
      var value$1 = tree.value$1;
      var right = $as_sci_RedBlackTree$Tree(zipFrom.head$1);
      var union = new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$1, value$1, blkNewLeft, right)
    } else {
      var key$2 = tree.key$1;
      var value$2 = tree.value$1;
      var left = $as_sci_RedBlackTree$Tree(zipFrom.head$1);
      var union = new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$2, value$2, left, blkNewRight)
    };
    var xs = zipFrom.tail$1;
    var acc = union;
    var these = xs;
    while ((these !== null)) {
      var arg1 = acc;
      var arg2 = these.head$1;
      var tree$2 = $as_sci_RedBlackTree$Tree(arg1);
      var node = $as_sci_RedBlackTree$Tree(arg2);
      acc = (leftMost ? $m_sci_RedBlackTree$().balanceLeft__p1__Z__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree((node instanceof $c_sci_RedBlackTree$BlackTree), node.key$1, node.value$1, tree$2, node.right$1) : $m_sci_RedBlackTree$().balanceRight__p1__Z__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree((node instanceof $c_sci_RedBlackTree$BlackTree), node.key$1, node.value$1, node.left$1, tree$2));
      these = these.tail$1
    };
    var zippedTree = $as_sci_RedBlackTree$Tree(acc);
    return zippedTree
  }
});
$c_sci_RedBlackTree$.prototype.del__p1__sci_RedBlackTree$Tree__O__s_math_Ordering__sci_RedBlackTree$Tree = (function(tree, k, ordering) {
  if ((tree === null)) {
    return null
  } else {
    var cmp = ordering.compare__O__O__I(k, tree.key$1);
    return ((cmp < 0) ? this.delLeft$1__p1__sci_RedBlackTree$Tree__O__s_math_Ordering__sci_RedBlackTree$Tree(tree, k, ordering) : ((cmp > 0) ? this.delRight$1__p1__sci_RedBlackTree$Tree__O__s_math_Ordering__sci_RedBlackTree$Tree(tree, k, ordering) : this.append$1__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(tree.left$1, tree.right$1)))
  }
});
$c_sci_RedBlackTree$.prototype.unzipBoth$1__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$NList__sci_RedBlackTree$NList__I__T4 = (function(left, right, leftZipper, rightZipper, smallerDepth) {
  _unzipBoth: while (true) {
    var tree = left;
    if ((tree instanceof $c_sci_RedBlackTree$BlackTree)) {
      var tree$1 = right;
      var jsx$1 = (tree$1 instanceof $c_sci_RedBlackTree$BlackTree)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var temp$left = left.right$1;
      var temp$right = right.left$1;
      var x = left;
      var xs = leftZipper;
      var temp$leftZipper = new $c_sci_RedBlackTree$NList().init___O__sci_RedBlackTree$NList(x, xs);
      var x$1 = right;
      var xs$1 = rightZipper;
      var temp$rightZipper = new $c_sci_RedBlackTree$NList().init___O__sci_RedBlackTree$NList(x$1, xs$1);
      var temp$smallerDepth = ((1 + smallerDepth) | 0);
      left = temp$left;
      right = temp$right;
      leftZipper = temp$leftZipper;
      rightZipper = temp$rightZipper;
      smallerDepth = temp$smallerDepth;
      continue _unzipBoth
    } else {
      var tree$2 = left;
      if ((tree$2 instanceof $c_sci_RedBlackTree$RedTree)) {
        var tree$3 = right;
        var jsx$2 = (tree$3 instanceof $c_sci_RedBlackTree$RedTree)
      } else {
        var jsx$2 = false
      };
      if (jsx$2) {
        var temp$left$2 = left.right$1;
        var temp$right$2 = right.left$1;
        var x$2 = left;
        var xs$2 = leftZipper;
        var temp$leftZipper$2 = new $c_sci_RedBlackTree$NList().init___O__sci_RedBlackTree$NList(x$2, xs$2);
        var x$3 = right;
        var xs$3 = rightZipper;
        var temp$rightZipper$2 = new $c_sci_RedBlackTree$NList().init___O__sci_RedBlackTree$NList(x$3, xs$3);
        left = temp$left$2;
        right = temp$right$2;
        leftZipper = temp$leftZipper$2;
        rightZipper = temp$rightZipper$2;
        continue _unzipBoth
      } else {
        var tree$4 = right;
        if ((tree$4 instanceof $c_sci_RedBlackTree$RedTree)) {
          var temp$right$3 = right.left$1;
          var x$4 = right;
          var xs$4 = rightZipper;
          var temp$rightZipper$3 = new $c_sci_RedBlackTree$NList().init___O__sci_RedBlackTree$NList(x$4, xs$4);
          right = temp$right$3;
          rightZipper = temp$rightZipper$3;
          continue _unzipBoth
        } else {
          var tree$5 = left;
          if ((tree$5 instanceof $c_sci_RedBlackTree$RedTree)) {
            var temp$left$3 = left.right$1;
            var x$5 = left;
            var xs$5 = leftZipper;
            var temp$leftZipper$3 = new $c_sci_RedBlackTree$NList().init___O__sci_RedBlackTree$NList(x$5, xs$5);
            left = temp$left$3;
            leftZipper = temp$leftZipper$3;
            continue _unzipBoth
          } else if (((left === null) && (right === null))) {
            return new $c_T4().init___O__O__O__O(null, true, false, smallerDepth)
          } else {
            if ((left === null)) {
              var tree$6 = right;
              var jsx$3 = (tree$6 instanceof $c_sci_RedBlackTree$BlackTree)
            } else {
              var jsx$3 = false
            };
            if (jsx$3) {
              var x$6 = right;
              var xs$6 = rightZipper;
              return new $c_T4().init___O__O__O__O(this.unzip$1__p1__sci_RedBlackTree$NList__Z__sci_RedBlackTree$NList(new $c_sci_RedBlackTree$NList().init___O__sci_RedBlackTree$NList(x$6, xs$6), true), false, true, smallerDepth)
            } else {
              var tree$7 = left;
              if (((tree$7 instanceof $c_sci_RedBlackTree$BlackTree) && (right === null))) {
                var x$7 = left;
                var xs$7 = leftZipper;
                return new $c_T4().init___O__O__O__O(this.unzip$1__p1__sci_RedBlackTree$NList__Z__sci_RedBlackTree$NList(new $c_sci_RedBlackTree$NList().init___O__sci_RedBlackTree$NList(x$7, xs$7), false), false, false, smallerDepth)
              } else {
                throw new $c_jl_IllegalStateException().init___T(((("unmatched trees in unzip: " + left) + ", ") + right))
              }
            }
          }
        }
      }
    }
  }
});
$c_sci_RedBlackTree$.prototype.balanceLeft__p1__Z__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree = (function(isBlack, z, zv, l, d) {
  if ((l instanceof $c_sci_RedBlackTree$RedTree)) {
    var tree = l.left$1;
    var jsx$1 = (tree instanceof $c_sci_RedBlackTree$RedTree)
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var key$1 = l.key$1;
    var value$1 = l.value$1;
    var key = l.left$1.key$1;
    var value = l.left$1.value$1;
    var left = l.left$1.left$1;
    var right = l.left$1.right$1;
    var left$2 = new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key, value, left, right);
    var left$1 = l.right$1;
    var right$1 = new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(z, zv, left$1, d);
    return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$1, value$1, left$2, right$1)
  } else {
    if ((l instanceof $c_sci_RedBlackTree$RedTree)) {
      var tree$1 = l.right$1;
      var jsx$2 = (tree$1 instanceof $c_sci_RedBlackTree$RedTree)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var key$3 = l.right$1.key$1;
      var value$3 = l.right$1.value$1;
      var key$2 = l.key$1;
      var value$2 = l.value$1;
      var left$3 = l.left$1;
      var right$2 = l.right$1.left$1;
      var left$5 = new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$2, value$2, left$3, right$2);
      var left$4 = l.right$1.right$1;
      var right$3 = new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(z, zv, left$4, d);
      return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$3, value$3, left$5, right$3)
    } else {
      return this.mkTree__p1__Z__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(isBlack, z, zv, l, d)
    }
  }
});
$c_sci_RedBlackTree$.prototype.$$undforeachKey__p1__sci_RedBlackTree$Tree__F1__V = (function(tree, f) {
  __foreachKey: while (true) {
    if ((tree.left$1 !== null)) {
      this.$$undforeachKey__p1__sci_RedBlackTree$Tree__F1__V(tree.left$1, f)
    };
    f.apply__O__O(tree.key$1);
    if ((tree.right$1 !== null)) {
      tree = tree.right$1;
      continue __foreachKey
    };
    break
  }
});
$c_sci_RedBlackTree$.prototype.balanceRight__p1__Z__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree = (function(isBlack, x, xv, a, r) {
  if ((r instanceof $c_sci_RedBlackTree$RedTree)) {
    var tree = r.left$1;
    var jsx$1 = (tree instanceof $c_sci_RedBlackTree$RedTree)
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var key$1 = r.left$1.key$1;
    var value$1 = r.left$1.value$1;
    var right = r.left$1.left$1;
    var left$1 = new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(x, xv, a, right);
    var key = r.key$1;
    var value = r.value$1;
    var left = r.left$1.right$1;
    var right$1 = r.right$1;
    var right$2 = new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key, value, left, right$1);
    return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$1, value$1, left$1, right$2)
  } else {
    if ((r instanceof $c_sci_RedBlackTree$RedTree)) {
      var tree$1 = r.right$1;
      var jsx$2 = (tree$1 instanceof $c_sci_RedBlackTree$RedTree)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var key$3 = r.key$1;
      var value$3 = r.value$1;
      var right$3 = r.left$1;
      var left$3 = new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(x, xv, a, right$3);
      var key$2 = r.right$1.key$1;
      var value$2 = r.right$1.value$1;
      var left$2 = r.right$1.left$1;
      var right$4 = r.right$1.right$1;
      var right$5 = new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$2, value$2, left$2, right$4);
      return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key$3, value$3, left$3, right$5)
    } else {
      return this.mkTree__p1__Z__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(isBlack, x, xv, a, r)
    }
  }
});
$c_sci_RedBlackTree$.prototype.update__sci_RedBlackTree$Tree__O__O__Z__s_math_Ordering__sci_RedBlackTree$Tree = (function(tree, k, v, overwrite, evidence$3) {
  return this.blacken__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(this.upd__p1__sci_RedBlackTree$Tree__O__O__Z__s_math_Ordering__sci_RedBlackTree$Tree(tree, k, v, overwrite, evidence$3))
});
$c_sci_RedBlackTree$.prototype.lookup__sci_RedBlackTree$Tree__O__s_math_Ordering__sci_RedBlackTree$Tree = (function(tree, x, ordering) {
  _lookup: while (true) {
    if ((tree === null)) {
      return null
    } else {
      var cmp = ordering.compare__O__O__I(x, tree.key$1);
      if ((cmp < 0)) {
        tree = tree.left$1;
        continue _lookup
      } else if ((cmp > 0)) {
        tree = tree.right$1;
        continue _lookup
      } else {
        return tree
      }
    }
  }
});
$c_sci_RedBlackTree$.prototype.mkTree__p1__Z__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree = (function(isBlack, k, v, l, r) {
  return (isBlack ? new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(k, v, l, r) : new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(k, v, l, r))
});
$c_sci_RedBlackTree$.prototype.unzip$1__p1__sci_RedBlackTree$NList__Z__sci_RedBlackTree$NList = (function(zipper, leftMost) {
  _unzip: while (true) {
    var next = (leftMost ? $as_sci_RedBlackTree$Tree(zipper.head$1).left$1 : $as_sci_RedBlackTree$Tree(zipper.head$1).right$1);
    if ((next === null)) {
      return zipper
    } else {
      var xs = zipper;
      zipper = new $c_sci_RedBlackTree$NList().init___O__sci_RedBlackTree$NList(next, xs);
      continue _unzip
    }
  }
});
$c_sci_RedBlackTree$.prototype.contains__sci_RedBlackTree$Tree__O__s_math_Ordering__Z = (function(tree, x, evidence$1) {
  return (this.lookup__sci_RedBlackTree$Tree__O__s_math_Ordering__sci_RedBlackTree$Tree(tree, x, evidence$1) !== null)
});
$c_sci_RedBlackTree$.prototype.balLeft$1__p1__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree = (function(x, xv, tl, tr) {
  if ((tl instanceof $c_sci_RedBlackTree$RedTree)) {
    var left = tl.black__sci_RedBlackTree$Tree();
    return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(x, xv, left, tr)
  } else if ((tr instanceof $c_sci_RedBlackTree$BlackTree)) {
    return this.balance$1__p1__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(x, xv, tl, tr.red__sci_RedBlackTree$Tree())
  } else {
    if ((tr instanceof $c_sci_RedBlackTree$RedTree)) {
      var tree = tr.left$1;
      var jsx$1 = (tree instanceof $c_sci_RedBlackTree$BlackTree)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var key = tr.left$1.key$1;
      var value = tr.left$1.value$1;
      var right = tr.left$1.left$1;
      var left$1 = new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(x, xv, tl, right);
      var right$1 = this.balance$1__p1__O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(tr.key$1, tr.value$1, tr.left$1.right$1, this.subl$1__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(tr.right$1));
      return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key, value, left$1, right$1)
    } else {
      throw new $c_jl_IllegalStateException().init___T("Defect: invariance violation")
    }
  }
});
$c_sci_RedBlackTree$.prototype.doTake__p1__sci_RedBlackTree$Tree__I__sci_RedBlackTree$Tree = (function(tree, n) {
  if ((n <= 0)) {
    return null
  };
  if ((n >= this.count__sci_RedBlackTree$Tree__I(tree))) {
    return tree
  };
  var count = this.count__sci_RedBlackTree$Tree__I(tree.left$1);
  if ((n <= count)) {
    return this.doTake__p1__sci_RedBlackTree$Tree__I__sci_RedBlackTree$Tree(tree.left$1, n)
  };
  var newRight = this.doTake__p1__sci_RedBlackTree$Tree__I__sci_RedBlackTree$Tree(tree.right$1, (((-1) + ((n - count) | 0)) | 0));
  return ((newRight === tree.right$1) ? tree : ((newRight === null) ? this.updNth__p1__sci_RedBlackTree$Tree__I__O__O__Z__sci_RedBlackTree$Tree(tree.left$1, n, tree.key$1, tree.value$1, false) : this.rebalance__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(tree, tree.left$1, newRight)))
});
var $d_sci_RedBlackTree$ = new $TypeData().initClass({
  sci_RedBlackTree$: 0
}, false, "scala.collection.immutable.RedBlackTree$", {
  sci_RedBlackTree$: 1,
  O: 1
});
$c_sci_RedBlackTree$.prototype.$classData = $d_sci_RedBlackTree$;
var $n_sci_RedBlackTree$ = (void 0);
function $m_sci_RedBlackTree$() {
  if ((!$n_sci_RedBlackTree$)) {
    $n_sci_RedBlackTree$ = new $c_sci_RedBlackTree$().init___()
  };
  return $n_sci_RedBlackTree$
}
/** @constructor */
function $c_sci_RedBlackTree$NList() {
  $c_O.call(this);
  this.head$1 = null;
  this.tail$1 = null
}
$c_sci_RedBlackTree$NList.prototype = new $h_O();
$c_sci_RedBlackTree$NList.prototype.constructor = $c_sci_RedBlackTree$NList;
/** @constructor */
function $h_sci_RedBlackTree$NList() {
  /*<skip>*/
}
$h_sci_RedBlackTree$NList.prototype = $c_sci_RedBlackTree$NList.prototype;
$c_sci_RedBlackTree$NList.prototype.init___O__sci_RedBlackTree$NList = (function(head, tail) {
  this.head$1 = head;
  this.tail$1 = tail;
  return this
});
function $as_sci_RedBlackTree$NList(obj) {
  return (((obj instanceof $c_sci_RedBlackTree$NList) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.RedBlackTree$NList"))
}
function $isArrayOf_sci_RedBlackTree$NList(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_RedBlackTree$NList)))
}
function $asArrayOf_sci_RedBlackTree$NList(obj, depth) {
  return (($isArrayOf_sci_RedBlackTree$NList(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.RedBlackTree$NList;", depth))
}
var $d_sci_RedBlackTree$NList = new $TypeData().initClass({
  sci_RedBlackTree$NList: 0
}, false, "scala.collection.immutable.RedBlackTree$NList", {
  sci_RedBlackTree$NList: 1,
  O: 1
});
$c_sci_RedBlackTree$NList.prototype.$classData = $d_sci_RedBlackTree$NList;
/** @constructor */
function $c_sci_Stream$$hash$colon$colon$() {
  $c_O.call(this)
}
$c_sci_Stream$$hash$colon$colon$.prototype = new $h_O();
$c_sci_Stream$$hash$colon$colon$.prototype.constructor = $c_sci_Stream$$hash$colon$colon$;
/** @constructor */
function $h_sci_Stream$$hash$colon$colon$() {
  /*<skip>*/
}
$h_sci_Stream$$hash$colon$colon$.prototype = $c_sci_Stream$$hash$colon$colon$.prototype;
$c_sci_Stream$$hash$colon$colon$.prototype.init___ = (function() {
  return this
});
var $d_sci_Stream$$hash$colon$colon$ = new $TypeData().initClass({
  sci_Stream$$hash$colon$colon$: 0
}, false, "scala.collection.immutable.Stream$$hash$colon$colon$", {
  sci_Stream$$hash$colon$colon$: 1,
  O: 1
});
$c_sci_Stream$$hash$colon$colon$.prototype.$classData = $d_sci_Stream$$hash$colon$colon$;
var $n_sci_Stream$$hash$colon$colon$ = (void 0);
function $m_sci_Stream$$hash$colon$colon$() {
  if ((!$n_sci_Stream$$hash$colon$colon$)) {
    $n_sci_Stream$$hash$colon$colon$ = new $c_sci_Stream$$hash$colon$colon$().init___()
  };
  return $n_sci_Stream$$hash$colon$colon$
}
/** @constructor */
function $c_sci_Stream$ConsWrapper() {
  $c_O.call(this);
  this.tl$1 = null
}
$c_sci_Stream$ConsWrapper.prototype = new $h_O();
$c_sci_Stream$ConsWrapper.prototype.constructor = $c_sci_Stream$ConsWrapper;
/** @constructor */
function $h_sci_Stream$ConsWrapper() {
  /*<skip>*/
}
$h_sci_Stream$ConsWrapper.prototype = $c_sci_Stream$ConsWrapper.prototype;
$c_sci_Stream$ConsWrapper.prototype.init___F0 = (function(tl) {
  this.tl$1 = tl;
  return this
});
$c_sci_Stream$ConsWrapper.prototype.$$hash$colon$colon__O__sci_Stream = (function(hd) {
  var tl = this.tl$1;
  return new $c_sci_Stream$Cons().init___O__F0(hd, tl)
});
$c_sci_Stream$ConsWrapper.prototype.$$hash$colon$colon$colon__sci_Stream__sci_Stream = (function(prefix) {
  return prefix.append__F0__sci_Stream(this.tl$1)
});
var $d_sci_Stream$ConsWrapper = new $TypeData().initClass({
  sci_Stream$ConsWrapper: 0
}, false, "scala.collection.immutable.Stream$ConsWrapper", {
  sci_Stream$ConsWrapper: 1,
  O: 1
});
$c_sci_Stream$ConsWrapper.prototype.$classData = $d_sci_Stream$ConsWrapper;
/** @constructor */
function $c_sci_StreamIterator$LazyCell() {
  $c_O.call(this);
  this.v$1 = null;
  this.st$1 = null;
  this.bitmap$0$1 = false;
  this.$$outer$1 = null
}
$c_sci_StreamIterator$LazyCell.prototype = new $h_O();
$c_sci_StreamIterator$LazyCell.prototype.constructor = $c_sci_StreamIterator$LazyCell;
/** @constructor */
function $h_sci_StreamIterator$LazyCell() {
  /*<skip>*/
}
$h_sci_StreamIterator$LazyCell.prototype = $c_sci_StreamIterator$LazyCell.prototype;
$c_sci_StreamIterator$LazyCell.prototype.init___sci_StreamIterator__F0 = (function($$outer, st) {
  this.st$1 = st;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_sci_StreamIterator$LazyCell.prototype.v$lzycompute__p1__sci_Stream = (function() {
  if ((!this.bitmap$0$1)) {
    this.v$1 = $as_sci_Stream(this.st$1.apply__O());
    this.bitmap$0$1 = true
  };
  this.st$1 = null;
  return this.v$1
});
$c_sci_StreamIterator$LazyCell.prototype.v__sci_Stream = (function() {
  return ((!this.bitmap$0$1) ? this.v$lzycompute__p1__sci_Stream() : this.v$1)
});
var $d_sci_StreamIterator$LazyCell = new $TypeData().initClass({
  sci_StreamIterator$LazyCell: 0
}, false, "scala.collection.immutable.StreamIterator$LazyCell", {
  sci_StreamIterator$LazyCell: 1,
  O: 1
});
$c_sci_StreamIterator$LazyCell.prototype.$classData = $d_sci_StreamIterator$LazyCell;
/** @constructor */
function $c_sci_StringOps$() {
  $c_O.call(this)
}
$c_sci_StringOps$.prototype = new $h_O();
$c_sci_StringOps$.prototype.constructor = $c_sci_StringOps$;
/** @constructor */
function $h_sci_StringOps$() {
  /*<skip>*/
}
$h_sci_StringOps$.prototype = $c_sci_StringOps$.prototype;
$c_sci_StringOps$.prototype.init___ = (function() {
  return this
});
$c_sci_StringOps$.prototype.equals$extension__T__O__Z = (function($$this, x$1) {
  if ((x$1 instanceof $c_sci_StringOps)) {
    var StringOps$1 = ((x$1 === null) ? null : $as_sci_StringOps(x$1).repr$1);
    return ($$this === StringOps$1)
  } else {
    return false
  }
});
$c_sci_StringOps$.prototype.slice$extension__T__I__I__T = (function($$this, from, until) {
  var start = ((from < 0) ? 0 : from);
  if (((until <= start) || (start >= $uI($$this.length)))) {
    return ""
  };
  var end = ((until > $uI($$this.length)) ? $uI($$this.length) : until);
  return $as_T($$this.substring(start, end))
});
var $d_sci_StringOps$ = new $TypeData().initClass({
  sci_StringOps$: 0
}, false, "scala.collection.immutable.StringOps$", {
  sci_StringOps$: 1,
  O: 1
});
$c_sci_StringOps$.prototype.$classData = $d_sci_StringOps$;
var $n_sci_StringOps$ = (void 0);
function $m_sci_StringOps$() {
  if ((!$n_sci_StringOps$)) {
    $n_sci_StringOps$ = new $c_sci_StringOps$().init___()
  };
  return $n_sci_StringOps$
}
/** @constructor */
function $c_sci_WrappedString$() {
  $c_O.call(this)
}
$c_sci_WrappedString$.prototype = new $h_O();
$c_sci_WrappedString$.prototype.constructor = $c_sci_WrappedString$;
/** @constructor */
function $h_sci_WrappedString$() {
  /*<skip>*/
}
$h_sci_WrappedString$.prototype = $c_sci_WrappedString$.prototype;
$c_sci_WrappedString$.prototype.init___ = (function() {
  return this
});
$c_sci_WrappedString$.prototype.newBuilder__scm_Builder = (function() {
  var this$2 = new $c_scm_StringBuilder().init___();
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2) {
      var x = $as_T(x$2);
      return new $c_sci_WrappedString().init___T(x)
    })
  })(this));
  return new $c_scm_Builder$$anon$1().init___scm_Builder__F1(this$2, f)
});
var $d_sci_WrappedString$ = new $TypeData().initClass({
  sci_WrappedString$: 0
}, false, "scala.collection.immutable.WrappedString$", {
  sci_WrappedString$: 1,
  O: 1
});
$c_sci_WrappedString$.prototype.$classData = $d_sci_WrappedString$;
var $n_sci_WrappedString$ = (void 0);
function $m_sci_WrappedString$() {
  if ((!$n_sci_WrappedString$)) {
    $n_sci_WrappedString$ = new $c_sci_WrappedString$().init___()
  };
  return $n_sci_WrappedString$
}
/** @constructor */
function $c_scm_ArrayOps$ofBoolean$() {
  $c_O.call(this)
}
$c_scm_ArrayOps$ofBoolean$.prototype = new $h_O();
$c_scm_ArrayOps$ofBoolean$.prototype.constructor = $c_scm_ArrayOps$ofBoolean$;
/** @constructor */
function $h_scm_ArrayOps$ofBoolean$() {
  /*<skip>*/
}
$h_scm_ArrayOps$ofBoolean$.prototype = $c_scm_ArrayOps$ofBoolean$.prototype;
$c_scm_ArrayOps$ofBoolean$.prototype.init___ = (function() {
  return this
});
$c_scm_ArrayOps$ofBoolean$.prototype.equals$extension__AZ__O__Z = (function($$this, x$1) {
  if ((x$1 instanceof $c_scm_ArrayOps$ofBoolean)) {
    var ofBoolean$1 = ((x$1 === null) ? null : $as_scm_ArrayOps$ofBoolean(x$1).repr$1);
    return ($$this === ofBoolean$1)
  } else {
    return false
  }
});
var $d_scm_ArrayOps$ofBoolean$ = new $TypeData().initClass({
  scm_ArrayOps$ofBoolean$: 0
}, false, "scala.collection.mutable.ArrayOps$ofBoolean$", {
  scm_ArrayOps$ofBoolean$: 1,
  O: 1
});
$c_scm_ArrayOps$ofBoolean$.prototype.$classData = $d_scm_ArrayOps$ofBoolean$;
var $n_scm_ArrayOps$ofBoolean$ = (void 0);
function $m_scm_ArrayOps$ofBoolean$() {
  if ((!$n_scm_ArrayOps$ofBoolean$)) {
    $n_scm_ArrayOps$ofBoolean$ = new $c_scm_ArrayOps$ofBoolean$().init___()
  };
  return $n_scm_ArrayOps$ofBoolean$
}
/** @constructor */
function $c_scm_ArrayOps$ofByte$() {
  $c_O.call(this)
}
$c_scm_ArrayOps$ofByte$.prototype = new $h_O();
$c_scm_ArrayOps$ofByte$.prototype.constructor = $c_scm_ArrayOps$ofByte$;
/** @constructor */
function $h_scm_ArrayOps$ofByte$() {
  /*<skip>*/
}
$h_scm_ArrayOps$ofByte$.prototype = $c_scm_ArrayOps$ofByte$.prototype;
$c_scm_ArrayOps$ofByte$.prototype.init___ = (function() {
  return this
});
$c_scm_ArrayOps$ofByte$.prototype.equals$extension__AB__O__Z = (function($$this, x$1) {
  if ((x$1 instanceof $c_scm_ArrayOps$ofByte)) {
    var ofByte$1 = ((x$1 === null) ? null : $as_scm_ArrayOps$ofByte(x$1).repr$1);
    return ($$this === ofByte$1)
  } else {
    return false
  }
});
var $d_scm_ArrayOps$ofByte$ = new $TypeData().initClass({
  scm_ArrayOps$ofByte$: 0
}, false, "scala.collection.mutable.ArrayOps$ofByte$", {
  scm_ArrayOps$ofByte$: 1,
  O: 1
});
$c_scm_ArrayOps$ofByte$.prototype.$classData = $d_scm_ArrayOps$ofByte$;
var $n_scm_ArrayOps$ofByte$ = (void 0);
function $m_scm_ArrayOps$ofByte$() {
  if ((!$n_scm_ArrayOps$ofByte$)) {
    $n_scm_ArrayOps$ofByte$ = new $c_scm_ArrayOps$ofByte$().init___()
  };
  return $n_scm_ArrayOps$ofByte$
}
/** @constructor */
function $c_scm_ArrayOps$ofChar$() {
  $c_O.call(this)
}
$c_scm_ArrayOps$ofChar$.prototype = new $h_O();
$c_scm_ArrayOps$ofChar$.prototype.constructor = $c_scm_ArrayOps$ofChar$;
/** @constructor */
function $h_scm_ArrayOps$ofChar$() {
  /*<skip>*/
}
$h_scm_ArrayOps$ofChar$.prototype = $c_scm_ArrayOps$ofChar$.prototype;
$c_scm_ArrayOps$ofChar$.prototype.init___ = (function() {
  return this
});
$c_scm_ArrayOps$ofChar$.prototype.equals$extension__AC__O__Z = (function($$this, x$1) {
  if ((x$1 instanceof $c_scm_ArrayOps$ofChar)) {
    var ofChar$1 = ((x$1 === null) ? null : $as_scm_ArrayOps$ofChar(x$1).repr$1);
    return ($$this === ofChar$1)
  } else {
    return false
  }
});
var $d_scm_ArrayOps$ofChar$ = new $TypeData().initClass({
  scm_ArrayOps$ofChar$: 0
}, false, "scala.collection.mutable.ArrayOps$ofChar$", {
  scm_ArrayOps$ofChar$: 1,
  O: 1
});
$c_scm_ArrayOps$ofChar$.prototype.$classData = $d_scm_ArrayOps$ofChar$;
var $n_scm_ArrayOps$ofChar$ = (void 0);
function $m_scm_ArrayOps$ofChar$() {
  if ((!$n_scm_ArrayOps$ofChar$)) {
    $n_scm_ArrayOps$ofChar$ = new $c_scm_ArrayOps$ofChar$().init___()
  };
  return $n_scm_ArrayOps$ofChar$
}
/** @constructor */
function $c_scm_ArrayOps$ofDouble$() {
  $c_O.call(this)
}
$c_scm_ArrayOps$ofDouble$.prototype = new $h_O();
$c_scm_ArrayOps$ofDouble$.prototype.constructor = $c_scm_ArrayOps$ofDouble$;
/** @constructor */
function $h_scm_ArrayOps$ofDouble$() {
  /*<skip>*/
}
$h_scm_ArrayOps$ofDouble$.prototype = $c_scm_ArrayOps$ofDouble$.prototype;
$c_scm_ArrayOps$ofDouble$.prototype.init___ = (function() {
  return this
});
$c_scm_ArrayOps$ofDouble$.prototype.equals$extension__AD__O__Z = (function($$this, x$1) {
  if ((x$1 instanceof $c_scm_ArrayOps$ofDouble)) {
    var ofDouble$1 = ((x$1 === null) ? null : $as_scm_ArrayOps$ofDouble(x$1).repr$1);
    return ($$this === ofDouble$1)
  } else {
    return false
  }
});
var $d_scm_ArrayOps$ofDouble$ = new $TypeData().initClass({
  scm_ArrayOps$ofDouble$: 0
}, false, "scala.collection.mutable.ArrayOps$ofDouble$", {
  scm_ArrayOps$ofDouble$: 1,
  O: 1
});
$c_scm_ArrayOps$ofDouble$.prototype.$classData = $d_scm_ArrayOps$ofDouble$;
var $n_scm_ArrayOps$ofDouble$ = (void 0);
function $m_scm_ArrayOps$ofDouble$() {
  if ((!$n_scm_ArrayOps$ofDouble$)) {
    $n_scm_ArrayOps$ofDouble$ = new $c_scm_ArrayOps$ofDouble$().init___()
  };
  return $n_scm_ArrayOps$ofDouble$
}
/** @constructor */
function $c_scm_ArrayOps$ofFloat$() {
  $c_O.call(this)
}
$c_scm_ArrayOps$ofFloat$.prototype = new $h_O();
$c_scm_ArrayOps$ofFloat$.prototype.constructor = $c_scm_ArrayOps$ofFloat$;
/** @constructor */
function $h_scm_ArrayOps$ofFloat$() {
  /*<skip>*/
}
$h_scm_ArrayOps$ofFloat$.prototype = $c_scm_ArrayOps$ofFloat$.prototype;
$c_scm_ArrayOps$ofFloat$.prototype.init___ = (function() {
  return this
});
$c_scm_ArrayOps$ofFloat$.prototype.equals$extension__AF__O__Z = (function($$this, x$1) {
  if ((x$1 instanceof $c_scm_ArrayOps$ofFloat)) {
    var ofFloat$1 = ((x$1 === null) ? null : $as_scm_ArrayOps$ofFloat(x$1).repr$1);
    return ($$this === ofFloat$1)
  } else {
    return false
  }
});
var $d_scm_ArrayOps$ofFloat$ = new $TypeData().initClass({
  scm_ArrayOps$ofFloat$: 0
}, false, "scala.collection.mutable.ArrayOps$ofFloat$", {
  scm_ArrayOps$ofFloat$: 1,
  O: 1
});
$c_scm_ArrayOps$ofFloat$.prototype.$classData = $d_scm_ArrayOps$ofFloat$;
var $n_scm_ArrayOps$ofFloat$ = (void 0);
function $m_scm_ArrayOps$ofFloat$() {
  if ((!$n_scm_ArrayOps$ofFloat$)) {
    $n_scm_ArrayOps$ofFloat$ = new $c_scm_ArrayOps$ofFloat$().init___()
  };
  return $n_scm_ArrayOps$ofFloat$
}
/** @constructor */
function $c_scm_ArrayOps$ofInt$() {
  $c_O.call(this)
}
$c_scm_ArrayOps$ofInt$.prototype = new $h_O();
$c_scm_ArrayOps$ofInt$.prototype.constructor = $c_scm_ArrayOps$ofInt$;
/** @constructor */
function $h_scm_ArrayOps$ofInt$() {
  /*<skip>*/
}
$h_scm_ArrayOps$ofInt$.prototype = $c_scm_ArrayOps$ofInt$.prototype;
$c_scm_ArrayOps$ofInt$.prototype.init___ = (function() {
  return this
});
$c_scm_ArrayOps$ofInt$.prototype.equals$extension__AI__O__Z = (function($$this, x$1) {
  if ((x$1 instanceof $c_scm_ArrayOps$ofInt)) {
    var ofInt$1 = ((x$1 === null) ? null : $as_scm_ArrayOps$ofInt(x$1).repr$1);
    return ($$this === ofInt$1)
  } else {
    return false
  }
});
var $d_scm_ArrayOps$ofInt$ = new $TypeData().initClass({
  scm_ArrayOps$ofInt$: 0
}, false, "scala.collection.mutable.ArrayOps$ofInt$", {
  scm_ArrayOps$ofInt$: 1,
  O: 1
});
$c_scm_ArrayOps$ofInt$.prototype.$classData = $d_scm_ArrayOps$ofInt$;
var $n_scm_ArrayOps$ofInt$ = (void 0);
function $m_scm_ArrayOps$ofInt$() {
  if ((!$n_scm_ArrayOps$ofInt$)) {
    $n_scm_ArrayOps$ofInt$ = new $c_scm_ArrayOps$ofInt$().init___()
  };
  return $n_scm_ArrayOps$ofInt$
}
/** @constructor */
function $c_scm_ArrayOps$ofLong$() {
  $c_O.call(this)
}
$c_scm_ArrayOps$ofLong$.prototype = new $h_O();
$c_scm_ArrayOps$ofLong$.prototype.constructor = $c_scm_ArrayOps$ofLong$;
/** @constructor */
function $h_scm_ArrayOps$ofLong$() {
  /*<skip>*/
}
$h_scm_ArrayOps$ofLong$.prototype = $c_scm_ArrayOps$ofLong$.prototype;
$c_scm_ArrayOps$ofLong$.prototype.init___ = (function() {
  return this
});
$c_scm_ArrayOps$ofLong$.prototype.equals$extension__AJ__O__Z = (function($$this, x$1) {
  if ((x$1 instanceof $c_scm_ArrayOps$ofLong)) {
    var ofLong$1 = ((x$1 === null) ? null : $as_scm_ArrayOps$ofLong(x$1).repr$1);
    return ($$this === ofLong$1)
  } else {
    return false
  }
});
var $d_scm_ArrayOps$ofLong$ = new $TypeData().initClass({
  scm_ArrayOps$ofLong$: 0
}, false, "scala.collection.mutable.ArrayOps$ofLong$", {
  scm_ArrayOps$ofLong$: 1,
  O: 1
});
$c_scm_ArrayOps$ofLong$.prototype.$classData = $d_scm_ArrayOps$ofLong$;
var $n_scm_ArrayOps$ofLong$ = (void 0);
function $m_scm_ArrayOps$ofLong$() {
  if ((!$n_scm_ArrayOps$ofLong$)) {
    $n_scm_ArrayOps$ofLong$ = new $c_scm_ArrayOps$ofLong$().init___()
  };
  return $n_scm_ArrayOps$ofLong$
}
/** @constructor */
function $c_scm_ArrayOps$ofRef$() {
  $c_O.call(this)
}
$c_scm_ArrayOps$ofRef$.prototype = new $h_O();
$c_scm_ArrayOps$ofRef$.prototype.constructor = $c_scm_ArrayOps$ofRef$;
/** @constructor */
function $h_scm_ArrayOps$ofRef$() {
  /*<skip>*/
}
$h_scm_ArrayOps$ofRef$.prototype = $c_scm_ArrayOps$ofRef$.prototype;
$c_scm_ArrayOps$ofRef$.prototype.init___ = (function() {
  return this
});
$c_scm_ArrayOps$ofRef$.prototype.equals$extension__AO__O__Z = (function($$this, x$1) {
  if ((x$1 instanceof $c_scm_ArrayOps$ofRef)) {
    var ofRef$1 = ((x$1 === null) ? null : $as_scm_ArrayOps$ofRef(x$1).repr$1);
    return ($$this === ofRef$1)
  } else {
    return false
  }
});
var $d_scm_ArrayOps$ofRef$ = new $TypeData().initClass({
  scm_ArrayOps$ofRef$: 0
}, false, "scala.collection.mutable.ArrayOps$ofRef$", {
  scm_ArrayOps$ofRef$: 1,
  O: 1
});
$c_scm_ArrayOps$ofRef$.prototype.$classData = $d_scm_ArrayOps$ofRef$;
var $n_scm_ArrayOps$ofRef$ = (void 0);
function $m_scm_ArrayOps$ofRef$() {
  if ((!$n_scm_ArrayOps$ofRef$)) {
    $n_scm_ArrayOps$ofRef$ = new $c_scm_ArrayOps$ofRef$().init___()
  };
  return $n_scm_ArrayOps$ofRef$
}
/** @constructor */
function $c_scm_ArrayOps$ofShort$() {
  $c_O.call(this)
}
$c_scm_ArrayOps$ofShort$.prototype = new $h_O();
$c_scm_ArrayOps$ofShort$.prototype.constructor = $c_scm_ArrayOps$ofShort$;
/** @constructor */
function $h_scm_ArrayOps$ofShort$() {
  /*<skip>*/
}
$h_scm_ArrayOps$ofShort$.prototype = $c_scm_ArrayOps$ofShort$.prototype;
$c_scm_ArrayOps$ofShort$.prototype.init___ = (function() {
  return this
});
$c_scm_ArrayOps$ofShort$.prototype.equals$extension__AS__O__Z = (function($$this, x$1) {
  if ((x$1 instanceof $c_scm_ArrayOps$ofShort)) {
    var ofShort$1 = ((x$1 === null) ? null : $as_scm_ArrayOps$ofShort(x$1).repr$1);
    return ($$this === ofShort$1)
  } else {
    return false
  }
});
var $d_scm_ArrayOps$ofShort$ = new $TypeData().initClass({
  scm_ArrayOps$ofShort$: 0
}, false, "scala.collection.mutable.ArrayOps$ofShort$", {
  scm_ArrayOps$ofShort$: 1,
  O: 1
});
$c_scm_ArrayOps$ofShort$.prototype.$classData = $d_scm_ArrayOps$ofShort$;
var $n_scm_ArrayOps$ofShort$ = (void 0);
function $m_scm_ArrayOps$ofShort$() {
  if ((!$n_scm_ArrayOps$ofShort$)) {
    $n_scm_ArrayOps$ofShort$ = new $c_scm_ArrayOps$ofShort$().init___()
  };
  return $n_scm_ArrayOps$ofShort$
}
/** @constructor */
function $c_scm_ArrayOps$ofUnit$() {
  $c_O.call(this)
}
$c_scm_ArrayOps$ofUnit$.prototype = new $h_O();
$c_scm_ArrayOps$ofUnit$.prototype.constructor = $c_scm_ArrayOps$ofUnit$;
/** @constructor */
function $h_scm_ArrayOps$ofUnit$() {
  /*<skip>*/
}
$h_scm_ArrayOps$ofUnit$.prototype = $c_scm_ArrayOps$ofUnit$.prototype;
$c_scm_ArrayOps$ofUnit$.prototype.init___ = (function() {
  return this
});
$c_scm_ArrayOps$ofUnit$.prototype.equals$extension__Asr_BoxedUnit__O__Z = (function($$this, x$1) {
  if ((x$1 instanceof $c_scm_ArrayOps$ofUnit)) {
    var ofUnit$1 = ((x$1 === null) ? null : $as_scm_ArrayOps$ofUnit(x$1).repr$1);
    return ($$this === ofUnit$1)
  } else {
    return false
  }
});
var $d_scm_ArrayOps$ofUnit$ = new $TypeData().initClass({
  scm_ArrayOps$ofUnit$: 0
}, false, "scala.collection.mutable.ArrayOps$ofUnit$", {
  scm_ArrayOps$ofUnit$: 1,
  O: 1
});
$c_scm_ArrayOps$ofUnit$.prototype.$classData = $d_scm_ArrayOps$ofUnit$;
var $n_scm_ArrayOps$ofUnit$ = (void 0);
function $m_scm_ArrayOps$ofUnit$() {
  if ((!$n_scm_ArrayOps$ofUnit$)) {
    $n_scm_ArrayOps$ofUnit$ = new $c_scm_ArrayOps$ofUnit$().init___()
  };
  return $n_scm_ArrayOps$ofUnit$
}
function $f_scm_FlatHashTable__calcSizeMapSize__I__I($thiz, tableLength) {
  return ((1 + (tableLength >> 5)) | 0)
}
function $f_scm_FlatHashTable__tableSizeSeed__I($thiz) {
  return $m_jl_Integer$().bitCount__I__I((((-1) + $thiz.table$5.u.length) | 0))
}
function $f_scm_FlatHashTable__addElem__O__Z($thiz, elem) {
  var newEntry = $f_scm_FlatHashTable$HashUtils__elemToEntry__O__O($thiz, elem);
  return $f_scm_FlatHashTable__addEntry__O__Z($thiz, newEntry)
}
function $f_scm_FlatHashTable__precedes$1__pscm_FlatHashTable__I__I__Z($thiz, i, j) {
  var d = ($thiz.table$5.u.length >> 1);
  return ((i <= j) ? (((j - i) | 0) < d) : (((i - j) | 0) > d))
}
function $f_scm_FlatHashTable__addEntry__O__Z($thiz, newEntry) {
  var hcode = $objectHashCode(newEntry);
  var h = $f_scm_FlatHashTable__index__I__I($thiz, hcode);
  var curEntry = $thiz.table$5.get(h);
  while ((curEntry !== null)) {
    if ($m_sr_BoxesRunTime$().equals__O__O__Z(curEntry, newEntry)) {
      return false
    };
    h = ((((1 + h) | 0) % $thiz.table$5.u.length) | 0);
    curEntry = $thiz.table$5.get(h)
  };
  $thiz.table$5.set(h, newEntry);
  $thiz.tableSize$5 = ((1 + $thiz.tableSize$5) | 0);
  var h$1 = h;
  $f_scm_FlatHashTable__nnSizeMapAdd__I__V($thiz, h$1);
  if (($thiz.tableSize$5 >= $thiz.threshold$5)) {
    $f_scm_FlatHashTable__growTable__pscm_FlatHashTable__V($thiz)
  };
  return true
}
function $f_scm_FlatHashTable__index__I__I($thiz, hcode) {
  var seed = $thiz.seedvalue$5;
  var improved = $f_scm_FlatHashTable$HashUtils__improve__I__I__I($thiz, hcode, seed);
  var ones = (((-1) + $thiz.table$5.u.length) | 0);
  return (((improved >>> ((32 - $m_jl_Integer$().bitCount__I__I(ones)) | 0)) | 0) & ones)
}
function $f_scm_FlatHashTable__initWithContents__scm_FlatHashTable$Contents__V($thiz, c) {
  if ((c !== null)) {
    $thiz.$$undloadFactor$5 = c.loadFactor__I();
    $thiz.table$5 = c.table__AO();
    $thiz.tableSize$5 = c.tableSize__I();
    $thiz.threshold$5 = c.threshold__I();
    $thiz.seedvalue$5 = c.seedvalue__I();
    $thiz.sizemap$5 = c.sizemap__AI()
  }
}
function $f_scm_FlatHashTable__removeElem__O__Z($thiz, elem) {
  var removalEntry = $f_scm_FlatHashTable$HashUtils__elemToEntry__O__O($thiz, elem);
  var hcode = $objectHashCode(removalEntry);
  var h = $f_scm_FlatHashTable__index__I__I($thiz, hcode);
  var curEntry = $thiz.table$5.get(h);
  while ((curEntry !== null)) {
    if ($m_sr_BoxesRunTime$().equals__O__O__Z(curEntry, removalEntry)) {
      var h0 = h;
      var h1 = ((((1 + h0) | 0) % $thiz.table$5.u.length) | 0);
      while (($thiz.table$5.get(h1) !== null)) {
        var hcode$1 = $objectHashCode($thiz.table$5.get(h1));
        var h2 = $f_scm_FlatHashTable__index__I__I($thiz, hcode$1);
        if ((h2 !== h1)) {
          var j = h0;
          var jsx$1 = $f_scm_FlatHashTable__precedes$1__pscm_FlatHashTable__I__I__Z($thiz, h2, j)
        } else {
          var jsx$1 = false
        };
        if (jsx$1) {
          $thiz.table$5.set(h0, $thiz.table$5.get(h1));
          h0 = h1
        };
        h1 = ((((1 + h1) | 0) % $thiz.table$5.u.length) | 0)
      };
      $thiz.table$5.set(h0, null);
      $thiz.tableSize$5 = (((-1) + $thiz.tableSize$5) | 0);
      var h$1 = h0;
      $f_scm_FlatHashTable__nnSizeMapRemove__I__V($thiz, h$1);
      return true
    };
    h = ((((1 + h) | 0) % $thiz.table$5.u.length) | 0);
    curEntry = $thiz.table$5.get(h)
  };
  return false
}
function $f_scm_FlatHashTable__$$init$__V($thiz) {
  $thiz.$$undloadFactor$5 = 450;
  $thiz.table$5 = $newArrayObject($d_O.getArrayOf(), [$m_scm_HashTable$().nextPositivePowerOfTwo__I__I(32)]);
  $thiz.tableSize$5 = 0;
  $thiz.threshold$5 = $m_scm_FlatHashTable$().newThreshold__I__I__I($thiz.$$undloadFactor$5, $m_scm_HashTable$().nextPositivePowerOfTwo__I__I(32));
  $thiz.sizemap$5 = null;
  $thiz.seedvalue$5 = $f_scm_FlatHashTable__tableSizeSeed__I($thiz)
}
function $f_scm_FlatHashTable__findElemImpl__pscm_FlatHashTable__O__O($thiz, elem) {
  var searchEntry = $f_scm_FlatHashTable$HashUtils__elemToEntry__O__O($thiz, elem);
  var hcode = $objectHashCode(searchEntry);
  var h = $f_scm_FlatHashTable__index__I__I($thiz, hcode);
  var curEntry = $thiz.table$5.get(h);
  while (((curEntry !== null) && (!$m_sr_BoxesRunTime$().equals__O__O__Z(curEntry, searchEntry)))) {
    h = ((((1 + h) | 0) % $thiz.table$5.u.length) | 0);
    curEntry = $thiz.table$5.get(h)
  };
  return curEntry
}
function $f_scm_FlatHashTable__containsElem__O__Z($thiz, elem) {
  return ($f_scm_FlatHashTable__findElemImpl__pscm_FlatHashTable__O__O($thiz, elem) !== null)
}
function $f_scm_FlatHashTable__nnSizeMapRemove__I__V($thiz, h) {
  if (($thiz.sizemap$5 !== null)) {
    var ev$1 = $thiz.sizemap$5;
    var ev$2 = (h >> 5);
    ev$1.set(ev$2, (((-1) + ev$1.get(ev$2)) | 0))
  }
}
function $f_scm_FlatHashTable__nnSizeMapReset__I__V($thiz, tableLength) {
  if (($thiz.sizemap$5 !== null)) {
    var nsize = $f_scm_FlatHashTable__calcSizeMapSize__I__I($thiz, tableLength);
    if (($thiz.sizemap$5.u.length !== nsize)) {
      $thiz.sizemap$5 = $newArrayObject($d_I.getArrayOf(), [nsize])
    } else {
      $m_ju_Arrays$().fill__AI__I__V($thiz.sizemap$5, 0)
    }
  }
}
function $f_scm_FlatHashTable__nnSizeMapAdd__I__V($thiz, h) {
  if (($thiz.sizemap$5 !== null)) {
    var p = (h >> 5);
    var ev$1 = $thiz.sizemap$5;
    ev$1.set(p, ((1 + ev$1.get(p)) | 0))
  }
}
function $f_scm_FlatHashTable__growTable__pscm_FlatHashTable__V($thiz) {
  var oldtable = $thiz.table$5;
  $thiz.table$5 = $newArrayObject($d_O.getArrayOf(), [($thiz.table$5.u.length << 1)]);
  $thiz.tableSize$5 = 0;
  var tableLength = $thiz.table$5.u.length;
  $f_scm_FlatHashTable__nnSizeMapReset__I__V($thiz, tableLength);
  $thiz.seedvalue$5 = $f_scm_FlatHashTable__tableSizeSeed__I($thiz);
  $thiz.threshold$5 = $m_scm_FlatHashTable$().newThreshold__I__I__I($thiz.$$undloadFactor$5, $thiz.table$5.u.length);
  var i = 0;
  while ((i < oldtable.u.length)) {
    var entry = oldtable.get(i);
    if ((entry !== null)) {
      $f_scm_FlatHashTable__addEntry__O__Z($thiz, entry)
    };
    i = ((1 + i) | 0)
  }
}
/** @constructor */
function $c_scm_FlatHashTable$() {
  $c_O.call(this)
}
$c_scm_FlatHashTable$.prototype = new $h_O();
$c_scm_FlatHashTable$.prototype.constructor = $c_scm_FlatHashTable$;
/** @constructor */
function $h_scm_FlatHashTable$() {
  /*<skip>*/
}
$h_scm_FlatHashTable$.prototype = $c_scm_FlatHashTable$.prototype;
$c_scm_FlatHashTable$.prototype.init___ = (function() {
  return this
});
$c_scm_FlatHashTable$.prototype.newThreshold__I__I__I = (function(_loadFactor, size) {
  var assertion = (_loadFactor < 500);
  if ((!assertion)) {
    throw new $c_jl_AssertionError().init___O("assertion failed: loadFactor too large; must be < 0.5")
  };
  var hi = (size >> 31);
  var hi$1 = (_loadFactor >> 31);
  var a0 = (65535 & size);
  var a1 = ((size >>> 16) | 0);
  var b0 = (65535 & _loadFactor);
  var b1 = ((_loadFactor >>> 16) | 0);
  var a0b0 = $imul(a0, b0);
  var a1b0 = $imul(a1, b0);
  var a0b1 = $imul(a0, b1);
  var lo = ((a0b0 + (((a1b0 + a0b1) | 0) << 16)) | 0);
  var c1part = ((((a0b0 >>> 16) | 0) + a0b1) | 0);
  var hi$2 = (((((((($imul(size, hi$1) + $imul(hi, _loadFactor)) | 0) + $imul(a1, b1)) | 0) + ((c1part >>> 16) | 0)) | 0) + (((((65535 & c1part) + a1b0) | 0) >>> 16) | 0)) | 0);
  var this$2 = $m_sjsr_RuntimeLong$();
  var lo$1 = this$2.divideImpl__I__I__I__I__I(lo, hi$2, 1000, 0);
  return lo$1
});
var $d_scm_FlatHashTable$ = new $TypeData().initClass({
  scm_FlatHashTable$: 0
}, false, "scala.collection.mutable.FlatHashTable$", {
  scm_FlatHashTable$: 1,
  O: 1
});
$c_scm_FlatHashTable$.prototype.$classData = $d_scm_FlatHashTable$;
var $n_scm_FlatHashTable$ = (void 0);
function $m_scm_FlatHashTable$() {
  if ((!$n_scm_FlatHashTable$)) {
    $n_scm_FlatHashTable$ = new $c_scm_FlatHashTable$().init___()
  };
  return $n_scm_FlatHashTable$
}
/** @constructor */
function $c_scm_FlatHashTable$NullSentinel$() {
  $c_O.call(this)
}
$c_scm_FlatHashTable$NullSentinel$.prototype = new $h_O();
$c_scm_FlatHashTable$NullSentinel$.prototype.constructor = $c_scm_FlatHashTable$NullSentinel$;
/** @constructor */
function $h_scm_FlatHashTable$NullSentinel$() {
  /*<skip>*/
}
$h_scm_FlatHashTable$NullSentinel$.prototype = $c_scm_FlatHashTable$NullSentinel$.prototype;
$c_scm_FlatHashTable$NullSentinel$.prototype.init___ = (function() {
  return this
});
$c_scm_FlatHashTable$NullSentinel$.prototype.toString__T = (function() {
  return "NullSentinel"
});
$c_scm_FlatHashTable$NullSentinel$.prototype.hashCode__I = (function() {
  return 0
});
var $d_scm_FlatHashTable$NullSentinel$ = new $TypeData().initClass({
  scm_FlatHashTable$NullSentinel$: 0
}, false, "scala.collection.mutable.FlatHashTable$NullSentinel$", {
  scm_FlatHashTable$NullSentinel$: 1,
  O: 1
});
$c_scm_FlatHashTable$NullSentinel$.prototype.$classData = $d_scm_FlatHashTable$NullSentinel$;
var $n_scm_FlatHashTable$NullSentinel$ = (void 0);
function $m_scm_FlatHashTable$NullSentinel$() {
  if ((!$n_scm_FlatHashTable$NullSentinel$)) {
    $n_scm_FlatHashTable$NullSentinel$ = new $c_scm_FlatHashTable$NullSentinel$().init___()
  };
  return $n_scm_FlatHashTable$NullSentinel$
}
function $f_scm_HashTable__calcSizeMapSize__I__I($thiz, tableLength) {
  return ((1 + (tableLength >> 5)) | 0)
}
function $f_scm_HashTable__tableSizeSeed__I($thiz) {
  return $m_jl_Integer$().bitCount__I__I((((-1) + $thiz.table__Ascm_HashEntry().u.length) | 0))
}
function $f_scm_HashTable__clearTable__V($thiz) {
  var i = (((-1) + $thiz.table__Ascm_HashEntry().u.length) | 0);
  while ((i >= 0)) {
    $thiz.table__Ascm_HashEntry().set(i, null);
    i = (((-1) + i) | 0)
  };
  $thiz.tableSize$und$eq__I__V(0);
  $f_scm_HashTable__nnSizeMapReset__I__V($thiz, 0)
}
function $f_scm_HashTable__findEntry0__pscm_HashTable__O__I__scm_HashEntry($thiz, key, h) {
  var e = $thiz.table__Ascm_HashEntry().get(h);
  while (true) {
    if ((e !== null)) {
      var key1 = e.key__O();
      var jsx$1 = (!$m_sr_BoxesRunTime$().equals__O__O__Z(key1, key))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      e = $as_scm_HashEntry(e.next__O())
    } else {
      break
    }
  };
  return e
}
function $f_scm_HashTable__addEntry__scm_HashEntry__V($thiz, e) {
  var key = e.key__O();
  var hcode = $m_sr_Statics$().anyHash__O__I(key);
  var h = $f_scm_HashTable__index__I__I($thiz, hcode);
  $f_scm_HashTable__addEntry0__pscm_HashTable__scm_HashEntry__I__V($thiz, e, h)
}
function $f_scm_HashTable__initWithContents__scm_HashTable$Contents__V($thiz, c) {
  if ((c !== null)) {
    $thiz.$$undloadFactor$und$eq__I__V(c.loadFactor__I());
    $thiz.table$und$eq__Ascm_HashEntry__V(c.table__Ascm_HashEntry());
    $thiz.tableSize$und$eq__I__V(c.tableSize__I());
    $thiz.threshold$und$eq__I__V(c.threshold__I());
    $thiz.seedvalue$und$eq__I__V(c.seedvalue__I());
    $thiz.sizemap$und$eq__AI__V(c.sizemap__AI())
  }
}
function $f_scm_HashTable__index__I__I($thiz, hcode) {
  var ones = (((-1) + $thiz.table__Ascm_HashEntry().u.length) | 0);
  var exponent = $clz32(ones);
  var seed = $thiz.seedvalue__I();
  return ((($f_scm_HashTable$HashUtils__improve__I__I__I($thiz, hcode, seed) >>> exponent) | 0) & ones)
}
function $f_scm_HashTable__$$init$__V($thiz) {
  $thiz.$$undloadFactor$und$eq__I__V(750);
  var this$1 = $m_scm_HashTable$();
  var expectedSize = $thiz.initialSize__I();
  $thiz.table$und$eq__Ascm_HashEntry__V($newArrayObject($d_scm_HashEntry.getArrayOf(), [this$1.nextPositivePowerOfTwo__I__I(expectedSize)]));
  $thiz.tableSize$und$eq__I__V(0);
  var _loadFactor = $thiz.$$undloadFactor__I();
  var jsx$1 = $m_scm_HashTable$();
  var this$2 = $m_scm_HashTable$();
  var expectedSize$1 = $thiz.initialSize__I();
  $thiz.threshold$und$eq__I__V(jsx$1.newThreshold__I__I__I(_loadFactor, this$2.nextPositivePowerOfTwo__I__I(expectedSize$1)));
  $thiz.sizemap$und$eq__AI__V(null);
  $thiz.seedvalue$und$eq__I__V($f_scm_HashTable__tableSizeSeed__I($thiz))
}
function $f_scm_HashTable__removeEntry__O__scm_HashEntry($thiz, key) {
  var hcode = $m_sr_Statics$().anyHash__O__I(key);
  var h = $f_scm_HashTable__index__I__I($thiz, hcode);
  var e = $thiz.table__Ascm_HashEntry().get(h);
  if ((e !== null)) {
    var key1 = e.key__O();
    if ($m_sr_BoxesRunTime$().equals__O__O__Z(key1, key)) {
      $thiz.table__Ascm_HashEntry().set(h, $as_scm_HashEntry(e.next__O()));
      $thiz.tableSize$und$eq__I__V((((-1) + $thiz.tableSize__I()) | 0));
      $f_scm_HashTable__nnSizeMapRemove__I__V($thiz, h);
      e.next$und$eq__O__V(null);
      return e
    } else {
      var e1 = $as_scm_HashEntry(e.next__O());
      while (true) {
        if ((e1 !== null)) {
          var key1$1 = e1.key__O();
          var jsx$1 = (!$m_sr_BoxesRunTime$().equals__O__O__Z(key1$1, key))
        } else {
          var jsx$1 = false
        };
        if (jsx$1) {
          e = e1;
          e1 = $as_scm_HashEntry(e1.next__O())
        } else {
          break
        }
      };
      if ((e1 !== null)) {
        e.next$und$eq__O__V(e1.next__O());
        $thiz.tableSize$und$eq__I__V((((-1) + $thiz.tableSize__I()) | 0));
        $f_scm_HashTable__nnSizeMapRemove__I__V($thiz, h);
        e1.next$und$eq__O__V(null);
        return e1
      }
    }
  };
  return null
}
function $f_scm_HashTable__scala$collection$mutable$HashTable$$lastPopulatedIndex__I($thiz) {
  var idx = (((-1) + $thiz.table__Ascm_HashEntry().u.length) | 0);
  while ((($thiz.table__Ascm_HashEntry().get(idx) === null) && (idx > 0))) {
    idx = (((-1) + idx) | 0)
  };
  return idx
}
function $f_scm_HashTable__findOrAddEntry__O__O__scm_HashEntry($thiz, key, value) {
  var hcode = $m_sr_Statics$().anyHash__O__I(key);
  var h = $f_scm_HashTable__index__I__I($thiz, hcode);
  var e = $f_scm_HashTable__findEntry0__pscm_HashTable__O__I__scm_HashEntry($thiz, key, h);
  if ((e !== null)) {
    return e
  } else {
    var e$1 = $thiz.createNewEntry__O__O__scm_HashEntry(key, value);
    $f_scm_HashTable__addEntry0__pscm_HashTable__scm_HashEntry__I__V($thiz, e$1, h);
    return null
  }
}
function $f_scm_HashTable__findEntry__O__scm_HashEntry($thiz, key) {
  var hcode = $m_sr_Statics$().anyHash__O__I(key);
  var h = $f_scm_HashTable__index__I__I($thiz, hcode);
  return $f_scm_HashTable__findEntry0__pscm_HashTable__O__I__scm_HashEntry($thiz, key, h)
}
function $f_scm_HashTable__addEntry0__pscm_HashTable__scm_HashEntry__I__V($thiz, e, h) {
  e.next$und$eq__O__V($thiz.table__Ascm_HashEntry().get(h));
  $thiz.table__Ascm_HashEntry().set(h, e);
  $thiz.tableSize$und$eq__I__V(((1 + $thiz.tableSize__I()) | 0));
  $f_scm_HashTable__nnSizeMapAdd__I__V($thiz, h);
  if (($thiz.tableSize__I() > $thiz.threshold__I())) {
    var newSize = ($thiz.table__Ascm_HashEntry().u.length << 1);
    $f_scm_HashTable__resize__pscm_HashTable__I__V($thiz, newSize)
  }
}
function $f_scm_HashTable__nnSizeMapRemove__I__V($thiz, h) {
  if (($thiz.sizemap__AI() !== null)) {
    var ev$1 = $thiz.sizemap__AI();
    var ev$2 = (h >> 5);
    ev$1.set(ev$2, (((-1) + ev$1.get(ev$2)) | 0))
  }
}
function $f_scm_HashTable__nnSizeMapReset__I__V($thiz, tableLength) {
  if (($thiz.sizemap__AI() !== null)) {
    var nsize = $f_scm_HashTable__calcSizeMapSize__I__I($thiz, tableLength);
    if (($thiz.sizemap__AI().u.length !== nsize)) {
      $thiz.sizemap$und$eq__AI__V($newArrayObject($d_I.getArrayOf(), [nsize]))
    } else {
      $m_ju_Arrays$().fill__AI__I__V($thiz.sizemap__AI(), 0)
    }
  }
}
function $f_scm_HashTable__nnSizeMapAdd__I__V($thiz, h) {
  if (($thiz.sizemap__AI() !== null)) {
    var ev$1 = $thiz.sizemap__AI();
    var ev$2 = (h >> 5);
    ev$1.set(ev$2, ((1 + ev$1.get(ev$2)) | 0))
  }
}
function $f_scm_HashTable__resize__pscm_HashTable__I__V($thiz, newSize) {
  var oldTable = $thiz.table__Ascm_HashEntry();
  $thiz.table$und$eq__Ascm_HashEntry__V($newArrayObject($d_scm_HashEntry.getArrayOf(), [newSize]));
  var tableLength = $thiz.table__Ascm_HashEntry().u.length;
  $f_scm_HashTable__nnSizeMapReset__I__V($thiz, tableLength);
  var i = (((-1) + oldTable.u.length) | 0);
  while ((i >= 0)) {
    var e = oldTable.get(i);
    while ((e !== null)) {
      var key = e.key__O();
      var hcode = $m_sr_Statics$().anyHash__O__I(key);
      var h = $f_scm_HashTable__index__I__I($thiz, hcode);
      var e1 = $as_scm_HashEntry(e.next__O());
      e.next$und$eq__O__V($thiz.table__Ascm_HashEntry().get(h));
      $thiz.table__Ascm_HashEntry().set(h, e);
      e = e1;
      $f_scm_HashTable__nnSizeMapAdd__I__V($thiz, h)
    };
    i = (((-1) + i) | 0)
  };
  $thiz.threshold$und$eq__I__V($m_scm_HashTable$().newThreshold__I__I__I($thiz.$$undloadFactor__I(), newSize))
}
/** @constructor */
function $c_scm_HashTable$() {
  $c_O.call(this)
}
$c_scm_HashTable$.prototype = new $h_O();
$c_scm_HashTable$.prototype.constructor = $c_scm_HashTable$;
/** @constructor */
function $h_scm_HashTable$() {
  /*<skip>*/
}
$h_scm_HashTable$.prototype = $c_scm_HashTable$.prototype;
$c_scm_HashTable$.prototype.init___ = (function() {
  return this
});
$c_scm_HashTable$.prototype.nextPositivePowerOfTwo__I__I = (function(target) {
  return (1 << ((-$clz32((((-1) + target) | 0))) | 0))
});
$c_scm_HashTable$.prototype.newThreshold__I__I__I = (function(_loadFactor, size) {
  var hi = (size >> 31);
  var hi$1 = (_loadFactor >> 31);
  var a0 = (65535 & size);
  var a1 = ((size >>> 16) | 0);
  var b0 = (65535 & _loadFactor);
  var b1 = ((_loadFactor >>> 16) | 0);
  var a0b0 = $imul(a0, b0);
  var a1b0 = $imul(a1, b0);
  var a0b1 = $imul(a0, b1);
  var lo = ((a0b0 + (((a1b0 + a0b1) | 0) << 16)) | 0);
  var c1part = ((((a0b0 >>> 16) | 0) + a0b1) | 0);
  var hi$2 = (((((((($imul(size, hi$1) + $imul(hi, _loadFactor)) | 0) + $imul(a1, b1)) | 0) + ((c1part >>> 16) | 0)) | 0) + (((((65535 & c1part) + a1b0) | 0) >>> 16) | 0)) | 0);
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo$1 = this$1.divideImpl__I__I__I__I__I(lo, hi$2, 1000, 0);
  return lo$1
});
var $d_scm_HashTable$ = new $TypeData().initClass({
  scm_HashTable$: 0
}, false, "scala.collection.mutable.HashTable$", {
  scm_HashTable$: 1,
  O: 1
});
$c_scm_HashTable$.prototype.$classData = $d_scm_HashTable$;
var $n_scm_HashTable$ = (void 0);
function $m_scm_HashTable$() {
  if ((!$n_scm_HashTable$)) {
    $n_scm_HashTable$ = new $c_scm_HashTable$().init___()
  };
  return $n_scm_HashTable$
}
/** @constructor */
function $c_scm_WrappedArray$() {
  $c_O.call(this);
  this.EmptyWrappedArray$1 = null
}
$c_scm_WrappedArray$.prototype = new $h_O();
$c_scm_WrappedArray$.prototype.constructor = $c_scm_WrappedArray$;
/** @constructor */
function $h_scm_WrappedArray$() {
  /*<skip>*/
}
$h_scm_WrappedArray$.prototype = $c_scm_WrappedArray$.prototype;
$c_scm_WrappedArray$.prototype.init___ = (function() {
  $n_scm_WrappedArray$ = this;
  this.EmptyWrappedArray$1 = new $c_scm_WrappedArray$ofRef().init___AO($newArrayObject($d_O.getArrayOf(), [0]));
  return this
});
var $d_scm_WrappedArray$ = new $TypeData().initClass({
  scm_WrappedArray$: 0
}, false, "scala.collection.mutable.WrappedArray$", {
  scm_WrappedArray$: 1,
  O: 1
});
$c_scm_WrappedArray$.prototype.$classData = $d_scm_WrappedArray$;
var $n_scm_WrappedArray$ = (void 0);
function $m_scm_WrappedArray$() {
  if ((!$n_scm_WrappedArray$)) {
    $n_scm_WrappedArray$ = new $c_scm_WrappedArray$().init___()
  };
  return $n_scm_WrappedArray$
}
/** @constructor */
function $c_sjs_concurrent_JSExecutionContext$() {
  $c_O.call(this);
  this.runNow$1 = null;
  this.queue$1 = null
}
$c_sjs_concurrent_JSExecutionContext$.prototype = new $h_O();
$c_sjs_concurrent_JSExecutionContext$.prototype.constructor = $c_sjs_concurrent_JSExecutionContext$;
/** @constructor */
function $h_sjs_concurrent_JSExecutionContext$() {
  /*<skip>*/
}
$h_sjs_concurrent_JSExecutionContext$.prototype = $c_sjs_concurrent_JSExecutionContext$.prototype;
$c_sjs_concurrent_JSExecutionContext$.prototype.init___ = (function() {
  $n_sjs_concurrent_JSExecutionContext$ = this;
  this.runNow$1 = $m_sjs_concurrent_RunNowExecutionContext$();
  this.queue$1 = $m_sjs_concurrent_QueueExecutionContext$().apply__s_concurrent_ExecutionContextExecutor();
  return this
});
var $d_sjs_concurrent_JSExecutionContext$ = new $TypeData().initClass({
  sjs_concurrent_JSExecutionContext$: 0
}, false, "scala.scalajs.concurrent.JSExecutionContext$", {
  sjs_concurrent_JSExecutionContext$: 1,
  O: 1
});
$c_sjs_concurrent_JSExecutionContext$.prototype.$classData = $d_sjs_concurrent_JSExecutionContext$;
var $n_sjs_concurrent_JSExecutionContext$ = (void 0);
function $m_sjs_concurrent_JSExecutionContext$() {
  if ((!$n_sjs_concurrent_JSExecutionContext$)) {
    $n_sjs_concurrent_JSExecutionContext$ = new $c_sjs_concurrent_JSExecutionContext$().init___()
  };
  return $n_sjs_concurrent_JSExecutionContext$
}
/** @constructor */
function $c_sjs_concurrent_QueueExecutionContext$() {
  $c_O.call(this)
}
$c_sjs_concurrent_QueueExecutionContext$.prototype = new $h_O();
$c_sjs_concurrent_QueueExecutionContext$.prototype.constructor = $c_sjs_concurrent_QueueExecutionContext$;
/** @constructor */
function $h_sjs_concurrent_QueueExecutionContext$() {
  /*<skip>*/
}
$h_sjs_concurrent_QueueExecutionContext$.prototype = $c_sjs_concurrent_QueueExecutionContext$.prototype;
$c_sjs_concurrent_QueueExecutionContext$.prototype.init___ = (function() {
  return this
});
$c_sjs_concurrent_QueueExecutionContext$.prototype.apply__s_concurrent_ExecutionContextExecutor = (function() {
  var v = $g.Promise;
  if ((v === (void 0))) {
    return new $c_sjs_concurrent_QueueExecutionContext$TimeoutsExecutionContext().init___()
  } else {
    return new $c_sjs_concurrent_QueueExecutionContext$PromisesExecutionContext().init___()
  }
});
var $d_sjs_concurrent_QueueExecutionContext$ = new $TypeData().initClass({
  sjs_concurrent_QueueExecutionContext$: 0
}, false, "scala.scalajs.concurrent.QueueExecutionContext$", {
  sjs_concurrent_QueueExecutionContext$: 1,
  O: 1
});
$c_sjs_concurrent_QueueExecutionContext$.prototype.$classData = $d_sjs_concurrent_QueueExecutionContext$;
var $n_sjs_concurrent_QueueExecutionContext$ = (void 0);
function $m_sjs_concurrent_QueueExecutionContext$() {
  if ((!$n_sjs_concurrent_QueueExecutionContext$)) {
    $n_sjs_concurrent_QueueExecutionContext$ = new $c_sjs_concurrent_QueueExecutionContext$().init___()
  };
  return $n_sjs_concurrent_QueueExecutionContext$
}
/** @constructor */
function $c_sjs_js_JSConverters$JSRichFuture$() {
  $c_O.call(this)
}
$c_sjs_js_JSConverters$JSRichFuture$.prototype = new $h_O();
$c_sjs_js_JSConverters$JSRichFuture$.prototype.constructor = $c_sjs_js_JSConverters$JSRichFuture$;
/** @constructor */
function $h_sjs_js_JSConverters$JSRichFuture$() {
  /*<skip>*/
}
$h_sjs_js_JSConverters$JSRichFuture$.prototype = $c_sjs_js_JSConverters$JSRichFuture$.prototype;
$c_sjs_js_JSConverters$JSRichFuture$.prototype.init___ = (function() {
  return this
});
$c_sjs_js_JSConverters$JSRichFuture$.prototype.scala$scalajs$js$JSConverters$JSRichFuture$$$anonfun$toJSPromise$1__sjs_js_Function1__sjs_js_Function1__s_concurrent_Future__s_concurrent_ExecutionContext__V = (function(resolve, reject, $$this$1, executor$1) {
  $$this$1.onComplete__F1__s_concurrent_ExecutionContext__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, resolve$1, reject$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_s_util_Try(x0$1$2);
      if ((x0$1 instanceof $c_s_util_Success)) {
        var x2 = $as_s_util_Success(x0$1);
        var value = x2.value$2;
        return resolve$1(value)
      } else if ((x0$1 instanceof $c_s_util_Failure)) {
        var x3 = $as_s_util_Failure(x0$1);
        var th = x3.exception$2;
        if ((th instanceof $c_sjs_js_JavaScriptException)) {
          var x2$2 = $as_sjs_js_JavaScriptException(th);
          var e = x2$2.exception$4;
          var jsx$1 = e
        } else {
          var jsx$1 = th
        };
        return reject$1(jsx$1)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, resolve, reject)), executor$1)
});
$c_sjs_js_JSConverters$JSRichFuture$.prototype.toJSPromise$extension__s_concurrent_Future__s_concurrent_ExecutionContext__sjs_js_Promise = (function($$this, executor) {
  return new $g.Promise((function($$this$1, executor$1) {
    return (function(arg1$2, arg2$2) {
      $m_sjs_js_JSConverters$JSRichFuture$().scala$scalajs$js$JSConverters$JSRichFuture$$$anonfun$toJSPromise$1__sjs_js_Function1__sjs_js_Function1__s_concurrent_Future__s_concurrent_ExecutionContext__V(arg1$2, arg2$2, $$this$1, executor$1)
    })
  })($$this, executor))
});
var $d_sjs_js_JSConverters$JSRichFuture$ = new $TypeData().initClass({
  sjs_js_JSConverters$JSRichFuture$: 0
}, false, "scala.scalajs.js.JSConverters$JSRichFuture$", {
  sjs_js_JSConverters$JSRichFuture$: 1,
  O: 1
});
$c_sjs_js_JSConverters$JSRichFuture$.prototype.$classData = $d_sjs_js_JSConverters$JSRichFuture$;
var $n_sjs_js_JSConverters$JSRichFuture$ = (void 0);
function $m_sjs_js_JSConverters$JSRichFuture$() {
  if ((!$n_sjs_js_JSConverters$JSRichFuture$)) {
    $n_sjs_js_JSConverters$JSRichFuture$ = new $c_sjs_js_JSConverters$JSRichFuture$().init___()
  };
  return $n_sjs_js_JSConverters$JSRichFuture$
}
/** @constructor */
function $c_sjs_js_JSConverters$JSRichGenMap$() {
  $c_O.call(this)
}
$c_sjs_js_JSConverters$JSRichGenMap$.prototype = new $h_O();
$c_sjs_js_JSConverters$JSRichGenMap$.prototype.constructor = $c_sjs_js_JSConverters$JSRichGenMap$;
/** @constructor */
function $h_sjs_js_JSConverters$JSRichGenMap$() {
  /*<skip>*/
}
$h_sjs_js_JSConverters$JSRichGenMap$.prototype = $c_sjs_js_JSConverters$JSRichGenMap$.prototype;
$c_sjs_js_JSConverters$JSRichGenMap$.prototype.init___ = (function() {
  return this
});
var $d_sjs_js_JSConverters$JSRichGenMap$ = new $TypeData().initClass({
  sjs_js_JSConverters$JSRichGenMap$: 0
}, false, "scala.scalajs.js.JSConverters$JSRichGenMap$", {
  sjs_js_JSConverters$JSRichGenMap$: 1,
  O: 1
});
$c_sjs_js_JSConverters$JSRichGenMap$.prototype.$classData = $d_sjs_js_JSConverters$JSRichGenMap$;
var $n_sjs_js_JSConverters$JSRichGenMap$ = (void 0);
function $m_sjs_js_JSConverters$JSRichGenMap$() {
  if ((!$n_sjs_js_JSConverters$JSRichGenMap$)) {
    $n_sjs_js_JSConverters$JSRichGenMap$ = new $c_sjs_js_JSConverters$JSRichGenMap$().init___()
  };
  return $n_sjs_js_JSConverters$JSRichGenMap$
}
/** @constructor */
function $c_sjs_js_JSConverters$JSRichGenTraversableOnce$() {
  $c_O.call(this)
}
$c_sjs_js_JSConverters$JSRichGenTraversableOnce$.prototype = new $h_O();
$c_sjs_js_JSConverters$JSRichGenTraversableOnce$.prototype.constructor = $c_sjs_js_JSConverters$JSRichGenTraversableOnce$;
/** @constructor */
function $h_sjs_js_JSConverters$JSRichGenTraversableOnce$() {
  /*<skip>*/
}
$h_sjs_js_JSConverters$JSRichGenTraversableOnce$.prototype = $c_sjs_js_JSConverters$JSRichGenTraversableOnce$.prototype;
$c_sjs_js_JSConverters$JSRichGenTraversableOnce$.prototype.init___ = (function() {
  return this
});
$c_sjs_js_JSConverters$JSRichGenTraversableOnce$.prototype.toJSArray$extension__sc_GenTraversableOnce__sjs_js_Array = (function($$this) {
  if (($$this instanceof $c_sjs_js_ArrayOps)) {
    var x2 = $as_sjs_js_ArrayOps($$this);
    return x2.scala$scalajs$js$ArrayOps$$array$f
  } else if (($$this instanceof $c_sjs_js_WrappedArray)) {
    var x3 = $as_sjs_js_WrappedArray($$this);
    return x3.array$6
  } else {
    var result = [];
    $$this.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, result$1) {
      return (function(x$2) {
        return $uI(result$1.push(x$2))
      })
    })(this, result)));
    return result
  }
});
var $d_sjs_js_JSConverters$JSRichGenTraversableOnce$ = new $TypeData().initClass({
  sjs_js_JSConverters$JSRichGenTraversableOnce$: 0
}, false, "scala.scalajs.js.JSConverters$JSRichGenTraversableOnce$", {
  sjs_js_JSConverters$JSRichGenTraversableOnce$: 1,
  O: 1
});
$c_sjs_js_JSConverters$JSRichGenTraversableOnce$.prototype.$classData = $d_sjs_js_JSConverters$JSRichGenTraversableOnce$;
var $n_sjs_js_JSConverters$JSRichGenTraversableOnce$ = (void 0);
function $m_sjs_js_JSConverters$JSRichGenTraversableOnce$() {
  if ((!$n_sjs_js_JSConverters$JSRichGenTraversableOnce$)) {
    $n_sjs_js_JSConverters$JSRichGenTraversableOnce$ = new $c_sjs_js_JSConverters$JSRichGenTraversableOnce$().init___()
  };
  return $n_sjs_js_JSConverters$JSRichGenTraversableOnce$
}
/** @constructor */
function $c_sjs_js_Thenable$ThenableOps$() {
  $c_O.call(this)
}
$c_sjs_js_Thenable$ThenableOps$.prototype = new $h_O();
$c_sjs_js_Thenable$ThenableOps$.prototype.constructor = $c_sjs_js_Thenable$ThenableOps$;
/** @constructor */
function $h_sjs_js_Thenable$ThenableOps$() {
  /*<skip>*/
}
$h_sjs_js_Thenable$ThenableOps$.prototype = $c_sjs_js_Thenable$ThenableOps$.prototype;
$c_sjs_js_Thenable$ThenableOps$.prototype.init___ = (function() {
  return this
});
$c_sjs_js_Thenable$ThenableOps$.prototype.toFuture$extension__sjs_js_Thenable__s_concurrent_Future = (function($$this) {
  var p2 = new $c_s_concurrent_impl_Promise$DefaultPromise().init___();
  var a = (function(p2$1$1) {
    return (function(arg1$2$1) {
      return $m_sjs_js_Thenable$ThenableOps$().scala$scalajs$js$Thenable$ThenableOps$$$anonfun$toFuture$2__O__s_concurrent_Promise__sjs_js_$bar(arg1$2$1, p2$1$1)
    })
  })(p2);
  $$this.then((function(p2$1) {
    return (function(arg1$2) {
      return $m_sjs_js_Thenable$ThenableOps$().scala$scalajs$js$Thenable$ThenableOps$$$anonfun$toFuture$1__O__s_concurrent_Promise__sjs_js_$bar(arg1$2, p2$1)
    })
  })(p2), a);
  return p2
});
$c_sjs_js_Thenable$ThenableOps$.prototype.scala$scalajs$js$Thenable$ThenableOps$$$anonfun$toFuture$2__O__s_concurrent_Promise__sjs_js_$bar = (function(e, p2$1) {
  if ((e instanceof $c_jl_Throwable)) {
    var x2 = $as_jl_Throwable(e);
    var cause = x2
  } else {
    var cause = new $c_sjs_js_JavaScriptException().init___O(e)
  };
  $f_s_concurrent_Promise__failure__jl_Throwable__s_concurrent_Promise(p2$1, cause)
});
$c_sjs_js_Thenable$ThenableOps$.prototype.scala$scalajs$js$Thenable$ThenableOps$$$anonfun$toFuture$1__O__s_concurrent_Promise__sjs_js_$bar = (function(v, p2$1) {
  $f_s_concurrent_Promise__success__O__s_concurrent_Promise(p2$1, v)
});
var $d_sjs_js_Thenable$ThenableOps$ = new $TypeData().initClass({
  sjs_js_Thenable$ThenableOps$: 0
}, false, "scala.scalajs.js.Thenable$ThenableOps$", {
  sjs_js_Thenable$ThenableOps$: 1,
  O: 1
});
$c_sjs_js_Thenable$ThenableOps$.prototype.$classData = $d_sjs_js_Thenable$ThenableOps$;
var $n_sjs_js_Thenable$ThenableOps$ = (void 0);
function $m_sjs_js_Thenable$ThenableOps$() {
  if ((!$n_sjs_js_Thenable$ThenableOps$)) {
    $n_sjs_js_Thenable$ThenableOps$ = new $c_sjs_js_Thenable$ThenableOps$().init___()
  };
  return $n_sjs_js_Thenable$ThenableOps$
}
/** @constructor */
function $c_sjs_js_WrappedDictionary$Cache$() {
  $c_O.call(this);
  this.safeHasOwnProperty$1 = null
}
$c_sjs_js_WrappedDictionary$Cache$.prototype = new $h_O();
$c_sjs_js_WrappedDictionary$Cache$.prototype.constructor = $c_sjs_js_WrappedDictionary$Cache$;
/** @constructor */
function $h_sjs_js_WrappedDictionary$Cache$() {
  /*<skip>*/
}
$h_sjs_js_WrappedDictionary$Cache$.prototype = $c_sjs_js_WrappedDictionary$Cache$.prototype;
$c_sjs_js_WrappedDictionary$Cache$.prototype.init___ = (function() {
  $n_sjs_js_WrappedDictionary$Cache$ = this;
  this.safeHasOwnProperty$1 = $g.Object.prototype.hasOwnProperty;
  return this
});
var $d_sjs_js_WrappedDictionary$Cache$ = new $TypeData().initClass({
  sjs_js_WrappedDictionary$Cache$: 0
}, false, "scala.scalajs.js.WrappedDictionary$Cache$", {
  sjs_js_WrappedDictionary$Cache$: 1,
  O: 1
});
$c_sjs_js_WrappedDictionary$Cache$.prototype.$classData = $d_sjs_js_WrappedDictionary$Cache$;
var $n_sjs_js_WrappedDictionary$Cache$ = (void 0);
function $m_sjs_js_WrappedDictionary$Cache$() {
  if ((!$n_sjs_js_WrappedDictionary$Cache$)) {
    $n_sjs_js_WrappedDictionary$Cache$ = new $c_sjs_js_WrappedDictionary$Cache$().init___()
  };
  return $n_sjs_js_WrappedDictionary$Cache$
}
/** @constructor */
function $c_sjsr_Bits$() {
  $c_O.call(this);
  this.scala$scalajs$runtime$Bits$$$undareTypedArraysSupported$f = false;
  this.arrayBuffer$1 = null;
  this.int32Array$1 = null;
  this.float32Array$1 = null;
  this.float64Array$1 = null;
  this.areTypedArraysBigEndian$1 = false;
  this.highOffset$1 = 0;
  this.lowOffset$1 = 0
}
$c_sjsr_Bits$.prototype = new $h_O();
$c_sjsr_Bits$.prototype.constructor = $c_sjsr_Bits$;
/** @constructor */
function $h_sjsr_Bits$() {
  /*<skip>*/
}
$h_sjsr_Bits$.prototype = $c_sjsr_Bits$.prototype;
$c_sjsr_Bits$.prototype.init___ = (function() {
  $n_sjsr_Bits$ = this;
  var x = ((($g.ArrayBuffer && $g.Int32Array) && $g.Float32Array) && $g.Float64Array);
  this.scala$scalajs$runtime$Bits$$$undareTypedArraysSupported$f = $uZ((!(!x)));
  this.arrayBuffer$1 = (this.scala$scalajs$runtime$Bits$$$undareTypedArraysSupported$f ? new $g.ArrayBuffer(8) : null);
  this.int32Array$1 = (this.scala$scalajs$runtime$Bits$$$undareTypedArraysSupported$f ? new $g.Int32Array(this.arrayBuffer$1, 0, 2) : null);
  this.float32Array$1 = (this.scala$scalajs$runtime$Bits$$$undareTypedArraysSupported$f ? new $g.Float32Array(this.arrayBuffer$1, 0, 2) : null);
  this.float64Array$1 = (this.scala$scalajs$runtime$Bits$$$undareTypedArraysSupported$f ? new $g.Float64Array(this.arrayBuffer$1, 0, 1) : null);
  if ((!this.scala$scalajs$runtime$Bits$$$undareTypedArraysSupported$f)) {
    var jsx$1 = true
  } else {
    this.int32Array$1[0] = 16909060;
    var jsx$1 = ($uB(new $g.Int8Array(this.arrayBuffer$1, 0, 8)[0]) === 1)
  };
  this.areTypedArraysBigEndian$1 = jsx$1;
  this.highOffset$1 = (this.areTypedArraysBigEndian$1 ? 0 : 1);
  this.lowOffset$1 = (this.areTypedArraysBigEndian$1 ? 1 : 0);
  return this
});
$c_sjsr_Bits$.prototype.numberHashCode__D__I = (function(value) {
  var iv = $uI((value | 0));
  if (((iv === value) && ((1.0 / value) !== (-Infinity)))) {
    return iv
  } else {
    var t = this.doubleToLongBits__D__J(value);
    var lo = t.lo$2;
    var hi = t.hi$2;
    return (lo ^ hi)
  }
});
$c_sjsr_Bits$.prototype.doubleToLongBitsPolyfill__p1__D__J = (function(value) {
  if ((value !== value)) {
    var _3 = $uD($g.Math.pow(2.0, 51));
    var x1_$_$$und1$1 = false;
    var x1_$_$$und2$1 = 2047;
    var x1_$_$$und3$1 = _3
  } else if (((value === Infinity) || (value === (-Infinity)))) {
    var _1 = (value < 0);
    var x1_$_$$und1$1 = _1;
    var x1_$_$$und2$1 = 2047;
    var x1_$_$$und3$1 = 0.0
  } else if ((value === 0.0)) {
    var _1$1 = ((1 / value) === (-Infinity));
    var x1_$_$$und1$1 = _1$1;
    var x1_$_$$und2$1 = 0;
    var x1_$_$$und3$1 = 0.0
  } else {
    var s = (value < 0);
    var av = (s ? (-value) : value);
    if ((av >= $uD($g.Math.pow(2.0, (-1022))))) {
      var twoPowFbits = $uD($g.Math.pow(2.0, 52));
      var a = ($uD($g.Math.log(av)) / 0.6931471805599453);
      var x = $uD($g.Math.floor(a));
      var a$1 = $uI((x | 0));
      var e = ((a$1 < 1023) ? a$1 : 1023);
      var b = e;
      var twoPowE = $uD($g.Math.pow(2.0, b));
      if ((twoPowE > av)) {
        e = (((-1) + e) | 0);
        twoPowE = (twoPowE / 2)
      };
      var n = ((av / twoPowE) * twoPowFbits);
      var w = $uD($g.Math.floor(n));
      var f = (n - w);
      var f$1 = ((f < 0.5) ? w : ((f > 0.5) ? (1 + w) : (((w % 2) !== 0) ? (1 + w) : w)));
      if (((f$1 / twoPowFbits) >= 2)) {
        e = ((1 + e) | 0);
        f$1 = 1.0
      };
      if ((e > 1023)) {
        e = 2047;
        f$1 = 0.0
      } else {
        e = ((1023 + e) | 0);
        f$1 = (f$1 - twoPowFbits)
      };
      var _2 = e;
      var _3$1 = f$1;
      var x1_$_$$und1$1 = s;
      var x1_$_$$und2$1 = _2;
      var x1_$_$$und3$1 = _3$1
    } else {
      var n$1 = (av / $uD($g.Math.pow(2.0, (-1074))));
      var w$1 = $uD($g.Math.floor(n$1));
      var f$2 = (n$1 - w$1);
      var _3$2 = ((f$2 < 0.5) ? w$1 : ((f$2 > 0.5) ? (1 + w$1) : (((w$1 % 2) !== 0) ? (1 + w$1) : w$1)));
      var x1_$_$$und1$1 = s;
      var x1_$_$$und2$1 = 0;
      var x1_$_$$und3$1 = _3$2
    }
  };
  var s$1 = $uZ(x1_$_$$und1$1);
  var e$1 = $uI(x1_$_$$und2$1);
  var f$3 = $uD(x1_$_$$und3$1);
  var x$1 = (f$3 / 4.294967296E9);
  var hif = $uI((x$1 | 0));
  var hi = (((s$1 ? (-2147483648) : 0) | (e$1 << 20)) | hif);
  var lo = $uI((f$3 | 0));
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_sjsr_Bits$.prototype.longBitsToDoublePolyfill__p1__J__D = (function(bits) {
  var lo = bits.hi$2;
  var x = bits.lo$2;
  var lo$1 = $uD((x >>> 0));
  var s = (lo < 0);
  var e = (2047 & (lo >> 20));
  var f = ((4.294967296E9 * (1048575 & lo)) + lo$1);
  if ((e === 2047)) {
    return ((f !== 0.0) ? (NaN) : (s ? (-Infinity) : Infinity))
  } else if ((e > 0)) {
    var b = (((-1023) + e) | 0);
    var x$1 = ($uD($g.Math.pow(2.0, b)) * (1 + (f / $uD($g.Math.pow(2.0, 52)))));
    return (s ? (-x$1) : x$1)
  } else if ((f !== 0.0)) {
    var x$2 = ($uD($g.Math.pow(2.0, (-1022))) * (f / $uD($g.Math.pow(2.0, 52))));
    return (s ? (-x$2) : x$2)
  } else {
    return (s ? (-0) : 0.0)
  }
});
$c_sjsr_Bits$.prototype.longBitsToDouble__J__D = (function(bits) {
  if (this.scala$scalajs$runtime$Bits$$$undareTypedArraysSupported$f) {
    var jsx$2 = this.int32Array$1;
    var jsx$1 = this.highOffset$1;
    var lo = bits.hi$2;
    jsx$2[jsx$1] = lo;
    this.int32Array$1[this.lowOffset$1] = bits.lo$2;
    return $uD(this.float64Array$1[0])
  } else {
    return this.longBitsToDoublePolyfill__p1__J__D(bits)
  }
});
$c_sjsr_Bits$.prototype.doubleToLongBits__D__J = (function(value) {
  if (this.scala$scalajs$runtime$Bits$$$undareTypedArraysSupported$f) {
    this.float64Array$1[0] = value;
    var value$1 = $uI(this.int32Array$1[this.highOffset$1]);
    var value$2 = $uI(this.int32Array$1[this.lowOffset$1]);
    return new $c_sjsr_RuntimeLong().init___I__I(value$2, value$1)
  } else {
    return this.doubleToLongBitsPolyfill__p1__D__J(value)
  }
});
var $d_sjsr_Bits$ = new $TypeData().initClass({
  sjsr_Bits$: 0
}, false, "scala.scalajs.runtime.Bits$", {
  sjsr_Bits$: 1,
  O: 1
});
$c_sjsr_Bits$.prototype.$classData = $d_sjsr_Bits$;
var $n_sjsr_Bits$ = (void 0);
function $m_sjsr_Bits$() {
  if ((!$n_sjsr_Bits$)) {
    $n_sjsr_Bits$ = new $c_sjsr_Bits$().init___()
  };
  return $n_sjsr_Bits$
}
/** @constructor */
function $c_sjsr_RuntimeString$() {
  $c_O.call(this);
  this.CASE$undINSENSITIVE$undORDER$1 = null;
  this.bitmap$0$1 = false
}
$c_sjsr_RuntimeString$.prototype = new $h_O();
$c_sjsr_RuntimeString$.prototype.constructor = $c_sjsr_RuntimeString$;
/** @constructor */
function $h_sjsr_RuntimeString$() {
  /*<skip>*/
}
$h_sjsr_RuntimeString$.prototype = $c_sjsr_RuntimeString$.prototype;
$c_sjsr_RuntimeString$.prototype.endsWith__T__T__Z = (function(thiz, suffix) {
  return ($as_T(thiz.substring((($uI(thiz.length) - $uI(suffix.length)) | 0))) === suffix)
});
$c_sjsr_RuntimeString$.prototype.init___ = (function() {
  return this
});
$c_sjsr_RuntimeString$.prototype.indexOf__T__I__I__I = (function(thiz, ch, fromIndex) {
  var str = this.fromCodePoint__p1__I__T(ch);
  return $uI(thiz.indexOf(str, fromIndex))
});
$c_sjsr_RuntimeString$.prototype.toCharArray__T__AC = (function(thiz) {
  var length = $uI(thiz.length);
  var result = $newArrayObject($d_C.getArrayOf(), [length]);
  var i = 0;
  while ((i < length)) {
    var jsx$1 = i;
    var index = i;
    result.set(jsx$1, (65535 & $uI(thiz.charCodeAt(index))));
    i = ((1 + i) | 0)
  };
  return result
});
$c_sjsr_RuntimeString$.prototype.split__T__T__I__AT = (function(thiz, regex, limit) {
  if ((thiz === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  var this$1 = $m_ju_regex_Pattern$();
  return this$1.compile__T__I__ju_regex_Pattern(regex, 0).split__jl_CharSequence__I__AT(thiz, limit)
});
$c_sjsr_RuntimeString$.prototype.replaceFirst__T__T__T__T = (function(thiz, regex, replacement) {
  if ((thiz === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  var this$1 = $m_ju_regex_Pattern$();
  var this$2 = this$1.compile__T__I__ju_regex_Pattern(regex, 0);
  return new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$2, thiz, 0, $uI(thiz.length)).replaceFirst__T__T(replacement)
});
$c_sjsr_RuntimeString$.prototype.lastIndexOf__T__I__I = (function(thiz, ch) {
  var str = this.fromCodePoint__p1__I__T(ch);
  return $uI(thiz.lastIndexOf(str))
});
$c_sjsr_RuntimeString$.prototype.getBytes__T__Ljava_nio_charset_Charset__AB = (function(thiz, charset) {
  var buf = charset.encode__T__Ljava_nio_ByteBuffer(thiz);
  var res = $newArrayObject($d_B.getArrayOf(), [((buf.$$undlimit$1 - buf.java$nio$Buffer$$$undposition$1) | 0)]);
  buf.get__AB__I__I__Ljava_nio_ByteBuffer(res, 0, res.u.length);
  return res
});
$c_sjsr_RuntimeString$.prototype.indexOf__T__I__I = (function(thiz, ch) {
  var str = this.fromCodePoint__p1__I__T(ch);
  return $uI(thiz.indexOf(str))
});
$c_sjsr_RuntimeString$.prototype.newString__AC__I__I__T = (function(value, offset, count) {
  var end = ((offset + count) | 0);
  if ((((offset < 0) || (end < offset)) || (end > value.u.length))) {
    throw new $c_jl_StringIndexOutOfBoundsException().init___()
  };
  var result = "";
  var i = offset;
  while ((i !== end)) {
    var jsx$1 = result;
    var c = value.get(i);
    result = (("" + jsx$1) + $as_T($g.String.fromCharCode(c)));
    i = ((1 + i) | 0)
  };
  return result
});
$c_sjsr_RuntimeString$.prototype.compareToIgnoreCase__T__T__I = (function(thiz, str) {
  var thiz$1 = $as_T(thiz.toLowerCase());
  var anotherString = $as_T(str.toLowerCase());
  return ((thiz$1 === anotherString) ? 0 : ($uZ((thiz$1 < anotherString)) ? (-1) : 1))
});
$c_sjsr_RuntimeString$.prototype.fromCodePoint__p1__I__T = (function(codePoint) {
  if ((((-65536) & codePoint) === 0)) {
    return $as_T($g.String.fromCharCode(codePoint))
  } else if (((codePoint < 0) || (codePoint > 1114111))) {
    throw new $c_jl_IllegalArgumentException().init___()
  } else {
    var offsetCp = (((-65536) + codePoint) | 0);
    return $as_T($g.String.fromCharCode((55296 | (offsetCp >> 10)), (56320 | (1023 & offsetCp))))
  }
});
$c_sjsr_RuntimeString$.prototype.hashCode__T__I = (function(thiz) {
  var res = 0;
  var mul = 1;
  var i = (((-1) + $uI(thiz.length)) | 0);
  while ((i >= 0)) {
    var jsx$1 = res;
    var index = i;
    res = ((jsx$1 + $imul((65535 & $uI(thiz.charCodeAt(index))), mul)) | 0);
    mul = $imul(31, mul);
    i = (((-1) + i) | 0)
  };
  return res
});
$c_sjsr_RuntimeString$.prototype.format__T__AO__T = (function(format, args) {
  var frm = new $c_ju_Formatter().init___();
  var res = frm.format__T__AO__ju_Formatter(format, args).toString__T();
  frm.close__V();
  return res
});
$c_sjsr_RuntimeString$.prototype.replaceAll__T__T__T__T = (function(thiz, regex, replacement) {
  if ((thiz === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  var this$1 = $m_ju_regex_Pattern$();
  var this$2 = this$1.compile__T__I__ju_regex_Pattern(regex, 0);
  return new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$2, thiz, 0, $uI(thiz.length)).replaceAll__T__T(replacement)
});
var $d_sjsr_RuntimeString$ = new $TypeData().initClass({
  sjsr_RuntimeString$: 0
}, false, "scala.scalajs.runtime.RuntimeString$", {
  sjsr_RuntimeString$: 1,
  O: 1
});
$c_sjsr_RuntimeString$.prototype.$classData = $d_sjsr_RuntimeString$;
var $n_sjsr_RuntimeString$ = (void 0);
function $m_sjsr_RuntimeString$() {
  if ((!$n_sjsr_RuntimeString$)) {
    $n_sjsr_RuntimeString$ = new $c_sjsr_RuntimeString$().init___()
  };
  return $n_sjsr_RuntimeString$
}
/** @constructor */
function $c_sjsr_StackTrace$() {
  $c_O.call(this);
  this.isRhino$1 = false;
  this.decompressedClasses$1 = null;
  this.decompressedPrefixes$1 = null;
  this.compressedPrefixes$1 = null;
  this.bitmap$0$1 = 0
}
$c_sjsr_StackTrace$.prototype = new $h_O();
$c_sjsr_StackTrace$.prototype.constructor = $c_sjsr_StackTrace$;
/** @constructor */
function $h_sjsr_StackTrace$() {
  /*<skip>*/
}
$h_sjsr_StackTrace$.prototype = $c_sjsr_StackTrace$.prototype;
$c_sjsr_StackTrace$.prototype.compressedPrefixes$lzycompute__p1__sjs_js_Array = (function() {
  if (((((8 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.compressedPrefixes$1 = $g.Object.keys(this.decompressedPrefixes__p1__sjs_js_Dictionary());
    this.bitmap$0$1 = (((8 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.compressedPrefixes$1
});
$c_sjsr_StackTrace$.prototype.extractFirefox__p1__sjs_js_Dynamic__sjs_js_Array = (function(e) {
  var x = $as_T(e.stack);
  var jsx$2 = x.replace($m_sjsr_StackTrace$StringRE$().re$extension1__T__T__sjs_js_RegExp("(?:\\n@:0)?\\s+$", "m"), "");
  var x$1 = $as_T(jsx$2);
  var jsx$1 = x$1.replace($m_sjsr_StackTrace$StringRE$().re$extension1__T__T__sjs_js_RegExp("^(?:\\((\\S*)\\))?@", "gm"), "{anonymous}($1)@");
  var x$2 = $as_T(jsx$1);
  return x$2.split("\n")
});
$c_sjsr_StackTrace$.prototype.extractOpera10a__p1__sjs_js_Dynamic__sjs_js_Array = (function(e) {
  var lineRE = $m_sjsr_StackTrace$StringRE$().re$extension1__T__T__sjs_js_RegExp("Line (\\d+).*script (?:in )?(\\S+)(?:: In function (\\S+))?$", "i");
  var x = $as_T(e.stacktrace);
  var lines = x.split("\n");
  var result = [];
  var i = 0;
  var len = $uI(lines.length);
  while ((i < len)) {
    var mtch = lineRE.exec($as_T(lines[i]));
    if ((mtch !== null)) {
      var value = mtch[3];
      var fnName = $as_T(((value === (void 0)) ? "{anonymous}" : value));
      var value$1 = mtch[2];
      if ((value$1 === (void 0))) {
        throw new $c_ju_NoSuchElementException().init___T("undefined.get")
      };
      var value$2 = mtch[1];
      if ((value$2 === (void 0))) {
        throw new $c_ju_NoSuchElementException().init___T("undefined.get")
      };
      var jsx$1 = result.push(((((fnName + "()@") + value$1) + ":") + value$2));
      $uI(jsx$1)
    };
    i = ((2 + i) | 0)
  };
  return result
});
$c_sjsr_StackTrace$.prototype.init___ = (function() {
  return this
});
$c_sjsr_StackTrace$.prototype.isRhino__p1__Z = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.isRhino$lzycompute__p1__Z() : this.isRhino$1)
});
$c_sjsr_StackTrace$.prototype.decodeClassName__p1__T__T = (function(encodedName) {
  var encoded = (((65535 & $uI(encodedName.charCodeAt(0))) === 36) ? $as_T(encodedName.substring(1)) : encodedName);
  var dict = this.decompressedClasses__p1__sjs_js_Dictionary();
  if ($uZ($m_sjs_js_WrappedDictionary$Cache$().safeHasOwnProperty$1.call(dict, encoded))) {
    var dict$1 = this.decompressedClasses__p1__sjs_js_Dictionary();
    if ((!$uZ($m_sjs_js_WrappedDictionary$Cache$().safeHasOwnProperty$1.call(dict$1, encoded)))) {
      throw new $c_ju_NoSuchElementException().init___T(("key not found: " + encoded))
    };
    var base = $as_T(dict$1[encoded])
  } else {
    var base = this.loop$1__p1__I__T__T(0, encoded)
  };
  var thiz = $as_T(base.split("_").join("."));
  return $as_T(thiz.split("$und").join("_"))
});
$c_sjsr_StackTrace$.prototype.extractOpera10b__p1__sjs_js_Dynamic__sjs_js_Array = (function(e) {
  var lineRE = $m_sjsr_StackTrace$StringRE$().re$extension0__T__sjs_js_RegExp("^(.*)@(.+):(\\d+)$");
  var x = $as_T(e.stacktrace);
  var lines = x.split("\n");
  var result = [];
  var i = 0;
  var len = $uI(lines.length);
  while ((i < len)) {
    var mtch = lineRE.exec($as_T(lines[i]));
    if ((mtch !== null)) {
      var value = mtch[1];
      if ((value === (void 0))) {
        var fnName = "global code"
      } else {
        var x$3 = $as_T(value);
        var fnName = (x$3 + "()")
      };
      var value$1 = mtch[2];
      if ((value$1 === (void 0))) {
        throw new $c_ju_NoSuchElementException().init___T("undefined.get")
      };
      var value$2 = mtch[3];
      if ((value$2 === (void 0))) {
        throw new $c_ju_NoSuchElementException().init___T("undefined.get")
      };
      var jsx$1 = result.push(((((fnName + "@") + value$1) + ":") + value$2));
      $uI(jsx$1)
    };
    i = ((1 + i) | 0)
  };
  return result
});
$c_sjsr_StackTrace$.prototype.extractChrome__p1__sjs_js_Dynamic__sjs_js_Array = (function(e) {
  var x = ($as_T(e.stack) + "\n");
  var jsx$6 = x.replace($m_sjsr_StackTrace$StringRE$().re$extension0__T__sjs_js_RegExp("^[\\s\\S]+?\\s+at\\s+"), " at ");
  var x$1 = $as_T(jsx$6);
  var jsx$5 = x$1.replace($m_sjsr_StackTrace$StringRE$().re$extension1__T__T__sjs_js_RegExp("^\\s+(at eval )?at\\s+", "gm"), "");
  var x$2 = $as_T(jsx$5);
  var jsx$4 = x$2.replace($m_sjsr_StackTrace$StringRE$().re$extension1__T__T__sjs_js_RegExp("^([^\\(]+?)([\\n])", "gm"), "{anonymous}() ($1)$2");
  var x$3 = $as_T(jsx$4);
  var jsx$3 = x$3.replace($m_sjsr_StackTrace$StringRE$().re$extension1__T__T__sjs_js_RegExp("^Object.<anonymous>\\s*\\(([^\\)]+)\\)", "gm"), "{anonymous}() ($1)");
  var x$4 = $as_T(jsx$3);
  var jsx$2 = x$4.replace($m_sjsr_StackTrace$StringRE$().re$extension1__T__T__sjs_js_RegExp("^([^\\(]+|\\{anonymous\\}\\(\\)) \\((.+)\\)$", "gm"), "$1@$2");
  var x$5 = $as_T(jsx$2);
  var jsx$1 = x$5.split("\n");
  return jsx$1.slice(0, (-1))
});
$c_sjsr_StackTrace$.prototype.extract__sjs_js_Dynamic__Ajl_StackTraceElement = (function(stackdata) {
  var lines = this.normalizeStackTraceLines__p1__sjs_js_Dynamic__sjs_js_Array(stackdata);
  return this.normalizedLinesToStackTrace__p1__sjs_js_Array__Ajl_StackTraceElement(lines)
});
$c_sjsr_StackTrace$.prototype.compressedPrefixes__p1__sjs_js_Array = (function() {
  return (((((8 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.compressedPrefixes$lzycompute__p1__sjs_js_Array() : this.compressedPrefixes$1)
});
$c_sjsr_StackTrace$.prototype.decompressedClasses__p1__sjs_js_Dictionary = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.decompressedClasses$lzycompute__p1__sjs_js_Dictionary() : this.decompressedClasses$1)
});
$c_sjsr_StackTrace$.prototype.extractClassMethod__p1__T__T2 = (function(functionName) {
  var PatC = $m_sjsr_StackTrace$StringRE$().re$extension0__T__sjs_js_RegExp("^(?:Object\\.|\\[object Object\\]\\.)?(?:ScalaJS\\.c\\.|\\$c_)([^\\.]+)(?:\\.prototype)?\\.([^\\.]+)$");
  var PatS = $m_sjsr_StackTrace$StringRE$().re$extension0__T__sjs_js_RegExp("^(?:Object\\.|\\[object Object\\]\\.)?(?:ScalaJS\\.(?:s|f)\\.|\\$(?:s|f)_)((?:_[^_]|[^_])+)__([^\\.]+)$");
  var PatM = $m_sjsr_StackTrace$StringRE$().re$extension0__T__sjs_js_RegExp("^(?:Object\\.|\\[object Object\\]\\.)?(?:ScalaJS\\.m\\.|\\$m_)([^\\.]+)$");
  var isModule = false;
  var mtch = PatC.exec(functionName);
  if ((mtch === null)) {
    mtch = PatS.exec(functionName);
    if ((mtch === null)) {
      mtch = PatM.exec(functionName);
      isModule = true
    }
  };
  if ((mtch !== null)) {
    var value = mtch[1];
    if ((value === (void 0))) {
      throw new $c_ju_NoSuchElementException().init___T("undefined.get")
    };
    var className = this.decodeClassName__p1__T__T($as_T(value));
    if (isModule) {
      var methodName = "<clinit>"
    } else {
      var value$1 = mtch[2];
      if ((value$1 === (void 0))) {
        throw new $c_ju_NoSuchElementException().init___T("undefined.get")
      };
      var methodName = this.decodeMethodName__p1__T__T($as_T(value$1))
    };
    return new $c_T2().init___O__O(className, methodName)
  } else {
    return new $c_T2().init___O__O("<jscode>", functionName)
  }
});
$c_sjsr_StackTrace$.prototype.isRhino$lzycompute__p1__Z = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.isRhino$1 = this.liftedTree1$1__p1__Z();
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.isRhino$1
});
$c_sjsr_StackTrace$.prototype.decompressedPrefixes$lzycompute__p1__sjs_js_Dictionary = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.decompressedPrefixes$1 = {
      "sjsr_": "scala_scalajs_runtime_",
      "sjs_": "scala_scalajs_",
      "sci_": "scala_collection_immutable_",
      "scm_": "scala_collection_mutable_",
      "scg_": "scala_collection_generic_",
      "sc_": "scala_collection_",
      "sr_": "scala_runtime_",
      "s_": "scala_",
      "jl_": "java_lang_",
      "ju_": "java_util_"
    };
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.decompressedPrefixes$1
});
$c_sjsr_StackTrace$.prototype.extract__jl_Throwable__Ajl_StackTraceElement = (function(throwable) {
  return this.extract__sjs_js_Dynamic__Ajl_StackTraceElement(throwable.stackdata)
});
$c_sjsr_StackTrace$.prototype.decompressedClasses$lzycompute__p1__sjs_js_Dictionary = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    var dict = {
      "O": "java_lang_Object",
      "T": "java_lang_String",
      "V": "scala_Unit",
      "Z": "scala_Boolean",
      "C": "scala_Char",
      "B": "scala_Byte",
      "S": "scala_Short",
      "I": "scala_Int",
      "J": "scala_Long",
      "F": "scala_Float",
      "D": "scala_Double"
    };
    var index = 0;
    while ((index <= 22)) {
      if ((index >= 2)) {
        dict[("T" + index)] = ("scala_Tuple" + index)
      };
      dict[("F" + index)] = ("scala_Function" + index);
      index = ((1 + index) | 0)
    };
    this.decompressedClasses$1 = dict;
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.decompressedClasses$1
});
$c_sjsr_StackTrace$.prototype.normalizeStackTraceLines__p1__sjs_js_Dynamic__sjs_js_Array = (function(e) {
  var x = (!e);
  if ($uZ((!(!x)))) {
    return []
  } else if (this.isRhino__p1__Z()) {
    return this.extractRhino__p1__sjs_js_Dynamic__sjs_js_Array(e)
  } else {
    var x$1 = (e.arguments && e.stack);
    if ($uZ((!(!x$1)))) {
      return this.extractChrome__p1__sjs_js_Dynamic__sjs_js_Array(e)
    } else {
      var x$2 = (e.stack && e.sourceURL);
      if ($uZ((!(!x$2)))) {
        return this.extractSafari__p1__sjs_js_Dynamic__sjs_js_Array(e)
      } else {
        var x$3 = (e.stack && e.number);
        if ($uZ((!(!x$3)))) {
          return this.extractIE__p1__sjs_js_Dynamic__sjs_js_Array(e)
        } else {
          var x$4 = (e.stack && e.fileName);
          if ($uZ((!(!x$4)))) {
            return this.extractFirefox__p1__sjs_js_Dynamic__sjs_js_Array(e)
          } else {
            var x$5 = (e.message && e["opera#sourceloc"]);
            if ($uZ((!(!x$5)))) {
              var x$6 = (!e.stacktrace);
              if ($uZ((!(!x$6)))) {
                return this.extractOpera9__p1__sjs_js_Dynamic__sjs_js_Array(e)
              } else {
                var x$7 = ((e.message.indexOf("\n") > (-1)) && (e.message.split("\n").length > e.stacktrace.split("\n").length));
                if ($uZ((!(!x$7)))) {
                  return this.extractOpera9__p1__sjs_js_Dynamic__sjs_js_Array(e)
                } else {
                  return this.extractOpera10a__p1__sjs_js_Dynamic__sjs_js_Array(e)
                }
              }
            } else {
              var x$8 = ((e.message && e.stack) && e.stacktrace);
              if ($uZ((!(!x$8)))) {
                var x$9 = (e.stacktrace.indexOf("called from line") < 0);
                if ($uZ((!(!x$9)))) {
                  return this.extractOpera10b__p1__sjs_js_Dynamic__sjs_js_Array(e)
                } else {
                  return this.extractOpera11__p1__sjs_js_Dynamic__sjs_js_Array(e)
                }
              } else {
                var x$10 = (e.stack && (!e.fileName));
                if ($uZ((!(!x$10)))) {
                  return this.extractChrome__p1__sjs_js_Dynamic__sjs_js_Array(e)
                } else {
                  return this.extractOther__p1__sjs_js_Dynamic__sjs_js_Array(e)
                }
              }
            }
          }
        }
      }
    }
  }
});
$c_sjsr_StackTrace$.prototype.extractOpera9__p1__sjs_js_Dynamic__sjs_js_Array = (function(e) {
  var lineRE = $m_sjsr_StackTrace$StringRE$().re$extension1__T__T__sjs_js_RegExp("Line (\\d+).*script (?:in )?(\\S+)", "i");
  var x = $as_T(e.message);
  var lines = x.split("\n");
  var result = [];
  var i = 2;
  var len = $uI(lines.length);
  while ((i < len)) {
    var mtch = lineRE.exec($as_T(lines[i]));
    if ((mtch !== null)) {
      var value = mtch[2];
      if ((value === (void 0))) {
        throw new $c_ju_NoSuchElementException().init___T("undefined.get")
      };
      var value$1 = mtch[1];
      if ((value$1 === (void 0))) {
        throw new $c_ju_NoSuchElementException().init___T("undefined.get")
      };
      var jsx$1 = result.push(((("{anonymous}()@" + value) + ":") + value$1));
      $uI(jsx$1)
    };
    i = ((2 + i) | 0)
  };
  return result
});
$c_sjsr_StackTrace$.prototype.normalizedLinesToStackTrace__p1__sjs_js_Array__Ajl_StackTraceElement = (function(lines) {
  var NormalizedFrameLine = $m_sjsr_StackTrace$StringRE$().re$extension0__T__sjs_js_RegExp("^([^\\@]*)\\@(.*):([0-9]+)$");
  var NormalizedFrameLineWithColumn = $m_sjsr_StackTrace$StringRE$().re$extension0__T__sjs_js_RegExp("^([^\\@]*)\\@(.*):([0-9]+):([0-9]+)$");
  var trace = [];
  var i = 0;
  while ((i < $uI(lines.length))) {
    var line = $as_T(lines[i]);
    if ((line === null)) {
      throw new $c_jl_NullPointerException().init___()
    };
    if ((line !== "")) {
      var mtch1 = NormalizedFrameLineWithColumn.exec(line);
      if ((mtch1 !== null)) {
        var value = mtch1[1];
        if ((value === (void 0))) {
          throw new $c_ju_NoSuchElementException().init___T("undefined.get")
        };
        var x1 = this.extractClassMethod__p1__T__T2($as_T(value));
        if ((x1 === null)) {
          throw new $c_s_MatchError().init___O(x1)
        };
        var className = $as_T(x1.$$und1__O());
        var methodName = $as_T(x1.$$und2__O());
        var value$1 = mtch1[2];
        if ((value$1 === (void 0))) {
          throw new $c_ju_NoSuchElementException().init___T("undefined.get")
        };
        var fileName = $as_T(value$1);
        var value$2 = mtch1[3];
        if ((value$2 === (void 0))) {
          throw new $c_ju_NoSuchElementException().init___T("undefined.get")
        };
        var x = $as_T(value$2);
        var this$15 = new $c_sci_StringOps().init___T(x);
        var this$17 = $m_jl_Integer$();
        var $$this = this$15.repr$1;
        var lineNumber = this$17.parseInt__T__I__I($$this, 10);
        var value$3 = mtch1[4];
        if ((value$3 === (void 0))) {
          throw new $c_ju_NoSuchElementException().init___T("undefined.get")
        };
        var x$1 = $as_T(value$3);
        var this$23 = new $c_sci_StringOps().init___T(x$1);
        var this$25 = $m_jl_Integer$();
        var $$this$1 = this$23.repr$1;
        var value$4 = this$25.parseInt__T__I__I($$this$1, 10);
        var jsx$1 = trace.push({
          "declaringClass": className,
          "methodName": methodName,
          "fileName": fileName,
          "lineNumber": lineNumber,
          "columnNumber": ((value$4 === (void 0)) ? (void 0) : value$4)
        });
        $uI(jsx$1)
      } else {
        var mtch2 = NormalizedFrameLine.exec(line);
        if ((mtch2 !== null)) {
          var value$5 = mtch2[1];
          if ((value$5 === (void 0))) {
            throw new $c_ju_NoSuchElementException().init___T("undefined.get")
          };
          var x1$2 = this.extractClassMethod__p1__T__T2($as_T(value$5));
          if ((x1$2 === null)) {
            throw new $c_s_MatchError().init___O(x1$2)
          };
          var className$3 = $as_T(x1$2.$$und1__O());
          var methodName$3 = $as_T(x1$2.$$und2__O());
          var value$6 = mtch2[2];
          if ((value$6 === (void 0))) {
            throw new $c_ju_NoSuchElementException().init___T("undefined.get")
          };
          var fileName$1 = $as_T(value$6);
          var value$7 = mtch2[3];
          if ((value$7 === (void 0))) {
            throw new $c_ju_NoSuchElementException().init___T("undefined.get")
          };
          var x$2 = $as_T(value$7);
          var this$52 = new $c_sci_StringOps().init___T(x$2);
          var this$54 = $m_jl_Integer$();
          var $$this$2 = this$52.repr$1;
          var lineNumber$1 = this$54.parseInt__T__I__I($$this$2, 10);
          var jsx$2 = trace.push({
            "declaringClass": className$3,
            "methodName": methodName$3,
            "fileName": fileName$1,
            "lineNumber": lineNumber$1,
            "columnNumber": (void 0)
          });
          $uI(jsx$2)
        } else {
          $uI(trace.push({
            "declaringClass": "<jscode>",
            "methodName": line,
            "fileName": null,
            "lineNumber": (-1),
            "columnNumber": (void 0)
          }))
        }
      }
    };
    i = ((1 + i) | 0)
  };
  var value$8 = $env.sourceMapper;
  var mappedTrace = ((value$8 === (void 0)) ? trace : value$8(trace));
  var result = $newArrayObject($d_jl_StackTraceElement.getArrayOf(), [$uI(mappedTrace.length)]);
  i = 0;
  while ((i < $uI(mappedTrace.length))) {
    var jsSte = mappedTrace[i];
    var ste = new $c_jl_StackTraceElement().init___T__T__T__I($as_T(jsSte.declaringClass), $as_T(jsSte.methodName), $as_T(jsSte.fileName), $uI(jsSte.lineNumber));
    var value$9 = jsSte.columnNumber;
    if ((value$9 !== (void 0))) {
      var columnNumber = $uI(value$9);
      ste.setColumnNumber(columnNumber)
    };
    result.set(i, ste);
    i = ((1 + i) | 0)
  };
  return result
});
$c_sjsr_StackTrace$.prototype.extractOpera11__p1__sjs_js_Dynamic__sjs_js_Array = (function(e) {
  var lineRE = $m_sjsr_StackTrace$StringRE$().re$extension0__T__sjs_js_RegExp("^.*line (\\d+), column (\\d+)(?: in (.+))? in (\\S+):$");
  var x = $as_T(e.stacktrace);
  var lines = x.split("\n");
  var result = [];
  var i = 0;
  var len = $uI(lines.length);
  while ((i < len)) {
    var mtch = lineRE.exec($as_T(lines[i]));
    if ((mtch !== null)) {
      var value = mtch[4];
      if ((value === (void 0))) {
        throw new $c_ju_NoSuchElementException().init___T("undefined.get")
      };
      var jsx$1 = $as_T(value);
      var value$1 = mtch[1];
      if ((value$1 === (void 0))) {
        throw new $c_ju_NoSuchElementException().init___T("undefined.get")
      };
      var value$2 = mtch[2];
      if ((value$2 === (void 0))) {
        throw new $c_ju_NoSuchElementException().init___T("undefined.get")
      };
      var location = ((((jsx$1 + ":") + value$1) + ":") + value$2);
      var value$3 = mtch[2];
      var fnName0 = $as_T(((value$3 === (void 0)) ? "global code" : value$3));
      var x$1 = $as_T(fnName0.replace($m_sjsr_StackTrace$StringRE$().re$extension0__T__sjs_js_RegExp("<anonymous function: (\\S+)>"), "$1"));
      var jsx$2 = x$1.replace($m_sjsr_StackTrace$StringRE$().re$extension0__T__sjs_js_RegExp("<anonymous function>"), "{anonymous}");
      var fnName = $as_T(jsx$2);
      $uI(result.push(((fnName + "@") + location)))
    };
    i = ((2 + i) | 0)
  };
  return result
});
$c_sjsr_StackTrace$.prototype.extractSafari__p1__sjs_js_Dynamic__sjs_js_Array = (function(e) {
  var x = $as_T(e.stack);
  var jsx$3 = x.replace($m_sjsr_StackTrace$StringRE$().re$extension1__T__T__sjs_js_RegExp("\\[native code\\]\\n", "m"), "");
  var x$1 = $as_T(jsx$3);
  var jsx$2 = x$1.replace($m_sjsr_StackTrace$StringRE$().re$extension1__T__T__sjs_js_RegExp("^(?=\\w+Error\\:).*$\\n", "m"), "");
  var x$2 = $as_T(jsx$2);
  var jsx$1 = x$2.replace($m_sjsr_StackTrace$StringRE$().re$extension1__T__T__sjs_js_RegExp("^@", "gm"), "{anonymous}()@");
  var x$3 = $as_T(jsx$1);
  return x$3.split("\n")
});
$c_sjsr_StackTrace$.prototype.loop$1__p1__I__T__T = (function(i, encoded$1) {
  _loop: while (true) {
    if ((i < $uI(this.compressedPrefixes__p1__sjs_js_Array().length))) {
      var prefix = $as_T(this.compressedPrefixes__p1__sjs_js_Array()[i]);
      if ((($uI(encoded$1.length) >= 0) && ($as_T(encoded$1.substring(0, $uI(prefix.length))) === prefix))) {
        var dict = this.decompressedPrefixes__p1__sjs_js_Dictionary();
        if ((!$uZ($m_sjs_js_WrappedDictionary$Cache$().safeHasOwnProperty$1.call(dict, prefix)))) {
          throw new $c_ju_NoSuchElementException().init___T(("key not found: " + prefix))
        };
        var jsx$1 = $as_T(dict[prefix]);
        var beginIndex = $uI(prefix.length);
        return (("" + jsx$1) + $as_T(encoded$1.substring(beginIndex)))
      } else {
        i = ((1 + i) | 0);
        continue _loop
      }
    } else {
      return ((($uI(encoded$1.length) >= 0) && ($as_T(encoded$1.substring(0, $uI("L".length))) === "L")) ? $as_T(encoded$1.substring(1)) : encoded$1)
    }
  }
});
$c_sjsr_StackTrace$.prototype.liftedTree1$1__p1__Z = (function() {
  try {
    $g.Packages.org.mozilla.javascript.JavaScriptException;
    return true
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      if ((e$2 instanceof $c_sjs_js_JavaScriptException)) {
        return false
      } else {
        throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(e$2)
      }
    } else {
      throw e
    }
  }
});
$c_sjsr_StackTrace$.prototype.decompressedPrefixes__p1__sjs_js_Dictionary = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.decompressedPrefixes$lzycompute__p1__sjs_js_Dictionary() : this.decompressedPrefixes$1)
});
$c_sjsr_StackTrace$.prototype.extractRhino__p1__sjs_js_Dynamic__sjs_js_Array = (function(e) {
  var value = e.stack;
  var x = $as_T(((value === (void 0)) ? "" : value));
  var jsx$3 = x.replace($m_sjsr_StackTrace$StringRE$().re$extension1__T__T__sjs_js_RegExp("^\\s+at\\s+", "gm"), "");
  var x$1 = $as_T(jsx$3);
  var jsx$2 = x$1.replace($m_sjsr_StackTrace$StringRE$().re$extension1__T__T__sjs_js_RegExp("^(.+?)(?: \\((.+)\\))?$", "gm"), "$2@$1");
  var x$2 = $as_T(jsx$2);
  var jsx$1 = x$2.replace($m_sjsr_StackTrace$StringRE$().re$extension1__T__T__sjs_js_RegExp("\\r\\n?", "gm"), "\n");
  var x$3 = $as_T(jsx$1);
  return x$3.split("\n")
});
$c_sjsr_StackTrace$.prototype.extractOther__p1__sjs_js_Dynamic__sjs_js_Array = (function(e) {
  return []
});
$c_sjsr_StackTrace$.prototype.extractIE__p1__sjs_js_Dynamic__sjs_js_Array = (function(e) {
  var x = $as_T(e.stack);
  var jsx$3 = x.replace($m_sjsr_StackTrace$StringRE$().re$extension1__T__T__sjs_js_RegExp("^\\s*at\\s+(.*)$", "gm"), "$1");
  var x$1 = $as_T(jsx$3);
  var jsx$2 = x$1.replace($m_sjsr_StackTrace$StringRE$().re$extension1__T__T__sjs_js_RegExp("^Anonymous function\\s+", "gm"), "{anonymous}() ");
  var x$2 = $as_T(jsx$2);
  var jsx$1 = x$2.replace($m_sjsr_StackTrace$StringRE$().re$extension1__T__T__sjs_js_RegExp("^([^\\(]+|\\{anonymous\\}\\(\\))\\s+\\((.+)\\)$", "gm"), "$1@$2");
  var x$3 = $as_T(jsx$1);
  var qual$1 = x$3.split("\n");
  return qual$1.slice(1)
});
$c_sjsr_StackTrace$.prototype.decodeMethodName__p1__T__T = (function(encodedName) {
  if ((($uI(encodedName.length) >= 0) && ($as_T(encodedName.substring(0, $uI("init___".length))) === "init___"))) {
    return "<init>"
  } else {
    var methodNameLen = $uI(encodedName.indexOf("__"));
    return ((methodNameLen < 0) ? encodedName : $as_T(encodedName.substring(0, methodNameLen)))
  }
});
var $d_sjsr_StackTrace$ = new $TypeData().initClass({
  sjsr_StackTrace$: 0
}, false, "scala.scalajs.runtime.StackTrace$", {
  sjsr_StackTrace$: 1,
  O: 1
});
$c_sjsr_StackTrace$.prototype.$classData = $d_sjsr_StackTrace$;
var $n_sjsr_StackTrace$ = (void 0);
function $m_sjsr_StackTrace$() {
  if ((!$n_sjsr_StackTrace$)) {
    $n_sjsr_StackTrace$ = new $c_sjsr_StackTrace$().init___()
  };
  return $n_sjsr_StackTrace$
}
/** @constructor */
function $c_sjsr_StackTrace$StringRE$() {
  $c_O.call(this)
}
$c_sjsr_StackTrace$StringRE$.prototype = new $h_O();
$c_sjsr_StackTrace$StringRE$.prototype.constructor = $c_sjsr_StackTrace$StringRE$;
/** @constructor */
function $h_sjsr_StackTrace$StringRE$() {
  /*<skip>*/
}
$h_sjsr_StackTrace$StringRE$.prototype = $c_sjsr_StackTrace$StringRE$.prototype;
$c_sjsr_StackTrace$StringRE$.prototype.init___ = (function() {
  return this
});
$c_sjsr_StackTrace$StringRE$.prototype.re$extension1__T__T__sjs_js_RegExp = (function($$this, mods) {
  return new $g.RegExp($$this, mods)
});
$c_sjsr_StackTrace$StringRE$.prototype.re$extension0__T__sjs_js_RegExp = (function($$this) {
  return new $g.RegExp($$this)
});
var $d_sjsr_StackTrace$StringRE$ = new $TypeData().initClass({
  sjsr_StackTrace$StringRE$: 0
}, false, "scala.scalajs.runtime.StackTrace$StringRE$", {
  sjsr_StackTrace$StringRE$: 1,
  O: 1
});
$c_sjsr_StackTrace$StringRE$.prototype.$classData = $d_sjsr_StackTrace$StringRE$;
var $n_sjsr_StackTrace$StringRE$ = (void 0);
function $m_sjsr_StackTrace$StringRE$() {
  if ((!$n_sjsr_StackTrace$StringRE$)) {
    $n_sjsr_StackTrace$StringRE$ = new $c_sjsr_StackTrace$StringRE$().init___()
  };
  return $n_sjsr_StackTrace$StringRE$
}
/** @constructor */
function $c_sjsr_package$() {
  $c_O.call(this)
}
$c_sjsr_package$.prototype = new $h_O();
$c_sjsr_package$.prototype.constructor = $c_sjsr_package$;
/** @constructor */
function $h_sjsr_package$() {
  /*<skip>*/
}
$h_sjsr_package$.prototype = $c_sjsr_package$.prototype;
$c_sjsr_package$.prototype.init___ = (function() {
  return this
});
$c_sjsr_package$.prototype.unwrapJavaScriptException__jl_Throwable__O = (function(th) {
  if ((th instanceof $c_sjs_js_JavaScriptException)) {
    var x2 = $as_sjs_js_JavaScriptException(th);
    var e = x2.exception$4;
    return e
  } else {
    return th
  }
});
$c_sjsr_package$.prototype.wrapJavaScriptException__O__jl_Throwable = (function(e) {
  if ((e instanceof $c_jl_Throwable)) {
    var x2 = $as_jl_Throwable(e);
    return x2
  } else {
    return new $c_sjs_js_JavaScriptException().init___O(e)
  }
});
var $d_sjsr_package$ = new $TypeData().initClass({
  sjsr_package$: 0
}, false, "scala.scalajs.runtime.package$", {
  sjsr_package$: 1,
  O: 1
});
$c_sjsr_package$.prototype.$classData = $d_sjsr_package$;
var $n_sjsr_package$ = (void 0);
function $m_sjsr_package$() {
  if ((!$n_sjsr_package$)) {
    $n_sjsr_package$ = new $c_sjsr_package$().init___()
  };
  return $n_sjsr_package$
}
/** @constructor */
function $c_sr_BoxesRunTime$() {
  $c_O.call(this)
}
$c_sr_BoxesRunTime$.prototype = new $h_O();
$c_sr_BoxesRunTime$.prototype.constructor = $c_sr_BoxesRunTime$;
/** @constructor */
function $h_sr_BoxesRunTime$() {
  /*<skip>*/
}
$h_sr_BoxesRunTime$.prototype = $c_sr_BoxesRunTime$.prototype;
$c_sr_BoxesRunTime$.prototype.init___ = (function() {
  return this
});
$c_sr_BoxesRunTime$.prototype.equalsCharObject__jl_Character__O__Z = (function(xc, y) {
  if ((y instanceof $c_jl_Character)) {
    var x2 = $as_jl_Character(y);
    return (xc.value$1 === x2.value$1)
  } else if ($is_jl_Number(y)) {
    var x3 = $as_jl_Number(y);
    if (((typeof x3) === "number")) {
      var x2$1 = $uD(x3);
      return (x2$1 === xc.value$1)
    } else if ((x3 instanceof $c_sjsr_RuntimeLong)) {
      var t = $uJ(x3);
      var lo = t.lo$2;
      var hi = t.hi$2;
      var value = xc.value$1;
      var hi$1 = (value >> 31);
      return ((lo === value) && (hi === hi$1))
    } else {
      return ((x3 === null) ? (xc === null) : $objectEquals(x3, xc))
    }
  } else {
    return ((xc === null) && (y === null))
  }
});
$c_sr_BoxesRunTime$.prototype.equalsNumObject__jl_Number__O__Z = (function(xn, y) {
  if ($is_jl_Number(y)) {
    var x2 = $as_jl_Number(y);
    return this.equalsNumNum__jl_Number__jl_Number__Z(xn, x2)
  } else if ((y instanceof $c_jl_Character)) {
    var x3 = $as_jl_Character(y);
    if (((typeof xn) === "number")) {
      var x2$1 = $uD(xn);
      return (x2$1 === x3.value$1)
    } else if ((xn instanceof $c_sjsr_RuntimeLong)) {
      var t = $uJ(xn);
      var lo = t.lo$2;
      var hi = t.hi$2;
      var value = x3.value$1;
      var hi$1 = (value >> 31);
      return ((lo === value) && (hi === hi$1))
    } else {
      return ((xn === null) ? (x3 === null) : $objectEquals(xn, x3))
    }
  } else {
    return ((xn === null) ? (y === null) : $objectEquals(xn, y))
  }
});
$c_sr_BoxesRunTime$.prototype.equals__O__O__Z = (function(x, y) {
  if ((x === y)) {
    return true
  } else if ($is_jl_Number(x)) {
    var x2 = $as_jl_Number(x);
    return this.equalsNumObject__jl_Number__O__Z(x2, y)
  } else if ((x instanceof $c_jl_Character)) {
    var x3 = $as_jl_Character(x);
    return this.equalsCharObject__jl_Character__O__Z(x3, y)
  } else {
    return ((x === null) ? (y === null) : $objectEquals(x, y))
  }
});
$c_sr_BoxesRunTime$.prototype.equalsNumNum__jl_Number__jl_Number__Z = (function(xn, yn) {
  if (((typeof xn) === "number")) {
    var x2 = $uD(xn);
    if (((typeof yn) === "number")) {
      var x2$2 = $uD(yn);
      return (x2 === x2$2)
    } else if ((yn instanceof $c_sjsr_RuntimeLong)) {
      var t = $uJ(yn);
      var lo = t.lo$2;
      var hi = t.hi$2;
      return (x2 === $m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toDouble__I__I__D(lo, hi))
    } else if ((yn instanceof $c_s_math_ScalaNumber)) {
      var x4 = $as_s_math_ScalaNumber(yn);
      return x4.equals__O__Z(x2)
    } else {
      return false
    }
  } else if ((xn instanceof $c_sjsr_RuntimeLong)) {
    var t$1 = $uJ(xn);
    var lo$1 = t$1.lo$2;
    var hi$1 = t$1.hi$2;
    if ((yn instanceof $c_sjsr_RuntimeLong)) {
      var t$2 = $uJ(yn);
      var lo$2 = t$2.lo$2;
      var hi$2 = t$2.hi$2;
      return ((lo$1 === lo$2) && (hi$1 === hi$2))
    } else if (((typeof yn) === "number")) {
      var x3$3 = $uD(yn);
      return ($m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toDouble__I__I__D(lo$1, hi$1) === x3$3)
    } else if ((yn instanceof $c_s_math_ScalaNumber)) {
      var x4$2 = $as_s_math_ScalaNumber(yn);
      return x4$2.equals__O__Z(new $c_sjsr_RuntimeLong().init___I__I(lo$1, hi$1))
    } else {
      return false
    }
  } else {
    return ((xn === null) ? (yn === null) : $objectEquals(xn, yn))
  }
});
var $d_sr_BoxesRunTime$ = new $TypeData().initClass({
  sr_BoxesRunTime$: 0
}, false, "scala.runtime.BoxesRunTime$", {
  sr_BoxesRunTime$: 1,
  O: 1
});
$c_sr_BoxesRunTime$.prototype.$classData = $d_sr_BoxesRunTime$;
var $n_sr_BoxesRunTime$ = (void 0);
function $m_sr_BoxesRunTime$() {
  if ((!$n_sr_BoxesRunTime$)) {
    $n_sr_BoxesRunTime$ = new $c_sr_BoxesRunTime$().init___()
  };
  return $n_sr_BoxesRunTime$
}
var $d_sr_Null$ = new $TypeData().initClass({
  sr_Null$: 0
}, false, "scala.runtime.Null$", {
  sr_Null$: 1,
  O: 1
});
/** @constructor */
function $c_sr_RichLong$() {
  $c_O.call(this)
}
$c_sr_RichLong$.prototype = new $h_O();
$c_sr_RichLong$.prototype.constructor = $c_sr_RichLong$;
/** @constructor */
function $h_sr_RichLong$() {
  /*<skip>*/
}
$h_sr_RichLong$.prototype = $c_sr_RichLong$.prototype;
$c_sr_RichLong$.prototype.intValue$extension__J__I = (function($$this) {
  return $$this.lo$2
});
$c_sr_RichLong$.prototype.init___ = (function() {
  return this
});
$c_sr_RichLong$.prototype.floatValue$extension__J__F = (function($$this) {
  return $fround($m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toDouble__I__I__D($$this.lo$2, $$this.hi$2))
});
$c_sr_RichLong$.prototype.equals$extension__J__O__Z = (function($$this, x$1) {
  if ((x$1 instanceof $c_sr_RichLong)) {
    var t = $as_sr_RichLong(x$1).self$1;
    var lo = t.lo$2;
    var hi = t.hi$2;
    return (($$this.lo$2 === lo) && ($$this.hi$2 === hi))
  } else {
    return false
  }
});
$c_sr_RichLong$.prototype.isValidChar$extension__J__Z = (function($$this) {
  var value = (65535 & $$this.lo$2);
  var hi = (value >> 31);
  return ((value === $$this.lo$2) && (hi === $$this.hi$2))
});
$c_sr_RichLong$.prototype.byteValue$extension__J__B = (function($$this) {
  return (($$this.lo$2 << 24) >> 24)
});
$c_sr_RichLong$.prototype.isValidShort$extension__J__Z = (function($$this) {
  var value = (($$this.lo$2 << 16) >> 16);
  var hi = (value >> 31);
  return ((value === $$this.lo$2) && (hi === $$this.hi$2))
});
$c_sr_RichLong$.prototype.doubleValue$extension__J__D = (function($$this) {
  return $m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toDouble__I__I__D($$this.lo$2, $$this.hi$2)
});
$c_sr_RichLong$.prototype.isValidInt$extension__J__Z = (function($$this) {
  var value = $$this.lo$2;
  var hi = (value >> 31);
  return ((value === $$this.lo$2) && (hi === $$this.hi$2))
});
$c_sr_RichLong$.prototype.shortValue$extension__J__S = (function($$this) {
  return (($$this.lo$2 << 16) >> 16)
});
$c_sr_RichLong$.prototype.isValidByte$extension__J__Z = (function($$this) {
  var value = (($$this.lo$2 << 24) >> 24);
  var hi = (value >> 31);
  return ((value === $$this.lo$2) && (hi === $$this.hi$2))
});
var $d_sr_RichLong$ = new $TypeData().initClass({
  sr_RichLong$: 0
}, false, "scala.runtime.RichLong$", {
  sr_RichLong$: 1,
  O: 1
});
$c_sr_RichLong$.prototype.$classData = $d_sr_RichLong$;
var $n_sr_RichLong$ = (void 0);
function $m_sr_RichLong$() {
  if ((!$n_sr_RichLong$)) {
    $n_sr_RichLong$ = new $c_sr_RichLong$().init___()
  };
  return $n_sr_RichLong$
}
/** @constructor */
function $c_sr_ScalaRunTime$() {
  $c_O.call(this)
}
$c_sr_ScalaRunTime$.prototype = new $h_O();
$c_sr_ScalaRunTime$.prototype.constructor = $c_sr_ScalaRunTime$;
/** @constructor */
function $h_sr_ScalaRunTime$() {
  /*<skip>*/
}
$h_sr_ScalaRunTime$.prototype = $c_sr_ScalaRunTime$.prototype;
$c_sr_ScalaRunTime$.prototype.init___ = (function() {
  return this
});
$c_sr_ScalaRunTime$.prototype.array$undlength__O__I = (function(xs) {
  if ($isArrayOf_O(xs, 1)) {
    var x2 = $asArrayOf_O(xs, 1);
    return x2.u.length
  } else if ($isArrayOf_I(xs, 1)) {
    var x3 = $asArrayOf_I(xs, 1);
    return x3.u.length
  } else if ($isArrayOf_D(xs, 1)) {
    var x4 = $asArrayOf_D(xs, 1);
    return x4.u.length
  } else if ($isArrayOf_J(xs, 1)) {
    var x5 = $asArrayOf_J(xs, 1);
    return x5.u.length
  } else if ($isArrayOf_F(xs, 1)) {
    var x6 = $asArrayOf_F(xs, 1);
    return x6.u.length
  } else if ($isArrayOf_C(xs, 1)) {
    var x7 = $asArrayOf_C(xs, 1);
    return x7.u.length
  } else if ($isArrayOf_B(xs, 1)) {
    var x8 = $asArrayOf_B(xs, 1);
    return x8.u.length
  } else if ($isArrayOf_S(xs, 1)) {
    var x9 = $asArrayOf_S(xs, 1);
    return x9.u.length
  } else if ($isArrayOf_Z(xs, 1)) {
    var x10 = $asArrayOf_Z(xs, 1);
    return x10.u.length
  } else if ($isArrayOf_sr_BoxedUnit(xs, 1)) {
    var x11 = $asArrayOf_sr_BoxedUnit(xs, 1);
    return x11.u.length
  } else if ((xs === null)) {
    throw new $c_jl_NullPointerException().init___()
  } else {
    throw new $c_s_MatchError().init___O(xs)
  }
});
$c_sr_ScalaRunTime$.prototype.array$undupdate__O__I__O__V = (function(xs, idx, value) {
  if ($isArrayOf_O(xs, 1)) {
    var x2 = $asArrayOf_O(xs, 1);
    x2.set(idx, value)
  } else if ($isArrayOf_I(xs, 1)) {
    var x3 = $asArrayOf_I(xs, 1);
    x3.set(idx, $uI(value))
  } else if ($isArrayOf_D(xs, 1)) {
    var x4 = $asArrayOf_D(xs, 1);
    x4.set(idx, $uD(value))
  } else if ($isArrayOf_J(xs, 1)) {
    var x5 = $asArrayOf_J(xs, 1);
    x5.set(idx, $uJ(value))
  } else if ($isArrayOf_F(xs, 1)) {
    var x6 = $asArrayOf_F(xs, 1);
    x6.set(idx, $uF(value))
  } else if ($isArrayOf_C(xs, 1)) {
    var x7 = $asArrayOf_C(xs, 1);
    if ((value === null)) {
      var jsx$1 = 0
    } else {
      var this$2 = $as_jl_Character(value);
      var jsx$1 = this$2.value$1
    };
    x7.set(idx, jsx$1)
  } else if ($isArrayOf_B(xs, 1)) {
    var x8 = $asArrayOf_B(xs, 1);
    x8.set(idx, $uB(value))
  } else if ($isArrayOf_S(xs, 1)) {
    var x9 = $asArrayOf_S(xs, 1);
    x9.set(idx, $uS(value))
  } else if ($isArrayOf_Z(xs, 1)) {
    var x10 = $asArrayOf_Z(xs, 1);
    x10.set(idx, $uZ(value))
  } else if ($isArrayOf_sr_BoxedUnit(xs, 1)) {
    var x11 = $asArrayOf_sr_BoxedUnit(xs, 1);
    x11.set(idx, (void 0))
  } else if ((xs === null)) {
    throw new $c_jl_NullPointerException().init___()
  } else {
    throw new $c_s_MatchError().init___O(xs)
  }
});
$c_sr_ScalaRunTime$.prototype.$$undtoString__s_Product__T = (function(x) {
  var this$1 = x.productIterator__sc_Iterator();
  var start = (x.productPrefix__T() + "(");
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this$1, start, ",", ")")
});
$c_sr_ScalaRunTime$.prototype.array$undapply__O__I__O = (function(xs, idx) {
  if ($isArrayOf_O(xs, 1)) {
    var x2 = $asArrayOf_O(xs, 1);
    return x2.get(idx)
  } else if ($isArrayOf_I(xs, 1)) {
    var x3 = $asArrayOf_I(xs, 1);
    return x3.get(idx)
  } else if ($isArrayOf_D(xs, 1)) {
    var x4 = $asArrayOf_D(xs, 1);
    return x4.get(idx)
  } else if ($isArrayOf_J(xs, 1)) {
    var x5 = $asArrayOf_J(xs, 1);
    return x5.get(idx)
  } else if ($isArrayOf_F(xs, 1)) {
    var x6 = $asArrayOf_F(xs, 1);
    return x6.get(idx)
  } else if ($isArrayOf_C(xs, 1)) {
    var x7 = $asArrayOf_C(xs, 1);
    var c = x7.get(idx);
    return new $c_jl_Character().init___C(c)
  } else if ($isArrayOf_B(xs, 1)) {
    var x8 = $asArrayOf_B(xs, 1);
    return x8.get(idx)
  } else if ($isArrayOf_S(xs, 1)) {
    var x9 = $asArrayOf_S(xs, 1);
    return x9.get(idx)
  } else if ($isArrayOf_Z(xs, 1)) {
    var x10 = $asArrayOf_Z(xs, 1);
    return x10.get(idx)
  } else if ($isArrayOf_sr_BoxedUnit(xs, 1)) {
    var x11 = $asArrayOf_sr_BoxedUnit(xs, 1);
    return x11.get(idx)
  } else if ((xs === null)) {
    throw new $c_jl_NullPointerException().init___()
  } else {
    throw new $c_s_MatchError().init___O(xs)
  }
});
var $d_sr_ScalaRunTime$ = new $TypeData().initClass({
  sr_ScalaRunTime$: 0
}, false, "scala.runtime.ScalaRunTime$", {
  sr_ScalaRunTime$: 1,
  O: 1
});
$c_sr_ScalaRunTime$.prototype.$classData = $d_sr_ScalaRunTime$;
var $n_sr_ScalaRunTime$ = (void 0);
function $m_sr_ScalaRunTime$() {
  if ((!$n_sr_ScalaRunTime$)) {
    $n_sr_ScalaRunTime$ = new $c_sr_ScalaRunTime$().init___()
  };
  return $n_sr_ScalaRunTime$
}
/** @constructor */
function $c_sr_Statics$() {
  $c_O.call(this)
}
$c_sr_Statics$.prototype = new $h_O();
$c_sr_Statics$.prototype.constructor = $c_sr_Statics$;
/** @constructor */
function $h_sr_Statics$() {
  /*<skip>*/
}
$h_sr_Statics$.prototype = $c_sr_Statics$.prototype;
$c_sr_Statics$.prototype.init___ = (function() {
  return this
});
$c_sr_Statics$.prototype.mixLast__I__I__I = (function(hash, data) {
  var k = data;
  k = $imul((-862048943), k);
  var i = k;
  k = ((i << 15) | ((i >>> 17) | 0));
  k = $imul(461845907, k);
  return (hash ^ k)
});
$c_sr_Statics$.prototype.doubleHash__D__I = (function(dv) {
  var iv = $doubleToInt(dv);
  if ((iv === dv)) {
    return iv
  } else {
    var this$1 = $m_sjsr_RuntimeLong$();
    var lo = this$1.scala$scalajs$runtime$RuntimeLong$$fromDoubleImpl__D__I(dv);
    var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
    return (($m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toDouble__I__I__D(lo, hi) === dv) ? (lo ^ hi) : $m_sjsr_Bits$().numberHashCode__D__I(dv))
  }
});
$c_sr_Statics$.prototype.anyHash__O__I = (function(x) {
  if ((x === null)) {
    return 0
  } else if (((typeof x) === "number")) {
    var x3 = $uD(x);
    return this.doubleHash__D__I(x3)
  } else if ((x instanceof $c_sjsr_RuntimeLong)) {
    var t = $uJ(x);
    var lo = t.lo$2;
    var hi = t.hi$2;
    return this.longHash__J__I(new $c_sjsr_RuntimeLong().init___I__I(lo, hi))
  } else {
    return $objectHashCode(x)
  }
});
$c_sr_Statics$.prototype.avalanche__I__I = (function(h0) {
  var h = h0;
  h = (h ^ ((h >>> 16) | 0));
  h = $imul((-2048144789), h);
  h = (h ^ ((h >>> 13) | 0));
  h = $imul((-1028477387), h);
  h = (h ^ ((h >>> 16) | 0));
  return h
});
$c_sr_Statics$.prototype.mix__I__I__I = (function(hash, data) {
  var h = this.mixLast__I__I__I(hash, data);
  var i = h;
  h = ((i << 13) | ((i >>> 19) | 0));
  return (((-430675100) + $imul(5, h)) | 0)
});
$c_sr_Statics$.prototype.longHash__J__I = (function(lv) {
  var lo = lv.lo$2;
  var lo$1 = lv.hi$2;
  return ((lo$1 === (lo >> 31)) ? lo : (lo ^ lo$1))
});
$c_sr_Statics$.prototype.finalizeHash__I__I__I = (function(hash, length) {
  return this.avalanche__I__I((hash ^ length))
});
var $d_sr_Statics$ = new $TypeData().initClass({
  sr_Statics$: 0
}, false, "scala.runtime.Statics$", {
  sr_Statics$: 1,
  O: 1
});
$c_sr_Statics$.prototype.$classData = $d_sr_Statics$;
var $n_sr_Statics$ = (void 0);
function $m_sr_Statics$() {
  if ((!$n_sr_Statics$)) {
    $n_sr_Statics$ = new $c_sr_Statics$().init___()
  };
  return $n_sr_Statics$
}
/** @constructor */
function $c_Lamf_AMFStyle$() {
  $c_O.call(this)
}
$c_Lamf_AMFStyle$.prototype = new $h_O();
$c_Lamf_AMFStyle$.prototype.constructor = $c_Lamf_AMFStyle$;
/** @constructor */
function $h_Lamf_AMFStyle$() {
  /*<skip>*/
}
$h_Lamf_AMFStyle$.prototype = $c_Lamf_AMFStyle$.prototype;
$c_Lamf_AMFStyle$.prototype.init___ = (function() {
  return this
});
$c_Lamf_AMFStyle$.prototype.profileName__Lamf_ProfileName = (function() {
  return $m_Lamf_AmfProfile$()
});
var $d_Lamf_AMFStyle$ = new $TypeData().initClass({
  Lamf_AMFStyle$: 0
}, false, "amf.AMFStyle$", {
  Lamf_AMFStyle$: 1,
  O: 1,
  Lamf_MessageStyle: 1
});
$c_Lamf_AMFStyle$.prototype.$classData = $d_Lamf_AMFStyle$;
var $n_Lamf_AMFStyle$ = (void 0);
function $m_Lamf_AMFStyle$() {
  if ((!$n_Lamf_AMFStyle$)) {
    $n_Lamf_AMFStyle$ = new $c_Lamf_AMFStyle$().init___()
  };
  return $n_Lamf_AMFStyle$
}
/** @constructor */
function $c_Lamf_AsyncStyle$() {
  $c_O.call(this)
}
$c_Lamf_AsyncStyle$.prototype = new $h_O();
$c_Lamf_AsyncStyle$.prototype.constructor = $c_Lamf_AsyncStyle$;
/** @constructor */
function $h_Lamf_AsyncStyle$() {
  /*<skip>*/
}
$h_Lamf_AsyncStyle$.prototype = $c_Lamf_AsyncStyle$.prototype;
$c_Lamf_AsyncStyle$.prototype.init___ = (function() {
  return this
});
$c_Lamf_AsyncStyle$.prototype.profileName__Lamf_ProfileName = (function() {
  return $m_Lamf_AsyncProfile$()
});
var $d_Lamf_AsyncStyle$ = new $TypeData().initClass({
  Lamf_AsyncStyle$: 0
}, false, "amf.AsyncStyle$", {
  Lamf_AsyncStyle$: 1,
  O: 1,
  Lamf_MessageStyle: 1
});
$c_Lamf_AsyncStyle$.prototype.$classData = $d_Lamf_AsyncStyle$;
var $n_Lamf_AsyncStyle$ = (void 0);
function $m_Lamf_AsyncStyle$() {
  if ((!$n_Lamf_AsyncStyle$)) {
    $n_Lamf_AsyncStyle$ = new $c_Lamf_AsyncStyle$().init___()
  };
  return $n_Lamf_AsyncStyle$
}
/** @constructor */
function $c_Lamf_Core$() {
  $c_O.call(this);
  this.platform$1 = null
}
$c_Lamf_Core$.prototype = new $h_O();
$c_Lamf_Core$.prototype.constructor = $c_Lamf_Core$;
/** @constructor */
function $h_Lamf_Core$() {
  /*<skip>*/
}
$h_Lamf_Core$.prototype = $c_Lamf_Core$.prototype;
$c_Lamf_Core$.prototype.$$js$exported$meth$loadValidationProfile__T__Lamf_client_environment_Environment__O = (function(url, env) {
  return $m_Lamf_client_validate_Validator$().loadValidationProfile__T__Lamf_client_environment_Environment__sjs_js_Promise(url, env)
});
$c_Lamf_Core$.prototype.init___ = (function() {
  $n_Lamf_Core$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_Core$.prototype.$$js$exported$meth$validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__O = (function(model, profileName, messageStyle, env) {
  return $m_Lamf_client_validate_Validator$().validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__Z__sjs_js_Promise(model, profileName, messageStyle, env, false)
});
$c_Lamf_Core$.prototype.$$js$exported$meth$validateResolved__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__O = (function(model, profileName, messageStyle, env) {
  return $m_Lamf_client_validate_Validator$().validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__Z__sjs_js_Promise(model, profileName, messageStyle, env, true)
});
$c_Lamf_Core$.prototype.$$js$exported$meth$init__Lamf_client_execution_BaseExecutionEnvironment__O = (function(exec) {
  return this.init__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise(exec)
});
$c_Lamf_Core$.prototype.$$js$exported$meth$generator__T__T__Lamf_client_environment_Environment__O = (function(vendor, mediaType, env) {
  return this.generator__T__T__Lamf_client_environment_Environment__Lamf_client_render_Renderer(vendor, mediaType, env)
});
$c_Lamf_Core$.prototype.generator__T__T__Lamf_client_environment_Environment__Lamf_client_render_Renderer = (function(vendor, mediaType, env) {
  return new $c_Lamf_client_render_Renderer().init___T__T__s_Option(vendor, mediaType, new $c_s_Some().init___O(env))
});
$c_Lamf_Core$.prototype.$$js$exported$meth$generator__T__T__O = (function(vendor, mediaType) {
  return new $c_Lamf_client_render_Renderer().init___T__T__s_Option(vendor, mediaType, $m_s_None$())
});
$c_Lamf_Core$.prototype.$$js$exported$meth$init__O = (function() {
  return this.init__sjs_js_Promise()
});
$c_Lamf_Core$.prototype.$$js$exported$meth$parser__T__T__O = (function(vendor, mediaType) {
  return new $c_Lamf_client_parse_Parser().init___T__T__s_Option(vendor, mediaType, $m_s_None$())
});
$c_Lamf_Core$.prototype.$$js$exported$meth$validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__O = (function(model, profileName, messageStyle) {
  var env = $m_Lamf_client_environment_DefaultEnvironment$().apply__Lamf_client_environment_Environment();
  return $m_Lamf_client_validate_Validator$().validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__Z__sjs_js_Promise(model, profileName, messageStyle, env, false)
});
$c_Lamf_Core$.prototype.registerNamespace__T__T__Z = (function(alias, prefix) {
  return $m_Lamf_core_vocabulary_Namespace$().registerNamespace__T__T__s_Option(alias, prefix).isDefined__Z()
});
$c_Lamf_Core$.prototype.init__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise = (function(exec) {
  var executionContext = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  $m_Lamf_client_convert_CoreRegister$().register__Lamf_core_remote_Platform__V(this.platform$1);
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = $m_Lamf_core_AMF$().init__s_concurrent_ExecutionContext__s_concurrent_Future(executionContext);
  var m = $m_Lamf_client_convert_CoreClientConverters$().UnitMatcher__Lamf_client_convert_CoreBaseConverter$UnitMatcher$();
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$1, from, m, executionContext).asClient__O()
});
$c_Lamf_Core$.prototype.$$js$exported$meth$loadValidationProfile__T__O = (function(url) {
  var env = $m_Lamf_client_environment_DefaultEnvironment$().apply__Lamf_client_environment_Environment();
  return $m_Lamf_client_validate_Validator$().loadValidationProfile__T__Lamf_client_environment_Environment__sjs_js_Promise(url, env)
});
$c_Lamf_Core$.prototype.$$js$exported$meth$registerNamespace__T__T__O = (function(alias, prefix) {
  return this.registerNamespace__T__T__Z(alias, prefix)
});
$c_Lamf_Core$.prototype.$$js$exported$meth$registerPlugin__Lamf_client_plugins_AMFPlugin__O = (function(plugin) {
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V(plugin)
});
$c_Lamf_Core$.prototype.$$js$exported$meth$emitShapesGraph__Lamf_ProfileName__O = (function(profileName) {
  var this$2 = $m_Lamf_core_services_RuntimeValidator$();
  return this$2.validator__p1__Lamf_core_services_RuntimeValidator().emitShapesGraph__Lamf_ProfileName__T(profileName)
});
$c_Lamf_Core$.prototype.parser__T__T__Lamf_client_environment_Environment__Lamf_client_parse_Parser = (function(vendor, mediaType, env) {
  return new $c_Lamf_client_parse_Parser().init___T__T__s_Option(vendor, mediaType, new $c_s_Some().init___O(env))
});
$c_Lamf_Core$.prototype.$$js$exported$meth$resolver__T__O = (function(vendor) {
  return new $c_Lamf_client_resolve_Resolver().init___T(vendor)
});
$c_Lamf_Core$.prototype.$$js$exported$meth$validateResolved__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__O = (function(model, profileName, messageStyle) {
  var env = $m_Lamf_client_environment_DefaultEnvironment$().apply__Lamf_client_environment_Environment();
  return $m_Lamf_client_validate_Validator$().validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__Z__sjs_js_Promise(model, profileName, messageStyle, env, true)
});
$c_Lamf_Core$.prototype.init__sjs_js_Promise = (function() {
  var this$1 = this.platform$1;
  return this.init__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise(this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment())
});
$c_Lamf_Core$.prototype.$$js$exported$meth$parser__T__T__Lamf_client_environment_Environment__O = (function(vendor, mediaType, env) {
  return this.parser__T__T__Lamf_client_environment_Environment__Lamf_client_parse_Parser(vendor, mediaType, env)
});
$c_Lamf_Core$.prototype.registerPlugin = (function(arg) {
  var prep = $as_Lamf_client_plugins_AMFPlugin(arg);
  return this.$$js$exported$meth$registerPlugin__Lamf_client_plugins_AMFPlugin__O(prep)
});
$c_Lamf_Core$.prototype.registerNamespace = (function(arg, arg$2) {
  var prep = $as_T(arg);
  var prep$2 = $as_T(arg$2);
  return this.$$js$exported$meth$registerNamespace__T__T__O(prep, prep$2)
});
$c_Lamf_Core$.prototype.emitShapesGraph = (function(arg) {
  var prep = $as_Lamf_ProfileName(arg);
  return this.$$js$exported$meth$emitShapesGraph__Lamf_ProfileName__O(prep)
});
$c_Lamf_Core$.prototype.loadValidationProfile = (function(arg) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 1;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      var prep = $as_T(arg);
      return this.$$js$exported$meth$loadValidationProfile__T__O(prep);
      break
    }
    case 1: {
      var prep$2 = $as_T(arg);
      var prep$3 = $as_Lamf_client_environment_Environment(rest[0]);
      return this.$$js$exported$meth$loadValidationProfile__T__Lamf_client_environment_Environment__O(prep$2, prep$3);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_Core$.prototype.validateResolved = (function(arg, arg$2, arg$3) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 3;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      var prep = $as_Lamf_client_model_document_BaseUnit(arg);
      var prep$2 = $as_Lamf_ProfileName(arg$2);
      var prep$3 = $as_Lamf_MessageStyle(arg$3);
      return this.$$js$exported$meth$validateResolved__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__O(prep, prep$2, prep$3);
      break
    }
    case 1: {
      var prep$4 = $as_Lamf_client_model_document_BaseUnit(arg);
      var prep$5 = $as_Lamf_ProfileName(arg$2);
      var prep$6 = $as_Lamf_MessageStyle(arg$3);
      var prep$7 = $as_Lamf_client_environment_Environment(rest[0]);
      return this.$$js$exported$meth$validateResolved__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__O(prep$4, prep$5, prep$6, prep$7);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_Core$.prototype.validate = (function(arg, arg$2, arg$3) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 3;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      var prep = $as_Lamf_client_model_document_BaseUnit(arg);
      var prep$2 = $as_Lamf_ProfileName(arg$2);
      var prep$3 = $as_Lamf_MessageStyle(arg$3);
      return this.$$js$exported$meth$validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__O(prep, prep$2, prep$3);
      break
    }
    case 1: {
      var prep$4 = $as_Lamf_client_model_document_BaseUnit(arg);
      var prep$5 = $as_Lamf_ProfileName(arg$2);
      var prep$6 = $as_Lamf_MessageStyle(arg$3);
      var prep$7 = $as_Lamf_client_environment_Environment(rest[0]);
      return this.$$js$exported$meth$validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__O(prep$4, prep$5, prep$6, prep$7);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_Core$.prototype.resolver = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$resolver__T__O(prep)
});
$c_Lamf_Core$.prototype.generator = (function(arg, arg$2) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 2;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      var prep = $as_T(arg);
      var prep$2 = $as_T(arg$2);
      return this.$$js$exported$meth$generator__T__T__O(prep, prep$2);
      break
    }
    case 1: {
      var prep$3 = $as_T(arg);
      var prep$4 = $as_T(arg$2);
      var prep$5 = $as_Lamf_client_environment_Environment(rest[0]);
      return this.$$js$exported$meth$generator__T__T__Lamf_client_environment_Environment__O(prep$3, prep$4, prep$5);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_Core$.prototype.parser = (function(arg, arg$2) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 2;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_T(arg);
      var prep$2 = $as_T(arg$2);
      var prep$3 = $as_Lamf_client_environment_Environment(rest[0]);
      return this.$$js$exported$meth$parser__T__T__Lamf_client_environment_Environment__O(prep, prep$2, prep$3);
      break
    }
    case 0: {
      var prep$4 = $as_T(arg);
      var prep$5 = $as_T(arg$2);
      return this.$$js$exported$meth$parser__T__T__O(prep$4, prep$5);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_Core$.prototype.init = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      return this.$$js$exported$meth$init__O();
      break
    }
    case 1: {
      var prep = $as_Lamf_client_execution_BaseExecutionEnvironment(rest[0]);
      return this.$$js$exported$meth$init__Lamf_client_execution_BaseExecutionEnvironment__O(prep);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
var $d_Lamf_Core$ = new $TypeData().initClass({
  Lamf_Core$: 0
}, false, "amf.Core$", {
  Lamf_Core$: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_Core$.prototype.$classData = $d_Lamf_Core$;
var $n_Lamf_Core$ = (void 0);
function $m_Lamf_Core$() {
  if ((!$n_Lamf_Core$)) {
    $n_Lamf_Core$ = new $c_Lamf_Core$().init___()
  };
  return $n_Lamf_Core$
}
/** @constructor */
function $c_Lamf_Main$() {
  $c_O.call(this);
  this.platform$1 = null
}
$c_Lamf_Main$.prototype = new $h_O();
$c_Lamf_Main$.prototype.constructor = $c_Lamf_Main$;
/** @constructor */
function $h_Lamf_Main$() {
  /*<skip>*/
}
$h_Lamf_Main$.prototype = $c_Lamf_Main$.prototype;
$c_Lamf_Main$.prototype.init___ = (function() {
  $n_Lamf_Main$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_Main$.prototype.$$js$exported$meth$failPromise__O__O = (function(e) {
  this.failPromise__O__V(e)
});
$c_Lamf_Main$.prototype.runParse__Lamf_core_client_ParserConfig__s_concurrent_Future = (function(config) {
  var platform = this.platform$1;
  return new $c_Lamf_client_commands_ParseCommand().init___Lamf_core_remote_Platform(platform).run__Lamf_core_client_ParserConfig__s_concurrent_Future(config)
});
$c_Lamf_Main$.prototype.$$js$exported$meth$runValidate__Lamf_core_client_ParserConfig__O = (function(config) {
  return this.runValidate__Lamf_core_client_ParserConfig__s_concurrent_Future(config)
});
$c_Lamf_Main$.prototype.$$js$exported$meth$runParse__Lamf_core_client_ParserConfig__O = (function(config) {
  return this.runParse__Lamf_core_client_ParserConfig__s_concurrent_Future(config)
});
$c_Lamf_Main$.prototype.$$js$exported$meth$runPatch__Lamf_core_client_ParserConfig__O = (function(config) {
  return this.runPatch__Lamf_core_client_ParserConfig__s_concurrent_Future(config)
});
$c_Lamf_Main$.prototype.$$js$exported$meth$main__sjs_js_Array__O = (function(rawArgs) {
  return this.main__sjs_js_Array__sjs_js_Promise(rawArgs)
});
$c_Lamf_Main$.prototype.$$js$exported$meth$runTranslate__Lamf_core_client_ParserConfig__O = (function(config) {
  return this.runTranslate__Lamf_core_client_ParserConfig__s_concurrent_Future(config)
});
$c_Lamf_Main$.prototype.enableTracing__p1__Lamf_core_client_ParserConfig__O = (function(cfg) {
  if (cfg.trace$1) {
    var this$2 = $m_s_Console$();
    var this$3 = $as_Ljava_io_PrintStream(this$2.outVar$2.v$1);
    this$3.java$lang$JSConsoleBasedPrintStream$$printString__T__V("Enabling tracing!\n");
    return $m_Lamf_core_benchmark_ExecutionLog$().start__Lamf_core_benchmark_ExecutionLog$()
  } else {
    return (void 0)
  }
});
$c_Lamf_Main$.prototype.failPromise__O__V = (function(e) {
  $m_jl_System$().err$1.println__T__V("Exception");
  var this$1 = $m_jl_System$().err$1;
  this$1.java$lang$JSConsoleBasedPrintStream$$printString__T__V((e + "\n"));
  var jsx$1 = $g.process;
  var value = $m_Lamf_core_client_ExitCodes$().WrongInvocation$1;
  jsx$1.exit(value)
});
$c_Lamf_Main$.prototype.runPatch__Lamf_core_client_ParserConfig__s_concurrent_Future = (function(config) {
  var platform = this.platform$1;
  return new $c_Lamf_client_commands_PatchCommand().init___Lamf_core_remote_Platform(platform).run__Lamf_core_client_ParserConfig__s_concurrent_Future(config)
});
$c_Lamf_Main$.prototype.runTranslate__Lamf_core_client_ParserConfig__s_concurrent_Future = (function(config) {
  var platform = this.platform$1;
  return new $c_Lamf_client_commands_TranslateCommand().init___Lamf_core_remote_Platform(platform).run__Lamf_core_client_ParserConfig__s_concurrent_Future(config)
});
$c_Lamf_Main$.prototype.runValidate__Lamf_core_client_ParserConfig__s_concurrent_Future = (function(config) {
  var platform = this.platform$1;
  return new $c_Lamf_client_commands_ValidateCommand().init___Lamf_core_remote_Platform(platform).run__Lamf_core_client_ParserConfig__s_concurrent_Future(config)
});
$c_Lamf_Main$.prototype.$$js$exported$meth$failCommand__O = (function() {
  this.failCommand__V()
});
$c_Lamf_Main$.prototype.main__sjs_js_Array__sjs_js_Promise = (function(rawArgs) {
  var len = $uI(rawArgs.length);
  var result = $newArrayObject($d_T.getArrayOf(), [len]);
  var len$1 = result.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(rawArgs.length);
  var x$1 = ((x < len$1) ? x : len$1);
  var that = result.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    result.set(jsx$1, rawArgs[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  var x1 = $m_Lamf_client_commands_CmdLineParser$().parse__AT__s_Option(result);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var cfg = $as_Lamf_core_client_ParserConfig(x2.value$2);
    this.enableTracing__p1__Lamf_core_client_ParserConfig__O(cfg);
    var rc18 = false;
    var x2$2 = null;
    var x1$2 = cfg.mode$1;
    if ((x1$2 instanceof $c_s_Some)) {
      rc18 = true;
      x2$2 = $as_s_Some(x1$2);
      var p3 = $as_T(x2$2.value$2);
      if (($m_Lamf_core_client_ParserConfig$().REPL$1 === p3)) {
        var this$12 = $m_s_Console$();
        var this$13 = $as_Ljava_io_PrintStream(this$12.outVar$2.v$1);
        this$13.java$lang$JSConsoleBasedPrintStream$$printString__T__V("REPL not supported in the JS client yet\n");
        this.failCommand__V();
        throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Error executing AMF"))
      }
    };
    if (rc18) {
      var p5 = $as_T(x2$2.value$2);
      if (($m_Lamf_core_client_ParserConfig$().TRANSLATE$1 === p5)) {
        var f = this.runTranslate__Lamf_core_client_ParserConfig__s_concurrent_Future(cfg);
        f.failed__s_concurrent_Future().foreach__F1__s_concurrent_ExecutionContext__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(e$2) {
            var e = $as_jl_Throwable(e$2);
            $m_Lamf_Main$().failPromise__O__V(e)
          })
        })(this)), $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext());
        return $m_sjs_js_JSConverters$JSRichFuture$().toJSPromise$extension__s_concurrent_Future__s_concurrent_ExecutionContext__sjs_js_Promise(f, $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext())
      }
    };
    if (rc18) {
      var p7 = $as_T(x2$2.value$2);
      if (($m_Lamf_core_client_ParserConfig$().VALIDATE$1 === p7)) {
        var f$2 = this.runValidate__Lamf_core_client_ParserConfig__s_concurrent_Future(cfg);
        f$2.failed__s_concurrent_Future().foreach__F1__s_concurrent_ExecutionContext__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
          return (function(e$3$2) {
            var e$3 = $as_jl_Throwable(e$3$2);
            $m_Lamf_Main$().failPromise__O__V(e$3)
          })
        })(this)), $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext());
        return $m_sjs_js_JSConverters$JSRichFuture$().toJSPromise$extension__s_concurrent_Future__s_concurrent_ExecutionContext__sjs_js_Promise(f$2, $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext())
      }
    };
    if (rc18) {
      var p9 = $as_T(x2$2.value$2);
      if (($m_Lamf_core_client_ParserConfig$().PARSE$1 === p9)) {
        var f$3 = this.runParse__Lamf_core_client_ParserConfig__s_concurrent_Future(cfg);
        f$3.failed__s_concurrent_Future().foreach__F1__s_concurrent_ExecutionContext__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
          return (function(e$4$2) {
            var e$4 = $as_jl_Throwable(e$4$2);
            $m_Lamf_Main$().failPromise__O__V(e$4)
          })
        })(this)), $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext());
        var f$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
          return (function(r$2) {
            var r = $as_s_util_Try(r$2);
            var this$17 = $m_s_Console$();
            var this$18 = $as_Ljava_io_PrintStream(this$17.outVar$2.v$1);
            this$18.java$lang$JSConsoleBasedPrintStream$$printString__T__V("... composing...\n");
            $m_Lamf_core_benchmark_ExecutionLog$().finish__Lamf_core_benchmark_ExecutionLog$().buildReport__V();
            return r
          })
        })(this));
        var executor = $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext();
        var composed = $f_s_concurrent_impl_Promise__transform__F1__s_concurrent_ExecutionContext__s_concurrent_Future(f$3, f$1, executor);
        return $m_sjs_js_JSConverters$JSRichFuture$().toJSPromise$extension__s_concurrent_Future__s_concurrent_ExecutionContext__sjs_js_Promise(composed, $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext())
      }
    };
    if (rc18) {
      var p11 = $as_T(x2$2.value$2);
      if (($m_Lamf_core_client_ParserConfig$().PATCH$1 === p11)) {
        var f$4 = this.runPatch__Lamf_core_client_ParserConfig__s_concurrent_Future(cfg);
        f$4.failed__s_concurrent_Future().foreach__F1__s_concurrent_ExecutionContext__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1) {
          return (function(e$5$2) {
            var e$5 = $as_jl_Throwable(e$5$2);
            $m_Lamf_Main$().failPromise__O__V(e$5)
          })
        })(this)), $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext());
        return $m_sjs_js_JSConverters$JSRichFuture$().toJSPromise$extension__s_concurrent_Future__s_concurrent_ExecutionContext__sjs_js_Promise(f$4, $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext())
      }
    };
    this.failCommand__V();
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Error executing AMF"))
  } else {
    var jsx$2 = $g.process;
    var value = $m_Lamf_core_client_ExitCodes$().WrongInvocation$1;
    jsx$2.exit(value);
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Error executing AMF"))
  }
});
$c_Lamf_Main$.prototype.failCommand__V = (function() {
  $m_jl_System$().err$1.println__T__V("Wrong command");
  var jsx$1 = $g.process;
  var value = $m_Lamf_core_client_ExitCodes$().WrongInvocation$1;
  jsx$1.exit(value)
});
$c_Lamf_Main$.prototype.runPatch = (function(arg) {
  var prep = $as_Lamf_core_client_ParserConfig(arg);
  return this.$$js$exported$meth$runPatch__Lamf_core_client_ParserConfig__O(prep)
});
$c_Lamf_Main$.prototype.runParse = (function(arg) {
  var prep = $as_Lamf_core_client_ParserConfig(arg);
  return this.$$js$exported$meth$runParse__Lamf_core_client_ParserConfig__O(prep)
});
$c_Lamf_Main$.prototype.runValidate = (function(arg) {
  var prep = $as_Lamf_core_client_ParserConfig(arg);
  return this.$$js$exported$meth$runValidate__Lamf_core_client_ParserConfig__O(prep)
});
$c_Lamf_Main$.prototype.runTranslate = (function(arg) {
  var prep = $as_Lamf_core_client_ParserConfig(arg);
  return this.$$js$exported$meth$runTranslate__Lamf_core_client_ParserConfig__O(prep)
});
$c_Lamf_Main$.prototype.failPromise = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$failPromise__O__O(prep)
});
$c_Lamf_Main$.prototype.failCommand = (function() {
  return this.$$js$exported$meth$failCommand__O()
});
$c_Lamf_Main$.prototype.main = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$main__sjs_js_Array__O(prep)
});
var $d_Lamf_Main$ = new $TypeData().initClass({
  Lamf_Main$: 0
}, false, "amf.Main$", {
  Lamf_Main$: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_Main$.prototype.$classData = $d_Lamf_Main$;
var $n_Lamf_Main$ = (void 0);
function $m_Lamf_Main$() {
  if ((!$n_Lamf_Main$)) {
    $n_Lamf_Main$ = new $c_Lamf_Main$().init___()
  };
  return $n_Lamf_Main$
}
/** @constructor */
function $c_Lamf_OASStyle$() {
  $c_O.call(this)
}
$c_Lamf_OASStyle$.prototype = new $h_O();
$c_Lamf_OASStyle$.prototype.constructor = $c_Lamf_OASStyle$;
/** @constructor */
function $h_Lamf_OASStyle$() {
  /*<skip>*/
}
$h_Lamf_OASStyle$.prototype = $c_Lamf_OASStyle$.prototype;
$c_Lamf_OASStyle$.prototype.init___ = (function() {
  return this
});
$c_Lamf_OASStyle$.prototype.profileName__Lamf_ProfileName = (function() {
  return $m_Lamf_OasProfile$()
});
var $d_Lamf_OASStyle$ = new $TypeData().initClass({
  Lamf_OASStyle$: 0
}, false, "amf.OASStyle$", {
  Lamf_OASStyle$: 1,
  O: 1,
  Lamf_MessageStyle: 1
});
$c_Lamf_OASStyle$.prototype.$classData = $d_Lamf_OASStyle$;
var $n_Lamf_OASStyle$ = (void 0);
function $m_Lamf_OASStyle$() {
  if ((!$n_Lamf_OASStyle$)) {
    $n_Lamf_OASStyle$ = new $c_Lamf_OASStyle$().init___()
  };
  return $n_Lamf_OASStyle$
}
/** @constructor */
function $c_Lamf_RAMLStyle$() {
  $c_O.call(this)
}
$c_Lamf_RAMLStyle$.prototype = new $h_O();
$c_Lamf_RAMLStyle$.prototype.constructor = $c_Lamf_RAMLStyle$;
/** @constructor */
function $h_Lamf_RAMLStyle$() {
  /*<skip>*/
}
$h_Lamf_RAMLStyle$.prototype = $c_Lamf_RAMLStyle$.prototype;
$c_Lamf_RAMLStyle$.prototype.init___ = (function() {
  return this
});
$c_Lamf_RAMLStyle$.prototype.profileName__Lamf_ProfileName = (function() {
  return $m_Lamf_RamlProfile$()
});
var $d_Lamf_RAMLStyle$ = new $TypeData().initClass({
  Lamf_RAMLStyle$: 0
}, false, "amf.RAMLStyle$", {
  Lamf_RAMLStyle$: 1,
  O: 1,
  Lamf_MessageStyle: 1
});
$c_Lamf_RAMLStyle$.prototype.$classData = $d_Lamf_RAMLStyle$;
var $n_Lamf_RAMLStyle$ = (void 0);
function $m_Lamf_RAMLStyle$() {
  if ((!$n_Lamf_RAMLStyle$)) {
    $n_Lamf_RAMLStyle$ = new $c_Lamf_RAMLStyle$().init___()
  };
  return $n_Lamf_RAMLStyle$
}
/** @constructor */
function $c_Lamf_client_AMF$() {
  $c_O.call(this);
  this.platform$1 = null
}
$c_Lamf_client_AMF$.prototype = new $h_O();
$c_Lamf_client_AMF$.prototype.constructor = $c_Lamf_client_AMF$;
/** @constructor */
function $h_Lamf_client_AMF$() {
  /*<skip>*/
}
$h_Lamf_client_AMF$.prototype = $c_Lamf_client_AMF$.prototype;
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$loadValidationProfile__T__Lamf_client_environment_Environment__O = (function(url, env) {
  $m_Lamf_Core$();
  return $m_Lamf_client_validate_Validator$().loadValidationProfile__T__Lamf_client_environment_Environment__sjs_js_Promise(url, env)
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$resolveOas20__Lamf_client_model_document_BaseUnit__O = (function(unit) {
  var this$1 = new $c_Lamf_client_resolve_Oas20Resolver().init___();
  return this$1.resolve__Lamf_client_model_document_BaseUnit__T__Lamf_client_model_document_BaseUnit(unit, $m_Lamf_core_resolution_pipelines_ResolutionPipeline$().DEFAULT$undPIPELINE$1)
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$registerDialect__T__Lamf_client_environment_Environment__O = (function(url, env) {
  return $m_Lamf_plugins_document_Vocabularies$().registerDialect__T__Lamf_client_environment_Environment__sjs_js_Promise(url, env)
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$oas20Parser__O = (function() {
  return new $c_Lamf_client_parse_Oas20Parser().init___()
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$yamlPayloadParser__O = (function() {
  return new $c_Lamf_client_parse_YamlPayloadParser().init___()
});
$c_Lamf_client_AMF$.prototype.init___ = (function() {
  $n_Lamf_client_AMF$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$amfGraphParser__O = (function() {
  return new $c_Lamf_client_parse_AmfGraphParser().init___()
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__O = (function(model, profileName, messageStyle, env) {
  $m_Lamf_Core$();
  return $m_Lamf_client_validate_Validator$().validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__Z__sjs_js_Promise(model, profileName, messageStyle, env, false)
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$validateResolved__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__O = (function(model, profileName, messageStyle, env) {
  $m_Lamf_Core$();
  return $m_Lamf_client_validate_Validator$().validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__Z__sjs_js_Promise(model, profileName, messageStyle, env, true)
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$init__Lamf_client_execution_BaseExecutionEnvironment__O = (function(executionEnvironment) {
  return this.init__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise(executionEnvironment)
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$oas20Generator__O = (function() {
  return new $c_Lamf_client_render_Oas20Renderer().init___()
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$raml10Generator__O = (function() {
  return new $c_Lamf_client_render_Raml10Renderer().init___()
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$ramlParser__O = (function() {
  return new $c_Lamf_client_parse_RamlParser().init___()
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$resolveAmfGraph__Lamf_client_model_document_BaseUnit__O = (function(unit) {
  var this$1 = new $c_Lamf_client_resolve_AmfGraphResolver().init___();
  return this$1.resolve__Lamf_client_model_document_BaseUnit__T__Lamf_client_model_document_BaseUnit(unit, $m_Lamf_core_resolution_pipelines_ResolutionPipeline$().DEFAULT$undPIPELINE$1)
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$init__O = (function() {
  return this.init__sjs_js_Promise()
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$raml08Generator__O = (function() {
  return new $c_Lamf_client_render_Raml08Renderer().init___()
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$resolveRaml08__Lamf_client_model_document_BaseUnit__O = (function(unit) {
  var this$1 = new $c_Lamf_client_resolve_Raml08Resolver().init___();
  return this$1.resolve__Lamf_client_model_document_BaseUnit__T__Lamf_client_model_document_BaseUnit(unit, $m_Lamf_core_resolution_pipelines_ResolutionPipeline$().DEFAULT$undPIPELINE$1)
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$resolveRaml10__Lamf_client_model_document_BaseUnit__O = (function(unit) {
  var this$1 = new $c_Lamf_client_resolve_Raml10Resolver().init___();
  return this$1.resolve__Lamf_client_model_document_BaseUnit__T__Lamf_client_model_document_BaseUnit(unit, $m_Lamf_core_resolution_pipelines_ResolutionPipeline$().DEFAULT$undPIPELINE$1)
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__O = (function(model, profileName, messageStyle) {
  $m_Lamf_Core$();
  var env = $m_Lamf_client_environment_DefaultEnvironment$().apply__Lamf_client_environment_Environment();
  return $m_Lamf_client_validate_Validator$().validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__Z__sjs_js_Promise(model, profileName, messageStyle, env, false)
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$jsonPayloadParser__O = (function() {
  return new $c_Lamf_client_parse_JsonPayloadParser().init___()
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$raml08Parser__O = (function() {
  return new $c_Lamf_client_parse_Raml08Parser().init___()
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$registerDialect__T__O = (function(url) {
  return $m_Lamf_plugins_document_Vocabularies$().registerDialect__T__sjs_js_Promise(url)
});
$c_Lamf_client_AMF$.prototype.init__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise = (function(executionEnvironment) {
  $m_Lamf_plugins_document_WebApi$().register__Lamf_client_execution_BaseExecutionEnvironment__V(executionEnvironment);
  $m_Lamf_plugins_document_Vocabularies$().register__V();
  $m_Lamf_Core$();
  var plugin = $m_Lamf_plugins_features_validation_AMFValidatorPlugin$();
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V(plugin);
  $m_Lamf_Core$();
  var plugin$1 = $m_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$();
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V(plugin$1);
  return $m_Lamf_Core$().init__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise(executionEnvironment)
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$loadValidationProfile__T__O = (function(url) {
  $m_Lamf_Core$();
  var env = $m_Lamf_client_environment_DefaultEnvironment$().apply__Lamf_client_environment_Environment();
  return $m_Lamf_client_validate_Validator$().loadValidationProfile__T__Lamf_client_environment_Environment__sjs_js_Promise(url, env)
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$registerNamespace__T__T__O = (function(alias, prefix) {
  return $m_Lamf_Core$().registerNamespace__T__T__Z(alias, prefix)
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$amfGraphGenerator__O = (function() {
  return new $c_Lamf_client_render_AmfGraphRenderer().init___()
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$emitShapesGraph__Lamf_ProfileName__O = (function(profileName) {
  $m_Lamf_Core$();
  var this$3 = $m_Lamf_core_services_RuntimeValidator$();
  return this$3.validator__p1__Lamf_core_services_RuntimeValidator().emitShapesGraph__Lamf_ProfileName__T(profileName)
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$validateResolved__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__O = (function(model, profileName, messageStyle) {
  $m_Lamf_Core$();
  var env = $m_Lamf_client_environment_DefaultEnvironment$().apply__Lamf_client_environment_Environment();
  return $m_Lamf_client_validate_Validator$().validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__Z__sjs_js_Promise(model, profileName, messageStyle, env, true)
});
$c_Lamf_client_AMF$.prototype.$$js$exported$meth$raml10Parser__O = (function() {
  return new $c_Lamf_client_parse_Raml10Parser().init___()
});
$c_Lamf_client_AMF$.prototype.init__sjs_js_Promise = (function() {
  var this$1 = this.platform$1;
  return this.init__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise(this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment())
});
$c_Lamf_client_AMF$.prototype.yamlPayloadParser = (function() {
  return this.$$js$exported$meth$yamlPayloadParser__O()
});
$c_Lamf_client_AMF$.prototype.jsonPayloadParser = (function() {
  return this.$$js$exported$meth$jsonPayloadParser__O()
});
$c_Lamf_client_AMF$.prototype.resolveAmfGraph = (function(arg) {
  var prep = $as_Lamf_client_model_document_BaseUnit(arg);
  return this.$$js$exported$meth$resolveAmfGraph__Lamf_client_model_document_BaseUnit__O(prep)
});
$c_Lamf_client_AMF$.prototype.resolveOas20 = (function(arg) {
  var prep = $as_Lamf_client_model_document_BaseUnit(arg);
  return this.$$js$exported$meth$resolveOas20__Lamf_client_model_document_BaseUnit__O(prep)
});
$c_Lamf_client_AMF$.prototype.resolveRaml08 = (function(arg) {
  var prep = $as_Lamf_client_model_document_BaseUnit(arg);
  return this.$$js$exported$meth$resolveRaml08__Lamf_client_model_document_BaseUnit__O(prep)
});
$c_Lamf_client_AMF$.prototype.resolveRaml10 = (function(arg) {
  var prep = $as_Lamf_client_model_document_BaseUnit(arg);
  return this.$$js$exported$meth$resolveRaml10__Lamf_client_model_document_BaseUnit__O(prep)
});
$c_Lamf_client_AMF$.prototype.registerDialect = (function(arg) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 1;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_T(arg);
      var prep$2 = $as_Lamf_client_environment_Environment(rest[0]);
      return this.$$js$exported$meth$registerDialect__T__Lamf_client_environment_Environment__O(prep, prep$2);
      break
    }
    case 0: {
      var prep$3 = $as_T(arg);
      return this.$$js$exported$meth$registerDialect__T__O(prep$3);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_AMF$.prototype.registerNamespace = (function(arg, arg$2) {
  var prep = $as_T(arg);
  var prep$2 = $as_T(arg$2);
  return this.$$js$exported$meth$registerNamespace__T__T__O(prep, prep$2)
});
$c_Lamf_client_AMF$.prototype.emitShapesGraph = (function(arg) {
  var prep = $as_Lamf_ProfileName(arg);
  return this.$$js$exported$meth$emitShapesGraph__Lamf_ProfileName__O(prep)
});
$c_Lamf_client_AMF$.prototype.loadValidationProfile = (function(arg) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 1;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      var prep = $as_T(arg);
      return this.$$js$exported$meth$loadValidationProfile__T__O(prep);
      break
    }
    case 1: {
      var prep$2 = $as_T(arg);
      var prep$3 = $as_Lamf_client_environment_Environment(rest[0]);
      return this.$$js$exported$meth$loadValidationProfile__T__Lamf_client_environment_Environment__O(prep$2, prep$3);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_AMF$.prototype.validateResolved = (function(arg, arg$2, arg$3) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 3;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_client_model_document_BaseUnit(arg);
      var prep$2 = $as_Lamf_ProfileName(arg$2);
      var prep$3 = $as_Lamf_MessageStyle(arg$3);
      var prep$4 = $as_Lamf_client_environment_Environment(rest[0]);
      return this.$$js$exported$meth$validateResolved__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__O(prep, prep$2, prep$3, prep$4);
      break
    }
    case 0: {
      var prep$5 = $as_Lamf_client_model_document_BaseUnit(arg);
      var prep$6 = $as_Lamf_ProfileName(arg$2);
      var prep$7 = $as_Lamf_MessageStyle(arg$3);
      return this.$$js$exported$meth$validateResolved__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__O(prep$5, prep$6, prep$7);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_AMF$.prototype.validate = (function(arg, arg$2, arg$3) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 3;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_client_model_document_BaseUnit(arg);
      var prep$2 = $as_Lamf_ProfileName(arg$2);
      var prep$3 = $as_Lamf_MessageStyle(arg$3);
      var prep$4 = $as_Lamf_client_environment_Environment(rest[0]);
      return this.$$js$exported$meth$validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_client_environment_Environment__O(prep, prep$2, prep$3, prep$4);
      break
    }
    case 0: {
      var prep$5 = $as_Lamf_client_model_document_BaseUnit(arg);
      var prep$6 = $as_Lamf_ProfileName(arg$2);
      var prep$7 = $as_Lamf_MessageStyle(arg$3);
      return this.$$js$exported$meth$validate__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__O(prep$5, prep$6, prep$7);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_AMF$.prototype.amfGraphGenerator = (function() {
  return this.$$js$exported$meth$amfGraphGenerator__O()
});
$c_Lamf_client_AMF$.prototype.amfGraphParser = (function() {
  return this.$$js$exported$meth$amfGraphParser__O()
});
$c_Lamf_client_AMF$.prototype.oas20Generator = (function() {
  return this.$$js$exported$meth$oas20Generator__O()
});
$c_Lamf_client_AMF$.prototype.oas20Parser = (function() {
  return this.$$js$exported$meth$oas20Parser__O()
});
$c_Lamf_client_AMF$.prototype.raml08Generator = (function() {
  return this.$$js$exported$meth$raml08Generator__O()
});
$c_Lamf_client_AMF$.prototype.raml08Parser = (function() {
  return this.$$js$exported$meth$raml08Parser__O()
});
$c_Lamf_client_AMF$.prototype.raml10Generator = (function() {
  return this.$$js$exported$meth$raml10Generator__O()
});
$c_Lamf_client_AMF$.prototype.ramlParser = (function() {
  return this.$$js$exported$meth$ramlParser__O()
});
$c_Lamf_client_AMF$.prototype.raml10Parser = (function() {
  return this.$$js$exported$meth$raml10Parser__O()
});
$c_Lamf_client_AMF$.prototype.init = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_client_execution_BaseExecutionEnvironment(rest[0]);
      return this.$$js$exported$meth$init__Lamf_client_execution_BaseExecutionEnvironment__O(prep);
      break
    }
    case 0: {
      return this.$$js$exported$meth$init__O();
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
var $d_Lamf_client_AMF$ = new $TypeData().initClass({
  Lamf_client_AMF$: 0
}, false, "amf.client.AMF$", {
  Lamf_client_AMF$: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_client_AMF$.prototype.$classData = $d_Lamf_client_AMF$;
var $n_Lamf_client_AMF$ = (void 0);
function $m_Lamf_client_AMF$() {
  if ((!$n_Lamf_client_AMF$)) {
    $n_Lamf_client_AMF$ = new $c_Lamf_client_AMF$().init___()
  };
  return $n_Lamf_client_AMF$
}
/** @constructor */
function $c_Lamf_client_commands_CmdLineParser$$anon$1() {
  $c_Lscopt_OptionParser.call(this)
}
$c_Lamf_client_commands_CmdLineParser$$anon$1.prototype = new $h_Lscopt_OptionParser();
$c_Lamf_client_commands_CmdLineParser$$anon$1.prototype.constructor = $c_Lamf_client_commands_CmdLineParser$$anon$1;
/** @constructor */
function $h_Lamf_client_commands_CmdLineParser$$anon$1() {
  /*<skip>*/
}
$h_Lamf_client_commands_CmdLineParser$$anon$1.prototype = $c_Lamf_client_commands_CmdLineParser$$anon$1.prototype;
$c_Lamf_client_commands_CmdLineParser$$anon$1.prototype.init___ = (function() {
  $c_Lscopt_OptionParser.prototype.init___T.call(this, "amf");
  var array = ["Anything Modeling Framework", "4.X"];
  var jsx$1 = this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Head$(), "", $m_Lscopt_Read$().unitRead$1);
  var b = new $c_scm_StringBuilder().init___();
  var elem$1 = false;
  elem$1 = true;
  b.append__T__scm_StringBuilder("");
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    if (elem$1) {
      b.append__O__scm_StringBuilder(arg1);
      elem$1 = false
    } else {
      b.append__T__scm_StringBuilder(" ");
      b.append__O__scm_StringBuilder(arg1)
    };
    i = ((1 + i) | 0)
  };
  b.append__T__scm_StringBuilder("");
  jsx$1.text__T__Lscopt_OptionDef(b.underlying$5.java$lang$StringBuilder$$content$f);
  var this$4 = this.arg__T__Lscopt_Read__Lscopt_OptionDef("<file_in> [<file_out>]", $m_Lscopt_Read$().stringRead$1);
  this$4.maxOccurs__I__Lscopt_OptionDef($m_Lscopt_OptionDef$().UNBOUNDED$1).text__T__Lscopt_OptionDef("Input file to parse and output where translation will be stored").action__F2__Lscopt_OptionDef(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(f$2, c$2) {
      var f = $as_T(f$2);
      var c = $as_Lamf_core_client_ParserConfig(c$2);
      if (c.input$1.isEmpty__Z()) {
        var x$1 = new $c_s_Some().init___O(f);
        var x$2 = c.mode$1;
        var x$3 = c.inputFormat$1;
        var x$4 = c.inputMediaType$1;
        var x$5 = c.output$1;
        var x$6 = c.outputFormat$1;
        var x$7 = c.outputMediaType$1;
        var x$8 = c.withSourceMaps$1;
        var x$9 = c.withCompactNamespaces$1;
        var x$10 = c.validate$1;
        var x$11 = c.trace$1;
        var x$12 = c.patchTarget$1;
        var x$13 = c.validationProfile$1;
        var x$14 = c.customProfile$1;
        var x$15 = c.resolve$1;
        var x$16 = c.dialects$1;
        var x$17 = c.stdout$1;
        var x$18 = c.stderr$1;
        var x$19 = c.proc$1;
        return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(x$2, x$1, x$3, x$4, x$5, x$6, x$7, x$8, x$9, x$10, x$11, x$12, x$13, x$14, x$15, x$16, x$17, x$18, x$19)
      } else {
        var x$20 = new $c_s_Some().init___O(f);
        var x$21 = c.mode$1;
        var x$22 = c.input$1;
        var x$23 = c.inputFormat$1;
        var x$24 = c.inputMediaType$1;
        var x$25 = c.outputFormat$1;
        var x$26 = c.outputMediaType$1;
        var x$27 = c.withSourceMaps$1;
        var x$28 = c.withCompactNamespaces$1;
        var x$29 = c.validate$1;
        var x$30 = c.trace$1;
        var x$31 = c.patchTarget$1;
        var x$32 = c.validationProfile$1;
        var x$33 = c.customProfile$1;
        var x$34 = c.resolve$1;
        var x$35 = c.dialects$1;
        var x$36 = c.stdout$1;
        var x$37 = c.stderr$1;
        var x$38 = c.proc$1;
        return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(x$21, x$22, x$23, x$24, x$20, x$25, x$26, x$27, x$28, x$29, x$30, x$31, x$32, x$33, x$34, x$35, x$36, x$37, x$38)
      }
    })
  })(this)));
  var evidence$8 = $m_Lscopt_Read$().seqRead__Lscopt_Read__Lscopt_Read($m_Lscopt_Read$().stringRead$1);
  this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Opt$(), "dialects", evidence$8).valueName__T__Lscopt_OptionDef("<dialect_file1>,<dialect_file2>...").abbr__T__Lscopt_OptionDef("ds").text__T__Lscopt_OptionDef("List of dialects files that will loaded before parsing").action__F2__Lscopt_OptionDef(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$2$1) {
    return (function(x$2$1, c$3$2) {
      var x = $as_sc_Seq(x$2$1);
      var c$3 = $as_Lamf_core_client_ParserConfig(c$3$2);
      var x$40 = c$3.mode$1;
      var x$41 = c$3.input$1;
      var x$42 = c$3.inputFormat$1;
      var x$43 = c$3.inputMediaType$1;
      var x$44 = c$3.output$1;
      var x$45 = c$3.outputFormat$1;
      var x$46 = c$3.outputMediaType$1;
      var x$47 = c$3.withSourceMaps$1;
      var x$48 = c$3.withCompactNamespaces$1;
      var x$49 = c$3.validate$1;
      var x$50 = c$3.trace$1;
      var x$51 = c$3.patchTarget$1;
      var x$52 = c$3.validationProfile$1;
      var x$53 = c$3.customProfile$1;
      var x$54 = c$3.resolve$1;
      var x$55 = c$3.stdout$1;
      var x$56 = c$3.stderr$1;
      var x$57 = c$3.proc$1;
      return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(x$40, x$41, x$42, x$43, x$44, x$45, x$46, x$47, x$48, x$49, x$50, x$51, x$52, x$53, x$54, x, x$55, x$56, x$57)
    })
  })(this)));
  var evidence$8$1 = $m_Lscopt_Read$().stringRead$1;
  this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Opt$(), "format-in", evidence$8$1).abbr__T__Lscopt_OptionDef("in").text__T__Lscopt_OptionDef("Input format for the file to parse").validate__F1__Lscopt_OptionDef(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(f$3$2) {
      var f$3 = $as_T(f$3$2);
      if ($m_Lamf_client_commands_CmdLineParser$().knownSpec__T__Z(f$3)) {
        $m_Lscopt_OptionDef$();
        $m_s_package$();
        return new $c_s_util_Right().init___O((void 0))
      } else {
        var msg = (((((((((((("Invalid value " + f$3) + ", values supported: '") + $m_Lamf_core_remote_Raml10$().name$1) + "', '") + $m_Lamf_core_remote_Raml08$().name$1) + "', '") + $m_Lamf_core_remote_Oas20$().name$1) + "', '") + $m_Lamf_core_remote_Aml$().name$1) + "', '") + $m_Lamf_core_remote_Amf$().name$1) + "'");
        $m_s_package$();
        return new $c_s_util_Left().init___O(msg)
      }
    })
  })(this))).action__F2__Lscopt_OptionDef(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$4$1) {
    return (function(f$4$2, c$4$2) {
      var f$4 = $as_T(f$4$2);
      var c$4 = $as_Lamf_core_client_ParserConfig(c$4$2);
      var x$58 = new $c_s_Some().init___O(f$4);
      var x$59 = c$4.mode$1;
      var x$60 = c$4.input$1;
      var x$61 = c$4.inputMediaType$1;
      var x$62 = c$4.output$1;
      var x$63 = c$4.outputFormat$1;
      var x$64 = c$4.outputMediaType$1;
      var x$65 = c$4.withSourceMaps$1;
      var x$66 = c$4.withCompactNamespaces$1;
      var x$67 = c$4.validate$1;
      var x$68 = c$4.trace$1;
      var x$69 = c$4.patchTarget$1;
      var x$70 = c$4.validationProfile$1;
      var x$71 = c$4.customProfile$1;
      var x$72 = c$4.resolve$1;
      var x$73 = c$4.dialects$1;
      var x$74 = c$4.stdout$1;
      var x$75 = c$4.stderr$1;
      var x$76 = c$4.proc$1;
      return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(x$59, x$60, x$58, x$61, x$62, x$63, x$64, x$65, x$66, x$67, x$68, x$69, x$70, x$71, x$72, x$73, x$74, x$75, x$76)
    })
  })(this)));
  var evidence$8$2 = $m_Lscopt_Read$().stringRead$1;
  this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Opt$(), "media-type-in", evidence$8$2).abbr__T__Lscopt_OptionDef("mime-in").text__T__Lscopt_OptionDef("Input media type for the file to parse").action__F2__Lscopt_OptionDef(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$5$1) {
    return (function(f$5$2, c$5$2) {
      var f$5 = $as_T(f$5$2);
      var c$5 = $as_Lamf_core_client_ParserConfig(c$5$2);
      var x$77 = new $c_s_Some().init___O(f$5);
      var x$78 = c$5.mode$1;
      var x$79 = c$5.input$1;
      var x$80 = c$5.inputFormat$1;
      var x$81 = c$5.output$1;
      var x$82 = c$5.outputFormat$1;
      var x$83 = c$5.outputMediaType$1;
      var x$84 = c$5.withSourceMaps$1;
      var x$85 = c$5.withCompactNamespaces$1;
      var x$86 = c$5.validate$1;
      var x$87 = c$5.trace$1;
      var x$88 = c$5.patchTarget$1;
      var x$89 = c$5.validationProfile$1;
      var x$90 = c$5.customProfile$1;
      var x$91 = c$5.resolve$1;
      var x$92 = c$5.dialects$1;
      var x$93 = c$5.stdout$1;
      var x$94 = c$5.stderr$1;
      var x$95 = c$5.proc$1;
      return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(x$78, x$79, x$80, x$77, x$81, x$82, x$83, x$84, x$85, x$86, x$87, x$88, x$89, x$90, x$91, x$92, x$93, x$94, x$95)
    })
  })(this)));
  var evidence$8$3 = $m_Lscopt_Read$().stringRead$1;
  this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Opt$(), "validation-profile", evidence$8$3).abbr__T__Lscopt_OptionDef("p").text__T__Lscopt_OptionDef("Standard validation profile to use").validate__F1__Lscopt_OptionDef(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1) {
    return (function(f$6$2) {
      var f$6 = $as_T(f$6$2);
      if ($m_Lamf_client_commands_CmdLineParser$().knownSpec__T__Z(f$6)) {
        $m_Lscopt_OptionDef$();
        $m_s_package$();
        return new $c_s_util_Right().init___O((void 0))
      } else {
        var msg$1 = (((((((((((("Invalid value " + f$6) + ", values supported: '") + $m_Lamf_core_remote_Raml10$().name$1) + "', '") + $m_Lamf_core_remote_Raml08$().name$1) + "', '") + $m_Lamf_core_remote_Oas20$().name$1) + "', '") + $m_Lamf_core_remote_Aml$().name$1) + "', '") + $m_Lamf_core_remote_Amf$().name$1) + "'");
        $m_s_package$();
        return new $c_s_util_Left().init___O(msg$1)
      }
    })
  })(this))).action__F2__Lscopt_OptionDef(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$7$1) {
    return (function(f$7$2, c$6$2) {
      var f$7 = $as_T(f$7$2);
      var c$6 = $as_Lamf_core_client_ParserConfig(c$6$2);
      var x$97 = c$6.mode$1;
      var x$98 = c$6.input$1;
      var x$99 = c$6.inputFormat$1;
      var x$100 = c$6.inputMediaType$1;
      var x$101 = c$6.output$1;
      var x$102 = c$6.outputFormat$1;
      var x$103 = c$6.outputMediaType$1;
      var x$104 = c$6.withSourceMaps$1;
      var x$105 = c$6.withCompactNamespaces$1;
      var x$106 = c$6.validate$1;
      var x$107 = c$6.trace$1;
      var x$108 = c$6.patchTarget$1;
      var x$109 = c$6.customProfile$1;
      var x$110 = c$6.resolve$1;
      var x$111 = c$6.dialects$1;
      var x$112 = c$6.stdout$1;
      var x$113 = c$6.stderr$1;
      var x$114 = c$6.proc$1;
      return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(x$97, x$98, x$99, x$100, x$101, x$102, x$103, x$104, x$105, x$106, x$107, x$108, f$7, x$109, x$110, x$111, x$112, x$113, x$114)
    })
  })(this)));
  var evidence$8$4 = $m_Lscopt_Read$().stringRead$1;
  this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Opt$(), "custom-validation-profile", evidence$8$4).abbr__T__Lscopt_OptionDef("cp").text__T__Lscopt_OptionDef("Custom validation profile location").action__F2__Lscopt_OptionDef(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$8$1) {
    return (function(f$8$2, c$7$2) {
      var f$8 = $as_T(f$8$2);
      var c$7 = $as_Lamf_core_client_ParserConfig(c$7$2);
      var x$115 = new $c_s_Some().init___O(f$8);
      var x$116 = c$7.mode$1;
      var x$117 = c$7.input$1;
      var x$118 = c$7.inputFormat$1;
      var x$119 = c$7.inputMediaType$1;
      var x$120 = c$7.output$1;
      var x$121 = c$7.outputFormat$1;
      var x$122 = c$7.outputMediaType$1;
      var x$123 = c$7.withSourceMaps$1;
      var x$124 = c$7.withCompactNamespaces$1;
      var x$125 = c$7.validate$1;
      var x$126 = c$7.trace$1;
      var x$127 = c$7.patchTarget$1;
      var x$128 = c$7.validationProfile$1;
      var x$129 = c$7.resolve$1;
      var x$130 = c$7.dialects$1;
      var x$131 = c$7.stdout$1;
      var x$132 = c$7.stderr$1;
      var x$133 = c$7.proc$1;
      return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(x$116, x$117, x$118, x$119, x$120, x$121, x$122, x$123, x$124, x$125, x$126, x$127, x$128, x$115, x$129, x$130, x$131, x$132, x$133)
    })
  })(this)));
  var this$20 = this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Cmd$(), "parse", $m_Lscopt_Read$().unitRead$1).text__T__Lscopt_OptionDef("Parse the input file and generates the JSON-LD AMF model").action__F2__Lscopt_OptionDef(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$9$1) {
    return (function(x$1$2, c$8$2) {
      $asUnit(x$1$2);
      var c$8 = $as_Lamf_core_client_ParserConfig(c$8$2);
      var mode = new $c_s_Some().init___O($m_Lamf_core_client_ParserConfig$().PARSE$1);
      var input = c$8.input$1;
      var inputFormat = c$8.inputFormat$1;
      var inputMediaType = c$8.inputMediaType$1;
      var output = c$8.output$1;
      var outputFormat = c$8.outputFormat$1;
      var outputMediaType = c$8.outputMediaType$1;
      var withSourceMaps = c$8.withSourceMaps$1;
      var withCompactNamespaces = c$8.withCompactNamespaces$1;
      var validate = c$8.validate$1;
      var trace = c$8.trace$1;
      var patchTarget = c$8.patchTarget$1;
      var validationProfile = c$8.validationProfile$1;
      var customProfile = c$8.customProfile$1;
      var resolve = c$8.resolve$1;
      var dialects = c$8.dialects$1;
      var stdout = c$8.stdout$1;
      var stderr = c$8.stderr$1;
      var proc = c$8.proc$1;
      return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(mode, input, inputFormat, inputMediaType, output, outputFormat, outputMediaType, withSourceMaps, withCompactNamespaces, validate, trace, patchTarget, validationProfile, customProfile, resolve, dialects, stdout, stderr, proc)
    })
  })(this)));
  var evidence$8$5 = $m_Lscopt_Read$().booleanRead$1;
  this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Opt$(), "source-maps", evidence$8$5).abbr__T__Lscopt_OptionDef("sm").text__T__Lscopt_OptionDef("Generate source maps in AMF output").action__F2__Lscopt_OptionDef(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$10$1) {
    return (function(f$9$2, c$9$2) {
      var f$9 = $uZ(f$9$2);
      var c$9 = $as_Lamf_core_client_ParserConfig(c$9$2);
      var x$135 = c$9.mode$1;
      var x$136 = c$9.input$1;
      var x$137 = c$9.inputFormat$1;
      var x$138 = c$9.inputMediaType$1;
      var x$139 = c$9.output$1;
      var x$140 = c$9.outputFormat$1;
      var x$141 = c$9.outputMediaType$1;
      var x$142 = c$9.withCompactNamespaces$1;
      var x$143 = c$9.validate$1;
      var x$144 = c$9.trace$1;
      var x$145 = c$9.patchTarget$1;
      var x$146 = c$9.validationProfile$1;
      var x$147 = c$9.customProfile$1;
      var x$148 = c$9.resolve$1;
      var x$149 = c$9.dialects$1;
      var x$150 = c$9.stdout$1;
      var x$151 = c$9.stderr$1;
      var x$152 = c$9.proc$1;
      return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(x$135, x$136, x$137, x$138, x$139, x$140, x$141, f$9, x$142, x$143, x$144, x$145, x$146, x$147, x$148, x$149, x$150, x$151, x$152)
    })
  })(this)));
  var evidence$8$6 = $m_Lscopt_Read$().booleanRead$1;
  this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Opt$(), "compacted", evidence$8$6).abbr__T__Lscopt_OptionDef("ctx").text__T__Lscopt_OptionDef("Compact namespaces in context").action__F2__Lscopt_OptionDef(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$11) {
    return (function(f$10$2, c$10$2) {
      var f$10 = $uZ(f$10$2);
      var c$10 = $as_Lamf_core_client_ParserConfig(c$10$2);
      var x$154 = c$10.mode$1;
      var x$155 = c$10.input$1;
      var x$156 = c$10.inputFormat$1;
      var x$157 = c$10.inputMediaType$1;
      var x$158 = c$10.output$1;
      var x$159 = c$10.outputFormat$1;
      var x$160 = c$10.outputMediaType$1;
      var x$161 = c$10.withSourceMaps$1;
      var x$162 = c$10.validate$1;
      var x$163 = c$10.trace$1;
      var x$164 = c$10.patchTarget$1;
      var x$165 = c$10.validationProfile$1;
      var x$166 = c$10.customProfile$1;
      var x$167 = c$10.resolve$1;
      var x$168 = c$10.dialects$1;
      var x$169 = c$10.stdout$1;
      var x$170 = c$10.stderr$1;
      var x$171 = c$10.proc$1;
      return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(x$154, x$155, x$156, x$157, x$158, x$159, x$160, x$161, f$10, x$162, x$163, x$164, x$165, x$166, x$167, x$168, x$169, x$170, x$171)
    })
  })(this)));
  var evidence$8$7 = $m_Lscopt_Read$().booleanRead$1;
  this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Opt$(), "validate", evidence$8$7).abbr__T__Lscopt_OptionDef("v").text__T__Lscopt_OptionDef("Perform validation").action__F2__Lscopt_OptionDef(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$12) {
    return (function(f$11$2, c$11$2) {
      var f$11 = $uZ(f$11$2);
      var c$11 = $as_Lamf_core_client_ParserConfig(c$11$2);
      var x$173 = c$11.mode$1;
      var x$174 = c$11.input$1;
      var x$175 = c$11.inputFormat$1;
      var x$176 = c$11.inputMediaType$1;
      var x$177 = c$11.output$1;
      var x$178 = c$11.outputFormat$1;
      var x$179 = c$11.outputMediaType$1;
      var x$180 = c$11.withSourceMaps$1;
      var x$181 = c$11.withCompactNamespaces$1;
      var x$182 = c$11.trace$1;
      var x$183 = c$11.patchTarget$1;
      var x$184 = c$11.validationProfile$1;
      var x$185 = c$11.customProfile$1;
      var x$186 = c$11.resolve$1;
      var x$187 = c$11.dialects$1;
      var x$188 = c$11.stdout$1;
      var x$189 = c$11.stderr$1;
      var x$190 = c$11.proc$1;
      return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(x$173, x$174, x$175, x$176, x$177, x$178, x$179, x$180, x$181, f$11, x$182, x$183, x$184, x$185, x$186, x$187, x$188, x$189, x$190)
    })
  })(this)));
  var evidence$8$8 = $m_Lscopt_Read$().booleanRead$1;
  this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Opt$(), "resolve", evidence$8$8).abbr__T__Lscopt_OptionDef("r").text__T__Lscopt_OptionDef("Resolve after parsing").action__F2__Lscopt_OptionDef(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$13) {
    return (function(f$12$2, c$12$2) {
      var f$12 = $uZ(f$12$2);
      var c$12 = $as_Lamf_core_client_ParserConfig(c$12$2);
      var x$192 = c$12.mode$1;
      var x$193 = c$12.input$1;
      var x$194 = c$12.inputFormat$1;
      var x$195 = c$12.inputMediaType$1;
      var x$196 = c$12.output$1;
      var x$197 = c$12.outputFormat$1;
      var x$198 = c$12.outputMediaType$1;
      var x$199 = c$12.withSourceMaps$1;
      var x$200 = c$12.withCompactNamespaces$1;
      var x$201 = c$12.validate$1;
      var x$202 = c$12.trace$1;
      var x$203 = c$12.patchTarget$1;
      var x$204 = c$12.validationProfile$1;
      var x$205 = c$12.customProfile$1;
      var x$206 = c$12.dialects$1;
      var x$207 = c$12.stdout$1;
      var x$208 = c$12.stderr$1;
      var x$209 = c$12.proc$1;
      return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(x$192, x$193, x$194, x$195, x$196, x$197, x$198, x$199, x$200, x$201, x$202, x$203, x$204, x$205, f$12, x$206, x$207, x$208, x$209)
    })
  })(this)));
  var evidence$8$9 = $m_Lscopt_Read$().booleanRead$1;
  var array$1 = [this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Opt$(), "trace", evidence$8$9).abbr__T__Lscopt_OptionDef("t").text__T__Lscopt_OptionDef("Trace execution").action__F2__Lscopt_OptionDef(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$14) {
    return (function(f$13$2, c$13$2) {
      var f$13 = $uZ(f$13$2);
      var c$13 = $as_Lamf_core_client_ParserConfig(c$13$2);
      var x$39 = ((("TRACING EXECUTION... " + f$13) + " => ") + c$13);
      var this$16 = $m_s_Console$();
      var this$17 = $as_Ljava_io_PrintStream(this$16.outVar$2.v$1);
      this$17.java$lang$JSConsoleBasedPrintStream$$printString__T__V((x$39 + "\n"));
      var x$211 = c$13.mode$1;
      var x$212 = c$13.input$1;
      var x$213 = c$13.inputFormat$1;
      var x$214 = c$13.inputMediaType$1;
      var x$215 = c$13.output$1;
      var x$216 = c$13.outputFormat$1;
      var x$217 = c$13.outputMediaType$1;
      var x$218 = c$13.withSourceMaps$1;
      var x$219 = c$13.withCompactNamespaces$1;
      var x$220 = c$13.validate$1;
      var x$221 = c$13.patchTarget$1;
      var x$222 = c$13.validationProfile$1;
      var x$223 = c$13.customProfile$1;
      var x$224 = c$13.resolve$1;
      var x$225 = c$13.dialects$1;
      var x$226 = c$13.stdout$1;
      var x$227 = c$13.stderr$1;
      var x$228 = c$13.proc$1;
      return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(x$211, x$212, x$213, x$214, x$215, x$216, x$217, x$218, x$219, x$220, true, x$221, x$222, x$223, x$224, x$225, x$226, x$227, x$228)
    })
  })(this)))];
  var i$1 = 0;
  var len$1 = $uI(array$1.length);
  while ((i$1 < len$1)) {
    var index$1 = i$1;
    var arg1$1 = array$1[index$1];
    var x$40$1 = $as_Lscopt_OptionDef(arg1$1);
    x$40$1.parent__Lscopt_OptionDef__Lscopt_OptionDef(this$20);
    i$1 = ((1 + i$1) | 0)
  };
  var this$26 = this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Cmd$(), "translate", $m_Lscopt_Read$().unitRead$1).text__T__Lscopt_OptionDef("Translates the input file into a different format").action__F2__Lscopt_OptionDef(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$15$1) {
    return (function(x$2$2$2, c$14$2) {
      $asUnit(x$2$2$2);
      var c$14 = $as_Lamf_core_client_ParserConfig(c$14$2);
      var mode$1 = new $c_s_Some().init___O($m_Lamf_core_client_ParserConfig$().TRANSLATE$1);
      var input$1 = c$14.input$1;
      var inputFormat$1 = c$14.inputFormat$1;
      var inputMediaType$1 = c$14.inputMediaType$1;
      var output$1 = c$14.output$1;
      var outputFormat$1 = c$14.outputFormat$1;
      var outputMediaType$1 = c$14.outputMediaType$1;
      var withSourceMaps$1 = c$14.withSourceMaps$1;
      var withCompactNamespaces$1 = c$14.withCompactNamespaces$1;
      var validate$1 = c$14.validate$1;
      var trace$1 = c$14.trace$1;
      var patchTarget$1 = c$14.patchTarget$1;
      var validationProfile$1 = c$14.validationProfile$1;
      var customProfile$1 = c$14.customProfile$1;
      var resolve$1 = c$14.resolve$1;
      var dialects$1 = c$14.dialects$1;
      var stdout$1 = c$14.stdout$1;
      var stderr$1 = c$14.stderr$1;
      var proc$1 = c$14.proc$1;
      return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(mode$1, input$1, inputFormat$1, inputMediaType$1, output$1, outputFormat$1, outputMediaType$1, withSourceMaps$1, withCompactNamespaces$1, validate$1, trace$1, patchTarget$1, validationProfile$1, customProfile$1, resolve$1, dialects$1, stdout$1, stderr$1, proc$1)
    })
  })(this)));
  var evidence$8$10 = $m_Lscopt_Read$().stringRead$1;
  this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Opt$(), "format-out", evidence$8$10).abbr__T__Lscopt_OptionDef("out").text__T__Lscopt_OptionDef("Output format for the file to generate").validate__F1__Lscopt_OptionDef(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$16$1) {
    return (function(f$14$2) {
      var f$14 = $as_T(f$14$2);
      if ($m_Lamf_client_commands_CmdLineParser$().knownSpec__T__Z(f$14)) {
        $m_Lscopt_OptionDef$();
        $m_s_package$();
        return new $c_s_util_Right().init___O((void 0))
      } else {
        var msg$2 = (((((((((((("Invalid value " + f$14) + ", values supported: '") + $m_Lamf_core_remote_Raml10$().name$1) + "', '") + $m_Lamf_core_remote_Raml08$().name$1) + "', '") + $m_Lamf_core_remote_Oas20$().name$1) + "', '") + $m_Lamf_core_remote_Aml$().name$1) + "', '") + $m_Lamf_core_remote_Amf$().name$1) + "'");
        $m_s_package$();
        return new $c_s_util_Left().init___O(msg$2)
      }
    })
  })(this))).action__F2__Lscopt_OptionDef(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$17$1) {
    return (function(f$15$2, c$15$2) {
      var f$15 = $as_T(f$15$2);
      var c$15 = $as_Lamf_core_client_ParserConfig(c$15$2);
      var x$229 = new $c_s_Some().init___O(f$15);
      var x$230 = c$15.mode$1;
      var x$231 = c$15.input$1;
      var x$232 = c$15.inputFormat$1;
      var x$233 = c$15.inputMediaType$1;
      var x$234 = c$15.output$1;
      var x$235 = c$15.outputMediaType$1;
      var x$236 = c$15.withSourceMaps$1;
      var x$237 = c$15.withCompactNamespaces$1;
      var x$238 = c$15.validate$1;
      var x$239 = c$15.trace$1;
      var x$240 = c$15.patchTarget$1;
      var x$241 = c$15.validationProfile$1;
      var x$242 = c$15.customProfile$1;
      var x$243 = c$15.resolve$1;
      var x$244 = c$15.dialects$1;
      var x$245 = c$15.stdout$1;
      var x$246 = c$15.stderr$1;
      var x$247 = c$15.proc$1;
      return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(x$230, x$231, x$232, x$233, x$234, x$229, x$235, x$236, x$237, x$238, x$239, x$240, x$241, x$242, x$243, x$244, x$245, x$246, x$247)
    })
  })(this)));
  var evidence$8$11 = $m_Lscopt_Read$().stringRead$1;
  this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Opt$(), "media-type-out", evidence$8$11).abbr__T__Lscopt_OptionDef("mime-out").text__T__Lscopt_OptionDef("Output media type for the file to generate").action__F2__Lscopt_OptionDef(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$18$1) {
    return (function(f$16$2, c$16$2) {
      var f$16 = $as_T(f$16$2);
      var c$16 = $as_Lamf_core_client_ParserConfig(c$16$2);
      var x$248 = new $c_s_Some().init___O(f$16);
      var x$249 = c$16.mode$1;
      var x$250 = c$16.input$1;
      var x$251 = c$16.inputFormat$1;
      var x$252 = c$16.inputMediaType$1;
      var x$253 = c$16.output$1;
      var x$254 = c$16.outputFormat$1;
      var x$255 = c$16.withSourceMaps$1;
      var x$256 = c$16.withCompactNamespaces$1;
      var x$257 = c$16.validate$1;
      var x$258 = c$16.trace$1;
      var x$259 = c$16.patchTarget$1;
      var x$260 = c$16.validationProfile$1;
      var x$261 = c$16.customProfile$1;
      var x$262 = c$16.resolve$1;
      var x$263 = c$16.dialects$1;
      var x$264 = c$16.stdout$1;
      var x$265 = c$16.stderr$1;
      var x$266 = c$16.proc$1;
      return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(x$249, x$250, x$251, x$252, x$253, x$254, x$248, x$255, x$256, x$257, x$258, x$259, x$260, x$261, x$262, x$263, x$264, x$265, x$266)
    })
  })(this)));
  var evidence$8$12 = $m_Lscopt_Read$().booleanRead$1;
  this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Opt$(), "source-maps", evidence$8$12).abbr__T__Lscopt_OptionDef("sm").text__T__Lscopt_OptionDef("Generate source maps in AMF output").action__F2__Lscopt_OptionDef(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$19$1) {
    return (function(f$17$2, c$17$2) {
      var f$17 = $uZ(f$17$2);
      var c$17 = $as_Lamf_core_client_ParserConfig(c$17$2);
      var x$268 = c$17.mode$1;
      var x$269 = c$17.input$1;
      var x$270 = c$17.inputFormat$1;
      var x$271 = c$17.inputMediaType$1;
      var x$272 = c$17.output$1;
      var x$273 = c$17.outputFormat$1;
      var x$274 = c$17.outputMediaType$1;
      var x$275 = c$17.withCompactNamespaces$1;
      var x$276 = c$17.validate$1;
      var x$277 = c$17.trace$1;
      var x$278 = c$17.patchTarget$1;
      var x$279 = c$17.validationProfile$1;
      var x$280 = c$17.customProfile$1;
      var x$281 = c$17.resolve$1;
      var x$282 = c$17.dialects$1;
      var x$283 = c$17.stdout$1;
      var x$284 = c$17.stderr$1;
      var x$285 = c$17.proc$1;
      return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(x$268, x$269, x$270, x$271, x$272, x$273, x$274, f$17, x$275, x$276, x$277, x$278, x$279, x$280, x$281, x$282, x$283, x$284, x$285)
    })
  })(this)));
  var evidence$8$13 = $m_Lscopt_Read$().booleanRead$1;
  this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Opt$(), "validate", evidence$8$13).abbr__T__Lscopt_OptionDef("v").text__T__Lscopt_OptionDef("Perform validation").action__F2__Lscopt_OptionDef(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$20$1) {
    return (function(f$18$2, c$18$2) {
      var f$18 = $uZ(f$18$2);
      var c$18 = $as_Lamf_core_client_ParserConfig(c$18$2);
      var x$287 = c$18.mode$1;
      var x$288 = c$18.input$1;
      var x$289 = c$18.inputFormat$1;
      var x$290 = c$18.inputMediaType$1;
      var x$291 = c$18.output$1;
      var x$292 = c$18.outputFormat$1;
      var x$293 = c$18.outputMediaType$1;
      var x$294 = c$18.withSourceMaps$1;
      var x$295 = c$18.withCompactNamespaces$1;
      var x$296 = c$18.trace$1;
      var x$297 = c$18.patchTarget$1;
      var x$298 = c$18.validationProfile$1;
      var x$299 = c$18.customProfile$1;
      var x$300 = c$18.resolve$1;
      var x$301 = c$18.dialects$1;
      var x$302 = c$18.stdout$1;
      var x$303 = c$18.stderr$1;
      var x$304 = c$18.proc$1;
      return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(x$287, x$288, x$289, x$290, x$291, x$292, x$293, x$294, x$295, f$18, x$296, x$297, x$298, x$299, x$300, x$301, x$302, x$303, x$304)
    })
  })(this)));
  var evidence$8$14 = $m_Lscopt_Read$().booleanRead$1;
  var array$2 = [this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Opt$(), "resolve", evidence$8$14).abbr__T__Lscopt_OptionDef("r").text__T__Lscopt_OptionDef("Resolve after parsing").action__F2__Lscopt_OptionDef(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$21$1) {
    return (function(f$19$2, c$19$2) {
      var f$19 = $uZ(f$19$2);
      var c$19 = $as_Lamf_core_client_ParserConfig(c$19$2);
      var x$306 = c$19.mode$1;
      var x$307 = c$19.input$1;
      var x$308 = c$19.inputFormat$1;
      var x$309 = c$19.inputMediaType$1;
      var x$310 = c$19.output$1;
      var x$311 = c$19.outputFormat$1;
      var x$312 = c$19.outputMediaType$1;
      var x$313 = c$19.withSourceMaps$1;
      var x$314 = c$19.withCompactNamespaces$1;
      var x$315 = c$19.validate$1;
      var x$316 = c$19.trace$1;
      var x$317 = c$19.patchTarget$1;
      var x$318 = c$19.validationProfile$1;
      var x$319 = c$19.customProfile$1;
      var x$320 = c$19.dialects$1;
      var x$321 = c$19.stdout$1;
      var x$322 = c$19.stderr$1;
      var x$323 = c$19.proc$1;
      return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(x$306, x$307, x$308, x$309, x$310, x$311, x$312, x$313, x$314, x$315, x$316, x$317, x$318, x$319, f$19, x$320, x$321, x$322, x$323)
    })
  })(this)))];
  var i$2 = 0;
  var len$2 = $uI(array$2.length);
  while ((i$2 < len$2)) {
    var index$2 = i$2;
    var arg1$2 = array$2[index$2];
    var x$40$2 = $as_Lscopt_OptionDef(arg1$2);
    x$40$2.parent__Lscopt_OptionDef__Lscopt_OptionDef(this$26);
    i$2 = ((1 + i$2) | 0)
  };
  var this$29 = this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Cmd$(), "patch", $m_Lscopt_Read$().unitRead$1).text__T__Lscopt_OptionDef("Apply a AML patch").action__F2__Lscopt_OptionDef(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$22$1) {
    return (function(x$3$2, c$20$2) {
      $asUnit(x$3$2);
      var c$20 = $as_Lamf_core_client_ParserConfig(c$20$2);
      var mode$2 = new $c_s_Some().init___O($m_Lamf_core_client_ParserConfig$().PATCH$1);
      var input$2 = c$20.input$1;
      var inputFormat$2 = c$20.inputFormat$1;
      var inputMediaType$2 = c$20.inputMediaType$1;
      var output$2 = c$20.output$1;
      var outputFormat$2 = c$20.outputFormat$1;
      var outputMediaType$2 = c$20.outputMediaType$1;
      var withSourceMaps$2 = c$20.withSourceMaps$1;
      var withCompactNamespaces$2 = c$20.withCompactNamespaces$1;
      var validate$2 = c$20.validate$1;
      var trace$2 = c$20.trace$1;
      var patchTarget$2 = c$20.patchTarget$1;
      var validationProfile$2 = c$20.validationProfile$1;
      var customProfile$2 = c$20.customProfile$1;
      var resolve$2 = c$20.resolve$1;
      var dialects$2 = c$20.dialects$1;
      var stdout$2 = c$20.stdout$1;
      var stderr$2 = c$20.stderr$1;
      var proc$2 = c$20.proc$1;
      return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(mode$2, input$2, inputFormat$2, inputMediaType$2, output$2, outputFormat$2, outputMediaType$2, withSourceMaps$2, withCompactNamespaces$2, validate$2, trace$2, patchTarget$2, validationProfile$2, customProfile$2, resolve$2, dialects$2, stdout$2, stderr$2, proc$2)
    })
  })(this)));
  var evidence$8$15 = $m_Lscopt_Read$().stringRead$1;
  var array$3 = [this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Opt$(), "patch-target", evidence$8$15).abbr__T__Lscopt_OptionDef("tg").text__T__Lscopt_OptionDef("Location of the file being patched").action__F2__Lscopt_OptionDef(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$23$1) {
    return (function(f$20$2, c$21$2) {
      var f$20 = $as_T(f$20$2);
      var c$21 = $as_Lamf_core_client_ParserConfig(c$21$2);
      var x$324 = new $c_s_Some().init___O(f$20);
      var x$325 = c$21.mode$1;
      var x$326 = c$21.input$1;
      var x$327 = c$21.inputFormat$1;
      var x$328 = c$21.inputMediaType$1;
      var x$329 = c$21.output$1;
      var x$330 = c$21.outputFormat$1;
      var x$331 = c$21.outputMediaType$1;
      var x$332 = c$21.withSourceMaps$1;
      var x$333 = c$21.withCompactNamespaces$1;
      var x$334 = c$21.validate$1;
      var x$335 = c$21.trace$1;
      var x$336 = c$21.validationProfile$1;
      var x$337 = c$21.customProfile$1;
      var x$338 = c$21.resolve$1;
      var x$339 = c$21.dialects$1;
      var x$340 = c$21.stdout$1;
      var x$341 = c$21.stderr$1;
      var x$342 = c$21.proc$1;
      return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(x$325, x$326, x$327, x$328, x$329, x$330, x$331, x$332, x$333, x$334, x$335, x$324, x$336, x$337, x$338, x$339, x$340, x$341, x$342)
    })
  })(this)))];
  var i$3 = 0;
  var len$3 = $uI(array$3.length);
  while ((i$3 < len$3)) {
    var index$3 = i$3;
    var arg1$3 = array$3[index$3];
    var x$40$3 = $as_Lscopt_OptionDef(arg1$3);
    x$40$3.parent__Lscopt_OptionDef__Lscopt_OptionDef(this$29);
    i$3 = ((1 + i$3) | 0)
  };
  this.makeDef__Lscopt_OptionDefKind__T__Lscopt_Read__Lscopt_OptionDef($m_Lscopt_Cmd$(), "validate", $m_Lscopt_Read$().unitRead$1).text__T__Lscopt_OptionDef("Validates the spec and generates the validation report").action__F2__Lscopt_OptionDef(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$24$1) {
    return (function(x$4$2, c$22$2) {
      $asUnit(x$4$2);
      var c$22 = $as_Lamf_core_client_ParserConfig(c$22$2);
      var mode$3 = new $c_s_Some().init___O($m_Lamf_core_client_ParserConfig$().VALIDATE$1);
      var input$3 = c$22.input$1;
      var inputFormat$3 = c$22.inputFormat$1;
      var inputMediaType$3 = c$22.inputMediaType$1;
      var output$3 = c$22.output$1;
      var outputFormat$3 = c$22.outputFormat$1;
      var outputMediaType$3 = c$22.outputMediaType$1;
      var withSourceMaps$3 = c$22.withSourceMaps$1;
      var withCompactNamespaces$3 = c$22.withCompactNamespaces$1;
      var validate$3 = c$22.validate$1;
      var trace$3 = c$22.trace$1;
      var patchTarget$3 = c$22.patchTarget$1;
      var validationProfile$3 = c$22.validationProfile$1;
      var customProfile$3 = c$22.customProfile$1;
      var resolve$3 = c$22.resolve$1;
      var dialects$3 = c$22.dialects$1;
      var stdout$3 = c$22.stdout$1;
      var stderr$3 = c$22.stderr$1;
      var proc$3 = c$22.proc$1;
      return new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(mode$3, input$3, inputFormat$3, inputMediaType$3, output$3, outputFormat$3, outputMediaType$3, withSourceMaps$3, withCompactNamespaces$3, validate$3, trace$3, patchTarget$3, validationProfile$3, customProfile$3, resolve$3, dialects$3, stdout$3, stderr$3, proc$3)
    })
  })(this)));
  this.checkConfig__F1__Lscopt_OptionDef(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$25$1) {
    return (function(c$23$2) {
      var c$23 = $as_Lamf_core_client_ParserConfig(c$23$2);
      var error = "";
      if (c$23.input$1.isEmpty__Z()) {
        error = (error + "Missing <file_input>\n")
      };
      if (c$23.inputMediaType$1.isEmpty__Z()) {
        error = (error + "Missing <file_input>\n")
      };
      if (c$23.mode$1.isDefined__Z()) {
        var x$96 = c$23.mode$1.get__O();
        var x$2$3 = $m_Lamf_core_client_ParserConfig$().PATCH$1;
        var jsx$2 = (!((x$96 === null) ? (x$2$3 === null) : $objectEquals(x$96, x$2$3)))
      } else {
        var jsx$2 = false
      };
      if (jsx$2) {
        if (c$23.inputFormat$1.isEmpty__Z()) {
          error = (error + "Missing --format-in\n")
        }
      };
      if (c$23.inputMediaType$1.isEmpty__Z()) {
        error = (error + "Missing --media-type-in\n")
      };
      if (c$23.mode$1.isDefined__Z()) {
        var x$3$3 = c$23.mode$1.get__O();
        var x$4$3 = $m_Lamf_core_client_ParserConfig$().TRANSLATE$1;
        var jsx$3 = ((x$3$3 === null) ? (x$4$3 === null) : $objectEquals(x$3$3, x$4$3))
      } else {
        var jsx$3 = false
      };
      if (jsx$3) {
        if (c$23.outputFormat$1.isEmpty__Z()) {
          error = (error + "Missing --format-out\n")
        };
        if (c$23.outputMediaType$1.isEmpty__Z()) {
          error = (error + "Missing --media-type-out\n")
        }
      };
      if ((error === "")) {
        $m_Lscopt_OptionDef$();
        $m_s_package$();
        return new $c_s_util_Right().init___O((void 0))
      } else {
        var msg$3 = error;
        $m_s_package$();
        return new $c_s_util_Left().init___O(msg$3)
      }
    })
  })(this)));
  return this
});
var $d_Lamf_client_commands_CmdLineParser$$anon$1 = new $TypeData().initClass({
  Lamf_client_commands_CmdLineParser$$anon$1: 0
}, false, "amf.client.commands.CmdLineParser$$anon$1", {
  Lamf_client_commands_CmdLineParser$$anon$1: 1,
  Lscopt_OptionParser: 1,
  O: 1
});
$c_Lamf_client_commands_CmdLineParser$$anon$1.prototype.$classData = $d_Lamf_client_commands_CmdLineParser$$anon$1;
/** @constructor */
function $c_Lamf_client_commands_TranslateCommand() {
  $c_O.call(this);
  this.platform$1 = null;
  this.validationCommand$1 = null;
  this.executionContext$1 = null
}
$c_Lamf_client_commands_TranslateCommand.prototype = new $h_O();
$c_Lamf_client_commands_TranslateCommand.prototype.constructor = $c_Lamf_client_commands_TranslateCommand;
/** @constructor */
function $h_Lamf_client_commands_TranslateCommand() {
  /*<skip>*/
}
$h_Lamf_client_commands_TranslateCommand.prototype = $c_Lamf_client_commands_TranslateCommand.prototype;
$c_Lamf_client_commands_TranslateCommand.prototype.init___Lamf_core_remote_Platform = (function(platform) {
  this.platform$1 = platform;
  this.executionContext$1 = $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext();
  this.validationCommand$1 = new $c_Lamf_client_commands_ValidateCommand().init___Lamf_core_remote_Platform(platform);
  return this
});
$c_Lamf_client_commands_TranslateCommand.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_client_commands_TranslateCommand.prototype.run__Lamf_core_client_ParserConfig__s_concurrent_Future = (function(config) {
  var res = $f_Lamf_client_commands_CommandHelper__AMFInit__s_concurrent_Future(this).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, config$1) {
    return (function(_$2) {
      $asUnit(_$2);
      return $f_Lamf_client_commands_CommandHelper__parseInput__Lamf_core_client_ParserConfig__s_concurrent_Future($this, config$1).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, config$1$1) {
        return (function(model$2) {
          var model = $as_Lamf_core_model_document_BaseUnit(model$2);
          return $this$1.checkValidation__Lamf_core_client_ParserConfig__Lamf_core_model_document_BaseUnit__s_concurrent_Future(config$1$1, model).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, config$1$2, model$1) {
            return (function(_$2$1) {
              $asUnit(_$2$1);
              return $f_Lamf_client_commands_CommandHelper__resolve__Lamf_core_client_ParserConfig__Lamf_core_model_document_BaseUnit__s_concurrent_Future($this$2, config$1$2, model$1).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, config$1$3) {
                return (function(model$2$1) {
                  var model$3 = $as_Lamf_core_model_document_BaseUnit(model$2$1);
                  return $f_Lamf_client_commands_CommandHelper__generateOutput__Lamf_core_client_ParserConfig__Lamf_core_model_document_BaseUnit__s_concurrent_Future($this$3, config$1$3, model$3).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$4) {
                    return (function(generated$2) {
                      $asUnit(generated$2)
                    })
                  })($this$3)), $this$3.executionContext$1)
                })
              })($this$2, config$1$2)), $this$2.executionContext$1)
            })
          })($this$1, config$1$1, model)), $this$1.executionContext$1)
        })
      })($this, config$1)), $this.executionContext$1)
    })
  })(this, config)), this.executionContext$1);
  res.onComplete__F1__s_concurrent_ExecutionContext__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, config$2) {
    return (function(x0$1$2) {
      var x0$1 = $as_s_util_Try(x0$1$2);
      if ((x0$1 instanceof $c_s_util_Failure)) {
        var x2 = $as_s_util_Failure(x0$1);
        var ex = x2.exception$2;
        if ((ex !== null)) {
          config$2.stderr$1.print__jl_Throwable__V(ex);
          var statusCode = $m_Lamf_core_client_ExitCodes$().Exception$1;
          $m_jl_System$();
          var this$4 = $m_jl_Runtime$();
          var this$5 = this$4.currentRuntime$1;
          this$5.halt__I__V(statusCode);
          return (void 0)
        }
      };
      if ((x0$1 instanceof $c_s_util_Success)) {
        var x3 = $as_s_util_Success(x0$1);
        var other = x3.value$2;
        return other
      };
      throw new $c_s_MatchError().init___O(x0$1)
    })
  })(this, config)), this.executionContext$1);
  return res
});
$c_Lamf_client_commands_TranslateCommand.prototype.checkValidation__Lamf_core_client_ParserConfig__Lamf_core_model_document_BaseUnit__s_concurrent_Future = (function(config, model) {
  if (config.customProfile$1.isDefined__Z()) {
    var x$1 = $as_T(config.customProfile$1.get__O());
    var x$2 = $m_Lamf_core_errorhandling_UnhandledErrorHandler$();
    $m_Lamf_core_services_RuntimeValidator$();
    var x$3 = $m_Lamf_internal_environment_Environment$().apply__Lamf_internal_environment_Environment();
    var customProfileLoaded = $m_Lamf_core_services_RuntimeValidator$().loadValidationProfile__T__Lamf_internal_environment_Environment__Lamf_core_errorhandling_ErrorHandler__s_concurrent_Future(x$1, x$3, x$2).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(profileName$2) {
        var profileName = $as_Lamf_ProfileName(profileName$2);
        return profileName
      })
    })(this)), this.executionContext$1)
  } else {
    var customProfileLoaded = $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$2, model$1, config$1) {
      return (function() {
        if ((model$1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstance)) {
          var x2 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstance(model$1);
          var x1$2 = $m_Lamf_plugins_document_vocabularies_AMLPlugin$().apply__Lamf_plugins_document_vocabularies_AMLPlugin().registry$2.dialectFor__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__s_Option(x2);
          if ((x1$2 instanceof $c_s_Some)) {
            var x2$2 = $as_s_Some(x1$2);
            var dialect = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(x2$2.value$2);
            return $m_Lamf_ProfileName$().apply__T__Lamf_ProfileName(dialect.nameAndVersion__T())
          } else {
            return config$1.profile$1
          }
        } else {
          return config$1.profile$1
        }
      })
    })(this, model, config)), this.executionContext$1)
  };
  return customProfileLoaded.flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3, model$2, config$2) {
    return (function(profileName$3$2) {
      var profileName$3 = $as_Lamf_ProfileName(profileName$3$2);
      return $m_Lamf_core_services_RuntimeValidator$().apply__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_internal_environment_Environment__Z__s_concurrent_Future(model$2, profileName$3, ($m_Lamf_core_services_RuntimeValidator$(), $m_Lamf_AMFStyle$()), ($m_Lamf_core_services_RuntimeValidator$(), $m_Lamf_internal_environment_Environment$().apply__Lamf_internal_environment_Environment()), ($m_Lamf_core_services_RuntimeValidator$(), false)).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, config$2$1) {
        return (function(report$2) {
          var report = $as_Lamf_core_validation_AMFValidationReport(report$2);
          if ((!report.conforms$1)) {
            config$2$1.stderr$1.print__T__V(report.toString__I__T(report.DefaultMax$1));
            var statusCode = $m_Lamf_core_client_ExitCodes$().FailingValidation$1;
            $m_jl_System$();
            var this$8 = $m_jl_Runtime$();
            var this$9 = this$8.currentRuntime$1;
            this$9.halt__I__V(statusCode)
          }
        })
      })(this$3, config$2)), this$3.executionContext$1)
    })
  })(this, model, config)), this.executionContext$1)
});
$c_Lamf_client_commands_TranslateCommand.prototype.executionContext__s_concurrent_ExecutionContext = (function() {
  return this.executionContext$1
});
var $d_Lamf_client_commands_TranslateCommand = new $TypeData().initClass({
  Lamf_client_commands_TranslateCommand: 0
}, false, "amf.client.commands.TranslateCommand", {
  Lamf_client_commands_TranslateCommand: 1,
  O: 1,
  Lamf_client_commands_CommandHelper: 1
});
$c_Lamf_client_commands_TranslateCommand.prototype.$classData = $d_Lamf_client_commands_TranslateCommand;
/** @constructor */
function $c_Lamf_client_commands_ValidateCommand() {
  $c_O.call(this);
  this.platform$1 = null;
  this.executionContext$1 = null
}
$c_Lamf_client_commands_ValidateCommand.prototype = new $h_O();
$c_Lamf_client_commands_ValidateCommand.prototype.constructor = $c_Lamf_client_commands_ValidateCommand;
/** @constructor */
function $h_Lamf_client_commands_ValidateCommand() {
  /*<skip>*/
}
$h_Lamf_client_commands_ValidateCommand.prototype = $c_Lamf_client_commands_ValidateCommand.prototype;
$c_Lamf_client_commands_ValidateCommand.prototype.report__Lamf_core_model_document_BaseUnit__Lamf_core_client_ParserConfig__s_concurrent_Future = (function(model, config) {
  if (config.customProfile$1.isDefined__Z()) {
    var x$1 = $as_T(config.customProfile$1.get__O());
    var x$2 = $m_Lamf_core_errorhandling_UnhandledErrorHandler$();
    $m_Lamf_core_services_RuntimeValidator$();
    var x$3 = $m_Lamf_internal_environment_Environment$().apply__Lamf_internal_environment_Environment();
    var customProfileLoaded = $m_Lamf_core_services_RuntimeValidator$().loadValidationProfile__T__Lamf_internal_environment_Environment__Lamf_core_errorhandling_ErrorHandler__s_concurrent_Future(x$1, x$3, x$2).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(profileName$2) {
        var profileName = $as_Lamf_ProfileName(profileName$2);
        return profileName
      })
    })(this)), this.executionContext$1)
  } else {
    var customProfileLoaded = $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$2, model$1, config$1) {
      return (function() {
        if ((model$1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstance)) {
          var x2 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstance(model$1);
          var x1$2 = $m_Lamf_plugins_document_vocabularies_AMLPlugin$().apply__Lamf_plugins_document_vocabularies_AMLPlugin().registry$2.dialectFor__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__s_Option(x2);
          if ((x1$2 instanceof $c_s_Some)) {
            var x2$2 = $as_s_Some(x1$2);
            var dialect = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(x2$2.value$2);
            return $m_Lamf_ProfileName$().apply__T__Lamf_ProfileName(dialect.nameAndVersion__T())
          } else {
            return config$1.profile$1
          }
        } else {
          return config$1.profile$1
        }
      })
    })(this, model, config)), this.executionContext$1)
  };
  return customProfileLoaded.flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3, model$2) {
    return (function(profileName$3$2) {
      var profileName$3 = $as_Lamf_ProfileName(profileName$3$2);
      return $m_Lamf_core_services_RuntimeValidator$().apply__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_internal_environment_Environment__Z__s_concurrent_Future(model$2, profileName$3, ($m_Lamf_core_services_RuntimeValidator$(), $m_Lamf_AMFStyle$()), ($m_Lamf_core_services_RuntimeValidator$(), $m_Lamf_internal_environment_Environment$().apply__Lamf_internal_environment_Environment()), ($m_Lamf_core_services_RuntimeValidator$(), false))
    })
  })(this, model)), this.executionContext$1)
});
$c_Lamf_client_commands_ValidateCommand.prototype.processOutput__Lamf_core_validation_AMFValidationReport__Lamf_core_client_ParserConfig__V = (function(report, config) {
  var json = $m_Lamf_plugins_features_validation_emitters_ValidationReportJSONLDEmitter$().emitJSON__Lamf_core_validation_AMFValidationReport__T(report);
  var x1 = config.output$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var f = $as_T(x2.value$2);
    var this$1 = this.platform$1;
    var executionContext = this.executionContext$1;
    $f_Lamf_core_remote_Platform__write__T__T__s_concurrent_ExecutionContext__s_concurrent_Future(this$1, f, json, executionContext)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      config.stdout$1.print__T__V(json)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  if ((!report.conforms$1)) {
    var statusCode = $m_Lamf_core_client_ExitCodes$().FailingValidation$1;
    $m_jl_System$();
    var this$4 = $m_jl_Runtime$();
    var this$5 = this$4.currentRuntime$1;
    this$5.halt__I__V(statusCode)
  }
});
$c_Lamf_client_commands_ValidateCommand.prototype.init___Lamf_core_remote_Platform = (function(platform) {
  this.platform$1 = platform;
  this.executionContext$1 = $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext();
  return this
});
$c_Lamf_client_commands_ValidateCommand.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_client_commands_ValidateCommand.prototype.run__Lamf_core_client_ParserConfig__s_concurrent_Future = (function(config) {
  var res = $f_Lamf_client_commands_CommandHelper__AMFInit__s_concurrent_Future(this).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, config$1) {
    return (function(_$2) {
      $asUnit(_$2);
      return $f_Lamf_client_commands_CommandHelper__processDialects__Lamf_core_client_ParserConfig__s_concurrent_Future($this, config$1).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, config$1$1) {
        return (function(_$2$2) {
          $asUnit(_$2$2);
          return $f_Lamf_client_commands_CommandHelper__parseInput__Lamf_core_client_ParserConfig__s_concurrent_Future($this$1, config$1$1).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, config$1$2) {
            return (function(model$2) {
              var model = $as_Lamf_core_model_document_BaseUnit(model$2);
              return $this$2.report__Lamf_core_model_document_BaseUnit__Lamf_core_client_ParserConfig__s_concurrent_Future(model, config$1$2).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, config$1$3) {
                return (function(report$2) {
                  var report = $as_Lamf_core_validation_AMFValidationReport(report$2);
                  $this$3.processOutput__Lamf_core_validation_AMFValidationReport__Lamf_core_client_ParserConfig__V(report, config$1$3)
                })
              })($this$2, config$1$2)), $this$2.executionContext$1)
            })
          })($this$1, config$1$1)), $this$1.executionContext$1)
        })
      })($this, config$1)), $this.executionContext$1)
    })
  })(this, config)), this.executionContext$1);
  res.onComplete__F1__s_concurrent_ExecutionContext__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, config$2) {
    return (function(x0$1$2) {
      var x0$1 = $as_s_util_Try(x0$1$2);
      if ((x0$1 instanceof $c_s_util_Failure)) {
        var x2 = $as_s_util_Failure(x0$1);
        var ex = x2.exception$2;
        config$2.stderr$1.print__jl_Throwable__V(ex);
        var statusCode = $m_Lamf_core_client_ExitCodes$().Exception$1;
        $m_jl_System$();
        var this$4 = $m_jl_Runtime$();
        var this$5 = this$4.currentRuntime$1;
        this$5.halt__I__V(statusCode)
      } else if ((x0$1 instanceof $c_s_util_Success)) {
        var x3 = $as_s_util_Success(x0$1);
        $asUnit(x3.value$2)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, config)), this.executionContext$1);
  return res
});
$c_Lamf_client_commands_ValidateCommand.prototype.executionContext__s_concurrent_ExecutionContext = (function() {
  return this.executionContext$1
});
var $d_Lamf_client_commands_ValidateCommand = new $TypeData().initClass({
  Lamf_client_commands_ValidateCommand: 0
}, false, "amf.client.commands.ValidateCommand", {
  Lamf_client_commands_ValidateCommand: 1,
  O: 1,
  Lamf_client_commands_CommandHelper: 1
});
$c_Lamf_client_commands_ValidateCommand.prototype.$classData = $d_Lamf_client_commands_ValidateCommand;
/** @constructor */
function $c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2$$anon$3() {
  $c_O.call(this);
  this.shape$1 = null;
  this.defaultSeverity$1 = null;
  this.validationMode$1 = null;
  this.env$1 = null;
  this.validator$1$1 = null
}
$c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2$$anon$3.prototype = new $h_O();
$c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2$$anon$3.prototype.constructor = $c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2$$anon$3;
/** @constructor */
function $h_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2$$anon$3() {
  /*<skip>*/
}
$h_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2$$anon$3.prototype = $c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2$$anon$3.prototype;
$c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2$$anon$3.prototype.validate__T__T__s_concurrent_ExecutionContext__s_concurrent_Future = (function(payload, mediaType, executionContext) {
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.validator$1$1.validate(payload, mediaType);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$();
  return new $c_Lamf_client_convert_FutureConverter$ClientFutureOps().init___Lamf_client_convert_FutureConverter__O__Lamf_client_convert_ClientInternalMatcher__s_concurrent_ExecutionContext(this$1, from, m, executionContext).asInternal__s_concurrent_Future()
});
$c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2$$anon$3.prototype.validate__Lamf_core_model_document_PayloadFragment__s_concurrent_ExecutionContext__s_concurrent_Future = (function(payloadFragment, executionContext) {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var jsx$1 = this.validator$1$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PayloadFragmentMatcher__Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$();
  var from = jsx$1.validate(m.asClient__Lamf_core_model_document_PayloadFragment__Lamf_client_model_document_PayloadFragment(payloadFragment));
  var m$1 = $m_Lamf_client_convert_WebApiClientConverters$().ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$();
  return new $c_Lamf_client_convert_FutureConverter$ClientFutureOps().init___Lamf_client_convert_FutureConverter__O__Lamf_client_convert_ClientInternalMatcher__s_concurrent_ExecutionContext(this$2, from, m$1, executionContext).asInternal__s_concurrent_Future()
});
$c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2$$anon$3.prototype.init___Lamf_client_convert_ClientPayloadPluginConverter$$anon$2__Lamf_client_plugins_ClientPayloadValidator = (function($$outer, validator$1) {
  this.validator$1$1 = validator$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = $as_Lamf_client_model_domain_Shape(validator$1.shape);
  $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  this.shape$1 = from.$$undinternal__Lamf_core_model_domain_Shape();
  this.defaultSeverity$1 = $as_T(validator$1.defaultSeverity);
  this.validationMode$1 = $as_Lamf_client_plugins_ValidationMode(validator$1.validationMode);
  this.env$1 = $as_Lamf_client_environment_Environment(validator$1.env).$$undinternal$1;
  return this
});
$c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2$$anon$3.prototype.isValid__T__T__s_concurrent_ExecutionContext__s_concurrent_Future = (function(payload, mediaType, executionContext) {
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.validator$1$1.isValid(payload, mediaType);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().BooleanMatcher__Lamf_client_convert_CoreBaseConverter$BooleanMatcher$();
  return new $c_Lamf_client_convert_FutureConverter$ClientFutureOps().init___Lamf_client_convert_FutureConverter__O__Lamf_client_convert_ClientInternalMatcher__s_concurrent_ExecutionContext(this$1, from, m, executionContext).asInternal__s_concurrent_Future()
});
$c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2$$anon$3.prototype.syncValidate__T__T__Lamf_core_validation_AMFValidationReport = (function(mediaType, payload) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = $as_Lamf_client_validate_ValidationReport(this.validator$1$1.syncValidate(mediaType, payload));
  $m_Lamf_client_convert_WebApiClientConverters$().ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$();
  return from.$$undinternal$1
});
var $d_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2$$anon$3 = new $TypeData().initClass({
  Lamf_client_convert_ClientPayloadPluginConverter$$anon$2$$anon$3: 0
}, false, "amf.client.convert.ClientPayloadPluginConverter$$anon$2$$anon$3", {
  Lamf_client_convert_ClientPayloadPluginConverter$$anon$2$$anon$3: 1,
  O: 1,
  Lamf_core_validation_PayloadValidator: 1
});
$c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2$$anon$3.prototype.$classData = $d_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2$$anon$3;
/** @constructor */
function $c_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$.prototype = new $h_O();
$c_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$.prototype.constructor = $c_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$;
/** @constructor */
function $h_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$.prototype = $c_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$.prototype;
$c_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$.prototype.asInternal__O__O = (function(from) {
  return new $c_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$$anon$1().init___Lamf_client_plugins_ClientAMFPlugin(from)
});
var $d_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$ = new $TypeData().initClass({
  Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$: 0
}, false, "amf.client.convert.ClientPayloadPluginConverter$AMFPluginConverter$", {
  Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$: 1,
  O: 1,
  Lamf_client_convert_ClientInternalMatcher: 1
});
$c_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$.prototype.$classData = $d_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$;
var $n_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$ = (void 0);
function $m_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$() {
  if ((!$n_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$)) {
    $n_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$ = new $c_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$().init___()
  };
  return $n_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$
}
/** @constructor */
function $c_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$$anon$1() {
  $c_O.call(this);
  this.ID$1 = null;
  this.from$1$1 = null
}
$c_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$$anon$1.prototype = new $h_O();
$c_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$$anon$1.prototype.constructor = $c_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$$anon$1;
/** @constructor */
function $h_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$$anon$1() {
  /*<skip>*/
}
$h_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$$anon$1.prototype = $c_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$$anon$1.prototype;
$c_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$$anon$1.prototype.init__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  return new $c_Lamf_client_convert_FutureConverter$ClientFutureOps().init___Lamf_client_convert_FutureConverter__O__Lamf_client_convert_ClientInternalMatcher__s_concurrent_ExecutionContext($m_Lamf_client_convert_WebApiClientConverters$(), this.from$1$1.init(), $m_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$(), executionContext).asInternal__s_concurrent_Future()
});
$c_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$$anon$1.prototype.init___Lamf_client_plugins_ClientAMFPlugin = (function(from$1) {
  this.from$1$1 = from$1;
  this.ID$1 = $as_T(from$1.ID);
  return this
});
$c_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$$anon$1.prototype.ID__T = (function() {
  return this.ID$1
});
$c_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$$anon$1.prototype.dependencies__sc_Seq = (function() {
  return new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher($m_Lamf_client_convert_WebApiClientConverters$(), this.from$1$1.dependencies(), $m_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$()).asInternal__sc_Seq()
});
var $d_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$$anon$1 = new $TypeData().initClass({
  Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$$anon$1: 0
}, false, "amf.client.convert.ClientPayloadPluginConverter$AMFPluginConverter$$anon$1", {
  Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$$anon$1: 1,
  O: 1,
  Lamf_client_plugins_AMFPlugin: 1
});
$c_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$$anon$1.prototype.$classData = $d_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$$anon$1;
/** @constructor */
function $c_Lamf_client_convert_FieldConverter$AnyFieldMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_FieldConverter$AnyFieldMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_FieldConverter$AnyFieldMatcher$.prototype.constructor = $c_Lamf_client_convert_FieldConverter$AnyFieldMatcher$;
/** @constructor */
function $h_Lamf_client_convert_FieldConverter$AnyFieldMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_FieldConverter$AnyFieldMatcher$.prototype = $c_Lamf_client_convert_FieldConverter$AnyFieldMatcher$.prototype;
$c_Lamf_client_convert_FieldConverter$AnyFieldMatcher$.prototype.init___Lamf_client_convert_FieldConverter = (function($$outer) {
  return this
});
$c_Lamf_client_convert_FieldConverter$AnyFieldMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_core_model_AnyField(from);
  return new $c_Lamf_client_model_AnyField().init___Lamf_core_model_AnyField(from$1)
});
var $d_Lamf_client_convert_FieldConverter$AnyFieldMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_FieldConverter$AnyFieldMatcher$: 0
}, false, "amf.client.convert.FieldConverter$AnyFieldMatcher$", {
  Lamf_client_convert_FieldConverter$AnyFieldMatcher$: 1,
  O: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_FieldConverter$AnyFieldMatcher$.prototype.$classData = $d_Lamf_client_convert_FieldConverter$AnyFieldMatcher$;
/** @constructor */
function $c_Lamf_client_convert_FieldConverter$BoolFieldMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_FieldConverter$BoolFieldMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_FieldConverter$BoolFieldMatcher$.prototype.constructor = $c_Lamf_client_convert_FieldConverter$BoolFieldMatcher$;
/** @constructor */
function $h_Lamf_client_convert_FieldConverter$BoolFieldMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_FieldConverter$BoolFieldMatcher$.prototype = $c_Lamf_client_convert_FieldConverter$BoolFieldMatcher$.prototype;
$c_Lamf_client_convert_FieldConverter$BoolFieldMatcher$.prototype.init___Lamf_client_convert_FieldConverter = (function($$outer) {
  return this
});
$c_Lamf_client_convert_FieldConverter$BoolFieldMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_core_model_BoolField(from);
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from$1)
});
var $d_Lamf_client_convert_FieldConverter$BoolFieldMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_FieldConverter$BoolFieldMatcher$: 0
}, false, "amf.client.convert.FieldConverter$BoolFieldMatcher$", {
  Lamf_client_convert_FieldConverter$BoolFieldMatcher$: 1,
  O: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_FieldConverter$BoolFieldMatcher$.prototype.$classData = $d_Lamf_client_convert_FieldConverter$BoolFieldMatcher$;
/** @constructor */
function $c_Lamf_client_convert_FieldConverter$DoubleFieldMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_FieldConverter$DoubleFieldMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_FieldConverter$DoubleFieldMatcher$.prototype.constructor = $c_Lamf_client_convert_FieldConverter$DoubleFieldMatcher$;
/** @constructor */
function $h_Lamf_client_convert_FieldConverter$DoubleFieldMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_FieldConverter$DoubleFieldMatcher$.prototype = $c_Lamf_client_convert_FieldConverter$DoubleFieldMatcher$.prototype;
$c_Lamf_client_convert_FieldConverter$DoubleFieldMatcher$.prototype.init___Lamf_client_convert_FieldConverter = (function($$outer) {
  return this
});
$c_Lamf_client_convert_FieldConverter$DoubleFieldMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_core_model_DoubleField(from);
  return new $c_Lamf_client_model_DoubleField().init___Lamf_core_model_DoubleField(from$1)
});
var $d_Lamf_client_convert_FieldConverter$DoubleFieldMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_FieldConverter$DoubleFieldMatcher$: 0
}, false, "amf.client.convert.FieldConverter$DoubleFieldMatcher$", {
  Lamf_client_convert_FieldConverter$DoubleFieldMatcher$: 1,
  O: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_FieldConverter$DoubleFieldMatcher$.prototype.$classData = $d_Lamf_client_convert_FieldConverter$DoubleFieldMatcher$;
/** @constructor */
function $c_Lamf_client_convert_FieldConverter$IntFieldMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_FieldConverter$IntFieldMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_FieldConverter$IntFieldMatcher$.prototype.constructor = $c_Lamf_client_convert_FieldConverter$IntFieldMatcher$;
/** @constructor */
function $h_Lamf_client_convert_FieldConverter$IntFieldMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_FieldConverter$IntFieldMatcher$.prototype = $c_Lamf_client_convert_FieldConverter$IntFieldMatcher$.prototype;
$c_Lamf_client_convert_FieldConverter$IntFieldMatcher$.prototype.init___Lamf_client_convert_FieldConverter = (function($$outer) {
  return this
});
$c_Lamf_client_convert_FieldConverter$IntFieldMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_core_model_IntField(from);
  return new $c_Lamf_client_model_IntField().init___Lamf_core_model_IntField(from$1)
});
var $d_Lamf_client_convert_FieldConverter$IntFieldMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_FieldConverter$IntFieldMatcher$: 0
}, false, "amf.client.convert.FieldConverter$IntFieldMatcher$", {
  Lamf_client_convert_FieldConverter$IntFieldMatcher$: 1,
  O: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_FieldConverter$IntFieldMatcher$.prototype.$classData = $d_Lamf_client_convert_FieldConverter$IntFieldMatcher$;
/** @constructor */
function $c_Lamf_client_convert_FieldConverter$StrFieldMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_FieldConverter$StrFieldMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_FieldConverter$StrFieldMatcher$.prototype.constructor = $c_Lamf_client_convert_FieldConverter$StrFieldMatcher$;
/** @constructor */
function $h_Lamf_client_convert_FieldConverter$StrFieldMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_FieldConverter$StrFieldMatcher$.prototype = $c_Lamf_client_convert_FieldConverter$StrFieldMatcher$.prototype;
$c_Lamf_client_convert_FieldConverter$StrFieldMatcher$.prototype.init___Lamf_client_convert_FieldConverter = (function($$outer) {
  return this
});
$c_Lamf_client_convert_FieldConverter$StrFieldMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_core_model_StrField(from);
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from$1)
});
var $d_Lamf_client_convert_FieldConverter$StrFieldMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_FieldConverter$StrFieldMatcher$: 0
}, false, "amf.client.convert.FieldConverter$StrFieldMatcher$", {
  Lamf_client_convert_FieldConverter$StrFieldMatcher$: 1,
  O: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_FieldConverter$StrFieldMatcher$.prototype.$classData = $d_Lamf_client_convert_FieldConverter$StrFieldMatcher$;
/** @constructor */
function $c_Lamf_client_environment_DefaultEnvironment$() {
  $c_O.call(this);
  this.platform$1 = null
}
$c_Lamf_client_environment_DefaultEnvironment$.prototype = new $h_O();
$c_Lamf_client_environment_DefaultEnvironment$.prototype.constructor = $c_Lamf_client_environment_DefaultEnvironment$;
/** @constructor */
function $h_Lamf_client_environment_DefaultEnvironment$() {
  /*<skip>*/
}
$h_Lamf_client_environment_DefaultEnvironment$.prototype = $c_Lamf_client_environment_DefaultEnvironment$.prototype;
$c_Lamf_client_environment_DefaultEnvironment$.prototype.init___ = (function() {
  $n_Lamf_client_environment_DefaultEnvironment$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_environment_DefaultEnvironment$.prototype.apply__Lamf_client_environment_Environment = (function() {
  var this$1 = this.platform$1;
  return this.apply__Lamf_client_execution_BaseExecutionEnvironment__Lamf_client_environment_Environment(this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment())
});
$c_Lamf_client_environment_DefaultEnvironment$.prototype.$$js$exported$meth$apply__O = (function() {
  return this.apply__Lamf_client_environment_Environment()
});
$c_Lamf_client_environment_DefaultEnvironment$.prototype.apply__Lamf_client_execution_BaseExecutionEnvironment__Lamf_client_environment_Environment = (function(exec) {
  var executionContext = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.platform$1.loaders__s_concurrent_ExecutionContext__sc_Seq(executionContext);
  var m = $m_Lamf_client_convert_CoreClientConverters$().ResourceLoaderMatcher__Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$();
  var loaders = new $c_Lamf_client_convert_CollectionConverter$InternalSeqOpsWithEC().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcherWithEC__s_concurrent_ExecutionContext(this$1, from, m, executionContext).asClient__O();
  return new $c_Lamf_client_environment_Environment().init___Lamf_client_execution_BaseExecutionEnvironment(exec).withLoaders__sjs_js_Array__Lamf_client_environment_Environment(loaders)
});
$c_Lamf_client_environment_DefaultEnvironment$.prototype.apply = (function() {
  return this.$$js$exported$meth$apply__O()
});
var $d_Lamf_client_environment_DefaultEnvironment$ = new $TypeData().initClass({
  Lamf_client_environment_DefaultEnvironment$: 0
}, false, "amf.client.environment.DefaultEnvironment$", {
  Lamf_client_environment_DefaultEnvironment$: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_client_environment_DefaultEnvironment$.prototype.$classData = $d_Lamf_client_environment_DefaultEnvironment$;
var $n_Lamf_client_environment_DefaultEnvironment$ = (void 0);
function $m_Lamf_client_environment_DefaultEnvironment$() {
  if ((!$n_Lamf_client_environment_DefaultEnvironment$)) {
    $n_Lamf_client_environment_DefaultEnvironment$ = new $c_Lamf_client_environment_DefaultEnvironment$().init___()
  };
  return $n_Lamf_client_environment_DefaultEnvironment$
}
/** @constructor */
function $c_Lamf_client_environment_Environment$$anon$1() {
  $c_O.call(this);
  this.loader$1$1 = null
}
$c_Lamf_client_environment_Environment$$anon$1.prototype = new $h_O();
$c_Lamf_client_environment_Environment$$anon$1.prototype.constructor = $c_Lamf_client_environment_Environment$$anon$1;
/** @constructor */
function $h_Lamf_client_environment_Environment$$anon$1() {
  /*<skip>*/
}
$h_Lamf_client_environment_Environment$$anon$1.prototype = $c_Lamf_client_environment_Environment$$anon$1.prototype;
$c_Lamf_client_environment_Environment$$anon$1.prototype.init___Lamf_client_environment_Environment__Lamf_client_resource_ClientResourceLoader = (function($$outer, loader$1) {
  this.loader$1$1 = loader$1;
  return this
});
$c_Lamf_client_environment_Environment$$anon$1.prototype.$$js$exported$meth$fetch__T__O = (function(resource) {
  return this.fetch__T__sjs_js_Promise(resource)
});
$c_Lamf_client_environment_Environment$$anon$1.prototype.fetch__T__sjs_js_Promise = (function(resource) {
  return this.loader$1$1.fetch(resource)
});
$c_Lamf_client_environment_Environment$$anon$1.prototype.$$js$exported$meth$accepts__T__O = (function(resource) {
  return this.accepts__T__Z(resource)
});
$c_Lamf_client_environment_Environment$$anon$1.prototype.accepts__T__Z = (function(resource) {
  return $uZ(this.loader$1$1.accepts(resource))
});
$c_Lamf_client_environment_Environment$$anon$1.prototype.accepts = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$accepts__T__O(prep)
});
$c_Lamf_client_environment_Environment$$anon$1.prototype.fetch = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$fetch__T__O(prep)
});
var $d_Lamf_client_environment_Environment$$anon$1 = new $TypeData().initClass({
  Lamf_client_environment_Environment$$anon$1: 0
}, false, "amf.client.environment.Environment$$anon$1", {
  Lamf_client_environment_Environment$$anon$1: 1,
  O: 1,
  Lamf_client_resource_ResourceLoader: 1
});
$c_Lamf_client_environment_Environment$$anon$1.prototype.$classData = $d_Lamf_client_environment_Environment$$anon$1;
/** @constructor */
function $c_Lamf_client_environment_Environment$$anon$2() {
  $c_O.call(this);
  this.resolver$1$1 = null
}
$c_Lamf_client_environment_Environment$$anon$2.prototype = new $h_O();
$c_Lamf_client_environment_Environment$$anon$2.prototype.constructor = $c_Lamf_client_environment_Environment$$anon$2;
/** @constructor */
function $h_Lamf_client_environment_Environment$$anon$2() {
  /*<skip>*/
}
$h_Lamf_client_environment_Environment$$anon$2.prototype = $c_Lamf_client_environment_Environment$$anon$2.prototype;
$c_Lamf_client_environment_Environment$$anon$2.prototype.init___Lamf_client_environment_Environment__Lamf_client_reference_ClientReferenceResolver = (function($$outer, resolver$1) {
  this.resolver$1$1 = resolver$1;
  return this
});
$c_Lamf_client_environment_Environment$$anon$2.prototype.$$js$exported$meth$fetch__T__O = (function(url) {
  return this.fetch__T__sjs_js_Promise(url)
});
$c_Lamf_client_environment_Environment$$anon$2.prototype.fetch__T__sjs_js_Promise = (function(url) {
  return this.resolver$1$1.fetch(url)
});
$c_Lamf_client_environment_Environment$$anon$2.prototype.fetch = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$fetch__T__O(prep)
});
var $d_Lamf_client_environment_Environment$$anon$2 = new $TypeData().initClass({
  Lamf_client_environment_Environment$$anon$2: 0
}, false, "amf.client.environment.Environment$$anon$2", {
  Lamf_client_environment_Environment$$anon$2: 1,
  O: 1,
  Lamf_client_reference_ReferenceResolver: 1
});
$c_Lamf_client_environment_Environment$$anon$2.prototype.$classData = $d_Lamf_client_environment_Environment$$anon$2;
/** @constructor */
function $c_Lamf_client_handler_ErrorHandler$$$Lambda$1() {
  $c_O.call(this);
  this.f$1 = null
}
$c_Lamf_client_handler_ErrorHandler$$$Lambda$1.prototype = new $h_O();
$c_Lamf_client_handler_ErrorHandler$$$Lambda$1.prototype.constructor = $c_Lamf_client_handler_ErrorHandler$$$Lambda$1;
/** @constructor */
function $h_Lamf_client_handler_ErrorHandler$$$Lambda$1() {
  /*<skip>*/
}
$h_Lamf_client_handler_ErrorHandler$$$Lambda$1.prototype = $c_Lamf_client_handler_ErrorHandler$$$Lambda$1.prototype;
$c_Lamf_client_handler_ErrorHandler$$$Lambda$1.prototype.init___O = (function(f) {
  this.f$1 = f;
  return this
});
$c_Lamf_client_handler_ErrorHandler$$$Lambda$1.prototype.reportConstraint__T__T__sjs_js_UndefOr__T__sjs_js_UndefOr__T__sjs_js_UndefOr__V = (function(id$3, node$3, property$3, message$3, range$3, level$3, location$3) {
  (0, this.f$1)(id$3, node$3, property$3, message$3, range$3, level$3, location$3)
});
var $d_Lamf_client_handler_ErrorHandler$$$Lambda$1 = new $TypeData().initClass({
  Lamf_client_handler_ErrorHandler$$$Lambda$1: 0
}, false, "amf.client.handler.ErrorHandler$$$Lambda$1", {
  Lamf_client_handler_ErrorHandler$$$Lambda$1: 1,
  O: 1,
  Lamf_client_resolve_ClientErrorHandler: 1
});
$c_Lamf_client_handler_ErrorHandler$$$Lambda$1.prototype.$classData = $d_Lamf_client_handler_ErrorHandler$$$Lambda$1;
function $f_Lamf_client_model_document_DeclaresModel__withDeclaredElement__Lamf_client_model_domain_DomainElement__Lamf_client_model_document_DeclaresModel($thiz, declared) {
  var this$2 = $thiz.$$undinternal__Lamf_core_model_document_DeclaresModel();
  $m_Lamf_client_convert_CoreClientConverters$();
  $m_Lamf_client_convert_CoreClientConverters$().DomainElementMatcher__Lamf_client_convert_DomainElementConverter$DomainElementMatcher$();
  var element = declared.$$undinternal__Lamf_core_model_domain_DomainElement();
  var field = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
  $as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, element));
  return $thiz
}
function $f_Lamf_client_model_document_DeclaresModel__declares__sjs_js_Array($thiz) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = $thiz.$$undinternal__Lamf_core_model_document_DeclaresModel().declares__sc_Seq();
  var m = $m_Lamf_client_convert_CoreClientConverters$().DomainElementMatcher__Lamf_client_convert_DomainElementConverter$DomainElementMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
}
function $f_Lamf_client_model_document_DeclaresModel__withDeclares__sjs_js_Array__Lamf_client_model_document_DeclaresModel($thiz, declares) {
  var this$2 = $thiz.$$undinternal__Lamf_core_model_document_DeclaresModel();
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var m = $m_Lamf_client_convert_CoreClientConverters$().DomainElementMatcher__Lamf_client_convert_DomainElementConverter$DomainElementMatcher$();
  var declarations = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, declares, m).asInternal__sc_Seq();
  var field = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
  $as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, declarations));
  return $thiz
}
function $f_Lamf_client_model_document_EncodesModel__withEncodes__Lamf_client_model_domain_DomainElement__Lamf_client_model_document_EncodesModel($thiz, encoded) {
  var this$2 = $thiz.$$undinternal__Lamf_core_model_document_EncodesModel();
  $m_Lamf_client_convert_CoreClientConverters$();
  $m_Lamf_client_convert_CoreClientConverters$().DomainElementMatcher__Lamf_client_convert_DomainElementConverter$DomainElementMatcher$();
  var encoded$1 = encoded.$$undinternal__Lamf_core_model_domain_DomainElement();
  var field = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
  $as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, encoded$1));
  return $thiz
}
function $f_Lamf_client_model_document_EncodesModel__encodes__Lamf_client_model_domain_DomainElement($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var from = $thiz.$$undinternal__Lamf_core_model_document_EncodesModel().encodes__Lamf_core_model_domain_DomainElement();
  var m = $m_Lamf_client_convert_CoreClientConverters$().DomainElementMatcher__Lamf_client_convert_DomainElementConverter$DomainElementMatcher$();
  return m.asClient__Lamf_core_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(from)
}
/** @constructor */
function $c_Lamf_client_parse_AmfGraphParser() {
  $c_Lamf_client_parse_Parser.call(this);
  this.env$2 = null
}
$c_Lamf_client_parse_AmfGraphParser.prototype = new $h_Lamf_client_parse_Parser();
$c_Lamf_client_parse_AmfGraphParser.prototype.constructor = $c_Lamf_client_parse_AmfGraphParser;
/** @constructor */
function $h_Lamf_client_parse_AmfGraphParser() {
  /*<skip>*/
}
$h_Lamf_client_parse_AmfGraphParser.prototype = $c_Lamf_client_parse_AmfGraphParser.prototype;
$c_Lamf_client_parse_AmfGraphParser.prototype.init___ = (function() {
  $c_Lamf_client_parse_AmfGraphParser.prototype.init___s_Option.call(this, $m_s_None$());
  return this
});
$c_Lamf_client_parse_AmfGraphParser.prototype.init___Lamf_client_environment_Environment = (function(environment) {
  $c_Lamf_client_parse_AmfGraphParser.prototype.init___s_Option.call(this, new $c_s_Some().init___O(environment));
  return this
});
$c_Lamf_client_parse_AmfGraphParser.prototype.init___s_Option = (function(env) {
  this.env$2 = env;
  $c_Lamf_client_parse_Parser.prototype.init___T__T__s_Option.call(this, "AMF Graph", "application/ld+json", env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_graph_AMFGraphPlugin$());
  return this
});
var $d_Lamf_client_parse_AmfGraphParser = new $TypeData().initClass({
  Lamf_client_parse_AmfGraphParser: 0
}, false, "amf.client.parse.AmfGraphParser", {
  Lamf_client_parse_AmfGraphParser: 1,
  Lamf_client_parse_Parser: 1,
  O: 1
});
$c_Lamf_client_parse_AmfGraphParser.prototype.$classData = $d_Lamf_client_parse_AmfGraphParser;
/** @constructor */
function $c_Lamf_client_parse_Aml10Parser() {
  $c_Lamf_client_parse_Parser.call(this);
  this.mediaType$2 = null;
  this.env$2 = null
}
$c_Lamf_client_parse_Aml10Parser.prototype = new $h_Lamf_client_parse_Parser();
$c_Lamf_client_parse_Aml10Parser.prototype.constructor = $c_Lamf_client_parse_Aml10Parser;
/** @constructor */
function $h_Lamf_client_parse_Aml10Parser() {
  /*<skip>*/
}
$h_Lamf_client_parse_Aml10Parser.prototype = $c_Lamf_client_parse_Aml10Parser.prototype;
$c_Lamf_client_parse_Aml10Parser.prototype.init___ = (function() {
  $c_Lamf_client_parse_Aml10Parser.prototype.init___T__s_Option.call(this, "application/yaml", $m_s_None$());
  return this
});
$c_Lamf_client_parse_Aml10Parser.prototype.init___Lamf_client_environment_Environment = (function(env) {
  $c_Lamf_client_parse_Aml10Parser.prototype.init___T__s_Option.call(this, "application/yaml", new $c_s_Some().init___O(env));
  return this
});
$c_Lamf_client_parse_Aml10Parser.prototype.init___T = (function(mediaType) {
  $c_Lamf_client_parse_Aml10Parser.prototype.init___T__s_Option.call(this, mediaType, $m_s_None$());
  return this
});
$c_Lamf_client_parse_Aml10Parser.prototype.init___T__Lamf_client_environment_Environment = (function(mediaType, env) {
  $c_Lamf_client_parse_Aml10Parser.prototype.init___T__s_Option.call(this, mediaType, new $c_s_Some().init___O(env));
  return this
});
$c_Lamf_client_parse_Aml10Parser.prototype.init___T__s_Option = (function(mediaType, env) {
  this.mediaType$2 = mediaType;
  this.env$2 = env;
  $c_Lamf_client_parse_Parser.prototype.init___T__T__s_Option.call(this, "AML 1.0", mediaType, env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_vocabularies_AMLPlugin$());
  return this
});
var $d_Lamf_client_parse_Aml10Parser = new $TypeData().initClass({
  Lamf_client_parse_Aml10Parser: 0
}, false, "amf.client.parse.Aml10Parser", {
  Lamf_client_parse_Aml10Parser: 1,
  Lamf_client_parse_Parser: 1,
  O: 1
});
$c_Lamf_client_parse_Aml10Parser.prototype.$classData = $d_Lamf_client_parse_Aml10Parser;
/** @constructor */
function $c_Lamf_client_parse_Async20JsonParser() {
  $c_Lamf_client_parse_Parser.call(this);
  this.env$2 = null
}
$c_Lamf_client_parse_Async20JsonParser.prototype = new $h_Lamf_client_parse_Parser();
$c_Lamf_client_parse_Async20JsonParser.prototype.constructor = $c_Lamf_client_parse_Async20JsonParser;
/** @constructor */
function $h_Lamf_client_parse_Async20JsonParser() {
  /*<skip>*/
}
$h_Lamf_client_parse_Async20JsonParser.prototype = $c_Lamf_client_parse_Async20JsonParser.prototype;
$c_Lamf_client_parse_Async20JsonParser.prototype.init___ = (function() {
  $c_Lamf_client_parse_Async20JsonParser.prototype.init___s_Option.call(this, $m_s_None$());
  return this
});
$c_Lamf_client_parse_Async20JsonParser.prototype.init___Lamf_client_environment_Environment = (function(env) {
  $c_Lamf_client_parse_Async20JsonParser.prototype.init___s_Option.call(this, new $c_s_Some().init___O(env));
  return this
});
$c_Lamf_client_parse_Async20JsonParser.prototype.init___s_Option = (function(env) {
  this.env$2 = env;
  $c_Lamf_client_parse_Parser.prototype.init___T__T__s_Option.call(this, $m_Lamf_core_remote_AsyncApi20$().name$1, "application/json", env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_webapi_Async20Plugin$());
  return this
});
var $d_Lamf_client_parse_Async20JsonParser = new $TypeData().initClass({
  Lamf_client_parse_Async20JsonParser: 0
}, false, "amf.client.parse.Async20JsonParser", {
  Lamf_client_parse_Async20JsonParser: 1,
  Lamf_client_parse_Parser: 1,
  O: 1
});
$c_Lamf_client_parse_Async20JsonParser.prototype.$classData = $d_Lamf_client_parse_Async20JsonParser;
/** @constructor */
function $c_Lamf_client_parse_Async20Parser() {
  $c_Lamf_client_parse_Parser.call(this);
  this.env$2 = null
}
$c_Lamf_client_parse_Async20Parser.prototype = new $h_Lamf_client_parse_Parser();
$c_Lamf_client_parse_Async20Parser.prototype.constructor = $c_Lamf_client_parse_Async20Parser;
/** @constructor */
function $h_Lamf_client_parse_Async20Parser() {
  /*<skip>*/
}
$h_Lamf_client_parse_Async20Parser.prototype = $c_Lamf_client_parse_Async20Parser.prototype;
$c_Lamf_client_parse_Async20Parser.prototype.init___ = (function() {
  $c_Lamf_client_parse_Async20Parser.prototype.init___s_Option.call(this, $m_s_None$());
  return this
});
$c_Lamf_client_parse_Async20Parser.prototype.init___Lamf_client_environment_Environment = (function(env) {
  $c_Lamf_client_parse_Async20Parser.prototype.init___s_Option.call(this, new $c_s_Some().init___O(env));
  return this
});
$c_Lamf_client_parse_Async20Parser.prototype.init___s_Option = (function(env) {
  this.env$2 = env;
  $c_Lamf_client_parse_Parser.prototype.init___T__T__s_Option.call(this, $m_Lamf_core_remote_AsyncApi20$().name$1, "application/yaml", env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_webapi_Async20Plugin$());
  return this
});
var $d_Lamf_client_parse_Async20Parser = new $TypeData().initClass({
  Lamf_client_parse_Async20Parser: 0
}, false, "amf.client.parse.Async20Parser", {
  Lamf_client_parse_Async20Parser: 1,
  Lamf_client_parse_Parser: 1,
  O: 1
});
$c_Lamf_client_parse_Async20Parser.prototype.$classData = $d_Lamf_client_parse_Async20Parser;
/** @constructor */
function $c_Lamf_client_parse_JsonPayloadParser() {
  $c_Lamf_client_parse_Parser.call(this);
  this.env$2 = null
}
$c_Lamf_client_parse_JsonPayloadParser.prototype = new $h_Lamf_client_parse_Parser();
$c_Lamf_client_parse_JsonPayloadParser.prototype.constructor = $c_Lamf_client_parse_JsonPayloadParser;
/** @constructor */
function $h_Lamf_client_parse_JsonPayloadParser() {
  /*<skip>*/
}
$h_Lamf_client_parse_JsonPayloadParser.prototype = $c_Lamf_client_parse_JsonPayloadParser.prototype;
$c_Lamf_client_parse_JsonPayloadParser.prototype.init___ = (function() {
  $c_Lamf_client_parse_JsonPayloadParser.prototype.init___s_Option.call(this, $m_s_None$());
  return this
});
$c_Lamf_client_parse_JsonPayloadParser.prototype.init___Lamf_client_environment_Environment = (function(environment) {
  $c_Lamf_client_parse_JsonPayloadParser.prototype.init___s_Option.call(this, new $c_s_Some().init___O(environment));
  return this
});
$c_Lamf_client_parse_JsonPayloadParser.prototype.init___s_Option = (function(env) {
  this.env$2 = env;
  $c_Lamf_client_parse_Parser.prototype.init___T__T__s_Option.call(this, $m_Lamf_core_remote_Payload$().name$1, "application/amf+json", env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_webapi_PayloadPlugin$());
  return this
});
var $d_Lamf_client_parse_JsonPayloadParser = new $TypeData().initClass({
  Lamf_client_parse_JsonPayloadParser: 0
}, false, "amf.client.parse.JsonPayloadParser", {
  Lamf_client_parse_JsonPayloadParser: 1,
  Lamf_client_parse_Parser: 1,
  O: 1
});
$c_Lamf_client_parse_JsonPayloadParser.prototype.$classData = $d_Lamf_client_parse_JsonPayloadParser;
/** @constructor */
function $c_Lamf_client_parse_Oas20Parser() {
  $c_Lamf_client_parse_Parser.call(this);
  this.env$2 = null
}
$c_Lamf_client_parse_Oas20Parser.prototype = new $h_Lamf_client_parse_Parser();
$c_Lamf_client_parse_Oas20Parser.prototype.constructor = $c_Lamf_client_parse_Oas20Parser;
/** @constructor */
function $h_Lamf_client_parse_Oas20Parser() {
  /*<skip>*/
}
$h_Lamf_client_parse_Oas20Parser.prototype = $c_Lamf_client_parse_Oas20Parser.prototype;
$c_Lamf_client_parse_Oas20Parser.prototype.init___ = (function() {
  $c_Lamf_client_parse_Oas20Parser.prototype.init___s_Option.call(this, $m_s_None$());
  return this
});
$c_Lamf_client_parse_Oas20Parser.prototype.init___Lamf_client_environment_Environment = (function(environment) {
  $c_Lamf_client_parse_Oas20Parser.prototype.init___s_Option.call(this, new $c_s_Some().init___O(environment));
  return this
});
$c_Lamf_client_parse_Oas20Parser.prototype.init___s_Option = (function(env) {
  this.env$2 = env;
  $c_Lamf_client_parse_Parser.prototype.init___T__T__s_Option.call(this, $m_Lamf_core_remote_Oas20$().name$1, "application/json", env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_webapi_Oas20Plugin$());
  return this
});
var $d_Lamf_client_parse_Oas20Parser = new $TypeData().initClass({
  Lamf_client_parse_Oas20Parser: 0
}, false, "amf.client.parse.Oas20Parser", {
  Lamf_client_parse_Oas20Parser: 1,
  Lamf_client_parse_Parser: 1,
  O: 1
});
$c_Lamf_client_parse_Oas20Parser.prototype.$classData = $d_Lamf_client_parse_Oas20Parser;
/** @constructor */
function $c_Lamf_client_parse_Oas20YamlParser() {
  $c_Lamf_client_parse_Parser.call(this);
  this.env$2 = null
}
$c_Lamf_client_parse_Oas20YamlParser.prototype = new $h_Lamf_client_parse_Parser();
$c_Lamf_client_parse_Oas20YamlParser.prototype.constructor = $c_Lamf_client_parse_Oas20YamlParser;
/** @constructor */
function $h_Lamf_client_parse_Oas20YamlParser() {
  /*<skip>*/
}
$h_Lamf_client_parse_Oas20YamlParser.prototype = $c_Lamf_client_parse_Oas20YamlParser.prototype;
$c_Lamf_client_parse_Oas20YamlParser.prototype.init___ = (function() {
  $c_Lamf_client_parse_Oas20YamlParser.prototype.init___s_Option.call(this, $m_s_None$());
  return this
});
$c_Lamf_client_parse_Oas20YamlParser.prototype.init___Lamf_client_environment_Environment = (function(environment) {
  $c_Lamf_client_parse_Oas20YamlParser.prototype.init___s_Option.call(this, new $c_s_Some().init___O(environment));
  return this
});
$c_Lamf_client_parse_Oas20YamlParser.prototype.init___s_Option = (function(env) {
  this.env$2 = env;
  $c_Lamf_client_parse_Parser.prototype.init___T__T__s_Option.call(this, $m_Lamf_core_remote_Oas20$().name$1, "application/yaml", env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_webapi_Oas20Plugin$());
  return this
});
var $d_Lamf_client_parse_Oas20YamlParser = new $TypeData().initClass({
  Lamf_client_parse_Oas20YamlParser: 0
}, false, "amf.client.parse.Oas20YamlParser", {
  Lamf_client_parse_Oas20YamlParser: 1,
  Lamf_client_parse_Parser: 1,
  O: 1
});
$c_Lamf_client_parse_Oas20YamlParser.prototype.$classData = $d_Lamf_client_parse_Oas20YamlParser;
/** @constructor */
function $c_Lamf_client_parse_Oas30Parser() {
  $c_Lamf_client_parse_Parser.call(this);
  this.env$2 = null
}
$c_Lamf_client_parse_Oas30Parser.prototype = new $h_Lamf_client_parse_Parser();
$c_Lamf_client_parse_Oas30Parser.prototype.constructor = $c_Lamf_client_parse_Oas30Parser;
/** @constructor */
function $h_Lamf_client_parse_Oas30Parser() {
  /*<skip>*/
}
$h_Lamf_client_parse_Oas30Parser.prototype = $c_Lamf_client_parse_Oas30Parser.prototype;
$c_Lamf_client_parse_Oas30Parser.prototype.init___ = (function() {
  $c_Lamf_client_parse_Oas30Parser.prototype.init___s_Option.call(this, $m_s_None$());
  return this
});
$c_Lamf_client_parse_Oas30Parser.prototype.init___Lamf_client_environment_Environment = (function(environment) {
  $c_Lamf_client_parse_Oas30Parser.prototype.init___s_Option.call(this, new $c_s_Some().init___O(environment));
  return this
});
$c_Lamf_client_parse_Oas30Parser.prototype.init___s_Option = (function(env) {
  this.env$2 = env;
  $c_Lamf_client_parse_Parser.prototype.init___T__T__s_Option.call(this, $m_Lamf_core_remote_Oas30$().name$1, "application/json", env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_webapi_Oas30Plugin$());
  return this
});
var $d_Lamf_client_parse_Oas30Parser = new $TypeData().initClass({
  Lamf_client_parse_Oas30Parser: 0
}, false, "amf.client.parse.Oas30Parser", {
  Lamf_client_parse_Oas30Parser: 1,
  Lamf_client_parse_Parser: 1,
  O: 1
});
$c_Lamf_client_parse_Oas30Parser.prototype.$classData = $d_Lamf_client_parse_Oas30Parser;
/** @constructor */
function $c_Lamf_client_parse_Oas30YamlParser() {
  $c_Lamf_client_parse_Parser.call(this);
  this.env$2 = null
}
$c_Lamf_client_parse_Oas30YamlParser.prototype = new $h_Lamf_client_parse_Parser();
$c_Lamf_client_parse_Oas30YamlParser.prototype.constructor = $c_Lamf_client_parse_Oas30YamlParser;
/** @constructor */
function $h_Lamf_client_parse_Oas30YamlParser() {
  /*<skip>*/
}
$h_Lamf_client_parse_Oas30YamlParser.prototype = $c_Lamf_client_parse_Oas30YamlParser.prototype;
$c_Lamf_client_parse_Oas30YamlParser.prototype.init___ = (function() {
  $c_Lamf_client_parse_Oas30YamlParser.prototype.init___s_Option.call(this, $m_s_None$());
  return this
});
$c_Lamf_client_parse_Oas30YamlParser.prototype.init___Lamf_client_environment_Environment = (function(environment) {
  $c_Lamf_client_parse_Oas30YamlParser.prototype.init___s_Option.call(this, new $c_s_Some().init___O(environment));
  return this
});
$c_Lamf_client_parse_Oas30YamlParser.prototype.init___s_Option = (function(env) {
  this.env$2 = env;
  $c_Lamf_client_parse_Parser.prototype.init___T__T__s_Option.call(this, $m_Lamf_core_remote_Oas30$().name$1, "application/yaml", env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_webapi_Oas30Plugin$());
  return this
});
var $d_Lamf_client_parse_Oas30YamlParser = new $TypeData().initClass({
  Lamf_client_parse_Oas30YamlParser: 0
}, false, "amf.client.parse.Oas30YamlParser", {
  Lamf_client_parse_Oas30YamlParser: 1,
  Lamf_client_parse_Parser: 1,
  O: 1
});
$c_Lamf_client_parse_Oas30YamlParser.prototype.$classData = $d_Lamf_client_parse_Oas30YamlParser;
/** @constructor */
function $c_Lamf_client_parse_Raml08Parser() {
  $c_Lamf_client_parse_Parser.call(this);
  this.env$2 = null
}
$c_Lamf_client_parse_Raml08Parser.prototype = new $h_Lamf_client_parse_Parser();
$c_Lamf_client_parse_Raml08Parser.prototype.constructor = $c_Lamf_client_parse_Raml08Parser;
/** @constructor */
function $h_Lamf_client_parse_Raml08Parser() {
  /*<skip>*/
}
$h_Lamf_client_parse_Raml08Parser.prototype = $c_Lamf_client_parse_Raml08Parser.prototype;
$c_Lamf_client_parse_Raml08Parser.prototype.init___ = (function() {
  $c_Lamf_client_parse_Raml08Parser.prototype.init___s_Option.call(this, $m_s_None$());
  return this
});
$c_Lamf_client_parse_Raml08Parser.prototype.init___Lamf_client_environment_Environment = (function(environment) {
  $c_Lamf_client_parse_Raml08Parser.prototype.init___s_Option.call(this, new $c_s_Some().init___O(environment));
  return this
});
$c_Lamf_client_parse_Raml08Parser.prototype.init___s_Option = (function(env) {
  this.env$2 = env;
  $c_Lamf_client_parse_Parser.prototype.init___T__T__s_Option.call(this, $m_Lamf_core_remote_Raml08$().name$1, "application/yaml", env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_webapi_Raml08Plugin$());
  return this
});
var $d_Lamf_client_parse_Raml08Parser = new $TypeData().initClass({
  Lamf_client_parse_Raml08Parser: 0
}, false, "amf.client.parse.Raml08Parser", {
  Lamf_client_parse_Raml08Parser: 1,
  Lamf_client_parse_Parser: 1,
  O: 1
});
$c_Lamf_client_parse_Raml08Parser.prototype.$classData = $d_Lamf_client_parse_Raml08Parser;
/** @constructor */
function $c_Lamf_client_parse_Raml10Parser() {
  $c_Lamf_client_parse_Parser.call(this);
  this.env$2 = null
}
$c_Lamf_client_parse_Raml10Parser.prototype = new $h_Lamf_client_parse_Parser();
$c_Lamf_client_parse_Raml10Parser.prototype.constructor = $c_Lamf_client_parse_Raml10Parser;
/** @constructor */
function $h_Lamf_client_parse_Raml10Parser() {
  /*<skip>*/
}
$h_Lamf_client_parse_Raml10Parser.prototype = $c_Lamf_client_parse_Raml10Parser.prototype;
$c_Lamf_client_parse_Raml10Parser.prototype.init___ = (function() {
  $c_Lamf_client_parse_Raml10Parser.prototype.init___s_Option.call(this, $m_s_None$());
  return this
});
$c_Lamf_client_parse_Raml10Parser.prototype.init___Lamf_client_environment_Environment = (function(environment) {
  $c_Lamf_client_parse_Raml10Parser.prototype.init___s_Option.call(this, new $c_s_Some().init___O(environment));
  return this
});
$c_Lamf_client_parse_Raml10Parser.prototype.init___s_Option = (function(env) {
  this.env$2 = env;
  $c_Lamf_client_parse_Parser.prototype.init___T__T__s_Option.call(this, $m_Lamf_core_remote_Raml10$().name$1, "application/yaml", env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_webapi_Raml10Plugin$());
  return this
});
var $d_Lamf_client_parse_Raml10Parser = new $TypeData().initClass({
  Lamf_client_parse_Raml10Parser: 0
}, false, "amf.client.parse.Raml10Parser", {
  Lamf_client_parse_Raml10Parser: 1,
  Lamf_client_parse_Parser: 1,
  O: 1
});
$c_Lamf_client_parse_Raml10Parser.prototype.$classData = $d_Lamf_client_parse_Raml10Parser;
/** @constructor */
function $c_Lamf_client_parse_RamlParser() {
  $c_Lamf_client_parse_Parser.call(this);
  this.env$2 = null
}
$c_Lamf_client_parse_RamlParser.prototype = new $h_Lamf_client_parse_Parser();
$c_Lamf_client_parse_RamlParser.prototype.constructor = $c_Lamf_client_parse_RamlParser;
/** @constructor */
function $h_Lamf_client_parse_RamlParser() {
  /*<skip>*/
}
$h_Lamf_client_parse_RamlParser.prototype = $c_Lamf_client_parse_RamlParser.prototype;
$c_Lamf_client_parse_RamlParser.prototype.init___ = (function() {
  $c_Lamf_client_parse_RamlParser.prototype.init___s_Option.call(this, $m_s_None$());
  return this
});
$c_Lamf_client_parse_RamlParser.prototype.init___Lamf_client_environment_Environment = (function(environment) {
  $c_Lamf_client_parse_RamlParser.prototype.init___s_Option.call(this, new $c_s_Some().init___O(environment));
  return this
});
$c_Lamf_client_parse_RamlParser.prototype.init___s_Option = (function(env) {
  this.env$2 = env;
  $c_Lamf_client_parse_Parser.prototype.init___T__T__s_Option.call(this, $m_Lamf_core_remote_Raml$().name$1, "application/yaml", env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_webapi_Raml10Plugin$());
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_webapi_Raml08Plugin$());
  return this
});
var $d_Lamf_client_parse_RamlParser = new $TypeData().initClass({
  Lamf_client_parse_RamlParser: 0
}, false, "amf.client.parse.RamlParser", {
  Lamf_client_parse_RamlParser: 1,
  Lamf_client_parse_Parser: 1,
  O: 1
});
$c_Lamf_client_parse_RamlParser.prototype.$classData = $d_Lamf_client_parse_RamlParser;
/** @constructor */
function $c_Lamf_client_parse_YamlPayloadParser() {
  $c_Lamf_client_parse_Parser.call(this);
  this.env$2 = null
}
$c_Lamf_client_parse_YamlPayloadParser.prototype = new $h_Lamf_client_parse_Parser();
$c_Lamf_client_parse_YamlPayloadParser.prototype.constructor = $c_Lamf_client_parse_YamlPayloadParser;
/** @constructor */
function $h_Lamf_client_parse_YamlPayloadParser() {
  /*<skip>*/
}
$h_Lamf_client_parse_YamlPayloadParser.prototype = $c_Lamf_client_parse_YamlPayloadParser.prototype;
$c_Lamf_client_parse_YamlPayloadParser.prototype.init___ = (function() {
  $c_Lamf_client_parse_YamlPayloadParser.prototype.init___s_Option.call(this, $m_s_None$());
  return this
});
$c_Lamf_client_parse_YamlPayloadParser.prototype.init___Lamf_client_environment_Environment = (function(environment) {
  $c_Lamf_client_parse_YamlPayloadParser.prototype.init___s_Option.call(this, new $c_s_Some().init___O(environment));
  return this
});
$c_Lamf_client_parse_YamlPayloadParser.prototype.init___s_Option = (function(env) {
  this.env$2 = env;
  $c_Lamf_client_parse_Parser.prototype.init___T__T__s_Option.call(this, $m_Lamf_core_remote_Payload$().name$1, "application/amf+yaml", env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_webapi_PayloadPlugin$());
  return this
});
var $d_Lamf_client_parse_YamlPayloadParser = new $TypeData().initClass({
  Lamf_client_parse_YamlPayloadParser: 0
}, false, "amf.client.parse.YamlPayloadParser", {
  Lamf_client_parse_YamlPayloadParser: 1,
  Lamf_client_parse_Parser: 1,
  O: 1
});
$c_Lamf_client_parse_YamlPayloadParser.prototype.$classData = $d_Lamf_client_parse_YamlPayloadParser;
/** @constructor */
function $c_Lamf_client_plugins_AMFDocumentPlugin() {
  $c_O.call(this);
  this.priority$1 = 0
}
$c_Lamf_client_plugins_AMFDocumentPlugin.prototype = new $h_O();
$c_Lamf_client_plugins_AMFDocumentPlugin.prototype.constructor = $c_Lamf_client_plugins_AMFDocumentPlugin;
/** @constructor */
function $h_Lamf_client_plugins_AMFDocumentPlugin() {
  /*<skip>*/
}
$h_Lamf_client_plugins_AMFDocumentPlugin.prototype = $c_Lamf_client_plugins_AMFDocumentPlugin.prototype;
$c_Lamf_client_plugins_AMFDocumentPlugin.prototype.init___ = (function() {
  this.priority$1 = $m_Lamf_client_plugins_AMFDocumentPluginSettings$PluginPriorities$().default$1;
  return this
});
$c_Lamf_client_plugins_AMFDocumentPlugin.prototype.modelEntitiesResolver__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_plugins_AMFDocumentPlugin.prototype.emit__Lamf_core_model_document_BaseUnit__Lorg_yaml_builder_DocBuilder__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__Z = (function(unit, builder, renderOptions, shapeRenderOptions) {
  if ((builder instanceof $c_Lorg_yaml_builder_YDocumentBuilder)) {
    var x2 = $as_Lorg_yaml_builder_YDocumentBuilder(builder);
    var this$1 = this.unparseAsYDocument__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__s_Option(unit, renderOptions, shapeRenderOptions);
    if ((!this$1.isEmpty__Z())) {
      var arg1 = this$1.get__O();
      var doc = $as_Lorg_yaml_model_YDocument(arg1);
      x2.document$und$eq__Lorg_yaml_model_YPart__V(doc);
      return true
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_client_plugins_AMFDocumentPlugin.prototype.priority__I = (function() {
  return this.priority$1
});
function $as_Lamf_client_plugins_AMFDocumentPlugin(obj) {
  return (((obj instanceof $c_Lamf_client_plugins_AMFDocumentPlugin) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.plugins.AMFDocumentPlugin"))
}
function $isArrayOf_Lamf_client_plugins_AMFDocumentPlugin(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_plugins_AMFDocumentPlugin)))
}
function $asArrayOf_Lamf_client_plugins_AMFDocumentPlugin(obj, depth) {
  return (($isArrayOf_Lamf_client_plugins_AMFDocumentPlugin(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.plugins.AMFDocumentPlugin;", depth))
}
/** @constructor */
function $c_Lamf_client_plugins_AMFDomainPlugin() {
  $c_O.call(this)
}
$c_Lamf_client_plugins_AMFDomainPlugin.prototype = new $h_O();
$c_Lamf_client_plugins_AMFDomainPlugin.prototype.constructor = $c_Lamf_client_plugins_AMFDomainPlugin;
/** @constructor */
function $h_Lamf_client_plugins_AMFDomainPlugin() {
  /*<skip>*/
}
$h_Lamf_client_plugins_AMFDomainPlugin.prototype = $c_Lamf_client_plugins_AMFDomainPlugin.prototype;
function $as_Lamf_client_plugins_AMFDomainPlugin(obj) {
  return (((obj instanceof $c_Lamf_client_plugins_AMFDomainPlugin) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.plugins.AMFDomainPlugin"))
}
function $isArrayOf_Lamf_client_plugins_AMFDomainPlugin(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_plugins_AMFDomainPlugin)))
}
function $asArrayOf_Lamf_client_plugins_AMFDomainPlugin(obj, depth) {
  return (($isArrayOf_Lamf_client_plugins_AMFDomainPlugin(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.plugins.AMFDomainPlugin;", depth))
}
/** @constructor */
function $c_Lamf_client_plugins_AMFSyntaxPlugin() {
  $c_O.call(this)
}
$c_Lamf_client_plugins_AMFSyntaxPlugin.prototype = new $h_O();
$c_Lamf_client_plugins_AMFSyntaxPlugin.prototype.constructor = $c_Lamf_client_plugins_AMFSyntaxPlugin;
/** @constructor */
function $h_Lamf_client_plugins_AMFSyntaxPlugin() {
  /*<skip>*/
}
$h_Lamf_client_plugins_AMFSyntaxPlugin.prototype = $c_Lamf_client_plugins_AMFSyntaxPlugin.prototype;
$c_Lamf_client_plugins_AMFSyntaxPlugin.prototype.unparse__T__Lamf_core_parser_ParsedDocument__s_Option = (function(mediaType, ast) {
  var this$2 = this.unparse__T__Lamf_core_parser_ParsedDocument__O__Lorg_mulesoft_common_io_Output__s_Option(mediaType, ast, new $c_Ljava_io_StringWriter().init___(), $m_Lorg_mulesoft_common_io_Output$OutputWriter$());
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var x$1 = $as_Ljava_io_StringWriter(arg1);
    return new $c_s_Some().init___O(x$1.toString__T())
  }
});
function $as_Lamf_client_plugins_AMFSyntaxPlugin(obj) {
  return (((obj instanceof $c_Lamf_client_plugins_AMFSyntaxPlugin) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.plugins.AMFSyntaxPlugin"))
}
function $isArrayOf_Lamf_client_plugins_AMFSyntaxPlugin(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_plugins_AMFSyntaxPlugin)))
}
function $asArrayOf_Lamf_client_plugins_AMFSyntaxPlugin(obj, depth) {
  return (($isArrayOf_Lamf_client_plugins_AMFSyntaxPlugin(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.plugins.AMFSyntaxPlugin;", depth))
}
function $is_Lamf_client_plugins_AMFValidationPlugin(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_client_plugins_AMFValidationPlugin)))
}
function $as_Lamf_client_plugins_AMFValidationPlugin(obj) {
  return (($is_Lamf_client_plugins_AMFValidationPlugin(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.plugins.AMFValidationPlugin"))
}
function $isArrayOf_Lamf_client_plugins_AMFValidationPlugin(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_plugins_AMFValidationPlugin)))
}
function $asArrayOf_Lamf_client_plugins_AMFValidationPlugin(obj, depth) {
  return (($isArrayOf_Lamf_client_plugins_AMFValidationPlugin(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.plugins.AMFValidationPlugin;", depth))
}
/** @constructor */
function $c_Lamf_client_plugins_ScalarRelaxedValidationMode$() {
  $c_O.call(this)
}
$c_Lamf_client_plugins_ScalarRelaxedValidationMode$.prototype = new $h_O();
$c_Lamf_client_plugins_ScalarRelaxedValidationMode$.prototype.constructor = $c_Lamf_client_plugins_ScalarRelaxedValidationMode$;
/** @constructor */
function $h_Lamf_client_plugins_ScalarRelaxedValidationMode$() {
  /*<skip>*/
}
$h_Lamf_client_plugins_ScalarRelaxedValidationMode$.prototype = $c_Lamf_client_plugins_ScalarRelaxedValidationMode$.prototype;
$c_Lamf_client_plugins_ScalarRelaxedValidationMode$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_client_plugins_ScalarRelaxedValidationMode$ = new $TypeData().initClass({
  Lamf_client_plugins_ScalarRelaxedValidationMode$: 0
}, false, "amf.client.plugins.ScalarRelaxedValidationMode$", {
  Lamf_client_plugins_ScalarRelaxedValidationMode$: 1,
  O: 1,
  Lamf_client_plugins_ValidationMode: 1
});
$c_Lamf_client_plugins_ScalarRelaxedValidationMode$.prototype.$classData = $d_Lamf_client_plugins_ScalarRelaxedValidationMode$;
var $n_Lamf_client_plugins_ScalarRelaxedValidationMode$ = (void 0);
function $m_Lamf_client_plugins_ScalarRelaxedValidationMode$() {
  if ((!$n_Lamf_client_plugins_ScalarRelaxedValidationMode$)) {
    $n_Lamf_client_plugins_ScalarRelaxedValidationMode$ = new $c_Lamf_client_plugins_ScalarRelaxedValidationMode$().init___()
  };
  return $n_Lamf_client_plugins_ScalarRelaxedValidationMode$
}
/** @constructor */
function $c_Lamf_client_plugins_StrictValidationMode$() {
  $c_O.call(this)
}
$c_Lamf_client_plugins_StrictValidationMode$.prototype = new $h_O();
$c_Lamf_client_plugins_StrictValidationMode$.prototype.constructor = $c_Lamf_client_plugins_StrictValidationMode$;
/** @constructor */
function $h_Lamf_client_plugins_StrictValidationMode$() {
  /*<skip>*/
}
$h_Lamf_client_plugins_StrictValidationMode$.prototype = $c_Lamf_client_plugins_StrictValidationMode$.prototype;
$c_Lamf_client_plugins_StrictValidationMode$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_client_plugins_StrictValidationMode$ = new $TypeData().initClass({
  Lamf_client_plugins_StrictValidationMode$: 0
}, false, "amf.client.plugins.StrictValidationMode$", {
  Lamf_client_plugins_StrictValidationMode$: 1,
  O: 1,
  Lamf_client_plugins_ValidationMode: 1
});
$c_Lamf_client_plugins_StrictValidationMode$.prototype.$classData = $d_Lamf_client_plugins_StrictValidationMode$;
var $n_Lamf_client_plugins_StrictValidationMode$ = (void 0);
function $m_Lamf_client_plugins_StrictValidationMode$() {
  if ((!$n_Lamf_client_plugins_StrictValidationMode$)) {
    $n_Lamf_client_plugins_StrictValidationMode$ = new $c_Lamf_client_plugins_StrictValidationMode$().init___()
  };
  return $n_Lamf_client_plugins_StrictValidationMode$
}
/** @constructor */
function $c_Lamf_client_render_JsonSchemaDraft4$() {
  $c_O.call(this)
}
$c_Lamf_client_render_JsonSchemaDraft4$.prototype = new $h_O();
$c_Lamf_client_render_JsonSchemaDraft4$.prototype.constructor = $c_Lamf_client_render_JsonSchemaDraft4$;
/** @constructor */
function $h_Lamf_client_render_JsonSchemaDraft4$() {
  /*<skip>*/
}
$h_Lamf_client_render_JsonSchemaDraft4$.prototype = $c_Lamf_client_render_JsonSchemaDraft4$.prototype;
$c_Lamf_client_render_JsonSchemaDraft4$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_client_render_JsonSchemaDraft4$ = new $TypeData().initClass({
  Lamf_client_render_JsonSchemaDraft4$: 0
}, false, "amf.client.render.JsonSchemaDraft4$", {
  Lamf_client_render_JsonSchemaDraft4$: 1,
  O: 1,
  Lamf_client_render_JSONSchemaVersion: 1
});
$c_Lamf_client_render_JsonSchemaDraft4$.prototype.$classData = $d_Lamf_client_render_JsonSchemaDraft4$;
var $n_Lamf_client_render_JsonSchemaDraft4$ = (void 0);
function $m_Lamf_client_render_JsonSchemaDraft4$() {
  if ((!$n_Lamf_client_render_JsonSchemaDraft4$)) {
    $n_Lamf_client_render_JsonSchemaDraft4$ = new $c_Lamf_client_render_JsonSchemaDraft4$().init___()
  };
  return $n_Lamf_client_render_JsonSchemaDraft4$
}
/** @constructor */
function $c_Lamf_client_render_JsonSchemaDraft7$() {
  $c_O.call(this)
}
$c_Lamf_client_render_JsonSchemaDraft7$.prototype = new $h_O();
$c_Lamf_client_render_JsonSchemaDraft7$.prototype.constructor = $c_Lamf_client_render_JsonSchemaDraft7$;
/** @constructor */
function $h_Lamf_client_render_JsonSchemaDraft7$() {
  /*<skip>*/
}
$h_Lamf_client_render_JsonSchemaDraft7$.prototype = $c_Lamf_client_render_JsonSchemaDraft7$.prototype;
$c_Lamf_client_render_JsonSchemaDraft7$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_client_render_JsonSchemaDraft7$ = new $TypeData().initClass({
  Lamf_client_render_JsonSchemaDraft7$: 0
}, false, "amf.client.render.JsonSchemaDraft7$", {
  Lamf_client_render_JsonSchemaDraft7$: 1,
  O: 1,
  Lamf_client_render_JSONSchemaVersion: 1
});
$c_Lamf_client_render_JsonSchemaDraft7$.prototype.$classData = $d_Lamf_client_render_JsonSchemaDraft7$;
var $n_Lamf_client_render_JsonSchemaDraft7$ = (void 0);
function $m_Lamf_client_render_JsonSchemaDraft7$() {
  if ((!$n_Lamf_client_render_JsonSchemaDraft7$)) {
    $n_Lamf_client_render_JsonSchemaDraft7$ = new $c_Lamf_client_render_JsonSchemaDraft7$().init___()
  };
  return $n_Lamf_client_render_JsonSchemaDraft7$
}
/** @constructor */
function $c_Lamf_client_render_Renderer() {
  $c_O.call(this);
  this.vendor$1 = null;
  this.mediaType$1 = null;
  this.env$1 = null;
  this.executionContext$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_render_Renderer.prototype = new $h_O();
$c_Lamf_client_render_Renderer.prototype.constructor = $c_Lamf_client_render_Renderer;
/** @constructor */
function $h_Lamf_client_render_Renderer() {
  /*<skip>*/
}
$h_Lamf_client_render_Renderer.prototype = $c_Lamf_client_render_Renderer.prototype;
$c_Lamf_client_render_Renderer.prototype.generateToWriter__Lamf_client_model_document_BaseUnit__Lamf_client_render_RenderOptions__Lorg_mulesoft_common_io_LimitedStringBuffer__sjs_js_Promise = (function(unit, options, writer) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.generate__p1__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__O__Lorg_mulesoft_common_io_Output__s_concurrent_Future(unit.$$undinternal__Lamf_core_model_document_BaseUnit(), $m_Lamf_core_emitter_RenderOptions$().apply__Lamf_client_render_RenderOptions__Lamf_core_emitter_RenderOptions(options), writer, $m_Lorg_mulesoft_common_io_Output$StringBufferWriter$());
  var m = $m_Lamf_client_convert_CoreClientConverters$().UnitMatcher__Lamf_client_convert_CoreBaseConverter$UnitMatcher$();
  var executionContext = this.executionContext$1;
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$1, from, m, executionContext).asClient__O()
});
$c_Lamf_client_render_Renderer.prototype.generate__p1__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__O__Lorg_mulesoft_common_io_Output__s_concurrent_Future = (function(unit, options, writer, evidence$1) {
  return new $c_Lamf_core_AMFSerializer().init___Lamf_core_model_document_BaseUnit__T__T__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions(unit, this.mediaType__T(), this.vendor$1, options, new $c_Lamf_core_emitter_ShapeRenderOptions().init___()).renderToWriter__O__Lorg_mulesoft_common_io_Output__s_concurrent_ExecutionContext__s_concurrent_Future(writer, evidence$1, this.executionContext$1)
});
$c_Lamf_client_render_Renderer.prototype.generate__p1__Lamf_core_model_document_BaseUnit__T__Lamf_core_emitter_RenderOptions__s_concurrent_Future = (function(unit, url, options) {
  return new $c_Lamf_core_AMFSerializer().init___Lamf_core_model_document_BaseUnit__T__T__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions(unit, this.mediaType__T(), this.vendor$1, options, new $c_Lamf_core_emitter_ShapeRenderOptions().init___()).renderToFile__Lamf_core_remote_Platform__T__s_concurrent_ExecutionContext__s_concurrent_Future(this.platform$1, url, this.executionContext$1)
});
$c_Lamf_client_render_Renderer.prototype.$$js$exported$meth$generateFile__Lamf_client_model_document_BaseUnit__T__O = (function(unit, url) {
  return this.generateFile__Lamf_client_model_document_BaseUnit__T__Lamf_client_render_RenderOptions__sjs_js_Promise(unit, url, new $c_Lamf_client_render_RenderOptions().init___())
});
$c_Lamf_client_render_Renderer.prototype.$$js$exported$meth$generateFile__Lamf_client_model_document_BaseUnit__T__Lamf_client_render_RenderOptions__O = (function(unit, url, options) {
  return this.generateFile__Lamf_client_model_document_BaseUnit__T__Lamf_client_render_RenderOptions__sjs_js_Promise(unit, url, options)
});
$c_Lamf_client_render_Renderer.prototype.$$js$exported$meth$generateToWriter__Lamf_client_model_document_BaseUnit__Lorg_mulesoft_common_io_LimitedStringBuffer__O = (function(unit, writer) {
  return this.generateToWriter__Lamf_client_model_document_BaseUnit__Lamf_client_render_RenderOptions__Lorg_mulesoft_common_io_LimitedStringBuffer__sjs_js_Promise(unit, new $c_Lamf_client_render_RenderOptions().init___(), writer)
});
$c_Lamf_client_render_Renderer.prototype.$$js$exported$meth$generateString__Lamf_client_model_document_BaseUnit__Lamf_client_render_RenderOptions__O = (function(unit, options) {
  return this.generateString__Lamf_client_model_document_BaseUnit__Lamf_client_render_RenderOptions__sjs_js_Promise(unit, options)
});
$c_Lamf_client_render_Renderer.prototype.generate__p1__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__Lorg_yaml_builder_DocBuilder__s_concurrent_Future = (function(unit, options, builder) {
  return new $c_Lamf_core_AMFSerializer().init___Lamf_core_model_document_BaseUnit__T__T__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions(unit, this.mediaType__T(), this.vendor$1, options, new $c_Lamf_core_emitter_ShapeRenderOptions().init___()).renderToBuilder__Lorg_yaml_builder_DocBuilder__s_concurrent_ExecutionContext__s_concurrent_Future(builder, this.executionContext$1)
});
$c_Lamf_client_render_Renderer.prototype.generate__p1__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__s_concurrent_Future = (function(unit, options) {
  return new $c_Lamf_core_AMFSerializer().init___Lamf_core_model_document_BaseUnit__T__T__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions(unit, this.mediaType__T(), this.vendor$1, options, new $c_Lamf_core_emitter_ShapeRenderOptions().init___()).renderToString__s_concurrent_ExecutionContext__s_concurrent_Future(this.executionContext$1)
});
$c_Lamf_client_render_Renderer.prototype.$$js$exported$meth$generateToWriter__Lamf_client_model_document_BaseUnit__Lamf_client_render_RenderOptions__Lorg_mulesoft_common_io_LimitedStringBuffer__O = (function(unit, options, writer) {
  return this.generateToWriter__Lamf_client_model_document_BaseUnit__Lamf_client_render_RenderOptions__Lorg_mulesoft_common_io_LimitedStringBuffer__sjs_js_Promise(unit, options, writer)
});
$c_Lamf_client_render_Renderer.prototype.generateToWriter__Lamf_client_model_document_BaseUnit__Lamf_client_render_RenderOptions__Ljava_io_Writer__sjs_js_Promise = (function(unit, options, writer) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.generate__p1__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__O__Lorg_mulesoft_common_io_Output__s_concurrent_Future(unit.$$undinternal__Lamf_core_model_document_BaseUnit(), $m_Lamf_core_emitter_RenderOptions$().apply__Lamf_client_render_RenderOptions__Lamf_core_emitter_RenderOptions(options), writer, $m_Lorg_mulesoft_common_io_Output$OutputWriter$());
  var m = $m_Lamf_client_convert_CoreClientConverters$().UnitMatcher__Lamf_client_convert_CoreBaseConverter$UnitMatcher$();
  var executionContext = this.executionContext$1;
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$1, from, m, executionContext).asClient__O()
});
$c_Lamf_client_render_Renderer.prototype.generateString__Lamf_client_model_document_BaseUnit__Lamf_client_render_RenderOptions__sjs_js_Promise = (function(unit, options) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.generate__p1__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__s_concurrent_Future(unit.$$undinternal__Lamf_core_model_document_BaseUnit(), $m_Lamf_core_emitter_RenderOptions$().apply__Lamf_client_render_RenderOptions__Lamf_core_emitter_RenderOptions(options));
  var m = $m_Lamf_client_convert_CoreClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  var executionContext = this.executionContext$1;
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$1, from, m, executionContext).asClient__O()
});
$c_Lamf_client_render_Renderer.prototype.mediaType__T = (function() {
  return this.mediaType$1
});
$c_Lamf_client_render_Renderer.prototype.$$js$exported$meth$generateToWriter__Lamf_client_model_document_BaseUnit__Lamf_client_render_RenderOptions__Ljava_io_Writer__O = (function(unit, options, writer) {
  return this.generateToWriter__Lamf_client_model_document_BaseUnit__Lamf_client_render_RenderOptions__Ljava_io_Writer__sjs_js_Promise(unit, options, writer)
});
$c_Lamf_client_render_Renderer.prototype.$$js$exported$meth$generateToWriter__Lamf_client_model_document_BaseUnit__Ljava_io_Writer__O = (function(unit, writer) {
  return this.generateToWriter__Lamf_client_model_document_BaseUnit__Lamf_client_render_RenderOptions__Ljava_io_Writer__sjs_js_Promise(unit, new $c_Lamf_client_render_RenderOptions().init___(), writer)
});
$c_Lamf_client_render_Renderer.prototype.$$js$exported$meth$generateString__Lamf_client_model_document_BaseUnit__O = (function(unit) {
  return this.generateString__Lamf_client_model_document_BaseUnit__Lamf_client_render_RenderOptions__sjs_js_Promise(unit, new $c_Lamf_client_render_RenderOptions().init___())
});
$c_Lamf_client_render_Renderer.prototype.genToBuilder__Lamf_client_model_document_BaseUnit__Lamf_client_render_RenderOptions__Lorg_yaml_builder_DocBuilder__sjs_js_Promise = (function(unit, options, builder) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.generate__p1__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__Lorg_yaml_builder_DocBuilder__s_concurrent_Future(unit.$$undinternal__Lamf_core_model_document_BaseUnit(), $m_Lamf_core_emitter_RenderOptions$().apply__Lamf_client_render_RenderOptions__Lamf_core_emitter_RenderOptions(options), builder);
  var m = $m_Lamf_client_convert_CoreClientConverters$().UnitMatcher__Lamf_client_convert_CoreBaseConverter$UnitMatcher$();
  var executionContext = this.executionContext$1;
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$1, from, m, executionContext).asClient__O()
});
$c_Lamf_client_render_Renderer.prototype.init___T__T__s_Option = (function(vendor, mediaType, env) {
  this.vendor$1 = vendor;
  this.mediaType$1 = mediaType;
  this.env$1 = env;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  if ((env instanceof $c_s_Some)) {
    var x2 = $as_s_Some(env);
    var environment = $as_Lamf_client_environment_Environment(x2.value$2);
    var this$2 = environment.executionEnvironment__Lamf_client_execution_BaseExecutionEnvironment();
    var jsx$1 = this$2.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1
  } else {
    var x = $m_s_None$();
    if ((x === env)) {
      var this$3 = this.platform$1;
      var this$4 = this$3.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
      var jsx$1 = this$4.$$undinternal$1.context$1
    } else {
      var jsx$1;
      throw new $c_s_MatchError().init___O(env)
    }
  };
  this.executionContext$1 = jsx$1;
  return this
});
$c_Lamf_client_render_Renderer.prototype.generateFile__Lamf_client_model_document_BaseUnit__T__Lamf_client_render_RenderOptions__sjs_js_Promise = (function(unit, url, options) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.generate__p1__Lamf_core_model_document_BaseUnit__T__Lamf_core_emitter_RenderOptions__s_concurrent_Future(unit.$$undinternal__Lamf_core_model_document_BaseUnit(), url, $m_Lamf_core_emitter_RenderOptions$().apply__Lamf_client_render_RenderOptions__Lamf_core_emitter_RenderOptions(options));
  var m = $m_Lamf_client_convert_CoreClientConverters$().UnitMatcher__Lamf_client_convert_CoreBaseConverter$UnitMatcher$();
  var executionContext = this.executionContext$1;
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$1, from, m, executionContext).asClient__O()
});
$c_Lamf_client_render_Renderer.prototype.generateToWriter = (function(arg, arg$2) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 2;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      if ((rest[0] instanceof $c_Ljava_io_Writer)) {
        var prep$4 = $as_Lamf_client_model_document_BaseUnit(arg);
        var prep$5 = $as_Lamf_client_render_RenderOptions(arg$2);
        var prep$6 = $as_Ljava_io_Writer(rest[0]);
        return this.$$js$exported$meth$generateToWriter__Lamf_client_model_document_BaseUnit__Lamf_client_render_RenderOptions__Ljava_io_Writer__O(prep$4, prep$5, prep$6)
      } else if ((rest[0] instanceof $c_Lorg_mulesoft_common_io_LimitedStringBuffer)) {
        var prep = $as_Lamf_client_model_document_BaseUnit(arg);
        var prep$2 = $as_Lamf_client_render_RenderOptions(arg$2);
        var prep$3 = $as_Lorg_mulesoft_common_io_LimitedStringBuffer(rest[0]);
        return this.$$js$exported$meth$generateToWriter__Lamf_client_model_document_BaseUnit__Lamf_client_render_RenderOptions__Lorg_mulesoft_common_io_LimitedStringBuffer__O(prep, prep$2, prep$3)
      } else {
        throw "No matching overload"
      };
      break
    }
    case 0: {
      if ((arg$2 instanceof $c_Ljava_io_Writer)) {
        var prep$9 = $as_Lamf_client_model_document_BaseUnit(arg);
        var prep$10 = $as_Ljava_io_Writer(arg$2);
        return this.$$js$exported$meth$generateToWriter__Lamf_client_model_document_BaseUnit__Ljava_io_Writer__O(prep$9, prep$10)
      } else if ((arg$2 instanceof $c_Lorg_mulesoft_common_io_LimitedStringBuffer)) {
        var prep$7 = $as_Lamf_client_model_document_BaseUnit(arg);
        var prep$8 = $as_Lorg_mulesoft_common_io_LimitedStringBuffer(arg$2);
        return this.$$js$exported$meth$generateToWriter__Lamf_client_model_document_BaseUnit__Lorg_mulesoft_common_io_LimitedStringBuffer__O(prep$7, prep$8)
      } else {
        throw "No matching overload"
      };
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_render_Renderer.prototype.generateString = (function(arg) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 1;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      var prep = $as_Lamf_client_model_document_BaseUnit(arg);
      return this.$$js$exported$meth$generateString__Lamf_client_model_document_BaseUnit__O(prep);
      break
    }
    case 1: {
      var prep$2 = $as_Lamf_client_model_document_BaseUnit(arg);
      var prep$3 = $as_Lamf_client_render_RenderOptions(rest[0]);
      return this.$$js$exported$meth$generateString__Lamf_client_model_document_BaseUnit__Lamf_client_render_RenderOptions__O(prep$2, prep$3);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_render_Renderer.prototype.generateFile = (function(arg, arg$2) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 2;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_client_model_document_BaseUnit(arg);
      var prep$2 = $as_T(arg$2);
      var prep$3 = $as_Lamf_client_render_RenderOptions(rest[0]);
      return this.$$js$exported$meth$generateFile__Lamf_client_model_document_BaseUnit__T__Lamf_client_render_RenderOptions__O(prep, prep$2, prep$3);
      break
    }
    case 0: {
      var prep$4 = $as_Lamf_client_model_document_BaseUnit(arg);
      var prep$5 = $as_T(arg$2);
      return this.$$js$exported$meth$generateFile__Lamf_client_model_document_BaseUnit__T__O(prep$4, prep$5);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
var $d_Lamf_client_render_Renderer = new $TypeData().initClass({
  Lamf_client_render_Renderer: 0
}, false, "amf.client.render.Renderer", {
  Lamf_client_render_Renderer: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_client_render_Renderer.prototype.$classData = $d_Lamf_client_render_Renderer;
/** @constructor */
function $c_Lamf_client_render_Unspecified$() {
  $c_O.call(this)
}
$c_Lamf_client_render_Unspecified$.prototype = new $h_O();
$c_Lamf_client_render_Unspecified$.prototype.constructor = $c_Lamf_client_render_Unspecified$;
/** @constructor */
function $h_Lamf_client_render_Unspecified$() {
  /*<skip>*/
}
$h_Lamf_client_render_Unspecified$.prototype = $c_Lamf_client_render_Unspecified$.prototype;
$c_Lamf_client_render_Unspecified$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_client_render_Unspecified$ = new $TypeData().initClass({
  Lamf_client_render_Unspecified$: 0
}, false, "amf.client.render.Unspecified$", {
  Lamf_client_render_Unspecified$: 1,
  O: 1,
  Lamf_client_render_JSONSchemaVersion: 1
});
$c_Lamf_client_render_Unspecified$.prototype.$classData = $d_Lamf_client_render_Unspecified$;
var $n_Lamf_client_render_Unspecified$ = (void 0);
function $m_Lamf_client_render_Unspecified$() {
  if ((!$n_Lamf_client_render_Unspecified$)) {
    $n_Lamf_client_render_Unspecified$ = new $c_Lamf_client_render_Unspecified$().init___()
  };
  return $n_Lamf_client_render_Unspecified$
}
/** @constructor */
function $c_Lamf_client_resolve_AmfGraphResolver() {
  $c_Lamf_client_resolve_Resolver.call(this)
}
$c_Lamf_client_resolve_AmfGraphResolver.prototype = new $h_Lamf_client_resolve_Resolver();
$c_Lamf_client_resolve_AmfGraphResolver.prototype.constructor = $c_Lamf_client_resolve_AmfGraphResolver;
/** @constructor */
function $h_Lamf_client_resolve_AmfGraphResolver() {
  /*<skip>*/
}
$h_Lamf_client_resolve_AmfGraphResolver.prototype = $c_Lamf_client_resolve_AmfGraphResolver.prototype;
$c_Lamf_client_resolve_AmfGraphResolver.prototype.init___ = (function() {
  $c_Lamf_client_resolve_Resolver.prototype.init___T.call(this, "AMF Graph");
  return this
});
var $d_Lamf_client_resolve_AmfGraphResolver = new $TypeData().initClass({
  Lamf_client_resolve_AmfGraphResolver: 0
}, false, "amf.client.resolve.AmfGraphResolver", {
  Lamf_client_resolve_AmfGraphResolver: 1,
  Lamf_client_resolve_Resolver: 1,
  O: 1
});
$c_Lamf_client_resolve_AmfGraphResolver.prototype.$classData = $d_Lamf_client_resolve_AmfGraphResolver;
/** @constructor */
function $c_Lamf_client_resolve_Async20Resolver() {
  $c_Lamf_client_resolve_Resolver.call(this)
}
$c_Lamf_client_resolve_Async20Resolver.prototype = new $h_Lamf_client_resolve_Resolver();
$c_Lamf_client_resolve_Async20Resolver.prototype.constructor = $c_Lamf_client_resolve_Async20Resolver;
/** @constructor */
function $h_Lamf_client_resolve_Async20Resolver() {
  /*<skip>*/
}
$h_Lamf_client_resolve_Async20Resolver.prototype = $c_Lamf_client_resolve_Async20Resolver.prototype;
$c_Lamf_client_resolve_Async20Resolver.prototype.init___ = (function() {
  $c_Lamf_client_resolve_Resolver.prototype.init___T.call(this, $m_Lamf_core_remote_AsyncApi20$().name$1);
  return this
});
var $d_Lamf_client_resolve_Async20Resolver = new $TypeData().initClass({
  Lamf_client_resolve_Async20Resolver: 0
}, false, "amf.client.resolve.Async20Resolver", {
  Lamf_client_resolve_Async20Resolver: 1,
  Lamf_client_resolve_Resolver: 1,
  O: 1
});
$c_Lamf_client_resolve_Async20Resolver.prototype.$classData = $d_Lamf_client_resolve_Async20Resolver;
/** @constructor */
function $c_Lamf_client_resolve_ClientErrorHandlerConverter$$$Lambda$1() {
  $c_O.call(this);
  this.f$1 = null
}
$c_Lamf_client_resolve_ClientErrorHandlerConverter$$$Lambda$1.prototype = new $h_O();
$c_Lamf_client_resolve_ClientErrorHandlerConverter$$$Lambda$1.prototype.constructor = $c_Lamf_client_resolve_ClientErrorHandlerConverter$$$Lambda$1;
/** @constructor */
function $h_Lamf_client_resolve_ClientErrorHandlerConverter$$$Lambda$1() {
  /*<skip>*/
}
$h_Lamf_client_resolve_ClientErrorHandlerConverter$$$Lambda$1.prototype = $c_Lamf_client_resolve_ClientErrorHandlerConverter$$$Lambda$1.prototype;
$c_Lamf_client_resolve_ClientErrorHandlerConverter$$$Lambda$1.prototype.init___O = (function(f) {
  this.f$1 = f;
  return this
});
$c_Lamf_client_resolve_ClientErrorHandlerConverter$$$Lambda$1.prototype.reportConstraint__T__T__sjs_js_UndefOr__T__sjs_js_UndefOr__T__sjs_js_UndefOr__V = (function(id$3, node$3, property$3, message$3, range$3, level$3, location$3) {
  (0, this.f$1)(id$3, node$3, property$3, message$3, range$3, level$3, location$3)
});
var $d_Lamf_client_resolve_ClientErrorHandlerConverter$$$Lambda$1 = new $TypeData().initClass({
  Lamf_client_resolve_ClientErrorHandlerConverter$$$Lambda$1: 0
}, false, "amf.client.resolve.ClientErrorHandlerConverter$$$Lambda$1", {
  Lamf_client_resolve_ClientErrorHandlerConverter$$$Lambda$1: 1,
  O: 1,
  Lamf_client_resolve_ClientErrorHandler: 1
});
$c_Lamf_client_resolve_ClientErrorHandlerConverter$$$Lambda$1.prototype.$classData = $d_Lamf_client_resolve_ClientErrorHandlerConverter$$$Lambda$1;
/** @constructor */
function $c_Lamf_client_resolve_ClientErrorHandlerConverter$$anonfun$convert$2() {
  $c_O.call(this);
  this.clientErrorHandler$1$1 = null
}
$c_Lamf_client_resolve_ClientErrorHandlerConverter$$anonfun$convert$2.prototype = new $h_O();
$c_Lamf_client_resolve_ClientErrorHandlerConverter$$anonfun$convert$2.prototype.constructor = $c_Lamf_client_resolve_ClientErrorHandlerConverter$$anonfun$convert$2;
/** @constructor */
function $h_Lamf_client_resolve_ClientErrorHandlerConverter$$anonfun$convert$2() {
  /*<skip>*/
}
$h_Lamf_client_resolve_ClientErrorHandlerConverter$$anonfun$convert$2.prototype = $c_Lamf_client_resolve_ClientErrorHandlerConverter$$anonfun$convert$2.prototype;
$c_Lamf_client_resolve_ClientErrorHandlerConverter$$anonfun$convert$2.prototype.init___Lamf_client_resolve_ClientErrorHandler = (function(clientErrorHandler$1) {
  this.clientErrorHandler$1$1 = clientErrorHandler$1;
  return this
});
$c_Lamf_client_resolve_ClientErrorHandlerConverter$$anonfun$convert$2.prototype.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V = (function(specification, node, property, message, lexical, location) {
  this.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().WARNING$1, location)
});
$c_Lamf_client_resolve_ClientErrorHandlerConverter$$anonfun$convert$2.prototype.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V = (function(id, node, property, message, lexical, level, location) {
  $m_Lamf_client_resolve_ClientErrorHandlerConverter$().amf$client$resolve$ClientErrorHandlerConverter$$$anonfun$convert$1__T__T__s_Option__T__s_Option__T__s_Option__Lamf_client_resolve_ClientErrorHandler__V(id, node, property, message, lexical, level, location, this.clientErrorHandler$1$1)
});
var $d_Lamf_client_resolve_ClientErrorHandlerConverter$$anonfun$convert$2 = new $TypeData().initClass({
  Lamf_client_resolve_ClientErrorHandlerConverter$$anonfun$convert$2: 0
}, false, "amf.client.resolve.ClientErrorHandlerConverter$$anonfun$convert$2", {
  Lamf_client_resolve_ClientErrorHandlerConverter$$anonfun$convert$2: 1,
  O: 1,
  Lamf_core_errorhandling_ErrorHandler: 1
});
$c_Lamf_client_resolve_ClientErrorHandlerConverter$$anonfun$convert$2.prototype.$classData = $d_Lamf_client_resolve_ClientErrorHandlerConverter$$anonfun$convert$2;
/** @constructor */
function $c_Lamf_client_resolve_Oas20Resolver() {
  $c_Lamf_client_resolve_Resolver.call(this)
}
$c_Lamf_client_resolve_Oas20Resolver.prototype = new $h_Lamf_client_resolve_Resolver();
$c_Lamf_client_resolve_Oas20Resolver.prototype.constructor = $c_Lamf_client_resolve_Oas20Resolver;
/** @constructor */
function $h_Lamf_client_resolve_Oas20Resolver() {
  /*<skip>*/
}
$h_Lamf_client_resolve_Oas20Resolver.prototype = $c_Lamf_client_resolve_Oas20Resolver.prototype;
$c_Lamf_client_resolve_Oas20Resolver.prototype.init___ = (function() {
  $c_Lamf_client_resolve_Resolver.prototype.init___T.call(this, $m_Lamf_core_remote_Oas20$().name$1);
  return this
});
var $d_Lamf_client_resolve_Oas20Resolver = new $TypeData().initClass({
  Lamf_client_resolve_Oas20Resolver: 0
}, false, "amf.client.resolve.Oas20Resolver", {
  Lamf_client_resolve_Oas20Resolver: 1,
  Lamf_client_resolve_Resolver: 1,
  O: 1
});
$c_Lamf_client_resolve_Oas20Resolver.prototype.$classData = $d_Lamf_client_resolve_Oas20Resolver;
/** @constructor */
function $c_Lamf_client_resolve_Oas30Resolver() {
  $c_Lamf_client_resolve_Resolver.call(this)
}
$c_Lamf_client_resolve_Oas30Resolver.prototype = new $h_Lamf_client_resolve_Resolver();
$c_Lamf_client_resolve_Oas30Resolver.prototype.constructor = $c_Lamf_client_resolve_Oas30Resolver;
/** @constructor */
function $h_Lamf_client_resolve_Oas30Resolver() {
  /*<skip>*/
}
$h_Lamf_client_resolve_Oas30Resolver.prototype = $c_Lamf_client_resolve_Oas30Resolver.prototype;
$c_Lamf_client_resolve_Oas30Resolver.prototype.init___ = (function() {
  $c_Lamf_client_resolve_Resolver.prototype.init___T.call(this, $m_Lamf_core_remote_Oas30$().name$1);
  return this
});
var $d_Lamf_client_resolve_Oas30Resolver = new $TypeData().initClass({
  Lamf_client_resolve_Oas30Resolver: 0
}, false, "amf.client.resolve.Oas30Resolver", {
  Lamf_client_resolve_Oas30Resolver: 1,
  Lamf_client_resolve_Resolver: 1,
  O: 1
});
$c_Lamf_client_resolve_Oas30Resolver.prototype.$classData = $d_Lamf_client_resolve_Oas30Resolver;
/** @constructor */
function $c_Lamf_client_resolve_Raml08Resolver() {
  $c_Lamf_client_resolve_Resolver.call(this)
}
$c_Lamf_client_resolve_Raml08Resolver.prototype = new $h_Lamf_client_resolve_Resolver();
$c_Lamf_client_resolve_Raml08Resolver.prototype.constructor = $c_Lamf_client_resolve_Raml08Resolver;
/** @constructor */
function $h_Lamf_client_resolve_Raml08Resolver() {
  /*<skip>*/
}
$h_Lamf_client_resolve_Raml08Resolver.prototype = $c_Lamf_client_resolve_Raml08Resolver.prototype;
$c_Lamf_client_resolve_Raml08Resolver.prototype.init___ = (function() {
  $c_Lamf_client_resolve_Resolver.prototype.init___T.call(this, $m_Lamf_core_remote_Raml08$().name$1);
  return this
});
var $d_Lamf_client_resolve_Raml08Resolver = new $TypeData().initClass({
  Lamf_client_resolve_Raml08Resolver: 0
}, false, "amf.client.resolve.Raml08Resolver", {
  Lamf_client_resolve_Raml08Resolver: 1,
  Lamf_client_resolve_Resolver: 1,
  O: 1
});
$c_Lamf_client_resolve_Raml08Resolver.prototype.$classData = $d_Lamf_client_resolve_Raml08Resolver;
/** @constructor */
function $c_Lamf_client_resolve_Raml10Resolver() {
  $c_Lamf_client_resolve_Resolver.call(this)
}
$c_Lamf_client_resolve_Raml10Resolver.prototype = new $h_Lamf_client_resolve_Resolver();
$c_Lamf_client_resolve_Raml10Resolver.prototype.constructor = $c_Lamf_client_resolve_Raml10Resolver;
/** @constructor */
function $h_Lamf_client_resolve_Raml10Resolver() {
  /*<skip>*/
}
$h_Lamf_client_resolve_Raml10Resolver.prototype = $c_Lamf_client_resolve_Raml10Resolver.prototype;
$c_Lamf_client_resolve_Raml10Resolver.prototype.init___ = (function() {
  $c_Lamf_client_resolve_Resolver.prototype.init___T.call(this, $m_Lamf_core_remote_Raml10$().name$1);
  return this
});
var $d_Lamf_client_resolve_Raml10Resolver = new $TypeData().initClass({
  Lamf_client_resolve_Raml10Resolver: 0
}, false, "amf.client.resolve.Raml10Resolver", {
  Lamf_client_resolve_Raml10Resolver: 1,
  Lamf_client_resolve_Resolver: 1,
  O: 1
});
$c_Lamf_client_resolve_Raml10Resolver.prototype.$classData = $d_Lamf_client_resolve_Raml10Resolver;
/** @constructor */
function $c_Lamf_client_resource_BaseHttpResourceLoader() {
  $c_O.call(this)
}
$c_Lamf_client_resource_BaseHttpResourceLoader.prototype = new $h_O();
$c_Lamf_client_resource_BaseHttpResourceLoader.prototype.constructor = $c_Lamf_client_resource_BaseHttpResourceLoader;
/** @constructor */
function $h_Lamf_client_resource_BaseHttpResourceLoader() {
  /*<skip>*/
}
$h_Lamf_client_resource_BaseHttpResourceLoader.prototype = $c_Lamf_client_resource_BaseHttpResourceLoader.prototype;
$c_Lamf_client_resource_BaseHttpResourceLoader.prototype.$$js$exported$meth$accepts__T__O = (function(resource) {
  return this.accepts__T__Z(resource)
});
$c_Lamf_client_resource_BaseHttpResourceLoader.prototype.accepts__T__Z = (function(resource) {
  var o10 = $m_Lamf_core_remote_HttpParts$().unapply__T__s_Option(resource);
  if ((!o10.isEmpty__Z())) {
    return true
  };
  return false
});
$c_Lamf_client_resource_BaseHttpResourceLoader.prototype.fetch = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$fetch__T__O(prep)
});
$c_Lamf_client_resource_BaseHttpResourceLoader.prototype.accepts = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$accepts__T__O(prep)
});
/** @constructor */
function $c_Lamf_core_AMFCompiler$$$Lambda$1() {
  $c_O.call(this);
  this.f$1 = null
}
$c_Lamf_core_AMFCompiler$$$Lambda$1.prototype = new $h_O();
$c_Lamf_core_AMFCompiler$$$Lambda$1.prototype.constructor = $c_Lamf_core_AMFCompiler$$$Lambda$1;
/** @constructor */
function $h_Lamf_core_AMFCompiler$$$Lambda$1() {
  /*<skip>*/
}
$h_Lamf_core_AMFCompiler$$$Lambda$1.prototype = $c_Lamf_core_AMFCompiler$$$Lambda$1.prototype;
$c_Lamf_core_AMFCompiler$$$Lambda$1.prototype.init___O = (function(f) {
  this.f$1 = f;
  return this
});
$c_Lamf_core_AMFCompiler$$$Lambda$1.prototype.build__Lamf_core_CompilerContext__s_Option__s_Option__Lamf_core_parser_ReferenceKind__Lamf_core_client_ParsingOptions__s_concurrent_Future = (function(compilerContext$3, mediaType$3, vendor$3, referenceKind$3, parsingOptions$3) {
  return $as_s_concurrent_Future((0, this.f$1)(compilerContext$3, mediaType$3, vendor$3, referenceKind$3, parsingOptions$3))
});
var $d_Lamf_core_AMFCompiler$$$Lambda$1 = new $TypeData().initClass({
  Lamf_core_AMFCompiler$$$Lambda$1: 0
}, false, "amf.core.AMFCompiler$$$Lambda$1", {
  Lamf_core_AMFCompiler$$$Lambda$1: 1,
  O: 1,
  Lamf_core_services_RuntimeCompiler: 1
});
$c_Lamf_core_AMFCompiler$$$Lambda$1.prototype.$classData = $d_Lamf_core_AMFCompiler$$$Lambda$1;
/** @constructor */
function $c_Lamf_core_AMFSerializer$$anon$1() {
  $c_O.call(this);
  this.executionContext$1$1 = null
}
$c_Lamf_core_AMFSerializer$$anon$1.prototype = new $h_O();
$c_Lamf_core_AMFSerializer$$anon$1.prototype.constructor = $c_Lamf_core_AMFSerializer$$anon$1;
/** @constructor */
function $h_Lamf_core_AMFSerializer$$anon$1() {
  /*<skip>*/
}
$h_Lamf_core_AMFSerializer$$anon$1.prototype = $c_Lamf_core_AMFSerializer$$anon$1.prototype;
$c_Lamf_core_AMFSerializer$$anon$1.prototype.dump__Lamf_core_model_document_BaseUnit__T__T__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__T = (function(unit, mediaType, vendor, options, shapeOptions) {
  return new $c_Lamf_core_AMFSerializer().init___Lamf_core_model_document_BaseUnit__T__T__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions(unit, mediaType, vendor, options, shapeOptions).amf$core$AMFSerializer$$render__T()
});
$c_Lamf_core_AMFSerializer$$anon$1.prototype.init___s_concurrent_ExecutionContext = (function(executionContext$1) {
  this.executionContext$1$1 = executionContext$1;
  return this
});
$c_Lamf_core_AMFSerializer$$anon$1.prototype.dumpToFile__Lamf_core_remote_Platform__T__Lamf_core_model_document_BaseUnit__T__T__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__s_concurrent_Future = (function(platform, file, unit, mediaType, vendor, options, shapeOptions) {
  return new $c_Lamf_core_AMFSerializer().init___Lamf_core_model_document_BaseUnit__T__T__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions(unit, mediaType, vendor, options, shapeOptions).renderToFile__Lamf_core_remote_Platform__T__s_concurrent_ExecutionContext__s_concurrent_Future(platform, file, this.executionContext$1$1)
});
var $d_Lamf_core_AMFSerializer$$anon$1 = new $TypeData().initClass({
  Lamf_core_AMFSerializer$$anon$1: 0
}, false, "amf.core.AMFSerializer$$anon$1", {
  Lamf_core_AMFSerializer$$anon$1: 1,
  O: 1,
  Lamf_core_services_RuntimeSerializer: 1
});
$c_Lamf_core_AMFSerializer$$anon$1.prototype.$classData = $d_Lamf_core_AMFSerializer$$anon$1;
/** @constructor */
function $c_Lamf_core_client_RuntimeProc$() {
  $c_Lamf_core_client_Proc.call(this)
}
$c_Lamf_core_client_RuntimeProc$.prototype = new $h_Lamf_core_client_Proc();
$c_Lamf_core_client_RuntimeProc$.prototype.constructor = $c_Lamf_core_client_RuntimeProc$;
/** @constructor */
function $h_Lamf_core_client_RuntimeProc$() {
  /*<skip>*/
}
$h_Lamf_core_client_RuntimeProc$.prototype = $c_Lamf_core_client_RuntimeProc$.prototype;
$c_Lamf_core_client_RuntimeProc$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_core_client_RuntimeProc$ = new $TypeData().initClass({
  Lamf_core_client_RuntimeProc$: 0
}, false, "amf.core.client.RuntimeProc$", {
  Lamf_core_client_RuntimeProc$: 1,
  Lamf_core_client_Proc: 1,
  O: 1
});
$c_Lamf_core_client_RuntimeProc$.prototype.$classData = $d_Lamf_core_client_RuntimeProc$;
var $n_Lamf_core_client_RuntimeProc$ = (void 0);
function $m_Lamf_core_client_RuntimeProc$() {
  if ((!$n_Lamf_core_client_RuntimeProc$)) {
    $n_Lamf_core_client_RuntimeProc$ = new $c_Lamf_core_client_RuntimeProc$().init___()
  };
  return $n_Lamf_core_client_RuntimeProc$
}
/** @constructor */
function $c_Lamf_core_client_StdErrWriter$() {
  $c_Lamf_core_client_ProcWriter.call(this)
}
$c_Lamf_core_client_StdErrWriter$.prototype = new $h_Lamf_core_client_ProcWriter();
$c_Lamf_core_client_StdErrWriter$.prototype.constructor = $c_Lamf_core_client_StdErrWriter$;
/** @constructor */
function $h_Lamf_core_client_StdErrWriter$() {
  /*<skip>*/
}
$h_Lamf_core_client_StdErrWriter$.prototype = $c_Lamf_core_client_StdErrWriter$.prototype;
$c_Lamf_core_client_StdErrWriter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_client_StdErrWriter$.prototype.print__T__V = (function(s) {
  $m_jl_System$().err$1.println__T__V(s)
});
$c_Lamf_core_client_StdErrWriter$.prototype.print__jl_Throwable__V = (function(e) {
  var this$1 = $m_jl_System$().err$1;
  this$1.java$lang$JSConsoleBasedPrintStream$$printString__T__V((e + "\n"))
});
var $d_Lamf_core_client_StdErrWriter$ = new $TypeData().initClass({
  Lamf_core_client_StdErrWriter$: 0
}, false, "amf.core.client.StdErrWriter$", {
  Lamf_core_client_StdErrWriter$: 1,
  Lamf_core_client_ProcWriter: 1,
  O: 1
});
$c_Lamf_core_client_StdErrWriter$.prototype.$classData = $d_Lamf_core_client_StdErrWriter$;
var $n_Lamf_core_client_StdErrWriter$ = (void 0);
function $m_Lamf_core_client_StdErrWriter$() {
  if ((!$n_Lamf_core_client_StdErrWriter$)) {
    $n_Lamf_core_client_StdErrWriter$ = new $c_Lamf_core_client_StdErrWriter$().init___()
  };
  return $n_Lamf_core_client_StdErrWriter$
}
function $f_Lamf_core_emitter_BaseEmitters_package$BaseValueEmitter__$$init$__V($thiz) {
  var x1 = $thiz.f__Lamf_core_parser_FieldEntry().field$1.type$1;
  var x = $m_Lamf_core_metamodel_Type$Date$();
  if (x.equals__O__Z(x1)) {
    var jsx$1 = $m_Lorg_yaml_model_YType$().Timestamp$1
  } else {
    var x$3 = $m_Lamf_core_metamodel_Type$Int$();
    if (x$3.equals__O__Z(x1)) {
      var jsx$1 = $m_Lorg_yaml_model_YType$().Int$1
    } else {
      var x$5 = $m_Lamf_core_metamodel_Type$Bool$();
      if (x$5.equals__O__Z(x1)) {
        var jsx$1 = $m_Lorg_yaml_model_YType$().Bool$1
      } else {
        var x$7 = $m_Lamf_core_metamodel_Type$Double$();
        if (x$7.equals__O__Z(x1)) {
          var jsx$2 = true
        } else {
          var x$9 = $m_Lamf_core_metamodel_Type$Float$();
          var jsx$2 = x$9.equals__O__Z(x1)
        };
        if (jsx$2) {
          var jsx$1 = $m_Lorg_yaml_model_YType$().Float$1
        } else {
          var jsx$1 = $m_Lorg_yaml_model_YType$().Str$1
        }
      }
    }
  };
  $thiz.amf$core$emitter$BaseEmitters$BaseValueEmitter$$undsetter$und$tag$und$eq__Lorg_yaml_model_YType__V(jsx$1)
}
function $f_Lamf_core_emitter_BaseEmitters_package$BaseValueEmitter__position__Lamf_core_parser_Position($thiz) {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = $thiz.f__Lamf_core_parser_FieldEntry().value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
}
function $f_Lamf_core_errorhandling_ErrorCollector__$$init$__V($thiz) {
  $thiz.amf$core$errorhandling$ErrorCollector$$undsetter$und$amf$core$errorhandling$ErrorCollector$$errors$und$eq__scm_ListBuffer__V($as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())))
}
function $f_Lamf_core_errorhandling_ErrorCollector__handlerAmfResult__Lamf_core_validation_AMFValidationResult__Z($thiz, result) {
  var this$1 = $thiz.amf$core$errorhandling$ErrorCollector$$errors__scm_ListBuffer();
  var this$2 = this$1.scala$collection$mutable$ListBuffer$$start$6;
  inlinereturn$5: {
    var these = this$2;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      var v = $as_Lamf_core_validation_AMFValidationResult(arg1);
      if (v.equals__O__Z(result)) {
        var jsx$1 = true;
        break inlinereturn$5
      };
      these = $as_sc_LinearSeqOptimized(these.tail__O())
    };
    var jsx$1 = false
  };
  if ((!jsx$1)) {
    $thiz.amf$core$errorhandling$ErrorCollector$$errors__scm_ListBuffer().$$plus$eq__O__scm_ListBuffer(result);
    return true
  } else {
    return false
  }
}
/** @constructor */
function $c_Lamf_core_lexer_CharStream() {
  $c_O.call(this)
}
$c_Lamf_core_lexer_CharStream.prototype = new $h_O();
$c_Lamf_core_lexer_CharStream.prototype.constructor = $c_Lamf_core_lexer_CharStream;
/** @constructor */
function $h_Lamf_core_lexer_CharStream() {
  /*<skip>*/
}
$h_Lamf_core_lexer_CharStream.prototype = $c_Lamf_core_lexer_CharStream.prototype;
/** @constructor */
function $c_Lamf_core_metamodel_Type$Any$() {
  $c_O.call(this);
  this.type$1 = null
}
$c_Lamf_core_metamodel_Type$Any$.prototype = new $h_O();
$c_Lamf_core_metamodel_Type$Any$.prototype.constructor = $c_Lamf_core_metamodel_Type$Any$;
/** @constructor */
function $h_Lamf_core_metamodel_Type$Any$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_Type$Any$.prototype = $c_Lamf_core_metamodel_Type$Any$.prototype;
$c_Lamf_core_metamodel_Type$Any$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_Type$Any$ = this;
  $m_sci_List$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Xsd$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "anyType")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  this.type$1 = result;
  return this
});
$c_Lamf_core_metamodel_Type$Any$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_core_metamodel_Type$Any$ = new $TypeData().initClass({
  Lamf_core_metamodel_Type$Any$: 0
}, false, "amf.core.metamodel.Type$Any$", {
  Lamf_core_metamodel_Type$Any$: 1,
  O: 1,
  Lamf_core_metamodel_Type: 1
});
$c_Lamf_core_metamodel_Type$Any$.prototype.$classData = $d_Lamf_core_metamodel_Type$Any$;
var $n_Lamf_core_metamodel_Type$Any$ = (void 0);
function $m_Lamf_core_metamodel_Type$Any$() {
  if ((!$n_Lamf_core_metamodel_Type$Any$)) {
    $n_Lamf_core_metamodel_Type$Any$ = new $c_Lamf_core_metamodel_Type$Any$().init___()
  };
  return $n_Lamf_core_metamodel_Type$Any$
}
/** @constructor */
function $c_Lamf_core_metamodel_Type$ArrayLike() {
  $c_O.call(this);
  this.element$1 = null;
  this.type$1 = null
}
$c_Lamf_core_metamodel_Type$ArrayLike.prototype = new $h_O();
$c_Lamf_core_metamodel_Type$ArrayLike.prototype.constructor = $c_Lamf_core_metamodel_Type$ArrayLike;
/** @constructor */
function $h_Lamf_core_metamodel_Type$ArrayLike() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_Type$ArrayLike.prototype = $c_Lamf_core_metamodel_Type$ArrayLike.prototype;
$c_Lamf_core_metamodel_Type$ArrayLike.prototype.init___Lamf_core_metamodel_Type = (function(element) {
  this.element$1 = element;
  this.type$1 = element.type__sci_List();
  return this
});
$c_Lamf_core_metamodel_Type$ArrayLike.prototype.type__sci_List = (function() {
  return this.type$1
});
function $as_Lamf_core_metamodel_Type$ArrayLike(obj) {
  return (((obj instanceof $c_Lamf_core_metamodel_Type$ArrayLike) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.metamodel.Type$ArrayLike"))
}
function $isArrayOf_Lamf_core_metamodel_Type$ArrayLike(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_metamodel_Type$ArrayLike)))
}
function $asArrayOf_Lamf_core_metamodel_Type$ArrayLike(obj, depth) {
  return (($isArrayOf_Lamf_core_metamodel_Type$ArrayLike(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.metamodel.Type$ArrayLike;", depth))
}
function $f_Lamf_core_metamodel_domain_ExternalSourceElementModel__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Raw$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "raw"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "raw", "Raw textual information that cannot be processed for the current model semantics.", $m_sci_Nil$()), true));
  var jsx$2 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$ReferenceId$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "reference-id"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "reference id", "Internal identifier for an inlined fragment", $m_sci_Nil$()), true));
  var jsx$3 = $m_Lamf_core_metamodel_Type$Str$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "location"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "location", "Location of an inlined fragment", $m_sci_Nil$()), true))
}
function $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "link-target"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "link target", "URI of the linked element", $m_sci_Nil$()), true));
  var jsx$2 = $m_Lamf_core_metamodel_domain_DomainElementModel$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "effective-target"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "effective target", "URI of the final element in a chain of linked elements", $m_sci_Nil$()), true));
  var jsx$3 = $m_Lamf_core_metamodel_Type$Str$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "link-label"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "link label", "Label for the type of link", $m_sci_Nil$()), true));
  var jsx$4 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "recursive"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "supports recursion", "Indication taht this kind of linkable element can support recursive links", $m_sci_Nil$()), true))
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_common_DescriptionField$() {
  $c_O.call(this);
  this.Description$1 = null
}
$c_Lamf_core_metamodel_domain_common_DescriptionField$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_common_DescriptionField$.prototype.constructor = $c_Lamf_core_metamodel_domain_common_DescriptionField$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_common_DescriptionField$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_common_DescriptionField$.prototype = $c_Lamf_core_metamodel_domain_common_DescriptionField$.prototype;
$c_Lamf_core_metamodel_domain_common_DescriptionField$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_common_DescriptionField$ = this;
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  return this
});
$c_Lamf_core_metamodel_domain_common_DescriptionField$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
var $d_Lamf_core_metamodel_domain_common_DescriptionField$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_common_DescriptionField$: 0
}, false, "amf.core.metamodel.domain.common.DescriptionField$", {
  Lamf_core_metamodel_domain_common_DescriptionField$: 1,
  O: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1
});
$c_Lamf_core_metamodel_domain_common_DescriptionField$.prototype.$classData = $d_Lamf_core_metamodel_domain_common_DescriptionField$;
var $n_Lamf_core_metamodel_domain_common_DescriptionField$ = (void 0);
function $m_Lamf_core_metamodel_domain_common_DescriptionField$() {
  if ((!$n_Lamf_core_metamodel_domain_common_DescriptionField$)) {
    $n_Lamf_core_metamodel_domain_common_DescriptionField$ = new $c_Lamf_core_metamodel_domain_common_DescriptionField$().init___()
  };
  return $n_Lamf_core_metamodel_domain_common_DescriptionField$
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_common_DisplayNameField$() {
  $c_O.call(this);
  this.DisplayName$1 = null
}
$c_Lamf_core_metamodel_domain_common_DisplayNameField$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_common_DisplayNameField$.prototype.constructor = $c_Lamf_core_metamodel_domain_common_DisplayNameField$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_common_DisplayNameField$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_common_DisplayNameField$.prototype = $c_Lamf_core_metamodel_domain_common_DisplayNameField$.prototype;
$c_Lamf_core_metamodel_domain_common_DisplayNameField$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_common_DisplayNameField$ = this;
  $f_Lamf_core_metamodel_domain_common_DisplayNameField__$$init$__V(this);
  return this
});
$c_Lamf_core_metamodel_domain_common_DisplayNameField$.prototype.amf$core$metamodel$domain$common$DisplayNameField$$undsetter$und$DisplayName$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DisplayName$1 = x$1
});
var $d_Lamf_core_metamodel_domain_common_DisplayNameField$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_common_DisplayNameField$: 0
}, false, "amf.core.metamodel.domain.common.DisplayNameField$", {
  Lamf_core_metamodel_domain_common_DisplayNameField$: 1,
  O: 1,
  Lamf_core_metamodel_domain_common_DisplayNameField: 1
});
$c_Lamf_core_metamodel_domain_common_DisplayNameField$.prototype.$classData = $d_Lamf_core_metamodel_domain_common_DisplayNameField$;
var $n_Lamf_core_metamodel_domain_common_DisplayNameField$ = (void 0);
function $m_Lamf_core_metamodel_domain_common_DisplayNameField$() {
  if ((!$n_Lamf_core_metamodel_domain_common_DisplayNameField$)) {
    $n_Lamf_core_metamodel_domain_common_DisplayNameField$ = new $c_Lamf_core_metamodel_domain_common_DisplayNameField$().init___()
  };
  return $n_Lamf_core_metamodel_domain_common_DisplayNameField$
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_common_NameFieldSchema$() {
  $c_O.call(this);
  this.Name$1 = null
}
$c_Lamf_core_metamodel_domain_common_NameFieldSchema$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_common_NameFieldSchema$.prototype.constructor = $c_Lamf_core_metamodel_domain_common_NameFieldSchema$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_common_NameFieldSchema$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_common_NameFieldSchema$.prototype = $c_Lamf_core_metamodel_domain_common_NameFieldSchema$.prototype;
$c_Lamf_core_metamodel_domain_common_NameFieldSchema$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_common_NameFieldSchema$ = this;
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  return this
});
$c_Lamf_core_metamodel_domain_common_NameFieldSchema$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_core_metamodel_domain_common_NameFieldSchema$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_common_NameFieldSchema$: 0
}, false, "amf.core.metamodel.domain.common.NameFieldSchema$", {
  Lamf_core_metamodel_domain_common_NameFieldSchema$: 1,
  O: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1
});
$c_Lamf_core_metamodel_domain_common_NameFieldSchema$.prototype.$classData = $d_Lamf_core_metamodel_domain_common_NameFieldSchema$;
var $n_Lamf_core_metamodel_domain_common_NameFieldSchema$ = (void 0);
function $m_Lamf_core_metamodel_domain_common_NameFieldSchema$() {
  if ((!$n_Lamf_core_metamodel_domain_common_NameFieldSchema$)) {
    $n_Lamf_core_metamodel_domain_common_NameFieldSchema$ = new $c_Lamf_core_metamodel_domain_common_NameFieldSchema$().init___()
  };
  return $n_Lamf_core_metamodel_domain_common_NameFieldSchema$
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_common_NameFieldShacl$() {
  $c_O.call(this);
  this.Name$1 = null
}
$c_Lamf_core_metamodel_domain_common_NameFieldShacl$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_common_NameFieldShacl$.prototype.constructor = $c_Lamf_core_metamodel_domain_common_NameFieldShacl$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_common_NameFieldShacl$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_common_NameFieldShacl$.prototype = $c_Lamf_core_metamodel_domain_common_NameFieldShacl$.prototype;
$c_Lamf_core_metamodel_domain_common_NameFieldShacl$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_common_NameFieldShacl$ = this;
  $f_Lamf_core_metamodel_domain_common_NameFieldShacl__$$init$__V(this);
  return this
});
var $d_Lamf_core_metamodel_domain_common_NameFieldShacl$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_common_NameFieldShacl$: 0
}, false, "amf.core.metamodel.domain.common.NameFieldShacl$", {
  Lamf_core_metamodel_domain_common_NameFieldShacl$: 1,
  O: 1,
  Lamf_core_metamodel_domain_common_NameFieldShacl: 1
});
$c_Lamf_core_metamodel_domain_common_NameFieldShacl$.prototype.$classData = $d_Lamf_core_metamodel_domain_common_NameFieldShacl$;
var $n_Lamf_core_metamodel_domain_common_NameFieldShacl$ = (void 0);
function $m_Lamf_core_metamodel_domain_common_NameFieldShacl$() {
  if ((!$n_Lamf_core_metamodel_domain_common_NameFieldShacl$)) {
    $n_Lamf_core_metamodel_domain_common_NameFieldShacl$ = new $c_Lamf_core_metamodel_domain_common_NameFieldShacl$().init___()
  };
  return $n_Lamf_core_metamodel_domain_common_NameFieldShacl$
}
function $is_Lamf_core_metamodel_domain_templates_KeyField(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_metamodel_domain_templates_KeyField)))
}
function $as_Lamf_core_metamodel_domain_templates_KeyField(obj) {
  return (($is_Lamf_core_metamodel_domain_templates_KeyField(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.metamodel.domain.templates.KeyField"))
}
function $isArrayOf_Lamf_core_metamodel_domain_templates_KeyField(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_metamodel_domain_templates_KeyField)))
}
function $asArrayOf_Lamf_core_metamodel_domain_templates_KeyField(obj, depth) {
  return (($isArrayOf_Lamf_core_metamodel_domain_templates_KeyField(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.metamodel.domain.templates.KeyField;", depth))
}
function $f_Lamf_core_metamodel_domain_templates_OptionalField__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  $thiz.amf$core$metamodel$domain$templates$OptionalField$$undsetter$und$Optional$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "optional"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "optional", "Marks some information as optional", $m_sci_Nil$()), true))
}
function $is_Lamf_core_metamodel_domain_templates_OptionalField(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_metamodel_domain_templates_OptionalField)))
}
function $as_Lamf_core_metamodel_domain_templates_OptionalField(obj) {
  return (($is_Lamf_core_metamodel_domain_templates_OptionalField(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.metamodel.domain.templates.OptionalField"))
}
function $isArrayOf_Lamf_core_metamodel_domain_templates_OptionalField(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_metamodel_domain_templates_OptionalField)))
}
function $asArrayOf_Lamf_core_metamodel_domain_templates_OptionalField(obj, depth) {
  return (($isArrayOf_Lamf_core_metamodel_domain_templates_OptionalField(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.metamodel.domain.templates.OptionalField;", depth))
}
function $is_Lamf_core_model_document_DeclaresModel(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_document_DeclaresModel)))
}
function $as_Lamf_core_model_document_DeclaresModel(obj) {
  return (($is_Lamf_core_model_document_DeclaresModel(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.document.DeclaresModel"))
}
function $isArrayOf_Lamf_core_model_document_DeclaresModel(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_document_DeclaresModel)))
}
function $asArrayOf_Lamf_core_model_document_DeclaresModel(obj, depth) {
  return (($isArrayOf_Lamf_core_model_document_DeclaresModel(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.document.DeclaresModel;", depth))
}
function $is_Lamf_core_model_document_EncodesModel(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_document_EncodesModel)))
}
function $as_Lamf_core_model_document_EncodesModel(obj) {
  return (($is_Lamf_core_model_document_EncodesModel(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.document.EncodesModel"))
}
function $isArrayOf_Lamf_core_model_document_EncodesModel(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_document_EncodesModel)))
}
function $asArrayOf_Lamf_core_model_document_EncodesModel(obj, depth) {
  return (($isArrayOf_Lamf_core_model_document_EncodesModel(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.document.EncodesModel;", depth))
}
/** @constructor */
function $c_Lamf_core_model_document_FieldsFilter$All$() {
  $c_O.call(this)
}
$c_Lamf_core_model_document_FieldsFilter$All$.prototype = new $h_O();
$c_Lamf_core_model_document_FieldsFilter$All$.prototype.constructor = $c_Lamf_core_model_document_FieldsFilter$All$;
/** @constructor */
function $h_Lamf_core_model_document_FieldsFilter$All$() {
  /*<skip>*/
}
$h_Lamf_core_model_document_FieldsFilter$All$.prototype = $c_Lamf_core_model_document_FieldsFilter$All$.prototype;
$c_Lamf_core_model_document_FieldsFilter$All$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_model_document_FieldsFilter$All$.prototype.filter__Lamf_core_parser_Fields__sci_List = (function(fields) {
  var this$3 = fields.fs$1;
  var this$1 = $m_Lamf_core_parser_FieldEntry$();
  var f = $f_F2__tupled__F1(this$1);
  var this$2 = $m_sci_Iterable$();
  var bf = this$2.ReusableCBFInstance$2;
  var jsx$2 = $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$3, f, bf));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_parser_FieldEntry(x$1$2);
      return x$1.value$1.value$1
    })
  })(this));
  var this$4 = $m_sc_Iterable$();
  return $as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2)).toList__sci_List()
});
var $d_Lamf_core_model_document_FieldsFilter$All$ = new $TypeData().initClass({
  Lamf_core_model_document_FieldsFilter$All$: 0
}, false, "amf.core.model.document.FieldsFilter$All$", {
  Lamf_core_model_document_FieldsFilter$All$: 1,
  O: 1,
  Lamf_core_model_document_FieldsFilter: 1
});
$c_Lamf_core_model_document_FieldsFilter$All$.prototype.$classData = $d_Lamf_core_model_document_FieldsFilter$All$;
var $n_Lamf_core_model_document_FieldsFilter$All$ = (void 0);
function $m_Lamf_core_model_document_FieldsFilter$All$() {
  if ((!$n_Lamf_core_model_document_FieldsFilter$All$)) {
    $n_Lamf_core_model_document_FieldsFilter$All$ = new $c_Lamf_core_model_document_FieldsFilter$All$().init___()
  };
  return $n_Lamf_core_model_document_FieldsFilter$All$
}
/** @constructor */
function $c_Lamf_core_model_document_FieldsFilter$Local$() {
  $c_O.call(this)
}
$c_Lamf_core_model_document_FieldsFilter$Local$.prototype = new $h_O();
$c_Lamf_core_model_document_FieldsFilter$Local$.prototype.constructor = $c_Lamf_core_model_document_FieldsFilter$Local$;
/** @constructor */
function $h_Lamf_core_model_document_FieldsFilter$Local$() {
  /*<skip>*/
}
$h_Lamf_core_model_document_FieldsFilter$Local$.prototype = $c_Lamf_core_model_document_FieldsFilter$Local$.prototype;
$c_Lamf_core_model_document_FieldsFilter$Local$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_model_document_FieldsFilter$Local$.prototype.filter__Lamf_core_parser_Fields__sci_List = (function(fields) {
  var this$3 = fields.fs$1;
  var this$1 = $m_Lamf_core_parser_FieldEntry$();
  var f = $f_F2__tupled__F1(this$1);
  var this$2 = $m_sci_Iterable$();
  var bf = this$2.ReusableCBFInstance$2;
  var jsx$2 = $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$3, f, bf));
  var jsx$1 = new $c_Lamf_core_model_document_FieldsFilter$Local$$anonfun$filter$1().init___();
  var this$4 = $m_sc_Iterable$();
  return $as_sc_TraversableOnce(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2)).toList__sci_List()
});
var $d_Lamf_core_model_document_FieldsFilter$Local$ = new $TypeData().initClass({
  Lamf_core_model_document_FieldsFilter$Local$: 0
}, false, "amf.core.model.document.FieldsFilter$Local$", {
  Lamf_core_model_document_FieldsFilter$Local$: 1,
  O: 1,
  Lamf_core_model_document_FieldsFilter: 1
});
$c_Lamf_core_model_document_FieldsFilter$Local$.prototype.$classData = $d_Lamf_core_model_document_FieldsFilter$Local$;
var $n_Lamf_core_model_document_FieldsFilter$Local$ = (void 0);
function $m_Lamf_core_model_document_FieldsFilter$Local$() {
  if ((!$n_Lamf_core_model_document_FieldsFilter$Local$)) {
    $n_Lamf_core_model_document_FieldsFilter$Local$ = new $c_Lamf_core_model_document_FieldsFilter$Local$().init___()
  };
  return $n_Lamf_core_model_document_FieldsFilter$Local$
}
function $is_Lamf_core_model_domain_DomainElement(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_domain_DomainElement)))
}
function $as_Lamf_core_model_domain_DomainElement(obj) {
  return (($is_Lamf_core_model_domain_DomainElement(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.DomainElement"))
}
function $isArrayOf_Lamf_core_model_domain_DomainElement(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_DomainElement)))
}
function $asArrayOf_Lamf_core_model_domain_DomainElement(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_DomainElement(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.DomainElement;", depth))
}
function $f_Lamf_core_model_domain_Linkable__withLinkTarget__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement($thiz, target) {
  $thiz.fields__Lamf_core_parser_Fields().setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_core_metamodel_domain_LinkableElementModel$().Target$1, target, ($thiz.fields__Lamf_core_parser_Fields(), $m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
  var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().TargetId$1;
  var value = target.id__T();
  return $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject($thiz, field, value))
}
function $f_Lamf_core_model_domain_Linkable__buildLinkHash__pLamf_core_model_domain_Linkable__T__Lamf_core_parser_Annotations__I($thiz, label, annotations) {
  var sb = new $c_scm_StringBuilder().init___();
  sb.append__T__scm_StringBuilder(label);
  var this$1 = annotations.amf$core$parser$Annotations$$annotations$1;
  var this$2 = this$1.scala$collection$mutable$ListBuffer$$start$6;
  var these = this$2;
  while ((!these.isEmpty__Z())) {
    var arg1 = these.head__O();
    var x0$1 = $as_Lamf_core_model_domain_Annotation(arg1);
    if ($is_Lamf_core_model_domain_SerializableAnnotation(x0$1)) {
      var x2 = $as_Lamf_core_model_domain_SerializableAnnotation(x0$1);
      sb.append__T__scm_StringBuilder(x2.name__T());
      sb.append__T__scm_StringBuilder(x2.value__T())
    };
    these = $as_sci_List(these.tail__O())
  };
  var this$3 = sb.underlying$5.java$lang$StringBuilder$$content$f;
  return $m_sjsr_RuntimeString$().hashCode__T__I(this$3)
}
function $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O($thiz, label, annotations, unresolved, supportsRecursion) {
  if ($as_Lamf_core_model_domain_Linkable(unresolved).shouldLink__Z()) {
    var linked = $thiz.link__T__Lamf_core_parser_Annotations__O(label, annotations);
    if ((supportsRecursion && $is_Lamf_core_model_domain_Linkable(linked))) {
      var this$1 = $as_Lamf_core_model_domain_Linkable(linked);
      var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1;
      $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, supportsRecursion))
    };
    return linked
  } else {
    return $thiz
  }
}
function $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O($thiz, label, annotations) {
  var copied = $thiz.linkCopy__Lamf_core_model_domain_Linkable();
  var hash = $f_Lamf_core_model_domain_Linkable__buildLinkHash__pLamf_core_model_domain_Linkable__T__Lamf_core_parser_Annotations__I($thiz, label, annotations);
  var this$1 = $as_Lamf_core_model_domain_Linkable(copied.withId__T__Lamf_core_model_domain_AmfObject(((copied.id__T() + "/link-") + hash)));
  var target = $as_Lamf_core_model_domain_DomainElement($thiz);
  var this$2 = $as_Lamf_core_model_domain_Linkable($f_Lamf_core_model_domain_Linkable__withLinkTarget__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(this$1, target));
  var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1;
  var this$3 = $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$2, field, label));
  return $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$3, annotations)
}
function $f_Lamf_core_model_domain_Linkable__$$init$__V($thiz) {
  $thiz.linkAnnotations$und$eq__s_Option__V($m_s_None$());
  $thiz.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V(true);
  $thiz.isUnresolved$und$eq__Z__V(false);
  $thiz.unresolvedSeverity$und$eq__T__V("error");
  $thiz.refName$und$eq__T__V("");
  $thiz.refAst$und$eq__s_Option__V($m_s_None$());
  $thiz.refCtx$und$eq__s_Option__V($m_s_None$());
  $thiz.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V(new $c_Lamf_core_utils_package$IdCounter().init___())
}
function $f_Lamf_core_model_domain_Linkable__copyElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_Linkable($thiz, a) {
  return $as_Lamf_core_model_domain_Linkable($thiz.classConstructor__F2().apply__O__O__O($thiz.fields__Lamf_core_parser_Fields().copy__Lamf_core_parser_Fields(), a))
}
function $f_Lamf_core_model_domain_Linkable__toFutureRef__F1__V($thiz, resolve) {
  var x1 = $thiz.refCtx__s_Option();
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var ctx = $as_Lamf_core_parser_ParserContext(x2.value$2);
    var this$3 = ctx.futureDeclarations$1;
    var id = $thiz.id__T();
    var name = $thiz.refName__T();
    var promise = new $c_Lamf_core_parser_DeclarationPromise().init___F1__F0__Z(resolve, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, ctx$1) {
      return (function() {
        if (($this.unresolvedSeverity__T() === "warning")) {
          var this$1 = ctx$1.eh$1;
          var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnresolvedReference$1;
          var node = $this.id__T();
          var message = (("Unresolved reference '" + $this.refName__T()) + "'");
          var ast = $as_Lorg_yaml_model_YPart($this.refAst__s_Option().get__O());
          var property = $m_s_None$();
          var location = ast.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, node, property, message, location);
          return (void 0)
        } else {
          var this$2 = ctx$1.eh$1;
          var specification$1 = $m_Lamf_plugins_features_validation_CoreValidations$().UnresolvedReference$1;
          var node$1 = $this.id__T();
          var message$1 = (("Unresolved reference '" + $this.refName__T()) + "'");
          var ast$1 = $as_Lorg_yaml_model_YPart($this.refAst__s_Option().get__O());
          var prop = $m_s_None$();
          var l = ast$1.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$2, specification$1, node$1, prop, message$1, l);
          return (void 0)
        }
      })
    })($thiz, ctx)), false);
    $f_Lamf_core_parser_FutureDeclarations__futureRef__T__T__Lamf_core_parser_DeclarationPromise__V(this$3, id, name, promise)
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Cannot create unresolved reference with missing parsing context"))
  }
}
function $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option($thiz) {
  return $m_s_Option$().apply__O__s_Option($thiz.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Target$1))
}
function $f_Lamf_core_model_domain_Linkable__unresolved__T__Lorg_yaml_model_YPart__T__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement($thiz, refName, refAst, unresolvedSeverity, ctx) {
  $thiz.isUnresolved$und$eq__Z__V(true);
  $thiz.refName$und$eq__T__V(refName);
  $thiz.refAst$und$eq__s_Option__V(new $c_s_Some().init___O(refAst));
  $thiz.refCtx$und$eq__s_Option__V(new $c_s_Some().init___O(ctx));
  return $as_Lamf_core_model_domain_DomainElement($thiz)
}
function $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement($thiz, links) {
  var this$1 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option($thiz);
  if (this$1.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x0$1 = $as_Lamf_core_model_domain_DomainElement(arg1);
    matchEnd4: {
      var jsx$1;
      if ($is_Lamf_core_model_domain_Linkable(x0$1)) {
        if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option($thiz).isDefined__Z()) {
          if (links.contains__O__Z(x0$1.id__T())) {
            var this$2 = $as_Lamf_core_model_domain_Linkable(x0$1);
            var jsx$1 = $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2).get__O());
            break matchEnd4
          } else {
            var jsx$2 = $as_Lamf_core_model_domain_Linkable(x0$1);
            var x$1 = x0$1.id__T();
            var this$3 = $m_sc_Seq$();
            var jsx$1 = jsx$2.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement($as_sc_Seq(links.$$plus$colon__O__scg_CanBuildFrom__O(x$1, this$3.ReusableCBFInstance$2)));
            break matchEnd4
          }
        }
      };
      var jsx$1 = x0$1
    };
    var this$4 = new $c_s_Some().init___O(jsx$1)
  };
  return $as_Lamf_core_model_domain_DomainElement((this$4.isEmpty__Z() ? $as_Lamf_core_model_domain_DomainElement($thiz) : this$4.get__O()))
}
function $f_Lamf_core_model_domain_Linkable__copyElement__Lamf_core_model_domain_Linkable($thiz) {
  var jsx$2 = $thiz.classConstructor__F2();
  var jsx$1 = $thiz.fields__Lamf_core_parser_Fields().copy__Lamf_core_parser_Fields();
  var this$1 = $thiz.annotations__Lamf_core_parser_Annotations();
  return $as_Lamf_core_model_domain_Linkable(jsx$2.apply__O__O__O(jsx$1, $m_Lamf_core_parser_Annotations$().apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(this$1)))
}
function $is_Lamf_core_model_domain_Linkable(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_domain_Linkable)))
}
function $as_Lamf_core_model_domain_Linkable(obj) {
  return (($is_Lamf_core_model_domain_Linkable(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.Linkable"))
}
function $isArrayOf_Lamf_core_model_domain_Linkable(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_Linkable)))
}
function $asArrayOf_Lamf_core_model_domain_Linkable(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_Linkable(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.Linkable;", depth))
}
/** @constructor */
function $c_Lamf_core_parser_Annotations$$anon$1() {
  $c_Lamf_core_parser_Annotations.call(this)
}
$c_Lamf_core_parser_Annotations$$anon$1.prototype = new $h_Lamf_core_parser_Annotations();
$c_Lamf_core_parser_Annotations$$anon$1.prototype.constructor = $c_Lamf_core_parser_Annotations$$anon$1;
/** @constructor */
function $h_Lamf_core_parser_Annotations$$anon$1() {
  /*<skip>*/
}
$h_Lamf_core_parser_Annotations$$anon$1.prototype = $c_Lamf_core_parser_Annotations$$anon$1.prototype;
$c_Lamf_core_parser_Annotations$$anon$1.prototype.init___ = (function() {
  $c_Lamf_core_parser_Annotations.prototype.init___.call(this);
  return this
});
$c_Lamf_core_parser_Annotations$$anon$1.prototype.$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations = (function(other) {
  return this
});
$c_Lamf_core_parser_Annotations$$anon$1.prototype.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations = (function(annotation) {
  return this
});
$c_Lamf_core_parser_Annotations$$anon$1.prototype.$$plus$plus$eq__sc_TraversableOnce__Lamf_core_parser_Annotations = (function(other) {
  return this
});
var $d_Lamf_core_parser_Annotations$$anon$1 = new $TypeData().initClass({
  Lamf_core_parser_Annotations$$anon$1: 0
}, false, "amf.core.parser.Annotations$$anon$1", {
  Lamf_core_parser_Annotations$$anon$1: 1,
  Lamf_core_parser_Annotations: 1,
  O: 1
});
$c_Lamf_core_parser_Annotations$$anon$1.prototype.$classData = $d_Lamf_core_parser_Annotations$$anon$1;
function $f_Lamf_core_parser_BaseArrayNode__text__Lamf_core_model_domain_AmfArray($thiz) {
  var eta$0$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$8$2) {
      var x$8 = $as_Lorg_yaml_model_YNode(x$8$2);
      var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv = $this.iv__Lorg_yaml_model_IllegalTypeHandler();
      return $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(x$8, conversion, iv)).text$3
    })
  })($thiz));
  var fn = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, eta$0$1$1) {
    return (function(e$2) {
      var e = $as_Lorg_yaml_model_YNode(e$2);
      return $f_Lamf_core_parser_BaseArrayNode__scalar__pLamf_core_parser_BaseArrayNode__F1__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(this$2, eta$0$1$1, e)
    })
  })($thiz, eta$0$1));
  return $f_Lamf_core_parser_BaseArrayNode__array__pLamf_core_parser_BaseArrayNode__F1__Lamf_core_model_domain_AmfArray($thiz, fn)
}
function $f_Lamf_core_parser_BaseArrayNode__array__pLamf_core_parser_BaseArrayNode__F1__Lamf_core_model_domain_AmfArray($thiz, fn) {
  var x1 = $thiz.nodes__T2();
  if ((x1 !== null)) {
    var all = $as_sc_Seq(x1.$$und1__O());
    var node = $as_Lorg_yaml_model_YNode(x1.$$und2__O());
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, fn$1) {
      return (function(x$13$2) {
        var x$13 = $as_Lorg_yaml_model_YNode(x$13$2);
        return $as_Lamf_core_model_domain_AmfElement(fn$1.apply__O__O(x$13))
      })
    })($thiz, fn));
    var this$1 = $m_sc_Seq$();
    var elements = $as_sc_Seq(all.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
    return new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(elements, $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(node))
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
}
function $f_Lamf_core_parser_BaseArrayNode__$boolean__Lamf_core_model_domain_AmfArray($thiz) {
  var eta$0$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$11$2) {
      var x$11 = $as_Lorg_yaml_model_YNode(x$11$2);
      var conversion = $m_Lorg_yaml_convert_YRead$BooleanYRead$();
      var iv = $this.iv__Lorg_yaml_model_IllegalTypeHandler();
      return $uZ($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(x$11, conversion, iv))
    })
  })($thiz));
  var fn = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, eta$0$1$1) {
    return (function(e$2) {
      var e = $as_Lorg_yaml_model_YNode(e$2);
      return $f_Lamf_core_parser_BaseArrayNode__scalar__pLamf_core_parser_BaseArrayNode__F1__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(this$2, eta$0$1$1, e)
    })
  })($thiz, eta$0$1));
  return $f_Lamf_core_parser_BaseArrayNode__array__pLamf_core_parser_BaseArrayNode__F1__Lamf_core_model_domain_AmfArray($thiz, fn)
}
function $f_Lamf_core_parser_BaseArrayNode__integer__Lamf_core_model_domain_AmfArray($thiz) {
  var eta$0$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$9$2) {
      var x$9 = $as_Lorg_yaml_model_YNode(x$9$2);
      var conversion = $m_Lorg_yaml_convert_YRead$IntYRead$();
      var iv = $this.iv__Lorg_yaml_model_IllegalTypeHandler();
      return $uI($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(x$9, conversion, iv))
    })
  })($thiz));
  var fn = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, eta$0$1$1) {
    return (function(e$2) {
      var e = $as_Lorg_yaml_model_YNode(e$2);
      return $f_Lamf_core_parser_BaseArrayNode__scalar__pLamf_core_parser_BaseArrayNode__F1__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(this$2, eta$0$1$1, e)
    })
  })($thiz, eta$0$1));
  return $f_Lamf_core_parser_BaseArrayNode__array__pLamf_core_parser_BaseArrayNode__F1__Lamf_core_model_domain_AmfArray($thiz, fn)
}
function $f_Lamf_core_parser_BaseArrayNode__negated__Lamf_core_model_domain_AmfArray($thiz) {
  var eta$0$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$12$2) {
      var x$12 = $as_Lorg_yaml_model_YNode(x$12$2);
      var conversion = $m_Lorg_yaml_convert_YRead$BooleanYRead$();
      var iv = $this.iv__Lorg_yaml_model_IllegalTypeHandler();
      return (!$uZ($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(x$12, conversion, iv)))
    })
  })($thiz));
  var fn = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, eta$0$1$1) {
    return (function(e$2) {
      var e = $as_Lorg_yaml_model_YNode(e$2);
      return $f_Lamf_core_parser_BaseArrayNode__scalar__pLamf_core_parser_BaseArrayNode__F1__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(this$2, eta$0$1$1, e)
    })
  })($thiz, eta$0$1));
  return $f_Lamf_core_parser_BaseArrayNode__array__pLamf_core_parser_BaseArrayNode__F1__Lamf_core_model_domain_AmfArray($thiz, fn)
}
function $f_Lamf_core_parser_BaseArrayNode__string__Lamf_core_model_domain_AmfArray($thiz) {
  var eta$0$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$7$2) {
      var x$7 = $as_Lorg_yaml_model_YNode(x$7$2);
      var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
      var iv = $this.iv__Lorg_yaml_model_IllegalTypeHandler();
      return $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(x$7, conversion, iv))
    })
  })($thiz));
  var fn = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, eta$0$1$1) {
    return (function(e$2) {
      var e = $as_Lorg_yaml_model_YNode(e$2);
      return $f_Lamf_core_parser_BaseArrayNode__scalar__pLamf_core_parser_BaseArrayNode__F1__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(this$2, eta$0$1$1, e)
    })
  })($thiz, eta$0$1));
  return $f_Lamf_core_parser_BaseArrayNode__array__pLamf_core_parser_BaseArrayNode__F1__Lamf_core_model_domain_AmfArray($thiz, fn)
}
function $f_Lamf_core_parser_BaseArrayNode__scalar__pLamf_core_parser_BaseArrayNode__F1__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar($thiz, fn, e) {
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(fn.apply__O__O(e), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(e.value__Lorg_yaml_model_YValue()))
}
/** @constructor */
function $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1() {
  $c_O.call(this);
  this.promises$1 = null
}
$c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1.prototype = new $h_O();
$c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1.prototype.constructor = $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1;
/** @constructor */
function $h_Lamf_core_parser_EmptyFutureDeclarations$$anon$1() {
  /*<skip>*/
}
$h_Lamf_core_parser_EmptyFutureDeclarations$$anon$1.prototype = $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1.prototype;
$c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1.prototype.init___ = (function() {
  $f_Lamf_core_parser_FutureDeclarations__$$init$__V(this);
  return this
});
var $d_Lamf_core_parser_EmptyFutureDeclarations$$anon$1 = new $TypeData().initClass({
  Lamf_core_parser_EmptyFutureDeclarations$$anon$1: 0
}, false, "amf.core.parser.EmptyFutureDeclarations$$anon$1", {
  Lamf_core_parser_EmptyFutureDeclarations$$anon$1: 1,
  O: 1,
  Lamf_core_parser_FutureDeclarations: 1
});
$c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1.prototype.$classData = $d_Lamf_core_parser_EmptyFutureDeclarations$$anon$1;
/** @constructor */
function $c_Lamf_core_parser_ExtensionReference$() {
  $c_O.call(this)
}
$c_Lamf_core_parser_ExtensionReference$.prototype = new $h_O();
$c_Lamf_core_parser_ExtensionReference$.prototype.constructor = $c_Lamf_core_parser_ExtensionReference$;
/** @constructor */
function $h_Lamf_core_parser_ExtensionReference$() {
  /*<skip>*/
}
$h_Lamf_core_parser_ExtensionReference$.prototype = $c_Lamf_core_parser_ExtensionReference$.prototype;
$c_Lamf_core_parser_ExtensionReference$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_core_parser_ExtensionReference$ = new $TypeData().initClass({
  Lamf_core_parser_ExtensionReference$: 0
}, false, "amf.core.parser.ExtensionReference$", {
  Lamf_core_parser_ExtensionReference$: 1,
  O: 1,
  Lamf_core_parser_ReferenceKind: 1
});
$c_Lamf_core_parser_ExtensionReference$.prototype.$classData = $d_Lamf_core_parser_ExtensionReference$;
var $n_Lamf_core_parser_ExtensionReference$ = (void 0);
function $m_Lamf_core_parser_ExtensionReference$() {
  if ((!$n_Lamf_core_parser_ExtensionReference$)) {
    $n_Lamf_core_parser_ExtensionReference$ = new $c_Lamf_core_parser_ExtensionReference$().init___()
  };
  return $n_Lamf_core_parser_ExtensionReference$
}
/** @constructor */
function $c_Lamf_core_parser_InferredLinkReference$() {
  $c_O.call(this)
}
$c_Lamf_core_parser_InferredLinkReference$.prototype = new $h_O();
$c_Lamf_core_parser_InferredLinkReference$.prototype.constructor = $c_Lamf_core_parser_InferredLinkReference$;
/** @constructor */
function $h_Lamf_core_parser_InferredLinkReference$() {
  /*<skip>*/
}
$h_Lamf_core_parser_InferredLinkReference$.prototype = $c_Lamf_core_parser_InferredLinkReference$.prototype;
$c_Lamf_core_parser_InferredLinkReference$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_core_parser_InferredLinkReference$ = new $TypeData().initClass({
  Lamf_core_parser_InferredLinkReference$: 0
}, false, "amf.core.parser.InferredLinkReference$", {
  Lamf_core_parser_InferredLinkReference$: 1,
  O: 1,
  Lamf_core_parser_ReferenceKind: 1
});
$c_Lamf_core_parser_InferredLinkReference$.prototype.$classData = $d_Lamf_core_parser_InferredLinkReference$;
var $n_Lamf_core_parser_InferredLinkReference$ = (void 0);
function $m_Lamf_core_parser_InferredLinkReference$() {
  if ((!$n_Lamf_core_parser_InferredLinkReference$)) {
    $n_Lamf_core_parser_InferredLinkReference$ = new $c_Lamf_core_parser_InferredLinkReference$().init___()
  };
  return $n_Lamf_core_parser_InferredLinkReference$
}
/** @constructor */
function $c_Lamf_core_parser_LibraryReference$() {
  $c_O.call(this)
}
$c_Lamf_core_parser_LibraryReference$.prototype = new $h_O();
$c_Lamf_core_parser_LibraryReference$.prototype.constructor = $c_Lamf_core_parser_LibraryReference$;
/** @constructor */
function $h_Lamf_core_parser_LibraryReference$() {
  /*<skip>*/
}
$h_Lamf_core_parser_LibraryReference$.prototype = $c_Lamf_core_parser_LibraryReference$.prototype;
$c_Lamf_core_parser_LibraryReference$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_core_parser_LibraryReference$ = new $TypeData().initClass({
  Lamf_core_parser_LibraryReference$: 0
}, false, "amf.core.parser.LibraryReference$", {
  Lamf_core_parser_LibraryReference$: 1,
  O: 1,
  Lamf_core_parser_ReferenceKind: 1
});
$c_Lamf_core_parser_LibraryReference$.prototype.$classData = $d_Lamf_core_parser_LibraryReference$;
var $n_Lamf_core_parser_LibraryReference$ = (void 0);
function $m_Lamf_core_parser_LibraryReference$() {
  if ((!$n_Lamf_core_parser_LibraryReference$)) {
    $n_Lamf_core_parser_LibraryReference$ = new $c_Lamf_core_parser_LibraryReference$().init___()
  };
  return $n_Lamf_core_parser_LibraryReference$
}
/** @constructor */
function $c_Lamf_core_parser_LinkReference$() {
  $c_O.call(this)
}
$c_Lamf_core_parser_LinkReference$.prototype = new $h_O();
$c_Lamf_core_parser_LinkReference$.prototype.constructor = $c_Lamf_core_parser_LinkReference$;
/** @constructor */
function $h_Lamf_core_parser_LinkReference$() {
  /*<skip>*/
}
$h_Lamf_core_parser_LinkReference$.prototype = $c_Lamf_core_parser_LinkReference$.prototype;
$c_Lamf_core_parser_LinkReference$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_core_parser_LinkReference$ = new $TypeData().initClass({
  Lamf_core_parser_LinkReference$: 0
}, false, "amf.core.parser.LinkReference$", {
  Lamf_core_parser_LinkReference$: 1,
  O: 1,
  Lamf_core_parser_ReferenceKind: 1
});
$c_Lamf_core_parser_LinkReference$.prototype.$classData = $d_Lamf_core_parser_LinkReference$;
var $n_Lamf_core_parser_LinkReference$ = (void 0);
function $m_Lamf_core_parser_LinkReference$() {
  if ((!$n_Lamf_core_parser_LinkReference$)) {
    $n_Lamf_core_parser_LinkReference$ = new $c_Lamf_core_parser_LinkReference$().init___()
  };
  return $n_Lamf_core_parser_LinkReference$
}
/** @constructor */
function $c_Lamf_core_parser_SchemaReference$() {
  $c_O.call(this)
}
$c_Lamf_core_parser_SchemaReference$.prototype = new $h_O();
$c_Lamf_core_parser_SchemaReference$.prototype.constructor = $c_Lamf_core_parser_SchemaReference$;
/** @constructor */
function $h_Lamf_core_parser_SchemaReference$() {
  /*<skip>*/
}
$h_Lamf_core_parser_SchemaReference$.prototype = $c_Lamf_core_parser_SchemaReference$.prototype;
$c_Lamf_core_parser_SchemaReference$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_core_parser_SchemaReference$ = new $TypeData().initClass({
  Lamf_core_parser_SchemaReference$: 0
}, false, "amf.core.parser.SchemaReference$", {
  Lamf_core_parser_SchemaReference$: 1,
  O: 1,
  Lamf_core_parser_ReferenceKind: 1
});
$c_Lamf_core_parser_SchemaReference$.prototype.$classData = $d_Lamf_core_parser_SchemaReference$;
var $n_Lamf_core_parser_SchemaReference$ = (void 0);
function $m_Lamf_core_parser_SchemaReference$() {
  if ((!$n_Lamf_core_parser_SchemaReference$)) {
    $n_Lamf_core_parser_SchemaReference$ = new $c_Lamf_core_parser_SchemaReference$().init___()
  };
  return $n_Lamf_core_parser_SchemaReference$
}
/** @constructor */
function $c_Lamf_core_parser_SearchScope$All$() {
  $c_O.call(this)
}
$c_Lamf_core_parser_SearchScope$All$.prototype = new $h_O();
$c_Lamf_core_parser_SearchScope$All$.prototype.constructor = $c_Lamf_core_parser_SearchScope$All$;
/** @constructor */
function $h_Lamf_core_parser_SearchScope$All$() {
  /*<skip>*/
}
$h_Lamf_core_parser_SearchScope$All$.prototype = $c_Lamf_core_parser_SearchScope$All$.prototype;
$c_Lamf_core_parser_SearchScope$All$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_core_parser_SearchScope$All$ = new $TypeData().initClass({
  Lamf_core_parser_SearchScope$All$: 0
}, false, "amf.core.parser.SearchScope$All$", {
  Lamf_core_parser_SearchScope$All$: 1,
  O: 1,
  Lamf_core_parser_SearchScope$Scope: 1
});
$c_Lamf_core_parser_SearchScope$All$.prototype.$classData = $d_Lamf_core_parser_SearchScope$All$;
var $n_Lamf_core_parser_SearchScope$All$ = (void 0);
function $m_Lamf_core_parser_SearchScope$All$() {
  if ((!$n_Lamf_core_parser_SearchScope$All$)) {
    $n_Lamf_core_parser_SearchScope$All$ = new $c_Lamf_core_parser_SearchScope$All$().init___()
  };
  return $n_Lamf_core_parser_SearchScope$All$
}
/** @constructor */
function $c_Lamf_core_parser_SearchScope$Fragments$() {
  $c_O.call(this)
}
$c_Lamf_core_parser_SearchScope$Fragments$.prototype = new $h_O();
$c_Lamf_core_parser_SearchScope$Fragments$.prototype.constructor = $c_Lamf_core_parser_SearchScope$Fragments$;
/** @constructor */
function $h_Lamf_core_parser_SearchScope$Fragments$() {
  /*<skip>*/
}
$h_Lamf_core_parser_SearchScope$Fragments$.prototype = $c_Lamf_core_parser_SearchScope$Fragments$.prototype;
$c_Lamf_core_parser_SearchScope$Fragments$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_core_parser_SearchScope$Fragments$ = new $TypeData().initClass({
  Lamf_core_parser_SearchScope$Fragments$: 0
}, false, "amf.core.parser.SearchScope$Fragments$", {
  Lamf_core_parser_SearchScope$Fragments$: 1,
  O: 1,
  Lamf_core_parser_SearchScope$Scope: 1
});
$c_Lamf_core_parser_SearchScope$Fragments$.prototype.$classData = $d_Lamf_core_parser_SearchScope$Fragments$;
var $n_Lamf_core_parser_SearchScope$Fragments$ = (void 0);
function $m_Lamf_core_parser_SearchScope$Fragments$() {
  if ((!$n_Lamf_core_parser_SearchScope$Fragments$)) {
    $n_Lamf_core_parser_SearchScope$Fragments$ = new $c_Lamf_core_parser_SearchScope$Fragments$().init___()
  };
  return $n_Lamf_core_parser_SearchScope$Fragments$
}
/** @constructor */
function $c_Lamf_core_parser_SearchScope$Named$() {
  $c_O.call(this)
}
$c_Lamf_core_parser_SearchScope$Named$.prototype = new $h_O();
$c_Lamf_core_parser_SearchScope$Named$.prototype.constructor = $c_Lamf_core_parser_SearchScope$Named$;
/** @constructor */
function $h_Lamf_core_parser_SearchScope$Named$() {
  /*<skip>*/
}
$h_Lamf_core_parser_SearchScope$Named$.prototype = $c_Lamf_core_parser_SearchScope$Named$.prototype;
$c_Lamf_core_parser_SearchScope$Named$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_core_parser_SearchScope$Named$ = new $TypeData().initClass({
  Lamf_core_parser_SearchScope$Named$: 0
}, false, "amf.core.parser.SearchScope$Named$", {
  Lamf_core_parser_SearchScope$Named$: 1,
  O: 1,
  Lamf_core_parser_SearchScope$Scope: 1
});
$c_Lamf_core_parser_SearchScope$Named$.prototype.$classData = $d_Lamf_core_parser_SearchScope$Named$;
var $n_Lamf_core_parser_SearchScope$Named$ = (void 0);
function $m_Lamf_core_parser_SearchScope$Named$() {
  if ((!$n_Lamf_core_parser_SearchScope$Named$)) {
    $n_Lamf_core_parser_SearchScope$Named$ = new $c_Lamf_core_parser_SearchScope$Named$().init___()
  };
  return $n_Lamf_core_parser_SearchScope$Named$
}
/** @constructor */
function $c_Lamf_core_parser_SimpleReferenceHandler$() {
  $c_O.call(this)
}
$c_Lamf_core_parser_SimpleReferenceHandler$.prototype = new $h_O();
$c_Lamf_core_parser_SimpleReferenceHandler$.prototype.constructor = $c_Lamf_core_parser_SimpleReferenceHandler$;
/** @constructor */
function $h_Lamf_core_parser_SimpleReferenceHandler$() {
  /*<skip>*/
}
$h_Lamf_core_parser_SimpleReferenceHandler$.prototype = $c_Lamf_core_parser_SimpleReferenceHandler$.prototype;
$c_Lamf_core_parser_SimpleReferenceHandler$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_parser_SimpleReferenceHandler$.prototype.update__Lamf_core_parser_ParsedReference__Lamf_core_CompilerContext__s_concurrent_ExecutionContext__s_concurrent_Future = (function(reference, compilerContext, executionContext) {
  return $m_s_concurrent_Future$().successful__O__s_concurrent_Future(reference)
});
$c_Lamf_core_parser_SimpleReferenceHandler$.prototype.collect__Lamf_core_parser_ParsedDocument__Lamf_core_parser_ParserContext__Lamf_core_parser_ReferenceCollector = (function(document, ctx) {
  return $m_Lamf_core_parser_EmptyReferenceCollector$()
});
var $d_Lamf_core_parser_SimpleReferenceHandler$ = new $TypeData().initClass({
  Lamf_core_parser_SimpleReferenceHandler$: 0
}, false, "amf.core.parser.SimpleReferenceHandler$", {
  Lamf_core_parser_SimpleReferenceHandler$: 1,
  O: 1,
  Lamf_core_parser_ReferenceHandler: 1
});
$c_Lamf_core_parser_SimpleReferenceHandler$.prototype.$classData = $d_Lamf_core_parser_SimpleReferenceHandler$;
var $n_Lamf_core_parser_SimpleReferenceHandler$ = (void 0);
function $m_Lamf_core_parser_SimpleReferenceHandler$() {
  if ((!$n_Lamf_core_parser_SimpleReferenceHandler$)) {
    $n_Lamf_core_parser_SimpleReferenceHandler$ = new $c_Lamf_core_parser_SimpleReferenceHandler$().init___()
  };
  return $n_Lamf_core_parser_SimpleReferenceHandler$
}
/** @constructor */
function $c_Lamf_core_parser_UnspecifiedReference$() {
  $c_O.call(this)
}
$c_Lamf_core_parser_UnspecifiedReference$.prototype = new $h_O();
$c_Lamf_core_parser_UnspecifiedReference$.prototype.constructor = $c_Lamf_core_parser_UnspecifiedReference$;
/** @constructor */
function $h_Lamf_core_parser_UnspecifiedReference$() {
  /*<skip>*/
}
$h_Lamf_core_parser_UnspecifiedReference$.prototype = $c_Lamf_core_parser_UnspecifiedReference$.prototype;
$c_Lamf_core_parser_UnspecifiedReference$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_core_parser_UnspecifiedReference$ = new $TypeData().initClass({
  Lamf_core_parser_UnspecifiedReference$: 0
}, false, "amf.core.parser.UnspecifiedReference$", {
  Lamf_core_parser_UnspecifiedReference$: 1,
  O: 1,
  Lamf_core_parser_ReferenceKind: 1
});
$c_Lamf_core_parser_UnspecifiedReference$.prototype.$classData = $d_Lamf_core_parser_UnspecifiedReference$;
var $n_Lamf_core_parser_UnspecifiedReference$ = (void 0);
function $m_Lamf_core_parser_UnspecifiedReference$() {
  if ((!$n_Lamf_core_parser_UnspecifiedReference$)) {
    $n_Lamf_core_parser_UnspecifiedReference$ = new $c_Lamf_core_parser_UnspecifiedReference$().init___()
  };
  return $n_Lamf_core_parser_UnspecifiedReference$
}
/** @constructor */
function $c_Lamf_core_parser_package$YScalarYRead$() {
  $c_O.call(this)
}
$c_Lamf_core_parser_package$YScalarYRead$.prototype = new $h_O();
$c_Lamf_core_parser_package$YScalarYRead$.prototype.constructor = $c_Lamf_core_parser_package$YScalarYRead$;
/** @constructor */
function $h_Lamf_core_parser_package$YScalarYRead$() {
  /*<skip>*/
}
$h_Lamf_core_parser_package$YScalarYRead$.prototype = $c_Lamf_core_parser_package$YScalarYRead$.prototype;
$c_Lamf_core_parser_package$YScalarYRead$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_parser_package$YScalarYRead$.prototype.read__Lorg_yaml_model_YNode__s_util_Either = (function(node) {
  var x1 = node.value__Lorg_yaml_model_YValue();
  if ((x1 instanceof $c_Lorg_yaml_model_YScalar)) {
    var x2 = $as_Lorg_yaml_model_YScalar(x1);
    $m_s_package$();
    return new $c_s_util_Right().init___O(x2)
  } else {
    return $m_Lorg_yaml_convert_YRead$().error__Lorg_yaml_model_YNode__T__s_util_Left(node, ("Expected scalar but found: " + x1))
  }
});
$c_Lamf_core_parser_package$YScalarYRead$.prototype.defaultValue__O = (function() {
  return $m_Lorg_yaml_model_YScalar$().Null$1
});
var $d_Lamf_core_parser_package$YScalarYRead$ = new $TypeData().initClass({
  Lamf_core_parser_package$YScalarYRead$: 0
}, false, "amf.core.parser.package$YScalarYRead$", {
  Lamf_core_parser_package$YScalarYRead$: 1,
  O: 1,
  Lorg_yaml_convert_YRead: 1
});
$c_Lamf_core_parser_package$YScalarYRead$.prototype.$classData = $d_Lamf_core_parser_package$YScalarYRead$;
var $n_Lamf_core_parser_package$YScalarYRead$ = (void 0);
function $m_Lamf_core_parser_package$YScalarYRead$() {
  if ((!$n_Lamf_core_parser_package$YScalarYRead$)) {
    $n_Lamf_core_parser_package$YScalarYRead$ = new $c_Lamf_core_parser_package$YScalarYRead$().init___()
  };
  return $n_Lamf_core_parser_package$YScalarYRead$
}
/** @constructor */
function $c_Lamf_core_rdf_RdfModelParser() {
  $c_O.call(this);
  this.ctx$1 = null
}
$c_Lamf_core_rdf_RdfModelParser.prototype = new $h_O();
$c_Lamf_core_rdf_RdfModelParser.prototype.constructor = $c_Lamf_core_rdf_RdfModelParser;
/** @constructor */
function $h_Lamf_core_rdf_RdfModelParser() {
  /*<skip>*/
}
$h_Lamf_core_rdf_RdfModelParser.prototype = $c_Lamf_core_rdf_RdfModelParser.prototype;
$c_Lamf_core_rdf_RdfModelParser.prototype.init___Lamf_core_rdf_RdfParserContext = (function(ctx) {
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_core_rdf_RdfModelParser.prototype.parse__Lamf_core_rdf_RdfModel__T__Lamf_core_model_document_BaseUnit = (function(model, location) {
  var x1 = model.findNode__T__s_Option(location);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var rootNode = $as_Lamf_core_rdf_Node(x2.value$2);
    var nodeFinder = new $c_Lamf_core_rdf_graph_NodeFinder().init___Lamf_core_rdf_RdfModel(model);
    var parser = new $c_Lamf_core_rdf_parsers_ObjectParser().init___T__Lamf_core_rdf_RecursionControl__Lamf_core_rdf_helper_PluginEntitiesFacade__Lamf_core_rdf_graph_NodeFinder__Lamf_core_rdf_parsers_SourcesRetriever__Lamf_core_rdf_RdfParserContext(location, new $c_Lamf_core_rdf_RecursionControl().init___sci_Set($as_sci_Set($m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))), new $c_Lamf_core_rdf_helper_PluginEntitiesFacade().init___Lamf_core_parser_ParserContext(this.ctx$1), nodeFinder, new $c_Lamf_core_rdf_parsers_SourcesRetriever().init___Lamf_core_rdf_graph_NodeFinder(nodeFinder), this.ctx$1);
    var x1$2 = parser.parse__Lamf_core_rdf_Node__Z__s_Option(rootNode, true);
    matchEnd5: {
      var unit$2;
      if ((x1$2 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$2);
        var unit = $as_Lamf_core_model_domain_AmfElement(x2$2.value$2);
        if ($is_Lamf_core_model_document_BaseUnit(unit)) {
          var x3 = $as_Lamf_core_model_document_BaseUnit(unit);
          var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
          var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(location, "#", 0);
          var this$4 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
          var value = $as_T($f_sc_IndexedSeqOptimized__head__O(this$4));
          $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x3, field, value);
          var parserRun = this.ctx$1.parserRun$1;
          $f_Lamf_core_model_document_BaseUnit__withRunNumber__I__Lamf_core_model_document_BaseUnit(x3, parserRun);
          var unit$2 = x3;
          break matchEnd5
        }
      };
      var this$5 = this.ctx$1.eh$1;
      var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnableToParseRdfDocument$1;
      var message = ("Unable to parse RDF model for location root node: " + location);
      var property = $m_s_None$();
      var lexical = $m_s_None$();
      var location$1 = $m_s_None$();
      this$5.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, location, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location$1);
      $m_Lamf_core_parser_Annotations$();
      var annotations = new $c_Lamf_core_parser_Annotations().init___();
      var unit$2 = new $c_Lamf_core_model_document_Document().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
    }
  } else {
    var this$9 = this.ctx$1.eh$1;
    var specification$1 = $m_Lamf_plugins_features_validation_CoreValidations$().UnableToParseRdfDocument$1;
    var message$1 = ("Unable to parse RDF model for location root node: " + location);
    var property$1 = $m_s_None$();
    var lexical$1 = $m_s_None$();
    var location$2 = $m_s_None$();
    this$9.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification$1.id$1, location, property$1, message$1, lexical$1, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location$2);
    $m_Lamf_core_parser_Annotations$();
    var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
    var unit$2 = new $c_Lamf_core_model_document_Document().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1)
  };
  var this$14 = this.ctx$1.collected$2;
  var pf = new $c_Lamf_core_rdf_RdfModelParser$$anonfun$parse$1().init___Lamf_core_rdf_RdfModelParser(this);
  var this$13 = $m_scm_ListBuffer$();
  var bf = this$13.ReusableCBFInstance$2;
  var this$15 = $as_scg_TraversableForwarder($f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this$14, pf, bf));
  var this$16 = this$15.scala$collection$mutable$ListBuffer$$start$6;
  var these = this$16;
  while ((!these.isEmpty__Z())) {
    var arg1 = these.head__O();
    var x$1 = $as_Lamf_core_model_domain_ResolvableAnnotation(arg1);
    x$1.resolve__sci_Map__V(this.ctx$1.nodes$2);
    these = $as_sci_List(these.tail__O())
  };
  return unit$2
});
$c_Lamf_core_rdf_RdfModelParser.prototype.ctx__Lamf_core_rdf_RdfParserContext = (function() {
  return this.ctx$1
});
var $d_Lamf_core_rdf_RdfModelParser = new $TypeData().initClass({
  Lamf_core_rdf_RdfModelParser: 0
}, false, "amf.core.rdf.RdfModelParser", {
  Lamf_core_rdf_RdfModelParser: 1,
  O: 1,
  Lamf_core_rdf_RdfParserCommon: 1
});
$c_Lamf_core_rdf_RdfModelParser.prototype.$classData = $d_Lamf_core_rdf_RdfModelParser;
/** @constructor */
function $c_Lamf_core_rdf_converter_AnyTypeConverter$() {
  $c_O.call(this);
  this.xsdString$1 = null;
  this.xsdInteger$1 = null;
  this.xsdFloat$1 = null;
  this.amlNumber$1 = null;
  this.xsdDouble$1 = null;
  this.xsdBoolean$1 = null;
  this.xsdDateTime$1 = null;
  this.xsdDate$1 = null
}
$c_Lamf_core_rdf_converter_AnyTypeConverter$.prototype = new $h_O();
$c_Lamf_core_rdf_converter_AnyTypeConverter$.prototype.constructor = $c_Lamf_core_rdf_converter_AnyTypeConverter$;
/** @constructor */
function $h_Lamf_core_rdf_converter_AnyTypeConverter$() {
  /*<skip>*/
}
$h_Lamf_core_rdf_converter_AnyTypeConverter$.prototype = $c_Lamf_core_rdf_converter_AnyTypeConverter$.prototype;
$c_Lamf_core_rdf_converter_AnyTypeConverter$.prototype.init___ = (function() {
  $n_Lamf_core_rdf_converter_AnyTypeConverter$ = this;
  this.xsdString$1 = $m_Lamf_core_model_DataType$().String$1;
  this.xsdInteger$1 = $m_Lamf_core_model_DataType$().Integer$1;
  this.xsdFloat$1 = $m_Lamf_core_model_DataType$().Float$1;
  this.amlNumber$1 = $m_Lamf_core_model_DataType$().Number$1;
  this.xsdDouble$1 = $m_Lamf_core_model_DataType$().Double$1;
  this.xsdBoolean$1 = $m_Lamf_core_model_DataType$().Boolean$1;
  this.xsdDateTime$1 = $m_Lamf_core_model_DataType$().DateTime$1;
  this.xsdDate$1 = $m_Lamf_core_model_DataType$().Date$1;
  return this
});
$c_Lamf_core_rdf_converter_AnyTypeConverter$.prototype.tryConvert__Lamf_core_rdf_PropertyObject__Lamf_core_errorhandling_ErrorHandler__s_Option = (function(property, errorHandler) {
  if ((property instanceof $c_Lamf_core_rdf_Literal)) {
    var x2 = $as_Lamf_core_rdf_Literal(property);
    var v = x2.value$1;
    var typed = x2.literalType$2;
    var rc15 = false;
    var x2$2 = null;
    if ((typed instanceof $c_s_Some)) {
      rc15 = true;
      x2$2 = $as_s_Some(typed);
      var s = $as_T(x2$2.value$2);
      if ((s !== null)) {
        if ((s === this.xsdBoolean$1)) {
          var this$2 = new $c_sci_StringOps().init___T(v);
          var $$this = this$2.repr$1;
          return new $c_s_Some().init___O(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($f_sci_StringLike__parseBoolean__psci_StringLike__T__Z(this$2, $$this), new $c_Lamf_core_parser_Annotations().init___()))
        }
      }
    };
    if (rc15) {
      var s$2 = $as_T(x2$2.value$2);
      if ((s$2 !== null)) {
        if ((s$2 === this.xsdInteger$1)) {
          var this$6 = new $c_sci_StringOps().init___T(v);
          var this$8 = $m_jl_Integer$();
          var $$this$1 = this$6.repr$1;
          return new $c_s_Some().init___O(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(this$8.parseInt__T__I__I($$this$1, 10), new $c_Lamf_core_parser_Annotations().init___()))
        }
      }
    };
    if (rc15) {
      var s$3 = $as_T(x2$2.value$2);
      if ((s$3 !== null)) {
        if ((s$3 === this.xsdFloat$1)) {
          var this$11 = new $c_sci_StringOps().init___T(v);
          var $$this$2 = this$11.repr$1;
          return new $c_s_Some().init___O(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($fround($m_jl_Double$().parseDouble__T__D($$this$2)), new $c_Lamf_core_parser_Annotations().init___()))
        }
      }
    };
    if (rc15) {
      var s$4 = $as_T(x2$2.value$2);
      if ((s$4 !== null)) {
        if ((s$4 === this.xsdDouble$1)) {
          var this$16 = new $c_sci_StringOps().init___T(v);
          var jsx$1 = $m_jl_Double$();
          var $$this$3 = this$16.repr$1;
          return new $c_s_Some().init___O(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(jsx$1.parseDouble__T__D($$this$3), new $c_Lamf_core_parser_Annotations().init___()))
        }
      }
    };
    if (rc15) {
      var s$5 = $as_T(x2$2.value$2);
      if ((s$5 !== null)) {
        if ((s$5 === this.xsdDateTime$1)) {
          var this$19 = $m_Lorg_mulesoft_common_time_SimpleDateTime$().parse__T__s_util_Either(v);
          return new $c_s_Some().init___O(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(new $c_s_util_Either$RightProjection().init___s_util_Either(this$19).get__O(), new $c_Lamf_core_parser_Annotations().init___()))
        }
      }
    };
    if (rc15) {
      var s$6 = $as_T(x2$2.value$2);
      if ((s$6 !== null)) {
        if ((s$6 === this.xsdDate$1)) {
          var this$21 = $m_Lorg_mulesoft_common_time_SimpleDateTime$().parse__T__s_util_Either(v);
          return new $c_s_Some().init___O(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(new $c_s_util_Either$RightProjection().init___s_util_Either(this$21).get__O(), new $c_Lamf_core_parser_Annotations().init___()))
        }
      }
    };
    return new $c_s_Some().init___O(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(v, new $c_Lamf_core_parser_Annotations().init___()))
  } else if ((property instanceof $c_Lamf_core_rdf_Uri)) {
    var x3 = $as_Lamf_core_rdf_Uri(property);
    var v$2 = x3.value$1;
    var message = ("Expecting String literal found URI " + v$2);
    return $f_Lamf_core_rdf_converter_Converter__conversionValidation__T__Lamf_core_errorhandling_ErrorHandler__s_None$(this, message, errorHandler)
  } else {
    throw new $c_s_MatchError().init___O(property)
  }
});
var $d_Lamf_core_rdf_converter_AnyTypeConverter$ = new $TypeData().initClass({
  Lamf_core_rdf_converter_AnyTypeConverter$: 0
}, false, "amf.core.rdf.converter.AnyTypeConverter$", {
  Lamf_core_rdf_converter_AnyTypeConverter$: 1,
  O: 1,
  Lamf_core_rdf_converter_Converter: 1
});
$c_Lamf_core_rdf_converter_AnyTypeConverter$.prototype.$classData = $d_Lamf_core_rdf_converter_AnyTypeConverter$;
var $n_Lamf_core_rdf_converter_AnyTypeConverter$ = (void 0);
function $m_Lamf_core_rdf_converter_AnyTypeConverter$() {
  if ((!$n_Lamf_core_rdf_converter_AnyTypeConverter$)) {
    $n_Lamf_core_rdf_converter_AnyTypeConverter$ = new $c_Lamf_core_rdf_converter_AnyTypeConverter$().init___()
  };
  return $n_Lamf_core_rdf_converter_AnyTypeConverter$
}
/** @constructor */
function $c_Lamf_core_rdf_converter_ScalarTypeConverter$() {
  $c_O.call(this)
}
$c_Lamf_core_rdf_converter_ScalarTypeConverter$.prototype = new $h_O();
$c_Lamf_core_rdf_converter_ScalarTypeConverter$.prototype.constructor = $c_Lamf_core_rdf_converter_ScalarTypeConverter$;
/** @constructor */
function $h_Lamf_core_rdf_converter_ScalarTypeConverter$() {
  /*<skip>*/
}
$h_Lamf_core_rdf_converter_ScalarTypeConverter$.prototype = $c_Lamf_core_rdf_converter_ScalarTypeConverter$.prototype;
$c_Lamf_core_rdf_converter_ScalarTypeConverter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_rdf_converter_ScalarTypeConverter$.prototype.date__Lamf_core_rdf_PropertyObject__Lamf_core_errorhandling_ErrorHandler__s_Option = (function(property, errorHandler) {
  if ((property instanceof $c_Lamf_core_rdf_Literal)) {
    var x2 = $as_Lamf_core_rdf_Literal(property);
    var v = x2.value$1;
    var x1$2 = $m_Lorg_mulesoft_common_time_SimpleDateTime$().parse__T__s_util_Either(v);
    if ((x1$2 instanceof $c_s_util_Right)) {
      var x2$2 = $as_s_util_Right(x1$2);
      var value = $as_Lorg_mulesoft_common_time_SimpleDateTime(x2$2.value$2);
      return new $c_s_Some().init___O(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, new $c_Lamf_core_parser_Annotations().init___()))
    } else if ((x1$2 instanceof $c_s_util_Left)) {
      var x3 = $as_s_util_Left(x1$2);
      var error = $as_Lorg_mulesoft_common_parse_ParseError(x3.value$2);
      var message = error.message__T();
      return $f_Lamf_core_rdf_converter_Converter__conversionValidation__T__Lamf_core_errorhandling_ErrorHandler__s_None$(this, message, errorHandler)
    } else {
      throw new $c_s_MatchError().init___O(x1$2)
    }
  } else if ((property instanceof $c_Lamf_core_rdf_Uri)) {
    var x4 = $as_Lamf_core_rdf_Uri(property);
    var v$2 = x4.value$1;
    var message$1 = ("Expecting Date literal found URI " + v$2);
    return $f_Lamf_core_rdf_converter_Converter__conversionValidation__T__Lamf_core_errorhandling_ErrorHandler__s_None$(this, message$1, errorHandler)
  } else {
    throw new $c_s_MatchError().init___O(property)
  }
});
$c_Lamf_core_rdf_converter_ScalarTypeConverter$.prototype.bool__Lamf_core_rdf_PropertyObject__Lamf_core_errorhandling_ErrorHandler__s_Option = (function(property, errorHandler) {
  if ((property instanceof $c_Lamf_core_rdf_Literal)) {
    var x2 = $as_Lamf_core_rdf_Literal(property);
    var v = x2.value$1;
    var this$2 = new $c_sci_StringOps().init___T(v);
    var $$this = this$2.repr$1;
    return new $c_s_Some().init___O(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($f_sci_StringLike__parseBoolean__psci_StringLike__T__Z(this$2, $$this), new $c_Lamf_core_parser_Annotations().init___()))
  } else if ((property instanceof $c_Lamf_core_rdf_Uri)) {
    var x4 = $as_Lamf_core_rdf_Uri(property);
    var v$2 = x4.value$1;
    var message = ("Expecting Boolean literal found URI " + v$2);
    return $f_Lamf_core_rdf_converter_Converter__conversionValidation__T__Lamf_core_errorhandling_ErrorHandler__s_None$(this, message, errorHandler)
  } else {
    throw new $c_s_MatchError().init___O(property)
  }
});
$c_Lamf_core_rdf_converter_ScalarTypeConverter$.prototype.$float__Lamf_core_rdf_PropertyObject__Lamf_core_errorhandling_ErrorHandler__s_Option = (function(property, errorHandler) {
  if ((property instanceof $c_Lamf_core_rdf_Literal)) {
    var x2 = $as_Lamf_core_rdf_Literal(property);
    var v = x2.value$1;
    var this$2 = new $c_sci_StringOps().init___T(v);
    var $$this = this$2.repr$1;
    return new $c_s_Some().init___O(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($fround($m_jl_Double$().parseDouble__T__D($$this)), new $c_Lamf_core_parser_Annotations().init___()))
  } else if ((property instanceof $c_Lamf_core_rdf_Uri)) {
    var x4 = $as_Lamf_core_rdf_Uri(property);
    var v$2 = x4.value$1;
    var message = ("Expecting Float literal found URI " + v$2);
    return $f_Lamf_core_rdf_converter_Converter__conversionValidation__T__Lamf_core_errorhandling_ErrorHandler__s_None$(this, message, errorHandler)
  } else {
    throw new $c_s_MatchError().init___O(property)
  }
});
$c_Lamf_core_rdf_converter_ScalarTypeConverter$.prototype.$double__Lamf_core_rdf_PropertyObject__Lamf_core_errorhandling_ErrorHandler__s_Option = (function(property, errorHandler) {
  if ((property instanceof $c_Lamf_core_rdf_Literal)) {
    var x2 = $as_Lamf_core_rdf_Literal(property);
    var v = x2.value$1;
    var this$2 = new $c_sci_StringOps().init___T(v);
    var jsx$1 = $m_jl_Double$();
    var $$this = this$2.repr$1;
    return new $c_s_Some().init___O(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(jsx$1.parseDouble__T__D($$this), new $c_Lamf_core_parser_Annotations().init___()))
  } else if ((property instanceof $c_Lamf_core_rdf_Uri)) {
    var x4 = $as_Lamf_core_rdf_Uri(property);
    var v$2 = x4.value$1;
    var message = ("Expecting Double literal found URI " + v$2);
    return $f_Lamf_core_rdf_converter_Converter__conversionValidation__T__Lamf_core_errorhandling_ErrorHandler__s_None$(this, message, errorHandler)
  } else {
    throw new $c_s_MatchError().init___O(property)
  }
});
$c_Lamf_core_rdf_converter_ScalarTypeConverter$.prototype.$int__Lamf_core_rdf_PropertyObject__Lamf_core_errorhandling_ErrorHandler__s_Option = (function(property, errorHandler) {
  if ((property instanceof $c_Lamf_core_rdf_Literal)) {
    var x2 = $as_Lamf_core_rdf_Literal(property);
    var v = x2.value$1;
    var this$2 = new $c_sci_StringOps().init___T(v);
    var this$4 = $m_jl_Integer$();
    var $$this = this$2.repr$1;
    return new $c_s_Some().init___O(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(this$4.parseInt__T__I__I($$this, 10), new $c_Lamf_core_parser_Annotations().init___()))
  } else if ((property instanceof $c_Lamf_core_rdf_Uri)) {
    var x4 = $as_Lamf_core_rdf_Uri(property);
    var v$2 = x4.value$1;
    var message = ("Expecting Int literal found URI " + v$2);
    return $f_Lamf_core_rdf_converter_Converter__conversionValidation__T__Lamf_core_errorhandling_ErrorHandler__s_None$(this, message, errorHandler)
  } else {
    throw new $c_s_MatchError().init___O(property)
  }
});
$c_Lamf_core_rdf_converter_ScalarTypeConverter$.prototype.tryConvert__Lamf_core_metamodel_Type__Lamf_core_rdf_PropertyObject__Lamf_core_errorhandling_ErrorHandler__s_Option = (function(type, property, errorHandler) {
  var x = $m_Lamf_core_metamodel_Type$Iri$();
  if (x.equals__O__Z(type)) {
    var jsx$1 = true
  } else {
    var x$3 = $m_Lamf_core_metamodel_Type$Str$();
    if (x$3.equals__O__Z(type)) {
      var jsx$1 = true
    } else {
      var x$5 = $m_Lamf_core_metamodel_Type$RegExp$();
      if (x$5.equals__O__Z(type)) {
        var jsx$1 = true
      } else {
        var x$7 = $m_Lamf_core_metamodel_Type$LiteralUri$();
        var jsx$1 = x$7.equals__O__Z(type)
      }
    }
  };
  if (jsx$1) {
    return new $c_s_Some().init___O($m_Lamf_core_rdf_converter_StringIriUriRegexParser$().parse__Lamf_core_rdf_PropertyObject__Lamf_core_model_domain_AmfScalar(property))
  } else {
    var x$9 = $m_Lamf_core_metamodel_Type$Bool$();
    if (x$9.equals__O__Z(type)) {
      return this.bool__Lamf_core_rdf_PropertyObject__Lamf_core_errorhandling_ErrorHandler__s_Option(property, errorHandler)
    } else {
      var x$11 = $m_Lamf_core_metamodel_Type$Int$();
      if (x$11.equals__O__Z(type)) {
        return this.$int__Lamf_core_rdf_PropertyObject__Lamf_core_errorhandling_ErrorHandler__s_Option(property, errorHandler)
      } else {
        var x$13 = $m_Lamf_core_metamodel_Type$Float$();
        if (x$13.equals__O__Z(type)) {
          return this.$float__Lamf_core_rdf_PropertyObject__Lamf_core_errorhandling_ErrorHandler__s_Option(property, errorHandler)
        } else {
          var x$15 = $m_Lamf_core_metamodel_Type$Double$();
          if (x$15.equals__O__Z(type)) {
            return this.$double__Lamf_core_rdf_PropertyObject__Lamf_core_errorhandling_ErrorHandler__s_Option(property, errorHandler)
          } else {
            var x$17 = $m_Lamf_core_metamodel_Type$DateTime$();
            if (x$17.equals__O__Z(type)) {
              var jsx$2 = true
            } else {
              var x$19 = $m_Lamf_core_metamodel_Type$Date$();
              var jsx$2 = x$19.equals__O__Z(type)
            };
            if (jsx$2) {
              return this.date__Lamf_core_rdf_PropertyObject__Lamf_core_errorhandling_ErrorHandler__s_Option(property, errorHandler)
            } else {
              return $m_s_None$()
            }
          }
        }
      }
    }
  }
});
var $d_Lamf_core_rdf_converter_ScalarTypeConverter$ = new $TypeData().initClass({
  Lamf_core_rdf_converter_ScalarTypeConverter$: 0
}, false, "amf.core.rdf.converter.ScalarTypeConverter$", {
  Lamf_core_rdf_converter_ScalarTypeConverter$: 1,
  O: 1,
  Lamf_core_rdf_converter_Converter: 1
});
$c_Lamf_core_rdf_converter_ScalarTypeConverter$.prototype.$classData = $d_Lamf_core_rdf_converter_ScalarTypeConverter$;
var $n_Lamf_core_rdf_converter_ScalarTypeConverter$ = (void 0);
function $m_Lamf_core_rdf_converter_ScalarTypeConverter$() {
  if ((!$n_Lamf_core_rdf_converter_ScalarTypeConverter$)) {
    $n_Lamf_core_rdf_converter_ScalarTypeConverter$ = new $c_Lamf_core_rdf_converter_ScalarTypeConverter$().init___()
  };
  return $n_Lamf_core_rdf_converter_ScalarTypeConverter$
}
/** @constructor */
function $c_Lamf_core_rdf_parsers_CustomPropertiesParser() {
  $c_O.call(this);
  this.linkFinder$1 = null;
  this.sourcesRetriever$1 = null;
  this.ctx$1 = null
}
$c_Lamf_core_rdf_parsers_CustomPropertiesParser.prototype = new $h_O();
$c_Lamf_core_rdf_parsers_CustomPropertiesParser.prototype.constructor = $c_Lamf_core_rdf_parsers_CustomPropertiesParser;
/** @constructor */
function $h_Lamf_core_rdf_parsers_CustomPropertiesParser() {
  /*<skip>*/
}
$h_Lamf_core_rdf_parsers_CustomPropertiesParser.prototype = $c_Lamf_core_rdf_parsers_CustomPropertiesParser.prototype;
$c_Lamf_core_rdf_parsers_CustomPropertiesParser.prototype.applyScalarDomainProperties__p1__Lamf_core_model_domain_DomainElement__sc_Seq__V = (function(instance, scalars) {
  scalars.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, instance$1) {
    return (function(e$2) {
      var e = $as_Lamf_core_model_domain_extensions_DomainExtension(e$2);
      var this$1 = instance$1.fields__Lamf_core_parser_Fields().fieldsMeta__sci_List();
      inlinereturn$2: {
        var these = this$1;
        while ((!these.isEmpty__Z())) {
          var arg1 = these.head__O();
          var f = $as_Lamf_core_metamodel_Field(arg1);
          var this$2 = $as_Lamf_core_model_StrField(e.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Element$1));
          var other = f.value$1.iri__T();
          if ($f_Lamf_core_model_ValueField__is__O__Z(this$2, other)) {
            var this$3 = new $c_s_Some().init___O(these.head__O());
            break inlinereturn$2
          };
          these = $as_sc_LinearSeqOptimized(these.tail__O())
        };
        var this$3 = $m_s_None$()
      };
      if ((!this$3.isEmpty__Z())) {
        var arg1$1 = this$3.get__O();
        var f$3 = $as_Lamf_core_metamodel_Field(arg1$1);
        var this$4 = instance$1.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option(f$3);
        if ((!this$4.isEmpty__Z())) {
          var arg1$2 = this$4.get__O();
          var x0$1 = $as_Lamf_core_parser_FieldEntry(arg1$2);
          if ((x0$1 !== null)) {
            var value = x0$1.value$1;
            value.value$1.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_DomainExtensionAnnotation().init___Lamf_core_model_domain_extensions_DomainExtension(e))
          } else {
            throw new $c_s_MatchError().init___O(x0$1)
          }
        }
      }
    })
  })(this, instance)))
});
$c_Lamf_core_rdf_parsers_CustomPropertiesParser.prototype.parse__Lamf_core_rdf_Node__Lamf_core_model_domain_DomainElement__V = (function(node, instance) {
  var this$1 = node.getProperties__T__s_Option($m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field().value$1.iri__T());
  var jsx$2 = $as_sc_TraversableLike($as_sc_TraversableLike((this$1.isEmpty__Z() ? $m_sci_Nil$() : this$1.get__O())).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_rdf_PropertyObject(x$1$2);
      return (x$1 instanceof $c_Lamf_core_rdf_Uri)
    })
  })(this))));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_rdf_PropertyObject(x$2$2);
      var this$4 = $as_Lamf_core_rdf_Uri(x$2);
      return this$4.value$1
    })
  })(this));
  var this$5 = $m_sc_Seq$();
  var properties = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2));
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, node$1) {
    return (function(uri$2) {
      var uri = $as_T(uri$2);
      var this$6 = node$1.getProperties__T__s_Option(uri);
      if (this$6.isEmpty__Z()) {
        var xo = $m_s_None$()
      } else {
        var arg1 = this$6.get__O();
        var entries = $as_sc_Seq(arg1);
        $m_Lamf_core_parser_Annotations$();
        var annotations = new $c_Lamf_core_parser_Annotations().init___();
        var extension = new $c_Lamf_core_model_domain_extensions_DomainExtension().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
        if (entries.nonEmpty__Z()) {
          var x1 = this$4$1.linkFinder$1.findLink__Lamf_core_rdf_PropertyObject__s_Option($as_Lamf_core_rdf_PropertyObject(entries.head__O()));
          if ((x1 instanceof $c_s_Some)) {
            var x2 = $as_s_Some(x1);
            var obj = $as_Lamf_core_rdf_Node(x2.value$2);
            var x1$2 = obj.getProperties__T__s_Option($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1.value$1.iri__T());
            matchEnd4: {
              if ((x1$2 instanceof $c_s_Some)) {
                var x2$2 = $as_s_Some(x1$2);
                var es = $as_sc_Seq(x2$2.value$2);
                if ((es.nonEmpty__Z() && (es.head__O() instanceof $c_Lamf_core_rdf_Literal))) {
                  $m_Lorg_yaml_model_YNode$();
                  var t = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1.type$1;
                  $m_Lorg_yaml_model_YNode$();
                  var this$10 = $as_Lamf_core_rdf_Literal(es.head__O());
                  var str = this$10.value$1;
                  var node$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
                  var node$3 = $f_Lamf_core_rdf_RdfParserCommon__value__Lamf_core_metamodel_Type__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode(this$4$1, t, node$2);
                  var iv = this$4$1.ctx$1;
                  var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
                  var name = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node$3, conversion, iv));
                  var field = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1;
                  $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(extension, field, name));
                  break matchEnd4
                }
              }
            };
            var x1$3 = obj.getProperties__T__s_Option($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Element$1.value$1.iri__T());
            matchEnd4$2: {
              if ((x1$3 instanceof $c_s_Some)) {
                var x2$3 = $as_s_Some(x1$3);
                var es$2 = $as_sc_Seq(x2$3.value$2);
                if ((es$2.nonEmpty__Z() && (es$2.head__O() instanceof $c_Lamf_core_rdf_Literal))) {
                  $m_Lorg_yaml_model_YNode$();
                  var t$1 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Element$1.type$1;
                  $m_Lorg_yaml_model_YNode$();
                  var this$13 = $as_Lamf_core_rdf_Literal(es$2.head__O());
                  var str$1 = this$13.value$1;
                  var node$4 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
                  var node$5 = $f_Lamf_core_rdf_RdfParserCommon__value__Lamf_core_metamodel_Type__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode(this$4$1, t$1, node$4);
                  var iv$1 = this$4$1.ctx$1;
                  var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
                  var name$1 = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node$5, conversion$1, iv$1));
                  var field$1 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1;
                  $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(extension, field$1, name$1));
                  break matchEnd4$2
                }
              }
            };
            $m_Lamf_core_parser_Annotations$();
            var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
            var definition = new $c_Lamf_core_model_domain_extensions_CustomDomainProperty().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
            definition.id$1 = uri;
            var field$2 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().DefinedBy$1;
            $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(extension, field$2, definition));
            var this$20 = new $c_Lamf_core_rdf_parsers_DynamicTypeParser().init___Lamf_core_rdf_graph_NodeFinder__Lamf_core_rdf_parsers_SourcesRetriever__Lamf_core_rdf_helper_DefaultNodeClassSorter__Lamf_core_rdf_RdfParserContext(this$4$1.linkFinder$1, this$4$1.sourcesRetriever$1, new $c_Lamf_core_rdf_helper_DefaultNodeClassSorter().init___(), this$4$1.ctx$1).parse__Lamf_core_rdf_PropertyObject__s_Option($as_Lamf_core_rdf_PropertyObject(entries.head__O()));
            if ((!this$20.isEmpty__Z())) {
              var arg1$1 = this$20.get__O();
              var pn = $as_Lamf_core_model_domain_DataNode(arg1$1);
              var value = pn.id$1;
              $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(extension, value);
              var field$3 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1;
              $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(extension, field$3, pn))
            };
            var sources = this$4$1.sourcesRetriever$1.retrieve__Lamf_core_rdf_Node__Lamf_core_model_document_SourceMap(node$1);
            var jsx$4 = extension.annotations$1;
            var key = extension.id$1;
            jsx$4.$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations($f_Lamf_core_rdf_RdfParserCommon__annots__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this$4$1, sources, key))
          }
        };
        var xo = new $c_s_Some().init___O(extension)
      };
      return xo.toList__sci_List()
    })
  })(this, node));
  var this$22 = $m_sc_Seq$();
  var extensions = $as_sc_Seq(properties.flatMap__F1__scg_CanBuildFrom__O(jsx$3, this$22.ReusableCBFInstance$2));
  if (extensions.nonEmpty__Z()) {
    var x1$1 = extensions.partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1) {
      return (function(x$3$2) {
        var x$3 = $as_Lamf_core_model_domain_extensions_DomainExtension(x$3$2);
        return x$3.isScalarExtension__Z()
      })
    })(this)));
    if ((x1$1 !== null)) {
      var scalars = $as_sc_Seq(x1$1.$$und1__O());
      var objects = $as_sc_Seq(x1$1.$$und2__O());
      var field$4 = $m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field();
      $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(instance, field$4, objects));
      this.applyScalarDomainProperties__p1__Lamf_core_model_domain_DomainElement__sc_Seq__V(instance, scalars)
    } else {
      throw new $c_s_MatchError().init___O(x1$1)
    }
  }
});
$c_Lamf_core_rdf_parsers_CustomPropertiesParser.prototype.init___Lamf_core_rdf_graph_NodeFinder__Lamf_core_rdf_parsers_SourcesRetriever__Lamf_core_rdf_RdfParserContext = (function(linkFinder, sourcesRetriever, ctx) {
  this.linkFinder$1 = linkFinder;
  this.sourcesRetriever$1 = sourcesRetriever;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_core_rdf_parsers_CustomPropertiesParser.prototype.ctx__Lamf_core_rdf_RdfParserContext = (function() {
  return this.ctx$1
});
var $d_Lamf_core_rdf_parsers_CustomPropertiesParser = new $TypeData().initClass({
  Lamf_core_rdf_parsers_CustomPropertiesParser: 0
}, false, "amf.core.rdf.parsers.CustomPropertiesParser", {
  Lamf_core_rdf_parsers_CustomPropertiesParser: 1,
  O: 1,
  Lamf_core_rdf_RdfParserCommon: 1
});
$c_Lamf_core_rdf_parsers_CustomPropertiesParser.prototype.$classData = $d_Lamf_core_rdf_parsers_CustomPropertiesParser;
/** @constructor */
function $c_Lamf_core_rdf_parsers_DynamicArrayParser() {
  $c_O.call(this);
  this.linkFinder$1 = null;
  this.sourcesRetriever$1 = null;
  this.ctx$1 = null
}
$c_Lamf_core_rdf_parsers_DynamicArrayParser.prototype = new $h_O();
$c_Lamf_core_rdf_parsers_DynamicArrayParser.prototype.constructor = $c_Lamf_core_rdf_parsers_DynamicArrayParser;
/** @constructor */
function $h_Lamf_core_rdf_parsers_DynamicArrayParser() {
  /*<skip>*/
}
$h_Lamf_core_rdf_parsers_DynamicArrayParser.prototype = $c_Lamf_core_rdf_parsers_DynamicArrayParser.prototype;
$c_Lamf_core_rdf_parsers_DynamicArrayParser.prototype.init___Lamf_core_rdf_graph_NodeFinder__Lamf_core_rdf_parsers_SourcesRetriever__Lamf_core_rdf_RdfParserContext = (function(linkFinder, sourcesRetriever, ctx) {
  this.linkFinder$1 = linkFinder;
  this.sourcesRetriever$1 = sourcesRetriever;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_core_rdf_parsers_DynamicArrayParser.prototype.ctx__Lamf_core_rdf_RdfParserContext = (function() {
  return this.ctx$1
});
$c_Lamf_core_rdf_parsers_DynamicArrayParser.prototype.parseDynamicArrayInner__p1__Lamf_core_rdf_PropertyObject__sc_Seq__sc_Seq = (function(entry, acc) {
  _parseDynamicArrayInner: while (true) {
    var x1 = this.linkFinder$1.findLink__Lamf_core_rdf_PropertyObject__s_Option(entry);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var n = $as_Lamf_core_rdf_Node(x2.value$2);
      var this$1 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
      var this$3 = n.getProperties__T__s_Option(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "next").iri__T());
      var nextNode = $as_sc_TraversableLike((this$3.isEmpty__Z() ? $m_sci_Nil$() : this$3.get__O())).headOption__s_Option();
      var this$4 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
      var this$6 = n.getProperties__T__s_Option(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "first").iri__T());
      var firstNode = $as_sc_TraversableLike((this$6.isEmpty__Z() ? $m_sci_Nil$() : this$6.get__O())).headOption__s_Option();
      matchEnd6: {
        var updatedAcc;
        if ((firstNode instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(firstNode);
          var id = $as_Lamf_core_rdf_PropertyObject(x2$2.value$2);
          if ((id instanceof $c_Lamf_core_rdf_Uri)) {
            var x3 = $as_Lamf_core_rdf_Uri(id);
            var x1$3 = new $c_Lamf_core_rdf_parsers_DynamicTypeParser().init___Lamf_core_rdf_graph_NodeFinder__Lamf_core_rdf_parsers_SourcesRetriever__Lamf_core_rdf_helper_DefaultNodeClassSorter__Lamf_core_rdf_RdfParserContext(this.linkFinder$1, this.sourcesRetriever$1, new $c_Lamf_core_rdf_helper_DefaultNodeClassSorter().init___(), this.ctx$1).parse__Lamf_core_rdf_PropertyObject__s_Option(x3);
            if ((x1$3 instanceof $c_s_Some)) {
              var x2$3 = $as_s_Some(x1$3);
              var member = $as_Lamf_core_model_domain_DataNode(x2$3.value$2);
              var jsx$3 = acc;
              var jsx$2 = $m_sc_Seq$();
              var array = [member];
              var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
              var this$10 = $m_sc_Seq$();
              var updatedAcc = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$10.ReusableCBFInstance$2));
              break matchEnd6
            } else {
              var updatedAcc = acc;
              break matchEnd6
            }
          }
        };
        var updatedAcc = acc
      };
      if ((nextNode instanceof $c_s_Some)) {
        var x2$4 = $as_s_Some(nextNode);
        var nextNodeProp = $as_Lamf_core_rdf_PropertyObject(x2$4.value$2);
        if ((nextNodeProp instanceof $c_Lamf_core_rdf_Uri)) {
          var x3$2 = $as_Lamf_core_rdf_Uri(nextNodeProp);
          var id$2 = x3$2.value$1;
          var this$11 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
          if ((id$2 !== new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$11, "nil").iri__T())) {
            entry = x3$2;
            acc = updatedAcc;
            continue _parseDynamicArrayInner
          }
        }
      };
      return updatedAcc
    } else {
      var x$2 = $m_s_None$();
      if ((x$2 === x1)) {
        return acc
      } else {
        throw new $c_s_MatchError().init___O(x1)
      }
    }
  }
});
$c_Lamf_core_rdf_parsers_DynamicArrayParser.prototype.parse__Lamf_core_rdf_PropertyObject__Lamf_core_model_domain_ArrayNode = (function(propertyObject) {
  var x1 = this.linkFinder$1.findLink__Lamf_core_rdf_PropertyObject__s_Option(propertyObject);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var node = $as_Lamf_core_rdf_Node(x2.value$2);
    var sources = this.sourcesRetriever$1.retrieve__Lamf_core_rdf_Node__Lamf_core_model_document_SourceMap(node);
    var key = node.subject$1;
    var nodeAnnotations = $f_Lamf_core_rdf_RdfParserCommon__annots__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, sources, key)
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    $m_Lamf_core_parser_Annotations$();
    var nodeAnnotations = new $c_Lamf_core_parser_Annotations().init___()
  };
  var nodes = this.parseDynamicArrayInner__p1__Lamf_core_rdf_PropertyObject__sc_Seq__sc_Seq(propertyObject, $m_sci_Nil$());
  $m_Lamf_core_model_domain_ArrayNode$();
  var array = new $c_Lamf_core_model_domain_ArrayNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), nodeAnnotations);
  nodes.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, array$1) {
    return (function(member$2) {
      var member = $as_Lamf_core_model_domain_DataNode(member$2);
      return array$1.addMember__Lamf_core_model_domain_DataNode__sc_Seq(member)
    })
  })(this, array)));
  return array
});
var $d_Lamf_core_rdf_parsers_DynamicArrayParser = new $TypeData().initClass({
  Lamf_core_rdf_parsers_DynamicArrayParser: 0
}, false, "amf.core.rdf.parsers.DynamicArrayParser", {
  Lamf_core_rdf_parsers_DynamicArrayParser: 1,
  O: 1,
  Lamf_core_rdf_RdfParserCommon: 1
});
$c_Lamf_core_rdf_parsers_DynamicArrayParser.prototype.$classData = $d_Lamf_core_rdf_parsers_DynamicArrayParser;
/** @constructor */
function $c_Lamf_core_rdf_parsers_DynamicTypeParser() {
  $c_O.call(this);
  this.linkFinder$1 = null;
  this.sourcesRetriever$1 = null;
  this.sorter$1 = null;
  this.ctx$1 = null;
  this.dynamicBuilders$1 = null
}
$c_Lamf_core_rdf_parsers_DynamicTypeParser.prototype = new $h_O();
$c_Lamf_core_rdf_parsers_DynamicTypeParser.prototype.constructor = $c_Lamf_core_rdf_parsers_DynamicTypeParser;
/** @constructor */
function $h_Lamf_core_rdf_parsers_DynamicTypeParser() {
  /*<skip>*/
}
$h_Lamf_core_rdf_parsers_DynamicTypeParser.prototype = $c_Lamf_core_rdf_parsers_DynamicTypeParser.prototype;
$c_Lamf_core_rdf_parsers_DynamicTypeParser.prototype.init___Lamf_core_rdf_graph_NodeFinder__Lamf_core_rdf_parsers_SourcesRetriever__Lamf_core_rdf_helper_DefaultNodeClassSorter__Lamf_core_rdf_RdfParserContext = (function(linkFinder, sourcesRetriever, sorter, ctx) {
  this.linkFinder$1 = linkFinder;
  this.sourcesRetriever$1 = sourcesRetriever;
  this.sorter$1 = sorter;
  this.ctx$1 = ctx;
  var self = $m_Lamf_core_model_domain_LinkNode$().builderType$1.iri__T();
  var y = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(annotations$2) {
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      var this$2 = $m_Lamf_core_model_domain_LinkNode$();
      return this$2.apply__T__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_LinkNode("", "", annotations)
    })
  })(this));
  var jsx$3 = new $c_T2().init___O__O(self, y);
  var self$1 = $m_Lamf_core_model_domain_ArrayNode$().builderType$1.iri__T();
  var y$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(annotations$3$2) {
      var annotations$3 = $as_Lamf_core_parser_Annotations(annotations$3$2);
      $m_Lamf_core_model_domain_ArrayNode$();
      return new $c_Lamf_core_model_domain_ArrayNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$3)
    })
  })(this));
  var jsx$2 = new $c_T2().init___O__O(self$1, y$1);
  var self$2 = $as_Lamf_core_vocabulary_ValueType($m_Lamf_core_metamodel_domain_ScalarNodeModel$().type$1.head__O()).iri__T();
  var y$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(annotations$4$2) {
      var annotations$4 = $as_Lamf_core_parser_Annotations(annotations$4$2);
      var this$9 = $m_Lamf_core_model_domain_ScalarNode$();
      return this$9.apply__T__s_Option__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode("", $m_s_None$(), annotations$4)
    })
  })(this));
  var jsx$1 = new $c_T2().init___O__O(self$2, y$2);
  var self$3 = $m_Lamf_core_model_domain_ObjectNode$().builderType$1.iri__T();
  var y$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
    return (function(annotations$5$2) {
      var annotations$5 = $as_Lamf_core_parser_Annotations(annotations$5$2);
      $m_Lamf_core_model_domain_ObjectNode$();
      return new $c_Lamf_core_model_domain_ObjectNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$5)
    })
  })(this));
  var array = [jsx$3, jsx$2, jsx$1, new $c_T2().init___O__O(self$3, y$3)];
  var this$18 = new $c_scm_HashMap().init___();
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$18.$$plus$eq__T2__scm_HashMap($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  this.dynamicBuilders$1 = this$18;
  return this
});
$c_Lamf_core_rdf_parsers_DynamicTypeParser.prototype.parse__Lamf_core_rdf_PropertyObject__s_Option = (function(property) {
  var this$1 = this.linkFinder$1.findLink__Lamf_core_rdf_PropertyObject__s_Option(property);
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var node = $as_Lamf_core_rdf_Node(arg1);
    var sources = this.sourcesRetriever$1.retrieve__Lamf_core_rdf_Node__Lamf_core_model_document_SourceMap(node);
    var builder = $as_F1(this.retrieveDynamicType__Lamf_core_rdf_Node__s_Option(node).get__O());
    var key = property.value__T();
    var x1 = $as_Lamf_core_model_domain_AmfObject(builder.apply__O__O($f_Lamf_core_rdf_RdfParserCommon__annots__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, sources, key)));
    if ((x1 instanceof $c_Lamf_core_model_domain_ObjectNode)) {
      var x2 = $as_Lamf_core_model_domain_ObjectNode(x1);
      var value = node.subject$1;
      $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(x2, value);
      node.getKeys__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, node$1, x2$1) {
        return (function(uri$2) {
          var uri = $as_T(uri$2);
          if ((((uri !== "@type") && (uri !== "@id")) && (uri !== $m_Lamf_core_metamodel_domain_DomainElementModel$().Sources$1.value$1.iri__T()))) {
            var this$2 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
            var jsx$2 = (uri !== new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$2, "name").iri__T())
          } else {
            var jsx$2 = false
          };
          if (jsx$2) {
            var x1$1 = $as_Lamf_core_rdf_PropertyObject($as_sc_IterableLike(node$1.getProperties__T__s_Option(uri).get__O()).head__O());
            if ((x1$1 instanceof $c_Lamf_core_rdf_Literal)) {
              var x2$2 = $as_Lamf_core_rdf_Literal(x1$1);
              var dataNode = $m_Lamf_core_rdf_parsers_DynamicLiteralParser$().parse__Lamf_core_rdf_Literal__Lamf_core_model_domain_ScalarNode(x2$2)
            } else if ($this.isRDFArray__Lamf_core_rdf_PropertyObject__Z(x1$1)) {
              var dataNode = new $c_Lamf_core_rdf_parsers_DynamicArrayParser().init___Lamf_core_rdf_graph_NodeFinder__Lamf_core_rdf_parsers_SourcesRetriever__Lamf_core_rdf_RdfParserContext($this.linkFinder$1, $this.sourcesRetriever$1, $this.ctx$1).parse__Lamf_core_rdf_PropertyObject__Lamf_core_model_domain_ArrayNode(x1$1)
            } else if ((x1$1 instanceof $c_Lamf_core_rdf_Uri)) {
              var x5 = $as_Lamf_core_rdf_Uri(x1$1);
              var this$4 = $this.parse__Lamf_core_rdf_PropertyObject__s_Option(x5);
              if (this$4.isEmpty__Z()) {
                $m_Lamf_core_model_domain_ObjectNode$();
                $m_Lamf_core_parser_Annotations$();
                var annotations = new $c_Lamf_core_parser_Annotations().init___();
                var jsx$3 = new $c_Lamf_core_model_domain_ObjectNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
              } else {
                var jsx$3 = this$4.get__O()
              };
              var dataNode = $as_Lamf_core_model_domain_DataNode(jsx$3)
            } else {
              $m_Lamf_core_model_domain_ObjectNode$();
              $m_Lamf_core_parser_Annotations$();
              var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
              var dataNode = new $c_Lamf_core_model_domain_ObjectNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1)
            };
            return x2$1.addProperty__T__Lamf_core_model_domain_DataNode__Lamf_core_parser_Annotations__Lamf_core_model_domain_ObjectNode(uri, dataNode, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
          } else {
            return (void 0)
          }
        })
      })(this, node, x2)));
      var jsx$1 = x2
    } else if ((x1 instanceof $c_Lamf_core_model_domain_ScalarNode)) {
      var x3 = $as_Lamf_core_model_domain_ScalarNode(x1);
      var value$1 = node.subject$1;
      $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(x3, value$1);
      node.getKeys__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, node$2, x3$1) {
        return (function(k$2) {
          var k = $as_T(k$2);
          var entries = $as_sc_Seq(node$2.getProperties__T__s_Option(k).get__O());
          if (((k === $m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1.value$1.iri__T()) && (entries.head__O() instanceof $c_Lamf_core_rdf_Literal))) {
            var parsedScalar = $m_Lamf_core_rdf_parsers_DynamicLiteralParser$().parse__Lamf_core_rdf_Literal__Lamf_core_model_domain_ScalarNode($as_Lamf_core_rdf_Literal(entries.head__O()));
            var this$12 = $as_Lamf_core_model_StrField(parsedScalar.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1)).option$1;
            if ((!this$12.isEmpty__Z())) {
              var arg1$1 = this$12.get__O();
              var v = $as_T(arg1$1);
              var field = $m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1;
              var value$2 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(v, $as_Lamf_core_model_StrField(parsedScalar.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1)).annotations$1);
              $as_Lamf_core_model_domain_ScalarNode($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(x3$1, field, value$2))
            }
          }
        })
      })(this, node, x3)));
      var jsx$1 = x3
    } else if ((x1 instanceof $c_Lamf_core_model_domain_LinkNode)) {
      var x4 = $as_Lamf_core_model_domain_LinkNode(x1);
      var value$3 = node.subject$1;
      $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(x4, value$3);
      node.getKeys__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, node$3, x4$1) {
        return (function(k$3$2) {
          var k$3 = $as_T(k$3$2);
          var entries$1 = $as_sc_Seq(node$3.getProperties__T__s_Option(k$3).get__O());
          if (((k$3 === $m_Lamf_core_metamodel_domain_LinkNodeModel$().Alias$1.value$1.iri__T()) && (entries$1.head__O() instanceof $c_Lamf_core_rdf_Literal))) {
            var parsedScalar$1 = $m_Lamf_core_rdf_parsers_DynamicLiteralParser$().parse__Lamf_core_rdf_Literal__Lamf_core_model_domain_ScalarNode($as_Lamf_core_rdf_Literal(entries$1.head__O()));
            var this$13 = $as_Lamf_core_model_StrField(parsedScalar$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1)).option$1;
            if ((!this$13.isEmpty__Z())) {
              var arg1$2 = this$13.get__O();
              var alias = $as_T(arg1$2);
              var field$1 = $m_Lamf_core_metamodel_domain_LinkNodeModel$().Alias$1;
              $as_Lamf_core_model_domain_LinkNode($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x4$1, field$1, alias))
            }
          } else if (((k$3 === $m_Lamf_core_metamodel_domain_LinkNodeModel$().Value$1.value$1.iri__T()) && (entries$1.head__O() instanceof $c_Lamf_core_rdf_Literal))) {
            var parsedScalar$2 = $m_Lamf_core_rdf_parsers_DynamicLiteralParser$().parse__Lamf_core_rdf_Literal__Lamf_core_model_domain_ScalarNode($as_Lamf_core_rdf_Literal(entries$1.head__O()));
            var this$14 = $as_Lamf_core_model_StrField(parsedScalar$2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1)).option$1;
            if ((!this$14.isEmpty__Z())) {
              var arg1$3 = this$14.get__O();
              var link = $as_T(arg1$3);
              var field$2 = $m_Lamf_core_metamodel_domain_LinkNodeModel$().Value$1;
              $as_Lamf_core_model_domain_LinkNode($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x4$1, field$2, link))
            }
          }
        })
      })(this, node, x4)));
      var jsx$4 = this.ctx$1.referencesMap$2;
      var this$15 = $as_Lamf_core_model_StrField(x4.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkNodeModel$().Alias$1));
      var this$16 = this$15.option$1;
      var x1$2 = jsx$4.get__O__s_Option($as_T((this$16.isEmpty__Z() ? null : this$16.get__O())));
      if ((x1$2 instanceof $c_s_Some)) {
        var x2$2$1 = $as_s_Some(x1$2);
        var target = $as_Lamf_core_model_domain_DomainElement(x2$2$1.value$2);
        x4.withLinkedDomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_LinkNode(target)
      } else {
        var this$19 = this.ctx$1.unresolvedReferences$2;
        var this$17 = $as_Lamf_core_model_StrField(x4.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkNodeModel$().Alias$1));
        var this$18 = this$17.option$1;
        var key$1 = $as_T((this$18.isEmpty__Z() ? null : this$18.get__O()));
        var x1$3 = this$19.get__O__s_Option(key$1);
        if ((x1$3 instanceof $c_s_Some)) {
          var x2$3 = $as_s_Some(x1$3);
          var v$1 = x2$3.value$2;
          var jsx$5 = v$1
        } else {
          var x = $m_s_None$();
          if ((!(x === x1$3))) {
            throw new $c_s_MatchError().init___O(x1$3)
          };
          var jsx$5 = $m_sci_Nil$()
        };
        var unresolved = $as_sc_Seq(jsx$5);
        var jsx$8 = this.ctx$1.unresolvedReferences$2;
        var this$20 = $as_Lamf_core_model_StrField(x4.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkNodeModel$().Alias$1));
        var this$21 = this$20.option$1;
        var self = $as_T((this$21.isEmpty__Z() ? null : this$21.get__O()));
        var jsx$7 = $m_sc_Seq$();
        var array = [x4];
        var jsx$6 = jsx$7.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
        var this$25 = $m_sc_Seq$();
        var y = unresolved.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$6, this$25.ReusableCBFInstance$2);
        jsx$8.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(self, y))
      };
      var jsx$1 = x4
    } else if ((x1 instanceof $c_Lamf_core_model_domain_ArrayNode)) {
      var x5$1 = $as_Lamf_core_model_domain_ArrayNode(x1);
      var value$4 = node.subject$1;
      $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(x5$1, value$4);
      node.getKeys__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1, x5$2, node$4) {
        return (function(k$4$2) {
          var k$4 = $as_T(k$4$2);
          if ((k$4 === $m_Lamf_core_metamodel_domain_ArrayNodeModel$().Member$1.value$1.iri__T())) {
            var this$27 = node$4.getProperties__T__s_Option(k$4);
            var jsx$10 = $as_sc_TraversableLike((this$27.isEmpty__Z() ? $m_sci_Nil$() : this$27.get__O()));
            var jsx$9 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$2) {
              return (function(property$2) {
                var property$1 = $as_Lamf_core_rdf_PropertyObject(property$2);
                var xo = this$2$2.parse__Lamf_core_rdf_PropertyObject__s_Option(property$1);
                return xo.toList__sci_List()
              })
            })(this$5$1));
            var this$29 = $m_sc_Seq$();
            return x5$2.withMembers__sc_Seq__Lamf_core_model_domain_ArrayNode($as_sc_Seq(jsx$10.flatMap__F1__scg_CanBuildFrom__O(jsx$9, this$29.ReusableCBFInstance$2)))
          } else {
            return (void 0)
          }
        })
      })(this, x5$1, node)));
      var jsx$1 = x5$1
    } else {
      var jsx$1;
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot parse object data node from non object JSON structure " + x1)))
    };
    return new $c_s_Some().init___O(jsx$1)
  }
});
$c_Lamf_core_rdf_parsers_DynamicTypeParser.prototype.isRDFArray__Lamf_core_rdf_PropertyObject__Z = (function(entry) {
  if ((entry instanceof $c_Lamf_core_rdf_Uri)) {
    var x2 = $as_Lamf_core_rdf_Uri(entry);
    var x1$2 = this.linkFinder$1.findLink__Lamf_core_rdf_PropertyObject__s_Option(x2);
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var node = $as_Lamf_core_rdf_Node(x2$2.value$2);
      var this$1 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
      if (node.getProperties__T__s_Option(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "first").iri__T()).isDefined__Z()) {
        return true
      } else {
        var this$3 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
        return node.getProperties__T__s_Option(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "rest").iri__T()).isDefined__Z()
      }
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_rdf_parsers_DynamicTypeParser.prototype.ctx__Lamf_core_rdf_RdfParserContext = (function() {
  return this.ctx$1
});
$c_Lamf_core_rdf_parsers_DynamicTypeParser.prototype.retrieveDynamicType__Lamf_core_rdf_Node__s_Option = (function(node) {
  var x1 = this.sorter$1.sortedClassesOf__Lamf_core_rdf_Node__sc_Seq(node).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(t$2) {
      var t = $as_T(t$2);
      return $this.dynamicBuilders$1.contains__O__Z(t)
    })
  })(this)));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var t$3 = $as_T(x2.value$2);
    return new $c_s_Some().init___O(this.dynamicBuilders$1.apply__O__O(t$3))
  } else {
    return $m_s_None$()
  }
});
var $d_Lamf_core_rdf_parsers_DynamicTypeParser = new $TypeData().initClass({
  Lamf_core_rdf_parsers_DynamicTypeParser: 0
}, false, "amf.core.rdf.parsers.DynamicTypeParser", {
  Lamf_core_rdf_parsers_DynamicTypeParser: 1,
  O: 1,
  Lamf_core_rdf_RdfParserCommon: 1
});
$c_Lamf_core_rdf_parsers_DynamicTypeParser.prototype.$classData = $d_Lamf_core_rdf_parsers_DynamicTypeParser;
/** @constructor */
function $c_Lamf_core_rdf_parsers_ObjectParser() {
  $c_O.call(this);
  this.rootId$1 = null;
  this.recursionControl$1 = null;
  this.plugins$1 = null;
  this.nodeFinder$1 = null;
  this.sourcesRetriever$1 = null;
  this.ctx$1 = null
}
$c_Lamf_core_rdf_parsers_ObjectParser.prototype = new $h_O();
$c_Lamf_core_rdf_parsers_ObjectParser.prototype.constructor = $c_Lamf_core_rdf_parsers_ObjectParser;
/** @constructor */
function $h_Lamf_core_rdf_parsers_ObjectParser() {
  /*<skip>*/
}
$h_Lamf_core_rdf_parsers_ObjectParser.prototype = $c_Lamf_core_rdf_parsers_ObjectParser.prototype;
$c_Lamf_core_rdf_parsers_ObjectParser.prototype.isSelfEncoded__p1__Lamf_core_rdf_Node__Z = (function(node) {
  return (node.subject$1 === this.rootId$1)
});
$c_Lamf_core_rdf_parsers_ObjectParser.prototype.parse__Lamf_core_rdf_Node__Z__s_Option = (function(node, findBaseUnit) {
  var this$1 = this.recursionControl$1;
  if ((this$1.visited$1.contains__O__Z(node.subject$1) && (!this.isSelfEncoded__p1__Lamf_core_rdf_Node__Z(node)))) {
    return this.ctx$1.nodes$2.get__O__s_Option(node.subject$1)
  } else {
    this.recursionControl$1.visited__Lamf_core_rdf_Node__V(node);
    var id = node.subject$1;
    var this$2 = this.plugins$1.retrieveType__T__Lamf_core_rdf_Node__Z__s_Option(id, node, findBaseUnit);
    if (this$2.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1 = this$2.get__O();
      var model = $as_Lamf_core_metamodel_Obj(arg1);
      var sources = this.sourcesRetriever$1.retrieve__Lamf_core_rdf_Node__Lamf_core_model_document_SourceMap(node);
      var instance = $as_Lamf_core_model_domain_AmfObject(this.plugins$1.buildType__Lamf_core_metamodel_Obj__F1(model).apply__O__O($f_Lamf_core_rdf_RdfParserCommon__annots__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, sources, id)));
      instance.withId__T__Lamf_core_model_domain_AmfObject(id);
      this.ctx$1.nodes$2 = this.ctx$1.nodes$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(id, instance));
      this.checkLinkables__p1__Lamf_core_model_domain_AmfObject__V(instance);
      var modelFields = this.extractModelFields__p1__Lamf_core_metamodel_Obj__sci_List(model);
      var these = modelFields;
      while ((!these.isEmpty__Z())) {
        var arg1$1 = these.head__O();
        var f = $as_Lamf_core_metamodel_Field(arg1$1);
        var k = f.value$1.iri__T();
        var properties = this.key__Lamf_core_rdf_Node__T__sc_Seq(node, k);
        if (properties.nonEmpty__Z()) {
          this.traverse__p1__Lamf_core_model_domain_AmfObject__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_document_SourceMap__T__V(instance, f, properties, sources, k)
        };
        these = $as_sci_List(these.tail__O())
      };
      matchEnd5: {
        if (($is_Lamf_core_model_domain_DomainElement(instance) && $is_Lamf_core_model_domain_Linkable(instance))) {
          var x2 = $as_Lamf_core_model_domain_DomainElement(instance);
          this.parseLinkableProperties__p1__Lamf_core_rdf_Node__Lamf_core_model_domain_DomainElement__V(node, x2);
          break matchEnd5
        };
        if ((instance instanceof $c_Lamf_core_model_domain_ExternalDomainElement)) {
          var x3 = $as_Lamf_core_model_domain_ExternalDomainElement(instance);
          if (this.ctx$1.unresolvedExtReferencesMap$2.contains__O__Z(x3.id$1)) {
            var this$5 = this.ctx$1.unresolvedExtReferencesMap$2.get__O__s_Option(x3.id$1);
            if ((!this$5.isEmpty__Z())) {
              var arg1$2 = this$5.get__O();
              var element = $as_Lamf_core_model_domain_ExternalSourceElement(arg1$2);
              var this$6 = $as_Lamf_core_model_StrField(x3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1)).option$1;
              if ((!this$6.isEmpty__Z())) {
                var arg1$3 = this$6.get__O();
                var x$1 = $as_T(arg1$3);
                var field = $m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1;
                $as_Lamf_core_model_domain_ExternalSourceElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(element, field, x$1))
              }
            };
            this.ctx$1.unresolvedExtReferencesMap$2.remove__O__s_Option(x3.id$1);
            break matchEnd5
          }
        }
      };
      if ($is_Lamf_core_model_domain_DomainElement(instance)) {
        var x2$2 = $as_Lamf_core_model_domain_DomainElement(instance);
        new $c_Lamf_core_rdf_parsers_CustomPropertiesParser().init___Lamf_core_rdf_graph_NodeFinder__Lamf_core_rdf_parsers_SourcesRetriever__Lamf_core_rdf_RdfParserContext(this.nodeFinder$1, this.sourcesRetriever$1, this.ctx$1).parse__Lamf_core_rdf_Node__Lamf_core_model_domain_DomainElement__V(node, x2$2)
      };
      return new $c_s_Some().init___O(instance)
    }
  }
});
$c_Lamf_core_rdf_parsers_ObjectParser.prototype.getRdfProperties__p1__s_Option__scm_ListBuffer = (function(maybeCollection) {
  var properties = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  if ((!maybeCollection.isEmpty__Z())) {
    var arg1 = maybeCollection.get__O();
    var collection = $as_Lamf_core_rdf_Node(arg1);
    collection.getKeys__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, properties$1, collection$1) {
      return (function(entry$2) {
        var entry = $as_T(entry$2);
        var this$1 = $m_Lamf_core_vocabulary_Namespace$().Rdfs$1;
        var prefix = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "_").iri__T();
        if ((($uI(entry.length) >= 0) && ($as_T(entry.substring(0, $uI(prefix.length))) === prefix))) {
          return properties$1.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer($as_sc_TraversableOnce(collection$1.getProperties__T__s_Option(entry).get__O()))
        } else {
          return (void 0)
        }
      })
    })(this, properties, collection)))
  };
  return properties
});
$c_Lamf_core_rdf_parsers_ObjectParser.prototype.parseList__p1__Lamf_core_metamodel_Type__s_Option__sc_Seq = (function(listElement, maybeCollection) {
  var properties = this.getRdfProperties__p1__s_Option__scm_ListBuffer(maybeCollection);
  var this$1 = $m_scm_ListBuffer$();
  var bf = this$1.ReusableCBFInstance$2;
  var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(properties, bf);
  var this$2 = properties.scala$collection$mutable$ListBuffer$$start$6;
  var these = this$2;
  while ((!these.isEmpty__Z())) {
    var arg1 = these.head__O();
    var property = $as_Lamf_core_rdf_PropertyObject(arg1);
    var x = $m_Lamf_core_metamodel_domain_DataNodeModel$();
    if ((x === listElement)) {
      var jsx$1 = this.parseDynamicType__Lamf_core_rdf_PropertyObject__s_Option(property)
    } else if ($is_Lamf_core_metamodel_Obj(listElement)) {
      var x1$2 = this.nodeFinder$1.findLink__Lamf_core_rdf_PropertyObject__s_Option(property);
      if ((x1$2 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1$2);
        var node = $as_Lamf_core_rdf_Node(x2.value$2);
        var jsx$1 = this.parse__Lamf_core_rdf_Node__Z__s_Option(node, false)
      } else {
        var jsx$1 = $m_s_None$()
      }
    } else if ((listElement instanceof $c_Lamf_core_metamodel_Type$Scalar)) {
      var jsx$1 = $m_Lamf_core_rdf_converter_ScalarTypeConverter$().tryConvert__Lamf_core_metamodel_Type__Lamf_core_rdf_PropertyObject__Lamf_core_errorhandling_ErrorHandler__s_Option(listElement, property, this.ctx$1.eh$1)
    } else {
      var x$3 = $m_Lamf_core_metamodel_Type$Any$();
      if ((!(x$3 === listElement))) {
        throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Unknown list element type: " + listElement)))
      };
      var jsx$1 = $m_Lamf_core_rdf_converter_AnyTypeConverter$().tryConvert__Lamf_core_rdf_PropertyObject__Lamf_core_errorhandling_ErrorHandler__s_Option(property, this.ctx$1.eh$1)
    };
    b.$$plus$eq__O__scm_Builder(jsx$1);
    these = $as_sci_List(these.tail__O())
  };
  var res = $as_scm_ListBuffer(b.result__O());
  var pf = new $c_Lamf_core_rdf_parsers_ObjectParser$$anonfun$parseList$2().init___Lamf_core_rdf_parsers_ObjectParser(this);
  var this$3 = $m_scm_ListBuffer$();
  var bf$1 = this$3.ReusableCBFInstance$2;
  return $as_sc_Seq($f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(res, pf, bf$1))
});
$c_Lamf_core_rdf_parsers_ObjectParser.prototype.parseScalar__p1__Lamf_core_model_domain_AmfObject__Lamf_core_metamodel_Field__Lamf_core_rdf_PropertyObject__Lamf_core_parser_Annotations__V = (function(instance, field, property, annotations) {
  var this$1 = $m_Lamf_core_rdf_converter_ScalarTypeConverter$().tryConvert__Lamf_core_metamodel_Type__Lamf_core_rdf_PropertyObject__Lamf_core_errorhandling_ErrorHandler__s_Option(field.type$1, property, this.ctx$1.eh$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var x$2 = $as_Lamf_core_model_domain_AmfScalar(arg1);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, field, x$2, annotations)
  }
});
$c_Lamf_core_rdf_parsers_ObjectParser.prototype.parseList__p1__Lamf_core_model_domain_AmfObject__Lamf_core_metamodel_Type$SortedArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__V = (function(instance, l, field, properties, annotations) {
  var jsx$1 = l.element$1;
  var property = $as_Lamf_core_rdf_PropertyObject(properties.head__O());
  var values = this.parseList__p1__Lamf_core_metamodel_Type__s_Option__sc_Seq(jsx$1, this.nodeFinder$1.findLink__Lamf_core_rdf_PropertyObject__s_Option(property));
  $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, field, values, annotations)
});
$c_Lamf_core_rdf_parsers_ObjectParser.prototype.extractModelFields__p1__Lamf_core_metamodel_Obj__sci_List = (function(model) {
  if ($is_Lamf_core_metamodel_domain_ShapeModel(model)) {
    var x2 = $as_Lamf_core_metamodel_domain_ShapeModel(model);
    var jsx$3 = x2.fields__sci_List();
    var jsx$2 = $m_sc_Seq$();
    var array = [$m_Lamf_core_metamodel_domain_ShapeModel$().CustomShapePropertyDefinitions__Lamf_core_metamodel_Field(), $m_Lamf_core_metamodel_domain_ShapeModel$().CustomShapeProperties__Lamf_core_metamodel_Field()];
    var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$3 = $m_sci_List$();
    return $as_sci_List(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))
  } else {
    return model.fields__sci_List()
  }
});
$c_Lamf_core_rdf_parsers_ObjectParser.prototype.traverse__p1__Lamf_core_model_domain_AmfObject__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_document_SourceMap__T__V = (function(instance, f, properties, sources, key) {
  var property = $as_Lamf_core_rdf_PropertyObject(properties.head__O());
  var rc10 = false;
  var x4 = null;
  var x1 = f.type$1;
  matchEnd11: {
    var x = $m_Lamf_core_metamodel_domain_DataNodeModel$();
    if ((x === x1)) {
      var x1$2 = this.parseDynamicType__Lamf_core_rdf_PropertyObject__s_Option(property);
      if ((x1$2 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1$2);
        var parsed = $as_Lamf_core_model_domain_DataNode(x2.value$2);
        var annotations = $f_Lamf_core_rdf_RdfParserCommon__annots__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, sources, key);
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, parsed, annotations)
      };
      break matchEnd11
    };
    if ($is_Lamf_core_metamodel_Obj(x1)) {
      var x1$3 = this.nodeFinder$1.findLink__Lamf_core_rdf_PropertyObject__s_Option(property);
      if ((x1$3 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$3);
        var node = $as_Lamf_core_rdf_Node(x2$2.value$2);
        var x1$4 = this.parse__Lamf_core_rdf_Node__Z__s_Option(node, false);
        if ((x1$4 instanceof $c_s_Some)) {
          var x2$3 = $as_s_Some(x1$4);
          var parsed$2 = $as_Lamf_core_model_domain_AmfElement(x2$3.value$2);
          var annotations$1 = $f_Lamf_core_rdf_RdfParserCommon__annots__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, sources, key);
          $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, parsed$2, annotations$1)
        }
      } else {
        var this$1 = this.ctx$1.eh$1;
        var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnableToParseRdfDocument$1;
        var node$1 = instance.id__T();
        var message = ((("Error parsing RDF graph node, unknown linked node for property " + key) + " in node ") + instance.id__T());
        var property$1 = $m_s_None$();
        var lexical = $m_s_None$();
        var location = $m_s_None$();
        this$1.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node$1, property$1, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
      };
      break matchEnd11
    };
    if ((x1 instanceof $c_Lamf_core_metamodel_Type$SortedArray)) {
      rc10 = true;
      x4 = $as_Lamf_core_metamodel_Type$SortedArray(x1);
      if ((properties.length__I() === 1)) {
        this.parseList__p1__Lamf_core_model_domain_AmfObject__Lamf_core_metamodel_Type$SortedArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__V(instance, x4, f, properties, $f_Lamf_core_rdf_RdfParserCommon__annots__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, sources, key));
        break matchEnd11
      }
    };
    if (rc10) {
      var this$2 = this.ctx$1.eh$1;
      var specification$1 = $m_Lamf_plugins_features_validation_CoreValidations$().UnableToParseRdfDocument$1;
      var node$2 = instance.id__T();
      var message$1 = ((("Error, more than one sorted array values found in node for property " + key) + " in node ") + instance.id__T());
      var property$2 = $m_s_None$();
      var lexical$1 = $m_s_None$();
      var location$1 = $m_s_None$();
      this$2.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification$1.id$1, node$2, property$2, message$1, lexical$1, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location$1);
      break matchEnd11
    };
    if ((x1 instanceof $c_Lamf_core_metamodel_Type$Array)) {
      var x6 = $as_Lamf_core_metamodel_Type$Array(x1);
      var x1$5 = x6.element$1;
      if ($is_Lamf_core_metamodel_Obj(x1$5)) {
        var jsx$1 = f.value$1.iri__T();
        var this$3 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
        var shouldParseUnit = (jsx$1 === new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "references").iri__T());
        var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, shouldParseUnit$1) {
          return (function(n$2) {
            var n = $as_Lamf_core_rdf_PropertyObject(n$2);
            var x1$1 = $this.nodeFinder$1.findLink__Lamf_core_rdf_PropertyObject__s_Option(n);
            if ((x1$1 instanceof $c_s_Some)) {
              var x2$1 = $as_s_Some(x1$1);
              var o = $as_Lamf_core_rdf_Node(x2$1.value$2);
              var xo = $this.parse__Lamf_core_rdf_Node__Z__s_Option(o, shouldParseUnit$1);
              return xo.toList__sci_List()
            } else {
              var xo$1 = $m_s_None$();
              return xo$1.toList__sci_List()
            }
          })
        })(this, shouldParseUnit));
        var this$7 = $m_sc_Seq$();
        var values = $as_sc_Seq(properties.flatMap__F1__scg_CanBuildFrom__O(jsx$2, this$7.ReusableCBFInstance$2))
      } else {
        var x$6 = $m_Lamf_core_metamodel_Type$Str$();
        if (x$6.equals__O__Z(x1$5)) {
          var jsx$3 = true
        } else {
          var x$8 = $m_Lamf_core_metamodel_Type$Iri$();
          var jsx$3 = x$8.equals__O__Z(x1$5)
        };
        if ((!jsx$3)) {
          throw new $c_s_MatchError().init___O(x1$5)
        };
        var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
          return (function(property$2$2) {
            var property$2$1 = $as_Lamf_core_rdf_PropertyObject(property$2$2);
            return $m_Lamf_core_rdf_converter_StringIriUriRegexParser$().parse__Lamf_core_rdf_PropertyObject__Lamf_core_model_domain_AmfScalar(property$2$1)
          })
        })(this));
        var this$8 = $m_sc_Seq$();
        var values = $as_sc_Seq(properties.map__F1__scg_CanBuildFrom__O(jsx$4, this$8.ReusableCBFInstance$2))
      };
      var annotations$2 = $f_Lamf_core_rdf_RdfParserCommon__annots__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, sources, key);
      $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, values, annotations$2);
      break matchEnd11
    };
    if ((x1 instanceof $c_Lamf_core_metamodel_Type$Scalar)) {
      this.parseScalar__p1__Lamf_core_model_domain_AmfObject__Lamf_core_metamodel_Field__Lamf_core_rdf_PropertyObject__Lamf_core_parser_Annotations__V(instance, f, property, $f_Lamf_core_rdf_RdfParserCommon__annots__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, sources, key));
      break matchEnd11
    };
    var x$10 = $m_Lamf_core_metamodel_Type$Any$();
    if ((x$10 === x1)) {
      this.parseAny__p1__Lamf_core_model_domain_AmfObject__Lamf_core_metamodel_Field__Lamf_core_rdf_PropertyObject__Lamf_core_parser_Annotations__V(instance, f, property, $f_Lamf_core_rdf_RdfParserCommon__annots__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, sources, key));
      break matchEnd11
    };
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_core_rdf_parsers_ObjectParser.prototype.checkLinkables__p1__Lamf_core_model_domain_AmfObject__V = (function(instance) {
  if (($is_Lamf_core_model_domain_DomainElement(instance) && $is_Lamf_core_model_domain_Linkable(instance))) {
    var x2 = $as_Lamf_core_model_domain_DomainElement(instance);
    var jsx$1 = this.ctx$1.referencesMap$2;
    var self = x2.id__T();
    jsx$1.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(self, x2));
    var this$3 = this.ctx$1.unresolvedReferences$2;
    var key = x2.id__T();
    var x1 = this$3.get__O__s_Option(key);
    if ((x1 instanceof $c_s_Some)) {
      var x2$1 = $as_s_Some(x1);
      var v = x2$1.value$2;
      var jsx$2 = v
    } else {
      var x = $m_s_None$();
      if ((!(x === x1))) {
        throw new $c_s_MatchError().init___O(x1)
      };
      var jsx$2 = $m_sci_Nil$()
    };
    $as_sc_IterableLike(jsx$2).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, x2$2) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_model_domain_DomainElement(x0$1$2);
        if ($is_Lamf_core_model_domain_Linkable(x0$1)) {
          var this$4 = $as_Lamf_core_model_domain_Linkable(x0$1);
          return $f_Lamf_core_model_domain_Linkable__withLinkTarget__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(this$4, x2$2)
        } else if ((x0$1 instanceof $c_Lamf_core_model_domain_LinkNode)) {
          var x3 = $as_Lamf_core_model_domain_LinkNode(x0$1);
          return x3.withLinkedDomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_LinkNode(x2$2)
        } else {
          throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Only linkable elements can be linked"))
        }
      })
    })(this, x2)));
    this.ctx$1.unresolvedReferences$2.update__O__O__V(x2.id__T(), $m_sci_Nil$())
  } else if ($is_Lamf_core_model_domain_ExternalSourceElement(instance)) {
    var x3$1 = $as_Lamf_core_model_domain_ExternalSourceElement(instance);
    var jsx$3 = this.ctx$1.unresolvedExtReferencesMap$2;
    var this$5 = $as_Lamf_core_model_StrField(x3$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().ReferenceId$1));
    var this$6 = this$5.option$1;
    var self$1 = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
    jsx$3.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(self$1, x3$1))
  }
});
$c_Lamf_core_rdf_parsers_ObjectParser.prototype.setLinkTarget__p1__Lamf_core_model_domain_DomainElement__T__O = (function(instance, targetId) {
  var x1 = this.ctx$1.referencesMap$2.get__O__s_Option(targetId);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var target = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    var this$1 = $as_Lamf_core_model_domain_Linkable(instance);
    return $f_Lamf_core_model_domain_Linkable__withLinkTarget__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(this$1, target)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$2 = this.ctx$1.unresolvedReferences$2;
      var x1$1 = this$2.get__O__s_Option(targetId);
      if ((x1$1 instanceof $c_s_Some)) {
        var x2$1 = $as_s_Some(x1$1);
        var v = x2$1.value$2;
        var jsx$1 = v
      } else {
        var x$1 = $m_s_None$();
        if ((!(x$1 === x1$1))) {
          throw new $c_s_MatchError().init___O(x1$1)
        };
        var jsx$1 = $m_sci_Nil$()
      };
      var unresolved = $as_sc_Seq(jsx$1);
      var jsx$4 = this.ctx$1.unresolvedReferences$2;
      var jsx$3 = $m_sc_Seq$();
      var array = [instance];
      var jsx$2 = jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
      var this$6 = $m_sc_Seq$();
      var y = unresolved.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$6.ReusableCBFInstance$2);
      return jsx$4.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(targetId, y))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_core_rdf_parsers_ObjectParser.prototype.init___T__Lamf_core_rdf_RecursionControl__Lamf_core_rdf_helper_PluginEntitiesFacade__Lamf_core_rdf_graph_NodeFinder__Lamf_core_rdf_parsers_SourcesRetriever__Lamf_core_rdf_RdfParserContext = (function(rootId, recursionControl, plugins, nodeFinder, sourcesRetriever, ctx) {
  this.rootId$1 = rootId;
  this.recursionControl$1 = recursionControl;
  this.plugins$1 = plugins;
  this.nodeFinder$1 = nodeFinder;
  this.sourcesRetriever$1 = sourcesRetriever;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_core_rdf_parsers_ObjectParser.prototype.ctx__Lamf_core_rdf_RdfParserContext = (function() {
  return this.ctx$1
});
$c_Lamf_core_rdf_parsers_ObjectParser.prototype.parseLinkableProperties__p1__Lamf_core_rdf_Node__Lamf_core_model_domain_DomainElement__V = (function(node, instance) {
  var this$1 = node.getProperties__T__s_Option($m_Lamf_core_metamodel_domain_LinkableElementModel$().TargetId$1.value$1.iri__T());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var entries = $as_sc_Seq(arg1);
    var x1 = entries.headOption__s_Option();
    matchEnd6: {
      var this$2;
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var p3 = $as_Lamf_core_rdf_PropertyObject(x2.value$2);
        if ((p3 instanceof $c_Lamf_core_rdf_Uri)) {
          var x4 = $as_Lamf_core_rdf_Uri(p3);
          var id = x4.value$1;
          var this$2 = new $c_s_Some().init___O(id);
          break matchEnd6
        }
      };
      var this$2 = $m_s_None$()
    }
  };
  if ((!this$2.isEmpty__Z())) {
    var arg1$1 = this$2.get__O();
    var targetId = $as_T(arg1$1);
    this.setLinkTarget__p1__Lamf_core_model_domain_DomainElement__T__O(instance, targetId)
  };
  var this$3 = node.getProperties__T__s_Option($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1.value$1.iri__T());
  if (this$3.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1$2 = this$3.get__O();
    var entries$3 = $as_sc_Seq(arg1$2);
    var x1$1 = entries$3.headOption__s_Option();
    matchEnd7: {
      var this$4;
      if ((x1$1 instanceof $c_s_Some)) {
        var x2$1 = $as_s_Some(x1$1);
        var p3$1 = $as_Lamf_core_rdf_PropertyObject(x2$1.value$2);
        if ((p3$1 instanceof $c_Lamf_core_rdf_Literal)) {
          var x4$1 = $as_Lamf_core_rdf_Literal(p3$1);
          var v = x4$1.value$1;
          var this$4 = new $c_s_Some().init___O(v);
          break matchEnd7
        }
      };
      var this$4 = $m_s_None$()
    }
  };
  if ((!this$4.isEmpty__Z())) {
    var arg1$3 = this$4.get__O();
    var s = $as_T(arg1$3);
    var this$5 = $as_Lamf_core_model_domain_Linkable(instance);
    var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1;
    $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$5, field, s))
  }
});
$c_Lamf_core_rdf_parsers_ObjectParser.prototype.key__Lamf_core_rdf_Node__T__sc_Seq = (function(node, property) {
  var this$1 = node.getProperties__T__s_Option(property);
  return $as_sc_Seq((this$1.isEmpty__Z() ? $m_sci_Nil$() : this$1.get__O()))
});
$c_Lamf_core_rdf_parsers_ObjectParser.prototype.parseDynamicType__Lamf_core_rdf_PropertyObject__s_Option = (function(id) {
  return new $c_Lamf_core_rdf_parsers_DynamicTypeParser().init___Lamf_core_rdf_graph_NodeFinder__Lamf_core_rdf_parsers_SourcesRetriever__Lamf_core_rdf_helper_DefaultNodeClassSorter__Lamf_core_rdf_RdfParserContext(this.nodeFinder$1, this.sourcesRetriever$1, new $c_Lamf_core_rdf_helper_DefaultNodeClassSorter().init___(), this.ctx$1).parse__Lamf_core_rdf_PropertyObject__s_Option(id)
});
$c_Lamf_core_rdf_parsers_ObjectParser.prototype.parseAny__p1__Lamf_core_model_domain_AmfObject__Lamf_core_metamodel_Field__Lamf_core_rdf_PropertyObject__Lamf_core_parser_Annotations__V = (function(instance, field, property, annotations) {
  var this$1 = $m_Lamf_core_rdf_converter_AnyTypeConverter$().tryConvert__Lamf_core_rdf_PropertyObject__Lamf_core_errorhandling_ErrorHandler__s_Option(property, this.ctx$1.eh$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var x$3 = $as_Lamf_core_model_domain_AmfScalar(arg1);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, field, x$3, annotations)
  }
});
var $d_Lamf_core_rdf_parsers_ObjectParser = new $TypeData().initClass({
  Lamf_core_rdf_parsers_ObjectParser: 0
}, false, "amf.core.rdf.parsers.ObjectParser", {
  Lamf_core_rdf_parsers_ObjectParser: 1,
  O: 1,
  Lamf_core_rdf_RdfParserCommon: 1
});
$c_Lamf_core_rdf_parsers_ObjectParser.prototype.$classData = $d_Lamf_core_rdf_parsers_ObjectParser;
/** @constructor */
function $c_Lamf_core_remote_Amf$() {
  $c_O.call(this);
  this.name$1 = null
}
$c_Lamf_core_remote_Amf$.prototype = new $h_O();
$c_Lamf_core_remote_Amf$.prototype.constructor = $c_Lamf_core_remote_Amf$;
/** @constructor */
function $h_Lamf_core_remote_Amf$() {
  /*<skip>*/
}
$h_Lamf_core_remote_Amf$.prototype = $c_Lamf_core_remote_Amf$.prototype;
$c_Lamf_core_remote_Amf$.prototype.init___ = (function() {
  this.name$1 = "AMF Graph";
  return this
});
$c_Lamf_core_remote_Amf$.prototype.name__T = (function() {
  return this.name$1
});
var $d_Lamf_core_remote_Amf$ = new $TypeData().initClass({
  Lamf_core_remote_Amf$: 0
}, false, "amf.core.remote.Amf$", {
  Lamf_core_remote_Amf$: 1,
  O: 1,
  Lamf_core_remote_Vendor: 1
});
$c_Lamf_core_remote_Amf$.prototype.$classData = $d_Lamf_core_remote_Amf$;
var $n_Lamf_core_remote_Amf$ = (void 0);
function $m_Lamf_core_remote_Amf$() {
  if ((!$n_Lamf_core_remote_Amf$)) {
    $n_Lamf_core_remote_Amf$ = new $c_Lamf_core_remote_Amf$().init___()
  };
  return $n_Lamf_core_remote_Amf$
}
/** @constructor */
function $c_Lamf_core_remote_Aml$() {
  $c_O.call(this);
  this.name$1 = null
}
$c_Lamf_core_remote_Aml$.prototype = new $h_O();
$c_Lamf_core_remote_Aml$.prototype.constructor = $c_Lamf_core_remote_Aml$;
/** @constructor */
function $h_Lamf_core_remote_Aml$() {
  /*<skip>*/
}
$h_Lamf_core_remote_Aml$.prototype = $c_Lamf_core_remote_Aml$.prototype;
$c_Lamf_core_remote_Aml$.prototype.init___ = (function() {
  this.name$1 = "AML 1.0";
  return this
});
$c_Lamf_core_remote_Aml$.prototype.toString__T = (function() {
  var thiz = this.name$1;
  return $as_T(thiz.trim())
});
$c_Lamf_core_remote_Aml$.prototype.name__T = (function() {
  return this.name$1
});
var $d_Lamf_core_remote_Aml$ = new $TypeData().initClass({
  Lamf_core_remote_Aml$: 0
}, false, "amf.core.remote.Aml$", {
  Lamf_core_remote_Aml$: 1,
  O: 1,
  Lamf_core_remote_Vendor: 1
});
$c_Lamf_core_remote_Aml$.prototype.$classData = $d_Lamf_core_remote_Aml$;
var $n_Lamf_core_remote_Aml$ = (void 0);
function $m_Lamf_core_remote_Aml$() {
  if ((!$n_Lamf_core_remote_Aml$)) {
    $n_Lamf_core_remote_Aml$ = new $c_Lamf_core_remote_Aml$().init___()
  };
  return $n_Lamf_core_remote_Aml$
}
/** @constructor */
function $c_Lamf_core_remote_FileMediaType$() {
  $c_O.call(this)
}
$c_Lamf_core_remote_FileMediaType$.prototype = new $h_O();
$c_Lamf_core_remote_FileMediaType$.prototype.constructor = $c_Lamf_core_remote_FileMediaType$;
/** @constructor */
function $h_Lamf_core_remote_FileMediaType$() {
  /*<skip>*/
}
$h_Lamf_core_remote_FileMediaType$.prototype = $c_Lamf_core_remote_FileMediaType$.prototype;
$c_Lamf_core_remote_FileMediaType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_core_remote_FileMediaType$ = new $TypeData().initClass({
  Lamf_core_remote_FileMediaType$: 0
}, false, "amf.core.remote.FileMediaType$", {
  Lamf_core_remote_FileMediaType$: 1,
  O: 1,
  Lamf_core_remote_FileMediaType: 1
});
$c_Lamf_core_remote_FileMediaType$.prototype.$classData = $d_Lamf_core_remote_FileMediaType$;
var $n_Lamf_core_remote_FileMediaType$ = (void 0);
function $m_Lamf_core_remote_FileMediaType$() {
  if ((!$n_Lamf_core_remote_FileMediaType$)) {
    $n_Lamf_core_remote_FileMediaType$ = new $c_Lamf_core_remote_FileMediaType$().init___()
  };
  return $n_Lamf_core_remote_FileMediaType$
}
function $f_Lamf_core_remote_JsPlatform__normalizeURL__T__T($thiz, url) {
  return $as_T($i_path.normalize(url))
}
function $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T($thiz, url) {
  return $as_T($g.encodeURIComponent(url))
}
function $f_Lamf_core_remote_JsPlatform__decodeURIComponent__T__T($thiz, url) {
  return $as_T($g.decodeURIComponent(url))
}
function $f_Lamf_core_remote_JsPlatform__encodeURI__T__T($thiz, url) {
  return $as_T($g.encodeURI(url))
}
function $f_Lamf_core_remote_JsPlatform__decodeURI__T__T($thiz, url) {
  return $as_T($g.decodeURI(url))
}
function $f_Lamf_core_remote_JsPlatform__normalizePath__T__T($thiz, url) {
  var res = new $c_Ljava_net_URI().init___T($f_Lamf_core_remote_JsPlatform__encodeURI__T__T($thiz, url)).normalize__Ljava_net_URI().origStr$1;
  return $f_Lamf_core_remote_Platform__fixFilePrefix__T__T($thiz, res)
}
/** @constructor */
function $c_Lamf_core_remote_JsonSchema$() {
  $c_O.call(this);
  this.name$1 = null
}
$c_Lamf_core_remote_JsonSchema$.prototype = new $h_O();
$c_Lamf_core_remote_JsonSchema$.prototype.constructor = $c_Lamf_core_remote_JsonSchema$;
/** @constructor */
function $h_Lamf_core_remote_JsonSchema$() {
  /*<skip>*/
}
$h_Lamf_core_remote_JsonSchema$.prototype = $c_Lamf_core_remote_JsonSchema$.prototype;
$c_Lamf_core_remote_JsonSchema$.prototype.init___ = (function() {
  this.name$1 = "JSON Schema";
  return this
});
$c_Lamf_core_remote_JsonSchema$.prototype.toString__T = (function() {
  var thiz = this.name$1;
  return $as_T(thiz.trim())
});
$c_Lamf_core_remote_JsonSchema$.prototype.name__T = (function() {
  return this.name$1
});
var $d_Lamf_core_remote_JsonSchema$ = new $TypeData().initClass({
  Lamf_core_remote_JsonSchema$: 0
}, false, "amf.core.remote.JsonSchema$", {
  Lamf_core_remote_JsonSchema$: 1,
  O: 1,
  Lamf_core_remote_Vendor: 1
});
$c_Lamf_core_remote_JsonSchema$.prototype.$classData = $d_Lamf_core_remote_JsonSchema$;
var $n_Lamf_core_remote_JsonSchema$ = (void 0);
function $m_Lamf_core_remote_JsonSchema$() {
  if ((!$n_Lamf_core_remote_JsonSchema$)) {
    $n_Lamf_core_remote_JsonSchema$ = new $c_Lamf_core_remote_JsonSchema$().init___()
  };
  return $n_Lamf_core_remote_JsonSchema$
}
/** @constructor */
function $c_Lamf_core_remote_Payload$() {
  $c_O.call(this);
  this.name$1 = null
}
$c_Lamf_core_remote_Payload$.prototype = new $h_O();
$c_Lamf_core_remote_Payload$.prototype.constructor = $c_Lamf_core_remote_Payload$;
/** @constructor */
function $h_Lamf_core_remote_Payload$() {
  /*<skip>*/
}
$h_Lamf_core_remote_Payload$.prototype = $c_Lamf_core_remote_Payload$.prototype;
$c_Lamf_core_remote_Payload$.prototype.init___ = (function() {
  this.name$1 = "AMF Payload";
  return this
});
$c_Lamf_core_remote_Payload$.prototype.name__T = (function() {
  return this.name$1
});
var $d_Lamf_core_remote_Payload$ = new $TypeData().initClass({
  Lamf_core_remote_Payload$: 0
}, false, "amf.core.remote.Payload$", {
  Lamf_core_remote_Payload$: 1,
  O: 1,
  Lamf_core_remote_Vendor: 1
});
$c_Lamf_core_remote_Payload$.prototype.$classData = $d_Lamf_core_remote_Payload$;
var $n_Lamf_core_remote_Payload$ = (void 0);
function $m_Lamf_core_remote_Payload$() {
  if ((!$n_Lamf_core_remote_Payload$)) {
    $n_Lamf_core_remote_Payload$ = new $c_Lamf_core_remote_Payload$().init___()
  };
  return $n_Lamf_core_remote_Payload$
}
/** @constructor */
function $c_Lamf_core_remote_UnknowVendor() {
  $c_O.call(this);
  this.name$1 = null
}
$c_Lamf_core_remote_UnknowVendor.prototype = new $h_O();
$c_Lamf_core_remote_UnknowVendor.prototype.constructor = $c_Lamf_core_remote_UnknowVendor;
/** @constructor */
function $h_Lamf_core_remote_UnknowVendor() {
  /*<skip>*/
}
$h_Lamf_core_remote_UnknowVendor.prototype = $c_Lamf_core_remote_UnknowVendor.prototype;
$c_Lamf_core_remote_UnknowVendor.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_remote_UnknowVendor.prototype.init___T = (function(name) {
  this.name$1 = name;
  return this
});
var $d_Lamf_core_remote_UnknowVendor = new $TypeData().initClass({
  Lamf_core_remote_UnknowVendor: 0
}, false, "amf.core.remote.UnknowVendor", {
  Lamf_core_remote_UnknowVendor: 1,
  O: 1,
  Lamf_core_remote_Vendor: 1
});
$c_Lamf_core_remote_UnknowVendor.prototype.$classData = $d_Lamf_core_remote_UnknowVendor;
/** @constructor */
function $c_Lamf_core_remote_UnsupportedFileSystem$() {
  $c_O.call(this)
}
$c_Lamf_core_remote_UnsupportedFileSystem$.prototype = new $h_O();
$c_Lamf_core_remote_UnsupportedFileSystem$.prototype.constructor = $c_Lamf_core_remote_UnsupportedFileSystem$;
/** @constructor */
function $h_Lamf_core_remote_UnsupportedFileSystem$() {
  /*<skip>*/
}
$h_Lamf_core_remote_UnsupportedFileSystem$.prototype = $c_Lamf_core_remote_UnsupportedFileSystem$.prototype;
$c_Lamf_core_remote_UnsupportedFileSystem$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_remote_UnsupportedFileSystem$.prototype.unsupported__p1__sr_Nothing$ = (function() {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Unsupported operation"))
});
$c_Lamf_core_remote_UnsupportedFileSystem$.prototype.asyncFile__T__Lorg_mulesoft_common_io_AsyncFile = (function(path) {
  this.unsupported__p1__sr_Nothing$()
});
$c_Lamf_core_remote_UnsupportedFileSystem$.prototype.separatorChar__C = (function() {
  this.unsupported__p1__sr_Nothing$()
});
var $d_Lamf_core_remote_UnsupportedFileSystem$ = new $TypeData().initClass({
  Lamf_core_remote_UnsupportedFileSystem$: 0
}, false, "amf.core.remote.UnsupportedFileSystem$", {
  Lamf_core_remote_UnsupportedFileSystem$: 1,
  O: 1,
  Lorg_mulesoft_common_io_FileSystem: 1
});
$c_Lamf_core_remote_UnsupportedFileSystem$.prototype.$classData = $d_Lamf_core_remote_UnsupportedFileSystem$;
var $n_Lamf_core_remote_UnsupportedFileSystem$ = (void 0);
function $m_Lamf_core_remote_UnsupportedFileSystem$() {
  if ((!$n_Lamf_core_remote_UnsupportedFileSystem$)) {
    $n_Lamf_core_remote_UnsupportedFileSystem$ = new $c_Lamf_core_remote_UnsupportedFileSystem$().init___()
  };
  return $n_Lamf_core_remote_UnsupportedFileSystem$
}
/** @constructor */
function $c_Lamf_core_resolution_pipelines_BasicResolutionPipeline() {
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.call(this);
  this.references$2 = null;
  this.steps$2 = null
}
$c_Lamf_core_resolution_pipelines_BasicResolutionPipeline.prototype = new $h_Lamf_core_resolution_pipelines_ResolutionPipeline();
$c_Lamf_core_resolution_pipelines_BasicResolutionPipeline.prototype.constructor = $c_Lamf_core_resolution_pipelines_BasicResolutionPipeline;
/** @constructor */
function $h_Lamf_core_resolution_pipelines_BasicResolutionPipeline() {
  /*<skip>*/
}
$h_Lamf_core_resolution_pipelines_BasicResolutionPipeline.prototype = $c_Lamf_core_resolution_pipelines_BasicResolutionPipeline.prototype;
$c_Lamf_core_resolution_pipelines_BasicResolutionPipeline.prototype.steps__sc_Seq = (function() {
  return this.steps$2
});
$c_Lamf_core_resolution_pipelines_BasicResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(eh) {
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, eh);
  this.references$2 = new $c_Lamf_core_resolution_stages_ReferenceResolutionStage().init___Z__Lamf_core_errorhandling_ErrorHandler(false, this.errorHandler$1);
  var jsx$1 = $m_sc_Seq$();
  var array = [this.references$2];
  this.steps$2 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
var $d_Lamf_core_resolution_pipelines_BasicResolutionPipeline = new $TypeData().initClass({
  Lamf_core_resolution_pipelines_BasicResolutionPipeline: 0
}, false, "amf.core.resolution.pipelines.BasicResolutionPipeline", {
  Lamf_core_resolution_pipelines_BasicResolutionPipeline: 1,
  Lamf_core_resolution_pipelines_ResolutionPipeline: 1,
  O: 1
});
$c_Lamf_core_resolution_pipelines_BasicResolutionPipeline.prototype.$classData = $d_Lamf_core_resolution_pipelines_BasicResolutionPipeline;
/** @constructor */
function $c_Lamf_core_resolution_stages_CleanReferencesStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_core_resolution_stages_CleanReferencesStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_core_resolution_stages_CleanReferencesStage.prototype.constructor = $c_Lamf_core_resolution_stages_CleanReferencesStage;
/** @constructor */
function $h_Lamf_core_resolution_stages_CleanReferencesStage() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_CleanReferencesStage.prototype = $c_Lamf_core_resolution_stages_CleanReferencesStage.prototype;
$c_Lamf_core_resolution_stages_CleanReferencesStage.prototype.persistReferenceShapes__p2__Lamf_core_model_document_BaseUnit__V = (function(model) {
  var jsx$2 = model.references__sc_Seq();
  var jsx$1 = new $c_Lamf_core_resolution_stages_CleanReferencesStage$$anonfun$1().init___Lamf_core_resolution_stages_CleanReferencesStage(this);
  var this$1 = $m_sc_Seq$();
  var referenceShapes = $as_sc_Seq($as_scg_GenericTraversableTemplate(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).flatten__F1__sc_GenTraversable($m_s_Predef$().singleton$und$less$colon$less$2));
  model.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_References().init___sc_Seq(referenceShapes))
});
$c_Lamf_core_resolution_stages_CleanReferencesStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  this.persistReferenceShapes__p2__Lamf_core_model_document_BaseUnit__V(model);
  model.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_core_metamodel_document_BaseUnitModel$().References$1);
  return model
});
$c_Lamf_core_resolution_stages_CleanReferencesStage.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_core_resolution_stages_CleanReferencesStage = new $TypeData().initClass({
  Lamf_core_resolution_stages_CleanReferencesStage: 0
}, false, "amf.core.resolution.stages.CleanReferencesStage", {
  Lamf_core_resolution_stages_CleanReferencesStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_core_resolution_stages_CleanReferencesStage.prototype.$classData = $d_Lamf_core_resolution_stages_CleanReferencesStage;
/** @constructor */
function $c_Lamf_core_resolution_stages_DeclarationsRemovalStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_core_resolution_stages_DeclarationsRemovalStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_core_resolution_stages_DeclarationsRemovalStage.prototype.constructor = $c_Lamf_core_resolution_stages_DeclarationsRemovalStage;
/** @constructor */
function $h_Lamf_core_resolution_stages_DeclarationsRemovalStage() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_DeclarationsRemovalStage.prototype = $c_Lamf_core_resolution_stages_DeclarationsRemovalStage.prototype;
$c_Lamf_core_resolution_stages_DeclarationsRemovalStage.prototype.persistDeclaredShapes__p2__Lamf_core_model_document_DeclaresModel__V = (function(doc) {
  var jsx$2 = doc.declares__sc_Seq();
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_model_domain_DomainElement(x$2$2);
      return x$2.id__T()
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var declaredShapes = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  doc.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_Declares().init___sc_Seq(declaredShapes))
});
$c_Lamf_core_resolution_stages_DeclarationsRemovalStage.prototype.removeAllDeclarationsButSecuritySchemes__p2__Lamf_core_model_document_DeclaresModel__O = (function(doc) {
  var schemes = $as_sc_Seq(doc.declares__sc_Seq().filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_domain_DomainElement(x$1$2);
      return ($as_Lamf_core_vocabulary_ValueType(x$1.meta__Lamf_core_metamodel_Obj().type__sci_List().head__O()).iri__T() === "http://a.ml/vocabularies/security#SecurityScheme")
    })
  })(this))));
  this.persistDeclaredShapes__p2__Lamf_core_model_document_DeclaresModel__V(doc);
  if (schemes.isEmpty__Z()) {
    return doc.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_core_metamodel_document_DocumentModel$().Declares$1)
  } else {
    var x1 = doc.fields__Lamf_core_parser_Fields().$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_document_DocumentModel$().Declares$1);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var array = $as_Lamf_core_model_domain_AmfArray(x2.value$2);
      array.values$1 = schemes
    };
    return (void 0)
  }
});
$c_Lamf_core_resolution_stages_DeclarationsRemovalStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  if (($is_Lamf_core_model_document_DeclaresModel(model) && $is_Lamf_core_model_document_EncodesModel(model))) {
    this.removeAllDeclarationsButSecuritySchemes__p2__Lamf_core_model_document_DeclaresModel__O($as_Lamf_core_model_document_DeclaresModel(model))
  };
  return model
});
$c_Lamf_core_resolution_stages_DeclarationsRemovalStage.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_core_resolution_stages_DeclarationsRemovalStage = new $TypeData().initClass({
  Lamf_core_resolution_stages_DeclarationsRemovalStage: 0
}, false, "amf.core.resolution.stages.DeclarationsRemovalStage", {
  Lamf_core_resolution_stages_DeclarationsRemovalStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_core_resolution_stages_DeclarationsRemovalStage.prototype.$classData = $d_Lamf_core_resolution_stages_DeclarationsRemovalStage;
/** @constructor */
function $c_Lamf_core_resolution_stages_ExternalSourceRemovalStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this);
  this.visited$2 = null
}
$c_Lamf_core_resolution_stages_ExternalSourceRemovalStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_core_resolution_stages_ExternalSourceRemovalStage.prototype.constructor = $c_Lamf_core_resolution_stages_ExternalSourceRemovalStage;
/** @constructor */
function $h_Lamf_core_resolution_stages_ExternalSourceRemovalStage() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_ExternalSourceRemovalStage.prototype = $c_Lamf_core_resolution_stages_ExternalSourceRemovalStage.prototype;
$c_Lamf_core_resolution_stages_ExternalSourceRemovalStage.prototype.init___scm_Set__Lamf_core_errorhandling_ErrorHandler = (function(visited, errorHandler) {
  this.visited$2 = visited;
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
$c_Lamf_core_resolution_stages_ExternalSourceRemovalStage.prototype.transformation__p2__Lamf_core_model_domain_DomainElement__Z__s_Option = (function(element, cycle) {
  if ($is_Lamf_core_model_domain_ExternalSourceElement(element)) {
    var x2 = $as_Lamf_core_model_domain_ExternalSourceElement(element);
    x2.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().ReferenceId$1);
    return new $c_s_Some().init___O(x2)
  } else {
    return new $c_s_Some().init___O(element)
  }
});
$c_Lamf_core_resolution_stages_ExternalSourceRemovalStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  var knownIdSelector = new $c_Lamf_core_resolution_stages_selectors_KnownElementIdSelector().init___scm_Set(this.visited$2);
  var another = $m_Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$();
  return model.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(new $c_Lamf_core_resolution_stages_selectors_OrSelector().init___Lamf_core_resolution_stages_selectors_Selector__Lamf_core_resolution_stages_selectors_Selector(knownIdSelector, another), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(element$2, cycle$2) {
      var element = $as_Lamf_core_model_domain_DomainElement(element$2);
      var cycle = $uZ(cycle$2);
      return $this.transformation__p2__Lamf_core_model_domain_DomainElement__Z__s_Option(element, cycle)
    })
  })(this)), this.errorHandler$1)
});
var $d_Lamf_core_resolution_stages_ExternalSourceRemovalStage = new $TypeData().initClass({
  Lamf_core_resolution_stages_ExternalSourceRemovalStage: 0
}, false, "amf.core.resolution.stages.ExternalSourceRemovalStage", {
  Lamf_core_resolution_stages_ExternalSourceRemovalStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_core_resolution_stages_ExternalSourceRemovalStage.prototype.$classData = $d_Lamf_core_resolution_stages_ExternalSourceRemovalStage;
/** @constructor */
function $c_Lamf_core_resolution_stages_LinkNodeResolutionStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this);
  this.keepEditingInfo$2 = false;
  this.visited$2 = null;
  this.modelResolver$2 = null
}
$c_Lamf_core_resolution_stages_LinkNodeResolutionStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_core_resolution_stages_LinkNodeResolutionStage.prototype.constructor = $c_Lamf_core_resolution_stages_LinkNodeResolutionStage;
/** @constructor */
function $h_Lamf_core_resolution_stages_LinkNodeResolutionStage() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_LinkNodeResolutionStage.prototype = $c_Lamf_core_resolution_stages_LinkNodeResolutionStage.prototype;
$c_Lamf_core_resolution_stages_LinkNodeResolutionStage.prototype.init___Z__scm_Set__Lamf_core_errorhandling_ErrorHandler = (function(keepEditingInfo, visited, errorHandler) {
  this.keepEditingInfo$2 = keepEditingInfo;
  this.visited$2 = visited;
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  this.modelResolver$2 = $m_s_None$();
  return this
});
$c_Lamf_core_resolution_stages_LinkNodeResolutionStage.prototype.transformation__p2__Lamf_core_model_domain_DomainElement__Z__s_Option = (function(element, cycle) {
  if ((element instanceof $c_Lamf_core_model_domain_LinkNode)) {
    var x2 = $as_Lamf_core_model_domain_LinkNode(element);
    return $m_Lamf_core_resolution_stages_helpers_LinkNodeResolver$().resolveDynamicLink__Lamf_core_model_domain_LinkNode__s_Option__Z__s_Option(x2, this.modelResolver$2, this.keepEditingInfo$2)
  } else {
    return new $c_s_Some().init___O(element)
  }
});
$c_Lamf_core_resolution_stages_LinkNodeResolutionStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  this.modelResolver$2 = new $c_s_Some().init___O(new $c_Lamf_core_resolution_stages_helpers_ModelReferenceResolver().init___Lamf_core_model_document_BaseUnit(model));
  var knownIdSelector = new $c_Lamf_core_resolution_stages_selectors_KnownElementIdSelector().init___scm_Set(this.visited$2);
  var another = $m_Lamf_core_resolution_stages_selectors_LinkSelector$();
  var this$1 = new $c_Lamf_core_resolution_stages_selectors_OrSelector().init___Lamf_core_resolution_stages_selectors_Selector__Lamf_core_resolution_stages_selectors_Selector(knownIdSelector, another);
  var another$1 = $m_Lamf_core_resolution_stages_selectors_LinkNodeSelector$();
  return model.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(new $c_Lamf_core_resolution_stages_selectors_OrSelector().init___Lamf_core_resolution_stages_selectors_Selector__Lamf_core_resolution_stages_selectors_Selector(this$1, another$1), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(element$2, cycle$2) {
      var element = $as_Lamf_core_model_domain_DomainElement(element$2);
      var cycle = $uZ(cycle$2);
      return $this.transformation__p2__Lamf_core_model_domain_DomainElement__Z__s_Option(element, cycle)
    })
  })(this)), this.errorHandler$1)
});
var $d_Lamf_core_resolution_stages_LinkNodeResolutionStage = new $TypeData().initClass({
  Lamf_core_resolution_stages_LinkNodeResolutionStage: 0
}, false, "amf.core.resolution.stages.LinkNodeResolutionStage", {
  Lamf_core_resolution_stages_LinkNodeResolutionStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_core_resolution_stages_LinkNodeResolutionStage.prototype.$classData = $d_Lamf_core_resolution_stages_LinkNodeResolutionStage;
/** @constructor */
function $c_Lamf_core_resolution_stages_UrlShortenerStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this);
  this.Shortener$module$2 = null;
  this.shortener$2 = null;
  this.amf$core$resolution$stages$UrlShortenerStage$$base$2 = null
}
$c_Lamf_core_resolution_stages_UrlShortenerStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_core_resolution_stages_UrlShortenerStage.prototype.constructor = $c_Lamf_core_resolution_stages_UrlShortenerStage;
/** @constructor */
function $h_Lamf_core_resolution_stages_UrlShortenerStage() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_UrlShortenerStage.prototype = $c_Lamf_core_resolution_stages_UrlShortenerStage.prototype;
$c_Lamf_core_resolution_stages_UrlShortenerStage.prototype.Shortener__p2__Lamf_core_resolution_stages_UrlShortenerStage$Shortener$ = (function() {
  if ((this.Shortener$module$2 === null)) {
    this.Shortener$lzycompute$1__p2__V()
  };
  return this.Shortener$module$2
});
$c_Lamf_core_resolution_stages_UrlShortenerStage.prototype.Shortener$lzycompute$1__p2__V = (function() {
  if ((this.Shortener$module$2 === null)) {
    this.Shortener$module$2 = new $c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener$().init___Lamf_core_resolution_stages_UrlShortenerStage(this)
  }
});
$c_Lamf_core_resolution_stages_UrlShortenerStage.prototype.shorten__Lamf_core_model_domain_AmfElement__sci_Set__V = (function(element, ids) {
  if ($is_Lamf_core_model_domain_AmfObject(element)) {
    var x2 = $as_Lamf_core_model_domain_AmfObject(element);
    var shorthenId = this.shortener$2.shorten__T__T(x2.id__T());
    var that = x2.id__T();
    if ((!(shorthenId === that))) {
      x2.withId__T__Lamf_core_model_domain_AmfObject(this.shortener$2.shorten__T__T(x2.id__T()));
      var this$1 = x2.fields__Lamf_core_parser_Fields();
      var this$4 = this$1.fs$1;
      var this$2 = $m_Lamf_core_parser_FieldEntry$();
      var f = $f_F2__tupled__F1(this$2);
      var this$3 = $m_sci_Iterable$();
      var bf = this$3.ReusableCBFInstance$2;
      $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$4, f, bf)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ids$1) {
        return (function(x0$1$2) {
          var x0$1 = $as_Lamf_core_parser_FieldEntry(x0$1$2);
          if ((x0$1 !== null)) {
            var f$1 = x0$1.field$1;
            var value = x0$1.value$1;
            if ((value !== null)) {
              var x$2 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().Target$1;
              if (((f$1 === null) ? (x$2 === null) : f$1.equals__O__Z(x$2))) {
                var x1$2 = value.value$1;
                if ($is_Lamf_core_model_domain_AmfObject(x1$2)) {
                  var x2$2 = $as_Lamf_core_model_domain_AmfObject(x1$2);
                  return x2$2.withId__T__Lamf_core_model_domain_AmfObject($this.shortener$2.shorten__T__T(x2$2.id__T()))
                } else {
                  return (void 0)
                }
              }
            }
          };
          if ((x0$1 !== null)) {
            var f$2 = x0$1.field$1;
            var value$2 = x0$1.value$1;
            if ((value$2 !== null)) {
              var x$3 = f$2.type$1;
              var x$4 = $m_Lamf_core_metamodel_Type$Iri$();
              if (((x$3 !== null) && x$3.equals__O__Z(x$4))) {
                $this.shorten__Lamf_core_parser_Annotations__V(value$2.annotations$1);
                var v = value$2.value$1.toString__T();
                if (ids$1.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, v$1) {
                  return (function(i$2) {
                    var i = $as_T(i$2);
                    return (($uI(v$1.length) >= 0) && ($as_T(v$1.substring(0, $uI(i.length))) === i))
                  })
                })($this, v)))) {
                  value$2.value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($this.shortener$2.shorten__T__T(v), value$2.value$1.annotations__Lamf_core_parser_Annotations());
                  return (void 0)
                } else {
                  return (void 0)
                }
              }
            }
          };
          if ((x0$1 !== null)) {
            var value$3 = x0$1.value$1;
            if ((value$3 !== null)) {
              $this.shorten__Lamf_core_model_domain_AmfElement__sci_Set__V(value$3.value$1, ids$1);
              $this.shorten__Lamf_core_parser_Annotations__V(value$3.annotations$1);
              return (void 0)
            }
          };
          throw new $c_s_MatchError().init___O(x0$1)
        })
      })(this, ids)))
    }
  } else if ((element instanceof $c_Lamf_core_model_domain_AmfArray)) {
    var x3 = $as_Lamf_core_model_domain_AmfArray(element);
    x3.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, ids$2) {
      return (function(v$2) {
        var v$3 = $as_Lamf_core_model_domain_AmfElement(v$2);
        this$2$1.shorten__Lamf_core_model_domain_AmfElement__sci_Set__V(v$3, ids$2)
      })
    })(this, ids)))
  };
  this.shorten__Lamf_core_parser_Annotations__V(element.annotations__Lamf_core_parser_Annotations())
});
$c_Lamf_core_resolution_stages_UrlShortenerStage.prototype.shorten__Lamf_core_parser_Annotations__V = (function(annotations) {
  var this$2 = annotations.amf$core$parser$Annotations$$annotations$1;
  var this$1 = $m_scm_ListBuffer$();
  var bf = this$1.ReusableCBFInstance$2;
  var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$2, bf);
  var this$3 = this$2.scala$collection$mutable$ListBuffer$$start$6;
  var these = this$3;
  while ((!these.isEmpty__Z())) {
    var arg1 = these.head__O();
    var x0$1 = $as_Lamf_core_model_domain_Annotation(arg1);
    b.$$plus$eq__O__scm_Builder(($is_Lamf_core_model_domain_UriAnnotation(x0$1) ? $as_Lamf_core_model_domain_UriAnnotation(x0$1).shorten__F1__Lamf_core_model_domain_Annotation(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(uri$2) {
        var uri = $as_T(uri$2);
        return $this.shortener$2.shorten__T__T(uri)
      })
    })(this))) : x0$1));
    these = $as_sci_List(these.tail__O())
  };
  annotations.amf$core$parser$Annotations$$annotations$1 = $as_scm_ListBuffer(b.result__O())
});
$c_Lamf_core_resolution_stages_UrlShortenerStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  var array = [model.id__T()];
  if (($uI(array.length) === 0)) {
    var jsx$4 = $m_sci_Set$EmptySet$()
  } else {
    var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      b.$$plus$eq__O__scm_SetBuilder(arg1);
      i = ((1 + i) | 0)
    };
    var jsx$4 = b.elems$1
  };
  var jsx$3 = $as_sc_SetLike(jsx$4);
  var jsx$2 = model.references__sc_Seq();
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_document_BaseUnit(x$1$2);
      return x$1.id__T()
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  var ids = $as_sci_Set(jsx$3.$$plus$plus__sc_GenTraversableOnce__sc_Set($as_sc_GenTraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2))));
  this.shorten__Lamf_core_model_domain_AmfElement__sci_Set__V(model, ids);
  var value = this.amf$core$resolution$stages$UrlShortenerStage$$base$2;
  return $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(model, value))
});
$c_Lamf_core_resolution_stages_UrlShortenerStage.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  this.shortener$2 = new $c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener().init___Lamf_core_resolution_stages_UrlShortenerStage__scm_Map(this, (this.Shortener__p2__Lamf_core_resolution_stages_UrlShortenerStage$Shortener$(), $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()))));
  this.amf$core$resolution$stages$UrlShortenerStage$$base$2 = "amf://id";
  return this
});
var $d_Lamf_core_resolution_stages_UrlShortenerStage = new $TypeData().initClass({
  Lamf_core_resolution_stages_UrlShortenerStage: 0
}, false, "amf.core.resolution.stages.UrlShortenerStage", {
  Lamf_core_resolution_stages_UrlShortenerStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_core_resolution_stages_UrlShortenerStage.prototype.$classData = $d_Lamf_core_resolution_stages_UrlShortenerStage;
/** @constructor */
function $c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution() {
  $c_Lamf_core_resolution_stages_elements_resolution_ElementStageTransformer.call(this);
  this.errorHandler$2 = null;
  this.keepEditingInfo$2 = false;
  this.modelResolver$2 = null;
  this.cache$2 = null;
  this.customDomainElementTransformation$2 = null
}
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype = new $h_Lamf_core_resolution_stages_elements_resolution_ElementStageTransformer();
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.constructor = $c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution;
/** @constructor */
function $h_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype = $c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype;
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.innerName__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_NamedDomainElement__V = (function(source, resolved) {
  if ($is_Lamf_core_model_domain_NamedDomainElement(source)) {
    var x2 = $as_Lamf_core_model_domain_Linkable(source);
    var rc12 = false;
    var x2$2 = null;
    var this$1 = $as_Lamf_core_model_domain_NamedDomainElement(x2);
    var x1$2 = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(this$1.nameField__Lamf_core_metamodel_Field())).option$1;
    matchEnd13: {
      if ((x1$2 instanceof $c_s_Some)) {
        rc12 = true;
        x2$2 = $as_s_Some(x1$2);
        var elem = $as_Lamf_core_model_domain_DomainElement(x2);
        if (elem.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_AutoGeneratedName.getClassOf())) {
          this.inner__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_NamedDomainElement__V(source, resolved);
          break matchEnd13
        }
      };
      matchEnd17: {
        var jsx$2;
        if ((x1$2 instanceof $c_s_Some)) {
          var x4 = $as_s_Some(x1$2);
          var p5 = $as_T(x4.value$2);
          if (((p5 === "schema") || ((p5 === "type") || (p5 === "body")))) {
            var jsx$2 = true;
            break matchEnd17
          }
        };
        var x = $m_s_None$();
        if ((x === x1$2)) {
          var jsx$2 = true;
          break matchEnd17
        };
        var jsx$2 = false
      };
      if (jsx$2) {
        var this$2 = $as_Lamf_core_model_domain_Linkable(source);
        var jsx$1 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2).isDefined__Z()
      } else {
        var jsx$1 = false
      };
      if (jsx$1) {
        this.inner__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_NamedDomainElement__V(source, resolved);
        break matchEnd13
      };
      if (rc12) {
        var other = $as_T(x2$2.value$2);
        var a = $as_Lamf_core_model_StrField(resolved.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(resolved.nameField__Lamf_core_metamodel_Field())).annotations$1;
        $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(resolved, other, a);
        break matchEnd13
      }
    }
  }
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.traverseNestedLinksIfCopy__p2__Lamf_core_model_domain_DomainElement__sc_Seq__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement = (function(element, conditions, l, resolved) {
  var x1 = $as_Lamf_core_model_domain_Linkable(l).effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement($as_Lamf_core_model_domain_Linkable(l).effectiveLinkTarget$default$1__sc_Seq());
  if ($is_Lamf_core_model_domain_Linkable(x1)) {
    if (this.shouldCopyElement__p2__sc_Seq__Lamf_core_model_domain_Linkable__Lamf_core_model_domain_DomainElement__Z(conditions, $as_Lamf_core_model_domain_Linkable(l), x1)) {
      this.cache$2.put__O__O__s_Option(element.id__T(), resolved);
      return this.resolveNestedLinks__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(resolved)
    }
  };
  return resolved
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.propagateAnnotations__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__V = (function(link, element) {
  var this$1 = link.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_TrackedElement.getClassOf());
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var x0$1 = $as_Lamf_core_annotations_TrackedElement(arg1);
    if ((x0$1 !== null)) {
      var values = x0$1.parents$1;
      this.addLinkTrackedElementsToResolvedElement__p2__Lamf_core_model_domain_DomainElement__Lamf_core_annotations_TrackedElement__sci_Set__Lamf_core_model_domain_DomainElement(element, x0$1, values)
    } else {
      throw new $c_s_MatchError().init___O(x0$1)
    }
  };
  if ((link.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_AutoGeneratedName.getClassOf()) && (!element.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf())))) {
    var annotation = new $c_Lamf_core_annotations_AutoGeneratedName().init___();
    $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(element, annotation)
  }
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.shouldCopyElement__p2__sc_Seq__Lamf_core_model_domain_Linkable__Lamf_core_model_domain_DomainElement__Z = (function(conditions, linkable, linkableAsElement) {
  return conditions.forall__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, linkable$1, linkableAsElement$1) {
    return (function(condition$2) {
      var condition = $as_F2(condition$2);
      return $uZ(condition.apply__O__O__O(linkable$1, linkableAsElement$1))
    })
  })(this, linkable, linkableAsElement)))
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.transform__Lamf_core_model_domain_DomainElement__s_Option = (function(element) {
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$().VALID$undDECLARATION$undCONDITION$1];
  return this.transform__Lamf_core_model_domain_DomainElement__sc_Seq__s_Option(element, $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))))
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.withName__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement = (function(resolved, source) {
  if ($is_Lamf_core_model_domain_NamedDomainElement(resolved)) {
    var x2 = $as_Lamf_core_model_domain_NamedDomainElement(resolved);
    if (this.isExample__p2__Lamf_core_model_domain_DomainElement__Z(x2)) {
      matchEnd4: {
        if ($is_Lamf_core_model_domain_NamedDomainElement(source)) {
          var x2$2 = $as_Lamf_core_model_domain_NamedDomainElement(source);
          if ($as_Lamf_core_model_StrField(x2$2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(x2$2.nameField__Lamf_core_metamodel_Field())).option$1.isDefined__Z()) {
            var this$1 = $as_Lamf_core_model_StrField(x2$2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(x2$2.nameField__Lamf_core_metamodel_Field()));
            var this$2 = this$1.option$1;
            var name = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
            var a = $as_Lamf_core_model_StrField(x2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(x2.nameField__Lamf_core_metamodel_Field())).annotations$1;
            $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(x2, name, a);
            break matchEnd4
          }
        }
      }
    } else {
      if ($as_Lamf_core_model_StrField(x2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(x2.nameField__Lamf_core_metamodel_Field())).option$1.isEmpty__Z()) {
        var jsx$3 = true
      } else {
        var this$3 = $as_Lamf_core_model_StrField(x2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(x2.nameField__Lamf_core_metamodel_Field()));
        var this$4 = this$3.option$1;
        var jsx$3 = ($as_T((this$4.isEmpty__Z() ? null : this$4.get__O())) === "schema")
      };
      if (jsx$3) {
        var jsx$2 = true
      } else {
        var this$5 = $as_Lamf_core_model_StrField(x2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(x2.nameField__Lamf_core_metamodel_Field()));
        var this$6 = this$5.option$1;
        var jsx$2 = ($as_T((this$6.isEmpty__Z() ? null : this$6.get__O())) === "type")
      };
      if (jsx$2) {
        var jsx$1 = true
      } else {
        var this$7 = $as_Lamf_core_model_StrField(x2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(x2.nameField__Lamf_core_metamodel_Field()));
        var this$8 = this$7.option$1;
        var jsx$1 = ($as_T((this$8.isEmpty__Z() ? null : this$8.get__O())) === "body")
      };
      if ((jsx$1 || x2.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_AutoGeneratedName.getClassOf()))) {
        if ($is_Lamf_core_model_domain_Linkable(source)) {
          this.innerName__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_NamedDomainElement__V(source, x2)
        }
      }
    }
  };
  this.annotateResolvedName__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__O(resolved, source);
  return resolved
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.isExample__p2__Lamf_core_model_domain_DomainElement__Z = (function(r) {
  var this$1 = r.meta__Lamf_core_metamodel_Obj().type__sci_List();
  var jsx$1 = $f_sc_TraversableLike__headOption__s_Option(this$1);
  var this$2 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  return jsx$1.contains__O__Z(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$2, "Example"))
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.resolveLinkTarget__p2__Lamf_core_model_domain_DomainElement__sc_Seq__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement = (function(element, conditions, l) {
  var x1 = $as_Lamf_core_model_domain_Linkable(l).effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement($as_Lamf_core_model_domain_Linkable(l).effectiveLinkTarget$default$1__sc_Seq());
  if ((x1 !== null)) {
    if (this.cache$2.contains__O__Z(x1.id__T())) {
      return $as_Lamf_core_model_domain_DomainElement(this.cache$2.apply__O__O(x1.id__T()))
    }
  };
  if ($is_Lamf_core_model_domain_Linkable(x1)) {
    if (this.shouldCopyElement__p2__sc_Seq__Lamf_core_model_domain_Linkable__Lamf_core_model_domain_DomainElement__Z(conditions, $as_Lamf_core_model_domain_Linkable(l), x1)) {
      return $as_Lamf_core_model_domain_DomainElement(this.copyEffectiveLinkTarget__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_Linkable(element, x1))
    }
  };
  if ((x1 !== null)) {
    this.propagateAnnotations__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__V(l, x1);
    return x1
  };
  throw new $c_s_MatchError().init___O(x1)
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.innerLinkNodeResolution__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement = (function(target) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var nested = new $c_Lamf_core_model_document_Document().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  nested.fields$1.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_core_metamodel_document_DocumentModel$().Encodes$1, target, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
  var result = $as_Lamf_core_model_document_Document(new $c_Lamf_core_resolution_stages_LinkNodeResolutionStage().init___Z__scm_Set__Lamf_core_errorhandling_ErrorHandler(this.keepEditingInfo$2, $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), this.errorHandler$2).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(nested));
  return result.encodes__Lamf_core_model_domain_DomainElement()
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.addIntermediateLinkTargetsToCache__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__scm_Set__V = (function(element, resolved, visited) {
  _addIntermediateLinkTargetsToCache: while (true) {
    if ((!visited.contains__O__Z(element.id__T()))) {
      visited.$$plus$eq__O__scm_SetLike(element.id__T());
      var x1 = element;
      if ($is_Lamf_core_model_domain_Linkable(x1)) {
        var this$1 = $as_Lamf_core_model_domain_Linkable(x1);
        if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1).isDefined__Z()) {
          this.setDeclaredElementIfMissing__p2__Lamf_core_parser_Annotations__Lamf_core_model_domain_DomainElement__V(element.annotations__Lamf_core_parser_Annotations(), resolved);
          var elem = element;
          if (elem.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf())) {
            this.cache$2.put__O__O__s_Option(element.id__T(), resolved)
          };
          var this$2 = $as_Lamf_core_model_domain_Linkable(x1);
          element = $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2).get__O());
          continue _addIntermediateLinkTargetsToCache
        }
      }
    };
    break
  }
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.annotateResolvedName__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__O = (function(resolved, source) {
  if ($is_Lamf_core_model_domain_NamedDomainElement(source)) {
    var x2 = $as_Lamf_core_model_domain_NamedDomainElement(source);
    var this$1 = $as_Lamf_core_model_StrField(x2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(x2.nameField__Lamf_core_metamodel_Field()));
    if ($f_Lamf_core_model_StrField__nonEmpty__Z(this$1)) {
      var resolvedNamesPresent = resolved.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity.getClassOf());
      var resolvedNamedEntityAnnotation = $as_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity((resolvedNamesPresent.isEmpty__Z() ? new $c_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity().init___scm_HashMap($as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()))) : resolvedNamesPresent.get__O()));
      var this$5 = resolvedNamedEntityAnnotation.vals$1;
      var this$3 = $as_Lamf_core_model_StrField(x2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(x2.nameField__Lamf_core_metamodel_Field()));
      var this$4 = this$3.option$1;
      var key = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
      var x1 = this$5.get__O__s_Option(key);
      if ((x1 instanceof $c_s_Some)) {
        var x2$1 = $as_s_Some(x1);
        var v = x2$1.value$2;
        var jsx$1 = v
      } else {
        var x = $m_s_None$();
        if ((!(x === x1))) {
          throw new $c_s_MatchError().init___O(x1)
        };
        var jsx$1 = $m_sci_Nil$()
      };
      var referenced = $as_sc_Seq(jsx$1);
      var jsx$5 = resolvedNamedEntityAnnotation.vals$1;
      var this$6 = $as_Lamf_core_model_StrField(x2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(x2.nameField__Lamf_core_metamodel_Field()));
      var this$7 = this$6.option$1;
      var jsx$4 = $as_T((this$7.isEmpty__Z() ? null : this$7.get__O()));
      var jsx$3 = $m_sc_Seq$();
      var array = [x2];
      var jsx$2 = jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
      var this$10 = $m_sc_Seq$();
      jsx$5.put__O__O__s_Option(jsx$4, referenced.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$10.ReusableCBFInstance$2));
      return (resolvedNamesPresent.isEmpty__Z() ? resolved.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(resolvedNamedEntityAnnotation) : (void 0))
    }
  };
  if ($is_Lamf_core_model_domain_Linkable(source)) {
    if ($is_Lamf_core_model_domain_NamedDomainElement(source)) {
      var this$11 = $as_Lamf_core_model_domain_Linkable(source);
      var jsx$6 = $as_Lamf_core_model_StrField(this$11.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1.isDefined__Z()
    } else {
      var jsx$6 = false
    };
    if (jsx$6) {
      var resolvedNamesPresent$2 = resolved.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity.getClassOf());
      var resolvedNamedEntityAnnotation$2 = $as_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity((resolvedNamesPresent$2.isEmpty__Z() ? new $c_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity().init___scm_HashMap($as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()))) : resolvedNamesPresent$2.get__O()));
      var this$16 = resolvedNamedEntityAnnotation$2.vals$1;
      var this$13 = $as_Lamf_core_model_domain_Linkable(source);
      var this$14 = $as_Lamf_core_model_StrField(this$13.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1));
      var this$15 = this$14.option$1;
      var key$1 = $as_T((this$15.isEmpty__Z() ? null : this$15.get__O()));
      var x1$1 = this$16.get__O__s_Option(key$1);
      if ((x1$1 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$1);
        var v$1 = x2$2.value$2;
        var jsx$7 = v$1
      } else {
        var x$1 = $m_s_None$();
        if ((!(x$1 === x1$1))) {
          throw new $c_s_MatchError().init___O(x1$1)
        };
        var jsx$7 = $m_sci_Nil$()
      };
      var referenced$2 = $as_sc_Seq(jsx$7);
      var jsx$11 = resolvedNamedEntityAnnotation$2.vals$1;
      var this$17 = $as_Lamf_core_model_domain_Linkable(source);
      var this$18 = $as_Lamf_core_model_StrField(this$17.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1));
      var this$19 = this$18.option$1;
      var jsx$10 = $as_T((this$19.isEmpty__Z() ? null : this$19.get__O()));
      var jsx$9 = $m_sc_Seq$();
      var array$1 = [$as_Lamf_core_model_domain_NamedDomainElement(source)];
      var jsx$8 = jsx$9.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
      var this$22 = $m_sc_Seq$();
      jsx$11.put__O__O__s_Option(jsx$10, referenced$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$8, this$22.ReusableCBFInstance$2));
      return (resolvedNamesPresent$2.isEmpty__Z() ? resolved.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(resolvedNamedEntityAnnotation$2) : (void 0))
    }
  }
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.addLinkTrackedElementsToResolvedElement__p2__Lamf_core_model_domain_DomainElement__Lamf_core_annotations_TrackedElement__sci_Set__Lamf_core_model_domain_DomainElement = (function(element, t, values) {
  var this$1 = element.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_TrackedElement.getClassOf());
  if (this$1.isEmpty__Z()) {
    var tracked = t
  } else {
    var arg1 = this$1.get__O();
    var inner = $as_Lamf_core_annotations_TrackedElement(arg1);
    var tracked = new $c_Lamf_core_annotations_TrackedElement().init___sci_Set($as_sci_Set(values.$$plus$plus__sc_GenTraversableOnce__sc_Set(inner.parents$1)))
  };
  element.annotations__Lamf_core_parser_Annotations().reject__F1__Lamf_core_parser_Annotations(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3) {
    return (function(x$4$2) {
      var x$4 = $as_Lamf_core_model_domain_Annotation(x$4$2);
      return (x$4 instanceof $c_Lamf_core_annotations_TrackedElement)
    })
  })(this)));
  return $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(element, tracked))
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.copyEffectiveLinkTarget__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_Linkable = (function(element, resolved) {
  var this$1 = resolved.annotations__Lamf_core_parser_Annotations();
  var copiedAnnotations = $m_Lamf_core_parser_Annotations$().apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(this$1).reject__F1__Lamf_core_parser_Annotations(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_core_model_domain_Annotation(x$3$2);
      return (x$3 instanceof $c_Lamf_core_annotations_AutoGeneratedName)
    })
  })(this)));
  var this$2 = $as_Lamf_core_model_domain_Linkable(resolved);
  var copied = $as_Lamf_core_model_domain_Linkable($f_Lamf_core_model_domain_Linkable__copyElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_Linkable(this$2, copiedAnnotations).withId__T__Lamf_core_model_domain_AmfObject(element.id__T()));
  var annotation = new $c_Lamf_core_annotations_TypeAlias().init___T(resolved.id__T());
  $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(copied, annotation);
  this.copyOriginalName__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_Linkable__O(element, copied);
  return copied
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.init___Lamf_core_errorhandling_ErrorHandler__Z__s_Option__scm_Map__F2 = (function(errorHandler, keepEditingInfo, modelResolver, cache, customDomainElementTransformation) {
  this.errorHandler$2 = errorHandler;
  this.keepEditingInfo$2 = keepEditingInfo;
  this.modelResolver$2 = modelResolver;
  this.cache$2 = cache;
  this.customDomainElementTransformation$2 = customDomainElementTransformation;
  return this
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.addResolvedLinkAnnotations__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__s_Option = (function(link, resolved) {
  resolved.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ResolvedLinkAnnotation().init___T(link.id__T()));
  var this$1 = $as_Lamf_core_model_domain_Linkable(link);
  var this$2 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1);
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var linkTarget = $as_Lamf_core_model_domain_DomainElement(arg1);
    return new $c_s_Some().init___O(resolved.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ResolvedLinkTargetAnnotation().init___T(linkTarget.id__T())))
  }
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.inner__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_NamedDomainElement__V = (function(source, resolved) {
  var this$1 = $as_Lamf_core_model_domain_Linkable(source);
  var x1 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1);
  matchEnd5: {
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var target = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
      if ($is_Lamf_core_model_domain_Linkable(target)) {
        this.innerName__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_NamedDomainElement__V(target, resolved);
        break matchEnd5
      }
    }
  }
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.resolveNestedLinks__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement = (function(domainElement) {
  var this$1 = $m_Lamf_core_resolution_stages_selectors_LinkSelector$();
  var another = $m_Lamf_core_resolution_stages_selectors_LinkNodeSelector$();
  var selectorAdapter = new $c_Lamf_core_traversal_DomainElementSelectorAdapter().init___F1(new $c_Lamf_core_resolution_stages_selectors_OrSelector().init___Lamf_core_resolution_stages_selectors_Selector__Lamf_core_resolution_stages_selectors_Selector(this$1, another));
  var transformationAdapter = new $c_Lamf_core_traversal_DomainElementTransformationAdapter().init___F2(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(elem$2, x$2$2) {
      var elem = $as_Lamf_core_model_domain_DomainElement(elem$2);
      $uZ(x$2$2);
      return $this.transform__Lamf_core_model_domain_DomainElement__s_Option(elem)
    })
  })(this)));
  var qual$1 = new $c_Lamf_core_traversal_TransformationTraversal().init___Lamf_core_traversal_TransformationData(new $c_Lamf_core_traversal_TransformationData().init___F1__F2(selectorAdapter, transformationAdapter));
  var x$2$3 = new $c_Lamf_core_traversal_ObjectIdTraversalPath().init___scm_Set($as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
  return $as_Lamf_core_model_domain_DomainElement(qual$1.traverse__Lamf_core_model_domain_AmfObject__Lamf_core_traversal_TraversalPath__Lamf_core_model_domain_AmfObject(domainElement, x$2$3))
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.setDeclaredElementIfMissing__p2__Lamf_core_parser_Annotations__Lamf_core_model_domain_DomainElement__V = (function(parentAnnotations, child) {
  var this$1 = parentAnnotations.amf$core$parser$Annotations$$annotations$1;
  var this$2 = this$1.scala$collection$mutable$ListBuffer$$start$6;
  var these = this$2;
  while ((!these.isEmpty__Z())) {
    var arg1 = these.head__O();
    var a = $as_Lamf_core_model_domain_Annotation(arg1);
    if (((a instanceof $c_Lamf_core_annotations_DeclaredElement) && (!child.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($objectGetClass(a))))) {
      child.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(a)
    };
    these = $as_sci_List(these.tail__O())
  }
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.copyOriginalName__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_Linkable__O = (function(element, copied) {
  if ($is_Lamf_core_model_domain_NamedDomainElement(element)) {
    var x2 = $as_Lamf_core_model_domain_NamedDomainElement(element);
    if ($as_Lamf_core_model_StrField(x2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(x2.nameField__Lamf_core_metamodel_Field())).option$1.isDefined__Z()) {
      var this$3 = $as_Lamf_core_model_domain_NamedDomainElement(copied);
      var this$1 = $as_Lamf_core_model_StrField(x2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(x2.nameField__Lamf_core_metamodel_Field()));
      var this$2 = this$1.option$1;
      var name = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
      var a = $as_Lamf_core_model_StrField(x2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(x2.nameField__Lamf_core_metamodel_Field())).annotations$1;
      return $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a)
    }
  }
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.transform__Lamf_core_model_domain_DomainElement__sc_Seq__s_Option = (function(element, conditions) {
  if ($is_Lamf_core_model_domain_Linkable(element)) {
    var this$1 = $as_Lamf_core_model_domain_Linkable(element);
    if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1).isDefined__Z()) {
      var jsx$1 = this.cache$2;
      var this$2 = $as_Lamf_core_model_domain_Linkable(element);
      if (jsx$1.contains__O__Z($as_Lamf_core_model_domain_AmfObject($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2).get__O()).id__T())) {
        var jsx$2 = this.cache$2;
        var this$3 = $as_Lamf_core_model_domain_Linkable(element);
        return new $c_s_Some().init___O(jsx$2.apply__O__O($as_Lamf_core_model_domain_AmfObject($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$3).get__O()).id__T()))
      } else if ((this.cache$2.contains__O__Z(element.id__T()) && this.shouldCopyElement__p2__sc_Seq__Lamf_core_model_domain_Linkable__Lamf_core_model_domain_DomainElement__Z(conditions, $as_Lamf_core_model_domain_Linkable(element), $as_Lamf_core_model_domain_DomainElement(this.cache$2.apply__O__O(element.id__T()))))) {
        var cached = $as_Lamf_core_model_domain_DomainElement(this.cache$2.apply__O__O(element.id__T()));
        return new $c_s_Some().init___O(this.copyEffectiveLinkTarget__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_Linkable(element, cached))
      } else {
        var target = this.resolveLinkTarget__p2__Lamf_core_model_domain_DomainElement__sc_Seq__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(element, conditions, element);
        var resolved = this.innerLinkNodeResolution__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(target);
        var x1$2 = resolved;
        matchEnd4: {
          if ($is_Lamf_core_model_domain_Linkable(x1$2)) {
            var this$4 = $as_Lamf_core_model_domain_Linkable(element);
            var this$5 = $as_Lamf_core_model_BoolField(this$4.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1)).option$1;
            if ($uZ((this$5.isEmpty__Z() ? false : this$5.get__O()))) {
              var this$6 = $as_Lamf_core_model_domain_Linkable(x1$2);
              var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1;
              $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$6, field, true));
              break matchEnd4
            }
          }
        };
        resolved = $as_Lamf_core_model_domain_DomainElement(this.customDomainElementTransformation$2.apply__O__O__O(this.withName__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(resolved, element), element));
        resolved.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ResolvedInheritance().init___());
        if (this.keepEditingInfo$2) {
          this.addResolvedLinkAnnotations__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__s_Option(element, resolved)
        };
        this.addIntermediateLinkTargetsToCache__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__scm_Set__V(element, resolved, $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
        resolved = this.traverseNestedLinksIfCopy__p2__Lamf_core_model_domain_DomainElement__sc_Seq__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(element, conditions, element, resolved);
        return new $c_s_Some().init___O(resolved)
      }
    }
  };
  if ((element instanceof $c_Lamf_core_model_domain_LinkNode)) {
    var x3 = $as_Lamf_core_model_domain_LinkNode(element);
    return $m_Lamf_core_resolution_stages_helpers_LinkNodeResolver$().resolveDynamicLink__Lamf_core_model_domain_LinkNode__s_Option__Z__s_Option(x3, this.modelResolver$2, this.keepEditingInfo$2)
  };
  return $m_s_None$()
});
var $d_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution = new $TypeData().initClass({
  Lamf_core_resolution_stages_elements_resolution_ReferenceResolution: 0
}, false, "amf.core.resolution.stages.elements.resolution.ReferenceResolution", {
  Lamf_core_resolution_stages_elements_resolution_ReferenceResolution: 1,
  Lamf_core_resolution_stages_elements_resolution_ElementStageTransformer: 1,
  O: 1
});
$c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution.prototype.$classData = $d_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution;
/** @constructor */
function $c_Lamf_core_traversal_DomainElementSelectorAdapter() {
  $c_O.call(this);
  this.selector$1 = null
}
$c_Lamf_core_traversal_DomainElementSelectorAdapter.prototype = new $h_O();
$c_Lamf_core_traversal_DomainElementSelectorAdapter.prototype.constructor = $c_Lamf_core_traversal_DomainElementSelectorAdapter;
/** @constructor */
function $h_Lamf_core_traversal_DomainElementSelectorAdapter() {
  /*<skip>*/
}
$h_Lamf_core_traversal_DomainElementSelectorAdapter.prototype = $c_Lamf_core_traversal_DomainElementSelectorAdapter.prototype;
$c_Lamf_core_traversal_DomainElementSelectorAdapter.prototype.apply__Lamf_core_model_domain_AmfObject__Z = (function(obj) {
  if ($is_Lamf_core_model_domain_DomainElement(obj)) {
    var x2 = $as_Lamf_core_model_domain_DomainElement(obj);
    return $uZ(this.selector$1.apply__O__O(x2))
  } else {
    return false
  }
});
$c_Lamf_core_traversal_DomainElementSelectorAdapter.prototype.apply__O__O = (function(v1) {
  return this.apply__Lamf_core_model_domain_AmfObject__Z($as_Lamf_core_model_domain_AmfObject(v1))
});
$c_Lamf_core_traversal_DomainElementSelectorAdapter.prototype.toString__T = (function() {
  return "<function1>"
});
$c_Lamf_core_traversal_DomainElementSelectorAdapter.prototype.apply$mcZI$sp__I__Z = (function(v1) {
  return this.apply__Lamf_core_model_domain_AmfObject__Z($as_Lamf_core_model_domain_AmfObject(v1))
});
$c_Lamf_core_traversal_DomainElementSelectorAdapter.prototype.init___F1 = (function(selector) {
  this.selector$1 = selector;
  return this
});
var $d_Lamf_core_traversal_DomainElementSelectorAdapter = new $TypeData().initClass({
  Lamf_core_traversal_DomainElementSelectorAdapter: 0
}, false, "amf.core.traversal.DomainElementSelectorAdapter", {
  Lamf_core_traversal_DomainElementSelectorAdapter: 1,
  O: 1,
  F1: 1
});
$c_Lamf_core_traversal_DomainElementSelectorAdapter.prototype.$classData = $d_Lamf_core_traversal_DomainElementSelectorAdapter;
/** @constructor */
function $c_Lamf_core_traversal_DomainElementTransformationAdapter() {
  $c_O.call(this);
  this.transformation$1 = null
}
$c_Lamf_core_traversal_DomainElementTransformationAdapter.prototype = new $h_O();
$c_Lamf_core_traversal_DomainElementTransformationAdapter.prototype.constructor = $c_Lamf_core_traversal_DomainElementTransformationAdapter;
/** @constructor */
function $h_Lamf_core_traversal_DomainElementTransformationAdapter() {
  /*<skip>*/
}
$h_Lamf_core_traversal_DomainElementTransformationAdapter.prototype = $c_Lamf_core_traversal_DomainElementTransformationAdapter.prototype;
$c_Lamf_core_traversal_DomainElementTransformationAdapter.prototype.init___F2 = (function(transformation) {
  this.transformation$1 = transformation;
  return this
});
$c_Lamf_core_traversal_DomainElementTransformationAdapter.prototype.toString__T = (function() {
  return "<function2>"
});
$c_Lamf_core_traversal_DomainElementTransformationAdapter.prototype.apply__O__O__O = (function(v1, v2) {
  return this.apply__Lamf_core_model_domain_AmfObject__Z__s_Option($as_Lamf_core_model_domain_AmfObject(v1), $uZ(v2))
});
$c_Lamf_core_traversal_DomainElementTransformationAdapter.prototype.apply__Lamf_core_model_domain_AmfObject__Z__s_Option = (function(obj, isCycle) {
  if ($is_Lamf_core_model_domain_DomainElement(obj)) {
    var x2 = $as_Lamf_core_model_domain_DomainElement(obj);
    return $as_s_Option(this.transformation$1.apply__O__O__O(x2, isCycle))
  } else {
    return new $c_s_Some().init___O(obj)
  }
});
var $d_Lamf_core_traversal_DomainElementTransformationAdapter = new $TypeData().initClass({
  Lamf_core_traversal_DomainElementTransformationAdapter: 0
}, false, "amf.core.traversal.DomainElementTransformationAdapter", {
  Lamf_core_traversal_DomainElementTransformationAdapter: 1,
  O: 1,
  F2: 1
});
$c_Lamf_core_traversal_DomainElementTransformationAdapter.prototype.$classData = $d_Lamf_core_traversal_DomainElementTransformationAdapter;
/** @constructor */
function $c_Lamf_core_traversal_iterator_AmfElementStrategy$() {
  $c_O.call(this)
}
$c_Lamf_core_traversal_iterator_AmfElementStrategy$.prototype = new $h_O();
$c_Lamf_core_traversal_iterator_AmfElementStrategy$.prototype.constructor = $c_Lamf_core_traversal_iterator_AmfElementStrategy$;
/** @constructor */
function $h_Lamf_core_traversal_iterator_AmfElementStrategy$() {
  /*<skip>*/
}
$h_Lamf_core_traversal_iterator_AmfElementStrategy$.prototype = $c_Lamf_core_traversal_iterator_AmfElementStrategy$.prototype;
$c_Lamf_core_traversal_iterator_AmfElementStrategy$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_traversal_iterator_AmfElementStrategy$.prototype.iterator__sci_List__Lamf_core_traversal_iterator_AmfIterator = (function(elements) {
  return new $c_Lamf_core_traversal_iterator_AmfElementIterator().init___sci_List(elements)
});
var $d_Lamf_core_traversal_iterator_AmfElementStrategy$ = new $TypeData().initClass({
  Lamf_core_traversal_iterator_AmfElementStrategy$: 0
}, false, "amf.core.traversal.iterator.AmfElementStrategy$", {
  Lamf_core_traversal_iterator_AmfElementStrategy$: 1,
  O: 1,
  Lamf_core_traversal_iterator_IteratorStrategy: 1
});
$c_Lamf_core_traversal_iterator_AmfElementStrategy$.prototype.$classData = $d_Lamf_core_traversal_iterator_AmfElementStrategy$;
var $n_Lamf_core_traversal_iterator_AmfElementStrategy$ = (void 0);
function $m_Lamf_core_traversal_iterator_AmfElementStrategy$() {
  if ((!$n_Lamf_core_traversal_iterator_AmfElementStrategy$)) {
    $n_Lamf_core_traversal_iterator_AmfElementStrategy$ = new $c_Lamf_core_traversal_iterator_AmfElementStrategy$().init___()
  };
  return $n_Lamf_core_traversal_iterator_AmfElementStrategy$
}
/** @constructor */
function $c_Lamf_core_traversal_iterator_DomainElementStrategy$() {
  $c_O.call(this)
}
$c_Lamf_core_traversal_iterator_DomainElementStrategy$.prototype = new $h_O();
$c_Lamf_core_traversal_iterator_DomainElementStrategy$.prototype.constructor = $c_Lamf_core_traversal_iterator_DomainElementStrategy$;
/** @constructor */
function $h_Lamf_core_traversal_iterator_DomainElementStrategy$() {
  /*<skip>*/
}
$h_Lamf_core_traversal_iterator_DomainElementStrategy$.prototype = $c_Lamf_core_traversal_iterator_DomainElementStrategy$.prototype;
$c_Lamf_core_traversal_iterator_DomainElementStrategy$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_traversal_iterator_DomainElementStrategy$.prototype.iterator__sci_List__Lamf_core_traversal_iterator_AmfIterator = (function(elements) {
  return new $c_Lamf_core_traversal_iterator_DomainElementIterator().init___sci_List(elements)
});
var $d_Lamf_core_traversal_iterator_DomainElementStrategy$ = new $TypeData().initClass({
  Lamf_core_traversal_iterator_DomainElementStrategy$: 0
}, false, "amf.core.traversal.iterator.DomainElementStrategy$", {
  Lamf_core_traversal_iterator_DomainElementStrategy$: 1,
  O: 1,
  Lamf_core_traversal_iterator_IteratorStrategy: 1
});
$c_Lamf_core_traversal_iterator_DomainElementStrategy$.prototype.$classData = $d_Lamf_core_traversal_iterator_DomainElementStrategy$;
var $n_Lamf_core_traversal_iterator_DomainElementStrategy$ = (void 0);
function $m_Lamf_core_traversal_iterator_DomainElementStrategy$() {
  if ((!$n_Lamf_core_traversal_iterator_DomainElementStrategy$)) {
    $n_Lamf_core_traversal_iterator_DomainElementStrategy$ = new $c_Lamf_core_traversal_iterator_DomainElementStrategy$().init___()
  };
  return $n_Lamf_core_traversal_iterator_DomainElementStrategy$
}
/** @constructor */
function $c_Lamf_core_utils_package$AmfStrings() {
  $c_O.call(this);
  this.str$1 = null;
  this.platform$1 = null
}
$c_Lamf_core_utils_package$AmfStrings.prototype = new $h_O();
$c_Lamf_core_utils_package$AmfStrings.prototype.constructor = $c_Lamf_core_utils_package$AmfStrings;
/** @constructor */
function $h_Lamf_core_utils_package$AmfStrings() {
  /*<skip>*/
}
$h_Lamf_core_utils_package$AmfStrings.prototype = $c_Lamf_core_utils_package$AmfStrings.prototype;
$c_Lamf_core_utils_package$AmfStrings.prototype.asOasExtension__T = (function() {
  return ("x-amf-" + this.str$1)
});
$c_Lamf_core_utils_package$AmfStrings.prototype.validReferencePath__Z = (function() {
  var thiz = this.str$1;
  return ($m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "\\.", 0).u.length < 3)
});
$c_Lamf_core_utils_package$AmfStrings.prototype.urlComponentDecoded__T = (function() {
  var this$1 = this.platform$1;
  var url = this.str$1;
  var x1 = $f_Lamf_core_remote_Platform__safeDecodeURIComponent__T__s_util_Either(this$1, url);
  if ((x1 instanceof $c_s_util_Right)) {
    var x2 = $as_s_util_Right(x1);
    var decodedUrl = $as_T(x2.value$2);
    return decodedUrl
  } else if ((x1 instanceof $c_s_util_Left)) {
    var x3 = $as_s_util_Left(x1);
    var rawUrl = $as_T(x3.value$2);
    return rawUrl
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_core_utils_package$AmfStrings.prototype.normalizeUrl__T = (function() {
  if ((this.str$1 === null)) {
    var jsx$1 = true
  } else {
    var thiz = this.str$1;
    if ((thiz === null)) {
      throw new $c_jl_NullPointerException().init___()
    };
    var jsx$1 = (thiz === "")
  };
  if (jsx$1) {
    return ""
  } else {
    var thiz$1 = this.str$1;
    if ((($uI(thiz$1.length) >= 0) && ($as_T(thiz$1.substring(0, $uI("http:".length))) === "http:"))) {
      var jsx$3 = true
    } else {
      var thiz$2 = this.str$1;
      var jsx$3 = (($uI(thiz$2.length) >= 0) && ($as_T(thiz$2.substring(0, $uI("https:".length))) === "https:"))
    };
    if (jsx$3) {
      var jsx$2 = true
    } else {
      var thiz$3 = this.str$1;
      var jsx$2 = (($uI(thiz$3.length) >= 0) && ($as_T(thiz$3.substring(0, $uI("file:".length))) === "file:"))
    };
    if (jsx$2) {
      return this.str$1
    } else {
      var thiz$4 = this.str$1;
      if ((($uI(thiz$4.length) >= 0) && ($as_T(thiz$4.substring(0, $uI("/".length))) === "/"))) {
        return ("file:/" + this.str$1)
      } else {
        return ("file://" + this.str$1)
      }
    }
  }
});
$c_Lamf_core_utils_package$AmfStrings.prototype.asRamlAnnotation__T = (function() {
  return (("(amf-" + this.str$1) + ")")
});
$c_Lamf_core_utils_package$AmfStrings.prototype.option__s_Option = (function() {
  var thiz = this.str$1;
  if ((thiz === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  if ((thiz === "")) {
    return $m_s_None$()
  } else {
    return $m_s_Option$().apply__O__s_Option(this.str$1)
  }
});
$c_Lamf_core_utils_package$AmfStrings.prototype.init___T = (function(str) {
  this.str$1 = str;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
var $d_Lamf_core_utils_package$AmfStrings = new $TypeData().initClass({
  Lamf_core_utils_package$AmfStrings: 0
}, false, "amf.core.utils.package$AmfStrings", {
  Lamf_core_utils_package$AmfStrings: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_core_utils_package$AmfStrings.prototype.$classData = $d_Lamf_core_utils_package$AmfStrings;
/** @constructor */
function $c_Lamf_plugins_document_Vocabularies$() {
  $c_O.call(this);
  this.platform$1 = null
}
$c_Lamf_plugins_document_Vocabularies$.prototype = new $h_O();
$c_Lamf_plugins_document_Vocabularies$.prototype.constructor = $c_Lamf_plugins_document_Vocabularies$;
/** @constructor */
function $h_Lamf_plugins_document_Vocabularies$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_Vocabularies$.prototype = $c_Lamf_plugins_document_Vocabularies$.prototype;
$c_Lamf_plugins_document_Vocabularies$.prototype.registerDialect__T__T__Lamf_client_environment_Environment__sjs_js_Promise = (function(url, dialectText, env) {
  var this$1 = env.executionEnvironment__Lamf_client_execution_BaseExecutionEnvironment();
  var executionContext = this$1.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  var this$2 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var from = $m_Lamf_plugins_document_vocabularies_AMLPlugin$().apply__Lamf_plugins_document_vocabularies_AMLPlugin().registry$2.registerDialect__T__T__Lamf_internal_environment_Environment__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(url, dialectText, env.$$undinternal$1, env.executionEnvironment__Lamf_client_execution_BaseExecutionEnvironment());
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().DialectConverter__Lamf_client_convert_DialectConverter$DialectConverter$();
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$2, from, m, executionContext).asClient__O()
});
$c_Lamf_plugins_document_Vocabularies$.prototype.$$js$exported$meth$registerDialect__T__Lamf_client_environment_Environment__O = (function(url, env) {
  return this.registerDialect__T__Lamf_client_environment_Environment__sjs_js_Promise(url, env)
});
$c_Lamf_plugins_document_Vocabularies$.prototype.registerDialect__T__sjs_js_Promise = (function(url) {
  var this$1 = this.platform$1;
  var this$2 = this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  var executionContext = this$2.$$undinternal$1.context$1;
  var this$4 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var qual$1 = $m_Lamf_plugins_document_vocabularies_AMLPlugin$().apply__Lamf_plugins_document_vocabularies_AMLPlugin().registry$2;
  var x$2 = $m_Lamf_internal_environment_Environment$().apply__Lamf_internal_environment_Environment();
  var this$3 = qual$1.platform$1;
  var x$3 = this$3.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  var from = qual$1.registerDialect__T__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future(url, x$2, x$3.$$undinternal$1.context$1);
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().DialectConverter__Lamf_client_convert_DialectConverter$DialectConverter$();
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$4, from, m, executionContext).asClient__O()
});
$c_Lamf_plugins_document_Vocabularies$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_Vocabularies$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_plugins_document_Vocabularies$.prototype.registerDialect__T__T__sjs_js_Promise = (function(url, dialectText) {
  var this$1 = this.platform$1;
  var this$2 = this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  var executionContext = this$2.$$undinternal$1.context$1;
  var this$4 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$3 = $m_Lamf_plugins_document_vocabularies_AMLPlugin$().apply__Lamf_plugins_document_vocabularies_AMLPlugin().registry$2;
  var from = this$3.registerDialect__T__T__Lamf_internal_environment_Environment__s_concurrent_Future(url, dialectText, $m_Lamf_internal_environment_Environment$().apply__Lamf_internal_environment_Environment());
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().DialectConverter__Lamf_client_convert_DialectConverter$DialectConverter$();
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$4, from, m, executionContext).asClient__O()
});
$c_Lamf_plugins_document_Vocabularies$.prototype.$$js$exported$meth$register__O = (function() {
  this.register__V()
});
$c_Lamf_plugins_document_Vocabularies$.prototype.registerDialect__T__Lamf_client_environment_Environment__sjs_js_Promise = (function(url, env) {
  var this$1 = env.executionEnvironment__Lamf_client_execution_BaseExecutionEnvironment();
  var executionContext = this$1.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  var this$3 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$2 = $m_Lamf_plugins_document_vocabularies_AMLPlugin$().apply__Lamf_plugins_document_vocabularies_AMLPlugin().registry$2;
  var environment = env.$$undinternal$1;
  var exec = env.executionEnvironment__Lamf_client_execution_BaseExecutionEnvironment();
  var from = this$2.registerDialect__T__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future(url, environment, exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1);
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().DialectConverter__Lamf_client_convert_DialectConverter$DialectConverter$();
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$3, from, m, executionContext).asClient__O()
});
$c_Lamf_plugins_document_Vocabularies$.prototype.$$js$exported$meth$registerDialect__T__T__Lamf_client_environment_Environment__O = (function(url, dialectText, env) {
  return this.registerDialect__T__T__Lamf_client_environment_Environment__sjs_js_Promise(url, dialectText, env)
});
$c_Lamf_plugins_document_Vocabularies$.prototype.$$js$exported$meth$registerDialect__T__O = (function(url) {
  return this.registerDialect__T__sjs_js_Promise(url)
});
$c_Lamf_plugins_document_Vocabularies$.prototype.$$js$exported$meth$registerDialect__T__T__O = (function(url, dialectText) {
  return this.registerDialect__T__T__sjs_js_Promise(url, dialectText)
});
$c_Lamf_plugins_document_Vocabularies$.prototype.register__V = (function() {
  $m_Lamf_plugins_domain_VocabulariesRegister$().register__Lamf_core_remote_Platform__V(this.platform$1);
  $m_Lamf_Core$();
  var plugin = $m_Lamf_plugins_document_vocabularies_AMLPlugin$();
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V(plugin)
});
$c_Lamf_plugins_document_Vocabularies$.prototype.registerDialect = (function(arg) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 1;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      if ($is_T(rest[0])) {
        var prep$3 = $as_T(arg);
        var prep$4 = $as_T(rest[0]);
        return this.$$js$exported$meth$registerDialect__T__T__O(prep$3, prep$4)
      } else if ((rest[0] instanceof $c_Lamf_client_environment_Environment)) {
        var prep = $as_T(arg);
        var prep$2 = $as_Lamf_client_environment_Environment(rest[0]);
        return this.$$js$exported$meth$registerDialect__T__Lamf_client_environment_Environment__O(prep, prep$2)
      } else {
        throw "No matching overload"
      };
      break
    }
    case 2: {
      var prep$5 = $as_T(arg);
      var prep$6 = $as_T(rest[0]);
      var prep$7 = $as_Lamf_client_environment_Environment(rest[1]);
      return this.$$js$exported$meth$registerDialect__T__T__Lamf_client_environment_Environment__O(prep$5, prep$6, prep$7);
      break
    }
    case 0: {
      var prep$8 = $as_T(arg);
      return this.$$js$exported$meth$registerDialect__T__O(prep$8);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_plugins_document_Vocabularies$.prototype.register = (function() {
  return this.$$js$exported$meth$register__O()
});
var $d_Lamf_plugins_document_Vocabularies$ = new $TypeData().initClass({
  Lamf_plugins_document_Vocabularies$: 0
}, false, "amf.plugins.document.Vocabularies$", {
  Lamf_plugins_document_Vocabularies$: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_plugins_document_Vocabularies$.prototype.$classData = $d_Lamf_plugins_document_Vocabularies$;
var $n_Lamf_plugins_document_Vocabularies$ = (void 0);
function $m_Lamf_plugins_document_Vocabularies$() {
  if ((!$n_Lamf_plugins_document_Vocabularies$)) {
    $n_Lamf_plugins_document_Vocabularies$ = new $c_Lamf_plugins_document_Vocabularies$().init___()
  };
  return $n_Lamf_plugins_document_Vocabularies$
}
/** @constructor */
function $c_Lamf_plugins_document_WebApi$() {
  $c_O.call(this);
  this.platform$1 = null
}
$c_Lamf_plugins_document_WebApi$.prototype = new $h_O();
$c_Lamf_plugins_document_WebApi$.prototype.constructor = $c_Lamf_plugins_document_WebApi$;
/** @constructor */
function $h_Lamf_plugins_document_WebApi$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_WebApi$.prototype = $c_Lamf_plugins_document_WebApi$.prototype;
$c_Lamf_plugins_document_WebApi$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_WebApi$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_plugins_document_WebApi$.prototype.$$js$exported$meth$register__Lamf_client_execution_BaseExecutionEnvironment__O = (function(executionEnvironment) {
  this.register__Lamf_client_execution_BaseExecutionEnvironment__V(executionEnvironment)
});
$c_Lamf_plugins_document_WebApi$.prototype.$$js$exported$meth$register__O = (function() {
  this.register__V()
});
$c_Lamf_plugins_document_WebApi$.prototype.register__Lamf_client_execution_BaseExecutionEnvironment__V = (function(executionEnvironment) {
  $m_Lamf_client_convert_WebApiRegister$().register__Lamf_core_remote_Platform__V(this.platform$1);
  $m_Lamf_Core$();
  var plugin = $m_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$();
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V(plugin);
  $m_Lamf_Core$();
  var plugin$1 = $m_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$();
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V(plugin$1);
  $m_Lamf_Core$();
  var plugin$2 = $m_Lamf_plugins_document_webapi_Oas20Plugin$();
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V(plugin$2);
  $m_Lamf_Core$();
  var plugin$3 = $m_Lamf_plugins_document_webapi_Oas30Plugin$();
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V(plugin$3);
  $m_Lamf_Core$();
  var plugin$4 = $m_Lamf_plugins_document_webapi_Async20Plugin$();
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V(plugin$4);
  $m_Lamf_Core$();
  var plugin$5 = $m_Lamf_plugins_document_webapi_Raml10Plugin$();
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V(plugin$5);
  $m_Lamf_Core$();
  var plugin$6 = $m_Lamf_plugins_document_webapi_Raml08Plugin$();
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V(plugin$6);
  $m_Lamf_Core$();
  var plugin$7 = $m_Lamf_plugins_document_webapi_PayloadPlugin$();
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V(plugin$7);
  $m_Lamf_Core$();
  var plugin$8 = $m_Lamf_plugins_document_webapi_JsonSchemaPlugin$();
  $m_Lamf_core_AMF$().registerPlugin__Lamf_client_plugins_AMFPlugin__V(plugin$8)
});
$c_Lamf_plugins_document_WebApi$.prototype.register__V = (function() {
  var this$1 = this.platform$1;
  this.register__Lamf_client_execution_BaseExecutionEnvironment__V(this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment())
});
$c_Lamf_plugins_document_WebApi$.prototype.register = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      return this.$$js$exported$meth$register__O();
      break
    }
    case 1: {
      var prep = $as_Lamf_client_execution_BaseExecutionEnvironment(rest[0]);
      return this.$$js$exported$meth$register__Lamf_client_execution_BaseExecutionEnvironment__O(prep);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
var $d_Lamf_plugins_document_WebApi$ = new $TypeData().initClass({
  Lamf_plugins_document_WebApi$: 0
}, false, "amf.plugins.document.WebApi$", {
  Lamf_plugins_document_WebApi$: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_plugins_document_WebApi$.prototype.$classData = $d_Lamf_plugins_document_WebApi$;
var $n_Lamf_plugins_document_WebApi$ = (void 0);
function $m_Lamf_plugins_document_WebApi$() {
  if ((!$n_Lamf_plugins_document_WebApi$)) {
    $n_Lamf_plugins_document_WebApi$ = new $c_Lamf_plugins_document_WebApi$().init___()
  };
  return $n_Lamf_plugins_document_WebApi$
}
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext() {
  $c_Lamf_plugins_document_graph_emitter_EmissionContext.call(this)
}
$c_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext.prototype = new $h_Lamf_plugins_document_graph_emitter_EmissionContext();
$c_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext.prototype = $c_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext.prototype;
$c_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext.prototype.canGenerateLink__Lamf_core_model_domain_AmfElement__Z = (function(e) {
  return false
});
$c_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext.prototype.init___scm_Map__T__Lamf_core_emitter_RenderOptions__Z = (function(prefixes, base, options, emittingDeclarations) {
  $c_Lamf_plugins_document_graph_emitter_EmissionContext.prototype.init___scm_Map__T__Lamf_core_emitter_RenderOptions__Z__Z.call(this, prefixes, base, options, emittingDeclarations, false);
  return this
});
var $d_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_FlattenedEmissionContext: 0
}, false, "amf.plugins.document.graph.emitter.FlattenedEmissionContext", {
  Lamf_plugins_document_graph_emitter_FlattenedEmissionContext: 1,
  Lamf_plugins_document_graph_emitter_EmissionContext: 1,
  O: 1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_FlattenedEmissionContext;
/** @constructor */
function $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser() {
  $c_O.call(this);
  this.Parser$module$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser.prototype = new $h_O();
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser.prototype.constructor = $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser;
/** @constructor */
function $h_Lamf_plugins_document_graph_parser_FlattenedGraphParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_parser_FlattenedGraphParser.prototype = $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser.prototype;
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser.prototype.parse__Lorg_yaml_model_YDocument__T__Lamf_core_model_document_BaseUnit = (function(document, location) {
  var parser = new $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser().init___Lamf_plugins_document_graph_parser_FlattenedGraphParser__sci_Map(this, $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())));
  return parser.parse__Lorg_yaml_model_YDocument__T__Lamf_core_model_document_BaseUnit(document, location)
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser.prototype.init___Lamf_plugins_document_graph_parser_GraphParserContext = (function(ctx) {
  this.ctx$1 = ctx;
  return this
});
var $d_Lamf_plugins_document_graph_parser_FlattenedGraphParser = new $TypeData().initClass({
  Lamf_plugins_document_graph_parser_FlattenedGraphParser: 0
}, false, "amf.plugins.document.graph.parser.FlattenedGraphParser", {
  Lamf_plugins_document_graph_parser_FlattenedGraphParser: 1,
  O: 1,
  Lamf_plugins_document_graph_parser_GraphParser: 1
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser.prototype.$classData = $d_Lamf_plugins_document_graph_parser_FlattenedGraphParser;
/** @constructor */
function $c_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$() {
  $c_O.call(this);
  this.graphDependenciesPredicate$1 = null
}
$c_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$.prototype = new $h_O();
$c_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$.prototype.constructor = $c_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$;
/** @constructor */
function $h_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$.prototype = $c_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$.prototype;
$c_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$ = this;
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  this.graphDependenciesPredicate$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "graphDependencies").iri__T();
  return this
});
$c_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$.prototype.update__Lamf_core_parser_ParsedReference__Lamf_core_CompilerContext__s_concurrent_ExecutionContext__s_concurrent_Future = (function(reference, compilerContext, executionContext) {
  return $m_s_concurrent_Future$().successful__O__s_concurrent_Future(reference)
});
$c_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$.prototype.processDependencyEntry__Lorg_yaml_model_YMapEntry__Lamf_core_parser_ReferenceCollector = (function(entry) {
  var this$1 = entry.value$2;
  var x1 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Seq$1;
  if ((x === x1)) {
    var this$2 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
    var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
    var jsx$2 = $as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv)).nodes$3;
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(node$2) {
        var node = $as_Lorg_yaml_model_YNode(node$2);
        var x1$1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
        var x$1 = $m_Lorg_yaml_model_YType$().Map$1;
        if ((x$1 === x1$1)) {
          return $m_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$().extractLink__Lorg_yaml_model_YNode__s_Option(node)
        } else {
          return $m_s_None$()
        }
      })
    })(this));
    var this$3 = $m_sc_IndexedSeq$();
    var links = $as_sc_IndexedSeq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBF$6));
    var collector = new $c_Lamf_core_parser_ReferenceCollector().init___();
    links.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, collector$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_s_Option(x0$1$2);
        matchEnd5: {
          if ((x0$1 instanceof $c_s_Some)) {
            var x2 = $as_s_Some(x0$1);
            var p3 = $as_T2(x2.value$2);
            if ((p3 !== null)) {
              var link = $as_T(p3.$$und1__O());
              var linkEntry = $as_Lorg_yaml_model_YNode(p3.$$und2__O());
              collector$1.$$plus$eq__T__Lamf_core_parser_ReferenceKind__Lorg_yaml_model_YNode__V(link, $m_Lamf_core_parser_UnspecifiedReference$(), linkEntry);
              break matchEnd5
            }
          }
        }
      })
    })(this, collector)));
    return collector
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$.prototype.collect__Lamf_core_parser_ParsedDocument__Lamf_core_parser_ParserContext__Lamf_core_parser_ReferenceCollector = (function(inputParsed, ctx) {
  if ((inputParsed instanceof $c_Lamf_core_parser_SyamlParsedDocument)) {
    var x2 = $as_Lamf_core_parser_SyamlParsedDocument(inputParsed);
    var document = x2.document$2;
    var node = document.node$2;
    var jsx$1 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node);
    var reader = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var this$3 = $m_sc_IndexedSeq$();
    var bf = this$3.ReusableCBF$6;
    var maybeMaps = jsx$1.toOption__Lorg_yaml_convert_YRead__s_Option(new $c_Lorg_yaml_convert_YRead$$anon$1().init___scg_CanBuildFrom__Lorg_yaml_convert_YRead(bf, reader));
    if (maybeMaps.isEmpty__Z()) {
      var x1$2 = $m_s_None$()
    } else {
      var arg1 = maybeMaps.get__O();
      var s = $as_sc_Seq(arg1);
      var x1$2 = s.headOption__s_Option()
    };
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var map = $as_Lorg_yaml_model_YMap(x2$2.value$2);
      if ((map !== null)) {
        var x1$3 = map.entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
          return (function(x$1$2) {
            var x$1 = $as_Lorg_yaml_model_YMapEntry(x$1$2);
            var this$4 = x$1.key$2;
            var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
            var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
            var x = $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv);
            var x$2 = $m_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$().graphDependenciesPredicate$1;
            return ((x === null) ? (x$2 === null) : $objectEquals(x, x$2))
          })
        })(this)));
        if ((x1$3 instanceof $c_s_Some)) {
          var x2$3 = $as_s_Some(x1$3);
          var entry = $as_Lorg_yaml_model_YMapEntry(x2$3.value$2);
          return this.processDependencyEntry__Lorg_yaml_model_YMapEntry__Lamf_core_parser_ReferenceCollector(entry)
        } else {
          var x$3 = $m_s_None$();
          if ((x$3 === x1$3)) {
            return $m_Lamf_core_parser_EmptyReferenceCollector$()
          } else {
            throw new $c_s_MatchError().init___O(x1$3)
          }
        }
      }
    };
    var x$3$1 = $m_s_None$();
    if ((x$3$1 === x1$2)) {
      return $m_Lamf_core_parser_EmptyReferenceCollector$()
    };
    throw new $c_s_MatchError().init___O(x1$2)
  } else {
    return $m_Lamf_core_parser_EmptyReferenceCollector$()
  }
});
$c_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$.prototype.extractLink__Lorg_yaml_model_YNode__s_Option = (function(node) {
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
  var x1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_Lorg_yaml_model_YMapEntry(x$2$2);
      var this$1 = x$2.key$2;
      var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
      var iv$1 = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
      var x = $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion$1, iv$1);
      return ((x !== null) && $objectEquals(x, "@id"))
    })
  })(this)));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    var this$2 = entry.value$2;
    var conversion$2 = $m_Lorg_yaml_convert_YRead$StringYRead$();
    var iv$2 = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
    return new $c_s_Some().init___O(new $c_T2().init___O__O($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$2, iv$2), entry.value$2))
  } else {
    return $m_s_None$()
  }
});
var $d_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$ = new $TypeData().initClass({
  Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$: 0
}, false, "amf.plugins.document.graph.parser.GraphDependenciesReferenceHandler$", {
  Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$: 1,
  O: 1,
  Lamf_core_parser_ReferenceHandler: 1
});
$c_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$.prototype.$classData = $d_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$;
var $n_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$ = (void 0);
function $m_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$() {
  if ((!$n_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$)) {
    $n_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$ = new $c_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$().init___()
  };
  return $n_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$
}
function $f_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModel__$$init$__V($thiz) {
  var jsx$1 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$());
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  $thiz.amf$plugins$document$vocabularies$metamodel$document$ExternalContextModel$$undsetter$und$Externals$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "externals"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true))
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$() {
  $c_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$.prototype = new $h_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification();
$c_Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$: 0
}, false, "amf.plugins.document.vocabularies.model.domain.ExtensionPointProperty$", {
  Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$: 1,
  Lamf_plugins_document_vocabularies_model_domain_PropertyClassification: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$;
var $n_Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$() {
  if ((!$n_Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$)) {
    $n_Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$ = new $c_Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$() {
  $c_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$.prototype = new $h_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification();
$c_Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$: 0
}, false, "amf.plugins.document.vocabularies.model.domain.ExternalLinkProperty$", {
  Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$: 1,
  Lamf_plugins_document_vocabularies_model_domain_PropertyClassification: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$;
var $n_Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$() {
  if ((!$n_Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$)) {
    $n_Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$ = new $c_Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$() {
  $c_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$.prototype = new $h_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification();
$c_Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$: 0
}, false, "amf.plugins.document.vocabularies.model.domain.LiteralProperty$", {
  Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$: 1,
  Lamf_plugins_document_vocabularies_model_domain_PropertyClassification: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$;
var $n_Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$() {
  if ((!$n_Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$)) {
    $n_Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$ = new $c_Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$() {
  $c_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$.prototype = new $h_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification();
$c_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$: 0
}, false, "amf.plugins.document.vocabularies.model.domain.LiteralPropertyCollection$", {
  Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$: 1,
  Lamf_plugins_document_vocabularies_model_domain_PropertyClassification: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$;
var $n_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$() {
  if ((!$n_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$)) {
    $n_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$ = new $c_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_ObjectMapInheritanceProperty$() {
  $c_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectMapInheritanceProperty$.prototype = new $h_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification();
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectMapInheritanceProperty$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_ObjectMapInheritanceProperty$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_ObjectMapInheritanceProperty$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_ObjectMapInheritanceProperty$.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_ObjectMapInheritanceProperty$.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectMapInheritanceProperty$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_document_vocabularies_model_domain_ObjectMapInheritanceProperty$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_ObjectMapInheritanceProperty$: 0
}, false, "amf.plugins.document.vocabularies.model.domain.ObjectMapInheritanceProperty$", {
  Lamf_plugins_document_vocabularies_model_domain_ObjectMapInheritanceProperty$: 1,
  Lamf_plugins_document_vocabularies_model_domain_PropertyClassification: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectMapInheritanceProperty$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_ObjectMapInheritanceProperty$;
var $n_Lamf_plugins_document_vocabularies_model_domain_ObjectMapInheritanceProperty$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_model_domain_ObjectMapInheritanceProperty$() {
  if ((!$n_Lamf_plugins_document_vocabularies_model_domain_ObjectMapInheritanceProperty$)) {
    $n_Lamf_plugins_document_vocabularies_model_domain_ObjectMapInheritanceProperty$ = new $c_Lamf_plugins_document_vocabularies_model_domain_ObjectMapInheritanceProperty$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_model_domain_ObjectMapInheritanceProperty$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$() {
  $c_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$.prototype = new $h_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification();
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$: 0
}, false, "amf.plugins.document.vocabularies.model.domain.ObjectMapProperty$", {
  Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$: 1,
  Lamf_plugins_document_vocabularies_model_domain_PropertyClassification: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$;
var $n_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$() {
  if ((!$n_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$)) {
    $n_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$ = new $c_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$() {
  $c_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$.prototype = new $h_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification();
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$: 0
}, false, "amf.plugins.document.vocabularies.model.domain.ObjectPairProperty$", {
  Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$: 1,
  Lamf_plugins_document_vocabularies_model_domain_PropertyClassification: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$;
var $n_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$() {
  if ((!$n_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$)) {
    $n_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$ = new $c_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$() {
  $c_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$.prototype = new $h_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification();
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$: 0
}, false, "amf.plugins.document.vocabularies.model.domain.ObjectProperty$", {
  Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$: 1,
  Lamf_plugins_document_vocabularies_model_domain_PropertyClassification: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$;
var $n_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$() {
  if ((!$n_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$)) {
    $n_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$ = new $c_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$() {
  $c_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$.prototype = new $h_Lamf_plugins_document_vocabularies_model_domain_PropertyClassification();
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$: 0
}, false, "amf.plugins.document.vocabularies.model.domain.ObjectPropertyCollection$", {
  Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$: 1,
  Lamf_plugins_document_vocabularies_model_domain_PropertyClassification: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$;
var $n_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$() {
  if ((!$n_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$)) {
    $n_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$ = new $c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler() {
  $c_O.call(this);
  this.registry$1 = null;
  this.eh$1 = null;
  this.collector$1 = null
}
$c_Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler.prototype = $c_Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler.prototype;
$c_Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler.prototype.ramlInclude__p1__Lorg_yaml_model_YNode__V = (function(node) {
  var x1 = node.value__Lorg_yaml_model_YValue();
  if ((x1 instanceof $c_Lorg_yaml_model_YScalar)) {
    var x2 = $as_Lorg_yaml_model_YScalar(x1);
    this.collector$1.$$plus$eq__T__Lamf_core_parser_ReferenceKind__Lorg_yaml_model_YNode__V(x2.text$3, $m_Lamf_core_parser_LinkReference$(), node)
  } else {
    var this$1 = this.eh$1;
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().InvalidInclude$1;
    var message = ("Unexpected !include or dialect with " + node.value__Lorg_yaml_model_YValue());
    var prop = $m_s_None$();
    var l = node.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, "", prop, message, l)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler.prototype.dialectDefinitionUrl__T__T = (function(mt) {
  var io = $uI(mt.indexOf("|"));
  if ((io > 0)) {
    var beginIndex = ((1 + io) | 0);
    var msk = $as_T(mt.substring(beginIndex));
    var si = $uI(msk.indexOf("<"));
    var se = $uI(msk.lastIndexOf(">"));
    var beginIndex$1 = ((1 + si) | 0);
    return $as_T(msk.substring(beginIndex$1, se))
  } else {
    return ""
  }
});
$c_Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler.prototype.update__Lamf_core_parser_ParsedReference__Lamf_core_CompilerContext__s_concurrent_ExecutionContext__s_concurrent_Future = (function(reference, compilerContext, executionContext) {
  return $m_s_concurrent_Future$().successful__O__s_concurrent_Future(reference)
});
$c_Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler.prototype.library__p1__Lorg_yaml_model_YMapEntry__V = (function(entry) {
  var jsx$1 = this.collector$1;
  $m_Lorg_yaml_model_YNode$();
  var node = entry.value$2;
  var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
  var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
  jsx$1.$$plus$eq__T__Lamf_core_parser_ReferenceKind__Lorg_yaml_model_YNode__V($as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)), $m_Lamf_core_parser_LibraryReference$(), entry.value$2)
});
$c_Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler.prototype.ramlIncludeText__p1__T__V = (function(text) {
  var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(text, "#", 0);
  var this$3 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
  var link = $as_T($f_sc_IndexedSeqOptimized__head__O(this$3));
  var this$5 = new $c_sci_StringOps().init___T(link);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$5)) {
    this.ramlInclude__p1__Lorg_yaml_model_YNode__V(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(link)))
  }
});
$c_Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler.prototype.libraries__p1__Lorg_yaml_model_YDocument__Lamf_core_parser_ParserContext__V = (function(document, ctx) {
  var evidence$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var x1 = document.obj__Lorg_yaml_model_YObj().to__Lorg_yaml_convert_YRead__s_util_Either(evidence$1);
  if ((x1 instanceof $c_s_util_Right)) {
    var x2 = $as_s_util_Right(x1);
    var map = $as_Lorg_yaml_model_YMap(x2.value$2);
    var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("uses");
    if ((!this$2.isEmpty__Z())) {
      var arg1 = this$2.get__O();
      var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
      var this$3 = entry.value$2;
      var evidence$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var x1$1 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$3, evidence$2);
      if ((x1$1 instanceof $c_s_util_Right)) {
        var x2$1 = $as_s_util_Right(x1$1);
        var m = $as_Lorg_yaml_model_YMap(x2$1.value$2);
        m.entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(entry$2$2) {
            var entry$2 = $as_Lorg_yaml_model_YMapEntry(entry$2$2);
            $this.library__p1__Lorg_yaml_model_YMapEntry__V(entry$2)
          })
        })(this)))
      } else {
        var this$4 = ctx.eh$1;
        var specification = $m_Lamf_validation_DialectValidations$().InvalidModuleType$1;
        var message = ("Expected map but found: " + entry.value$2);
        var ast = entry.value$2;
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$4, specification, "", prop, message, l)
      }
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler.prototype.links__p1__Lorg_yaml_model_YPart__V = (function(part) {
  matchEnd5: {
    if ((part instanceof $c_Lorg_yaml_model_YMapEntry)) {
      var x2 = $as_Lorg_yaml_model_YMapEntry(part);
      var this$1 = x2.key$2;
      var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
      var x1$2 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3;
      if ((x1$2 === "$target")) {
        var includeRef = x2.value$2;
        this.ramlInclude__p1__Lorg_yaml_model_YNode__V(includeRef)
      } else if ((x1$2 === "$dialect")) {
        var dialectRef = x2.value$2;
        var jsx$1 = this.registry$1;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv$1 = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
        if ((!jsx$1.knowsHeader__T__Z(("%" + $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(dialectRef, conversion$1, iv$1))))) {
          $m_Lorg_yaml_model_YNode$();
          var iv$2 = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
          var conversion$2 = $m_Lorg_yaml_convert_YRead$StringYRead$();
          this.ramlIncludeText__p1__T__V($as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(dialectRef, conversion$2, iv$2)))
        }
      } else if ((x1$2 === "$include")) {
        var includeRef$2 = x2.value$2;
        this.ramlInclude__p1__Lorg_yaml_model_YNode__V(includeRef$2)
      } else if ((x1$2 === "$ref")) {
        var this$3 = x2.value$2.asScalar__s_Option();
        if (this$3.isEmpty__Z()) {
          var this$4 = $m_s_None$()
        } else {
          var arg1 = this$3.get__O();
          var x$1 = $as_Lorg_yaml_model_YScalar(arg1);
          var this$4 = new $c_s_Some().init___O(x$1.text$3)
        };
        if ((!this$4.isEmpty__Z())) {
          var arg1$1 = this$4.get__O();
          var text = $as_T(arg1$1);
          this.ramlIncludeText__p1__T__V(text)
        }
      } else {
        part.children$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
          return (function(part$2$2) {
            var part$2 = $as_Lorg_yaml_model_YPart(part$2$2);
            this$3$1.links__p1__Lorg_yaml_model_YPart__V(part$2)
          })
        })(this)))
      };
      break matchEnd5
    };
    if ((part instanceof $c_Lorg_yaml_model_YNode)) {
      var x3 = $as_Lorg_yaml_model_YNode(part);
      var x$2 = x3.tag__Lorg_yaml_model_YTag().tagType$3;
      var x$3 = $m_Lorg_yaml_model_YType$().Include$1;
      if ((x$2 === x$3)) {
        this.ramlInclude__p1__Lorg_yaml_model_YNode__V(x3);
        break matchEnd5
      }
    };
    part.children$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
      return (function(part$3$2) {
        var part$3 = $as_Lorg_yaml_model_YPart(part$3$2);
        this$4$1.links__p1__Lorg_yaml_model_YPart__V(part$3)
      })
    })(this)))
  }
});
$c_Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler.prototype.init___Lamf_plugins_document_vocabularies_DialectsRegistry__Lamf_core_errorhandling_ErrorHandler = (function(registry, eh) {
  this.registry$1 = registry;
  this.eh$1 = eh;
  this.collector$1 = new $c_Lamf_core_parser_ReferenceCollector().init___();
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler.prototype.collect__Lamf_core_parser_ParsedDocument__Lamf_core_parser_ParserContext__Lamf_core_parser_ReferenceCollector = (function(parsedDoc, ctx) {
  if ((parsedDoc instanceof $c_Lamf_core_parser_SyamlParsedDocument)) {
    var x2 = $as_Lamf_core_parser_SyamlParsedDocument(parsedDoc);
    var this$1 = x2.comment$2;
    if ((!this$1.isEmpty__Z())) {
      var arg1 = this$1.get__O();
      var comment = $as_T(arg1);
      if (this.referencesDialect__p1__T__Z(comment)) {
        this.collector$1.$$plus$eq__T__Lamf_core_parser_ReferenceKind__Lorg_yaml_model_YNode__V(this.dialectDefinitionUrl__T__T(comment), $m_Lamf_core_parser_SchemaReference$(), x2.document$2.node$2)
      }
    };
    this.libraries__p1__Lorg_yaml_model_YDocument__Lamf_core_parser_ParserContext__V(x2.document$2, ctx);
    this.links__p1__Lorg_yaml_model_YPart__V(x2.document$2)
  };
  return this.collector$1
});
$c_Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler.prototype.referencesDialect__p1__T__Z = (function(mt) {
  var io = $uI(mt.indexOf("|"));
  if ((io > 0)) {
    var beginIndex = ((1 + io) | 0);
    var msk = $as_T(mt.substring(beginIndex));
    var si = $uI(msk.indexOf("<"));
    var se = $uI(msk.lastIndexOf(">"));
    return ((si > 0) && (se > si))
  } else {
    return false
  }
});
var $d_Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler: 0
}, false, "amf.plugins.document.vocabularies.parser.common.SyntaxExtensionsReferenceHandler", {
  Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler: 1,
  O: 1,
  Lamf_core_parser_ReferenceHandler: 1
});
$c_Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps() {
  $c_Lamf_core_parser_package$YMapOps.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps.prototype = new $h_Lamf_core_parser_package$YMapOps();
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps.prototype = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps.prototype;
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps.prototype.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V = (function(keyword, parser) {
  var this$1 = this.key__T__s_Option(keyword);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    parser.parse__Lorg_yaml_model_YMapEntry__V(entry)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps.prototype.init___Lorg_yaml_model_YMap = (function(map) {
  $c_Lamf_core_parser_package$YMapOps.prototype.init___Lorg_yaml_model_YMap.call(this, map);
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps.prototype.key__T__F1__V = (function(keyword, fn) {
  $c_Lamf_core_parser_package$YMapOps.prototype.key__T__F1__V.call(this, keyword, fn)
});
var $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps: 0
}, false, "amf.plugins.document.vocabularies.parser.dialects.DialectAstOps$DialectYMapOps", {
  Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps: 1,
  Lamf_core_parser_package$YMapOps: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser$$anon$1() {
  $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser.call(this);
  this.$$outer$2 = null
}
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser$$anon$1.prototype = new $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser();
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser$$anon$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser$$anon$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser$$anon$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser$$anon$1.prototype = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser$$anon$1.prototype;
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser$$anon$1.prototype.init___Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser.prototype.init___Lamf_plugins_document_vocabularies_parser_dialects_DialectContext.call(this, $$outer.ctx$1);
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser$$anon$1.prototype.parse__Lorg_yaml_model_YMapEntry__V = (function(entry) {
  var this$1 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$1;
  var jsx$3 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).entries$3;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, entry$1) {
    return (function(fragmentEntry$2) {
      var fragmentEntry = $as_Lorg_yaml_model_YMapEntry(fragmentEntry$2);
      var this$2 = fragmentEntry.key$2;
      var conversion$1 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
      var iv$1 = $this.ctx$1;
      var fragmentName = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$1, iv$1)).text$3;
      var this$3 = fragmentEntry.value$2;
      var conversion$2 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
      var iv$2 = $this.ctx$1;
      var nodeId = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion$2, iv$2)).text$3;
      var this$4 = $m_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(fragmentEntry.value$2);
      var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DocumentName$1;
      var this$8 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, fragmentName));
      var jsx$2 = $this.$$outer$2.into$2.id$1;
      var this$6 = new $c_Lamf_core_utils_package$AmfStrings().init___T(fragmentName);
      var this$7 = this$6.platform$1;
      var url = this$6.str$1;
      var value = ((jsx$2 + "/fragments/") + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$7, url));
      var documentsMapping = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$8, value));
      var nodeMapping = $this.ctx$1.declarations$2.findNodeMappingOrError__Lorg_yaml_model_YPart__T__Lamf_core_parser_SearchScope$Scope__Lamf_plugins_document_vocabularies_model_domain_NodeMappable(entry$1.value$2, nodeId, $m_Lamf_core_parser_SearchScope$All$());
      var field$1 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().EncodedNode$1;
      var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(nodeMapping.id__T(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$1.value$2));
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$1);
      return $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(documentsMapping, field$1, value$1, annotations))
    })
  })(this, entry));
  var this$9 = $m_sc_IndexedSeq$();
  var docs = $as_sc_IndexedSeq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$1, this$9.ReusableCBF$6));
  var this$10 = this.$$outer$2.into$2;
  var field$2 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Fragments$1;
  var value$2 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(docs, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
  var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$10, field$2, value$2, annotations$1)
});
var $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser$$anon$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser$$anon$1: 0
}, false, "amf.plugins.document.vocabularies.parser.dialects.DialectFragmentParser$$anon$1", {
  Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser$$anon$1: 1,
  Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser$$anon$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser$$anon$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectScalarValueEntryParser() {
  $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser.call(this);
  this.f$2 = null;
  this.target$2 = null
}
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectScalarValueEntryParser.prototype = new $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser();
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectScalarValueEntryParser.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectScalarValueEntryParser;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectScalarValueEntryParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_dialects_DialectScalarValueEntryParser.prototype = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectScalarValueEntryParser.prototype;
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectScalarValueEntryParser.prototype.buildScalarNode__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar = (function(node) {
  var iv = this.ctx$1;
  return this.typedScalar__p2__Lamf_core_parser_ScalarNode__Lorg_yaml_model_YType__Lamf_core_model_domain_AmfScalar(new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv), node.tag__Lorg_yaml_model_YTag().tagType$3)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectScalarValueEntryParser.prototype.parse__Lorg_yaml_model_YMapEntry__V = (function(entry) {
  var this$1 = this.target$2;
  var field = this.f$2;
  var value = this.buildScalarNode__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(entry.value$2);
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$1, field, value, annotations)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectScalarValueEntryParser.prototype.typedScalar__p2__Lamf_core_parser_ScalarNode__Lorg_yaml_model_YType__Lamf_core_model_domain_AmfScalar = (function(scalar, tagType) {
  var x1 = this.f$2.type$1;
  var x = $m_Lamf_core_metamodel_Type$Int$();
  if (x.equals__O__Z(x1)) {
    return scalar.integer__Lamf_core_model_domain_AmfScalar()
  } else {
    var x$3 = $m_Lamf_core_metamodel_Type$Bool$();
    if (x$3.equals__O__Z(x1)) {
      return scalar.$boolean__Lamf_core_model_domain_AmfScalar()
    } else {
      var x$5 = $m_Lamf_core_metamodel_Type$Double$();
      if (x$5.equals__O__Z(x1)) {
        return scalar.$double__Lamf_core_model_domain_AmfScalar()
      } else {
        var x$7 = $m_Lamf_core_metamodel_Type$Str$();
        if (x$7.equals__O__Z(x1)) {
          var x$10 = $m_Lorg_yaml_model_YType$().Str$1;
          var jsx$1 = (tagType === x$10)
        } else {
          var jsx$1 = false
        };
        if (jsx$1) {
          return scalar.string__Lamf_core_model_domain_AmfScalar()
        } else {
          return scalar.text__Lamf_core_model_domain_AmfScalar()
        }
      }
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectScalarValueEntryParser.prototype.init___Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext = (function(f, target, ctx) {
  this.f$2 = f;
  this.target$2 = target;
  $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser.prototype.init___Lamf_plugins_document_vocabularies_parser_dialects_DialectContext.call(this, ctx);
  return this
});
var $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectScalarValueEntryParser = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_dialects_DialectScalarValueEntryParser: 0
}, false, "amf.plugins.document.vocabularies.parser.dialects.DialectScalarValueEntryParser", {
  Lamf_plugins_document_vocabularies_parser_dialects_DialectScalarValueEntryParser: 1,
  Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectScalarValueEntryParser.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectScalarValueEntryParser;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesParser() {
  $c_O.call(this);
  this.root$1 = null;
  this.ctx$1 = null;
  this.map$1 = null;
  this.vocabulary$1 = null
}
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesParser.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesParser.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesParser;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesParser.prototype = $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesParser.prototype;
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesParser.prototype.parseDocument__Lamf_core_model_document_BaseUnit = (function() {
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("base");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var value = new $c_Lamf_core_parser_ValueNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(entry.value$2, this.ctx$1);
    var this$4 = this.vocabulary$1;
    var field = $m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Base$1;
    var value$1 = value.string__Lamf_core_model_domain_AmfScalar();
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$4, field, value$1, annotations)
  };
  var map$1 = this.map$1;
  var this$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var this$7 = this$6.key__T__s_Option("vocabulary");
  if ((!this$7.isEmpty__Z())) {
    var arg1$1 = this$7.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var value$2 = new $c_Lamf_core_parser_ValueNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(entry$3.value$2, this.ctx$1);
    var this$8 = this.vocabulary$1;
    var field$1 = $m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Name$1;
    var value$3 = value$2.string__Lamf_core_model_domain_AmfScalar();
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$8, field$1, value$3, annotations$1)
  };
  var map$2 = this.map$1;
  var this$10 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var this$11 = this$10.key__T__s_Option("usage");
  if ((!this$11.isEmpty__Z())) {
    var arg1$2 = this$11.get__O();
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var value$4 = new $c_Lamf_core_parser_ValueNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(entry$4.value$2, this.ctx$1);
    var this$12 = this.vocabulary$1;
    var field$2 = $m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Usage$1;
    var value$5 = value$4.string__Lamf_core_model_domain_AmfScalar();
    var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$12, field$2, value$5, annotations$2)
  };
  var this$13 = this.ctx$1;
  var id = this.vocabulary$1.id$1;
  var map$3 = this.map$1;
  $f_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularySyntax__closedNode__T__T__Lorg_yaml_model_YMap__V(this$13, "vocabulary", id, map$3);
  var jsx$1 = new $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser().init___Lorg_yaml_model_YMap__sc_Seq__Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext(this.map$1, this.root$1.references$1, this.ctx$1);
  var this$14 = this.vocabulary$1;
  var this$15 = $as_Lamf_core_model_StrField(this$14.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Base$1));
  var this$16 = this$15.option$1;
  var references = jsx$1.parse__T__Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations($as_T((this$16.isEmpty__Z() ? null : this$16.get__O())));
  var this$17 = this.ctx$1.declarations$2.externals$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$17)) {
    var this$20 = this.vocabulary$1;
    var this$18 = this.ctx$1.declarations$2.externals$2;
    var this$19 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$18);
    var externals = this$19.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream();
    var field$3 = $m_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$().Externals$1;
    $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$20, field$3, externals)
  };
  this.parseClassTerms__Lorg_yaml_model_YMap__V(this.map$1);
  this.parsePropertyTerms__Lorg_yaml_model_YMap__V(this.map$1);
  var declarables = this.ctx$1.terms__sc_Seq();
  var this$30 = this.ctx$1.imported$2;
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var alias = $as_T(x0$1.$$und1__O());
        var library = $as_Lamf_plugins_document_vocabularies_model_document_Vocabulary(x0$1.$$und2__O());
        $m_Lamf_core_parser_Annotations$();
        var annotations$3 = new $c_Lamf_core_parser_Annotations().init___();
        var this$24 = new $c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$3);
        var field$4 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$().Alias$1;
        var this$25 = $as_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$24, field$4, alias));
        var reference = library.id$1;
        var field$5 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$().Reference$1;
        var this$28 = $as_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$25, field$5, reference));
        var this$26 = $as_Lamf_core_model_StrField(library.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Base$1));
        var this$27 = this$26.option$1;
        var base = $as_T((this$27.isEmpty__Z() ? null : this$27.get__O()));
        var field$6 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$().Base$1;
        var qual$1 = $as_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$28, field$6, base));
        var x$1 = this$4$1.vocabulary$1.id$1;
        $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        return $as_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1))
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this));
  var this$29 = $m_sci_Iterable$();
  var bf = this$29.ReusableCBFInstance$2;
  var imported = $as_sci_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$30, f, bf));
  if ($f_sc_TraversableOnce__nonEmpty__Z(imported)) {
    var this$31 = this.vocabulary$1;
    var vocabularies = imported.toSeq__sc_Seq();
    var field$7 = $m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Imports$1;
    $as_Lamf_plugins_document_vocabularies_model_document_Vocabulary($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$31, field$7, vocabularies))
  };
  if (declarables.nonEmpty__Z()) {
    var this$32 = this.vocabulary$1;
    var field$8 = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
    $as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$32, field$8, declarables))
  };
  var this$33 = references.references$1;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$33)) {
    var this$34 = this.vocabulary$1;
    var references$1 = references.baseUnitReferences__sc_Seq();
    var field$9 = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
    $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$34, field$9, references$1))
  };
  this.ctx$1.pendingLocal$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1) {
    return (function(x0$2$2) {
      var x0$2 = $as_T4(x0$2$2);
      if ((x0$2 !== null)) {
        var term = $as_T(x0$2.$$und1$1);
        var location = $as_Lorg_yaml_model_YPart(x0$2.$$und3$1);
        var isProperty = $uZ(x0$2.$$und4$1);
        if (isProperty) {
          var this$35 = this$5$1.ctx$1;
          var node = this$5$1.vocabulary$1.id$1;
          $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__missingPropertyTermWarning__T__T__Lorg_yaml_model_YPart__V(this$35, term, node, location)
        } else {
          var this$36 = this$5$1.ctx$1;
          var node$1 = this$5$1.vocabulary$1.id$1;
          $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__missingClassTermWarning__T__T__Lorg_yaml_model_YPart__V(this$36, term, node$1, location)
        }
      } else {
        throw new $c_s_MatchError().init___O(x0$2)
      }
    })
  })(this)));
  return this.vocabulary$1
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesParser.prototype.parsePropertyTerm__Lorg_yaml_model_YMapEntry__V = (function(propertyTermDeclaration) {
  var this$1 = propertyTermDeclaration.value$2;
  var x1 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Null$1;
  if ((x === x1)) {
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(propertyTermDeclaration);
    var propertyTerm = new $c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
  } else {
    var this$4 = propertyTermDeclaration.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$1;
    var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv));
    var x1$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("range");
    var x$3 = $m_s_None$();
    if ((x$3 === x1$2)) {
      var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(propertyTermDeclaration);
      var propertyTerm = new $c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1)
    } else {
      if ((!(x1$2 instanceof $c_s_Some))) {
        throw new $c_s_MatchError().init___O(x1$2)
      };
      var x2 = $as_s_Some(x1$2);
      var value = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var this$8 = value.value$2;
      var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$1 = this.ctx$1;
      var x1$3 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$8, conversion$1, iv$1)).text$3;
      if (((x1$3 === "string") || ((x1$3 === "integer") || ((x1$3 === "float") || ((x1$3 === "double") || ((x1$3 === "long") || ((x1$3 === "boolean") || ((x1$3 === "uri") || ((x1$3 === "any") || ((x1$3 === "time") || ((x1$3 === "date") || (x1$3 === "dateTime")))))))))))) {
        var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(propertyTermDeclaration);
        var propertyTerm = new $c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$2)
      } else {
        var annotations$3 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(propertyTermDeclaration);
        var propertyTerm = new $c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$3)
      }
    }
  };
  var this$13 = propertyTermDeclaration.key$2;
  var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
  var iv$2 = this.ctx$1;
  var propertyTermAlias = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$13, conversion$2, iv$2)).text$3;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().Name$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyTerm, field, propertyTermAlias));
  var jsx$1 = this.ctx$1;
  var this$14 = this.vocabulary$1;
  var this$15 = $as_Lamf_core_model_StrField(this$14.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Base$1));
  var this$16 = this$15.option$1;
  var x1$4 = jsx$1.resolvePropertyTermAlias__T__T__Lorg_yaml_model_YPart__Z__s_Option($as_T((this$16.isEmpty__Z() ? null : this$16.get__O())), propertyTermAlias, propertyTermDeclaration.key$2, false);
  var x$5 = $m_s_None$();
  if ((x$5 === x1$4)) {
    var this$17 = this.ctx$1;
    var node = this.vocabulary$1.id$1;
    var ast = propertyTermDeclaration.key$2;
    $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__missingPropertyTermWarning__T__T__Lorg_yaml_model_YPart__V(this$17, propertyTermAlias, node, ast)
  } else if ((x1$4 instanceof $c_s_Some)) {
    var x2$2 = $as_s_Some(x1$4);
    var id = $as_T(x2$2.value$2);
    propertyTerm.id$1 = id
  } else {
    throw new $c_s_MatchError().init___O(x1$4)
  };
  var this$18 = propertyTermDeclaration.value$2;
  var x1$5 = this$18.tag__Lorg_yaml_model_YTag().tagType$3;
  var x$7 = $m_Lorg_yaml_model_YType$().Null$1;
  if ((!(x$7 === x1$5))) {
    var this$19 = propertyTermDeclaration.value$2;
    var conversion$3 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$3 = this.ctx$1;
    var propertyTermMap = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$19, conversion$3, iv$3));
    var this$20 = this.ctx$1;
    var id$1 = propertyTerm.id$1;
    $f_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularySyntax__closedNode__T__T__Lorg_yaml_model_YMap__V(this$20, "propertyTerm", id$1, propertyTermMap);
    var this$22 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(propertyTermMap);
    var this$23 = this$22.key__T__s_Option("displayName");
    if ((!this$23.isEmpty__Z())) {
      var arg1 = this$23.get__O();
      var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
      var value$1 = new $c_Lamf_core_parser_ValueNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(entry.value$2, this.ctx$1);
      var field$1 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().DisplayName$1;
      var value$2 = value$1.string__Lamf_core_model_domain_AmfScalar();
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(propertyTerm, field$1, value$2)
    };
    var this$25 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(propertyTermMap);
    var this$26 = this$25.key__T__s_Option("description");
    if ((!this$26.isEmpty__Z())) {
      var arg1$1 = this$26.get__O();
      var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
      var value$3 = new $c_Lamf_core_parser_ValueNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(entry$3.value$2, this.ctx$1);
      var field$2 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().Description$1;
      var value$4 = value$3.string__Lamf_core_model_domain_AmfScalar();
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(propertyTerm, field$2, value$4)
    };
    var this$28 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(propertyTermMap);
    var this$29 = this$28.key__T__s_Option("range");
    if ((!this$29.isEmpty__Z())) {
      var arg1$2 = this$29.get__O();
      var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
      var this$30 = entry$4.value$2;
      var conversion$4 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$4 = this.ctx$1;
      var text = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$30, conversion$4, iv$4)).text$3;
      if ((text === "guid")) {
        var this$31 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
        var rangeId = new $c_s_Some().init___O(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$31, "guid").iri__T())
      } else if (((text === "any") || ((text === "uri") || ((text === "string") || ((text === "integer") || ((text === "float") || ((text === "double") || ((text === "long") || ((text === "boolean") || ((text === "time") || ((text === "date") || (text === "dateTime")))))))))))) {
        var rangeId = new $c_s_Some().init___O($m_Lamf_core_model_DataType$().apply__T__T(text))
      } else {
        var jsx$2 = this.ctx$1;
        var this$33 = this.vocabulary$1;
        var this$34 = $as_Lamf_core_model_StrField(this$33.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Base$1));
        var this$35 = this$34.option$1;
        var x1$2$1 = jsx$2.resolveClassTermAlias__T__T__Lorg_yaml_model_YPart__Z__s_Option($as_T((this$35.isEmpty__Z() ? null : this$35.get__O())), text, entry$4.value$2, true);
        if ((x1$2$1 instanceof $c_s_Some)) {
          var x2$1 = $as_s_Some(x1$2$1);
          var classTermId = $as_T(x2$1.value$2);
          var rangeId = new $c_s_Some().init___O(classTermId)
        } else {
          var x$1 = $m_s_None$();
          if ((!(x$1 === x1$2$1))) {
            throw new $c_s_MatchError().init___O(x1$2$1)
          };
          var this$36 = this.ctx$1;
          var node$1 = propertyTerm.id$1;
          var ast$1 = entry$4.value$2;
          $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__missingClassTermWarning__T__T__Lorg_yaml_model_YPart__V(this$36, text, node$1, ast$1);
          var rangeId = $m_s_None$()
        }
      };
      matchEnd6: {
        if ((rangeId instanceof $c_s_Some)) {
          var x2$2$1 = $as_s_Some(rangeId);
          var id$2 = $as_T(x2$2$1.value$2);
          if ((id$2 !== null)) {
            var field$3 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().Range$1;
            $as_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyTerm, field$3, id$2));
            break matchEnd6
          }
        };
        var x$3$1 = $m_s_None$();
        if ((x$3$1 === rangeId)) {
          break matchEnd6
        };
        throw new $c_s_MatchError().init___O(rangeId)
      }
    };
    var this$38 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(propertyTermMap);
    var this$39 = this$38.key__T__s_Option("extends");
    if ((!this$39.isEmpty__Z())) {
      var arg1$3 = this$39.get__O();
      var entry$5 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
      var this$40 = entry$5.value$2;
      var x1$1 = this$40.tag__Lorg_yaml_model_YTag().tagType$3;
      var x$2 = $m_Lorg_yaml_model_YType$().Str$1;
      if ((x$2 === x1$1)) {
        var jsx$3 = $m_sc_Seq$();
        var array = [new $c_Lamf_core_parser_ValueNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(entry$5.value$2, this.ctx$1).string__Lamf_core_model_domain_AmfScalar().toString__T()];
        var refs = $as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
      } else {
        var x$3$2 = $m_Lorg_yaml_model_YType$().Seq$1;
        if ((!(x$3$2 === x1$1))) {
          throw new $c_s_MatchError().init___O(x1$1)
        };
        var jsx$5 = $as_sc_TraversableLike(new $c_Lamf_core_parser_DefaultArrayNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(entry$5.value$2, this.ctx$1).nodes__T2().$$und1__O());
        var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(x$7$2) {
            var x$7$1 = $as_Lorg_yaml_model_YNode(x$7$2);
            var conversion$5 = $m_Lamf_core_parser_package$YScalarYRead$();
            var iv$5 = $this.ctx$1;
            return $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(x$7$1, conversion$5, iv$5)).text$3
          })
        })(this));
        var this$43 = $m_sc_Seq$();
        var refs = $as_sc_Seq(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$4, this$43.ReusableCBFInstance$2))
      };
      var jsx$8 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, entry$1, propertyTerm$1) {
        return (function(term$2) {
          var term = $as_T(term$2);
          var jsx$9 = this$2$1.ctx$1;
          var this$44 = this$2$1.vocabulary$1;
          var this$45 = $as_Lamf_core_model_StrField(this$44.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Base$1));
          var this$46 = this$45.option$1;
          var x1$6 = jsx$9.resolvePropertyTermAlias__T__T__Lorg_yaml_model_YPart__Z__s_Option($as_T((this$46.isEmpty__Z() ? null : this$46.get__O())), term, entry$1.value$2, true);
          if ((x1$6 instanceof $c_s_Some)) {
            var x2$3 = $as_s_Some(x1$6);
            var v = $as_T(x2$3.value$2);
            return new $c_s_Some().init___O(v)
          } else {
            var x$4 = $m_s_None$();
            if ((x$4 === x1$6)) {
              var this$47 = this$2$1.ctx$1;
              var node$2 = propertyTerm$1.id$1;
              var ast$2 = entry$1.value$2;
              $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__missingPropertyTermWarning__T__T__Lorg_yaml_model_YPart__V(this$47, term, node$2, ast$2);
              return $m_s_None$()
            } else {
              throw new $c_s_MatchError().init___O(x1$6)
            }
          }
        })
      })(this, entry$5, propertyTerm));
      var this$48 = $m_sc_Seq$();
      var jsx$7 = $as_sc_TraversableLike($as_sc_TraversableLike(refs.map__F1__scg_CanBuildFrom__O(jsx$8, this$48.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
        return (function(x$8$2) {
          var x$8 = $as_s_Option(x$8$2);
          return x$8.isDefined__Z()
        })
      })(this))));
      var jsx$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
        return (function(x$9$2) {
          var x$9 = $as_s_Option(x$9$2);
          return $as_T(x$9.get__O())
        })
      })(this));
      var this$49 = $m_sc_Seq$();
      var superClasses = $as_sc_Seq(jsx$7.map__F1__scg_CanBuildFrom__O(jsx$6, this$49.ReusableCBFInstance$2));
      var field$4 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().SubPropertyOf$1;
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(propertyTerm, field$4, superClasses)
    }
  };
  this.ctx$1.register__T__Lamf_plugins_document_vocabularies_model_domain_PropertyTerm__V(propertyTermAlias, propertyTerm)
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$1
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesParser.prototype.parsePropertyTerms__Lorg_yaml_model_YMap__V = (function(map) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("propertyTerms");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$1;
    var classDeclarations = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv));
    classDeclarations.entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(propertyTermDeclaration$2) {
        var propertyTermDeclaration = $as_Lorg_yaml_model_YMapEntry(propertyTermDeclaration$2);
        $this.parsePropertyTerm__Lorg_yaml_model_YMapEntry__V(propertyTermDeclaration)
      })
    })(this)))
  }
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext = (function(root, ctx) {
  this.root$1 = root;
  this.ctx$1 = ctx;
  var this$1 = $as_Lamf_core_parser_SyamlParsedDocument(root.parsed$1).document$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  this.map$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, ctx));
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.map$1);
  var this$4 = new $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var location = root.location$1;
  var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
  var this$5 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, location));
  var value = root.location$1;
  this.vocabulary$1 = $as_Lamf_plugins_document_vocabularies_model_document_Vocabulary($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesParser.prototype.parseClassTerms__Lorg_yaml_model_YMap__V = (function(map) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("classTerms");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$1;
    var classDeclarations = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv));
    classDeclarations.entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(classTermDeclaration$2) {
        var classTermDeclaration = $as_Lorg_yaml_model_YMapEntry(classTermDeclaration$2);
        $this.parseClassTerm__Lorg_yaml_model_YMapEntry__V(classTermDeclaration)
      })
    })(this)))
  }
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesParser.prototype.parseClassTerm__Lorg_yaml_model_YMapEntry__V = (function(classTermDeclaration) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(classTermDeclaration);
  var classTerm = new $c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var this$3 = classTermDeclaration.key$2;
  var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
  var iv = this.ctx$1;
  var classTermAlias = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv)).text$3;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().Name$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_ClassTerm($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(classTerm, field, classTermAlias));
  var jsx$1 = this.ctx$1;
  var this$4 = this.vocabulary$1;
  var this$5 = $as_Lamf_core_model_StrField(this$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Base$1));
  var this$6 = this$5.option$1;
  var x1 = jsx$1.resolveClassTermAlias__T__T__Lorg_yaml_model_YPart__Z__s_Option($as_T((this$6.isEmpty__Z() ? null : this$6.get__O())), classTermAlias, classTermDeclaration.key$2, false);
  var x = $m_s_None$();
  if ((x === x1)) {
    var this$7 = this.ctx$1;
    var node = this.vocabulary$1.id$1;
    var ast = classTermDeclaration.key$2;
    $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__missingClassTermWarning__T__T__Lorg_yaml_model_YPart__V(this$7, classTermAlias, node, ast)
  } else if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var id = $as_T(x2.value$2);
    classTerm.id$1 = id
  } else {
    throw new $c_s_MatchError().init___O(x1)
  };
  var this$8 = classTermDeclaration.value$2;
  var x1$2 = this$8.tag__Lorg_yaml_model_YTag().tagType$3;
  var x$3 = $m_Lorg_yaml_model_YType$().Null$1;
  if ((!(x$3 === x1$2))) {
    var this$9 = classTermDeclaration.value$2;
    var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$1 = this.ctx$1;
    var classTermMap = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$9, conversion$1, iv$1));
    var this$10 = this.ctx$1;
    var id$1 = classTerm.id$1;
    $f_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularySyntax__closedNode__T__T__Lorg_yaml_model_YMap__V(this$10, "classTerm", id$1, classTermMap);
    var this$12 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(classTermMap);
    var this$13 = this$12.key__T__s_Option("displayName");
    if ((!this$13.isEmpty__Z())) {
      var arg1 = this$13.get__O();
      var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
      var value = new $c_Lamf_core_parser_ValueNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(entry.value$2, this.ctx$1);
      var field$1 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().DisplayName$1;
      var value$1 = value.string__Lamf_core_model_domain_AmfScalar();
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(classTerm, field$1, value$1)
    };
    var this$15 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(classTermMap);
    var this$16 = this$15.key__T__s_Option("description");
    if ((!this$16.isEmpty__Z())) {
      var arg1$1 = this$16.get__O();
      var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
      var value$2 = new $c_Lamf_core_parser_ValueNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(entry$3.value$2, this.ctx$1);
      var field$2 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().Description$1;
      var value$3 = value$2.string__Lamf_core_model_domain_AmfScalar();
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(classTerm, field$2, value$3)
    };
    var this$18 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(classTermMap);
    var this$19 = this$18.key__T__s_Option("properties");
    if ((!this$19.isEmpty__Z())) {
      var arg1$2 = this$19.get__O();
      var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
      var this$20 = entry$4.value$2;
      var x1$1 = this$20.tag__Lorg_yaml_model_YTag().tagType$3;
      var x$1 = $m_Lorg_yaml_model_YType$().Str$1;
      if ((x$1 === x1$1)) {
        var jsx$2 = $m_sc_Seq$();
        var array = [new $c_Lamf_core_parser_ValueNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(entry$4.value$2, this.ctx$1).string__Lamf_core_model_domain_AmfScalar().toString__T()];
        var refs = $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
      } else {
        var x$3$1 = $m_Lorg_yaml_model_YType$().Seq$1;
        if ((!(x$3$1 === x1$1))) {
          throw new $c_s_MatchError().init___O(x1$1)
        };
        var jsx$4 = $as_sc_TraversableLike(new $c_Lamf_core_parser_DefaultArrayNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(entry$4.value$2, this.ctx$1).nodes__T2().$$und1__O());
        var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(x$1$2) {
            var x$1$1 = $as_Lorg_yaml_model_YNode(x$1$2);
            return x$1$1.value__Lorg_yaml_model_YValue().toString__T()
          })
        })(this));
        var this$23 = $m_sc_Seq$();
        var refs = $as_sc_Seq(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$23.ReusableCBFInstance$2))
      };
      var jsx$7 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, entry$1, classTerm$1) {
        return (function(term$2) {
          var term = $as_T(term$2);
          var jsx$8 = this$2$1.ctx$1;
          var this$24 = this$2$1.vocabulary$1;
          var this$25 = $as_Lamf_core_model_StrField(this$24.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Base$1));
          var this$26 = this$25.option$1;
          var x1$3 = jsx$8.resolvePropertyTermAlias__T__T__Lorg_yaml_model_YPart__Z__s_Option($as_T((this$26.isEmpty__Z() ? null : this$26.get__O())), term, entry$1.value$2, true);
          if ((x1$3 instanceof $c_s_Some)) {
            var x2$1 = $as_s_Some(x1$3);
            var v = $as_T(x2$1.value$2);
            return new $c_s_Some().init___O(v)
          } else {
            var x$2 = $m_s_None$();
            if ((x$2 === x1$3)) {
              var this$27 = this$2$1.ctx$1;
              var node$1 = classTerm$1.id$1;
              var ast$1 = entry$1.value$2;
              $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__missingPropertyTermWarning__T__T__Lorg_yaml_model_YPart__V(this$27, term, node$1, ast$1);
              return $m_s_None$()
            } else {
              throw new $c_s_MatchError().init___O(x1$3)
            }
          }
        })
      })(this, entry$4, classTerm));
      var this$28 = $m_sc_Seq$();
      var jsx$6 = $as_sc_TraversableLike($as_sc_TraversableLike(refs.map__F1__scg_CanBuildFrom__O(jsx$7, this$28.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
        return (function(x$2$2$2) {
          var x$2$2 = $as_s_Option(x$2$2$2);
          return x$2$2.isDefined__Z()
        })
      })(this))));
      var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
        return (function(x$3$2$2) {
          var x$3$2 = $as_s_Option(x$3$2$2);
          return $as_T(x$3$2.get__O())
        })
      })(this));
      var this$29 = $m_sc_Seq$();
      var properties = $as_sc_Seq(jsx$6.map__F1__scg_CanBuildFrom__O(jsx$5, this$29.ReusableCBFInstance$2));
      if (properties.nonEmpty__Z()) {
        var field$3 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().Properties$1;
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(classTerm, field$3, properties)
      }
    };
    var this$31 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(classTermMap);
    var this$32 = this$31.key__T__s_Option("extends");
    if ((!this$32.isEmpty__Z())) {
      var arg1$3 = this$32.get__O();
      var entry$5 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
      var this$33 = entry$5.value$2;
      var x1$4 = this$33.tag__Lorg_yaml_model_YTag().tagType$3;
      var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
      if ((x$4 === x1$4)) {
        var jsx$9 = $m_sc_Seq$();
        var array$1 = [new $c_Lamf_core_parser_ValueNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(entry$5.value$2, this.ctx$1).string__Lamf_core_model_domain_AmfScalar().toString__T()];
        var refs$1 = $as_sc_Seq(jsx$9.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)))
      } else {
        var x$3$3 = $m_Lorg_yaml_model_YType$().Seq$1;
        if ((!(x$3$3 === x1$4))) {
          throw new $c_s_MatchError().init___O(x1$4)
        };
        var jsx$11 = $as_sc_TraversableLike(new $c_Lamf_core_parser_DefaultArrayNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(entry$5.value$2, this.ctx$1).nodes__T2().$$und1__O());
        var jsx$10 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
          return (function(x$4$2$2) {
            var x$4$2 = $as_Lorg_yaml_model_YNode(x$4$2$2);
            return x$4$2.value__Lorg_yaml_model_YValue().toString__T()
          })
        })(this));
        var this$36 = $m_sc_Seq$();
        var refs$1 = $as_sc_Seq(jsx$11.map__F1__scg_CanBuildFrom__O(jsx$10, this$36.ReusableCBFInstance$2))
      };
      var jsx$14 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$2, entry$2, classTerm$1$1) {
        return (function(term$2$1) {
          var term$1 = $as_T(term$2$1);
          var jsx$15 = this$2$2.ctx$1;
          var this$37 = this$2$2.vocabulary$1;
          var this$38 = $as_Lamf_core_model_StrField(this$37.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Base$1));
          var this$39 = this$38.option$1;
          var x1$5 = jsx$15.resolveClassTermAlias__T__T__Lorg_yaml_model_YPart__Z__s_Option($as_T((this$39.isEmpty__Z() ? null : this$39.get__O())), term$1, entry$2.value$2, true);
          if ((x1$5 instanceof $c_s_Some)) {
            var x2$2 = $as_s_Some(x1$5);
            var v$1 = $as_T(x2$2.value$2);
            return new $c_s_Some().init___O(v$1)
          } else {
            var x$5 = $m_s_None$();
            if ((x$5 === x1$5)) {
              var this$40 = this$2$2.ctx$1;
              var node$2 = classTerm$1$1.id$1;
              var ast$2 = entry$2.value$2;
              $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__missingClassTermWarning__T__T__Lorg_yaml_model_YPart__V(this$40, term$1, node$2, ast$2);
              return $m_s_None$()
            } else {
              throw new $c_s_MatchError().init___O(x1$5)
            }
          }
        })
      })(this, entry$5, classTerm));
      var this$41 = $m_sc_Seq$();
      var jsx$13 = $as_sc_TraversableLike($as_sc_TraversableLike(refs$1.map__F1__scg_CanBuildFrom__O(jsx$14, this$41.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$2) {
        return (function(x$5$2) {
          var x$5$1 = $as_s_Option(x$5$2);
          return x$5$1.isDefined__Z()
        })
      })(this))));
      var jsx$12 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$2) {
        return (function(x$6$2) {
          var x$6 = $as_s_Option(x$6$2);
          return $as_T(x$6.get__O())
        })
      })(this));
      var this$42 = $m_sc_Seq$();
      var superClasses = $as_sc_Seq(jsx$13.map__F1__scg_CanBuildFrom__O(jsx$12, this$42.ReusableCBFInstance$2));
      var field$4 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().SubClassOf$1;
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(classTerm, field$4, superClasses)
    }
  };
  this.ctx$1.register__T__Lamf_plugins_document_vocabularies_model_domain_ClassTerm__V(classTermAlias, classTerm)
});
var $d_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesParser = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesParser: 0
}, false, "amf.plugins.document.vocabularies.parser.vocabularies.VocabulariesParser", {
  Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesParser: 1,
  O: 1,
  Lamf_core_parser_BaseSpecParser: 1
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesParser.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesParser;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations() {
  $c_Lamf_core_parser_Declarations.call(this);
  this.externals$2 = null;
  this.classTerms$2 = null;
  this.propertyTerms$2 = null;
  this.usedVocabs$2 = null;
  this.errorHandler$2 = null
}
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations.prototype = new $h_Lamf_core_parser_Declarations();
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations.prototype = $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations.prototype;
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations.prototype.getOrCreateLibrary__T__Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations = (function(alias) {
  var x1 = this.libraries$1.get__O__s_Option(alias);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var lib = $as_Lamf_core_parser_Declarations(x2.value$2);
    if ((lib instanceof $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations)) {
      var x3 = $as_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations(lib);
      return x3
    }
  };
  var x$1 = this.errorHandler$2;
  var x$2 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
  var x$3 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$4 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$5 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$6 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$7 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var result = new $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations().init___sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations(x$3, x$4, x$5, x$6, x$7, x$1, x$2);
  this.libraries$1 = this.libraries$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(alias, result));
  return result
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations.prototype.init___sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations = (function(externals, classTerms, propertyTerms, usedVocabs, libs, errorHandler, futureDeclarations) {
  this.externals$2 = externals;
  this.classTerms$2 = classTerms;
  this.propertyTerms$2 = propertyTerms;
  this.usedVocabs$2 = usedVocabs;
  this.errorHandler$2 = errorHandler;
  $c_Lamf_core_parser_Declarations.prototype.init___sci_Map__sci_Map__sci_Map__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations.call(this, libs, $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())), errorHandler, futureDeclarations);
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations.prototype.registerTerm__Lamf_plugins_document_vocabularies_model_domain_PropertyTerm__V = (function(term) {
  var this$1 = $as_Lamf_core_model_StrField(term.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().Name$1));
  var this$2 = this$1.option$1;
  var thiz = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  if ((!($uI(thiz.indexOf(".")) !== (-1)))) {
    var jsx$1 = this.propertyTerms$2;
    var this$6 = $as_Lamf_core_model_StrField(term.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().Name$1));
    var this$7 = this$6.option$1;
    var self = $as_T((this$7.isEmpty__Z() ? null : this$7.get__O()));
    this.propertyTerms$2 = jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, term))
  }
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations.prototype.getPropertyTermId__T__s_Option = (function(alias) {
  var x1 = this.propertyTerms$2.get__O__s_Option(alias);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var pt = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm(x2.value$2);
    return new $c_s_Some().init___O(pt.id$1)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return $m_s_None$()
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations.prototype.registerTerm__Lamf_plugins_document_vocabularies_model_domain_ClassTerm__V = (function(term) {
  var this$1 = $as_Lamf_core_model_StrField(term.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().Name$1));
  var this$2 = this$1.option$1;
  var thiz = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  if ((!($uI(thiz.indexOf(".")) !== (-1)))) {
    var jsx$1 = this.classTerms$2;
    var this$6 = $as_Lamf_core_model_StrField(term.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().Name$1));
    var this$7 = this$6.option$1;
    var self = $as_T((this$7.isEmpty__Z() ? null : this$7.get__O()));
    this.classTerms$2 = jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, term))
  }
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations.prototype.getClassTermId__T__s_Option = (function(alias) {
  var x1 = this.classTerms$2.get__O__s_Option(alias);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var ct = $as_Lamf_plugins_document_vocabularies_model_domain_ClassTerm(x2.value$2);
    return new $c_s_Some().init___O(ct.id$1)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return $m_s_None$()
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations.prototype.registerUsedVocabulary__T__Lamf_plugins_document_vocabularies_model_document_Vocabulary__V = (function(alias, vocab) {
  this.usedVocabs$2 = this.usedVocabs$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(alias, vocab))
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations.prototype.resolveExternalNamespace__s_Option__T__s_util_Try = (function(prefix, suffix) {
  if ((prefix instanceof $c_s_Some)) {
    var x2 = $as_s_Some(prefix);
    var prefixString = $as_T(x2.value$2);
    var x1$2 = this.resolveExternal__T__s_Option(((prefixString + ".") + suffix));
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var resolvedPrefix = $as_T(x2$2.value$2);
      return new $c_s_util_Success().init___O(resolvedPrefix)
    } else {
      return new $c_s_util_Failure().init___jl_Throwable(new $c_jl_Exception().init___T(("Cannot resolve external prefix " + prefixString)))
    }
  } else {
    var this$1 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
    return new $c_s_util_Success().init___O(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, suffix).iri__T())
  }
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations.prototype.resolveExternal__T__s_Option = (function(key) {
  if (($uI(key.indexOf(".")) !== (-1))) {
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(key, "\\.", 0);
    var this$6 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    var prefix = $as_T($f_sc_IndexedSeqOptimized__head__O(this$6));
    var xs$1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(key, "\\.", 0);
    var this$9 = new $c_scm_ArrayOps$ofRef().init___AO(xs$1);
    var value = $as_T($f_sc_IndexedSeqOptimized__last__O(this$9));
    var this$10 = this.externals$2.get__O__s_Option(prefix);
    if (this$10.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1 = this$10.get__O();
      var external = $as_Lamf_plugins_document_vocabularies_model_domain_External(arg1);
      var this$11 = $as_Lamf_core_model_StrField(external.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().Base$1));
      var this$12 = this$11.option$1;
      return new $c_s_Some().init___O((("" + $as_T((this$12.isEmpty__Z() ? null : this$12.get__O()))) + value))
    }
  } else {
    return $m_s_None$()
  }
});
function $as_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.parser.vocabularies.VocabularyDeclarations"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.parser.vocabularies.VocabularyDeclarations;", depth))
}
var $d_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations: 0
}, false, "amf.plugins.document.vocabularies.parser.vocabularies.VocabularyDeclarations", {
  Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations: 1,
  Lamf_core_parser_Declarations: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstancePatchResolutionPipeline() {
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.call(this);
  this.steps$2 = null
}
$c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstancePatchResolutionPipeline.prototype = new $h_Lamf_core_resolution_pipelines_ResolutionPipeline();
$c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstancePatchResolutionPipeline.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstancePatchResolutionPipeline;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstancePatchResolutionPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstancePatchResolutionPipeline.prototype = $c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstancePatchResolutionPipeline.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstancePatchResolutionPipeline.prototype.steps__sc_Seq = (function() {
  return this.steps$2
});
$c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstancePatchResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(eh) {
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, eh);
  var jsx$1 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectInstanceReferencesResolutionStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_core_resolution_stages_CleanReferencesStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_core_resolution_stages_DeclarationsRemovalStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1)];
  this.steps$2 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
var $d_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstancePatchResolutionPipeline = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstancePatchResolutionPipeline: 0
}, false, "amf.plugins.document.vocabularies.resolution.pipelines.DialectInstancePatchResolutionPipeline", {
  Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstancePatchResolutionPipeline: 1,
  Lamf_core_resolution_pipelines_ResolutionPipeline: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstancePatchResolutionPipeline.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstancePatchResolutionPipeline;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstanceResolutionPipeline() {
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.call(this);
  this.steps$2 = null
}
$c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstanceResolutionPipeline.prototype = new $h_Lamf_core_resolution_pipelines_ResolutionPipeline();
$c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstanceResolutionPipeline.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstanceResolutionPipeline;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstanceResolutionPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstanceResolutionPipeline.prototype = $c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstanceResolutionPipeline.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstanceResolutionPipeline.prototype.steps__sc_Seq = (function() {
  return this.steps$2
});
$c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstanceResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(eh) {
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, eh);
  var jsx$1 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectInstanceReferencesResolutionStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_core_resolution_stages_CleanReferencesStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_core_resolution_stages_DeclarationsRemovalStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1)];
  this.steps$2 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
var $d_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstanceResolutionPipeline = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstanceResolutionPipeline: 0
}, false, "amf.plugins.document.vocabularies.resolution.pipelines.DialectInstanceResolutionPipeline", {
  Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstanceResolutionPipeline: 1,
  Lamf_core_resolution_pipelines_ResolutionPipeline: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstanceResolutionPipeline.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstanceResolutionPipeline;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectResolutionPipeline() {
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.call(this);
  this.steps$2 = null
}
$c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectResolutionPipeline.prototype = new $h_Lamf_core_resolution_pipelines_ResolutionPipeline();
$c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectResolutionPipeline.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectResolutionPipeline;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectResolutionPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectResolutionPipeline.prototype = $c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectResolutionPipeline.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectResolutionPipeline.prototype.steps__sc_Seq = (function() {
  return this.steps$2
});
$c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(eh) {
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, eh);
  var jsx$1 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectNodeExtensionStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1)];
  this.steps$2 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
var $d_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectResolutionPipeline = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_pipelines_DialectResolutionPipeline: 0
}, false, "amf.plugins.document.vocabularies.resolution.pipelines.DialectResolutionPipeline", {
  Lamf_plugins_document_vocabularies_resolution_pipelines_DialectResolutionPipeline: 1,
  Lamf_core_resolution_pipelines_ResolutionPipeline: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectResolutionPipeline.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectResolutionPipeline;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectInstanceReferencesResolutionStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this);
  this.model$2 = null;
  this.modelResolver$2 = null;
  this.mutuallyRecursive$2 = null
}
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectInstanceReferencesResolutionStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectInstanceReferencesResolutionStage.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectInstanceReferencesResolutionStage;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_stages_DialectInstanceReferencesResolutionStage() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_stages_DialectInstanceReferencesResolutionStage.prototype = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectInstanceReferencesResolutionStage.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectInstanceReferencesResolutionStage.prototype.transform__Lamf_core_model_domain_DomainElement__Z__s_Option = (function(element, isCycle) {
  var rc5 = false;
  var x2 = null;
  if ($is_Lamf_core_model_domain_Linkable(element)) {
    rc5 = true;
    x2 = element;
    var this$1 = $as_Lamf_core_model_domain_Linkable(x2);
    if (($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1).isDefined__Z() && (!isCycle))) {
      var this$2 = $as_Lamf_core_model_domain_Linkable(x2);
      return new $c_s_Some().init___O(this.resolveLinked__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2).get__O())))
    }
  };
  if (rc5) {
    var this$3 = $as_Lamf_core_model_domain_Linkable(x2);
    var jsx$1 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$3).isDefined__Z()
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return new $c_s_Some().init___O(x2)
  };
  return new $c_s_Some().init___O(element)
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectInstanceReferencesResolutionStage.prototype.resolveLinked__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement = (function(element) {
  if (this.mutuallyRecursive$2.contains__O__Z(element.id__T())) {
    return element
  } else {
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var nested = new $c_Lamf_plugins_document_vocabularies_model_document_DialectInstance().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
    nested.fields$1.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_core_metamodel_document_DocumentModel$().Encodes$1, element, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
    var jsx$5 = new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectInstanceReferencesResolutionStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1);
    var jsx$4 = this.modelResolver$2;
    var jsx$3 = this.mutuallyRecursive$2;
    var jsx$2 = $m_sc_Seq$();
    var array = [element.id__T()];
    var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$8 = $m_sc_Seq$();
    var result = jsx$5.recursiveResolveInvocation__Lamf_core_model_document_BaseUnit__s_Option__sc_Seq__Lamf_core_model_document_BaseUnit(nested, jsx$4, $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$8.ReusableCBFInstance$2)));
    var this$9 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstance(result);
    return $as_Lamf_core_model_domain_DomainElement(this$9.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().Encodes$1))
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectInstanceReferencesResolutionStage.prototype.recursiveResolveInvocation__Lamf_core_model_document_BaseUnit__s_Option__sc_Seq__Lamf_core_model_document_BaseUnit = (function(model, modelResolver, mutuallyRecursive) {
  this.mutuallyRecursive$2 = mutuallyRecursive;
  this.model$2 = new $c_s_Some().init___O(model);
  this.modelResolver$2 = new $c_s_Some().init___O((modelResolver.isEmpty__Z() ? new $c_Lamf_core_resolution_stages_helpers_ModelReferenceResolver().init___Lamf_core_model_document_BaseUnit(model) : modelResolver.get__O()));
  return model.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit($m_Lamf_core_resolution_stages_selectors_LinkSelector$(), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$2) {
    return (function(element$2, isCycle$2) {
      var element = $as_Lamf_core_model_domain_DomainElement(element$2);
      var isCycle = $uZ(isCycle$2);
      return this$2.transform__Lamf_core_model_domain_DomainElement__Z__s_Option(element, isCycle)
    })
  })(this)), this.errorHandler$1)
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectInstanceReferencesResolutionStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  this.model$2 = new $c_s_Some().init___O(model);
  this.modelResolver$2 = new $c_s_Some().init___O(new $c_Lamf_core_resolution_stages_helpers_ModelReferenceResolver().init___Lamf_core_model_document_BaseUnit(model));
  return model.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit($m_Lamf_core_resolution_stages_selectors_LinkSelector$(), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(element$2, isCycle$2) {
      var element = $as_Lamf_core_model_domain_DomainElement(element$2);
      var isCycle = $uZ(isCycle$2);
      return $this.transform__Lamf_core_model_domain_DomainElement__Z__s_Option(element, isCycle)
    })
  })(this)), this.errorHandler$1)
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectInstanceReferencesResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  this.model$2 = $m_s_None$();
  this.modelResolver$2 = $m_s_None$();
  this.mutuallyRecursive$2 = $m_sci_Nil$();
  return this
});
var $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectInstanceReferencesResolutionStage = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_stages_DialectInstanceReferencesResolutionStage: 0
}, false, "amf.plugins.document.vocabularies.resolution.stages.DialectInstanceReferencesResolutionStage", {
  Lamf_plugins_document_vocabularies_resolution_stages_DialectInstanceReferencesResolutionStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectInstanceReferencesResolutionStage.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectInstanceReferencesResolutionStage;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectNodeExtensionStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectNodeExtensionStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectNodeExtensionStage.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectNodeExtensionStage;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_stages_DialectNodeExtensionStage() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_stages_DialectNodeExtensionStage.prototype = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectNodeExtensionStage.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectNodeExtensionStage.prototype.mergeNode__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMapping = (function(nodeMapping) {
  var x1 = $as_sc_Seq(nodeMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field()));
  matchEnd6: {
    if ((x1 instanceof $c_sci_$colon$colon)) {
      var x2 = $as_sci_$colon$colon(x1);
      var superNodeMapping = $as_Lamf_core_model_domain_DomainElement(x2.head$5);
      if ((superNodeMapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
        var x4 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(superNodeMapping);
        var superMerged = this.mergeNode__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x4);
        var x1$2 = $as_Lamf_core_model_StrField(superMerged.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().IdTemplate$1)).option$1;
        if ((x1$2 instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(x1$2);
          var idTemplate = $as_T(x2$2.value$2);
          var x1$3 = $as_Lamf_core_model_StrField(nodeMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().IdTemplate$1)).option$1;
          var x = $m_s_None$();
          if ((x === x1$3)) {
            var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().IdTemplate$1;
            $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(nodeMapping, field, idTemplate))
          }
        };
        var merged = this.mergeNodeMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMapping(nodeMapping, superMerged);
        var jsx$1 = $m_sc_Seq$();
        var array = [x4.id$1];
        var ids = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
        var field$1 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().ResolvedExtends$1;
        $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(merged, field$1, ids));
        merged.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().Extends__Lamf_core_metamodel_Field());
        break matchEnd6
      }
    }
  };
  return nodeMapping
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectNodeExtensionStage.prototype.mergeNodeMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMapping = (function(nodeMapping, superMerged) {
  var acc = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  $as_sc_Seq(nodeMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, acc$1) {
    return (function(prop$2) {
      var prop = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(prop$2);
      var this$1 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
      var this$2 = this$1.option$1;
      var self = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
      return $as_scm_Map(acc$1.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(self, prop)))
    })
  })(this, acc)));
  $as_sc_Seq(superMerged.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, acc$2) {
    return (function(property$2) {
      var property = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(property$2);
      var this$5 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
      var this$6 = this$5.option$1;
      var x1 = acc$2.get__O__s_Option($as_T((this$6.isEmpty__Z() ? null : this$6.get__O())));
      if ((x1 instanceof $c_s_Some)) {
        return (void 0)
      } else {
        var x = $m_s_None$();
        if ((x === x1)) {
          var this$7 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
          var this$8 = this$7.option$1;
          var self$1 = $as_T((this$8.isEmpty__Z() ? null : this$8.get__O()));
          var jsx$1 = property.fields$1.copy__Lamf_core_parser_Fields();
          var this$10 = property.annotations$1;
          var this$11 = new $c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(jsx$1, $m_Lamf_core_parser_Annotations$().apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(this$10));
          var value = property.id$1;
          var y = $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$11, value);
          return acc$2.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(self$1, y))
        } else {
          throw new $c_s_MatchError().init___O(x1)
        }
      }
    })
  })(this, acc)));
  var props = acc.values__sc_Iterable().toList__sci_List();
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1;
  return $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(nodeMapping, field, props))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectNodeExtensionStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  if ($is_Lamf_core_model_document_DeclaresModel(model)) {
    $as_Lamf_core_model_document_DeclaresModel(model).declares__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_model_domain_DomainElement(x0$1$2);
        if ((x0$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
          var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x0$1);
          return $this.mergeNode__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x2)
        } else {
          return (void 0)
        }
      })
    })(this)))
  };
  return model
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectNodeExtensionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectNodeExtensionStage = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_stages_DialectNodeExtensionStage: 0
}, false, "amf.plugins.document.vocabularies.resolution.stages.DialectNodeExtensionStage", {
  Lamf_plugins_document_vocabularies_resolution_stages_DialectNodeExtensionStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectNodeExtensionStage.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectNodeExtensionStage;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype.findPropertyMappingMergePolicy__p2__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T = (function(property) {
  var this$1 = $f_Lamf_plugins_document_vocabularies_model_domain_MergeableMapping__mergePolicy__Lamf_core_model_StrField(property).option$1;
  return $as_T((this$1.isEmpty__Z() ? "update" : this$1.get__O()))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype.patchNodeDelete__p2__s_Option__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option = (function(targetNode, targetLocation, patchNode, patchLocation) {
  return ((targetNode.isDefined__Z() && this.sameNodeIdentity__p2__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__Z($as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(targetNode.get__O()), targetLocation, patchNode, patchLocation)) ? $m_s_None$() : targetNode)
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype.patchObjectProperty__p2__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Value__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__T__V = (function(targetNode, patchField, patchValue, propertyMapping, targetLocation, patchLocation) {
  var x1 = patchValue.value$1;
  if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x1);
    var targetNodeValue = targetNode.fields$1.$$qmark__Lamf_core_metamodel_Field__s_Option(patchField);
    var x1$2 = this.patchNode__p2__s_Option__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(targetNodeValue, targetLocation, x2, patchLocation);
    matchEnd5: {
      if ((x1$2 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$2);
        var mergedNode = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2$2.value$2);
        if ((mergedNode !== null)) {
          targetNode.graph__Lamf_core_model_domain_Graph().patchObj__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfObject__V(patchField, mergedNode);
          break matchEnd5
        }
      };
      targetNode.graph__Lamf_core_model_domain_Graph().removeField__T__Lamf_core_model_domain_Graph(patchField.value$1.iri__T())
    }
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype.patchProperty__p2__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Value__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__T__V = (function(targetNode, patchField, patchValue, propertyMapping, targetLocation, patchLocation) {
  var x1 = propertyMapping.classification__Lamf_plugins_document_vocabularies_model_domain_PropertyClassification();
  var x = $m_Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$();
  if ((x === x1)) {
    this.patchLiteralProperty__p2__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Value__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__T__V(targetNode, patchField, patchValue, propertyMapping, targetLocation, patchLocation)
  } else {
    var x$3 = $m_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$();
    if ((x$3 === x1)) {
      this.patchLiteralCollectionProperty__p2__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Value__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__T__V(targetNode, patchField, patchValue, propertyMapping, targetLocation, patchLocation)
    } else {
      var x$5 = $m_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$();
      if ((x$5 === x1)) {
        this.patchObjectProperty__p2__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Value__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__T__V(targetNode, patchField, patchValue, propertyMapping, targetLocation, patchLocation)
      } else {
        var x$7 = $m_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$();
        if ((x$7 === x1)) {
          var jsx$1 = true
        } else {
          var x$9 = $m_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$();
          if ((x$9 === x1)) {
            var jsx$1 = true
          } else {
            var x$11 = $m_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$();
            var jsx$1 = (x$11 === x1)
          }
        };
        if (jsx$1) {
          this.patchObjectCollectionProperty__p2__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Value__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__T__V(targetNode, patchField, patchValue, propertyMapping, targetLocation, patchLocation)
        }
      }
    }
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype.applyPatch__p2__Lamf_plugins_document_vocabularies_model_document_DialectInstance__Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch__Lamf_plugins_document_vocabularies_model_document_DialectInstance = (function(target, patch) {
  var x1 = this.patchNode__p2__s_Option__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(new $c_s_Some().init___O($as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_Lamf_core_model_domain_DomainElement(target.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().Encodes$1)))), $as_T($f_Lamf_core_model_document_BaseUnit__location__s_Option(target).get__O()), $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_Lamf_core_model_domain_DomainElement(patch.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().Encodes$1))), $as_T($f_Lamf_core_model_document_BaseUnit__location__s_Option(patch).get__O()));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var patchedDialectElement = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2.value$2);
    var field = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
    return $as_Lamf_plugins_document_vocabularies_model_document_DialectInstance($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(target, field, patchedDialectElement)))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      target.fields$1.remove__T__Lamf_core_parser_Fields($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().Encodes$1.value$1.iri__T());
      return target
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype.patchLiteralProperty__p2__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Value__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__T__V = (function(targetNode, patchField, patchValue, propertyMapping, targetLocation, patchLocation) {
  var x1 = this.findPropertyMappingMergePolicy__p2__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T(propertyMapping);
  if ((x1 === "insert")) {
    var this$1 = targetNode.graph__Lamf_core_model_domain_Graph();
    var jsx$1 = (!this$1.properties__sc_Seq().contains__O__Z(patchField.value$1.iri__T()))
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    targetNode.graph__Lamf_core_model_domain_Graph().patchField__Lamf_core_metamodel_Field__Lamf_core_parser_Value__V(patchField, patchValue)
  } else {
    if ((x1 === "delete")) {
      var this$2 = targetNode.graph__Lamf_core_model_domain_Graph();
      var jsx$2 = this$2.properties__sc_Seq().contains__O__Z(patchField.value$1.iri__T())
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      try {
        if ($m_sr_BoxesRunTime$().equals__O__O__Z($as_Lamf_core_model_domain_AmfScalar(targetNode.fields$1.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value(patchField).value$1).value$1, $as_Lamf_core_model_domain_AmfScalar(patchValue.value$1).value$1)) {
          targetNode.graph__Lamf_core_model_domain_Graph().removeField__T__Lamf_core_model_domain_Graph(patchField.value$1.iri__T())
        }
      } catch (e) {
        var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
        if ((!(e$2 instanceof $c_jl_Exception))) {
          throw e
        }
      }
    } else {
      if ((x1 === "update")) {
        var this$3 = targetNode.graph__Lamf_core_model_domain_Graph();
        var jsx$3 = this$3.properties__sc_Seq().contains__O__Z(patchField.value$1.iri__T())
      } else {
        var jsx$3 = false
      };
      if (jsx$3) {
        targetNode.graph__Lamf_core_model_domain_Graph().patchField__Lamf_core_metamodel_Field__Lamf_core_parser_Value__V(patchField, patchValue)
      } else if ((x1 === "upsert")) {
        targetNode.graph__Lamf_core_model_domain_Graph().patchField__Lamf_core_metamodel_Field__Lamf_core_parser_Value__V(patchField, patchValue)
      } else if ((x1 !== "ignore")) {
        if ((x1 === "fail")) {
          var this$4 = this.errorHandler$1;
          var specification = $m_Lamf_validation_DialectValidations$().InvalidDialectPatch$1;
          var node = targetNode.id$1;
          var property = $m_s_None$();
          var message = (("Property " + patchField.value$1.iri__T()) + " cannot be patched");
          var lexical = targetNode.fields$1.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value(patchField).annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
          var location = $m_s_None$();
          this$4.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
        }
      }
    }
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype.patchNodeInsert__p2__s_Option__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option = (function(targetNode, targetLocation, patchNode, patchLocation) {
  return (targetNode.isEmpty__Z() ? new $c_s_Some().init___O(patchNode) : targetNode)
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype.findTarget__p2__Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch__s_Option = (function(patch) {
  var x1 = $as_Lamf_core_model_StrField(patch.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$().Extends$1)).option$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var id = $as_T(x2.value$2);
    if ($f_Lamf_core_model_document_BaseUnit__location__s_Option(patch).isDefined__Z()) {
      var x1$2 = $as_sc_Seq(patch.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().References$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, id$1) {
        return (function(u$2) {
          var u = $as_Lamf_core_model_document_BaseUnit(u$2);
          return ((u instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstance) && $m_sjsr_RuntimeString$().endsWith__T__T__Z($as_T($f_Lamf_core_model_document_BaseUnit__location__s_Option(u).get__O()), id$1))
        })
      })(this, id)));
      if ((x1$2 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$2);
        var d = $as_Lamf_core_model_document_BaseUnit(x2$2.value$2);
        if ((d instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstance)) {
          var x3 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstance(d);
          if ($f_Lamf_core_model_document_BaseUnit__location__s_Option(x3).isDefined__Z()) {
            return new $c_s_Some().init___O(x3)
          }
        }
      };
      return $m_s_None$()
    }
  };
  return $m_s_None$()
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype.findNodeMergePolicy__p2__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T = (function(element) {
  var this$1 = element.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping();
  var this$2 = $f_Lamf_plugins_document_vocabularies_model_domain_MergeableMapping__mergePolicy__Lamf_core_model_StrField(this$1).option$1;
  return $as_T((this$2.isEmpty__Z() ? "update" : this$2.get__O()))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype.resolvePatch__p2__Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch__Lamf_core_model_document_BaseUnit = (function(patch) {
  var x1 = this.findTarget__p2__Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch__s_Option(patch);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var target = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstance(x2.value$2);
    if ((target !== null)) {
      return this.applyPatch__p2__Lamf_plugins_document_vocabularies_model_document_DialectInstance__Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch__Lamf_plugins_document_vocabularies_model_document_DialectInstance(target, patch)
    }
  };
  return patch
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype.patchLiteralCollectionProperty__p2__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Value__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__T__V = (function(targetNode, patchField, patchValue, propertyMapping, targetLocation, patchLocation) {
  var rc5 = false;
  var x2 = null;
  var this$1 = targetNode.fields$1;
  var x1 = this$1.fs$1.get__O__s_Option(patchField);
  matchEnd6: {
    var targetPropertyValueSeq;
    if ((x1 instanceof $c_s_Some)) {
      rc5 = true;
      x2 = $as_s_Some(x1);
      var v = $as_Lamf_core_parser_Value(x2.value$2);
      if ((v.value$1 instanceof $c_Lamf_core_model_domain_AmfArray)) {
        var targetPropertyValueSeq = $as_Lamf_core_model_domain_AmfArray(v.value$1).values$1;
        break matchEnd6
      }
    };
    if (rc5) {
      var v$2 = $as_Lamf_core_parser_Value(x2.value$2);
      var jsx$1 = $m_sc_Seq$();
      var array = [v$2.value$1];
      var targetPropertyValueSeq = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
      break matchEnd6
    };
    var targetPropertyValueSeq = $m_sci_Nil$()
  };
  var targetPropertyValue = $as_sci_Set($m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable(targetPropertyValueSeq));
  var x1$2 = patchValue.value$1;
  if ((x1$2 instanceof $c_Lamf_core_model_domain_AmfArray)) {
    var x2$2 = $as_Lamf_core_model_domain_AmfArray(x1$2);
    var patchPropertyValueSeq = x2$2.values$1
  } else {
    var jsx$2 = $m_sc_Seq$();
    var array$1 = [x1$2];
    var patchPropertyValueSeq = $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)))
  };
  var patchPropertyValue = $as_sci_Set($m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable(patchPropertyValueSeq));
  var x1$3 = this.findPropertyMappingMergePolicy__p2__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T(propertyMapping);
  if ((x1$3 === "insert")) {
    targetNode.graph__Lamf_core_model_domain_Graph().patchSeqField__Lamf_core_metamodel_Field__sc_Seq__V(patchField, targetPropertyValue.union__sc_GenSet__sc_Set(patchPropertyValue).toSeq__sc_Seq())
  } else if ((x1$3 === "delete")) {
    targetNode.graph__Lamf_core_model_domain_Graph().patchSeqField__Lamf_core_metamodel_Field__sc_Seq__V(patchField, targetPropertyValue.diff__sc_GenSet__sc_Set(patchPropertyValue).toSeq__sc_Seq())
  } else if ((x1$3 === "update")) {
    targetNode.graph__Lamf_core_model_domain_Graph().patchSeqField__Lamf_core_metamodel_Field__sc_Seq__V(patchField, $f_sc_SetLike__toSeq__sc_Seq(patchPropertyValue))
  } else if ((x1$3 === "upsert")) {
    targetNode.graph__Lamf_core_model_domain_Graph().patchSeqField__Lamf_core_metamodel_Field__sc_Seq__V(patchField, targetPropertyValue.union__sc_GenSet__sc_Set(patchPropertyValue).toSeq__sc_Seq())
  } else if ((x1$3 !== "ignore")) {
    if ((x1$3 === "fail")) {
      var this$6 = this.errorHandler$1;
      var specification = $m_Lamf_validation_DialectValidations$().InvalidDialectPatch$1;
      var node = targetNode.id$1;
      var property = $m_s_None$();
      var message = (("Property " + patchField.value$1.iri__T()) + " cannot be patched");
      var lexical = patchValue.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      var location = $m_s_None$();
      this$6.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype.patchNodeUpdate__p2__s_Option__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option = (function(targetNode, targetLocation, patchNode, patchLocation) {
  var nodeMapping = patchNode.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping();
  if ((targetNode.isDefined__Z() && this.sameNodeIdentity__p2__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__Z($as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(targetNode.get__O()), targetLocation, patchNode, patchLocation))) {
    var this$1 = patchNode.meta__Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel().fields$1;
    var these = this$1;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      var patchField = $as_Lamf_core_metamodel_Field(arg1);
      var this$2 = patchNode.fields$1;
      var x1 = this$2.fs$1.get__O__s_Option(patchField);
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var fieldValue = $as_Lamf_core_parser_Value(x2.value$2);
        var x1$2 = $as_sc_Seq(nodeMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, patchField$1) {
          return (function(x$2$2) {
            var x$2 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$2$2);
            var this$3 = $as_Lamf_core_model_StrField(x$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
            var this$4 = this$3.option$1;
            return ($as_T((this$4.isEmpty__Z() ? null : this$4.get__O())) === patchField$1.value$1.iri__T())
          })
        })(this, patchField)));
        if ((x1$2 instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(x1$2);
          var propertyMapping = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x2$2.value$2);
          this.patchProperty__p2__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Value__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__T__V($as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(targetNode.get__O()), patchField, fieldValue, propertyMapping, targetLocation, patchLocation)
        }
      };
      these = $as_sci_List(these.tail__O())
    }
  };
  return targetNode
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype.patchNodeUpsert__p2__s_Option__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option = (function(targetNode, targetLocation, patchNode, patchLocation) {
  return (targetNode.isEmpty__Z() ? this.patchNodeInsert__p2__s_Option__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(targetNode, targetLocation, patchNode, patchLocation) : this.patchNodeUpdate__p2__s_Option__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(targetNode, targetLocation, patchNode, patchLocation))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  if ((model instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch(model);
    return this.resolvePatch__p2__Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch__Lamf_core_model_document_BaseUnit(x2)
  } else {
    return model
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype.sameNodeIdentity__p2__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__Z = (function(target, targetLocation, patchNode, patchLocation) {
  var id = target.id$1;
  var jsx$1 = $as_T(id.split(targetLocation).join(""));
  var id$1 = patchNode.id$1;
  return (jsx$1 === $as_T(id$1.split(patchLocation).join("")))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype.patchNode__p2__s_Option__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option = (function(targetNode, targetLocation, patchNode, patchLocation) {
  var x1 = this.findNodeMergePolicy__p2__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T(patchNode);
  if ((x1 === "insert")) {
    return this.patchNodeInsert__p2__s_Option__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(targetNode, targetLocation, patchNode, patchLocation)
  } else if ((x1 === "delete")) {
    return this.patchNodeDelete__p2__s_Option__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(targetNode, targetLocation, patchNode, patchLocation)
  } else if ((x1 === "update")) {
    return this.patchNodeUpdate__p2__s_Option__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(targetNode, targetLocation, patchNode, patchLocation)
  } else if ((x1 === "upsert")) {
    return this.patchNodeUpsert__p2__s_Option__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(targetNode, targetLocation, patchNode, patchLocation)
  } else if ((x1 === "ignore")) {
    return targetNode
  } else if ((x1 === "fail")) {
    var this$3 = this.errorHandler$1;
    var specification = $m_Lamf_validation_DialectValidations$().InvalidDialectPatch$1;
    var node = patchNode.id$1;
    var property = $m_s_None$();
    var this$2 = patchNode.meta__Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel().type$1;
    var f = (function($this) {
      return (function(x$1$2) {
        var x$1 = $as_Lamf_core_vocabulary_ValueType(x$1$2);
        return x$1.iri__T()
      })
    })(this);
    var this$1 = $m_sci_List$();
    var bf = this$1.ReusableCBFInstance$2;
    if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
      if ((this$2 === $m_sci_Nil$())) {
        var jsx$1 = $m_sci_Nil$()
      } else {
        var arg1 = this$2.head__O();
        var h = new $c_sci_$colon$colon().init___O__sci_List(f(arg1), $m_sci_Nil$());
        var t = h;
        var rest = $as_sci_List(this$2.tail__O());
        while ((rest !== $m_sci_Nil$())) {
          var arg1$1 = rest.head__O();
          var nx = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$1), $m_sci_Nil$());
          t.tl$5 = nx;
          t = nx;
          rest = $as_sci_List(rest.tail__O())
        };
        var jsx$1 = h
      }
    } else {
      var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$2, bf);
      var these = this$2;
      while ((!these.isEmpty__Z())) {
        var arg1$2 = these.head__O();
        b.$$plus$eq__O__scm_Builder(f(arg1$2));
        these = $as_sci_List(these.tail__O())
      };
      var jsx$1 = b.result__O()
    };
    var message = (("Node " + $as_sc_TraversableOnce(jsx$1).mkString__T__T(",")) + " cannot be patched");
    var lexical = patchNode.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var location = $m_s_None$();
    this$3.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
    return $m_s_None$()
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype.patchObjectCollectionProperty__p2__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Value__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__T__V = (function(targetNode, patchField, patchValue, propertyMapping, targetLocation, patchLocation) {
  var rc5 = false;
  var x2 = null;
  var this$1 = targetNode.fields$1;
  var x1 = this$1.fs$1.get__O__s_Option(patchField);
  matchEnd6: {
    var targetPropertyValue;
    if ((x1 instanceof $c_s_Some)) {
      rc5 = true;
      x2 = $as_s_Some(x1);
      var v = $as_Lamf_core_parser_Value(x2.value$2);
      if ((v.value$1 instanceof $c_Lamf_core_model_domain_AmfArray)) {
        var targetPropertyValue = $as_Lamf_core_model_domain_AmfArray(v.value$1).values$1;
        break matchEnd6
      }
    };
    if (rc5) {
      var v$2 = $as_Lamf_core_parser_Value(x2.value$2);
      var jsx$1 = $m_sc_Seq$();
      var array = [v$2.value$1];
      var targetPropertyValue = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
      break matchEnd6
    };
    var targetPropertyValue = $m_sci_Nil$()
  };
  var jsx$2 = new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$1().init___Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage(this);
  var this$4 = $m_sc_Seq$();
  var targetPropertyValueIds = $as_sci_Map($as_sc_TraversableOnce(targetPropertyValue.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$2, this$4.ReusableCBFInstance$2)).foldLeft__O__F2__O($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this, targetLocation$1) {
    return (function(acc$2, elm$2) {
      var acc = $as_sci_Map(acc$2);
      var elm = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(elm$2);
      var id = elm.id$1;
      var self = $as_T(id.split(targetLocation$1).join(""));
      return acc.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, elm))
    })
  })(this, targetLocation))));
  var x1$2 = patchValue.value$1;
  if ((x1$2 instanceof $c_Lamf_core_model_domain_AmfArray)) {
    var x2$2 = $as_Lamf_core_model_domain_AmfArray(x1$2);
    var patchPropertyValue = x2$2.values$1
  } else {
    var jsx$3 = $m_sc_Seq$();
    var array$1 = [x1$2];
    var patchPropertyValue = $as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)))
  };
  var jsx$4 = new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$2().init___Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage(this);
  var this$11 = $m_sc_Seq$();
  var patchPropertyValueIds = $as_sci_Map($as_sc_TraversableOnce(patchPropertyValue.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$4, this$11.ReusableCBFInstance$2)).foldLeft__O__F2__O($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$2$1, patchLocation$1) {
    return (function(acc$3$2, elm$3$2) {
      var acc$3 = $as_sci_Map(acc$3$2);
      var elm$3 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(elm$3$2);
      var id$1 = elm$3.id$1;
      var self$1 = $as_T(id$1.split(patchLocation$1).join(""));
      return acc$3.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$1, elm$3))
    })
  })(this, patchLocation))));
  var x1$3 = this.findPropertyMappingMergePolicy__p2__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T(propertyMapping);
  if ((x1$3 === "insert")) {
    var pf = new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$3().init___Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage__sci_Map__T(this, targetPropertyValueIds, patchLocation);
    var this$16 = $m_sci_Iterable$();
    var bf = this$16.ReusableCBFInstance$2;
    var jsx$6 = $as_sc_TraversableLike($f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(patchPropertyValueIds, pf, bf));
    var jsx$5 = new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$4().init___Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage(this);
    var this$17 = $m_sci_Iterable$();
    var newDialectDomainElements = $as_sc_TraversableOnce(jsx$6.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$5, this$17.ReusableCBFInstance$2)).toSeq__sc_Seq();
    var jsx$8 = new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$5().init___Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage(this);
    var this$18 = $m_sc_Seq$();
    var jsx$7 = $as_sc_SeqLike(targetPropertyValue.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$8, this$18.ReusableCBFInstance$2));
    var this$19 = $m_sc_Seq$();
    var unionElements = $as_sc_Seq(jsx$7.union__sc_GenSeq__scg_CanBuildFrom__O(newDialectDomainElements, this$19.ReusableCBFInstance$2));
    targetNode.graph__Lamf_core_model_domain_Graph().patchSeqField__Lamf_core_metamodel_Field__sc_Seq__V(patchField, unionElements)
  } else if ((x1$3 === "delete")) {
    var pf$1 = new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$6().init___Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage__sci_Map__T(this, targetPropertyValueIds, patchLocation);
    var this$20 = $m_sci_Iterable$();
    var bf$1 = this$20.ReusableCBFInstance$2;
    var jsx$10 = $as_sc_TraversableLike($f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(patchPropertyValueIds, pf$1, bf$1));
    var jsx$9 = new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$7().init___Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage(this);
    var this$21 = $m_sci_Iterable$();
    var newDialectDomainElements$2 = $as_sc_TraversableOnce(jsx$10.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$9, this$21.ReusableCBFInstance$2)).toSeq__sc_Seq();
    var jsx$11 = new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$8().init___Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage(this);
    var this$22 = $m_sc_Seq$();
    var unionElements$2 = $as_sc_Seq($as_sc_SeqLike(targetPropertyValue.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$11, this$22.ReusableCBFInstance$2)).diff__sc_GenSeq__O(newDialectDomainElements$2));
    targetNode.graph__Lamf_core_model_domain_Graph().patchSeqField__Lamf_core_metamodel_Field__sc_Seq__V(patchField, unionElements$2)
  } else if ((x1$3 === "update")) {
    var pf$2 = new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$9().init___Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage__sci_Map__T(this, targetPropertyValueIds, patchLocation);
    var this$23 = $m_sci_Iterable$();
    var bf$2 = this$23.ReusableCBFInstance$2;
    var jsx$15 = $as_sc_TraversableLike($f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(patchPropertyValueIds, pf$2, bf$2));
    var jsx$14 = new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$10().init___Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage(this);
    var this$24 = $m_sci_Iterable$();
    var jsx$13 = $as_sc_TraversableLike(jsx$15.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$14, this$24.ReusableCBFInstance$2));
    var jsx$12 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, targetLocation$2, patchLocation$2) {
      return (function(x0$1$2) {
        var x0$1 = $as_T2(x0$1$2);
        if ((x0$1 !== null)) {
          var targetElem = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x0$1.$$und1__O());
          var patchElem = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x0$1.$$und2__O());
          return new $c_T2().init___O__O(targetElem, this$3$1.patchNode__p2__s_Option__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(new $c_s_Some().init___O(targetElem), targetLocation$2, patchElem, patchLocation$2))
        } else {
          throw new $c_s_MatchError().init___O(x0$1)
        }
      })
    })(this, targetLocation, patchLocation));
    var this$25 = $m_sci_Iterable$();
    var computedDomainElements = $as_sc_TraversableOnce(jsx$13.map__F1__scg_CanBuildFrom__O(jsx$12, this$25.ReusableCBFInstance$2)).toSeq__sc_Seq();
    var newDomainElements = $as_sci_Map(computedDomainElements.foldLeft__O__F2__O(targetPropertyValueIds, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$4$1, targetLocation$3) {
      return (function(x0$2$2, x1$1$2) {
        var x0$2 = $as_sci_Map(x0$2$2);
        var x1$1 = $as_T2(x1$1$2);
        var x1$4 = new $c_T2().init___O__O(x0$2, x1$1);
        var acc$1 = $as_sci_Map(x1$4.$$und1$f);
        var p2 = $as_T2(x1$4.$$und2$f);
        if ((p2 !== null)) {
          var targetElem$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(p2.$$und1__O());
          var maybePatchedElem = $as_s_Option(p2.$$und2__O());
          if ((maybePatchedElem instanceof $c_s_Some)) {
            var x2$1 = $as_s_Some(maybePatchedElem);
            var mergedElem = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2$1.value$2);
            var id$2 = targetElem$1.id$1;
            return acc$1.updated__O__O__sci_Map($as_T(id$2.split(targetLocation$3).join("")), mergedElem)
          } else {
            var x = $m_s_None$();
            if ((x === maybePatchedElem)) {
              var id$3 = targetElem$1.id$1;
              return $as_sci_Map(acc$1.$$minus__O__sc_Map($as_T(id$3.split(targetLocation$3).join(""))))
            } else {
              throw new $c_s_MatchError().init___O(maybePatchedElem)
            }
          }
        };
        throw new $c_s_MatchError().init___O(x1$4)
      })
    })(this, targetLocation))));
    var jsx$16 = targetNode.graph__Lamf_core_model_domain_Graph();
    var this$30 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(newDomainElements);
    jsx$16.patchSeqField__Lamf_core_metamodel_Field__sc_Seq__V(patchField, this$30.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream())
  } else if ((x1$3 === "upsert")) {
    var jsx$18 = $f_sc_MapLike__toSeq__sc_Seq(patchPropertyValueIds);
    var jsx$17 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1, targetPropertyValueIds$1, patchLocation$3) {
      return (function(x0$3$2) {
        var x0$3 = $as_T2(x0$3$2);
        if ((x0$3 !== null)) {
          var id$4 = $as_T(x0$3.$$und1__O());
          var elem = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x0$3.$$und2__O());
          var x1$2$1 = targetPropertyValueIds$1.get__O__s_Option($as_T(id$4.split(patchLocation$3).join("")));
          if ((x1$2$1 instanceof $c_s_Some)) {
            var x2$3 = $as_s_Some(x1$2$1);
            var targetElem$2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2$3.value$2);
            return new $c_T2().init___O__O(new $c_s_Some().init___O(targetElem$2), elem)
          } else {
            var x$1 = $m_s_None$();
            if ((x$1 === x1$2$1)) {
              return new $c_T2().init___O__O($m_s_None$(), elem)
            } else {
              throw new $c_s_MatchError().init___O(x1$2$1)
            }
          }
        } else {
          throw new $c_s_MatchError().init___O(x0$3)
        }
      })
    })(this, targetPropertyValueIds, patchLocation));
    var this$33 = $m_sc_Seq$();
    var existingElems = $as_sc_Seq(jsx$18.map__F1__scg_CanBuildFrom__O(jsx$17, this$33.ReusableCBFInstance$2));
    var jsx$19 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1, targetLocation$4, patchLocation$4) {
      return (function(x0$4$2) {
        var x0$4 = $as_T2(x0$4$2);
        if ((x0$4 !== null)) {
          var maybeTargetElem = $as_s_Option(x0$4.$$und1__O());
          var patchElem$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x0$4.$$und2__O());
          if ((maybeTargetElem instanceof $c_s_Some)) {
            var x2$4 = $as_s_Some(maybeTargetElem);
            var targetElem$3 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2$4.value$2);
            return new $c_T2().init___O__O(new $c_s_Some().init___O(targetElem$3), this$6$1.patchNode__p2__s_Option__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(new $c_s_Some().init___O(targetElem$3), targetLocation$4, patchElem$1, patchLocation$4))
          } else {
            var x$2 = $m_s_None$();
            if ((x$2 === maybeTargetElem)) {
              return new $c_T2().init___O__O($m_s_None$(), new $c_s_Some().init___O(patchElem$1))
            } else {
              throw new $c_s_MatchError().init___O(maybeTargetElem)
            }
          }
        } else {
          throw new $c_s_MatchError().init___O(x0$4)
        }
      })
    })(this, targetLocation, patchLocation));
    var this$34 = $m_sc_Seq$();
    var computedDomainElements$2 = $as_sc_Seq(existingElems.map__F1__scg_CanBuildFrom__O(jsx$19, this$34.ReusableCBFInstance$2));
    var newDomainElements$2 = $as_sci_Map(computedDomainElements$2.foldLeft__O__F2__O(targetPropertyValueIds, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$7$1, targetLocation$5, patchLocation$5) {
      return (function(x0$5$2, x1$2$2$2) {
        var x0$5 = $as_sci_Map(x0$5$2);
        var x1$2$2 = $as_T2(x1$2$2$2);
        var x1$5 = new $c_T2().init___O__O(x0$5, x1$2$2);
        var acc$4 = $as_sci_Map(x1$5.$$und1$f);
        var p2$1 = $as_T2(x1$5.$$und2$f);
        if ((p2$1 !== null)) {
          var maybeTargetElem$1 = $as_s_Option(p2$1.$$und1__O());
          var maybeMergedElem = $as_s_Option(p2$1.$$und2__O());
          if ((maybeTargetElem$1 instanceof $c_s_Some)) {
            var x2$5 = $as_s_Some(maybeTargetElem$1);
            var targetElem$4 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2$5.value$2);
            if ((maybeMergedElem instanceof $c_s_Some)) {
              var x2$2$1 = $as_s_Some(maybeMergedElem);
              var mergedElement = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2$2$1.value$2);
              var id$5 = targetElem$4.id$1;
              return acc$4.updated__O__O__sci_Map($as_T(id$5.split(targetLocation$5).join("")), mergedElement)
            } else {
              var x$3 = $m_s_None$();
              if ((x$3 === maybeMergedElem)) {
                var id$6 = targetElem$4.id$1;
                return $as_sci_Map(acc$4.$$minus__O__sc_Map($as_T(id$6.split(targetLocation$5).join(""))))
              } else {
                throw new $c_s_MatchError().init___O(maybeMergedElem)
              }
            }
          } else {
            var x$3$1 = $m_s_None$();
            if ((x$3$1 === maybeTargetElem$1)) {
              if ((maybeMergedElem instanceof $c_s_Some)) {
                var x2$3$1 = $as_s_Some(maybeMergedElem);
                var mergedElement$2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2$3$1.value$2);
                var id$7 = mergedElement$2.id$1;
                return acc$4.updated__O__O__sci_Map($as_T(id$7.split(patchLocation$5).join("")), mergedElement$2)
              } else {
                var x$5 = $m_s_None$();
                if ((x$5 === maybeMergedElem)) {
                  return acc$4
                } else {
                  throw new $c_s_MatchError().init___O(maybeMergedElem)
                }
              }
            } else {
              throw new $c_s_MatchError().init___O(maybeTargetElem$1)
            }
          }
        };
        throw new $c_s_MatchError().init___O(x1$5)
      })
    })(this, targetLocation, patchLocation))));
    var jsx$20 = targetNode.graph__Lamf_core_model_domain_Graph();
    var this$41 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(newDomainElements$2);
    jsx$20.patchSeqField__Lamf_core_metamodel_Field__sc_Seq__V(patchField, this$41.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream())
  } else if ((x1$3 !== "ignore")) {
    if ((x1$3 === "fail")) {
      var this$42 = this.errorHandler$1;
      var specification = $m_Lamf_validation_DialectValidations$().InvalidDialectPatch$1;
      var node = targetNode.id$1;
      var property = $m_s_None$();
      var message = (("Property " + patchField.value$1.iri__T()) + " cannot be patched");
      var lexical = patchValue.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      var location = $m_s_None$();
      this$42.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage: 0
}, false, "amf.plugins.document.vocabularies.resolution.stages.DialectPatchApplicationStage", {
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage.prototype = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage.prototype.genName__T__sci_Map__T = (function(baseName, allDeclarations) {
  var c = 1;
  var acc = baseName;
  while (allDeclarations.contains__O__Z(acc)) {
    c = ((1 + c) | 0);
    acc = (("" + baseName) + c)
  };
  return acc
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage.prototype.findDeclarations__Lamf_core_model_document_BaseUnit__sci_Map__sci_Map = (function(model, acc) {
  if ($is_Lamf_core_model_document_DeclaresModel(model)) {
    var jsx$2 = $as_Lamf_core_model_document_DeclaresModel(model).declares__sc_Seq();
    var jsx$1 = new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$1().init___Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage(this);
    var this$1 = $m_sc_Seq$();
    var updateDeclarations = $as_sci_Map($as_sc_TraversableOnce(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).foldLeft__O__F2__O(acc, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
      return (function(x0$1$2, x1$1$2) {
        var x0$1 = $as_sci_Map(x0$1$2);
        var x1$1 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1$1$2);
        return x0$1.updated__O__O__sci_Map(x1$1.id__T(), x1$1)
      })
    })(this))))
  } else {
    var updateDeclarations = acc
  };
  var jsx$4 = model.references__sc_Seq();
  var jsx$3 = new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findDeclarations$2().init___Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage(this);
  var this$2 = $m_sc_Seq$();
  return $as_sci_Map($as_sc_TraversableOnce(jsx$4.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$3, this$2.ReusableCBFInstance$2)).foldLeft__O__F2__O(updateDeclarations, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$2$1) {
    return (function(x0$2$2, x1$2$2) {
      var x0$2 = $as_sci_Map(x0$2$2);
      var x1$2 = $as_Lamf_core_model_document_BaseUnit(x1$2$2);
      return this$2$1.findDeclarations__Lamf_core_model_document_BaseUnit__sci_Map__sci_Map(x1$2, x0$2)
    })
  })(this))))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage.prototype.dereferencePendingDeclarations__sc_Seq__scm_Map__sci_Map__V = (function(pending, acc, allDeclarations) {
  if (pending.nonEmpty__Z()) {
    var nextPending = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(pending.head__O());
    var x1 = acc.get__O__s_Option(nextPending.id__T());
    if ((x1 instanceof $c_s_Some)) {
      this.dereferencePendingDeclarations__sc_Seq__scm_Map__sci_Map__V($as_sc_Seq(pending.tail__O()), acc, allDeclarations)
    } else {
      var x = $m_s_None$();
      if ((x === x1)) {
        if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(nextPending).isDefined__Z()) {
          var links = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
          var jsx$1 = this.cloneNodeMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_plugins_document_vocabularies_model_domain_NodeMappable($as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable($f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(nextPending, links)));
          var this$1 = $as_Lamf_core_model_StrField(nextPending.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(nextPending.Name__Lamf_core_metamodel_Field()));
          var this$2 = this$1.option$1;
          var effectiveNextPending = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(jsx$1.withName__T__Lamf_plugins_document_vocabularies_model_domain_NodeMappable($as_T((this$2.isEmpty__Z() ? null : this$2.get__O()))).withId__T__Lamf_core_model_domain_AmfObject(nextPending.id__T()))
        } else {
          var effectiveNextPending = nextPending
        };
        if ((effectiveNextPending instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
          var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(effectiveNextPending);
          var jsx$9 = $as_sc_TraversableLike(pending.tail__O());
          var jsx$8 = $as_sc_Seq(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1));
          var jsx$7 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
            return (function(x$4$2) {
              var x$4 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$4$2);
              return $as_sc_Seq(x$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1))
            })
          })(this));
          var this$3 = $m_sc_Seq$();
          var jsx$6 = $as_sc_TraversableLike(jsx$8.flatMap__F1__scg_CanBuildFrom__O(jsx$7, this$3.ReusableCBFInstance$2));
          var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, allDeclarations$1) {
            return (function(r$2) {
              var r = $as_Lamf_core_model_StrField(r$2);
              var this$4 = r.option$1;
              return allDeclarations$1.get__O__s_Option($as_T((this$4.isEmpty__Z() ? null : this$4.get__O())))
            })
          })(this, allDeclarations));
          var this$5 = $m_sc_Seq$();
          var jsx$4 = $as_sc_TraversableLike(jsx$6.map__F1__scg_CanBuildFrom__O(jsx$5, this$5.ReusableCBFInstance$2));
          var jsx$3 = new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$2().init___Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage(this);
          var this$6 = $m_sc_Seq$();
          var jsx$2 = $as_sc_GenTraversableOnce(jsx$4.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$3, this$6.ReusableCBFInstance$2));
          var this$7 = $m_sc_Seq$();
          var newPendingRange = $as_sc_Seq(jsx$9.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$7.ReusableCBFInstance$2))
        } else {
          if ((!(effectiveNextPending instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping))) {
            throw new $c_s_MatchError().init___O(effectiveNextPending)
          };
          var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(effectiveNextPending);
          var jsx$15 = $as_sc_TraversableLike(pending.tail__O());
          var jsx$14 = $as_sc_Seq(x3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1));
          var jsx$13 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, allDeclarations$2) {
            return (function(r$3$2) {
              var r$3 = $as_Lamf_core_model_StrField(r$3$2);
              var this$8 = r$3.option$1;
              return allDeclarations$2.get__O__s_Option($as_T((this$8.isEmpty__Z() ? null : this$8.get__O())))
            })
          })(this, allDeclarations));
          var this$9 = $m_sc_Seq$();
          var jsx$12 = $as_sc_TraversableLike(jsx$14.map__F1__scg_CanBuildFrom__O(jsx$13, this$9.ReusableCBFInstance$2));
          var jsx$11 = new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$3().init___Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage(this);
          var this$10 = $m_sc_Seq$();
          var jsx$10 = $as_sc_GenTraversableOnce(jsx$12.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$11, this$10.ReusableCBFInstance$2));
          var this$11 = $m_sc_Seq$();
          var newPendingRange = $as_sc_Seq(jsx$15.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$10, this$11.ReusableCBFInstance$2))
        };
        var x1$3 = $as_sc_Seq(effectiveNextPending.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field())).headOption__s_Option();
        matchEnd5$2: {
          var newPending;
          if ((x1$3 instanceof $c_s_Some)) {
            var x2$2 = $as_s_Some(x1$3);
            var n = $as_Lamf_core_model_domain_DomainElement(x2$2.value$2);
            if ($is_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(n)) {
              var x3$2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(n);
              if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x3$2).isDefined__Z()) {
                var jsx$17 = $m_sc_Seq$();
                var array = [$as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x3$2).get__O())];
                var jsx$16 = jsx$17.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
                var this$14 = $m_sc_Seq$();
                var newPending = $as_sc_Seq(newPendingRange.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$16, this$14.ReusableCBFInstance$2));
                break matchEnd5$2
              }
            }
          };
          var newPending = newPendingRange
        };
        var this$15 = $as_Lamf_core_model_StrField(effectiveNextPending.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(effectiveNextPending.Name__Lamf_core_metamodel_Field()));
        var this$16 = this$15.option$1;
        var thiz = $as_T((this$16.isEmpty__Z() ? null : this$16.get__O()));
        if (($uI(thiz.indexOf(".")) !== (-1))) {
          var this$20 = $as_Lamf_core_model_StrField(effectiveNextPending.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(effectiveNextPending.Name__Lamf_core_metamodel_Field()));
          var this$21 = this$20.option$1;
          var thiz$1 = $as_T((this$21.isEmpty__Z() ? null : this$21.get__O()));
          var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz$1, ".", 0);
          var this$24 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
          effectiveNextPending.withName__T__Lamf_plugins_document_vocabularies_model_domain_NodeMappable(this.genName__T__sci_Map__T($as_T($f_sc_IndexedSeqOptimized__last__O(this$24)), allDeclarations))
        };
        var self = effectiveNextPending.id__T();
        acc.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(self, effectiveNextPending));
        this.dereferencePendingDeclarations__sc_Seq__scm_Map__sci_Map__V(newPending, acc, allDeclarations)
      } else {
        throw new $c_s_MatchError().init___O(x1)
      }
    }
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage.prototype.findVocabularies__Lamf_core_model_document_BaseUnit__sci_Set__sci_Set = (function(model, acc) {
  var updateDeclarations = $as_sci_Set(model.references__sc_Seq().foldLeft__O__F2__O(acc, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(x0$1$2, x1$1$2) {
      var x0$1 = $as_sci_Set(x0$1$2);
      var x1$1 = $as_Lamf_core_model_document_BaseUnit(x1$1$2);
      var jsx$2 = x1$1.references__sc_Seq();
      var jsx$1 = new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$$nestedInanonfun$findVocabularies$1$1().init___Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage($this);
      var this$1 = $m_sc_Seq$();
      return $as_sci_Set(x0$1.$$plus$plus__sc_GenTraversableOnce__sc_Set($as_sc_GenTraversableOnce(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))))
    })
  })(this))));
  var jsx$4 = model.references__sc_Seq();
  var jsx$3 = new $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findVocabularies$2().init___Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage(this);
  var this$2 = $m_sc_Seq$();
  return $as_sci_Set($as_sc_TraversableOnce(jsx$4.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$3, this$2.ReusableCBFInstance$2)).foldLeft__O__F2__O(updateDeclarations, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$2$1) {
    return (function(x0$2$2, x1$2$2) {
      var x0$2 = $as_sci_Set(x0$2$2);
      var x1$2 = $as_Lamf_plugins_document_vocabularies_model_document_DialectLibrary(x1$2$2);
      return this$2$1.findVocabularies__Lamf_core_model_document_BaseUnit__sci_Set__sci_Set(x1$2, x0$2)
    })
  })(this))))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage.prototype.cloneNodeMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_plugins_document_vocabularies_model_domain_NodeMappable = (function(target) {
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$2 = target.fields__Lamf_core_parser_Fields();
  var this$5 = this$2.fs$1;
  var this$3 = $m_Lamf_core_parser_FieldEntry$();
  var f = $f_F2__tupled__F1(this$3);
  var this$4 = $m_sci_Iterable$();
  var bf = this$4.ReusableCBFInstance$2;
  $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$5, f, bf)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, fields$1) {
    return (function(entry$2) {
      var entry = $as_Lamf_core_parser_FieldEntry(entry$2);
      return fields$1.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(entry.field$1, entry.value$1.value$1, entry.value$1.annotations$1)
    })
  })(this, fields)));
  if ((target instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    return new $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
  } else if ((target instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping)) {
    return new $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
  } else {
    throw new $c_s_MatchError().init___O(target)
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  var allDeclarations = this.findDeclarations__Lamf_core_model_document_BaseUnit__sci_Map__sci_Map(model, $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())));
  var allExternals = this.findExternals__Lamf_core_model_document_BaseUnit__sci_Set__sci_Set(model, $as_sci_Set($m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
  var allVocabularies = this.findVocabularies__Lamf_core_model_document_BaseUnit__sci_Set__sci_Set(model, $as_sci_Set($m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
  var finalDeclarationsMap = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var unitDeclarations = $as_sc_Seq($as_Lamf_core_model_document_DeclaresModel(model).declares__sc_Seq().filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$5$2) {
      var x$5 = $as_Lamf_core_model_domain_DomainElement(x$5$2);
      return $is_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x$5)
    })
  })(this))));
  this.dereferencePendingDeclarations__sc_Seq__scm_Map__sci_Map__V(unitDeclarations, finalDeclarationsMap, allDeclarations);
  this.linkExtendedNodes__scm_Map__V(finalDeclarationsMap);
  var finalDeclarations = finalDeclarationsMap.values__sc_Iterable().toSeq__sc_Seq();
  var this$1 = $m_sci_Set$();
  var bf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  var vocabulariesAliases = $as_sci_Map($as_sc_TraversableOnce($f_sc_IterableLike__zipWithIndex__scg_CanBuildFrom__O(allVocabularies, bf)).foldLeft__O__F2__O($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$2) {
    return (function(x0$1$2, x1$1$2) {
      var x0$1 = $as_sci_Map(x0$1$2);
      var x1$1 = $as_T2(x1$1$2);
      var x1 = new $c_T2().init___O__O(x0$1, x1$1);
      var acc = $as_sci_Map(x1.$$und1$f);
      var p2 = $as_T2(x1.$$und2$f);
      if ((p2 !== null)) {
        var vocab = $as_Lamf_plugins_document_vocabularies_model_document_Vocabulary(p2.$$und1__O());
        var i = p2.$$und2$mcI$sp__I();
        return acc.updated__O__O__sci_Map(("vocab" + i), new $c_T2().init___O__O(vocab.id$1, vocab.id$1))
      };
      throw new $c_s_MatchError().init___O(x1)
    })
  })(this))));
  var jsx$3 = $f_sc_SetLike__toSeq__sc_Seq(allExternals);
  var this$3 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike(jsx$3.zipWithIndex__scg_CanBuildFrom__O(this$3.ReusableCBFInstance$2));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, model$1) {
    return (function(x0$2$2) {
      var x0$2 = $as_T2(x0$2$2);
      if ((x0$2 !== null)) {
        var external = $as_T(x0$2.$$und1__O());
        var i$1 = x0$2.$$und2$mcI$sp__I();
        if ((external !== null)) {
          $m_Lamf_core_parser_Annotations$();
          var annotations = new $c_Lamf_core_parser_Annotations().init___();
          var this$7 = new $c_Lamf_plugins_document_vocabularies_model_domain_External().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
          var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().Base$1;
          var this$8 = $as_Lamf_plugins_document_vocabularies_model_domain_External($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$7, field, external));
          var alias = ("external" + i$1);
          var field$1 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().DisplayName$1;
          var this$10 = $as_Lamf_plugins_document_vocabularies_model_domain_External($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$8, field$1, alias));
          var this$9 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(model$1);
          var value = (($as_T((this$9.isEmpty__Z() ? model$1.id__T() : this$9.get__O())) + "#/external/external") + i$1);
          return $as_Lamf_plugins_document_vocabularies_model_domain_External($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$10, value))
        }
      };
      throw new $c_s_MatchError().init___O(x0$2)
    })
  })(this, model));
  var this$11 = $m_sc_Seq$();
  var finalExternals = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$11.ReusableCBFInstance$2));
  if ((model instanceof $c_Lamf_plugins_document_vocabularies_model_document_Dialect)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(model);
    $m_Lamf_core_parser_Annotations$();
    var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
    var this$15 = new $c_Lamf_plugins_document_vocabularies_model_document_Dialect().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
    var value$1 = x2.id$1;
    var this$17 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$15, value$1));
    var this$16 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(x2);
    var location = $as_T((this$16.isEmpty__Z() ? x2.id$1 : this$16.get__O()));
    var field$2 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
    var this$18 = $as_Lamf_plugins_document_vocabularies_model_document_Dialect($as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$17, field$2, location)));
    var documentsMapping = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1));
    var field$3 = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1;
    var this$19 = $as_Lamf_plugins_document_vocabularies_model_document_Dialect($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$18, field$3, documentsMapping));
    var field$4 = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
    var this$20 = $as_Lamf_plugins_document_vocabularies_model_document_ExternalContext($as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$19, field$4, finalDeclarations)));
    var this$21 = $as_Lamf_core_model_domain_AmfObject(this$20);
    var field$5 = $m_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$().Externals$1;
    var this$24 = $as_Lamf_plugins_document_vocabularies_model_document_Dialect($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$21, field$5, finalExternals));
    var this$22 = $as_Lamf_core_model_StrField(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Name$1));
    var this$23 = this$22.option$1;
    var name = $as_T((this$23.isEmpty__Z() ? null : this$23.get__O()));
    var field$6 = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Name$1;
    var this$27 = $as_Lamf_plugins_document_vocabularies_model_document_Dialect($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$24, field$6, name));
    var this$25 = $as_Lamf_core_model_StrField(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Version$1));
    var this$26 = this$25.option$1;
    var version = $as_T((this$26.isEmpty__Z() ? null : this$26.get__O()));
    var field$7 = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Version$1;
    var resolved = $as_Lamf_plugins_document_vocabularies_model_document_Dialect($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$27, field$7, version))
  } else if ((model instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary)) {
    var x3 = $as_Lamf_plugins_document_vocabularies_model_document_DialectLibrary(model);
    $m_Lamf_core_parser_Annotations$();
    var annotations$2 = new $c_Lamf_core_parser_Annotations().init___();
    var this$31 = new $c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$2);
    var value$2 = x3.id$1;
    var this$33 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$31, value$2));
    var this$32 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(x3);
    var location$1 = $as_T((this$32.isEmpty__Z() ? x3.id$1 : this$32.get__O()));
    var field$8 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
    var this$34 = $as_Lamf_core_model_document_DeclaresModel($as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$33, field$8, location$1)));
    var field$9 = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
    var this$35 = $as_Lamf_plugins_document_vocabularies_model_document_ExternalContext($as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$34, field$9, finalDeclarations)));
    var this$36 = $as_Lamf_core_model_domain_AmfObject(this$35);
    var field$10 = $m_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$().Externals$1;
    var resolved = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$36, field$10, finalExternals))
  } else {
    if ((!(model instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectFragment))) {
      throw new $c_s_MatchError().init___O(model)
    };
    var x4 = $as_Lamf_plugins_document_vocabularies_model_document_DialectFragment(model);
    $m_Lamf_core_parser_Annotations$();
    var annotations$3 = new $c_Lamf_core_parser_Annotations().init___();
    var this$40 = new $c_Lamf_plugins_document_vocabularies_model_document_DialectFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$3);
    var value$3 = x4.id$1;
    var this$42 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$40, value$3));
    var this$41 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(x4);
    var location$2 = $as_T((this$41.isEmpty__Z() ? x4.id$1 : this$41.get__O()));
    var field$11 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
    var this$43 = $as_Lamf_plugins_document_vocabularies_model_document_DialectFragment($as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$42, field$11, location$2)));
    var nodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Encodes$1));
    var field$12 = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Encodes$1;
    var this$44 = $as_Lamf_plugins_document_vocabularies_model_document_DialectFragment($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$43, field$12, nodeMapping));
    var field$13 = $m_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$().Externals$1;
    var resolved = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$44, field$13, finalExternals))
  };
  var jsx$4 = resolved.annotations__Lamf_core_parser_Annotations();
  var this$45 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$45);
  jsx$4.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_Aliases().init___sci_Set($as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(vocabulariesAliases, cbf))));
  return resolved
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage.prototype.findExternals__Lamf_core_model_document_BaseUnit__sci_Set__sci_Set = (function(model, acc) {
  if ((model instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_document_DialectLibrary(model);
    var jsx$2 = $f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(x2);
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$1$2) {
        var x$1 = $as_Lamf_plugins_document_vocabularies_model_domain_External(x$1$2);
        var this$1 = $as_Lamf_core_model_StrField(x$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().Base$1));
        var this$2 = this$1.option$1;
        return $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()))
      })
    })(this));
    var this$3 = $m_sc_Seq$();
    var updateDeclarations = $as_sci_Set(acc.$$plus$plus__sc_GenTraversableOnce__sc_Set($as_sc_GenTraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))))
  } else if ((model instanceof $c_Lamf_plugins_document_vocabularies_model_document_Dialect)) {
    var x3 = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(model);
    var jsx$4 = $f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(x3);
    var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(x$2$2) {
        var x$2 = $as_Lamf_plugins_document_vocabularies_model_domain_External(x$2$2);
        var this$4 = $as_Lamf_core_model_StrField(x$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().Base$1));
        var this$5 = this$4.option$1;
        return $as_T((this$5.isEmpty__Z() ? null : this$5.get__O()))
      })
    })(this));
    var this$6 = $m_sc_Seq$();
    var updateDeclarations = $as_sci_Set(acc.$$plus$plus__sc_GenTraversableOnce__sc_Set($as_sc_GenTraversableOnce(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$6.ReusableCBFInstance$2))))
  } else if ((model instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectFragment)) {
    var x4 = $as_Lamf_plugins_document_vocabularies_model_document_DialectFragment(model);
    var jsx$6 = $f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(x4);
    var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
      return (function(x$3$2) {
        var x$3 = $as_Lamf_plugins_document_vocabularies_model_domain_External(x$3$2);
        var this$7 = $as_Lamf_core_model_StrField(x$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().Base$1));
        var this$8 = this$7.option$1;
        return $as_T((this$8.isEmpty__Z() ? null : this$8.get__O()))
      })
    })(this));
    var this$9 = $m_sc_Seq$();
    var updateDeclarations = $as_sci_Set(acc.$$plus$plus__sc_GenTraversableOnce__sc_Set($as_sc_GenTraversableOnce(jsx$6.map__F1__scg_CanBuildFrom__O(jsx$5, this$9.ReusableCBFInstance$2))))
  } else {
    var updateDeclarations = acc
  };
  return $as_sci_Set(model.references__sc_Seq().foldLeft__O__F2__O(updateDeclarations, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$4$1) {
    return (function(x0$1$2, x1$1$2) {
      var x0$1 = $as_sci_Set(x0$1$2);
      var x1$1 = $as_Lamf_core_model_document_BaseUnit(x1$1$2);
      return this$4$1.findExternals__Lamf_core_model_document_BaseUnit__sci_Set__sci_Set(x1$1, x0$1)
    })
  })(this))))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage.prototype.linkExtendedNodes__scm_Map__V = (function(acc) {
  acc.values__sc_Iterable().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, acc$1) {
    return (function(nodeMappable$2) {
      var nodeMappable = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(nodeMappable$2);
      var x1 = $as_sc_Seq(nodeMappable.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field())).headOption__s_Option();
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var extended = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
        if ($is_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(extended)) {
          var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(extended);
          if (($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x3).isDefined__Z() && acc$1.contains__O__Z($as_Lamf_core_model_domain_AmfObject($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x3).get__O()).id__T()))) {
            var found = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(acc$1.apply__O__O($as_Lamf_core_model_domain_AmfObject($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x3).get__O()).id__T()));
            var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().Extends__Lamf_core_metamodel_Field();
            var jsx$1 = $m_sc_Seq$();
            var array = [found];
            var values = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
            return $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(nodeMappable, field, values)
          }
        }
      }
    })
  })(this, acc)))
});
var $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage: 0
}, false, "amf.plugins.document.vocabularies.resolution.stages.DialectReferencesResolutionStage", {
  Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_validation_AMFDialectValidations() {
  $c_O.call(this);
  this.dialect$1 = null
}
$c_Lamf_plugins_document_vocabularies_validation_AMFDialectValidations.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_validation_AMFDialectValidations.prototype.constructor = $c_Lamf_plugins_document_vocabularies_validation_AMFDialectValidations;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_validation_AMFDialectValidations() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_validation_AMFDialectValidations.prototype = $c_Lamf_plugins_document_vocabularies_validation_AMFDialectValidations.prototype;
$c_Lamf_plugins_document_vocabularies_validation_AMFDialectValidations.prototype.emitPropertyValidations__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__scm_Set__sci_List = (function(node, prop, recursion) {
  $m_scm_ListBuffer$();
  var this$2 = new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_ListBuffer().init___());
  var validations = $as_scm_ListBuffer($as_sc_GenTraversable(this$2.elems$1));
  var this$3 = $as_Lamf_core_model_DoubleField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Minimum$1)).option$1;
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var minValue = $uD(arg1);
    var message = ((("Property '" + $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1))) + "' minimum inclusive value is ") + minValue);
    var this$4 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
    var this$5 = this$4.option$1;
    var x$29 = this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$5.isEmpty__Z() ? null : this$5.get__O())), "minimum");
    var x$31 = new $c_s_Some().init___O(message);
    var x$32 = new $c_s_Some().init___O(message);
    var jsx$1 = $m_sc_Seq$();
    var array = [node.id$1];
    var x$33 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
    var jsx$2 = $m_sc_Seq$();
    var this$8 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
    var this$9 = this$8.option$1;
    var x$1 = $as_T((this$9.isEmpty__Z() ? null : this$9.get__O()));
    var this$10 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
    var this$11 = this$10.option$1;
    var x$2 = (this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$11.isEmpty__Z() ? null : this$11.get__O())), "minimum") + "/prop");
    var x$3 = new $c_s_Some().init___O(message);
    var x$4 = new $c_s_Some().init___O(("" + minValue));
    var x$5 = $m_s_None$();
    var x$6 = $m_s_None$();
    var x$7 = $m_s_None$();
    var x$8 = $m_s_None$();
    var x$9 = $m_s_None$();
    var x$10 = $m_s_None$();
    var x$11 = $m_s_None$();
    var x$12 = $m_s_None$();
    var x$13 = $m_s_None$();
    var x$14 = $m_s_None$();
    var x$15 = $m_s_None$();
    var x$16 = $m_s_None$();
    var x$17 = $m_s_None$();
    var x$18 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$30 = new $c_scm_ListBuffer().init___();
    var x$19 = this$30.toList__sci_List();
    var x$20 = $m_s_None$();
    var x$21 = $m_s_None$();
    var x$22 = $m_s_None$();
    var x$23 = $m_s_None$();
    var x$24 = $m_s_None$();
    var x$25 = $m_s_None$();
    var x$26 = $m_s_None$();
    var x$27 = $m_s_None$();
    var x$28 = $m_s_None$();
    var array$1 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$1, x$2, x$5, x$3, x$6, x$7, x$8, x$9, x$10, x$11, x$12, x$13, x$4, x$14, x$15, x$16, x$17, x$18, x$19, x$20, x$21, x$22, x$23, x$24, x$25, x$26, x$27, x$28)];
    var x$34 = $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)));
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$45 = new $c_scm_ListBuffer().init___();
    var x$35 = this$45.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$49 = new $c_scm_ListBuffer().init___();
    var x$36 = this$49.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$53 = new $c_scm_ListBuffer().init___();
    var x$37 = this$53.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$57 = new $c_scm_ListBuffer().init___();
    var x$38 = this$57.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$61 = new $c_scm_ListBuffer().init___();
    var x$39 = this$61.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$40 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$66 = new $c_scm_ListBuffer().init___();
    var x$41 = this$66.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$42 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$43 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$44 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$45 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$46 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$47 = $m_s_None$();
    validations.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$29, message, x$31, x$32, x$35, x$33, x$36, x$37, x$38, x$39, x$40, x$34, x$41, x$42, x$43, x$44, x$45, x$46, x$47))
  };
  var this$73 = $as_Lamf_core_model_DoubleField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Maximum$1)).option$1;
  if ((!this$73.isEmpty__Z())) {
    var arg1$1 = this$73.get__O();
    var maxValue = $uD(arg1$1);
    var message$1 = ((("Property '" + $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1))) + "' maximum inclusive value is ") + maxValue);
    var this$74 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
    var this$75 = this$74.option$1;
    var x$76 = this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$75.isEmpty__Z() ? null : this$75.get__O())), "maximum");
    var x$78 = new $c_s_Some().init___O(message$1);
    var x$79 = new $c_s_Some().init___O(message$1);
    var jsx$3 = $m_sc_Seq$();
    var array$2 = [node.id$1];
    var x$80 = $as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2)));
    var jsx$4 = $m_sc_Seq$();
    var this$78 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
    var this$79 = this$78.option$1;
    var x$48 = $as_T((this$79.isEmpty__Z() ? null : this$79.get__O()));
    var this$80 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
    var this$81 = this$80.option$1;
    var x$49 = (this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$81.isEmpty__Z() ? null : this$81.get__O())), "maximum") + "/prop");
    var x$50 = new $c_s_Some().init___O(message$1);
    var x$51 = new $c_s_Some().init___O(("" + maxValue));
    var x$52 = $m_s_None$();
    var x$53 = $m_s_None$();
    var x$54 = $m_s_None$();
    var x$55 = $m_s_None$();
    var x$56 = $m_s_None$();
    var x$57 = $m_s_None$();
    var x$58 = $m_s_None$();
    var x$59 = $m_s_None$();
    var x$60 = $m_s_None$();
    var x$61 = $m_s_None$();
    var x$62 = $m_s_None$();
    var x$63 = $m_s_None$();
    var x$64 = $m_s_None$();
    var x$65 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$100 = new $c_scm_ListBuffer().init___();
    var x$66 = this$100.toList__sci_List();
    var x$67 = $m_s_None$();
    var x$68 = $m_s_None$();
    var x$69 = $m_s_None$();
    var x$70 = $m_s_None$();
    var x$71 = $m_s_None$();
    var x$72 = $m_s_None$();
    var x$73 = $m_s_None$();
    var x$74 = $m_s_None$();
    var x$75 = $m_s_None$();
    var array$3 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$48, x$49, x$52, x$50, x$53, x$54, x$55, x$56, x$57, x$58, x$59, x$60, x$61, x$51, x$62, x$63, x$64, x$65, x$66, x$67, x$68, x$69, x$70, x$71, x$72, x$73, x$74, x$75)];
    var x$81 = $as_sc_Seq(jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$3)));
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$115 = new $c_scm_ListBuffer().init___();
    var x$82 = this$115.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$119 = new $c_scm_ListBuffer().init___();
    var x$83 = this$119.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$123 = new $c_scm_ListBuffer().init___();
    var x$84 = this$123.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$127 = new $c_scm_ListBuffer().init___();
    var x$85 = this$127.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$131 = new $c_scm_ListBuffer().init___();
    var x$86 = this$131.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$87 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$136 = new $c_scm_ListBuffer().init___();
    var x$88 = this$136.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$89 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$90 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$91 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$92 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$93 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$94 = $m_s_None$();
    validations.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$76, message$1, x$78, x$79, x$82, x$80, x$83, x$84, x$85, x$86, x$87, x$81, x$88, x$89, x$90, x$91, x$92, x$93, x$94))
  };
  var this$143 = $as_Lamf_core_model_IntField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MinCount$1));
  if (this$143.option$1.isDefined__Z()) {
    var this$144 = $as_Lamf_core_model_IntField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MinCount$1));
    var jsx$5 = ($f_Lamf_core_model_IntField__value__I(this$144) > 0)
  } else {
    var jsx$5 = false
  };
  if (jsx$5) {
    var message$2 = (("Property '" + $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1))) + "' is mandatory");
    var this$145 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
    var this$146 = this$145.option$1;
    var x$123 = this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$146.isEmpty__Z() ? null : this$146.get__O())), "required");
    var x$125 = new $c_s_Some().init___O(message$2);
    var x$126 = new $c_s_Some().init___O(message$2);
    var jsx$6 = $m_sc_Seq$();
    var array$4 = [node.id$1];
    var x$127 = $as_sc_Seq(jsx$6.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$4)));
    var jsx$7 = $m_sc_Seq$();
    var this$149 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
    var this$150 = this$149.option$1;
    var x$95 = $as_T((this$150.isEmpty__Z() ? null : this$150.get__O()));
    var this$151 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
    var this$152 = this$151.option$1;
    var x$96 = (this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$152.isEmpty__Z() ? null : this$152.get__O())), "required") + "/prop");
    var x$97 = new $c_s_Some().init___O(message$2);
    var x$98 = new $c_s_Some().init___O("1");
    var x$99 = $m_s_None$();
    var x$100 = $m_s_None$();
    var x$101 = $m_s_None$();
    var x$102 = $m_s_None$();
    var x$103 = $m_s_None$();
    var x$104 = $m_s_None$();
    var x$105 = $m_s_None$();
    var x$106 = $m_s_None$();
    var x$107 = $m_s_None$();
    var x$108 = $m_s_None$();
    var x$109 = $m_s_None$();
    var x$110 = $m_s_None$();
    var x$111 = $m_s_None$();
    var x$112 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$170 = new $c_scm_ListBuffer().init___();
    var x$113 = this$170.toList__sci_List();
    var x$114 = $m_s_None$();
    var x$115 = $m_s_None$();
    var x$116 = $m_s_None$();
    var x$117 = $m_s_None$();
    var x$118 = $m_s_None$();
    var x$119 = $m_s_None$();
    var x$120 = $m_s_None$();
    var x$121 = $m_s_None$();
    var x$122 = $m_s_None$();
    var array$5 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$95, x$96, x$99, x$97, x$100, x$101, x$102, x$98, x$103, x$104, x$105, x$106, x$107, x$108, x$109, x$110, x$111, x$112, x$113, x$114, x$115, x$116, x$117, x$118, x$119, x$120, x$121, x$122)];
    var x$128 = $as_sc_Seq(jsx$7.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$5)));
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$185 = new $c_scm_ListBuffer().init___();
    var x$129 = this$185.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$189 = new $c_scm_ListBuffer().init___();
    var x$130 = this$189.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$193 = new $c_scm_ListBuffer().init___();
    var x$131 = this$193.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$197 = new $c_scm_ListBuffer().init___();
    var x$132 = this$197.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$201 = new $c_scm_ListBuffer().init___();
    var x$133 = this$201.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$134 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$206 = new $c_scm_ListBuffer().init___();
    var x$135 = this$206.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$136 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$137 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$138 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$139 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$140 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$141 = $m_s_None$();
    validations.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$123, message$2, x$125, x$126, x$129, x$127, x$130, x$131, x$132, x$133, x$134, x$128, x$135, x$136, x$137, x$138, x$139, x$140, x$141))
  };
  var this$213 = $as_Lamf_core_model_BoolField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().AllowMultiple$1));
  if ((!$f_Lamf_core_model_BoolField__value__Z(this$213))) {
    var this$214 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermKeyProperty$1));
    var jsx$8 = $f_Lamf_core_model_StrField__isNullOrEmpty__Z(this$214)
  } else {
    var jsx$8 = false
  };
  if (jsx$8) {
    var message$2$1 = (("Property '" + $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1))) + "' cannot have more than 1 value");
    var this$215 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
    var this$216 = this$215.option$1;
    var x$170 = this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$216.isEmpty__Z() ? null : this$216.get__O())), "notCollection");
    var x$172 = new $c_s_Some().init___O(message$2$1);
    var x$173 = new $c_s_Some().init___O(message$2$1);
    var jsx$9 = $m_sc_Seq$();
    var array$6 = [node.id$1];
    var x$174 = $as_sc_Seq(jsx$9.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$6)));
    var jsx$10 = $m_sc_Seq$();
    var this$219 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
    var this$220 = this$219.option$1;
    var x$142 = $as_T((this$220.isEmpty__Z() ? null : this$220.get__O()));
    var this$221 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
    var this$222 = this$221.option$1;
    var x$143 = (this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$222.isEmpty__Z() ? null : this$222.get__O())), "notCollection") + "/prop");
    var x$144 = new $c_s_Some().init___O(message$2$1);
    var x$145 = new $c_s_Some().init___O("1");
    var x$146 = $m_s_None$();
    var x$147 = $m_s_None$();
    var x$148 = $m_s_None$();
    var x$149 = $m_s_None$();
    var x$150 = $m_s_None$();
    var x$151 = $m_s_None$();
    var x$152 = $m_s_None$();
    var x$153 = $m_s_None$();
    var x$154 = $m_s_None$();
    var x$155 = $m_s_None$();
    var x$156 = $m_s_None$();
    var x$157 = $m_s_None$();
    var x$158 = $m_s_None$();
    var x$159 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$240 = new $c_scm_ListBuffer().init___();
    var x$160 = this$240.toList__sci_List();
    var x$161 = $m_s_None$();
    var x$162 = $m_s_None$();
    var x$163 = $m_s_None$();
    var x$164 = $m_s_None$();
    var x$165 = $m_s_None$();
    var x$166 = $m_s_None$();
    var x$167 = $m_s_None$();
    var x$168 = $m_s_None$();
    var x$169 = $m_s_None$();
    var array$7 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$142, x$143, x$146, x$144, x$147, x$148, x$145, x$149, x$150, x$151, x$152, x$153, x$154, x$155, x$156, x$157, x$158, x$159, x$160, x$161, x$162, x$163, x$164, x$165, x$166, x$167, x$168, x$169)];
    var x$175 = $as_sc_Seq(jsx$10.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$7)));
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$255 = new $c_scm_ListBuffer().init___();
    var x$176 = this$255.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$259 = new $c_scm_ListBuffer().init___();
    var x$177 = this$259.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$263 = new $c_scm_ListBuffer().init___();
    var x$178 = this$263.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$267 = new $c_scm_ListBuffer().init___();
    var x$179 = this$267.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$271 = new $c_scm_ListBuffer().init___();
    var x$180 = this$271.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$181 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$276 = new $c_scm_ListBuffer().init___();
    var x$182 = this$276.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$183 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$184 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$185 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$186 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$187 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$188 = $m_s_None$();
    validations.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$170, message$2$1, x$172, x$173, x$176, x$174, x$177, x$178, x$179, x$180, x$181, x$175, x$182, x$183, x$184, x$185, x$186, x$187, x$188))
  };
  var x1 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Pattern$1)).option$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var pattern = $as_T(x2.value$2);
    var message$3 = ((("Property '" + $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1))) + "' must match pattern ") + pattern);
    var this$283 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
    var this$284 = this$283.option$1;
    var x$217 = this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$284.isEmpty__Z() ? null : this$284.get__O())), "pattern");
    var x$219 = new $c_s_Some().init___O(message$3);
    var x$220 = new $c_s_Some().init___O(message$3);
    var jsx$11 = $m_sc_Seq$();
    var array$8 = [node.id$1];
    var x$221 = $as_sc_Seq(jsx$11.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$8)));
    var jsx$12 = $m_sc_Seq$();
    var this$287 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
    var this$288 = this$287.option$1;
    var x$189 = $as_T((this$288.isEmpty__Z() ? null : this$288.get__O()));
    var this$289 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
    var this$290 = this$289.option$1;
    var x$190 = (this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$290.isEmpty__Z() ? null : this$290.get__O())), "pattern") + "/prop");
    var x$191 = new $c_s_Some().init___O(message$3);
    var x$192 = new $c_s_Some().init___O(pattern);
    var x$193 = $m_s_None$();
    var x$194 = $m_s_None$();
    var x$195 = $m_s_None$();
    var x$196 = $m_s_None$();
    var x$197 = $m_s_None$();
    var x$198 = $m_s_None$();
    var x$199 = $m_s_None$();
    var x$200 = $m_s_None$();
    var x$201 = $m_s_None$();
    var x$202 = $m_s_None$();
    var x$203 = $m_s_None$();
    var x$204 = $m_s_None$();
    var x$205 = $m_s_None$();
    var x$206 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$308 = new $c_scm_ListBuffer().init___();
    var x$207 = this$308.toList__sci_List();
    var x$208 = $m_s_None$();
    var x$209 = $m_s_None$();
    var x$210 = $m_s_None$();
    var x$211 = $m_s_None$();
    var x$212 = $m_s_None$();
    var x$213 = $m_s_None$();
    var x$214 = $m_s_None$();
    var x$215 = $m_s_None$();
    var x$216 = $m_s_None$();
    var array$9 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$189, x$190, x$193, x$191, x$192, x$194, x$195, x$196, x$197, x$198, x$199, x$200, x$201, x$202, x$203, x$204, x$205, x$206, x$207, x$208, x$209, x$210, x$211, x$212, x$213, x$214, x$215, x$216)];
    var x$222 = $as_sc_Seq(jsx$12.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$9)));
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$323 = new $c_scm_ListBuffer().init___();
    var x$223 = this$323.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$327 = new $c_scm_ListBuffer().init___();
    var x$224 = this$327.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$331 = new $c_scm_ListBuffer().init___();
    var x$225 = this$331.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$335 = new $c_scm_ListBuffer().init___();
    var x$226 = this$335.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$339 = new $c_scm_ListBuffer().init___();
    var x$227 = this$339.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$228 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$344 = new $c_scm_ListBuffer().init___();
    var x$229 = this$344.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$230 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$231 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$232 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$233 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$234 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$235 = $m_s_None$();
    validations.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$217, message$3, x$219, x$220, x$223, x$221, x$224, x$225, x$226, x$227, x$228, x$222, x$229, x$230, x$231, x$232, x$233, x$234, x$235))
  };
  if ($as_sc_Seq(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Enum$1)).nonEmpty__Z()) {
    var jsx$14 = $as_sc_Seq(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Enum$1));
    var jsx$13 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
      return (function(x$3$2) {
        var x$3$1 = $as_Lamf_core_model_AnyField(x$3$2);
        var this$351 = x$3$1.option$1;
        return (this$351.isEmpty__Z() ? null : this$351.get__O())
      })
    })(this));
    var this$352 = $m_sc_Seq$();
    var values = $as_sc_Seq(jsx$14.map__F1__scg_CanBuildFrom__O(jsx$13, this$352.ReusableCBFInstance$2));
    var message$4 = ((("Property '" + $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1))) + "' must match some value in ") + values.mkString__T__T(","));
    var this$353 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
    var this$354 = this$353.option$1;
    var x$264 = this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$354.isEmpty__Z() ? null : this$354.get__O())), "enum");
    var x$266 = new $c_s_Some().init___O(message$4);
    var x$267 = new $c_s_Some().init___O(message$4);
    var jsx$15 = $m_sc_Seq$();
    var array$10 = [node.id$1];
    var x$268 = $as_sc_Seq(jsx$15.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$10)));
    var jsx$17 = $m_sc_Seq$();
    var this$357 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
    var this$358 = this$357.option$1;
    var x$236 = $as_T((this$358.isEmpty__Z() ? null : this$358.get__O()));
    var this$359 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
    var this$360 = this$359.option$1;
    var x$237 = (this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$360.isEmpty__Z() ? null : this$360.get__O())), "enum") + "/prop");
    var x$238 = new $c_s_Some().init___O(message$4);
    var jsx$16 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
      return (function(v$2) {
        return ("" + v$2)
      })
    })(this));
    var this$361 = $m_sc_Seq$();
    var x$239 = $as_sc_Seq(values.map__F1__scg_CanBuildFrom__O(jsx$16, this$361.ReusableCBFInstance$2));
    var x$240 = $m_s_None$();
    var x$241 = $m_s_None$();
    var x$242 = $m_s_None$();
    var x$243 = $m_s_None$();
    var x$244 = $m_s_None$();
    var x$245 = $m_s_None$();
    var x$246 = $m_s_None$();
    var x$247 = $m_s_None$();
    var x$248 = $m_s_None$();
    var x$249 = $m_s_None$();
    var x$250 = $m_s_None$();
    var x$251 = $m_s_None$();
    var x$252 = $m_s_None$();
    var x$253 = $m_s_None$();
    var x$254 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var x$255 = $m_s_None$();
    var x$256 = $m_s_None$();
    var x$257 = $m_s_None$();
    var x$258 = $m_s_None$();
    var x$259 = $m_s_None$();
    var x$260 = $m_s_None$();
    var x$261 = $m_s_None$();
    var x$262 = $m_s_None$();
    var x$263 = $m_s_None$();
    var array$11 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$236, x$237, x$240, x$238, x$241, x$242, x$243, x$244, x$245, x$246, x$247, x$248, x$249, x$250, x$251, x$252, x$253, x$254, x$239, x$255, x$256, x$257, x$258, x$259, x$260, x$261, x$262, x$263)];
    var x$269 = $as_sc_Seq(jsx$17.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$11)));
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$391 = new $c_scm_ListBuffer().init___();
    var x$270 = this$391.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$395 = new $c_scm_ListBuffer().init___();
    var x$271 = this$395.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$399 = new $c_scm_ListBuffer().init___();
    var x$272 = this$399.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$403 = new $c_scm_ListBuffer().init___();
    var x$273 = this$403.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$407 = new $c_scm_ListBuffer().init___();
    var x$274 = this$407.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$275 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$412 = new $c_scm_ListBuffer().init___();
    var x$276 = this$412.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$277 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$278 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$279 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$280 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$281 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$282 = $m_s_None$();
    validations.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$264, message$4, x$266, x$267, x$270, x$268, x$271, x$272, x$273, x$274, x$275, x$269, x$276, x$277, x$278, x$279, x$280, x$281, x$282))
  };
  var this$419 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
  if (this$419.option$1.isDefined__Z()) {
    var this$420 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
    var this$421 = this$420.option$1;
    var dataRange = $as_T((this$421.isEmpty__Z() ? null : this$421.get__O()));
    if (($m_Lamf_core_model_DataType$().Any$1 !== dataRange)) {
      if ((($m_Lamf_core_model_DataType$().Number$1 === dataRange) || (($m_Lamf_core_model_DataType$().Float$1 === dataRange) || ($m_Lamf_core_model_DataType$().Double$1 === dataRange)))) {
        var message$5 = ((((("Property '" + $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1))) + "'  value must be of type ") + $m_Lamf_core_model_DataType$().Integer$1) + " or ") + $m_Lamf_core_model_DataType$().Float$1);
        var this$422 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
        var this$423 = this$422.option$1;
        var x$311 = this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$423.isEmpty__Z() ? null : this$423.get__O())), "dialectRange");
        var x$313 = new $c_s_Some().init___O(message$5);
        var x$314 = new $c_s_Some().init___O(message$5);
        var jsx$18 = $m_sc_Seq$();
        var array$12 = [node.id$1];
        var x$315 = $as_sc_Seq(jsx$18.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$12)));
        var jsx$33 = $m_sc_Seq$();
        var this$426 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
        var this$427 = this$426.option$1;
        var x$283 = $as_T((this$427.isEmpty__Z() ? null : this$427.get__O()));
        var this$428 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
        var this$429 = this$428.option$1;
        var x$284 = (this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$429.isEmpty__Z() ? null : this$429.get__O())), "dialectRange") + "/prop");
        var x$285 = new $c_s_Some().init___O(message$5);
        var x$286$1 = new $c_s_Some().init___O(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$5$1) {
          return (function(b$2, x$4$2) {
            var b = $as_Lorg_yaml_model_YDocument$EntryBuilder(b$2);
            $as_T(x$4$2);
            $m_Lorg_yaml_model_YNode$();
            var this$430 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
            var str = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$430, "or").iri__T();
            var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
            var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
            var jsx$28 = v.builder$1;
            var sourceName = v.sourceName$2;
            var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
            $m_Lorg_yaml_model_YNode$();
            var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@list");
            var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
            var jsx$26 = v$1.builder$1;
            var sourceName$1 = v$1.sourceName$2;
            var b$3 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$1);
            var jsx$21 = b$3.builder$1;
            var sourceName$2 = b$3.sourceName$2;
            var b$4 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$2);
            $m_Lorg_yaml_model_YNode$();
            var this$437 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
            var str$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$437, "datatype").iri__T();
            var key$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
            var v$3 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$4.sourceName$2);
            var jsx$19 = v$3.builder$1;
            var sourceName$3 = v$3.sourceName$2;
            var b$5 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$3);
            $m_Lorg_yaml_model_YNode$();
            var key$3 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@id");
            $m_Lorg_yaml_model_YNode$();
            var thiz = $m_Lamf_core_model_DataType$().Integer$1;
            var str$2 = $as_T(thiz.trim());
            var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$2);
            b$5.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$3, value);
            jsx$19.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$5.builder$1, sourceName$3), $m_Lorg_yaml_model_YType$().Map$1));
            var this$446 = v$3.builder$1;
            var array$13 = [key$2];
            if ((this$446.size0$6 < 0)) {
              throw new $c_jl_IndexOutOfBoundsException().init___T("0")
            };
            var len = $uI(array$13.length);
            var newSize = ((this$446.size0$6 + len) | 0);
            $f_scm_ResizableArray__ensureSize__I__V(this$446, newSize);
            var len$1 = this$446.size0$6;
            var src = this$446.array$6;
            var dest = this$446.array$6;
            $systemArraycopy(src, 0, dest, len, len$1);
            var xs = this$446.array$6;
            var len$2 = xs.u.length;
            var i = 0;
            var j = 0;
            var x = $uI(array$13.length);
            var x$30 = ((x < len$2) ? x : len$2);
            var that = xs.u.length;
            var end = ((x$30 < that) ? x$30 : that);
            while ((i < end)) {
              var jsx$20 = j;
              var index = i;
              xs.set(jsx$20, array$13[index]);
              i = ((1 + i) | 0);
              j = ((1 + j) | 0)
            };
            this$446.size0$6 = newSize;
            b$4.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$3.builder$1));
            jsx$21.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$4.builder$1, sourceName$2), $m_Lorg_yaml_model_YType$().Map$1));
            var jsx$24 = b$3.builder$1;
            var sourceName$4 = b$3.sourceName$2;
            var b$6 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$4);
            $m_Lorg_yaml_model_YNode$();
            var this$458 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
            var str$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$458, "datatype").iri__T();
            var key$4 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$3);
            var v$4 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$6.sourceName$2);
            var jsx$22 = v$4.builder$1;
            var sourceName$5 = v$4.sourceName$2;
            var b$7 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$5);
            $m_Lorg_yaml_model_YNode$();
            var key$5 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@id");
            $m_Lorg_yaml_model_YNode$();
            var thiz$1 = $m_Lamf_core_model_DataType$().Double$1;
            var str$4 = $as_T(thiz$1.trim());
            var value$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$4);
            b$7.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$5, value$1);
            jsx$22.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$7.builder$1, sourceName$5), $m_Lorg_yaml_model_YType$().Map$1));
            var this$467 = v$4.builder$1;
            var array$14 = [key$4];
            if ((this$467.size0$6 < 0)) {
              throw new $c_jl_IndexOutOfBoundsException().init___T("0")
            };
            var len$3 = $uI(array$14.length);
            var newSize$1 = ((this$467.size0$6 + len$3) | 0);
            $f_scm_ResizableArray__ensureSize__I__V(this$467, newSize$1);
            var len$4 = this$467.size0$6;
            var src$1 = this$467.array$6;
            var dest$1 = this$467.array$6;
            $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
            var xs$1 = this$467.array$6;
            var len$5 = xs$1.u.length;
            var i$1 = 0;
            var j$1 = 0;
            var x$77 = $uI(array$14.length);
            var x$124 = ((x$77 < len$5) ? x$77 : len$5);
            var that$1 = xs$1.u.length;
            var end$1 = ((x$124 < that$1) ? x$124 : that$1);
            while ((i$1 < end$1)) {
              var jsx$23 = j$1;
              var index$1 = i$1;
              xs$1.set(jsx$23, array$14[index$1]);
              i$1 = ((1 + i$1) | 0);
              j$1 = ((1 + j$1) | 0)
            };
            this$467.size0$6 = newSize$1;
            b$6.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$4.builder$1));
            jsx$24.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$6.builder$1, sourceName$4), $m_Lorg_yaml_model_YType$().Map$1));
            var jsx$25 = $m_Lorg_yaml_model_YNode$();
            $m_Lorg_yaml_model_YSequence$();
            var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$1);
            var parts = b$3.builder$1;
            var node$1 = jsx$25.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
            jsx$26.$$plus$eq__O__scm_ArrayBuffer(node$1);
            var this$481 = v$1.builder$1;
            var array$15 = [key$1];
            if ((this$481.size0$6 < 0)) {
              throw new $c_jl_IndexOutOfBoundsException().init___T("0")
            };
            var len$6 = $uI(array$15.length);
            var newSize$2 = ((this$481.size0$6 + len$6) | 0);
            $f_scm_ResizableArray__ensureSize__I__V(this$481, newSize$2);
            var len$7 = this$481.size0$6;
            var src$2 = this$481.array$6;
            var dest$2 = this$481.array$6;
            $systemArraycopy(src$2, 0, dest$2, len$6, len$7);
            var xs$2 = this$481.array$6;
            var len$8 = xs$2.u.length;
            var i$2 = 0;
            var j$2 = 0;
            var x$171 = $uI(array$15.length);
            var x$218 = ((x$171 < len$8) ? x$171 : len$8);
            var that$2 = xs$2.u.length;
            var end$2 = ((x$218 < that$2) ? x$218 : that$2);
            while ((i$2 < end$2)) {
              var jsx$27 = j$2;
              var index$2 = i$2;
              xs$2.set(jsx$27, array$15[index$2]);
              i$2 = ((1 + i$2) | 0);
              j$2 = ((1 + j$2) | 0)
            };
            this$481.size0$6 = newSize$2;
            b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1));
            jsx$28.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
            var this$494 = v.builder$1;
            var array$16 = [key];
            if ((this$494.size0$6 < 0)) {
              throw new $c_jl_IndexOutOfBoundsException().init___T("0")
            };
            var len$9 = $uI(array$16.length);
            var newSize$3 = ((this$494.size0$6 + len$9) | 0);
            $f_scm_ResizableArray__ensureSize__I__V(this$494, newSize$3);
            var len$10 = this$494.size0$6;
            var src$3 = this$494.array$6;
            var dest$3 = this$494.array$6;
            $systemArraycopy(src$3, 0, dest$3, len$9, len$10);
            var xs$3 = this$494.array$6;
            var len$11 = xs$3.u.length;
            var i$3 = 0;
            var j$3 = 0;
            var x$265 = $uI(array$16.length);
            var x$286 = ((x$265 < len$11) ? x$265 : len$11);
            var that$3 = xs$3.u.length;
            var end$3 = ((x$286 < that$3) ? x$286 : that$3);
            while ((i$3 < end$3)) {
              var jsx$29 = j$3;
              var index$3 = i$3;
              xs$3.set(jsx$29, array$16[index$3]);
              i$3 = ((1 + i$3) | 0);
              j$3 = ((1 + j$3) | 0)
            };
            this$494.size0$6 = newSize$3;
            b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
          })
        })(this)));
        var x$287 = new $c_s_Some().init___O(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$6$1) {
          return (function(rdfModel$2, subject$2) {
            var rdfModel = $as_Lamf_core_rdf_RdfModel(rdfModel$2);
            var subject = $as_T(subject$2);
            var propId = rdfModel.nextAnonId__T();
            var firstConstraintListId = (propId + "_ointdoub1");
            var nextConstraintListId = (propId + "_ointdoub2");
            var this$505 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
            rdfModel.addTriple__T__T__T__Lamf_core_rdf_RdfModel(subject, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$505, "or").iri__T(), firstConstraintListId);
            var this$507 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
            rdfModel.addTriple__T__T__T__Lamf_core_rdf_RdfModel(firstConstraintListId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$507, "first").iri__T(), (firstConstraintListId + "_v"));
            var this$509 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
            var jsx$30 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$509, "datatype").iri__T();
            var thiz$2 = $m_Lamf_core_model_DataType$().Integer$1;
            rdfModel.addTriple__T__T__T__Lamf_core_rdf_RdfModel((firstConstraintListId + "_v"), jsx$30, $as_T(thiz$2.trim()));
            var this$512 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
            rdfModel.addTriple__T__T__T__Lamf_core_rdf_RdfModel(firstConstraintListId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$512, "rest").iri__T(), nextConstraintListId);
            var this$514 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
            rdfModel.addTriple__T__T__T__Lamf_core_rdf_RdfModel(nextConstraintListId, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$514, "first").iri__T(), (nextConstraintListId + "_v"));
            var this$516 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
            var jsx$31 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$516, "datatype").iri__T();
            var thiz$3 = $m_Lamf_core_model_DataType$().Double$1;
            rdfModel.addTriple__T__T__T__Lamf_core_rdf_RdfModel((nextConstraintListId + "_v"), jsx$31, $as_T(thiz$3.trim()));
            var this$519 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
            var jsx$32 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$519, "rest").iri__T();
            var this$521 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
            return rdfModel.addTriple__T__T__T__Lamf_core_rdf_RdfModel(nextConstraintListId, jsx$32, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$521, "nil").iri__T())
          })
        })(this)));
        var x$288 = $m_s_None$();
        var x$289 = $m_s_None$();
        var x$290 = $m_s_None$();
        var x$291 = $m_s_None$();
        var x$292 = $m_s_None$();
        var x$293 = $m_s_None$();
        var x$294 = $m_s_None$();
        var x$295 = $m_s_None$();
        var x$296 = $m_s_None$();
        var x$297 = $m_s_None$();
        var x$298 = $m_s_None$();
        var x$299 = $m_s_None$();
        var x$300 = $m_s_None$();
        var x$301 = $m_s_None$();
        var x$302 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$541 = new $c_scm_ListBuffer().init___();
        var x$303 = this$541.toList__sci_List();
        var x$304 = $m_s_None$();
        var x$305 = $m_s_None$();
        var x$306 = $m_s_None$();
        var x$307 = $m_s_None$();
        var x$308 = $m_s_None$();
        var x$309 = $m_s_None$();
        var x$310 = $m_s_None$();
        var array$17 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$283, x$284, x$288, x$285, x$289, x$290, x$291, x$292, x$293, x$294, x$295, x$296, x$297, x$298, x$299, x$300, x$301, x$302, x$303, x$286$1, x$287, x$304, x$305, x$306, x$307, x$308, x$309, x$310)];
        var x$316 = $as_sc_Seq(jsx$33.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$17)));
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$554 = new $c_scm_ListBuffer().init___();
        var x$317 = this$554.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$558 = new $c_scm_ListBuffer().init___();
        var x$318 = this$558.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$562 = new $c_scm_ListBuffer().init___();
        var x$319 = this$562.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$566 = new $c_scm_ListBuffer().init___();
        var x$320 = this$566.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$570 = new $c_scm_ListBuffer().init___();
        var x$321 = this$570.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$322 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$575 = new $c_scm_ListBuffer().init___();
        var x$323 = this$575.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$324 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$325 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$326 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$327 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$328 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$329 = $m_s_None$();
        validations.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$311, message$5, x$313, x$314, x$317, x$315, x$318, x$319, x$320, x$321, x$322, x$316, x$323, x$324, x$325, x$326, x$327, x$328, x$329))
      } else if (($m_Lamf_core_model_DataType$().Link$1 === dataRange)) {
        var message$6 = (("Property '" + $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1))) + "'  value must be of a link");
        var this$582 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
        var this$583 = this$582.option$1;
        var x$358 = this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$583.isEmpty__Z() ? null : this$583.get__O())), "dialectRange");
        var x$360 = new $c_s_Some().init___O(message$6);
        var x$361 = new $c_s_Some().init___O(message$6);
        var jsx$34 = $m_sc_Seq$();
        var array$18 = [node.id$1];
        var x$362 = $as_sc_Seq(jsx$34.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$18)));
        var jsx$38 = $m_sc_Seq$();
        var this$586 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
        var this$587 = this$586.option$1;
        var x$330 = $as_T((this$587.isEmpty__Z() ? null : this$587.get__O()));
        var this$588 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
        var this$589 = this$588.option$1;
        var x$331 = (this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$589.isEmpty__Z() ? null : this$589.get__O())), "dialectRange") + "/prop");
        var x$332 = new $c_s_Some().init___O(message$6);
        var x$333$1 = new $c_s_Some().init___O(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$7$1) {
          return (function(b$3$2, x$12$2) {
            var b$3$1 = $as_Lorg_yaml_model_YDocument$EntryBuilder(b$3$2);
            $as_T(x$12$2);
            $m_Lorg_yaml_model_YNode$();
            var this$590 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
            var str$5 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$590, "nodeKind").iri__T();
            var key$6 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$5);
            var v$5 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$3$1.sourceName$2);
            var jsx$35 = v$5.builder$1;
            var sourceName$6 = v$5.sourceName$2;
            var b$8 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$6);
            $m_Lorg_yaml_model_YNode$();
            var key$7 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@id");
            $m_Lorg_yaml_model_YNode$();
            var this$595 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
            var str$6 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$595, "IRI").iri__T();
            var value$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$6);
            b$8.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$7, value$2);
            jsx$35.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$8.builder$1, sourceName$6), $m_Lorg_yaml_model_YType$().Map$1));
            var this$600 = v$5.builder$1;
            var array$19 = [key$6];
            if ((this$600.size0$6 < 0)) {
              throw new $c_jl_IndexOutOfBoundsException().init___T("0")
            };
            var len$12 = $uI(array$19.length);
            var newSize$4 = ((this$600.size0$6 + len$12) | 0);
            $f_scm_ResizableArray__ensureSize__I__V(this$600, newSize$4);
            var len$13 = this$600.size0$6;
            var src$4 = this$600.array$6;
            var dest$4 = this$600.array$6;
            $systemArraycopy(src$4, 0, dest$4, len$12, len$13);
            var xs$4 = this$600.array$6;
            var len$14 = xs$4.u.length;
            var i$4 = 0;
            var j$4 = 0;
            var x$312 = $uI(array$19.length);
            var x$333 = ((x$312 < len$14) ? x$312 : len$14);
            var that$4 = xs$4.u.length;
            var end$4 = ((x$333 < that$4) ? x$333 : that$4);
            while ((i$4 < end$4)) {
              var jsx$36 = j$4;
              var index$4 = i$4;
              xs$4.set(jsx$36, array$19[index$4]);
              i$4 = ((1 + i$4) | 0);
              j$4 = ((1 + j$4) | 0)
            };
            this$600.size0$6 = newSize$4;
            b$3$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$5.builder$1))
          })
        })(this)));
        var x$334 = new $c_s_Some().init___O(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$8$1) {
          return (function(rdfModel$3$2, subject$3$2) {
            var rdfModel$3 = $as_Lamf_core_rdf_RdfModel(rdfModel$3$2);
            var subject$3 = $as_T(subject$3$2);
            rdfModel$3.nextAnonId__T();
            var this$611 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
            var jsx$37 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$611, "nodeKind").iri__T();
            var this$613 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
            return rdfModel$3.addTriple__T__T__T__Lamf_core_rdf_RdfModel(subject$3, jsx$37, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$613, "IRI").iri__T())
          })
        })(this)));
        var x$335 = $m_s_None$();
        var x$336 = $m_s_None$();
        var x$337 = $m_s_None$();
        var x$338 = $m_s_None$();
        var x$339 = $m_s_None$();
        var x$340 = $m_s_None$();
        var x$341 = $m_s_None$();
        var x$342 = $m_s_None$();
        var x$343 = $m_s_None$();
        var x$344 = $m_s_None$();
        var x$345 = $m_s_None$();
        var x$346 = $m_s_None$();
        var x$347 = $m_s_None$();
        var x$348 = $m_s_None$();
        var x$349 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$633 = new $c_scm_ListBuffer().init___();
        var x$350 = this$633.toList__sci_List();
        var x$351 = $m_s_None$();
        var x$352 = $m_s_None$();
        var x$353 = $m_s_None$();
        var x$354 = $m_s_None$();
        var x$355 = $m_s_None$();
        var x$356 = $m_s_None$();
        var x$357 = $m_s_None$();
        var array$20 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$330, x$331, x$335, x$332, x$336, x$337, x$338, x$339, x$340, x$341, x$342, x$343, x$344, x$345, x$346, x$347, x$348, x$349, x$350, x$333$1, x$334, x$351, x$352, x$353, x$354, x$355, x$356, x$357)];
        var x$363 = $as_sc_Seq(jsx$38.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$20)));
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$646 = new $c_scm_ListBuffer().init___();
        var x$364 = this$646.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$650 = new $c_scm_ListBuffer().init___();
        var x$365 = this$650.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$654 = new $c_scm_ListBuffer().init___();
        var x$366 = this$654.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$658 = new $c_scm_ListBuffer().init___();
        var x$367 = this$658.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$662 = new $c_scm_ListBuffer().init___();
        var x$368 = this$662.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$369 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$667 = new $c_scm_ListBuffer().init___();
        var x$370 = this$667.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$371 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$372 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$373 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$374 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$375 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$376 = $m_s_None$();
        validations.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$358, message$6, x$360, x$361, x$364, x$362, x$365, x$366, x$367, x$368, x$369, x$363, x$370, x$371, x$372, x$373, x$374, x$375, x$376))
      } else if ($m_sjsr_RuntimeString$().endsWith__T__T__Z(dataRange, "guid")) {
        var message$7 = ((("Property '" + $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1))) + "'  value must be of type xsd:string > ") + dataRange);
        var this$674 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
        var this$675 = this$674.option$1;
        var x$405 = this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$675.isEmpty__Z() ? null : this$675.get__O())), "dataRange");
        var x$407 = new $c_s_Some().init___O(message$7);
        var x$408 = new $c_s_Some().init___O(message$7);
        var jsx$39 = $m_sc_Seq$();
        var array$21 = [node.id$1];
        var x$409 = $as_sc_Seq(jsx$39.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$21)));
        var jsx$40 = $m_sc_Seq$();
        var this$678 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
        var this$679 = this$678.option$1;
        var x$377 = $as_T((this$679.isEmpty__Z() ? null : this$679.get__O()));
        var this$680 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
        var this$681 = this$680.option$1;
        var x$378 = (this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$681.isEmpty__Z() ? null : this$681.get__O())), "dataRange") + "/prop");
        var x$379 = new $c_s_Some().init___O(message$7);
        var this$682 = $m_Lamf_core_vocabulary_Namespace$().Xsd$1;
        var x$380 = new $c_s_Some().init___O(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$682, "string").iri__T());
        var x$381 = $m_s_None$();
        var x$382 = $m_s_None$();
        var x$383 = $m_s_None$();
        var x$384 = $m_s_None$();
        var x$385 = $m_s_None$();
        var x$386 = $m_s_None$();
        var x$387 = $m_s_None$();
        var x$388 = $m_s_None$();
        var x$389 = $m_s_None$();
        var x$390 = $m_s_None$();
        var x$391 = $m_s_None$();
        var x$392 = $m_s_None$();
        var x$393 = $m_s_None$();
        var x$394 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$701 = new $c_scm_ListBuffer().init___();
        var x$395 = this$701.toList__sci_List();
        var x$396 = $m_s_None$();
        var x$397 = $m_s_None$();
        var x$398 = $m_s_None$();
        var x$399 = $m_s_None$();
        var x$400 = $m_s_None$();
        var x$401 = $m_s_None$();
        var x$402 = $m_s_None$();
        var x$403 = $m_s_None$();
        var x$404 = $m_s_None$();
        var array$22 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$377, x$378, x$381, x$379, x$382, x$383, x$384, x$385, x$386, x$387, x$388, x$389, x$390, x$391, x$392, x$393, x$380, x$394, x$395, x$396, x$397, x$398, x$399, x$400, x$401, x$402, x$403, x$404)];
        var x$410 = $as_sc_Seq(jsx$40.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$22)));
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$716 = new $c_scm_ListBuffer().init___();
        var x$411 = this$716.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$720 = new $c_scm_ListBuffer().init___();
        var x$412 = this$720.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$724 = new $c_scm_ListBuffer().init___();
        var x$413 = this$724.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$728 = new $c_scm_ListBuffer().init___();
        var x$414 = this$728.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$732 = new $c_scm_ListBuffer().init___();
        var x$415 = this$732.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$416 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$737 = new $c_scm_ListBuffer().init___();
        var x$417 = this$737.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$418 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$419 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$420 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$421 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$422 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$423 = $m_s_None$();
        validations.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$405, message$7, x$407, x$408, x$411, x$409, x$412, x$413, x$414, x$415, x$416, x$410, x$417, x$418, x$419, x$420, x$421, x$422, x$423))
      } else if ((dataRange !== $m_Lamf_core_model_DataType$().Any$1)) {
        var message$8 = ((("Property '" + $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1))) + "'  value must be of type ") + dataRange);
        var this$744 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
        var this$745 = this$744.option$1;
        var x$452 = this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$745.isEmpty__Z() ? null : this$745.get__O())), "dataRange");
        var x$454 = new $c_s_Some().init___O(message$8);
        var x$455 = new $c_s_Some().init___O(message$8);
        var jsx$41 = $m_sc_Seq$();
        var array$23 = [node.id$1];
        var x$456 = $as_sc_Seq(jsx$41.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$23)));
        var jsx$42 = $m_sc_Seq$();
        var this$748 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
        var this$749 = this$748.option$1;
        var x$424 = $as_T((this$749.isEmpty__Z() ? null : this$749.get__O()));
        var this$750 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
        var this$751 = this$750.option$1;
        var x$425 = (this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$751.isEmpty__Z() ? null : this$751.get__O())), "dataRange") + "/prop");
        var x$426 = new $c_s_Some().init___O(message$8);
        var x$427 = new $c_s_Some().init___O(dataRange);
        var x$428 = $m_s_None$();
        var x$429 = $m_s_None$();
        var x$430 = $m_s_None$();
        var x$431 = $m_s_None$();
        var x$432 = $m_s_None$();
        var x$433 = $m_s_None$();
        var x$434 = $m_s_None$();
        var x$435 = $m_s_None$();
        var x$436 = $m_s_None$();
        var x$437 = $m_s_None$();
        var x$438 = $m_s_None$();
        var x$439 = $m_s_None$();
        var x$440 = $m_s_None$();
        var x$441 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$769 = new $c_scm_ListBuffer().init___();
        var x$442 = this$769.toList__sci_List();
        var x$443 = $m_s_None$();
        var x$444 = $m_s_None$();
        var x$445 = $m_s_None$();
        var x$446 = $m_s_None$();
        var x$447 = $m_s_None$();
        var x$448 = $m_s_None$();
        var x$449 = $m_s_None$();
        var x$450 = $m_s_None$();
        var x$451 = $m_s_None$();
        var array$24 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$424, x$425, x$428, x$426, x$429, x$430, x$431, x$432, x$433, x$434, x$435, x$436, x$437, x$438, x$439, x$440, x$427, x$441, x$442, x$443, x$444, x$445, x$446, x$447, x$448, x$449, x$450, x$451)];
        var x$457 = $as_sc_Seq(jsx$42.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$24)));
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$784 = new $c_scm_ListBuffer().init___();
        var x$458 = this$784.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$788 = new $c_scm_ListBuffer().init___();
        var x$459 = this$788.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$792 = new $c_scm_ListBuffer().init___();
        var x$460 = this$792.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$796 = new $c_scm_ListBuffer().init___();
        var x$461 = this$796.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$800 = new $c_scm_ListBuffer().init___();
        var x$462 = this$800.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$463 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$805 = new $c_scm_ListBuffer().init___();
        var x$464 = this$805.toList__sci_List();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$465 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$466 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$467 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$468 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$469 = $m_s_None$();
        $m_Lamf_core_validation_core_ValidationSpecification$();
        var x$470 = $m_s_None$();
        validations.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$452, message$8, x$454, x$455, x$458, x$456, x$459, x$460, x$461, x$462, x$463, x$457, x$464, x$465, x$466, x$467, x$468, x$469, x$470))
      } else {
        throw new $c_s_MatchError().init___O(dataRange)
      }
    }
  };
  if ($as_sc_Seq(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1)).nonEmpty__Z()) {
    var jsx$47 = $as_sc_Seq(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1));
    var jsx$46 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$9$1) {
      return (function(x$15$2) {
        var x$15$1 = $as_Lamf_core_model_StrField(x$15$2);
        var this$812 = x$15$1.option$1;
        return $as_T((this$812.isEmpty__Z() ? null : this$812.get__O()))
      })
    })(this));
    var this$813 = $m_sc_Seq$();
    var jsx$45 = $as_sc_SeqLike(jsx$47.map__F1__scg_CanBuildFrom__O(jsx$46, this$813.ReusableCBFInstance$2));
    var this$814 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
    var jsx$44 = (!jsx$45.contains__O__Z(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$814, "anyNode").iri__T()))
  } else {
    var jsx$44 = false
  };
  if (jsx$44) {
    var this$816 = $as_Lamf_core_model_BoolField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().ExternallyLinkable$1)).option$1;
    var jsx$43 = (!$uZ((this$816.isEmpty__Z() ? false : this$816.get__O())))
  } else {
    var jsx$43 = false
  };
  if (jsx$43) {
    var jsx$52 = $as_sc_Seq(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1));
    var jsx$48 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$11$1) {
      return (function(rangeId$2) {
        var rangeId = $as_Lamf_core_model_StrField(rangeId$2);
        var this$817 = rangeId.option$1;
        var nodeMappingId = $as_T((this$817.isEmpty__Z() ? null : this$817.get__O()));
        var x1$1 = $f_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__findNodeMappingById__T__T2(this$11$1, nodeMappingId);
        if ((x1$1 !== null)) {
          var nodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1$1.$$und2__O());
          if ((nodeMapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
            var x4 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(nodeMapping);
            var jsx$49 = $m_sc_Seq$();
            var array$25 = [x4.id$1];
            return $as_sc_Seq(jsx$49.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$25)))
          }
        };
        if ((x1$1 !== null)) {
          var unionMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1$1.$$und2__O());
          if ((unionMapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping)) {
            var x5 = $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(unionMapping);
            var jsx$51 = $as_sc_Seq(x5.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1));
            var jsx$50 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
              return (function(x$16$2) {
                var x$16$1 = $as_Lamf_core_model_StrField(x$16$2);
                var this$820 = x$16$1.option$1;
                return $as_T((this$820.isEmpty__Z() ? null : this$820.get__O()))
              })
            })(this$11$1));
            var this$821 = $m_sc_Seq$();
            return $as_sc_Seq(jsx$51.map__F1__scg_CanBuildFrom__O(jsx$50, this$821.ReusableCBFInstance$2))
          }
        };
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$824 = new $c_scm_ListBuffer().init___();
        return this$824.toList__sci_List()
      })
    })(this));
    var this$825 = $m_sc_Seq$();
    var effectiveRange = $as_sc_TraversableOnce(jsx$52.flatMap__F1__scg_CanBuildFrom__O(jsx$48, this$825.ReusableCBFInstance$2)).toSet__sci_Set();
    var message$9 = ((("Property '" + $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1))) + "'  value must be of type ") + $as_sc_Seq(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1)));
    var this$826 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
    var this$827 = this$826.option$1;
    var x$499 = this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$827.isEmpty__Z() ? null : this$827.get__O())), "objectRange");
    var x$501 = new $c_s_Some().init___O(message$9);
    var x$502 = new $c_s_Some().init___O(message$9);
    var jsx$53 = $m_sc_Seq$();
    var array$26 = [node.id$1];
    var x$503 = $as_sc_Seq(jsx$53.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$26)));
    var jsx$54 = $m_sc_Seq$();
    var this$830 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
    var this$831 = this$830.option$1;
    var x$471 = $as_T((this$831.isEmpty__Z() ? null : this$831.get__O()));
    var this$832 = $as_Lamf_core_model_StrField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
    var this$833 = this$832.option$1;
    var x$472 = (this.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T(node, $as_T((this$833.isEmpty__Z() ? null : this$833.get__O())), "objectRange") + "/prop");
    var x$473 = new $c_s_Some().init___O(message$9);
    var x$474 = $f_sc_SetLike__toSeq__sc_Seq(effectiveRange);
    var x$475 = $m_s_None$();
    var x$476 = $m_s_None$();
    var x$477 = $m_s_None$();
    var x$478 = $m_s_None$();
    var x$479 = $m_s_None$();
    var x$480 = $m_s_None$();
    var x$481 = $m_s_None$();
    var x$482 = $m_s_None$();
    var x$483 = $m_s_None$();
    var x$484 = $m_s_None$();
    var x$485 = $m_s_None$();
    var x$486 = $m_s_None$();
    var x$487 = $m_s_None$();
    var x$488 = $m_s_None$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$851 = new $c_scm_ListBuffer().init___();
    var x$489 = this$851.toList__sci_List();
    var x$490 = $m_s_None$();
    var x$491 = $m_s_None$();
    var x$492 = $m_s_None$();
    var x$493 = $m_s_None$();
    var x$494 = $m_s_None$();
    var x$495 = $m_s_None$();
    var x$496 = $m_s_None$();
    var x$497 = $m_s_None$();
    var x$498 = $m_s_None$();
    var array$27 = [new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$471, x$472, x$475, x$473, x$476, x$477, x$478, x$479, x$480, x$481, x$482, x$483, x$484, x$485, x$486, x$487, x$488, x$474, x$489, x$490, x$491, x$492, x$493, x$494, x$495, x$496, x$497, x$498)];
    var x$504 = $as_sc_Seq(jsx$54.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$27)));
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$866 = new $c_scm_ListBuffer().init___();
    var x$505 = this$866.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$870 = new $c_scm_ListBuffer().init___();
    var x$506 = this$870.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$874 = new $c_scm_ListBuffer().init___();
    var x$507 = this$874.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$878 = new $c_scm_ListBuffer().init___();
    var x$508 = this$878.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$882 = new $c_scm_ListBuffer().init___();
    var x$509 = this$882.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$510 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$887 = new $c_scm_ListBuffer().init___();
    var x$511 = this$887.toList__sci_List();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$512 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$513 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$514 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$515 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$516 = $m_s_None$();
    $m_Lamf_core_validation_core_ValidationSpecification$();
    var x$517 = $m_s_None$();
    validations.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$499, message$9, x$501, x$502, x$505, x$503, x$506, x$507, x$508, x$509, x$510, x$504, x$511, x$512, x$513, x$514, x$515, x$516, x$517));
    effectiveRange.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$12$1, recursion$1, validations$1) {
      return (function(nodeMapping$2) {
        var nodeMapping$1 = $as_T(nodeMapping$2);
        var this$894 = this$12$1.dialect$1;
        var this$895 = $f_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer__findNodeMapping__T__s_Option(this$894, nodeMapping$1);
        if ((!this$895.isEmpty__Z())) {
          var arg1$2 = this$895.get__O();
          var mapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(arg1$2);
          if ((!recursion$1.contains__O__Z(mapping.id$1))) {
            validations$1.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(this$12$1.emitEntityValidations__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__scm_Set__sci_List(mapping, $as_scm_Set(recursion$1.$$plus$eq__O__scm_SetLike(mapping.id$1))))
          }
        }
      })
    })(this, recursion, validations)))
  };
  return validations.toList__sci_List()
});
$c_Lamf_plugins_document_vocabularies_validation_AMFDialectValidations.prototype.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect = (function() {
  return this.dialect$1
});
$c_Lamf_plugins_document_vocabularies_validation_AMFDialectValidations.prototype.profile__Lamf_core_validation_core_ValidationProfile = (function() {
  var parsedValidations = this.validations__sci_List();
  var x$1 = $m_Lamf_ProfileName$().apply__T__Lamf_ProfileName(this.dialect$1.nameAndVersion__T());
  var x$2 = $m_s_None$();
  var f = (function($this) {
    return (function(x$1$2$2) {
      var x$1$2 = $as_Lamf_core_validation_core_ValidationSpecification(x$1$2$2);
      return x$1$2.name$1
    })
  })(this);
  var this$1 = $m_sci_List$();
  var bf = this$1.ReusableCBFInstance$2;
  if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
    if ((parsedValidations === $m_sci_Nil$())) {
      var jsx$1 = $m_sci_Nil$()
    } else {
      var arg1 = parsedValidations.head__O();
      var h = new $c_sci_$colon$colon().init___O__sci_List(f(arg1), $m_sci_Nil$());
      var t = h;
      var rest = $as_sci_List(parsedValidations.tail__O());
      while ((rest !== $m_sci_Nil$())) {
        var arg1$1 = rest.head__O();
        var nx = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$1), $m_sci_Nil$());
        t.tl$5 = nx;
        t = nx;
        rest = $as_sci_List(rest.tail__O())
      };
      var jsx$1 = h
    }
  } else {
    var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(parsedValidations, bf);
    var these = parsedValidations;
    while ((!these.isEmpty__Z())) {
      var arg1$2 = these.head__O();
      b.$$plus$eq__O__scm_Builder(f(arg1$2));
      these = $as_sci_List(these.tail__O())
    };
    var jsx$1 = b.result__O()
  };
  var x$3 = $as_sc_Seq(jsx$1);
  var jsx$2 = $m_Lamf_plugins_features_validation_Validations$().validations$1;
  var this$2 = $m_sci_List$();
  var x$4 = $as_sc_Seq(parsedValidations.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$2.ReusableCBFInstance$2));
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$6 = new $c_scm_ListBuffer().init___();
  var x$5 = this$6.toList__sci_List();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$10 = new $c_scm_ListBuffer().init___();
  var x$6 = this$10.toList__sci_List();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$14 = new $c_scm_ListBuffer().init___();
  var x$7 = this$14.toList__sci_List();
  var x$8 = new $c_scm_HashMap().init___();
  return new $c_Lamf_core_validation_core_ValidationProfile().init___Lamf_ProfileName__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__scm_Map(x$1, x$2, x$3, x$5, x$6, x$7, x$4, x$8)
});
$c_Lamf_plugins_document_vocabularies_validation_AMFDialectValidations.prototype.validationId__p1__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__T__T = (function(dialectNode, propName, constraint) {
  var x1 = $m_s_Option$().apply__O__s_Option(dialectNode.id__T());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var id = $as_T(x2.value$2);
    var this$2 = new $c_Lamf_core_utils_package$AmfStrings().init___T(propName);
    var this$3 = this$2.platform$1;
    var url = this$2.str$1;
    return (((((id + "_") + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$3, url)) + "_") + constraint) + "_validation")
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Cannot generate validation for dialect node without ID"))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_validation_AMFDialectValidations.prototype.emitEntityValidations__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__scm_Set__sci_List = (function(node, recursion) {
  var jsx$2 = $as_sc_Seq(node.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, node$1, recursion$1) {
    return (function(propertyMapping$2) {
      var propertyMapping = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(propertyMapping$2);
      return $this.emitPropertyValidations__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__scm_Set__sci_List(node$1, propertyMapping, $as_scm_Set(recursion$1.$$plus$eq__O__scm_SetLike(node$1.id$1)))
    })
  })(this, node, recursion));
  var this$1 = $m_sc_Seq$();
  return $as_sc_TraversableOnce(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).toList__sci_List()
});
$c_Lamf_plugins_document_vocabularies_validation_AMFDialectValidations.prototype.validations__sci_List = (function() {
  var jsx$1 = $m_s_Option$();
  var this$1 = this.dialect$1;
  var this$2 = jsx$1.apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1)));
  if (this$2.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var docs = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(arg1);
    var this$3 = $m_s_Option$().apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(docs.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Root$1)))
  };
  if (this$3.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1$1 = this$3.get__O();
    var root = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(arg1$1);
    var this$4 = $as_Lamf_core_model_StrField(root.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().EncodedNode$1)).option$1
  };
  if (this$4.isEmpty__Z()) {
    var this$5 = $m_s_None$()
  } else {
    var arg1$2 = this$4.get__O();
    var mappingId = $as_T(arg1$2);
    var rc11 = false;
    var x2 = null;
    var x1 = $m_s_Option$().apply__O__s_Option($f_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__findNodeMappingById__T__T2(this, mappingId));
    matchEnd12: {
      var jsx$2;
      if ((x1 instanceof $c_s_Some)) {
        rc11 = true;
        x2 = $as_s_Some(x1);
        var p3 = $as_T2(x2.value$2);
        if ((p3 !== null)) {
          var nodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(p3.$$und2__O());
          if ((nodeMapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
            var x8 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(nodeMapping);
            var jsx$2 = this.emitEntityValidations__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__scm_Set__sci_List(x8, $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
            break matchEnd12
          }
        }
      };
      if (rc11) {
        var p6 = $as_T2(x2.value$2);
        if ((p6 !== null)) {
          var nodeMapping$2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(p6.$$und2__O());
          if ((nodeMapping$2 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping)) {
            var x9 = $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(nodeMapping$2);
            var jsx$2 = this.emitRootUnionNodeMapping__Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping__scm_Set__sci_List(x9, $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
            break matchEnd12
          }
        }
      };
      var jsx$2 = $m_sci_Nil$()
    };
    var this$5 = new $c_s_Some().init___O(jsx$2)
  };
  return $as_sci_List((this$5.isEmpty__Z() ? $m_sci_Nil$() : this$5.get__O()))
});
$c_Lamf_plugins_document_vocabularies_validation_AMFDialectValidations.prototype.emitRootUnionNodeMapping__Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping__scm_Set__sci_List = (function(nodeMapping, recursion) {
  $m_scm_ListBuffer$();
  var this$2 = new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_ListBuffer().init___());
  var validations = $as_scm_ListBuffer($as_sc_GenTraversable(this$2.elems$1));
  var jsx$2 = $as_sc_Seq(nodeMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_model_StrField(x$2$2);
      var this$3 = x$2.option$1;
      return $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()))
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  var range = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2));
  range.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, validations$1, recursion$1) {
    return (function(rangeId$2) {
      var rangeId = $as_T(rangeId$2);
      var x1 = $f_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__findNodeMappingById__T__T2(this$2$1, rangeId);
      if ((x1 !== null)) {
        var nodeMapping$1 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1.$$und2__O());
        if ((nodeMapping$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
          var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(nodeMapping$1);
          return validations$1.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(this$2$1.emitEntityValidations__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__scm_Set__sci_List(x3, $as_scm_Set(recursion$1.$$plus$eq__O__scm_SetLike(x3.id$1))))
        }
      }
    })
  })(this, validations, recursion)));
  return validations.toList__sci_List()
});
$c_Lamf_plugins_document_vocabularies_validation_AMFDialectValidations.prototype.init___Lamf_plugins_document_vocabularies_model_document_Dialect = (function(dialect) {
  this.dialect$1 = dialect;
  return this
});
var $d_Lamf_plugins_document_vocabularies_validation_AMFDialectValidations = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_validation_AMFDialectValidations: 0
}, false, "amf.plugins.document.vocabularies.validation.AMFDialectValidations", {
  Lamf_plugins_document_vocabularies_validation_AMFDialectValidations: 1,
  O: 1,
  Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper: 1
});
$c_Lamf_plugins_document_vocabularies_validation_AMFDialectValidations.prototype.$classData = $d_Lamf_plugins_document_vocabularies_validation_AMFDialectValidations;
/** @constructor */
function $c_Lamf_plugins_document_webapi_JsonRefsReferenceHandler() {
  $c_O.call(this);
  this.references$1 = null;
  this.refUrls$1 = null
}
$c_Lamf_plugins_document_webapi_JsonRefsReferenceHandler.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_JsonRefsReferenceHandler.prototype.constructor = $c_Lamf_plugins_document_webapi_JsonRefsReferenceHandler;
/** @constructor */
function $h_Lamf_plugins_document_webapi_JsonRefsReferenceHandler() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_JsonRefsReferenceHandler.prototype = $c_Lamf_plugins_document_webapi_JsonRefsReferenceHandler.prototype;
$c_Lamf_plugins_document_webapi_JsonRefsReferenceHandler.prototype.init___ = (function() {
  this.references$1 = new $c_Lamf_core_parser_ReferenceCollector().init___();
  this.refUrls$1 = $as_sci_Set($m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  return this
});
$c_Lamf_plugins_document_webapi_JsonRefsReferenceHandler.prototype.collectRef__p1__Lorg_yaml_model_YMap__Lamf_core_parser_ParserContext__V = (function(map, ctx) {
  var ref = $as_Lorg_yaml_model_YNode(map.map$3.apply__O__O(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("$ref"))));
  var x1 = ref.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Str$1;
  if ((x === x1)) {
    var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
    var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
    var refValue = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(ref, conversion, iv));
    if ((!(($uI(refValue.length) >= 0) && ($as_T(refValue.substring(0, $uI("#".length))) === "#")))) {
      var jsx$1 = this.refUrls$1;
      var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(refValue, "#", 0);
      var this$9 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
      this.refUrls$1 = $as_sci_Set(jsx$1.$$plus__O__sc_Set($f_sc_IndexedSeqOptimized__head__O(this$9)))
    }
  } else {
    var this$10 = ctx.eh$1;
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnresolvedReference$1;
    var message = ("Unexpected $ref with " + ref);
    var ast = ref.value__Lorg_yaml_model_YValue();
    var prop = $m_s_None$();
    var l = ast.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$10, specification, "", prop, message, l)
  }
});
$c_Lamf_plugins_document_webapi_JsonRefsReferenceHandler.prototype.update__Lamf_core_parser_ParsedReference__Lamf_core_CompilerContext__s_concurrent_ExecutionContext__s_concurrent_Future = (function(reference, compilerContext, executionContext) {
  return $m_s_concurrent_Future$().successful__O__s_concurrent_Future(reference)
});
$c_Lamf_plugins_document_webapi_JsonRefsReferenceHandler.prototype.collect__Lamf_core_parser_ParsedDocument__Lamf_core_parser_ParserContext__Lamf_core_parser_ReferenceCollector = (function(inputParsed, ctx) {
  if ((inputParsed instanceof $c_Lamf_core_parser_SyamlParsedDocument)) {
    var x2 = $as_Lamf_core_parser_SyamlParsedDocument(inputParsed);
    this.links__Lorg_yaml_model_YPart__Lamf_core_parser_ParserContext__V(x2.document$2, ctx);
    this.refUrls$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(ref$2) {
        var ref = $as_T(ref$2);
        if (((($uI(ref.length) >= 0) && ($as_T(ref.substring(0, $uI("http:".length))) === "http:")) || (($uI(ref.length) >= 0) && ($as_T(ref.substring(0, $uI("https:".length))) === "https:")))) {
          $this.references$1.$$plus$eq__T__Lamf_core_parser_ReferenceKind__Lorg_yaml_model_YNode__V(ref, $m_Lamf_core_parser_LinkReference$(), ($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(ref)))
        } else {
          $this.references$1.$$plus$eq__T__Lamf_core_parser_ReferenceKind__Lorg_yaml_model_YNode__V(ref, $m_Lamf_core_parser_InferredLinkReference$(), ($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(ref)))
        }
      })
    })(this)))
  };
  return this.references$1
});
$c_Lamf_plugins_document_webapi_JsonRefsReferenceHandler.prototype.links__Lorg_yaml_model_YPart__Lamf_core_parser_ParserContext__V = (function(part, ctx) {
  matchEnd4: {
    var childrens;
    if ((part instanceof $c_Lorg_yaml_model_YMap)) {
      var x2 = $as_Lorg_yaml_model_YMap(part);
      if (x2.map$3.contains__O__Z(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("$ref")))) {
        this.collectRef__p1__Lorg_yaml_model_YMap__Lamf_core_parser_ParserContext__V(x2, ctx);
        var childrens = $as_sc_IndexedSeq(part.children$1.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x2$1) {
          return (function(c$2) {
            var c = $as_Lorg_yaml_model_YPart(c$2);
            var x$2 = x2$1.entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
              return (function(x$1$2) {
                var x$1 = $as_Lorg_yaml_model_YMapEntry(x$1$2);
                var this$2 = x$1.key$2;
                var conversion = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
                var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
                return ($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv)).text$3 === "$ref")
              })
            })($this))).get__O();
            return (!((c === null) ? (x$2 === null) : c.equals__O__Z(x$2)))
          })
        })(this, x2))));
        break matchEnd4
      }
    };
    var childrens = part.children$1
  };
  childrens.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, ctx$1) {
    return (function(c$3$2) {
      var c$3 = $as_Lorg_yaml_model_YPart(c$3$2);
      this$2$1.links__Lorg_yaml_model_YPart__Lamf_core_parser_ParserContext__V(c$3, ctx$1)
    })
  })(this, ctx)))
});
var $d_Lamf_plugins_document_webapi_JsonRefsReferenceHandler = new $TypeData().initClass({
  Lamf_plugins_document_webapi_JsonRefsReferenceHandler: 0
}, false, "amf.plugins.document.webapi.JsonRefsReferenceHandler", {
  Lamf_plugins_document_webapi_JsonRefsReferenceHandler: 1,
  O: 1,
  Lamf_core_parser_ReferenceHandler: 1
});
$c_Lamf_plugins_document_webapi_JsonRefsReferenceHandler.prototype.$classData = $d_Lamf_plugins_document_webapi_JsonRefsReferenceHandler;
function $f_Lamf_plugins_document_webapi_contexts_TagToReferenceEmitter__$$init$__V($thiz) {
  var this$1 = $thiz.label__s_Option();
  $thiz.amf$plugins$document$webapi$contexts$TagToReferenceEmitter$$undsetter$und$referenceLabel$und$eq__T__V($as_T((this$1.isEmpty__Z() ? $thiz.target__Lamf_core_model_domain_DomainElement().id__T() : this$1.get__O())))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext() {
  $c_Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this);
  this.jsonPointersMap$2 = null;
  this.anyOfKey$2 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_SpecEmitterContext();
$c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions = (function(eh, refEmitter, options) {
  $c_Lamf_plugins_document_webapi_contexts_SpecEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions.call(this, eh, refEmitter, options);
  this.jsonPointersMap$2 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.anyOfKey$2 = new $c_Lamf_core_utils_package$AmfStrings().init___T("union").asOasExtension__T();
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.prototype.anyOfKey__T = (function() {
  return this.anyOfKey$2
});
function $as_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.emitter.OasLikeSpecEmitterContext"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.emitter.OasLikeSpecEmitterContext;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory() {
  $c_O.call(this);
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory.prototype.init___Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(spec) {
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory.prototype.annotationEmitter__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(domainExtension$2, ordering$2) {
      var domainExtension = $as_Lamf_core_model_domain_extensions_DomainExtension(domainExtension$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter().init___Lamf_core_model_domain_extensions_DomainExtension__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(domainExtension, ordering, $this.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext())
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory.prototype.exampleEmitter__F5 = (function() {
  return new $c_sjsr_AnonFunction5().init___sjs_js_Function5((function($this) {
    return (function(isHeader$2, exampleOption$2, ordering$2, extensions$2, references$2) {
      var isHeader = $uZ(isHeader$2);
      var exampleOption = $as_s_Option(exampleOption$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      var extensions = $as_sc_Seq(extensions$2);
      var references = $as_sc_Seq(references$2);
      var x = $this.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext().schemaVersion__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion();
      var x$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$();
      if (((x !== null) && x.equals__O__Z(x$2))) {
        var this$2 = exampleOption.toList__sci_List();
        var this$3 = $m_sc_Seq$();
        var examples = $as_sc_Seq(this$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(extensions, this$3.ReusableCBFInstance$2));
        var spec = $this.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext();
        return new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_Draft7ExampleEmitters().init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(examples, ordering, references, spec)
      } else {
        return $m_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters$().apply__Z__s_Option__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext__Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters(isHeader, exampleOption, ordering, extensions, references, $this.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext())
      }
    })
  })(this))
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$.prototype.ref__T__Lorg_yaml_model_YDocument$PartBuilder__V = (function(url, b) {
  var jsx$1 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("$ref", url, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
var $d_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.async.AsyncRefEmitter$", {
  Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_RefEmitter: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$;
var $n_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$ = (void 0);
function $m_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$() {
  if ((!$n_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$)) {
    $n_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$ = new $c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$().init___()
  };
  return $n_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$.prototype.ref__T__Lorg_yaml_model_YDocument$PartBuilder__V = (function(url, b) {
  var jsx$1 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("$ref", url, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
var $d_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.oas.OasRefEmitter$", {
  Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_RefEmitter: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$;
var $n_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$ = (void 0);
function $m_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$() {
  if ((!$n_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$)) {
    $n_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$ = new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$().init___()
  };
  return $n_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter.call(this);
  this.shapeEmitters$2 = null;
  this.$$outer$2 = null;
  this.property$1$f = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter();
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4.prototype.shapeEmitters__sc_Seq = (function() {
  return this.shapeEmitters$2
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4.prototype.emitters__s_util_Either = (function() {
  $m_s_package$();
  var value = this.shapeEmitters$2;
  return new $c_s_util_Left().init___O(value)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4.prototype.init___Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory__Lamf_core_model_domain_extensions_CustomDomainProperty__Lamf_core_emitter_SpecOrdering = (function($$outer, property$1, ordering$4) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.property$1$f = property$1;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter.prototype.init___Lamf_core_model_domain_extensions_CustomDomainProperty__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, property$1, ordering$4, $$outer.spec$1);
  var jsx$1 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4$$anon$5().init___Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4(this)];
  this.shapeEmitters$2 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
var $d_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.raml.Raml08EmitterVersionFactory$$anon$4", {
  Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$.prototype.ref__T__Lorg_yaml_model_YDocument$PartBuilder__V = (function(url, b) {
  var node = $m_Lorg_yaml_model_YNode$().include__T__T__Lorg_yaml_model_YNode$MutRef(url, ($m_Lorg_yaml_model_YNode$(), ""));
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer(node)
});
var $d_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.raml.RamlRefEmitter$", {
  Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_RefEmitter: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$;
var $n_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$ = (void 0);
function $m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$() {
  if ((!$n_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$)) {
    $n_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$ = new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$().init___()
  };
  return $n_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext() {
  $c_Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this)
}
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_SpecEmitterContext();
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.prototype.localReference__Lamf_core_model_domain_Linkable__Lamf_core_emitter_PartEmitter = (function(reference) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter().init___Lamf_core_model_domain_Linkable(reference)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.prototype.eh__Lamf_core_errorhandling_ErrorHandler = (function() {
  return this.eh$1
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext$$anon$1() {
  $c_O.call(this);
  this.nodes$1 = null
}
$c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext$$anon$1.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext$$anon$1.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext$$anon$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext$$anon$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext$$anon$1.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext$$anon$1.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext$$anon$1.prototype.nodes__sci_Map = (function() {
  return this.nodes$1
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext$$anon$1.prototype.init___Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext = (function($$outer) {
  this.nodes$1 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  return this
});
var $d_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext$$anon$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext$$anon$1: 0
}, false, "amf.plugins.document.webapi.contexts.parser.raml.PayloadContext$$anon$1", {
  Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext$$anon$1: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_SpecSyntax: 1
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext$$anon$1.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext$$anon$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory() {
  $c_O.call(this);
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory.prototype.init___Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(ctx) {
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory.prototype.securitySchemeParser__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(part$2, adopt$2) {
      var part = $as_Lorg_yaml_model_YPart(part$2);
      var adopt = $as_F1(adopt$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser().init___Lorg_yaml_model_YPart__F1__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(part, adopt, $this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext())
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory.prototype.operationParser__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(entry$2, producer$2, parseOptional$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var producer = $as_F1(producer$2);
      var parseOptional = $uZ(parseOptional$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser().init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(entry, producer, parseOptional, $this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext())
    })
  })(this))
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$() {
  $c_Lamf_plugins_document_webapi_parser_AsyncHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$.prototype = new $h_Lamf_plugins_document_webapi_parser_AsyncHeader();
$c_Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$.prototype = $c_Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$.prototype;
$c_Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_AsyncHeader.prototype.init___T__T.call(this, $m_Lamf_plugins_document_webapi_parser_AsyncHeader$().async$1, "2.0.0");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$: 0
}, false, "amf.plugins.document.webapi.parser.AsyncHeader$Async20Header$", {
  Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$: 1,
  Lamf_plugins_document_webapi_parser_AsyncHeader: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$;
var $n_Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$)) {
    $n_Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$ = new $c_Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$.prototype = $c_Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$.prototype;
$c_Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$.prototype.matchType__Lamf_plugins_domain_shapes_models_TypeDef__T = (function(typeDef) {
  return $f_Lamf_plugins_document_webapi_parser_OasTypeDefStringValueMatcher__matchType__Lamf_plugins_domain_shapes_models_TypeDef__T(this, typeDef)
});
var $d_Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$: 0
}, false, "amf.plugins.document.webapi.parser.CommonOasTypeDefMatcher$", {
  Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_OasTypeDefStringValueMatcher: 1
});
$c_Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$;
var $n_Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$)) {
    $n_Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$ = new $c_Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_JsonSchemaTypeDefMatcher$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_JsonSchemaTypeDefMatcher$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_JsonSchemaTypeDefMatcher$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_JsonSchemaTypeDefMatcher$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_JsonSchemaTypeDefMatcher$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_JsonSchemaTypeDefMatcher$.prototype = $c_Lamf_plugins_document_webapi_parser_JsonSchemaTypeDefMatcher$.prototype;
$c_Lamf_plugins_document_webapi_parser_JsonSchemaTypeDefMatcher$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_JsonSchemaTypeDefMatcher$.prototype.matchType__Lamf_plugins_domain_shapes_models_TypeDef__T = (function(typeDef) {
  var x$2 = $m_Lamf_plugins_domain_shapes_models_TypeDef$LongType$();
  if (((typeDef !== null) && (typeDef === x$2))) {
    return "number"
  } else {
    return $f_Lamf_plugins_document_webapi_parser_OasTypeDefStringValueMatcher__matchType__Lamf_plugins_domain_shapes_models_TypeDef__T(this, typeDef)
  }
});
var $d_Lamf_plugins_document_webapi_parser_JsonSchemaTypeDefMatcher$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_JsonSchemaTypeDefMatcher$: 0
}, false, "amf.plugins.document.webapi.parser.JsonSchemaTypeDefMatcher$", {
  Lamf_plugins_document_webapi_parser_JsonSchemaTypeDefMatcher$: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_OasTypeDefStringValueMatcher: 1
});
$c_Lamf_plugins_document_webapi_parser_JsonSchemaTypeDefMatcher$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_JsonSchemaTypeDefMatcher$;
var $n_Lamf_plugins_document_webapi_parser_JsonSchemaTypeDefMatcher$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_JsonSchemaTypeDefMatcher$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_JsonSchemaTypeDefMatcher$)) {
    $n_Lamf_plugins_document_webapi_parser_JsonSchemaTypeDefMatcher$ = new $c_Lamf_plugins_document_webapi_parser_JsonSchemaTypeDefMatcher$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_JsonSchemaTypeDefMatcher$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$.prototype = new $h_Lamf_plugins_document_webapi_parser_OasHeader();
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$.prototype = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$.prototype;
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.prototype.init___T__T.call(this, $m_Lamf_plugins_document_webapi_parser_OasHeader$().extensionName$1, "2.0 AnnotationTypeDeclaration");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$: 0
}, false, "amf.plugins.document.webapi.parser.OasHeader$Oas20AnnotationTypeDeclaration$", {
  Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$: 1,
  Lamf_plugins_document_webapi_parser_OasHeader: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$;
var $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$)) {
    $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$ = new $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$.prototype = new $h_Lamf_plugins_document_webapi_parser_OasHeader();
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$.prototype = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$.prototype;
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.prototype.init___T__T.call(this, $m_Lamf_plugins_document_webapi_parser_OasHeader$().extensionName$1, "2.0 DataType");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$: 0
}, false, "amf.plugins.document.webapi.parser.OasHeader$Oas20DataType$", {
  Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$: 1,
  Lamf_plugins_document_webapi_parser_OasHeader: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$;
var $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$)) {
    $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$ = new $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$.prototype = new $h_Lamf_plugins_document_webapi_parser_OasHeader();
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$.prototype = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$.prototype;
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.prototype.init___T__T.call(this, $m_Lamf_plugins_document_webapi_parser_OasHeader$().extensionName$1, "2.0 DocumentationItem");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$: 0
}, false, "amf.plugins.document.webapi.parser.OasHeader$Oas20DocumentationItem$", {
  Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$: 1,
  Lamf_plugins_document_webapi_parser_OasHeader: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$;
var $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$)) {
    $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$ = new $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$.prototype = new $h_Lamf_plugins_document_webapi_parser_OasHeader();
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$.prototype = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$.prototype;
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.prototype.init___T__T.call(this, $m_Lamf_plugins_document_webapi_parser_OasHeader$().extensionType$1, "2.0 Extension");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$: 0
}, false, "amf.plugins.document.webapi.parser.OasHeader$Oas20Extension$", {
  Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$: 1,
  Lamf_plugins_document_webapi_parser_OasHeader: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$;
var $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$)) {
    $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$ = new $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$.prototype = new $h_Lamf_plugins_document_webapi_parser_OasHeader();
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$.prototype = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$.prototype;
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.prototype.init___T__T.call(this, $m_Lamf_plugins_document_webapi_parser_OasHeader$().swagger$1, "2.0");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$: 0
}, false, "amf.plugins.document.webapi.parser.OasHeader$Oas20Header$", {
  Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$: 1,
  Lamf_plugins_document_webapi_parser_OasHeader: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$;
var $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$)) {
    $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$ = new $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$.prototype = new $h_Lamf_plugins_document_webapi_parser_OasHeader();
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$.prototype = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$.prototype;
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.prototype.init___T__T.call(this, $m_Lamf_plugins_document_webapi_parser_OasHeader$().extensionName$1, "2.0 NamedExample");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$: 0
}, false, "amf.plugins.document.webapi.parser.OasHeader$Oas20NamedExample$", {
  Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$: 1,
  Lamf_plugins_document_webapi_parser_OasHeader: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$;
var $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$)) {
    $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$ = new $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$.prototype = new $h_Lamf_plugins_document_webapi_parser_OasHeader();
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$.prototype = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$.prototype;
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.prototype.init___T__T.call(this, $m_Lamf_plugins_document_webapi_parser_OasHeader$().extensionType$1, "2.0 Overlay");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$: 0
}, false, "amf.plugins.document.webapi.parser.OasHeader$Oas20Overlay$", {
  Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$: 1,
  Lamf_plugins_document_webapi_parser_OasHeader: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$;
var $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$)) {
    $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$ = new $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$.prototype = new $h_Lamf_plugins_document_webapi_parser_OasHeader();
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$.prototype = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$.prototype;
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.prototype.init___T__T.call(this, $m_Lamf_plugins_document_webapi_parser_OasHeader$().extensionName$1, "2.0 ResourceType");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$: 0
}, false, "amf.plugins.document.webapi.parser.OasHeader$Oas20ResourceType$", {
  Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$: 1,
  Lamf_plugins_document_webapi_parser_OasHeader: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$;
var $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$)) {
    $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$ = new $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$.prototype = new $h_Lamf_plugins_document_webapi_parser_OasHeader();
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$.prototype = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$.prototype;
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.prototype.init___T__T.call(this, $m_Lamf_plugins_document_webapi_parser_OasHeader$().extensionName$1, "2.0 SecurityScheme");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$: 0
}, false, "amf.plugins.document.webapi.parser.OasHeader$Oas20SecurityScheme$", {
  Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$: 1,
  Lamf_plugins_document_webapi_parser_OasHeader: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$;
var $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$)) {
    $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$ = new $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$.prototype = new $h_Lamf_plugins_document_webapi_parser_OasHeader();
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$.prototype = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$.prototype;
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.prototype.init___T__T.call(this, $m_Lamf_plugins_document_webapi_parser_OasHeader$().extensionName$1, "2.0 Trait");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$: 0
}, false, "amf.plugins.document.webapi.parser.OasHeader$Oas20Trait$", {
  Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$: 1,
  Lamf_plugins_document_webapi_parser_OasHeader: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$;
var $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$)) {
    $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$ = new $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$.prototype = new $h_Lamf_plugins_document_webapi_parser_OasHeader();
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$.prototype = $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$.prototype;
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_OasHeader.prototype.init___T__T.call(this, $m_Lamf_plugins_document_webapi_parser_OasHeader$().openapi$1, "3\\.0\\.[0-9]+");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$: 0
}, false, "amf.plugins.document.webapi.parser.OasHeader$Oas30Header$", {
  Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$: 1,
  Lamf_plugins_document_webapi_parser_OasHeader: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$;
var $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$)) {
    $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$ = new $c_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations() {
  $c_Lamf_core_parser_Declarations.call(this);
  this.alias$2 = null;
  this.libs$2 = null;
  this.frags$2 = null;
  this.shapes$2 = null;
  this.anns$2 = null;
  this.resourceTypes$2 = null;
  this.parameters$2 = null;
  this.payloads$2 = null;
  this.traits$2 = null;
  this.securitySchemes$2 = null;
  this.responses$2 = null;
  this.examples$2 = null;
  this.requests$2 = null;
  this.headers$2 = null;
  this.links$2 = null;
  this.correlationIds$2 = null;
  this.callbacks$2 = null;
  this.messages$2 = null;
  this.messageBindings$2 = null;
  this.operationBindings$2 = null;
  this.channelBindings$2 = null;
  this.serverBindings$2 = null;
  this.operationTraits$2 = null;
  this.messageTraits$2 = null;
  this.errorHandler$2 = null;
  this.futureDeclarations$2 = null;
  this.others$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype = new $h_Lamf_core_parser_Declarations();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findCorrelationId__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, scope) {
  var this$1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$9$2) {
      var x$9 = $as_Lamf_core_parser_Declarations(x$9$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$9).correlationIds$2
    })
  })(this)), scope);
  var pf = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findCorrelationId$2().init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(this);
  if ((!this$1.isEmpty__Z())) {
    var this$2 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$1.get__O();
    return this$2.apply__O__s_Option(v1)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.registerOasParameter__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter__V = (function(oasParameter) {
  var this$1 = oasParameter.domainElement$1;
  var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
  $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$1, annotation);
  this.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations($as_Lamf_core_model_domain_DomainElement(oasParameter.domainElement$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findType__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option = (function(key, scope, error) {
  var rc6 = false;
  var x2 = null;
  var x1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$22$2) {
      var x$22 = $as_Lamf_core_parser_Declarations(x$22$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$22).shapes$2
    })
  })(this)), scope);
  if ((x1 instanceof $c_s_Some)) {
    rc6 = true;
    x2 = $as_s_Some(x1);
    var anyShape = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    if ((anyShape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
      var x4 = $as_Lamf_plugins_domain_shapes_models_AnyShape(anyShape);
      return new $c_s_Some().init___O(x4)
    }
  };
  if (rc6) {
    var other = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    var x$2 = $m_Lamf_core_parser_SearchScope$Fragments$();
    if (((scope !== null) && (scope === x$2))) {
      if ((!error.isEmpty__Z())) {
        var arg1 = error.get__O();
        var x$23 = $as_F1(arg1);
        x$23.apply__O__O((("Fragment of type " + $objectGetClass(other).getSimpleName__T()) + " does not conform to the expected type DataType"))
      };
      return $m_s_None$()
    }
  };
  return $m_s_None$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findTemplatedLink__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, scope) {
  var this$1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$7$2) {
      var x$7 = $as_Lamf_core_parser_Declarations(x$7$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$7).links$2
    })
  })(this)), scope);
  var pf = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findTemplatedLink$2().init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(this);
  if ((!this$1.isEmpty__Z())) {
    var this$2 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$1.get__O();
    return this$2.apply__O__s_Option(v1)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findOperationBindings__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, scope) {
  var this$1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$11$2) {
      var x$11 = $as_Lamf_core_parser_Declarations(x$11$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$11).operationBindings$2
    })
  })(this)), scope);
  var pf = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationBindings$2().init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(this);
  if ((!this$1.isEmpty__Z())) {
    var this$2 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$1.get__O();
    return this$2.apply__O__s_Option(v1)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.aliased__T__T = (function(name) {
  var x1 = this.alias__s_Option();
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var prefix = $as_T(x2.value$2);
    return ((prefix + ".") + name)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return name
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.futureDeclarations__Lamf_core_parser_FutureDeclarations = (function() {
  return this.futureDeclarations$2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findEquivalent__Lamf_core_model_domain_DomainElement__s_Option = (function(element) {
  if ((element instanceof $c_Lamf_plugins_domain_webapi_models_templates_ResourceType)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(element);
    var this$1 = $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().Name$1));
    var this$2 = this$1.option$1;
    return this.findResourceType__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())), $m_Lamf_core_parser_SearchScope$All$(), $m_s_None$())
  } else if ((element instanceof $c_Lamf_plugins_domain_webapi_models_templates_Trait)) {
    var x3 = $as_Lamf_plugins_domain_webapi_models_templates_Trait(element);
    var this$3 = $as_Lamf_core_model_StrField(x3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().Name$1));
    var this$4 = this$3.option$1;
    return this.findTrait__p2__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option($as_T((this$4.isEmpty__Z() ? null : this$4.get__O())), $m_Lamf_core_parser_SearchScope$All$(), $m_s_None$())
  } else if ((element instanceof $c_Lamf_core_model_domain_Shape)) {
    var x4 = $as_Lamf_core_model_domain_Shape(element);
    var this$5 = $as_Lamf_core_model_StrField(x4.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
    var this$6 = this$5.option$1;
    return this.findType__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option($as_T((this$6.isEmpty__Z() ? null : this$6.get__O())), $m_Lamf_core_parser_SearchScope$All$(), $m_s_None$())
  } else if ((element instanceof $c_Lamf_plugins_domain_webapi_models_Parameter)) {
    var x5 = $as_Lamf_plugins_domain_webapi_models_Parameter(element);
    var this$7 = $as_Lamf_core_model_StrField(x5.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
    var this$8 = this$7.option$1;
    return this.findParameter__T__Lamf_core_parser_SearchScope$Scope__s_Option($as_T((this$8.isEmpty__Z() ? null : this$8.get__O())), $m_Lamf_core_parser_SearchScope$All$())
  } else if ((element instanceof $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme)) {
    var x6 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(element);
    var this$9 = $as_Lamf_core_model_StrField(x6.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Name$1));
    var this$10 = this$9.option$1;
    return this.findSecurityScheme__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option($as_T((this$10.isEmpty__Z() ? null : this$10.get__O())), $m_Lamf_core_parser_SearchScope$All$(), $m_s_None$())
  } else if ((element instanceof $c_Lamf_plugins_domain_webapi_models_Response)) {
    var x7 = $as_Lamf_plugins_domain_webapi_models_Response(element);
    var this$11 = $as_Lamf_core_model_StrField(x7.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Name$1));
    var this$12 = this$11.option$1;
    return this.findResponse__T__Lamf_core_parser_SearchScope$Scope__s_Option($as_T((this$12.isEmpty__Z() ? null : this$12.get__O())), $m_Lamf_core_parser_SearchScope$All$())
  } else {
    return $c_Lamf_core_parser_Declarations.prototype.findEquivalent__Lamf_core_model_domain_DomainElement__s_Option.call(this, element)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.init___s_Option__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations__sci_Map = (function(alias, libs, frags, shapes, anns, resourceTypes, parameters, payloads, traits, securitySchemes, responses, examples, requests, headers, links, correlationIds, callbacks, messages, messageBindings, operationBindings, channelBindings, serverBindings, operationTraits, messageTraits, errorHandler, futureDeclarations, others) {
  this.alias$2 = alias;
  this.libs$2 = libs;
  this.frags$2 = frags;
  this.shapes$2 = shapes;
  this.anns$2 = anns;
  this.resourceTypes$2 = resourceTypes;
  this.parameters$2 = parameters;
  this.payloads$2 = payloads;
  this.traits$2 = traits;
  this.securitySchemes$2 = securitySchemes;
  this.responses$2 = responses;
  this.examples$2 = examples;
  this.requests$2 = requests;
  this.headers$2 = headers;
  this.links$2 = links;
  this.correlationIds$2 = correlationIds;
  this.callbacks$2 = callbacks;
  this.messages$2 = messages;
  this.messageBindings$2 = messageBindings;
  this.operationBindings$2 = operationBindings;
  this.channelBindings$2 = channelBindings;
  this.serverBindings$2 = serverBindings;
  this.operationTraits$2 = operationTraits;
  this.messageTraits$2 = messageTraits;
  this.errorHandler$2 = errorHandler;
  this.futureDeclarations$2 = futureDeclarations;
  this.others$2 = others;
  $c_Lamf_core_parser_Declarations.prototype.init___sci_Map__sci_Map__sci_Map__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations.call(this, libs, frags, anns, errorHandler, futureDeclarations);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findResourceType__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option = (function(key, scope, error) {
  var rc6 = false;
  var x2 = null;
  var x1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$17$2) {
      var x$17 = $as_Lamf_core_parser_Declarations(x$17$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$17).resourceTypes$2
    })
  })(this)), scope);
  if ((x1 instanceof $c_s_Some)) {
    rc6 = true;
    x2 = $as_s_Some(x1);
    var r = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    if ((r instanceof $c_Lamf_plugins_domain_webapi_models_templates_ResourceType)) {
      var x4 = $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(r);
      return new $c_s_Some().init___O(x4)
    }
  };
  if (rc6) {
    var other = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    var x$2 = $m_Lamf_core_parser_SearchScope$Fragments$();
    if (((scope !== null) && (scope === x$2))) {
      if ((!error.isEmpty__Z())) {
        var arg1 = error.get__O();
        var x$18 = $as_F1(arg1);
        x$18.apply__O__O((("Fragment of type " + $objectGetClass(other).getSimpleName__T()) + " does not conform to the expected type ResourceType"))
      };
      return $m_s_None$()
    }
  };
  return $m_s_None$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findHeader__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, scope) {
  var this$1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$8$2) {
      var x$8 = $as_Lamf_core_parser_Declarations(x$8$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$8).headers$2
    })
  })(this)), scope);
  var pf = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findHeader$2().init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(this);
  if ((!this$1.isEmpty__Z())) {
    var this$2 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$1.get__O();
    return this$2.apply__O__s_Option(v1)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.registerHeader__Lamf_plugins_domain_webapi_models_Parameter__V = (function(header) {
  var jsx$1 = this.headers$2;
  var this$1 = $as_Lamf_core_model_StrField(header.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
  var this$2 = this$1.option$1;
  var self = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  this.headers$2 = jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, header))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findOperationTrait__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, scope) {
  var this$1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$15$2) {
      var x$15 = $as_Lamf_core_parser_Declarations(x$15$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$15).operationTraits$2
    })
  })(this)), scope);
  var pf = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationTrait$2().init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(this);
  if ((!this$1.isEmpty__Z())) {
    var this$2 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$1.get__O();
    return this$2.apply__O__s_Option(v1)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findMessageTrait__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, scope) {
  var this$1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$16$2) {
      var x$16 = $as_Lamf_core_parser_Declarations(x$16$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$16).messageTraits$2
    })
  })(this)), scope);
  var pf = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageTrait$2().init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(this);
  if ((!this$1.isEmpty__Z())) {
    var this$2 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$1.get__O();
    return this$2.apply__O__s_Option(v1)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findDocumentations__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option = (function(key, scope, error) {
  var rc6 = false;
  var x2 = null;
  var x1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, $m_sci_Map$EmptyMap$(), scope);
  if ((x1 instanceof $c_s_Some)) {
    rc6 = true;
    x2 = $as_s_Some(x1);
    var u = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    if ((u instanceof $c_Lamf_plugins_domain_shapes_models_CreativeWork)) {
      var x4 = $as_Lamf_plugins_domain_shapes_models_CreativeWork(u);
      return new $c_s_Some().init___O(x4)
    }
  };
  if (rc6) {
    var other = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    var x$2 = $m_Lamf_core_parser_SearchScope$Fragments$();
    if (((scope !== null) && (scope === x$2))) {
      if ((!error.isEmpty__Z())) {
        var arg1 = error.get__O();
        var x$19 = $as_F1(arg1);
        x$19.apply__O__O((("Fragment of type " + $objectGetClass(other).getSimpleName__T()) + " does not conform to the expected type DocumentationItem"))
      };
      return $m_s_None$()
    }
  };
  return $m_s_None$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.declarables__sc_Seq = (function() {
  var jsx$38 = $c_Lamf_core_parser_Declarations.prototype.declarables__sc_Seq.call(this).toList__sci_List();
  var this$1 = this.shapes$2;
  var this$4 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$1);
  var this$2 = this.resourceTypes$2;
  var that = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$2);
  var this$3 = $m_sc_Iterable$();
  var bf = this$3.ReusableCBFInstance$2;
  var jsx$37 = $as_sc_TraversableLike($f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this$4, that, bf));
  var this$5 = this.traits$2;
  var jsx$36 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$5);
  var this$6 = $m_sc_Iterable$();
  var jsx$35 = $as_sc_TraversableLike(jsx$37.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$36, this$6.ReusableCBFInstance$2));
  var this$7 = this.parameters$2;
  var jsx$34 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$7);
  var this$8 = $m_sc_Iterable$();
  var jsx$33 = $as_sc_TraversableLike(jsx$35.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$34, this$8.ReusableCBFInstance$2));
  var this$9 = this.payloads$2;
  var jsx$32 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$9);
  var this$10 = $m_sc_Iterable$();
  var jsx$31 = $as_sc_TraversableLike(jsx$33.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$32, this$10.ReusableCBFInstance$2));
  var this$11 = this.securitySchemes$2;
  var jsx$30 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$11);
  var this$12 = $m_sc_Iterable$();
  var jsx$29 = $as_sc_TraversableLike(jsx$31.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$30, this$12.ReusableCBFInstance$2));
  var this$13 = this.responses$2;
  var jsx$28 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$13);
  var this$14 = $m_sc_Iterable$();
  var jsx$27 = $as_sc_TraversableLike(jsx$29.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$28, this$14.ReusableCBFInstance$2));
  var this$15 = this.examples$2;
  var jsx$26 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$15);
  var this$16 = $m_sc_Iterable$();
  var jsx$25 = $as_sc_TraversableLike(jsx$27.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$26, this$16.ReusableCBFInstance$2));
  var this$17 = this.requests$2;
  var jsx$24 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$17);
  var this$18 = $m_sc_Iterable$();
  var jsx$23 = $as_sc_TraversableLike(jsx$25.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$24, this$18.ReusableCBFInstance$2));
  var this$19 = this.links$2;
  var jsx$22 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$19);
  var this$20 = $m_sc_Iterable$();
  var jsx$21 = $as_sc_TraversableLike(jsx$23.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$22, this$20.ReusableCBFInstance$2));
  var this$21 = this.callbacks$2;
  var this$22 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$21);
  $m_sc_Iterable$();
  $m_sci_Iterable$();
  var b = new $c_scm_ListBuffer().init___();
  var this$25 = this$22.$$outer$3.valuesIterator__sc_Iterator();
  while (this$25.hasNext__Z()) {
    var arg1 = this$25.next__O();
    var xs = $as_sc_GenTraversableOnce(arg1).seq__sc_TraversableOnce();
    b.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(xs)
  };
  var jsx$20 = b.toList__sci_List();
  var this$26 = $m_sc_Iterable$();
  var jsx$19 = $as_sc_TraversableLike(jsx$21.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$20, this$26.ReusableCBFInstance$2));
  var this$27 = this.headers$2;
  var jsx$18 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$27);
  var this$28 = $m_sc_Iterable$();
  var jsx$17 = $as_sc_TraversableLike(jsx$19.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$18, this$28.ReusableCBFInstance$2));
  var this$29 = this.correlationIds$2;
  var jsx$16 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$29);
  var this$30 = $m_sc_Iterable$();
  var jsx$15 = $as_sc_TraversableLike(jsx$17.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$16, this$30.ReusableCBFInstance$2));
  var this$31 = this.messageBindings$2;
  var jsx$14 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$31);
  var this$32 = $m_sc_Iterable$();
  var jsx$13 = $as_sc_TraversableLike(jsx$15.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$14, this$32.ReusableCBFInstance$2));
  var this$33 = this.operationBindings$2;
  var jsx$12 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$33);
  var this$34 = $m_sc_Iterable$();
  var jsx$11 = $as_sc_TraversableLike(jsx$13.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$12, this$34.ReusableCBFInstance$2));
  var this$35 = this.channelBindings$2;
  var jsx$10 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$35);
  var this$36 = $m_sc_Iterable$();
  var jsx$9 = $as_sc_TraversableLike(jsx$11.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$10, this$36.ReusableCBFInstance$2));
  var this$37 = this.serverBindings$2;
  var jsx$8 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$37);
  var this$38 = $m_sc_Iterable$();
  var jsx$7 = $as_sc_TraversableLike(jsx$9.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$8, this$38.ReusableCBFInstance$2));
  var this$39 = this.messages$2;
  var jsx$6 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$39);
  var this$40 = $m_sc_Iterable$();
  var jsx$5 = $as_sc_TraversableLike(jsx$7.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$6, this$40.ReusableCBFInstance$2));
  var this$41 = this.operationTraits$2;
  var jsx$4 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$41);
  var this$42 = $m_sc_Iterable$();
  var jsx$3 = $as_sc_TraversableLike(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$42.ReusableCBFInstance$2));
  var this$43 = this.messageTraits$2;
  var jsx$2 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$43);
  var this$44 = $m_sc_Iterable$();
  var jsx$1 = $as_sc_TraversableOnce(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$44.ReusableCBFInstance$2)).toList__sci_List();
  var this$45 = $m_sci_List$();
  return $as_sc_Seq(jsx$38.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$45.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findTrait__p2__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option = (function(key, scope, error) {
  var rc6 = false;
  var x2 = null;
  var x1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$20$2) {
      var x$20 = $as_Lamf_core_parser_Declarations(x$20$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$20).traits$2
    })
  })(this)), scope);
  if ((x1 instanceof $c_s_Some)) {
    rc6 = true;
    x2 = $as_s_Some(x1);
    var t = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    if ((t instanceof $c_Lamf_plugins_domain_webapi_models_templates_Trait)) {
      var x4 = $as_Lamf_plugins_domain_webapi_models_templates_Trait(t);
      return new $c_s_Some().init___O(x4)
    }
  };
  if (rc6) {
    var other = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    var x$2 = $m_Lamf_core_parser_SearchScope$Fragments$();
    if (((scope !== null) && (scope === x$2))) {
      if ((!error.isEmpty__Z())) {
        var arg1 = error.get__O();
        var x$21 = $as_F1(arg1);
        x$21.apply__O__O((("Fragment of type " + $objectGetClass(other).getSimpleName__T()) + " does not conform to the expected type Trait"))
      };
      return $m_s_None$()
    }
  };
  return $m_s_None$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.getOrCreateLibrary__T__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function(alias) {
  var x1 = this.libraries$1.get__O__s_Option(alias);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var lib = $as_Lamf_core_parser_Declarations(x2.value$2);
    if ((lib instanceof $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations)) {
      var x3 = $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(lib);
      return x3
    }
  };
  var x$1 = new $c_s_Some().init___O(alias);
  var x$2 = this.errorHandler__Lamf_core_errorhandling_ErrorHandler();
  var x$3 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
  var x$4 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$5 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$6 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$7 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$8 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$9 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$10 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$11 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$12 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$13 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$14 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$15 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$16 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$17 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$18 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$19 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$20 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$21 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$22 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$23 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$24 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$25 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$26 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$27 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var result = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations().init___s_Option__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations__sci_Map(x$1, x$4, x$5, x$6, x$7, x$8, x$9, x$10, x$11, x$12, x$13, x$14, x$15, x$16, x$17, x$18, x$19, x$20, x$21, x$22, x$23, x$24, x$25, x$26, x$2, x$3, x$27);
  this.libraries$1 = this.libraries$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(alias, result));
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findResponse__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, scope) {
  var this$1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$6$2) {
      var x$6 = $as_Lamf_core_parser_Declarations(x$6$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$6).responses$2
    })
  })(this)), scope);
  var pf = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findResponse$2().init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(this);
  if ((!this$1.isEmpty__Z())) {
    var this$2 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$1.get__O();
    return this$2.apply__O__s_Option(v1)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.errorHandler__Lamf_core_errorhandling_ErrorHandler = (function() {
  return this.errorHandler$2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findTraitOrError__Lorg_yaml_model_YPart__T__Lamf_core_parser_SearchScope$Scope__Lamf_plugins_domain_webapi_models_templates_Trait = (function(ast, key, scope) {
  var x1 = this.findTrait__p2__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option(key, scope, $m_s_None$());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var result = $as_Lamf_plugins_domain_webapi_models_templates_Trait(x2.value$2);
    return result
  } else {
    this.error__T__Lorg_yaml_model_YPart__V((("Trait " + key) + " not found"), ast);
    return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait().init___T__Lorg_yaml_model_YPart(key, ast)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function(element) {
  var rc22 = false;
  var x5 = null;
  matchEnd23: {
    if ((element instanceof $c_Lamf_plugins_domain_webapi_models_templates_ResourceType)) {
      var x2 = $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(element);
      var jsx$1 = this.resourceTypes$2;
      var this$1 = $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().Name$1));
      var this$2 = this$1.option$1;
      var self = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
      this.resourceTypes$2 = jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, x2));
      break matchEnd23
    };
    if ((element instanceof $c_Lamf_plugins_domain_webapi_models_templates_Trait)) {
      var x3 = $as_Lamf_plugins_domain_webapi_models_templates_Trait(element);
      var jsx$2 = this.traits$2;
      var this$5 = $as_Lamf_core_model_StrField(x3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().Name$1));
      var this$6 = this$5.option$1;
      var self$1 = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
      this.traits$2 = jsx$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$1, x3));
      break matchEnd23
    };
    if ((element instanceof $c_Lamf_core_model_domain_Shape)) {
      var x4 = $as_Lamf_core_model_domain_Shape(element);
      this.addSchema__Lamf_core_model_domain_Shape__V(x4);
      break matchEnd23
    };
    if ((element instanceof $c_Lamf_plugins_domain_webapi_models_Parameter)) {
      rc22 = true;
      x5 = $as_Lamf_plugins_domain_webapi_models_Parameter(element);
      if (x5.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredHeader.getClassOf())) {
        var jsx$3 = this.headers$2;
        var this$9 = x5;
        var this$10 = $as_Lamf_core_model_StrField(this$9.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
        var this$11 = this$10.option$1;
        var self$2 = $as_T((this$11.isEmpty__Z() ? null : this$11.get__O()));
        var y = x5;
        this.headers$2 = jsx$3.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$2, y));
        break matchEnd23
      }
    };
    if (rc22) {
      var jsx$4 = this.parameters$2;
      var this$14 = x5;
      var this$15 = $as_Lamf_core_model_StrField(this$14.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
      var this$16 = this$15.option$1;
      var self$3 = $as_T((this$16.isEmpty__Z() ? null : this$16.get__O()));
      var y$1 = x5;
      this.parameters$2 = jsx$4.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$3, y$1));
      break matchEnd23
    };
    if ((element instanceof $c_Lamf_plugins_domain_webapi_models_Payload)) {
      var x7 = $as_Lamf_plugins_domain_webapi_models_Payload(element);
      var jsx$5 = this.payloads$2;
      var this$19 = $as_Lamf_core_model_StrField(x7.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Name$1));
      var this$20 = this$19.option$1;
      var self$4 = $as_T((this$20.isEmpty__Z() ? null : this$20.get__O()));
      this.payloads$2 = jsx$5.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$4, x7));
      break matchEnd23
    };
    if ((element instanceof $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme)) {
      var x8 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(element);
      var jsx$6 = this.securitySchemes$2;
      var this$23 = $as_Lamf_core_model_StrField(x8.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Name$1));
      var this$24 = this$23.option$1;
      var self$5 = $as_T((this$24.isEmpty__Z() ? null : this$24.get__O()));
      this.securitySchemes$2 = jsx$6.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$5, x8));
      break matchEnd23
    };
    if ((element instanceof $c_Lamf_plugins_domain_webapi_models_Response)) {
      var x9 = $as_Lamf_plugins_domain_webapi_models_Response(element);
      var jsx$7 = this.responses$2;
      var this$27 = $as_Lamf_core_model_StrField(x9.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Name$1));
      var this$28 = this$27.option$1;
      var self$6 = $as_T((this$28.isEmpty__Z() ? null : this$28.get__O()));
      this.responses$2 = jsx$7.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$6, x9));
      break matchEnd23
    };
    if ((element instanceof $c_Lamf_plugins_domain_shapes_models_Example)) {
      var x10 = $as_Lamf_plugins_domain_shapes_models_Example(element);
      var jsx$8 = this.examples$2;
      var this$31 = $as_Lamf_core_model_StrField(x10.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Name$1));
      var this$32 = this$31.option$1;
      var self$7 = $as_T((this$32.isEmpty__Z() ? null : this$32.get__O()));
      this.examples$2 = jsx$8.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$7, x10));
      break matchEnd23
    };
    if ((element instanceof $c_Lamf_plugins_domain_webapi_models_Request)) {
      var x11 = $as_Lamf_plugins_domain_webapi_models_Request(element);
      var jsx$9 = this.requests$2;
      var this$35 = $as_Lamf_core_model_StrField(x11.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Name$1));
      var this$36 = this$35.option$1;
      var self$8 = $as_T((this$36.isEmpty__Z() ? null : this$36.get__O()));
      this.requests$2 = jsx$9.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$8, x11));
      break matchEnd23
    };
    if ((element instanceof $c_Lamf_plugins_domain_webapi_models_TemplatedLink)) {
      var x12 = $as_Lamf_plugins_domain_webapi_models_TemplatedLink(element);
      var jsx$10 = this.links$2;
      var this$39 = $as_Lamf_core_model_StrField(x12.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Name$1));
      var this$40 = this$39.option$1;
      var self$9 = $as_T((this$40.isEmpty__Z() ? null : this$40.get__O()));
      this.links$2 = jsx$10.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$9, x12));
      break matchEnd23
    };
    if ((element instanceof $c_Lamf_plugins_domain_webapi_models_CorrelationId)) {
      var x13 = $as_Lamf_plugins_domain_webapi_models_CorrelationId(element);
      var jsx$11 = this.correlationIds$2;
      var this$43 = $as_Lamf_core_model_StrField(x13.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$().Name$1));
      var this$44 = this$43.option$1;
      var self$10 = $as_T((this$44.isEmpty__Z() ? null : this$44.get__O()));
      this.correlationIds$2 = jsx$11.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$10, x13));
      break matchEnd23
    };
    if ((element instanceof $c_Lamf_plugins_domain_webapi_models_Message)) {
      var x14 = $as_Lamf_plugins_domain_webapi_models_Message(element);
      var this$47 = $as_Lamf_core_model_BoolField(x14.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().IsAbstract$1));
      if ($f_Lamf_core_model_BoolField__value__Z(this$47)) {
        var jsx$12 = this.messageTraits$2;
        var this$48 = $as_Lamf_core_model_StrField(x14.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(x14.nameField__Lamf_core_metamodel_Field()));
        var this$49 = this$48.option$1;
        var self$11 = $as_T((this$49.isEmpty__Z() ? null : this$49.get__O()));
        this.messageTraits$2 = jsx$12.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$11, x14));
        break matchEnd23
      } else {
        var jsx$13 = this.messages$2;
        var this$52 = $as_Lamf_core_model_StrField(x14.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(x14.nameField__Lamf_core_metamodel_Field()));
        var this$53 = this$52.option$1;
        var self$12 = $as_T((this$53.isEmpty__Z() ? null : this$53.get__O()));
        this.messages$2 = jsx$13.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$12, x14));
        break matchEnd23
      }
    };
    if ((element instanceof $c_Lamf_plugins_domain_webapi_models_Operation)) {
      var x15 = $as_Lamf_plugins_domain_webapi_models_Operation(element);
      var this$56 = $as_Lamf_core_model_BoolField(x15.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().IsAbstract$1));
      if ($f_Lamf_core_model_BoolField__value__Z(this$56)) {
        var jsx$14 = this.operationTraits$2;
        var this$57 = $as_Lamf_core_model_StrField(x15.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Name$1));
        var this$58 = this$57.option$1;
        var self$13 = $as_T((this$58.isEmpty__Z() ? null : this$58.get__O()));
        this.operationTraits$2 = jsx$14.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$13, x15));
        break matchEnd23
      }
    };
    if ((element instanceof $c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings)) {
      var x16 = $as_Lamf_plugins_domain_webapi_models_bindings_MessageBindings(element);
      var jsx$15 = this.messageBindings$2;
      var this$61 = $as_Lamf_core_model_StrField(x16.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$().Name$1));
      var this$62 = this$61.option$1;
      var self$14 = $as_T((this$62.isEmpty__Z() ? null : this$62.get__O()));
      this.messageBindings$2 = jsx$15.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$14, x16));
      break matchEnd23
    };
    if ((element instanceof $c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings)) {
      var x17 = $as_Lamf_plugins_domain_webapi_models_bindings_ServerBindings(element);
      var jsx$16 = this.serverBindings$2;
      var this$65 = $as_Lamf_core_model_StrField(x17.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$().Name$1));
      var this$66 = this$65.option$1;
      var self$15 = $as_T((this$66.isEmpty__Z() ? null : this$66.get__O()));
      this.serverBindings$2 = jsx$16.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$15, x17));
      break matchEnd23
    };
    if ((element instanceof $c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings)) {
      var x18 = $as_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings(element);
      var jsx$17 = this.channelBindings$2;
      var this$69 = $as_Lamf_core_model_StrField(x18.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$().Name$1));
      var this$70 = this$69.option$1;
      var self$16 = $as_T((this$70.isEmpty__Z() ? null : this$70.get__O()));
      this.channelBindings$2 = jsx$17.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$16, x18));
      break matchEnd23
    };
    if ((element instanceof $c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings)) {
      var x19 = $as_Lamf_plugins_domain_webapi_models_bindings_OperationBindings(element);
      var jsx$18 = this.operationBindings$2;
      var this$73 = $as_Lamf_core_model_StrField(x19.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$().Name$1));
      var this$74 = this$73.option$1;
      var self$17 = $as_T((this$74.isEmpty__Z() ? null : this$74.get__O()));
      this.operationBindings$2 = jsx$18.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$17, x19));
      break matchEnd23
    };
    if ((element instanceof $c_Lamf_plugins_domain_webapi_models_Callback)) {
      var x20 = $as_Lamf_plugins_domain_webapi_models_Callback(element);
      var this$77 = $as_Lamf_core_model_StrField(x20.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$().Name$1));
      var this$78 = this$77.option$1;
      var name = $as_T((this$78.isEmpty__Z() ? null : this$78.get__O()));
      var x1$2 = this.callbacks$2.get__O__s_Option(name);
      if ((x1$2 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$2);
        var prev = $as_sci_List(x2$2.value$2);
        var jsx$19 = this.callbacks$2;
        var y$2 = new $c_sci_$colon$colon().init___O__sci_List(x20, prev);
        this.callbacks$2 = jsx$19.$$plus__T2__sci_Map(new $c_T2().init___O__O(name, y$2))
      } else {
        var x = $m_s_None$();
        if ((!(x === x1$2))) {
          throw new $c_s_MatchError().init___O(x1$2)
        };
        var jsx$20 = this.callbacks$2;
        $m_sci_List$();
        var array = [x20];
        var i = (((-1) + $uI(array.length)) | 0);
        var result = $m_sci_Nil$();
        while ((i >= 0)) {
          var this$85 = result;
          var index = i;
          var x$1 = array[index];
          result = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$85);
          i = (((-1) + i) | 0)
        };
        var y$3 = result;
        this.callbacks$2 = jsx$20.$$plus__T2__sci_Map(new $c_T2().init___O__O(name, y$3))
      };
      break matchEnd23
    };
    $c_Lamf_core_parser_Declarations.prototype.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_core_parser_Declarations.call(this, element)
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findChannelBindings__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, scope) {
  var this$1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$12$2) {
      var x$12 = $as_Lamf_core_parser_Declarations(x$12$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$12).channelBindings$2
    })
  })(this)), scope);
  var pf = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findChannelBindings$2().init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(this);
  if ((!this$1.isEmpty__Z())) {
    var this$2 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$1.get__O();
    return this$2.apply__O__s_Option(v1)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findRequestBody__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, scope) {
  var this$1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$4$2) {
      var x$4 = $as_Lamf_core_parser_Declarations(x$4$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$4).requests$2
    })
  })(this)), scope);
  var pf = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findRequestBody$2().init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(this);
  if ((!this$1.isEmpty__Z())) {
    var this$2 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$1.get__O();
    return this$2.apply__O__s_Option(v1)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.promoteExternaltoDataTypeFragment__T__T__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape = (function(text, fullRef, shape) {
  var x1 = this.fragments$1.get__O__s_Option(text);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var fragmentRef = $as_Lamf_core_parser_FragmentRef(x2.value$2);
    var jsx$2 = this.promotedFragments$1;
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var this$5 = new $c_Lamf_plugins_document_webapi_model_DataTypeFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
    var this$4 = fragmentRef.location$1;
    var value = $as_T((this$4.isEmpty__Z() ? fullRef : this$4.get__O()));
    var this$7 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
    var this$6 = fragmentRef.location$1;
    var location = $as_T((this$6.isEmpty__Z() ? fullRef : this$6.get__O()));
    var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
    var this$8 = $as_Lamf_core_model_document_EncodesModel($as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$7, field, location)));
    var field$1 = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
    var jsx$1 = $as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$8, field$1, shape));
    var this$9 = $m_sc_Seq$();
    this.promotedFragments$1 = $as_sc_Seq(jsx$2.$$colon$plus__O__scg_CanBuildFrom__O(jsx$1, this$9.ReusableCBFInstance$2));
    var jsx$3 = this.fragments$1;
    var y = new $c_Lamf_core_parser_FragmentRef().init___Lamf_core_model_domain_DomainElement__s_Option(shape, fragmentRef.location$1);
    this.fragments$1 = jsx$3.$$plus__T2__sci_Map(new $c_T2().init___O__O(text, y))
  } else {
    var jsx$5 = this.promotedFragments$1;
    $m_Lamf_core_parser_Annotations$();
    var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
    var this$15 = new $c_Lamf_plugins_document_webapi_model_DataTypeFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
    var this$16 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$15, fullRef));
    var field$2 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
    var this$17 = $as_Lamf_core_model_document_EncodesModel($as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$16, field$2, fullRef)));
    var field$3 = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
    var jsx$4 = $as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$17, field$3, shape));
    var this$18 = $m_sc_Seq$();
    this.promotedFragments$1 = $as_sc_Seq(jsx$5.$$colon$plus__O__scg_CanBuildFrom__O(jsx$4, this$18.ReusableCBFInstance$2));
    var jsx$6 = this.fragments$1;
    var y$1 = new $c_Lamf_core_parser_FragmentRef().init___Lamf_core_model_domain_DomainElement__s_Option(shape, $m_s_None$());
    this.fragments$1 = jsx$6.$$plus__T2__sci_Map(new $c_T2().init___O__O(text, y$1))
  };
  return shape
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findResponseOrError__Lorg_yaml_model_YPart__T__Lamf_core_parser_SearchScope$Scope__Lamf_plugins_domain_webapi_models_Response = (function(ast, key, searchScope) {
  var x1 = this.findResponse__T__Lamf_core_parser_SearchScope$Scope__s_Option(key, searchScope);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var result = $as_Lamf_plugins_domain_webapi_models_Response(x2.value$2);
    return result
  } else {
    this.error__T__Lorg_yaml_model_YPart__V((("Response '" + key) + "' not found"), ast);
    return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse().init___T__Lorg_yaml_model_YPart(key, ast)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findParameter__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, scope) {
  var this$1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_parser_Declarations(x$2$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$2).parameters$2
    })
  })(this)), scope);
  var pf = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findParameter$2().init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(this);
  if ((!this$1.isEmpty__Z())) {
    var this$2 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$1.get__O();
    return this$2.apply__O__s_Option(v1)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findNamedExample__T__s_Option__s_Option = (function(key, error) {
  var rc7 = false;
  var x2 = null;
  var this$1 = this.fragments$1.get__O__s_Option(key);
  if (this$1.isEmpty__Z()) {
    var x1 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$26 = $as_Lamf_core_parser_FragmentRef(arg1);
    var x1 = new $c_s_Some().init___O(x$26.encoded$1)
  };
  if ((x1 instanceof $c_s_Some)) {
    rc7 = true;
    x2 = $as_s_Some(x1);
    var e = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    if ((e instanceof $c_Lamf_plugins_domain_shapes_models_Example)) {
      var x5 = $as_Lamf_plugins_domain_shapes_models_Example(e);
      return new $c_s_Some().init___O(x5)
    }
  };
  if (rc7) {
    if ((!error.isEmpty__Z())) {
      var arg1$1 = error.get__O();
      var x$27 = $as_F1(arg1$1);
      x$27.apply__O__O((("Fragment defined in " + key) + " does not conform to the expected type NamedExample"))
    };
    return $m_s_None$()
  };
  return $m_s_None$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findResourceTypeOrError__Lorg_yaml_model_YPart__T__Lamf_core_parser_SearchScope$Scope__Lamf_plugins_domain_webapi_models_templates_ResourceType = (function(ast, key, scope) {
  var x1 = this.findResourceType__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option(key, scope, $m_s_None$());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var result = $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(x2.value$2);
    return result
  } else {
    this.error__T__Lorg_yaml_model_YPart__V((("ResourceType " + key) + " not found"), ast);
    return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType().init___T__Lorg_yaml_model_YPart(key, ast)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findSecurityScheme__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option = (function(key, scope, error) {
  var rc6 = false;
  var x2 = null;
  var x1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$24$2) {
      var x$24 = $as_Lamf_core_parser_Declarations(x$24$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$24).securitySchemes$2
    })
  })(this)), scope);
  if ((x1 instanceof $c_s_Some)) {
    rc6 = true;
    x2 = $as_s_Some(x1);
    var ss = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    if ((ss instanceof $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme)) {
      var x4 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(ss);
      return new $c_s_Some().init___O(x4)
    }
  };
  if (rc6) {
    var other = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    var x$2 = $m_Lamf_core_parser_SearchScope$Fragments$();
    if (((scope !== null) && (scope === x$2))) {
      if ((!error.isEmpty__Z())) {
        var arg1 = error.get__O();
        var x$25 = $as_F1(arg1);
        x$25.apply__O__O((("Fragment of type " + $objectGetClass(other).getSimpleName__T()) + " does not conform to the expected type SecurityScheme"))
      };
      return $m_s_None$()
    }
  };
  return $m_s_None$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findNamedExampleOrError__Lorg_yaml_model_YPart__T__Lamf_plugins_domain_shapes_models_Example = (function(ast, key) {
  var x1 = this.findNamedExample__T__s_Option__s_Option(key, $m_s_None$());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var result = $as_Lamf_plugins_domain_shapes_models_Example(x2.value$2);
    return result
  } else {
    this.error__T__Lorg_yaml_model_YPart__V((("NamedExample '" + key) + "' not found"), ast);
    return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample().init___T__Lorg_yaml_model_YPart(key, ast)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findExample__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, scope) {
  var this$1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$5$2) {
      var x$5 = $as_Lamf_core_parser_Declarations(x$5$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$5).examples$2
    })
  })(this)), scope);
  var pf = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findExample$2().init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(this);
  if ((!this$1.isEmpty__Z())) {
    var this$2 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$1.get__O();
    return this$2.apply__O__s_Option(v1)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findSecuritySchemeOrError__Lorg_yaml_model_YPart__T__Lamf_core_parser_SearchScope$Scope__Lamf_plugins_domain_webapi_models_security_SecurityScheme = (function(ast, key, scope) {
  var x1 = this.findSecurityScheme__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option(key, scope, $m_s_None$());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var result = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(x2.value$2);
    return result
  } else {
    this.error__T__Lorg_yaml_model_YPart__V((("SecurityScheme '" + key) + "' not found"), ast);
    return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme().init___T__Lorg_yaml_model_YPart(key, ast)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.alias__s_Option = (function() {
  return this.alias$2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findServerBindings__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, scope) {
  var this$1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$10$2) {
      var x$10 = $as_Lamf_core_parser_Declarations(x$10$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$10).serverBindings$2
    })
  })(this)), scope);
  var pf = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findServerBindings$2().init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(this);
  if ((!this$1.isEmpty__Z())) {
    var this$2 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$1.get__O();
    return this$2.apply__O__s_Option(v1)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findMessageBindings__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, scope) {
  var this$1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$13$2) {
      var x$13 = $as_Lamf_core_parser_Declarations(x$13$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$13).messageBindings$2
    })
  })(this)), scope);
  var pf = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageBindings$2().init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(this);
  if ((!this$1.isEmpty__Z())) {
    var this$2 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$1.get__O();
    return this$2.apply__O__s_Option(v1)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findPayload__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, scope) {
  var this$1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_core_parser_Declarations(x$3$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$3).payloads$2
    })
  })(this)), scope);
  var pf = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findPayload$2().init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(this);
  if ((!this$1.isEmpty__Z())) {
    var this$2 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$1.get__O();
    return this$2.apply__O__s_Option(v1)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.findMessage__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, scope) {
  var this$1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$14$2) {
      var x$14 = $as_Lamf_core_parser_Declarations(x$14$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$14).messages$2
    })
  })(this)), scope);
  var pf = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessage$2().init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(this);
  if ((!this$1.isEmpty__Z())) {
    var this$2 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$1.get__O();
    return this$2.apply__O__s_Option(v1)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.addSchema__Lamf_core_model_domain_Shape__V = (function(s) {
  var this$3 = this.futureDeclarations__Lamf_core_parser_FutureDeclarations();
  var this$1 = $as_Lamf_core_model_StrField(s.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
  var this$2 = this$1.option$1;
  var name = this.aliased__T__T($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())));
  $f_Lamf_core_parser_FutureDeclarations__resolveRef__T__Lamf_core_model_domain_Linkable__V(this$3, name, s);
  var jsx$1 = this.shapes$2;
  var this$4 = $as_Lamf_core_model_StrField(s.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
  var this$5 = this$4.option$1;
  var self = $as_T((this$5.isEmpty__Z() ? null : this$5.get__O()));
  this.shapes$2 = jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, s))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.mergeParts__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__V = (function(other, merged) {
  this.libs$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, merged$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var k = $as_T(x0$1.$$und1__O());
        var s = $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x0$1.$$und2__O());
        merged$1.libs$2 = merged$1.libs$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(k, s))
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, merged)));
  other.libs$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, merged$2) {
    return (function(x0$2$2) {
      var x0$2 = $as_T2(x0$2$2);
      if ((x0$2 !== null)) {
        var k$1 = $as_T(x0$2.$$und1__O());
        var s$1 = $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x0$2.$$und2__O());
        merged$2.libs$2 = merged$2.libs$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$1, s$1))
      } else {
        throw new $c_s_MatchError().init___O(x0$2)
      }
    })
  })(this, merged)));
  this.frags$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, merged$3) {
    return (function(x0$3$2) {
      var x0$3 = $as_T2(x0$3$2);
      if ((x0$3 !== null)) {
        var k$2 = $as_T(x0$3.$$und1__O());
        var s$2 = $as_Lamf_core_parser_FragmentRef(x0$3.$$und2__O());
        merged$3.frags$2 = merged$3.frags$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$2, s$2))
      } else {
        throw new $c_s_MatchError().init___O(x0$3)
      }
    })
  })(this, merged)));
  other.frags$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, merged$4) {
    return (function(x0$4$2) {
      var x0$4 = $as_T2(x0$4$2);
      if ((x0$4 !== null)) {
        var k$3 = $as_T(x0$4.$$und1__O());
        var s$3 = $as_Lamf_core_parser_FragmentRef(x0$4.$$und2__O());
        merged$4.frags$2 = merged$4.frags$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$3, s$3))
      } else {
        throw new $c_s_MatchError().init___O(x0$4)
      }
    })
  })(this, merged)));
  this.libraries$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1, merged$5) {
    return (function(x0$5$2) {
      var x0$5 = $as_T2(x0$5$2);
      if ((x0$5 !== null)) {
        var k$4 = $as_T(x0$5.$$und1__O());
        var s$4 = $as_Lamf_core_parser_Declarations(x0$5.$$und2__O());
        merged$5.libraries$1 = merged$5.libraries$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$4, s$4))
      } else {
        throw new $c_s_MatchError().init___O(x0$5)
      }
    })
  })(this, merged)));
  other.libraries$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1, merged$6) {
    return (function(x0$6$2) {
      var x0$6 = $as_T2(x0$6$2);
      if ((x0$6 !== null)) {
        var k$5 = $as_T(x0$6.$$und1__O());
        var s$5 = $as_Lamf_core_parser_Declarations(x0$6.$$und2__O());
        merged$6.libraries$1 = merged$6.libraries$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$5, s$5))
      } else {
        throw new $c_s_MatchError().init___O(x0$6)
      }
    })
  })(this, merged)));
  this.fragments$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$7$1, merged$7) {
    return (function(x0$7$2) {
      var x0$7 = $as_T2(x0$7$2);
      if ((x0$7 !== null)) {
        var k$6 = $as_T(x0$7.$$und1__O());
        var s$6 = $as_Lamf_core_parser_FragmentRef(x0$7.$$und2__O());
        merged$7.fragments$1 = merged$7.fragments$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$6, s$6))
      } else {
        throw new $c_s_MatchError().init___O(x0$7)
      }
    })
  })(this, merged)));
  other.fragments$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$8$1, merged$8) {
    return (function(x0$8$2) {
      var x0$8 = $as_T2(x0$8$2);
      if ((x0$8 !== null)) {
        var k$7 = $as_T(x0$8.$$und1__O());
        var s$7 = $as_Lamf_core_parser_FragmentRef(x0$8.$$und2__O());
        merged$8.fragments$1 = merged$8.fragments$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$7, s$7))
      } else {
        throw new $c_s_MatchError().init___O(x0$8)
      }
    })
  })(this, merged)));
  this.shapes$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$9$1, merged$9) {
    return (function(x0$9$2) {
      var x0$9 = $as_T2(x0$9$2);
      if ((x0$9 !== null)) {
        var k$8 = $as_T(x0$9.$$und1__O());
        var s$8 = $as_Lamf_core_model_domain_Shape(x0$9.$$und2__O());
        merged$9.shapes$2 = merged$9.shapes$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$8, s$8))
      } else {
        throw new $c_s_MatchError().init___O(x0$9)
      }
    })
  })(this, merged)));
  other.shapes$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$10$1, merged$10) {
    return (function(x0$10$2) {
      var x0$10 = $as_T2(x0$10$2);
      if ((x0$10 !== null)) {
        var k$9 = $as_T(x0$10.$$und1__O());
        var s$9 = $as_Lamf_core_model_domain_Shape(x0$10.$$und2__O());
        merged$10.shapes$2 = merged$10.shapes$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$9, s$9))
      } else {
        throw new $c_s_MatchError().init___O(x0$10)
      }
    })
  })(this, merged)));
  this.anns$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$11$1, merged$11) {
    return (function(x0$11$2) {
      var x0$11 = $as_T2(x0$11$2);
      if ((x0$11 !== null)) {
        var k$10 = $as_T(x0$11.$$und1__O());
        var s$10 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(x0$11.$$und2__O());
        merged$11.anns$2 = merged$11.anns$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$10, s$10))
      } else {
        throw new $c_s_MatchError().init___O(x0$11)
      }
    })
  })(this, merged)));
  other.anns$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$12$1, merged$12) {
    return (function(x0$12$2) {
      var x0$12 = $as_T2(x0$12$2);
      if ((x0$12 !== null)) {
        var k$11 = $as_T(x0$12.$$und1__O());
        var s$11 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(x0$12.$$und2__O());
        merged$12.anns$2 = merged$12.anns$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$11, s$11))
      } else {
        throw new $c_s_MatchError().init___O(x0$12)
      }
    })
  })(this, merged)));
  this.annotations$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$13$1, merged$13) {
    return (function(x0$13$2) {
      var x0$13 = $as_T2(x0$13$2);
      if ((x0$13 !== null)) {
        var k$12 = $as_T(x0$13.$$und1__O());
        var s$12 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(x0$13.$$und2__O());
        merged$13.annotations$1 = merged$13.annotations$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$12, s$12))
      } else {
        throw new $c_s_MatchError().init___O(x0$13)
      }
    })
  })(this, merged)));
  other.annotations$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$14$1, merged$14) {
    return (function(x0$14$2) {
      var x0$14 = $as_T2(x0$14$2);
      if ((x0$14 !== null)) {
        var k$13 = $as_T(x0$14.$$und1__O());
        var s$13 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(x0$14.$$und2__O());
        merged$14.annotations$1 = merged$14.annotations$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$13, s$13))
      } else {
        throw new $c_s_MatchError().init___O(x0$14)
      }
    })
  })(this, merged)));
  this.resourceTypes$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$15$1, merged$15) {
    return (function(x0$15$2) {
      var x0$15 = $as_T2(x0$15$2);
      if ((x0$15 !== null)) {
        var k$14 = $as_T(x0$15.$$und1__O());
        var s$14 = $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(x0$15.$$und2__O());
        merged$15.resourceTypes$2 = merged$15.resourceTypes$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$14, s$14))
      } else {
        throw new $c_s_MatchError().init___O(x0$15)
      }
    })
  })(this, merged)));
  other.resourceTypes$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$16$1, merged$16) {
    return (function(x0$16$2) {
      var x0$16 = $as_T2(x0$16$2);
      if ((x0$16 !== null)) {
        var k$15 = $as_T(x0$16.$$und1__O());
        var s$15 = $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(x0$16.$$und2__O());
        merged$16.resourceTypes$2 = merged$16.resourceTypes$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$15, s$15))
      } else {
        throw new $c_s_MatchError().init___O(x0$16)
      }
    })
  })(this, merged)));
  this.parameters$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$17$1, merged$17) {
    return (function(x0$17$2) {
      var x0$17 = $as_T2(x0$17$2);
      if ((x0$17 !== null)) {
        var k$16 = $as_T(x0$17.$$und1__O());
        var s$16 = $as_Lamf_plugins_domain_webapi_models_Parameter(x0$17.$$und2__O());
        merged$17.parameters$2 = merged$17.parameters$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$16, s$16))
      } else {
        throw new $c_s_MatchError().init___O(x0$17)
      }
    })
  })(this, merged)));
  other.parameters$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$18$1, merged$18) {
    return (function(x0$18$2) {
      var x0$18 = $as_T2(x0$18$2);
      if ((x0$18 !== null)) {
        var k$17 = $as_T(x0$18.$$und1__O());
        var s$17 = $as_Lamf_plugins_domain_webapi_models_Parameter(x0$18.$$und2__O());
        merged$18.parameters$2 = merged$18.parameters$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$17, s$17))
      } else {
        throw new $c_s_MatchError().init___O(x0$18)
      }
    })
  })(this, merged)));
  this.payloads$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$19$1, merged$19) {
    return (function(x0$19$2) {
      var x0$19 = $as_T2(x0$19$2);
      if ((x0$19 !== null)) {
        var k$18 = $as_T(x0$19.$$und1__O());
        var s$18 = $as_Lamf_plugins_domain_webapi_models_Payload(x0$19.$$und2__O());
        merged$19.payloads$2 = merged$19.payloads$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$18, s$18))
      } else {
        throw new $c_s_MatchError().init___O(x0$19)
      }
    })
  })(this, merged)));
  other.payloads$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$20$1, merged$20) {
    return (function(x0$20$2) {
      var x0$20 = $as_T2(x0$20$2);
      if ((x0$20 !== null)) {
        var k$19 = $as_T(x0$20.$$und1__O());
        var s$19 = $as_Lamf_plugins_domain_webapi_models_Payload(x0$20.$$und2__O());
        merged$20.payloads$2 = merged$20.payloads$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$19, s$19))
      } else {
        throw new $c_s_MatchError().init___O(x0$20)
      }
    })
  })(this, merged)));
  this.traits$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$21$1, merged$21) {
    return (function(x0$21$2) {
      var x0$21 = $as_T2(x0$21$2);
      if ((x0$21 !== null)) {
        var k$20 = $as_T(x0$21.$$und1__O());
        var s$20 = $as_Lamf_plugins_domain_webapi_models_templates_Trait(x0$21.$$und2__O());
        merged$21.traits$2 = merged$21.traits$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$20, s$20))
      } else {
        throw new $c_s_MatchError().init___O(x0$21)
      }
    })
  })(this, merged)));
  other.traits$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$22$1, merged$22) {
    return (function(x0$22$2) {
      var x0$22 = $as_T2(x0$22$2);
      if ((x0$22 !== null)) {
        var k$21 = $as_T(x0$22.$$und1__O());
        var s$21 = $as_Lamf_plugins_domain_webapi_models_templates_Trait(x0$22.$$und2__O());
        merged$22.traits$2 = merged$22.traits$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$21, s$21))
      } else {
        throw new $c_s_MatchError().init___O(x0$22)
      }
    })
  })(this, merged)));
  this.securitySchemes$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$23$1, merged$23) {
    return (function(x0$23$2) {
      var x0$23 = $as_T2(x0$23$2);
      if ((x0$23 !== null)) {
        var k$22 = $as_T(x0$23.$$und1__O());
        var s$22 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(x0$23.$$und2__O());
        merged$23.securitySchemes$2 = merged$23.securitySchemes$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$22, s$22))
      } else {
        throw new $c_s_MatchError().init___O(x0$23)
      }
    })
  })(this, merged)));
  other.securitySchemes$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$24$1, merged$24) {
    return (function(x0$24$2) {
      var x0$24 = $as_T2(x0$24$2);
      if ((x0$24 !== null)) {
        var k$23 = $as_T(x0$24.$$und1__O());
        var s$23 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(x0$24.$$und2__O());
        merged$24.securitySchemes$2 = merged$24.securitySchemes$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$23, s$23))
      } else {
        throw new $c_s_MatchError().init___O(x0$24)
      }
    })
  })(this, merged)));
  this.responses$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$25$1, merged$25) {
    return (function(x0$25$2) {
      var x0$25 = $as_T2(x0$25$2);
      if ((x0$25 !== null)) {
        var k$24 = $as_T(x0$25.$$und1__O());
        var s$24 = $as_Lamf_plugins_domain_webapi_models_Response(x0$25.$$und2__O());
        merged$25.responses$2 = merged$25.responses$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$24, s$24))
      } else {
        throw new $c_s_MatchError().init___O(x0$25)
      }
    })
  })(this, merged)));
  other.responses$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$26$1, merged$26) {
    return (function(x0$26$2) {
      var x0$26 = $as_T2(x0$26$2);
      if ((x0$26 !== null)) {
        var k$25 = $as_T(x0$26.$$und1__O());
        var s$25 = $as_Lamf_plugins_domain_webapi_models_Response(x0$26.$$und2__O());
        merged$26.responses$2 = merged$26.responses$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$25, s$25))
      } else {
        throw new $c_s_MatchError().init___O(x0$26)
      }
    })
  })(this, merged)))
});
function $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.WebApiDeclarations;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations: 1,
  Lamf_core_parser_Declarations: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$() {
  $c_O.call(this);
  this.nodes$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$ = this;
  var jsx$56 = $m_s_Predef$().Map$2;
  var jsx$54 = $m_s_Predef$().Set$2;
  var array = ["asyncapi", "id", "info", "servers", "channels", "components", "tags", "externalDocs", "defaultContentType"];
  var y = jsx$54.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
  var jsx$55 = new $c_T2().init___O__O("webApi", y);
  var jsx$52 = $m_s_Predef$().Set$2;
  var array$1 = ["url", "protocol", "protocolVersion", "description", "variables", "security", "bindings"];
  var y$1 = jsx$52.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
  var jsx$53 = new $c_T2().init___O__O("server", y$1);
  var jsx$50 = $m_s_Predef$().Set$2;
  var array$2 = ["default", "description", "enum", "examples"];
  var y$2 = jsx$50.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2));
  var jsx$51 = new $c_T2().init___O__O("serverVariable", y$2);
  var jsx$48 = $m_s_Predef$().Set$2;
  var array$3 = ["method", "query", "headers", "bindingVersion"];
  var y$3 = jsx$48.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$3));
  var jsx$49 = new $c_T2().init___O__O("wsChannelBinding", y$3);
  var jsx$46 = $m_s_Predef$().Set$2;
  var array$4 = ["name", "durable", "exclusive", "autoDelete", "vhost"];
  var y$4 = jsx$46.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$4));
  var jsx$47 = new $c_T2().init___O__O("amqpQueueChannelBinding", y$4);
  var jsx$44 = $m_s_Predef$().Set$2;
  var array$5 = ["is", "queue", "bindingVersion"];
  var y$5 = jsx$44.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$5));
  var jsx$45 = new $c_T2().init___O__O("amqpIsQueueChannelBinding", y$5);
  var jsx$42 = $m_s_Predef$().Set$2;
  var array$6 = ["name", "type", "durable", "autoDelete", "vhost"];
  var y$6 = jsx$42.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$6));
  var jsx$43 = new $c_T2().init___O__O("amqpExchangeChannelBinding", y$6);
  var jsx$40 = $m_s_Predef$().Set$2;
  var array$7 = ["is", "exchange", "bindingVersion"];
  var y$7 = jsx$40.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$7));
  var jsx$41 = new $c_T2().init___O__O("amqpIsExchangeChannelBinding", y$7);
  var jsx$38 = $m_s_Predef$().Set$2;
  var array$8 = ["type", "method", "query", "bindingVersion"];
  var y$8 = jsx$38.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$8));
  var jsx$39 = new $c_T2().init___O__O("httpOperationBinding", y$8);
  var jsx$36 = $m_s_Predef$().Set$2;
  var array$9 = ["expiration", "userId", "cc", "priority", "deliveryMode", "mandatory", "bcc", "replyTo", "timestamp", "ack", "bindingVersion"];
  var y$9 = jsx$36.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$9));
  var jsx$37 = new $c_T2().init___O__O("amqpOperationBinding", y$9);
  var jsx$34 = $m_s_Predef$().Set$2;
  var array$10 = ["contentEncoding", "messageType", "bindingVersion"];
  var y$10 = jsx$34.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$10));
  var jsx$35 = new $c_T2().init___O__O("amqpMessageBinding", y$10);
  var jsx$32 = $m_s_Predef$().Set$2;
  var array$11 = ["qos", "retain", "bindingVersion"];
  var y$11 = jsx$32.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$11));
  var jsx$33 = new $c_T2().init___O__O("mqttOperationBinding", y$11);
  var jsx$30 = $m_s_Predef$().Set$2;
  var array$12 = ["clientId", "cleanSession", "lastWill", "keepAlive", "bindingVersion"];
  var y$12 = jsx$30.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$12));
  var jsx$31 = new $c_T2().init___O__O("mqttServerBinding", y$12);
  var jsx$28 = $m_s_Predef$().Set$2;
  var array$13 = ["topic", "qos", "retain"];
  var y$13 = jsx$28.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$13));
  var jsx$29 = new $c_T2().init___O__O("mqttServerLastWill", y$13);
  var jsx$26 = $m_s_Predef$().Set$2;
  var array$14 = ["bindingVersion"];
  var y$14 = jsx$26.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$14));
  var jsx$27 = new $c_T2().init___O__O("mqttMessageBinding", y$14);
  var jsx$24 = $m_s_Predef$().Set$2;
  var array$15 = ["headers", "bindingVersion"];
  var y$15 = jsx$24.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$15));
  var jsx$25 = new $c_T2().init___O__O("httpMessageBinding", y$15);
  var jsx$22 = $m_s_Predef$().Set$2;
  var array$16 = ["key", "bindingVersion"];
  var y$16 = jsx$22.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$16));
  var jsx$23 = new $c_T2().init___O__O("kafkaMessageBinding", y$16);
  var jsx$20 = $m_s_Predef$().Set$2;
  var array$17 = ["groupId", "clientId", "bindingVersion"];
  var y$17 = jsx$20.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$17));
  var jsx$21 = new $c_T2().init___O__O("kafkaOperationBinding", y$17);
  var jsx$18 = $m_s_Predef$().Set$2;
  var array$18 = ["$ref", "$schema", "$comment", "$id", "format", "title", "description", "maximum", "exclusiveMaximum", "minimum", "exclusiveMinimum", "maxLength", "minLength", "pattern", "maxItems", "minItems", "uniqueItems", "maxProperties", "minProperties", "required", "enum", "type", "items", "additionalItems", "collectionFormat", "allOf", "properties", "additionalProperties", "propertyNames", "discriminator", "readOnly", "writeOnly", "deprecated", "externalDocs", "allOf", "anyOf", "oneOf", "not", "dependencies", "multipleOf", "default", "examples", "if", "then", "else", "const", "contains", "name", "patternProperties"];
  var y$18 = jsx$18.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$18));
  var jsx$19 = new $c_T2().init___O__O("schema", y$18);
  var jsx$16 = $m_s_Predef$().Set$2;
  var array$19 = ["headers", "payload", "correlationId", "schemaFormat", "contentType", "name", "title", "summary", "description", "tags", "externalDocs", "bindings", "examples", "traits"];
  var y$19 = jsx$16.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$19));
  var jsx$17 = new $c_T2().init___O__O("message", y$19);
  var jsx$14 = $m_s_Predef$().Set$2;
  var array$20 = ["description", "location"];
  var y$20 = jsx$14.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$20));
  var jsx$15 = new $c_T2().init___O__O("correlationId", y$20);
  var jsx$12 = $m_s_Predef$().Set$2;
  var array$21 = ["description", "schema", "location"];
  var y$21 = jsx$12.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$21));
  var jsx$13 = new $c_T2().init___O__O("parameter", y$21);
  var jsx$10 = $m_s_Predef$().Set$2;
  var array$22 = ["description", "subscribe", "publish", "parameters", "bindings"];
  var y$22 = jsx$10.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$22));
  var jsx$11 = new $c_T2().init___O__O("pathItem", y$22);
  var jsx$8 = $m_s_Predef$().Set$2;
  var array$23 = ["operationId", "summary", "description", "tags", "externalDocs", "bindings", "traits", "message"];
  var y$23 = jsx$8.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$23));
  var jsx$9 = new $c_T2().init___O__O("operation", y$23);
  var jsx$6 = $m_s_Predef$().Set$2;
  var array$24 = ["operationId", "summary", "description", "tags", "externalDocs", "bindings"];
  var y$24 = jsx$6.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$24));
  var jsx$7 = new $c_T2().init___O__O("operationTrait", y$24);
  var jsx$4 = $m_s_Predef$().Set$2;
  var array$25 = ["headers", "correlationId", "schemaFormat", "contentType", "name", "title", "summary", "description", "tags", "externalDocs", "bindings", "examples"];
  var y$25 = jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$25));
  var jsx$5 = new $c_T2().init___O__O("messageTrait", y$25);
  var jsx$2 = $m_s_Predef$().Set$2;
  var array$26 = ["title", "description", "termsOfService", "contact", "license", "version"];
  var y$26 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$26));
  var jsx$3 = new $c_T2().init___O__O("info", y$26);
  var jsx$1 = $m_s_Predef$().Set$2;
  var array$27 = ["type", "description", "name", "in", "scheme", "bearerFormat", "flows", "openIdConnectUrl"];
  var y$27 = jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$27));
  var array$28 = [jsx$55, jsx$53, jsx$51, jsx$49, jsx$47, jsx$45, jsx$43, jsx$41, jsx$39, jsx$37, jsx$35, jsx$33, jsx$31, jsx$29, jsx$27, jsx$25, jsx$23, jsx$21, jsx$19, jsx$17, jsx$15, jsx$13, jsx$11, jsx$9, jsx$7, jsx$5, jsx$3, new $c_T2().init___O__O("securityScheme", y$27)];
  this.nodes$1 = $as_sci_Map(jsx$56.apply__sc_Seq__sc_GenMap(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$28)));
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$.prototype.nodes__sci_Map = (function() {
  return this.nodes$1
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.Async20Syntax$", {
  Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_SpecSyntax: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$;
var $n_Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$ = new $c_Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_Draft7ExampleEmitters() {
  $c_O.call(this);
  this.examples$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_Draft7ExampleEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_Draft7ExampleEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_Draft7ExampleEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_Draft7ExampleEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_Draft7ExampleEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_Draft7ExampleEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_Draft7ExampleEmitters.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(examples, ordering, references, spec) {
  this.examples$1 = examples;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_Draft7ExampleEmitters.prototype.emitters__scm_ListBuffer = (function() {
  $m_scm_ListBuffer$();
  var array = [new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("examples", this.examples$1, this.ordering$1, this.references$1, this.spec$1)];
  if (($uI(array.length) === 0)) {
    var this$4 = new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_ListBuffer().init___());
    var jsx$1 = $as_sc_GenTraversable(this$4.elems$1)
  } else {
    var b = new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_ListBuffer().init___());
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      b.$$plus$eq__O__scm_GrowingBuilder(arg1);
      i = ((1 + i) | 0)
    };
    var jsx$1 = $as_sc_GenTraversable(b.elems$1)
  };
  return $as_scm_ListBuffer(jsx$1)
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_Draft7ExampleEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_Draft7ExampleEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.Draft7ExampleEmitters", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_Draft7ExampleEmitters: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeExampleEmitters: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_Draft7ExampleEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_Draft7ExampleEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser() {
  $c_O.call(this);
  this.entryLike$1 = null;
  this.parent$1 = null;
  this.messageType$1 = null;
  this.populator$1 = null;
  this.finder$1 = null;
  this.isTrait$1 = false;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser.prototype.buildMessage__p1__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Message = (function(map) {
  var rc10 = false;
  var x2 = null;
  var x1 = this.messageType$1;
  if ((x1 instanceof $c_s_Some)) {
    rc10 = true;
    x2 = $as_s_Some(x1);
    var p3 = $as_Lamf_plugins_document_webapi_parser_spec_async_MessageType(x2.value$2);
    var x = $m_Lamf_plugins_document_webapi_parser_spec_async_Publish$();
    if ((x === p3)) {
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(map);
      return new $c_Lamf_plugins_domain_webapi_models_Request().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
    }
  };
  if (rc10) {
    var p5 = $as_Lamf_plugins_document_webapi_parser_spec_async_MessageType(x2.value$2);
    var x$3 = $m_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$();
    if ((x$3 === p5)) {
      var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(map);
      return new $c_Lamf_plugins_domain_webapi_models_Response().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1)
    }
  };
  var x$5 = $m_s_None$();
  if ((x$5 === x1)) {
    var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(map);
    return new $c_Lamf_plugins_domain_webapi_models_Message().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$2)
  };
  throw new $c_s_MatchError().init___O(x1)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser.prototype.nameAndAdopt__Lamf_plugins_domain_webapi_models_Message__s_Option__Lamf_plugins_domain_webapi_models_Message = (function(m, key) {
  if ((!key.isEmpty__Z())) {
    var arg1 = key.get__O();
    var k = $as_Lorg_yaml_model_YNode(arg1);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Name$1;
    var iv = this.ctx$1;
    var this$2 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(k, iv);
    var value = this$2.string__Lamf_core_model_domain_AmfScalar();
    $as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(m, field, value))
  };
  var parent = this.parent$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  return $as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(m, parent))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser.prototype.remote__p1__T__Lamf_plugins_domain_webapi_models_Message = (function(fullRef) {
  var this$3 = this.ctx$1;
  $m_Lamf_core_parser_Annotations$();
  new $c_Lamf_core_parser_Annotations().init___();
  var x1 = this$3.jsonSchemaRefGuide$2.obtainRemoteYNode__T__s_Option(fullRef);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var messageNode = $as_Lorg_yaml_model_YNode(x2.value$2);
    var jsx$1 = $m_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$();
    var errorHandler = this.ctx$1;
    var external = jsx$1.apply__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__s_Option__Z__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser(new $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(messageNode, errorHandler), this.parent$1, this.messageType$1, false, this.ctx$1).parse__Lamf_plugins_domain_webapi_models_Message();
    return this.nameAndAdopt__Lamf_plugins_domain_webapi_models_Message__s_Option__Lamf_plugins_domain_webapi_models_Message(this.generateLink__p1__T__Lamf_plugins_domain_webapi_models_Message__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_plugins_domain_webapi_models_Message(fullRef, external, this.entryLike$1), this.entryLike$1.key__s_Option())
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$5 = this.ctx$1.eh$1;
      var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnresolvedReference$1;
      var message = ("Cannot find link reference " + fullRef);
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entryLike$1.asMap__Lorg_yaml_model_YMap());
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$5, specification, "", message, annotations);
      var errorMessage = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessage().init___T__Lorg_yaml_model_YPart__Z(fullRef, this.entryLike$1.asMap__Lorg_yaml_model_YMap(), this.isTrait$1);
      var annotations$1 = errorMessage.annotations$1;
      return this.nameAndAdopt__Lamf_plugins_domain_webapi_models_Message__s_Option__Lamf_plugins_domain_webapi_models_Message($as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(errorMessage, fullRef, annotations$1)), this.entryLike$1.key__s_Option())
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__s_Option__Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator__Lamf_plugins_document_webapi_parser_spec_async_parser_Finder__Z__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(entryLike, parent, messageType, populator, finder, isTrait, ctx) {
  this.entryLike$1 = entryLike;
  this.parent$1 = parent;
  this.messageType$1 = messageType;
  this.populator$1 = populator;
  this.finder$1 = finder;
  this.isTrait$1 = isTrait;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser.prototype.handleRef__p1__T__Lamf_plugins_domain_webapi_models_Message = (function(fullRef) {
  var label = this.finder$1.label__T__T(fullRef);
  var this$1 = this.finder$1.findInComponents__T__Lamf_core_parser_SearchScope$Scope__s_Option(label, $m_Lamf_core_parser_SearchScope$Named$());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var msg = $as_Lamf_plugins_domain_webapi_models_Message(arg1);
    var this$2 = new $c_s_Some().init___O(this.nameAndAdopt__Lamf_plugins_domain_webapi_models_Message__s_Option__Lamf_plugins_domain_webapi_models_Message(this.generateLink__p1__T__Lamf_plugins_domain_webapi_models_Message__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_plugins_domain_webapi_models_Message(label, msg, this.entryLike$1), this.entryLike$1.key__s_Option()))
  };
  return $as_Lamf_plugins_domain_webapi_models_Message((this$2.isEmpty__Z() ? this.remote__p1__T__Lamf_plugins_domain_webapi_models_Message(fullRef) : this$2.get__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser.prototype.generateLink__p1__T__Lamf_plugins_domain_webapi_models_Message__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_plugins_domain_webapi_models_Message = (function(label, effectiveTarget, entryLike) {
  var message = this.buildMessage__p1__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Message(entryLike.asMap__Lorg_yaml_model_YMap());
  var this$1 = (("" + message.id$1) + label);
  var hash = $m_sjsr_RuntimeString$().hashCode__T__I(this$1);
  var this$2 = $as_Lamf_core_model_domain_Linkable(message.withId__T__Lamf_core_model_domain_AmfObject(((message.id$1 + "/link-") + hash)));
  var this$3 = $as_Lamf_core_model_domain_Linkable($f_Lamf_core_model_domain_Linkable__withLinkTarget__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(this$2, effectiveTarget));
  var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1;
  return $as_Lamf_plugins_domain_webapi_models_Message($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$3, field, label)))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser.prototype.parse__Lamf_plugins_domain_webapi_models_Message = (function() {
  var map = this.entryLike$1.asMap__Lorg_yaml_model_YMap();
  var x1 = this.ctx$1.link__Lorg_yaml_model_YNode__s_util_Either(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1)));
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var fullRef = $as_T(x2.value$2);
    return this.handleRef__p1__T__Lamf_plugins_domain_webapi_models_Message(fullRef)
  } else if ((x1 instanceof $c_s_util_Right)) {
    var message = this.buildMessage__p1__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Message(map);
    this.nameAndAdopt__Lamf_plugins_domain_webapi_models_Message__s_Option__Lamf_plugins_domain_webapi_models_Message(message, this.entryLike$1.key__s_Option());
    return this.populator$1.populate__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Message__Lamf_plugins_domain_webapi_models_Message(map, message)
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncMessageParser", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator() {
  $c_O.call(this);
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator.prototype.populate__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Message__Lamf_plugins_domain_webapi_models_Message = (function(map, message) {
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().DisplayName$1;
  var iv = this.ctx$1;
  jsx$1.key__T__F1__V("name", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(message));
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Title$1;
  var iv$1 = this.ctx$1;
  jsx$2.key__T__F1__V("title", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(message));
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Summary$1;
  var iv$2 = this.ctx$1;
  jsx$3.key__T__F1__V("summary", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(message));
  var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Description$1;
  var iv$3 = this.ctx$1;
  jsx$4.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$3, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(message));
  var jsx$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Documentation$1;
  var iv$4 = this.ctx$1;
  jsx$5.key__T__F1__V("externalDocs", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$4, iv$4).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(message).using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, message$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lorg_yaml_model_YNode(x$1$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$().parse__Lorg_yaml_model_YNode__T__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_domain_shapes_models_CreativeWork(x$1, message$1.id$1, $this.ctx$1)
    })
  })(this, message))));
  var this$7 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$8 = this$7.key__T__s_Option("tags");
  if ((!this$8.isEmpty__Z())) {
    var arg1 = this$8.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var tags = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser().init___T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(message.id$1, entry, this.ctx$1).parse__sc_Seq();
    var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Tags$1;
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(tags, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(message, field$5, value, annotations)
  };
  var examples = this.parseNamedValueExamples__p1__Lorg_yaml_model_YMap__T__sc_Seq(map, message.id$1);
  if (examples.nonEmpty__Z()) {
    examples.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, message$2) {
      return (function(ex$2) {
        var ex = $as_Lamf_plugins_domain_shapes_models_Example(ex$2);
        return ex.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations($m_Lamf_core_annotations_TrackedElement$().apply__T__Lamf_core_annotations_TrackedElement(message$2.id$1))
      })
    })(this, message)));
    var field$6 = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Examples$1;
    var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(examples, new $c_Lamf_core_parser_Annotations().init___());
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(message, field$6, value$1)
  };
  var this$11 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$12 = this$11.key__T__s_Option("headers");
  if ((!this$12.isEmpty__Z())) {
    var arg1$1 = this$12.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var this$13 = this.parseHeaderSchema__p1__Lorg_yaml_model_YMapEntry__T__s_Option(entry$3, message.id$1);
    if ((!this$13.isEmpty__Z())) {
      var arg1$2 = this$13.get__O();
      var param = $as_Lamf_plugins_domain_webapi_models_Parameter(arg1$2);
      var field$7 = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Headers$1;
      var jsx$6 = $m_sc_Seq$();
      var array = [param];
      var value$2 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$6.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3.value$2));
      var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
      $as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(message, field$7, value$2, annotations$1))
    }
  };
  var jsx$7 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$8 = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().CorrelationId$1;
  var iv$5 = this.ctx$1;
  jsx$7.key__T__F1__V("correlationId", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$8, iv$5).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(message).using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1, message$3) {
    return (function(x$2$2) {
      var x$2 = $as_Lorg_yaml_model_YNode(x$2$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser$().apply__Lorg_yaml_model_YNode__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser(x$2, message$3.id$1, this$5$1.ctx$1).parse__Lamf_plugins_domain_webapi_models_CorrelationId()
    })
  })(this, message))));
  var this$18 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("bindings");
  if ((!this$18.isEmpty__Z())) {
    var arg1$3 = this$18.get__O();
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
    var node = entry$4.value$2;
    var errorHandler = this.ctx$1;
    var bindings = $as_Lamf_plugins_domain_webapi_models_bindings_MessageBindings(new $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser().init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(new $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, errorHandler), message.id$1, this.ctx$1).parse__Lamf_core_model_domain_NamedDomainElement());
    var field$9 = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Bindings$1;
    var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(message, field$9, bindings, annotations$2);
    new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(message, map, $m_sci_Nil$(), this.ctx$1).parseOrphanNode__T__V("bindings")
  };
  this.parseTraits__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Message__V(map, message);
  $m_Lamf_core_parser_Annotations$();
  var annotation = new $c_Lamf_core_annotations_VirtualObject().init___();
  var annotations$3 = new $c_Lamf_core_parser_Annotations().init___().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(annotation);
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_Payload().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$3);
  var x$1$3 = message.id$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var payload = $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1$3));
  var jsx$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$10 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1;
  var iv$6 = this.ctx$1;
  jsx$8.key__T__F1__V("contentType", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$10, iv$6).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(payload));
  var jsx$9 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$11 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().SchemaMediaType$1;
  var iv$7 = this.ctx$1;
  jsx$9.key__T__F1__V("schemaFormat", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$11, iv$7).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(payload));
  this.parseSchema__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Payload__V(map, payload);
  this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(message.id$1, map, "message");
  var field$12 = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1;
  var jsx$10 = $m_sc_Seq$();
  var array$1 = [payload];
  var value$3 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$10.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1))), new $c_Lamf_core_parser_Annotations().init___());
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(message, field$12, value$3);
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(message, map, $m_sci_Nil$(), this.ctx$1).parse__V();
  return message
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$2__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator.prototype.parseNamedValueExamples__p1__Lorg_yaml_model_YMap__T__sc_Seq = (function(map, parentId) {
  var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("examples");
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var examplesEntry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    var this$2 = examplesEntry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$1;
    var jsx$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv)).entries$3;
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parentId$1) {
      return (function(entry$2) {
        var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
        var example = $m_Lamf_plugins_domain_shapes_models_Example$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_Example(entry);
        var field = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Name$1;
        var node = entry.key$2;
        var iv$1 = $this.ctx$1;
        var this$4 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv$1);
        var value = this$4.text__Lamf_core_model_domain_AmfScalar();
        var qual$1 = $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(example, field, value));
        $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, parentId$1);
        return new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser().init___Lorg_yaml_model_YNode__Lamf_plugins_domain_shapes_models_Example__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext(entry.value$2, example, $m_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$(), $this.ctx$1).parse__Lamf_plugins_domain_shapes_models_Example()
      })
    })(this, parentId));
    var this$5 = $m_sc_IndexedSeq$();
    return $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBF$6))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return $m_sci_Nil$()
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator.prototype.EmptyTarget$lzycompute$2__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator.prototype.init___Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(ctx) {
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator.prototype.parseHeaderSchema__p1__Lorg_yaml_model_YMapEntry__T__s_Option = (function(entry, parentId) {
  var this$2 = $m_Lamf_plugins_domain_webapi_models_Parameter$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_Parameter(entry.value$2);
  $m_Lamf_core_parser_Annotations$();
  var annotation = new $c_Lamf_core_annotations_SynthesizedField().init___();
  var a = new $c_Lamf_core_parser_Annotations().init___().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(annotation);
  var qual$1 = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$2, "default-parameter", a));
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var param = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, parentId));
  var shape$3 = $m_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, param$1) {
    return (function(shape$2) {
      var shape = $as_Lamf_core_model_domain_Shape(shape$2);
      $m_Lamf_core_parser_Annotations$();
      var a$1 = new $c_Lamf_core_parser_Annotations().init___();
      var qual$2 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, "schema", a$1));
      var x$3 = param$1.id$1;
      var x$4 = qual$2.adopted$default$2__sc_Seq();
      qual$2.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$3, x$4)
    })
  })(this, param)), $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$(), this.ctx$1).parse__s_Option();
  if (shape$3.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = shape$3.get__O();
    var schema = $as_Lamf_core_model_domain_Shape(arg1);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
    var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations("header", new $c_Lamf_core_parser_Annotations().init___());
    var annotations = ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SynthesizedField().init___());
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(param, field, value, annotations);
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1;
    return new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(param, field$1, schema)))
  }
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField() {
  $c_O.call(this);
  this.target$1 = null;
  this.field$1 = null;
  this.iv$1 = null;
  this.custom$1 = null;
  this.annotations$1 = null;
  this.mapped$1 = null;
  this.typed$1 = null;
  this.single$1 = false;
  this.entries$1 = false;
  this.annotated$1 = false;
  this.opt$1 = false;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype.negated__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField = (function() {
  this.typed$1 = new $c_s_Some().init___O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_parser_TypedNode(x$2$2);
      return x$2.negated__Lamf_core_model_domain_AmfElement()
    })
  })(this)));
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype.createArrayNode__p1__Lorg_yaml_model_YNode__Lamf_core_parser_ArrayNode = (function(node) {
  if (this.single$1) {
    return $m_Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_core_parser_ArrayNode(node, this.iv$1)
  } else if (this.entries$1) {
    return $m_Lamf_plugins_document_webapi_parser_spec_common_MapArrayNode$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_core_parser_ArrayNode(node, this.iv$1)
  } else {
    var iv = this.iv$1;
    return new $c_Lamf_core_parser_DefaultArrayNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype.apply__O__O = (function(v1) {
  this.apply__Lorg_yaml_model_YMapEntry__V($as_Lorg_yaml_model_YMapEntry(v1))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype.parseScalar__p1__Lorg_yaml_model_YNode__Lamf_core_metamodel_Type__Lorg_yaml_model_YType__Lamf_core_model_domain_AmfElement = (function(node, element, tagType) {
  if (this.annotated$1) {
    var scalar = this.parseScalarValued__p1__Lorg_yaml_model_YNode__Lamf_core_parser_ScalarNode(node)
  } else {
    var iv = this.iv$1;
    var scalar = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv)
  };
  if (this.typed$1.isDefined__Z()) {
    return $as_Lamf_core_model_domain_AmfElement($as_F1(this.typed$1.get__O()).apply__O__O(scalar))
  } else {
    var x = $m_Lamf_core_metamodel_Type$Int$();
    if (x.equals__O__Z(element)) {
      return scalar.integer__Lamf_core_model_domain_AmfScalar()
    } else {
      var x$3 = $m_Lamf_core_metamodel_Type$Bool$();
      if (x$3.equals__O__Z(element)) {
        return scalar.$boolean__Lamf_core_model_domain_AmfScalar()
      } else {
        var x$5 = $m_Lamf_core_metamodel_Type$Double$();
        if (x$5.equals__O__Z(element)) {
          return scalar.$double__Lamf_core_model_domain_AmfScalar()
        } else {
          var x$7 = $m_Lamf_core_metamodel_Type$Str$();
          if (x$7.equals__O__Z(element)) {
            var x$9 = $m_Lorg_yaml_model_YType$().Str$1;
            var jsx$1 = (x$9 === tagType)
          } else {
            var jsx$1 = false
          };
          if (jsx$1) {
            return scalar.string__Lamf_core_model_domain_AmfScalar()
          } else {
            return scalar.text__Lamf_core_model_domain_AmfScalar()
          }
        }
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype.withAnnotation__Lamf_core_model_domain_Annotation__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField = (function(a) {
  this.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(a);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype.parseScalarValued__p1__Lorg_yaml_model_YNode__Lamf_core_parser_ScalarNode = (function(node) {
  var result = $m_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_core_parser_ScalarNode(node, this.iv$1);
  var x1 = this.target$1;
  if ((x1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget)) {
    var x2 = $as_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget(x1);
    var element = x2.elem$1;
    var jsx$3 = this.custom$1;
    var jsx$2 = this.collectDomainExtensions__p1__T__Lamf_core_parser_ScalarNode__sc_Seq(((element.id__T() + "/") + this.field$1.value$1.name$1), result);
    var jsx$1 = $m_Lamf_core_annotations_DomainExtensionAnnotation$();
    var this$1 = $m_sc_Seq$();
    jsx$3.$$plus$plus$eq__sc_TraversableOnce__Lamf_core_parser_Annotations($as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)))
  } else {
    var x = this.$$outer$1.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$();
    if ((x === x1)) {
      var jsx$6 = this.custom$1;
      var jsx$5 = this.collectDomainExtensions__p1__T__Lamf_core_parser_ScalarNode__sc_Seq(null, result);
      var jsx$4 = $m_Lamf_core_annotations_DomainExtensionAnnotation$();
      var this$2 = $m_sc_Seq$();
      jsx$6.$$plus$plus$eq__sc_TraversableOnce__Lamf_core_parser_Annotations($as_sc_TraversableOnce(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$4, this$2.ReusableCBFInstance$2)))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype.init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$Target__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext = (function($$outer, target, field, iv) {
  this.target$1 = target;
  this.field$1 = field;
  this.iv$1 = iv;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.custom$1 = ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___());
  this.annotations$1 = ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___());
  this.mapped$1 = $m_s_None$();
  this.typed$1 = $m_s_None$();
  this.single$1 = false;
  this.entries$1 = false;
  this.annotated$1 = false;
  this.opt$1 = false;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype.toString__T = (function() {
  return "<function1>"
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype.allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField = (function() {
  this.annotated$1 = true;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype.apply$mcZI$sp__I__Z = (function(v1) {
  return $uZ((this.apply__Lorg_yaml_model_YMapEntry__V($as_Lorg_yaml_model_YMapEntry(v1)), (void 0)))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype.treatMapAsArray__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField = (function() {
  this.entries$1 = true;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype.allowingSingleValue__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField = (function() {
  this.single$1 = true;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype.collectDomainExtensions__p1__T__Lamf_core_parser_ScalarNode__sc_Seq = (function(parent, n) {
  if ((n instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode)) {
    var x2 = $as_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode(n);
    return $m_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$().parseExtensions__T__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext__sc_Seq(parent, x2.obj$1, $m_sci_Nil$(), this.iv$1)
  } else if ((n instanceof $c_Lamf_core_parser_DefaultScalarNode)) {
    return $m_sci_Nil$()
  } else {
    throw new $c_s_MatchError().init___O(n)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype.using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField = (function(fn) {
  this.mapped$1 = new $c_s_Some().init___O(fn);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype.parseArray__p1__Lorg_yaml_model_YNode__Lamf_core_metamodel_Type__Lamf_core_model_domain_AmfElement = (function(node, element) {
  var array = this.createArrayNode__p1__Lorg_yaml_model_YNode__Lamf_core_parser_ArrayNode(node);
  if (($is_Lamf_core_metamodel_Obj(element) && this.mapped$1.isDefined__Z())) {
    return array.obj__F1__Lamf_core_model_domain_AmfArray($as_F1(this.mapped$1.get__O()))
  } else if (this.typed$1.isDefined__Z()) {
    return $as_Lamf_core_model_domain_AmfElement($as_F1(this.typed$1.get__O()).apply__O__O(array))
  } else {
    var x = $m_Lamf_core_metamodel_Type$Int$();
    if (x.equals__O__Z(element)) {
      return array.integer__Lamf_core_model_domain_AmfArray()
    } else {
      var x$3 = $m_Lamf_core_metamodel_Type$Bool$();
      if (x$3.equals__O__Z(element)) {
        return array.$boolean__Lamf_core_model_domain_AmfArray()
      } else {
        return array.text__Lamf_core_model_domain_AmfArray()
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype.apply__Lorg_yaml_model_YMapEntry__V = (function(entry) {
  var node = entry.value$2;
  var this$1 = entry.value$2;
  var x1 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Null$1;
  if ((!((x === x1) && this.opt$1))) {
    var x1$2 = this.field$1.type$1;
    if (($is_Lamf_core_metamodel_Obj(x1$2) && this.mapped$1.isDefined__Z())) {
      var value = $as_Lamf_core_model_domain_AmfElement($as_F1(this.mapped$1.get__O()).apply__O__O(node))
    } else if ((x1$2 instanceof $c_Lamf_core_metamodel_Type$ArrayLike)) {
      var x2 = $as_Lamf_core_metamodel_Type$ArrayLike(x1$2);
      var o10 = new $c_s_Some().init___O(x2.element__Lamf_core_metamodel_Type());
      var element = $as_Lamf_core_metamodel_Type(o10.value$2);
      var value = this.parseArray__p1__Lorg_yaml_model_YNode__Lamf_core_metamodel_Type__Lamf_core_model_domain_AmfElement(node, element)
    } else {
      var this$3 = entry.value$2;
      var value = this.parseScalar__p1__Lorg_yaml_model_YNode__Lamf_core_metamodel_Type__Lorg_yaml_model_YType__Lamf_core_model_domain_AmfElement(node, x1$2, this$3.tag__Lorg_yaml_model_YTag().tagType$3)
    };
    value.annotations__Lamf_core_parser_Annotations().$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(this.custom$1);
    this.target$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, value$1, entry$1) {
      return (function(x$3$2) {
        var x$3 = $as_Lamf_core_model_domain_DomainElement(x$3$2);
        var field = $this.field$1;
        var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$1).$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations($this.annotations$1);
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(x$3, field, value$1, annotations)
      })
    })(this, value, entry)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype.optional__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField = (function() {
  this.opt$1 = true;
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.SpecParserOps$ObjectField", {
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField: 1,
  O: 1,
  F1: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType.call(this);
  this.typeDef$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$ = this;
  this.typeDef$2 = $m_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$.prototype.typeDef__Lamf_plugins_domain_shapes_models_TypeDef = (function() {
  return this.typeDef$2
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.AnyDefaultType$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SettingsProducers$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SettingsProducers$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SettingsProducers$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SettingsProducers$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SettingsProducers$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SettingsProducers$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SettingsProducers$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SettingsProducers$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SettingsProducers$.prototype.$for__Lamf_plugins_domain_webapi_models_security_WithSettings__sci_Map = (function(scheme) {
  var common = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$().$for__Lamf_plugins_domain_webapi_models_security_WithSettings__sci_Map(scheme);
  var y = new $c_s_Some().init___O(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, scheme$1) {
    return (function() {
      return scheme$1.withOpenIdConnectSettings__Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings()
    })
  })(this, scheme)));
  var jsx$6 = new $c_T2().init___O__O("openIdConnect", y);
  var y$1 = new $c_s_Some().init___O(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$2$1, scheme$2) {
    return (function() {
      return scheme$2.withHttpSettings__Lamf_plugins_domain_webapi_models_security_HttpSettings()
    })
  })(this, scheme)));
  var jsx$5 = new $c_T2().init___O__O("http", y$1);
  var y$2 = $m_s_None$();
  var jsx$4 = new $c_T2().init___O__O("userPassword", y$2);
  var y$3 = $m_s_None$();
  var jsx$3 = new $c_T2().init___O__O("X509", y$3);
  var y$4 = $m_s_None$();
  var jsx$2 = new $c_T2().init___O__O("symmetricEncryption", y$4);
  var y$5 = $m_s_None$();
  var jsx$1 = new $c_T2().init___O__O("asymmetricEncryption", y$5);
  var y$6 = new $c_s_Some().init___O(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$3$1, scheme$3) {
    return (function() {
      return scheme$3.withHttpApiKeySettings__Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings()
    })
  })(this, scheme)));
  var array = [jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, jsx$1, new $c_T2().init___O__O("httpApiKey", y$6)];
  var this$18 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$18.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  var specific = $as_sci_Map(this$18.elems$1);
  return common.$$plus$plus__sc_GenTraversableOnce__sci_Map(specific)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SettingsProducers$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_Async2SettingsProducers$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.Async2SettingsProducers$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_Async2SettingsProducers$: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_SettingsProducers: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SettingsProducers$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SettingsProducers$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SettingsProducers$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SettingsProducers$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SettingsProducers$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SettingsProducers$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SettingsProducers$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SettingsProducers$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion.prototype.init___T.call(this, "draft-3");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.JSONSchemaDraft3SchemaVersion$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion.prototype.init___T.call(this, "draft-4");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.JSONSchemaDraft4SchemaVersion$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft6SchemaVersion$() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft6SchemaVersion$.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft6SchemaVersion$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft6SchemaVersion$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft6SchemaVersion$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft6SchemaVersion$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft6SchemaVersion$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft6SchemaVersion$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion.prototype.init___T.call(this, "draft-6");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft6SchemaVersion$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft6SchemaVersion$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.JSONSchemaDraft6SchemaVersion$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft6SchemaVersion$: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft6SchemaVersion$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft6SchemaVersion$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft6SchemaVersion$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft6SchemaVersion$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft6SchemaVersion$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft6SchemaVersion$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft6SchemaVersion$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft6SchemaVersion$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion.prototype.init___T.call(this, "draft-7");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.JSONSchemaDraft7SchemaVersion$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion.prototype.init___T.call(this, "");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.JSONSchemaUnspecifiedVersion$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion.call(this);
  this.position$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion.prototype.init___T__T__Lamf_core_errorhandling_ErrorHandler = (function(name, position, eh) {
  this.position$2 = position;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion.prototype.init___T.call(this, name);
  if (((position !== "schema") && (position !== "parameter"))) {
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
    var message = (("Invalid schema position '" + position) + "', only 'schema' and 'parameter' are valid");
    var property = $m_s_None$();
    var lexical = $m_s_None$();
    var location = $m_s_None$();
    eh.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, "", property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
  };
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OASSchemaVersion"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OASSchemaVersion;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SettingsProducers$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SettingsProducers$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SettingsProducers$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SettingsProducers$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SettingsProducers$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SettingsProducers$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SettingsProducers$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SettingsProducers$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SettingsProducers$.prototype.$for__Lamf_plugins_domain_webapi_models_security_WithSettings__sci_Map = (function(scheme) {
  var common = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$().$for__Lamf_plugins_domain_webapi_models_security_WithSettings__sci_Map(scheme);
  var y = $m_s_None$();
  var jsx$1 = new $c_T2().init___O__O("Basic Authentication", y);
  var y$1 = $m_s_None$();
  var array = [jsx$1, new $c_T2().init___O__O("Digest Authentication", y$1)];
  var this$8 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$8.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  var specific = $as_sci_Map(this$8.elems$1);
  return common.$$plus$plus__sc_GenTraversableOnce__sci_Map(specific)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SettingsProducers$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SettingsProducers$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.Oas2SettingsProducers$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SettingsProducers$: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_SettingsProducers: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SettingsProducers$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SettingsProducers$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SettingsProducers$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SettingsProducers$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SettingsProducers$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SettingsProducers$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SettingsProducers$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SettingsProducers$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SettingsProducers$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SettingsProducers$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SettingsProducers$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SettingsProducers$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SettingsProducers$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SettingsProducers$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SettingsProducers$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SettingsProducers$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SettingsProducers$.prototype.$for__Lamf_plugins_domain_webapi_models_security_WithSettings__sci_Map = (function(scheme) {
  var common = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$().$for__Lamf_plugins_domain_webapi_models_security_WithSettings__sci_Map(scheme);
  var y = new $c_s_Some().init___O(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, scheme$1) {
    return (function() {
      return scheme$1.withOpenIdConnectSettings__Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings()
    })
  })(this, scheme)));
  var jsx$1 = new $c_T2().init___O__O("openIdConnect", y);
  var y$1 = new $c_s_Some().init___O(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$2$1, scheme$2) {
    return (function() {
      return scheme$2.withHttpSettings__Lamf_plugins_domain_webapi_models_security_HttpSettings()
    })
  })(this, scheme)));
  var array = [jsx$1, new $c_T2().init___O__O("http", y$1)];
  var this$8 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$8.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  var specific = $as_sci_Map(this$8.elems$1);
  return common.$$plus$plus__sc_GenTraversableOnce__sci_Map(specific)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SettingsProducers$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SettingsProducers$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.Oas3SettingsProducers$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SettingsProducers$: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_SettingsProducers: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SettingsProducers$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SettingsProducers$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SettingsProducers$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SettingsProducers$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SettingsProducers$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SettingsProducers$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SettingsProducers$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SettingsProducers$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$.prototype.$for__Lamf_plugins_domain_webapi_models_security_WithSettings__sci_Map = (function(scheme) {
  var y = new $c_s_Some().init___O(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, scheme$1) {
    return (function() {
      return scheme$1.withOAuth1Settings__Lamf_plugins_domain_webapi_models_security_OAuth1Settings()
    })
  })(this, scheme)));
  var jsx$2 = new $c_T2().init___O__O("OAuth 1.0", y);
  var y$1 = new $c_s_Some().init___O(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$2$1, scheme$2) {
    return (function() {
      return scheme$2.withOAuth2Settings__Lamf_plugins_domain_webapi_models_security_OAuth2Settings()
    })
  })(this, scheme)));
  var jsx$1 = new $c_T2().init___O__O("OAuth 2.0", y$1);
  var y$2 = new $c_s_Some().init___O(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$3$1, scheme$3) {
    return (function() {
      return scheme$3.withApiKeySettings__Lamf_plugins_domain_webapi_models_security_ApiKeySettings()
    })
  })(this, scheme)));
  var array = [jsx$2, jsx$1, new $c_T2().init___O__O("Api Key", y$2)];
  var this$10 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$10.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  return $as_sci_Map(this$10.elems$1)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasLikeCommonSettingsProducers$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_SettingsProducers: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCommonSettingsProducers$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.scheme$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser.prototype.parseApiKeySettings__Lamf_plugins_domain_webapi_models_security_ApiKeySettings__Lamf_plugins_domain_webapi_models_security_ApiKeySettings = (function(settings) {
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("name");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var node = entry.value$2;
    var iv = this.ctx$1;
    var value = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().Name$1;
    var value$1 = value.string__Lamf_core_model_domain_AmfScalar();
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(settings, field, value$1, annotations)
  };
  var map$1 = this.map$1;
  var this$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var this$7 = this$6.key__T__s_Option("in");
  if ((!this$7.isEmpty__Z())) {
    var arg1$1 = this$7.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var node$1 = entry$3.value$2;
    var iv$1 = this.ctx$1;
    var value$2 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$1, iv$1);
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().In$1;
    var value$3 = value$2.string__Lamf_core_model_domain_AmfScalar();
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(settings, field$1, value$3, annotations$1)
  };
  var map$2 = this.map$1;
  var this$11 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("settings").asOasExtension__T();
  var this$12 = this$11.key__T__s_Option(keyword);
  if ((!this$12.isEmpty__Z())) {
    var arg1$2 = this$12.get__O();
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var this$13 = entry$4.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$2 = this.ctx$1;
    var jsx$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$13, conversion, iv$2));
    var array = ["name", "in"];
    this.parseDynamicSettings__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_Settings__sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings(jsx$1, settings, new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))
  };
  return settings
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser.prototype.parseDynamicSettings__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_Settings__sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings = (function(xSettings, settings, properties) {
  var entries = $as_sc_IndexedSeq(xSettings.entries$3.filterNot__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, properties$1) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var this$1 = entry.key$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
      var iv = $this.ctx$1;
      var key = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3;
      return (properties$1.contains__O__Z(key) || $m_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$().isOasAnnotation__T__Z(key))
    })
  })(this, properties))));
  if ($f_sc_TraversableOnce__nonEmpty__Z(entries)) {
    $m_Lorg_yaml_model_YNode$();
    var jsx$1 = $m_Lorg_yaml_model_YMap$();
    var this$2 = entries.headOption__s_Option();
    if (this$2.isEmpty__Z()) {
      var this$3 = $m_s_None$()
    } else {
      var arg1 = this$2.get__O();
      var x$1 = $as_Lorg_yaml_model_YMapEntry(arg1);
      var this$3 = new $c_s_Some().init___O(x$1.location$1.sourceName$1)
    };
    var map = jsx$1.apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(entries, $as_T((this$3.isEmpty__Z() ? "" : this$3.get__O())));
    var x$1$3 = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1);
    var x$2 = new $c_s_Some().init___O(settings.id$1);
    var x$3 = new $c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables().init___();
    var node = $m_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser(x$1$3, x$3, x$2, this.ctx$1).parse__Lamf_core_model_domain_DataNode();
    var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().AdditionalProperties$1;
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(settings, field, node)
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(this.scheme$1, xSettings, $m_sci_Nil$(), this.ctx$1).parse__V();
  return settings
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser.prototype.parseScope__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_domain_webapi_models_security_Scope = (function(scopeEntry, parentId) {
  var this$1 = scopeEntry.key$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
  var iv = this.ctx$1;
  var name = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3;
  $m_Lorg_yaml_model_YNode$();
  var node = scopeEntry.value$2;
  var iv$1 = this.ctx$1;
  var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
  var description = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$1, iv$1));
  var this$4 = $m_Lamf_plugins_domain_webapi_models_security_Scope$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_security_Scope(scopeEntry);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Name$1;
  var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(name, new $c_Lamf_core_parser_Annotations().init___());
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(scopeEntry.key$2);
  var this$6 = $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$4, field, value, annotations);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Description$1;
  var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(description, new $c_Lamf_core_parser_Annotations().init___());
  var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(scopeEntry.value$2);
  var qual$1 = $as_Lamf_plugins_domain_webapi_models_security_Scope($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$6, field$1, value$1, annotations$1));
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  return $as_Lamf_plugins_domain_webapi_models_security_Scope($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, parentId))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser.prototype.parseAnnotations__Lamf_plugins_domain_webapi_models_security_Settings__Lamf_plugins_domain_webapi_models_security_Settings = (function(settings) {
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(settings, this.map$1, $m_sci_Nil$(), this.ctx$1).parse__V();
  var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.map$1);
  return $as_Lamf_plugins_domain_webapi_models_security_Settings($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(settings, other))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser.prototype.parseOauth1Settings__Lamf_plugins_domain_webapi_models_security_OAuth1Settings__Lamf_plugins_domain_webapi_models_security_OAuth1Settings = (function(settings) {
  var map = this.map$1;
  var this$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("settings").asOasExtension__T();
  var this$4 = this$3.key__T__s_Option(keyword);
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$5 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$1;
    var map$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv));
    var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$().RequestTokenUri$1;
    var iv$1 = this.ctx$1;
    jsx$1.key__T__F1__V("requestTokenUri", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(settings));
    var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$().AuthorizationUri$1;
    var iv$2 = this.ctx$1;
    jsx$2.key__T__F1__V("authorizationUri", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(settings));
    var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$().TokenCredentialsUri$1;
    var iv$3 = this.ctx$1;
    jsx$3.key__T__F1__V("tokenCredentialsUri", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(settings));
    var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
    var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$().Signatures$1;
    var iv$4 = this.ctx$1;
    jsx$4.key__T__F1__V("signatures", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$3, iv$4).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(settings));
    var array = ["requestTokenUri", "authorizationUri", "tokenCredentialsUri", "signatures"];
    this.parseDynamicSettings__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_Settings__sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings(map$1, settings, new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))
  };
  return settings
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser.prototype.produceSettings__s_Option = (function() {
  var settingsProducers = this.vendorSpecificSettingsProducers__Lamf_plugins_document_webapi_parser_spec_declaration_SettingsProducers().$for__Lamf_plugins_domain_webapi_models_security_WithSettings__sci_Map(this.scheme$1);
  var this$1 = this.scheme$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1));
  var this$3 = this$2.option$1;
  var settingsType = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
  var x1 = settingsProducers.get__O__s_Option(settingsType);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var producerOption = $as_s_Option(x2.value$2);
    if (producerOption.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1 = producerOption.get__O();
      var producer = $as_F0(arg1);
      return new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_security_Settings(producer.apply__O()))
    }
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return new $c_s_Some().init___O(this.scheme$1.withDefaultSettings__Lamf_plugins_domain_webapi_models_security_Settings())
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser.prototype.parseScopes__Lamf_plugins_domain_webapi_models_security_OAuth2Flow__Lorg_yaml_model_YMap__V = (function(flow, map) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("scopes");
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$3 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$1;
    var scopeMap = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv));
    var jsx$2 = $as_sc_TraversableLike(scopeMap.entries$3.filterNot__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(entry$2$2) {
        var entry$2 = $as_Lorg_yaml_model_YMapEntry(entry$2$2);
        var jsx$3 = $m_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$();
        $m_Lorg_yaml_model_YNode$();
        var node = entry$2.key$2;
        var iv$1 = $this.ctx$1;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        return jsx$3.isOasAnnotation__T__Z($as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$1, iv$1)))
      })
    })(this))));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, flow$1) {
      return (function(x$2$2) {
        var x$2 = $as_Lorg_yaml_model_YMapEntry(x$2$2);
        return this$2$1.parseScope__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_domain_webapi_models_security_Scope(x$2, flow$1.id$1)
      })
    })(this, flow));
    var this$5 = $m_sc_IndexedSeq$();
    var scopes = $as_sc_IndexedSeq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBF$6));
    var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Scopes$1;
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(flow, field, scopes, annotations))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser.prototype.init___Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function(map, scheme, ctx) {
  this.map$1 = map;
  this.scheme$1 = scheme;
  this.ctx$1 = ctx;
  return this
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser.call(this);
  this.options$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser.prototype.parse__Lamf_core_model_domain_Shape.call(this);
  this.parseExample__p2__V();
  var map = this.map__Lorg_yaml_model_YMap();
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("type");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = this.shape__Lamf_plugins_domain_shapes_models_AnyShape();
    var annotation = new $c_Lamf_core_annotations_ExplicitField().init___();
    $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$4, annotation)
  };
  var x = this.$$outer$1.version$2;
  var x$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$();
  if (((x !== null) && x.equals__O__Z(x$2))) {
    var map$1 = this.map__Lorg_yaml_model_YMap();
    var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
    var this$6 = this.$$outer$1;
    var field = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Comment$1;
    var iv = this.$$outer$1.ctx$2;
    jsx$1.key__T__F1__V("$comment", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$6, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape__Lamf_plugins_domain_shapes_models_AnyShape()))
  };
  return this.shape__Lamf_plugins_domain_shapes_models_AnyShape()
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype.options__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions = (function() {
  return this.options$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser = (function($$outer) {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_document_webapi_contexts_WebApiContext.call(this, $$outer, $$outer.ctx$2);
  this.options$2 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions().init___Z__Z__Z(true, false, false);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype.parseExample__p2__V = (function() {
  var x = this.$$outer$1.version$2;
  var x$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$();
  if (((x !== null) && x.equals__O__Z(x$2))) {
    var jsx$1 = true
  } else {
    var x$3 = this.$$outer$1.version$2;
    var x$4 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft6SchemaVersion$();
    var jsx$1 = ((x$3 !== null) && x$3.equals__O__Z(x$4))
  };
  if (jsx$1) {
    this.parseExamplesArray__p2__V()
  } else {
    new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser().init___Lorg_yaml_model_YMap__T__T__Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext(this.map__Lorg_yaml_model_YMap(), "example", new $c_Lamf_core_utils_package$AmfStrings().init___T("examples").asOasExtension__T(), this.shape__Lamf_plugins_domain_shapes_models_AnyShape(), this.options__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions(), this.$$outer$1.ctx$2).parse__V()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype.parseExamplesArray__p2__V = (function() {
  var map = this.map__Lorg_yaml_model_YMap();
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("examples");
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var counter = new $c_Lamf_core_utils_package$IdCounter().init___();
    var this$3 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
    var iv = this.$$outer$1.ctx$2;
    var jsx$2 = $as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv)).nodes$3;
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, counter$1) {
      return (function(n$2) {
        var n = $as_Lorg_yaml_model_YNode(n$2);
        var qual$1 = $m_Lamf_plugins_domain_shapes_models_Example$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_Example(n);
        var x$1 = counter$1.genId__T__T("default-example");
        $m_Lamf_core_parser_Annotations$();
        var x$2 = new $c_Lamf_core_parser_Annotations().init___();
        var exa = $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, x$1, x$2));
        var parent = $this.shape__Lamf_plugins_domain_shapes_models_AnyShape().id$1;
        $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(exa, parent);
        return new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser().init___Lorg_yaml_model_YNode__Lamf_plugins_domain_shapes_models_Example__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext(n, exa, $this.options__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions(), $this.$$outer$1.ctx$2).parse__Lamf_plugins_domain_shapes_models_Example()
      })
    })(this, counter));
    var this$5 = $m_sc_IndexedSeq$();
    var examples = $as_sc_IndexedSeq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBF$6));
    var this$6 = this.shape__Lamf_plugins_domain_shapes_models_AnyShape();
    var field = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Examples$1;
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    new $c_s_Some().init___O($as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$6, field, examples, annotations)))
  }
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$AnyShapeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$AnyShapeParser;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RAMLSchemaVersion() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RAMLSchemaVersion.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RAMLSchemaVersion.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RAMLSchemaVersion;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RAMLSchemaVersion() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RAMLSchemaVersion.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RAMLSchemaVersion.prototype;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser() {
  $c_O.call(this);
  this.dataNodeParser$1 = null;
  this.enumParser$1 = null;
  this.bitmap$0$1 = 0;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser.prototype.parseInheritance__V = (function() {
  var this$1 = this.$$outer$1.typeOrSchema__Lorg_yaml_model_YMap__s_Option(this.map__Lorg_yaml_model_YMap());
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YMapEntry__Lamf_core_model_domain_Shape__s_Option__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this.$$outer$1, entry, this.shape__Lamf_core_model_domain_Shape(), new $c_s_Some().init___O(this.map__Lorg_yaml_model_YMap()), this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext()).parse__V()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser.prototype.parse__Lamf_core_model_domain_Shape = (function() {
  this.parseInheritance__V();
  var map = this.map__Lorg_yaml_model_YMap();
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$2 = this.$$outer$1;
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().DisplayName$1;
  var iv = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$1.key__T__F1__V("displayName", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$2, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape__Lamf_core_model_domain_Shape()).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var map$1 = this.map__Lorg_yaml_model_YMap();
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var this$4 = this.$$outer$1;
  var field$1 = $m_Lamf_core_metamodel_domain_ShapeModel$().Description$1;
  var iv$1 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$2.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$4, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape__Lamf_core_model_domain_Shape()).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var map$2 = this.map__Lorg_yaml_model_YMap();
  var this$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var this$7 = this$6.key__T__s_Option("default");
  if ((!this$7.isEmpty__Z())) {
    var arg1 = this$7.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$8 = entry.value$2;
    var x1 = this$8.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Null$1;
    if ((!(x === x1))) {
      var dataNodeResult = new $c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser().init___Lorg_yaml_model_YNode__T__Z__Z__Z__Lamf_plugins_document_webapi_contexts_WebApiContext(entry.value$2, (this.shape__Lamf_core_model_domain_Shape().id$1 + "/default"), false, false, false, this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext()).parse__Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult();
      var this$9 = this.shape__Lamf_core_model_domain_Shape();
      $f_Lamf_plugins_domain_shapes_models_ShapeHelper__setDefaultStrValue__Lorg_yaml_model_YMapEntry__V(this$9, entry);
      var this$10 = dataNodeResult.dataNode$1;
      if ((!this$10.isEmpty__Z())) {
        var arg1$1 = this$10.get__O();
        var dataNode = $as_Lamf_core_model_domain_DataNode(arg1$1);
        var this$11 = this.shape__Lamf_core_model_domain_Shape();
        var field$2 = $m_Lamf_core_metamodel_domain_ShapeModel$().Default$1;
        var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
        $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$11, field$2, dataNode, annotations))
      }
    }
  };
  var map$3 = this.map__Lorg_yaml_model_YMap();
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3);
  var this$13 = this.$$outer$1;
  var field$3 = $m_Lamf_core_metamodel_domain_ShapeModel$().Values$1;
  var iv$2 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$3.key__T__F1__V("enum", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$13, field$3, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape__Lamf_core_model_domain_Shape()).using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.enumParser__F1()));
  var map$4 = this.map__Lorg_yaml_model_YMap();
  var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$4);
  var this$15 = this.$$outer$1;
  var field$4 = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MinItems$1;
  var iv$3 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$4.key__T__F1__V("minItems", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$15, field$4, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape__Lamf_core_model_domain_Shape()).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var map$5 = this.map__Lorg_yaml_model_YMap();
  var jsx$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$5);
  var this$17 = this.$$outer$1;
  var field$5 = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MaxItems$1;
  var iv$4 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$5.key__T__F1__V("maxItems", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$17, field$5, iv$4).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape__Lamf_core_model_domain_Shape()).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var map$6 = this.map__Lorg_yaml_model_YMap();
  var jsx$7 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$6);
  var jsx$6 = new $c_Lamf_core_utils_package$AmfStrings().init___T("externalDocs").asRamlAnnotation__T();
  var this$20 = this.$$outer$1;
  var field$6 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Documentation$1;
  var iv$5 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$7.key__T__F1__V(jsx$6, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$20, field$6, iv$5).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape__Lamf_core_model_domain_Shape()).using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$27$2) {
      var x$27 = $as_Lorg_yaml_model_YNode(x$27$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$().parse__Lorg_yaml_model_YNode__T__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_domain_shapes_models_CreativeWork(x$27, this$2$1.shape__Lamf_core_model_domain_Shape().id$1, this$2$1.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext())
    })
  })(this))));
  var map$7 = this.map__Lorg_yaml_model_YMap();
  var this$22 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$7);
  var this$23 = this$22.key__T__s_Option("xml");
  if ((!this$23.isEmpty__Z())) {
    var arg1$2 = this$23.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var this$24 = this.shape__Lamf_core_model_domain_Shape();
    var this$25 = $as_Lamf_core_model_StrField(this$24.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
    var this$26 = this$25.option$1;
    var xmlSerializer = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser().init___T__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext($as_T((this$26.isEmpty__Z() ? null : this$26.get__O())), entry$3.value$2, this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext()).parse__Lamf_plugins_domain_shapes_models_XMLSerializer();
    var this$27 = this.shape__Lamf_core_model_domain_Shape();
    var field$7 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().XMLSerialization$1;
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$27, field$7, xmlSerializer, annotations$1)
  };
  var map$8 = this.map__Lorg_yaml_model_YMap();
  if (new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$8).key__T__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("or").asRamlAnnotation__T()).isDefined__Z()) {
    new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape(this.$$outer$1, this.map__Lorg_yaml_model_YMap(), this.shape__Lamf_core_model_domain_Shape()).parse__V()
  };
  var map$9 = this.map__Lorg_yaml_model_YMap();
  if (new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$9).key__T__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("and").asRamlAnnotation__T()).isDefined__Z()) {
    new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape(this.$$outer$1, this.map__Lorg_yaml_model_YMap(), this.shape__Lamf_core_model_domain_Shape()).parse__V()
  };
  var map$10 = this.map__Lorg_yaml_model_YMap();
  if (new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$10).key__T__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("xone").asRamlAnnotation__T()).isDefined__Z()) {
    new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape(this.$$outer$1, this.map__Lorg_yaml_model_YMap(), this.shape__Lamf_core_model_domain_Shape()).parse__V()
  };
  var map$11 = this.map__Lorg_yaml_model_YMap();
  if (new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$11).key__T__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("not").asRamlAnnotation__T()).isDefined__Z()) {
    new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape(this.$$outer$1, this.map__Lorg_yaml_model_YMap(), this.shape__Lamf_core_model_domain_Shape()).parse__V()
  };
  var map$12 = this.map__Lorg_yaml_model_YMap();
  var jsx$9 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$12);
  var jsx$8 = new $c_Lamf_core_utils_package$AmfStrings().init___T("readOnly").asRamlAnnotation__T();
  var this$38 = this.$$outer$1;
  var field$8 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().ReadOnly$1;
  var iv$6 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$9.key__T__F1__V(jsx$8, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$38, field$8, iv$6).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape__Lamf_core_model_domain_Shape()));
  var map$13 = this.map__Lorg_yaml_model_YMap();
  var this$40 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$13);
  var this$41 = this$40.key__T__s_Option("facets");
  if ((!this$41.isEmpty__Z())) {
    var arg1$3 = this$41.get__O();
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
    var jsx$10 = this.$$outer$1;
    var this$42 = entry$4.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$7 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
    new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YMap__F1(jsx$10, $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$42, conversion, iv$7)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, entry$1) {
      return (function(name$2) {
        var name = $as_T(name$2);
        var propertyShape = $this.shape__Lamf_core_model_domain_Shape().withCustomShapePropertyDefinition__T__Lamf_core_model_domain_extensions_PropertyShape(name);
        if ((($uI(name.length) >= 0) && ($as_T(name.substring(0, $uI("(".length))) === "("))) {
          var this$48 = $this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1;
          var specification = $m_Lamf_validations_ParserSideValidations$().InvalidFragmentType$1;
          var node = propertyShape.id$1;
          var message = (("User defined facet name '" + name) + "' must not begin with open parenthesis");
          var prop = $m_s_None$();
          var l = entry$1.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$48, specification, node, prop, message, l)
        };
        return propertyShape
      })
    })(this, entry$4))).parse__sc_Seq()
  };
  var map$14 = this.map__Lorg_yaml_model_YMap();
  var this$50 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$14);
  var this$51 = this$50.key__T__s_Option("type");
  if ((!this$51.isEmpty__Z())) {
    var arg1$4 = this$51.get__O();
    var entry$5 = $as_Lorg_yaml_model_YMapEntry(arg1$4);
    var jsx$12 = this.shape__Lamf_core_model_domain_Shape().annotations__Lamf_core_parser_Annotations();
    var jsx$11 = $m_Lamf_core_parser_Range$();
    var this$52 = entry$5.key$2;
    var this$53 = this$52.location$1;
    jsx$12.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo().init___Lamf_core_parser_Range(jsx$11.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$53.lineFrom$1, this$53.columnFrom$1, this$53.lineTo$1, this$53.columnTo$1))))
  };
  return this.shape__Lamf_core_model_domain_Shape()
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser.prototype.enumParser$lzycompute__p1__F1 = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.enumParser$1 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$().apply__T__T__Lamf_plugins_document_webapi_contexts_WebApiContext__F1(this.shape__Lamf_core_model_domain_Shape().id$1, $m_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$().UNKNOWN$undENUM$1, this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext());
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.enumParser$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser.prototype.enumParser__F1 = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.enumParser$lzycompute__p1__F1() : this.enumParser$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser() {
  $c_O.call(this);
  this.part$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser.prototype.init___Lorg_yaml_model_YPart__F1__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(part, adopt, ctx) {
  this.part$1 = part;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser.prototype.getName__T = (function() {
  var x1 = this.part$1;
  if ((x1 instanceof $c_Lorg_yaml_model_YMapEntry)) {
    var x2 = $as_Lorg_yaml_model_YMapEntry(x1);
    var this$1 = x2.key$2;
    var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv = this.ctx$1;
    return $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3
  } else if ((x1 instanceof $c_Lorg_yaml_model_YMap)) {
    return "securityDefinitions"
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser.prototype.getNode__Lorg_yaml_model_YNode = (function() {
  var x1 = this.part$1;
  if ((x1 instanceof $c_Lorg_yaml_model_YMapEntry)) {
    var x2 = $as_Lorg_yaml_model_YMapEntry(x1);
    return x2.value$2
  } else if ((x1 instanceof $c_Lorg_yaml_model_YMap)) {
    var x3 = $as_Lorg_yaml_model_YMap(x1);
    $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YNode$();
    return $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(x3, $m_Lorg_yaml_model_YType$().Map$1)
  } else if ((x1 instanceof $c_Lorg_yaml_model_YNode)) {
    var x4 = $as_Lorg_yaml_model_YNode(x1);
    return x4
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.SecuritySchemeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.SecuritySchemeParser;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType.call(this);
  this.typeDef$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$ = this;
  this.typeDef$2 = $m_Lamf_plugins_domain_shapes_models_TypeDef$StrType$();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$.prototype.typeDef__Lamf_plugins_domain_shapes_models_TypeDef = (function() {
  return this.typeDef$2
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.StringDefaultType$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeEmitter.call(this);
  this.shape$2 = null;
  this.ordering$2 = null;
  this.references$2 = null;
  this.isHeader$2 = false;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.prototype.emitters__sc_Seq = (function() {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = this.spec$2.options__Lamf_core_emitter_ShapeRenderOptions();
  if (this$1.amf$core$emitter$ShapeRenderOptions$$documentation$1) {
    var this$2 = this.shape$2.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Examples$1);
    if ((!this$2.isEmpty__Z())) {
      var arg1 = this$2.get__O();
      var f = $as_Lamf_core_parser_FieldEntry(arg1);
      var jsx$3 = this.spec$2;
      var jsx$2 = $as_Lamf_core_model_domain_AmfArray(f.value$1.value$1).values$1;
      var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter(this);
      var this$3 = $m_sc_Seq$();
      var examples = jsx$3.filterLocal__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2)));
      var tuple = examples.partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(e$2) {
          var e = $as_Lamf_plugins_domain_shapes_models_Example(e$2);
          var this$4 = e.fields$1.fieldsMeta__sci_List();
          var elem = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Name$1;
          if ((!$f_sc_LinearSeqOptimized__contains__O__Z(this$4, elem))) {
            return (!$f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(e).isDefined__Z())
          } else {
            return false
          }
        })
      })(this)));
      matchEnd11: {
        var jsx$4;
        if ((tuple !== null)) {
          var p2 = $as_sc_Seq(tuple.$$und1__O());
          var p3 = $as_sc_Seq(tuple.$$und2__O());
          var x = $m_sci_Nil$();
          if (x.equals__O__Z(p2)) {
            var x$3 = $m_sci_Nil$();
            var jsx$5 = x$3.equals__O__Z(p3)
          } else {
            var jsx$5 = false
          };
          if (jsx$5) {
            var jsx$4 = $m_sci_Nil$();
            break matchEnd11
          }
        };
        if ((tuple !== null)) {
          var named = $as_sc_Seq(tuple.$$und1__O());
          var p4 = $as_sc_Seq(tuple.$$und2__O());
          var x$5 = $m_sci_Nil$();
          if (x$5.equals__O__Z(p4)) {
            var jsx$4 = this.examplesEmitters__p2__s_Option__sc_Seq__Z__scm_ListBuffer(named.headOption__s_Option(), $as_sc_Seq(named.tail__O()), this.isHeader$2);
            break matchEnd11
          }
        };
        if ((tuple !== null)) {
          var p5 = $as_sc_Seq(tuple.$$und1__O());
          var named$2 = $as_sc_Seq(tuple.$$und2__O());
          var x$7 = $m_sci_Nil$();
          if (x$7.equals__O__Z(p5)) {
            var jsx$4 = this.examplesEmitters__p2__s_Option__sc_Seq__Z__scm_ListBuffer($m_s_None$(), named$2, this.isHeader$2);
            break matchEnd11
          }
        };
        if ((tuple !== null)) {
          var anonymous = $as_sc_Seq(tuple.$$und1__O());
          var named$3 = $as_sc_Seq(tuple.$$und2__O());
          var jsx$7 = anonymous.headOption__s_Option();
          var jsx$6 = $as_sc_TraversableLike(anonymous.tail__O());
          var this$5 = $m_sc_Seq$();
          var jsx$4 = this.examplesEmitters__p2__s_Option__sc_Seq__Z__scm_ListBuffer(jsx$7, $as_sc_Seq(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(named$3, this$5.ReusableCBFInstance$2)), this.isHeader$2);
          break matchEnd11
        };
        throw new $c_s_MatchError().init___O(tuple)
      };
      new $c_s_Some().init___O(result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(jsx$4))
    };
    var x$1 = this.spec$2.schemaVersion__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion();
    var x$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$();
    if (((x$1 !== null) && x$1.equals__O__Z(x$2))) {
      var this$6 = this.shape$2.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Comment$1);
      if ((!this$6.isEmpty__Z())) {
        var arg1$1 = this$6.get__O();
        var c = $as_Lamf_core_parser_FieldEntry(arg1$1);
        new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("$comment", c, $m_s_None$())))
      }
    }
  };
  var jsx$8 = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeEmitter.prototype.emitters__sc_Seq.call(this);
  var this$8 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$8.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(result, this$8.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(shape, ordering, references, pointer, schemaPath, isHeader, spec) {
  this.shape$2 = shape;
  this.ordering$2 = ordering;
  this.references$2 = references;
  this.isHeader$2 = isHeader;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.call(this, shape, ordering, references, pointer, schemaPath, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.prototype.examplesEmitters__p2__s_Option__sc_Seq__Z__scm_ListBuffer = (function(main, extensions, isHeader) {
  return $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeExampleEmitters(this.spec$2.factory__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory().exampleEmitter__F5().apply__O__O__O__O__O__O(isHeader, main, this.ordering$2, extensions, this.references$2)).emitters__scm_ListBuffer()
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasAnyShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeEmitter: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter;
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__parse__Lamf_plugins_domain_shapes_models_AnyShape($thiz) {
  var origin = $f_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__buildTextAndOrigin__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin($thiz);
  var x1 = origin.errorShape$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var shape = $as_Lamf_plugins_domain_shapes_models_AnyShape(x2.value$2);
    return shape
  } else {
    return $thiz.parseValue__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin__Lamf_plugins_domain_shapes_models_AnyShape(origin)
  }
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__getOrigin__Lorg_yaml_model_YNode__s_Option($thiz, node) {
  if ((node instanceof $c_Lorg_yaml_model_YNode$MutRef)) {
    var x2 = $as_Lorg_yaml_model_YNode$MutRef(node);
    return new $c_s_Some().init___O(x2.origValue$4.toString__T())
  } else {
    return $m_s_None$()
  }
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__buildTextAndOrigin__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin($thiz) {
  var this$1 = $thiz.value__Lorg_yaml_model_YNode();
  var x1 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var this$2 = $thiz.value__Lorg_yaml_model_YNode();
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = $as_Lamf_core_parser_BaseSpecParser($thiz).ctx__Lamf_core_parser_ParserContext();
    var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv));
    var x1$2 = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.prototype.nestedTypeOrSchema__Lorg_yaml_model_YMap__s_Option.call($thiz, map);
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var typeEntry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      if ((typeEntry !== null)) {
        var node = typeEntry.value$2;
        if (new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lamf_core_parser_package$YScalarYRead$()).isDefined__Z()) {
          var this$4 = typeEntry.value$2;
          var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
          var iv$1 = $as_Lamf_core_parser_BaseSpecParser($thiz).ctx__Lamf_core_parser_ParserContext();
          var jsx$2 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion$1, iv$1)).text$3;
          var jsx$1 = typeEntry.value$2;
          var node$1 = typeEntry.value$2;
          return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin().init___Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__T__Lorg_yaml_model_YNode__s_Option__s_Option($thiz, jsx$2, jsx$1, $f_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__getOrigin__Lorg_yaml_model_YNode__s_Option($thiz, node$1), ($thiz.ValueAndOrigin__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$(), $m_s_None$()))
        }
      }
    };
    return $f_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__failSchemaExpressionParser__pLamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin($thiz)
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Seq$1;
    if ((x$3 === x1)) {
      return $f_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__failSchemaExpressionParser__pLamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin($thiz)
    } else {
      var this$6 = $thiz.value__Lorg_yaml_model_YNode();
      var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$2 = $as_Lamf_core_parser_BaseSpecParser($thiz).ctx__Lamf_core_parser_ParserContext();
      var jsx$4 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion$2, iv$2)).text$3;
      var jsx$3 = $thiz.value__Lorg_yaml_model_YNode();
      var node$2 = $thiz.value__Lorg_yaml_model_YNode();
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin().init___Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__T__Lorg_yaml_model_YNode__s_Option__s_Option($thiz, jsx$4, jsx$3, $f_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__getOrigin__Lorg_yaml_model_YNode__s_Option($thiz, node$2), ($thiz.ValueAndOrigin__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$(), $m_s_None$()))
    }
  }
}
function $f_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__failSchemaExpressionParser__pLamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin($thiz) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var shape = new $c_Lamf_plugins_domain_shapes_models_SchemaShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $thiz.adopt__F1().apply__O__O(shape);
  var this$4 = $as_Lamf_core_parser_BaseSpecParser($thiz).ctx__Lamf_core_parser_ParserContext().eh$1;
  var specification = $m_Lamf_validations_ParserSideValidations$().InvalidExternalTypeType$1;
  var node = shape.id$1;
  var message = (("Cannot parse " + $thiz.externalType__T()) + " Schema expression out of a non string value");
  var ast = $thiz.value__Lorg_yaml_model_YNode();
  var prop = $m_s_None$();
  var l = ast.location$1;
  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$4, specification, node, prop, message, l);
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin().init___Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__T__Lorg_yaml_model_YNode__s_Option__s_Option($thiz, "", $thiz.value__Lorg_yaml_model_YNode(), $m_s_None$(), new $c_s_Some().init___O(shape))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser() {
  $c_O.call(this);
  this.node$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser.prototype.init___Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(node, ctx) {
  this.node$1 = node;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser.prototype.parse__Lamf_plugins_domain_webapi_models_License = (function() {
  var license = $m_Lamf_plugins_domain_webapi_models_License$().apply__Lorg_yaml_model_YNode__Lamf_plugins_domain_webapi_models_License(this.node$1);
  var this$1 = this.node$1;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$1;
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_LicenseModel$().Url$1;
  var iv$1 = this.ctx$1;
  jsx$1.key__T__F1__V("url", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(license));
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_LicenseModel$().Name$1;
  var iv$2 = this.ctx$1;
  jsx$2.key__T__F1__V("name", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(license));
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(license, map, $m_sci_Nil$(), this.ctx$1).parse__V();
  this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(license.id$1, map, "license");
  return license
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.LicenseParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter.call(this);
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersEmitter.prototype.init___Lamf_core_model_domain_DomainElement__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(elem, f, ordering, references, spec) {
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter.prototype.init___Lamf_core_model_domain_DomainElement__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.call(this, elem, f, ordering, references, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersEmitter.prototype.asExtension__T__sc_Seq__scm_ListBuffer__V = (function(key, servers, result) {
  var x1 = this.spec$2.factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory();
  if ((x1 instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory)) {
    $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter.prototype.asExtension__T__sc_Seq__scm_ListBuffer__V.call(this, key, servers, result)
  }
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser() {
  $c_O.call(this);
  this.entry$1 = null;
  this.producer$1 = null;
  this.collector$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__sci_List__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function(entry, producer, collector, ctx) {
  this.entry$1 = entry;
  this.producer$1 = producer;
  this.collector$1 = collector;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser.prototype.identicalPaths__T__T__Z = (function(first, second) {
  return (first === second)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser.prototype.parse__s_Option = (function() {
  var this$1 = this.entry$1.key$2;
  var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
  var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
  var path = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3;
  var this$2 = $as_Lamf_core_model_domain_AmfElement(this.producer$1.apply__O__O(path));
  var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1);
  var endpoint = $as_Lamf_plugins_domain_webapi_models_EndPoint($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$2, other));
  var value = this.entry$1.value$2;
  var node = endpoint.id$1;
  var property = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1.value$1.iri__T();
  var ctx = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
  $f_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__checkBalancedParams__T__Lorg_yaml_model_YNode__T__T__Lamf_plugins_document_webapi_contexts_WebApiContext__V(this, path, value, node, property, ctx);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1;
  var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(path, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1.key$2));
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(endpoint, field, value$1);
  if ((!$m_Lamf_core_utils_package$TemplateUri$().isValid__T__Z(path))) {
    var this$3 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext().eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().InvalidEndpointPath$1;
    var node$1 = endpoint.id$1;
    var message = $m_Lamf_core_utils_package$TemplateUri$().invalidMsg__T__T(path);
    var ast = this.entry$1.value$2;
    var prop = $m_s_None$();
    var l = ast.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$3, specification, node$1, prop, message, l)
  };
  var this$4 = this.collector$1;
  inlinereturn$10: {
    var these = this$4;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      var other$1 = $as_Lamf_plugins_domain_webapi_models_EndPoint(arg1);
      var this$5 = $as_Lamf_core_model_StrField(other$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1)).option$1;
      if ((!this$5.isEmpty__Z())) {
        var arg1$1 = this$5.get__O();
        var x$1 = $as_T(arg1$1);
        var jsx$2 = this.identicalPaths__T__T__Z(x$1, path)
      } else {
        var jsx$2 = false
      };
      if (jsx$2) {
        var jsx$1 = true;
        break inlinereturn$10
      };
      these = $as_sc_LinearSeqOptimized(these.tail__O())
    };
    var jsx$1 = false
  };
  if (jsx$1) {
    var this$6 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext().eh$1;
    var specification$1 = $m_Lamf_validations_ParserSideValidations$().DuplicatedEndpointPath$1;
    var node$2 = endpoint.id$1;
    var message$1 = ("Duplicated resource path " + path);
    var ast$1 = this.entry$1;
    var prop$1 = $m_s_None$();
    var l$1 = ast$1.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$6, specification$1, node$2, prop$1, message$1, l$1);
    return $m_s_None$()
  } else {
    return this.parseEndpoint__p1__Lamf_plugins_domain_webapi_models_EndPoint__s_Option(endpoint)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser.prototype.parseEndpoint__p1__Lamf_plugins_domain_webapi_models_EndPoint__s_Option = (function(endpoint) {
  var x1 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext().link__Lorg_yaml_model_YNode__s_util_Either(this.entry$1.value$2);
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var value = $as_T(x2.value$2);
    var rc6 = false;
    var x2$2 = null;
    var this$3 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
    this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
    $m_Lamf_core_parser_Annotations$();
    new $c_Lamf_core_parser_Annotations().init___();
    this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
    var this$4 = this$3.jsonSchemaRefGuide$2.obtainRemoteYNode__T__s_Option(value);
    var x1$2 = (this$4.isEmpty__Z() ? this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext().declarations__Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations().asts__sci_Map().get__O__s_Option(value) : this$4);
    if ((x1$2 instanceof $c_s_Some)) {
      rc6 = true;
      x2$2 = $as_s_Some(x1$2);
      var map = $as_Lorg_yaml_model_YNode(x2$2.value$2);
      var x = map.tag__Lorg_yaml_model_YTag().tagType$3;
      var x$2 = $m_Lorg_yaml_model_YType$().Map$1;
      if ((x === x$2)) {
        var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
        return new $c_s_Some().init___O(this.parseEndpointMap__Lamf_plugins_domain_webapi_models_EndPoint__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_EndPoint(endpoint, $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(map, conversion, iv))))
      }
    };
    if (rc6) {
      var n = $as_Lorg_yaml_model_YNode(x2$2.value$2);
      var this$5 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext().eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidEndpointType$1;
      var node = endpoint.id$1;
      var prop = $m_s_None$();
      var l = n.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$5, specification, node, prop, "Invalid node for path item", l);
      return $m_s_None$()
    };
    var x$3 = $m_s_None$();
    if ((x$3 === x1$2)) {
      var this$6 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext().eh$1;
      var specification$1 = $m_Lamf_validations_ParserSideValidations$().InvalidEndpointPath$1;
      var node$1 = endpoint.id$1;
      var message = ("Cannot find fragment path item ref " + value);
      var ast = this.entry$1.value$2;
      var prop$1 = $m_s_None$();
      var l$1 = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$6, specification$1, node$1, prop$1, message, l$1);
      return $m_s_None$()
    };
    throw new $c_s_MatchError().init___O(x1$2)
  } else if ((x1 instanceof $c_s_util_Right)) {
    var x3 = $as_s_util_Right(x1);
    var node$2 = $as_Lorg_yaml_model_YNode(x3.value$2);
    var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$1 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
    return new $c_s_Some().init___O(this.parseEndpointMap__Lamf_plugins_domain_webapi_models_EndPoint__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_EndPoint(endpoint, $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node$2, conversion$1, iv$1))))
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser.prototype.parseEndpointMap__Lamf_plugins_domain_webapi_models_EndPoint__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_EndPoint = (function(endpoint, map) {
  this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext().closedShape__T__Lorg_yaml_model_YMap__T__V(endpoint.id$1, map, "pathItem");
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var jsx$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T("description").asOasExtension__T();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Description$1;
  var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
  jsx$2.key__T__F1__V(jsx$1, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(endpoint));
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(endpoint, map, $m_sci_Nil$(), this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext()).parse__V();
  return endpoint
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser() {
  $c_O.call(this);
  this.entry$1 = null;
  this.producer$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function(entry, producer, ctx) {
  this.entry$1 = entry;
  this.producer$1 = producer;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser.prototype.parse__Lamf_plugins_domain_webapi_models_Operation = (function() {
  var jsx$1 = this.producer$1;
  var node = this.entry$1.key$2;
  var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
  var this$2 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
  var this$3 = $as_Lamf_core_model_domain_AmfElement(jsx$1.apply__O__O($objectToString(this$2.string__Lamf_core_model_domain_AmfScalar().value$1)));
  var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1);
  var operation = $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$3, other));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Method$1;
  var node$1 = this.entry$1.key$2;
  var iv$1 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
  var this$5 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$1, iv$1);
  var value = this$5.string__Lamf_core_model_domain_AmfScalar();
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(operation, field, value);
  var this$6 = this.entry$1.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv$2 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion, iv$2));
  this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext().closedShape__T__Lorg_yaml_model_YMap__T__V(operation.id$1, map, "operation");
  var this$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("operationId");
  if ((!this$8.isEmpty__Z())) {
    var arg1 = this$8.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var operationId = entry.value$2.toString__T();
    var this$9 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
    if ((!this$9.operationIds$3.add__O__Z(operationId))) {
      var this$10 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext().eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().DuplicatedOperationId$1;
      var node$2 = operation.id$1;
      var message = (("Duplicated operation id '" + operationId) + "'");
      var ast = entry.value$2;
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$10, specification, node$2, prop, message, l)
    }
  };
  this.parseOperationId__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Operation__V(map, operation);
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Description$1;
  var iv$3 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
  jsx$2.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(operation));
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Summary$1;
  var iv$4 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
  jsx$3.key__T__F1__V("summary", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$4).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(operation));
  var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Documentation$1;
  var iv$5 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
  jsx$4.key__T__F1__V("externalDocs", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$3, iv$5).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(operation).using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, operation$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lorg_yaml_model_YNode(x$1$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$().parse__Lorg_yaml_model_YNode__T__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_domain_shapes_models_CreativeWork(x$1, operation$1.id$1, this$2$1.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext())
    })
  })(this, operation))));
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(operation, map, $m_sci_Nil$(), this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext()).parseOrphanNode__T__V("responses");
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(operation, map, $m_sci_Nil$(), this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext()).parse__V();
  return operation
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser.prototype.parseOperationId__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Operation__V = (function(map, operation) {
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Name$1;
  var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
  jsx$1.key__T__F1__V("operationId", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(operation));
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().OperationId$1;
  var iv$1 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
  jsx$2.key__T__F1__V("operationId", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(operation))
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser() {
  $c_O.call(this);
  this.parent$1 = null;
  this.map$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function() {
  return this.ctx$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser.prototype.parse__Lamf_plugins_domain_webapi_models_Server = (function() {
  var server = $m_Lamf_plugins_domain_webapi_models_Server$().apply__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Server(this.map$1);
  var map = this.map$1;
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Url$1;
  var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
  jsx$1.key__T__F1__V("url", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(server));
  var parent = this.parent$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(server, parent);
  var map$1 = this.map$1;
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Description$1;
  var iv$1 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
  jsx$2.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(server));
  var map$2 = this.map$1;
  var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2).key__T__s_Option("variables");
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$5 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$2 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
    var jsx$4 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv$2)).entries$3;
    var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, server$1) {
      return (function(x$1$2) {
        var x$1 = $as_Lorg_yaml_model_YMapEntry(x$1$2);
        return $this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext().factory__Lamf_plugins_document_webapi_contexts_parser_OasLikeSpecVersionFactory().serverVariableParser__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser(x$1, server$1.id$1).parse__Lamf_plugins_domain_webapi_models_Parameter()
      })
    })(this, server));
    var this$6 = $m_sc_IndexedSeq$();
    var variables = $as_sc_IndexedSeq(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$6.ReusableCBF$6));
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Variables$1;
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(variables, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $as_Lamf_plugins_domain_webapi_models_Server($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(server, field$2, value, annotations))
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(server, this.map$1, $m_sci_Nil$(), this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext()).parse__V();
  this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext().closedShape__T__Lorg_yaml_model_YMap__T__V(server.id$1, this.map$1, "server");
  return server
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser.prototype.init___T__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function(parent, map, ctx) {
  this.parent$1 = parent;
  this.map$1 = map;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasLikeServerParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser() {
  $c_O.call(this);
  this.entry$1 = null;
  this.parent$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser.prototype.parse__Lamf_plugins_domain_webapi_models_Parameter = (function() {
  var node = this.entry$1.key$2;
  var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
  var node$1 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
  var this$2 = $m_Lamf_plugins_domain_webapi_models_Parameter$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_Parameter(this.entry$1);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1;
  var value = node$1.string__Lamf_core_model_domain_AmfScalar();
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1.key$2);
  var variable = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$2, field, value, annotations));
  var parent = this.parent$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(variable, parent);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
  var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations("path", new $c_Lamf_core_parser_Annotations().init___());
  var annotations$1 = ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SynthesizedField().init___());
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(variable, field$1, value$1, annotations$1);
  $m_Lorg_yaml_model_YNode$();
  var node$2 = this.entry$1.key$2;
  var iv$1 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
  var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
  var name = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node$2, conversion, iv$1));
  var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().ParameterName$1;
  var this$6 = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(variable, field$2, name));
  var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1;
  $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$6, field$3, true));
  var this$7 = this.entry$1.value$2;
  var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv$2 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$7, conversion$1, iv$2));
  this.parseMap__Lamf_plugins_domain_webapi_models_Parameter__Lorg_yaml_model_YMap__V(variable, map);
  return variable
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser.prototype.init___Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function(entry, parent, ctx) {
  this.entry$1 = entry;
  this.parent$1 = parent;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$2__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser.prototype.EmptyTarget$lzycompute$2__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser.prototype.parseMap__Lamf_plugins_domain_webapi_models_Parameter__Lorg_yaml_model_YMap__V = (function(variable, map) {
  this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext().closedShape__T__Lorg_yaml_model_YMap__T__V(variable.id$1, map, "serverVariable");
  $m_Lorg_yaml_model_YNode$();
  var node = this.entry$1.key$2;
  var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
  var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
  var this$2 = variable.withScalarSchema__T__Lamf_plugins_domain_shapes_models_ScalarShape($as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)));
  var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(map);
  var this$3 = $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$2, other));
  var dataType = $m_Lamf_core_model_DataType$().String$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
  var schema = $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$3, field, dataType));
  var counter = new $c_Lamf_core_utils_package$IdCounter().init___();
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_core_metamodel_domain_ShapeModel$().Values$1;
  var iv$1 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(schema);
  var eta$0$1 = new $c_s_Some().init___O(schema.id$1);
  jsx$2.key__T__F1__V("enum", jsx$1.using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, eta$0$1$1, counter$1) {
    return (function(node$2) {
      var node$1 = $as_Lorg_yaml_model_YNode(node$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$().parse__s_Option__Lamf_core_utils_package$IdCounter__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_core_model_domain_DataNode(eta$0$1$1, counter$1, node$1, $this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext())
    })
  })(this, eta$0$1, counter))));
  var this$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$7 = this$6.key__T__s_Option("default");
  if ((!this$7.isEmpty__Z())) {
    var arg1 = this$7.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    $m_Lorg_yaml_model_YNode$();
    var node$3 = entry.value$2;
    var iv$2 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
    var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
    var value = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node$3, conversion$1, iv$2));
    var field$2 = $m_Lamf_core_metamodel_domain_ShapeModel$().DefaultValueString$1;
    $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(schema, field$2, value));
    var $default = $m_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser(entry.value$2, new $c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables().init___(), $m_s_None$(), this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext()).parse__Lamf_core_model_domain_DataNode();
    var field$3 = $m_Lamf_core_metamodel_domain_ShapeModel$().Default$1;
    $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(schema, field$3, $default))
  };
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$4 = $m_Lamf_core_metamodel_domain_ShapeModel$().Description$1;
  var iv$3 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
  jsx$3.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$4, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(schema))
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.elem$1 = null;
  this.field$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser.prototype.init___Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function(map, elem, field, ctx) {
  this.map$1 = map;
  this.elem$1 = elem;
  this.field$1 = field;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser.prototype.parseServers__T__V = (function(key) {
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(key);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$5 = entry.value$2;
    var reader = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var this$4 = $m_sc_IndexedSeq$();
    var bf = this$4.ReusableCBF$6;
    var conversion = new $c_Lorg_yaml_convert_YRead$$anon$1().init___scg_CanBuildFrom__Lorg_yaml_convert_YRead(bf, reader);
    var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
    var jsx$2 = $as_sc_TraversableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$1$2) {
        var x$1 = $as_Lorg_yaml_model_YMap(x$1$2);
        return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser().init___T__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext($this.elem$1.id__T(), x$1, $this.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext()).parse__Lamf_plugins_domain_webapi_models_Server()
      })
    })(this));
    var this$6 = $m_sc_Seq$();
    var servers = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2));
    var this$7 = this.elem$1;
    var field = this.field$1;
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(servers, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry));
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$7, field, value, annotations))
  }
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser() {
  $c_O.call(this);
  this.node$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser.prototype.init___Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(node, ctx) {
  this.node$1 = node;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser.prototype.parse__Lamf_plugins_domain_webapi_models_Organization = (function() {
  var organization = $m_Lamf_plugins_domain_webapi_models_Organization$().apply__Lorg_yaml_model_YNode__Lamf_plugins_domain_webapi_models_Organization(this.node$1);
  var this$1 = this.node$1;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$1;
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$().Url$1;
  var iv$1 = this.ctx$1;
  jsx$1.key__T__F1__V("url", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(organization));
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$().Name$1;
  var iv$2 = this.ctx$1;
  jsx$2.key__T__F1__V("name", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(organization));
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$().Email$1;
  var iv$3 = this.ctx$1;
  jsx$3.key__T__F1__V("email", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(organization));
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(organization, map, $m_sci_Nil$(), this.ctx$1).parse__V();
  this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(organization.id$1, map, "contact");
  return organization
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OrganizationParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser() {
  $c_O.call(this);
  this.entry$1 = null;
  this.producer$1 = null;
  this.parent$1 = null;
  this.collector$1 = null;
  this.parseOptionalOperations$1 = false;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser.prototype.parsePath__T = (function() {
  var this$1 = this.parent$1;
  if (this$1.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$13 = $as_Lamf_plugins_domain_webapi_models_EndPoint(arg1);
    var this$2 = $as_Lamf_core_model_StrField(x$13.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1));
    var this$3 = this$2.option$1;
    var this$4 = new $c_s_Some().init___O($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())))
  };
  var jsx$1 = $as_T((this$4.isEmpty__Z() ? "" : this$4.get__O()));
  var this$5 = this.entry$1.key$2;
  var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
  var iv = this.ctx$1;
  return (("" + jsx$1) + $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv)).text$3)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser.prototype.implicitPathParamsOrdered__p1__Lamf_plugins_domain_webapi_models_EndPoint__Z__F1__sc_Seq__sc_Seq = (function(endpoint, isResourceType, filter, explicitParams) {
  var this$1 = this.parent$1;
  if (this$1.isEmpty__Z()) {
    var this$6 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$9 = $as_Lamf_plugins_domain_webapi_models_EndPoint(arg1);
    var this$6 = new $c_s_Some().init___O($as_sci_Map($as_sc_TraversableOnce($as_sc_Seq(x$9.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$10$2) {
        var x$10 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$10$2);
        var this$2 = $as_Lamf_core_model_StrField(x$10.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
        var this$3 = this$2.option$1;
        return ($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())) === "path")
      })
    })(this)))).foldLeft__O__F2__O($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$2$1) {
      return (function(x0$1$2, x1$1$2) {
        var x0$1 = $as_sci_Map(x0$1$2);
        var x1$1 = $as_Lamf_plugins_domain_webapi_models_Parameter(x1$1$2);
        var this$4 = $as_Lamf_core_model_StrField(x1$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
        var this$5 = this$4.option$1;
        return x0$1.updated__O__O__sci_Map($as_T((this$5.isEmpty__Z() ? null : this$5.get__O())), x1$1)
      })
    })(this)))))
  };
  var parentParams = $as_sci_Map((this$6.isEmpty__Z() ? $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())) : this$6.get__O()));
  var pathParams = $m_Lamf_core_utils_package$TemplateUri$().variables__T__sc_Seq(this.parsePath__T());
  var jsx$2 = $as_sc_TraversableLike(pathParams.filter__F1__O(filter));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, parentParams$1, endpoint$1, explicitParams$1) {
    return (function(variable$2) {
      var variable = $as_T(variable$2);
      var x1 = parentParams$1.get__O__s_Option(variable);
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var param = $as_Lamf_plugins_domain_webapi_models_Parameter(x2.value$2);
        var pathParam = param.cloneParameter__T__Lamf_plugins_domain_webapi_models_Parameter(endpoint$1.id$1);
        pathParam.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SynthesizedField().init___());
        var xo = new $c_s_Some().init___O(pathParam);
        return xo.toList__sci_List()
      } else {
        var x = $m_s_None$();
        if ((x === x1)) {
          var x1$2 = explicitParams$1.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, variable$1) {
            return (function(p$2) {
              var p = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2);
              var this$8 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
              var this$9 = this$8.option$1;
              var this$10 = $as_T((this$9.isEmpty__Z() ? null : this$9.get__O()));
              if ((this$10 === variable$1)) {
                var this$11 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
                var this$12 = this$11.option$1;
                var this$13 = $as_T((this$12.isEmpty__Z() ? null : this$12.get__O()));
                return (this$13 === "path")
              } else {
                return false
              }
            })
          })(this$3$1, variable)));
          if ((x1$2 instanceof $c_s_Some)) {
            var x2$2 = $as_s_Some(x1$2);
            var p$3 = $as_Lamf_plugins_domain_webapi_models_Parameter(x2$2.value$2);
            var xo$1 = new $c_s_Some().init___O(p$3);
            return xo$1.toList__sci_List()
          } else {
            var x$3 = $m_s_None$();
            if ((x$3 === x1$2)) {
              var xo$2 = this$3$1.generateParam__Lamf_plugins_domain_webapi_models_EndPoint__T__s_Option(endpoint$1, variable);
              return xo$2.toList__sci_List()
            } else {
              throw new $c_s_MatchError().init___O(x1$2)
            }
          }
        } else {
          throw new $c_s_MatchError().init___O(x1)
        }
      }
    })
  })(this, parentParams, endpoint, explicitParams));
  var this$16 = $m_sc_Seq$();
  var params = $as_sc_Seq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$16.ReusableCBFInstance$2));
  if ((!isResourceType)) {
    this.checkParamsUsage__p1__Lamf_plugins_domain_webapi_models_EndPoint__sc_Seq__sc_Seq__V(endpoint, pathParams, explicitParams)
  };
  var jsx$3 = $as_sc_GenTraversableOnce(explicitParams.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, params$1) {
    return (function(x$11$2) {
      var x$11 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$11$2);
      return (!params$1.contains__O__Z(x$11))
    })
  })(this, params))));
  var this$17 = $m_sc_Seq$();
  return $as_sc_Seq(params.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$17.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser.prototype.validateSlashsInSchema__p1__Lamf_core_model_domain_Shape__Lorg_yaml_model_YMapEntry__V = (function(shape, entry) {
  var this$1 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_DataNode(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Default$1)));
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var x$3 = $as_Lamf_core_model_domain_DataNode(arg1);
    this.validateSlashInDataNode__p1__Lamf_core_model_domain_DataNode__Lorg_yaml_model_YMapEntry__V(x$3, entry)
  };
  $as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Values$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, entry$1) {
    return (function(value$2) {
      var value = $as_Lamf_core_model_domain_DataNode(value$2);
      this$2.validateSlashInDataNode__p1__Lamf_core_model_domain_DataNode__Lorg_yaml_model_YMapEntry__V(value, entry$1)
    })
  })(this, entry)));
  if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(shape);
    $as_sc_Seq(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3, entry$2) {
      return (function(example$2) {
        var example = $as_Lamf_plugins_domain_shapes_models_Example(example$2);
        var this$4 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_DataNode(example.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1)));
        if ((!this$4.isEmpty__Z())) {
          var arg1$1 = this$4.get__O();
          var x$4 = $as_Lamf_core_model_domain_DataNode(arg1$1);
          this$3.validateSlashInDataNode__p1__Lamf_core_model_domain_DataNode__Lorg_yaml_model_YMapEntry__V(x$4, entry$2)
        }
      })
    })(this, entry)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser.prototype.parseEndpoint__Lamf_plugins_domain_webapi_models_EndPoint__Lorg_yaml_model_YMap__V = (function(endpoint, map) {
  var x = this.ctx$1.contextType$3;
  var x$2 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().RESOURCE$undTYPE$2;
  var isResourceType = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2));
  this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(endpoint.id$1, map, (isResourceType ? "resourceType" : "endPoint"));
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Name$1;
  var iv = this.ctx$1;
  jsx$1.key__T__F1__V("displayName", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(endpoint).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Description$1;
  var iv$1 = this.ctx$1;
  jsx$2.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(endpoint).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$5 = this$4.key__T__s_Option("is");
  if ((!this$5.isEmpty__Z())) {
    var arg1 = this$5.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var jsx$4 = endpoint.annotations$1;
    var jsx$3 = $m_Lamf_core_parser_Range$();
    var this$6 = e.location$1;
    jsx$4.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry().init___Lamf_core_parser_Range(jsx$3.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$6.lineFrom$1, this$6.columnFrom$1, this$6.lineTo$1, this$6.columnTo$1))));
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Extends__Lamf_core_metamodel_Field();
    var iv$2 = this.ctx$1;
    var jsx$5 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(endpoint);
    var eta$0$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, endpoint$2) {
      return (function(name$2) {
        var name = $as_T(name$2);
        return $f_Lamf_plugins_domain_webapi_models_ExtensibleWebApiDomainElement__withTrait__T__Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait(endpoint$2, name)
      })
    })(this, endpoint));
    jsx$5.using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, eta$0$1$1) {
      return (function(node$2) {
        var node = $as_Lorg_yaml_model_YNode(node$2);
        return $m_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$().parse__F1__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_core_model_domain_templates_ParametrizedDeclaration(eta$0$1$1, node, this$2$1.ctx$1)
      })
    })(this, eta$0$1))).allowingSingleValue__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField().optional__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField().apply__Lorg_yaml_model_YMapEntry__V(e)
  };
  var this$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$9 = this$8.key__T__s_Option("type");
  if ((!this$9.isEmpty__Z())) {
    var arg1$1 = this$9.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var jsx$7 = endpoint.annotations$1;
    var jsx$6 = $m_Lamf_core_parser_Range$();
    var this$10 = entry.location$1;
    jsx$7.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry().init___Lamf_core_parser_Range(jsx$6.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$10.lineFrom$1, this$10.columnFrom$1, this$10.lineTo$1, this$10.columnTo$1))));
    new $c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser().init___Lorg_yaml_model_YNode__F1__F2__Lamf_plugins_document_webapi_contexts_WebApiContext(entry.value$2, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, endpoint$2$1) {
      return (function(name$2$1) {
        var name$1 = $as_T(name$2$1);
        return $f_Lamf_plugins_domain_webapi_models_ExtensibleWebApiDomainElement__withResourceType__T__Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType(endpoint$2$1, name$1)
      })
    })(this, endpoint)), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$2$2, entry$1) {
      return (function(key$2, scope$2) {
        var key = $as_T(key$2);
        var scope = $as_Lamf_core_parser_SearchScope$Scope(scope$2);
        return this$2$2.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().findResourceTypeOrError__Lorg_yaml_model_YPart__T__Lamf_core_parser_SearchScope$Scope__Lamf_plugins_domain_webapi_models_templates_ResourceType(entry$1.value$2, key, scope)
      })
    })(this, entry)), this.ctx$1).parse__Lamf_core_model_domain_templates_ParametrizedDeclaration()
  };
  var optionalMethod = (this.parseOptionalOperations$1 ? "\\??" : "");
  var this$12 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var expression = ("(get|patch|put|post|delete|options|head|connect|trace)" + optionalMethod);
  var entries = this$12.regex__T__sc_Iterable(expression);
  if (entries.nonEmpty__Z()) {
    var operations = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    entries.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, endpoint$2$2, operations$1) {
      return (function(entry$2) {
        var entry$3 = $as_Lorg_yaml_model_YMapEntry(entry$2);
        var x1 = $this$2.ctx$1;
        if ((x1 instanceof $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext)) {
          var this$13 = $this$2.ctx$1;
          var jsx$9 = this$13.rootContextDocument$1;
          var jsx$8 = $this$2.ctx$1.refs$1;
          var x$1 = $this$2.ctx$1.eh$1;
          $m_sc_Seq$();
          $m_sci_Seq$();
          var this$17 = new $c_scm_ListBuffer().init___();
          var x$3 = this$17.toList__sci_List();
          var x$4 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
          $m_sc_Seq$();
          $m_sci_Seq$();
          var this$24 = new $c_scm_ListBuffer().init___();
          var x$5 = new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$24.toList__sci_List());
          var operationContext = new $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions(jsx$9, jsx$8, new $c_Lamf_core_parser_ParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext("", x$3, x$4, x$1, x$5), new $c_s_Some().init___O($this$2.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations()), $this$2.ctx$1.contextType$3, $this$2.ctx$1.options$2)
        } else {
          var this$25 = $this$2.ctx$1;
          var jsx$11 = this$25.rootContextDocument$1;
          var jsx$10 = $this$2.ctx$1.refs$1;
          var x$6 = $this$2.ctx$1.eh$1;
          $m_sc_Seq$();
          $m_sci_Seq$();
          var this$29 = new $c_scm_ListBuffer().init___();
          var x$8 = this$29.toList__sci_List();
          var x$9 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
          $m_sc_Seq$();
          $m_sci_Seq$();
          var this$36 = new $c_scm_ListBuffer().init___();
          var x$10 = new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$36.toList__sci_List());
          var operationContext = new $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions(jsx$11, jsx$10, new $c_Lamf_core_parser_ParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext("", x$8, x$9, x$6, x$10), new $c_s_Some().init___O($this$2.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations()), $this$2.ctx$1.contextType$3, $this$2.ctx$1.options$2)
        };
        var operation = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser().init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(entry$3, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, endpoint$2$3) {
          return (function(method$2) {
            var method = $as_T(method$2);
            return endpoint$2$3.withOperation__T__Lamf_plugins_domain_webapi_models_Operation(method)
          })
        })($this$2, endpoint$2$2)), $this$2.parseOptionalOperations$1, operationContext).parse__Lamf_plugins_domain_webapi_models_Operation();
        operations$1.$$plus$eq__O__scm_ListBuffer(operation);
        var jsx$12 = $this$2.ctx$1.operationContexts$3;
        var x$7 = operation.id$1;
        var this$38 = new $c_sci_StringOps().init___T(x$7);
        return jsx$12.put__O__O__s_Option($f_sci_StringLike__stripSuffix__T__T(this$38, "%3F"), operationContext)
      })
    })(this, endpoint, operations)));
    var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1;
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(operations, new $c_Lamf_core_parser_Annotations().init___());
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(endpoint, field$3, value)
  };
  var idCounter = new $c_Lamf_core_utils_package$IdCounter().init___();
  var eta$0$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, endpoint$1) {
    return (function(name$2$2) {
      var name$3 = $as_T(name$2$2);
      return endpoint$1.withSecurity__T__Lamf_plugins_domain_webapi_models_security_SecurityRequirement(name$3)
    })
  })(this, endpoint));
  var RequirementParser = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1, eta$0$2$1, idCounter$1) {
    return (function(node$2$1) {
      var node$1 = $as_Lorg_yaml_model_YNode(node$2$1);
      return $m_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$().parse__F1__Lamf_core_utils_package$IdCounter__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_domain_webapi_models_security_SecurityRequirement(eta$0$2$1, idCounter$1, node$1, this$5$1.ctx$1)
    })
  })(this, eta$0$2, idCounter));
  var jsx$13 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Security$1;
  var iv$3 = this.ctx$1;
  jsx$13.key__T__F1__V("securedBy", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$4, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(endpoint).using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(RequirementParser).allowingSingleValue__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var elem = new $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters().init___sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq($m_sci_Nil$(), $m_sci_Nil$(), $m_sci_Nil$(), $m_sci_Nil$(), $m_sci_Nil$(), $m_sci_Nil$());
  var elem$1 = null;
  elem$1 = elem;
  $m_Lamf_core_parser_Annotations$();
  var elem$2 = new $c_Lamf_core_parser_Annotations().init___();
  var elem$1$1 = null;
  elem$1$1 = elem$2;
  var entries$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).regex__T__sc_Iterable(this.uriParametersKey__T());
  var pf = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser(this);
  var x1$1 = $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(entries$3, pf);
  var x$3$1 = $m_s_None$();
  if ((x$3$1 === x1$1)) {
    var implicitExplicitPathParams = this.implicitPathParamsOrdered__p1__Lamf_plugins_domain_webapi_models_EndPoint__Z__F1__sc_Seq__sc_Seq(endpoint, isResourceType, this.implicitPathParamsOrdered$default$3__p1__F1(), $m_sci_Nil$())
  } else {
    if ((!(x1$1 instanceof $c_s_Some))) {
      throw new $c_s_MatchError().init___O(x1$1)
    };
    var x2 = $as_s_Some(x1$1);
    var e$3 = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    elem$1$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(e$3.value$2);
    var this$51 = e$3.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$4 = this.ctx$1;
    var jsx$15 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$51, conversion, iv$4)).entries$3;
    var jsx$14 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1, endpoint$3) {
      return (function(entry$3$2) {
        var entry$3$1 = $as_Lorg_yaml_model_YMapEntry(entry$3$2);
        var this$52 = $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser(this$6$1.ctx$1.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().parameterParser__F3().apply__O__O__O__O(entry$3$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$4, endpoint$2$4) {
          return (function(p$2) {
            var p = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2);
            var parent = endpoint$2$4.id$1;
            $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
            $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(p, parent)
          })
        })(this$6$1, endpoint$3)), false)).parse__Lamf_plugins_domain_webapi_models_Parameter();
        var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
        var param = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$52, field$5, "path"));
        var this$53 = param.fields$1.$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1);
        if ((!this$53.isEmpty__Z())) {
          var arg1$2 = this$53.get__O();
          var schema = $as_Lamf_core_model_domain_Shape(arg1$2);
          this$6$1.validateSlashsInSchema__p1__Lamf_core_model_domain_Shape__Lorg_yaml_model_YMapEntry__V(schema, entry$3$1)
        };
        return param
      })
    })(this, endpoint));
    var this$54 = $m_sc_IndexedSeq$();
    var explicitParameters = $as_sc_IndexedSeq(jsx$15.map__F1__scg_CanBuildFrom__O(jsx$14, this$54.ReusableCBF$6));
    var implicitExplicitPathParams = this.implicitPathParamsOrdered__p1__Lamf_plugins_domain_webapi_models_EndPoint__Z__F1__sc_Seq__sc_Seq(endpoint, isResourceType, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$7$1, explicitParameters$1) {
      return (function(variable$2) {
        var variable = $as_T(variable$2);
        return (!explicitParameters$1.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$5, variable$1) {
          return (function(x$1$2) {
            var x$1$1 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$1$2);
            var this$55 = $as_Lamf_core_model_StrField(x$1$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
            return $f_Lamf_core_model_ValueField__is__O__Z(this$55, variable$1)
          })
        })(this$7$1, variable))))
      })
    })(this, explicitParameters)), explicitParameters)
  };
  var jsx$16 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Parameters(elem$1);
  var x$12 = $m_sci_Nil$();
  var x$13 = $m_sci_Nil$();
  var x$14 = $m_sci_Nil$();
  var x$15 = $m_sci_Nil$();
  var x$16 = $m_sci_Nil$();
  elem$1 = jsx$16.add__Lamf_plugins_document_webapi_parser_spec_domain_Parameters__Lamf_plugins_document_webapi_parser_spec_domain_Parameters(new $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters().init___sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq(x$12, implicitExplicitPathParams, x$13, x$14, x$15, x$16));
  var this$63 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("parameters").asRamlAnnotation__T();
  var this$64 = this$63.key__T__s_Option(keyword);
  if ((!this$64.isEmpty__Z())) {
    var arg1$3 = this$64.get__O();
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
    var jsx$17 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Parameters(elem$1);
    var this$65 = entry$4.value$2;
    var conversion$1 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var iv$5 = this.ctx$1;
    var qual$1 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser().init___sc_Seq__T__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($as_sc_Seq($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$65, conversion$1, iv$5)), endpoint.id$1, $m_Lamf_plugins_document_webapi_parser_spec_package$().toOas__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.ctx$1));
    elem$1 = jsx$17.add__Lamf_plugins_document_webapi_parser_spec_domain_Parameters__Lamf_plugins_document_webapi_parser_spec_domain_Parameters(qual$1.parse__Z__Lamf_plugins_document_webapi_parser_spec_domain_Parameters(false));
    elem$1$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4.value$2)
  };
  var x1$2 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Parameters(elem$1);
  matchEnd6: {
    if ((x1$2 !== null)) {
      var query = x1$2.query$1;
      var path = x1$2.path$1;
      var header = x1$2.header$1;
      if ($as_Lamf_plugins_document_webapi_parser_spec_domain_Parameters(elem$1).nonEmpty__Z()) {
        var field$6 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1;
        var this$66 = $m_sc_Seq$();
        var jsx$18 = $as_sc_TraversableLike(query.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(path, this$66.ReusableCBFInstance$2));
        var this$67 = $m_sc_Seq$();
        var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$18.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(header, this$67.ReusableCBFInstance$2)), $as_Lamf_core_parser_Annotations(elem$1$1));
        var annotations = $as_Lamf_core_parser_Annotations(elem$1$1);
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(endpoint, field$6, value$1, annotations);
        break matchEnd6
      }
    }
  };
  var this$70 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T("payloads").asRamlAnnotation__T();
  var this$71 = this$70.key__T__s_Option(keyword$1);
  if ((!this$71.isEmpty__Z())) {
    var arg1$4 = this$71.get__O();
    var entry$5 = $as_Lorg_yaml_model_YMapEntry(arg1$4);
    var field$7 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Payloads$1;
    var jsx$19 = $m_sc_Seq$();
    var array = [new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser().init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(entry$5, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$6, endpoint$2$5) {
      return (function(mediaType$2) {
        var mediaType = $as_s_Option(mediaType$2);
        return endpoint$2$5.withPayload__s_Option__Lamf_plugins_domain_webapi_models_Payload(mediaType)
      })
    })(this, endpoint)), false, this.ctx$1).parse__Lamf_plugins_domain_webapi_models_Payload()];
    var value$2 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$19.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$5.value$2));
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$5);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(endpoint, field$7, value$2, annotations$1)
  };
  this.collector$1.$$plus$eq__O__scm_ListBuffer(endpoint);
  if (isResourceType) {
    $m_sci_List$();
    var array$1 = [$m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().resourceType$1];
    var i = (((-1) + $uI(array$1.length)) | 0);
    var result = $m_sci_Nil$();
    while ((i >= 0)) {
      var this$77 = result;
      var index = i;
      var x$11 = array$1[index];
      result = new $c_sci_$colon$colon().init___O__sci_List(x$11, this$77);
      i = (((-1) + i) | 0)
    };
    var jsx$20 = result
  } else {
    $m_sci_List$();
    var array$2 = [$m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().endpoint$1];
    var i$1 = (((-1) + $uI(array$2.length)) | 0);
    var result$1 = $m_sci_Nil$();
    while ((i$1 >= 0)) {
      var this$81 = result$1;
      var index$1 = i$1;
      var x$17 = array$2[index$1];
      result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$17, this$81);
      i$1 = (((-1) + i$1) | 0)
    };
    var jsx$20 = result$1
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(endpoint, map, jsx$20, this.ctx$1).parse__V();
  var this$83 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var entries$1 = this$83.regex__T__sc_Iterable("^/.*");
  if (entries$1.nonEmpty__Z()) {
    if (isResourceType) {
      entries$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$7, endpoint$2$6, map$1) {
        return (function(entry$2$1) {
          var entry$6 = $as_Lorg_yaml_model_YMapEntry(entry$2$1);
          var nestedEndpointName = entry$6.key$2.toString__T();
          var this$88 = $this$7.ctx$1.eh$1;
          var specification = $m_Lamf_validations_ResolutionSideValidations$().NestedEndpoint$1;
          var x$18 = endpoint$2$6.id$1;
          var this$85 = new $c_sci_StringOps().init___T(x$18);
          var node$3 = $f_sci_StringLike__stripSuffix__T__T(this$85, "/applied");
          var property = $m_s_None$();
          var message = (("Nested endpoint in resourceType: '" + nestedEndpointName) + "'");
          var jsx$21 = $m_Lamf_core_parser_Range$();
          var this$86 = entry$6.key$2;
          var this$87 = this$86.location$1;
          var lexical = new $c_s_Some().init___O(new $c_Lamf_core_annotations_LexicalInformation().init___Lamf_core_parser_Range(jsx$21.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$87.lineFrom$1, this$87.columnFrom$1, this$87.lineTo$1, this$87.columnTo$1))));
          var location = new $c_s_Some().init___O(map$1.location$1.sourceName$1);
          this$88.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node$3, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
        })
      })(this, endpoint, map)))
    } else {
      entries$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$3, endpoint$2$7) {
        return (function(x$2$2) {
          var x$2$1 = $as_Lorg_yaml_model_YMapEntry(x$2$2);
          $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser(this$2$3.ctx$1.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().endPointParser__F5().apply__O__O__O__O__O__O(x$2$1, this$2$3.producer$1, new $c_s_Some().init___O(endpoint$2$7), this$2$3.collector$1, false)).parse__V()
        })
      })(this, endpoint)))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser.prototype.parse__V = (function() {
  var path = this.parsePath__T();
  var this$1 = $as_Lamf_core_model_domain_AmfElement(this.producer$1.apply__O__O(path));
  var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1);
  var endpoint = $as_Lamf_plugins_domain_webapi_models_EndPoint($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$1, other));
  var this$2 = this.parent$1;
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var p = $as_Lamf_plugins_domain_webapi_models_EndPoint(arg1);
    var annotation = $m_Lamf_plugins_domain_webapi_annotations_ParentEndPoint$().apply__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_domain_webapi_annotations_ParentEndPoint(p);
    new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_EndPoint($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(endpoint, annotation)))
  };
  var value = this.entry$1.value$2;
  var node = endpoint.id$1;
  var property = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1.value$1.iri__T();
  var ctx = this.ctx$1;
  $f_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__checkBalancedParams__T__Lorg_yaml_model_YNode__T__T__Lamf_plugins_document_webapi_contexts_WebApiContext__V(this, path, value, node, property, ctx);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1;
  var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(path, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1.key$2));
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(endpoint, field, value$1);
  if ((!$m_Lamf_core_utils_package$TemplateUri$().isValid__T__Z(path))) {
    var this$3 = this.ctx$1.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().InvalidEndpointPath$1;
    var node$1 = endpoint.id$1;
    var message = $m_Lamf_core_utils_package$TemplateUri$().invalidMsg__T__T(path);
    var ast = this.entry$1.value$2;
    var prop = $m_s_None$();
    var l = ast.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$3, specification, node$1, prop, message, l)
  };
  var this$4 = this.collector$1;
  var this$5 = this$4.scala$collection$mutable$ListBuffer$$start$6;
  inlinereturn$18: {
    var these = this$5;
    while ((!these.isEmpty__Z())) {
      var arg1$1 = these.head__O();
      var e = $as_Lamf_plugins_domain_webapi_models_EndPoint(arg1$1);
      var this$6 = $as_Lamf_core_model_StrField(e.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1));
      if ($f_Lamf_core_model_ValueField__is__O__Z(this$6, path)) {
        var jsx$1 = true;
        break inlinereturn$18
      };
      these = $as_sc_LinearSeqOptimized(these.tail__O())
    };
    var jsx$1 = false
  };
  if (jsx$1) {
    var this$7 = this.ctx$1.eh$1;
    var specification$1 = $m_Lamf_validations_ParserSideValidations$().DuplicatedEndpointPath$1;
    var node$2 = endpoint.id$1;
    var message$1 = ("Duplicated resource path " + path);
    var ast$1 = this.entry$1;
    var prop$1 = $m_s_None$();
    var l$1 = ast$1.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$7, specification$1, node$2, prop$1, message$1, l$1)
  } else {
    var this$8 = this.entry$1.value$2;
    var x1 = this$8.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Null$1;
    if ((x === x1)) {
      this.collector$1.$$plus$eq__O__scm_ListBuffer(endpoint)
    } else {
      var this$9 = this.entry$1.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = this.ctx$1;
      var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$9, conversion, iv));
      this.parseEndpoint__Lamf_plugins_domain_webapi_models_EndPoint__Lorg_yaml_model_YMap__V(endpoint, map)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser.prototype.implicitPathParamsOrdered$default$3__p1__F1 = (function() {
  return new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$8$2) {
      $as_T(x$8$2);
      return true
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__s_Option__scm_ListBuffer__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(entry, producer, parent, collector, parseOptionalOperations, ctx) {
  this.entry$1 = entry;
  this.producer$1 = producer;
  this.parent$1 = parent;
  this.collector$1 = collector;
  this.parseOptionalOperations$1 = parseOptionalOperations;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser.prototype.validateSlashInDataNode__p1__Lamf_core_model_domain_DataNode__Lorg_yaml_model_YMapEntry__V = (function(node, entry) {
  matchEnd4: {
    if ((node instanceof $c_Lamf_core_model_domain_ScalarNode)) {
      var x2 = $as_Lamf_core_model_domain_ScalarNode(node);
      var this$1 = $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1)).option$1;
      if ((!this$1.isEmpty__Z())) {
        var arg1 = this$1.get__O();
        var x$5 = $as_T(arg1);
        var this$5 = new $c_sci_StringOps().init___T(x$5);
        var elem = new $c_jl_Character().init___C(47);
        var jsx$1 = $f_sc_SeqLike__contains__O__Z(this$5, elem)
      } else {
        var jsx$1 = false
      };
      if (jsx$1) {
        var this$8 = this.ctx$1.eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().SlashInUriParameterValues$1;
        var node$1 = node.id$1;
        var this$6 = $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1));
        var this$7 = this$6.option$1;
        var message = (("Value '" + $as_T((this$7.isEmpty__Z() ? null : this$7.get__O()))) + "' of uri parameter must not contain '/' character");
        var ast = entry.value$2;
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$8, specification, node$1, prop, message, l);
        break matchEnd4
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser.prototype.generateParam__Lamf_plugins_domain_webapi_models_EndPoint__T__s_Option = (function(endpoint, variable) {
  var operationsDefineParam = ($as_sc_Seq(endpoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1)).nonEmpty__Z() && $as_sc_Seq(endpoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1)).forall__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, variable$1) {
    return (function(op$2) {
      var op = $as_Lamf_plugins_domain_webapi_models_Operation(op$2);
      var this$1 = $m_s_Option$().apply__O__s_Option(op.request__Lamf_plugins_domain_webapi_models_Request());
      if ((!this$1.isEmpty__Z())) {
        var arg1 = this$1.get__O();
        var x$6 = $as_Lamf_plugins_domain_webapi_models_Request(arg1);
        return $as_sc_Seq(x$6.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().UriParameters$1)).exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, variable$2) {
          return (function(x$7$2) {
            var x$7 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$7$2);
            return $as_Lamf_core_model_StrField(x$7.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().ParameterName$1)).option$1.contains__O__Z(variable$2)
          })
        })($this, variable$1)))
      } else {
        return false
      }
    })
  })(this, variable))));
  if (operationsDefineParam) {
    return $m_s_None$()
  } else {
    var this$2 = endpoint.withParameter__T__Lamf_plugins_domain_webapi_models_Parameter(variable);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
    var this$3 = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$2, field, "path"));
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1;
    var pathParam = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$3, field$1, true));
    var this$4 = pathParam.withScalarSchema__T__Lamf_plugins_domain_shapes_models_ScalarShape(variable);
    var dataType = $m_Lamf_core_model_DataType$().String$1;
    var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
    $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field$2, dataType));
    pathParam.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SynthesizedField().init___());
    return new $c_s_Some().init___O(pathParam)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser.prototype.checkParamsUsage__p1__Lamf_plugins_domain_webapi_models_EndPoint__sc_Seq__sc_Seq__V = (function(endpoint, pathParams, endpointParams) {
  endpointParams.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, pathParams$1) {
    return (function(p$2) {
      var p = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2);
      var this$1 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1)).option$1;
      if ((!this$1.isEmpty__Z())) {
        var arg1 = this$1.get__O();
        var n = $as_T(arg1);
        var jsx$1 = pathParams$1.contains__O__Z(n)
      } else {
        var jsx$1 = false
      };
      if ((!jsx$1)) {
        var jsx$5 = $this.ctx$1.eh$1;
        var jsx$4 = $m_Lamf_validations_ParserSideValidations$().UnusedBaseUriParameter$1;
        var jsx$3 = p.id$1;
        var jsx$2 = $m_s_None$();
        var this$2 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
        var this$3 = this$2.option$1;
        jsx$5.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V(jsx$4, jsx$3, jsx$2, ("Unused uri parameter " + $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()))), p.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), $f_Lamf_core_model_domain_AmfElement__location__s_Option(p))
      }
    })
  })(this, pathParams)));
  var jsx$9 = $as_sc_Seq(endpoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1));
  var jsx$8 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(o$2) {
      var o = $as_Lamf_plugins_domain_webapi_models_Operation(o$2);
      var xo = $m_s_Option$().apply__O__s_Option(o.request__Lamf_plugins_domain_webapi_models_Request());
      return xo.toList__sci_List()
    })
  })(this));
  var this$5 = $m_sc_Seq$();
  var jsx$7 = $as_sc_TraversableLike(jsx$9.flatMap__F1__scg_CanBuildFrom__O(jsx$8, this$5.ReusableCBFInstance$2));
  var jsx$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x$12$2) {
      var x$12 = $as_Lamf_plugins_domain_webapi_models_Request(x$12$2);
      return $as_sc_Seq(x$12.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().UriParameters$1))
    })
  })(this));
  var this$6 = $m_sc_Seq$();
  $as_sc_IterableLike(jsx$7.flatMap__F1__scg_CanBuildFrom__O(jsx$6, this$6.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, pathParams$2) {
    return (function(p$3$2) {
      var p$3 = $as_Lamf_plugins_domain_webapi_models_Parameter(p$3$2);
      var this$7 = $as_Lamf_core_model_StrField(p$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1)).option$1;
      if ((!this$7.isEmpty__Z())) {
        var arg1$1 = this$7.get__O();
        var n$1 = $as_T(arg1$1);
        var jsx$10 = pathParams$2.contains__O__Z(n$1)
      } else {
        var jsx$10 = false
      };
      if ((!jsx$10)) {
        var jsx$14 = this$4$1.ctx$1.eh$1;
        var jsx$13 = $m_Lamf_validations_ParserSideValidations$().UnusedBaseUriParameter$1;
        var jsx$12 = p$3.id$1;
        var jsx$11 = $m_s_None$();
        var this$8 = $as_Lamf_core_model_StrField(p$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
        var this$9 = this$8.option$1;
        jsx$14.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V(jsx$13, jsx$12, jsx$11, ("Unused operation uri parameter " + $as_T((this$9.isEmpty__Z() ? null : this$9.get__O()))), p$3.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), $f_Lamf_core_model_domain_AmfElement__location__s_Option(p$3))
      }
    })
  })(this, pathParams)))
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlEndpointParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlEndpointParser;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.parseOptional$1 = false;
  this.ctx$1 = null;
  this.request$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser.prototype.parse__s_Option = (function() {
  var target = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser$$anon$1().init___Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser(this);
  var map = this.map$1;
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryParameters$1;
  var iv = this.ctx$1;
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$Target__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(target);
  var eta$0$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(p$2) {
      var p = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2);
      var parent = $as_Lamf_core_model_domain_AmfObject($this.request$1.getOrCreate__O()).id__T();
      $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(p, parent)
    })
  })(this));
  jsx$2.key__T__F1__V("queryParameters", jsx$1.using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, eta$0$1$1) {
    return (function(node$2) {
      var node = $as_Lorg_yaml_model_YNode(node$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_domain_RamlQueryParameterParser$().parse__F1__Z__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_domain_webapi_models_Parameter(eta$0$1$1, this$2.parseOptional$1, node, this$2.ctx$1)
    })
  })(this, eta$0$1))).treatMapAsArray__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField().optional__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var map$1 = this.map$1;
  var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Headers$1;
  var iv$1 = this.ctx$1;
  var jsx$3 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$Target__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(target);
  var eta$0$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(p$3$2) {
      var p$3 = $as_Lamf_plugins_domain_webapi_models_Parameter(p$3$2);
      var parent$1 = $as_Lamf_core_model_domain_AmfObject(this$3$1.request$1.getOrCreate__O()).id__T();
      $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(p$3, parent$1)
    })
  })(this));
  jsx$4.key__T__F1__V("headers", jsx$3.using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4, eta$0$2$1) {
    return (function(node$3$2) {
      var node$3 = $as_Lorg_yaml_model_YNode(node$3$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$().parse__F1__Z__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_domain_webapi_models_Parameter(eta$0$2$1, this$4.parseOptional$1, node$3, this$4.ctx$1)
    })
  })(this, eta$0$2))).treatMapAsArray__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField().optional__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var map$2 = this.map$1;
  var this$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var keyword = this.baseUriParametersKey__T();
  var this$7 = this$6.key__T__s_Option(keyword);
  if ((!this$7.isEmpty__Z())) {
    var arg1 = this$7.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$8 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$2 = this.ctx$1;
    var jsx$6 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$8, conversion, iv$2)).entries$3;
    var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
      return (function(paramEntry$2) {
        var paramEntry = $as_Lorg_yaml_model_YMapEntry(paramEntry$2);
        var this$9 = $this$1.parseParameter__Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_domain_webapi_models_Parameter(paramEntry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2) {
          return (function(p$2$1) {
            var p$1 = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2$1);
            var parent$2 = $as_Lamf_core_model_domain_AmfObject($this$2.request$1.getOrCreate__O()).id__T();
            $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
            $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(p$1, parent$2)
          })
        })($this$1)), $this$1.parseOptional$1);
        var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
        return $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$9, field$2, "path"))
      })
    })(this));
    var this$10 = $m_sc_IndexedSeq$();
    var parameters = $as_sc_IndexedSeq(jsx$6.map__F1__scg_CanBuildFrom__O(jsx$5, this$10.ReusableCBF$6));
    var this$11 = $as_Lamf_core_model_domain_AmfObject(this.request$1.getOrCreate__O());
    var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().UriParameters$1;
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(parameters, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$11, field$3, value, annotations)
  };
  var map$3 = this.map$1;
  var this$13 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3);
  var this$14 = this$13.key__T__s_Option("body");
  if ((!this$14.isEmpty__Z())) {
    var arg1$1 = this$14.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var payloads = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var this$15 = entry$3.value$2;
    var x1 = this$15.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Null$1;
    if ((x === x1)) {
      var this$17 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser(this.ctx$1.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().typeParser__F4().apply__O__O__O__O__O(entry$3, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3) {
        return (function(shape$2) {
          var shape = $as_Lamf_core_model_domain_Shape(shape$2);
          $m_Lamf_core_parser_Annotations$();
          var a = new $c_Lamf_core_parser_Annotations().init___();
          var qual$1 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, "default", a));
          var x$1 = $as_Lamf_core_model_domain_AmfObject($this$3.request$1.getOrCreate__O()).id__T();
          var x$2 = qual$1.adopted$default$2__sc_Seq();
          qual$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$1, x$2)
        })
      })(this)), false, this.defaultType__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType())).parse__s_Option();
      if ((!this$17.isEmpty__Z())) {
        var arg1$2 = this$17.get__O();
        var schema = $as_Lamf_core_model_domain_Shape(arg1$2);
        var payload = $as_Lamf_plugins_domain_webapi_models_Message(this.request$1.getOrCreate__O()).withPayload__s_Option__Lamf_plugins_domain_webapi_models_Payload($m_s_None$());
        payload.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_EmptyPayload().init___());
        $m_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$().ramlAutoGeneratedAnnotation__Lamf_core_model_domain_Shape__V(schema);
        var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
        var this$20 = $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(payload, other));
        var schema$1 = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(schema, payload.id$1, $m_s_None$());
        var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
        payloads.$$plus$eq__O__scm_ListBuffer($as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$20, field$4, schema$1)))
      }
    } else {
      var x$3 = $m_Lorg_yaml_model_YType$().Str$1;
      if ((x$3 === x1)) {
        var this$22 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser(this.ctx$1.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().typeParser__F4().apply__O__O__O__O__O(entry$3, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$2) {
          return (function(shape$3$2) {
            var shape$3 = $as_Lamf_core_model_domain_Shape(shape$3$2);
            $m_Lamf_core_parser_Annotations$();
            var a$1 = new $c_Lamf_core_parser_Annotations().init___();
            var qual$2 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape$3, "default", a$1));
            var x$3$1 = $as_Lamf_core_model_domain_AmfObject(this$3$2.request$1.getOrCreate__O()).id__T();
            var x$4 = qual$2.adopted$default$2__sc_Seq();
            qual$2.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$3$1, x$4)
          })
        })(this)), false, this.defaultType__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType())).parse__s_Option();
        if ((!this$22.isEmpty__Z())) {
          var arg1$3 = this$22.get__O();
          var schema$3 = $as_Lamf_core_model_domain_Shape(arg1$3);
          var payload$1 = $as_Lamf_plugins_domain_webapi_models_Message(this.request$1.getOrCreate__O()).withPayload__s_Option__Lamf_plugins_domain_webapi_models_Payload($m_s_None$());
          $m_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$().ramlAutoGeneratedAnnotation__Lamf_core_model_domain_Shape__V(schema$3);
          var other$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
          var this$25 = $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(payload$1, other$1));
          var schema$2 = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(schema$3, payload$1.id$1, $m_s_None$());
          var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
          payloads.$$plus$eq__O__scm_ListBuffer($as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$25, field$5, schema$2)))
        }
      } else {
        var this$26 = entry$3.value$2;
        var evidence$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var x1$2 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$26, evidence$2);
        if ((x1$2 instanceof $c_s_util_Right)) {
          var x2 = $as_s_util_Right(x1$2);
          var m = $as_Lorg_yaml_model_YMap(x2.value$2);
          var this$28 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(m);
          var entries = this$28.regex__T__sc_Iterable(".*/.*");
          if (entries.nonEmpty__Z()) {
            entries.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$4, payloads$1) {
              return (function(entry$2) {
                var entry$1 = $as_Lorg_yaml_model_YMapEntry(entry$2);
                var jsx$7 = $this$4.ctx$1.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().payloadParser__F3();
                var eta$0$3 = $as_Lamf_plugins_domain_webapi_models_Request($this$4.request$1.getOrCreate__O());
                return payloads$1.$$plus$eq__O__scm_ListBuffer($as_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser(jsx$7.apply__O__O__O__O(entry$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$5, eta$0$3$1) {
                  return (function(mediaType$2) {
                    var mediaType = $as_s_Option(mediaType$2);
                    return eta$0$3$1.withPayload__s_Option__Lamf_plugins_domain_webapi_models_Payload(mediaType)
                  })
                })($this$4, eta$0$3)), false)).parse__Lamf_plugins_domain_webapi_models_Payload())
              })
            })(this, payloads)))
          };
          var entries$3 = $as_sc_IndexedSeq(m.entries$3.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1, mediaTypeRegexPattern) {
            return (function(e$2) {
              var e = $as_Lorg_yaml_model_YMapEntry(e$2);
              var this$29 = e.key$2;
              var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
              var iv$3 = this$6$1.ctx$1;
              var thiz = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$29, conversion$1, iv$3)).text$3;
              if ((thiz === null)) {
                throw new $c_jl_NullPointerException().init___()
              };
              return (!$m_ju_regex_Pattern$().matches__T__jl_CharSequence__Z(mediaTypeRegexPattern, thiz))
            })
          })(this, ".*/.*"))));
          var others = $m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(entries$3, m.location$1.sourceName$1);
          var this$31 = others.entries$3;
          if ($f_sc_TraversableOnce__nonEmpty__Z(this$31)) {
            if (payloads.isEmpty__Z()) {
              var this$33 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser(this.ctx$1.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().typeParser__F4().apply__O__O__O__O__O(entry$3, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$7$1) {
                return (function(shape$4$2) {
                  var shape$4 = $as_Lamf_core_model_domain_Shape(shape$4$2);
                  $m_Lamf_core_parser_Annotations$();
                  var a$2 = new $c_Lamf_core_parser_Annotations().init___();
                  var qual$3 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape$4, "default", a$2));
                  var x$5 = $as_Lamf_core_model_domain_AmfObject(this$7$1.request$1.getOrCreate__O()).id__T();
                  var x$6 = qual$3.adopted$default$2__sc_Seq();
                  qual$3.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$5, x$6)
                })
              })(this)), false, this.defaultType__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType())).parse__s_Option();
              if ((!this$33.isEmpty__Z())) {
                var arg1$4 = this$33.get__O();
                var schema$4 = $as_Lamf_core_model_domain_Shape(arg1$4);
                var payload$2 = $as_Lamf_plugins_domain_webapi_models_Message(this.request$1.getOrCreate__O()).withPayload__s_Option__Lamf_plugins_domain_webapi_models_Payload($m_s_None$());
                $m_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$().ramlAutoGeneratedAnnotation__Lamf_core_model_domain_Shape__V(schema$4);
                var other$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
                var this$36 = $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(payload$2, other$2));
                var schema$5 = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(schema$4, payload$2.id$1, $m_s_None$());
                var field$6 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
                payloads.$$plus$eq__O__scm_ListBuffer($as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$36, field$6, schema$5)))
              }
            } else {
              others.entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$9$1) {
                return (function(e$3$2) {
                  var e$3 = $as_Lorg_yaml_model_YMapEntry(e$3$2);
                  var this$38 = this$9$1.ctx$1.eh$1;
                  var specification = $m_Lamf_validations_ParserSideValidations$().UnsupportedExampleMediaTypeErrorSpecification$1;
                  var node$1 = $as_Lamf_core_model_domain_AmfObject(this$9$1.request$1.getOrCreate__O()).id__T();
                  var this$37 = e$3.key$2;
                  var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
                  var iv$4 = this$9$1.ctx$1;
                  var message = (("Unexpected key '" + $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$37, conversion$2, iv$4)).text$3) + "'. Expecting valid media types.");
                  var prop = $m_s_None$();
                  var l = e$3.location$1;
                  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$38, specification, node$1, prop, message, l)
                })
              })(this)))
            }
          }
        }
      }
    };
    if (payloads.nonEmpty__Z()) {
      var this$39 = $as_Lamf_core_model_domain_AmfObject(this.request$1.getOrCreate__O());
      var field$7 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Payloads$1;
      var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(payloads, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3.value$2));
      var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$39, field$7, value$1, annotations$1)
    }
  };
  this.parse__Lamf_core_utils_Lazy__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$Target__V(this.request$1, target);
  var this$40 = this.request$1;
  var this$41 = this$40.value$1;
  if ((!this$41.isEmpty__Z())) {
    var arg1$5 = this$41.get__O();
    var x$1$1 = $as_Lamf_plugins_domain_webapi_models_Request(arg1$5);
    var jsx$9 = x$1$1.annotations$2;
    var jsx$8 = $m_Lamf_core_parser_Annotations$();
    $m_Lorg_yaml_model_YNode$();
    var map$4 = this.map$1;
    jsx$9.$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(jsx$8.apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map$4, $m_Lorg_yaml_model_YType$().Map$1)))
  };
  var this$43 = this.request$1;
  return this$43.value$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser.prototype.init___Lorg_yaml_model_YMap__F0__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(map, producer, parseOptional, ctx) {
  this.map$1 = map;
  this.parseOptional$1 = parseOptional;
  this.ctx$1 = ctx;
  this.request$1 = new $c_Lamf_core_utils_Lazy().init___F0(producer);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlRequestParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlRequestParser;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser$$anon$1() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser$$anon$1.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser$$anon$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser$$anon$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser$$anon$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser$$anon$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser$$anon$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser$$anon$1.prototype.foreach__F1__V = (function(fn) {
  fn.apply__O__O(this.$$outer$1.request$1.getOrCreate__O())
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser$$anon$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser$$anon$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser$$anon$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlRequestParser$$anon$1", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser$$anon$1: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$Target: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser$$anon$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser$$anon$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser() {
  $c_O.call(this);
  this.entry$1 = null;
  this.adopt$1 = null;
  this.parseOptional$1 = false;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(entry, adopt, parseOptional, ctx) {
  this.entry$1 = entry;
  this.adopt$1 = adopt;
  this.parseOptional$1 = parseOptional;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser.prototype.parse__Lamf_plugins_domain_webapi_models_Response = (function() {
  var node = this.entry$1.key$2;
  var iv = this.ctx$1;
  var this$2 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
  var node$1 = this$2.text__Lamf_core_model_domain_AmfScalar();
  var this$3 = this.entry$1.value$2;
  var x1 = this$3.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Null$1;
  if ((x === x1)) {
    var this$4 = $m_Lamf_plugins_domain_webapi_models_Response$().apply__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_Response(this.entry$1);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Name$1;
    var this$5 = $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$4, field, node$1);
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1;
    var response = $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$5, field$1, node$1));
    this.adopt$1.apply__O__O(response);
    var response$2 = response
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Str$1;
    if ((x$3 === x1)) {
      var jsx$1 = true
    } else {
      var x$5 = $m_Lorg_yaml_model_YType$().Int$1;
      var jsx$1 = (x$5 === x1)
    };
    if (jsx$1) {
      var this$6 = this.entry$1.value$2;
      var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$1 = this.ctx$1;
      var ref = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion, iv$1)).text$3;
      var qual$1 = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().findResponseOrError__Lorg_yaml_model_YPart__T__Lamf_core_parser_SearchScope$Scope__Lamf_plugins_domain_webapi_models_Response(this.entry$1.value$2, ref, $m_Lamf_core_parser_SearchScope$All$());
      $m_Lamf_core_parser_Annotations$();
      var x$2$2 = new $c_Lamf_core_parser_Annotations().init___();
      var res = $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(qual$1, ref, x$2$2));
      var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Name$1;
      $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(res, field$2, node$1)).annotations$2.$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations($m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1));
      var response$2 = res
    } else {
      var this$8 = this.entry$1.value$2;
      var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv$2 = this.ctx$1;
      var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$8, conversion$1, iv$2));
      var this$9 = $m_Lamf_plugins_domain_webapi_models_Response$().apply__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_Response(this.entry$1);
      var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Name$1;
      var res$2 = $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$9, field$3, node$1));
      this.adopt$1.apply__O__O(res$2);
      var this$10 = $as_Lamf_core_model_StrField(res$2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Name$1));
      var this$11 = this$10.option$1;
      var statusCode = $as_T((this$11.isEmpty__Z() ? null : this$11.get__O()));
      var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1;
      $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(res$2, field$4, statusCode));
      if (((this.parseOptional$1 && $m_sjsr_RuntimeString$().endsWith__T__T__Z(node$1.toString__T(), "?")) && this.supportsOptionalResponses__Z())) {
        var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Optional$1;
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(res$2, field$5, true);
        var x$1 = node$1.toString__T();
        var this$13 = new $c_sci_StringOps().init___T(x$1);
        var name = $f_sci_StringLike__stripSuffix__T__T(this$13, "?");
        var field$6 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Name$1;
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(res$2, field$6, name);
        var field$7 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1;
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(res$2, field$7, name)
      };
      var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
      var field$8 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Description$1;
      var iv$3 = this.ctx$1;
      jsx$2.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$8, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(res$2).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
      var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
      var field$9 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Headers$1;
      var iv$4 = this.ctx$1;
      var jsx$3 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$9, iv$4).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(res$2);
      var eta$0$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, res$2$1) {
        return (function(p$2) {
          var p = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2);
          var parent = res$2$1.id$1;
          $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
          $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(p, parent)
        })
      })(this, res$2));
      jsx$4.key__T__F1__V("headers", jsx$3.using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, eta$0$1$1) {
        return (function(node$2$2) {
          var node$2 = $as_Lorg_yaml_model_YNode(node$2$2);
          return $m_Lamf_plugins_document_webapi_parser_spec_domain_RamlHeaderParser$().parse__F1__Z__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_domain_webapi_models_Parameter(eta$0$1$1, this$2$1.parseOptional$1, node$2, this$2$1.ctx$1)
        })
      })(this, eta$0$1))).treatMapAsArray__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField().optional__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
      var this$17 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
      var this$18 = this$17.key__T__s_Option("body");
      if ((!this$18.isEmpty__Z())) {
        var arg1 = this$18.get__O();
        var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
        var payloads = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
        var payload = new $c_Lamf_plugins_domain_webapi_models_Payload().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
        var parent$1 = res$2.id$1;
        $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(payload, parent$1);
        var this$21 = entry.value$2;
        var x1$1 = this$21.tag__Lorg_yaml_model_YTag().tagType$3;
        var x$2 = $m_Lorg_yaml_model_YType$().Null$1;
        if ((x$2 === x1$1)) {
          var this$24 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser(this.ctx$1.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().typeParser__F4().apply__O__O__O__O__O(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, payload$1) {
            return (function(shape$2) {
              var shape = $as_Lamf_core_model_domain_Shape(shape$2);
              var jsx$5 = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$();
              $m_Lamf_core_parser_Annotations$();
              var a = new $c_Lamf_core_parser_Annotations().init___();
              var qual$2 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, "default", a));
              var x$3$1 = payload$1.id$1;
              var x$4 = qual$2.adopted$default$2__sc_Seq();
              jsx$5.tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape($as_Lamf_core_model_domain_Shape(qual$2.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$3$1, x$4)), payload$1.id$1, $m_s_None$())
            })
          })(this, payload)), false, this.defaultType__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType())).parse__s_Option();
          if ((!this$24.isEmpty__Z())) {
            var arg1$1 = this$24.get__O();
            var schema = $as_Lamf_core_model_domain_Shape(arg1$1);
            schema.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SynthesizedField().init___());
            payload.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_EmptyPayload().init___());
            $m_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$().ramlAutoGeneratedAnnotation__Lamf_core_model_domain_Shape__V(schema);
            var field$10 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
            payloads.$$plus$eq__O__scm_ListBuffer($as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(payload, field$10, schema)))
          };
          var field$11 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Payloads$1;
          var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(payloads, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
          var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
          $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(res$2, field$11, value, annotations$1)
        } else {
          var x$3$2 = $m_Lorg_yaml_model_YType$().Str$1;
          if ((x$3$2 === x1$1)) {
            var this$28 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser(this.ctx$1.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().typeParser__F4().apply__O__O__O__O__O(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, payload$2) {
              return (function(shape$3$2) {
                var shape$3 = $as_Lamf_core_model_domain_Shape(shape$3$2);
                var jsx$6 = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$();
                $m_Lamf_core_parser_Annotations$();
                var a$1 = new $c_Lamf_core_parser_Annotations().init___();
                var qual$3 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape$3, "default", a$1));
                var x$5$1 = payload$2.id$1;
                var x$6 = qual$3.adopted$default$2__sc_Seq();
                jsx$6.tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape($as_Lamf_core_model_domain_Shape(qual$3.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$5$1, x$6)), payload$2.id$1, $m_s_None$())
              })
            })(this, payload)), false, this.defaultType__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType())).parse__s_Option();
            if ((!this$28.isEmpty__Z())) {
              var arg1$2 = this$28.get__O();
              var s = $as_Lamf_core_model_domain_Shape(arg1$2);
              $m_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$().ramlAutoGeneratedAnnotation__Lamf_core_model_domain_Shape__V(s);
              var field$12 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
              payloads.$$plus$eq__O__scm_ListBuffer($as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(payload, field$12, s)))
            };
            var field$13 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Payloads$1;
            var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(payloads, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
            var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
            $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(res$2, field$13, value$1, annotations$2)
          } else {
            var this$30 = entry.value$2;
            var evidence$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
            var x1$2 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$30, evidence$2);
            if ((x1$2 instanceof $c_s_util_Right)) {
              var x2 = $as_s_util_Right(x1$2);
              var m = $as_Lorg_yaml_model_YMap(x2.value$2);
              var this$32 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(m);
              var entries = this$32.regex__T__sc_Iterable(".*/.*");
              if (entries.nonEmpty__Z()) {
                entries.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, payloads$1, res$1) {
                  return (function(entry$2) {
                    var entry$1 = $as_Lorg_yaml_model_YMapEntry(entry$2);
                    return payloads$1.$$plus$eq__O__scm_ListBuffer($as_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser($this$2.ctx$1.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().payloadParser__F3().apply__O__O__O__O(entry$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, res$1$1) {
                      return (function(mediaType$2) {
                        var mediaType = $as_s_Option(mediaType$2);
                        return res$1$1.withPayload__s_Option__Lamf_plugins_domain_webapi_models_Payload(mediaType)
                      })
                    })($this$2, res$1)), false)).parse__Lamf_plugins_domain_webapi_models_Payload())
                  })
                })(this, payloads, res$2)))
              };
              var entries$3 = $as_sc_IndexedSeq(m.entries$3.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1, mediaTypeRegexPattern) {
                return (function(e$2) {
                  var e = $as_Lorg_yaml_model_YMapEntry(e$2);
                  var this$33 = e.key$2;
                  var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
                  var iv$5 = this$6$1.ctx$1;
                  var thiz = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$33, conversion$2, iv$5)).text$3;
                  if ((thiz === null)) {
                    throw new $c_jl_NullPointerException().init___()
                  };
                  return (!$m_ju_regex_Pattern$().matches__T__jl_CharSequence__Z(mediaTypeRegexPattern, thiz))
                })
              })(this, ".*/.*"))));
              var jsx$7 = $m_Lorg_yaml_model_YMap$();
              var this$35 = entries$3.headOption__s_Option();
              if (this$35.isEmpty__Z()) {
                var this$36 = $m_s_None$()
              } else {
                var arg1$3 = this$35.get__O();
                var x$1$1 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
                var this$36 = new $c_s_Some().init___O(x$1$1.location$1.sourceName$1)
              };
              var others = jsx$7.apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(entries$3, $as_T((this$36.isEmpty__Z() ? "" : this$36.get__O())));
              var this$37 = others.entries$3;
              if ($f_sc_TraversableOnce__nonEmpty__Z(this$37)) {
                if (payloads.isEmpty__Z()) {
                  var this$39 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser(this.ctx$1.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().typeParser__F4().apply__O__O__O__O__O(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$9$1, payload$3) {
                    return (function(shape$4$2) {
                      var shape$4 = $as_Lamf_core_model_domain_Shape(shape$4$2);
                      $m_Lamf_core_parser_Annotations$();
                      var a$2 = new $c_Lamf_core_parser_Annotations().init___();
                      var qual$4 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape$4, "default", a$2));
                      var x$7 = payload$3.id$1;
                      var x$8 = qual$4.adopted$default$2__sc_Seq();
                      qual$4.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$7, x$8)
                    })
                  })(this, payload)), false, this.defaultType__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType())).parse__s_Option();
                  if ((!this$39.isEmpty__Z())) {
                    var arg1$4 = this$39.get__O();
                    var schema$3 = $as_Lamf_core_model_domain_Shape(arg1$4);
                    var payload$4 = res$2.withPayload__s_Option__Lamf_plugins_domain_webapi_models_Payload($m_s_None$());
                    $m_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$().ramlAutoGeneratedAnnotation__Lamf_core_model_domain_Shape__V(schema$3);
                    var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
                    var this$42 = $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(payload$4, other));
                    var schema$1 = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(schema$3, payload$4.id$1, $m_s_None$());
                    var field$14 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
                    payloads.$$plus$eq__O__scm_ListBuffer($as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$42, field$14, schema$1)))
                  }
                } else {
                  others.entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$11$1, res$1$2) {
                    return (function(e$3$2) {
                      var e$3 = $as_Lorg_yaml_model_YMapEntry(e$3$2);
                      var this$44 = this$11$1.ctx$1.eh$1;
                      var specification = $m_Lamf_validations_ParserSideValidations$().UnsupportedExampleMediaTypeErrorSpecification$1;
                      var node$3 = res$1$2.id$1;
                      var this$43 = e$3.key$2;
                      var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
                      var iv$6 = this$11$1.ctx$1;
                      var message = (("Unexpected key '" + $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$43, conversion$3, iv$6)).text$3) + "'. Expecting valid media types.");
                      var prop = $m_s_None$();
                      var l = e$3.location$1;
                      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$44, specification, node$3, prop, message, l)
                    })
                  })(this, res$2)))
                }
              }
            };
            if (payloads.nonEmpty__Z()) {
              var field$15 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Payloads$1;
              var value$2 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(payloads, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
              var annotations$3 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
              $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(res$2, field$15, value$2, annotations$3)
            }
          }
        }
      };
      var this$47 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
      var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("examples").asRamlAnnotation__T();
      var this$48 = this$47.key__T__s_Option(keyword);
      if ((!this$48.isEmpty__Z())) {
        var arg1$5 = this$48.get__O();
        var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$5);
        var examples = new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser().init___Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_WebApiContext(entry$3, res$2.id$1, this.ctx$1).parse__sc_Seq();
        var field$16 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Examples$1;
        var value$3 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(examples, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3.value$2));
        var annotations$4 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(res$2, field$16, value$3, annotations$4)
      };
      this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(res$2.id$1, map, "response");
      this.parseMap__Lamf_plugins_domain_webapi_models_Response__Lorg_yaml_model_YMap__V(res$2, map);
      var response$2 = res$2
    }
  };
  response$2.annotations$2.$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations($m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1));
  return response$2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlResponseParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlResponseParser;", depth))
}
function $f_Lamf_plugins_document_webapi_parser_spec_domain_SingleValueArrayEmitter__emit__Lorg_yaml_model_YDocument$EntryBuilder__V($thiz, b) {
  var single = $thiz.f__Lamf_core_parser_FieldEntry().value$1.value$1.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_SingleValueArray.getClassOf());
  var value = $thiz.f__Lamf_core_parser_FieldEntry().value$1;
  var this$2 = $thiz.f__Lamf_core_parser_FieldEntry();
  var elements = $thiz.collect__sc_Seq__sc_Seq($as_Lamf_core_model_domain_AmfArray(this$2.value$1.value$1).values$1);
  if (single) {
    $m_Lorg_yaml_model_YNode$();
    var str = $thiz.key__T();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    $thiz.emit__Lamf_core_model_domain_AmfElement__Lamf_core_emitter_PartEmitter($as_Lamf_core_model_domain_AmfElement(elements.head__O())).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
    var this$6 = v.builder$1;
    var array = [key];
    if ((this$6.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$6.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
    var len$1 = this$6.size0$6;
    var src = this$6.array$6;
    var dest = this$6.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$6.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$1 = j;
      var index = i;
      xs.set(jsx$1, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$6.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  } else {
    $m_Lorg_yaml_model_YNode$();
    var str$1 = $thiz.key__T();
    var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
    var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$6 = v$1.builder$1;
    var sourceName = v$1.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
    var jsx$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var jsx$3 = $thiz.ordering__Lamf_core_emitter_SpecOrdering();
    var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(element$2) {
        var element = $as_Lamf_core_model_domain_AmfElement(element$2);
        return $this.emit__Lamf_core_model_domain_AmfElement__Lamf_core_emitter_PartEmitter(element)
      })
    })($thiz));
    var this$19 = $m_sc_Seq$();
    jsx$4.traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V(jsx$3.sorted__sc_Seq__sc_Seq($as_sc_Seq(elements.map__F1__scg_CanBuildFrom__O(jsx$2, this$19.ReusableCBFInstance$2))), b$1);
    var jsx$5 = $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YSequence$();
    var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
    var parts = b$1.builder$1;
    var node = jsx$5.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
    jsx$6.$$plus$eq__O__scm_ArrayBuffer(node);
    var this$23 = v$1.builder$1;
    var array$1 = [key$1];
    if ((this$23.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$3 = $uI(array$1.length);
    var newSize$1 = ((this$23.size0$6 + len$3) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$23, newSize$1);
    var len$4 = this$23.size0$6;
    var src$1 = this$23.array$6;
    var dest$1 = this$23.array$6;
    $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
    var xs$1 = this$23.array$6;
    var len$5 = xs$1.u.length;
    var i$1 = 0;
    var j$1 = 0;
    var x$2 = $uI(array$1.length);
    var x$3 = ((x$2 < len$5) ? x$2 : len$5);
    var that$1 = xs$1.u.length;
    var end$1 = ((x$3 < that$1) ? x$3 : that$1);
    while ((i$1 < end$1)) {
      var jsx$7 = j$1;
      var index$1 = i$1;
      xs$1.set(jsx$7, array$1[index$1]);
      i$1 = ((1 + i$1) | 0);
      j$1 = ((1 + j$1) | 0)
    };
    this$23.size0$6 = newSize$1;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1))
  }
}
function $f_Lamf_plugins_document_webapi_parser_spec_domain_SingleValueArrayEmitter__position__Lamf_core_parser_Position($thiz) {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = $thiz.f__Lamf_core_parser_FieldEntry().value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser() {
  $c_O.call(this);
  this.node$1 = null;
  this.adopt$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser.prototype.parse__Lamf_plugins_domain_webapi_models_Tag = (function() {
  var this$1 = this.node$1;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$1;
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var tag = $m_Lamf_plugins_domain_webapi_models_Tag$().apply__Lorg_yaml_model_YNode__Lamf_plugins_domain_webapi_models_Tag(this.node$1);
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_TagModel$().Name$1;
  var iv$1 = this.ctx$1;
  jsx$1.key__T__F1__V("name", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(tag));
  this.adopt$1.apply__O__O(tag);
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_TagModel$().Description$1;
  var iv$2 = this.ctx$1;
  jsx$2.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(tag));
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_TagModel$().Documentation$1;
  var iv$3 = this.ctx$1;
  jsx$3.key__T__F1__V("externalDocs", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(tag).using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, tag$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lorg_yaml_model_YNode(x$1$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$().parse__Lorg_yaml_model_YNode__T__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_domain_shapes_models_CreativeWork(x$1, tag$1.id$1, $this.ctx$1)
    })
  })(this, tag))));
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(tag, map, $m_sci_Nil$(), this.ctx$1).parse__V();
  this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(tag.id$1, map, "tag");
  return tag
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser.prototype.init___Lorg_yaml_model_YNode__F1__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(node, adopt, ctx) {
  this.node$1 = node;
  this.adopt$1 = adopt;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_TagsParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.TagsParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_TagsParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser() {
  $c_O.call(this);
  this.entryLike$1 = null;
  this.parent$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.parseDynamicBinding__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement = (function(entry, parent, ctx) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var binding = new $c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$().Definition$1;
  var x$1 = entry.value$2;
  var x$2 = new $c_s_Some().init___O(parent);
  var x$3 = new $c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables().init___();
  var value = $m_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser(x$1, x$3, x$2, ctx).parse__Lamf_core_model_domain_DataNode();
  var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(binding, field, value, annotations$1);
  return binding
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.parseWs__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement = (function(entry, parent, ctx) {
  return this.parseEmptyBinding__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement(entry, parent, ctx)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.validateEmptyMap__p1__Lorg_yaml_model_YNode__T__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V = (function(value, node, type, ctx) {
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var this$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(value, conversion, ctx)).entries$3;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$1)) {
    var this$2 = ctx.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().NonEmptyBindingMap$1;
    var message = (("Reserved name binding '" + type) + "' must have an empty map");
    var prop = $m_s_None$();
    var l = value.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$2, specification, node, prop, message, l)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.parseAmqp__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement = (function(entry, parent, ctx) {
  return this.parseEmptyBinding__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement(entry, parent, ctx)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.parse__Lamf_core_model_domain_NamedDomainElement = (function() {
  var map = this.entryLike$1.asMap__Lorg_yaml_model_YMap();
  var x1 = this.ctx$1.link__Lorg_yaml_model_YNode__s_util_Either(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1)));
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var fullRef = $as_T(x2.value$2);
    return this.handleRef__T__Lamf_core_model_domain_NamedDomainElement(fullRef)
  } else if ((x1 instanceof $c_s_util_Right)) {
    return this.buildAndPopulate__Lamf_core_model_domain_NamedDomainElement()
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(entryLike, parent, ctx) {
  this.entryLike$1 = entryLike;
  this.parent$1 = parent;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.setDefaultBindingVersionValue__p1__Lamf_plugins_domain_webapi_models_bindings_BindingVersion__Lamf_core_metamodel_Field__Lamf_plugins_domain_webapi_models_bindings_BindingVersion = (function(binding, field) {
  var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations("latest", new $c_Lamf_core_parser_Annotations().init___());
  $m_Lamf_core_parser_Annotations$();
  var annotation = new $c_Lamf_core_annotations_SynthesizedField().init___();
  var annotations = new $c_Lamf_core_parser_Annotations().init___().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(annotation);
  return $as_Lamf_plugins_domain_webapi_models_bindings_BindingVersion($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(binding, field, value, annotations))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.parseMqtt__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement = (function(entry, parent, ctx) {
  return this.parseEmptyBinding__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement(entry, parent, ctx)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.parseEmptyBinding__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement = (function(entry, parent, ctx) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var binding = new $c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var jsx$2 = entry.value$2;
  var jsx$1 = binding.id$1;
  var this$3 = entry.key$2;
  var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
  this.validateEmptyMap__p1__Lorg_yaml_model_YNode__T__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V(jsx$2, jsx$1, $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, ctx)), ctx);
  return binding
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.parseSchema__Lamf_core_metamodel_Field__Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V = (function(field, binding, entry, parent, ctx) {
  var this$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(shape$2) {
      var shape = $as_Lamf_core_model_domain_Shape(shape$2);
      $m_Lamf_core_parser_Annotations$();
      var a = new $c_Lamf_core_parser_Annotations().init___();
      $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, "schema", a)
    })
  })(this)), $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$(), ctx).parse__s_Option();
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var shape$3 = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1);
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(binding, field, shape$3, annotations);
    $as_Lamf_plugins_domain_shapes_models_AnyShape(shape$3.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(parent, shape$3.adopted$default$2__sc_Seq()))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.nameAndAdopt__Lamf_core_model_domain_NamedDomainElement__s_Option__Lamf_core_model_domain_NamedDomainElement = (function(m, key) {
  if ((!key.isEmpty__Z())) {
    var arg1 = key.get__O();
    var k = $as_Lorg_yaml_model_YNode(arg1);
    var conversion = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
    var iv = this.ctx$1;
    var name = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(k, conversion, iv)).text$3;
    var a = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(k);
    $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(m, name, a)
  };
  var this$1 = m.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(this.parent$1, m.adopted$default$2__sc_Seq());
  var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entryLike$1.asMap__Lorg_yaml_model_YMap());
  return $as_Lamf_core_model_domain_NamedDomainElement($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$1, other))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.setBindingType__p1__Lorg_yaml_model_YMapEntry__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement = (function(entry, binding) {
  var node = entry.key$2;
  var iv = this.ctx$1;
  var node$1 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$().Type$1;
  var value = node$1.string__Lamf_core_model_domain_AmfScalar();
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.key$2);
  return $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(binding, field, value, annotations))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.parseBindings__Lamf_core_model_domain_NamedDomainElement__Lorg_yaml_model_YMap__Lamf_core_model_domain_NamedDomainElement = (function(obj, map) {
  var bindings = this.parseElements__Lorg_yaml_model_YMap__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__sc_Seq(map, obj.id__T(), this.ctx$1);
  var field = this.bindingsField__Lamf_core_metamodel_Field();
  var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(bindings, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(map));
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(map);
  return $as_Lamf_core_model_domain_NamedDomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(obj, field, value, annotations))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.parseBindingVersion__Lamf_plugins_domain_webapi_models_bindings_BindingVersion__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V = (function(binding, field, map, ctx) {
  new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__F1__V("bindingVersion", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  var this$2 = $as_Lamf_core_model_StrField(binding.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(binding.bindingVersionField__Lamf_core_metamodel_Field()));
  if ($f_Lamf_core_model_StrField__isNullOrEmpty__Z(this$2)) {
    this.setDefaultBindingVersionValue__p1__Lamf_plugins_domain_webapi_models_bindings_BindingVersion__Lamf_core_metamodel_Field__Lamf_plugins_domain_webapi_models_bindings_BindingVersion(binding, field)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.parseElement__p1__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement = (function(entry, parent, ctx) {
  var this$1 = entry.key$2;
  var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
  var x1 = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, ctx));
  var binding = (($m_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$().Http$1 === x1) ? this.parseHttp__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement(entry, parent, ctx) : (($m_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$().WebSockets$1 === x1) ? this.parseWs__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement(entry, parent, ctx) : (($m_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$().Kafka$1 === x1) ? this.parseKafka__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement(entry, parent, ctx) : (($m_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$().Amqp$1 === x1) ? this.parseAmqp__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement(entry, parent, ctx) : (($m_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$().Amqp1$1 === x1) ? this.parseEmptyBinding__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement(entry, parent, ctx) : (($m_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$().Mqtt$1 === x1) ? this.parseMqtt__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement(entry, parent, ctx) : (($m_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$().Mqtt5$1 === x1) ? this.parseEmptyBinding__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement(entry, parent, ctx) : (($m_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$().Nats$1 === x1) ? this.parseEmptyBinding__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement(entry, parent, ctx) : (($m_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$().Jms$1 === x1) ? this.parseEmptyBinding__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement(entry, parent, ctx) : (($m_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$().Sns$1 === x1) ? this.parseEmptyBinding__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement(entry, parent, ctx) : (($m_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$().Sqs$1 === x1) ? this.parseEmptyBinding__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement(entry, parent, ctx) : (($m_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$().Stomp$1 === x1) ? this.parseEmptyBinding__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement(entry, parent, ctx) : (($m_Lamf_plugins_document_webapi_parser_spec_domain_binding_Bindings$().Redis$1 === x1) ? this.parseEmptyBinding__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement(entry, parent, ctx) : this.parseDynamicBinding__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement(entry, parent, ctx))))))))))))));
  return this.setBindingType__p1__Lorg_yaml_model_YMapEntry__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(entry, binding)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.remote__T__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_NamedDomainElement = (function(fullRef, entryLike, parent, ctx) {
  $m_Lamf_core_parser_Annotations$();
  new $c_Lamf_core_parser_Annotations().init___();
  var x1 = ctx.jsonSchemaRefGuide$2.obtainRemoteYNode__T__s_Option(fullRef);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var bindingsNode = $as_Lorg_yaml_model_YNode(x2.value$2);
    var external = this.createParser__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser(new $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(bindingsNode, ctx)).parse__Lamf_core_model_domain_NamedDomainElement();
    return this.nameAndAdopt__Lamf_core_model_domain_NamedDomainElement__s_Option__Lamf_core_model_domain_NamedDomainElement($as_Lamf_core_model_domain_NamedDomainElement($as_Lamf_core_model_domain_Linkable(external).link__T__Lamf_core_parser_Annotations__O(fullRef, ($as_Lamf_core_model_domain_Linkable(external), $m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))), entryLike.key__s_Option())
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$5 = ctx.eh$1;
      var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnresolvedReference$1;
      var message = ("Cannot find link reference " + fullRef);
      var ast = entryLike.asMap__Lorg_yaml_model_YMap();
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$5, specification, "", prop, message, l);
      var errorBinding = this.errorBindings__T__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_core_model_domain_NamedDomainElement(fullRef, entryLike);
      return this.nameAndAdopt__Lamf_core_model_domain_NamedDomainElement__s_Option__Lamf_core_model_domain_NamedDomainElement($as_Lamf_core_model_domain_NamedDomainElement($as_Lamf_core_model_domain_Linkable(errorBinding).link__T__Lamf_core_parser_Annotations__O(fullRef, errorBinding.annotations__Lamf_core_parser_Annotations())), entryLike.key__s_Option())
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.parseElements__Lorg_yaml_model_YMap__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__sc_Seq = (function(map, parent, ctx) {
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).regex__T__sc_Iterable("^(?!x-).*");
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$1, ctx$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lorg_yaml_model_YMapEntry(x$1$2);
      return $this.parseElement__p1__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement(x$1, parent$1, ctx$1)
    })
  })(this, parent, ctx));
  var this$2 = $m_sc_Iterable$();
  return $as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2)).toSeq__sc_Seq()
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.parseHttp__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement = (function(entry, parent, ctx) {
  return this.parseEmptyBinding__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement(entry, parent, ctx)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.parseKafka__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement = (function(entry, parent, ctx) {
  return this.parseEmptyBinding__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement(entry, parent, ctx)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.buildAndPopulate__Lamf_core_model_domain_NamedDomainElement = (function() {
  var map = this.entryLike$1.asMap__Lorg_yaml_model_YMap();
  var bindings = this.createBindings__Lamf_core_model_domain_NamedDomainElement();
  this.nameAndAdopt__Lamf_core_model_domain_NamedDomainElement__s_Option__Lamf_core_model_domain_NamedDomainElement(bindings, this.entryLike$1.key__s_Option());
  return this.parseBindings__Lamf_core_model_domain_NamedDomainElement__Lorg_yaml_model_YMap__Lamf_core_model_domain_NamedDomainElement(bindings, map)
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$() {
  $c_O.call(this);
  this.nodes$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$ = this;
  var y = $m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$());
  var jsx$17 = new $c_T2().init___O__O("paths", y);
  var array = ["swagger", "info", "host", "basePath", "schemes", "consumes", "produces", "paths", "definitions", "parameters", "responses", "securityDefinitions", "security", "tags", "externalDocs"];
  if (($uI(array.length) === 0)) {
    var y$1 = $m_sci_Set$EmptySet$()
  } else {
    var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      b.$$plus$eq__O__scm_SetBuilder(arg1);
      i = ((1 + i) | 0)
    };
    var y$1 = b.elems$1
  };
  var jsx$16 = new $c_T2().init___O__O("webApi", y$1);
  var array$1 = ["title", "description", "termsOfService", "contact", "license", "version"];
  if (($uI(array$1.length) === 0)) {
    var y$2 = $m_sci_Set$EmptySet$()
  } else {
    var b$1 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$1 = 0;
    var len$1 = $uI(array$1.length);
    while ((i$1 < len$1)) {
      var index$1 = i$1;
      var arg1$1 = array$1[index$1];
      b$1.$$plus$eq__O__scm_SetBuilder(arg1$1);
      i$1 = ((1 + i$1) | 0)
    };
    var y$2 = b$1.elems$1
  };
  var jsx$15 = new $c_T2().init___O__O("info", y$2);
  var array$2 = ["name", "url", "email"];
  if (($uI(array$2.length) === 0)) {
    var y$3 = $m_sci_Set$EmptySet$()
  } else {
    var b$2 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$2 = 0;
    var len$2 = $uI(array$2.length);
    while ((i$2 < len$2)) {
      var index$2 = i$2;
      var arg1$2 = array$2[index$2];
      b$2.$$plus$eq__O__scm_SetBuilder(arg1$2);
      i$2 = ((1 + i$2) | 0)
    };
    var y$3 = b$2.elems$1
  };
  var jsx$14 = new $c_T2().init___O__O("contact", y$3);
  var array$3 = ["name", "url"];
  if (($uI(array$3.length) === 0)) {
    var y$4 = $m_sci_Set$EmptySet$()
  } else {
    var b$3 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$3 = 0;
    var len$3 = $uI(array$3.length);
    while ((i$3 < len$3)) {
      var index$3 = i$3;
      var arg1$3 = array$3[index$3];
      b$3.$$plus$eq__O__scm_SetBuilder(arg1$3);
      i$3 = ((1 + i$3) | 0)
    };
    var y$4 = b$3.elems$1
  };
  var jsx$13 = new $c_T2().init___O__O("license", y$4);
  var array$4 = ["attribute", "wrapped", "name", "namespace", "prefix"];
  if (($uI(array$4.length) === 0)) {
    var y$5 = $m_sci_Set$EmptySet$()
  } else {
    var b$4 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$4 = 0;
    var len$4 = $uI(array$4.length);
    while ((i$4 < len$4)) {
      var index$4 = i$4;
      var arg1$4 = array$4[index$4];
      b$4.$$plus$eq__O__scm_SetBuilder(arg1$4);
      i$4 = ((1 + i$4) | 0)
    };
    var y$5 = b$4.elems$1
  };
  var jsx$12 = new $c_T2().init___O__O("xmlSerialization", y$5);
  var array$5 = ["url", "description", "variables"];
  if (($uI(array$5.length) === 0)) {
    var y$6 = $m_sci_Set$EmptySet$()
  } else {
    var b$5 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$5 = 0;
    var len$5 = $uI(array$5.length);
    while ((i$5 < len$5)) {
      var index$5 = i$5;
      var arg1$5 = array$5[index$5];
      b$5.$$plus$eq__O__scm_SetBuilder(arg1$5);
      i$5 = ((1 + i$5) | 0)
    };
    var y$6 = b$5.elems$1
  };
  var jsx$11 = new $c_T2().init___O__O("server", y$6);
  var array$6 = ["enum", "default", "description"];
  if (($uI(array$6.length) === 0)) {
    var y$7 = $m_sci_Set$EmptySet$()
  } else {
    var b$6 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$6 = 0;
    var len$6 = $uI(array$6.length);
    while ((i$6 < len$6)) {
      var index$6 = i$6;
      var arg1$6 = array$6[index$6];
      b$6.$$plus$eq__O__scm_SetBuilder(arg1$6);
      i$6 = ((1 + i$6) | 0)
    };
    var y$7 = b$6.elems$1
  };
  var jsx$10 = new $c_T2().init___O__O("serverVariable", y$7);
  var array$7 = ["get", "put", "post", "delete", "options", "head", "patch", "connect", "trace", "parameters", "$ref"];
  if (($uI(array$7.length) === 0)) {
    var y$8 = $m_sci_Set$EmptySet$()
  } else {
    var b$7 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$7 = 0;
    var len$7 = $uI(array$7.length);
    while ((i$7 < len$7)) {
      var index$7 = i$7;
      var arg1$7 = array$7[index$7];
      b$7.$$plus$eq__O__scm_SetBuilder(arg1$7);
      i$7 = ((1 + i$7) | 0)
    };
    var y$8 = b$7.elems$1
  };
  var jsx$9 = new $c_T2().init___O__O("pathItem", y$8);
  var array$8 = ["tags", "summary", "description", "externalDocs", "operationId", "consumes", "produces", "parameters", "responses", "schemes", "deprecated", "security"];
  if (($uI(array$8.length) === 0)) {
    var y$9 = $m_sci_Set$EmptySet$()
  } else {
    var b$8 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$8 = 0;
    var len$8 = $uI(array$8.length);
    while ((i$8 < len$8)) {
      var index$8 = i$8;
      var arg1$8 = array$8[index$8];
      b$8.$$plus$eq__O__scm_SetBuilder(arg1$8);
      i$8 = ((1 + i$8) | 0)
    };
    var y$9 = b$8.elems$1
  };
  var jsx$8 = new $c_T2().init___O__O("operation", y$9);
  var array$9 = ["url", "description"];
  if (($uI(array$9.length) === 0)) {
    var y$10 = $m_sci_Set$EmptySet$()
  } else {
    var b$9 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$9 = 0;
    var len$9 = $uI(array$9.length);
    while ((i$9 < len$9)) {
      var index$9 = i$9;
      var arg1$9 = array$9[index$9];
      b$9.$$plus$eq__O__scm_SetBuilder(arg1$9);
      i$9 = ((1 + i$9) | 0)
    };
    var y$10 = b$9.elems$1
  };
  var jsx$7 = new $c_T2().init___O__O("externalDoc", y$10);
  var array$10 = ["name", "in", "description", "required", "type", "format", "allowEmptyValue", "items", "collectionFormat", "default", "maximum", "exclusiveMaximum", "minimum", "exclusiveMinimum", "maxLength", "minLength", "pattern", "maxItems", "minItems", "uniqueItems", "enum", "multipleOf", "deprecated", "example"];
  if (($uI(array$10.length) === 0)) {
    var y$11 = $m_sci_Set$EmptySet$()
  } else {
    var b$10 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$10 = 0;
    var len$10 = $uI(array$10.length);
    while ((i$10 < len$10)) {
      var index$10 = i$10;
      var arg1$10 = array$10[index$10];
      b$10.$$plus$eq__O__scm_SetBuilder(arg1$10);
      i$10 = ((1 + i$10) | 0)
    };
    var y$11 = b$10.elems$1
  };
  var jsx$6 = new $c_T2().init___O__O("parameter", y$11);
  var array$11 = ["name", "in", "description", "required", "schema"];
  if (($uI(array$11.length) === 0)) {
    var y$12 = $m_sci_Set$EmptySet$()
  } else {
    var b$11 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$11 = 0;
    var len$11 = $uI(array$11.length);
    while ((i$11 < len$11)) {
      var index$11 = i$11;
      var arg1$11 = array$11[index$11];
      b$11.$$plus$eq__O__scm_SetBuilder(arg1$11);
      i$11 = ((1 + i$11) | 0)
    };
    var y$12 = b$11.elems$1
  };
  var jsx$5 = new $c_T2().init___O__O("bodyParameter", y$12);
  var array$12 = ["description", "schema", "headers", "examples"];
  if (($uI(array$12.length) === 0)) {
    var y$13 = $m_sci_Set$EmptySet$()
  } else {
    var b$12 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$12 = 0;
    var len$12 = $uI(array$12.length);
    while ((i$12 < len$12)) {
      var index$12 = i$12;
      var arg1$12 = array$12[index$12];
      b$12.$$plus$eq__O__scm_SetBuilder(arg1$12);
      i$12 = ((1 + i$12) | 0)
    };
    var y$13 = b$12.elems$1
  };
  var jsx$4 = new $c_T2().init___O__O("response", y$13);
  var array$13 = ["description", "type", "items", "collectionFormat", "default", "maximum", "exclusiveMaximum", "minimum", "exclusiveMinimum", "maxLength", "minLength", "pattern", "maxItems", "minItems", "uniqueItems", "enum", "multipleOf"];
  if (($uI(array$13.length) === 0)) {
    var y$14 = $m_sci_Set$EmptySet$()
  } else {
    var b$13 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$13 = 0;
    var len$13 = $uI(array$13.length);
    while ((i$13 < len$13)) {
      var index$13 = i$13;
      var arg1$13 = array$13[index$13];
      b$13.$$plus$eq__O__scm_SetBuilder(arg1$13);
      i$13 = ((1 + i$13) | 0)
    };
    var y$14 = b$13.elems$1
  };
  var jsx$3 = new $c_T2().init___O__O("headerParameter", y$14);
  var array$14 = ["name", "description", "externalDocs"];
  if (($uI(array$14.length) === 0)) {
    var y$15 = $m_sci_Set$EmptySet$()
  } else {
    var b$14 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$14 = 0;
    var len$14 = $uI(array$14.length);
    while ((i$14 < len$14)) {
      var index$14 = i$14;
      var arg1$14 = array$14[index$14];
      b$14.$$plus$eq__O__scm_SetBuilder(arg1$14);
      i$14 = ((1 + i$14) | 0)
    };
    var y$15 = b$14.elems$1
  };
  var jsx$2 = new $c_T2().init___O__O("tag", y$15);
  var array$15 = ["$ref", "$schema", "format", "title", "description", "maximum", "exclusiveMaximum", "minimum", "exclusiveMinimum", "maxLength", "minLength", "pattern", "maxItems", "minItems", "uniqueItems", "maxProperties", "minProperties", "required", "enum", "type", "items", "additionalItems", "collectionFormat", "allOf", "properties", "additionalProperties", "discriminator", "readOnly", "xml", "externalDocs", "allOf", "anyOf", "not", "dependencies", "multipleOf", "default", "example", "id", "name", "patternProperties"];
  if (($uI(array$15.length) === 0)) {
    var y$16 = $m_sci_Set$EmptySet$()
  } else {
    var b$15 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$15 = 0;
    var len$15 = $uI(array$15.length);
    while ((i$15 < len$15)) {
      var index$15 = i$15;
      var arg1$15 = array$15[index$15];
      b$15.$$plus$eq__O__scm_SetBuilder(arg1$15);
      i$15 = ((1 + i$15) | 0)
    };
    var y$16 = b$15.elems$1
  };
  var jsx$1 = new $c_T2().init___O__O("schema", y$16);
  var array$16 = ["type", "description", "name", "in", "flow", "authorizationUrl", "tokenUrl", "scopes"];
  if (($uI(array$16.length) === 0)) {
    var y$17 = $m_sci_Set$EmptySet$()
  } else {
    var b$16 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$16 = 0;
    var len$16 = $uI(array$16.length);
    while ((i$16 < len$16)) {
      var index$16 = i$16;
      var arg1$16 = array$16[index$16];
      b$16.$$plus$eq__O__scm_SetBuilder(arg1$16);
      i$16 = ((1 + i$16) | 0)
    };
    var y$17 = b$16.elems$1
  };
  var array$17 = [jsx$17, jsx$16, jsx$15, jsx$14, jsx$13, jsx$12, jsx$11, jsx$10, jsx$9, jsx$8, jsx$7, jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, jsx$1, new $c_T2().init___O__O("securityScheme", y$17)];
  var this$91 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i$17 = 0;
  var len$17 = $uI(array$17.length);
  while ((i$17 < len$17)) {
    var index$17 = i$17;
    var arg1$17 = array$17[index$17];
    this$91.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1$17));
    i$17 = ((1 + i$17) | 0)
  };
  this.nodes$1 = $as_sci_Map(this$91.elems$1);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$.prototype.nodes__sci_Map = (function() {
  return this.nodes$1
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.Oas2Syntax$", {
  Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_SpecSyntax: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$;
var $n_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$ = new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$() {
  $c_O.call(this);
  this.nodes$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$ = this;
  var jsx$59 = $m_s_Predef$().Map$2;
  var y = $m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$());
  var jsx$58 = new $c_T2().init___O__O("paths", y);
  var jsx$56 = $m_s_Predef$().Set$2;
  var array = ["openapi", "info", "servers", "paths", "components", "security", "tags", "externalDocs"];
  var y$1 = jsx$56.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
  var jsx$57 = new $c_T2().init___O__O("webApi", y$1);
  var jsx$54 = $m_s_Predef$().Set$2;
  var array$1 = ["schemas", "responses", "parameters", "examples", "requestBodies", "headers", "securitySchemes", "links", "callbacks"];
  var y$2 = jsx$54.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
  var jsx$55 = new $c_T2().init___O__O("components", y$2);
  var jsx$52 = $m_s_Predef$().Set$2;
  var array$2 = ["title", "description", "termsOfService", "contact", "license", "version"];
  var y$3 = jsx$52.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2));
  var jsx$53 = new $c_T2().init___O__O("info", y$3);
  var jsx$50 = $m_s_Predef$().Set$2;
  var array$3 = ["name", "url", "email"];
  var y$4 = jsx$50.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$3));
  var jsx$51 = new $c_T2().init___O__O("contact", y$4);
  var jsx$48 = $m_s_Predef$().Set$2;
  var array$4 = ["name", "url"];
  var y$5 = jsx$48.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$4));
  var jsx$49 = new $c_T2().init___O__O("license", y$5);
  var jsx$46 = $m_s_Predef$().Set$2;
  var array$5 = ["attribute", "wrapped", "name", "namespace", "prefix"];
  var y$6 = jsx$46.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$5));
  var jsx$47 = new $c_T2().init___O__O("xmlSerialization", y$6);
  var jsx$44 = $m_s_Predef$().Set$2;
  var array$6 = ["get", "put", "post", "delete", "options", "head", "patch", "connect", "trace", "parameters", "servers", "summary", "description", "\\$ref"];
  var y$7 = jsx$44.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$6));
  var jsx$45 = new $c_T2().init___O__O("pathItem", y$7);
  var jsx$42 = $m_s_Predef$().Set$2;
  var array$7 = ["tags", "summary", "description", "externalDocs", "operationId", "parameters", "requestBody", "responses", "callbacks", "deprecated", "security", "servers"];
  var y$8 = jsx$42.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$7));
  var jsx$43 = new $c_T2().init___O__O("operation", y$8);
  var jsx$40 = $m_s_Predef$().Set$2;
  var array$8 = ["operationRef", "operationId", "description", "server", "parameters", "requestBody"];
  var y$9 = jsx$40.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$8));
  var jsx$41 = new $c_T2().init___O__O("link", y$9);
  var jsx$38 = $m_s_Predef$().Set$2;
  var array$9 = ["url", "description", "variables"];
  var y$10 = jsx$38.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$9));
  var jsx$39 = new $c_T2().init___O__O("server", y$10);
  var jsx$36 = $m_s_Predef$().Set$2;
  var array$10 = ["enum", "default", "description"];
  var y$11 = jsx$36.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$10));
  var jsx$37 = new $c_T2().init___O__O("serverVariable", y$11);
  var jsx$34 = $m_s_Predef$().Set$2;
  var array$11 = ["url", "description"];
  var y$12 = jsx$34.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$11));
  var jsx$35 = new $c_T2().init___O__O("externalDoc", y$12);
  var jsx$32 = $m_s_Predef$().Set$2;
  var array$12 = ["summary", "description", "value", "externalValue"];
  var y$13 = jsx$32.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$12));
  var jsx$33 = new $c_T2().init___O__O("example", y$13);
  var jsx$30 = $m_s_Predef$().Set$2;
  var array$13 = ["name", "in", "description", "required", "deprecated", "allowEmptyValue", "style", "explode", "allowReserved", "schema", "example", "examples", "content"];
  var y$14 = jsx$30.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$13));
  var jsx$31 = new $c_T2().init___O__O("parameter", y$14);
  var jsx$28 = $m_s_Predef$().Set$2;
  var array$14 = ["description", "required", "deprecated", "allowEmptyValue", "style", "explode", "allowReserved", "schema", "example", "examples", "content"];
  var y$15 = jsx$28.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$14));
  var jsx$29 = new $c_T2().init___O__O("header", y$15);
  var jsx$26 = $m_s_Predef$().Set$2;
  var array$15 = ["description", "content", "required"];
  var y$16 = jsx$26.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$15));
  var jsx$27 = new $c_T2().init___O__O("request", y$16);
  var jsx$24 = $m_s_Predef$().Set$2;
  var array$16 = ["name", "in", "description", "required", "schema"];
  var y$17 = jsx$24.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$16));
  var jsx$25 = new $c_T2().init___O__O("bodyParameter", y$17);
  var jsx$22 = $m_s_Predef$().Set$2;
  var array$17 = ["description", "content", "headers", "links"];
  var y$18 = jsx$22.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$17));
  var jsx$23 = new $c_T2().init___O__O("response", y$18);
  var jsx$20 = $m_s_Predef$().Set$2;
  var array$18 = ["schema", "example", "examples", "encoding"];
  var y$19 = jsx$20.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$18));
  var jsx$21 = new $c_T2().init___O__O("content", y$19);
  var jsx$18 = $m_s_Predef$().Set$2;
  var array$19 = ["contentType", "headers", "style", "explode", "allowReserved"];
  var y$20 = jsx$18.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$19));
  var jsx$19 = new $c_T2().init___O__O("encoding", y$20);
  var jsx$16 = $m_s_Predef$().Set$2;
  var array$20 = ["description", "type", "items", "collectionFormat", "default", "maximum", "exclusiveMaximum", "minimum", "exclusiveMinimum", "maxLength", "minLength", "pattern", "maxItems", "minItems", "uniqueItems", "enum", "multipleOf"];
  var y$21 = jsx$16.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$20));
  var jsx$17 = new $c_T2().init___O__O("headerParameter", y$21);
  var jsx$14 = $m_s_Predef$().Set$2;
  var array$21 = ["name", "description", "externalDocs"];
  var y$22 = jsx$14.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$21));
  var jsx$15 = new $c_T2().init___O__O("tag", y$22);
  var jsx$12 = $m_s_Predef$().Set$2;
  var array$22 = ["propertyName", "mapping"];
  var y$23 = jsx$12.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$22));
  var jsx$13 = new $c_T2().init___O__O("discriminator", y$23);
  var jsx$10 = $m_s_Predef$().Set$2;
  var array$23 = ["$ref", "$schema", "format", "title", "description", "maximum", "exclusiveMaximum", "minimum", "exclusiveMinimum", "maxLength", "minLength", "nullable", "pattern", "maxItems", "minItems", "uniqueItems", "maxProperties", "minProperties", "required", "enum", "type", "items", "additionalItems", "collectionFormat", "allOf", "properties", "additionalProperties", "discriminator", "readOnly", "writeOnly", "xml", "deprecated", "externalDocs", "allOf", "anyOf", "oneOf", "not", "dependencies", "multipleOf", "default", "example", "id", "name", "patternProperties"];
  var y$24 = jsx$10.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$23));
  var jsx$11 = new $c_T2().init___O__O("schema", y$24);
  var jsx$8 = $m_s_Predef$().Set$2;
  var array$24 = ["type", "description", "name", "in", "scheme", "bearerFormat", "flows", "openIdConnectUrl"];
  var y$25 = jsx$8.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$24));
  var jsx$9 = new $c_T2().init___O__O("securityScheme", y$25);
  var jsx$6 = $m_s_Predef$().Set$2;
  var array$25 = ["refreshUrl", "tokenUrl", "scopes"];
  var y$26 = jsx$6.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$25));
  var jsx$7 = new $c_T2().init___O__O("clientCredentials", y$26);
  var jsx$4 = $m_s_Predef$().Set$2;
  var array$26 = ["authorizationUrl", "refreshUrl", "scopes"];
  var y$27 = jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$26));
  var jsx$5 = new $c_T2().init___O__O("implicit", y$27);
  var jsx$2 = $m_s_Predef$().Set$2;
  var array$27 = ["refreshUrl", "tokenUrl", "scopes"];
  var y$28 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$27));
  var jsx$3 = new $c_T2().init___O__O("password", y$28);
  var jsx$1 = $m_s_Predef$().Set$2;
  var array$28 = ["authorizationUrl", "refreshUrl", "tokenUrl", "scopes"];
  var y$29 = jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$28));
  var array$29 = [jsx$58, jsx$57, jsx$55, jsx$53, jsx$51, jsx$49, jsx$47, jsx$45, jsx$43, jsx$41, jsx$39, jsx$37, jsx$35, jsx$33, jsx$31, jsx$29, jsx$27, jsx$25, jsx$23, jsx$21, jsx$19, jsx$17, jsx$15, jsx$13, jsx$11, jsx$9, jsx$7, jsx$5, jsx$3, new $c_T2().init___O__O("authorizationCode", y$29)];
  this.nodes$1 = $as_sci_Map(jsx$59.apply__sc_Seq__sc_GenMap(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$29)));
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$.prototype.nodes__sci_Map = (function() {
  return this.nodes$1
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.Oas3Syntax$", {
  Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_SpecSyntax: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$;
var $n_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$ = new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$() {
  $c_O.call(this);
  this.EndPointEmitter$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$.prototype.endpointEmitterWithPath__Lamf_plugins_domain_webapi_models_EndPoint__T__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext__Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter = (function(endpoint, path, ordering, references, spec) {
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1;
  $as_Lamf_plugins_domain_webapi_models_EndPoint($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(endpoint, field, path));
  return new $c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters__Lamf_plugins_domain_webapi_models_EndPoint__s_Option__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this, endpoint, new $c_s_Some().init___O(path), ordering, references, spec)
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasDocumentEmitter$", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$;
var $n_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$ = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings.call(this);
  this.types$2 = null;
  this.bitmap$0$2 = false
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings.prototype.init___Lamf_core_remote_Vendor.call(this, $m_Lamf_core_remote_Vendor$().OAS20$1);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$.prototype.types__sci_Map = (function() {
  return ((!this.bitmap$0$2) ? this.types$lzycompute__p2__sci_Map() : this.types$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$.prototype.mapsTo__T__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType = (function(text) {
  return $as_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType(this.types__sci_Map().getOrElse__O__F0__O(text, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, text$1) {
    return (function() {
      return new $c_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType().init___T(text$1)
    })
  })(this, text))))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$.prototype.types$lzycompute__p2__sci_Map = (function() {
  if ((!this.bitmap$0$2)) {
    var y = $m_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$().amf$plugins$document$webapi$parser$spec$oas$OasLikeSecuritySchemeTypeMappings$$OAuth20$1;
    var jsx$2 = new $c_T2().init___O__O("OAuth 2.0", y);
    var y$1 = $m_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$().amf$plugins$document$webapi$parser$spec$oas$OasLikeSecuritySchemeTypeMappings$$BasicAuth$1;
    var jsx$1 = new $c_T2().init___O__O("Basic Authentication", y$1);
    var y$2 = $m_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$().amf$plugins$document$webapi$parser$spec$oas$OasLikeSecuritySchemeTypeMappings$$ApiKeyOas$1;
    var array = [jsx$2, jsx$1, new $c_T2().init___O__O("Api Key", y$2)];
    var this$10 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      this$10.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
      i = ((1 + i) | 0)
    };
    this.types$2 = $as_sci_Map(this$10.elems$1);
    this.bitmap$0$2 = true
  };
  return this.types$2
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$;
var $n_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$ = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas2SchemeMappings$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings.call(this);
  this.types$2 = null;
  this.bitmap$0$2 = false
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings.prototype.init___Lamf_core_remote_Vendor.call(this, $m_Lamf_core_remote_Vendor$().OAS30$1);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$.prototype.types__sci_Map = (function() {
  return ((!this.bitmap$0$2) ? this.types$lzycompute__p2__sci_Map() : this.types$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$.prototype.mapsTo__T__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType = (function(text) {
  return $as_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType(this.types__sci_Map().getOrElse__O__F0__O(text, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, text$1) {
    return (function() {
      return new $c_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType().init___T(text$1)
    })
  })(this, text))))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$.prototype.types$lzycompute__p2__sci_Map = (function() {
  if ((!this.bitmap$0$2)) {
    var y = $m_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$().amf$plugins$document$webapi$parser$spec$oas$OasLikeSecuritySchemeTypeMappings$$OAuth20$1;
    var jsx$5 = new $c_T2().init___O__O("OAuth 2.0", y);
    var y$1 = $m_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$().amf$plugins$document$webapi$parser$spec$oas$OasLikeSecuritySchemeTypeMappings$$Http$1;
    var jsx$4 = new $c_T2().init___O__O("Basic Authentication", y$1);
    var y$2 = $m_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$().amf$plugins$document$webapi$parser$spec$oas$OasLikeSecuritySchemeTypeMappings$$Http$1;
    var jsx$3 = new $c_T2().init___O__O("Digest Authentication", y$2);
    var y$3 = $m_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$().amf$plugins$document$webapi$parser$spec$oas$OasLikeSecuritySchemeTypeMappings$$Http$1;
    var jsx$2 = new $c_T2().init___O__O("http", y$3);
    var y$4 = $m_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$().amf$plugins$document$webapi$parser$spec$oas$OasLikeSecuritySchemeTypeMappings$$OpenIdConnect$1;
    var jsx$1 = new $c_T2().init___O__O("openIdConnect", y$4);
    var y$5 = $m_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$().amf$plugins$document$webapi$parser$spec$oas$OasLikeSecuritySchemeTypeMappings$$ApiKeyOas$1;
    var array = [jsx$5, jsx$4, jsx$3, jsx$2, jsx$1, new $c_T2().init___O__O("Api Key", y$5)];
    var this$16 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      this$16.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
      i = ((1 + i) | 0)
    };
    this.types$2 = $as_sci_Map(this$16.elems$1);
    this.bitmap$0$2 = true
  };
  return this.types$2
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$SchemeMappings: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$;
var $n_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$ = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$Oas3SchemeMappings$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter() {
  $c_O.call(this);
  this.ReferencesEmitter$module$1 = null;
  this.ReferenceEmitter$module$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter.prototype.init___Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(spec) {
  this.spec$1 = spec;
  return this
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters() {
  $c_O.call(this);
  this.label$1 = null;
  this.exampleOption$1 = null;
  this.ordering$1 = null;
  this.extensions$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters.prototype.init___T__s_Option__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(label, exampleOption, ordering, extensions, references, spec) {
  this.label$1 = label;
  this.exampleOption$1 = exampleOption;
  this.ordering$1 = ordering;
  this.extensions$1 = extensions;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters.prototype.emitters__scm_ListBuffer = (function() {
  var em = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = this.exampleOption$1;
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var a = $as_Lamf_plugins_domain_shapes_models_Example(arg1);
    em.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter().init___T__Lamf_plugins_domain_shapes_models_Example__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.label$1, a, this.ordering$1, this.spec$1))
  };
  if (this.extensions$1.nonEmpty__Z()) {
    em.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(new $c_Lamf_core_utils_package$AmfStrings().init___T("examples").asOasExtension__T(), this.extensions$1, this.ordering$1, this.references$1, this.spec$1))
  };
  return em
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasExampleEmitters", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeExampleEmitters: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasExampleEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler() {
  $c_O.call(this);
  this.vendor$1 = null;
  this.plugin$1 = null;
  this.references$1 = null;
  this.linkRegex$1 = null
}
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype.constructor = $c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler;
/** @constructor */
function $h_Lamf_plugins_document_webapi_references_WebApiReferenceHandler() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype = $c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype;
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype.links__p1__Lorg_yaml_model_YPart__Lamf_core_parser_ParserContext__V = (function(part, ctx) {
  var x1 = this.vendor$1;
  if ((($m_Lamf_core_remote_Raml10$().name$1 === x1) || (($m_Lamf_core_remote_Raml08$().name$1 === x1) || ($m_Lamf_core_remote_Raml$().name$1 === x1)))) {
    this.ramlLinks__Lorg_yaml_model_YPart__Lamf_core_parser_ParserContext__V(part, ctx)
  } else if ((($m_Lamf_core_remote_Oas20$().name$1 === x1) || (($m_Lamf_core_remote_Oas30$().name$1 === x1) || ($m_Lamf_core_remote_AsyncApi20$().name$1 === x1)))) {
    this.oasLinks__Lorg_yaml_model_YPart__Lamf_core_parser_ParserContext__V(part, ctx)
  }
});
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype.checkInlined__p1__Lorg_yaml_model_YScalar__V = (function(scalar) {
  var str = $as_T(scalar.value$3);
  if ($m_Lamf_core_utils_package$MediaTypeMatcher$().isJson$extension__T__Z(str)) {
    var this$2 = this.linkRegex$1.findAllIn__jl_CharSequence__s_util_matching_Regex$MatchIterator(str);
    while (this$2.hasNext__Z()) {
      var arg1 = this$2.next__T();
      try {
        var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(arg1, "\"", 0);
        var this$5 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
        var thiz = $as_T($f_sc_IndexedSeqOptimized__last__O(this$5));
        var xs$1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "#", 0);
        var this$8 = new $c_scm_ArrayOps$ofRef().init___AO(xs$1);
        var link = $as_T($f_sc_IndexedSeqOptimized__head__O(this$8));
        if ((($uI(link.indexOf("<<")) === (-1)) && ($uI(link.indexOf(">>")) === (-1)))) {
          this.references$1.$$plus$eq__T__Lamf_core_parser_ReferenceKind__Lorg_yaml_model_YNode__V(link, $m_Lamf_core_parser_InferredLinkReference$(), $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(scalar, $m_Lorg_yaml_model_YType$().Str$1))
        }
      } catch (e) {
        var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
        if ((!(e$2 instanceof $c_jl_Exception))) {
          throw e
        }
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype.isRef__p1__Lorg_yaml_model_YMapEntry__Z = (function(entry) {
  var x1 = entry.key$2.value__Lorg_yaml_model_YValue();
  if ((x1 instanceof $c_Lorg_yaml_model_YScalar)) {
    var x2 = $as_Lorg_yaml_model_YScalar(x1);
    return (x2.text$3 === "$ref")
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype.update__Lamf_core_parser_ParsedReference__Lamf_core_CompilerContext__s_concurrent_ExecutionContext__s_concurrent_Future = (function(reference, compilerContext, executionContext) {
  var x1 = this.vendor$1;
  return (((($m_Lamf_core_remote_Raml10$().name$1 === x1) || (($m_Lamf_core_remote_Raml08$().name$1 === x1) || ($m_Lamf_core_remote_Raml$().name$1 === x1))) && (reference.unit$1 instanceof $c_Lamf_core_model_document_ExternalFragment)) ? this.handleRamlExternalFragment__p1__Lamf_core_parser_ParsedReference__Lamf_core_CompilerContext__s_concurrent_ExecutionContext__s_concurrent_Future(reference, compilerContext, executionContext) : $m_s_concurrent_Future$().successful__O__s_concurrent_Future(reference))
});
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype.handleRamlExternalFragment__p1__Lamf_core_parser_ParsedReference__Lamf_core_CompilerContext__s_concurrent_ExecutionContext__s_concurrent_Future = (function(reference, compilerContext, executionContext) {
  var x1 = this.resolveUnitDocument__p1__Lamf_core_parser_ParsedReference__Lamf_core_parser_ParserContext__s_util_Either(reference, compilerContext.parserContext$1);
  if ((x1 instanceof $c_s_util_Right)) {
    var x2 = $as_s_util_Right(x1);
    var document = $as_Lorg_yaml_model_YDocument(x2.value$2);
    var parsed = new $c_Lamf_core_parser_SyamlParsedDocument().init___Lorg_yaml_model_YDocument__s_Option(document, $m_s_None$());
    var refs = new $c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler().init___T__Lamf_plugins_document_webapi_BaseWebApiPlugin(this.vendor$1, this.plugin$1).collect__Lamf_core_parser_ParsedDocument__Lamf_core_parser_ParserContext__Lamf_core_parser_ReferenceCollector(parsed, compilerContext.parserContext$1);
    var updated = compilerContext.forReference__T__Z__s_concurrent_ExecutionContext__Lamf_core_CompilerContext(reference.unit$1.id__T(), false, executionContext);
    var jsx$5 = refs.toReferences__sc_Seq();
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, updated$1, executionContext$1, reference$1, compilerContext$1) {
      return (function(r$2) {
        var r = $as_Lamf_core_parser_Reference(r$2);
        var jsx$3 = r.refs$1;
        var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
          return (function(x$3$2) {
            var x$3 = $as_Lamf_core_parser_RefContainer(x$3$2);
            return x$3.node$1
          })
        })($this));
        var this$2 = $m_sc_Seq$();
        return r.resolve__Lamf_core_CompilerContext__sc_Seq__Z__s_concurrent_ExecutionContext__s_concurrent_Future(updated$1, $as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$2.ReusableCBFInstance$2)), true, executionContext$1).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, r$1, updated$1$1, executionContext$1$1, reference$1$1, compilerContext$1$1) {
          return (function(x0$1$2) {
            var x0$1 = $as_Lamf_core_parser_ReferenceResolutionResult(x0$1$2);
            if ((x0$1 !== null)) {
              var p2 = x0$1.exception$1;
              var p3 = x0$1.unit$1;
              var x = $m_s_None$();
              if (((x === p2) && (p3 instanceof $c_s_Some))) {
                var x4 = $as_s_Some(p3);
                var unit = $as_Lamf_core_model_document_BaseUnit(x4.value$2);
                var resolved = this$2$1.handleRamlExternalFragment__p1__Lamf_core_parser_ParsedReference__Lamf_core_CompilerContext__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_Lamf_core_parser_ParsedReference().init___Lamf_core_model_document_BaseUnit__Lamf_core_parser_Reference__s_Option(unit, r$1, $m_s_None$()), updated$1$1, executionContext$1$1);
                var bu = reference$1$1.unit$1;
                var jsx$4 = new $c_Lamf_core_TaggedReferences$BuReferenceTagger().init___Lamf_core_model_document_BaseUnit(bu);
                var this$5 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(unit);
                jsx$4.tagReference__T__Lamf_core_parser_Reference__Lamf_core_model_document_BaseUnit($as_T((this$5.isEmpty__Z() ? unit.id__T() : this$5.get__O())), r$1);
                return resolved.map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$2, reference$1$2, r$1$1, compilerContext$1$2) {
                  return (function(res$2) {
                    var res = $as_Lamf_core_parser_ParsedReference(res$2);
                    var this$6 = reference$1$2.unit$1;
                    var newRef = res.unit$1;
                    $f_Lamf_core_model_document_BaseUnit__addReference__Lamf_core_model_document_BaseUnit__V(this$6, newRef);
                    r$1$1.refs$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, res$1, compilerContext$1$3) {
                      return (function(refContainer$2) {
                        var refContainer = $as_Lamf_core_parser_RefContainer(refContainer$2);
                        var x1$1 = refContainer.node$1;
                        if ((x1$1 instanceof $c_Lorg_yaml_model_YNode$MutRef)) {
                          var x2$1 = $as_Lorg_yaml_model_YNode$MutRef(x1$1);
                          res$1.unit$1.references__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, compilerContext$1$4) {
                            return (function(u$2) {
                              var u = $as_Lamf_core_model_document_BaseUnit(u$2);
                              return compilerContext$1$4.parserContext$1.addSonRef__Lamf_core_model_document_BaseUnit__Lamf_core_parser_ParserContext(u)
                            })
                          })($this$2, compilerContext$1$3)));
                          x2$1.target$4 = res$1.ast$1
                        } else {
                          var id = $m_Lamf_validations_ParserSideValidations$().InvalidFragmentType$1;
                          compilerContext$1$3.violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lorg_yaml_model_YPart__V(id, "", "Cannot inline a fragment in a not mutable node", x1$1)
                        }
                      })
                    })(this$2$2, res, compilerContext$1$2)))
                  })
                })(this$2$1, reference$1$1, r$1, compilerContext$1$1)), executionContext$1$1)
              }
            };
            if ((x0$1 !== null)) {
              var p5 = x0$1.exception$1;
              if ((p5 instanceof $c_s_Some)) {
                return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$3$1) {
                  return (function() {
                    return $m_sci_Nil$()
                  })
                })(this$2$1)), executionContext$1$1)
              }
            };
            return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$4$1) {
              return (function() {
                return $m_sci_Nil$()
              })
            })(this$2$1)), executionContext$1$1)
          })
        })($this, r, updated$1, executionContext$1, reference$1, compilerContext$1)), executionContext$1)
      })
    })(this, updated, executionContext, reference, compilerContext));
    var this$7 = $m_sc_Seq$();
    var externals = $as_sc_Seq(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
    var jsx$6 = $m_s_concurrent_Future$();
    var this$8 = $m_sc_Seq$();
    return jsx$6.sequence__sc_TraversableOnce__scg_CanBuildFrom__s_concurrent_ExecutionContext__s_concurrent_Future(externals, this$8.ReusableCBFInstance$2, executionContext).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$3, document$1, reference$2) {
      return (function(x$4$2) {
        $as_sc_Seq(x$4$2);
        var x$1 = new $c_s_Some().init___O(document$1.node$2);
        var x$2 = reference$2.unit$1;
        var x$3$1 = reference$2.origin$1;
        return new $c_Lamf_core_parser_ParsedReference().init___Lamf_core_model_document_BaseUnit__Lamf_core_parser_Reference__s_Option(x$2, x$3$1, x$1)
      })
    })(this, document, reference)), executionContext)
  } else if ((x1 instanceof $c_s_util_Left)) {
    var x3 = $as_s_util_Left(x1);
    var raw = $as_T(x3.value$2);
    var jsx$8 = $m_s_concurrent_Future$();
    reference.unit$1.references__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$2, compilerContext$2) {
      return (function(u$2$1) {
        var u$1 = $as_Lamf_core_model_document_BaseUnit(u$2$1);
        return compilerContext$2.parserContext$1.addSonRef__Lamf_core_model_document_BaseUnit__Lamf_core_parser_ParserContext(u$1)
      })
    })(this, compilerContext)));
    var jsx$7 = $m_Lorg_yaml_model_YNode$();
    var this$9 = reference.unit$1;
    var this$10 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$9);
    var x$4$3 = new $c_s_Some().init___O(jsx$7.apply__T__T__Lorg_yaml_model_YNode(raw, $as_T((this$10.isEmpty__Z() ? "" : this$10.get__O()))));
    var x$5 = reference.unit$1;
    var x$6 = reference.origin$1;
    return jsx$8.successful__O__s_concurrent_Future(new $c_Lamf_core_parser_ParsedReference().init___Lamf_core_model_document_BaseUnit__Lamf_core_parser_Reference__s_Option(x$5, x$6, x$4$3))
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype.overlaysAndExtensions__p1__Lorg_yaml_model_YDocument__Lamf_core_parser_ParserContext__V = (function(document, ctx) {
  var this$1 = document.node$2;
  var evidence$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var x1 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$1, evidence$2);
  if ((x1 instanceof $c_s_util_Right)) {
    var x2 = $as_s_util_Right(x1);
    var map = $as_Lorg_yaml_model_YMap(x2.value$2);
    var x1$2 = this.vendor$1;
    var ext = (($m_Lamf_core_remote_Raml10$().name$1 === x1$2) ? new $c_s_Some().init___O("extends") : ((($m_Lamf_core_remote_Oas20$().name$1 === x1$2) || ($m_Lamf_core_remote_Oas30$().name$1 === x1$2)) ? new $c_s_Some().init___O("x-extends") : $m_s_None$()));
    if ((!ext.isEmpty__Z())) {
      var arg1 = ext.get__O();
      var u = $as_T(arg1);
      var this$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(u);
      if ((!this$3.isEmpty__Z())) {
        var arg1$1 = this$3.get__O();
        var entry = $as_Lorg_yaml_model_YMapEntry(arg1$1);
        var this$4 = entry.value$2;
        var x1$1 = this$4.tag__Lorg_yaml_model_YTag().tagType$3;
        var x = $m_Lorg_yaml_model_YType$().Map$1;
        if ((x === x1$1)) {
          var jsx$1 = true
        } else {
          var x$3 = $m_Lorg_yaml_model_YType$().Seq$1;
          if ((x$3 === x1$1)) {
            var jsx$1 = true
          } else {
            var x$5 = $m_Lorg_yaml_model_YType$().Null$1;
            var jsx$1 = (x$5 === x1$1)
          }
        };
        if (jsx$1) {
          var this$5 = ctx.eh$1;
          var specification = $m_Lamf_validations_ParserSideValidations$().InvalidExtensionsType$1;
          var message = ("Expected scalar but found: " + entry.value$2);
          var ast = entry.value$2;
          var prop = $m_s_None$();
          var l = ast.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$5, specification, "", prop, message, l)
        } else {
          this.extension__p1__Lorg_yaml_model_YMapEntry__V(entry)
        }
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype.hasDocumentAST__p1__Lamf_core_model_document_BaseUnit__Z = (function(other) {
  var this$1 = other.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_SourceAST.getClassOf());
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var x$6 = $as_Lamf_core_annotations_SourceAST(arg1);
    return (x$6.ast$1 instanceof $c_Lorg_yaml_model_YDocument)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype.oasInclude__p1__Lorg_yaml_model_YMap__Lamf_core_parser_ParserContext__V = (function(map, ctx) {
  var ref = $as_Lorg_yaml_model_YMapEntry(map.entries$3.head__O());
  var this$1 = ref.value$2;
  var x1 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Str$1;
  if ((x === x1)) {
    var jsx$1 = this.references$1;
    var this$2 = ref.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
    var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
    jsx$1.$$plus$eq__T__Lamf_core_parser_ReferenceKind__Lorg_yaml_model_YNode__V($as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv)), $m_Lamf_core_parser_LinkReference$(), ref.value$2)
  } else {
    var this$3 = ctx.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().UnexpectedReference$1;
    var message = ("Unexpected $ref with " + ref);
    var ast = ref.value$2;
    var prop = $m_s_None$();
    var l = ast.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$3, specification, "", prop, message, l)
  }
});
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype.libraries__p1__Lorg_yaml_model_YDocument__Lamf_core_parser_ParserContext__V = (function(document, ctx) {
  var evidence$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var x1 = document.obj__Lorg_yaml_model_YObj().to__Lorg_yaml_convert_YRead__s_util_Either(evidence$1);
  if ((x1 instanceof $c_s_util_Right)) {
    var x2 = $as_s_util_Right(x1);
    var map = $as_Lorg_yaml_model_YMap(x2.value$2);
    var x1$2 = this.vendor$1;
    var uses = (($m_Lamf_core_remote_Raml10$().name$1 === x1$2) ? new $c_s_Some().init___O("uses") : ((($m_Lamf_core_remote_Oas20$().name$1 === x1$2) || ($m_Lamf_core_remote_Oas30$().name$1 === x1$2)) ? new $c_s_Some().init___O("x-amf-uses") : $m_s_None$()));
    if ((!uses.isEmpty__Z())) {
      var arg1 = uses.get__O();
      var u = $as_T(arg1);
      var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(u);
      if ((!this$2.isEmpty__Z())) {
        var arg1$1 = this$2.get__O();
        var entry = $as_Lorg_yaml_model_YMapEntry(arg1$1);
        var this$3 = entry.value$2;
        var x1$1 = this$3.tag__Lorg_yaml_model_YTag().tagType$3;
        var x = $m_Lorg_yaml_model_YType$().Map$1;
        if ((x === x1$1)) {
          var this$4 = entry.value$2;
          var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
          var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
          $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ctx$2) {
            return (function(x$1$2) {
              var x$1 = $as_Lorg_yaml_model_YMapEntry(x$1$2);
              $this.library__p1__Lorg_yaml_model_YMapEntry__Lamf_core_parser_ParserContext__V(x$1, ctx$2)
            })
          })(this, ctx)))
        } else {
          var x$3 = $m_Lorg_yaml_model_YType$().Null$1;
          if ((!(x$3 === x1$1))) {
            var this$5 = ctx.eh$1;
            var specification = $m_Lamf_validation_DialectValidations$().InvalidModuleType$1;
            var message = ("Expected map but found: " + entry.value$2);
            var ast = entry.value$2;
            var prop = $m_s_None$();
            var l = ast.location$1;
            $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$5, specification, "", prop, message, l)
          }
        }
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype.ramlInclude__p1__Lorg_yaml_model_YNode__Lamf_core_parser_ParserContext__V = (function(node, ctx) {
  var x1 = node.value__Lorg_yaml_model_YValue();
  if ((x1 instanceof $c_Lorg_yaml_model_YScalar)) {
    var x2 = $as_Lorg_yaml_model_YScalar(x1);
    this.references$1.$$plus$eq__T__Lamf_core_parser_ReferenceKind__Lorg_yaml_model_YNode__V(x2.text$3, $m_Lamf_core_parser_LinkReference$(), node)
  } else {
    var this$1 = ctx.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().UnexpectedReference$1;
    var message = ("Unexpected !include with " + node.value__Lorg_yaml_model_YValue());
    var prop = $m_s_None$();
    var l = node.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, "", prop, message, l)
  }
});
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype.oasLinks__Lorg_yaml_model_YPart__Lamf_core_parser_ParserContext__V = (function(part, ctx) {
  matchEnd4: {
    if ((part instanceof $c_Lorg_yaml_model_YMap)) {
      var x2 = $as_Lorg_yaml_model_YMap(part);
      if (((x2.entries$3.size__I() === 1) && this.isRef__p1__Lorg_yaml_model_YMapEntry__Z($as_Lorg_yaml_model_YMapEntry(x2.entries$3.head__O())))) {
        this.oasInclude__p1__Lorg_yaml_model_YMap__Lamf_core_parser_ParserContext__V(x2, ctx);
        break matchEnd4
      }
    };
    part.children$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ctx$1) {
      return (function(c$2) {
        var c = $as_Lorg_yaml_model_YPart(c$2);
        $this.oasLinks__Lorg_yaml_model_YPart__Lamf_core_parser_ParserContext__V(c, ctx$1)
      })
    })(this, ctx)))
  }
});
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype.ramlLinks__Lorg_yaml_model_YPart__Lamf_core_parser_ParserContext__V = (function(part, ctx) {
  matchEnd5: {
    if ((part instanceof $c_Lorg_yaml_model_YNode)) {
      var x2 = $as_Lorg_yaml_model_YNode(part);
      var x = x2.tag__Lorg_yaml_model_YTag().tagType$3;
      var x$2 = $m_Lorg_yaml_model_YType$().Include$1;
      if ((x === x$2)) {
        this.ramlInclude__p1__Lorg_yaml_model_YNode__Lamf_core_parser_ParserContext__V(x2, ctx);
        break matchEnd5
      }
    };
    if ((part instanceof $c_Lorg_yaml_model_YScalar)) {
      var x3 = $as_Lorg_yaml_model_YScalar(part);
      if ($is_T(x3.value$3)) {
        this.checkInlined__p1__Lorg_yaml_model_YScalar__V(x3);
        break matchEnd5
      }
    };
    part.children$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ctx$1) {
      return (function(x$2$2$2) {
        var x$2$2 = $as_Lorg_yaml_model_YPart(x$2$2$2);
        $this.ramlLinks__Lorg_yaml_model_YPart__Lamf_core_parser_ParserContext__V(x$2$2, ctx$1)
      })
    })(this, ctx)))
  }
});
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype.library__p1__Lorg_yaml_model_YMapEntry__Lamf_core_parser_ParserContext__V = (function(entry, ctx) {
  var x1 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$().apply__Lorg_yaml_model_YMapEntry__Lamf_core_parser_ParserContext__s_Option(entry, ctx);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var location = $as_T(x2.value$2);
    this.references$1.$$plus$eq__T__Lamf_core_parser_ReferenceKind__Lorg_yaml_model_YNode__V(location, $m_Lamf_core_parser_LibraryReference$(), entry.value$2)
  } else {
    var this$1 = ctx.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().ModuleNotFound$1;
    var prop = $m_s_None$();
    var l = entry.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, "", prop, "Missing library location", l)
  }
});
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype.collect__Lamf_core_parser_ParsedDocument__Lamf_core_parser_ParserContext__Lamf_core_parser_ReferenceCollector = (function(parsed, ctx) {
  var doc = $as_Lamf_core_parser_SyamlParsedDocument(parsed).document$2;
  this.libraries__p1__Lorg_yaml_model_YDocument__Lamf_core_parser_ParserContext__V(doc, ctx);
  this.links__p1__Lorg_yaml_model_YPart__Lamf_core_parser_ParserContext__V(doc, ctx);
  if (this.isRamlOverlayOrExtension__T__Lamf_core_parser_ParsedDocument__Z(this.vendor$1, parsed)) {
    this.overlaysAndExtensions__p1__Lorg_yaml_model_YDocument__Lamf_core_parser_ParserContext__V(doc, ctx)
  };
  return this.references$1
});
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype.isRamlOverlayOrExtension__T__Lamf_core_parser_ParsedDocument__Z = (function(vendor, parsed) {
  var x1 = $as_Lamf_core_parser_SyamlParsedDocument(parsed).comment$2;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var c = $as_T(x2.value$2);
    var x1$2 = $m_Lamf_plugins_document_webapi_parser_RamlHeader$().fromText__T__s_Option(c);
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var p3 = $as_Lamf_plugins_document_webapi_parser_RamlHeader(x2$2.value$2);
      var x = $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$();
      if (x.equals__O__Z(p3)) {
        var jsx$1 = true
      } else {
        var x$3 = $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$();
        var jsx$1 = x$3.equals__O__Z(p3)
      };
      if ((jsx$1 && (vendor === $m_Lamf_core_remote_Raml10$().name$1))) {
        return true
      }
    };
    return false
  } else {
    var x$5 = $m_s_None$();
    if ((x$5 === x1)) {
      return false
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype.isRamlOrYaml__p1__Lamf_core_model_domain_ExternalDomainElement__Z = (function(encodes) {
  var jsx$1 = $as_Lamf_client_plugins_AMFDocumentPlugin(this.plugin$1).documentSyntaxes__sc_Seq();
  var this$1 = $as_Lamf_core_model_StrField(encodes.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().MediaType$1));
  var this$2 = this$1.option$1;
  return jsx$1.contains__O__Z($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())))
});
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype.resolveUnitDocument__p1__Lamf_core_parser_ParsedReference__Lamf_core_parser_ParserContext__s_util_Either = (function(reference, ctx) {
  var rc5 = false;
  var x2 = null;
  var x1 = reference.unit$1;
  if ((x1 instanceof $c_Lamf_core_model_document_ExternalFragment)) {
    rc5 = true;
    x2 = $as_Lamf_core_model_document_ExternalFragment(x1);
    var this$1 = x2;
    if (this.isRamlOrYaml__p1__Lamf_core_model_domain_ExternalDomainElement__Z($as_Lamf_core_model_domain_ExternalDomainElement($as_Lamf_core_model_domain_DomainElement(this$1.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))))) {
      $m_s_package$();
      var jsx$2 = $m_Lorg_yaml_parser_YamlParser$();
      var this$2 = x2;
      var this$3 = $as_Lamf_core_model_domain_ExternalDomainElement($as_Lamf_core_model_domain_DomainElement(this$2.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)));
      var this$4 = $as_Lamf_core_model_StrField(this$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1));
      var this$5 = this$4.option$1;
      var jsx$1 = $as_T((this$5.isEmpty__Z() ? null : this$5.get__O()));
      var this$6 = x2;
      var this$7 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$6);
      var this$8 = jsx$2.apply__jl_CharSequence__T__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_YamlParser(jsx$1, $as_T((this$7.isEmpty__Z() ? "" : this$7.get__O())), ctx.eh$1).withIncludeTag__T__Lorg_yaml_parser_YamlParser("!include");
      var value = $f_Lorg_yaml_parser_YParser__document__Lorg_yaml_model_YDocument(this$8);
      return new $c_s_util_Right().init___O(value)
    }
  };
  if (rc5) {
    $m_s_package$();
    var this$10 = x2;
    var this$11 = $as_Lamf_core_model_domain_ExternalDomainElement($as_Lamf_core_model_domain_DomainElement(this$10.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)));
    var this$12 = $as_Lamf_core_model_StrField(this$11.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1));
    var this$13 = this$12.option$1;
    var value$1 = $as_T((this$13.isEmpty__Z() ? null : this$13.get__O()));
    return new $c_s_util_Left().init___O(value$1)
  };
  if (this.hasDocumentAST__p1__Lamf_core_model_document_BaseUnit__Z(x1)) {
    $m_s_package$();
    var this$15 = x1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_SourceAST.getClassOf());
    if (this$15.isEmpty__Z()) {
      var jsx$3 = $m_s_None$()
    } else {
      var arg1 = this$15.get__O();
      var x$5 = $as_Lamf_core_annotations_SourceAST(arg1);
      var jsx$3 = new $c_s_Some().init___O($as_Lorg_yaml_model_YDocument(x$5.ast$1))
    };
    var value$2 = jsx$3.get__O();
    return new $c_s_util_Right().init___O(value$2)
  };
  $m_s_package$();
  return new $c_s_util_Left().init___O("")
});
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype.init___T__Lamf_plugins_document_webapi_BaseWebApiPlugin = (function(vendor, plugin) {
  this.vendor$1 = vendor;
  this.plugin$1 = plugin;
  this.references$1 = new $c_Lamf_core_parser_ReferenceCollector().init___();
  var this$2 = new $c_sci_StringOps().init___T("(\"\\$ref\":\\s*\".*\")");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.linkRegex$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  return this
});
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype.extension__p1__Lorg_yaml_model_YMapEntry__V = (function(entry) {
  var jsx$1 = this.references$1;
  var this$1 = entry.value$2;
  var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
  var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
  jsx$1.$$plus$eq__T__Lamf_core_parser_ReferenceKind__Lorg_yaml_model_YNode__V($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3, $m_Lamf_core_parser_ExtensionReference$(), entry.value$2)
});
var $d_Lamf_plugins_document_webapi_references_WebApiReferenceHandler = new $TypeData().initClass({
  Lamf_plugins_document_webapi_references_WebApiReferenceHandler: 0
}, false, "amf.plugins.document.webapi.references.WebApiReferenceHandler", {
  Lamf_plugins_document_webapi_references_WebApiReferenceHandler: 1,
  O: 1,
  Lamf_core_parser_ReferenceHandler: 1
});
$c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler.prototype.$classData = $d_Lamf_plugins_document_webapi_references_WebApiReferenceHandler;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline() {
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.call(this);
  this.baseSteps$2 = null;
  this.urlShortening$2 = false;
  this.steps$2 = null;
  this.ID$2 = null;
  this.bitmap$0$2 = false
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline.prototype = new $h_Lamf_core_resolution_pipelines_ResolutionPipeline();
$c_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler__Z = (function(eh, urlShortening) {
  this.urlShortening$2 = urlShortening;
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, eh);
  this.steps$2 = this.baseSteps__sc_Seq();
  this.ID$2 = $m_Lamf_core_resolution_pipelines_ResolutionPipeline$().EDITING$undPIPELINE$1;
  return this
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline.prototype.url__s_Option = (function() {
  return (this.urlShortening$2 ? new $c_s_Some().init___O(new $c_Lamf_core_resolution_stages_UrlShortenerStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1)) : $m_s_None$())
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline.prototype.steps__sc_Seq = (function() {
  return this.steps$2
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline.prototype.baseSteps$lzycompute__p2__sc_Seq = (function() {
  if ((!this.bitmap$0$2)) {
    var jsx$10 = $m_sc_Seq$();
    var jsx$9 = this.references__Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage();
    var jsx$8 = new $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionsResolutionStage().init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler(this.profileName__Lamf_ProfileName(), true, this.errorHandler$1);
    var jsx$7 = new $c_Lamf_plugins_domain_shapes_resolution_stages_ShapeNormalizationStage().init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler(this.profileName__Lamf_ProfileName(), true, this.errorHandler$1);
    var jsx$6 = new $c_Lamf_plugins_domain_webapi_resolution_stages_SecurityResolutionStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1);
    var jsx$5 = this.parameterNormalizationStage__Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage();
    var jsx$4 = new $c_Lamf_plugins_domain_webapi_resolution_stages_ServersNormalizationStage().init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler(this.profileName__Lamf_ProfileName(), true, this.errorHandler$1);
    var jsx$3 = new $c_Lamf_plugins_domain_webapi_resolution_stages_PathDescriptionNormalizationStage().init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler(this.profileName__Lamf_ProfileName(), true, this.errorHandler$1);
    var x$1 = this.profileName__Lamf_ProfileName();
    var array = [jsx$9, jsx$8, jsx$7, jsx$6, jsx$5, jsx$4, jsx$3, new $c_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage().init___Lamf_ProfileName__Z__Z__Lamf_core_errorhandling_ErrorHandler(x$1, false, true, this.errorHandler$1), new $c_Lamf_plugins_domain_webapi_resolution_stages_ResponseExamplesResolutionStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage().init___Lamf_ProfileName__Lamf_core_errorhandling_ErrorHandler(this.profileName__Lamf_ProfileName(), this.errorHandler$1)];
    var jsx$2 = $as_sc_TraversableLike(jsx$10.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
    var xo = this.url__s_Option();
    var jsx$1 = xo.toList__sci_List();
    var this$4 = $m_sc_Seq$();
    this.baseSteps$2 = $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2));
    this.bitmap$0$2 = true
  };
  return this.baseSteps$2
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline.prototype.baseSteps__sc_Seq = (function() {
  return ((!this.bitmap$0$2) ? this.baseSteps$lzycompute__p2__sc_Seq() : this.baseSteps$2)
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline() {
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.call(this);
  this.baseSteps$2 = null;
  this.steps$2 = null;
  this.bitmap$0$2 = false
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline.prototype = new $h_Lamf_core_resolution_pipelines_ResolutionPipeline();
$c_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline.prototype.steps__sc_Seq = (function() {
  return this.steps$2
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline.prototype.baseSteps$lzycompute__p2__sc_Seq = (function() {
  if ((!this.bitmap$0$2)) {
    var jsx$1 = $m_sc_Seq$();
    var array = [this.references__Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage(), new $c_Lamf_core_resolution_stages_ExternalSourceRemovalStage().init___scm_Set__Lamf_core_errorhandling_ErrorHandler($as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionsResolutionStage().init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler(this.profileName__Lamf_ProfileName(), false, this.errorHandler$1), new $c_Lamf_plugins_domain_shapes_resolution_stages_ShapeNormalizationStage().init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler(this.profileName__Lamf_ProfileName(), false, this.errorHandler$1), new $c_Lamf_plugins_domain_webapi_resolution_stages_SecurityResolutionStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), this.parameterNormalizationStage__Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage(), new $c_Lamf_plugins_domain_webapi_resolution_stages_ServersNormalizationStage().init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler(this.profileName__Lamf_ProfileName(), false, this.errorHandler$1), new $c_Lamf_plugins_domain_webapi_resolution_stages_PathDescriptionNormalizationStage().init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler(this.profileName__Lamf_ProfileName(), false, this.errorHandler$1), new $c_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage().init___Lamf_ProfileName__Z__Z__Lamf_core_errorhandling_ErrorHandler(this.profileName__Lamf_ProfileName(), false, false, this.errorHandler$1), new $c_Lamf_plugins_domain_webapi_resolution_stages_ResponseExamplesResolutionStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage().init___Lamf_ProfileName__Lamf_core_errorhandling_ErrorHandler(this.profileName__Lamf_ProfileName(), this.errorHandler$1), new $c_Lamf_core_resolution_stages_CleanReferencesStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_core_resolution_stages_DeclarationsRemovalStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1)];
    this.baseSteps$2 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
    this.bitmap$0$2 = true
  };
  return this.baseSteps$2
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline.prototype.baseSteps__sc_Seq = (function() {
  return ((!this.bitmap$0$2) ? this.baseSteps$lzycompute__p2__sc_Seq() : this.baseSteps$2)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(eh) {
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, eh);
  this.steps$2 = this.baseSteps__sc_Seq();
  return this
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline() {
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.call(this);
  this.baseSteps$2 = null;
  this.profile$2 = null;
  this.steps$2 = null;
  this.bitmap$0$2 = false
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline.prototype = new $h_Lamf_core_resolution_pipelines_ResolutionPipeline();
$c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline.prototype.steps__sc_Seq = (function() {
  return this.steps$2
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline.prototype.baseSteps$lzycompute__p2__sc_Seq = (function() {
  if ((!this.bitmap$0$2)) {
    var jsx$1 = $m_sc_Seq$();
    var array = [new $c_Lamf_core_resolution_stages_ReferenceResolutionStage().init___Z__Lamf_core_errorhandling_ErrorHandler(false, this.errorHandler$1), new $c_Lamf_core_resolution_stages_ExternalSourceRemovalStage().init___scm_Set__Lamf_core_errorhandling_ErrorHandler($as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionsResolutionStage().init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler(this.profile$2, false, this.errorHandler$1), new $c_Lamf_plugins_domain_shapes_resolution_stages_ShapeNormalizationStage().init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler(this.profile$2, false, this.errorHandler$1), new $c_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage().init___Lamf_ProfileName__Z__Z__Lamf_core_errorhandling_ErrorHandler(this.profile$2, true, false, this.errorHandler$1), new $c_Lamf_plugins_domain_webapi_resolution_stages_ResponseExamplesResolutionStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage().init___Lamf_ProfileName__Lamf_core_errorhandling_ErrorHandler(this.profile$2, this.errorHandler$1)];
    this.baseSteps$2 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
    this.bitmap$0$2 = true
  };
  return this.baseSteps$2
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline.prototype.baseSteps__sc_Seq = (function() {
  return ((!this.bitmap$0$2) ? this.baseSteps$lzycompute__p2__sc_Seq() : this.baseSteps$2)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline.prototype.init___Lamf_ProfileName__Lamf_core_errorhandling_ErrorHandler = (function(profile, eh) {
  this.profile$2 = profile;
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, eh);
  this.steps$2 = this.baseSteps__sc_Seq();
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.ValidationResolutionPipeline", {
  Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline: 1,
  Lamf_core_resolution_pipelines_ResolutionPipeline: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_CompatibilityPipeline() {
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.call(this);
  this.targetProfile$2 = null;
  this.steps$2 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_CompatibilityPipeline.prototype = new $h_Lamf_core_resolution_pipelines_ResolutionPipeline();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_CompatibilityPipeline.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_CompatibilityPipeline;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_CompatibilityPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_CompatibilityPipeline.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_CompatibilityPipeline.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_CompatibilityPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_ProfileName = (function(eh, targetProfile) {
  this.targetProfile$2 = targetProfile;
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, eh);
  var x1 = this.targetProfile$2;
  var x = $m_Lamf_RamlProfile$();
  if (x.equals__O__Z(x1)) {
    var jsx$2 = true
  } else {
    var x$3 = $m_Lamf_Raml10Profile$();
    if (x$3.equals__O__Z(x1)) {
      var jsx$2 = true
    } else {
      var x$5 = $m_Lamf_Raml08Profile$();
      var jsx$2 = x$5.equals__O__Z(x1)
    }
  };
  if (jsx$2) {
    var jsx$1 = new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_RamlCompatibilityPipeline().init___Lamf_core_errorhandling_ErrorHandler(eh).steps$2
  } else {
    var x$7 = $m_Lamf_Oas30Profile$();
    if (x$7.equals__O__Z(x1)) {
      var jsx$1 = new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_Oas3CompatibilityPipeline().init___Lamf_core_errorhandling_ErrorHandler(eh).steps$2
    } else {
      var x$9 = $m_Lamf_OasProfile$();
      if (x$9.equals__O__Z(x1)) {
        var jsx$3 = true
      } else {
        var x$11 = $m_Lamf_Oas20Profile$();
        var jsx$3 = x$11.equals__O__Z(x1)
      };
      if (jsx$3) {
        var jsx$1 = new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_OasCompatibilityPipeline().init___Lamf_core_errorhandling_ErrorHandler(eh).steps$2
      } else {
        var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
        var property = $m_s_None$();
        var lexical = $m_s_None$();
        var location = $m_s_None$();
        eh.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, "", property, "No compatibility pipeline registered to target profile", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
        var jsx$1 = $m_sci_Nil$()
      }
    }
  };
  this.steps$2 = jsx$1;
  return this
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_CompatibilityPipeline.prototype.steps__sc_Seq = (function() {
  return this.steps$2
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_CompatibilityPipeline = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_CompatibilityPipeline: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.CompatibilityPipeline", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_CompatibilityPipeline: 1,
  Lamf_core_resolution_pipelines_ResolutionPipeline: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_CompatibilityPipeline.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_CompatibilityPipeline;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_Oas3CompatibilityPipeline() {
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.call(this);
  this.resolution$2 = null;
  this.steps$2 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_Oas3CompatibilityPipeline.prototype = new $h_Lamf_core_resolution_pipelines_ResolutionPipeline();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_Oas3CompatibilityPipeline.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_Oas3CompatibilityPipeline;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_Oas3CompatibilityPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_Oas3CompatibilityPipeline.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_Oas3CompatibilityPipeline.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_Oas3CompatibilityPipeline.prototype.steps__sc_Seq = (function() {
  return this.steps$2
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_Oas3CompatibilityPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(eh) {
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, eh);
  this.resolution$2 = new $c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ResolutionPipeline().init___Lamf_core_errorhandling_ErrorHandler(eh);
  var jsx$3 = this.resolution$2.steps$3;
  var jsx$2 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanNullSecurity().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanSchemes().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryDocumentationUrl().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryResponses().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryPathParameters().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_AddItemsToArrayType().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1)];
  var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
  var this$3 = $m_sc_Seq$();
  this.steps$2 = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_Oas3CompatibilityPipeline = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_Oas3CompatibilityPipeline: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.Oas3CompatibilityPipeline", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_Oas3CompatibilityPipeline: 1,
  Lamf_core_resolution_pipelines_ResolutionPipeline: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_Oas3CompatibilityPipeline.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_Oas3CompatibilityPipeline;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_OasCompatibilityPipeline() {
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.call(this);
  this.resolution$2 = null;
  this.steps$2 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_OasCompatibilityPipeline.prototype = new $h_Lamf_core_resolution_pipelines_ResolutionPipeline();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_OasCompatibilityPipeline.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_OasCompatibilityPipeline;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_OasCompatibilityPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_OasCompatibilityPipeline.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_OasCompatibilityPipeline.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_OasCompatibilityPipeline.prototype.steps__sc_Seq = (function() {
  return this.steps$2
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_OasCompatibilityPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(eh) {
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, eh);
  this.resolution$2 = new $c_Lamf_plugins_document_webapi_resolution_pipelines_OasResolutionPipeline().init___Lamf_core_errorhandling_ErrorHandler(eh);
  var jsx$3 = this.resolution$2.steps$2;
  var jsx$2 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_LowercaseSchemes().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_Oas20SecuritySettingsMapper().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryDocumentationUrl().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryResponses().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryPathParameters().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanNullSecurity().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanParameterExamples().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanIdenticalExamples().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1)];
  var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
  var this$3 = $m_sc_Seq$();
  this.steps$2 = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_OasCompatibilityPipeline = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_OasCompatibilityPipeline: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.OasCompatibilityPipeline", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_OasCompatibilityPipeline: 1,
  Lamf_core_resolution_pipelines_ResolutionPipeline: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_OasCompatibilityPipeline.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_OasCompatibilityPipeline;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_RamlCompatibilityPipeline() {
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.call(this);
  this.steps$2 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_RamlCompatibilityPipeline.prototype = new $h_Lamf_core_resolution_pipelines_ResolutionPipeline();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_RamlCompatibilityPipeline.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_RamlCompatibilityPipeline;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_RamlCompatibilityPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_RamlCompatibilityPipeline.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_RamlCompatibilityPipeline.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_RamlCompatibilityPipeline.prototype.steps__sc_Seq = (function() {
  return this.steps$2
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_RamlCompatibilityPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(eh) {
  $c_Lamf_core_resolution_pipelines_ResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, eh);
  var jsx$1 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryAnnotationType().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultPayloadMediaType().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryCreativeWorkFields().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultToNumericDefaultResponse().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeExamplesOptional().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CapitalizeSchemes().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SecuritySettingsMapper().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ShapeFormatAdjuster().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CustomAnnotationDeclaration().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PushSingleOperationPathParams().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_UnionsAsTypeExpressions().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_EscapeTypeNames().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeRequiredFieldImplicitForOptionalProperties().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveRamlCompatibleDeclarations().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveLinksWithNonDeclaredTargets().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_domain_webapi_resolution_stages_RamlCompatiblePayloadAndParameterResolutionStage().init___Lamf_ProfileName__Lamf_core_errorhandling_ErrorHandler($m_Lamf_RamlProfile$(), this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_RecursionDetection().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1)];
  this.steps$2 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_RamlCompatibilityPipeline = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_RamlCompatibilityPipeline: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.RamlCompatibilityPipeline", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_RamlCompatibilityPipeline: 1,
  Lamf_core_resolution_pipelines_ResolutionPipeline: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_RamlCompatibilityPipeline.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_RamlCompatibilityPipeline;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_AmfElementLinkResolutionStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_AmfElementLinkResolutionStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_AmfElementLinkResolutionStage.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_AmfElementLinkResolutionStage;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_AmfElementLinkResolutionStage() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_AmfElementLinkResolutionStage.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_AmfElementLinkResolutionStage.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_AmfElementLinkResolutionStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  if ((model instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(model);
    var resolver = new $c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution().init___Lamf_core_errorhandling_ErrorHandler__Z__s_Option__scm_Map__F2(this.errorHandler__Lamf_core_errorhandling_ErrorHandler(), ($m_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$(), false), ($m_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$(), $m_s_None$()), ($m_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$(), $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()))), $m_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$().$$lessinit$greater$default$5__F2());
    var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
    var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
    var this$3 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(x2, strategy, fieldsFilter);
    while (this$3.hasNext__Z()) {
      var arg1 = this$3.next__Lamf_core_model_domain_AmfElement();
      if ($is_Lamf_core_model_domain_DomainElement(arg1)) {
        var x2$1 = $as_Lamf_core_model_domain_DomainElement(arg1);
        var this$4 = x2$1.fields__Lamf_core_parser_Fields();
        var this$7 = this$4.fs$1;
        var this$5 = $m_Lamf_core_parser_FieldEntry$();
        var f = $f_F2__tupled__F1(this$5);
        var this$6 = $m_sci_Iterable$();
        var bf = this$6.ReusableCBFInstance$2;
        $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$7, f, bf)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x2$1$1, resolver$1, x2$2) {
          return (function(f$2) {
            var f$1 = $as_Lamf_core_parser_FieldEntry(f$2);
            var x1 = f$1.value$1.value$1;
            if ($is_Lamf_core_model_domain_Linkable(x1)) {
              var x2$3 = $as_Lamf_core_model_domain_Linkable(x1);
              if (($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x2$3).isDefined__Z() && $this.selector__Lamf_core_model_domain_Linkable__Lamf_core_model_document_BaseUnit__Z(x2$3, x2$1$1))) {
                var jsx$2 = $as_Lamf_core_model_domain_DomainElement(x2$3);
                var jsx$1 = $m_sc_Seq$();
                var array = [$m_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$().ASSERT$undDIFFERENT$1];
                var x1$2 = resolver$1.transform__Lamf_core_model_domain_DomainElement__sc_Seq__s_Option(jsx$2, $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))));
                if ((x1$2 instanceof $c_s_Some)) {
                  var x2$3$1 = $as_s_Some(x1$2);
                  var resolved = $as_Lamf_core_model_domain_DomainElement(x2$3$1.value$2);
                  return x2$2.fields__Lamf_core_parser_Fields().setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(f$1.field$1, resolved, (x2$2.fields__Lamf_core_parser_Fields(), $m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
                } else {
                  var x = $m_s_None$();
                  if ((x === x1$2)) {
                    return (void 0)
                  } else {
                    throw new $c_s_MatchError().init___O(x1$2)
                  }
                }
              }
            };
            if ((x1 instanceof $c_Lamf_core_model_domain_AmfArray)) {
              var x3 = $as_Lamf_core_model_domain_AmfArray(x1);
              var jsx$6 = x3.values$1;
              var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, x2$1$2, resolver$1$1) {
                return (function(x0$2$2) {
                  var x0$2 = $as_Lamf_core_model_domain_AmfElement(x0$2$2);
                  if ($is_Lamf_core_model_domain_Linkable(x0$2)) {
                    var x2$4 = $as_Lamf_core_model_domain_Linkable(x0$2);
                    if (($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x2$4).isDefined__Z() && $this$1.selector__Lamf_core_model_domain_Linkable__Lamf_core_model_document_BaseUnit__Z(x2$4, x2$1$2))) {
                      var jsx$5 = $as_Lamf_core_model_domain_DomainElement(x2$4);
                      var jsx$4 = $m_sc_Seq$();
                      var array$1 = [$m_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$().ASSERT$undDIFFERENT$1];
                      var this$14 = resolver$1$1.transform__Lamf_core_model_domain_DomainElement__sc_Seq__s_Option(jsx$5, $as_sc_Seq(jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1))));
                      return $as_Lamf_core_model_domain_AmfElement((this$14.isEmpty__Z() ? x2$4 : this$14.get__O()))
                    }
                  };
                  return x0$2
                })
              })($this, x2$1$1, resolver$1));
              var this$15 = $m_sc_Seq$();
              var newItems = $as_sc_Seq(jsx$6.map__F1__scg_CanBuildFrom__O(jsx$3, this$15.ReusableCBFInstance$2));
              var jsx$8 = x2$2.fields__Lamf_core_parser_Fields();
              var jsx$7 = f$1.field$1;
              var annotations = x3.annotations$1;
              return jsx$8.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(jsx$7, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(newItems, annotations), (x2$2.fields__Lamf_core_parser_Fields(), $m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
            }
          })
        })(this, x2, resolver, x2$1)))
      } else {
        throw new $c_s_MatchError().init___O(arg1)
      }
    }
  };
  return model
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_SecuritySettingsMapper() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_SecuritySettingsMapper.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_SecuritySettingsMapper.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_SecuritySettingsMapper;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_SecuritySettingsMapper() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_SecuritySettingsMapper.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_SecuritySettingsMapper.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_SecuritySettingsMapper.prototype.fixApiKey__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_domain_webapi_models_security_ApiKeySettings__V = (function(security, apiKey) {
  if ($as_sc_Seq(security.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().QueryParameters$1)).nonEmpty__Z()) {
    var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().In$1;
    $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(apiKey, field, "query"));
    var this$1 = $as_Lamf_core_model_domain_NamedDomainElement($as_sc_Seq(security.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().QueryParameters$1)).head__O());
    var this$2 = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(this$1.nameField__Lamf_core_metamodel_Field()));
    var this$3 = this$2.option$1;
    var name = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().Name$1;
    $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(apiKey, field$1, name))
  } else if ($as_sc_Seq(security.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Headers$1)).nonEmpty__Z()) {
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().In$1;
    $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(apiKey, field$2, "header"));
    var this$4 = $as_Lamf_core_model_domain_NamedDomainElement($as_sc_Seq(security.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Headers$1)).head__O());
    var this$5 = $as_Lamf_core_model_StrField(this$4.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(this$4.nameField__Lamf_core_metamodel_Field()));
    var this$6 = this$5.option$1;
    var name$1 = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
    var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().Name$1;
    $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(apiKey, field$3, name$1))
  } else {
    var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().In$1;
    $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(apiKey, field$4, "query"));
    var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().Name$1;
    $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(apiKey, field$5, ""))
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_SecuritySettingsMapper.prototype.fixSettings__p2__Lamf_core_model_document_DeclaresModel__V = (function(d) {
  d.declares__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_domain_DomainElement(x0$1$2);
      if ((x0$1 instanceof $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme)) {
        var x2 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(x0$1);
        $this.fixSettings__p2__Lamf_plugins_domain_webapi_models_security_SecurityScheme__V(x2)
      }
    })
  })(this)))
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_SecuritySettingsMapper.prototype.fixSettings__p2__Lamf_plugins_domain_webapi_models_security_SecurityScheme__V = (function(security) {
  var x1 = $as_Lamf_plugins_domain_webapi_models_security_Settings(security.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1));
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(x1);
    this.fixOauth2__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__V(x2)
  } else if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings)) {
    var x3 = $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(x1);
    this.fixApiKey__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_domain_webapi_models_security_ApiKeySettings__V(security, x3)
  } else {
    if ((x1 === null)) {
      var this$1 = $as_Lamf_core_model_StrField(security.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1)).option$1;
      var x = (this$1.isEmpty__Z() ? "" : this$1.get__O());
      var jsx$1 = ((x !== null) && $objectEquals(x, "x-amf-apiKey"))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      this.fixApiKey__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_domain_webapi_models_security_ApiKeySettings__V(security, security.withApiKeySettings__Lamf_plugins_domain_webapi_models_security_ApiKeySettings())
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_SecuritySettingsMapper.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  if ($is_Lamf_core_model_document_DeclaresModel(model)) {
    try {
      this.fixSettings__p2__Lamf_core_model_document_DeclaresModel__V($as_Lamf_core_model_document_DeclaresModel(model))
    } catch (e) {
      var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
      if ((e$2 === null)) {
        throw e
      }
    };
    return model
  } else {
    return model
  }
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_AddItemsToArrayType() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_AddItemsToArrayType.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_AddItemsToArrayType.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_AddItemsToArrayType;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_AddItemsToArrayType() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_AddItemsToArrayType.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_AddItemsToArrayType.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_AddItemsToArrayType.prototype.setArrayType__p2__Lamf_plugins_domain_shapes_models_ArrayShape__V = (function(array) {
  var x1 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(array.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1)));
  var x = $m_s_None$();
  if ((x === x1)) {
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var fields = new $c_Lamf_core_parser_Fields().init___();
    array.withItems__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_ArrayShape(new $c_Lamf_plugins_domain_shapes_models_AnyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations))
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_AddItemsToArrayType.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  try {
    var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
    var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
    var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
    while (this$1.hasNext__Z()) {
      var arg1 = this$1.next__Lamf_core_model_domain_AmfElement();
      if ((arg1 instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
        var x2 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(arg1);
        this.setArrayType__p2__Lamf_plugins_domain_shapes_models_ArrayShape__V(x2)
      }
    };
    return model
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      return model
    } else {
      throw e
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_AddItemsToArrayType.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_AddItemsToArrayType = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_AddItemsToArrayType: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.oas3.AddItemsToArrayType", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_AddItemsToArrayType: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_AddItemsToArrayType.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_AddItemsToArrayType;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanNullSecurity() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanNullSecurity.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanNullSecurity.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanNullSecurity;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanNullSecurity() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanNullSecurity.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanNullSecurity.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanNullSecurity.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  try {
    var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
    var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
    var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
    while (this$1.hasNext__Z()) {
      var arg1 = this$1.next__Lamf_core_model_domain_AmfElement();
      if ((arg1 instanceof $c_Lamf_plugins_domain_webapi_models_Operation)) {
        var x2 = $as_Lamf_plugins_domain_webapi_models_Operation(arg1);
        var isNull = new $c_sr_BooleanRef().init___Z(false);
        $as_sc_Seq(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Security$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, isNull$1) {
          return (function(requirement$2) {
            var requirement = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(requirement$2);
            var schemes = $as_sc_Seq($as_sc_Seq(requirement.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$().Schemes$1)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, isNull$1$1) {
              return (function(securityScheme$2) {
                var securityScheme = $as_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme(securityScheme$2);
                if ((!securityScheme.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_NullSecurity.getClassOf()))) {
                  return true
                } else {
                  isNull$1$1.elem$1 = true;
                  return false
                }
              })
            })($this, isNull$1))));
            var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$().Schemes$1;
            return $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(requirement, field, schemes))
          })
        })(this, isNull)));
        if (isNull.elem$1) {
          $m_Lamf_core_parser_Annotations$();
          var annotations = new $c_Lamf_core_parser_Annotations().init___();
          var this$6 = new $c_Lamf_core_model_domain_extensions_DomainExtension().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
          var field$1 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1;
          var this$9 = $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$6, field$1, "optionalSecurity"));
          var this$7 = $m_Lamf_core_model_domain_ScalarNode$();
          var dataType = new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Boolean$1);
          var extension = this$7.apply__T__s_Option__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode("true", dataType, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
          var field$2 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1;
          var extensions = $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$9, field$2, extension));
          var field$3 = $m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field();
          $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(x2, field$3, extensions))
        }
      }
    };
    return model
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      return model
    } else {
      throw e
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanNullSecurity.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanNullSecurity = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanNullSecurity: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.oas3.CleanNullSecurity", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanNullSecurity: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanNullSecurity.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanNullSecurity;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds.prototype.isRepeated__p2__T2__Z = (function(tuple) {
  return ($as_sc_SeqLike(tuple.$$und2__O()).size__I() > 1)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds.prototype.addDistinctOperationIds__p2__sc_Seq__V = (function(operations) {
  var this$1 = $m_sc_Seq$();
  $as_sc_IterableLike(operations.zipWithIndex__scg_CanBuildFrom__O(this$1.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var operation = $as_Lamf_plugins_domain_webapi_models_Operation(x0$1.$$und1__O());
        var index = x0$1.$$und2$mcI$sp__I();
        var jsx$1 = $m_s_Predef$any2stringadd$();
        var self = $as_Lamf_core_model_StrField(operation.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Name$1));
        var name = jsx$1.$$plus$extension__O__T__T(self, ("_" + index));
        $m_Lamf_core_parser_Annotations$();
        var a = new $c_Lamf_core_parser_Annotations().init___();
        return $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(operation, name, a))
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this)))
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds.prototype.getOperationsFromModel__p2__Lamf_core_model_document_BaseUnit__sc_Seq = (function(model) {
  var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
  var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
  var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
  var pf = new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds$$anonfun$getOperationsFromModel$1().init___Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds(this);
  var this$2 = new $c_sc_Iterator$$anon$13().init___sc_Iterator__s_PartialFunction(this$1, pf);
  return $f_sc_Iterator__toStream__sci_Stream(this$2)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds.prototype.operationsWithRepeatedIds__p2__sc_Seq__sc_Seq = (function(operations) {
  return $as_sc_MapLike($as_sc_TraversableLike(operations.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2) {
      var x = $as_Lamf_plugins_domain_webapi_models_Operation(x$2);
      return $as_Lamf_core_model_StrField(x.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Name$1)).option$1.isDefined__Z()
    })
  })(this)))).groupBy__F1__sci_Map(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_plugins_domain_webapi_models_Operation(x$1$2);
      var this$1 = $as_Lamf_core_model_StrField(x$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Name$1));
      var this$3 = this$1.option$1;
      return $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()))
    })
  })(this))).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(tuple$2) {
      var tuple = $as_T2(tuple$2);
      return this$3$1.isRepeated__p2__T2__Z(tuple)
    })
  })(this)))).values__sc_Iterable().toSeq__sc_Seq()
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  try {
    var operations = this.getOperationsFromModel__p2__Lamf_core_model_document_BaseUnit__sc_Seq(model);
    var repeatedOperationIds = this.operationsWithRepeatedIds__p2__sc_Seq__sc_Seq(operations);
    repeatedOperationIds.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(operations$2$2) {
        var operations$2 = $as_sc_Seq(operations$2$2);
        $this.addDistinctOperationIds__p2__sc_Seq__V(operations$2)
      })
    })(this)));
    return model
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      return model
    } else {
      throw e
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.oas3.CleanRepeatedOperationIds", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanSchemes() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanSchemes.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanSchemes.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanSchemes;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanSchemes() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanSchemes.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanSchemes.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanSchemes.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  try {
    var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
    var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
    var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
    while (this$1.hasNext__Z()) {
      var arg1 = this$1.next__Lamf_core_model_domain_AmfElement();
      if ((arg1 instanceof $c_Lamf_plugins_domain_webapi_models_Operation)) {
        var x2 = $as_Lamf_plugins_domain_webapi_models_Operation(arg1);
        x2.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Schemes$1)
      } else if ((arg1 instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)) {
        var x3 = $as_Lamf_plugins_domain_webapi_models_WebApi(arg1);
        x3.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Schemes$1)
      }
    };
    return model
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      return model
    } else {
      throw e
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanSchemes.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanSchemes = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanSchemes: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.oas3.CleanSchemes", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanSchemes: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanSchemes.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanSchemes;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryDocumentationUrl() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this);
  this.tagCounter$2 = 0
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryDocumentationUrl.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryDocumentationUrl.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryDocumentationUrl;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryDocumentationUrl() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryDocumentationUrl.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryDocumentationUrl.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryDocumentationUrl.prototype.ensureDocumentationUrl__p2__Lamf_plugins_domain_webapi_models_WebApi__V = (function(api) {
  $as_sc_Seq(api.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Documentations$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(documentation$2) {
      var documentation = $as_Lamf_plugins_domain_shapes_models_CreativeWork(documentation$2);
      var this$1 = $as_Lamf_core_model_StrField(documentation.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Url$1));
      if ($f_Lamf_core_model_StrField__isNullOrEmpty__Z(this$1)) {
        var field = $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Url$1;
        return $as_Lamf_plugins_domain_shapes_models_CreativeWork($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(documentation, field, "http://"))
      } else {
        return (void 0)
      }
    })
  })(this)))
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryDocumentationUrl.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  if ((model instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(model);
    if ((x2.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)) {
      try {
        this.ensureDocumentationUrl__p2__Lamf_plugins_domain_webapi_models_WebApi__V($as_Lamf_plugins_domain_webapi_models_WebApi(x2.encodes__Lamf_core_model_domain_DomainElement()))
      } catch (e) {
        var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
        if ((e$2 === null)) {
          throw e
        }
      };
      return model
    }
  };
  return model
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryDocumentationUrl.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  this.tagCounter$2 = 0;
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryDocumentationUrl = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryDocumentationUrl: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.oas3.MandatoryDocumentationUrl", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryDocumentationUrl: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryDocumentationUrl.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryDocumentationUrl;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryPathParameters() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryPathParameters.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryPathParameters.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryPathParameters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryPathParameters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryPathParameters.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryPathParameters.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryPathParameters.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  try {
    var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
    var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
    var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
    while (this$1.hasNext__Z()) {
      var arg1 = this$1.next__Lamf_core_model_domain_AmfElement();
      matchEnd4: {
        if ((arg1 instanceof $c_Lamf_plugins_domain_webapi_models_Parameter)) {
          var x2 = $as_Lamf_plugins_domain_webapi_models_Parameter(arg1);
          var this$2 = $as_Lamf_core_model_StrField(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
          if ($f_Lamf_core_model_ValueField__is__O__Z(this$2, "path")) {
            var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1;
            $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(x2, field, true));
            break matchEnd4
          }
        }
      }
    };
    return model
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 instanceof $c_jl_Exception)) {
      return model
    } else {
      throw e
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryPathParameters.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryPathParameters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryPathParameters: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.oas3.MandatoryPathParameters", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryPathParameters: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryPathParameters.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryPathParameters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryResponses() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryResponses.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryResponses.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryResponses;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryResponses() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryResponses.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryResponses.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryResponses.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  try {
    var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
    var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
    var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
    while (this$1.hasNext__Z()) {
      var arg1 = this$1.next__Lamf_core_model_domain_AmfElement();
      if ((arg1 instanceof $c_Lamf_plugins_domain_webapi_models_Operation)) {
        var x2 = $as_Lamf_plugins_domain_webapi_models_Operation(arg1);
        if ($as_sc_Seq(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1)).isEmpty__Z()) {
          var jsx$1 = $m_sc_Seq$();
          $m_Lamf_core_parser_Annotations$();
          var annotations = new $c_Lamf_core_parser_Annotations().init___();
          var qual$1 = new $c_Lamf_plugins_domain_webapi_models_Response().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
          $m_Lamf_core_parser_Annotations$();
          var x$2 = new $c_Lamf_core_parser_Annotations().init___();
          var this$6 = $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, "200", x$2));
          var field = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1;
          var this$7 = $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$6, field, "200"));
          var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Description$1;
          var array = [$as_Lamf_plugins_domain_webapi_models_Response($as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$7, field$1, "")))];
          var responses = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
          var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1;
          $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(x2, field$2, responses))
        }
      }
    };
    return model
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 instanceof $c_jl_Exception)) {
      return model
    } else {
      throw e
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryResponses.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryResponses = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryResponses: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.oas3.MandatoryResponses", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryResponses: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryResponses.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_MandatoryResponses;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanIdenticalExamples() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanIdenticalExamples.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanIdenticalExamples.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanIdenticalExamples;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanIdenticalExamples() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanIdenticalExamples.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanIdenticalExamples.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanIdenticalExamples.prototype.cleanExamples__Lamf_plugins_domain_shapes_models_AnyShape__V = (function(shape) {
  var uniqueExamples = $as_sc_MapLike($as_sc_TraversableOnce($as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(e$2) {
      var e = $as_Lamf_plugins_domain_shapes_models_Example(e$2);
      return $as_Lamf_core_model_StrField(e.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1)).option$1.isDefined__Z()
    })
  })(this)))).foldLeft__O__F2__O($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$2) {
    return (function(acc$2, curr$2) {
      var acc = $as_sci_Map(acc$2);
      var curr = $as_Lamf_plugins_domain_shapes_models_Example(curr$2);
      var this$1 = $as_Lamf_core_model_StrField(curr.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1));
      var this$3 = this$1.option$1;
      var this$4 = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
      var this$5 = $m_sjsr_RuntimeString$().hashCode__T__I(this$4);
      return acc.updated__O__O__sci_Map(("" + this$5), curr)
    })
  })(this)))).values__sc_Iterable();
  var field = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Examples$1;
  var values = uniqueExamples.toSeq__sc_Seq();
  $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(shape, field, values)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanIdenticalExamples.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  try {
    var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
    var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
    var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
    while (this$1.hasNext__Z()) {
      var arg1 = this$1.next__Lamf_core_model_domain_AmfElement();
      if ((arg1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
        var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1);
        this.cleanExamples__Lamf_plugins_domain_shapes_models_AnyShape__V(x2)
      }
    };
    return model
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      return model
    } else {
      throw e
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanIdenticalExamples.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanIdenticalExamples = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanIdenticalExamples: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.oas.CleanIdenticalExamples", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanIdenticalExamples: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanIdenticalExamples.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanIdenticalExamples;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanNullSecurity() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanNullSecurity.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanNullSecurity.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanNullSecurity;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanNullSecurity() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanNullSecurity.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanNullSecurity.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanNullSecurity.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  try {
    var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
    var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
    var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
    while (this$1.hasNext__Z()) {
      var arg1 = this$1.next__Lamf_core_model_domain_AmfElement();
      if ((arg1 instanceof $c_Lamf_plugins_domain_webapi_models_Operation)) {
        var x2 = $as_Lamf_plugins_domain_webapi_models_Operation(arg1);
        var isNull = new $c_sr_BooleanRef().init___Z(false);
        $as_sc_Seq(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Security$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, isNull$1) {
          return (function(requirement$2) {
            var requirement = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(requirement$2);
            var schemes = $as_sc_Seq($as_sc_Seq(requirement.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$().Schemes$1)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, isNull$1$1) {
              return (function(securityScheme$2) {
                var securityScheme = $as_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme(securityScheme$2);
                if ((!securityScheme.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_NullSecurity.getClassOf()))) {
                  return true
                } else {
                  isNull$1$1.elem$1 = true;
                  return false
                }
              })
            })($this, isNull$1))));
            var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$().Schemes$1;
            return $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(requirement, field, schemes))
          })
        })(this, isNull)));
        if (isNull.elem$1) {
          $m_Lamf_core_parser_Annotations$();
          var annotations = new $c_Lamf_core_parser_Annotations().init___();
          var this$6 = new $c_Lamf_core_model_domain_extensions_DomainExtension().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
          var field$1 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1;
          var this$9 = $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$6, field$1, "optionalSecurity"));
          var this$7 = $m_Lamf_core_model_domain_ScalarNode$();
          var dataType = new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Boolean$1);
          var extension = this$7.apply__T__s_Option__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode("true", dataType, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
          var field$2 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1;
          var extensions = $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$9, field$2, extension));
          var field$3 = $m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field();
          $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(x2, field$3, extensions))
        }
      }
    };
    return model
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      return model
    } else {
      throw e
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanNullSecurity.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanNullSecurity = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanNullSecurity: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.oas.CleanNullSecurity", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanNullSecurity: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanNullSecurity.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanNullSecurity;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanParameterExamples() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanParameterExamples.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanParameterExamples.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanParameterExamples;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanParameterExamples() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanParameterExamples.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanParameterExamples.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanParameterExamples.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  try {
    var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
    var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
    var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
    while (this$1.hasNext__Z()) {
      var arg1 = this$1.next__Lamf_core_model_domain_AmfElement();
      if ((arg1 instanceof $c_Lamf_plugins_domain_webapi_models_Parameter)) {
        var x2 = $as_Lamf_plugins_domain_webapi_models_Parameter(arg1);
        var this$2 = $as_Lamf_core_model_StrField(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1)).option$1;
        if (this$2.isEmpty__Z()) {
          var jsx$1 = true
        } else {
          var arg1$1 = this$2.get__O();
          var x$1 = $as_T(arg1$1);
          var jsx$1 = (!($as_T(x$1.toLowerCase()) === $as_T("body".toLowerCase())))
        };
        if (jsx$1) {
          var this$6 = this$2
        } else {
          var this$6 = $m_s_None$()
        };
        if (this$6.isEmpty__Z()) {
          var this$7 = $m_s_None$()
        } else {
          var arg1$2 = this$6.get__O();
          $as_T(arg1$2);
          var this$7 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1)))
        };
        if ((!this$7.isEmpty__Z())) {
          var arg1$3 = this$7.get__O();
          var x$3 = $as_Lamf_core_model_domain_Shape(arg1$3);
          new $c_s_Some().init___O(x$3.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Examples$1))
        }
      }
    };
    return model
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      return model
    } else {
      throw e
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanParameterExamples.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanParameterExamples = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanParameterExamples: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.oas.CleanParameterExamples", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanParameterExamples: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanParameterExamples.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_CleanParameterExamples;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_LowercaseSchemes() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_LowercaseSchemes.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_LowercaseSchemes.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_LowercaseSchemes;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_LowercaseSchemes() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_LowercaseSchemes.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_LowercaseSchemes.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_LowercaseSchemes.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  if ((model instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(model);
    if ((x2.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)) {
      try {
        var api = $as_Lamf_plugins_domain_webapi_models_WebApi(x2.encodes__Lamf_core_model_domain_DomainElement());
        this.capitalizeProtocols__p2__Lamf_core_model_domain_DomainElement__sc_Seq__Lamf_core_metamodel_Field__O(api, $as_sc_Seq(api.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Schemes$1)), $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Schemes$1);
        var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
        var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
        var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
        while (this$1.hasNext__Z()) {
          var arg1 = this$1.next__Lamf_core_model_domain_AmfElement();
          if ((arg1 instanceof $c_Lamf_plugins_domain_webapi_models_Operation)) {
            var x2$1 = $as_Lamf_plugins_domain_webapi_models_Operation(arg1);
            this.capitalizeProtocols__p2__Lamf_core_model_domain_DomainElement__sc_Seq__Lamf_core_metamodel_Field__O(x2$1, $as_sc_Seq(x2$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Schemes$1)), $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Schemes$1)
          }
        }
      } catch (e) {
        var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
        if ((e$2 === null)) {
          throw e
        }
      };
      return model
    }
  };
  return model
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_LowercaseSchemes.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_LowercaseSchemes.prototype.capitalizeProtocols__p2__Lamf_core_model_domain_DomainElement__sc_Seq__Lamf_core_metamodel_Field__O = (function(element, schemes, field) {
  var jsx$1 = $m_sc_Seq$();
  var array = ["HTTP", "HTTPS"];
  var valid = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_StrField(x$1$2);
      var xo = x$1.option$1;
      return xo.toList__sci_List()
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  var jsx$3 = $as_sc_TraversableLike($as_sc_TraversableLike(schemes.flatMap__F1__scg_CanBuildFrom__O(jsx$4, this$4.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, valid$1) {
    return (function(scheme$2) {
      var scheme = $as_T(scheme$2);
      return valid$1.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, scheme$1) {
        return (function(x$1$2$1) {
          var x$1$1 = $as_T(x$1$2$1);
          return ($as_T(scheme$1.toLowerCase()) === ((x$1$1 === null) ? null : $as_T(x$1$1.toLowerCase())))
        })
      })(this$2$1, scheme)))
    })
  })(this, valid))));
  var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x$2$2) {
      var x$2 = $as_T(x$2$2);
      return $as_T(x$2.toLowerCase())
    })
  })(this));
  var this$9 = $m_sc_Seq$();
  var s = $as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$9.ReusableCBFInstance$2));
  element.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields(field);
  return (s.nonEmpty__Z() ? $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(element, field, s) : (void 0))
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_LowercaseSchemes = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_LowercaseSchemes: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.oas.LowercaseSchemes", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_LowercaseSchemes: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_LowercaseSchemes.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_LowercaseSchemes;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryDocumentationUrl() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this);
  this.tagCounter$2 = 0
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryDocumentationUrl.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryDocumentationUrl.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryDocumentationUrl;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryDocumentationUrl() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryDocumentationUrl.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryDocumentationUrl.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryDocumentationUrl.prototype.ensureDocumentationUrl__p2__Lamf_plugins_domain_webapi_models_WebApi__V = (function(api) {
  $as_sc_Seq(api.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Documentations$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(documentation$2) {
      var documentation = $as_Lamf_plugins_domain_shapes_models_CreativeWork(documentation$2);
      var this$1 = $as_Lamf_core_model_StrField(documentation.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Url$1));
      if ($f_Lamf_core_model_StrField__isNullOrEmpty__Z(this$1)) {
        var field = $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Url$1;
        return $as_Lamf_plugins_domain_shapes_models_CreativeWork($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(documentation, field, "http://"))
      } else {
        return (void 0)
      }
    })
  })(this)))
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryDocumentationUrl.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  if ((model instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(model);
    if ((x2.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)) {
      try {
        this.ensureDocumentationUrl__p2__Lamf_plugins_domain_webapi_models_WebApi__V($as_Lamf_plugins_domain_webapi_models_WebApi(x2.encodes__Lamf_core_model_domain_DomainElement()))
      } catch (e) {
        var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
        if ((e$2 === null)) {
          throw e
        }
      };
      return model
    }
  };
  return model
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryDocumentationUrl.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  this.tagCounter$2 = 0;
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryDocumentationUrl = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryDocumentationUrl: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.oas.MandatoryDocumentationUrl", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryDocumentationUrl: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryDocumentationUrl.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryDocumentationUrl;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryPathParameters() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryPathParameters.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryPathParameters.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryPathParameters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryPathParameters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryPathParameters.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryPathParameters.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryPathParameters.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  try {
    var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
    var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
    var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
    while (this$1.hasNext__Z()) {
      var arg1 = this$1.next__Lamf_core_model_domain_AmfElement();
      matchEnd4: {
        if ((arg1 instanceof $c_Lamf_plugins_domain_webapi_models_Parameter)) {
          var x2 = $as_Lamf_plugins_domain_webapi_models_Parameter(arg1);
          var this$2 = $as_Lamf_core_model_StrField(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
          if ($f_Lamf_core_model_ValueField__is__O__Z(this$2, "path")) {
            var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1;
            $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(x2, field, true));
            break matchEnd4
          }
        }
      }
    };
    return model
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 instanceof $c_jl_Exception)) {
      return model
    } else {
      throw e
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryPathParameters.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryPathParameters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryPathParameters: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.oas.MandatoryPathParameters", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryPathParameters: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryPathParameters.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryPathParameters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryResponses() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryResponses.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryResponses.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryResponses;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryResponses() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryResponses.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryResponses.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryResponses.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  try {
    var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
    var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
    var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
    while (this$1.hasNext__Z()) {
      var arg1 = this$1.next__Lamf_core_model_domain_AmfElement();
      if ((arg1 instanceof $c_Lamf_plugins_domain_webapi_models_Operation)) {
        var x2 = $as_Lamf_plugins_domain_webapi_models_Operation(arg1);
        if ($as_sc_Seq(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1)).isEmpty__Z()) {
          var jsx$1 = $m_sc_Seq$();
          $m_Lamf_core_parser_Annotations$();
          var annotations = new $c_Lamf_core_parser_Annotations().init___();
          var qual$1 = new $c_Lamf_plugins_domain_webapi_models_Response().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
          $m_Lamf_core_parser_Annotations$();
          var x$2 = new $c_Lamf_core_parser_Annotations().init___();
          var this$6 = $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, "200", x$2));
          var field = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1;
          var this$7 = $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$6, field, "200"));
          var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Description$1;
          var array = [$as_Lamf_plugins_domain_webapi_models_Response($as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$7, field$1, "")))];
          var responses = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
          var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1;
          $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(x2, field$2, responses))
        }
      }
    };
    return model
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 instanceof $c_jl_Exception)) {
      return model
    } else {
      throw e
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryResponses.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryResponses = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryResponses: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.oas.MandatoryResponses", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryResponses: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryResponses.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_MandatoryResponses;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CapitalizeSchemes() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CapitalizeSchemes.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CapitalizeSchemes.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CapitalizeSchemes;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CapitalizeSchemes() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CapitalizeSchemes.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CapitalizeSchemes.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CapitalizeSchemes.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  if ((model instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(model);
    if ((x2.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)) {
      try {
        var api = $as_Lamf_plugins_domain_webapi_models_WebApi(x2.encodes__Lamf_core_model_domain_DomainElement());
        this.capitalizeProtocols__p2__Lamf_core_model_domain_DomainElement__sc_Seq__Lamf_core_metamodel_Field__O(api, $as_sc_Seq(api.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Schemes$1)), $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Schemes$1);
        var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
        var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
        var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
        while (this$1.hasNext__Z()) {
          var arg1 = this$1.next__Lamf_core_model_domain_AmfElement();
          if ((arg1 instanceof $c_Lamf_plugins_domain_webapi_models_Operation)) {
            var x2$1 = $as_Lamf_plugins_domain_webapi_models_Operation(arg1);
            this.capitalizeProtocols__p2__Lamf_core_model_domain_DomainElement__sc_Seq__Lamf_core_metamodel_Field__O(x2$1, $as_sc_Seq(x2$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Schemes$1)), $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Schemes$1)
          }
        }
      } catch (e) {
        var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
        if ((e$2 === null)) {
          throw e
        }
      };
      return model
    }
  };
  return model
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CapitalizeSchemes.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CapitalizeSchemes.prototype.capitalizeProtocols__p2__Lamf_core_model_domain_DomainElement__sc_Seq__Lamf_core_metamodel_Field__O = (function(element, schemes, field) {
  var jsx$1 = $m_sc_Seq$();
  var array = ["http", "https"];
  var valid = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_StrField(x$1$2);
      var xo = x$1.option$1;
      return xo.toList__sci_List()
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  var jsx$3 = $as_sc_TraversableLike($as_sc_TraversableLike(schemes.flatMap__F1__scg_CanBuildFrom__O(jsx$4, this$4.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, valid$1) {
    return (function(scheme$2) {
      var scheme = $as_T(scheme$2);
      return valid$1.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, scheme$1) {
        return (function(x$1$2$1) {
          var x$1$1 = $as_T(x$1$2$1);
          return ($as_T(scheme$1.toLowerCase()) === ((x$1$1 === null) ? null : $as_T(x$1$1.toLowerCase())))
        })
      })(this$2$1, scheme)))
    })
  })(this, valid))));
  var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x$2$2) {
      var x$2 = $as_T(x$2$2);
      return $as_T(x$2.toUpperCase())
    })
  })(this));
  var this$9 = $m_sc_Seq$();
  var s = $as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$9.ReusableCBFInstance$2));
  element.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields(field);
  return (s.nonEmpty__Z() ? $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(element, field, s) : (void 0))
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CapitalizeSchemes = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CapitalizeSchemes: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.CapitalizeSchemes", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CapitalizeSchemes: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CapitalizeSchemes.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CapitalizeSchemes;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CustomAnnotationDeclaration() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CustomAnnotationDeclaration.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CustomAnnotationDeclaration.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CustomAnnotationDeclaration;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CustomAnnotationDeclaration() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CustomAnnotationDeclaration.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CustomAnnotationDeclaration.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CustomAnnotationDeclaration.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  try {
    var this$11 = $m_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$().ramlKnownAnnotations$1;
    var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(name$2) {
        var name = $as_T(name$2);
        $m_Lamf_core_parser_Annotations$();
        var annotations = new $c_Lamf_core_parser_Annotations().init___();
        var qual$1 = new $c_Lamf_core_model_domain_extensions_CustomDomainProperty().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
        var x$1 = ("amf-" + name);
        $m_Lamf_core_parser_Annotations$();
        var x$2 = new $c_Lamf_core_parser_Annotations().init___();
        var this$9 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, x$1, x$2));
        $m_Lamf_core_parser_Annotations$();
        var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
        var fields = new $c_Lamf_core_parser_Fields().init___();
        var schema = new $c_Lamf_plugins_domain_shapes_models_AnyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations$1);
        var field = $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Schema$1;
        return $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$9, field, schema))
      })
    })(this));
    var this$10 = $m_sci_Set$();
    var bf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$10);
    var annotationsTypes = $as_sci_Set($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$11, f, bf));
    return ($is_Lamf_core_model_document_DeclaresModel(model) ? (annotationsTypes.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, x2) {
      return (function(element$2) {
        var element = $as_Lamf_core_model_domain_DomainElement(element$2);
        var this$12 = $as_Lamf_core_model_document_DeclaresModel(x2);
        var field$1 = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
        return $as_Lamf_core_model_document_BaseUnit($as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$12, field$1, element)))
      })
    })(this, model))), model) : model)
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      return model
    } else {
      throw e
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CustomAnnotationDeclaration.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CustomAnnotationDeclaration = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CustomAnnotationDeclaration: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.CustomAnnotationDeclaration", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CustomAnnotationDeclaration: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CustomAnnotationDeclaration.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CustomAnnotationDeclaration;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultPayloadMediaType() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultPayloadMediaType.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultPayloadMediaType.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultPayloadMediaType;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultPayloadMediaType() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultPayloadMediaType.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultPayloadMediaType.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultPayloadMediaType.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  try {
    var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
    var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
    var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
    while (this$1.hasNext__Z()) {
      var arg1 = this$1.next__Lamf_core_model_domain_AmfElement();
      matchEnd4: {
        if ((arg1 instanceof $c_Lamf_plugins_domain_webapi_models_Payload)) {
          var x2 = $as_Lamf_plugins_domain_webapi_models_Payload(arg1);
          var this$2 = $as_Lamf_core_model_StrField(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1));
          if ($f_Lamf_core_model_StrField__isNullOrEmpty__Z(this$2)) {
            var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1;
            $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x2, field, "*/*"));
            break matchEnd4
          }
        }
      }
    }
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 === null)) {
      throw e
    }
  };
  return model
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultPayloadMediaType.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultPayloadMediaType = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultPayloadMediaType: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.DefaultPayloadMediaType", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultPayloadMediaType: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultPayloadMediaType.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultPayloadMediaType;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultToNumericDefaultResponse() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultToNumericDefaultResponse.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultToNumericDefaultResponse.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultToNumericDefaultResponse;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultToNumericDefaultResponse() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultToNumericDefaultResponse.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultToNumericDefaultResponse.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultToNumericDefaultResponse.prototype.checkDefaultResponse__Lamf_plugins_domain_webapi_models_Operation__V = (function(operation) {
  var x1 = $as_sc_Seq(operation.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_plugins_domain_webapi_models_Response(x$1$2);
      var this$1 = $as_Lamf_core_model_StrField(x$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1));
      var this$2 = this$1.option$1;
      return ($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())) === "default")
    })
  })(this)));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var defaultResponse = $as_Lamf_plugins_domain_webapi_models_Response(x2.value$2);
    var responsesMap = $as_sci_Map($as_sc_Seq(operation.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1)).foldLeft__O__F2__O($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$2$1) {
      return (function(x0$1$2, x1$1$2) {
        var x0$1 = $as_sci_Map(x0$1$2);
        var x1$1 = $as_Lamf_plugins_domain_webapi_models_Response(x1$1$2);
        var this$3 = $as_Lamf_core_model_StrField(x1$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1));
        var this$4 = this$3.option$1;
        return x0$1.updated__O__O__sci_Map($as_T((this$4.isEmpty__Z() ? null : this$4.get__O())), x1$1)
      })
    })(this))));
    var jsx$1 = $m_sc_Seq$();
    var array = ["200", "500"];
    var preferredStatusCodes = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
    var x1$2 = preferredStatusCodes.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, responsesMap$1) {
      return (function(x$2$2) {
        var x$2 = $as_T(x$2$2);
        return responsesMap$1.get__O__s_Option(x$2).isEmpty__Z()
      })
    })(this, responsesMap)));
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var preferredStatusCode = $as_T(x2$2.value$2);
      var field = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1;
      $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(defaultResponse, field, preferredStatusCode))
    } else {
      var nextAvailable = 501;
      var found = false;
      while (((!found) && (nextAvailable < 600))) {
        var this$7 = nextAvailable;
        if (responsesMap.get__O__s_Option(("" + this$7)).isEmpty__Z()) {
          found = true;
          var this$9 = nextAvailable;
          var statusCode = ("" + this$9);
          var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1;
          $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(defaultResponse, field$1, statusCode))
        } else {
          nextAvailable = ((1 + nextAvailable) | 0)
        }
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultToNumericDefaultResponse.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  try {
    var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
    var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
    var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
    while (this$1.hasNext__Z()) {
      var arg1 = this$1.next__Lamf_core_model_domain_AmfElement();
      if ((arg1 instanceof $c_Lamf_plugins_domain_webapi_models_Operation)) {
        var x2 = $as_Lamf_plugins_domain_webapi_models_Operation(arg1);
        this.checkDefaultResponse__Lamf_plugins_domain_webapi_models_Operation__V(x2)
      }
    }
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 === null)) {
      throw e
    }
  };
  return model
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultToNumericDefaultResponse.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultToNumericDefaultResponse = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultToNumericDefaultResponse: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.DefaultToNumericDefaultResponse", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultToNumericDefaultResponse: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultToNumericDefaultResponse.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_DefaultToNumericDefaultResponse;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_EscapeTypeNames() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_EscapeTypeNames.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_EscapeTypeNames.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_EscapeTypeNames;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_EscapeTypeNames() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_EscapeTypeNames.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_EscapeTypeNames.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_EscapeTypeNames.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  if ((model instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(model);
    if ((x2.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)) {
      try {
        var replacedNames = new $c_scm_HashMap().init___();
        var expressionLikeNameCounter = new $c_Lamf_plugins_document_vocabularies_emitters_common_IdCounter().init___();
        var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
        var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
        var this$2 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(x2, strategy, fieldsFilter);
        while (this$2.hasNext__Z()) {
          var arg1 = this$2.next__Lamf_core_model_domain_AmfElement();
          if ((arg1 instanceof $c_Lamf_core_model_domain_Shape)) {
            var x2$1 = $as_Lamf_core_model_domain_Shape(arg1);
            var this$3 = $as_Lamf_core_model_StrField(x2$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
            if ((!this$3.isEmpty__Z())) {
              var arg1$1 = this$3.get__O();
              var name = $as_T(arg1$1);
              var x1 = $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$().matchType__Lamf_plugins_document_webapi_parser_TypeName__Lamf_plugins_domain_shapes_models_TypeDef__Z__Lamf_plugins_domain_shapes_models_TypeDef(new $c_Lamf_plugins_document_webapi_parser_TypeName().init___T__s_Option(name, $m_s_None$()), $m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$(), ($m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$(), false));
              var x = $m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$();
              if (((x === x1) && ($uI(name.indexOf(".")) !== (-1)))) {
                var newName = $as_T(name.split(".").join("_"));
                replacedNames.put__O__O__s_Option(name, newName);
                $m_Lamf_core_parser_Annotations$();
                var a = new $c_Lamf_core_parser_Annotations().init___();
                var jsx$1 = $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(x2$1, newName, a)
              } else {
                var x$3 = $m_Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$();
                if ((x$3 === x1)) {
                  var jsx$2 = true
                } else {
                  var x$5 = $m_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$();
                  if ((x$5 === x1)) {
                    var jsx$2 = true
                  } else {
                    var x$7 = $m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$();
                    var jsx$2 = (x$7 === x1)
                  }
                };
                if (jsx$2) {
                  var jsx$1 = (void 0)
                } else {
                  var x$9 = $m_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$();
                  if ((x$9 === x1)) {
                    var newName$2 = expressionLikeNameCounter.genId__T__T("type");
                    replacedNames.put__O__O__s_Option(name, newName$2);
                    $m_Lamf_core_parser_Annotations$();
                    var a$1 = new $c_Lamf_core_parser_Annotations().init___();
                    var jsx$1 = $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(x2$1, newName$2, a$1)
                  } else {
                    var newName$3 = (name + "_");
                    replacedNames.put__O__O__s_Option(name, newName$3);
                    $m_Lamf_core_parser_Annotations$();
                    var a$2 = new $c_Lamf_core_parser_Annotations().init___();
                    var jsx$1 = $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(x2$1, newName$3, a$2)
                  }
                }
              };
              new $c_s_Some().init___O(jsx$1)
            }
          }
        };
        var strategy$1 = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
        var fieldsFilter$1 = $m_Lamf_core_model_document_FieldsFilter$Local$();
        var this$13 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy$1, fieldsFilter$1);
        while (this$13.hasNext__Z()) {
          var arg1$2 = this$13.next__Lamf_core_model_domain_AmfElement();
          matchEnd4$2: {
            if ($is_Lamf_core_model_domain_Linkable(arg1$2)) {
              var x2$2 = $as_Lamf_core_model_domain_Linkable(arg1$2);
              if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x2$2).isDefined__Z()) {
                var this$14 = $as_Lamf_core_model_StrField(x2$2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1;
                if (this$14.isEmpty__Z()) {
                  var x1$2 = $m_s_None$()
                } else {
                  var arg1$3 = this$14.get__O();
                  var key = $as_T(arg1$3);
                  var x1$2 = replacedNames.get__O__s_Option(key)
                };
                if ((x1$2 instanceof $c_s_Some)) {
                  var x2$2$1 = $as_s_Some(x1$2);
                  var newLabel = $as_T(x2$2$1.value$2);
                  var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1;
                  $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x2$2, field, newLabel));
                  break matchEnd4$2
                } else {
                  break matchEnd4$2
                }
              }
            }
          }
        }
      } catch (e) {
        var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
        if ((e$2 === null)) {
          throw e
        }
      };
      return model
    }
  };
  return model
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_EscapeTypeNames.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_EscapeTypeNames = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_EscapeTypeNames: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.EscapeTypeNames", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_EscapeTypeNames: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_EscapeTypeNames.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_EscapeTypeNames;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$() {
  $c_Lamf_core_resolution_stages_elements_resolution_ElementStageTransformer.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$.prototype = new $h_Lamf_core_resolution_stages_elements_resolution_ElementStageTransformer();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$.prototype.transform__Lamf_core_model_domain_DomainElement__s_Option = (function(element) {
  return this.transform__Lamf_plugins_domain_shapes_models_NodeShape__s_Option($as_Lamf_plugins_domain_shapes_models_NodeShape(element))
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$.prototype.transform__Lamf_plugins_domain_shapes_models_NodeShape__s_Option = (function(node) {
  $as_sc_Seq(node.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(propertyShape$2) {
      var propertyShape = $as_Lamf_core_model_domain_extensions_PropertyShape(propertyShape$2);
      var this$1 = propertyShape.fields$2.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1);
      if (this$1.isEmpty__Z()) {
        return $m_s_None$()
      } else {
        var arg1 = this$1.get__O();
        var f = $as_Lamf_core_parser_FieldEntry(arg1);
        return new $c_s_Some().init___O((($uI($as_Lamf_core_model_domain_AmfScalar(f.value$1.value$1).value$1) === 0) ? f.value$1.annotations$1.reject__F1__Lamf_core_parser_Annotations(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
          return (function(a$2) {
            var a = $as_Lamf_core_model_domain_Annotation(a$2);
            return (a instanceof $c_Lamf_core_annotations_ExplicitField)
          })
        })($this))) : (void 0)))
      }
    })
  })(this)));
  return new $c_s_Some().init___O(node)
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.ImplicitRequiredTransformer$", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$: 1,
  Lamf_core_resolution_stages_elements_resolution_ElementStageTransformer: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$;
var $n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$ = (void 0);
function $m_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$() {
  if ((!$n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$)) {
    $n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$ = new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$().init___()
  };
  return $n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeExamplesOptional() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeExamplesOptional.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeExamplesOptional.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeExamplesOptional;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeExamplesOptional() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeExamplesOptional.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeExamplesOptional.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeExamplesOptional.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  try {
    var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
    var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
    var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
    while (this$1.hasNext__Z()) {
      var arg1 = this$1.next__Lamf_core_model_domain_AmfElement();
      if ((arg1 instanceof $c_Lamf_plugins_domain_shapes_models_Example)) {
        var x2 = $as_Lamf_plugins_domain_shapes_models_Example(arg1);
        var field = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Strict$1;
        $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(x2, field, false))
      }
    }
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 === null)) {
      throw e
    }
  };
  return model
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeExamplesOptional.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeExamplesOptional = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeExamplesOptional: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.MakeExamplesOptional", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeExamplesOptional: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeExamplesOptional.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeExamplesOptional;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryAnnotationType() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this);
  this.annotationCounter$2 = 0
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryAnnotationType.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryAnnotationType.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryAnnotationType;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryAnnotationType() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryAnnotationType.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryAnnotationType.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryAnnotationType.prototype.ensureType__Lamf_core_model_domain_extensions_CustomDomainProperty__Lamf_core_model_domain_extensions_CustomDomainProperty = (function(customDomainProperty) {
  if ($m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(customDomainProperty.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Schema$1))).isEmpty__Z()) {
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var fields = new $c_Lamf_core_parser_Fields().init___();
    var schema = new $c_Lamf_plugins_domain_shapes_models_AnyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
    var field = $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Schema$1;
    $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(customDomainProperty, field, schema))
  };
  return customDomainProperty
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryAnnotationType.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  try {
    if ((model instanceof $c_Lamf_core_model_document_Document)) {
      var x2 = $as_Lamf_core_model_document_Document(model);
      var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
      var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
      var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
      while (this$1.hasNext__Z()) {
        var arg1 = this$1.next__Lamf_core_model_domain_AmfElement();
        if ((arg1 instanceof $c_Lamf_core_model_domain_extensions_DomainExtension)) {
          var x2$1 = $as_Lamf_core_model_domain_extensions_DomainExtension(arg1);
          var x1$2 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_extensions_CustomDomainProperty(x2$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().DefinedBy$1)));
          if ((x1$2 instanceof $c_s_Some)) {
            var x2$2 = $as_s_Some(x1$2);
            var customDomainProperty = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(x2$2.value$2);
            var customDomainPropertyWithSchema = this.ensureType__Lamf_core_model_domain_extensions_CustomDomainProperty__Lamf_core_model_domain_extensions_CustomDomainProperty(customDomainProperty)
          } else {
            var x = $m_s_None$();
            if ((!(x === x1$2))) {
              throw new $c_s_MatchError().init___O(x1$2)
            };
            this.annotationCounter$2 = ((1 + this.annotationCounter$2) | 0);
            $m_Lamf_core_parser_Annotations$();
            var annotations = new $c_Lamf_core_parser_Annotations().init___();
            var this$6 = new $c_Lamf_core_model_domain_extensions_CustomDomainProperty().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
            var jsx$1 = $m_s_Predef$any2stringadd$();
            var self = $f_Lamf_core_model_document_BaseUnit__location__s_Option(model);
            var value = jsx$1.$$plus$extension__O__T__T(self, ("#genAnnotation" + this.annotationCounter$2));
            var qual$1 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$6, value));
            var this$7 = $as_Lamf_core_model_StrField(x2$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1));
            var this$8 = this$7.option$1;
            var x$1 = $as_T((this$8.isEmpty__Z() ? null : this$8.get__O()));
            $m_Lamf_core_parser_Annotations$();
            var x$2$2 = new $c_Lamf_core_parser_Annotations().init___();
            var this$14 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, x$1, x$2$2));
            $m_Lamf_core_parser_Annotations$();
            var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
            var fields = new $c_Lamf_core_parser_Fields().init___();
            var schema = new $c_Lamf_plugins_domain_shapes_models_AnyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations$1);
            var field = $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Schema$1;
            var customDomainProperty$2 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$14, field, schema));
            var field$1 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().DefinedBy$1;
            $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(x2$1, field$1, customDomainProperty$2));
            var customDomainPropertyWithSchema = customDomainProperty$2
          };
          if ((!$as_sc_Seq(x2.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().Declares$1)).exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, customDomainPropertyWithSchema$1) {
            return (function(x$1$2$2) {
              var x$1$2 = $as_Lamf_core_model_domain_DomainElement(x$1$2$2);
              return (x$1$2.id__T() === customDomainPropertyWithSchema$1.id$1)
            })
          })(this, customDomainPropertyWithSchema))))) {
            var field$2 = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
            $as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(x2, field$2, customDomainPropertyWithSchema))
          }
        }
      }
    }
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 === null)) {
      throw e
    }
  };
  return model
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryAnnotationType.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  this.annotationCounter$2 = 0;
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryAnnotationType = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryAnnotationType: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.MandatoryAnnotationType", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryAnnotationType: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryAnnotationType.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryAnnotationType;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryCreativeWorkFields() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryCreativeWorkFields.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryCreativeWorkFields.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryCreativeWorkFields;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryCreativeWorkFields() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryCreativeWorkFields.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryCreativeWorkFields.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryCreativeWorkFields.prototype.fillMandatoryFields__p2__Lamf_plugins_domain_shapes_models_CreativeWork__V = (function(creativeWork) {
  var this$1 = $as_Lamf_core_model_StrField(creativeWork.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Title$1));
  if ($f_Lamf_core_model_StrField__isNullOrEmpty__Z(this$1)) {
    var field = $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Title$1;
    $as_Lamf_plugins_domain_shapes_models_CreativeWork($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(creativeWork, field, "generated"))
  };
  var this$2 = $as_Lamf_core_model_StrField(creativeWork.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Description$1));
  if ($f_Lamf_core_model_StrField__isNullOrEmpty__Z(this$2)) {
    var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Description$1;
    $as_Lamf_plugins_domain_shapes_models_CreativeWork($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(creativeWork, field$1, "generated"))
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryCreativeWorkFields.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  try {
    var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
    var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
    var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
    while (this$1.hasNext__Z()) {
      var arg1 = this$1.next__Lamf_core_model_domain_AmfElement();
      if ((arg1 instanceof $c_Lamf_plugins_domain_shapes_models_CreativeWork)) {
        var x2 = $as_Lamf_plugins_domain_shapes_models_CreativeWork(arg1);
        this.fillMandatoryFields__p2__Lamf_plugins_domain_shapes_models_CreativeWork__V(x2)
      }
    }
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 === null)) {
      throw e
    }
  };
  return model
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryCreativeWorkFields.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryCreativeWorkFields = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryCreativeWorkFields: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.MandatoryCreativeWorkFields", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryCreativeWorkFields: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryCreativeWorkFields.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryCreativeWorkFields;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this);
  this.tagCounter$2 = 0
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle.prototype.missingTitle__p2__Lamf_plugins_domain_webapi_models_WebApi__Z = (function(webApi) {
  return $as_Lamf_core_model_StrField(webApi.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Name$1)).option$1.isEmpty__Z()
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle.prototype.ensureWebApiTitle__p2__Lamf_plugins_domain_webapi_models_WebApi__O = (function(api) {
  if (this.missingTitle__p2__Lamf_plugins_domain_webapi_models_WebApi__Z(api)) {
    $m_Lamf_core_parser_Annotations$();
    var a = new $c_Lamf_core_parser_Annotations().init___();
    return $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(api, "generated", a)
  } else {
    return (void 0)
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle.prototype.generateDocumentationTitle__p2__Lamf_plugins_domain_shapes_models_CreativeWork__V = (function(documentation) {
  if (this.needsATitle__p2__Lamf_plugins_domain_shapes_models_CreativeWork__Z(documentation)) {
    var x1 = $as_Lamf_core_model_StrField(documentation.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Url$1)).option$1;
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var url = $as_T(x2.value$2);
      var field = $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Title$1;
      $as_Lamf_plugins_domain_shapes_models_CreativeWork($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(documentation, field, url))
    } else {
      var x = $m_s_None$();
      if ((x === x1)) {
        var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Title$1;
        $as_Lamf_plugins_domain_shapes_models_CreativeWork($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(documentation, field$1, "generated"))
      } else {
        throw new $c_s_MatchError().init___O(x1)
      }
    }
  };
  documentation.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Url$1)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle.prototype.needsATitle__p2__Lamf_plugins_domain_shapes_models_CreativeWork__Z = (function(documentation) {
  var x1 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_StrField(documentation.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Title$1)));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var strField = $as_Lamf_core_model_StrField(x2.value$2);
    return $f_Lamf_core_model_StrField__isNullOrEmpty__Z(strField)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return false
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle.prototype.generateDocumentationTitleForTag__p2__Lamf_plugins_domain_webapi_models_Tag__V = (function(tag) {
  var x1 = $m_s_Option$().apply__O__s_Option($as_Lamf_plugins_domain_shapes_models_CreativeWork(tag.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TagModel$().Documentation$1)));
  matchEnd5: {
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var doc = $as_Lamf_plugins_domain_shapes_models_CreativeWork(x2.value$2);
      if (this.needsATitle__p2__Lamf_plugins_domain_shapes_models_CreativeWork__Z(doc)) {
        var this$1 = $as_Lamf_core_model_StrField(tag.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TagModel$().Name$1)).option$1;
        if (this$1.isEmpty__Z()) {
          this.tagCounter$2 = ((1 + this.tagCounter$2) | 0);
          var jsx$1 = (("Tag " + this.tagCounter$2) + " documentation")
        } else {
          var jsx$1 = this$1.get__O()
        };
        var documentationTitle = $as_T(jsx$1);
        var this$2 = $as_Lamf_plugins_domain_shapes_models_CreativeWork(tag.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TagModel$().Documentation$1));
        var field = $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Title$1;
        $as_Lamf_plugins_domain_shapes_models_CreativeWork($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$2, field, documentationTitle));
        break matchEnd5
      }
    };
    var x = $m_s_None$();
    if ((x === x1)) {
      break matchEnd5
    };
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle.prototype.extractDocumentedElements__p2__Lamf_core_model_document_BaseUnit__sc_Iterator = (function(model) {
  var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
  var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
  var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
  var pf = new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle$$anonfun$extractDocumentedElements$1().init___Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle(this);
  return new $c_sc_Iterator$$anon$13().init___sc_Iterator__s_PartialFunction(this$1, pf)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  var this$1 = this.extractDocumentedElements__p2__Lamf_core_model_document_BaseUnit__sc_Iterator(model);
  while (this$1.hasNext__Z()) {
    var arg1 = this$1.next__O();
    var x0$1 = $as_Lamf_core_model_domain_AmfElement(arg1);
    if ((x0$1 instanceof $c_Lamf_plugins_domain_webapi_models_Tag)) {
      var x2 = $as_Lamf_plugins_domain_webapi_models_Tag(x0$1);
      this.generateDocumentationTitleForTag__p2__Lamf_plugins_domain_webapi_models_Tag__V(x2)
    } else {
      $as_sc_IterableLike($as_Lamf_plugins_domain_webapi_models_DocumentedElement(x0$1).documentations__sc_Seq().filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x$2) {
          var x = $as_Lamf_plugins_domain_shapes_models_CreativeWork(x$2);
          return (x !== null)
        })
      })(this)))).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
        return (function(documentation$2) {
          var documentation = $as_Lamf_plugins_domain_shapes_models_CreativeWork(documentation$2);
          this$2.generateDocumentationTitle__p2__Lamf_plugins_domain_shapes_models_CreativeWork__V(documentation)
        })
      })(this)))
    }
  };
  if ((model instanceof $c_Lamf_core_model_document_Document)) {
    var x2$1 = $as_Lamf_core_model_document_Document(model);
    if ((x2$1.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)) {
      var webApi = $as_Lamf_plugins_domain_webapi_models_WebApi(x2$1.encodes__Lamf_core_model_domain_DomainElement());
      this.ensureWebApiTitle__p2__Lamf_plugins_domain_webapi_models_WebApi__O(webApi);
      return model
    }
  };
  return model
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  this.tagCounter$2 = 0;
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.MandatoryDocumentationTitle", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PushSingleOperationPathParams() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PushSingleOperationPathParams.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PushSingleOperationPathParams.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PushSingleOperationPathParams;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PushSingleOperationPathParams() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PushSingleOperationPathParams.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PushSingleOperationPathParams.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PushSingleOperationPathParams.prototype.checkUriParams__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_domain_webapi_models_EndPoint = (function(endpoint) {
  if ((($as_sc_Seq(endpoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1)).size__I() === 1) && $m_s_Option$().apply__O__s_Option($as_Lamf_plugins_domain_webapi_models_Operation($as_sc_Seq(endpoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1)).head__O()).request__Lamf_plugins_domain_webapi_models_Request()).isDefined__Z())) {
    var operation = $as_Lamf_plugins_domain_webapi_models_Operation($as_sc_Seq(endpoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1)).head__O());
    var this$1 = operation.request__Lamf_plugins_domain_webapi_models_Request();
    var uriParams = $as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().UriParameters$1));
    if (uriParams.nonEmpty__Z()) {
      operation.request__Lamf_plugins_domain_webapi_models_Request().fields$2.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().UriParameters$1);
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(param$2) {
          var param = $as_Lamf_plugins_domain_webapi_models_Parameter(param$2);
          var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1;
          return $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(param, field, true))
        })
      })(this));
      var this$2 = $m_sc_Seq$();
      var parameters = $as_sc_Seq(uriParams.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
      var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1;
      return $as_Lamf_plugins_domain_webapi_models_EndPoint($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(endpoint, field$1, parameters))
    } else {
      return endpoint
    }
  } else {
    return endpoint
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PushSingleOperationPathParams.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  try {
    var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
    var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
    var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
    while (this$1.hasNext__Z()) {
      var arg1 = this$1.next__Lamf_core_model_domain_AmfElement();
      if ((arg1 instanceof $c_Lamf_plugins_domain_webapi_models_EndPoint)) {
        var x2 = $as_Lamf_plugins_domain_webapi_models_EndPoint(arg1);
        this.checkUriParams__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_domain_webapi_models_EndPoint(x2)
      }
    }
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 === null)) {
      throw e
    }
  };
  return model
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PushSingleOperationPathParams.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PushSingleOperationPathParams = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PushSingleOperationPathParams: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.PushSingleOperationPathParams", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PushSingleOperationPathParams: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PushSingleOperationPathParams.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PushSingleOperationPathParams;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_RecursionDetection() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_RecursionDetection.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_RecursionDetection.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_RecursionDetection;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_RecursionDetection() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_RecursionDetection.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_RecursionDetection.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_RecursionDetection.prototype.isValidShape__p2__Lamf_core_model_domain_AmfObject__Z = (function(obj) {
  return (((obj instanceof $c_Lamf_core_model_domain_Shape) && (!(obj instanceof $c_Lamf_core_model_domain_extensions_PropertyShape))) && (!(obj instanceof $c_Lamf_plugins_domain_shapes_models_DataArrangementShape)))
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_RecursionDetection.prototype.advance__p2__Lamf_core_model_domain_AmfElement__scm_ListBuffer__sci_Set__Lamf_core_model_domain_AmfElement = (function(element, general, branch) {
  if ((element instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
    var x2 = $as_Lamf_core_model_domain_RecursiveShape(element);
    return x2
  } else if ($is_Lamf_core_model_domain_AmfObject(element)) {
    var x3 = $as_Lamf_core_model_domain_AmfObject(element);
    var id = x3.id__T();
    if (branch.contains__O__Z(id)) {
      return $m_Lamf_core_model_domain_RecursiveShape$().apply__Lamf_core_model_domain_Shape__Lamf_core_model_domain_RecursiveShape($as_Lamf_core_model_domain_Shape(x3))
    } else {
      var this$1 = general.scala$collection$mutable$ListBuffer$$start$6;
      if ($f_sc_LinearSeqOptimized__contains__O__Z(this$1, id)) {
        return x3
      } else {
        var branchIds = (this.isValidShape__p2__Lamf_core_model_domain_AmfObject__Z(x3) ? (general.$$plus$eq__O__scm_ListBuffer(id), $as_sci_Set(branch.$$plus__O__sc_Set(id))) : branch);
        var this$2 = x3.fields__Lamf_core_parser_Fields();
        var this$5 = this$2.fs$1;
        var this$3 = $m_Lamf_core_parser_FieldEntry$();
        var f = $f_F2__tupled__F1(this$3);
        var this$4 = $m_sci_Iterable$();
        var bf = this$4.ReusableCBFInstance$2;
        $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$5, f, bf)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, general$1, branchIds$1, x3$1) {
          return (function(f$2) {
            var f$1 = $as_Lamf_core_parser_FieldEntry(f$2);
            var x1 = $this.advance__p2__Lamf_core_model_domain_AmfElement__scm_ListBuffer__sci_Set__Lamf_core_model_domain_AmfElement(f$1.value$1.value$1, general$1, branchIds$1);
            if ((x1 instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
              var x2$1 = $as_Lamf_core_model_domain_RecursiveShape(x1);
              return x3$1.fields__Lamf_core_parser_Fields().setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(f$1.field$1, x2$1, (x3$1.fields__Lamf_core_parser_Fields(), $m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
            } else if ((x1 instanceof $c_Lamf_core_model_domain_AmfArray)) {
              var x3$2 = $as_Lamf_core_model_domain_AmfArray(x1);
              return x3$1.fields__Lamf_core_parser_Fields().setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(f$1.field$1, x3$2, (x3$1.fields__Lamf_core_parser_Fields(), $m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
            } else {
              return (void 0)
            }
          })
        })(this, general, branchIds, x3)));
        return x3
      }
    }
  } else if ((element instanceof $c_Lamf_core_model_domain_AmfArray)) {
    var x4 = $as_Lamf_core_model_domain_AmfArray(element);
    var jsx$2 = x4.values$1;
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, general$2, branch$1) {
      return (function(x$1$2) {
        var x$1 = $as_Lamf_core_model_domain_AmfElement(x$1$2);
        return this$2$1.advance__p2__Lamf_core_model_domain_AmfElement__scm_ListBuffer__sci_Set__Lamf_core_model_domain_AmfElement(x$1, general$2, branch$1)
      })
    })(this, general, branch));
    var this$10 = $m_sc_Seq$();
    var elements = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$10.ReusableCBFInstance$2));
    return (elements.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
      return (function(x$2$2) {
        var x$2 = $as_Lamf_core_model_domain_AmfElement(x$2$2);
        return (x$2 instanceof $c_Lamf_core_model_domain_RecursiveShape)
      })
    })(this))) ? new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(elements, x4.annotations$1) : x4)
  } else {
    return element
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_RecursionDetection.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  if ((model instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(model);
    var this$1 = x2.fields__Lamf_core_parser_Fields();
    var this$4 = this$1.fs$1;
    var this$2 = $m_Lamf_core_parser_FieldEntry$();
    var f = $f_F2__tupled__F1(this$2);
    var this$3 = $m_sci_Iterable$();
    var bf = this$3.ReusableCBFInstance$2;
    $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$4, f, bf)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(f$2) {
        var f$1 = $as_Lamf_core_parser_FieldEntry(f$2);
        return $this.advance__p2__Lamf_core_model_domain_AmfElement__scm_ListBuffer__sci_Set__Lamf_core_model_domain_AmfElement(f$1.value$1.value$1, $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), $m_sci_Set$EmptySet$())
      })
    })(this)))
  };
  return model
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_RecursionDetection.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_RecursionDetection = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_RecursionDetection: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.RecursionDetection", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_RecursionDetection: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_RecursionDetection.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_RecursionDetection;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveRamlCompatibleDeclarations() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this);
  this.domainSelector$2 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveRamlCompatibleDeclarations.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveRamlCompatibleDeclarations.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveRamlCompatibleDeclarations;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveRamlCompatibleDeclarations() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveRamlCompatibleDeclarations.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveRamlCompatibleDeclarations.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveRamlCompatibleDeclarations.prototype.customDomainElementTransformation__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_Linkable__Lamf_core_model_domain_DomainElement = (function(resolved, link) {
  if ((resolved instanceof $c_Lamf_plugins_domain_webapi_models_Response)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_Response(resolved);
    if ((link instanceof $c_Lamf_plugins_domain_webapi_models_Response)) {
      var x3 = $as_Lamf_plugins_domain_webapi_models_Response(link);
      var this$1 = $as_Lamf_core_model_StrField(x3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1));
      var this$2 = this$1.option$1;
      var statusCode = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
      var field = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1;
      return $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x2, field, statusCode))
    }
  };
  return resolved
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveRamlCompatibleDeclarations.prototype.transformation__p2__Lamf_core_model_domain_DomainElement__Z__s_Option = (function(e, isCycle) {
  var x$1 = this.errorHandler$1;
  var x$2 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(resolved$2, link$2) {
      var resolved = $as_Lamf_core_model_domain_DomainElement(resolved$2);
      var link = $as_Lamf_core_model_domain_Linkable(link$2);
      return $this.customDomainElementTransformation__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_Linkable__Lamf_core_model_domain_DomainElement(resolved, link)
    })
  })(this));
  $m_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$();
  var x$3 = false;
  $m_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$();
  var x$4 = $m_s_None$();
  $m_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$();
  var x$5 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var referenceResolution = new $c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution().init___Lamf_core_errorhandling_ErrorHandler__Z__s_Option__scm_Map__F2(x$1, x$3, x$4, x$5, x$2);
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$().ASSERT$undDIFFERENT$1];
  return referenceResolution.transform__Lamf_core_model_domain_DomainElement__sc_Seq__s_Option(e, $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))))
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveRamlCompatibleDeclarations.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  var this$1 = $m_Lamf_core_resolution_stages_selectors_LinkSelector$();
  var another = this.domainSelector$2;
  var result = model.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(new $c_Lamf_core_resolution_stages_selectors_AndSelector().init___Lamf_core_resolution_stages_selectors_Selector__Lamf_core_resolution_stages_selectors_Selector(this$1, another), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(e$2, isCycle$2) {
      var e = $as_Lamf_core_model_domain_DomainElement(e$2);
      var isCycle = $uZ(isCycle$2);
      return $this.transformation__p2__Lamf_core_model_domain_DomainElement__Z__s_Option(e, isCycle)
    })
  })(this)), this.errorHandler$1);
  if ((model instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(model);
    var filteredDeclarations = $as_sc_Seq($as_sc_Seq(x2.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().Declares$1)).filterNot__F1__O(this.domainSelector$2));
    var field = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
    $as_Lamf_core_model_document_Document($as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(x2, field, filteredDeclarations)))
  } else {
    throw new $c_s_MatchError().init___O(model)
  };
  return result
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveRamlCompatibleDeclarations.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  var this$1 = $m_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResponseSelector$();
  var another = $m_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ParameterSelector$();
  var this$2 = new $c_Lamf_core_resolution_stages_selectors_OrSelector().init___Lamf_core_resolution_stages_selectors_Selector__Lamf_core_resolution_stages_selectors_Selector(this$1, another);
  var another$1 = $m_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PayloadSelector$();
  var this$3 = new $c_Lamf_core_resolution_stages_selectors_OrSelector().init___Lamf_core_resolution_stages_selectors_Selector__Lamf_core_resolution_stages_selectors_Selector(this$2, another$1);
  var another$2 = $m_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CallbackSelector$();
  var this$4 = new $c_Lamf_core_resolution_stages_selectors_OrSelector().init___Lamf_core_resolution_stages_selectors_Selector__Lamf_core_resolution_stages_selectors_Selector(this$3, another$2);
  var another$3 = $m_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ExampleSelector$();
  this.domainSelector$2 = new $c_Lamf_core_resolution_stages_selectors_OrSelector().init___Lamf_core_resolution_stages_selectors_Selector__Lamf_core_resolution_stages_selectors_Selector(this$4, another$3);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveRamlCompatibleDeclarations = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveRamlCompatibleDeclarations: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.ResolveRamlCompatibleDeclarations", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveRamlCompatibleDeclarations: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveRamlCompatibleDeclarations.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveRamlCompatibleDeclarations;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames.prototype.sanitizeName__T__s_Option = (function(name) {
  var array = [new $c_jl_Character().init___C(32), new $c_jl_Character().init___C(91), new $c_jl_Character().init___C(93)];
  if (($uI(array.length) === 0)) {
    var jsx$1 = $m_sci_Set$EmptySet$()
  } else {
    var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      b.$$plus$eq__O__scm_SetBuilder(arg1);
      i = ((1 + i) | 0)
    };
    var jsx$1 = b.elems$1
  };
  var excludedChars = $as_sci_Set(jsx$1);
  if (excludedChars.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, name$1) {
    return (function(x$1$2) {
      if ((x$1$2 === null)) {
        var x$1 = 0
      } else {
        var this$11 = $as_jl_Character(x$1$2);
        var x$1 = this$11.value$1
      };
      var this$15 = new $c_sci_StringOps().init___T(name$1);
      var elem = new $c_jl_Character().init___C(x$1);
      return $f_sc_SeqLike__contains__O__Z(this$15, elem)
    })
  })(this, name)))) {
    var this$17 = new $c_sci_StringOps().init___T(name);
    return new $c_s_Some().init___O($f_sc_TraversableLike__filterImpl__F1__Z__O(this$17, excludedChars, true))
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  if ((model instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(model);
    var jsx$2 = $as_sc_Seq(x2.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().Declares$1));
    var jsx$1 = new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames$$anonfun$resolve$1().init___Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames(this);
    var this$1 = $m_sc_Seq$();
    jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2);
    var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
    var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
    var this$2 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(x2, strategy, fieldsFilter);
    while (this$2.hasNext__Z()) {
      var arg1 = this$2.next__Lamf_core_model_domain_AmfElement();
      if ($is_Lamf_core_model_domain_DomainElement(arg1)) {
        var x2$1 = $as_Lamf_core_model_domain_DomainElement(arg1);
        matchEnd4: {
          if ($is_Lamf_core_model_domain_Linkable(x2$1)) {
            var this$3 = $as_Lamf_core_model_domain_Linkable(x2$1);
            if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$3).isDefined__Z()) {
              var this$4 = $as_Lamf_core_model_domain_Linkable(x2$1);
              var this$5 = $as_Lamf_core_model_StrField(this$4.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1));
              var this$6 = this$5.option$1;
              var x1$3 = this.sanitizeName__T__s_Option($as_T((this$6.isEmpty__Z() ? null : this$6.get__O())));
              if ((x1$3 instanceof $c_s_Some)) {
                var x2$3 = $as_s_Some(x1$3);
                var name = $as_T(x2$3.value$2);
                var this$7 = $as_Lamf_core_model_domain_Linkable(x2$1);
                var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1;
                $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$7, field, name));
                break matchEnd4
              } else {
                var x = $m_s_None$();
                if ((x === x1$3)) {
                  break matchEnd4
                } else {
                  throw new $c_s_MatchError().init___O(x1$3)
                }
              }
            }
          }
        }
      } else {
        throw new $c_s_MatchError().init___O(arg1)
      }
    }
  };
  return model
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.SanitizeCustomTypeNames", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SecuritySettingsMapper() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SecuritySettingsMapper.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SecuritySettingsMapper.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SecuritySettingsMapper;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SecuritySettingsMapper() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SecuritySettingsMapper.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SecuritySettingsMapper.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SecuritySettingsMapper.prototype.fixApiKey__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_domain_webapi_models_security_ApiKeySettings__V = (function(security, apiKey) {
  var this$1 = $as_Lamf_core_model_StrField(apiKey.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().In$1));
  var this$2 = this$1.option$1;
  var x1 = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  if ((x1 === "query")) {
    var this$3 = $as_Lamf_core_model_StrField(apiKey.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().Name$1)).option$1;
    var this$8 = security.withQueryParameter__T__Lamf_plugins_domain_webapi_models_Parameter($as_T((this$3.isEmpty__Z() ? "default" : this$3.get__O())));
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var fields = new $c_Lamf_core_parser_Fields().init___();
    var schema = new $c_Lamf_plugins_domain_shapes_models_AnyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1;
    $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$8, field, schema))
  } else if ((x1 === "header")) {
    var this$9 = $as_Lamf_core_model_StrField(apiKey.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().Name$1)).option$1;
    var this$14 = security.withHeader__T__Lamf_plugins_domain_webapi_models_Parameter($as_T((this$9.isEmpty__Z() ? "default" : this$9.get__O())));
    $m_Lamf_core_parser_Annotations$();
    var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
    var fields$1 = new $c_Lamf_core_parser_Fields().init___();
    var schema$1 = new $c_Lamf_plugins_domain_shapes_models_AnyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields$1, annotations$1);
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1;
    $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$14, field$1, schema$1))
  };
  security.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SecuritySettingsMapper.prototype.fixSettings__p2__Lamf_core_model_document_DeclaresModel__V = (function(d) {
  d.declares__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_domain_DomainElement(x0$1$2);
      if ((x0$1 instanceof $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme)) {
        var x2 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(x0$1);
        $this.fixSettings__p2__Lamf_plugins_domain_webapi_models_security_SecurityScheme__V(x2)
      }
    })
  })(this)))
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SecuritySettingsMapper.prototype.fixSettings__p2__Lamf_plugins_domain_webapi_models_security_SecurityScheme__V = (function(security) {
  var x1 = $as_Lamf_plugins_domain_webapi_models_security_Settings(security.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1));
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(x1);
    this.fixOauth2__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__V(x2)
  } else if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings)) {
    var x3 = $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(x1);
    this.fixApiKey__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_domain_webapi_models_security_ApiKeySettings__V(security, x3)
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SecuritySettingsMapper.prototype.fixOauth2__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__V = (function(oauth2) {
  if ($as_sc_Seq(oauth2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().AuthorizationGrants$1)).isEmpty__Z()) {
    var jsx$1 = $m_sc_Seq$();
    var array = ["implicit"];
    var authorizationGrants = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
    var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().AuthorizationGrants$1;
    $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(oauth2, field, authorizationGrants))
  };
  var this$3 = $as_sc_Seq(oauth2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1)).headOption__s_Option();
  var flow = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow((this$3.isEmpty__Z() ? oauth2.withFlow__Lamf_plugins_domain_webapi_models_security_OAuth2Flow() : this$3.get__O()));
  if ($as_Lamf_core_model_StrField(flow.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1)).option$1.isEmpty__Z()) {
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1;
    $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(flow, field$1, ""))
  };
  if ($as_Lamf_core_model_StrField(flow.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1)).option$1.isEmpty__Z()) {
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1;
    $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(flow, field$2, ""))
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SecuritySettingsMapper.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  if ($is_Lamf_core_model_document_DeclaresModel(model)) {
    try {
      this.fixSettings__p2__Lamf_core_model_document_DeclaresModel__V($as_Lamf_core_model_document_DeclaresModel(model))
    } catch (e) {
      var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
      if ((e$2 === null)) {
        throw e
      }
    };
    return model
  } else {
    return model
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SecuritySettingsMapper.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SecuritySettingsMapper = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SecuritySettingsMapper: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.SecuritySettingsMapper", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SecuritySettingsMapper: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SecuritySettingsMapper.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SecuritySettingsMapper;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ShapeFormatAdjuster() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ShapeFormatAdjuster.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ShapeFormatAdjuster.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ShapeFormatAdjuster;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ShapeFormatAdjuster() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ShapeFormatAdjuster.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ShapeFormatAdjuster.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ShapeFormatAdjuster.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  try {
    var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
    var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
    var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
    while (this$1.hasNext__Z()) {
      var arg1 = this$1.next__Lamf_core_model_domain_AmfElement();
      matchEnd4: {
        if ((arg1 instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
          var x2 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(arg1);
          var this$2 = $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__format__Lamf_core_model_StrField(x2);
          if ($f_Lamf_core_model_StrField__nonEmpty__Z(this$2)) {
            var jsx$1 = $m_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$();
            var this$3 = $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1));
            var this$4 = this$3.option$1;
            var typeDef = jsx$1.typeDef__T__Lamf_plugins_domain_shapes_models_TypeDef($as_T((this$4.isEmpty__Z() ? null : this$4.get__O())));
            var x$2 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$();
            if ((!((typeDef !== null) && (typeDef === x$2)))) {
              var x$4 = $m_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$();
              var jsx$3 = (!((typeDef !== null) && (typeDef === x$4)))
            } else {
              var jsx$3 = false
            };
            if (jsx$3) {
              var x$6 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$();
              var jsx$2 = (!((typeDef !== null) && (typeDef === x$6)))
            } else {
              var jsx$2 = false
            };
            if (jsx$2) {
              var x$8 = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$();
              if (((typeDef !== null) && (typeDef === x$8))) {
                var jsx$4 = $m_sc_Seq$();
                var array = ["rfc3339", "rfc2616"];
                var valid = $as_sc_Seq(jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
              } else {
                var jsx$5 = $m_sc_Seq$();
                var array$1 = ["int32", "int64", "int", "long", "float", "double", "int16", "int8"];
                var valid = $as_sc_Seq(jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)))
              };
              var this$9 = $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__format__Lamf_core_model_StrField(x2);
              var this$10 = this$9.option$1;
              if ((!valid.contains__O__Z($as_T((this$10.isEmpty__Z() ? null : this$10.get__O()))))) {
                x2.fields$2.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Format$1);
                break matchEnd4
              } else {
                break matchEnd4
              }
            } else {
              x2.fields$2.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Format$1);
              break matchEnd4
            }
          }
        }
      }
    }
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 === null)) {
      throw e
    }
  };
  return model
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ShapeFormatAdjuster.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ShapeFormatAdjuster = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ShapeFormatAdjuster: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.ShapeFormatAdjuster", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ShapeFormatAdjuster: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ShapeFormatAdjuster.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ShapeFormatAdjuster;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_UnionsAsTypeExpressions() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_UnionsAsTypeExpressions.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_UnionsAsTypeExpressions.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_UnionsAsTypeExpressions;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_UnionsAsTypeExpressions() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_UnionsAsTypeExpressions.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_UnionsAsTypeExpressions.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_UnionsAsTypeExpressions.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  try {
    var document = $as_Lamf_core_model_document_DeclaresModel(model);
    var elem = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var collectedDecls = new $c_sr_ObjectRef().init___O(elem);
    document.declares__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, collectedDecls$1) {
      return (function(decl$2) {
        var decl = $as_Lamf_core_model_domain_DomainElement(decl$2);
        return $as_scm_ListBuffer(collectedDecls$1.elem$1).$$plus$eq__O__scm_ListBuffer(decl)
      })
    })(this, collectedDecls)));
    var counter = new $c_sr_IntRef().init___I(1);
    var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
    var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
    var this$3 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator(model, strategy, fieldsFilter);
    while (this$3.hasNext__Z()) {
      var arg1 = this$3.next__Lamf_core_model_domain_AmfElement();
      if ((arg1 instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
        var x2 = $as_Lamf_plugins_domain_shapes_models_UnionShape(arg1);
        var jsx$2 = $as_sc_Seq(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1));
        var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, collectedDecls$1$1, counter$1) {
          return (function(shape$2) {
            var shape = $as_Lamf_core_model_domain_Shape(shape$2);
            var this$4 = $as_scm_ListBuffer(collectedDecls$1$1.elem$1);
            var this$5 = this$4.scala$collection$mutable$ListBuffer$$start$6;
            inlinereturn$22: {
              var these = this$5;
              while ((!these.isEmpty__Z())) {
                var arg1$1 = these.head__O();
                var x$1 = $as_Lamf_core_model_domain_DomainElement(arg1$1);
                if ((x$1.id__T() === shape.id$1)) {
                  var x1 = new $c_s_Some().init___O(these.head__O());
                  break inlinereturn$22
                };
                these = $as_sc_LinearSeqOptimized(these.tail__O())
              };
              var x1 = $m_s_None$()
            };
            if ((x1 instanceof $c_s_Some)) {
              var x2$1 = $as_s_Some(x1);
              var declared = $as_Lamf_core_model_domain_DomainElement(x2$1.value$2);
              if ((declared instanceof $c_Lamf_core_model_domain_Shape)) {
                var x3 = $as_Lamf_core_model_domain_Shape(declared);
                if ($as_Lamf_core_model_StrField(x3.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1.isDefined__Z()) {
                  var this$6 = $as_Lamf_core_model_StrField(x3.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
                  var this$7 = this$6.option$1;
                  return $as_T((this$7.isEmpty__Z() ? null : this$7.get__O()))
                }
              }
            };
            if ($as_Lamf_core_model_StrField(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1.isEmpty__Z()) {
              var namedShape = ("GenShape" + counter$1.elem$1);
              counter$1.elem$1 = ((1 + counter$1.elem$1) | 0);
              $m_Lamf_core_parser_Annotations$();
              var a = new $c_Lamf_core_parser_Annotations().init___();
              $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, namedShape, a)
            };
            $as_scm_ListBuffer(collectedDecls$1$1.elem$1).$$plus$eq__O__scm_ListBuffer(shape);
            return $as_Lamf_core_model_StrField(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1))
          })
        })(this, collectedDecls, counter));
        var this$9 = $m_sc_Seq$();
        var names = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$9.ReusableCBFInstance$2));
        x2.annotations$2.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression().init___T(names.mkString__T__T(" | ")))
      }
    };
    var declarations = $as_scm_ListBuffer(collectedDecls.elem$1);
    var field = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
    $as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(document, field, declarations))
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 === null)) {
      throw e
    }
  };
  return model
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_UnionsAsTypeExpressions.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_UnionsAsTypeExpressions = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_UnionsAsTypeExpressions: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.UnionsAsTypeExpressions", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_UnionsAsTypeExpressions: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_UnionsAsTypeExpressions.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_UnionsAsTypeExpressions;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge() {
  $c_O.call(this);
  this.restrictions$1 = null;
  this.keepEditingInfo$1 = false;
  this.domainElemdomainElementArrayMergeStrategy$1 = null;
  this.extensionId$1 = null;
  this.extensionLocation$1 = null;
  this.preMergeTransform$1 = null;
  this.errorHandler$1 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype.forbiddenInsertionError__p1__Lamf_core_parser_FieldEntry__V = (function(entry) {
  if ((entry === null)) {
    throw new $c_s_MatchError().init___O(entry)
  };
  var field = entry.field$1;
  var value = entry.value$1;
  var x1$2 = entry.value$1.value$1;
  if ($is_Lamf_core_model_domain_AmfObject(x1$2)) {
    var x2 = $as_Lamf_core_model_domain_AmfObject(x1$2);
    var _1 = x2.id__T();
    var _2 = x2.annotations__Lamf_core_parser_Annotations();
    var x1$3_$_$$und1$f = _1;
    var x1$3_$_$$und2$f = _2
  } else if ((x1$2 instanceof $c_Lamf_core_model_domain_AmfArray)) {
    var x3 = $as_Lamf_core_model_domain_AmfArray(x1$2);
    var this$1 = value.annotations$1;
    if (this$1.amf$core$parser$Annotations$$annotations$1.nonEmpty__Z()) {
      var ann = value.annotations$1
    } else {
      var this$2 = x3.values$1.headOption__s_Option();
      if (this$2.isEmpty__Z()) {
        var this$3 = $m_s_None$()
      } else {
        var arg1 = this$2.get__O();
        var x$7 = $as_Lamf_core_model_domain_AmfElement(arg1);
        var this$3 = new $c_s_Some().init___O(x$7.annotations__Lamf_core_parser_Annotations())
      };
      var ann = $as_Lamf_core_parser_Annotations((this$3.isEmpty__Z() ? ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()) : this$3.get__O()))
    };
    var this$5 = field.value$1;
    var _1$1 = $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this$5);
    var x1$3_$_$$und1$f = _1$1;
    var x1$3_$_$$und2$f = ann
  } else {
    var this$6 = field.value$1;
    var _1$2 = $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this$6);
    var _2$1 = entry.value$1.value$1.annotations__Lamf_core_parser_Annotations();
    var x1$3_$_$$und1$f = _1$2;
    var x1$3_$_$$und2$f = _2$1
  };
  var node = $as_T(x1$3_$_$$und1$f);
  var annotations = $as_Lamf_core_parser_Annotations(x1$3_$_$$und2$f);
  var this$8 = this.errorHandler$1;
  var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
  var this$7 = entry.value$1.value$1;
  var message = (((("Property '" + node) + "' of type '") + $objectGetClass(this$7).getSimpleName__T()) + "' is not allowed to be overriden or added in overlays");
  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$8, specification, node, message, annotations)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype.areSameType__p1__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Z = (function(master, overlay) {
  var x = $objectGetClass(master);
  var x$2 = $objectGetClass(overlay);
  return (x === x$2)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype.findElementWithNullKey__p1__Lamf_core_metamodel_domain_templates_KeyField__Lamf_core_model_domain_AmfArray__s_Option = (function(key, master) {
  var this$1 = master.values$1.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, key$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_domain_AmfElement(x0$1$2);
      if ($is_Lamf_core_model_domain_DomainElement(x0$1)) {
        var x2 = $as_Lamf_core_model_domain_DomainElement(x0$1);
        return x2.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option(key$1.key__Lamf_core_metamodel_Field()).isEmpty__Z()
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, key)));
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$11 = $as_Lamf_core_model_domain_AmfElement(arg1);
    return new $c_s_Some().init___O($as_Lamf_core_model_domain_DomainElement(x$11))
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype.incompatibleType__p1__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Z = (function(master, overlay) {
  return (((master instanceof $c_Lamf_core_model_domain_Shape) && (overlay instanceof $c_Lamf_core_model_domain_Shape)) && (!this.areSameType__p1__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Z(master, overlay)))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype.mergeByKeyResult__p1__Lamf_core_model_domain_DomainElement__Z__s_Option__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_resolution_stages_IdTracker__Lamf_core_model_domain_DomainElement = (function(target, asSimpleProperty, existing, obj, field, idTracker) {
  if ((existing instanceof $c_s_Some)) {
    var x2 = $as_s_Some(existing);
    var e = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    if ((!asSimpleProperty)) {
      return this.merge__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_resolution_stages_IdTracker__Lamf_core_model_domain_DomainElement(e, $as_Lamf_core_model_domain_DomainElement(obj.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(target.id__T(), obj.adopted$default$2__sc_Seq())), idTracker)
    }
  };
  var x = $m_s_None$();
  if (((x === existing) && (!this.restrictions$1.allowsNodeInsertionIn__Lamf_core_metamodel_Field__Z(field)))) {
    var this$1 = this.errorHandler$1;
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
    var node = obj.id__T();
    var message = (((("Property of key '" + obj.id__T()) + "' of class '") + $objectGetClass(obj).getSimpleName__T()) + "' is not allowed to be overriden or added in overlays");
    var annotations = obj.annotations__Lamf_core_parser_Annotations();
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$1, specification, node, message, annotations);
    return obj
  };
  var id = target.id__T();
  return $as_Lamf_core_model_domain_DomainElement($f_Lamf_plugins_document_webapi_resolution_stages_InnerAdoption__adoptInner__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_document_webapi_resolution_stages_IdTracker__Lamf_core_model_domain_AmfElement(this, id, obj, idTracker))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype.buildElementByKeyMap__p1__Lamf_core_metamodel_domain_templates_KeyField__Lamf_core_model_domain_AmfArray__sci_Map = (function(key, master) {
  var jsx$4 = master.values$1;
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$12$2) {
      var x$12 = $as_Lamf_core_model_domain_AmfElement(x$12$2);
      return $as_Lamf_core_model_domain_DomainElement(x$12)
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$1.ReusableCBFInstance$2));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, key$1) {
    return (function(element$2) {
      var element = $as_Lamf_core_model_domain_DomainElement(element$2);
      var this$3 = element.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option(key$1.key__Lamf_core_metamodel_Field());
      if (this$3.isEmpty__Z()) {
        var xo = $m_s_None$()
      } else {
        var arg1 = this$3.get__O();
        var x$13 = $as_Lamf_core_parser_FieldEntry(arg1);
        var self = $as_Lamf_core_model_domain_AmfScalar(x$13.value$1.value$1).value$1;
        var xo = new $c_s_Some().init___O(new $c_T2().init___O__O(self, element))
      };
      return xo.toList__sci_List()
    })
  })(this, key));
  var this$7 = $m_sc_Seq$();
  return $as_sc_TraversableOnce(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype.mergeArrays__p1__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_metamodel_Type__Lamf_core_model_domain_AmfArray__Lamf_core_model_domain_AmfArray__V = (function(target, field, element, main, other) {
  if ((element instanceof $c_Lamf_core_metamodel_Type$Scalar)) {
    this.mergeScalarArrays__p1__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfArray__Lamf_core_model_domain_AmfArray__V(target, field, main, other)
  } else if ($is_Lamf_core_metamodel_domain_templates_KeyField(element)) {
    var x3 = $as_Lamf_core_metamodel_domain_templates_KeyField(element);
    this.mergeByKeyValue__p1__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_metamodel_domain_templates_KeyField__Lamf_core_model_domain_AmfArray__Lamf_core_model_domain_AmfArray__V(target, field, x3, main, other)
  } else if ($is_Lamf_core_metamodel_domain_DomainElementModel(element)) {
    this.domainElemdomainElementArrayMergeStrategy$1.merge__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfArray__T__s_Option__V(target, field, other, this.extensionId$1, this.extensionLocation$1)
  } else {
    var this$1 = this.errorHandler$1;
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
    var node = this.extensionId$1;
    var message = (("Cannot merge '" + element) + "': not a KeyField nor a Scalar");
    var annotations = target.annotations__Lamf_core_parser_Annotations();
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$1, specification, node, message, annotations)
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype.init___Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions__Z__Lamf_plugins_document_webapi_resolution_stages_DomainElementArrayMergeStrategy__T__s_Option__Lamf_plugins_document_webapi_resolution_stages_PreMergeTransform__Lamf_core_errorhandling_ErrorHandler = (function(restrictions, keepEditingInfo, domainElemdomainElementArrayMergeStrategy, extensionId, extensionLocation, preMergeTransform, errorHandler) {
  this.restrictions$1 = restrictions;
  this.keepEditingInfo$1 = keepEditingInfo;
  this.domainElemdomainElementArrayMergeStrategy$1 = domainElemdomainElementArrayMergeStrategy;
  this.extensionId$1 = extensionId;
  this.extensionLocation$1 = extensionLocation;
  this.preMergeTransform$1 = preMergeTransform;
  this.errorHandler$1 = errorHandler;
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype.mergeScalarArrays__p1__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfArray__Lamf_core_model_domain_AmfArray__V = (function(target, field, main, other) {
  var jsx$2 = main.values$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$10$2) {
      var x$10 = $as_Lamf_core_model_domain_AmfElement(x$10$2);
      return $as_Lamf_core_model_domain_AmfScalar(x$10).value$1
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var existing = $as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).toSet__sci_Set();
  other.scalars__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, existing$1, target$1, field$1) {
    return (function(scalarValue$2) {
      var scalarValue = $as_Lamf_core_model_domain_AmfScalar(scalarValue$2);
      var scalar = scalarValue.value$1;
      if ((!existing$1.contains__O__Z(scalar))) {
        var scalarValue$2$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(scalar, new $c_Lamf_core_parser_Annotations().init___());
        if (this$2.keepEditingInfo$1) {
          scalarValue$2$1.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance().init___T__s_Option(this$2.extensionId$1, this$2.extensionLocation$1))
        };
        return $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(target$1, field$1, scalarValue$2$1)
      } else {
        return (void 0)
      }
    })
  })(this, existing, target, field)))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype.isSimpleProperty__p1__Lamf_core_metamodel_domain_templates_KeyField__Z = (function(key) {
  var x$2 = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$();
  if (((key !== null) && (key === x$2))) {
    var jsx$2 = true
  } else {
    var x$4 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$();
    var jsx$2 = ((key !== null) && (key === x$4))
  };
  if (jsx$2) {
    var jsx$1 = true
  } else {
    var x$6 = $m_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$();
    var jsx$1 = ((key !== null) && (key === x$6))
  };
  if (jsx$1) {
    return true
  } else {
    var x$8 = $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$();
    return ((key !== null) && (key === x$8))
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype.mergeField__p1__Lamf_core_parser_FieldEntry__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_resolution_stages_IdTracker__V = (function(entry, master, overlay, idTracker) {
  if ((entry === null)) {
    throw new $c_s_MatchError().init___O(entry)
  };
  var field = entry.field$1;
  var value = entry.value$1;
  var rc8 = false;
  var x4 = null;
  var rc9 = false;
  var x2 = null;
  var x1$2 = master.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option(field);
  matchEnd10: {
    var x = $m_s_None$();
    if ((x === x1$2)) {
      rc8 = true;
      x4 = x1$2;
      if (this.restrictions$1.allowsNodeInsertionIn__Lamf_core_metamodel_Field__Z(field)) {
        this.insertNode__p1__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_resolution_stages_IdTracker__Lamf_core_parser_FieldEntry__V(master, idTracker, entry);
        break matchEnd10
      }
    };
    if (rc8) {
      var x$5 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
      if (((field === null) ? (x$5 === null) : field.equals__O__Z(x$5))) {
        var jsx$1 = value.annotations$1.contains__jl_Class__Z($d_Lamf_plugins_document_webapi_annotations_Inferred.getClassOf())
      } else {
        var jsx$1 = false
      }
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      break matchEnd10
    };
    if (rc8) {
      this.forbiddenInsertionError__p1__Lamf_core_parser_FieldEntry__V(entry);
      break matchEnd10
    };
    if ((x1$2 instanceof $c_s_Some)) {
      rc9 = true;
      x2 = $as_s_Some(x1$2);
      var existing = $as_Lamf_core_parser_FieldEntry(x2.value$2);
      if (this.restrictions$1.allowsOverride__Lamf_core_metamodel_Field__Z(field)) {
        var x1$3 = field.type$1;
        if ((x1$3 instanceof $c_Lamf_core_metamodel_Type$Scalar)) {
          if (this.keepEditingInfo$1) {
            entry.value$1.value$1.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance().init___T__s_Option(this.extensionId$1, this.extensionLocation$1))
          };
          var value$1 = entry.value$1.value$1;
          $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(master, field, value$1)
        } else if ((x1$3 instanceof $c_Lamf_core_metamodel_Type$ArrayLike)) {
          var x2$2 = $as_Lamf_core_metamodel_Type$ArrayLike(x1$3);
          var o13 = new $c_s_Some().init___O(x2$2.element__Lamf_core_metamodel_Type());
          var element = $as_Lamf_core_metamodel_Type(o13.value$2);
          this.mergeArrays__p1__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_metamodel_Type__Lamf_core_model_domain_AmfArray__Lamf_core_model_domain_AmfArray__V(master, field, element, $as_Lamf_core_model_domain_AmfArray(existing.value$1.value$1), $as_Lamf_core_model_domain_AmfArray(entry.value$1.value$1))
        } else {
          var x$6 = $m_Lamf_core_metamodel_domain_DataNodeModel$();
          if ((x$6 === x1$3)) {
            this.mergeDataNode__p1__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__V(master, field, $as_Lamf_core_model_domain_DomainElement(existing.value$1.value$1), $as_Lamf_core_model_domain_DomainElement(entry.value$1.value$1))
          } else if (($is_Lamf_core_metamodel_domain_ShapeModel(x1$3) && this.incompatibleType__p1__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(existing.value$1.value$1), $as_Lamf_core_model_domain_DomainElement(entry.value$1.value$1)))) {
            var value$2 = $as_Lamf_core_model_domain_DomainElement(entry.value$1.value$1);
            $m_Lamf_core_parser_Annotations$();
            var annotation = new $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance().init___T__s_Option(overlay.id__T(), this.extensionLocation$1);
            var annotations = new $c_Lamf_core_parser_Annotations().init___().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(annotation);
            $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(master, field, value$2, annotations)
          } else if ($is_Lamf_core_metamodel_domain_DomainElementModel(x1$3)) {
            this.merge__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_resolution_stages_IdTracker__Lamf_core_model_domain_DomainElement($as_Lamf_core_model_domain_DomainElement(existing.value$1.value$1), $as_Lamf_core_model_domain_DomainElement(entry.value$1.value$1), idTracker)
          } else {
            var this$3 = this.errorHandler$1;
            var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
            var node = field.value$1.iri__T();
            var message = (("Cannot merge '" + field.type$1) + "':not a (Scalar|Array|Object)");
            var annotations$1 = entry.value$1.value$1.annotations__Lamf_core_parser_Annotations();
            $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$3, specification, node, message, annotations$1)
          }
        };
        break matchEnd10
      }
    };
    if (rc9) {
      var existing$2 = $as_Lamf_core_parser_FieldEntry(x2.value$2);
      if ((!this.isSameValue__p1__Lamf_core_parser_FieldEntry__Lamf_core_parser_FieldEntry__Z(existing$2, entry))) {
        var this$5 = this.errorHandler$1;
        var specification$1 = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
        var node$1 = field.value$1.iri__T();
        var this$4 = existing$2.field$1;
        var message$1 = (((("Property '" + this$4.value$1.iri__T()) + "' in '") + $objectGetClass(master).getSimpleName__T()) + "' is not allowed to be overriden or added in overlays");
        var annotations$2 = value.annotations$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$5, specification$1, node$1, message$1, annotations$2);
        break matchEnd10
      } else {
        break matchEnd10
      }
    };
    throw new $c_s_MatchError().init___O(x1$2)
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype.ignored__p1__Lamf_core_parser_FieldEntry__Lamf_core_model_domain_DomainElement__Z = (function(entry, domainElement) {
  var x1 = entry.field$1;
  var x = $m_Lamf_core_metamodel_domain_DomainElementModel$().Sources$1;
  if (((x === null) ? (x1 === null) : x.equals__O__Z(x1))) {
    var jsx$1 = true
  } else {
    var x$3 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1;
    var jsx$1 = ((x$3 === null) ? (x1 === null) : x$3.equals__O__Z(x1))
  };
  if ((!jsx$1)) {
    var x$5 = $m_Lamf_core_metamodel_document_ExtensionLikeModel$().Extends$1;
    return (!(((x$5 === null) ? (x1 === null) : x$5.equals__O__Z(x1)) && $is_Lamf_core_metamodel_document_ExtensionLikeModel(domainElement)))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype.mergeDataNode__p1__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__V = (function(master, field, existing, overlay) {
  matchEnd5: {
    if ((existing instanceof $c_Lamf_core_model_domain_DataNode)) {
      var x2 = $as_Lamf_core_model_domain_DataNode(existing);
      if ((overlay instanceof $c_Lamf_core_model_domain_DataNode)) {
        var x3 = $as_Lamf_core_model_domain_DataNode(overlay);
        if (this.areSameType__p1__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Z(existing, overlay)) {
          $m_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$().merge__Lamf_core_model_domain_DataNode__Lamf_core_model_domain_DataNode__V(x2, x3);
          break matchEnd5
        }
      }
    };
    if (this.keepEditingInfo$1) {
      overlay.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance().init___T__s_Option(this.extensionId$1, this.extensionLocation$1))
    };
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(master, field, overlay)
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype.mergeByKeyValue__p1__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_metamodel_domain_templates_KeyField__Lamf_core_model_domain_AmfArray__Lamf_core_model_domain_AmfArray__V = (function(target, field, key, master, extension) {
  var asSimpleProperty = this.isSimpleProperty__p1__Lamf_core_metamodel_domain_templates_KeyField__Z(key);
  var elem = this.buildElementByKeyMap__p1__Lamf_core_metamodel_domain_templates_KeyField__Lamf_core_model_domain_AmfArray__sci_Map(key, master);
  var existing = new $c_sr_ObjectRef().init___O(elem);
  var elem$1 = this.findElementWithNullKey__p1__Lamf_core_metamodel_domain_templates_KeyField__Lamf_core_model_domain_AmfArray__s_Option(key, master);
  var nullKey = new $c_sr_ObjectRef().init___O(elem$1);
  extension.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, key$1, existing$1, target$1, asSimpleProperty$1, field$1, nullKey$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_domain_AmfElement(x0$1$2);
      if ($is_Lamf_core_model_domain_DomainElement(x0$1)) {
        var x2 = $as_Lamf_core_model_domain_DomainElement(x0$1);
        var tracker = new $c_Lamf_plugins_document_webapi_resolution_stages_IdTracker().init___();
        var x1$2 = x2.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option(key$1.key__Lamf_core_metamodel_Field());
        if ((x1$2 instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(x1$2);
          var value = $as_Lamf_core_parser_FieldEntry(x2$2.value$2);
          var keyValue = $as_Lamf_core_model_domain_AmfScalar(value.value$1.value$1).value$1;
          var jsx$1 = $as_sci_Map(existing$1.elem$1);
          var y = $this.mergeByKeyResult__p1__Lamf_core_model_domain_DomainElement__Z__s_Option__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_resolution_stages_IdTracker__Lamf_core_model_domain_DomainElement(target$1, asSimpleProperty$1, $as_sci_Map(existing$1.elem$1).get__O__s_Option(keyValue), x2, field$1, tracker);
          existing$1.elem$1 = jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(keyValue, y))
        } else {
          nullKey$1.elem$1 = new $c_s_Some().init___O($this.mergeByKeyResult__p1__Lamf_core_model_domain_DomainElement__Z__s_Option__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_resolution_stages_IdTracker__Lamf_core_model_domain_DomainElement(target$1, asSimpleProperty$1, $as_s_Option(nullKey$1.elem$1), x2, field$1, tracker))
        }
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, key, existing, target, asSimpleProperty, field, nullKey)));
  var this$5 = $as_sci_Map(existing.elem$1);
  var this$6 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$5);
  var jsx$3 = this$6.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream();
  var xo = $as_s_Option(nullKey.elem$1);
  var jsx$2 = xo.toList__sci_List();
  var this$8 = $m_sc_Seq$();
  var values = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$8.ReusableCBFInstance$2));
  $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(target, field, values)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype.merge__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_resolution_stages_IdTracker__Lamf_core_model_domain_DomainElement = (function(master, overlay, idTracker) {
  var x$2 = master.id__T();
  var x$1 = overlay.id__T();
  var this$1 = $m_sci_Nil$();
  var this$2 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$1);
  var ids = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$2);
  if (idTracker.notTracking__sc_Seq__Z(ids)) {
    var this$3 = idTracker.knownIds$1;
    $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$3, ids);
    this.cleanSynthesizedFacets__p1__Lamf_core_model_domain_DomainElement__V(master);
    var this$4 = this.preMergeTransform$1.transform__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(master, overlay).fields__Lamf_core_parser_Fields();
    var this$7 = this$4.fs$1;
    var this$5 = $m_Lamf_core_parser_FieldEntry$();
    var f = $f_F2__tupled__F1(this$5);
    var this$6 = $m_sci_Iterable$();
    var bf = this$6.ReusableCBFInstance$2;
    $as_sc_IterableLike($as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$7, f, bf)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, master$1) {
      return (function(f$2) {
        var f$1 = $as_Lamf_core_parser_FieldEntry(f$2);
        return $this.ignored__p1__Lamf_core_parser_FieldEntry__Lamf_core_model_domain_DomainElement__Z(f$1, master$1)
      })
    })(this, master)))).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, master$2, overlay$1, idTracker$1) {
      return (function(x$3$2) {
        var x$3 = $as_Lamf_core_parser_FieldEntry(x$3$2);
        this$2$1.mergeField__p1__Lamf_core_parser_FieldEntry__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_resolution_stages_IdTracker__V(x$3, master$2, overlay$1, idTracker$1)
      })
    })(this, master, overlay, idTracker)))
  };
  return master
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype.cleanSynthesizedFacets__p1__Lamf_core_model_domain_DomainElement__V = (function(domain) {
  if ((domain instanceof $c_Lamf_core_model_domain_Shape)) {
    var x2 = $as_Lamf_core_model_domain_Shape(domain);
    x2.annotations__Lamf_core_parser_Annotations().reject__F1__Lamf_core_parser_Annotations(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$9$2) {
        var x$9 = $as_Lamf_core_model_domain_Annotation(x$9$2);
        return (x$9 instanceof $c_Lamf_core_annotations_SynthesizedField)
      })
    })(this)))
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype.insertNode__p1__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_resolution_stages_IdTracker__Lamf_core_parser_FieldEntry__V = (function(master, idTracker, entry) {
  if ((entry === null)) {
    throw new $c_s_MatchError().init___O(entry)
  };
  var field = entry.field$1;
  var value = entry.value$1;
  var id = master.id__T();
  var target = value.value$1;
  var newValue = $f_Lamf_plugins_document_webapi_resolution_stages_InnerAdoption__adoptInner__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_document_webapi_resolution_stages_IdTracker__Lamf_core_model_domain_AmfElement(this, id, target, idTracker);
  if (this.keepEditingInfo$1) {
    newValue.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance().init___T__s_Option(this.extensionId$1, this.extensionLocation$1))
  };
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(master, field, newValue)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype.isSameValue__p1__Lamf_core_parser_FieldEntry__Lamf_core_parser_FieldEntry__Z = (function(existing, master) {
  var this$1 = existing.value$1;
  var jsx$1 = this$1.value$1.toString__T();
  var this$2 = master.value$1;
  return (jsx$1 === this$2.value$1.toString__T())
});
var $d_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge: 0
}, false, "amf.plugins.document.webapi.resolution.stages.ExtensionDomainElementMerge", {
  Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge: 1,
  O: 1,
  Lamf_plugins_document_webapi_resolution_stages_InnerAdoption: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage() {
  $c_O.call(this);
  this.IriMerger$module$1 = null;
  this.profile$1 = null;
  this.keepEditingInfo$1 = false;
  this.errorHandler$1 = null;
  this.domainElementArrayMergeStrategy$1 = null;
  this.parserEH$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage.prototype.mergeAliases__Lamf_core_model_document_Document__Lamf_core_model_document_ExtensionLike__V = (function(document, extension) {
  var this$1 = extension.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_Aliases.getClassOf());
  var extensionsAliases = $as_Lamf_core_annotations_Aliases((this$1.isEmpty__Z() ? new $c_Lamf_core_annotations_Aliases().init___sci_Set($as_sci_Set($m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))) : this$1.get__O())).aliases$1;
  var this$2 = document.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_Aliases.getClassOf());
  var documentAliases = $as_Lamf_core_annotations_Aliases((this$2.isEmpty__Z() ? new $c_Lamf_core_annotations_Aliases().init___sci_Set($as_sci_Set($m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))) : this$2.get__O())).aliases$1;
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3) {
    return (function(x$2$2) {
      var x$2 = $as_T2(x$2$2);
      return $as_T(x$2.$$und1__O())
    })
  })(this));
  var this$4 = $m_sci_Set$();
  var bf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$4);
  var jsx$1 = $as_sc_GenSetLike($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(extensionsAliases, f, bf));
  var f$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
    return (function(x$3$2) {
      var x$3 = $as_T2(x$3$2);
      return $as_T(x$3.$$und1__O())
    })
  })(this));
  var this$5 = $m_sci_Set$();
  var bf$1 = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$5);
  $as_sc_IterableLike(jsx$1.intersect__sc_GenSet__O($as_sc_GenSet($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(documentAliases, f$1, bf$1)))).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1, extensionsAliases$1, documentAliases$1, document$1) {
    return (function(alias$2) {
      var alias = $as_T(alias$2);
      var this$6 = extensionsAliases$1.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, alias$1) {
        return (function(x$4$2) {
          var x$4 = $as_T2(x$4$2);
          var x = x$4.$$und1__O();
          return ((x === null) ? (alias$1 === null) : $objectEquals(x, alias$1))
        })
      })(this$5$1, alias)));
      if (this$6.isEmpty__Z()) {
        var jsx$2 = $m_s_None$()
      } else {
        var arg1 = this$6.get__O();
        var x$5 = $as_T2(arg1);
        var jsx$2 = new $c_s_Some().init___O($as_T($as_T2(x$5.$$und2__O()).$$und1__O()))
      };
      var extensionFullUrl = $as_T(jsx$2.get__O());
      var this$7 = documentAliases$1.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, alias$3) {
        return (function(x$6$2) {
          var x$6 = $as_T2(x$6$2);
          var x$1 = x$6.$$und1__O();
          return ((x$1 === null) ? (alias$3 === null) : $objectEquals(x$1, alias$3))
        })
      })(this$5$1, alias)));
      if (this$7.isEmpty__Z()) {
        var jsx$3 = $m_s_None$()
      } else {
        var arg1$1 = this$7.get__O();
        var x$7 = $as_T2(arg1$1);
        var jsx$3 = new $c_s_Some().init___O($as_T($as_T2(x$7.$$und2__O()).$$und1__O()))
      };
      var docFullUrl = $as_T(jsx$3.get__O());
      if ((extensionFullUrl !== docFullUrl)) {
        var this$9 = this$5$1.errorHandler__Lamf_core_errorhandling_ErrorHandler();
        var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
        var node = (((((("Conflicting urls for alias '" + alias) + "' and libraries: '") + extensionFullUrl) + "' - '") + docFullUrl) + "'");
        var this$8 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(document$1);
        var message = $as_T((this$8.isEmpty__Z() ? document$1.id$1 : this$8.get__O()));
        var property = $m_s_None$();
        var lexical = $m_s_None$();
        var location = $m_s_None$();
        this$9.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
      }
    })
  })(this, extensionsAliases, documentAliases, document)));
  var totalAliases = $as_sci_Set(extensionsAliases.union__sc_GenSet__sc_Set(documentAliases));
  if ($f_sc_TraversableOnce__nonEmpty__Z(totalAliases)) {
    document.annotations__Lamf_core_parser_Annotations().reject__F1__Lamf_core_parser_Annotations(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1) {
      return (function(x$8$2) {
        var x$8 = $as_Lamf_core_model_domain_Annotation(x$8$2);
        return (x$8 instanceof $c_Lamf_core_annotations_Aliases)
      })
    })(this)));
    document.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_Aliases().init___sci_Set(totalAliases))
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage.prototype.adoptIris__Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_resolution_stages_IdTracker__V = (function(iriMerger, target, tracker) {
  if (tracker.notTracking__T__Z(target.id__T())) {
    var id = target.id__T();
    tracker.knownIds$1.$$plus$eq__O__scm_SetLike(id);
    var this$3 = target.fields__Lamf_core_parser_Fields();
    var fn = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, iriMerger$1, target$1, tracker$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_T2(x0$1$2);
        if ((x0$1 !== null)) {
          var field = $as_Lamf_core_metamodel_Field(x0$1.$$und1__O());
          var value = $as_Lamf_core_parser_Value(x0$1.$$und2__O());
          var x1$2 = field.type$1;
          matchEnd9: {
            var x = $m_Lamf_core_metamodel_Type$Iri$();
            if (x.equals__O__Z(x1$2)) {
              iriMerger$1.merge__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__V(target$1, field, value.value$1);
              break matchEnd9
            };
            if ((x1$2 instanceof $c_Lamf_core_metamodel_Type$ArrayLike)) {
              var x2 = $as_Lamf_core_metamodel_Type$ArrayLike(x1$2);
              var o13 = new $c_s_Some().init___O(x2.element__Lamf_core_metamodel_Type());
              if ($is_Lamf_core_metamodel_domain_DomainElementModel(o13.value$2)) {
                var jsx$2 = $as_Lamf_core_model_domain_AmfArray(value.value$1).values$1;
                var jsx$1 = new $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$$nestedInanonfun$adoptIris$1$1().init___Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage($this);
                var this$2 = $m_sc_Seq$();
                $as_sc_IterableLike(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, iriMerger$2, tracker$1$1) {
                  return (function(x$10$2) {
                    var x$10 = $as_Lamf_core_model_domain_DomainElement(x$10$2);
                    $this$1.adoptIris__Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_resolution_stages_IdTracker__V(iriMerger$2, x$10, tracker$1$1)
                  })
                })($this, iriMerger$1, tracker$1)));
                break matchEnd9
              }
            };
            if ($is_Lamf_core_metamodel_domain_DomainElementModel(x1$2)) {
              $this.adoptIris__Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_resolution_stages_IdTracker__V(iriMerger$1, $as_Lamf_core_model_domain_DomainElement(value.value$1), tracker$1);
              break matchEnd9
            }
          }
        } else {
          throw new $c_s_MatchError().init___O(x0$1)
        }
      })
    })(this, iriMerger, target, tracker));
    this$3.fs$1.foreach__F1__V(fn)
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage.prototype.mergeReferences__Lamf_core_model_document_Document__Lamf_core_model_document_ExtensionLike__T__s_Option__V = (function(document, extension, extensionId, extensionLocation) {
  var jsx$5 = $as_sc_Seq(document.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().References$1));
  var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_document_BaseUnit(x$1$2);
      return x$1.id__T()
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var jsx$3 = $as_sc_TraversableLike(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$4, this$1.ReusableCBFInstance$2));
  var jsx$2 = $m_sc_Seq$();
  var array = [document.id$1, extension.id$1];
  var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
  var this$4 = $m_sc_Seq$();
  var existing = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2));
  var jsx$7 = $as_sc_Seq(extension.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().References$1));
  var jsx$6 = new $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$1().init___Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage(this);
  var this$5 = $m_sc_Seq$();
  var extensionReferences = $as_sc_Seq(jsx$7.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$6, this$5.ReusableCBFInstance$2));
  var jsx$11 = $as_sc_Seq(document.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().References$1));
  var jsx$10 = $as_sc_TraversableLike(extensionReferences.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, existing$1) {
    return (function(unit$2) {
      var unit = $as_Lamf_core_model_document_BaseUnit(unit$2);
      return (!existing$1.contains__O__Z(unit.id__T()))
    })
  })(this, existing))));
  var jsx$9 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, extensionId$1, extensionLocation$1) {
    return (function(unit$3$2) {
      var unit$3 = $as_Lamf_core_model_document_BaseUnit(unit$3$2);
      unit$3.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance().init___T__s_Option(extensionId$1, extensionLocation$1));
      return unit$3
    })
  })(this, extensionId, extensionLocation));
  var this$6 = $m_sc_Seq$();
  var jsx$8 = $as_sc_GenTraversableOnce(jsx$10.map__F1__scg_CanBuildFrom__O(jsx$9, this$6.ReusableCBFInstance$2));
  var this$7 = $m_sc_Seq$();
  var refs = $as_sc_Seq(jsx$11.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$8, this$7.ReusableCBFInstance$2));
  var field = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
  $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(document, field, refs))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage.prototype.init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler = (function(profile, keepEditingInfo, errorHandler) {
  this.profile$1 = profile;
  this.keepEditingInfo$1 = keepEditingInfo;
  this.errorHandler$1 = errorHandler;
  this.domainElementArrayMergeStrategy$1 = new $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anon$1().init___Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage(this);
  this.parserEH$1 = $m_Lamf_client_parse_DefaultParserErrorHandler$().fromErrorHandler__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_errorhandler_AmfParserErrorHandler(errorHandler);
  var x = $m_Lamf_Raml08Profile$();
  if (x.equals__O__Z(profile)) {
    var jsx$2 = $m_sci_Nil$();
    var x$1 = this.parserEH$1;
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$4 = new $c_scm_ListBuffer().init___();
    var x$3 = this$4.toList__sci_List();
    var x$4 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$11 = new $c_scm_ListBuffer().init___();
    var x$5 = new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$11.toList__sci_List());
    var jsx$1 = new $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions("", jsx$2, new $c_Lamf_core_parser_ParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext("", x$3, x$4, x$1, x$5), $m_s_None$(), $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2, new $c_Lamf_core_client_ParsingOptions().init___())
  } else {
    var jsx$3 = $m_sci_Nil$();
    var x$6 = this.parserEH$1;
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$19 = new $c_scm_ListBuffer().init___();
    var x$8 = this$19.toList__sci_List();
    var x$9 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$26 = new $c_scm_ListBuffer().init___();
    var x$10 = new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$26.toList__sci_List());
    var jsx$1 = new $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions("", jsx$3, new $c_Lamf_core_parser_ParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext("", x$8, x$9, x$6, x$10), $m_s_None$(), $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2, new $c_Lamf_core_client_ParsingOptions().init___())
  };
  this.ctx$1 = jsx$1;
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage.prototype.removeExtends__Lamf_core_model_document_Document__Lamf_core_model_document_BaseUnit = (function(document) {
  var this$1 = $as_Lamf_plugins_domain_webapi_models_WebApi(document.encodes__Lamf_core_model_domain_DomainElement());
  $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(endpoint$2) {
      var endpoint = $as_Lamf_plugins_domain_webapi_models_EndPoint(endpoint$2);
      if ((!$this.keepEditingInfo__Z())) {
        endpoint.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field())
      };
      $as_sc_Seq(endpoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
        return (function(operation$2) {
          var operation = $as_Lamf_plugins_domain_webapi_models_Operation(operation$2);
          return ((!$this$1.keepEditingInfo__Z()) ? operation.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field()) : (void 0))
        })
      })($this)))
    })
  })(this)));
  return document
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage.prototype.mergeDeclarations__Lamf_core_model_document_Document__Lamf_core_model_document_ExtensionLike__Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger__T__s_Option__V = (function(master, extension, iriMerger, extensionId, extensionLocation) {
  var declarations = $m_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$().apply__sc_Seq__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations($as_sc_Seq(master.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().Declares$1)), this.ctx$1.eh$1, new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___());
  var mergingTracker = new $c_Lamf_plugins_document_webapi_resolution_stages_IdTracker().init___();
  $as_sc_Seq(extension.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().Declares$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, declarations$1, extensionId$1, extensionLocation$1, mergingTracker$1, master$1) {
    return (function(declaration$2) {
      var declaration = $as_Lamf_core_model_domain_DomainElement(declaration$2);
      var x1 = declarations$1.findEquivalent__Lamf_core_model_domain_DomainElement__s_Option(declaration);
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var equivalent = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
        return new $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge().init___Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions__Z__Lamf_plugins_document_webapi_resolution_stages_DomainElementArrayMergeStrategy__T__s_Option__Lamf_plugins_document_webapi_resolution_stages_PreMergeTransform__Lamf_core_errorhandling_ErrorHandler($this.restrictions__Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions(), $this.keepEditingInfo__Z(), $this.domainElementArrayMergeStrategy$1, extensionId$1, extensionLocation$1, new $c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform().init___Lamf_core_errorhandling_ErrorHandler($this.errorHandler__Lamf_core_errorhandling_ErrorHandler()), $this.errorHandler__Lamf_core_errorhandling_ErrorHandler()).merge__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_resolution_stages_IdTracker__Lamf_core_model_domain_DomainElement(equivalent, declaration, mergingTracker$1)
      } else {
        var x = $m_s_None$();
        if ((x === x1)) {
          var id = (master$1.id$1 + "#/declarations");
          var extendedDeclaration = $as_Lamf_core_model_domain_DomainElement($f_Lamf_plugins_document_webapi_resolution_stages_InnerAdoption__adoptInner__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_document_webapi_resolution_stages_IdTracker__Lamf_core_model_domain_AmfElement($this, id, declaration, mergingTracker$1));
          if ($this.keepEditingInfo__Z()) {
            extendedDeclaration.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance().init___T__s_Option(extensionId$1, extensionLocation$1))
          };
          return declarations$1.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(extendedDeclaration)
        } else {
          throw new $c_s_MatchError().init___O(x1)
        }
      }
    })
  })(this, declarations, extensionId, extensionLocation, mergingTracker, master)));
  var declarables = declarations.declarables__sc_Seq();
  var adoptIrisTracker = new $c_Lamf_plugins_document_webapi_resolution_stages_IdTracker().init___();
  declarables.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, iriMerger$1, adoptIrisTracker$1) {
    return (function(x$9$2) {
      var x$9 = $as_Lamf_core_model_domain_DomainElement(x$9$2);
      this$2.adoptIris__Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_resolution_stages_IdTracker__V(iriMerger$1, x$9, adoptIrisTracker$1)
    })
  })(this, iriMerger, adoptIrisTracker)));
  var field = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
  $as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(master, field, declarables))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage.prototype.resolveOverlay__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_ExtensionLike__Lamf_core_model_document_BaseUnit = (function(model, entryPoint) {
  $m_scm_ListBuffer$();
  var array = [entryPoint];
  if (($uI(array.length) === 0)) {
    var this$4 = new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_ListBuffer().init___());
    var jsx$1 = $as_sc_GenTraversable(this$4.elems$1)
  } else {
    var b = new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_ListBuffer().init___());
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      b.$$plus$eq__O__scm_GrowingBuilder(arg1);
      i = ((1 + i) | 0)
    };
    var jsx$1 = $as_sc_GenTraversable(b.elems$1)
  };
  var x1 = this.extensionsQueue__scm_ListBuffer__Lamf_core_model_document_BaseUnit__sci_List($as_scm_ListBuffer(jsx$1), entryPoint);
  if ((x1 instanceof $c_sci_$colon$colon)) {
    var x2 = $as_sci_$colon$colon(x1);
    var document = $as_Lamf_core_model_document_BaseUnit(x2.head$5);
    var extensions = x2.tl$5;
    if ((document instanceof $c_Lamf_core_model_document_Document)) {
      var x3 = $as_Lamf_core_model_document_Document(document);
      var extendsStage = new $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage().init___Lamf_ProfileName__Z__Z__scm_Set__Lamf_core_errorhandling_ErrorHandler(this.profile__Lamf_ProfileName(), this.keepEditingInfo__Z(), true, $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), this.errorHandler__Lamf_core_errorhandling_ErrorHandler());
      var referenceStage = new $c_Lamf_core_resolution_stages_ReferenceResolutionStage().init___Z__Lamf_core_errorhandling_ErrorHandler(this.keepEditingInfo__Z(), this.errorHandler__Lamf_core_errorhandling_ErrorHandler());
      referenceStage.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(x3);
      var masterTree = $as_Lamf_plugins_domain_webapi_models_WebApi(x3.encodes__Lamf_core_model_domain_DomainElement());
      var these = extensions;
      while ((!these.isEmpty__Z())) {
        var arg1$1 = these.head__O();
        var x0$1 = $as_Lamf_core_model_document_BaseUnit(arg1$1);
        if ((x0$1 instanceof $c_Lamf_core_model_document_ExtensionLike)) {
          var x2$1 = $as_Lamf_core_model_document_ExtensionLike(x0$1);
          referenceStage.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(x2$1);
          var iriMerger = new $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger().init___Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage__T__T(this, (x3.id$1 + "#"), (x2$1.id$1 + "#"));
          this.mergeDeclarations__Lamf_core_model_document_Document__Lamf_core_model_document_ExtensionLike__Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger__T__s_Option__V(x3, x2$1, iriMerger, x2$1.id$1, $m_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$().findUnitLocationOfElement__T__Lamf_core_model_document_BaseUnit__s_Option(x2$1.id$1, model));
          this.mergeAliases__Lamf_core_model_document_Document__Lamf_core_model_document_ExtensionLike__V(x3, x2$1);
          this.mergeReferences__Lamf_core_model_document_Document__Lamf_core_model_document_ExtensionLike__T__s_Option__V(x3, x2$1, x2$1.id$1, $m_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$().findUnitLocationOfElement__T__Lamf_core_model_document_BaseUnit__s_Option(x2$1.id$1, model))
        } else {
          throw new $c_s_MatchError().init___O(x0$1)
        };
        these = $as_sci_List(these.tail__O())
      };
      extendsStage.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(x3);
      var these$1 = extensions;
      while ((!these$1.isEmpty__Z())) {
        var arg1$2 = these$1.head__O();
        var x0$2 = $as_Lamf_core_model_document_BaseUnit(arg1$2);
        if ((x0$2 instanceof $c_Lamf_core_model_document_ExtensionLike)) {
          var x2$2 = $as_Lamf_core_model_document_ExtensionLike(x0$2);
          var iriMerger$1 = new $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger().init___Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage__T__T(this, (x3.id$1 + "#"), (x2$2.id$1 + "#"));
          new $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionDomainElementMerge().init___Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions__Z__Lamf_plugins_document_webapi_resolution_stages_DomainElementArrayMergeStrategy__T__s_Option__Lamf_plugins_document_webapi_resolution_stages_PreMergeTransform__Lamf_core_errorhandling_ErrorHandler(this.restrictions__Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions(), this.keepEditingInfo__Z(), this.domainElementArrayMergeStrategy$1, x2$2.id$1, $m_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$().findUnitLocationOfElement__T__Lamf_core_model_document_BaseUnit__s_Option(x2$2.id$1, model), new $c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler__Lamf_core_errorhandling_ErrorHandler()), this.errorHandler__Lamf_core_errorhandling_ErrorHandler()).merge__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_resolution_stages_IdTracker__Lamf_core_model_domain_DomainElement(masterTree, $as_Lamf_core_model_domain_DomainElement(x2$2.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().Encodes$1)), new $c_Lamf_plugins_document_webapi_resolution_stages_IdTracker().init___());
          this.adoptIris__Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_resolution_stages_IdTracker__V(iriMerger$1, masterTree, new $c_Lamf_plugins_document_webapi_resolution_stages_IdTracker().init___());
          $as_Lamf_core_model_document_Document(extendsStage.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(x3))
        } else {
          throw new $c_s_MatchError().init___O(x0$2)
        };
        these$1 = $as_sci_List(these$1.tail__O())
      };
      return this.removeExtends__Lamf_core_model_document_Document__Lamf_core_model_document_BaseUnit(x3)
    }
  };
  return model
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage.prototype.extensionsQueue__scm_ListBuffer__Lamf_core_model_document_BaseUnit__sci_List = (function(collector, model) {
  if ((model instanceof $c_Lamf_core_model_document_ExtensionLike)) {
    var x2 = $as_Lamf_core_model_document_ExtensionLike(model);
    var id = $as_T(x2.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_ExtensionLikeModel$().Extends$1));
    var x1$2 = $f_Lamf_core_model_document_BaseUnit__findInReferences__T__s_Option(model, id);
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var e = $as_Lamf_core_model_document_BaseUnit(x2$2.value$2);
      collector.$$plus$eq__O__scm_ListBuffer(e);
      return this.extensionsQueue__scm_ListBuffer__Lamf_core_model_document_BaseUnit__sci_List(collector, e)
    } else {
      var x = $m_s_None$();
      if (((x === x1$2) && $m_s_Option$().apply__O__s_Option($as_T(x2.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_ExtensionLikeModel$().Extends$1))).isDefined__Z())) {
        var this$1 = this.errorHandler__Lamf_core_errorhandling_ErrorHandler();
        var specification = $m_Lamf_validations_ResolutionSideValidations$().MissingExtensionInReferences$1;
        var target = new $c_s_Some().init___O($as_T(x2.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_ExtensionLikeModel$().Extends$1)));
        var message = (("BaseUnit '" + $as_T(x2.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_ExtensionLikeModel$().Extends$1))) + "' not found in references.");
        var node = model.id__T();
        var lexical = model.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
        var location = $f_Lamf_core_model_document_BaseUnit__location__s_Option(model);
        this$1.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, target, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
        return $m_sci_Nil$()
      } else {
        var this$2 = this.errorHandler__Lamf_core_errorhandling_ErrorHandler();
        var specification$1 = $m_Lamf_validations_ResolutionSideValidations$().MissingExtensionInReferences$1;
        var target$1 = new $c_s_Some().init___O($as_T(x2.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_ExtensionLikeModel$().Extends$1)));
        var message$1 = (("Missing extend property for model '" + model.id__T()) + "'.");
        var node$1 = model.id__T();
        var lexical$1 = model.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
        var location$1 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(model);
        this$2.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification$1.id$1, node$1, target$1, message$1, lexical$1, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location$1);
        return $m_sci_Nil$()
      }
    }
  } else {
    return $as_scm_ListBuffer($f_sc_SeqLike__reverse__O(collector)).toList__sci_List()
  }
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anon$1() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anon$1.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anon$1.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anon$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anon$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anon$1.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anon$1.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anon$1.prototype.init___Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anon$1.prototype.merge__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfArray__T__s_Option__V = (function(target, field, o, extensionId, extensionLocation) {
  this.$$outer$1.setDomainElementArrayValue__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfArray__T__s_Option__V(target, field, o, extensionId, extensionLocation)
});
var $d_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anon$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anon$1: 0
}, false, "amf.plugins.document.webapi.resolution.stages.ExtensionLikeResolutionStage$$anon$1", {
  Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anon$1: 1,
  O: 1,
  Lamf_plugins_document_webapi_resolution_stages_DomainElementArrayMergeStrategy: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anon$1.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anon$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform() {
  $c_O.call(this);
  this.errorHandler$1 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform.prototype.transformStructuredValue__p1__Lamf_plugins_domain_shapes_models_Example__Lamf_plugins_domain_shapes_models_Example = (function(example) {
  var this$2 = $m_Lorg_yaml_model_YDocument$().apply__T__Lorg_yaml_model_YDocument$WithComment("");
  var b = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(this$2.org$yaml$model$YDocument$WithComment$$sourceName$f);
  var x = this$2.comment$1;
  var this$4 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$4)) {
    b.comment__T__V(this$2.comment$1)
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler($as_Lamf_core_model_domain_DataNode(example.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1)), $m_Lamf_core_emitter_SpecOrdering$Lexical$(), false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.errorHandler$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b);
  var node = new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this$2.org$yaml$model$YDocument$WithComment$$sourceName$f), b.builder$1).node$2;
  var jsx$1 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var x$1$3 = new $c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform$ParserErrorHandlerAdapter().init___Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform__I__Lamf_core_errorhandling_ErrorHandler(this, (-1), this.errorHandler$1);
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$9 = new $c_scm_ListBuffer().init___();
  var x$3 = this$9.toList__sci_List();
  var x$4 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$16 = new $c_scm_ListBuffer().init___();
  var x$5 = new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$16.toList__sci_List());
  var dummyCtx = new $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions("", jsx$1, new $c_Lamf_core_parser_ParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext("", x$3, x$4, x$1$3, x$5), $m_s_None$(), $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2, new $c_Lamf_core_client_ParsingOptions().init___());
  var result = new $c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser().init___Lorg_yaml_model_YNode__T__Z__Z__Z__Lamf_plugins_document_webapi_contexts_WebApiContext(node, example.id$1, true, false, false, dummyCtx).parse__Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult();
  var this$21 = result.dataNode$1;
  if ((!this$21.isEmpty__Z())) {
    var arg1 = this$21.get__O();
    var dataNode = $as_Lamf_core_model_domain_DataNode(arg1);
    var field = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1;
    var annotations = $as_Lamf_core_model_domain_DataNode(example.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1)).annotations__Lamf_core_parser_Annotations();
    $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(example, field, dataNode, annotations))
  };
  return example
});
$c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform.prototype.transform__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement = (function(main, overlay) {
  var _3 = overlay.meta__Lamf_core_metamodel_Obj();
  if (((main instanceof $c_Lamf_core_model_domain_Shape) && (overlay instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape))) {
    var x5 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(overlay);
    var x = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$();
    if (((x === _3) && this.hasInferredType__p1__Lamf_plugins_domain_shapes_models_ScalarShape__Z(x5))) {
      return this.transformExamplesOf__p1__Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_core_model_domain_DomainElement(x5)
    }
  };
  return overlay
});
$c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform.prototype.hasInferredType__p1__Lamf_plugins_domain_shapes_models_ScalarShape__Z = (function(scalar) {
  var x1 = scalar.fields$2.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var p3 = $as_Lamf_core_parser_FieldEntry(x2.value$2);
    if ((p3 !== null)) {
      var value = p3.value$1;
      return value.annotations$1.contains__jl_Class__Z($d_Lamf_plugins_document_webapi_annotations_Inferred.getClassOf())
    }
  };
  var x = $m_s_None$();
  if ((x === x1)) {
    return false
  };
  throw new $c_s_MatchError().init___O(x1)
});
$c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform.prototype.transformExamplesOf__p1__Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_core_model_domain_DomainElement = (function(shape) {
  var jsx$2 = $as_sc_Seq(shape.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(e$2) {
      var e = $as_Lamf_plugins_domain_shapes_models_Example(e$2);
      return $this.transformStructuredValue__p1__Lamf_plugins_domain_shapes_models_Example__Lamf_plugins_domain_shapes_models_Example(e)
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var examples = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  var field = $m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1;
  return $as_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(shape, field, examples))
});
$c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  this.errorHandler$1 = errorHandler;
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform: 0
}, false, "amf.plugins.document.webapi.resolution.stages.InferredOverlayTypeExampleTransform", {
  Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform: 1,
  O: 1,
  Lamf_plugins_document_webapi_resolution_stages_PreMergeTransform: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$2() {
  $c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$2.prototype = new $h_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions();
$c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$2.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$2.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$2.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$2.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$2.prototype.allowsNodeInsertionIn__Lamf_core_metamodel_Field__Z = (function(field) {
  return true
});
$c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$2.prototype.allowsOverride__Lamf_core_metamodel_Field__Z = (function(field) {
  return true
});
var $d_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$2: 0
}, false, "amf.plugins.document.webapi.resolution.stages.MergingRestrictions$$anon$2", {
  Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$2: 1,
  Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$2.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$3() {
  $c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions.call(this);
  this.allowedFields$2 = null;
  this.allowedScalarFieldsInObject$2 = null;
  this.blockedObjectFields$2 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$3.prototype = new $h_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions();
$c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$3.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$3;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$3() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$3.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$3.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$3.prototype.init___ = (function() {
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_core_metamodel_domain_common_NameFieldShacl$().Name$1, $m_Lamf_core_metamodel_domain_common_NameFieldSchema$().Name$1, $m_Lamf_core_metamodel_domain_common_DisplayNameField$().DisplayName$1, $m_Lamf_core_metamodel_domain_ShapeModel$().DisplayName$1, $m_Lamf_core_metamodel_domain_common_DescriptionField$().Description$1, $m_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$().Documentation$1, $m_Lamf_plugins_domain_webapi_metamodel_TagModel$().Documentation$1, $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Documentations$1, $m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1, $m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1, $m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field()];
  this.allowedFields$2 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  var jsx$2 = $m_sc_Seq$();
  var array$1 = [$m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1, $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Method$1, $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1, $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1];
  this.allowedScalarFieldsInObject$2 = $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)));
  var jsx$3 = $m_sc_Seq$();
  var array$2 = [$m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Servers$1];
  this.blockedObjectFields$2 = $as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2)));
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$3.prototype.isAllowedObjectField__p2__Lamf_core_metamodel_Field__Z = (function(field) {
  return (!this.blockedObjectFields$2.contains__O__Z(field))
});
$c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$3.prototype.allowsNodeInsertionIn__Lamf_core_metamodel_Field__Z = (function(field) {
  return this.allowedFields$2.contains__O__Z(field)
});
$c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$3.prototype.allowsOverride__Lamf_core_metamodel_Field__Z = (function(field) {
  var x1 = field.type$1;
  return ((x1 instanceof $c_Lamf_core_metamodel_Type$Scalar) ? (this.allowedFields$2.contains__O__Z(field) || this.allowedScalarFieldsInObject$2.contains__O__Z(field)) : (this.allowedFields$2.contains__O__Z(field) || this.isAllowedObjectField__p2__Lamf_core_metamodel_Field__Z(field)))
});
var $d_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$3 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$3: 0
}, false, "amf.plugins.document.webapi.resolution.stages.MergingRestrictions$$anon$3", {
  Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$3: 1,
  Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$3.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$$anon$3;
function $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$RamlAndOasValidations__amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result__sc_Seq($thiz) {
  var jsx$5 = $thiz.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result__sc_Seq();
  var jsx$4 = $m_sc_Seq$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var name = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().doc$1.displayName$1;
  var ns = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns, name);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$1, "binding");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$2 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$2, "in");
  var x$7 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$3 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$9 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$3, "path");
  var x$10 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$3 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$7, "", x$1, x$2, x$9, x$3, "query,path,header,uri,cookie", "Binding information for a parameter with an invalid value", "'in' property of a parameter with an invalid value", x$10);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$4 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$11 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$4, "EndPoint");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$5 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$12 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$5, "path");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$6 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$13 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$6, "pattern");
  var x$17 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$7 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$19 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$7, "path");
  var x$20 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$2 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$17, "", x$11, x$12, x$19, x$13, "^/", "Resource path must start with a '/'", "PathItem path must start with a '/'", x$20);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$8 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$21 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$8, "Operation");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$9 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$22 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$9, "method");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$10 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$23 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$10, "in");
  var x$27 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$11 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$29 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$11, "path");
  var x$30 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var array = [jsx$3, jsx$2, $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$27, "", x$21, x$22, x$29, x$23, "get,put,post,delete,options,head,patch,connect,trace", "Unknown method type", "Unknown Operation method", x$30)];
  var jsx$1 = jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
  var this$36 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$36.ReusableCBFInstance$2))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$.prototype = $c_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$.prototype;
$c_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$.prototype.parsePropertyConstraint__p1__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation__Lamf_core_vocabulary_ValueType__Lamf_core_validation_core_PropertyConstraint = (function(constraintUri, validation, sh) {
  var x$1 = validation.owlProperty$1;
  var x$3 = validation.message$1;
  var x$4 = $m_s_None$();
  var x$5 = $m_s_None$();
  var x$6 = $m_s_None$();
  var x$7 = $m_s_None$();
  var x$8 = $m_s_None$();
  var x$9 = $m_s_None$();
  var x$10 = $m_s_None$();
  var x$11 = $m_s_None$();
  var x$12 = $m_s_None$();
  var x$13 = $m_s_None$();
  var x$14 = $m_s_None$();
  var x$15 = $m_s_None$();
  var x$16 = $m_s_None$();
  var x$17 = $m_s_None$();
  var x$18 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$19 = new $c_scm_ListBuffer().init___();
  var x$19 = this$19.toList__sci_List();
  var x$20 = $m_s_None$();
  var x$21 = $m_s_None$();
  var x$22 = $m_s_None$();
  var x$23 = $m_s_None$();
  var x$24 = $m_s_None$();
  var x$25 = $m_s_None$();
  var x$26 = $m_s_None$();
  var x$27 = $m_s_None$();
  var x$28 = $m_s_None$();
  var constraint = new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$1, constraintUri, x$4, x$3, x$5, x$6, x$7, x$8, x$9, x$10, x$11, x$12, x$13, x$14, x$15, x$16, x$17, x$18, x$19, x$20, x$21, x$22, x$23, x$24, x$25, x$26, x$27, x$28);
  var x1 = sh.iri__T();
  if ((x1 === "http://www.w3.org/ns/shacl#minCount")) {
    var x$29 = new $c_s_Some().init___O(validation.value$1);
    var x$30 = constraint.ramlPropertyId$1;
    var x$31 = constraint.name$1;
    var x$32 = constraint.path$1;
    var x$33 = constraint.message$1;
    var x$34 = constraint.pattern$1;
    var x$35 = constraint.patternedProperty$1;
    var x$36 = constraint.maxCount$1;
    var x$37 = constraint.minLength$1;
    var x$38 = constraint.maxLength$1;
    var x$39 = constraint.minExclusive$1;
    var x$40 = constraint.maxExclusive$1;
    var x$41 = constraint.minInclusive$1;
    var x$42 = constraint.maxInclusive$1;
    var x$43 = constraint.multipleOf$1;
    var x$44 = constraint.node$1;
    var x$45 = constraint.datatype$1;
    var x$46 = constraint.class$1;
    var x$47 = constraint.in$1;
    var x$48 = constraint.custom$1;
    var x$49 = constraint.customRdf$1;
    var x$50 = constraint.atLeast$1;
    var x$51 = constraint.atMost$1;
    var x$52 = constraint.value$1;
    var x$53 = constraint.equalToProperty$1;
    var x$54 = constraint.disjointWithProperty$1;
    var x$55 = constraint.lessThanProperty$1;
    var x$56 = constraint.lessThanOrEqualsToProperty$1;
    return new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$30, x$31, x$32, x$33, x$34, x$35, x$36, x$29, x$37, x$38, x$39, x$40, x$41, x$42, x$43, x$44, x$45, x$46, x$47, x$48, x$49, x$50, x$51, x$52, x$53, x$54, x$55, x$56)
  } else if ((x1 === "http://www.w3.org/ns/shacl#maxCount")) {
    var x$57 = new $c_s_Some().init___O(validation.value$1);
    var x$58 = constraint.ramlPropertyId$1;
    var x$59 = constraint.name$1;
    var x$60 = constraint.path$1;
    var x$61 = constraint.message$1;
    var x$62 = constraint.pattern$1;
    var x$63 = constraint.patternedProperty$1;
    var x$64 = constraint.minCount$1;
    var x$65 = constraint.minLength$1;
    var x$66 = constraint.maxLength$1;
    var x$67 = constraint.minExclusive$1;
    var x$68 = constraint.maxExclusive$1;
    var x$69 = constraint.minInclusive$1;
    var x$70 = constraint.maxInclusive$1;
    var x$71 = constraint.multipleOf$1;
    var x$72 = constraint.node$1;
    var x$73 = constraint.datatype$1;
    var x$74 = constraint.class$1;
    var x$75 = constraint.in$1;
    var x$76 = constraint.custom$1;
    var x$77 = constraint.customRdf$1;
    var x$78 = constraint.atLeast$1;
    var x$79 = constraint.atMost$1;
    var x$80 = constraint.value$1;
    var x$81 = constraint.equalToProperty$1;
    var x$82 = constraint.disjointWithProperty$1;
    var x$83 = constraint.lessThanProperty$1;
    var x$84 = constraint.lessThanOrEqualsToProperty$1;
    return new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$58, x$59, x$60, x$61, x$62, x$63, x$57, x$64, x$65, x$66, x$67, x$68, x$69, x$70, x$71, x$72, x$73, x$74, x$75, x$76, x$77, x$78, x$79, x$80, x$81, x$82, x$83, x$84)
  } else if ((x1 === "http://www.w3.org/ns/shacl#pattern")) {
    var x$85 = new $c_s_Some().init___O(validation.value$1);
    var x$86 = constraint.ramlPropertyId$1;
    var x$87 = constraint.name$1;
    var x$88 = constraint.path$1;
    var x$89 = constraint.message$1;
    var x$90 = constraint.patternedProperty$1;
    var x$91 = constraint.maxCount$1;
    var x$92 = constraint.minCount$1;
    var x$93 = constraint.minLength$1;
    var x$94 = constraint.maxLength$1;
    var x$95 = constraint.minExclusive$1;
    var x$96 = constraint.maxExclusive$1;
    var x$97 = constraint.minInclusive$1;
    var x$98 = constraint.maxInclusive$1;
    var x$99 = constraint.multipleOf$1;
    var x$100 = constraint.node$1;
    var x$101 = constraint.datatype$1;
    var x$102 = constraint.class$1;
    var x$103 = constraint.in$1;
    var x$104 = constraint.custom$1;
    var x$105 = constraint.customRdf$1;
    var x$106 = constraint.atLeast$1;
    var x$107 = constraint.atMost$1;
    var x$108 = constraint.value$1;
    var x$109 = constraint.equalToProperty$1;
    var x$110 = constraint.disjointWithProperty$1;
    var x$111 = constraint.lessThanProperty$1;
    var x$112 = constraint.lessThanOrEqualsToProperty$1;
    return new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$86, x$87, x$88, x$89, x$85, x$90, x$91, x$92, x$93, x$94, x$95, x$96, x$97, x$98, x$99, x$100, x$101, x$102, x$103, x$104, x$105, x$106, x$107, x$108, x$109, x$110, x$111, x$112)
  } else if ((x1 === "http://www.w3.org/ns/shacl#minExclusive")) {
    var x$113 = new $c_s_Some().init___O(validation.value$1);
    var x$114 = constraint.ramlPropertyId$1;
    var x$115 = constraint.name$1;
    var x$116 = constraint.path$1;
    var x$117 = constraint.message$1;
    var x$118 = constraint.pattern$1;
    var x$119 = constraint.patternedProperty$1;
    var x$120 = constraint.maxCount$1;
    var x$121 = constraint.minCount$1;
    var x$122 = constraint.minLength$1;
    var x$123 = constraint.maxLength$1;
    var x$124 = constraint.maxExclusive$1;
    var x$125 = constraint.minInclusive$1;
    var x$126 = constraint.maxInclusive$1;
    var x$127 = constraint.multipleOf$1;
    var x$128 = constraint.node$1;
    var x$129 = constraint.datatype$1;
    var x$130 = constraint.class$1;
    var x$131 = constraint.in$1;
    var x$132 = constraint.custom$1;
    var x$133 = constraint.customRdf$1;
    var x$134 = constraint.atLeast$1;
    var x$135 = constraint.atMost$1;
    var x$136 = constraint.value$1;
    var x$137 = constraint.equalToProperty$1;
    var x$138 = constraint.disjointWithProperty$1;
    var x$139 = constraint.lessThanProperty$1;
    var x$140 = constraint.lessThanOrEqualsToProperty$1;
    return new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$114, x$115, x$116, x$117, x$118, x$119, x$120, x$121, x$122, x$123, x$113, x$124, x$125, x$126, x$127, x$128, x$129, x$130, x$131, x$132, x$133, x$134, x$135, x$136, x$137, x$138, x$139, x$140)
  } else if ((x1 === "http://www.w3.org/ns/shacl#maxExclusive")) {
    var x$141 = new $c_s_Some().init___O(validation.value$1);
    var x$142 = constraint.ramlPropertyId$1;
    var x$143 = constraint.name$1;
    var x$144 = constraint.path$1;
    var x$145 = constraint.message$1;
    var x$146 = constraint.pattern$1;
    var x$147 = constraint.patternedProperty$1;
    var x$148 = constraint.maxCount$1;
    var x$149 = constraint.minCount$1;
    var x$150 = constraint.minLength$1;
    var x$151 = constraint.maxLength$1;
    var x$152 = constraint.minExclusive$1;
    var x$153 = constraint.minInclusive$1;
    var x$154 = constraint.maxInclusive$1;
    var x$155 = constraint.multipleOf$1;
    var x$156 = constraint.node$1;
    var x$157 = constraint.datatype$1;
    var x$158 = constraint.class$1;
    var x$159 = constraint.in$1;
    var x$160 = constraint.custom$1;
    var x$161 = constraint.customRdf$1;
    var x$162 = constraint.atLeast$1;
    var x$163 = constraint.atMost$1;
    var x$164 = constraint.value$1;
    var x$165 = constraint.equalToProperty$1;
    var x$166 = constraint.disjointWithProperty$1;
    var x$167 = constraint.lessThanProperty$1;
    var x$168 = constraint.lessThanOrEqualsToProperty$1;
    return new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$142, x$143, x$144, x$145, x$146, x$147, x$148, x$149, x$150, x$151, x$152, x$141, x$153, x$154, x$155, x$156, x$157, x$158, x$159, x$160, x$161, x$162, x$163, x$164, x$165, x$166, x$167, x$168)
  } else if ((x1 === "http://www.w3.org/ns/shacl#minInclusive")) {
    var x$169 = new $c_s_Some().init___O(validation.value$1);
    var x$170 = constraint.ramlPropertyId$1;
    var x$171 = constraint.name$1;
    var x$172 = constraint.path$1;
    var x$173 = constraint.message$1;
    var x$174 = constraint.pattern$1;
    var x$175 = constraint.patternedProperty$1;
    var x$176 = constraint.maxCount$1;
    var x$177 = constraint.minCount$1;
    var x$178 = constraint.minLength$1;
    var x$179 = constraint.maxLength$1;
    var x$180 = constraint.minExclusive$1;
    var x$181 = constraint.maxExclusive$1;
    var x$182 = constraint.maxInclusive$1;
    var x$183 = constraint.multipleOf$1;
    var x$184 = constraint.node$1;
    var x$185 = constraint.datatype$1;
    var x$186 = constraint.class$1;
    var x$187 = constraint.in$1;
    var x$188 = constraint.custom$1;
    var x$189 = constraint.customRdf$1;
    var x$190 = constraint.atLeast$1;
    var x$191 = constraint.atMost$1;
    var x$192 = constraint.value$1;
    var x$193 = constraint.equalToProperty$1;
    var x$194 = constraint.disjointWithProperty$1;
    var x$195 = constraint.lessThanProperty$1;
    var x$196 = constraint.lessThanOrEqualsToProperty$1;
    return new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$170, x$171, x$172, x$173, x$174, x$175, x$176, x$177, x$178, x$179, x$180, x$181, x$169, x$182, x$183, x$184, x$185, x$186, x$187, x$188, x$189, x$190, x$191, x$192, x$193, x$194, x$195, x$196)
  } else if ((x1 === "http://www.w3.org/ns/shacl#maxInclusive")) {
    var x$197 = new $c_s_Some().init___O(validation.value$1);
    var x$198 = constraint.ramlPropertyId$1;
    var x$199 = constraint.name$1;
    var x$200 = constraint.path$1;
    var x$201 = constraint.message$1;
    var x$202 = constraint.pattern$1;
    var x$203 = constraint.patternedProperty$1;
    var x$204 = constraint.maxCount$1;
    var x$205 = constraint.minCount$1;
    var x$206 = constraint.minLength$1;
    var x$207 = constraint.maxLength$1;
    var x$208 = constraint.minExclusive$1;
    var x$209 = constraint.maxExclusive$1;
    var x$210 = constraint.minInclusive$1;
    var x$211 = constraint.multipleOf$1;
    var x$212 = constraint.node$1;
    var x$213 = constraint.datatype$1;
    var x$214 = constraint.class$1;
    var x$215 = constraint.in$1;
    var x$216 = constraint.custom$1;
    var x$217 = constraint.customRdf$1;
    var x$218 = constraint.atLeast$1;
    var x$219 = constraint.atMost$1;
    var x$220 = constraint.value$1;
    var x$221 = constraint.equalToProperty$1;
    var x$222 = constraint.disjointWithProperty$1;
    var x$223 = constraint.lessThanProperty$1;
    var x$224 = constraint.lessThanOrEqualsToProperty$1;
    return new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$198, x$199, x$200, x$201, x$202, x$203, x$204, x$205, x$206, x$207, x$208, x$209, x$210, x$197, x$211, x$212, x$213, x$214, x$215, x$216, x$217, x$218, x$219, x$220, x$221, x$222, x$223, x$224)
  } else if ((x1 === "http://www.w3.org/ns/shacl#minLength")) {
    var x$225 = new $c_s_Some().init___O(validation.value$1);
    var x$226 = constraint.ramlPropertyId$1;
    var x$227 = constraint.name$1;
    var x$228 = constraint.path$1;
    var x$229 = constraint.message$1;
    var x$230 = constraint.pattern$1;
    var x$231 = constraint.patternedProperty$1;
    var x$232 = constraint.maxCount$1;
    var x$233 = constraint.minCount$1;
    var x$234 = constraint.maxLength$1;
    var x$235 = constraint.minExclusive$1;
    var x$236 = constraint.maxExclusive$1;
    var x$237 = constraint.minInclusive$1;
    var x$238 = constraint.maxInclusive$1;
    var x$239 = constraint.multipleOf$1;
    var x$240 = constraint.node$1;
    var x$241 = constraint.datatype$1;
    var x$242 = constraint.class$1;
    var x$243 = constraint.in$1;
    var x$244 = constraint.custom$1;
    var x$245 = constraint.customRdf$1;
    var x$246 = constraint.atLeast$1;
    var x$247 = constraint.atMost$1;
    var x$248 = constraint.value$1;
    var x$249 = constraint.equalToProperty$1;
    var x$250 = constraint.disjointWithProperty$1;
    var x$251 = constraint.lessThanProperty$1;
    var x$252 = constraint.lessThanOrEqualsToProperty$1;
    return new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$226, x$227, x$228, x$229, x$230, x$231, x$232, x$233, x$225, x$234, x$235, x$236, x$237, x$238, x$239, x$240, x$241, x$242, x$243, x$244, x$245, x$246, x$247, x$248, x$249, x$250, x$251, x$252)
  } else if ((x1 === "http://www.w3.org/ns/shacl#maxLength")) {
    var x$253 = new $c_s_Some().init___O(validation.value$1);
    var x$254 = constraint.ramlPropertyId$1;
    var x$255 = constraint.name$1;
    var x$256 = constraint.path$1;
    var x$257 = constraint.message$1;
    var x$258 = constraint.pattern$1;
    var x$259 = constraint.patternedProperty$1;
    var x$260 = constraint.maxCount$1;
    var x$261 = constraint.minCount$1;
    var x$262 = constraint.minLength$1;
    var x$263 = constraint.minExclusive$1;
    var x$264 = constraint.maxExclusive$1;
    var x$265 = constraint.minInclusive$1;
    var x$266 = constraint.maxInclusive$1;
    var x$267 = constraint.multipleOf$1;
    var x$268 = constraint.node$1;
    var x$269 = constraint.datatype$1;
    var x$270 = constraint.class$1;
    var x$271 = constraint.in$1;
    var x$272 = constraint.custom$1;
    var x$273 = constraint.customRdf$1;
    var x$274 = constraint.atLeast$1;
    var x$275 = constraint.atMost$1;
    var x$276 = constraint.value$1;
    var x$277 = constraint.equalToProperty$1;
    var x$278 = constraint.disjointWithProperty$1;
    var x$279 = constraint.lessThanProperty$1;
    var x$280 = constraint.lessThanOrEqualsToProperty$1;
    return new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$254, x$255, x$256, x$257, x$258, x$259, x$260, x$261, x$262, x$253, x$263, x$264, x$265, x$266, x$267, x$268, x$269, x$270, x$271, x$272, x$273, x$274, x$275, x$276, x$277, x$278, x$279, x$280)
  } else if ((x1 === "http://www.w3.org/ns/shacl#in")) {
    var jsx$1 = $m_s_Predef$();
    var thiz = validation.value$1;
    var x$281 = jsx$1.wrapRefArray__AO__scm_WrappedArray($m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "\\s*,\\s*", 0));
    var x$282 = constraint.ramlPropertyId$1;
    var x$283 = constraint.name$1;
    var x$284 = constraint.path$1;
    var x$285 = constraint.message$1;
    var x$286 = constraint.pattern$1;
    var x$287 = constraint.patternedProperty$1;
    var x$288 = constraint.maxCount$1;
    var x$289 = constraint.minCount$1;
    var x$290 = constraint.minLength$1;
    var x$291 = constraint.maxLength$1;
    var x$292 = constraint.minExclusive$1;
    var x$293 = constraint.maxExclusive$1;
    var x$294 = constraint.minInclusive$1;
    var x$295 = constraint.maxInclusive$1;
    var x$296 = constraint.multipleOf$1;
    var x$297 = constraint.node$1;
    var x$298 = constraint.datatype$1;
    var x$299 = constraint.class$1;
    var x$300 = constraint.custom$1;
    var x$301 = constraint.customRdf$1;
    var x$302 = constraint.atLeast$1;
    var x$303 = constraint.atMost$1;
    var x$304 = constraint.value$1;
    var x$305 = constraint.equalToProperty$1;
    var x$306 = constraint.disjointWithProperty$1;
    var x$307 = constraint.lessThanProperty$1;
    var x$308 = constraint.lessThanOrEqualsToProperty$1;
    return new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$282, x$283, x$284, x$285, x$286, x$287, x$288, x$289, x$290, x$291, x$292, x$293, x$294, x$295, x$296, x$297, x$298, x$299, x$281, x$300, x$301, x$302, x$303, x$304, x$305, x$306, x$307, x$308)
  } else if ((x1 === "http://www.w3.org/ns/shacl#node")) {
    var x$309 = new $c_s_Some().init___O(validation.value$1);
    var x$310 = constraint.ramlPropertyId$1;
    var x$311 = constraint.name$1;
    var x$312 = constraint.path$1;
    var x$313 = constraint.message$1;
    var x$314 = constraint.pattern$1;
    var x$315 = constraint.patternedProperty$1;
    var x$316 = constraint.maxCount$1;
    var x$317 = constraint.minCount$1;
    var x$318 = constraint.minLength$1;
    var x$319 = constraint.maxLength$1;
    var x$320 = constraint.minExclusive$1;
    var x$321 = constraint.maxExclusive$1;
    var x$322 = constraint.minInclusive$1;
    var x$323 = constraint.maxInclusive$1;
    var x$324 = constraint.multipleOf$1;
    var x$325 = constraint.datatype$1;
    var x$326 = constraint.class$1;
    var x$327 = constraint.in$1;
    var x$328 = constraint.custom$1;
    var x$329 = constraint.customRdf$1;
    var x$330 = constraint.atLeast$1;
    var x$331 = constraint.atMost$1;
    var x$332 = constraint.value$1;
    var x$333 = constraint.equalToProperty$1;
    var x$334 = constraint.disjointWithProperty$1;
    var x$335 = constraint.lessThanProperty$1;
    var x$336 = constraint.lessThanOrEqualsToProperty$1;
    return new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$310, x$311, x$312, x$313, x$314, x$315, x$316, x$317, x$318, x$319, x$320, x$321, x$322, x$323, x$324, x$309, x$325, x$326, x$327, x$328, x$329, x$330, x$331, x$332, x$333, x$334, x$335, x$336)
  } else if ((x1 === "http://www.w3.org/ns/shacl#datatype")) {
    var x$337 = new $c_s_Some().init___O(validation.value$1);
    var x$338 = constraint.ramlPropertyId$1;
    var x$339 = constraint.name$1;
    var x$340 = constraint.path$1;
    var x$341 = constraint.message$1;
    var x$342 = constraint.pattern$1;
    var x$343 = constraint.patternedProperty$1;
    var x$344 = constraint.maxCount$1;
    var x$345 = constraint.minCount$1;
    var x$346 = constraint.minLength$1;
    var x$347 = constraint.maxLength$1;
    var x$348 = constraint.minExclusive$1;
    var x$349 = constraint.maxExclusive$1;
    var x$350 = constraint.minInclusive$1;
    var x$351 = constraint.maxInclusive$1;
    var x$352 = constraint.multipleOf$1;
    var x$353 = constraint.node$1;
    var x$354 = constraint.class$1;
    var x$355 = constraint.in$1;
    var x$356 = constraint.custom$1;
    var x$357 = constraint.customRdf$1;
    var x$358 = constraint.atLeast$1;
    var x$359 = constraint.atMost$1;
    var x$360 = constraint.value$1;
    var x$361 = constraint.equalToProperty$1;
    var x$362 = constraint.disjointWithProperty$1;
    var x$363 = constraint.lessThanProperty$1;
    var x$364 = constraint.lessThanOrEqualsToProperty$1;
    return new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$338, x$339, x$340, x$341, x$342, x$343, x$344, x$345, x$346, x$347, x$348, x$349, x$350, x$351, x$352, x$353, x$337, x$354, x$355, x$356, x$357, x$358, x$359, x$360, x$361, x$362, x$363, x$364)
  } else if ((x1 === "http://www.w3.org/ns/shacl#class")) {
    var jsx$2 = $m_sc_Seq$();
    var array = [validation.value$1];
    var x$365 = $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
    var x$366 = constraint.ramlPropertyId$1;
    var x$367 = constraint.name$1;
    var x$368 = constraint.path$1;
    var x$369 = constraint.message$1;
    var x$370 = constraint.pattern$1;
    var x$371 = constraint.patternedProperty$1;
    var x$372 = constraint.maxCount$1;
    var x$373 = constraint.minCount$1;
    var x$374 = constraint.minLength$1;
    var x$375 = constraint.maxLength$1;
    var x$376 = constraint.minExclusive$1;
    var x$377 = constraint.maxExclusive$1;
    var x$378 = constraint.minInclusive$1;
    var x$379 = constraint.maxInclusive$1;
    var x$380 = constraint.multipleOf$1;
    var x$381 = constraint.node$1;
    var x$382 = constraint.datatype$1;
    var x$383 = constraint.in$1;
    var x$384 = constraint.custom$1;
    var x$385 = constraint.customRdf$1;
    var x$386 = constraint.atLeast$1;
    var x$387 = constraint.atMost$1;
    var x$388 = constraint.value$1;
    var x$389 = constraint.equalToProperty$1;
    var x$390 = constraint.disjointWithProperty$1;
    var x$391 = constraint.lessThanProperty$1;
    var x$392 = constraint.lessThanOrEqualsToProperty$1;
    return new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$366, x$367, x$368, x$369, x$370, x$371, x$372, x$373, x$374, x$375, x$376, x$377, x$378, x$379, x$380, x$381, x$382, x$365, x$383, x$384, x$385, x$386, x$387, x$388, x$389, x$390, x$391, x$392)
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Unsupported constraint " + validation.constraint$1)))
  }
});
$c_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$.prototype.parseValidation__p1__sc_Seq__sc_Seq = (function(validations) {
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(validation$2) {
      var validation = $as_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(validation$2);
      var x1 = validation.uri$1;
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var s = $as_T(x2.value$2);
        var uri = $as_T(s.trim())
      } else {
        var this$2 = $m_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$();
        var uri = $f_Lamf_plugins_document_webapi_validation_ImportUtils__validationId__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation__T(this$2, validation)
      };
      var this$3 = validation.message$1;
      var x$2 = $as_T((this$3.isEmpty__Z() ? "" : this$3.get__O()));
      var x$3 = new $c_s_Some().init___O(validation.ramlErrorMessage$1);
      var x$4 = new $c_s_Some().init___O(validation.openApiErrorMessage$1);
      var jsx$2 = $m_sc_Seq$();
      var array = [validation.owlClass$1];
      var x$5 = $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
      $m_Lamf_core_validation_core_ValidationSpecification$();
      $m_sc_Seq$();
      $m_sci_Seq$();
      var this$9 = new $c_scm_ListBuffer().init___();
      var x$6 = this$9.toList__sci_List();
      $m_Lamf_core_validation_core_ValidationSpecification$();
      $m_sc_Seq$();
      $m_sci_Seq$();
      var this$13 = new $c_scm_ListBuffer().init___();
      var x$7 = this$13.toList__sci_List();
      $m_Lamf_core_validation_core_ValidationSpecification$();
      $m_sc_Seq$();
      $m_sci_Seq$();
      var this$17 = new $c_scm_ListBuffer().init___();
      var x$8 = this$17.toList__sci_List();
      $m_Lamf_core_validation_core_ValidationSpecification$();
      $m_sc_Seq$();
      $m_sci_Seq$();
      var this$21 = new $c_scm_ListBuffer().init___();
      var x$9 = this$21.toList__sci_List();
      $m_Lamf_core_validation_core_ValidationSpecification$();
      $m_sc_Seq$();
      $m_sci_Seq$();
      var this$25 = new $c_scm_ListBuffer().init___();
      var x$10 = this$25.toList__sci_List();
      $m_Lamf_core_validation_core_ValidationSpecification$();
      var x$11 = $m_s_None$();
      $m_Lamf_core_validation_core_ValidationSpecification$();
      $m_sc_Seq$();
      $m_sci_Seq$();
      var this$30 = new $c_scm_ListBuffer().init___();
      var x$12 = this$30.toList__sci_List();
      $m_Lamf_core_validation_core_ValidationSpecification$();
      $m_sc_Seq$();
      $m_sci_Seq$();
      var this$34 = new $c_scm_ListBuffer().init___();
      var x$13 = this$34.toList__sci_List();
      $m_Lamf_core_validation_core_ValidationSpecification$();
      var x$14 = $m_s_None$();
      $m_Lamf_core_validation_core_ValidationSpecification$();
      var x$15 = $m_s_None$();
      $m_Lamf_core_validation_core_ValidationSpecification$();
      var x$16 = $m_s_None$();
      $m_Lamf_core_validation_core_ValidationSpecification$();
      var x$17 = $m_s_None$();
      $m_Lamf_core_validation_core_ValidationSpecification$();
      var x$18 = $m_s_None$();
      $m_Lamf_core_validation_core_ValidationSpecification$();
      var x$19 = $m_s_None$();
      var spec = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(uri, x$2, x$3, x$4, x$6, x$5, x$7, x$8, x$9, x$10, x$11, x$12, x$13, x$14, x$15, x$16, x$17, x$18, x$19);
      var jsx$3 = $m_Lamf_core_vocabulary_Namespace$();
      var thiz = validation.target$1;
      var x1$2 = jsx$3.expand__T__Lamf_core_vocabulary_ValueType($as_T(thiz.trim())).iri__T();
      if ((x1$2 === "http://www.w3.org/ns/shacl#path")) {
        var thiz$1 = validation.constraint$1;
        var thiz$2 = $as_T(thiz$1.trim());
        if (($uI(thiz$2.indexOf("#")) !== (-1))) {
          var thiz$3 = validation.constraint$1;
          var thiz$4 = $as_T(thiz$3.trim());
          var strings = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz$4, "#", 0);
          var jsx$4 = $m_Lamf_core_vocabulary_Namespace$();
          var this$49 = new $c_scm_ArrayOps$ofRef().init___AO(strings);
          var ns = $as_Lamf_core_vocabulary_Namespace(jsx$4.find__T__s_Option($as_T($f_sc_IndexedSeqOptimized__head__O(this$49))).get__O());
          var this$51 = new $c_scm_ArrayOps$ofRef().init___AO(strings);
          var name = $as_T($f_sc_IndexedSeqOptimized__last__O(this$51));
          var valueType = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns, name)
        } else {
          var valueType = $m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType(validation.constraint$1)
        };
        if ((valueType !== null)) {
          var p2 = valueType.ns$1;
          var x = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
          if (((x === null) ? (p2 === null) : x.equals__O__Z(p2))) {
            var jsx$6 = $m_sc_Seq$();
            var jsx$5 = $m_sc_Seq$();
            var array$1 = [$m_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$().parsePropertyConstraint__p1__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation__Lamf_core_vocabulary_ValueType__Lamf_core_validation_core_PropertyConstraint((uri + "/prop"), validation, valueType)];
            var x$20$2 = $as_sc_Seq(jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)));
            var x$21 = spec.name$1;
            var x$22 = spec.message$1;
            var x$23 = spec.ramlMessage$1;
            var x$24 = spec.oasMessage$1;
            var x$25 = spec.targetInstance$1;
            var x$26 = spec.targetClass$1;
            var x$27 = spec.targetObject$1;
            var x$28 = spec.unionConstraints$1;
            var x$29 = spec.andConstraints$1;
            var x$30 = spec.xoneConstraints$1;
            var x$31 = spec.notConstraint$1;
            var x$32 = spec.nodeConstraints$1;
            var x$33 = spec.closed$1;
            var x$34 = spec.functionConstraint$1;
            var x$35 = spec.custom$1;
            var x$36 = spec.nested$1;
            var x$37 = spec.replacesFunctionConstraint$1;
            var x$38 = spec.query$1;
            var array$2 = [new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$21, x$22, x$23, x$24, x$25, x$26, x$27, x$28, x$29, x$30, x$31, x$20$2, x$32, x$33, x$34, x$35, x$36, x$37, x$38)];
            return $as_sc_Seq(jsx$6.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2)))
          }
        };
        if ((valueType !== null)) {
          var p4 = valueType.ns$1;
          var x$39 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
          if (((x$39 === null) ? (p4 === null) : x$39.equals__O__Z(p4))) {
            var x1$4 = $m_Lamf_plugins_document_webapi_validation_complexShaclCustomValidations$().defintions$1.get__O__s_Option(valueType.name$1);
            if ((x1$4 instanceof $c_s_Some)) {
              var x2$2 = $as_s_Some(x1$4);
              var specs = $as_sc_Seq(x2$2.value$2);
              return specs
            } else {
              var jsx$7 = $m_sc_Seq$();
              var x$39$2 = $m_s_Option$().apply__O__s_Option($m_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$().parseFunctionConstraint__p1__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation__Lamf_core_vocabulary_ValueType__Lamf_core_validation_core_FunctionConstraint(validation, valueType));
              var x$40$2 = spec.name$1;
              var x$41 = spec.message$1;
              var x$42 = spec.ramlMessage$1;
              var x$43 = spec.oasMessage$1;
              var x$44 = spec.targetInstance$1;
              var x$45 = spec.targetClass$1;
              var x$46 = spec.targetObject$1;
              var x$47 = spec.unionConstraints$1;
              var x$48 = spec.andConstraints$1;
              var x$49 = spec.xoneConstraints$1;
              var x$50 = spec.notConstraint$1;
              var x$51 = spec.propertyConstraints$1;
              var x$52 = spec.nodeConstraints$1;
              var x$53 = spec.closed$1;
              var x$54 = spec.custom$1;
              var x$55 = spec.nested$1;
              var x$56 = spec.replacesFunctionConstraint$1;
              var x$57 = spec.query$1;
              var array$3 = [new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$40$2, x$41, x$42, x$43, x$44, x$45, x$46, x$47, x$48, x$49, x$50, x$51, x$52, x$53, x$39$2, x$54, x$55, x$56, x$57)];
              return $as_sc_Seq(jsx$7.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$3)))
            }
          }
        };
        var jsx$8 = $m_sc_Seq$();
        var array$4 = [spec];
        return $as_sc_Seq(jsx$8.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$4)))
      } else if ((x1$2 === "http://www.w3.org/ns/shacl#targetObjectsOf")) {
        var jsx$11 = $m_sc_Seq$();
        var jsx$9 = $m_sc_Seq$();
        var array$5 = [validation.owlProperty$1];
        var x$58 = $as_sc_Seq(jsx$9.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$5)));
        var jsx$10 = $m_sc_Seq$();
        var array$6 = [new $c_Lamf_core_validation_core_NodeConstraint().init___T__T(validation.constraint$1, validation.value$1)];
        var x$59 = $as_sc_Seq(jsx$10.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$6)));
        var x$60 = spec.name$1;
        var x$61 = spec.message$1;
        var x$62 = spec.ramlMessage$1;
        var x$63 = spec.oasMessage$1;
        var x$64 = spec.targetInstance$1;
        var x$65 = spec.targetClass$1;
        var x$66 = spec.unionConstraints$1;
        var x$67 = spec.andConstraints$1;
        var x$68 = spec.xoneConstraints$1;
        var x$69 = spec.notConstraint$1;
        var x$70 = spec.propertyConstraints$1;
        var x$71 = spec.closed$1;
        var x$72 = spec.functionConstraint$1;
        var x$73 = spec.custom$1;
        var x$74 = spec.nested$1;
        var x$75 = spec.replacesFunctionConstraint$1;
        var x$76 = spec.query$1;
        var array$7 = [new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$60, x$61, x$62, x$63, x$64, x$65, x$58, x$66, x$67, x$68, x$69, x$70, x$59, x$71, x$72, x$73, x$74, x$75, x$76)];
        return $as_sc_Seq(jsx$11.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$7)))
      } else {
        throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Unknown validation target " + validation.target$1)))
      }
    })
  })(this));
  var this$68 = $m_sc_Seq$();
  return $as_sc_Seq(validations.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$68.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$.prototype.parseFunctionConstraint__p1__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation__Lamf_core_vocabulary_ValueType__Lamf_core_validation_core_FunctionConstraint = (function(validation, sh) {
  var x$1 = validation.message$1;
  var x$2 = $m_s_None$();
  var this$1 = $m_Lamf_plugins_document_webapi_validation_JsCustomValidations$();
  var name = sh.name$1;
  var x$3 = this$1.functions$1.get__O__s_Option(name);
  var x$4 = new $c_s_Some().init___O(sh.name$1);
  var x$5 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var x$6 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  return new $c_Lamf_core_validation_core_FunctionConstraint().init___s_Option__s_Option__sc_Seq__s_Option__sc_Seq__s_Option(x$1, x$3, x$5, x$2, x$6, x$4)
});
$c_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$.prototype.profiles__sci_List = (function() {
  var this$32 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().map$1;
  var f$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var profile = $as_Lamf_ProfileName(x0$1.$$und1__O());
        var validationsInGroup = $as_sc_Seq(x0$1.$$und2__O());
        var violationValidations = $m_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$().parseValidation__p1__sc_Seq__sc_Seq($as_sc_Seq(validationsInGroup.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
          return (function(x$1$2) {
            var x$1 = $as_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$1$2);
            return (x$1.severity$1 === $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1)
          })
        })($this)))));
        var infoValidations = $m_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$().parseValidation__p1__sc_Seq__sc_Seq($as_sc_Seq(validationsInGroup.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
          return (function(x$2$2) {
            var x$2 = $as_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$2$2);
            return (x$2.severity$1 === $m_Lamf_core_validation_SeverityLevels$().INFO$1)
          })
        })($this)))));
        var warningValidations = $m_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$().parseValidation__p1__sc_Seq__sc_Seq($as_sc_Seq(validationsInGroup.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3) {
          return (function(x$3$2) {
            var x$3 = $as_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$3$2);
            return (x$3.severity$1 === $m_Lamf_core_validation_SeverityLevels$().WARNING$1)
          })
        })($this)))));
        var this$1 = $m_Lamf_plugins_features_validation_Validations$().validations$1;
        var f = (function(this$4, profile$1) {
          return (function(v$2) {
            var v = $as_Lamf_core_validation_core_ValidationSpecification(v$2);
            return ($m_Lamf_plugins_features_validation_Validations$().level__T__Lamf_ProfileName__T(v.id$1, profile$1) === $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1)
          })
        })($this, profile);
        if ((this$1 !== null)) {
          var l = this$1;
          var l$1 = l;
          x: {
            var result;
            _noneIn: while (true) {
              if (l$1.isEmpty__Z()) {
                var result = $m_sci_Nil$();
                break
              } else {
                var h = l$1.head__O();
                var t = $as_sci_List(l$1.tail__O());
                if (($uZ(f(h)) === false)) {
                  l$1 = t;
                  continue _noneIn
                };
                var start = l$1;
                var remaining = t;
                var remaining$1 = remaining;
                _allIn: while (true) {
                  if (remaining$1.isEmpty__Z()) {
                    var result = start;
                    break x
                  } else {
                    var x$2$1 = remaining$1.head__O();
                    if (($uZ(f(x$2$1)) !== false)) {
                      remaining$1 = $as_sci_List(remaining$1.tail__O());
                      continue _allIn
                    };
                    var firstMiss = remaining$1;
                    var newHead = new $c_sci_$colon$colon().init___O__sci_List(start.head__O(), $m_sci_Nil$());
                    var toProcess = $as_sci_List(start.tail__O());
                    var currentLast = newHead;
                    while ((toProcess !== firstMiss)) {
                      var newElem = new $c_sci_$colon$colon().init___O__sci_List(toProcess.head__O(), $m_sci_Nil$());
                      currentLast.tl$5 = newElem;
                      currentLast = newElem;
                      toProcess = $as_sci_List(toProcess.tail__O())
                    };
                    var next = $as_sci_List(firstMiss.tail__O());
                    var nextToCopy = next;
                    while ((!next.isEmpty__Z())) {
                      var head = next.head__O();
                      if (($uZ(f(head)) !== false)) {
                        next = $as_sci_List(next.tail__O())
                      } else {
                        while ((nextToCopy !== next)) {
                          var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy.head__O(), $m_sci_Nil$());
                          currentLast.tl$5 = newElem$2;
                          currentLast = newElem$2;
                          nextToCopy = $as_sci_List(nextToCopy.tail__O())
                        };
                        nextToCopy = $as_sci_List(next.tail__O());
                        next = $as_sci_List(next.tail__O())
                      }
                    };
                    if ((!nextToCopy.isEmpty__Z())) {
                      currentLast.tl$5 = nextToCopy
                    };
                    var result = newHead;
                    break x
                  }
                }
              }
            }
          };
          var this$7 = result
        } else {
          $m_sci_List$();
          var b = new $c_scm_ListBuffer().init___();
          var these = this$1;
          while ((!these.isEmpty__Z())) {
            var arg1 = these.head__O();
            if (($uZ(f(arg1)) !== false)) {
              b.$$plus$eq__O__scm_ListBuffer(arg1)
            };
            these = $as_sci_List(these.tail__O())
          };
          var this$7 = b.toList__sci_List()
        };
        var f$1 = (function(this$5$1) {
          return (function(x$4$2) {
            var x$4 = $as_Lamf_core_validation_core_ValidationSpecification(x$4$2);
            return x$4.name$1
          })
        })($this);
        var this$6 = $m_sci_List$();
        var bf = this$6.ReusableCBFInstance$2;
        if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
          if ((this$7 === $m_sci_Nil$())) {
            var jsx$1 = $m_sci_Nil$()
          } else {
            var arg1$1 = this$7.head__O();
            var h$1 = new $c_sci_$colon$colon().init___O__sci_List(f$1(arg1$1), $m_sci_Nil$());
            var t$1 = h$1;
            var rest = $as_sci_List(this$7.tail__O());
            while ((rest !== $m_sci_Nil$())) {
              var arg1$2 = rest.head__O();
              var nx = new $c_sci_$colon$colon().init___O__sci_List(f$1(arg1$2), $m_sci_Nil$());
              t$1.tl$5 = nx;
              t$1 = nx;
              rest = $as_sci_List(rest.tail__O())
            };
            var jsx$1 = h$1
          }
        } else {
          var b$1 = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$7, bf);
          var these$1 = this$7;
          while ((!these$1.isEmpty__Z())) {
            var arg1$3 = these$1.head__O();
            b$1.$$plus$eq__O__scm_Builder(f$1(arg1$3));
            these$1 = $as_sci_List(these$1.tail__O())
          };
          var jsx$1 = b$1.result__O()
        };
        var violationParserSideValidations = $as_sci_List(jsx$1);
        var this$8 = $m_Lamf_plugins_features_validation_Validations$().validations$1;
        var f$2 = (function(this$6$1, profile$2) {
          return (function(v$3$2) {
            var v$3 = $as_Lamf_core_validation_core_ValidationSpecification(v$3$2);
            return ($m_Lamf_plugins_features_validation_Validations$().level__T__Lamf_ProfileName__T(v$3.id$1, profile$2) === $m_Lamf_core_validation_SeverityLevels$().INFO$1)
          })
        })($this, profile);
        if ((this$8 !== null)) {
          var l$2 = this$8;
          var l$3 = l$2;
          x$2: {
            var result$1;
            _noneIn$1: while (true) {
              if (l$3.isEmpty__Z()) {
                var result$1 = $m_sci_Nil$();
                break
              } else {
                var h$2 = l$3.head__O();
                var t$2 = $as_sci_List(l$3.tail__O());
                if (($uZ(f$2(h$2)) === false)) {
                  l$3 = t$2;
                  continue _noneIn$1
                };
                var start$1 = l$3;
                var remaining$2 = t$2;
                var remaining$3 = remaining$2;
                _allIn$1: while (true) {
                  if (remaining$3.isEmpty__Z()) {
                    var result$1 = start$1;
                    break x$2
                  } else {
                    var x$2$3 = remaining$3.head__O();
                    if (($uZ(f$2(x$2$3)) !== false)) {
                      remaining$3 = $as_sci_List(remaining$3.tail__O());
                      continue _allIn$1
                    };
                    var firstMiss$1 = remaining$3;
                    var newHead$1 = new $c_sci_$colon$colon().init___O__sci_List(start$1.head__O(), $m_sci_Nil$());
                    var toProcess$1 = $as_sci_List(start$1.tail__O());
                    var currentLast$1 = newHead$1;
                    while ((toProcess$1 !== firstMiss$1)) {
                      var newElem$1 = new $c_sci_$colon$colon().init___O__sci_List(toProcess$1.head__O(), $m_sci_Nil$());
                      currentLast$1.tl$5 = newElem$1;
                      currentLast$1 = newElem$1;
                      toProcess$1 = $as_sci_List(toProcess$1.tail__O())
                    };
                    var next$1 = $as_sci_List(firstMiss$1.tail__O());
                    var nextToCopy$1 = next$1;
                    while ((!next$1.isEmpty__Z())) {
                      var head$1 = next$1.head__O();
                      if (($uZ(f$2(head$1)) !== false)) {
                        next$1 = $as_sci_List(next$1.tail__O())
                      } else {
                        while ((nextToCopy$1 !== next$1)) {
                          var newElem$2$1 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy$1.head__O(), $m_sci_Nil$());
                          currentLast$1.tl$5 = newElem$2$1;
                          currentLast$1 = newElem$2$1;
                          nextToCopy$1 = $as_sci_List(nextToCopy$1.tail__O())
                        };
                        nextToCopy$1 = $as_sci_List(next$1.tail__O());
                        next$1 = $as_sci_List(next$1.tail__O())
                      }
                    };
                    if ((!nextToCopy$1.isEmpty__Z())) {
                      currentLast$1.tl$5 = nextToCopy$1
                    };
                    var result$1 = newHead$1;
                    break x$2
                  }
                }
              }
            }
          };
          var this$11 = result$1
        } else {
          $m_sci_List$();
          var b$2 = new $c_scm_ListBuffer().init___();
          var these$2 = this$8;
          while ((!these$2.isEmpty__Z())) {
            var arg1$4 = these$2.head__O();
            if (($uZ(f$2(arg1$4)) !== false)) {
              b$2.$$plus$eq__O__scm_ListBuffer(arg1$4)
            };
            these$2 = $as_sci_List(these$2.tail__O())
          };
          var this$11 = b$2.toList__sci_List()
        };
        var f$3 = (function(this$7$1) {
          return (function(x$5$2) {
            var x$5 = $as_Lamf_core_validation_core_ValidationSpecification(x$5$2);
            return x$5.name$1
          })
        })($this);
        var this$10 = $m_sci_List$();
        var bf$1 = this$10.ReusableCBFInstance$2;
        if ((bf$1 === $m_sci_List$().ReusableCBFInstance$2)) {
          if ((this$11 === $m_sci_Nil$())) {
            var jsx$2 = $m_sci_Nil$()
          } else {
            var arg1$5 = this$11.head__O();
            var h$3 = new $c_sci_$colon$colon().init___O__sci_List(f$3(arg1$5), $m_sci_Nil$());
            var t$3 = h$3;
            var rest$1 = $as_sci_List(this$11.tail__O());
            while ((rest$1 !== $m_sci_Nil$())) {
              var arg1$6 = rest$1.head__O();
              var nx$1 = new $c_sci_$colon$colon().init___O__sci_List(f$3(arg1$6), $m_sci_Nil$());
              t$3.tl$5 = nx$1;
              t$3 = nx$1;
              rest$1 = $as_sci_List(rest$1.tail__O())
            };
            var jsx$2 = h$3
          }
        } else {
          var b$3 = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$11, bf$1);
          var these$3 = this$11;
          while ((!these$3.isEmpty__Z())) {
            var arg1$7 = these$3.head__O();
            b$3.$$plus$eq__O__scm_Builder(f$3(arg1$7));
            these$3 = $as_sci_List(these$3.tail__O())
          };
          var jsx$2 = b$3.result__O()
        };
        var infoParserSideValidations = $as_sci_List(jsx$2);
        var this$12 = $m_Lamf_plugins_features_validation_Validations$().validations$1;
        var f$4 = (function(this$8$1, profile$3) {
          return (function(v$4$2) {
            var v$4 = $as_Lamf_core_validation_core_ValidationSpecification(v$4$2);
            return ($m_Lamf_plugins_features_validation_Validations$().level__T__Lamf_ProfileName__T(v$4.id$1, profile$3) === $m_Lamf_core_validation_SeverityLevels$().WARNING$1)
          })
        })($this, profile);
        if ((this$12 !== null)) {
          var l$4 = this$12;
          var l$5 = l$4;
          x$4: {
            var result$2;
            _noneIn$2: while (true) {
              if (l$5.isEmpty__Z()) {
                var result$2 = $m_sci_Nil$();
                break
              } else {
                var h$4 = l$5.head__O();
                var t$4 = $as_sci_List(l$5.tail__O());
                if (($uZ(f$4(h$4)) === false)) {
                  l$5 = t$4;
                  continue _noneIn$2
                };
                var start$2 = l$5;
                var remaining$4 = t$4;
                var remaining$5 = remaining$4;
                _allIn$2: while (true) {
                  if (remaining$5.isEmpty__Z()) {
                    var result$2 = start$2;
                    break x$4
                  } else {
                    var x$2$4 = remaining$5.head__O();
                    if (($uZ(f$4(x$2$4)) !== false)) {
                      remaining$5 = $as_sci_List(remaining$5.tail__O());
                      continue _allIn$2
                    };
                    var firstMiss$2 = remaining$5;
                    var newHead$2 = new $c_sci_$colon$colon().init___O__sci_List(start$2.head__O(), $m_sci_Nil$());
                    var toProcess$2 = $as_sci_List(start$2.tail__O());
                    var currentLast$2 = newHead$2;
                    while ((toProcess$2 !== firstMiss$2)) {
                      var newElem$3 = new $c_sci_$colon$colon().init___O__sci_List(toProcess$2.head__O(), $m_sci_Nil$());
                      currentLast$2.tl$5 = newElem$3;
                      currentLast$2 = newElem$3;
                      toProcess$2 = $as_sci_List(toProcess$2.tail__O())
                    };
                    var next$2 = $as_sci_List(firstMiss$2.tail__O());
                    var nextToCopy$2 = next$2;
                    while ((!next$2.isEmpty__Z())) {
                      var head$2 = next$2.head__O();
                      if (($uZ(f$4(head$2)) !== false)) {
                        next$2 = $as_sci_List(next$2.tail__O())
                      } else {
                        while ((nextToCopy$2 !== next$2)) {
                          var newElem$2$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy$2.head__O(), $m_sci_Nil$());
                          currentLast$2.tl$5 = newElem$2$2;
                          currentLast$2 = newElem$2$2;
                          nextToCopy$2 = $as_sci_List(nextToCopy$2.tail__O())
                        };
                        nextToCopy$2 = $as_sci_List(next$2.tail__O());
                        next$2 = $as_sci_List(next$2.tail__O())
                      }
                    };
                    if ((!nextToCopy$2.isEmpty__Z())) {
                      currentLast$2.tl$5 = nextToCopy$2
                    };
                    var result$2 = newHead$2;
                    break x$4
                  }
                }
              }
            }
          };
          var this$15 = result$2
        } else {
          $m_sci_List$();
          var b$4 = new $c_scm_ListBuffer().init___();
          var these$4 = this$12;
          while ((!these$4.isEmpty__Z())) {
            var arg1$8 = these$4.head__O();
            if (($uZ(f$4(arg1$8)) !== false)) {
              b$4.$$plus$eq__O__scm_ListBuffer(arg1$8)
            };
            these$4 = $as_sci_List(these$4.tail__O())
          };
          var this$15 = b$4.toList__sci_List()
        };
        var f$5 = (function(this$9$1) {
          return (function(x$6$2) {
            var x$6 = $as_Lamf_core_validation_core_ValidationSpecification(x$6$2);
            return x$6.name$1
          })
        })($this);
        var this$14 = $m_sci_List$();
        var bf$2 = this$14.ReusableCBFInstance$2;
        if ((bf$2 === $m_sci_List$().ReusableCBFInstance$2)) {
          if ((this$15 === $m_sci_Nil$())) {
            var jsx$3 = $m_sci_Nil$()
          } else {
            var arg1$9 = this$15.head__O();
            var h$5 = new $c_sci_$colon$colon().init___O__sci_List(f$5(arg1$9), $m_sci_Nil$());
            var t$5 = h$5;
            var rest$2 = $as_sci_List(this$15.tail__O());
            while ((rest$2 !== $m_sci_Nil$())) {
              var arg1$10 = rest$2.head__O();
              var nx$2 = new $c_sci_$colon$colon().init___O__sci_List(f$5(arg1$10), $m_sci_Nil$());
              t$5.tl$5 = nx$2;
              t$5 = nx$2;
              rest$2 = $as_sci_List(rest$2.tail__O())
            };
            var jsx$3 = h$5
          }
        } else {
          var b$5 = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$15, bf$2);
          var these$5 = this$15;
          while ((!these$5.isEmpty__Z())) {
            var arg1$11 = these$5.head__O();
            b$5.$$plus$eq__O__scm_Builder(f$5(arg1$11));
            these$5 = $as_sci_List(these$5.tail__O())
          };
          var jsx$3 = b$5.result__O()
        };
        var warningParserSideValidations = $as_sci_List(jsx$3);
        var x$7 = $m_Lamf_AmfProfile$();
        if (((profile !== null) && profile.equals__O__Z(x$7))) {
          var x$2$3$1 = $m_s_None$()
        } else {
          var x$2$3$1 = new $c_s_Some().init___O($m_Lamf_AmfProfile$())
        };
        var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$10$1) {
          return (function(x$7$2$2) {
            var x$7$2 = $as_Lamf_core_validation_core_ValidationSpecification(x$7$2$2);
            return x$7$2.name$1
          })
        })($this));
        var this$16 = $m_sc_Seq$();
        var jsx$4 = $as_sc_GenTraversableOnce(infoValidations.map__F1__scg_CanBuildFrom__O(jsx$5, this$16.ReusableCBFInstance$2));
        var this$17 = $m_sci_List$();
        var x$3$3 = $as_sc_Seq(infoParserSideValidations.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$17.ReusableCBFInstance$2));
        var jsx$7 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$11$1) {
          return (function(x$8$2) {
            var x$8 = $as_Lamf_core_validation_core_ValidationSpecification(x$8$2);
            return x$8.name$1
          })
        })($this));
        var this$18 = $m_sc_Seq$();
        var jsx$6 = $as_sc_GenTraversableOnce(warningValidations.map__F1__scg_CanBuildFrom__O(jsx$7, this$18.ReusableCBFInstance$2));
        var this$19 = $m_sci_List$();
        var x$4$3 = $as_sc_Seq(warningParserSideValidations.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$6, this$19.ReusableCBFInstance$2));
        var jsx$9 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$12$1) {
          return (function(x$9$2) {
            var x$9 = $as_Lamf_core_validation_core_ValidationSpecification(x$9$2);
            return x$9.name$1
          })
        })($this));
        var this$20 = $m_sc_Seq$();
        var jsx$8 = $as_sc_GenTraversableOnce(violationValidations.map__F1__scg_CanBuildFrom__O(jsx$9, this$20.ReusableCBFInstance$2));
        var this$21 = $m_sci_List$();
        var x$5$3 = $as_sc_Seq(violationParserSideValidations.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$8, this$21.ReusableCBFInstance$2));
        var this$22 = $m_sc_Seq$();
        var jsx$12 = $as_sc_TraversableLike(infoValidations.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(warningValidations, this$22.ReusableCBFInstance$2));
        var this$23 = $m_sc_Seq$();
        var jsx$11 = $as_sc_TraversableLike(jsx$12.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(violationValidations, this$23.ReusableCBFInstance$2));
        var jsx$10 = $m_Lamf_plugins_features_validation_Validations$().validations$1;
        var this$24 = $m_sc_Seq$();
        var x$6$3 = $as_sc_Seq(jsx$11.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$10, this$24.ReusableCBFInstance$2));
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$28 = new $c_scm_ListBuffer().init___();
        var x$7$3 = this$28.toList__sci_List();
        var x$8$3 = new $c_scm_HashMap().init___();
        return new $c_Lamf_core_validation_core_ValidationProfile().init___Lamf_ProfileName__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__scm_Map(profile, x$2$3$1, x$5$3, x$3$3, x$4$3, x$7$3, x$6$3, x$8$3)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this));
  var this$31 = $m_sci_Iterable$();
  var bf$3 = this$31.ReusableCBFInstance$2;
  return $as_sc_TraversableOnce($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$32, f$6, bf$3)).toList__sci_List()
});
var $d_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_DefaultAMFValidations$: 0
}, false, "amf.plugins.document.webapi.validation.DefaultAMFValidations$", {
  Lamf_plugins_document_webapi_validation_DefaultAMFValidations$: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_ImportUtils: 1
});
$c_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$;
var $n_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$)) {
    $n_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$ = new $c_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_DefaultAMFValidations$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$.prototype = $c_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$.prototype;
$c_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$.prototype.processException__jl_Throwable__s_Option__O = (function(r, element) {
  return false
});
$c_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$.prototype.processResults__sc_Seq__Z = (function(r) {
  return (!r.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_validation_AMFValidationResult(x$1$2);
      return (x$1.level$1 === $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1)
    })
  })(this))))
});
$c_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$.prototype.processResults__sc_Seq__O = (function(r) {
  return this.processResults__sc_Seq__Z(r)
});
var $d_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$: 0
}, false, "amf.plugins.document.webapi.validation.remote.BooleanValidationProcessor$", {
  Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_remote_ValidationProcessor: 1
});
$c_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$;
var $n_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$)) {
    $n_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$ = new $c_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator() {
  $c_O.call(this);
  this.shape$1 = null;
  this.env$1 = null;
  this.defaultSeverity$1 = null;
  this.isFileShape$1 = false;
  this.schemas$1 = null
}
$c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype = $c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype;
$c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype.validateForPayload__T__T__Lamf_plugins_document_webapi_validation_remote_ValidationProcessor__O = (function(mediaType, payload, validationProcessor) {
  if ((!$m_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$().payloadMediaType$1.contains__O__Z(mediaType))) {
    var jsx$1 = $m_sc_Seq$();
    var message = (((("Unsupported payload media type '" + mediaType) + "', only ") + $m_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$().payloadMediaType$1.toString__T()) + " supported");
    var level = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var targetProperty = $m_s_None$();
    var validationId = $m_Lamf_validations_PayloadValidations$().ExampleValidationErrorSpecification$1.id$1;
    var position = $m_s_None$();
    var location = $m_s_None$();
    var array = [new $c_Lamf_core_validation_AMFValidationResult().init___T__T__T__s_Option__T__s_Option__s_Option__O(message, level, "", targetProperty, validationId, position, location, null)];
    return validationProcessor.processResults__sc_Seq__O($as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))))
  } else {
    try {
      return this.performValidation__p1__T2__Lamf_plugins_document_webapi_validation_remote_ValidationProcessor__O(this.buildCandidate__p1__T__T__T2(mediaType, payload), validationProcessor)
    } catch (e) {
      if ((e instanceof $c_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject)) {
        var e$3 = $as_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject(e);
        return validationProcessor.processException__jl_Throwable__s_Option__O(e$3, $m_s_None$())
      } else if ((e instanceof $c_Lamf_plugins_document_webapi_validation_remote_InvalidJsonValue)) {
        var e$2 = $as_Lamf_plugins_document_webapi_validation_remote_InvalidJsonValue(e);
        return validationProcessor.processException__jl_Throwable__s_Option__O(e$2, $m_s_None$())
      } else {
        throw e
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype.buildPayloadObj__T__T__T2 = (function(mediaType, payload) {
  if ((mediaType === "application/json")) {
    var x = this.validationMode$2;
    var x$2 = $m_Lamf_client_plugins_ScalarRelaxedValidationMode$();
    var jsx$1 = (!((x !== null) && (x === x$2)))
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return new $c_T2().init___O__O(new $c_s_Some().init___O(this.loadJson__T__sjs_js_Dynamic(payload)), $m_s_None$())
  } else {
    return this.buildPayloadNode__T__T__T2(mediaType, payload)
  }
});
$c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype.buildCandidate__p1__Lamf_core_model_document_PayloadFragment__T2 = (function(payload) {
  return (this.isFileShape$1 ? new $c_T2().init___O__O($m_s_None$(), $m_s_None$()) : new $c_T2().init___O__O(this.loadDataNodeString__Lamf_core_model_document_PayloadFragment__s_Option(payload), new $c_s_Some().init___O(new $c_Lamf_core_validation_PayloadParsingResult().init___Lamf_core_model_document_PayloadFragment__sci_List(payload, $m_sci_Nil$()))))
});
$c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype.validate__T__T__s_concurrent_ExecutionContext__s_concurrent_Future = (function(mediaType, payload, executionContext) {
  return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, mediaType$1, payload$1) {
    return (function() {
      var profileName = $m_Lamf_ProfileNames$().AMF$1;
      return $as_Lamf_core_validation_AMFValidationReport($this.validateForPayload__T__T__Lamf_plugins_document_webapi_validation_remote_ValidationProcessor__O(mediaType$1, payload$1, new $c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor().init___Lamf_ProfileName(profileName)))
    })
  })(this, mediaType, payload)), executionContext)
});
$c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype.generateSchemaString__p1__Lamf_plugins_document_webapi_model_DataTypeFragment__s_Option = (function(dataType) {
  var renderOptions = new $c_Lamf_core_emitter_ShapeRenderOptions().init___().withoutDocumentation__Lamf_core_emitter_ShapeRenderOptions().withCompactedEmission__Lamf_core_emitter_ShapeRenderOptions().withSchemaVersion__Lamf_client_render_JSONSchemaVersion__Lamf_core_emitter_ShapeRenderOptions($m_Lamf_client_render_JsonSchemaDraft7$());
  $m_sci_List$();
  var array = [$as_Lamf_core_model_domain_Shape($as_Lamf_core_model_domain_DomainElement(dataType.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)))];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var declarations = result;
  var x$1 = $as_Lamf_core_model_domain_Shape($as_Lamf_core_model_domain_DomainElement(dataType.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)));
  var x$4 = $m_Lamf_core_emitter_SpecOrdering$Lexical$();
  var emitter = new $c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter().init___Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_core_emitter_ShapeRenderOptions(x$1, declarations, x$4, renderOptions);
  var document = new $c_Lamf_core_parser_SyamlParsedDocument().init___Lorg_yaml_model_YDocument__s_Option(emitter.emitDocument__Lorg_yaml_model_YDocument(), $m_s_None$());
  return $m_Lamf_plugins_syntax_SYamlSyntaxPlugin$().unparse__T__Lamf_core_parser_ParsedDocument__s_Option("application/json", document)
});
$c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype.generateSchema__p1__Lamf_core_model_domain_Shape__Lamf_plugins_document_webapi_validation_remote_ValidationProcessor__s_util_Either = (function(fragmentShape, validationProcessor) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var dataType = new $c_Lamf_plugins_document_webapi_model_DataTypeFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  dataType.fields$1.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$().Encodes$1, fragmentShape, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
  var schemaOption = this.generateSchemaString__p1__Lamf_plugins_document_webapi_model_DataTypeFragment__s_Option(dataType);
  if ((schemaOption instanceof $c_s_Some)) {
    var x2 = $as_s_Some(schemaOption);
    var charSequence = $as_jl_CharSequence(x2.value$2);
    return this.loadSchema__jl_CharSequence__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_validation_remote_ValidationProcessor__s_util_Either(charSequence, fragmentShape, validationProcessor)
  } else {
    var x = $m_s_None$();
    if ((x === schemaOption)) {
      $m_s_package$();
      var value = $m_s_None$();
      return new $c_s_util_Right().init___O(value)
    } else {
      throw new $c_s_MatchError().init___O(schemaOption)
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype.validate__Lamf_core_model_document_PayloadFragment__s_concurrent_ExecutionContext__s_concurrent_Future = (function(fragment, executionContext) {
  return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, fragment$1) {
    return (function() {
      var profileName = $m_Lamf_ProfileNames$().AMF$1;
      return $as_Lamf_core_validation_AMFValidationReport($this.validateForFragment__Lamf_core_model_document_PayloadFragment__Lamf_plugins_document_webapi_validation_remote_ValidationProcessor__O(fragment$1, new $c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor().init___Lamf_ProfileName(profileName)))
    })
  })(this, fragment)), executionContext)
});
$c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype.parsePayload__p1__T__T__Lamf_core_parser_errorhandler_AmfParserErrorHandler__Lamf_core_model_document_PayloadFragment = (function(payload, mediaType, errorHandler) {
  var options = new $c_Lamf_core_client_ParsingOptions().init___();
  var this$2 = this.env$1.maxYamlReferences$1;
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var t = $uJ(arg1);
    var lo = t.lo$2;
    var hi = t.hi$2;
    options.setMaxYamlReferences__J__Lamf_core_client_ParsingOptions(new $c_sjsr_RuntimeLong().init___I__I(lo, hi))
  };
  var x$7 = $m_sci_Nil$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$6 = new $c_scm_ListBuffer().init___();
  var x$3 = this$6.toList__sci_List();
  var x$4 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$13 = new $c_scm_ListBuffer().init___();
  var x$5 = new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$13.toList__sci_List());
  var x$8 = new $c_Lamf_core_parser_ParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext("", x$3, x$4, errorHandler, x$5);
  var x$10 = $m_s_None$();
  var x$11 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2;
  var defaultCtx = new $c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions("", x$7, x$8, x$10, x$11, options);
  var parser = ((mediaType === "application/json") ? $m_Lorg_yaml_parser_JsonParser$().apply__jl_CharSequence__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_JsonParser(payload, errorHandler) : $m_Lorg_yaml_parser_YamlParser$().apply__jl_CharSequence__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_YamlParser(payload, errorHandler));
  var node = $f_Lorg_yaml_parser_YParser__document__Lorg_yaml_model_YDocument(parser).node$2;
  var jsx$2 = $m_Lamf_core_model_document_PayloadFragment$();
  if (node.isNull__Z()) {
    var this$16 = $m_Lamf_core_model_domain_ScalarNode$();
    var dataType = $m_s_None$();
    var jsx$1 = this$16.apply__T__s_Option__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode(payload, dataType, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___())).withDataType__T__Lamf_core_model_domain_ScalarNode($m_Lamf_core_model_DataType$().Nil$1)
  } else {
    var jsx$1 = $m_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser(node, new $c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables().init___(), $m_s_None$(), defaultCtx).parse__Lamf_core_model_domain_DataNode()
  };
  return jsx$2.apply__Lamf_core_model_domain_DataNode__T__Lamf_core_model_document_PayloadFragment(jsx$1, mediaType)
});
$c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype.getOrCreateSchema__p1__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_document_webapi_validation_remote_ValidationProcessor__s_util_Either = (function(s, validationProcessor) {
  var x1 = this.schemas$1.get__O__s_Option(s.id$1);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var json = x2.value$2;
    $m_s_package$();
    var value = new $c_s_Some().init___O(json);
    return new $c_s_util_Right().init___O(value)
  } else {
    var x1$2 = this.generateSchema__p1__Lamf_core_model_domain_Shape__Lamf_plugins_document_webapi_validation_remote_ValidationProcessor__s_util_Either(s, validationProcessor);
    if ((x1$2 instanceof $c_s_util_Right)) {
      var x2$2 = $as_s_util_Right(x1$2);
      var maybeSchema = $as_s_Option(x2$2.value$2);
      if ((!maybeSchema.isEmpty__Z())) {
        var arg1 = maybeSchema.get__O();
        this.schemas$1.put__O__O__s_Option(s.id$1, arg1)
      };
      $m_s_package$();
      return new $c_s_util_Right().init___O(maybeSchema)
    } else if ((x1$2 instanceof $c_s_util_Left)) {
      var x3 = $as_s_util_Left(x1$2);
      var result = x3.value$2;
      $m_s_package$();
      return new $c_s_util_Left().init___O(result)
    } else {
      throw new $c_s_MatchError().init___O(x1$2)
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype.isValid__T__T__s_concurrent_ExecutionContext__s_concurrent_Future = (function(mediaType, payload, executionContext) {
  return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, mediaType$1, payload$1) {
    return (function() {
      return $uZ($this.validateForPayload__T__T__Lamf_plugins_document_webapi_validation_remote_ValidationProcessor__O(mediaType$1, payload$1, $m_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$()))
    })
  })(this, mediaType, payload)), executionContext)
});
$c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype.parsePayloadWithErrorHandler__T__T__Lamf_internal_environment_Environment__Lamf_core_model_domain_Shape__Lamf_core_validation_PayloadParsingResult = (function(payload, mediaType, env, shape) {
  var errorHandler = new $c_Lamf_client_parse_DefaultParserErrorHandler().init___I($m_Lamf_core_AMFCompilerRunCount$().nextRun__I());
  return new $c_Lamf_core_validation_PayloadParsingResult().init___Lamf_core_model_document_PayloadFragment__sci_List(this.parsePayload__p1__T__T__Lamf_core_parser_errorhandler_AmfParserErrorHandler__Lamf_core_model_document_PayloadFragment(payload, mediaType, errorHandler), errorHandler.amf$core$errorhandling$ErrorCollector$$errors$1.toList__sci_List())
});
$c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype.syncValidate__T__T__Lamf_core_validation_AMFValidationReport = (function(mediaType, payload) {
  var profileName = $m_Lamf_ProfileNames$().AMF$1;
  return $as_Lamf_core_validation_AMFValidationReport(this.validateForPayload__T__T__Lamf_plugins_document_webapi_validation_remote_ValidationProcessor__O(mediaType, payload, new $c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor().init___Lamf_ProfileName(profileName)))
});
$c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype.validateForFragment__Lamf_core_model_document_PayloadFragment__Lamf_plugins_document_webapi_validation_remote_ValidationProcessor__O = (function(fragment, validationProcessor) {
  try {
    return this.performValidation__p1__T2__Lamf_plugins_document_webapi_validation_remote_ValidationProcessor__O(this.buildCandidate__p1__Lamf_core_model_document_PayloadFragment__T2(fragment), validationProcessor)
  } catch (e) {
    if ((e instanceof $c_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject)) {
      var e$3 = $as_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject(e);
      return validationProcessor.processException__jl_Throwable__s_Option__O(e$3, new $c_s_Some().init___O($as_Lamf_core_model_domain_DataNode(fragment.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().Encodes$1))))
    } else if ((e instanceof $c_Lamf_plugins_document_webapi_validation_remote_InvalidJsonValue)) {
      var e$2 = $as_Lamf_plugins_document_webapi_validation_remote_InvalidJsonValue(e);
      return validationProcessor.processException__jl_Throwable__s_Option__O(e$2, new $c_s_Some().init___O($as_Lamf_core_model_domain_DataNode(fragment.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().Encodes$1))))
    } else {
      throw e
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype.init___Lamf_core_model_domain_Shape__Lamf_internal_environment_Environment = (function(shape, env) {
  this.shape$1 = shape;
  this.env$1 = env;
  this.defaultSeverity$1 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  this.isFileShape$1 = (shape instanceof $c_Lamf_plugins_domain_shapes_models_FileShape);
  this.schemas$1 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  return this
});
$c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype.literalRepresentation__Lamf_core_model_document_PayloadFragment__s_Option = (function(payload) {
  var x1 = payload.raw$1;
  matchEnd6: {
    var futureText;
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var p3 = $as_T(x2.value$2);
      if ((p3 === "")) {
        var futureText = $m_s_None$();
        break matchEnd6
      }
    };
    var y = new $c_Lorg_yaml_builder_YDocumentBuilder().init___();
    if ($m_Lamf_plugins_document_webapi_PayloadPlugin$().emit__Lamf_core_model_document_BaseUnit__Lorg_yaml_builder_DocBuilder__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__Z(payload, y, ($m_Lamf_plugins_document_webapi_PayloadPlugin$(), new $c_Lamf_core_emitter_RenderOptions().init___()), ($m_Lamf_plugins_document_webapi_PayloadPlugin$(), new $c_Lamf_core_emitter_ShapeRenderOptions().init___()))) {
      var x1$2 = $m_Lamf_plugins_syntax_SYamlSyntaxPlugin$().unparse__T__Lamf_core_parser_ParsedDocument__s_Option("application/json", new $c_Lamf_core_parser_SyamlParsedDocument().init___Lorg_yaml_model_YDocument__s_Option($as_Lorg_yaml_model_YDocument($as_Lorg_yaml_model_YPart(y.$$unddocument$2.get__O())), $m_s_None$()));
      if ((x1$2 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$2);
        var serialized = $as_jl_CharSequence(x2$2.value$2);
        var futureText = new $c_s_Some().init___O($objectToString(serialized))
      } else {
        var futureText = $m_s_None$()
      }
    } else {
      var futureText = $m_s_None$()
    }
  };
  if (futureText.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = futureText.get__O();
    var text = $as_T(arg1);
    var x1$1 = $as_Lamf_core_model_domain_DataNode(payload.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().Encodes$1));
    matchEnd4: {
      var jsx$1;
      if ((x1$1 instanceof $c_Lamf_core_model_domain_ScalarNode)) {
        var x2$1 = $as_Lamf_core_model_domain_ScalarNode(x1$1);
        if ($as_Lamf_core_model_StrField(x2$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().DataType$1)).option$1.contains__O__Z($m_Lamf_core_model_DataType$().String$1)) {
          var this$7 = new $c_sci_StringOps().init___T(text);
          var jsx$3 = $f_sc_TraversableOnce__nonEmpty__Z(this$7)
        } else {
          var jsx$3 = false
        };
        if (jsx$3) {
          var this$9 = new $c_sci_StringOps().init___T(text);
          var c = $f_sc_IndexedSeqOptimized__head__O(this$9);
          if ((c === null)) {
            var jsx$4 = 0
          } else {
            var this$11 = $as_jl_Character(c);
            var jsx$4 = this$11.value$1
          };
          var jsx$2 = (jsx$4 !== 34)
        } else {
          var jsx$2 = false
        };
        if (jsx$2) {
          var this$13 = new $c_sci_StringOps().init___T(text);
          var jsx$1 = (("\"" + $f_sci_StringLike__stripLineEnd__T(this$13)) + "\"");
          break matchEnd4
        }
      };
      var this$15 = new $c_sci_StringOps().init___T(text);
      var jsx$1 = $f_sci_StringLike__stripLineEnd__T(this$15)
    };
    return new $c_s_Some().init___O(jsx$1)
  }
});
$c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype.buildPayloadNode__T__T__T2 = (function(mediaType, payload) {
  var x1 = this.parsePayloadWithErrorHandler__T__T__Lamf_internal_environment_Environment__Lamf_core_model_domain_Shape__Lamf_core_validation_PayloadParsingResult(payload, mediaType, this.env$1, this.shape$1);
  var this$1 = x1.results$1;
  if ((!$f_sc_TraversableOnce__nonEmpty__Z(this$1))) {
    var x = this.validationMode$2;
    var x$2 = $m_Lamf_client_plugins_ScalarRelaxedValidationMode$();
    var jsx$1 = ((x !== null) && (x === x$2))
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var frag = $m_Lamf_plugins_document_webapi_validation_remote_ScalarPayloadForParam$().apply__Lamf_core_model_document_PayloadFragment__Lamf_core_model_domain_Shape__Lamf_core_model_document_PayloadFragment(x1.fragment$1, this.shape$1);
    var results = x1.results$1;
    var fixedResult = new $c_Lamf_core_validation_PayloadParsingResult().init___Lamf_core_model_document_PayloadFragment__sci_List(frag, results)
  } else {
    var fixedResult = x1
  };
  var this$2 = fixedResult.results$1;
  if ((!$f_sc_TraversableOnce__nonEmpty__Z(this$2))) {
    return new $c_T2().init___O__O(this.loadDataNodeString__Lamf_core_model_document_PayloadFragment__s_Option(fixedResult.fragment$1), new $c_s_Some().init___O(fixedResult))
  } else {
    return new $c_T2().init___O__O($m_s_None$(), new $c_s_Some().init___O(fixedResult))
  }
});
$c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype.buildCandidate__p1__T__T__T2 = (function(mediaType, payload) {
  return (this.isFileShape$1 ? new $c_T2().init___O__O($m_s_None$(), $m_s_None$()) : this.buildPayloadObj__T__T__T2(mediaType, payload))
});
$c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype.performValidation__p1__T2__Lamf_plugins_document_webapi_validation_remote_ValidationProcessor__O = (function(payload, validationProcessor) {
  if ((payload !== null)) {
    var p3 = $as_s_Option(payload.$$und2__O());
    if ((p3 instanceof $c_s_Some)) {
      var x4 = $as_s_Some(p3);
      var result = $as_Lamf_core_validation_PayloadParsingResult(x4.value$2);
      var this$1 = result.results$1;
      if ($f_sc_TraversableOnce__nonEmpty__Z(this$1)) {
        return validationProcessor.processResults__sc_Seq__O(result.results$1)
      }
    }
  };
  if ((payload !== null)) {
    var p5 = $as_s_Option(payload.$$und1__O());
    var resultOption = $as_s_Option(payload.$$und2__O());
    if ((p5 instanceof $c_s_Some)) {
      var x6 = $as_s_Some(p5);
      var obj = x6.value$2;
      if (resultOption.isEmpty__Z()) {
        var fragmentOption = $m_s_None$()
      } else {
        var arg1 = resultOption.get__O();
        var x$2 = $as_Lamf_core_validation_PayloadParsingResult(arg1);
        var fragmentOption = new $c_s_Some().init___O(x$2.fragment$1)
      };
      try {
        if ((this.shape$1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
          var x1$3 = this.getOrCreateSchema__p1__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_document_webapi_validation_remote_ValidationProcessor__s_util_Either($as_Lamf_plugins_domain_shapes_models_AnyShape(this.shape$1), validationProcessor)
        } else {
          $m_s_package$();
          var jsx$1 = $m_sc_Seq$();
          var level = this.defaultSeverity$1;
          var targetProperty = new $c_s_Some().init___O(this.shape$1.id$1);
          var validationId = $m_Lamf_validations_PayloadValidations$().ExampleValidationErrorSpecification$1.id$1;
          var this$2 = this.shape$1;
          var position = this$2.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
          var location = this.shape$1.location__s_Option();
          var array = [new $c_Lamf_core_validation_AMFValidationResult().init___T__T__T__s_Option__T__s_Option__s_Option__O("Cannot validate shape that is not an any shape", level, "", targetProperty, validationId, position, location, null)];
          var value = validationProcessor.processResults__sc_Seq__O($as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))));
          var x1$3 = new $c_s_util_Left().init___O(value)
        };
        if ((x1$3 instanceof $c_s_util_Right)) {
          var x2 = $as_s_util_Right(x1$3);
          var p3$2 = $as_s_Option(x2.value$2);
          if ((p3$2 instanceof $c_s_Some)) {
            var x4$2 = $as_s_Some(p3$2);
            var schema = x4$2.value$2;
            return this.callValidator__sjs_js_Dictionary__sjs_js_Dynamic__s_Option__Lamf_plugins_document_webapi_validation_remote_ValidationProcessor__O(schema, obj, fragmentOption, validationProcessor)
          }
        };
        if ((x1$3 instanceof $c_s_util_Left)) {
          var x5 = $as_s_util_Left(x1$3);
          var result$2 = x5.value$2;
          return result$2
        };
        return validationProcessor.processResults__sc_Seq__O($m_sci_Nil$())
      } catch (e) {
        if ((e instanceof $c_Lamf_plugins_document_webapi_validation_remote_UnknownDiscriminator)) {
          var e$2 = $as_Lamf_plugins_document_webapi_validation_remote_UnknownDiscriminator(e);
          if (fragmentOption.isEmpty__Z()) {
            var jsx$2 = $m_s_None$()
          } else {
            var arg1$1 = fragmentOption.get__O();
            var x$3 = $as_Lamf_core_model_document_PayloadFragment(arg1$1);
            var jsx$2 = new $c_s_Some().init___O($as_Lamf_core_model_domain_DataNode(x$3.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().Encodes$1)))
          };
          return validationProcessor.processException__jl_Throwable__s_Option__O(e$2, jsx$2)
        } else {
          throw e
        }
      }
    }
  };
  return validationProcessor.processResults__sc_Seq__O($m_sci_Nil$())
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$.prototype.expression__T__Z = (function(exp) {
  var this$1 = new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser().init___T(exp);
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__completelyValid__Z(this$1)
});
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.AsyncExpressionValidator$", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_ExpressionValidator: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$;
var $n_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$)) {
    $n_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$ = new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncExpressionValidator$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$.prototype.expression__T__Z = (function(exp) {
  var this$1 = new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser().init___T(exp);
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__completelyValid__Z(this$1)
});
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.Oas3ExpressionValidator$", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_ExpressionValidator: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$;
var $n_Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$)) {
    $n_Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$ = new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_runtimeexpression_Oas3ExpressionValidator$
}
function $f_Lamf_plugins_document_webapi_validation_runtimeexpression_WithNameExpression__$$init$__V($thiz) {
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$()];
  $thiz.amf$plugins$document$webapi$validation$runtimeexpression$WithNameExpression$$undsetter$und$followedBy$und$eq__sc_Seq__V($as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))))
}
function $f_Lamf_plugins_document_webapi_validation_runtimeexpression_WithSourceBaseExpression__$$init$__V($thiz) {
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$(), $m_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$(), $m_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$(), $m_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$(), $m_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$()];
  $thiz.amf$plugins$document$webapi$validation$runtimeexpression$WithSourceBaseExpression$$undsetter$und$followedBy$und$eq__sc_Seq__V($as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))))
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$() {
  $c_O.call(this);
  this.Documentation$1 = null
}
$c_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$.prototype.constructor = $c_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$.prototype = $c_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$.prototype;
$c_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$ = this;
  $f_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField__$$init$__V(this);
  return this
});
$c_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$.prototype.amf$plugins$domain$shapes$metamodel$common$DocumentationField$$undsetter$und$Documentation$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Documentation$1 = x$1
});
var $d_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$: 0
}, false, "amf.plugins.domain.shapes.metamodel.common.DocumentationField$", {
  Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_metamodel_common_DocumentationField: 1
});
$c_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$.prototype.$classData = $d_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$;
var $n_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$ = (void 0);
function $m_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$() {
  if ((!$n_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$)) {
    $n_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$ = new $c_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$() {
  $c_O.call(this);
  this.Examples$1 = null
}
$c_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$.prototype.constructor = $c_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$.prototype = $c_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$.prototype;
$c_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$ = this;
  $f_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField__$$init$__V(this);
  return this
});
$c_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$.prototype.amf$plugins$domain$shapes$metamodel$common$ExamplesField$$undsetter$und$Examples$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Examples$1 = x$1
});
var $d_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$: 0
}, false, "amf.plugins.domain.shapes.metamodel.common.ExamplesField$", {
  Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_metamodel_common_ExamplesField: 1
});
$c_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$.prototype.$classData = $d_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$;
var $n_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$ = (void 0);
function $m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$() {
  if ((!$n_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$)) {
    $n_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$ = new $c_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$AnyType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$AnyType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$AnyType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$ArrayType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$JSONSchemaType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$LinkType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$LinkType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$LinkType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$LinkType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$LinkType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$LinkType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$LinkType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$LinkType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$LinkType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$LinkType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$LinkType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$LinkType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$LinkType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$LinkType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$LinkType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$LinkType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$LinkType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$LinkType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$LinkType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$LinkType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$MultipleMatch$", {
  Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$NilUnionType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$NilUnionType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$NilUnionType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$NilUnionType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$NilUnionType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$NilUnionType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$NilUnionType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$NilUnionType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$NilUnionType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$NilUnionType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$NilUnionType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$NilUnionType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$NilUnionType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$NilUnionType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$NilUnionType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$NilUnionType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$NilUnionType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$NilUnionType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$NilUnionType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$NilUnionType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$ObjectType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$TypeExpressionType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$UndefinedType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$UnionType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$UnionType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$UnionType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$XMLSchemaType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_RequestParamsLinkStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_domain_shapes_resolution_stages_RequestParamsLinkStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_domain_shapes_resolution_stages_RequestParamsLinkStage.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_RequestParamsLinkStage;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_RequestParamsLinkStage() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_RequestParamsLinkStage.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_RequestParamsLinkStage.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_RequestParamsLinkStage.prototype.setParams__p2__Lamf_plugins_domain_webapi_models_Request__Lamf_plugins_domain_webapi_models_Request__V = (function(from, to) {
  if ($as_sc_Seq(from.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().CookieParameters$1)).nonEmpty__Z()) {
    var cookieParameters = $as_sc_Seq(from.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().CookieParameters$1));
    var field = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().CookieParameters$1;
    $as_Lamf_plugins_domain_webapi_models_Request($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(to, field, cookieParameters))
  };
  if ($as_sc_Seq(from.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Headers$1)).nonEmpty__Z()) {
    var headers = $as_sc_Seq(from.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Headers$1));
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Headers$1;
    $as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(to, field$1, headers))
  };
  if ($as_sc_Seq(from.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().UriParameters$1)).nonEmpty__Z()) {
    var uriParameters = $as_sc_Seq(from.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().UriParameters$1));
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().UriParameters$1;
    $as_Lamf_plugins_domain_webapi_models_Request($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(to, field$2, uriParameters))
  };
  if ($as_sc_Seq(from.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryParameters$1)).nonEmpty__Z()) {
    var parameters = $as_sc_Seq(from.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryParameters$1));
    var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryParameters$1;
    $as_Lamf_plugins_domain_webapi_models_Request($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(to, field$3, parameters))
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_RequestParamsLinkStage.prototype.customDomainElementTransformation__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_Linkable__Lamf_core_model_domain_DomainElement = (function(resolved, link) {
  if ((resolved instanceof $c_Lamf_plugins_domain_webapi_models_Request)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_Request(resolved);
    if ((link instanceof $c_Lamf_plugins_domain_webapi_models_Request)) {
      var x3 = $as_Lamf_plugins_domain_webapi_models_Request(link);
      var fields = x2.fields$2.copy__Lamf_core_parser_Fields();
      var this$1 = x2.annotations$2;
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(this$1);
      var copied = new $c_Lamf_plugins_domain_webapi_models_Request().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
      copied.id$1 = x3.id$1;
      this.setParams__p2__Lamf_plugins_domain_webapi_models_Request__Lamf_plugins_domain_webapi_models_Request__V(x3, copied);
      return copied
    }
  };
  return resolved
});
$c_Lamf_plugins_domain_shapes_resolution_stages_RequestParamsLinkStage.prototype.transform__p2__Lamf_core_model_domain_DomainElement__Z__s_Option = (function(e, isCycle) {
  var x$1 = this.errorHandler$1;
  var x$2 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(resolved$2, link$2) {
      var resolved = $as_Lamf_core_model_domain_DomainElement(resolved$2);
      var link = $as_Lamf_core_model_domain_Linkable(link$2);
      return $this.customDomainElementTransformation__p2__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_Linkable__Lamf_core_model_domain_DomainElement(resolved, link)
    })
  })(this));
  $m_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$();
  var x$3 = false;
  $m_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$();
  var x$4 = $m_s_None$();
  $m_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$();
  var x$5 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var referenceResolution = new $c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution().init___Lamf_core_errorhandling_ErrorHandler__Z__s_Option__scm_Map__F2(x$1, x$3, x$4, x$5, x$2);
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution$().ASSERT$undDIFFERENT$1];
  return referenceResolution.transform__Lamf_core_model_domain_DomainElement__sc_Seq__s_Option(e, $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_RequestParamsLinkStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  var this$1 = $m_Lamf_core_resolution_stages_selectors_LinkSelector$();
  var another = $m_Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$();
  return model.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(new $c_Lamf_core_resolution_stages_selectors_AndSelector().init___Lamf_core_resolution_stages_selectors_Selector__Lamf_core_resolution_stages_selectors_Selector(this$1, another), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(e$2, isCycle$2) {
      var e = $as_Lamf_core_model_domain_DomainElement(e$2);
      var isCycle = $uZ(isCycle$2);
      return $this.transform__p2__Lamf_core_model_domain_DomainElement__Z__s_Option(e, isCycle)
    })
  })(this)), this.errorHandler$1)
});
$c_Lamf_plugins_domain_shapes_resolution_stages_RequestParamsLinkStage.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_domain_shapes_resolution_stages_RequestParamsLinkStage = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_RequestParamsLinkStage: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.RequestParamsLinkStage", {
  Lamf_plugins_domain_shapes_resolution_stages_RequestParamsLinkStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_RequestParamsLinkStage.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_RequestParamsLinkStage;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_ShapeNormalizationStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this);
  this.keepEditingInfo$2 = false;
  this.m$2 = null;
  this.context$2 = null
}
$c_Lamf_plugins_domain_shapes_resolution_stages_ShapeNormalizationStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_domain_shapes_resolution_stages_ShapeNormalizationStage.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_ShapeNormalizationStage;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_ShapeNormalizationStage() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_ShapeNormalizationStage.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_ShapeNormalizationStage.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_ShapeNormalizationStage.prototype.transform__Lamf_core_model_domain_DomainElement__Z__s_Option = (function(element, isCycle) {
  if ((element instanceof $c_Lamf_core_model_domain_Shape)) {
    var x2 = $as_Lamf_core_model_domain_Shape(element);
    var this$1 = new $c_Lamf_plugins_domain_shapes_resolution_stages_ShapeTransformer().init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext(this.context$2);
    return this$1.transform__Lamf_core_model_domain_Shape__s_Option(x2)
  } else {
    return new $c_s_Some().init___O(element)
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_ShapeNormalizationStage.prototype.init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler = (function(profile, keepEditingInfo, errorHandler) {
  this.keepEditingInfo$2 = keepEditingInfo;
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  this.m$2 = $m_s_None$();
  this.context$2 = new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext().init___Lamf_core_errorhandling_ErrorHandler__Z__Lamf_ProfileName__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache(errorHandler, keepEditingInfo, profile, new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache().init___());
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_ShapeNormalizationStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  this.m$2 = new $c_s_Some().init___O(model);
  return model.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit($m_Lamf_core_resolution_stages_selectors_ShapeSelector$(), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(element$2, isCycle$2) {
      var element = $as_Lamf_core_model_domain_DomainElement(element$2);
      var isCycle = $uZ(isCycle$2);
      return $this.transform__Lamf_core_model_domain_DomainElement__Z__s_Option(element, isCycle)
    })
  })(this)), this.errorHandler$1)
});
var $d_Lamf_plugins_domain_shapes_resolution_stages_ShapeNormalizationStage = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_ShapeNormalizationStage: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.ShapeNormalizationStage", {
  Lamf_plugins_domain_shapes_resolution_stages_ShapeNormalizationStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_ShapeNormalizationStage.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_ShapeNormalizationStage;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_ShapeTransformer() {
  $c_Lamf_core_resolution_stages_elements_resolution_ElementStageTransformer.call(this);
  this.context$2 = null;
  this.recursionRegister$2 = null
}
$c_Lamf_plugins_domain_shapes_resolution_stages_ShapeTransformer.prototype = new $h_Lamf_core_resolution_stages_elements_resolution_ElementStageTransformer();
$c_Lamf_plugins_domain_shapes_resolution_stages_ShapeTransformer.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_ShapeTransformer;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_ShapeTransformer() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_ShapeTransformer.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_ShapeTransformer.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_ShapeTransformer.prototype.init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext = (function(context) {
  this.context$2 = context;
  this.recursionRegister$2 = new $c_Lamf_plugins_domain_shapes_resolution_stages_recursion_RecursionErrorRegister().init___Lamf_core_errorhandling_ErrorHandler(context.errorHandler$1);
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_ShapeTransformer.prototype.transform__Lamf_core_model_domain_DomainElement__s_Option = (function(element) {
  return this.transform__Lamf_core_model_domain_Shape__s_Option($as_Lamf_core_model_domain_Shape(element))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_ShapeTransformer.prototype.transform__Lamf_core_model_domain_Shape__s_Option = (function(element) {
  return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$().apply__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext__Lamf_core_model_domain_Shape($m_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$().apply__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext__Lamf_plugins_domain_shapes_resolution_stages_recursion_RecursionErrorRegister__Lamf_core_model_domain_Shape(element, this.context$2, this.recursionRegister$2), this.context$2))
});
var $d_Lamf_plugins_domain_shapes_resolution_stages_ShapeTransformer = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_ShapeTransformer: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.ShapeTransformer", {
  Lamf_plugins_domain_shapes_resolution_stages_ShapeTransformer: 1,
  Lamf_core_resolution_stages_elements_resolution_ElementStageTransformer: 1,
  O: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_ShapeTransformer.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_ShapeTransformer;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm() {
  $c_O.call(this);
  this.UnionErrorHandler$module$1 = null;
  this.context$1 = null;
  this.allShapeFields$1 = null;
  this.keepEditingInfo$1 = false
}
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.computeMinNode__Lamf_plugins_domain_shapes_models_NodeShape__Lamf_plugins_domain_shapes_models_NodeShape__Lamf_core_model_domain_Shape = (function(baseNode, superNode) {
  var superProperties = $as_sc_Seq(superNode.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1));
  var baseProperties = $as_sc_Seq(baseNode.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1));
  var commonProps = $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  superProperties.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, commonProps$1) {
    return (function(p$2) {
      var p = $as_Lamf_core_model_domain_extensions_PropertyShape(p$2);
      var this$1 = $as_Lamf_core_model_StrField(p.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Path$1));
      var this$2 = this$1.option$1;
      return commonProps$1.put__O__O__s_Option($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())), false)
    })
  })(this, commonProps)));
  baseProperties.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, commonProps$2) {
    return (function(p$3$2) {
      var p$3 = $as_Lamf_core_model_domain_extensions_PropertyShape(p$3$2);
      var this$3 = $as_Lamf_core_model_StrField(p$3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Path$1));
      var this$4 = this$3.option$1;
      if (commonProps$2.get__O__s_Option($as_T((this$4.isEmpty__Z() ? null : this$4.get__O()))).isDefined__Z()) {
        var this$5 = $as_Lamf_core_model_StrField(p$3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Path$1));
        var this$6 = this$5.option$1;
        return commonProps$2.put__O__O__s_Option($as_T((this$6.isEmpty__Z() ? null : this$6.get__O())), true)
      } else {
        var this$7 = $as_Lamf_core_model_StrField(p$3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Path$1));
        var this$8 = this$7.option$1;
        return commonProps$2.put__O__O__s_Option($as_T((this$8.isEmpty__Z() ? null : this$8.get__O())), false)
      }
    })
  })(this, commonProps)));
  var this$9 = $m_scm_Iterable$();
  var bf = this$9.ReusableCBFInstance$2;
  var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(commonProps, bf);
  var iterTable = commonProps.table$5;
  var idx = $f_scm_HashTable__scala$collection$mutable$HashTable$$lastPopulatedIndex__I(commonProps);
  var es = iterTable.get(idx);
  while ((es !== null)) {
    var next = $as_scm_HashEntry(es.next__O());
    var arg1 = es;
    var e = $as_scm_DefaultEntry(arg1);
    var arg1$1 = new $c_T2().init___O__O(e.key$1, e.value$1);
    matchEnd7: {
      var jsx$1;
      var path = $as_T(arg1$1.$$und1$f);
      var p2 = $uZ(arg1$1.$$und2$f);
      if ((p2 === true)) {
        var superProp = $as_Lamf_core_model_domain_extensions_PropertyShape(superProperties.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, path$1) {
          return (function(x$4$2) {
            var x$4 = $as_Lamf_core_model_domain_extensions_PropertyShape(x$4$2);
            var this$10 = $as_Lamf_core_model_StrField(x$4.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Path$1));
            return $f_Lamf_core_model_ValueField__is__O__Z(this$10, path$1)
          })
        })(this, path))).get__O());
        var baseProp = $as_Lamf_core_model_domain_extensions_PropertyShape(baseProperties.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$2, path$2) {
          return (function(x$5$2) {
            var x$5 = $as_Lamf_core_model_domain_extensions_PropertyShape(x$5$2);
            var this$11 = $as_Lamf_core_model_StrField(x$5.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Path$1));
            return $f_Lamf_core_model_ValueField__is__O__Z(this$11, path$2)
          })
        })(this, path))).get__O());
        var jsx$1 = this.context$1.minShape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(baseProp, superProp);
        break matchEnd7
      };
      var path$2$1 = $as_T(arg1$1.$$und1$f);
      var p3 = $uZ(arg1$1.$$und2$f);
      if ((p3 === false)) {
        var superPropOption = superProperties.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, path$2$2) {
          return (function(x$6$2) {
            var x$6 = $as_Lamf_core_model_domain_extensions_PropertyShape(x$6$2);
            var this$12 = $as_Lamf_core_model_StrField(x$6.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Path$1));
            return $f_Lamf_core_model_ValueField__is__O__Z(this$12, path$2$2)
          })
        })(this, path$2$1)));
        var basePropOption = baseProperties.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, path$2$3) {
          return (function(x$7$2) {
            var x$7 = $as_Lamf_core_model_domain_extensions_PropertyShape(x$7$2);
            var this$13 = $as_Lamf_core_model_StrField(x$7.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Path$1));
            return $f_Lamf_core_model_ValueField__is__O__Z(this$13, path$2$3)
          })
        })(this, path$2$1)));
        if (this.keepEditingInfo$1) {
          if (superPropOption.isEmpty__Z()) {
            var this$14 = $m_s_None$()
          } else {
            var arg1$2 = superPropOption.get__O();
            var prop = $as_Lamf_core_model_domain_extensions_PropertyShape(arg1$2);
            var this$14 = new $c_s_Some().init___O(this.inheritProp__Lamf_core_model_domain_Shape__Lamf_core_model_domain_extensions_PropertyShape__Lamf_core_model_domain_extensions_PropertyShape(superNode, prop))
          };
          if (this$14.isEmpty__Z()) {
            var qual$1 = $as_Lamf_core_model_domain_extensions_PropertyShape(basePropOption.get__O());
            var x$1 = new $c_s_Some().init___O(this.context$1.errorHandler$1);
            var x$2 = $m_s_None$();
            var x$3 = new $c_Lamf_core_traversal_ModelTraversalRegistry().init___();
            var jsx$2 = qual$1.cloneShape__s_Option__s_Option__Lamf_core_traversal_ModelTraversalRegistry__Z__Lamf_core_model_domain_extensions_PropertyShape(x$1, x$2, x$3, false)
          } else {
            var jsx$2 = this$14.get__O()
          };
          var jsx$1 = $as_Lamf_core_model_domain_Shape(jsx$2);
          break matchEnd7
        } else {
          if (superPropOption.isEmpty__Z()) {
            var this$15 = $m_s_None$()
          } else {
            var arg1$3 = superPropOption.get__O();
            var x$8 = $as_Lamf_core_model_domain_extensions_PropertyShape(arg1$3);
            var this$15 = new $c_s_Some().init___O(x$8.cloneShape__s_Option__s_Option__Lamf_core_traversal_ModelTraversalRegistry__Z__Lamf_core_model_domain_extensions_PropertyShape(new $c_s_Some().init___O(this.context$1.errorHandler$1), $m_s_None$(), new $c_Lamf_core_traversal_ModelTraversalRegistry().init___(), false))
          };
          if (this$15.isEmpty__Z()) {
            var qual$2 = $as_Lamf_core_model_domain_extensions_PropertyShape(basePropOption.get__O());
            var x$5$1 = new $c_s_Some().init___O(this.context$1.errorHandler$1);
            var x$6$1 = $m_s_None$();
            var x$7$1 = new $c_Lamf_core_traversal_ModelTraversalRegistry().init___();
            var jsx$3 = qual$2.cloneShape__s_Option__s_Option__Lamf_core_traversal_ModelTraversalRegistry__Z__Lamf_core_model_domain_extensions_PropertyShape(x$5$1, x$6$1, x$7$1, false)
          } else {
            var jsx$3 = this$15.get__O()
          };
          var jsx$1 = $as_Lamf_core_model_domain_Shape(jsx$3);
          break matchEnd7
        }
      };
      throw new $c_s_MatchError().init___O(arg1$1)
    };
    b.$$plus$eq__O__scm_Builder(jsx$1);
    es = next;
    while (((es === null) && (idx > 0))) {
      idx = (((-1) + idx) | 0);
      es = iterTable.get(idx)
    }
  };
  var minProps = $as_scm_Iterable(b.result__O());
  var x1 = $m_s_Option$().apply__O__s_Option(baseNode.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var field = $as_Lamf_core_parser_Value(x2.value$2);
    var annotations = field.annotations$1
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___()
  };
  baseNode.fields$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(minProps.toSeq__sc_Seq(), new $c_Lamf_core_parser_Annotations().init___()), annotations);
  var fields = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().fields$1;
  var jsx$4 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1, $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Examples$1];
  var filteredFields = $as_sc_Seq(jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNarrowRestrictions__sc_Seq__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_model_domain_Shape(this, fields, baseNode, superNode, filteredFields);
  if (this.context$1.isRaml08$1) {
    var this$20 = superNode.annotations$2.find__jl_Class__s_Option($d_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.getClassOf());
    if ((!this$20.isEmpty__Z())) {
      var arg1$4 = this$20.get__O();
      var x$9 = $as_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema(arg1$4);
      baseNode.annotations$2.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(x$9)
    }
  };
  return baseNode
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext = (function(context) {
  this.context$1 = context;
  var jsx$6 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().fields$1;
  var jsx$5 = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().fields$1;
  var this$1 = $m_sci_List$();
  var jsx$4 = $as_sci_List(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$5, this$1.ReusableCBFInstance$2));
  var jsx$3 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().fields$1;
  var this$2 = $m_sci_List$();
  var jsx$2 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$2.ReusableCBFInstance$2));
  var jsx$1 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().fields$1;
  var this$3 = $m_sci_List$();
  this.allShapeFields$1 = $as_sci_List($as_sc_SeqLike(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2)).distinct__O());
  this.keepEditingInfo$1 = context.keepEditingInfo$1;
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.computeMinSchema__p1__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_SchemaShape__Lamf_plugins_domain_shapes_models_SchemaShape = (function(superShape, schema) {
  var this$2 = superShape.fields__Lamf_core_parser_Fields();
  var fn = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, schema$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      matchEnd5: {
        if ((x0$1 !== null)) {
          var f = $as_Lamf_core_metamodel_Field(x0$1.$$und1__O());
          var v = $as_Lamf_core_parser_Value(x0$1.$$und2__O());
          if ((f !== null)) {
            if ((v !== null)) {
              var this$1 = schema$1.fields$2;
              if ((!this$1.fs$1.contains__O__Z(f))) {
                var value = v.value$1;
                var annotations = v.annotations$1;
                $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(schema$1, f, value, annotations);
                break matchEnd5
              }
            }
          }
        }
      }
    })
  })(this, schema));
  this$2.fs$1.foreach__F1__V(fn);
  return schema
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.avoidDuplicatedIds__p1__sc_Seq__V = (function(newUnionItems) {
  newUnionItems.groupBy__F1__sci_Map(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$10$2) {
      var x$10 = $as_Lamf_core_model_domain_Shape(x$10$2);
      return x$10.id$1
    })
  })(this))).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      matchEnd4: {
        if ((x0$1 !== null)) {
          var shapes = $as_sc_Seq(x0$1.$$und2__O());
          if ((shapes.size__I() > 1)) {
            var counter = new $c_Lamf_plugins_document_vocabularies_emitters_common_IdCounter().init___();
            shapes.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, counter$1) {
              return (function(shape$2) {
                var shape = $as_Lamf_core_model_domain_Shape(shape$2);
                shape.id$1 = counter$1.genId__T__T(shape.id$1)
              })
            })(this$2, counter)));
            break matchEnd4
          }
        }
      }
    })
  })(this)))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.computeMinAny__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_model_domain_Shape = (function(baseShape, anyShape) {
  var fields = this.allShapeFields$1;
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$3 = new $c_scm_ListBuffer().init___();
  var filteredFields = this$3.toList__sci_List();
  $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNarrowRestrictions__sc_Seq__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_model_domain_Shape(this, fields, baseShape, anyShape, filteredFields);
  return baseShape
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.UnionErrorHandler$lzycompute$1__p1__V = (function() {
  if ((this.UnionErrorHandler$module$1 === null)) {
    this.UnionErrorHandler$module$1 = new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$().init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm(this)
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.copy__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape = (function(shape) {
  if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(shape);
    var this$1 = $c_Lamf_core_model_domain_Shape.prototype.copyShape__Lamf_core_model_domain_Shape.call(x2);
    var value = x2.id$1;
    return $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$1, value))
  } else if ((shape instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
    var x3 = $as_Lamf_core_model_domain_RecursiveShape(shape);
    return x3.copyShape__Lamf_core_model_domain_RecursiveShape()
  } else {
    return shape
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.computeMinMatrix__Lamf_plugins_domain_shapes_models_MatrixShape__Lamf_plugins_domain_shapes_models_MatrixShape__Lamf_core_model_domain_Shape = (function(baseMatrix, superMatrix) {
  var superItems = $as_Lamf_core_model_domain_Shape(superMatrix.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1));
  var baseItems = $as_Lamf_core_model_domain_Shape(baseMatrix.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1));
  if (($m_s_Option$().apply__O__s_Option(superItems).isDefined__Z() && $m_s_Option$().apply__O__s_Option(baseItems).isDefined__Z())) {
    var newItems = this.context$1.minShape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(baseItems, superItems);
    baseMatrix.fields$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1, newItems, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
    var fields = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().fields$1;
    var jsx$1 = $m_sc_Seq$();
    var array = [$m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1];
    var filteredFields = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
    $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNarrowRestrictions__sc_Seq__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_model_domain_Shape(this, fields, baseMatrix, superMatrix, filteredFields)
  } else if ($m_s_Option$().apply__O__s_Option(superItems).isDefined__Z()) {
    baseMatrix.fields$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1, superItems, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
  };
  return baseMatrix
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.isGenericNodeShape__Lamf_core_model_domain_Shape__Z = (function(shape) {
  if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_NodeShape(shape);
    return $as_sc_Seq(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1)).isEmpty__Z()
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.computeMinProperty__Lamf_core_model_domain_extensions_PropertyShape__Lamf_core_model_domain_extensions_PropertyShape__Lamf_core_model_domain_Shape = (function(baseProperty, superProperty) {
  if (((this.isExactlyAny__p1__Lamf_core_model_domain_Shape__Z($as_Lamf_core_model_domain_Shape(baseProperty.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1))) && (!this.isInferred__p1__Lamf_core_model_domain_extensions_PropertyShape__Z(baseProperty))) && this.isSubtypeOfAny__p1__Lamf_core_model_domain_Shape__Z($as_Lamf_core_model_domain_Shape(superProperty.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1))))) {
    var this$1 = this.context$1.errorHandler$1;
    var specification = $m_Lamf_validations_ResolutionSideValidations$().InvalidTypeInheritanceErrorSpecification$1;
    var target = new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1.value$1.iri__T());
    var node = baseProperty.id$1;
    var lexical = baseProperty.annotations$2.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var location = $f_Lamf_core_model_domain_AmfElement__location__s_Option(baseProperty);
    this$1.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, target, "Resolution error: Invalid scalar inheritance base type 'any' can't override", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
  } else {
    var newRange = this.context$1.minShape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape($as_Lamf_core_model_domain_Shape(baseProperty.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1)), $as_Lamf_core_model_domain_Shape(superProperty.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1)));
    baseProperty.fields$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1, newRange, baseProperty.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1).annotations$1);
    var fields = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().fields__sci_List();
    var jsx$1 = $m_sc_Seq$();
    var array = [$m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1];
    var filteredFields = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
    $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNarrowRestrictions__sc_Seq__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_model_domain_Shape(this, fields, baseProperty, superProperty, filteredFields)
  };
  return baseProperty
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.UnionErrorHandler__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$ = (function() {
  if ((this.UnionErrorHandler$module$1 === null)) {
    this.UnionErrorHandler$lzycompute$1__p1__V()
  };
  return this.UnionErrorHandler$module$1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.isInferred__p1__Lamf_core_model_domain_extensions_PropertyShape__Z = (function(shape) {
  return $as_Lamf_core_model_domain_Shape(shape.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1)).annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_plugins_document_webapi_annotations_Inferred.getClassOf())
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.computeMinUnionNode__Lamf_plugins_domain_shapes_models_UnionShape__Lamf_plugins_domain_shapes_models_NodeShape__Lamf_core_model_domain_Shape = (function(baseUnion, superNode) {
  var this$1 = this.UnionErrorHandler__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$();
  var ctx = this.context$1;
  var unionContext = new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext().init___Lamf_core_errorhandling_ErrorHandler__Z__Lamf_ProfileName__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache(this$1, ctx.keepEditingInfo$1, ctx.profile$1, ctx.cache$1);
  var jsx$2 = $as_sc_Seq(baseUnion.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, unionContext$1, superNode$1) {
    return (function(baseUnionElement$2) {
      var baseUnionElement = $as_Lamf_core_model_domain_Shape(baseUnionElement$2);
      return unionContext$1.minShape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(baseUnionElement, superNode$1)
    })
  })(this, unionContext, superNode));
  var this$2 = $m_sc_Seq$();
  var newUnionItems = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  baseUnion.fields$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(newUnionItems, new $c_Lamf_core_parser_Annotations().init___()), baseUnion.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1).annotations$1);
  var fields = $m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().fields$1;
  var jsx$3 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1];
  var filteredFields = $as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNarrowRestrictions__sc_Seq__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_model_domain_Shape(this, fields, baseUnion, superNode, filteredFields);
  return baseUnion
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.computeMinUnion__Lamf_plugins_domain_shapes_models_UnionShape__Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_model_domain_Shape = (function(baseUnion, superUnion) {
  var this$1 = this.UnionErrorHandler__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$();
  var ctx = this.context$1;
  var unionContext = new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext().init___Lamf_core_errorhandling_ErrorHandler__Z__Lamf_ProfileName__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache(this$1, ctx.keepEditingInfo$1, ctx.profile$1, ctx.cache$1);
  if (($as_sc_Seq(baseUnion.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1)).isEmpty__Z() || $as_sc_Seq(superUnion.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1)).isEmpty__Z())) {
    var jsx$2 = $as_sc_Seq(baseUnion.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1));
    var jsx$1 = $as_sc_Seq(superUnion.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1));
    var this$2 = $m_sc_Seq$();
    var newUnionItems = $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2))
  } else {
    var jsx$6 = $as_sc_Seq(baseUnion.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1));
    var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, superUnion$1, unionContext$1) {
      return (function(baseUnionElement$2) {
        var baseUnionElement = $as_Lamf_core_model_domain_Shape(baseUnionElement$2);
        var jsx$5 = $as_sc_Seq(superUnion$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1));
        var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, unionContext$1$1, baseUnionElement$1) {
          return (function(superUnionElement$2) {
            var superUnionElement = $as_Lamf_core_model_domain_Shape(superUnionElement$2);
            try {
              return new $c_s_Some().init___O(unionContext$1$1.minShape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(baseUnionElement$1, superUnionElement))
            } catch (e) {
              var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
              if ((e$2 instanceof $c_jl_Exception)) {
                return $m_s_None$()
              } else {
                throw e
              }
            }
          })
        })($this, unionContext$1, baseUnionElement));
        var this$3 = $m_sc_Seq$();
        return $as_sc_Seq(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$4, this$3.ReusableCBFInstance$2))
      })
    })(this, superUnion, unionContext));
    var this$4 = $m_sc_Seq$();
    var minShapes = $as_sc_Seq(jsx$6.flatMap__F1__scg_CanBuildFrom__O(jsx$3, this$4.ReusableCBFInstance$2));
    var jsx$7 = new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$1().init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm(this);
    var this$5 = $m_sc_Seq$();
    var finalMinShapes = $as_sc_Seq(minShapes.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$7, this$5.ReusableCBFInstance$2));
    if (finalMinShapes.isEmpty__Z()) {
      throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("Cannot compute inheritance for union", $m_s_None$(), $f_Lamf_core_model_domain_ExternalSourceElement__location__s_Option(baseUnion), baseUnion.annotations$2.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), false)
    };
    var newUnionItems = finalMinShapes
  };
  this.avoidDuplicatedIds__p1__sc_Seq__V(newUnionItems);
  baseUnion.fields$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(newUnionItems, new $c_Lamf_core_parser_Annotations().init___()), baseUnion.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1).annotations$1);
  var fields = $m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().fields$1;
  var jsx$8 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1];
  var filteredFields = $as_sc_Seq(jsx$8.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNarrowRestrictions__sc_Seq__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_model_domain_Shape(this, fields, baseUnion, superUnion, filteredFields);
  return baseUnion
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.computeMinScalar__Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_plugins_domain_shapes_models_ScalarShape = (function(baseScalar, superScalar) {
  var fields = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().fields$1;
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Examples$1];
  var filteredFields = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNarrowRestrictions__sc_Seq__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_model_domain_Shape(this, fields, baseScalar, superScalar, filteredFields);
  return baseScalar
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.isSubtypeOfAny__p1__Lamf_core_model_domain_Shape__Z = (function(shape) {
  var x = shape.meta__Lamf_core_metamodel_Obj();
  var x$2 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$();
  if ((!((x !== null) && (x === x$2)))) {
    return (shape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.computeMinArray__Lamf_plugins_domain_shapes_models_ArrayShape__Lamf_plugins_domain_shapes_models_ArrayShape__Lamf_core_model_domain_Shape = (function(baseArray, superArray) {
  var superItemsOption = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(superArray.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1)));
  var baseItemsOption = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(baseArray.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1)));
  if (baseItemsOption.isEmpty__Z()) {
    var this$1 = $m_s_None$()
  } else {
    var arg1 = baseItemsOption.get__O();
    var baseItems = $as_Lamf_core_model_domain_Shape(arg1);
    if ((superItemsOption instanceof $c_s_Some)) {
      var x2 = $as_s_Some(superItemsOption);
      var superItems = $as_Lamf_core_model_domain_Shape(x2.value$2);
      var jsx$1 = this.context$1.minShape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(baseItems, superItems)
    } else {
      var jsx$1 = baseItems
    };
    var this$1 = new $c_s_Some().init___O(jsx$1)
  };
  var newItems = (this$1.isEmpty__Z() ? superItemsOption : this$1);
  if ((!newItems.isEmpty__Z())) {
    var arg1$1 = newItems.get__O();
    var ni = $as_Lamf_core_model_domain_Shape(arg1$1);
    baseArray.withItems__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_ArrayShape(ni)
  };
  var fields = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().fields$1;
  var jsx$2 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1];
  var filteredFields = $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNarrowRestrictions__sc_Seq__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_model_domain_Shape(this, fields, baseArray, superArray, filteredFields);
  return baseArray
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.setValuesOfUnionElement__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__V = (function(newShape, superUnionElement) {
  var this$1 = $as_Lamf_core_model_StrField(superUnionElement.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var n = $as_T(arg1);
    $m_Lamf_core_parser_Annotations$();
    var a = new $c_Lamf_core_parser_Annotations().init___();
    $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(newShape, n, a))
  };
  matchEnd5: {
    if ((newShape instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
      var x2 = $as_Lamf_plugins_domain_shapes_models_NodeShape(newShape);
      if ((superUnionElement instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
        var x3 = $as_Lamf_plugins_domain_shapes_models_NodeShape(superUnionElement);
        var this$3 = x2.fields$2;
        var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1;
        var this$4 = this$3.fs$1.get__O__s_Option(field);
        if ((!this$4.isEmpty__Z())) {
          var arg1$1 = this$4.get__O();
          var closedValue = $as_Lamf_core_parser_Value(arg1$1);
          var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1;
          var this$5 = $as_Lamf_core_model_BoolField(x3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1));
          var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($f_Lamf_core_model_BoolField__value__Z(this$5), closedValue.value$1.annotations__Lamf_core_parser_Annotations());
          var annotations = closedValue.annotations$1;
          new $c_s_Some().init___O($as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(x2, field$1, value, annotations)))
        };
        break matchEnd5
      }
    }
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.computeMinShape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape = (function(derivedShapeOrig, superShapeOri) {
  var superShape = this.copy__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(superShapeOri);
  var derivedShape = derivedShapeOrig.cloneShape__s_Option__s_Option__Lamf_core_traversal_ModelTraversalRegistry__Z__Lamf_core_model_domain_Shape(new $c_s_Some().init___O(this.context$1.errorHandler$1), derivedShapeOrig.cloneShape$default$2__s_Option(), derivedShapeOrig.cloneShape$default$3__Lamf_core_traversal_ModelTraversalRegistry(), derivedShapeOrig.cloneShape$default$4__Z());
  try {
    var rc16 = false;
    var x6 = null;
    var rc17 = false;
    var x7 = null;
    if ((derivedShape instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
      var x2 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(derivedShape);
      if ((superShape instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
        var superScalar = $as_Lamf_plugins_domain_shapes_models_ScalarShape(superShape);
        var this$1 = $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1));
        var this$2 = this$1.option$1;
        var b = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
        var this$3 = $as_Lamf_core_model_StrField(superScalar.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1));
        var this$4 = this$3.option$1;
        var s = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
        if ((b === s)) {
          return this.computeMinScalar__Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_plugins_domain_shapes_models_ScalarShape(x2, superScalar)
        } else if (((b === $m_Lamf_core_model_DataType$().Integer$1) && (((s === $m_Lamf_core_model_DataType$().Float$1) || (s === $m_Lamf_core_model_DataType$().Double$1)) || (s === $m_Lamf_core_model_DataType$().Number$1)))) {
          var dataType = $m_Lamf_core_model_DataType$().Integer$1;
          var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
          return this.computeMinScalar__Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_plugins_domain_shapes_models_ScalarShape(x2, $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(superScalar, field, dataType)))
        } else if (($as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1)).option$1.isEmpty__Z() && $as_Lamf_core_model_StrField(superScalar.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1)).option$1.isDefined__Z())) {
          var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
          return this.computeMinShape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape($as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x2, field$1, s)), superScalar)
        } else {
          var this$5 = this.context$1.errorHandler$1;
          var specification = $m_Lamf_validations_ResolutionSideValidations$().InvalidTypeInheritanceErrorSpecification$1;
          var target = new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1.value$1.iri__T());
          var message = (((("Resolution error: Invalid scalar inheritance base type " + b) + " < ") + s) + " ");
          var node = derivedShape.id$1;
          var lexical = derivedShape.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
          var location = derivedShape.location__s_Option();
          this$5.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, target, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
          return x2
        }
      }
    };
    if ((derivedShape instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
      var x3 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(derivedShape);
      if ((superShape instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
        var superArray = $as_Lamf_plugins_domain_shapes_models_ArrayShape(superShape);
        return this.computeMinArray__Lamf_plugins_domain_shapes_models_ArrayShape__Lamf_plugins_domain_shapes_models_ArrayShape__Lamf_core_model_domain_Shape(x3, superArray)
      }
    };
    if ((derivedShape instanceof $c_Lamf_plugins_domain_shapes_models_MatrixShape)) {
      var x4 = $as_Lamf_plugins_domain_shapes_models_MatrixShape(derivedShape);
      if ((superShape instanceof $c_Lamf_plugins_domain_shapes_models_MatrixShape)) {
        var superArray$2 = $as_Lamf_plugins_domain_shapes_models_MatrixShape(superShape);
        return this.computeMinMatrix__Lamf_plugins_domain_shapes_models_MatrixShape__Lamf_plugins_domain_shapes_models_MatrixShape__Lamf_core_model_domain_Shape(x4, superArray$2)
      }
    };
    if ((derivedShape instanceof $c_Lamf_plugins_domain_shapes_models_TupleShape)) {
      var x5 = $as_Lamf_plugins_domain_shapes_models_TupleShape(derivedShape);
      if ((superShape instanceof $c_Lamf_plugins_domain_shapes_models_TupleShape)) {
        var superArray$3 = $as_Lamf_plugins_domain_shapes_models_TupleShape(superShape);
        return this.computeMinTuple__Lamf_plugins_domain_shapes_models_TupleShape__Lamf_plugins_domain_shapes_models_TupleShape__Lamf_core_model_domain_Shape(x5, superArray$3)
      }
    };
    if ((derivedShape instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
      rc16 = true;
      x6 = $as_Lamf_plugins_domain_shapes_models_NodeShape(derivedShape);
      if ((superShape instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
        var superNode = $as_Lamf_plugins_domain_shapes_models_NodeShape(superShape);
        return this.computeMinNode__Lamf_plugins_domain_shapes_models_NodeShape__Lamf_plugins_domain_shapes_models_NodeShape__Lamf_core_model_domain_Shape(x6, superNode)
      }
    };
    if ((derivedShape instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
      rc17 = true;
      x7 = $as_Lamf_plugins_domain_shapes_models_UnionShape(derivedShape);
      if ((superShape instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
        var superUnion = $as_Lamf_plugins_domain_shapes_models_UnionShape(superShape);
        return this.computeMinUnion__Lamf_plugins_domain_shapes_models_UnionShape__Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_model_domain_Shape(x7, superUnion)
      }
    };
    if ((rc17 && (superShape instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape))) {
      var superNode$2 = $as_Lamf_plugins_domain_shapes_models_NodeShape(superShape);
      return this.computeMinUnionNode__Lamf_plugins_domain_shapes_models_UnionShape__Lamf_plugins_domain_shapes_models_NodeShape__Lamf_core_model_domain_Shape(x7, superNode$2)
    };
    if ((derivedShape !== null)) {
      if ((superShape instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
        var superUnion$2 = $as_Lamf_plugins_domain_shapes_models_UnionShape(superShape);
        return this.computeMinSuperUnion__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_model_domain_Shape(derivedShape, superUnion$2)
      }
    };
    if ((derivedShape instanceof $c_Lamf_core_model_domain_extensions_PropertyShape)) {
      var x10 = $as_Lamf_core_model_domain_extensions_PropertyShape(derivedShape);
      if ((superShape instanceof $c_Lamf_core_model_domain_extensions_PropertyShape)) {
        var superProperty = $as_Lamf_core_model_domain_extensions_PropertyShape(superShape);
        return this.computeMinProperty__Lamf_core_model_domain_extensions_PropertyShape__Lamf_core_model_domain_extensions_PropertyShape__Lamf_core_model_domain_Shape(x10, superProperty)
      }
    };
    if ((derivedShape instanceof $c_Lamf_plugins_domain_shapes_models_FileShape)) {
      var x11 = $as_Lamf_plugins_domain_shapes_models_FileShape(derivedShape);
      if ((superShape instanceof $c_Lamf_plugins_domain_shapes_models_FileShape)) {
        var superFile = $as_Lamf_plugins_domain_shapes_models_FileShape(superShape);
        return this.computeMinFile__Lamf_plugins_domain_shapes_models_FileShape__Lamf_plugins_domain_shapes_models_FileShape__Lamf_core_model_domain_Shape(x11, superFile)
      }
    };
    if ((derivedShape instanceof $c_Lamf_plugins_domain_shapes_models_NilShape)) {
      var x12 = $as_Lamf_plugins_domain_shapes_models_NilShape(derivedShape);
      if ((superShape instanceof $c_Lamf_plugins_domain_shapes_models_NilShape)) {
        return x12
      }
    };
    if ((superShape instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
      var recursiveShape = $as_Lamf_core_model_domain_RecursiveShape(superShape);
      return $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__restrictShape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(this, derivedShape, recursiveShape)
    };
    var this$6 = derivedShape.meta__Lamf_core_metamodel_Obj().type__sci_List();
    var this$7 = $f_sc_TraversableLike__headOption__s_Option(this$6);
    if ((!this$7.isEmpty__Z())) {
      var arg1 = this$7.get__O();
      var x$1 = $as_Lamf_core_vocabulary_ValueType(arg1);
      var jsx$2 = (x$1.iri__T() === $as_Lamf_core_vocabulary_ValueType($m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().type$1.head__O()).iri__T())
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var jsx$1 = true
    } else {
      var this$8 = superShape.meta__Lamf_core_metamodel_Obj().type__sci_List();
      var this$9 = $f_sc_TraversableLike__headOption__s_Option(this$8);
      if ((!this$9.isEmpty__Z())) {
        var arg1$1 = this$9.get__O();
        var x$2 = $as_Lamf_core_vocabulary_ValueType(arg1$1);
        var jsx$1 = (x$2.iri__T() === $as_Lamf_core_vocabulary_ValueType($m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().type$1.head__O()).iri__T())
      } else {
        var jsx$1 = false
      }
    };
    if (jsx$1) {
      if ((derivedShape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
        var x2$2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(derivedShape);
        return $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__restrictShape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(this, x2$2, superShape)
      } else {
        return this.computeMinAny__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_model_domain_Shape(derivedShape, $as_Lamf_plugins_domain_shapes_models_AnyShape(superShape))
      }
    };
    if ((rc16 && (this.isGenericNodeShape__Lamf_core_model_domain_Shape__Z(x6) && (superShape instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)))) {
      var baseShape = x6;
      return $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__restrictShape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(this, baseShape, superShape)
    };
    if ((derivedShape instanceof $c_Lamf_plugins_domain_shapes_models_SchemaShape)) {
      var x14 = $as_Lamf_plugins_domain_shapes_models_SchemaShape(derivedShape);
      var x = superShape.meta__Lamf_core_metamodel_Obj();
      var x$3 = $m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$();
      if (((x !== null) && (x === x$3))) {
        return this.computeMinSchema__p1__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_SchemaShape__Lamf_plugins_domain_shapes_models_SchemaShape(superShape, x14)
      }
    };
    var this$10 = this.context$1.errorHandler$1;
    var specification$1 = $m_Lamf_validations_ResolutionSideValidations$().InvalidTypeInheritanceErrorSpecification$1;
    var target$1 = new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1.value$1.iri__T());
    var message$1 = (((("Resolution error: Incompatible types [" + $m_Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$().beautify__T__T(derivedShape.ramlSyntaxKey__T())) + ", ") + $m_Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$().beautify__T__T(superShape.ramlSyntaxKey__T())) + "]");
    var node$1 = derivedShape.id$1;
    var lexical$1 = derivedShape.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var location$1 = derivedShape.location__s_Option();
    this$10.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification$1.id$1, node$1, target$1, message$1, lexical$1, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location$1);
    return derivedShape
  } catch (e) {
    if ((e instanceof $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError)) {
      var e$2 = $as_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError(e);
      if (e$2.isViolation$3) {
        var this$14 = this.context$1.errorHandler$1;
        var specification$2 = $m_Lamf_validations_ResolutionSideValidations$().InvalidTypeInheritanceErrorSpecification$1;
        var node$2 = derivedShape.id$1;
        var this$11 = e$2.property$3;
        var property = (this$11.isEmpty__Z() ? new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1.value$1.iri__T()) : this$11);
        var message$2 = e$2.s$1;
        var this$12 = e$2.position$3;
        var lexical$2 = (this$12.isEmpty__Z() ? derivedShape.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()) : this$12);
        var this$13 = e$2.location$3;
        var location$2 = (this$13.isEmpty__Z() ? derivedShape.location__s_Option() : this$13);
        this$14.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification$2.id$1, node$2, property, message$2, lexical$2, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location$2)
      } else {
        var jsx$8 = this.context$1.errorHandler$1;
        var jsx$7 = $m_Lamf_validations_ResolutionSideValidations$().InvalidTypeInheritanceWarningSpecification$1;
        var jsx$6 = derivedShape.id$1;
        var this$15 = e$2.property$3;
        var jsx$5 = (this$15.isEmpty__Z() ? new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1.value$1.iri__T()) : this$15);
        var jsx$4 = e$2.s$1;
        var this$16 = e$2.position$3;
        var jsx$3 = (this$16.isEmpty__Z() ? derivedShape.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()) : this$16);
        var this$17 = e$2.location$3;
        jsx$8.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V(jsx$7, jsx$6, jsx$5, jsx$4, jsx$3, (this$17.isEmpty__Z() ? derivedShape.location__s_Option() : this$17))
      };
      return derivedShape
    } else {
      throw e
    }
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.computeMinTuple__Lamf_plugins_domain_shapes_models_TupleShape__Lamf_plugins_domain_shapes_models_TupleShape__Lamf_core_model_domain_Shape = (function(baseTuple, superTuple) {
  var superItems = $as_sc_Seq(baseTuple.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().TupleItems$2));
  var baseItems = $as_sc_Seq(superTuple.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().TupleItems$2));
  if ((superItems.length__I() !== baseItems.length__I())) {
    if ((this.context$1.isRaml08$1 && baseItems.isEmpty__Z())) {
      baseTuple.fields$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().Items$1, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(superItems, new $c_Lamf_core_parser_Annotations().init___()), baseTuple.fields$2.get__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement($m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().Items$1).annotations__Lamf_core_parser_Annotations());
      return baseTuple
    } else {
      throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("Cannot inherit from a tuple shape with different number of elements", $m_s_None$(), $f_Lamf_core_model_domain_ExternalSourceElement__location__s_Option(baseTuple), baseTuple.annotations$2.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), false)
    }
  } else {
    var this$3 = $as_sc_TraversableViewLike(baseItems.view__sc_SeqView().zipWithIndex__scg_CanBuildFrom__O(new $c_sc_SeqView$$anon$1().init___()));
    var p = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(check$ifrefutable$1$2) {
        var check$ifrefutable$1 = $as_T2(check$ifrefutable$1$2);
        return (check$ifrefutable$1 !== null)
      })
    })(this));
    var this$5 = $f_sc_TraversableViewLike__withFilter__F1__sc_TraversableView(this$3, p);
    var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, superItems$1) {
      return (function(x$3$2) {
        var x$3 = $as_T2(x$3$2);
        if ((x$3 !== null)) {
          var baseItem = $as_Lamf_core_model_domain_Shape(x$3.$$und1__O());
          var i = x$3.$$und2$mcI$sp__I();
          return this$2$1.context$1.minShape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(baseItem, $as_Lamf_core_model_domain_Shape(superItems$1.apply__I__O(i)))
        } else {
          throw new $c_s_MatchError().init___O(x$3)
        }
      })
    })(this, superItems));
    new $c_sc_SeqView$$anon$1().init___();
    var newItems = $as_sc_SeqView(this$5.newMapped__F1__sc_TraversableViewLike$Transformed(f));
    baseTuple.fields$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().Items$1, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(newItems, new $c_Lamf_core_parser_Annotations().init___()), baseTuple.fields$2.get__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement($m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().Items$1).annotations__Lamf_core_parser_Annotations());
    var fields = $m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().fields$2;
    var jsx$1 = $m_sc_Seq$();
    var array = [$m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().Items$1];
    var filteredFields = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
    $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNarrowRestrictions__sc_Seq__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_model_domain_Shape(this, fields, baseTuple, superTuple, filteredFields);
    return baseTuple
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.isExactlyAny__p1__Lamf_core_model_domain_Shape__Z = (function(shape) {
  var x = shape.meta__Lamf_core_metamodel_Obj();
  var x$2 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$();
  return ((x !== null) && (x === x$2))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.computeMinFile__Lamf_plugins_domain_shapes_models_FileShape__Lamf_plugins_domain_shapes_models_FileShape__Lamf_core_model_domain_Shape = (function(baseFile, superFile) {
  var fields = $m_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$().fields$1;
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$3 = new $c_scm_ListBuffer().init___();
  var filteredFields = this$3.toList__sci_List();
  $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNarrowRestrictions__sc_Seq__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_model_domain_Shape(this, fields, baseFile, superFile, filteredFields);
  return baseFile
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.computeMinSuperUnion__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_model_domain_Shape = (function(baseShape, superUnion) {
  var this$1 = this.UnionErrorHandler__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$();
  var ctx = this.context$1;
  var unionContext = new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext().init___Lamf_core_errorhandling_ErrorHandler__Z__Lamf_ProfileName__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache(this$1, ctx.keepEditingInfo$1, ctx.profile$1, ctx.cache$1);
  var jsx$2 = $as_sc_Seq(superUnion.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, unionContext$1, baseShape$1) {
    return (function(superUnionElement$2) {
      var superUnionElement = $as_Lamf_core_model_domain_Shape(superUnionElement$2);
      try {
        var newShape = unionContext$1.minShape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(baseShape$1, superUnionElement);
        $this.setValuesOfUnionElement__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__V(newShape, superUnionElement);
        return new $c_s_Some().init___O(newShape)
      } catch (e) {
        var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
        if ((e$2 instanceof $c_jl_Exception)) {
          return $m_s_None$()
        } else {
          throw e
        }
      }
    })
  })(this, unionContext, baseShape));
  var this$2 = $m_sc_Seq$();
  var minItems = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  var jsx$3 = new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$2().init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm(this);
  var this$3 = $m_sc_Seq$();
  var newUnionItems = $as_sc_Seq(minItems.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$3, this$3.ReusableCBFInstance$2));
  if (newUnionItems.isEmpty__Z()) {
    throw new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError().init___T__s_Option__s_Option__s_Option__Z("Cannot compute inheritance from union", $m_s_None$(), baseShape.location__s_Option(), baseShape.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), false)
  };
  var elem = $m_sci_Nil$();
  var accExamples = new $c_sr_ObjectRef().init___O(elem);
  var this$5 = $m_sc_Seq$();
  $as_sc_IterableLike(newUnionItems.zipWithIndex__scg_CanBuildFrom__O(this$5.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, accExamples$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var shape = $as_Lamf_core_model_domain_Shape(x0$1.$$und1__O());
        var i = x0$1.$$und2$mcI$sp__I();
        shape.id$1 = ((shape.id$1 + "_") + i);
        if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
          var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(shape);
          var jsx$5 = $as_sci_List(accExamples$1.elem$1);
          var jsx$4 = $as_sc_Seq(x2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1));
          var this$6 = $m_sci_List$();
          accExamples$1.elem$1 = $as_sci_List(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$6.ReusableCBFInstance$2));
          x2.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Examples$1);
          x2.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().DefaultValueString$1);
          x2.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Default$1)
        };
        return shape
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, accExamples)));
  superUnion.fields$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(newUnionItems, new $c_Lamf_core_parser_Annotations().init___()), superUnion.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1).annotations$1);
  var fields = this.allShapeFields$1;
  var jsx$6 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1];
  var filteredFields = $as_sc_Seq(jsx$6.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation__computeNarrowRestrictions__sc_Seq__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_model_domain_Shape(this, fields, baseShape, superUnion, filteredFields);
  var this$10 = baseShape.fields__Lamf_core_parser_Fields();
  var fn = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, superUnion$1) {
    return (function(x0$2$2) {
      var x0$2 = $as_T2(x0$2$2);
      if ((x0$2 !== null)) {
        var field = $as_Lamf_core_metamodel_Field(x0$2.$$und1__O());
        var value = $as_Lamf_core_parser_Value(x0$2.$$und2__O());
        var x$2 = $m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1;
        if ((!((field === null) ? (x$2 === null) : field.equals__O__Z(x$2)))) {
          superUnion$1.fields$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(field, value.value$1, value.annotations$1)
        }
      } else {
        throw new $c_s_MatchError().init___O(x0$2)
      }
    })
  })(this, superUnion));
  this$10.fs$1.foreach__F1__V(fn);
  var this$11 = $as_sci_List(accExamples.elem$1);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$11)) {
    var jsx$8 = superUnion.fields$2;
    var jsx$7 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Examples$1;
    var this$12 = $as_sci_List(accExamples.elem$1);
    jsx$8.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(jsx$7, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq($f_sc_SeqLike__distinct__O(this$12)), new $c_Lamf_core_parser_Annotations().init___()), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
  };
  var value$1 = baseShape.id$1;
  return $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(superUnion, value$1))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.inheritProp__Lamf_core_model_domain_Shape__Lamf_core_model_domain_extensions_PropertyShape__Lamf_core_model_domain_extensions_PropertyShape = (function(from, prop) {
  var clonedProp = prop.cloneShape__s_Option__s_Option__Lamf_core_traversal_ModelTraversalRegistry__Z__Lamf_core_model_domain_extensions_PropertyShape(new $c_s_Some().init___O(this.context$1.errorHandler$1), $m_s_None$(), new $c_Lamf_core_traversal_ModelTraversalRegistry().init___(), false);
  if (clonedProp.annotations$2.find__jl_Class__s_Option($d_Lamf_core_annotations_InheritanceProvenance.getClassOf()).isEmpty__Z()) {
    clonedProp.annotations$2.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_InheritanceProvenance().init___T(from.id$1));
    clonedProp.id$1 = (clonedProp.id$1 + "/inherited")
  };
  return clonedProp
});
var $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.MinShapeAlgorithm", {
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm: 1,
  O: 1,
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$() {
  $c_O.call(this);
  this.platform$1 = null
}
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$.prototype.constructor = $c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$.prototype = $c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$.prototype;
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$.prototype.validateAll__sc_Seq__T__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future = (function(candidates, severity, env, executionContext) {
  var validators = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, validators$1, env$1, severity$1, executionContext$1) {
    return (function(c$2) {
      var c = $as_Lamf_core_validation_ValidationCandidate(c$2);
      var jsx$2 = c.shape$1;
      var this$1 = c.payload$1;
      var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().MediaType$1));
      var this$3 = this$2.option$1;
      var x1 = validators$1.get__O__s_Option(new $c_T2().init___O__O(jsx$2, $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()))));
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var v = $as_Lamf_core_validation_PayloadValidator(x2.value$2);
        var validator = v
      } else {
        var jsx$3 = $m_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$();
        var this$4 = c.payload$1;
        var this$5 = $as_Lamf_core_model_StrField(this$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().MediaType$1));
        var this$6 = this$5.option$1;
        var qual$1 = jsx$3.plugin__p1__T__Lamf_core_model_domain_Shape__Lamf_internal_environment_Environment__T__Lamf_core_validation_AMFPayloadValidationPlugin($as_T((this$6.isEmpty__Z() ? null : this$6.get__O())), c.shape$1, env$1, severity$1);
        var x$1 = c.shape$1;
        var x$3 = $m_Lamf_client_plugins_StrictValidationMode$();
        var v$2 = qual$1.validator__Lamf_core_model_domain_Shape__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__Lamf_core_validation_PayloadValidator(x$1, env$1, x$3);
        var jsx$4 = c.shape$1;
        var this$7 = c.payload$1;
        var this$8 = $as_Lamf_core_model_StrField(this$7.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().MediaType$1));
        var this$9 = this$8.option$1;
        validators$1.put__O__O__s_Option(new $c_T2().init___O__O(jsx$4, $as_T((this$9.isEmpty__Z() ? null : this$9.get__O()))), v$2);
        var validator = v$2
      };
      return validator.validate__Lamf_core_model_document_PayloadFragment__s_concurrent_ExecutionContext__s_concurrent_Future(c.payload$1, executionContext$1)
    })
  })(this, validators, env, severity, executionContext));
  var this$10 = $m_sc_Seq$();
  var futures = $as_sc_Seq(candidates.map__F1__scg_CanBuildFrom__O(jsx$1, this$10.ReusableCBFInstance$2));
  var jsx$5 = $m_s_concurrent_Future$();
  var this$11 = $m_sc_Seq$();
  return jsx$5.sequence__sc_TraversableOnce__scg_CanBuildFrom__s_concurrent_ExecutionContext__s_concurrent_Future(futures, this$11.ReusableCBFInstance$2, executionContext).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(f$2) {
      var f = $as_sc_Seq(f$2);
      var jsx$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
        return (function(report$2) {
          var report = $as_Lamf_core_validation_AMFValidationReport(report$2);
          var jsx$7 = report.results$1;
          var this$12 = $m_s_math_Ordering$();
          var evidence$1 = $m_s_Predef$().singleton$und$less$colon$less$2;
          return $as_sc_Seq(jsx$7.sorted__s_math_Ordering__O(new $c_s_math_LowPriorityOrderingImplicits$$anon$3().init___s_math_LowPriorityOrderingImplicits__F1(this$12, evidence$1)))
        })
      })(this$2$1));
      var this$13 = $m_sc_Seq$();
      var seq = $as_sc_Seq(f.flatMap__F1__scg_CanBuildFrom__O(jsx$6, this$13.ReusableCBFInstance$2));
      return new $c_Lamf_core_validation_AMFValidationReport().init___Z__T__Lamf_ProfileName__sc_Seq((!seq.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$2) {
        return (function(x$1$2) {
          var x$1$1 = $as_Lamf_core_validation_AMFValidationResult(x$1$2);
          return (x$1$1.level$1 === $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1)
        })
      })(this$2$1)))), "", $m_Lamf_ProfileName$().apply__T__Lamf_ProfileName(""), seq)
    })
  })(this)), executionContext)
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$.prototype.validateFragment__Lamf_core_model_domain_Shape__Lamf_core_model_document_PayloadFragment__T__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future = (function(shape, fragment, severity, env, validationMode, exec) {
  var executionContext = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  var this$1 = $as_Lamf_core_model_StrField(fragment.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().MediaType$1));
  var this$2 = this$1.option$1;
  var p = this.plugin__p1__T__Lamf_core_model_domain_Shape__Lamf_internal_environment_Environment__T__Lamf_core_validation_AMFPayloadValidationPlugin($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())), shape, env, severity);
  return p.validator__Lamf_core_model_domain_Shape__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__Lamf_core_validation_PayloadValidator(shape, env, validationMode).validate__Lamf_core_model_document_PayloadFragment__s_concurrent_ExecutionContext__s_concurrent_Future(fragment, executionContext)
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$.prototype.validate__Lamf_core_model_domain_Shape__T__T__T__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future = (function(shape, mediaType, payload, severity, env, validationMode, exec) {
  var executionContext = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  var p = this.plugin__p1__T__Lamf_core_model_domain_Shape__Lamf_internal_environment_Environment__T__Lamf_core_validation_AMFPayloadValidationPlugin(mediaType, shape, env, severity);
  return p.validator__Lamf_core_model_domain_Shape__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__Lamf_core_validation_PayloadValidator(shape, env, validationMode).validate__T__T__s_concurrent_ExecutionContext__s_concurrent_Future(mediaType, payload, executionContext)
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$.prototype.validateWithGuessing__Lamf_core_model_domain_Shape__T__T__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future = (function(shape, payload, severity, env, validationMode, exec) {
  return this.validate__Lamf_core_model_domain_Shape__T__T__T__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(shape, $m_Lamf_core_utils_package$MediaTypeMatcher$().guessMediaType$extension__T__Z__T(payload, false), payload, severity, env, validationMode, exec)
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$.prototype.plugin__p1__T__Lamf_core_model_domain_Shape__Lamf_internal_environment_Environment__T__Lamf_core_validation_AMFPayloadValidationPlugin = (function(mediaType, shape, env, defaultSeverity) {
  var this$1 = this.searchPlugin__p1__T__Lamf_core_model_domain_Shape__Lamf_internal_environment_Environment__T__s_Option(mediaType, shape, env, defaultSeverity);
  return $as_Lamf_core_validation_AMFPayloadValidationPlugin((this$1.isEmpty__Z() ? new $c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin().init___T(defaultSeverity) : this$1.get__O()))
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$.prototype.searchPlugin__p1__T__Lamf_core_model_domain_Shape__Lamf_internal_environment_Environment__T__s_Option = (function(mediaType, shape, env, defaultSeverity) {
  return $m_Lamf_core_registries_AMFPluginsRegistry$().dataNodeValidatorPluginForMediaType__T__sc_Seq(mediaType).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, shape$1, env$1) {
    return (function(plugin$2) {
      var plugin = $as_Lamf_core_validation_AMFPayloadValidationPlugin(plugin$2);
      return plugin.canValidate__Lamf_core_model_domain_Shape__Lamf_internal_environment_Environment__Z(shape$1, env$1)
    })
  })(this, shape, env)))
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$.prototype.payloadValidator__Lamf_core_model_domain_Shape__T__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__s_Option = (function(shape, mediaType, env, validationMode) {
  var this$1 = this.searchPlugin__p1__T__Lamf_core_model_domain_Shape__Lamf_internal_environment_Environment__T__s_Option(mediaType, shape, env, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1);
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$2 = $as_Lamf_core_validation_AMFPayloadValidationPlugin(arg1);
    return new $c_s_Some().init___O(x$2.validator__Lamf_core_model_domain_Shape__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__Lamf_core_validation_PayloadValidator(shape, env, validationMode))
  }
});
var $d_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$: 0
}, false, "amf.plugins.domain.shapes.validation.PayloadValidationPluginsHandler$", {
  Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$.prototype.$classData = $d_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$;
var $n_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$ = (void 0);
function $m_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$() {
  if ((!$n_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$)) {
    $n_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$ = new $c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_AbstractModel$() {
  $c_O.call(this);
  this.IsAbstract$1 = null
}
$c_Lamf_plugins_domain_webapi_metamodel_AbstractModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_AbstractModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_AbstractModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_AbstractModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_AbstractModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_AbstractModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_AbstractModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_AbstractModel$ = this;
  $f_Lamf_plugins_domain_webapi_metamodel_AbstractModel__$$init$__V(this);
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_AbstractModel$.prototype.amf$plugins$domain$webapi$metamodel$AbstractModel$$undsetter$und$IsAbstract$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsAbstract$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_AbstractModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_AbstractModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.AbstractModel$", {
  Lamf_plugins_domain_webapi_metamodel_AbstractModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_AbstractModel: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_AbstractModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_AbstractModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_AbstractModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_AbstractModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_AbstractModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_AbstractModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_AbstractModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_AbstractModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$() {
  $c_O.call(this);
  this.Headers$1 = null
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$ = this;
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders__$$init$__V(this);
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingHeaders$$undsetter$und$Headers$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Headers$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.BindingHeaders$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$() {
  $c_O.call(this);
  this.Query$1 = null
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$ = this;
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery__$$init$__V(this);
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingQuery$$undsetter$und$Query$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Query$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.BindingQuery$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$() {
  $c_O.call(this);
  this.BindingVersion$1 = null
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$ = this;
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion__$$init$__V(this);
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingVersion$$undsetter$und$BindingVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.BindingVersion$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.BindingVersion$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this);
  this.merger$2 = null;
  this.bitmap$0$2 = false
}
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage.prototype.resolve__p2__Lamf_plugins_domain_webapi_models_WebApi__V = (function(webApi) {
  var jsx$2 = $as_sc_Seq(webApi.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_plugins_domain_webapi_models_EndPoint(x$2$2);
      return $as_sc_Seq(x$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1))
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var operations = $as_sc_Seq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  this.mergeOperations__p2__sc_Seq__V(operations);
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(operation$2) {
      var operation = $as_Lamf_plugins_domain_webapi_models_Operation(operation$2);
      var jsx$5 = $as_sc_Seq(operation.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Request$1));
      var jsx$4 = $as_sc_Seq(operation.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1));
      var this$3 = $m_sc_Seq$();
      return $as_sc_Seq(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$3.ReusableCBFInstance$2))
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  var messages = $as_sc_Seq(operations.flatMap__F1__scg_CanBuildFrom__O(jsx$3, this$4.ReusableCBFInstance$2));
  this.mergeMessages__p2__sc_Seq__V(messages)
});
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage.prototype.merger$lzycompute__p2__Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch = (function() {
  if ((!this.bitmap$0$2)) {
    var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$1$2) {
        $as_Lamf_core_model_domain_AmfElement(x$1$2);
        return false
      })
    })(this));
    var jsx$2 = new $c_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria().init___();
    var jsx$1 = $m_sc_Seq$();
    var array = [$m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Name$1, $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Name$1, $m_Lamf_plugins_domain_webapi_metamodel_AbstractModel$().IsAbstract$1];
    this.merger$2 = new $c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch().init___F1__Lamf_plugins_domain_shapes_resolution_stages_merge_KeyCriteria__sc_Seq(jsx$3, jsx$2, $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))));
    this.bitmap$0$2 = true
  };
  return this.merger$2
});
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage.prototype.mergeMessages__p2__sc_Seq__V = (function(message) {
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(m$2) {
      var m = $as_Lamf_plugins_domain_webapi_models_Message(m$2);
      return new $c_T2().init___O__O(m, $this.getMessageTraits__p2__Lamf_plugins_domain_webapi_models_Message__sc_Seq(m))
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  $as_sc_IterableLike(message.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var message$1 = $as_Lamf_plugins_domain_webapi_models_Message(x0$1.$$und1__O());
        var traits = $as_sc_Seq(x0$1.$$und2__O());
        return this$2.merge__p2__Lamf_core_model_domain_AmfElement__sc_Seq__Lamf_core_model_domain_AmfElement(message$1, traits)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this)))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage.prototype.merge__p2__Lamf_core_model_domain_AmfElement__sc_Seq__Lamf_core_model_domain_AmfElement = (function(target, patches) {
  return $as_Lamf_core_model_domain_AmfElement(patches.foldLeft__O__F2__O(target, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(acc$2, curr$2) {
      var acc = $as_Lamf_core_model_domain_AmfElement(acc$2);
      var curr = $as_Lamf_core_model_domain_AmfElement(curr$2);
      return $this.merger__p2__Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch().merge__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement(acc, curr)
    })
  })(this))))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage.prototype.getOperationTraits__p2__Lamf_plugins_domain_webapi_models_Operation__sc_Seq = (function(extended) {
  var jsx$2 = $as_sc_Seq(extended.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field()));
  var jsx$1 = new $c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getOperationTraits$1().init___Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage(this);
  var this$1 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage.prototype.mergeOperations__p2__sc_Seq__V = (function(operations) {
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(o$2) {
      var o = $as_Lamf_plugins_domain_webapi_models_Operation(o$2);
      return new $c_T2().init___O__O(o, $this.getOperationTraits__p2__Lamf_plugins_domain_webapi_models_Operation__sc_Seq(o))
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  $as_sc_IterableLike(operations.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var operation = $as_Lamf_plugins_domain_webapi_models_Operation(x0$1.$$und1__O());
        var traits = $as_sc_Seq(x0$1.$$und2__O());
        return this$2.merge__p2__Lamf_core_model_domain_AmfElement__sc_Seq__Lamf_core_model_domain_AmfElement(operation, traits)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this)))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage.prototype.getMessageTraits__p2__Lamf_plugins_domain_webapi_models_Message__sc_Seq = (function(extended) {
  var jsx$2 = $as_sc_Seq(extended.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field()));
  var jsx$1 = new $c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getMessageTraits$1().init___Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage(this);
  var this$1 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  if ((model instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(model);
    if ((x2.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)) {
      var webApi = $as_Lamf_plugins_domain_webapi_models_WebApi(x2.encodes__Lamf_core_model_domain_DomainElement());
      this.resolve__p2__Lamf_plugins_domain_webapi_models_WebApi__V(webApi);
      return x2
    }
  };
  return model
});
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage.prototype.merger__p2__Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch = (function() {
  return ((!this.bitmap$0$2) ? this.merger$lzycompute__p2__Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch() : this.merger$2)
});
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.JsonMergePatchStage", {
  Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this);
  this.profile$2 = null;
  this.isValidation$2 = false;
  this.keepEditingInfo$2 = false
}
$c_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage.prototype.validateFilePayloads__p2__Lamf_plugins_domain_webapi_models_Request__V = (function(request) {
  var filePayloads = $as_sc_Seq($as_sc_Seq(request.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$5$2) {
      var x$5 = $as_Lamf_plugins_domain_webapi_models_Payload(x$5$2);
      var x1 = $as_Lamf_core_model_domain_Shape(x$5.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1));
      if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
        var x2 = $as_Lamf_plugins_domain_shapes_models_NodeShape(x1);
        return $as_sc_Seq(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1)).exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
          return (function(x$6$2) {
            var x$6 = $as_Lamf_core_model_domain_extensions_PropertyShape(x$6$2);
            return ($as_Lamf_core_model_domain_Shape(x$6.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1)) instanceof $c_Lamf_plugins_domain_shapes_models_FileShape)
          })
        })($this)))
      } else {
        return false
      }
    })
  })(this))));
  $as_sc_IterableLike(filePayloads.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$7$2) {
      var x$7 = $as_Lamf_plugins_domain_webapi_models_Payload(x$7$2);
      var x1$1 = $as_Lamf_core_model_StrField(x$7.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1)).option$1;
      matchEnd12: {
        var jsx$1;
        if ((x1$1 instanceof $c_s_Some)) {
          var x2$1 = $as_s_Some(x1$1);
          var p3 = $as_T(x2$1.value$2);
          if ((p3 === "multipart/form-data")) {
            var jsx$1 = true;
            break matchEnd12
          }
        };
        if ((x1$1 instanceof $c_s_Some)) {
          var x4 = $as_s_Some(x1$1);
          var p5 = $as_T(x4.value$2);
          if ((p5 === "application/x-www-form-urlencoded")) {
            var jsx$1 = true;
            break matchEnd12
          }
        };
        var jsx$1 = false
      };
      return (!jsx$1)
    })
  })(this)))).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3) {
    return (function(payload$2) {
      var payload = $as_Lamf_plugins_domain_webapi_models_Payload(payload$2);
      var x1$2 = $as_Lamf_core_model_domain_Shape(payload.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1));
      if ((x1$2 instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
        var x2$2 = $as_Lamf_plugins_domain_shapes_models_NodeShape(x1$2);
        var errorProperties = $as_sc_Seq($as_sc_Seq(x2$2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2) {
          return (function(x$8$2) {
            var x$8 = $as_Lamf_core_model_domain_extensions_PropertyShape(x$8$2);
            return ($as_Lamf_core_model_domain_Shape(x$8.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1)) instanceof $c_Lamf_plugins_domain_shapes_models_FileShape)
          })
        })(this$3))))
      } else {
        var errorProperties = $m_sci_Nil$()
      };
      errorProperties.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
        return (function(prop$2) {
          var prop = $as_Lamf_core_model_domain_extensions_PropertyShape(prop$2);
          this$2$1.mediaTypeError__p2__Lamf_core_model_domain_extensions_PropertyShape__V(prop)
        })
      })(this$3)))
    })
  })(this)))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage.prototype.payloads__p2__sc_Seq__sc_Seq__T__sc_Seq = (function(p, mediaTypes, parent) {
  var x1 = p.partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_plugins_domain_webapi_models_Payload(x$2$2);
      return x$2.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1).isEmpty__Z()
    })
  })(this)));
  if ((x1 === null)) {
    throw new $c_s_MatchError().init___O(x1)
  };
  var noMediaType = $as_sc_Seq(x1.$$und1__O());
  var result = $as_sc_Seq(x1.$$und2__O());
  var result$2 = new $c_sr_ObjectRef().init___O(result);
  noMediaType.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, mediaTypes$1, result$2$1, parent$1) {
    return (function(payload$2) {
      var payload = $as_Lamf_plugins_domain_webapi_models_Payload(payload$2);
      mediaTypes$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, result$1, payload$1, parent$1$1) {
        return (function(mediaType$2) {
          var mediaType = $as_T(mediaType$2);
          var jsx$3 = $as_sc_Seq(result$1.elem$1);
          var annotations = payload$1.annotations$1;
          var this$5 = new $c_Lamf_plugins_domain_webapi_models_Payload().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
          var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1;
          var qual$1 = $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$5, field, mediaType));
          $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
          var parsedPayload = $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, parent$1$1));
          var this$6 = $as_Lamf_core_model_StrField(payload$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Name$1)).option$1;
          if ((!this$6.isEmpty__Z())) {
            var arg1 = this$6.get__O();
            var name = $as_T(arg1);
            $m_Lamf_core_parser_Annotations$();
            var a = new $c_Lamf_core_parser_Annotations().init___();
            $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(parsedPayload, name, a))
          };
          if ($m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(payload$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1))).isDefined__Z()) {
            var jsx$2 = parsedPayload.fields$1;
            var jsx$1 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
            var newPayloadId = parsedPayload.id$1;
            jsx$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(jsx$1, $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().replaceTracking__Lamf_core_model_domain_Shape__T__T__Lamf_core_model_domain_Shape($as_Lamf_core_model_domain_Shape(payload$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1)), newPayloadId, payload$1.id$1), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
          };
          var this$10 = $m_sc_Seq$();
          result$1.elem$1 = $as_sc_Seq(jsx$3.$$colon$plus__O__scg_CanBuildFrom__O(parsedPayload, this$10.ReusableCBFInstance$2))
        })
      })(this$2, result$2$1, payload, parent$1)));
      $as_sc_Seq(result$2$1.elem$1).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, payload$3) {
        return (function(newPayload$2) {
          var newPayload = $as_Lamf_plugins_domain_webapi_models_Payload(newPayload$2);
          var idToRemove = payload$3.id$1;
          $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().removeTracking__Lamf_core_model_domain_Shape__T__V($as_Lamf_core_model_domain_Shape(newPayload.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1)), idToRemove)
        })
      })(this$2, payload)))
    })
  })(this, mediaTypes, result$2, parent)));
  return $as_sc_Seq(result$2.elem$1)
});
$c_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage.prototype.getAndRemove__p2__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__F0__s_Option = (function(element, field, removeCondition) {
  var this$1 = element.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option(field);
  if (this$1.isEmpty__Z()) {
    var result = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_Lamf_core_parser_FieldEntry(arg1);
    var jsx$2 = $as_Lamf_core_model_domain_AmfArray(x$1.value$1.value$1).values$1;
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(v$2) {
        var v = $as_Lamf_core_model_domain_AmfElement(v$2);
        return $as_Lamf_core_model_domain_AmfScalar(v).toString__T()
      })
    })(this));
    var this$2 = $m_sc_Seq$();
    var result = new $c_s_Some().init___O($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2)))
  };
  if ($uZ(removeCondition.apply__O())) {
    element.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields(field)
  };
  return result
});
$c_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage.prototype.propagatePayloads__Lamf_plugins_domain_webapi_models_WebApi__V = (function(api) {
  $as_sc_Seq(api.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(endpoint$2) {
      var endpoint = $as_Lamf_plugins_domain_webapi_models_EndPoint(endpoint$2);
      var payloads = $as_sc_Seq(endpoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Payloads$1));
      endpoint.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Payloads$1);
      if (payloads.nonEmpty__Z()) {
        $as_sc_Seq(endpoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, payloads$1) {
          return (function(operation$2) {
            var operation = $as_Lamf_plugins_domain_webapi_models_Operation(operation$2);
            var x1 = $m_s_Option$().apply__O__s_Option(operation.request__Lamf_plugins_domain_webapi_models_Request());
            if ((x1 instanceof $c_s_Some)) {
              var x2 = $as_s_Some(x1);
              var request = $as_Lamf_plugins_domain_webapi_models_Request(x2.value$2);
              payloads$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, request$1) {
                return (function(payload$2) {
                  var payload = $as_Lamf_plugins_domain_webapi_models_Payload(payload$2);
                  var field = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Payloads$1;
                  return $as_Lamf_plugins_domain_webapi_models_Request($f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(request$1, field, payload))
                })
              })($this$1, request)));
              return (void 0)
            } else {
              var x = $m_s_None$();
              if ((x === x1)) {
                var this$1 = operation.withRequest__Lamf_plugins_domain_webapi_models_Request();
                var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1;
                return $as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$1, field$1, payloads$1))
              } else {
                throw new $c_s_MatchError().init___O(x1)
              }
            }
          })
        })($this, payloads)))
      }
    })
  })(this)))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage.prototype.keepMediaTypesInModel__p2__F0 = (function() {
  return new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
    return (function() {
      return ((!$this.isValidation$2) && (!$this.keepEditingInfo$2))
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage.prototype.mediaTypeError__p2__Lamf_core_model_domain_extensions_PropertyShape__V = (function(prop) {
  var this$1 = this.errorHandler$1;
  var specification = $m_Lamf_validations_ResolutionSideValidations$().InvalidConsumesWithFileParameter$1;
  var node = prop.id$1;
  var annotations = $as_Lamf_core_model_domain_Shape(prop.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1)).annotations__Lamf_core_parser_Annotations();
  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$1, specification, node, "Consumes must be either 'multipart/form-data', 'application/x-www-form-urlencoded', or both when a file parameter is present", annotations)
});
$c_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage.prototype.overrideWith__s_Option__s_Option__s_Option = (function(root, overrider) {
  var this$1 = (overrider.isEmpty__Z() ? root : overrider);
  if (this$1.isEmpty__Z()) {
    var jsx$1 = true
  } else {
    var arg1 = this$1.get__O();
    var x$4 = $as_sc_Seq(arg1);
    var jsx$1 = x$4.nonEmpty__Z()
  };
  if (jsx$1) {
    return this$1
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage.prototype.init___Lamf_ProfileName__Z__Z__Lamf_core_errorhandling_ErrorHandler = (function(profile, isValidation, keepEditingInfo, errorHandler) {
  this.profile$2 = profile;
  this.isValidation$2 = isValidation;
  this.keepEditingInfo$2 = keepEditingInfo;
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
$c_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  matchEnd4: {
    if ((model instanceof $c_Lamf_core_model_document_Document)) {
      var x2 = $as_Lamf_core_model_document_Document(model);
      if ((x2.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)) {
        this.propagatePayloads__Lamf_plugins_domain_webapi_models_WebApi__V($as_Lamf_plugins_domain_webapi_models_WebApi(x2.encodes__Lamf_core_model_domain_DomainElement()));
        this.resolveMediaTypes__Lamf_plugins_domain_webapi_models_WebApi__V($as_Lamf_plugins_domain_webapi_models_WebApi(x2.encodes__Lamf_core_model_domain_DomainElement()));
        break matchEnd4
      }
    }
  };
  return model
});
$c_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage.prototype.resolveMediaTypes__Lamf_plugins_domain_webapi_models_WebApi__V = (function(api) {
  var rootAccepts = this.getAndRemove__p2__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__F0__s_Option(api, $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Accepts$1, this.keepMediaTypesInModel__p2__F0());
  var rootContentType = this.getAndRemove__p2__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__F0__s_Option(api, $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().ContentType$1, this.keepMediaTypesInModel__p2__F0());
  $as_sc_Seq(api.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, rootAccepts$1, rootContentType$1) {
    return (function(endPoint$2) {
      var endPoint = $as_Lamf_plugins_domain_webapi_models_EndPoint(endPoint$2);
      $as_sc_Seq(endPoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, rootAccepts$1$1, rootContentType$1$1) {
        return (function(operation$2) {
          var operation = $as_Lamf_plugins_domain_webapi_models_Operation(operation$2);
          var opAccepts = $this$1.getAndRemove__p2__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__F0__s_Option(operation, $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Accepts$1, $this$1.keepMediaTypesInModel__p2__F0());
          var opContentType = $this$1.getAndRemove__p2__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__F0__s_Option(operation, $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().ContentType$1, $this$1.keepMediaTypesInModel__p2__F0());
          var accepts = $this$1.overrideWith__s_Option__s_Option__s_Option(rootAccepts$1$1, opAccepts);
          var contentType = $this$1.overrideWith__s_Option__s_Option__s_Option(rootContentType$1$1, opContentType);
          var this$1 = $m_s_Option$().apply__O__s_Option(operation.request__Lamf_plugins_domain_webapi_models_Request());
          if ((!this$1.isEmpty__Z())) {
            var arg1 = this$1.get__O();
            var request = $as_Lamf_plugins_domain_webapi_models_Request(arg1);
            if ((accepts instanceof $c_s_Some)) {
              var x2 = $as_s_Some(accepts);
              var a = $as_sc_Seq(x2.value$2);
              if ((!$this$1.isValidation$2)) {
                var x = $this$1.profile$2;
                var x$2 = $m_Lamf_OasProfile$();
                var jsx$1 = ((x !== null) && x.equals__O__Z(x$2))
              } else {
                var jsx$1 = false
              };
              if (jsx$1) {
                var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Accepts$1;
                $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(operation, field, a)
              };
              var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Payloads$1;
              var values = $this$1.payloads__p2__sc_Seq__sc_Seq__T__sc_Seq($as_sc_Seq(request.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1)), a, request.id$1);
              $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(request, field$1, values)
            } else {
              var x$3 = $m_s_None$();
              if ((!(x$3 === accepts))) {
                throw new $c_s_MatchError().init___O(accepts)
              }
            };
            var x$5 = $this$1.profile$2;
            var x$6 = $m_Lamf_Oas20Profile$();
            if (((x$5 !== null) && x$5.equals__O__Z(x$6))) {
              $this$1.validateFilePayloads__p2__Lamf_plugins_domain_webapi_models_Request__V(request)
            }
          };
          $as_sc_Seq(operation.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, contentType$1, operation$1) {
            return (function(response$2) {
              var response = $as_Lamf_plugins_domain_webapi_models_Response(response$2);
              if ((contentType$1 instanceof $c_s_Some)) {
                var x2$1 = $as_s_Some(contentType$1);
                var ct = $as_sc_Seq(x2$1.value$2);
                if ((!this$2.isValidation$2)) {
                  var x$1 = this$2.profile$2;
                  var x$2$1 = $m_Lamf_OasProfile$();
                  var jsx$2 = ((x$1 !== null) && x$1.equals__O__Z(x$2$1))
                } else {
                  var jsx$2 = false
                };
                if (jsx$2) {
                  var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().ContentType$1;
                  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(operation$1, field$2, ct)
                };
                var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Payloads$1;
                var values$1 = this$2.payloads__p2__sc_Seq__sc_Seq__T__sc_Seq($as_sc_Seq(response.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1)), ct, response.id$1);
                return $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(response, field$3, values$1)
              } else {
                var x$3$1 = $m_s_None$();
                if ((x$3$1 === contentType$1)) {
                  return (void 0)
                } else {
                  throw new $c_s_MatchError().init___O(contentType$1)
                }
              }
            })
          })($this$1, contentType, operation)))
        })
      })($this, rootAccepts$1, rootContentType$1)))
    })
  })(this, rootAccepts, rootContentType)))
});
var $d_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.MediaTypeResolutionStage", {
  Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_MediaTypeResolutionStage;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage.prototype.pushParamsToEndpointOperations__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_document_webapi_parser_spec_domain_Parameters__V = (function(endpoint, finalParams) {
  $as_sc_Seq(endpoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, finalParams$1) {
    return (function(op$2) {
      var op = $as_Lamf_plugins_domain_webapi_models_Operation(op$2);
      return $this.setRequestParameters__p2__Lamf_plugins_domain_webapi_models_Operation__Lamf_plugins_document_webapi_parser_spec_domain_Parameters__O(op, finalParams$1)
    })
  })(this, finalParams)))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage.prototype.assignPathParametersTo__Lamf_plugins_domain_webapi_models_EndPoint__sc_Seq__O = (function(endpoint, path) {
  return (path.nonEmpty__Z() ? endpoint.fields$1.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(path, new $c_Lamf_core_parser_Annotations().init___()), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___())) : (void 0))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage.prototype.setRequestParameters__p2__Lamf_plugins_domain_webapi_models_Operation__Lamf_plugins_document_webapi_parser_spec_domain_Parameters__O = (function(op, params) {
  var this$1 = $m_s_Option$().apply__O__s_Option(op.request__Lamf_plugins_domain_webapi_models_Request());
  var request = $as_Lamf_plugins_domain_webapi_models_Request((this$1.isEmpty__Z() ? op.withRequest__Lamf_plugins_domain_webapi_models_Request() : this$1.get__O()));
  var finalParams = params.merge__Lamf_plugins_document_webapi_parser_spec_domain_Parameters__Lamf_plugins_document_webapi_parser_spec_domain_Parameters(new $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters().init___sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq($as_sc_Seq(request.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryParameters$1)), $as_sc_Seq(request.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().UriParameters$1)), $as_sc_Seq(request.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Headers$1)), $m_sci_Nil$(), $m_sci_Nil$(), $m_sci_Nil$()));
  if (finalParams.query$1.nonEmpty__Z()) {
    request.fields$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryParameters$1, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(finalParams.query$1, new $c_Lamf_core_parser_Annotations().init___()), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
  };
  if (finalParams.header$1.nonEmpty__Z()) {
    request.fields$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Headers$1, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(finalParams.header$1, new $c_Lamf_core_parser_Annotations().init___()), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
  };
  return (finalParams.path$1.nonEmpty__Z() ? request.fields$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().UriParameters$1, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(finalParams.path$1, new $c_Lamf_core_parser_Annotations().init___()), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___())) : (void 0))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  if ((model instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(model);
    if ((x2.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)) {
      var webApi = $as_Lamf_plugins_domain_webapi_models_WebApi(x2.encodes__Lamf_core_model_domain_DomainElement());
      this.resolve__Lamf_plugins_domain_webapi_models_WebApi__Lamf_plugins_domain_webapi_models_WebApi(webApi);
      return x2
    }
  };
  return model
});
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_PathDescriptionNormalizationStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this);
  this.profile$2 = null;
  this.keepEditingInfo$2 = false
}
$c_Lamf_plugins_domain_webapi_resolution_stages_PathDescriptionNormalizationStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_domain_webapi_resolution_stages_PathDescriptionNormalizationStage.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_PathDescriptionNormalizationStage;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_PathDescriptionNormalizationStage() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_PathDescriptionNormalizationStage.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_PathDescriptionNormalizationStage.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_PathDescriptionNormalizationStage.prototype.setValueIfNotPresent__p2__Lamf_plugins_domain_webapi_models_Operation__Lamf_core_metamodel_Field__s_Option__V = (function(op, field, value) {
  var this$1 = op.fields$1;
  if ((!this$1.fs$1.contains__O__Z(field))) {
    if ((!value.isEmpty__Z())) {
      var arg1 = value.get__O();
      var x$3 = $as_T(arg1);
      $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(op, field, x$3))
    }
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_PathDescriptionNormalizationStage.prototype.normalizeDescriptions__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(unit) {
  if ((unit instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(unit);
    if ((x2.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)) {
      var webApi = $as_Lamf_plugins_domain_webapi_models_WebApi(x2.encodes__Lamf_core_model_domain_DomainElement());
      $as_sc_Seq(webApi.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(endPoint$2) {
          var endPoint = $as_Lamf_plugins_domain_webapi_models_EndPoint(endPoint$2);
          $this.applyToOperations__p2__Lamf_plugins_domain_webapi_models_EndPoint__V(endPoint)
        })
      })(this)));
      return x2
    }
  };
  return unit
});
$c_Lamf_plugins_domain_webapi_resolution_stages_PathDescriptionNormalizationStage.prototype.init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler = (function(profile, keepEditingInfo, errorHandler) {
  this.profile$2 = profile;
  this.keepEditingInfo$2 = keepEditingInfo;
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
$c_Lamf_plugins_domain_webapi_resolution_stages_PathDescriptionNormalizationStage.prototype.applyToOperations__p2__Lamf_plugins_domain_webapi_models_EndPoint__V = (function(endPoint) {
  var this$1 = endPoint.fields$1.$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Description$1);
  if (this$1.isEmpty__Z()) {
    var description = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_Lamf_core_model_domain_AmfScalar(arg1);
    var description = new $c_s_Some().init___O(x$1.toString__T())
  };
  var this$2 = endPoint.fields$1.$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Summary$1);
  if (this$2.isEmpty__Z()) {
    var summary = $m_s_None$()
  } else {
    var arg1$1 = this$2.get__O();
    var x$2 = $as_Lamf_core_model_domain_AmfScalar(arg1$1);
    var summary = new $c_s_Some().init___O(x$2.toString__T())
  };
  var operations = $as_sc_Seq(endPoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1));
  if ((operations.nonEmpty__Z() && (!this.keepEditingInfo$2))) {
    endPoint.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Description$1);
    endPoint.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Summary$1)
  };
  operations.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3, description$1, summary$1) {
    return (function(operation$2) {
      var operation = $as_Lamf_plugins_domain_webapi_models_Operation(operation$2);
      this$3.setValueIfNotPresent__p2__Lamf_plugins_domain_webapi_models_Operation__Lamf_core_metamodel_Field__s_Option__V(operation, $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Description$1, description$1);
      this$3.setValueIfNotPresent__p2__Lamf_plugins_domain_webapi_models_Operation__Lamf_core_metamodel_Field__s_Option__V(operation, $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Summary$1, summary$1)
    })
  })(this, description, summary)))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_PathDescriptionNormalizationStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  var x1 = this.profile$2;
  var x = $m_Lamf_Oas30Profile$();
  if (x.equals__O__Z(x1)) {
    var jsx$1 = true
  } else {
    var x$3 = $m_Lamf_Async20Profile$();
    var jsx$1 = x$3.equals__O__Z(x1)
  };
  if (jsx$1) {
    return this.normalizeDescriptions__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(model)
  } else {
    return model
  }
});
var $d_Lamf_plugins_domain_webapi_resolution_stages_PathDescriptionNormalizationStage = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_PathDescriptionNormalizationStage: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.PathDescriptionNormalizationStage", {
  Lamf_plugins_domain_webapi_resolution_stages_PathDescriptionNormalizationStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_PathDescriptionNormalizationStage.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_PathDescriptionNormalizationStage;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this);
  this.profile$2 = null
}
$c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage.prototype.searchDeclarations__p2__Lamf_core_model_document_Document__sc_Seq = (function(doc) {
  var jsx$2 = $as_sc_Seq(doc.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().Declares$1));
  var jsx$1 = new $c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage$$anonfun$searchDeclarations$1().init___Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage(this);
  var this$1 = $m_sc_Seq$();
  return $as_sc_Seq($as_scg_GenericTraversableTemplate(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).flatten__F1__sc_GenTraversable($m_s_Predef$().singleton$und$less$colon$less$2))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage.prototype.appliesTo__Lamf_ProfileName__Z = (function(profile) {
  var x = $m_Lamf_Oas30Profile$();
  if (x.equals__O__Z(profile)) {
    return true
  } else {
    var x$3 = $m_Lamf_AmfProfile$();
    return x$3.equals__O__Z(profile)
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage.prototype.setExamplesInSchema__p2__Lamf_plugins_domain_webapi_models_SchemaContainer__V = (function(payloadOrParam) {
  var x1 = payloadOrParam.schema__Lamf_core_model_domain_Shape();
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x1);
    $as_sc_Seq(payloadOrParam.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x2$1, payloadOrParam$1) {
      return (function(example$2) {
        var example = $as_Lamf_plugins_domain_shapes_models_Example(example$2);
        if ((!$as_sc_Seq(x2$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, example$1) {
          return (function(x$4$2) {
            var x$4 = $as_Lamf_plugins_domain_shapes_models_Example(x$4$2);
            return (x$4.id$1 === example$1.id$1)
          })
        })($this, example))))) {
          var annotation = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracked__T__Lamf_plugins_domain_shapes_models_Example__s_Option__Lamf_core_annotations_TrackedElement($as_Lamf_core_model_domain_AmfObject(payloadOrParam$1).id__T(), example, $m_s_None$());
          $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(example, annotation);
          $this.addExampleToShape__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_domain_shapes_models_Example__V(x2$1, example);
          payloadOrParam$1.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)
        }
      })
    })(this, x2, payloadOrParam)))
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage.prototype.searchPayloadAndParams__Lamf_plugins_domain_webapi_models_WebApi__sc_Seq = (function(webApi) {
  var jsx$6 = $as_sc_Seq(webApi.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(endpoint$2) {
      var endpoint = $as_Lamf_plugins_domain_webapi_models_EndPoint(endpoint$2);
      var jsx$3 = $as_sc_Seq(endpoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1));
      var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
        return (function(x$1$2) {
          var x$1 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$1$2);
          return $as_sc_Seq(x$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Payloads$1))
        })
      })($this));
      var this$1 = $m_sc_Seq$();
      var paramSchemas = $as_sc_Seq(jsx$3.flatMap__F1__scg_CanBuildFrom__O(jsx$2, this$1.ReusableCBFInstance$2));
      var endpointSchemas = $this.traverseEndpoint__p2__Lamf_plugins_domain_webapi_models_EndPoint__sc_Seq(endpoint);
      var this$2 = $m_sc_Seq$();
      var jsx$5 = $as_sc_TraversableLike(paramSchemas.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(endpointSchemas, this$2.ReusableCBFInstance$2));
      var jsx$4 = $as_sc_Seq(endpoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1));
      var this$3 = $m_sc_Seq$();
      return $as_sc_Seq(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$3.ReusableCBFInstance$2))
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$6.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage.prototype.addExampleToShape__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_domain_shapes_models_Example__V = (function(shape, example) {
  var jsx$3 = $as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1));
  var jsx$2 = $m_sc_Seq$();
  var array = [example];
  var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
  var this$3 = $m_sc_Seq$();
  var examples = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
  var field = $m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1;
  $as_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(shape, field, examples))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage.prototype.traverseEndpoint__p2__Lamf_plugins_domain_webapi_models_EndPoint__sc_Seq = (function(endpoint) {
  var jsx$4 = $as_sc_Seq(endpoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(op$2) {
      var op = $as_Lamf_plugins_domain_webapi_models_Operation(op$2);
      var jsx$3 = $as_sc_Seq(op.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1));
      var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
        return (function(x$2$2) {
          var x$2 = $as_Lamf_plugins_domain_webapi_models_Response(x$2$2);
          return $as_sc_Seq(x$2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1))
        })
      })($this));
      var this$1 = $m_sc_Seq$();
      var responseSchemas = $as_sc_Seq(jsx$3.flatMap__F1__scg_CanBuildFrom__O(jsx$2, this$1.ReusableCBFInstance$2));
      var x1 = $m_s_Option$().apply__O__s_Option(op.request__Lamf_plugins_domain_webapi_models_Request());
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var req = $as_Lamf_plugins_domain_webapi_models_Request(x2.value$2);
        var requestSchemas = $this.reqSchemas__p2__Lamf_plugins_domain_webapi_models_Request__sc_Seq(req)
      } else {
        var x = $m_s_None$();
        if ((!(x === x1))) {
          throw new $c_s_MatchError().init___O(x1)
        };
        var requestSchemas = $m_sci_Nil$()
      };
      var this$2 = $m_sc_Seq$();
      return $as_sc_Seq(responseSchemas.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(requestSchemas, this$2.ReusableCBFInstance$2))
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$4.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  return (this.appliesTo__Lamf_ProfileName__Z(this.profile$2) ? this.resolveExamples__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(model) : model)
});
$c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage.prototype.reqSchemas__p2__Lamf_plugins_domain_webapi_models_Request__sc_Seq = (function(req) {
  var jsx$4 = $as_sc_Seq(req.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().UriParameters$1));
  var jsx$3 = $as_sc_Seq(req.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryParameters$1));
  var this$1 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$1.ReusableCBFInstance$2));
  var jsx$1 = $as_sc_Seq(req.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().CookieParameters$1));
  var this$2 = $m_sc_Seq$();
  var reqParams = $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  var jsx$8 = $as_sc_Seq(req.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1));
  var jsx$7 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$3$2);
      return $as_sc_Seq(x$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Payloads$1))
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  var jsx$6 = $as_sc_GenTraversableOnce(reqParams.flatMap__F1__scg_CanBuildFrom__O(jsx$7, this$3.ReusableCBFInstance$2));
  var this$4 = $m_sc_Seq$();
  var jsx$5 = $as_sc_TraversableLike(jsx$8.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$6, this$4.ReusableCBFInstance$2));
  var this$5 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(reqParams, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage.prototype.init___Lamf_ProfileName__Lamf_core_errorhandling_ErrorHandler = (function(profile, errorHandler) {
  this.profile$2 = profile;
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
$c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage.prototype.resolveExamples__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  matchEnd4: {
    if ((model instanceof $c_Lamf_core_model_document_Document)) {
      var x2 = $as_Lamf_core_model_document_Document(model);
      if ((x2.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)) {
        var webApiSchemas = this.searchPayloadAndParams__Lamf_plugins_domain_webapi_models_WebApi__sc_Seq($as_Lamf_plugins_domain_webapi_models_WebApi(x2.encodes__Lamf_core_model_domain_DomainElement()));
        var declaredSchemas = this.searchDeclarations__p2__Lamf_core_model_document_Document__sc_Seq(x2);
        var this$1 = $m_sc_Seq$();
        $as_sc_IterableLike(webApiSchemas.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(declaredSchemas, this$1.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(payloadOrParam$2) {
            var payloadOrParam = $as_Lamf_plugins_domain_webapi_models_SchemaContainer(payloadOrParam$2);
            $this.setExamplesInSchema__p2__Lamf_plugins_domain_webapi_models_SchemaContainer__V(payloadOrParam)
          })
        })(this)));
        break matchEnd4
      }
    }
  };
  return model
});
var $d_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.PayloadAndParameterResolutionStage", {
  Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_ResponseExamplesResolutionStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_domain_webapi_resolution_stages_ResponseExamplesResolutionStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_domain_webapi_resolution_stages_ResponseExamplesResolutionStage.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_ResponseExamplesResolutionStage;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_ResponseExamplesResolutionStage() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_ResponseExamplesResolutionStage.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_ResponseExamplesResolutionStage.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_ResponseExamplesResolutionStage.prototype.resolveWebApi__Lamf_plugins_domain_webapi_models_WebApi__Lamf_plugins_domain_webapi_models_WebApi = (function(webApi) {
  var jsx$4 = $as_sc_Seq(webApi.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1));
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(e$2) {
      var e = $as_Lamf_plugins_domain_webapi_models_EndPoint(e$2);
      return $as_sc_Seq(e.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1))
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike(jsx$4.flatMap__F1__scg_CanBuildFrom__O(jsx$3, this$1.ReusableCBFInstance$2));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(o$2) {
      var o = $as_Lamf_plugins_domain_webapi_models_Operation(o$2);
      return $as_sc_Seq(o.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1))
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  var allResponses = $as_sc_Seq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
  var this$4 = $m_sc_Seq$();
  $as_sc_IterableLike(allResponses.zipWithIndex__scg_CanBuildFrom__O(this$4.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var response = $as_Lamf_plugins_domain_webapi_models_Response(x0$1.$$und1__O());
        var index = x0$1.$$und2$mcI$sp__I();
        var jsx$6 = $as_sc_Seq(response.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1));
        var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
          return (function(e$2$1) {
            var e$1 = $as_Lamf_plugins_domain_shapes_models_Example(e$2$1);
            var this$5 = $as_Lamf_core_model_StrField(e$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().MediaType$1));
            var this$6 = this$5.option$1;
            var self = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
            return new $c_T2().init___O__O(self, e$1)
          })
        })(this$3$1));
        var this$9 = $m_sc_Seq$();
        var examplesByMediaType = $as_sc_TraversableOnce(jsx$6.map__F1__scg_CanBuildFrom__O(jsx$5, this$9.ReusableCBFInstance$2)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2);
        response.fields$2.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Examples$1);
        examplesByMediaType.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, response$1, index$1) {
          return (function(x0$2$2) {
            var x0$2 = $as_T2(x0$2$2);
            if ((x0$2 !== null)) {
              var mediaType = $as_T(x0$2.$$und1__O());
              var example = $as_Lamf_plugins_domain_shapes_models_Example(x0$2.$$und2__O());
              var jsx$8 = $as_sc_Seq(response$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1));
              var jsx$7 = $m_sc_Seq$();
              var array = [mediaType, "*/*"];
              var arg1 = jsx$7.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
              var mediaTypes = $as_sc_Seq(arg1);
              var x1$2 = jsx$8.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, mediaTypes$1) {
                return (function(p$2) {
                  var p = $as_Lamf_plugins_domain_webapi_models_Payload(p$2);
                  var this$12 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1));
                  var this$13 = this$12.option$1;
                  return mediaTypes$1.contains__O__Z($as_T((this$13.isEmpty__Z() ? null : this$13.get__O())))
                })
              })(this$2$1, mediaTypes)));
              if ((x1$2 instanceof $c_s_Some)) {
                var x2 = $as_s_Some(x1$2);
                var p$1 = $as_Lamf_plugins_domain_webapi_models_Payload(x2.value$2);
                var x1$3 = $as_Lamf_core_model_domain_Shape(p$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1));
                if ((x1$3 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
                  var x2$2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x1$3);
                  var annotation = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracked__T__Lamf_plugins_domain_shapes_models_Example__s_Option__Lamf_core_annotations_TrackedElement(p$1.id$1, example, new $c_s_Some().init___O(response$1.id$1));
                  $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(example, annotation);
                  if ((!$as_sc_Seq(x2$2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$2, example$1) {
                    return (function(x$1$2) {
                      var x$1 = $as_Lamf_plugins_domain_shapes_models_Example(x$1$2);
                      return (x$1.id$1 === example$1.id$1)
                    })
                  })(this$2$1, example))))) {
                    var this$14 = $as_Lamf_core_model_StrField(example.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().MediaType$1));
                    var this$15 = this$14.option$1;
                    var name = (("" + $as_T((this$15.isEmpty__Z() ? null : this$15.get__O()))) + index$1);
                    $m_Lamf_core_parser_Annotations$();
                    var a = new $c_Lamf_core_parser_Annotations().init___();
                    $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(example, name, a);
                    var jsx$11 = $as_sc_Seq(x2$2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1));
                    var jsx$10 = $m_sc_Seq$();
                    var array$1 = [example];
                    var jsx$9 = jsx$10.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
                    var this$19 = $m_sc_Seq$();
                    var examples = $as_sc_Seq(jsx$11.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$9, this$19.ReusableCBFInstance$2));
                    var field = $m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1;
                    return $as_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(x2$2, field, examples))
                  } else {
                    return (void 0)
                  }
                } else {
                  var jsx$14 = $as_sc_Seq(response$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1));
                  var jsx$13 = $m_sc_Seq$();
                  var array$2 = [example];
                  var jsx$12 = jsx$13.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2));
                  var this$22 = $m_sc_Seq$();
                  var examples$1 = $as_sc_Seq(jsx$14.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$12, this$22.ReusableCBFInstance$2));
                  var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1;
                  return $as_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(response$1, field$1, examples$1))
                }
              } else {
                this$2$1.violationForUnmappedExample__p2__Lamf_plugins_domain_shapes_models_Example__T__sc_Seq__V(example, mediaType, $as_sc_Seq(response$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1)));
                var jsx$17 = $as_sc_Seq(response$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1));
                var jsx$16 = $m_sc_Seq$();
                var array$3 = [example];
                var jsx$15 = jsx$16.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$3));
                var this$25 = $m_sc_Seq$();
                var examples$2 = $as_sc_Seq(jsx$17.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$15, this$25.ReusableCBFInstance$2));
                var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1;
                return $as_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(response$1, field$2, examples$2))
              }
            } else {
              throw new $c_s_MatchError().init___O(x0$2)
            }
          })
        })(this$3$1, response, index)))
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this)));
  return webApi
});
$c_Lamf_plugins_domain_webapi_resolution_stages_ResponseExamplesResolutionStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  if ((model instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(model);
    if ((x2.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)) {
      var encoded = this.resolveWebApi__Lamf_plugins_domain_webapi_models_WebApi__Lamf_plugins_domain_webapi_models_WebApi($as_Lamf_plugins_domain_webapi_models_WebApi(x2.encodes__Lamf_core_model_domain_DomainElement()));
      var field = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
      return $as_Lamf_core_model_document_BaseUnit($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(x2, field, encoded)))
    }
  };
  return model
});
$c_Lamf_plugins_domain_webapi_resolution_stages_ResponseExamplesResolutionStage.prototype.violationForUnmappedExample__p2__Lamf_plugins_domain_shapes_models_Example__T__sc_Seq__V = (function(example, mediaType, payloads) {
  if (payloads.isEmpty__Z()) {
    var this$1 = this.errorHandler$1;
    var specification = $m_Lamf_validations_ResolutionSideValidations$().ExamplesWithNoSchemaDefined$1;
    var node = example.id$1;
    var annotations = example.annotations$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$1, specification, node, "When schema is undefined, 'examples' facet is invalid as no content is returned as part of the response", annotations)
  } else {
    var this$2 = this.errorHandler$1;
    var specification$1 = $m_Lamf_validations_ResolutionSideValidations$().ExamplesWithInvalidMimeType$1;
    var node$1 = example.id$1;
    var message = (("Mime type '" + mediaType) + "' defined in examples must be present in a 'produces' property");
    var annotations$1 = example.annotations$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$2, specification$1, node$1, message, annotations$1)
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_ResponseExamplesResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_domain_webapi_resolution_stages_ResponseExamplesResolutionStage = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_ResponseExamplesResolutionStage: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.ResponseExamplesResolutionStage", {
  Lamf_plugins_domain_webapi_resolution_stages_ResponseExamplesResolutionStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_ResponseExamplesResolutionStage.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_ResponseExamplesResolutionStage;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_SecurityResolutionStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_domain_webapi_resolution_stages_SecurityResolutionStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_domain_webapi_resolution_stages_SecurityResolutionStage.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_SecurityResolutionStage;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_SecurityResolutionStage() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_SecurityResolutionStage.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_SecurityResolutionStage.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_SecurityResolutionStage.prototype.resolveSecurity__Lamf_plugins_domain_webapi_models_WebApi__V = (function(api) {
  var rootSecurity = this.getAndRemove__p2__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__s_Option(api, $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Security$1);
  $as_sc_Seq(api.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, rootSecurity$1) {
    return (function(endPoint$2) {
      var endPoint = $as_Lamf_plugins_domain_webapi_models_EndPoint(endPoint$2);
      var endPointSecurity = $this.overrideWith__p2__s_Option__s_Option__s_Option(rootSecurity$1, $this.getAndRemove__p2__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__s_Option(endPoint, $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Security$1));
      $as_sc_Seq(endPoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, endPointSecurity$1) {
        return (function(operation$2) {
          var operation = $as_Lamf_plugins_domain_webapi_models_Operation(operation$2);
          var opSecurity = $this$1.getAndRemove__p2__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__s_Option(operation, $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Security$1);
          var this$1 = $this$1.overrideWith__p2__s_Option__s_Option__s_Option(endPointSecurity$1, opSecurity);
          if ((!this$1.isEmpty__Z())) {
            var arg1 = this$1.get__O();
            var requirements = $as_sc_Seq(arg1);
            if (requirements.nonEmpty__Z()) {
              var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Security$1;
              $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(operation, field, requirements)
            }
          }
        })
      })($this, endPointSecurity)))
    })
  })(this, rootSecurity)))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_SecurityResolutionStage.prototype.overrideWith__p2__s_Option__s_Option__s_Option = (function(base, overrider) {
  var this$1 = (overrider.isEmpty__Z() ? base : overrider);
  if (this$1.isEmpty__Z()) {
    var jsx$1 = true
  } else {
    var arg1 = this$1.get__O();
    var x$2 = $as_sc_Seq(arg1);
    var jsx$1 = x$2.nonEmpty__Z()
  };
  if (jsx$1) {
    return this$1
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_SecurityResolutionStage.prototype.getAndRemove__p2__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__s_Option = (function(element, field) {
  var this$1 = element.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option(field);
  if (this$1.isEmpty__Z()) {
    var result = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_Lamf_core_parser_FieldEntry(arg1);
    var jsx$2 = $as_Lamf_core_model_domain_AmfArray(x$1.value$1.value$1).values$1;
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(v$2) {
        var v = $as_Lamf_core_model_domain_AmfElement(v$2);
        return $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(v)
      })
    })(this));
    var this$2 = $m_sc_Seq$();
    var result = new $c_s_Some().init___O($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2)))
  };
  element.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields(field);
  return result
});
$c_Lamf_plugins_domain_webapi_resolution_stages_SecurityResolutionStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  matchEnd4: {
    if ((model instanceof $c_Lamf_core_model_document_Document)) {
      var x2 = $as_Lamf_core_model_document_Document(model);
      if ((x2.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)) {
        this.resolveSecurity__Lamf_plugins_domain_webapi_models_WebApi__V($as_Lamf_plugins_domain_webapi_models_WebApi(x2.encodes__Lamf_core_model_domain_DomainElement()));
        break matchEnd4
      }
    }
  };
  return model
});
$c_Lamf_plugins_domain_webapi_resolution_stages_SecurityResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_domain_webapi_resolution_stages_SecurityResolutionStage = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_SecurityResolutionStage: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.SecurityResolutionStage", {
  Lamf_plugins_domain_webapi_resolution_stages_SecurityResolutionStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_SecurityResolutionStage.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_SecurityResolutionStage;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_ServersNormalizationStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this);
  this.profile$2 = null;
  this.keepEditingInfo$2 = false
}
$c_Lamf_plugins_domain_webapi_resolution_stages_ServersNormalizationStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_domain_webapi_resolution_stages_ServersNormalizationStage.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_ServersNormalizationStage;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_ServersNormalizationStage() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_ServersNormalizationStage.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_ServersNormalizationStage.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_ServersNormalizationStage.prototype.normalizeServers__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(unit) {
  if ((unit instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(unit);
    if ((x2.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)) {
      var webApi = $as_Lamf_plugins_domain_webapi_models_WebApi(x2.encodes__Lamf_core_model_domain_DomainElement());
      var endpoints = $as_sc_Seq(webApi.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1));
      this.propagateServers__p2__Lamf_plugins_domain_webapi_models_ServerContainer__sc_Seq__V(webApi, endpoints);
      endpoints.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(endPoint$2) {
          var endPoint = $as_Lamf_plugins_domain_webapi_models_EndPoint(endPoint$2);
          $this.propagateServers__p2__Lamf_plugins_domain_webapi_models_ServerContainer__sc_Seq__V(endPoint, $as_sc_Seq(endPoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1)))
        })
      })(this)));
      return x2
    }
  };
  return unit
});
$c_Lamf_plugins_domain_webapi_resolution_stages_ServersNormalizationStage.prototype.init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler = (function(profile, keepEditingInfo, errorHandler) {
  this.profile$2 = profile;
  this.keepEditingInfo$2 = keepEditingInfo;
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
$c_Lamf_plugins_domain_webapi_resolution_stages_ServersNormalizationStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  var x1 = this.profile$2;
  var x = $m_Lamf_Oas30Profile$();
  if (x.equals__O__Z(x1)) {
    return this.normalizeServers__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(model)
  } else {
    return model
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_ServersNormalizationStage.prototype.propagateServers__p2__Lamf_plugins_domain_webapi_models_ServerContainer__sc_Seq__V = (function(base, children) {
  if ((children.nonEmpty__Z() && base.servers__sc_Seq().nonEmpty__Z())) {
    var servers = base.servers__sc_Seq();
    if ((!this.keepEditingInfo$2)) {
      base.removeServers__V()
    };
    children.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, servers$1) {
      return (function(child$2) {
        var child = $as_Lamf_plugins_domain_webapi_models_ServerContainer(child$2);
        return (child.servers__sc_Seq().isEmpty__Z() ? child.withServers__sc_Seq__Lamf_plugins_domain_webapi_models_ServerContainer(servers$1) : (void 0))
      })
    })(this, servers)))
  }
});
var $d_Lamf_plugins_domain_webapi_resolution_stages_ServersNormalizationStage = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_ServersNormalizationStage: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.ServersNormalizationStage", {
  Lamf_plugins_domain_webapi_resolution_stages_ServersNormalizationStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_ServersNormalizationStage.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_ServersNormalizationStage;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncContentTypeResolutionStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncContentTypeResolutionStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncContentTypeResolutionStage.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncContentTypeResolutionStage;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncContentTypeResolutionStage() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncContentTypeResolutionStage.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncContentTypeResolutionStage.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncContentTypeResolutionStage.prototype.resolve__p2__Lamf_plugins_domain_webapi_models_WebApi__V = (function(webApi) {
  var contentType = $as_sc_Seq(webApi.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().ContentType$1)).headOption__s_Option();
  if ((!contentType.isEmpty__Z())) {
    var arg1 = contentType.get__O();
    var mediaType = $as_Lamf_core_model_StrField(arg1);
    var payloads = this.getPayloads__p2__Lamf_plugins_domain_webapi_models_WebApi__sc_Seq(webApi);
    $as_sc_IterableLike(payloads.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(p$2) {
        var p = $as_Lamf_plugins_domain_webapi_models_Payload(p$2);
        return $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1)).option$1.isEmpty__Z()
      })
    })(this)))).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, mediaType$1) {
      return (function(x$1$2) {
        var x$1 = $as_Lamf_plugins_domain_webapi_models_Payload(x$1$2);
        var this$1 = mediaType$1.option$1;
        var mediaType$2 = $as_T((this$1.isEmpty__Z() ? null : this$1.get__O()));
        var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1;
        return $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x$1, field, mediaType$2))
      })
    })(this, mediaType)))
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncContentTypeResolutionStage.prototype.getPayloads__p2__Lamf_plugins_domain_webapi_models_WebApi__sc_Seq = (function(webApi) {
  var jsx$2 = $as_sc_Seq(webApi.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_plugins_domain_webapi_models_EndPoint(x$2$2);
      return $as_sc_Seq(x$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1))
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var operations = $as_sc_Seq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  var jsx$10 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_plugins_domain_webapi_models_Operation(x$3$2);
      return $as_sc_Seq(x$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Request$1))
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  var jsx$9 = $as_sc_TraversableLike(operations.flatMap__F1__scg_CanBuildFrom__O(jsx$10, this$3.ReusableCBFInstance$2));
  var jsx$8 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x$4$2) {
      var x$4 = $as_Lamf_plugins_domain_webapi_models_Request(x$4$2);
      return $as_sc_Seq(x$4.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1))
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  var jsx$7 = $as_sc_TraversableLike(jsx$9.flatMap__F1__scg_CanBuildFrom__O(jsx$8, this$4.ReusableCBFInstance$2));
  var jsx$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
    return (function(x$5$2) {
      var x$5 = $as_Lamf_plugins_domain_webapi_models_Operation(x$5$2);
      return $as_sc_Seq(x$5.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1))
    })
  })(this));
  var this$5 = $m_sc_Seq$();
  var jsx$5 = $as_sc_TraversableLike(operations.flatMap__F1__scg_CanBuildFrom__O(jsx$6, this$5.ReusableCBFInstance$2));
  var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1) {
    return (function(x$6$2) {
      var x$6 = $as_Lamf_plugins_domain_webapi_models_Response(x$6$2);
      return $as_sc_Seq(x$6.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1))
    })
  })(this));
  var this$6 = $m_sc_Seq$();
  var jsx$3 = $as_sc_GenTraversableOnce(jsx$5.flatMap__F1__scg_CanBuildFrom__O(jsx$4, this$6.ReusableCBFInstance$2));
  var this$7 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$7.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$7.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncContentTypeResolutionStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  if ((model instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(model);
    if ((x2.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)) {
      var webApi = $as_Lamf_plugins_domain_webapi_models_WebApi(x2.encodes__Lamf_core_model_domain_DomainElement());
      this.resolve__p2__Lamf_plugins_domain_webapi_models_WebApi__V(webApi);
      return x2
    }
  };
  return model
});
$c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncContentTypeResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncContentTypeResolutionStage = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_async_AsyncContentTypeResolutionStage: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.async.AsyncContentTypeResolutionStage", {
  Lamf_plugins_domain_webapi_resolution_stages_async_AsyncContentTypeResolutionStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncContentTypeResolutionStage.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncContentTypeResolutionStage;
/** @constructor */
function $c_Lamf_plugins_features_validation_CoreValidations$() {
  $c_O.call(this);
  this.specification$1 = null;
  this.namespace$1 = null;
  this.CycleReferenceError$1 = null;
  this.InvalidCrossSpec$1 = null;
  this.UnresolvedReference$1 = null;
  this.UriSyntaxError$1 = null;
  this.InvalidFragmentRef$1 = null;
  this.DeclarationNotFound$1 = null;
  this.SyamlError$1 = null;
  this.SyamlWarning$1 = null;
  this.ExpectedModule$1 = null;
  this.InvalidInclude$1 = null;
  this.UnableToParseNode$1 = null;
  this.UnableToConvertToScalar$1 = null;
  this.UnableToParseRdfDocument$1 = null;
  this.NodeNotFound$1 = null;
  this.NotLinkable$1 = null;
  this.UnableToParseDocument$1 = null;
  this.MissingIdInNode$1 = null;
  this.MissingTypeInNode$1 = null;
  this.RecursiveShapeSpecification$1 = null;
  this.ResolutionValidation$1 = null;
  this.levels$1 = null;
  this.validations$1 = null;
  this.amf$plugins$features$validation$Validations$$default$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_features_validation_CoreValidations$.prototype = new $h_O();
$c_Lamf_plugins_features_validation_CoreValidations$.prototype.constructor = $c_Lamf_plugins_features_validation_CoreValidations$;
/** @constructor */
function $h_Lamf_plugins_features_validation_CoreValidations$() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_CoreValidations$.prototype = $c_Lamf_plugins_features_validation_CoreValidations$.prototype;
$c_Lamf_plugins_features_validation_CoreValidations$.prototype.init___ = (function() {
  $n_Lamf_plugins_features_validation_CoreValidations$ = this;
  this.specification$1 = $m_Lamf_core_validation_core_ValidationSpecification$().CORE$undVALIDATION$1;
  this.namespace$1 = $m_Lamf_core_vocabulary_Namespace$().AmfCore$1;
  var ramlMessage = $m_s_None$();
  var oasMessage = $m_s_None$();
  this.CycleReferenceError$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "cycle-reference", "Cycle in references", ramlMessage, oasMessage);
  var ramlMessage$1 = $m_s_None$();
  var oasMessage$1 = $m_s_None$();
  this.InvalidCrossSpec$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-cross-spec", "Cross spec file usage is not allowed", ramlMessage$1, oasMessage$1);
  var ramlMessage$2 = $m_s_None$();
  var oasMessage$2 = $m_s_None$();
  this.UnresolvedReference$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "unresolved-reference", "Unresolved reference", ramlMessage$2, oasMessage$2);
  var ramlMessage$3 = $m_s_None$();
  var oasMessage$3 = $m_s_None$();
  this.UriSyntaxError$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "uri-syntax-error", "invalid uri syntax", ramlMessage$3, oasMessage$3);
  var ramlMessage$4 = $m_s_None$();
  var oasMessage$4 = $m_s_None$();
  this.InvalidFragmentRef$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-fragment-ref", "References with # in RAML are not allowed", ramlMessage$4, oasMessage$4);
  var ramlMessage$5 = $m_s_None$();
  var oasMessage$5 = $m_s_None$();
  this.DeclarationNotFound$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "declaration-not-found", "Declaration not found", ramlMessage$5, oasMessage$5);
  var ramlMessage$6 = $m_s_None$();
  var oasMessage$6 = $m_s_None$();
  this.SyamlError$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "syaml-error", "Syaml error", ramlMessage$6, oasMessage$6);
  var ramlMessage$7 = $m_s_None$();
  var oasMessage$7 = $m_s_None$();
  this.SyamlWarning$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "syaml-warning", "Syaml warning", ramlMessage$7, oasMessage$7);
  var ramlMessage$8 = $m_s_None$();
  var oasMessage$8 = $m_s_None$();
  this.ExpectedModule$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "expected-module", "Expected Module", ramlMessage$8, oasMessage$8);
  var ramlMessage$9 = $m_s_None$();
  var oasMessage$9 = $m_s_None$();
  this.InvalidInclude$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-include", "Invalid !include value", ramlMessage$9, oasMessage$9);
  var ramlMessage$10 = $m_s_None$();
  var oasMessage$10 = $m_s_None$();
  this.UnableToParseNode$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "parse-node-fail", "JsonLD @types failed to parse in node", ramlMessage$10, oasMessage$10);
  var ramlMessage$11 = $m_s_None$();
  var oasMessage$11 = $m_s_None$();
  this.UnableToConvertToScalar$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "unable-to-convert-scalar", "Unable to convert scalar", ramlMessage$11, oasMessage$11);
  var ramlMessage$12 = $m_s_None$();
  var oasMessage$12 = $m_s_None$();
  this.UnableToParseRdfDocument$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "parse-rdf-document-fail", "Unable to parse rdf document", ramlMessage$12, oasMessage$12);
  var ramlMessage$13 = $m_s_None$();
  var oasMessage$13 = $m_s_None$();
  this.NodeNotFound$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "node-not-found", "Builder for model not found", ramlMessage$13, oasMessage$13);
  var ramlMessage$14 = $m_s_None$();
  var oasMessage$14 = $m_s_None$();
  this.NotLinkable$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "not-linkable", "Only linkable elements can be linked", ramlMessage$14, oasMessage$14);
  var ramlMessage$15 = $m_s_None$();
  var oasMessage$15 = $m_s_None$();
  this.UnableToParseDocument$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "parse-document-fail", "Unable to parse document", ramlMessage$15, oasMessage$15);
  var ramlMessage$16 = $m_s_None$();
  var oasMessage$16 = $m_s_None$();
  this.MissingIdInNode$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "missing-id-in-node", "Missing @id in json-ld node", ramlMessage$16, oasMessage$16);
  var ramlMessage$17 = $m_s_None$();
  var oasMessage$17 = $m_s_None$();
  this.MissingTypeInNode$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "missing-type-in-node", "Missing @type in json-ld node", ramlMessage$17, oasMessage$17);
  var ramlMessage$18 = new $c_s_Some().init___O("Recursive type");
  var oasMessage$18 = new $c_s_Some().init___O("Recursive schema");
  this.RecursiveShapeSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "recursive-shape", "Recursive shape", ramlMessage$18, oasMessage$18);
  var ramlMessage$19 = $m_s_None$();
  var oasMessage$19 = $m_s_None$();
  this.ResolutionValidation$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "resolution-validation", "Default resolution validation", ramlMessage$19, oasMessage$19);
  var self = this.SyamlWarning$1.id$1;
  var lvl = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var y = $f_Lamf_plugins_features_validation_Validations__all__T__sci_Map(this, lvl);
  var jsx$7 = new $c_T2().init___O__O(self, y);
  var self$1 = this.RecursiveShapeSpecification$1.id$1;
  var self$2 = $m_Lamf_RamlProfile$();
  var y$1 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$6 = new $c_T2().init___O__O(self$2, y$1);
  var self$3 = $m_Lamf_Raml10Profile$();
  var y$2 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$5 = new $c_T2().init___O__O(self$3, y$2);
  var self$4 = $m_Lamf_Raml08Profile$();
  var y$3 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$4 = new $c_T2().init___O__O(self$4, y$3);
  var self$5 = $m_Lamf_OasProfile$();
  var y$4 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$3 = new $c_T2().init___O__O(self$5, y$4);
  var self$6 = $m_Lamf_Oas20Profile$();
  var y$5 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$2 = new $c_T2().init___O__O(self$6, y$5);
  var self$7 = $m_Lamf_Oas30Profile$();
  var y$6 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$1 = new $c_T2().init___O__O(self$7, y$6);
  var self$8 = $m_Lamf_AmfProfile$();
  var y$7 = $m_Lamf_core_validation_SeverityLevels$().INFO$1;
  var array = [jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, jsx$1, new $c_T2().init___O__O(self$8, y$7)];
  var this$21 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$21.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  var y$8 = this$21.elems$1;
  var array$1 = [jsx$7, new $c_T2().init___O__O(self$1, y$8)];
  var this$26 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i$1 = 0;
  var len$1 = $uI(array$1.length);
  while ((i$1 < len$1)) {
    var index$1 = i$1;
    var arg1$1 = array$1[index$1];
    this$26.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1$1));
    i$1 = ((1 + i$1) | 0)
  };
  this.levels$1 = $as_sci_Map(this$26.elems$1);
  $m_sci_List$();
  var array$2 = [this.CycleReferenceError$1, this.NotLinkable$1, this.UnresolvedReference$1, this.SyamlError$1, this.SyamlWarning$1, this.NodeNotFound$1, this.UnableToParseDocument$1, this.UnableToParseNode$1, this.ExpectedModule$1, this.MissingIdInNode$1, this.MissingTypeInNode$1, this.UriSyntaxError$1, this.UnableToParseRdfDocument$1, this.DeclarationNotFound$1, this.InvalidInclude$1, this.InvalidCrossSpec$1, this.InvalidFragmentRef$1, this.RecursiveShapeSpecification$1, this.ResolutionValidation$1];
  var i$2 = (((-1) + $uI(array$2.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i$2 >= 0)) {
    var this$30 = result;
    var index$2 = i$2;
    var x = array$2[index$2];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$30);
    i$2 = (((-1) + i$2) | 0)
  };
  this.validations$1 = result;
  return this
});
$c_Lamf_plugins_features_validation_CoreValidations$.prototype.namespace__Lamf_core_vocabulary_Namespace = (function() {
  return this.namespace$1
});
$c_Lamf_plugins_features_validation_CoreValidations$.prototype.specification__T = (function() {
  return this.specification$1
});
var $d_Lamf_plugins_features_validation_CoreValidations$ = new $TypeData().initClass({
  Lamf_plugins_features_validation_CoreValidations$: 0
}, false, "amf.plugins.features.validation.CoreValidations$", {
  Lamf_plugins_features_validation_CoreValidations$: 1,
  O: 1,
  Lamf_plugins_features_validation_Validations: 1
});
$c_Lamf_plugins_features_validation_CoreValidations$.prototype.$classData = $d_Lamf_plugins_features_validation_CoreValidations$;
var $n_Lamf_plugins_features_validation_CoreValidations$ = (void 0);
function $m_Lamf_plugins_features_validation_CoreValidations$() {
  if ((!$n_Lamf_plugins_features_validation_CoreValidations$)) {
    $n_Lamf_plugins_features_validation_CoreValidations$ = new $c_Lamf_plugins_features_validation_CoreValidations$().init___()
  };
  return $n_Lamf_plugins_features_validation_CoreValidations$
}
/** @constructor */
function $c_Lamf_plugins_features_validation_CustomValidationReport() {
  $c_O.call(this);
  this.rs$1 = null;
  this.duplicates$1 = null
}
$c_Lamf_plugins_features_validation_CustomValidationReport.prototype = new $h_O();
$c_Lamf_plugins_features_validation_CustomValidationReport.prototype.constructor = $c_Lamf_plugins_features_validation_CustomValidationReport;
/** @constructor */
function $h_Lamf_plugins_features_validation_CustomValidationReport() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_CustomValidationReport.prototype = $c_Lamf_plugins_features_validation_CustomValidationReport.prototype;
$c_Lamf_plugins_features_validation_CustomValidationReport.prototype.init___sci_List = (function(rs) {
  this.rs$1 = rs;
  this.duplicates$1 = $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  return this
});
$c_Lamf_plugins_features_validation_CustomValidationReport.prototype.results__sci_List = (function() {
  return this.rs$1
});
$c_Lamf_plugins_features_validation_CustomValidationReport.prototype.conforms__Z = (function() {
  var this$1 = this.rs$1;
  var these = this$1;
  while ((!these.isEmpty__Z())) {
    var arg1 = these.head__O();
    var x$1 = $as_Lamf_core_validation_core_ValidationResult(arg1);
    if ((x$1.severity__T() === $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1)) {
      return true
    };
    these = $as_sc_LinearSeqOptimized(these.tail__O())
  };
  return false
});
$c_Lamf_plugins_features_validation_CustomValidationReport.prototype.registerResult__Lamf_core_validation_core_ValidationResult__V = (function(result) {
  var key = ((("" + result.sourceShape__T()) + result.sourceConstraintComponent__T()) + result.focusNode__T());
  if ((!this.duplicates$1.contains__O__Z(key))) {
    this.duplicates$1.$$plus$eq__O__scm_SetLike(key);
    var jsx$3 = this.rs$1;
    var jsx$2 = $m_sc_Seq$();
    var array = [result];
    var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$3 = $m_sci_List$();
    this.rs$1 = $as_sci_List(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))
  }
});
var $d_Lamf_plugins_features_validation_CustomValidationReport = new $TypeData().initClass({
  Lamf_plugins_features_validation_CustomValidationReport: 0
}, false, "amf.plugins.features.validation.CustomValidationReport", {
  Lamf_plugins_features_validation_CustomValidationReport: 1,
  O: 1,
  Lamf_core_validation_core_ValidationReport: 1
});
$c_Lamf_plugins_features_validation_CustomValidationReport.prototype.$classData = $d_Lamf_plugins_features_validation_CustomValidationReport;
/** @constructor */
function $c_Lamf_plugins_features_validation_JSValidationReport() {
  $c_O.call(this);
  this.wrapped$1 = null
}
$c_Lamf_plugins_features_validation_JSValidationReport.prototype = new $h_O();
$c_Lamf_plugins_features_validation_JSValidationReport.prototype.constructor = $c_Lamf_plugins_features_validation_JSValidationReport;
/** @constructor */
function $h_Lamf_plugins_features_validation_JSValidationReport() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_JSValidationReport.prototype = $c_Lamf_plugins_features_validation_JSValidationReport.prototype;
$c_Lamf_plugins_features_validation_JSValidationReport.prototype.$$js$exported$meth$toString__O = (function() {
  return $m_Lamf_core_validation_core_ValidationReport$().displayString__Lamf_core_validation_core_ValidationReport__T(this)
});
$c_Lamf_plugins_features_validation_JSValidationReport.prototype.toString__T = (function() {
  return $m_Lamf_core_validation_core_ValidationReport$().displayString__Lamf_core_validation_core_ValidationReport__T(this)
});
$c_Lamf_plugins_features_validation_JSValidationReport.prototype.$$js$exported$prop$results__O = (function() {
  return this.results__sci_List()
});
$c_Lamf_plugins_features_validation_JSValidationReport.prototype.init___sjs_js_Dynamic = (function(wrapped) {
  this.wrapped$1 = wrapped;
  return this
});
$c_Lamf_plugins_features_validation_JSValidationReport.prototype.$$js$exported$prop$conforms__O = (function() {
  return this.conforms__Z()
});
$c_Lamf_plugins_features_validation_JSValidationReport.prototype.results__sci_List = (function() {
  var array = this.wrapped$1.results();
  var array$1 = [];
  var x1 = $uI(array.length);
  switch (x1) {
    case (-1): {
      break
    }
  };
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    var elem = new $c_Lamf_plugins_features_validation_JSValidationResult().init___sjs_js_Dynamic(arg1);
    array$1.push(elem);
    i = ((1 + i) | 0)
  };
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$5 = result;
    var index$1 = i$1;
    var x = array$1[index$1];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$5);
    i$1 = (((-1) + i$1) | 0)
  };
  return result
});
$c_Lamf_plugins_features_validation_JSValidationReport.prototype.conforms__Z = (function() {
  return $uZ(this.wrapped$1.conforms())
});
$c_Lamf_plugins_features_validation_JSValidationReport.prototype.toString = (function() {
  return this.$$js$exported$meth$toString__O()
});
Object.defineProperty($c_Lamf_plugins_features_validation_JSValidationReport.prototype, "results", {
  "get": (function() {
    return this.$$js$exported$prop$results__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_plugins_features_validation_JSValidationReport.prototype, "conforms", {
  "get": (function() {
    return this.$$js$exported$prop$conforms__O()
  }),
  "configurable": true
});
var $d_Lamf_plugins_features_validation_JSValidationReport = new $TypeData().initClass({
  Lamf_plugins_features_validation_JSValidationReport: 0
}, false, "amf.plugins.features.validation.JSValidationReport", {
  Lamf_plugins_features_validation_JSValidationReport: 1,
  O: 1,
  Lamf_core_validation_core_ValidationReport: 1
});
$c_Lamf_plugins_features_validation_JSValidationReport.prototype.$classData = $d_Lamf_plugins_features_validation_JSValidationReport;
/** @constructor */
function $c_Lamf_plugins_features_validation_JSValidationResult() {
  $c_O.call(this);
  this.wrapped$1 = null
}
$c_Lamf_plugins_features_validation_JSValidationResult.prototype = new $h_O();
$c_Lamf_plugins_features_validation_JSValidationResult.prototype.constructor = $c_Lamf_plugins_features_validation_JSValidationResult;
/** @constructor */
function $h_Lamf_plugins_features_validation_JSValidationResult() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_JSValidationResult.prototype = $c_Lamf_plugins_features_validation_JSValidationResult.prototype;
$c_Lamf_plugins_features_validation_JSValidationResult.prototype.severity__T = (function() {
  return $as_T($m_Lamf_plugins_features_validation_JSUtils$().$default__sjs_js_Dynamic__O__O(this.wrapped$1.severity(), "Violation"))
});
$c_Lamf_plugins_features_validation_JSValidationResult.prototype.path__T = (function() {
  var res = $as_T($m_Lamf_plugins_features_validation_JSUtils$().$default__sjs_js_Dynamic__O__O(this.wrapped$1.path(), ""));
  return ((($uI(res.length) >= 0) && ($as_T(res.substring(0, $uI("_:".length))) === "_:")) ? "" : res)
});
$c_Lamf_plugins_features_validation_JSValidationResult.prototype.message__s_Option = (function() {
  return $m_Lamf_plugins_features_validation_JSUtils$().maybe__sjs_js_Dynamic__s_Option(this.wrapped$1.message())
});
$c_Lamf_plugins_features_validation_JSValidationResult.prototype.sourceConstraintComponent__T = (function() {
  return $as_T($m_Lamf_plugins_features_validation_JSUtils$().$default__sjs_js_Dynamic__O__O(this.wrapped$1.sourceConstraintComponent(), ""))
});
$c_Lamf_plugins_features_validation_JSValidationResult.prototype.$$js$exported$prop$message__O = (function() {
  return this.message__s_Option()
});
$c_Lamf_plugins_features_validation_JSValidationResult.prototype.$$js$exported$prop$sourceConstraintComponent__O = (function() {
  return this.sourceConstraintComponent__T()
});
$c_Lamf_plugins_features_validation_JSValidationResult.prototype.focusNode__T = (function() {
  return $as_T($m_Lamf_plugins_features_validation_JSUtils$().$default__sjs_js_Dynamic__O__O(this.wrapped$1.focusNode(), ""))
});
$c_Lamf_plugins_features_validation_JSValidationResult.prototype.init___sjs_js_Dynamic = (function(wrapped) {
  this.wrapped$1 = wrapped;
  return this
});
$c_Lamf_plugins_features_validation_JSValidationResult.prototype.$$js$exported$prop$focusNode__O = (function() {
  return this.focusNode__T()
});
$c_Lamf_plugins_features_validation_JSValidationResult.prototype.$$js$exported$prop$severity__O = (function() {
  return this.severity__T()
});
$c_Lamf_plugins_features_validation_JSValidationResult.prototype.sourceShape__T = (function() {
  var result = $as_T($m_Lamf_plugins_features_validation_JSUtils$().$default__sjs_js_Dynamic__O__O(this.wrapped$1.sourceShape(), ""));
  var prefix = $m_Lamf_core_vocabulary_Namespace$().AmfParser$1.base$1;
  if (((($uI(result.length) >= 0) && ($as_T(result.substring(0, $uI(prefix.length))) === prefix)) && $m_sjsr_RuntimeString$().endsWith__T__T__Z(result, "#property"))) {
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(result, "#", 0);
    var this$8 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    return $as_T($f_sc_IndexedSeqOptimized__head__O(this$8))
  } else {
    return result
  }
});
$c_Lamf_plugins_features_validation_JSValidationResult.prototype.$$js$exported$prop$path__O = (function() {
  return this.path__T()
});
$c_Lamf_plugins_features_validation_JSValidationResult.prototype.$$js$exported$prop$sourceShape__O = (function() {
  return this.sourceShape__T()
});
Object.defineProperty($c_Lamf_plugins_features_validation_JSValidationResult.prototype, "sourceShape", {
  "get": (function() {
    return this.$$js$exported$prop$sourceShape__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_plugins_features_validation_JSValidationResult.prototype, "severity", {
  "get": (function() {
    return this.$$js$exported$prop$severity__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_plugins_features_validation_JSValidationResult.prototype, "focusNode", {
  "get": (function() {
    return this.$$js$exported$prop$focusNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_plugins_features_validation_JSValidationResult.prototype, "sourceConstraintComponent", {
  "get": (function() {
    return this.$$js$exported$prop$sourceConstraintComponent__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_plugins_features_validation_JSValidationResult.prototype, "path", {
  "get": (function() {
    return this.$$js$exported$prop$path__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_plugins_features_validation_JSValidationResult.prototype, "message", {
  "get": (function() {
    return this.$$js$exported$prop$message__O()
  }),
  "configurable": true
});
var $d_Lamf_plugins_features_validation_JSValidationResult = new $TypeData().initClass({
  Lamf_plugins_features_validation_JSValidationResult: 0
}, false, "amf.plugins.features.validation.JSValidationResult", {
  Lamf_plugins_features_validation_JSValidationResult: 1,
  O: 1,
  Lamf_core_validation_core_ValidationResult: 1
});
$c_Lamf_plugins_features_validation_JSValidationResult.prototype.$classData = $d_Lamf_plugins_features_validation_JSValidationResult;
/** @constructor */
function $c_Lamf_plugins_features_validation_RdflibRdfModel() {
  $c_Lamf_core_rdf_RdfModel.call(this);
  this.rdf$2 = null;
  this.jsonld$2 = null;
  this.model$2 = null;
  this.nodesCache$2 = null;
  this.bitmap$0$2 = 0
}
$c_Lamf_plugins_features_validation_RdflibRdfModel.prototype = new $h_Lamf_core_rdf_RdfModel();
$c_Lamf_plugins_features_validation_RdflibRdfModel.prototype.constructor = $c_Lamf_plugins_features_validation_RdflibRdfModel;
/** @constructor */
function $h_Lamf_plugins_features_validation_RdflibRdfModel() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_RdflibRdfModel.prototype = $c_Lamf_plugins_features_validation_RdflibRdfModel.prototype;
$c_Lamf_plugins_features_validation_RdflibRdfModel.prototype.findNode__T__s_Option = (function(uri) {
  var x1 = this.nodesCache$2.get__O__s_Option(uri);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var node = $as_Lamf_core_rdf_Node(x2.value$2);
    return new $c_s_Some().init___O(node)
  } else {
    var statements = this.model$2.getQuads(uri);
    if (($uI(statements.length) === 0)) {
      return $m_s_None$()
    } else {
      var elem = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
      var elem$1 = null;
      elem$1 = elem;
      var elem$2 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      var elem$1$1 = null;
      elem$1$1 = elem$2;
      var lt = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
        return (function(t1$2, t2$2) {
          var thiz = $as_T(t1$2.predicate.uri);
          var anotherString = $as_T(t2$2.predicate.uri);
          return (((thiz === anotherString) ? 0 : ($uZ((thiz < anotherString)) ? (-1) : 1)) > 0)
        })
      })(this));
      var ord = new $c_s_math_Ordering$$anon$6().init___F2(lt);
      var len = $uI(statements.length);
      var array = [];
      if ((len === 1)) {
        var i = 0;
        var len$1 = $uI(statements.length);
        while ((i < len$1)) {
          var index = i;
          var arg1 = statements[index];
          array.push(arg1);
          i = ((1 + i) | 0)
        }
      } else if ((len > 1)) {
        var arr = $newArrayObject($d_O.getArrayOf(), [len]);
        var elem$1$2 = 0;
        elem$1$2 = 0;
        var i$1 = 0;
        var len$2 = $uI(statements.length);
        while ((i$1 < len$2)) {
          var index$1 = i$1;
          var arg1$1 = statements[index$1];
          arr.set(elem$1$2, arg1$1);
          elem$1$2 = ((1 + elem$1$2) | 0);
          i$1 = ((1 + i$1) | 0)
        };
        $m_ju_Arrays$().sort__AO__ju_Comparator__V(arr, ord);
        elem$1$2 = 0;
        while ((elem$1$2 < arr.u.length)) {
          var elem$3 = arr.get(elem$1$2);
          array.push(elem$3);
          elem$1$2 = ((1 + elem$1$2) | 0)
        }
      };
      var i$2 = 0;
      var len$3 = $uI(array.length);
      while ((i$2 < len$3)) {
        var index$2 = i$2;
        var arg1$2 = array[index$2];
        var property = $as_T(arg1$2.predicate.uri);
        var obj = arg1$2.object;
        var oldProps = $as_sc_Seq($as_sci_Map(elem$1).getOrElse__O__F0__O(property, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this$1) {
          return (function() {
            return $m_sci_Nil$()
          })
        })(this))));
        var this$10 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
        if ((property === new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "type").iri__T())) {
          var jsx$3 = $as_sc_Seq(elem$1$1);
          var jsx$2 = $m_sc_Seq$();
          var array$1 = [$as_T(obj.uri)];
          var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
          var this$14 = $m_sc_Seq$();
          elem$1$1 = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$14.ReusableCBFInstance$2))
        } else if (($as_T(obj.termType) === "Literal")) {
          var jsx$6 = $as_sci_Map(elem$1);
          var jsx$5 = $m_sc_Seq$();
          var array$2 = [new $c_Lamf_core_rdf_Literal().init___T__s_Option(("" + obj.value), ($m_s_Option$().apply__O__s_Option(obj.datatype).isDefined__Z() ? new $c_s_Some().init___O($as_T(obj.datatype.uri)) : $m_s_None$()))];
          var jsx$4 = jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2));
          var this$17 = $m_sc_Seq$();
          elem$1 = jsx$6.updated__O__O__sci_Map(property, oldProps.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$17.ReusableCBFInstance$2))
        } else {
          var jsx$9 = $as_sci_Map(elem$1);
          var jsx$8 = $m_sc_Seq$();
          var this$18 = $m_s_Option$().apply__O__s_Option(obj.uri);
          var array$3 = [new $c_Lamf_core_rdf_Uri().init___T(("" + (this$18.isEmpty__Z() ? obj.toCanonical() : this$18.get__O())))];
          var jsx$7 = jsx$8.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$3));
          var this$21 = $m_sc_Seq$();
          elem$1 = jsx$9.updated__O__O__sci_Map(property, oldProps.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$7, this$21.ReusableCBFInstance$2))
        };
        i$2 = ((1 + i$2) | 0)
      };
      var newNode = new $c_Lamf_core_rdf_Node().init___T__sc_Seq__sci_Map(uri, $as_sc_Seq(elem$1$1), $as_sci_Map(elem$1));
      this.nodesCache$2 = this.nodesCache$2.updated__O__O__sci_Map(uri, newNode);
      return new $c_s_Some().init___O(newNode)
    }
  }
});
$c_Lamf_plugins_features_validation_RdflibRdfModel.prototype.rdf$lzycompute__p2__sjs_js_Dynamic = (function() {
  if (((((1 & this.bitmap$0$2) << 24) >> 24) === 0)) {
    this.rdf$2 = $m_Lamf_plugins_features_validation_RDF$().instance__sjs_js_Dynamic();
    this.bitmap$0$2 = (((1 | this.bitmap$0$2) << 24) >> 24)
  };
  return this.rdf$2
});
$c_Lamf_plugins_features_validation_RdflibRdfModel.prototype.rdf__sjs_js_Dynamic = (function() {
  return (((((1 & this.bitmap$0$2) << 24) >> 24) === 0) ? this.rdf$lzycompute__p2__sjs_js_Dynamic() : this.rdf$2)
});
$c_Lamf_plugins_features_validation_RdflibRdfModel.prototype.nextAnonId__T = (function() {
  return $objectToString(this.rdf__sjs_js_Dynamic().blankNode())
});
$c_Lamf_plugins_features_validation_RdflibRdfModel.prototype.load__T__T__V = (function(mediaType, text) {
  var effectiveMediaType = ((mediaType === "application/json") ? "application/ld+json" : mediaType);
  this.rdf__sjs_js_Dynamic().parse(text, this.model$2, "", effectiveMediaType)
});
$c_Lamf_plugins_features_validation_RdflibRdfModel.prototype.addTriple__T__T__T__Lamf_core_rdf_RdfModel = (function(subject, predicate, objResource) {
  this.nodesCache$2 = $as_sci_Map(this.nodesCache$2.$$minus__O__sc_Map(subject));
  var s = this.checkAnon__T__sjs_js_Any(subject);
  var p = this.rdf__sjs_js_Dynamic().namedNode(predicate);
  var o = this.checkAnon__T__sjs_js_Any(objResource);
  this.model$2.add(s, p, o);
  return this
});
$c_Lamf_plugins_features_validation_RdflibRdfModel.prototype.init___sjs_js_Dynamic = (function(model) {
  this.model$2 = model;
  $c_Lamf_core_rdf_RdfModel.prototype.init___.call(this);
  this.nodesCache$2 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  return this
});
$c_Lamf_plugins_features_validation_RdflibRdfModel.prototype.serializeWriter__T__O__Lorg_mulesoft_common_io_Output__s_Option = (function(mediaType, writer, evidence$1) {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Sync rdf serialization to writer not supported yet"))
});
$c_Lamf_plugins_features_validation_RdflibRdfModel.prototype.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel = (function(subject, predicate, objLiteralValue, objLiteralType) {
  this.nodesCache$2 = $as_sci_Map(this.nodesCache$2.$$minus__O__sc_Map(subject));
  var s = this.checkAnon__T__sjs_js_Any(subject);
  var p = this.rdf__sjs_js_Dynamic().namedNode(predicate);
  if ((objLiteralType instanceof $c_s_Some)) {
    var x2 = $as_s_Some(objLiteralType);
    var literalType = $as_T(x2.value$2);
    var dt = this.rdf__sjs_js_Dynamic().namedNode(literalType);
    var o = this.rdf__sjs_js_Dynamic().literal(objLiteralValue, dt)
  } else {
    var o = this.rdf__sjs_js_Dynamic().literal(objLiteralValue)
  };
  this.model$2.add(s, p, o);
  return this
});
$c_Lamf_plugins_features_validation_RdflibRdfModel.prototype.checkAnon__T__sjs_js_Any = (function(s) {
  if ((($uI(s.length) >= 0) && ($as_T(s.substring(0, $uI("_:n".length))) === "_:n"))) {
    try {
      var idString = $as_T(s.split("_:n").join(""));
      var this$8 = $m_jl_Integer$();
      var id = this$8.parseInt__T__I__I(idString, 10);
      var node = this.rdf__sjs_js_Dynamic().blankNode(idString);
      node.id = id;
      return node
    } catch (e) {
      var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
      if ((e$2 !== null)) {
        return this.rdf__sjs_js_Dynamic().namedNode(s)
      } else {
        throw e
      }
    }
  } else {
    return this.rdf__sjs_js_Dynamic().namedNode(s)
  }
});
var $d_Lamf_plugins_features_validation_RdflibRdfModel = new $TypeData().initClass({
  Lamf_plugins_features_validation_RdflibRdfModel: 0
}, false, "amf.plugins.features.validation.RdflibRdfModel", {
  Lamf_plugins_features_validation_RdflibRdfModel: 1,
  Lamf_core_rdf_RdfModel: 1,
  O: 1
});
$c_Lamf_plugins_features_validation_RdflibRdfModel.prototype.$classData = $d_Lamf_plugins_features_validation_RdflibRdfModel;
/** @constructor */
function $c_Lamf_plugins_features_validation_Validations$() {
  $c_O.call(this);
  this.allLevels$1 = null;
  this.default$1 = null;
  this.validations$1 = null;
  this.levels$1 = null;
  this.platform$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_features_validation_Validations$.prototype = new $h_O();
$c_Lamf_plugins_features_validation_Validations$.prototype.constructor = $c_Lamf_plugins_features_validation_Validations$;
/** @constructor */
function $h_Lamf_plugins_features_validation_Validations$() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_Validations$.prototype = $c_Lamf_plugins_features_validation_Validations$.prototype;
$c_Lamf_plugins_features_validation_Validations$.prototype.init___ = (function() {
  $n_Lamf_plugins_features_validation_Validations$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  var this$2 = this.platform$1.validations__scm_Set();
  var this$3 = $m_sci_List$();
  var cbf = this$3.ReusableCBFInstance$2;
  this.validations$1 = $as_sci_List($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this$2, cbf));
  var this$4 = this.platform$1.levels__scm_Map();
  var ev = $m_s_Predef$().singleton$und$less$colon$less$2;
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  this$4.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$1, ev$1) {
    return (function(x$2) {
      return b$1.$$plus$eq__O__scm_Builder(x$2)
    })
  })(this$4, b, ev)));
  this.levels$1 = $as_sci_Map(b.elems$1);
  return this
});
$c_Lamf_plugins_features_validation_Validations$.prototype.level__T__Lamf_ProfileName__T = (function(id, profile) {
  return $as_T($as_sc_MapLike(this.allLevels__sci_Map().getOrElse__O__F0__O(id, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
    return (function() {
      return $m_Lamf_plugins_features_validation_Validations$().$default__p1__sci_Map()
    })
  })(this)))).getOrElse__O__F0__O(profile, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$2) {
    return (function() {
      return $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1
    })
  })(this))))
});
$c_Lamf_plugins_features_validation_Validations$.prototype.$default__p1__sci_Map = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.default$lzycompute__p1__sci_Map() : this.default$1)
});
$c_Lamf_plugins_features_validation_Validations$.prototype.allLevels__sci_Map = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.allLevels$lzycompute__p1__sci_Map() : this.allLevels$1)
});
$c_Lamf_plugins_features_validation_Validations$.prototype.default$lzycompute__p1__sci_Map = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.default$1 = this.all__T__sci_Map($m_Lamf_core_validation_SeverityLevels$().VIOLATION$1);
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.default$1
});
$c_Lamf_plugins_features_validation_Validations$.prototype.all__T__sci_Map = (function(lvl) {
  var jsx$2 = $m_Lamf_ProfileNames$().specProfiles__sc_Seq();
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, lvl$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_ProfileName(x$1$2);
      return new $c_T2().init___O__O(x$1, lvl$1)
    })
  })(this, lvl));
  var this$3 = $m_sc_Seq$();
  return $as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2)
});
$c_Lamf_plugins_features_validation_Validations$.prototype.allLevels$lzycompute__p1__sci_Map = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    var this$1 = this.validations$1;
    var z = this.levels$1;
    var acc = z;
    var these = this$1;
    while ((!these.isEmpty__Z())) {
      var arg1 = acc;
      var arg2 = these.head__O();
      var acc$1 = $as_sci_Map(arg1);
      var validation = $as_Lamf_core_validation_core_ValidationSpecification(arg2);
      if (acc$1.contains__O__Z(validation.id$1)) {
        acc = acc$1
      } else {
        var self = validation.id$1;
        var y = $m_Lamf_plugins_features_validation_Validations$().$default__p1__sci_Map();
        acc = acc$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, y))
      };
      these = $as_sc_LinearSeqOptimized(these.tail__O())
    };
    this.allLevels$1 = $as_sci_Map(acc);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.allLevels$1
});
var $d_Lamf_plugins_features_validation_Validations$ = new $TypeData().initClass({
  Lamf_plugins_features_validation_Validations$: 0
}, false, "amf.plugins.features.validation.Validations$", {
  Lamf_plugins_features_validation_Validations$: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_plugins_features_validation_Validations$.prototype.$classData = $d_Lamf_plugins_features_validation_Validations$;
var $n_Lamf_plugins_features_validation_Validations$ = (void 0);
function $m_Lamf_plugins_features_validation_Validations$() {
  if ((!$n_Lamf_plugins_features_validation_Validations$)) {
    $n_Lamf_plugins_features_validation_Validations$ = new $c_Lamf_plugins_features_validation_Validations$().init___()
  };
  return $n_Lamf_plugins_features_validation_Validations$
}
/** @constructor */
function $c_Lamf_plugins_features_validation_model_ParsedFunctionConstraint$() {
  $c_O.call(this)
}
$c_Lamf_plugins_features_validation_model_ParsedFunctionConstraint$.prototype = new $h_O();
$c_Lamf_plugins_features_validation_model_ParsedFunctionConstraint$.prototype.constructor = $c_Lamf_plugins_features_validation_model_ParsedFunctionConstraint$;
/** @constructor */
function $h_Lamf_plugins_features_validation_model_ParsedFunctionConstraint$() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_model_ParsedFunctionConstraint$.prototype = $c_Lamf_plugins_features_validation_model_ParsedFunctionConstraint$.prototype;
$c_Lamf_plugins_features_validation_model_ParsedFunctionConstraint$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_features_validation_model_ParsedFunctionConstraint$.prototype.apply__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_core_validation_core_FunctionConstraint = (function(node) {
  return new $c_Lamf_core_validation_core_FunctionConstraint().init___s_Option__s_Option__sc_Seq__s_Option__sc_Seq__s_Option($f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "message"), $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "code"), $f_Lamf_plugins_features_validation_model_DialectWrapper__extractStrings__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__sc_Seq(this, node, "libraries"), $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "functionName"), $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), $m_s_None$())
});
var $d_Lamf_plugins_features_validation_model_ParsedFunctionConstraint$ = new $TypeData().initClass({
  Lamf_plugins_features_validation_model_ParsedFunctionConstraint$: 0
}, false, "amf.plugins.features.validation.model.ParsedFunctionConstraint$", {
  Lamf_plugins_features_validation_model_ParsedFunctionConstraint$: 1,
  O: 1,
  Lamf_plugins_features_validation_model_DialectWrapper: 1
});
$c_Lamf_plugins_features_validation_model_ParsedFunctionConstraint$.prototype.$classData = $d_Lamf_plugins_features_validation_model_ParsedFunctionConstraint$;
var $n_Lamf_plugins_features_validation_model_ParsedFunctionConstraint$ = (void 0);
function $m_Lamf_plugins_features_validation_model_ParsedFunctionConstraint$() {
  if ((!$n_Lamf_plugins_features_validation_model_ParsedFunctionConstraint$)) {
    $n_Lamf_plugins_features_validation_model_ParsedFunctionConstraint$ = new $c_Lamf_plugins_features_validation_model_ParsedFunctionConstraint$().init___()
  };
  return $n_Lamf_plugins_features_validation_model_ParsedFunctionConstraint$
}
/** @constructor */
function $c_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$() {
  $c_O.call(this);
  this.validationNs$1 = null
}
$c_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$.prototype = new $h_O();
$c_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$.prototype.constructor = $c_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$;
/** @constructor */
function $h_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$.prototype = $c_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$.prototype;
$c_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$.prototype.init___ = (function() {
  this.validationNs$1 = "http://a.ml/vocabularies/amf-validation#";
  return this
});
$c_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$.prototype.apply__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__scm_Map__T__s_Option__T__T2 = (function(node, prefixes, nameForNestedValidation, message, nested) {
  var x = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "name");
  var name = $as_T($f_Lamf_plugins_features_validation_model_DialectWrapper__mandatory__T__s_Option__O(this, "name in property constraint", x));
  var path = $m_Lamf_core_validation_model_PropertyPathParser$().apply__T__F1__Lamf_core_validation_model_PropertyPath(name, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, prefixes$1) {
    return (function(s$2) {
      var s = $as_T(s$2);
      var this$1 = $m_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$();
      return $f_Lamf_plugins_features_validation_model_DialectWrapper__expand__T__scm_Map__T(this$1, s, prefixes$1)
    })
  })(this, prefixes)));
  var this$2 = node.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping();
  var this$5 = $as_sc_Seq(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, property) {
    return (function(x$9$2) {
      var x$9 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$9$2);
      var this$3 = $as_Lamf_core_model_StrField(x$9.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
      var this$4 = this$3.option$1;
      return ($as_T((this$4.isEmpty__Z() ? null : this$4.get__O())) === property)
    })
  })(this, "nested")));
  if (this$5.isEmpty__Z()) {
    var this$7 = $m_s_None$()
  } else {
    var arg1 = this$5.get__O();
    var p = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(arg1);
    var this$6 = node.objectProperty__Lamf_core_metamodel_Field__s_Option(p.toField__Lamf_core_metamodel_Field());
    if (this$6.isEmpty__Z()) {
      var this$7 = $m_s_None$()
    } else {
      var arg1$1 = this$6.get__O();
      var x$12 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(arg1$1);
      var this$7 = new $c_s_Some().init___O($m_Lamf_plugins_features_validation_model_ParsedValidationSpecification$().apply__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__scm_Map__s_Option__s_Option__s_Option__s_Option__T2(x$12, prefixes, new $c_s_Some().init___O((nameForNestedValidation + "_nested_node")), message, $m_s_None$(), new $c_s_Some().init___O(nested)))
    }
  };
  if (this$7.isEmpty__Z()) {
    var this$10 = $m_s_None$()
  } else {
    var arg1$2 = this$7.get__O();
    var x0$1 = $as_T2(arg1$2);
    if ((x0$1 === null)) {
      throw new $c_s_MatchError().init___O(x0$1)
    };
    var v = $as_Lamf_core_validation_core_ValidationSpecification(x0$1.$$und1__O());
    var nested$1 = $as_sc_Seq(x0$1.$$und2__O());
    var jsx$1 = $m_sc_Seq$();
    var array = [v];
    var this$10 = new $c_s_Some().init___O(new $c_T2().init___O__O(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)), nested$1))
  };
  var x1 = $as_T2((this$10.isEmpty__Z() ? new $c_T2().init___O__O($m_sci_Nil$(), $m_sci_Nil$()) : this$10.get__O()));
  if ((x1 === null)) {
    throw new $c_s_MatchError().init___O(x1)
  };
  var nestedNode = $as_sc_Seq(x1.$$und1__O());
  var nestedConstraints = $as_sc_Seq(x1.$$und2__O());
  var this$11 = node.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping();
  var this$14 = $as_sc_Seq(this$11.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, property$1) {
    return (function(x$9$2$1) {
      var x$9$1 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$9$2$1);
      var this$12 = $as_Lamf_core_model_StrField(x$9$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
      var this$13 = this$12.option$1;
      return ($as_T((this$13.isEmpty__Z() ? null : this$13.get__O())) === property$1)
    })
  })(this, "atLeast")));
  if (this$14.isEmpty__Z()) {
    var atLeastTuple = $m_s_None$()
  } else {
    var arg1$3 = this$14.get__O();
    var p$1 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(arg1$3);
    var this$15 = node.objectProperty__Lamf_core_metamodel_Field__s_Option(p$1.toField__Lamf_core_metamodel_Field());
    if (this$15.isEmpty__Z()) {
      var atLeastTuple = $m_s_None$()
    } else {
      var arg1$4 = this$15.get__O();
      var x$14 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(arg1$4);
      var atLeastTuple = new $c_s_Some().init___O($m_Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$().apply__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__scm_Map__s_Option__s_Option__s_Option__s_Option__T3(x$14, prefixes, new $c_s_Some().init___O((((nameForNestedValidation + "_") + name) + "_atLeast_")), message, $m_s_None$(), new $c_s_Some().init___O(nested)))
    }
  };
  var this$16 = node.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping();
  var this$19 = $as_sc_Seq(this$16.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, property$2) {
    return (function(x$9$2$2) {
      var x$9$3 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$9$2$2);
      var this$17 = $as_Lamf_core_model_StrField(x$9$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
      var this$18 = this$17.option$1;
      return ($as_T((this$18.isEmpty__Z() ? null : this$18.get__O())) === property$2)
    })
  })(this, "atMost")));
  if (this$19.isEmpty__Z()) {
    var atMostTuple = $m_s_None$()
  } else {
    var arg1$5 = this$19.get__O();
    var p$2 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(arg1$5);
    var this$20 = node.objectProperty__Lamf_core_metamodel_Field__s_Option(p$2.toField__Lamf_core_metamodel_Field());
    if (this$20.isEmpty__Z()) {
      var atMostTuple = $m_s_None$()
    } else {
      var arg1$6 = this$20.get__O();
      var x$15 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(arg1$6);
      var atMostTuple = new $c_s_Some().init___O($m_Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$().apply__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__scm_Map__s_Option__s_Option__s_Option__s_Option__T3(x$15, prefixes, new $c_s_Some().init___O((((nameForNestedValidation + "_") + name) + "_atLeast_")), message, $m_s_None$(), new $c_s_Some().init___O(nested)))
    }
  };
  var x$1 = new $c_s_Some().init___O(name);
  var value = $as_T($f_Lamf_plugins_features_validation_model_DialectWrapper__mandatory__T__s_Option__O(this, "ramlID in property constraint", x$1));
  var x$1$1 = $f_Lamf_plugins_features_validation_model_DialectWrapper__expand__T__scm_Map__T(this, value, prefixes);
  var x$3 = new $c_s_Some().init___O(path);
  var x$4 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "message");
  var x$5 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "pattern");
  var x$6 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "maxCount");
  var x$7 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "minCount");
  var x$8 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "maxLength");
  var x$9$4 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "minLength");
  var x$10 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "maxExclusive");
  var x$11 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "minExclusive");
  var x$12$3 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "maxInclusive");
  var x$13$2 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "minInclusive");
  var x$14$3 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractStrings__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__sc_Seq(this, node, "in");
  var this$21 = nestedNode.headOption__s_Option();
  if (this$21.isEmpty__Z()) {
    var x$15$3 = $m_s_None$()
  } else {
    var arg1$7 = this$21.get__O();
    var x$16 = $as_Lamf_core_validation_core_ValidationSpecification(arg1$7);
    var x$15$3 = new $c_s_Some().init___O(x$16.id$1)
  };
  var this$22 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "equalsToProperty");
  if (this$22.isEmpty__Z()) {
    var x$16$3 = $m_s_None$()
  } else {
    var arg1$8 = this$22.get__O();
    var s$3 = $as_T(arg1$8);
    var this$23 = $m_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$();
    var x$16$3 = new $c_s_Some().init___O($f_Lamf_plugins_features_validation_model_DialectWrapper__expand__T__scm_Map__T(this$23, s$3, prefixes))
  };
  var this$24 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "disjointWithProperty");
  if (this$24.isEmpty__Z()) {
    var x$17 = $m_s_None$()
  } else {
    var arg1$9 = this$24.get__O();
    var s$4 = $as_T(arg1$9);
    var this$25 = $m_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$();
    var x$17 = new $c_s_Some().init___O($f_Lamf_plugins_features_validation_model_DialectWrapper__expand__T__scm_Map__T(this$25, s$4, prefixes))
  };
  var this$26 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "lessThanProperty");
  if (this$26.isEmpty__Z()) {
    var x$18 = $m_s_None$()
  } else {
    var arg1$10 = this$26.get__O();
    var s$5 = $as_T(arg1$10);
    var this$27 = $m_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$();
    var x$18 = new $c_s_Some().init___O($f_Lamf_plugins_features_validation_model_DialectWrapper__expand__T__scm_Map__T(this$27, s$5, prefixes))
  };
  var this$28 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "lessThanOrEqualsToProperty");
  if (this$28.isEmpty__Z()) {
    var x$19 = $m_s_None$()
  } else {
    var arg1$11 = this$28.get__O();
    var s$6 = $as_T(arg1$11);
    var this$29 = $m_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$();
    var x$19 = new $c_s_Some().init___O($f_Lamf_plugins_features_validation_model_DialectWrapper__expand__T__scm_Map__T(this$29, s$6, prefixes))
  };
  if (atLeastTuple.isEmpty__Z()) {
    var x$20 = $m_s_None$()
  } else {
    var arg1$12 = atLeastTuple.get__O();
    var t = $as_T3(arg1$12);
    var x$20 = new $c_s_Some().init___O(new $c_T2().init___O__O(t.$$und1$1, $as_Lamf_core_validation_core_ValidationSpecification(t.$$und2$1).id$1))
  };
  if (atMostTuple.isEmpty__Z()) {
    var x$21 = $m_s_None$()
  } else {
    var arg1$13 = atMostTuple.get__O();
    var t$3 = $as_T3(arg1$13);
    var x$21 = new $c_s_Some().init___O(new $c_T2().init___O__O(t$3.$$und1$1, $as_Lamf_core_validation_core_ValidationSpecification(t$3.$$und2$1).id$1))
  };
  var x$22 = $m_s_None$();
  var x$23 = $m_s_None$();
  var x$24 = $m_s_None$();
  var x$25 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var x$26 = $m_s_None$();
  var x$27 = $m_s_None$();
  var x$28 = $m_s_None$();
  var property$3 = new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$1$1, name, x$3, x$4, x$5, x$22, x$6, x$7, x$9$4, x$8, x$11, x$10, x$13$2, x$12$3, x$23, x$15$3, x$24, x$25, x$14$3, x$26, x$27, x$20, x$21, x$28, x$16$3, x$17, x$18, x$19);
  if (atLeastTuple.isEmpty__Z()) {
    var this$39 = $m_s_None$()
  } else {
    var arg1$14 = atLeastTuple.get__O();
    var t$4 = $as_T3(arg1$14);
    var jsx$4 = $m_sc_Seq$();
    var array$1 = [$as_Lamf_core_validation_core_ValidationSpecification(t$4.$$und2$1)];
    var this$39 = new $c_s_Some().init___O($as_sc_Seq(jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1))))
  };
  var jsx$3 = $as_sc_TraversableLike((this$39.isEmpty__Z() ? $m_sci_Nil$() : this$39.get__O()));
  if (atLeastTuple.isEmpty__Z()) {
    var this$40 = $m_s_None$()
  } else {
    var arg1$15 = atLeastTuple.get__O();
    var x$17$2 = $as_T3(arg1$15);
    var this$40 = new $c_s_Some().init___O($as_sc_Seq(x$17$2.$$und3$1))
  };
  var jsx$2 = $as_sc_GenTraversableOnce((this$40.isEmpty__Z() ? $m_sci_Nil$() : this$40.get__O()));
  var this$41 = $m_sc_Seq$();
  var atLeastAcc = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$41.ReusableCBFInstance$2));
  if (atMostTuple.isEmpty__Z()) {
    var this$44 = $m_s_None$()
  } else {
    var arg1$16 = atMostTuple.get__O();
    var t$5 = $as_T3(arg1$16);
    var jsx$7 = $m_sc_Seq$();
    var array$2 = [$as_Lamf_core_validation_core_ValidationSpecification(t$5.$$und2$1)];
    var this$44 = new $c_s_Some().init___O($as_sc_Seq(jsx$7.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2))))
  };
  var jsx$6 = $as_sc_TraversableLike((this$44.isEmpty__Z() ? $m_sci_Nil$() : this$44.get__O()));
  if (atMostTuple.isEmpty__Z()) {
    var this$45 = $m_s_None$()
  } else {
    var arg1$17 = atMostTuple.get__O();
    var x$18$2 = $as_T3(arg1$17);
    var this$45 = new $c_s_Some().init___O($as_sc_Seq(x$18$2.$$und3$1))
  };
  var jsx$5 = $as_sc_GenTraversableOnce((this$45.isEmpty__Z() ? $m_sci_Nil$() : this$45.get__O()));
  var this$46 = $m_sc_Seq$();
  var atLMostAcc = $as_sc_Seq(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$5, this$46.ReusableCBFInstance$2));
  var this$47 = $m_sc_Seq$();
  var jsx$9 = $as_sc_TraversableLike(nestedNode.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(nestedConstraints, this$47.ReusableCBFInstance$2));
  var this$48 = $m_sc_Seq$();
  var jsx$8 = $as_sc_TraversableLike(jsx$9.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(atLeastAcc, this$48.ReusableCBFInstance$2));
  var this$49 = $m_sc_Seq$();
  return new $c_T2().init___O__O(property$3, jsx$8.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(atLMostAcc, this$49.ReusableCBFInstance$2))
});
var $d_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$ = new $TypeData().initClass({
  Lamf_plugins_features_validation_model_ParsedPropertyConstraint$: 0
}, false, "amf.plugins.features.validation.model.ParsedPropertyConstraint$", {
  Lamf_plugins_features_validation_model_ParsedPropertyConstraint$: 1,
  O: 1,
  Lamf_plugins_features_validation_model_DialectWrapper: 1
});
$c_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$.prototype.$classData = $d_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$;
var $n_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$ = (void 0);
function $m_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$() {
  if ((!$n_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$)) {
    $n_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$ = new $c_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$().init___()
  };
  return $n_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$
}
/** @constructor */
function $c_Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$() {
  $c_O.call(this)
}
$c_Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$.prototype = new $h_O();
$c_Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$.prototype.constructor = $c_Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$;
/** @constructor */
function $h_Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$.prototype = $c_Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$.prototype;
$c_Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$.prototype.apply__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__scm_Map__s_Option__s_Option__s_Option__s_Option__T3 = (function(node, prefixes, nameForNestedValidation, message, targetClassForNestedValidation, nested) {
  var x = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractInt__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "count");
  var count = $uI($f_Lamf_plugins_features_validation_model_DialectWrapper__mandatory__T__s_Option__O(this, "count missing in qualified validation specification", x));
  var this$1 = node.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping();
  var this$4 = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, property) {
    return (function(x$9$2) {
      var x$9 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$9$2);
      var this$2 = $as_Lamf_core_model_StrField(x$9.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
      var this$3 = this$2.option$1;
      return ($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())) === property)
    })
  })(this, "validation")));
  if (this$4.isEmpty__Z()) {
    var jsx$1 = $m_s_None$()
  } else {
    var arg1 = this$4.get__O();
    var p = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(arg1);
    var this$5 = node.objectProperty__Lamf_core_metamodel_Field__s_Option(p.toField__Lamf_core_metamodel_Field());
    if (this$5.isEmpty__Z()) {
      var jsx$1 = $m_s_None$()
    } else {
      var arg1$1 = this$5.get__O();
      var x$19 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(arg1$1);
      var jsx$1 = new $c_s_Some().init___O($m_Lamf_plugins_features_validation_model_ParsedValidationSpecification$().apply__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__scm_Map__s_Option__s_Option__s_Option__s_Option__T2(x$19, prefixes, nameForNestedValidation, message, $m_s_None$(), nested))
    }
  };
  var x1 = $as_T2(jsx$1.get__O());
  if ((x1 === null)) {
    throw new $c_s_MatchError().init___O(x1)
  };
  var validation = $as_Lamf_core_validation_core_ValidationSpecification(x1.$$und1__O());
  var nestedValidations = $as_sc_Seq(x1.$$und2__O());
  return new $c_T3().init___O__O__O(count, validation, nestedValidations)
});
var $d_Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$ = new $TypeData().initClass({
  Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$: 0
}, false, "amf.plugins.features.validation.model.ParsedQualifiedValidationSpecification$", {
  Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$: 1,
  O: 1,
  Lamf_plugins_features_validation_model_DialectWrapper: 1
});
$c_Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$.prototype.$classData = $d_Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$;
var $n_Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$ = (void 0);
function $m_Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$() {
  if ((!$n_Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$)) {
    $n_Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$ = new $c_Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$().init___()
  };
  return $n_Lamf_plugins_features_validation_model_ParsedQualifiedValidationSpecification$
}
/** @constructor */
function $c_Lamf_plugins_features_validation_model_ParsedQueryConstraint$() {
  $c_O.call(this)
}
$c_Lamf_plugins_features_validation_model_ParsedQueryConstraint$.prototype = new $h_O();
$c_Lamf_plugins_features_validation_model_ParsedQueryConstraint$.prototype.constructor = $c_Lamf_plugins_features_validation_model_ParsedQueryConstraint$;
/** @constructor */
function $h_Lamf_plugins_features_validation_model_ParsedQueryConstraint$() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_model_ParsedQueryConstraint$.prototype = $c_Lamf_plugins_features_validation_model_ParsedQueryConstraint$.prototype;
$c_Lamf_plugins_features_validation_model_ParsedQueryConstraint$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_features_validation_model_ParsedQueryConstraint$.prototype.apply__T__scm_Map__Lamf_core_validation_core_QueryConstraint = (function(query, prefixes) {
  var ev = $m_s_Predef$().singleton$und$less$colon$less$2;
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  prefixes.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$1, ev$1) {
    return (function(x$2) {
      return b$1.$$plus$eq__O__scm_Builder(x$2)
    })
  })(prefixes, b, ev)));
  var ns = $as_sci_Map(b.elems$1);
  return new $c_Lamf_core_validation_core_QueryConstraint().init___sci_Map__T(ns, query)
});
var $d_Lamf_plugins_features_validation_model_ParsedQueryConstraint$ = new $TypeData().initClass({
  Lamf_plugins_features_validation_model_ParsedQueryConstraint$: 0
}, false, "amf.plugins.features.validation.model.ParsedQueryConstraint$", {
  Lamf_plugins_features_validation_model_ParsedQueryConstraint$: 1,
  O: 1,
  Lamf_plugins_features_validation_model_DialectWrapper: 1
});
$c_Lamf_plugins_features_validation_model_ParsedQueryConstraint$.prototype.$classData = $d_Lamf_plugins_features_validation_model_ParsedQueryConstraint$;
var $n_Lamf_plugins_features_validation_model_ParsedQueryConstraint$ = (void 0);
function $m_Lamf_plugins_features_validation_model_ParsedQueryConstraint$() {
  if ((!$n_Lamf_plugins_features_validation_model_ParsedQueryConstraint$)) {
    $n_Lamf_plugins_features_validation_model_ParsedQueryConstraint$ = new $c_Lamf_plugins_features_validation_model_ParsedQueryConstraint$().init___()
  };
  return $n_Lamf_plugins_features_validation_model_ParsedQueryConstraint$
}
/** @constructor */
function $c_Lamf_plugins_features_validation_model_ParsedValidationProfile$() {
  $c_O.call(this)
}
$c_Lamf_plugins_features_validation_model_ParsedValidationProfile$.prototype = new $h_O();
$c_Lamf_plugins_features_validation_model_ParsedValidationProfile$.prototype.constructor = $c_Lamf_plugins_features_validation_model_ParsedValidationProfile$;
/** @constructor */
function $h_Lamf_plugins_features_validation_model_ParsedValidationProfile$() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_model_ParsedValidationProfile$.prototype = $c_Lamf_plugins_features_validation_model_ParsedValidationProfile$.prototype;
$c_Lamf_plugins_features_validation_model_ParsedValidationProfile$.prototype.collectValidations__sc_Seq__sc_Seq = (function(nestedValidations) {
  return $as_sc_Seq(nestedValidations.foldLeft__O__F2__O($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(x0$1$2, x1$1$2) {
      var x0$1 = $as_sc_Seq(x0$1$2);
      var x1$1 = $as_T2(x1$1$2);
      var x1 = new $c_T2().init___O__O(x0$1, x1$1);
      var validationsAcc = $as_sc_Seq(x1.$$und1$f);
      var p2 = $as_T2(x1.$$und2$f);
      if ((p2 !== null)) {
        var validation = $as_Lamf_core_validation_core_ValidationSpecification(p2.$$und1__O());
        var nested = $as_sc_Seq(p2.$$und2__O());
        var jsx$3 = $m_sc_Seq$();
        var array = [validation];
        var jsx$2 = jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
        var this$3 = $m_sc_Seq$();
        var jsx$1 = $as_sc_TraversableLike(validationsAcc.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$3.ReusableCBFInstance$2));
        var this$4 = $m_sc_Seq$();
        return $as_sc_Seq(jsx$1.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(nested, this$4.ReusableCBFInstance$2))
      };
      throw new $c_s_MatchError().init___O(x1)
    })
  })(this))))
});
$c_Lamf_plugins_features_validation_model_ParsedValidationProfile$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_features_validation_model_ParsedValidationProfile$.prototype.deref__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(v) {
  var x1 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(v);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var linked = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    if ((linked instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
      var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(linked);
      var this$1 = v.fields$1;
      var this$4 = this$1.fs$1;
      var this$2 = $m_Lamf_core_parser_FieldEntry$();
      var f = $f_F2__tupled__F1(this$2);
      var this$3 = $m_sci_Iterable$();
      var bf = this$3.ReusableCBFInstance$2;
      var nameFieldEntry = $as_Lamf_core_parser_FieldEntry($as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$4, f, bf)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x$33$2) {
          var x$33 = $as_Lamf_core_parser_FieldEntry(x$33$2);
          return (x$33.field$1.value$1.name$1 === "name")
        })
      })(this))).get__O());
      var nameValue = $as_T($as_Lamf_core_model_domain_AmfScalar(nameFieldEntry.value$1.value$1).value$1);
      var field = nameFieldEntry.field$1;
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x3, field, nameValue);
      return x3
    }
  };
  return v
});
$c_Lamf_plugins_features_validation_model_ParsedValidationProfile$.prototype.apply__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_core_validation_core_ValidationProfile = (function(node) {
  var prfx = $f_Lamf_plugins_features_validation_model_DialectWrapper__prefixes__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__scm_Map(this, node);
  var jsx$7 = $m_Lamf_ProfileName$();
  var x = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "profile");
  var jsx$6 = jsx$7.apply__T__Lamf_ProfileName($as_T($f_Lamf_plugins_features_validation_model_DialectWrapper__mandatory__T__s_Option__O(this, "profile in validation profile", x)));
  var this$1 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "extends");
  if (this$1.isEmpty__Z()) {
    var jsx$5 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var profile = $as_T(arg1);
    var jsx$5 = new $c_s_Some().init___O($m_Lamf_ProfileName$().apply__T__Lamf_ProfileName(profile))
  };
  var jsx$4 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractStrings__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__sc_Seq(this, node, "violation");
  var jsx$3 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractStrings__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__sc_Seq(this, node, "info");
  var jsx$2 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractStrings__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__sc_Seq(this, node, "warning");
  var jsx$1 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractStrings__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__sc_Seq(this, node, "disabled");
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, prfx$1) {
    return (function(v$2) {
      var v = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(v$2);
      return $m_Lamf_plugins_features_validation_model_ParsedValidationSpecification$().apply__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__scm_Map__s_Option__s_Option__s_Option__s_Option__T2($m_Lamf_plugins_features_validation_model_ParsedValidationProfile$().deref__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(v), prfx$1, $m_s_None$(), $m_s_None$(), $m_s_None$(), $m_s_None$())
    })
  })(this, prfx));
  return new $c_Lamf_core_validation_core_ValidationProfile().init___Lamf_ProfileName__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__scm_Map(jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, jsx$1, this.collectValidations__sc_Seq__sc_Seq($f_Lamf_plugins_features_validation_model_DialectWrapper__mapEntities__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__F1__sc_Seq(this, node, "validations", f)), prfx)
});
var $d_Lamf_plugins_features_validation_model_ParsedValidationProfile$ = new $TypeData().initClass({
  Lamf_plugins_features_validation_model_ParsedValidationProfile$: 0
}, false, "amf.plugins.features.validation.model.ParsedValidationProfile$", {
  Lamf_plugins_features_validation_model_ParsedValidationProfile$: 1,
  O: 1,
  Lamf_plugins_features_validation_model_DialectWrapper: 1
});
$c_Lamf_plugins_features_validation_model_ParsedValidationProfile$.prototype.$classData = $d_Lamf_plugins_features_validation_model_ParsedValidationProfile$;
var $n_Lamf_plugins_features_validation_model_ParsedValidationProfile$ = (void 0);
function $m_Lamf_plugins_features_validation_model_ParsedValidationProfile$() {
  if ((!$n_Lamf_plugins_features_validation_model_ParsedValidationProfile$)) {
    $n_Lamf_plugins_features_validation_model_ParsedValidationProfile$ = new $c_Lamf_plugins_features_validation_model_ParsedValidationProfile$().init___()
  };
  return $n_Lamf_plugins_features_validation_model_ParsedValidationProfile$
}
/** @constructor */
function $c_Lamf_plugins_features_validation_model_ParsedValidationSpecification$() {
  $c_O.call(this)
}
$c_Lamf_plugins_features_validation_model_ParsedValidationSpecification$.prototype = new $h_O();
$c_Lamf_plugins_features_validation_model_ParsedValidationSpecification$.prototype.constructor = $c_Lamf_plugins_features_validation_model_ParsedValidationSpecification$;
/** @constructor */
function $h_Lamf_plugins_features_validation_model_ParsedValidationSpecification$() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_model_ParsedValidationSpecification$.prototype = $c_Lamf_plugins_features_validation_model_ParsedValidationSpecification$.prototype;
$c_Lamf_plugins_features_validation_model_ParsedValidationSpecification$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_features_validation_model_ParsedValidationSpecification$.prototype.collectNestedValidations__sc_Seq__T2 = (function(nestedValidations) {
  return $as_T2(nestedValidations.foldLeft__O__F2__O(new $c_T2().init___O__O($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()), $m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(x0$1$2, x1$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      var x1$1 = $as_T2(x1$1$2);
      var x1 = new $c_T2().init___O__O(x0$1, x1$1);
      var p2 = $as_T2(x1.$$und1$f);
      var p3 = $as_T2(x1.$$und2$f);
      if ((p2 !== null)) {
        var validationsAcc = $as_sc_Seq(p2.$$und1__O());
        var nestedAcc = $as_sc_Seq(p2.$$und2__O());
        if ((p3 !== null)) {
          var validation = $as_Lamf_core_validation_core_ValidationSpecification(p3.$$und1__O());
          var nested = $as_sc_Seq(p3.$$und2__O());
          var jsx$3 = $m_sc_Seq$();
          var array = [validation];
          var jsx$2 = jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
          var this$3 = $m_sc_Seq$();
          var jsx$1 = validationsAcc.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$3.ReusableCBFInstance$2);
          var this$4 = $m_sc_Seq$();
          return new $c_T2().init___O__O(jsx$1, nestedAcc.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(nested, this$4.ReusableCBFInstance$2))
        }
      };
      throw new $c_s_MatchError().init___O(x1)
    })
  })(this))))
});
$c_Lamf_plugins_features_validation_model_ParsedValidationSpecification$.prototype.apply__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__scm_Map__s_Option__s_Option__s_Option__s_Option__T2 = (function(node, prefixes, nameForNestedValidation, message, targetClassForNestedValidation, nested) {
  if (nameForNestedValidation.isEmpty__Z()) {
    var this$2 = $m_Lamf_plugins_features_validation_model_ParsedValidationSpecification$();
    var this$1 = $m_Lamf_plugins_features_validation_model_ParsedValidationSpecification$();
    var x = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this$1, node, "name");
    var jsx$1 = $as_T($f_Lamf_plugins_features_validation_model_DialectWrapper__mandatory__T__s_Option__O(this$2, "name in validation specification", x))
  } else {
    var jsx$1 = nameForNestedValidation.get__O()
  };
  var name = $as_T(jsx$1);
  if (targetClassForNestedValidation.isEmpty__Z()) {
    var this$3 = $m_Lamf_plugins_features_validation_model_ParsedValidationSpecification$();
    var jsx$4 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractStrings__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__sc_Seq(this$3, node, "targetClass");
    var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, prefixes$3) {
      return (function(x$21$2) {
        var x$21 = $as_T(x$21$2);
        var this$4 = $m_Lamf_plugins_features_validation_model_ParsedValidationSpecification$();
        return $f_Lamf_plugins_features_validation_model_DialectWrapper__expand__T__scm_Map__T(this$4, x$21, prefixes$3)
      })
    })(this, prefixes));
    var this$5 = $m_sc_Seq$();
    var jsx$2 = $as_sc_Seq(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$5.ReusableCBFInstance$2))
  } else {
    var jsx$2 = targetClassForNestedValidation.get__O()
  };
  var targetClasses = $as_sc_Seq(jsx$2);
  if (message.isEmpty__Z()) {
    var this$6 = $m_Lamf_plugins_features_validation_model_ParsedValidationSpecification$();
    var this$7 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this$6, node, "message");
    var jsx$5 = $as_T((this$7.isEmpty__Z() ? ("Unsatisfied constraint " + name) : this$7.get__O()))
  } else {
    var jsx$5 = message.get__O()
  };
  var finalMessage = $as_T(jsx$5);
  var finalNested = new $c_s_Some().init___O((nested.isEmpty__Z() ? name : nested.get__O()));
  var f = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$5$1, prefixes$1, name$1, finalMessage$1, finalNested$1) {
    return (function(x0$1$2, x1$1$2) {
      var x0$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x0$1$2);
      var x1$1 = $uI(x1$1$2);
      return $m_Lamf_plugins_features_validation_model_ParsedPropertyConstraint$().apply__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__scm_Map__T__s_Option__T__T2(x0$1, prefixes$1, ((name$1 + "_prop") + x1$1), new $c_s_Some().init___O(finalMessage$1), $as_T(finalNested$1.get__O()))
    })
  })(this, prefixes, name, finalMessage, finalNested));
  var propsTuples = $f_Lamf_plugins_features_validation_model_DialectWrapper__mapIndexedEntities__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__F2__sc_Seq(this, node, "propertyConstraints", f);
  var jsx$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1) {
    return (function(x$22$2) {
      var x$22 = $as_T2(x$22$2);
      return $as_Lamf_core_validation_core_PropertyConstraint(x$22.$$und1__O())
    })
  })(this));
  var this$8 = $m_sc_Seq$();
  var propertyConstraints = $as_sc_Seq(propsTuples.map__F1__scg_CanBuildFrom__O(jsx$6, this$8.ReusableCBFInstance$2));
  var jsx$7 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$7$1) {
    return (function(x$23$2) {
      var x$23 = $as_T2(x$23$2);
      return $as_sc_Seq(x$23.$$und2__O())
    })
  })(this));
  var this$9 = $m_sc_Seq$();
  var nestedProperties = $as_sc_Seq(propsTuples.flatMap__F1__scg_CanBuildFrom__O(jsx$7, this$9.ReusableCBFInstance$2));
  var jsx$12 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractStrings__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__sc_Seq(this, node, "classConstraints");
  var jsx$11 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$8$1, prefixes$2) {
    return (function(s$2) {
      var s = $as_T(s$2);
      var this$10 = $m_Lamf_plugins_features_validation_model_ParsedValidationSpecification$();
      return $f_Lamf_plugins_features_validation_model_DialectWrapper__expand__T__scm_Map__T(this$10, s, prefixes$2)
    })
  })(this, prefixes));
  var this$11 = $m_sc_Seq$();
  var jsx$10 = $as_sc_IterableLike(jsx$12.map__F1__scg_CanBuildFrom__O(jsx$11, this$11.ReusableCBFInstance$2));
  var this$12 = $m_sc_Seq$();
  var jsx$9 = $as_sc_TraversableLike(jsx$10.zipWithIndex__scg_CanBuildFrom__O(this$12.ReusableCBFInstance$2));
  var jsx$8 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$9$1, prefixes$4) {
    return (function(x0$2$2) {
      var x0$2 = $as_T2(x0$2$2);
      if ((x0$2 !== null)) {
        var id = $as_T(x0$2.$$und1__O());
        var i = x0$2.$$und2$mcI$sp__I();
        var this$13 = $m_Lamf_plugins_features_validation_model_ParsedValidationSpecification$();
        var x$1 = $f_Lamf_plugins_features_validation_model_DialectWrapper__expand__T__scm_Map__T(this$13, "rdf.type", prefixes$4);
        var x$2 = ("rdf.type_" + i);
        var x$3 = new $c_s_Some().init___O($m_Lamf_core_validation_model_PropertyPathParser$().apply__T__F1__Lamf_core_validation_model_PropertyPath("rdf.type", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, prefixes$3$1) {
          return (function(s$2$1) {
            var s$1 = $as_T(s$2$1);
            var this$14 = $m_Lamf_plugins_features_validation_model_ParsedValidationSpecification$();
            return $f_Lamf_plugins_features_validation_model_DialectWrapper__expand__T__scm_Map__T(this$14, s$1, prefixes$3$1)
          })
        })(this$9$1, prefixes$4))));
        var this$15 = $m_Lamf_plugins_features_validation_model_ParsedValidationSpecification$();
        var x$4 = new $c_s_Some().init___O($f_Lamf_plugins_features_validation_model_DialectWrapper__expand__T__scm_Map__T(this$15, id, prefixes$4));
        var x$5 = $m_s_None$();
        var x$6 = $m_s_None$();
        var x$7 = $m_s_None$();
        var x$8 = $m_s_None$();
        var x$9 = $m_s_None$();
        var x$10 = $m_s_None$();
        var x$11 = $m_s_None$();
        var x$12 = $m_s_None$();
        var x$13 = $m_s_None$();
        var x$14 = $m_s_None$();
        var x$15 = $m_s_None$();
        var x$16 = $m_s_None$();
        var x$17 = $m_s_None$();
        var x$18 = $m_s_None$();
        var x$19 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$34 = new $c_scm_ListBuffer().init___();
        var x$20 = this$34.toList__sci_List();
        var x$21$1 = $m_s_None$();
        var x$22$1 = $m_s_None$();
        var x$23$1 = $m_s_None$();
        var x$24 = $m_s_None$();
        var x$25 = $m_s_None$();
        var x$26 = $m_s_None$();
        var x$27 = $m_s_None$();
        var x$28 = $m_s_None$();
        return new $c_Lamf_core_validation_core_PropertyConstraint().init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$1, x$2, x$3, x$5, x$6, x$7, x$8, x$9, x$10, x$11, x$12, x$13, x$14, x$15, x$16, x$17, x$18, x$19, x$20, x$21$1, x$22$1, x$23$1, x$24, x$4, x$25, x$26, x$27, x$28)
      } else {
        throw new $c_s_MatchError().init___O(x0$2)
      }
    })
  })(this, prefixes));
  var this$43 = $m_sc_Seq$();
  var additionalPropertyConstraints = $as_sc_Seq(jsx$9.map__F1__scg_CanBuildFrom__O(jsx$8, this$43.ReusableCBFInstance$2));
  var this$44 = $f_Lamf_plugins_features_validation_model_DialectWrapper__extractString__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__s_Option(this, node, "query");
  if (this$44.isEmpty__Z()) {
    var queryConstraint = $m_s_None$()
  } else {
    var arg1 = this$44.get__O();
    var query = $as_T(arg1);
    var queryConstraint = new $c_s_Some().init___O($m_Lamf_plugins_features_validation_model_ParsedQueryConstraint$().apply__T__scm_Map__Lamf_core_validation_core_QueryConstraint(query, prefixes))
  };
  var this$45 = $m_sc_Seq$();
  var x$32 = $as_sc_Seq(propertyConstraints.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(additionalPropertyConstraints, this$45.ReusableCBFInstance$2));
  var this$46 = node.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping();
  var this$49 = $as_sc_Seq(this$46.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, property) {
    return (function(x$9$2) {
      var x$9$1 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$9$2);
      var this$47 = $as_Lamf_core_model_StrField(x$9$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
      var this$48 = this$47.option$1;
      return ($as_T((this$48.isEmpty__Z() ? null : this$48.get__O())) === property)
    })
  })(this, "functionConstraint")));
  if (this$49.isEmpty__Z()) {
    var x$33 = $m_s_None$()
  } else {
    var arg1$1 = this$49.get__O();
    var p = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(arg1$1);
    var this$50 = node.objectProperty__Lamf_core_metamodel_Field__s_Option(p.toField__Lamf_core_metamodel_Field());
    if (this$50.isEmpty__Z()) {
      var x$33 = $m_s_None$()
    } else {
      var arg1$2 = this$50.get__O();
      var node$2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(arg1$2);
      var x$33 = new $c_s_Some().init___O($m_Lamf_plugins_features_validation_model_ParsedFunctionConstraint$().apply__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_core_validation_core_FunctionConstraint(node$2))
    }
  };
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$36 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$37 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$56 = new $c_scm_ListBuffer().init___();
  var x$38 = this$56.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$60 = new $c_scm_ListBuffer().init___();
  var x$39 = this$60.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$64 = new $c_scm_ListBuffer().init___();
  var x$40 = this$64.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$68 = new $c_scm_ListBuffer().init___();
  var x$41 = this$68.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$72 = new $c_scm_ListBuffer().init___();
  var x$42 = this$72.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$43 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$77 = new $c_scm_ListBuffer().init___();
  var x$44 = this$77.toList__sci_List();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$45 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$46 = $m_s_None$();
  $m_Lamf_core_validation_core_ValidationSpecification$();
  var x$47 = $m_s_None$();
  var base = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(name, finalMessage, x$36, x$37, x$38, targetClasses, x$39, x$40, x$41, x$42, x$43, x$32, x$44, x$45, x$33, x$46, nested, x$47, queryConstraint);
  var f$1 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$12$1, prefixes$5, name$2, finalMessage$2, finalNested$2) {
    return (function(x0$3$2, x1$2$2) {
      var x0$3 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x0$3$2);
      var x1$2 = $uI(x1$2$2);
      var x1 = new $c_T2().init___O__O(x0$3, x1$2);
      var n = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x1.$$und1$f);
      var i$1 = $uI(x1.$$und2$f);
      if ((n !== null)) {
        return $m_Lamf_plugins_features_validation_model_ParsedValidationSpecification$().apply__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__scm_Map__s_Option__s_Option__s_Option__s_Option__T2(n, prefixes$5, new $c_s_Some().init___O(((name$2 + "_and_") + i$1)), new $c_s_Some().init___O(finalMessage$2), $m_s_None$(), finalNested$2)
      };
      throw new $c_s_MatchError().init___O(x1)
    })
  })(this, prefixes, name, finalMessage, finalNested));
  var x1$3 = this.collectNestedValidations__sc_Seq__T2($f_Lamf_plugins_features_validation_model_DialectWrapper__mapIndexedEntities__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__F2__sc_Seq(this, node, "and", f$1));
  if ((x1$3 === null)) {
    throw new $c_s_MatchError().init___O(x1$3)
  };
  var andConstraints = $as_sc_Seq(x1$3.$$und1__O());
  var nestedAndConstraints = $as_sc_Seq(x1$3.$$und2__O());
  var f$2 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$13$1, prefixes$6, name$3, finalMessage$3, finalNested$3) {
    return (function(x0$4$2, x1$3$2) {
      var x0$4 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x0$4$2);
      var x1$3$1 = $uI(x1$3$2);
      var x1$4 = new $c_T2().init___O__O(x0$4, x1$3$1);
      var n$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x1$4.$$und1$f);
      var i$2 = $uI(x1$4.$$und2$f);
      if ((n$1 !== null)) {
        return $m_Lamf_plugins_features_validation_model_ParsedValidationSpecification$().apply__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__scm_Map__s_Option__s_Option__s_Option__s_Option__T2(n$1, prefixes$6, new $c_s_Some().init___O(((name$3 + "_or_") + i$2)), new $c_s_Some().init___O(finalMessage$3), $m_s_None$(), finalNested$3)
      };
      throw new $c_s_MatchError().init___O(x1$4)
    })
  })(this, prefixes, name, finalMessage, finalNested));
  var x1$4$1 = this.collectNestedValidations__sc_Seq__T2($f_Lamf_plugins_features_validation_model_DialectWrapper__mapIndexedEntities__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__F2__sc_Seq(this, node, "or", f$2));
  if ((x1$4$1 === null)) {
    throw new $c_s_MatchError().init___O(x1$4$1)
  };
  var orConstraints = $as_sc_Seq(x1$4$1.$$und1__O());
  var nestedOrConstraints = $as_sc_Seq(x1$4$1.$$und2__O());
  var f$3 = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$14$1, prefixes$7, name$4, finalMessage$4, finalNested$4) {
    return (function(x0$5$2, x1$4$2$2) {
      var x0$5 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x0$5$2);
      var x1$4$2 = $uI(x1$4$2$2);
      var x1$5 = new $c_T2().init___O__O(x0$5, x1$4$2);
      var n$2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x1$5.$$und1$f);
      var i$3 = $uI(x1$5.$$und2$f);
      if ((n$2 !== null)) {
        return $m_Lamf_plugins_features_validation_model_ParsedValidationSpecification$().apply__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__scm_Map__s_Option__s_Option__s_Option__s_Option__T2(n$2, prefixes$7, new $c_s_Some().init___O(((name$4 + "_xone_") + i$3)), new $c_s_Some().init___O(finalMessage$4), $m_s_None$(), finalNested$4)
      };
      throw new $c_s_MatchError().init___O(x1$5)
    })
  })(this, prefixes, name, finalMessage, finalNested));
  var x1$5$1 = this.collectNestedValidations__sc_Seq__T2($f_Lamf_plugins_features_validation_model_DialectWrapper__mapIndexedEntities__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T__F2__sc_Seq(this, node, "xone", f$3));
  if ((x1$5$1 === null)) {
    throw new $c_s_MatchError().init___O(x1$5$1)
  };
  var xoneConstraints = $as_sc_Seq(x1$5$1.$$und1__O());
  var xoneNestedConstraints = $as_sc_Seq(x1$5$1.$$und2__O());
  var this$81 = node.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping();
  var this$84 = $as_sc_Seq(this$81.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, property$1) {
    return (function(x$9$2$1) {
      var x$9$3 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$9$2$1);
      var this$82 = $as_Lamf_core_model_StrField(x$9$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
      var this$83 = this$82.option$1;
      return ($as_T((this$83.isEmpty__Z() ? null : this$83.get__O())) === property$1)
    })
  })(this, "not")));
  if (this$84.isEmpty__Z()) {
    var this$86 = $m_s_None$()
  } else {
    var arg1$3 = this$84.get__O();
    var p$1 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(arg1$3);
    var this$85 = node.objectProperty__Lamf_core_metamodel_Field__s_Option(p$1.toField__Lamf_core_metamodel_Field());
    if (this$85.isEmpty__Z()) {
      var this$86 = $m_s_None$()
    } else {
      var arg1$4 = this$85.get__O();
      var x$27$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(arg1$4);
      var this$86 = new $c_s_Some().init___O($m_Lamf_plugins_features_validation_model_ParsedValidationSpecification$().apply__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__scm_Map__s_Option__s_Option__s_Option__s_Option__T2(x$27$1, prefixes, new $c_s_Some().init___O((name + "_not")), new $c_s_Some().init___O(finalMessage), $m_s_None$(), finalNested))
    }
  };
  if (this$86.isEmpty__Z()) {
    var this$89 = $m_s_None$()
  } else {
    var arg1$5 = this$86.get__O();
    var x0$6 = $as_T2(arg1$5);
    if ((x0$6 === null)) {
      throw new $c_s_MatchError().init___O(x0$6)
    };
    var v = $as_Lamf_core_validation_core_ValidationSpecification(x0$6.$$und1__O());
    var nested$1 = $as_sc_Seq(x0$6.$$und2__O());
    var jsx$13 = $m_sc_Seq$();
    var array = [v];
    var this$89 = new $c_s_Some().init___O(new $c_T2().init___O__O(jsx$13.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)), nested$1))
  };
  var x1$6 = $as_T2((this$89.isEmpty__Z() ? new $c_T2().init___O__O($m_sci_Nil$(), $m_sci_Nil$()) : this$89.get__O()));
  if ((x1$6 === null)) {
    throw new $c_s_MatchError().init___O(x1$6)
  };
  var notConstraints = $as_sc_Seq(x1$6.$$und1__O());
  var notNestedConstraints = $as_sc_Seq(x1$6.$$und2__O());
  var this$90 = $m_sc_Seq$();
  var jsx$16 = $as_sc_TraversableLike(nestedAndConstraints.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(nestedOrConstraints, this$90.ReusableCBFInstance$2));
  var this$91 = $m_sc_Seq$();
  var jsx$15 = $as_sc_TraversableLike(jsx$16.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(xoneNestedConstraints, this$91.ReusableCBFInstance$2));
  var this$92 = $m_sc_Seq$();
  var jsx$14 = $as_sc_TraversableLike(jsx$15.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(notNestedConstraints, this$92.ReusableCBFInstance$2));
  var this$93 = $m_sc_Seq$();
  var allNested = $as_sc_Seq(jsx$14.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(nestedProperties, this$93.ReusableCBFInstance$2));
  var jsx$17 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$18$1) {
    return (function(x$29$2$2) {
      var x$29$2 = $as_Lamf_core_validation_core_ValidationSpecification(x$29$2$2);
      return x$29$2.id$1
    })
  })(this));
  var this$94 = $m_sc_Seq$();
  var x$48 = $as_sc_Seq(andConstraints.map__F1__scg_CanBuildFrom__O(jsx$17, this$94.ReusableCBFInstance$2));
  var jsx$18 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$19$1) {
    return (function(x$30$2$2) {
      var x$30$2 = $as_Lamf_core_validation_core_ValidationSpecification(x$30$2$2);
      return x$30$2.id$1
    })
  })(this));
  var this$95 = $m_sc_Seq$();
  var x$49 = $as_sc_Seq(orConstraints.map__F1__scg_CanBuildFrom__O(jsx$18, this$95.ReusableCBFInstance$2));
  var jsx$19 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$20$1) {
    return (function(x$31$2$2) {
      var x$31$2 = $as_Lamf_core_validation_core_ValidationSpecification(x$31$2$2);
      return x$31$2.id$1
    })
  })(this));
  var this$96 = $m_sc_Seq$();
  var x$50 = $as_sc_Seq(xoneConstraints.map__F1__scg_CanBuildFrom__O(jsx$19, this$96.ReusableCBFInstance$2));
  var this$97 = notConstraints.headOption__s_Option();
  if (this$97.isEmpty__Z()) {
    var x$51 = $m_s_None$()
  } else {
    var arg1$6 = this$97.get__O();
    var x$32$2 = $as_Lamf_core_validation_core_ValidationSpecification(arg1$6);
    var x$51 = new $c_s_Some().init___O(x$32$2.id$1)
  };
  var x$52 = base.name$1;
  var x$53 = base.message$1;
  var x$54 = base.ramlMessage$1;
  var x$55 = base.oasMessage$1;
  var x$56 = base.targetInstance$1;
  var x$57 = base.targetClass$1;
  var x$58 = base.targetObject$1;
  var x$59 = base.propertyConstraints$1;
  var x$60 = base.nodeConstraints$1;
  var x$61 = base.closed$1;
  var x$62 = base.functionConstraint$1;
  var x$63 = base.custom$1;
  var x$64 = base.nested$1;
  var x$65 = base.replacesFunctionConstraint$1;
  var x$66 = base.query$1;
  var finalValidation = new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$52, x$53, x$54, x$55, x$56, x$57, x$58, x$49, x$48, x$50, x$51, x$59, x$60, x$61, x$62, x$63, x$64, x$65, x$66);
  var this$98 = $m_sc_Seq$();
  var jsx$22 = $as_sc_TraversableLike(andConstraints.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(orConstraints, this$98.ReusableCBFInstance$2));
  var this$99 = $m_sc_Seq$();
  var jsx$21 = $as_sc_TraversableLike(jsx$22.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(xoneConstraints, this$99.ReusableCBFInstance$2));
  var this$100 = $m_sc_Seq$();
  var jsx$20 = $as_sc_TraversableLike(jsx$21.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(notConstraints, this$100.ReusableCBFInstance$2));
  var this$101 = $m_sc_Seq$();
  return new $c_T2().init___O__O(finalValidation, jsx$20.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(allNested, this$101.ReusableCBFInstance$2))
});
var $d_Lamf_plugins_features_validation_model_ParsedValidationSpecification$ = new $TypeData().initClass({
  Lamf_plugins_features_validation_model_ParsedValidationSpecification$: 0
}, false, "amf.plugins.features.validation.model.ParsedValidationSpecification$", {
  Lamf_plugins_features_validation_model_ParsedValidationSpecification$: 1,
  O: 1,
  Lamf_plugins_features_validation_model_DialectWrapper: 1
});
$c_Lamf_plugins_features_validation_model_ParsedValidationSpecification$.prototype.$classData = $d_Lamf_plugins_features_validation_model_ParsedValidationSpecification$;
var $n_Lamf_plugins_features_validation_model_ParsedValidationSpecification$ = (void 0);
function $m_Lamf_plugins_features_validation_model_ParsedValidationSpecification$() {
  if ((!$n_Lamf_plugins_features_validation_model_ParsedValidationSpecification$)) {
    $n_Lamf_plugins_features_validation_model_ParsedValidationSpecification$ = new $c_Lamf_plugins_features_validation_model_ParsedValidationSpecification$().init___()
  };
  return $n_Lamf_plugins_features_validation_model_ParsedValidationSpecification$
}
/** @constructor */
function $c_Lamf_validation_DialectValidations$() {
  $c_O.call(this);
  this.specification$1 = null;
  this.namespace$1 = null;
  this.DialectError$1 = null;
  this.MissingVocabulary$1 = null;
  this.MissingClassTermSpecification$1 = null;
  this.MissingPropertyTermSpecification$1 = null;
  this.MissingFragmentSpecification$1 = null;
  this.MissingPropertyRangeSpecification$1 = null;
  this.DifferentTermsInMapKey$1 = null;
  this.InconsistentPropertyRangeValueSpecification$1 = null;
  this.ClosedShapeSpecification$1 = null;
  this.ClosedShapeSpecificationWarning$1 = null;
  this.MissingPropertySpecification$1 = null;
  this.InvalidModuleType$1 = null;
  this.DialectAmbiguousRangeSpecification$1 = null;
  this.InvalidUnionType$1 = null;
  this.ExpectedVocabularyModule$1 = null;
  this.InvalidDialectPatch$1 = null;
  this.GuidRangeWithoutUnique$1 = null;
  this.DuplicateTerm$1 = null;
  this.levels$1 = null;
  this.validations$1 = null;
  this.amf$plugins$features$validation$Validations$$default$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_validation_DialectValidations$.prototype = new $h_O();
$c_Lamf_validation_DialectValidations$.prototype.constructor = $c_Lamf_validation_DialectValidations$;
/** @constructor */
function $h_Lamf_validation_DialectValidations$() {
  /*<skip>*/
}
$h_Lamf_validation_DialectValidations$.prototype = $c_Lamf_validation_DialectValidations$.prototype;
$c_Lamf_validation_DialectValidations$.prototype.init___ = (function() {
  $n_Lamf_validation_DialectValidations$ = this;
  this.specification$1 = $m_Lamf_core_validation_core_ValidationSpecification$().AML$undVALIDATION$1;
  this.namespace$1 = $m_Lamf_core_vocabulary_Namespace$().AmfAml$1;
  var ramlMessage = $m_s_None$();
  var oasMessage = $m_s_None$();
  this.DialectError$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "dialect-error", "Dialect error", ramlMessage, oasMessage);
  var ramlMessage$1 = $m_s_None$();
  var oasMessage$1 = $m_s_None$();
  this.MissingVocabulary$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "missing-vocabulary", "Missing vocabulary", ramlMessage$1, oasMessage$1);
  var ramlMessage$2 = $m_s_None$();
  var oasMessage$2 = $m_s_None$();
  this.MissingClassTermSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "missing-class-term", "Missing class term", ramlMessage$2, oasMessage$2);
  var ramlMessage$3 = $m_s_None$();
  var oasMessage$3 = $m_s_None$();
  this.MissingPropertyTermSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "missing-property-term", "Missing property term", ramlMessage$3, oasMessage$3);
  var ramlMessage$4 = $m_s_None$();
  var oasMessage$4 = $m_s_None$();
  this.MissingFragmentSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "missing-dialect-fragment", "Missing dialect fragment", ramlMessage$4, oasMessage$4);
  var ramlMessage$5 = $m_s_None$();
  var oasMessage$5 = $m_s_None$();
  this.MissingPropertyRangeSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "missing-node-mapping-range-term", "Missing property range term", ramlMessage$5, oasMessage$5);
  var ramlMessage$6 = $m_s_None$();
  var oasMessage$6 = $m_s_None$();
  this.DifferentTermsInMapKey$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "different-terms-in-mapkey", "Different terms in map key", ramlMessage$6, oasMessage$6);
  var ramlMessage$7 = $m_s_None$();
  var oasMessage$7 = $m_s_None$();
  this.InconsistentPropertyRangeValueSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "inconsistent-property-range-value", "Range value does not match the expected type", ramlMessage$7, oasMessage$7);
  var ramlMessage$8 = $m_s_None$();
  var oasMessage$8 = $m_s_None$();
  this.ClosedShapeSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "closed-shape", "Invalid property for node", ramlMessage$8, oasMessage$8);
  var ramlMessage$9 = $m_s_None$();
  var oasMessage$9 = $m_s_None$();
  this.ClosedShapeSpecificationWarning$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "closed-shape-warning", "Invalid property for node", ramlMessage$9, oasMessage$9);
  var ramlMessage$10 = $m_s_None$();
  var oasMessage$10 = $m_s_None$();
  this.MissingPropertySpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "mandatory-property-shape", "Missing mandatory property", ramlMessage$10, oasMessage$10);
  var ramlMessage$11 = $m_s_None$();
  var oasMessage$11 = $m_s_None$();
  this.InvalidModuleType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-module-type", "Invalid module type", ramlMessage$11, oasMessage$11);
  var ramlMessage$12 = $m_s_None$();
  var oasMessage$12 = $m_s_None$();
  this.DialectAmbiguousRangeSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "dialect-ambiguous-range", "Ambiguous entity range", ramlMessage$12, oasMessage$12);
  var ramlMessage$13 = $m_s_None$();
  var oasMessage$13 = $m_s_None$();
  this.InvalidUnionType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-union-type", "Union should be a sequence", ramlMessage$13, oasMessage$13);
  var ramlMessage$14 = $m_s_None$();
  var oasMessage$14 = $m_s_None$();
  this.ExpectedVocabularyModule$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "expected-vocabulary-module", "Expected vocabulary module", ramlMessage$14, oasMessage$14);
  var ramlMessage$15 = $m_s_None$();
  var oasMessage$15 = $m_s_None$();
  this.InvalidDialectPatch$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-dialect-patch", "Invalid dialect patch", ramlMessage$15, oasMessage$15);
  var ramlMessage$16 = $m_s_None$();
  var oasMessage$16 = $m_s_None$();
  this.GuidRangeWithoutUnique$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "guid-scalar-non-unique", "GUID scalar type declared without unique constraint", ramlMessage$16, oasMessage$16);
  var ramlMessage$17 = $m_s_None$();
  var oasMessage$17 = $m_s_None$();
  this.DuplicateTerm$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "duplicate-term", "Vocabulary defines duplicate terms", ramlMessage$17, oasMessage$17);
  var self = this.ClosedShapeSpecificationWarning$1.id$1;
  var lvl = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var y = $f_Lamf_plugins_features_validation_Validations__all__T__sci_Map(this, lvl);
  var jsx$2 = new $c_T2().init___O__O(self, y);
  var self$1 = this.MissingClassTermSpecification$1.id$1;
  var lvl$1 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var y$1 = $f_Lamf_plugins_features_validation_Validations__all__T__sci_Map(this, lvl$1);
  var jsx$1 = new $c_T2().init___O__O(self$1, y$1);
  var self$2 = this.MissingPropertyTermSpecification$1.id$1;
  var lvl$2 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var y$2 = $f_Lamf_plugins_features_validation_Validations__all__T__sci_Map(this, lvl$2);
  var array = [jsx$2, jsx$1, new $c_T2().init___O__O(self$2, y$2)];
  var this$10 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$10.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  this.levels$1 = $as_sci_Map(this$10.elems$1);
  $m_sci_List$();
  var array$1 = [this.ClosedShapeSpecification$1, this.DialectAmbiguousRangeSpecification$1, this.InconsistentPropertyRangeValueSpecification$1, this.MissingPropertyRangeSpecification$1, this.MissingClassTermSpecification$1, this.MissingPropertyTermSpecification$1, this.DifferentTermsInMapKey$1, this.MissingFragmentSpecification$1, this.MissingPropertySpecification$1, this.InvalidModuleType$1, this.MissingVocabulary$1, this.InvalidUnionType$1, this.InvalidDialectPatch$1, this.DialectError$1, this.GuidRangeWithoutUnique$1, this.DuplicateTerm$1];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$14 = result;
    var index$1 = i$1;
    var x = array$1[index$1];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$14);
    i$1 = (((-1) + i$1) | 0)
  };
  this.validations$1 = result;
  return this
});
$c_Lamf_validation_DialectValidations$.prototype.namespace__Lamf_core_vocabulary_Namespace = (function() {
  return this.namespace$1
});
$c_Lamf_validation_DialectValidations$.prototype.specification__T = (function() {
  return this.specification$1
});
var $d_Lamf_validation_DialectValidations$ = new $TypeData().initClass({
  Lamf_validation_DialectValidations$: 0
}, false, "amf.validation.DialectValidations$", {
  Lamf_validation_DialectValidations$: 1,
  O: 1,
  Lamf_plugins_features_validation_Validations: 1
});
$c_Lamf_validation_DialectValidations$.prototype.$classData = $d_Lamf_validation_DialectValidations$;
var $n_Lamf_validation_DialectValidations$ = (void 0);
function $m_Lamf_validation_DialectValidations$() {
  if ((!$n_Lamf_validation_DialectValidations$)) {
    $n_Lamf_validation_DialectValidations$ = new $c_Lamf_validation_DialectValidations$().init___()
  };
  return $n_Lamf_validation_DialectValidations$
}
/** @constructor */
function $c_Lamf_validations_ParserSideValidations$() {
  $c_O.call(this);
  this.specification$1 = null;
  this.namespace$1 = null;
  this.NonEmptyBindingMap$1 = null;
  this.ExclusiveLinkTargetError$1 = null;
  this.InvalidJsonSchemaType$1 = null;
  this.MandatoryObjectNodeType$1 = null;
  this.InvalidShapeFormat$1 = null;
  this.InvalidSecuritySchemeType$1 = null;
  this.InvalidDatetimeFormat$1 = null;
  this.InvalidBasePath$1 = null;
  this.InvalidBaseUriParametersType$1 = null;
  this.UnusedBaseUriParameter$1 = null;
  this.ParametersWithoutBaseUri$1 = null;
  this.ParameterNameRequired$1 = null;
  this.RequestBodyContentRequired$1 = null;
  this.DiscriminatorNameRequired$1 = null;
  this.InvalidRequiredValue$1 = null;
  this.InvalidServerPath$1 = null;
  this.InvalidAbstractDeclarationParameterInType$1 = null;
  this.InvalidSecuredByType$1 = null;
  this.ScopeNamesMustBeEmpty$1 = null;
  this.MandatoryPathsProperty$1 = null;
  this.MandatoryChannelsProperty$1 = null;
  this.InvalidSecuritySchemeDescribedByType$1 = null;
  this.ExpectedReference$1 = null;
  this.InvalidTagType$1 = null;
  this.InvalidSecuritySchemeObject$1 = null;
  this.InvalidSecurityRequirementObject$1 = null;
  this.InvalidSecurityRequirementsSeq$1 = null;
  this.InvalidEndpointPath$1 = null;
  this.DuplicatedEndpointPath$1 = null;
  this.DuplicatedOperationId$1 = null;
  this.SchemaDeprecated$1 = null;
  this.SchemasDeprecated$1 = null;
  this.InvalidOperationType$1 = null;
  this.InvalidExternalTypeType$1 = null;
  this.InvalidXmlSchemaType$1 = null;
  this.InvalidJsonSchemaExpression$1 = null;
  this.InvalidPropertyType$1 = null;
  this.UnableToParseArray$1 = null;
  this.InvalidDecimalPoint$1 = null;
  this.DuplicateRequiredItem$1 = null;
  this.InvalidTypeDefinition$1 = null;
  this.InvalidRequiredArrayForSchemaVersion$1 = null;
  this.InvalidRequiredBooleanForSchemaVersion$1 = null;
  this.MissingOAuthFlowField$1 = null;
  this.InvalidAdditionalPropertiesType$1 = null;
  this.InvalidAdditionalItemsType$1 = null;
  this.InvalidTupleType$1 = null;
  this.InvalidSchemaType$1 = null;
  this.InvalidMediaTypeType$1 = null;
  this.InvalidXoneType$1 = null;
  this.InvalidAndType$1 = null;
  this.InvalidOrType$1 = null;
  this.InvalidDisjointUnionType$1 = null;
  this.UnexpectedVendor$1 = null;
  this.NullAbstractDeclaration$1 = null;
  this.InvalidAbstractDeclarationType$1 = null;
  this.UnableToParseShapeExtensions$1 = null;
  this.InvalidJsonSchemaVersion$1 = null;
  this.CrossSecurityWarningSpecification$1 = null;
  this.ChainedReferenceSpecification$1 = null;
  this.UnableToSetDefaultType$1 = null;
  this.ExclusiveSchemaType$1 = null;
  this.ExclusiveSchemasType$1 = null;
  this.ExclusivePropertiesSpecification$1 = null;
  this.ExamplesMustBeAMap$1 = null;
  this.ExamplesMustBeASeq$1 = null;
  this.PathTemplateUnbalancedParameters$1 = null;
  this.OasBodyAndFormDataParameterSpecification$1 = null;
  this.OasInvalidBodyParameter$1 = null;
  this.DuplicatedParameters$1 = null;
  this.DuplicatedTags$1 = null;
  this.OasInvalidParameterBinding$1 = null;
  this.OasFormDataNotFileSpecification$1 = null;
  this.UnsupportedExampleMediaTypeErrorSpecification$1 = null;
  this.UnknownSecuritySchemeErrorSpecification$1 = null;
  this.MissingSecuritySchemeErrorSpecification$1 = null;
  this.UnknownScopeErrorSpecification$1 = null;
  this.DuplicatedPropertySpecification$1 = null;
  this.UnexpectedRamlScalarKey$1 = null;
  this.UnexpectedFileTypesSyntax$1 = null;
  this.JsonSchemaInheratinaceWarningSpecification$1 = null;
  this.XmlSchemaInheratinaceWarningSpecification$1 = null;
  this.InvalidEndpointType$1 = null;
  this.InvalidParameterType$1 = null;
  this.UnableToParseShape$1 = null;
  this.JsonSchemaFragmentNotFound$1 = null;
  this.PatternPropertiesOnClosedNodeSpecification$1 = null;
  this.DiscriminatorOnExtendedUnionSpecification$1 = null;
  this.UnresolvedParameter$1 = null;
  this.UnableToParseJsonSchema$1 = null;
  this.MalformedJsonReference$1 = null;
  this.InvalidAnnotationType$1 = null;
  this.InvalidAnnotationTarget$1 = null;
  this.InvalidFragmentType$1 = null;
  this.InvalidParameterStyleBindingCombination$1 = null;
  this.InvalidTypesType$1 = null;
  this.InvalidOAuth2FlowName$1 = null;
  this.InvalidDocumentationType$1 = null;
  this.InvalidAllowedTargetsType$1 = null;
  this.InvalidExtensionsType$1 = null;
  this.ModuleNotFound$1 = null;
  this.InvalidTypeExpression$1 = null;
  this.UnexpectedReference$1 = null;
  this.ReadOnlyPropertyMarkedRequired$1 = null;
  this.MissingDiscriminatorProperty$1 = null;
  this.InvalidPayload$1 = null;
  this.InvalidValueInPropertiesFacet$1 = null;
  this.InvalidComponents$1 = null;
  this.InvalidUserDefinedFacetName$1 = null;
  this.InvalidFieldNameInComponents$1 = null;
  this.MissingRequiredUserDefinedFacet$1 = null;
  this.ParameterMissingSchemaOrContent$1 = null;
  this.ServerVariableMissingDefault$1 = null;
  this.UserDefinedFacetMatchesBuiltInFacets$1 = null;
  this.InvalidEndpointDeclaration$1 = null;
  this.UserDefinedFacetMatchesAncestorsTypeFacets$1 = null;
  this.SlashInUriParameterValues$1 = null;
  this.ItemsFieldRequired$1 = null;
  this.InvalidIdentifier$1 = null;
  this.ExeededMaxYamlReferences$1 = null;
  this.MissingParameterType$1 = null;
  this.InvalidStatusCode$1 = null;
  this.UnknownYamlTag$1 = null;
  this.levels$1 = null;
  this.validations$1 = null;
  this.amf$plugins$features$validation$Validations$$default$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_validations_ParserSideValidations$.prototype = new $h_O();
$c_Lamf_validations_ParserSideValidations$.prototype.constructor = $c_Lamf_validations_ParserSideValidations$;
/** @constructor */
function $h_Lamf_validations_ParserSideValidations$() {
  /*<skip>*/
}
$h_Lamf_validations_ParserSideValidations$.prototype = $c_Lamf_validations_ParserSideValidations$.prototype;
$c_Lamf_validations_ParserSideValidations$.prototype.init___ = (function() {
  $n_Lamf_validations_ParserSideValidations$ = this;
  this.specification$1 = $m_Lamf_core_validation_core_ValidationSpecification$().PARSER$undSIDE$undVALIDATION$1;
  this.namespace$1 = $m_Lamf_core_vocabulary_Namespace$().AmfParser$1;
  var ramlMessage = $m_s_None$();
  var oasMessage = $m_s_None$();
  this.NonEmptyBindingMap$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "non-empty-binding-map", "Reserved name binding must have an empty map", ramlMessage, oasMessage);
  var ramlMessage$1 = $m_s_None$();
  var oasMessage$1 = $m_s_None$();
  this.ExclusiveLinkTargetError$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "exclusive-link-target-error", "operationRef and operationId are mutually exclusive in a OAS 3.0.0 Link Object", ramlMessage$1, oasMessage$1);
  var ramlMessage$2 = $m_s_None$();
  var oasMessage$2 = $m_s_None$();
  this.InvalidJsonSchemaType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-json-schema-type", "Invalid json schema definition type", ramlMessage$2, oasMessage$2);
  var ramlMessage$3 = $m_s_None$();
  var oasMessage$3 = $m_s_None$();
  this.MandatoryObjectNodeType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "mandatory-object-node-type", "Mandatory object node type", ramlMessage$3, oasMessage$3);
  var ramlMessage$4 = $m_s_None$();
  var oasMessage$4 = $m_s_None$();
  this.InvalidShapeFormat$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-shape-format", "Invalid shape format", ramlMessage$4, oasMessage$4);
  var ramlMessage$5 = $m_s_None$();
  var oasMessage$5 = $m_s_None$();
  this.InvalidSecuritySchemeType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-security-scheme-type", "Invalid security scheme type", ramlMessage$5, oasMessage$5);
  var ramlMessage$6 = $m_s_None$();
  var oasMessage$6 = $m_s_None$();
  this.InvalidDatetimeFormat$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-datetime-format", "Invalid format value for datetime", ramlMessage$6, oasMessage$6);
  var ramlMessage$7 = $m_s_None$();
  var oasMessage$7 = $m_s_None$();
  this.InvalidBasePath$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-base-path", "Invalid base path", ramlMessage$7, oasMessage$7);
  var ramlMessage$8 = $m_s_None$();
  var oasMessage$8 = $m_s_None$();
  this.InvalidBaseUriParametersType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-base-uri-parameters-type", "Invalid baseUriParameters type", ramlMessage$8, oasMessage$8);
  var ramlMessage$9 = $m_s_None$();
  var oasMessage$9 = $m_s_None$();
  this.UnusedBaseUriParameter$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "unused-base-uri-parameter", "Unused base uri parameter", ramlMessage$9, oasMessage$9);
  var ramlMessage$10 = $m_s_None$();
  var oasMessage$10 = $m_s_None$();
  this.ParametersWithoutBaseUri$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "parameters-without-base-uri", "'baseUri' not defined and 'baseUriParameters' defined.", ramlMessage$10, oasMessage$10);
  var ramlMessage$11 = $m_s_None$();
  var oasMessage$11 = $m_s_None$();
  this.ParameterNameRequired$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "parameter-name-required", "Parameter name is required", ramlMessage$11, oasMessage$11);
  var ramlMessage$12 = $m_s_None$();
  var oasMessage$12 = $m_s_None$();
  this.RequestBodyContentRequired$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "content-required", "Request body content is required", ramlMessage$12, oasMessage$12);
  var ramlMessage$13 = $m_s_None$();
  var oasMessage$13 = $m_s_None$();
  this.DiscriminatorNameRequired$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "discriminator-name-required", "Discriminator property name is required", ramlMessage$13, oasMessage$13);
  var ramlMessage$14 = $m_s_None$();
  var oasMessage$14 = $m_s_None$();
  this.InvalidRequiredValue$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-required-value", "Invalid required value", ramlMessage$14, oasMessage$14);
  var ramlMessage$15 = $m_s_None$();
  var oasMessage$15 = $m_s_None$();
  this.InvalidServerPath$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-server-path", "Invalid server path", ramlMessage$15, oasMessage$15);
  var ramlMessage$16 = $m_s_None$();
  var oasMessage$16 = $m_s_None$();
  this.InvalidAbstractDeclarationParameterInType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-abstract-declaration-parameter-in-type", "Trait/Resource Type parameter in type", ramlMessage$16, oasMessage$16);
  var ramlMessage$17 = $m_s_None$();
  var oasMessage$17 = $m_s_None$();
  this.InvalidSecuredByType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-secured-by-type", "Invalid 'securedBy' type", ramlMessage$17, oasMessage$17);
  var ramlMessage$18 = $m_s_None$();
  var oasMessage$18 = $m_s_None$();
  this.ScopeNamesMustBeEmpty$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "scope-names-must-be-empty", "Scope names must be an empty array", ramlMessage$18, oasMessage$18);
  var ramlMessage$19 = $m_s_None$();
  var oasMessage$19 = $m_s_None$();
  this.MandatoryPathsProperty$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "mandatory-paths-property", "Paths property must be declared", ramlMessage$19, oasMessage$19);
  var ramlMessage$20 = $m_s_None$();
  var oasMessage$20 = $m_s_None$();
  this.MandatoryChannelsProperty$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "mandatory-channels-property", "Channels property must be declared", ramlMessage$20, oasMessage$20);
  var ramlMessage$21 = $m_s_None$();
  var oasMessage$21 = $m_s_None$();
  this.InvalidSecuritySchemeDescribedByType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-security-scheme-described-by-type", "Invalid 'describedBy' type, map expected", ramlMessage$21, oasMessage$21);
  var ramlMessage$22 = $m_s_None$();
  var oasMessage$22 = $m_s_None$();
  this.ExpectedReference$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "expected-reference", "Expected reference", ramlMessage$22, oasMessage$22);
  var ramlMessage$23 = $m_s_None$();
  var oasMessage$23 = $m_s_None$();
  this.InvalidTagType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-tag-type", "Tag values must be of type string", ramlMessage$23, oasMessage$23);
  var ramlMessage$24 = $m_s_None$();
  var oasMessage$24 = $m_s_None$();
  this.InvalidSecuritySchemeObject$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-security-scheme-object", "Invalid security scheme", ramlMessage$24, oasMessage$24);
  var ramlMessage$25 = $m_s_None$();
  var oasMessage$25 = $m_s_None$();
  this.InvalidSecurityRequirementObject$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-security-requirement-object", "Invalid security requirement object", ramlMessage$25, oasMessage$25);
  var ramlMessage$26 = $m_s_None$();
  var oasMessage$26 = $m_s_None$();
  this.InvalidSecurityRequirementsSeq$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-security-requirements-sequence", "'security' must be an array of security requirements object", ramlMessage$26, oasMessage$26);
  var ramlMessage$27 = $m_s_None$();
  var oasMessage$27 = $m_s_None$();
  this.InvalidEndpointPath$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-endpoint-path", "Invalid endpoint path (invalid template uri)", ramlMessage$27, oasMessage$27);
  var ramlMessage$28 = $m_s_None$();
  var oasMessage$28 = $m_s_None$();
  this.DuplicatedEndpointPath$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "duplicated-endpoint-path", "Duplicated endpoint path", ramlMessage$28, oasMessage$28);
  var ramlMessage$29 = $m_s_None$();
  var oasMessage$29 = $m_s_None$();
  this.DuplicatedOperationId$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "duplicated-operation-id", "Duplicated operation id", ramlMessage$29, oasMessage$29);
  var ramlMessage$30 = $m_s_None$();
  var oasMessage$30 = $m_s_None$();
  this.SchemaDeprecated$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "schema-deprecated", "'schema' keyword it's deprecated for 1.0 version, should use 'type' instead", ramlMessage$30, oasMessage$30);
  var ramlMessage$31 = $m_s_None$();
  var oasMessage$31 = $m_s_None$();
  this.SchemasDeprecated$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "schemas-deprecated", "'schemas' keyword it's deprecated for 1.0 version, should use 'types' instead", ramlMessage$31, oasMessage$31);
  var ramlMessage$32 = $m_s_None$();
  var oasMessage$32 = $m_s_None$();
  this.InvalidOperationType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-operation-type", "Invalid operation type", ramlMessage$32, oasMessage$32);
  var ramlMessage$33 = $m_s_None$();
  var oasMessage$33 = $m_s_None$();
  this.InvalidExternalTypeType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-external-type-type", "Invalid external type type", ramlMessage$33, oasMessage$33);
  var ramlMessage$34 = $m_s_None$();
  var oasMessage$34 = $m_s_None$();
  this.InvalidXmlSchemaType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-xml-schema-type", "Invalid xml schema type", ramlMessage$34, oasMessage$34);
  var ramlMessage$35 = $m_s_None$();
  var oasMessage$35 = $m_s_None$();
  this.InvalidJsonSchemaExpression$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-json-schema-expression", "Invalid json schema expression", ramlMessage$35, oasMessage$35);
  var ramlMessage$36 = $m_s_None$();
  var oasMessage$36 = $m_s_None$();
  this.InvalidPropertyType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-property-type", "Invalid property key type. Should be string", ramlMessage$36, oasMessage$36);
  var ramlMessage$37 = $m_s_None$();
  var oasMessage$37 = $m_s_None$();
  this.UnableToParseArray$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "unable-to-parse-array", "Unable to parse array definition", ramlMessage$37, oasMessage$37);
  var ramlMessage$38 = $m_s_None$();
  var oasMessage$38 = $m_s_None$();
  this.InvalidDecimalPoint$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-decimal-point", "Invalid decimal point", ramlMessage$38, oasMessage$38);
  var ramlMessage$39 = $m_s_None$();
  var oasMessage$39 = $m_s_None$();
  this.DuplicateRequiredItem$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "duplicate-required-item", "Duplicate required item", ramlMessage$39, oasMessage$39);
  var ramlMessage$40 = $m_s_None$();
  var oasMessage$40 = $m_s_None$();
  this.InvalidTypeDefinition$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-type-definition", "Invalid type definition", ramlMessage$40, oasMessage$40);
  var ramlMessage$41 = $m_s_None$();
  var oasMessage$41 = $m_s_None$();
  this.InvalidRequiredArrayForSchemaVersion$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-required-array-for-schema-version", "Required arrays of properties not supported in JSON Schema below version draft-4", ramlMessage$41, oasMessage$41);
  var ramlMessage$42 = $m_s_None$();
  var oasMessage$42 = $m_s_None$();
  this.InvalidRequiredBooleanForSchemaVersion$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-required-boolean-for-schema-version", "Required property boolean value is only supported in JSON Schema draft-3", ramlMessage$42, oasMessage$42);
  var ramlMessage$43 = $m_s_None$();
  var oasMessage$43 = $m_s_None$();
  this.MissingOAuthFlowField$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "missing-oauth-flow-field", "Missing mandatory property for declared OAuth flow", ramlMessage$43, oasMessage$43);
  var ramlMessage$44 = $m_s_None$();
  var oasMessage$44 = $m_s_None$();
  this.InvalidAdditionalPropertiesType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-additional-properties-type", "additionalProperties should be a boolean or a map", ramlMessage$44, oasMessage$44);
  var ramlMessage$45 = $m_s_None$();
  var oasMessage$45 = $m_s_None$();
  this.InvalidAdditionalItemsType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-additional-items-type", "additionalItems should be a boolean or a map", ramlMessage$45, oasMessage$45);
  var ramlMessage$46 = $m_s_None$();
  var oasMessage$46 = $m_s_None$();
  this.InvalidTupleType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-tuple-type", "Tuple should be a sequence", ramlMessage$46, oasMessage$46);
  var ramlMessage$47 = $m_s_None$();
  var oasMessage$47 = $m_s_None$();
  this.InvalidSchemaType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-schema-type", "Schema should be a string", ramlMessage$47, oasMessage$47);
  var ramlMessage$48 = $m_s_None$();
  var oasMessage$48 = $m_s_None$();
  this.InvalidMediaTypeType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-media-type-type", "Media type should be a string", ramlMessage$48, oasMessage$48);
  var ramlMessage$49 = $m_s_None$();
  var oasMessage$49 = $m_s_None$();
  this.InvalidXoneType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-xone-type", "Xone should be a sequence", ramlMessage$49, oasMessage$49);
  var ramlMessage$50 = $m_s_None$();
  var oasMessage$50 = $m_s_None$();
  this.InvalidAndType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-and-type", "And should be a sequence", ramlMessage$50, oasMessage$50);
  var ramlMessage$51 = $m_s_None$();
  var oasMessage$51 = $m_s_None$();
  this.InvalidOrType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-or-type", "Or should be a sequence", ramlMessage$51, oasMessage$51);
  var ramlMessage$52 = $m_s_None$();
  var oasMessage$52 = $m_s_None$();
  this.InvalidDisjointUnionType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-disjoint-union-type", "Invalid type for disjoint union", ramlMessage$52, oasMessage$52);
  var ramlMessage$53 = $m_s_None$();
  var oasMessage$53 = $m_s_None$();
  this.UnexpectedVendor$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "unexpected-vendor", "Unexpected vendor", ramlMessage$53, oasMessage$53);
  var ramlMessage$54 = $m_s_None$();
  var oasMessage$54 = $m_s_None$();
  this.NullAbstractDeclaration$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "null-abstract-declaration", "Generating abstract declaration (resource type / trait)  with null value", ramlMessage$54, oasMessage$54);
  var ramlMessage$55 = $m_s_None$();
  var oasMessage$55 = $m_s_None$();
  this.InvalidAbstractDeclarationType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-abstract-declaration-type", "Invalid type for declaration node", ramlMessage$55, oasMessage$55);
  var ramlMessage$56 = $m_s_None$();
  var oasMessage$56 = $m_s_None$();
  this.UnableToParseShapeExtensions$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "unable-to-parse-shape-extensions", "Unable to parse shape extensions", ramlMessage$56, oasMessage$56);
  var ramlMessage$57 = $m_s_None$();
  var oasMessage$57 = $m_s_None$();
  this.InvalidJsonSchemaVersion$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-json-schema-version", "Invalid Json Schema version", ramlMessage$57, oasMessage$57);
  var ramlMessage$58 = $m_s_None$();
  var oasMessage$58 = $m_s_None$();
  this.CrossSecurityWarningSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "cross-security-warning", "Using a security scheme type from raml in oas or from oas in raml", ramlMessage$58, oasMessage$58);
  var ramlMessage$59 = $m_s_None$();
  var oasMessage$59 = $m_s_None$();
  this.ChainedReferenceSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "chained-reference-error", "References cannot be chained", ramlMessage$59, oasMessage$59);
  var ramlMessage$60 = $m_s_None$();
  var oasMessage$60 = $m_s_None$();
  this.UnableToSetDefaultType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "unable-to-set-default-type", "Unable to set default type", ramlMessage$60, oasMessage$60);
  var ramlMessage$61 = $m_s_None$();
  var oasMessage$61 = $m_s_None$();
  this.ExclusiveSchemaType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "exclusive-schema-type", "'schema' and 'type' properties are mutually exclusive", ramlMessage$61, oasMessage$61);
  var ramlMessage$62 = $m_s_None$();
  var oasMessage$62 = $m_s_None$();
  this.ExclusiveSchemasType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "exclusive-schemas-type", "'schemas' and 'types' properties are mutually exclusive", ramlMessage$62, oasMessage$62);
  var ramlMessage$63 = $m_s_None$();
  var oasMessage$63 = $m_s_None$();
  this.ExclusivePropertiesSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "exclusive-properties-error", "Exclusive properties declared together", ramlMessage$63, oasMessage$63);
  var ramlMessage$64 = $m_s_None$();
  var oasMessage$64 = $m_s_None$();
  this.ExamplesMustBeAMap$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "examples-must-be-map", "Examples value should be a map", ramlMessage$64, oasMessage$64);
  var ramlMessage$65 = $m_s_None$();
  var oasMessage$65 = $m_s_None$();
  this.ExamplesMustBeASeq$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "examples-must-be-seq", "Examples value should be an array of strings", ramlMessage$65, oasMessage$65);
  var ramlMessage$66 = $m_s_None$();
  var oasMessage$66 = $m_s_None$();
  this.PathTemplateUnbalancedParameters$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "path-template-unbalanced-parameters", "Nested parameters are not allowed in path templates", ramlMessage$66, oasMessage$66);
  var ramlMessage$67 = $m_s_None$();
  var oasMessage$67 = $m_s_None$();
  this.OasBodyAndFormDataParameterSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "oas-not-body-and-form-data-parameters", "Operation cannot have a body parameter and a formData parameter", ramlMessage$67, oasMessage$67);
  var ramlMessage$68 = $m_s_None$();
  var oasMessage$68 = $m_s_None$();
  this.OasInvalidBodyParameter$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "oas-invalid-body-parameter", "Only one body parameter is allowed", ramlMessage$68, oasMessage$68);
  var ramlMessage$69 = $m_s_None$();
  var oasMessage$69 = $m_s_None$();
  this.DuplicatedParameters$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "duplicate-parameters", "Sibling parameters must have unique 'name' and 'in' values", ramlMessage$69, oasMessage$69);
  var ramlMessage$70 = $m_s_None$();
  var oasMessage$70 = $m_s_None$();
  this.DuplicatedTags$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "duplicate-tags", "Sibling tags must have unique names", ramlMessage$70, oasMessage$70);
  var ramlMessage$71 = $m_s_None$();
  var oasMessage$71 = $m_s_None$();
  this.OasInvalidParameterBinding$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "oas-invalid-parameter-binding", "Parameter has invalid binding", ramlMessage$71, oasMessage$71);
  var ramlMessage$72 = $m_s_None$();
  var oasMessage$72 = $m_s_None$();
  this.OasFormDataNotFileSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "oas-file-not-form-data-parameters", "Parameters with type file must be in formData", ramlMessage$72, oasMessage$72);
  var ramlMessage$73 = $m_s_None$();
  var oasMessage$73 = $m_s_None$();
  this.UnsupportedExampleMediaTypeErrorSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "unsupported-example-media-type", "Cannot validate example with unsupported media type", ramlMessage$73, oasMessage$73);
  var ramlMessage$74 = $m_s_None$();
  var oasMessage$74 = $m_s_None$();
  this.UnknownSecuritySchemeErrorSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "unknown-security-scheme", "Cannot find the security scheme", ramlMessage$74, oasMessage$74);
  var ramlMessage$75 = $m_s_None$();
  var oasMessage$75 = $m_s_None$();
  this.MissingSecuritySchemeErrorSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "missing-security-scheme-type", "Missing security scheme type", ramlMessage$75, oasMessage$75);
  var ramlMessage$76 = $m_s_None$();
  var oasMessage$76 = $m_s_None$();
  this.UnknownScopeErrorSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "unknown-scope", "Cannot find the scope in the security settings", ramlMessage$76, oasMessage$76);
  var ramlMessage$77 = $m_s_None$();
  var oasMessage$77 = $m_s_None$();
  this.DuplicatedPropertySpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "duplicated-property", "Duplicated property in node", ramlMessage$77, oasMessage$77);
  var ramlMessage$78 = $m_s_None$();
  var oasMessage$78 = $m_s_None$();
  this.UnexpectedRamlScalarKey$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "unexpected-raml-scalar-key", "Unexpected key. Options are 'value' or annotations \\(.+\\)", ramlMessage$78, oasMessage$78);
  var ramlMessage$79 = $m_s_None$();
  var oasMessage$79 = $m_s_None$();
  this.UnexpectedFileTypesSyntax$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "unexpected-file-types-syntax", "Unexpected 'fileTypes' syntax. Options are string or sequence", ramlMessage$79, oasMessage$79);
  var ramlMessage$80 = $m_s_None$();
  var oasMessage$80 = $m_s_None$();
  this.JsonSchemaInheratinaceWarningSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "json-schema-inheritance", "Inheriting from JSON Schema", ramlMessage$80, oasMessage$80);
  var ramlMessage$81 = $m_s_None$();
  var oasMessage$81 = $m_s_None$();
  this.XmlSchemaInheratinaceWarningSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "xml-schema-inheritance", "Inheriting from XML Schema", ramlMessage$81, oasMessage$81);
  var ramlMessage$82 = $m_s_None$();
  var oasMessage$82 = $m_s_None$();
  this.InvalidEndpointType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-endpoint-type", "Invalid endpoint type", ramlMessage$82, oasMessage$82);
  var ramlMessage$83 = $m_s_None$();
  var oasMessage$83 = $m_s_None$();
  this.InvalidParameterType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-parameter-type", "Invalid parameter type", ramlMessage$83, oasMessage$83);
  var ramlMessage$84 = $m_s_None$();
  var oasMessage$84 = $m_s_None$();
  this.UnableToParseShape$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "unable-to-parse-shape", "Unable to parse shape", ramlMessage$84, oasMessage$84);
  var ramlMessage$85 = $m_s_None$();
  var oasMessage$85 = $m_s_None$();
  this.JsonSchemaFragmentNotFound$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "json-schema-fragment-not-found", "Json schema fragment not found", ramlMessage$85, oasMessage$85);
  var ramlMessage$86 = $m_s_None$();
  var oasMessage$86 = $m_s_None$();
  this.PatternPropertiesOnClosedNodeSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "pattern-properties-on-closed-node", "Closed node cannot define pattern properties", ramlMessage$86, oasMessage$86);
  var ramlMessage$87 = $m_s_None$();
  var oasMessage$87 = $m_s_None$();
  this.DiscriminatorOnExtendedUnionSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "discriminator-on-extended-union", "Property 'discriminator' not supported in a node extending a unionShape", ramlMessage$87, oasMessage$87);
  var ramlMessage$88 = $m_s_None$();
  var oasMessage$88 = $m_s_None$();
  this.UnresolvedParameter$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "unresolved-parameter", "Unresolved parameter", ramlMessage$88, oasMessage$88);
  var ramlMessage$89 = $m_s_None$();
  var oasMessage$89 = $m_s_None$();
  this.UnableToParseJsonSchema$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "unable-to-parse-json-schema", "Unable to parse json schema", ramlMessage$89, oasMessage$89);
  var ramlMessage$90 = $m_s_None$();
  var oasMessage$90 = $m_s_None$();
  this.MalformedJsonReference$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "malformed-json-reference", "Malformed json reference", ramlMessage$90, oasMessage$90);
  var ramlMessage$91 = $m_s_None$();
  var oasMessage$91 = $m_s_None$();
  this.InvalidAnnotationType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-annotation-type", "Invalid annotation type", ramlMessage$91, oasMessage$91);
  var ramlMessage$92 = $m_s_None$();
  var oasMessage$92 = $m_s_None$();
  this.InvalidAnnotationTarget$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-annotation-target", "Annotation not allowed in used target", ramlMessage$92, oasMessage$92);
  var ramlMessage$93 = $m_s_None$();
  var oasMessage$93 = $m_s_None$();
  this.InvalidFragmentType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-fragment-type", "Invalid fragment type", ramlMessage$93, oasMessage$93);
  var ramlMessage$94 = $m_s_None$();
  var oasMessage$94 = $m_s_None$();
  this.InvalidParameterStyleBindingCombination$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-parameter-style-binding-combination", "Invalid parameter style binding combination", ramlMessage$94, oasMessage$94);
  var ramlMessage$95 = $m_s_None$();
  var oasMessage$95 = $m_s_None$();
  this.InvalidTypesType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-types-type", "Invalid types type", ramlMessage$95, oasMessage$95);
  var ramlMessage$96 = $m_s_None$();
  var oasMessage$96 = $m_s_None$();
  this.InvalidOAuth2FlowName$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-oauth2-flow-name", "Invalid OAuth2 flow name", ramlMessage$96, oasMessage$96);
  var ramlMessage$97 = $m_s_None$();
  var oasMessage$97 = $m_s_None$();
  this.InvalidDocumentationType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-documentation-type", "Invalid documentation type", ramlMessage$97, oasMessage$97);
  var ramlMessage$98 = $m_s_None$();
  var oasMessage$98 = $m_s_None$();
  this.InvalidAllowedTargetsType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-allowed-targets-type", "Invalid allowedTargets type", ramlMessage$98, oasMessage$98);
  var ramlMessage$99 = $m_s_None$();
  var oasMessage$99 = $m_s_None$();
  this.InvalidExtensionsType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-extension-type", "Invalid extension type", ramlMessage$99, oasMessage$99);
  var ramlMessage$100 = $m_s_None$();
  var oasMessage$100 = $m_s_None$();
  this.ModuleNotFound$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "module-not-found", "Module not found", ramlMessage$100, oasMessage$100);
  var ramlMessage$101 = $m_s_None$();
  var oasMessage$101 = $m_s_None$();
  this.InvalidTypeExpression$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-type-expression", "Invalid type expression", ramlMessage$101, oasMessage$101);
  var ramlMessage$102 = $m_s_None$();
  var oasMessage$102 = $m_s_None$();
  this.UnexpectedReference$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "unexpected-reference", "Unexpected reference", ramlMessage$102, oasMessage$102);
  var ramlMessage$103 = $m_s_None$();
  var oasMessage$103 = $m_s_None$();
  this.ReadOnlyPropertyMarkedRequired$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "read-only-property-marked-required", "Read only property should not be marked as required by a schema", ramlMessage$103, oasMessage$103);
  var ramlMessage$104 = $m_s_None$();
  var oasMessage$104 = $m_s_None$();
  this.MissingDiscriminatorProperty$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "missing-discriminator-property", "Type is missing property marked as discriminator", ramlMessage$104, oasMessage$104);
  var ramlMessage$105 = $m_s_None$();
  var oasMessage$105 = $m_s_None$();
  this.InvalidPayload$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-payload", "Invalid payload", ramlMessage$105, oasMessage$105);
  var ramlMessage$106 = $m_s_None$();
  var oasMessage$106 = $m_s_None$();
  this.InvalidValueInPropertiesFacet$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-value-in-properties-facet", "Properties facet must be a map of key and values", ramlMessage$106, oasMessage$106);
  var ramlMessage$107 = $m_s_None$();
  var oasMessage$107 = $m_s_None$();
  this.InvalidComponents$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-components", "Components facet must be a map", ramlMessage$107, oasMessage$107);
  var ramlMessage$108 = $m_s_None$();
  var oasMessage$108 = $m_s_None$();
  this.InvalidUserDefinedFacetName$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-user-defined-facet-name", "User defined facets must not begin with open parenthesis", ramlMessage$108, oasMessage$108);
  var ramlMessage$109 = $m_s_None$();
  var oasMessage$109 = $m_s_None$();
  this.InvalidFieldNameInComponents$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-field-name-in-components", "Field name in components must match the following expression: ^[a-zA-Z0-9\\.\\-_]+$", ramlMessage$109, oasMessage$109);
  var ramlMessage$110 = $m_s_None$();
  var oasMessage$110 = $m_s_None$();
  this.MissingRequiredUserDefinedFacet$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "missing-user-defined-facet", "Type is missing required user defined facet", ramlMessage$110, oasMessage$110);
  var ramlMessage$111 = $m_s_None$();
  var oasMessage$111 = $m_s_None$();
  this.ParameterMissingSchemaOrContent$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "parameter-missing-schema-or-content", "Parameter must define a 'schema' or 'content' field, but not both", ramlMessage$111, oasMessage$111);
  var ramlMessage$112 = $m_s_None$();
  var oasMessage$112 = $m_s_None$();
  this.ServerVariableMissingDefault$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "server-variable-missing-default", "Server variable must define a 'default' field", ramlMessage$112, oasMessage$112);
  var ramlMessage$113 = $m_s_None$();
  var oasMessage$113 = $m_s_None$();
  this.UserDefinedFacetMatchesBuiltInFacets$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "user-defined-facets-matches-built-in", "User defined facet name matches built in facet of type", ramlMessage$113, oasMessage$113);
  var ramlMessage$114 = $m_s_None$();
  var oasMessage$114 = $m_s_None$();
  this.InvalidEndpointDeclaration$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-endpoint-declaration", "Invalid endpoint declaration", ramlMessage$114, oasMessage$114);
  var ramlMessage$115 = $m_s_None$();
  var oasMessage$115 = $m_s_None$();
  this.UserDefinedFacetMatchesAncestorsTypeFacets$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "user-defined-facets-matches-ancestor", "User defined facet name matches ancestor type facet", ramlMessage$115, oasMessage$115);
  var ramlMessage$116 = $m_s_None$();
  var oasMessage$116 = $m_s_None$();
  this.SlashInUriParameterValues$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "slash-in-uri-parameter-value", "Values of uri parameter must not contain '/' character", ramlMessage$116, oasMessage$116);
  var ramlMessage$117 = $m_s_None$();
  var oasMessage$117 = $m_s_None$();
  this.ItemsFieldRequired$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "items-field-required", "'items' field is required when type is array", ramlMessage$117, oasMessage$117);
  var ramlMessage$118 = $m_s_None$();
  var oasMessage$118 = $m_s_None$();
  this.InvalidIdentifier$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-identifier", "'id' must be a string", ramlMessage$118, oasMessage$118);
  var ramlMessage$119 = $m_s_None$();
  var oasMessage$119 = $m_s_None$();
  this.ExeededMaxYamlReferences$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "max-yaml-references", "Exceeded maximum yaml references threshold", ramlMessage$119, oasMessage$119);
  var ramlMessage$120 = $m_s_None$();
  var oasMessage$120 = $m_s_None$();
  this.MissingParameterType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "missing-parameter-type", "Missing parameter type", ramlMessage$120, oasMessage$120);
  var ramlMessage$121 = $m_s_None$();
  var oasMessage$121 = $m_s_None$();
  this.InvalidStatusCode$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-status-code", "Status code for a Response object must be a string", ramlMessage$121, oasMessage$121);
  var ramlMessage$122 = $m_s_None$();
  var oasMessage$122 = $m_s_None$();
  this.UnknownYamlTag$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "unknown-yaml-tag", "Unknown tag detected, must be allowed by json schema ruleset", ramlMessage$122, oasMessage$122);
  var jsx$35 = $m_s_Predef$().Map$2;
  var self = this.ExclusiveLinkTargetError$1.id$1;
  var $$this = self;
  var lvl = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var y = $f_Lamf_plugins_features_validation_Validations__all__T__sci_Map(this, lvl);
  var jsx$34 = new $c_T2().init___O__O($$this, y);
  var self$1 = this.OasBodyAndFormDataParameterSpecification$1.id$1;
  var $$this$3 = self$1;
  var jsx$32 = $m_s_Predef$().Map$2;
  var self$2 = $m_Lamf_OasProfile$();
  var $$this$1 = self$2;
  var y$1 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$31 = new $c_T2().init___O__O($$this$1, y$1);
  var self$3 = $m_Lamf_Oas20Profile$();
  var $$this$2 = self$3;
  var y$2 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var array = [jsx$31, new $c_T2().init___O__O($$this$2, y$2)];
  var y$3 = jsx$32.apply__sc_Seq__sc_GenMap(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
  var jsx$33 = new $c_T2().init___O__O($$this$3, y$3);
  var self$4 = this.OasInvalidBodyParameter$1.id$1;
  var $$this$4 = self$4;
  var lvl$1 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var y$4 = $f_Lamf_plugins_features_validation_Validations__all__T__sci_Map(this, lvl$1);
  var jsx$30 = new $c_T2().init___O__O($$this$4, y$4);
  var self$5 = this.OasInvalidParameterBinding$1.id$1;
  var $$this$5 = self$5;
  var lvl$2 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var y$5 = $f_Lamf_plugins_features_validation_Validations__all__T__sci_Map(this, lvl$2);
  var jsx$29 = new $c_T2().init___O__O($$this$5, y$5);
  var self$6 = this.OasFormDataNotFileSpecification$1.id$1;
  var $$this$8 = self$6;
  var jsx$27 = $m_s_Predef$().Map$2;
  var self$7 = $m_Lamf_OasProfile$();
  var $$this$6 = self$7;
  var y$6 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$26 = new $c_T2().init___O__O($$this$6, y$6);
  var self$8 = $m_Lamf_Oas20Profile$();
  var $$this$7 = self$8;
  var y$7 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var array$1 = [jsx$26, new $c_T2().init___O__O($$this$7, y$7)];
  var y$8 = jsx$27.apply__sc_Seq__sc_GenMap(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
  var jsx$28 = new $c_T2().init___O__O($$this$8, y$8);
  var self$9 = this.JsonSchemaInheratinaceWarningSpecification$1.id$1;
  var $$this$9 = self$9;
  var lvl$3 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var y$9 = $f_Lamf_plugins_features_validation_Validations__all__T__sci_Map(this, lvl$3);
  var jsx$25 = new $c_T2().init___O__O($$this$9, y$9);
  var self$10 = this.PatternPropertiesOnClosedNodeSpecification$1.id$1;
  var $$this$17 = self$10;
  var jsx$23 = $m_s_Predef$().Map$2;
  var self$11 = $m_Lamf_RamlProfile$();
  var $$this$10 = self$11;
  var y$10 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$22 = new $c_T2().init___O__O($$this$10, y$10);
  var self$12 = $m_Lamf_Raml10Profile$();
  var $$this$11 = self$12;
  var y$11 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$21 = new $c_T2().init___O__O($$this$11, y$11);
  var self$13 = $m_Lamf_Raml08Profile$();
  var $$this$12 = self$13;
  var y$12 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$20 = new $c_T2().init___O__O($$this$12, y$12);
  var self$14 = $m_Lamf_OasProfile$();
  var $$this$13 = self$14;
  var y$13 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var jsx$19 = new $c_T2().init___O__O($$this$13, y$13);
  var self$15 = $m_Lamf_Oas20Profile$();
  var $$this$14 = self$15;
  var y$14 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var jsx$18 = new $c_T2().init___O__O($$this$14, y$14);
  var self$16 = $m_Lamf_Oas30Profile$();
  var $$this$15 = self$16;
  var y$15 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var jsx$17 = new $c_T2().init___O__O($$this$15, y$15);
  var self$17 = $m_Lamf_AmfProfile$();
  var $$this$16 = self$17;
  var y$16 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var array$2 = [jsx$22, jsx$21, jsx$20, jsx$19, jsx$18, jsx$17, new $c_T2().init___O__O($$this$16, y$16)];
  var y$17 = jsx$23.apply__sc_Seq__sc_GenMap(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2));
  var jsx$24 = new $c_T2().init___O__O($$this$17, y$17);
  var self$18 = this.DiscriminatorOnExtendedUnionSpecification$1.id$1;
  var $$this$25 = self$18;
  var jsx$15 = $m_s_Predef$().Map$2;
  var self$19 = $m_Lamf_RamlProfile$();
  var $$this$18 = self$19;
  var y$18 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$14 = new $c_T2().init___O__O($$this$18, y$18);
  var self$20 = $m_Lamf_Raml10Profile$();
  var $$this$19 = self$20;
  var y$19 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$13 = new $c_T2().init___O__O($$this$19, y$19);
  var self$21 = $m_Lamf_Raml08Profile$();
  var $$this$20 = self$21;
  var y$20 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$12 = new $c_T2().init___O__O($$this$20, y$20);
  var self$22 = $m_Lamf_OasProfile$();
  var $$this$21 = self$22;
  var y$21 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var jsx$11 = new $c_T2().init___O__O($$this$21, y$21);
  var self$23 = $m_Lamf_Oas20Profile$();
  var $$this$22 = self$23;
  var y$22 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var jsx$10 = new $c_T2().init___O__O($$this$22, y$22);
  var self$24 = $m_Lamf_Oas30Profile$();
  var $$this$23 = self$24;
  var y$23 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var jsx$9 = new $c_T2().init___O__O($$this$23, y$23);
  var self$25 = $m_Lamf_AmfProfile$();
  var $$this$24 = self$25;
  var y$24 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var array$3 = [jsx$14, jsx$13, jsx$12, jsx$11, jsx$10, jsx$9, new $c_T2().init___O__O($$this$24, y$24)];
  var y$25 = jsx$15.apply__sc_Seq__sc_GenMap(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$3));
  var jsx$16 = new $c_T2().init___O__O($$this$25, y$25);
  var self$26 = this.NullAbstractDeclaration$1.id$1;
  var $$this$26 = self$26;
  var lvl$4 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var y$26 = $f_Lamf_plugins_features_validation_Validations__all__T__sci_Map(this, lvl$4);
  var jsx$8 = new $c_T2().init___O__O($$this$26, y$26);
  var self$27 = this.SchemaDeprecated$1.id$1;
  var $$this$27 = self$27;
  var lvl$5 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var y$27 = $f_Lamf_plugins_features_validation_Validations__all__T__sci_Map(this, lvl$5);
  var jsx$7 = new $c_T2().init___O__O($$this$27, y$27);
  var self$28 = this.SchemasDeprecated$1.id$1;
  var $$this$28 = self$28;
  var lvl$6 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var y$28 = $f_Lamf_plugins_features_validation_Validations__all__T__sci_Map(this, lvl$6);
  var jsx$6 = new $c_T2().init___O__O($$this$28, y$28);
  var self$29 = this.UnusedBaseUriParameter$1.id$1;
  var $$this$29 = self$29;
  var lvl$7 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var y$29 = $f_Lamf_plugins_features_validation_Validations__all__T__sci_Map(this, lvl$7);
  var jsx$5 = new $c_T2().init___O__O($$this$29, y$29);
  var self$30 = this.InvalidShapeFormat$1.id$1;
  var $$this$30 = self$30;
  var lvl$8 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var y$30 = $f_Lamf_plugins_features_validation_Validations__all__T__sci_Map(this, lvl$8);
  var jsx$4 = new $c_T2().init___O__O($$this$30, y$30);
  var self$31 = this.CrossSecurityWarningSpecification$1.id$1;
  var $$this$31 = self$31;
  var lvl$9 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var y$31 = $f_Lamf_plugins_features_validation_Validations__all__T__sci_Map(this, lvl$9);
  var jsx$3 = new $c_T2().init___O__O($$this$31, y$31);
  var self$32 = this.ReadOnlyPropertyMarkedRequired$1.id$1;
  var $$this$32 = self$32;
  var lvl$10 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var y$32 = $f_Lamf_plugins_features_validation_Validations__all__T__sci_Map(this, lvl$10);
  var jsx$2 = new $c_T2().init___O__O($$this$32, y$32);
  var self$33 = this.MissingDiscriminatorProperty$1.id$1;
  var $$this$33 = self$33;
  var lvl$11 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var y$33 = $f_Lamf_plugins_features_validation_Validations__all__T__sci_Map(this, lvl$11);
  var jsx$1 = new $c_T2().init___O__O($$this$33, y$33);
  var self$34 = this.InvalidPayload$1.id$1;
  var $$this$34 = self$34;
  var lvl$12 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var y$34 = $f_Lamf_plugins_features_validation_Validations__all__T__sci_Map(this, lvl$12);
  var array$4 = [jsx$34, jsx$33, jsx$30, jsx$29, jsx$28, jsx$25, jsx$24, jsx$16, jsx$8, jsx$7, jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, jsx$1, new $c_T2().init___O__O($$this$34, y$34)];
  this.levels$1 = $as_sci_Map(jsx$35.apply__sc_Seq__sc_GenMap(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$4)));
  $m_sci_List$();
  var array$5 = [this.ChainedReferenceSpecification$1, this.ExclusivePropertiesSpecification$1, this.PathTemplateUnbalancedParameters$1, this.UnknownSecuritySchemeErrorSpecification$1, this.MissingSecuritySchemeErrorSpecification$1, this.UnknownScopeErrorSpecification$1, this.JsonSchemaInheratinaceWarningSpecification$1, this.XmlSchemaInheratinaceWarningSpecification$1, this.DuplicatedPropertySpecification$1, this.ExamplesMustBeAMap$1, this.ExamplesMustBeASeq$1, this.UnsupportedExampleMediaTypeErrorSpecification$1, this.OasInvalidBodyParameter$1, this.DuplicatedParameters$1, this.DuplicatedTags$1, this.PatternPropertiesOnClosedNodeSpecification$1, this.DiscriminatorOnExtendedUnionSpecification$1, this.OasFormDataNotFileSpecification$1, this.OasBodyAndFormDataParameterSpecification$1, this.OasInvalidParameterBinding$1, this.UnableToParseJsonSchema$1, this.UnexpectedRamlScalarKey$1, this.UnableToParseShapeExtensions$1, this.InvalidAbstractDeclarationType$1, this.NullAbstractDeclaration$1, this.UnexpectedVendor$1, this.InvalidDisjointUnionType$1, this.InvalidOrType$1, this.InvalidAndType$1, this.InvalidXoneType$1, this.InvalidAdditionalPropertiesType$1, this.InvalidAdditionalItemsType$1, this.InvalidRequiredArrayForSchemaVersion$1, this.InvalidRequiredBooleanForSchemaVersion$1, this.InvalidSchemaType$1, this.UnableToSetDefaultType$1, this.InvalidTypeDefinition$1, this.InvalidTupleType$1, this.UnableToParseArray$1, this.InvalidDecimalPoint$1, this.InvalidPropertyType$1, this.JsonSchemaFragmentNotFound$1, this.InvalidJsonSchemaExpression$1, this.InvalidXmlSchemaType$1, this.InvalidExternalTypeType$1, this.InvalidAbstractDeclarationParameterInType$1, this.ExclusiveSchemaType$1, this.SchemaDeprecated$1, this.UnresolvedParameter$1, this.ParameterNameRequired$1, this.RequestBodyContentRequired$1, this.DiscriminatorNameRequired$1, this.InvalidSecuredByType$1, this.ScopeNamesMustBeEmpty$1, this.InvalidSecuritySchemeDescribedByType$1, this.InvalidEndpointPath$1, this.DuplicatedEndpointPath$1, this.DuplicatedOperationId$1, this.InvalidOperationType$1, this.InvalidServerPath$1, this.ParametersWithoutBaseUri$1, this.UnusedBaseUriParameter$1, this.InvalidBaseUriParametersType$1, this.InvalidBasePath$1, this.InvalidParameterType$1, this.InvalidMediaTypeType$1, this.InvalidJsonSchemaVersion$1, this.InvalidEndpointType$1, this.UnableToParseShape$1, this.InvalidAnnotationType$1, this.InvalidAnnotationTarget$1, this.InvalidFragmentType$1, this.InvalidTypesType$1, this.SchemasDeprecated$1, this.ExclusiveSchemasType$1, this.InvalidDocumentationType$1, this.InvalidAllowedTargetsType$1, this.InvalidTypeExpression$1, this.InvalidExtensionsType$1, this.ModuleNotFound$1, this.UnexpectedReference$1, this.InvalidShapeFormat$1, this.UnexpectedFileTypesSyntax$1, this.InvalidJsonSchemaType$1, this.CrossSecurityWarningSpecification$1, this.ReadOnlyPropertyMarkedRequired$1, this.MissingDiscriminatorProperty$1, this.InvalidPayload$1, this.InvalidValueInPropertiesFacet$1, this.InvalidUserDefinedFacetName$1, this.InvalidFieldNameInComponents$1, this.MissingRequiredUserDefinedFacet$1, this.ParameterMissingSchemaOrContent$1, this.ServerVariableMissingDefault$1, this.SlashInUriParameterValues$1, this.InvalidDatetimeFormat$1, this.ItemsFieldRequired$1, this.InvalidTagType$1, this.InvalidIdentifier$1, this.InvalidComponents$1, this.ExeededMaxYamlReferences$1, this.InvalidStatusCode$1, this.UnknownYamlTag$1];
  var xs = new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$5);
  this.validations$1 = $f_sc_IndexedSeqOptimized__toList__sci_List(xs);
  return this
});
$c_Lamf_validations_ParserSideValidations$.prototype.namespace__Lamf_core_vocabulary_Namespace = (function() {
  return this.namespace$1
});
$c_Lamf_validations_ParserSideValidations$.prototype.specification__T = (function() {
  return this.specification$1
});
var $d_Lamf_validations_ParserSideValidations$ = new $TypeData().initClass({
  Lamf_validations_ParserSideValidations$: 0
}, false, "amf.validations.ParserSideValidations$", {
  Lamf_validations_ParserSideValidations$: 1,
  O: 1,
  Lamf_plugins_features_validation_Validations: 1
});
$c_Lamf_validations_ParserSideValidations$.prototype.$classData = $d_Lamf_validations_ParserSideValidations$;
var $n_Lamf_validations_ParserSideValidations$ = (void 0);
function $m_Lamf_validations_ParserSideValidations$() {
  if ((!$n_Lamf_validations_ParserSideValidations$)) {
    $n_Lamf_validations_ParserSideValidations$ = new $c_Lamf_validations_ParserSideValidations$().init___()
  };
  return $n_Lamf_validations_ParserSideValidations$
}
/** @constructor */
function $c_Lamf_validations_PayloadValidations$() {
  $c_O.call(this);
  this.specification$1 = null;
  this.namespace$1 = null;
  this.UnsupportedExampleMediaTypeWarningSpecification$1 = null;
  this.ExampleValidationErrorSpecification$1 = null;
  this.SchemaException$1 = null;
  this.levels$1 = null;
  this.validations$1 = null;
  this.amf$plugins$features$validation$Validations$$default$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_validations_PayloadValidations$.prototype = new $h_O();
$c_Lamf_validations_PayloadValidations$.prototype.constructor = $c_Lamf_validations_PayloadValidations$;
/** @constructor */
function $h_Lamf_validations_PayloadValidations$() {
  /*<skip>*/
}
$h_Lamf_validations_PayloadValidations$.prototype = $c_Lamf_validations_PayloadValidations$.prototype;
$c_Lamf_validations_PayloadValidations$.prototype.init___ = (function() {
  $n_Lamf_validations_PayloadValidations$ = this;
  this.specification$1 = $m_Lamf_core_validation_core_ValidationSpecification$().PAYLOAD$undVALIDATION$1;
  this.namespace$1 = $m_Lamf_core_vocabulary_Namespace$().AmfValidation$1;
  var ramlMessage = $m_s_None$();
  var oasMessage = $m_s_None$();
  this.UnsupportedExampleMediaTypeWarningSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "unsupported-example-media-type-warning", "Cannot validate example with unsupported media type", ramlMessage, oasMessage);
  var ramlMessage$1 = $m_s_None$();
  var oasMessage$1 = $m_s_None$();
  this.ExampleValidationErrorSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "example-validation-error", "Example does not validate type", ramlMessage$1, oasMessage$1);
  var ramlMessage$2 = $m_s_None$();
  var oasMessage$2 = $m_s_None$();
  this.SchemaException$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "schema-exception", "Schema exception", ramlMessage$2, oasMessage$2);
  var self = this.UnsupportedExampleMediaTypeWarningSpecification$1.id$1;
  var lvl = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var y = $f_Lamf_plugins_features_validation_Validations__all__T__sci_Map(this, lvl);
  var jsx$8 = new $c_T2().init___O__O(self, y);
  var self$1 = this.ExampleValidationErrorSpecification$1.id$1;
  var self$2 = $m_Lamf_RamlProfile$();
  var y$1 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$6 = new $c_T2().init___O__O(self$2, y$1);
  var self$3 = $m_Lamf_Raml10Profile$();
  var y$2 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$5 = new $c_T2().init___O__O(self$3, y$2);
  var self$4 = $m_Lamf_Raml08Profile$();
  var y$3 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$4 = new $c_T2().init___O__O(self$4, y$3);
  var self$5 = $m_Lamf_OasProfile$();
  var y$4 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var jsx$3 = new $c_T2().init___O__O(self$5, y$4);
  var self$6 = $m_Lamf_Oas20Profile$();
  var y$5 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var jsx$2 = new $c_T2().init___O__O(self$6, y$5);
  var self$7 = $m_Lamf_Oas30Profile$();
  var y$6 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var jsx$1 = new $c_T2().init___O__O(self$7, y$6);
  var self$8 = $m_Lamf_AmfProfile$();
  var y$7 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var array = [jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, jsx$1, new $c_T2().init___O__O(self$8, y$7)];
  var this$21 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$21.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  var y$8 = this$21.elems$1;
  var jsx$7 = new $c_T2().init___O__O(self$1, y$8);
  var self$9 = this.SchemaException$1.id$1;
  var lvl$1 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var y$9 = $f_Lamf_plugins_features_validation_Validations__all__T__sci_Map(this, lvl$1);
  var array$1 = [jsx$8, jsx$7, new $c_T2().init___O__O(self$9, y$9)];
  var this$28 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i$1 = 0;
  var len$1 = $uI(array$1.length);
  while ((i$1 < len$1)) {
    var index$1 = i$1;
    var arg1$1 = array$1[index$1];
    this$28.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1$1));
    i$1 = ((1 + i$1) | 0)
  };
  this.levels$1 = $as_sci_Map(this$28.elems$1);
  $m_sci_List$();
  var array$2 = [this.UnsupportedExampleMediaTypeWarningSpecification$1, this.ExampleValidationErrorSpecification$1, this.SchemaException$1];
  var i$2 = (((-1) + $uI(array$2.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i$2 >= 0)) {
    var this$32 = result;
    var index$2 = i$2;
    var x = array$2[index$2];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$32);
    i$2 = (((-1) + i$2) | 0)
  };
  this.validations$1 = result;
  return this
});
$c_Lamf_validations_PayloadValidations$.prototype.namespace__Lamf_core_vocabulary_Namespace = (function() {
  return this.namespace$1
});
$c_Lamf_validations_PayloadValidations$.prototype.specification__T = (function() {
  return this.specification$1
});
var $d_Lamf_validations_PayloadValidations$ = new $TypeData().initClass({
  Lamf_validations_PayloadValidations$: 0
}, false, "amf.validations.PayloadValidations$", {
  Lamf_validations_PayloadValidations$: 1,
  O: 1,
  Lamf_plugins_features_validation_Validations: 1
});
$c_Lamf_validations_PayloadValidations$.prototype.$classData = $d_Lamf_validations_PayloadValidations$;
var $n_Lamf_validations_PayloadValidations$ = (void 0);
function $m_Lamf_validations_PayloadValidations$() {
  if ((!$n_Lamf_validations_PayloadValidations$)) {
    $n_Lamf_validations_PayloadValidations$ = new $c_Lamf_validations_PayloadValidations$().init___()
  };
  return $n_Lamf_validations_PayloadValidations$
}
/** @constructor */
function $c_Lamf_validations_RenderSideValidations$() {
  $c_O.call(this);
  this.specification$1 = null;
  this.namespace$1 = null;
  this.RenderValidation$1 = null;
  this.levels$1 = null;
  this.validations$1 = null;
  this.amf$plugins$features$validation$Validations$$default$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_validations_RenderSideValidations$.prototype = new $h_O();
$c_Lamf_validations_RenderSideValidations$.prototype.constructor = $c_Lamf_validations_RenderSideValidations$;
/** @constructor */
function $h_Lamf_validations_RenderSideValidations$() {
  /*<skip>*/
}
$h_Lamf_validations_RenderSideValidations$.prototype = $c_Lamf_validations_RenderSideValidations$.prototype;
$c_Lamf_validations_RenderSideValidations$.prototype.init___ = (function() {
  $n_Lamf_validations_RenderSideValidations$ = this;
  this.specification$1 = $m_Lamf_core_validation_core_ValidationSpecification$().RENDER$undSIDE$undVALIDATION$1;
  this.namespace$1 = $m_Lamf_core_vocabulary_Namespace$().AmfRender$1;
  var ramlMessage = $m_s_None$();
  var oasMessage = $m_s_None$();
  this.RenderValidation$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "render-validation", "Default render validation", ramlMessage, oasMessage);
  this.levels$1 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  $m_sci_List$();
  var array = [this.RenderValidation$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  this.validations$1 = result;
  return this
});
$c_Lamf_validations_RenderSideValidations$.prototype.namespace__Lamf_core_vocabulary_Namespace = (function() {
  return this.namespace$1
});
$c_Lamf_validations_RenderSideValidations$.prototype.specification__T = (function() {
  return this.specification$1
});
var $d_Lamf_validations_RenderSideValidations$ = new $TypeData().initClass({
  Lamf_validations_RenderSideValidations$: 0
}, false, "amf.validations.RenderSideValidations$", {
  Lamf_validations_RenderSideValidations$: 1,
  O: 1,
  Lamf_plugins_features_validation_Validations: 1
});
$c_Lamf_validations_RenderSideValidations$.prototype.$classData = $d_Lamf_validations_RenderSideValidations$;
var $n_Lamf_validations_RenderSideValidations$ = (void 0);
function $m_Lamf_validations_RenderSideValidations$() {
  if ((!$n_Lamf_validations_RenderSideValidations$)) {
    $n_Lamf_validations_RenderSideValidations$ = new $c_Lamf_validations_RenderSideValidations$().init___()
  };
  return $n_Lamf_validations_RenderSideValidations$
}
/** @constructor */
function $c_Lamf_validations_ResolutionSideValidations$() {
  $c_O.call(this);
  this.specification$1 = null;
  this.namespace$1 = null;
  this.UnsupportedPipeline$1 = null;
  this.MissingExtensionInReferences$1 = null;
  this.InvalidTypeInheritanceWarningSpecification$1 = null;
  this.InvalidTypeInheritanceErrorSpecification$1 = null;
  this.NestedEndpoint$1 = null;
  this.UnequalMediaTypeDefinitionsInExtendsPayloads$1 = null;
  this.ParseResourceTypeFail$1 = null;
  this.InvalidConsumesWithFileParameter$1 = null;
  this.ExamplesWithInvalidMimeType$1 = null;
  this.ExamplesWithNoSchemaDefined$1 = null;
  this.levels$1 = null;
  this.validations$1 = null;
  this.amf$plugins$features$validation$Validations$$default$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_validations_ResolutionSideValidations$.prototype = new $h_O();
$c_Lamf_validations_ResolutionSideValidations$.prototype.constructor = $c_Lamf_validations_ResolutionSideValidations$;
/** @constructor */
function $h_Lamf_validations_ResolutionSideValidations$() {
  /*<skip>*/
}
$h_Lamf_validations_ResolutionSideValidations$.prototype = $c_Lamf_validations_ResolutionSideValidations$.prototype;
$c_Lamf_validations_ResolutionSideValidations$.prototype.init___ = (function() {
  $n_Lamf_validations_ResolutionSideValidations$ = this;
  this.specification$1 = $m_Lamf_core_validation_core_ValidationSpecification$().RESOLUTION$undSIDE$undVALIDATION$1;
  this.namespace$1 = $m_Lamf_core_vocabulary_Namespace$().AmfResolution$1;
  var ramlMessage = $m_s_None$();
  var oasMessage = $m_s_None$();
  this.UnsupportedPipeline$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "unsupported-pipeline", "Unsupported pipeline", ramlMessage, oasMessage);
  var ramlMessage$1 = $m_s_None$();
  var oasMessage$1 = $m_s_None$();
  this.MissingExtensionInReferences$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "missing-extension", "Missing extension in reference", ramlMessage$1, oasMessage$1);
  var ramlMessage$2 = $m_s_None$();
  var oasMessage$2 = $m_s_None$();
  this.InvalidTypeInheritanceWarningSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-type-inheritance-warning", "Invalid inheritance relationship", ramlMessage$2, oasMessage$2);
  var ramlMessage$3 = $m_s_None$();
  var oasMessage$3 = $m_s_None$();
  this.InvalidTypeInheritanceErrorSpecification$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-type-inheritance", "Invalid inheritance relationship", ramlMessage$3, oasMessage$3);
  var ramlMessage$4 = $m_s_None$();
  var oasMessage$4 = $m_s_None$();
  this.NestedEndpoint$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "nested-endpoint", "Nested endpoints", ramlMessage$4, oasMessage$4);
  var ramlMessage$5 = $m_s_None$();
  var oasMessage$5 = $m_s_None$();
  this.UnequalMediaTypeDefinitionsInExtendsPayloads$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "unequal-media-type-definitions-in-extends-payloads", "Cannot merge payloads with explicit and implicit media types", ramlMessage$5, oasMessage$5);
  var ramlMessage$6 = $m_s_None$();
  var oasMessage$6 = $m_s_None$();
  this.ParseResourceTypeFail$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "parse-resource-type-fail", "Failed while parsing an endpoint from a resource type", ramlMessage$6, oasMessage$6);
  var ramlMessage$7 = $m_s_None$();
  var oasMessage$7 = $m_s_None$();
  this.InvalidConsumesWithFileParameter$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "invalid-consumes-with-file-parameter", "File parameters must have specific consumes property defined", ramlMessage$7, oasMessage$7);
  var ramlMessage$8 = $m_s_None$();
  var oasMessage$8 = $m_s_None$();
  this.ExamplesWithInvalidMimeType$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "examples-with-invalid-mime-type", "Mime type defined in 'examples' must be present in a 'produces' property", ramlMessage$8, oasMessage$8);
  var ramlMessage$9 = $m_s_None$();
  var oasMessage$9 = $m_s_None$();
  this.ExamplesWithNoSchemaDefined$1 = $f_Lamf_plugins_features_validation_Validations__validation__T__T__s_Option__s_Option__Lamf_core_validation_core_ValidationSpecification(this, "examples-with-no-schema-defined", "When schema is undefined, 'examples' facet is invalid as no content is returned as part of the response", ramlMessage$9, oasMessage$9);
  var self = this.InvalidTypeInheritanceWarningSpecification$1.id$1;
  var lvl = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  var y = $f_Lamf_plugins_features_validation_Validations__all__T__sci_Map(this, lvl);
  var array = [new $c_T2().init___O__O(self, y)];
  var this$6 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$6.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  this.levels$1 = $as_sci_Map(this$6.elems$1);
  $m_sci_List$();
  var array$1 = [this.MissingExtensionInReferences$1, this.InvalidTypeInheritanceErrorSpecification$1, this.InvalidTypeInheritanceWarningSpecification$1, this.NestedEndpoint$1, this.UnequalMediaTypeDefinitionsInExtendsPayloads$1, this.ParseResourceTypeFail$1, this.UnsupportedPipeline$1, this.InvalidConsumesWithFileParameter$1, this.ExamplesWithInvalidMimeType$1, this.ExamplesWithNoSchemaDefined$1];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$10 = result;
    var index$1 = i$1;
    var x = array$1[index$1];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$10);
    i$1 = (((-1) + i$1) | 0)
  };
  this.validations$1 = result;
  return this
});
$c_Lamf_validations_ResolutionSideValidations$.prototype.namespace__Lamf_core_vocabulary_Namespace = (function() {
  return this.namespace$1
});
$c_Lamf_validations_ResolutionSideValidations$.prototype.specification__T = (function() {
  return this.specification$1
});
var $d_Lamf_validations_ResolutionSideValidations$ = new $TypeData().initClass({
  Lamf_validations_ResolutionSideValidations$: 0
}, false, "amf.validations.ResolutionSideValidations$", {
  Lamf_validations_ResolutionSideValidations$: 1,
  O: 1,
  Lamf_plugins_features_validation_Validations: 1
});
$c_Lamf_validations_ResolutionSideValidations$.prototype.$classData = $d_Lamf_validations_ResolutionSideValidations$;
var $n_Lamf_validations_ResolutionSideValidations$ = (void 0);
function $m_Lamf_validations_ResolutionSideValidations$() {
  if ((!$n_Lamf_validations_ResolutionSideValidations$)) {
    $n_Lamf_validations_ResolutionSideValidations$ = new $c_Lamf_validations_ResolutionSideValidations$().init___()
  };
  return $n_Lamf_validations_ResolutionSideValidations$
}
/** @constructor */
function $c_Ljava_nio_charset_Charset() {
  $c_O.call(this);
  this.aliasesSet$1 = null;
  this.cachedDecoder$1 = null;
  this.cachedEncoder$1 = null;
  this.canonicalName$1 = null;
  this.java$nio$charset$Charset$$$undaliases$1 = null;
  this.bitmap$0$1 = 0
}
$c_Ljava_nio_charset_Charset.prototype = new $h_O();
$c_Ljava_nio_charset_Charset.prototype.constructor = $c_Ljava_nio_charset_Charset;
/** @constructor */
function $h_Ljava_nio_charset_Charset() {
  /*<skip>*/
}
$h_Ljava_nio_charset_Charset.prototype = $c_Ljava_nio_charset_Charset.prototype;
$c_Ljava_nio_charset_Charset.prototype.cachedEncoder__p1__Ljava_nio_charset_CharsetEncoder = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.cachedEncoder$lzycompute__p1__Ljava_nio_charset_CharsetEncoder() : this.cachedEncoder$1)
});
$c_Ljava_nio_charset_Charset.prototype.cachedEncoder$lzycompute__p1__Ljava_nio_charset_CharsetEncoder = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.cachedEncoder$1 = new $c_Ljava_nio_charset_UTF$und8$Encoder().init___().onMalformedInput__Ljava_nio_charset_CodingErrorAction__Ljava_nio_charset_CharsetEncoder($m_Ljava_nio_charset_CodingErrorAction$().REPLACE$1).onUnmappableCharacter__Ljava_nio_charset_CodingErrorAction__Ljava_nio_charset_CharsetEncoder($m_Ljava_nio_charset_CodingErrorAction$().REPLACE$1);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.cachedEncoder$1
});
$c_Ljava_nio_charset_Charset.prototype.init___T__AT = (function(canonicalName, _aliases) {
  this.canonicalName$1 = canonicalName;
  this.java$nio$charset$Charset$$$undaliases$1 = _aliases;
  return this
});
$c_Ljava_nio_charset_Charset.prototype.equals__O__Z = (function(that) {
  if ((that instanceof $c_Ljava_nio_charset_Charset)) {
    var x2 = $as_Ljava_nio_charset_Charset(that);
    return (this.canonicalName$1 === x2.canonicalName$1)
  } else {
    return false
  }
});
$c_Ljava_nio_charset_Charset.prototype.compareTo__O__I = (function(x$1) {
  var that = $as_Ljava_nio_charset_Charset(x$1);
  return $m_sjsr_RuntimeString$().compareToIgnoreCase__T__T__I(this.canonicalName$1, that.canonicalName$1)
});
$c_Ljava_nio_charset_Charset.prototype.toString__T = (function() {
  return this.canonicalName$1
});
$c_Ljava_nio_charset_Charset.prototype.encode__T__Ljava_nio_ByteBuffer = (function(str) {
  var this$1 = $m_Ljava_nio_CharBuffer$();
  var cb = this$1.wrap__jl_CharSequence__I__I__Ljava_nio_CharBuffer(str, 0, $uI(str.length));
  return this.cachedEncoder__p1__Ljava_nio_charset_CharsetEncoder().encode__Ljava_nio_CharBuffer__Ljava_nio_ByteBuffer(cb)
});
$c_Ljava_nio_charset_Charset.prototype.hashCode__I = (function() {
  return $m_sr_Statics$().anyHash__O__I(this.canonicalName$1)
});
function $as_Ljava_nio_charset_Charset(obj) {
  return (((obj instanceof $c_Ljava_nio_charset_Charset) || (obj === null)) ? obj : $throwClassCastException(obj, "java.nio.charset.Charset"))
}
function $isArrayOf_Ljava_nio_charset_Charset(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Ljava_nio_charset_Charset)))
}
function $asArrayOf_Ljava_nio_charset_Charset(obj, depth) {
  return (($isArrayOf_Ljava_nio_charset_Charset(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.nio.charset.Charset;", depth))
}
/** @constructor */
function $c_Ljava_nio_charset_UTF$und8$Decoder() {
  $c_Ljava_nio_charset_CharsetDecoder.call(this)
}
$c_Ljava_nio_charset_UTF$und8$Decoder.prototype = new $h_Ljava_nio_charset_CharsetDecoder();
$c_Ljava_nio_charset_UTF$und8$Decoder.prototype.constructor = $c_Ljava_nio_charset_UTF$und8$Decoder;
/** @constructor */
function $h_Ljava_nio_charset_UTF$und8$Decoder() {
  /*<skip>*/
}
$h_Ljava_nio_charset_UTF$und8$Decoder.prototype = $c_Ljava_nio_charset_UTF$und8$Decoder.prototype;
$c_Ljava_nio_charset_UTF$und8$Decoder.prototype.init___ = (function() {
  $c_Ljava_nio_charset_CharsetDecoder.prototype.init___Ljava_nio_charset_Charset__F__F.call(this, $m_Ljava_nio_charset_UTF$und8$(), 1.0, 1.0);
  return this
});
$c_Ljava_nio_charset_UTF$und8$Decoder.prototype.decodeLoop__Ljava_nio_ByteBuffer__Ljava_nio_CharBuffer__Ljava_nio_charset_CoderResult = (function($in, out) {
  if (((($in.$$undarray$2 !== null) && (!$in.$$undreadOnly$3)) && ((out.$$undarray$2 !== null) && (!out.isReadOnly__Z())))) {
    return this.decodeLoopArray__p2__Ljava_nio_ByteBuffer__Ljava_nio_CharBuffer__Ljava_nio_charset_CoderResult($in, out)
  } else {
    _loop: while (true) {
      var startPosition = $in.java$nio$Buffer$$$undposition$1;
      if (($in.java$nio$Buffer$$$undposition$1 === $in.$$undlimit$1)) {
        return $m_Ljava_nio_charset_CoderResult$().UNDERFLOW$1
      } else {
        var leading = $in.get__B();
        if ((leading >= 0)) {
          if ((out.java$nio$Buffer$$$undposition$1 === out.$$undlimit$1)) {
            var result = $m_Ljava_nio_charset_CoderResult$().OVERFLOW$1;
            $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, startPosition);
            return result
          } else {
            out.put__C__Ljava_nio_CharBuffer((65535 & leading));
            continue _loop
          }
        } else {
          var length = $m_Ljava_nio_charset_UTF$und8$().java$nio$charset$UTF$und8$$lengthByLeading$2.get((127 & leading));
          if ((length === (-1))) {
            var this$5 = $m_Ljava_nio_charset_CoderResult$();
            var result$1 = this$5.java$nio$charset$CoderResult$$Malformed1$1;
            $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, startPosition);
            return result$1
          } else {
            if (($in.java$nio$Buffer$$$undposition$1 !== $in.$$undlimit$1)) {
              var b2 = $in.get__B();
              if (((192 & b2) !== 128)) {
                var this$6 = $m_Ljava_nio_charset_CoderResult$();
                var failure = this$6.java$nio$charset$CoderResult$$Malformed1$1;
                var decoded_$_failure$1 = failure;
                var decoded_$_high$1 = 0;
                var decoded_$_low$1 = 0
              } else if ((length === 2)) {
                var codePoint = (((31 & leading) << 6) | (63 & b2));
                if ((codePoint < 128)) {
                  var this$8 = $m_Ljava_nio_charset_CoderResult$();
                  var failure$1 = this$8.java$nio$charset$CoderResult$$Malformed1$1;
                  var decoded_$_failure$1 = failure$1;
                  var decoded_$_high$1 = 0;
                  var decoded_$_low$1 = 0
                } else {
                  var single = (65535 & codePoint);
                  var decoded_$_failure$1 = null;
                  var decoded_$_high$1 = single;
                  var decoded_$_low$1 = 0
                }
              } else if (($in.java$nio$Buffer$$$undposition$1 !== $in.$$undlimit$1)) {
                var b3 = $in.get__B();
                if (((192 & b3) !== 128)) {
                  var this$11 = $m_Ljava_nio_charset_CoderResult$();
                  var failure$2 = this$11.java$nio$charset$CoderResult$$Malformed2$1;
                  var decoded_$_failure$1 = failure$2;
                  var decoded_$_high$1 = 0;
                  var decoded_$_low$1 = 0
                } else if ((length === 3)) {
                  var codePoint$1 = ((((15 & leading) << 12) | ((63 & b2) << 6)) | (63 & b3));
                  if ((codePoint$1 < 2048)) {
                    var this$13 = $m_Ljava_nio_charset_CoderResult$();
                    var failure$3 = this$13.java$nio$charset$CoderResult$$Malformed1$1;
                    var decoded_$_failure$1 = failure$3;
                    var decoded_$_high$1 = 0;
                    var decoded_$_low$1 = 0
                  } else if (((codePoint$1 >= 55296) && (codePoint$1 <= 57343))) {
                    var this$15 = $m_Ljava_nio_charset_CoderResult$();
                    var failure$4 = this$15.java$nio$charset$CoderResult$$Malformed3$1;
                    var decoded_$_failure$1 = failure$4;
                    var decoded_$_high$1 = 0;
                    var decoded_$_low$1 = 0
                  } else {
                    var single$1 = (65535 & codePoint$1);
                    var decoded_$_failure$1 = null;
                    var decoded_$_high$1 = single$1;
                    var decoded_$_low$1 = 0
                  }
                } else if (($in.java$nio$Buffer$$$undposition$1 !== $in.$$undlimit$1)) {
                  var b4 = $in.get__B();
                  if (((192 & b4) !== 128)) {
                    var this$18 = $m_Ljava_nio_charset_CoderResult$();
                    var failure$5 = this$18.java$nio$charset$CoderResult$$Malformed3$1;
                    var decoded_$_failure$1 = failure$5;
                    var decoded_$_high$1 = 0;
                    var decoded_$_low$1 = 0
                  } else {
                    var codePoint$2 = (((((7 & leading) << 18) | ((63 & b2) << 12)) | ((63 & b3) << 6)) | (63 & b4));
                    if (((codePoint$2 < 65536) || (codePoint$2 > 1114111))) {
                      var this$20 = $m_Ljava_nio_charset_CoderResult$();
                      var failure$6 = this$20.java$nio$charset$CoderResult$$Malformed1$1;
                      var decoded_$_failure$1 = failure$6;
                      var decoded_$_high$1 = 0;
                      var decoded_$_low$1 = 0
                    } else {
                      var offsetCodePoint = (((-65536) + codePoint$2) | 0);
                      var high = (65535 & (55296 | (offsetCodePoint >> 10)));
                      var low = (65535 & (56320 | (1023 & offsetCodePoint)));
                      var decoded_$_failure$1 = null;
                      var decoded_$_high$1 = high;
                      var decoded_$_low$1 = low
                    }
                  }
                } else {
                  var failure$7 = $m_Ljava_nio_charset_CoderResult$().UNDERFLOW$1;
                  var decoded_$_failure$1 = failure$7;
                  var decoded_$_high$1 = 0;
                  var decoded_$_low$1 = 0
                }
              } else {
                var failure$8 = $m_Ljava_nio_charset_CoderResult$().UNDERFLOW$1;
                var decoded_$_failure$1 = failure$8;
                var decoded_$_high$1 = 0;
                var decoded_$_low$1 = 0
              }
            } else {
              var failure$9 = $m_Ljava_nio_charset_CoderResult$().UNDERFLOW$1;
              var decoded_$_failure$1 = failure$9;
              var decoded_$_high$1 = 0;
              var decoded_$_low$1 = 0
            };
            if ((decoded_$_failure$1 !== null)) {
              var result$2 = decoded_$_failure$1;
              $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, startPosition);
              return result$2
            } else if ((decoded_$_low$1 === 0)) {
              if ((out.java$nio$Buffer$$$undposition$1 === out.$$undlimit$1)) {
                var result$3 = $m_Ljava_nio_charset_CoderResult$().OVERFLOW$1;
                $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, startPosition);
                return result$3
              } else {
                out.put__C__Ljava_nio_CharBuffer(decoded_$_high$1);
                continue _loop
              }
            } else if ((((out.$$undlimit$1 - out.java$nio$Buffer$$$undposition$1) | 0) < 2)) {
              var result$4 = $m_Ljava_nio_charset_CoderResult$().OVERFLOW$1;
              $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, startPosition);
              return result$4
            } else {
              out.put__C__Ljava_nio_CharBuffer(decoded_$_high$1);
              out.put__C__Ljava_nio_CharBuffer(decoded_$_low$1);
              continue _loop
            }
          }
        }
      }
    }
  }
});
$c_Ljava_nio_charset_UTF$und8$Decoder.prototype.decodeLoopArray__p2__Ljava_nio_ByteBuffer__Ljava_nio_CharBuffer__Ljava_nio_charset_CoderResult = (function($in, out) {
  var a = $in.$$undarray$2;
  if ((a === null)) {
    throw new $c_jl_UnsupportedOperationException().init___()
  };
  if ($in.$$undreadOnly$3) {
    throw new $c_Ljava_nio_ReadOnlyBufferException().init___()
  };
  var o = $in.$$undarrayOffset$2;
  if ((o === (-1))) {
    throw new $c_jl_UnsupportedOperationException().init___()
  };
  if ($in.$$undreadOnly$3) {
    throw new $c_Ljava_nio_ReadOnlyBufferException().init___()
  };
  var inStart = (($in.java$nio$Buffer$$$undposition$1 + o) | 0);
  var inEnd = (($in.$$undlimit$1 + o) | 0);
  var a$1 = out.$$undarray$2;
  if ((a$1 === null)) {
    throw new $c_jl_UnsupportedOperationException().init___()
  };
  if (out.isReadOnly__Z()) {
    throw new $c_Ljava_nio_ReadOnlyBufferException().init___()
  };
  var o$1 = out.$$undarrayOffset$2;
  if ((o$1 === (-1))) {
    throw new $c_jl_UnsupportedOperationException().init___()
  };
  if (out.isReadOnly__Z()) {
    throw new $c_Ljava_nio_ReadOnlyBufferException().init___()
  };
  var outStart = ((out.java$nio$Buffer$$$undposition$1 + o$1) | 0);
  var outEnd = ((out.$$undlimit$1 + o$1) | 0);
  var inPos = inStart;
  var outPos = outStart;
  _loop: while (true) {
    if ((inPos === inEnd)) {
      var result = $m_Ljava_nio_charset_CoderResult$().UNDERFLOW$1;
      var inPos$1 = inPos;
      var outPos$1 = outPos;
      var newPosition = ((inPos$1 - o) | 0);
      $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition);
      var newPosition$1 = ((outPos$1 - o$1) | 0);
      $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call(out, newPosition$1);
      return result
    } else {
      var leading = a.get(inPos);
      if ((leading >= 0)) {
        if ((outPos === outEnd)) {
          var result$1 = $m_Ljava_nio_charset_CoderResult$().OVERFLOW$1;
          var inPos$1$1 = inPos;
          var outPos$1$1 = outPos;
          var newPosition$2 = ((inPos$1$1 - o) | 0);
          $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition$2);
          var newPosition$3 = ((outPos$1$1 - o$1) | 0);
          $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call(out, newPosition$3);
          return result$1
        } else {
          a$1.set(outPos, (65535 & leading));
          var temp$inPos = ((1 + inPos) | 0);
          var temp$outPos = ((1 + outPos) | 0);
          inPos = temp$inPos;
          outPos = temp$outPos;
          continue _loop
        }
      } else {
        var length = $m_Ljava_nio_charset_UTF$und8$().java$nio$charset$UTF$und8$$lengthByLeading$2.get((127 & leading));
        if ((length === (-1))) {
          var this$9 = $m_Ljava_nio_charset_CoderResult$();
          var result$2 = this$9.java$nio$charset$CoderResult$$Malformed1$1;
          var inPos$1$2 = inPos;
          var outPos$1$2 = outPos;
          var newPosition$4 = ((inPos$1$2 - o) | 0);
          $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition$4);
          var newPosition$5 = ((outPos$1$2 - o$1) | 0);
          $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call(out, newPosition$5);
          return result$2
        } else {
          if ((((1 + inPos) | 0) >= inEnd)) {
            var failure = $m_Ljava_nio_charset_CoderResult$().UNDERFLOW$1;
            var decoded_$_failure$1 = failure;
            var decoded_$_high$1 = 0;
            var decoded_$_low$1 = 0
          } else {
            var b2 = a.get(((1 + inPos) | 0));
            if (((192 & b2) !== 128)) {
              var this$11 = $m_Ljava_nio_charset_CoderResult$();
              var failure$1 = this$11.java$nio$charset$CoderResult$$Malformed1$1;
              var decoded_$_failure$1 = failure$1;
              var decoded_$_high$1 = 0;
              var decoded_$_low$1 = 0
            } else if ((length === 2)) {
              var codePoint = (((31 & leading) << 6) | (63 & b2));
              if ((codePoint < 128)) {
                var this$13 = $m_Ljava_nio_charset_CoderResult$();
                var failure$2 = this$13.java$nio$charset$CoderResult$$Malformed1$1;
                var decoded_$_failure$1 = failure$2;
                var decoded_$_high$1 = 0;
                var decoded_$_low$1 = 0
              } else {
                var single = (65535 & codePoint);
                var decoded_$_failure$1 = null;
                var decoded_$_high$1 = single;
                var decoded_$_low$1 = 0
              }
            } else if ((((2 + inPos) | 0) >= inEnd)) {
              var failure$3 = $m_Ljava_nio_charset_CoderResult$().UNDERFLOW$1;
              var decoded_$_failure$1 = failure$3;
              var decoded_$_high$1 = 0;
              var decoded_$_low$1 = 0
            } else {
              var b3 = a.get(((2 + inPos) | 0));
              if (((192 & b3) !== 128)) {
                var this$17 = $m_Ljava_nio_charset_CoderResult$();
                var failure$4 = this$17.java$nio$charset$CoderResult$$Malformed2$1;
                var decoded_$_failure$1 = failure$4;
                var decoded_$_high$1 = 0;
                var decoded_$_low$1 = 0
              } else if ((length === 3)) {
                var codePoint$1 = ((((15 & leading) << 12) | ((63 & b2) << 6)) | (63 & b3));
                if ((codePoint$1 < 2048)) {
                  var this$19 = $m_Ljava_nio_charset_CoderResult$();
                  var failure$5 = this$19.java$nio$charset$CoderResult$$Malformed1$1;
                  var decoded_$_failure$1 = failure$5;
                  var decoded_$_high$1 = 0;
                  var decoded_$_low$1 = 0
                } else if (((codePoint$1 >= 55296) && (codePoint$1 <= 57343))) {
                  var this$21 = $m_Ljava_nio_charset_CoderResult$();
                  var failure$6 = this$21.java$nio$charset$CoderResult$$Malformed3$1;
                  var decoded_$_failure$1 = failure$6;
                  var decoded_$_high$1 = 0;
                  var decoded_$_low$1 = 0
                } else {
                  var single$1 = (65535 & codePoint$1);
                  var decoded_$_failure$1 = null;
                  var decoded_$_high$1 = single$1;
                  var decoded_$_low$1 = 0
                }
              } else if ((((3 + inPos) | 0) >= inEnd)) {
                var failure$7 = $m_Ljava_nio_charset_CoderResult$().UNDERFLOW$1;
                var decoded_$_failure$1 = failure$7;
                var decoded_$_high$1 = 0;
                var decoded_$_low$1 = 0
              } else {
                var b4 = a.get(((3 + inPos) | 0));
                if (((192 & b4) !== 128)) {
                  var this$25 = $m_Ljava_nio_charset_CoderResult$();
                  var failure$8 = this$25.java$nio$charset$CoderResult$$Malformed3$1;
                  var decoded_$_failure$1 = failure$8;
                  var decoded_$_high$1 = 0;
                  var decoded_$_low$1 = 0
                } else {
                  var codePoint$2 = (((((7 & leading) << 18) | ((63 & b2) << 12)) | ((63 & b3) << 6)) | (63 & b4));
                  if (((codePoint$2 < 65536) || (codePoint$2 > 1114111))) {
                    var this$27 = $m_Ljava_nio_charset_CoderResult$();
                    var failure$9 = this$27.java$nio$charset$CoderResult$$Malformed1$1;
                    var decoded_$_failure$1 = failure$9;
                    var decoded_$_high$1 = 0;
                    var decoded_$_low$1 = 0
                  } else {
                    var offsetCodePoint = (((-65536) + codePoint$2) | 0);
                    var high = (65535 & (55296 | (offsetCodePoint >> 10)));
                    var low = (65535 & (56320 | (1023 & offsetCodePoint)));
                    var decoded_$_failure$1 = null;
                    var decoded_$_high$1 = high;
                    var decoded_$_low$1 = low
                  }
                }
              }
            }
          };
          if ((decoded_$_failure$1 !== null)) {
            var result$3 = decoded_$_failure$1;
            var inPos$1$3 = inPos;
            var outPos$1$3 = outPos;
            var newPosition$6 = ((inPos$1$3 - o) | 0);
            $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition$6);
            var newPosition$7 = ((outPos$1$3 - o$1) | 0);
            $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call(out, newPosition$7);
            return result$3
          } else if ((decoded_$_low$1 === 0)) {
            if ((outPos === outEnd)) {
              var result$4 = $m_Ljava_nio_charset_CoderResult$().OVERFLOW$1;
              var inPos$1$4 = inPos;
              var outPos$1$4 = outPos;
              var newPosition$8 = ((inPos$1$4 - o) | 0);
              $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition$8);
              var newPosition$9 = ((outPos$1$4 - o$1) | 0);
              $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call(out, newPosition$9);
              return result$4
            } else {
              a$1.set(outPos, decoded_$_high$1);
              var temp$inPos$2 = ((inPos + length) | 0);
              var temp$outPos$2 = ((1 + outPos) | 0);
              inPos = temp$inPos$2;
              outPos = temp$outPos$2;
              continue _loop
            }
          } else if ((((2 + outPos) | 0) > outEnd)) {
            var result$5 = $m_Ljava_nio_charset_CoderResult$().OVERFLOW$1;
            var inPos$1$5 = inPos;
            var outPos$1$5 = outPos;
            var newPosition$10 = ((inPos$1$5 - o) | 0);
            $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition$10);
            var newPosition$11 = ((outPos$1$5 - o$1) | 0);
            $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call(out, newPosition$11);
            return result$5
          } else {
            a$1.set(outPos, decoded_$_high$1);
            a$1.set(((1 + outPos) | 0), decoded_$_low$1);
            var temp$inPos$3 = ((inPos + length) | 0);
            var temp$outPos$3 = ((2 + outPos) | 0);
            inPos = temp$inPos$3;
            outPos = temp$outPos$3;
            continue _loop
          }
        }
      }
    }
  }
});
var $d_Ljava_nio_charset_UTF$und8$Decoder = new $TypeData().initClass({
  Ljava_nio_charset_UTF$und8$Decoder: 0
}, false, "java.nio.charset.UTF_8$Decoder", {
  Ljava_nio_charset_UTF$und8$Decoder: 1,
  Ljava_nio_charset_CharsetDecoder: 1,
  O: 1
});
$c_Ljava_nio_charset_UTF$und8$Decoder.prototype.$classData = $d_Ljava_nio_charset_UTF$und8$Decoder;
/** @constructor */
function $c_Ljava_nio_charset_UTF$und8$Encoder() {
  $c_Ljava_nio_charset_CharsetEncoder.call(this)
}
$c_Ljava_nio_charset_UTF$und8$Encoder.prototype = new $h_Ljava_nio_charset_CharsetEncoder();
$c_Ljava_nio_charset_UTF$und8$Encoder.prototype.constructor = $c_Ljava_nio_charset_UTF$und8$Encoder;
/** @constructor */
function $h_Ljava_nio_charset_UTF$und8$Encoder() {
  /*<skip>*/
}
$h_Ljava_nio_charset_UTF$und8$Encoder.prototype = $c_Ljava_nio_charset_UTF$und8$Encoder.prototype;
$c_Ljava_nio_charset_UTF$und8$Encoder.prototype.init___ = (function() {
  $c_Ljava_nio_charset_CharsetEncoder.prototype.init___Ljava_nio_charset_Charset__F__F.call(this, $m_Ljava_nio_charset_UTF$und8$(), 1.100000023841858, 3.0);
  return this
});
$c_Ljava_nio_charset_UTF$und8$Encoder.prototype.encodeLoop__Ljava_nio_CharBuffer__Ljava_nio_ByteBuffer__Ljava_nio_charset_CoderResult = (function($in, out) {
  if (((($in.$$undarray$2 !== null) && (!$in.isReadOnly__Z())) && ((out.$$undarray$2 !== null) && (!out.$$undreadOnly$3)))) {
    return this.encodeLoopArray__p2__Ljava_nio_CharBuffer__Ljava_nio_ByteBuffer__Ljava_nio_charset_CoderResult($in, out)
  } else {
    _loop: while (true) {
      if (($in.java$nio$Buffer$$$undposition$1 === $in.$$undlimit$1)) {
        return $m_Ljava_nio_charset_CoderResult$().UNDERFLOW$1
      } else {
        var c1 = $in.get__C();
        if ((c1 < 128)) {
          if ((out.java$nio$Buffer$$$undposition$1 === out.$$undlimit$1)) {
            var result = $m_Ljava_nio_charset_CoderResult$().OVERFLOW$1;
            var newPosition = (((-1) + $in.java$nio$Buffer$$$undposition$1) | 0);
            $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition);
            return result
          } else {
            out.put__B__Ljava_nio_ByteBuffer(((c1 << 24) >> 24));
            continue _loop
          }
        } else if ((c1 < 2048)) {
          if ((((out.$$undlimit$1 - out.java$nio$Buffer$$$undposition$1) | 0) < 2)) {
            var result$1 = $m_Ljava_nio_charset_CoderResult$().OVERFLOW$1;
            var newPosition$1 = (((-1) + $in.java$nio$Buffer$$$undposition$1) | 0);
            $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition$1);
            return result$1
          } else {
            out.put__B__Ljava_nio_ByteBuffer((((192 | (c1 >> 6)) << 24) >> 24));
            out.put__B__Ljava_nio_ByteBuffer((((128 | (63 & c1)) << 24) >> 24));
            continue _loop
          }
        } else if ((!($m_Ljava_nio_charset_UTF$und8$(), ((63488 & c1) === 55296)))) {
          if ((((out.$$undlimit$1 - out.java$nio$Buffer$$$undposition$1) | 0) < 3)) {
            var result$2 = $m_Ljava_nio_charset_CoderResult$().OVERFLOW$1;
            var newPosition$2 = (((-1) + $in.java$nio$Buffer$$$undposition$1) | 0);
            $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition$2);
            return result$2
          } else {
            out.put__B__Ljava_nio_ByteBuffer((((224 | (c1 >> 12)) << 24) >> 24));
            out.put__B__Ljava_nio_ByteBuffer((((128 | (63 & (c1 >> 6))) << 24) >> 24));
            out.put__B__Ljava_nio_ByteBuffer((((128 | (63 & c1)) << 24) >> 24));
            continue _loop
          }
        } else if (((64512 & c1) === 55296)) {
          if (($in.java$nio$Buffer$$$undposition$1 === $in.$$undlimit$1)) {
            var result$3 = $m_Ljava_nio_charset_CoderResult$().UNDERFLOW$1;
            var newPosition$3 = (((-1) + $in.java$nio$Buffer$$$undposition$1) | 0);
            $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition$3);
            return result$3
          } else {
            var c2 = $in.get__C();
            if (((64512 & c2) !== 56320)) {
              var this$8 = $m_Ljava_nio_charset_CoderResult$();
              var result$4 = this$8.java$nio$charset$CoderResult$$Malformed1$1;
              var newPosition$4 = (((-2) + $in.java$nio$Buffer$$$undposition$1) | 0);
              $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition$4);
              return result$4
            } else if ((((out.$$undlimit$1 - out.java$nio$Buffer$$$undposition$1) | 0) < 4)) {
              var result$5 = $m_Ljava_nio_charset_CoderResult$().OVERFLOW$1;
              var newPosition$5 = (((-2) + $in.java$nio$Buffer$$$undposition$1) | 0);
              $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition$5);
              return result$5
            } else {
              var cp = ((65536 + ((((1023 & c1) << 10) + (1023 & c2)) | 0)) | 0);
              out.put__B__Ljava_nio_ByteBuffer((((240 | (cp >> 18)) << 24) >> 24));
              out.put__B__Ljava_nio_ByteBuffer((((128 | (63 & (cp >> 12))) << 24) >> 24));
              out.put__B__Ljava_nio_ByteBuffer((((128 | (63 & (cp >> 6))) << 24) >> 24));
              out.put__B__Ljava_nio_ByteBuffer((((128 | (63 & cp)) << 24) >> 24));
              continue _loop
            }
          }
        } else {
          var this$10 = $m_Ljava_nio_charset_CoderResult$();
          var result$6 = this$10.java$nio$charset$CoderResult$$Malformed1$1;
          var newPosition$6 = (((-1) + $in.java$nio$Buffer$$$undposition$1) | 0);
          $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition$6);
          return result$6
        }
      }
    }
  }
});
$c_Ljava_nio_charset_UTF$und8$Encoder.prototype.encodeLoopArray__p2__Ljava_nio_CharBuffer__Ljava_nio_ByteBuffer__Ljava_nio_charset_CoderResult = (function($in, out) {
  var a = $in.$$undarray$2;
  if ((a === null)) {
    throw new $c_jl_UnsupportedOperationException().init___()
  };
  if ($in.isReadOnly__Z()) {
    throw new $c_Ljava_nio_ReadOnlyBufferException().init___()
  };
  var o = $in.$$undarrayOffset$2;
  if ((o === (-1))) {
    throw new $c_jl_UnsupportedOperationException().init___()
  };
  if ($in.isReadOnly__Z()) {
    throw new $c_Ljava_nio_ReadOnlyBufferException().init___()
  };
  var inStart = (($in.java$nio$Buffer$$$undposition$1 + o) | 0);
  var inEnd = (($in.$$undlimit$1 + o) | 0);
  var a$1 = out.$$undarray$2;
  if ((a$1 === null)) {
    throw new $c_jl_UnsupportedOperationException().init___()
  };
  if (out.$$undreadOnly$3) {
    throw new $c_Ljava_nio_ReadOnlyBufferException().init___()
  };
  var o$1 = out.$$undarrayOffset$2;
  if ((o$1 === (-1))) {
    throw new $c_jl_UnsupportedOperationException().init___()
  };
  if (out.$$undreadOnly$3) {
    throw new $c_Ljava_nio_ReadOnlyBufferException().init___()
  };
  var outStart = ((out.java$nio$Buffer$$$undposition$1 + o$1) | 0);
  var outEnd = ((out.$$undlimit$1 + o$1) | 0);
  var inPos = inStart;
  var outPos = outStart;
  _loop: while (true) {
    if ((inPos === inEnd)) {
      var result = $m_Ljava_nio_charset_CoderResult$().UNDERFLOW$1;
      var inPos$2 = inPos;
      var outPos$2 = outPos;
      var newPosition = ((inPos$2 - o) | 0);
      $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition);
      var newPosition$1 = ((outPos$2 - o$1) | 0);
      $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call(out, newPosition$1);
      return result
    } else {
      var c1 = a.get(inPos);
      if ((c1 < 128)) {
        if ((outPos === outEnd)) {
          var result$1 = $m_Ljava_nio_charset_CoderResult$().OVERFLOW$1;
          var inPos$2$1 = inPos;
          var outPos$2$1 = outPos;
          var newPosition$2 = ((inPos$2$1 - o) | 0);
          $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition$2);
          var newPosition$3 = ((outPos$2$1 - o$1) | 0);
          $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call(out, newPosition$3);
          return result$1
        } else {
          a$1.set(outPos, ((c1 << 24) >> 24));
          var temp$inPos = ((1 + inPos) | 0);
          var temp$outPos = ((1 + outPos) | 0);
          inPos = temp$inPos;
          outPos = temp$outPos;
          continue _loop
        }
      } else if ((c1 < 2048)) {
        if ((((2 + outPos) | 0) > outEnd)) {
          var result$2 = $m_Ljava_nio_charset_CoderResult$().OVERFLOW$1;
          var inPos$2$2 = inPos;
          var outPos$2$2 = outPos;
          var newPosition$4 = ((inPos$2$2 - o) | 0);
          $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition$4);
          var newPosition$5 = ((outPos$2$2 - o$1) | 0);
          $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call(out, newPosition$5);
          return result$2
        } else {
          a$1.set(outPos, (((192 | (c1 >> 6)) << 24) >> 24));
          a$1.set(((1 + outPos) | 0), (((128 | (63 & c1)) << 24) >> 24));
          var temp$inPos$2 = ((1 + inPos) | 0);
          var temp$outPos$2 = ((2 + outPos) | 0);
          inPos = temp$inPos$2;
          outPos = temp$outPos$2;
          continue _loop
        }
      } else if ((!($m_Ljava_nio_charset_UTF$und8$(), ((63488 & c1) === 55296)))) {
        if ((((3 + outPos) | 0) > outEnd)) {
          var result$3 = $m_Ljava_nio_charset_CoderResult$().OVERFLOW$1;
          var inPos$2$3 = inPos;
          var outPos$2$3 = outPos;
          var newPosition$6 = ((inPos$2$3 - o) | 0);
          $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition$6);
          var newPosition$7 = ((outPos$2$3 - o$1) | 0);
          $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call(out, newPosition$7);
          return result$3
        } else {
          a$1.set(outPos, (((224 | (c1 >> 12)) << 24) >> 24));
          a$1.set(((1 + outPos) | 0), (((128 | (63 & (c1 >> 6))) << 24) >> 24));
          a$1.set(((2 + outPos) | 0), (((128 | (63 & c1)) << 24) >> 24));
          var temp$inPos$3 = ((1 + inPos) | 0);
          var temp$outPos$3 = ((3 + outPos) | 0);
          inPos = temp$inPos$3;
          outPos = temp$outPos$3;
          continue _loop
        }
      } else if (((64512 & c1) === 55296)) {
        if ((((1 + inPos) | 0) === inEnd)) {
          var result$4 = $m_Ljava_nio_charset_CoderResult$().UNDERFLOW$1;
          var inPos$2$4 = inPos;
          var outPos$2$4 = outPos;
          var newPosition$8 = ((inPos$2$4 - o) | 0);
          $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition$8);
          var newPosition$9 = ((outPos$2$4 - o$1) | 0);
          $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call(out, newPosition$9);
          return result$4
        } else {
          var c2 = a.get(((1 + inPos) | 0));
          if (((64512 & c2) !== 56320)) {
            var this$12 = $m_Ljava_nio_charset_CoderResult$();
            var result$5 = this$12.java$nio$charset$CoderResult$$Malformed1$1;
            var inPos$2$5 = inPos;
            var outPos$2$5 = outPos;
            var newPosition$10 = ((inPos$2$5 - o) | 0);
            $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition$10);
            var newPosition$11 = ((outPos$2$5 - o$1) | 0);
            $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call(out, newPosition$11);
            return result$5
          } else if ((((4 + outPos) | 0) > outEnd)) {
            var result$6 = $m_Ljava_nio_charset_CoderResult$().OVERFLOW$1;
            var inPos$2$6 = inPos;
            var outPos$2$6 = outPos;
            var newPosition$12 = ((inPos$2$6 - o) | 0);
            $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition$12);
            var newPosition$13 = ((outPos$2$6 - o$1) | 0);
            $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call(out, newPosition$13);
            return result$6
          } else {
            var cp = ((65536 + ((((1023 & c1) << 10) + (1023 & c2)) | 0)) | 0);
            a$1.set(outPos, (((240 | (cp >> 18)) << 24) >> 24));
            a$1.set(((1 + outPos) | 0), (((128 | (63 & (cp >> 12))) << 24) >> 24));
            a$1.set(((2 + outPos) | 0), (((128 | (63 & (cp >> 6))) << 24) >> 24));
            a$1.set(((3 + outPos) | 0), (((128 | (63 & cp)) << 24) >> 24));
            var temp$inPos$4 = ((2 + inPos) | 0);
            var temp$outPos$4 = ((4 + outPos) | 0);
            inPos = temp$inPos$4;
            outPos = temp$outPos$4;
            continue _loop
          }
        }
      } else {
        var this$14 = $m_Ljava_nio_charset_CoderResult$();
        var result$7 = this$14.java$nio$charset$CoderResult$$Malformed1$1;
        var inPos$2$7 = inPos;
        var outPos$2$7 = outPos;
        var newPosition$14 = ((inPos$2$7 - o) | 0);
        $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call($in, newPosition$14);
        var newPosition$15 = ((outPos$2$7 - o$1) | 0);
        $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call(out, newPosition$15);
        return result$7
      }
    }
  }
});
var $d_Ljava_nio_charset_UTF$und8$Encoder = new $TypeData().initClass({
  Ljava_nio_charset_UTF$und8$Encoder: 0
}, false, "java.nio.charset.UTF_8$Encoder", {
  Ljava_nio_charset_UTF$und8$Encoder: 1,
  Ljava_nio_charset_CharsetEncoder: 1,
  O: 1
});
$c_Ljava_nio_charset_UTF$und8$Encoder.prototype.$classData = $d_Ljava_nio_charset_UTF$und8$Encoder;
/** @constructor */
function $c_Lorg_mulesoft_common_io_JsBaseFile() {
  $c_O.call(this);
  this.fileSystem$1 = null;
  this.path$1 = null;
  this.prefixLength$1 = 0;
  this.global$1 = null
}
$c_Lorg_mulesoft_common_io_JsBaseFile.prototype = new $h_O();
$c_Lorg_mulesoft_common_io_JsBaseFile.prototype.constructor = $c_Lorg_mulesoft_common_io_JsBaseFile;
/** @constructor */
function $h_Lorg_mulesoft_common_io_JsBaseFile() {
  /*<skip>*/
}
$h_Lorg_mulesoft_common_io_JsBaseFile.prototype = $c_Lorg_mulesoft_common_io_JsBaseFile.prototype;
$c_Lorg_mulesoft_common_io_JsBaseFile.prototype.toString__T = (function() {
  return this.path$1
});
$c_Lorg_mulesoft_common_io_JsBaseFile.prototype.init___Lorg_mulesoft_common_io_JsServerFileSystem__T = (function(fileSystem, path) {
  this.fileSystem$1 = fileSystem;
  this.path$1 = path;
  this.global$1 = $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext();
  this.prefixLength$1 = fileSystem.prefixLength__T__I(path);
  return this
});
/** @constructor */
function $c_Lorg_mulesoft_common_io_JsServerFileSystem() {
  $c_O.call(this)
}
$c_Lorg_mulesoft_common_io_JsServerFileSystem.prototype = new $h_O();
$c_Lorg_mulesoft_common_io_JsServerFileSystem.prototype.constructor = $c_Lorg_mulesoft_common_io_JsServerFileSystem;
/** @constructor */
function $h_Lorg_mulesoft_common_io_JsServerFileSystem() {
  /*<skip>*/
}
$h_Lorg_mulesoft_common_io_JsServerFileSystem.prototype = $c_Lorg_mulesoft_common_io_JsServerFileSystem.prototype;
$c_Lorg_mulesoft_common_io_JsServerFileSystem.prototype.asyncFile__T__Lorg_mulesoft_common_io_AsyncFile = (function(path) {
  return ((path === null) ? null : new $c_Lorg_mulesoft_common_io_JsAsyncFile().init___Lorg_mulesoft_common_io_JsServerFileSystem__T(this, path))
});
$c_Lorg_mulesoft_common_io_JsServerFileSystem.prototype.separatorChar__C = (function() {
  var thiz = $as_T($i_path.sep);
  return (65535 & $uI(thiz.charCodeAt(0)))
});
$c_Lorg_mulesoft_common_io_JsServerFileSystem.prototype.prefixLength__T__I = (function(path) {
  return (($uI(path.length) === 0) ? 0 : (((65535 & $uI(path.charCodeAt(0))) === this.separatorChar__C()) ? 1 : 0))
});
/** @constructor */
function $c_Lorg_mulesoft_common_io_Output$OutputWriter$() {
  $c_O.call(this)
}
$c_Lorg_mulesoft_common_io_Output$OutputWriter$.prototype = new $h_O();
$c_Lorg_mulesoft_common_io_Output$OutputWriter$.prototype.constructor = $c_Lorg_mulesoft_common_io_Output$OutputWriter$;
/** @constructor */
function $h_Lorg_mulesoft_common_io_Output$OutputWriter$() {
  /*<skip>*/
}
$h_Lorg_mulesoft_common_io_Output$OutputWriter$.prototype = $c_Lorg_mulesoft_common_io_Output$OutputWriter$.prototype;
$c_Lorg_mulesoft_common_io_Output$OutputWriter$.prototype.init___ = (function() {
  return this
});
$c_Lorg_mulesoft_common_io_Output$OutputWriter$.prototype.append__O__C__V = (function(w, c) {
  var writer = $as_Ljava_io_Writer(w);
  writer.append__C__Ljava_io_StringWriter(c)
});
$c_Lorg_mulesoft_common_io_Output$OutputWriter$.prototype.append__O__jl_CharSequence__V = (function(w, s) {
  var writer = $as_Ljava_io_Writer(w);
  writer.append__jl_CharSequence__Ljava_io_StringWriter(s)
});
$c_Lorg_mulesoft_common_io_Output$OutputWriter$.prototype.flush__O__V = (function(w) {
  $as_Ljava_io_Writer(w)
});
var $d_Lorg_mulesoft_common_io_Output$OutputWriter$ = new $TypeData().initClass({
  Lorg_mulesoft_common_io_Output$OutputWriter$: 0
}, false, "org.mulesoft.common.io.Output$OutputWriter$", {
  Lorg_mulesoft_common_io_Output$OutputWriter$: 1,
  O: 1,
  Lorg_mulesoft_common_io_Output: 1
});
$c_Lorg_mulesoft_common_io_Output$OutputWriter$.prototype.$classData = $d_Lorg_mulesoft_common_io_Output$OutputWriter$;
var $n_Lorg_mulesoft_common_io_Output$OutputWriter$ = (void 0);
function $m_Lorg_mulesoft_common_io_Output$OutputWriter$() {
  if ((!$n_Lorg_mulesoft_common_io_Output$OutputWriter$)) {
    $n_Lorg_mulesoft_common_io_Output$OutputWriter$ = new $c_Lorg_mulesoft_common_io_Output$OutputWriter$().init___()
  };
  return $n_Lorg_mulesoft_common_io_Output$OutputWriter$
}
/** @constructor */
function $c_Lorg_mulesoft_common_io_Output$StringBufferWriter$() {
  $c_O.call(this)
}
$c_Lorg_mulesoft_common_io_Output$StringBufferWriter$.prototype = new $h_O();
$c_Lorg_mulesoft_common_io_Output$StringBufferWriter$.prototype.constructor = $c_Lorg_mulesoft_common_io_Output$StringBufferWriter$;
/** @constructor */
function $h_Lorg_mulesoft_common_io_Output$StringBufferWriter$() {
  /*<skip>*/
}
$h_Lorg_mulesoft_common_io_Output$StringBufferWriter$.prototype = $c_Lorg_mulesoft_common_io_Output$StringBufferWriter$.prototype;
$c_Lorg_mulesoft_common_io_Output$StringBufferWriter$.prototype.init___ = (function() {
  return this
});
$c_Lorg_mulesoft_common_io_Output$StringBufferWriter$.prototype.append__O__C__V = (function(w, c) {
  $f_Lorg_mulesoft_common_io_Output__append__O__C__V(this, w, c)
});
$c_Lorg_mulesoft_common_io_Output$StringBufferWriter$.prototype.append__O__jl_CharSequence__V = (function(w, s) {
  var w$1 = $as_Lorg_mulesoft_common_io_LimitedStringBuffer(w);
  w$1.append__jl_CharSequence__Lorg_mulesoft_common_io_LimitedStringBuffer(s)
});
$c_Lorg_mulesoft_common_io_Output$StringBufferWriter$.prototype.flush__O__V = (function(w) {
  /*<skip>*/
});
var $d_Lorg_mulesoft_common_io_Output$StringBufferWriter$ = new $TypeData().initClass({
  Lorg_mulesoft_common_io_Output$StringBufferWriter$: 0
}, false, "org.mulesoft.common.io.Output$StringBufferWriter$", {
  Lorg_mulesoft_common_io_Output$StringBufferWriter$: 1,
  O: 1,
  Lorg_mulesoft_common_io_Output: 1
});
$c_Lorg_mulesoft_common_io_Output$StringBufferWriter$.prototype.$classData = $d_Lorg_mulesoft_common_io_Output$StringBufferWriter$;
var $n_Lorg_mulesoft_common_io_Output$StringBufferWriter$ = (void 0);
function $m_Lorg_mulesoft_common_io_Output$StringBufferWriter$() {
  if ((!$n_Lorg_mulesoft_common_io_Output$StringBufferWriter$)) {
    $n_Lorg_mulesoft_common_io_Output$StringBufferWriter$ = new $c_Lorg_mulesoft_common_io_Output$StringBufferWriter$().init___()
  };
  return $n_Lorg_mulesoft_common_io_Output$StringBufferWriter$
}
/** @constructor */
function $c_Lorg_mulesoft_lexer_BaseLexer() {
  $c_O.call(this);
  this.input$1 = null;
  this.positionOffset$1 = null;
  this.tokenQueue$1 = null;
  this.mark$1 = null;
  this.sourceName$1 = null;
  this.$$undtokenData$1 = null
}
$c_Lorg_mulesoft_lexer_BaseLexer.prototype = new $h_O();
$c_Lorg_mulesoft_lexer_BaseLexer.prototype.constructor = $c_Lorg_mulesoft_lexer_BaseLexer;
/** @constructor */
function $h_Lorg_mulesoft_lexer_BaseLexer() {
  /*<skip>*/
}
$h_Lorg_mulesoft_lexer_BaseLexer.prototype = $c_Lorg_mulesoft_lexer_BaseLexer.prototype;
$c_Lorg_mulesoft_lexer_BaseLexer.prototype.position__p1__Lorg_mulesoft_lexer_Position = (function() {
  var this$1 = this.input$1;
  var this$2 = this$1.state$1;
  return $m_Lorg_mulesoft_lexer_Position$().apply__I__I__I__Lorg_mulesoft_lexer_Position(this$2.line$1, this$2.column$1, this$2.offset$1).$$plus__Lorg_mulesoft_lexer_Position__Lorg_mulesoft_lexer_Position(this.positionOffset$1)
});
$c_Lorg_mulesoft_lexer_BaseLexer.prototype.emit__Lorg_mulesoft_lexer_Token__Z = (function(token) {
  var newMark = this.position__p1__Lorg_mulesoft_lexer_Position();
  this.tokenQueue$1.$$plus$eq__O__Lorg_mulesoft_lexer_Queue(new $c_Lorg_mulesoft_lexer_TokenData().init___Lorg_mulesoft_lexer_Token__Lorg_mulesoft_lexer_SourceLocation(token, new $c_Lorg_mulesoft_lexer_SourceLocation().init___T__I__I__I__I__I__I(this.sourceName$1, this.mark$1.offset$1, newMark.offset$1, this.mark$1.line$1, this.mark$1.column$1, newMark.line$1, newMark.column$1)));
  this.mark$1 = newMark;
  return true
});
$c_Lorg_mulesoft_lexer_BaseLexer.prototype.advance__V = (function() {
  while (this.tokenQueue$1.isEmpty__Z()) {
    var this$1 = this.input$1;
    if ((this$1.state$1.current$1 !== $m_Lorg_mulesoft_lexer_LexerInput$().EofChar$1)) {
      var this$2 = this.input$1;
      var p = this$2.state$1.offset$1;
      var this$3 = this.input$1;
      this.findToken__I__V(this$3.state$1.current$1);
      var this$4 = this.input$1;
      if ((p === this$4.state$1.offset$1)) {
        this.advance__V()
      }
    } else {
      this.processPending__V()
    }
  };
  this.$$undtokenData$1 = $as_Lorg_mulesoft_lexer_TokenData(this.tokenQueue$1.dequeue__O())
});
$c_Lorg_mulesoft_lexer_BaseLexer.prototype.init___Lorg_mulesoft_lexer_LexerInput__Lorg_mulesoft_lexer_Position = (function(input, positionOffset) {
  this.input$1 = input;
  this.positionOffset$1 = positionOffset;
  this.tokenQueue$1 = new $c_Lorg_mulesoft_lexer_Queue().init___();
  this.mark$1 = this.position__p1__Lorg_mulesoft_lexer_Position();
  this.sourceName$1 = this.input$1.sourceName$1;
  this.initialize__V();
  return this
});
$c_Lorg_mulesoft_lexer_BaseLexer.prototype.tokenText__Lorg_mulesoft_lexer_TokenData__jl_CharSequence = (function(td) {
  return this.input$1.subSequence__I__I__jl_CharSequence(td.range$1.offsetFrom$1, td.range$1.offsetTo$1)
});
$c_Lorg_mulesoft_lexer_BaseLexer.prototype.consumeAndEmit__I__Lorg_mulesoft_lexer_Token__Z = (function(n, token) {
  return ((n <= 0) || (this.input$1.consume__I__V(n), this.emit__Lorg_mulesoft_lexer_Token__Z(token)))
});
$c_Lorg_mulesoft_lexer_BaseLexer.prototype.consume__C__Z = (function(c) {
  var this$1 = this.input$1;
  if ((this$1.state$1.current$1 === c)) {
    var this$2 = this.input$1;
    this$2.state$1.consume__jl_CharSequence__I__V(this$2.data$1, this$2.endOffset$1);
    return true
  } else {
    return false
  }
});
$c_Lorg_mulesoft_lexer_BaseLexer.prototype.check__T__I = (function(str) {
  var len = $uI(str.length);
  if ((len > 0)) {
    var this$5 = new $c_sci_Range().init___I__I__I(0, len, 1);
    var this$6 = new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this$5, 0, this$5.length__I());
    var res = true;
    while ((res && this$6.hasNext__Z())) {
      var arg1 = this$6.next__O();
      var i = $uI(arg1);
      res = ((65535 & $uI(str.charCodeAt(i))) === this.input$1.lookAhead__I__I(i))
    };
    var jsx$1 = res
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return len
  } else {
    return 0
  }
});
$c_Lorg_mulesoft_lexer_BaseLexer.prototype.consume__T__Z = (function(str) {
  var l = this.check__T__I(str);
  return ((l !== 0) && (this.input$1.consume__I__V(l), true))
});
$c_Lorg_mulesoft_lexer_BaseLexer.prototype.findToken__I__V = (function(chr) {
  /*<skip>*/
});
$c_Lorg_mulesoft_lexer_BaseLexer.prototype.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z = (function(token) {
  var this$1 = this.input$1;
  this$1.state$1.consume__jl_CharSequence__I__V(this$1.data$1, this$1.endOffset$1);
  return this.emit__Lorg_mulesoft_lexer_Token__Z(token)
});
$c_Lorg_mulesoft_lexer_BaseLexer.prototype.emit__Lorg_mulesoft_lexer_Token__Lorg_mulesoft_lexer_Token__Z = (function(t1, t2) {
  this.emit__Lorg_mulesoft_lexer_Token__Z(t1);
  return this.emit__Lorg_mulesoft_lexer_Token__Z(t2)
});
/** @constructor */
function $c_Lorg_mulesoft_lexer_CharSequenceLexerInput() {
  $c_O.call(this);
  this.data$1 = null;
  this.startOffset$1 = 0;
  this.endOffset$1 = 0;
  this.sourceName$1 = null;
  this.state$1 = null
}
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput.prototype = new $h_O();
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput.prototype.constructor = $c_Lorg_mulesoft_lexer_CharSequenceLexerInput;
/** @constructor */
function $h_Lorg_mulesoft_lexer_CharSequenceLexerInput() {
  /*<skip>*/
}
$h_Lorg_mulesoft_lexer_CharSequenceLexerInput.prototype = $c_Lorg_mulesoft_lexer_CharSequenceLexerInput.prototype;
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput.prototype.init___jl_CharSequence__I__I__T = (function(data, startOffset, endOffset, sourceName) {
  this.data$1 = data;
  this.startOffset$1 = startOffset;
  this.endOffset$1 = endOffset;
  this.sourceName$1 = sourceName;
  var x$5 = $m_Lorg_mulesoft_lexer_LexerInput$().EofChar$1;
  this.state$1 = new $c_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState().init___I__I__I__I__I(0, 1, startOffset, startOffset, x$5).init__jl_CharSequence__I__Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState(data, endOffset);
  return this
});
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput.prototype.subSequence__I__I__jl_CharSequence = (function(start, end) {
  if ((((start < this.startOffset$1) || (end > this.endOffset$1)) || (end < start))) {
    throw new $c_jl_IllegalArgumentException().init___T("Invalid sub-sequence")
  };
  return $charSequenceSubSequence(this.data$1, start, end)
});
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput.prototype.countWhiteSpaces__I__I = (function(offset) {
  var i = 0;
  var off = (((-1) + ((this.state$1.nextOffset$1 + offset) | 0)) | 0);
  if ((off < 0)) {
    return 0
  };
  while ((off < this.endOffset$1)) {
    var c = $charSequenceCharAt(this.data$1, off);
    if (((c !== 32) && (c !== 9))) {
      return i
    };
    i = ((1 + i) | 0);
    off = ((1 + off) | 0)
  };
  return i
});
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput.prototype.countSpaces__I__I__I = (function(offset, max) {
  var i = 0;
  var off = (((-1) + ((this.state$1.nextOffset$1 + offset) | 0)) | 0);
  if ((off < 0)) {
    return 0
  };
  while (((i < max) && (off < this.endOffset$1))) {
    if (($charSequenceCharAt(this.data$1, off) !== 32)) {
      return i
    };
    i = ((1 + i) | 0);
    off = ((1 + off) | 0)
  };
  return i
});
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput.prototype.createMark__Lorg_mulesoft_lexer_LexerInput$Mark = (function() {
  var qual$1 = this.state$1;
  var x$1 = qual$1.column$1;
  var x$2 = qual$1.line$1;
  var x$3 = qual$1.offset$1;
  var x$4 = qual$1.nextOffset$1;
  var x$5 = qual$1.current$1;
  return new $c_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState().init___I__I__I__I__I(x$1, x$2, x$3, x$4, x$5)
});
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput.prototype.consume__I__V = (function(n) {
  var isEmpty$4 = (n <= 0);
  var scala$collection$immutable$Range$$lastElement$4 = (((-1) + n) | 0);
  if ((!isEmpty$4)) {
    var i = 0;
    while (true) {
      var v1 = i;
      this.state$1.consume__jl_CharSequence__I__V(this.data$1, this.endOffset$1);
      if ((i === scala$collection$immutable$Range$$lastElement$4)) {
        break
      };
      i = ((1 + i) | 0)
    }
  }
});
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput.prototype.lookAhead__I__I = (function(i) {
  if ((i === 0)) {
    return this.state$1.current$1
  };
  var off = (((-1) + ((this.state$1.nextOffset$1 + i) | 0)) | 0);
  if (((off < 0) || (off >= this.endOffset$1))) {
    return $m_Lorg_mulesoft_lexer_LexerInput$().EofChar$1
  };
  var chr = $charSequenceCharAt(this.data$1, off);
  if ((i > 0)) {
    if ((((64512 & chr) === 55296) && (((1 + off) | 0) < this.endOffset$1))) {
      var c = $charSequenceCharAt(this.data$1, ((1 + off) | 0));
      var jsx$1 = ((64512 & c) === 56320)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var low = $charSequenceCharAt(this.data$1, ((1 + off) | 0));
      return ((65536 + ((((1023 & chr) << 10) + (1023 & low)) | 0)) | 0)
    };
    return chr
  };
  if ((((64512 & chr) === 56320) && ((((-1) + off) | 0) > 0))) {
    var c$1 = $charSequenceCharAt(this.data$1, (((-1) + off) | 0));
    var jsx$2 = ((64512 & c$1) === 55296)
  } else {
    var jsx$2 = false
  };
  if (jsx$2) {
    var high = $charSequenceCharAt(this.data$1, (((-1) + off) | 0));
    return ((65536 + ((((1023 & high) << 10) + (1023 & chr)) | 0)) | 0)
  };
  return chr
});
var $d_Lorg_mulesoft_lexer_CharSequenceLexerInput = new $TypeData().initClass({
  Lorg_mulesoft_lexer_CharSequenceLexerInput: 0
}, false, "org.mulesoft.lexer.CharSequenceLexerInput", {
  Lorg_mulesoft_lexer_CharSequenceLexerInput: 1,
  O: 1,
  Lorg_mulesoft_lexer_LexerInput: 1
});
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput.prototype.$classData = $d_Lorg_mulesoft_lexer_CharSequenceLexerInput;
/** @constructor */
function $c_Lorg_yaml_builder_BaseOutputBuilder() {
  $c_Lorg_yaml_builder_DocBuilder.call(this);
  this.writer$2 = null;
  this.prettyPrint$2 = false;
  this.evidence$1$2 = null;
  this.indentation$2 = null
}
$c_Lorg_yaml_builder_BaseOutputBuilder.prototype = new $h_Lorg_yaml_builder_DocBuilder();
$c_Lorg_yaml_builder_BaseOutputBuilder.prototype.constructor = $c_Lorg_yaml_builder_BaseOutputBuilder;
/** @constructor */
function $h_Lorg_yaml_builder_BaseOutputBuilder() {
  /*<skip>*/
}
$h_Lorg_yaml_builder_BaseOutputBuilder.prototype = $c_Lorg_yaml_builder_BaseOutputBuilder.prototype;
$c_Lorg_yaml_builder_BaseOutputBuilder.prototype.init___O__Z__Lorg_mulesoft_common_io_Output = (function(writer, prettyPrint, evidence$1) {
  this.writer$2 = writer;
  this.prettyPrint$2 = prettyPrint;
  this.evidence$1$2 = evidence$1;
  this.indentation$2 = "";
  return this
});
$c_Lorg_yaml_builder_BaseOutputBuilder.prototype.dedent__V = (function() {
  var thiz = this.indentation$2;
  this.indentation$2 = $as_T(thiz.substring(2))
});
$c_Lorg_yaml_builder_BaseOutputBuilder.prototype.emitIndent__V = (function() {
  if (this.prettyPrint$2) {
    var x = this.indentation$2;
    var this$2 = new $c_sci_StringOps().init___T(x);
    var jsx$1 = $f_sc_TraversableOnce__nonEmpty__Z(this$2)
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var w = this.writer$2;
    var this$4 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(w);
    var s = this.indentation$2;
    var o = this.evidence$1$2;
    o.append__O__jl_CharSequence__V(this$4.w$1, s)
  }
});
$c_Lorg_yaml_builder_BaseOutputBuilder.prototype.indent__V = (function() {
  this.indentation$2 = (this.indentation$2 + "  ")
});
$c_Lorg_yaml_builder_BaseOutputBuilder.prototype.list__F1__O = (function(f) {
  this.emitSeq__F1__V(f);
  var w = this.writer$2;
  var this$2 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(w);
  var o = this.evidence$1$2;
  o.append__O__C__V(this$2.w$1, 10);
  return this.writer$2
});
$c_Lorg_yaml_builder_BaseOutputBuilder.prototype.obj__F1__O = (function(f) {
  this.emitMap__F1__V(f);
  var w = this.writer$2;
  var this$2 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(w);
  var o = this.evidence$1$2;
  o.append__O__C__V(this$2.w$1, 10);
  return this.writer$2
});
$c_Lorg_yaml_builder_BaseOutputBuilder.prototype.newLine__V = (function() {
  var w = this.writer$2;
  var this$2 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(w);
  var o = this.evidence$1$2;
  o.append__O__jl_CharSequence__V(this$2.w$1, "\n");
  this.emitIndent__V()
});
/** @constructor */
function $c_Lorg_yaml_builder_JsOutputBuilder() {
  $c_Lorg_yaml_builder_DocBuilder.call(this);
  this.obj$2 = null
}
$c_Lorg_yaml_builder_JsOutputBuilder.prototype = new $h_Lorg_yaml_builder_DocBuilder();
$c_Lorg_yaml_builder_JsOutputBuilder.prototype.constructor = $c_Lorg_yaml_builder_JsOutputBuilder;
/** @constructor */
function $h_Lorg_yaml_builder_JsOutputBuilder() {
  /*<skip>*/
}
$h_Lorg_yaml_builder_JsOutputBuilder.prototype = $c_Lorg_yaml_builder_JsOutputBuilder.prototype;
$c_Lorg_yaml_builder_JsOutputBuilder.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_builder_JsOutputBuilder.prototype.$$js$exported$prop$result__O = (function() {
  return this.obj$2
});
$c_Lorg_yaml_builder_JsOutputBuilder.prototype.isDefined__Z = (function() {
  return (this.obj$2 === null)
});
$c_Lorg_yaml_builder_JsOutputBuilder.prototype.doc__F1__sjs_js_Any = (function(f) {
  this.obj$2 = this.org$yaml$builder$JsOutputBuilder$$createSeq__F1__sjs_js_Array(f)[0];
  return this.obj$2
});
$c_Lorg_yaml_builder_JsOutputBuilder.prototype.org$yaml$builder$JsOutputBuilder$$createObj__F1__sjs_js_Object = (function(f) {
  var result = (0, $g.Object)();
  var b = new $c_Lorg_yaml_builder_JsOutputBuilder$$anon$2().init___Lorg_yaml_builder_JsOutputBuilder__sjs_js_Dynamic(this, result);
  f.apply__O__O(b);
  return result
});
$c_Lorg_yaml_builder_JsOutputBuilder.prototype.$$js$exported$prop$isDefined__O = (function() {
  return this.isDefined__Z()
});
$c_Lorg_yaml_builder_JsOutputBuilder.prototype.list__F1__sjs_js_Any = (function(f) {
  this.obj$2 = this.org$yaml$builder$JsOutputBuilder$$createSeq__F1__sjs_js_Array(f);
  return this.obj$2
});
$c_Lorg_yaml_builder_JsOutputBuilder.prototype.list__F1__O = (function(f) {
  return this.list__F1__sjs_js_Any(f)
});
$c_Lorg_yaml_builder_JsOutputBuilder.prototype.$$js$exported$meth$doc__F1__O = (function(f) {
  return this.doc__F1__sjs_js_Any(f)
});
$c_Lorg_yaml_builder_JsOutputBuilder.prototype.obj__F1__sjs_js_Any = (function(f) {
  this.obj$2 = this.org$yaml$builder$JsOutputBuilder$$createObj__F1__sjs_js_Object(f);
  return this.obj$2
});
$c_Lorg_yaml_builder_JsOutputBuilder.prototype.obj__F1__O = (function(f) {
  return this.obj__F1__sjs_js_Any(f)
});
$c_Lorg_yaml_builder_JsOutputBuilder.prototype.$$js$exported$meth$obj__F1__O = (function(f) {
  return this.obj__F1__sjs_js_Any(f)
});
$c_Lorg_yaml_builder_JsOutputBuilder.prototype.$$js$exported$meth$list__F1__O = (function(f) {
  return this.list__F1__sjs_js_Any(f)
});
$c_Lorg_yaml_builder_JsOutputBuilder.prototype.org$yaml$builder$JsOutputBuilder$$fromScalar__Lorg_yaml_builder_DocBuilder$Scalar__sjs_js_Any = (function(scalar) {
  var x1 = scalar.t$1;
  var x = $m_Lorg_yaml_builder_DocBuilder$SType$Str$();
  if ((x === x1)) {
    var s = $objectToString(scalar.value$1);
    return s
  } else {
    var x$3 = $m_Lorg_yaml_builder_DocBuilder$SType$Bool$();
    if ((x$3 === x1)) {
      var value = $uZ(scalar.value$1);
      return value
    } else {
      var x$5 = $m_Lorg_yaml_builder_DocBuilder$SType$Float$();
      if ((x$5 === x1)) {
        var value$1 = $uD(scalar.value$1);
        return value$1
      } else {
        var x$7 = $m_Lorg_yaml_builder_DocBuilder$SType$Int$();
        if ((x$7 === x1)) {
          var t = $uJ(scalar.value$1);
          var lo = t.lo$2;
          var hi = t.hi$2;
          return $m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toDouble__I__I__D(lo, hi)
        } else {
          throw new $c_s_MatchError().init___O(x1)
        }
      }
    }
  }
});
$c_Lorg_yaml_builder_JsOutputBuilder.prototype.org$yaml$builder$JsOutputBuilder$$createSeq__F1__sjs_js_Array = (function(f) {
  var result = [];
  var partBuilder = new $c_Lorg_yaml_builder_JsOutputBuilder$$anon$1().init___Lorg_yaml_builder_JsOutputBuilder__sjs_js_Array(this, result);
  f.apply__O__O(partBuilder);
  return result
});
$c_Lorg_yaml_builder_JsOutputBuilder.prototype.doc = (function(arg) {
  var prep = $as_F1(arg);
  return this.$$js$exported$meth$doc__F1__O(prep)
});
$c_Lorg_yaml_builder_JsOutputBuilder.prototype.obj = (function(arg) {
  var prep = $as_F1(arg);
  return this.$$js$exported$meth$obj__F1__O(prep)
});
$c_Lorg_yaml_builder_JsOutputBuilder.prototype.list = (function(arg) {
  var prep = $as_F1(arg);
  return this.$$js$exported$meth$list__F1__O(prep)
});
Object.defineProperty($c_Lorg_yaml_builder_JsOutputBuilder.prototype, "result", {
  "get": (function() {
    return this.$$js$exported$prop$result__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lorg_yaml_builder_JsOutputBuilder.prototype, "isDefined", {
  "get": (function() {
    return this.$$js$exported$prop$isDefined__O()
  }),
  "configurable": true
});
var $d_Lorg_yaml_builder_JsOutputBuilder = new $TypeData().initClass({
  Lorg_yaml_builder_JsOutputBuilder: 0
}, false, "org.yaml.builder.JsOutputBuilder", {
  Lorg_yaml_builder_JsOutputBuilder: 1,
  Lorg_yaml_builder_DocBuilder: 1,
  O: 1
});
$c_Lorg_yaml_builder_JsOutputBuilder.prototype.$classData = $d_Lorg_yaml_builder_JsOutputBuilder;
/** @constructor */
function $c_Lorg_yaml_builder_JsOutputBuilder$$anon$1() {
  $c_Lorg_yaml_builder_DocBuilder$Part.call(this);
  this.$$outer$2 = null;
  this.result$1$2 = null
}
$c_Lorg_yaml_builder_JsOutputBuilder$$anon$1.prototype = new $h_Lorg_yaml_builder_DocBuilder$Part();
$c_Lorg_yaml_builder_JsOutputBuilder$$anon$1.prototype.constructor = $c_Lorg_yaml_builder_JsOutputBuilder$$anon$1;
/** @constructor */
function $h_Lorg_yaml_builder_JsOutputBuilder$$anon$1() {
  /*<skip>*/
}
$h_Lorg_yaml_builder_JsOutputBuilder$$anon$1.prototype = $c_Lorg_yaml_builder_JsOutputBuilder$$anon$1.prototype;
$c_Lorg_yaml_builder_JsOutputBuilder$$anon$1.prototype.list__F1__s_Option = (function(f) {
  var value = this.$$outer$2.org$yaml$builder$JsOutputBuilder$$createSeq__F1__sjs_js_Array(f);
  this.result$1$2.push(value);
  return new $c_s_Some().init___O(value)
});
$c_Lorg_yaml_builder_JsOutputBuilder$$anon$1.prototype.$$plus$eq__sjs_js_Any__V = (function(element) {
  this.result$1$2.push(element)
});
$c_Lorg_yaml_builder_JsOutputBuilder$$anon$1.prototype.$$plus$eq__Lorg_yaml_builder_DocBuilder$Scalar__V = (function(scalar) {
  this.result$1$2.push(this.$$outer$2.org$yaml$builder$JsOutputBuilder$$fromScalar__Lorg_yaml_builder_DocBuilder$Scalar__sjs_js_Any(scalar))
});
$c_Lorg_yaml_builder_JsOutputBuilder$$anon$1.prototype.$$plus$eq__O__V = (function(element) {
  this.$$plus$eq__sjs_js_Any__V(element)
});
$c_Lorg_yaml_builder_JsOutputBuilder$$anon$1.prototype.init___Lorg_yaml_builder_JsOutputBuilder__sjs_js_Array = (function($$outer, result$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.result$1$2 = result$1;
  return this
});
$c_Lorg_yaml_builder_JsOutputBuilder$$anon$1.prototype.obj__F1__s_Option = (function(f) {
  var value = this.$$outer$2.org$yaml$builder$JsOutputBuilder$$createObj__F1__sjs_js_Object(f);
  this.result$1$2.push(value);
  return new $c_s_Some().init___O(value)
});
var $d_Lorg_yaml_builder_JsOutputBuilder$$anon$1 = new $TypeData().initClass({
  Lorg_yaml_builder_JsOutputBuilder$$anon$1: 0
}, false, "org.yaml.builder.JsOutputBuilder$$anon$1", {
  Lorg_yaml_builder_JsOutputBuilder$$anon$1: 1,
  Lorg_yaml_builder_DocBuilder$Part: 1,
  O: 1
});
$c_Lorg_yaml_builder_JsOutputBuilder$$anon$1.prototype.$classData = $d_Lorg_yaml_builder_JsOutputBuilder$$anon$1;
/** @constructor */
function $c_Lorg_yaml_builder_JsOutputBuilder$$anon$2() {
  $c_Lorg_yaml_builder_DocBuilder$Entry.call(this);
  this.$$outer$2 = null;
  this.o$1$2 = null
}
$c_Lorg_yaml_builder_JsOutputBuilder$$anon$2.prototype = new $h_Lorg_yaml_builder_DocBuilder$Entry();
$c_Lorg_yaml_builder_JsOutputBuilder$$anon$2.prototype.constructor = $c_Lorg_yaml_builder_JsOutputBuilder$$anon$2;
/** @constructor */
function $h_Lorg_yaml_builder_JsOutputBuilder$$anon$2() {
  /*<skip>*/
}
$h_Lorg_yaml_builder_JsOutputBuilder$$anon$2.prototype = $c_Lorg_yaml_builder_JsOutputBuilder$$anon$2.prototype;
$c_Lorg_yaml_builder_JsOutputBuilder$$anon$2.prototype.entry__T__Lorg_yaml_builder_DocBuilder$Scalar__V = (function(key, value) {
  this.o$1$2[key] = this.$$outer$2.org$yaml$builder$JsOutputBuilder$$fromScalar__Lorg_yaml_builder_DocBuilder$Scalar__sjs_js_Any(value)
});
$c_Lorg_yaml_builder_JsOutputBuilder$$anon$2.prototype.init___Lorg_yaml_builder_JsOutputBuilder__sjs_js_Dynamic = (function($$outer, o$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.o$1$2 = o$1;
  return this
});
$c_Lorg_yaml_builder_JsOutputBuilder$$anon$2.prototype.entry__T__F1__V = (function(key, f) {
  this.o$1$2[key] = this.$$outer$2.org$yaml$builder$JsOutputBuilder$$createSeq__F1__sjs_js_Array(f)[0]
});
var $d_Lorg_yaml_builder_JsOutputBuilder$$anon$2 = new $TypeData().initClass({
  Lorg_yaml_builder_JsOutputBuilder$$anon$2: 0
}, false, "org.yaml.builder.JsOutputBuilder$$anon$2", {
  Lorg_yaml_builder_JsOutputBuilder$$anon$2: 1,
  Lorg_yaml_builder_DocBuilder$Entry: 1,
  O: 1
});
$c_Lorg_yaml_builder_JsOutputBuilder$$anon$2.prototype.$classData = $d_Lorg_yaml_builder_JsOutputBuilder$$anon$2;
/** @constructor */
function $c_Lorg_yaml_builder_YDocumentBuilder() {
  $c_Lorg_yaml_builder_DocBuilder.call(this);
  this.$$unddocument$2 = null
}
$c_Lorg_yaml_builder_YDocumentBuilder.prototype = new $h_Lorg_yaml_builder_DocBuilder();
$c_Lorg_yaml_builder_YDocumentBuilder.prototype.constructor = $c_Lorg_yaml_builder_YDocumentBuilder;
/** @constructor */
function $h_Lorg_yaml_builder_YDocumentBuilder() {
  /*<skip>*/
}
$h_Lorg_yaml_builder_YDocumentBuilder.prototype = $c_Lorg_yaml_builder_YDocumentBuilder.prototype;
$c_Lorg_yaml_builder_YDocumentBuilder.prototype.init___ = (function() {
  this.$$unddocument$2 = $m_s_None$();
  return this
});
$c_Lorg_yaml_builder_YDocumentBuilder.prototype.org$yaml$builder$YDocumentBuilder$$mkNode__Lorg_yaml_builder_DocBuilder$Scalar__Lorg_yaml_model_YNode = (function(scalar) {
  var x1 = scalar.t$1;
  var x = $m_Lorg_yaml_builder_DocBuilder$SType$Str$();
  if ((x === x1)) {
    $m_Lorg_yaml_model_YNode$();
    var str = $objectToString(scalar.value$1);
    return $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str)
  } else {
    var x$3 = $m_Lorg_yaml_builder_DocBuilder$SType$Bool$();
    if ((x$3 === x1)) {
      $m_Lorg_yaml_model_YNode$();
      var bool = $uZ(scalar.value$1);
      return $m_Lorg_yaml_model_YNode$().apply__Z__Lorg_yaml_model_YNode(bool)
    } else {
      var x$5 = $m_Lorg_yaml_builder_DocBuilder$SType$Float$();
      if ((x$5 === x1)) {
        $m_Lorg_yaml_model_YNode$();
        var $double = $uD(scalar.value$1);
        return $m_Lorg_yaml_model_YNode$().apply__D__Lorg_yaml_model_YNode($double)
      } else {
        var x$7 = $m_Lorg_yaml_builder_DocBuilder$SType$Int$();
        if ((x$7 === x1)) {
          $m_Lorg_yaml_model_YNode$();
          var t = $uJ(scalar.value$1);
          var lo = t.lo$2;
          var hi = t.hi$2;
          return $m_Lorg_yaml_model_YNode$().apply__J__Lorg_yaml_model_YNode(new $c_sjsr_RuntimeLong().init___I__I(lo, hi))
        } else {
          throw new $c_s_MatchError().init___O(x1)
        }
      }
    }
  }
});
$c_Lorg_yaml_builder_YDocumentBuilder.prototype.org$yaml$builder$YDocumentBuilder$$createPartBuilder__F1__scm_ArrayBuffer = (function(f) {
  var builder = new $c_scm_ArrayBuffer().init___();
  var partBuilder = new $c_Lorg_yaml_builder_YDocumentBuilder$$anon$1().init___Lorg_yaml_builder_YDocumentBuilder__scm_ArrayBuffer(this, builder);
  f.apply__O__O(partBuilder);
  return builder
});
$c_Lorg_yaml_builder_YDocumentBuilder.prototype.document$und$eq__Lorg_yaml_model_YPart__V = (function(doc) {
  this.$$unddocument$2 = new $c_s_Some().init___O(doc)
});
$c_Lorg_yaml_builder_YDocumentBuilder.prototype.list__F1__O = (function(f) {
  return this.list__F1__Lorg_yaml_model_YPart(f)
});
$c_Lorg_yaml_builder_YDocumentBuilder.prototype.obj__F1__O = (function(f) {
  return this.obj__F1__Lorg_yaml_model_YPart(f)
});
$c_Lorg_yaml_builder_YDocumentBuilder.prototype.org$yaml$builder$YDocumentBuilder$$addEntry$1__T__Lorg_yaml_model_YNode__scm_ArrayBuffer__V = (function(key, node, builder$2) {
  builder$2.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry($m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(key), node))
});
$c_Lorg_yaml_builder_YDocumentBuilder.prototype.org$yaml$builder$YDocumentBuilder$$createMapNode__F1__Lorg_yaml_model_YNode = (function(f) {
  var builder = new $c_scm_ArrayBuffer().init___();
  var b = new $c_Lorg_yaml_builder_YDocumentBuilder$$anon$2().init___Lorg_yaml_builder_YDocumentBuilder__scm_ArrayBuffer(this, builder);
  f.apply__O__O(b);
  return $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(builder, ""), $m_Lorg_yaml_model_YType$().Map$1)
});
$c_Lorg_yaml_builder_YDocumentBuilder.prototype.org$yaml$builder$YDocumentBuilder$$createSeqNode__F1__Lorg_yaml_model_YNode = (function(f) {
  var jsx$1 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var parts = this.org$yaml$builder$YDocumentBuilder$$createPartBuilder__F1__scm_ArrayBuffer(f);
  return jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().Unknown$1, parts), $m_Lorg_yaml_model_YType$().Seq$1)
});
$c_Lorg_yaml_builder_YDocumentBuilder.prototype.obj__F1__Lorg_yaml_model_YPart = (function(f) {
  var doc = $m_Lorg_yaml_model_YDocument$().fromNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YDocument(this.org$yaml$builder$YDocumentBuilder$$createMapNode__F1__Lorg_yaml_model_YNode(f));
  this.$$unddocument$2 = new $c_s_Some().init___O(doc);
  return doc
});
$c_Lorg_yaml_builder_YDocumentBuilder.prototype.list__F1__Lorg_yaml_model_YPart = (function(f) {
  var doc = $m_Lorg_yaml_model_YDocument$().fromNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YDocument(this.org$yaml$builder$YDocumentBuilder$$createSeqNode__F1__Lorg_yaml_model_YNode(f));
  this.$$unddocument$2 = new $c_s_Some().init___O(doc);
  return doc
});
function $as_Lorg_yaml_builder_YDocumentBuilder(obj) {
  return (((obj instanceof $c_Lorg_yaml_builder_YDocumentBuilder) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.builder.YDocumentBuilder"))
}
function $isArrayOf_Lorg_yaml_builder_YDocumentBuilder(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_builder_YDocumentBuilder)))
}
function $asArrayOf_Lorg_yaml_builder_YDocumentBuilder(obj, depth) {
  return (($isArrayOf_Lorg_yaml_builder_YDocumentBuilder(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.builder.YDocumentBuilder;", depth))
}
var $d_Lorg_yaml_builder_YDocumentBuilder = new $TypeData().initClass({
  Lorg_yaml_builder_YDocumentBuilder: 0
}, false, "org.yaml.builder.YDocumentBuilder", {
  Lorg_yaml_builder_YDocumentBuilder: 1,
  Lorg_yaml_builder_DocBuilder: 1,
  O: 1
});
$c_Lorg_yaml_builder_YDocumentBuilder.prototype.$classData = $d_Lorg_yaml_builder_YDocumentBuilder;
/** @constructor */
function $c_Lorg_yaml_builder_YDocumentBuilder$$anon$1() {
  $c_Lorg_yaml_builder_DocBuilder$Part.call(this);
  this.$$outer$2 = null;
  this.builder$1$2 = null
}
$c_Lorg_yaml_builder_YDocumentBuilder$$anon$1.prototype = new $h_Lorg_yaml_builder_DocBuilder$Part();
$c_Lorg_yaml_builder_YDocumentBuilder$$anon$1.prototype.constructor = $c_Lorg_yaml_builder_YDocumentBuilder$$anon$1;
/** @constructor */
function $h_Lorg_yaml_builder_YDocumentBuilder$$anon$1() {
  /*<skip>*/
}
$h_Lorg_yaml_builder_YDocumentBuilder$$anon$1.prototype = $c_Lorg_yaml_builder_YDocumentBuilder$$anon$1.prototype;
$c_Lorg_yaml_builder_YDocumentBuilder$$anon$1.prototype.list__F1__s_Option = (function(f) {
  var result = this.$$outer$2.org$yaml$builder$YDocumentBuilder$$createSeqNode__F1__Lorg_yaml_model_YNode(f);
  this.builder$1$2.$$plus$eq__O__scm_ArrayBuffer(result);
  return new $c_s_Some().init___O(result)
});
$c_Lorg_yaml_builder_YDocumentBuilder$$anon$1.prototype.$$plus$eq__Lorg_yaml_builder_DocBuilder$Scalar__V = (function(scalar) {
  this.builder$1$2.$$plus$eq__O__scm_ArrayBuffer(this.$$outer$2.org$yaml$builder$YDocumentBuilder$$mkNode__Lorg_yaml_builder_DocBuilder$Scalar__Lorg_yaml_model_YNode(scalar))
});
$c_Lorg_yaml_builder_YDocumentBuilder$$anon$1.prototype.$$plus$eq__Lorg_yaml_model_YPart__V = (function(element) {
  if ((element instanceof $c_Lorg_yaml_model_YNode)) {
    var x2 = $as_Lorg_yaml_model_YNode(element);
    this.builder$1$2.$$plus$eq__O__scm_ArrayBuffer(x2)
  }
});
$c_Lorg_yaml_builder_YDocumentBuilder$$anon$1.prototype.init___Lorg_yaml_builder_YDocumentBuilder__scm_ArrayBuffer = (function($$outer, builder$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.builder$1$2 = builder$1;
  return this
});
$c_Lorg_yaml_builder_YDocumentBuilder$$anon$1.prototype.$$plus$eq__O__V = (function(element) {
  this.$$plus$eq__Lorg_yaml_model_YPart__V($as_Lorg_yaml_model_YPart(element))
});
$c_Lorg_yaml_builder_YDocumentBuilder$$anon$1.prototype.obj__F1__s_Option = (function(f) {
  var result = this.$$outer$2.org$yaml$builder$YDocumentBuilder$$createMapNode__F1__Lorg_yaml_model_YNode(f);
  this.builder$1$2.$$plus$eq__O__scm_ArrayBuffer(result);
  return new $c_s_Some().init___O(result)
});
var $d_Lorg_yaml_builder_YDocumentBuilder$$anon$1 = new $TypeData().initClass({
  Lorg_yaml_builder_YDocumentBuilder$$anon$1: 0
}, false, "org.yaml.builder.YDocumentBuilder$$anon$1", {
  Lorg_yaml_builder_YDocumentBuilder$$anon$1: 1,
  Lorg_yaml_builder_DocBuilder$Part: 1,
  O: 1
});
$c_Lorg_yaml_builder_YDocumentBuilder$$anon$1.prototype.$classData = $d_Lorg_yaml_builder_YDocumentBuilder$$anon$1;
/** @constructor */
function $c_Lorg_yaml_builder_YDocumentBuilder$$anon$2() {
  $c_Lorg_yaml_builder_DocBuilder$Entry.call(this);
  this.$$outer$2 = null;
  this.builder$2$2 = null
}
$c_Lorg_yaml_builder_YDocumentBuilder$$anon$2.prototype = new $h_Lorg_yaml_builder_DocBuilder$Entry();
$c_Lorg_yaml_builder_YDocumentBuilder$$anon$2.prototype.constructor = $c_Lorg_yaml_builder_YDocumentBuilder$$anon$2;
/** @constructor */
function $h_Lorg_yaml_builder_YDocumentBuilder$$anon$2() {
  /*<skip>*/
}
$h_Lorg_yaml_builder_YDocumentBuilder$$anon$2.prototype = $c_Lorg_yaml_builder_YDocumentBuilder$$anon$2.prototype;
$c_Lorg_yaml_builder_YDocumentBuilder$$anon$2.prototype.entry__T__Lorg_yaml_builder_DocBuilder$Scalar__V = (function(key, value) {
  this.$$outer$2.org$yaml$builder$YDocumentBuilder$$addEntry$1__T__Lorg_yaml_model_YNode__scm_ArrayBuffer__V(key, this.$$outer$2.org$yaml$builder$YDocumentBuilder$$mkNode__Lorg_yaml_builder_DocBuilder$Scalar__Lorg_yaml_model_YNode(value), this.builder$2$2)
});
$c_Lorg_yaml_builder_YDocumentBuilder$$anon$2.prototype.init___Lorg_yaml_builder_YDocumentBuilder__scm_ArrayBuffer = (function($$outer, builder$2) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.builder$2$2 = builder$2;
  return this
});
$c_Lorg_yaml_builder_YDocumentBuilder$$anon$2.prototype.entry__T__F1__V = (function(key, f) {
  var jsx$1 = this.$$outer$2;
  var this$1 = this.$$outer$2.org$yaml$builder$YDocumentBuilder$$createPartBuilder__F1__scm_ArrayBuffer(f);
  jsx$1.org$yaml$builder$YDocumentBuilder$$addEntry$1__T__Lorg_yaml_model_YNode__scm_ArrayBuffer__V(key, $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$1, 0)), this.builder$2$2)
});
var $d_Lorg_yaml_builder_YDocumentBuilder$$anon$2 = new $TypeData().initClass({
  Lorg_yaml_builder_YDocumentBuilder$$anon$2: 0
}, false, "org.yaml.builder.YDocumentBuilder$$anon$2", {
  Lorg_yaml_builder_YDocumentBuilder$$anon$2: 1,
  Lorg_yaml_builder_DocBuilder$Entry: 1,
  O: 1
});
$c_Lorg_yaml_builder_YDocumentBuilder$$anon$2.prototype.$classData = $d_Lorg_yaml_builder_YDocumentBuilder$$anon$2;
/** @constructor */
function $c_Lorg_yaml_convert_ScalarYRead() {
  $c_O.call(this);
  this.expectedType$1 = null;
  this.dv$1 = null
}
$c_Lorg_yaml_convert_ScalarYRead.prototype = new $h_O();
$c_Lorg_yaml_convert_ScalarYRead.prototype.constructor = $c_Lorg_yaml_convert_ScalarYRead;
/** @constructor */
function $h_Lorg_yaml_convert_ScalarYRead() {
  /*<skip>*/
}
$h_Lorg_yaml_convert_ScalarYRead.prototype = $c_Lorg_yaml_convert_ScalarYRead.prototype;
$c_Lorg_yaml_convert_ScalarYRead.prototype.init___Lorg_yaml_model_YType__O = (function(expectedType, dv) {
  this.expectedType$1 = expectedType;
  this.dv$1 = dv;
  return this
});
$c_Lorg_yaml_convert_ScalarYRead.prototype.read__Lorg_yaml_model_YNode__s_util_Either = (function(node) {
  var tagType = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x$2 = this.expectedType$1;
  if ((!(tagType === x$2))) {
    return $m_Lorg_yaml_convert_YRead$().error__Lorg_yaml_model_YNode__T__s_util_Left(node, (((("Expecting " + this.expectedType$1) + " and ") + tagType) + " provided"))
  };
  var x1 = node.asScalar__s_Option();
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var v = $as_Lorg_yaml_model_YScalar(x2.value$2);
    try {
      $m_s_package$();
      var value = v.value$3;
      return new $c_s_util_Right().init___O(value)
    } catch (e) {
      if ((e instanceof $c_jl_ClassCastException)) {
        var e$2 = $as_jl_ClassCastException(e);
        return $m_Lorg_yaml_convert_YRead$().error__Lorg_yaml_model_YNode__T__s_util_Left(node, e$2.s$1)
      } else {
        throw e
      }
    }
  } else {
    return $m_Lorg_yaml_convert_YRead$().error__Lorg_yaml_model_YNode__T__s_util_Left(node, "Scalar expected")
  }
});
$c_Lorg_yaml_convert_ScalarYRead.prototype.defaultValue__O = (function() {
  return this.dv$1
});
/** @constructor */
function $c_Lorg_yaml_convert_YRead$$anon$1() {
  $c_O.call(this);
  this.bf$1$1 = null;
  this.reader$1$1 = null
}
$c_Lorg_yaml_convert_YRead$$anon$1.prototype = new $h_O();
$c_Lorg_yaml_convert_YRead$$anon$1.prototype.constructor = $c_Lorg_yaml_convert_YRead$$anon$1;
/** @constructor */
function $h_Lorg_yaml_convert_YRead$$anon$1() {
  /*<skip>*/
}
$h_Lorg_yaml_convert_YRead$$anon$1.prototype = $c_Lorg_yaml_convert_YRead$$anon$1.prototype;
$c_Lorg_yaml_convert_YRead$$anon$1.prototype.mapValues__p1__sc_Seq__O = (function(s) {
  var b = this.bf$1$1.apply__scm_Builder();
  $f_scm_Builder__sizeHint__sc_TraversableLike__V(b, s);
  s.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$1) {
    return (function(x$2) {
      var x = $as_Lorg_yaml_model_YNode(x$2);
      var x1 = $this.reader$1$1.read__Lorg_yaml_model_YNode__s_util_Either(x);
      if ((!(x1 instanceof $c_s_util_Right))) {
        if ((x1 instanceof $c_s_util_Left)) {
          var x3 = $as_s_util_Left(x1);
          var err = $as_Lorg_yaml_model_YError(x3.value$2);
          err.throwIt__sr_Nothing$()
        };
        throw new $c_s_MatchError().init___O(x1)
      };
      var x2 = $as_s_util_Right(x1);
      var n = x2.value$2;
      return b$1.$$plus$eq__O__scm_Builder(n)
    })
  })(this, b)));
  return b.result__O()
});
$c_Lorg_yaml_convert_YRead$$anon$1.prototype.read__Lorg_yaml_model_YNode__s_util_Either = (function(node) {
  try {
    var this$1 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$().read__Lorg_yaml_model_YNode__s_util_Either(node);
    if ((this$1 instanceof $c_s_util_Right)) {
      var x2 = $as_s_util_Right(this$1);
      var b = x2.value$2;
      var s = $as_sc_Seq(b);
      return new $c_s_util_Right().init___O(this.mapValues__p1__sc_Seq__O(s))
    } else {
      return this$1
    }
  } catch (e) {
    if ((e instanceof $c_Lorg_yaml_model_YException)) {
      var e$2 = $as_Lorg_yaml_model_YException(e);
      $m_s_package$();
      var value = e$2.yError$4;
      return new $c_s_util_Left().init___O(value)
    } else {
      throw e
    }
  }
});
$c_Lorg_yaml_convert_YRead$$anon$1.prototype.init___scg_CanBuildFrom__Lorg_yaml_convert_YRead = (function(bf$1, reader$1) {
  this.bf$1$1 = bf$1;
  this.reader$1$1 = reader$1;
  return this
});
$c_Lorg_yaml_convert_YRead$$anon$1.prototype.defaultValue__O = (function() {
  return this.bf$1$1.apply__scm_Builder().result__O()
});
var $d_Lorg_yaml_convert_YRead$$anon$1 = new $TypeData().initClass({
  Lorg_yaml_convert_YRead$$anon$1: 0
}, false, "org.yaml.convert.YRead$$anon$1", {
  Lorg_yaml_convert_YRead$$anon$1: 1,
  O: 1,
  Lorg_yaml_convert_YRead: 1
});
$c_Lorg_yaml_convert_YRead$$anon$1.prototype.$classData = $d_Lorg_yaml_convert_YRead$$anon$1;
/** @constructor */
function $c_Lorg_yaml_convert_YRead$SeqNodeYRead$() {
  $c_O.call(this)
}
$c_Lorg_yaml_convert_YRead$SeqNodeYRead$.prototype = new $h_O();
$c_Lorg_yaml_convert_YRead$SeqNodeYRead$.prototype.constructor = $c_Lorg_yaml_convert_YRead$SeqNodeYRead$;
/** @constructor */
function $h_Lorg_yaml_convert_YRead$SeqNodeYRead$() {
  /*<skip>*/
}
$h_Lorg_yaml_convert_YRead$SeqNodeYRead$.prototype = $c_Lorg_yaml_convert_YRead$SeqNodeYRead$.prototype;
$c_Lorg_yaml_convert_YRead$SeqNodeYRead$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_convert_YRead$SeqNodeYRead$.prototype.read__Lorg_yaml_model_YNode__s_util_Either = (function(node) {
  var x1 = node.value__Lorg_yaml_model_YValue();
  if ((x1 instanceof $c_Lorg_yaml_model_YSequence)) {
    var x2 = $as_Lorg_yaml_model_YSequence(x1);
    $m_s_package$();
    var value = x2.nodes$3;
    return new $c_s_util_Right().init___O(value)
  } else {
    return $m_Lorg_yaml_convert_YRead$().error__Lorg_yaml_model_YNode__T__s_util_Left(node, "YAML sequence expected")
  }
});
$c_Lorg_yaml_convert_YRead$SeqNodeYRead$.prototype.defaultValue__O = (function() {
  $m_s_package$();
  $m_sci_IndexedSeq$();
  $m_sci_Vector$();
  var this$4 = new $c_sci_VectorBuilder().init___();
  return this$4.result__sci_Vector()
});
var $d_Lorg_yaml_convert_YRead$SeqNodeYRead$ = new $TypeData().initClass({
  Lorg_yaml_convert_YRead$SeqNodeYRead$: 0
}, false, "org.yaml.convert.YRead$SeqNodeYRead$", {
  Lorg_yaml_convert_YRead$SeqNodeYRead$: 1,
  O: 1,
  Lorg_yaml_convert_YRead: 1
});
$c_Lorg_yaml_convert_YRead$SeqNodeYRead$.prototype.$classData = $d_Lorg_yaml_convert_YRead$SeqNodeYRead$;
var $n_Lorg_yaml_convert_YRead$SeqNodeYRead$ = (void 0);
function $m_Lorg_yaml_convert_YRead$SeqNodeYRead$() {
  if ((!$n_Lorg_yaml_convert_YRead$SeqNodeYRead$)) {
    $n_Lorg_yaml_convert_YRead$SeqNodeYRead$ = new $c_Lorg_yaml_convert_YRead$SeqNodeYRead$().init___()
  };
  return $n_Lorg_yaml_convert_YRead$SeqNodeYRead$
}
/** @constructor */
function $c_Lorg_yaml_convert_YRead$YMapYRead$() {
  $c_O.call(this)
}
$c_Lorg_yaml_convert_YRead$YMapYRead$.prototype = new $h_O();
$c_Lorg_yaml_convert_YRead$YMapYRead$.prototype.constructor = $c_Lorg_yaml_convert_YRead$YMapYRead$;
/** @constructor */
function $h_Lorg_yaml_convert_YRead$YMapYRead$() {
  /*<skip>*/
}
$h_Lorg_yaml_convert_YRead$YMapYRead$.prototype = $c_Lorg_yaml_convert_YRead$YMapYRead$.prototype;
$c_Lorg_yaml_convert_YRead$YMapYRead$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_convert_YRead$YMapYRead$.prototype.read__Lorg_yaml_model_YNode__s_util_Either = (function(node) {
  var x1 = node.value__Lorg_yaml_model_YValue();
  if ((x1 instanceof $c_Lorg_yaml_model_YMap)) {
    var x2 = $as_Lorg_yaml_model_YMap(x1);
    $m_s_package$();
    return new $c_s_util_Right().init___O(x2)
  } else {
    return $m_Lorg_yaml_convert_YRead$().error__Lorg_yaml_model_YNode__T__s_util_Left(node, "YAML map expected")
  }
});
$c_Lorg_yaml_convert_YRead$YMapYRead$.prototype.defaultValue__O = (function() {
  return $m_Lorg_yaml_model_YMap$().empty$1
});
var $d_Lorg_yaml_convert_YRead$YMapYRead$ = new $TypeData().initClass({
  Lorg_yaml_convert_YRead$YMapYRead$: 0
}, false, "org.yaml.convert.YRead$YMapYRead$", {
  Lorg_yaml_convert_YRead$YMapYRead$: 1,
  O: 1,
  Lorg_yaml_convert_YRead: 1
});
$c_Lorg_yaml_convert_YRead$YMapYRead$.prototype.$classData = $d_Lorg_yaml_convert_YRead$YMapYRead$;
var $n_Lorg_yaml_convert_YRead$YMapYRead$ = (void 0);
function $m_Lorg_yaml_convert_YRead$YMapYRead$() {
  if ((!$n_Lorg_yaml_convert_YRead$YMapYRead$)) {
    $n_Lorg_yaml_convert_YRead$YMapYRead$ = new $c_Lorg_yaml_convert_YRead$YMapYRead$().init___()
  };
  return $n_Lorg_yaml_convert_YRead$YMapYRead$
}
/** @constructor */
function $c_Lorg_yaml_convert_YRead$YScalarYRead$() {
  $c_O.call(this)
}
$c_Lorg_yaml_convert_YRead$YScalarYRead$.prototype = new $h_O();
$c_Lorg_yaml_convert_YRead$YScalarYRead$.prototype.constructor = $c_Lorg_yaml_convert_YRead$YScalarYRead$;
/** @constructor */
function $h_Lorg_yaml_convert_YRead$YScalarYRead$() {
  /*<skip>*/
}
$h_Lorg_yaml_convert_YRead$YScalarYRead$.prototype = $c_Lorg_yaml_convert_YRead$YScalarYRead$.prototype;
$c_Lorg_yaml_convert_YRead$YScalarYRead$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_convert_YRead$YScalarYRead$.prototype.read__Lorg_yaml_model_YNode__s_util_Either = (function(node) {
  var x1 = node.value__Lorg_yaml_model_YValue();
  if ((x1 instanceof $c_Lorg_yaml_model_YScalar)) {
    var x2 = $as_Lorg_yaml_model_YScalar(x1);
    $m_s_package$();
    return new $c_s_util_Right().init___O(x2)
  } else {
    return $m_Lorg_yaml_convert_YRead$().error__Lorg_yaml_model_YNode__T__s_util_Left(node, "YAML scalar expected")
  }
});
$c_Lorg_yaml_convert_YRead$YScalarYRead$.prototype.defaultValue__O = (function() {
  return $m_Lorg_yaml_model_YScalar$().Null$1
});
var $d_Lorg_yaml_convert_YRead$YScalarYRead$ = new $TypeData().initClass({
  Lorg_yaml_convert_YRead$YScalarYRead$: 0
}, false, "org.yaml.convert.YRead$YScalarYRead$", {
  Lorg_yaml_convert_YRead$YScalarYRead$: 1,
  O: 1,
  Lorg_yaml_convert_YRead: 1
});
$c_Lorg_yaml_convert_YRead$YScalarYRead$.prototype.$classData = $d_Lorg_yaml_convert_YRead$YScalarYRead$;
var $n_Lorg_yaml_convert_YRead$YScalarYRead$ = (void 0);
function $m_Lorg_yaml_convert_YRead$YScalarYRead$() {
  if ((!$n_Lorg_yaml_convert_YRead$YScalarYRead$)) {
    $n_Lorg_yaml_convert_YRead$YScalarYRead$ = new $c_Lorg_yaml_convert_YRead$YScalarYRead$().init___()
  };
  return $n_Lorg_yaml_convert_YRead$YScalarYRead$
}
/** @constructor */
function $c_Lorg_yaml_convert_YRead$YSeqYRead$() {
  $c_O.call(this)
}
$c_Lorg_yaml_convert_YRead$YSeqYRead$.prototype = new $h_O();
$c_Lorg_yaml_convert_YRead$YSeqYRead$.prototype.constructor = $c_Lorg_yaml_convert_YRead$YSeqYRead$;
/** @constructor */
function $h_Lorg_yaml_convert_YRead$YSeqYRead$() {
  /*<skip>*/
}
$h_Lorg_yaml_convert_YRead$YSeqYRead$.prototype = $c_Lorg_yaml_convert_YRead$YSeqYRead$.prototype;
$c_Lorg_yaml_convert_YRead$YSeqYRead$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_convert_YRead$YSeqYRead$.prototype.read__Lorg_yaml_model_YNode__s_util_Either = (function(node) {
  var x1 = node.value__Lorg_yaml_model_YValue();
  if ((x1 instanceof $c_Lorg_yaml_model_YSequence)) {
    var x2 = $as_Lorg_yaml_model_YSequence(x1);
    $m_s_package$();
    return new $c_s_util_Right().init___O(x2)
  } else {
    return $m_Lorg_yaml_convert_YRead$().error__Lorg_yaml_model_YNode__T__s_util_Left(node, "YAML sequence expected")
  }
});
$c_Lorg_yaml_convert_YRead$YSeqYRead$.prototype.defaultValue__O = (function() {
  return $m_Lorg_yaml_model_YSequence$().empty$1
});
var $d_Lorg_yaml_convert_YRead$YSeqYRead$ = new $TypeData().initClass({
  Lorg_yaml_convert_YRead$YSeqYRead$: 0
}, false, "org.yaml.convert.YRead$YSeqYRead$", {
  Lorg_yaml_convert_YRead$YSeqYRead$: 1,
  O: 1,
  Lorg_yaml_convert_YRead: 1
});
$c_Lorg_yaml_convert_YRead$YSeqYRead$.prototype.$classData = $d_Lorg_yaml_convert_YRead$YSeqYRead$;
var $n_Lorg_yaml_convert_YRead$YSeqYRead$ = (void 0);
function $m_Lorg_yaml_convert_YRead$YSeqYRead$() {
  if ((!$n_Lorg_yaml_convert_YRead$YSeqYRead$)) {
    $n_Lorg_yaml_convert_YRead$YSeqYRead$ = new $c_Lorg_yaml_convert_YRead$YSeqYRead$().init___()
  };
  return $n_Lorg_yaml_convert_YRead$YSeqYRead$
}
/** @constructor */
function $c_Lorg_yaml_lexer_YamlToken() {
  $c_Lorg_mulesoft_lexer_Token.call(this)
}
$c_Lorg_yaml_lexer_YamlToken.prototype = new $h_Lorg_mulesoft_lexer_Token();
$c_Lorg_yaml_lexer_YamlToken.prototype.constructor = $c_Lorg_yaml_lexer_YamlToken;
/** @constructor */
function $h_Lorg_yaml_lexer_YamlToken() {
  /*<skip>*/
}
$h_Lorg_yaml_lexer_YamlToken.prototype = $c_Lorg_yaml_lexer_YamlToken.prototype;
$c_Lorg_yaml_lexer_YamlToken.prototype.init___T__T = (function(name, abbreviation) {
  $c_Lorg_mulesoft_lexer_Token.prototype.init___T__T.call(this, name, abbreviation);
  $m_Lorg_yaml_lexer_YamlToken$().org$yaml$lexer$YamlToken$$tokens$1.put__O__O__s_Option(this.abbreviation$1, this);
  return this
});
function $as_Lorg_yaml_lexer_YamlToken(obj) {
  return (((obj instanceof $c_Lorg_yaml_lexer_YamlToken) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.lexer.YamlToken"))
}
function $isArrayOf_Lorg_yaml_lexer_YamlToken(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_lexer_YamlToken)))
}
function $asArrayOf_Lorg_yaml_lexer_YamlToken(obj, depth) {
  return (($isArrayOf_Lorg_yaml_lexer_YamlToken(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.lexer.YamlToken;", depth))
}
var $d_Lorg_yaml_lexer_YamlToken = new $TypeData().initClass({
  Lorg_yaml_lexer_YamlToken: 0
}, false, "org.yaml.lexer.YamlToken", {
  Lorg_yaml_lexer_YamlToken: 1,
  Lorg_mulesoft_lexer_Token: 1,
  O: 1
});
$c_Lorg_yaml_lexer_YamlToken.prototype.$classData = $d_Lorg_yaml_lexer_YamlToken;
/** @constructor */
function $c_Lorg_yaml_model_FoldedMark$() {
  $c_O.call(this)
}
$c_Lorg_yaml_model_FoldedMark$.prototype = new $h_O();
$c_Lorg_yaml_model_FoldedMark$.prototype.constructor = $c_Lorg_yaml_model_FoldedMark$;
/** @constructor */
function $h_Lorg_yaml_model_FoldedMark$() {
  /*<skip>*/
}
$h_Lorg_yaml_model_FoldedMark$.prototype = $c_Lorg_yaml_model_FoldedMark$.prototype;
$c_Lorg_yaml_model_FoldedMark$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_model_FoldedMark$.prototype.markText__T__T = (function(text) {
  return text
});
$c_Lorg_yaml_model_FoldedMark$.prototype.plain__Z = (function() {
  return false
});
var $d_Lorg_yaml_model_FoldedMark$ = new $TypeData().initClass({
  Lorg_yaml_model_FoldedMark$: 0
}, false, "org.yaml.model.FoldedMark$", {
  Lorg_yaml_model_FoldedMark$: 1,
  O: 1,
  Lorg_yaml_model_ScalarMark: 1
});
$c_Lorg_yaml_model_FoldedMark$.prototype.$classData = $d_Lorg_yaml_model_FoldedMark$;
var $n_Lorg_yaml_model_FoldedMark$ = (void 0);
function $m_Lorg_yaml_model_FoldedMark$() {
  if ((!$n_Lorg_yaml_model_FoldedMark$)) {
    $n_Lorg_yaml_model_FoldedMark$ = new $c_Lorg_yaml_model_FoldedMark$().init___()
  };
  return $n_Lorg_yaml_model_FoldedMark$
}
/** @constructor */
function $c_Lorg_yaml_model_IllegalTypeHandler$$anon$1() {
  $c_O.call(this);
  this.f$1$1 = null
}
$c_Lorg_yaml_model_IllegalTypeHandler$$anon$1.prototype = new $h_O();
$c_Lorg_yaml_model_IllegalTypeHandler$$anon$1.prototype.constructor = $c_Lorg_yaml_model_IllegalTypeHandler$$anon$1;
/** @constructor */
function $h_Lorg_yaml_model_IllegalTypeHandler$$anon$1() {
  /*<skip>*/
}
$h_Lorg_yaml_model_IllegalTypeHandler$$anon$1.prototype = $c_Lorg_yaml_model_IllegalTypeHandler$$anon$1.prototype;
$c_Lorg_yaml_model_IllegalTypeHandler$$anon$1.prototype.handle__Lorg_yaml_model_YError__O__O = (function(error, defaultValue) {
  this.f$1$1.apply__O__O(error);
  return defaultValue
});
$c_Lorg_yaml_model_IllegalTypeHandler$$anon$1.prototype.init___F1 = (function(f$1) {
  this.f$1$1 = f$1;
  return this
});
var $d_Lorg_yaml_model_IllegalTypeHandler$$anon$1 = new $TypeData().initClass({
  Lorg_yaml_model_IllegalTypeHandler$$anon$1: 0
}, false, "org.yaml.model.IllegalTypeHandler$$anon$1", {
  Lorg_yaml_model_IllegalTypeHandler$$anon$1: 1,
  O: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1
});
$c_Lorg_yaml_model_IllegalTypeHandler$$anon$1.prototype.$classData = $d_Lorg_yaml_model_IllegalTypeHandler$$anon$1;
/** @constructor */
function $c_Lorg_yaml_model_MultilineMark$() {
  $c_O.call(this)
}
$c_Lorg_yaml_model_MultilineMark$.prototype = new $h_O();
$c_Lorg_yaml_model_MultilineMark$.prototype.constructor = $c_Lorg_yaml_model_MultilineMark$;
/** @constructor */
function $h_Lorg_yaml_model_MultilineMark$() {
  /*<skip>*/
}
$h_Lorg_yaml_model_MultilineMark$.prototype = $c_Lorg_yaml_model_MultilineMark$.prototype;
$c_Lorg_yaml_model_MultilineMark$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_model_MultilineMark$.prototype.markText__T__T = (function(text) {
  return text
});
$c_Lorg_yaml_model_MultilineMark$.prototype.plain__Z = (function() {
  return false
});
var $d_Lorg_yaml_model_MultilineMark$ = new $TypeData().initClass({
  Lorg_yaml_model_MultilineMark$: 0
}, false, "org.yaml.model.MultilineMark$", {
  Lorg_yaml_model_MultilineMark$: 1,
  O: 1,
  Lorg_yaml_model_ScalarMark: 1
});
$c_Lorg_yaml_model_MultilineMark$.prototype.$classData = $d_Lorg_yaml_model_MultilineMark$;
var $n_Lorg_yaml_model_MultilineMark$ = (void 0);
function $m_Lorg_yaml_model_MultilineMark$() {
  if ((!$n_Lorg_yaml_model_MultilineMark$)) {
    $n_Lorg_yaml_model_MultilineMark$ = new $c_Lorg_yaml_model_MultilineMark$().init___()
  };
  return $n_Lorg_yaml_model_MultilineMark$
}
/** @constructor */
function $c_Lorg_yaml_model_NoMark$() {
  $c_O.call(this)
}
$c_Lorg_yaml_model_NoMark$.prototype = new $h_O();
$c_Lorg_yaml_model_NoMark$.prototype.constructor = $c_Lorg_yaml_model_NoMark$;
/** @constructor */
function $h_Lorg_yaml_model_NoMark$() {
  /*<skip>*/
}
$h_Lorg_yaml_model_NoMark$.prototype = $c_Lorg_yaml_model_NoMark$.prototype;
$c_Lorg_yaml_model_NoMark$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_model_NoMark$.prototype.markText__T__T = (function(text) {
  return text
});
$c_Lorg_yaml_model_NoMark$.prototype.plain__Z = (function() {
  return true
});
var $d_Lorg_yaml_model_NoMark$ = new $TypeData().initClass({
  Lorg_yaml_model_NoMark$: 0
}, false, "org.yaml.model.NoMark$", {
  Lorg_yaml_model_NoMark$: 1,
  O: 1,
  Lorg_yaml_model_ScalarMark: 1
});
$c_Lorg_yaml_model_NoMark$.prototype.$classData = $d_Lorg_yaml_model_NoMark$;
var $n_Lorg_yaml_model_NoMark$ = (void 0);
function $m_Lorg_yaml_model_NoMark$() {
  if ((!$n_Lorg_yaml_model_NoMark$)) {
    $n_Lorg_yaml_model_NoMark$ = new $c_Lorg_yaml_model_NoMark$().init___()
  };
  return $n_Lorg_yaml_model_NoMark$
}
/** @constructor */
function $c_Lorg_yaml_model_ParseErrorHandler$$$Lambda$1() {
  $c_O.call(this);
  this.f$1 = null
}
$c_Lorg_yaml_model_ParseErrorHandler$$$Lambda$1.prototype = new $h_O();
$c_Lorg_yaml_model_ParseErrorHandler$$$Lambda$1.prototype.constructor = $c_Lorg_yaml_model_ParseErrorHandler$$$Lambda$1;
/** @constructor */
function $h_Lorg_yaml_model_ParseErrorHandler$$$Lambda$1() {
  /*<skip>*/
}
$h_Lorg_yaml_model_ParseErrorHandler$$$Lambda$1.prototype = $c_Lorg_yaml_model_ParseErrorHandler$$$Lambda$1.prototype;
$c_Lorg_yaml_model_ParseErrorHandler$$$Lambda$1.prototype.handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V = (function(location, e$3) {
  (0, this.f$1)(location, e$3)
});
$c_Lorg_yaml_model_ParseErrorHandler$$$Lambda$1.prototype.init___O = (function(f) {
  this.f$1 = f;
  return this
});
var $d_Lorg_yaml_model_ParseErrorHandler$$$Lambda$1 = new $TypeData().initClass({
  Lorg_yaml_model_ParseErrorHandler$$$Lambda$1: 0
}, false, "org.yaml.model.ParseErrorHandler$$$Lambda$1", {
  Lorg_yaml_model_ParseErrorHandler$$$Lambda$1: 1,
  O: 1,
  Lorg_yaml_model_ParseErrorHandler: 1
});
$c_Lorg_yaml_model_ParseErrorHandler$$$Lambda$1.prototype.$classData = $d_Lorg_yaml_model_ParseErrorHandler$$$Lambda$1;
/** @constructor */
function $c_Lorg_yaml_model_ParseErrorHandler$$$Lambda$2() {
  $c_O.call(this);
  this.f$1 = null
}
$c_Lorg_yaml_model_ParseErrorHandler$$$Lambda$2.prototype = new $h_O();
$c_Lorg_yaml_model_ParseErrorHandler$$$Lambda$2.prototype.constructor = $c_Lorg_yaml_model_ParseErrorHandler$$$Lambda$2;
/** @constructor */
function $h_Lorg_yaml_model_ParseErrorHandler$$$Lambda$2() {
  /*<skip>*/
}
$h_Lorg_yaml_model_ParseErrorHandler$$$Lambda$2.prototype = $c_Lorg_yaml_model_ParseErrorHandler$$$Lambda$2.prototype;
$c_Lorg_yaml_model_ParseErrorHandler$$$Lambda$2.prototype.handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V = (function(location, e$3) {
  (0, this.f$1)(location, e$3)
});
$c_Lorg_yaml_model_ParseErrorHandler$$$Lambda$2.prototype.init___O = (function(f) {
  this.f$1 = f;
  return this
});
var $d_Lorg_yaml_model_ParseErrorHandler$$$Lambda$2 = new $TypeData().initClass({
  Lorg_yaml_model_ParseErrorHandler$$$Lambda$2: 0
}, false, "org.yaml.model.ParseErrorHandler$$$Lambda$2", {
  Lorg_yaml_model_ParseErrorHandler$$$Lambda$2: 1,
  O: 1,
  Lorg_yaml_model_ParseErrorHandler: 1
});
$c_Lorg_yaml_model_ParseErrorHandler$$$Lambda$2.prototype.$classData = $d_Lorg_yaml_model_ParseErrorHandler$$$Lambda$2;
/** @constructor */
function $c_Lorg_yaml_model_UnknownMark$() {
  $c_O.call(this)
}
$c_Lorg_yaml_model_UnknownMark$.prototype = new $h_O();
$c_Lorg_yaml_model_UnknownMark$.prototype.constructor = $c_Lorg_yaml_model_UnknownMark$;
/** @constructor */
function $h_Lorg_yaml_model_UnknownMark$() {
  /*<skip>*/
}
$h_Lorg_yaml_model_UnknownMark$.prototype = $c_Lorg_yaml_model_UnknownMark$.prototype;
$c_Lorg_yaml_model_UnknownMark$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_model_UnknownMark$.prototype.markText__T__T = (function(text) {
  return text
});
$c_Lorg_yaml_model_UnknownMark$.prototype.plain__Z = (function() {
  return false
});
var $d_Lorg_yaml_model_UnknownMark$ = new $TypeData().initClass({
  Lorg_yaml_model_UnknownMark$: 0
}, false, "org.yaml.model.UnknownMark$", {
  Lorg_yaml_model_UnknownMark$: 1,
  O: 1,
  Lorg_yaml_model_ScalarMark: 1
});
$c_Lorg_yaml_model_UnknownMark$.prototype.$classData = $d_Lorg_yaml_model_UnknownMark$;
var $n_Lorg_yaml_model_UnknownMark$ = (void 0);
function $m_Lorg_yaml_model_UnknownMark$() {
  if ((!$n_Lorg_yaml_model_UnknownMark$)) {
    $n_Lorg_yaml_model_UnknownMark$ = new $c_Lorg_yaml_model_UnknownMark$().init___()
  };
  return $n_Lorg_yaml_model_UnknownMark$
}
/** @constructor */
function $c_Lorg_yaml_model_YDirective() {
  $c_Lorg_yaml_model_YPart.call(this);
  this.name$2 = null;
  this.args$2 = null
}
$c_Lorg_yaml_model_YDirective.prototype = new $h_Lorg_yaml_model_YPart();
$c_Lorg_yaml_model_YDirective.prototype.constructor = $c_Lorg_yaml_model_YDirective;
/** @constructor */
function $h_Lorg_yaml_model_YDirective() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YDirective.prototype = $c_Lorg_yaml_model_YDirective.prototype;
$c_Lorg_yaml_model_YDirective.prototype.equals__O__Z = (function(obj) {
  if ((obj instanceof $c_Lorg_yaml_model_YDirective)) {
    var x2 = $as_Lorg_yaml_model_YDirective(obj);
    if ((this.name$2 === x2.name$2)) {
      var x = this.args$2;
      var x$2 = x2.args$2;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_model_YDirective.prototype.toString__T = (function() {
  return ((("%" + this.name$2) + " ") + this.args$2.mkString__T__T(" "))
});
$c_Lorg_yaml_model_YDirective.prototype.init___T__sc_IndexedSeq__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq = (function(name, args, location, parts) {
  this.name$2 = name;
  this.args$2 = args;
  $c_Lorg_yaml_model_YPart.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq.call(this, location, parts);
  return this
});
$c_Lorg_yaml_model_YDirective.prototype.hashCode__I = (function() {
  var this$1 = this.name$2;
  return (($m_sjsr_RuntimeString$().hashCode__T__I(this$1) + $imul(31, this.args$2.hashCode__I())) | 0)
});
function $as_Lorg_yaml_model_YDirective(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YDirective) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YDirective"))
}
function $isArrayOf_Lorg_yaml_model_YDirective(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YDirective)))
}
function $asArrayOf_Lorg_yaml_model_YDirective(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YDirective(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YDirective;", depth))
}
var $d_Lorg_yaml_model_YDirective = new $TypeData().initClass({
  Lorg_yaml_model_YDirective: 0
}, false, "org.yaml.model.YDirective", {
  Lorg_yaml_model_YDirective: 1,
  Lorg_yaml_model_YPart: 1,
  O: 1
});
$c_Lorg_yaml_model_YDirective.prototype.$classData = $d_Lorg_yaml_model_YDirective;
/** @constructor */
function $c_Lorg_yaml_model_YDocument$PartBuilder() {
  $c_Lorg_yaml_model_YDocument$BaseBuilder.call(this);
  this.sourceName$2 = null
}
$c_Lorg_yaml_model_YDocument$PartBuilder.prototype = new $h_Lorg_yaml_model_YDocument$BaseBuilder();
$c_Lorg_yaml_model_YDocument$PartBuilder.prototype.constructor = $c_Lorg_yaml_model_YDocument$PartBuilder;
/** @constructor */
function $h_Lorg_yaml_model_YDocument$PartBuilder() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YDocument$PartBuilder.prototype = $c_Lorg_yaml_model_YDocument$PartBuilder.prototype;
$c_Lorg_yaml_model_YDocument$PartBuilder.prototype.init___T = (function(sourceName) {
  this.sourceName$2 = sourceName;
  $c_Lorg_yaml_model_YDocument$BaseBuilder.prototype.init___.call(this);
  return this
});
$c_Lorg_yaml_model_YDocument$PartBuilder.prototype.sourceName__T = (function() {
  return this.sourceName$2
});
$c_Lorg_yaml_model_YDocument$PartBuilder.prototype.$$plus$eq__T__V = (function(str) {
  this.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__T__T__Lorg_yaml_model_YNode(str, this.sourceName$2))
});
function $as_Lorg_yaml_model_YDocument$PartBuilder(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YDocument$PartBuilder) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YDocument$PartBuilder"))
}
function $isArrayOf_Lorg_yaml_model_YDocument$PartBuilder(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YDocument$PartBuilder)))
}
function $asArrayOf_Lorg_yaml_model_YDocument$PartBuilder(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YDocument$PartBuilder(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YDocument$PartBuilder;", depth))
}
var $d_Lorg_yaml_model_YDocument$PartBuilder = new $TypeData().initClass({
  Lorg_yaml_model_YDocument$PartBuilder: 0
}, false, "org.yaml.model.YDocument$PartBuilder", {
  Lorg_yaml_model_YDocument$PartBuilder: 1,
  Lorg_yaml_model_YDocument$BaseBuilder: 1,
  O: 1
});
$c_Lorg_yaml_model_YDocument$PartBuilder.prototype.$classData = $d_Lorg_yaml_model_YDocument$PartBuilder;
/** @constructor */
function $c_Lorg_yaml_model_YMapEntry() {
  $c_Lorg_yaml_model_YPart.call(this);
  this.key$2 = null;
  this.value$2 = null
}
$c_Lorg_yaml_model_YMapEntry.prototype = new $h_Lorg_yaml_model_YPart();
$c_Lorg_yaml_model_YMapEntry.prototype.constructor = $c_Lorg_yaml_model_YMapEntry;
/** @constructor */
function $h_Lorg_yaml_model_YMapEntry() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YMapEntry.prototype = $c_Lorg_yaml_model_YMapEntry.prototype;
$c_Lorg_yaml_model_YMapEntry.prototype.toString__T = (function() {
  var jsx$1 = $m_s_Predef$any2stringadd$();
  var self = this.key$2;
  return (("" + jsx$1.$$plus$extension__O__T__T(self, ": ")) + this.value$2)
});
$c_Lorg_yaml_model_YMapEntry.prototype.init___Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq = (function(key, value, location, parts) {
  this.key$2 = key;
  this.value$2 = value;
  $c_Lorg_yaml_model_YPart.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq.call(this, location, parts);
  return this
});
function $as_Lorg_yaml_model_YMapEntry(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YMapEntry) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YMapEntry"))
}
function $isArrayOf_Lorg_yaml_model_YMapEntry(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YMapEntry)))
}
function $asArrayOf_Lorg_yaml_model_YMapEntry(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YMapEntry(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YMapEntry;", depth))
}
var $d_Lorg_yaml_model_YMapEntry = new $TypeData().initClass({
  Lorg_yaml_model_YMapEntry: 0
}, false, "org.yaml.model.YMapEntry", {
  Lorg_yaml_model_YMapEntry: 1,
  Lorg_yaml_model_YPart: 1,
  O: 1
});
$c_Lorg_yaml_model_YMapEntry.prototype.$classData = $d_Lorg_yaml_model_YMapEntry;
/** @constructor */
function $c_Lorg_yaml_model_YTokens() {
  $c_Lorg_yaml_model_YPart.call(this);
  this.tokens$2 = null
}
$c_Lorg_yaml_model_YTokens.prototype = new $h_Lorg_yaml_model_YPart();
$c_Lorg_yaml_model_YTokens.prototype.constructor = $c_Lorg_yaml_model_YTokens;
/** @constructor */
function $h_Lorg_yaml_model_YTokens() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YTokens.prototype = $c_Lorg_yaml_model_YTokens.prototype;
$c_Lorg_yaml_model_YTokens.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq = (function(location, tokens) {
  this.tokens$2 = tokens;
  $m_s_package$();
  $m_sci_IndexedSeq$();
  $m_sci_Vector$();
  var this$5 = new $c_sci_VectorBuilder().init___();
  $c_Lorg_yaml_model_YPart.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq.call(this, location, this$5.result__sci_Vector());
  return this
});
/** @constructor */
function $c_Lorg_yaml_parser_JsonParser() {
  $c_O.call(this);
  this.SequenceValueParser$module$1 = null;
  this.MapEntryParser$module$1 = null;
  this.lexer$1 = null;
  this.eh$1 = null;
  this.org$yaml$parser$JsonParser$$keepTokens$1 = false;
  this.org$yaml$parser$JsonParser$$current$1 = null;
  this.stack$1 = null
}
$c_Lorg_yaml_parser_JsonParser.prototype = new $h_O();
$c_Lorg_yaml_parser_JsonParser.prototype.constructor = $c_Lorg_yaml_parser_JsonParser;
/** @constructor */
function $h_Lorg_yaml_parser_JsonParser() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_JsonParser.prototype = $c_Lorg_yaml_parser_JsonParser.prototype;
$c_Lorg_yaml_parser_JsonParser.prototype.parseDocument__p1__Lorg_yaml_model_YDocument = (function() {
  this.org$yaml$parser$JsonParser$$push__V();
  if (this.consumeOrError__p1__Lorg_yaml_lexer_YamlToken__Z($m_Lorg_yaml_lexer_YamlToken$().BeginDocument$1)) {
    this.org$yaml$parser$JsonParser$$process__Z();
    this.consumeOrError__p1__Lorg_yaml_lexer_YamlToken__Z($m_Lorg_yaml_lexer_YamlToken$().EndDocument$1)
  };
  var parts = this.org$yaml$parser$JsonParser$$current$1.buildParts__ALorg_yaml_model_YPart();
  var sl = this.org$yaml$parser$JsonParser$$current$1.location__Lorg_mulesoft_lexer_SourceLocation();
  this.org$yaml$parser$JsonParser$$pop__V();
  return new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(sl, $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray(parts))
});
$c_Lorg_yaml_parser_JsonParser.prototype.notCurrent__p1__Lorg_yaml_lexer_YamlToken__Z = (function(token) {
  var x = this.currentToken__p1__Lorg_yaml_lexer_YamlToken();
  if ((!(x === token))) {
    return (!this.eof__p1__Z())
  } else {
    return false
  }
});
$c_Lorg_yaml_parser_JsonParser.prototype.org$yaml$parser$JsonParser$$currentByTextOrError__Lorg_yaml_lexer_YamlToken__T__Z = (function(token, text) {
  return (this.org$yaml$parser$JsonParser$$currentByText__Lorg_yaml_lexer_YamlToken__T__Z(token, text) || (this.expected__T__V(text), false))
});
$c_Lorg_yaml_parser_JsonParser.prototype.parse__Z__sc_IndexedSeq = (function(keepTokens) {
  this.org$yaml$parser$JsonParser$$keepTokens$1 = keepTokens;
  $m_s_package$();
  var array = [this.parseDocument__p1__Lorg_yaml_model_YDocument()];
  if (($uI(array.length) === 0)) {
    $m_sci_IndexedSeq$();
    $m_sci_Vector$();
    var this$6 = new $c_sci_VectorBuilder().init___();
    return this$6.result__sci_Vector()
  } else {
    $m_sci_IndexedSeq$();
    $m_sci_Vector$();
    var b = new $c_sci_VectorBuilder().init___();
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      b.$$plus$eq__O__sci_VectorBuilder(arg1);
      i = ((1 + i) | 0)
    };
    return b.result__sci_Vector()
  }
});
$c_Lorg_yaml_parser_JsonParser.prototype.init___Lorg_yaml_lexer_JsonLexer__Lorg_yaml_model_ParseErrorHandler = (function(lexer, eh) {
  this.lexer$1 = lexer;
  this.eh$1 = eh;
  this.org$yaml$parser$JsonParser$$keepTokens$1 = false;
  this.org$yaml$parser$JsonParser$$current$1 = new $c_Lorg_yaml_parser_JsonParser$JsonBuilder().init___Lorg_yaml_parser_JsonParser(this);
  $m_sci_List$();
  var array = [this.org$yaml$parser$JsonParser$$current$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  this.stack$1 = result;
  return this
});
$c_Lorg_yaml_parser_JsonParser.prototype.consumeOrError__p1__Lorg_yaml_lexer_YamlToken__Z = (function(token) {
  return (this.currentOrError__p1__Lorg_yaml_lexer_YamlToken__Z(token) && this.org$yaml$parser$JsonParser$$consume__Z())
});
$c_Lorg_yaml_parser_JsonParser.prototype.expected__p1__Lorg_yaml_lexer_YamlToken__Z = (function(token) {
  var x = $m_Lorg_yaml_lexer_YamlToken$().BeginScalar$1;
  if ((x === token)) {
    this.expected__T__V("\"")
  } else {
    var x$3 = $m_Lorg_yaml_lexer_YamlToken$().EndMapping$1;
    if ((x$3 === token)) {
      this.expected__T__V("}")
    } else {
      var x$5 = $m_Lorg_yaml_lexer_YamlToken$().EndSequence$1;
      if ((x$5 === token)) {
        this.expected__T__V("]")
      } else {
        this.unexpected__V()
      }
    }
  };
  return false
});
$c_Lorg_yaml_parser_JsonParser.prototype.org$yaml$parser$JsonParser$$stackParts__Lorg_yaml_model_YPart__scm_ArrayBuffer = (function(part) {
  this.org$yaml$parser$JsonParser$$pop__V();
  return this.org$yaml$parser$JsonParser$$current$1.parts$1.$$plus$eq__O__scm_ArrayBuffer(part)
});
$c_Lorg_yaml_parser_JsonParser.prototype.org$yaml$parser$JsonParser$$discardIf__Lorg_yaml_lexer_YamlToken__V = (function(token) {
  if (this.isCurrent__p1__Lorg_yaml_lexer_YamlToken__Z(token)) {
    this.lexer$1.advance__V()
  }
});
$c_Lorg_yaml_parser_JsonParser.prototype.currentRange__p1__Lorg_mulesoft_lexer_SourceLocation = (function() {
  var this$1 = this.lexer$1;
  return this$1.$$undtokenData$1.range$1
});
$c_Lorg_yaml_parser_JsonParser.prototype.unexpected__V = (function() {
  var this$1 = this.lexer$1;
  this.reportError__p1__T__V((("Unexpected '" + $objectToString(this$1.tokenText__Lorg_mulesoft_lexer_TokenData__jl_CharSequence(this$1.$$undtokenData$1))) + "'"))
});
$c_Lorg_yaml_parser_JsonParser.prototype.parseSeq__p1__Z = (function() {
  this.org$yaml$parser$JsonParser$$push__V();
  var r = this.parseList__p1__Lorg_yaml_lexer_YamlToken__Lorg_yaml_lexer_YamlToken__Lorg_yaml_parser_JsonParser$ElementParser__Z($m_Lorg_yaml_lexer_YamlToken$().BeginSequence$1, $m_Lorg_yaml_lexer_YamlToken$().EndSequence$1, new $c_Lorg_yaml_parser_JsonParser$SequenceValueParser().init___Lorg_yaml_parser_JsonParser(this));
  var sl = this.org$yaml$parser$JsonParser$$current$1.location__Lorg_mulesoft_lexer_SourceLocation();
  if (r) {
    this.org$yaml$parser$JsonParser$$consume__Z()
  };
  $m_Lorg_yaml_model_YSequence$();
  var parts = $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray(this.org$yaml$parser$JsonParser$$current$1.buildParts__ALorg_yaml_model_YPart());
  var v = new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(sl, parts);
  var this$2 = $m_Lorg_yaml_model_YType$().Seq$1;
  this.org$yaml$parser$JsonParser$$stackParts__Lorg_yaml_model_YPart__scm_ArrayBuffer(this.buildNode__p1__Lorg_yaml_model_YValue__Lorg_yaml_model_YTag__Lorg_yaml_model_YNode(v, this$2.org$yaml$model$YType$$tag$und$1));
  return r
});
$c_Lorg_yaml_parser_JsonParser.prototype.org$yaml$parser$JsonParser$$consume__Z = (function() {
  this.org$yaml$parser$JsonParser$$current$1.append__V();
  var this$1 = this.lexer$1;
  var x = this$1.$$undtokenData$1.token$1;
  var x$2 = $m_Lorg_yaml_lexer_YamlToken$().Error$1;
  if ((x === x$2)) {
    var jsx$2 = this.eh$1;
    var jsx$1 = this.currentRange__p1__Lorg_mulesoft_lexer_SourceLocation();
    var this$2 = this.lexer$1;
    jsx$2.handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V(jsx$1, new $c_Lorg_yaml_model_LexerException().init___T__jl_Exception($objectToString(this$2.tokenText__Lorg_mulesoft_lexer_TokenData__jl_CharSequence(this$2.$$undtokenData$1)), null))
  };
  this.lexer$1.advance__V();
  return true
});
$c_Lorg_yaml_parser_JsonParser.prototype.org$yaml$parser$JsonParser$$process__Z = (function() {
  var x1 = this.currentToken__p1__Lorg_yaml_lexer_YamlToken();
  var x = $m_Lorg_yaml_lexer_YamlToken$().BeginSequence$1;
  if ((x === x1)) {
    return this.parseSeq__p1__Z()
  } else {
    var x$3 = $m_Lorg_yaml_lexer_YamlToken$().BeginMapping$1;
    if ((x$3 === x1)) {
      return this.parseMap__p1__Z()
    } else {
      var x$5 = $m_Lorg_yaml_lexer_YamlToken$().BeginScalar$1;
      if ((x$5 === x1)) {
        return this.org$yaml$parser$JsonParser$$parseScalar__Z()
      } else {
        this.unexpected__V();
        return false
      }
    }
  }
});
$c_Lorg_yaml_parser_JsonParser.prototype.parseEscaped__p1__T = (function() {
  var metaTextBuilder = new $c_scm_StringBuilder().init___();
  while (this.notCurrent__p1__Lorg_yaml_lexer_YamlToken__Z($m_Lorg_yaml_lexer_YamlToken$().EndEscape$1)) {
    var x1 = this.currentToken__p1__Lorg_yaml_lexer_YamlToken();
    var x = $m_Lorg_yaml_lexer_YamlToken$().Indicator$1;
    if ((x === x1)) {
      var this$1 = this.lexer$1;
      metaTextBuilder.append__T__scm_StringBuilder($objectToString(this$1.tokenText__Lorg_mulesoft_lexer_TokenData__jl_CharSequence(this$1.$$undtokenData$1)))
    } else {
      var x$3 = $m_Lorg_yaml_lexer_YamlToken$().LineBreak$1;
      if ((x$3 === x1)) {
        metaTextBuilder.underlying$5.setLength__I__V(0)
      } else {
        var x$5 = $m_Lorg_yaml_lexer_YamlToken$().MetaText$1;
        if ((x$5 === x1)) {
          var this$2 = this.lexer$1;
          metaTextBuilder.append__T__scm_StringBuilder($objectToString(this$2.tokenText__Lorg_mulesoft_lexer_TokenData__jl_CharSequence(this$2.$$undtokenData$1)))
        }
      }
    };
    this.org$yaml$parser$JsonParser$$consume__Z()
  };
  var jsx$1 = $m_Lorg_mulesoft_common_core_package$Strings$();
  var str = metaTextBuilder.underlying$5.java$lang$StringBuilder$$content$f;
  return jsx$1.decode$extension1__T__Z__T(str, true)
});
$c_Lorg_yaml_parser_JsonParser.prototype.parseList__p1__Lorg_yaml_lexer_YamlToken__Lorg_yaml_lexer_YamlToken__Lorg_yaml_parser_JsonParser$ElementParser__Z = (function(leftToken, rightToken, parser) {
  $m_s_Predef$().assert__Z__V(this.isCurrent__p1__Lorg_yaml_lexer_YamlToken__Z(leftToken));
  this.org$yaml$parser$JsonParser$$consume__Z();
  this.org$yaml$parser$JsonParser$$current$1.addNonContent__V();
  while (this.notCurrent__p1__Lorg_yaml_lexer_YamlToken__Z(rightToken)) {
    parser.parse__V();
    if (this.notCurrent__p1__Lorg_yaml_lexer_YamlToken__Z(rightToken)) {
      if (this.org$yaml$parser$JsonParser$$currentByTextOrError__Lorg_yaml_lexer_YamlToken__T__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1, ",")) {
        this.org$yaml$parser$JsonParser$$consume__Z();
        this.org$yaml$parser$JsonParser$$skipWhiteSpace__V();
        this.org$yaml$parser$JsonParser$$current$1.addNonContent__V();
        var x = this.currentToken__p1__Lorg_yaml_lexer_YamlToken();
        if ((x === rightToken)) {
          this.expected__T__V("value")
        }
      }
    }
  };
  return this.currentOrError__p1__Lorg_yaml_lexer_YamlToken__Z(rightToken)
});
$c_Lorg_yaml_parser_JsonParser.prototype.expected__T__V = (function(expected) {
  var this$1 = this.lexer$1;
  var thiz = $objectToString(this$1.tokenText__Lorg_mulesoft_lexer_TokenData__jl_CharSequence(this$1.$$undtokenData$1));
  if ((thiz === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  if ((thiz === "")) {
    var jsx$1 = (("Missing '" + expected) + "'")
  } else {
    var this$3 = this.lexer$1;
    var jsx$1 = (((("Expecting '" + expected) + "' but '") + $objectToString(this$3.tokenText__Lorg_mulesoft_lexer_TokenData__jl_CharSequence(this$3.$$undtokenData$1))) + "' found")
  };
  this.reportError__p1__T__V(jsx$1)
});
$c_Lorg_yaml_parser_JsonParser.prototype.org$yaml$parser$JsonParser$$parseScalar__Z = (function() {
  if (this.currentOrError__p1__Lorg_yaml_lexer_YamlToken__Z($m_Lorg_yaml_lexer_YamlToken$().BeginScalar$1)) {
    this.org$yaml$parser$JsonParser$$push__V();
    this.org$yaml$parser$JsonParser$$current$1.addNonContent__V();
    var textBuilder = new $c_scm_StringBuilder().init___();
    var markChar = "";
    while (this.notCurrent__p1__Lorg_yaml_lexer_YamlToken__Z($m_Lorg_yaml_lexer_YamlToken$().EndScalar$1)) {
      var x1 = this.currentToken__p1__Lorg_yaml_lexer_YamlToken();
      var x = $m_Lorg_yaml_lexer_YamlToken$().BeginEscape$1;
      if ((x === x1)) {
        textBuilder.append__T__scm_StringBuilder(this.parseEscaped__p1__T())
      } else {
        var x$3 = $m_Lorg_yaml_lexer_YamlToken$().Indicator$1;
        if ((x$3 === x1)) {
          var this$1 = this.lexer$1;
          markChar = $objectToString(this$1.tokenText__Lorg_mulesoft_lexer_TokenData__jl_CharSequence(this$1.$$undtokenData$1))
        } else {
          var x$5 = $m_Lorg_yaml_lexer_YamlToken$().Text$1;
          if ((x$5 === x1)) {
            var this$2 = this.lexer$1;
            textBuilder.append__O__scm_StringBuilder(this$2.tokenText__Lorg_mulesoft_lexer_TokenData__jl_CharSequence(this$2.$$undtokenData$1))
          }
        }
      };
      this.org$yaml$parser$JsonParser$$consume__Z()
    };
    var loc = this.org$yaml$parser$JsonParser$$current$1.location__Lorg_mulesoft_lexer_SourceLocation();
    this.consumeOrError__p1__Lorg_yaml_lexer_YamlToken__Z($m_Lorg_yaml_lexer_YamlToken$().EndScalar$1);
    this.org$yaml$parser$JsonParser$$current$1.addNonContent__V();
    var txt = textBuilder.underlying$5.java$lang$StringBuilder$$content$f;
    var sm = $m_Lorg_yaml_model_ScalarMark$().apply__T__Lorg_yaml_model_ScalarMark(markChar);
    var jsx$2 = $m_Lorg_yaml_parser_ScalarParser$();
    var x$8 = $m_Lorg_yaml_model_DoubleQuoteMark$();
    if (((sm !== null) && (sm === x$8))) {
      var this$3 = $m_Lorg_yaml_model_YType$().Str$1;
      var jsx$1 = this$3.org$yaml$model$YType$$tag$und$1
    } else {
      var jsx$1 = null
    };
    var pr = jsx$2.parse__T__Lorg_yaml_model_ScalarMark__Lorg_yaml_model_YTag__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_ParserResult(txt, sm, jsx$1, loc, this.eh$1);
    this.org$yaml$parser$JsonParser$$stackParts__Lorg_yaml_model_YPart__scm_ArrayBuffer(this.buildNode__p1__Lorg_yaml_model_YValue__Lorg_yaml_model_YTag__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YScalar().init___O__T__Lorg_yaml_model_ScalarMark__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(pr.value$1, txt, sm, loc, $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray(this.org$yaml$parser$JsonParser$$current$1.buildParts__ALorg_yaml_model_YPart())), pr.tag$1));
    return true
  } else {
    return false
  }
});
$c_Lorg_yaml_parser_JsonParser.prototype.org$yaml$parser$JsonParser$$currentByText__Lorg_yaml_lexer_YamlToken__T__Z = (function(token, text) {
  if (this.isCurrent__p1__Lorg_yaml_lexer_YamlToken__Z(token)) {
    var this$1 = this.lexer$1;
    return ($objectToString(this$1.tokenText__Lorg_mulesoft_lexer_TokenData__jl_CharSequence(this$1.$$undtokenData$1)) === text)
  } else {
    return false
  }
});
$c_Lorg_yaml_parser_JsonParser.prototype.documents__sc_IndexedSeq = (function() {
  this.org$yaml$parser$JsonParser$$keepTokens$1 = false;
  return $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray($makeNativeArrayWrapper($d_Lorg_yaml_model_YDocument.getArrayOf(), [this.parseDocument__p1__Lorg_yaml_model_YDocument()]))
});
$c_Lorg_yaml_parser_JsonParser.prototype.buildNode__p1__Lorg_yaml_model_YValue__Lorg_yaml_model_YTag__Lorg_yaml_model_YNode = (function(value, tag) {
  var x$3 = this.lexer$1.sourceName$1;
  $m_Lorg_yaml_model_YNode$();
  var x$4 = $m_s_None$();
  $m_Lorg_yaml_model_YNode$();
  var x$5 = null;
  return $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YTag__s_Option__sc_IndexedSeq__T__Lorg_yaml_model_YNode(value, tag, x$4, x$5, x$3)
});
$c_Lorg_yaml_parser_JsonParser.prototype.currentToken__p1__Lorg_yaml_lexer_YamlToken = (function() {
  this.org$yaml$parser$JsonParser$$skipWhiteSpace__V();
  var this$1 = this.lexer$1;
  var t = $as_Lorg_yaml_lexer_YamlToken(this$1.$$undtokenData$1.token$1);
  return t
});
$c_Lorg_yaml_parser_JsonParser.prototype.isCurrent__p1__Lorg_yaml_lexer_YamlToken__Z = (function(token) {
  var x = this.currentToken__p1__Lorg_yaml_lexer_YamlToken();
  return (x === token)
});
$c_Lorg_yaml_parser_JsonParser.prototype.eof__p1__Z = (function() {
  var x = this.currentToken__p1__Lorg_yaml_lexer_YamlToken();
  var x$2 = $m_Lorg_yaml_lexer_YamlToken$().EndDocument$1;
  return (x === x$2)
});
$c_Lorg_yaml_parser_JsonParser.prototype.org$yaml$parser$JsonParser$$pop__V = (function() {
  this.stack$1 = $as_sci_List(this.stack$1.tail__O());
  this.org$yaml$parser$JsonParser$$current$1 = $as_Lorg_yaml_parser_JsonParser$JsonBuilder(this.stack$1.head__O())
});
$c_Lorg_yaml_parser_JsonParser.prototype.reportError__p1__T__V = (function(msg) {
  this.eh$1.handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V(this.currentRange__p1__Lorg_mulesoft_lexer_SourceLocation(), new $c_Lorg_yaml_model_ParserException().init___T__jl_Exception(msg, null))
});
$c_Lorg_yaml_parser_JsonParser.prototype.current$1__p1__T2__Z = (function(t) {
  var x1 = $as_s_Option(t.$$und2__O());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var text = $as_T(x2.value$2);
    return this.org$yaml$parser$JsonParser$$currentByTextOrError__Lorg_yaml_lexer_YamlToken__T__Z($as_Lorg_yaml_lexer_YamlToken(t.$$und1__O()), text)
  } else {
    return this.isCurrent__p1__Lorg_yaml_lexer_YamlToken__Z($as_Lorg_yaml_lexer_YamlToken(t.$$und1__O()))
  }
});
$c_Lorg_yaml_parser_JsonParser.prototype.currentOrError__p1__Lorg_yaml_lexer_YamlToken__Z = (function(token) {
  return (this.isCurrent__p1__Lorg_yaml_lexer_YamlToken__Z(token) || this.expected__p1__Lorg_yaml_lexer_YamlToken__Z(token))
});
$c_Lorg_yaml_parser_JsonParser.prototype.org$yaml$parser$JsonParser$$skipWhiteSpace__V = (function() {
  while (true) {
    var this$1 = this.lexer$1;
    var x = this$1.$$undtokenData$1.token$1;
    var x$2 = $m_Lorg_yaml_lexer_YamlToken$().WhiteSpace$1;
    if ((x === x$2)) {
      var jsx$1 = true
    } else {
      var this$2 = this.lexer$1;
      var x$3 = this$2.$$undtokenData$1.token$1;
      var x$4 = $m_Lorg_yaml_lexer_YamlToken$().LineBreak$1;
      var jsx$1 = (x$3 === x$4)
    };
    if (jsx$1) {
      this.org$yaml$parser$JsonParser$$current$1.append__V();
      this.lexer$1.advance__V()
    } else {
      break
    }
  }
});
$c_Lorg_yaml_parser_JsonParser.prototype.parseMap__p1__Z = (function() {
  this.org$yaml$parser$JsonParser$$push__V();
  var r = this.parseList__p1__Lorg_yaml_lexer_YamlToken__Lorg_yaml_lexer_YamlToken__Lorg_yaml_parser_JsonParser$ElementParser__Z($m_Lorg_yaml_lexer_YamlToken$().BeginMapping$1, $m_Lorg_yaml_lexer_YamlToken$().EndMapping$1, new $c_Lorg_yaml_parser_JsonParser$MapEntryParser().init___Lorg_yaml_parser_JsonParser(this));
  var sl = this.org$yaml$parser$JsonParser$$current$1.location__Lorg_mulesoft_lexer_SourceLocation();
  if (r) {
    this.org$yaml$parser$JsonParser$$consume__Z()
  };
  var parts = this.org$yaml$parser$JsonParser$$current$1.buildParts__ALorg_yaml_model_YPart();
  $m_Lorg_yaml_model_YMap$();
  var c = $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray(parts);
  var v = new $c_Lorg_yaml_model_YMap().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(sl, c);
  var this$2 = $m_Lorg_yaml_model_YType$().Map$1;
  this.org$yaml$parser$JsonParser$$stackParts__Lorg_yaml_model_YPart__scm_ArrayBuffer(this.buildNode__p1__Lorg_yaml_model_YValue__Lorg_yaml_model_YTag__Lorg_yaml_model_YNode(v, this$2.org$yaml$model$YType$$tag$und$1));
  return r
});
$c_Lorg_yaml_parser_JsonParser.prototype.org$yaml$parser$JsonParser$$push__V = (function() {
  this.org$yaml$parser$JsonParser$$current$1 = new $c_Lorg_yaml_parser_JsonParser$JsonBuilder().init___Lorg_yaml_parser_JsonParser(this);
  var x$1 = this.org$yaml$parser$JsonParser$$current$1;
  var this$1 = this.stack$1;
  this.stack$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$1)
});
var $d_Lorg_yaml_parser_JsonParser = new $TypeData().initClass({
  Lorg_yaml_parser_JsonParser: 0
}, false, "org.yaml.parser.JsonParser", {
  Lorg_yaml_parser_JsonParser: 1,
  O: 1,
  Lorg_yaml_parser_YParser: 1
});
$c_Lorg_yaml_parser_JsonParser.prototype.$classData = $d_Lorg_yaml_parser_JsonParser;
/** @constructor */
function $c_Lorg_yaml_parser_YamlLoader$AliasBuilder() {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.call(this)
}
$c_Lorg_yaml_parser_YamlLoader$AliasBuilder.prototype = new $h_Lorg_yaml_parser_YamlLoader$YamlBuilder();
$c_Lorg_yaml_parser_YamlLoader$AliasBuilder.prototype.constructor = $c_Lorg_yaml_parser_YamlLoader$AliasBuilder;
/** @constructor */
function $h_Lorg_yaml_parser_YamlLoader$AliasBuilder() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_YamlLoader$AliasBuilder.prototype = $c_Lorg_yaml_parser_YamlLoader$AliasBuilder.prototype;
$c_Lorg_yaml_parser_YamlLoader$AliasBuilder.prototype.init___Lorg_yaml_parser_YamlLoader = (function($$outer) {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.init___Lorg_yaml_parser_YamlLoader__Lorg_mulesoft_lexer_SourceLocation.call(this, $$outer, $$outer.org$yaml$parser$YamlLoader$$YamlBuilder__Lorg_yaml_parser_YamlLoader$YamlBuilder$().$$lessinit$greater$default$1__Lorg_mulesoft_lexer_SourceLocation());
  return this
});
$c_Lorg_yaml_parser_YamlLoader$AliasBuilder.prototype.create__V = (function() {
  var this$1 = this.metaTextBuilder$1;
  var aliasName = this$1.underlying$5.java$lang$StringBuilder$$content$f;
  this.addCurrentToken__V();
  var jsx$1 = this.$$outer$1;
  var location = this.location__Lorg_mulesoft_lexer_SourceLocation();
  var ts = this.buildTokens__sc_IndexedSeq();
  jsx$1.org$yaml$parser$YamlLoader$$pop__Lorg_yaml_model_YPart__V(new $c_Lorg_yaml_model_YAnchor().init___T__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(aliasName, location, ts));
  var this$3 = this.$$outer$1;
  var this$4 = this$3.stack$1;
  $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$4.list$1.head__O()).alias$1 = aliasName
});
var $d_Lorg_yaml_parser_YamlLoader$AliasBuilder = new $TypeData().initClass({
  Lorg_yaml_parser_YamlLoader$AliasBuilder: 0
}, false, "org.yaml.parser.YamlLoader$AliasBuilder", {
  Lorg_yaml_parser_YamlLoader$AliasBuilder: 1,
  Lorg_yaml_parser_YamlLoader$YamlBuilder: 1,
  O: 1
});
$c_Lorg_yaml_parser_YamlLoader$AliasBuilder.prototype.$classData = $d_Lorg_yaml_parser_YamlLoader$AliasBuilder;
/** @constructor */
function $c_Lorg_yaml_parser_YamlLoader$AnchorBuilder() {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.call(this)
}
$c_Lorg_yaml_parser_YamlLoader$AnchorBuilder.prototype = new $h_Lorg_yaml_parser_YamlLoader$YamlBuilder();
$c_Lorg_yaml_parser_YamlLoader$AnchorBuilder.prototype.constructor = $c_Lorg_yaml_parser_YamlLoader$AnchorBuilder;
/** @constructor */
function $h_Lorg_yaml_parser_YamlLoader$AnchorBuilder() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_YamlLoader$AnchorBuilder.prototype = $c_Lorg_yaml_parser_YamlLoader$AnchorBuilder.prototype;
$c_Lorg_yaml_parser_YamlLoader$AnchorBuilder.prototype.init___Lorg_yaml_parser_YamlLoader = (function($$outer) {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.init___Lorg_yaml_parser_YamlLoader__Lorg_mulesoft_lexer_SourceLocation.call(this, $$outer, $$outer.org$yaml$parser$YamlLoader$$YamlBuilder__Lorg_yaml_parser_YamlLoader$YamlBuilder$().$$lessinit$greater$default$1__Lorg_mulesoft_lexer_SourceLocation());
  return this
});
$c_Lorg_yaml_parser_YamlLoader$AnchorBuilder.prototype.create__V = (function() {
  this.addCurrentToken__V();
  var this$1 = this.metaTextBuilder$1;
  var name = this$1.underlying$5.java$lang$StringBuilder$$content$f;
  var location = this.location__Lorg_mulesoft_lexer_SourceLocation();
  var ts = this.buildTokens__sc_IndexedSeq();
  var anchor = new $c_Lorg_yaml_model_YAnchor().init___T__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(name, location, ts);
  this.$$outer$1.org$yaml$parser$YamlLoader$$pop__Lorg_yaml_model_YPart__V(anchor);
  var this$3 = this.$$outer$1;
  var this$4 = this$3.stack$1;
  $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$4.list$1.head__O()).anchor$1 = new $c_s_Some().init___O(anchor)
});
var $d_Lorg_yaml_parser_YamlLoader$AnchorBuilder = new $TypeData().initClass({
  Lorg_yaml_parser_YamlLoader$AnchorBuilder: 0
}, false, "org.yaml.parser.YamlLoader$AnchorBuilder", {
  Lorg_yaml_parser_YamlLoader$AnchorBuilder: 1,
  Lorg_yaml_parser_YamlLoader$YamlBuilder: 1,
  O: 1
});
$c_Lorg_yaml_parser_YamlLoader$AnchorBuilder.prototype.$classData = $d_Lorg_yaml_parser_YamlLoader$AnchorBuilder;
/** @constructor */
function $c_Lorg_yaml_parser_YamlLoader$CommentBuilder() {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.call(this)
}
$c_Lorg_yaml_parser_YamlLoader$CommentBuilder.prototype = new $h_Lorg_yaml_parser_YamlLoader$YamlBuilder();
$c_Lorg_yaml_parser_YamlLoader$CommentBuilder.prototype.constructor = $c_Lorg_yaml_parser_YamlLoader$CommentBuilder;
/** @constructor */
function $h_Lorg_yaml_parser_YamlLoader$CommentBuilder() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_YamlLoader$CommentBuilder.prototype = $c_Lorg_yaml_parser_YamlLoader$CommentBuilder.prototype;
$c_Lorg_yaml_parser_YamlLoader$CommentBuilder.prototype.init___Lorg_yaml_parser_YamlLoader = (function($$outer) {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.init___Lorg_yaml_parser_YamlLoader__Lorg_mulesoft_lexer_SourceLocation.call(this, $$outer, $$outer.org$yaml$parser$YamlLoader$$YamlBuilder__Lorg_yaml_parser_YamlLoader$YamlBuilder$().$$lessinit$greater$default$1__Lorg_mulesoft_lexer_SourceLocation());
  return this
});
$c_Lorg_yaml_parser_YamlLoader$CommentBuilder.prototype.create__V = (function() {
  this.addCurrentToken__V();
  var jsx$1 = this.$$outer$1;
  var this$1 = this.metaTextBuilder$1;
  var metaText = this$1.underlying$5.java$lang$StringBuilder$$content$f;
  var location = this.location__Lorg_mulesoft_lexer_SourceLocation();
  var tokens = this.buildTokens__sc_IndexedSeq();
  jsx$1.org$yaml$parser$YamlLoader$$pop__Lorg_yaml_model_YPart__V(new $c_Lorg_yaml_model_YComment().init___T__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(metaText, location, tokens))
});
var $d_Lorg_yaml_parser_YamlLoader$CommentBuilder = new $TypeData().initClass({
  Lorg_yaml_parser_YamlLoader$CommentBuilder: 0
}, false, "org.yaml.parser.YamlLoader$CommentBuilder", {
  Lorg_yaml_parser_YamlLoader$CommentBuilder: 1,
  Lorg_yaml_parser_YamlLoader$YamlBuilder: 1,
  O: 1
});
$c_Lorg_yaml_parser_YamlLoader$CommentBuilder.prototype.$classData = $d_Lorg_yaml_parser_YamlLoader$CommentBuilder;
/** @constructor */
function $c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder() {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.call(this);
  this.org$yaml$parser$YamlLoader$DirectiveBuilder$$args$2 = null
}
$c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder.prototype = new $h_Lorg_yaml_parser_YamlLoader$YamlBuilder();
$c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder.prototype.constructor = $c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder;
/** @constructor */
function $h_Lorg_yaml_parser_YamlLoader$DirectiveBuilder() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_YamlLoader$DirectiveBuilder.prototype = $c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder.prototype;
$c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder.prototype.init___Lorg_yaml_parser_YamlLoader = (function($$outer) {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.init___Lorg_yaml_parser_YamlLoader__Lorg_mulesoft_lexer_SourceLocation.call(this, $$outer, $$outer.org$yaml$parser$YamlLoader$$YamlBuilder__Lorg_yaml_parser_YamlLoader$YamlBuilder$().$$lessinit$greater$default$1__Lorg_mulesoft_lexer_SourceLocation());
  $m_scm_ListBuffer$();
  var this$2 = new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_ListBuffer().init___());
  this.org$yaml$parser$YamlLoader$DirectiveBuilder$$args$2 = $as_scm_ListBuffer($as_sc_GenTraversable(this$2.elems$1));
  return this
});
$c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder.prototype.create__V = (function() {
  this.addArg__p2__V();
  var parts = this.buildParts__ALorg_yaml_model_YPart();
  var pf = new $c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder$$anonfun$create$3().init___Lorg_yaml_parser_YamlLoader$DirectiveBuilder(this);
  var nonLocalReturnKey1 = new $c_O().init___();
  try {
    var i = 0;
    var len = parts.u.length;
    while ((i < len)) {
      var index = i;
      var arg1 = parts.get(index);
      var $default = $m_s_PartialFunction$().scala$PartialFunction$$fallback$undpf$f;
      var z = pf.applyOrElse__Lorg_yaml_model_YPart__F1__O($as_Lorg_yaml_model_YPart(arg1), $default);
      if ((!$m_s_PartialFunction$().scala$PartialFunction$$fallbackOccurred__O__Z(z))) {
        throw new $c_sr_NonLocalReturnControl().init___O__O(nonLocalReturnKey1, new $c_s_Some().init___O(z))
      };
      i = ((1 + i) | 0)
    };
    $m_s_None$()
  } catch (e) {
    if ((e instanceof $c_sr_NonLocalReturnControl)) {
      var ex = $as_sr_NonLocalReturnControl(e);
      if ((ex.key$2 === nonLocalReturnKey1)) {
        $as_s_Option(ex.value__O())
      } else {
        throw ex
      }
    } else {
      throw e
    }
  };
  var jsx$2 = this.$$outer$1;
  var this$4 = this.org$yaml$parser$YamlLoader$DirectiveBuilder$$args$2;
  var name = $as_T(this$4.scala$collection$mutable$ListBuffer$$start$6.head__O());
  var jsx$1 = $m_s_Predef$();
  var this$5 = this.org$yaml$parser$YamlLoader$DirectiveBuilder$$args$2;
  var this$7 = $as_scg_TraversableForwarder($f_sc_TraversableLike__tail__O(this$5));
  var this$8 = this$7.scala$collection$mutable$ListBuffer$$start$6;
  var len$1 = $f_sc_LinearSeqOptimized__length__I(this$8);
  var result = $newArrayObject($d_T.getArrayOf(), [len$1]);
  $f_sc_TraversableOnce__copyToArray__O__I__V(this$8, result, 0);
  var args = jsx$1.wrapRefArray__AO__scm_WrappedArray(result);
  var location = this.location__Lorg_mulesoft_lexer_SourceLocation();
  var parts$1 = $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray(parts);
  jsx$2.org$yaml$parser$YamlLoader$$pop__Lorg_yaml_model_YPart__V(new $c_Lorg_yaml_model_YDirective().init___T__sc_IndexedSeq__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(name, args, location, parts$1))
});
$c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder.prototype.addArg__p2__V = (function() {
  var this$1 = this.metaTextBuilder$1;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$1)) {
    var jsx$1 = this.org$yaml$parser$YamlLoader$DirectiveBuilder$$args$2;
    var this$2 = this.metaTextBuilder$1;
    jsx$1.$$plus$eq__O__scm_ListBuffer(this$2.underlying$5.java$lang$StringBuilder$$content$f);
    var this$3 = this.metaTextBuilder$1;
    this$3.underlying$5.setLength__I__V(0)
  }
});
$c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder.prototype.processWhitSpace__V = (function() {
  this.addArg__p2__V()
});
var $d_Lorg_yaml_parser_YamlLoader$DirectiveBuilder = new $TypeData().initClass({
  Lorg_yaml_parser_YamlLoader$DirectiveBuilder: 0
}, false, "org.yaml.parser.YamlLoader$DirectiveBuilder", {
  Lorg_yaml_parser_YamlLoader$DirectiveBuilder: 1,
  Lorg_yaml_parser_YamlLoader$YamlBuilder: 1,
  O: 1
});
$c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder.prototype.$classData = $d_Lorg_yaml_parser_YamlLoader$DirectiveBuilder;
/** @constructor */
function $c_Lorg_yaml_parser_YamlLoader$DocBuilder() {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.call(this)
}
$c_Lorg_yaml_parser_YamlLoader$DocBuilder.prototype = new $h_Lorg_yaml_parser_YamlLoader$YamlBuilder();
$c_Lorg_yaml_parser_YamlLoader$DocBuilder.prototype.constructor = $c_Lorg_yaml_parser_YamlLoader$DocBuilder;
/** @constructor */
function $h_Lorg_yaml_parser_YamlLoader$DocBuilder() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_YamlLoader$DocBuilder.prototype = $c_Lorg_yaml_parser_YamlLoader$DocBuilder.prototype;
$c_Lorg_yaml_parser_YamlLoader$DocBuilder.prototype.init___Lorg_yaml_parser_YamlLoader = (function($$outer) {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.init___Lorg_yaml_parser_YamlLoader__Lorg_mulesoft_lexer_SourceLocation.call(this, $$outer, $$outer.org$yaml$parser$YamlLoader$$YamlBuilder__Lorg_yaml_parser_YamlLoader$YamlBuilder$().$$lessinit$greater$default$1__Lorg_mulesoft_lexer_SourceLocation());
  $$outer.org$yaml$parser$YamlLoader$$aliases$1.clear__V();
  return this
});
$c_Lorg_yaml_parser_YamlLoader$DocBuilder.prototype.create__V = (function() {
  this.$$outer$1.org$yaml$parser$YamlLoader$$pop__Lorg_yaml_model_YPart__V(new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(this.location__Lorg_mulesoft_lexer_SourceLocation(), $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray(this.buildParts__ALorg_yaml_model_YPart())))
});
var $d_Lorg_yaml_parser_YamlLoader$DocBuilder = new $TypeData().initClass({
  Lorg_yaml_parser_YamlLoader$DocBuilder: 0
}, false, "org.yaml.parser.YamlLoader$DocBuilder", {
  Lorg_yaml_parser_YamlLoader$DocBuilder: 1,
  Lorg_yaml_parser_YamlLoader$YamlBuilder: 1,
  O: 1
});
$c_Lorg_yaml_parser_YamlLoader$DocBuilder.prototype.$classData = $d_Lorg_yaml_parser_YamlLoader$DocBuilder;
/** @constructor */
function $c_Lorg_yaml_parser_YamlLoader$MapBuilder() {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.call(this)
}
$c_Lorg_yaml_parser_YamlLoader$MapBuilder.prototype = new $h_Lorg_yaml_parser_YamlLoader$YamlBuilder();
$c_Lorg_yaml_parser_YamlLoader$MapBuilder.prototype.constructor = $c_Lorg_yaml_parser_YamlLoader$MapBuilder;
/** @constructor */
function $h_Lorg_yaml_parser_YamlLoader$MapBuilder() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_YamlLoader$MapBuilder.prototype = $c_Lorg_yaml_parser_YamlLoader$MapBuilder.prototype;
$c_Lorg_yaml_parser_YamlLoader$MapBuilder.prototype.init___Lorg_yaml_parser_YamlLoader = (function($$outer) {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.init___Lorg_yaml_parser_YamlLoader__Lorg_mulesoft_lexer_SourceLocation.call(this, $$outer, $$outer.org$yaml$parser$YamlLoader$$YamlBuilder__Lorg_yaml_parser_YamlLoader$YamlBuilder$().$$lessinit$greater$default$1__Lorg_mulesoft_lexer_SourceLocation());
  return this
});
$c_Lorg_yaml_parser_YamlLoader$MapBuilder.prototype.create__V = (function() {
  var parts = this.buildParts__ALorg_yaml_model_YPart();
  this.$$outer$1.org$yaml$parser$YamlLoader$$duplicates__ALorg_yaml_model_YPart__V(parts);
  $m_Lorg_yaml_model_YMap$();
  var location = this.location__Lorg_mulesoft_lexer_SourceLocation();
  var c = $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray(parts);
  var v = new $c_Lorg_yaml_model_YMap().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(location, c);
  this.$$outer$1.org$yaml$parser$YamlLoader$$pop__Lorg_yaml_model_YPart__V(v);
  var this$2 = this.$$outer$1;
  var this$3 = this$2.stack$1;
  $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$3.list$1.head__O()).setValue__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__V(v, $m_Lorg_yaml_model_YType$().Map$1)
});
var $d_Lorg_yaml_parser_YamlLoader$MapBuilder = new $TypeData().initClass({
  Lorg_yaml_parser_YamlLoader$MapBuilder: 0
}, false, "org.yaml.parser.YamlLoader$MapBuilder", {
  Lorg_yaml_parser_YamlLoader$MapBuilder: 1,
  Lorg_yaml_parser_YamlLoader$YamlBuilder: 1,
  O: 1
});
$c_Lorg_yaml_parser_YamlLoader$MapBuilder.prototype.$classData = $d_Lorg_yaml_parser_YamlLoader$MapBuilder;
/** @constructor */
function $c_Lorg_yaml_parser_YamlLoader$NodeBuilder() {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.call(this)
}
$c_Lorg_yaml_parser_YamlLoader$NodeBuilder.prototype = new $h_Lorg_yaml_parser_YamlLoader$YamlBuilder();
$c_Lorg_yaml_parser_YamlLoader$NodeBuilder.prototype.constructor = $c_Lorg_yaml_parser_YamlLoader$NodeBuilder;
/** @constructor */
function $h_Lorg_yaml_parser_YamlLoader$NodeBuilder() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_YamlLoader$NodeBuilder.prototype = $c_Lorg_yaml_parser_YamlLoader$NodeBuilder.prototype;
$c_Lorg_yaml_parser_YamlLoader$NodeBuilder.prototype.init___Lorg_yaml_parser_YamlLoader = (function($$outer) {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.init___Lorg_yaml_parser_YamlLoader__Lorg_mulesoft_lexer_SourceLocation.call(this, $$outer, $$outer.org$yaml$parser$YamlLoader$$YamlBuilder__Lorg_yaml_parser_YamlLoader$YamlBuilder$().$$lessinit$greater$default$1__Lorg_mulesoft_lexer_SourceLocation());
  return this
});
$c_Lorg_yaml_parser_YamlLoader$NodeBuilder.prototype.create__V = (function() {
  var parts = this.buildParts__ALorg_yaml_model_YPart();
  var loc = this.location__Lorg_mulesoft_lexer_SourceLocation();
  var x = this.alias$1;
  var this$2 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$2)) {
    var jsx$2 = this.alias$1;
    var this$3 = this.$$outer$1.org$yaml$parser$YamlLoader$$aliases$1;
    var key = this.alias$1;
    var x1 = this$3.get__O__s_Option(key);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var v = x2.value$2;
      var jsx$1 = v
    } else {
      var x$1 = $m_s_None$();
      if ((!(x$1 === x1))) {
        throw new $c_s_MatchError().init___O(x1)
      };
      this.$$outer$1.eh$1.handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V(loc, new $c_Lorg_yaml_model_UndefinedAnchorException().init___T__jl_Exception(this.alias$1, null));
      var jsx$1 = $m_Lorg_yaml_model_YNode$().Null$1
    };
    var node = new $c_Lorg_yaml_model_YNode$Alias().init___T__Lorg_yaml_model_YNode__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(jsx$2, $as_Lorg_yaml_model_YNode(jsx$1), loc, $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray(parts))
  } else {
    var x$2 = this.$$outer$1.includeTag$1;
    var this$5 = new $c_sci_StringOps().init___T(x$2);
    if (($f_sc_TraversableOnce__nonEmpty__Z(this$5) && (this.tag$1.text$3 === this.$$outer$1.includeTag$1))) {
      var node = new $c_Lorg_yaml_model_YNode$MutRef().init___Lorg_yaml_model_YValue__Lorg_yaml_model_YTag__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(this.value$1, this.tag$1, loc, $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray(parts))
    } else {
      var node = new $c_Lorg_yaml_model_YNodePlain().init___Lorg_yaml_model_YValue__Lorg_yaml_model_YTag__s_Option__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(this.value$1, this.tag$1, this.anchor$1, loc, $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray(parts))
    }
  };
  var this$6 = this.anchor$1;
  if ((!this$6.isEmpty__Z())) {
    var arg1 = this$6.get__O();
    var a = $as_Lorg_yaml_model_YAnchor(arg1);
    var jsx$3 = this.$$outer$1.org$yaml$parser$YamlLoader$$aliases$1;
    var self = a.name$3;
    $as_scm_Map(jsx$3.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(self, node)))
  };
  this.$$outer$1.org$yaml$parser$YamlLoader$$pop__Lorg_yaml_model_YPart__V(node)
});
function $as_Lorg_yaml_parser_YamlLoader$NodeBuilder(obj) {
  return (((obj instanceof $c_Lorg_yaml_parser_YamlLoader$NodeBuilder) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.parser.YamlLoader$NodeBuilder"))
}
function $isArrayOf_Lorg_yaml_parser_YamlLoader$NodeBuilder(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_parser_YamlLoader$NodeBuilder)))
}
function $asArrayOf_Lorg_yaml_parser_YamlLoader$NodeBuilder(obj, depth) {
  return (($isArrayOf_Lorg_yaml_parser_YamlLoader$NodeBuilder(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.parser.YamlLoader$NodeBuilder;", depth))
}
var $d_Lorg_yaml_parser_YamlLoader$NodeBuilder = new $TypeData().initClass({
  Lorg_yaml_parser_YamlLoader$NodeBuilder: 0
}, false, "org.yaml.parser.YamlLoader$NodeBuilder", {
  Lorg_yaml_parser_YamlLoader$NodeBuilder: 1,
  Lorg_yaml_parser_YamlLoader$YamlBuilder: 1,
  O: 1
});
$c_Lorg_yaml_parser_YamlLoader$NodeBuilder.prototype.$classData = $d_Lorg_yaml_parser_YamlLoader$NodeBuilder;
/** @constructor */
function $c_Lorg_yaml_parser_YamlLoader$PairBuilder() {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.call(this)
}
$c_Lorg_yaml_parser_YamlLoader$PairBuilder.prototype = new $h_Lorg_yaml_parser_YamlLoader$YamlBuilder();
$c_Lorg_yaml_parser_YamlLoader$PairBuilder.prototype.constructor = $c_Lorg_yaml_parser_YamlLoader$PairBuilder;
/** @constructor */
function $h_Lorg_yaml_parser_YamlLoader$PairBuilder() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_YamlLoader$PairBuilder.prototype = $c_Lorg_yaml_parser_YamlLoader$PairBuilder.prototype;
$c_Lorg_yaml_parser_YamlLoader$PairBuilder.prototype.init___Lorg_yaml_parser_YamlLoader = (function($$outer) {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.init___Lorg_yaml_parser_YamlLoader__Lorg_mulesoft_lexer_SourceLocation.call(this, $$outer, $$outer.org$yaml$parser$YamlLoader$$YamlBuilder__Lorg_yaml_parser_YamlLoader$YamlBuilder$().$$lessinit$greater$default$1__Lorg_mulesoft_lexer_SourceLocation());
  return this
});
$c_Lorg_yaml_parser_YamlLoader$PairBuilder.prototype.create__V = (function() {
  this.$$outer$1.org$yaml$parser$YamlLoader$$pop__Lorg_yaml_model_YPart__V($m_Lorg_yaml_model_YMapEntry$().apply__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(this.location__Lorg_mulesoft_lexer_SourceLocation(), $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray(this.buildParts__ALorg_yaml_model_YPart())))
});
var $d_Lorg_yaml_parser_YamlLoader$PairBuilder = new $TypeData().initClass({
  Lorg_yaml_parser_YamlLoader$PairBuilder: 0
}, false, "org.yaml.parser.YamlLoader$PairBuilder", {
  Lorg_yaml_parser_YamlLoader$PairBuilder: 1,
  Lorg_yaml_parser_YamlLoader$YamlBuilder: 1,
  O: 1
});
$c_Lorg_yaml_parser_YamlLoader$PairBuilder.prototype.$classData = $d_Lorg_yaml_parser_YamlLoader$PairBuilder;
/** @constructor */
function $c_Lorg_yaml_parser_YamlLoader$ScalarBuilder() {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.call(this);
  this.text$2 = null;
  this.mark$2 = null
}
$c_Lorg_yaml_parser_YamlLoader$ScalarBuilder.prototype = new $h_Lorg_yaml_parser_YamlLoader$YamlBuilder();
$c_Lorg_yaml_parser_YamlLoader$ScalarBuilder.prototype.constructor = $c_Lorg_yaml_parser_YamlLoader$ScalarBuilder;
/** @constructor */
function $h_Lorg_yaml_parser_YamlLoader$ScalarBuilder() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_YamlLoader$ScalarBuilder.prototype = $c_Lorg_yaml_parser_YamlLoader$ScalarBuilder.prototype;
$c_Lorg_yaml_parser_YamlLoader$ScalarBuilder.prototype.appendText__jl_CharSequence__V = (function(txt) {
  var x = this.mark$2;
  var x$2 = $m_Lorg_yaml_model_UnknownMark$();
  if (((x !== null) && (x === x$2))) {
    this.mark$2 = $m_Lorg_yaml_model_NoMark$()
  };
  this.text$2.append__O__scm_StringBuilder(txt)
});
$c_Lorg_yaml_parser_YamlLoader$ScalarBuilder.prototype.init___Lorg_yaml_parser_YamlLoader__Lorg_yaml_model_YTag = (function($$outer, t) {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.init___Lorg_yaml_parser_YamlLoader__Lorg_mulesoft_lexer_SourceLocation.call(this, $$outer, $$outer.org$yaml$parser$YamlLoader$$YamlBuilder__Lorg_yaml_parser_YamlLoader$YamlBuilder$().$$lessinit$greater$default$1__Lorg_mulesoft_lexer_SourceLocation());
  this.tag$1 = t;
  this.text$2 = new $c_scm_StringBuilder().init___();
  this.mark$2 = $m_Lorg_yaml_model_UnknownMark$();
  return this
});
$c_Lorg_yaml_parser_YamlLoader$ScalarBuilder.prototype.create__V = (function() {
  var this$1 = this.text$2;
  var txt = this$1.underlying$5.java$lang$StringBuilder$$content$f;
  var x = this.mark$2;
  var x$2 = $m_Lorg_yaml_model_UnknownMark$();
  if (((x !== null) && (x === x$2))) {
    var m = $m_Lorg_yaml_model_NoMark$()
  } else {
    var m = this.mark$2
  };
  var loc = this.location__Lorg_mulesoft_lexer_SourceLocation();
  var r = $m_Lorg_yaml_parser_ScalarParser$().parse__T__Lorg_yaml_model_ScalarMark__Lorg_yaml_model_YTag__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_ParserResult(txt, m, this.tag$1, loc, this.$$outer$1.eh$1);
  var scalar = new $c_Lorg_yaml_model_YScalar().init___O__T__Lorg_yaml_model_ScalarMark__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(r.value$1, txt, m, loc, $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray(this.buildParts__ALorg_yaml_model_YPart()));
  this.$$outer$1.org$yaml$parser$YamlLoader$$pop__Lorg_yaml_model_YPart__V(scalar);
  var this$2 = this.$$outer$1;
  var this$3 = this$2.stack$1;
  $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$3.list$1.head__O()).setValue__Lorg_yaml_model_YValue__Lorg_yaml_model_YTag__V(scalar, r.tag$1)
});
$c_Lorg_yaml_parser_YamlLoader$ScalarBuilder.prototype.processIndicator__V = (function() {
  var x = this.mark$2;
  var x$2 = $m_Lorg_yaml_model_UnknownMark$();
  if (((x !== null) && (x === x$2))) {
    var jsx$1 = $m_Lorg_yaml_model_ScalarMark$();
    var this$1 = this.$$outer$1.lexer$1;
    this.mark$2 = jsx$1.apply__T__Lorg_yaml_model_ScalarMark($objectToString(this$1.tokenText__Lorg_mulesoft_lexer_TokenData__jl_CharSequence(this$1.$$undtokenData$1)))
  };
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.processIndicator__V.call(this)
});
var $d_Lorg_yaml_parser_YamlLoader$ScalarBuilder = new $TypeData().initClass({
  Lorg_yaml_parser_YamlLoader$ScalarBuilder: 0
}, false, "org.yaml.parser.YamlLoader$ScalarBuilder", {
  Lorg_yaml_parser_YamlLoader$ScalarBuilder: 1,
  Lorg_yaml_parser_YamlLoader$YamlBuilder: 1,
  O: 1
});
$c_Lorg_yaml_parser_YamlLoader$ScalarBuilder.prototype.$classData = $d_Lorg_yaml_parser_YamlLoader$ScalarBuilder;
/** @constructor */
function $c_Lorg_yaml_parser_YamlLoader$SeqBuilder() {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.call(this)
}
$c_Lorg_yaml_parser_YamlLoader$SeqBuilder.prototype = new $h_Lorg_yaml_parser_YamlLoader$YamlBuilder();
$c_Lorg_yaml_parser_YamlLoader$SeqBuilder.prototype.constructor = $c_Lorg_yaml_parser_YamlLoader$SeqBuilder;
/** @constructor */
function $h_Lorg_yaml_parser_YamlLoader$SeqBuilder() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_YamlLoader$SeqBuilder.prototype = $c_Lorg_yaml_parser_YamlLoader$SeqBuilder.prototype;
$c_Lorg_yaml_parser_YamlLoader$SeqBuilder.prototype.init___Lorg_yaml_parser_YamlLoader = (function($$outer) {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.init___Lorg_yaml_parser_YamlLoader__Lorg_mulesoft_lexer_SourceLocation.call(this, $$outer, $$outer.org$yaml$parser$YamlLoader$$YamlBuilder__Lorg_yaml_parser_YamlLoader$YamlBuilder$().$$lessinit$greater$default$1__Lorg_mulesoft_lexer_SourceLocation());
  return this
});
$c_Lorg_yaml_parser_YamlLoader$SeqBuilder.prototype.create__V = (function() {
  $m_Lorg_yaml_model_YSequence$();
  var loc = this.location__Lorg_mulesoft_lexer_SourceLocation();
  var parts = $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray(this.buildParts__ALorg_yaml_model_YPart());
  var v = new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts);
  this.$$outer$1.org$yaml$parser$YamlLoader$$pop__Lorg_yaml_model_YPart__V(v);
  var this$2 = this.$$outer$1;
  var this$3 = this$2.stack$1;
  $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$3.list$1.head__O()).setValue__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__V(v, $m_Lorg_yaml_model_YType$().Seq$1)
});
var $d_Lorg_yaml_parser_YamlLoader$SeqBuilder = new $TypeData().initClass({
  Lorg_yaml_parser_YamlLoader$SeqBuilder: 0
}, false, "org.yaml.parser.YamlLoader$SeqBuilder", {
  Lorg_yaml_parser_YamlLoader$SeqBuilder: 1,
  Lorg_yaml_parser_YamlLoader$YamlBuilder: 1,
  O: 1
});
$c_Lorg_yaml_parser_YamlLoader$SeqBuilder.prototype.$classData = $d_Lorg_yaml_parser_YamlLoader$SeqBuilder;
/** @constructor */
function $c_Lorg_yaml_parser_YamlLoader$TagBuilder() {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.call(this)
}
$c_Lorg_yaml_parser_YamlLoader$TagBuilder.prototype = new $h_Lorg_yaml_parser_YamlLoader$YamlBuilder();
$c_Lorg_yaml_parser_YamlLoader$TagBuilder.prototype.constructor = $c_Lorg_yaml_parser_YamlLoader$TagBuilder;
/** @constructor */
function $h_Lorg_yaml_parser_YamlLoader$TagBuilder() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_YamlLoader$TagBuilder.prototype = $c_Lorg_yaml_parser_YamlLoader$TagBuilder.prototype;
$c_Lorg_yaml_parser_YamlLoader$TagBuilder.prototype.init___Lorg_yaml_parser_YamlLoader = (function($$outer) {
  $c_Lorg_yaml_parser_YamlLoader$YamlBuilder.prototype.init___Lorg_yaml_parser_YamlLoader__Lorg_mulesoft_lexer_SourceLocation.call(this, $$outer, $$outer.org$yaml$parser$YamlLoader$$YamlBuilder__Lorg_yaml_parser_YamlLoader$YamlBuilder$().$$lessinit$greater$default$1__Lorg_mulesoft_lexer_SourceLocation());
  return this
});
$c_Lorg_yaml_parser_YamlLoader$TagBuilder.prototype.create__V = (function() {
  this.addCurrentToken__V();
  var jsx$3 = $m_Lorg_yaml_model_YTag$();
  var this$1 = this.metaTextBuilder$1;
  var jsx$2 = this$1.underlying$5.java$lang$StringBuilder$$content$f;
  var jsx$1 = this.location__Lorg_mulesoft_lexer_SourceLocation();
  var this$2 = this.$$outer$1;
  var this$3 = this$2.stack$1;
  var t = jsx$3.apply__T__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq__Lorg_yaml_model_YTag(jsx$2, jsx$1, $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$3.list$1.head__O()).buildTokens__sc_IndexedSeq());
  this.$$outer$1.org$yaml$parser$YamlLoader$$pop__Lorg_yaml_model_YPart__V(t);
  var this$4 = this.$$outer$1;
  var this$5 = this$4.stack$1;
  var x1 = $as_Lorg_yaml_parser_YamlLoader$YamlBuilder(this$5.list$1.head__O());
  if ((x1 instanceof $c_Lorg_yaml_parser_YamlLoader$NodeBuilder)) {
    var x2 = $as_Lorg_yaml_parser_YamlLoader$NodeBuilder(x1);
    x2.tag$1 = t
  }
});
$c_Lorg_yaml_parser_YamlLoader$TagBuilder.prototype.processIndicator__V = (function() {
  var jsx$1 = this.metaTextBuilder$1;
  var this$1 = this.$$outer$1.lexer$1;
  jsx$1.append__O__scm_StringBuilder(this$1.tokenText__Lorg_mulesoft_lexer_TokenData__jl_CharSequence(this$1.$$undtokenData$1))
});
var $d_Lorg_yaml_parser_YamlLoader$TagBuilder = new $TypeData().initClass({
  Lorg_yaml_parser_YamlLoader$TagBuilder: 0
}, false, "org.yaml.parser.YamlLoader$TagBuilder", {
  Lorg_yaml_parser_YamlLoader$TagBuilder: 1,
  Lorg_yaml_parser_YamlLoader$YamlBuilder: 1,
  O: 1
});
$c_Lorg_yaml_parser_YamlLoader$TagBuilder.prototype.$classData = $d_Lorg_yaml_parser_YamlLoader$TagBuilder;
/** @constructor */
function $c_Lorg_yaml_parser_YamlParser() {
  $c_O.call(this);
  this.lexer$1 = null;
  this.eh$1 = null;
  this.includeTag$1 = null
}
$c_Lorg_yaml_parser_YamlParser.prototype = new $h_O();
$c_Lorg_yaml_parser_YamlParser.prototype.constructor = $c_Lorg_yaml_parser_YamlParser;
/** @constructor */
function $h_Lorg_yaml_parser_YamlParser() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_YamlParser.prototype = $c_Lorg_yaml_parser_YamlParser.prototype;
$c_Lorg_yaml_parser_YamlParser.prototype.parse__Z__sc_IndexedSeq = (function(keepTokens) {
  return new $c_Lorg_yaml_parser_YamlLoader().init___Lorg_yaml_lexer_YamlLexer__Z__T__Lorg_yaml_model_ParseErrorHandler(this.lexer$1, keepTokens, this.includeTag$1, this.eh$1).parse__sc_IndexedSeq()
});
$c_Lorg_yaml_parser_YamlParser.prototype.init___Lorg_yaml_lexer_YamlLexer__Lorg_yaml_model_ParseErrorHandler = (function(lexer, eh) {
  this.lexer$1 = lexer;
  this.eh$1 = eh;
  this.includeTag$1 = "";
  return this
});
$c_Lorg_yaml_parser_YamlParser.prototype.documents__sc_IndexedSeq = (function() {
  var parts = this.parse__Z__sc_IndexedSeq(false);
  var header = $as_sc_IndexedSeq(parts.takeWhile__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(p$2) {
      var p = $as_Lorg_yaml_model_YPart(p$2);
      return (!(p instanceof $c_Lorg_yaml_model_YDocument))
    })
  })(this))));
  var jsx$1 = new $c_Lorg_yaml_parser_YamlParser$$anonfun$1().init___Lorg_yaml_parser_YamlParser(this);
  var t = new $c_s_reflect_ClassTag$GenericClassTag().init___jl_Class($d_Lorg_yaml_model_YDocument.getClassOf());
  var b = new $c_s_Array$ArrayCanBuildFrom$1().init___s_reflect_ClassTag(t);
  var docs = $asArrayOf_Lorg_yaml_model_YDocument(parts.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, new $c_sc_package$$anon$1().init___scg_CanBuildFrom(b)), 1);
  if ((docs.u.length !== 0)) {
    var jsx$3 = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this.lexer$1.sourceName$1);
    var jsx$2 = docs.get(0).children$1;
    var this$6 = $m_sc_IndexedSeq$();
    docs.set(0, new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(jsx$3, $as_sc_IndexedSeq(header.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$6.ReusableCBF$6))))
  };
  return $m_s_Predef$().wrapRefArray__AO__scm_WrappedArray(docs)
});
$c_Lorg_yaml_parser_YamlParser.prototype.withIncludeTag__T__Lorg_yaml_parser_YamlParser = (function(s) {
  this.includeTag$1 = s;
  return this
});
var $d_Lorg_yaml_parser_YamlParser = new $TypeData().initClass({
  Lorg_yaml_parser_YamlParser: 0
}, false, "org.yaml.parser.YamlParser", {
  Lorg_yaml_parser_YamlParser: 1,
  O: 1,
  Lorg_yaml_parser_YParser: 1
});
$c_Lorg_yaml_parser_YamlParser.prototype.$classData = $d_Lorg_yaml_parser_YamlParser;
/** @constructor */
function $c_Lorg_yaml_render_JsonRenderOptions() {
  $c_O.call(this);
  this.encodeNonAscii$1 = false;
  this.insertSpaces$1 = false;
  this.indentSize$1 = 0
}
$c_Lorg_yaml_render_JsonRenderOptions.prototype = new $h_O();
$c_Lorg_yaml_render_JsonRenderOptions.prototype.constructor = $c_Lorg_yaml_render_JsonRenderOptions;
/** @constructor */
function $h_Lorg_yaml_render_JsonRenderOptions() {
  /*<skip>*/
}
$h_Lorg_yaml_render_JsonRenderOptions.prototype = $c_Lorg_yaml_render_JsonRenderOptions.prototype;
$c_Lorg_yaml_render_JsonRenderOptions.prototype.init___ = (function() {
  this.indentSize$1 = 2;
  this.encodeNonAscii$1 = true;
  this.insertSpaces$1 = true;
  return this
});
$c_Lorg_yaml_render_JsonRenderOptions.prototype.withoutNonAsciiEncode__Lorg_yaml_render_JsonRenderOptions = (function() {
  this.encodeNonAscii$1 = false;
  return this
});
var $d_Lorg_yaml_render_JsonRenderOptions = new $TypeData().initClass({
  Lorg_yaml_render_JsonRenderOptions: 0
}, false, "org.yaml.render.JsonRenderOptions", {
  Lorg_yaml_render_JsonRenderOptions: 1,
  O: 1,
  Lorg_yaml_render_RenderOptions: 1
});
$c_Lorg_yaml_render_JsonRenderOptions.prototype.$classData = $d_Lorg_yaml_render_JsonRenderOptions;
/** @constructor */
function $c_Lorg_yaml_render_YamlRenderOptions() {
  $c_O.call(this);
  this.indentSize$1 = 0
}
$c_Lorg_yaml_render_YamlRenderOptions.prototype = new $h_O();
$c_Lorg_yaml_render_YamlRenderOptions.prototype.constructor = $c_Lorg_yaml_render_YamlRenderOptions;
/** @constructor */
function $h_Lorg_yaml_render_YamlRenderOptions() {
  /*<skip>*/
}
$h_Lorg_yaml_render_YamlRenderOptions.prototype = $c_Lorg_yaml_render_YamlRenderOptions.prototype;
$c_Lorg_yaml_render_YamlRenderOptions.prototype.init___ = (function() {
  this.indentSize$1 = 2;
  return this
});
var $d_Lorg_yaml_render_YamlRenderOptions = new $TypeData().initClass({
  Lorg_yaml_render_YamlRenderOptions: 0
}, false, "org.yaml.render.YamlRenderOptions", {
  Lorg_yaml_render_YamlRenderOptions: 1,
  O: 1,
  Lorg_yaml_render_RenderOptions: 1
});
$c_Lorg_yaml_render_YamlRenderOptions.prototype.$classData = $d_Lorg_yaml_render_YamlRenderOptions;
/** @constructor */
function $c_Lscopt_Read$() {
  $c_O.call(this);
  this.stringRead$1 = null;
  this.charRead$1 = null;
  this.doubleRead$1 = null;
  this.booleanRead$1 = null;
  this.intRead$1 = null;
  this.longRead$1 = null;
  this.bigIntRead$1 = null;
  this.bigDecimalRead$1 = null;
  this.durationRead$1 = null;
  this.unitRead$1 = null;
  this.sep$1 = null;
  this.uriRead$1 = null
}
$c_Lscopt_Read$.prototype = new $h_O();
$c_Lscopt_Read$.prototype.constructor = $c_Lscopt_Read$;
/** @constructor */
function $h_Lscopt_Read$() {
  /*<skip>*/
}
$h_Lscopt_Read$.prototype = $c_Lscopt_Read$.prototype;
$c_Lscopt_Read$.prototype.init___ = (function() {
  $n_Lscopt_Read$ = this;
  $f_Lscopt_platform$PlatformReadInstances__$$init$__V(this);
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2) {
      var x = $as_T(x$2);
      return x
    })
  })(this));
  this.stringRead$1 = new $c_Lscopt_Read$$anon$2().init___F1(f);
  var f$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$1$2) {
      var x$1 = $as_T(x$1$2);
      var x1 = $m_sjsr_RuntimeString$().getBytes__T__Ljava_nio_charset_Charset__AB(x$1, $m_Ljava_nio_charset_UTF$und8$());
      matchEnd4: {
        var c;
        var o7 = $m_s_Array$().unapplySeq__O__s_Option(x1);
        if (((!o7.isEmpty__Z()) && ((o7.get__O() !== null) && ($as_sc_SeqLike(o7.get__O()).lengthCompare__I__I(1) === 0)))) {
          var $char = $uB($as_sc_SeqLike(o7.get__O()).apply__I__O(0));
          var c = (65535 & $char);
          break matchEnd4
        };
        throw new $c_jl_IllegalArgumentException().init___T((("'" + x1) + "' is not a char."))
      };
      return new $c_jl_Character().init___C(c)
    })
  })(this));
  this.charRead$1 = new $c_Lscopt_Read$$anon$2().init___F1(f$1);
  var f$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x$2$2$2) {
      var x$2$2 = $as_T(x$2$2$2);
      var this$9 = new $c_sci_StringOps().init___T(x$2$2);
      var jsx$1 = $m_jl_Double$();
      var $$this = this$9.repr$1;
      return jsx$1.parseDouble__T__D($$this)
    })
  })(this));
  this.doubleRead$1 = new $c_Lscopt_Read$$anon$2().init___F1(f$2);
  var f$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
    return (function(x$3$2) {
      var x$3 = $as_T(x$3$2);
      var x1$1 = $as_T(x$3.toLowerCase());
      if ((x1$1 === "true")) {
        return true
      } else if ((x1$1 !== "false")) {
        if ((x1$1 === "yes")) {
          return true
        } else if ((x1$1 !== "no")) {
          if ((x1$1 === "1")) {
            return true
          } else if ((x1$1 === "0")) {
            return false
          } else {
            throw new $c_jl_IllegalArgumentException().init___T((("'" + x1$1) + "' is not a boolean."))
          }
        } else {
          return false
        }
      } else {
        return false
      }
    })
  })(this));
  this.booleanRead$1 = new $c_Lscopt_Read$$anon$2().init___F1(f$3);
  var f$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1) {
    return (function(str$2) {
      var str = $as_T(str$2);
      var x1$2 = $m_Lscopt_Read$().fixedPointWithRadix__p1__T__T2(str);
      if ((x1$2 === null)) {
        throw new $c_s_MatchError().init___O(x1$2)
      };
      var s = $as_T(x1$2.$$und1__O());
      var radix = x1$2.$$und2$mcI$sp__I();
      return $m_jl_Integer$().parseInt__T__I__I(s, radix)
    })
  })(this));
  this.intRead$1 = new $c_Lscopt_Read$$anon$2().init___F1(f$4);
  var f$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1) {
    return (function(str$3$2) {
      var str$3 = $as_T(str$3$2);
      var x1$3 = $m_Lscopt_Read$().fixedPointWithRadix__p1__T__T2(str$3);
      if ((x1$3 === null)) {
        throw new $c_s_MatchError().init___O(x1$3)
      };
      var s$1 = $as_T(x1$3.$$und1__O());
      var radix$1 = x1$3.$$und2$mcI$sp__I();
      return $m_jl_Long$().parseLong__T__I__J(s$1, radix$1)
    })
  })(this));
  this.longRead$1 = new $c_Lscopt_Read$$anon$2().init___F1(f$5);
  var f$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$7$1) {
    return (function(str$4$2) {
      var str$4 = $as_T(str$4$2);
      var x1$4 = $m_Lscopt_Read$().fixedPointWithRadix__p1__T__T2(str$4);
      if ((x1$4 === null)) {
        throw new $c_s_MatchError().init___O(x1$4)
      };
      var s$2 = $as_T(x1$4.$$und1__O());
      var radix$2 = x1$4.$$und2$mcI$sp__I();
      return $m_s_package$().BigInt__s_math_BigInt$().apply__T__I__s_math_BigInt(s$2, radix$2)
    })
  })(this));
  this.bigIntRead$1 = new $c_Lscopt_Read$$anon$2().init___F1(f$6);
  var f$7 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$8$1) {
    return (function(x$7$2) {
      var x$7 = $as_T(x$7$2);
      var this$12 = $m_s_package$().BigDecimal__s_math_BigDecimal$();
      return this$12.exact__T__s_math_BigDecimal(x$7)
    })
  })(this));
  this.bigDecimalRead$1 = new $c_Lscopt_Read$$anon$2().init___F1(f$7);
  var f$8 = this.liftedTree1$1__p1__F1();
  this.durationRead$1 = new $c_Lscopt_Read$$anon$2().init___F1(f$8);
  this.unitRead$1 = new $c_Lscopt_Read$$anon$4().init___();
  this.sep$1 = ",";
  return this
});
$c_Lscopt_Read$.prototype.liftedTree1$1__p1__F1 = (function() {
  try {
    return new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$8$2) {
        var x$8 = $as_T(x$8$2);
        return $m_s_concurrent_duration_Duration$().apply__T__s_concurrent_duration_Duration(x$8)
      })
    })(this))
  } catch (e) {
    if ((e instanceof $c_jl_NumberFormatException)) {
      var e$2 = $as_jl_NumberFormatException(e);
      $m_Lscopt_platform$();
      var s = e$2.s$1;
      throw new $c_Lscopt_ParseException().init___T__I(s, (-1))
    } else {
      throw e
    }
  }
});
$c_Lscopt_Read$.prototype.fixedPointWithRadix__p1__T__T2 = (function(str) {
  var x1 = $as_T(str.toLowerCase());
  if ((($uI(x1.length) >= 0) && ($as_T(x1.substring(0, $uI("0x".length))) === "0x"))) {
    var this$8 = new $c_sci_StringOps().init___T(x1);
    return new $c_T2().init___O__O($f_sci_StringLike__stripPrefix__T__T(this$8, "0x"), 16)
  } else {
    return new $c_T2().init___O__O(x1, 10)
  }
});
$c_Lscopt_Read$.prototype.seqRead__Lscopt_Read__Lscopt_Read = (function(evidence$3) {
  var f$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, evidence$3$1) {
    return (function(s$2) {
      var s = $as_T(s$2);
      var regex = $m_Lscopt_Read$().sep$1;
      var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(s, regex, 0);
      var f = evidence$3$1.reads__F1();
      var this$5 = $m_s_Array$();
      new $c_s_Predef$DummyImplicit().init___();
      new $c_s_FallbackArrayBuilding$$anon$1().init___s_FallbackArrayBuilding(this$5);
      var b = $m_scm_ArraySeq$().newBuilder__scm_Builder();
      var x1 = xs.u.length;
      switch (x1) {
        case (-1): {
          break
        }
        default: {
          b.sizeHint__I__V(x1)
        }
      };
      var i = 0;
      var len = xs.u.length;
      while ((i < len)) {
        var index = i;
        var arg1 = xs.get(index);
        b.$$plus$eq__O__scm_Builder(f.apply__O__O(arg1));
        i = ((1 + i) | 0)
      };
      return $as_sc_Seq(b.result__O())
    })
  })(this, evidence$3));
  return new $c_Lscopt_Read$$anon$2().init___F1(f$1)
});
var $d_Lscopt_Read$ = new $TypeData().initClass({
  Lscopt_Read$: 0
}, false, "scopt.Read$", {
  Lscopt_Read$: 1,
  O: 1,
  Lscopt_platform$PlatformReadInstances: 1
});
$c_Lscopt_Read$.prototype.$classData = $d_Lscopt_Read$;
var $n_Lscopt_Read$ = (void 0);
function $m_Lscopt_Read$() {
  if ((!$n_Lscopt_Read$)) {
    $n_Lscopt_Read$ = new $c_Lscopt_Read$().init___()
  };
  return $n_Lscopt_Read$
}
/** @constructor */
function $c_Lscopt_Read$$anon$2() {
  $c_O.call(this);
  this.arity$1 = 0;
  this.reads$1 = null
}
$c_Lscopt_Read$$anon$2.prototype = new $h_O();
$c_Lscopt_Read$$anon$2.prototype.constructor = $c_Lscopt_Read$$anon$2;
/** @constructor */
function $h_Lscopt_Read$$anon$2() {
  /*<skip>*/
}
$h_Lscopt_Read$$anon$2.prototype = $c_Lscopt_Read$$anon$2.prototype;
$c_Lscopt_Read$$anon$2.prototype.arity__I = (function() {
  return this.arity$1
});
$c_Lscopt_Read$$anon$2.prototype.reads__F1 = (function() {
  return this.reads$1
});
$c_Lscopt_Read$$anon$2.prototype.init___F1 = (function(f$1) {
  this.arity$1 = 1;
  this.reads$1 = f$1;
  return this
});
var $d_Lscopt_Read$$anon$2 = new $TypeData().initClass({
  Lscopt_Read$$anon$2: 0
}, false, "scopt.Read$$anon$2", {
  Lscopt_Read$$anon$2: 1,
  O: 1,
  Lscopt_Read: 1
});
$c_Lscopt_Read$$anon$2.prototype.$classData = $d_Lscopt_Read$$anon$2;
/** @constructor */
function $c_Lscopt_Read$$anon$4() {
  $c_O.call(this);
  this.arity$1 = 0;
  this.reads$1 = null
}
$c_Lscopt_Read$$anon$4.prototype = new $h_O();
$c_Lscopt_Read$$anon$4.prototype.constructor = $c_Lscopt_Read$$anon$4;
/** @constructor */
function $h_Lscopt_Read$$anon$4() {
  /*<skip>*/
}
$h_Lscopt_Read$$anon$4.prototype = $c_Lscopt_Read$$anon$4.prototype;
$c_Lscopt_Read$$anon$4.prototype.init___ = (function() {
  this.arity$1 = 0;
  this.reads$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(s$2) {
      $as_T(s$2)
    })
  })(this));
  return this
});
$c_Lscopt_Read$$anon$4.prototype.arity__I = (function() {
  return this.arity$1
});
$c_Lscopt_Read$$anon$4.prototype.reads__F1 = (function() {
  return this.reads$1
});
var $d_Lscopt_Read$$anon$4 = new $TypeData().initClass({
  Lscopt_Read$$anon$4: 0
}, false, "scopt.Read$$anon$4", {
  Lscopt_Read$$anon$4: 1,
  O: 1,
  Lscopt_Read: 1
});
$c_Lscopt_Read$$anon$4.prototype.$classData = $d_Lscopt_Read$$anon$4;
/** @constructor */
function $c_jl_Number() {
  $c_O.call(this)
}
$c_jl_Number.prototype = new $h_O();
$c_jl_Number.prototype.constructor = $c_jl_Number;
/** @constructor */
function $h_jl_Number() {
  /*<skip>*/
}
$h_jl_Number.prototype = $c_jl_Number.prototype;
function $is_jl_Number(obj) {
  return ((obj instanceof $c_jl_Number) || ((typeof obj) === "number"))
}
function $as_jl_Number(obj) {
  return (($is_jl_Number(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "java.lang.Number"))
}
function $isArrayOf_jl_Number(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_Number)))
}
function $asArrayOf_jl_Number(obj, depth) {
  return (($isArrayOf_jl_Number(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.Number;", depth))
}
/** @constructor */
function $c_jl_StackTraceElement() {
  $c_O.call(this);
  this.declaringClass$1 = null;
  this.methodName$1 = null;
  this.fileName$1 = null;
  this.lineNumber$1 = 0;
  this.columnNumber$1 = 0
}
$c_jl_StackTraceElement.prototype = new $h_O();
$c_jl_StackTraceElement.prototype.constructor = $c_jl_StackTraceElement;
/** @constructor */
function $h_jl_StackTraceElement() {
  /*<skip>*/
}
$h_jl_StackTraceElement.prototype = $c_jl_StackTraceElement.prototype;
$c_jl_StackTraceElement.prototype.$$js$exported$meth$getColumnNumber__O = (function() {
  return this.columnNumber$1
});
$c_jl_StackTraceElement.prototype.init___T__T__T__I = (function(declaringClass, methodName, fileName, lineNumber) {
  this.declaringClass$1 = declaringClass;
  this.methodName$1 = methodName;
  this.fileName$1 = fileName;
  this.lineNumber$1 = lineNumber;
  this.columnNumber$1 = (-1);
  return this
});
$c_jl_StackTraceElement.prototype.equals__O__Z = (function(that) {
  if ((that instanceof $c_jl_StackTraceElement)) {
    var x2 = $as_jl_StackTraceElement(that);
    return ((((this.fileName$1 === x2.fileName$1) && (this.lineNumber$1 === x2.lineNumber$1)) && (this.declaringClass$1 === x2.declaringClass$1)) && (this.methodName$1 === x2.methodName$1))
  } else {
    return false
  }
});
$c_jl_StackTraceElement.prototype.$$js$exported$meth$setColumnNumber__I__O = (function(columnNumber) {
  this.columnNumber$1 = columnNumber
});
$c_jl_StackTraceElement.prototype.toString__T = (function() {
  var result = "";
  if ((this.declaringClass$1 !== "<jscode>")) {
    result = ((("" + result) + this.declaringClass$1) + ".")
  };
  result = (("" + result) + this.methodName$1);
  if ((this.fileName$1 === null)) {
    result = (result + "(Unknown Source)")
  } else {
    result = ((result + "(") + this.fileName$1);
    if ((this.lineNumber$1 >= 0)) {
      result = ((result + ":") + this.lineNumber$1);
      if ((this.columnNumber$1 >= 0)) {
        result = ((result + ":") + this.columnNumber$1)
      }
    };
    result = (result + ")")
  };
  return result
});
$c_jl_StackTraceElement.prototype.hashCode__I = (function() {
  var this$1 = this.declaringClass$1;
  var jsx$1 = $m_sjsr_RuntimeString$().hashCode__T__I(this$1);
  var this$2 = this.methodName$1;
  return (jsx$1 ^ $m_sjsr_RuntimeString$().hashCode__T__I(this$2))
});
$c_jl_StackTraceElement.prototype.setColumnNumber = (function(arg) {
  var prep = $uI(arg);
  return this.$$js$exported$meth$setColumnNumber__I__O(prep)
});
$c_jl_StackTraceElement.prototype.getColumnNumber = (function() {
  return this.$$js$exported$meth$getColumnNumber__O()
});
function $as_jl_StackTraceElement(obj) {
  return (((obj instanceof $c_jl_StackTraceElement) || (obj === null)) ? obj : $throwClassCastException(obj, "java.lang.StackTraceElement"))
}
function $isArrayOf_jl_StackTraceElement(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_StackTraceElement)))
}
function $asArrayOf_jl_StackTraceElement(obj, depth) {
  return (($isArrayOf_jl_StackTraceElement(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.StackTraceElement;", depth))
}
var $d_jl_StackTraceElement = new $TypeData().initClass({
  jl_StackTraceElement: 0
}, false, "java.lang.StackTraceElement", {
  jl_StackTraceElement: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_jl_StackTraceElement.prototype.$classData = $d_jl_StackTraceElement;
/** @constructor */
function $c_jl_Thread() {
  $c_O.call(this);
  this.java$lang$Thread$$interruptedState$1 = false;
  this.name$1 = null
}
$c_jl_Thread.prototype = new $h_O();
$c_jl_Thread.prototype.constructor = $c_jl_Thread;
/** @constructor */
function $h_jl_Thread() {
  /*<skip>*/
}
$h_jl_Thread.prototype = $c_jl_Thread.prototype;
$c_jl_Thread.prototype.run__V = (function() {
  /*<skip>*/
});
$c_jl_Thread.prototype.init___sr_BoxedUnit = (function(dummy) {
  this.java$lang$Thread$$interruptedState$1 = false;
  this.name$1 = "main";
  return this
});
var $d_jl_Thread = new $TypeData().initClass({
  jl_Thread: 0
}, false, "java.lang.Thread", {
  jl_Thread: 1,
  O: 1,
  jl_Runnable: 1
});
$c_jl_Thread.prototype.$classData = $d_jl_Thread;
/** @constructor */
function $c_jl_Throwable() {
  $c_O.call(this);
  this.s$1 = null;
  this.e$1 = null;
  this.enableSuppression$1 = false;
  this.writableStackTrace$1 = false;
  this.stackTrace$1 = null;
  this.suppressed$1 = null
}
$c_jl_Throwable.prototype = new $h_O();
$c_jl_Throwable.prototype.constructor = $c_jl_Throwable;
/** @constructor */
function $h_jl_Throwable() {
  /*<skip>*/
}
$h_jl_Throwable.prototype = $c_jl_Throwable.prototype;
$c_jl_Throwable.prototype.fillInStackTrace__jl_Throwable = (function() {
  var v = $g.Error.captureStackTrace;
  if ((v === (void 0))) {
    try {
      var e$1 = {}.undef()
    } catch (e) {
      var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
      if ((e$2 !== null)) {
        if ((e$2 instanceof $c_sjs_js_JavaScriptException)) {
          var x5 = $as_sjs_js_JavaScriptException(e$2);
          var e$3 = x5.exception$4;
          var e$1 = e$3
        } else {
          var e$1;
          throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(e$2)
        }
      } else {
        var e$1;
        throw e
      }
    };
    this.stackdata = e$1
  } else {
    $g.Error.captureStackTrace(this);
    this.stackdata = this
  };
  return this
});
$c_jl_Throwable.prototype.getMessage__T = (function() {
  return this.s$1
});
$c_jl_Throwable.prototype.toString__T = (function() {
  var className = $objectGetClass(this).getName__T();
  var message = this.getMessage__T();
  return ((message === null) ? className : ((className + ": ") + message))
});
$c_jl_Throwable.prototype.getStackTrace__Ajl_StackTraceElement = (function() {
  if ((this.stackTrace$1 === null)) {
    if (this.writableStackTrace$1) {
      this.stackTrace$1 = $m_sjsr_StackTrace$().extract__jl_Throwable__Ajl_StackTraceElement(this)
    } else {
      this.stackTrace$1 = $newArrayObject($d_jl_StackTraceElement.getArrayOf(), [0])
    }
  };
  return this.stackTrace$1
});
$c_jl_Throwable.prototype.init___T = (function(s) {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
$c_jl_Throwable.prototype.printStackTrace__Ljava_io_PrintStream__V = (function(s) {
  var f = (function($this, s$1) {
    return (function(x$1$2) {
      var x$1 = $as_T(x$1$2);
      s$1.println__T__V(x$1)
    })
  })(this, s);
  this.getStackTrace__Ajl_StackTraceElement();
  var arg1 = this.toString__T();
  f(arg1);
  if ((this.stackTrace$1.u.length !== 0)) {
    var i = 0;
    while ((i < this.stackTrace$1.u.length)) {
      var arg1$1 = ("  at " + this.stackTrace$1.get(i));
      f(arg1$1);
      i = ((1 + i) | 0)
    }
  } else {
    f("  <no stack trace available>")
  };
  var wCause = this;
  while (true) {
    var jsx$2 = wCause;
    var this$1 = wCause;
    if ((jsx$2 !== this$1.e$1)) {
      var this$2 = wCause;
      var jsx$1 = (this$2.e$1 !== null)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var parentTrace = wCause.getStackTrace__Ajl_StackTraceElement();
      var this$3 = wCause;
      wCause = this$3.e$1;
      var thisTrace = wCause.getStackTrace__Ajl_StackTraceElement();
      var thisLength = thisTrace.u.length;
      var parentLength = parentTrace.u.length;
      var arg1$2 = ("Caused by: " + wCause.toString__T());
      f(arg1$2);
      if ((thisLength !== 0)) {
        var sameFrameCount = 0;
        while (true) {
          if (((sameFrameCount < thisLength) && (sameFrameCount < parentLength))) {
            var x = thisTrace.get((((-1) + ((thisLength - sameFrameCount) | 0)) | 0));
            var x$2 = parentTrace.get((((-1) + ((parentLength - sameFrameCount) | 0)) | 0));
            var jsx$3 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
          } else {
            var jsx$3 = false
          };
          if (jsx$3) {
            sameFrameCount = ((1 + sameFrameCount) | 0)
          } else {
            break
          }
        };
        if ((sameFrameCount > 0)) {
          sameFrameCount = (((-1) + sameFrameCount) | 0)
        };
        var lengthToPrint = ((thisLength - sameFrameCount) | 0);
        var i$2 = 0;
        while ((i$2 < lengthToPrint)) {
          var arg1$3 = ("  at " + thisTrace.get(i$2));
          f(arg1$3);
          i$2 = ((1 + i$2) | 0)
        };
        if ((sameFrameCount > 0)) {
          var arg1$4 = (("  ... " + sameFrameCount) + " more");
          f(arg1$4)
        }
      } else {
        f("  <no stack trace available>")
      }
    } else {
      break
    }
  }
});
$c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z = (function(s, e, enableSuppression, writableStackTrace) {
  this.s$1 = s;
  this.e$1 = e;
  this.enableSuppression$1 = enableSuppression;
  this.writableStackTrace$1 = writableStackTrace;
  if (writableStackTrace) {
    this.fillInStackTrace__jl_Throwable()
  };
  return this
});
function $as_jl_Throwable(obj) {
  return (((obj instanceof $c_jl_Throwable) || (obj === null)) ? obj : $throwClassCastException(obj, "java.lang.Throwable"))
}
function $isArrayOf_jl_Throwable(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_Throwable)))
}
function $asArrayOf_jl_Throwable(obj, depth) {
  return (($isArrayOf_jl_Throwable(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.Throwable;", depth))
}
var $d_jl_Throwable = new $TypeData().initClass({
  jl_Throwable: 0
}, false, "java.lang.Throwable", {
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_jl_Throwable.prototype.$classData = $d_jl_Throwable;
/** @constructor */
function $c_ju_regex_GroupStartMapper$AlternativesNode() {
  $c_ju_regex_GroupStartMapper$Node.call(this);
  this.alternatives$2 = null
}
$c_ju_regex_GroupStartMapper$AlternativesNode.prototype = new $h_ju_regex_GroupStartMapper$Node();
$c_ju_regex_GroupStartMapper$AlternativesNode.prototype.constructor = $c_ju_regex_GroupStartMapper$AlternativesNode;
/** @constructor */
function $h_ju_regex_GroupStartMapper$AlternativesNode() {
  /*<skip>*/
}
$h_ju_regex_GroupStartMapper$AlternativesNode.prototype = $c_ju_regex_GroupStartMapper$AlternativesNode.prototype;
$c_ju_regex_GroupStartMapper$AlternativesNode.prototype.propagate__sjs_js_RegExp$ExecResult__sjs_js_Array__I__I__V = (function(matchResult, groupStartMap, start, end) {
  var len = $uI(this.alternatives$2.length);
  var i = 0;
  while ((i !== len)) {
    $as_ju_regex_GroupStartMapper$Node(this.alternatives$2[i]).propagateFromStart__sjs_js_RegExp$ExecResult__sjs_js_Array__I__I(matchResult, groupStartMap, start);
    i = ((1 + i) | 0)
  }
});
$c_ju_regex_GroupStartMapper$AlternativesNode.prototype.setNewGroup__I__I = (function(newGroupIndex) {
  var nextIndex = $c_ju_regex_GroupStartMapper$Node.prototype.setNewGroup__I__I.call(this, newGroupIndex);
  var len = $uI(this.alternatives$2.length);
  var i = 0;
  while ((i !== len)) {
    nextIndex = $as_ju_regex_GroupStartMapper$Node(this.alternatives$2[i]).setNewGroup__I__I(nextIndex);
    i = ((1 + i) | 0)
  };
  return nextIndex
});
$c_ju_regex_GroupStartMapper$AlternativesNode.prototype.init___sjs_js_Array = (function(alternatives) {
  this.alternatives$2 = alternatives;
  return this
});
$c_ju_regex_GroupStartMapper$AlternativesNode.prototype.buildRegex__sjs_js_Array__T = (function(groupNodeMap) {
  var result = "(";
  var len = $uI(this.alternatives$2.length);
  var i = 0;
  while ((i !== len)) {
    if ((i !== 0)) {
      result = (result + "|")
    };
    result = (("" + result) + $as_ju_regex_GroupStartMapper$Node(this.alternatives$2[i]).buildRegex__sjs_js_Array__T(groupNodeMap));
    i = ((1 + i) | 0)
  };
  return (result + ")")
});
var $d_ju_regex_GroupStartMapper$AlternativesNode = new $TypeData().initClass({
  ju_regex_GroupStartMapper$AlternativesNode: 0
}, false, "java.util.regex.GroupStartMapper$AlternativesNode", {
  ju_regex_GroupStartMapper$AlternativesNode: 1,
  ju_regex_GroupStartMapper$Node: 1,
  O: 1
});
$c_ju_regex_GroupStartMapper$AlternativesNode.prototype.$classData = $d_ju_regex_GroupStartMapper$AlternativesNode;
/** @constructor */
function $c_ju_regex_GroupStartMapper$BackReferenceNode() {
  $c_ju_regex_GroupStartMapper$Node.call(this);
  this.groupNumber$2 = 0
}
$c_ju_regex_GroupStartMapper$BackReferenceNode.prototype = new $h_ju_regex_GroupStartMapper$Node();
$c_ju_regex_GroupStartMapper$BackReferenceNode.prototype.constructor = $c_ju_regex_GroupStartMapper$BackReferenceNode;
/** @constructor */
function $h_ju_regex_GroupStartMapper$BackReferenceNode() {
  /*<skip>*/
}
$h_ju_regex_GroupStartMapper$BackReferenceNode.prototype = $c_ju_regex_GroupStartMapper$BackReferenceNode.prototype;
$c_ju_regex_GroupStartMapper$BackReferenceNode.prototype.init___I = (function(groupNumber) {
  this.groupNumber$2 = groupNumber;
  return this
});
$c_ju_regex_GroupStartMapper$BackReferenceNode.prototype.propagate__sjs_js_RegExp$ExecResult__sjs_js_Array__I__I__V = (function(matchResult, groupStartMap, start, end) {
  /*<skip>*/
});
$c_ju_regex_GroupStartMapper$BackReferenceNode.prototype.buildRegex__sjs_js_Array__T = (function(groupNodeMap) {
  var newGroupNumber = ((this.groupNumber$2 >= $uI(groupNodeMap.length)) ? 0 : $as_ju_regex_GroupStartMapper$Node(groupNodeMap[this.groupNumber$2]).newGroup$1);
  return (("(\\" + newGroupNumber) + ")")
});
var $d_ju_regex_GroupStartMapper$BackReferenceNode = new $TypeData().initClass({
  ju_regex_GroupStartMapper$BackReferenceNode: 0
}, false, "java.util.regex.GroupStartMapper$BackReferenceNode", {
  ju_regex_GroupStartMapper$BackReferenceNode: 1,
  ju_regex_GroupStartMapper$Node: 1,
  O: 1
});
$c_ju_regex_GroupStartMapper$BackReferenceNode.prototype.$classData = $d_ju_regex_GroupStartMapper$BackReferenceNode;
/** @constructor */
function $c_ju_regex_GroupStartMapper$GroupNode() {
  $c_ju_regex_GroupStartMapper$Node.call(this);
  this.number$2 = 0;
  this.inner$2 = null
}
$c_ju_regex_GroupStartMapper$GroupNode.prototype = new $h_ju_regex_GroupStartMapper$Node();
$c_ju_regex_GroupStartMapper$GroupNode.prototype.constructor = $c_ju_regex_GroupStartMapper$GroupNode;
/** @constructor */
function $h_ju_regex_GroupStartMapper$GroupNode() {
  /*<skip>*/
}
$h_ju_regex_GroupStartMapper$GroupNode.prototype = $c_ju_regex_GroupStartMapper$GroupNode.prototype;
$c_ju_regex_GroupStartMapper$GroupNode.prototype.init___I__ju_regex_GroupStartMapper$Node = (function(number, inner) {
  this.number$2 = number;
  this.inner$2 = inner;
  return this
});
$c_ju_regex_GroupStartMapper$GroupNode.prototype.propagate__sjs_js_RegExp$ExecResult__sjs_js_Array__I__I__V = (function(matchResult, groupStartMap, start, end) {
  var value = matchResult[this.newGroup$1];
  if ((value !== (void 0))) {
    groupStartMap[this.number$2] = start
  };
  this.inner$2.propagateFromStart__sjs_js_RegExp$ExecResult__sjs_js_Array__I__I(matchResult, groupStartMap, start)
});
$c_ju_regex_GroupStartMapper$GroupNode.prototype.setNewGroup__I__I = (function(newGroupIndex) {
  return this.inner$2.setNewGroup__I__I($c_ju_regex_GroupStartMapper$Node.prototype.setNewGroup__I__I.call(this, newGroupIndex))
});
$c_ju_regex_GroupStartMapper$GroupNode.prototype.buildRegex__sjs_js_Array__T = (function(groupNodeMap) {
  return (("(" + this.inner$2.buildRegex__sjs_js_Array__T(groupNodeMap)) + ")")
});
var $d_ju_regex_GroupStartMapper$GroupNode = new $TypeData().initClass({
  ju_regex_GroupStartMapper$GroupNode: 0
}, false, "java.util.regex.GroupStartMapper$GroupNode", {
  ju_regex_GroupStartMapper$GroupNode: 1,
  ju_regex_GroupStartMapper$Node: 1,
  O: 1
});
$c_ju_regex_GroupStartMapper$GroupNode.prototype.$classData = $d_ju_regex_GroupStartMapper$GroupNode;
/** @constructor */
function $c_ju_regex_GroupStartMapper$LeafRegexNode() {
  $c_ju_regex_GroupStartMapper$Node.call(this);
  this.regex$2 = null
}
$c_ju_regex_GroupStartMapper$LeafRegexNode.prototype = new $h_ju_regex_GroupStartMapper$Node();
$c_ju_regex_GroupStartMapper$LeafRegexNode.prototype.constructor = $c_ju_regex_GroupStartMapper$LeafRegexNode;
/** @constructor */
function $h_ju_regex_GroupStartMapper$LeafRegexNode() {
  /*<skip>*/
}
$h_ju_regex_GroupStartMapper$LeafRegexNode.prototype = $c_ju_regex_GroupStartMapper$LeafRegexNode.prototype;
$c_ju_regex_GroupStartMapper$LeafRegexNode.prototype.propagate__sjs_js_RegExp$ExecResult__sjs_js_Array__I__I__V = (function(matchResult, groupStartMap, start, end) {
  /*<skip>*/
});
$c_ju_regex_GroupStartMapper$LeafRegexNode.prototype.init___T = (function(regex) {
  this.regex$2 = regex;
  return this
});
$c_ju_regex_GroupStartMapper$LeafRegexNode.prototype.buildRegex__sjs_js_Array__T = (function(groupNodeMap) {
  return (("(" + this.regex$2) + ")")
});
function $as_ju_regex_GroupStartMapper$LeafRegexNode(obj) {
  return (((obj instanceof $c_ju_regex_GroupStartMapper$LeafRegexNode) || (obj === null)) ? obj : $throwClassCastException(obj, "java.util.regex.GroupStartMapper$LeafRegexNode"))
}
function $isArrayOf_ju_regex_GroupStartMapper$LeafRegexNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.ju_regex_GroupStartMapper$LeafRegexNode)))
}
function $asArrayOf_ju_regex_GroupStartMapper$LeafRegexNode(obj, depth) {
  return (($isArrayOf_ju_regex_GroupStartMapper$LeafRegexNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.util.regex.GroupStartMapper$LeafRegexNode;", depth))
}
var $d_ju_regex_GroupStartMapper$LeafRegexNode = new $TypeData().initClass({
  ju_regex_GroupStartMapper$LeafRegexNode: 0
}, false, "java.util.regex.GroupStartMapper$LeafRegexNode", {
  ju_regex_GroupStartMapper$LeafRegexNode: 1,
  ju_regex_GroupStartMapper$Node: 1,
  O: 1
});
$c_ju_regex_GroupStartMapper$LeafRegexNode.prototype.$classData = $d_ju_regex_GroupStartMapper$LeafRegexNode;
/** @constructor */
function $c_ju_regex_GroupStartMapper$RepeatedNode() {
  $c_ju_regex_GroupStartMapper$Node.call(this);
  this.inner$2 = null;
  this.repeater$2 = null
}
$c_ju_regex_GroupStartMapper$RepeatedNode.prototype = new $h_ju_regex_GroupStartMapper$Node();
$c_ju_regex_GroupStartMapper$RepeatedNode.prototype.constructor = $c_ju_regex_GroupStartMapper$RepeatedNode;
/** @constructor */
function $h_ju_regex_GroupStartMapper$RepeatedNode() {
  /*<skip>*/
}
$h_ju_regex_GroupStartMapper$RepeatedNode.prototype = $c_ju_regex_GroupStartMapper$RepeatedNode.prototype;
$c_ju_regex_GroupStartMapper$RepeatedNode.prototype.init___ju_regex_GroupStartMapper$Node__T = (function(inner, repeater) {
  this.inner$2 = inner;
  this.repeater$2 = repeater;
  return this
});
$c_ju_regex_GroupStartMapper$RepeatedNode.prototype.propagate__sjs_js_RegExp$ExecResult__sjs_js_Array__I__I__V = (function(matchResult, groupStartMap, start, end) {
  this.inner$2.propagateFromEnd__sjs_js_RegExp$ExecResult__sjs_js_Array__I__I(matchResult, groupStartMap, end)
});
$c_ju_regex_GroupStartMapper$RepeatedNode.prototype.setNewGroup__I__I = (function(newGroupIndex) {
  return this.inner$2.setNewGroup__I__I($c_ju_regex_GroupStartMapper$Node.prototype.setNewGroup__I__I.call(this, newGroupIndex))
});
$c_ju_regex_GroupStartMapper$RepeatedNode.prototype.buildRegex__sjs_js_Array__T = (function(groupNodeMap) {
  return ((("(" + this.inner$2.buildRegex__sjs_js_Array__T(groupNodeMap)) + this.repeater$2) + ")")
});
var $d_ju_regex_GroupStartMapper$RepeatedNode = new $TypeData().initClass({
  ju_regex_GroupStartMapper$RepeatedNode: 0
}, false, "java.util.regex.GroupStartMapper$RepeatedNode", {
  ju_regex_GroupStartMapper$RepeatedNode: 1,
  ju_regex_GroupStartMapper$Node: 1,
  O: 1
});
$c_ju_regex_GroupStartMapper$RepeatedNode.prototype.$classData = $d_ju_regex_GroupStartMapper$RepeatedNode;
/** @constructor */
function $c_ju_regex_GroupStartMapper$SequenceNode() {
  $c_ju_regex_GroupStartMapper$Node.call(this);
  this.sequence$2 = null
}
$c_ju_regex_GroupStartMapper$SequenceNode.prototype = new $h_ju_regex_GroupStartMapper$Node();
$c_ju_regex_GroupStartMapper$SequenceNode.prototype.constructor = $c_ju_regex_GroupStartMapper$SequenceNode;
/** @constructor */
function $h_ju_regex_GroupStartMapper$SequenceNode() {
  /*<skip>*/
}
$h_ju_regex_GroupStartMapper$SequenceNode.prototype = $c_ju_regex_GroupStartMapper$SequenceNode.prototype;
$c_ju_regex_GroupStartMapper$SequenceNode.prototype.propagate__sjs_js_RegExp$ExecResult__sjs_js_Array__I__I__V = (function(matchResult, groupStartMap, start, end) {
  var len = $uI(this.sequence$2.length);
  var i = 0;
  var nextStart = start;
  while ((i !== len)) {
    nextStart = $as_ju_regex_GroupStartMapper$Node(this.sequence$2[i]).propagateFromStart__sjs_js_RegExp$ExecResult__sjs_js_Array__I__I(matchResult, groupStartMap, nextStart);
    i = ((1 + i) | 0)
  }
});
$c_ju_regex_GroupStartMapper$SequenceNode.prototype.setNewGroup__I__I = (function(newGroupIndex) {
  var nextIndex = $c_ju_regex_GroupStartMapper$Node.prototype.setNewGroup__I__I.call(this, newGroupIndex);
  var len = $uI(this.sequence$2.length);
  var i = 0;
  while ((i !== len)) {
    nextIndex = $as_ju_regex_GroupStartMapper$Node(this.sequence$2[i]).setNewGroup__I__I(nextIndex);
    i = ((1 + i) | 0)
  };
  return nextIndex
});
$c_ju_regex_GroupStartMapper$SequenceNode.prototype.init___sjs_js_Array = (function(sequence) {
  this.sequence$2 = sequence;
  return this
});
$c_ju_regex_GroupStartMapper$SequenceNode.prototype.buildRegex__sjs_js_Array__T = (function(groupNodeMap) {
  var result = "(";
  var len = $uI(this.sequence$2.length);
  var i = 0;
  while ((i !== len)) {
    result = (("" + result) + $as_ju_regex_GroupStartMapper$Node(this.sequence$2[i]).buildRegex__sjs_js_Array__T(groupNodeMap));
    i = ((1 + i) | 0)
  };
  return (result + ")")
});
var $d_ju_regex_GroupStartMapper$SequenceNode = new $TypeData().initClass({
  ju_regex_GroupStartMapper$SequenceNode: 0
}, false, "java.util.regex.GroupStartMapper$SequenceNode", {
  ju_regex_GroupStartMapper$SequenceNode: 1,
  ju_regex_GroupStartMapper$Node: 1,
  O: 1
});
$c_ju_regex_GroupStartMapper$SequenceNode.prototype.$classData = $d_ju_regex_GroupStartMapper$SequenceNode;
/** @constructor */
function $c_ju_regex_GroupStartMapper$ZeroLengthTestNode() {
  $c_ju_regex_GroupStartMapper$Node.call(this);
  this.indicator$2 = null;
  this.inner$2 = null
}
$c_ju_regex_GroupStartMapper$ZeroLengthTestNode.prototype = new $h_ju_regex_GroupStartMapper$Node();
$c_ju_regex_GroupStartMapper$ZeroLengthTestNode.prototype.constructor = $c_ju_regex_GroupStartMapper$ZeroLengthTestNode;
/** @constructor */
function $h_ju_regex_GroupStartMapper$ZeroLengthTestNode() {
  /*<skip>*/
}
$h_ju_regex_GroupStartMapper$ZeroLengthTestNode.prototype = $c_ju_regex_GroupStartMapper$ZeroLengthTestNode.prototype;
$c_ju_regex_GroupStartMapper$ZeroLengthTestNode.prototype.propagate__sjs_js_RegExp$ExecResult__sjs_js_Array__I__I__V = (function(matchResult, groupStartMap, start, end) {
  this.inner$2.propagateFromStart__sjs_js_RegExp$ExecResult__sjs_js_Array__I__I(matchResult, groupStartMap, start)
});
$c_ju_regex_GroupStartMapper$ZeroLengthTestNode.prototype.setNewGroup__I__I = (function(newGroupIndex) {
  return this.inner$2.setNewGroup__I__I($c_ju_regex_GroupStartMapper$Node.prototype.setNewGroup__I__I.call(this, newGroupIndex))
});
$c_ju_regex_GroupStartMapper$ZeroLengthTestNode.prototype.buildRegex__sjs_js_Array__T = (function(groupNodeMap) {
  return ((("((" + this.indicator$2) + this.inner$2.buildRegex__sjs_js_Array__T(groupNodeMap)) + "))")
});
$c_ju_regex_GroupStartMapper$ZeroLengthTestNode.prototype.init___T__ju_regex_GroupStartMapper$Node = (function(indicator, inner) {
  this.indicator$2 = indicator;
  this.inner$2 = inner;
  return this
});
var $d_ju_regex_GroupStartMapper$ZeroLengthTestNode = new $TypeData().initClass({
  ju_regex_GroupStartMapper$ZeroLengthTestNode: 0
}, false, "java.util.regex.GroupStartMapper$ZeroLengthTestNode", {
  ju_regex_GroupStartMapper$ZeroLengthTestNode: 1,
  ju_regex_GroupStartMapper$Node: 1,
  O: 1
});
$c_ju_regex_GroupStartMapper$ZeroLengthTestNode.prototype.$classData = $d_ju_regex_GroupStartMapper$ZeroLengthTestNode;
/** @constructor */
function $c_ju_regex_Matcher() {
  $c_O.call(this);
  this.pattern0$1 = null;
  this.input0$1 = null;
  this.regionStart0$1 = 0;
  this.regionEnd0$1 = 0;
  this.regexp$1 = null;
  this.inputstr$1 = null;
  this.lastMatch$1 = null;
  this.lastMatchIsValid$1 = false;
  this.canStillFind$1 = false;
  this.appendPos$1 = 0;
  this.startOfGroupCache$1 = null
}
$c_ju_regex_Matcher.prototype = new $h_O();
$c_ju_regex_Matcher.prototype.constructor = $c_ju_regex_Matcher;
/** @constructor */
function $h_ju_regex_Matcher() {
  /*<skip>*/
}
$h_ju_regex_Matcher.prototype = $c_ju_regex_Matcher.prototype;
$c_ju_regex_Matcher.prototype.find__Z = (function() {
  if (this.canStillFind$1) {
    this.lastMatchIsValid$1 = true;
    this.lastMatch$1 = this.regexp$1.exec(this.inputstr$1);
    if ((this.lastMatch$1 !== null)) {
      var value = this.lastMatch$1[0];
      if ((value === (void 0))) {
        throw new $c_ju_NoSuchElementException().init___T("undefined.get")
      };
      var thiz = $as_T(value);
      if ((thiz === null)) {
        throw new $c_jl_NullPointerException().init___()
      };
      if ((thiz === "")) {
        var ev$1 = this.regexp$1;
        ev$1.lastIndex = ((1 + $uI(ev$1.lastIndex)) | 0)
      }
    } else {
      this.canStillFind$1 = false
    };
    this.startOfGroupCache$1 = null;
    return (this.lastMatch$1 !== null)
  } else {
    return false
  }
});
$c_ju_regex_Matcher.prototype.ensureLastMatch__p1__sjs_js_RegExp$ExecResult = (function() {
  if ((this.lastMatch$1 === null)) {
    throw new $c_jl_IllegalStateException().init___T("No match available")
  };
  return this.lastMatch$1
});
$c_ju_regex_Matcher.prototype.group__I__T = (function(group) {
  var value = this.ensureLastMatch__p1__sjs_js_RegExp$ExecResult()[group];
  return $as_T(((value === (void 0)) ? null : value))
});
$c_ju_regex_Matcher.prototype.start__I__I = (function(group) {
  return ((group === 0) ? this.start__I() : $uI(this.startOfGroup__p1__sjs_js_Array()[group]))
});
$c_ju_regex_Matcher.prototype.matches__Z = (function() {
  this.reset__ju_regex_Matcher();
  this.find__Z();
  if ((this.lastMatch$1 !== null)) {
    if ((this.start__I() !== 0)) {
      var jsx$1 = true
    } else {
      var jsx$2 = this.end__I();
      var thiz = this.inputstr$1;
      var jsx$1 = (jsx$2 !== $uI(thiz.length))
    }
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    this.reset__ju_regex_Matcher()
  };
  return (this.lastMatch$1 !== null)
});
$c_ju_regex_Matcher.prototype.startOfGroup__p1__sjs_js_Array = (function() {
  if ((this.startOfGroupCache$1 === null)) {
    this.startOfGroupCache$1 = this.pattern0$1.groupStartMapper__ju_regex_GroupStartMapper().apply__T__I__sjs_js_Array(this.inputstr$1, this.start__I())
  };
  return this.startOfGroupCache$1
});
$c_ju_regex_Matcher.prototype.appendTail__jl_StringBuffer__jl_StringBuffer = (function(sb) {
  var thiz = this.inputstr$1;
  var beginIndex = this.appendPos$1;
  sb.append__T__jl_StringBuffer($as_T(thiz.substring(beginIndex)));
  var thiz$1 = this.inputstr$1;
  this.appendPos$1 = $uI(thiz$1.length);
  return sb
});
$c_ju_regex_Matcher.prototype.end__I = (function() {
  var jsx$1 = this.start__I();
  var thiz = this.group__T();
  return ((jsx$1 + $uI(thiz.length)) | 0)
});
$c_ju_regex_Matcher.prototype.init___ju_regex_Pattern__jl_CharSequence__I__I = (function(pattern0, input0, regionStart0, regionEnd0) {
  this.pattern0$1 = pattern0;
  this.input0$1 = input0;
  this.regionStart0$1 = regionStart0;
  this.regionEnd0$1 = regionEnd0;
  this.regexp$1 = this.pattern0$1.newJSRegExp__sjs_js_RegExp();
  this.inputstr$1 = $objectToString($charSequenceSubSequence(this.input0$1, this.regionStart0$1, this.regionEnd0$1));
  this.lastMatch$1 = null;
  this.lastMatchIsValid$1 = false;
  this.canStillFind$1 = true;
  this.appendPos$1 = 0;
  return this
});
$c_ju_regex_Matcher.prototype.appendReplacement__jl_StringBuffer__T__ju_regex_Matcher = (function(sb, replacement) {
  var thiz = this.inputstr$1;
  var beginIndex = this.appendPos$1;
  var endIndex = this.start__I();
  sb.append__T__jl_StringBuffer($as_T(thiz.substring(beginIndex, endIndex)));
  var len = $uI(replacement.length);
  var i = 0;
  while ((i < len)) {
    var index = i;
    var x1 = (65535 & $uI(replacement.charCodeAt(index)));
    switch (x1) {
      case 36: {
        i = ((1 + i) | 0);
        var j = i;
        while (true) {
          if ((i < len)) {
            var index$1 = i;
            var c = (65535 & $uI(replacement.charCodeAt(index$1)));
            var jsx$1 = ((c >= 48) && (c <= 57))
          } else {
            var jsx$1 = false
          };
          if (jsx$1) {
            i = ((1 + i) | 0)
          } else {
            break
          }
        };
        var this$8 = $m_jl_Integer$();
        var endIndex$1 = i;
        var s = $as_T(replacement.substring(j, endIndex$1));
        var group = this$8.parseInt__T__I__I(s, 10);
        sb.append__T__jl_StringBuffer(this.group__I__T(group));
        break
      }
      case 92: {
        i = ((1 + i) | 0);
        if ((i < len)) {
          var index$2 = i;
          sb.append__C__jl_StringBuffer((65535 & $uI(replacement.charCodeAt(index$2))))
        };
        i = ((1 + i) | 0);
        break
      }
      default: {
        sb.append__C__jl_StringBuffer(x1);
        i = ((1 + i) | 0)
      }
    }
  };
  this.appendPos$1 = this.end__I();
  return this
});
$c_ju_regex_Matcher.prototype.replaceFirst__T__T = (function(replacement) {
  this.reset__ju_regex_Matcher();
  if (this.find__Z()) {
    var sb = new $c_jl_StringBuffer().init___();
    this.appendReplacement__jl_StringBuffer__T__ju_regex_Matcher(sb, replacement);
    this.appendTail__jl_StringBuffer__jl_StringBuffer(sb);
    return sb.toString__T()
  } else {
    return this.inputstr$1
  }
});
$c_ju_regex_Matcher.prototype.replaceAll__T__T = (function(replacement) {
  this.reset__ju_regex_Matcher();
  var sb = new $c_jl_StringBuffer().init___();
  while (this.find__Z()) {
    this.appendReplacement__jl_StringBuffer__T__ju_regex_Matcher(sb, replacement)
  };
  this.appendTail__jl_StringBuffer__jl_StringBuffer(sb);
  return sb.toString__T()
});
$c_ju_regex_Matcher.prototype.group__T = (function() {
  var value = this.ensureLastMatch__p1__sjs_js_RegExp$ExecResult()[0];
  if ((value === (void 0))) {
    throw new $c_ju_NoSuchElementException().init___T("undefined.get")
  };
  return $as_T(value)
});
$c_ju_regex_Matcher.prototype.start__I = (function() {
  return $uI(this.ensureLastMatch__p1__sjs_js_RegExp$ExecResult().index)
});
$c_ju_regex_Matcher.prototype.end__I__I = (function(group) {
  var s = this.start__I__I(group);
  if ((s === (-1))) {
    return (-1)
  } else {
    var thiz = this.group__I__T(group);
    return ((s + $uI(thiz.length)) | 0)
  }
});
$c_ju_regex_Matcher.prototype.reset__ju_regex_Matcher = (function() {
  this.regexp$1.lastIndex = 0;
  this.lastMatch$1 = null;
  this.lastMatchIsValid$1 = false;
  this.canStillFind$1 = true;
  this.appendPos$1 = 0;
  this.startOfGroupCache$1 = null;
  return this
});
var $d_ju_regex_Matcher = new $TypeData().initClass({
  ju_regex_Matcher: 0
}, false, "java.util.regex.Matcher", {
  ju_regex_Matcher: 1,
  O: 1,
  ju_regex_MatchResult: 1
});
$c_ju_regex_Matcher.prototype.$classData = $d_ju_regex_Matcher;
/** @constructor */
function $c_s_Array$ArrayCanBuildFrom$1() {
  $c_O.call(this);
  this.t$1$1 = null
}
$c_s_Array$ArrayCanBuildFrom$1.prototype = new $h_O();
$c_s_Array$ArrayCanBuildFrom$1.prototype.constructor = $c_s_Array$ArrayCanBuildFrom$1;
/** @constructor */
function $h_s_Array$ArrayCanBuildFrom$1() {
  /*<skip>*/
}
$h_s_Array$ArrayCanBuildFrom$1.prototype = $c_s_Array$ArrayCanBuildFrom$1.prototype;
$c_s_Array$ArrayCanBuildFrom$1.prototype.apply__scm_Builder = (function() {
  return this.apply__scm_ArrayBuilder()
});
$c_s_Array$ArrayCanBuildFrom$1.prototype.init___s_reflect_ClassTag = (function(t$1) {
  this.t$1$1 = t$1;
  return this
});
$c_s_Array$ArrayCanBuildFrom$1.prototype.apply__O__scm_Builder = (function(from) {
  return this.apply__O__scm_ArrayBuilder(from)
});
$c_s_Array$ArrayCanBuildFrom$1.prototype.apply__O__scm_ArrayBuilder = (function(from) {
  var evidence$1 = this.t$1$1;
  return new $c_scm_ArrayBuilder$generic().init___jl_Class(evidence$1.runtimeClass__jl_Class())
});
$c_s_Array$ArrayCanBuildFrom$1.prototype.apply__scm_ArrayBuilder = (function() {
  var evidence$1 = this.t$1$1;
  return new $c_scm_ArrayBuilder$generic().init___jl_Class(evidence$1.runtimeClass__jl_Class())
});
var $d_s_Array$ArrayCanBuildFrom$1 = new $TypeData().initClass({
  s_Array$ArrayCanBuildFrom$1: 0
}, false, "scala.Array$ArrayCanBuildFrom$1", {
  s_Array$ArrayCanBuildFrom$1: 1,
  O: 1,
  scg_CanBuildFrom: 1
});
$c_s_Array$ArrayCanBuildFrom$1.prototype.$classData = $d_s_Array$ArrayCanBuildFrom$1;
/** @constructor */
function $c_s_FallbackArrayBuilding$$anon$1() {
  $c_O.call(this)
}
$c_s_FallbackArrayBuilding$$anon$1.prototype = new $h_O();
$c_s_FallbackArrayBuilding$$anon$1.prototype.constructor = $c_s_FallbackArrayBuilding$$anon$1;
/** @constructor */
function $h_s_FallbackArrayBuilding$$anon$1() {
  /*<skip>*/
}
$h_s_FallbackArrayBuilding$$anon$1.prototype = $c_s_FallbackArrayBuilding$$anon$1.prototype;
$c_s_FallbackArrayBuilding$$anon$1.prototype.apply__scm_Builder = (function() {
  return $m_scm_ArraySeq$().newBuilder__scm_Builder()
});
$c_s_FallbackArrayBuilding$$anon$1.prototype.init___s_FallbackArrayBuilding = (function($$outer) {
  return this
});
$c_s_FallbackArrayBuilding$$anon$1.prototype.apply__O__scm_Builder = (function(from) {
  return $m_scm_ArraySeq$().newBuilder__scm_Builder()
});
var $d_s_FallbackArrayBuilding$$anon$1 = new $TypeData().initClass({
  s_FallbackArrayBuilding$$anon$1: 0
}, false, "scala.FallbackArrayBuilding$$anon$1", {
  s_FallbackArrayBuilding$$anon$1: 1,
  O: 1,
  scg_CanBuildFrom: 1
});
$c_s_FallbackArrayBuilding$$anon$1.prototype.$classData = $d_s_FallbackArrayBuilding$$anon$1;
/** @constructor */
function $c_s_LowPriorityImplicits$$anon$4() {
  $c_O.call(this)
}
$c_s_LowPriorityImplicits$$anon$4.prototype = new $h_O();
$c_s_LowPriorityImplicits$$anon$4.prototype.constructor = $c_s_LowPriorityImplicits$$anon$4;
/** @constructor */
function $h_s_LowPriorityImplicits$$anon$4() {
  /*<skip>*/
}
$h_s_LowPriorityImplicits$$anon$4.prototype = $c_s_LowPriorityImplicits$$anon$4.prototype;
$c_s_LowPriorityImplicits$$anon$4.prototype.apply__scm_Builder = (function() {
  $m_sci_IndexedSeq$();
  $m_sci_Vector$();
  return new $c_sci_VectorBuilder().init___()
});
$c_s_LowPriorityImplicits$$anon$4.prototype.apply__O__scm_Builder = (function(from) {
  $as_T(from);
  $m_sci_IndexedSeq$();
  $m_sci_Vector$();
  return new $c_sci_VectorBuilder().init___()
});
$c_s_LowPriorityImplicits$$anon$4.prototype.init___s_LowPriorityImplicits = (function($$outer) {
  return this
});
var $d_s_LowPriorityImplicits$$anon$4 = new $TypeData().initClass({
  s_LowPriorityImplicits$$anon$4: 0
}, false, "scala.LowPriorityImplicits$$anon$4", {
  s_LowPriorityImplicits$$anon$4: 1,
  O: 1,
  scg_CanBuildFrom: 1
});
$c_s_LowPriorityImplicits$$anon$4.prototype.$classData = $d_s_LowPriorityImplicits$$anon$4;
/** @constructor */
function $c_s_Predef$$anon$1() {
  $c_O.call(this)
}
$c_s_Predef$$anon$1.prototype = new $h_O();
$c_s_Predef$$anon$1.prototype.constructor = $c_s_Predef$$anon$1;
/** @constructor */
function $h_s_Predef$$anon$1() {
  /*<skip>*/
}
$h_s_Predef$$anon$1.prototype = $c_s_Predef$$anon$1.prototype;
$c_s_Predef$$anon$1.prototype.init___ = (function() {
  return this
});
$c_s_Predef$$anon$1.prototype.apply__scm_Builder = (function() {
  return new $c_scm_StringBuilder().init___()
});
$c_s_Predef$$anon$1.prototype.apply__O__scm_Builder = (function(from) {
  $as_T(from);
  return new $c_scm_StringBuilder().init___()
});
var $d_s_Predef$$anon$1 = new $TypeData().initClass({
  s_Predef$$anon$1: 0
}, false, "scala.Predef$$anon$1", {
  s_Predef$$anon$1: 1,
  O: 1,
  scg_CanBuildFrom: 1
});
$c_s_Predef$$anon$1.prototype.$classData = $d_s_Predef$$anon$1;
function $f_s_Product2__productElement__I__O($thiz, n) {
  switch (n) {
    case 0: {
      return $thiz.$$und1__O();
      break
    }
    case 1: {
      return $thiz.$$und2__O();
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + n))
    }
  }
}
function $f_s_Product3__productElement__I__O($thiz, n) {
  switch (n) {
    case 0: {
      return $thiz.$$und1$1;
      break
    }
    case 1: {
      return $thiz.$$und2$1;
      break
    }
    case 2: {
      return $thiz.$$und3$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + n))
    }
  }
}
function $f_s_Product4__productElement__I__O($thiz, n) {
  switch (n) {
    case 0: {
      return $thiz.$$und1$1;
      break
    }
    case 1: {
      return $thiz.$$und2$1;
      break
    }
    case 2: {
      return $thiz.$$und3$1;
      break
    }
    case 3: {
      return $thiz.$$und4$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + n))
    }
  }
}
/** @constructor */
function $c_s_concurrent_BlockContext$DefaultBlockContext$() {
  $c_O.call(this)
}
$c_s_concurrent_BlockContext$DefaultBlockContext$.prototype = new $h_O();
$c_s_concurrent_BlockContext$DefaultBlockContext$.prototype.constructor = $c_s_concurrent_BlockContext$DefaultBlockContext$;
/** @constructor */
function $h_s_concurrent_BlockContext$DefaultBlockContext$() {
  /*<skip>*/
}
$h_s_concurrent_BlockContext$DefaultBlockContext$.prototype = $c_s_concurrent_BlockContext$DefaultBlockContext$.prototype;
$c_s_concurrent_BlockContext$DefaultBlockContext$.prototype.init___ = (function() {
  return this
});
var $d_s_concurrent_BlockContext$DefaultBlockContext$ = new $TypeData().initClass({
  s_concurrent_BlockContext$DefaultBlockContext$: 0
}, false, "scala.concurrent.BlockContext$DefaultBlockContext$", {
  s_concurrent_BlockContext$DefaultBlockContext$: 1,
  O: 1,
  s_concurrent_BlockContext: 1
});
$c_s_concurrent_BlockContext$DefaultBlockContext$.prototype.$classData = $d_s_concurrent_BlockContext$DefaultBlockContext$;
var $n_s_concurrent_BlockContext$DefaultBlockContext$ = (void 0);
function $m_s_concurrent_BlockContext$DefaultBlockContext$() {
  if ((!$n_s_concurrent_BlockContext$DefaultBlockContext$)) {
    $n_s_concurrent_BlockContext$DefaultBlockContext$ = new $c_s_concurrent_BlockContext$DefaultBlockContext$().init___()
  };
  return $n_s_concurrent_BlockContext$DefaultBlockContext$
}
/** @constructor */
function $c_s_package$$anon$1() {
  $c_O.call(this)
}
$c_s_package$$anon$1.prototype = new $h_O();
$c_s_package$$anon$1.prototype.constructor = $c_s_package$$anon$1;
/** @constructor */
function $h_s_package$$anon$1() {
  /*<skip>*/
}
$h_s_package$$anon$1.prototype = $c_s_package$$anon$1.prototype;
$c_s_package$$anon$1.prototype.init___ = (function() {
  return this
});
$c_s_package$$anon$1.prototype.toString__T = (function() {
  return "object AnyRef"
});
var $d_s_package$$anon$1 = new $TypeData().initClass({
  s_package$$anon$1: 0
}, false, "scala.package$$anon$1", {
  s_package$$anon$1: 1,
  O: 1,
  s_Specializable: 1
});
$c_s_package$$anon$1.prototype.$classData = $d_s_package$$anon$1;
/** @constructor */
function $c_s_util_hashing_MurmurHash3$() {
  $c_s_util_hashing_MurmurHash3.call(this);
  this.seqSeed$2 = 0;
  this.mapSeed$2 = 0;
  this.setSeed$2 = 0
}
$c_s_util_hashing_MurmurHash3$.prototype = new $h_s_util_hashing_MurmurHash3();
$c_s_util_hashing_MurmurHash3$.prototype.constructor = $c_s_util_hashing_MurmurHash3$;
/** @constructor */
function $h_s_util_hashing_MurmurHash3$() {
  /*<skip>*/
}
$h_s_util_hashing_MurmurHash3$.prototype = $c_s_util_hashing_MurmurHash3$.prototype;
$c_s_util_hashing_MurmurHash3$.prototype.init___ = (function() {
  $n_s_util_hashing_MurmurHash3$ = this;
  this.seqSeed$2 = $m_sjsr_RuntimeString$().hashCode__T__I("Seq");
  this.mapSeed$2 = $m_sjsr_RuntimeString$().hashCode__T__I("Map");
  this.setSeed$2 = $m_sjsr_RuntimeString$().hashCode__T__I("Set");
  return this
});
$c_s_util_hashing_MurmurHash3$.prototype.seqHash__sc_Seq__I = (function(xs) {
  if ((xs instanceof $c_sci_List)) {
    var x2 = $as_sci_List(xs);
    return this.listHash__sci_List__I__I(x2, this.seqSeed$2)
  } else {
    return this.orderedHash__sc_TraversableOnce__I__I(xs, this.seqSeed$2)
  }
});
var $d_s_util_hashing_MurmurHash3$ = new $TypeData().initClass({
  s_util_hashing_MurmurHash3$: 0
}, false, "scala.util.hashing.MurmurHash3$", {
  s_util_hashing_MurmurHash3$: 1,
  s_util_hashing_MurmurHash3: 1,
  O: 1
});
$c_s_util_hashing_MurmurHash3$.prototype.$classData = $d_s_util_hashing_MurmurHash3$;
var $n_s_util_hashing_MurmurHash3$ = (void 0);
function $m_s_util_hashing_MurmurHash3$() {
  if ((!$n_s_util_hashing_MurmurHash3$)) {
    $n_s_util_hashing_MurmurHash3$ = new $c_s_util_hashing_MurmurHash3$().init___()
  };
  return $n_s_util_hashing_MurmurHash3$
}
/** @constructor */
function $c_s_util_matching_Regex$Match() {
  $c_O.call(this);
  this.starts$1 = null;
  this.ends$1 = null;
  this.source$1 = null;
  this.matcher$1 = null;
  this.groupNames$1 = null;
  this.start$1 = 0;
  this.end$1 = 0;
  this.scala$util$matching$Regex$MatchData$$nameToIndex$1 = null;
  this.bitmap$0$1 = 0
}
$c_s_util_matching_Regex$Match.prototype = new $h_O();
$c_s_util_matching_Regex$Match.prototype.constructor = $c_s_util_matching_Regex$Match;
/** @constructor */
function $h_s_util_matching_Regex$Match() {
  /*<skip>*/
}
$h_s_util_matching_Regex$Match.prototype = $c_s_util_matching_Regex$Match.prototype;
$c_s_util_matching_Regex$Match.prototype.force__s_util_matching_Regex$Match = (function() {
  this.starts__p1__AI();
  this.ends__p1__AI();
  return this
});
$c_s_util_matching_Regex$Match.prototype.init___jl_CharSequence__ju_regex_Matcher__sc_Seq = (function(source, matcher, groupNames) {
  this.source$1 = source;
  this.matcher$1 = matcher;
  this.groupNames$1 = groupNames;
  this.start$1 = matcher.start__I();
  this.end$1 = matcher.end__I();
  return this
});
$c_s_util_matching_Regex$Match.prototype.start__I__I = (function(i) {
  return this.starts__p1__AI().get(i)
});
$c_s_util_matching_Regex$Match.prototype.toString__T = (function() {
  return $f_s_util_matching_Regex$MatchData__matched__T(this)
});
$c_s_util_matching_Regex$Match.prototype.end__I = (function() {
  return this.end$1
});
$c_s_util_matching_Regex$Match.prototype.ends$lzycompute__p1__AI = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    var this$2 = this.matcher$1;
    var end = $m_ju_regex_Matcher$().java$util$regex$Matcher$$getGroupCount__sjs_js_RegExp$ExecResult__ju_regex_Pattern__I(this$2.lastMatch$1, this$2.pattern0$1);
    var isEmpty$4 = (end < 0);
    if (isEmpty$4) {
      var scala$collection$immutable$Range$$numRangeElements$4 = 0
    } else {
      var hi = (end >> 31);
      var lo = ((1 + end) | 0);
      var hi$1 = ((lo === 0) ? ((1 + hi) | 0) : hi);
      var scala$collection$immutable$Range$$numRangeElements$4 = (((hi$1 === 0) ? (((-2147483648) ^ lo) > (-1)) : (hi$1 > 0)) ? (-1) : lo)
    };
    $m_sci_IndexedSeq$();
    $m_sc_IndexedSeq$();
    $m_sci_IndexedSeq$();
    $m_sci_Vector$();
    var b = new $c_sci_VectorBuilder().init___();
    if ((scala$collection$immutable$Range$$numRangeElements$4 < 0)) {
      $m_sci_Range$().scala$collection$immutable$Range$$fail__I__I__I__Z__sr_Nothing$(0, end, 1, true)
    };
    switch (scala$collection$immutable$Range$$numRangeElements$4) {
      case (-1): {
        break
      }
    };
    if ((!isEmpty$4)) {
      var i = 0;
      while (true) {
        var arg1 = i;
        var elem = this.matcher$1.end__I__I(arg1);
        b.$$plus$eq__O__sci_VectorBuilder(elem);
        if ((i === end)) {
          break
        };
        i = ((1 + i) | 0)
      }
    };
    var this$11 = b.result__sci_Vector();
    var len = this$11.length__I();
    var result = $newArrayObject($d_I.getArrayOf(), [len]);
    $f_sc_TraversableOnce__copyToArray__O__I__V(this$11, result, 0);
    this.ends$1 = result;
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.ends$1
});
$c_s_util_matching_Regex$Match.prototype.ends__p1__AI = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.ends$lzycompute__p1__AI() : this.ends$1)
});
$c_s_util_matching_Regex$Match.prototype.source__jl_CharSequence = (function() {
  return this.source$1
});
$c_s_util_matching_Regex$Match.prototype.start__I = (function() {
  return this.start$1
});
$c_s_util_matching_Regex$Match.prototype.end__I__I = (function(i) {
  return this.ends__p1__AI().get(i)
});
$c_s_util_matching_Regex$Match.prototype.starts__p1__AI = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.starts$lzycompute__p1__AI() : this.starts$1)
});
$c_s_util_matching_Regex$Match.prototype.starts$lzycompute__p1__AI = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    var this$2 = this.matcher$1;
    var end = $m_ju_regex_Matcher$().java$util$regex$Matcher$$getGroupCount__sjs_js_RegExp$ExecResult__ju_regex_Pattern__I(this$2.lastMatch$1, this$2.pattern0$1);
    var isEmpty$4 = (end < 0);
    if (isEmpty$4) {
      var scala$collection$immutable$Range$$numRangeElements$4 = 0
    } else {
      var hi = (end >> 31);
      var lo = ((1 + end) | 0);
      var hi$1 = ((lo === 0) ? ((1 + hi) | 0) : hi);
      var scala$collection$immutable$Range$$numRangeElements$4 = (((hi$1 === 0) ? (((-2147483648) ^ lo) > (-1)) : (hi$1 > 0)) ? (-1) : lo)
    };
    $m_sci_IndexedSeq$();
    $m_sc_IndexedSeq$();
    $m_sci_IndexedSeq$();
    $m_sci_Vector$();
    var b = new $c_sci_VectorBuilder().init___();
    if ((scala$collection$immutable$Range$$numRangeElements$4 < 0)) {
      $m_sci_Range$().scala$collection$immutable$Range$$fail__I__I__I__Z__sr_Nothing$(0, end, 1, true)
    };
    switch (scala$collection$immutable$Range$$numRangeElements$4) {
      case (-1): {
        break
      }
    };
    if ((!isEmpty$4)) {
      var i = 0;
      while (true) {
        var arg1 = i;
        var elem = this.matcher$1.start__I__I(arg1);
        b.$$plus$eq__O__sci_VectorBuilder(elem);
        if ((i === end)) {
          break
        };
        i = ((1 + i) | 0)
      }
    };
    var this$11 = b.result__sci_Vector();
    var len = this$11.length__I();
    var result = $newArrayObject($d_I.getArrayOf(), [len]);
    $f_sc_TraversableOnce__copyToArray__O__I__V(this$11, result, 0);
    this.starts$1 = result;
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.starts$1
});
function $as_s_util_matching_Regex$Match(obj) {
  return (((obj instanceof $c_s_util_matching_Regex$Match) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.util.matching.Regex$Match"))
}
function $isArrayOf_s_util_matching_Regex$Match(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_util_matching_Regex$Match)))
}
function $asArrayOf_s_util_matching_Regex$Match(obj, depth) {
  return (($isArrayOf_s_util_matching_Regex$Match(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.util.matching.Regex$Match;", depth))
}
var $d_s_util_matching_Regex$Match = new $TypeData().initClass({
  s_util_matching_Regex$Match: 0
}, false, "scala.util.matching.Regex$Match", {
  s_util_matching_Regex$Match: 1,
  O: 1,
  s_util_matching_Regex$MatchData: 1
});
$c_s_util_matching_Regex$Match.prototype.$classData = $d_s_util_matching_Regex$Match;
function $f_sc_Iterator__exists__F1__Z($thiz, p) {
  var res = false;
  while (((!res) && $thiz.hasNext__Z())) {
    res = $uZ(p.apply__O__O($thiz.next__O()))
  };
  return res
}
function $f_sc_Iterator__isEmpty__Z($thiz) {
  return (!$thiz.hasNext__Z())
}
function $f_sc_Iterator__take__I__sc_Iterator($thiz, n) {
  return $thiz.sliceIterator__I__I__sc_Iterator(0, ((n > 0) ? n : 0))
}
function $f_sc_Iterator__forall__F1__Z($thiz, p) {
  var res = true;
  while ((res && $thiz.hasNext__Z())) {
    res = $uZ(p.apply__O__O($thiz.next__O()))
  };
  return res
}
function $f_sc_Iterator__sliceIterator__I__I__sc_Iterator($thiz, from, until) {
  var lo = ((from > 0) ? from : 0);
  var rest = ((until < 0) ? (-1) : ((until <= lo) ? 0 : ((until - lo) | 0)));
  return ((rest === 0) ? $m_sc_Iterator$().empty$1 : new $c_sc_Iterator$SliceIterator().init___sc_Iterator__I__I($thiz, lo, rest))
}
function $f_sc_Iterator__foreach__F1__V($thiz, f) {
  while ($thiz.hasNext__Z()) {
    f.apply__O__O($thiz.next__O())
  }
}
function $f_sc_Iterator__$$plus$plus__F0__sc_Iterator($thiz, that) {
  return new $c_sc_Iterator$ConcatIterator().init___sc_Iterator($thiz).$$plus$plus__F0__sc_Iterator(that)
}
function $f_sc_Iterator__find__F1__s_Option($thiz, p) {
  while ($thiz.hasNext__Z()) {
    var a = $thiz.next__O();
    if ($uZ(p.apply__O__O(a))) {
      return new $c_s_Some().init___O(a)
    }
  };
  return $m_s_None$()
}
function $f_sc_Iterator__toStream__sci_Stream($thiz) {
  if ($thiz.hasNext__Z()) {
    var hd = $thiz.next__O();
    var tl = new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
      return (function() {
        return $this.toStream__sci_Stream()
      })
    })($thiz));
    return new $c_sci_Stream$Cons().init___O__F0(hd, tl)
  } else {
    $m_sci_Stream$();
    return $m_sci_Stream$Empty$()
  }
}
function $f_sc_Iterator__contains__O__Z($thiz, elem) {
  var res = false;
  while (((!res) && $thiz.hasNext__Z())) {
    var arg1 = $thiz.next__O();
    res = $m_sr_BoxesRunTime$().equals__O__O__Z(arg1, elem)
  };
  return res
}
function $f_sc_Iterator__copyToArray__O__I__I__V($thiz, xs, start, len) {
  var i = start;
  var y = (($m_sr_ScalaRunTime$().array$undlength__O__I(xs) - start) | 0);
  var end = ((start + ((len < y) ? len : y)) | 0);
  while (((i < end) && $thiz.hasNext__Z())) {
    $m_sr_ScalaRunTime$().array$undupdate__O__I__O__V(xs, i, $thiz.next__O());
    i = ((1 + i) | 0)
  }
}
function $f_sc_Iterator__drop__I__sc_Iterator($thiz, n) {
  var j = 0;
  while (((j < n) && $thiz.hasNext__Z())) {
    $thiz.next__O();
    j = ((1 + j) | 0)
  };
  return $thiz
}
function $is_sc_Iterator(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_Iterator)))
}
function $as_sc_Iterator(obj) {
  return (($is_sc_Iterator(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.Iterator"))
}
function $isArrayOf_sc_Iterator(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_Iterator)))
}
function $asArrayOf_sc_Iterator(obj, depth) {
  return (($isArrayOf_sc_Iterator(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.Iterator;", depth))
}
/** @constructor */
function $c_sc_SeqView$$anon$1() {
  $c_O.call(this)
}
$c_sc_SeqView$$anon$1.prototype = new $h_O();
$c_sc_SeqView$$anon$1.prototype.constructor = $c_sc_SeqView$$anon$1;
/** @constructor */
function $h_sc_SeqView$$anon$1() {
  /*<skip>*/
}
$h_sc_SeqView$$anon$1.prototype = $c_sc_SeqView$$anon$1.prototype;
$c_sc_SeqView$$anon$1.prototype.init___ = (function() {
  return this
});
$c_sc_SeqView$$anon$1.prototype.apply__scm_Builder = (function() {
  return new $c_sc_TraversableView$NoBuilder().init___()
});
$c_sc_SeqView$$anon$1.prototype.apply__O__scm_Builder = (function(from) {
  $as_sc_TraversableView(from);
  return new $c_sc_TraversableView$NoBuilder().init___()
});
var $d_sc_SeqView$$anon$1 = new $TypeData().initClass({
  sc_SeqView$$anon$1: 0
}, false, "scala.collection.SeqView$$anon$1", {
  sc_SeqView$$anon$1: 1,
  O: 1,
  scg_CanBuildFrom: 1
});
$c_sc_SeqView$$anon$1.prototype.$classData = $d_sc_SeqView$$anon$1;
/** @constructor */
function $c_sc_TraversableLike$WithFilter() {
  $c_O.call(this);
  this.p$1 = null;
  this.$$outer$1 = null
}
$c_sc_TraversableLike$WithFilter.prototype = new $h_O();
$c_sc_TraversableLike$WithFilter.prototype.constructor = $c_sc_TraversableLike$WithFilter;
/** @constructor */
function $h_sc_TraversableLike$WithFilter() {
  /*<skip>*/
}
$h_sc_TraversableLike$WithFilter.prototype = $c_sc_TraversableLike$WithFilter.prototype;
$c_sc_TraversableLike$WithFilter.prototype.foreach__F1__V = (function(f) {
  this.$$outer$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, f$1) {
    return (function(x$2) {
      return ($uZ($this.p$1.apply__O__O(x$2)) ? f$1.apply__O__O(x$2) : (void 0))
    })
  })(this, f)))
});
$c_sc_TraversableLike$WithFilter.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  var b = bf.apply__O__scm_Builder(this.$$outer$1.repr__O());
  this.$$outer$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$1, f$1) {
    return (function(x$2) {
      return ($uZ($this.p$1.apply__O__O(x$2)) ? b$1.$$plus$eq__O__scm_Builder(f$1.apply__O__O(x$2)) : (void 0))
    })
  })(this, b, f)));
  return b.result__O()
});
$c_sc_TraversableLike$WithFilter.prototype.init___sc_TraversableLike__F1 = (function($$outer, p) {
  this.p$1 = p;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_sc_TraversableLike$WithFilter = new $TypeData().initClass({
  sc_TraversableLike$WithFilter: 0
}, false, "scala.collection.TraversableLike$WithFilter", {
  sc_TraversableLike$WithFilter: 1,
  O: 1,
  scg_FilterMonadic: 1
});
$c_sc_TraversableLike$WithFilter.prototype.$classData = $d_sc_TraversableLike$WithFilter;
/** @constructor */
function $c_sc_package$$anon$1() {
  $c_O.call(this);
  this.b$1$1 = null
}
$c_sc_package$$anon$1.prototype = new $h_O();
$c_sc_package$$anon$1.prototype.constructor = $c_sc_package$$anon$1;
/** @constructor */
function $h_sc_package$$anon$1() {
  /*<skip>*/
}
$h_sc_package$$anon$1.prototype = $c_sc_package$$anon$1.prototype;
$c_sc_package$$anon$1.prototype.apply__scm_Builder = (function() {
  return this.b$1$1.apply__scm_Builder()
});
$c_sc_package$$anon$1.prototype.apply__O__scm_Builder = (function(from) {
  return this.b$1$1.apply__scm_Builder()
});
$c_sc_package$$anon$1.prototype.init___scg_CanBuildFrom = (function(b$1) {
  this.b$1$1 = b$1;
  return this
});
var $d_sc_package$$anon$1 = new $TypeData().initClass({
  sc_package$$anon$1: 0
}, false, "scala.collection.package$$anon$1", {
  sc_package$$anon$1: 1,
  O: 1,
  scg_CanBuildFrom: 1
});
$c_sc_package$$anon$1.prototype.$classData = $d_sc_package$$anon$1;
/** @constructor */
function $c_scg_GenMapFactory$MapCanBuildFrom() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_scg_GenMapFactory$MapCanBuildFrom.prototype = new $h_O();
$c_scg_GenMapFactory$MapCanBuildFrom.prototype.constructor = $c_scg_GenMapFactory$MapCanBuildFrom;
/** @constructor */
function $h_scg_GenMapFactory$MapCanBuildFrom() {
  /*<skip>*/
}
$h_scg_GenMapFactory$MapCanBuildFrom.prototype = $c_scg_GenMapFactory$MapCanBuildFrom.prototype;
$c_scg_GenMapFactory$MapCanBuildFrom.prototype.apply__scm_Builder = (function() {
  return this.$$outer$1.newBuilder__scm_Builder()
});
$c_scg_GenMapFactory$MapCanBuildFrom.prototype.apply__O__scm_Builder = (function(from) {
  $as_sc_GenMap(from);
  return this.$$outer$1.newBuilder__scm_Builder()
});
$c_scg_GenMapFactory$MapCanBuildFrom.prototype.init___scg_GenMapFactory = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_scg_GenMapFactory$MapCanBuildFrom = new $TypeData().initClass({
  scg_GenMapFactory$MapCanBuildFrom: 0
}, false, "scala.collection.generic.GenMapFactory$MapCanBuildFrom", {
  scg_GenMapFactory$MapCanBuildFrom: 1,
  O: 1,
  scg_CanBuildFrom: 1
});
$c_scg_GenMapFactory$MapCanBuildFrom.prototype.$classData = $d_scg_GenMapFactory$MapCanBuildFrom;
/** @constructor */
function $c_scg_GenSetFactory() {
  $c_scg_GenericCompanion.call(this)
}
$c_scg_GenSetFactory.prototype = new $h_scg_GenericCompanion();
$c_scg_GenSetFactory.prototype.constructor = $c_scg_GenSetFactory;
/** @constructor */
function $h_scg_GenSetFactory() {
  /*<skip>*/
}
$h_scg_GenSetFactory.prototype = $c_scg_GenSetFactory.prototype;
/** @constructor */
function $c_scg_GenSetFactory$$anon$1() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_scg_GenSetFactory$$anon$1.prototype = new $h_O();
$c_scg_GenSetFactory$$anon$1.prototype.constructor = $c_scg_GenSetFactory$$anon$1;
/** @constructor */
function $h_scg_GenSetFactory$$anon$1() {
  /*<skip>*/
}
$h_scg_GenSetFactory$$anon$1.prototype = $c_scg_GenSetFactory$$anon$1.prototype;
$c_scg_GenSetFactory$$anon$1.prototype.apply__scm_Builder = (function() {
  return this.$$outer$1.newBuilder__scm_Builder()
});
$c_scg_GenSetFactory$$anon$1.prototype.apply__O__scm_Builder = (function(from) {
  return this.apply__sc_GenSet__scm_Builder($as_sc_GenSet(from))
});
$c_scg_GenSetFactory$$anon$1.prototype.init___scg_GenSetFactory = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_scg_GenSetFactory$$anon$1.prototype.apply__sc_GenSet__scm_Builder = (function(from) {
  return ($is_sc_Set(from) ? from.companion__scg_GenericCompanion().newBuilder__scm_Builder() : this.$$outer$1.newBuilder__scm_Builder())
});
var $d_scg_GenSetFactory$$anon$1 = new $TypeData().initClass({
  scg_GenSetFactory$$anon$1: 0
}, false, "scala.collection.generic.GenSetFactory$$anon$1", {
  scg_GenSetFactory$$anon$1: 1,
  O: 1,
  scg_CanBuildFrom: 1
});
$c_scg_GenSetFactory$$anon$1.prototype.$classData = $d_scg_GenSetFactory$$anon$1;
/** @constructor */
function $c_scg_GenTraversableFactory() {
  $c_scg_GenericCompanion.call(this);
  this.ReusableCBFInstance$2 = null
}
$c_scg_GenTraversableFactory.prototype = new $h_scg_GenericCompanion();
$c_scg_GenTraversableFactory.prototype.constructor = $c_scg_GenTraversableFactory;
/** @constructor */
function $h_scg_GenTraversableFactory() {
  /*<skip>*/
}
$h_scg_GenTraversableFactory.prototype = $c_scg_GenTraversableFactory.prototype;
$c_scg_GenTraversableFactory.prototype.init___ = (function() {
  this.ReusableCBFInstance$2 = new $c_scg_GenTraversableFactory$$anon$1().init___scg_GenTraversableFactory(this);
  return this
});
/** @constructor */
function $c_scg_GenTraversableFactory$GenericCanBuildFrom() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_scg_GenTraversableFactory$GenericCanBuildFrom.prototype = new $h_O();
$c_scg_GenTraversableFactory$GenericCanBuildFrom.prototype.constructor = $c_scg_GenTraversableFactory$GenericCanBuildFrom;
/** @constructor */
function $h_scg_GenTraversableFactory$GenericCanBuildFrom() {
  /*<skip>*/
}
$h_scg_GenTraversableFactory$GenericCanBuildFrom.prototype = $c_scg_GenTraversableFactory$GenericCanBuildFrom.prototype;
$c_scg_GenTraversableFactory$GenericCanBuildFrom.prototype.apply__scm_Builder = (function() {
  return this.$$outer$1.newBuilder__scm_Builder()
});
$c_scg_GenTraversableFactory$GenericCanBuildFrom.prototype.apply__O__scm_Builder = (function(from) {
  var from$1 = $as_sc_GenTraversable(from);
  return from$1.companion__scg_GenericCompanion().newBuilder__scm_Builder()
});
$c_scg_GenTraversableFactory$GenericCanBuildFrom.prototype.init___scg_GenTraversableFactory = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
function $as_scg_GenTraversableFactory$GenericCanBuildFrom(obj) {
  return (((obj instanceof $c_scg_GenTraversableFactory$GenericCanBuildFrom) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.generic.GenTraversableFactory$GenericCanBuildFrom"))
}
function $isArrayOf_scg_GenTraversableFactory$GenericCanBuildFrom(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scg_GenTraversableFactory$GenericCanBuildFrom)))
}
function $asArrayOf_scg_GenTraversableFactory$GenericCanBuildFrom(obj, depth) {
  return (($isArrayOf_scg_GenTraversableFactory$GenericCanBuildFrom(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.generic.GenTraversableFactory$GenericCanBuildFrom;", depth))
}
/** @constructor */
function $c_scg_ImmutableSortedSetFactory() {
  $c_scg_SortedSetFactory.call(this)
}
$c_scg_ImmutableSortedSetFactory.prototype = new $h_scg_SortedSetFactory();
$c_scg_ImmutableSortedSetFactory.prototype.constructor = $c_scg_ImmutableSortedSetFactory;
/** @constructor */
function $h_scg_ImmutableSortedSetFactory() {
  /*<skip>*/
}
$h_scg_ImmutableSortedSetFactory.prototype = $c_scg_ImmutableSortedSetFactory.prototype;
/** @constructor */
function $c_scg_MapFactory() {
  $c_scg_GenMapFactory.call(this)
}
$c_scg_MapFactory.prototype = new $h_scg_GenMapFactory();
$c_scg_MapFactory.prototype.constructor = $c_scg_MapFactory;
/** @constructor */
function $h_scg_MapFactory() {
  /*<skip>*/
}
$h_scg_MapFactory.prototype = $c_scg_MapFactory.prototype;
/** @constructor */
function $c_sci_HashMap$$anon$1() {
  $c_sci_HashMap$Merger.call(this);
  this.invert$2 = null;
  this.mergef$1$f = null
}
$c_sci_HashMap$$anon$1.prototype = new $h_sci_HashMap$Merger();
$c_sci_HashMap$$anon$1.prototype.constructor = $c_sci_HashMap$$anon$1;
/** @constructor */
function $h_sci_HashMap$$anon$1() {
  /*<skip>*/
}
$h_sci_HashMap$$anon$1.prototype = $c_sci_HashMap$$anon$1.prototype;
$c_sci_HashMap$$anon$1.prototype.init___F2 = (function(mergef$1) {
  this.mergef$1$f = mergef$1;
  this.invert$2 = new $c_sci_HashMap$$anon$1$$anon$2().init___sci_HashMap$$anon$1(this);
  return this
});
$c_sci_HashMap$$anon$1.prototype.apply__T2__T2__T2 = (function(kv1, kv2) {
  return $as_T2(this.mergef$1$f.apply__O__O__O(kv1, kv2))
});
var $d_sci_HashMap$$anon$1 = new $TypeData().initClass({
  sci_HashMap$$anon$1: 0
}, false, "scala.collection.immutable.HashMap$$anon$1", {
  sci_HashMap$$anon$1: 1,
  sci_HashMap$Merger: 1,
  O: 1
});
$c_sci_HashMap$$anon$1.prototype.$classData = $d_sci_HashMap$$anon$1;
/** @constructor */
function $c_sci_HashMap$$anon$1$$anon$2() {
  $c_sci_HashMap$Merger.call(this);
  this.$$outer$2 = null
}
$c_sci_HashMap$$anon$1$$anon$2.prototype = new $h_sci_HashMap$Merger();
$c_sci_HashMap$$anon$1$$anon$2.prototype.constructor = $c_sci_HashMap$$anon$1$$anon$2;
/** @constructor */
function $h_sci_HashMap$$anon$1$$anon$2() {
  /*<skip>*/
}
$h_sci_HashMap$$anon$1$$anon$2.prototype = $c_sci_HashMap$$anon$1$$anon$2.prototype;
$c_sci_HashMap$$anon$1$$anon$2.prototype.init___sci_HashMap$$anon$1 = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  return this
});
$c_sci_HashMap$$anon$1$$anon$2.prototype.apply__T2__T2__T2 = (function(kv1, kv2) {
  return $as_T2(this.$$outer$2.mergef$1$f.apply__O__O__O(kv2, kv1))
});
var $d_sci_HashMap$$anon$1$$anon$2 = new $TypeData().initClass({
  sci_HashMap$$anon$1$$anon$2: 0
}, false, "scala.collection.immutable.HashMap$$anon$1$$anon$2", {
  sci_HashMap$$anon$1$$anon$2: 1,
  sci_HashMap$Merger: 1,
  O: 1
});
$c_sci_HashMap$$anon$1$$anon$2.prototype.$classData = $d_sci_HashMap$$anon$1$$anon$2;
/** @constructor */
function $c_sci_List$$anon$1() {
  $c_O.call(this)
}
$c_sci_List$$anon$1.prototype = new $h_O();
$c_sci_List$$anon$1.prototype.constructor = $c_sci_List$$anon$1;
/** @constructor */
function $h_sci_List$$anon$1() {
  /*<skip>*/
}
$h_sci_List$$anon$1.prototype = $c_sci_List$$anon$1.prototype;
$c_sci_List$$anon$1.prototype.init___ = (function() {
  return this
});
$c_sci_List$$anon$1.prototype.apply__O__O = (function(x) {
  return this
});
$c_sci_List$$anon$1.prototype.toString__T = (function() {
  return "<function1>"
});
$c_sci_List$$anon$1.prototype.apply$mcZI$sp__I__Z = (function(v1) {
  return $uZ(this)
});
var $d_sci_List$$anon$1 = new $TypeData().initClass({
  sci_List$$anon$1: 0
}, false, "scala.collection.immutable.List$$anon$1", {
  sci_List$$anon$1: 1,
  O: 1,
  F1: 1
});
$c_sci_List$$anon$1.prototype.$classData = $d_sci_List$$anon$1;
/** @constructor */
function $c_sci_Stream$StreamWithFilter() {
  $c_O.call(this);
  this.filtered$1 = null;
  this.p$1 = null;
  this.s$1 = null;
  this.bitmap$0$1 = false
}
$c_sci_Stream$StreamWithFilter.prototype = new $h_O();
$c_sci_Stream$StreamWithFilter.prototype.constructor = $c_sci_Stream$StreamWithFilter;
/** @constructor */
function $h_sci_Stream$StreamWithFilter() {
  /*<skip>*/
}
$h_sci_Stream$StreamWithFilter.prototype = $c_sci_Stream$StreamWithFilter.prototype;
$c_sci_Stream$StreamWithFilter.prototype.foreach__F1__V = (function(f) {
  this.filtered__p1__sci_Stream().foreach__F1__V(f)
});
$c_sci_Stream$StreamWithFilter.prototype.filtered__p1__sci_Stream = (function() {
  return ((!this.bitmap$0$1) ? this.filtered$lzycompute__p1__sci_Stream() : this.filtered$1)
});
$c_sci_Stream$StreamWithFilter.prototype.init___F0__F1 = (function(sl, p) {
  this.p$1 = p;
  this.s$1 = $as_sci_Stream(sl.apply__O());
  return this
});
$c_sci_Stream$StreamWithFilter.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return this.filtered__p1__sci_Stream().map__F1__scg_CanBuildFrom__O(f, bf)
});
$c_sci_Stream$StreamWithFilter.prototype.filtered$lzycompute__p1__sci_Stream = (function() {
  if ((!this.bitmap$0$1)) {
    var this$1 = this.s$1;
    var p = this.p$1;
    var f = this$1.filterImpl__F1__Z__sci_Stream(p, false);
    this.s$1 = null;
    this.filtered$1 = f;
    this.bitmap$0$1 = true
  };
  return this.filtered$1
});
var $d_sci_Stream$StreamWithFilter = new $TypeData().initClass({
  sci_Stream$StreamWithFilter: 0
}, false, "scala.collection.immutable.Stream$StreamWithFilter", {
  sci_Stream$StreamWithFilter: 1,
  O: 1,
  scg_FilterMonadic: 1
});
$c_sci_Stream$StreamWithFilter.prototype.$classData = $d_sci_Stream$StreamWithFilter;
function $f_scm_Builder__sizeHint__sc_TraversableLike__V($thiz, coll) {
  var x1 = coll.sizeHintIfCheap__I();
  switch (x1) {
    case (-1): {
      break
    }
    default: {
      $thiz.sizeHint__I__V(x1)
    }
  }
}
function $f_scm_Builder__sizeHint__sc_TraversableLike__I__V($thiz, coll, delta) {
  var x1 = coll.sizeHintIfCheap__I();
  switch (x1) {
    case (-1): {
      break
    }
    default: {
      $thiz.sizeHint__I__V(((x1 + delta) | 0))
    }
  }
}
function $f_scm_Builder__sizeHintBounded__I__sc_TraversableLike__V($thiz, size, boundingColl) {
  var x1 = boundingColl.sizeHintIfCheap__I();
  switch (x1) {
    case (-1): {
      break
    }
    default: {
      $thiz.sizeHint__I__V(((size < x1) ? size : x1))
    }
  }
}
function $is_scm_Builder(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.scm_Builder)))
}
function $as_scm_Builder(obj) {
  return (($is_scm_Builder(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.Builder"))
}
function $isArrayOf_scm_Builder(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_Builder)))
}
function $asArrayOf_scm_Builder(obj, depth) {
  return (($isArrayOf_scm_Builder(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.Builder;", depth))
}
/** @constructor */
function $c_sr_AbstractFunction0() {
  $c_O.call(this)
}
$c_sr_AbstractFunction0.prototype = new $h_O();
$c_sr_AbstractFunction0.prototype.constructor = $c_sr_AbstractFunction0;
/** @constructor */
function $h_sr_AbstractFunction0() {
  /*<skip>*/
}
$h_sr_AbstractFunction0.prototype = $c_sr_AbstractFunction0.prototype;
$c_sr_AbstractFunction0.prototype.toString__T = (function() {
  return "<function0>"
});
/** @constructor */
function $c_sr_AbstractFunction1() {
  $c_O.call(this)
}
$c_sr_AbstractFunction1.prototype = new $h_O();
$c_sr_AbstractFunction1.prototype.constructor = $c_sr_AbstractFunction1;
/** @constructor */
function $h_sr_AbstractFunction1() {
  /*<skip>*/
}
$h_sr_AbstractFunction1.prototype = $c_sr_AbstractFunction1.prototype;
$c_sr_AbstractFunction1.prototype.toString__T = (function() {
  return "<function1>"
});
$c_sr_AbstractFunction1.prototype.apply$mcZI$sp__I__Z = (function(v1) {
  return $uZ(this.apply__O__O(v1))
});
/** @constructor */
function $c_sr_AbstractFunction2() {
  $c_O.call(this)
}
$c_sr_AbstractFunction2.prototype = new $h_O();
$c_sr_AbstractFunction2.prototype.constructor = $c_sr_AbstractFunction2;
/** @constructor */
function $h_sr_AbstractFunction2() {
  /*<skip>*/
}
$h_sr_AbstractFunction2.prototype = $c_sr_AbstractFunction2.prototype;
$c_sr_AbstractFunction2.prototype.toString__T = (function() {
  return "<function2>"
});
/** @constructor */
function $c_sr_AbstractFunction3() {
  $c_O.call(this)
}
$c_sr_AbstractFunction3.prototype = new $h_O();
$c_sr_AbstractFunction3.prototype.constructor = $c_sr_AbstractFunction3;
/** @constructor */
function $h_sr_AbstractFunction3() {
  /*<skip>*/
}
$h_sr_AbstractFunction3.prototype = $c_sr_AbstractFunction3.prototype;
$c_sr_AbstractFunction3.prototype.toString__T = (function() {
  return "<function3>"
});
/** @constructor */
function $c_sr_AbstractFunction4() {
  $c_O.call(this)
}
$c_sr_AbstractFunction4.prototype = new $h_O();
$c_sr_AbstractFunction4.prototype.constructor = $c_sr_AbstractFunction4;
/** @constructor */
function $h_sr_AbstractFunction4() {
  /*<skip>*/
}
$h_sr_AbstractFunction4.prototype = $c_sr_AbstractFunction4.prototype;
$c_sr_AbstractFunction4.prototype.toString__T = (function() {
  return "<function4>"
});
/** @constructor */
function $c_sr_AbstractFunction5() {
  $c_O.call(this)
}
$c_sr_AbstractFunction5.prototype = new $h_O();
$c_sr_AbstractFunction5.prototype.constructor = $c_sr_AbstractFunction5;
/** @constructor */
function $h_sr_AbstractFunction5() {
  /*<skip>*/
}
$h_sr_AbstractFunction5.prototype = $c_sr_AbstractFunction5.prototype;
$c_sr_AbstractFunction5.prototype.toString__T = (function() {
  return "<function5>"
});
/** @constructor */
function $c_sr_BooleanRef() {
  $c_O.call(this);
  this.elem$1 = false
}
$c_sr_BooleanRef.prototype = new $h_O();
$c_sr_BooleanRef.prototype.constructor = $c_sr_BooleanRef;
/** @constructor */
function $h_sr_BooleanRef() {
  /*<skip>*/
}
$h_sr_BooleanRef.prototype = $c_sr_BooleanRef.prototype;
$c_sr_BooleanRef.prototype.toString__T = (function() {
  var b = this.elem$1;
  return ("" + b)
});
$c_sr_BooleanRef.prototype.init___Z = (function(elem) {
  this.elem$1 = elem;
  return this
});
var $d_sr_BooleanRef = new $TypeData().initClass({
  sr_BooleanRef: 0
}, false, "scala.runtime.BooleanRef", {
  sr_BooleanRef: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_sr_BooleanRef.prototype.$classData = $d_sr_BooleanRef;
function $isArrayOf_sr_BoxedUnit(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sr_BoxedUnit)))
}
function $asArrayOf_sr_BoxedUnit(obj, depth) {
  return (($isArrayOf_sr_BoxedUnit(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.runtime.BoxedUnit;", depth))
}
var $d_sr_BoxedUnit = new $TypeData().initClass({
  sr_BoxedUnit: 0
}, false, "scala.runtime.BoxedUnit", {
  sr_BoxedUnit: 1,
  O: 1,
  Ljava_io_Serializable: 1
}, (void 0), (void 0), (function(x) {
  return (x === (void 0))
}));
/** @constructor */
function $c_sr_IntRef() {
  $c_O.call(this);
  this.elem$1 = 0
}
$c_sr_IntRef.prototype = new $h_O();
$c_sr_IntRef.prototype.constructor = $c_sr_IntRef;
/** @constructor */
function $h_sr_IntRef() {
  /*<skip>*/
}
$h_sr_IntRef.prototype = $c_sr_IntRef.prototype;
$c_sr_IntRef.prototype.toString__T = (function() {
  var i = this.elem$1;
  return ("" + i)
});
$c_sr_IntRef.prototype.init___I = (function(elem) {
  this.elem$1 = elem;
  return this
});
var $d_sr_IntRef = new $TypeData().initClass({
  sr_IntRef: 0
}, false, "scala.runtime.IntRef", {
  sr_IntRef: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_sr_IntRef.prototype.$classData = $d_sr_IntRef;
/** @constructor */
function $c_sr_LongRef() {
  $c_O.call(this);
  this.elem$1 = $m_sjsr_RuntimeLong$().Zero__sjsr_RuntimeLong()
}
$c_sr_LongRef.prototype = new $h_O();
$c_sr_LongRef.prototype.constructor = $c_sr_LongRef;
/** @constructor */
function $h_sr_LongRef() {
  /*<skip>*/
}
$h_sr_LongRef.prototype = $c_sr_LongRef.prototype;
$c_sr_LongRef.prototype.init___J = (function(elem) {
  this.elem$1 = elem;
  return this
});
$c_sr_LongRef.prototype.toString__T = (function() {
  var t = this.elem$1;
  var lo = t.lo$2;
  var hi = t.hi$2;
  return $m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toString__I__I__T(lo, hi)
});
var $d_sr_LongRef = new $TypeData().initClass({
  sr_LongRef: 0
}, false, "scala.runtime.LongRef", {
  sr_LongRef: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_sr_LongRef.prototype.$classData = $d_sr_LongRef;
/** @constructor */
function $c_sr_ObjectRef() {
  $c_O.call(this);
  this.elem$1 = null
}
$c_sr_ObjectRef.prototype = new $h_O();
$c_sr_ObjectRef.prototype.constructor = $c_sr_ObjectRef;
/** @constructor */
function $h_sr_ObjectRef() {
  /*<skip>*/
}
$h_sr_ObjectRef.prototype = $c_sr_ObjectRef.prototype;
$c_sr_ObjectRef.prototype.toString__T = (function() {
  var obj = this.elem$1;
  return ("" + obj)
});
$c_sr_ObjectRef.prototype.init___O = (function(elem) {
  this.elem$1 = elem;
  return this
});
var $d_sr_ObjectRef = new $TypeData().initClass({
  sr_ObjectRef: 0
}, false, "scala.runtime.ObjectRef", {
  sr_ObjectRef: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_sr_ObjectRef.prototype.$classData = $d_sr_ObjectRef;
/** @constructor */
function $c_Lamf_ProfileName$() {
  $c_O.call(this)
}
$c_Lamf_ProfileName$.prototype = new $h_O();
$c_Lamf_ProfileName$.prototype.constructor = $c_Lamf_ProfileName$;
/** @constructor */
function $h_Lamf_ProfileName$() {
  /*<skip>*/
}
$h_Lamf_ProfileName$.prototype = $c_Lamf_ProfileName$.prototype;
$c_Lamf_ProfileName$.prototype.init___ = (function() {
  return this
});
$c_Lamf_ProfileName$.prototype.apply__T__Lamf_ProfileName = (function(profile) {
  return (($m_Lamf_core_remote_Amf$().name$1 === profile) ? $m_Lamf_AmfProfile$() : (($m_Lamf_core_remote_Oas$().name$1 === profile) ? $m_Lamf_OasProfile$() : (($m_Lamf_core_remote_Oas20$().name$1 === profile) ? $m_Lamf_Oas20Profile$() : (($m_Lamf_core_remote_Oas30$().name$1 === profile) ? $m_Lamf_Oas30Profile$() : (($m_Lamf_core_remote_Raml$().name$1 === profile) ? $m_Lamf_RamlProfile$() : (($m_Lamf_core_remote_Raml08$().name$1 === profile) ? $m_Lamf_Raml08Profile$() : (($m_Lamf_core_remote_Raml10$().name$1 === profile) ? $m_Lamf_Raml10Profile$() : (($m_Lamf_core_remote_AsyncApi$().name$1 === profile) ? $m_Lamf_AsyncProfile$() : (($m_Lamf_core_remote_AsyncApi20$().name$1 === profile) ? $m_Lamf_Async20Profile$() : new $c_Lamf_ProfileName().init___T(profile))))))))))
});
var $d_Lamf_ProfileName$ = new $TypeData().initClass({
  Lamf_ProfileName$: 0
}, false, "amf.ProfileName$", {
  Lamf_ProfileName$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_ProfileName$.prototype.$classData = $d_Lamf_ProfileName$;
var $n_Lamf_ProfileName$ = (void 0);
function $m_Lamf_ProfileName$() {
  if ((!$n_Lamf_ProfileName$)) {
    $n_Lamf_ProfileName$ = new $c_Lamf_ProfileName$().init___()
  };
  return $n_Lamf_ProfileName$
}
/** @constructor */
function $c_Lamf_client_commands_ParseCommand() {
  $c_Lamf_client_commands_TranslateCommand.call(this)
}
$c_Lamf_client_commands_ParseCommand.prototype = new $h_Lamf_client_commands_TranslateCommand();
$c_Lamf_client_commands_ParseCommand.prototype.constructor = $c_Lamf_client_commands_ParseCommand;
/** @constructor */
function $h_Lamf_client_commands_ParseCommand() {
  /*<skip>*/
}
$h_Lamf_client_commands_ParseCommand.prototype = $c_Lamf_client_commands_ParseCommand.prototype;
$c_Lamf_client_commands_ParseCommand.prototype.init___Lamf_core_remote_Platform = (function(platform) {
  $c_Lamf_client_commands_TranslateCommand.prototype.init___Lamf_core_remote_Platform.call(this, platform);
  return this
});
$c_Lamf_client_commands_ParseCommand.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_client_commands_ParseCommand.prototype.run__Lamf_core_client_ParserConfig__s_concurrent_Future = (function(origConfig) {
  var x$1 = new $c_s_Some().init___O("AMF Graph");
  var x$2 = new $c_s_Some().init___O("application/ld+json");
  var x$3 = origConfig.mode$1;
  var x$4 = origConfig.input$1;
  var x$5 = origConfig.inputFormat$1;
  var x$6 = origConfig.inputMediaType$1;
  var x$7 = origConfig.output$1;
  var x$8 = origConfig.withSourceMaps$1;
  var x$9 = origConfig.withCompactNamespaces$1;
  var x$10 = origConfig.validate$1;
  var x$11 = origConfig.trace$1;
  var x$12 = origConfig.patchTarget$1;
  var x$13 = origConfig.validationProfile$1;
  var x$14 = origConfig.customProfile$1;
  var x$15 = origConfig.resolve$1;
  var x$16 = origConfig.dialects$1;
  var x$17 = origConfig.stdout$1;
  var x$18 = origConfig.stderr$1;
  var x$19 = origConfig.proc$1;
  var config = new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(x$3, x$4, x$5, x$6, x$7, x$1, x$2, x$8, x$9, x$10, x$11, x$12, x$13, x$14, x$15, x$16, x$17, x$18, x$19);
  var res = $f_Lamf_client_commands_CommandHelper__AMFInit__s_concurrent_Future(this).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, config$1) {
    return (function(_$2) {
      $asUnit(_$2);
      return $f_Lamf_client_commands_CommandHelper__processDialects__Lamf_core_client_ParserConfig__s_concurrent_Future($this, config$1).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, config$1$1) {
        return (function(_$2$2) {
          $asUnit(_$2$2);
          return $f_Lamf_client_commands_CommandHelper__parseInput__Lamf_core_client_ParserConfig__s_concurrent_Future($this$1, config$1$1).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, config$1$2) {
            return (function(model$2) {
              var model = $as_Lamf_core_model_document_BaseUnit(model$2);
              return $this$2.checkValidation__Lamf_core_client_ParserConfig__Lamf_core_model_document_BaseUnit__s_concurrent_Future(config$1$2, model).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, config$1$3, model$1) {
                return (function(_$2$3) {
                  $asUnit(_$2$3);
                  return $f_Lamf_client_commands_CommandHelper__resolve__Lamf_core_client_ParserConfig__Lamf_core_model_document_BaseUnit__s_concurrent_Future($this$3, config$1$3, model$1).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$4, config$1$4) {
                    return (function(model$2$1) {
                      var model$3 = $as_Lamf_core_model_document_BaseUnit(model$2$1);
                      return $f_Lamf_client_commands_CommandHelper__generateOutput__Lamf_core_client_ParserConfig__Lamf_core_model_document_BaseUnit__s_concurrent_Future($this$4, config$1$4, model$3).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$5) {
                        return (function(generated$2) {
                          $asUnit(generated$2)
                        })
                      })($this$4)), $this$4.executionContext$1)
                    })
                  })($this$3, config$1$3)), $this$3.executionContext$1)
                })
              })($this$2, config$1$2, model)), $this$2.executionContext$1)
            })
          })($this$1, config$1$1)), $this$1.executionContext$1)
        })
      })($this, config$1)), $this.executionContext$1)
    })
  })(this, config)), this.executionContext$1);
  res.onComplete__F1__s_concurrent_ExecutionContext__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, config$2) {
    return (function(x0$1$2) {
      var x0$1 = $as_s_util_Try(x0$1$2);
      matchEnd6: {
        if ((x0$1 instanceof $c_s_util_Failure)) {
          var x2 = $as_s_util_Failure(x0$1);
          var ex = x2.exception$2;
          if ((ex !== null)) {
            config$2.stderr$1.print__jl_Throwable__V(ex);
            var statusCode = $m_Lamf_core_client_ExitCodes$().Exception$1;
            $m_jl_System$();
            var this$4 = $m_jl_Runtime$();
            var this$5 = this$4.currentRuntime$1;
            this$5.halt__I__V(statusCode);
            break matchEnd6
          }
        };
        if ((x0$1 instanceof $c_s_util_Success)) {
          var x3 = $as_s_util_Success(x0$1);
          var other = $asUnit(x3.value$2);
          break matchEnd6
        };
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, config)), this.executionContext$1);
  return res
});
var $d_Lamf_client_commands_ParseCommand = new $TypeData().initClass({
  Lamf_client_commands_ParseCommand: 0
}, false, "amf.client.commands.ParseCommand", {
  Lamf_client_commands_ParseCommand: 1,
  Lamf_client_commands_TranslateCommand: 1,
  O: 1,
  Lamf_client_commands_CommandHelper: 1
});
$c_Lamf_client_commands_ParseCommand.prototype.$classData = $d_Lamf_client_commands_ParseCommand;
/** @constructor */
function $c_Lamf_client_commands_PatchCommand() {
  $c_Lamf_client_commands_TranslateCommand.call(this)
}
$c_Lamf_client_commands_PatchCommand.prototype = new $h_Lamf_client_commands_TranslateCommand();
$c_Lamf_client_commands_PatchCommand.prototype.constructor = $c_Lamf_client_commands_PatchCommand;
/** @constructor */
function $h_Lamf_client_commands_PatchCommand() {
  /*<skip>*/
}
$h_Lamf_client_commands_PatchCommand.prototype = $c_Lamf_client_commands_PatchCommand.prototype;
$c_Lamf_client_commands_PatchCommand.prototype.init___Lamf_core_remote_Platform = (function(platform) {
  $c_Lamf_client_commands_TranslateCommand.prototype.init___Lamf_core_remote_Platform.call(this, platform);
  return this
});
$c_Lamf_client_commands_PatchCommand.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_client_commands_PatchCommand.prototype.run__Lamf_core_client_ParserConfig__s_concurrent_Future = (function(origConfig) {
  var x$1 = new $c_s_Some().init___O("AML 1.0");
  var x$2 = new $c_s_Some().init___O("application/yaml");
  var x$4 = origConfig.mode$1;
  var x$5 = origConfig.input$1;
  var x$6 = origConfig.inputFormat$1;
  var x$7 = origConfig.inputMediaType$1;
  var x$8 = origConfig.output$1;
  var x$9 = origConfig.withSourceMaps$1;
  var x$10 = origConfig.withCompactNamespaces$1;
  var x$11 = origConfig.validate$1;
  var x$12 = origConfig.trace$1;
  var x$13 = origConfig.patchTarget$1;
  var x$14 = origConfig.validationProfile$1;
  var x$15 = origConfig.customProfile$1;
  var x$16 = origConfig.dialects$1;
  var x$17 = origConfig.stdout$1;
  var x$18 = origConfig.stderr$1;
  var x$19 = origConfig.proc$1;
  var config = new $c_Lamf_core_client_ParserConfig().init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc(x$4, x$5, x$6, x$7, x$8, x$1, x$2, x$9, x$10, x$11, x$12, x$13, x$14, x$15, true, x$16, x$17, x$18, x$19);
  var res = $f_Lamf_client_commands_CommandHelper__AMFInit__s_concurrent_Future(this).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, config$1) {
    return (function(_$2) {
      $asUnit(_$2);
      return $f_Lamf_client_commands_CommandHelper__processDialects__Lamf_core_client_ParserConfig__s_concurrent_Future($this, config$1).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, config$1$1) {
        return (function(_$2$2) {
          $asUnit(_$2$2);
          return $f_Lamf_client_commands_CommandHelper__parseInput__Lamf_core_client_ParserConfig__s_concurrent_Future($this$1, config$1$1).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, config$1$2) {
            return (function(model$2) {
              var model = $as_Lamf_core_model_document_BaseUnit(model$2);
              return $this$2.checkValidation__Lamf_core_client_ParserConfig__Lamf_core_model_document_BaseUnit__s_concurrent_Future(config$1$2, model).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, config$1$3, model$1) {
                return (function(_$2$3) {
                  $asUnit(_$2$3);
                  return $this$3.rewriteTarget__Lamf_core_client_ParserConfig__Lamf_core_model_document_BaseUnit__s_concurrent_Future(config$1$3, model$1).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$4, config$1$4) {
                    return (function(model$2$1) {
                      var model$3 = $as_Lamf_core_model_document_BaseUnit(model$2$1);
                      return $f_Lamf_client_commands_CommandHelper__resolve__Lamf_core_client_ParserConfig__Lamf_core_model_document_BaseUnit__s_concurrent_Future($this$4, config$1$4, model$3).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$5, config$1$5) {
                        return (function(model$2$2) {
                          var model$2$3 = $as_Lamf_core_model_document_BaseUnit(model$2$2);
                          return $f_Lamf_client_commands_CommandHelper__generateOutput__Lamf_core_client_ParserConfig__Lamf_core_model_document_BaseUnit__s_concurrent_Future($this$5, config$1$5, model$2$3).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$6) {
                            return (function(generated$2) {
                              $asUnit(generated$2)
                            })
                          })($this$5)), $this$5.executionContext$1)
                        })
                      })($this$4, config$1$4)), $this$4.executionContext$1)
                    })
                  })($this$3, config$1$3)), $this$3.executionContext$1)
                })
              })($this$2, config$1$2, model)), $this$2.executionContext$1)
            })
          })($this$1, config$1$1)), $this$1.executionContext$1)
        })
      })($this, config$1)), $this.executionContext$1)
    })
  })(this, config)), this.executionContext$1);
  res.onComplete__F1__s_concurrent_ExecutionContext__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, config$2) {
    return (function(x0$1$2) {
      var x0$1 = $as_s_util_Try(x0$1$2);
      matchEnd6: {
        if ((x0$1 instanceof $c_s_util_Failure)) {
          var x2 = $as_s_util_Failure(x0$1);
          var ex = x2.exception$2;
          if ((ex !== null)) {
            config$2.stderr$1.print__jl_Throwable__V(ex);
            var statusCode = $m_Lamf_core_client_ExitCodes$().Exception$1;
            $m_jl_System$();
            var this$4 = $m_jl_Runtime$();
            var this$5 = this$4.currentRuntime$1;
            this$5.halt__I__V(statusCode);
            break matchEnd6
          }
        };
        if ((x0$1 instanceof $c_s_util_Success)) {
          var x3 = $as_s_util_Success(x0$1);
          var other = $asUnit(x3.value$2);
          break matchEnd6
        };
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, config)), this.executionContext$1);
  return res
});
$c_Lamf_client_commands_PatchCommand.prototype.rewriteTarget__Lamf_core_client_ParserConfig__Lamf_core_model_document_BaseUnit__s_concurrent_Future = (function(config, model) {
  return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, model$1, config$1) {
    return (function() {
      if ((model$1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch)) {
        var x2 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch(model$1);
        var x1$2 = config$1.patchTarget$1;
        if ((x1$2 instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(x1$2);
          var location = $as_T(x2$2.value$2);
          var target = $this.platform$1.resolvePath__T__T(location);
          var field = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$().Extends$1;
          return $as_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x2, field, target))
        } else {
          return x2
        }
      } else {
        return model$1
      }
    })
  })(this, model, config)), this.executionContext$1)
});
var $d_Lamf_client_commands_PatchCommand = new $TypeData().initClass({
  Lamf_client_commands_PatchCommand: 0
}, false, "amf.client.commands.PatchCommand", {
  Lamf_client_commands_PatchCommand: 1,
  Lamf_client_commands_TranslateCommand: 1,
  O: 1,
  Lamf_client_commands_CommandHelper: 1
});
$c_Lamf_client_commands_PatchCommand.prototype.$classData = $d_Lamf_client_commands_PatchCommand;
/** @constructor */
function $c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2() {
  $c_O.call(this);
  this.payloadMediaType$1 = null;
  this.ID$1 = null;
  this.clientPlugin$1$1 = null
}
$c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2.prototype = new $h_O();
$c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2.prototype.constructor = $c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2;
/** @constructor */
function $h_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2() {
  /*<skip>*/
}
$h_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2.prototype = $c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2.prototype;
$c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2.prototype.init__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  return new $c_Lamf_client_convert_FutureConverter$ClientFutureOps().init___Lamf_client_convert_FutureConverter__O__Lamf_client_convert_ClientInternalMatcher__s_concurrent_ExecutionContext($m_Lamf_client_convert_WebApiClientConverters$(), this.clientPlugin$1$1.init(), $m_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$(), executionContext).asInternal__s_concurrent_Future()
});
$c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2.prototype.validator__Lamf_core_model_domain_Shape__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__Lamf_core_validation_PayloadValidator = (function(s, env, validationMode) {
  var jsx$1 = this.clientPlugin$1$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var validator = jsx$1.validator(m.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(s), new $c_Lamf_client_environment_Environment().init___Lamf_internal_environment_Environment(env), validationMode);
  return new $c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2$$anon$3().init___Lamf_client_convert_ClientPayloadPluginConverter$$anon$2__Lamf_client_plugins_ClientPayloadValidator(this, validator)
});
$c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2.prototype.canValidate__Lamf_core_model_domain_Shape__Lamf_internal_environment_Environment__Z = (function(shape, env) {
  return $uZ(this.clientPlugin$1$1.canValidate($m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$().asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(shape), new $c_Lamf_client_environment_Environment().init___Lamf_internal_environment_Environment(env)))
});
$c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2.prototype.ID__T = (function() {
  return this.ID$1
});
$c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2.prototype.dependencies__sc_Seq = (function() {
  return new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher($m_Lamf_client_convert_WebApiClientConverters$(), this.clientPlugin$1$1.dependencies(), $m_Lamf_client_convert_ClientPayloadPluginConverter$AMFPluginConverter$()).asInternal__sc_Seq()
});
$c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2.prototype.init___Lamf_client_plugins_ClientAMFPayloadValidationPlugin = (function(clientPlugin$1) {
  this.clientPlugin$1$1 = clientPlugin$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var from = clientPlugin$1.payloadMediaType;
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  this.payloadMediaType$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, from, m).asInternal__sc_Seq();
  this.ID$1 = $as_T(clientPlugin$1.ID);
  return this
});
$c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2.prototype.payloadMediaType__sc_Seq = (function() {
  return this.payloadMediaType$1
});
var $d_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2 = new $TypeData().initClass({
  Lamf_client_convert_ClientPayloadPluginConverter$$anon$2: 0
}, false, "amf.client.convert.ClientPayloadPluginConverter$$anon$2", {
  Lamf_client_convert_ClientPayloadPluginConverter$$anon$2: 1,
  O: 1,
  Lamf_core_validation_AMFPayloadValidationPlugin: 1,
  Lamf_client_plugins_AMFPlugin: 1
});
$c_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2.prototype.$classData = $d_Lamf_client_convert_ClientPayloadPluginConverter$$anon$2;
function $f_Lamf_client_model_document_BaseUnit__findById__T__sjs_js_UndefOr($thiz, id) {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_document_BaseUnit();
  var id$1 = $m_Lamf_core_vocabulary_Namespace$().uri__T__Lamf_core_vocabulary_ValueType(id).iri__T();
  var from = $f_Lamf_core_model_document_BaseUnit__findById__T__s_Option(this$1, id$1);
  var m = $m_Lamf_client_convert_CoreClientConverters$().DomainElementMatcher__Lamf_client_convert_DomainElementConverter$DomainElementMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
}
function $f_Lamf_client_model_document_BaseUnit__withLocation__T__Lamf_client_model_document_BaseUnit($thiz, location) {
  var this$1 = $thiz.$$undinternal__Lamf_core_model_document_BaseUnit();
  var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
  $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, location));
  return $thiz
}
function $f_Lamf_client_model_document_BaseUnit__references__sjs_js_Array($thiz) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = $thiz.$$undinternal__Lamf_core_model_document_BaseUnit().references__sc_Seq();
  var m = $m_Lamf_client_convert_CoreClientConverters$().BaseUnitMatcher__Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
}
function $f_Lamf_client_model_document_BaseUnit__withUsage__T__Lamf_client_model_document_BaseUnit($thiz, usage) {
  var this$1 = $thiz.$$undinternal__Lamf_core_model_document_BaseUnit();
  var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1;
  $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, usage));
  return $thiz
}
function $f_Lamf_client_model_document_BaseUnit__withReferences__sjs_js_Array__Lamf_client_model_document_BaseUnit($thiz, references) {
  var this$2 = $thiz.$$undinternal__Lamf_core_model_document_BaseUnit();
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var m = $m_Lamf_client_convert_CoreClientConverters$().BaseUnitMatcher__Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$();
  var references$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, references, m).asInternal__sc_Seq();
  var field = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
  $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, references$1));
  return $thiz
}
function $f_Lamf_client_model_document_BaseUnit__toNativeRdfModel__Lamf_client_render_RenderOptions__Lamf_core_rdf_RdfModel($thiz, renderOptions) {
  var coreOptions = $m_Lamf_core_emitter_RenderOptions$().apply__Lamf_client_render_RenderOptions__Lamf_core_emitter_RenderOptions(renderOptions);
  var this$1 = $thiz.$$undinternal__Lamf_core_model_document_BaseUnit();
  return $f_Lamf_core_model_document_BaseUnit__toNativeRdfModel__Lamf_core_emitter_RenderOptions__Lamf_core_rdf_RdfModel(this$1, coreOptions)
}
function $f_Lamf_client_model_document_BaseUnit__withReferenceAlias__T__T__T__Lamf_client_model_document_BaseUnit($thiz, alias, fullUrl, relativeUrl) {
  $m_Lamf_core_annotations_AliasDeclaration$().apply__Lamf_core_model_document_BaseUnit__T__T__T__V($thiz.$$undinternal__Lamf_core_model_document_BaseUnit(), alias, fullUrl, relativeUrl);
  return $thiz
}
function $f_Lamf_client_model_document_BaseUnit__cloneUnit__Lamf_client_model_document_BaseUnit($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_document_BaseUnit();
  var branch = new $c_scm_HashMap().init___();
  var from = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this$1, branch));
  var m = $m_Lamf_client_convert_CoreClientConverters$().BaseUnitMatcher__Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$();
  return m.asClient__Lamf_core_model_document_BaseUnit__Lamf_client_model_document_BaseUnit(from)
}
function $f_Lamf_client_model_document_BaseUnit__usage__Lamf_client_model_StrField($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_document_BaseUnit();
  var from = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
}
function $f_Lamf_client_model_document_BaseUnit__sourceVendor__sjs_js_UndefOr($thiz) {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_document_BaseUnit();
  var from = $f_Lamf_core_model_document_BaseUnit__sourceVendor__s_Option(this$1);
  var m = $m_Lamf_client_convert_CoreClientConverters$().VendorMatcher__Lamf_client_convert_CoreBaseConverter$VendorMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
}
function $f_Lamf_client_model_document_BaseUnit__withRaw__T__Lamf_client_model_document_BaseUnit($thiz, raw) {
  var this$1 = $thiz.$$undinternal__Lamf_core_model_document_BaseUnit();
  $f_Lamf_core_model_document_BaseUnit__withRaw__T__Lamf_core_model_document_BaseUnit(this$1, raw);
  return $thiz
}
function $f_Lamf_client_model_document_BaseUnit__raw__sjs_js_UndefOr($thiz) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = $thiz.$$undinternal__Lamf_core_model_document_BaseUnit().raw__s_Option();
  var m = $m_Lamf_client_convert_CoreClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
}
function $f_Lamf_client_model_document_BaseUnit__location__T($thiz) {
  var this$1 = $thiz.$$undinternal__Lamf_core_model_document_BaseUnit();
  var this$2 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$1);
  return $as_T((this$2.isEmpty__Z() ? "" : this$2.get__O()))
}
function $f_Lamf_client_model_document_BaseUnit__modelVersion__Lamf_client_model_StrField($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_document_BaseUnit();
  var from = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_BaseUnitModel$().ModelVersion$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
}
function $f_Lamf_client_model_document_BaseUnit__withId__T__Lamf_client_model_document_BaseUnit($thiz, id) {
  var this$1 = $thiz.$$undinternal__Lamf_core_model_document_BaseUnit();
  $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$1, id);
  return $thiz
}
function $f_Lamf_client_model_document_BaseUnit__findByType__T__sjs_js_Array($thiz, typeId) {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_document_BaseUnit();
  var shapeType = $m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType(typeId).iri__T();
  var from = $f_Lamf_core_model_document_BaseUnit__findByType__T__sc_Seq(this$1, shapeType);
  var m = $m_Lamf_client_convert_CoreClientConverters$().DomainElementMatcher__Lamf_client_convert_DomainElementConverter$DomainElementMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
}
function $is_Lamf_client_model_document_BaseUnit(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_client_model_document_BaseUnit)))
}
function $as_Lamf_client_model_document_BaseUnit(obj) {
  return (($is_Lamf_client_model_document_BaseUnit(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.document.BaseUnit"))
}
function $isArrayOf_Lamf_client_model_document_BaseUnit(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_document_BaseUnit)))
}
function $asArrayOf_Lamf_client_model_document_BaseUnit(obj, depth) {
  return (($isArrayOf_Lamf_client_model_document_BaseUnit(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.document.BaseUnit;", depth))
}
function $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array($thiz) {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_DomainElement();
  var from = $as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field()));
  var m = $m_Lamf_client_convert_CoreClientConverters$().DomainElementMatcher__Lamf_client_convert_DomainElementConverter$DomainElementMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
}
function $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array($thiz) {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_DomainElement();
  var from = $as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field()));
  var m = $m_Lamf_client_convert_CoreClientConverters$().DomainExtensionMatcher__Lamf_client_convert_DomainExtensionConverter$DomainExtensionMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
}
function $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement($thiz, isExternalLink) {
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_DomainElement();
  var field = $m_Lamf_core_metamodel_domain_DomainElementModel$().IsExternalLink$1;
  $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, isExternalLink));
  return $thiz
}
function $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range($thiz) {
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_DomainElement();
  var this$2 = this$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  if (this$2.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var x$1 = $as_Lamf_core_annotations_LexicalInformation(arg1);
    var this$3 = new $c_s_Some().init___O(x$1.range__Lamf_core_parser_Range())
  };
  return $as_Lamf_core_parser_Range((this$3.isEmpty__Z() ? null : this$3.get__O()))
}
function $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement($thiz, id) {
  $thiz.$$undinternal__Lamf_core_model_domain_DomainElement().withId__T__Lamf_core_model_domain_AmfObject(id);
  return $thiz
}
function $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var from = $thiz.$$undinternal__Lamf_core_model_domain_DomainElement().graph__Lamf_core_model_domain_Graph();
  $m_Lamf_client_convert_CoreClientConverters$().GraphDomainConverter__Lamf_client_convert_GraphDomainConverter$GraphDomainConverter$();
  return new $c_Lamf_client_model_domain_Graph().init___Lamf_core_model_domain_Graph(from)
}
function $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement($thiz, extension) {
  var this$2 = $thiz.$$undinternal__Lamf_core_model_domain_DomainElement();
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var m = $m_Lamf_client_convert_CoreClientConverters$().ParameterizedDeclarationMatcher__Lamf_client_convert_DeclarationsConverter$ParameterizedDeclarationMatcher$();
  var extend = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, extension, m).asInternal__sc_Seq();
  var field = $m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field();
  $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, extend));
  return $thiz
}
function $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_DomainElement();
  var from = $as_Lamf_core_model_BoolField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().IsExternalLink$1));
  $m_Lamf_client_convert_CoreClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
}
function $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement($thiz, extensions) {
  var this$2 = $thiz.$$undinternal__Lamf_core_model_domain_DomainElement();
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var m = $m_Lamf_client_convert_CoreClientConverters$().DomainExtensionMatcher__Lamf_client_convert_DomainExtensionConverter$DomainExtensionMatcher$();
  var extensions$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, extensions, m).asInternal__sc_Seq();
  var field = $m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field();
  $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, extensions$1));
  return $thiz
}
function $is_Lamf_client_model_domain_DomainElement(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_client_model_domain_DomainElement)))
}
function $as_Lamf_client_model_domain_DomainElement(obj) {
  return (($is_Lamf_client_model_domain_DomainElement(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.DomainElement"))
}
function $isArrayOf_Lamf_client_model_domain_DomainElement(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_DomainElement)))
}
function $asArrayOf_Lamf_client_model_domain_DomainElement(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_DomainElement(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.DomainElement;", depth))
}
/** @constructor */
function $c_Lamf_client_render_AmfGraphRenderer() {
  $c_Lamf_client_render_Renderer.call(this);
  this.env$2 = null
}
$c_Lamf_client_render_AmfGraphRenderer.prototype = new $h_Lamf_client_render_Renderer();
$c_Lamf_client_render_AmfGraphRenderer.prototype.constructor = $c_Lamf_client_render_AmfGraphRenderer;
/** @constructor */
function $h_Lamf_client_render_AmfGraphRenderer() {
  /*<skip>*/
}
$h_Lamf_client_render_AmfGraphRenderer.prototype = $c_Lamf_client_render_AmfGraphRenderer.prototype;
$c_Lamf_client_render_AmfGraphRenderer.prototype.init___ = (function() {
  $c_Lamf_client_render_AmfGraphRenderer.prototype.init___s_Option.call(this, $m_s_None$());
  return this
});
$c_Lamf_client_render_AmfGraphRenderer.prototype.$$js$exported$meth$generateToBuilder__Lamf_client_model_document_BaseUnit__Lamf_client_render_RenderOptions__Lorg_yaml_builder_DocBuilder__O = (function(unit, options, builder) {
  return this.genToBuilder__Lamf_client_model_document_BaseUnit__Lamf_client_render_RenderOptions__Lorg_yaml_builder_DocBuilder__sjs_js_Promise(unit, options, builder)
});
$c_Lamf_client_render_AmfGraphRenderer.prototype.init___Lamf_client_environment_Environment = (function(env) {
  $c_Lamf_client_render_AmfGraphRenderer.prototype.init___s_Option.call(this, new $c_s_Some().init___O(env));
  return this
});
$c_Lamf_client_render_AmfGraphRenderer.prototype.$$js$exported$meth$generateToBuilder__Lamf_client_model_document_BaseUnit__Lorg_yaml_builder_DocBuilder__O = (function(unit, builder) {
  var options = new $c_Lamf_client_render_RenderOptions().init___();
  return this.genToBuilder__Lamf_client_model_document_BaseUnit__Lamf_client_render_RenderOptions__Lorg_yaml_builder_DocBuilder__sjs_js_Promise(unit, options, builder)
});
$c_Lamf_client_render_AmfGraphRenderer.prototype.init___s_Option = (function(env) {
  this.env$2 = env;
  $c_Lamf_client_render_Renderer.prototype.init___T__T__s_Option.call(this, "AMF Graph", "application/ld+json", env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_graph_AMFGraphPlugin$());
  return this
});
$c_Lamf_client_render_AmfGraphRenderer.prototype.generateToBuilder = (function(arg, arg$2) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 2;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_client_model_document_BaseUnit(arg);
      var prep$2 = $as_Lamf_client_render_RenderOptions(arg$2);
      var prep$3 = $as_Lorg_yaml_builder_DocBuilder(rest[0]);
      return this.$$js$exported$meth$generateToBuilder__Lamf_client_model_document_BaseUnit__Lamf_client_render_RenderOptions__Lorg_yaml_builder_DocBuilder__O(prep, prep$2, prep$3);
      break
    }
    case 0: {
      var prep$4 = $as_Lamf_client_model_document_BaseUnit(arg);
      var prep$5 = $as_Lorg_yaml_builder_DocBuilder(arg$2);
      return this.$$js$exported$meth$generateToBuilder__Lamf_client_model_document_BaseUnit__Lorg_yaml_builder_DocBuilder__O(prep$4, prep$5);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
var $d_Lamf_client_render_AmfGraphRenderer = new $TypeData().initClass({
  Lamf_client_render_AmfGraphRenderer: 0
}, false, "amf.client.render.AmfGraphRenderer", {
  Lamf_client_render_AmfGraphRenderer: 1,
  Lamf_client_render_Renderer: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_client_render_AmfGraphRenderer.prototype.$classData = $d_Lamf_client_render_AmfGraphRenderer;
/** @constructor */
function $c_Lamf_client_render_Aml10Renderer() {
  $c_Lamf_client_render_Renderer.call(this);
  this.env$2 = null
}
$c_Lamf_client_render_Aml10Renderer.prototype = new $h_Lamf_client_render_Renderer();
$c_Lamf_client_render_Aml10Renderer.prototype.constructor = $c_Lamf_client_render_Aml10Renderer;
/** @constructor */
function $h_Lamf_client_render_Aml10Renderer() {
  /*<skip>*/
}
$h_Lamf_client_render_Aml10Renderer.prototype = $c_Lamf_client_render_Aml10Renderer.prototype;
$c_Lamf_client_render_Aml10Renderer.prototype.init___ = (function() {
  $c_Lamf_client_render_Aml10Renderer.prototype.init___T__s_Option.call(this, "application/yaml", $m_s_None$());
  return this
});
$c_Lamf_client_render_Aml10Renderer.prototype.mediaType__T = (function() {
  return this.mediaType$1
});
$c_Lamf_client_render_Aml10Renderer.prototype.$$js$exported$prop$mediaType__O = (function() {
  return this.mediaType$1
});
$c_Lamf_client_render_Aml10Renderer.prototype.init___T = (function(mediaType) {
  $c_Lamf_client_render_Aml10Renderer.prototype.init___T__s_Option.call(this, mediaType, $m_s_None$());
  return this
});
$c_Lamf_client_render_Aml10Renderer.prototype.init___T__s_Option = (function(mediaType, env) {
  this.env$2 = env;
  $c_Lamf_client_render_Renderer.prototype.init___T__T__s_Option.call(this, "AML 1.0", mediaType, env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_vocabularies_AMLPlugin$());
  return this
});
Object.defineProperty($c_Lamf_client_render_Aml10Renderer.prototype, "mediaType", {
  "get": (function() {
    return this.$$js$exported$prop$mediaType__O()
  }),
  "configurable": true
});
var $d_Lamf_client_render_Aml10Renderer = new $TypeData().initClass({
  Lamf_client_render_Aml10Renderer: 0
}, false, "amf.client.render.Aml10Renderer", {
  Lamf_client_render_Aml10Renderer: 1,
  Lamf_client_render_Renderer: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_client_render_Aml10Renderer.prototype.$classData = $d_Lamf_client_render_Aml10Renderer;
/** @constructor */
function $c_Lamf_client_render_Async20Renderer() {
  $c_Lamf_client_render_Renderer.call(this)
}
$c_Lamf_client_render_Async20Renderer.prototype = new $h_Lamf_client_render_Renderer();
$c_Lamf_client_render_Async20Renderer.prototype.constructor = $c_Lamf_client_render_Async20Renderer;
/** @constructor */
function $h_Lamf_client_render_Async20Renderer() {
  /*<skip>*/
}
$h_Lamf_client_render_Async20Renderer.prototype = $c_Lamf_client_render_Async20Renderer.prototype;
$c_Lamf_client_render_Async20Renderer.prototype.init___ = (function() {
  $c_Lamf_client_render_Renderer.prototype.init___T__T__s_Option.call(this, $m_Lamf_core_remote_AsyncApi20$().name$1, "application/yaml", $m_s_None$());
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_webapi_Async20Plugin$());
  return this
});
var $d_Lamf_client_render_Async20Renderer = new $TypeData().initClass({
  Lamf_client_render_Async20Renderer: 0
}, false, "amf.client.render.Async20Renderer", {
  Lamf_client_render_Async20Renderer: 1,
  Lamf_client_render_Renderer: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_client_render_Async20Renderer.prototype.$classData = $d_Lamf_client_render_Async20Renderer;
/** @constructor */
function $c_Lamf_client_render_JsonPayloadRenderer() {
  $c_Lamf_client_render_Renderer.call(this);
  this.env$2 = null
}
$c_Lamf_client_render_JsonPayloadRenderer.prototype = new $h_Lamf_client_render_Renderer();
$c_Lamf_client_render_JsonPayloadRenderer.prototype.constructor = $c_Lamf_client_render_JsonPayloadRenderer;
/** @constructor */
function $h_Lamf_client_render_JsonPayloadRenderer() {
  /*<skip>*/
}
$h_Lamf_client_render_JsonPayloadRenderer.prototype = $c_Lamf_client_render_JsonPayloadRenderer.prototype;
$c_Lamf_client_render_JsonPayloadRenderer.prototype.init___ = (function() {
  $c_Lamf_client_render_JsonPayloadRenderer.prototype.init___s_Option.call(this, $m_s_None$());
  return this
});
$c_Lamf_client_render_JsonPayloadRenderer.prototype.init___Lamf_client_environment_Environment = (function(env) {
  $c_Lamf_client_render_JsonPayloadRenderer.prototype.init___s_Option.call(this, new $c_s_Some().init___O(env));
  return this
});
$c_Lamf_client_render_JsonPayloadRenderer.prototype.init___s_Option = (function(env) {
  this.env$2 = env;
  $c_Lamf_client_render_Renderer.prototype.init___T__T__s_Option.call(this, $m_Lamf_core_remote_Payload$().name$1, "application/payload+json", env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_webapi_PayloadPlugin$());
  return this
});
var $d_Lamf_client_render_JsonPayloadRenderer = new $TypeData().initClass({
  Lamf_client_render_JsonPayloadRenderer: 0
}, false, "amf.client.render.JsonPayloadRenderer", {
  Lamf_client_render_JsonPayloadRenderer: 1,
  Lamf_client_render_Renderer: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_client_render_JsonPayloadRenderer.prototype.$classData = $d_Lamf_client_render_JsonPayloadRenderer;
/** @constructor */
function $c_Lamf_client_render_JsonldRenderer() {
  $c_Lamf_client_render_Renderer.call(this);
  this.env$2 = null
}
$c_Lamf_client_render_JsonldRenderer.prototype = new $h_Lamf_client_render_Renderer();
$c_Lamf_client_render_JsonldRenderer.prototype.constructor = $c_Lamf_client_render_JsonldRenderer;
/** @constructor */
function $h_Lamf_client_render_JsonldRenderer() {
  /*<skip>*/
}
$h_Lamf_client_render_JsonldRenderer.prototype = $c_Lamf_client_render_JsonldRenderer.prototype;
$c_Lamf_client_render_JsonldRenderer.prototype.init___ = (function() {
  $c_Lamf_client_render_JsonldRenderer.prototype.init___s_Option.call(this, $m_s_None$());
  return this
});
$c_Lamf_client_render_JsonldRenderer.prototype.init___Lamf_client_environment_Environment = (function(env) {
  $c_Lamf_client_render_JsonldRenderer.prototype.init___s_Option.call(this, new $c_s_Some().init___O(env));
  return this
});
$c_Lamf_client_render_JsonldRenderer.prototype.init___s_Option = (function(env) {
  this.env$2 = env;
  $c_Lamf_client_render_Renderer.prototype.init___T__T__s_Option.call(this, $m_Lamf_core_remote_Amf$().name$1, "application/ld+json", env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_graph_AMFGraphPlugin$());
  return this
});
var $d_Lamf_client_render_JsonldRenderer = new $TypeData().initClass({
  Lamf_client_render_JsonldRenderer: 0
}, false, "amf.client.render.JsonldRenderer", {
  Lamf_client_render_JsonldRenderer: 1,
  Lamf_client_render_Renderer: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_client_render_JsonldRenderer.prototype.$classData = $d_Lamf_client_render_JsonldRenderer;
/** @constructor */
function $c_Lamf_client_render_Oas20Renderer() {
  $c_Lamf_client_render_Renderer.call(this);
  this.env$2 = null
}
$c_Lamf_client_render_Oas20Renderer.prototype = new $h_Lamf_client_render_Renderer();
$c_Lamf_client_render_Oas20Renderer.prototype.constructor = $c_Lamf_client_render_Oas20Renderer;
/** @constructor */
function $h_Lamf_client_render_Oas20Renderer() {
  /*<skip>*/
}
$h_Lamf_client_render_Oas20Renderer.prototype = $c_Lamf_client_render_Oas20Renderer.prototype;
$c_Lamf_client_render_Oas20Renderer.prototype.init___ = (function() {
  $c_Lamf_client_render_Oas20Renderer.prototype.init___s_Option.call(this, $m_s_None$());
  return this
});
$c_Lamf_client_render_Oas20Renderer.prototype.init___Lamf_client_environment_Environment = (function(env) {
  $c_Lamf_client_render_Oas20Renderer.prototype.init___s_Option.call(this, new $c_s_Some().init___O(env));
  return this
});
$c_Lamf_client_render_Oas20Renderer.prototype.init___s_Option = (function(env) {
  this.env$2 = env;
  $c_Lamf_client_render_Renderer.prototype.init___T__T__s_Option.call(this, $m_Lamf_core_remote_Oas20$().name$1, "application/json", env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_webapi_Oas20Plugin$());
  return this
});
var $d_Lamf_client_render_Oas20Renderer = new $TypeData().initClass({
  Lamf_client_render_Oas20Renderer: 0
}, false, "amf.client.render.Oas20Renderer", {
  Lamf_client_render_Oas20Renderer: 1,
  Lamf_client_render_Renderer: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_client_render_Oas20Renderer.prototype.$classData = $d_Lamf_client_render_Oas20Renderer;
/** @constructor */
function $c_Lamf_client_render_Oas30Renderer() {
  $c_Lamf_client_render_Renderer.call(this);
  this.env$2 = null
}
$c_Lamf_client_render_Oas30Renderer.prototype = new $h_Lamf_client_render_Renderer();
$c_Lamf_client_render_Oas30Renderer.prototype.constructor = $c_Lamf_client_render_Oas30Renderer;
/** @constructor */
function $h_Lamf_client_render_Oas30Renderer() {
  /*<skip>*/
}
$h_Lamf_client_render_Oas30Renderer.prototype = $c_Lamf_client_render_Oas30Renderer.prototype;
$c_Lamf_client_render_Oas30Renderer.prototype.init___ = (function() {
  $c_Lamf_client_render_Oas30Renderer.prototype.init___s_Option.call(this, $m_s_None$());
  return this
});
$c_Lamf_client_render_Oas30Renderer.prototype.init___Lamf_client_environment_Environment = (function(env) {
  $c_Lamf_client_render_Oas30Renderer.prototype.init___s_Option.call(this, new $c_s_Some().init___O(env));
  return this
});
$c_Lamf_client_render_Oas30Renderer.prototype.init___s_Option = (function(env) {
  this.env$2 = env;
  $c_Lamf_client_render_Renderer.prototype.init___T__T__s_Option.call(this, $m_Lamf_core_remote_Oas30$().name$1, "application/json", env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_webapi_Oas30Plugin$());
  return this
});
var $d_Lamf_client_render_Oas30Renderer = new $TypeData().initClass({
  Lamf_client_render_Oas30Renderer: 0
}, false, "amf.client.render.Oas30Renderer", {
  Lamf_client_render_Oas30Renderer: 1,
  Lamf_client_render_Renderer: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_client_render_Oas30Renderer.prototype.$classData = $d_Lamf_client_render_Oas30Renderer;
/** @constructor */
function $c_Lamf_client_render_Raml08Renderer() {
  $c_Lamf_client_render_Renderer.call(this);
  this.env$2 = null
}
$c_Lamf_client_render_Raml08Renderer.prototype = new $h_Lamf_client_render_Renderer();
$c_Lamf_client_render_Raml08Renderer.prototype.constructor = $c_Lamf_client_render_Raml08Renderer;
/** @constructor */
function $h_Lamf_client_render_Raml08Renderer() {
  /*<skip>*/
}
$h_Lamf_client_render_Raml08Renderer.prototype = $c_Lamf_client_render_Raml08Renderer.prototype;
$c_Lamf_client_render_Raml08Renderer.prototype.init___ = (function() {
  $c_Lamf_client_render_Raml08Renderer.prototype.init___s_Option.call(this, $m_s_None$());
  return this
});
$c_Lamf_client_render_Raml08Renderer.prototype.init___Lamf_client_environment_Environment = (function(env) {
  $c_Lamf_client_render_Raml08Renderer.prototype.init___s_Option.call(this, new $c_s_Some().init___O(env));
  return this
});
$c_Lamf_client_render_Raml08Renderer.prototype.init___s_Option = (function(env) {
  this.env$2 = env;
  $c_Lamf_client_render_Renderer.prototype.init___T__T__s_Option.call(this, $m_Lamf_core_remote_Raml08$().name$1, "application/yaml", env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_webapi_Raml08Plugin$());
  return this
});
var $d_Lamf_client_render_Raml08Renderer = new $TypeData().initClass({
  Lamf_client_render_Raml08Renderer: 0
}, false, "amf.client.render.Raml08Renderer", {
  Lamf_client_render_Raml08Renderer: 1,
  Lamf_client_render_Renderer: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_client_render_Raml08Renderer.prototype.$classData = $d_Lamf_client_render_Raml08Renderer;
/** @constructor */
function $c_Lamf_client_render_Raml10Renderer() {
  $c_Lamf_client_render_Renderer.call(this);
  this.env$2 = null
}
$c_Lamf_client_render_Raml10Renderer.prototype = new $h_Lamf_client_render_Renderer();
$c_Lamf_client_render_Raml10Renderer.prototype.constructor = $c_Lamf_client_render_Raml10Renderer;
/** @constructor */
function $h_Lamf_client_render_Raml10Renderer() {
  /*<skip>*/
}
$h_Lamf_client_render_Raml10Renderer.prototype = $c_Lamf_client_render_Raml10Renderer.prototype;
$c_Lamf_client_render_Raml10Renderer.prototype.init___ = (function() {
  $c_Lamf_client_render_Raml10Renderer.prototype.init___s_Option.call(this, $m_s_None$());
  return this
});
$c_Lamf_client_render_Raml10Renderer.prototype.init___Lamf_client_environment_Environment = (function(env) {
  $c_Lamf_client_render_Raml10Renderer.prototype.init___s_Option.call(this, new $c_s_Some().init___O(env));
  return this
});
$c_Lamf_client_render_Raml10Renderer.prototype.init___s_Option = (function(env) {
  this.env$2 = env;
  $c_Lamf_client_render_Renderer.prototype.init___T__T__s_Option.call(this, $m_Lamf_core_remote_Raml10$().name$1, "application/yaml", env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_webapi_Raml10Plugin$());
  return this
});
var $d_Lamf_client_render_Raml10Renderer = new $TypeData().initClass({
  Lamf_client_render_Raml10Renderer: 0
}, false, "amf.client.render.Raml10Renderer", {
  Lamf_client_render_Raml10Renderer: 1,
  Lamf_client_render_Renderer: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_client_render_Raml10Renderer.prototype.$classData = $d_Lamf_client_render_Raml10Renderer;
/** @constructor */
function $c_Lamf_client_render_YamlPayloadRenderer() {
  $c_Lamf_client_render_Renderer.call(this);
  this.env$2 = null
}
$c_Lamf_client_render_YamlPayloadRenderer.prototype = new $h_Lamf_client_render_Renderer();
$c_Lamf_client_render_YamlPayloadRenderer.prototype.constructor = $c_Lamf_client_render_YamlPayloadRenderer;
/** @constructor */
function $h_Lamf_client_render_YamlPayloadRenderer() {
  /*<skip>*/
}
$h_Lamf_client_render_YamlPayloadRenderer.prototype = $c_Lamf_client_render_YamlPayloadRenderer.prototype;
$c_Lamf_client_render_YamlPayloadRenderer.prototype.init___ = (function() {
  $c_Lamf_client_render_YamlPayloadRenderer.prototype.init___s_Option.call(this, $m_s_None$());
  return this
});
$c_Lamf_client_render_YamlPayloadRenderer.prototype.init___Lamf_client_environment_Environment = (function(env) {
  $c_Lamf_client_render_YamlPayloadRenderer.prototype.init___s_Option.call(this, new $c_s_Some().init___O(env));
  return this
});
$c_Lamf_client_render_YamlPayloadRenderer.prototype.init___s_Option = (function(env) {
  this.env$2 = env;
  $c_Lamf_client_render_Renderer.prototype.init___T__T__s_Option.call(this, $m_Lamf_core_remote_Payload$().name$1, "application/payload+yaml", env);
  $m_Lamf_core_registries_AMFPluginsRegistry$().registerDocumentPlugin__Lamf_client_plugins_AMFDocumentPlugin__V($m_Lamf_plugins_document_webapi_PayloadPlugin$());
  return this
});
var $d_Lamf_client_render_YamlPayloadRenderer = new $TypeData().initClass({
  Lamf_client_render_YamlPayloadRenderer: 0
}, false, "amf.client.render.YamlPayloadRenderer", {
  Lamf_client_render_YamlPayloadRenderer: 1,
  Lamf_client_render_Renderer: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_client_render_YamlPayloadRenderer.prototype.$classData = $d_Lamf_client_render_YamlPayloadRenderer;
/** @constructor */
function $c_Lamf_core_Root$() {
  $c_O.call(this)
}
$c_Lamf_core_Root$.prototype = new $h_O();
$c_Lamf_core_Root$.prototype.constructor = $c_Lamf_core_Root$;
/** @constructor */
function $h_Lamf_core_Root$() {
  /*<skip>*/
}
$h_Lamf_core_Root$.prototype = $c_Lamf_core_Root$.prototype;
$c_Lamf_core_Root$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_Root$.prototype.apply__Lamf_core_parser_ParsedDocument__T__T__sc_Seq__Lamf_core_parser_ReferenceKind__T__Lamf_core_Root = (function(parsed, location, mediatype, references, referenceKind, raw) {
  return new $c_Lamf_core_Root().init___Lamf_core_parser_ParsedDocument__T__T__sc_Seq__Lamf_core_parser_ReferenceKind__T(parsed, new $c_Lamf_core_utils_package$AmfStrings().init___T(location).normalizeUrl__T(), mediatype, references, referenceKind, raw)
});
var $d_Lamf_core_Root$ = new $TypeData().initClass({
  Lamf_core_Root$: 0
}, false, "amf.core.Root$", {
  Lamf_core_Root$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_Root$.prototype.$classData = $d_Lamf_core_Root$;
var $n_Lamf_core_Root$ = (void 0);
function $m_Lamf_core_Root$() {
  if ((!$n_Lamf_core_Root$)) {
    $n_Lamf_core_Root$ = new $c_Lamf_core_Root$().init___()
  };
  return $n_Lamf_core_Root$
}
function $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration($thiz, value) {
  return $thiz.amf$core$annotations$ErrorDeclaration$$super$withId__T__Lamf_core_annotations_ErrorDeclaration((("" + $thiz.namespace__T()) + value))
}
function $is_Lamf_core_annotations_ErrorDeclaration(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_annotations_ErrorDeclaration)))
}
function $as_Lamf_core_annotations_ErrorDeclaration(obj) {
  return (($is_Lamf_core_annotations_ErrorDeclaration(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.ErrorDeclaration"))
}
function $isArrayOf_Lamf_core_annotations_ErrorDeclaration(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_ErrorDeclaration)))
}
function $asArrayOf_Lamf_core_annotations_ErrorDeclaration(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_ErrorDeclaration(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.ErrorDeclaration;", depth))
}
/** @constructor */
function $c_Lamf_core_client_ParserConfig$() {
  $c_O.call(this);
  this.PARSE$1 = null;
  this.TRANSLATE$1 = null;
  this.REPL$1 = null;
  this.VALIDATE$1 = null;
  this.PATCH$1 = null
}
$c_Lamf_core_client_ParserConfig$.prototype = new $h_O();
$c_Lamf_core_client_ParserConfig$.prototype.constructor = $c_Lamf_core_client_ParserConfig$;
/** @constructor */
function $h_Lamf_core_client_ParserConfig$() {
  /*<skip>*/
}
$h_Lamf_core_client_ParserConfig$.prototype = $c_Lamf_core_client_ParserConfig$.prototype;
$c_Lamf_core_client_ParserConfig$.prototype.init___ = (function() {
  this.PARSE$1 = "parse";
  this.TRANSLATE$1 = "translate";
  this.REPL$1 = "repl";
  this.VALIDATE$1 = "validate";
  this.PATCH$1 = "patch";
  return this
});
var $d_Lamf_core_client_ParserConfig$ = new $TypeData().initClass({
  Lamf_core_client_ParserConfig$: 0
}, false, "amf.core.client.ParserConfig$", {
  Lamf_core_client_ParserConfig$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_client_ParserConfig$.prototype.$classData = $d_Lamf_core_client_ParserConfig$;
var $n_Lamf_core_client_ParserConfig$ = (void 0);
function $m_Lamf_core_client_ParserConfig$() {
  if ((!$n_Lamf_core_client_ParserConfig$)) {
    $n_Lamf_core_client_ParserConfig$ = new $c_Lamf_core_client_ParserConfig$().init___()
  };
  return $n_Lamf_core_client_ParserConfig$
}
/** @constructor */
function $c_Lamf_core_client_StdOutWriter$() {
  $c_Lamf_core_client_ProcWriter.call(this);
  this.platform$2 = null
}
$c_Lamf_core_client_StdOutWriter$.prototype = new $h_Lamf_core_client_ProcWriter();
$c_Lamf_core_client_StdOutWriter$.prototype.constructor = $c_Lamf_core_client_StdOutWriter$;
/** @constructor */
function $h_Lamf_core_client_StdOutWriter$() {
  /*<skip>*/
}
$h_Lamf_core_client_StdOutWriter$.prototype = $c_Lamf_core_client_StdOutWriter$.prototype;
$c_Lamf_core_client_StdOutWriter$.prototype.init___ = (function() {
  $n_Lamf_core_client_StdOutWriter$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$2 = this$1.platform$1;
  return this
});
$c_Lamf_core_client_StdOutWriter$.prototype.print__T__V = (function(s) {
  $m_jl_System$().out$1.println__T__V(s)
});
$c_Lamf_core_client_StdOutWriter$.prototype.print__jl_Throwable__V = (function(e) {
  var this$2 = $m_jl_System$().out$1;
  this$2.java$lang$JSConsoleBasedPrintStream$$printString__T__V((e + "\n"))
});
var $d_Lamf_core_client_StdOutWriter$ = new $TypeData().initClass({
  Lamf_core_client_StdOutWriter$: 0
}, false, "amf.core.client.StdOutWriter$", {
  Lamf_core_client_StdOutWriter$: 1,
  Lamf_core_client_ProcWriter: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_core_client_StdOutWriter$.prototype.$classData = $d_Lamf_core_client_StdOutWriter$;
var $n_Lamf_core_client_StdOutWriter$ = (void 0);
function $m_Lamf_core_client_StdOutWriter$() {
  if ((!$n_Lamf_core_client_StdOutWriter$)) {
    $n_Lamf_core_client_StdOutWriter$ = new $c_Lamf_core_client_StdOutWriter$().init___()
  };
  return $n_Lamf_core_client_StdOutWriter$
}
/** @constructor */
function $c_Lamf_core_emitter_SpecOrdering$() {
  $c_O.call(this)
}
$c_Lamf_core_emitter_SpecOrdering$.prototype = new $h_O();
$c_Lamf_core_emitter_SpecOrdering$.prototype.constructor = $c_Lamf_core_emitter_SpecOrdering$;
/** @constructor */
function $h_Lamf_core_emitter_SpecOrdering$() {
  /*<skip>*/
}
$h_Lamf_core_emitter_SpecOrdering$.prototype = $c_Lamf_core_emitter_SpecOrdering$.prototype;
$c_Lamf_core_emitter_SpecOrdering$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_emitter_SpecOrdering$.prototype.ordering__Lamf_core_remote_Vendor__Lamf_core_parser_Annotations__Lamf_core_emitter_SpecOrdering = (function(target, annotations) {
  var x1 = annotations.find__jl_Class__s_Option($d_Lamf_core_annotations_SourceVendor.getClassOf());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var p3 = $as_Lamf_core_annotations_SourceVendor(x2.value$2);
    if ((p3 !== null)) {
      var source = p3.vendor$1;
      var x$2 = $m_Lamf_core_remote_Amf$();
      if ((((source !== null) && (source === x$2)) || this.equivalent__p1__Lamf_core_remote_Vendor__Lamf_core_remote_Vendor__Z(source, target))) {
        return $m_Lamf_core_emitter_SpecOrdering$Lexical$()
      }
    }
  };
  return $m_Lamf_core_emitter_SpecOrdering$Default$()
});
$c_Lamf_core_emitter_SpecOrdering$.prototype.equivalent__p1__Lamf_core_remote_Vendor__Lamf_core_remote_Vendor__Z = (function(left, right) {
  return ($is_Lamf_core_remote_Oas(left) ? $is_Lamf_core_remote_Oas(right) : ($is_Lamf_core_remote_Raml(left) ? $is_Lamf_core_remote_Raml(right) : ($is_Lamf_core_remote_Async(left) && $is_Lamf_core_remote_Async(right))))
});
var $d_Lamf_core_emitter_SpecOrdering$ = new $TypeData().initClass({
  Lamf_core_emitter_SpecOrdering$: 0
}, false, "amf.core.emitter.SpecOrdering$", {
  Lamf_core_emitter_SpecOrdering$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_emitter_SpecOrdering$.prototype.$classData = $d_Lamf_core_emitter_SpecOrdering$;
var $n_Lamf_core_emitter_SpecOrdering$ = (void 0);
function $m_Lamf_core_emitter_SpecOrdering$() {
  if ((!$n_Lamf_core_emitter_SpecOrdering$)) {
    $n_Lamf_core_emitter_SpecOrdering$ = new $c_Lamf_core_emitter_SpecOrdering$().init___()
  };
  return $n_Lamf_core_emitter_SpecOrdering$
}
/** @constructor */
function $c_Lamf_core_errorhandling_AmfStaticReportBuilder() {
  $c_Lamf_core_errorhandling_AmfReportBuilder.call(this);
  this.model$2 = null;
  this.profileName$2 = null;
  this.validations$2 = null
}
$c_Lamf_core_errorhandling_AmfStaticReportBuilder.prototype = new $h_Lamf_core_errorhandling_AmfReportBuilder();
$c_Lamf_core_errorhandling_AmfStaticReportBuilder.prototype.constructor = $c_Lamf_core_errorhandling_AmfStaticReportBuilder;
/** @constructor */
function $h_Lamf_core_errorhandling_AmfStaticReportBuilder() {
  /*<skip>*/
}
$h_Lamf_core_errorhandling_AmfStaticReportBuilder.prototype = $c_Lamf_core_errorhandling_AmfStaticReportBuilder.prototype;
$c_Lamf_core_errorhandling_AmfStaticReportBuilder.prototype.buildFromStatic__Lamf_core_validation_AMFValidationReport = (function() {
  var this$1 = this.model$2;
  var this$2 = this$1.amf$core$model$document$BaseUnit$$run__s_Option();
  if (this$2.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var parserRun = $uI(arg1);
    var this$3 = new $c_s_Some().init___O($m_Lamf_core_errorhandling_StaticErrorCollector$().getRun__I__sc_Seq(parserRun))
  };
  var jsx$2 = $as_sc_TraversableLike((this$3.isEmpty__Z() ? $m_sci_Nil$() : this$3.get__O()));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_validation_AMFValidationResult(x$2$2);
      var this$4 = this$3$1.profileName$2;
      var messageStyle = this$4.amf$ProfileName$$m$1;
      var validations = this$3$1.validations$2;
      return $f_Lamf_core_validation_ValidationResultProcessor__processAggregatedResult__Lamf_core_validation_AMFValidationResult__Lamf_MessageStyle__Lamf_core_validation_EffectiveValidations__Lamf_core_validation_AMFValidationResult(this$3$1, x$2, messageStyle, validations)
    })
  })(this));
  var this$5 = $m_sc_Seq$();
  var results = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2));
  return $c_Lamf_core_errorhandling_AmfReportBuilder.prototype.buildReport__sc_Seq__Lamf_core_validation_AMFValidationReport.call(this, results)
});
$c_Lamf_core_errorhandling_AmfStaticReportBuilder.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_ProfileName = (function(model, profileName) {
  this.model$2 = model;
  this.profileName$2 = profileName;
  $c_Lamf_core_errorhandling_AmfReportBuilder.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_ProfileName.call(this, model, profileName);
  this.validations$2 = new $c_Lamf_core_validation_EffectiveValidations().init___scm_HashMap__scm_HashMap__scm_HashMap__scm_HashMap__scm_HashMap($as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()))).someEffective__Lamf_core_validation_core_ValidationProfile__Lamf_core_validation_EffectiveValidations($m_Lamf_plugins_features_validation_ParserSideValidationProfiler$().parserSideValidationsProfile__Lamf_ProfileName__Lamf_core_validation_core_ValidationProfile(profileName));
  return this
});
var $d_Lamf_core_errorhandling_AmfStaticReportBuilder = new $TypeData().initClass({
  Lamf_core_errorhandling_AmfStaticReportBuilder: 0
}, false, "amf.core.errorhandling.AmfStaticReportBuilder", {
  Lamf_core_errorhandling_AmfStaticReportBuilder: 1,
  Lamf_core_errorhandling_AmfReportBuilder: 1,
  O: 1,
  Lamf_core_validation_ValidationResultProcessor: 1
});
$c_Lamf_core_errorhandling_AmfStaticReportBuilder.prototype.$classData = $d_Lamf_core_errorhandling_AmfStaticReportBuilder;
/** @constructor */
function $c_Lamf_core_errorhandling_UnhandledErrorHandler$() {
  $c_O.call(this)
}
$c_Lamf_core_errorhandling_UnhandledErrorHandler$.prototype = new $h_O();
$c_Lamf_core_errorhandling_UnhandledErrorHandler$.prototype.constructor = $c_Lamf_core_errorhandling_UnhandledErrorHandler$;
/** @constructor */
function $h_Lamf_core_errorhandling_UnhandledErrorHandler$() {
  /*<skip>*/
}
$h_Lamf_core_errorhandling_UnhandledErrorHandler$.prototype = $c_Lamf_core_errorhandling_UnhandledErrorHandler$.prototype;
$c_Lamf_core_errorhandling_UnhandledErrorHandler$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_errorhandling_UnhandledErrorHandler$.prototype.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V = (function(specification, node, property, message, lexical, location) {
  var id = specification.id$1;
  var level = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  $f_Lamf_core_errorhandling_UnhandledErrorHandler__reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(this, id, node, property, message, lexical, level, location)
});
$c_Lamf_core_errorhandling_UnhandledErrorHandler$.prototype.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V = (function(id, node, property, message, lexical, level, location) {
  $f_Lamf_core_errorhandling_UnhandledErrorHandler__reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(this, id, node, property, message, lexical, level, location)
});
var $d_Lamf_core_errorhandling_UnhandledErrorHandler$ = new $TypeData().initClass({
  Lamf_core_errorhandling_UnhandledErrorHandler$: 0
}, false, "amf.core.errorhandling.UnhandledErrorHandler$", {
  Lamf_core_errorhandling_UnhandledErrorHandler$: 1,
  O: 1,
  Lamf_core_errorhandling_UnhandledErrorHandler: 1,
  Lamf_core_errorhandling_ErrorHandler: 1
});
$c_Lamf_core_errorhandling_UnhandledErrorHandler$.prototype.$classData = $d_Lamf_core_errorhandling_UnhandledErrorHandler$;
var $n_Lamf_core_errorhandling_UnhandledErrorHandler$ = (void 0);
function $m_Lamf_core_errorhandling_UnhandledErrorHandler$() {
  if ((!$n_Lamf_core_errorhandling_UnhandledErrorHandler$)) {
    $n_Lamf_core_errorhandling_UnhandledErrorHandler$ = new $c_Lamf_core_errorhandling_UnhandledErrorHandler$().init___()
  };
  return $n_Lamf_core_errorhandling_UnhandledErrorHandler$
}
/** @constructor */
function $c_Lamf_core_lexer_CharSequenceStream() {
  $c_Lamf_core_lexer_CharStream.call(this);
  this.data$2 = null;
  this.startOffset$2 = 0;
  this.endOffset$2 = 0;
  this.sourceName$2 = null;
  this.column$und$2 = 0;
  this.line$2 = 0;
  this.pointer$2 = 0
}
$c_Lamf_core_lexer_CharSequenceStream.prototype = new $h_Lamf_core_lexer_CharStream();
$c_Lamf_core_lexer_CharSequenceStream.prototype.constructor = $c_Lamf_core_lexer_CharSequenceStream;
/** @constructor */
function $h_Lamf_core_lexer_CharSequenceStream() {
  /*<skip>*/
}
$h_Lamf_core_lexer_CharSequenceStream.prototype = $c_Lamf_core_lexer_CharSequenceStream.prototype;
$c_Lamf_core_lexer_CharSequenceStream.prototype.init___jl_CharSequence__I__I__T = (function(data, startOffset, endOffset, sourceName) {
  this.data$2 = data;
  this.startOffset$2 = startOffset;
  this.endOffset$2 = endOffset;
  this.sourceName$2 = sourceName;
  this.column$und$2 = 0;
  this.line$2 = 1;
  this.pointer$2 = startOffset;
  return this
});
$c_Lamf_core_lexer_CharSequenceStream.prototype.subSequence__I__I__jl_CharSequence = (function(start, end) {
  if ((!(((start >= this.startOffset$2) && (end <= this.endOffset$2)) && (start <= end)))) {
    throw new $c_jl_IllegalArgumentException().init___T(((("Invalid sub-sequence start: " + start) + ", end: ") + end))
  };
  return $charSequenceSubSequence(this.data$2, start, end)
});
$c_Lamf_core_lexer_CharSequenceStream.prototype.toString__T = (function() {
  return $objectToString(this.data$2)
});
$c_Lamf_core_lexer_CharSequenceStream.prototype.length__I = (function() {
  return ((this.endOffset$2 - this.startOffset$2) | 0)
});
$c_Lamf_core_lexer_CharSequenceStream.prototype.charAt__I__C = (function(index) {
  return $charSequenceCharAt(this.data$2, index)
});
$c_Lamf_core_lexer_CharSequenceStream.prototype.init___T__jl_CharSequence = (function(sourceName, data) {
  $c_Lamf_core_lexer_CharSequenceStream.prototype.init___jl_CharSequence__I__I__T.call(this, data, 0, $charSequenceLength(data), sourceName);
  return this
});
var $d_Lamf_core_lexer_CharSequenceStream = new $TypeData().initClass({
  Lamf_core_lexer_CharSequenceStream: 0
}, false, "amf.core.lexer.CharSequenceStream", {
  Lamf_core_lexer_CharSequenceStream: 1,
  Lamf_core_lexer_CharStream: 1,
  O: 1,
  jl_CharSequence: 1
});
$c_Lamf_core_lexer_CharSequenceStream.prototype.$classData = $d_Lamf_core_lexer_CharSequenceStream;
function $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "root"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "root", "Indicates if the base unit represents the root of the document model obtained from parsing", $m_sci_Nil$()), true));
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "location"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "location", "Location of the metadata document that generated this base unit", $m_sci_Nil$()), true));
  var jsx$3 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_document_BaseUnitModel$());
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "references"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "references", "references across base units", $m_sci_Nil$()), true));
  var jsx$7 = $m_Lamf_core_metamodel_Type$Str$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var jsx$6 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "usage");
  var jsx$5 = $m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1;
  var jsx$4 = $m_sc_Seq$();
  var this$12 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$12, "description").iri__T()];
  $thiz.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$7, jsx$6, new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq(jsx$5, "usage", "Human readable description of the unit", $as_sc_Seq(jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))), true));
  var jsx$8 = $m_Lamf_core_metamodel_Type$Iri$();
  var ns = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  $thiz.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$8, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns, "describedBy"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "described by", "Link to the AML dialect describing a particular subgraph of information", $m_sci_Nil$()), true));
  var jsx$9 = $m_Lamf_core_metamodel_Type$Str$();
  var this$18 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$9, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$18, "version"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "version", "Version of the current model", $m_sci_Nil$()), true))
}
function $is_Lamf_core_metamodel_document_BaseUnitModel(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_metamodel_document_BaseUnitModel)))
}
function $as_Lamf_core_metamodel_document_BaseUnitModel(obj) {
  return (($is_Lamf_core_metamodel_document_BaseUnitModel(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.metamodel.document.BaseUnitModel"))
}
function $isArrayOf_Lamf_core_metamodel_document_BaseUnitModel(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_metamodel_document_BaseUnitModel)))
}
function $asArrayOf_Lamf_core_metamodel_document_BaseUnitModel(obj, depth) {
  return (($isArrayOf_Lamf_core_metamodel_document_BaseUnitModel(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.metamodel.document.BaseUnitModel;", depth))
}
/** @constructor */
function $c_Lamf_core_metamodel_document_SourceMapModel$() {
  $c_O.call(this);
  this.Element$1 = null;
  this.Value$1 = null;
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null
}
$c_Lamf_core_metamodel_document_SourceMapModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_document_SourceMapModel$.prototype.constructor = $c_Lamf_core_metamodel_document_SourceMapModel$;
/** @constructor */
function $h_Lamf_core_metamodel_document_SourceMapModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_document_SourceMapModel$.prototype = $c_Lamf_core_metamodel_document_SourceMapModel$.prototype;
$c_Lamf_core_metamodel_document_SourceMapModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_document_SourceMapModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().SourceMaps$1;
  this.Element$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "element"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "element", "Label indicating the type of source map information", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().SourceMaps$1;
  this.Value$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "value"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "value", "Value for the source map.", $m_sci_Nil$()), true);
  this.fields$1 = $m_sci_Nil$();
  $m_sci_List$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().SourceMaps$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "SourceMap")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$12 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$12);
    i = (((-1) + i) | 0)
  };
  this.type$1 = result;
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "Source Map", "SourceMaps include tags with syntax specific information obtained when parsing a particular specification syntax like RAML or OpenAPI.\nIt can be used to re-generate the document from the RDF model with a similar syntax", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_document_SourceMapModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_document_SourceMapModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_document_SourceMapModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_core_metamodel_document_SourceMapModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_core_metamodel_document_SourceMapModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_document_SourceMapModel$: 0
}, false, "amf.core.metamodel.document.SourceMapModel$", {
  Lamf_core_metamodel_document_SourceMapModel$: 1,
  O: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1
});
$c_Lamf_core_metamodel_document_SourceMapModel$.prototype.$classData = $d_Lamf_core_metamodel_document_SourceMapModel$;
var $n_Lamf_core_metamodel_document_SourceMapModel$ = (void 0);
function $m_Lamf_core_metamodel_document_SourceMapModel$() {
  if ((!$n_Lamf_core_metamodel_document_SourceMapModel$)) {
    $n_Lamf_core_metamodel_document_SourceMapModel$ = new $c_Lamf_core_metamodel_document_SourceMapModel$().init___()
  };
  return $n_Lamf_core_metamodel_document_SourceMapModel$
}
function $f_Lamf_core_metamodel_domain_DomainElementModel__Extends__Lamf_core_metamodel_Field($thiz) {
  var jsx$1 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_domain_DomainElementModel$());
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  return new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "extends"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "extends", "Entity that is going to be extended overlaying or adding additional information\nThe type of the relationship provide the semantics about thow the referenced and referencer elements must be combined when generating the domain model from the document model.", $m_sci_Nil$()), true)
}
function $f_Lamf_core_metamodel_domain_DomainElementModel__CustomDomainProperties__Lamf_core_metamodel_Field($thiz) {
  var jsx$1 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$());
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  return new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "customDomainProperties"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "custom domain properties", "Extensions provided for a particular domain element.", $m_sci_Nil$()), true)
}
function $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_document_SourceMapModel$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().SourceMaps$1;
  $thiz.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "sources"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "source", "Indicates that this parsing Unit has SourceMaps", $m_sci_Nil$()), true));
  var jsx$2 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "isExternalLink"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "isExternalLink", "Marks this domain element as a reference to the actual element identified by the same URI", $m_sci_Nil$()), true))
}
function $is_Lamf_core_metamodel_domain_DomainElementModel(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_metamodel_domain_DomainElementModel)))
}
function $as_Lamf_core_metamodel_domain_DomainElementModel(obj) {
  return (($is_Lamf_core_metamodel_domain_DomainElementModel(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.metamodel.domain.DomainElementModel"))
}
function $isArrayOf_Lamf_core_metamodel_domain_DomainElementModel(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_metamodel_domain_DomainElementModel)))
}
function $asArrayOf_Lamf_core_metamodel_domain_DomainElementModel(obj, depth) {
  return (($isArrayOf_Lamf_core_metamodel_domain_DomainElementModel(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.metamodel.domain.DomainElementModel;", depth))
}
function $is_Lamf_core_model_AnyField(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_AnyField)))
}
function $as_Lamf_core_model_AnyField(obj) {
  return (($is_Lamf_core_model_AnyField(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.AnyField"))
}
function $isArrayOf_Lamf_core_model_AnyField(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_AnyField)))
}
function $asArrayOf_Lamf_core_model_AnyField(obj, depth) {
  return (($isArrayOf_Lamf_core_model_AnyField(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.AnyField;", depth))
}
function $f_Lamf_core_model_StrField__isNullOrEmpty__Z($thiz) {
  var this$1 = $thiz.option$1;
  if (this$1.isEmpty__Z()) {
    return true
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_T(arg1);
    if ((x$1 === null)) {
      throw new $c_jl_NullPointerException().init___()
    };
    return (x$1 === "")
  }
}
function $f_Lamf_core_model_StrField__nonEmpty__Z($thiz) {
  return (!$f_Lamf_core_model_StrField__isNullOrEmpty__Z($thiz))
}
function $is_Lamf_core_model_StrField(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_StrField)))
}
function $as_Lamf_core_model_StrField(obj) {
  return (($is_Lamf_core_model_StrField(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.StrField"))
}
function $isArrayOf_Lamf_core_model_StrField(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_StrField)))
}
function $asArrayOf_Lamf_core_model_StrField(obj, depth) {
  return (($isArrayOf_Lamf_core_model_StrField(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.StrField;", depth))
}
/** @constructor */
function $c_Lamf_core_model_document_PayloadFragment$() {
  $c_O.call(this)
}
$c_Lamf_core_model_document_PayloadFragment$.prototype = new $h_O();
$c_Lamf_core_model_document_PayloadFragment$.prototype.constructor = $c_Lamf_core_model_document_PayloadFragment$;
/** @constructor */
function $h_Lamf_core_model_document_PayloadFragment$() {
  /*<skip>*/
}
$h_Lamf_core_model_document_PayloadFragment$.prototype = $c_Lamf_core_model_document_PayloadFragment$.prototype;
$c_Lamf_core_model_document_PayloadFragment$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_model_document_PayloadFragment$.prototype.apply__Lamf_core_model_domain_DataNode__T__Lamf_core_model_document_PayloadFragment = (function(payload, mediaType) {
  return this.apply__p1__Lamf_core_model_domain_DataNode__Lamf_core_model_document_PayloadFragment(payload).withMediaType__T__Lamf_core_model_document_PayloadFragment(mediaType)
});
$c_Lamf_core_model_document_PayloadFragment$.prototype.apply__p1__Lamf_core_model_document_PayloadFragment = (function() {
  var this$3 = new $c_Lamf_core_model_document_PayloadFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
  return $as_Lamf_core_model_document_PayloadFragment($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$3, "http://test.com/payload"))
});
$c_Lamf_core_model_document_PayloadFragment$.prototype.apply__p1__Lamf_core_model_domain_DataNode__Lamf_core_model_document_PayloadFragment = (function(payload) {
  var this$1 = this.apply__p1__Lamf_core_model_document_PayloadFragment();
  var field = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
  var fragment = $as_Lamf_core_model_document_PayloadFragment($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$1, field, payload)));
  var this$2 = payload.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_SourceLocation.getClassOf());
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var l = $as_Lamf_core_annotations_SourceLocation(arg1);
    var location = l.location$1;
    var field$1 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
    $as_Lamf_core_model_document_PayloadFragment($as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(fragment, field$1, location)))
  };
  return fragment
});
var $d_Lamf_core_model_document_PayloadFragment$ = new $TypeData().initClass({
  Lamf_core_model_document_PayloadFragment$: 0
}, false, "amf.core.model.document.PayloadFragment$", {
  Lamf_core_model_document_PayloadFragment$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_document_PayloadFragment$.prototype.$classData = $d_Lamf_core_model_document_PayloadFragment$;
var $n_Lamf_core_model_document_PayloadFragment$ = (void 0);
function $m_Lamf_core_model_document_PayloadFragment$() {
  if ((!$n_Lamf_core_model_document_PayloadFragment$)) {
    $n_Lamf_core_model_document_PayloadFragment$ = new $c_Lamf_core_model_document_PayloadFragment$().init___()
  };
  return $n_Lamf_core_model_document_PayloadFragment$
}
function $is_Lamf_core_model_domain_EternalSerializedAnnotation(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_domain_EternalSerializedAnnotation)))
}
function $as_Lamf_core_model_domain_EternalSerializedAnnotation(obj) {
  return (($is_Lamf_core_model_domain_EternalSerializedAnnotation(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.EternalSerializedAnnotation"))
}
function $isArrayOf_Lamf_core_model_domain_EternalSerializedAnnotation(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_EternalSerializedAnnotation)))
}
function $asArrayOf_Lamf_core_model_domain_EternalSerializedAnnotation(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_EternalSerializedAnnotation(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.EternalSerializedAnnotation;", depth))
}
function $f_Lamf_core_model_domain_ExternalSourceElement__isLinkToSource__Z($thiz) {
  return $thiz.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().ReferenceId$1).isDefined__Z()
}
function $f_Lamf_core_model_domain_ExternalSourceElement__location__s_Option($thiz) {
  var location = $as_Lamf_core_model_StrField($thiz.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Location$1));
  return (location.option$1.isDefined__Z() ? location.option$1 : $f_Lamf_core_model_domain_AmfElement__location__s_Option($thiz))
}
function $is_Lamf_core_model_domain_ExternalSourceElement(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_domain_ExternalSourceElement)))
}
function $as_Lamf_core_model_domain_ExternalSourceElement(obj) {
  return (($is_Lamf_core_model_domain_ExternalSourceElement(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.ExternalSourceElement"))
}
function $isArrayOf_Lamf_core_model_domain_ExternalSourceElement(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_ExternalSourceElement)))
}
function $asArrayOf_Lamf_core_model_domain_ExternalSourceElement(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_ExternalSourceElement(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.ExternalSourceElement;", depth))
}
function $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement($thiz, name, a) {
  var field = $thiz.nameField__Lamf_core_metamodel_Field();
  var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(name, a);
  return $as_Lamf_core_model_domain_NamedDomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject($thiz, field, value))
}
function $is_Lamf_core_model_domain_NamedDomainElement(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_domain_NamedDomainElement)))
}
function $as_Lamf_core_model_domain_NamedDomainElement(obj) {
  return (($is_Lamf_core_model_domain_NamedDomainElement(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.NamedDomainElement"))
}
function $isArrayOf_Lamf_core_model_domain_NamedDomainElement(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_NamedDomainElement)))
}
function $asArrayOf_Lamf_core_model_domain_NamedDomainElement(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_NamedDomainElement(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.NamedDomainElement;", depth))
}
/** @constructor */
function $c_Lamf_core_model_domain_extensions_CustomDomainProperty$() {
  $c_O.call(this)
}
$c_Lamf_core_model_domain_extensions_CustomDomainProperty$.prototype = new $h_O();
$c_Lamf_core_model_domain_extensions_CustomDomainProperty$.prototype.constructor = $c_Lamf_core_model_domain_extensions_CustomDomainProperty$;
/** @constructor */
function $h_Lamf_core_model_domain_extensions_CustomDomainProperty$() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_extensions_CustomDomainProperty$.prototype = $c_Lamf_core_model_domain_extensions_CustomDomainProperty$.prototype;
$c_Lamf_core_model_domain_extensions_CustomDomainProperty$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty$.prototype.apply__Lorg_yaml_model_YPart__Lamf_core_model_domain_extensions_CustomDomainProperty = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  return new $c_Lamf_core_model_domain_extensions_CustomDomainProperty().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_core_model_domain_extensions_CustomDomainProperty$ = new $TypeData().initClass({
  Lamf_core_model_domain_extensions_CustomDomainProperty$: 0
}, false, "amf.core.model.domain.extensions.CustomDomainProperty$", {
  Lamf_core_model_domain_extensions_CustomDomainProperty$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty$.prototype.$classData = $d_Lamf_core_model_domain_extensions_CustomDomainProperty$;
var $n_Lamf_core_model_domain_extensions_CustomDomainProperty$ = (void 0);
function $m_Lamf_core_model_domain_extensions_CustomDomainProperty$() {
  if ((!$n_Lamf_core_model_domain_extensions_CustomDomainProperty$)) {
    $n_Lamf_core_model_domain_extensions_CustomDomainProperty$ = new $c_Lamf_core_model_domain_extensions_CustomDomainProperty$().init___()
  };
  return $n_Lamf_core_model_domain_extensions_CustomDomainProperty$
}
function $is_Lamf_core_model_domain_extensions_Extension(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_domain_extensions_Extension)))
}
function $as_Lamf_core_model_domain_extensions_Extension(obj) {
  return (($is_Lamf_core_model_domain_extensions_Extension(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.extensions.Extension"))
}
function $isArrayOf_Lamf_core_model_domain_extensions_Extension(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_extensions_Extension)))
}
function $asArrayOf_Lamf_core_model_domain_extensions_Extension(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_extensions_Extension(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.extensions.Extension;", depth))
}
/** @constructor */
function $c_Lamf_core_model_domain_extensions_ShapeExtension$() {
  $c_O.call(this)
}
$c_Lamf_core_model_domain_extensions_ShapeExtension$.prototype = new $h_O();
$c_Lamf_core_model_domain_extensions_ShapeExtension$.prototype.constructor = $c_Lamf_core_model_domain_extensions_ShapeExtension$;
/** @constructor */
function $h_Lamf_core_model_domain_extensions_ShapeExtension$() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_extensions_ShapeExtension$.prototype = $c_Lamf_core_model_domain_extensions_ShapeExtension$.prototype;
$c_Lamf_core_model_domain_extensions_ShapeExtension$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_model_domain_extensions_ShapeExtension$.prototype.apply__Lorg_yaml_model_YPart__Lamf_core_model_domain_extensions_ShapeExtension = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  return new $c_Lamf_core_model_domain_extensions_ShapeExtension().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_core_model_domain_extensions_ShapeExtension$ = new $TypeData().initClass({
  Lamf_core_model_domain_extensions_ShapeExtension$: 0
}, false, "amf.core.model.domain.extensions.ShapeExtension$", {
  Lamf_core_model_domain_extensions_ShapeExtension$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_domain_extensions_ShapeExtension$.prototype.$classData = $d_Lamf_core_model_domain_extensions_ShapeExtension$;
var $n_Lamf_core_model_domain_extensions_ShapeExtension$ = (void 0);
function $m_Lamf_core_model_domain_extensions_ShapeExtension$() {
  if ((!$n_Lamf_core_model_domain_extensions_ShapeExtension$)) {
    $n_Lamf_core_model_domain_extensions_ShapeExtension$ = new $c_Lamf_core_model_domain_extensions_ShapeExtension$().init___()
  };
  return $n_Lamf_core_model_domain_extensions_ShapeExtension$
}
/** @constructor */
function $c_Lamf_core_model_domain_templates_VariableValue$() {
  $c_O.call(this)
}
$c_Lamf_core_model_domain_templates_VariableValue$.prototype = new $h_O();
$c_Lamf_core_model_domain_templates_VariableValue$.prototype.constructor = $c_Lamf_core_model_domain_templates_VariableValue$;
/** @constructor */
function $h_Lamf_core_model_domain_templates_VariableValue$() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_templates_VariableValue$.prototype = $c_Lamf_core_model_domain_templates_VariableValue$.prototype;
$c_Lamf_core_model_domain_templates_VariableValue$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_model_domain_templates_VariableValue$.prototype.apply__Lorg_yaml_model_YPart__Lamf_core_model_domain_templates_VariableValue = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  return new $c_Lamf_core_model_domain_templates_VariableValue().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_core_model_domain_templates_VariableValue$ = new $TypeData().initClass({
  Lamf_core_model_domain_templates_VariableValue$: 0
}, false, "amf.core.model.domain.templates.VariableValue$", {
  Lamf_core_model_domain_templates_VariableValue$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_domain_templates_VariableValue$.prototype.$classData = $d_Lamf_core_model_domain_templates_VariableValue$;
var $n_Lamf_core_model_domain_templates_VariableValue$ = (void 0);
function $m_Lamf_core_model_domain_templates_VariableValue$() {
  if ((!$n_Lamf_core_model_domain_templates_VariableValue$)) {
    $n_Lamf_core_model_domain_templates_VariableValue$ = new $c_Lamf_core_model_domain_templates_VariableValue$().init___()
  };
  return $n_Lamf_core_model_domain_templates_VariableValue$
}
/** @constructor */
function $c_Lamf_core_parser_Range$() {
  $c_O.call(this)
}
$c_Lamf_core_parser_Range$.prototype = new $h_O();
$c_Lamf_core_parser_Range$.prototype.constructor = $c_Lamf_core_parser_Range$;
/** @constructor */
function $h_Lamf_core_parser_Range$() {
  /*<skip>*/
}
$h_Lamf_core_parser_Range$.prototype = $c_Lamf_core_parser_Range$.prototype;
$c_Lamf_core_parser_Range$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_parser_Range$.prototype.apply__T__Lamf_core_parser_Range = (function(serialized) {
  var this$2 = new $c_sci_StringOps().init___T("\\[\\(([0-9]*),([0-9]*)\\)-\\(([0-9]*),([0-9]*)\\)\\]");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  var Pattern = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  var o7 = Pattern.unapplySeq__jl_CharSequence__s_Option(serialized);
  if ((!o7.isEmpty__Z())) {
    if ((o7.get__O() !== null)) {
      var this$4 = $as_sc_LinearSeqOptimized(o7.get__O());
      var jsx$1 = ($f_sc_LinearSeqOptimized__lengthCompare__I__I(this$4, 4) === 0)
    } else {
      var jsx$1 = false
    }
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var l1 = $as_T($as_sc_LinearSeqOptimized(o7.get__O()).apply__I__O(0));
    var c1 = $as_T($as_sc_LinearSeqOptimized(o7.get__O()).apply__I__O(1));
    var l2 = $as_T($as_sc_LinearSeqOptimized(o7.get__O()).apply__I__O(2));
    var c2 = $as_T($as_sc_LinearSeqOptimized(o7.get__O()).apply__I__O(3));
    var this$6 = new $c_sci_StringOps().init___T(l1);
    var this$8 = $m_jl_Integer$();
    var $$this$1 = this$6.repr$1;
    var _1$mcI$sp = this$8.parseInt__T__I__I($$this$1, 10);
    var this$10 = new $c_sci_StringOps().init___T(c1);
    var this$12 = $m_jl_Integer$();
    var $$this$2 = this$10.repr$1;
    var _2$mcI$sp = this$12.parseInt__T__I__I($$this$2, 10);
    var this$14 = new $c_sci_StringOps().init___T(l2);
    var this$16 = $m_jl_Integer$();
    var $$this$3 = this$14.repr$1;
    var _1$mcI$sp$1 = this$16.parseInt__T__I__I($$this$3, 10);
    var this$18 = new $c_sci_StringOps().init___T(c2);
    var this$20 = $m_jl_Integer$();
    var $$this$4 = this$18.repr$1;
    var _2$mcI$sp$1 = this$20.parseInt__T__I__I($$this$4, 10);
    return new $c_Lamf_core_parser_Range().init___Lamf_core_parser_Position__Lamf_core_parser_Position(new $c_Lamf_core_parser_Position().init___I__I(_1$mcI$sp, _2$mcI$sp), new $c_Lamf_core_parser_Position().init___I__I(_1$mcI$sp$1, _2$mcI$sp$1))
  };
  throw new $c_s_MatchError().init___O(serialized)
});
$c_Lamf_core_parser_Range$.prototype.apply__Lamf_core_parser_Position__I__Lamf_core_parser_Range = (function(start, delta) {
  return new $c_Lamf_core_parser_Range().init___Lamf_core_parser_Position__Lamf_core_parser_Position(start, new $c_Lamf_core_parser_Position().init___I__I(start.line$1, ((start.column$1 + delta) | 0)))
});
$c_Lamf_core_parser_Range$.prototype.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range = (function(r) {
  return new $c_Lamf_core_parser_Range().init___Lamf_core_parser_Position__Lamf_core_parser_Position(new $c_Lamf_core_parser_Position().init___I__I(r.lineFrom$1, r.columnFrom$1), new $c_Lamf_core_parser_Position().init___I__I(r.lineTo$1, r.columnTo$1))
});
var $d_Lamf_core_parser_Range$ = new $TypeData().initClass({
  Lamf_core_parser_Range$: 0
}, false, "amf.core.parser.Range$", {
  Lamf_core_parser_Range$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_Range$.prototype.$classData = $d_Lamf_core_parser_Range$;
var $n_Lamf_core_parser_Range$ = (void 0);
function $m_Lamf_core_parser_Range$() {
  if ((!$n_Lamf_core_parser_Range$)) {
    $n_Lamf_core_parser_Range$ = new $c_Lamf_core_parser_Range$().init___()
  };
  return $n_Lamf_core_parser_Range$
}
/** @constructor */
function $c_Lamf_core_parser_Reference$() {
  $c_O.call(this)
}
$c_Lamf_core_parser_Reference$.prototype = new $h_O();
$c_Lamf_core_parser_Reference$.prototype.constructor = $c_Lamf_core_parser_Reference$;
/** @constructor */
function $h_Lamf_core_parser_Reference$() {
  /*<skip>*/
}
$h_Lamf_core_parser_Reference$.prototype = $c_Lamf_core_parser_Reference$.prototype;
$c_Lamf_core_parser_Reference$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_parser_Reference$.prototype.apply__T__Lamf_core_parser_ReferenceKind__Lorg_yaml_model_YNode__s_Option__Lamf_core_parser_Reference = (function(url, kind, node, fragment) {
  var jsx$1 = $m_sc_Seq$();
  var array = [new $c_Lamf_core_parser_RefContainer().init___Lamf_core_parser_ReferenceKind__Lorg_yaml_model_YNode__s_Option(kind, node, fragment)];
  return new $c_Lamf_core_parser_Reference().init___T__sc_Seq(url, $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))))
});
var $d_Lamf_core_parser_Reference$ = new $TypeData().initClass({
  Lamf_core_parser_Reference$: 0
}, false, "amf.core.parser.Reference$", {
  Lamf_core_parser_Reference$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_Reference$.prototype.$classData = $d_Lamf_core_parser_Reference$;
var $n_Lamf_core_parser_Reference$ = (void 0);
function $m_Lamf_core_parser_Reference$() {
  if ((!$n_Lamf_core_parser_Reference$)) {
    $n_Lamf_core_parser_Reference$ = new $c_Lamf_core_parser_Reference$().init___()
  };
  return $n_Lamf_core_parser_Reference$
}
function $f_Lamf_core_parser_errorhandler_ParserErrorHandler__handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V($thiz, location, e) {
  matchEnd4: {
    if ((e instanceof $c_Lorg_yaml_model_LexerException)) {
      var x2 = $as_Lorg_yaml_model_LexerException(e);
      var thiz = x2.text$5;
      if ((thiz === null)) {
        throw new $c_jl_NullPointerException().init___()
      };
      if ($m_ju_regex_Pattern$().matches__T__jl_CharSequence__Z("\\s+", thiz)) {
        break matchEnd4
      }
    };
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().SyamlError$1;
    var message = e.s$1;
    var prop = $m_s_None$();
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V($thiz, specification, "", prop, message, location)
  }
}
function $f_Lamf_core_parser_errorhandler_ParserErrorHandler__handle__Lorg_yaml_model_YError__O__O($thiz, error, defaultValue) {
  var specification = $m_Lamf_plugins_features_validation_CoreValidations$().SyamlError$1;
  var message = error.error__T();
  var ast = $f_Lamf_core_parser_errorhandler_ParserErrorHandler__part__Lorg_yaml_model_YError__Lorg_yaml_model_YPart($thiz, error);
  var prop = $m_s_None$();
  var l = ast.location$1;
  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V($thiz, specification, "", prop, message, l);
  return defaultValue
}
function $f_Lamf_core_parser_errorhandler_ParserErrorHandler__part__Lorg_yaml_model_YError__Lorg_yaml_model_YPart($thiz, error) {
  var x1 = error.node$1;
  if ((x1 instanceof $c_Lorg_yaml_model_YDocument)) {
    var x2 = $as_Lorg_yaml_model_YDocument(x1);
    return x2
  } else if ((x1 instanceof $c_Lorg_yaml_model_YNode)) {
    var x3 = $as_Lorg_yaml_model_YNode(x1);
    return x3
  } else if ((x1 instanceof $c_Lorg_yaml_model_YSuccess)) {
    var x4 = $as_Lorg_yaml_model_YSuccess(x1);
    return x4.node$2
  } else if ((x1 instanceof $c_Lorg_yaml_model_YFail)) {
    var x5 = $as_Lorg_yaml_model_YFail(x1);
    var error$1 = x5.error$2;
    return $f_Lamf_core_parser_errorhandler_ParserErrorHandler__part__Lorg_yaml_model_YError__Lorg_yaml_model_YPart($thiz, error$1)
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
}
/** @constructor */
function $c_Lamf_core_plugin_CorePlugin$() {
  $c_Lamf_client_plugins_AMFDomainPlugin.call(this);
  this.ID$2 = null
}
$c_Lamf_core_plugin_CorePlugin$.prototype = new $h_Lamf_client_plugins_AMFDomainPlugin();
$c_Lamf_core_plugin_CorePlugin$.prototype.constructor = $c_Lamf_core_plugin_CorePlugin$;
/** @constructor */
function $h_Lamf_core_plugin_CorePlugin$() {
  /*<skip>*/
}
$h_Lamf_core_plugin_CorePlugin$.prototype = $c_Lamf_core_plugin_CorePlugin$.prototype;
$c_Lamf_core_plugin_CorePlugin$.prototype.init___ = (function() {
  this.ID$2 = "";
  return this
});
$c_Lamf_core_plugin_CorePlugin$.prototype.init__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  return $m_s_concurrent_Future$().successful__O__s_concurrent_Future(this)
});
$c_Lamf_core_plugin_CorePlugin$.prototype.modelEntities__sc_Seq = (function() {
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_core_metamodel_document_DocumentModel$(), $m_Lamf_core_metamodel_document_ModuleModel$(), $m_Lamf_core_metamodel_domain_templates_VariableValueModel$(), $m_Lamf_core_metamodel_document_SourceMapModel$(), $m_Lamf_core_metamodel_domain_RecursiveShapeModel$(), $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$(), $m_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$(), $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$(), $m_Lamf_core_metamodel_document_ExternalFragmentModel$(), $m_Lamf_core_metamodel_domain_ExternalDomainElementModel$(), $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$()];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_core_plugin_CorePlugin$.prototype.ID__T = (function() {
  return this.ID$2
});
$c_Lamf_core_plugin_CorePlugin$.prototype.dependencies__sc_Seq = (function() {
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$3 = new $c_scm_ListBuffer().init___();
  return this$3.toList__sci_List()
});
$c_Lamf_core_plugin_CorePlugin$.prototype.serializableAnnotations__sci_Map = (function() {
  var y = $m_Lamf_core_annotations_LexicalInformation$();
  var jsx$10 = new $c_T2().init___O__O("lexical", y);
  var y$1 = $m_Lamf_core_annotations_HostLexicalInformation$();
  var jsx$9 = new $c_T2().init___O__O("host-lexical", y$1);
  var y$2 = $m_Lamf_core_annotations_BasePathLexicalInformation$();
  var jsx$8 = new $c_T2().init___O__O("base-path-lexical", y$2);
  var y$3 = $m_Lamf_core_annotations_SourceVendor$();
  var jsx$7 = new $c_T2().init___O__O("source-vendor", y$3);
  var y$4 = $m_Lamf_core_annotations_SingleValueArray$();
  var jsx$6 = new $c_T2().init___O__O("single-value-array", y$4);
  var y$5 = $m_Lamf_core_annotations_Aliases$();
  var jsx$5 = new $c_T2().init___O__O("aliases-array", y$5);
  var y$6 = $m_Lamf_core_annotations_SynthesizedField$();
  var jsx$4 = new $c_T2().init___O__O("synthesized-field", y$6);
  var y$7 = $m_Lamf_core_annotations_DefaultNode$();
  var jsx$3 = new $c_T2().init___O__O("default-node", y$7);
  var y$8 = $m_Lamf_core_annotations_DataNodePropertiesAnnotations$();
  var jsx$2 = new $c_T2().init___O__O("data-node-properties", y$8);
  var y$9 = $m_Lamf_core_annotations_ResolvedLinkAnnotation$();
  var jsx$1 = new $c_T2().init___O__O("resolved-link", y$9);
  var y$10 = $m_Lamf_core_annotations_NullSecurity$();
  var array = [jsx$10, jsx$9, jsx$8, jsx$7, jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, jsx$1, new $c_T2().init___O__O("null-security", y$10)];
  var this$26 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$26.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  return $as_sci_Map(this$26.elems$1)
});
var $d_Lamf_core_plugin_CorePlugin$ = new $TypeData().initClass({
  Lamf_core_plugin_CorePlugin$: 0
}, false, "amf.core.plugin.CorePlugin$", {
  Lamf_core_plugin_CorePlugin$: 1,
  Lamf_client_plugins_AMFDomainPlugin: 1,
  O: 1,
  Lamf_client_plugins_AMFPlugin: 1
});
$c_Lamf_core_plugin_CorePlugin$.prototype.$classData = $d_Lamf_core_plugin_CorePlugin$;
var $n_Lamf_core_plugin_CorePlugin$ = (void 0);
function $m_Lamf_core_plugin_CorePlugin$() {
  if ((!$n_Lamf_core_plugin_CorePlugin$)) {
    $n_Lamf_core_plugin_CorePlugin$ = new $c_Lamf_core_plugin_CorePlugin$().init___()
  };
  return $n_Lamf_core_plugin_CorePlugin$
}
/** @constructor */
function $c_Lamf_core_rdf_RdfModelEmitter() {
  $c_O.call(this);
  this.Emitter$module$1 = null;
  this.amf$core$rdf$RdfModelEmitter$$rdfmodel$f = null
}
$c_Lamf_core_rdf_RdfModelEmitter.prototype = new $h_O();
$c_Lamf_core_rdf_RdfModelEmitter.prototype.constructor = $c_Lamf_core_rdf_RdfModelEmitter;
/** @constructor */
function $h_Lamf_core_rdf_RdfModelEmitter() {
  /*<skip>*/
}
$h_Lamf_core_rdf_RdfModelEmitter.prototype = $c_Lamf_core_rdf_RdfModelEmitter.prototype;
$c_Lamf_core_rdf_RdfModelEmitter.prototype.emit__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__V = (function(unit, options) {
  new $c_Lamf_core_rdf_RdfModelEmitter$Emitter().init___Lamf_core_rdf_RdfModelEmitter__Lamf_core_emitter_RenderOptions(this, options).root__Lamf_core_model_document_BaseUnit__V(unit)
});
$c_Lamf_core_rdf_RdfModelEmitter.prototype.init___Lamf_core_rdf_RdfModel = (function(rdfmodel) {
  this.amf$core$rdf$RdfModelEmitter$$rdfmodel$f = rdfmodel;
  return this
});
var $d_Lamf_core_rdf_RdfModelEmitter = new $TypeData().initClass({
  Lamf_core_rdf_RdfModelEmitter: 0
}, false, "amf.core.rdf.RdfModelEmitter", {
  Lamf_core_rdf_RdfModelEmitter: 1,
  O: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_plugins_document_graph_emitter_CommonEmitter: 1
});
$c_Lamf_core_rdf_RdfModelEmitter.prototype.$classData = $d_Lamf_core_rdf_RdfModelEmitter;
/** @constructor */
function $c_Lamf_core_remote_AsyncApi$() {
  $c_O.call(this);
  this.name$1 = null
}
$c_Lamf_core_remote_AsyncApi$.prototype = new $h_O();
$c_Lamf_core_remote_AsyncApi$.prototype.constructor = $c_Lamf_core_remote_AsyncApi$;
/** @constructor */
function $h_Lamf_core_remote_AsyncApi$() {
  /*<skip>*/
}
$h_Lamf_core_remote_AsyncApi$.prototype = $c_Lamf_core_remote_AsyncApi$.prototype;
$c_Lamf_core_remote_AsyncApi$.prototype.init___ = (function() {
  $n_Lamf_core_remote_AsyncApi$ = this;
  $f_Lamf_core_remote_Async__$$init$__V(this);
  return this
});
$c_Lamf_core_remote_AsyncApi$.prototype.toString__T = (function() {
  var thiz = this.name$1;
  return $as_T(thiz.trim())
});
$c_Lamf_core_remote_AsyncApi$.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_remote_AsyncApi$.prototype.amf$core$remote$Async$$undsetter$und$name$und$eq__T__V = (function(x$1) {
  this.name$1 = x$1
});
$c_Lamf_core_remote_AsyncApi$.prototype.version__T = (function() {
  return ""
});
var $d_Lamf_core_remote_AsyncApi$ = new $TypeData().initClass({
  Lamf_core_remote_AsyncApi$: 0
}, false, "amf.core.remote.AsyncApi$", {
  Lamf_core_remote_AsyncApi$: 1,
  O: 1,
  Lamf_core_remote_Async: 1,
  Lamf_core_remote_Vendor: 1
});
$c_Lamf_core_remote_AsyncApi$.prototype.$classData = $d_Lamf_core_remote_AsyncApi$;
var $n_Lamf_core_remote_AsyncApi$ = (void 0);
function $m_Lamf_core_remote_AsyncApi$() {
  if ((!$n_Lamf_core_remote_AsyncApi$)) {
    $n_Lamf_core_remote_AsyncApi$ = new $c_Lamf_core_remote_AsyncApi$().init___()
  };
  return $n_Lamf_core_remote_AsyncApi$
}
/** @constructor */
function $c_Lamf_core_remote_AsyncApi20$() {
  $c_O.call(this);
  this.name$1 = null
}
$c_Lamf_core_remote_AsyncApi20$.prototype = new $h_O();
$c_Lamf_core_remote_AsyncApi20$.prototype.constructor = $c_Lamf_core_remote_AsyncApi20$;
/** @constructor */
function $h_Lamf_core_remote_AsyncApi20$() {
  /*<skip>*/
}
$h_Lamf_core_remote_AsyncApi20$.prototype = $c_Lamf_core_remote_AsyncApi20$.prototype;
$c_Lamf_core_remote_AsyncApi20$.prototype.init___ = (function() {
  $n_Lamf_core_remote_AsyncApi20$ = this;
  $f_Lamf_core_remote_Async__$$init$__V(this);
  return this
});
$c_Lamf_core_remote_AsyncApi20$.prototype.toString__T = (function() {
  var thiz = this.name$1;
  return $as_T(thiz.trim())
});
$c_Lamf_core_remote_AsyncApi20$.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_remote_AsyncApi20$.prototype.amf$core$remote$Async$$undsetter$und$name$und$eq__T__V = (function(x$1) {
  this.name$1 = x$1
});
$c_Lamf_core_remote_AsyncApi20$.prototype.version__T = (function() {
  return "2.0"
});
var $d_Lamf_core_remote_AsyncApi20$ = new $TypeData().initClass({
  Lamf_core_remote_AsyncApi20$: 0
}, false, "amf.core.remote.AsyncApi20$", {
  Lamf_core_remote_AsyncApi20$: 1,
  O: 1,
  Lamf_core_remote_Async: 1,
  Lamf_core_remote_Vendor: 1
});
$c_Lamf_core_remote_AsyncApi20$.prototype.$classData = $d_Lamf_core_remote_AsyncApi20$;
var $n_Lamf_core_remote_AsyncApi20$ = (void 0);
function $m_Lamf_core_remote_AsyncApi20$() {
  if ((!$n_Lamf_core_remote_AsyncApi20$)) {
    $n_Lamf_core_remote_AsyncApi20$ = new $c_Lamf_core_remote_AsyncApi20$().init___()
  };
  return $n_Lamf_core_remote_AsyncApi20$
}
/** @constructor */
function $c_Lamf_core_remote_FileLoaderException() {
  $c_jl_Throwable.call(this)
}
$c_Lamf_core_remote_FileLoaderException.prototype = new $h_jl_Throwable();
$c_Lamf_core_remote_FileLoaderException.prototype.constructor = $c_Lamf_core_remote_FileLoaderException;
/** @constructor */
function $h_Lamf_core_remote_FileLoaderException() {
  /*<skip>*/
}
$h_Lamf_core_remote_FileLoaderException.prototype = $c_Lamf_core_remote_FileLoaderException.prototype;
/** @constructor */
function $c_Lamf_core_remote_Oas$() {
  $c_O.call(this);
  this.name$1 = null
}
$c_Lamf_core_remote_Oas$.prototype = new $h_O();
$c_Lamf_core_remote_Oas$.prototype.constructor = $c_Lamf_core_remote_Oas$;
/** @constructor */
function $h_Lamf_core_remote_Oas$() {
  /*<skip>*/
}
$h_Lamf_core_remote_Oas$.prototype = $c_Lamf_core_remote_Oas$.prototype;
$c_Lamf_core_remote_Oas$.prototype.init___ = (function() {
  $n_Lamf_core_remote_Oas$ = this;
  $f_Lamf_core_remote_Oas__$$init$__V(this);
  return this
});
$c_Lamf_core_remote_Oas$.prototype.toString__T = (function() {
  var thiz = this.name$1;
  return $as_T(thiz.trim())
});
$c_Lamf_core_remote_Oas$.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_remote_Oas$.prototype.amf$core$remote$Oas$$undsetter$und$name$und$eq__T__V = (function(x$1) {
  this.name$1 = x$1
});
$c_Lamf_core_remote_Oas$.prototype.version__T = (function() {
  return ""
});
var $d_Lamf_core_remote_Oas$ = new $TypeData().initClass({
  Lamf_core_remote_Oas$: 0
}, false, "amf.core.remote.Oas$", {
  Lamf_core_remote_Oas$: 1,
  O: 1,
  Lamf_core_remote_Oas: 1,
  Lamf_core_remote_Vendor: 1
});
$c_Lamf_core_remote_Oas$.prototype.$classData = $d_Lamf_core_remote_Oas$;
var $n_Lamf_core_remote_Oas$ = (void 0);
function $m_Lamf_core_remote_Oas$() {
  if ((!$n_Lamf_core_remote_Oas$)) {
    $n_Lamf_core_remote_Oas$ = new $c_Lamf_core_remote_Oas$().init___()
  };
  return $n_Lamf_core_remote_Oas$
}
/** @constructor */
function $c_Lamf_core_remote_Oas20$() {
  $c_O.call(this);
  this.name$1 = null
}
$c_Lamf_core_remote_Oas20$.prototype = new $h_O();
$c_Lamf_core_remote_Oas20$.prototype.constructor = $c_Lamf_core_remote_Oas20$;
/** @constructor */
function $h_Lamf_core_remote_Oas20$() {
  /*<skip>*/
}
$h_Lamf_core_remote_Oas20$.prototype = $c_Lamf_core_remote_Oas20$.prototype;
$c_Lamf_core_remote_Oas20$.prototype.init___ = (function() {
  $n_Lamf_core_remote_Oas20$ = this;
  $f_Lamf_core_remote_Oas__$$init$__V(this);
  return this
});
$c_Lamf_core_remote_Oas20$.prototype.toString__T = (function() {
  var thiz = this.name$1;
  return $as_T(thiz.trim())
});
$c_Lamf_core_remote_Oas20$.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_remote_Oas20$.prototype.amf$core$remote$Oas$$undsetter$und$name$und$eq__T__V = (function(x$1) {
  this.name$1 = x$1
});
$c_Lamf_core_remote_Oas20$.prototype.version__T = (function() {
  return "2.0"
});
var $d_Lamf_core_remote_Oas20$ = new $TypeData().initClass({
  Lamf_core_remote_Oas20$: 0
}, false, "amf.core.remote.Oas20$", {
  Lamf_core_remote_Oas20$: 1,
  O: 1,
  Lamf_core_remote_Oas: 1,
  Lamf_core_remote_Vendor: 1
});
$c_Lamf_core_remote_Oas20$.prototype.$classData = $d_Lamf_core_remote_Oas20$;
var $n_Lamf_core_remote_Oas20$ = (void 0);
function $m_Lamf_core_remote_Oas20$() {
  if ((!$n_Lamf_core_remote_Oas20$)) {
    $n_Lamf_core_remote_Oas20$ = new $c_Lamf_core_remote_Oas20$().init___()
  };
  return $n_Lamf_core_remote_Oas20$
}
/** @constructor */
function $c_Lamf_core_remote_Oas30$() {
  $c_O.call(this);
  this.name$1 = null
}
$c_Lamf_core_remote_Oas30$.prototype = new $h_O();
$c_Lamf_core_remote_Oas30$.prototype.constructor = $c_Lamf_core_remote_Oas30$;
/** @constructor */
function $h_Lamf_core_remote_Oas30$() {
  /*<skip>*/
}
$h_Lamf_core_remote_Oas30$.prototype = $c_Lamf_core_remote_Oas30$.prototype;
$c_Lamf_core_remote_Oas30$.prototype.init___ = (function() {
  $n_Lamf_core_remote_Oas30$ = this;
  $f_Lamf_core_remote_Oas__$$init$__V(this);
  return this
});
$c_Lamf_core_remote_Oas30$.prototype.toString__T = (function() {
  var thiz = this.name$1;
  return $as_T(thiz.trim())
});
$c_Lamf_core_remote_Oas30$.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_remote_Oas30$.prototype.amf$core$remote$Oas$$undsetter$und$name$und$eq__T__V = (function(x$1) {
  this.name$1 = x$1
});
$c_Lamf_core_remote_Oas30$.prototype.version__T = (function() {
  return "3.0"
});
var $d_Lamf_core_remote_Oas30$ = new $TypeData().initClass({
  Lamf_core_remote_Oas30$: 0
}, false, "amf.core.remote.Oas30$", {
  Lamf_core_remote_Oas30$: 1,
  O: 1,
  Lamf_core_remote_Oas: 1,
  Lamf_core_remote_Vendor: 1
});
$c_Lamf_core_remote_Oas30$.prototype.$classData = $d_Lamf_core_remote_Oas30$;
var $n_Lamf_core_remote_Oas30$ = (void 0);
function $m_Lamf_core_remote_Oas30$() {
  if ((!$n_Lamf_core_remote_Oas30$)) {
    $n_Lamf_core_remote_Oas30$ = new $c_Lamf_core_remote_Oas30$().init___()
  };
  return $n_Lamf_core_remote_Oas30$
}
/** @constructor */
function $c_Lamf_core_remote_Raml$() {
  $c_O.call(this);
  this.name$1 = null
}
$c_Lamf_core_remote_Raml$.prototype = new $h_O();
$c_Lamf_core_remote_Raml$.prototype.constructor = $c_Lamf_core_remote_Raml$;
/** @constructor */
function $h_Lamf_core_remote_Raml$() {
  /*<skip>*/
}
$h_Lamf_core_remote_Raml$.prototype = $c_Lamf_core_remote_Raml$.prototype;
$c_Lamf_core_remote_Raml$.prototype.init___ = (function() {
  $n_Lamf_core_remote_Raml$ = this;
  $f_Lamf_core_remote_Raml__$$init$__V(this);
  return this
});
$c_Lamf_core_remote_Raml$.prototype.amf$core$remote$Raml$$undsetter$und$name$und$eq__T__V = (function(x$1) {
  this.name$1 = x$1
});
$c_Lamf_core_remote_Raml$.prototype.toString__T = (function() {
  var thiz = this.name$1;
  return $as_T(thiz.trim())
});
$c_Lamf_core_remote_Raml$.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_remote_Raml$.prototype.version__T = (function() {
  return ""
});
var $d_Lamf_core_remote_Raml$ = new $TypeData().initClass({
  Lamf_core_remote_Raml$: 0
}, false, "amf.core.remote.Raml$", {
  Lamf_core_remote_Raml$: 1,
  O: 1,
  Lamf_core_remote_Raml: 1,
  Lamf_core_remote_Vendor: 1
});
$c_Lamf_core_remote_Raml$.prototype.$classData = $d_Lamf_core_remote_Raml$;
var $n_Lamf_core_remote_Raml$ = (void 0);
function $m_Lamf_core_remote_Raml$() {
  if ((!$n_Lamf_core_remote_Raml$)) {
    $n_Lamf_core_remote_Raml$ = new $c_Lamf_core_remote_Raml$().init___()
  };
  return $n_Lamf_core_remote_Raml$
}
/** @constructor */
function $c_Lamf_core_remote_Raml08$() {
  $c_O.call(this);
  this.name$1 = null
}
$c_Lamf_core_remote_Raml08$.prototype = new $h_O();
$c_Lamf_core_remote_Raml08$.prototype.constructor = $c_Lamf_core_remote_Raml08$;
/** @constructor */
function $h_Lamf_core_remote_Raml08$() {
  /*<skip>*/
}
$h_Lamf_core_remote_Raml08$.prototype = $c_Lamf_core_remote_Raml08$.prototype;
$c_Lamf_core_remote_Raml08$.prototype.init___ = (function() {
  $n_Lamf_core_remote_Raml08$ = this;
  $f_Lamf_core_remote_Raml__$$init$__V(this);
  return this
});
$c_Lamf_core_remote_Raml08$.prototype.amf$core$remote$Raml$$undsetter$und$name$und$eq__T__V = (function(x$1) {
  this.name$1 = x$1
});
$c_Lamf_core_remote_Raml08$.prototype.toString__T = (function() {
  var thiz = this.name$1;
  return $as_T(thiz.trim())
});
$c_Lamf_core_remote_Raml08$.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_remote_Raml08$.prototype.version__T = (function() {
  return "0.8"
});
var $d_Lamf_core_remote_Raml08$ = new $TypeData().initClass({
  Lamf_core_remote_Raml08$: 0
}, false, "amf.core.remote.Raml08$", {
  Lamf_core_remote_Raml08$: 1,
  O: 1,
  Lamf_core_remote_Raml: 1,
  Lamf_core_remote_Vendor: 1
});
$c_Lamf_core_remote_Raml08$.prototype.$classData = $d_Lamf_core_remote_Raml08$;
var $n_Lamf_core_remote_Raml08$ = (void 0);
function $m_Lamf_core_remote_Raml08$() {
  if ((!$n_Lamf_core_remote_Raml08$)) {
    $n_Lamf_core_remote_Raml08$ = new $c_Lamf_core_remote_Raml08$().init___()
  };
  return $n_Lamf_core_remote_Raml08$
}
/** @constructor */
function $c_Lamf_core_remote_Raml10$() {
  $c_O.call(this);
  this.name$1 = null
}
$c_Lamf_core_remote_Raml10$.prototype = new $h_O();
$c_Lamf_core_remote_Raml10$.prototype.constructor = $c_Lamf_core_remote_Raml10$;
/** @constructor */
function $h_Lamf_core_remote_Raml10$() {
  /*<skip>*/
}
$h_Lamf_core_remote_Raml10$.prototype = $c_Lamf_core_remote_Raml10$.prototype;
$c_Lamf_core_remote_Raml10$.prototype.init___ = (function() {
  $n_Lamf_core_remote_Raml10$ = this;
  $f_Lamf_core_remote_Raml__$$init$__V(this);
  return this
});
$c_Lamf_core_remote_Raml10$.prototype.amf$core$remote$Raml$$undsetter$und$name$und$eq__T__V = (function(x$1) {
  this.name$1 = x$1
});
$c_Lamf_core_remote_Raml10$.prototype.toString__T = (function() {
  var thiz = this.name$1;
  return $as_T(thiz.trim())
});
$c_Lamf_core_remote_Raml10$.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_remote_Raml10$.prototype.version__T = (function() {
  return "1.0"
});
var $d_Lamf_core_remote_Raml10$ = new $TypeData().initClass({
  Lamf_core_remote_Raml10$: 0
}, false, "amf.core.remote.Raml10$", {
  Lamf_core_remote_Raml10$: 1,
  O: 1,
  Lamf_core_remote_Raml: 1,
  Lamf_core_remote_Vendor: 1
});
$c_Lamf_core_remote_Raml10$.prototype.$classData = $d_Lamf_core_remote_Raml10$;
var $n_Lamf_core_remote_Raml10$ = (void 0);
function $m_Lamf_core_remote_Raml10$() {
  if ((!$n_Lamf_core_remote_Raml10$)) {
    $n_Lamf_core_remote_Raml10$ = new $c_Lamf_core_remote_Raml10$().init___()
  };
  return $n_Lamf_core_remote_Raml10$
}
/** @constructor */
function $c_Lamf_core_resolution_stages_ReferenceResolutionStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this);
  this.keepEditingInfo$2 = false;
  this.modelResolver$2 = null;
  this.cache$2 = null
}
$c_Lamf_core_resolution_stages_ReferenceResolutionStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_core_resolution_stages_ReferenceResolutionStage.prototype.constructor = $c_Lamf_core_resolution_stages_ReferenceResolutionStage;
/** @constructor */
function $h_Lamf_core_resolution_stages_ReferenceResolutionStage() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_ReferenceResolutionStage.prototype = $c_Lamf_core_resolution_stages_ReferenceResolutionStage.prototype;
$c_Lamf_core_resolution_stages_ReferenceResolutionStage.prototype.errorHandler__Lamf_core_errorhandling_ErrorHandler = (function() {
  return this.errorHandler$1
});
$c_Lamf_core_resolution_stages_ReferenceResolutionStage.prototype.transformer__Lamf_core_resolution_stages_elements_resolution_ElementStageTransformer = (function() {
  var x$1 = this.cache$2;
  var x$2 = this.keepEditingInfo$2;
  var x$3 = this.modelResolver$2;
  var x$4 = this.errorHandler__Lamf_core_errorhandling_ErrorHandler();
  var x$5 = this.customDomainElementTransformation__F2();
  return new $c_Lamf_core_resolution_stages_elements_resolution_ReferenceResolution().init___Lamf_core_errorhandling_ErrorHandler__Z__s_Option__scm_Map__F2(x$4, x$2, x$3, x$1, x$5)
});
$c_Lamf_core_resolution_stages_ReferenceResolutionStage.prototype.customDomainElementTransformation__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(d$2, x$1$2) {
      var d = $as_Lamf_core_model_domain_DomainElement(d$2);
      $as_Lamf_core_model_domain_Linkable(x$1$2);
      return d
    })
  })(this))
});
$c_Lamf_core_resolution_stages_ReferenceResolutionStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  this.modelResolver$2 = new $c_s_Some().init___O(new $c_Lamf_core_resolution_stages_helpers_ModelReferenceResolver().init___Lamf_core_model_document_BaseUnit(model));
  var this$1 = $m_Lamf_core_resolution_stages_selectors_LinkSelector$();
  var another = $m_Lamf_core_resolution_stages_selectors_LinkNodeSelector$();
  return model.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(new $c_Lamf_core_resolution_stages_selectors_OrSelector().init___Lamf_core_resolution_stages_selectors_Selector__Lamf_core_resolution_stages_selectors_Selector(this$1, another), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(element$2, isCycle$2) {
      var element = $as_Lamf_core_model_domain_DomainElement(element$2);
      $uZ(isCycle$2);
      return $this.transformer__Lamf_core_resolution_stages_elements_resolution_ElementStageTransformer().transform__Lamf_core_model_domain_DomainElement__s_Option(element)
    })
  })(this)), this.errorHandler__Lamf_core_errorhandling_ErrorHandler())
});
$c_Lamf_core_resolution_stages_ReferenceResolutionStage.prototype.resolveDomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement = (function(element) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_core_model_document_Document().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var doc = $as_Lamf_core_model_document_Document($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, "http://resolutionstage.com/test#"));
  if ((element.id__T() !== null)) {
    doc.fields__Lamf_core_parser_Fields().setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_core_metamodel_document_DocumentModel$().Encodes$1, element, (doc.fields__Lamf_core_parser_Fields(), $m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
  } else {
    var field = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
    $as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(doc, field, element))
  };
  return $as_Lamf_core_model_document_Document(this.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(doc)).encodes__Lamf_core_model_domain_DomainElement()
});
$c_Lamf_core_resolution_stages_ReferenceResolutionStage.prototype.init___Z__Lamf_core_errorhandling_ErrorHandler = (function(keepEditingInfo, errorHandler) {
  this.keepEditingInfo$2 = keepEditingInfo;
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  this.modelResolver$2 = $m_s_None$();
  this.cache$2 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  return this
});
var $d_Lamf_core_resolution_stages_ReferenceResolutionStage = new $TypeData().initClass({
  Lamf_core_resolution_stages_ReferenceResolutionStage: 0
}, false, "amf.core.resolution.stages.ReferenceResolutionStage", {
  Lamf_core_resolution_stages_ReferenceResolutionStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1,
  Lamf_core_resolution_stages_elements_resolution_ElementResolutionStage: 1
});
$c_Lamf_core_resolution_stages_ReferenceResolutionStage.prototype.$classData = $d_Lamf_core_resolution_stages_ReferenceResolutionStage;
/** @constructor */
function $c_Lamf_core_utils_package$AliasCounter$() {
  $c_O.call(this);
  this.defaultThreshold$1 = 0
}
$c_Lamf_core_utils_package$AliasCounter$.prototype = new $h_O();
$c_Lamf_core_utils_package$AliasCounter$.prototype.constructor = $c_Lamf_core_utils_package$AliasCounter$;
/** @constructor */
function $h_Lamf_core_utils_package$AliasCounter$() {
  /*<skip>*/
}
$h_Lamf_core_utils_package$AliasCounter$.prototype = $c_Lamf_core_utils_package$AliasCounter$.prototype;
$c_Lamf_core_utils_package$AliasCounter$.prototype.init___ = (function() {
  this.defaultThreshold$1 = 10000;
  return this
});
$c_Lamf_core_utils_package$AliasCounter$.prototype.apply__s_Option__Lamf_core_utils_package$AliasCounter = (function(maxThreshold) {
  if ((maxThreshold instanceof $c_s_Some)) {
    var x2 = $as_s_Some(maxThreshold);
    var t = $uJ(x2.value$2);
    var lo = t.lo$2;
    var hi = t.hi$2;
    return new $c_Lamf_core_utils_package$AliasCounter().init___I__J(0, new $c_sjsr_RuntimeLong().init___I__I(lo, hi))
  } else {
    var x = $m_s_None$();
    if ((x === maxThreshold)) {
      return new $c_Lamf_core_utils_package$AliasCounter().init___I__J(0, this.apply$default$2__J())
    } else {
      throw new $c_s_MatchError().init___O(maxThreshold)
    }
  }
});
$c_Lamf_core_utils_package$AliasCounter$.prototype.apply$default$2__J = (function() {
  var value = $m_Lamf_core_utils_package$AliasCounter$().defaultThreshold$1;
  var hi = (value >> 31);
  return new $c_sjsr_RuntimeLong().init___I__I(value, hi)
});
var $d_Lamf_core_utils_package$AliasCounter$ = new $TypeData().initClass({
  Lamf_core_utils_package$AliasCounter$: 0
}, false, "amf.core.utils.package$AliasCounter$", {
  Lamf_core_utils_package$AliasCounter$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_utils_package$AliasCounter$.prototype.$classData = $d_Lamf_core_utils_package$AliasCounter$;
var $n_Lamf_core_utils_package$AliasCounter$ = (void 0);
function $m_Lamf_core_utils_package$AliasCounter$() {
  if ((!$n_Lamf_core_utils_package$AliasCounter$)) {
    $n_Lamf_core_utils_package$AliasCounter$ = new $c_Lamf_core_utils_package$AliasCounter$().init___()
  };
  return $n_Lamf_core_utils_package$AliasCounter$
}
/** @constructor */
function $c_Lamf_core_utils_package$QName$() {
  $c_O.call(this);
  this.Empty$1 = null
}
$c_Lamf_core_utils_package$QName$.prototype = new $h_O();
$c_Lamf_core_utils_package$QName$.prototype.constructor = $c_Lamf_core_utils_package$QName$;
/** @constructor */
function $h_Lamf_core_utils_package$QName$() {
  /*<skip>*/
}
$h_Lamf_core_utils_package$QName$.prototype = $c_Lamf_core_utils_package$QName$.prototype;
$c_Lamf_core_utils_package$QName$.prototype.init___ = (function() {
  $n_Lamf_core_utils_package$QName$ = this;
  this.Empty$1 = new $c_Lamf_core_utils_package$QName().init___T__T("", "");
  return this
});
$c_Lamf_core_utils_package$QName$.prototype.apply__T__Lamf_core_utils_package$QName = (function(fqn) {
  var thiz = $m_Lorg_mulesoft_common_core_package$Strings$().notNull$extension__T__T(fqn);
  var x = $as_T(thiz.trim());
  var this$4 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$4)) {
    var x1 = $m_sjsr_RuntimeString$().lastIndexOf__T__I__I(fqn, 46);
    switch (x1) {
      case (-1): {
        return new $c_Lamf_core_utils_package$QName().init___T__T("", fqn);
        break
      }
      default: {
        var jsx$1 = $as_T(fqn.substring(0, x1));
        var beginIndex = ((1 + x1) | 0);
        return new $c_Lamf_core_utils_package$QName().init___T__T(jsx$1, $as_T(fqn.substring(beginIndex)))
      }
    }
  } else {
    return this.Empty$1
  }
});
var $d_Lamf_core_utils_package$QName$ = new $TypeData().initClass({
  Lamf_core_utils_package$QName$: 0
}, false, "amf.core.utils.package$QName$", {
  Lamf_core_utils_package$QName$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_utils_package$QName$.prototype.$classData = $d_Lamf_core_utils_package$QName$;
var $n_Lamf_core_utils_package$QName$ = (void 0);
function $m_Lamf_core_utils_package$QName$() {
  if ((!$n_Lamf_core_utils_package$QName$)) {
    $n_Lamf_core_utils_package$QName$ = new $c_Lamf_core_utils_package$QName$().init___()
  };
  return $n_Lamf_core_utils_package$QName$
}
/** @constructor */
function $c_Lamf_core_validation_AMFValidationReport$() {
  $c_O.call(this)
}
$c_Lamf_core_validation_AMFValidationReport$.prototype = new $h_O();
$c_Lamf_core_validation_AMFValidationReport$.prototype.constructor = $c_Lamf_core_validation_AMFValidationReport$;
/** @constructor */
function $h_Lamf_core_validation_AMFValidationReport$() {
  /*<skip>*/
}
$h_Lamf_core_validation_AMFValidationReport$.prototype = $c_Lamf_core_validation_AMFValidationReport$.prototype;
$c_Lamf_core_validation_AMFValidationReport$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_validation_AMFValidationReport$.prototype.apply__T__Lamf_ProfileName__sc_Seq__Lamf_core_validation_AMFValidationReport = (function(model, profile, results) {
  return new $c_Lamf_core_validation_AMFValidationReport().init___Z__T__Lamf_ProfileName__sc_Seq((!results.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_validation_AMFValidationResult(x$2$2);
      return (x$2.level$1 === $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1)
    })
  })(this)))), model, profile, results)
});
var $d_Lamf_core_validation_AMFValidationReport$ = new $TypeData().initClass({
  Lamf_core_validation_AMFValidationReport$: 0
}, false, "amf.core.validation.AMFValidationReport$", {
  Lamf_core_validation_AMFValidationReport$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_validation_AMFValidationReport$.prototype.$classData = $d_Lamf_core_validation_AMFValidationReport$;
var $n_Lamf_core_validation_AMFValidationReport$ = (void 0);
function $m_Lamf_core_validation_AMFValidationReport$() {
  if ((!$n_Lamf_core_validation_AMFValidationReport$)) {
    $n_Lamf_core_validation_AMFValidationReport$ = new $c_Lamf_core_validation_AMFValidationReport$().init___()
  };
  return $n_Lamf_core_validation_AMFValidationReport$
}
/** @constructor */
function $c_Lamf_core_validation_AMFValidationResult$() {
  $c_O.call(this)
}
$c_Lamf_core_validation_AMFValidationResult$.prototype = new $h_O();
$c_Lamf_core_validation_AMFValidationResult$.prototype.constructor = $c_Lamf_core_validation_AMFValidationResult$;
/** @constructor */
function $h_Lamf_core_validation_AMFValidationResult$() {
  /*<skip>*/
}
$h_Lamf_core_validation_AMFValidationResult$.prototype = $c_Lamf_core_validation_AMFValidationResult$.prototype;
$c_Lamf_core_validation_AMFValidationResult$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_validation_AMFValidationResult$.prototype.fromSHACLValidation__Lamf_core_model_document_BaseUnit__T__T__Lamf_core_validation_core_ValidationResult__Lamf_core_validation_AMFValidationResult = (function(model, message, level, validation) {
  var rc6 = false;
  var x3 = null;
  var id = validation.focusNode__T();
  var x1 = $f_Lamf_core_model_document_BaseUnit__findById__T__s_Option(model, id);
  var x = $m_s_None$();
  if ((x === x1)) {
    rc6 = true;
    x3 = x1;
    if ((validation.focusNode__T() === model.id__T())) {
      var targetNode = model.id__T();
      var targetProperty = $m_s_Option$().apply__O__s_Option(validation.path__T());
      var validationId = validation.sourceShape__T();
      var position = new $c_s_Some().init___O(new $c_Lamf_core_annotations_LexicalInformation().init___Lamf_core_parser_Range($m_Lamf_core_parser_Range$NONE$()));
      var location = $f_Lamf_core_model_document_BaseUnit__location__s_Option(model);
      return new $c_Lamf_core_validation_AMFValidationResult().init___T__T__T__s_Option__T__s_Option__s_Option__O(message, level, targetNode, targetProperty, validationId, position, location, validation)
    }
  };
  if (rc6) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot find node with validation error " + validation.focusNode__T())))
  };
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var node = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    var x1$2 = this.findPositionAndLocation__p1__Lamf_core_model_domain_DomainElement__Lamf_core_validation_core_ValidationResult__T2(node, validation);
    if ((x1$2 === null)) {
      throw new $c_s_MatchError().init___O(x1$2)
    };
    var pos = $as_s_Option(x1$2.$$und1__O());
    var location$1 = $as_s_Option(x1$2.$$und2__O());
    var targetNode$1 = node.id__T();
    var targetProperty$1 = $m_s_Option$().apply__O__s_Option(validation.path__T());
    var validationId$1 = validation.sourceShape__T();
    return new $c_Lamf_core_validation_AMFValidationResult().init___T__T__T__s_Option__T__s_Option__s_Option__O(message, level, targetNode$1, targetProperty$1, validationId$1, pos, location$1, validation)
  };
  throw new $c_s_MatchError().init___O(x1)
});
$c_Lamf_core_validation_AMFValidationResult$.prototype.findPositionAndLocation__p1__Lamf_core_model_domain_DomainElement__Lamf_core_validation_core_ValidationResult__T2 = (function(node, validation) {
  if (($m_s_Option$().apply__O__s_Option(validation.path__T()).isDefined__Z() && (validation.path__T() !== ""))) {
    var rc6 = false;
    var x2 = null;
    var this$1 = node.fields__Lamf_core_parser_Fields();
    var this$4 = this$1.fs$1;
    var this$2 = $m_Lamf_core_parser_FieldEntry$();
    var f = $f_F2__tupled__F1(this$2);
    var this$3 = $m_sci_Iterable$();
    var bf = this$3.ReusableCBFInstance$2;
    var x1 = $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$4, f, bf)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, validation$1) {
      return (function(f$2) {
        var f$1 = $as_Lamf_core_parser_FieldEntry(f$2);
        return (f$1.field$1.value$1.iri__T() === validation$1.path__T())
      })
    })(this, validation)));
    matchEnd7: {
      var annotations;
      if ((x1 instanceof $c_s_Some)) {
        rc6 = true;
        x2 = $as_s_Some(x1);
        var f$3 = $as_Lamf_core_parser_FieldEntry(x2.value$2);
        if (f$3.value$1.value$1.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_LexicalInformation.getClassOf())) {
          var annotations = f$3.value$1.value$1.annotations__Lamf_core_parser_Annotations();
          break matchEnd7
        }
      };
      if (rc6) {
        var f$4 = $as_Lamf_core_parser_FieldEntry(x2.value$2);
        if (f$4.value$1.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_LexicalInformation.getClassOf())) {
          var annotations = f$4.value$1.annotations$1;
          break matchEnd7
        }
      };
      if (rc6) {
        var f$5 = $as_Lamf_core_parser_FieldEntry(x2.value$2);
        var x1$2 = f$5.value$1.value$1;
        if ((x1$2 instanceof $c_Lamf_core_model_domain_AmfArray)) {
          var x2$2 = $as_Lamf_core_model_domain_AmfArray(x1$2);
          if (x2$2.values$1.nonEmpty__Z()) {
            var annotations = $as_Lamf_core_model_domain_AmfElement(x2$2.values$1.head__O()).annotations__Lamf_core_parser_Annotations();
            break matchEnd7
          }
        };
        var annotations = node.annotations__Lamf_core_parser_Annotations();
        break matchEnd7
      };
      var annotations = node.annotations__Lamf_core_parser_Annotations()
    }
  } else {
    var annotations = node.annotations__Lamf_core_parser_Annotations()
  };
  var jsx$2 = annotations.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  var this$5 = annotations.find__jl_Class__s_Option($d_Lamf_core_annotations_SourceLocation.getClassOf());
  if (this$5.isEmpty__Z()) {
    var jsx$1 = $m_s_None$()
  } else {
    var arg1 = this$5.get__O();
    var x$6 = $as_Lamf_core_annotations_SourceLocation(arg1);
    var jsx$1 = new $c_s_Some().init___O(x$6.location$1)
  };
  return new $c_T2().init___O__O(jsx$2, jsx$1)
});
var $d_Lamf_core_validation_AMFValidationResult$ = new $TypeData().initClass({
  Lamf_core_validation_AMFValidationResult$: 0
}, false, "amf.core.validation.AMFValidationResult$", {
  Lamf_core_validation_AMFValidationResult$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_validation_AMFValidationResult$.prototype.$classData = $d_Lamf_core_validation_AMFValidationResult$;
var $n_Lamf_core_validation_AMFValidationResult$ = (void 0);
function $m_Lamf_core_validation_AMFValidationResult$() {
  if ((!$n_Lamf_core_validation_AMFValidationResult$)) {
    $n_Lamf_core_validation_AMFValidationResult$ = new $c_Lamf_core_validation_AMFValidationResult$().init___()
  };
  return $n_Lamf_core_validation_AMFValidationResult$
}
/** @constructor */
function $c_Lamf_core_validation_core_ValidationSpecification$() {
  $c_O.call(this);
  this.CORE$undVALIDATION$1 = null;
  this.AML$undVALIDATION$1 = null;
  this.PARSER$undSIDE$undVALIDATION$1 = null;
  this.PAYLOAD$undVALIDATION$1 = null;
  this.RENDER$undSIDE$undVALIDATION$1 = null;
  this.RESOLUTION$undSIDE$undVALIDATION$1 = null
}
$c_Lamf_core_validation_core_ValidationSpecification$.prototype = new $h_O();
$c_Lamf_core_validation_core_ValidationSpecification$.prototype.constructor = $c_Lamf_core_validation_core_ValidationSpecification$;
/** @constructor */
function $h_Lamf_core_validation_core_ValidationSpecification$() {
  /*<skip>*/
}
$h_Lamf_core_validation_core_ValidationSpecification$.prototype = $c_Lamf_core_validation_core_ValidationSpecification$.prototype;
$c_Lamf_core_validation_core_ValidationSpecification$.prototype.init___ = (function() {
  $n_Lamf_core_validation_core_ValidationSpecification$ = this;
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.CORE$undVALIDATION$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "CoreShape").iri__T();
  var this$3 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.AML$undVALIDATION$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "AmlShape").iri__T();
  var this$5 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.PARSER$undSIDE$undVALIDATION$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$5, "ParserShape").iri__T();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.PAYLOAD$undVALIDATION$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "PayloadShape").iri__T();
  var this$9 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.RENDER$undSIDE$undVALIDATION$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$9, "RenderShape").iri__T();
  var this$11 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.RESOLUTION$undSIDE$undVALIDATION$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$11, "ResolutionShape").iri__T();
  return this
});
var $d_Lamf_core_validation_core_ValidationSpecification$ = new $TypeData().initClass({
  Lamf_core_validation_core_ValidationSpecification$: 0
}, false, "amf.core.validation.core.ValidationSpecification$", {
  Lamf_core_validation_core_ValidationSpecification$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_validation_core_ValidationSpecification$.prototype.$classData = $d_Lamf_core_validation_core_ValidationSpecification$;
var $n_Lamf_core_validation_core_ValidationSpecification$ = (void 0);
function $m_Lamf_core_validation_core_ValidationSpecification$() {
  if ((!$n_Lamf_core_validation_core_ValidationSpecification$)) {
    $n_Lamf_core_validation_core_ValidationSpecification$ = new $c_Lamf_core_validation_core_ValidationSpecification$().init___()
  };
  return $n_Lamf_core_validation_core_ValidationSpecification$
}
/** @constructor */
function $c_Lamf_core_vocabulary_Namespace$() {
  $c_O.call(this);
  this.Document$1 = null;
  this.ApiContract$1 = null;
  this.ApiBinding$1 = null;
  this.Security$1 = null;
  this.Shapes$1 = null;
  this.Data$1 = null;
  this.SourceMaps$1 = null;
  this.Shacl$1 = null;
  this.Core$1 = null;
  this.Xsd$1 = null;
  this.AnonShapes$1 = null;
  this.Rdf$1 = null;
  this.WihtoutNamespace$1 = null;
  this.Meta$1 = null;
  this.Owl$1 = null;
  this.Rdfs$1 = null;
  this.AmfCore$1 = null;
  this.AmfAml$1 = null;
  this.AmfParser$1 = null;
  this.AmfResolution$1 = null;
  this.AmfValidation$1 = null;
  this.AmfRender$1 = null;
  this.ns$1 = null
}
$c_Lamf_core_vocabulary_Namespace$.prototype = new $h_O();
$c_Lamf_core_vocabulary_Namespace$.prototype.constructor = $c_Lamf_core_vocabulary_Namespace$;
/** @constructor */
function $h_Lamf_core_vocabulary_Namespace$() {
  /*<skip>*/
}
$h_Lamf_core_vocabulary_Namespace$.prototype = $c_Lamf_core_vocabulary_Namespace$.prototype;
$c_Lamf_core_vocabulary_Namespace$.prototype.init___ = (function() {
  $n_Lamf_core_vocabulary_Namespace$ = this;
  this.Document$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("http://a.ml/vocabularies/document#");
  this.ApiContract$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("http://a.ml/vocabularies/apiContract#");
  this.ApiBinding$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("http://a.ml/vocabularies/apiBinding#");
  this.Security$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("http://a.ml/vocabularies/security#");
  this.Shapes$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("http://a.ml/vocabularies/shapes#");
  this.Data$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("http://a.ml/vocabularies/data#");
  this.SourceMaps$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("http://a.ml/vocabularies/document-source-maps#");
  this.Shacl$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("http://www.w3.org/ns/shacl#");
  this.Core$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("http://a.ml/vocabularies/core#");
  this.Xsd$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("http://www.w3.org/2001/XMLSchema#");
  this.AnonShapes$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("http://a.ml/vocabularies/shapes/anon#");
  this.Rdf$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("http://www.w3.org/1999/02/22-rdf-syntax-ns#");
  this.WihtoutNamespace$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("");
  this.Meta$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("http://a.ml/vocabularies/meta#");
  this.Owl$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("http://www.w3.org/2002/07/owl#");
  this.Rdfs$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("http://www.w3.org/2000/01/rdf-schema#");
  this.AmfCore$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("http://a.ml/vocabularies/amf/core#");
  this.AmfAml$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("http://a.ml/vocabularies/amf/aml#");
  this.AmfParser$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("http://a.ml/vocabularies/amf/parser#");
  this.AmfResolution$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("http://a.ml/vocabularies/amf/resolution#");
  this.AmfValidation$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("http://a.ml/vocabularies/amf/validation#");
  this.AmfRender$1 = new $c_Lamf_core_vocabulary_Namespace().init___T("http://a.ml/vocabularies/amf/render#");
  var y = this.Rdf$1;
  var jsx$21 = new $c_T2().init___O__O("rdf", y);
  var y$1 = this.Shacl$1;
  var jsx$20 = new $c_T2().init___O__O("sh", y$1);
  var y$2 = this.Shacl$1;
  var jsx$19 = new $c_T2().init___O__O("shacl", y$2);
  var y$3 = this.Security$1;
  var jsx$18 = new $c_T2().init___O__O("security", y$3);
  var y$4 = this.Core$1;
  var jsx$17 = new $c_T2().init___O__O("core", y$4);
  var y$5 = this.Document$1;
  var jsx$16 = new $c_T2().init___O__O("raml-doc", y$5);
  var y$6 = this.Document$1;
  var jsx$15 = new $c_T2().init___O__O("doc", y$6);
  var y$7 = this.Xsd$1;
  var jsx$14 = new $c_T2().init___O__O("xsd", y$7);
  var y$8 = this.AmfParser$1;
  var jsx$13 = new $c_T2().init___O__O("amf-parser", y$8);
  var y$9 = this.AmfCore$1;
  var jsx$12 = new $c_T2().init___O__O("amf-core", y$9);
  var y$10 = this.ApiContract$1;
  var jsx$11 = new $c_T2().init___O__O("apiContract", y$10);
  var y$11 = this.ApiBinding$1;
  var jsx$10 = new $c_T2().init___O__O("apiBinding", y$11);
  var y$12 = this.AmfResolution$1;
  var jsx$9 = new $c_T2().init___O__O("amf-resolution", y$12);
  var y$13 = this.AmfValidation$1;
  var jsx$8 = new $c_T2().init___O__O("amf-validation", y$13);
  var y$14 = this.AmfRender$1;
  var jsx$7 = new $c_T2().init___O__O("amf-render", y$14);
  var y$15 = this.Shapes$1;
  var jsx$6 = new $c_T2().init___O__O("raml-shapes", y$15);
  var y$16 = this.Shapes$1;
  var jsx$5 = new $c_T2().init___O__O("shapes", y$16);
  var y$17 = this.Data$1;
  var jsx$4 = new $c_T2().init___O__O("data", y$17);
  var y$18 = this.SourceMaps$1;
  var jsx$3 = new $c_T2().init___O__O("sourcemaps", y$18);
  var y$19 = this.Meta$1;
  var jsx$2 = new $c_T2().init___O__O("meta", y$19);
  var y$20 = this.Owl$1;
  var jsx$1 = new $c_T2().init___O__O("owl", y$20);
  var y$21 = this.Rdfs$1;
  var array = [jsx$21, jsx$20, jsx$19, jsx$18, jsx$17, jsx$16, jsx$15, jsx$14, jsx$13, jsx$12, jsx$11, jsx$10, jsx$9, jsx$8, jsx$7, jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, jsx$1, new $c_T2().init___O__O("rdfs", y$21)];
  var this$48 = new $c_scm_HashMap().init___();
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$48.$$plus$eq__T2__scm_HashMap($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  this.ns$1 = this$48;
  return this
});
$c_Lamf_core_vocabulary_Namespace$.prototype.compact__T__T = (function(uri) {
  var this$1 = this.ns$1;
  var this$2 = this$1.iterator__sc_Iterator();
  inlinereturn$3: {
    while (this$2.hasNext__Z()) {
      var a = this$2.next__O();
      var x0$1 = $as_T2(a);
      if ((x0$1 === null)) {
        throw new $c_s_MatchError().init___O(x0$1)
      };
      var namespace = $as_Lamf_core_vocabulary_Namespace(x0$1.$$und2__O());
      var str = namespace.base$1;
      if (($uI(uri.indexOf(str)) === 0)) {
        var x1 = new $c_s_Some().init___O(a);
        break inlinereturn$3
      }
    };
    var x1 = $m_s_None$()
  };
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var p3 = $as_T2(x2.value$2);
    if ((p3 !== null)) {
      var prefix = $as_T(p3.$$und1__O());
      var namespace$1 = $as_Lamf_core_vocabulary_Namespace(p3.$$und2__O());
      var this$9 = new $c_sci_StringOps().init___T(prefix);
      var target = namespace$1.base$1;
      var x = $as_T(uri.split(target).join(":"));
      var that = new $c_sci_StringOps().init___T(x);
      var bf = $m_s_Predef$().StringCanBuildFrom$2;
      return $as_T($f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this$9, that, bf))
    }
  };
  var x$1 = $m_s_None$();
  if ((x$1 === x1)) {
    return uri
  };
  throw new $c_s_MatchError().init___O(x1)
});
$c_Lamf_core_vocabulary_Namespace$.prototype.compactAndCollect__T__scm_Map__T = (function(uri, prefixes) {
  var this$1 = this.ns$1;
  var this$2 = this$1.iterator__sc_Iterator();
  inlinereturn$3: {
    while (this$2.hasNext__Z()) {
      var a = this$2.next__O();
      var x0$1 = $as_T2(a);
      if ((x0$1 === null)) {
        throw new $c_s_MatchError().init___O(x0$1)
      };
      var namespace = $as_Lamf_core_vocabulary_Namespace(x0$1.$$und2__O());
      var str = namespace.base$1;
      if (($uI(uri.indexOf(str)) === 0)) {
        var x1 = new $c_s_Some().init___O(a);
        break inlinereturn$3
      }
    };
    var x1 = $m_s_None$()
  };
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var p3 = $as_T2(x2.value$2);
    if ((p3 !== null)) {
      var prefix = $as_T(p3.$$und1__O());
      var namespace$1 = $as_Lamf_core_vocabulary_Namespace(p3.$$und2__O());
      prefixes.put__O__O__s_Option(prefix, namespace$1.base$1);
      var this$9 = new $c_sci_StringOps().init___T(prefix);
      var target = namespace$1.base$1;
      var x = $as_T(uri.split(target).join(":"));
      var that = new $c_sci_StringOps().init___T(x);
      var bf = $m_s_Predef$().StringCanBuildFrom$2;
      return $as_T($f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this$9, that, bf))
    }
  };
  var x$1 = $m_s_None$();
  if ((x$1 === x1)) {
    return uri
  };
  throw new $c_s_MatchError().init___O(x1)
});
$c_Lamf_core_vocabulary_Namespace$.prototype.uri__T__Lamf_core_vocabulary_ValueType = (function(s) {
  if (($uI(s.indexOf(":")) > (-1))) {
    return this.expand__T__Lamf_core_vocabulary_ValueType(s)
  } else {
    var this$3 = this.ns$1;
    var this$4 = new $c_scm_HashMap$$anon$2().init___scm_HashMap(this$3);
    var this$5 = this$4.$$outer$3.valuesIterator__sc_Iterator();
    inlinereturn$7: {
      while (this$5.hasNext__Z()) {
        var a = this$5.next__O();
        var n = $as_Lamf_core_vocabulary_Namespace(a);
        var str = n.base$1;
        if (($uI(s.indexOf(str)) === 0)) {
          var x1 = new $c_s_Some().init___O(a);
          break inlinereturn$7
        }
      };
      var x1 = $m_s_None$()
    };
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var foundNs = $as_Lamf_core_vocabulary_Namespace(x2.value$2);
      var regex = foundNs.base$1;
      var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(s, regex, 0);
      var this$10 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
      var name = $as_T($f_sc_IndexedSeqOptimized__last__O(this$10));
      return new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(foundNs, name)
    } else {
      return $m_Lamf_core_vocabulary_ValueType$().apply__T__Lamf_core_vocabulary_ValueType(s)
    }
  }
});
$c_Lamf_core_vocabulary_Namespace$.prototype.registerNamespace__T__T__s_Option = (function(alias, prefix) {
  return this.ns$1.put__O__O__s_Option(alias, new $c_Lamf_core_vocabulary_Namespace().init___T(prefix))
});
$c_Lamf_core_vocabulary_Namespace$.prototype.expand__T__Lamf_core_vocabulary_ValueType = (function(uri) {
  if ((($uI(uri.length) >= 0) && ($as_T(uri.substring(0, $uI("http://".length))) === "http://"))) {
    return $m_Lamf_core_vocabulary_ValueType$().apply__T__Lamf_core_vocabulary_ValueType(uri)
  } else {
    var x1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(uri, ":", 0);
    var o7 = $m_s_Array$().unapplySeq__O__s_Option(x1);
    if (((!o7.isEmpty__Z()) && ((o7.get__O() !== null) && ($as_sc_SeqLike(o7.get__O()).lengthCompare__I__I(2) === 0)))) {
      var prefix = $as_T($as_sc_SeqLike(o7.get__O()).apply__I__O(0));
      var postfix = $as_T($as_sc_SeqLike(o7.get__O()).apply__I__O(1));
      var x1$2 = this.ns$1.get__O__s_Option(prefix);
      if ((x1$2 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1$2);
        var n = $as_Lamf_core_vocabulary_Namespace(x2.value$2);
        return new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(n, postfix)
      } else {
        return $m_Lamf_core_vocabulary_ValueType$().apply__T__Lamf_core_vocabulary_ValueType(uri)
      }
    };
    return $m_Lamf_core_vocabulary_ValueType$().apply__T__Lamf_core_vocabulary_ValueType(uri)
  }
});
$c_Lamf_core_vocabulary_Namespace$.prototype.find__T__s_Option = (function(uri) {
  return ((uri === "http://a.ml/vocabularies/document") ? new $c_s_Some().init___O(this.Document$1) : ((uri === "http://a.ml/vocabularies/apiContract") ? new $c_s_Some().init___O(this.ApiContract$1) : ((uri === "http://a.ml/vocabularies/apiBinding") ? new $c_s_Some().init___O(this.ApiBinding$1) : ((uri === "http://a.ml/vocabularies/security") ? new $c_s_Some().init___O(this.Security$1) : ((uri === "http://a.ml/vocabularies/shapes") ? new $c_s_Some().init___O(this.Shapes$1) : ((uri === "http://a.ml/vocabularies/data") ? new $c_s_Some().init___O(this.Data$1) : ((uri === "http://a.ml/vocabularies/document-source-maps") ? new $c_s_Some().init___O(this.SourceMaps$1) : ((uri === "http://www.w3.org/ns/shacl") ? new $c_s_Some().init___O(this.Shacl$1) : ((uri === "http://a.ml/vocabularies/core#") ? new $c_s_Some().init___O(this.Core$1) : ((uri === "http://www.w3.org/2001/XMLSchema") ? new $c_s_Some().init___O(this.Xsd$1) : ((uri === "http://a.ml/vocabularies/shapes/anon") ? new $c_s_Some().init___O(this.AnonShapes$1) : ((uri === "http://www.w3.org/1999/02/22-rdf-syntax-ns") ? new $c_s_Some().init___O(this.Rdf$1) : ((uri === "") ? new $c_s_Some().init___O(this.WihtoutNamespace$1) : ((uri === "http://a.ml/vocabularies/meta") ? new $c_s_Some().init___O(this.Meta$1) : ((uri === "http://www.w3.org/2002/07/owl") ? new $c_s_Some().init___O(this.Owl$1) : ((uri === "http://www.w3.org/2000/01/rdf-schema") ? new $c_s_Some().init___O(this.Rdfs$1) : ((uri === "http://a.ml/vocabularies/amf/parser") ? new $c_s_Some().init___O(this.AmfParser$1) : $m_s_None$())))))))))))))))))
});
var $d_Lamf_core_vocabulary_Namespace$ = new $TypeData().initClass({
  Lamf_core_vocabulary_Namespace$: 0
}, false, "amf.core.vocabulary.Namespace$", {
  Lamf_core_vocabulary_Namespace$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_vocabulary_Namespace$.prototype.$classData = $d_Lamf_core_vocabulary_Namespace$;
var $n_Lamf_core_vocabulary_Namespace$ = (void 0);
function $m_Lamf_core_vocabulary_Namespace$() {
  if ((!$n_Lamf_core_vocabulary_Namespace$)) {
    $n_Lamf_core_vocabulary_Namespace$ = new $c_Lamf_core_vocabulary_Namespace$().init___()
  };
  return $n_Lamf_core_vocabulary_Namespace$
}
/** @constructor */
function $c_Lamf_core_vocabulary_ValueType$() {
  $c_O.call(this)
}
$c_Lamf_core_vocabulary_ValueType$.prototype = new $h_O();
$c_Lamf_core_vocabulary_ValueType$.prototype.constructor = $c_Lamf_core_vocabulary_ValueType$;
/** @constructor */
function $h_Lamf_core_vocabulary_ValueType$() {
  /*<skip>*/
}
$h_Lamf_core_vocabulary_ValueType$.prototype = $c_Lamf_core_vocabulary_ValueType$.prototype;
$c_Lamf_core_vocabulary_ValueType$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_vocabulary_ValueType$.prototype.apply__T__Lamf_core_vocabulary_ValueType = (function(iri) {
  if (($uI(iri.indexOf("#")) !== (-1))) {
    var pair = $m_sjsr_RuntimeString$().split__T__T__I__AT(iri, "#", 0);
    var this$6 = new $c_scm_ArrayOps$ofRef().init___AO(pair);
    var name = $as_T($f_sc_IndexedSeqOptimized__last__O(this$6));
    var this$8 = new $c_scm_ArrayOps$ofRef().init___AO(pair);
    var ns = ($as_T($f_sc_IndexedSeqOptimized__head__O(this$8)) + "#");
    return new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(new $c_Lamf_core_vocabulary_Namespace().init___T(ns), name)
  } else {
    var thiz = $as_T(iri.split("://").join("_"));
    if (($uI(thiz.indexOf("/")) !== (-1))) {
      var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(iri, "/", 0);
      var this$16 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
      var name$2 = $as_T($f_sc_IndexedSeqOptimized__last__O(this$16));
      var ns$2 = $as_T(iri.split(name$2).join(""));
      return new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(new $c_Lamf_core_vocabulary_Namespace().init___T(ns$2), name$2)
    } else {
      return new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(new $c_Lamf_core_vocabulary_Namespace().init___T(iri), "")
    }
  }
});
var $d_Lamf_core_vocabulary_ValueType$ = new $TypeData().initClass({
  Lamf_core_vocabulary_ValueType$: 0
}, false, "amf.core.vocabulary.ValueType$", {
  Lamf_core_vocabulary_ValueType$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_vocabulary_ValueType$.prototype.$classData = $d_Lamf_core_vocabulary_ValueType$;
var $n_Lamf_core_vocabulary_ValueType$ = (void 0);
function $m_Lamf_core_vocabulary_ValueType$() {
  if ((!$n_Lamf_core_vocabulary_ValueType$)) {
    $n_Lamf_core_vocabulary_ValueType$ = new $c_Lamf_core_vocabulary_ValueType$().init___()
  };
  return $n_Lamf_core_vocabulary_ValueType$
}
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter() {
  $c_O.call(this);
  this.builder$1 = null;
  this.options$1 = null;
  this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f = null;
  this.pending$1 = null;
  this.root$1 = null
}
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype;
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$scalar__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V = (function(b, content, t) {
  this.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(b, $objectToString($as_Lamf_core_model_domain_AmfScalar(content).value$1), t)
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.root__Lamf_core_model_document_BaseUnit__V = (function(unit) {
  this.builder$1.obj__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, unit$1) {
    return (function(ob$2) {
      var ob = $as_Lorg_yaml_builder_DocBuilder$Entry(ob$2);
      ob.entry__T__F1__V("@graph", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, unit$1$1) {
        return (function(x$1$2) {
          var x$1 = $as_Lorg_yaml_builder_DocBuilder$Part(x$1$2);
          x$1.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, unit$1$2) {
            return (function(rootBuilder$2) {
              var rootBuilder = $as_Lorg_yaml_builder_DocBuilder$Part(rootBuilder$2);
              $this$2.root$1 = rootBuilder;
              var declarationsEntry = unit$1$2.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_document_ModuleModel$().Declares$1);
              var referencesEntry = unit$1$2.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_document_ModuleModel$().References$1);
              var annotations = unit$1$2.annotations__Lamf_core_parser_Annotations();
              var ctx = $this$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f;
              $f_Lamf_plugins_document_graph_emitter_CommonEmitter__extractDeclarationsAndReferencesToContext__s_Option__s_Option__Lamf_core_parser_Annotations__Lamf_plugins_document_graph_emitter_EmissionContext__Lamf_plugins_document_graph_emitter_EmissionContext($this$2, declarationsEntry, referencesEntry, annotations, ctx);
              unit$1$2.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_core_metamodel_document_ModuleModel$().Declares$1);
              unit$1$2.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_core_metamodel_document_ModuleModel$().References$1);
              matchEnd4: {
                if ($is_Lamf_core_model_document_EncodesModel(unit$1$2)) {
                  if ($this$2.isSelfEncoded__p1__Lamf_core_model_document_BaseUnit__Z(unit$1$2)) {
                    $this$2.queueObjectFieldValues__Lamf_core_model_domain_AmfObject__F2__V(unit$1$2, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this$3) {
                      return (function(f$2, x$2$2) {
                        var f = $as_Lamf_core_metamodel_Field(f$2);
                        $as_Lamf_core_parser_Value(x$2$2);
                        var x$3 = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
                        return (!((f === null) ? (x$3 === null) : f.equals__O__Z(x$3)))
                      })
                    })($this$2)));
                    $this$2.queueObjectFieldValues__Lamf_core_model_domain_AmfObject__F2__V($as_Lamf_core_model_document_EncodesModel(unit$1$2).encodes__Lamf_core_model_domain_DomainElement(), $this$2.queueObjectFieldValues$default$2__F2());
                    break matchEnd4
                  }
                };
                $this$2.queueObjectFieldValues__Lamf_core_model_domain_AmfObject__F2__V(unit$1$2, $this$2.queueObjectFieldValues$default$2__F2())
              };
              while ($this$2.pending$1.hasPendingEmissions__Z()) {
                var emission = $this$2.pending$1.nextEmission__Lamf_plugins_document_graph_emitter_flattened_utils_Emission();
                emission.fn$1.apply__O__O($this$2.root$1)
              };
              if ($this$2.isSelfEncoded__p1__Lamf_core_model_document_BaseUnit__Z(unit$1$2)) {
                $this$2.emitSelfEncodedBaseUnitNode__Lamf_core_model_document_BaseUnit__V(unit$1$2)
              } else {
                $this$2.emitBaseUnitNode__Lamf_core_model_document_BaseUnit__V(unit$1$2)
              };
              while ($this$2.pending$1.hasPendingEmissions__Z()) {
                var emission$2 = $this$2.pending$1.nextEmission__Lamf_plugins_document_graph_emitter_flattened_utils_Emission();
                $this$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingDeclarations$1 = $as_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata(emission$2).isDeclaration__Z();
                $this$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingReferences$1 = $as_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata(emission$2).isReference__Z();
                emission$2.fn$1.apply__O__O($this$2.root$1)
              };
              while (true) {
                var this$1 = $this$2.pending$1;
                var this$2 = this$1.pendingExternalLinks$1;
                if ($f_sc_TraversableOnce__nonEmpty__Z(this$2)) {
                  var emission$3 = $this$2.pending$1.nextExternalEmission__Lamf_plugins_document_graph_emitter_flattened_utils_Emission();
                  $this$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingDeclarations$1 = $as_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata(emission$3).isDeclaration__Z();
                  $this$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingReferences$1 = $as_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata(emission$3).isReference__Z();
                  emission$3.fn$1.apply__O__O($this$2.root$1)
                } else {
                  break
                }
              };
              while ($this$2.pending$1.hasPendingEmissions__Z()) {
                var emission$4 = $this$2.pending$1.nextEmission__Lamf_plugins_document_graph_emitter_flattened_utils_Emission();
                $this$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingDeclarations$1 = $as_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata(emission$4).isDeclaration__Z();
                $this$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingReferences$1 = $as_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata(emission$4).isReference__Z();
                emission$4.fn$1.apply__O__O($this$2.root$1)
              }
            })
          })($this$1, unit$1$1)))
        })
      })($this, unit$1)));
      $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emitContext__Lorg_yaml_builder_DocBuilder$Entry__V(ob)
    })
  })(this, unit)))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.emit$1__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfObject__V = (function(b, obj$1) {
  b.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, obj$1$1) {
    return (function(x$17$2) {
      var x$17 = $as_Lorg_yaml_builder_DocBuilder$Entry(x$17$2);
      $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createIdNode__Lorg_yaml_builder_DocBuilder$Entry__T__V(x$17, obj$1$1.id__T())
    })
  })(this, obj$1)));
  this.pending$1.tryEnqueue__Lamf_plugins_document_graph_emitter_flattened_utils_Emission__s_util_Try(this.object2Emission__Lamf_core_model_domain_AmfObject__Lamf_plugins_document_graph_emitter_flattened_utils_Emission(obj$1))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.createEternalsAnnotationsNodes__p1__T__Lamf_core_emitter_RenderOptions__Lorg_yaml_builder_DocBuilder$Entry__Lamf_core_model_document_SourceMap__V = (function(id, options, b, sources) {
  var this$1 = sources.eternals$1;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$1)) {
    if (options.rawSourceMaps$1) {
      b.entry__T__F1__V("smaps", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, id$1, sources$1) {
        return (function(x$28$2) {
          var x$28 = $as_Lorg_yaml_builder_DocBuilder$Part(x$28$2);
          x$28.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, id$10, sources$7) {
            return (function(b$2) {
              var b$1 = $as_Lorg_yaml_builder_DocBuilder$Entry(b$2);
              $this$1.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createAnnotationNodes__T__Lorg_yaml_builder_DocBuilder$Entry__scm_ListMap__V(id$10, b$1, sources$7.eternals$1)
            })
          })($this, id$1, sources$1)))
        })
      })(this, id, sources)))
    } else {
      b.entry__T__F1__V(this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emitIri__T__T($m_Lamf_core_metamodel_domain_DomainElementModel$().Sources$1.value$1.iri__T()), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, id$2, sources$2) {
        return (function(x$29$2) {
          var x$29 = $as_Lorg_yaml_builder_DocBuilder$Part(x$29$2);
          x$29.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, id$10$1, sources$7$1) {
            return (function(x$30$2) {
              var x$30 = $as_Lorg_yaml_builder_DocBuilder$Part(x$30$2);
              x$30.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, id$10$2, sources$7$2) {
                return (function(b$2$1) {
                  var b$3 = $as_Lorg_yaml_builder_DocBuilder$Entry(b$2$1);
                  $this$3.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createIdNode__Lorg_yaml_builder_DocBuilder$Entry__T__V(b$3, id$10$2);
                  var e = new $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5().init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__T__Lamf_core_model_document_SourceMap($this$3, id$10$2, sources$7$2);
                  e.id$2 = new $c_s_Some().init___O(id$10$2);
                  e.isDeclaration$2 = $this$3.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingDeclarations$1;
                  e.isReference$2 = $this$3.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingReferences$1;
                  $this$3.pending$1.tryEnqueue__Lamf_plugins_document_graph_emitter_flattened_utils_Emission__s_util_Try(e)
                })
              })($this$2, id$10$1, sources$7$1)))
            })
          })(this$2, id$2, sources$2)))
        })
      })(this, id, sources)))
    }
  }
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.emit$2__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_DomainElement__V = (function(b, elementWithLink$1) {
  var this$1 = $as_Lamf_core_model_domain_Linkable(elementWithLink$1);
  var savedLinkTarget = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1);
  var this$2 = $as_Lamf_core_model_domain_Linkable(elementWithLink$1);
  var this$3 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2);
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var target = $as_Lamf_core_model_domain_DomainElement(arg1);
    var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().TargetId$1;
    var value = target.id__T();
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(elementWithLink$1, field, value);
    elementWithLink$1.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_core_metamodel_domain_LinkableElementModel$().Target$1)
  };
  b.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, elementWithLink$1$1) {
    return (function(o$2) {
      var o = $as_Lorg_yaml_builder_DocBuilder$Entry(o$2);
      this$2$1.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createIdNode__Lorg_yaml_builder_DocBuilder$Entry__T__V(o, elementWithLink$1$1.id__T());
      this$2$1.pending$1.tryEnqueue__Lamf_plugins_document_graph_emitter_flattened_utils_Emission__s_util_Try(this$2$1.object2Emission__Lamf_core_model_domain_AmfObject__Lamf_plugins_document_graph_emitter_flattened_utils_Emission(elementWithLink$1$1))
    })
  })(this, elementWithLink$1)));
  if ((!savedLinkTarget.isEmpty__Z())) {
    var arg1$1 = savedLinkTarget.get__O();
    var target$3 = $as_Lamf_core_model_domain_DomainElement(arg1$1);
    elementWithLink$1.fields__Lamf_core_parser_Fields().setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_core_metamodel_domain_LinkableElementModel$().Target$1, target$3, (elementWithLink$1.fields__Lamf_core_parser_Fields(), $m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
  }
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.createSourcesNode__p1__T__Lamf_core_model_document_SourceMap__Lorg_yaml_builder_DocBuilder$Entry__V = (function(id, sources, b) {
  var this$1 = this.options$1;
  if (this$1.amf$core$emitter$RenderOptions$$sources$1) {
    var this$2 = sources.annotations$1;
    var jsx$1 = $f_sc_TraversableOnce__nonEmpty__Z(this$2)
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var this$3 = this.options$1;
    if (this$3.rawSourceMaps$1) {
      b.entry__T__F1__V("smaps", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, id$1, sources$1) {
        return (function(x$25$2) {
          var x$25 = $as_Lorg_yaml_builder_DocBuilder$Part(x$25$2);
          x$25.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, id$9, sources$6) {
            return (function(b$2) {
              var b$1 = $as_Lorg_yaml_builder_DocBuilder$Entry(b$2);
              $this$1.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createAnnotationNodes__T__Lorg_yaml_builder_DocBuilder$Entry__scm_ListMap__V(id$9, b$1, sources$6.annotations$1);
              $this$1.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createAnnotationNodes__T__Lorg_yaml_builder_DocBuilder$Entry__scm_ListMap__V(id$9, b$1, sources$6.eternals$1)
            })
          })($this, id$1, sources$1)))
        })
      })(this, id, sources)))
    } else {
      b.entry__T__F1__V(this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emitIri__T__T($m_Lamf_core_metamodel_domain_DomainElementModel$().Sources$1.value$1.iri__T()), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, id$2, sources$2) {
        return (function(x$26$2) {
          var x$26 = $as_Lorg_yaml_builder_DocBuilder$Part(x$26$2);
          x$26.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, id$9$1, sources$6$1) {
            return (function(x$27$2) {
              var x$27 = $as_Lorg_yaml_builder_DocBuilder$Part(x$27$2);
              x$27.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, id$9$2, sources$6$2) {
                return (function(b$2$1) {
                  var b$3 = $as_Lorg_yaml_builder_DocBuilder$Entry(b$2$1);
                  $this$3.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createIdNode__Lorg_yaml_builder_DocBuilder$Entry__T__V(b$3, id$9$2);
                  var e = new $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4().init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__T__Lamf_core_model_document_SourceMap($this$3, id$9$2, sources$6$2);
                  e.id$2 = new $c_s_Some().init___O(id$9$2);
                  e.isDeclaration$2 = $this$3.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingDeclarations$1;
                  e.isReference$2 = $this$3.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingReferences$1;
                  $this$3.pending$1.tryEnqueue__Lamf_plugins_document_graph_emitter_flattened_utils_Emission__s_util_Try(e)
                })
              })($this$2, id$9$1, sources$6$1)))
            })
          })(this$2$1, id$2, sources$2)))
        })
      })(this, id, sources)))
    }
  } else {
    this.createEternalsAnnotationsNodes__p1__T__Lamf_core_emitter_RenderOptions__Lorg_yaml_builder_DocBuilder$Entry__Lamf_core_model_document_SourceMap__V(id, this.options$1, b, sources)
  }
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.emitBaseUnitNode__Lamf_core_model_document_BaseUnit__V = (function(unit) {
  var id = unit.id__T();
  this.root$1.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, id$1, unit$1) {
    return (function(b$2) {
      var b = $as_Lorg_yaml_builder_DocBuilder$Entry(b$2);
      $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createIdNode__Lorg_yaml_builder_DocBuilder$Entry__T__V(b, id$1);
      $this.emitReferences__p1__Lorg_yaml_builder_DocBuilder$Entry__T__Lamf_core_model_document_SourceMap__V(b, unit$1.id__T(), $m_Lamf_core_model_document_SourceMap$().apply__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_document_SourceMap(unit$1.id__T(), unit$1));
      $this.emitDeclarations__p1__Lorg_yaml_builder_DocBuilder$Entry__T__Lamf_core_model_document_SourceMap__V(b, unit$1.id__T(), $m_Lamf_core_model_document_SourceMap$().apply__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_document_SourceMap(unit$1.id__T(), unit$1));
      var sources = $m_Lamf_core_model_document_SourceMap$().apply__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_document_SourceMap(id$1, unit$1);
      var obj = $f_Lamf_core_metamodel_MetaModelTypeMapping__metaModel__O__Lamf_core_metamodel_Obj($this, unit$1);
      var ctx = $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f;
      $f_Lamf_plugins_document_graph_emitter_CommonEmitter__createTypeNode__Lorg_yaml_builder_DocBuilder$Entry__Lamf_core_metamodel_Obj__Lamf_plugins_document_graph_emitter_EmissionContext__V($this, b, obj, ctx);
      $this.traverseMetaModel__T__Lamf_core_model_domain_AmfObject__Lamf_core_model_document_SourceMap__Lamf_core_metamodel_Obj__Lorg_yaml_builder_DocBuilder$Entry__V(id$1, unit$1, sources, obj, b);
      $this.createCustomExtensions__p1__Lamf_core_model_domain_AmfObject__Lorg_yaml_builder_DocBuilder$Entry__V(unit$1, b);
      var sourceMapId = $f_Lamf_plugins_document_graph_emitter_CommonEmitter__sourceMapIdFor__T__T($this, id$1);
      $this.createSourcesNode__p1__T__Lamf_core_model_document_SourceMap__Lorg_yaml_builder_DocBuilder$Entry__V(sourceMapId, sources, b)
    })
  })(this, id, unit)))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$safeIri__Lorg_yaml_builder_DocBuilder$Part__T__Z__V = (function(b, content, inArray) {
  if (inArray) {
    this.emit$4__p1__Lorg_yaml_builder_DocBuilder$Part__T__V(b, content)
  } else {
    b.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, content$1) {
      return (function(b$2$2) {
        var b$2 = $as_Lorg_yaml_builder_DocBuilder$Part(b$2$2);
        $this.emit$4__p1__Lorg_yaml_builder_DocBuilder$Part__T__V(b$2, content$1)
      })
    })(this, content)))
  }
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.queueObjectFieldValues$default$2__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(f$2, v$2) {
      $as_Lamf_core_metamodel_Field(f$2);
      $as_Lamf_core_parser_Value(v$2);
      return true
    })
  })(this))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.extractToLink__p1__Lamf_core_model_domain_Shape__Lorg_yaml_builder_DocBuilder$Part__Z__V = (function(shape, b, inArray) {
  var this$1 = this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f;
  if (((!this$1.declarations$1.contains__O__Z(shape)) && (!this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.isInReferencedShapes__Lamf_core_model_domain_AmfElement__Z(shape)))) {
    this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.$$plus__Lamf_core_model_domain_AmfElement__Lamf_plugins_document_graph_emitter_EmissionContext(shape);
    var x1 = $as_Lamf_core_model_StrField(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
    var x = $m_s_None$();
    if ((x === x1)) {
      $m_Lamf_core_parser_Annotations$();
      var a = new $c_Lamf_core_parser_Annotations().init___();
      $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, "inline-type", a);
      shape.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_InlineElement().init___())
    } else {
      matchEnd14: {
        var jsx$1;
        if ((x1 instanceof $c_s_Some)) {
          var x2 = $as_s_Some(x1);
          var p3 = $as_T(x2.value$2);
          if ((p3 === "schema")) {
            var jsx$1 = true;
            break matchEnd14
          }
        };
        if ((x1 instanceof $c_s_Some)) {
          var x4 = $as_s_Some(x1);
          var p5 = $as_T(x4.value$2);
          if ((p5 === "type")) {
            var jsx$1 = true;
            break matchEnd14
          }
        };
        var jsx$1 = false
      };
      if (jsx$1) {
        shape.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_InlineElement().init___())
      } else if ((!shape.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf()))) {
        shape.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_InlineElement().init___())
      }
    }
  };
  var this$3 = $as_Lamf_core_model_StrField(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
  var this$4 = this$3.option$1;
  var linkLabel = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
  if ((shape instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
    var x2$2 = $as_Lamf_core_model_domain_RecursiveShape(shape);
    var this$5 = (("" + x2$2.id$1) + linkLabel);
    var hash = $m_sjsr_RuntimeString$().hashCode__T__I(this$5);
    var fields = new $c_Lamf_core_parser_Fields().init___();
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var this$9 = new $c_Lamf_core_model_domain_RecursiveShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
    var value = ((x2$2.id$1 + "/link-") + hash);
    var this$10 = $as_Lamf_core_model_domain_Linkable($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$9, value));
    var this$11 = $as_Lamf_core_model_domain_Linkable($f_Lamf_core_model_domain_Linkable__withLinkTarget__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(this$10, x2$2));
    var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1;
    var linked = $as_Lamf_core_model_domain_Shape($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$11, field, linkLabel)))
  } else {
    var linked = $as_Lamf_core_model_domain_Shape(shape.link__T__Lamf_core_parser_Annotations__O(linkLabel, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___())))
  };
  this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$link__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_DomainElement__Z__V(b, linked, inArray)
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.traverseMetaModel__T__Lamf_core_model_domain_AmfObject__Lamf_core_model_document_SourceMap__Lamf_core_metamodel_Obj__Lorg_yaml_builder_DocBuilder$Entry__V = (function(id, element, sources, obj, b) {
  var modelFields = $f_Lamf_plugins_document_graph_emitter_CommonEmitter__getMetaModelFields__Lamf_core_model_domain_AmfObject__Lamf_core_metamodel_Obj__sc_Seq(this, element, obj);
  matchEnd4: {
    if ((element instanceof $c_Lamf_core_model_domain_ObjectNode)) {
      var x2 = $as_Lamf_core_model_domain_ObjectNode(element);
      var this$1 = this.options$1;
      if (this$1.validating$1) {
        var url = ($m_Lamf_core_vocabulary_Namespace$().AmfValidation$1.base$1 + "/properties");
        b.entry__T__F1__V(url, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x2$1, id$1) {
          return (function(x$8$2) {
            var x$8 = $as_Lorg_yaml_builder_DocBuilder$Part(x$8$2);
            var t = $m_Lamf_core_metamodel_Type$Int$();
            var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(x2$1.propertyFields__sc_Iterable().size__I(), new $c_Lamf_core_parser_Annotations().init___());
            $m_Lamf_core_parser_Annotations$();
            var annotations = new $c_Lamf_core_parser_Annotations().init___();
            var v = new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value, annotations);
            var f = (function($this$1) {
              return (function(x$7$2) {
                $as_Lamf_core_parser_Value(x$7$2)
              })
            })($this);
            var x = $m_Lamf_core_metamodel_Type$Iri$();
            if (x.equals__O__Z(t)) {
              $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$iri__Lorg_yaml_builder_DocBuilder$Part__T__Z__V(x$8, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T(), false);
              $asUnit(f(v))
            } else {
              var x$3 = $m_Lamf_core_metamodel_Type$EncodedIri$();
              if (x$3.equals__O__Z(t)) {
                $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$safeIri__Lorg_yaml_builder_DocBuilder$Part__T__Z__V(x$8, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T(), false);
                $asUnit(f(v))
              } else {
                var x$5 = $m_Lamf_core_metamodel_Type$LiteralUri$();
                if (x$5.equals__O__Z(t)) {
                  $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(x$8, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T(), $m_Lamf_core_model_DataType$().AnyUri$1, false);
                  $asUnit(f(v))
                } else {
                  var x$7$1 = $m_Lamf_core_metamodel_Type$Str$();
                  if (x$7$1.equals__O__Z(t)) {
                    var content = v.value$1;
                    var t$1 = $m_Lorg_yaml_builder_DocBuilder$SType$Str$();
                    $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$scalar__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(x$8, content, t$1);
                    $asUnit(f(v))
                  } else {
                    var x$9 = $m_Lamf_core_metamodel_Type$Bool$();
                    if (x$9.equals__O__Z(t)) {
                      var content$1 = v.value$1;
                      var t$2 = $m_Lorg_yaml_builder_DocBuilder$SType$Bool$();
                      $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$scalar__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(x$8, content$1, t$2);
                      $asUnit(f(v))
                    } else {
                      var x$11 = $m_Lamf_core_metamodel_Type$Int$();
                      if (x$11.equals__O__Z(t)) {
                        var content$2 = v.value$1;
                        var t$3 = $m_Lorg_yaml_builder_DocBuilder$SType$Int$();
                        $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$scalar__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(x$8, content$2, t$3);
                        $asUnit(f(v))
                      } else {
                        var x$13 = $m_Lamf_core_metamodel_Type$Double$();
                        if (x$13.equals__O__Z(t)) {
                          var content$3 = v.value$1;
                          var t$4 = $m_Lorg_yaml_builder_DocBuilder$SType$Float$();
                          $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$scalar__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(x$8, content$3, t$4);
                          $asUnit(f(v))
                        } else {
                          var x$15 = $m_Lamf_core_metamodel_Type$Float$();
                          if (x$15.equals__O__Z(t)) {
                            var content$4 = v.value$1;
                            var t$5 = $m_Lorg_yaml_builder_DocBuilder$SType$Float$();
                            $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$scalar__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(x$8, content$4, t$5);
                            $asUnit(f(v))
                          } else {
                            var x$17 = $m_Lamf_core_metamodel_Type$DateTime$();
                            if (x$17.equals__O__Z(t)) {
                              var dateTime = $as_Lorg_mulesoft_common_time_SimpleDateTime($as_Lamf_core_model_domain_AmfScalar(v.value$1).value$1);
                              $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(x$8, dateTime.toString__T(), $m_Lamf_core_model_DataType$().DateTime$1, false);
                              $asUnit(f(v))
                            } else {
                              var x$19 = $m_Lamf_core_metamodel_Type$Date$();
                              if (x$19.equals__O__Z(t)) {
                                var x1$2 = $as_Lamf_core_model_domain_AmfScalar(v.value$1).value$1;
                                if ((x1$2 instanceof $c_Lorg_mulesoft_common_time_SimpleDateTime)) {
                                  var x2$2 = $as_Lorg_mulesoft_common_time_SimpleDateTime(x1$2);
                                  var maybeDateTime = new $c_s_Some().init___O(x2$2)
                                } else {
                                  var maybeDateTime = $m_Lorg_mulesoft_common_time_SimpleDateTime$().parse__T__s_util_Either($objectToString(x1$2)).toOption__s_Option()
                                };
                                if ((maybeDateTime instanceof $c_s_Some)) {
                                  var x2$2$1 = $as_s_Some(maybeDateTime);
                                  var dateTime$2 = $as_Lorg_mulesoft_common_time_SimpleDateTime(x2$2$1.value$2);
                                  if ((dateTime$2.timeOfDay$1.isDefined__Z() || dateTime$2.zoneOffset$1.isDefined__Z())) {
                                    $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(x$8, dateTime$2.toString__T(), $m_Lamf_core_model_DataType$().DateTime$1, false)
                                  } else {
                                    var arg$macro$1 = dateTime$2.year$1;
                                    var arg$macro$2 = dateTime$2.month$1;
                                    var arg$macro$3 = dateTime$2.day$1;
                                    var this$7 = new $c_sci_StringOps().init___T("%04d-%02d-%02d");
                                    var array = [arg$macro$1, arg$macro$2, arg$macro$3];
                                    var jsx$2 = $m_sjsr_RuntimeString$();
                                    var $$this = this$7.repr$1;
                                    $m_sc_Seq$();
                                    $m_sjs_js_WrappedArray$();
                                    var array$1 = [];
                                    var x1 = $uI(array.length);
                                    switch (x1) {
                                      case (-1): {
                                        break
                                      }
                                    };
                                    var i = 0;
                                    var len = $uI(array.length);
                                    while ((i < len)) {
                                      var index = i;
                                      var arg1 = array[index];
                                      var elem = $f_sci_StringLike__unwrapArg__psci_StringLike__O__O(this$7, arg1);
                                      array$1.push(elem);
                                      i = ((1 + i) | 0)
                                    };
                                    $m_s_reflect_ManifestFactory$ObjectManifest$();
                                    var len$1 = $uI(array$1.length);
                                    var result = $newArrayObject($d_O.getArrayOf(), [len$1]);
                                    var len$2 = result.u.length;
                                    var i$1 = 0;
                                    var j = 0;
                                    var x$1 = $uI(array$1.length);
                                    var x$2 = ((x$1 < len$2) ? x$1 : len$2);
                                    var that = result.u.length;
                                    var end = ((x$2 < that) ? x$2 : that);
                                    while ((i$1 < end)) {
                                      var jsx$1 = j;
                                      var index$1 = i$1;
                                      result.set(jsx$1, array$1[index$1]);
                                      i$1 = ((1 + i$1) | 0);
                                      j = ((1 + j) | 0)
                                    };
                                    $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(x$8, jsx$2.format__T__AO__T($$this, result), $m_Lamf_core_model_DataType$().Date$1, false)
                                  }
                                } else {
                                  var content$5 = v.value$1;
                                  var t$6 = $m_Lorg_yaml_builder_DocBuilder$SType$Str$();
                                  $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$scalar__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(x$8, content$5, t$6)
                                };
                                $asUnit(f(v))
                              } else {
                                var x$21 = $m_Lamf_core_metamodel_Type$Any$();
                                if (((x$21 === t) && (v.value$1 instanceof $c_Lamf_core_model_domain_AmfScalar))) {
                                  var x1$4 = $as_Lamf_core_model_domain_AmfScalar(v.value$1).value$1;
                                  if (((typeof x1$4) === "boolean")) {
                                    var x2$3 = $uZ(x1$4);
                                    $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(x$8, ("" + x2$3), $m_Lamf_core_model_DataType$().Boolean$1, true)
                                  } else if ($isInt(x1$4)) {
                                    var x3$2 = $uI(x1$4);
                                    $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(x$8, ("" + x3$2), $m_Lamf_core_model_DataType$().Integer$1, true)
                                  } else if ($isFloat(x1$4)) {
                                    var x4 = $uF(x1$4);
                                    $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(x$8, ("" + x4), $m_Lamf_core_model_DataType$().Float$1, true)
                                  } else if (((typeof x1$4) === "number")) {
                                    var x5 = $uD(x1$4);
                                    $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(x$8, ("" + x5), $m_Lamf_core_model_DataType$().Double$1, true)
                                  } else if ((x1$4 instanceof $c_Lorg_mulesoft_common_time_SimpleDateTime)) {
                                    var x6 = $as_Lorg_mulesoft_common_time_SimpleDateTime(x1$4);
                                    $this.emitSimpleDateTime__p1__Lorg_yaml_builder_DocBuilder$Part__Lorg_mulesoft_common_time_SimpleDateTime__Z__V(x$8, x6, true)
                                  } else {
                                    var content$6 = $objectToString(x1$4);
                                    $this.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(x$8, content$6, $m_Lorg_yaml_builder_DocBuilder$SType$Str$())
                                  }
                                } else {
                                  throw new $c_s_MatchError().init___O(t)
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          })
        })(this, x2, id)));
        break matchEnd4
      }
    }
  };
  this.emitFields__p1__T__Lamf_core_model_domain_AmfObject__Lamf_core_model_document_SourceMap__Lorg_yaml_builder_DocBuilder$Entry__sc_Seq__V(id, element, sources, b, modelFields)
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.createSortedArray__Lorg_yaml_builder_DocBuilder$Part__sc_Seq__T__Lamf_core_metamodel_Type__V = (function(b, seq, parent, element) {
  b.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$1, seq$1, element$1) {
    return (function(b$2$2) {
      var b$2 = $as_Lorg_yaml_builder_DocBuilder$Entry(b$2$2);
      var id = (parent$1 + "/list");
      $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createIdNode__Lorg_yaml_builder_DocBuilder$Entry__T__V(b$2, id);
      var e = new $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3().init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__T__sc_Seq__Lamf_core_metamodel_Type($this, id, seq$1, element$1);
      e.id$2 = new $c_s_Some().init___O(id);
      e.isDeclaration$2 = $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingDeclarations$1;
      e.isReference$2 = $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingReferences$1;
      $this.pending$1.tryEnqueue__Lamf_plugins_document_graph_emitter_flattened_utils_Emission__s_util_Try(e)
    })
  })(this, parent, seq, element)))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.emitObject__Lamf_core_model_domain_AmfObject__Lorg_yaml_builder_DocBuilder$Entry__V = (function(amfObject, b) {
  var id = amfObject.id__T();
  this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createIdNode__Lorg_yaml_builder_DocBuilder$Entry__T__V(b, id);
  var sources = $m_Lamf_core_model_document_SourceMap$().apply__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_document_SourceMap(id, amfObject);
  var obj = $f_Lamf_core_metamodel_MetaModelTypeMapping__metaModel__O__Lamf_core_metamodel_Obj(this, amfObject);
  var ctx = this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f;
  $f_Lamf_plugins_document_graph_emitter_CommonEmitter__createTypeNode__Lorg_yaml_builder_DocBuilder$Entry__Lamf_core_metamodel_Obj__Lamf_plugins_document_graph_emitter_EmissionContext__V(this, b, obj, ctx);
  this.traverseMetaModel__T__Lamf_core_model_domain_AmfObject__Lamf_core_model_document_SourceMap__Lamf_core_metamodel_Obj__Lorg_yaml_builder_DocBuilder$Entry__V(id, amfObject, sources, obj, b);
  this.createCustomExtensions__p1__Lamf_core_model_domain_AmfObject__Lorg_yaml_builder_DocBuilder$Entry__V(amfObject, b);
  var sourceMapId = $f_Lamf_plugins_document_graph_emitter_CommonEmitter__sourceMapIdFor__T__T(this, id);
  this.createSourcesNode__p1__T__Lamf_core_model_document_SourceMap__Lorg_yaml_builder_DocBuilder$Entry__V(sourceMapId, sources, b)
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.createCustomExtension__p1__Lorg_yaml_builder_DocBuilder$Entry__T__Lamf_core_model_domain_extensions_DomainExtension__s_Option__V = (function(b, uri, extension, field) {
  b.entry__T__F1__V(uri, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, extension$1, field$1) {
    return (function(x$14$2) {
      var x$14 = $as_Lorg_yaml_builder_DocBuilder$Part(x$14$2);
      x$14.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, extension$1$1, field$1$1) {
        return (function(b$2) {
          var b$1 = $as_Lorg_yaml_builder_DocBuilder$Entry(b$2);
          $this$1.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createIdNode__Lorg_yaml_builder_DocBuilder$Entry__T__V(b$1, $as_Lamf_core_model_domain_DataNode(extension$1$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)).id$1);
          var e = new $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2().init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__Lamf_core_model_domain_extensions_DomainExtension__s_Option($this$1, extension$1$1, field$1$1);
          e.id$2 = new $c_s_Some().init___O($as_Lamf_core_model_domain_DataNode(extension$1$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)).id$1);
          e.isDeclaration$2 = $this$1.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingDeclarations$1;
          e.isReference$2 = $this$1.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingReferences$1;
          $this$1.pending$1.tryEnqueue__Lamf_plugins_document_graph_emitter_flattened_utils_Emission__s_util_Try(e)
        })
      })($this, extension$1, field$1)))
    })
  })(this, extension, field)))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.emitFields__p1__T__Lamf_core_model_domain_AmfObject__Lamf_core_model_document_SourceMap__Lorg_yaml_builder_DocBuilder$Entry__sc_Seq__V = (function(id, element, sources, b, modelFields) {
  modelFields.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, element$1, id$1, sources$1, b$1) {
    return (function(f$2) {
      var f = $as_Lamf_core_metamodel_Field(f$2);
      $this.emitStaticField__p1__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfObject__T__Lamf_core_model_document_SourceMap__Lorg_yaml_builder_DocBuilder$Entry__V(f, element$1, id$1, sources$1, b$1)
    })
  })(this, element, id, sources, b)))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$link__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_DomainElement__Z__V = (function(b, elementWithLink, inArray) {
  if (inArray) {
    this.emit$2__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_DomainElement__V(b, elementWithLink)
  } else {
    b.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, elementWithLink$1) {
      return (function(b$2$2) {
        var b$2 = $as_Lorg_yaml_builder_DocBuilder$Part(b$2$2);
        $this.emit$2__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_DomainElement__V(b$2, elementWithLink$1)
      })
    })(this, elementWithLink)))
  }
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.value__p1__Lamf_core_metamodel_Type__Lamf_core_parser_Value__T__F1__Lorg_yaml_builder_DocBuilder$Part__V = (function(t, v, parent, sources, b) {
  matchEnd19: {
    if (($is_Lamf_core_metamodel_domain_ShapeModel(t) && this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.canGenerateLink__Lamf_core_model_domain_AmfElement__Z(v.value$1))) {
      this.extractToLink__p1__Lamf_core_model_domain_Shape__Lorg_yaml_builder_DocBuilder$Part__Z__V($as_Lamf_core_model_domain_Shape(v.value$1), b, false);
      break matchEnd19
    };
    if (($is_Lamf_core_model_domain_DomainElement(t) && $is_Lamf_core_model_domain_Linkable(t))) {
      var this$1 = $as_Lamf_core_model_domain_Linkable(t);
      if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1).isDefined__Z()) {
        this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$link__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_DomainElement__Z__V(b, $as_Lamf_core_model_domain_DomainElement(t), false);
        $asUnit(sources.apply__O__O(v));
        break matchEnd19
      }
    };
    if ($is_Lamf_core_metamodel_Obj(t)) {
      var obj = $as_Lamf_core_model_domain_AmfObject(v.value$1);
      this.emit$1__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfObject__V(b, obj);
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    var x = $m_Lamf_core_metamodel_Type$Iri$();
    if (x.equals__O__Z(t)) {
      this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$iri__Lorg_yaml_builder_DocBuilder$Part__T__Z__V(b, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T(), false);
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    var x$3 = $m_Lamf_core_metamodel_Type$EncodedIri$();
    if (x$3.equals__O__Z(t)) {
      this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$safeIri__Lorg_yaml_builder_DocBuilder$Part__T__Z__V(b, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T(), false);
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    var x$5 = $m_Lamf_core_metamodel_Type$LiteralUri$();
    if (x$5.equals__O__Z(t)) {
      this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T(), $m_Lamf_core_model_DataType$().AnyUri$1, false);
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    var x$7 = $m_Lamf_core_metamodel_Type$Str$();
    if (x$7.equals__O__Z(t)) {
      var content = v.value$1;
      var t$1 = $m_Lorg_yaml_builder_DocBuilder$SType$Str$();
      this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$scalar__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(b, content, t$1);
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    var x$9 = $m_Lamf_core_metamodel_Type$Bool$();
    if (x$9.equals__O__Z(t)) {
      var content$1 = v.value$1;
      var t$2 = $m_Lorg_yaml_builder_DocBuilder$SType$Bool$();
      this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$scalar__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(b, content$1, t$2);
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    var x$11 = $m_Lamf_core_metamodel_Type$Int$();
    if (x$11.equals__O__Z(t)) {
      var content$2 = v.value$1;
      var t$3 = $m_Lorg_yaml_builder_DocBuilder$SType$Int$();
      this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$scalar__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(b, content$2, t$3);
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    var x$13 = $m_Lamf_core_metamodel_Type$Double$();
    if (x$13.equals__O__Z(t)) {
      var content$3 = v.value$1;
      var t$4 = $m_Lorg_yaml_builder_DocBuilder$SType$Float$();
      this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$scalar__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(b, content$3, t$4);
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    var x$15 = $m_Lamf_core_metamodel_Type$Float$();
    if (x$15.equals__O__Z(t)) {
      var content$4 = v.value$1;
      var t$5 = $m_Lorg_yaml_builder_DocBuilder$SType$Float$();
      this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$scalar__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(b, content$4, t$5);
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    var x$17 = $m_Lamf_core_metamodel_Type$DateTime$();
    if (x$17.equals__O__Z(t)) {
      var dateTime = $as_Lorg_mulesoft_common_time_SimpleDateTime($as_Lamf_core_model_domain_AmfScalar(v.value$1).value$1);
      this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, dateTime.toString__T(), $m_Lamf_core_model_DataType$().DateTime$1, false);
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    var x$19 = $m_Lamf_core_metamodel_Type$Date$();
    if (x$19.equals__O__Z(t)) {
      var x1$2 = $as_Lamf_core_model_domain_AmfScalar(v.value$1).value$1;
      if ((x1$2 instanceof $c_Lorg_mulesoft_common_time_SimpleDateTime)) {
        var x2 = $as_Lorg_mulesoft_common_time_SimpleDateTime(x1$2);
        var maybeDateTime = new $c_s_Some().init___O(x2)
      } else {
        var maybeDateTime = $m_Lorg_mulesoft_common_time_SimpleDateTime$().parse__T__s_util_Either($objectToString(x1$2)).toOption__s_Option()
      };
      if ((maybeDateTime instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(maybeDateTime);
        var dateTime$2 = $as_Lorg_mulesoft_common_time_SimpleDateTime(x2$2.value$2);
        if ((dateTime$2.timeOfDay$1.isDefined__Z() || dateTime$2.zoneOffset$1.isDefined__Z())) {
          this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, dateTime$2.toString__T(), $m_Lamf_core_model_DataType$().DateTime$1, false)
        } else {
          var arg$macro$1 = dateTime$2.year$1;
          var arg$macro$2 = dateTime$2.month$1;
          var arg$macro$3 = dateTime$2.day$1;
          var this$4 = new $c_sci_StringOps().init___T("%04d-%02d-%02d");
          var array = [arg$macro$1, arg$macro$2, arg$macro$3];
          var jsx$2 = $m_sjsr_RuntimeString$();
          var $$this = this$4.repr$1;
          $m_sc_Seq$();
          $m_sjs_js_WrappedArray$();
          var array$1 = [];
          var x1 = $uI(array.length);
          switch (x1) {
            case (-1): {
              break
            }
          };
          var i = 0;
          var len = $uI(array.length);
          while ((i < len)) {
            var index = i;
            var arg1 = array[index];
            var elem = $f_sci_StringLike__unwrapArg__psci_StringLike__O__O(this$4, arg1);
            array$1.push(elem);
            i = ((1 + i) | 0)
          };
          $m_s_reflect_ManifestFactory$ObjectManifest$();
          var len$1 = $uI(array$1.length);
          var result = $newArrayObject($d_O.getArrayOf(), [len$1]);
          var len$2 = result.u.length;
          var i$1 = 0;
          var j = 0;
          var x$1 = $uI(array$1.length);
          var x$2 = ((x$1 < len$2) ? x$1 : len$2);
          var that = result.u.length;
          var end = ((x$2 < that) ? x$2 : that);
          while ((i$1 < end)) {
            var jsx$1 = j;
            var index$1 = i$1;
            result.set(jsx$1, array$1[index$1]);
            i$1 = ((1 + i$1) | 0);
            j = ((1 + j) | 0)
          };
          this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, jsx$2.format__T__AO__T($$this, result), $m_Lamf_core_model_DataType$().Date$1, false)
        }
      } else {
        var content$5 = v.value$1;
        var t$6 = $m_Lorg_yaml_builder_DocBuilder$SType$Str$();
        this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$scalar__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(b, content$5, t$6)
      };
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    if ((t instanceof $c_Lamf_core_metamodel_Type$SortedArray)) {
      var x15 = $as_Lamf_core_metamodel_Type$SortedArray(t);
      this.createSortedArray__Lorg_yaml_builder_DocBuilder$Part__sc_Seq__T__Lamf_core_metamodel_Type__V(b, $as_Lamf_core_model_domain_AmfArray(v.value$1).values$1, parent, x15.element$1);
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    if ((t instanceof $c_Lamf_core_metamodel_Type$Array)) {
      var x16 = $as_Lamf_core_metamodel_Type$Array(t);
      b.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, v$1, sources$1, x16$1) {
        return (function(b$2$2) {
          var b$2 = $as_Lorg_yaml_builder_DocBuilder$Part(b$2$2);
          var seq = $as_Lamf_core_model_domain_AmfArray(v$1.value$1);
          sources$1.apply__O__O(v$1);
          var x1$1 = x16$1.element$1;
          if ($is_Lamf_core_metamodel_Obj(x1$1)) {
            seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, b$1) {
              return (function(x0$1$2) {
                var x0$1 = $as_Lamf_core_model_domain_AmfObject(x0$1$2);
                matchEnd5: {
                  if ((x0$1 instanceof $c_Lamf_core_model_domain_Shape)) {
                    var x2$1 = $as_Lamf_core_model_domain_Shape(x0$1);
                    if ($this$1.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.canGenerateLink__Lamf_core_model_domain_AmfElement__Z(x2$1)) {
                      $this$1.extractToLink__p1__Lamf_core_model_domain_Shape__Lorg_yaml_builder_DocBuilder$Part__Z__V(x2$1, b$1, true);
                      break matchEnd5
                    }
                  };
                  if (($is_Lamf_core_model_domain_DomainElement(x0$1) && $is_Lamf_core_model_domain_Linkable(x0$1))) {
                    var x3 = $as_Lamf_core_model_domain_DomainElement(x0$1);
                    var this$18 = $as_Lamf_core_model_domain_Linkable(x3);
                    if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$18).isDefined__Z()) {
                      $this$1.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$link__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_DomainElement__Z__V(b$1, x3, true);
                      break matchEnd5
                    }
                  };
                  $this$1.emit$1__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfObject__V(b$1, x0$1)
                }
              })
            })($this, b$2)))
          } else {
            var x$4 = $m_Lamf_core_metamodel_Type$Str$();
            if (x$4.equals__O__Z(x1$1)) {
              seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, b$3) {
                return (function(e$2) {
                  var e = $as_Lamf_core_model_domain_AmfScalar(e$2);
                  var content$6 = e.toString__T();
                  this$2$1.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(b$3, content$6, $m_Lorg_yaml_builder_DocBuilder$SType$Str$())
                })
              })($this, b$2)))
            } else {
              var x$3$1 = $m_Lamf_core_metamodel_Type$EncodedIri$();
              if (x$3$1.equals__O__Z(x1$1)) {
                seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, b$4) {
                  return (function(e$3$2) {
                    var e$3 = $as_Lamf_core_model_domain_AmfScalar(e$3$2);
                    this$3$1.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$safeIri__Lorg_yaml_builder_DocBuilder$Part__T__Z__V(b$4, e$3.toString__T(), true)
                  })
                })($this, b$2)))
              } else {
                var x$5$1 = $m_Lamf_core_metamodel_Type$Iri$();
                if (x$5$1.equals__O__Z(x1$1)) {
                  seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, b$5) {
                    return (function(e$4$2) {
                      var e$4 = $as_Lamf_core_model_domain_AmfScalar(e$4$2);
                      this$4$1.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$iri__Lorg_yaml_builder_DocBuilder$Part__T__Z__V(b$5, e$4.toString__T(), true)
                    })
                  })($this, b$2)))
                } else {
                  var x$7$1 = $m_Lamf_core_metamodel_Type$LiteralUri$();
                  if (x$7$1.equals__O__Z(x1$1)) {
                    $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b$2, $as_Lamf_core_model_domain_AmfScalar(v$1.value$1).toString__T(), $m_Lamf_core_model_DataType$().AnyUri$1, true)
                  } else {
                    var x$9$1 = $m_Lamf_core_metamodel_Type$Int$();
                    if (x$9$1.equals__O__Z(x1$1)) {
                      seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1, b$6) {
                        return (function(e$5$2) {
                          var e$5 = $as_Lamf_core_model_domain_AmfScalar(e$5$2);
                          this$5$1.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(b$6, $objectToString(e$5.value$1), $m_Lorg_yaml_builder_DocBuilder$SType$Int$())
                        })
                      })($this, b$2)))
                    } else {
                      var x$11$1 = $m_Lamf_core_metamodel_Type$Float$();
                      if (x$11$1.equals__O__Z(x1$1)) {
                        seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1, b$7) {
                          return (function(e$6$2) {
                            var e$6 = $as_Lamf_core_model_domain_AmfScalar(e$6$2);
                            this$6$1.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(b$7, $objectToString(e$6.value$1), $m_Lorg_yaml_builder_DocBuilder$SType$Float$())
                          })
                        })($this, b$2)))
                      } else {
                        var x$13$1 = $m_Lamf_core_metamodel_Type$Bool$();
                        if (x$13$1.equals__O__Z(x1$1)) {
                          seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$7$1, b$8) {
                            return (function(e$7$2) {
                              var e$7 = $as_Lamf_core_model_domain_AmfScalar(e$7$2);
                              this$7$1.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(b$8, $objectToString(e$7.value$1), $m_Lorg_yaml_builder_DocBuilder$SType$Bool$())
                            })
                          })($this, b$2)))
                        } else {
                          var x$15$1 = $m_Lamf_core_metamodel_Type$DateTime$();
                          if (x$15$1.equals__O__Z(x1$1)) {
                            seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$8$1, b$9) {
                              return (function(e$8$2) {
                                var e$8 = $as_Lamf_core_model_domain_AmfScalar(e$8$2);
                                var dateTime$1 = $as_Lorg_mulesoft_common_time_SimpleDateTime(e$8.value$1);
                                this$8$1.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b$9, dateTime$1.toString__T(), $m_Lamf_core_model_DataType$().DateTime$1, false)
                              })
                            })($this, b$2)))
                          } else {
                            var x$17$1 = $m_Lamf_core_metamodel_Type$Date$();
                            if (x$17$1.equals__O__Z(x1$1)) {
                              seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$9$1, b$10) {
                                return (function(e$9$2) {
                                  var e$9 = $as_Lamf_core_model_domain_AmfScalar(e$9$2);
                                  var dateTime$3 = $as_Lorg_mulesoft_common_time_SimpleDateTime(e$9.value$1);
                                  this$9$1.emitSimpleDateTime__p1__Lorg_yaml_builder_DocBuilder$Part__Lorg_mulesoft_common_time_SimpleDateTime__Z__V(b$10, dateTime$3, false)
                                })
                              })($this, b$2)))
                            } else {
                              var x$19$1 = $m_Lamf_core_metamodel_Type$Any$();
                              if ((x$19$1 === x1$1)) {
                                seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$10$1, b$11) {
                                  return (function(scalarElement$2) {
                                    var scalarElement = $as_Lamf_core_model_domain_AmfScalar(scalarElement$2);
                                    var x1$3 = scalarElement.value$1;
                                    if (((typeof x1$3) === "boolean")) {
                                      var x2$3 = $uZ(x1$3);
                                      this$10$1.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b$11, ("" + x2$3), $m_Lamf_core_model_DataType$().Boolean$1, true)
                                    } else if ($isInt(x1$3)) {
                                      var x3$1 = $uI(x1$3);
                                      this$10$1.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b$11, ("" + x3$1), $m_Lamf_core_model_DataType$().Integer$1, true)
                                    } else if ($isFloat(x1$3)) {
                                      var x4 = $uF(x1$3);
                                      this$10$1.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b$11, ("" + x4), $m_Lamf_core_model_DataType$().Float$1, true)
                                    } else if (((typeof x1$3) === "number")) {
                                      var x5 = $uD(x1$3);
                                      this$10$1.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b$11, ("" + x5), $m_Lamf_core_model_DataType$().Double$1, true)
                                    } else if ((x1$3 instanceof $c_Lorg_mulesoft_common_time_SimpleDateTime)) {
                                      var x6 = $as_Lorg_mulesoft_common_time_SimpleDateTime(x1$3);
                                      this$10$1.emitSimpleDateTime__p1__Lorg_yaml_builder_DocBuilder$Part__Lorg_mulesoft_common_time_SimpleDateTime__Z__V(b$11, x6, true)
                                    } else {
                                      var content$7 = $objectToString(x1$3);
                                      this$10$1.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(b$11, content$7, $m_Lorg_yaml_builder_DocBuilder$SType$Str$())
                                    }
                                  })
                                })($this, b$2)))
                              } else {
                                seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$11$1, b$12) {
                                  return (function(e$10$2) {
                                    var e$10 = $as_Lamf_core_model_domain_AmfScalar(e$10$2);
                                    this$11$1.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$iri__Lorg_yaml_builder_DocBuilder$Part__T__Z__V(b$12, e$10.toString__T(), true)
                                  })
                                })($this, b$2)))
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        })
      })(this, v, sources, x16)));
      break matchEnd19
    };
    var x$21 = $m_Lamf_core_metamodel_Type$Any$();
    if (((x$21 === t) && (v.value$1 instanceof $c_Lamf_core_model_domain_AmfScalar))) {
      var x1$4 = $as_Lamf_core_model_domain_AmfScalar(v.value$1).value$1;
      if (((typeof x1$4) === "boolean")) {
        var x2$3$1 = $uZ(x1$4);
        this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, ("" + x2$3$1), $m_Lamf_core_model_DataType$().Boolean$1, true)
      } else if ($isInt(x1$4)) {
        var x3$2 = $uI(x1$4);
        this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, ("" + x3$2), $m_Lamf_core_model_DataType$().Integer$1, true)
      } else if ($isFloat(x1$4)) {
        var x4$1 = $uF(x1$4);
        this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, ("" + x4$1), $m_Lamf_core_model_DataType$().Float$1, true)
      } else if (((typeof x1$4) === "number")) {
        var x5$1 = $uD(x1$4);
        this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, ("" + x5$1), $m_Lamf_core_model_DataType$().Double$1, true)
      } else if ((x1$4 instanceof $c_Lorg_mulesoft_common_time_SimpleDateTime)) {
        var x6$1 = $as_Lorg_mulesoft_common_time_SimpleDateTime(x1$4);
        this.emitSimpleDateTime__p1__Lorg_yaml_builder_DocBuilder$Part__Lorg_mulesoft_common_time_SimpleDateTime__Z__V(b, x6$1, true)
      } else {
        var content$8 = $objectToString(x1$4);
        this.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(b, content$8, $m_Lorg_yaml_builder_DocBuilder$SType$Str$())
      };
      break matchEnd19
    };
    throw new $c_s_MatchError().init___O(t)
  }
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.init___Lorg_yaml_builder_DocBuilder__Lamf_core_emitter_RenderOptions__Lamf_plugins_document_graph_emitter_EmissionContext = (function(builder, options, ctx) {
  this.builder$1 = builder;
  this.options$1 = options;
  this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f = ctx;
  this.pending$1 = new $c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue().init___();
  return this
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.emit$4__p1__Lorg_yaml_builder_DocBuilder$Part__T__V = (function(b, content$2) {
  b.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, content$2$1) {
    return (function(x$20$2) {
      var x$20 = $as_Lorg_yaml_builder_DocBuilder$Entry(x$20$2);
      x$20.entry__T__F1__V("@id", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, content$2$2) {
        return (function(x$21$2) {
          var x$21 = $as_Lorg_yaml_builder_DocBuilder$Part(x$21$2);
          var content = $this$1.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emitId__T__T(content$2$2);
          x$21.$$plus$eq__T__V(content)
        })
      })($this, content$2$1)))
    })
  })(this, content$2)))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.queueObjectFieldValues__Lamf_core_model_domain_AmfObject__F2__V = (function(amfObject, filter) {
  var this$1 = amfObject.fields__Lamf_core_parser_Fields();
  var fn = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, filter$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      matchEnd3: {
        if ((x0$1 !== null)) {
          var field = $as_Lamf_core_metamodel_Field(x0$1.$$und1__O());
          var value = $as_Lamf_core_parser_Value(x0$1.$$und2__O());
          if ($uZ(filter$1.apply__O__O__O(field, value))) {
            var x1$2 = field.type$1;
            if ($is_Lamf_core_metamodel_Obj(x1$2)) {
              var valueObj = $as_Lamf_core_model_domain_AmfObject(value.value$1);
              $this.pending$1.tryEnqueue__Lamf_plugins_document_graph_emitter_flattened_utils_Emission__s_util_Try($this.object2Emission__Lamf_core_model_domain_AmfObject__Lamf_plugins_document_graph_emitter_flattened_utils_Emission(valueObj))
            } else if ((x1$2 instanceof $c_Lamf_core_metamodel_Type$ArrayLike)) {
              var valueArray = $as_Lamf_core_model_domain_AmfArray(value.value$1);
              valueArray.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
                return (function(x0$2$2) {
                  var x0$2 = $as_Lamf_core_model_domain_AmfElement(x0$2$2);
                  if ($is_Lamf_core_model_domain_AmfObject(x0$2)) {
                    var x2 = $as_Lamf_core_model_domain_AmfObject(x0$2);
                    return $this$1.pending$1.tryEnqueue__Lamf_plugins_document_graph_emitter_flattened_utils_Emission__s_util_Try($this$1.object2Emission__Lamf_core_model_domain_AmfObject__Lamf_plugins_document_graph_emitter_flattened_utils_Emission(x2))
                  } else {
                    return (void 0)
                  }
                })
              })($this)))
            };
            break matchEnd3
          }
        }
      }
    })
  })(this, filter));
  this$1.fs$1.foreach__F1__V(fn)
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.emit$5__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__V = (function(b, content$3, dataType$1) {
  b.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, content$3$1, dataType$1$1) {
    return (function(m$2) {
      var m = $as_Lorg_yaml_builder_DocBuilder$Entry(m$2);
      m.entry__T__F1__V("@value", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, content$3$2) {
        return (function(x$22$2) {
          var x$22 = $as_Lorg_yaml_builder_DocBuilder$Part(x$22$2);
          x$22.$$plus$eq__T__V(content$3$2)
        })
      })($this, content$3$1)));
      m.entry__T__F1__V("@type", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, dataType$1$2) {
        return (function(x$23$2) {
          var x$23 = $as_Lorg_yaml_builder_DocBuilder$Part(x$23$2);
          var content = this$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emitIri__T__T(dataType$1$2);
          x$23.$$plus$eq__T__V(content)
        })
      })($this, dataType$1$1)))
    })
  })(this, content$3, dataType$1)))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$iri__Lorg_yaml_builder_DocBuilder$Part__T__Z__V = (function(b, content, inArray) {
  if (inArray) {
    this.emit$3__p1__Lorg_yaml_builder_DocBuilder$Part__T__V(b, content)
  } else {
    b.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, content$1) {
      return (function(b$2$2) {
        var b$2 = $as_Lorg_yaml_builder_DocBuilder$Part(b$2$2);
        $this.emit$3__p1__Lorg_yaml_builder_DocBuilder$Part__T__V(b$2, content$1)
      })
    })(this, content)))
  }
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createIdNode__Lorg_yaml_builder_DocBuilder$Entry__T__V = (function(b, id) {
  b.entry__T__F1__V("@id", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, id$1) {
    return (function(x$24$2) {
      var x$24 = $as_Lorg_yaml_builder_DocBuilder$Part(x$24$2);
      var content = $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emitId__T__T(id$1);
      x$24.$$plus$eq__T__V(content)
    })
  })(this, id)))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.emitStaticField__p1__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfObject__T__Lamf_core_model_document_SourceMap__Lorg_yaml_builder_DocBuilder$Entry__V = (function(field, element, id, sources, b) {
  var x1 = element.fields__Lamf_core_parser_Fields().entryJsonld__Lamf_core_metamodel_Field__s_Option(field);
  matchEnd6: {
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var p3 = $as_Lamf_core_parser_FieldEntry(x2.value$2);
      if ((p3 !== null)) {
        var f = p3.field$1;
        var v = p3.value$1;
        var url = this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emitIri__T__T(f.value$1.iri__T());
        b.entry__T__F1__V(url, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, f$1, v$1, id$1, sources$1, url$1) {
          return (function(x$9$2) {
            var x$9 = $as_Lorg_yaml_builder_DocBuilder$Part(x$9$2);
            $this.value__p1__Lamf_core_metamodel_Type__Lamf_core_parser_Value__T__F1__Lorg_yaml_builder_DocBuilder$Part__V(f$1.type$1, v$1, id$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, sources$4, url$3) {
              return (function(value$2) {
                var value = $as_Lamf_core_parser_Value(value$2);
                sources$4.property__T__Lamf_core_parser_Value__V(url$3, value)
              })
            })($this, sources$1, url$1)), x$9)
          })
        })(this, f, v, id, sources, url)));
        break matchEnd6
      }
    };
    var x = $m_s_None$();
    if ((x === x1)) {
      break matchEnd6
    };
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.emitSimpleDateTime__p1__Lorg_yaml_builder_DocBuilder$Part__Lorg_mulesoft_common_time_SimpleDateTime__Z__V = (function(b, dateTime, inArray) {
  if ((dateTime.timeOfDay$1.isDefined__Z() || dateTime.zoneOffset$1.isDefined__Z())) {
    this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, dateTime.toString__T(), $m_Lamf_core_model_DataType$().DateTime$1, inArray)
  } else {
    var arg$macro$1 = dateTime.year$1;
    var arg$macro$2 = dateTime.month$1;
    var arg$macro$3 = dateTime.day$1;
    var this$3 = new $c_sci_StringOps().init___T("%04d-%02d-%02d");
    var array = [arg$macro$1, arg$macro$2, arg$macro$3];
    var jsx$2 = $m_sjsr_RuntimeString$();
    var $$this = this$3.repr$1;
    $m_sc_Seq$();
    $m_sjs_js_WrappedArray$();
    var array$1 = [];
    var x1 = $uI(array.length);
    switch (x1) {
      case (-1): {
        break
      }
    };
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      var elem = $f_sci_StringLike__unwrapArg__psci_StringLike__O__O(this$3, arg1);
      array$1.push(elem);
      i = ((1 + i) | 0)
    };
    $m_s_reflect_ManifestFactory$ObjectManifest$();
    var len$1 = $uI(array$1.length);
    var result = $newArrayObject($d_O.getArrayOf(), [len$1]);
    var len$2 = result.u.length;
    var i$1 = 0;
    var j = 0;
    var x = $uI(array$1.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = result.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i$1 < end)) {
      var jsx$1 = j;
      var index$1 = i$1;
      result.set(jsx$1, array$1[index$1]);
      i$1 = ((1 + i$1) | 0);
      j = ((1 + j) | 0)
    };
    this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, jsx$2.format__T__AO__T($$this, result), $m_Lamf_core_model_DataType$().Date$1, false)
  }
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.emitSelfEncodedBaseUnitNode__Lamf_core_model_document_BaseUnit__V = (function(unit) {
  if ($is_Lamf_core_model_document_EncodesModel(unit)) {
    this.root$1.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x2, unit$1) {
      return (function(b$2) {
        var b = $as_Lorg_yaml_builder_DocBuilder$Entry(b$2);
        var id = x2.id__T();
        var unitObj = $f_Lamf_core_metamodel_MetaModelTypeMapping__metaModel__O__Lamf_core_metamodel_Obj($this, x2);
        var instance = $as_Lamf_core_model_document_EncodesModel(x2).encodes__Lamf_core_model_domain_DomainElement();
        var encodedObj = $f_Lamf_core_metamodel_MetaModelTypeMapping__metaModel__O__Lamf_core_metamodel_Obj($this, instance);
        $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createIdNode__Lorg_yaml_builder_DocBuilder$Entry__T__V(b, id);
        var jsx$2 = $f_Lamf_plugins_document_graph_emitter_CommonEmitter__getTypesAsIris__Lamf_core_metamodel_Obj__sci_List($this, unitObj);
        var jsx$1 = $f_Lamf_plugins_document_graph_emitter_CommonEmitter__getTypesAsIris__Lamf_core_metamodel_Obj__sci_List($this, encodedObj);
        var this$1 = $m_sci_List$();
        var allTypes = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
        var ctx = $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f;
        $f_Lamf_plugins_document_graph_emitter_CommonEmitter__createTypeNode__Lorg_yaml_builder_DocBuilder$Entry__sci_List__Lamf_plugins_document_graph_emitter_EmissionContext__V($this, b, allTypes, ctx);
        $this.emitReferences__p1__Lorg_yaml_builder_DocBuilder$Entry__T__Lamf_core_model_document_SourceMap__V(b, id, $m_Lamf_core_model_document_SourceMap$().apply__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_document_SourceMap(id, unit$1));
        $this.emitDeclarations__p1__Lorg_yaml_builder_DocBuilder$Entry__T__Lamf_core_model_document_SourceMap__V(b, id, $m_Lamf_core_model_document_SourceMap$().apply__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_document_SourceMap(id, unit$1));
        var sources = $m_Lamf_core_model_document_SourceMap$().apply__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_document_SourceMap(id, unit$1);
        var jsx$3 = $as_Lamf_core_model_document_EncodesModel(x2).encodes__Lamf_core_model_domain_DomainElement();
        var element = $as_Lamf_core_model_document_EncodesModel(x2).encodes__Lamf_core_model_domain_DomainElement();
        $this.emitFields__p1__T__Lamf_core_model_domain_AmfObject__Lamf_core_model_document_SourceMap__Lorg_yaml_builder_DocBuilder$Entry__sc_Seq__V(id, jsx$3, sources, b, $f_Lamf_plugins_document_graph_emitter_CommonEmitter__getMetaModelFields__Lamf_core_model_domain_AmfObject__Lamf_core_metamodel_Obj__sc_Seq($this, element, encodedObj));
        var this$2 = $this.pending$1;
        this$2.knownIds$1.$$plus$eq__O__scm_HashSet(id);
        $this.emitFields__p1__T__Lamf_core_model_domain_AmfObject__Lamf_core_model_document_SourceMap__Lorg_yaml_builder_DocBuilder$Entry__sc_Seq__V(id, x2, sources, b, $f_Lamf_plugins_document_graph_emitter_CommonEmitter__getMetaModelFields__Lamf_core_model_domain_AmfObject__Lamf_core_metamodel_Obj__sc_Seq($this, x2, unitObj));
        $this.createCustomExtensions__p1__Lamf_core_model_domain_AmfObject__Lorg_yaml_builder_DocBuilder$Entry__V(x2, b);
        var sourceMapId = $f_Lamf_plugins_document_graph_emitter_CommonEmitter__sourceMapIdFor__T__T($this, id);
        $this.createSourcesNode__p1__T__Lamf_core_model_document_SourceMap__Lorg_yaml_builder_DocBuilder$Entry__V(sourceMapId, sources, b)
      })
    })(this, unit, unit)))
  }
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.object2Emission__Lamf_core_model_domain_AmfObject__Lamf_plugins_document_graph_emitter_flattened_utils_Emission = (function(amfObject) {
  var id = amfObject.id__T();
  var e = new $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1().init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__Lamf_core_model_domain_AmfObject(this, amfObject);
  e.id$2 = new $c_s_Some().init___O(id);
  e.isDeclaration$2 = this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingDeclarations$1;
  e.isReference$2 = this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingReferences$1;
  if ($is_Lamf_core_model_domain_DomainElement(amfObject)) {
    var this$1 = $as_Lamf_core_model_domain_DomainElement(amfObject);
    var this$2 = $as_Lamf_core_model_BoolField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().IsExternalLink$1)).option$1;
    var jsx$1 = $uZ((this$2.isEmpty__Z() ? false : this$2.get__O()))
  } else {
    var jsx$1 = false
  };
  e.isExternal$2 = jsx$1;
  return e
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.createCustomExtensions__p1__Lamf_core_model_domain_AmfObject__Lorg_yaml_builder_DocBuilder$Entry__V = (function(element, b) {
  var customProperties = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = element.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field());
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var x0$1 = $as_Lamf_core_parser_FieldEntry(arg1);
    if ((x0$1 !== null)) {
      var v = x0$1.value$1;
      var x1$2 = v.value$1;
      if ((x1$2 instanceof $c_Lamf_core_model_domain_AmfArray)) {
        var x2 = $as_Lamf_core_model_domain_AmfArray(x1$2);
        var values = x2.values$1;
        $as_sc_IterableLike(values.sortBy__F1__s_math_Ordering__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(x$10$2) {
            var x$10 = $as_Lamf_core_model_domain_AmfElement(x$10$2);
            return $as_Lamf_core_model_domain_extensions_DomainExtension(x$10).id$1
          })
        })(this)), $m_s_math_Ordering$String$())).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, customProperties$1, b$2) {
          return (function(x0$2$2) {
            var x0$2 = $as_Lamf_core_model_domain_AmfElement(x0$2$2);
            if ((x0$2 instanceof $c_Lamf_core_model_domain_extensions_DomainExtension)) {
              var x2$1 = $as_Lamf_core_model_domain_extensions_DomainExtension(x0$2);
              var uri = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(x2$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().DefinedBy$1)).id$1;
              customProperties$1.$$plus$eq__O__scm_ListBuffer(uri);
              this$2.createCustomExtension__p1__Lorg_yaml_builder_DocBuilder$Entry__T__Lamf_core_model_domain_extensions_DomainExtension__s_Option__V(b$2, uri, x2$1, $m_s_None$())
            } else {
              throw new $c_s_MatchError().init___O(x0$2)
            }
          })
        })(this, customProperties, b)))
      }
    } else {
      throw new $c_s_MatchError().init___O(x0$1)
    }
  };
  var count = new $c_sr_IntRef().init___I(1);
  var this$9 = element.fields__Lamf_core_parser_Fields();
  var fn = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, element$1, count$1, customProperties$2, b$1) {
    return (function(x0$3$2) {
      var x0$3 = $as_T2(x0$3$2);
      if ((x0$3 !== null)) {
        var f = $as_Lamf_core_metamodel_Field(x0$3.$$und1__O());
        var v$1 = $as_Lamf_core_parser_Value(x0$3.$$und2__O());
        var this$4 = v$1.value$1.annotations__Lamf_core_parser_Annotations();
        var pf = new $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1().init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter(this$2$1);
        var this$6 = this$4.amf$core$parser$Annotations$$annotations$1;
        var this$5 = $m_scm_ListBuffer$();
        var bf = this$5.ReusableCBFInstance$2;
        $as_sc_IterableLike($as_sc_Seq($f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this$6, pf, bf)).sortBy__F1__s_math_Ordering__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
          return (function(x$11$2) {
            var x$11 = $as_Lamf_core_annotations_DomainExtensionAnnotation(x$11$2);
            return x$11.extension$1.id$1
          })
        })(this$2$1)), $m_s_math_Ordering$String$())).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$2, element$2, count$1$1, customProperties$1$1, b$2$1, f$1) {
          return (function(e$2) {
            var e = $as_Lamf_core_annotations_DomainExtensionAnnotation(e$2);
            var extension = e.extension$1;
            var jsx$2 = element$2.id__T();
            var jsx$1 = count$1$1.elem$1;
            var this$7 = $as_Lamf_core_model_StrField(extension.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1));
            var this$8 = this$7.option$1;
            var uri$1 = ((((jsx$2 + "/scalar-valued/") + jsx$1) + "/") + $as_T((this$8.isEmpty__Z() ? null : this$8.get__O())));
            customProperties$1$1.$$plus$eq__O__scm_ListBuffer(uri$1);
            $m_Lamf_core_model_domain_DataNodeOps$().adoptTree__T__Lamf_core_model_domain_DataNode__Lamf_core_model_domain_DataNode(uri$1, $as_Lamf_core_model_domain_DataNode(extension.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)));
            this$2$2.createCustomExtension__p1__Lorg_yaml_builder_DocBuilder$Entry__T__Lamf_core_model_domain_extensions_DomainExtension__s_Option__V(b$2$1, uri$1, extension, new $c_s_Some().init___O(f$1));
            count$1$1.elem$1 = ((1 + count$1$1.elem$1) | 0)
          })
        })(this$2$1, element$1, count$1, customProperties$2, b$1, f)))
      } else {
        throw new $c_s_MatchError().init___O(x0$3)
      }
    })
  })(this, element, count, customProperties, b));
  this$9.fs$1.foreach__F1__V(fn);
  if (customProperties.nonEmpty__Z()) {
    b.entry__T__F1__V(this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emitIri__T__T($m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field().value$1.iri__T()), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, customProperties$3) {
      return (function(x$12$2) {
        var x$12 = $as_Lorg_yaml_builder_DocBuilder$Part(x$12$2);
        x$12.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, customProperties$1$2) {
          return (function(b$2$2) {
            var b$3 = $as_Lorg_yaml_builder_DocBuilder$Part(b$2$2);
            var this$10 = customProperties$1$2.scala$collection$mutable$ListBuffer$$start$6;
            var these = this$10;
            while ((!these.isEmpty__Z())) {
              var arg1$1 = these.head__O();
              var x$13 = $as_T(arg1$1);
              $this$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$iri__Lorg_yaml_builder_DocBuilder$Part__T__Z__V(b$3, x$13, true);
              these = $as_sci_List(these.tail__O())
            }
          })
        })(this$3$1, customProperties$3)))
      })
    })(this, customProperties)))
  }
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.createAnnotationValueNode__p1__T__Lorg_yaml_builder_DocBuilder$Part__T2__V = (function(id, b, tuple) {
  if ((tuple !== null)) {
    var iri = $as_T(tuple.$$und1__O());
    var v = $as_T(tuple.$$und2__O());
    b.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, id$1) {
      return (function(b$2$2) {
        var b$2 = $as_Lorg_yaml_builder_DocBuilder$Entry(b$2$2);
        $this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createIdNode__Lorg_yaml_builder_DocBuilder$Entry__T__V(b$2, id$1)
      })
    })(this, id)));
    var e = new $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6().init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__T__T__T(this, id, iri, v);
    e.id$2 = new $c_s_Some().init___O(id);
    e.isDeclaration$2 = this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingDeclarations$1;
    e.isReference$2 = this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingReferences$1;
    this.pending$1.tryEnqueue__Lamf_plugins_document_graph_emitter_flattened_utils_Emission__s_util_Try(e)
  } else {
    throw new $c_s_MatchError().init___O(tuple)
  }
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.emit$3__p1__Lorg_yaml_builder_DocBuilder$Part__T__V = (function(b, content$1) {
  b.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, content$1$1) {
    return (function(x$18$2) {
      var x$18 = $as_Lorg_yaml_builder_DocBuilder$Entry(x$18$2);
      x$18.entry__T__F1__V("@id", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, content$1$2) {
        return (function(x$19$2) {
          var x$19 = $as_Lorg_yaml_builder_DocBuilder$Part(x$19$2);
          var content = $this$1.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emitId__T__T(content$1$2);
          x$19.$$plus$eq__T__V(content)
        })
      })($this, content$1$1)))
    })
  })(this, content$1)))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.emitReferences__p1__Lorg_yaml_builder_DocBuilder$Entry__T__Lamf_core_model_document_SourceMap__V = (function(b, id, sources) {
  var this$1 = this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f;
  var this$2 = this$1.references$1;
  if ($f_scm_SetLike__toSeq__sc_Seq(this$2).nonEmpty__Z()) {
    var this$3 = this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f;
    var this$4 = this$3.references$1;
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($f_scm_SetLike__toSeq__sc_Seq(this$4), new $c_Lamf_core_parser_Annotations().init___());
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var v = new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value, annotations);
    var f = $m_Lamf_core_metamodel_document_ModuleModel$().References$1;
    var url = this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emitIri__T__T(f.value$1.iri__T());
    this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingReferences__Z__Lamf_plugins_document_graph_emitter_EmissionContext(true);
    b.entry__T__F1__V(url, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, f$1, v$1, id$1, sources$1, url$1) {
      return (function(x$5$2) {
        var x$5 = $as_Lorg_yaml_builder_DocBuilder$Part(x$5$2);
        $this.value__p1__Lamf_core_metamodel_Type__Lamf_core_parser_Value__T__F1__Lorg_yaml_builder_DocBuilder$Part__V(f$1.type$1, v$1, id$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, sources$2, url$2) {
          return (function(value$2) {
            var value$1 = $as_Lamf_core_parser_Value(value$2);
            sources$2.property__T__Lamf_core_parser_Value__V(url$2, value$1)
          })
        })($this, sources$1, url$1)), x$5)
      })
    })(this, f, v, id, sources, url)))
  };
  this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingReferences__Z__Lamf_plugins_document_graph_emitter_EmissionContext(false)
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.isSelfEncoded__p1__Lamf_core_model_document_BaseUnit__Z = (function(unit) {
  if ($is_Lamf_core_model_document_EncodesModel(unit)) {
    var this$1 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_document_EncodesModel(unit).encodes__Lamf_core_model_domain_DomainElement());
    if ((!this$1.isEmpty__Z())) {
      var arg1 = this$1.get__O();
      var x$3 = $as_Lamf_core_model_domain_DomainElement(arg1);
      return (x$3.id__T() === unit.id__T())
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.emitDeclarations__p1__Lorg_yaml_builder_DocBuilder$Entry__T__Lamf_core_model_document_SourceMap__V = (function(b, id, sources) {
  var this$1 = this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f;
  var this$2 = this$1.declarations$1;
  if ($f_scm_SetLike__toSeq__sc_Seq(this$2).nonEmpty__Z()) {
    var this$3 = this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f;
    var this$4 = this$3.declarations$1;
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($f_scm_SetLike__toSeq__sc_Seq(this$4), new $c_Lamf_core_parser_Annotations().init___());
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var v = new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value, annotations);
    var f = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
    var url = this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emitIri__T__T(f.value$1.iri__T());
    this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingDeclarations__Z__Lamf_plugins_document_graph_emitter_EmissionContext(true);
    b.entry__T__F1__V(url, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, f$1, v$1, id$1, sources$1, url$1) {
      return (function(x$4$2) {
        var x$4 = $as_Lorg_yaml_builder_DocBuilder$Part(x$4$2);
        $this.value__p1__Lamf_core_metamodel_Type__Lamf_core_parser_Value__T__F1__Lorg_yaml_builder_DocBuilder$Part__V(f$1.type$1, v$1, id$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, sources$1$1, url$1$1) {
          return (function(value$2) {
            var value$1 = $as_Lamf_core_parser_Value(value$2);
            sources$1$1.property__T__Lamf_core_parser_Value__V(url$1$1, value$1)
          })
        })($this, sources$1, url$1)), x$4)
      })
    })(this, f, v, id, sources, url)))
  };
  this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emittingDeclarations__Z__Lamf_plugins_document_graph_emitter_EmissionContext(false)
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V = (function(b, content, t) {
  b.$$plus$eq__Lorg_yaml_builder_DocBuilder$Scalar__V($m_Lorg_yaml_builder_DocBuilder$Scalar$().apply__Lorg_yaml_builder_DocBuilder$SType__T__Lorg_yaml_builder_DocBuilder$Scalar(t, content))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V = (function(b, content, dataType, inArray) {
  if (inArray) {
    this.emit$5__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__V(b, content, dataType)
  } else {
    b.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, content$1, dataType$1) {
      return (function(b$2$2) {
        var b$2 = $as_Lorg_yaml_builder_DocBuilder$Part(b$2$2);
        $this.emit$5__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__V(b$2, content$1, dataType$1)
      })
    })(this, content, dataType)))
  }
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createAnnotationNodes__T__Lorg_yaml_builder_DocBuilder$Entry__scm_ListMap__V = (function(id, b, annotations) {
  var this$1 = annotations.elems$5;
  var this$2 = new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$1);
  while (this$2.hasNext__Z()) {
    var arg1 = this$2.next__O();
    var x0$1 = $as_T2(arg1);
    if ((x0$1 !== null)) {
      var a = $as_T(x0$1.$$und1__O());
      var values = $as_scm_ListMap(x0$1.$$und2__O());
      var this$3 = this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.options$1;
      if (this$3.rawSourceMaps$1) {
        b.entry__T__F1__V(a, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, values$1) {
          return (function(x$31$2) {
            var x$31 = $as_Lorg_yaml_builder_DocBuilder$Part(x$31$2);
            x$31.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, values$1$1) {
              return (function(o$2) {
                var o = $as_Lorg_yaml_builder_DocBuilder$Entry(o$2);
                var this$4 = values$1$1.elems$5;
                var this$5 = new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$4);
                while (this$5.hasNext__Z()) {
                  var arg1$1 = this$5.next__O();
                  var x0$2 = $as_T2(arg1$1);
                  if ((x0$2 !== null)) {
                    var iri = $as_T(x0$2.$$und1__O());
                    var v = $as_T(x0$2.$$und2__O());
                    o.entry__T__F1__V($this$1.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emitId__T__T($this$1.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emitIri__T__T(iri)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, v$1) {
                      return (function(x$32$2) {
                        var x$32 = $as_Lorg_yaml_builder_DocBuilder$Part(x$32$2);
                        x$32.$$plus$eq__T__V(v$1)
                      })
                    })($this$1, v)))
                  } else {
                    throw new $c_s_MatchError().init___O(x0$2)
                  }
                }
              })
            })($this, values$1)))
          })
        })(this, values)))
      } else {
        var jsx$1 = this.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f;
        var ns = $m_Lamf_core_vocabulary_Namespace$().SourceMaps$1;
        b.entry__T__F1__V(jsx$1.emitIri__T__T(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns, a).iri__T()), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, values$2, id$11, a$1) {
          return (function(x$33$2) {
            var x$33 = $as_Lorg_yaml_builder_DocBuilder$Part(x$33$2);
            x$33.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, values$1$2, id$11$1, a$1$1) {
              return (function(b$2) {
                var b$1 = $as_Lorg_yaml_builder_DocBuilder$Part(b$2);
                var this$7 = $m_scm_ListMap$();
                var bf = new $c_scg_GenMapFactory$MapCanBuildFrom().init___scg_GenMapFactory(this$7);
                $as_sc_IterableLike($f_sc_IterableLike__zipWithIndex__scg_CanBuildFrom__O(values$1$2, bf)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$4, id$11$2, a$1$2, b$3) {
                  return (function(x0$3$2) {
                    var x0$3 = $as_T2(x0$3$2);
                    if ((x0$3 !== null)) {
                      var tuple = $as_T2(x0$3.$$und1__O());
                      var index = x0$3.$$und2$mcI$sp__I();
                      $this$4.createAnnotationValueNode__p1__T__Lorg_yaml_builder_DocBuilder$Part__T2__V(((((id$11$2 + "/") + a$1$2) + "/element_") + index), b$3, tuple)
                    } else {
                      throw new $c_s_MatchError().init___O(x0$3)
                    }
                  })
                })($this$3, id$11$1, a$1$1, b$1)))
              })
            })(this$2$1, values$2, id$11, a$1)))
          })
        })(this, values, id, a)))
      }
    } else {
      throw new $c_s_MatchError().init___O(x0$1)
    }
  }
});
var $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter: 0
}, false, "amf.plugins.document.graph.emitter.FlattenedJsonLdEmitter", {
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter: 1,
  O: 1,
  Lamf_plugins_document_graph_emitter_CommonEmitter: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter;
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1() {
  $c_Lamf_plugins_document_graph_emitter_flattened_utils_Emission.call(this);
  this.id$2 = null;
  this.isDeclaration$2 = false;
  this.isReference$2 = false;
  this.isExternal$2 = false
}
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1.prototype = new $h_Lamf_plugins_document_graph_emitter_flattened_utils_Emission();
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1.prototype = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1.prototype;
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1.prototype.init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__Lamf_core_model_domain_AmfObject = (function($$outer, amfObject$1) {
  $c_Lamf_plugins_document_graph_emitter_flattened_utils_Emission.prototype.init___F1.call(this, new $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1$$anonfun$$lessinit$greater$1().init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__Lamf_core_model_domain_AmfObject($$outer, amfObject$1));
  $f_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata__$$init$__V(this);
  return this
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1.prototype.isDeclaration$und$eq__Z__V = (function(x$1) {
  this.isDeclaration$2 = x$1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1.prototype.isDeclaration__Z = (function() {
  return this.isDeclaration$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1.prototype.id__s_Option = (function() {
  return this.id$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1.prototype.isExternal$und$eq__Z__V = (function(x$1) {
  this.isExternal$2 = x$1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1.prototype.isExternal__Z = (function() {
  return this.isExternal$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1.prototype.isReference__Z = (function() {
  return this.isReference$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1.prototype.id$und$eq__s_Option__V = (function(x$1) {
  this.id$2 = x$1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1.prototype.isReference$und$eq__Z__V = (function(x$1) {
  this.isReference$2 = x$1
});
var $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1 = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1: 0
}, false, "amf.plugins.document.graph.emitter.FlattenedJsonLdEmitter$$anon$1", {
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1: 1,
  Lamf_plugins_document_graph_emitter_flattened_utils_Emission: 1,
  O: 1,
  Lamf_plugins_document_graph_emitter_flattened_utils_Metadata: 1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1;
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2() {
  $c_Lamf_plugins_document_graph_emitter_flattened_utils_Emission.call(this);
  this.id$2 = null;
  this.isDeclaration$2 = false;
  this.isReference$2 = false;
  this.isExternal$2 = false
}
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2.prototype = new $h_Lamf_plugins_document_graph_emitter_flattened_utils_Emission();
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2.prototype = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2.prototype;
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2.prototype.init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__Lamf_core_model_domain_extensions_DomainExtension__s_Option = (function($$outer, extension$1, field$1) {
  $c_Lamf_plugins_document_graph_emitter_flattened_utils_Emission.prototype.init___F1.call(this, new $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2$$anonfun$$lessinit$greater$2().init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__Lamf_core_model_domain_extensions_DomainExtension__s_Option($$outer, extension$1, field$1));
  $f_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata__$$init$__V(this);
  return this
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2.prototype.isDeclaration$und$eq__Z__V = (function(x$1) {
  this.isDeclaration$2 = x$1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2.prototype.isDeclaration__Z = (function() {
  return this.isDeclaration$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2.prototype.id__s_Option = (function() {
  return this.id$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2.prototype.isExternal$und$eq__Z__V = (function(x$1) {
  this.isExternal$2 = x$1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2.prototype.isExternal__Z = (function() {
  return this.isExternal$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2.prototype.isReference__Z = (function() {
  return this.isReference$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2.prototype.id$und$eq__s_Option__V = (function(x$1) {
  this.id$2 = x$1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2.prototype.isReference$und$eq__Z__V = (function(x$1) {
  this.isReference$2 = x$1
});
var $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2 = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2: 0
}, false, "amf.plugins.document.graph.emitter.FlattenedJsonLdEmitter$$anon$2", {
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2: 1,
  Lamf_plugins_document_graph_emitter_flattened_utils_Emission: 1,
  O: 1,
  Lamf_plugins_document_graph_emitter_flattened_utils_Metadata: 1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2;
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3() {
  $c_Lamf_plugins_document_graph_emitter_flattened_utils_Emission.call(this);
  this.id$2 = null;
  this.isDeclaration$2 = false;
  this.isReference$2 = false;
  this.isExternal$2 = false
}
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3.prototype = new $h_Lamf_plugins_document_graph_emitter_flattened_utils_Emission();
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3.prototype = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3.prototype;
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3.prototype.isDeclaration$und$eq__Z__V = (function(x$1) {
  this.isDeclaration$2 = x$1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3.prototype.isDeclaration__Z = (function() {
  return this.isDeclaration$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3.prototype.id__s_Option = (function() {
  return this.id$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3.prototype.init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__T__sc_Seq__Lamf_core_metamodel_Type = (function($$outer, id$7, seq$1, element$3) {
  $c_Lamf_plugins_document_graph_emitter_flattened_utils_Emission.prototype.init___F1.call(this, new $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3$$anonfun$$lessinit$greater$3().init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__T__sc_Seq__Lamf_core_metamodel_Type($$outer, id$7, seq$1, element$3));
  $f_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata__$$init$__V(this);
  return this
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3.prototype.isExternal$und$eq__Z__V = (function(x$1) {
  this.isExternal$2 = x$1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3.prototype.isExternal__Z = (function() {
  return this.isExternal$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3.prototype.isReference__Z = (function() {
  return this.isReference$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3.prototype.id$und$eq__s_Option__V = (function(x$1) {
  this.id$2 = x$1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3.prototype.isReference$und$eq__Z__V = (function(x$1) {
  this.isReference$2 = x$1
});
var $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3 = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3: 0
}, false, "amf.plugins.document.graph.emitter.FlattenedJsonLdEmitter$$anon$3", {
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3: 1,
  Lamf_plugins_document_graph_emitter_flattened_utils_Emission: 1,
  O: 1,
  Lamf_plugins_document_graph_emitter_flattened_utils_Metadata: 1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3;
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4() {
  $c_Lamf_plugins_document_graph_emitter_flattened_utils_Emission.call(this);
  this.id$2 = null;
  this.isDeclaration$2 = false;
  this.isReference$2 = false;
  this.isExternal$2 = false
}
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4.prototype = new $h_Lamf_plugins_document_graph_emitter_flattened_utils_Emission();
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4.prototype = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4.prototype;
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4.prototype.isDeclaration$und$eq__Z__V = (function(x$1) {
  this.isDeclaration$2 = x$1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4.prototype.isDeclaration__Z = (function() {
  return this.isDeclaration$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4.prototype.id__s_Option = (function() {
  return this.id$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4.prototype.isExternal$und$eq__Z__V = (function(x$1) {
  this.isExternal$2 = x$1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4.prototype.isExternal__Z = (function() {
  return this.isExternal$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4.prototype.isReference__Z = (function() {
  return this.isReference$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4.prototype.id$und$eq__s_Option__V = (function(x$1) {
  this.id$2 = x$1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4.prototype.isReference$und$eq__Z__V = (function(x$1) {
  this.isReference$2 = x$1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4.prototype.init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__T__Lamf_core_model_document_SourceMap = (function($$outer, id$9, sources$6) {
  $c_Lamf_plugins_document_graph_emitter_flattened_utils_Emission.prototype.init___F1.call(this, new $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4$$anonfun$$lessinit$greater$4().init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__T__Lamf_core_model_document_SourceMap($$outer, id$9, sources$6));
  $f_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata__$$init$__V(this);
  return this
});
var $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4 = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4: 0
}, false, "amf.plugins.document.graph.emitter.FlattenedJsonLdEmitter$$anon$4", {
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4: 1,
  Lamf_plugins_document_graph_emitter_flattened_utils_Emission: 1,
  O: 1,
  Lamf_plugins_document_graph_emitter_flattened_utils_Metadata: 1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4;
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5() {
  $c_Lamf_plugins_document_graph_emitter_flattened_utils_Emission.call(this);
  this.id$2 = null;
  this.isDeclaration$2 = false;
  this.isReference$2 = false;
  this.isExternal$2 = false
}
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5.prototype = new $h_Lamf_plugins_document_graph_emitter_flattened_utils_Emission();
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5.prototype = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5.prototype;
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5.prototype.isDeclaration$und$eq__Z__V = (function(x$1) {
  this.isDeclaration$2 = x$1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5.prototype.isDeclaration__Z = (function() {
  return this.isDeclaration$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5.prototype.id__s_Option = (function() {
  return this.id$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5.prototype.isExternal$und$eq__Z__V = (function(x$1) {
  this.isExternal$2 = x$1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5.prototype.isExternal__Z = (function() {
  return this.isExternal$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5.prototype.isReference__Z = (function() {
  return this.isReference$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5.prototype.id$und$eq__s_Option__V = (function(x$1) {
  this.id$2 = x$1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5.prototype.isReference$und$eq__Z__V = (function(x$1) {
  this.isReference$2 = x$1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5.prototype.init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__T__Lamf_core_model_document_SourceMap = (function($$outer, id$10, sources$7) {
  $c_Lamf_plugins_document_graph_emitter_flattened_utils_Emission.prototype.init___F1.call(this, new $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5$$anonfun$$lessinit$greater$5().init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__T__Lamf_core_model_document_SourceMap($$outer, id$10, sources$7));
  $f_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata__$$init$__V(this);
  return this
});
var $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5 = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5: 0
}, false, "amf.plugins.document.graph.emitter.FlattenedJsonLdEmitter$$anon$5", {
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5: 1,
  Lamf_plugins_document_graph_emitter_flattened_utils_Emission: 1,
  O: 1,
  Lamf_plugins_document_graph_emitter_flattened_utils_Metadata: 1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5;
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6() {
  $c_Lamf_plugins_document_graph_emitter_flattened_utils_Emission.call(this);
  this.id$2 = null;
  this.isDeclaration$2 = false;
  this.isReference$2 = false;
  this.isExternal$2 = false
}
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6.prototype = new $h_Lamf_plugins_document_graph_emitter_flattened_utils_Emission();
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6.prototype = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6.prototype;
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6.prototype.isDeclaration$und$eq__Z__V = (function(x$1) {
  this.isDeclaration$2 = x$1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6.prototype.isDeclaration__Z = (function() {
  return this.isDeclaration$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6.prototype.id__s_Option = (function() {
  return this.id$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6.prototype.init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__T__T__T = (function($$outer, id$12, iri$1, v$6) {
  $c_Lamf_plugins_document_graph_emitter_flattened_utils_Emission.prototype.init___F1.call(this, new $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6$$anonfun$$lessinit$greater$6().init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__T__T__T($$outer, id$12, iri$1, v$6));
  $f_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata__$$init$__V(this);
  return this
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6.prototype.isExternal$und$eq__Z__V = (function(x$1) {
  this.isExternal$2 = x$1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6.prototype.isExternal__Z = (function() {
  return this.isExternal$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6.prototype.isReference__Z = (function() {
  return this.isReference$2
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6.prototype.id$und$eq__s_Option__V = (function(x$1) {
  this.id$2 = x$1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6.prototype.isReference$und$eq__Z__V = (function(x$1) {
  this.isReference$2 = x$1
});
var $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6 = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6: 0
}, false, "amf.plugins.document.graph.emitter.FlattenedJsonLdEmitter$$anon$6", {
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6: 1,
  Lamf_plugins_document_graph_emitter_flattened_utils_Emission: 1,
  O: 1,
  Lamf_plugins_document_graph_emitter_flattened_utils_Metadata: 1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6;
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_JsonLdEmitter() {
  $c_O.call(this);
  this.builder$1 = null;
  this.options$1 = null;
  this.ctx$1 = null;
  this.cache$1 = null
}
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_JsonLdEmitter;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_JsonLdEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype = $c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype;
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.root__Lamf_core_model_document_BaseUnit__V = (function(unit) {
  var declaresEntry = unit.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_document_ModuleModel$().Declares$1);
  var referencesEntry = unit.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_document_ModuleModel$().References$1);
  var annotations = unit.annotations__Lamf_core_parser_Annotations();
  var ctx = this.ctx$1;
  $f_Lamf_plugins_document_graph_emitter_CommonEmitter__extractDeclarationsAndReferencesToContext__s_Option__s_Option__Lamf_core_parser_Annotations__Lamf_plugins_document_graph_emitter_EmissionContext__Lamf_plugins_document_graph_emitter_EmissionContext(this, declaresEntry, referencesEntry, annotations, ctx);
  unit.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_core_metamodel_document_ModuleModel$().Declares$1);
  unit.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_core_metamodel_document_ModuleModel$().References$1);
  this.builder$1.list__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, unit$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lorg_yaml_builder_DocBuilder$Part(x$1$2);
      x$1.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, unit$1$1) {
        return (function(eb$2) {
          var eb = $as_Lorg_yaml_builder_DocBuilder$Entry(eb$2);
          $this$1.traverse__Lamf_core_model_domain_AmfObject__Lorg_yaml_builder_DocBuilder$Entry__V(unit$1$1, eb);
          $this$1.emitReferences__p1__Lorg_yaml_builder_DocBuilder$Entry__T__Lamf_core_model_document_SourceMap__V(eb, unit$1$1.id__T(), $m_Lamf_core_model_document_SourceMap$().apply__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_document_SourceMap(unit$1$1.id__T(), unit$1$1));
          $this$1.emitDeclarations__p1__Lorg_yaml_builder_DocBuilder$Entry__T__Lamf_core_model_document_SourceMap__V(eb, unit$1$1.id__T(), $m_Lamf_core_model_document_SourceMap$().apply__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_document_SourceMap(unit$1$1.id__T(), unit$1$1));
          $this$1.ctx$1.emitContext__Lorg_yaml_builder_DocBuilder$Entry__V(eb)
        })
      })($this, unit$1)))
    })
  })(this, unit)));
  if ((!declaresEntry.isEmpty__Z())) {
    var arg1 = declaresEntry.get__O();
    var e = $as_Lamf_core_parser_FieldEntry(arg1);
    unit.fields__Lamf_core_parser_Fields().setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_core_metamodel_document_ModuleModel$().Declares$1, $as_Lamf_core_model_domain_AmfArray(e.value$1.value$1), (unit.fields__Lamf_core_parser_Fields(), $m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
  };
  if ((!referencesEntry.isEmpty__Z())) {
    var arg1$1 = referencesEntry.get__O();
    var e$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    unit.fields__Lamf_core_parser_Fields().setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_core_metamodel_document_ModuleModel$().References$1, $as_Lamf_core_model_domain_AmfArray(e$3.value$1.value$1), (unit.fields__Lamf_core_parser_Fields(), $m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
  }
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.emit$1__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfObject__V = (function(b, element$4) {
  var rc6 = false;
  var x3 = null;
  var x1 = this.cache$1.get__O__s_Option(element$4.id__T());
  matchEnd7: {
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var value = x2.value$2;
      b.$$plus$eq__O__V(value);
      break matchEnd7
    };
    var x = $m_s_None$();
    if ((x === x1)) {
      rc6 = true;
      x3 = x1;
      if (this.isExternalLink__p1__Lamf_core_model_domain_AmfObject__Z(element$4)) {
        b.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, element$4$1) {
          return (function(x$15$2) {
            var x$15 = $as_Lorg_yaml_builder_DocBuilder$Entry(x$15$2);
            $this.traverse__Lamf_core_model_domain_AmfObject__Lorg_yaml_builder_DocBuilder$Entry__V(element$4$1, x$15)
          })
        })(this, element$4)));
        break matchEnd7
      }
    };
    if (rc6) {
      var this$1 = b.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, element$4$2) {
        return (function(x$16$2) {
          var x$16 = $as_Lorg_yaml_builder_DocBuilder$Entry(x$16$2);
          this$2.traverse__Lamf_core_model_domain_AmfObject__Lorg_yaml_builder_DocBuilder$Entry__V(element$4$2, x$16)
        })
      })(this, element$4)));
      if ((!this$1.isEmpty__Z())) {
        var arg1 = this$1.get__O();
        this.cache$1.put__O__O__s_Option(element$4.id__T(), arg1)
      };
      break matchEnd7
    };
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.createEternalsAnnotationsNodes__p1__T__Lamf_core_emitter_RenderOptions__Lorg_yaml_builder_DocBuilder$Entry__Lamf_core_model_document_SourceMap__V = (function(id, options, b, sources) {
  var this$1 = sources.eternals$1;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$1)) {
    if (options.rawSourceMaps$1) {
      b.entry__T__F1__V("smaps", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, id$1, sources$1) {
        return (function(x$28$2) {
          var x$28 = $as_Lorg_yaml_builder_DocBuilder$Part(x$28$2);
          x$28.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, id$7, sources$7) {
            return (function(b$2) {
              var b$1 = $as_Lorg_yaml_builder_DocBuilder$Entry(b$2);
              $this$1.createAnnotationNodes__p1__T__Lorg_yaml_builder_DocBuilder$Entry__scm_ListMap__V(id$7, b$1, sources$7.eternals$1)
            })
          })($this, id$1, sources$1)))
        })
      })(this, id, sources)))
    } else {
      b.entry__T__F1__V(this.ctx$1.emitIri__T__T($m_Lamf_core_metamodel_domain_DomainElementModel$().Sources$1.value$1.iri__T()), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, id$2, sources$2) {
        return (function(x$29$2) {
          var x$29 = $as_Lorg_yaml_builder_DocBuilder$Part(x$29$2);
          x$29.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, id$7$1, sources$7$1) {
            return (function(x$30$2) {
              var x$30 = $as_Lorg_yaml_builder_DocBuilder$Part(x$30$2);
              x$30.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, id$7$2, sources$7$2) {
                return (function(b$2$1) {
                  var b$3 = $as_Lorg_yaml_builder_DocBuilder$Entry(b$2$1);
                  $this$3.createIdNode__p1__Lorg_yaml_builder_DocBuilder$Entry__T__V(b$3, id$7$2);
                  var obj = $m_Lamf_core_metamodel_document_SourceMapModel$();
                  var ctx = $this$3.ctx$1;
                  $f_Lamf_plugins_document_graph_emitter_CommonEmitter__createTypeNode__Lorg_yaml_builder_DocBuilder$Entry__Lamf_core_metamodel_Obj__Lamf_plugins_document_graph_emitter_EmissionContext__V($this$3, b$3, obj, ctx);
                  $this$3.createAnnotationNodes__p1__T__Lorg_yaml_builder_DocBuilder$Entry__scm_ListMap__V(id$7$2, b$3, sources$7$2.eternals$1)
                })
              })($this$2, id$7$1, sources$7$1)))
            })
          })(this$2, id$2, sources$2)))
        })
      })(this, id, sources)))
    }
  }
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.emit$2__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_DomainElement__V = (function(b, elementWithLink$1) {
  var this$1 = $as_Lamf_core_model_domain_Linkable(elementWithLink$1);
  var savedLinkTarget = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1);
  var this$2 = $as_Lamf_core_model_domain_Linkable(elementWithLink$1);
  var this$3 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2);
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var target = $as_Lamf_core_model_domain_DomainElement(arg1);
    var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().TargetId$1;
    var value = target.id__T();
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(elementWithLink$1, field, value);
    elementWithLink$1.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_core_metamodel_domain_LinkableElementModel$().Target$1)
  };
  b.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, elementWithLink$1$1) {
    return (function(o$2) {
      var o = $as_Lorg_yaml_builder_DocBuilder$Entry(o$2);
      this$2$1.traverse__Lamf_core_model_domain_AmfObject__Lorg_yaml_builder_DocBuilder$Entry__V(elementWithLink$1$1, o)
    })
  })(this, elementWithLink$1)));
  if ((!savedLinkTarget.isEmpty__Z())) {
    var arg1$1 = savedLinkTarget.get__O();
    var target$3 = $as_Lamf_core_model_domain_DomainElement(arg1$1);
    elementWithLink$1.fields__Lamf_core_parser_Fields().setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_core_metamodel_domain_LinkableElementModel$().Target$1, target$3, (elementWithLink$1.fields__Lamf_core_parser_Fields(), $m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
  }
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.createSourcesNode__p1__T__Lamf_core_model_document_SourceMap__Lorg_yaml_builder_DocBuilder$Entry__V = (function(id, sources, b) {
  var this$1 = this.options$1;
  if (this$1.amf$core$emitter$RenderOptions$$sources$1) {
    var this$2 = sources.annotations$1;
    var jsx$1 = $f_sc_TraversableOnce__nonEmpty__Z(this$2)
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var this$3 = this.options$1;
    if (this$3.rawSourceMaps$1) {
      b.entry__T__F1__V("smaps", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, id$1, sources$1) {
        return (function(x$25$2) {
          var x$25 = $as_Lorg_yaml_builder_DocBuilder$Part(x$25$2);
          x$25.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, id$6, sources$6) {
            return (function(b$2) {
              var b$1 = $as_Lorg_yaml_builder_DocBuilder$Entry(b$2);
              $this$1.createAnnotationNodes__p1__T__Lorg_yaml_builder_DocBuilder$Entry__scm_ListMap__V(id$6, b$1, sources$6.annotations$1);
              $this$1.createAnnotationNodes__p1__T__Lorg_yaml_builder_DocBuilder$Entry__scm_ListMap__V(id$6, b$1, sources$6.eternals$1)
            })
          })($this, id$1, sources$1)))
        })
      })(this, id, sources)))
    } else {
      b.entry__T__F1__V(this.ctx$1.emitIri__T__T($m_Lamf_core_metamodel_domain_DomainElementModel$().Sources$1.value$1.iri__T()), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, id$2, sources$2) {
        return (function(x$26$2) {
          var x$26 = $as_Lorg_yaml_builder_DocBuilder$Part(x$26$2);
          x$26.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, id$6$1, sources$6$1) {
            return (function(x$27$2) {
              var x$27 = $as_Lorg_yaml_builder_DocBuilder$Part(x$27$2);
              x$27.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, id$6$2, sources$6$2) {
                return (function(b$2$1) {
                  var b$3 = $as_Lorg_yaml_builder_DocBuilder$Entry(b$2$1);
                  $this$3.createIdNode__p1__Lorg_yaml_builder_DocBuilder$Entry__T__V(b$3, id$6$2);
                  var obj = $m_Lamf_core_metamodel_document_SourceMapModel$();
                  var ctx = $this$3.ctx$1;
                  $f_Lamf_plugins_document_graph_emitter_CommonEmitter__createTypeNode__Lorg_yaml_builder_DocBuilder$Entry__Lamf_core_metamodel_Obj__Lamf_plugins_document_graph_emitter_EmissionContext__V($this$3, b$3, obj, ctx);
                  $this$3.createAnnotationNodes__p1__T__Lorg_yaml_builder_DocBuilder$Entry__scm_ListMap__V(id$6$2, b$3, sources$6$2.annotations$1);
                  $this$3.createAnnotationNodes__p1__T__Lorg_yaml_builder_DocBuilder$Entry__scm_ListMap__V(id$6$2, b$3, sources$6$2.eternals$1)
                })
              })($this$2, id$6$1, sources$6$1)))
            })
          })(this$2$1, id$2, sources$2)))
        })
      })(this, id, sources)))
    }
  } else {
    this.createEternalsAnnotationsNodes__p1__T__Lamf_core_emitter_RenderOptions__Lorg_yaml_builder_DocBuilder$Entry__Lamf_core_model_document_SourceMap__V(id, this.options$1, b, sources)
  }
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.iri__p1__Lorg_yaml_builder_DocBuilder$Part__T__Z__V = (function(b, content, inArray) {
  if (inArray) {
    this.emit$3__p1__Lorg_yaml_builder_DocBuilder$Part__T__V(b, content)
  } else {
    b.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, content$1) {
      return (function(b$2$2) {
        var b$2 = $as_Lorg_yaml_builder_DocBuilder$Part(b$2$2);
        $this.emit$3__p1__Lorg_yaml_builder_DocBuilder$Part__T__V(b$2, content$1)
      })
    })(this, content)))
  }
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.listWithScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V = (function(b, content, t) {
  b.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, content$1, t$1) {
    return (function(x$37$2) {
      var x$37 = $as_Lorg_yaml_builder_DocBuilder$Part(x$37$2);
      $this.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(x$37, content$1, t$1)
    })
  })(this, content, t)))
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.extractToLink__p1__Lamf_core_model_domain_Shape__Lorg_yaml_builder_DocBuilder$Part__Z__V = (function(shape, b, inArray) {
  var this$1 = this.ctx$1;
  if (((!this$1.declarations$1.contains__O__Z(shape)) && (!this.ctx$1.isInReferencedShapes__Lamf_core_model_domain_AmfElement__Z(shape)))) {
    this.ctx$1.$$plus__Lamf_core_model_domain_AmfElement__Lamf_plugins_document_graph_emitter_EmissionContext(shape);
    var x1 = $as_Lamf_core_model_StrField(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$2 = this.ctx$1;
      var name = this$2.typeCount$1.genId__T__T("amf_inline_type");
      $m_Lamf_core_parser_Annotations$();
      var a = new $c_Lamf_core_parser_Annotations().init___();
      $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, name, a);
      shape.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_InlineElement().init___())
    } else {
      matchEnd14: {
        var jsx$1;
        if ((x1 instanceof $c_s_Some)) {
          var x2 = $as_s_Some(x1);
          var p3 = $as_T(x2.value$2);
          if ((p3 === "schema")) {
            var jsx$1 = true;
            break matchEnd14
          }
        };
        if ((x1 instanceof $c_s_Some)) {
          var x4 = $as_s_Some(x1);
          var p5 = $as_T(x4.value$2);
          if ((p5 === "type")) {
            var jsx$1 = true;
            break matchEnd14
          }
        };
        var jsx$1 = false
      };
      if (jsx$1) {
        shape.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_InlineElement().init___())
      } else if ((!shape.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf()))) {
        shape.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_InlineElement().init___())
      }
    }
  };
  var this$4 = $as_Lamf_core_model_StrField(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
  var this$5 = this$4.option$1;
  var linkLabel = $as_T((this$5.isEmpty__Z() ? null : this$5.get__O()));
  if ((shape instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
    var x2$2 = $as_Lamf_core_model_domain_RecursiveShape(shape);
    var this$6 = (("" + x2$2.id$1) + linkLabel);
    var hash = $m_sjsr_RuntimeString$().hashCode__T__I(this$6);
    var fields = new $c_Lamf_core_parser_Fields().init___();
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var this$10 = new $c_Lamf_core_model_domain_RecursiveShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
    var value = ((x2$2.id$1 + "/link-") + hash);
    var this$11 = $as_Lamf_core_model_domain_Linkable($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$10, value));
    var this$12 = $as_Lamf_core_model_domain_Linkable($f_Lamf_core_model_domain_Linkable__withLinkTarget__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(this$11, x2$2));
    var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1;
    var linked = $as_Lamf_core_model_domain_Shape($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$12, field, linkLabel)))
  } else {
    var linked = $as_Lamf_core_model_domain_Shape(shape.link__T__Lamf_core_parser_Annotations__O(linkLabel, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___())))
  };
  this.link__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_DomainElement__Z__V(b, linked, inArray)
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.traverseMetaModel__T__Lamf_core_model_domain_AmfObject__Lamf_core_model_document_SourceMap__Lamf_core_metamodel_Obj__Lorg_yaml_builder_DocBuilder$Entry__V = (function(id, element, sources, obj, b) {
  var ctx = this.ctx$1;
  $f_Lamf_plugins_document_graph_emitter_CommonEmitter__createTypeNode__Lorg_yaml_builder_DocBuilder$Entry__Lamf_core_metamodel_Obj__Lamf_plugins_document_graph_emitter_EmissionContext__V(this, b, obj, ctx);
  var modelFields = $f_Lamf_plugins_document_graph_emitter_CommonEmitter__getMetaModelFields__Lamf_core_model_domain_AmfObject__Lamf_core_metamodel_Obj__sc_Seq(this, element, obj);
  matchEnd4: {
    if ((element instanceof $c_Lamf_core_model_domain_ObjectNode)) {
      var x2 = $as_Lamf_core_model_domain_ObjectNode(element);
      var this$1 = this.options$1;
      if (this$1.validating$1) {
        var url = ($m_Lamf_core_vocabulary_Namespace$().AmfValidation$1.base$1 + "/properties");
        b.entry__T__F1__V(url, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x2$1, id$1) {
          return (function(x$5$2) {
            var x$5 = $as_Lorg_yaml_builder_DocBuilder$Part(x$5$2);
            var t = $m_Lamf_core_metamodel_Type$Int$();
            var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(x2$1.propertyFields__sc_Iterable().size__I(), new $c_Lamf_core_parser_Annotations().init___());
            $m_Lamf_core_parser_Annotations$();
            var annotations = new $c_Lamf_core_parser_Annotations().init___();
            var v = new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value, annotations);
            var f = (function($this$1) {
              return (function(x$4$2) {
                $as_Lamf_core_parser_Value(x$4$2)
              })
            })($this);
            var x = $m_Lamf_core_metamodel_Type$Iri$();
            if (x.equals__O__Z(t)) {
              $this.iri__p1__Lorg_yaml_builder_DocBuilder$Part__T__Z__V(x$5, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T(), false);
              $asUnit(f(v))
            } else {
              var x$3 = $m_Lamf_core_metamodel_Type$EncodedIri$();
              if (x$3.equals__O__Z(t)) {
                $this.safeIri__p1__Lorg_yaml_builder_DocBuilder$Part__T__Z__V(x$5, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T(), false);
                $asUnit(f(v))
              } else {
                var x$5$1 = $m_Lamf_core_metamodel_Type$LiteralUri$();
                if (x$5$1.equals__O__Z(t)) {
                  $this.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(x$5, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T(), $m_Lamf_core_model_DataType$().AnyUri$1, false);
                  $asUnit(f(v))
                } else {
                  var x$7 = $m_Lamf_core_metamodel_Type$Str$();
                  if (x$7.equals__O__Z(t)) {
                    var content = v.value$1;
                    $this.listWithScalar__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(x$5, content, $m_Lorg_yaml_builder_DocBuilder$SType$Str$());
                    $asUnit(f(v))
                  } else {
                    var x$9 = $m_Lamf_core_metamodel_Type$Bool$();
                    if (x$9.equals__O__Z(t)) {
                      $this.listWithScalar__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(x$5, v.value$1, $m_Lorg_yaml_builder_DocBuilder$SType$Bool$());
                      $asUnit(f(v))
                    } else {
                      var x$11 = $m_Lamf_core_metamodel_Type$Int$();
                      if (x$11.equals__O__Z(t)) {
                        $this.listWithScalar__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(x$5, v.value$1, $m_Lorg_yaml_builder_DocBuilder$SType$Int$());
                        $asUnit(f(v))
                      } else {
                        var x$13 = $m_Lamf_core_metamodel_Type$Double$();
                        if (x$13.equals__O__Z(t)) {
                          $this.listWithScalar__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(x$5, v.value$1, $m_Lorg_yaml_builder_DocBuilder$SType$Float$());
                          $asUnit(f(v))
                        } else {
                          var x$15 = $m_Lamf_core_metamodel_Type$Float$();
                          if (x$15.equals__O__Z(t)) {
                            $this.listWithScalar__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(x$5, v.value$1, $m_Lorg_yaml_builder_DocBuilder$SType$Float$());
                            $asUnit(f(v))
                          } else {
                            var x$17 = $m_Lamf_core_metamodel_Type$DateTime$();
                            if (x$17.equals__O__Z(t)) {
                              var dateTime = $as_Lorg_mulesoft_common_time_SimpleDateTime($as_Lamf_core_model_domain_AmfScalar(v.value$1).value$1);
                              $this.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(x$5, dateTime.toString__T(), $m_Lamf_core_model_DataType$().DateTime$1, false);
                              $asUnit(f(v))
                            } else {
                              var x$19 = $m_Lamf_core_metamodel_Type$Date$();
                              if (x$19.equals__O__Z(t)) {
                                var x1$2 = $as_Lamf_core_model_domain_AmfScalar(v.value$1).value$1;
                                if ((x1$2 instanceof $c_Lorg_mulesoft_common_time_SimpleDateTime)) {
                                  var x2$2 = $as_Lorg_mulesoft_common_time_SimpleDateTime(x1$2);
                                  var maybeDateTime = new $c_s_Some().init___O(x2$2)
                                } else {
                                  var maybeDateTime = $m_Lorg_mulesoft_common_time_SimpleDateTime$().parse__T__s_util_Either($objectToString(x1$2)).toOption__s_Option()
                                };
                                if ((maybeDateTime instanceof $c_s_Some)) {
                                  var x2$2$1 = $as_s_Some(maybeDateTime);
                                  var dateTime$2 = $as_Lorg_mulesoft_common_time_SimpleDateTime(x2$2$1.value$2);
                                  $this.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(x$5, dateTime$2.toString__T(), ((dateTime$2.timeOfDay$1.isDefined__Z() || dateTime$2.zoneOffset$1.isDefined__Z()) ? $m_Lamf_core_model_DataType$().DateTime$1 : $m_Lamf_core_model_DataType$().Date$1), false)
                                } else {
                                  var content$1 = v.value$1;
                                  $this.listWithScalar__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(x$5, content$1, $m_Lorg_yaml_builder_DocBuilder$SType$Str$())
                                };
                                $asUnit(f(v))
                              } else {
                                var x$21 = $m_Lamf_core_metamodel_Type$Any$();
                                if (((x$21 === t) && (v.value$1 instanceof $c_Lamf_core_model_domain_AmfScalar))) {
                                  var x1$4 = $as_Lamf_core_model_domain_AmfScalar(v.value$1).value$1;
                                  if (((typeof x1$4) === "boolean")) {
                                    var x2$3 = $uZ(x1$4);
                                    $this.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(x$5, ("" + x2$3), $m_Lamf_core_model_DataType$().Boolean$1, true)
                                  } else if ($isInt(x1$4)) {
                                    var x3$2 = $uI(x1$4);
                                    $this.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(x$5, ("" + x3$2), $m_Lamf_core_model_DataType$().Integer$1, true)
                                  } else if ($isFloat(x1$4)) {
                                    var x4 = $uF(x1$4);
                                    $this.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(x$5, ("" + x4), $m_Lamf_core_model_DataType$().Float$1, true)
                                  } else if (((typeof x1$4) === "number")) {
                                    var x5 = $uD(x1$4);
                                    $this.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(x$5, ("" + x5), $m_Lamf_core_model_DataType$().Double$1, true)
                                  } else if ((x1$4 instanceof $c_Lorg_mulesoft_common_time_SimpleDateTime)) {
                                    var x6 = $as_Lorg_mulesoft_common_time_SimpleDateTime(x1$4);
                                    $this.emitSimpleDateTime__p1__Lorg_yaml_builder_DocBuilder$Part__Lorg_mulesoft_common_time_SimpleDateTime__Z__V(x$5, x6, true)
                                  } else {
                                    var content$2 = $objectToString(x1$4);
                                    $this.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(x$5, content$2, $m_Lorg_yaml_builder_DocBuilder$SType$Str$())
                                  }
                                } else {
                                  throw new $c_s_MatchError().init___O(t)
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          })
        })(this, x2, id)));
        break matchEnd4
      }
    }
  };
  modelFields.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, element$1, id$2, sources$1, b$1) {
    return (function(f$2) {
      var f$1 = $as_Lamf_core_metamodel_Field(f$2);
      this$2$1.emitStaticField__p1__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfObject__T__Lamf_core_model_document_SourceMap__Lorg_yaml_builder_DocBuilder$Entry__V(f$1, element$1, id$2, sources$1, b$1)
    })
  })(this, element, id, sources, b)))
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.safeIri__p1__Lorg_yaml_builder_DocBuilder$Part__T__Z__V = (function(b, content, inArray) {
  if (inArray) {
    this.emit$4__p1__Lorg_yaml_builder_DocBuilder$Part__T__V(b, content)
  } else {
    b.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, content$1) {
      return (function(b$2$2) {
        var b$2 = $as_Lorg_yaml_builder_DocBuilder$Part(b$2$2);
        $this.emit$4__p1__Lorg_yaml_builder_DocBuilder$Part__T__V(b$2, content$1)
      })
    })(this, content)))
  }
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.createSortedArray__Lorg_yaml_builder_DocBuilder$Part__sc_Seq__T__Lamf_core_metamodel_Type__V = (function(b, seq, parent, element) {
  b.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$1, seq$1, element$1) {
    return (function(x$14$2) {
      var x$14 = $as_Lorg_yaml_builder_DocBuilder$Part(x$14$2);
      x$14.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, parent$1$1, seq$1$1, element$3) {
        return (function(b$2) {
          var b$1 = $as_Lorg_yaml_builder_DocBuilder$Entry(b$2);
          var id = (parent$1$1 + "/list");
          $this$1.createIdNode__p1__Lorg_yaml_builder_DocBuilder$Entry__T__V(b$1, id);
          var jsx$1 = $this$1.ctx$1;
          var this$1 = $m_Lamf_core_vocabulary_Namespace$().Rdfs$1;
          b$1.entry__T__T__V("@type", jsx$1.emitIri__T__T(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "Seq").iri__T()));
          var this$3 = $m_sc_Seq$();
          $as_sc_IterableLike(seq$1$1.zipWithIndex__scg_CanBuildFrom__O(this$3.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, b$3, element$3$1) {
            return (function(x0$1$2) {
              var x0$1 = $as_T2(x0$1$2);
              if ((x0$1 !== null)) {
                var e = $as_Lamf_core_model_domain_AmfElement(x0$1.$$und1__O());
                var i = x0$1.$$und2$mcI$sp__I();
                var jsx$2 = $this$2.ctx$1;
                var this$4 = $m_Lamf_core_vocabulary_Namespace$().Rdfs$1;
                var id$1 = ("_" + ((1 + i) | 0));
                b$3.entry__T__F1__V(jsx$2.emitIri__T__T(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, id$1).iri__T()), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, element$3$2, e$1) {
                  return (function(b$2$1) {
                    var b$4 = $as_Lorg_yaml_builder_DocBuilder$Part(b$2$1);
                    b$4.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$4, element$3$3, e$1$1) {
                      return (function(b$2$2) {
                        var b$2$3 = $as_Lorg_yaml_builder_DocBuilder$Part(b$2$2);
                        if ($is_Lamf_core_metamodel_Obj(element$3$3)) {
                          matchEnd5: {
                            if (($is_Lamf_core_model_domain_DomainElement(e$1$1) && $is_Lamf_core_model_domain_Linkable(e$1$1))) {
                              var x2 = $as_Lamf_core_model_domain_DomainElement(e$1$1);
                              var this$6 = $as_Lamf_core_model_domain_Linkable(x2);
                              if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$6).isDefined__Z()) {
                                $this$4.link__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_DomainElement__Z__V(b$2$3, x2, true);
                                break matchEnd5
                              }
                            };
                            if ($is_Lamf_core_model_domain_AmfObject(e$1$1)) {
                              var x3 = $as_Lamf_core_model_domain_AmfObject(e$1$1);
                              $this$4.obj__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfObject__Z__V(b$2$3, x3, true);
                              break matchEnd5
                            };
                            throw new $c_s_MatchError().init___O(e$1$1)
                          }
                        } else {
                          var x$2 = $m_Lamf_core_metamodel_Type$Str$();
                          if (x$2.equals__O__Z(element$3$3)) {
                            $this$4.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(b$2$3, e$1$1, $m_Lorg_yaml_builder_DocBuilder$SType$Str$())
                          } else {
                            var x$4 = $m_Lamf_core_metamodel_Type$EncodedIri$();
                            if (x$4.equals__O__Z(element$3$3)) {
                              $this$4.safeIri__p1__Lorg_yaml_builder_DocBuilder$Part__T__Z__V(b$2$3, $as_Lamf_core_model_domain_AmfScalar(e$1$1).toString__T(), true)
                            } else {
                              var x$6 = $m_Lamf_core_metamodel_Type$Iri$();
                              if (x$6.equals__O__Z(element$3$3)) {
                                $this$4.iri__p1__Lorg_yaml_builder_DocBuilder$Part__T__Z__V(b$2$3, $as_Lamf_core_model_domain_AmfScalar(e$1$1).toString__T(), true)
                              } else {
                                var x$8 = $m_Lamf_core_metamodel_Type$Any$();
                                if ((x$8 === element$3$3)) {
                                  var scalarElement = $as_Lamf_core_model_domain_AmfScalar(e$1$1);
                                  var x1$3 = scalarElement.value$1;
                                  if (((typeof x1$3) === "boolean")) {
                                    var x2$2 = $uZ(x1$3);
                                    $this$4.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b$2$3, ("" + x2$2), $m_Lamf_core_model_DataType$().Boolean$1, true)
                                  } else if ($is_T(x1$3)) {
                                    var x3$2 = $as_T(x1$3);
                                    $this$4.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b$2$3, x3$2, $m_Lamf_core_model_DataType$().String$1, true)
                                  } else if ($isInt(x1$3)) {
                                    var x4 = $uI(x1$3);
                                    $this$4.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b$2$3, ("" + x4), $m_Lamf_core_model_DataType$().Integer$1, true)
                                  } else if ($isFloat(x1$3)) {
                                    var x5 = $uF(x1$3);
                                    $this$4.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b$2$3, ("" + x5), $m_Lamf_core_model_DataType$().Float$1, true)
                                  } else if (((typeof x1$3) === "number")) {
                                    var x6 = $uD(x1$3);
                                    $this$4.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b$2$3, ("" + x6), $m_Lamf_core_model_DataType$().Double$1, true)
                                  } else {
                                    var content = $objectToString(x1$3);
                                    $this$4.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(b$2$3, content, $m_Lorg_yaml_builder_DocBuilder$SType$Str$())
                                  }
                                } else {
                                  throw new $c_s_MatchError().init___O(element$3$3)
                                }
                              }
                            }
                          }
                        }
                      })
                    })($this$3, element$3$2, e$1)))
                  })
                })($this$2, element$3$1, e)))
              } else {
                throw new $c_s_MatchError().init___O(x0$1)
              }
            })
          })($this$1, b$1, element$3)))
        })
      })($this, parent$1, seq$1, element$1)))
    })
  })(this, parent, seq, element)))
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.createCustomExtension__p1__Lorg_yaml_builder_DocBuilder$Entry__T__Lamf_core_model_domain_extensions_DomainExtension__s_Option__V = (function(b, uri, extension, field) {
  b.entry__T__F1__V(uri, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, extension$1, field$1) {
    return (function(x$11$2) {
      var x$11 = $as_Lorg_yaml_builder_DocBuilder$Part(x$11$2);
      x$11.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, extension$1$1, field$1$1) {
        return (function(b$2) {
          var b$1 = $as_Lorg_yaml_builder_DocBuilder$Entry(b$2);
          b$1.entry__T__F1__V($this$1.ctx$1.emitIri__T__T($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1.value$1.iri__T()), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, extension$1$2) {
            return (function(x$12$2) {
              var x$12 = $as_Lorg_yaml_builder_DocBuilder$Part(x$12$2);
              var this$1 = $as_Lamf_core_model_StrField(extension$1$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1));
              var this$2 = this$1.option$1;
              var content = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
              $this$2.listWithScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(x$12, content, $m_Lorg_yaml_builder_DocBuilder$SType$Str$())
            })
          })($this$1, extension$1$1)));
          if ((!field$1$1.isEmpty__Z())) {
            var arg1 = field$1$1.get__O();
            var f = $as_Lamf_core_metamodel_Field(arg1);
            b$1.entry__T__F1__V($this$1.ctx$1.emitIri__T__T($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Element$1.value$1.iri__T()), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, f$1) {
              return (function(x$13$2) {
                var x$13 = $as_Lorg_yaml_builder_DocBuilder$Part(x$13$2);
                var content$1 = f$1.value$1.iri__T();
                $this$3.listWithScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(x$13, content$1, $m_Lorg_yaml_builder_DocBuilder$SType$Str$())
              })
            })($this$1, f)))
          };
          $this$1.traverse__Lamf_core_model_domain_AmfObject__Lorg_yaml_builder_DocBuilder$Entry__V($as_Lamf_core_model_domain_DataNode(extension$1$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)), b$1)
        })
      })($this, extension$1, field$1)))
    })
  })(this, extension, field)))
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.obj__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfObject__Z__V = (function(b, element, inArray) {
  if (inArray) {
    this.emit$1__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfObject__V(b, element)
  } else {
    b.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, element$1) {
      return (function(b$2$2) {
        var b$2 = $as_Lorg_yaml_builder_DocBuilder$Part(b$2$2);
        $this.emit$1__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfObject__V(b$2, element$1)
      })
    })(this, element)))
  }
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V = (function(b, content, dataType, inArray) {
  if (inArray) {
    this.emit$5__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__V(b, content, dataType)
  } else {
    b.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, content$1, dataType$1) {
      return (function(b$2$2) {
        var b$2 = $as_Lorg_yaml_builder_DocBuilder$Part(b$2$2);
        $this.emit$5__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__V(b$2, content$1, dataType$1)
      })
    })(this, content, dataType)))
  }
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.createIdNode__p1__Lorg_yaml_builder_DocBuilder$Entry__T__V = (function(b, id) {
  b.entry__T__F1__V("@id", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, id$1) {
    return (function(x$24$2) {
      var x$24 = $as_Lorg_yaml_builder_DocBuilder$Part(x$24$2);
      var content = $this.ctx$1.emitId__T__T(id$1);
      x$24.$$plus$eq__T__V(content)
    })
  })(this, id)))
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.value__p1__Lamf_core_metamodel_Type__Lamf_core_parser_Value__T__F1__Lorg_yaml_builder_DocBuilder$Part__V = (function(t, v, parent, sources, b) {
  matchEnd19: {
    if (($is_Lamf_core_metamodel_domain_ShapeModel(t) && this.ctx$1.canGenerateLink__Lamf_core_model_domain_AmfElement__Z(v.value$1))) {
      this.extractToLink__p1__Lamf_core_model_domain_Shape__Lorg_yaml_builder_DocBuilder$Part__Z__V($as_Lamf_core_model_domain_Shape(v.value$1), b, false);
      break matchEnd19
    };
    if (($is_Lamf_core_model_domain_DomainElement(t) && $is_Lamf_core_model_domain_Linkable(t))) {
      var this$1 = $as_Lamf_core_model_domain_Linkable(t);
      if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1).isDefined__Z()) {
        this.link__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_DomainElement__Z__V(b, $as_Lamf_core_model_domain_DomainElement(t), false);
        $asUnit(sources.apply__O__O(v));
        break matchEnd19
      }
    };
    if ($is_Lamf_core_metamodel_Obj(t)) {
      this.obj__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfObject__Z__V(b, $as_Lamf_core_model_domain_AmfObject(v.value$1), false);
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    var x = $m_Lamf_core_metamodel_Type$Iri$();
    if (x.equals__O__Z(t)) {
      this.iri__p1__Lorg_yaml_builder_DocBuilder$Part__T__Z__V(b, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T(), false);
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    var x$3 = $m_Lamf_core_metamodel_Type$EncodedIri$();
    if (x$3.equals__O__Z(t)) {
      this.safeIri__p1__Lorg_yaml_builder_DocBuilder$Part__T__Z__V(b, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T(), false);
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    var x$5 = $m_Lamf_core_metamodel_Type$LiteralUri$();
    if (x$5.equals__O__Z(t)) {
      this.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T(), $m_Lamf_core_model_DataType$().AnyUri$1, false);
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    var x$7 = $m_Lamf_core_metamodel_Type$Str$();
    if (x$7.equals__O__Z(t)) {
      var content = v.value$1;
      this.listWithScalar__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(b, content, $m_Lorg_yaml_builder_DocBuilder$SType$Str$());
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    var x$9 = $m_Lamf_core_metamodel_Type$Bool$();
    if (x$9.equals__O__Z(t)) {
      this.listWithScalar__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(b, v.value$1, $m_Lorg_yaml_builder_DocBuilder$SType$Bool$());
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    var x$11 = $m_Lamf_core_metamodel_Type$Int$();
    if (x$11.equals__O__Z(t)) {
      this.listWithScalar__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(b, v.value$1, $m_Lorg_yaml_builder_DocBuilder$SType$Int$());
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    var x$13 = $m_Lamf_core_metamodel_Type$Double$();
    if (x$13.equals__O__Z(t)) {
      this.listWithScalar__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(b, v.value$1, $m_Lorg_yaml_builder_DocBuilder$SType$Float$());
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    var x$15 = $m_Lamf_core_metamodel_Type$Float$();
    if (x$15.equals__O__Z(t)) {
      this.listWithScalar__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(b, v.value$1, $m_Lorg_yaml_builder_DocBuilder$SType$Float$());
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    var x$17 = $m_Lamf_core_metamodel_Type$DateTime$();
    if (x$17.equals__O__Z(t)) {
      var dateTime = $as_Lorg_mulesoft_common_time_SimpleDateTime($as_Lamf_core_model_domain_AmfScalar(v.value$1).value$1);
      this.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, dateTime.toString__T(), $m_Lamf_core_model_DataType$().DateTime$1, false);
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    var x$19 = $m_Lamf_core_metamodel_Type$Date$();
    if (x$19.equals__O__Z(t)) {
      var x1$2 = $as_Lamf_core_model_domain_AmfScalar(v.value$1).value$1;
      if ((x1$2 instanceof $c_Lorg_mulesoft_common_time_SimpleDateTime)) {
        var x2 = $as_Lorg_mulesoft_common_time_SimpleDateTime(x1$2);
        var maybeDateTime = new $c_s_Some().init___O(x2)
      } else {
        var maybeDateTime = $m_Lorg_mulesoft_common_time_SimpleDateTime$().parse__T__s_util_Either($objectToString(x1$2)).toOption__s_Option()
      };
      if ((maybeDateTime instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(maybeDateTime);
        var dateTime$2 = $as_Lorg_mulesoft_common_time_SimpleDateTime(x2$2.value$2);
        this.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, dateTime$2.toString__T(), ((dateTime$2.timeOfDay$1.isDefined__Z() || dateTime$2.zoneOffset$1.isDefined__Z()) ? $m_Lamf_core_model_DataType$().DateTime$1 : $m_Lamf_core_model_DataType$().Date$1), false)
      } else {
        var content$1 = v.value$1;
        this.listWithScalar__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(b, content$1, $m_Lorg_yaml_builder_DocBuilder$SType$Str$())
      };
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    if ((t instanceof $c_Lamf_core_metamodel_Type$SortedArray)) {
      var x15 = $as_Lamf_core_metamodel_Type$SortedArray(t);
      this.createSortedArray__Lorg_yaml_builder_DocBuilder$Part__sc_Seq__T__Lamf_core_metamodel_Type__V(b, $as_Lamf_core_model_domain_AmfArray(v.value$1).values$1, parent, x15.element$1);
      $asUnit(sources.apply__O__O(v));
      break matchEnd19
    };
    if ((t instanceof $c_Lamf_core_metamodel_Type$Array)) {
      var x16 = $as_Lamf_core_metamodel_Type$Array(t);
      b.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, v$1, sources$1, x16$1) {
        return (function(b$2$2) {
          var b$2 = $as_Lorg_yaml_builder_DocBuilder$Part(b$2$2);
          var seq = $as_Lamf_core_model_domain_AmfArray(v$1.value$1);
          sources$1.apply__O__O(v$1);
          var x1 = x16$1.element$1;
          if ($is_Lamf_core_metamodel_Obj(x1)) {
            seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, b$1) {
              return (function(x0$1$2) {
                var x0$1 = $as_Lamf_core_model_domain_AmfObject(x0$1$2);
                matchEnd5: {
                  if ((x0$1 instanceof $c_Lamf_core_model_domain_Shape)) {
                    var x2$1 = $as_Lamf_core_model_domain_Shape(x0$1);
                    if ($this$1.ctx$1.canGenerateLink__Lamf_core_model_domain_AmfElement__Z(x2$1)) {
                      $this$1.extractToLink__p1__Lamf_core_model_domain_Shape__Lorg_yaml_builder_DocBuilder$Part__Z__V(x2$1, b$1, true);
                      break matchEnd5
                    }
                  };
                  if (($is_Lamf_core_model_domain_DomainElement(x0$1) && $is_Lamf_core_model_domain_Linkable(x0$1))) {
                    var x3 = $as_Lamf_core_model_domain_DomainElement(x0$1);
                    var this$2 = $as_Lamf_core_model_domain_Linkable(x3);
                    if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2).isDefined__Z()) {
                      $this$1.link__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_DomainElement__Z__V(b$1, x3, true);
                      break matchEnd5
                    }
                  };
                  $this$1.obj__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfObject__Z__V(b$1, x0$1, true)
                }
              })
            })($this, b$2)))
          } else {
            var x$1 = $m_Lamf_core_metamodel_Type$Str$();
            if (x$1.equals__O__Z(x1)) {
              seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, b$3) {
                return (function(e$2) {
                  var e = $as_Lamf_core_model_domain_AmfScalar(e$2);
                  var content$2 = e.toString__T();
                  this$2$1.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(b$3, content$2, $m_Lorg_yaml_builder_DocBuilder$SType$Str$())
                })
              })($this, b$2)))
            } else {
              var x$3$1 = $m_Lamf_core_metamodel_Type$EncodedIri$();
              if (x$3$1.equals__O__Z(x1)) {
                seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3, b$4) {
                  return (function(e$3$2) {
                    var e$3 = $as_Lamf_core_model_domain_AmfScalar(e$3$2);
                    this$3.safeIri__p1__Lorg_yaml_builder_DocBuilder$Part__T__Z__V(b$4, e$3.toString__T(), true)
                  })
                })($this, b$2)))
              } else {
                var x$5$1 = $m_Lamf_core_metamodel_Type$Iri$();
                if (x$5$1.equals__O__Z(x1)) {
                  seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4, b$5) {
                    return (function(e$4$2) {
                      var e$4 = $as_Lamf_core_model_domain_AmfScalar(e$4$2);
                      this$4.iri__p1__Lorg_yaml_builder_DocBuilder$Part__T__Z__V(b$5, e$4.toString__T(), true)
                    })
                  })($this, b$2)))
                } else {
                  var x$7$1 = $m_Lamf_core_metamodel_Type$LiteralUri$();
                  if (x$7$1.equals__O__Z(x1)) {
                    $this.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b$2, $as_Lamf_core_model_domain_AmfScalar(v$1.value$1).toString__T(), $m_Lamf_core_model_DataType$().AnyUri$1, true)
                  } else {
                    var x$9$1 = $m_Lamf_core_metamodel_Type$Int$();
                    if (x$9$1.equals__O__Z(x1)) {
                      seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5, b$6) {
                        return (function(e$5$2) {
                          var e$5 = $as_Lamf_core_model_domain_AmfScalar(e$5$2);
                          this$5.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(b$6, $objectToString(e$5.value$1), $m_Lorg_yaml_builder_DocBuilder$SType$Int$())
                        })
                      })($this, b$2)))
                    } else {
                      var x$11$1 = $m_Lamf_core_metamodel_Type$Float$();
                      if (x$11$1.equals__O__Z(x1)) {
                        seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6, b$7) {
                          return (function(e$6$2) {
                            var e$6 = $as_Lamf_core_model_domain_AmfScalar(e$6$2);
                            this$6.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(b$7, $objectToString(e$6.value$1), $m_Lorg_yaml_builder_DocBuilder$SType$Float$())
                          })
                        })($this, b$2)))
                      } else {
                        var x$13$1 = $m_Lamf_core_metamodel_Type$Bool$();
                        if (x$13$1.equals__O__Z(x1)) {
                          seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$7, b$8) {
                            return (function(e$7$2) {
                              var e$7 = $as_Lamf_core_model_domain_AmfScalar(e$7$2);
                              this$7.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(b$8, $objectToString(e$7.value$1), $m_Lorg_yaml_builder_DocBuilder$SType$Bool$())
                            })
                          })($this, b$2)))
                        } else {
                          var x$15$1 = $m_Lamf_core_metamodel_Type$DateTime$();
                          if (x$15$1.equals__O__Z(x1)) {
                            seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$8, b$9) {
                              return (function(e$8$2) {
                                var e$8 = $as_Lamf_core_model_domain_AmfScalar(e$8$2);
                                var dateTime$1 = $as_Lorg_mulesoft_common_time_SimpleDateTime(e$8.value$1);
                                this$8.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b$9, dateTime$1.toString__T(), $m_Lamf_core_model_DataType$().DateTime$1, false)
                              })
                            })($this, b$2)))
                          } else {
                            var x$17$1 = $m_Lamf_core_metamodel_Type$Date$();
                            if (x$17$1.equals__O__Z(x1)) {
                              seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$9, b$10) {
                                return (function(e$9$2) {
                                  var e$9 = $as_Lamf_core_model_domain_AmfScalar(e$9$2);
                                  var dateTime$3 = $as_Lorg_mulesoft_common_time_SimpleDateTime(e$9.value$1);
                                  this$9.emitSimpleDateTime__p1__Lorg_yaml_builder_DocBuilder$Part__Lorg_mulesoft_common_time_SimpleDateTime__Z__V(b$10, dateTime$3, false)
                                })
                              })($this, b$2)))
                            } else {
                              var x$19$1 = $m_Lamf_core_metamodel_Type$Any$();
                              if ((x$19$1 === x1)) {
                                seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$10, b$11) {
                                  return (function(scalarElement$2) {
                                    var scalarElement = $as_Lamf_core_model_domain_AmfScalar(scalarElement$2);
                                    var x1$1 = scalarElement.value$1;
                                    if (((typeof x1$1) === "boolean")) {
                                      var x2$3 = $uZ(x1$1);
                                      this$10.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b$11, ("" + x2$3), $m_Lamf_core_model_DataType$().Boolean$1, true)
                                    } else if ($isInt(x1$1)) {
                                      var x3$1 = $uI(x1$1);
                                      this$10.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b$11, ("" + x3$1), $m_Lamf_core_model_DataType$().Integer$1, true)
                                    } else if ($isFloat(x1$1)) {
                                      var x4 = $uF(x1$1);
                                      this$10.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b$11, ("" + x4), $m_Lamf_core_model_DataType$().Float$1, true)
                                    } else if (((typeof x1$1) === "number")) {
                                      var x5 = $uD(x1$1);
                                      this$10.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b$11, ("" + x5), $m_Lamf_core_model_DataType$().Double$1, true)
                                    } else if ((x1$1 instanceof $c_Lorg_mulesoft_common_time_SimpleDateTime)) {
                                      var x6 = $as_Lorg_mulesoft_common_time_SimpleDateTime(x1$1);
                                      this$10.emitSimpleDateTime__p1__Lorg_yaml_builder_DocBuilder$Part__Lorg_mulesoft_common_time_SimpleDateTime__Z__V(b$11, x6, true)
                                    } else {
                                      var content$3 = $objectToString(x1$1);
                                      this$10.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(b$11, content$3, $m_Lorg_yaml_builder_DocBuilder$SType$Str$())
                                    }
                                  })
                                })($this, b$2)))
                              } else {
                                seq.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$11$1, b$12) {
                                  return (function(e$10$2) {
                                    var e$10 = $as_Lamf_core_model_domain_AmfScalar(e$10$2);
                                    this$11$1.iri__p1__Lorg_yaml_builder_DocBuilder$Part__T__Z__V(b$12, e$10.toString__T(), true)
                                  })
                                })($this, b$2)))
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        })
      })(this, v, sources, x16)));
      break matchEnd19
    };
    var x$21 = $m_Lamf_core_metamodel_Type$Any$();
    if (((x$21 === t) && (v.value$1 instanceof $c_Lamf_core_model_domain_AmfScalar))) {
      var x1$4 = $as_Lamf_core_model_domain_AmfScalar(v.value$1).value$1;
      if (((typeof x1$4) === "boolean")) {
        var x2$3$1 = $uZ(x1$4);
        this.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, ("" + x2$3$1), $m_Lamf_core_model_DataType$().Boolean$1, true)
      } else if ($isInt(x1$4)) {
        var x3$2 = $uI(x1$4);
        this.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, ("" + x3$2), $m_Lamf_core_model_DataType$().Integer$1, true)
      } else if ($isFloat(x1$4)) {
        var x4$1 = $uF(x1$4);
        this.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, ("" + x4$1), $m_Lamf_core_model_DataType$().Float$1, true)
      } else if (((typeof x1$4) === "number")) {
        var x5$1 = $uD(x1$4);
        this.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, ("" + x5$1), $m_Lamf_core_model_DataType$().Double$1, true)
      } else if ((x1$4 instanceof $c_Lorg_mulesoft_common_time_SimpleDateTime)) {
        var x6$1 = $as_Lorg_mulesoft_common_time_SimpleDateTime(x1$4);
        this.emitSimpleDateTime__p1__Lorg_yaml_builder_DocBuilder$Part__Lorg_mulesoft_common_time_SimpleDateTime__Z__V(b, x6$1, true)
      } else {
        var content$4 = $objectToString(x1$4);
        this.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(b, content$4, $m_Lorg_yaml_builder_DocBuilder$SType$Str$())
      };
      break matchEnd19
    };
    throw new $c_s_MatchError().init___O(t)
  }
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.init___Lorg_yaml_builder_DocBuilder__Lamf_core_emitter_RenderOptions__Lamf_plugins_document_graph_emitter_EmissionContext = (function(builder, options, ctx) {
  this.builder$1 = builder;
  this.options$1 = options;
  this.ctx$1 = ctx;
  this.cache$1 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  return this
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.emit$4__p1__Lorg_yaml_builder_DocBuilder$Part__T__V = (function(b, content$2) {
  b.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, content$2$1) {
    return (function(x$20$2) {
      var x$20 = $as_Lorg_yaml_builder_DocBuilder$Entry(x$20$2);
      x$20.entry__T__F1__V("@id", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, content$2$2) {
        return (function(x$21$2) {
          var x$21 = $as_Lorg_yaml_builder_DocBuilder$Part(x$21$2);
          var content = $this$1.ctx$1.emitId__T__T(content$2$2);
          x$21.$$plus$eq__T__V(content)
        })
      })($this, content$2$1)))
    })
  })(this, content$2)))
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.isExternalLink__p1__Lamf_core_model_domain_AmfObject__Z = (function(element) {
  if ($is_Lamf_core_model_domain_DomainElement(element)) {
    var this$1 = $as_Lamf_core_model_domain_DomainElement(element);
    var this$2 = $as_Lamf_core_model_BoolField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().IsExternalLink$1)).option$1;
    return $uZ((this$2.isEmpty__Z() ? false : this$2.get__O()))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.emit$5__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__V = (function(b, content$3, dataType$1) {
  b.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, content$3$1, dataType$1$1) {
    return (function(m$2) {
      var m = $as_Lorg_yaml_builder_DocBuilder$Entry(m$2);
      m.entry__T__F1__V("@value", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, content$3$2) {
        return (function(x$22$2) {
          var x$22 = $as_Lorg_yaml_builder_DocBuilder$Part(x$22$2);
          x$22.$$plus$eq__T__V(content$3$2)
        })
      })($this, content$3$1)));
      m.entry__T__F1__V("@type", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, dataType$1$2) {
        return (function(x$23$2) {
          var x$23 = $as_Lorg_yaml_builder_DocBuilder$Part(x$23$2);
          var content = this$2.ctx$1.emitIri__T__T(dataType$1$2);
          x$23.$$plus$eq__T__V(content)
        })
      })($this, dataType$1$1)))
    })
  })(this, content$3, dataType$1)))
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.listWithScalar__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V = (function(b, content, t) {
  b.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, content$1, t$1) {
    return (function(x$38$2) {
      var x$38 = $as_Lorg_yaml_builder_DocBuilder$Part(x$38$2);
      $this.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(x$38, content$1, t$1)
    })
  })(this, content, t)))
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.emitStaticField__p1__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfObject__T__Lamf_core_model_document_SourceMap__Lorg_yaml_builder_DocBuilder$Entry__V = (function(field, element, id, sources, b) {
  var x1 = element.fields__Lamf_core_parser_Fields().entryJsonld__Lamf_core_metamodel_Field__s_Option(field);
  matchEnd6: {
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var p3 = $as_Lamf_core_parser_FieldEntry(x2.value$2);
      if ((p3 !== null)) {
        var f = p3.field$1;
        var v = p3.value$1;
        var url = this.ctx$1.emitIri__T__T(f.value$1.iri__T());
        b.entry__T__F1__V(url, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, f$1, v$1, id$1, sources$1, url$1) {
          return (function(x$6$2) {
            var x$6 = $as_Lorg_yaml_builder_DocBuilder$Part(x$6$2);
            $this.value__p1__Lamf_core_metamodel_Type__Lamf_core_parser_Value__T__F1__Lorg_yaml_builder_DocBuilder$Part__V(f$1.type$1, v$1, id$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, sources$4, url$3) {
              return (function(value$2) {
                var value = $as_Lamf_core_parser_Value(value$2);
                sources$4.property__T__Lamf_core_parser_Value__V(url$3, value)
              })
            })($this, sources$1, url$1)), x$6)
          })
        })(this, f, v, id, sources, url)));
        break matchEnd6
      }
    };
    var x = $m_s_None$();
    if ((x === x1)) {
      break matchEnd6
    };
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.emitSimpleDateTime__p1__Lorg_yaml_builder_DocBuilder$Part__Lorg_mulesoft_common_time_SimpleDateTime__Z__V = (function(b, dateTime, inArray) {
  if ((dateTime.timeOfDay$1.isDefined__Z() || dateTime.zoneOffset$1.isDefined__Z())) {
    this.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, dateTime.toString__T(), $m_Lamf_core_model_DataType$().DateTime$1, inArray)
  } else {
    this.typedScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, dateTime.toString__T(), $m_Lamf_core_model_DataType$().Date$1, false)
  }
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V = (function(b, content, t) {
  this.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(b, $objectToString($as_Lamf_core_model_domain_AmfScalar(content).value$1), t)
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.link__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_DomainElement__Z__V = (function(b, elementWithLink, inArray) {
  if (inArray) {
    this.emit$2__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_DomainElement__V(b, elementWithLink)
  } else {
    b.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, elementWithLink$1) {
      return (function(b$2$2) {
        var b$2 = $as_Lorg_yaml_builder_DocBuilder$Part(b$2$2);
        $this.emit$2__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_DomainElement__V(b$2, elementWithLink$1)
      })
    })(this, elementWithLink)))
  }
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.traverse__Lamf_core_model_domain_AmfObject__Lorg_yaml_builder_DocBuilder$Entry__V = (function(element, b) {
  var id = element.id__T();
  this.createIdNode__p1__Lorg_yaml_builder_DocBuilder$Entry__T__V(b, id);
  var sources = $m_Lamf_core_model_document_SourceMap$().apply__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_document_SourceMap(id, element);
  var obj = $f_Lamf_core_metamodel_MetaModelTypeMapping__metaModel__O__Lamf_core_metamodel_Obj(this, element);
  this.traverseMetaModel__T__Lamf_core_model_domain_AmfObject__Lamf_core_model_document_SourceMap__Lamf_core_metamodel_Obj__Lorg_yaml_builder_DocBuilder$Entry__V(id, element, sources, obj, b);
  this.createCustomExtensions__p1__Lamf_core_model_domain_AmfObject__Lorg_yaml_builder_DocBuilder$Entry__V(element, b);
  var sourceMapId = $f_Lamf_plugins_document_graph_emitter_CommonEmitter__sourceMapIdFor__T__T(this, id);
  this.createSourcesNode__p1__T__Lamf_core_model_document_SourceMap__Lorg_yaml_builder_DocBuilder$Entry__V(sourceMapId, sources, b)
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.createAnnotationNodes__p1__T__Lorg_yaml_builder_DocBuilder$Entry__scm_ListMap__V = (function(id, b, annotations) {
  var this$1 = annotations.elems$5;
  var this$2 = new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$1);
  while (this$2.hasNext__Z()) {
    var arg1 = this$2.next__O();
    var x0$1 = $as_T2(arg1);
    if ((x0$1 !== null)) {
      var a = $as_T(x0$1.$$und1__O());
      var values = $as_scm_ListMap(x0$1.$$und2__O());
      var this$3 = this.ctx$1.options$1;
      if (this$3.rawSourceMaps$1) {
        b.entry__T__F1__V(a, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, values$1) {
          return (function(x$31$2) {
            var x$31 = $as_Lorg_yaml_builder_DocBuilder$Part(x$31$2);
            x$31.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, values$1$1) {
              return (function(o$2) {
                var o = $as_Lorg_yaml_builder_DocBuilder$Entry(o$2);
                var this$4 = values$1$1.elems$5;
                var this$5 = new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$4);
                while (this$5.hasNext__Z()) {
                  var arg1$1 = this$5.next__O();
                  var x0$2 = $as_T2(arg1$1);
                  if ((x0$2 !== null)) {
                    var iri = $as_T(x0$2.$$und1__O());
                    var v = $as_T(x0$2.$$und2__O());
                    o.entry__T__F1__V($this$1.ctx$1.emitId__T__T($this$1.ctx$1.emitIri__T__T(iri)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, v$1) {
                      return (function(x$32$2) {
                        var x$32 = $as_Lorg_yaml_builder_DocBuilder$Part(x$32$2);
                        x$32.$$plus$eq__T__V(v$1)
                      })
                    })($this$1, v)))
                  } else {
                    throw new $c_s_MatchError().init___O(x0$2)
                  }
                }
              })
            })($this, values$1)))
          })
        })(this, values)))
      } else {
        var jsx$1 = this.ctx$1;
        var ns = $m_Lamf_core_vocabulary_Namespace$().SourceMaps$1;
        b.entry__T__F1__V(jsx$1.emitIri__T__T(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns, a).iri__T()), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, values$2, id$8, a$1) {
          return (function(x$33$2) {
            var x$33 = $as_Lorg_yaml_builder_DocBuilder$Part(x$33$2);
            x$33.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, values$1$2, id$8$1, a$1$1) {
              return (function(b$2) {
                var b$1 = $as_Lorg_yaml_builder_DocBuilder$Part(b$2);
                var this$7 = $m_scm_ListMap$();
                var bf = new $c_scg_GenMapFactory$MapCanBuildFrom().init___scg_GenMapFactory(this$7);
                $as_sc_IterableLike($f_sc_IterableLike__zipWithIndex__scg_CanBuildFrom__O(values$1$2, bf)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$4, id$8$2, a$1$2, b$3) {
                  return (function(x0$3$2) {
                    var x0$3 = $as_T2(x0$3$2);
                    if ((x0$3 !== null)) {
                      var tuple = $as_T2(x0$3.$$und1__O());
                      var index = x0$3.$$und2$mcI$sp__I();
                      $this$4.createAnnotationValueNode__p1__T__Lorg_yaml_builder_DocBuilder$Part__T2__V(((((id$8$2 + "/") + a$1$2) + "/element_") + index), b$3, tuple)
                    } else {
                      throw new $c_s_MatchError().init___O(x0$3)
                    }
                  })
                })($this$3, id$8$1, a$1$1, b$1)))
              })
            })(this$2$1, values$2, id$8, a$1)))
          })
        })(this, values, id, a)))
      }
    } else {
      throw new $c_s_MatchError().init___O(x0$1)
    }
  }
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.createCustomExtensions__p1__Lamf_core_model_domain_AmfObject__Lorg_yaml_builder_DocBuilder$Entry__V = (function(element, b) {
  var customProperties = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = element.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field());
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var x0$1 = $as_Lamf_core_parser_FieldEntry(arg1);
    if ((x0$1 !== null)) {
      var v = x0$1.value$1;
      var x1$2 = v.value$1;
      if ((x1$2 instanceof $c_Lamf_core_model_domain_AmfArray)) {
        var x2 = $as_Lamf_core_model_domain_AmfArray(x1$2);
        var values = x2.values$1;
        $as_sc_IterableLike(values.sortBy__F1__s_math_Ordering__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(x$7$2) {
            var x$7 = $as_Lamf_core_model_domain_AmfElement(x$7$2);
            return $as_Lamf_core_model_domain_extensions_DomainExtension(x$7).id$1
          })
        })(this)), $m_s_math_Ordering$String$())).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, customProperties$1, b$2) {
          return (function(x0$2$2) {
            var x0$2 = $as_Lamf_core_model_domain_AmfElement(x0$2$2);
            if ((x0$2 instanceof $c_Lamf_core_model_domain_extensions_DomainExtension)) {
              var x2$1 = $as_Lamf_core_model_domain_extensions_DomainExtension(x0$2);
              var uri = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(x2$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().DefinedBy$1)).id$1;
              customProperties$1.$$plus$eq__O__scm_ListBuffer(uri);
              this$2.createCustomExtension__p1__Lorg_yaml_builder_DocBuilder$Entry__T__Lamf_core_model_domain_extensions_DomainExtension__s_Option__V(b$2, uri, x2$1, $m_s_None$())
            } else {
              throw new $c_s_MatchError().init___O(x0$2)
            }
          })
        })(this, customProperties, b)))
      }
    } else {
      throw new $c_s_MatchError().init___O(x0$1)
    }
  };
  var count = new $c_sr_IntRef().init___I(1);
  var this$9 = element.fields__Lamf_core_parser_Fields();
  var fn = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, element$1, count$1, customProperties$2, b$1) {
    return (function(x0$3$2) {
      var x0$3 = $as_T2(x0$3$2);
      if ((x0$3 !== null)) {
        var f = $as_Lamf_core_metamodel_Field(x0$3.$$und1__O());
        var v$1 = $as_Lamf_core_parser_Value(x0$3.$$und2__O());
        var this$4 = v$1.value$1.annotations__Lamf_core_parser_Annotations();
        var pf = new $c_Lamf_plugins_document_graph_emitter_JsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1().init___Lamf_plugins_document_graph_emitter_JsonLdEmitter(this$2$1);
        var this$6 = this$4.amf$core$parser$Annotations$$annotations$1;
        var this$5 = $m_scm_ListBuffer$();
        var bf = this$5.ReusableCBFInstance$2;
        $as_sc_IterableLike($as_sc_Seq($f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this$6, pf, bf)).sortBy__F1__s_math_Ordering__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
          return (function(x$8$2) {
            var x$8 = $as_Lamf_core_annotations_DomainExtensionAnnotation(x$8$2);
            return x$8.extension$1.id$1
          })
        })(this$2$1)), $m_s_math_Ordering$String$())).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$2, element$2, count$1$1, customProperties$1$1, b$2$1, f$1) {
          return (function(e$2) {
            var e = $as_Lamf_core_annotations_DomainExtensionAnnotation(e$2);
            var extension = e.extension$1;
            var jsx$2 = element$2.id__T();
            var jsx$1 = count$1$1.elem$1;
            var this$7 = $as_Lamf_core_model_StrField(extension.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1));
            var this$8 = this$7.option$1;
            var uri$1 = ((((jsx$2 + "/scalar-valued/") + jsx$1) + "/") + $as_T((this$8.isEmpty__Z() ? null : this$8.get__O())));
            customProperties$1$1.$$plus$eq__O__scm_ListBuffer(uri$1);
            $m_Lamf_core_model_domain_DataNodeOps$().adoptTree__T__Lamf_core_model_domain_DataNode__Lamf_core_model_domain_DataNode(uri$1, $as_Lamf_core_model_domain_DataNode(extension.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)));
            this$2$2.createCustomExtension__p1__Lorg_yaml_builder_DocBuilder$Entry__T__Lamf_core_model_domain_extensions_DomainExtension__s_Option__V(b$2$1, uri$1, extension, new $c_s_Some().init___O(f$1));
            count$1$1.elem$1 = ((1 + count$1$1.elem$1) | 0)
          })
        })(this$2$1, element$1, count$1, customProperties$2, b$1, f)))
      } else {
        throw new $c_s_MatchError().init___O(x0$3)
      }
    })
  })(this, element, count, customProperties, b));
  this$9.fs$1.foreach__F1__V(fn);
  if (customProperties.nonEmpty__Z()) {
    b.entry__T__F1__V(this.ctx$1.emitIri__T__T($m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field().value$1.iri__T()), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, customProperties$3) {
      return (function(x$9$2) {
        var x$9 = $as_Lorg_yaml_builder_DocBuilder$Part(x$9$2);
        x$9.list__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, customProperties$1$2) {
          return (function(b$2$2) {
            var b$3 = $as_Lorg_yaml_builder_DocBuilder$Part(b$2$2);
            var this$10 = customProperties$1$2.scala$collection$mutable$ListBuffer$$start$6;
            var these = this$10;
            while ((!these.isEmpty__Z())) {
              var arg1$1 = these.head__O();
              var x$10 = $as_T(arg1$1);
              $this$2.iri__p1__Lorg_yaml_builder_DocBuilder$Part__T__Z__V(b$3, x$10, true);
              these = $as_sci_List(these.tail__O())
            }
          })
        })(this$3$1, customProperties$3)))
      })
    })(this, customProperties)))
  }
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.createAnnotationValueNode__p1__T__Lorg_yaml_builder_DocBuilder$Part__T2__V = (function(id, b, tuple) {
  if ((tuple !== null)) {
    var iri = $as_T(tuple.$$und1__O());
    var v = $as_T(tuple.$$und2__O());
    b.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, id$1, iri$1, v$1) {
      return (function(b$2$2) {
        var b$2 = $as_Lorg_yaml_builder_DocBuilder$Entry(b$2$2);
        $this.createIdNode__p1__Lorg_yaml_builder_DocBuilder$Entry__T__V(b$2, id$1);
        b$2.entry__T__F1__V($this.ctx$1.emitIri__T__T($m_Lamf_core_metamodel_document_SourceMapModel$().Element$1.value$1.iri__T()), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, iri$1$1) {
          return (function(x$34$2) {
            var x$34 = $as_Lorg_yaml_builder_DocBuilder$Part(x$34$2);
            $this$1.listWithScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(x$34, iri$1$1, $m_Lorg_yaml_builder_DocBuilder$SType$Str$())
          })
        })($this, iri$1)));
        b$2.entry__T__F1__V($this.ctx$1.emitIri__T__T($m_Lamf_core_metamodel_document_SourceMapModel$().Value$1.value$1.iri__T()), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, v$6) {
          return (function(x$35$2) {
            var x$35 = $as_Lorg_yaml_builder_DocBuilder$Part(x$35$2);
            this$2.listWithScalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(x$35, v$6, $m_Lorg_yaml_builder_DocBuilder$SType$Str$())
          })
        })($this, v$1)))
      })
    })(this, id, iri, v)))
  } else {
    throw new $c_s_MatchError().init___O(tuple)
  }
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.emit$3__p1__Lorg_yaml_builder_DocBuilder$Part__T__V = (function(b, content$1) {
  b.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, content$1$1) {
    return (function(x$18$2) {
      var x$18 = $as_Lorg_yaml_builder_DocBuilder$Entry(x$18$2);
      x$18.entry__T__F1__V("@id", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, content$1$2) {
        return (function(x$19$2) {
          var x$19 = $as_Lorg_yaml_builder_DocBuilder$Part(x$19$2);
          var content = $this$1.ctx$1.emitId__T__T(content$1$2);
          x$19.$$plus$eq__T__V(content)
        })
      })($this, content$1$1)))
    })
  })(this, content$1)))
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.emitReferences__p1__Lorg_yaml_builder_DocBuilder$Entry__T__Lamf_core_model_document_SourceMap__V = (function(b, id, sources) {
  var this$1 = this.ctx$1;
  var this$2 = this$1.references$1;
  if ($f_scm_SetLike__toSeq__sc_Seq(this$2).nonEmpty__Z()) {
    var this$3 = this.ctx$1;
    var this$4 = this$3.references$1;
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($f_scm_SetLike__toSeq__sc_Seq(this$4), new $c_Lamf_core_parser_Annotations().init___());
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var v = new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value, annotations);
    var f = $m_Lamf_core_metamodel_document_ModuleModel$().References$1;
    var url = this.ctx$1.emitIri__T__T(f.value$1.iri__T());
    this.ctx$1.emittingReferences__Z__Lamf_plugins_document_graph_emitter_EmissionContext(true);
    b.entry__T__F1__V(url, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, f$1, v$1, id$1, sources$1, url$1) {
      return (function(x$2$2) {
        var x$2 = $as_Lorg_yaml_builder_DocBuilder$Part(x$2$2);
        $this.value__p1__Lamf_core_metamodel_Type__Lamf_core_parser_Value__T__F1__Lorg_yaml_builder_DocBuilder$Part__V(f$1.type$1, v$1, id$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, sources$1$1, url$1$1) {
          return (function(value$2) {
            var value$1 = $as_Lamf_core_parser_Value(value$2);
            sources$1$1.property__T__Lamf_core_parser_Value__V(url$1$1, value$1)
          })
        })($this, sources$1, url$1)), x$2)
      })
    })(this, f, v, id, sources, url)))
  };
  this.ctx$1.emittingReferences__Z__Lamf_plugins_document_graph_emitter_EmissionContext(false)
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V = (function(b, content, t) {
  b.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, t$1, content$1) {
    return (function(x$36$2) {
      var x$36 = $as_Lorg_yaml_builder_DocBuilder$Entry(x$36$2);
      x$36.entry__T__Lorg_yaml_builder_DocBuilder$Scalar__V("@value", $m_Lorg_yaml_builder_DocBuilder$Scalar$().apply__Lorg_yaml_builder_DocBuilder$SType__T__Lorg_yaml_builder_DocBuilder$Scalar(t$1, content$1))
    })
  })(this, t, content)))
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.emitDeclarations__p1__Lorg_yaml_builder_DocBuilder$Entry__T__Lamf_core_model_document_SourceMap__V = (function(b, id, sources) {
  var this$1 = this.ctx$1;
  var this$2 = this$1.declarations$1;
  if ($f_scm_SetLike__toSeq__sc_Seq(this$2).nonEmpty__Z()) {
    var this$3 = this.ctx$1;
    var this$4 = this$3.declarations$1;
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($f_scm_SetLike__toSeq__sc_Seq(this$4), new $c_Lamf_core_parser_Annotations().init___());
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var v = new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value, annotations);
    var f = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
    var url = this.ctx$1.emitIri__T__T(f.value$1.iri__T());
    this.ctx$1.emittingDeclarations__Z__Lamf_plugins_document_graph_emitter_EmissionContext(true);
    b.entry__T__F1__V(url, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, f$1, v$1, id$1, sources$1, url$1) {
      return (function(x$3$2) {
        var x$3 = $as_Lorg_yaml_builder_DocBuilder$Part(x$3$2);
        $this.value__p1__Lamf_core_metamodel_Type__Lamf_core_parser_Value__T__F1__Lorg_yaml_builder_DocBuilder$Part__V(f$1.type$1, v$1, id$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, sources$2, url$2) {
          return (function(value$2) {
            var value$1 = $as_Lamf_core_parser_Value(value$2);
            sources$2.property__T__Lamf_core_parser_Value__V(url$2, value$1)
          })
        })($this, sources$1, url$1)), x$3)
      })
    })(this, f, v, id, sources, url)))
  };
  this.ctx$1.emittingDeclarations__Z__Lamf_plugins_document_graph_emitter_EmissionContext(false)
});
var $d_Lamf_plugins_document_graph_emitter_JsonLdEmitter = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_JsonLdEmitter: 0
}, false, "amf.plugins.document.graph.emitter.JsonLdEmitter", {
  Lamf_plugins_document_graph_emitter_JsonLdEmitter: 1,
  O: 1,
  Lamf_plugins_document_graph_emitter_CommonEmitter: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_JsonLdEmitter;
/** @constructor */
function $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$() {
  $c_Lamf_plugins_document_graph_parser_GraphContextHelper.call(this);
  this.AnnotationName$module$2 = null
}
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$.prototype = new $h_Lamf_plugins_document_graph_parser_GraphContextHelper();
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$.prototype.constructor = $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$;
/** @constructor */
function $h_Lamf_plugins_document_graph_parser_FlattenedGraphParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_parser_FlattenedGraphParser$.prototype = $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$.prototype;
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$.prototype.contentOfNode__Lorg_yaml_model_YNode__s_Option = (function(n) {
  return $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__contentOfNode__Lorg_yaml_model_YNode__s_Option(this, n)
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$.prototype.apply__Lamf_plugins_document_graph_parser_FlattenedGraphParser = (function() {
  var x$1 = new $c_Lamf_client_parse_DefaultParserErrorHandler().init___I($m_Lamf_core_AMFCompilerRunCount$().nextRun__I());
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$5 = new $c_scm_ListBuffer().init___();
  var x$3 = this$5.toList__sci_List();
  var x$4 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
  var x$5 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$6 = $m_s_None$();
  return new $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser().init___Lamf_plugins_document_graph_parser_GraphParserContext(new $c_Lamf_plugins_document_graph_parser_GraphParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_AmfParserErrorHandler__scm_Map__s_Option("", x$3, x$4, x$1, x$5, x$6))
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$.prototype.AnnotationName$lzycompute$2__p2__V = (function() {
  if (($m_Lamf_plugins_document_graph_parser_FlattenedGraphParser$().AnnotationName$module$2 === null)) {
    $m_Lamf_plugins_document_graph_parser_FlattenedGraphParser$().AnnotationName$module$2 = new $c_Lamf_plugins_document_graph_parser_GraphParserHelpers$AnnotationName$().init___Lamf_plugins_document_graph_parser_GraphParserHelpers(this)
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$.prototype.isRootNode__p2__Lorg_yaml_model_YNode__Lamf_plugins_document_graph_parser_GraphParserContext__Z = (function(node, ctx) {
  var x1 = node.value__Lorg_yaml_model_YValue();
  if ((x1 instanceof $c_Lorg_yaml_model_YMap)) {
    var x2 = $as_Lorg_yaml_model_YMap(x1);
    var obj = $m_Lamf_core_metamodel_document_BaseUnitModel$();
    var isBaseUnit = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__nodeIsOfType__Lorg_yaml_model_YNode__Lamf_core_metamodel_Obj__Lamf_plugins_document_graph_parser_GraphParserContext__Z(this, node, obj, ctx);
    var isRoot = x2.entries$3.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ctx$1) {
      return (function(entry$2) {
        var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
        var jsx$1 = $m_Lamf_plugins_document_graph_parser_FlattenedGraphParser$();
        var this$1 = entry.key$2;
        var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var key = jsx$1.expandUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T($as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, ctx$1)), ctx$1);
        if (($m_Lamf_core_metamodel_document_BaseUnitModel$().Root$1.value$1.iri__T() === key)) {
          var this$2 = entry.value$2;
          var conversion$1 = $m_Lorg_yaml_convert_YRead$BooleanYRead$();
          return $uZ($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$1, ctx$1))
        } else {
          return false
        }
      })
    })(this, ctx)));
    return (isBaseUnit && isRoot)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$.prototype.AnnotationName__Lamf_plugins_document_graph_parser_GraphParserHelpers$AnnotationName$ = (function() {
  if (($m_Lamf_plugins_document_graph_parser_FlattenedGraphParser$().AnnotationName$module$2 === null)) {
    this.AnnotationName$lzycompute$2__p2__V()
  };
  return $m_Lamf_plugins_document_graph_parser_FlattenedGraphParser$().AnnotationName$module$2
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$.prototype.canParse__Lamf_core_parser_SyamlParsedDocument__Z = (function(document) {
  var x1 = document.document$2.node$2.value__Lorg_yaml_model_YValue();
  if ((x1 instanceof $c_Lorg_yaml_model_YMap)) {
    var x2 = $as_Lorg_yaml_model_YMap(x1);
    var x$1 = new $c_Lamf_client_parse_IgnoringErrorHandler().init___();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$4 = new $c_scm_ListBuffer().init___();
    var x$3 = this$4.toList__sci_List();
    var x$4 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
    var x$5 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$6 = $m_s_None$();
    var ctx = new $c_Lamf_plugins_document_graph_parser_GraphParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_AmfParserErrorHandler__scm_Map__s_Option("", x$3, x$4, x$1, x$5, x$6);
    var this$10 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(x2).key__T__s_Option("@context");
    if ((!this$10.isEmpty__Z())) {
      var arg1 = this$10.get__O();
      var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
      $m_Lamf_plugins_document_graph_parser_FlattenedGraphParser$().parseCompactUris__Lorg_yaml_model_YNode__Lamf_plugins_document_graph_parser_GraphParserContext__V(entry.value$2, ctx)
    };
    var x1$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(x2).key__T__s_Option("@graph");
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var graphEntry = $as_Lorg_yaml_model_YMapEntry(x2$2.value$2);
      var this$12 = graphEntry.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
      var graphYSeq = $as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$12, conversion, ctx));
      return graphYSeq.nodes$3.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, ctx$1) {
        return (function(node$2) {
          var node = $as_Lorg_yaml_model_YNode(node$2);
          return $m_Lamf_plugins_document_graph_parser_FlattenedGraphParser$().isRootNode__p2__Lorg_yaml_model_YNode__Lamf_plugins_document_graph_parser_GraphParserContext__Z(node, ctx$1)
        })
      })(this, ctx)))
    } else {
      var x = $m_s_None$();
      if ((x === x1$2)) {
        return false
      } else {
        throw new $c_s_MatchError().init___O(x1$2)
      }
    }
  } else {
    return false
  }
});
var $d_Lamf_plugins_document_graph_parser_FlattenedGraphParser$ = new $TypeData().initClass({
  Lamf_plugins_document_graph_parser_FlattenedGraphParser$: 0
}, false, "amf.plugins.document.graph.parser.FlattenedGraphParser$", {
  Lamf_plugins_document_graph_parser_FlattenedGraphParser$: 1,
  Lamf_plugins_document_graph_parser_GraphContextHelper: 1,
  O: 1,
  Lamf_plugins_document_graph_parser_GraphParserHelpers: 1
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$.prototype.$classData = $d_Lamf_plugins_document_graph_parser_FlattenedGraphParser$;
var $n_Lamf_plugins_document_graph_parser_FlattenedGraphParser$ = (void 0);
function $m_Lamf_plugins_document_graph_parser_FlattenedGraphParser$() {
  if ((!$n_Lamf_plugins_document_graph_parser_FlattenedGraphParser$)) {
    $n_Lamf_plugins_document_graph_parser_FlattenedGraphParser$ = new $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$().init___()
  };
  return $n_Lamf_plugins_document_graph_parser_FlattenedGraphParser$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_DialectsRegistry() {
  $c_O.call(this);
  this.map$1 = null;
  this.resolved$1 = null;
  this.validations$1 = null;
  this.platform$1 = null
}
$c_Lamf_plugins_document_vocabularies_DialectsRegistry.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_DialectsRegistry.prototype.constructor = $c_Lamf_plugins_document_vocabularies_DialectsRegistry;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_DialectsRegistry() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_DialectsRegistry.prototype = $c_Lamf_plugins_document_vocabularies_DialectsRegistry.prototype;
$c_Lamf_plugins_document_vocabularies_DialectsRegistry.prototype.registerDialect__T__T__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future = (function(url, code, env, exec) {
  return this.registerDialect__T__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future(url, env.add__Lamf_internal_resource_ResourceLoader__Lamf_internal_environment_Environment(new $c_Lamf_internal_resource_StringResourceLoader().init___T__T(url, code)), exec)
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry.prototype.findNode__T__s_Option = (function(dialectNode) {
  var this$1 = this.map$1;
  var this$2 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$1);
  var this$3 = this$2.$$outer$3.valuesIterator__sc_Iterator();
  inlinereturn$6: {
    while (this$3.hasNext__Z()) {
      var a = this$3.next__O();
      var dialect = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(a);
      var s = dialect.id$1;
      if (($uI(dialectNode.indexOf(s)) !== (-1))) {
        var this$7 = new $c_s_Some().init___O(a);
        break inlinereturn$6
      }
    };
    var this$7 = $m_s_None$()
  };
  if (this$7.isEmpty__Z()) {
    var xo = $m_s_None$()
  } else {
    var arg1 = this$7.get__O();
    var dialect$3 = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(arg1);
    var xo = new $c_s_Some().init___O(new $c_T2().init___O__O(dialect$3, $as_sc_Seq(dialect$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Declares$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, dialectNode$1) {
      return (function(x$1$2) {
        var x$1 = $as_Lamf_core_model_domain_DomainElement(x$1$2);
        return (x$1.id__T() === dialectNode$1)
      })
    })(this, dialectNode)))))
  };
  var this$9 = xo.toList__sci_List();
  var pf = new $c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$findNode$4().init___Lamf_plugins_document_vocabularies_DialectsRegistry(this);
  return $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$9, pf)
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry.prototype.registerDialect__T__T__Lamf_internal_environment_Environment__s_concurrent_Future = (function(url, code, env) {
  var environment = env.add__Lamf_internal_resource_ResourceLoader__Lamf_internal_environment_Environment(new $c_Lamf_internal_resource_StringResourceLoader().init___T__T(url, code));
  var this$1 = this.platform$1;
  var exec = this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  return this.registerDialect__T__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future(url, environment, exec.$$undinternal$1.context$1)
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry.prototype.init___ = (function() {
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  this.map$1 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.resolved$1 = $as_sci_Set($m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  this.validations$1 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  return this
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry.prototype.registerDialect__T__T__Lamf_internal_environment_Environment__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future = (function(url, code, env, exec) {
  var environment = env.add__Lamf_internal_resource_ResourceLoader__Lamf_internal_environment_Environment(new $c_Lamf_internal_resource_StringResourceLoader().init___T__T(url, code));
  return this.registerDialect__T__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future(url, environment, exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1)
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry.prototype.buildMetaModel__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel = (function(nodeMapping, dialect) {
  var nodeType = $as_Lamf_core_model_StrField(nodeMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().NodeTypeMapping$1));
  var jsx$2 = $as_sc_Seq(nodeMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$4$2) {
      var x$4 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$4$2);
      return x$4.toField__Lamf_core_metamodel_Field()
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var fields = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  var jsx$4 = $as_sc_Seq(dialect.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Declares$1));
  var jsx$3 = new $c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$3().init___Lamf_plugins_document_vocabularies_DialectsRegistry(this);
  var this$2 = $m_sc_Seq$();
  var mapPropertiesInDomain = $as_sc_Seq($as_sc_TraversableLike($as_scg_GenericTraversableTemplate(jsx$4.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$3, this$2.ReusableCBFInstance$2)).flatten__F1__sc_GenTraversable($m_s_Predef$().singleton$und$less$colon$less$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, nodeMapping$1) {
    return (function(prop$2) {
      var prop = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(prop$2);
      return $as_sc_Seq(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1)).exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, nodeMapping$1$1) {
        return (function(x$6$2) {
          var x$6 = $as_Lamf_core_model_StrField(x$6$2);
          var this$3 = x$6.option$1;
          return ($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())) === nodeMapping$1$1.id$1)
        })
      })(this$2$1, nodeMapping$1)))
    })
  })(this, nodeMapping))));
  var jsx$11 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x$7$2) {
      var x$7 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$7$2);
      return $as_Lamf_core_model_StrField(x$7.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermKeyProperty$1))
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  var jsx$10 = $as_sc_TraversableLike($as_sc_SeqLike(mapPropertiesInDomain.map__F1__scg_CanBuildFrom__O(jsx$11, this$4.ReusableCBFInstance$2)).distinct__O());
  var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
    return (function(iri$2) {
      var iri = $as_Lamf_core_model_StrField(iri$2);
      var jsx$9 = $m_Lamf_core_metamodel_Type$Str$();
      var jsx$8 = $m_Lamf_core_vocabulary_ValueType$();
      var this$5 = iri.option$1;
      var jsx$7 = jsx$8.apply__T__Lamf_core_vocabulary_ValueType($as_T((this$5.isEmpty__Z() ? null : this$5.get__O())));
      var jsx$6 = $m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1;
      var this$6 = iri.option$1;
      return new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$9, jsx$7, new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq(jsx$6, "custom", $as_T((this$6.isEmpty__Z() ? null : this$6.get__O())), $m_sci_Nil$()), true)
    })
  })(this));
  var this$8 = $m_sc_Seq$();
  var mapPropertiesFields = $as_sc_Seq(jsx$10.map__F1__scg_CanBuildFrom__O(jsx$5, this$8.ReusableCBFInstance$2));
  var this$9 = nodeType.option$1;
  if (this$9.isEmpty__Z()) {
    var this$12 = $m_s_None$()
  } else {
    var arg1 = this$9.get__O();
    var x$8 = $as_T(arg1);
    var jsx$12 = $m_sc_Seq$();
    var array = [x$8];
    var this$12 = new $c_s_Some().init___O($as_sc_Seq(jsx$12.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))))
  };
  var nodeTypes = $as_sc_Seq((this$12.isEmpty__Z() ? $m_sci_Nil$() : this$12.get__O()));
  var this$13 = $m_sc_Seq$();
  return new $c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel().init___sc_Seq__sc_Seq__s_Option(nodeTypes, $as_sc_Seq(fields.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(mapPropertiesFields, this$13.ReusableCBFInstance$2)), new $c_s_Some().init___O(nodeMapping))
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry.prototype.registerDialect__T__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future = (function(uri, environment, exec) {
  var x1 = this.map$1.get__O__s_Option(uri);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var dialect = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(x2.value$2);
    return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, dialect$1) {
      return (function() {
        return dialect$1
      })
    })(this, dialect)), exec)
  } else {
    var context = new $c_Lamf_core_CompilerContextBuilder().init___T__Lamf_core_remote_Platform__Lamf_core_parser_errorhandler_ParserErrorHandler(uri, this.platform$1, $m_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$()).withEnvironment__Lamf_internal_environment_Environment__Lamf_core_CompilerContextBuilder(environment).build__s_concurrent_ExecutionContext__Lamf_core_CompilerContext(exec);
    return $m_Lamf_core_services_RuntimeCompiler$().forContext__Lamf_core_CompilerContext__s_Option__s_Option__Lamf_core_parser_ReferenceKind__Lamf_core_client_ParsingOptions__s_concurrent_ExecutionContext__s_concurrent_Future(context, new $c_s_Some().init___O("application/yaml"), new $c_s_Some().init___O($m_Lamf_core_remote_Aml$().name$1), ($m_Lamf_core_services_RuntimeCompiler$(), $m_Lamf_core_parser_UnspecifiedReference$()), ($m_Lamf_core_services_RuntimeCompiler$(), new $c_Lamf_core_client_ParsingOptions().init___()), exec).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_model_document_BaseUnit(x0$1$2);
        if ((x0$1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_Dialect)) {
          var x2$1 = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(x0$1);
          if (x2$1.hasValidHeader__Z()) {
            this$2$1.register__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_plugins_document_vocabularies_DialectsRegistry(x2$1);
            return x2$1
          }
        };
        throw new $c_s_MatchError().init___O(x0$1)
      })
    })(this)), exec)
  }
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry.prototype.buildType__Lamf_core_metamodel_Obj__s_Option = (function(modelType) {
  if ((modelType instanceof $c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel(modelType);
    var reviver = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x2$1) {
      return (function(annotations$2) {
        var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
        var x1 = x2$1.nodeMapping$1;
        if ((x1 instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(x1);
          var nodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x2$2.value$2);
          var jsx$3 = new $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
          var jsx$2 = x2$1.typeIri$1;
          var jsx$1 = nodeMapping.id$1;
          var this$3 = $m_sc_Seq$();
          return jsx$3.withInstanceTypes__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_sc_Seq(jsx$2.$$colon$plus__O__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))).withDefinedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(nodeMapping)
        } else {
          throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot find node mapping for dialectModel " + x2$1)))
        }
      })
    })(this, x2));
    return new $c_s_Some().init___O(reviver)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry.prototype.resolveDialect__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_plugins_document_vocabularies_model_document_Dialect = (function(dialect) {
  var solved = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(new $c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectResolutionPipeline().init___Lamf_core_errorhandling_ErrorHandler(new $c_Lamf_client_parse_DefaultErrorHandler().init___()).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(dialect));
  dialect.allHeaders__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, solved$1) {
    return (function(header$2) {
      var header = $as_T(header$2);
      $this.map$1 = $this.map$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(header, solved$1))
    })
  })(this, solved)));
  this.resolved$1 = $as_sci_Set(this.resolved$1.$$plus__O__sc_Set(dialect.header__T()));
  return solved
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry.prototype.findType__T__s_Option = (function(typeString) {
  var this$1 = this.map$1;
  var this$2 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$1);
  var this$3 = this$2.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream();
  var jsx$2 = this$3.distinct__sci_Stream();
  var jsx$1 = new $c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$1().init___Lamf_plugins_document_vocabularies_DialectsRegistry__T(this, typeString);
  var this$4 = $m_sc_Seq$();
  var this$5 = $as_sc_TraversableOnce(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2));
  var pf = new $c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$2().init___Lamf_plugins_document_vocabularies_DialectsRegistry(this);
  var foundMapping = $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$5, pf);
  if ((foundMapping instanceof $c_s_Some)) {
    var x2 = $as_s_Some(foundMapping);
    var p3 = $as_T2(x2.value$2);
    if ((p3 !== null)) {
      var dialect = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(p3.$$und1__O());
      var nodeMapping = $as_Lamf_core_model_domain_DomainElement(p3.$$und2__O());
      if ((dialect !== null)) {
        if ((nodeMapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
          var x5 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(nodeMapping);
          return new $c_s_Some().init___O(this.buildMetaModel__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel(x5, dialect))
        }
      }
    }
  };
  return $m_s_None$()
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry.prototype.knowsDialectInstance__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__Z = (function(instance) {
  return this.dialectFor__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__s_Option(instance).isDefined__Z()
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry.prototype.dialectFor__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__s_Option = (function(instance) {
  var this$1 = instance.definedBy__Lamf_core_model_StrField().option$1;
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var id = $as_T(arg1);
    var this$2 = this.map$1;
    var this$3 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$2);
    var this$4 = this$3.$$outer$3.valuesIterator__sc_Iterator();
    while (this$4.hasNext__Z()) {
      var a = this$4.next__O();
      var x$2 = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(a);
      if ((x$2.id$1 === id)) {
        return new $c_s_Some().init___O(a)
      }
    };
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry.prototype.registerDialect__T__T__s_concurrent_ExecutionContext__s_concurrent_Future = (function(url, code, exec) {
  return this.registerDialect__T__T__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future(url, code, $m_Lamf_internal_environment_Environment$().apply__s_concurrent_ExecutionContext__Lamf_internal_environment_Environment(exec), exec)
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry.prototype.register__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_plugins_document_vocabularies_DialectsRegistry = (function(dialect) {
  dialect.allHeaders__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, dialect$1) {
    return (function(header$2) {
      var header = $as_T(header$2);
      $this.map$1 = $this.map$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(header, dialect$1))
    })
  })(this, dialect)));
  this.resolved$1 = $as_sci_Set(this.resolved$1.$$minus__O__sc_Set(dialect.header__T()));
  this.validations$1 = $as_sci_Map(this.validations$1.$$minus__O__sc_Map(dialect.header__T()));
  return this
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry.prototype.headerKey__T__T = (function(header) {
  return $m_Lorg_mulesoft_common_core_package$Strings$().stripSpaces$extension__T__T(header)
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry.prototype.knowsHeader__T__Z = (function(header) {
  return ((((header === "%Vocabulary 1.0") || (header === "%Dialect 1.0")) || (header === "%Library / Dialect 1.0")) || this.map$1.contains__O__Z(this.headerKey__T__T(header)))
});
var $d_Lamf_plugins_document_vocabularies_DialectsRegistry = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_DialectsRegistry: 0
}, false, "amf.plugins.document.vocabularies.DialectsRegistry", {
  Lamf_plugins_document_vocabularies_DialectsRegistry: 1,
  O: 1,
  Lamf_core_registries_AMFDomainEntityResolver: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry.prototype.$classData = $d_Lamf_plugins_document_vocabularies_DialectsRegistry;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$6() {
  $c_O.call(this);
  this.$$outer$1 = null;
  this.ordering$1$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$6.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$6.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$6;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$6() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$6.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$6.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$6.prototype.init___Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters__Lamf_core_emitter_SpecOrdering = (function($$outer, ordering$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.ordering$1$1 = ordering$1;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$6.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("external");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$5 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var jsx$3 = this.ordering$1$1;
  var this$3 = this.$$outer$1.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect();
  var jsx$2 = $f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(this$3);
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(external$2) {
      var external = $as_Lamf_plugins_document_vocabularies_model_domain_External(external$2);
      return new $c_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter().init___Lamf_plugins_document_vocabularies_model_domain_External__Lamf_core_emitter_SpecOrdering(external, $this.ordering$1$1)
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  jsx$4.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$3.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2))), b$1);
  jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$6 = j;
    var index = i;
    xs.set(jsx$6, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$6.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.$$outer$1.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect();
  var jsx$2 = $f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(this$1);
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(e$2) {
      var e = $as_Lamf_plugins_document_vocabularies_model_domain_External(e$2);
      var this$2 = e.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      if (this$2.isEmpty__Z()) {
        var xo = $m_s_None$()
      } else {
        var arg1 = this$2.get__O();
        var x$40 = $as_Lamf_core_annotations_LexicalInformation(arg1);
        var xo = new $c_s_Some().init___O(x$40.range__Lamf_core_parser_Range().start$1)
      };
      return xo.toList__sci_List()
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  var this$5 = $as_sc_TraversableLike($as_sc_SeqLike(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2)).sortBy__F1__s_math_Ordering__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$41$2) {
      var x$41 = $as_Lamf_core_parser_Position(x$41$2);
      return x$41.line$1
    })
  })(this)), $m_s_math_Ordering$Int$())).headOption__s_Option();
  return $as_Lamf_core_parser_Position((this$5.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$5.get__O()))
});
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$6 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$6: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.DialectDocumentsEmitters$$anon$6", {
  Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$6: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$6.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$6;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$7() {
  $c_O.call(this);
  this.nodeMappingDeclarations$1$1 = null;
  this.dialect$1$1 = null;
  this.ordering$2$1 = null;
  this.aliases$1$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$7.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$7.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$7;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$7() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$7.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$7.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$7.prototype.init___Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters__sc_Seq__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sci_Map = (function($$outer, nodeMappingDeclarations$1, dialect$1, ordering$2, aliases$1) {
  this.nodeMappingDeclarations$1$1 = nodeMappingDeclarations$1;
  this.dialect$1$1 = dialect$1;
  this.ordering$2$1 = ordering$2;
  this.aliases$1$1 = aliases$1;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$7.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("nodeMappings");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$2 = this.nodeMappingDeclarations$1$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(n$2) {
      var n = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(n$2);
      return new $c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter().init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_core_emitter_SpecOrdering__sci_Map($this.dialect$1$1, n, $this.ordering$2$1, $this.aliases$1$1)
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  var nodeMappingEmitters = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$2$1.sorted__sc_Seq__sc_Seq(nodeMappingEmitters), b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$4 = j;
    var index = i;
    xs.set(jsx$4, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$7.prototype.position__Lamf_core_parser_Position = (function() {
  var jsx$3 = this.nodeMappingDeclarations$1$1;
  var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$43$2) {
      var x$43 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x$43$2);
      var this$1 = x$43.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      if (this$1.isEmpty__Z()) {
        var this$2 = $m_s_None$()
      } else {
        var arg1 = this$1.get__O();
        var x$44 = $as_Lamf_core_annotations_LexicalInformation(arg1);
        var this$2 = new $c_s_Some().init___O(x$44.range__Lamf_core_parser_Range().start$1)
      };
      return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  var jsx$1 = $as_sc_SeqLike($as_sc_TraversableLike(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$3.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$45$2) {
      var x$45 = $as_Lamf_core_parser_Position(x$45$2);
      var x$2 = $m_Lamf_core_parser_Position$ZERO$();
      return (!((x$45 !== null) && x$45.equals__O__Z(x$2)))
    })
  })(this))));
  var this$4 = $m_s_math_Ordering$();
  var evidence$1 = $m_s_Predef$().singleton$und$less$colon$less$2;
  var this$5 = $as_sc_TraversableLike(jsx$1.sorted__s_math_Ordering__O(new $c_s_math_LowPriorityOrderingImplicits$$anon$3().init___s_math_LowPriorityOrderingImplicits__F1(this$4, evidence$1))).headOption__s_Option();
  return $as_Lamf_core_parser_Position((this$5.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$5.get__O()))
});
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$7 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$7: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.DialectDocumentsEmitters$$anon$7", {
  Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$7: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$7.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anon$7;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$10() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$10.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$10.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$10;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$10() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$10.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$10.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$10.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.$$outer$1.dialect$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1));
  var this$3 = this$2.option$1;
  new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("usage", $as_T((this$3.isEmpty__Z() ? null : this$3.get__O())), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$10.prototype.init___Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$10.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.$$outer$1.dialect$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Usage$1);
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$48 = $as_Lamf_core_parser_FieldEntry(arg1);
    var this$3 = new $c_Lamf_plugins_document_vocabularies_emitters_dialects_FieldEntryImplicit$FieldEntryWithPosition().init___Lamf_core_parser_FieldEntry(x$48).startPosition__s_Option()
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$10 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$10: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.DialectEmitter$$anon$10", {
  Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$10: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$10.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$10;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$8() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$8.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$8.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$8;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$8() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$8.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$8.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$8.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.$$outer$1.dialect$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Name$1));
  var this$3 = this$2.option$1;
  new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("dialect", $as_T((this$3.isEmpty__Z() ? null : this$3.get__O())), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$8.prototype.init___Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$8.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.$$outer$1.dialect$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Name$1);
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$46 = $as_Lamf_core_parser_FieldEntry(arg1);
    var this$3 = new $c_Lamf_plugins_document_vocabularies_emitters_dialects_FieldEntryImplicit$FieldEntryWithPosition().init___Lamf_core_parser_FieldEntry(x$46).startPosition__s_Option()
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$8 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$8: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.DialectEmitter$$anon$8", {
  Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$8: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$8.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$8;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$9() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$9.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$9.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$9;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$9() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$9.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$9.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$9.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.$$outer$1.dialect$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Version$1));
  var this$3 = this$2.option$1;
  new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("version", $as_T((this$3.isEmpty__Z() ? null : this$3.get__O())), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$9.prototype.init___Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$9.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.$$outer$1.dialect$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Version$1);
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$47 = $as_Lamf_core_parser_FieldEntry(arg1);
    var this$3 = new $c_Lamf_plugins_document_vocabularies_emitters_dialects_FieldEntryImplicit$FieldEntryWithPosition().init___Lamf_core_parser_FieldEntry(x$47).startPosition__s_Option()
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$9 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$9: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.DialectEmitter$$anon$9", {
  Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$9: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$9.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$9;
function $f_Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter__emitDiscriminator__Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__sc_Seq($thiz, nodeWithDiscriminator) {
  var elem = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var elem$1 = null;
  elem$1 = elem;
  var this$2 = nodeWithDiscriminator.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().TypeDiscriminator$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var entry = $as_Lamf_core_parser_FieldEntry(arg1);
    var field = entry.field$1;
    var pos = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position($thiz, nodeWithDiscriminator, field);
    var typesMapping = $f_Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__typeDiscriminator__sci_Map(nodeWithDiscriminator);
    var jsx$3 = $as_sc_Seq(elem$1);
    var jsx$2 = $m_sc_Seq$();
    var array = [new $c_Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter$$anon$1().init___Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter__sci_Map__Lamf_core_parser_Position($thiz, typesMapping, pos)];
    var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$5 = $m_sc_Seq$();
    elem$1 = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
  };
  var this$6 = nodeWithDiscriminator.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().TypeDiscriminatorName$1);
  if ((!this$6.isEmpty__Z())) {
    var arg1$1 = this$6.get__O();
    var entry$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    var value = $objectToString($as_Lamf_core_model_domain_AmfScalar(entry$3.value$1.value$1).value$1);
    var field$1 = entry$3.field$1;
    var pos$1 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position($thiz, nodeWithDiscriminator, field$1);
    var jsx$6 = $as_sc_Seq(elem$1);
    var jsx$5 = $m_sc_Seq$();
    var array$1 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("typeDiscriminatorName", value, $m_Lorg_yaml_model_YType$().Str$1, pos$1)];
    var jsx$4 = jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
    var this$9 = $m_sc_Seq$();
    elem$1 = $as_sc_Seq(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$9.ReusableCBFInstance$2))
  };
  return $as_sc_Seq(elem$1)
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter$$anon$1() {
  $c_O.call(this);
  this.$$outer$1 = null;
  this.typesMapping$1$1 = null;
  this.pos$1$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter$$anon$1.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter$$anon$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter$$anon$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter$$anon$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter$$anon$1.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter$$anon$1.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter$$anon$1.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("typeDiscriminator");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  this.typesMapping$1$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$2) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var alias = $as_T(x0$1.$$und1__O());
        var nodeMappingId = $as_T(x0$1.$$und2__O());
        var this$3 = $this.$$outer$1;
        var x1$2 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_AliasesConsumer__aliasFor__T__s_Option(this$3, nodeMappingId);
        if ((x1$2 instanceof $c_s_Some)) {
          var x2 = $as_s_Some(x1$2);
          var nodeMapping = $as_T(x2.value$2);
          $m_Lorg_yaml_model_YNode$();
          var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(alias);
          $m_Lorg_yaml_model_YNode$();
          var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(nodeMapping);
          b$2.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$1, value)
        } else {
          $m_Lorg_yaml_model_YNode$();
          var key$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(alias);
          $m_Lorg_yaml_model_YNode$();
          var value$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(nodeMappingId);
          b$2.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$2, value$1)
        }
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, b$1)));
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$10 = v.builder$1;
  var array = [key];
  if ((this$10.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$10.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$10, newSize);
  var len$1 = this$10.size0$6;
  var src = this$10.array$6;
  var dest = this$10.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$10.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x$1 = $uI(array.length);
  var x$2 = ((x$1 < len$2) ? x$1 : len$2);
  var that = xs.u.length;
  var end = ((x$2 < that) ? x$2 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$10.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter$$anon$1.prototype.init___Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter__sci_Map__Lamf_core_parser_Position = (function($$outer, typesMapping$1, pos$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.typesMapping$1$1 = typesMapping$1;
  this.pos$1$1 = pos$1;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter$$anon$1.prototype.position__Lamf_core_parser_Position = (function() {
  return this.pos$1$1
});
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter$$anon$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter$$anon$1: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.DiscriminatorEmitter$$anon$1", {
  Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter$$anon$1: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter$$anon$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter$$anon$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anon$2() {
  $c_O.call(this);
  this.sortedNodes$1$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anon$2.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anon$2.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anon$2;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anon$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anon$2.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anon$2.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anon$2.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("declares");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.sortedNodes$1$1, b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$5 = v.builder$1;
  var array = [key];
  if ((this$5.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$5.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$5, newSize);
  var len$1 = this$5.size0$6;
  var src = this$5.array$6;
  var dest = this$5.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$5.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$5.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anon$2.prototype.init___Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter__sc_Seq = (function($$outer, sortedNodes$1) {
  this.sortedNodes$1$1 = sortedNodes$1;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anon$2.prototype.position__Lamf_core_parser_Position = (function() {
  return $as_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter(this.sortedNodes$1$1.head__O()).position$1
});
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anon$2 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anon$2: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.LibraryDocumentModelEmitter$$anon$2", {
  Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anon$2: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anon$2.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anon$2;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anon$5() {
  $c_O.call(this);
  this.targets$2$1 = null;
  this.pos$3$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anon$5.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anon$5.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anon$5;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anon$5() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anon$5.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anon$5.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anon$5.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("union");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$2 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  this.targets$2$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$2) {
    return (function(target$2) {
      var target = $as_T(target$2);
      new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(target, new $c_Lamf_core_parser_Annotations().init___()), $m_Lorg_yaml_model_YType$().Str$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$2)
    })
  })(this, b$1)));
  var jsx$1 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$2.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$8 = v.builder$1;
  var array = [key];
  if ((this$8.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$8.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$8, newSize);
  var len$1 = this$8.size0$6;
  var src = this$8.array$6;
  var dest = this$8.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$8.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$3 = j;
    var index = i;
    xs.set(jsx$3, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$8.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anon$5.prototype.init___Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter__sc_Seq__Lamf_core_parser_Position = (function($$outer, targets$2, pos$3) {
  this.targets$2$1 = targets$2;
  this.pos$3$1 = pos$3;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anon$5.prototype.position__Lamf_core_parser_Position = (function() {
  return this.pos$3$1
});
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anon$5 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anon$5: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.NodeMappingEmitter$$anon$5", {
  Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anon$5: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anon$5.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anon$5;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anon$4() {
  $c_O.call(this);
  this.targets$1$1 = null;
  this.pos$2$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anon$4.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anon$4.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anon$4;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anon$4() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anon$4.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anon$4.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anon$4.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("range");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$2 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  this.targets$1$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$2) {
    return (function(target$2) {
      var target = $as_T(target$2);
      new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(target, new $c_Lamf_core_parser_Annotations().init___()), $m_Lorg_yaml_model_YType$().Str$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$2)
    })
  })(this, b$1)));
  var jsx$1 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$2.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$8 = v.builder$1;
  var array = [key];
  if ((this$8.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$8.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$8, newSize);
  var len$1 = this$8.size0$6;
  var src = this$8.array$6;
  var dest = this$8.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$8.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$3 = j;
    var index = i;
    xs.set(jsx$3, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$8.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anon$4.prototype.init___Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter__sc_Seq__Lamf_core_parser_Position = (function($$outer, targets$1, pos$2) {
  this.targets$1$1 = targets$1;
  this.pos$2$1 = pos$2;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anon$4.prototype.position__Lamf_core_parser_Position = (function() {
  return this.pos$2$1
});
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anon$4 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anon$4: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.PropertyMappingEmitter$$anon$4", {
  Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anon$4: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anon$4.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anon$4;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter$$anon$11() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter$$anon$11.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter$$anon$11.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter$$anon$11;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter$$anon$11() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter$$anon$11.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter$$anon$11.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter$$anon$11.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.$$outer$1.dialect$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1));
  var this$3 = this$2.option$1;
  new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("usage", $as_T((this$3.isEmpty__Z() ? null : this$3.get__O())), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter$$anon$11.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.$$outer$1.dialect$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Usage$1);
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$49 = $as_Lamf_core_parser_FieldEntry(arg1);
    var this$3 = new $c_Lamf_plugins_document_vocabularies_emitters_dialects_FieldEntryImplicit$FieldEntryWithPosition().init___Lamf_core_parser_FieldEntry(x$49).startPosition__s_Option()
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter$$anon$11.prototype.init___Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter$$anon$11 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter$$anon$11: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.RamlDialectLibraryEmitter$$anon$11", {
  Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter$$anon$11: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter$$anon$11.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter$$anon$11;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter$$anon$3() {
  $c_O.call(this);
  this.sortedNodes$2$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter$$anon$3.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter$$anon$3.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter$$anon$3;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter$$anon$3() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter$$anon$3.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter$$anon$3.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter$$anon$3.prototype.init___Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter__sc_Seq = (function($$outer, sortedNodes$2) {
  this.sortedNodes$2$1 = sortedNodes$2;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter$$anon$3.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("declares");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.sortedNodes$2$1, b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$5 = v.builder$1;
  var array = [key];
  if ((this$5.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$5.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$5, newSize);
  var len$1 = this$5.size0$6;
  var src = this$5.array$6;
  var dest = this$5.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$5.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$5.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter$$anon$3.prototype.position__Lamf_core_parser_Position = (function() {
  return $as_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter(this.sortedNodes$2$1.head__O()).position$1
});
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter$$anon$3 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter$$anon$3: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.RootDocumentModelEmitter$$anon$3", {
  Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter$$anon$3: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter$$anon$3.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter$$anon$3;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anon$1() {
  $c_O.call(this);
  this.ordering$1$1 = null;
  this.model$1$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anon$1.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anon$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anon$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anon$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anon$1.prototype = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anon$1.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anon$1.prototype.init___Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_vocabularies_model_document_ExternalContext = (function($$outer, ordering$1, model$1) {
  this.ordering$1$1 = ordering$1;
  this.model$1$1 = model$1;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anon$1.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("$external");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$5 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var jsx$3 = this.ordering$1$1;
  var this$3 = this.model$1$1;
  var jsx$2 = $f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(this$3);
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(external$2) {
      var external = $as_Lamf_plugins_document_vocabularies_model_domain_External(external$2);
      return new $c_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter().init___Lamf_plugins_document_vocabularies_model_domain_External__Lamf_core_emitter_SpecOrdering(external, $this.ordering$1$1)
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  jsx$4.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$3.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2))), b$1);
  jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$6 = j;
    var index = i;
    xs.set(jsx$6, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anon$1.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.model$1$1;
  var jsx$4 = $f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(this$1);
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(e$2) {
      var e = $as_Lamf_plugins_document_vocabularies_model_domain_External(e$2);
      var this$2 = e.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      if (this$2.isEmpty__Z()) {
        return $m_s_None$()
      } else {
        var arg1 = this$2.get__O();
        var x$2 = $as_Lamf_core_annotations_LexicalInformation(arg1);
        return new $c_s_Some().init___O(x$2.range__Lamf_core_parser_Range().start$1)
      }
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike($as_sc_TraversableLike(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$3.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$3$2) {
      var x$3 = $as_s_Option(x$3$2);
      return x$3.isDefined__Z()
    })
  })(this))));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x$4$2) {
      var x$4 = $as_s_Option(x$4$2);
      return $as_Lamf_core_parser_Position(x$4.get__O())
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  var this$5 = $as_sc_TraversableLike($as_sc_SeqLike(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2)).sortBy__F1__s_math_Ordering__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
    return (function(x$5$2) {
      var x$5 = $as_Lamf_core_parser_Position(x$5$2);
      return x$5.line$1
    })
  })(this)), $m_s_math_Ordering$Int$())).headOption__s_Option();
  return $as_Lamf_core_parser_Position((this$5.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$5.get__O()))
});
var $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anon$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anon$1: 0
}, false, "amf.plugins.document.vocabularies.emitters.instances.DialectEmitterHelper$$anon$1", {
  Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anon$1: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anon$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anon$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$2() {
  $c_O.call(this);
  this.node$1$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$2.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$2.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$2;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$2.prototype = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$2.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$2.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  if (this.node$1$1.annotations$1.contains__jl_Class__Z($d_Lamf_plugins_document_vocabularies_annotations_RefInclude.getClassOf())) {
    var jsx$1 = b.builder$1;
    var sourceName = b.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("$include");
    $m_Lorg_yaml_model_YNode$();
    var str = this.node$1$1.includeName__T();
    var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value);
    jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  } else if (this.node$1$1.annotations$1.contains__jl_Class__Z($d_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef.getClassOf())) {
    var jsx$3 = b.builder$1;
    var sourceName$1 = b.sourceName$2;
    var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
    $m_Lorg_yaml_model_YNode$();
    var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("$ref");
    $m_Lorg_yaml_model_YNode$();
    var this$6 = this.node$1$1;
    var this$7 = $as_Lamf_core_model_StrField(this$6.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1;
    if (this$7.isEmpty__Z()) {
      var this$8 = this.node$1$1;
      var jsx$2 = $as_Lamf_core_model_domain_AmfObject($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$8).get__O()).id__T()
    } else {
      var jsx$2 = this$7.get__O()
    };
    var str$1 = $as_T(jsx$2);
    var value$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
    b$2.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$1, value$1);
    jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1))
  } else {
    var node = $m_Lorg_yaml_model_YNode$().include__T__T__Lorg_yaml_model_YNode$MutRef(this.node$1$1.includeName__T(), ($m_Lorg_yaml_model_YNode$(), ""));
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer(node)
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$2.prototype.init___Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function($$outer, node$1) {
  this.node$1$1 = node$1;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$2.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.node$1$1.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$21 = $as_Lamf_core_annotations_LexicalInformation(arg1);
    var this$2 = new $c_s_Some().init___O(x$21.range__Lamf_core_parser_Range().start$1)
  };
  return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
});
var $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$2 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$2: 0
}, false, "amf.plugins.document.vocabularies.emitters.instances.DialectNodeEmitter$$anon$2", {
  Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$2: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$2.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$2;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$3() {
  $c_O.call(this);
  this.$$outer$1 = null;
  this.key$1$1 = null;
  this.target$1$1 = null;
  this.propertyMapping$1$1 = null;
  this.annotations$1$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$3.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$3.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$3;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$3() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$3.prototype = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$3.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$3.prototype.init___Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__s_Option = (function($$outer, key$1, target$1, propertyMapping$1, annotations$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.key$1$1 = key$1;
  this.target$1$1 = target$1;
  this.propertyMapping$1$1 = propertyMapping$1;
  this.annotations$1$1 = annotations$1;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$3.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var x1 = this.target$1$1;
  if ((x1 instanceof $c_Lamf_core_model_domain_AmfArray)) {
    var x2 = $as_Lamf_core_model_domain_AmfArray(x1);
    var jsx$2 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
    x2.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, l) {
      return (function(elem$2) {
        var elem = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(elem$2);
        var this$3 = elem.fields$1;
        var this$4 = this$3.fs$1;
        if ($f_sc_TraversableOnce__nonEmpty__Z(this$4)) {
          var x1$1 = $this.$$outer$1.nodeMappingForObjectProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__s_Option($this.propertyMapping$1$1, elem);
          if ((x1$1 instanceof $c_s_Some)) {
            var x2$1 = $as_s_Some(x1$1);
            var rangeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x2$1.value$2);
            var x$3 = $this.$$outer$1.instance$1;
            var x$4 = $this.$$outer$1.dialect$1;
            var x$5 = $this.$$outer$1.ordering$1;
            var x$6 = $this.$$outer$1.aliases$1;
            var x$7 = $m_s_None$();
            var x$8 = $this.$$outer$1.keyPropertyId$1;
            var x$9 = $this.$$outer$1.renderOptions$1;
            var x$11 = $m_s_None$();
            var x$13 = $m_sci_Nil$();
            new $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter().init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sci_Map__s_Option__Z__s_Option__s_Option__Z__sc_Seq__Lamf_core_emitter_RenderOptions(elem, rangeMapping, x$3, x$4, x$5, x$6, x$8, false, x$11, x$7, false, x$13, x$9).emit__Lorg_yaml_model_YDocument$PartBuilder__V(l)
          }
        } else {
          $this.$$outer$1.emitCustomId__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YDocument$PartBuilder__V(elem, l)
        }
      })
    })(this, b$1)));
    var jsx$1 = $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YSequence$();
    var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
    var parts = b$1.builder$1;
    var node = jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
    jsx$2.$$plus$eq__O__scm_ArrayBuffer(node)
  } else if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
    var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x1);
    this.$$outer$1.emitCustomId__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YDocument$PartBuilder__V(x3, v)
  } else {
    throw new $c_s_MatchError().init___O(x1)
  };
  var this$10 = v.builder$1;
  var array = [key];
  if ((this$10.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$10.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$10, newSize);
  var len$1 = this$10.size0$6;
  var src = this$10.array$6;
  var dest = this$10.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$10.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$3 = j;
    var index = i;
    xs.set(jsx$3, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$10.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$3.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.annotations$1$1;
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$22 = $as_Lamf_core_parser_Annotations(arg1);
    var this$2 = x$22.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf())
  };
  var this$3 = (this$2.isEmpty__Z() ? this.target$1$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()) : this$2);
  if (this$3.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1$1 = this$3.get__O();
    var x$23 = $as_Lamf_core_annotations_LexicalInformation(arg1$1);
    var this$4 = new $c_s_Some().init___O(x$23.range__Lamf_core_parser_Range().start$1)
  };
  return $as_Lamf_core_parser_Position((this$4.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$4.get__O()))
});
var $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$3 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$3: 0
}, false, "amf.plugins.document.vocabularies.emitters.instances.DialectNodeEmitter$$anon$3", {
  Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$3: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$3.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$3;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$4() {
  $c_O.call(this);
  this.nodeMappings$1 = null;
  this.keyPropertyId$1 = null;
  this.$$outer$1 = null;
  this.propertyMapping$2$1 = null;
  this.elements$1$1 = null;
  this.discriminator$2$1 = null;
  this.isArray$1$1 = false;
  this.key$2$1 = null;
  this.annotations$2$1 = null;
  this.target$2$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$4.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$4.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$4;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$4() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$4.prototype = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$4.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$4.prototype.emitArray__p1__Lorg_yaml_model_YDocument$EntryBuilder__sci_Map__V = (function(b, mappedElements) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$2$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  var jsx$1 = this.$$outer$1.ordering$1;
  var this$3 = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(mappedElements);
  jsx$1.sorted__sc_Seq__sc_Seq($f_sc_SetLike__toSeq__sc_Seq(this$3)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$2) {
    return (function(x$28$2) {
      var x$28 = $as_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter(x$28$2);
      x$28.emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$2)
    })
  })(this, b$1)));
  var jsx$2 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$2.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$4 = j;
    var index = i;
    xs.set(jsx$4, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$4.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var mappedElements = $as_sci_Map(this.elements$1$1.foldLeft__O__F2__O($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(x0$1$2, x1$1$2) {
      var x0$1 = $as_sci_Map(x0$1$2);
      var x1$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x1$1$2);
      if ((x1$1 !== null)) {
        var x1$2 = $this.nodeMappings$1.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, x3) {
          return (function(nodeMapping$2) {
            var nodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(nodeMapping$2);
            var this$2 = x3.meta__Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel().type$1;
            var f = (function($this$2) {
              return (function(x$24$2) {
                var x$24 = $as_Lamf_core_vocabulary_ValueType(x$24$2);
                return x$24.iri__T()
              })
            })($this$1);
            var this$1 = $m_sci_List$();
            var bf = this$1.ReusableCBFInstance$2;
            if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
              if ((this$2 === $m_sci_Nil$())) {
                var jsx$1 = $m_sci_Nil$()
              } else {
                var arg1 = this$2.head__O();
                var h = new $c_sci_$colon$colon().init___O__sci_List(f(arg1), $m_sci_Nil$());
                var t = h;
                var rest = $as_sci_List(this$2.tail__O());
                while ((rest !== $m_sci_Nil$())) {
                  var arg1$1 = rest.head__O();
                  var nx = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$1), $m_sci_Nil$());
                  t.tl$5 = nx;
                  t = nx;
                  rest = $as_sci_List(rest.tail__O())
                };
                var jsx$1 = h
              }
            } else {
              var b$1 = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$2, bf);
              var these = this$2;
              while ((!these.isEmpty__Z())) {
                var arg1$2 = these.head__O();
                b$1.$$plus$eq__O__scm_Builder(f(arg1$2));
                these = $as_sci_List(these.tail__O())
              };
              var jsx$1 = b$1.result__O()
            };
            var this$5 = $as_sc_LinearSeqOptimized(jsx$1);
            var this$3 = $as_Lamf_core_model_StrField(nodeMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().NodeTypeMapping$1));
            var this$4 = this$3.option$1;
            var elem = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
            return $f_sc_LinearSeqOptimized__contains__O__Z(this$5, elem)
          })
        })($this, x1$1)));
        if ((x1$2 instanceof $c_s_Some)) {
          var x2 = $as_s_Some(x1$2);
          var nextNodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x2.value$2);
          var x$3 = $this.$$outer$1.instance$1;
          var x$4 = $this.$$outer$1.dialect$1;
          var x$5 = $this.$$outer$1.ordering$1;
          var x$6 = $this.$$outer$1.aliases$1;
          var x$7 = $this.discriminator$2$1.compute__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__s_Option(x1$1);
          var x$8 = $this.keyPropertyId$1;
          var x$9 = $this.$$outer$1.renderOptions$1;
          var x$11 = $m_s_None$();
          var x$13 = $m_sci_Nil$();
          var nodeEmitter = new $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter().init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sci_Map__s_Option__Z__s_Option__s_Option__Z__sc_Seq__Lamf_core_emitter_RenderOptions(x1$1, nextNodeMapping, x$3, x$4, x$5, x$6, x$8, false, x$11, x$7, false, x$13, x$9);
          return x0$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(nodeEmitter, x1$1))
        } else {
          return x0$1
        }
      } else {
        return x0$1
      }
    })
  })(this))));
  if (this.keyPropertyId$1.isDefined__Z()) {
    this.emitMap__p1__Lorg_yaml_model_YDocument$EntryBuilder__sci_Map__V(b, mappedElements)
  } else if (this.isArray$1$1) {
    this.emitArray__p1__Lorg_yaml_model_YDocument$EntryBuilder__sci_Map__V(b, mappedElements)
  } else {
    this.emitSingleElement__p1__Lorg_yaml_model_YDocument$EntryBuilder__sci_Map__V(b, mappedElements)
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$4.prototype.emitMap__p1__Lorg_yaml_model_YDocument$EntryBuilder__sci_Map__V = (function(b, mapElements) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$2$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$4 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$1 = this.$$outer$1.ordering$1;
  var this$3 = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(mapElements);
  jsx$1.sorted__sc_Seq__sc_Seq($f_sc_SetLike__toSeq__sc_Seq(this$3)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, mapElements$1, b$2) {
    return (function(emitter$2) {
      var emitter = $as_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter(emitter$2);
      var dialectDomainElement = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(mapElements$1.apply__O__O(emitter));
      var this$4 = dialectDomainElement.meta__Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel().fields$1;
      inlinereturn$18: {
        var these = this$4;
        while ((!these.isEmpty__Z())) {
          var arg1 = these.head__O();
          var x$26 = $as_Lamf_core_metamodel_Field(arg1);
          var jsx$3 = x$26.value$1.iri__T();
          var this$5 = $this.propertyMapping$2$1;
          var this$6 = $as_Lamf_core_model_StrField(this$5.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermKeyProperty$1));
          var this$7 = this$6.option$1;
          if ((jsx$3 === $as_T((this$7.isEmpty__Z() ? null : this$7.get__O())))) {
            var jsx$2 = new $c_s_Some().init___O(these.head__O());
            break inlinereturn$18
          };
          these = $as_sc_LinearSeqOptimized(these.tail__O())
        };
        var jsx$2 = $m_s_None$()
      };
      var mapKeyField = $as_Lamf_core_metamodel_Field(jsx$2.get__O());
      var this$8 = dialectDomainElement.fields$1.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value(mapKeyField);
      var mapKeyValue = this$8.value$1.toString__T();
      new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position(mapKeyValue, emitter, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$2)
    })
  })(this, mapElements, b$1)));
  jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$13 = v.builder$1;
  var array = [key];
  if ((this$13.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$13.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$13, newSize);
  var len$1 = this$13.size0$6;
  var src = this$13.array$6;
  var dest = this$13.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$13.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$5 = j;
    var index = i;
    xs.set(jsx$5, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$13.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$4.prototype.emitSingleElement__p1__Lorg_yaml_model_YDocument$EntryBuilder__sci_Map__V = (function(b, mappedElements) {
  var this$1 = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(mappedElements);
  var this$2 = $f_sc_TraversableLike__headOption__s_Option(this$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var emitter = $as_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter(arg1);
    new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position(this.key$2$1, emitter, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$4.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.annotations$2$1;
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$29 = $as_Lamf_core_parser_Annotations(arg1);
    var this$2 = x$29.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf())
  };
  var this$3 = (this$2.isEmpty__Z() ? this.target$2$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()) : this$2);
  if (this$3.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1$1 = this$3.get__O();
    var x$30 = $as_Lamf_core_annotations_LexicalInformation(arg1$1);
    var this$4 = new $c_s_Some().init___O(x$30.range__Lamf_core_parser_Range().start$1)
  };
  return $as_Lamf_core_parser_Position((this$4.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$4.get__O()))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$4.prototype.init___Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__sc_Seq__Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper__Z__T__s_Option__Lamf_core_model_domain_AmfElement = (function($$outer, propertyMapping$2, elements$1, discriminator$2, isArray$1, key$2, annotations$2, target$2) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.propertyMapping$2$1 = propertyMapping$2;
  this.elements$1$1 = elements$1;
  this.discriminator$2$1 = discriminator$2;
  this.isArray$1$1 = isArray$1;
  this.key$2$1 = key$2;
  this.annotations$2$1 = annotations$2;
  this.target$2$1 = target$2;
  var jsx$3 = $as_sc_Seq(propertyMapping$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(rangeNodeMapping$2) {
      var rangeNodeMapping = $as_Lamf_core_model_StrField(rangeNodeMapping$2);
      var jsx$2 = $this.$$outer$1;
      var this$1 = rangeNodeMapping.option$1;
      return jsx$2.findAllNodeMappings__T__sc_Seq($as_T((this$1.isEmpty__Z() ? null : this$1.get__O())))
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  this.nodeMappings$1 = $as_sc_Seq(jsx$3.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  this.keyPropertyId$1 = $as_Lamf_core_model_StrField(propertyMapping$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermKeyProperty$1)).option$1;
  return this
});
var $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$4 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$4: 0
}, false, "amf.plugins.document.vocabularies.emitters.instances.DialectNodeEmitter$$anon$4", {
  Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$4: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$4.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$4;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$5() {
  $c_O.call(this);
  this.key$3$1 = null;
  this.array$2$1 = null;
  this.keyProperty$1$1 = null;
  this.valueProperty$1$1 = null;
  this.annotations$3$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$5.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$5.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$5;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$5() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$5.prototype = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$5.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$5.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$3$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$2 = this.array$2$1.values$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(elem$2) {
      var elem = $as_Lamf_core_model_domain_AmfElement(elem$2);
      var this$3 = elem.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      if (this$3.isEmpty__Z()) {
        var this$4 = $m_s_None$()
      } else {
        var arg1 = this$3.get__O();
        var x$34 = $as_Lamf_core_annotations_LexicalInformation(arg1);
        var this$4 = new $c_s_Some().init___O(x$34.range__Lamf_core_parser_Range().start$1)
      };
      return $as_Lamf_core_parser_Position((this$4.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$4.get__O()))
    })
  })(this));
  var this$5 = $m_s_math_Ordering$();
  var evidence$1 = $m_s_Predef$().singleton$und$less$colon$less$2;
  var sortedElements = $as_sc_Seq(jsx$2.sortBy__F1__s_math_Ordering__O(jsx$1, new $c_s_math_LowPriorityOrderingImplicits$$anon$3().init___s_math_LowPriorityOrderingImplicits__F1(this$5, evidence$1)));
  sortedElements.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, b$2) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_domain_AmfElement(x0$1$2);
      if ((x0$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
        var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x0$1);
        var this$6 = x2.meta__Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel().fields$1;
        inlinereturn$23: {
          var these = this$6;
          while ((!these.isEmpty__Z())) {
            var arg1$1 = these.head__O();
            var x$35 = $as_Lamf_core_metamodel_Field(arg1$1);
            if ((x$35.value$1.iri__T() === this$2$1.keyProperty$1$1)) {
              var keyField = new $c_s_Some().init___O(these.head__O());
              break inlinereturn$23
            };
            these = $as_sc_LinearSeqOptimized(these.tail__O())
          };
          var keyField = $m_s_None$()
        };
        var this$7 = x2.meta__Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel().fields$1;
        inlinereturn$28: {
          var these$1 = this$7;
          while ((!these$1.isEmpty__Z())) {
            var arg1$2 = these$1.head__O();
            var x$36 = $as_Lamf_core_metamodel_Field(arg1$2);
            if ((x$36.value$1.iri__T() === this$2$1.valueProperty$1$1)) {
              var valueField = new $c_s_Some().init___O(these$1.head__O());
              break inlinereturn$28
            };
            these$1 = $as_sc_LinearSeqOptimized(these$1.tail__O())
          };
          var valueField = $m_s_None$()
        };
        if ((keyField.isDefined__Z() && valueField.isDefined__Z())) {
          var this$8 = x2.fields$1;
          var field = $as_Lamf_core_metamodel_Field(keyField.get__O());
          var this$9 = this$8.fs$1.get__O__s_Option(field);
          if (this$9.isEmpty__Z()) {
            var keyLiteral = $m_s_None$()
          } else {
            var arg1$3 = this$9.get__O();
            var x$37 = $as_Lamf_core_parser_Value(arg1$3);
            var keyLiteral = new $c_s_Some().init___O(x$37.value$1)
          };
          var this$10 = x2.fields$1;
          var field$1 = $as_Lamf_core_metamodel_Field(valueField.get__O());
          var this$11 = this$10.fs$1.get__O__s_Option(field$1);
          if (this$11.isEmpty__Z()) {
            var valueLiteral = $m_s_None$()
          } else {
            var arg1$4 = this$11.get__O();
            var x$38 = $as_Lamf_core_parser_Value(arg1$4);
            var valueLiteral = new $c_s_Some().init___O(x$38.value$1)
          };
          matchEnd9: {
            if ((keyLiteral instanceof $c_s_Some)) {
              var x4 = $as_s_Some(keyLiteral);
              var keyScalar = $as_Lamf_core_model_domain_AmfElement(x4.value$2);
              if ((keyScalar instanceof $c_Lamf_core_model_domain_AmfScalar)) {
                var x6 = $as_Lamf_core_model_domain_AmfScalar(keyScalar);
                if ((valueLiteral instanceof $c_s_Some)) {
                  var x5 = $as_s_Some(valueLiteral);
                  var valueScalar = $as_Lamf_core_model_domain_AmfElement(x5.value$2);
                  if ((valueScalar instanceof $c_Lamf_core_model_domain_AmfScalar)) {
                    var x7 = $as_Lamf_core_model_domain_AmfScalar(valueScalar);
                    new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position($objectToString(x6.value$1), $objectToString(x7.value$1), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$2);
                    break matchEnd9
                  }
                }
              }
            };
            throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Cannot generate object pair without scalar values for key and value"))
          }
        } else {
          throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Cannot generate object pair with undefined key or value"))
        }
      }
    })
  })(this, b$1)));
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$16 = v.builder$1;
  var array = [key];
  if ((this$16.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$16.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$16, newSize);
  var len$1 = this$16.size0$6;
  var src = this$16.array$6;
  var dest = this$16.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$16.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x$1 = $uI(array.length);
  var x$2 = ((x$1 < len$2) ? x$1 : len$2);
  var that = xs.u.length;
  var end = ((x$2 < that) ? x$2 : that);
  while ((i < end)) {
    var jsx$4 = j;
    var index = i;
    xs.set(jsx$4, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$16.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$5.prototype.init___Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter__T__Lamf_core_model_domain_AmfArray__T__T__s_Option = (function($$outer, key$3, array$2, keyProperty$1, valueProperty$1, annotations$3) {
  this.key$3$1 = key$3;
  this.array$2$1 = array$2;
  this.keyProperty$1$1 = keyProperty$1;
  this.valueProperty$1$1 = valueProperty$1;
  this.annotations$3$1 = annotations$3;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$5.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.annotations$3$1;
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$39 = $as_Lamf_core_parser_Annotations(arg1);
    var this$2 = x$39.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf())
  };
  var this$3 = (this$2.isEmpty__Z() ? this.array$2$1.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()) : this$2);
  if (this$3.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1$1 = this$3.get__O();
    var x$40 = $as_Lamf_core_annotations_LexicalInformation(arg1$1);
    var this$4 = new $c_s_Some().init___O(x$40.range__Lamf_core_parser_Range().start$1)
  };
  return $as_Lamf_core_parser_Position((this$4.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$4.get__O()))
});
var $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$5 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$5: 0
}, false, "amf.plugins.document.vocabularies.emitters.instances.DialectNodeEmitter$$anon$5", {
  Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$5: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$5.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$5;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$1() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$1.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$1.prototype = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$1.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$1.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.$$outer$1.classTerm$1;
  if (($as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().SubClassOf$1)).length__I() === 1)) {
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("extends");
    $m_Lorg_yaml_model_YNode$();
    var this$6 = this.$$outer$1;
    var this$3 = this.$$outer$1.classTerm$1;
    var this$4 = $as_Lamf_core_model_StrField($as_sc_Seq(this$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().SubClassOf$1)).head__O());
    var this$5 = this$4.option$1;
    var id = $as_T((this$5.isEmpty__Z() ? null : this$5.get__O()));
    var aliasMapping = this.$$outer$1.aliasMapping$1;
    var str = $f_Lamf_plugins_document_vocabularies_emitters_vocabularies_AliasMapper__aliasFor__T__sci_Map__T(this$6, id, aliasMapping);
    var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value)
  } else {
    $m_Lorg_yaml_model_YNode$();
    var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("extends");
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$2 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
    var this$10 = this.$$outer$1.classTerm$1;
    $as_sc_Seq(this$10.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().SubClassOf$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, l) {
      return (function(extended$2) {
        var extended = $as_Lamf_core_model_StrField(extended$2);
        var this$12 = $this.$$outer$1;
        var this$11 = extended.option$1;
        var id$1 = $as_T((this$11.isEmpty__Z() ? null : this$11.get__O()));
        var aliasMapping$1 = $this.$$outer$1.aliasMapping$1;
        l.$$plus$eq__T__V($f_Lamf_plugins_document_vocabularies_emitters_vocabularies_AliasMapper__aliasFor__T__sci_Map__T(this$12, id$1, aliasMapping$1))
      })
    })(this, b$1)));
    var jsx$1 = $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YSequence$();
    var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
    var parts = b$1.builder$1;
    var node = jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
    jsx$2.$$plus$eq__O__scm_ArrayBuffer(node);
    var this$16 = v.builder$1;
    var array = [key$1];
    if ((this$16.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$16.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$16, newSize);
    var len$1 = this$16.size0$6;
    var src = this$16.array$6;
    var dest = this$16.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$16.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$3 = j;
      var index = i;
      xs.set(jsx$3, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$16.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$1.prototype.init___Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$1.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.$$outer$1.classTerm$1.fields$1.get__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement($m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().SubClassOf$1).annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$2 = $as_Lamf_core_annotations_LexicalInformation(arg1);
    var this$2 = new $c_s_Some().init___O(x$2.range__Lamf_core_parser_Range().start$1)
  };
  return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
});
var $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$1: 0
}, false, "amf.plugins.document.vocabularies.emitters.vocabularies.ClassTermEmitter$$anon$1", {
  Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$1: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$2() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$2.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$2.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$2;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$2.prototype = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$2.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$2.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("properties");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$2 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  var this$3 = this.$$outer$1.classTerm$1;
  $as_sc_Seq(this$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().Properties$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, l) {
    return (function(prop$2) {
      var prop = $as_Lamf_core_model_StrField(prop$2);
      var this$5 = $this.$$outer$1;
      var this$4 = prop.option$1;
      var id = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
      var aliasMapping = $this.$$outer$1.aliasMapping$1;
      l.$$plus$eq__T__V($f_Lamf_plugins_document_vocabularies_emitters_vocabularies_AliasMapper__aliasFor__T__sci_Map__T(this$5, id, aliasMapping))
    })
  })(this, b$1)));
  var jsx$1 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$2.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$9 = v.builder$1;
  var array = [key];
  if ((this$9.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$9.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$9, newSize);
  var len$1 = this$9.size0$6;
  var src = this$9.array$6;
  var dest = this$9.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$9.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$3 = j;
    var index = i;
    xs.set(jsx$3, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$9.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$2.prototype.init___Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$2.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.$$outer$1.classTerm$1.fields$1.get__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement($m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().SubClassOf$1).annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$4 = $as_Lamf_core_annotations_LexicalInformation(arg1);
    var this$2 = new $c_s_Some().init___O(x$4.range__Lamf_core_parser_Range().start$1)
  };
  return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
});
var $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$2 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$2: 0
}, false, "amf.plugins.document.vocabularies.emitters.vocabularies.ClassTermEmitter$$anon$2", {
  Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$2: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$2.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$2;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$3() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$3.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$3.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$3;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$3() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$3.prototype = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$3.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$3.prototype.init___Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$3.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.$$outer$1.propertyTerm$1;
  if (($as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().SubPropertyOf$1)).size__I() === 1)) {
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("extends");
    $m_Lorg_yaml_model_YNode$();
    var this$6 = this.$$outer$1;
    var this$3 = this.$$outer$1.propertyTerm$1;
    var this$4 = $as_Lamf_core_model_StrField($as_sc_Seq(this$3.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().SubPropertyOf$1)).head__O());
    var this$5 = this$4.option$1;
    var id = $as_T((this$5.isEmpty__Z() ? null : this$5.get__O()));
    var aliasMapping = this.$$outer$1.aliasMapping$1;
    var str = $f_Lamf_plugins_document_vocabularies_emitters_vocabularies_AliasMapper__aliasFor__T__sci_Map__T(this$6, id, aliasMapping);
    var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value)
  } else {
    $m_Lorg_yaml_model_YNode$();
    var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("extends");
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$2 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
    var this$10 = this.$$outer$1.propertyTerm$1;
    $as_sc_Seq(this$10.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().SubPropertyOf$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, l) {
      return (function(extended$2) {
        var extended = $as_Lamf_core_model_StrField(extended$2);
        var this$12 = $this.$$outer$1;
        var this$11 = extended.option$1;
        var id$1 = $as_T((this$11.isEmpty__Z() ? null : this$11.get__O()));
        var aliasMapping$1 = $this.$$outer$1.aliasMapping$1;
        l.$$plus$eq__T__V($f_Lamf_plugins_document_vocabularies_emitters_vocabularies_AliasMapper__aliasFor__T__sci_Map__T(this$12, id$1, aliasMapping$1))
      })
    })(this, b$1)));
    var jsx$1 = $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YSequence$();
    var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
    var parts = b$1.builder$1;
    var node = jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
    jsx$2.$$plus$eq__O__scm_ArrayBuffer(node);
    var this$16 = v.builder$1;
    var array = [key$1];
    if ((this$16.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$16.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$16, newSize);
    var len$1 = this$16.size0$6;
    var src = this$16.array$6;
    var dest = this$16.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$16.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$3 = j;
      var index = i;
      xs.set(jsx$3, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$16.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$3.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.$$outer$1.propertyTerm$1.fields__Lamf_core_parser_Fields().get__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement($m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().SubPropertyOf$1).annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$8 = $as_Lamf_core_annotations_LexicalInformation(arg1);
    var this$2 = new $c_s_Some().init___O(x$8.range__Lamf_core_parser_Range().start$1)
  };
  return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
});
var $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$3 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$3: 0
}, false, "amf.plugins.document.vocabularies.emitters.vocabularies.PropertyTermEmitter$$anon$3", {
  Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$3: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$3.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$3;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$4() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$4.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$4.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$4;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$4() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$4.prototype = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$4.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$4.prototype.init___Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$4.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("range");
  $m_Lorg_yaml_model_YNode$();
  var this$5 = this.$$outer$1;
  var this$2 = this.$$outer$1.propertyTerm$1;
  var this$3 = $as_Lamf_core_model_StrField(this$2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().Range$1));
  var this$4 = this$3.option$1;
  var id = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
  var aliasMapping = this.$$outer$1.aliasMapping$1;
  var str = $f_Lamf_plugins_document_vocabularies_emitters_vocabularies_AliasMapper__aliasFor__T__sci_Map__T(this$5, id, aliasMapping);
  var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value)
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$4.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.$$outer$1.propertyTerm$1.fields__Lamf_core_parser_Fields().get__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement($m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().Range$1).annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$9 = $as_Lamf_core_annotations_LexicalInformation(arg1);
    var this$2 = new $c_s_Some().init___O(x$9.range__Lamf_core_parser_Range().start$1)
  };
  return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
});
var $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$4 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$4: 0
}, false, "amf.plugins.document.vocabularies.emitters.vocabularies.PropertyTermEmitter$$anon$4", {
  Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$4: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$4.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$4;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$10() {
  $c_O.call(this);
  this.$$outer$1 = null;
  this.ordering$4$1 = null;
  this.classTerms$1$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$10.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$10.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$10;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$10() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$10.prototype = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$10.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$10.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("classTerms");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$5 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var jsx$3 = this.ordering$4$1;
  var jsx$2 = this.classTerms$1$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(ct$2) {
      var ct = $as_Lamf_plugins_document_vocabularies_model_domain_ClassTerm(ct$2);
      return new $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter().init___Lamf_plugins_document_vocabularies_model_domain_ClassTerm__Lamf_core_emitter_SpecOrdering__sci_Map(ct, $this.ordering$4$1, $this.$$outer$1.aliasMapping$1)
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  jsx$4.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$3.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))), b$1);
  jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$6 = j;
    var index = i;
    xs.set(jsx$6, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$10.prototype.init___Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter__Lamf_core_emitter_SpecOrdering__sc_Seq = (function($$outer, ordering$4, classTerms$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.ordering$4$1 = ordering$4;
  this.classTerms$1$1 = classTerms$1;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$10.prototype.position__Lamf_core_parser_Position = (function() {
  var jsx$2 = this.classTerms$1$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$28$2) {
      var x$28 = $as_Lamf_plugins_document_vocabularies_model_domain_ClassTerm(x$28$2);
      var this$1 = x$28.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      if (this$1.isEmpty__Z()) {
        return $m_s_None$()
      } else {
        var arg1 = this$1.get__O();
        var x$29 = $as_Lamf_core_annotations_LexicalInformation(arg1);
        return new $c_s_Some().init___O(x$29.range__Lamf_core_parser_Range().start$1)
      }
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  var this$3 = $as_sc_IterableLike(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$30$2) {
      var x$30 = $as_s_Option(x$30$2);
      return x$30.isDefined__Z()
    })
  })(this)));
  if (this$3.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var x = this$3.get__O();
    var this$4 = $as_s_Option(x)
  };
  return $as_Lamf_core_parser_Position((this$4.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$4.get__O()))
});
var $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$10 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$10: 0
}, false, "amf.plugins.document.vocabularies.emitters.vocabularies.VocabularyEmitter$$anon$10", {
  Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$10: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$10.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$10;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$11() {
  $c_O.call(this);
  this.$$outer$1 = null;
  this.ordering$5$1 = null;
  this.propertyTerms$1$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$11.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$11.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$11;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$11() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$11.prototype = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$11.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$11.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("propertyTerms");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$5 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var jsx$3 = this.ordering$5$1;
  var jsx$2 = this.propertyTerms$1$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(pt$2) {
      var pt = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm(pt$2);
      return new $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter().init___Lamf_plugins_document_vocabularies_model_domain_PropertyTerm__Lamf_core_emitter_SpecOrdering__sci_Map(pt, $this.ordering$5$1, $this.$$outer$1.aliasMapping$1)
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  jsx$4.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$3.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))), b$1);
  jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$6 = j;
    var index = i;
    xs.set(jsx$6, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$11.prototype.init___Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter__Lamf_core_emitter_SpecOrdering__sc_Seq = (function($$outer, ordering$5, propertyTerms$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.ordering$5$1 = ordering$5;
  this.propertyTerms$1$1 = propertyTerms$1;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$11.prototype.position__Lamf_core_parser_Position = (function() {
  var jsx$2 = this.propertyTerms$1$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$33$2) {
      var x$33 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm(x$33$2);
      var this$1 = x$33.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      if (this$1.isEmpty__Z()) {
        return $m_s_None$()
      } else {
        var arg1 = this$1.get__O();
        var x$34 = $as_Lamf_core_annotations_LexicalInformation(arg1);
        return new $c_s_Some().init___O(x$34.range__Lamf_core_parser_Range().start$1)
      }
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  var this$3 = $as_sc_IterableLike(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$35$2) {
      var x$35 = $as_s_Option(x$35$2);
      return x$35.isDefined__Z()
    })
  })(this)));
  if (this$3.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var x = this$3.get__O();
    var this$4 = $as_s_Option(x)
  };
  return $as_Lamf_core_parser_Position((this$4.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$4.get__O()))
});
var $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$11 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$11: 0
}, false, "amf.plugins.document.vocabularies.emitters.vocabularies.VocabularyEmitter$$anon$11", {
  Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$11: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$11.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$11;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$5() {
  $c_O.call(this);
  this.$$outer$1 = null;
  this.ordering$2$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$5.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$5.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$5;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$5() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$5.prototype = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$5.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$5.prototype.init___Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter__Lamf_core_emitter_SpecOrdering = (function($$outer, ordering$2) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.ordering$2$1 = ordering$2;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$5.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("external");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$5 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var jsx$3 = this.ordering$2$1;
  var this$3 = this.$$outer$1.vocabulary$1;
  var jsx$2 = $f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(this$3);
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(external$2) {
      var external = $as_Lamf_plugins_document_vocabularies_model_domain_External(external$2);
      return new $c_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter().init___Lamf_plugins_document_vocabularies_model_domain_External__Lamf_core_emitter_SpecOrdering(external, $this.ordering$2$1)
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  jsx$4.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$3.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2))), b$1);
  jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$6 = j;
    var index = i;
    xs.set(jsx$6, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$5.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.$$outer$1.vocabulary$1;
  var jsx$4 = $f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(this$1);
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(e$2) {
      var e = $as_Lamf_plugins_document_vocabularies_model_domain_External(e$2);
      var this$2 = e.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      if (this$2.isEmpty__Z()) {
        return $m_s_None$()
      } else {
        var arg1 = this$2.get__O();
        var x$15 = $as_Lamf_core_annotations_LexicalInformation(arg1);
        return new $c_s_Some().init___O(x$15.range__Lamf_core_parser_Range().start$1)
      }
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike($as_sc_TraversableLike(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$3.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$16$2) {
      var x$16 = $as_s_Option(x$16$2);
      return x$16.isDefined__Z()
    })
  })(this))));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x$17$2) {
      var x$17 = $as_s_Option(x$17$2);
      return $as_Lamf_core_parser_Position(x$17.get__O())
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  var this$5 = $as_sc_TraversableLike($as_sc_SeqLike(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2)).sortBy__F1__s_math_Ordering__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
    return (function(x$18$2) {
      var x$18 = $as_Lamf_core_parser_Position(x$18$2);
      return x$18.line$1
    })
  })(this)), $m_s_math_Ordering$Int$())).headOption__s_Option();
  return $as_Lamf_core_parser_Position((this$5.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$5.get__O()))
});
var $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$5 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$5: 0
}, false, "amf.plugins.document.vocabularies.emitters.vocabularies.VocabularyEmitter$$anon$5", {
  Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$5: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$5.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$5;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$6() {
  $c_O.call(this);
  this.$$outer$1 = null;
  this.ordering$3$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$6.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$6.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$6;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$6() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$6.prototype = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$6.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$6.prototype.init___Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter__Lamf_core_emitter_SpecOrdering = (function($$outer, ordering$3) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.ordering$3$1 = ordering$3;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$6.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("uses");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$5 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var jsx$3 = this.ordering$3$1;
  var this$3 = this.$$outer$1.vocabulary$1;
  var jsx$2 = $as_sc_Seq(this$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Imports$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(vocabularyRef$2) {
      var vocabularyRef = $as_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference(vocabularyRef$2);
      return new $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter().init___Lamf_plugins_document_vocabularies_model_domain_VocabularyReference__Lamf_plugins_document_vocabularies_model_document_Vocabulary__Lamf_core_emitter_SpecOrdering(vocabularyRef, $this.$$outer$1.vocabulary$1, $this.ordering$3$1)
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  jsx$4.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$3.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2))), b$1);
  jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$6 = j;
    var index = i;
    xs.set(jsx$6, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$6.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.$$outer$1.vocabulary$1;
  var jsx$4 = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Imports$1));
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(e$2) {
      var e = $as_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference(e$2);
      var this$2 = e.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      if (this$2.isEmpty__Z()) {
        return $m_s_None$()
      } else {
        var arg1 = this$2.get__O();
        var x$20 = $as_Lamf_core_annotations_LexicalInformation(arg1);
        return new $c_s_Some().init___O(x$20.range__Lamf_core_parser_Range().start$1)
      }
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike($as_sc_TraversableLike(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$3.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$21$2) {
      var x$21 = $as_s_Option(x$21$2);
      return x$21.isDefined__Z()
    })
  })(this))));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x$22$2) {
      var x$22 = $as_s_Option(x$22$2);
      return $as_Lamf_core_parser_Position(x$22.get__O())
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  var this$5 = $as_sc_TraversableLike($as_sc_SeqLike(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2)).sortBy__F1__s_math_Ordering__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
    return (function(x$23$2) {
      var x$23 = $as_Lamf_core_parser_Position(x$23$2);
      return x$23.line$1
    })
  })(this)), $m_s_math_Ordering$Int$())).headOption__s_Option();
  return $as_Lamf_core_parser_Position((this$5.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$5.get__O()))
});
var $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$6 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$6: 0
}, false, "amf.plugins.document.vocabularies.emitters.vocabularies.VocabularyEmitter$$anon$6", {
  Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$6: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$6.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$6;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$7() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$7.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$7.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$7;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$7() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$7.prototype = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$7.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$7.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.$$outer$1.vocabulary$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Base$1));
  var this$3 = this$2.option$1;
  new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("base", $as_T((this$3.isEmpty__Z() ? null : this$3.get__O())), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$7.prototype.init___Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$7.prototype.position__Lamf_core_parser_Position = (function() {
  return $m_Lamf_core_parser_Position$ZERO$()
});
var $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$7 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$7: 0
}, false, "amf.plugins.document.vocabularies.emitters.vocabularies.VocabularyEmitter$$anon$7", {
  Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$7: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$7.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$7;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$8() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$8.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$8.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$8;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$8() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$8.prototype = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$8.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$8.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.$$outer$1.vocabulary$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Name$1));
  var this$3 = this$2.option$1;
  new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("vocabulary", $as_T((this$3.isEmpty__Z() ? null : this$3.get__O())), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$8.prototype.init___Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$8.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.$$outer$1.vocabulary$1.fields$1.get__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Name$1).annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$24 = $as_Lamf_core_annotations_LexicalInformation(arg1);
    var this$2 = new $c_s_Some().init___O(x$24.range__Lamf_core_parser_Range().start$1)
  };
  return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
});
var $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$8 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$8: 0
}, false, "amf.plugins.document.vocabularies.emitters.vocabularies.VocabularyEmitter$$anon$8", {
  Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$8: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$8.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$8;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$9() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$9.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$9.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$9;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$9() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$9.prototype = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$9.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$9.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.$$outer$1.vocabulary$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1));
  var this$3 = this$2.option$1;
  new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("usage", $as_T((this$3.isEmpty__Z() ? null : this$3.get__O())), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$9.prototype.init___Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$9.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.$$outer$1.vocabulary$1.fields$1.get__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Usage$1).annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$25 = $as_Lamf_core_annotations_LexicalInformation(arg1);
    var this$2 = new $c_s_Some().init___O(x$25.range__Lamf_core_parser_Range().start$1)
  };
  return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
});
var $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$9 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$9: 0
}, false, "amf.plugins.document.vocabularies.emitters.vocabularies.VocabularyEmitter$$anon$9", {
  Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$9: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$9.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$9;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$.prototype.apply__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  return new $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$: 0
}, false, "amf.plugins.document.vocabularies.model.domain.DialectDomainElement$", {
  Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$;
var $n_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$() {
  if ((!$n_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$)) {
    $n_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$ = new $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping$.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping$.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping$.prototype.apply__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_DocumentMapping = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  return new $c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_DocumentMapping$: 0
}, false, "amf.plugins.document.vocabularies.model.domain.DocumentMapping$", {
  Lamf_plugins_document_vocabularies_model_domain_DocumentMapping$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping$;
var $n_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping$() {
  if ((!$n_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping$)) {
    $n_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping$ = new $c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping$
}
function $f_Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__withTypeDiscriminator__sci_Map__O($thiz, typesMapping) {
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().TypeDiscriminator$1;
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var a = $as_T(x0$1.$$und1__O());
        var b = $as_T(x0$1.$$und2__O());
        return ((a + "->") + b)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })($thiz));
  var this$1 = $m_sci_Iterable$();
  var bf = this$1.ReusableCBFInstance$2;
  var value = $as_sc_TraversableOnce($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(typesMapping, f, bf)).mkString__T__T(",");
  return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject($thiz, field, value)
}
function $f_Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__typeDiscriminator__sci_Map($thiz) {
  var this$1 = $m_s_Option$().apply__O__s_Option($thiz.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().TypeDiscriminator$1));
  if (this$1.isEmpty__Z()) {
    var this$9 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var disambiguator = $as_T(arg1);
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(disambiguator, ",", 0);
    var z = $m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$());
    var start = 0;
    var end = xs.u.length;
    var z$1 = z;
    var start$1 = start;
    var z$2 = z$1;
    var jsx$1;
    _foldl: while (true) {
      if ((start$1 !== end)) {
        var temp$start = ((1 + start$1) | 0);
        var arg1$1 = z$2;
        var index = start$1;
        var arg2 = xs.get(index);
        var x0$1 = $as_sci_Map(arg1$1);
        var x1$1 = $as_T(arg2);
        var pair = $m_sjsr_RuntimeString$().split__T__T__I__AT(x1$1, "->", 0);
        var self = pair.get(1);
        var y = pair.get(0);
        var temp$z = x0$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, y));
        start$1 = temp$start;
        z$2 = temp$z;
        continue _foldl
      };
      var jsx$1 = z$2;
      break
    };
    var this$9 = new $c_s_Some().init___O($as_sci_Map(jsx$1))
  };
  return $as_sci_Map((this$9.isEmpty__Z() ? null : this$9.get__O()))
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$.prototype.apply__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  return new $c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$: 0
}, false, "amf.plugins.document.vocabularies.model.domain.PropertyMapping$", {
  Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$;
var $n_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$() {
  if ((!$n_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$)) {
    $n_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$ = new $c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping$.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping$.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping$.prototype.apply__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  return new $c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping$: 0
}, false, "amf.plugins.document.vocabularies.model.domain.PublicNodeMapping$", {
  Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping$;
var $n_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping$() {
  if ((!$n_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping$)) {
    $n_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping$ = new $c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$.prototype.apply__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  return new $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$: 0
}, false, "amf.plugins.document.vocabularies.model.domain.UnionNodeMapping$", {
  Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$;
var $n_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$() {
  if ((!$n_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$)) {
    $n_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$ = new $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations() {
  $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations.call(this);
  this.ErrorNodeMapabble$module$3 = null;
  this.nodeMappings$3 = null;
  this.errorHandler$3 = null;
  this.futureDeclarations$3 = null
}
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations.prototype = new $h_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations();
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations.prototype = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations.prototype;
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations.prototype.getOrCreateLibrary__T__Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations = (function(alias) {
  return this.getOrCreateLibrary__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations(alias)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations.prototype.$$plus$eq__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations = (function(nodeMapping) {
  var jsx$1 = this.nodeMappings$3;
  var this$1 = $as_Lamf_core_model_StrField(nodeMapping.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(nodeMapping.Name__Lamf_core_metamodel_Field()));
  var this$2 = this$1.option$1;
  var self = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  this.nodeMappings$3 = jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, nodeMapping));
  if ((!nodeMapping.isUnresolved__Z())) {
    var this$7 = this.futureDeclarations$3;
    var this$5 = $as_Lamf_core_model_StrField(nodeMapping.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(nodeMapping.Name__Lamf_core_metamodel_Field()));
    var this$6 = this$5.option$1;
    var name = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
    $f_Lamf_core_parser_FutureDeclarations__resolveRef__T__Lamf_core_model_domain_Linkable__V(this$7, name, nodeMapping)
  };
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations.prototype.findNodeMapping__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, scope) {
  var this$1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_parser_Declarations(x$1$2);
      return $as_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations(x$1).nodeMappings$3
    })
  })(this)), scope);
  var pf = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$$anonfun$findNodeMapping$2().init___Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations(this);
  if ((!this$1.isEmpty__Z())) {
    var this$2 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$1.get__O();
    return this$2.apply__O__s_Option(v1)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations.prototype.findClassTerm__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, scope) {
  var x1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_parser_Declarations(x$2$2);
      return $as_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations(x$2).classTerms$2
    })
  })(this)), scope);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var ct = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    if ((ct instanceof $c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm)) {
      var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_ClassTerm(ct);
      return new $c_s_Some().init___O(x3)
    }
  };
  var this$1 = this.resolveExternal__T__s_Option(key);
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$3 = $as_T(arg1);
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var this$5 = new $c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
    return new $c_s_Some().init___O($as_Lamf_plugins_document_vocabularies_model_domain_ClassTerm($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, x$3)))
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations.prototype.declarables__sc_Seq = (function() {
  var this$1 = this.nodeMappings$3;
  var this$2 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$1);
  return this$2.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream()
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations.prototype.registerNodeMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations = (function(nodeMapping) {
  var jsx$1 = this.nodeMappings$3;
  var this$1 = $as_Lamf_core_model_StrField(nodeMapping.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(nodeMapping.Name__Lamf_core_metamodel_Field()));
  var this$2 = this$1.option$1;
  var self = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  this.nodeMappings$3 = jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, nodeMapping));
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations.prototype.getOrCreateLibrary__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations = (function(alias) {
  var x1 = this.libraries$1.get__O__s_Option(alias);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var lib = $as_Lamf_core_parser_Declarations(x2.value$2);
    if ((lib instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations)) {
      var x3 = $as_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations(lib);
      return x3
    }
  };
  var x$1 = this.errorHandler$3;
  var x$2 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
  var x$3 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var result = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations().init___sci_Map__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations(x$3, x$1, x$2);
  this.libraries$1 = this.libraries$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(alias, result));
  return result
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations.prototype.findPropertyTerm__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, scope) {
  var x1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$4$2) {
      var x$4 = $as_Lamf_core_parser_Declarations(x$4$2);
      return $as_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations(x$4).propertyTerms$2
    })
  })(this)), scope);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var pt = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    if ((pt instanceof $c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm)) {
      var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm(pt);
      return new $c_s_Some().init___O(x3)
    }
  };
  var this$1 = this.resolveExternal__T__s_Option(key);
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$5 = $as_T(arg1);
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var this$5 = new $c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
    return new $c_s_Some().init___O($as_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, x$5)))
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations.prototype.init___sci_Map__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations = (function(nodeMappings, errorHandler, futureDeclarations) {
  this.nodeMappings$3 = nodeMappings;
  this.errorHandler$3 = errorHandler;
  this.futureDeclarations$3 = futureDeclarations;
  $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations.prototype.init___sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations.call(this, $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())), errorHandler, futureDeclarations);
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations.prototype.findNodeMappingOrError__Lorg_yaml_model_YPart__T__Lamf_core_parser_SearchScope$Scope__Lamf_plugins_document_vocabularies_model_domain_NodeMappable = (function(ast, key, scope) {
  var x1 = this.findNodeMapping__T__Lamf_core_parser_SearchScope$Scope__s_Option(key, scope);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var result = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x2.value$2);
    return result
  } else {
    this.error__T__Lorg_yaml_model_YPart__V((("NodeMappable " + key) + " not found"), ast);
    return new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble().init___Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations__T__Lorg_yaml_model_YPart(this, key, ast)
  }
});
function $as_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.parser.dialects.DialectDeclarations"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.parser.dialects.DialectDeclarations;", depth))
}
var $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations: 0
}, false, "amf.plugins.document.vocabularies.parser.dialects.DialectDeclarations", {
  Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations: 1,
  Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations: 1,
  Lamf_core_parser_Declarations: 1,
  O: 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser() {
  $c_O.call(this);
  this.root$1 = null;
  this.ctx$1 = null;
  this.map$1 = null;
  this.dialect$1 = null
}
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype;
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype.validateTemplate__T__Lorg_yaml_model_YMap__sc_Seq__V = (function(template, map, propMappings) {
  var this$2 = new $c_sci_StringOps().init___T("(\\{[^}]+\\})");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  var regex = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  var this$4 = regex.findAllIn__jl_CharSequence__s_util_matching_Regex$MatchIterator(template);
  while (this$4.hasNext__Z()) {
    var arg1 = this$4.next__T();
    var thiz = $as_T(arg1.split("{").join(""));
    var variable = $as_T(thiz.split("}").join(""));
    var x1 = propMappings.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, variable$1) {
      return (function(x$20$2) {
        var x$20 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$20$2);
        var this$9 = $as_Lamf_core_model_StrField(x$20.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
        var this$10 = this$9.option$1;
        return ($as_T((this$10.isEmpty__Z() ? null : this$10.get__O())) === variable$1)
      })
    })(this, variable)));
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var prop = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x2.value$2);
      var this$11 = $as_Lamf_core_model_IntField(prop.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MinCount$1)).option$1;
      if (($uI((this$11.isEmpty__Z() ? 0 : this$11.get__O())) !== 1)) {
        var this$12 = this.ctx$1.eh$1;
        var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
        var node = prop.id$1;
        var message = (("PropertyMapping for idTemplate variable '" + variable) + "' must be mandatory");
        var prop$1 = $m_s_None$();
        var l = map.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$12, specification, node, prop$1, message, l)
      }
    } else {
      var x = $m_s_None$();
      if ((x === x1)) {
        var this$13 = this.ctx$1.eh$1;
        var specification$1 = $m_Lamf_validation_DialectValidations$().DialectError$1;
        var message$1 = (("Missing propertyMapping for idTemplate variable '" + variable) + "'");
        var prop$2 = $m_s_None$();
        var l$1 = map.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$13, specification$1, "", prop$2, message$1, l$1)
      } else {
        throw new $c_s_MatchError().init___O(x1)
      }
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype.checkNodeMappableReferences__Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__V = (function(mappable) {
  var jsx$5 = $as_sc_Seq(mappable.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, mappable$1) {
    return (function(nodeMappingRef$2) {
      var nodeMappingRef = $as_Lamf_core_model_StrField(nodeMappingRef$2);
      var this$1 = nodeMappingRef.option$1;
      var jsx$2 = $as_T((this$1.isEmpty__Z() ? null : this$1.get__O()));
      var this$2 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
      if ((jsx$2 === new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$2, "anyNode").iri__T())) {
        var this$4 = nodeMappingRef.option$1;
        return new $c_s_Some().init___O($as_T((this$4.isEmpty__Z() ? null : this$4.get__O())))
      } else {
        var rc6 = false;
        var x2 = null;
        var jsx$3 = $this.ctx$1.declarations$2;
        var this$5 = nodeMappingRef.option$1;
        var x1 = jsx$3.findNodeMapping__T__Lamf_core_parser_SearchScope$Scope__s_Option($as_T((this$5.isEmpty__Z() ? null : this$5.get__O())), $m_Lamf_core_parser_SearchScope$All$());
        if ((x1 instanceof $c_s_Some)) {
          rc6 = true;
          x2 = $as_s_Some(x1);
          var mapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x2.value$2);
          if ((mapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
            var x4 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(mapping);
            if ((mappable$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping)) {
              $this.updateMapLabelReferences__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__V($as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(mappable$1), x4);
              return new $c_s_Some().init___O(x4.id$1)
            }
          }
        };
        if (rc6) {
          var mapping$2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x2.value$2);
          return new $c_s_Some().init___O(mapping$2.id__T())
        };
        var jsx$4 = $this.ctx$1;
        var this$6 = nodeMappingRef.option$1;
        var x1$2 = jsx$4.findInRecursiveShapes__T__s_Option($as_T((this$6.isEmpty__Z() ? null : this$6.get__O())));
        if ((x1$2 instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(x1$2);
          var recursiveId = $as_T(x2$2.value$2);
          return new $c_s_Some().init___O(recursiveId)
        } else {
          var this$10 = $this.ctx$1;
          var this$7 = nodeMappingRef.option$1;
          var term = $as_T((this$7.isEmpty__Z() ? null : this$7.get__O()));
          var node = mappable$1.id__T();
          var this$8 = mappable$1.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().ObjectRange$1);
          if (this$8.isEmpty__Z()) {
            var this$9 = $m_s_None$()
          } else {
            var arg1 = this$8.get__O();
            var x$11 = $as_Lamf_core_parser_FieldEntry(arg1);
            var this$9 = new $c_s_Some().init___O(x$11.value$1.annotations$1)
          };
          var annotations = $as_Lamf_core_parser_Annotations((this$9.isEmpty__Z() ? mappable$1.annotations__Lamf_core_parser_Annotations() : this$9.get__O()));
          $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__missingPropertyRangeViolation__T__T__Lamf_core_parser_Annotations__V(this$10, term, node, annotations);
          return $m_s_None$()
        }
      }
    })
  })(this, mappable));
  var this$11 = $m_sc_Seq$();
  var mapped = $as_sc_Seq(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$1, this$11.ReusableCBFInstance$2));
  var jsx$6 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser$$anonfun$1().init___Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser(this);
  var this$12 = $m_sc_Seq$();
  var refs = $as_sc_Seq(mapped.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$6, this$12.ReusableCBFInstance$2));
  if (refs.nonEmpty__Z()) {
    var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1;
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(mappable, field, refs)
  };
  var x1$1 = $m_s_Option$().apply__O__s_Option($f_Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__typeDiscriminator__sci_Map(mappable));
  if ((x1$1 instanceof $c_s_Some)) {
    var x2$1 = $as_s_Some(x1$1);
    var typeDiscriminators = $as_sci_Map(x2$1.value$2);
    var z = $m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$());
    var op = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$2$1, mappable$2) {
      return (function(x0$1$2, x1$1$2) {
        var x0$1 = $as_sci_Map(x0$1$2);
        var x1$1$1 = $as_T2(x1$1$2);
        var x1$3 = new $c_T2().init___O__O(x0$1, x1$1$1);
        var acc = $as_sci_Map(x1$3.$$und1$f);
        var p2 = $as_T2(x1$3.$$und2$f);
        if ((p2 !== null)) {
          var nodeMappingRef$1 = $as_T(p2.$$und1__O());
          var alias = $as_T(p2.$$und2__O());
          var x1$2$1 = this$2$1.ctx$1.declarations$2.findNodeMapping__T__Lamf_core_parser_SearchScope$Scope__s_Option(nodeMappingRef$1, $m_Lamf_core_parser_SearchScope$All$());
          if ((x1$2$1 instanceof $c_s_Some)) {
            var x2$3 = $as_s_Some(x1$2$1);
            var mapping$1 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x2$3.value$2);
            return acc.updated__O__O__sci_Map(mapping$1.id__T(), alias)
          } else {
            var this$15 = this$2$1.ctx$1;
            var node$1 = mappable$2.id__T();
            var this$13 = mappable$2.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().TypeDiscriminator$1);
            if (this$13.isEmpty__Z()) {
              var this$14 = $m_s_None$()
            } else {
              var arg1$1 = this$13.get__O();
              var x$12 = $as_Lamf_core_parser_FieldEntry(arg1$1);
              var this$14 = new $c_s_Some().init___O(x$12.value$1.annotations$1)
            };
            var annotations$1 = $as_Lamf_core_parser_Annotations((this$14.isEmpty__Z() ? mappable$2.annotations__Lamf_core_parser_Annotations() : this$14.get__O()));
            $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__missingPropertyRangeViolation__T__T__Lamf_core_parser_Annotations__V(this$15, nodeMappingRef$1, node$1, annotations$1);
            return acc
          }
        };
        throw new $c_s_MatchError().init___O(x1$3)
      })
    })(this, mappable));
    var mapped$2 = $as_sci_Map($f_sc_TraversableOnce__foldLeft__O__F2__O(typeDiscriminators, z, op));
    $f_Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__withTypeDiscriminator__sci_Map__O(mappable, mapped$2)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext = (function(root, ctx) {
  this.root$1 = root;
  this.ctx$1 = ctx;
  var this$1 = $as_Lamf_core_parser_SyamlParsedDocument(root.parsed$1).document$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  this.map$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, ctx));
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.map$1);
  var this$4 = new $c_Lamf_plugins_document_vocabularies_model_document_Dialect().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var location = root.location$1;
  var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
  var this$5 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, location));
  var value = root.location$1;
  this.dialect$1 = $as_Lamf_plugins_document_vocabularies_model_document_Dialect($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype.parseDocument__Lamf_core_model_document_BaseUnit = (function() {
  var map = this.map$1;
  var jsx$1 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map);
  var target = this.dialect$1;
  var ctx = this.ctx$1;
  jsx$1.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("dialect", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(target, ctx).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Name$1));
  var map$1 = this.map$1;
  var jsx$2 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$1);
  var target$1 = this.dialect$1;
  var ctx$1 = this.ctx$1;
  jsx$2.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("usage", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(target$1, ctx$1).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Usage$1));
  var map$2 = this.map$1;
  var jsx$3 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$2);
  var target$2 = this.dialect$1;
  var ctx$2 = this.ctx$1;
  jsx$3.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("version", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(target$2, ctx$2).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Version$1));
  var this$7 = this.ctx$1;
  var id = this.dialect$1.id$1;
  var map$3 = this.map$1;
  $f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__closedNode__T__T__Lorg_yaml_model_YMap__V(this$7, "dialect", id, map$3);
  var jsx$4 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser().init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lorg_yaml_model_YMap__sc_Seq__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(this.dialect$1, this.map$1, this.root$1.references$1, this.ctx$1);
  var this$8 = this.dialect$1;
  var this$9 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$8);
  var references = jsx$4.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations($as_T((this$9.isEmpty__Z() ? this.dialect$1.id$1 : this$9.get__O())));
  var this$10 = this.ctx$1.declarations$2.externals$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$10)) {
    var this$13 = this.dialect$1;
    var this$11 = this.ctx$1.declarations$2.externals$2;
    var this$12 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$11);
    var externals = this$12.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream();
    var field = $m_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$().Externals$1;
    $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$13, field, externals)
  };
  this.parseDeclarations__Lamf_core_Root__Lorg_yaml_model_YMap__V(this.root$1, this.map$1);
  var declarables = this.ctx$1.declarations$2.declarables__sc_Seq();
  declarables.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_domain_DomainElement(x0$1$2);
      if ((x0$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping)) {
        var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(x0$1);
        this$2$1.checkNodeMappableReferences__Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__V(x2)
      } else if ((x0$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
        var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x0$1);
        $as_sc_Seq(x3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(propertyMapping$2) {
            var propertyMapping = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(propertyMapping$2);
            $this.checkNodeMappableReferences__Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__V(propertyMapping)
          })
        })(this$2$1)))
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this)));
  if (declarables.nonEmpty__Z()) {
    var this$14 = this.dialect$1;
    var field$1 = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
    $as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$14, field$1, declarables))
  };
  if (references.baseUnitReferences__sc_Seq().nonEmpty__Z()) {
    var this$15 = this.dialect$1;
    var references$1 = references.baseUnitReferences__sc_Seq();
    var field$2 = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
    $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$15, field$2, references$1))
  };
  this.parseDocumentsMapping__p1__Lorg_yaml_model_YMap__V(this.map$1);
  var this$16 = this.dialect$1;
  $as_sc_Seq(this$16.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Declares$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x0$2$2) {
      var x0$2 = $as_Lamf_core_model_domain_DomainElement(x0$2$2);
      if ((x0$2 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
        var x2$1 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x0$2);
        if ((!x2$1.isUnresolved$1)) {
          var this$19 = this$3$1.ctx$1.futureDeclarations$1;
          var this$17 = $as_Lamf_core_model_StrField(x2$1.fields$1.field__Lamf_core_metamodel_Field__O(x2$1.Name$1));
          var this$18 = this$17.option$1;
          var name = $as_T((this$18.isEmpty__Z() ? null : this$18.get__O()));
          $f_Lamf_core_parser_FutureDeclarations__resolveRef__T__Lamf_core_model_domain_Linkable__V(this$19, name, x2$1)
        }
      }
    })
  })(this)));
  var this$20 = this.ctx$1.futureDeclarations$1;
  $f_Lamf_core_parser_FutureDeclarations__resolve__V(this$20);
  return this.dialect$1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype.parseLibrary__Lamf_core_model_document_BaseUnit = (function() {
  var map = this.map$1;
  var jsx$1 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map);
  var target = this.dialect$1;
  var ctx = this.ctx$1;
  jsx$1.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("usage", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(target, ctx).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Usage$1));
  var this$3 = this.ctx$1;
  var id = this.dialect$1.id$1;
  var map$1 = this.map$1;
  $f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__closedNode__T__T__Lorg_yaml_model_YMap__V(this$3, "library", id, map$1);
  var jsx$2 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser().init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lorg_yaml_model_YMap__sc_Seq__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(this.dialect$1, this.map$1, this.root$1.references$1, this.ctx$1);
  var this$4 = this.dialect$1;
  var this$5 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$4);
  var references = jsx$2.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations($as_T((this$5.isEmpty__Z() ? this.dialect$1.id$1 : this$5.get__O())));
  var this$6 = this.ctx$1.declarations$2.externals$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$6)) {
    var this$9 = this.dialect$1;
    var this$7 = this.ctx$1.declarations$2.externals$2;
    var this$8 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$7);
    var externals = this$8.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream();
    var field = $m_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$().Externals$1;
    $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$9, field, externals)
  };
  this.parseDeclarations__Lamf_core_Root__Lorg_yaml_model_YMap__V(this.root$1, this.map$1);
  var declarables = this.ctx$1.declarations$2.declarables__sc_Seq();
  declarables.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_domain_DomainElement(x0$1$2);
      if ((x0$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping)) {
        var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(x0$1);
        this$2$1.checkNodeMappableReferences__Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__V(x2)
      } else if ((x0$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
        var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x0$1);
        $as_sc_Seq(x3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(propertyMapping$2) {
            var propertyMapping = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(propertyMapping$2);
            $this.checkNodeMappableReferences__Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__V(propertyMapping)
          })
        })(this$2$1)))
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this)));
  if (declarables.nonEmpty__Z()) {
    var this$10 = this.dialect$1;
    var field$1 = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
    $as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$10, field$1, declarables))
  };
  if (references.baseUnitReferences__sc_Seq().nonEmpty__Z()) {
    var this$11 = this.dialect$1;
    var references$1 = references.baseUnitReferences__sc_Seq();
    var field$2 = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
    $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$11, field$2, references$1))
  };
  var this$12 = this.dialect$1;
  $as_sc_Seq(this$12.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Declares$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x0$2$2) {
      var x0$2 = $as_Lamf_core_model_domain_DomainElement(x0$2$2);
      if ((x0$2 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
        var x2$1 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x0$2);
        if ((!x2$1.isUnresolved$1)) {
          var this$15 = this$3$1.ctx$1.futureDeclarations$1;
          var this$13 = $as_Lamf_core_model_StrField(x2$1.fields$1.field__Lamf_core_metamodel_Field__O(x2$1.Name$1));
          var this$14 = this$13.option$1;
          var name = $as_T((this$14.isEmpty__Z() ? null : this$14.get__O()));
          $f_Lamf_core_parser_FutureDeclarations__resolveRef__T__Lamf_core_model_domain_Linkable__V(this$15, name, x2$1)
        }
      }
    })
  })(this)));
  var this$16 = this.ctx$1.futureDeclarations$1;
  $f_Lamf_core_parser_FutureDeclarations__resolve__V(this$16);
  return this.toLibrary__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_plugins_document_vocabularies_model_document_DialectLibrary(this.dialect$1)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype.parseDocumentsMapping__p1__Lorg_yaml_model_YMap__V = (function(map) {
  var this$2 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("documents");
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$3 = e.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$1;
    var jsx$3 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv));
    var jsx$2 = this.dialect$1.id$1;
    var this$4 = this.dialect$1;
    var this$5 = $as_Lamf_core_model_StrField(this$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Name$1));
    var this$6 = this$5.option$1;
    var jsx$1 = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
    var this$7 = this.dialect$1;
    var this$8 = $as_Lamf_core_model_StrField(this$7.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Version$1));
    var this$9 = this$8.option$1;
    var doc = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser().init___Lorg_yaml_model_YMap__T__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(jsx$3, jsx$2, ((jsx$1 + " ") + $as_T((this$9.isEmpty__Z() ? null : this$9.get__O()))), this.ctx$1).parse__Lamf_plugins_document_vocabularies_model_domain_DocumentsModel();
    var this$10 = this.dialect$1;
    var field = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1;
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(e);
    $as_Lamf_plugins_document_vocabularies_model_document_Dialect($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$10, field, doc, annotations))
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype.updateMapLabelReferences__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__V = (function(propertyMapping, range) {
  this.updateKeyMapReferences__p1__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__V(propertyMapping, range);
  this.updateValueMapReferences__p1__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__V(propertyMapping, range)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype.parseMapKey__p1__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__V = (function(map, propertyMapping) {
  var mapKey = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("mapKey");
  var mapTermKey = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("mapTermKey");
  if ((!mapKey.isEmpty__Z())) {
    var arg1 = mapKey.get__O();
    $as_Lorg_yaml_model_YMapEntry(arg1);
    if (mapTermKey.isEmpty__Z()) {
      /*<skip>*/
    } else {
      var arg1$1 = mapTermKey.get__O();
      $as_Lorg_yaml_model_YMapEntry(arg1$1);
      var this$3 = this.ctx$1.eh$1;
      var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
      var node = propertyMapping.id$1;
      var prop = $m_s_None$();
      var l = map.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$3, specification, node, prop, "mapKey and mapTermKey are mutually exclusive", l);
      new $c_s_Some().init___O((void 0))
    }
  };
  if (mapTermKey.isEmpty__Z()) {
    if ((!mapKey.isEmpty__Z())) {
      var arg1$2 = mapKey.get__O();
      var entry = $as_Lorg_yaml_model_YMapEntry(arg1$2);
      var propertyLabel = new $c_Lamf_core_parser_ValueNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(entry.value$2, this.ctx$1).string__Lamf_core_model_domain_AmfScalar().toString__T();
      var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapKeyProperty$1;
      $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field, propertyLabel))
    }
  } else {
    var arg1$3 = mapTermKey.get__O();
    var entry$1 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
    var propertyTermId = new $c_Lamf_core_parser_ValueNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(entry$1.value$2, this.ctx$1).string__Lamf_core_model_domain_AmfScalar().toString__T();
    var this$4 = this.getTermIfValid__p1__T__T__Lorg_yaml_model_YPart__s_Option(propertyTermId, propertyMapping.id$1, entry$1.value$2);
    if ((!this$4.isEmpty__Z())) {
      var arg1$4 = this$4.get__O();
      var key = $as_T(arg1$4);
      var field$1 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermKeyProperty$1;
      $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$1, key))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype.toLibrary__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_plugins_document_vocabularies_model_document_DialectLibrary = (function(dialect) {
  var annotations = dialect.annotations$1;
  var this$3 = new $c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = dialect.id$1;
  var this$5 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$3, value));
  var this$4 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(dialect);
  var location = $as_T((this$4.isEmpty__Z() ? dialect.id$1 : this$4.get__O()));
  var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
  var this$6 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$5, field, location));
  var references = $as_sc_Seq(dialect.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().References$1));
  var field$1 = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
  var library = $as_Lamf_plugins_document_vocabularies_model_document_DialectLibrary($as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$6, field$1, references)));
  var this$7 = $as_Lamf_core_model_StrField(dialect.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1)).option$1;
  if ((!this$7.isEmpty__Z())) {
    var arg1 = this$7.get__O();
    var usage = $as_T(arg1);
    var field$2 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1;
    $as_Lamf_plugins_document_vocabularies_model_document_DialectLibrary($as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(library, field$2, usage)))
  };
  var declares = $as_sc_Seq(dialect.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Declares$1));
  if (declares.nonEmpty__Z()) {
    var field$3 = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
    $as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(library, field$3, declares))
  };
  var externals = $f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(dialect);
  if (externals.nonEmpty__Z()) {
    var field$4 = $m_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$().Externals$1;
    $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(library, field$4, externals)
  };
  return library
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype.toFragment__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_plugins_document_vocabularies_model_document_DialectFragment = (function(dialect) {
  var annotations = dialect.annotations$1;
  var this$3 = new $c_Lamf_plugins_document_vocabularies_model_document_DialectFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = dialect.id$1;
  var this$5 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$3, value));
  var this$4 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(dialect);
  var location = $as_T((this$4.isEmpty__Z() ? dialect.id$1 : this$4.get__O()));
  var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
  var this$6 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$5, field, location));
  var references = $as_sc_Seq(dialect.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().References$1));
  var field$1 = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
  var fragment = $as_Lamf_plugins_document_vocabularies_model_document_DialectFragment($as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$6, field$1, references)));
  var this$7 = $as_Lamf_core_model_StrField(dialect.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1)).option$1;
  if ((!this$7.isEmpty__Z())) {
    var arg1 = this$7.get__O();
    var usage = $as_T(arg1);
    var field$2 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1;
    $as_Lamf_plugins_document_vocabularies_model_document_DialectFragment($as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(fragment, field$2, usage)))
  };
  var externals = $f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(dialect);
  if (externals.nonEmpty__Z()) {
    var externals$1 = $f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(dialect);
    var field$3 = $m_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$().Externals$1;
    $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(fragment, field$3, externals$1)
  };
  return fragment
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype.parseMapValue__p1__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__V = (function(map, propertyMapping) {
  var mapValu = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("mapValue");
  var mapTermValue = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("mapTermValue");
  if ((!mapValu.isEmpty__Z())) {
    var arg1 = mapValu.get__O();
    $as_Lorg_yaml_model_YMapEntry(arg1);
    if (mapTermValue.isEmpty__Z()) {
      /*<skip>*/
    } else {
      var arg1$1 = mapTermValue.get__O();
      $as_Lorg_yaml_model_YMapEntry(arg1$1);
      var this$3 = this.ctx$1.eh$1;
      var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
      var node = propertyMapping.id$1;
      var prop = $m_s_None$();
      var l = map.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$3, specification, node, prop, "mapValue and mapTermValue are mutually exclusive", l);
      new $c_s_Some().init___O((void 0))
    }
  };
  if (mapTermValue.isEmpty__Z()) {
    if ((!mapValu.isEmpty__Z())) {
      var arg1$2 = mapValu.get__O();
      var entry = $as_Lorg_yaml_model_YMapEntry(arg1$2);
      var propertyLabel = new $c_Lamf_core_parser_ValueNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(entry.value$2, this.ctx$1).string__Lamf_core_model_domain_AmfScalar().toString__T();
      var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapValueProperty$1;
      $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field, propertyLabel))
    }
  } else {
    var arg1$3 = mapTermValue.get__O();
    var entry$1 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
    var propertyTermId = new $c_Lamf_core_parser_ValueNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(entry$1.value$2, this.ctx$1).string__Lamf_core_model_domain_AmfScalar().toString__T();
    var this$4 = this.getTermIfValid__p1__T__T__Lorg_yaml_model_YPart__s_Option(propertyTermId, propertyMapping.id$1, entry$1.value$2);
    if ((!this$4.isEmpty__Z())) {
      var arg1$4 = this$4.get__O();
      var value = $as_T(arg1$4);
      var field$1 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermValueProperty$1;
      $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$1, value))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype.updateKeyMapReferences__p1__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__V = (function(propertyMapping, range) {
  var this$1 = $as_Lamf_core_model_StrField(propertyMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapKeyProperty$1)).option$1;
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var label = $as_T(arg1);
    var x1 = $as_sc_Seq(range.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, label$1) {
      return (function(x$14$2) {
        var x$14 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$14$2);
        var this$2 = $as_Lamf_core_model_StrField(x$14.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
        var this$3 = this$2.option$1;
        return ($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())) === label$1)
      })
    })(this, label)));
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var property = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x2.value$2);
      var this$4 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1)).option$1;
      if (this$4.isEmpty__Z()) {
        var this$5 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
        var jsx$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$5, label).iri__T()
      } else {
        var jsx$1 = this$4.get__O()
      };
      var term = $as_T(jsx$1);
      var x1$2 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermKeyProperty$1)).option$1;
      matchEnd4: {
        if ((x1$2 instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(x1$2);
          var actualTerm = $as_T(x2$2.value$2);
          if ((term !== actualTerm)) {
            propertyMapping.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermKeyProperty$1);
            propertyMapping.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapKeyProperty$1);
            var this$7 = this.ctx$1;
            var node = propertyMapping.id$1;
            var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapKeyProperty$1.value$1.iri__T();
            var annotations = $as_Lamf_core_model_StrField(propertyMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapKeyProperty$1)).annotations$1;
            $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__differentTermsInMapKey__T__T__T__Lamf_core_parser_Annotations__V(this$7, node, field, label, annotations);
            break matchEnd4
          }
        };
        var field$1 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermKeyProperty$1;
        $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$1, term))
      }
    } else {
      propertyMapping.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapKeyProperty$1);
      var this$8 = this.ctx$1;
      var node$1 = propertyMapping.id$1;
      var field$2 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapKeyProperty$1.value$1.iri__T();
      var annotations$1 = $as_Lamf_core_model_StrField(propertyMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapKeyProperty$1)).annotations$1;
      $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__missingPropertyKeyViolation__T__T__T__Lamf_core_parser_Annotations__V(this$8, node$1, field$2, label, annotations$1)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype.parseDeclarations__Lamf_core_Root__Lorg_yaml_model_YMap__V = (function(root, map) {
  var parent = (root.location$1 + "#/declarations");
  this.parseNodeMappingDeclarations__p1__Lorg_yaml_model_YMap__T__V(map, parent)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype.updateValueMapReferences__p1__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__V = (function(propertyMapping, range) {
  var this$1 = $as_Lamf_core_model_StrField(propertyMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapValueProperty$1)).option$1;
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var label = $as_T(arg1);
    var x1 = $as_sc_Seq(range.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, label$1) {
      return (function(x$13$2) {
        var x$13 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$13$2);
        var this$2 = $as_Lamf_core_model_StrField(x$13.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
        var this$3 = this$2.option$1;
        return ($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())) === label$1)
      })
    })(this, label)));
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var property = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x2.value$2);
      var this$4 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1)).option$1;
      if (this$4.isEmpty__Z()) {
        var this$5 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
        var jsx$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$5, label).iri__T()
      } else {
        var jsx$1 = this$4.get__O()
      };
      var term = $as_T(jsx$1);
      var x1$2 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermValueProperty$1)).option$1;
      matchEnd4: {
        if ((x1$2 instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(x1$2);
          var actualTerm = $as_T(x2$2.value$2);
          if ((term !== actualTerm)) {
            property.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermValueProperty$1);
            propertyMapping.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapValueProperty$1);
            var this$7 = this.ctx$1;
            var node = propertyMapping.id$1;
            var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapValueProperty$1.value$1.iri__T();
            var annotations = $as_Lamf_core_model_StrField(propertyMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapValueProperty$1)).annotations$1;
            $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__differentTermsInMapKey__T__T__T__Lamf_core_parser_Annotations__V(this$7, node, field, label, annotations);
            break matchEnd4
          }
        };
        var field$1 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermValueProperty$1;
        $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$1, term))
      }
    } else {
      propertyMapping.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapValueProperty$1);
      var this$8 = this.ctx$1;
      var node$1 = propertyMapping.id$1;
      var field$2 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapValueProperty$1.value$1.iri__T();
      var annotations$1 = $as_Lamf_core_model_StrField(propertyMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapValueProperty$1)).annotations$1;
      $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__missingPropertyKeyViolation__T__T__T__Lamf_core_parser_Annotations__V(this$8, node$1, field$2, label, annotations$1)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype.parseNodeMappingDeclarations__p1__Lorg_yaml_model_YMap__T__V = (function(map, parent) {
  var this$2 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("nodeMappings");
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$3 = e.value$2;
    var x1 = this$3.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x === x1)) {
      var this$4 = e.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = this.ctx$1;
      $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$1) {
        return (function(entry$2) {
          var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
          var rc7 = false;
          var x2 = null;
          var f = (function($this$1, entry$1, parent$1$1) {
            return (function(x0$1$2) {
              var x0$1 = $as_Lamf_core_model_domain_DomainElement(x0$1$2);
              if ($is_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x0$1)) {
                var x2$1 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x0$1);
                var node = entry$1.key$2;
                var iv$1 = $this$1.ctx$1;
                var this$6 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv$1);
                var name = this$6.string__Lamf_core_model_domain_AmfScalar();
                var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().Name$1;
                var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$1.key$2);
                var qual$1 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(x2$1, field, name, annotations));
                $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
                return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, parent$1$1)
              } else {
                var this$7 = $this$1.ctx$1.eh$1;
                var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
                var prop = $m_s_None$();
                var l = entry$1.location$1;
                $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$7, specification, parent$1$1, prop, "Error only valid node mapping or union mapping can be declared", l);
                return $m_s_None$()
              }
            })
          })($this, entry, parent$1);
          var this$8 = entry.value$2;
          var x1$1 = this$8.tag__Lorg_yaml_model_YTag().tagType$3;
          var x$1 = $m_Lorg_yaml_model_YType$().Map$1;
          if ((x$1 === x1$1)) {
            var this$9 = entry.value$2;
            var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
            var iv$2 = $this.ctx$1;
            var map$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$9, conversion$1, iv$2));
            if (new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option("union").isDefined__Z()) {
              var unionNodeMapping = $m_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$().apply__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(map$1);
              f(unionNodeMapping);
              var this$12 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$1);
              var this$13 = this$12.key__T__s_Option("union");
              if ((!this$13.isEmpty__Z())) {
                var arg1$1 = this$13.get__O();
                var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
                var this$14 = entry$3.value$2;
                var x1$2 = this$14.tag__Lorg_yaml_model_YTag().tagType$3;
                var x$3 = $m_Lorg_yaml_model_YType$().Seq$1;
                if ((x$3 === x1$2)) {
                  try {
                    var this$17 = entry$3.value$2;
                    var reader = $m_Lorg_yaml_convert_YRead$StringYRead$();
                    var this$16 = $m_sc_IndexedSeq$();
                    var bf = this$16.ReusableCBF$6;
                    var conversion$2 = new $c_Lorg_yaml_convert_YRead$$anon$1().init___scg_CanBuildFrom__Lorg_yaml_convert_YRead(bf, reader);
                    var iv$3 = $this.ctx$1;
                    var range = $as_sc_Seq($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$17, conversion$2, iv$3));
                    var field$1 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1;
                    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(unionNodeMapping, field$1, range)
                  } catch (e$1) {
                    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e$1);
                    if ((e$2 instanceof $c_jl_Exception)) {
                      var this$18 = $this.ctx$1.eh$1;
                      var specification$1 = $m_Lamf_validation_DialectValidations$().DialectError$1;
                      var node$1 = unionNodeMapping.id$1;
                      var ast = entry$3.value$2;
                      var prop$1 = $m_s_None$();
                      var l$1 = ast.location$1;
                      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$18, specification$1, node$1, prop$1, "Union node mappings must be declared as lists of node mapping references", l$1)
                    } else {
                      throw e$1
                    }
                  }
                } else {
                  var this$19 = $this.ctx$1.eh$1;
                  var specification$2 = $m_Lamf_validation_DialectValidations$().DialectError$1;
                  var node$2 = unionNodeMapping.id$1;
                  var ast$1 = entry$3.value$2;
                  var prop$2 = $m_s_None$();
                  var l$2 = ast$1.location$1;
                  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$19, specification$2, node$2, prop$2, "Union node mappings must be declared as lists of node mapping references", l$2)
                }
              };
              var this$21 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$1);
              var this$22 = this$21.key__T__s_Option("typeDiscriminator");
              if ((!this$22.isEmpty__Z())) {
                var arg1$2 = this$22.get__O();
                var entry$3$1 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
                var this$23 = entry$3$1.value$2;
                var conversion$3 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
                var iv$4 = $this.ctx$1;
                var types = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$23, conversion$3, iv$4));
                var typeMapping = $as_sci_Map(types.entries$3.foldLeft__O__F2__O($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this$2) {
                  return (function(x0$1$2$1, x1$1$2) {
                    var x0$1$1 = $as_sci_Map(x0$1$2$1);
                    var x1$1$1 = $as_Lorg_yaml_model_YMapEntry(x1$1$2);
                    var this$24 = x1$1$1.value$2;
                    var conversion$4 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
                    var iv$5 = $this$2.ctx$1;
                    var nodeMappingId = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$24, conversion$4, iv$5)).text$3;
                    var this$25 = x1$1$1.key$2;
                    var conversion$5 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
                    var iv$6 = $this$2.ctx$1;
                    var self = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$25, conversion$5, iv$6)).text$3;
                    return x0$1$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, nodeMappingId))
                  })
                })($this))));
                $f_Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__withTypeDiscriminator__sci_Map__O(unionNodeMapping, typeMapping)
              };
              var jsx$1 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$1);
              var ctx = $this.ctx$1;
              jsx$1.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("typeDiscriminatorName", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(unionNodeMapping, ctx).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().TypeDiscriminatorName$1));
              var x1$11 = new $c_s_Some().init___O(unionNodeMapping)
            } else {
              var nodeMapping = $m_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$().apply__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_NodeMapping(map$1);
              f(nodeMapping);
              var this$30 = $this.ctx$1;
              var id = nodeMapping.id$1;
              $f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__closedNode__T__T__Lorg_yaml_model_YMap__V(this$30, "nodeMapping", id, map$1);
              var this$32 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$1);
              var this$33 = this$32.key__T__s_Option("classTerm");
              if ((!this$33.isEmpty__Z())) {
                var arg1$3 = this$33.get__O();
                var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
                var value = new $c_Lamf_core_parser_ValueNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(entry$4.value$2, $this.ctx$1);
                var classTermId = value.string__Lamf_core_model_domain_AmfScalar().toString__T();
                var x1$3 = $this.ctx$1.declarations$2.findClassTerm__T__Lamf_core_parser_SearchScope$Scope__s_Option(classTermId, $m_Lamf_core_parser_SearchScope$All$());
                if ((x1$3 instanceof $c_s_Some)) {
                  var x2$2 = $as_s_Some(x1$3);
                  var classTerm = $as_Lamf_plugins_document_vocabularies_model_domain_ClassTerm(x2$2.value$2);
                  var nodeType = classTerm.id$1;
                  var field$2 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().NodeTypeMapping$1;
                  $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(nodeMapping, field$2, nodeType))
                } else {
                  var this$34 = $this.ctx$1.eh$1;
                  var specification$3 = $m_Lamf_validation_DialectValidations$().DialectError$1;
                  var node$3 = nodeMapping.id$1;
                  var message = ("Cannot find class term with alias " + classTermId);
                  var ast$2 = entry$4.value$2;
                  var prop$3 = $m_s_None$();
                  var l$3 = ast$2.location$1;
                  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$34, specification$3, node$3, prop$3, message, l$3)
                }
              };
              var this$36 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$1);
              var this$37 = this$36.key__T__s_Option("patch");
              if ((!this$37.isEmpty__Z())) {
                var arg1$4 = this$37.get__O();
                var entry$3$2 = $as_Lorg_yaml_model_YMapEntry(arg1$4);
                var node$4 = entry$3$2.value$2;
                var iv$7 = $this.ctx$1;
                var this$39 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$4, iv$7);
                var patchMethod = this$39.string__Lamf_core_model_domain_AmfScalar();
                var field$3 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().MergePolicy$1;
                var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3$2);
                $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(nodeMapping, field$3, patchMethod, annotations$1);
                var patchMethodValue = patchMethod.toString__T();
                if ((!$m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().ALLOWED$undMERGE$undPOLICY$1.contains__O__Z(patchMethodValue))) {
                  var this$40 = $this.ctx$1.eh$1;
                  var specification$4 = $m_Lamf_validation_DialectValidations$().DialectError$1;
                  var node$5 = nodeMapping.id$1;
                  var message$1 = (("Unsupported node mapping patch operation '" + patchMethod) + "'");
                  var ast$3 = entry$3$2.value$2;
                  var prop$4 = $m_s_None$();
                  var l$4 = ast$3.location$1;
                  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$40, specification$4, node$5, prop$4, message$1, l$4)
                }
              };
              var this$42 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$1);
              var this$43 = this$42.key__T__s_Option("mapping");
              if ((!this$43.isEmpty__Z())) {
                var arg1$5 = this$43.get__O();
                var entry$4$1 = $as_Lorg_yaml_model_YMapEntry(arg1$5);
                var this$44 = entry$4$1.value$2;
                var conversion$6 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
                var iv$8 = $this.ctx$1;
                var jsx$15 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$44, conversion$6, iv$8)).entries$3;
                var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, nodeMapping$1) {
                  return (function(entry$2$2) {
                    var entry$2$1 = $as_Lorg_yaml_model_YMapEntry(entry$2$2);
                    var this$45 = entry$2$1.value$2;
                    var conversion$7 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
                    var iv$9 = $this$3.ctx$1;
                    var map$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$45, conversion$7, iv$9));
                    var node$6 = entry$2$1.key$2;
                    var iv$10 = $this$3.ctx$1;
                    var this$47 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$6, iv$10);
                    var name$1 = this$47.string__Lamf_core_model_domain_AmfScalar();
                    var this$48 = $m_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$().apply__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(map$2);
                    var field$4 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1;
                    var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$2$1.key$2);
                    var propertyMapping = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$48, field$4, name$1, annotations$2));
                    var jsx$3 = nodeMapping$1.id$1;
                    var this$49 = entry$2$1.key$2;
                    var conversion$8 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
                    var iv$11 = $this$3.ctx$1;
                    var str = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$49, conversion$8, iv$11)).text$3;
                    var this$51 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
                    var this$52 = this$51.platform$1;
                    var url = this$51.str$1;
                    var parent$2 = ((jsx$3 + "/property/") + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$52, url));
                    $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
                    $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(propertyMapping, parent$2));
                    var this$53 = $this$3.ctx$1;
                    var id$1 = propertyMapping.id$1;
                    $f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__closedNode__T__T__Lorg_yaml_model_YMap__V(this$53, "propertyMapping", id$1, map$2);
                    var x1$4 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$2).key__T__s_Option("propertyTerm");
                    if ((x1$4 instanceof $c_s_Some)) {
                      var x2$3 = $as_s_Some(x1$4);
                      var e$3 = $as_Lorg_yaml_model_YMapEntry(x2$3.value$2);
                      var value$1 = new $c_Lamf_core_parser_ValueNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(e$3.value$2, $this$3.ctx$1);
                      var propertyTermId = value$1.string__Lamf_core_model_domain_AmfScalar().toString__T();
                      var x1$2$1 = $this$3.ctx$1.declarations$2.findPropertyTerm__T__Lamf_core_parser_SearchScope$Scope__s_Option(propertyTermId, $m_Lamf_core_parser_SearchScope$All$());
                      if ((x1$2$1 instanceof $c_s_Some)) {
                        var x2$2$1 = $as_s_Some(x1$2$1);
                        var propertyTerm = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm(x2$2$1.value$2);
                        var propertyId = propertyTerm.id$1;
                        var field$5 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1;
                        $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$5, propertyId))
                      } else {
                        var this$55 = $this$3.ctx$1.eh$1;
                        var specification$5 = $m_Lamf_validation_DialectValidations$().DialectError$1;
                        var node$7 = propertyMapping.id$1;
                        var message$2 = ("Cannot find property term with alias " + propertyTermId);
                        var ast$4 = e$3.value$2;
                        var prop$5 = $m_s_None$();
                        var l$5 = ast$4.location$1;
                        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$55, specification$5, node$7, prop$5, message$2, l$5)
                      }
                    } else {
                      var this$60 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
                      var this$56 = entry$2$1.key$2;
                      var conversion$9 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
                      var iv$12 = $this$3.ctx$1;
                      var str$1 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$56, conversion$9, iv$12)).text$3;
                      var this$58 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str$1);
                      var this$59 = this$58.platform$1;
                      var url$1 = this$58.str$1;
                      var id$2 = $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$59, url$1);
                      var propertyId$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$60, id$2).iri__T();
                      var field$6 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1;
                      $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$6, propertyId$1))
                    };
                    var this$63 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$2);
                    var this$64 = this$63.key__T__s_Option("range");
                    if ((!this$64.isEmpty__Z())) {
                      var arg1$6 = this$64.get__O();
                      var entry$2$3 = $as_Lorg_yaml_model_YMapEntry(arg1$6);
                      var this$65 = entry$2$3.value$2;
                      var x1$5 = this$65.tag__Lorg_yaml_model_YTag().tagType$3;
                      var x$4 = $m_Lorg_yaml_model_YType$().Seq$1;
                      if ((x$4 === x1$5)) {
                        var this$68 = entry$2$3.value$2;
                        var reader$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
                        var this$67 = $m_sc_IndexedSeq$();
                        var bf$1 = this$67.ReusableCBF$6;
                        var conversion$10 = new $c_Lorg_yaml_convert_YRead$$anon$1().init___scg_CanBuildFrom__Lorg_yaml_convert_YRead(bf$1, reader$1);
                        var iv$13 = $this$3.ctx$1;
                        var range$1 = $as_sc_Seq($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$68, conversion$10, iv$13));
                        var field$7 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1;
                        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(propertyMapping, field$7, range$1)
                      } else {
                        var value$2 = new $c_Lamf_core_parser_ValueNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(entry$2$3.value$2, $this$3.ctx$1);
                        var range$2 = value$2.string__Lamf_core_model_domain_AmfScalar().toString__T();
                        if ((range$2 === "guid")) {
                          var this$69 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
                          var range$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$69, "guid").iri__T();
                          var field$8 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1;
                          $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$8, range$3))
                        } else if (((range$2 === "string") || ((range$2 === "integer") || ((range$2 === "boolean") || ((range$2 === "float") || ((range$2 === "decimal") || ((range$2 === "double") || ((range$2 === "duration") || ((range$2 === "dateTime") || ((range$2 === "time") || ((range$2 === "date") || (range$2 === "anyType")))))))))))) {
                          var this$71 = $m_Lamf_core_vocabulary_Namespace$().Xsd$1;
                          var range$4 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$71, range$2).iri__T();
                          var field$9 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1;
                          $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$9, range$4))
                        } else if ((range$2 === "anyUri")) {
                          var range$5 = $m_Lamf_core_model_DataType$().AnyUri$1;
                          var field$10 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1;
                          $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$10, range$5))
                        } else if ((range$2 === "link")) {
                          var this$73 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
                          var range$6 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$73, "link").iri__T();
                          var field$11 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1;
                          $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$11, range$6))
                        } else if ((range$2 === "number")) {
                          var range$7 = $m_Lamf_core_model_DataType$().Number$1;
                          var field$12 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1;
                          $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$12, range$7))
                        } else if ((range$2 === "uri")) {
                          var range$8 = $m_Lamf_core_model_DataType$().AnyUri$1;
                          var field$13 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1;
                          $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$13, range$8))
                        } else if ((range$2 === "any")) {
                          var range$9 = $m_Lamf_core_model_DataType$().Any$1;
                          var field$14 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1;
                          $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$14, range$9))
                        } else if ((range$2 === "anyNode")) {
                          var jsx$4 = $m_sc_Seq$();
                          var this$75 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
                          var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$75, "anyNode").iri__T()];
                          var range$10 = $as_sc_Seq(jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
                          var field$15 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1;
                          $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(propertyMapping, field$15, range$10)
                        } else {
                          var jsx$5 = $m_sc_Seq$();
                          var array$1 = [range$2];
                          var range$11 = $as_sc_Seq(jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)));
                          var field$16 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1;
                          $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(propertyMapping, field$16, range$11)
                        }
                      }
                    };
                    $this$3.parseMapKey__p1__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__V(map$2, propertyMapping);
                    $this$3.parseMapValue__p1__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__V(map$2, propertyMapping);
                    var this$82 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$2);
                    var this$83 = this$82.key__T__s_Option("patch");
                    if ((!this$83.isEmpty__Z())) {
                      var arg1$7 = this$83.get__O();
                      var entry$3$3 = $as_Lorg_yaml_model_YMapEntry(arg1$7);
                      var node$8 = entry$3$3.value$2;
                      var iv$14 = $this$3.ctx$1;
                      var this$85 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$8, iv$14);
                      var patchMethod$1 = this$85.string__Lamf_core_model_domain_AmfScalar();
                      var field$17 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MergePolicy$1;
                      var annotations$3 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3$3);
                      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(propertyMapping, field$17, patchMethod$1, annotations$3);
                      var patchMethodValue$1 = patchMethod$1.toString__T();
                      if ((!$m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().ALLOWED$undMERGE$undPOLICY$1.contains__O__Z(patchMethodValue$1))) {
                        var this$86 = $this$3.ctx$1.eh$1;
                        var specification$6 = $m_Lamf_validation_DialectValidations$().DialectError$1;
                        var node$9 = propertyMapping.id$1;
                        var message$3 = (("Unsupported propertu mapping patch operation '" + patchMethod$1) + "'");
                        var ast$5 = entry$3$3.value$2;
                        var prop$6 = $m_s_None$();
                        var l$6 = ast$5.location$1;
                        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$86, specification$6, node$9, prop$6, message$3, l$6)
                      }
                    };
                    var this$88 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$2);
                    var this$89 = this$88.key__T__s_Option("mandatory");
                    if ((!this$89.isEmpty__Z())) {
                      var arg1$8 = this$89.get__O();
                      var entry$4$2 = $as_Lorg_yaml_model_YMapEntry(arg1$8);
                      var node$10 = entry$4$2.value$2;
                      var iv$15 = $this$3.ctx$1;
                      var this$91 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$10, iv$15);
                      var required = this$91.$boolean__Lamf_core_model_domain_AmfScalar().toBool__Z();
                      var value$3 = (required ? 1 : 0);
                      var field$18 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MinCount$1;
                      var value$4 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value$3, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4$2.value$2));
                      var annotations$4 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4$2);
                      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(propertyMapping, field$18, value$4, annotations$4)
                    };
                    var jsx$6 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$2);
                    var ctx$1 = $this$3.ctx$1;
                    jsx$6.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("pattern", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(propertyMapping, ctx$1).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Pattern$1));
                    var jsx$7 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$2);
                    var ctx$2 = $this$3.ctx$1;
                    jsx$7.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("minimum", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(propertyMapping, ctx$2).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Minimum$1));
                    var jsx$8 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$2);
                    var ctx$3 = $this$3.ctx$1;
                    jsx$8.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("unique", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(propertyMapping, ctx$3).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Unique$1));
                    var jsx$9 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$2);
                    var ctx$4 = $this$3.ctx$1;
                    jsx$9.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("maximum", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(propertyMapping, ctx$4).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Maximum$1));
                    var jsx$10 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$2);
                    var ctx$5 = $this$3.ctx$1;
                    jsx$10.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("allowMultiple", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(propertyMapping, ctx$5).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().AllowMultiple$1));
                    var jsx$11 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$2);
                    var ctx$6 = $this$3.ctx$1;
                    jsx$11.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("sorted", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(propertyMapping, ctx$6).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Sorted$1));
                    var this$105 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$2);
                    var this$106 = this$105.key__T__s_Option("enum");
                    if ((!this$106.isEmpty__Z())) {
                      var arg1$9 = this$106.get__O();
                      var entry$5 = $as_Lorg_yaml_model_YMapEntry(arg1$9);
                      var this$107 = entry$5.value$2;
                      var conversion$11 = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
                      var iv$16 = $this$3.ctx$1;
                      var seq = $as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$107, conversion$11, iv$16));
                      var jsx$13 = seq.nodes$3;
                      var jsx$12 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$4) {
                        return (function(node$2$1) {
                          var node$11 = $as_Lorg_yaml_model_YNode(node$2$1);
                          var x1$6 = node$11.value__Lorg_yaml_model_YValue();
                          if ((x1$6 instanceof $c_Lorg_yaml_model_YScalar)) {
                            var iv$17 = $this$4.ctx$1;
                            var this$109 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$11, iv$17);
                            var xo = new $c_s_Some().init___O(this$109.string__Lamf_core_model_domain_AmfScalar());
                            return xo.toList__sci_List()
                          } else {
                            var this$112 = $this$4.ctx$1.eh$1;
                            var specification$7 = $m_Lamf_validation_DialectValidations$().DialectError$1;
                            $m_Lorg_yaml_model_YNode$();
                            var iv$18 = $this$4.ctx$1;
                            var conversion$12 = $m_Lorg_yaml_convert_YRead$StringYRead$();
                            var message$4 = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node$11, conversion$12, iv$18));
                            var property = $m_s_None$();
                            var lexical = $m_s_None$();
                            var location = $m_s_None$();
                            this$112.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification$7.id$1, "Cannot create enumeration constraint from not scalar value", property, message$4, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
                            var xo$1 = $m_s_None$();
                            return xo$1.toList__sci_List()
                          }
                        })
                      })($this$3));
                      var this$114 = $m_sc_IndexedSeq$();
                      var values = $as_sc_IndexedSeq(jsx$13.flatMap__F1__scg_CanBuildFrom__O(jsx$12, this$114.ReusableCBF$6));
                      var field$19 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Enum$1;
                      var value$5 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(values, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(seq));
                      var annotations$5 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$5);
                      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(propertyMapping, field$19, value$5, annotations$5)
                    };
                    var this$116 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$2);
                    var this$117 = this$116.key__T__s_Option("typeDiscriminator");
                    if ((!this$117.isEmpty__Z())) {
                      var arg1$10 = this$117.get__O();
                      var entry$6 = $as_Lorg_yaml_model_YMapEntry(arg1$10);
                      var this$118 = entry$6.value$2;
                      var conversion$13 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
                      var iv$19 = $this$3.ctx$1;
                      var types$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$118, conversion$13, iv$19));
                      var typeMapping$1 = $as_sci_Map(types$1.entries$3.foldLeft__O__F2__O($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this$5) {
                        return (function(x0$1$2$2, x1$1$2$1) {
                          var x0$1$3 = $as_sci_Map(x0$1$2$2);
                          var x1$1$3 = $as_Lorg_yaml_model_YMapEntry(x1$1$2$1);
                          var this$119 = x1$1$3.value$2;
                          var conversion$14 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
                          var iv$20 = $this$5.ctx$1;
                          var nodeMappingId$1 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$119, conversion$14, iv$20)).text$3;
                          var this$120 = x1$1$3.key$2;
                          var conversion$15 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
                          var iv$21 = $this$5.ctx$1;
                          var self$1 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$120, conversion$15, iv$21)).text$3;
                          return x0$1$3.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$1, nodeMappingId$1))
                        })
                      })($this$3))));
                      $f_Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__withTypeDiscriminator__sci_Map__O(propertyMapping, typeMapping$1)
                    };
                    var jsx$14 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$2);
                    var ctx$7 = $this$3.ctx$1;
                    jsx$14.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("typeDiscriminatorName", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(propertyMapping, ctx$7).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().TypeDiscriminatorName$1));
                    var this$126 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$2);
                    var this$127 = this$126.key__T__s_Option("isLink");
                    if ((!this$127.isEmpty__Z())) {
                      var arg1$11 = this$127.get__O();
                      var entry$7 = $as_Lorg_yaml_model_YMapEntry(arg1$11);
                      var this$128 = entry$7.value$2;
                      var conversion$16 = $m_Lorg_yaml_convert_YRead$BooleanYRead$();
                      var iv$22 = $this$3.ctx$1;
                      var isLink = $uZ($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$128, conversion$16, iv$22));
                      var field$20 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().ExternallyLinkable$1;
                      $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(propertyMapping, field$20, isLink));
                      var x1$7 = $as_Lamf_core_model_StrField(propertyMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1)).option$1;
                      if ((x1$7 instanceof $c_s_Some)) {
                        var x2$4 = $as_s_Some(x1$7);
                        var v = $as_T(x2$4.value$2);
                        var this$130 = $this$3.ctx$1.eh$1;
                        var specification$8 = $m_Lamf_validation_DialectValidations$().DialectError$1;
                        var node$13 = ("External links support in property mappings only can be declared in object properties but scalar range detected: " + v);
                        $m_Lorg_yaml_model_YNode$();
                        var node$12 = entry$7.value$2;
                        var iv$23 = $this$3.ctx$1;
                        var conversion$17 = $m_Lorg_yaml_convert_YRead$StringYRead$();
                        var message$5 = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node$12, conversion$17, iv$23));
                        var property$1 = $m_s_None$();
                        var lexical$1 = $m_s_None$();
                        var location$1 = $m_s_None$();
                        this$130.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification$8.id$1, node$13, property$1, message$5, lexical$1, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location$1)
                      }
                    };
                    var declarations = $this$3.ctx$1.declarations$2;
                    var ctx$8 = $this$3.ctx$1;
                    $f_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser__parseAnnotations__Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations__Lamf_core_parser_ParserContext__O($this$3, map$2, propertyMapping, declarations, ctx$8);
                    $this$3.checkGuidUniqueContraint__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lorg_yaml_model_YPart__V(propertyMapping, map$2);
                    return propertyMapping
                  })
                })($this, nodeMapping));
                var this$131 = $m_sc_IndexedSeq$();
                var properties = $as_sc_IndexedSeq(jsx$15.map__F1__scg_CanBuildFrom__O(jsx$2, this$131.ReusableCBF$6));
                var x1$8 = properties.partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
                  return (function(x$15$2) {
                    var x$15 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$15$2);
                    var this$132 = $as_Lamf_core_model_StrField(x$15.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1)).option$1;
                    return this$132.isDefined__Z()
                  })
                })($this)));
                if ((x1$8 === null)) {
                  throw new $c_s_MatchError().init___O(x1$8)
                };
                var withTerm = $as_sc_IndexedSeq(x1$8.$$und1__O());
                var withourTerm = $as_sc_IndexedSeq(x1$8.$$und2__O());
                var this$140 = $as_sc_TraversableLike(withTerm.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
                  return (function(x$17$2) {
                    var x$17 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$17$2);
                    var this$133 = $as_Lamf_core_model_StrField(x$17.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1)).option$1;
                    return this$133.isDefined__Z()
                  })
                })($this)))).groupBy__F1__sci_Map(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
                  return (function(p$2) {
                    var p = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(p$2);
                    var this$134 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
                    var this$135 = this$134.option$1;
                    return $as_T((this$135.isEmpty__Z() ? null : this$135.get__O()))
                  })
                })($this)));
                var f$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1) {
                  return (function(x0$1$2$3) {
                    var x0$1$4 = $as_T2(x0$1$2$3);
                    if ((x0$1$4 !== null)) {
                      var termKey = $as_T(x0$1$4.$$und1__O());
                      var values$1 = $as_sc_IndexedSeq(x0$1$4.$$und2__O());
                      if ((values$1.length__I() > 1)) {
                        var this$136 = this$5$1.ctx$1.eh$1;
                        var specification$9 = $m_Lamf_validation_DialectValidations$().DialectError$1;
                        var node$14 = $as_Lamf_core_model_domain_AmfObject(values$1.head__O()).id__T();
                        var message$6 = (("Property term value must be unique in a node mapping. Term " + termKey) + " repeated");
                        var annotations$6 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(values$1.head__O()).annotations$1;
                        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$136, specification$9, node$14, message$6, annotations$6);
                        var xo$2 = values$1.headOption__s_Option();
                        return xo$2.toList__sci_List()
                      }
                    };
                    var xo$3 = $as_sc_TraversableLike(x0$1$4.$$und2__O()).headOption__s_Option();
                    return xo$3.toList__sci_List()
                  })
                })($this));
                var this$139 = $m_sci_Iterable$();
                var bf$2 = this$139.ReusableCBFInstance$2;
                var filterProperties = $as_sci_Iterable($f_sc_TraversableLike__flatMap__F1__scg_CanBuildFrom__O(this$140, f$1, bf$2));
                var field$21 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1;
                var jsx$16 = filterProperties.toSeq__sc_Seq();
                var this$141 = $m_sc_IndexedSeq$();
                var values$2 = $as_sc_Seq(withourTerm.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$16, this$141.ReusableCBF$6));
                var annotations$7 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4$1);
                $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(nodeMapping, field$21, values$2, annotations$7)
              };
              var this$143 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$1);
              var this$144 = this$143.key__T__s_Option("extends");
              if ((!this$144.isEmpty__Z())) {
                var arg1$12 = this$144.get__O();
                var entry$5$1 = $as_Lorg_yaml_model_YMapEntry(arg1$12);
                var node$15 = entry$5$1.value$2;
                var reference = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node$15).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YScalarYRead$());
                if ((reference instanceof $c_s_Some)) {
                  var this$146 = $this.ctx$1;
                  var node$16 = entry$5$1.value$2;
                  var x1$9 = $f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__link__Lorg_yaml_model_YNode__s_util_Either(this$146, node$16);
                  if ((x1$9 instanceof $c_s_util_Left)) {
                    var x2$5 = $as_s_util_Left(x1$9);
                    var key = $as_T(x2$5.value$2);
                    var refTuple = new $c_T2().init___O__O(key, $this.ctx$1.declarations$2.findNodeMapping__T__Lamf_core_parser_SearchScope$Scope__s_Option(key, $m_Lamf_core_parser_SearchScope$Fragments$()))
                  } else {
                    var this$147 = entry$5$1.value$2;
                    var conversion$18 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
                    var iv$24 = $this.ctx$1;
                    var text = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$147, conversion$18, iv$24)).text$3;
                    var refTuple = new $c_T2().init___O__O(text, $this.ctx$1.declarations$2.findNodeMapping__T__Lamf_core_parser_SearchScope$Scope__s_Option(text, $m_Lamf_core_parser_SearchScope$Named$()))
                  };
                  matchEnd8: {
                    var parsed;
                    if ((refTuple !== null)) {
                      var text$2 = $as_T(refTuple.$$und1__O());
                      var p2 = $as_s_Option(refTuple.$$und2__O());
                      if ((text$2 !== null)) {
                        if ((p2 instanceof $c_s_Some)) {
                          var x3 = $as_s_Some(p2);
                          var s = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x3.value$2);
                          var annotations$8 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$5$1.value$2);
                          var linkedNode = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(s, text$2, annotations$8));
                          f(linkedNode);
                          var parsed = new $c_s_Some().init___O(linkedNode);
                          break matchEnd8
                        }
                      }
                    };
                    if ((refTuple !== null)) {
                      var text$3 = $as_T(refTuple.$$und1__O());
                      if ((text$3 !== null)) {
                        var linkedNode$2 = $m_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$().apply__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_NodeMapping($this.map$1);
                        f(linkedNode$2);
                        var refAst = $this.map$1;
                        var ctx$9 = $this.ctx$1;
                        $f_Lamf_core_model_domain_Linkable__unresolved__T__Lorg_yaml_model_YPart__T__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(linkedNode$2, text$3, refAst, "error", ctx$9);
                        var parsed = new $c_s_Some().init___O(linkedNode$2);
                        break matchEnd8
                      }
                    };
                    throw new $c_s_MatchError().init___O(refTuple)
                  }
                } else {
                  var parsed = $m_s_None$()
                };
                matchEnd5$2: {
                  if ((parsed instanceof $c_s_Some)) {
                    var x2$6 = $as_s_Some(parsed);
                    var resolvedNodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x2$6.value$2);
                    if ((resolvedNodeMapping !== null)) {
                      var jsx$17 = $m_sc_Seq$();
                      var array$2 = [resolvedNodeMapping];
                      var extend = $as_sc_Seq(jsx$17.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2)));
                      var field$22 = $m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field();
                      $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(nodeMapping, field$22, extend));
                      break matchEnd5$2
                    }
                  };
                  var this$151 = $this.ctx$1.eh$1;
                  var specification$10 = $m_Lamf_validation_DialectValidations$().DialectError$1;
                  var node$17 = nodeMapping.id$1;
                  if (reference.isEmpty__Z()) {
                    var this$150 = $m_s_None$()
                  } else {
                    var arg1$13 = reference.get__O();
                    var x$18 = $as_Lorg_yaml_model_YScalar(arg1$13);
                    var this$150 = new $c_s_Some().init___O(x$18.mark$3.markText__T__T(x$18.text$3))
                  };
                  var message$7 = (("Cannot find extended node mapping with reference '" + (this$150.isEmpty__Z() ? "" : this$150.get__O())) + "'");
                  var ast$6 = entry$5$1.value$2;
                  var prop$7 = $m_s_None$();
                  var l$7 = ast$6.location$1;
                  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$151, specification$10, node$17, prop$7, message$7, l$7)
                }
              };
              var jsx$18 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$1);
              var ctx$10 = $this.ctx$1;
              jsx$18.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("idTemplate", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(nodeMapping, ctx$10).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().IdTemplate$1));
              var this$154 = $as_Lamf_core_model_StrField(nodeMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().NodeTypeMapping$1)).option$1;
              if ((!this$154.isEmpty__Z())) {
                var arg1$14 = this$154.get__O();
                var x$19 = $as_T(arg1$14);
                $this.validateTemplate__T__Lorg_yaml_model_YMap__sc_Seq__V(x$19, map$1, $as_sc_Seq(nodeMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)))
              };
              var declarations$1 = $this.ctx$1.declarations$2;
              var ctx$11 = $this.ctx$1;
              $f_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser__parseAnnotations__Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations__Lamf_core_parser_ParserContext__O($this, map$1, nodeMapping, declarations$1, ctx$11);
              $this.ctx$1.declarations$2.$$plus$eq__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations(nodeMapping);
              var x1$11 = new $c_s_Some().init___O(nodeMapping)
            }
          } else {
            var x$3$2 = $m_Lorg_yaml_model_YType$().Str$1;
            if ((x$3$2 === x1$1)) {
              var node$18 = entry.value$2;
              var jsx$19 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node$18).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YScalarYRead$()).isDefined__Z()
            } else {
              var jsx$19 = false
            };
            if (jsx$19) {
              var this$156 = $this.ctx$1;
              var node$19 = entry.value$2;
              var x1$10 = $f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__link__Lorg_yaml_model_YNode__s_util_Either(this$156, node$19);
              if ((x1$10 instanceof $c_s_util_Left)) {
                var x2$7 = $as_s_util_Left(x1$10);
                var key$1 = $as_T(x2$7.value$2);
                var refTuple$1 = new $c_T2().init___O__O(key$1, $this.ctx$1.declarations$2.findNodeMapping__T__Lamf_core_parser_SearchScope$Scope__s_Option(key$1, $m_Lamf_core_parser_SearchScope$Fragments$()))
              } else {
                var this$157 = entry.value$2;
                var conversion$19 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
                var iv$25 = $this.ctx$1;
                var text$1 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$157, conversion$19, iv$25)).text$3;
                var refTuple$1 = new $c_T2().init___O__O(text$1, $this.ctx$1.declarations$2.findNodeMapping__T__Lamf_core_parser_SearchScope$Scope__s_Option(text$1, $m_Lamf_core_parser_SearchScope$Named$()))
              };
              matchEnd8$1: {
                var x1$11;
                if ((refTuple$1 !== null)) {
                  var text$2$1 = $as_T(refTuple$1.$$und1__O());
                  var p2$1 = $as_s_Option(refTuple$1.$$und2__O());
                  if ((text$2$1 !== null)) {
                    if ((p2$1 instanceof $c_s_Some)) {
                      var x3$1 = $as_s_Some(p2$1);
                      var s$1 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x3$1.value$2);
                      var annotations$9 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
                      var linkedNode$1 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(s$1, text$2$1, annotations$9));
                      f(linkedNode$1);
                      var x1$11 = new $c_s_Some().init___O(linkedNode$1);
                      break matchEnd8$1
                    }
                  }
                };
                if ((refTuple$1 !== null)) {
                  var text$3$1 = $as_T(refTuple$1.$$und1__O());
                  if ((text$3$1 !== null)) {
                    var linkedNode$2$1 = $m_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$().apply__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_NodeMapping($this.map$1);
                    f(linkedNode$2$1);
                    var refAst$1 = $this.map$1;
                    var ctx$12 = $this.ctx$1;
                    $f_Lamf_core_model_domain_Linkable__unresolved__T__Lorg_yaml_model_YPart__T__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(linkedNode$2$1, text$3$1, refAst$1, "error", ctx$12);
                    var x1$11 = new $c_s_Some().init___O(linkedNode$2$1);
                    break matchEnd8$1
                  }
                };
                throw new $c_s_MatchError().init___O(refTuple$1)
              }
            } else {
              var x$5 = $m_Lorg_yaml_model_YType$().Include$1;
              if ((x$5 === x1$1)) {
                var node$20 = entry.value$2;
                var jsx$20 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node$20).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YScalarYRead$()).isDefined__Z()
              } else {
                var jsx$20 = false
              };
              if (jsx$20) {
                var this$159 = $this.ctx$1;
                var node$21 = entry.value$2;
                var x1$2$2 = $f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__link__Lorg_yaml_model_YNode__s_util_Either(this$159, node$21);
                if ((x1$2$2 instanceof $c_s_util_Left)) {
                  var x2$8 = $as_s_util_Left(x1$2$2);
                  var key$2 = $as_T(x2$8.value$2);
                  var refTuple$2 = new $c_T2().init___O__O(key$2, $this.ctx$1.declarations$2.findNodeMapping__T__Lamf_core_parser_SearchScope$Scope__s_Option(key$2, $m_Lamf_core_parser_SearchScope$Fragments$()))
                } else {
                  var this$160 = entry.value$2;
                  var conversion$20 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
                  var iv$26 = $this.ctx$1;
                  var text$4 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$160, conversion$20, iv$26)).text$3;
                  var refTuple$2 = new $c_T2().init___O__O(text$4, $this.ctx$1.declarations$2.findNodeMapping__T__Lamf_core_parser_SearchScope$Scope__s_Option(text$4, $m_Lamf_core_parser_SearchScope$Named$()))
                };
                matchEnd8$2: {
                  var x1$11;
                  if ((refTuple$2 !== null)) {
                    var text$2$2 = $as_T(refTuple$2.$$und1__O());
                    var p2$2 = $as_s_Option(refTuple$2.$$und2__O());
                    if ((text$2$2 !== null)) {
                      if ((p2$2 instanceof $c_s_Some)) {
                        var x3$2 = $as_s_Some(p2$2);
                        var s$2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x3$2.value$2);
                        var annotations$10 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
                        var this$161 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(s$2, text$2$2, annotations$10));
                        var field$23 = this$161.Name$1;
                        var linkedNode$3 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$161, field$23, text$2$2)));
                        f(linkedNode$3);
                        var x1$11 = new $c_s_Some().init___O(linkedNode$3);
                        break matchEnd8$2
                      }
                    }
                  };
                  if ((refTuple$2 !== null)) {
                    var text$3$2 = $as_T(refTuple$2.$$und1__O());
                    if ((text$3$2 !== null)) {
                      $m_Lamf_core_parser_Annotations$();
                      var annotations$11 = new $c_Lamf_core_parser_Annotations().init___();
                      var fields = new $c_Lamf_core_parser_Fields().init___();
                      var arg1$15 = new $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations$11);
                      var nodeMappingTmp = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(f(arg1$15));
                      var thiz = nodeMappingTmp.id$1;
                      var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "#", 0);
                      var this$168 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
                      var suffix = $as_T($f_sc_IndexedSeqOptimized__head__O(this$168));
                      var this$171 = $this.ctx$1;
                      var thiz$1 = nodeMappingTmp.id$1;
                      var node$22 = $as_T(thiz$1.split(suffix).join(""));
                      var ast$7 = entry.value$2;
                      $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__missingFragmentViolation__T__T__Lorg_yaml_model_YPart__V(this$171, text$3$2, node$22, ast$7);
                      var x1$11 = $m_s_None$();
                      break matchEnd8$2
                    }
                  };
                  throw new $c_s_MatchError().init___O(refTuple$2)
                }
              } else {
                var x1$11 = $m_s_None$()
              }
            }
          };
          if ((x1$11 instanceof $c_s_Some)) {
            rc7 = true;
            x2 = $as_s_Some(x1$11);
            var nodeMapping$2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x2.value$2);
            if ((nodeMapping$2 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
              var x4 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(nodeMapping$2);
              return $this.ctx$1.declarations$2.$$plus$eq__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations(x4)
            }
          };
          if (rc7) {
            var nodeMapping$2$1 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x2.value$2);
            if ((nodeMapping$2$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping)) {
              var x5 = $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(nodeMapping$2$1);
              return $this.ctx$1.declarations$2.$$plus$eq__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations(x5)
            }
          };
          var this$172 = $this.ctx$1.eh$1;
          var specification$11 = $m_Lamf_validation_DialectValidations$().DialectError$1;
          var message$8 = (("Error parsing shape '" + entry) + "'");
          var prop$8 = $m_s_None$();
          var l$8 = entry.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$172, specification$11, parent$1, prop$8, message$8, l$8)
        })
      })(this, parent)))
    } else {
      var x$3$3 = $m_Lorg_yaml_model_YType$().Null$1;
      if ((!(x$3$3 === x1))) {
        var this$173 = this.ctx$1.eh$1;
        var specification$12 = $m_Lamf_validation_DialectValidations$().DialectError$1;
        var message$9 = (("Invalid type " + x1) + " for 'nodeMappings' node.");
        var ast$8 = e.value$2;
        var prop$9 = $m_s_None$();
        var l$9 = ast$8.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$173, specification$12, parent, prop$9, message$9, l$9)
      }
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype.getTermIfValid__p1__T__T__Lorg_yaml_model_YPart__s_Option = (function(iri, propertyMappingId, ast) {
  var x1 = new $c_Lamf_core_vocabulary_Namespace().init___T(iri).base$1;
  if (($m_Lamf_core_vocabulary_Namespace$().Data$1.base$1 === x1)) {
    return new $c_s_Some().init___O(iri)
  } else {
    var x1$2 = this.ctx$1.declarations$2.findPropertyTerm__T__Lamf_core_parser_SearchScope$Scope__s_Option(iri, $m_Lamf_core_parser_SearchScope$All$());
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var term = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm(x2.value$2);
      return new $c_s_Some().init___O(term.id$1)
    } else {
      var this$1 = this.ctx$1.eh$1;
      var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
      var message = ("Cannot find property term with alias " + iri);
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, propertyMappingId, prop, message, l);
      return $m_s_None$()
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype.parseFragment__Lamf_core_model_document_BaseUnit = (function() {
  var map = this.map$1;
  var jsx$1 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map);
  var target = this.dialect$1;
  var ctx = this.ctx$1;
  jsx$1.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("usage", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(target, ctx).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Usage$1));
  var this$3 = this.ctx$1;
  var id = this.dialect$1.id$1;
  var map$1 = this.map$1;
  $f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__closedNode__T__T__Lorg_yaml_model_YMap__V(this$3, "fragment", id, map$1);
  var jsx$2 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser().init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lorg_yaml_model_YMap__sc_Seq__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(this.dialect$1, this.map$1, this.root$1.references$1, this.ctx$1);
  var this$4 = this.dialect$1;
  var this$5 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$4);
  var references = jsx$2.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations($as_T((this$5.isEmpty__Z() ? this.dialect$1.id$1 : this$5.get__O())));
  var this$6 = this.ctx$1.declarations$2.externals$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$6)) {
    var this$9 = this.dialect$1;
    var this$7 = this.ctx$1.declarations$2.externals$2;
    var this$8 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$7);
    var externals = this$8.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream();
    var field = $m_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$().Externals$1;
    $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$9, field, externals)
  };
  this.parseDeclarations__Lamf_core_Root__Lorg_yaml_model_YMap__V(this.root$1, this.map$1);
  if (references.baseUnitReferences__sc_Seq().nonEmpty__Z()) {
    var this$10 = this.dialect$1;
    var references$1 = references.baseUnitReferences__sc_Seq();
    var field$1 = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
    $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$10, field$1, references$1))
  };
  var fragment = this.toFragment__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_plugins_document_vocabularies_model_document_DialectFragment(this.dialect$1);
  var jsx$4 = $m_Lorg_yaml_model_YMapEntry$();
  var jsx$3 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("fragment");
  $m_Lorg_yaml_model_YNode$();
  var map$2 = this.map$1;
  $m_Lorg_yaml_model_YNode$();
  var entry = jsx$4.apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry(jsx$3, $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map$2, $m_Lorg_yaml_model_YType$().Map$1));
  var f = (function(this$2$1, fragment$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_domain_DomainElement(x0$1$2);
      if ((x0$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
        var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x0$1);
        var this$13 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x2.withId__T__Lamf_core_model_domain_AmfObject((fragment$1.id$1 + "/fragment")));
        var field$2 = this$13.Name$1;
        return $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$13, field$2, "fragment")))
      } else if ((x0$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping)) {
        var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(x0$1);
        var value = (fragment$1.id$1 + "/fragment");
        var this$14 = $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(x3, value));
        var field$3 = this$14.Name$1;
        return $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping($as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$14, field$3, "fragment")))
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, fragment);
  var this$15 = entry.value$2;
  var x1 = this$15.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var this$16 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$1;
    var map$3 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$16, conversion, iv));
    if (new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$3).key__T__s_Option("union").isDefined__Z()) {
      var unionNodeMapping = $m_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping$().apply__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(map$3);
      f(unionNodeMapping);
      var this$19 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$3);
      var this$20 = this$19.key__T__s_Option("union");
      if ((!this$20.isEmpty__Z())) {
        var arg1 = this$20.get__O();
        var entry$1 = $as_Lorg_yaml_model_YMapEntry(arg1);
        var this$21 = entry$1.value$2;
        var x1$1 = this$21.tag__Lorg_yaml_model_YTag().tagType$3;
        var x$1 = $m_Lorg_yaml_model_YType$().Seq$1;
        if ((x$1 === x1$1)) {
          try {
            var this$24 = entry$1.value$2;
            var reader = $m_Lorg_yaml_convert_YRead$StringYRead$();
            var this$23 = $m_sc_IndexedSeq$();
            var bf = this$23.ReusableCBF$6;
            var conversion$1 = new $c_Lorg_yaml_convert_YRead$$anon$1().init___scg_CanBuildFrom__Lorg_yaml_convert_YRead(bf, reader);
            var iv$1 = this.ctx$1;
            var range = $as_sc_Seq($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$24, conversion$1, iv$1));
            var field$4 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1;
            $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(unionNodeMapping, field$4, range)
          } catch (e) {
            var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
            if ((e$2 instanceof $c_jl_Exception)) {
              var this$25 = this.ctx$1.eh$1;
              var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
              var node = unionNodeMapping.id$1;
              var ast = entry$1.value$2;
              var prop = $m_s_None$();
              var l = ast.location$1;
              $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$25, specification, node, prop, "Union node mappings must be declared as lists of node mapping references", l)
            } else {
              throw e
            }
          }
        } else {
          var this$26 = this.ctx$1.eh$1;
          var specification$1 = $m_Lamf_validation_DialectValidations$().DialectError$1;
          var node$1 = unionNodeMapping.id$1;
          var ast$1 = entry$1.value$2;
          var prop$1 = $m_s_None$();
          var l$1 = ast$1.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$26, specification$1, node$1, prop$1, "Union node mappings must be declared as lists of node mapping references", l$1)
        }
      };
      var this$28 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$3);
      var this$29 = this$28.key__T__s_Option("typeDiscriminator");
      if ((!this$29.isEmpty__Z())) {
        var arg1$1 = this$29.get__O();
        var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
        var this$30 = entry$3.value$2;
        var conversion$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv$2 = this.ctx$1;
        var types = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$30, conversion$2, iv$2));
        var typeMapping = $as_sci_Map(types.entries$3.foldLeft__O__F2__O($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
          return (function(x0$1$2$1, x1$1$2) {
            var x0$1$1 = $as_sci_Map(x0$1$2$1);
            var x1$1$1 = $as_Lorg_yaml_model_YMapEntry(x1$1$2);
            var this$31 = x1$1$1.value$2;
            var conversion$3 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
            var iv$3 = $this.ctx$1;
            var nodeMappingId = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$31, conversion$3, iv$3)).text$3;
            var this$32 = x1$1$1.key$2;
            var conversion$4 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
            var iv$4 = $this.ctx$1;
            var self = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$32, conversion$4, iv$4)).text$3;
            return x0$1$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, nodeMappingId))
          })
        })(this))));
        $f_Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__withTypeDiscriminator__sci_Map__O(unionNodeMapping, typeMapping)
      };
      var jsx$5 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$3);
      var ctx$1 = this.ctx$1;
      jsx$5.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("typeDiscriminatorName", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(unionNodeMapping, ctx$1).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().TypeDiscriminatorName$1));
      var x1$10 = new $c_s_Some().init___O(unionNodeMapping)
    } else {
      var nodeMapping = $m_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$().apply__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_NodeMapping(map$3);
      f(nodeMapping);
      var this$38 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$3);
      var this$39 = this$38.key__T__s_Option("classTerm");
      if ((!this$39.isEmpty__Z())) {
        var arg1$2 = this$39.get__O();
        var entry$2 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
        var value$1 = new $c_Lamf_core_parser_ValueNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(entry$2.value$2, this.ctx$1);
        var classTermId = value$1.string__Lamf_core_model_domain_AmfScalar().toString__T();
        var x1$2 = this.ctx$1.declarations$2.findClassTerm__T__Lamf_core_parser_SearchScope$Scope__s_Option(classTermId, $m_Lamf_core_parser_SearchScope$All$());
        if ((x1$2 instanceof $c_s_Some)) {
          var x2$1 = $as_s_Some(x1$2);
          var classTerm = $as_Lamf_plugins_document_vocabularies_model_domain_ClassTerm(x2$1.value$2);
          var nodeType = classTerm.id$1;
          var field$5 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().NodeTypeMapping$1;
          $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(nodeMapping, field$5, nodeType))
        } else {
          var this$40 = this.ctx$1.eh$1;
          var specification$2 = $m_Lamf_validation_DialectValidations$().DialectError$1;
          var node$2 = nodeMapping.id$1;
          var message = ("Cannot find class term with alias " + classTermId);
          var ast$2 = entry$2.value$2;
          var prop$2 = $m_s_None$();
          var l$2 = ast$2.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$40, specification$2, node$2, prop$2, message, l$2)
        }
      };
      var this$42 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$3);
      var this$43 = this$42.key__T__s_Option("patch");
      if ((!this$43.isEmpty__Z())) {
        var arg1$3 = this$43.get__O();
        var entry$3$1 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
        var node$3 = entry$3$1.value$2;
        var iv$5 = this.ctx$1;
        var this$45 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$3, iv$5);
        var patchMethod = this$45.string__Lamf_core_model_domain_AmfScalar();
        var field$6 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().MergePolicy$1;
        var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3$1);
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(nodeMapping, field$6, patchMethod, annotations);
        var patchMethodValue = patchMethod.toString__T();
        if ((!$m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().ALLOWED$undMERGE$undPOLICY$1.contains__O__Z(patchMethodValue))) {
          var this$46 = this.ctx$1.eh$1;
          var specification$3 = $m_Lamf_validation_DialectValidations$().DialectError$1;
          var node$4 = nodeMapping.id$1;
          var message$1 = (("Unsupported node mapping patch operation '" + patchMethod) + "'");
          var ast$3 = entry$3$1.value$2;
          var prop$3 = $m_s_None$();
          var l$3 = ast$3.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$46, specification$3, node$4, prop$3, message$1, l$3)
        }
      };
      var this$48 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$3);
      var this$49 = this$48.key__T__s_Option("mapping");
      if ((!this$49.isEmpty__Z())) {
        var arg1$4 = this$49.get__O();
        var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$4);
        var this$50 = entry$4.value$2;
        var conversion$5 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv$6 = this.ctx$1;
        var jsx$19 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$50, conversion$5, iv$6)).entries$3;
        var jsx$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, nodeMapping$1) {
          return (function(entry$2$2) {
            var entry$2$1 = $as_Lorg_yaml_model_YMapEntry(entry$2$2);
            var this$51 = entry$2$1.value$2;
            var conversion$6 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
            var iv$7 = $this$1.ctx$1;
            var map$4 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$51, conversion$6, iv$7));
            var node$5 = entry$2$1.key$2;
            var iv$8 = $this$1.ctx$1;
            var this$53 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$5, iv$8);
            var name = this$53.string__Lamf_core_model_domain_AmfScalar();
            var this$54 = $m_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping$().apply__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(map$4);
            var field$7 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1;
            var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$2$1.key$2);
            var propertyMapping = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$54, field$7, name, annotations$1));
            var jsx$7 = nodeMapping$1.id$1;
            var this$55 = entry$2$1.key$2;
            var conversion$7 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
            var iv$9 = $this$1.ctx$1;
            var str = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$55, conversion$7, iv$9)).text$3;
            var this$57 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
            var this$58 = this$57.platform$1;
            var url = this$57.str$1;
            var parent = ((jsx$7 + "/property/") + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$58, url));
            $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
            $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(propertyMapping, parent));
            var this$59 = $this$1.ctx$1;
            var id$1 = propertyMapping.id$1;
            $f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__closedNode__T__T__Lorg_yaml_model_YMap__V(this$59, "propertyMapping", id$1, map$4);
            var x1$3 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$4).key__T__s_Option("propertyTerm");
            if ((x1$3 instanceof $c_s_Some)) {
              var x2$2 = $as_s_Some(x1$3);
              var e$1 = $as_Lorg_yaml_model_YMapEntry(x2$2.value$2);
              var value$2 = new $c_Lamf_core_parser_ValueNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(e$1.value$2, $this$1.ctx$1);
              var propertyTermId = value$2.string__Lamf_core_model_domain_AmfScalar().toString__T();
              var x1$2$1 = $this$1.ctx$1.declarations$2.findPropertyTerm__T__Lamf_core_parser_SearchScope$Scope__s_Option(propertyTermId, $m_Lamf_core_parser_SearchScope$All$());
              if ((x1$2$1 instanceof $c_s_Some)) {
                var x2$2$1 = $as_s_Some(x1$2$1);
                var propertyTerm = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm(x2$2$1.value$2);
                var propertyId = propertyTerm.id$1;
                var field$8 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1;
                $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$8, propertyId))
              } else {
                var this$61 = $this$1.ctx$1.eh$1;
                var specification$4 = $m_Lamf_validation_DialectValidations$().DialectError$1;
                var node$6 = propertyMapping.id$1;
                var message$2 = ("Cannot find property term with alias " + propertyTermId);
                var ast$4 = e$1.value$2;
                var prop$4 = $m_s_None$();
                var l$4 = ast$4.location$1;
                $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$61, specification$4, node$6, prop$4, message$2, l$4)
              }
            } else {
              var this$66 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
              var this$62 = entry$2$1.key$2;
              var conversion$8 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
              var iv$10 = $this$1.ctx$1;
              var str$1 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$62, conversion$8, iv$10)).text$3;
              var this$64 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str$1);
              var this$65 = this$64.platform$1;
              var url$1 = this$64.str$1;
              var id$2 = $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$65, url$1);
              var propertyId$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$66, id$2).iri__T();
              var field$9 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1;
              $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$9, propertyId$1))
            };
            var this$69 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$4);
            var this$70 = this$69.key__T__s_Option("range");
            if ((!this$70.isEmpty__Z())) {
              var arg1$5 = this$70.get__O();
              var entry$2$3 = $as_Lorg_yaml_model_YMapEntry(arg1$5);
              var this$71 = entry$2$3.value$2;
              var x1$4 = this$71.tag__Lorg_yaml_model_YTag().tagType$3;
              var x$2 = $m_Lorg_yaml_model_YType$().Seq$1;
              if ((x$2 === x1$4)) {
                var this$74 = entry$2$3.value$2;
                var reader$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
                var this$73 = $m_sc_IndexedSeq$();
                var bf$1 = this$73.ReusableCBF$6;
                var conversion$9 = new $c_Lorg_yaml_convert_YRead$$anon$1().init___scg_CanBuildFrom__Lorg_yaml_convert_YRead(bf$1, reader$1);
                var iv$11 = $this$1.ctx$1;
                var range$1 = $as_sc_Seq($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$74, conversion$9, iv$11));
                var field$10 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1;
                $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(propertyMapping, field$10, range$1)
              } else {
                var value$3 = new $c_Lamf_core_parser_ValueNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(entry$2$3.value$2, $this$1.ctx$1);
                var range$2 = value$3.string__Lamf_core_model_domain_AmfScalar().toString__T();
                if ((range$2 === "guid")) {
                  var this$75 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
                  var range$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$75, "guid").iri__T();
                  var field$11 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1;
                  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$11, range$3))
                } else if (((range$2 === "string") || ((range$2 === "integer") || ((range$2 === "boolean") || ((range$2 === "float") || ((range$2 === "decimal") || ((range$2 === "double") || ((range$2 === "duration") || ((range$2 === "dateTime") || ((range$2 === "time") || ((range$2 === "date") || (range$2 === "anyType")))))))))))) {
                  var this$77 = $m_Lamf_core_vocabulary_Namespace$().Xsd$1;
                  var range$4 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$77, range$2).iri__T();
                  var field$12 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1;
                  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$12, range$4))
                } else if ((range$2 === "anyUri")) {
                  var range$5 = $m_Lamf_core_model_DataType$().AnyUri$1;
                  var field$13 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1;
                  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$13, range$5))
                } else if ((range$2 === "link")) {
                  var this$79 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
                  var range$6 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$79, "link").iri__T();
                  var field$14 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1;
                  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$14, range$6))
                } else if ((range$2 === "number")) {
                  var range$7 = $m_Lamf_core_model_DataType$().Number$1;
                  var field$15 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1;
                  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$15, range$7))
                } else if ((range$2 === "uri")) {
                  var range$8 = $m_Lamf_core_model_DataType$().AnyUri$1;
                  var field$16 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1;
                  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$16, range$8))
                } else if ((range$2 === "any")) {
                  var range$9 = $m_Lamf_core_model_DataType$().Any$1;
                  var field$17 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1;
                  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(propertyMapping, field$17, range$9))
                } else if ((range$2 === "anyNode")) {
                  var jsx$8 = $m_sc_Seq$();
                  var this$81 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
                  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$81, "anyNode").iri__T()];
                  var range$10 = $as_sc_Seq(jsx$8.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
                  var field$18 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1;
                  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(propertyMapping, field$18, range$10)
                } else {
                  var jsx$9 = $m_sc_Seq$();
                  var array$1 = [range$2];
                  var range$11 = $as_sc_Seq(jsx$9.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)));
                  var field$19 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1;
                  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(propertyMapping, field$19, range$11)
                }
              }
            };
            $this$1.parseMapKey__p1__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__V(map$4, propertyMapping);
            $this$1.parseMapValue__p1__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__V(map$4, propertyMapping);
            var this$88 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$4);
            var this$89 = this$88.key__T__s_Option("patch");
            if ((!this$89.isEmpty__Z())) {
              var arg1$6 = this$89.get__O();
              var entry$3$2 = $as_Lorg_yaml_model_YMapEntry(arg1$6);
              var node$7 = entry$3$2.value$2;
              var iv$12 = $this$1.ctx$1;
              var this$91 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$7, iv$12);
              var patchMethod$1 = this$91.string__Lamf_core_model_domain_AmfScalar();
              var field$20 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MergePolicy$1;
              var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3$2);
              $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(propertyMapping, field$20, patchMethod$1, annotations$2);
              var patchMethodValue$1 = patchMethod$1.toString__T();
              if ((!$m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().ALLOWED$undMERGE$undPOLICY$1.contains__O__Z(patchMethodValue$1))) {
                var this$92 = $this$1.ctx$1.eh$1;
                var specification$5 = $m_Lamf_validation_DialectValidations$().DialectError$1;
                var node$8 = propertyMapping.id$1;
                var message$3 = (("Unsupported propertu mapping patch operation '" + patchMethod$1) + "'");
                var ast$5 = entry$3$2.value$2;
                var prop$5 = $m_s_None$();
                var l$5 = ast$5.location$1;
                $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$92, specification$5, node$8, prop$5, message$3, l$5)
              }
            };
            var this$94 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$4);
            var this$95 = this$94.key__T__s_Option("mandatory");
            if ((!this$95.isEmpty__Z())) {
              var arg1$7 = this$95.get__O();
              var entry$4$1 = $as_Lorg_yaml_model_YMapEntry(arg1$7);
              var node$9 = entry$4$1.value$2;
              var iv$13 = $this$1.ctx$1;
              var this$97 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$9, iv$13);
              var required = this$97.$boolean__Lamf_core_model_domain_AmfScalar().toBool__Z();
              var value$4 = (required ? 1 : 0);
              var field$21 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MinCount$1;
              var value$5 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value$4, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4$1.value$2));
              var annotations$3 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4$1);
              $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(propertyMapping, field$21, value$5, annotations$3)
            };
            var jsx$10 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$4);
            var ctx$2 = $this$1.ctx$1;
            jsx$10.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("pattern", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(propertyMapping, ctx$2).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Pattern$1));
            var jsx$11 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$4);
            var ctx$3 = $this$1.ctx$1;
            jsx$11.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("minimum", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(propertyMapping, ctx$3).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Minimum$1));
            var jsx$12 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$4);
            var ctx$4 = $this$1.ctx$1;
            jsx$12.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("unique", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(propertyMapping, ctx$4).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Unique$1));
            var jsx$13 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$4);
            var ctx$5 = $this$1.ctx$1;
            jsx$13.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("maximum", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(propertyMapping, ctx$5).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Maximum$1));
            var jsx$14 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$4);
            var ctx$6 = $this$1.ctx$1;
            jsx$14.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("allowMultiple", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(propertyMapping, ctx$6).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().AllowMultiple$1));
            var jsx$15 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$4);
            var ctx$7 = $this$1.ctx$1;
            jsx$15.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("sorted", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(propertyMapping, ctx$7).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Sorted$1));
            var this$111 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$4);
            var this$112 = this$111.key__T__s_Option("enum");
            if ((!this$112.isEmpty__Z())) {
              var arg1$8 = this$112.get__O();
              var entry$5 = $as_Lorg_yaml_model_YMapEntry(arg1$8);
              var this$113 = entry$5.value$2;
              var conversion$10 = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
              var iv$14 = $this$1.ctx$1;
              var seq = $as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$113, conversion$10, iv$14));
              var jsx$17 = seq.nodes$3;
              var jsx$16 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2) {
                return (function(node$2$1) {
                  var node$10 = $as_Lorg_yaml_model_YNode(node$2$1);
                  var x1$5 = node$10.value__Lorg_yaml_model_YValue();
                  if ((x1$5 instanceof $c_Lorg_yaml_model_YScalar)) {
                    var iv$15 = $this$2.ctx$1;
                    var this$115 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$10, iv$15);
                    var xo = new $c_s_Some().init___O(this$115.string__Lamf_core_model_domain_AmfScalar());
                    return xo.toList__sci_List()
                  } else {
                    var this$118 = $this$2.ctx$1.eh$1;
                    var specification$6 = $m_Lamf_validation_DialectValidations$().DialectError$1;
                    $m_Lorg_yaml_model_YNode$();
                    var iv$16 = $this$2.ctx$1;
                    var conversion$11 = $m_Lorg_yaml_convert_YRead$StringYRead$();
                    var message$4 = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node$10, conversion$11, iv$16));
                    var property = $m_s_None$();
                    var lexical = $m_s_None$();
                    var location = $m_s_None$();
                    this$118.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification$6.id$1, "Cannot create enumeration constraint from not scalar value", property, message$4, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
                    var xo$1 = $m_s_None$();
                    return xo$1.toList__sci_List()
                  }
                })
              })($this$1));
              var this$120 = $m_sc_IndexedSeq$();
              var values = $as_sc_IndexedSeq(jsx$17.flatMap__F1__scg_CanBuildFrom__O(jsx$16, this$120.ReusableCBF$6));
              var field$22 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Enum$1;
              var value$6 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(values, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(seq));
              var annotations$4 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$5);
              $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(propertyMapping, field$22, value$6, annotations$4)
            };
            var this$122 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$4);
            var this$123 = this$122.key__T__s_Option("typeDiscriminator");
            if ((!this$123.isEmpty__Z())) {
              var arg1$9 = this$123.get__O();
              var entry$6 = $as_Lorg_yaml_model_YMapEntry(arg1$9);
              var this$124 = entry$6.value$2;
              var conversion$12 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
              var iv$17 = $this$1.ctx$1;
              var types$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$124, conversion$12, iv$17));
              var typeMapping$1 = $as_sci_Map(types$1.entries$3.foldLeft__O__F2__O($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this$3) {
                return (function(x0$1$2$2, x1$1$2$1) {
                  var x0$1$3 = $as_sci_Map(x0$1$2$2);
                  var x1$1$3 = $as_Lorg_yaml_model_YMapEntry(x1$1$2$1);
                  var this$125 = x1$1$3.value$2;
                  var conversion$13 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
                  var iv$18 = $this$3.ctx$1;
                  var nodeMappingId$1 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$125, conversion$13, iv$18)).text$3;
                  var this$126 = x1$1$3.key$2;
                  var conversion$14 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
                  var iv$19 = $this$3.ctx$1;
                  var self$1 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$126, conversion$14, iv$19)).text$3;
                  return x0$1$3.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$1, nodeMappingId$1))
                })
              })($this$1))));
              $f_Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__withTypeDiscriminator__sci_Map__O(propertyMapping, typeMapping$1)
            };
            var jsx$18 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$4);
            var ctx$8 = $this$1.ctx$1;
            jsx$18.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("typeDiscriminatorName", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(propertyMapping, ctx$8).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().TypeDiscriminatorName$1));
            var this$132 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$4);
            var this$133 = this$132.key__T__s_Option("isLink");
            if ((!this$133.isEmpty__Z())) {
              var arg1$10 = this$133.get__O();
              var entry$7 = $as_Lorg_yaml_model_YMapEntry(arg1$10);
              var this$134 = entry$7.value$2;
              var conversion$15 = $m_Lorg_yaml_convert_YRead$BooleanYRead$();
              var iv$20 = $this$1.ctx$1;
              var isLink = $uZ($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$134, conversion$15, iv$20));
              var field$23 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().ExternallyLinkable$1;
              $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(propertyMapping, field$23, isLink));
              var x1$6 = $as_Lamf_core_model_StrField(propertyMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1)).option$1;
              if ((x1$6 instanceof $c_s_Some)) {
                var x2$3 = $as_s_Some(x1$6);
                var v = $as_T(x2$3.value$2);
                var this$136 = $this$1.ctx$1.eh$1;
                var specification$7 = $m_Lamf_validation_DialectValidations$().DialectError$1;
                var node$12 = ("External links support in property mappings only can be declared in object properties but scalar range detected: " + v);
                $m_Lorg_yaml_model_YNode$();
                var node$11 = entry$7.value$2;
                var iv$21 = $this$1.ctx$1;
                var conversion$16 = $m_Lorg_yaml_convert_YRead$StringYRead$();
                var message$5 = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node$11, conversion$16, iv$21));
                var property$1 = $m_s_None$();
                var lexical$1 = $m_s_None$();
                var location$1 = $m_s_None$();
                this$136.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification$7.id$1, node$12, property$1, message$5, lexical$1, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location$1)
              }
            };
            var declarations = $this$1.ctx$1.declarations$2;
            var ctx$9 = $this$1.ctx$1;
            $f_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser__parseAnnotations__Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations__Lamf_core_parser_ParserContext__O($this$1, map$4, propertyMapping, declarations, ctx$9);
            $this$1.checkGuidUniqueContraint__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lorg_yaml_model_YPart__V(propertyMapping, map$4);
            return propertyMapping
          })
        })(this, nodeMapping));
        var this$137 = $m_sc_IndexedSeq$();
        var properties = $as_sc_IndexedSeq(jsx$19.map__F1__scg_CanBuildFrom__O(jsx$6, this$137.ReusableCBF$6));
        var x1$7 = properties.partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$2) {
          return (function(x$15$2) {
            var x$15 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$15$2);
            var this$138 = $as_Lamf_core_model_StrField(x$15.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1)).option$1;
            return this$138.isDefined__Z()
          })
        })(this)));
        if ((x1$7 === null)) {
          throw new $c_s_MatchError().init___O(x1$7)
        };
        var withTerm = $as_sc_IndexedSeq(x1$7.$$und1__O());
        var withourTerm = $as_sc_IndexedSeq(x1$7.$$und2__O());
        var this$146 = $as_sc_TraversableLike(withTerm.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
          return (function(x$17$2) {
            var x$17 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$17$2);
            var this$139 = $as_Lamf_core_model_StrField(x$17.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1)).option$1;
            return this$139.isDefined__Z()
          })
        })(this)))).groupBy__F1__sci_Map(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
          return (function(p$2) {
            var p = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(p$2);
            var this$140 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
            var this$141 = this$140.option$1;
            return $as_T((this$141.isEmpty__Z() ? null : this$141.get__O()))
          })
        })(this)));
        var f$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1) {
          return (function(x0$1$2$3) {
            var x0$1$4 = $as_T2(x0$1$2$3);
            if ((x0$1$4 !== null)) {
              var termKey = $as_T(x0$1$4.$$und1__O());
              var values$1 = $as_sc_IndexedSeq(x0$1$4.$$und2__O());
              if ((values$1.length__I() > 1)) {
                var this$142 = this$5$1.ctx$1.eh$1;
                var specification$8 = $m_Lamf_validation_DialectValidations$().DialectError$1;
                var node$13 = $as_Lamf_core_model_domain_AmfObject(values$1.head__O()).id__T();
                var message$6 = (("Property term value must be unique in a node mapping. Term " + termKey) + " repeated");
                var annotations$5 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(values$1.head__O()).annotations$1;
                $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$142, specification$8, node$13, message$6, annotations$5);
                var xo$2 = values$1.headOption__s_Option();
                return xo$2.toList__sci_List()
              }
            };
            var xo$3 = $as_sc_TraversableLike(x0$1$4.$$und2__O()).headOption__s_Option();
            return xo$3.toList__sci_List()
          })
        })(this));
        var this$145 = $m_sci_Iterable$();
        var bf$2 = this$145.ReusableCBFInstance$2;
        var filterProperties = $as_sci_Iterable($f_sc_TraversableLike__flatMap__F1__scg_CanBuildFrom__O(this$146, f$1, bf$2));
        var field$24 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1;
        var jsx$20 = filterProperties.toSeq__sc_Seq();
        var this$147 = $m_sc_IndexedSeq$();
        var values$2 = $as_sc_Seq(withourTerm.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$20, this$147.ReusableCBF$6));
        var annotations$6 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4);
        $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(nodeMapping, field$24, values$2, annotations$6)
      };
      var this$149 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$3);
      var this$150 = this$149.key__T__s_Option("extends");
      if ((!this$150.isEmpty__Z())) {
        var arg1$11 = this$150.get__O();
        var entry$5$1 = $as_Lorg_yaml_model_YMapEntry(arg1$11);
        var node$14 = entry$5$1.value$2;
        var reference = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node$14).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YScalarYRead$());
        if ((reference instanceof $c_s_Some)) {
          var this$152 = this.ctx$1;
          var node$15 = entry$5$1.value$2;
          var x1$8 = $f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__link__Lorg_yaml_model_YNode__s_util_Either(this$152, node$15);
          if ((x1$8 instanceof $c_s_util_Left)) {
            var x2$4 = $as_s_util_Left(x1$8);
            var key = $as_T(x2$4.value$2);
            var refTuple = new $c_T2().init___O__O(key, this.ctx$1.declarations$2.findNodeMapping__T__Lamf_core_parser_SearchScope$Scope__s_Option(key, $m_Lamf_core_parser_SearchScope$Fragments$()))
          } else {
            var this$153 = entry$5$1.value$2;
            var conversion$17 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
            var iv$22 = this.ctx$1;
            var text = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$153, conversion$17, iv$22)).text$3;
            var refTuple = new $c_T2().init___O__O(text, this.ctx$1.declarations$2.findNodeMapping__T__Lamf_core_parser_SearchScope$Scope__s_Option(text, $m_Lamf_core_parser_SearchScope$Named$()))
          };
          matchEnd8: {
            var parsed;
            if ((refTuple !== null)) {
              var text$2 = $as_T(refTuple.$$und1__O());
              var p2 = $as_s_Option(refTuple.$$und2__O());
              if ((text$2 !== null)) {
                if ((p2 instanceof $c_s_Some)) {
                  var x3$1 = $as_s_Some(p2);
                  var s = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x3$1.value$2);
                  var annotations$7 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$5$1.value$2);
                  var linkedNode = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(s, text$2, annotations$7));
                  f(linkedNode);
                  var parsed = new $c_s_Some().init___O(linkedNode);
                  break matchEnd8
                }
              }
            };
            if ((refTuple !== null)) {
              var text$3 = $as_T(refTuple.$$und1__O());
              if ((text$3 !== null)) {
                var linkedNode$2 = $m_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$().apply__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_NodeMapping(this.map$1);
                f(linkedNode$2);
                var refAst = this.map$1;
                var ctx$10 = this.ctx$1;
                $f_Lamf_core_model_domain_Linkable__unresolved__T__Lorg_yaml_model_YPart__T__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(linkedNode$2, text$3, refAst, "error", ctx$10);
                var parsed = new $c_s_Some().init___O(linkedNode$2);
                break matchEnd8
              }
            };
            throw new $c_s_MatchError().init___O(refTuple)
          }
        } else {
          var parsed = $m_s_None$()
        };
        matchEnd5$2: {
          if ((parsed instanceof $c_s_Some)) {
            var x2$5 = $as_s_Some(parsed);
            var resolvedNodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x2$5.value$2);
            if ((resolvedNodeMapping !== null)) {
              var jsx$21 = $m_sc_Seq$();
              var array$2 = [resolvedNodeMapping];
              var extend = $as_sc_Seq(jsx$21.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2)));
              var field$25 = $m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field();
              $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(nodeMapping, field$25, extend));
              break matchEnd5$2
            }
          };
          var this$157 = this.ctx$1.eh$1;
          var specification$9 = $m_Lamf_validation_DialectValidations$().DialectError$1;
          var node$16 = nodeMapping.id$1;
          if (reference.isEmpty__Z()) {
            var this$156 = $m_s_None$()
          } else {
            var arg1$12 = reference.get__O();
            var x$18 = $as_Lorg_yaml_model_YScalar(arg1$12);
            var this$156 = new $c_s_Some().init___O(x$18.mark$3.markText__T__T(x$18.text$3))
          };
          var message$7 = (("Cannot find extended node mapping with reference '" + (this$156.isEmpty__Z() ? "" : this$156.get__O())) + "'");
          var ast$6 = entry$5$1.value$2;
          var prop$6 = $m_s_None$();
          var l$6 = ast$6.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$157, specification$9, node$16, prop$6, message$7, l$6)
        }
      };
      var jsx$22 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$3);
      var ctx$11 = this.ctx$1;
      jsx$22.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("idTemplate", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(nodeMapping, ctx$11).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().IdTemplate$1));
      var this$160 = $as_Lamf_core_model_StrField(nodeMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().NodeTypeMapping$1)).option$1;
      if ((!this$160.isEmpty__Z())) {
        var arg1$13 = this$160.get__O();
        var x$19 = $as_T(arg1$13);
        this.validateTemplate__T__Lorg_yaml_model_YMap__sc_Seq__V(x$19, map$3, $as_sc_Seq(nodeMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)))
      };
      var declarations$1 = this.ctx$1.declarations$2;
      var ctx$12 = this.ctx$1;
      $f_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser__parseAnnotations__Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations__Lamf_core_parser_ParserContext__O(this, map$3, nodeMapping, declarations$1, ctx$12);
      this.ctx$1.declarations$2.$$plus$eq__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations(nodeMapping);
      var x1$10 = new $c_s_Some().init___O(nodeMapping)
    }
  } else {
    var x$3$1 = $m_Lorg_yaml_model_YType$().Str$1;
    if ((x$3$1 === x1)) {
      var node$17 = entry.value$2;
      var jsx$23 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node$17).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YScalarYRead$()).isDefined__Z()
    } else {
      var jsx$23 = false
    };
    if (jsx$23) {
      var this$162 = this.ctx$1;
      var node$18 = entry.value$2;
      var x1$9 = $f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__link__Lorg_yaml_model_YNode__s_util_Either(this$162, node$18);
      if ((x1$9 instanceof $c_s_util_Left)) {
        var x2$6 = $as_s_util_Left(x1$9);
        var key$1 = $as_T(x2$6.value$2);
        var refTuple$1 = new $c_T2().init___O__O(key$1, this.ctx$1.declarations$2.findNodeMapping__T__Lamf_core_parser_SearchScope$Scope__s_Option(key$1, $m_Lamf_core_parser_SearchScope$Fragments$()))
      } else {
        var this$163 = entry.value$2;
        var conversion$18 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
        var iv$23 = this.ctx$1;
        var text$1 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$163, conversion$18, iv$23)).text$3;
        var refTuple$1 = new $c_T2().init___O__O(text$1, this.ctx$1.declarations$2.findNodeMapping__T__Lamf_core_parser_SearchScope$Scope__s_Option(text$1, $m_Lamf_core_parser_SearchScope$Named$()))
      };
      matchEnd8$1: {
        var x1$10;
        if ((refTuple$1 !== null)) {
          var text$2$1 = $as_T(refTuple$1.$$und1__O());
          var p2$1 = $as_s_Option(refTuple$1.$$und2__O());
          if ((text$2$1 !== null)) {
            if ((p2$1 instanceof $c_s_Some)) {
              var x3$2 = $as_s_Some(p2$1);
              var s$1 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x3$2.value$2);
              var annotations$8 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
              var linkedNode$1 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(s$1, text$2$1, annotations$8));
              f(linkedNode$1);
              var x1$10 = new $c_s_Some().init___O(linkedNode$1);
              break matchEnd8$1
            }
          }
        };
        if ((refTuple$1 !== null)) {
          var text$3$1 = $as_T(refTuple$1.$$und1__O());
          if ((text$3$1 !== null)) {
            var linkedNode$2$1 = $m_Lamf_plugins_document_vocabularies_model_domain_NodeMapping$().apply__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_NodeMapping(this.map$1);
            f(linkedNode$2$1);
            var refAst$1 = this.map$1;
            var ctx$13 = this.ctx$1;
            $f_Lamf_core_model_domain_Linkable__unresolved__T__Lorg_yaml_model_YPart__T__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(linkedNode$2$1, text$3$1, refAst$1, "error", ctx$13);
            var x1$10 = new $c_s_Some().init___O(linkedNode$2$1);
            break matchEnd8$1
          }
        };
        throw new $c_s_MatchError().init___O(refTuple$1)
      }
    } else {
      var x$5 = $m_Lorg_yaml_model_YType$().Include$1;
      if ((x$5 === x1)) {
        var node$19 = entry.value$2;
        var jsx$24 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node$19).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YScalarYRead$()).isDefined__Z()
      } else {
        var jsx$24 = false
      };
      if (jsx$24) {
        var this$165 = this.ctx$1;
        var node$20 = entry.value$2;
        var x1$2$2 = $f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__link__Lorg_yaml_model_YNode__s_util_Either(this$165, node$20);
        if ((x1$2$2 instanceof $c_s_util_Left)) {
          var x2$7 = $as_s_util_Left(x1$2$2);
          var key$2 = $as_T(x2$7.value$2);
          var refTuple$2 = new $c_T2().init___O__O(key$2, this.ctx$1.declarations$2.findNodeMapping__T__Lamf_core_parser_SearchScope$Scope__s_Option(key$2, $m_Lamf_core_parser_SearchScope$Fragments$()))
        } else {
          var this$166 = entry.value$2;
          var conversion$19 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
          var iv$24 = this.ctx$1;
          var text$4 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$166, conversion$19, iv$24)).text$3;
          var refTuple$2 = new $c_T2().init___O__O(text$4, this.ctx$1.declarations$2.findNodeMapping__T__Lamf_core_parser_SearchScope$Scope__s_Option(text$4, $m_Lamf_core_parser_SearchScope$Named$()))
        };
        matchEnd8$2: {
          var x1$10;
          if ((refTuple$2 !== null)) {
            var text$2$2 = $as_T(refTuple$2.$$und1__O());
            var p2$2 = $as_s_Option(refTuple$2.$$und2__O());
            if ((text$2$2 !== null)) {
              if ((p2$2 instanceof $c_s_Some)) {
                var x3$3 = $as_s_Some(p2$2);
                var s$2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x3$3.value$2);
                var annotations$9 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
                var this$167 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(s$2, text$2$2, annotations$9));
                var field$26 = this$167.Name$1;
                var linkedNode$3 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$167, field$26, text$2$2)));
                f(linkedNode$3);
                var x1$10 = new $c_s_Some().init___O(linkedNode$3);
                break matchEnd8$2
              }
            }
          };
          if ((refTuple$2 !== null)) {
            var text$3$2 = $as_T(refTuple$2.$$und1__O());
            if ((text$3$2 !== null)) {
              $m_Lamf_core_parser_Annotations$();
              var annotations$10 = new $c_Lamf_core_parser_Annotations().init___();
              var fields = new $c_Lamf_core_parser_Fields().init___();
              var arg1$14 = new $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations$10);
              var nodeMappingTmp = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(f(arg1$14));
              var thiz = nodeMappingTmp.id$1;
              var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "#", 0);
              var this$174 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
              var suffix = $as_T($f_sc_IndexedSeqOptimized__head__O(this$174));
              var this$177 = this.ctx$1;
              var thiz$1 = nodeMappingTmp.id$1;
              var node$21 = $as_T(thiz$1.split(suffix).join(""));
              var ast$7 = entry.value$2;
              $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__missingFragmentViolation__T__T__Lorg_yaml_model_YPart__V(this$177, text$3$2, node$21, ast$7);
              var x1$10 = $m_s_None$();
              break matchEnd8$2
            }
          };
          throw new $c_s_MatchError().init___O(refTuple$2)
        }
      } else {
        var x1$10 = $m_s_None$()
      }
    }
  };
  matchEnd5: {
    if ((x1$10 instanceof $c_s_Some)) {
      var x2$8 = $as_s_Some(x1$10);
      var encoded = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x2$8.value$2);
      if ((encoded !== null)) {
        fragment.fields$1.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1, encoded, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
        break matchEnd5
      }
    }
  };
  return fragment
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype.checkGuidUniqueContraint__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lorg_yaml_model_YPart__V = (function(propertyMapping, ast) {
  var this$1 = $as_Lamf_core_model_StrField(propertyMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1)).option$1;
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var literal = $as_T(arg1);
    var this$2 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    if ((literal === new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$2, "guid").iri__T())) {
      var this$4 = $as_Lamf_core_model_BoolField(propertyMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Unique$1)).option$1;
      var jsx$1 = (!$uZ((this$4.isEmpty__Z() ? false : this$4.get__O())))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var this$7 = this.ctx$1.eh$1;
      var specification = $m_Lamf_validation_DialectValidations$().GuidRangeWithoutUnique$1;
      var node = propertyMapping.id$1;
      var this$5 = $as_Lamf_core_model_StrField(propertyMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
      var this$6 = this$5.option$1;
      var message = (("Declaration of property '" + $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()))) + "' with range GUID and without unique constraint");
      var property = $m_s_None$();
      var location = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$7, specification, node, property, message, location)
    }
  }
});
var $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser: 0
}, false, "amf.plugins.document.vocabularies.parser.dialects.DialectsParser", {
  Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser: 1,
  O: 1,
  Lamf_core_parser_BaseSpecParser: 1,
  Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser: 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser;
function $f_Lamf_plugins_document_vocabularies_parser_instances_JsonPointerResolver__resolveJSONPointer__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__s_Option($thiz, map, mapping, id) {
  var mappingIds = $f_Lamf_plugins_document_vocabularies_parser_instances_NodeMappableHelper__allNodeMappingIds__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__sci_Set($thiz, mapping);
  var entry = $as_Lorg_yaml_model_YMapEntry(new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("$ref").get__O());
  var this$2 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
  var iv = $thiz.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
  var pointer = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv));
  var fullPointer = ((($uI(pointer.length) >= 0) && ($as_T(pointer.substring(0, $uI("#".length))) === "#")) ? (("" + $thiz.root$1.location$1) + pointer) : $f_Lamf_plugins_document_vocabularies_parser_instances_JsonPointerResolver__resolvedPath__T__T($thiz, pointer));
  var this$8 = $thiz.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().findJsonPointer__T__s_Option(fullPointer);
  if (this$8.isEmpty__Z()) {
    var this$15 = $m_s_None$()
  } else {
    var arg1 = this$8.get__O();
    var node = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(arg1);
    if (mappingIds.contains__O__Z(node.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping().id$1)) {
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(map);
      var this$9 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(node, pointer, annotations));
      var jsx$3 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$9, id));
      var jsx$2 = $m_sc_Seq$();
      var array = [mapping.id__T()];
      var jsx$1 = jsx$3.withInstanceTypes__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))))
    } else {
      var this$12 = $m_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$().apply__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(map);
      var jsx$5 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$12, id));
      var jsx$4 = $m_sc_Seq$();
      var array$1 = [mapping.id__T()];
      var linkedNode = jsx$5.withInstanceTypes__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_sc_Seq(jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1))));
      var ctx = $thiz.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
      $f_Lamf_core_model_domain_Linkable__unresolved__T__Lorg_yaml_model_YPart__T__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(linkedNode, fullPointer, map, "error", ctx);
      var jsx$1 = linkedNode
    };
    var this$15 = new $c_s_Some().init___O(jsx$1)
  };
  if (this$15.isEmpty__Z()) {
    var this$16 = $m_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$().apply__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(map);
    var jsx$7 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$16, id));
    var jsx$6 = $m_sc_Seq$();
    var array$2 = [mapping.id__T()];
    var linkedNode$1 = jsx$7.withInstanceTypes__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_sc_Seq(jsx$6.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2))));
    var ctx$1 = $thiz.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    $f_Lamf_core_model_domain_Linkable__unresolved__T__Lorg_yaml_model_YPart__T__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(linkedNode$1, fullPointer, map, "error", ctx$1);
    return new $c_s_Some().init___O(linkedNode$1)
  } else {
    return this$15
  }
}
function $f_Lamf_plugins_document_vocabularies_parser_instances_JsonPointerResolver__resolvedPath__T__T($thiz, str) {
  var base = $thiz.root$1.location$1;
  if ((($uI(str.length) >= 0) && ($as_T(str.substring(0, $uI("/".length))) === "/"))) {
    var fullPath = str
  } else if (($uI(str.indexOf("://")) !== (-1))) {
    var fullPath = str
  } else if ((($uI(str.length) >= 0) && ($as_T(str.substring(0, $uI("#".length))) === "#"))) {
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(base, "#", 0);
    var this$16 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    var fullPath = (("" + $as_T($f_sc_IndexedSeqOptimized__head__O(this$16))) + str)
  } else {
    var fullPath = (("" + $f_Lamf_plugins_document_vocabularies_parser_instances_JsonPointerResolver__basePath__T__T($thiz, base)) + str)
  };
  if (($uI(fullPath.indexOf("#")) !== (-1))) {
    var parts = $m_sjsr_RuntimeString$().split__T__T__I__AT(fullPath, "#", 0);
    var jsx$2 = $thiz.platform$1;
    var this$22 = new $c_scm_ArrayOps$ofRef().init___AO(parts);
    var jsx$1 = jsx$2.resolvePath__T__T($as_T($f_sc_IndexedSeqOptimized__head__O(this$22)));
    var this$24 = new $c_scm_ArrayOps$ofRef().init___AO(parts);
    return ((jsx$1 + "#") + $f_sc_IndexedSeqOptimized__last__O(this$24))
  } else {
    return $thiz.platform$1.resolvePath__T__T(fullPath)
  }
}
function $f_Lamf_plugins_document_vocabularies_parser_instances_JsonPointerResolver__basePath__T__T($thiz, path) {
  if (($uI(path.indexOf("#")) !== (-1))) {
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(path, "#", 0);
    var this$6 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    var withoutHash = $as_T($f_sc_IndexedSeqOptimized__head__O(this$6))
  } else {
    var withoutHash = path
  };
  var this$10 = new $c_sci_StringOps().init___T(withoutHash);
  var n = $uI(withoutHash.lastIndexOf("/"));
  return ($as_T($f_sc_IndexedSeqOptimized__splitAt__I__T2(this$10, n).$$und1__O()) + "/")
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_PayloadPlugin$() {
  $c_Lamf_client_plugins_AMFDocumentPlugin.call(this);
  this.ID$2 = null;
  this.vendors$2 = null;
  this.allowRecursiveReferences$2 = false
}
$c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype = new $h_Lamf_client_plugins_AMFDocumentPlugin();
$c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype.constructor = $c_Lamf_plugins_document_webapi_PayloadPlugin$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_PayloadPlugin$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_PayloadPlugin$.prototype = $c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype;
$c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype.init___ = (function() {
  $c_Lamf_client_plugins_AMFDocumentPlugin.prototype.init___.call(this);
  $n_Lamf_plugins_document_webapi_PayloadPlugin$ = this;
  this.ID$2 = $m_Lamf_core_remote_Payload$().name$1;
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_core_remote_Payload$().name$1];
  this.vendors$2 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  this.allowRecursiveReferences$2 = false;
  return this
});
$c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype.init__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
    return (function() {
      return $m_Lamf_plugins_document_webapi_PayloadPlugin$()
    })
  })(this)), executionContext)
});
$c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype.notRAML__p2__Lamf_core_Root__Z = (function(root) {
  var x1 = root.parsed$1;
  if ((x1 instanceof $c_Lamf_core_parser_SyamlParsedDocument)) {
    var x2 = $as_Lamf_core_parser_SyamlParsedDocument(x1);
    if (x2.comment$2.isEmpty__Z()) {
      return true
    } else {
      var this$1 = x2.comment$2;
      if ((!this$1.isEmpty__Z())) {
        var arg1 = this$1.get__O();
        var x$1 = $as_T(arg1);
        var jsx$1 = (($uI(x$1.length) >= 0) && ($as_T(x$1.substring(0, $uI("%".length))) === "%"))
      } else {
        var jsx$1 = false
      };
      return (!jsx$1)
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype.unparseAsYDocument__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__s_Option = (function(unit, renderOptions, shapeRenderOptions) {
  if ((unit instanceof $c_Lamf_core_model_document_PayloadFragment)) {
    var x2 = $as_Lamf_core_model_document_PayloadFragment(unit);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Lamf_core_errorhandling_ErrorHandler($as_Lamf_core_model_domain_DataNode(x2.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().Encodes$1)), $m_Lamf_core_emitter_SpecOrdering$Lexical$(), renderOptions.eh$1).emitDocument__Lorg_yaml_model_YDocument())
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype.canUnparse__Lamf_core_model_document_BaseUnit__Z = (function(unit) {
  return (unit instanceof $c_Lamf_core_model_document_PayloadFragment)
});
$c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype.notOAS__p2__Lamf_core_Root__Z = (function(root) {
  var x1 = root.parsed$1;
  if ((x1 instanceof $c_Lamf_core_parser_SyamlParsedDocument)) {
    var x2 = $as_Lamf_core_parser_SyamlParsedDocument(x1);
    var x1$2 = x2.document$2.node$2.value__Lorg_yaml_model_YValue();
    if ((!(x1$2 instanceof $c_Lorg_yaml_model_YMap))) {
      return true
    } else {
      var x2$2 = $as_Lorg_yaml_model_YMap(x1$2);
      return (!x2$2.entries$3.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x$2$2) {
          var x$2 = $as_Lorg_yaml_model_YMapEntry(x$2$2);
          var thiz = $as_Lorg_yaml_model_YScalar(x$2.key$2.value__Lorg_yaml_model_YValue()).text$3;
          return (($uI(thiz.length) >= 0) && ($as_T(thiz.substring(0, $uI("swagger".length))) === "swagger"))
        })
      })(this))))
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype.modelEntities__sc_Seq = (function() {
  return $m_sci_Nil$()
});
$c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype.parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option = (function(root, parentContext, platform, options) {
  var x1 = root.parsed$1;
  if ((x1 instanceof $c_Lamf_core_parser_SyamlParsedDocument)) {
    var x2 = $as_Lamf_core_parser_SyamlParsedDocument(x1);
    var x$1 = root.location$1;
    var x$2 = parentContext.refs$1;
    var x$5 = $m_s_None$();
    var x$6 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2;
    var ctx = new $c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions(x$1, x$2, parentContext, x$5, x$6, options);
    var document = x2.document$2;
    var location = root.location$1;
    var mediaType = root.mediatype$1;
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_PayloadParser().init___Lorg_yaml_model_YDocument__T__T__Lamf_plugins_document_webapi_contexts_WebApiContext(document, location, mediaType, ctx).parseUnit__Lamf_core_model_document_PayloadFragment())
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype.documentSyntaxes__sc_Seq = (function() {
  var jsx$1 = $m_sc_Seq$();
  var array = ["application/amf+json", "application/amf+yaml", "application/payload+json", "application/payload+yaml"];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype.emit__Lamf_core_model_document_BaseUnit__Lorg_yaml_builder_DocBuilder__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__Z = (function(unit, builder, renderOptions, shapeRenderOptions) {
  if ((builder instanceof $c_Lorg_yaml_builder_YDocumentBuilder)) {
    var x2 = $as_Lorg_yaml_builder_YDocumentBuilder(builder);
    if ((unit instanceof $c_Lamf_core_model_document_PayloadFragment)) {
      var x3 = $as_Lamf_core_model_document_PayloadFragment(unit);
      x2.document$und$eq__Lorg_yaml_model_YPart__V(new $c_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Lamf_core_errorhandling_ErrorHandler($as_Lamf_core_model_domain_DataNode(x3.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().Encodes$1)), $m_Lamf_core_emitter_SpecOrdering$Lexical$(), renderOptions.eh$1).emitDocument__Lorg_yaml_model_YDocument());
      return true
    }
  };
  return false
});
$c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype.referenceHandler__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_ReferenceHandler = (function(eh) {
  return $m_Lamf_core_parser_SimpleReferenceHandler$()
});
$c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype.vendors__sc_Seq = (function() {
  return this.vendors$2
});
$c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype.ID__T = (function() {
  return this.ID$2
});
$c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype.dependencies__sc_Seq = (function() {
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$(), $m_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$()];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype.canParse__Lamf_core_Root__Z = (function(root) {
  return (this.notRAML__p2__Lamf_core_Root__Z(root) && this.notOAS__p2__Lamf_core_Root__Z(root))
});
$c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype.allowRecursiveReferences__Z = (function() {
  return this.allowRecursiveReferences$2
});
$c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype.serializableAnnotations__sci_Map = (function() {
  return $m_sci_Map$EmptyMap$()
});
$c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_errorhandling_ErrorHandler__T__Lamf_core_model_document_BaseUnit = (function(unit, errorHandler, pipelineId) {
  return new $c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline().init___Lamf_ProfileName__Lamf_core_errorhandling_ErrorHandler($m_Lamf_AmfProfile$(), errorHandler).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit)
});
var $d_Lamf_plugins_document_webapi_PayloadPlugin$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_PayloadPlugin$: 0
}, false, "amf.plugins.document.webapi.PayloadPlugin$", {
  Lamf_plugins_document_webapi_PayloadPlugin$: 1,
  Lamf_client_plugins_AMFDocumentPlugin: 1,
  O: 1,
  Lamf_client_plugins_AMFPlugin: 1
});
$c_Lamf_plugins_document_webapi_PayloadPlugin$.prototype.$classData = $d_Lamf_plugins_document_webapi_PayloadPlugin$;
var $n_Lamf_plugins_document_webapi_PayloadPlugin$ = (void 0);
function $m_Lamf_plugins_document_webapi_PayloadPlugin$() {
  if ((!$n_Lamf_plugins_document_webapi_PayloadPlugin$)) {
    $n_Lamf_plugins_document_webapi_PayloadPlugin$ = new $c_Lamf_plugins_document_webapi_PayloadPlugin$().init___()
  };
  return $n_Lamf_plugins_document_webapi_PayloadPlugin$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterContext() {
  $c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.call(this);
  this.typeDefMatcher$3 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext();
$c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterContext.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterContext.prototype.typeDefMatcher__Lamf_plugins_document_webapi_parser_OasTypeDefStringValueMatcher = (function() {
  return this.typeDefMatcher$3
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions = (function(eh, refEmitter, options) {
  $c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions.call(this, eh, refEmitter, options);
  this.typeDefMatcher$3 = $m_Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$();
  return this
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterFactory() {
  $c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory.call(this)
}
$c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterFactory.prototype = new $h_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory();
$c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterFactory.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterFactory;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterFactory() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterFactory.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterFactory.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterFactory.prototype.recursiveShapeEmitter__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(recursive$2, ordering$2, schemaPath$2) {
      var recursive = $as_Lamf_core_model_domain_RecursiveShape(recursive$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      var schemaPath = $as_sc_Seq(schemaPath$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter().init___Lamf_core_model_domain_RecursiveShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(recursive, ordering, schemaPath, $this.spec$3)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterFactory.prototype.declaredTypesEmitter__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(types$2, references$2, ordering$2) {
      var types = $as_sc_Seq(types$2);
      var references = $as_sc_Seq(references$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_declaration_AsyncDeclaredTypesEmitters$().obtainEmitter__sc_Seq__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext__Lamf_core_emitter_EntryEmitter(types, references, ordering, $this.spec$3)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterFactory.prototype.typeEmitters__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq = (function(shape, ordering, ignored, references, pointer, schemaPath) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(shape, ordering, ignored, references, pointer, schemaPath, false, this.spec$3).emitters__sc_Seq()
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory() {
  $c_O.call(this);
  this.spec$1 = null;
  this.typesKey$1 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype.typesEmitter__F5 = (function() {
  return new $c_sjsr_AnonFunction5().init___sjs_js_Function5((function($this) {
    return (function(shape$2, ordering$2, annotations$2, ignored$2, references$2) {
      var shape = $as_Lamf_core_model_domain_Shape(shape$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      var annotations = $as_s_Option(annotations$2);
      var ignored = $as_sc_Seq(ignored$2);
      var references = $as_sc_Seq(references$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(shape, ordering, annotations, ignored, references, $this.spec$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype.init___Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(spec) {
  this.spec$1 = spec;
  this.typesKey$1 = "schemas";
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype.parameterEmitter__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(parameter$2, ordering$2, references$2) {
      var parameter = $as_Lamf_plugins_domain_webapi_models_Parameter(parameter$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      var references = $as_sc_Seq(references$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter().init___Lamf_plugins_domain_webapi_models_Parameter__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(parameter, ordering, references, $this.spec$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype.tagToReferenceEmitter__F3 = (function() {
  return $f_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory__tagToReferenceEmitter__F3(this)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype.payloadsEmitter__F4 = (function() {
  return new $c_sjsr_AnonFunction4().init___sjs_js_Function4((function($this) {
    return (function(key$2, f$2, ordering$2, references$2) {
      var key = $as_T(key$2);
      var f = $as_Lamf_core_parser_FieldEntry(f$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      var references = $as_sc_Seq(references$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(key, f, ordering, references, $this.spec$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype.namedSecurityEmitter__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(securityScheme$2, references$2, ordering$2) {
      var securityScheme = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(securityScheme$2);
      var references = $as_sc_Seq(references$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter().init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(securityScheme, references, ordering, $this.spec$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype.endpointEmitter__F4 = (function() {
  return new $c_sjsr_AnonFunction4().init___sjs_js_Function4((function($this) {
    return (function(endpoint$2, ordering$2, children$2, references$2) {
      var endpoint = $as_Lamf_plugins_domain_webapi_models_EndPoint(endpoint$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      var children = $as_scm_ListBuffer(children$2);
      var references = $as_sc_Seq(references$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter().init___Lamf_plugins_domain_webapi_models_EndPoint__Lamf_core_emitter_SpecOrdering__scm_ListBuffer__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(endpoint, ordering, children, references, $this.spec$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype.facetsInstanceEmitter__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(shapeExtension$2, ordering$2) {
      var shapeExtension = $as_Lamf_core_model_domain_extensions_ShapeExtension(shapeExtension$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      return new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$2().init___Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory__Lamf_core_model_domain_extensions_ShapeExtension__Lamf_core_emitter_SpecOrdering($this, shapeExtension, ordering)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype.annotationTypeEmitter__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(property$2, ordering$2) {
      var property = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(property$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      return new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4().init___Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory__Lamf_core_model_domain_extensions_CustomDomainProperty__Lamf_core_emitter_SpecOrdering($this, property, ordering)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype.annotationEmitter__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(domainExtension$2, ordering$2) {
      var domainExtension = $as_Lamf_core_model_domain_extensions_DomainExtension(domainExtension$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      return new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$3().init___Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory__Lamf_core_model_domain_extensions_DomainExtension__Lamf_core_emitter_SpecOrdering($this, domainExtension, ordering)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype.rootLevelEmitters__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(document$2, ordering$2) {
      var document = $as_Lamf_core_model_document_BaseUnit(document$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters().init___Lamf_core_model_document_BaseUnit__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(document, ordering, $this.spec$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype.customFacetsEmitter__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(f$2, ordering$2, x$3$2) {
      var f = $as_Lamf_core_parser_FieldEntry(f$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      $as_sc_Seq(x$3$2);
      return new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$1().init___Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering($this, f, ordering)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype.headerEmitter__F3 = (function() {
  return this.parameterEmitter__F3()
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype.retrieveHeader__Lamf_core_model_document_BaseUnit__s_Option = (function(document) {
  if ((document instanceof $c_Lamf_core_model_document_Document)) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$().text$1)
  } else {
    var this$1 = this.spec$1;
    var this$2 = this$1.eh$1;
    var specification = $m_Lamf_validations_RenderSideValidations$().RenderValidation$1;
    var node = document.id__T();
    var property = $m_s_None$();
    var lexical = document.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var location = $f_Lamf_core_model_document_BaseUnit__location__s_Option(document);
    this$2.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "Document has no header.", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype.typesKey__T = (function() {
  return this.typesKey$1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype.responseEmitter__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(response$2, ordering$2, references$2) {
      var response = $as_Lamf_plugins_domain_webapi_models_Response(response$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      var references = $as_sc_Seq(references$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter().init___Lamf_plugins_domain_webapi_models_Response__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(response, ordering, references, $this.spec$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype.securityRequirementEmitter__F2 = (function() {
  return $f_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory__securityRequirementEmitter__F2(this)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype.operationEmitter__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(operation$2, ordering$2, references$2) {
      var operation = $as_Lamf_plugins_domain_webapi_models_Operation(operation$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      var references = $as_sc_Seq(references$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter().init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(operation, ordering, references, $this.spec$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype.spec__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function() {
  return this.spec$1
});
var $d_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.raml.Raml08EmitterVersionFactory", {
  Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory: 1,
  Lamf_plugins_document_webapi_contexts_SpecEmitterFactory: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4$$anon$5() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4$$anon$5.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4$$anon$5.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4$$anon$5;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4$$anon$5() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4$$anon$5.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4$$anon$5.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4$$anon$5.prototype.init___Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4 = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4$$anon$5.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.$$outer$1.$$outer$2.spec$1;
  var this$4 = this$1.eh$1;
  var specification = $m_Lamf_validations_RenderSideValidations$().RenderValidation$1;
  var node = this.$$outer$1.property$1$f.id$1;
  var property = $m_s_None$();
  var message = ("Custom facets not supported for vendor " + this.$$outer$1.$$outer$2.spec$1.vendor__Lamf_core_remote_Vendor());
  var this$2 = this.$$outer$1.property$1$f;
  var lexical = this$2.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  var this$3 = this.$$outer$1.property$1$f;
  var location = $f_Lamf_core_model_domain_AmfElement__location__s_Option(this$3);
  this$4.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4$$anon$5.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.$$outer$1.property$1$f.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4$$anon$5 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4$$anon$5: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.raml.Raml08EmitterVersionFactory$$anon$4$$anon$5", {
  Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4$$anon$5: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4$$anon$5.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$4$$anon$5;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08SpecEmitterContext() {
  $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this);
  this.factory$3 = null;
  this.vendor$3 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08SpecEmitterContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext();
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08SpecEmitterContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08SpecEmitterContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08SpecEmitterContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08SpecEmitterContext.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08SpecEmitterContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08SpecEmitterContext.prototype.vendor__Lamf_core_remote_Vendor = (function() {
  return this.vendor$3
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08SpecEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_core_emitter_ShapeRenderOptions = (function(eh, options) {
  var refEmitter = $m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$();
  $c_Lamf_plugins_document_webapi_contexts_SpecEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions.call(this, eh, refEmitter, options);
  this.factory$3 = new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory().init___Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(this);
  this.vendor$3 = $m_Lamf_core_remote_Raml08$();
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08SpecEmitterContext.prototype.factory__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory = (function() {
  return this.factory$3
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08SpecEmitterContext.prototype.factory__Lamf_plugins_document_webapi_contexts_SpecEmitterFactory = (function() {
  return this.factory$3
});
var $d_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08SpecEmitterContext = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08SpecEmitterContext: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.raml.Raml08SpecEmitterContext", {
  Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08SpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_SpecEmitterContext: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08SpecEmitterContext.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08SpecEmitterContext;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory() {
  $c_O.call(this);
  this.spec$1 = null;
  this.typesKey$1 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype.typesEmitter__F5 = (function() {
  return new $c_sjsr_AnonFunction5().init___sjs_js_Function5((function($this) {
    return (function(shape$2, ordering$2, annotations$2, ignored$2, references$2) {
      var shape = $as_Lamf_core_model_domain_Shape(shape$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      var annotations = $as_s_Option(annotations$2);
      var ignored = $as_sc_Seq(ignored$2);
      var references = $as_sc_Seq(references$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(shape, ordering, annotations, ignored, references, $this.spec$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype.init___Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(spec) {
  this.spec$1 = spec;
  this.typesKey$1 = "types";
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype.parameterEmitter__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(parameter$2, ordering$2, references$2) {
      var parameter = $as_Lamf_plugins_domain_webapi_models_Parameter(parameter$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      var references = $as_sc_Seq(references$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter().init___Lamf_plugins_domain_webapi_models_Parameter__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(parameter, ordering, references, $this.spec$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype.tagToReferenceEmitter__F3 = (function() {
  return $f_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory__tagToReferenceEmitter__F3(this)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype.payloadsEmitter__F4 = (function() {
  return new $c_sjsr_AnonFunction4().init___sjs_js_Function4((function($this) {
    return (function(key$2, f$2, ordering$2, references$2) {
      var key = $as_T(key$2);
      var f = $as_Lamf_core_parser_FieldEntry(f$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      var references = $as_sc_Seq(references$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(key, f, ordering, references, $this.spec$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype.namedSecurityEmitter__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(securityScheme$2, references$2, ordering$2) {
      var securityScheme = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(securityScheme$2);
      var references = $as_sc_Seq(references$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter().init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(securityScheme, references, ordering, $this.spec$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype.endpointEmitter__F4 = (function() {
  return new $c_sjsr_AnonFunction4().init___sjs_js_Function4((function($this) {
    return (function(endpoint$2, ordering$2, children$2, references$2) {
      var endpoint = $as_Lamf_plugins_domain_webapi_models_EndPoint(endpoint$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      var children = $as_scm_ListBuffer(children$2);
      var references = $as_sc_Seq(references$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter().init___Lamf_plugins_domain_webapi_models_EndPoint__Lamf_core_emitter_SpecOrdering__scm_ListBuffer__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(endpoint, ordering, children, references, $this.spec$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype.facetsInstanceEmitter__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(shapeExtension$2, ordering$2) {
      var shapeExtension = $as_Lamf_core_model_domain_extensions_ShapeExtension(shapeExtension$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter().init___Lamf_core_model_domain_extensions_ShapeExtension__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(shapeExtension, ordering, $this.spec$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype.annotationTypeEmitter__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(property$2, ordering$2) {
      var property = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(property$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter().init___Lamf_core_model_domain_extensions_CustomDomainProperty__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(property, ordering, $this.spec$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype.annotationEmitter__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(domainExtension$2, ordering$2) {
      var domainExtension = $as_Lamf_core_model_domain_extensions_DomainExtension(domainExtension$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter().init___Lamf_core_model_domain_extensions_DomainExtension__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(domainExtension, ordering, $this.spec$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype.rootLevelEmitters__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(document$2, ordering$2) {
      var document = $as_Lamf_core_model_document_BaseUnit(document$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters().init___Lamf_core_model_document_BaseUnit__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(document, ordering, $this.spec$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype.customFacetsEmitter__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(f$2, ordering$2, references$2) {
      var f = $as_Lamf_core_parser_FieldEntry(f$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      var references = $as_sc_Seq(references$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(f, ordering, references, $this.spec$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype.headerEmitter__F3 = (function() {
  return this.parameterEmitter__F3()
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype.retrieveHeader__Lamf_core_model_document_BaseUnit__s_Option = (function(document) {
  if ((document instanceof $c_Lamf_plugins_document_webapi_model_Extension)) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$().text$1)
  } else if ((document instanceof $c_Lamf_plugins_document_webapi_model_Overlay)) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$().text$1)
  } else if ((document instanceof $c_Lamf_core_model_document_Document)) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$().text$1)
  } else {
    var this$1 = this.spec$1;
    var this$2 = this$1.eh$1;
    var specification = $m_Lamf_validations_RenderSideValidations$().RenderValidation$1;
    var node = document.id__T();
    var property = $m_s_None$();
    var lexical = document.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var location = $f_Lamf_core_model_document_BaseUnit__location__s_Option(document);
    this$2.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "Document has no header.", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype.typesKey__T = (function() {
  return this.typesKey$1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype.responseEmitter__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(response$2, ordering$2, references$2) {
      var response = $as_Lamf_plugins_domain_webapi_models_Response(response$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      var references = $as_sc_Seq(references$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter().init___Lamf_plugins_domain_webapi_models_Response__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(response, ordering, references, $this.spec$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype.securityRequirementEmitter__F2 = (function() {
  return $f_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory__securityRequirementEmitter__F2(this)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype.operationEmitter__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(operation$2, ordering$2, references$2) {
      var operation = $as_Lamf_plugins_domain_webapi_models_Operation(operation$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      var references = $as_sc_Seq(references$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter().init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(operation, ordering, references, $this.spec$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype.spec__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function() {
  return this.spec$1
});
var $d_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.raml.Raml10EmitterVersionFactory", {
  Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory: 1,
  Lamf_plugins_document_webapi_contexts_SpecEmitterFactory: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext() {
  $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this);
  this.factory$3 = null;
  this.vendor$3 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext();
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext.prototype.vendor__Lamf_core_remote_Vendor = (function() {
  return this.vendor$3
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext.prototype.factory__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory = (function() {
  return this.factory$3
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions = (function(eh, refEmitter, options) {
  $c_Lamf_plugins_document_webapi_contexts_SpecEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions.call(this, eh, refEmitter, options);
  this.factory$3 = new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10EmitterVersionFactory().init___Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(this);
  this.vendor$3 = $m_Lamf_core_remote_Raml10$();
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext.prototype.factory__Lamf_plugins_document_webapi_contexts_SpecEmitterFactory = (function() {
  return this.factory$3
});
var $d_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.raml.Raml10SpecEmitterContext", {
  Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_SpecEmitterContext: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext$$anon$6() {
  $c_O.call(this);
  this.reference$1$1 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext$$anon$6.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext$$anon$6.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext$$anon$6;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext$$anon$6() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext$$anon$6.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext$$anon$6.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext$$anon$6.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$1 = $m_Lorg_yaml_model_YNode$();
  var this$1 = this.reference$1$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1;
  var node = jsx$1.include__T__T__Lorg_yaml_model_YNode$MutRef($as_T((this$2.isEmpty__Z() ? $as_T(this.reference$1$1.location__s_Option().get__O()) : this$2.get__O())), ($m_Lorg_yaml_model_YNode$(), ""));
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer(node)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext$$anon$6.prototype.init___Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext__Lamf_core_model_domain_Linkable = (function($$outer, reference$1) {
  this.reference$1$1 = reference$1;
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext$$anon$6.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.reference$1$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext$$anon$6 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext$$anon$6: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.raml.RamlSpecEmitterContext$$anon$6", {
  Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext$$anon$6: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext$$anon$6.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext$$anon$6;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory() {
  $c_O.call(this);
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory.prototype.securitySchemeParser__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(part$2, adopt$2) {
      var part = $as_Lorg_yaml_model_YPart(part$2);
      var adopt = $as_F1(adopt$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser().init___Lorg_yaml_model_YPart__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(part, adopt, $this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext())
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory.prototype.init___Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(ctx) {
  this.ctx$1 = ctx;
  return this
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08VersionFactory() {
  $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory.call(this)
}
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08VersionFactory.prototype = new $h_Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory();
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08VersionFactory.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08VersionFactory;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08VersionFactory() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08VersionFactory.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08VersionFactory.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08VersionFactory.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function() {
  return this.ctx$1
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08VersionFactory.prototype.init___Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(ctx) {
  $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory.prototype.init___Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08VersionFactory.prototype.requestParser__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(map$2, producer$2, parseOptional$2) {
      var map = $as_Lorg_yaml_model_YMap(map$2);
      var producer = $as_F0(producer$2);
      var parseOptional = $uZ(parseOptional$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser().init___Lorg_yaml_model_YMap__F0__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(map, producer, parseOptional, $this.ctx$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08VersionFactory.prototype.parameterParser__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(entry$2, adopted$2, parseOptional$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var adopted = $as_F1(adopted$2);
      var parseOptional = $uZ(parseOptional$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser().init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(entry, adopted, parseOptional, $this.ctx$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08VersionFactory.prototype.endPointParser__F5 = (function() {
  return new $c_sjsr_AnonFunction5().init___sjs_js_Function5((function($this) {
    return (function(entry$2, producer$2, parent$2, collector$2, parseOptionalOperations$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var producer = $as_F1(producer$2);
      var parent = $as_s_Option(parent$2);
      var collector = $as_scm_ListBuffer(collector$2);
      var parseOptionalOperations = $uZ(parseOptionalOperations$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser().init___Lorg_yaml_model_YMapEntry__F1__s_Option__scm_ListBuffer__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(entry, producer, parent, collector, parseOptionalOperations, $this.ctx$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08VersionFactory.prototype.payloadParser__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(entry$2, producer$2, parseOptional$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var producer = $as_F1(producer$2);
      var parseOptional = $uZ(parseOptional$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser().init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(entry, producer, parseOptional, $this.ctx$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08VersionFactory.prototype.responseParser__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(entry$2, adopt$2, parseOptional$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var adopt = $as_F1(adopt$2);
      var parseOptional = $uZ(parseOptional$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser().init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(entry, adopt, parseOptional, $this.ctx$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08VersionFactory.prototype.typeParser__F4 = (function() {
  return new $c_sjsr_AnonFunction4().init___sjs_js_Function4((function($this) {
    return (function(entry$2, adopt$2, isAnnotation$2, defaultType$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var adopt = $as_F1(adopt$2);
      var isAnnotation = $uZ(isAnnotation$2);
      var defaultType = $as_Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType(defaultType$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser(entry, adopt, isAnnotation, defaultType, $this.ctx$1)
    })
  })(this))
});
var $d_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08VersionFactory = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_parser_raml_Raml08VersionFactory: 0
}, false, "amf.plugins.document.webapi.contexts.parser.raml.Raml08VersionFactory", {
  Lamf_plugins_document_webapi_contexts_parser_raml_Raml08VersionFactory: 1,
  Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_SpecVersionFactory: 1
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08VersionFactory.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08VersionFactory;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory() {
  $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory.call(this)
}
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory.prototype = new $h_Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory();
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function() {
  return this.ctx$1
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory.prototype.init___Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(ctx) {
  $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory.prototype.init___Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory.prototype.requestParser__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(map$2, producer$2, parseOptional$2) {
      var map = $as_Lorg_yaml_model_YMap(map$2);
      var producer = $as_F0(producer$2);
      var parseOptional = $uZ(parseOptional$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser().init___Lorg_yaml_model_YMap__F0__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(map, producer, parseOptional, $this.ctx$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory.prototype.parameterParser__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(entry$2, adopted$2, parseOptional$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var adopted = $as_F1(adopted$2);
      var parseOptional = $uZ(parseOptional$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser().init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(entry, adopted, parseOptional, $this.ctx$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory.prototype.endPointParser__F5 = (function() {
  return new $c_sjsr_AnonFunction5().init___sjs_js_Function5((function($this) {
    return (function(entry$2, producer$2, parent$2, collector$2, parseOptionalOperations$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var producer = $as_F1(producer$2);
      var parent = $as_s_Option(parent$2);
      var collector = $as_scm_ListBuffer(collector$2);
      var parseOptionalOperations = $uZ(parseOptionalOperations$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser().init___Lorg_yaml_model_YMapEntry__F1__s_Option__scm_ListBuffer__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(entry, producer, parent, collector, parseOptionalOperations, $this.ctx$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory.prototype.payloadParser__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(entry$2, producer$2, parseOptional$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var producer = $as_F1(producer$2);
      var parseOptional = $uZ(parseOptional$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser().init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(entry, producer, parseOptional, $this.ctx$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory.prototype.responseParser__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(entry$2, adopt$2, parseOptional$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var adopt = $as_F1(adopt$2);
      var parseOptional = $uZ(parseOptional$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser().init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(entry, adopt, parseOptional, $this.ctx$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory.prototype.typeParser__F4 = (function() {
  return new $c_sjsr_AnonFunction4().init___sjs_js_Function4((function($this) {
    return (function(entry$2, f$2, isAnnotation$2, $$default) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var f = $as_F1(f$2);
      var isAnnotation = $uZ(isAnnotation$2);
      var $default = $as_Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType($$default);
      return $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(entry, f, new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo().init___Z__Z(isAnnotation, false), $default, $this.ctx$1)
    })
  })(this))
});
var $d_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory: 0
}, false, "amf.plugins.document.webapi.contexts.parser.raml.Raml10VersionFactory", {
  Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory: 1,
  Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_SpecVersionFactory: 1
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_RamlHeader$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_RamlHeader$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_RamlHeader$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_RamlHeader$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_RamlHeader$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_RamlHeader$.prototype = $c_Lamf_plugins_document_webapi_parser_RamlHeader$.prototype;
$c_Lamf_plugins_document_webapi_parser_RamlHeader$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_RamlHeader$.prototype.fromText__T__s_Option = (function(text) {
  var this$1 = $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$().asRegExp__s_util_matching_Regex().pattern$1;
  if (new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$1, text, 0, $uI(text.length)).matches__Z()) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$())
  };
  var this$3 = $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$().asRegExp__s_util_matching_Regex().pattern$1;
  if (new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$3, text, 0, $uI(text.length)).matches__Z()) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$())
  };
  var this$5 = $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$().asRegExp__s_util_matching_Regex().pattern$1;
  if (new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$5, text, 0, $uI(text.length)).matches__Z()) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$())
  };
  var this$7 = $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$().asRegExp__s_util_matching_Regex().pattern$1;
  if (new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$7, text, 0, $uI(text.length)).matches__Z()) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$())
  };
  var this$9 = $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$().asRegExp__s_util_matching_Regex().pattern$1;
  if (new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$9, text, 0, $uI(text.length)).matches__Z()) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$())
  };
  var this$11 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$();
  var o12 = this$11.fromText__p1__T__s_Option(text);
  if ((!o12.isEmpty__Z())) {
    var fragment = $as_Lamf_plugins_document_webapi_parser_RamlHeader(o12.get__O());
    return new $c_s_Some().init___O(fragment)
  };
  if ((($uI(text.length) >= 0) && ($as_T(text.substring(0, $uI("%".length))) === "%"))) {
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_RamlHeader().init___T(text))
  };
  return $m_s_None$()
});
$c_Lamf_plugins_document_webapi_parser_RamlHeader$.prototype.apply__Lamf_core_Root__s_Option = (function(root) {
  var x1 = root.parsed$1;
  if ((x1 instanceof $c_Lamf_core_parser_SyamlParsedDocument)) {
    var x2 = $as_Lamf_core_parser_SyamlParsedDocument(x1);
    var this$1 = x2.comment$2;
    if (this$1.isEmpty__Z()) {
      var this$2 = $m_s_None$()
    } else {
      var arg1 = this$1.get__O();
      var text = $as_T(arg1);
      var this$2 = $m_Lamf_plugins_document_webapi_parser_RamlHeader$().fromText__T__s_Option(text)
    };
    if (this$2.isEmpty__Z()) {
      var this$3 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$();
      return this$3.fromRoot__Lamf_core_Root__s_Option(root)
    } else {
      return this$2
    }
  } else {
    return $m_s_None$()
  }
});
var $d_Lamf_plugins_document_webapi_parser_RamlHeader$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_RamlHeader$: 0
}, false, "amf.plugins.document.webapi.parser.RamlHeader$", {
  Lamf_plugins_document_webapi_parser_RamlHeader$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_RamlHeader$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_RamlHeader$;
var $n_Lamf_plugins_document_webapi_parser_RamlHeader$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_RamlHeader$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_RamlHeader$)) {
    $n_Lamf_plugins_document_webapi_parser_RamlHeader$ = new $c_Lamf_plugins_document_webapi_parser_RamlHeader$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_RamlHeader$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_TypeName$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_TypeName$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_TypeName$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_TypeName$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_TypeName$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_TypeName$.prototype = $c_Lamf_plugins_document_webapi_parser_TypeName$.prototype;
$c_Lamf_plugins_document_webapi_parser_TypeName$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_TypeName$.prototype.apply__T__T__Lamf_plugins_document_webapi_parser_TypeName = (function(typeDef, format) {
  return new $c_Lamf_plugins_document_webapi_parser_TypeName().init___T__s_Option(typeDef, new $c_s_Some().init___O(format))
});
var $d_Lamf_plugins_document_webapi_parser_TypeName$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_TypeName$: 0
}, false, "amf.plugins.document.webapi.parser.TypeName$", {
  Lamf_plugins_document_webapi_parser_TypeName$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_TypeName$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_TypeName$;
var $n_Lamf_plugins_document_webapi_parser_TypeName$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_TypeName$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_TypeName$)) {
    $n_Lamf_plugins_document_webapi_parser_TypeName$ = new $c_Lamf_plugins_document_webapi_parser_TypeName$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_TypeName$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations() {
  $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.call(this);
  this.asts$3 = null;
  this.alias$3 = null;
  this.errorHandler$3 = null;
  this.futureDeclarations$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations();
$c_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations.prototype = $c_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations.prototype.futureDeclarations__Lamf_core_parser_FutureDeclarations = (function() {
  return this.futureDeclarations$3
});
$c_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations.prototype.init___sci_Map__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations = (function(asts, alias, errorHandler, futureDeclarations) {
  this.asts$3 = asts;
  this.alias$3 = alias;
  this.errorHandler$3 = errorHandler;
  this.futureDeclarations$3 = futureDeclarations;
  var x$4 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$5 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$6 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$7 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$8 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$9 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$10 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$11 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$12 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$13 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$14 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$15 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$16 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$17 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$18 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$19 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$20 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$21 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$22 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$23 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$24 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$25 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$26 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$27 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.init___s_Option__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations__sci_Map.call(this, alias, x$4, x$5, x$6, x$7, x$8, x$9, x$10, x$11, x$12, x$13, x$14, x$15, x$16, x$17, x$18, x$19, x$20, x$21, x$22, x$23, x$24, x$25, x$26, errorHandler, futureDeclarations, x$27);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations.prototype.errorHandler__Lamf_core_errorhandling_ErrorHandler = (function() {
  return this.errorHandler$3
});
$c_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations.prototype.asts__sci_Map = (function() {
  return this.asts$3
});
$c_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations.prototype.alias__s_Option = (function() {
  return this.alias$3
});
function $as_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.OasLikeWebApiDeclarations"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.OasLikeWebApiDeclarations;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations: 0
}, false, "amf.plugins.document.webapi.parser.spec.OasLikeWebApiDeclarations", {
  Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations: 1,
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations: 1,
  Lamf_core_parser_Declarations: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations() {
  $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.call(this);
  this.externalShapes$3 = null;
  this.externalLibs$3 = null;
  this.alias$3 = null;
  this.errorHandler$3 = null;
  this.futureDeclarations$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations();
$c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations.prototype = $c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations.prototype.absorb__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__V = (function(other) {
  $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.mergeParts__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__V.call(this, other, this);
  this.externalShapes$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var k = $as_T(x0$1.$$und1__O());
        var s = $as_Lamf_plugins_domain_shapes_models_AnyShape(x0$1.$$und2__O());
        $this.externalShapes$3 = $this.externalShapes$3.$$plus__T2__sci_Map(new $c_T2().init___O__O(k, s))
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this)));
  other.externalShapes$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x0$2$2) {
      var x0$2 = $as_T2(x0$2$2);
      if ((x0$2 !== null)) {
        var k$1 = $as_T(x0$2.$$und1__O());
        var s$1 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x0$2.$$und2__O());
        this$2$1.externalShapes$3 = this$2$1.externalShapes$3.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$1, s$1))
      } else {
        throw new $c_s_MatchError().init___O(x0$2)
      }
    })
  })(this)))
});
$c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations.prototype.futureDeclarations__Lamf_core_parser_FutureDeclarations = (function() {
  return this.futureDeclarations$3
});
$c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations.prototype.init___sci_Map__sci_Map__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations = (function(externalShapes, externalLibs, alias, errorHandler, futureDeclarations) {
  this.externalShapes$3 = externalShapes;
  this.externalLibs$3 = externalLibs;
  this.alias$3 = alias;
  this.errorHandler$3 = errorHandler;
  this.futureDeclarations$3 = futureDeclarations;
  var x$4 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$5 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$6 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$7 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$8 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$9 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$10 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$11 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$12 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$13 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$14 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$15 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$16 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$17 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$18 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$19 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$20 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$21 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$22 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$23 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$24 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$25 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$26 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$27 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.init___s_Option__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations__sci_Map.call(this, alias, x$4, x$5, x$6, x$7, x$8, x$9, x$10, x$11, x$12, x$13, x$14, x$15, x$16, x$17, x$18, x$19, x$20, x$21, x$22, x$23, x$24, x$25, x$26, errorHandler, futureDeclarations, x$27);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations.prototype.errorHandler__Lamf_core_errorhandling_ErrorHandler = (function() {
  return this.errorHandler$3
});
$c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations.prototype.merge__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations = (function(other) {
  var x$1 = this.alias__s_Option();
  var x$2 = this.errorHandler__Lamf_core_errorhandling_ErrorHandler();
  var x$3 = this.futureDeclarations__Lamf_core_parser_FutureDeclarations();
  var x$4 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$5 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var merged = new $c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().init___sci_Map__sci_Map__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations(x$4, x$5, x$1, x$2, x$3);
  $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations.prototype.mergeParts__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__V.call(this, other, merged);
  this.externalShapes$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, merged$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var k = $as_T(x0$1.$$und1__O());
        var s = $as_Lamf_plugins_domain_shapes_models_AnyShape(x0$1.$$und2__O());
        merged$1.externalShapes$3 = merged$1.externalShapes$3.$$plus__T2__sci_Map(new $c_T2().init___O__O(k, s))
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, merged)));
  other.externalShapes$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, merged$2) {
    return (function(x0$2$2) {
      var x0$2 = $as_T2(x0$2$2);
      if ((x0$2 !== null)) {
        var k$1 = $as_T(x0$2.$$und1__O());
        var s$1 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x0$2.$$und2__O());
        merged$2.externalShapes$3 = merged$2.externalShapes$3.$$plus__T2__sci_Map(new $c_T2().init___O__O(k$1, s$1))
      } else {
        throw new $c_s_MatchError().init___O(x0$2)
      }
    })
  })(this, merged)));
  return merged
});
$c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations.prototype.registerExternalLib__T__sci_Map__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function(url, content) {
  this.externalLibs$3 = this.externalLibs$3.$$plus__T2__sci_Map(new $c_T2().init___O__O(url, content));
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations.prototype.findInExternalsLibs__T__T__s_Option = (function(lib, name) {
  var this$1 = this.externalLibs$3.get__O__s_Option(lib);
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$29 = $as_sci_Map(arg1);
    return x$29.get__O__s_Option(name)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations.prototype.alias__s_Option = (function() {
  return this.alias$3
});
function $as_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.RamlWebApiDeclarations"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.RamlWebApiDeclarations;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations: 0
}, false, "amf.plugins.document.webapi.parser.spec.RamlWebApiDeclarations", {
  Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations: 1,
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations: 1,
  Lamf_core_parser_Declarations: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter() {
  $c_O.call(this);
  this.bindings$1 = null;
  this.ordering$1 = null;
  this.extensions$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter.prototype.emitLink__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$1 = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$();
  var this$1 = $as_Lamf_core_model_domain_Linkable(this.bindings$1);
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1));
  var this$3 = this$2.option$1;
  var label = jsx$1.appendOas3ComponentsPrefix__T__T__T($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())), this.obtainComponentTag__T());
  this.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext().ref__Lorg_yaml_model_YDocument$PartBuilder__T__V(b, label)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter.prototype.obtainBindings__Lamf_core_model_domain_AmfElement__sc_Seq = (function(value) {
  if ((value instanceof $c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_bindings_ServerBindings(value);
    return $as_sc_Seq(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$().Bindings$1))
  } else if ((value instanceof $c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings)) {
    var x3 = $as_Lamf_plugins_domain_webapi_models_bindings_OperationBindings(value);
    return $as_sc_Seq(x3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$().Bindings$1))
  } else if ((value instanceof $c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings)) {
    var x4 = $as_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings(value);
    return $as_sc_Seq(x4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$().Bindings$1))
  } else if ((value instanceof $c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings)) {
    var x5 = $as_Lamf_plugins_domain_webapi_models_bindings_MessageBindings(value);
    return $as_sc_Seq(x5.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$().Bindings$1))
  } else {
    return $m_sci_Nil$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter.prototype.isLink__Z = (function() {
  var x1 = this.bindings$1;
  if ($is_Lamf_core_model_domain_Linkable(x1)) {
    var x2 = $as_Lamf_core_model_domain_Linkable(x1);
    if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x2).isDefined__Z()) {
      return true
    }
  };
  return false
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var jsx$4 = this.obtainBindings__Lamf_core_model_domain_AmfElement__sc_Seq(this.bindings$1);
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(element$2) {
      var element = $as_Lamf_core_model_domain_AmfElement(element$2);
      var xo = $this.emitterForElement__Lamf_core_model_domain_AmfElement__s_Option(element);
      return xo.toList__sci_List()
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike(jsx$4.flatMap__F1__scg_CanBuildFrom__O(jsx$3, this$2.ReusableCBFInstance$2));
  var jsx$1 = this.extensionEmitters__sc_Seq();
  var this$3 = $m_sc_Seq$();
  var emitters = $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
  $m_Lorg_yaml_model_YNode$();
  var str = this.key__T();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  if (this.isLink__Z()) {
    this.emitLink__Lorg_yaml_model_YDocument$PartBuilder__V(v)
  } else {
    var jsx$5 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(emitters), b$1);
    jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  };
  var this$8 = v.builder$1;
  var array = [key];
  if ((this$8.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$8.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$8, newSize);
  var len$1 = this$8.size0$6;
  var src = this$8.array$6;
  var dest = this$8.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$8.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$6 = j;
    var index = i;
    xs.set(jsx$6, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$8.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter.prototype.obtainComponentTag__T = (function() {
  var x1 = this.bindings$1;
  return ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings) ? "serverBindings" : ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings) ? "operationBindings" : ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings) ? "channelBindings" : ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings) ? "messageBindings" : "default"))))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter.prototype.init___Lamf_core_model_domain_AmfElement__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(bindings, ordering, extensions, spec) {
  this.bindings$1 = bindings;
  this.ordering$1 = ordering;
  this.extensions$1 = extensions;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter.prototype.extensionEmitters__sc_Seq = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.extensions$1, this.ordering$1, this.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext()).emitters__sc_Seq()
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter.prototype.emitterForElement__Lamf_core_model_domain_AmfElement__s_Option = (function(element) {
  if ((element instanceof $c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding(element);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_EmptyBindingEmitter().init___Lamf_plugins_domain_webapi_models_bindings_EmptyBinding__Lamf_core_emitter_SpecOrdering(x2, this.ordering$1))
  } else if ((element instanceof $c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding)) {
    var x3 = $as_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding(element);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_DynamicBindingEmitter().init___Lamf_plugins_domain_webapi_models_bindings_DynamicBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x3, this.ordering$1, this.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext()))
  } else if ($is_Lamf_plugins_domain_webapi_models_bindings_ChannelBinding(element)) {
    var x4 = $as_Lamf_plugins_domain_webapi_models_bindings_ChannelBinding(element);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiChannelBindingsEmitter().init___Lamf_plugins_domain_webapi_models_bindings_ChannelBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x4, this.ordering$1, this.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext()))
  } else if ($is_Lamf_plugins_domain_webapi_models_bindings_ServerBinding(element)) {
    var x5 = $as_Lamf_plugins_domain_webapi_models_bindings_ServerBinding(element);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiServerBindingsEmitter().init___Lamf_plugins_domain_webapi_models_bindings_ServerBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x5, this.ordering$1, this.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext()))
  } else if ($is_Lamf_plugins_domain_webapi_models_bindings_OperationBinding(element)) {
    var x6 = $as_Lamf_plugins_domain_webapi_models_bindings_OperationBinding(element);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiOperationBindingsEmitter().init___Lamf_plugins_domain_webapi_models_bindings_OperationBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x6, this.ordering$1, this.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext()))
  } else if ($is_Lamf_plugins_domain_webapi_models_bindings_MessageBinding(element)) {
    var x7 = $as_Lamf_plugins_domain_webapi_models_bindings_MessageBinding(element);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiMessageBindingsEmitter().init___Lamf_plugins_domain_webapi_models_bindings_MessageBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x7, this.ordering$1, this.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext()))
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.bindings$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdEmitter() {
  $c_O.call(this);
  this.correlationId$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("correlationId");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter().init___Lamf_plugins_domain_webapi_models_CorrelationId__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.correlationId$1, this.ordering$1, this.spec$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
  var this$4 = v.builder$1;
  var array = [key];
  if ((this$4.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$4.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$4, newSize);
  var len$1 = this$4.size0$6;
  var src = this$4.array$6;
  var dest = this$4.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$4.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$4.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdEmitter.prototype.init___Lamf_plugins_domain_webapi_models_CorrelationId__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(correlationId, ordering, spec) {
  this.correlationId$1 = correlationId;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.correlationId$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiCorrelationIdEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCreativeWorksEmitter() {
  $c_O.call(this);
  this.documentation$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCreativeWorksEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCreativeWorksEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCreativeWorksEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCreativeWorksEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCreativeWorksEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCreativeWorksEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCreativeWorksEmitter.prototype.init___Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(documentation, ordering, spec) {
  this.documentation$1 = documentation;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCreativeWorksEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var fs = this.documentation$1.fields$1;
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Description$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f, $m_s_None$())))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Url$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("url", f$3, $m_s_None$())))
  };
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("externalDocs");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$8 = v.builder$1;
  var array = [key];
  if ((this$8.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$8.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$8, newSize);
  var len$1 = this$8.size0$6;
  var src = this$8.array$6;
  var dest = this$8.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$8.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$8.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCreativeWorksEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.documentation$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCreativeWorksEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCreativeWorksEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiCreativeWorksEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCreativeWorksEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCreativeWorksEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCreativeWorksEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiEndpointsEmitter() {
  $c_O.call(this);
  this.f$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null;
  this.key$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiEndpointsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiEndpointsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiEndpointsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiEndpointsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiEndpointsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiEndpointsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiEndpointsEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(f, ordering, spec) {
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  this.key$1 = "channels";
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiEndpointsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.f$1;
  var jsx$4 = $as_Lamf_core_model_domain_AmfArray(this$1.value$1.value$1).values$1;
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_domain_AmfElement(x$1$2);
      return $as_Lamf_plugins_domain_webapi_models_EndPoint(x$1)
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$2.ReusableCBFInstance$2));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(e$2) {
      var e = $as_Lamf_plugins_domain_webapi_models_EndPoint(e$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter().init___Lamf_plugins_domain_webapi_models_EndPoint__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(e, this$2$1.ordering$1, this$2$1.spec$1)
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  var emitters = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$6 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, b$2) {
    return (function(e$2$1) {
      var e$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter(e$2$1);
      e$1.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$2)
    })
  })(this, b$1));
  var this$6 = $m_sc_Seq$();
  emitters.map__F1__scg_CanBuildFrom__O(jsx$5, this$6.ReusableCBFInstance$2);
  jsx$6.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$9 = v.builder$1;
  var array = [key];
  if ((this$9.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$9.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$9, newSize);
  var len$1 = this$9.size0$6;
  var src = this$9.array$6;
  var dest = this$9.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$9.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$2 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$2 < that) ? x$2 : that);
  while ((i < end)) {
    var jsx$7 = j;
    var index = i;
    xs.set(jsx$7, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$9.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiEndpointsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$1 = this.f$1;
  var annotations = this$1.value$1.value$1.annotations__Lamf_core_parser_Annotations();
  return this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiEndpointsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiEndpointsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiEndpointsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiEndpointsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiEndpointsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiEndpointsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter() {
  $c_O.call(this);
  this.message$1 = null;
  this.isTrait$1 = false;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var fs = this.message$1.fields__Lamf_core_parser_Fields();
  this.message$1.annotations__Lamf_core_parser_Annotations();
  var this$2 = this.message$1;
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2).isDefined__Z()) {
    this.emitLink__Lorg_yaml_model_YDocument$PartBuilder__V(b)
  } else {
    var jsx$1 = b.builder$1;
    var sourceName = b.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().DisplayName$1);
    if ((!this$4.isEmpty__Z())) {
      var arg1 = this$4.get__O();
      var f = $as_Lamf_core_parser_FieldEntry(arg1);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("name", f, $m_s_None$())))
    };
    var this$6 = this.message$1;
    var bindingOrphanAnnotations = $as_sc_Seq($as_sc_Seq(this$6.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field())).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(x$6$2) {
        var x$6 = $as_Lamf_core_model_domain_extensions_DomainExtension(x$6$2);
        return $as_Lamf_core_model_domain_DataNode(x$6.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)).annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.getClassOf())
      })
    })(this))));
    var this$7 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Headers$1);
    if ((!this$7.isEmpty__Z())) {
      var arg1$1 = this$7.get__O();
      var x$7 = $as_Lamf_core_parser_FieldEntry(arg1$1);
      this.emitHeader__p1__scm_ListBuffer__Lamf_core_parser_FieldEntry__V(result, x$7)
    };
    var this$8 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().CorrelationId$1);
    if ((!this$8.isEmpty__Z())) {
      var arg1$2 = this$8.get__O();
      var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$2);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdEmitter().init___Lamf_plugins_domain_webapi_models_CorrelationId__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext($as_Lamf_plugins_domain_webapi_models_CorrelationId(f$3.value$1.value$1), this.ordering$1, this.spec$1)))
    };
    var this$9 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Title$1);
    if ((!this$9.isEmpty__Z())) {
      var arg1$3 = this$9.get__O();
      var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$3);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("title", f$4, $m_s_None$())))
    };
    var this$11 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Summary$1);
    if ((!this$11.isEmpty__Z())) {
      var arg1$4 = this$11.get__O();
      var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$4);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("summary", f$5, $m_s_None$())))
    };
    var this$13 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Description$1);
    if ((!this$13.isEmpty__Z())) {
      var arg1$5 = this$13.get__O();
      var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$5);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f$6, $m_s_None$())))
    };
    var this$15 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Tags$1);
    if ((!this$15.isEmpty__Z())) {
      var arg1$6 = this$15.get__O();
      var f$7 = $as_Lamf_core_parser_FieldEntry(arg1$6);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("tags", $as_Lamf_core_model_domain_AmfArray(f$7.value$1.value$1).values$1, this.ordering$1, this.spec$1)))
    };
    var this$16 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Documentation$1);
    if ((!this$16.isEmpty__Z())) {
      var arg1$7 = this$16.get__O();
      var f$8 = $as_Lamf_core_parser_FieldEntry(arg1$7);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCreativeWorksEmitter().init___Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext($as_Lamf_plugins_domain_shapes_models_CreativeWork(f$8.value$1.value$1), this.ordering$1, this.spec$1)))
    };
    var this$17 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Bindings$1);
    if ((!this$17.isEmpty__Z())) {
      var arg1$8 = this$17.get__O();
      var f$9 = $as_Lamf_core_parser_FieldEntry(arg1$8);
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter().init___Lamf_core_model_domain_AmfElement__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(f$9.value$1.value$1, this.ordering$1, bindingOrphanAnnotations, this.spec$1))
    };
    var this$18 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Examples$1);
    if ((!this$18.isEmpty__Z())) {
      var arg1$9 = this$18.get__O();
      var f$10 = $as_Lamf_core_parser_FieldEntry(arg1$9);
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("examples", f$10.arrayValues__sc_Seq(), this.ordering$1, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), this.spec$1))
    };
    if ((!this.isTrait$1)) {
      var this$19 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Extends__Lamf_core_metamodel_Field());
      if ((!this$19.isEmpty__Z())) {
        var arg1$10 = this$19.get__O();
        var f$11 = $as_Lamf_core_parser_FieldEntry(arg1$10);
        this.emitTraits__Lamf_core_parser_FieldEntry__scm_ListBuffer__V(f$11, result)
      };
      var this$20 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1);
      if ((!this$20.isEmpty__Z())) {
        var arg1$11 = this$20.get__O();
        var f$12 = $as_Lamf_core_parser_FieldEntry(arg1$11);
        this.emitPayloads__p1__Lamf_core_parser_FieldEntry__scm_ListBuffer__V(f$12, result)
      }
    };
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
    jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter.prototype.emitLink__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$1 = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$();
  var this$1 = this.message$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1));
  var this$3 = this$2.option$1;
  var label = jsx$1.appendOas3ComponentsPrefix__T__T__T($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())), (this.isTrait$1 ? "messageTraits" : "messages"));
  this.spec$1.ref__Lorg_yaml_model_YDocument$PartBuilder__T__V(b, label)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter.prototype.emitPayloads__p1__Lamf_core_parser_FieldEntry__scm_ListBuffer__V = (function(f, result) {
  var this$1 = f.arrayValues__sc_Seq().headOption__s_Option();
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var payload = $as_Lamf_plugins_domain_webapi_models_Payload(arg1);
    var fs = payload.fields$1;
    var schemaMediaType = $as_Lamf_core_model_StrField(payload.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().SchemaMediaType$1)).option$1;
    var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1);
    if ((!this$2.isEmpty__Z())) {
      var arg1$1 = this$2.get__O();
      var field = $as_Lamf_core_parser_FieldEntry(arg1$1);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("contentType", field, $m_s_None$())))
    };
    var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().SchemaMediaType$1);
    if ((!this$4.isEmpty__Z())) {
      var arg1$2 = this$4.get__O();
      var field$3 = $as_Lamf_core_parser_FieldEntry(arg1$2);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("schemaFormat", field$3, $m_s_None$())))
    };
    var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1);
    if ((!this$6.isEmpty__Z())) {
      var arg1$3 = this$6.get__O();
      var field$4 = $as_Lamf_core_parser_FieldEntry(arg1$3);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter().init___T__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__s_Option__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext("payload", $as_Lamf_core_model_domain_Shape(field$4.value$1.value$1), this.ordering$1, $m_sci_Nil$(), schemaMediaType, this.spec$1)))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Message__Z__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(message, isTrait, ordering, spec) {
  this.message$1 = message;
  this.isTrait$1 = isTrait;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter.prototype.emitTraits__Lamf_core_parser_FieldEntry__scm_ListBuffer__V = (function(f, result) {
  result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(f.arrayValues__sc_Seq(), this.ordering$1, this.spec$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.message$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter.prototype.emitHeader__p1__scm_ListBuffer__Lamf_core_parser_FieldEntry__V = (function(result, field) {
  var this$1 = field.arrayValues__sc_Seq().headOption__s_Option();
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var param = $as_Lamf_plugins_domain_webapi_models_Parameter(arg1);
    var toEmit = $as_Lamf_core_model_domain_Shape(param.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1));
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter().init___T__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__s_Option__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext("headers", toEmit, this.ordering$1, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), $m_s_None$(), this.spec$1))
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiMessageContentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageEmitter() {
  $c_O.call(this);
  this.fieldEntry$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(fieldEntry, ordering, spec) {
  this.fieldEntry$1 = fieldEntry;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageEmitter.prototype.emitSingle__p1__Lorg_yaml_model_YDocument$EntryBuilder__Lamf_plugins_domain_webapi_models_Message__V = (function(b, message) {
  var x$2 = this.ordering$1;
  var emitter = new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter().init___Lamf_plugins_domain_webapi_models_Message__Z__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(message, false, x$2, this.spec$1);
  var eta$0$1 = new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations("message", new $c_Lamf_core_parser_Annotations().init___()), $m_Lorg_yaml_model_YType$().Str$1);
  var k = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  eta$0$1.emit__Lorg_yaml_model_YDocument$PartBuilder__V(k);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  emitter.emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
  var this$3 = k.builder$1;
  var jsx$1 = $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$3, 0));
  var this$4 = v.builder$1;
  b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(jsx$1, $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$4, 0)))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var messages = this.fieldEntry$1.arrayValues__sc_Seq();
  var x1 = messages.size__I();
  switch (x1) {
    case 1: {
      this.emitSingle__p1__Lorg_yaml_model_YDocument$EntryBuilder__Lamf_plugins_domain_webapi_models_Message__V(b, $as_Lamf_plugins_domain_webapi_models_Message(messages.head__O()));
      break
    }
    default: {
      if ((x1 > 1)) {
        this.emitMultiple__p1__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageEmitter.prototype.emitMultiple__p1__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("message");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var eta$0$1 = new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOneOfMessageEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.fieldEntry$1, this.ordering$1, this.spec$1);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  eta$0$1.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$4 = v.builder$1;
  var array = [key];
  if ((this$4.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$4.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$4, newSize);
  var len$1 = this$4.size0$6;
  var src = this$4.array$6;
  var dest = this$4.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$4.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$4.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.fieldEntry$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiMessageEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOneOfMessageEmitter() {
  $c_O.call(this);
  this.fieldEntry$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOneOfMessageEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOneOfMessageEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOneOfMessageEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOneOfMessageEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOneOfMessageEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOneOfMessageEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOneOfMessageEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(fieldEntry, ordering, spec) {
  this.fieldEntry$1 = fieldEntry;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOneOfMessageEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var messages = this.fieldEntry$1.arrayValues__sc_Seq();
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2) {
      var x = $as_Lamf_plugins_domain_webapi_models_Message(x$2);
      var x$2$1 = $this.ordering$1;
      return new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter().init___Lamf_plugins_domain_webapi_models_Message__Z__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x, false, x$2$1, $this.spec$1)
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var emitters = $as_sc_Seq(messages.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("oneOf");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(emitters), b$1);
  var jsx$2 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$2.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x$1 = $uI(array.length);
  var x$3 = ((x$1 < len$2) ? x$1 : len$2);
  var that = xs.u.length;
  var end = ((x$3 < that) ? x$3 : that);
  while ((i < end)) {
    var jsx$4 = j;
    var index = i;
    xs.set(jsx$4, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOneOfMessageEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.fieldEntry$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOneOfMessageEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOneOfMessageEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiOneOfMessageEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOneOfMessageEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOneOfMessageEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOneOfMessageEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiParametersEmitter() {
  $c_O.call(this);
  this.parameters$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiParametersEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiParametersEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiParametersEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiParametersEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiParametersEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiParametersEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiParametersEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var jsx$2 = this.parameters$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(p$2) {
      var p = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter().init___Lamf_plugins_domain_webapi_models_Parameter__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(p, $this.ordering$1, $this.spec$1)
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var parameterEmitters = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("parameters");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  parameterEmitters.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, pb) {
    return (function(e$2) {
      var e = $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter(e$2);
      e.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(pb)
    })
  })(this, b$1)));
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$4 = j;
    var index = i;
    xs.set(jsx$4, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiParametersEmitter.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(parameters, ordering, spec) {
  this.parameters$1 = parameters;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiParametersEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.parameters$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var p = $as_Lamf_plugins_domain_webapi_models_Parameter(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = p.annotations$1;
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiParametersEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiParametersEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiParametersEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiParametersEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiParametersEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiParametersEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiServersEmitter() {
  $c_O.call(this);
  this.f$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null;
  this.key$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiServersEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiServersEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiServersEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiServersEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiServersEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiServersEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiServersEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(f, ordering, spec) {
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  this.key$1 = "servers";
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiServersEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.f$1;
  var jsx$4 = $as_Lamf_core_model_domain_AmfArray(this$1.value$1.value$1).values$1;
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2) {
      var x = $as_Lamf_core_model_domain_AmfElement(x$2);
      return $as_Lamf_plugins_domain_webapi_models_Server(x)
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$2.ReusableCBFInstance$2));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_plugins_domain_webapi_models_Server(x$1$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter().init___Lamf_plugins_domain_webapi_models_Server__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x$1, this$2$1.ordering$1, this$2$1.spec$1)
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  var serverEmitters = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$6 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, b$2) {
    return (function(e$2) {
      var e = $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter(e$2);
      e.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$2)
    })
  })(this, b$1));
  var this$6 = $m_sc_Seq$();
  serverEmitters.map__F1__scg_CanBuildFrom__O(jsx$5, this$6.ReusableCBFInstance$2);
  jsx$6.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$9 = v.builder$1;
  var array = [key];
  if ((this$9.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$9.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$9, newSize);
  var len$1 = this$9.size0$6;
  var src = this$9.array$6;
  var dest = this$9.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$9.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x$3 = $uI(array.length);
  var x$4 = ((x$3 < len$2) ? x$3 : len$2);
  var that = xs.u.length;
  var end = ((x$4 < that) ? x$4 : that);
  while ((i < end)) {
    var jsx$7 = j;
    var index = i;
    xs.set(jsx$7, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$9.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiServersEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$1 = this.f$1;
  var annotations = this$1.value$1.value$1.annotations__Lamf_core_parser_Annotations();
  return this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiServersEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiServersEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiServersEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiServersEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiServersEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiServersEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter() {
  $c_O.call(this);
  this.channel$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter.prototype.operations__Lamf_core_parser_FieldEntry__sc_Seq = (function(f) {
  var jsx$2 = $as_sc_TraversableLike(f.arrayValues__sc_Seq().filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(e$2) {
      var e = $as_Lamf_plugins_domain_webapi_models_Operation(e$2);
      var this$1 = $as_Lamf_core_model_StrField(e.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Method$1));
      var this$2 = this$1.option$1;
      var thiz = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
      if ((thiz === null)) {
        throw new $c_jl_NullPointerException().init___()
      };
      return $m_ju_regex_Pattern$().matches__T__jl_CharSequence__Z("subscribe|publish", thiz)
    })
  })(this))));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(o$2) {
      var o = $as_Lamf_plugins_domain_webapi_models_Operation(o$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOperationEmitter().init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_emitter_SpecOrdering__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(o, this$2$1.ordering$1, false, this$2$1.spec$1)
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = this.channel$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1));
  var this$3 = this$2.option$1;
  var channelPath = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
  var fs = this.channel$1.fields$1;
  var this$4 = this.channel$1;
  var bindingOrphanAnnotations = $as_sc_Seq($as_sc_Seq(this$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field())).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_core_model_domain_extensions_DomainExtension(x$3$2);
      return $as_Lamf_core_model_domain_DataNode(x$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)).annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.getClassOf())
    })
  })(this))));
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Description$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1 = this$5.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f, $m_s_None$()))
  };
  var this$7 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1);
  if ((!this$7.isEmpty__Z())) {
    var arg1$1 = this$7.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(this.operations__Lamf_core_parser_FieldEntry__sc_Seq(f$3))
  };
  var this$8 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1);
  if ((!this$8.isEmpty__Z())) {
    var arg1$2 = this$8.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiParametersEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(f$4.arrayValues__sc_Seq(), this.ordering$1, this.spec$1))
  };
  var this$9 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Bindings$1);
  if ((!this$9.isEmpty__Z())) {
    var arg1$3 = this$9.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter().init___Lamf_core_model_domain_AmfElement__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(f$5.value$1.value$1, this.ordering$1, bindingOrphanAnnotations, this.spec$1))
  };
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(channelPath);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$13 = v.builder$1;
  var array = [key];
  if ((this$13.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$13.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$13, newSize);
  var len$1 = this$13.size0$6;
  var src = this$13.array$6;
  var dest = this$13.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$13.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$13.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter.prototype.init___Lamf_plugins_domain_webapi_models_EndPoint__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(channel, ordering, spec) {
  this.channel$1 = channel;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.channel$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiSingleEndpointEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiSingleEndpointEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiSingleEndpointEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleEndpointEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter() {
  $c_O.call(this);
  this.parameter$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter.prototype.emitLocation__p1__Lamf_core_parser_FieldEntry__scm_ListBuffer__V = (function(f, result) {
  var value = f.value$1;
  if ((!value.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_SynthesizedField.getClassOf()))) {
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("location", f, $m_s_None$()))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter.prototype.emitLink__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$1 = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$();
  var this$1 = this.parameter$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1));
  var this$3 = this$2.option$1;
  var label = jsx$1.appendOas3ComponentsPrefix__T__T__T($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())), "parameters");
  this.spec$1.ref__Lorg_yaml_model_YDocument$PartBuilder__T__V(b, label)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.parameter$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
  var this$3 = this$2.option$1;
  var paramName = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
  var fs = this.parameter$1.fields$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(paramName);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var this$4 = this.parameter$1;
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$4).isDefined__Z()) {
    this.emitLink__Lorg_yaml_model_YDocument$PartBuilder__V(v)
  } else {
    var jsx$1 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Description$1);
    if ((!this$6.isEmpty__Z())) {
      var arg1 = this$6.get__O();
      var f = $as_Lamf_core_parser_FieldEntry(arg1);
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f, $m_s_None$()))
    };
    var this$8 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1);
    if ((!this$8.isEmpty__Z())) {
      var arg1$1 = this$8.get__O();
      var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter().init___T__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__s_Option__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext("schema", $as_Lamf_core_model_domain_Shape(f$3.value$1.value$1), this.ordering$1, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), $m_s_None$(), this.spec$1))
    };
    var this$10 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1);
    if ((!this$10.isEmpty__Z())) {
      var arg1$2 = this$10.get__O();
      var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
      this.emitLocation__p1__Lamf_core_parser_FieldEntry__scm_ListBuffer__V(f$4, result)
    };
    result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.parameter$1, this.ordering$1, this.spec$1).emitters__sc_Seq());
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
    jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  };
  var this$13 = v.builder$1;
  var array = [key];
  if ((this$13.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$13.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$13, newSize);
  var len$1 = this$13.size0$6;
  var src = this$13.array$6;
  var dest = this$13.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$13.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$13.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Parameter__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(parameter, ordering, spec) {
  this.parameter$1 = parameter;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.parameter$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiSingleParameterEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiSingleParameterEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiSingleParameterEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleParameterEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter() {
  $c_O.call(this);
  this.server$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = this.server$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Name$1));
  var this$3 = this$2.option$1;
  var serverName = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
  var fs = this.server$1.fields$1;
  var this$4 = this.server$1;
  var bindingOrphanAnnotations = $as_sc_Seq($as_sc_Seq(this$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field())).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_core_model_domain_extensions_DomainExtension(x$3$2);
      return $as_Lamf_core_model_domain_DataNode(x$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)).annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.getClassOf())
    })
  })(this))));
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Url$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1 = this$5.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("url", f, $m_s_None$()))
  };
  var this$7 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Protocol$1);
  if ((!this$7.isEmpty__Z())) {
    var arg1$1 = this$7.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("protocol", f$3, $m_s_None$()))
  };
  var this$9 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().ProtocolVersion$1);
  if ((!this$9.isEmpty__Z())) {
    var arg1$2 = this$9.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("protocolVersion", f$4, $m_s_None$()))
  };
  var this$11 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Description$1);
  if ((!this$11.isEmpty__Z())) {
    var arg1$3 = this$11.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f$5, $m_s_None$()))
  };
  var this$13 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Variables$1);
  if ((!this$13.isEmpty__Z())) {
    var arg1$4 = this$13.get__O();
    var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(f$6, this.ordering$1, this.spec$1))
  };
  var this$14 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Security$1);
  if ((!this$14.isEmpty__Z())) {
    var arg1$5 = this$14.get__O();
    var f$7 = $as_Lamf_core_parser_FieldEntry(arg1$5);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("security", f$7, this.ordering$1, this.spec$1))
  };
  var this$15 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Bindings$1);
  if ((!this$15.isEmpty__Z())) {
    var arg1$6 = this$15.get__O();
    var f$8 = $as_Lamf_core_parser_FieldEntry(arg1$6);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter().init___Lamf_core_model_domain_AmfElement__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(f$8.value$1.value$1, this.ordering$1, bindingOrphanAnnotations, this.spec$1))
  };
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.server$1, this.ordering$1, this.spec$1).emitters__sc_Seq());
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(serverName);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$19 = v.builder$1;
  var array = [key];
  if ((this$19.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$19.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$19, newSize);
  var len$1 = this$19.size0$6;
  var src = this$19.array$6;
  var dest = this$19.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$19.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$19.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.server$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Server__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(server, ordering, spec) {
  this.server$1 = server;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiSingleServerEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiSingleServerEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiSingleServerEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiSingleServerEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySchemesEmitter() {
  $c_O.call(this);
  this.securitySchemes$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySchemesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySchemesEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySchemesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySchemesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySchemesEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySchemesEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySchemesEmitter.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(securitySchemes, ordering, spec) {
  this.securitySchemes$1 = securitySchemes;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySchemesEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var jsx$3 = this.ordering$1;
  var jsx$2 = this.securitySchemes$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(x$1$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter().init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x$1, $this.ordering$1, $this.spec$1)
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var emitters = jsx$3.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)));
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("securitySchemes");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$4 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(emitters, b$1);
  jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$5 = v.builder$1;
  var array = [key];
  if ((this$5.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$5.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$5, newSize);
  var len$1 = this$5.size0$6;
  var src = this$5.array$6;
  var dest = this$5.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$5.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$2 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$2 < that) ? x$2 : that);
  while ((i < end)) {
    var jsx$5 = j;
    var index = i;
    xs.set(jsx$5, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$5.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySchemesEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.securitySchemes$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var a = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = a.annotations$1;
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySchemesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySchemesEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncSecuritySchemesEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySchemesEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySchemesEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySchemesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_DynamicBindingEmitter() {
  $c_O.call(this);
  this.binding$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_DynamicBindingEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_DynamicBindingEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_DynamicBindingEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_DynamicBindingEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_DynamicBindingEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_DynamicBindingEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_DynamicBindingEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.binding$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$().Type$1));
  var this$3 = this$2.option$1;
  var bindingType = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
  var fs = this.binding$1.fields$1;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$().Definition$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler($as_Lamf_core_model_domain_DataNode(f.value$1.value$1), this.ordering$1, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler()).emitters__sc_Seq())
  };
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(bindingType);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$9 = v.builder$1;
  var array = [key];
  if ((this$9.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$9.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$9, newSize);
  var len$1 = this$9.size0$6;
  var src = this$9.array$6;
  var dest = this$9.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$9.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$9.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_DynamicBindingEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.binding$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_DynamicBindingEmitter.prototype.init___Lamf_plugins_domain_webapi_models_bindings_DynamicBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(binding, ordering, spec) {
  this.binding$1 = binding;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_DynamicBindingEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_DynamicBindingEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.DynamicBindingEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_DynamicBindingEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_DynamicBindingEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_DynamicBindingEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_EmptyBindingEmitter() {
  $c_O.call(this);
  this.binding$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_EmptyBindingEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_EmptyBindingEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_EmptyBindingEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_EmptyBindingEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_EmptyBindingEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_EmptyBindingEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_EmptyBindingEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.binding$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$().Type$1));
  var this$3 = this$2.option$1;
  var bindingType = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(bindingType);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  new $c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter().init___Lamf_core_parser_Position($m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_EmptyBindingEmitter.prototype.init___Lamf_plugins_domain_webapi_models_bindings_EmptyBinding__Lamf_core_emitter_SpecOrdering = (function(binding, ordering) {
  this.binding$1 = binding;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_EmptyBindingEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.binding$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_EmptyBindingEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_EmptyBindingEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.EmptyBindingEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_EmptyBindingEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_EmptyBindingEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_EmptyBindingEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelExchangeEmitter() {
  $c_O.call(this);
  this.binding$1 = null;
  this.ordering$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelExchangeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelExchangeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelExchangeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelExchangeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelExchangeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelExchangeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelExchangeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("exchange");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var fs = this.binding$1.fields$1;
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$().Name$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("name", f, $m_s_None$()))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$().Type$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("type", f$3, $m_s_None$()))
  };
  var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$().Durable$1);
  if ((!this$6.isEmpty__Z())) {
    var arg1$2 = this$6.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("durable", f$4, $m_s_None$()))
  };
  var this$8 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$().AutoDelete$1);
  if ((!this$8.isEmpty__Z())) {
    var arg1$3 = this$8.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("autoDelete", f$5, $m_s_None$()))
  };
  var this$10 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$().VHost$1);
  if ((!this$10.isEmpty__Z())) {
    var arg1$4 = this$10.get__O();
    var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("vhost", f$6, $m_s_None$()))
  };
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$14 = v.builder$1;
  var array = [key];
  if ((this$14.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$14.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$14, newSize);
  var len$1 = this$14.size0$6;
  var src = this$14.array$6;
  var dest = this$14.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$14.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$14.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelExchangeEmitter.prototype.init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange__Lamf_core_emitter_SpecOrdering = (function(binding, ordering) {
  this.binding$1 = binding;
  this.ordering$1 = ordering;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelExchangeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.binding$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelExchangeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelExchangeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.bindings.Amqp091ChannelExchangeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelExchangeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelExchangeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelExchangeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelQueueEmitter() {
  $c_O.call(this);
  this.binding$1 = null;
  this.ordering$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelQueueEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelQueueEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelQueueEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelQueueEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelQueueEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelQueueEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelQueueEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("queue");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var fs = this.binding$1.fields$1;
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$().Name$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("name", f, $m_s_None$()))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$().Exclusive$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("exclusive", f$3, $m_s_None$()))
  };
  var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$().Durable$1);
  if ((!this$6.isEmpty__Z())) {
    var arg1$2 = this$6.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("durable", f$4, $m_s_None$()))
  };
  var this$8 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$().AutoDelete$1);
  if ((!this$8.isEmpty__Z())) {
    var arg1$3 = this$8.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("autoDelete", f$5, $m_s_None$()))
  };
  var this$10 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$().VHost$1);
  if ((!this$10.isEmpty__Z())) {
    var arg1$4 = this$10.get__O();
    var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    if ((!this.isSynthesized__p1__Lamf_core_parser_FieldEntry__Z(f$6))) {
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("vhost", f$6, $m_s_None$()))
    }
  };
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$14 = v.builder$1;
  var array = [key];
  if ((this$14.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$14.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$14, newSize);
  var len$1 = this$14.size0$6;
  var src = this$14.array$6;
  var dest = this$14.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$14.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$14.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelQueueEmitter.prototype.init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue__Lamf_core_emitter_SpecOrdering = (function(binding, ordering) {
  this.binding$1 = binding;
  this.ordering$1 = ordering;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelQueueEmitter.prototype.isSynthesized__p1__Lamf_core_parser_FieldEntry__Z = (function(f) {
  return f.value$1.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_SynthesizedField.getClassOf())
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelQueueEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.binding$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelQueueEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelQueueEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.bindings.Amqp091ChannelQueueEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelQueueEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelQueueEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelQueueEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiChannelBindingsEmitter() {
  $c_O.call(this);
  this.binding$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiChannelBindingsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiChannelBindingsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiChannelBindingsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiChannelBindingsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiChannelBindingsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiChannelBindingsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiChannelBindingsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.emitterFor__p1__Lamf_plugins_domain_webapi_models_bindings_ChannelBinding__s_Option(this.binding$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var emitter = $as_Lamf_core_emitter_EntryEmitter(arg1);
    emitter.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiChannelBindingsEmitter.prototype.init___Lamf_plugins_domain_webapi_models_bindings_ChannelBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(binding, ordering, spec) {
  this.binding$1 = binding;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiChannelBindingsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.binding$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiChannelBindingsEmitter.prototype.emitterFor__p1__Lamf_plugins_domain_webapi_models_bindings_ChannelBinding__s_Option = (function(binding) {
  if ((binding instanceof $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding(binding);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelBindingEmitter().init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding__Lamf_core_emitter_SpecOrdering(x2, this.ordering$1))
  } else if ((binding instanceof $c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding)) {
    var x3 = $as_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding(binding);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_WebSocketChannelBindingEmitter().init___Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x3, this.ordering$1, this.spec$1))
  } else {
    return $m_s_None$()
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiChannelBindingsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiChannelBindingsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.bindings.AsyncApiChannelBindingsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiChannelBindingsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiChannelBindingsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiChannelBindingsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter.prototype.emitBindingVersion__Lamf_core_parser_Fields__scm_ListBuffer__V = (function(fs, result) {
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion$().BindingVersion$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    if ((!f.value$1.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_SynthesizedField.getClassOf()))) {
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("bindingVersion", f, $m_s_None$()))
    }
  }
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiMessageBindingsEmitter() {
  $c_O.call(this);
  this.binding$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiMessageBindingsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiMessageBindingsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiMessageBindingsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiMessageBindingsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiMessageBindingsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiMessageBindingsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiMessageBindingsEmitter.prototype.init___Lamf_plugins_domain_webapi_models_bindings_MessageBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(binding, ordering, spec) {
  this.binding$1 = binding;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiMessageBindingsEmitter.prototype.emitterFor__p1__Lamf_plugins_domain_webapi_models_bindings_MessageBinding__s_Option = (function(binding) {
  if ((binding instanceof $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding(binding);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091MessageEmitter().init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x2, this.ordering$1, this.spec$1))
  } else if ((binding instanceof $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding)) {
    var x3 = $as_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding(binding);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpMessageEmitter().init___Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x3, this.ordering$1, this.spec$1))
  } else if ((binding instanceof $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding)) {
    var x4 = $as_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding(binding);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaMessageEmitter().init___Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x4, this.ordering$1, this.spec$1))
  } else if ((binding instanceof $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding)) {
    var x5 = $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding(binding);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttMessageEmitter().init___Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x5, this.ordering$1, this.spec$1))
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiMessageBindingsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.emitterFor__p1__Lamf_plugins_domain_webapi_models_bindings_MessageBinding__s_Option(this.binding$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var emitter = $as_Lamf_core_emitter_EntryEmitter(arg1);
    emitter.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiMessageBindingsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.binding$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiMessageBindingsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiMessageBindingsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.bindings.AsyncApiMessageBindingsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiMessageBindingsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiMessageBindingsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiMessageBindingsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiOperationBindingsEmitter() {
  $c_O.call(this);
  this.binding$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiOperationBindingsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiOperationBindingsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiOperationBindingsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiOperationBindingsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiOperationBindingsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiOperationBindingsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiOperationBindingsEmitter.prototype.init___Lamf_plugins_domain_webapi_models_bindings_OperationBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(binding, ordering, spec) {
  this.binding$1 = binding;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiOperationBindingsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.emitterFor__p1__Lamf_plugins_domain_webapi_models_bindings_OperationBinding__s_Option(this.binding$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var emitter = $as_Lamf_core_emitter_EntryEmitter(arg1);
    emitter.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiOperationBindingsEmitter.prototype.emitterFor__p1__Lamf_plugins_domain_webapi_models_bindings_OperationBinding__s_Option = (function(binding) {
  if ((binding instanceof $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding(binding);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091OperationBindingEmitter().init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x2, this.ordering$1, this.spec$1))
  } else if ((binding instanceof $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding)) {
    var x3 = $as_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding(binding);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpOperationBindingEmitter().init___Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x3, this.ordering$1, this.spec$1))
  } else if ((binding instanceof $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding)) {
    var x4 = $as_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding(binding);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaOperationBindingEmitter().init___Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x4, this.ordering$1, this.spec$1))
  } else if ((binding instanceof $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding)) {
    var x5 = $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding(binding);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttOperationBindingEmitter().init___Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x5, this.ordering$1, this.spec$1))
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiOperationBindingsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.binding$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiOperationBindingsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiOperationBindingsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.bindings.AsyncApiOperationBindingsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiOperationBindingsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiOperationBindingsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiOperationBindingsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiServerBindingsEmitter() {
  $c_O.call(this);
  this.binding$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiServerBindingsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiServerBindingsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiServerBindingsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiServerBindingsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiServerBindingsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiServerBindingsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiServerBindingsEmitter.prototype.init___Lamf_plugins_domain_webapi_models_bindings_ServerBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(binding, ordering, spec) {
  this.binding$1 = binding;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiServerBindingsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.emitterFor__p1__Lamf_plugins_domain_webapi_models_bindings_ServerBinding__s_Option(this.binding$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var emitter = $as_Lamf_core_emitter_EntryEmitter(arg1);
    emitter.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiServerBindingsEmitter.prototype.emitterFor__p1__Lamf_plugins_domain_webapi_models_bindings_ServerBinding__s_Option = (function(binding) {
  if ((binding instanceof $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding(binding);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter().init___Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding__Lamf_core_emitter_SpecOrdering(x2, this.ordering$1))
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiServerBindingsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.binding$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiServerBindingsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiServerBindingsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.bindings.AsyncApiServerBindingsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiServerBindingsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiServerBindingsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiServerBindingsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter$LastWillEmitter() {
  $c_O.call(this);
  this.lastWill$1 = null;
  this.ordering$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter$LastWillEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter$LastWillEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter$LastWillEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter$LastWillEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter$LastWillEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter$LastWillEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter$LastWillEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("lastWill");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var fs = this.lastWill$1.fields$1;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$().Topic$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("topic", f, $m_s_None$()))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$().Qos$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("qos", f$3, $m_s_None$()))
  };
  var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$().Retain$1);
  if ((!this$6.isEmpty__Z())) {
    var arg1$2 = this$6.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("retain", f$4, $m_s_None$()))
  };
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$10 = v.builder$1;
  var array = [key];
  if ((this$10.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$10.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$10, newSize);
  var len$1 = this$10.size0$6;
  var src = this$10.array$6;
  var dest = this$10.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$10.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$10.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter$LastWillEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.lastWill$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter$LastWillEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter__Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill__Lamf_core_emitter_SpecOrdering = (function($$outer, lastWill, ordering) {
  this.lastWill$1 = lastWill;
  this.ordering$1 = ordering;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter$LastWillEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter$LastWillEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.bindings.MqttServerBindingEmitter$LastWillEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter$LastWillEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter$LastWillEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter$LastWillEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser$.prototype.apply__Lorg_yaml_model_YNode__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser = (function(node, parentId, ctx) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser().init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(new $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, ctx), parentId, ctx)
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncCorrelationIdParser$", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser.call(this);
  this.entry$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function() {
  return this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext()
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(entry, producer, ctx) {
  this.entry$2 = entry;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.call(this, entry, producer, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser.prototype.parse__Lamf_plugins_domain_webapi_models_Operation = (function() {
  var operation = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser.prototype.parse__Lamf_plugins_domain_webapi_models_Operation.call(this);
  var this$1 = this.entry$2.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var this$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$4 = this$3.key__T__s_Option("tags");
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var tags = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser().init___T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(operation.id$1, entry, this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext()).parse__sc_Seq();
    var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Tags$1;
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(tags, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(operation, field, value, annotations)
  };
  var this$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("bindings");
  if ((!this$6.isEmpty__Z())) {
    var arg1$1 = this$6.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var node = entry$3.value$2;
    var errorHandler = this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
    var bindings = $as_Lamf_plugins_domain_webapi_models_bindings_OperationBindings(new $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser().init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(new $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, errorHandler), operation.id$1, this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext()).parse__Lamf_core_model_domain_NamedDomainElement());
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Bindings$1;
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(operation, field$1, bindings, annotations$1);
    new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(operation, map, $m_sci_Nil$(), this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext()).parseOrphanNode__T__V("bindings")
  };
  this.parseMessages__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Operation__V(map, operation);
  this.parseTraits__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Operation__V(map, operation);
  return operation
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function() {
  return $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(this.ctx$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser.prototype.parseOperationId__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Operation__V = (function(map, operation) {
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().OperationId$1;
  var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
  jsx$1.key__T__F1__V("operationId", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(operation))
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$.prototype.parseExtensions__T__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext__sc_Seq = (function(parent, map, target, ctx) {
  var jsx$2 = map.entries$3;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$1, target$1, ctx$1) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var this$1 = entry.key$2;
      var evidence$1 = $m_Lamf_core_parser_package$YScalarYRead$();
      var this$2 = $f_Lorg_yaml_model_YNodeLike__asOption__Lorg_yaml_convert_YRead__s_Option(this$1, evidence$1);
      if (this$2.isEmpty__Z()) {
        var this$3 = $m_s_None$()
      } else {
        var arg1 = this$2.get__O();
        var x$2 = $as_Lorg_yaml_model_YScalar(arg1);
        var this$3 = new $c_s_Some().init___O(x$2.text$3)
      };
      var key = $as_T((this$3.isEmpty__Z() ? entry.key$2.toString__T() : this$3.get__O()));
      var this$4 = $m_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$().resolveAnnotation__T__s_Option(key);
      if (this$4.isEmpty__Z()) {
        var xo = $m_s_None$()
      } else {
        var arg1$1 = this$4.get__O();
        var x$3 = $as_T(arg1$1);
        var this$5 = new $c_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser().init___T__T__Lorg_yaml_model_YMapEntry__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(x$3, parent$1, entry, target$1, ctx$1).parse__Lamf_core_model_domain_extensions_DomainExtension();
        var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
        var xo = new $c_s_Some().init___O($as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$5, other)))
      };
      return xo.toList__sci_List()
    })
  })(this, parent, target, ctx));
  var this$7 = $m_sc_IndexedSeq$();
  return $as_sc_Seq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBF$6))
});
var $d_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.AnnotationParser$", {
  Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter$$anon$1() {
  $c_O.call(this);
  this.$$outer$1 = null;
  this.ctx$1$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter$$anon$1.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter$$anon$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter$$anon$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter$$anon$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter$$anon$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter$$anon$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter$$anon$1.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.$$outer$1.options$1;
  if (this$1.amf$core$emitter$ShapeRenderOptions$$compactedEmission$1) {
    var jsx$1 = this.ctx$1$1.definitionsQueue$3;
    var this$2 = this.$$outer$1.root$1;
    var name = jsx$1.normalizeName__s_Option__T($as_Lamf_core_model_StrField(this$2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1)
  } else {
    var this$3 = this.$$outer$1.root$1;
    var this$4 = $as_Lamf_core_model_StrField(this$3.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
    var this$5 = this$4.option$1;
    var name = $as_T((this$5.isEmpty__Z() ? null : this$5.get__O()))
  };
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("$ref");
  $m_Lorg_yaml_model_YNode$();
  var str = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().appendDefinitionsPrefix__T__s_Option__T(name, $m_s_None$());
  var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter$$anon$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter__Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext = (function($$outer, ctx$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.ctx$1$1 = ctx$1;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter$$anon$1.prototype.position__Lamf_core_parser_Position = (function() {
  return $m_Lamf_core_parser_Position$ZERO$()
});
var $d_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter$$anon$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter$$anon$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.JsonSchemaEmitter$$anon$1", {
  Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter$$anon$1: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter$$anon$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter$$anon$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$.prototype.apply__Lamf_core_model_domain_templates_AbstractDeclaration__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser = (function(declaration, parent, entry, ctx) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser().init___Lamf_core_model_domain_templates_AbstractDeclaration__T__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_plugins_document_webapi_contexts_WebApiContext(declaration, parent, new $c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike().init___Lorg_yaml_model_YMapEntry__Lorg_yaml_model_IllegalTypeHandler(entry, ctx), ctx)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.AbstractDeclarationParser$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter() {
  $c_O.call(this);
  this.domainExtension$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var k = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  k.$$plus$eq__T__V(this.name__T());
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = $m_s_Option$();
  var this$1 = this.domainExtension$1;
  var this$2 = jsx$1.apply__O__s_Option($as_Lamf_core_model_domain_DataNode(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)));
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var x$4 = $as_Lamf_core_model_domain_DataNode(arg1);
    new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler(x$4, this.ordering$1, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler()).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v)
  };
  var this$4 = k.builder$1;
  var jsx$2 = $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$4, 0));
  var this$5 = v.builder$1;
  b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(jsx$2, $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$5, 0)))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter.prototype.init___Lamf_core_model_domain_extensions_DomainExtension__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(domainExtension, ordering, spec) {
  this.domainExtension$1 = domainExtension;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.domainExtension$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.AnnotationEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.AnnotationEmitter;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser.call(this);
  this.map$2 = null;
  this.ctx$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser.prototype.parseOpenIdConnectSettings__Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings__Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings = (function(settings) {
  var map = this.map$2;
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$().Url$1;
  var iv = this.ctx$2;
  jsx$1.key__T__F1__V("openIdConnectUrl", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(settings));
  var map$1 = this.map$2;
  var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("settings").asOasExtension__T();
  var this$5 = this$4.key__T__s_Option(keyword);
  if ((!this$5.isEmpty__Z())) {
    var arg1 = this$5.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$6 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$1 = this.ctx$2;
    var jsx$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion, iv$1));
    var array = [];
    this.parseDynamicSettings__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_Settings__sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings(jsx$2, settings, new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))
  };
  return settings
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser.prototype.parseOauth2Settings__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__Lamf_plugins_domain_webapi_models_security_OAuth2Settings = (function(settings) {
  var map = this.map$2;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("flows");
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var x$1 = $as_Lorg_yaml_model_YMapEntry(arg1);
    this.parseFlows__p2__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__V(x$1, settings)
  };
  var map$1 = this.map$2;
  var this$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("settings").asOasExtension__T();
  var this$6 = this$5.key__T__s_Option(keyword);
  if ((!this$6.isEmpty__Z())) {
    var arg1$1 = this$6.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var this$7 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$2;
    var jsx$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$7, conversion, iv));
    var array = ["authorizationGrants"];
    this.parseDynamicSettings__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_Settings__sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings(jsx$1, settings, new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(settings, this.map$2, $m_sci_Nil$(), this.ctx$2).parseOrphanNode__T__V("flows");
  return settings
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser.prototype.parse__s_Option = (function() {
  var this$1 = this.produceSettings__s_Option();
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var settings = $as_Lamf_plugins_domain_webapi_models_security_Settings(arg1);
    if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings)) {
      var x2 = $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(settings);
      var parsedSettings = this.parseOauth1Settings__Lamf_plugins_domain_webapi_models_security_OAuth1Settings__Lamf_plugins_domain_webapi_models_security_OAuth1Settings(x2)
    } else if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings)) {
      var x3 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(settings);
      var parsedSettings = this.parseOauth2Settings__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__Lamf_plugins_domain_webapi_models_security_OAuth2Settings(x3)
    } else if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings)) {
      var x4 = $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(settings);
      var parsedSettings = this.parseApiKeySettings__Lamf_plugins_domain_webapi_models_security_ApiKeySettings__Lamf_plugins_domain_webapi_models_security_ApiKeySettings(x4)
    } else if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings)) {
      var x5 = $as_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(settings);
      var parsedSettings = this.parseHttpApiKeySettings__Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings__Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(x5)
    } else if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings)) {
      var x6 = $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(settings);
      var parsedSettings = this.parseOpenIdConnectSettings__Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings__Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(x6)
    } else if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_HttpSettings)) {
      var x7 = $as_Lamf_plugins_domain_webapi_models_security_HttpSettings(settings);
      var parsedSettings = this.parseHttpSettings__Lamf_plugins_domain_webapi_models_security_HttpSettings__Lamf_plugins_domain_webapi_models_security_HttpSettings(x7)
    } else {
      var map = this.map$2;
      var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("settings").asOasExtension__T());
      if (this$4.isEmpty__Z()) {
        var this$8 = $m_s_None$()
      } else {
        var arg1$1 = this$4.get__O();
        var entry = $as_Lorg_yaml_model_YMapEntry(arg1$1);
        var this$5 = entry.value$2;
        var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv = this.ctx$2;
        var jsx$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv));
        var array = [];
        var this$8 = new $c_s_Some().init___O(this.parseDynamicSettings__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_Settings__sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings(jsx$1, settings, new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
      };
      var parsedSettings = $as_Lamf_plugins_domain_webapi_models_security_Settings((this$8.isEmpty__Z() ? settings : this$8.get__O()))
    };
    return new $c_s_Some().init___O(this.parseAnnotations__Lamf_plugins_domain_webapi_models_security_Settings__Lamf_plugins_domain_webapi_models_security_Settings(parsedSettings))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser.prototype.init___Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(map, scheme, ctx) {
  this.map$2 = map;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser.prototype.init___Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.call(this, map, scheme, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser.prototype.parseFlows__p2__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__V = (function(entry, settings) {
  var this$1 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$2;
  var jsx$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).entries$3;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, settings$1) {
    return (function(x$2$2) {
      var x$2 = $as_Lorg_yaml_model_YMapEntry(x$2$2);
      return $this.parseFlow__p2__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_security_OAuth2Flow(settings$1, x$2)
    })
  })(this, settings));
  var this$2 = $m_sc_IndexedSeq$();
  var flows = $as_sc_IndexedSeq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBF$6));
  flows.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow(x$3$2);
      $m_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$().validateFlowFields__Lamf_plugins_domain_webapi_models_security_OAuth2Flow__Lamf_core_errorhandling_ErrorHandler__V(x$3, this$2$1.ctx$2.eh$1)
    })
  })(this)));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1;
  $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(settings, field, flows)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser.prototype.parseHttpSettings__Lamf_plugins_domain_webapi_models_security_HttpSettings__Lamf_plugins_domain_webapi_models_security_HttpSettings = (function(settings) {
  var map = this.map$2;
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$().Scheme$1;
  var iv = this.ctx$2;
  jsx$1.key__T__F1__V("scheme", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(settings));
  var map$1 = this.map$2;
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$().BearerFormat$1;
  var iv$1 = this.ctx$2;
  jsx$2.key__T__F1__V("bearerFormat", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(settings));
  return settings
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser.prototype.parseHttpApiKeySettings__Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings__Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings = (function(settings) {
  var map = this.map$2;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("name");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var node = entry.value$2;
    var iv = this.ctx$2;
    var value = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().Name$1;
    var value$1 = value.string__Lamf_core_model_domain_AmfScalar();
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(settings, field, value$1, annotations)
  };
  var map$1 = this.map$2;
  var this$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var this$7 = this$6.key__T__s_Option("in");
  if ((!this$7.isEmpty__Z())) {
    var arg1$1 = this$7.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var node$1 = entry$3.value$2;
    var iv$1 = this.ctx$2;
    var value$2 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$1, iv$1);
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$().In$1;
    var value$3 = value$2.string__Lamf_core_model_domain_AmfScalar();
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(settings, field$1, value$3, annotations$1)
  };
  var map$2 = this.map$2;
  var this$11 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("settings").asOasExtension__T();
  var this$12 = this$11.key__T__s_Option(keyword);
  if ((!this$12.isEmpty__Z())) {
    var arg1$2 = this$12.get__O();
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var this$13 = entry$4.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$2 = this.ctx$2;
    var jsx$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$13, conversion, iv$2));
    var array = ["name", "in"];
    this.parseDynamicSettings__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_Settings__sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings(jsx$1, settings, new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))
  };
  return settings
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser.prototype.parseFlow__p2__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_security_OAuth2Flow = (function(settings, flowEntry) {
  var flow = $m_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_security_OAuth2Flow(flowEntry);
  var this$1 = flowEntry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$2;
  var flowMap = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var node = flowEntry.key$2;
  var iv$1 = this.ctx$2;
  var this$3 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv$1);
  var flowKey = this$3.string__Lamf_core_model_domain_AmfScalar();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Flow$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(flow, field, flowKey);
  var parent = settings.id$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(flow, parent);
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(flowMap);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1;
  var iv$2 = this.ctx$2;
  jsx$1.key__T__F1__V("authorizationUrl", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(flow));
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(flowMap);
  var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1;
  var iv$3 = this.ctx$2;
  jsx$2.key__T__F1__V("tokenUrl", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(flow));
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(flowMap);
  var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().RefreshUri$1;
  var iv$4 = this.ctx$2;
  jsx$3.key__T__F1__V("refreshUrl", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$3, iv$4).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(flow));
  this.parseScopes__Lamf_plugins_domain_webapi_models_security_OAuth2Flow__Lorg_yaml_model_YMap__V(flow, flowMap);
  return flow
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser.prototype.vendorSpecificSettingsProducers__Lamf_plugins_document_webapi_parser_spec_declaration_SettingsProducers = (function() {
  return $m_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SettingsProducers$()
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.Async2SecuritySettingsParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter() {
  $c_O.call(this);
  this.f$1 = null;
  this.ordering$1 = null;
  this.references$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(f, ordering, references, spec) {
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.references$1 = references;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key__T();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var this$3 = this.f$1;
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(this$3.value$1.value$1).values$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(v$2) {
      var v$1 = $as_Lamf_core_model_domain_AmfElement(v$2);
      return $as_Lamf_core_emitter_EntryEmitter($this.shapeEmitter__F3().apply__O__O__O__O($as_Lamf_core_model_domain_extensions_PropertyShape(v$1), $this.ordering$1, $this.references$1))
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  var result = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2));
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$4 = j;
    var index = i;
    xs.set(jsx$4, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$1() {
  $c_O.call(this);
  this.x3$1$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$1.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1__Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter = (function($$outer, x3$1) {
  this.x3$1$1 = x3$1;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$1.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@value");
  $m_Lorg_yaml_model_YNode$();
  var str = this.x3$1$1.value$1;
  var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$1.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.x3$1$1;
  var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this$1.annotations$1;
  return this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.DataNodeEmitter$$anonfun$1$$anon$1", {
  Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$1: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$2() {
  $c_O.call(this);
  this.x4$1$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$2.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$2.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@value");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  this.x4$1$1.emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
  var this$3 = v.builder$1;
  var array = [key];
  if ((this$3.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$3.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$3, newSize);
  var len$1 = this$3.size0$6;
  var src = this$3.array$6;
  var dest = this$3.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$3.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$3.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1__Lamf_core_emitter_BaseEmitters_package$NullEmitter = (function($$outer, x4$1) {
  this.x4$1$1 = x4$1;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$2.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.x4$1$1;
  var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this$1.annotations$1;
  return this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.DataNodeEmitter$$anonfun$1$$anon$2", {
  Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$2: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters() {
  $c_O.call(this);
  this.types$1 = null;
  this.spec$1 = null;
  this.key$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.spec$1;
  this$1.emittingDeclarations$1 = true;
  this.emitTypes__Lorg_yaml_model_YDocument$EntryBuilder__V(b);
  this$1.emittingDeclarations$1 = false
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters.prototype.init___sc_Seq__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(types, references, ordering, spec) {
  this.types$1 = types;
  this.spec$1 = spec;
  var x = spec.vendor__Lamf_core_remote_Vendor();
  var x$2 = $m_Lamf_core_remote_Vendor$().OAS30$1;
  if ((x === x$2)) {
    var jsx$1 = true
  } else {
    var x$3 = spec.vendor__Lamf_core_remote_Vendor();
    var x$4 = $m_Lamf_core_remote_Vendor$().ASYNC20$1;
    var jsx$1 = (x$3 === x$4)
  };
  this.key$1 = (jsx$1 ? "schemas" : "definitions");
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.types$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var a = $as_Lamf_core_model_domain_Shape(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = a.annotations__Lamf_core_parser_Annotations();
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter() {
  $c_O.call(this);
  this.shapeExtension$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var k = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  k.$$plus$eq__T__V(this.name__T());
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = $m_s_Option$();
  var this$1 = this.shapeExtension$1;
  var this$2 = jsx$1.apply__O__s_Option($as_Lamf_core_model_domain_DataNode(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)));
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var x$5 = $as_Lamf_core_model_domain_DataNode(arg1);
    new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler(x$5, this.ordering$1, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler()).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v)
  };
  var this$4 = k.builder$1;
  var jsx$2 = $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$4, 0));
  var this$5 = v.builder$1;
  b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(jsx$2, $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$5, 0)))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter.prototype.init___Lamf_core_model_domain_extensions_ShapeExtension__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(shapeExtension, ordering, spec) {
  this.shapeExtension$1 = shapeExtension;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.shapeExtension$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.FacetsInstanceEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.FacetsInstanceEmitter;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$.prototype.apply__Lorg_yaml_model_YMapEntry__Lamf_core_parser_ParserContext__s_Option = (function(e, ctx) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser().init___Lorg_yaml_model_YMapEntry(e).parse__Lamf_core_parser_ParserContext__s_Option(ctx)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.LibraryLocationParser$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion.prototype.position__T = (function() {
  return this.position$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion.prototype.init___T__Lamf_core_errorhandling_ErrorHandler = (function(position, eh) {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion.prototype.init___T__T__Lamf_core_errorhandling_ErrorHandler.call(this, "oas2.0", position, eh);
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OAS20SchemaVersion"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OAS20SchemaVersion;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OAS20SchemaVersion", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion.prototype.position__T = (function() {
  return this.position$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion.prototype.init___T__Lamf_core_errorhandling_ErrorHandler = (function(position, eh) {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion.prototype.init___T__T__Lamf_core_errorhandling_ErrorHandler.call(this, "oas3.0.0", position, eh);
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OAS30SchemaVersion"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OAS30SchemaVersion;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OAS30SchemaVersion", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SecuritySettingsParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser.call(this);
  this.map$2 = null;
  this.ctx$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SecuritySettingsParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SecuritySettingsParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SecuritySettingsParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SecuritySettingsParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SecuritySettingsParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SecuritySettingsParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SecuritySettingsParser.prototype.parseOauth2Settings__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__Lamf_plugins_domain_webapi_models_security_OAuth2Settings = (function(settings) {
  var flow = new $c_Lamf_core_utils_Lazy().init___F0(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, settings$1) {
    return (function() {
      var qual$1 = $m_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_security_OAuth2Flow($this.map$2);
      var x$1 = settings$1.id$1;
      $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      return $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1))
    })
  })(this, settings)));
  var map = this.map$2;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("authorizationUrl");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$6 = $as_Lamf_core_model_domain_AmfObject(flow.getOrCreate__O());
    var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1;
    var node = entry.value$2;
    var iv = this.ctx$2;
    var this$5 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
    var value = this$5.string__Lamf_core_model_domain_AmfScalar();
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$6, field, value, annotations)
  };
  var map$1 = this.map$2;
  var this$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var this$9 = this$8.key__T__s_Option("tokenUrl");
  if ((!this$9.isEmpty__Z())) {
    var arg1$1 = this$9.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var this$12 = $as_Lamf_core_model_domain_AmfObject(flow.getOrCreate__O());
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1;
    var node$1 = entry$3.value$2;
    var iv$1 = this.ctx$2;
    var this$11 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$1, iv$1);
    var value$1 = this$11.string__Lamf_core_model_domain_AmfScalar();
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3.value$2);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$12, field$1, value$1, annotations$1)
  };
  var map$2 = this.map$2;
  var this$14 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var this$15 = this$14.key__T__s_Option("flow");
  if ((!this$15.isEmpty__Z())) {
    var arg1$2 = this$15.get__O();
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var node$2 = entry$4.value$2;
    var iv$2 = this.ctx$2;
    var value$2 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$2, iv$2);
    var this$17 = $as_Lamf_core_model_domain_AmfObject(flow.getOrCreate__O());
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Flow$1;
    var value$3 = value$2.string__Lamf_core_model_domain_AmfScalar();
    var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$17, field$2, value$3, annotations$2)
  };
  var map$3 = this.map$2;
  var this$19 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3).key__T__s_Option("scopes");
  if ((!this$19.isEmpty__Z())) {
    var arg1$3 = this$19.get__O();
    $as_Lorg_yaml_model_YMapEntry(arg1$3);
    this.parseScopes__Lamf_plugins_domain_webapi_models_security_OAuth2Flow__Lorg_yaml_model_YMap__V($as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow(flow.getOrCreate__O()), this.map$2)
  };
  var map$4 = this.map$2;
  var this$22 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$4);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("settings").asOasExtension__T();
  var this$23 = this$22.key__T__s_Option(keyword);
  if ((!this$23.isEmpty__Z())) {
    var arg1$4 = this$23.get__O();
    var entry$5 = $as_Lorg_yaml_model_YMapEntry(arg1$4);
    var this$24 = entry$5.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$3 = this.ctx$2;
    var xSettings = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$24, conversion, iv$3));
    var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(xSettings);
    var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().AuthorizationGrants$1;
    var iv$4 = this.ctx$2;
    jsx$1.key__T__F1__V("authorizationGrants", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$3, iv$4).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(settings));
    var array = ["authorizationGrants"];
    this.parseDynamicSettings__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_Settings__sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings(xSettings, settings, new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(settings, this.map$2, $m_sci_Nil$(), this.ctx$2).parseOrphanNode__T__V("scopes");
  var this$29 = flow.value$1;
  if ((!this$29.isEmpty__Z())) {
    var arg1$5 = this$29.get__O();
    var f = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow(arg1$5);
    var parent = settings.id$1;
    $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(f, parent);
    var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1;
    $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings($f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(settings, field$4, f))
  };
  return settings
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SecuritySettingsParser.prototype.parse__s_Option = (function() {
  var this$1 = this.produceSettings__s_Option();
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var settings = $as_Lamf_plugins_domain_webapi_models_security_Settings(arg1);
    if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings)) {
      var x2 = $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(settings);
      var parsedSettings = this.parseOauth1Settings__Lamf_plugins_domain_webapi_models_security_OAuth1Settings__Lamf_plugins_domain_webapi_models_security_OAuth1Settings(x2)
    } else if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings)) {
      var x3 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(settings);
      var parsedSettings = this.parseOauth2Settings__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__Lamf_plugins_domain_webapi_models_security_OAuth2Settings(x3)
    } else if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings)) {
      var x4 = $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(settings);
      var parsedSettings = this.parseApiKeySettings__Lamf_plugins_domain_webapi_models_security_ApiKeySettings__Lamf_plugins_domain_webapi_models_security_ApiKeySettings(x4)
    } else {
      var map = this.map$2;
      var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("settings").asOasExtension__T());
      if (this$4.isEmpty__Z()) {
        var this$8 = $m_s_None$()
      } else {
        var arg1$1 = this$4.get__O();
        var entry = $as_Lorg_yaml_model_YMapEntry(arg1$1);
        var this$5 = entry.value$2;
        var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv = this.ctx$2;
        var jsx$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv));
        var array = [];
        var this$8 = new $c_s_Some().init___O(this.parseDynamicSettings__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_Settings__sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings(jsx$1, settings, new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
      };
      var parsedSettings = $as_Lamf_plugins_domain_webapi_models_security_Settings((this$8.isEmpty__Z() ? settings : this$8.get__O()))
    };
    parsedSettings.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_VirtualObject().init___());
    return new $c_s_Some().init___O(this.parseAnnotations__Lamf_plugins_domain_webapi_models_security_Settings__Lamf_plugins_domain_webapi_models_security_Settings(parsedSettings))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SecuritySettingsParser.prototype.vendorSpecificSettingsProducers__Lamf_plugins_document_webapi_parser_spec_declaration_SettingsProducers = (function() {
  return $m_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SettingsProducers$()
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SecuritySettingsParser.prototype.init___Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(map, scheme, ctx) {
  this.map$2 = map;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser.prototype.init___Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.call(this, map, scheme, ctx);
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SecuritySettingsParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SecuritySettingsParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.Oas2SecuritySettingsParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SecuritySettingsParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SecuritySettingsParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SecuritySettingsParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SecuritySettingsParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser.call(this);
  this.map$2 = null;
  this.ctx$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SecuritySettingsParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SecuritySettingsParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SecuritySettingsParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SecuritySettingsParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SecuritySettingsParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SecuritySettingsParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SecuritySettingsParser.prototype.parseOpenIdConnectSettings__Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings__Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings = (function(settings) {
  var map = this.map$2;
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$().Url$1;
  var iv = this.ctx$2;
  jsx$1.key__T__F1__V("openIdConnectUrl", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(settings));
  var map$1 = this.map$2;
  var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("settings").asOasExtension__T();
  var this$5 = this$4.key__T__s_Option(keyword);
  if ((!this$5.isEmpty__Z())) {
    var arg1 = this$5.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$6 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$1 = this.ctx$2;
    var jsx$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion, iv$1));
    var array = [];
    this.parseDynamicSettings__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_Settings__sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings(jsx$2, settings, new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))
  };
  return settings
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SecuritySettingsParser.prototype.parseOauth2Settings__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__Lamf_plugins_domain_webapi_models_security_OAuth2Settings = (function(settings) {
  var map = this.map$2;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("flows");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var x$1 = $as_Lorg_yaml_model_YMapEntry(arg1);
    this.parseFlows__p2__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__V(x$1, settings)
  };
  var map$1 = this.map$2;
  var this$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("settings").asOasExtension__T();
  var this$7 = this$6.key__T__s_Option(keyword);
  if ((!this$7.isEmpty__Z())) {
    var arg1$1 = this$7.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var this$8 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$2;
    var jsx$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$8, conversion, iv));
    var array = ["authorizationGrants"];
    this.parseDynamicSettings__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_Settings__sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings(jsx$1, settings, new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(settings, this.map$2, $m_sci_Nil$(), this.ctx$2).parseOrphanNode__T__V("flows");
  return settings
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SecuritySettingsParser.prototype.parse__s_Option = (function() {
  var this$1 = this.produceSettings__s_Option();
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var settings = $as_Lamf_plugins_domain_webapi_models_security_Settings(arg1);
    if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings)) {
      var x2 = $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(settings);
      var parsedSettings = this.parseOauth1Settings__Lamf_plugins_domain_webapi_models_security_OAuth1Settings__Lamf_plugins_domain_webapi_models_security_OAuth1Settings(x2)
    } else if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings)) {
      var x3 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(settings);
      var parsedSettings = this.parseOauth2Settings__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__Lamf_plugins_domain_webapi_models_security_OAuth2Settings(x3)
    } else if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings)) {
      var x4 = $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(settings);
      var parsedSettings = this.parseApiKeySettings__Lamf_plugins_domain_webapi_models_security_ApiKeySettings__Lamf_plugins_domain_webapi_models_security_ApiKeySettings(x4)
    } else if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings)) {
      var x5 = $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(settings);
      var parsedSettings = this.parseOpenIdConnectSettings__Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings__Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(x5)
    } else if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_HttpSettings)) {
      var x6 = $as_Lamf_plugins_domain_webapi_models_security_HttpSettings(settings);
      var parsedSettings = this.parseHttpSettings__Lamf_plugins_domain_webapi_models_security_HttpSettings__Lamf_plugins_domain_webapi_models_security_HttpSettings(x6)
    } else {
      var map = this.map$2;
      var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("settings").asOasExtension__T());
      if (this$4.isEmpty__Z()) {
        var this$8 = $m_s_None$()
      } else {
        var arg1$1 = this$4.get__O();
        var entry = $as_Lorg_yaml_model_YMapEntry(arg1$1);
        var this$5 = entry.value$2;
        var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv = this.ctx$2;
        var jsx$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv));
        var array = [];
        var this$8 = new $c_s_Some().init___O(this.parseDynamicSettings__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_Settings__sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings(jsx$1, settings, new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
      };
      var parsedSettings = $as_Lamf_plugins_domain_webapi_models_security_Settings((this$8.isEmpty__Z() ? settings : this$8.get__O()))
    };
    return new $c_s_Some().init___O(this.parseAnnotations__Lamf_plugins_domain_webapi_models_security_Settings__Lamf_plugins_domain_webapi_models_security_Settings(parsedSettings))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SecuritySettingsParser.prototype.parseFlows__p2__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__V = (function(entry, settings) {
  var this$1 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$2;
  $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, settings$1) {
    return (function(x$2$2) {
      var x$2 = $as_Lorg_yaml_model_YMapEntry(x$2$2);
      return $this.parseFlow__p2__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_security_OAuth2Settings(settings$1, x$2)
    })
  })(this, settings)))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SecuritySettingsParser.prototype.parseHttpSettings__Lamf_plugins_domain_webapi_models_security_HttpSettings__Lamf_plugins_domain_webapi_models_security_HttpSettings = (function(settings) {
  var map = this.map$2;
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$().Scheme$1;
  var iv = this.ctx$2;
  jsx$1.key__T__F1__V("scheme", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(settings));
  var map$1 = this.map$2;
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$().BearerFormat$1;
  var iv$1 = this.ctx$2;
  jsx$2.key__T__F1__V("bearerFormat", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(settings));
  return settings
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SecuritySettingsParser.prototype.parseFlow__p2__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_security_OAuth2Settings = (function(settings, flowEntry) {
  var flow = $m_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_security_OAuth2Flow(flowEntry);
  var this$1 = flowEntry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$2;
  var flowMap = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var node = flowEntry.key$2;
  var iv$1 = this.ctx$2;
  var this$3 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv$1);
  var flowKey = this$3.string__Lamf_core_model_domain_AmfScalar();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Flow$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(flow, field, flowKey);
  var parent = settings.id$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(flow, parent);
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(flowMap);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1;
  var iv$2 = this.ctx$2;
  jsx$1.key__T__F1__V("authorizationUrl", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(flow));
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(flowMap);
  var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1;
  var iv$3 = this.ctx$2;
  jsx$2.key__T__F1__V("tokenUrl", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(flow));
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(flowMap);
  var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().RefreshUri$1;
  var iv$4 = this.ctx$2;
  jsx$3.key__T__F1__V("refreshUrl", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$3, iv$4).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(flow));
  this.parseScopes__Lamf_plugins_domain_webapi_models_security_OAuth2Flow__Lorg_yaml_model_YMap__V(flow, flowMap);
  $m_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$().validateFlowFields__Lamf_plugins_domain_webapi_models_security_OAuth2Flow__Lamf_core_errorhandling_ErrorHandler__V(flow, this.ctx$2.eh$1);
  var jsx$5 = this.ctx$2;
  var jsx$4 = flow.id$1;
  var this$7 = $as_Lamf_core_model_StrField(flow.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Flow$1));
  var this$8 = this$7.option$1;
  jsx$5.closedShape__T__Lorg_yaml_model_YMap__T__V(jsx$4, flowMap, $as_T((this$8.isEmpty__Z() ? null : this$8.get__O())));
  var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1;
  return $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings($f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(settings, field$4, flow))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SecuritySettingsParser.prototype.vendorSpecificSettingsProducers__Lamf_plugins_document_webapi_parser_spec_declaration_SettingsProducers = (function() {
  return $m_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SettingsProducers$()
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SecuritySettingsParser.prototype.init___Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(map, scheme, ctx) {
  this.map$2 = map;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser.prototype.init___Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.call(this, map, scheme, ctx);
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SecuritySettingsParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SecuritySettingsParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.Oas3SecuritySettingsParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SecuritySettingsParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SecuritySettingsParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SecuritySettingsParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$.prototype.parse__Lorg_yaml_model_YNode__T__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_domain_shapes_models_CreativeWork = (function(node, parentId, ctx) {
  $m_Lorg_yaml_model_YNode$();
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, ctx));
  $m_Lorg_yaml_model_YNode$();
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser().init___Lorg_yaml_model_YNode__T__Lamf_plugins_document_webapi_contexts_WebApiContext($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1), parentId, ctx).parse__Lamf_plugins_domain_shapes_models_CreativeWork()
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasLikeCreativeWorkParser$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySchemeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser.call(this);
  this.part$2 = null;
  this.adopt$2 = null;
  this.ctx$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySchemeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySchemeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySchemeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySchemeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySchemeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySchemeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySchemeParser.prototype.init___Lorg_yaml_model_YPart__F1__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function(part, adopt, ctx) {
  this.part$2 = part;
  this.adopt$2 = adopt;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser.prototype.init___Lorg_yaml_model_YPart__F1__Lamf_plugins_document_webapi_contexts_WebApiContext.call(this, part, adopt, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySchemeParser.prototype.parseType__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_SecurityScheme__V = (function(map, scheme) {
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1;
  var iv = this.ctx$2;
  jsx$1.key__T__F1__V("type", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(scheme));
  var rc11 = false;
  var x2 = null;
  var x1 = $as_Lamf_core_model_StrField(scheme.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1)).option$1;
  matchEnd12: {
    if ((x1 instanceof $c_s_Some)) {
      rc11 = true;
      x2 = $as_s_Some(x1);
      var p3 = $as_T(x2.value$2);
      if (((p3 === "OAuth 1.0") || ((p3 === "OAuth 2.0") || ((p3 === "Basic Authentication") || ((p3 === "Digest Authentication") || (p3 === "Pass Through")))))) {
        this.ctx$2.eh$1.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V($m_Lamf_validations_ParserSideValidations$().CrossSecurityWarningSpecification$1, scheme.id$1, new $c_s_Some().init___O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1.value$1.iri__T()), "RAML 1.0 security scheme type detected in OAS 2.0 spec", $as_Lamf_core_model_StrField(scheme.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1)).annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), new $c_s_Some().init___O(this.ctx$2.rootContextDocument$1));
        break matchEnd12
      }
    };
    if (rc11) {
      var s = $as_T(x2.value$2);
      if ((($uI(s.length) >= 0) && ($as_T(s.substring(0, $uI("x-".length))) === "x-"))) {
        this.ctx$2.eh$1.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V($m_Lamf_validations_ParserSideValidations$().CrossSecurityWarningSpecification$1, scheme.id$1, new $c_s_Some().init___O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1.value$1.iri__T()), (((("RAML 1.0 extension security scheme type '" + s) + "' detected in ") + this.ctx$2.vendor__Lamf_core_remote_Vendor().name__T()) + " spec"), $as_Lamf_core_model_StrField(scheme.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1)).annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), new $c_s_Some().init___O(this.ctx$2.rootContextDocument$1));
        break matchEnd12
      }
    }
  };
  var this$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$9 = this$8.key__T__s_Option("type");
  if ((!this$9.isEmpty__Z())) {
    var arg1 = this$9.get__O();
    var value = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$10 = value.value$2;
    var x = this$10.tag__Lorg_yaml_model_YTag().tagType$3;
    var x$2 = $m_Lorg_yaml_model_YType$().Null$1;
    if (((x === x$2) && $as_Lamf_core_model_StrField(scheme.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1)).option$1.contains__O__Z(""))) {
      var this$12 = this.ctx$2.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().MissingSecuritySchemeErrorSpecification$1;
      var node = scheme.id$1;
      var property = new $c_s_Some().init___O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1.value$1.iri__T());
      var jsx$2 = $m_Lamf_core_parser_Range$();
      var this$11 = map.location$1;
      var lexical = new $c_s_Some().init___O(new $c_Lamf_core_annotations_LexicalInformation().init___Lamf_core_parser_Range(jsx$2.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$11.lineFrom$1, this$11.columnFrom$1, this$11.lineTo$1, this$11.columnTo$1))));
      var location = new $c_s_Some().init___O(this.ctx$2.rootContextDocument$1);
      this$12.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "Security Scheme must have a mandatory value from 'oauth2', 'basic' or 'apiKey'", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
    }
  };
  scheme.normalizeType__V()
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySchemeParser.prototype.parseReferenced__T__Lorg_yaml_model_YNode__F1__Lamf_plugins_domain_webapi_models_security_SecurityScheme = (function(parsedUrl, node, adopt) {
  var this$2 = this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations().findSecurityScheme__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option(parsedUrl, $m_Lamf_core_parser_SearchScope$Fragments$(), (this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations(), $m_s_None$()));
  if (this$2.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var securityScheme = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(arg1);
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(node);
    var scheme = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(securityScheme, parsedUrl, annotations));
    adopt.apply__O__O(scheme);
    var this$3 = new $c_s_Some().init___O(scheme)
  };
  if (this$3.isEmpty__Z()) {
    var this$6 = this.ctx$2;
    $m_Lamf_core_parser_Annotations$();
    new $c_Lamf_core_parser_Annotations().init___();
    var x1 = this$6.jsonSchemaRefGuide$2.obtainRemoteYNode__T__s_Option(parsedUrl);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var schemeNode = $as_Lorg_yaml_model_YNode(x2.value$2);
      var jsx$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser(this.ctx$2.factory__Lamf_plugins_document_webapi_contexts_parser_OasLikeSpecVersionFactory().securitySchemeParser__F2().apply__O__O__O(schemeNode, adopt)).parse__Lamf_plugins_domain_webapi_models_security_SecurityScheme()
    } else {
      var x = $m_s_None$();
      if ((!(x === x1))) {
        throw new $c_s_MatchError().init___O(x1)
      };
      var this$7 = this.ctx$2.eh$1;
      var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnresolvedReference$1;
      var message = ("Cannot find security scheme reference " + parsedUrl);
      var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(node);
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$7, specification, "", message, annotations$1);
      var jsx$1 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(adopt.apply__O__O(new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme().init___T__Lorg_yaml_model_YPart(parsedUrl, node)))
    }
  } else {
    var jsx$1 = this$3.get__O()
  };
  return $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(jsx$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySchemeParser.prototype.parse__Lamf_plugins_domain_webapi_models_security_SecurityScheme = (function() {
  var node = this.getNode__Lorg_yaml_model_YNode();
  var x1 = this.ctx$2.link__Lorg_yaml_model_YNode__s_util_Either(node);
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var link = $as_T(x2.value$2);
    return this.parseReferenced__T__Lorg_yaml_model_YNode__F1__Lamf_plugins_domain_webapi_models_security_SecurityScheme(link, node, this.adopt$2)
  } else if ((x1 instanceof $c_s_util_Right)) {
    var x3 = $as_s_util_Right(x1);
    var value = $as_Lorg_yaml_model_YNode(x3.value$2);
    var scheme = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(this.adopt$2.apply__O__O($m_Lamf_plugins_domain_webapi_models_security_SecurityScheme$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_security_SecurityScheme(this.part$2)));
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$2;
    var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(value, conversion, iv));
    this.parseType__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_SecurityScheme__V(map, scheme);
    var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var jsx$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T("displayName").asOasExtension__T();
    var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().DisplayName$1;
    var iv$1 = this.ctx$2;
    jsx$2.key__T__F1__V(jsx$1, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(scheme));
    var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Description$1;
    var iv$2 = this.ctx$2;
    jsx$3.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(scheme));
    new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser().init___T__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(new $c_Lamf_core_utils_package$AmfStrings().init___T("describedBy").asOasExtension__T(), map, scheme, $m_Lamf_plugins_document_webapi_parser_spec_package$().toRaml__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this.ctx$2)).parse__V();
    var this$5 = this.ctx$2.factory__Lamf_plugins_document_webapi_contexts_parser_OasLikeSpecVersionFactory().securitySettingsParser__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser(map, scheme).parse__s_Option();
    if ((!this$5.isEmpty__Z())) {
      var arg1 = this$5.get__O();
      var settings = $as_Lamf_plugins_domain_webapi_models_security_Settings(arg1);
      var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1;
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(map);
      new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_security_SecurityScheme($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(scheme, field$2, settings, annotations)))
    };
    new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(scheme, map, $m_sci_Nil$(), this.ctx$2).parse__V();
    this.ctx$2.closedShape__T__Lorg_yaml_model_YMap__T__V(scheme.id$1, map, "securityScheme");
    return scheme
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$.prototype.apply__Lorg_yaml_model_YNode__T__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser = (function(node, name, adopt, version, ctx) {
  $m_s_package$();
  var jsx$1 = new $c_s_util_Right().init___O(node);
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser().init___s_util_Either__T__Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(jsx$1, name, $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, ctx)), adopt, version, ctx)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$.prototype.apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser = (function(entry, adopt, ctx) {
  $m_s_package$();
  var jsx$4 = new $c_s_util_Left().init___O(entry);
  var this$2 = entry.key$2;
  var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
  var jsx$3 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, ctx)).text$3;
  var this$3 = entry.value$2;
  var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var jsx$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion$1, ctx));
  var x = ctx.vendor__Lamf_core_remote_Vendor();
  var x$2 = $m_Lamf_core_remote_Vendor$().OAS30$1;
  if ((x === x$2)) {
    var eh = ctx.eh$1;
    var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion().init___T__Lamf_core_errorhandling_ErrorHandler("schema", eh)
  } else {
    var x$3 = ctx.vendor__Lamf_core_remote_Vendor();
    var x$4 = $m_Lamf_core_remote_Vendor$().ASYNC20$1;
    if ((x$3 === x$4)) {
      var jsx$1 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$()
    } else {
      var eh$1 = ctx.eh$1;
      var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion().init___T__Lamf_core_errorhandling_ErrorHandler("schema", eh$1)
    }
  };
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser().init___s_util_Either__T__Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(jsx$4, jsx$3, jsx$2, adopt, jsx$1, ctx)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$.prototype.apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser = (function(entry, adopt, version, ctx) {
  $m_s_package$();
  var jsx$2 = new $c_s_util_Left().init___O(entry);
  var this$2 = entry.key$2;
  var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
  var jsx$1 = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, ctx));
  var this$3 = entry.value$2;
  var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser().init___s_util_Either__T__Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(jsx$2, jsx$1, $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion$1, ctx)), adopt, version, ctx)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$.prototype.apply__Lorg_yaml_model_YNode__T__F1__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser = (function(node, name, adopt, ctx) {
  $m_s_package$();
  var jsx$2 = new $c_s_util_Right().init___O(node);
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var jsx$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, ctx));
  var eh = ctx.eh$1;
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser().init___s_util_Either__T__Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(jsx$2, name, jsx$1, adopt, new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion().init___T__Lamf_core_errorhandling_ErrorHandler("schema", eh), ctx)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$.prototype.apply__Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser = (function(entry, adopt, isAnnotation, defaultType, ctx) {
  $m_s_package$();
  var jsx$3 = new $c_s_util_Left().init___O(entry);
  var jsx$2 = entry.key$2;
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo().init___Z__Z(isAnnotation, false);
  var x$1 = ctx.rootContextDocument$1;
  var x$2 = ctx.refs$1;
  var x$4 = new $c_s_Some().init___O(ctx.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations());
  var x$5 = ctx.options$2;
  var x$6 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2;
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser().init___s_util_Either__Lorg_yaml_model_YNode__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(jsx$3, jsx$2, adopt, jsx$1, defaultType, new $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions(x$1, x$2, ctx, x$4, x$6, x$5))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$.prototype.apply__Lorg_yaml_model_YNode__T__F1__Z__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser = (function(node, name, adopt, isAnnotation, defaultType, ctx) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser().init___s_util_Either__Lorg_yaml_model_YNode__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(($m_s_package$(), new $c_s_util_Right().init___O(node)), ($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(name)), adopt, new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo().init___Z__Z(isAnnotation, false), defaultType, new $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions(ctx.rootContextDocument$1, ctx.refs$1, ctx, new $c_s_Some().init___O(ctx.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations()), ctx.contextType$3, ctx.options$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$.prototype.apply__s_util_Either__T__F1__Z__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser = (function(entryOrNode, name, adopt, isAnnotation, defaultType, ctx) {
  $m_Lorg_yaml_model_YNode$();
  var jsx$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(name);
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo().init___Z__Z(isAnnotation, false);
  var x$1 = ctx.rootContextDocument$1;
  var x$2 = ctx.refs$1;
  var x$4 = new $c_s_Some().init___O(ctx.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations());
  var x$5 = ctx.options$2;
  var x$6 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2;
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser().init___s_util_Either__Lorg_yaml_model_YNode__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(entryOrNode, jsx$2, adopt, jsx$1, defaultType, new $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions(x$1, x$2, ctx, x$4, x$6, x$5))
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.Raml08TypeParser$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$.prototype.apply__Lorg_yaml_model_YNode__T__F1__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser = (function(node, name, adopt, defaultType, ctx) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser().init___s_util_Either__Lorg_yaml_model_YNode__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(($m_s_package$(), new $c_s_util_Right().init___O(node)), ($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(name)), adopt, new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo().init___Z__Z(false, false), defaultType, ctx)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$.prototype.apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser = (function(entry, adopt, typeInfo, defaultType, ctx) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser().init___s_util_Either__Lorg_yaml_model_YNode__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(($m_s_package$(), new $c_s_util_Left().init___O(entry)), entry.key$2, adopt, typeInfo, defaultType, new $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions(ctx.rootContextDocument$1, ctx.refs$1, ctx, new $c_s_Some().init___O(ctx.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations()), ctx.contextType$3, ctx.options$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$.prototype.apply__s_util_Either__T__F1__Z__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser = (function(entryOrNode, name, adopt, isAnnotation, defaultType, ctx) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser().init___s_util_Either__Lorg_yaml_model_YNode__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(entryOrNode, ($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(name)), adopt, new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo().init___Z__Z(isAnnotation, false), defaultType, ctx)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.Raml10TypeParser$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher$.prototype.apply__Lamf_plugins_domain_shapes_models_UnionShape__Lorg_yaml_model_YNode__Lamf_core_parser_ParserContext__s_Option = (function(union, part, ctx) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$__Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_parser_ParserContext(this.$$outer$1, union, ctx).matchUnionFather__Lorg_yaml_model_YPart__s_Option(part)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher$.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$ = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher$;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations$.prototype.apply__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations = (function(ctx) {
  var references = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations().init___scm_Map__Lamf_plugins_document_webapi_contexts_WebApiContext(references, ctx)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.ReferenceDeclarations$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser$.prototype.parse__T__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_domain_shapes_models_XMLSerializer = (function(defaultName, node, ctx) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser().init___T__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext(defaultName, node, ctx).parse__Lamf_plugins_domain_shapes_models_XMLSerializer()
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.XMLSerializerParser$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$1() {
  $c_O.call(this);
  this.$$outer$1 = null;
  this.father$1$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$1.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter__Lamf_core_model_domain_Shape = (function($$outer, father$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.father$1$1 = father$1;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$1.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var eta$0$1 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$().apply__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext__Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter(this.father$1$1, this.$$outer$1.ordering$1, $m_sci_Nil$(), this.$$outer$1.amf$plugins$document$webapi$parser$spec$declaration$emitters$raml$Raml08TypeEmitter$$spec$f);
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("schema");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  eta$0$1.emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
  var this$4 = v.builder$1;
  var array = [key];
  if ((this$4.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$4.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$4, newSize);
  var len$1 = this$4.size0$6;
  var src = this$4.array$6;
  var dest = this$4.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$4.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$4.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$1.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.father$1$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.Raml08TypeEmitter$$anon$1", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$1: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2() {
  $c_O.call(this);
  this.$$outer$1 = null;
  this.x7$1$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$4 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  var this$2 = this.x7$1$1;
  var jsx$2 = $as_sc_Seq(this$2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1));
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2$$anonfun$$nestedInanonfun$emit$2$1().init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2(this);
  var this$3 = $m_sc_Seq$();
  $as_sc_IterableLike(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$2) {
    return (function(s$2) {
      var s = $as_Lamf_plugins_domain_shapes_models_AnyShape(s$2);
      $m_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$().apply__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext__Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter(s, $this.$$outer$1.ordering$1, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), $this.$$outer$1.amf$plugins$document$webapi$parser$spec$declaration$emitters$raml$Raml08TypeEmitter$$spec$f).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$2)
    })
  })(this, b$1)));
  var jsx$3 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$3.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$4.$$plus$eq__O__scm_ArrayBuffer(node)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter__Lamf_plugins_domain_shapes_models_UnionShape = (function($$outer, x7$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.x7$1$1 = x7$1;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2.prototype.position__Lamf_core_parser_Position = (function() {
  var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$1 = this.x7$1$1;
  var annotations = this$1.annotations$2;
  return this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.Raml08TypeEmitter$$anon$2", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$.prototype.apply__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext__Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter = (function(shape, ordering, references, spec) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(shape, ordering, $m_s_None$(), $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), spec)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.Raml08TypePartEmitter$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$;
var $n_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$ = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1$$anon$1() {
  $c_O.call(this);
  this.x3$2$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1$$anon$1.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1$$anon$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1$$anon$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1$$anon$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1$$anon$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1$$anon$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1$$anon$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1__Lamf_core_emitter_PartEmitter = (function($$outer, x3$2) {
  this.x3$2$1 = x3$2;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1$$anon$1.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("type");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  this.x3$2$1.emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
  var this$3 = v.builder$1;
  var array = [key];
  if ((this$3.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$3.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$3, newSize);
  var len$1 = this$3.size0$6;
  var src = this$3.array$6;
  var dest = this$3.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$3.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$3.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1$$anon$1.prototype.position__Lamf_core_parser_Position = (function() {
  return this.x3$2$1.position__Lamf_core_parser_Position()
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1$$anon$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1$$anon$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.Raml10TypeEmitter$$anonfun$entries$1$$anon$1", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1$$anon$1: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1$$anon$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1$$anon$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter.call(this);
  this.shape$2 = null;
  this.ordering$2 = null;
  this.references$2 = null;
  this.spec$2 = null;
  this.typeName$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype.typeName__s_Option = (function() {
  return this.typeName$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype.emitters__sc_Seq = (function() {
  var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter.prototype.emitters__sc_Seq.call(this)));
  var shape = this.shape$2;
  var ordering = this.ordering$2;
  var references = this.references$2;
  var spec = this.spec$2;
  $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter__emitExamples__Lamf_plugins_domain_shapes_models_AnyShape__scm_ListBuffer__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__V(this, shape, results, ordering, references, spec);
  return results
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(shape, ordering, references, spec) {
  this.shape$2 = shape;
  this.ordering$2 = ordering;
  this.references$2 = references;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this, shape, ordering, references, spec);
  this.typeName$2 = new $c_s_Some().init___O("any");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlAnyShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeInstanceEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter.call(this);
  this.shape$2 = null;
  this.ordering$2 = null;
  this.references$2 = null;
  this.spec$2 = null;
  this.typeName$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeInstanceEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeInstanceEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeInstanceEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeInstanceEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeInstanceEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeInstanceEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeInstanceEmitter.prototype.typeName__s_Option = (function() {
  return this.typeName$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeInstanceEmitter.prototype.emitters__sc_Seq = (function() {
  var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter.prototype.emitters__sc_Seq.call(this)));
  var shape = this.shape$2;
  var ordering = this.ordering$2;
  var references = this.references$2;
  var spec = this.spec$2;
  $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter__emitExamples__Lamf_plugins_domain_shapes_models_AnyShape__scm_ListBuffer__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__V(this, shape, results, ordering, references, spec);
  if ((!this.typeEmitted$1)) {
    var entry = new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", "any", $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$());
    var jsx$1 = $m_sc_Seq$();
    var array = [entry];
    results.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer($as_sc_TraversableOnce(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))))
  };
  return results
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeInstanceEmitter.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(shape, ordering, references, spec) {
  this.shape$2 = shape;
  this.ordering$2 = ordering;
  this.references$2 = references;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this, shape, ordering, references, spec);
  this.typeName$2 = new $c_s_Some().init___O("any");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeInstanceEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeInstanceEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlAnyShapeInstanceEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeInstanceEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeInstanceEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeInstanceEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.emitter$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  if (($m_s_Option$().apply__O__s_Option(this.shape$1).isDefined__Z() && this.shape$1.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_SynthesizedField.getClassOf()))) {
    $m_Lamf_core_emitter_BaseEmitters_package$().raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(b, "", $m_Lorg_yaml_model_YType$().Null$1)
  } else {
    var x1 = this.emitter$1;
    if ((x1 instanceof $c_s_util_Left)) {
      var x2 = $as_s_util_Left(x1);
      var p = $as_Lamf_core_emitter_PartEmitter(x2.value$2);
      p.emit__Lorg_yaml_model_YDocument$PartBuilder__V(b)
    } else if ((x1 instanceof $c_s_util_Right)) {
      var x3 = $as_s_util_Right(x1);
      var entries = $as_sc_Seq(x3.value$2);
      var jsx$1 = b.builder$1;
      var sourceName = b.sourceName$2;
      var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
      $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(entries), b$1);
      jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(shape, ordering, annotations, ignored, references, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  var x1 = this.emitters__sc_Seq();
  matchEnd5: {
    var jsx$1;
    $m_sc_Seq$();
    var o8 = new $c_s_Some().init___O(x1);
    if (((o8.value$2 !== null) && ($as_sc_SeqLike(o8.value$2).lengthCompare__I__I(1) === 0))) {
      var p = $as_Lamf_core_emitter_Emitter($as_sc_SeqLike(o8.value$2).apply__I__O(0));
      if ($is_Lamf_core_emitter_PartEmitter(p)) {
        var x3 = $as_Lamf_core_emitter_PartEmitter(p);
        $m_s_package$();
        var jsx$1 = new $c_s_util_Left().init___O(x3);
        break matchEnd5
      }
    };
    if (x1.forall__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$3$2) {
        var x$3 = $as_Lamf_core_emitter_Emitter(x$3$2);
        return $is_Lamf_core_emitter_EntryEmitter(x$3)
      })
    })(this)))) {
      $m_s_package$();
      var jsx$2 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter(this);
      var this$3 = $m_sc_Seq$();
      var value = x1.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$2, this$3.ReusableCBFInstance$2);
      var jsx$1 = new $c_s_util_Right().init___O(value);
      break matchEnd5
    };
    var this$5 = spec.eh__Lamf_core_errorhandling_ErrorHandler();
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
    var node = shape.id$1;
    var property = $m_s_None$();
    var message = ("IllegalTypeDeclarations found: " + x1);
    var lexical = shape.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var location = shape.location__s_Option();
    this$5.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
    $m_s_package$();
    var value$1 = $m_sci_Nil$();
    var jsx$1 = new $c_s_util_Right().init___O(value$1)
  };
  this.emitter$1 = jsx$1;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.emitters__sc_Seq().headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$2 = $as_Lamf_core_emitter_Emitter(arg1);
    var this$2 = new $c_s_Some().init___O(x$2.position__Lamf_core_parser_Position())
  };
  return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlTypePartEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlTypePartEmitter;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_AbstractSecurityRequirementEmitter() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_AbstractSecurityRequirementEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_AbstractSecurityRequirementEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_AbstractSecurityRequirementEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_AbstractSecurityRequirementEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_AbstractSecurityRequirementEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_AbstractSecurityRequirementEmitter.prototype;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_KeyedExampleEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.example$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_KeyedExampleEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_KeyedExampleEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_KeyedExampleEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_KeyedExampleEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_KeyedExampleEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_KeyedExampleEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_KeyedExampleEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter().init___Lamf_plugins_domain_shapes_models_Example__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.example$1, this.ordering$1, this.spec$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
  var this$4 = v.builder$1;
  var array = [key];
  if ((this$4.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$4.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$4, newSize);
  var len$1 = this$4.size0$6;
  var src = this$4.array$6;
  var dest = this$4.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$4.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$4.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_KeyedExampleEmitter.prototype.init___T__Lamf_plugins_domain_shapes_models_Example__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, example, ordering, spec) {
  this.key$1 = key;
  this.example$1 = example;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_KeyedExampleEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.example$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_KeyedExampleEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_KeyedExampleEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.KeyedExampleEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_KeyedExampleEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_KeyedExampleEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_KeyedExampleEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.examples$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  if (this.examples$1.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var str = this.key$1;
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var this$2 = $as_Lamf_core_model_domain_Linkable(this.examples$1.head__O());
    if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2).isDefined__Z()) {
      var this$3 = $as_Lamf_core_model_domain_Linkable(this.examples$1.head__O());
      var this$4 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$3);
      if ((!this$4.isEmpty__Z())) {
        var arg1 = this$4.get__O();
        var l = $as_Lamf_core_model_domain_DomainElement(arg1);
        var jsx$1 = this.spec$1.factory__Lamf_plugins_document_webapi_contexts_SpecEmitterFactory().tagToReferenceEmitter__F3();
        var this$5 = $as_Lamf_core_model_domain_Linkable(this.examples$1.head__O());
        $as_Lamf_core_emitter_PartEmitter(jsx$1.apply__O__O__O__O(l, $as_Lamf_core_model_StrField(this$5.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1, this.references$1)).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v)
      }
    } else {
      this.emit__Lorg_yaml_model_YDocument$PartBuilder__V(v)
    };
    var this$8 = v.builder$1;
    var array = [key];
    if ((this$8.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$8.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$8, newSize);
    var len$1 = this$8.size0$6;
    var src = this$8.array$6;
    var dest = this$8.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$8.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$2 = j;
      var index = i;
      xs.set(jsx$2, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$8.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter.prototype.init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, examples, ordering, references, spec) {
  this.key$1 = key;
  this.examples$1 = examples;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.examples$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var h = $as_Lamf_plugins_domain_shapes_models_Example(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = h.annotations$1;
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$() {
  $c_O.call(this);
  this.validStyles$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$.prototype.validateStyle__p1__Lamf_plugins_domain_webapi_models_Parameter__T__Lamf_plugins_document_webapi_contexts_WebApiContext__V = (function(param, style, ctx) {
  var this$1 = $as_Lamf_core_model_StrField(param.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
  var this$2 = this$1.option$1;
  var paramBinding = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  if ((!this.isStyleValid__p1__T__T__Z(paramBinding, style))) {
    var this$3 = ctx.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().InvalidParameterStyleBindingCombination$1;
    var node = param.id$1;
    var message = (((("'" + style) + "' style cannot be used with '") + paramBinding) + "' value of parameter property 'in'");
    var property = $m_s_None$();
    var lexical = $m_s_None$();
    var location = $m_s_None$();
    this$3.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$.prototype.isStyleValid__p1__T__T__Z = (function(paramBinding, style) {
  var this$1 = $m_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$().validStyles__sci_Map();
  var this$2 = this$1.iterator__sc_Iterator();
  var res = false;
  while (((!res) && this$2.hasNext__Z())) {
    var arg1 = this$2.next__O();
    var x0$1 = $as_T2(arg1);
    if ((x0$1 === null)) {
      throw new $c_s_MatchError().init___O(x0$1)
    };
    var key = $as_T(x0$1.$$und1__O());
    var value = $as_sci_List(x0$1.$$und2__O());
    res = ((key === style) && $f_sc_LinearSeqOptimized__contains__O__Z(value, paramBinding))
  };
  return res
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$.prototype.parseExplodeField__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Parameter__V = (function(map, result) {
  var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("explode");
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    var jsx$2 = result.fields$1;
    var jsx$1 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Explode$1;
    var this$2 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$BooleanYRead$();
    var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
    jsx$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(jsx$1, new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv), new $c_Lamf_core_parser_Annotations().init___()), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ExplicitField().init___()))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$4 = $as_Lamf_core_model_StrField(result.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Style$1)).option$1;
      if (this$4.isEmpty__Z()) {
        var defValue = $m_s_None$()
      } else {
        var arg1 = this$4.get__O();
        var x0$1 = $as_T(arg1);
        var defValue = new $c_s_Some().init___O((x0$1 === "form"))
      };
      if ((!defValue.isEmpty__Z())) {
        var arg1$1 = defValue.get__O();
        var x$7 = $uZ(arg1$1);
        var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Explode$1;
        $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(result, field, x$7))
      }
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$.prototype.validStyles__sci_Map = (function() {
  return ((!this.bitmap$0$1) ? this.validStyles$lzycompute__p1__sci_Map() : this.validStyles$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$.prototype.validStyles$lzycompute__p1__sci_Map = (function() {
  if ((!this.bitmap$0$1)) {
    $m_sci_List$();
    var array = ["path"];
    var i = (((-1) + $uI(array.length)) | 0);
    var result = $m_sci_Nil$();
    while ((i >= 0)) {
      var this$5 = result;
      var index = i;
      var x = array[index];
      result = new $c_sci_$colon$colon().init___O__sci_List(x, this$5);
      i = (((-1) + i) | 0)
    };
    var y = result;
    var jsx$6 = new $c_T2().init___O__O("matrix", y);
    $m_sci_List$();
    var array$1 = ["path"];
    var i$1 = (((-1) + $uI(array$1.length)) | 0);
    var result$1 = $m_sci_Nil$();
    while ((i$1 >= 0)) {
      var this$11 = result$1;
      var index$1 = i$1;
      var x$1 = array$1[index$1];
      result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$11);
      i$1 = (((-1) + i$1) | 0)
    };
    var y$1 = result$1;
    var jsx$5 = new $c_T2().init___O__O("label", y$1);
    $m_sci_List$();
    var array$2 = ["query", "cookie"];
    var i$2 = (((-1) + $uI(array$2.length)) | 0);
    var result$2 = $m_sci_Nil$();
    while ((i$2 >= 0)) {
      var this$17 = result$2;
      var index$2 = i$2;
      var x$2 = array$2[index$2];
      result$2 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$17);
      i$2 = (((-1) + i$2) | 0)
    };
    var y$2 = result$2;
    var jsx$4 = new $c_T2().init___O__O("form", y$2);
    $m_sci_List$();
    var array$3 = ["path", "header"];
    var i$3 = (((-1) + $uI(array$3.length)) | 0);
    var result$3 = $m_sci_Nil$();
    while ((i$3 >= 0)) {
      var this$23 = result$3;
      var index$3 = i$3;
      var x$3 = array$3[index$3];
      result$3 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$23);
      i$3 = (((-1) + i$3) | 0)
    };
    var y$3 = result$3;
    var jsx$3 = new $c_T2().init___O__O("simple", y$3);
    $m_sci_List$();
    var array$4 = ["query"];
    var i$4 = (((-1) + $uI(array$4.length)) | 0);
    var result$4 = $m_sci_Nil$();
    while ((i$4 >= 0)) {
      var this$29 = result$4;
      var index$4 = i$4;
      var x$4 = array$4[index$4];
      result$4 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$29);
      i$4 = (((-1) + i$4) | 0)
    };
    var y$4 = result$4;
    var jsx$2 = new $c_T2().init___O__O("spaceDelimited", y$4);
    $m_sci_List$();
    var array$5 = ["query"];
    var i$5 = (((-1) + $uI(array$5.length)) | 0);
    var result$5 = $m_sci_Nil$();
    while ((i$5 >= 0)) {
      var this$35 = result$5;
      var index$5 = i$5;
      var x$5 = array$5[index$5];
      result$5 = new $c_sci_$colon$colon().init___O__sci_List(x$5, this$35);
      i$5 = (((-1) + i$5) | 0)
    };
    var y$5 = result$5;
    var jsx$1 = new $c_T2().init___O__O("pipeDelimited", y$5);
    $m_sci_List$();
    var array$6 = ["query"];
    var i$6 = (((-1) + $uI(array$6.length)) | 0);
    var result$6 = $m_sci_Nil$();
    while ((i$6 >= 0)) {
      var this$41 = result$6;
      var index$6 = i$6;
      var x$6 = array$6[index$6];
      result$6 = new $c_sci_$colon$colon().init___O__sci_List(x$6, this$41);
      i$6 = (((-1) + i$6) | 0)
    };
    var y$6 = result$6;
    var array$7 = [jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, jsx$1, new $c_T2().init___O__O("deepObject", y$6)];
    var this$46 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
    var i$7 = 0;
    var len = $uI(array$7.length);
    while ((i$7 < len)) {
      var index$7 = i$7;
      var arg1 = array$7[index$7];
      this$46.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
      i$7 = ((1 + i$7) | 0)
    };
    this.validStyles$1 = $as_sci_Map(this$46.elems$1);
    this.bitmap$0$1 = true
  };
  return this.validStyles$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$.prototype.parseStyleField__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Parameter__Lamf_plugins_document_webapi_contexts_WebApiContext__V = (function(map, result, ctx) {
  var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("style");
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    var this$2 = entry.value$2.asScalar__s_Option();
    if (this$2.isEmpty__Z()) {
      var this$3 = $m_s_None$()
    } else {
      var arg1 = this$2.get__O();
      var x$8 = $as_Lorg_yaml_model_YScalar(arg1);
      var this$3 = new $c_s_Some().init___O(x$8.text$3)
    };
    var styleText = $as_T((this$3.isEmpty__Z() ? "" : this$3.get__O()));
    this.validateStyle__p1__Lamf_plugins_domain_webapi_models_Parameter__T__Lamf_plugins_document_webapi_contexts_WebApiContext__V(result, styleText, ctx);
    result.fields$1.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Style$1, new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(styleText, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2)), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ExplicitField().init___()))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var x1$2 = $as_Lamf_core_model_StrField(result.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1)).option$1;
      matchEnd18: {
        var jsx$1;
        if ((x1$2 instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(x1$2);
          var p3 = $as_T(x2$2.value$2);
          if ((p3 === "query")) {
            var jsx$1 = true;
            break matchEnd18
          }
        };
        if ((x1$2 instanceof $c_s_Some)) {
          var x4 = $as_s_Some(x1$2);
          var p5 = $as_T(x4.value$2);
          if ((p5 === "cookie")) {
            var jsx$1 = true;
            break matchEnd18
          }
        };
        var jsx$1 = false
      };
      if (jsx$1) {
        var defValue = new $c_s_Some().init___O("form")
      } else {
        matchEnd23: {
          var jsx$2;
          if ((x1$2 instanceof $c_s_Some)) {
            var x6 = $as_s_Some(x1$2);
            var p7 = $as_T(x6.value$2);
            if ((p7 === "path")) {
              var jsx$2 = true;
              break matchEnd23
            }
          };
          if ((x1$2 instanceof $c_s_Some)) {
            var x8 = $as_s_Some(x1$2);
            var p9 = $as_T(x8.value$2);
            if ((p9 === "header")) {
              var jsx$2 = true;
              break matchEnd23
            }
          };
          var jsx$2 = false
        };
        if (jsx$2) {
          var defValue = new $c_s_Some().init___O("simple")
        } else {
          var defValue = $m_s_None$()
        }
      };
      if ((!defValue.isEmpty__Z())) {
        var arg1$1 = defValue.get__O();
        var x$9 = $as_T(arg1$1);
        var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Style$1;
        $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(result, field, x$9))
      }
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$.prototype.validateSchemaOrContent__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Parameter__Lamf_plugins_document_webapi_contexts_WebApiContext__V = (function(map, param, ctx) {
  var _1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("schema");
  var _2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("content");
  if (((_1 instanceof $c_s_Some) && (_2 instanceof $c_s_Some))) {
    var jsx$1 = true
  } else {
    var x = $m_s_None$();
    if ((x === _1)) {
      var x$3 = $m_s_None$();
      var jsx$1 = (x$3 === _2)
    } else {
      var jsx$1 = false
    }
  };
  if (jsx$1) {
    var this$3 = ctx.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().ParameterMissingSchemaOrContent$1;
    var node = param.id$1;
    var annotations = param.annotations$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$3, specification, node, "Parameter must define a 'schema' or 'content' field, but not both", annotations)
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Oas3ParameterParser$", {
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser.prototype.parseEndpointMap__Lamf_plugins_domain_webapi_models_EndPoint__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_EndPoint = (function(endpoint, map) {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser.prototype.parseEndpointMap__Lamf_plugins_domain_webapi_models_EndPoint__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_EndPoint.call(this, endpoint, map);
  var elem = new $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters().init___sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq($m_sci_Nil$(), $m_sci_Nil$(), $m_sci_Nil$(), $m_sci_Nil$(), $m_sci_Nil$(), $m_sci_Nil$());
  var elem$1 = null;
  elem$1 = elem;
  var entries = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$9 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("parameters");
  if ((!this$9.isEmpty__Z())) {
    var arg1 = this$9.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    entries.$$plus$eq__O__scm_ListBuffer(entry);
    var jsx$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Parameters(elem$1);
    var this$10 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
    elem$1 = jsx$1.add__Lamf_plugins_document_webapi_parser_spec_domain_Parameters__Lamf_plugins_document_webapi_parser_spec_domain_Parameters(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser().init___sc_Seq__T__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($as_sc_Seq($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$10, conversion, iv)), endpoint.id$1, this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext()).parse__Z__Lamf_plugins_document_webapi_parser_spec_domain_Parameters(true))
  };
  var this$13 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("uriParameters").asOasExtension__T());
  if ((!this$13.isEmpty__Z())) {
    var arg1$1 = this$13.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    entries.$$plus$eq__O__scm_ListBuffer(entry$3);
    var this$14 = entry$3.value$2;
    var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$1 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
    var jsx$3 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser().init___Lorg_yaml_model_YMap__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$14, conversion$1, iv$1)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, endpoint$1) {
      return (function(p$2) {
        var p = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2);
        var parent = endpoint$1.id$1;
        $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(p, parent)
      })
    })(this, endpoint)), false, $m_Lamf_plugins_document_webapi_parser_spec_package$().toRaml__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext())).parse__sc_Seq();
    var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(x$2$2) {
        var x$2 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$2$2);
        var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
        return $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x$2, field, "path"))
      })
    })(this));
    var this$15 = $m_sc_Seq$();
    var uriParameters = $as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$15.ReusableCBFInstance$2));
    var jsx$4 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Parameters(elem$1);
    var x$2$3 = $m_sci_Nil$();
    var x$3 = $m_sci_Nil$();
    var x$4 = $m_sci_Nil$();
    var x$5 = $m_sci_Nil$();
    var x$6 = $m_sci_Nil$();
    elem$1 = jsx$4.add__Lamf_plugins_document_webapi_parser_spec_domain_Parameters__Lamf_plugins_document_webapi_parser_spec_domain_Parameters(new $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters().init___sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq(x$2$3, uriParameters, x$3, x$4, x$5, x$6))
  };
  var x1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Parameters(elem$1);
  matchEnd5: {
    if ((x1 !== null)) {
      var query = x1.query$1;
      var path = x1.path$1;
      var header = x1.header$1;
      var cookie = x1.cookie$1;
      if ((((query.nonEmpty__Z() || path.nonEmpty__Z()) || header.nonEmpty__Z()) || cookie.nonEmpty__Z())) {
        var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1;
        var this$21 = $m_sc_Seq$();
        var jsx$6 = $as_sc_TraversableLike(query.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(path, this$21.ReusableCBFInstance$2));
        var this$22 = $m_sc_Seq$();
        var jsx$5 = $as_sc_TraversableLike(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(header, this$22.ReusableCBFInstance$2));
        var this$23 = $m_sc_Seq$();
        var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(cookie, this$23.ReusableCBFInstance$2)), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations($as_Lorg_yaml_model_YMapEntry(entries.scala$collection$mutable$ListBuffer$$start$6.head__O()).value$2));
        var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations($as_Lorg_yaml_model_YPart(entries.scala$collection$mutable$ListBuffer$$start$6.head__O()));
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(endpoint, field$1, value, annotations);
        break matchEnd5
      }
    }
  };
  if ($as_Lamf_plugins_document_webapi_parser_spec_domain_Parameters(elem$1).body$1.nonEmpty__Z()) {
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Payloads$1;
    var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_Lamf_plugins_document_webapi_parser_spec_domain_Parameters(elem$1).body$1, new $c_Lamf_core_parser_Annotations().init___());
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations($as_Lorg_yaml_model_YPart(entries.scala$collection$mutable$ListBuffer$$start$6.head__O()));
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(endpoint, field$2, value$1, annotations$1)
  };
  var jsx$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var jsx$7 = new $c_Lamf_core_utils_package$AmfStrings().init___T("displayName").asOasExtension__T();
  var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Name$1;
  var iv$2 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
  jsx$8.key__T__F1__V(jsx$7, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$3, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(endpoint));
  var jsx$11 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var jsx$10 = new $c_Lamf_core_utils_package$AmfStrings().init___T("is").asOasExtension__T();
  var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Extends__Lamf_core_metamodel_Field();
  var iv$3 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
  var jsx$9 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$4, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(endpoint);
  var eta$0$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, endpoint$2) {
    return (function(name$2) {
      var name = $as_T(name$2);
      return $f_Lamf_plugins_domain_webapi_models_ExtensibleWebApiDomainElement__withTrait__T__Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait(endpoint$2, name)
    })
  })(this, endpoint));
  jsx$11.key__T__F1__V(jsx$10, jsx$9.using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, eta$0$1$1) {
    return (function(node$2) {
      var node = $as_Lorg_yaml_model_YNode(node$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$().parse__F1__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_core_model_domain_templates_ParametrizedDeclaration(eta$0$1$1, node, this$4$1.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext())
    })
  })(this, eta$0$1))).allowingSingleValue__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var this$31 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("type").asOasExtension__T();
  var this$32 = this$31.key__T__s_Option(keyword);
  if ((!this$32.isEmpty__Z())) {
    var arg1$2 = this$32.get__O();
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    new $c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser().init___Lorg_yaml_model_YNode__F1__F2__Lamf_plugins_document_webapi_contexts_WebApiContext(entry$4.value$2, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, endpoint$1$1) {
      return (function(name$2$1) {
        var name$1 = $as_T(name$2$1);
        return $f_Lamf_plugins_domain_webapi_models_ExtensibleWebApiDomainElement__withResourceType__T__Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType(endpoint$1$1, name$1)
      })
    })(this, endpoint)), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$2$2, entry$1) {
      return (function(key$2, scope$2) {
        var key = $as_T(key$2);
        var scope = $as_Lamf_core_parser_SearchScope$Scope(scope$2);
        return this$2$2.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().declarations$4.findResourceTypeOrError__Lorg_yaml_model_YPart__T__Lamf_core_parser_SearchScope$Scope__Lamf_plugins_domain_webapi_models_templates_ResourceType(entry$1.value$2, key, scope)
      })
    })(this, entry$4)), this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext()).parse__Lamf_core_model_domain_templates_ParametrizedDeclaration()
  };
  this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().factory__Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory().serversParser__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser(map, endpoint).parse__V();
  var this$35 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T("security").asOasExtension__T();
  var this$36 = this$35.key__T__s_Option(keyword$1);
  if ((!this$36.isEmpty__Z())) {
    var arg1$3 = this$36.get__O();
    var entry$5 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
    var idCounter = new $c_Lamf_core_utils_package$IdCounter().init___();
    var this$37 = entry$5.value$2;
    var conversion$2 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var iv$4 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
    var jsx$15 = $as_sc_TraversableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$37, conversion$2, iv$4));
    var jsx$14 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, endpoint$1$2, idCounter$1) {
      return (function(s$2) {
        var s = $as_Lorg_yaml_model_YNode(s$2);
        return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser().init___Lorg_yaml_model_YNode__F1__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(s, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, endpoint$1$3) {
          return (function(name$2$2) {
            var name$3 = $as_T(name$2$2);
            return endpoint$1$3.withSecurity__T__Lamf_plugins_domain_webapi_models_security_SecurityRequirement(name$3)
          })
        })($this$2, endpoint$1$2)), idCounter$1, $this$2.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext()).parse__s_Option()
      })
    })(this, endpoint, idCounter));
    var this$38 = $m_sc_Seq$();
    var jsx$13 = $as_sc_TraversableLike(jsx$15.map__F1__scg_CanBuildFrom__O(jsx$14, this$38.ReusableCBFInstance$2));
    var jsx$12 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser(this);
    var this$39 = $m_sc_Seq$();
    var securedBy = $as_sc_Seq(jsx$13.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$12, this$39.ReusableCBFInstance$2));
    if (securedBy.nonEmpty__Z()) {
      var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Security$1;
      var value$2 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(securedBy, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$5.value$2));
      var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$5);
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(endpoint, field$5, value$2, annotations$2)
    }
  };
  var this$41 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var entries$1 = this$41.regex__T__sc_Iterable("get|patch|put|post|delete|options|head|connect|trace");
  if (entries$1.nonEmpty__Z()) {
    var operations = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    entries$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$4, endpoint$1$4, operations$1) {
      return (function(entry$2) {
        var entry$6 = $as_Lorg_yaml_model_YMapEntry(entry$2);
        var operationParser = $this$4.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().factory__Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory().operationParser__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser(entry$6, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$5, endpoint$1$5) {
          return (function(method$2) {
            var method = $as_T(method$2);
            return endpoint$1$5.withOperation__T__Lamf_plugins_domain_webapi_models_Operation(method)
          })
        })($this$4, endpoint$1$4)));
        return operations$1.$$plus$eq__O__scm_ListBuffer(operationParser.parse__Lamf_plugins_domain_webapi_models_Operation())
      })
    })(this, endpoint, operations)));
    var field$6 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1;
    var value$3 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(operations, new $c_Lamf_core_parser_Annotations().init___());
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(endpoint, field$6, value$3)
  };
  return endpoint
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$.prototype.emitters__Lamf_plugins_domain_webapi_models_TemplatedLink__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext__scm_ListBuffer = (function(link, ordering, references, spec) {
  var fs = link.fields$1;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().OperationId$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("operationId", f, $m_s_None$())))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().OperationRef$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("operationRef", f$3, $m_s_None$())))
  };
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Description$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1$2 = this$5.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f$4, $m_s_None$())))
  };
  var this$7 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Mapping$1);
  if ((!this$7.isEmpty__Z())) {
    var arg1$3 = this$7.get__O();
    $as_Lamf_core_parser_FieldEntry(arg1$3);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext($as_sc_Seq(link.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Mapping$1)), ordering, references, spec))
  };
  var this$8 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Server$1);
  if ((!this$8.isEmpty__Z())) {
    var arg1$4 = this$8.get__O();
    $as_Lamf_core_parser_FieldEntry(arg1$4);
    var x$2$1 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter().init___Lamf_plugins_domain_webapi_models_Server__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext($as_Lamf_plugins_domain_webapi_models_Server(link.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Server$1)), ordering, spec);
    var this$9 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = $as_Lamf_plugins_domain_webapi_models_Server(link.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Server$1)).annotations$1;
    var x$3$2 = this$9.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position("server", x$2$1, x$4, x$3$2)))
  };
  var this$11 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().RequestBody$1);
  if ((!this$11.isEmpty__Z())) {
    var arg1$5 = this$11.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$5);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("requestBody", f$5, $m_s_None$())))
  };
  return result
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasLinkEmitter$", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$;
var $n_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$ = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasOperationParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser.call(this);
  this.entry$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasOperationParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasOperationParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasOperationParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasOperationParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasOperationParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasOperationParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasOperationParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(entry, producer, ctx) {
  this.entry$2 = entry;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.call(this, entry, producer, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasOperationParser.prototype.parse__Lamf_plugins_domain_webapi_models_Operation = (function() {
  var operation = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser.prototype.parse__Lamf_plugins_domain_webapi_models_Operation.call(this);
  var this$1 = this.entry$2.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Deprecated$1;
  var iv$1 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
  jsx$1.key__T__F1__V("deprecated", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(operation));
  var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$5 = this$4.key__T__s_Option("tags");
  if ((!this$5.isEmpty__Z())) {
    var arg1 = this$5.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$6 = entry.value$2;
    var conversion$1 = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
    var iv$2 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
    var tags = new $c_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser().init___Lorg_yaml_model_YSequence__T__Lamf_plugins_document_webapi_contexts_WebApiContext($as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion$1, iv$2)), operation.id$1, this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext()).parse__sc_Seq();
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Tags$1;
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(tags, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(operation, field$1, value, annotations)
  };
  var this$9 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("is").asOasExtension__T();
  var this$10 = this$9.key__T__s_Option(keyword);
  if ((!this$10.isEmpty__Z())) {
    var arg1$1 = this$10.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var this$11 = entry$3.value$2;
    var conversion$2 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var iv$3 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
    var jsx$3 = $as_sc_TraversableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$11, conversion$2, iv$3));
    var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, operation$2) {
      return (function(value$2) {
        var value$1 = $as_Lorg_yaml_model_YNode(value$2);
        return new $c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser().init___Lorg_yaml_model_YNode__F1__F2__Lamf_plugins_document_webapi_contexts_WebApiContext(value$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, operation$2$1) {
          return (function(name$2) {
            var name = $as_T(name$2);
            return $f_Lamf_plugins_domain_webapi_models_ExtensibleWebApiDomainElement__withTrait__T__Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait(operation$2$1, name)
          })
        })($this, operation$2)), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$2$1, value$3) {
          return (function(key$2, scope$2) {
            var key = $as_T(key$2);
            var scope = $as_Lamf_core_parser_SearchScope$Scope(scope$2);
            return this$2$1.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().declarations$4.findTraitOrError__Lorg_yaml_model_YPart__T__Lamf_core_parser_SearchScope$Scope__Lamf_plugins_domain_webapi_models_templates_Trait(value$3, key, scope)
          })
        })($this, value$1)), $this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext()).parse__Lamf_core_model_domain_templates_ParametrizedDeclaration()
      })
    })(this, operation));
    var this$12 = $m_sc_Seq$();
    var traits = $as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$12.ReusableCBFInstance$2));
    if (traits.nonEmpty__Z()) {
      var field$2 = $m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field();
      var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
      $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(operation, field$2, traits, annotations$1)
    }
  };
  var this$14 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$15 = this$14.key__T__s_Option("security");
  if ((!this$15.isEmpty__Z())) {
    var arg1$2 = this$15.get__O();
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Security$1;
    var value$4 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4.value$2));
    var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(operation, field$3, value$4, annotations$2);
    this.parseSecurity__p2__Lamf_plugins_domain_webapi_models_Operation__Lorg_yaml_model_YMapEntry__V(operation, entry$4)
  };
  var this$18 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T("security").asOasExtension__T();
  var this$19 = this$18.key__T__s_Option(keyword$1);
  if ((!this$19.isEmpty__Z())) {
    var arg1$3 = this$19.get__O();
    var entry$5 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
    this.parseSecurity__p2__Lamf_plugins_domain_webapi_models_Operation__Lorg_yaml_model_YMapEntry__V(operation, entry$5)
  };
  var this$21 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$22 = this$21.key__T__s_Option("responses");
  if ((!this$22.isEmpty__Z())) {
    var arg1$4 = this$22.get__O();
    var entry$6 = $as_Lorg_yaml_model_YMapEntry(arg1$4);
    var responses = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var this$23 = entry$6.value$2;
    var conversion$3 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$4 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
    $as_sc_IterableLike($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$23, conversion$3, iv$4)).entries$3.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2) {
      return (function(y$2) {
        var y = $as_Lorg_yaml_model_YMapEntry(y$2);
        var jsx$4 = $m_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$();
        var this$24 = y.key$2;
        var conversion$4 = $m_Lamf_core_parser_package$YScalarYRead$();
        var iv$5 = $this$2.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
        return (!jsx$4.isOasAnnotation__T__Z($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$24, conversion$4, iv$5)).text$3))
      })
    })(this)))).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$2, responses$1, operation$2$2) {
      return (function(entry$2$2) {
        var entry$2 = $as_Lorg_yaml_model_YMapEntry(entry$2$2);
        var node = entry$2.key$2;
        var iv$6 = this$2$2.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
        var this$26 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv$6);
        var node$1 = this$26.text__Lamf_core_model_domain_AmfScalar();
        var this$27 = entry$2.value$2;
        var conversion$5 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv$7 = this$2$2.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
        return responses$1.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser().init___Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$27, conversion$5, iv$7)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, node$2, operation$2$3, entry$1) {
          return (function(r$2) {
            var r = $as_Lamf_plugins_domain_webapi_models_Response(r$2);
            var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Name$1;
            var qual$1 = $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(r, field$4, node$2));
            var x$1 = operation$2$3.id$1;
            $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
            var this$30 = $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
            var this$28 = $as_Lamf_core_model_StrField(r.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Name$1));
            var this$29 = this$28.option$1;
            var statusCode = $as_T((this$29.isEmpty__Z() ? null : this$29.get__O()));
            var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1;
            $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$30, field$5, statusCode));
            r.annotations$2.$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations($m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$1));
            if (($this$3.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext() instanceof $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext)) {
              var this$31 = entry$1.key$2;
              var x = this$31.tag__Lorg_yaml_model_YTag().tagType$3;
              var x$3 = $m_Lorg_yaml_model_YType$().Str$1;
              var jsx$5 = (!(x === x$3))
            } else {
              var jsx$5 = false
            };
            if (jsx$5) {
              var this$32 = $this$3.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().eh$1;
              var specification = $m_Lamf_validations_ParserSideValidations$().InvalidStatusCode$1;
              var node$3 = r.id$1;
              var ast = entry$1.key$2;
              var prop = $m_s_None$();
              var l = ast.location$1;
              $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$32, specification, node$3, prop, "Status code for a Response object must be a string", l)
            }
          })
        })(this$2$2, node$1, operation$2$2, entry$2)), this$2$2.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext()).parse__Lamf_plugins_domain_webapi_models_Response())
      })
    })(this, responses, operation)));
    var field$6 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1;
    var value$5 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(responses, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$6.value$2));
    var annotations$3 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$6);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(operation, field$6, value$5, annotations$3)
  };
  return operation
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasOperationParser.prototype.parseSecurity__p2__Lamf_plugins_domain_webapi_models_Operation__Lorg_yaml_model_YMapEntry__V = (function(operation, entry) {
  var idCounter = new $c_Lamf_core_utils_package$IdCounter().init___();
  var this$1 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
  var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
  $as_sc_IterableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, operation$1, idCounter$1) {
    return (function(s$2) {
      var s = $as_Lorg_yaml_model_YNode(s$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser().init___Lorg_yaml_model_YNode__F1__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(s, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, operation$3) {
        return (function(name$2) {
          var name = $as_T(name$2);
          return operation$3.withSecurity__T__Lamf_plugins_domain_webapi_models_security_SecurityRequirement(name)
        })
      })($this, operation$1)), idCounter$1, $this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext()).parse__s_Option()
    })
  })(this, operation, idCounter)))
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$.prototype.defaultPayload__sc_Seq__s_Option = (function(payloads) {
  var this$2 = payloads.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(p$2) {
      var p = $as_Lamf_plugins_domain_webapi_models_Payload(p$2);
      var this$1 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1));
      return $f_Lamf_core_model_StrField__isNullOrEmpty__Z(this$1)
    })
  })(this)));
  var this$4 = (this$2.isEmpty__Z() ? payloads.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
    return (function(x$8$2) {
      var x$8 = $as_Lamf_plugins_domain_webapi_models_Payload(x$8$2);
      var this$3 = $as_Lamf_core_model_StrField(x$8.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1));
      return $f_Lamf_core_model_ValueField__is__O__Z(this$3, "application/json")
    })
  })(this))) : this$2);
  return (this$4.isEmpty__Z() ? payloads.headOption__s_Option() : this$4)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$.prototype.apply__sc_Seq__Z__Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads = (function(payloads, endpointPayloadEmitted) {
  var clean = $as_sc_Seq(payloads.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$5$2) {
      var x$5 = $as_Lamf_plugins_domain_webapi_models_Payload(x$5$2);
      return (!x$5.annotations$1.contains__jl_Class__Z($d_Lamf_plugins_document_webapi_annotations_EndPointBodyParameter.getClassOf()))
    })
  })(this))));
  var elem = clean.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$6$2) {
      var x$6 = $as_Lamf_plugins_domain_webapi_models_Payload(x$6$2);
      return x$6.annotations$1.contains__jl_Class__Z($d_Lamf_plugins_document_webapi_annotations_DefaultPayload.getClassOf())
    })
  })(this)));
  var $default = new $c_sr_ObjectRef().init___O(elem);
  if (endpointPayloadEmitted) {
    var jsx$1 = $as_s_Option($default.elem$1)
  } else {
    var this$3 = $as_s_Option($default.elem$1);
    var jsx$1 = (this$3.isEmpty__Z() ? $m_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$().defaultPayload__sc_Seq__s_Option(clean) : this$3)
  };
  $default.elem$1 = jsx$1;
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads().init___s_Option__sc_Seq($as_s_Option($default.elem$1), $as_sc_Seq(clean.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4, $default$1) {
    return (function(x$7$2) {
      var x$7 = $as_Lamf_plugins_domain_webapi_models_Payload(x$7$2);
      var this$5 = $as_s_Option($default$1.elem$1);
      var x$2 = (this$5.isEmpty__Z() ? null : this$5.get__O());
      return (!((x$7 === null) ? (x$2 === null) : x$7.equals__O__Z(x$2)))
    })
  })(this, $default)))))
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasPayloads$", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$;
var $n_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$ = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$.prototype.apply__T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter = (function(key, f, ordering, spec) {
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(f.value$1.value$1).values$1;
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$$anonfun$apply$1().init___();
  var this$1 = $m_sc_Seq$();
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(key, $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)), ordering, spec)
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasResponseExamplesEmitter$", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$;
var $n_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$ = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Parameters$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Parameters$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters$.prototype.classified__T__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_parser_spec_domain_Parameters = (function(path, params, payloads) {
  var elem = $m_sci_Nil$();
  var uriParams = new $c_sr_ObjectRef().init___O(elem);
  var elem$1 = $m_sci_Nil$();
  var pathParams = new $c_sr_ObjectRef().init___O(elem$1);
  $as_sc_IterableLike(params.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$1$2);
      var this$3 = $as_Lamf_core_model_StrField(x$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
      return $f_Lamf_core_model_ValueField__is__O__Z(this$3, "path")
    })
  })(this)))).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, path$1, pathParams$1, uriParams$1) {
    return (function(param$2) {
      var param = $as_Lamf_plugins_domain_webapi_models_Parameter(param$2);
      var this$4 = $as_Lamf_core_model_StrField(param.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
      var this$5 = this$4.option$1;
      var s = (("{" + $as_T((this$5.isEmpty__Z() ? null : this$5.get__O()))) + "}");
      if (($uI(path$1.indexOf(s)) !== (-1))) {
        var jsx$3 = $as_sc_Seq(pathParams$1.elem$1);
        var jsx$2 = $m_sc_Seq$();
        var array = [param];
        var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
        var this$11 = $m_sc_Seq$();
        pathParams$1.elem$1 = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$11.ReusableCBFInstance$2))
      } else {
        var jsx$6 = $as_sc_Seq(uriParams$1.elem$1);
        var jsx$5 = $m_sc_Seq$();
        var array$1 = [param];
        var jsx$4 = jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
        var this$14 = $m_sc_Seq$();
        uriParams$1.elem$1 = $as_sc_Seq(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$14.ReusableCBFInstance$2))
      }
    })
  })(this, path, pathParams, uriParams)));
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters().init___sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq($as_sc_Seq(params.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$2$2);
      var this$15 = $as_Lamf_core_model_StrField(x$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
      return $f_Lamf_core_model_ValueField__is__O__Z(this$15, "query")
    })
  })(this)))), $as_sc_Seq(pathParams.elem$1), $as_sc_Seq(params.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$3$2);
      var this$16 = $as_Lamf_core_model_StrField(x$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
      return $f_Lamf_core_model_ValueField__is__O__Z(this$16, "header")
    })
  })(this)))), $as_sc_Seq(params.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1) {
    return (function(x$4$2) {
      var x$4 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$4$2);
      var this$17 = $as_Lamf_core_model_StrField(x$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
      return $f_Lamf_core_model_ValueField__is__O__Z(this$17, "cookie")
    })
  })(this)))), $as_sc_Seq(uriParams.elem$1), payloads)
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Parameters$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Parameters$: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Parameters$", {
  Lamf_plugins_document_webapi_parser_spec_domain_Parameters$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Parameters$;
var $n_Lamf_plugins_document_webapi_parser_spec_domain_Parameters$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_domain_Parameters$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_domain_Parameters$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_domain_Parameters$ = new $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_domain_Parameters$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$.prototype.parse__F1__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_core_model_domain_templates_ParametrizedDeclaration = (function(producer, node, ctx) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser().init___Lorg_yaml_model_YNode__F1__F2__Lamf_plugins_document_webapi_contexts_WebApiContext(node, producer, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this, ctx$1, node$1) {
    return (function(key$2, scope$2) {
      var key = $as_T(key$2);
      var scope = $as_Lamf_core_parser_SearchScope$Scope(scope$2);
      return ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations().findTraitOrError__Lorg_yaml_model_YPart__T__Lamf_core_parser_SearchScope$Scope__Lamf_plugins_domain_webapi_models_templates_Trait(node$1, key, scope)
    })
  })(this, ctx, node)), ctx).parse__Lamf_core_model_domain_templates_ParametrizedDeclaration()
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.ParametrizedDeclarationParser$", {
  Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedSecuritySchemeEmitter() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedSecuritySchemeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedSecuritySchemeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedSecuritySchemeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedSecuritySchemeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedSecuritySchemeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedSecuritySchemeEmitter.prototype;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter$$anon$1() {
  $c_O.call(this);
  this.x4$1$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter$$anon$1.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter$$anon$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter$$anon$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter$$anon$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter$$anon$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter$$anon$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter$$anon$1.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("schema");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  this.x4$1$1.emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
  var this$3 = v.builder$1;
  var array = [key];
  if ((this$3.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$3.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$3, newSize);
  var len$1 = this$3.size0$6;
  var src = this$3.array$6;
  var dest = this$3.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$3.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$3.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter$$anon$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter__Lamf_core_emitter_PartEmitter = (function($$outer, x4$1) {
  this.x4$1$1 = x4$1;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter$$anon$1.prototype.position__Lamf_core_parser_Position = (function() {
  return this.x4$1$1.position__Lamf_core_parser_Position()
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter$$anon$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter$$anon$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml08ParameterEmitter$$anon$1", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter$$anon$1: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter$$anon$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter$$anon$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var emitters = this.$$outer$1.typeEmitters$1;
  if (emitters.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var this$1 = this.$$outer$1.payload$1;
    var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1));
    var this$3 = this$2.option$1;
    var str = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    matchEnd5: {
      $m_sc_Seq$();
      var o8 = new $c_s_Some().init___O(emitters);
      if (((o8.value$2 !== null) && ($as_sc_SeqLike(o8.value$2).lengthCompare__I__I(1) === 0))) {
        var pe = $as_Lamf_core_emitter_Emitter($as_sc_SeqLike(o8.value$2).apply__I__O(0));
        if ($is_Lamf_core_emitter_PartEmitter(pe)) {
          var x3 = $as_Lamf_core_emitter_PartEmitter(pe);
          x3.emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
          break matchEnd5
        }
      };
      if (emitters.forall__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x$8$2) {
          var x$8 = $as_Lamf_core_emitter_Emitter(x$8$2);
          return $is_Lamf_core_emitter_EntryEmitter(x$8)
        })
      })(this)))) {
        var jsx$4 = v.builder$1;
        var sourceName = v.sourceName$2;
        var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
        var jsx$3 = $m_Lamf_core_emitter_BaseEmitters_package$();
        var jsx$2 = this.$$outer$1.ordering$1;
        var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1$$anonfun$$nestedInanonfun$emit$14$1().init___Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1(this);
        var this$7 = $m_sc_Seq$();
        jsx$3.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$2.sorted__sc_Seq__sc_Seq($as_sc_Seq(emitters.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2))), b$1);
        jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
        break matchEnd5
      };
      var this$8 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$domain$Raml08PayloadEmitter$$spec$f;
      var this$11 = this$8.eh$1;
      var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
      var node = this.$$outer$1.payload$1.id$1;
      var property = $m_s_None$();
      var message = ("IllegalTypeDeclarations found: " + emitters);
      var this$9 = this.$$outer$1.payload$1;
      var lexical = this$9.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      var this$10 = this.$$outer$1.payload$1;
      var location = $f_Lamf_core_model_domain_AmfElement__location__s_Option(this$10);
      this$11.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
    };
    var this$14 = v.builder$1;
    var array = [key];
    if ((this$14.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$14.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$14, newSize);
    var len$1 = this$14.size0$6;
    var src = this$14.array$6;
    var dest = this$14.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$14.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$5 = j;
      var index = i;
      xs.set(jsx$5, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$14.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  } else {
    $m_Lorg_yaml_model_YNode$();
    var this$25 = this.$$outer$1.payload$1;
    var this$26 = $as_Lamf_core_model_StrField(this$25.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1));
    var this$27 = this$26.option$1;
    var str$1 = $as_T((this$27.isEmpty__Z() ? null : this$27.get__O()));
    var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
    var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    $m_Lamf_core_emitter_BaseEmitters_package$().raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(v$1, "", $m_Lorg_yaml_model_YType$().Null$1);
    var this$31 = v$1.builder$1;
    var array$1 = [key$1];
    if ((this$31.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$3 = $uI(array$1.length);
    var newSize$1 = ((this$31.size0$6 + len$3) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$31, newSize$1);
    var len$4 = this$31.size0$6;
    var src$1 = this$31.array$6;
    var dest$1 = this$31.array$6;
    $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
    var xs$1 = this$31.array$6;
    var len$5 = xs$1.u.length;
    var i$1 = 0;
    var j$1 = 0;
    var x$2 = $uI(array$1.length);
    var x$3 = ((x$2 < len$5) ? x$2 : len$5);
    var that$1 = xs$1.u.length;
    var end$1 = ((x$3 < that$1) ? x$3 : that$1);
    while ((i$1 < end$1)) {
      var jsx$6 = j$1;
      var index$1 = i$1;
      xs$1.set(jsx$6, array$1[index$1]);
      i$1 = ((1 + i$1) | 0);
      j$1 = ((1 + j$1) | 0)
    };
    this$31.size0$6 = newSize$1;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.$$outer$1.payload$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml08PayloadEmitter$$anon$1", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$2() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$2.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$2.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var map = $m_Lorg_yaml_model_YMap$().empty$1;
  var node = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1);
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer(node)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$2.prototype.position__Lamf_core_parser_Position = (function() {
  return $m_Lamf_core_parser_Position$ZERO$()
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml08PayloadEmitter$$anon$2", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$2: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter() {
  $c_O.call(this);
  this.ordering$1 = null;
  this.children$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter.prototype.init___Lamf_core_emitter_SpecOrdering__scm_ListBuffer__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(ordering, children, references, spec) {
  this.ordering$1 = ordering;
  this.children$1 = children;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var fs = this.endpoint__Lamf_plugins_domain_webapi_models_EndPoint().fields$1;
  this.endpoint__Lamf_plugins_domain_webapi_models_EndPoint();
  var k = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var x1 = this.endpoint__Lamf_plugins_domain_webapi_models_EndPoint().parent__s_Option();
  if ((x1 instanceof $c_s_Some)) {
    new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(this.endpoint__Lamf_plugins_domain_webapi_models_EndPoint().relativePath__T(), new $c_Lamf_core_parser_Annotations().init___()), $m_Lorg_yaml_model_YType$().Str$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(k)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$4 = $as_Lamf_core_parser_FieldEntry(fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1).get__O());
      new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType($as_Lamf_core_model_domain_AmfScalar(this$4.value$1.value$1), $m_Lorg_yaml_model_YType$().Str$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(k)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(this.emitters__Lamf_core_parser_Fields__scm_ListBuffer(fs)), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$7 = k.builder$1;
  var jsx$2 = $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$7, 0));
  var this$8 = v.builder$1;
  b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(jsx$2, $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$8, 0)))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter.prototype.emitters__Lamf_core_parser_Fields__scm_ListBuffer = (function(fs) {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Name$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("displayName", f, $m_s_None$(), this.spec$1)))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Description$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("description", f$3, $m_s_None$(), this.spec$1)))
  };
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Extends__Lamf_core_metamodel_Field());
  if ((!this$5.isEmpty__Z())) {
    var arg1$2 = this$5.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    var jsx$1 = this.ordering$1;
    var this$6 = this.spec$1;
    new $c_s_Some().init___O(result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lamf_core_errorhandling_ErrorHandler(f$4, jsx$1, false, this$6.eh$1).emitters__sc_Seq()))
  };
  var this$7 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1);
  if ((!this$7.isEmpty__Z())) {
    var arg1$3 = this$7.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    new $c_s_Some().init___O(result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(this.operations__p1__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq(f$5, this.ordering$1)))
  };
  var this$8 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Security$1);
  if ((!this$8.isEmpty__Z())) {
    var arg1$4 = this$8.get__O();
    var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("securedBy", f$6, this.ordering$1, this.spec$1)))
  };
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.endpoint__Lamf_plugins_domain_webapi_models_EndPoint(), this.ordering$1, this.spec$1).emitters__sc_Seq());
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(this.children$1);
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter.prototype.operations__p1__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq = (function(f, ordering) {
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(f.value$1.value$1).values$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ordering$1) {
    return (function(e$2) {
      var e = $as_Lamf_core_model_domain_AmfElement(e$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter($this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory().operationEmitter__F3().apply__O__O__O__O($as_Lamf_plugins_domain_webapi_models_Operation(e), ordering$1, $this.references$1))
    })
  })(this, ordering));
  var this$1 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.endpoint__Lamf_plugins_domain_webapi_models_EndPoint().annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter.prototype.$$plus$eq__Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter__V = (function(child) {
  this.children$1.$$plus$eq__O__scm_ListBuffer(child)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlEndPointEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlEndPointEmitter;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter() {
  $c_O.call(this);
  this.operation$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter.prototype.entries__Lamf_core_parser_Fields__sc_Seq = (function(fs) {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Name$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("displayName", f, $m_s_None$())))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Description$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("description", f$3, $m_s_None$(), this.spec$1)))
  };
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Deprecated$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1$2 = this$5.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("oasDeprecated").asRamlAnnotation__T(), f$4, $m_s_None$())))
  };
  var this$8 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Summary$1);
  if ((!this$8.isEmpty__Z())) {
    var arg1$3 = this$8.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("summary").asRamlAnnotation__T(), f$5, $m_s_None$())))
  };
  var this$11 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Tags$1);
  if ((!this$11.isEmpty__Z())) {
    var arg1$4 = this$11.get__O();
    var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(new $c_Lamf_core_utils_package$AmfStrings().init___T("tags").asRamlAnnotation__T(), $as_Lamf_core_model_domain_AmfArray(f$6.value$1.value$1).values$1, this.ordering$1, this.spec$1)))
  };
  var this$13 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Documentation$1);
  if ((!this$13.isEmpty__Z())) {
    var arg1$5 = this$13.get__O();
    var f$7 = $as_Lamf_core_parser_FieldEntry(arg1$5);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter().init___T__Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(new $c_Lamf_core_utils_package$AmfStrings().init___T("externalDocs").asRamlAnnotation__T(), $as_Lamf_plugins_domain_shapes_models_CreativeWork(f$7.value$1.value$1), this.ordering$1, this.spec$1)))
  };
  var this$15 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Schemes$1);
  if ((!this$15.isEmpty__Z())) {
    var arg1$6 = this$15.get__O();
    var f$8 = $as_Lamf_core_parser_FieldEntry(arg1$6);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType("protocols", f$8, this.ordering$1, false, $m_Lorg_yaml_model_YType$().Str$1)))
  };
  var this$17 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Accepts$1);
  if ((!this$17.isEmpty__Z())) {
    var arg1$7 = this$17.get__O();
    var f$9 = $as_Lamf_core_parser_FieldEntry(arg1$7);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType(new $c_Lamf_core_utils_package$AmfStrings().init___T("consumes").asRamlAnnotation__T(), f$9, this.ordering$1, false, $m_Lorg_yaml_model_YType$().Str$1)))
  };
  var this$20 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().ContentType$1);
  if ((!this$20.isEmpty__Z())) {
    var arg1$8 = this$20.get__O();
    var f$10 = $as_Lamf_core_parser_FieldEntry(arg1$8);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType(new $c_Lamf_core_utils_package$AmfStrings().init___T("produces").asRamlAnnotation__T(), f$10, this.ordering$1, false, $m_Lorg_yaml_model_YType$().Str$1)))
  };
  var this$23 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field());
  if ((!this$23.isEmpty__Z())) {
    var arg1$9 = this$23.get__O();
    var f$11 = $as_Lamf_core_parser_FieldEntry(arg1$9);
    var jsx$1 = this.ordering$1;
    var this$24 = this.spec$1;
    new $c_s_Some().init___O(result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lamf_core_errorhandling_ErrorHandler(f$11, jsx$1, false, this$24.eh$1).emitters__sc_Seq()))
  };
  var this$25 = $m_s_Option$().apply__O__s_Option(this.operation$1.request__Lamf_plugins_domain_webapi_models_Request());
  if ((!this$25.isEmpty__Z())) {
    var arg1$10 = this$25.get__O();
    var req = $as_Lamf_plugins_domain_webapi_models_Request(arg1$10);
    var fields = req.fields$2;
    var this$26 = fields.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryParameters$1);
    if ((!this$26.isEmpty__Z())) {
      var arg1$11 = this$26.get__O();
      var f$1 = $as_Lamf_core_parser_FieldEntry(arg1$11);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("queryParameters", f$1, this.ordering$1, this.references$1, this.spec$1)))
    };
    var this$27 = fields.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Headers$1);
    if ((!this$27.isEmpty__Z())) {
      var arg1$12 = this$27.get__O();
      var f$3$1 = $as_Lamf_core_parser_FieldEntry(arg1$12);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("headers", f$3$1, this.ordering$1, this.references$1, this.spec$1)))
    };
    var this$28 = fields.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Payloads$1);
    if ((!this$28.isEmpty__Z())) {
      var arg1$13 = this$28.get__O();
      var f$4$1 = $as_Lamf_core_parser_FieldEntry(arg1$13);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory().payloadsEmitter__F4().apply__O__O__O__O__O("body", f$4$1, this.ordering$1, this.references$1)))
    };
    var this$29 = fields.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().UriParameters$1);
    if ((!this$29.isEmpty__Z())) {
      var arg1$14 = this$29.get__O();
      var f$5$1 = $as_Lamf_core_parser_FieldEntry(arg1$14);
      new $c_s_Some().init___O(($as_Lamf_core_model_domain_AmfArray(f$5$1.value$1.value$1).values$1.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(f$2$2) {
          var f$2 = $as_Lamf_core_model_domain_AmfElement(f$2$2);
          return (!f$2.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_SynthesizedField.getClassOf()))
        })
      })(this))) ? result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.baseUriParameterKey__T(), f$5$1, this.ordering$1, this.references$1, this.spec$1)) : (void 0)))
    }
  };
  var this$30 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1);
  if ((!this$30.isEmpty__Z())) {
    var arg1$15 = this$30.get__O();
    var f$12 = $as_Lamf_core_parser_FieldEntry(arg1$15);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext("responses", f$12, this.ordering$1, this.references$1, false, this.spec$1)))
  };
  var this$31 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1);
  if ((!this$31.isEmpty__Z())) {
    var arg1$16 = this$31.get__O();
    var f$13 = $as_Lamf_core_parser_FieldEntry(arg1$16);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(new $c_Lamf_core_utils_package$AmfStrings().init___T("defaultResponse").asRamlAnnotation__T(), f$13, this.ordering$1, this.references$1, true, this.spec$1)))
  };
  var this$33 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Security$1);
  if ((!this$33.isEmpty__Z())) {
    var arg1$17 = this$33.get__O();
    var f$14 = $as_Lamf_core_parser_FieldEntry(arg1$17);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("securedBy", f$14, this.ordering$1, this.spec$1)))
  };
  var this$34 = this.operation$1.fields$1;
  var this$37 = this$34.fs$1;
  var this$35 = $m_Lamf_core_parser_FieldEntry$();
  var f$15 = $f_F2__tupled__F1(this$35);
  var this$36 = $m_sci_Iterable$();
  var bf = this$36.ReusableCBFInstance$2;
  var this$38 = $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$37, f$15, bf)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$15$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_parser_FieldEntry(x$1$2);
      var x = x$1.field$1;
      var x$2 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Callbacks$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    })
  })(this)));
  if ((!this$38.isEmpty__Z())) {
    var arg1$18 = this$38.get__O();
    var f$15$1 = $as_Lamf_core_parser_FieldEntry(arg1$18);
    var callbacks = f$15$1.arrayValues__sc_Seq();
    var annotations = f$15$1.value$1.annotations$1;
    var jsx$4 = new $c_Lamf_core_utils_package$AmfStrings().init___T("callbacks").asRamlAnnotation__T();
    var jsx$3 = this.ordering$1;
    var jsx$2 = this.references$1;
    var spec = this.spec$1;
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position(jsx$4, new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_core_parser_Annotations__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(callbacks, jsx$3, jsx$2, annotations, new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(spec.eh$1, spec.refEmitter$1, new $c_Lamf_core_emitter_ShapeRenderOptions().init___())), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()))
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var fs = this.operation$1.fields$1;
  var k = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var this$2 = $as_Lamf_core_parser_FieldEntry(fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Method$1).get__O());
  new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType($as_Lamf_core_model_domain_AmfScalar(this$2.value$1.value$1), $m_Lorg_yaml_model_YType$().Str$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(k);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(this.entries__Lamf_core_parser_Fields__sc_Seq(fs)), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$5 = k.builder$1;
  var jsx$2 = $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$5, 0));
  var this$6 = v.builder$1;
  b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(jsx$2, $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$6, 0)))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(operation, ordering, references, spec) {
  this.operation$1 = operation;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.operation$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlOperationEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlOperationEmitter;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterEmitter() {
  $c_O.call(this);
  this.parameter$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$2 = this.parameter$1;
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2).isDefined__Z()) {
    this.emitLink__p1__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
  } else {
    this.emitParameter__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Parameter__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(parameter, ordering, references, spec) {
  this.parameter$1 = parameter;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.parameter$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterEmitter.prototype.emitLink__p1__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.parameter$1;
  var fs = $as_Lamf_core_model_domain_AmfObject($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1).get__O()).fields__Lamf_core_parser_Fields();
  var k = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  this.emitParameterKey__Lamf_core_parser_Fields__Lorg_yaml_model_YDocument$PartBuilder__V(fs, k);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var this$2 = this.parameter$1;
  var this$3 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2);
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var l = $as_Lamf_core_model_domain_DomainElement(arg1);
    var jsx$1 = this.spec$1.factory__Lamf_plugins_document_webapi_contexts_SpecEmitterFactory().tagToReferenceEmitter__F3();
    var this$4 = this.parameter$1;
    $as_Lamf_core_emitter_PartEmitter(jsx$1.apply__O__O__O__O(l, $as_Lamf_core_model_StrField(this$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1, this.references$1)).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v)
  };
  var this$5 = k.builder$1;
  var jsx$2 = $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$5, 0));
  var this$6 = v.builder$1;
  b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(jsx$2, $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$6, 0)))
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser() {
  $c_O.call(this);
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(entry, adopted, ctx) {
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlParameterParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlParameterParser;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter() {
  $c_O.call(this);
  this.response$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Response__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(response, ordering, references, spec) {
  this.response$1 = response;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var fs = this.response$1.fields$2;
  var k = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var this$2 = $as_Lamf_core_parser_FieldEntry(fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1).get__O());
  new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType($as_Lamf_core_model_domain_AmfScalar(this$2.value$1.value$1), $m_Lorg_yaml_model_YType$().Str$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(k);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var this$4 = this.response$1;
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$4).isDefined__Z()) {
    this.spec$1.localReference__Lamf_core_model_domain_Linkable__Lamf_core_emitter_PartEmitter(this.response$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v)
  } else {
    var jsx$1 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(this.emitters__Lamf_core_parser_Fields__scm_ListBuffer(fs)), b$1);
    jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  };
  var this$6 = k.builder$1;
  var jsx$2 = $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$6, 0));
  var this$7 = v.builder$1;
  b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(jsx$2, $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$7, 0)))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter.prototype.emitters__Lamf_core_parser_Fields__scm_ListBuffer = (function(fs) {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Description$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("description", f, $m_s_None$(), this.spec$1)))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Headers$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("headers", f$3, this.ordering$1, this.references$1, this.spec$1)))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Payloads$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$2 = this$4.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory().payloadsEmitter__F4().apply__O__O__O__O__O("body", f$4, this.ordering$1, this.references$1)))
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.response$1.annotations$2;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlResponseEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlResponseEmitter;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$.prototype.parse__F1__Lamf_core_utils_package$IdCounter__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_domain_webapi_models_security_SecurityRequirement = (function(producer, idCounter, node, ctx) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser().init___Lorg_yaml_model_YNode__F1__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_WebApiContext(node, producer, idCounter, ctx).parse__Lamf_plugins_domain_webapi_models_security_SecurityRequirement()
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlSecurityRequirementParser$", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser$.prototype.parse__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_domain_webapi_models_security_Settings = (function(scheme, node, ctx) {
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var jsx$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, ctx));
  var this$1 = $as_Lamf_core_model_StrField(scheme.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1));
  var this$2 = this$1.option$1;
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser().init___Lorg_yaml_model_YMap__T__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_contexts_WebApiContext(jsx$1, $as_T((this$2.isEmpty__Z() ? null : this$2.get__O())), scheme, ctx).parse__Lamf_plugins_domain_webapi_models_security_Settings()
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlSecuritySettingsParser$", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Servers$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Servers$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Servers$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Servers$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Servers$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Servers$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Servers$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Servers$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Servers$.prototype.apply__Lamf_core_parser_FieldEntry__Lamf_plugins_document_webapi_parser_spec_domain_Servers = (function(f) {
  var x1 = f.arrayValues__sc_Seq().partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$10$2) {
      var x$10 = $as_Lamf_plugins_domain_webapi_models_Server(x$10$2);
      return x$10.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_SynthesizedField.getClassOf()).isDefined__Z()
    })
  })(this)));
  if ((x1 === null)) {
    throw new $c_s_MatchError().init___O(x1)
  };
  var $default = $as_sc_Seq(x1.$$und1__O());
  var servers = $as_sc_Seq(x1.$$und2__O());
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Servers().init___s_Option__sc_Seq($default.headOption__s_Option(), servers)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Servers$.prototype.isVariable__Lamf_plugins_domain_webapi_models_Parameter__Z = (function(parameter) {
  var nonLocalReturnKey1 = new $c_O().init___();
  try {
    var x1 = $as_Lamf_core_model_domain_Shape(parameter.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1));
    if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
      var x2 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(x1);
      var jsx$1 = $m_sc_Seq$();
      var array = [$m_Lamf_core_metamodel_domain_ShapeModel$().Name$1, $m_Lamf_core_metamodel_domain_ShapeModel$().Default$1, $m_Lamf_core_metamodel_domain_ShapeModel$().DefaultValueString$1, $m_Lamf_core_metamodel_domain_ShapeModel$().Values$1, $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1, $m_Lamf_core_metamodel_domain_ShapeModel$().Description$1];
      var variableFields = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
      var this$3 = x2.fields$2;
      var fn = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, variableFields$1, nonLocalReturnKey1$1) {
        return (function(x0$1$2) {
          var x0$1 = $as_T2(x0$1$2);
          if ((x0$1 !== null)) {
            var field = $as_Lamf_core_metamodel_Field(x0$1.$$und1__O());
            if ((!variableFields$1.contains__O__Z(field))) {
              throw new $c_sr_NonLocalReturnControl$mcZ$sp().init___O__Z(nonLocalReturnKey1$1, false)
            }
          } else {
            throw new $c_s_MatchError().init___O(x0$1)
          }
        })
      })(this, variableFields, nonLocalReturnKey1));
      this$3.fs$1.foreach__F1__V(fn);
      return true
    } else {
      return false
    }
  } catch (e) {
    if ((e instanceof $c_sr_NonLocalReturnControl)) {
      var ex = $as_sr_NonLocalReturnControl(e);
      if ((ex.key$2 === nonLocalReturnKey1)) {
        return ex.value$mcZ$sp__Z()
      } else {
        throw ex
      }
    } else {
      throw e
    }
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Servers$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Servers$: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Servers$", {
  Lamf_plugins_document_webapi_parser_spec_domain_Servers$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Servers$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Servers$;
var $n_Lamf_plugins_document_webapi_parser_spec_domain_Servers$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_domain_Servers$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_domain_Servers$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_domain_Servers$ = new $c_Lamf_plugins_document_webapi_parser_spec_domain_Servers$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_domain_Servers$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter$.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter$.prototype.apply__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext__Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter = (function(endpoint, ordering, references, spec) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters__Lamf_plugins_domain_webapi_models_EndPoint__s_Option__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.$$outer$1, endpoint, $m_s_None$(), ordering, references, spec)
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter$: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.AccessibleOasDocumentEmitters$EndPointEmitter$", {
  Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter$;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$.prototype.emitters__Lamf_plugins_domain_webapi_models_Request__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext__scm_ListBuffer = (function(request, ordering, references, spec) {
  var fs = request.fields$2;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Description$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f, $m_s_None$())))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Required$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("required", f$3, $m_s_None$())))
  };
  var this$5 = request.fields$2;
  var this$8 = this$5.fs$1;
  var this$6 = $m_Lamf_core_parser_FieldEntry$();
  var f$1 = $f_F2__tupled__F1(this$6);
  var this$7 = $m_sci_Iterable$();
  var bf = this$7.ReusableCBFInstance$2;
  var this$9 = $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$8, f$1, bf)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x$13$2) {
      var x$13 = $as_Lamf_core_parser_FieldEntry(x$13$2);
      var x = x$13.field$1;
      var x$2 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Payloads$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    })
  })(this)));
  if ((!this$9.isEmpty__Z())) {
    var arg1$2 = this$9.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    var payloads = f$4.arrayValues__sc_Seq();
    var annotations = f$4.value$1.annotations$1;
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position("content", new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_core_parser_Annotations__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(payloads, ordering, references, annotations, spec), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()))
  };
  return result
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.Oas3RequestBodyEmitter$", {
  Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$;
var $n_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$ = new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter.call(this);
  this.module$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleEmitter.prototype.emitModule__Lorg_yaml_model_YDocument = (function() {
  var ordering = $m_Lamf_core_emitter_SpecOrdering$().ordering__Lamf_core_remote_Vendor__Lamf_core_parser_Annotations__Lamf_core_emitter_SpecOrdering($m_Lamf_core_remote_Oas$(), this.module$2.annotations$1);
  var jsx$1 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_SpecOrdering(this, this.module$2, ordering)];
  var references = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  var this$3 = this.module$2;
  var jsx$2 = $as_sc_Seq(this$3.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_ModuleModel$().Declares$1));
  var this$4 = this.module$2;
  var declares = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(jsx$2, ordering, $as_sc_Seq(this$4.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_ModuleModel$().References$1)), this.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext()).emitters$1;
  var this$5 = this.module$2.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1);
  if (this$5.isEmpty__Z()) {
    var usages = $m_s_None$()
  } else {
    var arg1 = this$5.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    var usages = new $c_s_Some().init___O(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("usage").asOasExtension__T(), f, $m_s_None$()))
  };
  var this$9 = $m_Lorg_yaml_model_YDocument$().apply__T__Lorg_yaml_model_YDocument$WithComment("");
  var b = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(this$9.org$yaml$model$YDocument$WithComment$$sourceName$f);
  var x = this$9.comment$1;
  var this$11 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$11)) {
    b.comment__T__V(this$9.comment$1)
  };
  var jsx$6 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  this.docVersion__Lorg_yaml_model_YDocument$EntryBuilder__V(b$1);
  var jsx$5 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var jsx$4 = usages.toList__sci_List();
  var this$14 = $m_sc_Seq$();
  var jsx$3 = $as_sc_TraversableLike(declares.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$14.ReusableCBFInstance$2));
  var this$15 = $m_sc_Seq$();
  jsx$5.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(ordering.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(references, this$15.ReusableCBFInstance$2))), b$1);
  jsx$6.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  return new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this$9.org$yaml$model$YDocument$WithComment$$sourceName$f), b.builder$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleEmitter.prototype.init___Lamf_core_model_document_Module__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(module, spec) {
  this.module$2 = module;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter.prototype.init___Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, spec);
  return this
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser$.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser$.prototype.apply__Lorg_yaml_model_YMapEntry__F1__Lamf_core_model_domain_extensions_CustomDomainProperty = (function(ast, adopt) {
  var this$1 = ast.value$2;
  var x1 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var this$2 = ast.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f;
    var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv));
    var x1$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("$ref");
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var reference = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var jsx$2 = this.$$outer$1;
      var this$4 = reference.value$2;
      var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$1 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f;
      var jsx$1 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion$1, iv$1)).text$3;
      var this$5 = reference.value$2;
      var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$2 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f;
      return new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser().init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser__Lorg_yaml_model_YPart__T__Lorg_yaml_model_YScalar__F1(jsx$2, ast, jsx$1, $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion$2, iv$2)), adopt).parse__Lamf_core_model_domain_extensions_CustomDomainProperty()
    } else {
      var jsx$4 = this.$$outer$1;
      var this$6 = ast.key$2;
      var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$3 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f;
      var jsx$3 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion$3, iv$3)).text$3;
      var this$7 = ast.value$2;
      var conversion$4 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv$4 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f;
      return new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser().init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser__Lorg_yaml_model_YPart__T__Lorg_yaml_model_YMap__F1(jsx$4, ast, jsx$3, $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$7, conversion$4, iv$4)), adopt).parse__Lamf_core_model_domain_extensions_CustomDomainProperty()
    }
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Seq$1;
    if ((x$3 === x1)) {
      $m_Lamf_core_parser_Annotations$();
      var annotations = new $c_Lamf_core_parser_Annotations().init___();
      var qual$1 = new $c_Lamf_core_model_domain_extensions_CustomDomainProperty().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
      var this$11 = ast.key$2;
      var conversion$5 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$5 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f;
      var x$1 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$11, conversion$5, iv$5)).text$3;
      $m_Lamf_core_parser_Annotations$();
      var x$2$2 = new $c_Lamf_core_parser_Annotations().init___();
      var customDomainProperty = $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, x$1, x$2$2));
      adopt.apply__O__O(customDomainProperty);
      var this$13 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidAnnotationType$1;
      var node = customDomainProperty.id$1;
      var ast$1 = ast.value$2;
      var prop = $m_s_None$();
      var l = ast$1.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$13, specification, node, prop, "Invalid value node type for annotation types parser, expected map or scalar reference", l);
      return customDomainProperty
    } else {
      var jsx$6 = this.$$outer$1;
      var this$14 = ast.key$2;
      var conversion$6 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$6 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f;
      var jsx$5 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$14, conversion$6, iv$6)).text$3;
      var this$15 = ast.value$2;
      var conversion$7 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$7 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f;
      return new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser().init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser__Lorg_yaml_model_YPart__T__Lorg_yaml_model_YScalar__F1(jsx$6, ast, jsx$5, $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$15, conversion$7, iv$7)), adopt).parse__Lamf_core_model_domain_extensions_CustomDomainProperty()
    }
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasSpecParser$AnnotationTypesParser$", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser$;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationEmitter() {
  $c_O.call(this);
  this.operation$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(operation, ordering, spec) {
  this.operation$1 = operation;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var fs = this.operation$1.fields$1;
  var k = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var this$2 = $as_Lamf_core_parser_FieldEntry(fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Method$1).get__O());
  new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType($as_Lamf_core_model_domain_AmfScalar(this$2.value$1.value$1), $m_Lorg_yaml_model_YType$().Str$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(k);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  this.operationPartEmitter__Lamf_core_emitter_PartEmitter().emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
  var this$4 = k.builder$1;
  var jsx$1 = $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$4, 0));
  var this$5 = v.builder$1;
  b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(jsx$1, $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$5, 0)))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.operation$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationPartEmitter() {
  $c_O.call(this);
  this.operation$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationPartEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationPartEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationPartEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationPartEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationPartEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationPartEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationPartEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(operation, ordering, spec) {
  this.operation$1 = operation;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationPartEmitter.prototype.emitOperationId__Lamf_core_parser_Fields__scm_ListBuffer__V = (function(fs, result) {
  var x1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Name$1);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var f = $as_Lamf_core_parser_FieldEntry(x2.value$2);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("operationId", f, $m_s_None$()))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().OperationId$1);
      if ((!this$2.isEmpty__Z())) {
        var arg1 = this$2.get__O();
        var f$2 = $as_Lamf_core_parser_FieldEntry(arg1);
        result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("operationId", f$2, $m_s_None$()))
      }
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationPartEmitter.prototype.commonEmitters__sc_Seq = (function() {
  var fs = this.operation$1.fields$1;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  this.emitOperationId__Lamf_core_parser_Fields__scm_ListBuffer__V(fs, result);
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Description$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f, $m_s_None$())))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Summary$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("summary", f$3, $m_s_None$())))
  };
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Documentation$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1$2 = this$5.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter().init___T__Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("externalDocs", $as_Lamf_plugins_domain_shapes_models_CreativeWork(f$4.value$1.value$1), this.ordering$1, this.spec__Lamf_plugins_document_webapi_contexts_SpecEmitterContext())))
  };
  return result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.operation$1, this.ordering$1, this.spec__Lamf_plugins_document_webapi_contexts_SpecEmitterContext()).emitters__sc_Seq())
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationPartEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.operation$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter() {
  $c_O.call(this);
  this.securityScheme$1 = null;
  this.mappedType$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.securityScheme$1;
  var x1 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Name$1)).option$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var n = $as_T(x2.value$2);
    var name = n
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var this$4 = this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler();
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
    var node = this.securityScheme$1.id$1;
    var property = $m_s_None$();
    var message = ("Cannot declare security scheme without name " + this.securityScheme$1);
    var this$2 = this.securityScheme$1;
    var lexical = this$2.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var this$3 = this.securityScheme$1;
    var location = $f_Lamf_core_model_domain_AmfElement__location__s_Option(this$3);
    this$4.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
    var name = "default-"
  };
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(name);
  var this$6 = this.securityScheme$1;
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$6).isDefined__Z()) {
    var f = (function($this) {
      return (function(b$2$2) {
        var b$2 = $as_Lorg_yaml_model_YDocument$PartBuilder(b$2$2);
        $this.emitLink__p1__Lorg_yaml_model_YDocument$PartBuilder__V(b$2)
      })
    })(this);
    var vf_$_f$2 = f
  } else {
    var f$1 = (function(this$2$1) {
      return (function(b$3$2) {
        var b$3 = $as_Lorg_yaml_model_YDocument$PartBuilder(b$3$2);
        this$2$1.emitInline__Lorg_yaml_model_YDocument$PartBuilder__V(b$3)
      })
    })(this);
    var vf_$_f$2 = f$1
  };
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  vf_$_f$2(v);
  var this$9 = v.builder$1;
  var array = [key];
  if ((this$9.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$9.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$9, newSize);
  var len$1 = this$9.size0$6;
  var src = this$9.array$6;
  var dest = this$9.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$9.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x$1 = $uI(array.length);
  var x$2 = ((x$1 < len$2) ? x$1 : len$2);
  var that = xs.u.length;
  var end = ((x$2 < that) ? x$2 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$9.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter.prototype.emitLink__p1__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var this$1 = this.securityScheme$1;
  var this$2 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var l = $as_Lamf_core_model_domain_DomainElement(arg1);
    var this$3 = this.securityScheme$1;
    new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter().init___Lamf_core_model_domain_DomainElement__s_Option__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(l, $as_Lamf_core_model_StrField(this$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1, $m_sci_Nil$(), this.spec$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(securityScheme, mappedType, ordering, spec) {
  this.securityScheme$1 = securityScheme;
  this.mappedType$1 = mappedType;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter.prototype.emitInline__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$1 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter().init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.securityScheme$1, this.mappedType$1, this.ordering$1, this.spec$1).emitters__sc_Seq()), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.securityScheme$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasNamedSecuritySchemeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemesEmitters() {
  $c_O.call(this);
  this.securitySchemes$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemesEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemesEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemesEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemesEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemesEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemesEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemesEmitters.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(securitySchemes, ordering, spec) {
  this.securitySchemes$1 = securitySchemes;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemesEmitters.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var jsx$4 = this.securitySchemes$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(s$2) {
      var s = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(s$2);
      var jsx$3 = $m_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$();
      var jsx$2 = $this.spec$1.vendor__Lamf_core_remote_Vendor();
      var this$1 = $as_Lamf_core_model_StrField(s.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1));
      var this$2 = this$1.option$1;
      return new $c_T2().init___O__O(jsx$3.mapsTo__Lamf_core_remote_Vendor__T__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType(jsx$2, $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()))), s)
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  var securityTypeMap = $as_sc_Seq(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
  var x1 = securityTypeMap.partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var p2 = $as_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType(x0$1.$$und1__O());
        if ((p2 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType)) {
          return true
        }
      };
      return false
    })
  })(this)));
  if ((x1 === null)) {
    throw new $c_s_MatchError().init___O(x1)
  };
  var oasSecurityDefinitions = $as_sc_Seq(x1.$$und1__O());
  var extensionDefinitions = $as_sc_Seq(x1.$$und2__O());
  if (oasSecurityDefinitions.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var str = this.key__T();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$8 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    var jsx$7 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var jsx$6 = this.ordering$1;
    var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
      return (function(s$2$1) {
        var s$1 = $as_T2(s$2$1);
        return $this$1.emitter__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter($as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(s$1.$$und2__O()), $as_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType(s$1.$$und1__O()), $this$1.ordering$1)
      })
    })(this));
    var this$6 = $m_sc_Seq$();
    jsx$7.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$6.sorted__sc_Seq__sc_Seq($as_sc_Seq(oasSecurityDefinitions.map__F1__scg_CanBuildFrom__O(jsx$5, this$6.ReusableCBFInstance$2))), b$1);
    jsx$8.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
    var this$9 = v.builder$1;
    var array = [key];
    if ((this$9.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$9.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$9, newSize);
    var len$1 = this$9.size0$6;
    var src = this$9.array$6;
    var dest = this$9.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$9.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$9 = j;
      var index = i;
      xs.set(jsx$9, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$9.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  };
  if (extensionDefinitions.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var str$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T("securitySchemes").asOasExtension__T();
    var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
    var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$13 = v$1.builder$1;
    var sourceName$1 = v$1.sourceName$2;
    var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
    var jsx$12 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var jsx$11 = this.ordering$1;
    var jsx$10 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2) {
      return (function(s$2$2) {
        var s$3 = $as_T2(s$2$2);
        return $this$2.emitter__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter($as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(s$3.$$und2__O()), $as_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType(s$3.$$und1__O()), $this$2.ordering$1)
      })
    })(this));
    var this$23 = $m_sc_Seq$();
    jsx$12.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$11.sorted__sc_Seq__sc_Seq($as_sc_Seq(extensionDefinitions.map__F1__scg_CanBuildFrom__O(jsx$10, this$23.ReusableCBFInstance$2))), b$2);
    jsx$13.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1));
    var this$26 = v$1.builder$1;
    var array$1 = [key$1];
    if ((this$26.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$3 = $uI(array$1.length);
    var newSize$1 = ((this$26.size0$6 + len$3) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$26, newSize$1);
    var len$4 = this$26.size0$6;
    var src$1 = this$26.array$6;
    var dest$1 = this$26.array$6;
    $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
    var xs$1 = this$26.array$6;
    var len$5 = xs$1.u.length;
    var i$1 = 0;
    var j$1 = 0;
    var x$2 = $uI(array$1.length);
    var x$3 = ((x$2 < len$5) ? x$2 : len$5);
    var that$1 = xs$1.u.length;
    var end$1 = ((x$3 < that$1) ? x$3 : that$1);
    while ((i$1 < end$1)) {
      var jsx$14 = j$1;
      var index$1 = i$1;
      xs$1.set(jsx$14, array$1[index$1]);
      i$1 = ((1 + i$1) | 0);
      j$1 = ((1 + j$1) | 0)
    };
    this$26.size0$6 = newSize$1;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemesEmitters.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.securitySchemes$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var a = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = a.annotations$1;
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_ResponsesEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.f$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.orphanAnnotations$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_ResponsesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_ResponsesEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_ResponsesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_ResponsesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_ResponsesEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_ResponsesEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_ResponsesEmitter.prototype.init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(key, f, ordering, references, orphanAnnotations, spec) {
  this.key$1 = key;
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.orphanAnnotations$1 = orphanAnnotations;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_ResponsesEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var jsx$2 = this.responses__p1__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq(this.f$1, this.ordering$1);
  var jsx$1 = this.responsesElementsAnnotations__p1__sc_Seq();
  var this$1 = $m_sc_Seq$();
  var emitters = $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(emitters, b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$4 = j;
    var index = i;
    xs.set(jsx$4, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_ResponsesEmitter.prototype.responsesElementsAnnotations__p1__sc_Seq = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.orphanAnnotations$1, this.ordering$1, this.spec$1).emitters__sc_Seq()
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_ResponsesEmitter.prototype.responses__p1__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq = (function(f, ordering) {
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(f.value$1.value$1).values$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ordering$1) {
    return (function(e$2) {
      var e = $as_Lamf_core_model_domain_AmfElement(e$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter().init___Lamf_plugins_domain_webapi_models_Response__Lamf_core_emitter_SpecOrdering__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext($as_Lamf_plugins_domain_webapi_models_Response(e), ordering$1, $this.references$1, false, $this.spec$1)
    })
  })(this, ordering));
  var this$1 = $m_sc_Seq$();
  return ordering.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_ResponsesEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_ResponsesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_ResponsesEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.ResponsesEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_ResponsesEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_ResponsesEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_ResponsesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$.prototype.apply__Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser = (function(root, baseCtx) {
  var x$1 = $m_s_None$();
  var x$2 = baseCtx.eh$1;
  var x$3 = baseCtx.futureDeclarations$1;
  var x$4 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var x$5 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var parentDeclarations = new $c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().init___sci_Map__sci_Map__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations(x$4, x$5, x$1, x$2, x$3);
  var x$6 = baseCtx.rootContextDocument$1;
  var x$7 = baseCtx.refs$1;
  var x$9 = new $c_s_Some().init___O(baseCtx.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations());
  var x$11 = baseCtx.options$2;
  var x$12 = $m_s_None$();
  var x$13 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2;
  var exLikeCtx = new $c_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions(x$6, x$7, baseCtx, x$9, parentDeclarations, x$12, x$13, x$11);
  return new $c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser().init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext(root, exLikeCtx)
});
var $d_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.ExtensionLikeParser$", {
  Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$;
var $n_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$ = new $c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$() {
  $c_O.call(this);
  this.nodes$1 = null;
  this.commonNodes$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$ = this;
  $f_Lamf_plugins_document_webapi_parser_spec_raml_RamlSyntax__$$init$__V(this);
  var jsx$9 = this.commonNodes$1;
  var array = ["title", "description", "version", "baseUri", "baseUriParameters", "protocols", "mediaType", "documentation", "schemas", "traits", "resourceTypes", "securitySchemes", "securedBy"];
  if (($uI(array.length) === 0)) {
    var y = $m_sci_Set$EmptySet$()
  } else {
    var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      b.$$plus$eq__O__scm_SetBuilder(arg1);
      i = ((1 + i) | 0)
    };
    var y = b.elems$1
  };
  var jsx$8 = new $c_T2().init___O__O("webApi", y);
  var array$1 = ["type", "default", "schema", "example", "examples", "displayName", "description", "facets", "enum", "required", "repeat"];
  if (($uI(array$1.length) === 0)) {
    var y$1 = $m_sci_Set$EmptySet$()
  } else {
    var b$1 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$1 = 0;
    var len$1 = $uI(array$1.length);
    while ((i$1 < len$1)) {
      var index$1 = i$1;
      var arg1$1 = array$1[index$1];
      b$1.$$plus$eq__O__scm_SetBuilder(arg1$1);
      i$1 = ((1 + i$1) | 0)
    };
    var y$1 = b$1.elems$1
  };
  var jsx$7 = new $c_T2().init___O__O("shape", y$1);
  var array$2 = ["type", "default", "schema", "example", "examples", "displayName", "description", "facets", "enum", "repeat", "pattern", "minLength", "maxLength", "required"];
  if (($uI(array$2.length) === 0)) {
    var y$2 = $m_sci_Set$EmptySet$()
  } else {
    var b$2 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$2 = 0;
    var len$2 = $uI(array$2.length);
    while ((i$2 < len$2)) {
      var index$2 = i$2;
      var arg1$2 = array$2[index$2];
      b$2.$$plus$eq__O__scm_SetBuilder(arg1$2);
      i$2 = ((1 + i$2) | 0)
    };
    var y$2 = b$2.elems$1
  };
  var jsx$6 = new $c_T2().init___O__O("stringScalarShape", y$2);
  var array$3 = ["type", "default", "schema", "example", "examples", "displayName", "description", "facets", "enum", "required", "repeat", "format"];
  if (($uI(array$3.length) === 0)) {
    var y$3 = $m_sci_Set$EmptySet$()
  } else {
    var b$3 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$3 = 0;
    var len$3 = $uI(array$3.length);
    while ((i$3 < len$3)) {
      var index$3 = i$3;
      var arg1$3 = array$3[index$3];
      b$3.$$plus$eq__O__scm_SetBuilder(arg1$3);
      i$3 = ((1 + i$3) | 0)
    };
    var y$3 = b$3.elems$1
  };
  var jsx$5 = new $c_T2().init___O__O("dateScalarShape", y$3);
  var array$4 = ["type", "default", "schema", "example", "examples", "displayName", "description", "facets", "enum", "required", "repeat", "minimum", "maximum", "format", "multipleOf"];
  if (($uI(array$4.length) === 0)) {
    var y$4 = $m_sci_Set$EmptySet$()
  } else {
    var b$4 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$4 = 0;
    var len$4 = $uI(array$4.length);
    while ((i$4 < len$4)) {
      var index$4 = i$4;
      var arg1$4 = array$4[index$4];
      b$4.$$plus$eq__O__scm_SetBuilder(arg1$4);
      i$4 = ((1 + i$4) | 0)
    };
    var y$4 = b$4.elems$1
  };
  var jsx$4 = new $c_T2().init___O__O("numberScalarShape", y$4);
  var array$5 = ["displayName", "description", "get", "patch", "put", "post", "delete", "options", "head", "connect", "trace", "get?", "patch?", "put?", "post?", "delete?", "options?", "head?", "connect?", "trace?", "is", "type", "securedBy", "baseUriParameters", "uriParameters", "usage"];
  if (($uI(array$5.length) === 0)) {
    var y$5 = $m_sci_Set$EmptySet$()
  } else {
    var b$5 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$5 = 0;
    var len$5 = $uI(array$5.length);
    while ((i$5 < len$5)) {
      var index$5 = i$5;
      var arg1$5 = array$5[index$5];
      b$5.$$plus$eq__O__scm_SetBuilder(arg1$5);
      i$5 = ((1 + i$5) | 0)
    };
    var y$5 = b$5.elems$1
  };
  var jsx$3 = new $c_T2().init___O__O("endPoint", y$5);
  var array$6 = ["displayName", "description", "get", "patch", "put", "post", "delete", "options", "head", "connect", "trace", "get?", "patch?", "put?", "post?", "delete?", "options?", "head?", "connect?", "trace?", "is", "type", "securedBy", "baseUriParameters", "uriParameters", "usage", "is?", "securedBy?", "baseUriParameters?", "uriParameters?"];
  if (($uI(array$6.length) === 0)) {
    var y$6 = $m_sci_Set$EmptySet$()
  } else {
    var b$6 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$6 = 0;
    var len$6 = $uI(array$6.length);
    while ((i$6 < len$6)) {
      var index$6 = i$6;
      var arg1$6 = array$6[index$6];
      b$6.$$plus$eq__O__scm_SetBuilder(arg1$6);
      i$6 = ((1 + i$6) | 0)
    };
    var y$6 = b$6.elems$1
  };
  var jsx$2 = new $c_T2().init___O__O("resourceType", y$6);
  var array$7 = ["displayName", "description", "queryParameters", "headers", "responses", "body", "protocols", "is", "securedBy", "baseUriParameters", "usage"];
  if (($uI(array$7.length) === 0)) {
    var y$7 = $m_sci_Set$EmptySet$()
  } else {
    var b$7 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$7 = 0;
    var len$7 = $uI(array$7.length);
    while ((i$7 < len$7)) {
      var index$7 = i$7;
      var arg1$7 = array$7[index$7];
      b$7.$$plus$eq__O__scm_SetBuilder(arg1$7);
      i$7 = ((1 + i$7) | 0)
    };
    var y$7 = b$7.elems$1
  };
  var jsx$1 = new $c_T2().init___O__O("operation", y$7);
  var array$8 = ["displayName", "description", "queryParameters", "headers", "responses", "body", "protocols", "is", "securedBy", "baseUriParameters", "usage", "queryParameters?", "headers?", "responses?", "body?", "protocols?", "is?", "securedBy?", "baseUriParameters?"];
  if (($uI(array$8.length) === 0)) {
    var y$8 = $m_sci_Set$EmptySet$()
  } else {
    var b$8 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$8 = 0;
    var len$8 = $uI(array$8.length);
    while ((i$8 < len$8)) {
      var index$8 = i$8;
      var arg1$8 = array$8[index$8];
      b$8.$$plus$eq__O__scm_SetBuilder(arg1$8);
      i$8 = ((1 + i$8) | 0)
    };
    var y$8 = b$8.elems$1
  };
  var array$9 = [jsx$8, jsx$7, jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, jsx$1, new $c_T2().init___O__O("trait", y$8)];
  var this$49 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i$9 = 0;
  var len$9 = $uI(array$9.length);
  while ((i$9 < len$9)) {
    var index$9 = i$9;
    var arg1$9 = array$9[index$9];
    this$49.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1$9));
    i$9 = ((1 + i$9) | 0)
  };
  this.nodes$1 = jsx$9.$$plus$plus__sc_GenTraversableOnce__sci_Map(this$49.elems$1);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$.prototype.amf$plugins$document$webapi$parser$spec$raml$RamlSyntax$$undsetter$und$commonNodes$und$eq__sci_Map__V = (function(x$1) {
  this.commonNodes$1 = x$1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$.prototype.nodes__sci_Map = (function() {
  return this.nodes$1
});
var $d_Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.Raml08Syntax$", {
  Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlSyntax: 1,
  Lamf_plugins_document_webapi_parser_spec_SpecSyntax: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$;
var $n_Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$ = new $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$() {
  $c_O.call(this);
  this.shapeFacets$1 = null;
  this.nodes$1 = null;
  this.commonNodes$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$ = this;
  $f_Lamf_plugins_document_webapi_parser_spec_raml_RamlSyntax__$$init$__V(this);
  var array = ["type", "default", "schema", "example", "examples", "displayName", "description", "facets", "xml", "enum"];
  if (($uI(array.length) === 0)) {
    var jsx$1 = $m_sci_Set$EmptySet$()
  } else {
    var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      b.$$plus$eq__O__scm_SetBuilder(arg1);
      i = ((1 + i) | 0)
    };
    var jsx$1 = b.elems$1
  };
  this.shapeFacets$1 = $as_sci_Set(jsx$1);
  var jsx$31 = this.commonNodes$1;
  var array$1 = ["title", "description", "version", "baseUri", "baseUriParameters", "protocols", "mediaType", "documentation", "schemas", "types", "traits", "resourceTypes", "annotationTypes", "securitySchemes", "securedBy", "usage", "extends", "uses"];
  if (($uI(array$1.length) === 0)) {
    var y = $m_sci_Set$EmptySet$()
  } else {
    var b$1 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$1 = 0;
    var len$1 = $uI(array$1.length);
    while ((i$1 < len$1)) {
      var index$1 = i$1;
      var arg1$1 = array$1[index$1];
      b$1.$$plus$eq__O__scm_SetBuilder(arg1$1);
      i$1 = ((1 + i$1) | 0)
    };
    var y = b$1.elems$1
  };
  var jsx$30 = new $c_T2().init___O__O("webApi", y);
  var y$1 = this.shapeFacets$1;
  var jsx$29 = new $c_T2().init___O__O("shape", y$1);
  var y$2 = this.shapeFacets$1;
  var jsx$28 = new $c_T2().init___O__O("anyShape", y$2);
  var array$2 = ["type", "default", "schema", "example", "examples", "displayName", "description", "required"];
  if (($uI(array$2.length) === 0)) {
    var y$3 = $m_sci_Set$EmptySet$()
  } else {
    var b$2 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$2 = 0;
    var len$2 = $uI(array$2.length);
    while ((i$2 < len$2)) {
      var index$2 = i$2;
      var arg1$2 = array$2[index$2];
      b$2.$$plus$eq__O__scm_SetBuilder(arg1$2);
      i$2 = ((1 + i$2) | 0)
    };
    var y$3 = b$2.elems$1
  };
  var jsx$27 = new $c_T2().init___O__O("schemaShape", y$3);
  var y$4 = this.shapeFacets$1.$$plus__O__sc_Set("anyOf");
  var jsx$26 = new $c_T2().init___O__O("unionShape", y$4);
  var jsx$24 = this.shapeFacets$1;
  var array$3 = ["properties", "minProperties", "maxProperties", "discriminator", "discriminatorValue", "additionalProperties"];
  if (($uI(array$3.length) === 0)) {
    var jsx$23 = $m_sci_Set$EmptySet$()
  } else {
    var b$3 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$3 = 0;
    var len$3 = $uI(array$3.length);
    while ((i$3 < len$3)) {
      var index$3 = i$3;
      var arg1$3 = array$3[index$3];
      b$3.$$plus$eq__O__scm_SetBuilder(arg1$3);
      i$3 = ((1 + i$3) | 0)
    };
    var jsx$23 = b$3.elems$1
  };
  var y$5 = jsx$24.$$plus$plus__sc_GenTraversableOnce__sc_Set(jsx$23);
  var jsx$25 = new $c_T2().init___O__O("nodeShape", y$5);
  var jsx$21 = this.shapeFacets$1;
  var array$4 = ["uniqueItems", "items", "minItems", "maxItems"];
  if (($uI(array$4.length) === 0)) {
    var jsx$20 = $m_sci_Set$EmptySet$()
  } else {
    var b$4 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$4 = 0;
    var len$4 = $uI(array$4.length);
    while ((i$4 < len$4)) {
      var index$4 = i$4;
      var arg1$4 = array$4[index$4];
      b$4.$$plus$eq__O__scm_SetBuilder(arg1$4);
      i$4 = ((1 + i$4) | 0)
    };
    var jsx$20 = b$4.elems$1
  };
  var y$6 = jsx$21.$$plus$plus__sc_GenTraversableOnce__sc_Set(jsx$20);
  var jsx$22 = new $c_T2().init___O__O("arrayShape", y$6);
  var jsx$18 = this.shapeFacets$1;
  var array$5 = ["pattern", "minLength", "maxLength"];
  if (($uI(array$5.length) === 0)) {
    var jsx$17 = $m_sci_Set$EmptySet$()
  } else {
    var b$5 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$5 = 0;
    var len$5 = $uI(array$5.length);
    while ((i$5 < len$5)) {
      var index$5 = i$5;
      var arg1$5 = array$5[index$5];
      b$5.$$plus$eq__O__scm_SetBuilder(arg1$5);
      i$5 = ((1 + i$5) | 0)
    };
    var jsx$17 = b$5.elems$1
  };
  var y$7 = jsx$18.$$plus$plus__sc_GenTraversableOnce__sc_Set(jsx$17);
  var jsx$19 = new $c_T2().init___O__O("stringScalarShape", y$7);
  var jsx$15 = this.shapeFacets$1;
  var array$6 = ["minimum", "maximum", "format", "multipleOf"];
  if (($uI(array$6.length) === 0)) {
    var jsx$14 = $m_sci_Set$EmptySet$()
  } else {
    var b$6 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$6 = 0;
    var len$6 = $uI(array$6.length);
    while ((i$6 < len$6)) {
      var index$6 = i$6;
      var arg1$6 = array$6[index$6];
      b$6.$$plus$eq__O__scm_SetBuilder(arg1$6);
      i$6 = ((1 + i$6) | 0)
    };
    var jsx$14 = b$6.elems$1
  };
  var y$8 = jsx$15.$$plus$plus__sc_GenTraversableOnce__sc_Set(jsx$14);
  var jsx$16 = new $c_T2().init___O__O("numberScalarShape", y$8);
  var y$9 = this.shapeFacets$1.$$plus__O__sc_Set("format");
  var jsx$13 = new $c_T2().init___O__O("dateScalarShape", y$9);
  var jsx$11 = this.shapeFacets$1;
  var array$7 = ["fileTypes", "minLength", "maxLength"];
  if (($uI(array$7.length) === 0)) {
    var jsx$10 = $m_sci_Set$EmptySet$()
  } else {
    var b$7 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$7 = 0;
    var len$7 = $uI(array$7.length);
    while ((i$7 < len$7)) {
      var index$7 = i$7;
      var arg1$7 = array$7[index$7];
      b$7.$$plus$eq__O__scm_SetBuilder(arg1$7);
      i$7 = ((1 + i$7) | 0)
    };
    var jsx$10 = b$7.elems$1
  };
  var y$10 = jsx$11.$$plus$plus__sc_GenTraversableOnce__sc_Set(jsx$10);
  var jsx$12 = new $c_T2().init___O__O("fileShape", y$10);
  var array$8 = ["displayName", "description", "value", "strict"];
  if (($uI(array$8.length) === 0)) {
    var y$11 = $m_sci_Set$EmptySet$()
  } else {
    var b$8 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$8 = 0;
    var len$8 = $uI(array$8.length);
    while ((i$8 < len$8)) {
      var index$8 = i$8;
      var arg1$8 = array$8[index$8];
      b$8.$$plus$eq__O__scm_SetBuilder(arg1$8);
      i$8 = ((1 + i$8) | 0)
    };
    var y$11 = b$8.elems$1
  };
  var jsx$9 = new $c_T2().init___O__O("example", y$11);
  var array$9 = ["attribute", "wrapped", "name", "namespace", "prefix"];
  if (($uI(array$9.length) === 0)) {
    var y$12 = $m_sci_Set$EmptySet$()
  } else {
    var b$9 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$9 = 0;
    var len$9 = $uI(array$9.length);
    while ((i$9 < len$9)) {
      var index$9 = i$9;
      var arg1$9 = array$9[index$9];
      b$9.$$plus$eq__O__scm_SetBuilder(arg1$9);
      i$9 = ((1 + i$9) | 0)
    };
    var y$12 = b$9.elems$1
  };
  var jsx$8 = new $c_T2().init___O__O("xmlSerialization", y$12);
  var array$10 = ["displayName", "description", "get", "patch", "put", "post", "delete", "options", "head", "connect", "trace", "get?", "patch?", "put?", "post?", "delete?", "options?", "head?", "connect?", "trace?", "is", "type", "securedBy", "uriParameters", "usage"];
  if (($uI(array$10.length) === 0)) {
    var y$13 = $m_sci_Set$EmptySet$()
  } else {
    var b$10 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$10 = 0;
    var len$10 = $uI(array$10.length);
    while ((i$10 < len$10)) {
      var index$10 = i$10;
      var arg1$10 = array$10[index$10];
      b$10.$$plus$eq__O__scm_SetBuilder(arg1$10);
      i$10 = ((1 + i$10) | 0)
    };
    var y$13 = b$10.elems$1
  };
  var jsx$7 = new $c_T2().init___O__O("endPoint", y$13);
  var array$11 = ["displayName", "description", "get", "patch", "put", "post", "delete", "options", "head", "connect", "trace", "get?", "patch?", "put?", "post?", "delete?", "options?", "head?", "connect?", "trace?", "is", "type", "securedBy", "uriParameters", "usage"];
  if (($uI(array$11.length) === 0)) {
    var y$14 = $m_sci_Set$EmptySet$()
  } else {
    var b$11 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$11 = 0;
    var len$11 = $uI(array$11.length);
    while ((i$11 < len$11)) {
      var index$11 = i$11;
      var arg1$11 = array$11[index$11];
      b$11.$$plus$eq__O__scm_SetBuilder(arg1$11);
      i$11 = ((1 + i$11) | 0)
    };
    var y$14 = b$11.elems$1
  };
  var jsx$6 = new $c_T2().init___O__O("resourceType", y$14);
  var array$12 = ["displayName", "description", "queryParameters", "headers", "queryString", "responses", "body", "protocols", "is", "securedBy", "usage"];
  if (($uI(array$12.length) === 0)) {
    var y$15 = $m_sci_Set$EmptySet$()
  } else {
    var b$12 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$12 = 0;
    var len$12 = $uI(array$12.length);
    while ((i$12 < len$12)) {
      var index$12 = i$12;
      var arg1$12 = array$12[index$12];
      b$12.$$plus$eq__O__scm_SetBuilder(arg1$12);
      i$12 = ((1 + i$12) | 0)
    };
    var y$15 = b$12.elems$1
  };
  var jsx$5 = new $c_T2().init___O__O("operation", y$15);
  var array$13 = ["displayName", "description", "queryParameters", "headers", "queryString", "responses", "body", "protocols", "is", "securedBy", "usage"];
  if (($uI(array$13.length) === 0)) {
    var y$16 = $m_sci_Set$EmptySet$()
  } else {
    var b$13 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$13 = 0;
    var len$13 = $uI(array$13.length);
    while ((i$13 < len$13)) {
      var index$13 = i$13;
      var arg1$13 = array$13[index$13];
      b$13.$$plus$eq__O__scm_SetBuilder(arg1$13);
      i$13 = ((1 + i$13) | 0)
    };
    var y$16 = b$13.elems$1
  };
  var jsx$4 = new $c_T2().init___O__O("trait", y$16);
  var array$14 = ["displayName", "description", "allowedTargets"];
  if (($uI(array$14.length) === 0)) {
    var y$17 = $m_sci_Set$EmptySet$()
  } else {
    var b$14 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$14 = 0;
    var len$14 = $uI(array$14.length);
    while ((i$14 < len$14)) {
      var index$14 = i$14;
      var arg1$14 = array$14[index$14];
      b$14.$$plus$eq__O__scm_SetBuilder(arg1$14);
      i$14 = ((1 + i$14) | 0)
    };
    var y$17 = b$14.elems$1
  };
  var jsx$3 = new $c_T2().init___O__O("annotation", y$17);
  var array$15 = ["required"];
  if (($uI(array$15.length) === 0)) {
    var y$18 = $m_sci_Set$EmptySet$()
  } else {
    var b$15 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$15 = 0;
    var len$15 = $uI(array$15.length);
    while ((i$15 < len$15)) {
      var index$15 = i$15;
      var arg1$15 = array$15[index$15];
      b$15.$$plus$eq__O__scm_SetBuilder(arg1$15);
      i$15 = ((1 + i$15) | 0)
    };
    var y$18 = b$15.elems$1
  };
  var jsx$2 = new $c_T2().init___O__O("property", y$18);
  var array$16 = ["uses", "usage", "types", "schemas", "resourceTypes", "traits", "securitySchemes", "annotationTypes"];
  if (($uI(array$16.length) === 0)) {
    var y$19 = $m_sci_Set$EmptySet$()
  } else {
    var b$16 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i$16 = 0;
    var len$16 = $uI(array$16.length);
    while ((i$16 < len$16)) {
      var index$16 = i$16;
      var arg1$16 = array$16[index$16];
      b$16.$$plus$eq__O__scm_SetBuilder(arg1$16);
      i$16 = ((1 + i$16) | 0)
    };
    var y$19 = b$16.elems$1
  };
  var array$17 = [jsx$30, jsx$29, jsx$28, jsx$27, jsx$26, jsx$25, jsx$22, jsx$19, jsx$16, jsx$13, jsx$12, jsx$9, jsx$8, jsx$7, jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, new $c_T2().init___O__O("module", y$19)];
  var this$95 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i$17 = 0;
  var len$17 = $uI(array$17.length);
  while ((i$17 < len$17)) {
    var index$17 = i$17;
    var arg1$17 = array$17[index$17];
    this$95.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1$17));
    i$17 = ((1 + i$17) | 0)
  };
  this.nodes$1 = jsx$31.$$plus$plus__sc_GenTraversableOnce__sci_Map(this$95.elems$1);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$.prototype.amf$plugins$document$webapi$parser$spec$raml$RamlSyntax$$undsetter$und$commonNodes$und$eq__sci_Map__V = (function(x$1) {
  this.commonNodes$1 = x$1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$.prototype.nodes__sci_Map = (function() {
  return this.nodes$1
});
var $d_Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.Raml10Syntax$", {
  Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlSyntax: 1,
  Lamf_plugins_document_webapi_parser_spec_SpecSyntax: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$;
var $n_Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$ = new $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_DescribedByEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.securityScheme$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_DescribedByEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_DescribedByEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_DescribedByEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_DescribedByEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_DescribedByEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_DescribedByEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_DescribedByEmitter.prototype.entries__Lamf_core_parser_Fields__sc_Seq = (function(fs) {
  var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Headers$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("headers", f, this.ordering$1, this.references$1, this.spec$1))
  };
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().QueryParameters$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1$1 = this$2.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    if ($as_Lamf_core_model_domain_AmfArray(f$3.value$1.value$1).values$1.nonEmpty__Z()) {
      results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("queryParameters", f$3, this.ordering$1, this.references$1, this.spec$1))
    }
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Responses$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$2 = this$3.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext("responses", f$4, this.ordering$1, this.references$1, false, this.spec$1))
  };
  return results
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_DescribedByEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var fs = this.securityScheme$1.fields$1;
  var results = this.entries__Lamf_core_parser_Fields__sc_Seq(fs);
  if (results.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var str = this.key$1;
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$1 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(results), b$1);
    jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
    var this$5 = v.builder$1;
    var array = [key];
    if ((this$5.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$5.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$5, newSize);
    var len$1 = this$5.size0$6;
    var src = this$5.array$6;
    var dest = this$5.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$5.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$2 = j;
      var index = i;
      xs.set(jsx$2, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$5.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_DescribedByEmitter.prototype.init___T__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(key, securityScheme, ordering, references, spec) {
  this.key$1 = key;
  this.securityScheme$1 = securityScheme;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_DescribedByEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.securityScheme$1;
  var jsx$4 = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Headers$1));
  var this$2 = this.securityScheme$1;
  var jsx$3 = $as_sc_Seq(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().QueryParameters$1));
  var this$3 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$3.ReusableCBFInstance$2));
  var this$4 = this.securityScheme$1;
  var jsx$1 = $as_sc_Seq(this$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Responses$1));
  var this$5 = $m_sc_Seq$();
  var this$6 = $as_sc_TraversableLike(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2)).headOption__s_Option();
  if (this$6.isEmpty__Z()) {
    var this$8 = $m_s_None$()
  } else {
    var arg1 = this$6.get__O();
    var h = $as_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement(arg1);
    var this$7 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = h.annotations__Lamf_core_parser_Annotations();
    var this$8 = new $c_s_Some().init___O(this$7.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$8.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$8.get__O()))
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter() {
  $c_O.call(this);
  this.securityScheme$1 = null;
  this.references$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.securityScheme$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Name$1)).option$1;
  if (this$2.isEmpty__Z()) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot declare security scheme without name " + this.securityScheme$1)))
  };
  var name = $as_T(this$2.get__O());
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(name);
  var this$4 = this.securityScheme$1;
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$4).isDefined__Z()) {
    var f = (function(this$2$1) {
      return (function(b$2$2) {
        var b$2 = $as_Lorg_yaml_model_YDocument$PartBuilder(b$2$2);
        this$2$1.emitLink__p1__Lorg_yaml_model_YDocument$PartBuilder__V(b$2)
      })
    })(this);
    var vf_$_f$2 = f
  } else {
    var f$1 = (function(this$3$1) {
      return (function(b$3$2) {
        var b$3 = $as_Lorg_yaml_model_YDocument$PartBuilder(b$3$2);
        this$3$1.emitInline__p1__Lorg_yaml_model_YDocument$PartBuilder__V(b$3)
      })
    })(this);
    var vf_$_f$2 = f$1
  };
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  vf_$_f$2(v);
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter.prototype.emitLink__p1__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var this$1 = this.securityScheme$1;
  var this$2 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var l = $as_Lamf_core_model_domain_DomainElement(arg1);
    var this$3 = this.securityScheme$1;
    new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter().init___Lamf_core_model_domain_DomainElement__s_Option__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(l, $as_Lamf_core_model_StrField(this$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1, this.references$1, this.spec$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter.prototype.emitInline__p1__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$1 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq($as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter(this.securitySchemeEmitter__F3().apply__O__O__O__O(this.securityScheme$1, this.references$1, this.ordering$1)).emitters__sc_Seq()), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(securityScheme, references, ordering, spec) {
  this.securityScheme$1 = securityScheme;
  this.references$1 = references;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.securityScheme$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.emitters.RamlNamedSecuritySchemeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.emitters.RamlNamedSecuritySchemeEmitter;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_Async20EditingPipeline() {
  $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline.call(this);
  this.eh$3 = null;
  this.steps$3 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_Async20EditingPipeline.prototype = new $h_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline();
$c_Lamf_plugins_document_webapi_resolution_pipelines_Async20EditingPipeline.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_Async20EditingPipeline;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_Async20EditingPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_Async20EditingPipeline.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_Async20EditingPipeline.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_Async20EditingPipeline.prototype.profileName__Lamf_ProfileName = (function() {
  return $m_Lamf_Async20Profile$()
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Async20EditingPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler__Z = (function(eh, urlShortening) {
  this.eh$3 = eh;
  $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler__Z.call(this, eh, urlShortening);
  var jsx$1 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage().init___Z__Lamf_core_errorhandling_ErrorHandler(true, this.errorHandler$1), new $c_Lamf_plugins_domain_shapes_resolution_stages_ShapeNormalizationStage().init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler($m_Lamf_Async20Profile$(), true, this.errorHandler$1), new $c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncContentTypeResolutionStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncExamplePropagationResolutionStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_domain_webapi_resolution_stages_async_ServerVariableExampleResolutionStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_domain_webapi_resolution_stages_PathDescriptionNormalizationStage().init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler($m_Lamf_Async20Profile$(), true, this.errorHandler$1)];
  this.steps$3 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Async20EditingPipeline.prototype.references__Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage = (function() {
  return new $c_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage().init___Z__Lamf_core_errorhandling_ErrorHandler(true, this.errorHandler$1)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Async20EditingPipeline.prototype.steps__sc_Seq = (function() {
  return this.steps$3
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Async20EditingPipeline.prototype.parameterNormalizationStage__Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage = (function() {
  return new $c_Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1)
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_Async20EditingPipeline = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_Async20EditingPipeline: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.Async20EditingPipeline", {
  Lamf_plugins_document_webapi_resolution_pipelines_Async20EditingPipeline: 1,
  Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline: 1,
  Lamf_core_resolution_pipelines_ResolutionPipeline: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Async20EditingPipeline.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_Async20EditingPipeline;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_Async20ResolutionPipeline() {
  $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline.call(this);
  this.eh$3 = null;
  this.steps$3 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_Async20ResolutionPipeline.prototype = new $h_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline();
$c_Lamf_plugins_document_webapi_resolution_pipelines_Async20ResolutionPipeline.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_Async20ResolutionPipeline;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_Async20ResolutionPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_Async20ResolutionPipeline.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_Async20ResolutionPipeline.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_Async20ResolutionPipeline.prototype.profileName__Lamf_ProfileName = (function() {
  return $m_Lamf_Async20Profile$()
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Async20ResolutionPipeline.prototype.references__Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage = (function() {
  return new $c_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage().init___Z__Lamf_core_errorhandling_ErrorHandler(false, this.errorHandler$1)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Async20ResolutionPipeline.prototype.steps__sc_Seq = (function() {
  return this.steps$3
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Async20ResolutionPipeline.prototype.parameterNormalizationStage__Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage = (function() {
  return new $c_Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Async20ResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(eh) {
  this.eh$3 = eh;
  $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, eh);
  var jsx$1 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage().init___Z__Lamf_core_errorhandling_ErrorHandler(false, this.errorHandler$1), new $c_Lamf_core_resolution_stages_ExternalSourceRemovalStage().init___scm_Set__Lamf_core_errorhandling_ErrorHandler($as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), this.errorHandler$1), new $c_Lamf_plugins_domain_shapes_resolution_stages_ShapeNormalizationStage().init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler($m_Lamf_Async20Profile$(), false, this.errorHandler$1), new $c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncContentTypeResolutionStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncExamplePropagationResolutionStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_domain_webapi_resolution_stages_async_ServerVariableExampleResolutionStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_plugins_domain_webapi_resolution_stages_PathDescriptionNormalizationStage().init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler($m_Lamf_Async20Profile$(), false, this.errorHandler$1), new $c_Lamf_core_resolution_stages_CleanReferencesStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1), new $c_Lamf_core_resolution_stages_DeclarationsRemovalStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1)];
  this.steps$3 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_Async20ResolutionPipeline = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_Async20ResolutionPipeline: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.Async20ResolutionPipeline", {
  Lamf_plugins_document_webapi_resolution_pipelines_Async20ResolutionPipeline: 1,
  Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline: 1,
  Lamf_core_resolution_pipelines_ResolutionPipeline: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Async20ResolutionPipeline.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_Async20ResolutionPipeline;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_Async20ValidationResolutionPipeline() {
  $c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline.call(this);
  this.eh$3 = null;
  this.steps$3 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_Async20ValidationResolutionPipeline.prototype = new $h_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline();
$c_Lamf_plugins_document_webapi_resolution_pipelines_Async20ValidationResolutionPipeline.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_Async20ValidationResolutionPipeline;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_Async20ValidationResolutionPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_Async20ValidationResolutionPipeline.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_Async20ValidationResolutionPipeline.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_Async20ValidationResolutionPipeline.prototype.steps__sc_Seq = (function() {
  return this.steps$3
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Async20ValidationResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(eh) {
  this.eh$3 = eh;
  $c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline.prototype.init___Lamf_ProfileName__Lamf_core_errorhandling_ErrorHandler.call(this, $m_Lamf_Async20Profile$(), eh);
  var jsx$2 = this.baseSteps__sc_Seq();
  var jsx$1 = new $c_Lamf_plugins_domain_webapi_resolution_stages_async_ServerVariableExampleResolutionStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1);
  var this$1 = $m_sc_Seq$();
  this.steps$3 = $as_sc_Seq(jsx$2.$$colon$plus__O__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_Async20ValidationResolutionPipeline = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_Async20ValidationResolutionPipeline: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.Async20ValidationResolutionPipeline", {
  Lamf_plugins_document_webapi_resolution_pipelines_Async20ValidationResolutionPipeline: 1,
  Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline: 1,
  Lamf_core_resolution_pipelines_ResolutionPipeline: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Async20ValidationResolutionPipeline.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_Async20ValidationResolutionPipeline;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30EditingPipeline() {
  $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline.call(this);
  this.eh$3 = null;
  this.steps$3 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30EditingPipeline.prototype = new $h_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline();
$c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30EditingPipeline.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30EditingPipeline;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_Oas30EditingPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_Oas30EditingPipeline.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30EditingPipeline.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30EditingPipeline.prototype.profileName__Lamf_ProfileName = (function() {
  return $m_Lamf_Oas30Profile$()
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30EditingPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler__Z = (function(eh, urlShortening) {
  this.eh$3 = eh;
  $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler__Z.call(this, eh, urlShortening);
  var jsx$3 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_domain_shapes_resolution_stages_RequestParamsLinkStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1)];
  var jsx$2 = $as_sc_TraversableLike(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  var jsx$1 = this.baseSteps__sc_Seq();
  var this$3 = $m_sc_Seq$();
  this.steps$3 = $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
  return this
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30EditingPipeline.prototype.references__Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage = (function() {
  return new $c_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage().init___Z__Lamf_core_errorhandling_ErrorHandler(true, this.errorHandler$1)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30EditingPipeline.prototype.steps__sc_Seq = (function() {
  return this.steps$3
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30EditingPipeline.prototype.parameterNormalizationStage__Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage = (function() {
  return new $c_Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1)
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_Oas30EditingPipeline = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_Oas30EditingPipeline: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.Oas30EditingPipeline", {
  Lamf_plugins_document_webapi_resolution_pipelines_Oas30EditingPipeline: 1,
  Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline: 1,
  Lamf_core_resolution_pipelines_ResolutionPipeline: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30EditingPipeline.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_Oas30EditingPipeline;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ResolutionPipeline() {
  $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline.call(this);
  this.eh$3 = null;
  this.steps$3 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ResolutionPipeline.prototype = new $h_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline();
$c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ResolutionPipeline.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ResolutionPipeline;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ResolutionPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ResolutionPipeline.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ResolutionPipeline.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ResolutionPipeline.prototype.profileName__Lamf_ProfileName = (function() {
  return $m_Lamf_Oas30Profile$()
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ResolutionPipeline.prototype.references__Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage = (function() {
  return new $c_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage().init___Z__Lamf_core_errorhandling_ErrorHandler(false, this.errorHandler$1)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ResolutionPipeline.prototype.steps__sc_Seq = (function() {
  return this.steps$3
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ResolutionPipeline.prototype.parameterNormalizationStage__Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage = (function() {
  return new $c_Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(eh) {
  this.eh$3 = eh;
  $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, eh);
  var jsx$3 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_domain_shapes_resolution_stages_RequestParamsLinkStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1)];
  var jsx$2 = $as_sc_TraversableLike(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  var jsx$1 = this.baseSteps__sc_Seq();
  var this$3 = $m_sc_Seq$();
  this.steps$3 = $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ResolutionPipeline = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_Oas30ResolutionPipeline: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.Oas30ResolutionPipeline", {
  Lamf_plugins_document_webapi_resolution_pipelines_Oas30ResolutionPipeline: 1,
  Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline: 1,
  Lamf_core_resolution_pipelines_ResolutionPipeline: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ResolutionPipeline.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ResolutionPipeline;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ValidationResolutionPipeline() {
  $c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline.call(this);
  this.eh$3 = null;
  this.steps$3 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ValidationResolutionPipeline.prototype = new $h_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline();
$c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ValidationResolutionPipeline.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ValidationResolutionPipeline;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ValidationResolutionPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ValidationResolutionPipeline.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ValidationResolutionPipeline.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ValidationResolutionPipeline.prototype.steps__sc_Seq = (function() {
  return this.steps$3
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ValidationResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(eh) {
  this.eh$3 = eh;
  $c_Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline.prototype.init___Lamf_ProfileName__Lamf_core_errorhandling_ErrorHandler.call(this, $m_Lamf_Oas30Profile$(), eh);
  var x$1 = new $c_Lamf_plugins_domain_shapes_resolution_stages_RequestParamsLinkStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1);
  var jsx$1 = this.baseSteps__sc_Seq();
  var this$1 = $m_sc_Seq$();
  this.steps$3 = $as_sc_Seq(jsx$1.$$plus$colon__O__scg_CanBuildFrom__O(x$1, this$1.ReusableCBFInstance$2));
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ValidationResolutionPipeline = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_Oas30ValidationResolutionPipeline: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.Oas30ValidationResolutionPipeline", {
  Lamf_plugins_document_webapi_resolution_pipelines_Oas30ValidationResolutionPipeline: 1,
  Lamf_plugins_document_webapi_resolution_pipelines_ValidationResolutionPipeline: 1,
  Lamf_core_resolution_pipelines_ResolutionPipeline: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ValidationResolutionPipeline.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ValidationResolutionPipeline;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_OasEditingPipeline() {
  $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline.call(this);
  this.eh$3 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_OasEditingPipeline.prototype = new $h_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline();
$c_Lamf_plugins_document_webapi_resolution_pipelines_OasEditingPipeline.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_OasEditingPipeline;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_OasEditingPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_OasEditingPipeline.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_OasEditingPipeline.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_OasEditingPipeline.prototype.profileName__Lamf_ProfileName = (function() {
  return $m_Lamf_OasProfile$()
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_OasEditingPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler__Z = (function(eh, urlShortening) {
  this.eh$3 = eh;
  $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler__Z.call(this, eh, urlShortening);
  return this
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_OasEditingPipeline.prototype.references__Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage = (function() {
  return new $c_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage().init___Z__Lamf_core_errorhandling_ErrorHandler(true, this.errorHandler$1)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_OasEditingPipeline.prototype.parameterNormalizationStage__Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage = (function() {
  return new $c_Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1)
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_OasEditingPipeline = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_OasEditingPipeline: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.OasEditingPipeline", {
  Lamf_plugins_document_webapi_resolution_pipelines_OasEditingPipeline: 1,
  Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline: 1,
  Lamf_core_resolution_pipelines_ResolutionPipeline: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_OasEditingPipeline.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_OasEditingPipeline;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_OasResolutionPipeline() {
  $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline.call(this);
  this.eh$3 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_OasResolutionPipeline.prototype = new $h_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline();
$c_Lamf_plugins_document_webapi_resolution_pipelines_OasResolutionPipeline.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_OasResolutionPipeline;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_OasResolutionPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_OasResolutionPipeline.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_OasResolutionPipeline.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_OasResolutionPipeline.prototype.profileName__Lamf_ProfileName = (function() {
  return $m_Lamf_OasProfile$()
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_OasResolutionPipeline.prototype.references__Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage = (function() {
  return new $c_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage().init___Z__Lamf_core_errorhandling_ErrorHandler(false, this.errorHandler$1)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_OasResolutionPipeline.prototype.parameterNormalizationStage__Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage = (function() {
  return new $c_Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_OasResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(eh) {
  this.eh$3 = eh;
  $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, eh);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_OasResolutionPipeline = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_OasResolutionPipeline: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.OasResolutionPipeline", {
  Lamf_plugins_document_webapi_resolution_pipelines_OasResolutionPipeline: 1,
  Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline: 1,
  Lamf_core_resolution_pipelines_ResolutionPipeline: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_OasResolutionPipeline.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_OasResolutionPipeline;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08EditingPipeline() {
  $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline.call(this);
  this.eh$3 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08EditingPipeline.prototype = new $h_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline();
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08EditingPipeline.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08EditingPipeline;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_Raml08EditingPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_Raml08EditingPipeline.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08EditingPipeline.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08EditingPipeline.prototype.profileName__Lamf_ProfileName = (function() {
  return $m_Lamf_Raml08Profile$()
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08EditingPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler__Z = (function(eh, urlShortening) {
  this.eh$3 = eh;
  $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler__Z.call(this, eh, urlShortening);
  return this
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08EditingPipeline.prototype.references__Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage = (function() {
  return new $c_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage().init___Z__Lamf_core_errorhandling_ErrorHandler(true, this.errorHandler$1)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08EditingPipeline.prototype.parameterNormalizationStage__Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage = (function() {
  return new $c_Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1)
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_Raml08EditingPipeline = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_Raml08EditingPipeline: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.Raml08EditingPipeline", {
  Lamf_plugins_document_webapi_resolution_pipelines_Raml08EditingPipeline: 1,
  Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline: 1,
  Lamf_core_resolution_pipelines_ResolutionPipeline: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08EditingPipeline.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_Raml08EditingPipeline;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08ResolutionPipeline() {
  $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline.call(this);
  this.eh$3 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08ResolutionPipeline.prototype = new $h_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline();
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08ResolutionPipeline.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08ResolutionPipeline;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_Raml08ResolutionPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_Raml08ResolutionPipeline.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08ResolutionPipeline.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08ResolutionPipeline.prototype.profileName__Lamf_ProfileName = (function() {
  return $m_Lamf_Raml08Profile$()
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08ResolutionPipeline.prototype.references__Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage = (function() {
  return new $c_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage().init___Z__Lamf_core_errorhandling_ErrorHandler(false, this.errorHandler$1)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08ResolutionPipeline.prototype.parameterNormalizationStage__Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage = (function() {
  return new $c_Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08ResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(eh) {
  this.eh$3 = eh;
  $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, eh);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_Raml08ResolutionPipeline = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_Raml08ResolutionPipeline: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.Raml08ResolutionPipeline", {
  Lamf_plugins_document_webapi_resolution_pipelines_Raml08ResolutionPipeline: 1,
  Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline: 1,
  Lamf_core_resolution_pipelines_ResolutionPipeline: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08ResolutionPipeline.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_Raml08ResolutionPipeline;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10EditingPipeline() {
  $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline.call(this);
  this.eh$3 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10EditingPipeline.prototype = new $h_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline();
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10EditingPipeline.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10EditingPipeline;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_Raml10EditingPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_Raml10EditingPipeline.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10EditingPipeline.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10EditingPipeline.prototype.profileName__Lamf_ProfileName = (function() {
  return $m_Lamf_RamlProfile$()
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10EditingPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler__Z = (function(eh, urlShortening) {
  this.eh$3 = eh;
  $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler__Z.call(this, eh, urlShortening);
  return this
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10EditingPipeline.prototype.references__Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage = (function() {
  return new $c_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage().init___Z__Lamf_core_errorhandling_ErrorHandler(true, this.errorHandler$1)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10EditingPipeline.prototype.parameterNormalizationStage__Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage = (function() {
  return new $c_Lamf_plugins_domain_webapi_resolution_stages_Raml10ParametersNormalizationStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1)
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_Raml10EditingPipeline = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_Raml10EditingPipeline: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.Raml10EditingPipeline", {
  Lamf_plugins_document_webapi_resolution_pipelines_Raml10EditingPipeline: 1,
  Lamf_plugins_document_webapi_resolution_pipelines_AmfEditingPipeline: 1,
  Lamf_core_resolution_pipelines_ResolutionPipeline: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10EditingPipeline.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_Raml10EditingPipeline;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10ResolutionPipeline() {
  $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline.call(this);
  this.eh$3 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10ResolutionPipeline.prototype = new $h_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline();
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10ResolutionPipeline.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10ResolutionPipeline;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_Raml10ResolutionPipeline() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_Raml10ResolutionPipeline.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10ResolutionPipeline.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10ResolutionPipeline.prototype.profileName__Lamf_ProfileName = (function() {
  return $m_Lamf_RamlProfile$()
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10ResolutionPipeline.prototype.references__Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage = (function() {
  return new $c_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage().init___Z__Lamf_core_errorhandling_ErrorHandler(false, this.errorHandler$1)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10ResolutionPipeline.prototype.parameterNormalizationStage__Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage = (function() {
  return new $c_Lamf_plugins_domain_webapi_resolution_stages_Raml10ParametersNormalizationStage().init___Lamf_core_errorhandling_ErrorHandler(this.errorHandler$1)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10ResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(eh) {
  this.eh$3 = eh;
  $c_Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, eh);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_Raml10ResolutionPipeline = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_Raml10ResolutionPipeline: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.Raml10ResolutionPipeline", {
  Lamf_plugins_document_webapi_resolution_pipelines_Raml10ResolutionPipeline: 1,
  Lamf_plugins_document_webapi_resolution_pipelines_AmfResolutionPipeline: 1,
  Lamf_core_resolution_pipelines_ResolutionPipeline: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10ResolutionPipeline.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_Raml10ResolutionPipeline;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper() {
  $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_SecuritySettingsMapper.call(this);
  this.errorHandler$3 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper.prototype = new $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_SecuritySettingsMapper();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper.prototype.createFlowsFromRamlNullFlow__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__sc_Seq = (function(oauth2) {
  var jsx$2 = $as_sc_Seq(oauth2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().AuthorizationGrants$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(g$2) {
      var g = $as_Lamf_core_model_StrField(g$2);
      var this$1 = g.option$1;
      return $this.toOasGrant__p3__T__T($as_T((this$1.isEmpty__Z() ? null : this$1.get__O())))
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  var grants = $as_sc_Seq($as_sc_TraversableLike(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(g$3$2) {
      var g$3 = $as_T(g$3$2);
      var this$3 = this$2$1.VALID$undAUTHORIZATION$undGRANTS__sci_List();
      return $f_sc_LinearSeqOptimized__contains__O__Z(this$3, g$3)
    })
  })(this))));
  var flow = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($as_sc_Seq(oauth2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1)).head__O());
  var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, flow$1) {
    return (function(g$4$2) {
      var g$4 = $as_T(g$4$2);
      return new $c_T2().init___O__O(g$4, this$3$1.flowDeepCopy__p3__Lamf_plugins_domain_webapi_models_security_OAuth2Flow__Lamf_plugins_domain_webapi_models_security_OAuth2Flow(flow$1))
    })
  })(this, flow));
  var this$4 = $m_sc_Seq$();
  var jsx$4 = $as_sc_TraversableLike(grants.map__F1__scg_CanBuildFrom__O(jsx$5, this$4.ReusableCBFInstance$2));
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var grantName = $as_T(x0$1.$$und1__O());
        var flow$2 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow(x0$1.$$und2__O());
        var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Flow$1;
        return $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(flow$2, field, grantName))
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this));
  var this$5 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper.prototype.correctFlow__p3__Lamf_plugins_domain_webapi_models_security_OAuth2Flow__V = (function(flow) {
  var rc15 = false;
  var x2 = null;
  var jsx$1 = $m_s_Option$();
  var this$1 = $as_Lamf_core_model_StrField(flow.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Flow$1));
  var this$2 = this$1.option$1;
  var x1 = jsx$1.apply__O__s_Option($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())));
  matchEnd16: {
    if ((x1 instanceof $c_s_Some)) {
      rc15 = true;
      x2 = $as_s_Some(x1);
      var p3 = $as_T(x2.value$2);
      if ((p3 === "implicit")) {
        if ($as_Lamf_core_model_StrField(flow.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1)).option$1.isEmpty__Z()) {
          var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1;
          $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(flow, field, "http://"))
        };
        flow.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1);
        break matchEnd16
      }
    };
    if (rc15) {
      var p5 = $as_T(x2.value$2);
      if ((p5 === "authorizationCode")) {
        if ($as_Lamf_core_model_StrField(flow.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1)).option$1.isEmpty__Z()) {
          var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1;
          $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(flow, field$1, "http://"))
        };
        if ($as_Lamf_core_model_StrField(flow.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1)).option$1.isEmpty__Z()) {
          var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1;
          $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(flow, field$2, "http://"));
          break matchEnd16
        } else {
          break matchEnd16
        }
      }
    };
    if (rc15) {
      var p7 = $as_T(x2.value$2);
      if ((p7 === "password")) {
        if ($as_Lamf_core_model_StrField(flow.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1)).option$1.isEmpty__Z()) {
          var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1;
          $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(flow, field$3, "http://"))
        };
        flow.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1);
        break matchEnd16
      }
    };
    if (rc15) {
      var p9 = $as_T(x2.value$2);
      if ((p9 === "clientCredentials")) {
        if ($as_Lamf_core_model_StrField(flow.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1)).option$1.isEmpty__Z()) {
          var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1;
          $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(flow, field$4, "http://"))
        };
        flow.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1);
        break matchEnd16
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper.prototype.flowDeepCopy__p3__Lamf_plugins_domain_webapi_models_security_OAuth2Flow__Lamf_plugins_domain_webapi_models_security_OAuth2Flow = (function(flow) {
  var fields = flow.fields$1.copy__Lamf_core_parser_Fields();
  var this$1 = flow.annotations$1;
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(this$1);
  return new $c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper.prototype.toOasGrant__p3__T__T = (function(grant) {
  return ((grant === "authorization_code") ? "authorizationCode" : ((grant === "password") ? "password" : ((grant === "implicit") ? "implicit" : ((grant === "client_credentials") ? "clientCredentials" : grant))))
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper.prototype.addPermissiveScope__p3__Lamf_plugins_domain_webapi_models_security_OAuth2Flow__V = (function(flow) {
  if ($as_sc_Seq(flow.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Scopes$1)).isEmpty__Z()) {
    var jsx$1 = $m_sc_Seq$();
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var this$4 = new $c_Lamf_plugins_domain_webapi_models_security_Scope().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Name$1;
    var this$5 = $as_Lamf_plugins_domain_webapi_models_security_Scope($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, "*"));
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Description$1;
    var array = [$as_Lamf_plugins_domain_webapi_models_security_Scope($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$5, field$1, ""))];
    var scopes = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Scopes$1;
    $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(flow, field$2, scopes))
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper.prototype.flowNamesFromGrants__p3__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__sci_List = (function(oauth2) {
  var grants = $as_sc_Seq(oauth2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().AuthorizationGrants$1)).toList__sci_List();
  if (grants.isEmpty__Z()) {
    $m_sci_List$();
    var array = ["implicit"];
    var i = (((-1) + $uI(array.length)) | 0);
    var result = $m_sci_Nil$();
    while ((i >= 0)) {
      var this$4 = result;
      var index = i;
      var x = array[index];
      result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
      i = (((-1) + i) | 0)
    };
    return result
  } else {
    var f = (function($this) {
      return (function(g$2) {
        var g = $as_Lamf_core_model_StrField(g$2);
        var this$5 = g.option$1;
        return $as_T((this$5.isEmpty__Z() ? null : this$5.get__O()))
      })
    })(this);
    var this$6 = $m_sci_List$();
    var bf = this$6.ReusableCBFInstance$2;
    if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
      if ((grants === $m_sci_Nil$())) {
        var jsx$1 = $m_sci_Nil$()
      } else {
        var arg1 = grants.head__O();
        var h = new $c_sci_$colon$colon().init___O__sci_List(f(arg1), $m_sci_Nil$());
        var t = h;
        var rest = $as_sci_List(grants.tail__O());
        while ((rest !== $m_sci_Nil$())) {
          var arg1$1 = rest.head__O();
          var nx = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$1), $m_sci_Nil$());
          t.tl$5 = nx;
          t = nx;
          rest = $as_sci_List(rest.tail__O())
        };
        var jsx$1 = h
      }
    } else {
      var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(grants, bf);
      var these = grants;
      while ((!these.isEmpty__Z())) {
        var arg1$2 = these.head__O();
        b.$$plus$eq__O__scm_Builder(f(arg1$2));
        these = $as_sci_List(these.tail__O())
      };
      var jsx$1 = b.result__O()
    };
    var this$8 = $as_sci_List(jsx$1);
    var f$1 = (function(this$2$1) {
      return (function(flowName$2) {
        var flowName = $as_T(flowName$2);
        return this$2$1.flowNameMapping__p3__T__T(flowName)
      })
    })(this);
    var this$7 = $m_sci_List$();
    var bf$1 = this$7.ReusableCBFInstance$2;
    if ((bf$1 === $m_sci_List$().ReusableCBFInstance$2)) {
      if ((this$8 === $m_sci_Nil$())) {
        var jsx$2 = $m_sci_Nil$()
      } else {
        var arg1$3 = this$8.head__O();
        var h$1 = new $c_sci_$colon$colon().init___O__sci_List(f$1(arg1$3), $m_sci_Nil$());
        var t$1 = h$1;
        var rest$1 = $as_sci_List(this$8.tail__O());
        while ((rest$1 !== $m_sci_Nil$())) {
          var arg1$4 = rest$1.head__O();
          var nx$1 = new $c_sci_$colon$colon().init___O__sci_List(f$1(arg1$4), $m_sci_Nil$());
          t$1.tl$5 = nx$1;
          t$1 = nx$1;
          rest$1 = $as_sci_List(rest$1.tail__O())
        };
        var jsx$2 = h$1
      }
    } else {
      var b$1 = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$8, bf$1);
      var these$1 = this$8;
      while ((!these$1.isEmpty__Z())) {
        var arg1$5 = these$1.head__O();
        b$1.$$plus$eq__O__scm_Builder(f$1(arg1$5));
        these$1 = $as_sci_List(these$1.tail__O())
      };
      var jsx$2 = b$1.result__O()
    };
    return $as_sci_List(jsx$2)
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper.prototype.fixOauth2__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__V = (function(oauth2) {
  if ($as_sc_Seq(oauth2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1)).isEmpty__Z()) {
    var flows = this.flowNamesFromGrants__p3__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__sci_List(oauth2);
    var eta$0$1 = oauth2.withFlow__Lamf_plugins_domain_webapi_models_security_OAuth2Flow();
    var these = flows;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      var flow = $as_T(arg1);
      var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Flow$1;
      $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(eta$0$1, field, flow));
      these = $as_sci_List(these.tail__O())
    }
  } else if (this.hasRamlNullFlow__p3__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__Z(oauth2)) {
    var flows$1 = this.createFlowsFromRamlNullFlow__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__sc_Seq(oauth2);
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1;
    $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(oauth2, field$1, flows$1))
  };
  $as_sc_Seq(oauth2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(flow$3$2) {
      var flow$3 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow(flow$3$2);
      this$2.correctFlow__p3__Lamf_plugins_domain_webapi_models_security_OAuth2Flow__V(flow$3);
      this$2.addPermissiveScope__p3__Lamf_plugins_domain_webapi_models_security_OAuth2Flow__V(flow$3)
    })
  })(this)))
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper.prototype.hasRamlNullFlow__p3__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__Z = (function(oauth2) {
  var jsx$1 = $m_s_Option$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($as_sc_Seq(oauth2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1)).head__O());
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Flow$1));
  var this$3 = this$2.option$1;
  return jsx$1.apply__O__s_Option($as_T((this$3.isEmpty__Z() ? null : this$3.get__O()))).isEmpty__Z()
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper.prototype.VALID$undAUTHORIZATION$undGRANTS__sci_List = (function() {
  $m_sci_List$();
  var array = ["implicit", "clientCredentials", "authorizationCode", "password"];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  return result
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  this.errorHandler$3 = errorHandler;
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper.prototype.flowNameMapping__p3__T__T = (function(flowName) {
  return ((flowName === "authorization_code") ? "authorizationCode" : ((flowName === "password") ? "password" : ((flowName === "implicit") ? "implicit" : ((flowName === "client_credentials") ? "clientCredentials" : "implicit"))))
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.oas3.Oas30SecuritySettingsMapper", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper: 1,
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_SecuritySettingsMapper: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_Oas30SecuritySettingsMapper;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_Oas20SecuritySettingsMapper() {
  $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_SecuritySettingsMapper.call(this);
  this.errorHandler$3 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_Oas20SecuritySettingsMapper.prototype = new $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_SecuritySettingsMapper();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_Oas20SecuritySettingsMapper.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_Oas20SecuritySettingsMapper;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_Oas20SecuritySettingsMapper() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_Oas20SecuritySettingsMapper.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_Oas20SecuritySettingsMapper.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_Oas20SecuritySettingsMapper.prototype.fixOauth2__Lamf_plugins_domain_webapi_models_security_OAuth2Settings__V = (function(oauth2) {
  if ($as_sc_Seq(oauth2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1)).isEmpty__Z()) {
    var this$1 = $as_Lamf_core_model_ValueField($as_sc_Seq(oauth2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().AuthorizationGrants$1)).head__O()).option__s_Option();
    var x1 = $as_T((this$1.isEmpty__Z() ? "implicit" : this$1.get__O()));
    var flow = ((x1 === "authorization_code") ? "accessCode" : ((x1 === "password") ? "password" : ((x1 === "implicit") ? "implicit" : ((x1 === "client_credentials") ? "application" : "implicit"))));
    var this$2 = oauth2.withFlow__Lamf_plugins_domain_webapi_models_security_OAuth2Flow();
    var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Flow$1;
    $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$2, field, flow))
  };
  var flow$2 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($as_sc_Seq(oauth2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1)).head__O());
  var this$3 = $as_Lamf_core_model_StrField(flow$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Flow$1));
  var this$4 = this$3.option$1;
  var x1$2 = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
  if ((x1$2 === "implicit")) {
    if ($as_Lamf_core_model_StrField(flow$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1)).option$1.isEmpty__Z()) {
      var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1;
      $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(flow$2, field$1, "http://"))
    };
    flow$2.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1)
  } else if ((x1$2 === "accessCode")) {
    if ($as_Lamf_core_model_StrField(flow$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1)).option$1.isEmpty__Z()) {
      var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1;
      $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(flow$2, field$2, "http://"))
    };
    if ($as_Lamf_core_model_StrField(flow$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1)).option$1.isEmpty__Z()) {
      var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1;
      $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(flow$2, field$3, "http://"))
    }
  } else if ((x1$2 === "password")) {
    if ($as_Lamf_core_model_StrField(flow$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1)).option$1.isEmpty__Z()) {
      var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1;
      $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(flow$2, field$4, "http://"))
    };
    flow$2.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1)
  } else if ((x1$2 === "application")) {
    if ($as_Lamf_core_model_StrField(flow$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1)).option$1.isEmpty__Z()) {
      var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1;
      $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(flow$2, field$5, "http://"))
    };
    flow$2.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1)
  };
  if ($as_sc_Seq(flow$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Scopes$1)).isEmpty__Z()) {
    var jsx$1 = $m_sc_Seq$();
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var this$8 = new $c_Lamf_plugins_domain_webapi_models_security_Scope().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
    var field$6 = $m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Name$1;
    var this$9 = $as_Lamf_plugins_domain_webapi_models_security_Scope($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$8, field$6, "*"));
    var field$7 = $m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Description$1;
    var array = [$as_Lamf_plugins_domain_webapi_models_security_Scope($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$9, field$7, ""))];
    var scopes = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
    var field$8 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Scopes$1;
    $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(flow$2, field$8, scopes))
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_Oas20SecuritySettingsMapper.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  this.errorHandler$3 = errorHandler;
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_Oas20SecuritySettingsMapper = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_Oas20SecuritySettingsMapper: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.oas.Oas20SecuritySettingsMapper", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_Oas20SecuritySettingsMapper: 1,
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_SecuritySettingsMapper: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_Oas20SecuritySettingsMapper.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas_Oas20SecuritySettingsMapper;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveLinksWithNonDeclaredTargets() {
  $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_AmfElementLinkResolutionStage.call(this);
  this.errorHandler$3 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveLinksWithNonDeclaredTargets.prototype = new $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_AmfElementLinkResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveLinksWithNonDeclaredTargets.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveLinksWithNonDeclaredTargets;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveLinksWithNonDeclaredTargets() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveLinksWithNonDeclaredTargets.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveLinksWithNonDeclaredTargets.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveLinksWithNonDeclaredTargets.prototype.errorHandler__Lamf_core_errorhandling_ErrorHandler = (function() {
  return this.errorHandler$3
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveLinksWithNonDeclaredTargets.prototype.selector__Lamf_core_model_domain_Linkable__Lamf_core_model_document_BaseUnit__Z = (function(l, model) {
  if ((model instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(model);
    var targetId = l.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(l.effectiveLinkTarget$default$1__sc_Seq()).id__T();
    return (!$as_sc_Seq(x2.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().Declares$1)).exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, targetId$1) {
      return (function(x$1$2) {
        var x$1 = $as_Lamf_core_model_domain_DomainElement(x$1$2);
        return (x$1.id__T() === targetId$1)
      })
    })(this, targetId))))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveLinksWithNonDeclaredTargets.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  this.errorHandler$3 = errorHandler;
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveLinksWithNonDeclaredTargets = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveLinksWithNonDeclaredTargets: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.ResolveLinksWithNonDeclaredTargets", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveLinksWithNonDeclaredTargets: 1,
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_common_AmfElementLinkResolutionStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveLinksWithNonDeclaredTargets.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResolveLinksWithNonDeclaredTargets;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer$.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_BranchContainer$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_BranchContainer$.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer$.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer$.prototype.merge__sc_Seq__sc_Seq__sc_Seq = (function(left, right) {
  var jsx$1 = $as_sc_GenTraversableOnce(right.filterNot__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, left$1) {
    return (function(x$5$2) {
      var x$5 = $as_Lamf_plugins_document_webapi_resolution_stages_Branch(x$5$2);
      return left$1.contains__O__Z(x$5)
    })
  })(this, left))));
  var this$1 = $m_sc_Seq$();
  return $as_sc_Seq(left.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))
});
var $d_Lamf_plugins_document_webapi_resolution_stages_BranchContainer$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_BranchContainer$: 0
}, false, "amf.plugins.document.webapi.resolution.stages.BranchContainer$", {
  Lamf_plugins_document_webapi_resolution_stages_BranchContainer$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer$.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_BranchContainer$;
var $n_Lamf_plugins_document_webapi_resolution_stages_BranchContainer$ = (void 0);
function $m_Lamf_plugins_document_webapi_resolution_stages_BranchContainer$() {
  if ((!$n_Lamf_plugins_document_webapi_resolution_stages_BranchContainer$)) {
    $n_Lamf_plugins_document_webapi_resolution_stages_BranchContainer$ = new $c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer$().init___()
  };
  return $n_Lamf_plugins_document_webapi_resolution_stages_BranchContainer$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this);
  this.Branches$module$2 = null;
  this.ResourceTypeResolver$module$2 = null;
  this.TraitResolver$module$2 = null;
  this.TraitBranch$module$2 = null;
  this.EndPointTreeBuilder$module$2 = null;
  this.OperationTreeBuilder$module$2 = null;
  this.amf$plugins$document$webapi$resolution$stages$ExtendsResolutionStage$$profile$f = null;
  this.keepEditingInfo$2 = false;
  this.fromOverlay$2 = false;
  this.visited$2 = null;
  this.parserErrorHandler$2 = null;
  this.platform$2 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function() {
  var x1 = this.amf$plugins$document$webapi$resolution$stages$ExtendsResolutionStage$$profile$f;
  var x = $m_Lamf_Raml08Profile$();
  if (x.equals__O__Z(x1)) {
    var jsx$1 = $m_sci_Nil$();
    var x$1 = this.parserErrorHandler$2;
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$4 = new $c_scm_ListBuffer().init___();
    var x$3 = this$4.toList__sci_List();
    var x$4 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$11 = new $c_scm_ListBuffer().init___();
    var x$5 = new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$11.toList__sci_List());
    return new $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions("", jsx$1, new $c_Lamf_core_parser_ParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext("", x$3, x$4, x$1, x$5), $m_s_None$(), $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2, new $c_Lamf_core_client_ParsingOptions().init___())
  } else {
    var jsx$2 = $m_sci_Nil$();
    var x$6 = this.parserErrorHandler$2;
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$19 = new $c_scm_ListBuffer().init___();
    var x$8 = this$19.toList__sci_List();
    var x$9 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$26 = new $c_scm_ListBuffer().init___();
    var x$10 = new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$26.toList__sci_List());
    return new $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions("", jsx$2, new $c_Lamf_core_parser_ParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext("", x$8, x$9, x$6, x$10), $m_s_None$(), $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2, new $c_Lamf_core_client_ParsingOptions().init___())
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage.prototype.collectResourceTypes__p2__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_document_webapi_resolution_stages_Context__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_core_model_domain_ElementTree__scm_ListBuffer = (function(endpoint, context, apiContext, tree) {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  this.collectResourceTypes__p2__scm_ListBuffer__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_document_webapi_resolution_stages_Context__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_core_model_domain_ElementTree__V(result, endpoint, context, apiContext, tree);
  return result
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage.prototype.init___Lamf_ProfileName__Z__Z__scm_Set__Lamf_core_errorhandling_ErrorHandler = (function(profile, keepEditingInfo, fromOverlay, visited, errorHandler) {
  this.amf$plugins$document$webapi$resolution$stages$ExtendsResolutionStage$$profile$f = profile;
  this.keepEditingInfo$2 = keepEditingInfo;
  this.fromOverlay$2 = fromOverlay;
  this.visited$2 = visited;
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$2 = this$1.platform$1;
  this.parserErrorHandler$2 = $m_Lamf_client_parse_DefaultParserErrorHandler$().fromErrorHandler__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_errorhandler_AmfParserErrorHandler(errorHandler);
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage.prototype.findExtendsPredicate__p2__Lamf_core_model_domain_DomainElement__Z = (function(element) {
  return ((this.visited$2.contains__O__Z(element.id__T()) && (!this.fromOverlay$2)) || (this.visited$2.$$plus$eq__O__scm_SetLike(element.id__T()), (element instanceof $c_Lamf_plugins_domain_webapi_models_EndPoint)))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage.prototype.convert__p2__Lamf_core_model_document_BaseUnit__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_domain_webapi_models_EndPoint = (function(model, endpoint) {
  var context = new $c_Lamf_plugins_document_webapi_resolution_stages_Context().init___Lamf_core_model_document_BaseUnit__sci_Set(model, $as_sci_Set($m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))).add__T__T__Lamf_plugins_document_webapi_resolution_stages_Context("resourcePath", this.resourcePath__p2__Lamf_plugins_domain_webapi_models_EndPoint__T(endpoint)).add__T__T__Lamf_plugins_document_webapi_resolution_stages_Context("resourcePathName", this.resourcePathName__p2__Lamf_plugins_domain_webapi_models_EndPoint__T(endpoint));
  var tree = new $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder().init___Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage__Lamf_plugins_domain_webapi_models_EndPoint(this, endpoint).build__Lamf_core_model_domain_ElementTree();
  var extendsContext = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  var resourceTypes = this.collectResourceTypes__p2__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_document_webapi_resolution_stages_Context__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_core_model_domain_ElementTree__scm_ListBuffer(endpoint, context, extendsContext, tree);
  this.apply__Lamf_plugins_domain_webapi_models_EndPoint__scm_ListBuffer__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_domain_webapi_models_EndPoint(endpoint, resourceTypes, extendsContext);
  var resolver = new $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver().init___Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage(this);
  var jsx$4 = $as_sc_Seq(endpoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, context$1, extendsContext$1, resolver$1, endpoint$1, tree$1, resourceTypes$1) {
    return (function(operation$2) {
      var operation = $as_Lamf_plugins_domain_webapi_models_Operation(operation$2);
      var this$2 = $as_Lamf_core_model_StrField(operation.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Method$1));
      var this$3 = this$2.option$1;
      var local = context$1.add__T__T__Lamf_plugins_document_webapi_resolution_stages_Context("methodName", $as_T((this$3.isEmpty__Z() ? null : this$3.get__O())));
      var branches = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      var operationTree = new $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder().init___Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage__Lamf_plugins_domain_webapi_models_Operation($this, operation).build__Lamf_core_model_domain_ElementTree();
      var branchesObj = new $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches().init___Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext($this, extendsContext$1);
      branches.$$plus$eq__O__scm_ListBuffer(branchesObj.method__Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver__Lamf_plugins_domain_webapi_models_Operation__Lamf_plugins_document_webapi_resolution_stages_Context__Lamf_core_model_domain_ElementTree__Lamf_plugins_document_webapi_resolution_stages_BranchContainer(resolver$1, operation, local, operationTree));
      branches.$$plus$eq__O__scm_ListBuffer(branchesObj.endpoint__Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_document_webapi_resolution_stages_Context__Lamf_core_model_domain_ElementTree__Lamf_plugins_document_webapi_resolution_stages_BranchContainer(resolver$1, endpoint$1, local, tree$1));
      var this$4 = resourceTypes$1.scala$collection$mutable$ListBuffer$$start$6;
      var these = this$4;
      while ((!these.isEmpty__Z())) {
        var arg1 = these.head__O();
        var rt = $as_Lamf_plugins_domain_webapi_models_EndPoint(arg1);
        var this$5 = $as_Lamf_core_model_StrField(operation.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Method$1));
        var this$6 = this$5.option$1;
        branches.$$plus$eq__O__scm_ListBuffer(branchesObj.resourceType__Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_document_webapi_resolution_stages_Context__T__Lamf_core_model_domain_ElementTree__Lamf_plugins_document_webapi_resolution_stages_BranchContainer(resolver$1, rt, local, $as_T((this$6.isEmpty__Z() ? null : this$6.get__O())), tree$1));
        these = $as_sci_List(these.tail__O())
      };
      var z = $m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$());
      var this$7 = branches.scala$collection$mutable$ListBuffer$$start$6;
      var acc = z;
      var these$1 = this$7;
      while ((!these$1.isEmpty__Z())) {
        var arg1$1 = acc;
        var arg2 = these$1.head__O();
        var x0$1 = $as_sc_Seq(arg1$1);
        var x1$1 = $as_Lamf_plugins_document_webapi_resolution_stages_BranchContainer(arg2);
        var jsx$3 = $m_Lamf_plugins_document_webapi_resolution_stages_BranchContainer$().merge__sc_Seq__sc_Seq__sc_Seq(x0$1, x1$1.flatten__sc_Seq());
        var jsx$2 = new $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$$anonfun$$nestedInanonfun$convert$3$1().init___Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage($this);
        var this$8 = $m_sc_Seq$();
        acc = $as_sc_Seq(jsx$3.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$2, this$8.ReusableCBFInstance$2));
        these$1 = $as_sc_LinearSeqOptimized(these$1.tail__O())
      };
      var traits = $as_sc_Seq(acc);
      traits.foldLeft__O__F2__O(operation, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$3$1, extendsContext$1$1) {
        return (function(x0$2$2, x1$2$2) {
          var x0$2 = $as_Lamf_plugins_domain_webapi_models_Operation(x0$2$2);
          var x1$2 = $as_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch(x1$2$2);
          return $as_Lamf_plugins_domain_webapi_models_Operation(new $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging().init___Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(extendsContext$1$1).merge__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(x0$2, x1$2.operation$1))
        })
      })($this, extendsContext$1)));
      if (((!$this.keepEditingInfo$2) && (!$this.fromOverlay$2))) {
        operation.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field())
      };
      return traits
    })
  })(this, context, extendsContext, resolver, endpoint, tree, resourceTypes));
  var this$9 = $m_sc_Seq$();
  var traitList = $as_sc_Seq(jsx$4.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$9.ReusableCBFInstance$2));
  if (((!this.keepEditingInfo$2) && (!this.fromOverlay$2))) {
    endpoint.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field())
  };
  var this$10 = extendsContext.futureDeclarations$1;
  $f_Lamf_core_parser_FutureDeclarations__resolve__V(this$10);
  return ((resourceTypes.nonEmpty__Z() || traitList.nonEmpty__Z()) ? $as_Lamf_plugins_domain_webapi_models_EndPoint(new $c_Lamf_core_resolution_stages_ReferenceResolutionStage().init___Z__Lamf_core_errorhandling_ErrorHandler(this.keepEditingInfo$2, this.errorHandler$1).resolveDomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(endpoint)) : endpoint)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage.prototype.asEndPoint__Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType__Lamf_plugins_document_webapi_resolution_stages_Context__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_core_model_domain_ElementTree__Lamf_plugins_domain_webapi_models_EndPoint = (function(r, context, apiContext, tree) {
  var x1 = $m_s_Option$().apply__O__s_Option(r.target__Lamf_core_model_domain_templates_AbstractDeclaration());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var rt = $as_Lamf_core_model_domain_templates_AbstractDeclaration(x2.value$2);
    if ((rt instanceof $c_Lamf_plugins_domain_webapi_models_templates_ResourceType)) {
      var x3 = $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(rt);
      var node = x3.dataNode__Lamf_core_model_domain_DataNode().copyNode__Lamf_core_model_domain_DataNode();
      node.replaceVariables__sci_Set__sc_Seq__F1__Lamf_core_model_domain_DataNode(context.variables$1, tree.subtrees$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, apiContext$1, r$1) {
        return (function(message$2) {
          var message = $as_T(message$2);
          var this$1 = apiContext$1.eh$1;
          var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
          var node$1 = r$1.id$1;
          var property = $m_s_None$();
          var lexical = r$1.annotations$2.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
          var location = $f_Lamf_core_model_domain_AmfElement__location__s_Option(r$1);
          this$1.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node$1, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
        })
      })(this, apiContext, r)));
      var jsx$7 = $m_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$();
      var jsx$6 = context.model$1;
      var jsx$5 = this.amf$plugins$document$webapi$resolution$stages$ExtendsResolutionStage$$profile$f;
      var jsx$4 = x3.annotations$2;
      var this$2 = $as_Lamf_core_model_StrField(r.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$().Name$1));
      var this$3 = this$2.option$1;
      var jsx$3 = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
      var jsx$2 = r.id$1;
      var this$4 = $m_s_Option$().apply__O__s_Option(r.target__Lamf_core_model_domain_templates_AbstractDeclaration());
      if (this$4.isEmpty__Z()) {
        var jsx$1 = $m_s_None$()
      } else {
        var arg1 = this$4.get__O();
        var t = $as_Lamf_core_model_domain_templates_AbstractDeclaration(arg1);
        var jsx$1 = $m_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$().findUnitLocationOfElement__T__Lamf_core_model_document_BaseUnit__s_Option(t.id$1, context.model$1)
      };
      return jsx$7.asEndpoint__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_model_domain_DataNode__Lamf_core_parser_Annotations__T__T__s_Option__Z__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_domain_webapi_models_EndPoint(jsx$6, jsx$5, node, jsx$4, jsx$3, jsx$2, jsx$1, this.keepEditingInfo$2, new $c_s_Some().init___O(apiContext), this.errorHandler$1)
    }
  };
  var this$5 = apiContext.eh$1;
  var specification$1 = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
  var node$2 = r.id$1;
  var property$1 = $m_s_None$();
  var message$1 = ("Cannot find target for parametrized resource type " + r.id$1);
  var lexical$1 = r.annotations$2.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  var location$1 = $f_Lamf_core_model_domain_AmfElement__location__s_Option(r);
  this$5.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification$1.id$1, node$2, property$1, message$1, lexical$1, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location$1);
  var jsx$8 = r.id$1;
  var this$6 = r.annotations$2.find__jl_Class__s_Option($d_Lamf_core_annotations_SourceAST.getClassOf());
  if (this$6.isEmpty__Z()) {
    var this$7 = $m_s_None$()
  } else {
    var arg1$1 = this$6.get__O();
    var x$1 = $as_Lamf_core_annotations_SourceAST(arg1$1);
    var this$7 = new $c_s_Some().init___O(x$1.ast$1)
  };
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint().init___T__Lorg_yaml_model_YPart(jsx$8, $as_Lorg_yaml_model_YPart((this$7.isEmpty__Z() ? $m_Lorg_yaml_model_YNode$().Null$1 : this$7.get__O())))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage.prototype.transform__p2__Lamf_core_model_document_BaseUnit__Lamf_core_model_domain_DomainElement__Z__s_Option = (function(model, element, isCycle) {
  if ((element instanceof $c_Lamf_plugins_domain_webapi_models_EndPoint)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_EndPoint(element);
    return new $c_s_Some().init___O(this.convert__p2__Lamf_core_model_document_BaseUnit__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_domain_webapi_models_EndPoint(model, x2))
  } else {
    return new $c_s_Some().init___O(element)
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage.prototype.resourcePathName__p2__Lamf_plugins_domain_webapi_models_EndPoint__T = (function(endPoint) {
  var x = this.resourcePath__p2__Lamf_plugins_domain_webapi_models_EndPoint__T(endPoint);
  var this$2 = new $c_sci_StringOps().init___T(x);
  var xs = $f_sci_StringLike__split__C__AT(this$2, 47);
  var b = new $c_scm_ArrayBuilder$ofRef().init___s_reflect_ClassTag($m_s_reflect_ClassTag$().apply__jl_Class__s_reflect_ClassTag($objectGetClass(xs).getComponentType__jl_Class()));
  b.sizeHint__I__V(xs.u.length);
  var i = xs.u.length;
  while ((i > 0)) {
    i = (((-1) + i) | 0);
    var index = i;
    var elem = xs.get(index);
    b.$$plus$eq__O__scm_ArrayBuilder$ofRef(elem)
  };
  var xs$1 = b.result__AO();
  var len = xs$1.u.length;
  var i$1 = 0;
  while (true) {
    if ((i$1 < len)) {
      var index$1 = i$1;
      var arg1 = xs$1.get(index$1);
      var s = $as_T(arg1);
      var this$12 = new $c_sci_StringOps().init___T(s);
      if ($f_sc_TraversableOnce__nonEmpty__Z(this$12)) {
        var this$14 = new $c_sci_StringOps().init___T("\\{.*\\}");
        var groupNames = $m_sci_Nil$();
        var $$this = this$14.repr$1;
        var jsx$2 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames).findFirstIn__jl_CharSequence__s_Option(s).isEmpty__Z()
      } else {
        var jsx$2 = false
      };
      var jsx$1 = (!jsx$2)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      i$1 = ((1 + i$1) | 0)
    } else {
      break
    }
  };
  var i$2 = i$1;
  var this$18 = ((i$2 < xs$1.u.length) ? new $c_s_Some().init___O(xs$1.get(i$2)) : $m_s_None$());
  return $as_T((this$18.isEmpty__Z() ? "" : this$18.get__O()))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage.prototype.apply__Lamf_plugins_domain_webapi_models_EndPoint__scm_ListBuffer__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_domain_webapi_models_EndPoint = (function(endpoint, resourceTypes, ctx) {
  var this$1 = resourceTypes.scala$collection$mutable$ListBuffer$$start$6;
  var acc = endpoint;
  var these = this$1;
  while ((!these.isEmpty__Z())) {
    var arg1 = acc;
    var arg2 = these.head__O();
    var x0$1 = $as_Lamf_plugins_domain_webapi_models_EndPoint(arg1);
    var x1$1 = $as_Lamf_plugins_domain_webapi_models_EndPoint(arg2);
    acc = $as_Lamf_plugins_domain_webapi_models_EndPoint(new $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging().init___Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(ctx).merge__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(x0$1, x1$1));
    these = $as_sc_LinearSeqOptimized(these.tail__O())
  };
  return $as_Lamf_plugins_domain_webapi_models_EndPoint(acc)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage.prototype.collectResourceTypes__p2__scm_ListBuffer__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_document_webapi_resolution_stages_Context__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_core_model_domain_ElementTree__V = (function(collector, endpoint, initial, apiContext, tree) {
  var this$1 = endpoint.resourceType__s_Option();
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var resourceType = $as_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType(arg1);
    var context = initial.add__sc_Seq__Lamf_plugins_document_webapi_resolution_stages_Context(resourceType.variables__sc_Seq());
    var resolved = this.asEndPoint__Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType__Lamf_plugins_document_webapi_resolution_stages_Context__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_core_model_domain_ElementTree__Lamf_plugins_domain_webapi_models_EndPoint(resourceType, context, apiContext, tree);
    collector.$$plus$eq__O__scm_ListBuffer(resolved);
    this.collectResourceTypes__p2__scm_ListBuffer__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_document_webapi_resolution_stages_Context__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_core_model_domain_ElementTree__V(collector, resolved, context, apiContext, tree)
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  return model.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(element$2) {
      var element = $as_Lamf_core_model_domain_DomainElement(element$2);
      return $this.findExtendsPredicate__p2__Lamf_core_model_domain_DomainElement__Z(element)
    })
  })(this)), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$2, model$1) {
    return (function(element$3$2, isCycle$2) {
      var element$3 = $as_Lamf_core_model_domain_DomainElement(element$3$2);
      var isCycle = $uZ(isCycle$2);
      return this$2.transform__p2__Lamf_core_model_document_BaseUnit__Lamf_core_model_domain_DomainElement__Z__s_Option(model$1, element$3, isCycle)
    })
  })(this, model)), this.errorHandler$1)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage.prototype.resourcePath__p2__Lamf_plugins_domain_webapi_models_EndPoint__T = (function(endPoint) {
  var jsx$1 = $m_sjsr_RuntimeString$();
  var this$1 = $as_Lamf_core_model_StrField(endPoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1));
  var this$2 = this$1.option$1;
  return jsx$1.replaceAll__T__T__T__T($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())), "\\{ext\\}", "")
});
var $d_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage: 0
}, false, "amf.plugins.document.webapi.resolution.stages.ExtendsResolutionStage", {
  Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionResolutionStage() {
  $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage.call(this);
  this.restrictions$2 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionResolutionStage.prototype = new $h_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionResolutionStage.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionResolutionStage;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_ExtensionResolutionStage() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_ExtensionResolutionStage.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionResolutionStage.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionResolutionStage.prototype.keepEditingInfo__Z = (function() {
  return this.keepEditingInfo$1
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionResolutionStage.prototype.init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler = (function(profile, keepEditingInfo, errorHandler) {
  $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage.prototype.init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler.call(this, profile, keepEditingInfo, errorHandler);
  this.restrictions$2 = $m_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$().unrestricted$1;
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionResolutionStage.prototype.profile__Lamf_ProfileName = (function() {
  return this.profile$1
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionResolutionStage.prototype.errorHandler__Lamf_core_errorhandling_ErrorHandler = (function() {
  return this.errorHandler$1
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionResolutionStage.prototype.restrictions__Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions = (function() {
  return this.restrictions$2
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionResolutionStage.prototype.setDomainElementArrayValue__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfArray__T__s_Option__V = (function(target, field, other, extensionId, extensionLocation) {
  other.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, extensionId$1, extensionLocation$1, target$1, field$1) {
    return (function(value$2) {
      var value = $as_Lamf_core_model_domain_AmfElement(value$2);
      if ($this.keepEditingInfo$1) {
        value.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance().init___T__s_Option(extensionId$1, extensionLocation$1))
      };
      return $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(target$1, field$1, value))
    })
  })(this, extensionId, extensionLocation, target, field)))
});
var $d_Lamf_plugins_document_webapi_resolution_stages_ExtensionResolutionStage = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_ExtensionResolutionStage: 0
}, false, "amf.plugins.document.webapi.resolution.stages.ExtensionResolutionStage", {
  Lamf_plugins_document_webapi_resolution_stages_ExtensionResolutionStage: 1,
  Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage: 1,
  O: 1,
  Lamf_plugins_document_webapi_resolution_stages_InnerAdoption: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionResolutionStage.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_ExtensionResolutionStage;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionsResolutionStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this);
  this.profile$2 = null;
  this.keepEditingInfo$2 = false;
  this.platform$2 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionsResolutionStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionsResolutionStage.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionsResolutionStage;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_ExtensionsResolutionStage() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_ExtensionsResolutionStage.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionsResolutionStage.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionsResolutionStage.prototype.init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler = (function(profile, keepEditingInfo, errorHandler) {
  this.profile$2 = profile;
  this.keepEditingInfo$2 = keepEditingInfo;
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$2 = this$1.platform$1;
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionsResolutionStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  var extendsStage = new $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage().init___Lamf_ProfileName__Z__Z__scm_Set__Lamf_core_errorhandling_ErrorHandler(this.profile$2, this.keepEditingInfo$2, false, $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), this.errorHandler$1);
  if ((model instanceof $c_Lamf_plugins_document_webapi_model_Overlay)) {
    var x2 = $as_Lamf_plugins_document_webapi_model_Overlay(model);
    var this$2 = new $c_Lamf_plugins_document_webapi_resolution_stages_OverlayResolutionStage().init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler(this.profile$2, this.keepEditingInfo$2, this.errorHandler$1);
    return this$2.resolveOverlay__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_ExtensionLike__Lamf_core_model_document_BaseUnit(model, x2)
  } else if ((model instanceof $c_Lamf_plugins_document_webapi_model_Extension)) {
    var x3 = $as_Lamf_plugins_document_webapi_model_Extension(model);
    var this$3 = new $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionResolutionStage().init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler(this.profile$2, this.keepEditingInfo$2, this.errorHandler$1);
    return this$3.resolveOverlay__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_ExtensionLike__Lamf_core_model_document_BaseUnit(model, x3)
  } else {
    return extendsStage.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(model)
  }
});
var $d_Lamf_plugins_document_webapi_resolution_stages_ExtensionsResolutionStage = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_ExtensionsResolutionStage: 0
}, false, "amf.plugins.document.webapi.resolution.stages.ExtensionsResolutionStage", {
  Lamf_plugins_document_webapi_resolution_stages_ExtensionsResolutionStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionsResolutionStage.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_ExtensionsResolutionStage;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_OverlayResolutionStage() {
  $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage.call(this);
  this.restrictions$2 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_OverlayResolutionStage.prototype = new $h_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_stages_OverlayResolutionStage.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_OverlayResolutionStage;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_OverlayResolutionStage() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_OverlayResolutionStage.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_OverlayResolutionStage.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_OverlayResolutionStage.prototype.keepEditingInfo__Z = (function() {
  return this.keepEditingInfo$1
});
$c_Lamf_plugins_document_webapi_resolution_stages_OverlayResolutionStage.prototype.init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler = (function(profile, keepEditingInfo, errorHandler) {
  $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage.prototype.init___Lamf_ProfileName__Z__Lamf_core_errorhandling_ErrorHandler.call(this, profile, keepEditingInfo, errorHandler);
  this.restrictions$2 = $m_Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions$().onlyFunctionalField$1;
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_OverlayResolutionStage.prototype.profile__Lamf_ProfileName = (function() {
  return this.profile$1
});
$c_Lamf_plugins_document_webapi_resolution_stages_OverlayResolutionStage.prototype.errorHandler__Lamf_core_errorhandling_ErrorHandler = (function() {
  return this.errorHandler$1
});
$c_Lamf_plugins_document_webapi_resolution_stages_OverlayResolutionStage.prototype.restrictions__Lamf_plugins_document_webapi_resolution_stages_MergingRestrictions = (function() {
  return this.restrictions$2
});
$c_Lamf_plugins_document_webapi_resolution_stages_OverlayResolutionStage.prototype.setDomainElementArrayValue__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfArray__T__s_Option__V = (function(target, field, other, extensionId, extensionLocation) {
  var jsx$2 = other.values$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, extensionId$1, extensionLocation$1) {
    return (function(value$2) {
      var value = $as_Lamf_core_model_domain_AmfElement(value$2);
      if ($this.keepEditingInfo$1) {
        value.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance().init___T__s_Option(extensionId$1, extensionLocation$1))
      };
      return value
    })
  })(this, extensionId, extensionLocation));
  var this$1 = $m_sc_Seq$();
  var seq = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(target, field, seq)
});
var $d_Lamf_plugins_document_webapi_resolution_stages_OverlayResolutionStage = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_OverlayResolutionStage: 0
}, false, "amf.plugins.document.webapi.resolution.stages.OverlayResolutionStage", {
  Lamf_plugins_document_webapi_resolution_stages_OverlayResolutionStage: 1,
  Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage: 1,
  O: 1,
  Lamf_plugins_document_webapi_resolution_stages_InnerAdoption: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_OverlayResolutionStage.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_OverlayResolutionStage;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$() {
  $c_O.call(this);
  this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$.prototype = $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$.prototype;
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result__sc_Seq = (function() {
  return ((!this.bitmap$0$1) ? this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$lzycompute__p1__sc_Seq() : this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1)
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$lzycompute__p1__sc_Seq = (function() {
  if ((!this.bitmap$0$1)) {
    this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfProfileValidations__amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result__sc_Seq(this);
    this.bitmap$0$1 = true
  };
  return this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1
});
var $d_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$: 0
}, false, "amf.plugins.document.webapi.validation.AMFRawValidations$AmfValidations$", {
  Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfProfileValidations: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$ProfileValidations: 1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$;
var $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$)) {
    $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$ = new $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfValidations$
}
function $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$RamlValidations__amf$plugins$document$webapi$validation$AMFRawValidations$RamlValidations$$result__sc_Seq($thiz) {
  var jsx$19 = $thiz.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result__sc_Seq();
  var jsx$18 = $m_sc_Seq$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns, "WebAPI");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$1, "name");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$2 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$2, "minLength");
  var x$7 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$3 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$9 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$3, "path");
  var x$10 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$17 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$7, "", x$1, x$2, x$9, x$3, "1", "Info object 'title' must not be empty", "API name must not be an empty string", x$10);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$4 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$11 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$4, "CreativeWork");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$5 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$12 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$5, "title");
  var x$13 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  var x$17 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$6 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$19 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$6, "path");
  var x$20 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$16 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$17, "", x$11, x$12, x$19, x$13, "1", "API documentation title is mandatory", "Documentation object 'x-title' is mandatory", x$20);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$7 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$21 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$7, "CreativeWork");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$8 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$22 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$8, "description");
  var x$23 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  var x$27 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$9 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$29 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$9, "path");
  var x$30 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$15 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$27, "", x$21, x$22, x$29, x$23, "1", "API documentation content is mandatory", "Documentation object 'description' is mandatory", x$30);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$10 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var x$31 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$10, "DomainProperty");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$11 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$32 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$11, "schema");
  var x$33 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  var x$37 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$12 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$39 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$12, "path");
  var x$40 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$14 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$37, "", x$31, x$32, x$39, x$33, "1", "type is mandatory for a RAML annotationType", "schema is mandatory for an extension type", x$40);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$13 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var x$42 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$13, "Settings");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$14 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var x$43 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$14, "authorizationGrant");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$15 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$44 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$15, "pattern");
  var x$46 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$16 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$47 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$16, "path");
  var x$50 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$13 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$46, "Invalid authorization grant. The options are: authorization_code, password, client_credentials, implicit or any valid absolute URI", x$42, x$43, x$47, x$44, "^authorization_code|password|client_credentials|implicit|(\\w+:(\\/?\\/?)[^\\s]+)$", "", "", x$50);
  var x$51 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("raml-root-schemes-values");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$17 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$53 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$17, "WebAPI");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$18 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$54 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$18, "scheme");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$19 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$55 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$19, "pattern");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$20 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$59 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$20, "path");
  var x$60 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$12 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$51, "Protocols property must be http or https", x$53, x$54, x$59, x$55, "^(H|h)(T|t)(T|t)(P|p)(S|s)?$", "Protocols must have a case insensitive value matching http or https", "Swagger object 'schemes' property must have a case insensitive value matching http or https", x$60);
  var x$61 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("raml-operation-schemes-values");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$21 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$63 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$21, "Operation");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$22 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$64 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$22, "scheme");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$23 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$65 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$23, "pattern");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$24 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$69 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$24, "path");
  var x$70 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$11 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$61, "Protocols property must be http or https", x$63, x$64, x$69, x$65, "^(H|h)(T|t)(T|t)(P|p)(S|s)?$", "Protocols must have a case insensitive value matching http or https", "Swagger object 'schemes' property must have a case insensitive value matching http or https", x$70);
  var x$71 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("raml-root-schemes-non-empty-array");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$25 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$73 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$25, "WebAPI");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$26 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$74 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$26, "scheme");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$27 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$75 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$27, "nonEmptyListOfProtocols");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$28 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$76 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$28, "path");
  var x$80 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$10 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$71, "Protocols must be a non-empty array of case-insensitive strings with values 'http' and/or 'https'", x$73, x$74, x$76, x$75, "0", "", "", x$80);
  var x$81 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("raml-operation-schemes-non-empty-array");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$29 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$83 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$29, "Operation");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$30 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$84 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$30, "scheme");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$31 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$85 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$31, "nonEmptyListOfProtocols");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$32 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$86 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$32, "path");
  var x$90 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$9 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$81, "Protocols must be a non-empty array of case-insensitive strings with values 'http' and/or 'https'", x$83, x$84, x$86, x$85, "0", "", "", x$90);
  var x$91 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("min-max-inclusive");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$33 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$93 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$33, "ScalarShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$34 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$94 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$34, "minInclusive");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$35 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$95 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$35, "minimumMaximumValidation");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$36 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$96 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$36, "path");
  var x$100 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$8 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$91, "Maximum must be greater than or equal to minimum", x$93, x$94, x$96, x$95, "0", "", "", x$100);
  var x$101 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("min-max-items");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$37 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$103 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$37, "ArrayShape");
  var x$104 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$38 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$105 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$38, "minMaxItemsValidation");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$39 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$106 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$39, "path");
  var x$110 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$7 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$101, "MaxItems must be greater than or equal to minItems", x$103, x$104, x$106, x$105, "0", "", "", x$110);
  var x$111 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("min-max-length");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$40 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$113 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$40, "ScalarShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$41 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$114 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$41, "minLength");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$42 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$115 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$42, "minMaxLengthValidation");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$43 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$116 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$43, "path");
  var x$120 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$6 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$111, "MaxLength must be greater than or equal to minLength", x$113, x$114, x$116, x$115, "0", "", "", x$120);
  var x$121 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("min-max-length");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$44 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$123 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$44, "FileShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$45 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$124 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$45, "minLength");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$46 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$125 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$46, "minMaxLengthValidation");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$47 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$126 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$47, "path");
  var x$130 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$5 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$121, "MaxLength must be greater than or equal to minLength", x$123, x$124, x$126, x$125, "0", "", "", x$130);
  var x$131 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("min-max-properties");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$48 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$133 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$48, "NodeShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$49 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$134 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$49, "minProperties");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$50 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$135 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$50, "minMaxPropertiesValidation");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$51 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$136 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$51, "path");
  var x$140 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$4 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$131, "MaxProperties must be greater than or equal to minProperties", x$133, x$134, x$136, x$135, "0", "", "", x$140);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$52 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$141 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$52, "Payload");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$53 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$143 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$53, "mediaType");
  var x$144 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  var x$146 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$54 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$147 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$54, "path");
  var x$150 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$3 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$146, "Payload media type is mandatory", x$141, x$143, x$147, x$144, "1", "", "", x$150);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$55 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var x$152 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$55, "Settings");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$56 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var x$153 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$56, "signature");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$57 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$154 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$57, "pattern");
  var x$156 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$58 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$157 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$58, "path");
  var x$160 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$2 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$156, "Invalid OAuth 1.0 signature. The options are: HMAC-SHA1, RSA-SHA1, or PLAINTEXT", x$152, x$153, x$157, x$154, "^HMAC-SHA1|RSA-SHA1|PLAINTEXT$", "", "", x$160);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$59 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$161 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$59, "Response");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$60 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$162 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$60, "statusCode");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$61 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$163 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$61, "pattern");
  var x$167 = $m_s_None$();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$62 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$169 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$62, "path");
  var x$170 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var array = [jsx$17, jsx$16, jsx$15, jsx$14, jsx$13, jsx$12, jsx$11, jsx$10, jsx$9, jsx$8, jsx$7, jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$167, "", x$161, x$162, x$169, x$163, "^([1-5]{1}[0-9]{2})$|^(default)$", "Status code for a Response must be a value between 100 and 599", "Status code for a Response must be a value between 100 and 599 or 'default'", x$170), $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().schemaRequiredInParameter$1];
  var jsx$1 = jsx$18.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
  var this$171 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$19.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$171.ReusableCBFInstance$2))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_remote_JsPayloadValidator() {
  $c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.call(this);
  this.shape$2 = null;
  this.validationMode$2 = null;
  this.env$2 = null
}
$c_Lamf_plugins_document_webapi_validation_remote_JsPayloadValidator.prototype = new $h_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator();
$c_Lamf_plugins_document_webapi_validation_remote_JsPayloadValidator.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_remote_JsPayloadValidator;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_remote_JsPayloadValidator() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_remote_JsPayloadValidator.prototype = $c_Lamf_plugins_document_webapi_validation_remote_JsPayloadValidator.prototype;
$c_Lamf_plugins_document_webapi_validation_remote_JsPayloadValidator.prototype.loadSchema__jl_CharSequence__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_validation_remote_ValidationProcessor__s_util_Either = (function(jsonSchema, element, validationProcessor) {
  var schemaNode = this.loadJson__T__sjs_js_Dynamic($objectToString(jsonSchema));
  if ($uZ($m_sjs_js_WrappedDictionary$Cache$().safeHasOwnProperty$1.call(schemaNode, "x-amf-fragmentType"))) {
    delete schemaNode["x-amf-fragmentType"]
  };
  if ($uZ($m_sjs_js_WrappedDictionary$Cache$().safeHasOwnProperty$1.call(schemaNode, "example"))) {
    delete schemaNode.example
  };
  if ($uZ($m_sjs_js_WrappedDictionary$Cache$().safeHasOwnProperty$1.call(schemaNode, "examples"))) {
    delete schemaNode.examples
  };
  if ($uZ($m_sjs_js_WrappedDictionary$Cache$().safeHasOwnProperty$1.call(schemaNode, "x-amf-examples"))) {
    delete schemaNode["x-amf-examples"]
  };
  $m_s_package$();
  var value = new $c_s_Some().init___O(schemaNode);
  return new $c_s_util_Right().init___O(value)
});
$c_Lamf_plugins_document_webapi_validation_remote_JsPayloadValidator.prototype.callValidator__sjs_js_Dictionary__sjs_js_Dynamic__s_Option__Lamf_plugins_document_webapi_validation_remote_ValidationProcessor__O = (function(schema, obj, fragment, validationProcessor) {
  var fast = (validationProcessor === $m_Lamf_plugins_document_webapi_validation_remote_BooleanValidationProcessor$());
  var validator = (fast ? $m_Lamf_plugins_document_webapi_validation_remote_LazyAjv$().fast__Lamf_plugins_document_webapi_validation_remote_Ajv() : $m_Lamf_plugins_document_webapi_validation_remote_LazyAjv$().$default__Lamf_plugins_document_webapi_validation_remote_Ajv());
  try {
    var correct = $uZ(validator.validate(schema, obj));
    if (fast) {
      return correct
    } else {
      if ((!correct)) {
        var value = validator.errors;
        var array = ((value === (void 0)) ? [] : value);
        var array$1 = [];
        var x1 = $uI(array.length);
        switch (x1) {
          case (-1): {
            break
          }
        };
        var i = 0;
        var len = $uI(array.length);
        while ((i < len)) {
          var index = i;
          var arg1 = array[index];
          var message = this.makeValidationMessage__p2__Lamf_plugins_document_webapi_validation_remote_ValidationResult__T(arg1);
          var level = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
          if (fragment.isEmpty__Z()) {
            var this$8 = $m_s_None$()
          } else {
            var arg1$1 = fragment.get__O();
            var x$1 = $as_Lamf_core_model_document_PayloadFragment(arg1$1);
            var this$8 = new $c_s_Some().init___O($as_Lamf_core_model_domain_DataNode(x$1.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().Encodes$1)).id$1)
          };
          var targetNode = $as_T((this$8.isEmpty__Z() ? "" : this$8.get__O()));
          if (fragment.isEmpty__Z()) {
            var targetProperty = $m_s_None$()
          } else {
            var arg1$2 = fragment.get__O();
            var x$2 = $as_Lamf_core_model_document_PayloadFragment(arg1$2);
            var targetProperty = new $c_s_Some().init___O($as_Lamf_core_model_domain_DataNode(x$2.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().Encodes$1)).id$1)
          };
          var validationId = $m_Lamf_validations_PayloadValidations$().ExampleValidationErrorSpecification$1.id$1;
          if (fragment.isEmpty__Z()) {
            var position = $m_s_None$()
          } else {
            var arg1$3 = fragment.get__O();
            var x$3 = $as_Lamf_core_model_document_PayloadFragment(arg1$3);
            var this$9 = $as_Lamf_core_model_domain_DataNode(x$3.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().Encodes$1));
            var position = this$9.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf())
          };
          if (fragment.isEmpty__Z()) {
            var location = $m_s_None$()
          } else {
            var arg1$4 = fragment.get__O();
            var x$4 = $as_Lamf_core_model_document_PayloadFragment(arg1$4);
            var this$10 = $as_Lamf_core_model_domain_DataNode(x$4.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().Encodes$1));
            var location = $f_Lamf_core_model_domain_AmfElement__location__s_Option(this$10)
          };
          var elem = new $c_Lamf_core_validation_AMFValidationResult().init___T__T__T__s_Option__T__s_Option__s_Option__O(message, level, targetNode, targetProperty, validationId, position, location, arg1);
          array$1.push(elem);
          i = ((1 + i) | 0)
        };
        var results = new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)
      } else {
        var results = $m_sci_Nil$()
      };
      return validationProcessor.processResults__sc_Seq__O(results)
    }
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 instanceof $c_sjs_js_JavaScriptException)) {
      var e$3 = $as_sjs_js_JavaScriptException(e$2);
      if (fragment.isEmpty__Z()) {
        var jsx$1 = $m_s_None$()
      } else {
        var arg1$5 = fragment.get__O();
        var x$5 = $as_Lamf_core_model_document_PayloadFragment(arg1$5);
        var jsx$1 = new $c_s_Some().init___O($as_Lamf_core_model_domain_DataNode(x$5.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().Encodes$1)))
      };
      return validationProcessor.processException__jl_Throwable__s_Option__O(e$3, jsx$1)
    } else {
      throw e
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_remote_JsPayloadValidator.prototype.loadDataNodeString__Lamf_core_model_document_PayloadFragment__s_Option = (function(payload) {
  try {
    var this$1 = this.literalRepresentation__Lamf_core_model_document_PayloadFragment__s_Option(payload);
    if (this$1.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1 = this$1.get__O();
      var payloadText = $as_T(arg1);
      return new $c_s_Some().init___O(this.loadJson__T__sjs_js_Dynamic(payloadText))
    }
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      if ((e$2 instanceof $c_Lamf_plugins_document_webapi_validation_remote_ExampleUnknownException)) {
        return $m_s_None$()
      };
      if ((e$2 instanceof $c_sjs_js_JavaScriptException)) {
        var x10 = $as_sjs_js_JavaScriptException(e$2);
        if ($uZ((x10.exception$4 instanceof $g.SyntaxError))) {
          throw new $c_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject().init___jl_Throwable(x10)
        }
      };
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(e$2)
    } else {
      throw e
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_remote_JsPayloadValidator.prototype.init___Lamf_core_model_domain_Shape__Lamf_client_plugins_ValidationMode__Lamf_internal_environment_Environment = (function(shape, validationMode, env) {
  this.shape$2 = shape;
  this.validationMode$2 = validationMode;
  this.env$2 = env;
  $c_Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator.prototype.init___Lamf_core_model_domain_Shape__Lamf_internal_environment_Environment.call(this, shape, env);
  return this
});
$c_Lamf_plugins_document_webapi_validation_remote_JsPayloadValidator.prototype.loadJson__T__sjs_js_Dynamic = (function(str) {
  try {
    return $g.JSON.parse(str)
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      if ((e$2 instanceof $c_sjs_js_JavaScriptException)) {
        var x5 = $as_sjs_js_JavaScriptException(e$2);
        if ($uZ((x5.exception$4 instanceof $g.SyntaxError))) {
          throw new $c_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject().init___jl_Throwable(x5)
        }
      };
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(e$2)
    } else {
      throw e
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_remote_JsPayloadValidator.prototype.makeValidationMessage__p2__Lamf_plugins_document_webapi_validation_remote_ValidationResult__T = (function(validationResult) {
  var pointer = $as_T(validationResult.dataPath);
  var thiz = pointer;
  if ((($uI(thiz.length) >= 0) && ($as_T(thiz.substring(0, $uI(".".length))) === "."))) {
    pointer = $m_sjsr_RuntimeString$().replaceFirst__T__T__T__T(pointer, "\\.", "")
  };
  var thiz$1 = ((pointer + " ") + $as_T(validationResult.message));
  return $as_T(thiz$1.trim())
});
var $d_Lamf_plugins_document_webapi_validation_remote_JsPayloadValidator = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_remote_JsPayloadValidator: 0
}, false, "amf.plugins.document.webapi.validation.remote.JsPayloadValidator", {
  Lamf_plugins_document_webapi_validation_remote_JsPayloadValidator: 1,
  Lamf_plugins_document_webapi_validation_remote_PlatformPayloadValidator: 1,
  O: 1,
  Lamf_core_validation_PayloadValidator: 1
});
$c_Lamf_plugins_document_webapi_validation_remote_JsPayloadValidator.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_remote_JsPayloadValidator;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$() {
  $c_Lamf_client_plugins_AMFDomainPlugin.call(this);
  this.ID$2 = null
}
$c_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$.prototype = new $h_Lamf_client_plugins_AMFDomainPlugin();
$c_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$.prototype.constructor = $c_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$.prototype = $c_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$.prototype;
$c_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$.prototype.init___ = (function() {
  this.ID$2 = "Data Shapes Domain";
  return this
});
$c_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$.prototype.init__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
    return (function() {
      return $m_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$()
    })
  })(this)), executionContext)
});
$c_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$.prototype.modelEntities__sc_Seq = (function() {
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$(), $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$(), $m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$(), $m_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$(), $m_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$(), $m_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$(), $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$(), $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$(), $m_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$(), $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$(), $m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$(), $m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$(), $m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$(), $m_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$(), $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$()];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$.prototype.ID__T = (function() {
  return this.ID$2
});
$c_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$.prototype.dependencies__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$.prototype.serializableAnnotations__sci_Map = (function() {
  var y = $m_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression$();
  var jsx$3 = new $c_T2().init___O__O("type-expression", y);
  var y$1 = $m_Lamf_core_annotations_InheritanceProvenance$();
  var jsx$2 = new $c_T2().init___O__O("inheritance-provenance", y$1);
  var y$2 = $m_Lamf_core_annotations_InheritedShapes$();
  var jsx$1 = new $c_T2().init___O__O("inherited-shapes", y$2);
  var y$3 = $m_Lamf_core_annotations_NilUnion$();
  var array = [jsx$3, jsx$2, jsx$1, new $c_T2().init___O__O("nil-union", y$3)];
  var this$12 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$12.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  return $as_sci_Map(this$12.elems$1)
});
var $d_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_DataShapesDomainPlugin$: 0
}, false, "amf.plugins.domain.shapes.DataShapesDomainPlugin$", {
  Lamf_plugins_domain_shapes_DataShapesDomainPlugin$: 1,
  Lamf_client_plugins_AMFDomainPlugin: 1,
  O: 1,
  Lamf_client_plugins_AMFPlugin: 1
});
$c_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$.prototype.$classData = $d_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$;
var $n_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$ = (void 0);
function $m_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$() {
  if ((!$n_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$)) {
    $n_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$ = new $c_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_ArrayShape$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_ArrayShape$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_ArrayShape$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_ArrayShape$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_ArrayShape$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_ArrayShape$.prototype = $c_Lamf_plugins_domain_shapes_models_ArrayShape$.prototype;
$c_Lamf_plugins_domain_shapes_models_ArrayShape$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_models_ArrayShape$.prototype.apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_ArrayShape = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  return new $c_Lamf_plugins_domain_shapes_models_ArrayShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_domain_shapes_models_ArrayShape$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_ArrayShape$: 0
}, false, "amf.plugins.domain.shapes.models.ArrayShape$", {
  Lamf_plugins_domain_shapes_models_ArrayShape$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_ArrayShape$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_ArrayShape$;
var $n_Lamf_plugins_domain_shapes_models_ArrayShape$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_ArrayShape$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_ArrayShape$)) {
    $n_Lamf_plugins_domain_shapes_models_ArrayShape$ = new $c_Lamf_plugins_domain_shapes_models_ArrayShape$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_ArrayShape$
}
function $f_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement__withExample__s_Option__Lamf_plugins_domain_shapes_models_Example($thiz, name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var example = new $c_Lamf_plugins_domain_shapes_models_Example().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  if ((!name.isEmpty__Z())) {
    var arg1 = name.get__O();
    var x$1 = $as_T(arg1);
    $m_Lamf_core_parser_Annotations$();
    var a = new $c_Lamf_core_parser_Annotations().init___();
    $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(example, x$1, a))
  };
  var field = $m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject($thiz, field, example);
  return example
}
function $is_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement)))
}
function $as_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement(obj) {
  return (($is_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.models.ExemplifiedDomainElement"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.models.ExemplifiedDomainElement;", depth))
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_FileShape$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_FileShape$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_FileShape$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_FileShape$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_FileShape$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_FileShape$.prototype = $c_Lamf_plugins_domain_shapes_models_FileShape$.prototype;
$c_Lamf_plugins_domain_shapes_models_FileShape$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_models_FileShape$.prototype.apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_FileShape = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  return new $c_Lamf_plugins_domain_shapes_models_FileShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_domain_shapes_models_FileShape$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_FileShape$: 0
}, false, "amf.plugins.domain.shapes.models.FileShape$", {
  Lamf_plugins_domain_shapes_models_FileShape$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_FileShape$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_FileShape$;
var $n_Lamf_plugins_domain_shapes_models_FileShape$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_FileShape$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_FileShape$)) {
    $n_Lamf_plugins_domain_shapes_models_FileShape$ = new $c_Lamf_plugins_domain_shapes_models_FileShape$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_FileShape$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_NilShape$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_NilShape$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_NilShape$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_NilShape$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_NilShape$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_NilShape$.prototype = $c_Lamf_plugins_domain_shapes_models_NilShape$.prototype;
$c_Lamf_plugins_domain_shapes_models_NilShape$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_models_NilShape$.prototype.apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_NilShape = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  return new $c_Lamf_plugins_domain_shapes_models_NilShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_domain_shapes_models_NilShape$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_NilShape$: 0
}, false, "amf.plugins.domain.shapes.models.NilShape$", {
  Lamf_plugins_domain_shapes_models_NilShape$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_NilShape$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_NilShape$;
var $n_Lamf_plugins_domain_shapes_models_NilShape$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_NilShape$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_NilShape$)) {
    $n_Lamf_plugins_domain_shapes_models_NilShape$ = new $c_Lamf_plugins_domain_shapes_models_NilShape$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_NilShape$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_NodeShape$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_NodeShape$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_NodeShape$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_NodeShape$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_NodeShape$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_NodeShape$.prototype = $c_Lamf_plugins_domain_shapes_models_NodeShape$.prototype;
$c_Lamf_plugins_domain_shapes_models_NodeShape$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_models_NodeShape$.prototype.apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_NodeShape = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  return new $c_Lamf_plugins_domain_shapes_models_NodeShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_domain_shapes_models_NodeShape$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_NodeShape$: 0
}, false, "amf.plugins.domain.shapes.models.NodeShape$", {
  Lamf_plugins_domain_shapes_models_NodeShape$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_NodeShape$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_NodeShape$;
var $n_Lamf_plugins_domain_shapes_models_NodeShape$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_NodeShape$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_NodeShape$)) {
    $n_Lamf_plugins_domain_shapes_models_NodeShape$ = new $c_Lamf_plugins_domain_shapes_models_NodeShape$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_NodeShape$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_PropertyDependencies$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_PropertyDependencies$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_PropertyDependencies$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_PropertyDependencies$.prototype = $c_Lamf_plugins_domain_shapes_models_PropertyDependencies$.prototype;
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies$.prototype.apply__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_shapes_models_PropertyDependencies = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  return new $c_Lamf_plugins_domain_shapes_models_PropertyDependencies().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_domain_shapes_models_PropertyDependencies$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_PropertyDependencies$: 0
}, false, "amf.plugins.domain.shapes.models.PropertyDependencies$", {
  Lamf_plugins_domain_shapes_models_PropertyDependencies$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_PropertyDependencies$;
var $n_Lamf_plugins_domain_shapes_models_PropertyDependencies$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_PropertyDependencies$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_PropertyDependencies$)) {
    $n_Lamf_plugins_domain_shapes_models_PropertyDependencies$ = new $c_Lamf_plugins_domain_shapes_models_PropertyDependencies$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_PropertyDependencies$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_ScalarShape$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_ScalarShape$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_ScalarShape$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_ScalarShape$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_ScalarShape$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_ScalarShape$.prototype = $c_Lamf_plugins_domain_shapes_models_ScalarShape$.prototype;
$c_Lamf_plugins_domain_shapes_models_ScalarShape$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_models_ScalarShape$.prototype.apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_ScalarShape = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  return new $c_Lamf_plugins_domain_shapes_models_ScalarShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_domain_shapes_models_ScalarShape$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_ScalarShape$: 0
}, false, "amf.plugins.domain.shapes.models.ScalarShape$", {
  Lamf_plugins_domain_shapes_models_ScalarShape$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_ScalarShape$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_ScalarShape$;
var $n_Lamf_plugins_domain_shapes_models_ScalarShape$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_ScalarShape$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_ScalarShape$)) {
    $n_Lamf_plugins_domain_shapes_models_ScalarShape$ = new $c_Lamf_plugins_domain_shapes_models_ScalarShape$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_ScalarShape$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_SchemaShape$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_SchemaShape$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_SchemaShape$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_SchemaShape$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_SchemaShape$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_SchemaShape$.prototype = $c_Lamf_plugins_domain_shapes_models_SchemaShape$.prototype;
$c_Lamf_plugins_domain_shapes_models_SchemaShape$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_models_SchemaShape$.prototype.apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_SchemaShape = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  return new $c_Lamf_plugins_domain_shapes_models_SchemaShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_domain_shapes_models_SchemaShape$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_SchemaShape$: 0
}, false, "amf.plugins.domain.shapes.models.SchemaShape$", {
  Lamf_plugins_domain_shapes_models_SchemaShape$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_SchemaShape$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_SchemaShape$;
var $n_Lamf_plugins_domain_shapes_models_SchemaShape$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_SchemaShape$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_SchemaShape$)) {
    $n_Lamf_plugins_domain_shapes_models_SchemaShape$ = new $c_Lamf_plugins_domain_shapes_models_SchemaShape$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_SchemaShape$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TupleShape$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TupleShape$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TupleShape$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TupleShape$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TupleShape$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TupleShape$.prototype = $c_Lamf_plugins_domain_shapes_models_TupleShape$.prototype;
$c_Lamf_plugins_domain_shapes_models_TupleShape$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_models_TupleShape$.prototype.apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_TupleShape = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  return new $c_Lamf_plugins_domain_shapes_models_TupleShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_domain_shapes_models_TupleShape$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TupleShape$: 0
}, false, "amf.plugins.domain.shapes.models.TupleShape$", {
  Lamf_plugins_domain_shapes_models_TupleShape$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_TupleShape$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TupleShape$;
var $n_Lamf_plugins_domain_shapes_models_TupleShape$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TupleShape$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TupleShape$)) {
    $n_Lamf_plugins_domain_shapes_models_TupleShape$ = new $c_Lamf_plugins_domain_shapes_models_TupleShape$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TupleShape$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$BinaryType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1,
  Lamf_plugins_domain_shapes_models_ScalarType: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$BinaryType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$BoolType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$BoolType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$BoolType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1,
  Lamf_plugins_domain_shapes_models_ScalarType: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$ByteType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$ByteType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$ByteType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1,
  Lamf_plugins_domain_shapes_models_ScalarType: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$ByteType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$DateOnlyType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1,
  Lamf_plugins_domain_shapes_models_ScalarType: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$DateOnlyType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$DateTimeOnlyType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1,
  Lamf_plugins_domain_shapes_models_ScalarType: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeOnlyType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$DateTimeType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1,
  Lamf_plugins_domain_shapes_models_ScalarType: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$DoubleType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1,
  Lamf_plugins_domain_shapes_models_ScalarType: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$FileType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$FileType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$FileType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$FileType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$FileType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$FileType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$FileType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$FileType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$FileType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$FileType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$FileType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$FileType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1,
  Lamf_plugins_domain_shapes_models_ScalarType: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$FileType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$FileType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$FileType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$FileType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$FileType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$FileType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$FileType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$FileType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$FloatType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$FloatType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$FloatType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1,
  Lamf_plugins_domain_shapes_models_ScalarType: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$IntType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$IntType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$IntType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$IntType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$IntType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$IntType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$IntType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$IntType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$IntType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$IntType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$IntType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$IntType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1,
  Lamf_plugins_domain_shapes_models_ScalarType: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$IntType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$IntType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$IntType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$IntType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$IntType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$IntType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$IntType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$IntType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$LongType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$LongType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$LongType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$LongType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$LongType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$LongType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$LongType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$LongType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$LongType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$LongType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$LongType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$LongType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1,
  Lamf_plugins_domain_shapes_models_ScalarType: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$LongType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$LongType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$LongType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$LongType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$LongType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$LongType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$LongType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$LongType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$NilType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$NilType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$NilType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$NilType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$NilType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$NilType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$NilType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$NilType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$NilType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$NilType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$NilType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$NilType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1,
  Lamf_plugins_domain_shapes_models_ScalarType: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$NilType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$NilType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$NilType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$NilType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$NilType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$NilType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$NilType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$NilType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$NumberType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$NumberType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$NumberType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1,
  Lamf_plugins_domain_shapes_models_ScalarType: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$PasswordType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1,
  Lamf_plugins_domain_shapes_models_ScalarType: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$PasswordType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$StrType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$StrType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$StrType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$StrType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$StrType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$StrType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$StrType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$StrType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$StrType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$StrType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$StrType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$StrType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1,
  Lamf_plugins_domain_shapes_models_ScalarType: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$StrType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$StrType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$StrType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$StrType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$StrType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$StrType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$StrType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$StrType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$.prototype = $c_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$.prototype;
$c_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$.prototype.init___ = (function() {
  return this
});
var $d_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$: 0
}, false, "amf.plugins.domain.shapes.models.TypeDef$TimeOnlyType$", {
  Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_models_TypeDef: 1,
  Lamf_plugins_domain_shapes_models_ScalarType: 1
});
$c_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$;
var $n_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$)) {
    $n_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$ = new $c_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_TypeDef$TimeOnlyType$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_UnionShape$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_UnionShape$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_UnionShape$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_UnionShape$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_UnionShape$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_UnionShape$.prototype = $c_Lamf_plugins_domain_shapes_models_UnionShape$.prototype;
$c_Lamf_plugins_domain_shapes_models_UnionShape$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_models_UnionShape$.prototype.apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_UnionShape = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  return new $c_Lamf_plugins_domain_shapes_models_UnionShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_domain_shapes_models_UnionShape$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_UnionShape$: 0
}, false, "amf.plugins.domain.shapes.models.UnionShape$", {
  Lamf_plugins_domain_shapes_models_UnionShape$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_UnionShape$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_UnionShape$;
var $n_Lamf_plugins_domain_shapes_models_UnionShape$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_UnionShape$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_UnionShape$)) {
    $n_Lamf_plugins_domain_shapes_models_UnionShape$ = new $c_Lamf_plugins_domain_shapes_models_UnionShape$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_UnionShape$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_UnresolvedShape$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_UnresolvedShape$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_UnresolvedShape$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_UnresolvedShape$.prototype = $c_Lamf_plugins_domain_shapes_models_UnresolvedShape$.prototype;
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$.prototype.apply__T__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_UnresolvedShape = (function(reference, ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  var extensionParser = $m_s_None$();
  return new $c_Lamf_plugins_domain_shapes_models_UnresolvedShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations__T__s_Option__s_Option__Z(new $c_Lamf_core_parser_Fields().init___(), annotations, reference, extensionParser, $m_s_None$(), true)
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$.prototype.apply__T__s_Option__Lamf_plugins_domain_shapes_models_UnresolvedShape = (function(reference, ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations($as_Lorg_yaml_model_YPart((ast.isEmpty__Z() ? $m_Lorg_yaml_model_YNode$().Null$1 : ast.get__O())));
  var extensionParser = $m_s_None$();
  return new $c_Lamf_plugins_domain_shapes_models_UnresolvedShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations__T__s_Option__s_Option__Z(new $c_Lamf_core_parser_Fields().init___(), annotations, reference, extensionParser, $m_s_None$(), true)
});
var $d_Lamf_plugins_domain_shapes_models_UnresolvedShape$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_UnresolvedShape$: 0
}, false, "amf.plugins.domain.shapes.models.UnresolvedShape$", {
  Lamf_plugins_domain_shapes_models_UnresolvedShape$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_UnresolvedShape$;
var $n_Lamf_plugins_domain_shapes_models_UnresolvedShape$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_UnresolvedShape$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_UnresolvedShape$)) {
    $n_Lamf_plugins_domain_shapes_models_UnresolvedShape$ = new $c_Lamf_plugins_domain_shapes_models_UnresolvedShape$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_UnresolvedShape$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_XMLSerializer$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_models_XMLSerializer$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_XMLSerializer$.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_XMLSerializer$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_XMLSerializer$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_XMLSerializer$.prototype = $c_Lamf_plugins_domain_shapes_models_XMLSerializer$.prototype;
$c_Lamf_plugins_domain_shapes_models_XMLSerializer$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer$.prototype.apply__Lorg_yaml_model_YNode__Lamf_plugins_domain_shapes_models_XMLSerializer = (function(node) {
  var annotations = $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(node);
  return new $c_Lamf_plugins_domain_shapes_models_XMLSerializer().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_domain_shapes_models_XMLSerializer$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_XMLSerializer$: 0
}, false, "amf.plugins.domain.shapes.models.XMLSerializer$", {
  Lamf_plugins_domain_shapes_models_XMLSerializer$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer$.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_XMLSerializer$;
var $n_Lamf_plugins_domain_shapes_models_XMLSerializer$ = (void 0);
function $m_Lamf_plugins_domain_shapes_models_XMLSerializer$() {
  if ((!$n_Lamf_plugins_domain_shapes_models_XMLSerializer$)) {
    $n_Lamf_plugins_domain_shapes_models_XMLSerializer$ = new $c_Lamf_plugins_domain_shapes_models_XMLSerializer$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_models_XMLSerializer$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$.prototype.apply__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_domain_shapes_models_AnyShape = (function(any) {
  return new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster().init___Lamf_plugins_domain_shapes_models_AnyShape(any).adjust__Lamf_plugins_domain_shapes_models_AnyShape()
});
var $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.AnyShapeAdjuster$", {
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$;
var $n_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$ = (void 0);
function $m_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$() {
  if ((!$n_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$)) {
    $n_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$ = new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$.prototype.apply__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext__Lamf_core_model_domain_Shape = (function(s, context) {
  var this$1 = new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer().init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext(context);
  return $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeNormalizer__normalize__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(this$1, s)
});
var $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.ShapeCanonizer$", {
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$;
var $n_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$ = (void 0);
function $m_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$() {
  if ((!$n_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$)) {
    $n_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$ = new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$.prototype.apply__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext__Lamf_plugins_domain_shapes_resolution_stages_recursion_RecursionErrorRegister__Lamf_core_model_domain_Shape = (function(s, context, recursionRegister) {
  var this$1 = new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander().init___Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_resolution_stages_recursion_RecursionErrorRegister__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext(s, recursionRegister, context);
  var shape = this$1.root$1;
  return $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeNormalizer__normalize__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(this$1, shape)
});
var $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.ShapeExpander$", {
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$;
var $n_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$ = (void 0);
function $m_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$() {
  if ((!$n_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$)) {
    $n_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$ = new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$() {
  $c_Lamf_client_plugins_AMFDomainPlugin.call(this);
  this.ID$2 = null
}
$c_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$.prototype = new $h_Lamf_client_plugins_AMFDomainPlugin();
$c_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$.prototype.constructor = $c_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$.prototype = $c_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$.prototype;
$c_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$.prototype.init___ = (function() {
  this.ID$2 = "WebAPI Domain";
  return this
});
$c_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$.prototype.init__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
    return (function() {
      return $m_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$()
    })
  })(this)), executionContext)
});
$c_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$.prototype.modelEntities__sc_Seq = (function() {
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$(), $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$(), $m_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$(), $m_Lamf_plugins_domain_webapi_metamodel_LicenseModel$(), $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$(), $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$(), $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$(), $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$(), $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$(), $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$(), $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$(), $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$(), $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$(), $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$(), $m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$(), $m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$(), $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$(), $m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$(), $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$(), $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$(), $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$(), $m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$(), $m_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$(), $m_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$(), $m_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$(), $m_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$(), $m_Lamf_plugins_domain_webapi_metamodel_TagModel$(), $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$(), $m_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$(), $m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$(), $m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$(), $m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$(), $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$(), $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$(), $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$(), $m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$(), $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$(), $m_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$(), $m_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$(), $m_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$(), $m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$(), $m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$(), $m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$(), $m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$(), $m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$(), $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$(), $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$(), $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$(), $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$(), $m_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$(), $m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$()];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$.prototype.ID__T = (function() {
  return this.ID$2
});
$c_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$.prototype.dependencies__sc_Seq = (function() {
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$()];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$.prototype.serializableAnnotations__sci_Map = (function() {
  var y = $m_Lamf_plugins_domain_webapi_annotations_ParentEndPoint$();
  var jsx$4 = new $c_T2().init___O__O("parent-end-point", y);
  var y$1 = $m_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension$();
  var jsx$3 = new $c_T2().init___O__O("orphan-oas-extension", y$1);
  var y$2 = $m_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo$();
  var jsx$2 = new $c_T2().init___O__O("type-property-lexical-info", y$2);
  var y$3 = $m_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo$();
  var jsx$1 = new $c_T2().init___O__O("parameter-binding-in-body-lexical-info", y$3);
  var y$4 = $m_Lamf_plugins_domain_webapi_annotations_InvalidBinding$();
  var array = [jsx$4, jsx$3, jsx$2, jsx$1, new $c_T2().init___O__O("invalid-binding", y$4)];
  var this$14 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$14.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  return $as_sci_Map(this$14.elems$1)
});
var $d_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_WebAPIDomainPlugin$: 0
}, false, "amf.plugins.domain.webapi.WebAPIDomainPlugin$", {
  Lamf_plugins_domain_webapi_WebAPIDomainPlugin$: 1,
  Lamf_client_plugins_AMFDomainPlugin: 1,
  O: 1,
  Lamf_client_plugins_AMFPlugin: 1
});
$c_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$.prototype.$classData = $d_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$;
var $n_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$ = (void 0);
function $m_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$() {
  if ((!$n_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$)) {
    $n_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$ = new $c_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_IriTemplateMapping$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping$.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_IriTemplateMapping$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_IriTemplateMapping$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_IriTemplateMapping$.prototype = $c_Lamf_plugins_domain_webapi_models_IriTemplateMapping$.prototype;
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping$.prototype.apply__T__T__Lamf_plugins_domain_webapi_models_IriTemplateMapping = (function(variable, linkExpression) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$3 = new $c_Lamf_plugins_domain_webapi_models_IriTemplateMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$().TemplateVariable$1;
  var this$4 = $as_Lamf_plugins_domain_webapi_models_IriTemplateMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$3, field, variable));
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$().LinkExpression$1;
  return $as_Lamf_plugins_domain_webapi_models_IriTemplateMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field$1, linkExpression))
});
var $d_Lamf_plugins_domain_webapi_models_IriTemplateMapping$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_IriTemplateMapping$: 0
}, false, "amf.plugins.domain.webapi.models.IriTemplateMapping$", {
  Lamf_plugins_domain_webapi_models_IriTemplateMapping$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping$.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_IriTemplateMapping$;
var $n_Lamf_plugins_domain_webapi_models_IriTemplateMapping$ = (void 0);
function $m_Lamf_plugins_domain_webapi_models_IriTemplateMapping$() {
  if ((!$n_Lamf_plugins_domain_webapi_models_IriTemplateMapping$)) {
    $n_Lamf_plugins_domain_webapi_models_IriTemplateMapping$ = new $c_Lamf_plugins_domain_webapi_models_IriTemplateMapping$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_models_IriTemplateMapping$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_License$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_models_License$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_License$.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_License$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_License$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_License$.prototype = $c_Lamf_plugins_domain_webapi_models_License$.prototype;
$c_Lamf_plugins_domain_webapi_models_License$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_models_License$.prototype.apply__Lorg_yaml_model_YNode__Lamf_plugins_domain_webapi_models_License = (function(node) {
  var annotations = $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(node);
  return new $c_Lamf_plugins_domain_webapi_models_License().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_domain_webapi_models_License$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_License$: 0
}, false, "amf.plugins.domain.webapi.models.License$", {
  Lamf_plugins_domain_webapi_models_License$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_License$.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_License$;
var $n_Lamf_plugins_domain_webapi_models_License$ = (void 0);
function $m_Lamf_plugins_domain_webapi_models_License$() {
  if ((!$n_Lamf_plugins_domain_webapi_models_License$)) {
    $n_Lamf_plugins_domain_webapi_models_License$ = new $c_Lamf_plugins_domain_webapi_models_License$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_models_License$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_Organization$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_models_Organization$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_Organization$.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_Organization$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_Organization$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_Organization$.prototype = $c_Lamf_plugins_domain_webapi_models_Organization$.prototype;
$c_Lamf_plugins_domain_webapi_models_Organization$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_models_Organization$.prototype.apply__Lorg_yaml_model_YNode__Lamf_plugins_domain_webapi_models_Organization = (function(node) {
  var annotations = $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(node);
  return new $c_Lamf_plugins_domain_webapi_models_Organization().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_domain_webapi_models_Organization$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_Organization$: 0
}, false, "amf.plugins.domain.webapi.models.Organization$", {
  Lamf_plugins_domain_webapi_models_Organization$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_Organization$.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_Organization$;
var $n_Lamf_plugins_domain_webapi_models_Organization$ = (void 0);
function $m_Lamf_plugins_domain_webapi_models_Organization$() {
  if ((!$n_Lamf_plugins_domain_webapi_models_Organization$)) {
    $n_Lamf_plugins_domain_webapi_models_Organization$ = new $c_Lamf_plugins_domain_webapi_models_Organization$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_models_Organization$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_Payload$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_models_Payload$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_Payload$.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_Payload$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_Payload$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_Payload$.prototype = $c_Lamf_plugins_domain_webapi_models_Payload$.prototype;
$c_Lamf_plugins_domain_webapi_models_Payload$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_models_Payload$.prototype.apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_Payload = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  return new $c_Lamf_plugins_domain_webapi_models_Payload().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_domain_webapi_models_Payload$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_Payload$: 0
}, false, "amf.plugins.domain.webapi.models.Payload$", {
  Lamf_plugins_domain_webapi_models_Payload$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_Payload$.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_Payload$;
var $n_Lamf_plugins_domain_webapi_models_Payload$ = (void 0);
function $m_Lamf_plugins_domain_webapi_models_Payload$() {
  if ((!$n_Lamf_plugins_domain_webapi_models_Payload$)) {
    $n_Lamf_plugins_domain_webapi_models_Payload$ = new $c_Lamf_plugins_domain_webapi_models_Payload$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_models_Payload$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_Server$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_models_Server$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_Server$.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_Server$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_Server$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_Server$.prototype = $c_Lamf_plugins_domain_webapi_models_Server$.prototype;
$c_Lamf_plugins_domain_webapi_models_Server$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_models_Server$.prototype.apply__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Server = (function(ast) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  return new $c_Lamf_plugins_domain_webapi_models_Server().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_domain_webapi_models_Server$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_Server$: 0
}, false, "amf.plugins.domain.webapi.models.Server$", {
  Lamf_plugins_domain_webapi_models_Server$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_Server$.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_Server$;
var $n_Lamf_plugins_domain_webapi_models_Server$ = (void 0);
function $m_Lamf_plugins_domain_webapi_models_Server$() {
  if ((!$n_Lamf_plugins_domain_webapi_models_Server$)) {
    $n_Lamf_plugins_domain_webapi_models_Server$ = new $c_Lamf_plugins_domain_webapi_models_Server$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_models_Server$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_Tag$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_models_Tag$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_Tag$.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_Tag$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_Tag$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_Tag$.prototype = $c_Lamf_plugins_domain_webapi_models_Tag$.prototype;
$c_Lamf_plugins_domain_webapi_models_Tag$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_models_Tag$.prototype.apply__Lorg_yaml_model_YNode__Lamf_plugins_domain_webapi_models_Tag = (function(node) {
  var annotations = $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(node);
  return new $c_Lamf_plugins_domain_webapi_models_Tag().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_domain_webapi_models_Tag$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_Tag$: 0
}, false, "amf.plugins.domain.webapi.models.Tag$", {
  Lamf_plugins_domain_webapi_models_Tag$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_Tag$.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_Tag$;
var $n_Lamf_plugins_domain_webapi_models_Tag$ = (void 0);
function $m_Lamf_plugins_domain_webapi_models_Tag$() {
  if ((!$n_Lamf_plugins_domain_webapi_models_Tag$)) {
    $n_Lamf_plugins_domain_webapi_models_Tag$ = new $c_Lamf_plugins_domain_webapi_models_Tag$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_models_Tag$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_WebApi$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_models_WebApi$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_WebApi$.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_WebApi$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_WebApi$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_WebApi$.prototype = $c_Lamf_plugins_domain_webapi_models_WebApi$.prototype;
$c_Lamf_plugins_domain_webapi_models_WebApi$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_models_WebApi$.prototype.apply__Lorg_yaml_model_YNode__Lamf_plugins_domain_webapi_models_WebApi = (function(node) {
  var annotations = $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(node);
  return new $c_Lamf_plugins_domain_webapi_models_WebApi().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_domain_webapi_models_WebApi$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_WebApi$: 0
}, false, "amf.plugins.domain.webapi.models.WebApi$", {
  Lamf_plugins_domain_webapi_models_WebApi$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_WebApi$.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_WebApi$;
var $n_Lamf_plugins_domain_webapi_models_WebApi$ = (void 0);
function $m_Lamf_plugins_domain_webapi_models_WebApi$() {
  if ((!$n_Lamf_plugins_domain_webapi_models_WebApi$)) {
    $n_Lamf_plugins_domain_webapi_models_WebApi$ = new $c_Lamf_plugins_domain_webapi_models_WebApi$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_models_WebApi$
}
function $is_Lamf_plugins_domain_webapi_models_bindings_BindingVersion(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_domain_webapi_models_bindings_BindingVersion)))
}
function $as_Lamf_plugins_domain_webapi_models_bindings_BindingVersion(obj) {
  return (($is_Lamf_plugins_domain_webapi_models_bindings_BindingVersion(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.BindingVersion"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_BindingVersion(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_BindingVersion)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_BindingVersion(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_BindingVersion(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.BindingVersion;", depth))
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$.prototype = $c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$.prototype;
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$.prototype.apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_security_OAuth2Flow = (function(part) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(part);
  return new $c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_security_OAuth2Flow$: 0
}, false, "amf.plugins.domain.webapi.models.security.OAuth2Flow$", {
  Lamf_plugins_domain_webapi_models_security_OAuth2Flow$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$;
var $n_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$ = (void 0);
function $m_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$() {
  if ((!$n_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$)) {
    $n_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$ = new $c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_security_Scope$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_models_security_Scope$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_security_Scope$.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_security_Scope$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_security_Scope$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_security_Scope$.prototype = $c_Lamf_plugins_domain_webapi_models_security_Scope$.prototype;
$c_Lamf_plugins_domain_webapi_models_security_Scope$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_models_security_Scope$.prototype.apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_security_Scope = (function(part) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(part);
  return new $c_Lamf_plugins_domain_webapi_models_security_Scope().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
var $d_Lamf_plugins_domain_webapi_models_security_Scope$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_security_Scope$: 0
}, false, "amf.plugins.domain.webapi.models.security.Scope$", {
  Lamf_plugins_domain_webapi_models_security_Scope$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_security_Scope$.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_security_Scope$;
var $n_Lamf_plugins_domain_webapi_models_security_Scope$ = (void 0);
function $m_Lamf_plugins_domain_webapi_models_security_Scope$() {
  if ((!$n_Lamf_plugins_domain_webapi_models_security_Scope$)) {
    $n_Lamf_plugins_domain_webapi_models_security_Scope$ = new $c_Lamf_plugins_domain_webapi_models_security_Scope$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_models_security_Scope$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage() {
  $c_Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage.call(this);
  this.errorHandler$3 = null
}
$c_Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage.prototype = new $h_Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage();
$c_Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage.prototype.resolve__Lamf_plugins_domain_webapi_models_WebApi__Lamf_plugins_domain_webapi_models_WebApi = (function(webApi) {
  $as_sc_Seq(webApi.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(endpoint$2) {
      var endpoint = $as_Lamf_plugins_domain_webapi_models_EndPoint(endpoint$2);
      var jsx$1 = $m_Lamf_plugins_document_webapi_parser_spec_domain_Parameters$();
      var this$1 = $as_Lamf_core_model_StrField(endpoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1));
      var this$2 = this$1.option$1;
      var finalParams = jsx$1.classified__T__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_parser_spec_domain_Parameters($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())), $as_sc_Seq(endpoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1)), $m_sci_Nil$());
      if ((finalParams.nonEmpty__Z() && $as_sc_Seq(endpoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1)).nonEmpty__Z())) {
        endpoint.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1);
        $this.pushParamsToEndpointOperations__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_document_webapi_parser_spec_domain_Parameters__V(endpoint, finalParams)
      }
    })
  })(this)));
  return webApi
});
$c_Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  this.errorHandler$3 = errorHandler;
  $m_Lamf_OasProfile$();
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.OpenApiParametersNormalizationStage", {
  Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage: 1,
  Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_OpenApiParametersNormalizationStage;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_Raml10ParametersNormalizationStage() {
  $c_Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage.call(this);
  this.errorHandler$3 = null
}
$c_Lamf_plugins_domain_webapi_resolution_stages_Raml10ParametersNormalizationStage.prototype = new $h_Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage();
$c_Lamf_plugins_domain_webapi_resolution_stages_Raml10ParametersNormalizationStage.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_Raml10ParametersNormalizationStage;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_Raml10ParametersNormalizationStage() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_Raml10ParametersNormalizationStage.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_Raml10ParametersNormalizationStage.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_Raml10ParametersNormalizationStage.prototype.resolve__Lamf_plugins_domain_webapi_models_WebApi__Lamf_plugins_domain_webapi_models_WebApi = (function(webApi) {
  $as_sc_Seq(webApi.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(endpoint$2) {
      var endpoint = $as_Lamf_plugins_domain_webapi_models_EndPoint(endpoint$2);
      var endpointParameters = $as_sc_Seq(endpoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1));
      var x1 = endpointParameters.partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
        return (function(p$2) {
          var p = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2);
          var this$1 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
          return $f_Lamf_core_model_ValueField__is__O__Z(this$1, "path")
        })
      })($this)));
      if ((x1 === null)) {
        throw new $c_s_MatchError().init___O(x1)
      };
      var path = $as_sc_Seq(x1.$$und1__O());
      var other = $as_sc_Seq(x1.$$und2__O());
      var jsx$1 = $m_Lamf_plugins_document_webapi_parser_spec_domain_Parameters$();
      var this$2 = $as_Lamf_core_model_StrField(endpoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1));
      var this$3 = this$2.option$1;
      var finalParams = jsx$1.classified__T__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_parser_spec_domain_Parameters($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())), other, $m_sci_Nil$());
      if ((finalParams.nonEmpty__Z() && $as_sc_Seq(endpoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1)).nonEmpty__Z())) {
        endpoint.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1);
        $this.assignPathParametersTo__Lamf_plugins_domain_webapi_models_EndPoint__sc_Seq__O(endpoint, path);
        $this.pushParamsToEndpointOperations__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_document_webapi_parser_spec_domain_Parameters__V(endpoint, finalParams)
      }
    })
  })(this)));
  return webApi
});
$c_Lamf_plugins_domain_webapi_resolution_stages_Raml10ParametersNormalizationStage.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  this.errorHandler$3 = errorHandler;
  $m_Lamf_AmfProfile$();
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_domain_webapi_resolution_stages_Raml10ParametersNormalizationStage = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_Raml10ParametersNormalizationStage: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.Raml10ParametersNormalizationStage", {
  Lamf_plugins_domain_webapi_resolution_stages_Raml10ParametersNormalizationStage: 1,
  Lamf_plugins_domain_webapi_resolution_stages_ParametersNormalizationStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_Raml10ParametersNormalizationStage.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_Raml10ParametersNormalizationStage;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_RamlCompatiblePayloadAndParameterResolutionStage() {
  $c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage.call(this)
}
$c_Lamf_plugins_domain_webapi_resolution_stages_RamlCompatiblePayloadAndParameterResolutionStage.prototype = new $h_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage();
$c_Lamf_plugins_domain_webapi_resolution_stages_RamlCompatiblePayloadAndParameterResolutionStage.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_RamlCompatiblePayloadAndParameterResolutionStage;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_RamlCompatiblePayloadAndParameterResolutionStage() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_RamlCompatiblePayloadAndParameterResolutionStage.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_RamlCompatiblePayloadAndParameterResolutionStage.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_RamlCompatiblePayloadAndParameterResolutionStage.prototype.appliesTo__Lamf_ProfileName__Z = (function(profile) {
  var x = $m_Lamf_RamlProfile$();
  if (x.equals__O__Z(profile)) {
    return true
  } else {
    var x$3 = $m_Lamf_Raml10Profile$();
    if (x$3.equals__O__Z(profile)) {
      return true
    } else {
      var x$5 = $m_Lamf_Raml08Profile$();
      return x$5.equals__O__Z(profile)
    }
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_RamlCompatiblePayloadAndParameterResolutionStage.prototype.addExampleToShape__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_domain_shapes_models_Example__V = (function(shape, example) {
  var x1 = shape.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(shape.effectiveLinkTarget$default$1__sc_Seq());
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x1);
    $c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage.prototype.addExampleToShape__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_domain_shapes_models_Example__V.call(this, x2, example)
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_RamlCompatiblePayloadAndParameterResolutionStage.prototype.init___Lamf_ProfileName__Lamf_core_errorhandling_ErrorHandler = (function(profile, errorHandler) {
  $c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage.prototype.init___Lamf_ProfileName__Lamf_core_errorhandling_ErrorHandler.call(this, profile, errorHandler);
  return this
});
var $d_Lamf_plugins_domain_webapi_resolution_stages_RamlCompatiblePayloadAndParameterResolutionStage = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_RamlCompatiblePayloadAndParameterResolutionStage: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.RamlCompatiblePayloadAndParameterResolutionStage", {
  Lamf_plugins_domain_webapi_resolution_stages_RamlCompatiblePayloadAndParameterResolutionStage: 1,
  Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_RamlCompatiblePayloadAndParameterResolutionStage.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_RamlCompatiblePayloadAndParameterResolutionStage;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncExamplePropagationResolutionStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncExamplePropagationResolutionStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncExamplePropagationResolutionStage.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncExamplePropagationResolutionStage;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncExamplePropagationResolutionStage() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncExamplePropagationResolutionStage.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncExamplePropagationResolutionStage.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncExamplePropagationResolutionStage.prototype.propagateExamples__p2__Lamf_plugins_domain_webapi_models_WebApi__V = (function(webApi) {
  var messages = this.getAllMessages__p2__Lamf_plugins_domain_webapi_models_WebApi__sci_List(webApi);
  var these = messages;
  while ((!these.isEmpty__Z())) {
    var arg1 = these.head__O();
    var message = $as_Lamf_plugins_domain_webapi_models_Message(arg1);
    this.propagateExamplesToPayloads__p2__Lamf_plugins_domain_webapi_models_Message__V(message);
    these = $as_sci_List(these.tail__O())
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncExamplePropagationResolutionStage.prototype.getAllMessages__p2__Lamf_plugins_domain_webapi_models_WebApi__sci_List = (function(webApi) {
  var jsx$2 = $as_sc_Seq(webApi.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_plugins_domain_webapi_models_EndPoint(x$1$2);
      return $as_sc_Seq(x$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1))
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  return $as_sci_List($as_sc_TraversableOnce(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).foldLeft__O__F2__O($m_sci_Nil$(), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$2) {
    return (function(acc$2, curr$2) {
      var acc = $as_sci_List(acc$2);
      var curr = $as_Lamf_plugins_domain_webapi_models_Operation(curr$2);
      var jsx$5 = $as_sc_Seq(curr.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Request$1));
      var this$3 = $m_sci_List$();
      var jsx$4 = $as_sci_List(acc.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$5, this$3.ReusableCBFInstance$2));
      var jsx$3 = $as_sc_Seq(curr.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1));
      var this$4 = $m_sci_List$();
      return $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$4.ReusableCBFInstance$2))
    })
  })(this))))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncExamplePropagationResolutionStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  if ((model instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(model);
    if ((x2.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)) {
      this.propagateExamples__p2__Lamf_plugins_domain_webapi_models_WebApi__V($as_Lamf_plugins_domain_webapi_models_WebApi(x2.encodes__Lamf_core_model_domain_DomainElement()));
      return x2
    }
  };
  return model
});
$c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncExamplePropagationResolutionStage.prototype.propagateExamplesToPayloads__p2__Lamf_plugins_domain_webapi_models_Message__V = (function(message) {
  var jsx$2 = $as_sc_Seq(message.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_plugins_domain_webapi_models_Payload(x$2$2);
      return $as_Lamf_core_model_domain_Shape(x$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1))
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  $as_sc_IterableLike(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, message$1) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_core_model_domain_Shape(x$3$2);
      $f_Lamf_plugins_domain_webapi_resolution_stages_common_ExamplePropagationHelper__trackExamplesOf__Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement__Lamf_core_model_domain_Shape__V(this$2, message$1, x$3)
    })
  })(this, message)))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncExamplePropagationResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncExamplePropagationResolutionStage = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_async_AsyncExamplePropagationResolutionStage: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.async.AsyncExamplePropagationResolutionStage", {
  Lamf_plugins_domain_webapi_resolution_stages_async_AsyncExamplePropagationResolutionStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1,
  Lamf_plugins_domain_webapi_resolution_stages_common_ExamplePropagationHelper: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncExamplePropagationResolutionStage.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_async_AsyncExamplePropagationResolutionStage;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_async_ServerVariableExampleResolutionStage() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this)
}
$c_Lamf_plugins_domain_webapi_resolution_stages_async_ServerVariableExampleResolutionStage.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_domain_webapi_resolution_stages_async_ServerVariableExampleResolutionStage.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_async_ServerVariableExampleResolutionStage;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_async_ServerVariableExampleResolutionStage() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_async_ServerVariableExampleResolutionStage.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_async_ServerVariableExampleResolutionStage.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_async_ServerVariableExampleResolutionStage.prototype.propagateInServerVariables__p2__Lamf_plugins_domain_webapi_models_WebApi__V = (function(webApi) {
  var jsx$2 = $as_sc_Seq(webApi.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Servers$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_plugins_domain_webapi_models_Server(x$1$2);
      return $as_sc_Seq(x$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Variables$1))
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var params = $as_sc_Seq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  params.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(param$2) {
      var param = $as_Lamf_plugins_domain_webapi_models_Parameter(param$2);
      var this$3 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(param.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1)));
      if (this$3.isEmpty__Z()) {
        return $m_s_None$()
      } else {
        var arg1 = this$3.get__O();
        var x$2 = $as_Lamf_core_model_domain_Shape(arg1);
        $f_Lamf_plugins_domain_webapi_resolution_stages_common_ExamplePropagationHelper__trackExamplesOf__Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement__Lamf_core_model_domain_Shape__V(this$2, param, x$2);
        return new $c_s_Some().init___O((void 0))
      }
    })
  })(this)))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_async_ServerVariableExampleResolutionStage.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  if ((model instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(model);
    if ((x2.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)) {
      this.propagateInServerVariables__p2__Lamf_plugins_domain_webapi_models_WebApi__V($as_Lamf_plugins_domain_webapi_models_WebApi(x2.encodes__Lamf_core_model_domain_DomainElement()));
      return x2
    }
  };
  return model
});
$c_Lamf_plugins_domain_webapi_resolution_stages_async_ServerVariableExampleResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  return this
});
var $d_Lamf_plugins_domain_webapi_resolution_stages_async_ServerVariableExampleResolutionStage = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_async_ServerVariableExampleResolutionStage: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.async.ServerVariableExampleResolutionStage", {
  Lamf_plugins_domain_webapi_resolution_stages_async_ServerVariableExampleResolutionStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1,
  Lamf_plugins_domain_webapi_resolution_stages_common_ExamplePropagationHelper: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_async_ServerVariableExampleResolutionStage.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_async_ServerVariableExampleResolutionStage;
/** @constructor */
function $c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$1() {
  $c_O.call(this);
  this.constraintId$3$1 = null;
  this.f$1$1 = null;
  this.validatorPath$1$1 = null;
  this.validatorId$1$1 = null
}
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$1.prototype = new $h_O();
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$1.prototype.constructor = $c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$1;
/** @constructor */
function $h_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$1() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$1.prototype = $c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$1.prototype;
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$1.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$15 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@id");
  $m_Lorg_yaml_model_YNode$();
  var str = this.constraintId$3$1;
  var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value);
  $m_Lorg_yaml_model_YNode$();
  var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@type");
  $m_Lorg_yaml_model_YNode$();
  var this$5 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var str$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$5, "ConstraintComponent").iri__T();
  var value$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
  b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$1, value$1);
  if (this.f$1$1.parameters$1.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var this$8 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var str$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$8, "parameter").iri__T();
    var key$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$2);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
    var jsx$5 = v.builder$1;
    var sourceName$1 = v.sourceName$2;
    var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
    $m_Lorg_yaml_model_YNode$();
    var this$12 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var str$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$12, "path").iri__T();
    var key$3 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$3);
    var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$2.sourceName$2);
    var jsx$1 = v$1.builder$1;
    var sourceName$2 = v$1.sourceName$2;
    var b$3 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$2);
    $m_Lorg_yaml_model_YNode$();
    var key$4 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@id");
    $m_Lorg_yaml_model_YNode$();
    var str$4 = $as_Lamf_core_validation_core_FunctionConstraintParameter(this.f$1$1.parameters$1.head__O()).path__T();
    var value$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$4);
    b$3.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$4, value$2);
    jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$3.builder$1, sourceName$2), $m_Lorg_yaml_model_YType$().Map$1));
    var this$20 = v$1.builder$1;
    var array = [key$3];
    if ((this$20.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$20.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$20, newSize);
    var len$1 = this$20.size0$6;
    var src = this$20.array$6;
    var dest = this$20.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$20.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$2 = j;
      var index = i;
      xs.set(jsx$2, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$20.size0$6 = newSize;
    b$2.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1));
    $m_Lorg_yaml_model_YNode$();
    var this$31 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var str$5 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$31, "datatype").iri__T();
    var key$5 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$5);
    var v$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$2.sourceName$2);
    var jsx$3 = v$2.builder$1;
    var sourceName$3 = v$2.sourceName$2;
    var b$4 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$3);
    $m_Lorg_yaml_model_YNode$();
    var key$6 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@id");
    $m_Lorg_yaml_model_YNode$();
    var str$6 = $as_Lamf_core_validation_core_FunctionConstraintParameter(this.f$1$1.parameters$1.head__O()).datatype__T();
    var value$3 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$6);
    b$4.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$6, value$3);
    jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$4.builder$1, sourceName$3), $m_Lorg_yaml_model_YType$().Map$1));
    var this$39 = v$2.builder$1;
    var array$1 = [key$5];
    if ((this$39.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$3 = $uI(array$1.length);
    var newSize$1 = ((this$39.size0$6 + len$3) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$39, newSize$1);
    var len$4 = this$39.size0$6;
    var src$1 = this$39.array$6;
    var dest$1 = this$39.array$6;
    $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
    var xs$1 = this$39.array$6;
    var len$5 = xs$1.u.length;
    var i$1 = 0;
    var j$1 = 0;
    var x$2 = $uI(array$1.length);
    var x$3 = ((x$2 < len$5) ? x$2 : len$5);
    var that$1 = xs$1.u.length;
    var end$1 = ((x$3 < that$1) ? x$3 : that$1);
    while ((i$1 < end$1)) {
      var jsx$4 = j$1;
      var index$1 = i$1;
      xs$1.set(jsx$4, array$1[index$1]);
      i$1 = ((1 + i$1) | 0);
      j$1 = ((1 + j$1) | 0)
    };
    this$39.size0$6 = newSize$1;
    b$2.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$2.builder$1));
    jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1));
    var this$52 = v.builder$1;
    var array$2 = [key$2];
    if ((this$52.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$6 = $uI(array$2.length);
    var newSize$2 = ((this$52.size0$6 + len$6) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$52, newSize$2);
    var len$7 = this$52.size0$6;
    var src$2 = this$52.array$6;
    var dest$2 = this$52.array$6;
    $systemArraycopy(src$2, 0, dest$2, len$6, len$7);
    var xs$2 = this$52.array$6;
    var len$8 = xs$2.u.length;
    var i$2 = 0;
    var j$2 = 0;
    var x$4 = $uI(array$2.length);
    var x$5 = ((x$4 < len$8) ? x$4 : len$8);
    var that$2 = xs$2.u.length;
    var end$2 = ((x$5 < that$2) ? x$5 : that$2);
    while ((i$2 < end$2)) {
      var jsx$6 = j$2;
      var index$2 = i$2;
      xs$2.set(jsx$6, array$2[index$2]);
      i$2 = ((1 + i$2) | 0);
      j$2 = ((1 + j$2) | 0)
    };
    this$52.size0$6 = newSize$2;
    b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  } else {
    $m_Lorg_yaml_model_YNode$();
    var this$63 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var str$7 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$63, "parameter").iri__T();
    var key$7 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$7);
    var v$3 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
    var jsx$11 = v$3.builder$1;
    var sourceName$4 = v$3.sourceName$2;
    var b$5 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$4);
    $m_Lorg_yaml_model_YNode$();
    var this$67 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var str$8 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$67, "path").iri__T();
    var key$8 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$8);
    var v$4 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$5.sourceName$2);
    var jsx$7 = v$4.builder$1;
    var sourceName$5 = v$4.sourceName$2;
    var b$6 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$5);
    $m_Lorg_yaml_model_YNode$();
    var key$9 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@id");
    $m_Lorg_yaml_model_YNode$();
    var str$9 = this.validatorPath$1$1;
    var value$4 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$9);
    b$6.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$9, value$4);
    jsx$7.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$6.builder$1, sourceName$5), $m_Lorg_yaml_model_YType$().Map$1));
    var this$75 = v$4.builder$1;
    var array$3 = [key$8];
    if ((this$75.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$9 = $uI(array$3.length);
    var newSize$3 = ((this$75.size0$6 + len$9) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$75, newSize$3);
    var len$10 = this$75.size0$6;
    var src$3 = this$75.array$6;
    var dest$3 = this$75.array$6;
    $systemArraycopy(src$3, 0, dest$3, len$9, len$10);
    var xs$3 = this$75.array$6;
    var len$11 = xs$3.u.length;
    var i$3 = 0;
    var j$3 = 0;
    var x$6 = $uI(array$3.length);
    var x$7 = ((x$6 < len$11) ? x$6 : len$11);
    var that$3 = xs$3.u.length;
    var end$3 = ((x$7 < that$3) ? x$7 : that$3);
    while ((i$3 < end$3)) {
      var jsx$8 = j$3;
      var index$3 = i$3;
      xs$3.set(jsx$8, array$3[index$3]);
      i$3 = ((1 + i$3) | 0);
      j$3 = ((1 + j$3) | 0)
    };
    this$75.size0$6 = newSize$3;
    b$5.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$4.builder$1));
    $m_Lorg_yaml_model_YNode$();
    var this$86 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var str$10 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$86, "datatype").iri__T();
    var key$10 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$10);
    var v$5 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$5.sourceName$2);
    var jsx$9 = v$5.builder$1;
    var sourceName$6 = v$5.sourceName$2;
    var b$7 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$6);
    $m_Lorg_yaml_model_YNode$();
    var key$11 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@id");
    $m_Lorg_yaml_model_YNode$();
    var str$11 = $m_Lamf_core_model_DataType$().Boolean$1;
    var value$5 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$11);
    b$7.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$11, value$5);
    jsx$9.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$7.builder$1, sourceName$6), $m_Lorg_yaml_model_YType$().Map$1));
    var this$94 = v$5.builder$1;
    var array$4 = [key$10];
    if ((this$94.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$12 = $uI(array$4.length);
    var newSize$4 = ((this$94.size0$6 + len$12) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$94, newSize$4);
    var len$13 = this$94.size0$6;
    var src$4 = this$94.array$6;
    var dest$4 = this$94.array$6;
    $systemArraycopy(src$4, 0, dest$4, len$12, len$13);
    var xs$4 = this$94.array$6;
    var len$14 = xs$4.u.length;
    var i$4 = 0;
    var j$4 = 0;
    var x$8 = $uI(array$4.length);
    var x$9 = ((x$8 < len$14) ? x$8 : len$14);
    var that$4 = xs$4.u.length;
    var end$4 = ((x$9 < that$4) ? x$9 : that$4);
    while ((i$4 < end$4)) {
      var jsx$10 = j$4;
      var index$4 = i$4;
      xs$4.set(jsx$10, array$4[index$4]);
      i$4 = ((1 + i$4) | 0);
      j$4 = ((1 + j$4) | 0)
    };
    this$94.size0$6 = newSize$4;
    b$5.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$5.builder$1));
    jsx$11.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$5.builder$1, sourceName$4), $m_Lorg_yaml_model_YType$().Map$1));
    var this$107 = v$3.builder$1;
    var array$5 = [key$7];
    if ((this$107.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$15 = $uI(array$5.length);
    var newSize$5 = ((this$107.size0$6 + len$15) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$107, newSize$5);
    var len$16 = this$107.size0$6;
    var src$5 = this$107.array$6;
    var dest$5 = this$107.array$6;
    $systemArraycopy(src$5, 0, dest$5, len$15, len$16);
    var xs$5 = this$107.array$6;
    var len$17 = xs$5.u.length;
    var i$5 = 0;
    var j$5 = 0;
    var x$10 = $uI(array$5.length);
    var x$11 = ((x$10 < len$17) ? x$10 : len$17);
    var that$5 = xs$5.u.length;
    var end$5 = ((x$11 < that$5) ? x$11 : that$5);
    while ((i$5 < end$5)) {
      var jsx$12 = j$5;
      var index$5 = i$5;
      xs$5.set(jsx$12, array$5[index$5]);
      i$5 = ((1 + i$5) | 0);
      j$5 = ((1 + j$5) | 0)
    };
    this$107.size0$6 = newSize$5;
    b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$3.builder$1))
  };
  $m_Lorg_yaml_model_YNode$();
  var this$118 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var str$12 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$118, "validator").iri__T();
  var key$12 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$12);
  var v$6 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
  var jsx$13 = v$6.builder$1;
  var sourceName$7 = v$6.sourceName$2;
  var b$8 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$7);
  $m_Lorg_yaml_model_YNode$();
  var key$13 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@id");
  $m_Lorg_yaml_model_YNode$();
  var str$13 = this.validatorId$1$1;
  var value$6 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$13);
  b$8.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$13, value$6);
  jsx$13.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$8.builder$1, sourceName$7), $m_Lorg_yaml_model_YType$().Map$1));
  var this$126 = v$6.builder$1;
  var array$6 = [key$12];
  if ((this$126.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len$18 = $uI(array$6.length);
  var newSize$6 = ((this$126.size0$6 + len$18) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$126, newSize$6);
  var len$19 = this$126.size0$6;
  var src$6 = this$126.array$6;
  var dest$6 = this$126.array$6;
  $systemArraycopy(src$6, 0, dest$6, len$18, len$19);
  var xs$6 = this$126.array$6;
  var len$20 = xs$6.u.length;
  var i$6 = 0;
  var j$6 = 0;
  var x$12 = $uI(array$6.length);
  var x$13 = ((x$12 < len$20) ? x$12 : len$20);
  var that$6 = xs$6.u.length;
  var end$6 = ((x$13 < that$6) ? x$13 : that$6);
  while ((i$6 < end$6)) {
    var jsx$14 = j$6;
    var index$6 = i$6;
    xs$6.set(jsx$14, array$6[index$6]);
    i$6 = ((1 + i$6) | 0);
    j$6 = ((1 + j$6) | 0)
  };
  this$126.size0$6 = newSize$6;
  b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$6.builder$1));
  jsx$15.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$1.prototype.position__Lamf_core_parser_Position = (function() {
  return $m_Lamf_core_parser_Position$ZERO$()
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$1.prototype.init___Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter__T__Lamf_core_validation_core_FunctionConstraint__T__T = (function($$outer, constraintId$3, f$1, validatorPath$1, validatorId$1) {
  this.constraintId$3$1 = constraintId$3;
  this.f$1$1 = f$1;
  this.validatorPath$1$1 = validatorPath$1;
  this.validatorId$1$1 = validatorId$1;
  return this
});
var $d_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$1 = new $TypeData().initClass({
  Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$1: 0
}, false, "amf.plugins.features.validation.emitters.ValidationJSONLDEmitter$$anon$1", {
  Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$1: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$1.prototype.$classData = $d_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$1;
/** @constructor */
function $c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$2() {
  $c_O.call(this);
  this.$$outer$1 = null;
  this.f$2$1 = null;
  this.validatorId$2$1 = null;
  this.validationId$2$1 = null
}
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$2.prototype = new $h_O();
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$2.prototype.constructor = $c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$2;
/** @constructor */
function $h_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$2() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$2.prototype = $c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$2.prototype;
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$2.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var x1 = this.f$2$1.functionName$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var fnName = $as_T(x2.value$2);
    var jsx$9 = b.builder$1;
    var sourceName = b.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@id");
    $m_Lorg_yaml_model_YNode$();
    var str = this.validatorId$2$1;
    var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value);
    $m_Lorg_yaml_model_YNode$();
    var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@type");
    $m_Lorg_yaml_model_YNode$();
    var this$5 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var str$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$5, "JSValidator").iri__T();
    var value$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
    b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$1, value$1);
    var this$8 = this.f$2$1.message$1;
    if ((!this$8.isEmpty__Z())) {
      var arg1 = this$8.get__O();
      var msg = $as_T(arg1);
      $m_Lorg_yaml_model_YNode$();
      var this$9 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      var str$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$9, "message").iri__T();
      var key$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$2);
      var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
      this.$$outer$1.amf$plugins$features$validation$emitters$ValidationJSONLDEmitter$$genValue__Lorg_yaml_model_YDocument$PartBuilder__T__s_Option__V(v, msg, $m_s_None$());
      var this$15 = v.builder$1;
      var array = [key$2];
      if ((this$15.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len = $uI(array.length);
      var newSize = ((this$15.size0$6 + len) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$15, newSize);
      var len$1 = this$15.size0$6;
      var src = this$15.array$6;
      var dest = this$15.array$6;
      $systemArraycopy(src, 0, dest, len, len$1);
      var xs = this$15.array$6;
      var len$2 = xs.u.length;
      var i = 0;
      var j = 0;
      var x = $uI(array.length);
      var x$1 = ((x < len$2) ? x : len$2);
      var that = xs.u.length;
      var end = ((x$1 < that) ? x$1 : that);
      while ((i < end)) {
        var jsx$1 = j;
        var index = i;
        xs.set(jsx$1, array[index]);
        i = ((1 + i) | 0);
        j = ((1 + j) | 0)
      };
      this$15.size0$6 = newSize;
      b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
    };
    $m_Lorg_yaml_model_YNode$();
    var this$26 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var str$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$26, "jsLibrary").iri__T();
    var key$3 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$3);
    var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
    var jsx$6 = v$1.builder$1;
    var sourceName$1 = v$1.sourceName$2;
    var b$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$1);
    this.f$2$1.libraries$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$3) {
      return (function(library$2) {
        var library = $as_T(library$2);
        var jsx$4 = b$3.builder$1;
        var sourceName$2 = b$3.sourceName$2;
        var b$4 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$2);
        $m_Lorg_yaml_model_YNode$();
        var this$31 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        var str$4 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$31, "jsLibraryURL").iri__T();
        var key$4 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$4);
        var v$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$4.sourceName$2);
        var jsx$2 = v$2.builder$1;
        var sourceName$3 = v$2.sourceName$2;
        var b$5 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$3);
        $m_Lorg_yaml_model_YNode$();
        var key$5 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@value");
        $m_Lorg_yaml_model_YNode$();
        var value$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(library);
        b$5.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$5, value$2);
        $m_Lorg_yaml_model_YNode$();
        var key$6 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@type");
        $m_Lorg_yaml_model_YNode$();
        var value$3 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("http://www.w3.org/2001/XMLSchema#anyUri");
        b$5.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$6, value$3);
        jsx$2.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$5.builder$1, sourceName$3), $m_Lorg_yaml_model_YType$().Map$1));
        var this$41 = v$2.builder$1;
        var array$1 = [key$4];
        if ((this$41.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len$3 = $uI(array$1.length);
        var newSize$1 = ((this$41.size0$6 + len$3) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$41, newSize$1);
        var len$4 = this$41.size0$6;
        var src$1 = this$41.array$6;
        var dest$1 = this$41.array$6;
        $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
        var xs$1 = this$41.array$6;
        var len$5 = xs$1.u.length;
        var i$1 = 0;
        var j$1 = 0;
        var x$2 = $uI(array$1.length);
        var x$3 = ((x$2 < len$5) ? x$2 : len$5);
        var that$1 = xs$1.u.length;
        var end$1 = ((x$3 < that$1) ? x$3 : that$1);
        while ((i$1 < end$1)) {
          var jsx$3 = j$1;
          var index$1 = i$1;
          xs$1.set(jsx$3, array$1[index$1]);
          i$1 = ((1 + i$1) | 0);
          j$1 = ((1 + j$1) | 0)
        };
        this$41.size0$6 = newSize$1;
        b$4.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$2.builder$1));
        jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$4.builder$1, sourceName$2), $m_Lorg_yaml_model_YType$().Map$1))
      })
    })(this, b$2)));
    var jsx$5 = $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YSequence$();
    var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$1);
    var parts = b$2.builder$1;
    var node = jsx$5.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
    jsx$6.$$plus$eq__O__scm_ArrayBuffer(node);
    var this$55 = v$1.builder$1;
    var array$2 = [key$3];
    if ((this$55.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$6 = $uI(array$2.length);
    var newSize$2 = ((this$55.size0$6 + len$6) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$55, newSize$2);
    var len$7 = this$55.size0$6;
    var src$2 = this$55.array$6;
    var dest$2 = this$55.array$6;
    $systemArraycopy(src$2, 0, dest$2, len$6, len$7);
    var xs$2 = this$55.array$6;
    var len$8 = xs$2.u.length;
    var i$2 = 0;
    var j$2 = 0;
    var x$4 = $uI(array$2.length);
    var x$5 = ((x$4 < len$8) ? x$4 : len$8);
    var that$2 = xs$2.u.length;
    var end$2 = ((x$5 < that$2) ? x$5 : that$2);
    while ((i$2 < end$2)) {
      var jsx$7 = j$2;
      var index$2 = i$2;
      xs$2.set(jsx$7, array$2[index$2]);
      i$2 = ((1 + i$2) | 0);
      j$2 = ((1 + j$2) | 0)
    };
    this$55.size0$6 = newSize$2;
    b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1));
    $m_Lorg_yaml_model_YNode$();
    var this$66 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var str$5 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$66, "jsFunctionName").iri__T();
    var key$7 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$5);
    var v$3 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
    this.$$outer$1.amf$plugins$features$validation$emitters$ValidationJSONLDEmitter$$genValue__Lorg_yaml_model_YDocument$PartBuilder__T__s_Option__V(v$3, fnName, $m_s_None$());
    var this$72 = v$3.builder$1;
    var array$3 = [key$7];
    if ((this$72.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$9 = $uI(array$3.length);
    var newSize$3 = ((this$72.size0$6 + len$9) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$72, newSize$3);
    var len$10 = this$72.size0$6;
    var src$3 = this$72.array$6;
    var dest$3 = this$72.array$6;
    $systemArraycopy(src$3, 0, dest$3, len$9, len$10);
    var xs$3 = this$72.array$6;
    var len$11 = xs$3.u.length;
    var i$3 = 0;
    var j$3 = 0;
    var x$6 = $uI(array$3.length);
    var x$7 = ((x$6 < len$11) ? x$6 : len$11);
    var that$3 = xs$3.u.length;
    var end$3 = ((x$7 < that$3) ? x$7 : that$3);
    while ((i$3 < end$3)) {
      var jsx$8 = j$3;
      var index$3 = i$3;
      xs$3.set(jsx$8, array$3[index$3]);
      i$3 = ((1 + i$3) | 0);
      j$3 = ((1 + j$3) | 0)
    };
    this$72.size0$6 = newSize$3;
    b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$3.builder$1));
    jsx$9.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  } else {
    var x$8 = $m_s_None$();
    if ((x$8 === x1)) {
      var x1$2 = this.f$2$1.code$1;
      if ((!(x1$2 instanceof $c_s_Some))) {
        throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Cannot emit validator without JS code or JS function name"))
      };
      var jsx$21 = b.builder$1;
      var sourceName$4 = b.sourceName$2;
      var b$6 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$4);
      $m_Lorg_yaml_model_YNode$();
      var key$8 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@id");
      $m_Lorg_yaml_model_YNode$();
      var str$6 = this.validatorId$2$1;
      var value$4 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$6);
      b$6.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$8, value$4);
      $m_Lorg_yaml_model_YNode$();
      var key$9 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@type");
      $m_Lorg_yaml_model_YNode$();
      var this$87 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      var str$7 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$87, "JSValidator").iri__T();
      var value$5 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$7);
      b$6.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$9, value$5);
      var this$90 = this.f$2$1.message$1;
      if ((!this$90.isEmpty__Z())) {
        var arg1$1 = this$90.get__O();
        var msg$1 = $as_T(arg1$1);
        $m_Lorg_yaml_model_YNode$();
        var this$91 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
        var str$8 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$91, "message").iri__T();
        var key$10 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$8);
        var v$4 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$6.sourceName$2);
        this.$$outer$1.amf$plugins$features$validation$emitters$ValidationJSONLDEmitter$$genValue__Lorg_yaml_model_YDocument$PartBuilder__T__s_Option__V(v$4, msg$1, $m_s_None$());
        var this$97 = v$4.builder$1;
        var array$4 = [key$10];
        if ((this$97.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len$12 = $uI(array$4.length);
        var newSize$4 = ((this$97.size0$6 + len$12) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$97, newSize$4);
        var len$13 = this$97.size0$6;
        var src$4 = this$97.array$6;
        var dest$4 = this$97.array$6;
        $systemArraycopy(src$4, 0, dest$4, len$12, len$13);
        var xs$4 = this$97.array$6;
        var len$14 = xs$4.u.length;
        var i$4 = 0;
        var j$4 = 0;
        var x$9 = $uI(array$4.length);
        var x$10 = ((x$9 < len$14) ? x$9 : len$14);
        var that$4 = xs$4.u.length;
        var end$4 = ((x$10 < that$4) ? x$10 : that$4);
        while ((i$4 < end$4)) {
          var jsx$10 = j$4;
          var index$4 = i$4;
          xs$4.set(jsx$10, array$4[index$4]);
          i$4 = ((1 + i$4) | 0);
          j$4 = ((1 + j$4) | 0)
        };
        this$97.size0$6 = newSize$4;
        b$6.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$4.builder$1))
      };
      $m_Lorg_yaml_model_YNode$();
      var this$108 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      var str$9 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$108, "jsLibrary").iri__T();
      var key$11 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$9);
      var v$5 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$6.sourceName$2);
      var jsx$18 = v$5.builder$1;
      var sourceName$5 = v$5.sourceName$2;
      var b$7 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$5);
      var jsx$13 = $m_sc_Seq$();
      var array$5 = [$m_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$().validationLibraryUrl__T()];
      var jsx$12 = $as_sc_TraversableLike(jsx$13.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$5)));
      var jsx$11 = this.f$2$1.libraries$1;
      var this$114 = $m_sc_Seq$();
      $as_sc_IterableLike(jsx$12.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$11, this$114.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, b$8) {
        return (function(library$2$1) {
          var library$1 = $as_T(library$2$1);
          var jsx$16 = b$8.builder$1;
          var sourceName$6 = b$8.sourceName$2;
          var b$9 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$6);
          $m_Lorg_yaml_model_YNode$();
          var this$116 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
          var str$10 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$116, "jsLibraryURL").iri__T();
          var key$12 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$10);
          var v$6 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$9.sourceName$2);
          var jsx$14 = v$6.builder$1;
          var sourceName$7 = v$6.sourceName$2;
          var b$10 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$7);
          $m_Lorg_yaml_model_YNode$();
          var key$13 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@value");
          $m_Lorg_yaml_model_YNode$();
          var value$6 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(library$1);
          b$10.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$13, value$6);
          $m_Lorg_yaml_model_YNode$();
          var key$14 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("@type");
          $m_Lorg_yaml_model_YNode$();
          var value$7 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("http://www.w3.org/2001/XMLSchema#anyUri");
          b$10.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$14, value$7);
          jsx$14.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$10.builder$1, sourceName$7), $m_Lorg_yaml_model_YType$().Map$1));
          var this$126 = v$6.builder$1;
          var array$6 = [key$12];
          if ((this$126.size0$6 < 0)) {
            throw new $c_jl_IndexOutOfBoundsException().init___T("0")
          };
          var len$15 = $uI(array$6.length);
          var newSize$5 = ((this$126.size0$6 + len$15) | 0);
          $f_scm_ResizableArray__ensureSize__I__V(this$126, newSize$5);
          var len$16 = this$126.size0$6;
          var src$5 = this$126.array$6;
          var dest$5 = this$126.array$6;
          $systemArraycopy(src$5, 0, dest$5, len$15, len$16);
          var xs$5 = this$126.array$6;
          var len$17 = xs$5.u.length;
          var i$5 = 0;
          var j$5 = 0;
          var x$11 = $uI(array$6.length);
          var x$12 = ((x$11 < len$17) ? x$11 : len$17);
          var that$5 = xs$5.u.length;
          var end$5 = ((x$12 < that$5) ? x$12 : that$5);
          while ((i$5 < end$5)) {
            var jsx$15 = j$5;
            var index$5 = i$5;
            xs$5.set(jsx$15, array$6[index$5]);
            i$5 = ((1 + i$5) | 0);
            j$5 = ((1 + j$5) | 0)
          };
          this$126.size0$6 = newSize$5;
          b$9.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$6.builder$1));
          jsx$16.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$9.builder$1, sourceName$6), $m_Lorg_yaml_model_YType$().Map$1))
        })
      })(this, b$7)));
      var jsx$17 = $m_Lorg_yaml_model_YNode$();
      $m_Lorg_yaml_model_YSequence$();
      var loc$1 = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$5);
      var parts$1 = b$7.builder$1;
      var node$1 = jsx$17.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc$1, parts$1), $m_Lorg_yaml_model_YType$().Seq$1);
      jsx$18.$$plus$eq__O__scm_ArrayBuffer(node$1);
      var this$140 = v$5.builder$1;
      var array$7 = [key$11];
      if ((this$140.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$18 = $uI(array$7.length);
      var newSize$6 = ((this$140.size0$6 + len$18) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$140, newSize$6);
      var len$19 = this$140.size0$6;
      var src$6 = this$140.array$6;
      var dest$6 = this$140.array$6;
      $systemArraycopy(src$6, 0, dest$6, len$18, len$19);
      var xs$6 = this$140.array$6;
      var len$20 = xs$6.u.length;
      var i$6 = 0;
      var j$6 = 0;
      var x$13 = $uI(array$7.length);
      var x$14 = ((x$13 < len$20) ? x$13 : len$20);
      var that$6 = xs$6.u.length;
      var end$6 = ((x$14 < that$6) ? x$14 : that$6);
      while ((i$6 < end$6)) {
        var jsx$19 = j$6;
        var index$6 = i$6;
        xs$6.set(jsx$19, array$7[index$6]);
        i$6 = ((1 + i$6) | 0);
        j$6 = ((1 + j$6) | 0)
      };
      this$140.size0$6 = newSize$6;
      b$6.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$5.builder$1));
      $m_Lorg_yaml_model_YNode$();
      var this$151 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
      var str$11 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$151, "jsFunctionName").iri__T();
      var key$15 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$11);
      var v$7 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$6.sourceName$2);
      this.$$outer$1.amf$plugins$features$validation$emitters$ValidationJSONLDEmitter$$genValue__Lorg_yaml_model_YDocument$PartBuilder__T__s_Option__V(v$7, this.f$2$1.computeFunctionName__T__T(this.validationId$2$1), $m_s_None$());
      var this$157 = v$7.builder$1;
      var array$8 = [key$15];
      if ((this$157.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$21 = $uI(array$8.length);
      var newSize$7 = ((this$157.size0$6 + len$21) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$157, newSize$7);
      var len$22 = this$157.size0$6;
      var src$7 = this$157.array$6;
      var dest$7 = this$157.array$6;
      $systemArraycopy(src$7, 0, dest$7, len$21, len$22);
      var xs$7 = this$157.array$6;
      var len$23 = xs$7.u.length;
      var i$7 = 0;
      var j$7 = 0;
      var x$15 = $uI(array$8.length);
      var x$16 = ((x$15 < len$23) ? x$15 : len$23);
      var that$7 = xs$7.u.length;
      var end$7 = ((x$16 < that$7) ? x$16 : that$7);
      while ((i$7 < end$7)) {
        var jsx$20 = j$7;
        var index$7 = i$7;
        xs$7.set(jsx$20, array$8[index$7]);
        i$7 = ((1 + i$7) | 0);
        j$7 = ((1 + j$7) | 0)
      };
      this$157.size0$6 = newSize$7;
      b$6.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$7.builder$1));
      jsx$21.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$6.builder$1, sourceName$4), $m_Lorg_yaml_model_YType$().Map$1))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$2.prototype.init___Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter__Lamf_core_validation_core_FunctionConstraint__T__T = (function($$outer, f$2, validatorId$2, validationId$2) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.f$2$1 = f$2;
  this.validatorId$2$1 = validatorId$2;
  this.validationId$2$1 = validationId$2;
  return this
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$2.prototype.position__Lamf_core_parser_Position = (function() {
  return $m_Lamf_core_parser_Position$ZERO$()
});
var $d_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$2 = new $TypeData().initClass({
  Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$2: 0
}, false, "amf.plugins.features.validation.emitters.ValidationJSONLDEmitter$$anon$2", {
  Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$2: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$2.prototype.$classData = $d_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$$anon$2;
/** @constructor */
function $c_Ljava_math_BigDecimal$() {
  $c_O.call(this);
  this.ZERO$1 = null;
  this.ONE$1 = null;
  this.TEN$1 = null;
  this.java$math$BigDecimal$$LongFivePows$1 = null;
  this.java$math$BigDecimal$$LongFivePowsBitLength$1 = null;
  this.LongTenPows$1 = null;
  this.java$math$BigDecimal$$LongTenPowsBitLength$1 = null;
  this.BigIntScaledByZero$1 = null;
  this.ZeroScaledBy$1 = null;
  this.java$math$BigDecimal$$CharZeros$1 = null
}
$c_Ljava_math_BigDecimal$.prototype = new $h_O();
$c_Ljava_math_BigDecimal$.prototype.constructor = $c_Ljava_math_BigDecimal$;
/** @constructor */
function $h_Ljava_math_BigDecimal$() {
  /*<skip>*/
}
$h_Ljava_math_BigDecimal$.prototype = $c_Ljava_math_BigDecimal$.prototype;
$c_Ljava_math_BigDecimal$.prototype.valueOf__J__I__Ljava_math_BigDecimal = (function(unscaledVal, scale) {
  return ((scale === 0) ? this.valueOf__J__Ljava_math_BigDecimal(unscaledVal) : (((((unscaledVal.lo$2 === 0) && (unscaledVal.hi$2 === 0)) && (scale >= 0)) && (scale < this.ZeroScaledBy$1.u.length)) ? this.ZeroScaledBy$1.get(scale) : new $c_Ljava_math_BigDecimal().init___J__I(unscaledVal, scale)))
});
$c_Ljava_math_BigDecimal$.prototype.java$math$BigDecimal$$longCompareTo__J__J__I = (function(value1, value2) {
  var ahi = value1.hi$2;
  var bhi = value2.hi$2;
  if (((ahi === bhi) ? (((-2147483648) ^ value1.lo$2) > ((-2147483648) ^ value2.lo$2)) : (ahi > bhi))) {
    return 1
  } else {
    var ahi$1 = value1.hi$2;
    var bhi$1 = value2.hi$2;
    if (((ahi$1 === bhi$1) ? (((-2147483648) ^ value1.lo$2) < ((-2147483648) ^ value2.lo$2)) : (ahi$1 < bhi$1))) {
      return (-1)
    } else {
      return 0
    }
  }
});
$c_Ljava_math_BigDecimal$.prototype.init___ = (function() {
  $n_Ljava_math_BigDecimal$ = this;
  this.ZERO$1 = new $c_Ljava_math_BigDecimal().init___I__I(0, 0);
  this.ONE$1 = new $c_Ljava_math_BigDecimal().init___I__I(1, 0);
  this.TEN$1 = new $c_Ljava_math_BigDecimal().init___I__I(10, 0);
  this.java$math$BigDecimal$$LongFivePows$1 = this.newArrayOfPows__I__I__AJ(28, 5);
  var n = this.java$math$BigDecimal$$LongFivePows$1.u.length;
  var elems$2 = null;
  elems$2 = [];
  var i = 0;
  while ((i < n)) {
    var arg1 = i;
    var elem = $m_Ljava_math_BigDecimal$().bitLength__J__I($m_Ljava_math_BigDecimal$().java$math$BigDecimal$$LongFivePows$1.get(arg1));
    elems$2.push(elem);
    i = ((1 + i) | 0)
  };
  this.java$math$BigDecimal$$LongFivePowsBitLength$1 = $makeNativeArrayWrapper($d_I.getArrayOf(), elems$2);
  this.LongTenPows$1 = this.newArrayOfPows__I__I__AJ(19, 10);
  var n$1 = this.LongTenPows$1.u.length;
  var elems$2$1 = null;
  elems$2$1 = [];
  var i$1 = 0;
  while ((i$1 < n$1)) {
    var arg1$1 = i$1;
    var elem$1 = $m_Ljava_math_BigDecimal$().bitLength__J__I($m_Ljava_math_BigDecimal$().LongTenPows$1.get(arg1$1));
    elems$2$1.push(elem$1);
    i$1 = ((1 + i$1) | 0)
  };
  this.java$math$BigDecimal$$LongTenPowsBitLength$1 = $makeNativeArrayWrapper($d_I.getArrayOf(), elems$2$1);
  var elems$2$2 = null;
  elems$2$2 = [];
  var i$2 = 0;
  while ((i$2 < 11)) {
    var arg1$2 = i$2;
    var elem$2 = new $c_Ljava_math_BigDecimal().init___I__I(arg1$2, 0);
    elems$2$2.push(elem$2);
    i$2 = ((1 + i$2) | 0)
  };
  this.BigIntScaledByZero$1 = $makeNativeArrayWrapper($d_Ljava_math_BigDecimal.getArrayOf(), elems$2$2);
  var elems$2$3 = null;
  elems$2$3 = [];
  var i$3 = 0;
  while ((i$3 < 11)) {
    var arg1$3 = i$3;
    var elem$3 = new $c_Ljava_math_BigDecimal().init___I__I(0, arg1$3);
    elems$2$3.push(elem$3);
    i$3 = ((1 + i$3) | 0)
  };
  this.ZeroScaledBy$1 = $makeNativeArrayWrapper($d_Ljava_math_BigDecimal.getArrayOf(), elems$2$3);
  this.java$math$BigDecimal$$CharZeros$1 = "0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000";
  return this
});
$c_Ljava_math_BigDecimal$.prototype.java$math$BigDecimal$$roundingBehavior__I__I__Ljava_math_RoundingMode__I = (function(parityBit, fraction, roundingMode) {
  var absFraction = ((fraction < 0) ? ((-fraction) | 0) : fraction);
  var sigFraction = ((fraction === 0) ? 0 : ((fraction < 0) ? (-1) : 1));
  var x = $m_Ljava_math_RoundingMode$().UP$1;
  if ((x === roundingMode)) {
    return sigFraction
  } else {
    var x$3 = $m_Ljava_math_RoundingMode$().DOWN$1;
    if ((x$3 === roundingMode)) {
      return 0
    } else {
      var x$5 = $m_Ljava_math_RoundingMode$().CEILING$1;
      if ((x$5 === roundingMode)) {
        return ((sigFraction > 0) ? sigFraction : 0)
      } else {
        var x$7 = $m_Ljava_math_RoundingMode$().FLOOR$1;
        if ((x$7 === roundingMode)) {
          return ((sigFraction < 0) ? sigFraction : 0)
        } else {
          var x$9 = $m_Ljava_math_RoundingMode$().HALF$undUP$1;
          if ((x$9 === roundingMode)) {
            return ((absFraction >= 5) ? sigFraction : 0)
          } else {
            var x$11 = $m_Ljava_math_RoundingMode$().HALF$undDOWN$1;
            if ((x$11 === roundingMode)) {
              return ((absFraction > 5) ? sigFraction : 0)
            } else {
              var x$13 = $m_Ljava_math_RoundingMode$().HALF$undEVEN$1;
              if ((x$13 === roundingMode)) {
                return ((((absFraction + parityBit) | 0) > 5) ? sigFraction : 0)
              } else {
                var x$15 = $m_Ljava_math_RoundingMode$().UNNECESSARY$1;
                if ((x$15 === roundingMode)) {
                  if ((fraction === 0)) {
                    return 0
                  } else {
                    throw new $c_jl_ArithmeticException().init___T("Rounding necessary")
                  }
                } else {
                  throw new $c_s_MatchError().init___O(roundingMode)
                }
              }
            }
          }
        }
      }
    }
  }
});
$c_Ljava_math_BigDecimal$.prototype.java$math$BigDecimal$$bitLength__I__I = (function(sValue) {
  var smallValue = ((sValue < 0) ? (~sValue) : sValue);
  return ((32 - $clz32(smallValue)) | 0)
});
$c_Ljava_math_BigDecimal$.prototype.java$math$BigDecimal$$safeLongToInt__J__I = (function(longValue) {
  var ahi = longValue.hi$2;
  if (((ahi === (-1)) ? (((-2147483648) ^ longValue.lo$2) < 0) : (ahi < (-1)))) {
    var jsx$1 = true
  } else {
    var ahi$1 = longValue.hi$2;
    var jsx$1 = ((ahi$1 === 0) ? (((-2147483648) ^ longValue.lo$2) > (-1)) : (ahi$1 > 0))
  };
  if (jsx$1) {
    throw new $c_jl_ArithmeticException().init___T(("Out of int range: " + longValue))
  };
  return longValue.lo$2
});
$c_Ljava_math_BigDecimal$.prototype.valueOf__J__Ljava_math_BigDecimal = (function(unscaledVal) {
  var ahi = unscaledVal.hi$2;
  if ((ahi >= 0)) {
    var ahi$1 = unscaledVal.hi$2;
    var jsx$1 = ((ahi$1 === 0) ? (((-2147483648) ^ unscaledVal.lo$2) < (-2147483637)) : (ahi$1 < 0))
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return this.BigIntScaledByZero$1.get(unscaledVal.lo$2)
  } else {
    return new $c_Ljava_math_BigDecimal().init___J__I(unscaledVal, 0)
  }
});
$c_Ljava_math_BigDecimal$.prototype.bitLength__J__I = (function(sValue) {
  var ahi = sValue.hi$2;
  if ((ahi < 0)) {
    var lo = (~sValue.lo$2);
    var hi = (~sValue.hi$2);
    var x_$_lo$2 = lo;
    var x_$_hi$2 = hi;
    var t = new $c_sjsr_RuntimeLong().init___I__I(x_$_lo$2, x_$_hi$2)
  } else {
    var t = sValue
  };
  var lo$1 = t.lo$2;
  var hi$1 = t.hi$2;
  return ((64 - ((hi$1 !== 0) ? $clz32(hi$1) : ((32 + $clz32(lo$1)) | 0))) | 0)
});
$c_Ljava_math_BigDecimal$.prototype.newArrayOfPows__I__I__AJ = (function(len, pow) {
  var elems$2 = null;
  elems$2 = [];
  if ((len > 0)) {
    var acc = new $c_sjsr_RuntimeLong().init___I__I(1, 0);
    var i = 1;
    var elem = acc;
    var unboxedElem = ((elem === null) ? null : elem);
    elems$2.push(unboxedElem);
    while ((i < len)) {
      var arg1 = acc;
      var t = $uJ(arg1);
      var lo = t.lo$2;
      var hi = t.hi$2;
      var hi$1 = (pow >> 31);
      var a0 = (65535 & lo);
      var a1 = ((lo >>> 16) | 0);
      var b0 = (65535 & pow);
      var b1 = ((pow >>> 16) | 0);
      var a0b0 = $imul(a0, b0);
      var a1b0 = $imul(a1, b0);
      var a0b1 = $imul(a0, b1);
      var lo$1 = ((a0b0 + (((a1b0 + a0b1) | 0) << 16)) | 0);
      var c1part = ((((a0b0 >>> 16) | 0) + a0b1) | 0);
      var hi$2 = (((((((($imul(lo, hi$1) + $imul(hi, pow)) | 0) + $imul(a1, b1)) | 0) + ((c1part >>> 16) | 0)) | 0) + (((((65535 & c1part) + a1b0) | 0) >>> 16) | 0)) | 0);
      acc = new $c_sjsr_RuntimeLong().init___I__I(lo$1, hi$2);
      i = ((1 + i) | 0);
      var elem$1 = acc;
      var unboxedElem$1 = ((elem$1 === null) ? null : elem$1);
      elems$2.push(unboxedElem$1)
    }
  };
  return $makeNativeArrayWrapper($d_J.getArrayOf(), elems$2)
});
$c_Ljava_math_BigDecimal$.prototype.java$math$BigDecimal$$zeroScaledBy__J__Ljava_math_BigDecimal = (function(longScale) {
  var value = longScale.lo$2;
  var hi = (value >> 31);
  if (((longScale.lo$2 === value) && (longScale.hi$2 === hi))) {
    return this.valueOf__J__I__Ljava_math_BigDecimal($m_sjsr_RuntimeLong$().Zero__sjsr_RuntimeLong(), longScale.lo$2)
  } else {
    var ahi = longScale.hi$2;
    if ((ahi >= 0)) {
      return new $c_Ljava_math_BigDecimal().init___I__I(0, 2147483647)
    } else {
      return new $c_Ljava_math_BigDecimal().init___I__I(0, (-2147483648))
    }
  }
});
var $d_Ljava_math_BigDecimal$ = new $TypeData().initClass({
  Ljava_math_BigDecimal$: 0
}, false, "java.math.BigDecimal$", {
  Ljava_math_BigDecimal$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Ljava_math_BigDecimal$.prototype.$classData = $d_Ljava_math_BigDecimal$;
var $n_Ljava_math_BigDecimal$ = (void 0);
function $m_Ljava_math_BigDecimal$() {
  if ((!$n_Ljava_math_BigDecimal$)) {
    $n_Ljava_math_BigDecimal$ = new $c_Ljava_math_BigDecimal$().init___()
  };
  return $n_Ljava_math_BigDecimal$
}
/** @constructor */
function $c_Ljava_math_BigInteger$() {
  $c_O.call(this);
  this.ONE$1 = null;
  this.TEN$1 = null;
  this.ZERO$1 = null;
  this.MINUS$undONE$1 = null;
  this.SMALL$undVALUES$1 = null;
  this.TWO$undPOWS$1 = null
}
$c_Ljava_math_BigInteger$.prototype = new $h_O();
$c_Ljava_math_BigInteger$.prototype.constructor = $c_Ljava_math_BigInteger$;
/** @constructor */
function $h_Ljava_math_BigInteger$() {
  /*<skip>*/
}
$h_Ljava_math_BigInteger$.prototype = $c_Ljava_math_BigInteger$.prototype;
$c_Ljava_math_BigInteger$.prototype.init___ = (function() {
  $n_Ljava_math_BigInteger$ = this;
  this.ONE$1 = new $c_Ljava_math_BigInteger().init___I__I(1, 1);
  this.TEN$1 = new $c_Ljava_math_BigInteger().init___I__I(1, 10);
  this.ZERO$1 = new $c_Ljava_math_BigInteger().init___I__I(0, 0);
  this.MINUS$undONE$1 = new $c_Ljava_math_BigInteger().init___I__I((-1), 1);
  this.SMALL$undVALUES$1 = $makeNativeArrayWrapper($d_Ljava_math_BigInteger.getArrayOf(), [this.ZERO$1, this.ONE$1, new $c_Ljava_math_BigInteger().init___I__I(1, 2), new $c_Ljava_math_BigInteger().init___I__I(1, 3), new $c_Ljava_math_BigInteger().init___I__I(1, 4), new $c_Ljava_math_BigInteger().init___I__I(1, 5), new $c_Ljava_math_BigInteger().init___I__I(1, 6), new $c_Ljava_math_BigInteger().init___I__I(1, 7), new $c_Ljava_math_BigInteger().init___I__I(1, 8), new $c_Ljava_math_BigInteger().init___I__I(1, 9), this.TEN$1]);
  var elems$2 = null;
  elems$2 = [];
  var i = 0;
  while ((i < 32)) {
    var arg1 = i;
    var jsx$1 = $m_Ljava_math_BigInteger$();
    var lo = (((32 & arg1) === 0) ? (1 << arg1) : 0);
    var hi = (((32 & arg1) === 0) ? 0 : (1 << arg1));
    var elem = jsx$1.valueOf__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(lo, hi));
    var unboxedElem = ((elem === null) ? null : elem);
    elems$2.push(unboxedElem);
    i = ((1 + i) | 0)
  };
  this.TWO$undPOWS$1 = $makeNativeArrayWrapper($d_Ljava_math_BigInteger.getArrayOf(), elems$2);
  return this
});
$c_Ljava_math_BigInteger$.prototype.getPowerOfTwo__I__Ljava_math_BigInteger = (function(exp) {
  if ((exp < this.TWO$undPOWS$1.u.length)) {
    return this.TWO$undPOWS$1.get(exp)
  } else {
    var intCount = (exp >> 5);
    var bitN = (31 & exp);
    var resDigits = $newArrayObject($d_I.getArrayOf(), [((1 + intCount) | 0)]);
    resDigits.set(intCount, (1 << bitN));
    return new $c_Ljava_math_BigInteger().init___I__I__AI(1, ((1 + intCount) | 0), resDigits)
  }
});
$c_Ljava_math_BigInteger$.prototype.valueOf__J__Ljava_math_BigInteger = (function(lVal) {
  var ahi = lVal.hi$2;
  if ((ahi < 0)) {
    if ((!((lVal.lo$2 === (-1)) && (lVal.hi$2 === (-1))))) {
      var lo = lVal.lo$2;
      var hi = lVal.hi$2;
      var lo$1 = ((-lo) | 0);
      var hi$1 = ((lo !== 0) ? (~hi) : ((-hi) | 0));
      return new $c_Ljava_math_BigInteger().init___I__J((-1), new $c_sjsr_RuntimeLong().init___I__I(lo$1, hi$1))
    } else {
      return this.MINUS$undONE$1
    }
  } else {
    var ahi$1 = lVal.hi$2;
    if (((ahi$1 === 0) ? (((-2147483648) ^ lVal.lo$2) <= (-2147483638)) : (ahi$1 < 0))) {
      return this.SMALL$undVALUES$1.get(lVal.lo$2)
    } else {
      return new $c_Ljava_math_BigInteger().init___I__J(1, lVal)
    }
  }
});
var $d_Ljava_math_BigInteger$ = new $TypeData().initClass({
  Ljava_math_BigInteger$: 0
}, false, "java.math.BigInteger$", {
  Ljava_math_BigInteger$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Ljava_math_BigInteger$.prototype.$classData = $d_Ljava_math_BigInteger$;
var $n_Ljava_math_BigInteger$ = (void 0);
function $m_Ljava_math_BigInteger$() {
  if ((!$n_Ljava_math_BigInteger$)) {
    $n_Ljava_math_BigInteger$ = new $c_Ljava_math_BigInteger$().init___()
  };
  return $n_Ljava_math_BigInteger$
}
/** @constructor */
function $c_Ljava_math_RoundingMode$() {
  $c_O.call(this);
  this.UP$1 = null;
  this.DOWN$1 = null;
  this.CEILING$1 = null;
  this.FLOOR$1 = null;
  this.HALF$undUP$1 = null;
  this.HALF$undDOWN$1 = null;
  this.HALF$undEVEN$1 = null;
  this.UNNECESSARY$1 = null;
  this.$$undvalues$1 = null
}
$c_Ljava_math_RoundingMode$.prototype = new $h_O();
$c_Ljava_math_RoundingMode$.prototype.constructor = $c_Ljava_math_RoundingMode$;
/** @constructor */
function $h_Ljava_math_RoundingMode$() {
  /*<skip>*/
}
$h_Ljava_math_RoundingMode$.prototype = $c_Ljava_math_RoundingMode$.prototype;
$c_Ljava_math_RoundingMode$.prototype.init___ = (function() {
  $n_Ljava_math_RoundingMode$ = this;
  this.UP$1 = new $c_Ljava_math_RoundingMode().init___T__I("UP", 0);
  this.DOWN$1 = new $c_Ljava_math_RoundingMode().init___T__I("DOWN", 1);
  this.CEILING$1 = new $c_Ljava_math_RoundingMode().init___T__I("CEILING", 2);
  this.FLOOR$1 = new $c_Ljava_math_RoundingMode().init___T__I("FLOOR", 3);
  this.HALF$undUP$1 = new $c_Ljava_math_RoundingMode().init___T__I("HALF_UP", 4);
  this.HALF$undDOWN$1 = new $c_Ljava_math_RoundingMode().init___T__I("HALF_DOWN", 5);
  this.HALF$undEVEN$1 = new $c_Ljava_math_RoundingMode().init___T__I("HALF_EVEN", 6);
  this.UNNECESSARY$1 = new $c_Ljava_math_RoundingMode().init___T__I("UNNECESSARY", 7);
  this.$$undvalues$1 = $makeNativeArrayWrapper($d_Ljava_math_RoundingMode.getArrayOf(), [this.UP$1, this.DOWN$1, this.CEILING$1, this.FLOOR$1, this.HALF$undUP$1, this.HALF$undDOWN$1, this.HALF$undEVEN$1, this.UNNECESSARY$1]);
  return this
});
var $d_Ljava_math_RoundingMode$ = new $TypeData().initClass({
  Ljava_math_RoundingMode$: 0
}, false, "java.math.RoundingMode$", {
  Ljava_math_RoundingMode$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Ljava_math_RoundingMode$.prototype.$classData = $d_Ljava_math_RoundingMode$;
var $n_Ljava_math_RoundingMode$ = (void 0);
function $m_Ljava_math_RoundingMode$() {
  if ((!$n_Ljava_math_RoundingMode$)) {
    $n_Ljava_math_RoundingMode$ = new $c_Ljava_math_RoundingMode$().init___()
  };
  return $n_Ljava_math_RoundingMode$
}
/** @constructor */
function $c_Ljava_net_URI$() {
  $c_O.call(this);
  this.ipv4address$1 = null;
  this.ipv6address$1 = null;
  this.ipv6Re$1 = null;
  this.java$net$URI$$uriRe$1 = null;
  this.quoteStr$1 = null;
  this.userInfoQuoteRe$1 = null;
  this.pathQuoteRe$1 = null;
  this.authorityQuoteRe$1 = null;
  this.illegalQuoteRe$1 = null;
  this.nonASCIIQuoteRe$1 = null
}
$c_Ljava_net_URI$.prototype = new $h_O();
$c_Ljava_net_URI$.prototype.constructor = $c_Ljava_net_URI$;
/** @constructor */
function $h_Ljava_net_URI$() {
  /*<skip>*/
}
$h_Ljava_net_URI$.prototype = $c_Ljava_net_URI$.prototype;
$c_Ljava_net_URI$.prototype.init___ = (function() {
  $n_Ljava_net_URI$ = this;
  this.ipv4address$1 = "(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)";
  var ipv4 = this.ipv4address$1;
  this.ipv6address$1 = (((((((((((((("(?:(?:[0-9a-f]{1,4}:){7}[0-9a-f]{1,4}|(?:[0-9a-f]{1,4}:){1,7}:|(?:[0-9a-f]{1,4}:){1,6}(?::[0-9a-f]{1,4})|(?:[0-9a-f]{1,4}:){1,5}(?::[0-9a-f]{1,4}){1,2}|(?:[0-9a-f]{1,4}:){1,4}(?::[0-9a-f]{1,4}){1,3}|(?:[0-9a-f]{1,4}:){1,3}(?::[0-9a-f]{1,4}){1,4}|(?:[0-9a-f]{1,4}:){1,2}(?::[0-9a-f]{1,4}){1,5}|(?:[0-9a-f]{1,4}:)(?::[0-9a-f]{1,4}){1,6}|:(?:(?::[0-9a-f]{1,4}){1,7}|:)|(?:[0-9a-f]{1,4}:){6}" + ipv4) + "|(?:[0-9a-f]{1,4}:){1,5}:") + ipv4) + "|(?:[0-9a-f]{1,4}:){1,4}(?::[0-9a-f]{1,4}):") + ipv4) + "|(?:[0-9a-f]{1,4}:){1,3}(?::[0-9a-f]{1,4}){1,2}:") + ipv4) + "|(?:[0-9a-f]{1,4}:){1,2}(?::[0-9a-f]{1,4}){1,3}:") + ipv4) + "|(?:[0-9a-f]{1,4}:)(?::[0-9a-f]{1,4}){1,4}:") + ipv4) + "|::(?:[0-9a-f]{1,4}:){1,5}") + ipv4) + ")(?:%[0-9a-z]+)?");
  this.ipv6Re$1 = new $g.RegExp((("^" + this.ipv6address$1) + "$"), "i");
  var ipv6reference = (("\\[(?:" + this.ipv6address$1) + ")\\]");
  var host = (((("((?:(?:[a-z0-9]|[a-z0-9][a-z0-9-]*[a-z0-9])\\.)*(?:[a-z]|[a-z][a-z0-9-]*[a-z0-9])\\.?|" + this.ipv4address$1) + "|") + ipv6reference) + ")");
  var hostport = (host + "(?::([0-9]*))?");
  var server = (("(?:(?:((?:[a-z0-9-_.!~*'();:&=+$,]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])*)@)?" + hostport) + ")?");
  var authority = (server + "|(?:[a-z0-9-_.!~*'()$,;:@&=+]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])+");
  var net_path = (("//(" + authority) + ")(/(?:[a-z0-9-_.!~*'():@&=+$,]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])*(?:;(?:[a-z0-9-_.!~*'():@&=+$,]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])*)*(?:/(?:[a-z0-9-_.!~*'():@&=+$,]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])*(?:;(?:[a-z0-9-_.!~*'():@&=+$,]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])*)*)*)?");
  var hier_part = (("(?:" + net_path) + "|(/(?:[a-z0-9-_.!~*'():@&=+$,]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])*(?:;(?:[a-z0-9-_.!~*'():@&=+$,]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])*)*(?:/(?:[a-z0-9-_.!~*'():@&=+$,]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])*(?:;(?:[a-z0-9-_.!~*'():@&=+$,]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])*)*)*))(?:\\?((?:[;/?:@&=+$,\\[\\]a-z0-9-_.!~*'()]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])*))?");
  var absoluteURI = (("([a-z][a-z0-9+-.]*):(?:(" + hier_part) + ")|((?:[a-z0-9-_.!~*'();?:@&=+$,]|%[a-f0-9]{2})(?:[;/?:@&=+$,\\[\\]a-z0-9-_.!~*'()]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])*))");
  var relativeURI = (("((?:" + net_path) + "|(/(?:[a-z0-9-_.!~*'():@&=+$,]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])*(?:;(?:[a-z0-9-_.!~*'():@&=+$,]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])*)*(?:/(?:[a-z0-9-_.!~*'():@&=+$,]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])*(?:;(?:[a-z0-9-_.!~*'():@&=+$,]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])*)*)*)|((?:[a-z0-9-_.!~*'();@&=+$,]|%[a-f0-9]{2})*(?:/(?:[a-z0-9-_.!~*'():@&=+$,]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])*(?:;(?:[a-z0-9-_.!~*'():@&=+$,]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])*)*(?:/(?:[a-z0-9-_.!~*'():@&=+$,]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])*(?:;(?:[a-z0-9-_.!~*'():@&=+$,]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])*)*)*)?))(?:\\?((?:[;/?:@&=+$,\\[\\]a-z0-9-_.!~*'()]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])*))?)");
  var uriRef = (((("^(?:" + absoluteURI) + "|") + relativeURI) + ")(?:#((?:[;/?:@&=+$,\\[\\]a-z0-9-_.!~*'()]|%[a-f0-9]{2}|[^\u0000-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029])*))?$");
  this.java$net$URI$$uriRe$1 = new $g.RegExp(uriRef, "i");
  this.quoteStr$1 = (function(arg1$2) {
    var arg1 = $as_T(arg1$2);
    return $m_Ljava_net_URI$().java$net$URI$$$anonfun$quoteStr$1__T__T(arg1)
  });
  this.userInfoQuoteRe$1 = new $g.RegExp("[\u0000- \"#/<>?@\\[-\\^`{-}\u007f-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029]|%(?![0-9a-f]{2})", "ig");
  this.pathQuoteRe$1 = new $g.RegExp("[\u0000- \"#<>?\\[-\\^`{-}\u007f-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029]|%(?![0-9a-f]{2})", "ig");
  this.authorityQuoteRe$1 = new $g.RegExp("[\u0000- \"#/<>?\\^`{-}\u007f-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029]|%(?![0-9a-f]{2})", "ig");
  this.illegalQuoteRe$1 = new $g.RegExp("[\u0000- \"#<>@\\^`{-}\u007f-\u00a0\u1680\u2000-\u200a\u202f\u205f\u3000\u2028\u2029]|%(?![0-9a-f]{2})", "ig");
  this.nonASCIIQuoteRe$1 = new $g.RegExp("[^\u0000-\u007f]+", "g");
  return this
});
$c_Ljava_net_URI$.prototype.java$net$URI$$uriStr__T__T__T__T__T__T = (function(scheme, authority, path, query, fragment) {
  var resStr = "";
  if ((scheme !== null)) {
    resStr = ((("" + resStr) + scheme) + ":")
  };
  if ((authority !== null)) {
    resStr = ((resStr + "//") + this.quoteAuthority__p1__T__T(authority))
  };
  if ((path !== null)) {
    resStr = (("" + resStr) + this.quotePath__p1__T__T(path))
  };
  if ((query !== null)) {
    resStr = ((resStr + "?") + this.quoteIllegal__p1__T__T(query))
  };
  if ((fragment !== null)) {
    resStr = ((resStr + "#") + this.quoteIllegal__p1__T__T(fragment))
  };
  return resStr
});
$c_Ljava_net_URI$.prototype.loop$1__p1__I__T__T__I = (function(i, x$13, y$2) {
  _loop: while (true) {
    if (((i >= $uI(x$13.length)) || (i >= $uI(y$2.length)))) {
      return (($uI(x$13.length) - $uI(y$2.length)) | 0)
    } else {
      var index = i;
      var jsx$1 = $uI(x$13.charCodeAt(index));
      var index$1 = i;
      var diff = (((65535 & jsx$1) - (65535 & $uI(y$2.charCodeAt(index$1)))) | 0);
      if ((diff !== 0)) {
        return diff
      } else {
        var index$2 = i;
        if (((65535 & $uI(x$13.charCodeAt(index$2))) === 37)) {
          if (((((2 + i) | 0) >= $uI(x$13.length)) || (((2 + i) | 0) >= $uI(y$2.length)))) {
            throw new $c_jl_AssertionError().init___O("Invalid escape in URI")
          };
          var jsx$3 = $m_sjsr_RuntimeString$();
          var beginIndex = ((1 + i) | 0);
          var endIndex = ((3 + i) | 0);
          var jsx$2 = $as_T(x$13.substring(beginIndex, endIndex));
          var beginIndex$1 = ((1 + i) | 0);
          var endIndex$1 = ((3 + i) | 0);
          var cmp = jsx$3.compareToIgnoreCase__T__T__I(jsx$2, $as_T(y$2.substring(beginIndex$1, endIndex$1)));
          if ((cmp !== 0)) {
            return cmp
          } else {
            i = ((3 + i) | 0);
            continue _loop
          }
        } else {
          i = ((1 + i) | 0);
          continue _loop
        }
      }
    }
  }
});
$c_Ljava_net_URI$.prototype.containsNoEncodedComponent$1__p1__T__Z = (function(str$1) {
  var i = 0;
  while ((i !== $uI(str$1.length))) {
    var index = i;
    if (((65535 & $uI(str$1.charCodeAt(index))) === 37)) {
      return false
    };
    i = ((1 + i) | 0)
  };
  return true
});
$c_Ljava_net_URI$.prototype.quotePath__p1__T__T = (function(str) {
  return $as_T(str.replace(this.pathQuoteRe$1, this.quoteStr$1))
});
$c_Ljava_net_URI$.prototype.quoteIllegal__p1__T__T = (function(str) {
  return $as_T(str.replace(this.illegalQuoteRe$1, this.quoteStr$1))
});
$c_Ljava_net_URI$.prototype.java$net$URI$$normalizeEscapes__sjs_js_UndefOr__sjs_js_UndefOr = (function(maybeStr) {
  if ((maybeStr === (void 0))) {
    return (void 0)
  } else {
    var str = $as_T(maybeStr);
    var i = 0;
    var res = "";
    while ((i < $uI(str.length))) {
      var index = i;
      if (((65535 & $uI(str.charCodeAt(index))) === 37)) {
        if ((((2 + i) | 0) >= $uI(str.length))) {
          throw new $c_jl_AssertionError().init___O("Invalid escape in URI")
        };
        var jsx$1 = res;
        var beginIndex = i;
        var endIndex = ((3 + i) | 0);
        var thiz = $as_T(str.substring(beginIndex, endIndex));
        res = (("" + jsx$1) + $as_T(thiz.toUpperCase()));
        i = ((3 + i) | 0)
      } else {
        var jsx$2 = res;
        var beginIndex$1 = i;
        var endIndex$1 = ((1 + i) | 0);
        res = (("" + jsx$2) + $as_T(str.substring(beginIndex$1, endIndex$1)));
        i = ((1 + i) | 0)
      }
    };
    var value = res;
    return value
  }
});
$c_Ljava_net_URI$.prototype.java$net$URI$$$anonfun$quoteStr$1__T__T = (function(str) {
  var buf = $m_Ljava_nio_charset_UTF$und8$().encode__T__Ljava_nio_ByteBuffer(str);
  var res = "";
  while ((buf.java$nio$Buffer$$$undposition$1 !== buf.$$undlimit$1)) {
    var c = (255 & buf.get__B());
    var jsx$2 = res;
    var x = $uD((c >>> 0));
    var jsx$1 = x.toString(16);
    var thiz = $as_T(jsx$1);
    res = ((jsx$2 + ((c <= 15) ? "%0" : "%")) + $as_T(thiz.toUpperCase()))
  };
  return res
});
$c_Ljava_net_URI$.prototype.java$net$URI$$decodeComponent__T__T = (function(str) {
  if (this.containsNoEncodedComponent$1__p1__T__Z(str)) {
    return str
  } else {
    var this$1 = $m_Ljava_nio_CharBuffer$();
    var inBuf = this$1.wrap__jl_CharSequence__I__I__Ljava_nio_CharBuffer(str, 0, $uI(str.length));
    var outBuf = $m_Ljava_nio_CharBuffer$().allocate__I__Ljava_nio_CharBuffer(inBuf.$$undcapacity$1);
    var byteBuf = $m_Ljava_nio_ByteBuffer$().allocate__I__Ljava_nio_ByteBuffer(64);
    var elem$1 = false;
    elem$1 = false;
    var decoder = ($m_Ljava_nio_charset_UTF$und8$(), new $c_Ljava_nio_charset_UTF$und8$Decoder().init___()).onMalformedInput__Ljava_nio_charset_CodingErrorAction__Ljava_nio_charset_CharsetDecoder($m_Ljava_nio_charset_CodingErrorAction$().REPLACE$1).onUnmappableCharacter__Ljava_nio_charset_CodingErrorAction__Ljava_nio_charset_CharsetDecoder($m_Ljava_nio_charset_CodingErrorAction$().REPLACE$1);
    while ((inBuf.java$nio$Buffer$$$undposition$1 !== inBuf.$$undlimit$1)) {
      var x1 = inBuf.get__C();
      switch (x1) {
        case 37: {
          if ((byteBuf.java$nio$Buffer$$$undposition$1 === byteBuf.$$undlimit$1)) {
            $c_Ljava_nio_Buffer.prototype.flip__Ljava_nio_Buffer.call(byteBuf);
            decoder.decode__Ljava_nio_ByteBuffer__Ljava_nio_CharBuffer__Z__Ljava_nio_charset_CoderResult(byteBuf, outBuf, false);
            byteBuf.compact__Ljava_nio_ByteBuffer()
          };
          var c = inBuf.get__C();
          var jsx$1 = $as_T($g.String.fromCharCode(c));
          var c$1 = inBuf.get__C();
          var hexStr = (("" + jsx$1) + $as_T($g.String.fromCharCode(c$1)));
          var v = $m_jl_Integer$().parseInt__T__I__I(hexStr, 16);
          byteBuf.put__B__Ljava_nio_ByteBuffer(((v << 24) >> 24));
          elem$1 = true;
          break
        }
        default: {
          if (elem$1) {
            $c_Ljava_nio_Buffer.prototype.flip__Ljava_nio_Buffer.call(byteBuf);
            decoder.decode__Ljava_nio_ByteBuffer__Ljava_nio_CharBuffer__Z__Ljava_nio_charset_CoderResult(byteBuf, outBuf, true);
            decoder.reset__Ljava_nio_charset_CharsetDecoder();
            $c_Ljava_nio_Buffer.prototype.clear__Ljava_nio_Buffer.call(byteBuf);
            elem$1 = false
          };
          outBuf.put__C__Ljava_nio_CharBuffer(x1)
        }
      }
    };
    if (elem$1) {
      $c_Ljava_nio_Buffer.prototype.flip__Ljava_nio_Buffer.call(byteBuf);
      decoder.decode__Ljava_nio_ByteBuffer__Ljava_nio_CharBuffer__Z__Ljava_nio_charset_CoderResult(byteBuf, outBuf, true);
      decoder.reset__Ljava_nio_charset_CharsetDecoder();
      $c_Ljava_nio_Buffer.prototype.clear__Ljava_nio_Buffer.call(byteBuf);
      elem$1 = false
    };
    $c_Ljava_nio_Buffer.prototype.flip__Ljava_nio_Buffer.call(outBuf);
    return outBuf.toString__T()
  }
});
$c_Ljava_net_URI$.prototype.quoteAuthority__p1__T__T = (function(str) {
  return $as_T(str.replace(this.authorityQuoteRe$1, this.quoteStr$1))
});
var $d_Ljava_net_URI$ = new $TypeData().initClass({
  Ljava_net_URI$: 0
}, false, "java.net.URI$", {
  Ljava_net_URI$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Ljava_net_URI$.prototype.$classData = $d_Ljava_net_URI$;
var $n_Ljava_net_URI$ = (void 0);
function $m_Ljava_net_URI$() {
  if ((!$n_Ljava_net_URI$)) {
    $n_Ljava_net_URI$ = new $c_Ljava_net_URI$().init___()
  };
  return $n_Ljava_net_URI$
}
/** @constructor */
function $c_Ljava_nio_ByteBuffer() {
  $c_Ljava_nio_Buffer.call(this);
  this.$$undarray$2 = null;
  this.$$undarrayOffset$2 = 0;
  this.$$undisBigEndian$2 = false
}
$c_Ljava_nio_ByteBuffer.prototype = new $h_Ljava_nio_Buffer();
$c_Ljava_nio_ByteBuffer.prototype.constructor = $c_Ljava_nio_ByteBuffer;
/** @constructor */
function $h_Ljava_nio_ByteBuffer() {
  /*<skip>*/
}
$h_Ljava_nio_ByteBuffer.prototype = $c_Ljava_nio_ByteBuffer.prototype;
$c_Ljava_nio_ByteBuffer.prototype.equals__O__Z = (function(that) {
  if ((that instanceof $c_Ljava_nio_ByteBuffer)) {
    var x2 = $as_Ljava_nio_ByteBuffer(that);
    return (this.compareTo__Ljava_nio_ByteBuffer__I(x2) === 0)
  } else {
    return false
  }
});
$c_Ljava_nio_ByteBuffer.prototype.init___I__AB__I = (function(_capacity, _array, _arrayOffset) {
  this.$$undarray$2 = _array;
  this.$$undarrayOffset$2 = _arrayOffset;
  $c_Ljava_nio_Buffer.prototype.init___I.call(this, _capacity);
  this.$$undisBigEndian$2 = true;
  return this
});
$c_Ljava_nio_ByteBuffer.prototype.compareTo__O__I = (function(x$1) {
  return this.compareTo__Ljava_nio_ByteBuffer__I($as_Ljava_nio_ByteBuffer(x$1))
});
$c_Ljava_nio_ByteBuffer.prototype.compareTo__Ljava_nio_ByteBuffer__I = (function(that) {
  if ((this === that)) {
    return 0
  } else {
    var thisStart = this.java$nio$Buffer$$$undposition$1;
    var thisRemaining = ((this.$$undlimit$1 - thisStart) | 0);
    var thatStart = that.java$nio$Buffer$$$undposition$1;
    var thatRemaining = ((that.$$undlimit$1 - thatStart) | 0);
    var shortestLength = ((thisRemaining < thatRemaining) ? thisRemaining : thatRemaining);
    var i = 0;
    while ((i !== shortestLength)) {
      var index = ((thisStart + i) | 0);
      var arg1 = $uB(this.$$undarray$2.get(((this.$$undarrayOffset$2 + index) | 0)));
      var index$1 = ((thatStart + i) | 0);
      var arg2 = $uB(that.$$undarray$2.get(((that.$$undarrayOffset$2 + index$1) | 0)));
      var x$1 = $uB(arg1);
      var x$2 = $uB(arg2);
      var cmp = ((x$1 - x$2) | 0);
      if ((cmp !== 0)) {
        return cmp
      };
      i = ((1 + i) | 0)
    };
    return ((thisRemaining === thatRemaining) ? 0 : ((thisRemaining < thatRemaining) ? (-1) : 1))
  }
});
$c_Ljava_nio_ByteBuffer.prototype.put__Ljava_nio_ByteBuffer__Ljava_nio_ByteBuffer = (function(src) {
  if ((src === this)) {
    throw new $c_jl_IllegalArgumentException().init___()
  };
  if (this.$$undreadOnly$3) {
    throw new $c_Ljava_nio_ReadOnlyBufferException().init___()
  };
  var srcLimit = src.$$undlimit$1;
  var srcPos = src.java$nio$Buffer$$$undposition$1;
  var length = ((srcLimit - srcPos) | 0);
  var p = this.java$nio$Buffer$$$undposition$1;
  var newPos = ((p + length) | 0);
  if ((newPos > this.$$undlimit$1)) {
    throw new $c_Ljava_nio_BufferOverflowException().init___()
  };
  this.java$nio$Buffer$$$undposition$1 = newPos;
  var selfPos = p;
  $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call(src, srcLimit);
  var srcArray = src.$$undarray$2;
  if ((srcArray !== null)) {
    var startIndex = selfPos;
    var offset = ((src.$$undarrayOffset$2 + srcPos) | 0);
    $systemArraycopy(srcArray, offset, this.$$undarray$2, ((this.$$undarrayOffset$2 + startIndex) | 0), length)
  } else {
    while ((srcPos !== srcLimit)) {
      var index$1 = selfPos;
      var index = srcPos;
      var elem = $uB(src.$$undarray$2.get(((src.$$undarrayOffset$2 + index) | 0)));
      var elem$1 = $uB(elem);
      this.$$undarray$2.set(((this.$$undarrayOffset$2 + index$1) | 0), $uB(elem$1));
      srcPos = ((1 + srcPos) | 0);
      selfPos = ((1 + selfPos) | 0)
    }
  };
  return this
});
$c_Ljava_nio_ByteBuffer.prototype.hashCode__I = (function() {
  var start = this.java$nio$Buffer$$$undposition$1;
  var end = this.$$undlimit$1;
  var h = (-547316498);
  var i = start;
  while ((i !== end)) {
    var jsx$3 = $m_s_util_hashing_MurmurHash3$();
    var jsx$2 = h;
    var jsx$1 = $m_sr_Statics$();
    var index = i;
    h = jsx$3.mix__I__I__I(jsx$2, jsx$1.anyHash__O__I($uB(this.$$undarray$2.get(((this.$$undarrayOffset$2 + index) | 0)))));
    i = ((1 + i) | 0)
  };
  return $m_s_util_hashing_MurmurHash3$().finalizeHash__I__I__I(h, ((end - start) | 0))
});
function $as_Ljava_nio_ByteBuffer(obj) {
  return (((obj instanceof $c_Ljava_nio_ByteBuffer) || (obj === null)) ? obj : $throwClassCastException(obj, "java.nio.ByteBuffer"))
}
function $isArrayOf_Ljava_nio_ByteBuffer(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Ljava_nio_ByteBuffer)))
}
function $asArrayOf_Ljava_nio_ByteBuffer(obj, depth) {
  return (($isArrayOf_Ljava_nio_ByteBuffer(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.nio.ByteBuffer;", depth))
}
/** @constructor */
function $c_Ljava_nio_charset_UTF$und8$() {
  $c_Ljava_nio_charset_Charset.call(this);
  this.java$nio$charset$UTF$und8$$lengthByLeading$2 = null
}
$c_Ljava_nio_charset_UTF$und8$.prototype = new $h_Ljava_nio_charset_Charset();
$c_Ljava_nio_charset_UTF$und8$.prototype.constructor = $c_Ljava_nio_charset_UTF$und8$;
/** @constructor */
function $h_Ljava_nio_charset_UTF$und8$() {
  /*<skip>*/
}
$h_Ljava_nio_charset_UTF$und8$.prototype = $c_Ljava_nio_charset_UTF$und8$.prototype;
$c_Ljava_nio_charset_UTF$und8$.prototype.init___ = (function() {
  $c_Ljava_nio_charset_Charset.prototype.init___T__AT.call(this, "UTF-8", $makeNativeArrayWrapper($d_T.getArrayOf(), ["UTF8", "unicode-1-1-utf-8"]));
  $n_Ljava_nio_charset_UTF$und8$ = this;
  this.java$nio$charset$UTF$und8$$lengthByLeading$2 = $makeNativeArrayWrapper($d_I.getArrayOf(), [(-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1), 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, (-1), (-1), (-1), (-1), (-1), (-1), (-1), (-1)]);
  return this
});
var $d_Ljava_nio_charset_UTF$und8$ = new $TypeData().initClass({
  Ljava_nio_charset_UTF$und8$: 0
}, false, "java.nio.charset.UTF_8$", {
  Ljava_nio_charset_UTF$und8$: 1,
  Ljava_nio_charset_Charset: 1,
  O: 1,
  jl_Comparable: 1
});
$c_Ljava_nio_charset_UTF$und8$.prototype.$classData = $d_Ljava_nio_charset_UTF$und8$;
var $n_Ljava_nio_charset_UTF$und8$ = (void 0);
function $m_Ljava_nio_charset_UTF$und8$() {
  if ((!$n_Ljava_nio_charset_UTF$und8$)) {
    $n_Ljava_nio_charset_UTF$und8$ = new $c_Ljava_nio_charset_UTF$und8$().init___()
  };
  return $n_Ljava_nio_charset_UTF$und8$
}
/** @constructor */
function $c_Lorg_mulesoft_common_io_Fs$() {
  $c_Lorg_mulesoft_common_io_JsServerFileSystem.call(this)
}
$c_Lorg_mulesoft_common_io_Fs$.prototype = new $h_Lorg_mulesoft_common_io_JsServerFileSystem();
$c_Lorg_mulesoft_common_io_Fs$.prototype.constructor = $c_Lorg_mulesoft_common_io_Fs$;
/** @constructor */
function $h_Lorg_mulesoft_common_io_Fs$() {
  /*<skip>*/
}
$h_Lorg_mulesoft_common_io_Fs$.prototype = $c_Lorg_mulesoft_common_io_Fs$.prototype;
$c_Lorg_mulesoft_common_io_Fs$.prototype.init___ = (function() {
  return this
});
var $d_Lorg_mulesoft_common_io_Fs$ = new $TypeData().initClass({
  Lorg_mulesoft_common_io_Fs$: 0
}, false, "org.mulesoft.common.io.Fs$", {
  Lorg_mulesoft_common_io_Fs$: 1,
  Lorg_mulesoft_common_io_JsServerFileSystem: 1,
  O: 1,
  Lorg_mulesoft_common_io_FileSystem: 1
});
$c_Lorg_mulesoft_common_io_Fs$.prototype.$classData = $d_Lorg_mulesoft_common_io_Fs$;
var $n_Lorg_mulesoft_common_io_Fs$ = (void 0);
function $m_Lorg_mulesoft_common_io_Fs$() {
  if ((!$n_Lorg_mulesoft_common_io_Fs$)) {
    $n_Lorg_mulesoft_common_io_Fs$ = new $c_Lorg_mulesoft_common_io_Fs$().init___()
  };
  return $n_Lorg_mulesoft_common_io_Fs$
}
/** @constructor */
function $c_Lorg_mulesoft_common_time_SimpleDateTime$() {
  $c_O.call(this);
  this.ZeroTime$1 = null;
  this.Epoch$1 = null;
  this.datePattern$1 = null;
  this.timePattern$1 = null;
  this.timeZonePattern$1 = null;
  this.timeSeparation$1 = null;
  this.dateRegex$1 = null;
  this.dateTimeRegex$1 = null;
  this.partialTimeRegex$1 = null;
  this.fullTimeRegex$1 = null
}
$c_Lorg_mulesoft_common_time_SimpleDateTime$.prototype = new $h_O();
$c_Lorg_mulesoft_common_time_SimpleDateTime$.prototype.constructor = $c_Lorg_mulesoft_common_time_SimpleDateTime$;
/** @constructor */
function $h_Lorg_mulesoft_common_time_SimpleDateTime$() {
  /*<skip>*/
}
$h_Lorg_mulesoft_common_time_SimpleDateTime$.prototype = $c_Lorg_mulesoft_common_time_SimpleDateTime$.prototype;
$c_Lorg_mulesoft_common_time_SimpleDateTime$.prototype.init___ = (function() {
  $n_Lorg_mulesoft_common_time_SimpleDateTime$ = this;
  this.ZeroTime$1 = new $c_Lorg_mulesoft_common_time_TimeOfDay().init___I__I__I__I(0, 0, 0, 0);
  this.Epoch$1 = new $c_Lorg_mulesoft_common_time_SimpleDateTime().init___I__I__I__s_Option__s_Option(1970, 1, 1, new $c_s_Some().init___O(this.ZeroTime$1), new $c_s_Some().init___O(0));
  this.datePattern$1 = "(\\d{4})-(\\d\\d?)-(\\d\\d?)";
  this.timePattern$1 = "(\\d\\d?):(\\d\\d?)(?::(\\d\\d?))?(?:\\.(\\d{0,9}))?";
  this.timeZonePattern$1 = "(?:(?:[\\ \\t]*)?(Z|([-+]\\d\\d?)(?::(\\d\\d?))?))?";
  this.timeSeparation$1 = "(?:[Tt]|[\\ \\t]+)";
  var x = this.datePattern$1;
  var this$2 = new $c_sci_StringOps().init___T(x);
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.dateRegex$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  var x$1 = (((((this.datePattern$1 + "(?:") + this.timeSeparation$1) + this.timePattern$1) + this.timeZonePattern$1) + ")?");
  var this$5 = new $c_sci_StringOps().init___T(x$1);
  var groupNames$1 = $m_sci_Nil$();
  var $$this$1 = this$5.repr$1;
  this.dateTimeRegex$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this$1, groupNames$1);
  var x$2 = this.timePattern$1;
  var this$8 = new $c_sci_StringOps().init___T(x$2);
  var groupNames$2 = $m_sci_Nil$();
  var $$this$2 = this$8.repr$1;
  this.partialTimeRegex$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this$2, groupNames$2);
  var x$3 = (("" + this.timePattern$1) + this.timeZonePattern$1);
  var this$11 = new $c_sci_StringOps().init___T(x$3);
  var groupNames$3 = $m_sci_Nil$();
  var $$this$3 = this$11.repr$1;
  this.fullTimeRegex$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this$3, groupNames$3);
  return this
});
$c_Lorg_mulesoft_common_time_SimpleDateTime$.prototype.buildTimeOfDay__p1__T__T__T__T__Lorg_mulesoft_common_time_TimeOfDay = (function(hours, minutes, seconds, nanos) {
  var this$1 = $m_jl_Integer$();
  var jsx$4 = this$1.parseInt__T__I__I(hours, 10);
  var this$2 = $m_jl_Integer$();
  var jsx$3 = this$2.parseInt__T__I__I(minutes, 10);
  var jsx$2 = this.toInt__p1__T__I(seconds);
  if ((nanos === null)) {
    var jsx$1 = 0
  } else {
    var this$6 = $m_jl_Integer$();
    var this$5 = new $c_sci_StringOps().init___T("0");
    var n = ((9 - $uI(nanos.length)) | 0);
    var s = (("" + nanos) + $f_sci_StringLike__$$times__I__T(this$5, n));
    var jsx$1 = this$6.parseInt__T__I__I(s, 10)
  };
  return new $c_Lorg_mulesoft_common_time_TimeOfDay().init___I__I__I__I(jsx$4, jsx$3, jsx$2, jsx$1)
});
$c_Lorg_mulesoft_common_time_SimpleDateTime$.prototype.toInt__p1__T__I = (function(s) {
  if ($m_Lorg_mulesoft_common_core_package$Strings$().isNullOrEmpty$extension__T__Z(s)) {
    return 0
  } else {
    var this$2 = $m_jl_Integer$();
    return this$2.parseInt__T__I__I(s, 10)
  }
});
$c_Lorg_mulesoft_common_time_SimpleDateTime$.prototype.unapply__T__s_Option = (function(arg) {
  return this.parse__T__s_util_Either(arg).toOption__s_Option()
});
$c_Lorg_mulesoft_common_time_SimpleDateTime$.prototype.parse__T__s_util_Either = (function(str) {
  var o7 = this.dateTimeRegex$1.unapplySeq__jl_CharSequence__s_Option(str);
  if ((!o7.isEmpty__Z())) {
    if ((o7.get__O() !== null)) {
      var this$1 = $as_sc_LinearSeqOptimized(o7.get__O());
      var jsx$1 = ($f_sc_LinearSeqOptimized__lengthCompare__I__I(this$1, 10) === 0)
    } else {
      var jsx$1 = false
    }
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var year = $as_T($as_sc_LinearSeqOptimized(o7.get__O()).apply__I__O(0));
    var month = $as_T($as_sc_LinearSeqOptimized(o7.get__O()).apply__I__O(1));
    var day = $as_T($as_sc_LinearSeqOptimized(o7.get__O()).apply__I__O(2));
    var hours = $as_T($as_sc_LinearSeqOptimized(o7.get__O()).apply__I__O(3));
    var minutes = $as_T($as_sc_LinearSeqOptimized(o7.get__O()).apply__I__O(4));
    var seconds = $as_T($as_sc_LinearSeqOptimized(o7.get__O()).apply__I__O(5));
    var nanos = $as_T($as_sc_LinearSeqOptimized(o7.get__O()).apply__I__O(6));
    var z = $as_T($as_sc_LinearSeqOptimized(o7.get__O()).apply__I__O(7));
    var offsetHours = $as_T($as_sc_LinearSeqOptimized(o7.get__O()).apply__I__O(8));
    var offsetMinutes = $as_T($as_sc_LinearSeqOptimized(o7.get__O()).apply__I__O(9));
    try {
      $m_s_package$();
      var value = new $c_Lorg_mulesoft_common_time_SimpleDateTime().init___I__I__I__s_Option__s_Option($m_Lorg_mulesoft_common_time_SimpleDateTime$().toInt__p1__T__I(year), $m_Lorg_mulesoft_common_time_SimpleDateTime$().toInt__p1__T__I(month), $m_Lorg_mulesoft_common_time_SimpleDateTime$().toInt__p1__T__I(day), ((hours === null) ? $m_s_None$() : new $c_s_Some().init___O($m_Lorg_mulesoft_common_time_SimpleDateTime$().buildTimeOfDay__p1__T__T__T__T__Lorg_mulesoft_common_time_TimeOfDay(hours, minutes, seconds, nanos))), $m_Lorg_mulesoft_common_time_SimpleDateTime$().buildTimeZone__p1__T__T__T__s_Option(z, offsetHours, offsetMinutes));
      return new $c_s_util_Right().init___O(value)
    } catch (e) {
      var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
      if ((e$2 !== null)) {
        if ((e$2 instanceof $c_Lorg_mulesoft_common_parse_ParseException)) {
          var x5 = $as_Lorg_mulesoft_common_parse_ParseException(e$2);
          var e$3 = x5.parseError$4;
          $m_s_package$();
          return new $c_s_util_Left().init___O(e$3)
        } else {
          throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(e$2)
        }
      } else {
        throw e
      }
    }
  };
  return $m_Lorg_mulesoft_common_parse_ParseError$().formatError__T__T__s_util_Either(str, "")
});
$c_Lorg_mulesoft_common_time_SimpleDateTime$.prototype.org$mulesoft$common$time$SimpleDateTime$$zoneOffsetToString__I__T = (function(zoneOffset) {
  if ((zoneOffset === 0)) {
    return "Z"
  } else {
    var hours = ((zoneOffset / 3600) | 0);
    var minutes = ((((zoneOffset / 60) | 0) % 60) | 0);
    var sign = ((zoneOffset > 0) ? "+" : "-");
    if ((minutes === 0)) {
      var mins = ""
    } else {
      var arg$macro$1 = ((minutes < 0) ? ((-minutes) | 0) : minutes);
      var this$7 = new $c_sci_StringOps().init___T(":%02d");
      var array = [arg$macro$1];
      var jsx$2 = $m_sjsr_RuntimeString$();
      var $$this = this$7.repr$1;
      $m_sc_Seq$();
      $m_sjs_js_WrappedArray$();
      var array$1 = [];
      var x1 = $uI(array.length);
      switch (x1) {
        case (-1): {
          break
        }
      };
      var i = 0;
      var len = $uI(array.length);
      while ((i < len)) {
        var index = i;
        var arg1 = array[index];
        var elem = $f_sci_StringLike__unwrapArg__psci_StringLike__O__O(this$7, arg1);
        array$1.push(elem);
        i = ((1 + i) | 0)
      };
      $m_s_reflect_ManifestFactory$ObjectManifest$();
      var len$1 = $uI(array$1.length);
      var result = $newArrayObject($d_O.getArrayOf(), [len$1]);
      var len$2 = result.u.length;
      var i$1 = 0;
      var j = 0;
      var x = $uI(array$1.length);
      var x$1 = ((x < len$2) ? x : len$2);
      var that = result.u.length;
      var end = ((x$1 < that) ? x$1 : that);
      while ((i$1 < end)) {
        var jsx$1 = j;
        var index$1 = i$1;
        result.set(jsx$1, array$1[index$1]);
        i$1 = ((1 + i$1) | 0);
        j = ((1 + j) | 0)
      };
      var mins = jsx$2.format__T__AO__T($$this, result)
    };
    var arg$macro$3 = ((hours < 0) ? ((-hours) | 0) : hours);
    var this$27 = new $c_sci_StringOps().init___T("%s%02d%s");
    var array$2 = [sign, arg$macro$3, mins];
    var jsx$4 = $m_sjsr_RuntimeString$();
    var $$this$1 = this$27.repr$1;
    $m_sc_Seq$();
    $m_sjs_js_WrappedArray$();
    var array$3 = [];
    var x1$1 = $uI(array$2.length);
    switch (x1$1) {
      case (-1): {
        break
      }
    };
    var i$2 = 0;
    var len$3 = $uI(array$2.length);
    while ((i$2 < len$3)) {
      var index$2 = i$2;
      var arg1$1 = array$2[index$2];
      var elem$1 = $f_sci_StringLike__unwrapArg__psci_StringLike__O__O(this$27, arg1$1);
      array$3.push(elem$1);
      i$2 = ((1 + i$2) | 0)
    };
    $m_s_reflect_ManifestFactory$ObjectManifest$();
    var len$4 = $uI(array$3.length);
    var result$1 = $newArrayObject($d_O.getArrayOf(), [len$4]);
    var len$5 = result$1.u.length;
    var i$3 = 0;
    var j$1 = 0;
    var x$2 = $uI(array$3.length);
    var x$3 = ((x$2 < len$5) ? x$2 : len$5);
    var that$1 = result$1.u.length;
    var end$1 = ((x$3 < that$1) ? x$3 : that$1);
    while ((i$3 < end$1)) {
      var jsx$3 = j$1;
      var index$3 = i$3;
      result$1.set(jsx$3, array$3[index$3]);
      i$3 = ((1 + i$3) | 0);
      j$1 = ((1 + j$1) | 0)
    };
    return jsx$4.format__T__AO__T($$this$1, result$1)
  }
});
$c_Lorg_mulesoft_common_time_SimpleDateTime$.prototype.org$mulesoft$common$time$SimpleDateTime$$validateDate__I__I__I__V = (function(year, month, day) {
  if ((year === 0)) {
    var offending = year
  } else if (((month < 1) || (month > 12))) {
    var offending = month
  } else if (((day < 1) || (day > 31))) {
    var offending = day
  } else if (((day === 31) && ((((month === 4) || (month === 6)) || (month === 9)) || (month === 11)))) {
    var offending = day
  } else {
    if ((!((month === 2) && ((day > 29) || ((day === 29) && ((((year % 4) | 0) !== 0) || (((year >= 1600) && (((year % 100) | 0) === 0)) && (((year % 400) | 0) !== 0)))))))) {
      return (void 0)
    };
    var offending = day
  };
  throw new $c_Lorg_mulesoft_common_parse_ParseException().init___Lorg_mulesoft_common_parse_ParseError(new $c_Lorg_mulesoft_common_parse_RangeError().init___I(offending))
});
$c_Lorg_mulesoft_common_time_SimpleDateTime$.prototype.buildTimeZone__p1__T__T__T__s_Option = (function(z, offsetHours, offsetMinutes) {
  if ((z === null)) {
    return $m_s_None$()
  } else if ((offsetHours === null)) {
    return new $c_s_Some().init___O(0)
  } else {
    var oh = this.toInt__p1__T__I(offsetHours);
    var om = this.toInt__p1__T__I(offsetMinutes);
    if (((oh < (-24)) || (oh > 24))) {
      throw new $c_Lorg_mulesoft_common_parse_ParseException().init___Lorg_mulesoft_common_parse_ParseError(new $c_Lorg_mulesoft_common_parse_RangeError().init___I(oh))
    };
    if (((om < 0) || (om > 60))) {
      throw new $c_Lorg_mulesoft_common_parse_ParseException().init___Lorg_mulesoft_common_parse_ParseError(new $c_Lorg_mulesoft_common_parse_RangeError().init___I(om))
    };
    return new $c_s_Some().init___O((($imul(3600, oh) + $imul(60, ((oh < 0) ? ((-om) | 0) : om))) | 0))
  }
});
var $d_Lorg_mulesoft_common_time_SimpleDateTime$ = new $TypeData().initClass({
  Lorg_mulesoft_common_time_SimpleDateTime$: 0
}, false, "org.mulesoft.common.time.SimpleDateTime$", {
  Lorg_mulesoft_common_time_SimpleDateTime$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_mulesoft_common_time_SimpleDateTime$.prototype.$classData = $d_Lorg_mulesoft_common_time_SimpleDateTime$;
var $n_Lorg_mulesoft_common_time_SimpleDateTime$ = (void 0);
function $m_Lorg_mulesoft_common_time_SimpleDateTime$() {
  if ((!$n_Lorg_mulesoft_common_time_SimpleDateTime$)) {
    $n_Lorg_mulesoft_common_time_SimpleDateTime$ = new $c_Lorg_mulesoft_common_time_SimpleDateTime$().init___()
  };
  return $n_Lorg_mulesoft_common_time_SimpleDateTime$
}
/** @constructor */
function $c_Lorg_mulesoft_common_time_TimeOfDay$() {
  $c_O.call(this)
}
$c_Lorg_mulesoft_common_time_TimeOfDay$.prototype = new $h_O();
$c_Lorg_mulesoft_common_time_TimeOfDay$.prototype.constructor = $c_Lorg_mulesoft_common_time_TimeOfDay$;
/** @constructor */
function $h_Lorg_mulesoft_common_time_TimeOfDay$() {
  /*<skip>*/
}
$h_Lorg_mulesoft_common_time_TimeOfDay$.prototype = $c_Lorg_mulesoft_common_time_TimeOfDay$.prototype;
$c_Lorg_mulesoft_common_time_TimeOfDay$.prototype.init___ = (function() {
  return this
});
$c_Lorg_mulesoft_common_time_TimeOfDay$.prototype.org$mulesoft$common$time$TimeOfDay$$validateTimeOfDay__I__I__I__I__V = (function(hour, minute, second, nano) {
  if (((hour < 0) || (hour > 24))) {
    var offending = hour
  } else if ((((minute < 0) || (minute > 60)) || ((hour === 24) && (minute > 0)))) {
    var offending = minute
  } else if ((((second < 0) || (second > 60)) || ((hour === 24) && (second > 0)))) {
    var offending = second
  } else {
    if ((!(((nano < 0) || (nano > 999999999)) || ((hour === 24) && (nano > 0))))) {
      return (void 0)
    };
    var offending = nano
  };
  throw new $c_Lorg_mulesoft_common_parse_ParseException().init___Lorg_mulesoft_common_parse_ParseError(new $c_Lorg_mulesoft_common_parse_RangeError().init___I(offending))
});
var $d_Lorg_mulesoft_common_time_TimeOfDay$ = new $TypeData().initClass({
  Lorg_mulesoft_common_time_TimeOfDay$: 0
}, false, "org.mulesoft.common.time.TimeOfDay$", {
  Lorg_mulesoft_common_time_TimeOfDay$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_mulesoft_common_time_TimeOfDay$.prototype.$classData = $d_Lorg_mulesoft_common_time_TimeOfDay$;
var $n_Lorg_mulesoft_common_time_TimeOfDay$ = (void 0);
function $m_Lorg_mulesoft_common_time_TimeOfDay$() {
  if ((!$n_Lorg_mulesoft_common_time_TimeOfDay$)) {
    $n_Lorg_mulesoft_common_time_TimeOfDay$ = new $c_Lorg_mulesoft_common_time_TimeOfDay$().init___()
  };
  return $n_Lorg_mulesoft_common_time_TimeOfDay$
}
/** @constructor */
function $c_Lorg_mulesoft_lexer_InputRange$() {
  $c_O.call(this);
  this.Zero$1 = null;
  this.All$1 = null
}
$c_Lorg_mulesoft_lexer_InputRange$.prototype = new $h_O();
$c_Lorg_mulesoft_lexer_InputRange$.prototype.constructor = $c_Lorg_mulesoft_lexer_InputRange$;
/** @constructor */
function $h_Lorg_mulesoft_lexer_InputRange$() {
  /*<skip>*/
}
$h_Lorg_mulesoft_lexer_InputRange$.prototype = $c_Lorg_mulesoft_lexer_InputRange$.prototype;
$c_Lorg_mulesoft_lexer_InputRange$.prototype.init___ = (function() {
  $n_Lorg_mulesoft_lexer_InputRange$ = this;
  this.Zero$1 = new $c_Lorg_mulesoft_lexer_InputRange().init___I__I__I__I(1, 0, 1, 0);
  this.All$1 = new $c_Lorg_mulesoft_lexer_InputRange().init___I__I__I__I(1, 0, 2147483647, 2147483647);
  return this
});
$c_Lorg_mulesoft_lexer_InputRange$.prototype.apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange = (function(lineFrom, columnFrom, lineTo, columnTo) {
  return (((((lineFrom <= 1) && (columnFrom <= 0)) && (lineTo <= 1)) && (columnTo <= 0)) ? this.Zero$1 : (((((lineFrom <= 1) && (columnFrom <= 0)) && (lineTo === 2147483647)) && (lineFrom === 2147483647)) ? this.All$1 : new $c_Lorg_mulesoft_lexer_InputRange().init___I__I__I__I(lineFrom, columnFrom, lineTo, columnTo)))
});
var $d_Lorg_mulesoft_lexer_InputRange$ = new $TypeData().initClass({
  Lorg_mulesoft_lexer_InputRange$: 0
}, false, "org.mulesoft.lexer.InputRange$", {
  Lorg_mulesoft_lexer_InputRange$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_mulesoft_lexer_InputRange$.prototype.$classData = $d_Lorg_mulesoft_lexer_InputRange$;
var $n_Lorg_mulesoft_lexer_InputRange$ = (void 0);
function $m_Lorg_mulesoft_lexer_InputRange$() {
  if ((!$n_Lorg_mulesoft_lexer_InputRange$)) {
    $n_Lorg_mulesoft_lexer_InputRange$ = new $c_Lorg_mulesoft_lexer_InputRange$().init___()
  };
  return $n_Lorg_mulesoft_lexer_InputRange$
}
/** @constructor */
function $c_Lorg_mulesoft_lexer_Position() {
  $c_O.call(this);
  this.line$1 = 0;
  this.column$1 = 0;
  this.offset$1 = 0
}
$c_Lorg_mulesoft_lexer_Position.prototype = new $h_O();
$c_Lorg_mulesoft_lexer_Position.prototype.constructor = $c_Lorg_mulesoft_lexer_Position;
/** @constructor */
function $h_Lorg_mulesoft_lexer_Position() {
  /*<skip>*/
}
$h_Lorg_mulesoft_lexer_Position.prototype = $c_Lorg_mulesoft_lexer_Position.prototype;
$c_Lorg_mulesoft_lexer_Position.prototype.equals__O__Z = (function(obj) {
  if ((obj instanceof $c_Lorg_mulesoft_lexer_Position)) {
    var x2 = $as_Lorg_mulesoft_lexer_Position(obj);
    return (((this.line$1 === x2.line$1) && (this.column$1 === x2.column$1)) && (this.offset$1 === x2.offset$1))
  } else {
    return false
  }
});
$c_Lorg_mulesoft_lexer_Position.prototype.init___I__I__I = (function(line, column, offset) {
  this.line$1 = line;
  this.column$1 = column;
  this.offset$1 = offset;
  return this
});
$c_Lorg_mulesoft_lexer_Position.prototype.isZero__Z = (function() {
  return (((this.line$1 === 0) && (this.column$1 === 0)) && (this.offset$1 === 0))
});
$c_Lorg_mulesoft_lexer_Position.prototype.toString__T = (function() {
  var lc = (((this.line$1 <= 0) && (this.column$1 <= 0)) ? "" : (((("(" + this.line$1) + ", ") + this.column$1) + ")"));
  return ((lc + "@") + this.offset$1)
});
$c_Lorg_mulesoft_lexer_Position.prototype.compareTo__O__I = (function(that) {
  return this.compare__Lorg_mulesoft_lexer_Position__I($as_Lorg_mulesoft_lexer_Position(that))
});
$c_Lorg_mulesoft_lexer_Position.prototype.compare__O__I = (function(that) {
  return this.compare__Lorg_mulesoft_lexer_Position__I($as_Lorg_mulesoft_lexer_Position(that))
});
$c_Lorg_mulesoft_lexer_Position.prototype.hashCode__I = (function() {
  return ((this.line$1 + $imul(31, ((this.column$1 + $imul(31, this.offset$1)) | 0))) | 0)
});
$c_Lorg_mulesoft_lexer_Position.prototype.$$plus__Lorg_mulesoft_lexer_Position__Lorg_mulesoft_lexer_Position = (function(that) {
  return (this.isZero__Z() ? that : (that.isZero__Z() ? this : $m_Lorg_mulesoft_lexer_Position$().apply__I__I__I__Lorg_mulesoft_lexer_Position(((this.line$1 + that.line$1) | 0), ((this.column$1 + that.column$1) | 0), ((this.offset$1 + that.offset$1) | 0))))
});
$c_Lorg_mulesoft_lexer_Position.prototype.compare__Lorg_mulesoft_lexer_Position__I = (function(that) {
  if ((this.offset$1 !== that.offset$1)) {
    var x = this.offset$1;
    var y = that.offset$1;
    return ((x === y) ? 0 : ((x < y) ? (-1) : 1))
  } else if ((this.line$1 !== that.line$1)) {
    var x$1 = this.line$1;
    var y$1 = that.line$1;
    return ((x$1 === y$1) ? 0 : ((x$1 < y$1) ? (-1) : 1))
  } else {
    var x$2 = that.column$1;
    var y$2 = this.column$1;
    return ((x$2 === y$2) ? 0 : ((x$2 < y$2) ? (-1) : 1))
  }
});
function $as_Lorg_mulesoft_lexer_Position(obj) {
  return (((obj instanceof $c_Lorg_mulesoft_lexer_Position) || (obj === null)) ? obj : $throwClassCastException(obj, "org.mulesoft.lexer.Position"))
}
function $isArrayOf_Lorg_mulesoft_lexer_Position(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_mulesoft_lexer_Position)))
}
function $asArrayOf_Lorg_mulesoft_lexer_Position(obj, depth) {
  return (($isArrayOf_Lorg_mulesoft_lexer_Position(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.mulesoft.lexer.Position;", depth))
}
var $d_Lorg_mulesoft_lexer_Position = new $TypeData().initClass({
  Lorg_mulesoft_lexer_Position: 0
}, false, "org.mulesoft.lexer.Position", {
  Lorg_mulesoft_lexer_Position: 1,
  O: 1,
  s_math_Ordered: 1,
  jl_Comparable: 1
});
$c_Lorg_mulesoft_lexer_Position.prototype.$classData = $d_Lorg_mulesoft_lexer_Position;
/** @constructor */
function $c_Lorg_mulesoft_lexer_SourceLocation$() {
  $c_O.call(this);
  this.Unknown$1 = null;
  this.cache$1 = null
}
$c_Lorg_mulesoft_lexer_SourceLocation$.prototype = new $h_O();
$c_Lorg_mulesoft_lexer_SourceLocation$.prototype.constructor = $c_Lorg_mulesoft_lexer_SourceLocation$;
/** @constructor */
function $h_Lorg_mulesoft_lexer_SourceLocation$() {
  /*<skip>*/
}
$h_Lorg_mulesoft_lexer_SourceLocation$.prototype = $c_Lorg_mulesoft_lexer_SourceLocation$.prototype;
$c_Lorg_mulesoft_lexer_SourceLocation$.prototype.init___ = (function() {
  $n_Lorg_mulesoft_lexer_SourceLocation$ = this;
  this.Unknown$1 = ($m_Lorg_mulesoft_lexer_SourceLocation$(), new $c_Lorg_mulesoft_lexer_SourceLocation().init___T__I__I__I__I__I__I("", 0, 0, 0, 0, 0, 0));
  this.cache$1 = new $c_scm_HashMap().init___();
  return this
});
$c_Lorg_mulesoft_lexer_SourceLocation$.prototype.apply__T__Lorg_mulesoft_lexer_SourceLocation = (function(sourceName) {
  if ((sourceName === null)) {
    var jsx$1 = true
  } else {
    if ((sourceName === null)) {
      throw new $c_jl_NullPointerException().init___()
    };
    var jsx$1 = (sourceName === "")
  };
  if (jsx$1) {
    return this.Unknown$1
  } else {
    var x1 = this.cache$1.get__O__s_Option(sourceName);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var v = $as_Lorg_mulesoft_lexer_SourceLocation(x2.value$2);
      return v
    } else {
      $m_Lorg_mulesoft_lexer_SourceLocation$();
      var location = new $c_Lorg_mulesoft_lexer_SourceLocation().init___T__I__I__I__I__I__I(sourceName, 0, 0, 0, 0, 0, 0);
      this.cache$1.update__O__O__V(sourceName, location);
      return location
    }
  }
});
$c_Lorg_mulesoft_lexer_SourceLocation$.prototype.apply__T__Lorg_mulesoft_lexer_Position__Lorg_mulesoft_lexer_Position__Lorg_mulesoft_lexer_SourceLocation = (function(sourceName, from, to) {
  return ((from.isZero__Z() && to.isZero__Z()) ? $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName) : new $c_Lorg_mulesoft_lexer_SourceLocation().init___T__I__I__I__I__I__I(sourceName, from.offset$1, to.offset$1, from.line$1, from.column$1, to.line$1, to.column$1))
});
var $d_Lorg_mulesoft_lexer_SourceLocation$ = new $TypeData().initClass({
  Lorg_mulesoft_lexer_SourceLocation$: 0
}, false, "org.mulesoft.lexer.SourceLocation$", {
  Lorg_mulesoft_lexer_SourceLocation$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_mulesoft_lexer_SourceLocation$.prototype.$classData = $d_Lorg_mulesoft_lexer_SourceLocation$;
var $n_Lorg_mulesoft_lexer_SourceLocation$ = (void 0);
function $m_Lorg_mulesoft_lexer_SourceLocation$() {
  if ((!$n_Lorg_mulesoft_lexer_SourceLocation$)) {
    $n_Lorg_mulesoft_lexer_SourceLocation$ = new $c_Lorg_mulesoft_lexer_SourceLocation$().init___()
  };
  return $n_Lorg_mulesoft_lexer_SourceLocation$
}
/** @constructor */
function $c_Lorg_yaml_builder_DocBuilder$Scalar$() {
  $c_O.call(this)
}
$c_Lorg_yaml_builder_DocBuilder$Scalar$.prototype = new $h_O();
$c_Lorg_yaml_builder_DocBuilder$Scalar$.prototype.constructor = $c_Lorg_yaml_builder_DocBuilder$Scalar$;
/** @constructor */
function $h_Lorg_yaml_builder_DocBuilder$Scalar$() {
  /*<skip>*/
}
$h_Lorg_yaml_builder_DocBuilder$Scalar$.prototype = $c_Lorg_yaml_builder_DocBuilder$Scalar$.prototype;
$c_Lorg_yaml_builder_DocBuilder$Scalar$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_builder_DocBuilder$Scalar$.prototype.apply__Lorg_yaml_builder_DocBuilder$SType__T__Lorg_yaml_builder_DocBuilder$Scalar = (function(t, value) {
  var x = $m_Lorg_yaml_builder_DocBuilder$SType$Str$();
  if ((x === t)) {
    return new $c_Lorg_yaml_builder_DocBuilder$Scalar().init___Lorg_yaml_builder_DocBuilder$SType__O($m_Lorg_yaml_builder_DocBuilder$SType$Str$(), value)
  } else {
    var x$3 = $m_Lorg_yaml_builder_DocBuilder$SType$Int$();
    if ((x$3 === t)) {
      try {
        var this$3 = new $c_sci_StringOps().init___T(value);
        var this$5 = $m_jl_Long$();
        var $$this = this$3.repr$1;
        var t$1 = this$5.parseLong__T__I__J($$this, 10);
        var lo = t$1.lo$2;
        var hi = t$1.hi$2;
        return new $c_Lorg_yaml_builder_DocBuilder$Scalar().init___Lorg_yaml_builder_DocBuilder$SType__O($m_Lorg_yaml_builder_DocBuilder$SType$Int$(), new $c_sjsr_RuntimeLong().init___I__I(lo, hi))
      } catch (e) {
        var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
        if ((e$2 !== null)) {
          var o13 = $m_s_util_control_NonFatal$().unapply__jl_Throwable__s_Option(e$2);
          if ((!o13.isEmpty__Z())) {
            return new $c_Lorg_yaml_builder_DocBuilder$Scalar().init___Lorg_yaml_builder_DocBuilder$SType__O($m_Lorg_yaml_builder_DocBuilder$SType$Str$(), value)
          };
          throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(e$2)
        } else {
          throw e
        }
      }
    } else {
      var x$5 = $m_Lorg_yaml_builder_DocBuilder$SType$Float$();
      if ((x$5 === t)) {
        try {
          var this$9 = new $c_sci_StringOps().init___T(value);
          var jsx$1 = $m_jl_Double$();
          var $$this$1 = this$9.repr$1;
          var value$1 = jsx$1.parseDouble__T__D($$this$1);
          return new $c_Lorg_yaml_builder_DocBuilder$Scalar().init___Lorg_yaml_builder_DocBuilder$SType__O($m_Lorg_yaml_builder_DocBuilder$SType$Float$(), value$1)
        } catch (e$1) {
          var e$2$1 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e$1);
          if ((e$2$1 !== null)) {
            var o13$1 = $m_s_util_control_NonFatal$().unapply__jl_Throwable__s_Option(e$2$1);
            if ((!o13$1.isEmpty__Z())) {
              return new $c_Lorg_yaml_builder_DocBuilder$Scalar().init___Lorg_yaml_builder_DocBuilder$SType__O($m_Lorg_yaml_builder_DocBuilder$SType$Str$(), value)
            };
            throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(e$2$1)
          } else {
            throw e$1
          }
        }
      } else {
        var x$7 = $m_Lorg_yaml_builder_DocBuilder$SType$Bool$();
        if ((x$7 === t)) {
          try {
            var this$14 = new $c_sci_StringOps().init___T(value);
            var $$this$2 = this$14.repr$1;
            var value$2 = $f_sci_StringLike__parseBoolean__psci_StringLike__T__Z(this$14, $$this$2);
            return new $c_Lorg_yaml_builder_DocBuilder$Scalar().init___Lorg_yaml_builder_DocBuilder$SType__O($m_Lorg_yaml_builder_DocBuilder$SType$Bool$(), value$2)
          } catch (e$3) {
            var e$2$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e$3);
            if ((e$2$2 !== null)) {
              var o13$2 = $m_s_util_control_NonFatal$().unapply__jl_Throwable__s_Option(e$2$2);
              if ((!o13$2.isEmpty__Z())) {
                return new $c_Lorg_yaml_builder_DocBuilder$Scalar().init___Lorg_yaml_builder_DocBuilder$SType__O($m_Lorg_yaml_builder_DocBuilder$SType$Str$(), value)
              };
              throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(e$2$2)
            } else {
              throw e$3
            }
          }
        } else {
          throw new $c_s_MatchError().init___O(t)
        }
      }
    }
  }
});
var $d_Lorg_yaml_builder_DocBuilder$Scalar$ = new $TypeData().initClass({
  Lorg_yaml_builder_DocBuilder$Scalar$: 0
}, false, "org.yaml.builder.DocBuilder$Scalar$", {
  Lorg_yaml_builder_DocBuilder$Scalar$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_builder_DocBuilder$Scalar$.prototype.$classData = $d_Lorg_yaml_builder_DocBuilder$Scalar$;
var $n_Lorg_yaml_builder_DocBuilder$Scalar$ = (void 0);
function $m_Lorg_yaml_builder_DocBuilder$Scalar$() {
  if ((!$n_Lorg_yaml_builder_DocBuilder$Scalar$)) {
    $n_Lorg_yaml_builder_DocBuilder$Scalar$ = new $c_Lorg_yaml_builder_DocBuilder$Scalar$().init___()
  };
  return $n_Lorg_yaml_builder_DocBuilder$Scalar$
}
/** @constructor */
function $c_Lorg_yaml_builder_JsonOutputBuilder() {
  $c_Lorg_yaml_builder_BaseOutputBuilder.call(this);
  this.org$yaml$builder$JsonOutputBuilder$$evidence$1$f = null
}
$c_Lorg_yaml_builder_JsonOutputBuilder.prototype = new $h_Lorg_yaml_builder_BaseOutputBuilder();
$c_Lorg_yaml_builder_JsonOutputBuilder.prototype.constructor = $c_Lorg_yaml_builder_JsonOutputBuilder;
/** @constructor */
function $h_Lorg_yaml_builder_JsonOutputBuilder() {
  /*<skip>*/
}
$h_Lorg_yaml_builder_JsonOutputBuilder.prototype = $c_Lorg_yaml_builder_JsonOutputBuilder.prototype;
$c_Lorg_yaml_builder_JsonOutputBuilder.prototype.init___O__Z__Lorg_mulesoft_common_io_Output = (function(writer, prettyPrint, evidence$1) {
  this.org$yaml$builder$JsonOutputBuilder$$evidence$1$f = evidence$1;
  $c_Lorg_yaml_builder_BaseOutputBuilder.prototype.init___O__Z__Lorg_mulesoft_common_io_Output.call(this, writer, prettyPrint, evidence$1);
  return this
});
$c_Lorg_yaml_builder_JsonOutputBuilder.prototype.org$yaml$builder$JsonOutputBuilder$$emitNode__Lorg_yaml_builder_DocBuilder$Scalar__V = (function(scalar) {
  var _1 = scalar.t$1;
  var _2 = scalar.value$1;
  var x = $m_Lorg_yaml_builder_DocBuilder$SType$Str$();
  if (((x === _1) && $is_T(_2))) {
    var x7 = $as_T(_2);
    var w = this.writer$2;
    var this$8 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(w);
    var s = ((("" + new $c_jl_Character().init___C(34)) + $m_Lorg_mulesoft_common_core_package$Strings$().encode$extension1__T__Z__T(x7, true)) + new $c_jl_Character().init___C(34));
    var o = this.org$yaml$builder$JsonOutputBuilder$$evidence$1$f;
    o.append__O__jl_CharSequence__V(this$8.w$1, s)
  } else {
    var x$3 = $m_Lorg_yaml_builder_DocBuilder$SType$Bool$();
    if (((x$3 === _1) && ((typeof _2) === "boolean"))) {
      var x9 = $uZ(_2);
      var w$1 = this.writer$2;
      var this$11 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(w$1);
      var s$1 = ("" + x9);
      var o$1 = this.org$yaml$builder$JsonOutputBuilder$$evidence$1$f;
      o$1.append__O__jl_CharSequence__V(this$11.w$1, s$1)
    } else {
      var x$5 = $m_Lorg_yaml_builder_DocBuilder$SType$Int$();
      if (((x$5 === _1) && (_2 instanceof $c_sjsr_RuntimeLong))) {
        var t = $uJ(_2);
        var lo = t.lo$2;
        var hi = t.hi$2;
        var w$2 = this.writer$2;
        var this$13 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(w$2);
        var s$2 = $m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toString__I__I__T(lo, hi);
        var o$2 = this.org$yaml$builder$JsonOutputBuilder$$evidence$1$f;
        o$2.append__O__jl_CharSequence__V(this$13.w$1, s$2)
      } else {
        var x$7 = $m_Lorg_yaml_builder_DocBuilder$SType$Float$();
        if (((x$7 === _1) && ((typeof _2) === "number"))) {
          var x13 = $uD(_2);
          var s$2$1 = ("" + x13);
          if (($m_sjsr_RuntimeString$().indexOf__T__I__I(s$2$1, 46) === (-1))) {
            var x$1 = s$2$1;
            var this$18 = new $c_sci_StringOps().init___T(x$1);
            var elem = new $c_jl_Character().init___C(101);
            var jsx$2 = (!$f_sc_SeqLike__contains__O__Z(this$18, elem))
          } else {
            var jsx$2 = false
          };
          if (jsx$2) {
            var x$2 = s$2$1;
            var this$22 = new $c_sci_StringOps().init___T(x$2);
            var elem$1 = new $c_jl_Character().init___C(69);
            var jsx$1 = (!$f_sc_SeqLike__contains__O__Z(this$22, elem$1))
          } else {
            var jsx$1 = false
          };
          if (jsx$1) {
            s$2$1 = (s$2$1 + ".0")
          };
          var w$3 = this.writer$2;
          var this$24 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(w$3);
          var s$3 = s$2$1;
          var o$3 = this.org$yaml$builder$JsonOutputBuilder$$evidence$1$f;
          o$3.append__O__jl_CharSequence__V(this$24.w$1, s$3)
        }
      }
    }
  }
});
$c_Lorg_yaml_builder_JsonOutputBuilder.prototype.emitSeq__F1__V = (function(f) {
  var w = this.writer$2;
  var this$2 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(w);
  var o = this.org$yaml$builder$JsonOutputBuilder$$evidence$1$f;
  o.append__O__C__V(this$2.w$1, 91);
  var this$3 = new $c_Lorg_yaml_builder_JsonOutputBuilder$MyPart().init___Lorg_yaml_builder_JsonOutputBuilder(this);
  $f_Lorg_yaml_builder_JsonOutputBuilder$LifeCycle__execute__F1__V(this$3, f);
  var w$1 = this.writer$2;
  var this$5 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(w$1);
  var o$1 = this.org$yaml$builder$JsonOutputBuilder$$evidence$1$f;
  o$1.append__O__C__V(this$5.w$1, 93)
});
$c_Lorg_yaml_builder_JsonOutputBuilder.prototype.emitMap__F1__V = (function(f) {
  var w = this.writer$2;
  var this$2 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(w);
  var o = this.org$yaml$builder$JsonOutputBuilder$$evidence$1$f;
  o.append__O__C__V(this$2.w$1, 123);
  var this$3 = new $c_Lorg_yaml_builder_JsonOutputBuilder$MyEntry().init___Lorg_yaml_builder_JsonOutputBuilder(this);
  $f_Lorg_yaml_builder_JsonOutputBuilder$LifeCycle__execute__F1__V(this$3, f);
  var w$1 = this.writer$2;
  var this$5 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(w$1);
  var o$1 = this.org$yaml$builder$JsonOutputBuilder$$evidence$1$f;
  o$1.append__O__C__V(this$5.w$1, 125)
});
var $d_Lorg_yaml_builder_JsonOutputBuilder = new $TypeData().initClass({
  Lorg_yaml_builder_JsonOutputBuilder: 0
}, false, "org.yaml.builder.JsonOutputBuilder", {
  Lorg_yaml_builder_JsonOutputBuilder: 1,
  Lorg_yaml_builder_BaseOutputBuilder: 1,
  Lorg_yaml_builder_DocBuilder: 1,
  O: 1
});
$c_Lorg_yaml_builder_JsonOutputBuilder.prototype.$classData = $d_Lorg_yaml_builder_JsonOutputBuilder;
/** @constructor */
function $c_Lorg_yaml_builder_JsonOutputBuilder$MyEntry() {
  $c_Lorg_yaml_builder_DocBuilder$Entry.call(this);
  this.org$yaml$builder$JsonOutputBuilder$LifeCycle$$start$2 = false;
  this.org$yaml$builder$JsonOutputBuilder$LifeCycle$$newLineOnStart$2 = false;
  this.$$outer$2 = null
}
$c_Lorg_yaml_builder_JsonOutputBuilder$MyEntry.prototype = new $h_Lorg_yaml_builder_DocBuilder$Entry();
$c_Lorg_yaml_builder_JsonOutputBuilder$MyEntry.prototype.constructor = $c_Lorg_yaml_builder_JsonOutputBuilder$MyEntry;
/** @constructor */
function $h_Lorg_yaml_builder_JsonOutputBuilder$MyEntry() {
  /*<skip>*/
}
$h_Lorg_yaml_builder_JsonOutputBuilder$MyEntry.prototype = $c_Lorg_yaml_builder_JsonOutputBuilder$MyEntry.prototype;
$c_Lorg_yaml_builder_JsonOutputBuilder$MyEntry.prototype.entry__T__Lorg_yaml_builder_DocBuilder$Scalar__V = (function(key, value) {
  this.emitKey__p2__T__V(key);
  this.$$outer$2.org$yaml$builder$JsonOutputBuilder$$emitNode__Lorg_yaml_builder_DocBuilder$Scalar__V(value)
});
$c_Lorg_yaml_builder_JsonOutputBuilder$MyEntry.prototype.init___Lorg_yaml_builder_JsonOutputBuilder = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  $f_Lorg_yaml_builder_JsonOutputBuilder$LifeCycle__$$init$__V(this);
  return this
});
$c_Lorg_yaml_builder_JsonOutputBuilder$MyEntry.prototype.org$yaml$builder$JsonOutputBuilder$LifeCycle$$$outer__Lorg_yaml_builder_JsonOutputBuilder = (function() {
  return this.$$outer$2
});
$c_Lorg_yaml_builder_JsonOutputBuilder$MyEntry.prototype.org$yaml$builder$JsonOutputBuilder$LifeCycle$$start$und$eq__Z__V = (function(x$1) {
  this.org$yaml$builder$JsonOutputBuilder$LifeCycle$$start$2 = x$1
});
$c_Lorg_yaml_builder_JsonOutputBuilder$MyEntry.prototype.emitKey__p2__T__V = (function(key) {
  $f_Lorg_yaml_builder_JsonOutputBuilder$LifeCycle__before__V(this);
  var this$1 = this.$$outer$2;
  var w = this$1.writer$2;
  var this$3 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(w);
  var o = this.$$outer$2.org$yaml$builder$JsonOutputBuilder$$evidence$1$f;
  o.append__O__C__V(this$3.w$1, 34);
  var this$4 = this.$$outer$2;
  var w$1 = this$4.writer$2;
  var this$6 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(w$1);
  var o$1 = this.$$outer$2.org$yaml$builder$JsonOutputBuilder$$evidence$1$f;
  o$1.append__O__jl_CharSequence__V(this$6.w$1, key);
  var this$7 = this.$$outer$2;
  var w$2 = this$7.writer$2;
  var this$9 = new $c_Lorg_mulesoft_common_io_Output$OutputOps().init___O(w$2);
  var o$2 = this.$$outer$2.org$yaml$builder$JsonOutputBuilder$$evidence$1$f;
  o$2.append__O__jl_CharSequence__V(this$9.w$1, "\": ")
});
$c_Lorg_yaml_builder_JsonOutputBuilder$MyEntry.prototype.org$yaml$builder$JsonOutputBuilder$LifeCycle$$newLineOnStart$und$eq__Z__V = (function(x$1) {
  this.org$yaml$builder$JsonOutputBuilder$LifeCycle$$newLineOnStart$2 = x$1
});
$c_Lorg_yaml_builder_JsonOutputBuilder$MyEntry.prototype.org$yaml$builder$JsonOutputBuilder$LifeCycle$$newLineOnStart__Z = (function() {
  return this.org$yaml$builder$JsonOutputBuilder$LifeCycle$$newLineOnStart$2
});
$c_Lorg_yaml_builder_JsonOutputBuilder$MyEntry.prototype.entry__T__F1__V = (function(key, f) {
  this.emitKey__p2__T__V(key);
  f.apply__O__O(new $c_Lorg_yaml_builder_JsonOutputBuilder$MyPart().init___Lorg_yaml_builder_JsonOutputBuilder(this.$$outer$2))
});
$c_Lorg_yaml_builder_JsonOutputBuilder$MyEntry.prototype.org$yaml$builder$JsonOutputBuilder$LifeCycle$$start__Z = (function() {
  return this.org$yaml$builder$JsonOutputBuilder$LifeCycle$$start$2
});
var $d_Lorg_yaml_builder_JsonOutputBuilder$MyEntry = new $TypeData().initClass({
  Lorg_yaml_builder_JsonOutputBuilder$MyEntry: 0
}, false, "org.yaml.builder.JsonOutputBuilder$MyEntry", {
  Lorg_yaml_builder_JsonOutputBuilder$MyEntry: 1,
  Lorg_yaml_builder_DocBuilder$Entry: 1,
  O: 1,
  Lorg_yaml_builder_JsonOutputBuilder$LifeCycle: 1
});
$c_Lorg_yaml_builder_JsonOutputBuilder$MyEntry.prototype.$classData = $d_Lorg_yaml_builder_JsonOutputBuilder$MyEntry;
/** @constructor */
function $c_Lorg_yaml_builder_JsonOutputBuilder$MyPart() {
  $c_Lorg_yaml_builder_DocBuilder$Part.call(this);
  this.org$yaml$builder$JsonOutputBuilder$LifeCycle$$start$2 = false;
  this.org$yaml$builder$JsonOutputBuilder$LifeCycle$$newLineOnStart$2 = false;
  this.$$outer$2 = null
}
$c_Lorg_yaml_builder_JsonOutputBuilder$MyPart.prototype = new $h_Lorg_yaml_builder_DocBuilder$Part();
$c_Lorg_yaml_builder_JsonOutputBuilder$MyPart.prototype.constructor = $c_Lorg_yaml_builder_JsonOutputBuilder$MyPart;
/** @constructor */
function $h_Lorg_yaml_builder_JsonOutputBuilder$MyPart() {
  /*<skip>*/
}
$h_Lorg_yaml_builder_JsonOutputBuilder$MyPart.prototype = $c_Lorg_yaml_builder_JsonOutputBuilder$MyPart.prototype;
$c_Lorg_yaml_builder_JsonOutputBuilder$MyPart.prototype.list__F1__s_Option = (function(f) {
  $f_Lorg_yaml_builder_JsonOutputBuilder$LifeCycle__before__V(this);
  this.$$outer$2.emitSeq__F1__V(f);
  return $m_s_None$()
});
$c_Lorg_yaml_builder_JsonOutputBuilder$MyPart.prototype.init___Lorg_yaml_builder_JsonOutputBuilder = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  $f_Lorg_yaml_builder_JsonOutputBuilder$LifeCycle__$$init$__V(this);
  return this
});
$c_Lorg_yaml_builder_JsonOutputBuilder$MyPart.prototype.org$yaml$builder$JsonOutputBuilder$LifeCycle$$$outer__Lorg_yaml_builder_JsonOutputBuilder = (function() {
  return this.$$outer$2
});
$c_Lorg_yaml_builder_JsonOutputBuilder$MyPart.prototype.org$yaml$builder$JsonOutputBuilder$LifeCycle$$start$und$eq__Z__V = (function(x$1) {
  this.org$yaml$builder$JsonOutputBuilder$LifeCycle$$start$2 = x$1
});
$c_Lorg_yaml_builder_JsonOutputBuilder$MyPart.prototype.$$plus$eq__Lorg_yaml_builder_DocBuilder$Scalar__V = (function(scalar) {
  $f_Lorg_yaml_builder_JsonOutputBuilder$LifeCycle__before__V(this);
  this.$$outer$2.org$yaml$builder$JsonOutputBuilder$$emitNode__Lorg_yaml_builder_DocBuilder$Scalar__V(scalar)
});
$c_Lorg_yaml_builder_JsonOutputBuilder$MyPart.prototype.org$yaml$builder$JsonOutputBuilder$LifeCycle$$newLineOnStart__Z = (function() {
  return this.org$yaml$builder$JsonOutputBuilder$LifeCycle$$newLineOnStart$2
});
$c_Lorg_yaml_builder_JsonOutputBuilder$MyPart.prototype.org$yaml$builder$JsonOutputBuilder$LifeCycle$$newLineOnStart$und$eq__Z__V = (function(x$1) {
  this.org$yaml$builder$JsonOutputBuilder$LifeCycle$$newLineOnStart$2 = x$1
});
$c_Lorg_yaml_builder_JsonOutputBuilder$MyPart.prototype.$$plus$eq__O__V = (function(element) {
  /*<skip>*/
});
$c_Lorg_yaml_builder_JsonOutputBuilder$MyPart.prototype.org$yaml$builder$JsonOutputBuilder$LifeCycle$$start__Z = (function() {
  return this.org$yaml$builder$JsonOutputBuilder$LifeCycle$$start$2
});
$c_Lorg_yaml_builder_JsonOutputBuilder$MyPart.prototype.obj__F1__s_Option = (function(f) {
  $f_Lorg_yaml_builder_JsonOutputBuilder$LifeCycle__before__V(this);
  this.$$outer$2.emitMap__F1__V(f);
  return $m_s_None$()
});
var $d_Lorg_yaml_builder_JsonOutputBuilder$MyPart = new $TypeData().initClass({
  Lorg_yaml_builder_JsonOutputBuilder$MyPart: 0
}, false, "org.yaml.builder.JsonOutputBuilder$MyPart", {
  Lorg_yaml_builder_JsonOutputBuilder$MyPart: 1,
  Lorg_yaml_builder_DocBuilder$Part: 1,
  O: 1,
  Lorg_yaml_builder_JsonOutputBuilder$LifeCycle: 1
});
$c_Lorg_yaml_builder_JsonOutputBuilder$MyPart.prototype.$classData = $d_Lorg_yaml_builder_JsonOutputBuilder$MyPart;
/** @constructor */
function $c_Lorg_yaml_convert_YRead$BooleanYRead$() {
  $c_Lorg_yaml_convert_ScalarYRead.call(this)
}
$c_Lorg_yaml_convert_YRead$BooleanYRead$.prototype = new $h_Lorg_yaml_convert_ScalarYRead();
$c_Lorg_yaml_convert_YRead$BooleanYRead$.prototype.constructor = $c_Lorg_yaml_convert_YRead$BooleanYRead$;
/** @constructor */
function $h_Lorg_yaml_convert_YRead$BooleanYRead$() {
  /*<skip>*/
}
$h_Lorg_yaml_convert_YRead$BooleanYRead$.prototype = $c_Lorg_yaml_convert_YRead$BooleanYRead$.prototype;
$c_Lorg_yaml_convert_YRead$BooleanYRead$.prototype.init___ = (function() {
  $c_Lorg_yaml_convert_ScalarYRead.prototype.init___Lorg_yaml_model_YType__O.call(this, $m_Lorg_yaml_model_YType$().Bool$1, false);
  return this
});
var $d_Lorg_yaml_convert_YRead$BooleanYRead$ = new $TypeData().initClass({
  Lorg_yaml_convert_YRead$BooleanYRead$: 0
}, false, "org.yaml.convert.YRead$BooleanYRead$", {
  Lorg_yaml_convert_YRead$BooleanYRead$: 1,
  Lorg_yaml_convert_ScalarYRead: 1,
  O: 1,
  Lorg_yaml_convert_YRead: 1
});
$c_Lorg_yaml_convert_YRead$BooleanYRead$.prototype.$classData = $d_Lorg_yaml_convert_YRead$BooleanYRead$;
var $n_Lorg_yaml_convert_YRead$BooleanYRead$ = (void 0);
function $m_Lorg_yaml_convert_YRead$BooleanYRead$() {
  if ((!$n_Lorg_yaml_convert_YRead$BooleanYRead$)) {
    $n_Lorg_yaml_convert_YRead$BooleanYRead$ = new $c_Lorg_yaml_convert_YRead$BooleanYRead$().init___()
  };
  return $n_Lorg_yaml_convert_YRead$BooleanYRead$
}
/** @constructor */
function $c_Lorg_yaml_convert_YRead$DTYRead$() {
  $c_Lorg_yaml_convert_ScalarYRead.call(this)
}
$c_Lorg_yaml_convert_YRead$DTYRead$.prototype = new $h_Lorg_yaml_convert_ScalarYRead();
$c_Lorg_yaml_convert_YRead$DTYRead$.prototype.constructor = $c_Lorg_yaml_convert_YRead$DTYRead$;
/** @constructor */
function $h_Lorg_yaml_convert_YRead$DTYRead$() {
  /*<skip>*/
}
$h_Lorg_yaml_convert_YRead$DTYRead$.prototype = $c_Lorg_yaml_convert_YRead$DTYRead$.prototype;
$c_Lorg_yaml_convert_YRead$DTYRead$.prototype.init___ = (function() {
  $c_Lorg_yaml_convert_ScalarYRead.prototype.init___Lorg_yaml_model_YType__O.call(this, $m_Lorg_yaml_model_YType$().Timestamp$1, $m_Lorg_mulesoft_common_time_SimpleDateTime$().Epoch$1);
  return this
});
var $d_Lorg_yaml_convert_YRead$DTYRead$ = new $TypeData().initClass({
  Lorg_yaml_convert_YRead$DTYRead$: 0
}, false, "org.yaml.convert.YRead$DTYRead$", {
  Lorg_yaml_convert_YRead$DTYRead$: 1,
  Lorg_yaml_convert_ScalarYRead: 1,
  O: 1,
  Lorg_yaml_convert_YRead: 1
});
$c_Lorg_yaml_convert_YRead$DTYRead$.prototype.$classData = $d_Lorg_yaml_convert_YRead$DTYRead$;
var $n_Lorg_yaml_convert_YRead$DTYRead$ = (void 0);
function $m_Lorg_yaml_convert_YRead$DTYRead$() {
  if ((!$n_Lorg_yaml_convert_YRead$DTYRead$)) {
    $n_Lorg_yaml_convert_YRead$DTYRead$ = new $c_Lorg_yaml_convert_YRead$DTYRead$().init___()
  };
  return $n_Lorg_yaml_convert_YRead$DTYRead$
}
/** @constructor */
function $c_Lorg_yaml_convert_YRead$DoubleYRead$() {
  $c_Lorg_yaml_convert_ScalarYRead.call(this)
}
$c_Lorg_yaml_convert_YRead$DoubleYRead$.prototype = new $h_Lorg_yaml_convert_ScalarYRead();
$c_Lorg_yaml_convert_YRead$DoubleYRead$.prototype.constructor = $c_Lorg_yaml_convert_YRead$DoubleYRead$;
/** @constructor */
function $h_Lorg_yaml_convert_YRead$DoubleYRead$() {
  /*<skip>*/
}
$h_Lorg_yaml_convert_YRead$DoubleYRead$.prototype = $c_Lorg_yaml_convert_YRead$DoubleYRead$.prototype;
$c_Lorg_yaml_convert_YRead$DoubleYRead$.prototype.init___ = (function() {
  $c_Lorg_yaml_convert_ScalarYRead.prototype.init___Lorg_yaml_model_YType__O.call(this, $m_Lorg_yaml_model_YType$().Float$1, 0.0);
  return this
});
$c_Lorg_yaml_convert_YRead$DoubleYRead$.prototype.read__Lorg_yaml_model_YNode__s_util_Either = (function(node) {
  var x1 = $c_Lorg_yaml_convert_ScalarYRead.prototype.read__Lorg_yaml_model_YNode__s_util_Either.call(this, node);
  if ((x1 instanceof $c_s_util_Right)) {
    var x2 = $as_s_util_Right(x1);
    return x2
  } else {
    var this$1 = $m_Lorg_yaml_convert_YRead$LongYRead$().read__Lorg_yaml_model_YNode__s_util_Either(node);
    if ((this$1 instanceof $c_s_util_Right)) {
      var x2$1 = $as_s_util_Right(this$1);
      var b = x2$1.value$2;
      var t = $uJ(b);
      var lo = t.lo$2;
      var hi = t.hi$2;
      return new $c_s_util_Right().init___O($m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toDouble__I__I__D(lo, hi))
    } else {
      return this$1
    }
  }
});
var $d_Lorg_yaml_convert_YRead$DoubleYRead$ = new $TypeData().initClass({
  Lorg_yaml_convert_YRead$DoubleYRead$: 0
}, false, "org.yaml.convert.YRead$DoubleYRead$", {
  Lorg_yaml_convert_YRead$DoubleYRead$: 1,
  Lorg_yaml_convert_ScalarYRead: 1,
  O: 1,
  Lorg_yaml_convert_YRead: 1
});
$c_Lorg_yaml_convert_YRead$DoubleYRead$.prototype.$classData = $d_Lorg_yaml_convert_YRead$DoubleYRead$;
var $n_Lorg_yaml_convert_YRead$DoubleYRead$ = (void 0);
function $m_Lorg_yaml_convert_YRead$DoubleYRead$() {
  if ((!$n_Lorg_yaml_convert_YRead$DoubleYRead$)) {
    $n_Lorg_yaml_convert_YRead$DoubleYRead$ = new $c_Lorg_yaml_convert_YRead$DoubleYRead$().init___()
  };
  return $n_Lorg_yaml_convert_YRead$DoubleYRead$
}
/** @constructor */
function $c_Lorg_yaml_convert_YRead$IntYRead$() {
  $c_Lorg_yaml_convert_ScalarYRead.call(this)
}
$c_Lorg_yaml_convert_YRead$IntYRead$.prototype = new $h_Lorg_yaml_convert_ScalarYRead();
$c_Lorg_yaml_convert_YRead$IntYRead$.prototype.constructor = $c_Lorg_yaml_convert_YRead$IntYRead$;
/** @constructor */
function $h_Lorg_yaml_convert_YRead$IntYRead$() {
  /*<skip>*/
}
$h_Lorg_yaml_convert_YRead$IntYRead$.prototype = $c_Lorg_yaml_convert_YRead$IntYRead$.prototype;
$c_Lorg_yaml_convert_YRead$IntYRead$.prototype.init___ = (function() {
  $c_Lorg_yaml_convert_ScalarYRead.prototype.init___Lorg_yaml_model_YType__O.call(this, $m_Lorg_yaml_model_YType$().Int$1, 0);
  return this
});
$c_Lorg_yaml_convert_YRead$IntYRead$.prototype.read__Lorg_yaml_model_YNode__s_util_Either = (function(node) {
  var x1 = $m_Lorg_yaml_convert_YRead$LongYRead$().read__Lorg_yaml_model_YNode__s_util_Either(node);
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    return x2
  };
  if ((x1 instanceof $c_s_util_Right)) {
    var x4 = $as_s_util_Right(x1);
    var t = $uJ(x4.value$2);
    var lo = t.lo$2;
    var hi = t.hi$2;
    if ((((hi === (-1)) ? (((-2147483648) ^ lo) >= 0) : (hi > (-1))) && ((hi === 0) ? (((-2147483648) ^ lo) <= (-1)) : (hi < 0)))) {
      $m_s_package$();
      return new $c_s_util_Right().init___O(lo)
    }
  };
  return $m_Lorg_yaml_convert_YRead$().error__Lorg_yaml_model_YNode__T__s_util_Left(node, "Out of range")
});
var $d_Lorg_yaml_convert_YRead$IntYRead$ = new $TypeData().initClass({
  Lorg_yaml_convert_YRead$IntYRead$: 0
}, false, "org.yaml.convert.YRead$IntYRead$", {
  Lorg_yaml_convert_YRead$IntYRead$: 1,
  Lorg_yaml_convert_ScalarYRead: 1,
  O: 1,
  Lorg_yaml_convert_YRead: 1
});
$c_Lorg_yaml_convert_YRead$IntYRead$.prototype.$classData = $d_Lorg_yaml_convert_YRead$IntYRead$;
var $n_Lorg_yaml_convert_YRead$IntYRead$ = (void 0);
function $m_Lorg_yaml_convert_YRead$IntYRead$() {
  if ((!$n_Lorg_yaml_convert_YRead$IntYRead$)) {
    $n_Lorg_yaml_convert_YRead$IntYRead$ = new $c_Lorg_yaml_convert_YRead$IntYRead$().init___()
  };
  return $n_Lorg_yaml_convert_YRead$IntYRead$
}
/** @constructor */
function $c_Lorg_yaml_convert_YRead$LongYRead$() {
  $c_Lorg_yaml_convert_ScalarYRead.call(this)
}
$c_Lorg_yaml_convert_YRead$LongYRead$.prototype = new $h_Lorg_yaml_convert_ScalarYRead();
$c_Lorg_yaml_convert_YRead$LongYRead$.prototype.constructor = $c_Lorg_yaml_convert_YRead$LongYRead$;
/** @constructor */
function $h_Lorg_yaml_convert_YRead$LongYRead$() {
  /*<skip>*/
}
$h_Lorg_yaml_convert_YRead$LongYRead$.prototype = $c_Lorg_yaml_convert_YRead$LongYRead$.prototype;
$c_Lorg_yaml_convert_YRead$LongYRead$.prototype.init___ = (function() {
  $c_Lorg_yaml_convert_ScalarYRead.prototype.init___Lorg_yaml_model_YType__O.call(this, $m_Lorg_yaml_model_YType$().Int$1, $m_sjsr_RuntimeLong$().Zero__sjsr_RuntimeLong());
  return this
});
var $d_Lorg_yaml_convert_YRead$LongYRead$ = new $TypeData().initClass({
  Lorg_yaml_convert_YRead$LongYRead$: 0
}, false, "org.yaml.convert.YRead$LongYRead$", {
  Lorg_yaml_convert_YRead$LongYRead$: 1,
  Lorg_yaml_convert_ScalarYRead: 1,
  O: 1,
  Lorg_yaml_convert_YRead: 1
});
$c_Lorg_yaml_convert_YRead$LongYRead$.prototype.$classData = $d_Lorg_yaml_convert_YRead$LongYRead$;
var $n_Lorg_yaml_convert_YRead$LongYRead$ = (void 0);
function $m_Lorg_yaml_convert_YRead$LongYRead$() {
  if ((!$n_Lorg_yaml_convert_YRead$LongYRead$)) {
    $n_Lorg_yaml_convert_YRead$LongYRead$ = new $c_Lorg_yaml_convert_YRead$LongYRead$().init___()
  };
  return $n_Lorg_yaml_convert_YRead$LongYRead$
}
/** @constructor */
function $c_Lorg_yaml_convert_YRead$StringYRead$() {
  $c_Lorg_yaml_convert_ScalarYRead.call(this)
}
$c_Lorg_yaml_convert_YRead$StringYRead$.prototype = new $h_Lorg_yaml_convert_ScalarYRead();
$c_Lorg_yaml_convert_YRead$StringYRead$.prototype.constructor = $c_Lorg_yaml_convert_YRead$StringYRead$;
/** @constructor */
function $h_Lorg_yaml_convert_YRead$StringYRead$() {
  /*<skip>*/
}
$h_Lorg_yaml_convert_YRead$StringYRead$.prototype = $c_Lorg_yaml_convert_YRead$StringYRead$.prototype;
$c_Lorg_yaml_convert_YRead$StringYRead$.prototype.init___ = (function() {
  $c_Lorg_yaml_convert_ScalarYRead.prototype.init___Lorg_yaml_model_YType__O.call(this, $m_Lorg_yaml_model_YType$().Str$1, "");
  return this
});
var $d_Lorg_yaml_convert_YRead$StringYRead$ = new $TypeData().initClass({
  Lorg_yaml_convert_YRead$StringYRead$: 0
}, false, "org.yaml.convert.YRead$StringYRead$", {
  Lorg_yaml_convert_YRead$StringYRead$: 1,
  Lorg_yaml_convert_ScalarYRead: 1,
  O: 1,
  Lorg_yaml_convert_YRead: 1
});
$c_Lorg_yaml_convert_YRead$StringYRead$.prototype.$classData = $d_Lorg_yaml_convert_YRead$StringYRead$;
var $n_Lorg_yaml_convert_YRead$StringYRead$ = (void 0);
function $m_Lorg_yaml_convert_YRead$StringYRead$() {
  if ((!$n_Lorg_yaml_convert_YRead$StringYRead$)) {
    $n_Lorg_yaml_convert_YRead$StringYRead$ = new $c_Lorg_yaml_convert_YRead$StringYRead$().init___()
  };
  return $n_Lorg_yaml_convert_YRead$StringYRead$
}
/** @constructor */
function $c_Lorg_yaml_lexer_JsonLexer() {
  $c_Lorg_mulesoft_lexer_BaseLexer.call(this)
}
$c_Lorg_yaml_lexer_JsonLexer.prototype = new $h_Lorg_mulesoft_lexer_BaseLexer();
$c_Lorg_yaml_lexer_JsonLexer.prototype.constructor = $c_Lorg_yaml_lexer_JsonLexer;
/** @constructor */
function $h_Lorg_yaml_lexer_JsonLexer() {
  /*<skip>*/
}
$h_Lorg_yaml_lexer_JsonLexer.prototype = $c_Lorg_yaml_lexer_JsonLexer.prototype;
$c_Lorg_yaml_lexer_JsonLexer.prototype.initialize__V = (function() {
  this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginDocument$1);
  this.advance__V()
});
$c_Lorg_yaml_lexer_JsonLexer.prototype.processPending__V = (function() {
  this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndDocument$1)
});
$c_Lorg_yaml_lexer_JsonLexer.prototype.init___Lorg_mulesoft_lexer_LexerInput__Lorg_mulesoft_lexer_Position = (function(input, positionOffset) {
  $c_Lorg_mulesoft_lexer_BaseLexer.prototype.init___Lorg_mulesoft_lexer_LexerInput__Lorg_mulesoft_lexer_Position.call(this, input, positionOffset);
  return this
});
$c_Lorg_yaml_lexer_JsonLexer.prototype.advanceToTokens__p2__sci_Set__V = (function(tokens) {
  while (true) {
    var this$1 = this.input$1;
    if ((!tokens.contains__O__Z((65535 & this$1.state$1.current$1)))) {
      var this$2 = this.input$1;
      var jsx$1 = this$2.state$1.nonEof__Z()
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var this$3 = this.input$1;
      this$3.state$1.consume__jl_CharSequence__I__V(this$3.data$1, this$3.endOffset$1)
    } else {
      break
    }
  };
  this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Error$1)
});
$c_Lorg_yaml_lexer_JsonLexer.prototype.string__p2__V = (function() {
  var elem$1 = false;
  elem$1 = false;
  this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginScalar$1);
  this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1);
  while (true) {
    var this$2 = this.input$1;
    if ((this$2.state$1.current$1 !== 34)) {
      var this$3 = this.input$1;
      var jsx$1 = (this$3.state$1.current$1 !== $m_Lorg_mulesoft_lexer_LexerInput$().EofChar$1)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var this$4 = this.input$1;
      if ((this$4.state$1.current$1 === 92)) {
        if (elem$1) {
          this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Text$1);
          elem$1 = false
        };
        this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginEscape$1);
        this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1);
        var this$5 = this.input$1;
        var c = (65535 & this$5.state$1.current$1);
        if (($m_jl_Character$().toUpperCase__C__C(c) === 85)) {
          this.input$1.consume__I__V(4)
        };
        this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().MetaText$1);
        this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndEscape$1)
      } else {
        elem$1 = true;
        var this$8 = this.input$1;
        this$8.state$1.consume__jl_CharSequence__I__V(this$8.data$1, this$8.endOffset$1)
      }
    } else {
      break
    }
  };
  if (elem$1) {
    this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Text$1);
    elem$1 = false
  };
  this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1);
  this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndScalar$1)
});
$c_Lorg_yaml_lexer_JsonLexer.prototype.number__p2__V = (function() {
  this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginScalar$1);
  this.consume__C__Z(45);
  var valid = true;
  if ((!this.consume__C__Z(48))) {
    var this$1 = this.input$1;
    this$1.state$1.consume__jl_CharSequence__I__V(this$1.data$1, this$1.endOffset$1);
    var this$2 = this.input$1;
    while (true) {
      var v1 = this$2.state$1.current$1;
      if ($m_Lorg_yaml_lexer_JsonLexer$().org$yaml$lexer$JsonLexer$$isDigit__I__Z(v1)) {
        this$2.state$1.consume__jl_CharSequence__I__V(this$2.data$1, this$2.endOffset$1)
      } else {
        break
      }
    }
  } else {
    var jsx$1 = $m_Lorg_yaml_lexer_JsonLexer$();
    var this$3 = this.input$1;
    if (jsx$1.org$yaml$lexer$JsonLexer$$isDigit__I__Z(this$3.state$1.current$1)) {
      valid = false;
      var array = [44, 93, 125, 34, 91, 123, 58];
      if (($uI(array.length) === 0)) {
        var jsx$2 = $m_sci_Set$EmptySet$()
      } else {
        var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
        var i = 0;
        var len = $uI(array.length);
        while ((i < len)) {
          var index = i;
          var arg1 = array[index];
          b.$$plus$eq__O__scm_SetBuilder(arg1);
          i = ((1 + i) | 0)
        };
        var jsx$2 = b.elems$1
      };
      this.advanceToTokens__p2__sci_Set__V($as_sci_Set(jsx$2))
    }
  };
  if (valid) {
    if (this.consume__C__Z(46)) {
      var this$7 = this.input$1;
      while (true) {
        var v1$1 = this$7.state$1.current$1;
        if ($m_Lorg_yaml_lexer_JsonLexer$().org$yaml$lexer$JsonLexer$$isDigit__I__Z(v1$1)) {
          this$7.state$1.consume__jl_CharSequence__I__V(this$7.data$1, this$7.endOffset$1)
        } else {
          break
        }
      }
    };
    if ((this.consume__C__Z(101) || this.consume__C__Z(69))) {
      if ((!this.consume__C__Z(43))) {
        this.consume__C__Z(45)
      };
      var this$8 = this.input$1;
      while (true) {
        var v1$2 = this$8.state$1.current$1;
        if ($m_Lorg_yaml_lexer_JsonLexer$().org$yaml$lexer$JsonLexer$$isDigit__I__Z(v1$2)) {
          this$8.state$1.consume__jl_CharSequence__I__V(this$8.data$1, this$8.endOffset$1)
        } else {
          break
        }
      }
    };
    this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Text$1)
  };
  this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndScalar$1)
});
$c_Lorg_yaml_lexer_JsonLexer.prototype.findToken__I__V = (function(chr) {
  switch (chr) {
    case 91: {
      this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginSequence$1);
      break
    }
    case 123: {
      this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginMapping$1);
      break
    }
    case 93: {
      this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndSequence$1);
      break
    }
    case 125: {
      this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndMapping$1);
      break
    }
    case 58: {
      this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1);
      break
    }
    case 44: {
      this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1);
      break
    }
    case 34: {
      this.string__p2__V();
      break
    }
    case 45:
    case 48:
    case 49:
    case 50:
    case 51:
    case 52:
    case 53:
    case 54:
    case 55:
    case 56:
    case 57: {
      this.number__p2__V();
      break
    }
    case 10: {
      this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().LineBreak$1);
      break
    }
    case 32:
    case 9:
    case 13: {
      var this$1 = this.input$1;
      while (true) {
        var v1 = this$1.state$1.current$1;
        if ($m_Lorg_yaml_lexer_JsonLexer$().org$yaml$lexer$JsonLexer$$isWhitespace__I__Z(v1)) {
          this$1.state$1.consume__jl_CharSequence__I__V(this$1.data$1, this$1.endOffset$1)
        } else {
          break
        }
      };
      this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().WhiteSpace$1);
      break
    }
    case 110: {
      this.checkKeyword__p2__T__V("null");
      break
    }
    case 116: {
      this.checkKeyword__p2__T__V("true");
      break
    }
    case 102: {
      this.checkKeyword__p2__T__V("false");
      break
    }
    default: {
      var array = [91, 93, 123, 125, 58, 44];
      if (($uI(array.length) === 0)) {
        var jsx$1 = $m_sci_Set$EmptySet$()
      } else {
        var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
        var i = 0;
        var len = $uI(array.length);
        while ((i < len)) {
          var index = i;
          var arg1 = array[index];
          b.$$plus$eq__O__scm_SetBuilder(arg1);
          i = ((1 + i) | 0)
        };
        var jsx$1 = b.elems$1
      };
      this.advanceToTokens__p2__sci_Set__V($as_sci_Set(jsx$1))
    }
  }
});
$c_Lorg_yaml_lexer_JsonLexer.prototype.checkKeyword__p2__T__V = (function(str) {
  var l = this.check__T__I(str);
  if ((l > 0)) {
    this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginScalar$1);
    this.input$1.consume__I__V(l);
    this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Text$1);
    this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndScalar$1)
  } else {
    var array = [44, 58];
    if (($uI(array.length) === 0)) {
      var jsx$1 = $m_sci_Set$EmptySet$()
    } else {
      var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
      var i = 0;
      var len = $uI(array.length);
      while ((i < len)) {
        var index = i;
        var arg1 = array[index];
        b.$$plus$eq__O__scm_SetBuilder(arg1);
        i = ((1 + i) | 0)
      };
      var jsx$1 = b.elems$1
    };
    this.advanceToTokens__p2__sci_Set__V($as_sci_Set(jsx$1))
  }
});
var $d_Lorg_yaml_lexer_JsonLexer = new $TypeData().initClass({
  Lorg_yaml_lexer_JsonLexer: 0
}, false, "org.yaml.lexer.JsonLexer", {
  Lorg_yaml_lexer_JsonLexer: 1,
  Lorg_mulesoft_lexer_BaseLexer: 1,
  O: 1,
  Lorg_mulesoft_lexer_Lexer: 1
});
$c_Lorg_yaml_lexer_JsonLexer.prototype.$classData = $d_Lorg_yaml_lexer_JsonLexer;
/** @constructor */
function $c_Lorg_yaml_lexer_YamlLexer() {
  $c_Lorg_mulesoft_lexer_BaseLexer.call(this);
  this.input$2 = null
}
$c_Lorg_yaml_lexer_YamlLexer.prototype = new $h_Lorg_mulesoft_lexer_BaseLexer();
$c_Lorg_yaml_lexer_YamlLexer.prototype.constructor = $c_Lorg_yaml_lexer_YamlLexer;
/** @constructor */
function $h_Lorg_yaml_lexer_YamlLexer() {
  /*<skip>*/
}
$h_Lorg_yaml_lexer_YamlLexer.prototype = $c_Lorg_yaml_lexer_YamlLexer.prototype;
$c_Lorg_yaml_lexer_YamlLexer.prototype.saveState__p2__T3 = (function() {
  return new $c_T3().init___O__O__O(this.tokenQueue$1.size__I(), this.mark$1, this.input$2.createMark__Lorg_mulesoft_lexer_LexerInput$Mark())
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.blockCollection__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, ctx) {
  var s = this.saveState__p2__T3();
  var result = ((this.separate__I__Lorg_yaml_lexer_YamlContext__Z(((1 + n) | 0), ctx) && this.nodeProperties__p2__I__Lorg_yaml_lexer_YamlContext__Z(((1 + n) | 0), ctx)) && this.bc$1__p2__Lorg_yaml_lexer_YamlContext__I__Z(ctx, n));
  if ((!result)) {
    this.restoreState__p2__T3__V(s)
  };
  if (result) {
    return true
  } else {
    var s$1 = this.saveState__p2__T3();
    var result$1 = this.bc$1__p2__Lorg_yaml_lexer_YamlContext__I__Z(ctx, n);
    if ((!result$1)) {
      this.restoreState__p2__T3__V(s$1)
    };
    return result$1
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowFolded__p2__I__Z = (function(n) {
  this.separateInLine__p2__Z();
  return (this.folded__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, $m_Lorg_yaml_lexer_FlowIn$()) && this.linePrefix__p2__I__Z__Z__Z(n, true, false))
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.implicitJsonKey__Lorg_yaml_lexer_YamlContext__Z = (function(ctx) {
  return (this.flowJsonNode__I__Lorg_yaml_lexer_YamlContext__Z(0, ctx) && (this.separateInLine__p2__Z(), true))
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.chompedEmpty__I__C__Z = (function(n, t) {
  if ((t !== 43)) {
    if ((t !== 45)) {
      this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndScalar$1)
    };
    var s = this.saveState__p2__T3();
    while (true) {
      var this$1 = this.input$1;
      if ((this$1.state$1.nonEof__Z() && (this.indentLessOrEqual__I__Z(n) && this.lineBreak__p2__Lorg_yaml_lexer_YamlToken__Z($m_Lorg_yaml_lexer_YamlToken$().LineBreak$1)))) {
        s = this.saveState__p2__T3()
      } else {
        break
      }
    };
    this.restoreState__p2__T3__V(s)
  } else {
    var s$1 = this.saveState__p2__T3();
    while (true) {
      var this$2 = this.input$1;
      if ((this$2.state$1.nonEof__Z() && this.emptyLine__I__Lorg_yaml_lexer_YamlContext__Z(n, $m_Lorg_yaml_lexer_BlockIn$()))) {
        s$1 = this.saveState__p2__T3()
      } else {
        break
      }
    };
    this.restoreState__p2__T3__V(s$1);
    this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndScalar$1)
  };
  this.trailComments__I__Z(n);
  return true
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.nodeProperties__p2__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, c) {
  var s = this.saveState__p2__T3();
  if (this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginProperties$1)) {
    if (this.tagProperty__p2__Z()) {
      var s$1 = this.saveState__p2__T3();
      var b1 = this.separate__I__Lorg_yaml_lexer_YamlContext__Z(n, c);
      var result = (b1 && this.anchorProperty__p2__Z());
      if ((!result)) {
        this.restoreState__p2__T3__V(s$1)
      };
      var jsx$2 = true
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var jsx$1 = true
    } else if (this.anchorProperty__p2__Z()) {
      var s$2 = this.saveState__p2__T3();
      var result$1 = (this.separate__I__Lorg_yaml_lexer_YamlContext__Z(n, c) && this.tagProperty__p2__Z());
      if ((!result$1)) {
        this.restoreState__p2__T3__V(s$2)
      };
      var jsx$1 = true
    } else {
      var jsx$1 = false
    }
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var result$2 = this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndProperties$1)
  } else {
    var result$2 = false
  };
  if ((!result$2)) {
    this.restoreState__p2__T3__V(s)
  };
  return result$2
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.emptyLine__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, ctx) {
  var x$2 = $m_Lorg_yaml_lexer_FlowOut$();
  if (((ctx !== null) && (ctx === x$2))) {
    var jsx$1 = true
  } else {
    var x$4 = $m_Lorg_yaml_lexer_FlowIn$();
    var jsx$1 = ((ctx !== null) && (ctx === x$4))
  };
  if (this.linePrefix__p2__I__Z__Z__Z(n, jsx$1, true)) {
    return this.lineBreak__p2__Lorg_yaml_lexer_YamlToken__Z($m_Lorg_yaml_lexer_YamlToken$().LineFeed$1)
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.emptyScalar__Z = (function() {
  this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginScalar$1);
  return this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndScalar$1)
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.mapExplicitValue__I__Z = (function(n) {
  var s = this.saveState__p2__T3();
  var result = ((this.indent__I__Z(n) && this.indicator__I__Z(58)) && this.blockIndented__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, $m_Lorg_yaml_lexer_BlockOut$()));
  if ((!result)) {
    this.restoreState__p2__T3__V(s)
  };
  return result
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.nonEndOfDocument__p2__Z = (function() {
  var this$1 = this.input$1;
  if ((this$1.state$1.column$1 !== 0)) {
    return true
  } else {
    return ((!this.isDocumentEnd__p2__Z()) && (!this.isDirectivesEnd__p2__Z()))
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.lineBreakSequence__I__I = (function(offset) {
  var current = this.input$1.lookAhead__I__I(offset);
  if ((current === 10)) {
    return 1
  } else {
    if ((current === 13)) {
      var n = ((1 + offset) | 0);
      var jsx$1 = (this.input$1.lookAhead__I__I(n) === 10)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return 2
    } else {
      return 0
    }
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.plainMultiline__p2__I__Lorg_yaml_lexer_YamlContext__V = (function(n, ctx) {
  this.plainOneLine__p2__Lorg_yaml_lexer_YamlContext__V(ctx);
  var s = this.saveState__p2__T3();
  while (true) {
    var this$1 = this.input$1;
    if (this$1.state$1.nonEof__Z()) {
      if (this.flowFolded__p2__I__Z(n)) {
        if (this.plainChar__p2__Lorg_yaml_lexer_YamlContext__Z(ctx)) {
          var b3 = this.plainInLine__p2__Lorg_yaml_lexer_YamlContext__Z(ctx);
          if (b3) {
            this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Text$1)
          };
          var jsx$1 = b3
        } else {
          var jsx$1 = false
        }
      } else {
        var jsx$1 = false
      }
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      s = this.saveState__p2__T3()
    } else {
      break
    }
  };
  this.restoreState__p2__T3__V(s)
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.isPlainFirst__I__I__Lorg_yaml_lexer_YamlContext__Z = (function(chr, nextChar, ctx) {
  return (($m_Lorg_yaml_lexer_YamlCharRules$().isNsChar__I__Z(chr) && (!$m_Lorg_yaml_lexer_YamlCharRules$().isIndicator__I__Z(chr))) || ((((chr === 45) || (chr === 58)) || (chr === 63)) && this.isPlainSafe__p2__I__Lorg_yaml_lexer_YamlContext__Z(nextChar, ctx)))
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.literalContentLine__p2__I__Z = (function(n) {
  if (this.nonEndOfDocument__p2__Z()) {
    var s = this.saveState__p2__T3();
    while (true) {
      var this$1 = this.input$1;
      if ((this$1.state$1.nonEof__Z() && this.emptyLine__I__Lorg_yaml_lexer_YamlContext__Z(n, $m_Lorg_yaml_lexer_BlockIn$()))) {
        s = this.saveState__p2__T3()
      } else {
        break
      }
    };
    this.restoreState__p2__T3__V(s);
    if (this.indent__I__Z(n)) {
      var jsx$2 = $m_Lorg_yaml_lexer_YamlCharRules$();
      var this$2 = this.input$1;
      var jsx$1 = (!jsx$2.isBreakOrEof__I__Z(this$2.state$1.current$1))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var this$3 = this.input$1;
      while (true) {
        var v1 = this$3.state$1.current$1;
        if ((!$m_Lorg_yaml_lexer_YamlCharRules$().isBreakOrEof__I__Z(v1))) {
          this$3.state$1.consume__jl_CharSequence__I__V(this$3.data$1, this$3.endOffset$1)
        } else {
          break
        }
      };
      return this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Text$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.isPlainSafe__p2__I__Lorg_yaml_lexer_YamlContext__Z = (function(chr, ctx) {
  var x = $m_Lorg_yaml_lexer_FlowIn$();
  if ((x === ctx)) {
    var jsx$1 = true
  } else {
    var x$3 = $m_Lorg_yaml_lexer_FlowKey$();
    var jsx$1 = (x$3 === ctx)
  };
  if (jsx$1) {
    return ($m_Lorg_yaml_lexer_YamlCharRules$().isNsChar__I__Z(chr) && (!$m_Lorg_yaml_lexer_YamlCharRules$().isFlowIndicator__I__Z(chr)))
  } else {
    return $m_Lorg_yaml_lexer_YamlCharRules$().isNsChar__I__Z(chr)
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.indicator__I__Z = (function(chr) {
  var this$1 = this.input$1;
  if ((this$1.state$1.current$1 === chr)) {
    return this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1)
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.obtainClosingChar__I__s_Option = (function(first) {
  switch (first) {
    case 34:
    case 39: {
      return new $c_s_Some().init___O(first);
      break
    }
    case 123: {
      return new $c_s_Some().init___O(125);
      break
    }
    case 91: {
      return new $c_s_Some().init___O(93);
      break
    }
    default: {
      return $m_s_None$()
    }
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.folded__p2__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, ctx) {
  var jsx$1 = $m_Lorg_yaml_lexer_YamlCharRules$();
  var this$1 = this.input$1;
  if (jsx$1.isBBreak__I__Z(this$1.state$1.current$1)) {
    var s = this.saveState__p2__T3();
    var result = this.trimmed__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx);
    if ((!result)) {
      this.restoreState__p2__T3__V(s)
    };
    if (result) {
      return true
    } else {
      return this.lineBreak__p2__Lorg_yaml_lexer_YamlToken__Z($m_Lorg_yaml_lexer_YamlToken$().LineFold$1)
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.blockMapEntry__I__Z = (function(n) {
  var this$1 = this.input$1;
  var explicit = (this$1.state$1.current$1 === 63);
  var entry = (explicit || this.lineContainsMapIndicator__Z());
  if (entry) {
    var s = this.saveState__p2__T3();
    this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginPair$1);
    var result = ((explicit ? this.mapExplicitEntry__I__Z(n) : this.mapImplicitEntry__I__Z(n)) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndPair$1));
    if ((!result)) {
      this.restoreState__p2__T3__V(s)
    };
    return result
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.initialize__V = (function() {
  this.yamlStream__V();
  this.advance__V()
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowJsonContent__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, ctx) {
  var this$1 = this.input$1;
  var x1 = this$1.state$1.current$1;
  switch (x1) {
    case 91: {
      return this.flowSequence__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx);
      break
    }
    case 123: {
      return this.flowMapping__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx);
      break
    }
    case 39: {
      return this.quotedScalar__p2__I__Lorg_yaml_lexer_YamlContext__C__Z(n, ctx, 39);
      break
    }
    case 34: {
      return this.quotedScalar__p2__I__Lorg_yaml_lexer_YamlContext__C__Z(n, ctx, 34);
      break
    }
    default: {
      return false
    }
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.isPlainChar__I__Lorg_yaml_lexer_YamlContext__Z = (function(offset, ctx) {
  var x1 = this.input$1.lookAhead__I__I(offset);
  if ((x1 === 35)) {
    var n = (((-1) + offset) | 0);
    return (this.input$1.lookAhead__I__I(n) !== 32)
  } else if ((x1 === 58)) {
    var n$1 = ((1 + offset) | 0);
    return this.isPlainSafe__p2__I__Lorg_yaml_lexer_YamlContext__Z(this.input$1.lookAhead__I__I(n$1), ctx)
  } else {
    return ((!((x1 === 32) || ((x1 === 9) || ((x1 === 13) || ((x1 === 10) || ($m_Lorg_mulesoft_lexer_LexerInput$().EofChar$1 === x1)))))) && this.isPlainSafe__p2__I__Lorg_yaml_lexer_YamlContext__Z(this.input$1.lookAhead__I__I(offset), ctx))
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.foldedLines__p2__I__Z = (function(n) {
  var b1 = this.foldedText__p2__I__Z(n);
  if (b1) {
    var s = this.saveState__p2__T3();
    while (true) {
      var this$1 = this.input$1;
      if ((this$1.state$1.nonEof__Z() && (this.folded__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, $m_Lorg_yaml_lexer_BlockIn$()) && this.foldedText__p2__I__Z(n)))) {
        s = this.saveState__p2__T3()
      } else {
        break
      }
    };
    this.restoreState__p2__T3__V(s);
    return true
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.tagHandle__p2__Z = (function() {
  if (this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginHandle$1)) {
    if ((((this.input$1.lookAhead__I__I(1) === 33) && this.indicator__I__Z(33)) && this.indicator__I__Z(33))) {
      var jsx$2 = true
    } else if ($m_Lorg_yaml_lexer_YamlCharRules$().isWordChar__I__Z(this.input$1.lookAhead__I__I(1))) {
      var s = this.saveState__p2__T3();
      this.indicator__I__Z(33);
      var this$1 = this.input$1;
      while (true) {
        var v1 = this$1.state$1.current$1;
        if ($m_Lorg_yaml_lexer_YamlCharRules$().isWordChar__I__Z(v1)) {
          this$1.state$1.consume__jl_CharSequence__I__V(this$1.data$1, this$1.endOffset$1)
        } else {
          break
        }
      };
      var result = (this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().MetaText$1) && this.indicator__I__Z(33));
      if ((!result)) {
        this.restoreState__p2__T3__V(s)
      };
      var jsx$2 = result
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var jsx$1 = true
    } else {
      var jsx$1 = this.indicator__I__Z(33)
    }
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndHandle$1)
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.directiveDocument__p2__Z = (function() {
  var this$1 = this.input$1;
  if ((this$1.state$1.current$1 === 37)) {
    var f = (function($this) {
      return (function() {
        return $this.directive__p2__Z()
      })
    })(this);
    var s = this.saveState__p2__T3();
    var result = $uZ(f());
    if (result) {
      while (true) {
        s = this.saveState__p2__T3();
        var this$2 = this.input$1;
        if ((this$2.state$1.nonEof__Z() && $uZ(f()))) {
          /*<skip>*/
        } else {
          break
        }
      }
    };
    this.restoreState__p2__T3__V(s);
    var jsx$1 = result
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return this.explicitDocument__p2__Z()
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowPairEntry__p2__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, c) {
  var s = this.saveState__p2__T3();
  var b1 = this.implicitYamlKey__Lorg_yaml_lexer_YamlContext__Z($m_Lorg_yaml_lexer_FlowKey$());
  var result = (b1 && this.flowMapSeparateValue__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, c));
  if ((!result)) {
    this.restoreState__p2__T3__V(s)
  };
  if ((result || this.flowMapEmptyKeyEntry__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, c))) {
    return true
  } else {
    var s$1 = this.saveState__p2__T3();
    var result$1 = (this.implicitJsonKey__Lorg_yaml_lexer_YamlContext__Z($m_Lorg_yaml_lexer_FlowKey$()) && this.flowMapAdjacentValue__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, c));
    if ((!result$1)) {
      this.restoreState__p2__T3__V(s$1)
    };
    return result$1
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.separateInLine__p2__Z = (function() {
  var n = this.input$2.countWhiteSpaces__I__I(0);
  if (((n > 0) && this.consumeAndEmit__I__Lorg_mulesoft_lexer_Token__Z(n, $m_Lorg_yaml_lexer_YamlToken$().WhiteSpace$1))) {
    return true
  } else {
    var this$1 = this.input$1;
    return (this$1.state$1.column$1 === 0)
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.separateFlow__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, ctx) {
  var x = $m_Lorg_yaml_lexer_FlowKey$();
  if ((x === ctx)) {
    var jsx$1 = true
  } else {
    var x$3 = $m_Lorg_yaml_lexer_BlockKey$();
    var jsx$1 = (x$3 === ctx)
  };
  if (jsx$1) {
    return this.separateInLine__p2__Z()
  } else {
    var s = this.saveState__p2__T3();
    var result = (this.multilineComment__Z() && (this.linePrefix__p2__I__Z__Z__Z(n, true, false) || this.flowLinePrefix__p2__Z()));
    if ((!result)) {
      this.restoreState__p2__T3__V(s)
    };
    if (result) {
      return true
    } else {
      return this.separateInLine__p2__Z()
    }
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.literalScalar__I__Z = (function(n) {
  var this$1 = this.input$1;
  if ((this$1.state$1.current$1 === 124)) {
    this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginScalar$1);
    this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1);
    var x1 = this.blockHeader__I__T2(n);
    if ((x1 === null)) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var m = x1.$$und1$mcI$sp__I();
    var t = x1.$$und2$mcC$sp__C();
    return this.literalContent__I__C__Z(((n + m) | 0), t)
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.commentText__Z = (function() {
  var this$1 = this.input$1;
  if ((this$1.state$1.current$1 !== 35)) {
    return false
  };
  this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginComment$1);
  this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1);
  while (true) {
    var this$3 = $m_Lorg_yaml_lexer_YamlCharRules$();
    var this$2 = this.input$1;
    var c = this$2.state$1.current$1;
    if ((!this$3.isBreakOrEof__I__Z(c))) {
      var this$4 = this.input$1;
      this$4.state$1.consume__jl_CharSequence__I__V(this$4.data$1, this$4.endOffset$1)
    } else {
      break
    }
  };
  this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().MetaText$1);
  this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndComment$1);
  return this.breakComment__Z()
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowMapExplicitEntry__p2__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, c) {
  var this$1 = this.input$1;
  if ((this$1.state$1.current$1 === 44)) {
    var jsx$1 = true
  } else {
    var this$2 = this.input$1;
    var jsx$1 = (this$2.state$1.current$1 === 125)
  };
  if (((jsx$1 && this.emptyNode__p2__Z()) && this.emptyNode__p2__Z())) {
    return true
  } else {
    return this.flowMapImplicitEntry__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, c)
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowSequenceEntry__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, ctx) {
  var s = this.saveState__p2__T3();
  var result = ((((this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginNode$1) && this.emit__Lorg_mulesoft_lexer_Token__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginMapping$1, $m_Lorg_yaml_lexer_YamlToken$().BeginPair$1)) && this.flowPair__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx)) && this.emit__Lorg_mulesoft_lexer_Token__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndPair$1, $m_Lorg_yaml_lexer_YamlToken$().EndMapping$1)) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndNode$1));
  if ((!result)) {
    this.restoreState__p2__T3__V(s)
  };
  if (result) {
    return true
  } else {
    var s$1 = this.saveState__p2__T3();
    var result$1 = ((this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginNode$1) && this.flowNode__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx)) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndNode$1));
    if ((!result$1)) {
      this.restoreState__p2__T3__V(s$1)
    };
    return result$1
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowMapEmptyKeyEntry__p2__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, c) {
  var s = this.saveState__p2__T3();
  var result = (this.emptyNode__p2__Z() && this.flowMapSeparateValue__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, c));
  if ((!result)) {
    this.restoreState__p2__T3__V(s)
  };
  return result
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.blockNode__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, ctx) {
  var s = this.saveState__p2__T3();
  var result = this.blockInBlock__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx);
  if ((!result)) {
    this.restoreState__p2__T3__V(s)
  };
  if (result) {
    return true
  } else {
    var s$1 = this.saveState__p2__T3();
    var b1 = (this.separate__I__Lorg_yaml_lexer_YamlContext__Z(((1 + n) | 0), $m_Lorg_yaml_lexer_FlowOut$()) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginNode$1));
    var result$1 = (((b1 && this.flowNode__p2__I__Lorg_yaml_lexer_YamlContext__Z(((1 + n) | 0), $m_Lorg_yaml_lexer_FlowOut$())) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndNode$1)) && this.multilineComment__Z());
    if ((!result$1)) {
      this.restoreState__p2__T3__V(s$1)
    };
    return result$1
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.isDirectivesEnd__p2__Z = (function() {
  var this$1 = this.input$1;
  if (((this$1.state$1.current$1 === 45) && (this.input$1.lookAhead__I__I(1) === 45))) {
    return (this.input$1.lookAhead__I__I(2) === 45)
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowJsonNode__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, ctx) {
  if (this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginNode$1)) {
    if (this.nodeProperties__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx)) {
      this.separate__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx)
    };
    var jsx$1 = true
  } else {
    var jsx$1 = false
  };
  if ((jsx$1 && this.flowJsonContent__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx))) {
    return this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndNode$1)
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowYamlContent__p2__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, ctx) {
  var this$1 = this.input$1;
  if (this.isPlainFirst__I__I__Lorg_yaml_lexer_YamlContext__Z(this$1.state$1.current$1, this.input$1.lookAhead__I__I(1), ctx)) {
    return this.plainScalar__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx)
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.blockMapping__I__Z = (function(n) {
  var this$1 = this.input$1;
  if ((this$1.state$1.column$1 === 0)) {
    var m = this.detectMapStart__p2__I__I(n);
    if (((m > 0) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginMapping$1))) {
      var f = (function($this, n$1, m$1) {
        return (function() {
          return ($this.indent__I__Z(((n$1 + m$1) | 0)) && $this.blockMapEntry__I__Z(((n$1 + m$1) | 0)))
        })
      })(this, n, m);
      var s = this.saveState__p2__T3();
      var result = $uZ(f());
      if (result) {
        while (true) {
          s = this.saveState__p2__T3();
          var this$2 = this.input$1;
          if ((this$2.state$1.nonEof__Z() && $uZ(f()))) {
            /*<skip>*/
          } else {
            break
          }
        }
      };
      this.restoreState__p2__T3__V(s);
      var jsx$1 = result
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndMapping$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.foldedText__p2__I__Z = (function(n) {
  if ((!((this.input$2.countSpaces__I__I__I(0, 2147483647) !== n) || (!$m_Lorg_yaml_lexer_YamlCharRules$().isNsChar__I__Z(this.input$1.lookAhead__I__I(n)))))) {
    this.consumeAndEmit__I__Lorg_mulesoft_lexer_Token__Z(n, $m_Lorg_yaml_lexer_YamlToken$().Indent$1);
    var this$1 = this.input$1;
    while (true) {
      var v1 = this$1.state$1.current$1;
      if ($m_Lorg_yaml_lexer_YamlCharRules$().isNBChar__I__Z(v1)) {
        this$1.state$1.consume__jl_CharSequence__I__V(this$1.data$1, this$1.endOffset$1)
      } else {
        break
      }
    };
    return this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Text$1)
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.processPending__V = (function() {
  this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndStream$1)
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.init___Lorg_mulesoft_lexer_LexerInput__Lorg_mulesoft_lexer_Position = (function(input, positionOffset) {
  this.input$2 = input;
  $c_Lorg_mulesoft_lexer_BaseLexer.prototype.init___Lorg_mulesoft_lexer_LexerInput__Lorg_mulesoft_lexer_Position.call(this, input, positionOffset);
  return this
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.blockInBlock__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, ctx) {
  return ((this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginNode$1) && (this.blockScalar__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx) || this.blockCollection__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx))) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndNode$1))
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.anyDocument__p2__Z = (function() {
  var this$1 = this.input$1;
  if (this$1.state$1.nonEof__Z()) {
    var s = this.saveState__p2__T3();
    var result = ((this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginDocument$1) && ((this.directiveDocument__p2__Z() || this.explicitDocument__p2__Z()) || this.blockNode__I__Lorg_yaml_lexer_YamlContext__Z((-1), $m_Lorg_yaml_lexer_BlockIn$()))) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndDocument$1));
    if ((!result)) {
      this.restoreState__p2__T3__V(s)
    };
    return result
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.yamlStream__V = (function() {
  while (this.documentPrefix__p2__Z()) {
    /*<skip>*/
  };
  this.anyDocument__p2__Z();
  var this$1 = this.input$2;
  var currentOffset = this$1.state$1.offset$1;
  while (true) {
    var this$2 = this.input$1;
    if (this$2.state$1.nonEof__Z()) {
      var s = this.saveState__p2__T3();
      var f = (function($this) {
        return (function() {
          return $this.documentSuffix__p2__Z()
        })
      })(this);
      var s$1 = this.saveState__p2__T3();
      var result = $uZ(f());
      if (result) {
        while (true) {
          s$1 = this.saveState__p2__T3();
          var this$3 = this.input$1;
          if ((this$3.state$1.nonEof__Z() && $uZ(f()))) {
            /*<skip>*/
          } else {
            break
          }
        }
      };
      this.restoreState__p2__T3__V(s$1);
      if (result) {
        var s$2 = this.saveState__p2__T3();
        while (true) {
          var this$4 = this.input$1;
          if ((this$4.state$1.nonEof__Z() && this.documentPrefix__p2__Z())) {
            s$2 = this.saveState__p2__T3()
          } else {
            break
          }
        };
        this.restoreState__p2__T3__V(s$2);
        var jsx$1 = true
      } else {
        var jsx$1 = false
      };
      if (jsx$1) {
        this.anyDocument__p2__Z();
        var result$1 = true
      } else {
        var result$1 = false
      };
      if ((!result$1)) {
        this.restoreState__p2__T3__V(s)
      };
      if ((!result$1)) {
        var s$3 = this.saveState__p2__T3();
        var s$4 = this.saveState__p2__T3();
        while (true) {
          var this$5 = this.input$1;
          if ((this$5.state$1.nonEof__Z() && this.documentPrefix__p2__Z())) {
            s$4 = this.saveState__p2__T3()
          } else {
            break
          }
        };
        this.restoreState__p2__T3__V(s$4);
        var result$2 = ((this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginDocument$1) && this.explicitDocument__p2__Z()) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndDocument$1));
        if ((!result$2)) {
          this.restoreState__p2__T3__V(s$3)
        }
      };
      var this$6 = this.input$2;
      if ((this$6.state$1.offset$1 === currentOffset)) {
        var this$7 = this.input$1;
        while (true) {
          var v1 = this$7.state$1.current$1;
          if ((v1 !== $m_Lorg_mulesoft_lexer_LexerInput$().EofChar$1)) {
            this$7.state$1.consume__jl_CharSequence__I__V(this$7.data$1, this$7.endOffset$1)
          } else {
            break
          }
        };
        this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Error$1)
      };
      var this$8 = this.input$2;
      currentOffset = this$8.state$1.offset$1
    } else {
      break
    }
  };
  this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndStream$1)
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.compactMapping__I__Z = (function(n) {
  if ((this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginMapping$1) && this.blockMapEntry__I__Z(n))) {
    var s = this.saveState__p2__T3();
    while (true) {
      var this$1 = this.input$1;
      if ((this$1.state$1.nonEof__Z() && (this.indent__I__Z(n) && this.blockMapEntry__I__Z(n)))) {
        s = this.saveState__p2__T3()
      } else {
        break
      }
    };
    this.restoreState__p2__T3__V(s);
    var jsx$1 = true
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndMapping$1)
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.plainOneLine__p2__Lorg_yaml_lexer_YamlContext__V = (function(ctx) {
  this.plainFirst__p2__Lorg_yaml_lexer_YamlContext__Z(ctx);
  this.plainInLine__p2__Lorg_yaml_lexer_YamlContext__Z(ctx);
  this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Text$1)
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.mapImplicitEntry__I__Z = (function(n) {
  var s = this.saveState__p2__T3();
  var s$1 = this.saveState__p2__T3();
  var result = this.implicitJsonKey__Lorg_yaml_lexer_YamlContext__Z($m_Lorg_yaml_lexer_BlockKey$());
  if ((!result)) {
    this.restoreState__p2__T3__V(s$1)
  };
  if (result) {
    var jsx$1 = true
  } else {
    var s$2 = this.saveState__p2__T3();
    var result$1 = this.implicitYamlKey__Lorg_yaml_lexer_YamlContext__Z($m_Lorg_yaml_lexer_BlockKey$());
    if ((!result$1)) {
      this.restoreState__p2__T3__V(s$2)
    };
    var jsx$1 = result$1
  };
  if ((jsx$1 || this.emptyNode__p2__Z())) {
    var result$2 = this.mapImplicitValue__I__Z(n)
  } else {
    var result$2 = false
  };
  if ((!result$2)) {
    this.restoreState__p2__T3__V(s)
  };
  return result$2
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.lineBreak__p2__Lorg_yaml_lexer_YamlToken__Z = (function(t) {
  var n = this.lineBreakSequence__I__I(0);
  return ((n !== 0) && (this.input$1.consume__I__V(n), this.emit__Lorg_mulesoft_lexer_Token__Z(t)))
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.isInvalid$1__p2__I__Z = (function(chr) {
  return (((chr !== 93) && (chr !== 44)) && (chr !== $m_Lorg_mulesoft_lexer_LexerInput$().EofChar$1))
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.linePrefix__p2__I__Z__Z__Z = (function(n, flow, emptyLine) {
  var this$1 = this.input$1;
  if ((this$1.state$1.column$1 === 0)) {
    if ((this.isDirectivesEnd__p2__Z() || this.isDocumentEnd__p2__Z())) {
      return false
    };
    var spaces = this.input$2.countSpaces__I__I__I(0, n);
    if (((!emptyLine) && (spaces < n))) {
      return false
    };
    var whiteSpaces = (flow ? this.input$2.countWhiteSpaces__I__I(spaces) : 0);
    if (emptyLine) {
      var jsx$2 = $m_Lorg_yaml_lexer_YamlCharRules$();
      var n$1 = ((spaces + whiteSpaces) | 0);
      var jsx$1 = (!jsx$2.isBBreak__I__Z(this.input$1.lookAhead__I__I(n$1)))
    } else {
      var jsx$1 = false
    };
    if ((!jsx$1)) {
      this.consumeAndEmit__I__Lorg_mulesoft_lexer_Token__Z(spaces, $m_Lorg_yaml_lexer_YamlToken$().Indent$1);
      return this.consumeAndEmit__I__Lorg_mulesoft_lexer_Token__Z(whiteSpaces, $m_Lorg_yaml_lexer_YamlToken$().WhiteSpace$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.nameOrParameter$1__p2__Z = (function() {
  var jsx$1 = $m_Lorg_yaml_lexer_YamlCharRules$();
  var this$1 = this.input$1;
  if (jsx$1.isNsChar__I__Z(this$1.state$1.current$1)) {
    while (true) {
      var this$2 = this.input$1;
      this$2.state$1.consume__jl_CharSequence__I__V(this$2.data$1, this$2.endOffset$1);
      var jsx$2 = $m_Lorg_yaml_lexer_YamlCharRules$();
      var this$3 = this.input$1;
      if (jsx$2.isNsChar__I__Z(this$3.state$1.current$1)) {
        /*<skip>*/
      } else {
        break
      }
    };
    return this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().MetaText$1)
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.error__Z = (function() {
  var this$2 = $m_Lorg_yaml_lexer_YamlCharRules$();
  var this$1 = this.input$1;
  var c = this$1.state$1.current$1;
  if (this$2.isBreakOrEof__I__Z(c)) {
    return true
  } else {
    while (true) {
      var this$3 = this.input$1;
      this$3.state$1.consume__jl_CharSequence__I__V(this$3.data$1, this$3.endOffset$1);
      var this$5 = $m_Lorg_yaml_lexer_YamlCharRules$();
      var this$4 = this.input$1;
      var c$1 = this$4.state$1.current$1;
      if ((!this$5.isBreakOrEof__I__Z(c$1))) {
        /*<skip>*/
      } else {
        break
      }
    };
    return this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Error$1)
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowMapSeparateValue__p2__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, c) {
  var this$1 = this.input$1;
  if ((((this$1.state$1.current$1 === 58) && (!this.isPlainSafe__p2__I__Lorg_yaml_lexer_YamlContext__Z(this.input$1.lookAhead__I__I(1), c))) && this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1))) {
    var s = this.saveState__p2__T3();
    this.separate__I__Lorg_yaml_lexer_YamlContext__Z(n, c);
    this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginNode$1);
    var result = (this.flowNode__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, c) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndNode$1));
    if ((!result)) {
      this.restoreState__p2__T3__V(s)
    };
    if (result) {
      return true
    } else {
      return this.emptyNode__p2__Z()
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.plainInLine__p2__Lorg_yaml_lexer_YamlContext__Z = (function(ctx) {
  while (true) {
    var spaces = this.input$2.countWhiteSpaces__I__I(0);
    if (this.isPlainChar__I__Lorg_yaml_lexer_YamlContext__Z(spaces, ctx)) {
      var n = ((1 + spaces) | 0);
      this.input$1.consume__I__V(n);
      var jsx$1 = true
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      /*<skip>*/
    } else {
      break
    }
  };
  return true
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.spacedText__p2__I__Z = (function(n) {
  var m = this.input$2.countSpaces__I__I__I(0, 2147483647);
  if ((!((m < n) || ((m === n) && (!$m_Lorg_yaml_lexer_YamlCharRules$().isWhite__I__Z(this.input$1.lookAhead__I__I(n))))))) {
    this.consumeAndEmit__I__Lorg_mulesoft_lexer_Token__Z(n, $m_Lorg_yaml_lexer_YamlToken$().Indent$1);
    var this$1 = this.input$1;
    while (true) {
      var v1 = this$1.state$1.current$1;
      if ($m_Lorg_yaml_lexer_YamlCharRules$().isNBChar__I__Z(v1)) {
        this$1.state$1.consume__jl_CharSequence__I__V(this$1.data$1, this$1.endOffset$1)
      } else {
        break
      }
    };
    return this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Text$1)
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.inFlow__p2__Lorg_yaml_lexer_YamlContext__Lorg_yaml_lexer_YamlContext = (function(ctx) {
  var x$2 = $m_Lorg_yaml_lexer_BlockKey$();
  if (((ctx !== null) && (ctx === x$2))) {
    var jsx$1 = true
  } else {
    var x$4 = $m_Lorg_yaml_lexer_FlowKey$();
    var jsx$1 = ((ctx !== null) && (ctx === x$4))
  };
  if (jsx$1) {
    return $m_Lorg_yaml_lexer_FlowKey$()
  } else {
    return $m_Lorg_yaml_lexer_FlowIn$()
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.indentLess__I__Z = (function(n) {
  var m = this.input$2.countSpaces__I__I__I(0, 2147483647);
  return ((m < n) && this.consumeAndEmit__I__Lorg_mulesoft_lexer_Token__Z(m, $m_Lorg_yaml_lexer_YamlToken$().Indent$1))
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.detectMapStart__p2__I__I = (function(n) {
  var spaces = this.input$2.countSpaces__I__I__I(0, 2147483647);
  return ((((spaces > n) && (this.input$1.lookAhead__I__I(spaces) === 63)) || this.lineContainsMapIndicator__Z()) ? ((spaces - n) | 0) : 0)
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.literalContent__I__C__Z = (function(n, t) {
  var s = this.saveState__p2__T3();
  if (this.literalContentLine__p2__I__Z(n)) {
    var s$1 = this.saveState__p2__T3();
    while (true) {
      var this$1 = this.input$1;
      if ((this$1.state$1.nonEof__Z() && (this.lineBreak__p2__Lorg_yaml_lexer_YamlToken__Z($m_Lorg_yaml_lexer_YamlToken$().LineFeed$1) && this.literalContentLine__p2__I__Z(n)))) {
        s$1 = this.saveState__p2__T3()
      } else {
        break
      }
    };
    this.restoreState__p2__T3__V(s$1);
    var jsx$1 = true
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var result = this.chompedLast__C__Z(t)
  } else {
    var result = false
  };
  if ((!result)) {
    this.restoreState__p2__T3__V(s)
  };
  if ((!result)) {
    if ((t === 45)) {
      this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndScalar$1)
    }
  };
  return this.chompedEmpty__I__C__Z(n, t)
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.detectSequenceStart__p2__I__I = (function(n) {
  var spaces = this.input$2.countSpaces__I__I__I(0, 2147483647);
  if ((this.input$1.lookAhead__I__I(spaces) === 45)) {
    var jsx$2 = $m_Lorg_yaml_lexer_YamlCharRules$();
    var n$1 = ((1 + spaces) | 0);
    var jsx$1 = (!jsx$2.isNsChar__I__Z(this.input$1.lookAhead__I__I(n$1)))
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return ((spaces - n) | 0)
  } else {
    return 0
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowMapImplicitEntry__p2__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, c) {
  var s = this.saveState__p2__T3();
  var b1 = (this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginNode$1) && this.flowYamlNode__I__Lorg_yaml_lexer_YamlContext__Z(n, c));
  if ((b1 && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndNode$1))) {
    var s$1 = this.saveState__p2__T3();
    var result = ((this.separate__I__Lorg_yaml_lexer_YamlContext__Z(n, c), true) && this.flowMapSeparateValue__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, c));
    if ((!result)) {
      this.restoreState__p2__T3__V(s$1)
    };
    if (result) {
      var result$1 = true
    } else {
      var result$1 = this.emptyNode__p2__Z()
    }
  } else {
    var result$1 = false
  };
  if ((!result$1)) {
    this.restoreState__p2__T3__V(s)
  };
  if ((result$1 || this.flowMapEmptyKeyEntry__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, c))) {
    return true
  } else {
    return this.flowMapJsonKeyEntry__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, c)
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.blockIndented__p2__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, ctx) {
  var m = ((this.detectSequenceStart__p2__I__I(n) + n) | 0);
  if ((m > 0)) {
    var s = this.saveState__p2__T3();
    var result = (((this.indent__I__Z(m) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginNode$1)) && this.compactSequence__p2__I__Z(((((1 + n) | 0) + m) | 0))) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndNode$1));
    if ((!result)) {
      this.restoreState__p2__T3__V(s)
    };
    var jsx$2 = result
  } else {
    var jsx$2 = false
  };
  if (jsx$2) {
    var jsx$1 = true
  } else {
    var m$2 = ((this.detectMapStart__p2__I__I(n) + n) | 0);
    if ((m$2 > 0)) {
      var s$1 = this.saveState__p2__T3();
      var result$1 = (((this.indent__I__Z(m$2) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginNode$1)) && this.compactMapping__I__Z(((((1 + n) | 0) + m$2) | 0))) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndNode$1));
      if ((!result$1)) {
        this.restoreState__p2__T3__V(s$1)
      };
      var jsx$1 = result$1
    } else {
      var jsx$1 = false
    }
  };
  if (jsx$1) {
    return true
  } else if (this.blockNode__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx)) {
    return true
  } else {
    var s$2 = this.saveState__p2__T3();
    var result$2 = (this.emptyNode__p2__Z() && this.multilineComment__Z());
    if ((!result$2)) {
      this.restoreState__p2__T3__V(s$2)
    };
    return result$2
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowYamlNode__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, c) {
  if ((this.aliasNode__p2__Z() || this.flowYamlContent__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, c))) {
    return true
  } else if (this.nodeProperties__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, c)) {
    var s = this.saveState__p2__T3();
    var result = (this.separate__I__Lorg_yaml_lexer_YamlContext__Z(n, c) && this.flowYamlContent__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, c));
    if ((!result)) {
      this.restoreState__p2__T3__V(s)
    };
    if (result) {
      return true
    } else {
      return this.emptyScalar__Z()
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.documentSuffix__p2__Z = (function() {
  if (this.isDocumentEnd__p2__Z()) {
    var s = this.saveState__p2__T3();
    var result = (this.consumeAndEmit__I__Lorg_mulesoft_lexer_Token__Z(3, $m_Lorg_yaml_lexer_YamlToken$().DocumentEnd$1) && this.multilineComment__Z());
    if ((!result)) {
      this.restoreState__p2__T3__V(s)
    };
    return result
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.indent__I__Z = (function(n) {
  return ((n <= 0) || ((n === this.input$2.countSpaces__I__I__I(0, n)) && this.consumeAndEmit__I__Lorg_mulesoft_lexer_Token__Z(n, $m_Lorg_yaml_lexer_YamlToken$().Indent$1)))
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.quotedScalar__p2__I__Lorg_yaml_lexer_YamlContext__C__Z = (function(n, c, quoteChar) {
  var this$1 = this.input$1;
  if ((this$1.state$1.current$1 === quoteChar)) {
    var elem$1 = false;
    elem$1 = false;
    this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginScalar$1);
    this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1);
    var done = false;
    while ((!done)) {
      var this$3 = this.input$1;
      var x1 = this$3.state$1.current$1;
      if (((x1 === 34) && (quoteChar === 34))) {
        done = true
      } else if (((x1 === 39) && (quoteChar === 39))) {
        if ((this.input$1.lookAhead__I__I(1) !== 39)) {
          done = true
        } else {
          if (elem$1) {
            this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Text$1);
            elem$1 = false
          };
          this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginEscape$1);
          this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1);
          this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().MetaText$1);
          this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndEscape$1)
        }
      } else if (((x1 === 13) || (x1 === 10))) {
        var x$2 = $m_Lorg_yaml_lexer_BlockKey$();
        if ((!((c !== null) && (c === x$2)))) {
          var x$4 = $m_Lorg_yaml_lexer_FlowKey$();
          var jsx$1 = (!((c !== null) && (c === x$4)))
        } else {
          var jsx$1 = false
        };
        if (jsx$1) {
          if (elem$1) {
            this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Text$1);
            elem$1 = false
          };
          var s = this.saveState__p2__T3();
          var result = (this.lineBreak__p2__Lorg_yaml_lexer_YamlToken__Z($m_Lorg_yaml_lexer_YamlToken$().LineBreak$1) && this.emptyLine__I__Lorg_yaml_lexer_YamlContext__Z(n, c));
          if ((!result)) {
            this.restoreState__p2__T3__V(s)
          };
          if ((!result)) {
            this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().LineFold$1)
          };
          this.indent__I__Z(n);
          this.consumeAndEmit__I__Lorg_mulesoft_lexer_Token__Z(this.input$2.countWhiteSpaces__I__I(0), $m_Lorg_yaml_lexer_YamlToken$().WhiteSpace$1)
        } else {
          elem$1 = false;
          this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Error$1);
          done = true
        }
      } else if (((x1 === 92) && (quoteChar === 34))) {
        if (elem$1) {
          this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Text$1);
          elem$1 = false
        };
        this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginEscape$1);
        this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1);
        var this$4 = this.input$1;
        var nl = (this$4.state$1.current$1 === 10);
        if (nl) {
          this.lineBreak__p2__Lorg_yaml_lexer_YamlToken__Z($m_Lorg_yaml_lexer_YamlToken$().LineBreak$1)
        } else {
          var jsx$2 = $m_Lorg_yaml_lexer_YamlCharRules$();
          var this$5 = this.input$1;
          var x1$2 = jsx$2.escapeSeq__I__I(this$5.state$1.current$1);
          switch (x1$2) {
            case (-1): {
              this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Error$1);
              break
            }
            case 120: {
              this.processHexa$1__p2__I__Z(2);
              break
            }
            case 117: {
              this.processHexa$1__p2__I__Z(4);
              break
            }
            case 85: {
              this.processHexa$1__p2__I__Z(8);
              break
            }
            default: {
              this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().MetaText$1)
            }
          }
        };
        this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndEscape$1);
        if (nl) {
          this.consumeAndEmit__I__Lorg_mulesoft_lexer_Token__Z(this.input$2.countWhiteSpaces__I__I(0), $m_Lorg_yaml_lexer_YamlToken$().WhiteSpace$1)
        }
      } else if (((x1 === 32) || (x1 === 9))) {
        var spaces = this.input$2.countWhiteSpaces__I__I(0);
        if ($m_Lorg_yaml_lexer_YamlCharRules$().isBBreak__I__Z(this.input$1.lookAhead__I__I(spaces))) {
          if (elem$1) {
            this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Text$1);
            elem$1 = false
          };
          this.consumeAndEmit__I__Lorg_mulesoft_lexer_Token__Z(spaces, $m_Lorg_yaml_lexer_YamlToken$().WhiteSpace$1)
        } else {
          elem$1 = true;
          this.input$1.consume__I__V(spaces)
        }
      } else if (($m_Lorg_mulesoft_lexer_LexerInput$().EofChar$1 === x1)) {
        this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Error$1);
        done = true
      } else {
        elem$1 = true;
        var this$6 = this.input$1;
        this$6.state$1.consume__jl_CharSequence__I__V(this$6.data$1, this$6.endOffset$1)
      }
    };
    if (elem$1) {
      this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Text$1);
      elem$1 = false
    };
    this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1);
    return this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndScalar$1)
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowSequence__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, ctx) {
  var this$1 = this.input$1;
  if ((this$1.state$1.current$1 === 91)) {
    var s = this.saveState__p2__T3();
    if ((((this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginSequence$1) && this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1)) && (this.separateFlow__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx), true)) && (this.flowSequenceEntries__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, this.inFlow__p2__Lorg_yaml_lexer_YamlContext__Lorg_yaml_lexer_YamlContext(ctx)), true))) {
      var this$2 = this.input$1;
      var jsx$1 = (this$2.state$1.current$1 === 93)
    } else {
      var jsx$1 = false
    };
    if ((jsx$1 && this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1))) {
      var result = this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndSequence$1)
    } else {
      var result = false
    };
    if ((!result)) {
      this.restoreState__p2__T3__V(s)
    };
    return result
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.isNsAnchorChar__p2__I__Z = (function(c) {
  return ($m_Lorg_yaml_lexer_YamlCharRules$().isNsChar__I__Z(c) && (!$m_Lorg_yaml_lexer_YamlCharRules$().isFlowIndicator__I__Z(c)))
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.separate__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, ctx) {
  var x = $m_Lorg_yaml_lexer_FlowKey$();
  if ((x === ctx)) {
    var jsx$1 = true
  } else {
    var x$3 = $m_Lorg_yaml_lexer_BlockKey$();
    var jsx$1 = (x$3 === ctx)
  };
  if (jsx$1) {
    return this.separateInLine__p2__Z()
  } else {
    var s = this.saveState__p2__T3();
    var result = (this.multilineComment__Z() && this.linePrefix__p2__I__Z__Z__Z(n, true, false));
    if ((!result)) {
      this.restoreState__p2__T3__V(s)
    };
    if (result) {
      return true
    } else {
      return this.separateInLine__p2__Z()
    }
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.aliasNode__p2__Z = (function() {
  var this$1 = this.input$1;
  if ((((((this$1.state$1.current$1 === 42) && this.isNsAnchorChar__p2__I__Z(this.input$1.lookAhead__I__I(1))) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginAlias$1)) && this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1)) && this.anchorName__p2__Z())) {
    return this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndAlias$1)
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.tagProperty__p2__Z = (function() {
  var this$1 = this.input$1;
  if (((this$1.state$1.current$1 === 33) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginTag$1))) {
    if (((this.input$1.lookAhead__I__I(1) === 32) && this.indicator__I__Z(33))) {
      var jsx$2 = true
    } else {
      var s = this.saveState__p2__T3();
      if ((this.indicator__I__Z(33) && this.indicator__I__Z(60))) {
        var f = (function($this) {
          return (function() {
            return $this.uriChar__p2__Z()
          })
        })(this);
        var s$1 = this.saveState__p2__T3();
        var result = $uZ(f());
        if (result) {
          while (true) {
            s$1 = this.saveState__p2__T3();
            var this$2 = this.input$1;
            if ((this$2.state$1.nonEof__Z() && $uZ(f()))) {
              /*<skip>*/
            } else {
              break
            }
          }
        };
        this.restoreState__p2__T3__V(s$1);
        var jsx$3 = result
      } else {
        var jsx$3 = false
      };
      if ((jsx$3 && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().MetaText$1))) {
        var result$1 = this.indicator__I__Z(62)
      } else {
        var result$1 = false
      };
      if ((!result$1)) {
        this.restoreState__p2__T3__V(s)
      };
      var jsx$2 = result$1
    };
    if (jsx$2) {
      var jsx$1 = true
    } else {
      var s$2 = this.saveState__p2__T3();
      if (this.tagHandle__p2__Z()) {
        var s$3 = this.saveState__p2__T3();
        if (this.tagChar__p2__Z()) {
          while (this.tagChar__p2__Z()) {
            /*<skip>*/
          };
          var result$2 = this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().MetaText$1)
        } else {
          var result$2 = false
        };
        if ((!result$2)) {
          this.restoreState__p2__T3__V(s$3)
        };
        if (result$2) {
          var result$3 = true
        } else {
          var result$3 = this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Error$1)
        }
      } else {
        var result$3 = false
      };
      if ((!result$3)) {
        this.restoreState__p2__T3__V(s$2)
      };
      var jsx$1 = result$3
    }
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndTag$1)
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowMapAdjacentValue__p2__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, c) {
  if (this.indicator__I__Z(58)) {
    var s = this.saveState__p2__T3();
    this.separate__I__Lorg_yaml_lexer_YamlContext__Z(n, c);
    this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginNode$1);
    var result = (this.flowNode__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, c) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndNode$1));
    if ((!result)) {
      this.restoreState__p2__T3__V(s)
    };
    if (result) {
      return true
    } else {
      return this.emptyNode__p2__Z()
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.multilineComment__Z = (function() {
  var this$1 = this.input$1;
  if (((this$1.state$1.column$1 === 0) || this.spaceBreakComment__Z())) {
    var s = this.saveState__p2__T3();
    while (true) {
      var this$2 = this.input$1;
      if ((this$2.state$1.nonEof__Z() && this.lineComment__Z())) {
        s = this.saveState__p2__T3()
      } else {
        break
      }
    };
    this.restoreState__p2__T3__V(s);
    return true
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.spacedLines__p2__I__Z = (function(n) {
  var b = this.spacedText__p2__I__Z(n);
  if (b) {
    var s = this.saveState__p2__T3();
    while (true) {
      var this$1 = this.input$1;
      if (this$1.state$1.nonEof__Z()) {
        if (this.lineBreak__p2__Lorg_yaml_lexer_YamlToken__Z($m_Lorg_yaml_lexer_YamlToken$().LineFeed$1)) {
          var s$1 = this.saveState__p2__T3();
          while (true) {
            var this$2 = this.input$1;
            if ((this$2.state$1.nonEof__Z() && this.emptyLine__I__Lorg_yaml_lexer_YamlContext__Z(n, $m_Lorg_yaml_lexer_BlockIn$()))) {
              s$1 = this.saveState__p2__T3()
            } else {
              break
            }
          };
          this.restoreState__p2__T3__V(s$1);
          var jsx$2 = true
        } else {
          var jsx$2 = false
        };
        if (jsx$2) {
          var jsx$1 = this.spacedText__p2__I__Z(n)
        } else {
          var jsx$1 = false
        }
      } else {
        var jsx$1 = false
      };
      if (jsx$1) {
        s = this.saveState__p2__T3()
      } else {
        break
      }
    };
    this.restoreState__p2__T3__V(s);
    return true
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.mapImplicitValue__I__Z = (function(n) {
  if (this.indicator__I__Z(58)) {
    if (this.blockNode__I__Lorg_yaml_lexer_YamlContext__Z(n, $m_Lorg_yaml_lexer_BlockOut$())) {
      return true
    } else if (this.emptyNode__p2__Z()) {
      var s = this.saveState__p2__T3();
      var result = this.multilineComment__Z();
      if ((!result)) {
        this.restoreState__p2__T3__V(s)
      };
      if (result) {
        return true
      } else {
        var s$1 = this.saveState__p2__T3();
        var result$1 = (this.error__Z() && this.multilineComment__Z());
        if ((!result$1)) {
          this.restoreState__p2__T3__V(s$1)
        };
        return result$1
      }
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowMapEntries__p2__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, ctx) {
  _flowMapEntries: while (true) {
    var this$1 = this.input$1;
    if ((this$1.state$1.current$1 !== 125)) {
      if (this.flowMapEntry__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx)) {
        this.separateFlow__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx);
        if (this.indicator__I__Z(44)) {
          this.separateFlow__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx);
          continue _flowMapEntries
        } else {
          return false
        }
      } else {
        return false
      }
    } else {
      return false
    }
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.sameLines__p2__I__Z = (function(n) {
  if (this.nonEndOfDocument__p2__Z()) {
    var s = this.saveState__p2__T3();
    while (true) {
      var this$1 = this.input$1;
      if ((this$1.state$1.nonEof__Z() && this.emptyLine__I__Lorg_yaml_lexer_YamlContext__Z(n, $m_Lorg_yaml_lexer_BlockIn$()))) {
        s = this.saveState__p2__T3()
      } else {
        break
      }
    };
    this.restoreState__p2__T3__V(s);
    var s$1 = this.saveState__p2__T3();
    var result = this.foldedLines__p2__I__Z(n);
    if ((!result)) {
      this.restoreState__p2__T3__V(s$1)
    };
    if (result) {
      return true
    } else {
      var s$2 = this.saveState__p2__T3();
      var result$1 = this.spacedLines__p2__I__Z(n);
      if ((!result$1)) {
        this.restoreState__p2__T3__V(s$2)
      };
      return result$1
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.plainChar__p2__Lorg_yaml_lexer_YamlContext__Z = (function(ctx) {
  var result = this.isPlainChar__I__Lorg_yaml_lexer_YamlContext__Z(0, ctx);
  if (result) {
    var this$1 = this.input$1;
    this$1.state$1.consume__jl_CharSequence__I__V(this$1.data$1, this$1.endOffset$1)
  };
  return result
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.emptyNode__p2__Z = (function() {
  this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginNode$1);
  this.emptyScalar__Z();
  return this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndNode$1)
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.foldedContent__p2__I__C__Z = (function(n, t) {
  var s = this.saveState__p2__T3();
  if (this.sameLines__p2__I__Z(n)) {
    var s$1 = this.saveState__p2__T3();
    while (true) {
      var this$1 = this.input$1;
      if ((this$1.state$1.nonEof__Z() && (this.lineBreak__p2__Lorg_yaml_lexer_YamlToken__Z($m_Lorg_yaml_lexer_YamlToken$().LineFeed$1) && this.sameLines__p2__I__Z(n)))) {
        s$1 = this.saveState__p2__T3()
      } else {
        break
      }
    };
    this.restoreState__p2__T3__V(s$1);
    var jsx$1 = true
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var result = this.chompedLast__C__Z(t)
  } else {
    var result = false
  };
  if ((!result)) {
    this.restoreState__p2__T3__V(s)
  };
  if ((!result)) {
    if ((t === 45)) {
      this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndScalar$1)
    }
  };
  return this.chompedEmpty__I__C__Z(n, t)
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.indentLessOrEqual__I__Z = (function(n) {
  var m = this.input$2.countSpaces__I__I__I(0, 2147483647);
  return ((m <= n) && this.consumeAndEmit__I__Lorg_mulesoft_lexer_Token__Z(m, $m_Lorg_yaml_lexer_YamlToken$().Indent$1))
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.reservedDirective__p2__Z = (function() {
  if (this.nameOrParameter$1__p2__Z()) {
    var s = this.saveState__p2__T3();
    while (true) {
      var this$1 = this.input$1;
      if ((this$1.state$1.nonEof__Z() && (this.separateInLine__p2__Z() && this.nameOrParameter$1__p2__Z()))) {
        s = this.saveState__p2__T3()
      } else {
        break
      }
    };
    this.restoreState__p2__T3__V(s);
    return true
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.uriChar__p2__Z = (function() {
  var this$1 = this.input$1;
  if ((this$1.state$1.current$1 >= 0)) {
    var jsx$2 = $m_sjsr_RuntimeString$();
    var this$2 = this.input$1;
    if ((jsx$2.indexOf__T__I__I("#;/?:@&=+$,_.!~*'()[]", this$2.state$1.current$1) !== (-1))) {
      var jsx$1 = true
    } else {
      var jsx$3 = $m_Lorg_yaml_lexer_YamlCharRules$();
      var this$3 = this.input$1;
      var jsx$1 = jsx$3.isWordChar__I__Z(this$3.state$1.current$1)
    }
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var this$4 = this.input$1;
    this$4.state$1.consume__jl_CharSequence__I__V(this$4.data$1, this$4.endOffset$1);
    return true
  } else {
    var this$5 = this.input$1;
    if ((this$5.state$1.current$1 === 37)) {
      var c = this.input$1.lookAhead__I__I(1);
      var jsx$5 = ((((c >= 48) && (c <= 57)) || ((c >= 65) && (c <= 70))) || ((c >= 97) && (c <= 102)))
    } else {
      var jsx$5 = false
    };
    if (jsx$5) {
      var c$1 = this.input$1.lookAhead__I__I(2);
      var jsx$4 = ((((c$1 >= 48) && (c$1 <= 57)) || ((c$1 >= 65) && (c$1 <= 70))) || ((c$1 >= 97) && (c$1 <= 102)))
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      this.input$1.consume__I__V(3);
      return true
    } else {
      return false
    }
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowMapEntry__p2__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, c) {
  return ((this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginPair$1) && (((this.indicator__I__Z(63) && this.separate__I__Lorg_yaml_lexer_YamlContext__Z(n, c)) && this.flowMapExplicitEntry__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, c)) || this.flowMapImplicitEntry__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, c))) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndPair$1))
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.plainFirst__p2__Lorg_yaml_lexer_YamlContext__Z = (function(ctx) {
  var this$1 = this.input$1;
  var chr = this$1.state$1.current$1;
  var result = (($m_Lorg_yaml_lexer_YamlCharRules$().isNsChar__I__Z(chr) && (!$m_Lorg_yaml_lexer_YamlCharRules$().isIndicator__I__Z(chr))) || ((((chr === 45) || (chr === 58)) || (chr === 63)) && this.isPlainSafe__p2__I__Lorg_yaml_lexer_YamlContext__Z(this.input$1.lookAhead__I__I(1), ctx)));
  if (result) {
    var this$2 = this.input$1;
    this$2.state$1.consume__jl_CharSequence__I__V(this$2.data$1, this$2.endOffset$1)
  };
  return result
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.blockSequence__I__Z = (function(n) {
  var this$1 = this.input$1;
  if ((this$1.state$1.column$1 === 0)) {
    var m = this.detectSequenceStart__p2__I__I(n);
    if (((m > 0) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginSequence$1))) {
      var f = (function($this, n$1, m$1) {
        return (function() {
          var b1 = $this.indent__I__Z(((n$1 + m$1) | 0));
          return (b1 && $this.blockSeqEntry__p2__I__Z(((n$1 + m$1) | 0)))
        })
      })(this, n, m);
      var s = this.saveState__p2__T3();
      var result = $uZ(f());
      if (result) {
        while (true) {
          s = this.saveState__p2__T3();
          var this$2 = this.input$1;
          if ((this$2.state$1.nonEof__Z() && $uZ(f()))) {
            /*<skip>*/
          } else {
            break
          }
        }
      };
      this.restoreState__p2__T3__V(s);
      var jsx$1 = result
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndSequence$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowPair__p2__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, c) {
  return (((this.indicator__I__Z(63) && this.separate__I__Lorg_yaml_lexer_YamlContext__Z(n, c)) && this.flowMapExplicitEntry__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, c)) || this.flowPairEntry__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, c))
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.chompedLast__C__Z = (function(t) {
  var s = this.saveState__p2__T3();
  var this$1 = this.input$1;
  if (((this$1.state$1.current$1 === $m_Lorg_mulesoft_lexer_LexerInput$().EofChar$1) && (t === 45))) {
    var result = this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndScalar$1)
  } else {
    var result = false
  };
  if ((!result)) {
    this.restoreState__p2__T3__V(s)
  };
  if (result) {
    return true
  } else {
    var this$2 = this.input$1;
    if (((this$2.state$1.current$1 === $m_Lorg_mulesoft_lexer_LexerInput$().EofChar$1) || ((t !== 45) && this.lineBreak__p2__Lorg_yaml_lexer_YamlToken__Z($m_Lorg_yaml_lexer_YamlToken$().LineFeed$1)))) {
      return true
    } else {
      return (this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndScalar$1) && this.lineBreak__p2__Lorg_yaml_lexer_YamlToken__Z($m_Lorg_yaml_lexer_YamlToken$().LineBreak$1))
    }
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowLinePrefix__p2__Z = (function() {
  if ((this.isDirectivesEnd__p2__Z() || this.isDocumentEnd__p2__Z())) {
    return false
  };
  var spaces = this.input$2.countSpaces__I__I__I(0, 2147483647);
  var whiteSpaces = this.input$2.countWhiteSpaces__I__I(spaces);
  this.consumeAndEmit__I__Lorg_mulesoft_lexer_Token__Z(spaces, $m_Lorg_yaml_lexer_YamlToken$().Indent$1);
  return this.consumeAndEmit__I__Lorg_mulesoft_lexer_Token__Z(whiteSpaces, $m_Lorg_yaml_lexer_YamlToken$().WhiteSpace$1)
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.compactSequence__p2__I__Z = (function(n) {
  if ((this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginSequence$1) && this.blockSeqEntry__p2__I__Z(n))) {
    var s = this.saveState__p2__T3();
    while (true) {
      var this$1 = this.input$1;
      if ((this$1.state$1.nonEof__Z() && (this.indent__I__Z(n) && this.blockSeqEntry__p2__I__Z(n)))) {
        s = this.saveState__p2__T3()
      } else {
        break
      }
    };
    this.restoreState__p2__T3__V(s);
    var jsx$1 = true
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndSequence$1)
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.bc$1__p2__Lorg_yaml_lexer_YamlContext__I__Z = (function(ctx$8, n$39) {
  if (this.multilineComment__Z()) {
    var x$2 = $m_Lorg_yaml_lexer_BlockOut$();
    if (this.blockSequence__I__Z((((ctx$8 !== null) && (ctx$8 === x$2)) ? (((-1) + n$39) | 0) : n$39))) {
      return true
    } else {
      return this.blockMapping__I__Z(n$39)
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.chompingIndicator$1__p2__C = (function() {
  var this$1 = this.input$1;
  var x1 = this$1.state$1.current$1;
  switch (x1) {
    case 43: {
      this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1);
      return 43;
      break
    }
    case 45: {
      this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1);
      return 45;
      break
    }
    default: {
      return 32
    }
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.breakComment__Z = (function() {
  var this$1 = this.input$1;
  if ((this$1.state$1.current$1 === $m_Lorg_mulesoft_lexer_LexerInput$().EofChar$1)) {
    return true
  } else {
    return this.lineBreak__p2__Lorg_yaml_lexer_YamlToken__Z($m_Lorg_yaml_lexer_YamlToken$().LineBreak$1)
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.spaceBreakComment__Z = (function() {
  return (this.breakComment__Z() || this.lineComment__Z())
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.directive__p2__Z = (function() {
  var this$1 = this.input$1;
  if ((((this$1.state$1.current$1 === 37) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginDirective$1)) && this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1))) {
    var s = this.saveState__p2__T3();
    var result = this.yamlDirective__p2__Z();
    if ((!result)) {
      this.restoreState__p2__T3__V(s)
    };
    if (result) {
      var jsx$2 = true
    } else {
      var s$1 = this.saveState__p2__T3();
      var result$1 = this.tagDirective__p2__Z();
      if ((!result$1)) {
        this.restoreState__p2__T3__V(s$1)
      };
      var jsx$2 = result$1
    };
    if (jsx$2) {
      var jsx$1 = true
    } else {
      var s$2 = this.saveState__p2__T3();
      var result$2 = this.reservedDirective__p2__Z();
      if ((!result$2)) {
        this.restoreState__p2__T3__V(s$2)
      };
      var jsx$1 = result$2
    }
  } else {
    var jsx$1 = false
  };
  if ((jsx$1 && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndDirective$1))) {
    return this.multilineComment__Z()
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.mapExplicitEntry__I__Z = (function(n) {
  var b = this.indicator__I__Z(63);
  if ((b && this.blockIndented__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, $m_Lorg_yaml_lexer_BlockOut$()))) {
    var s = this.saveState__p2__T3();
    var result = (this.mapExplicitValue__I__Z(n) || this.emptyNode__p2__Z());
    if ((!result)) {
      this.restoreState__p2__T3__V(s)
    };
    return result
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.plainScalar__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, ctx) {
  this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginScalar$1);
  var x = $m_Lorg_yaml_lexer_FlowKey$();
  if ((x === ctx)) {
    var jsx$1 = true
  } else {
    var x$3 = $m_Lorg_yaml_lexer_BlockKey$();
    var jsx$1 = (x$3 === ctx)
  };
  if (jsx$1) {
    this.plainOneLine__p2__Lorg_yaml_lexer_YamlContext__V(ctx)
  } else {
    this.plainMultiline__p2__I__Lorg_yaml_lexer_YamlContext__V(n, ctx)
  };
  return this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndScalar$1)
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.documentPrefix__p2__Z = (function() {
  var this$1 = this.input$1;
  if (this$1.state$1.nonEof__Z()) {
    var this$2 = this.input$1;
    if (((this$2.state$1.current$1 === 65279) && this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Bom$1))) {
      if (this.breakComment__Z()) {
        /*<skip>*/
      } else {
        this.commentText__Z()
      };
      var jsx$2 = true
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var s = this.saveState__p2__T3();
      while (true) {
        var this$3 = this.input$1;
        if ((this$3.state$1.nonEof__Z() && this.lineComment__Z())) {
          s = this.saveState__p2__T3()
        } else {
          break
        }
      };
      this.restoreState__p2__T3__V(s);
      var jsx$1 = true
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return true
    } else {
      var f = (function(this$2$1) {
        return (function() {
          return this$2$1.lineComment__Z()
        })
      })(this);
      var s$1 = this.saveState__p2__T3();
      var result = $uZ(f());
      if (result) {
        while (true) {
          s$1 = this.saveState__p2__T3();
          var this$4 = this.input$1;
          if ((this$4.state$1.nonEof__Z() && $uZ(f()))) {
            /*<skip>*/
          } else {
            break
          }
        }
      };
      this.restoreState__p2__T3__V(s$1);
      return result
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.implicitYamlKey__Lorg_yaml_lexer_YamlContext__Z = (function(ctx) {
  return (((this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginNode$1) && this.flowYamlNode__I__Lorg_yaml_lexer_YamlContext__Z(0, ctx)) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndNode$1)) && (this.separateInLine__p2__Z(), true))
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.blockHeader__I__T2 = (function(n) {
  var t = this.chompingIndicator$1__p2__C();
  var this$1 = this.input$1;
  var c = this$1.state$1.current$1;
  var m = (((!((c >= 48) && (c <= 57))) || (c === 48)) ? (-1) : (this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1), (((-48) + c) | 0)));
  if ((t === 32)) {
    t = this.chompingIndicator$1__p2__C()
  };
  if ((!this.spaceBreakComment__Z())) {
    this.error__Z();
    this.breakComment__Z()
  };
  if ((m === (-1))) {
    var s = this.saveState__p2__T3();
    var s$1 = this.saveState__p2__T3();
    while (true) {
      var this$3 = this.input$1;
      if ((this$3.state$1.nonEof__Z() && this.emptyLine__I__Lorg_yaml_lexer_YamlContext__Z(n, $m_Lorg_yaml_lexer_BlockIn$()))) {
        s$1 = this.saveState__p2__T3()
      } else {
        break
      }
    };
    this.restoreState__p2__T3__V(s$1);
    var n1 = this.input$2.countSpaces__I__I__I(0, 2147483647);
    var that = ((n1 - n) | 0);
    m = ((that < 1) ? 1 : that);
    this.restoreState__p2__T3__V(s)
  };
  return new $c_s_Tuple2$mcIC$sp().init___I__C(m, t)
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.explicitDocument__p2__Z = (function() {
  if (this.isDirectivesEnd__p2__Z()) {
    var s = this.saveState__p2__T3();
    this.consumeAndEmit__I__Lorg_mulesoft_lexer_Token__Z(3, $m_Lorg_yaml_lexer_YamlToken$().DirectivesEnd$1);
    var s$1 = this.saveState__p2__T3();
    var result = this.blockNode__I__Lorg_yaml_lexer_YamlContext__Z((-1), $m_Lorg_yaml_lexer_BlockIn$());
    if ((!result)) {
      this.restoreState__p2__T3__V(s$1)
    };
    if (result) {
      var result$2 = true
    } else {
      var s$2 = this.saveState__p2__T3();
      var result$1 = (this.emptyNode__p2__Z() && this.multilineComment__Z());
      if ((!result$1)) {
        this.restoreState__p2__T3__V(s$2)
      };
      var result$2 = result$1
    };
    if ((!result$2)) {
      this.restoreState__p2__T3__V(s)
    };
    return result$2
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowNode__p2__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, c) {
  if (this.aliasNode__p2__Z()) {
    var jsx$1 = true
  } else {
    var s = this.saveState__p2__T3();
    var result = this.flowContent__I__Lorg_yaml_lexer_YamlContext__Z(n, c);
    if ((!result)) {
      this.restoreState__p2__T3__V(s)
    };
    var jsx$1 = result
  };
  if (jsx$1) {
    return true
  } else if (this.nodeProperties__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, c)) {
    var s$1 = this.saveState__p2__T3();
    var result$1 = (this.separate__I__Lorg_yaml_lexer_YamlContext__Z(n, c) && this.flowContent__I__Lorg_yaml_lexer_YamlContext__Z(n, c));
    if ((!result$1)) {
      this.restoreState__p2__T3__V(s$1)
    };
    if (result$1) {
      return true
    } else {
      return this.emptyScalar__Z()
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.lineComment__Z = (function() {
  return (this.separateInLine__p2__Z() && (this.breakComment__Z() || this.commentText__Z()))
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowMapping__p2__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, c) {
  var this$1 = this.input$1;
  if ((this$1.state$1.current$1 === 123)) {
    var s = this.saveState__p2__T3();
    if ((((this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginMapping$1) && this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1)) && (this.separateFlow__I__Lorg_yaml_lexer_YamlContext__Z(n, c), true)) && (this.flowMapEntries__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, this.inFlow__p2__Lorg_yaml_lexer_YamlContext__Lorg_yaml_lexer_YamlContext(c)), true))) {
      var this$2 = this.input$1;
      var jsx$1 = (this$2.state$1.current$1 === 125)
    } else {
      var jsx$1 = false
    };
    if (((jsx$1 && this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1)) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndMapping$1))) {
      this.separateInLine__p2__Z();
      var result = true
    } else {
      var result = false
    };
    if ((!result)) {
      this.restoreState__p2__T3__V(s)
    };
    return result
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.trailComments__I__Z = (function(n) {
  var s = this.saveState__p2__T3();
  if ((this.indentLess__I__Z(n) && this.commentText__Z())) {
    var s$1 = this.saveState__p2__T3();
    while (true) {
      var this$1 = this.input$1;
      if ((this$1.state$1.nonEof__Z() && this.lineComment__Z())) {
        s$1 = this.saveState__p2__T3()
      } else {
        break
      }
    };
    this.restoreState__p2__T3__V(s$1);
    var result = true
  } else {
    var result = false
  };
  if ((!result)) {
    this.restoreState__p2__T3__V(s)
  };
  return result
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.blockSeqEntry__p2__I__Z = (function(n) {
  return (this.indicator__I__Z(45) && this.blockIndented__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, $m_Lorg_yaml_lexer_BlockIn$()))
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.isDocumentEnd__p2__Z = (function() {
  var this$1 = this.input$1;
  if (((this$1.state$1.current$1 === 46) && (this.input$1.lookAhead__I__I(1) === 46))) {
    return (this.input$1.lookAhead__I__I(2) === 46)
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.restoreState__p2__T3__V = (function(s) {
  this.tokenQueue$1.reduceTo__I__V($uI(s.$$und1$1));
  this.mark$1 = $as_Lorg_mulesoft_lexer_Position(s.$$und2$1);
  var this$1 = this.input$2;
  var mark = $as_Lorg_mulesoft_lexer_LexerInput$Mark(s.$$und3$1);
  this$1.state$1 = $as_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState(mark)
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.lineContainsMapIndicator__Z = (function() {
  var i = new $c_sr_IntRef().init___I(0);
  var chr = 0;
  var n = i.elem$1;
  var first = this.input$1.lookAhead__I__I(n);
  var dueClosing = this.obtainClosingChar__I__s_Option(first);
  if (dueClosing.isDefined__Z()) {
    i.elem$1 = ((1 + i.elem$1) | 0)
  };
  while (true) {
    var n$1 = i.elem$1;
    chr = this.input$1.lookAhead__I__I(n$1);
    var x1 = dueClosing;
    matchEnd5: {
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var closingChar = $uI(x2.value$2);
        if ((chr === closingChar)) {
          if ((chr === 39)) {
            var n$2 = ((1 + i.elem$1) | 0);
            var jsx$1 = (this.input$1.lookAhead__I__I(n$2) === 39)
          } else {
            var jsx$1 = false
          };
          if (jsx$1) {
            i.elem$1 = ((1 + i.elem$1) | 0);
            break matchEnd5
          } else {
            if ((chr !== 34)) {
              var jsx$2 = true
            } else {
              var n$3 = (((-1) + i.elem$1) | 0);
              var jsx$2 = (this.input$1.lookAhead__I__I(n$3) !== 92)
            };
            if (jsx$2) {
              dueClosing = $m_s_None$();
              break matchEnd5
            } else {
              break matchEnd5
            }
          }
        }
      };
      var x = $m_s_None$();
      if ((x === x1)) {
        var this$2 = $m_Lorg_yaml_lexer_YamlCharRules$();
        var c1 = chr;
        var f = (function($this, i$1) {
          return (function() {
            var n$4 = ((1 + i$1.elem$1) | 0);
            return $this.input$1.lookAhead__I__I(n$4)
          })
        })(this, i);
        if ((c1 === 58)) {
          if (this$2.isWhite__I__Z($uI(f()))) {
            var jsx$3 = true
          } else {
            var c = $uI(f());
            var jsx$3 = this$2.isBreakOrEof__I__Z(c)
          }
        } else {
          var jsx$3 = false
        }
      } else {
        var jsx$3 = false
      };
      if (jsx$3) {
        return true
      }
    };
    i.elem$1 = ((1 + i.elem$1) | 0);
    var this$3 = $m_Lorg_yaml_lexer_YamlCharRules$();
    var c$1 = chr;
    if ((!this$3.isBreakOrEof__I__Z(c$1))) {
      /*<skip>*/
    } else {
      break
    }
  };
  return false
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.blockScalar__p2__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, ctx) {
  var s = this.saveState__p2__T3();
  if (this.separate__I__Lorg_yaml_lexer_YamlContext__Z(((1 + n) | 0), ctx)) {
    if (this.nodeProperties__p2__I__Lorg_yaml_lexer_YamlContext__Z(((1 + n) | 0), ctx)) {
      this.separate__I__Lorg_yaml_lexer_YamlContext__Z(((1 + n) | 0), ctx)
    };
    var result = (this.literalScalar__I__Z(n) || this.foldedScalar__I__Z(n))
  } else {
    var result = false
  };
  if ((!result)) {
    this.restoreState__p2__T3__V(s)
  };
  return result
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowContent__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, ctx) {
  return (this.flowJsonContent__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx) || this.flowYamlContent__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx))
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.tagPrefix__p2__Z = (function() {
  var s = this.saveState__p2__T3();
  if (this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginTag$1)) {
    if (this.indicator__I__Z(33)) {
      var s$1 = this.saveState__p2__T3();
      while (true) {
        var this$1 = this.input$1;
        if ((this$1.state$1.nonEof__Z() && this.uriChar__p2__Z())) {
          s$1 = this.saveState__p2__T3()
        } else {
          break
        }
      };
      this.restoreState__p2__T3__V(s$1);
      var jsx$2 = true
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var jsx$1 = true
    } else if (this.tagChar__p2__Z()) {
      var s$2 = this.saveState__p2__T3();
      while (true) {
        var this$2 = this.input$1;
        if ((this$2.state$1.nonEof__Z() && this.uriChar__p2__Z())) {
          s$2 = this.saveState__p2__T3()
        } else {
          break
        }
      };
      this.restoreState__p2__T3__V(s$2);
      var jsx$1 = true
    } else {
      var jsx$1 = false
    }
  } else {
    var jsx$1 = false
  };
  if ((jsx$1 && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().MetaText$1))) {
    var result = this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndTag$1)
  } else {
    var result = false
  };
  if ((!result)) {
    this.restoreState__p2__T3__V(s)
  };
  return result
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowSequenceEntries__p2__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, ctx) {
  _flowSequenceEntries: while (true) {
    var this$1 = this.input$1;
    if ((this$1.state$1.current$1 !== 93)) {
      if (this.flowSequenceEntry__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx)) {
        this.separateFlow__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx);
        var this$2 = this.input$1;
        if (this.isInvalid$1__p2__I__Z(this$2.state$1.current$1)) {
          var this$3 = this.input$1;
          while (true) {
            var v1 = this$3.state$1.current$1;
            if (this.isInvalid$1__p2__I__Z(v1)) {
              this$3.state$1.consume__jl_CharSequence__I__V(this$3.data$1, this$3.endOffset$1)
            } else {
              break
            }
          };
          this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Error$1)
        };
        var this$4 = this.input$1;
        var c = this$4.state$1.current$1;
        if (((c === 93) || (c === $m_Lorg_mulesoft_lexer_LexerInput$().EofChar$1))) {
          return true
        } else {
          this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1);
          this.separateFlow__I__Lorg_yaml_lexer_YamlContext__Z(n, ctx);
          continue _flowSequenceEntries
        }
      } else {
        return false
      }
    } else {
      return false
    }
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.anchorName__p2__Z = (function() {
  var this$1 = this.input$1;
  while (true) {
    var v1 = this$1.state$1.current$1;
    if (this.isNsAnchorChar__p2__I__Z(v1)) {
      this$1.state$1.consume__jl_CharSequence__I__V(this$1.data$1, this$1.endOffset$1)
    } else {
      break
    }
  };
  return this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().MetaText$1)
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.processHexa$1__p2__I__Z = (function(chars) {
  return (this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1) && this.consumeAndEmit__I__Lorg_mulesoft_lexer_Token__Z(chars, (this.allHexa$1__p2__I__Z(chars) ? $m_Lorg_yaml_lexer_YamlToken$().MetaText$1 : $m_Lorg_yaml_lexer_YamlToken$().Error$1)))
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.trimmed__p2__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, ctx) {
  var s = this.saveState__p2__T3();
  if (this.lineBreak__p2__Lorg_yaml_lexer_YamlToken__Z($m_Lorg_yaml_lexer_YamlToken$().LineBreak$1)) {
    var f = (function($this, n$1, ctx$1) {
      return (function() {
        return $this.emptyLine__I__Lorg_yaml_lexer_YamlContext__Z(n$1, ctx$1)
      })
    })(this, n, ctx);
    var s$1 = this.saveState__p2__T3();
    var result = $uZ(f());
    if (result) {
      while (true) {
        s$1 = this.saveState__p2__T3();
        var this$1 = this.input$1;
        if ((this$1.state$1.nonEof__Z() && $uZ(f()))) {
          /*<skip>*/
        } else {
          break
        }
      }
    };
    this.restoreState__p2__T3__V(s$1);
    var result$1 = result
  } else {
    var result$1 = false
  };
  if ((!result$1)) {
    this.restoreState__p2__T3__V(s)
  };
  return result$1
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.tagChar__p2__Z = (function() {
  var this$1 = this.input$1;
  if ((this$1.state$1.current$1 !== 124)) {
    var jsx$2 = $m_Lorg_yaml_lexer_YamlCharRules$();
    var this$2 = this.input$1;
    var jsx$1 = (!jsx$2.isFlowIndicator__I__Z(this$2.state$1.current$1))
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return this.uriChar__p2__Z()
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.flowMapJsonKeyEntry__p2__I__Lorg_yaml_lexer_YamlContext__Z = (function(n, c) {
  var s = this.saveState__p2__T3();
  if (this.flowJsonNode__I__Lorg_yaml_lexer_YamlContext__Z(n, c)) {
    var s$1 = this.saveState__p2__T3();
    this.separate__I__Lorg_yaml_lexer_YamlContext__Z(n, c);
    var result = this.flowMapAdjacentValue__p2__I__Lorg_yaml_lexer_YamlContext__Z(n, c);
    if ((!result)) {
      this.restoreState__p2__T3__V(s$1)
    };
    if (result) {
      var result$1 = true
    } else {
      var result$1 = this.emptyNode__p2__Z()
    }
  } else {
    var result$1 = false
  };
  if ((!result$1)) {
    this.restoreState__p2__T3__V(s)
  };
  return result$1
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.tagDirective__p2__Z = (function() {
  return (this.consume__T__Z("TAG") && (this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().MetaText$1), (((this.separateInLine__p2__Z() && this.tagHandle__p2__Z()) && this.separateInLine__p2__Z()) && this.tagPrefix__p2__Z())))
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.yamlDirective__p2__Z = (function() {
  if (this.consume__T__Z("YAML")) {
    this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().MetaText$1);
    if ((!this.separateInLine__p2__Z())) {
      var jsx$1 = true
    } else {
      var this$1 = this.input$1;
      var c = this$1.state$1.current$1;
      var jsx$1 = (!((c >= 48) && (c <= 57)))
    };
    if ((!jsx$1)) {
      var this$3 = this.input$1;
      while (true) {
        var v1 = this$3.state$1.current$1;
        if (((v1 >= 48) && (v1 <= 57))) {
          this$3.state$1.consume__jl_CharSequence__I__V(this$3.data$1, this$3.endOffset$1)
        } else {
          break
        }
      };
      var this$5 = this.input$1;
      if ((this$5.state$1.current$1 !== 46)) {
        var jsx$2 = true
      } else {
        var c$1 = this.input$1.lookAhead__I__I(1);
        var jsx$2 = (!((c$1 >= 48) && (c$1 <= 57)))
      };
      if ((!jsx$2)) {
        var this$7 = this.input$1;
        this$7.state$1.consume__jl_CharSequence__I__V(this$7.data$1, this$7.endOffset$1);
        var this$8 = this.input$1;
        while (true) {
          var v1$1 = this$8.state$1.current$1;
          if (((v1$1 >= 48) && (v1$1 <= 57))) {
            this$8.state$1.consume__jl_CharSequence__I__V(this$8.data$1, this$8.endOffset$1)
          } else {
            break
          }
        };
        return this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().MetaText$1)
      } else {
        return false
      }
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.anchorProperty__p2__Z = (function() {
  var this$1 = this.input$1;
  if ((((((this$1.state$1.current$1 === 38) && this.isNsAnchorChar__p2__I__Z(this.input$1.lookAhead__I__I(1))) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginAnchor$1)) && this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1)) && this.anchorName__p2__Z())) {
    return this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().EndAnchor$1)
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.foldedScalar__I__Z = (function(n) {
  var this$1 = this.input$1;
  if ((((this$1.state$1.current$1 === 62) && this.emit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().BeginScalar$1)) && this.consumeAndEmit__Lorg_mulesoft_lexer_Token__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1))) {
    var x1 = this.blockHeader__I__T2(n);
    if ((x1 === null)) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var m = x1.$$und1$mcI$sp__I();
    var t = x1.$$und2$mcC$sp__C();
    return this.foldedContent__p2__I__C__Z(((n + m) | 0), t)
  } else {
    return false
  }
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.allHexa$1__p2__I__Z = (function(chars) {
  var i = 0;
  while (true) {
    var v1 = i;
    var c = this.input$1.lookAhead__I__I(v1);
    if (((((c >= 48) && (c <= 57)) || ((c >= 65) && (c <= 70))) || ((c >= 97) && (c <= 102)))) {
      i = ((1 + i) | 0)
    } else {
      break
    }
  };
  var i$1 = i;
  return (i$1 >= chars)
});
var $d_Lorg_yaml_lexer_YamlLexer = new $TypeData().initClass({
  Lorg_yaml_lexer_YamlLexer: 0
}, false, "org.yaml.lexer.YamlLexer", {
  Lorg_yaml_lexer_YamlLexer: 1,
  Lorg_mulesoft_lexer_BaseLexer: 1,
  O: 1,
  Lorg_mulesoft_lexer_Lexer: 1
});
$c_Lorg_yaml_lexer_YamlLexer.prototype.$classData = $d_Lorg_yaml_lexer_YamlLexer;
/** @constructor */
function $c_Lorg_yaml_model_DoubleQuoteMark$() {
  $c_O.call(this);
  this.encodeChar$1 = 0
}
$c_Lorg_yaml_model_DoubleQuoteMark$.prototype = new $h_O();
$c_Lorg_yaml_model_DoubleQuoteMark$.prototype.constructor = $c_Lorg_yaml_model_DoubleQuoteMark$;
/** @constructor */
function $h_Lorg_yaml_model_DoubleQuoteMark$() {
  /*<skip>*/
}
$h_Lorg_yaml_model_DoubleQuoteMark$.prototype = $c_Lorg_yaml_model_DoubleQuoteMark$.prototype;
$c_Lorg_yaml_model_DoubleQuoteMark$.prototype.init___ = (function() {
  this.encodeChar$1 = 34;
  return this
});
$c_Lorg_yaml_model_DoubleQuoteMark$.prototype.encodeChar__C = (function() {
  return this.encodeChar$1
});
$c_Lorg_yaml_model_DoubleQuoteMark$.prototype.markText__T__T = (function(text) {
  return $f_Lorg_yaml_model_QuotedMark__markText__T__T(this, text)
});
$c_Lorg_yaml_model_DoubleQuoteMark$.prototype.plain__Z = (function() {
  return false
});
var $d_Lorg_yaml_model_DoubleQuoteMark$ = new $TypeData().initClass({
  Lorg_yaml_model_DoubleQuoteMark$: 0
}, false, "org.yaml.model.DoubleQuoteMark$", {
  Lorg_yaml_model_DoubleQuoteMark$: 1,
  O: 1,
  Lorg_yaml_model_QuotedMark: 1,
  Lorg_yaml_model_ScalarMark: 1
});
$c_Lorg_yaml_model_DoubleQuoteMark$.prototype.$classData = $d_Lorg_yaml_model_DoubleQuoteMark$;
var $n_Lorg_yaml_model_DoubleQuoteMark$ = (void 0);
function $m_Lorg_yaml_model_DoubleQuoteMark$() {
  if ((!$n_Lorg_yaml_model_DoubleQuoteMark$)) {
    $n_Lorg_yaml_model_DoubleQuoteMark$ = new $c_Lorg_yaml_model_DoubleQuoteMark$().init___()
  };
  return $n_Lorg_yaml_model_DoubleQuoteMark$
}
/** @constructor */
function $c_Lorg_yaml_model_SingleQuoteMark$() {
  $c_O.call(this);
  this.encodeChar$1 = 0
}
$c_Lorg_yaml_model_SingleQuoteMark$.prototype = new $h_O();
$c_Lorg_yaml_model_SingleQuoteMark$.prototype.constructor = $c_Lorg_yaml_model_SingleQuoteMark$;
/** @constructor */
function $h_Lorg_yaml_model_SingleQuoteMark$() {
  /*<skip>*/
}
$h_Lorg_yaml_model_SingleQuoteMark$.prototype = $c_Lorg_yaml_model_SingleQuoteMark$.prototype;
$c_Lorg_yaml_model_SingleQuoteMark$.prototype.init___ = (function() {
  this.encodeChar$1 = 39;
  return this
});
$c_Lorg_yaml_model_SingleQuoteMark$.prototype.encodeChar__C = (function() {
  return this.encodeChar$1
});
$c_Lorg_yaml_model_SingleQuoteMark$.prototype.markText__T__T = (function(text) {
  return $f_Lorg_yaml_model_QuotedMark__markText__T__T(this, text)
});
$c_Lorg_yaml_model_SingleQuoteMark$.prototype.plain__Z = (function() {
  return false
});
var $d_Lorg_yaml_model_SingleQuoteMark$ = new $TypeData().initClass({
  Lorg_yaml_model_SingleQuoteMark$: 0
}, false, "org.yaml.model.SingleQuoteMark$", {
  Lorg_yaml_model_SingleQuoteMark$: 1,
  O: 1,
  Lorg_yaml_model_QuotedMark: 1,
  Lorg_yaml_model_ScalarMark: 1
});
$c_Lorg_yaml_model_SingleQuoteMark$.prototype.$classData = $d_Lorg_yaml_model_SingleQuoteMark$;
var $n_Lorg_yaml_model_SingleQuoteMark$ = (void 0);
function $m_Lorg_yaml_model_SingleQuoteMark$() {
  if ((!$n_Lorg_yaml_model_SingleQuoteMark$)) {
    $n_Lorg_yaml_model_SingleQuoteMark$ = new $c_Lorg_yaml_model_SingleQuoteMark$().init___()
  };
  return $n_Lorg_yaml_model_SingleQuoteMark$
}
/** @constructor */
function $c_Lorg_yaml_model_YAnchor() {
  $c_Lorg_yaml_model_YTokens.call(this);
  this.name$3 = null
}
$c_Lorg_yaml_model_YAnchor.prototype = new $h_Lorg_yaml_model_YTokens();
$c_Lorg_yaml_model_YAnchor.prototype.constructor = $c_Lorg_yaml_model_YAnchor;
/** @constructor */
function $h_Lorg_yaml_model_YAnchor() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YAnchor.prototype = $c_Lorg_yaml_model_YAnchor.prototype;
$c_Lorg_yaml_model_YAnchor.prototype.toString__T = (function() {
  return ("&" + this.name$3)
});
$c_Lorg_yaml_model_YAnchor.prototype.init___T__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq = (function(name, loc, ts) {
  this.name$3 = name;
  $c_Lorg_yaml_model_YTokens.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq.call(this, loc, ts);
  return this
});
function $as_Lorg_yaml_model_YAnchor(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YAnchor) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YAnchor"))
}
function $isArrayOf_Lorg_yaml_model_YAnchor(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YAnchor)))
}
function $asArrayOf_Lorg_yaml_model_YAnchor(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YAnchor(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YAnchor;", depth))
}
var $d_Lorg_yaml_model_YAnchor = new $TypeData().initClass({
  Lorg_yaml_model_YAnchor: 0
}, false, "org.yaml.model.YAnchor", {
  Lorg_yaml_model_YAnchor: 1,
  Lorg_yaml_model_YTokens: 1,
  Lorg_yaml_model_YPart: 1,
  O: 1
});
$c_Lorg_yaml_model_YAnchor.prototype.$classData = $d_Lorg_yaml_model_YAnchor;
/** @constructor */
function $c_Lorg_yaml_model_YDocument$EntryBuilder() {
  $c_Lorg_yaml_model_YDocument$BaseBuilder.call(this);
  this.sourceName$2 = null
}
$c_Lorg_yaml_model_YDocument$EntryBuilder.prototype = new $h_Lorg_yaml_model_YDocument$BaseBuilder();
$c_Lorg_yaml_model_YDocument$EntryBuilder.prototype.constructor = $c_Lorg_yaml_model_YDocument$EntryBuilder;
/** @constructor */
function $h_Lorg_yaml_model_YDocument$EntryBuilder() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YDocument$EntryBuilder.prototype = $c_Lorg_yaml_model_YDocument$EntryBuilder.prototype;
$c_Lorg_yaml_model_YDocument$EntryBuilder.prototype.updateDynamic__T__Lorg_yaml_model_YNode__V = (function(name, value) {
  this.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V($m_Lorg_yaml_model_YNode$().apply__T__T__Lorg_yaml_model_YNode(name, this.sourceName$2), value)
});
$c_Lorg_yaml_model_YDocument$EntryBuilder.prototype.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V = (function(k, v) {
  this.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry(k, v))
});
$c_Lorg_yaml_model_YDocument$EntryBuilder.prototype.init___T = (function(sourceName) {
  this.sourceName$2 = sourceName;
  $c_Lorg_yaml_model_YDocument$BaseBuilder.prototype.init___.call(this);
  return this
});
$c_Lorg_yaml_model_YDocument$EntryBuilder.prototype.sourceName__T = (function() {
  return this.sourceName$2
});
function $as_Lorg_yaml_model_YDocument$EntryBuilder(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YDocument$EntryBuilder) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YDocument$EntryBuilder"))
}
function $isArrayOf_Lorg_yaml_model_YDocument$EntryBuilder(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YDocument$EntryBuilder)))
}
function $asArrayOf_Lorg_yaml_model_YDocument$EntryBuilder(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YDocument$EntryBuilder(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YDocument$EntryBuilder;", depth))
}
var $d_Lorg_yaml_model_YDocument$EntryBuilder = new $TypeData().initClass({
  Lorg_yaml_model_YDocument$EntryBuilder: 0
}, false, "org.yaml.model.YDocument$EntryBuilder", {
  Lorg_yaml_model_YDocument$EntryBuilder: 1,
  Lorg_yaml_model_YDocument$BaseBuilder: 1,
  O: 1,
  s_Dynamic: 1
});
$c_Lorg_yaml_model_YDocument$EntryBuilder.prototype.$classData = $d_Lorg_yaml_model_YDocument$EntryBuilder;
/** @constructor */
function $c_Lorg_yaml_model_YFail$() {
  $c_O.call(this)
}
$c_Lorg_yaml_model_YFail$.prototype = new $h_O();
$c_Lorg_yaml_model_YFail$.prototype.constructor = $c_Lorg_yaml_model_YFail$;
/** @constructor */
function $h_Lorg_yaml_model_YFail$() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YFail$.prototype = $c_Lorg_yaml_model_YFail$.prototype;
$c_Lorg_yaml_model_YFail$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_model_YFail$.prototype.apply__Lorg_yaml_model_YNodeLike__F0__Lorg_yaml_model_YFail = (function(node, err) {
  return new $c_Lorg_yaml_model_YFail().init___Lorg_yaml_model_YError(new $c_Lorg_yaml_model_YError().init___Lorg_yaml_model_YNodeLike__F0(node, err))
});
var $d_Lorg_yaml_model_YFail$ = new $TypeData().initClass({
  Lorg_yaml_model_YFail$: 0
}, false, "org.yaml.model.YFail$", {
  Lorg_yaml_model_YFail$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_model_YFail$.prototype.$classData = $d_Lorg_yaml_model_YFail$;
var $n_Lorg_yaml_model_YFail$ = (void 0);
function $m_Lorg_yaml_model_YFail$() {
  if ((!$n_Lorg_yaml_model_YFail$)) {
    $n_Lorg_yaml_model_YFail$ = new $c_Lorg_yaml_model_YFail$().init___()
  };
  return $n_Lorg_yaml_model_YFail$
}
/** @constructor */
function $c_Lorg_yaml_model_YIgnorable() {
  $c_Lorg_yaml_model_YTokens.call(this)
}
$c_Lorg_yaml_model_YIgnorable.prototype = new $h_Lorg_yaml_model_YTokens();
$c_Lorg_yaml_model_YIgnorable.prototype.constructor = $c_Lorg_yaml_model_YIgnorable;
/** @constructor */
function $h_Lorg_yaml_model_YIgnorable() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YIgnorable.prototype = $c_Lorg_yaml_model_YIgnorable.prototype;
/** @constructor */
function $c_Lorg_yaml_model_YTag() {
  $c_Lorg_yaml_model_YTokens.call(this);
  this.text$3 = null;
  this.tagType$3 = null;
  this.loc$3 = null
}
$c_Lorg_yaml_model_YTag.prototype = new $h_Lorg_yaml_model_YTokens();
$c_Lorg_yaml_model_YTag.prototype.constructor = $c_Lorg_yaml_model_YTag;
/** @constructor */
function $h_Lorg_yaml_model_YTag() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YTag.prototype = $c_Lorg_yaml_model_YTag.prototype;
$c_Lorg_yaml_model_YTag.prototype.isEmpty__Z = (function() {
  var x = this.tagType$3;
  var x$2 = $m_Lorg_yaml_model_YType$().Empty$1;
  return (x === x$2)
});
$c_Lorg_yaml_model_YTag.prototype.synthesized__Z = (function() {
  if (this.tagType$3.synthesized$1) {
    var this$1 = this.tagType$3;
    var x = this$1.org$yaml$model$YType$$tag$und$1;
    return ((x !== null) && (x === this))
  } else {
    return false
  }
});
$c_Lorg_yaml_model_YTag.prototype.withTag__Lorg_yaml_model_YType__Lorg_yaml_model_YTag = (function(tagType) {
  return new $c_Lorg_yaml_model_YTag().init___T__Lorg_yaml_model_YType__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(this.text$3, tagType, this.loc$3, this.tokens$2)
});
$c_Lorg_yaml_model_YTag.prototype.toString__T = (function() {
  return this.text$3
});
$c_Lorg_yaml_model_YTag.prototype.isUnknown__Z = (function() {
  var x = this.tagType$3;
  var x$2 = $m_Lorg_yaml_model_YType$().Unknown$1;
  return (x === x$2)
});
$c_Lorg_yaml_model_YTag.prototype.init___T__Lorg_yaml_model_YType__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq = (function(text, tagType, loc, tks) {
  this.text$3 = text;
  this.tagType$3 = tagType;
  this.loc$3 = loc;
  $c_Lorg_yaml_model_YTokens.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq.call(this, loc, tks);
  return this
});
function $as_Lorg_yaml_model_YTag(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YTag) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YTag"))
}
function $isArrayOf_Lorg_yaml_model_YTag(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YTag)))
}
function $asArrayOf_Lorg_yaml_model_YTag(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YTag(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YTag;", depth))
}
var $d_Lorg_yaml_model_YTag = new $TypeData().initClass({
  Lorg_yaml_model_YTag: 0
}, false, "org.yaml.model.YTag", {
  Lorg_yaml_model_YTag: 1,
  Lorg_yaml_model_YTokens: 1,
  Lorg_yaml_model_YPart: 1,
  O: 1
});
$c_Lorg_yaml_model_YTag.prototype.$classData = $d_Lorg_yaml_model_YTag;
/** @constructor */
function $c_Lorg_yaml_model_YValue() {
  $c_Lorg_yaml_model_YPart.call(this)
}
$c_Lorg_yaml_model_YValue.prototype = new $h_Lorg_yaml_model_YPart();
$c_Lorg_yaml_model_YValue.prototype.constructor = $c_Lorg_yaml_model_YValue;
/** @constructor */
function $h_Lorg_yaml_model_YValue() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YValue.prototype = $c_Lorg_yaml_model_YValue.prototype;
$c_Lorg_yaml_model_YValue.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq = (function(location, parts) {
  $c_Lorg_yaml_model_YPart.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq.call(this, location, parts);
  return this
});
function $as_Lorg_yaml_model_YValue(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YValue) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YValue"))
}
function $isArrayOf_Lorg_yaml_model_YValue(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YValue)))
}
function $asArrayOf_Lorg_yaml_model_YValue(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YValue(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YValue;", depth))
}
var $d_Lorg_yaml_model_YValue = new $TypeData().initClass({
  Lorg_yaml_model_YValue: 0
}, false, "org.yaml.model.YValue", {
  Lorg_yaml_model_YValue: 1,
  Lorg_yaml_model_YPart: 1,
  O: 1,
  Lorg_yaml_model_YValueLike: 1
});
$c_Lorg_yaml_model_YValue.prototype.$classData = $d_Lorg_yaml_model_YValue;
/** @constructor */
function $c_Lorg_yaml_parser_ParserResult$() {
  $c_O.call(this);
  this.Null$1 = null
}
$c_Lorg_yaml_parser_ParserResult$.prototype = new $h_O();
$c_Lorg_yaml_parser_ParserResult$.prototype.constructor = $c_Lorg_yaml_parser_ParserResult$;
/** @constructor */
function $h_Lorg_yaml_parser_ParserResult$() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_ParserResult$.prototype = $c_Lorg_yaml_parser_ParserResult$.prototype;
$c_Lorg_yaml_parser_ParserResult$.prototype.init___ = (function() {
  $n_Lorg_yaml_parser_ParserResult$ = this;
  var this$1 = $m_Lorg_yaml_model_YType$().Null$1;
  this.Null$1 = new $c_Lorg_yaml_parser_ParserResult().init___Lorg_yaml_model_YTag__O(this$1.org$yaml$model$YType$$tag$und$1, null);
  return this
});
var $d_Lorg_yaml_parser_ParserResult$ = new $TypeData().initClass({
  Lorg_yaml_parser_ParserResult$: 0
}, false, "org.yaml.parser.ParserResult$", {
  Lorg_yaml_parser_ParserResult$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_parser_ParserResult$.prototype.$classData = $d_Lorg_yaml_parser_ParserResult$;
var $n_Lorg_yaml_parser_ParserResult$ = (void 0);
function $m_Lorg_yaml_parser_ParserResult$() {
  if ((!$n_Lorg_yaml_parser_ParserResult$)) {
    $n_Lorg_yaml_parser_ParserResult$ = new $c_Lorg_yaml_parser_ParserResult$().init___()
  };
  return $n_Lorg_yaml_parser_ParserResult$
}
function $isArrayOf_jl_Boolean(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_Boolean)))
}
function $asArrayOf_jl_Boolean(obj, depth) {
  return (($isArrayOf_jl_Boolean(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.Boolean;", depth))
}
var $d_jl_Boolean = new $TypeData().initClass({
  jl_Boolean: 0
}, false, "java.lang.Boolean", {
  jl_Boolean: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  jl_Comparable: 1
}, (void 0), (void 0), (function(x) {
  return ((typeof x) === "boolean")
}));
/** @constructor */
function $c_jl_Character() {
  $c_O.call(this);
  this.value$1 = 0
}
$c_jl_Character.prototype = new $h_O();
$c_jl_Character.prototype.constructor = $c_jl_Character;
/** @constructor */
function $h_jl_Character() {
  /*<skip>*/
}
$h_jl_Character.prototype = $c_jl_Character.prototype;
$c_jl_Character.prototype.equals__O__Z = (function(that) {
  if ((that instanceof $c_jl_Character)) {
    var jsx$1 = this.value$1;
    var this$1 = $as_jl_Character(that);
    return (jsx$1 === this$1.value$1)
  } else {
    return false
  }
});
$c_jl_Character.prototype.compareTo__O__I = (function(o) {
  var that = $as_jl_Character(o);
  var x = this.value$1;
  var y = that.value$1;
  return ((x - y) | 0)
});
$c_jl_Character.prototype.toString__T = (function() {
  var c = this.value$1;
  return $as_T($g.String.fromCharCode(c))
});
$c_jl_Character.prototype.init___C = (function(value) {
  this.value$1 = value;
  return this
});
$c_jl_Character.prototype.hashCode__I = (function() {
  return this.value$1
});
function $as_jl_Character(obj) {
  return (((obj instanceof $c_jl_Character) || (obj === null)) ? obj : $throwClassCastException(obj, "java.lang.Character"))
}
function $isArrayOf_jl_Character(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_Character)))
}
function $asArrayOf_jl_Character(obj, depth) {
  return (($isArrayOf_jl_Character(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.Character;", depth))
}
var $d_jl_Character = new $TypeData().initClass({
  jl_Character: 0
}, false, "java.lang.Character", {
  jl_Character: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  jl_Comparable: 1
});
$c_jl_Character.prototype.$classData = $d_jl_Character;
/** @constructor */
function $c_jl_Character$() {
  $c_O.call(this);
  this.java$lang$Character$$charTypesFirst256$1 = null;
  this.charTypeIndices$1 = null;
  this.charTypes$1 = null;
  this.isMirroredIndices$1 = null;
  this.nonASCIIZeroDigitCodePoints$1 = null;
  this.bitmap$0$1 = 0
}
$c_jl_Character$.prototype = new $h_O();
$c_jl_Character$.prototype.constructor = $c_jl_Character$;
/** @constructor */
function $h_jl_Character$() {
  /*<skip>*/
}
$h_jl_Character$.prototype = $c_jl_Character$.prototype;
$c_jl_Character$.prototype.charTypes$lzycompute__p1__AI = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.charTypes$1 = $makeNativeArrayWrapper($d_I.getArrayOf(), [1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 5, 1, 2, 5, 1, 3, 2, 1, 3, 2, 1, 3, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 3, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 5, 2, 4, 27, 4, 27, 4, 27, 4, 27, 4, 27, 6, 1, 2, 1, 2, 4, 27, 1, 2, 0, 4, 2, 24, 0, 27, 1, 24, 1, 0, 1, 0, 1, 2, 1, 0, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 25, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 28, 6, 7, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 0, 1, 0, 4, 24, 0, 2, 0, 24, 20, 0, 26, 0, 6, 20, 6, 24, 6, 24, 6, 24, 6, 0, 5, 0, 5, 24, 0, 16, 0, 25, 24, 26, 24, 28, 6, 24, 0, 24, 5, 4, 5, 6, 9, 24, 5, 6, 5, 24, 5, 6, 16, 28, 6, 4, 6, 28, 6, 5, 9, 5, 28, 5, 24, 0, 16, 5, 6, 5, 6, 0, 5, 6, 5, 0, 9, 5, 6, 4, 28, 24, 4, 0, 5, 6, 4, 6, 4, 6, 4, 6, 0, 24, 0, 5, 6, 0, 24, 0, 5, 0, 5, 0, 6, 0, 6, 8, 5, 6, 8, 6, 5, 8, 6, 8, 6, 8, 5, 6, 5, 6, 24, 9, 24, 4, 5, 0, 5, 0, 6, 8, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 6, 5, 8, 6, 0, 8, 0, 8, 6, 5, 0, 8, 0, 5, 0, 5, 6, 0, 9, 5, 26, 11, 28, 26, 0, 6, 8, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 6, 0, 8, 6, 0, 6, 0, 6, 0, 6, 0, 5, 0, 5, 0, 9, 6, 5, 6, 0, 6, 8, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 6, 5, 8, 6, 0, 6, 8, 0, 8, 6, 0, 5, 0, 5, 6, 0, 9, 24, 26, 0, 6, 8, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 6, 5, 8, 6, 8, 6, 0, 8, 0, 8, 6, 0, 6, 8, 0, 5, 0, 5, 6, 0, 9, 28, 5, 11, 0, 6, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 8, 6, 8, 0, 8, 0, 8, 6, 0, 5, 0, 8, 0, 9, 11, 28, 26, 28, 0, 8, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 6, 8, 0, 6, 0, 6, 0, 6, 0, 5, 0, 5, 6, 0, 9, 0, 11, 28, 0, 8, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 6, 5, 8, 6, 8, 0, 6, 8, 0, 8, 6, 0, 8, 0, 5, 0, 5, 6, 0, 9, 0, 5, 0, 8, 0, 5, 0, 5, 0, 5, 0, 5, 8, 6, 0, 8, 0, 8, 6, 5, 0, 8, 0, 5, 6, 0, 9, 11, 0, 28, 5, 0, 8, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 6, 0, 8, 6, 0, 6, 0, 8, 0, 8, 24, 0, 5, 6, 5, 6, 0, 26, 5, 4, 6, 24, 9, 24, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 6, 5, 6, 0, 6, 5, 0, 5, 0, 4, 0, 6, 0, 9, 0, 5, 0, 5, 28, 24, 28, 24, 28, 6, 28, 9, 11, 28, 6, 28, 6, 28, 6, 21, 22, 21, 22, 8, 5, 0, 5, 0, 6, 8, 6, 24, 6, 5, 6, 0, 6, 0, 28, 6, 28, 0, 28, 24, 28, 24, 0, 5, 8, 6, 8, 6, 8, 6, 8, 6, 5, 9, 24, 5, 8, 6, 5, 6, 5, 8, 5, 8, 5, 6, 5, 6, 8, 6, 8, 6, 5, 8, 9, 8, 6, 28, 1, 0, 1, 0, 1, 0, 5, 24, 4, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 6, 24, 11, 0, 5, 28, 0, 5, 0, 20, 5, 24, 5, 12, 5, 21, 22, 0, 5, 24, 10, 0, 5, 0, 5, 6, 0, 5, 6, 24, 0, 5, 6, 0, 5, 0, 5, 0, 6, 0, 5, 6, 8, 6, 8, 6, 8, 6, 24, 4, 24, 26, 5, 6, 0, 9, 0, 11, 0, 24, 20, 24, 6, 12, 0, 9, 0, 5, 4, 5, 0, 5, 6, 5, 0, 5, 0, 5, 0, 6, 8, 6, 8, 0, 8, 6, 8, 6, 0, 28, 0, 24, 9, 5, 0, 5, 0, 5, 0, 8, 5, 8, 0, 9, 11, 0, 28, 5, 6, 8, 0, 24, 5, 8, 6, 8, 6, 0, 6, 8, 6, 8, 6, 8, 6, 0, 6, 9, 0, 9, 0, 24, 4, 24, 0, 6, 8, 5, 6, 8, 6, 8, 6, 8, 6, 8, 5, 0, 9, 24, 28, 6, 28, 0, 6, 8, 5, 8, 6, 8, 6, 8, 6, 8, 5, 9, 5, 6, 8, 6, 8, 6, 8, 6, 8, 0, 24, 5, 8, 6, 8, 6, 0, 24, 9, 0, 5, 9, 5, 4, 24, 0, 24, 0, 6, 24, 6, 8, 6, 5, 6, 5, 8, 6, 5, 0, 2, 4, 2, 4, 2, 4, 6, 0, 6, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 0, 1, 0, 2, 1, 2, 1, 2, 0, 1, 0, 2, 0, 1, 0, 1, 0, 1, 0, 1, 2, 1, 2, 0, 2, 3, 2, 3, 2, 3, 2, 0, 2, 1, 3, 27, 2, 27, 2, 0, 2, 1, 3, 27, 2, 0, 2, 1, 0, 27, 2, 1, 27, 0, 2, 0, 2, 1, 3, 27, 0, 12, 16, 20, 24, 29, 30, 21, 29, 30, 21, 29, 24, 13, 14, 16, 12, 24, 29, 30, 24, 23, 24, 25, 21, 22, 24, 25, 24, 23, 24, 12, 16, 0, 16, 11, 4, 0, 11, 25, 21, 22, 4, 11, 25, 21, 22, 0, 4, 0, 26, 0, 6, 7, 6, 7, 6, 0, 28, 1, 28, 1, 28, 2, 1, 2, 1, 2, 28, 1, 28, 25, 1, 28, 1, 28, 1, 28, 1, 28, 1, 28, 2, 1, 2, 5, 2, 28, 2, 1, 25, 1, 2, 28, 25, 28, 2, 28, 11, 10, 1, 2, 10, 11, 0, 25, 28, 25, 28, 25, 28, 25, 28, 25, 28, 25, 28, 25, 28, 25, 28, 25, 28, 25, 28, 25, 28, 25, 28, 21, 22, 28, 25, 28, 25, 28, 25, 28, 0, 28, 0, 28, 0, 11, 28, 11, 28, 25, 28, 25, 28, 25, 28, 25, 28, 0, 28, 21, 22, 21, 22, 21, 22, 21, 22, 21, 22, 21, 22, 21, 22, 11, 28, 25, 21, 22, 25, 21, 22, 21, 22, 21, 22, 21, 22, 21, 22, 25, 28, 25, 21, 22, 21, 22, 21, 22, 21, 22, 21, 22, 21, 22, 21, 22, 21, 22, 21, 22, 21, 22, 21, 22, 25, 21, 22, 21, 22, 25, 21, 22, 25, 28, 25, 28, 25, 0, 28, 0, 1, 0, 2, 0, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 4, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 28, 1, 2, 1, 2, 6, 1, 2, 0, 24, 11, 24, 2, 0, 2, 0, 2, 0, 5, 0, 4, 24, 0, 6, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 6, 24, 29, 30, 29, 30, 24, 29, 30, 24, 29, 30, 24, 20, 24, 20, 24, 29, 30, 24, 29, 30, 21, 22, 21, 22, 21, 22, 21, 22, 24, 4, 24, 20, 0, 28, 0, 28, 0, 28, 0, 28, 0, 12, 24, 28, 4, 5, 10, 21, 22, 21, 22, 21, 22, 21, 22, 21, 22, 28, 21, 22, 21, 22, 21, 22, 21, 22, 20, 21, 22, 28, 10, 6, 8, 20, 4, 28, 10, 4, 5, 24, 28, 0, 5, 0, 6, 27, 4, 5, 20, 5, 24, 4, 5, 0, 5, 0, 5, 0, 28, 11, 28, 5, 0, 28, 0, 5, 28, 0, 11, 28, 11, 28, 11, 28, 11, 28, 11, 28, 5, 0, 28, 5, 0, 5, 4, 5, 0, 28, 0, 5, 4, 24, 5, 4, 24, 5, 9, 5, 0, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 5, 6, 7, 24, 6, 24, 4, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 0, 6, 5, 10, 6, 24, 0, 27, 4, 27, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 4, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 4, 27, 1, 2, 1, 2, 0, 1, 2, 1, 2, 0, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 0, 4, 2, 5, 6, 5, 6, 5, 6, 5, 8, 6, 8, 28, 0, 11, 28, 26, 28, 0, 5, 24, 0, 8, 5, 8, 6, 0, 24, 9, 0, 6, 5, 24, 5, 0, 9, 5, 6, 24, 5, 6, 8, 0, 24, 5, 0, 6, 8, 5, 6, 8, 6, 8, 6, 8, 24, 0, 4, 9, 0, 24, 0, 5, 6, 8, 6, 8, 6, 0, 5, 6, 5, 6, 8, 0, 9, 0, 24, 5, 4, 5, 28, 5, 8, 0, 5, 6, 5, 6, 5, 6, 5, 6, 5, 6, 5, 0, 5, 4, 24, 5, 8, 6, 8, 24, 5, 4, 8, 6, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 8, 6, 8, 6, 8, 24, 8, 6, 0, 9, 0, 5, 0, 5, 0, 5, 0, 19, 18, 5, 0, 5, 0, 2, 0, 2, 0, 5, 6, 5, 25, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 27, 0, 5, 21, 22, 0, 5, 0, 5, 0, 5, 26, 28, 0, 6, 24, 21, 22, 24, 0, 6, 0, 24, 20, 23, 21, 22, 21, 22, 21, 22, 21, 22, 21, 22, 21, 22, 21, 22, 21, 22, 24, 21, 22, 24, 23, 24, 0, 24, 20, 21, 22, 21, 22, 21, 22, 24, 25, 20, 25, 0, 24, 26, 24, 0, 5, 0, 5, 0, 16, 0, 24, 26, 24, 21, 22, 24, 25, 24, 20, 24, 9, 24, 25, 24, 1, 21, 24, 22, 27, 23, 27, 2, 21, 25, 22, 25, 21, 22, 24, 21, 22, 24, 5, 4, 5, 4, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 26, 25, 27, 28, 26, 0, 28, 25, 28, 0, 16, 28, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 24, 0, 11, 0, 28, 10, 11, 28, 11, 0, 28, 0, 28, 6, 0, 5, 0, 5, 0, 5, 0, 11, 0, 5, 10, 5, 10, 0, 5, 0, 24, 5, 0, 5, 24, 10, 0, 1, 2, 5, 0, 9, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 24, 11, 0, 5, 11, 0, 24, 5, 0, 24, 0, 5, 0, 5, 0, 5, 6, 0, 6, 0, 6, 5, 0, 5, 0, 5, 0, 6, 0, 6, 11, 0, 24, 0, 5, 11, 24, 0, 5, 0, 24, 5, 0, 11, 5, 0, 11, 0, 5, 0, 11, 0, 8, 6, 8, 5, 6, 24, 0, 11, 9, 0, 6, 8, 5, 8, 6, 8, 6, 24, 16, 24, 0, 5, 0, 9, 0, 6, 5, 6, 8, 6, 0, 9, 24, 0, 6, 8, 5, 8, 6, 8, 5, 24, 0, 9, 0, 5, 6, 8, 6, 8, 6, 8, 6, 0, 9, 0, 5, 0, 10, 0, 24, 0, 5, 0, 5, 0, 5, 0, 5, 8, 0, 6, 4, 0, 5, 0, 28, 0, 28, 0, 28, 8, 6, 28, 8, 16, 6, 28, 6, 28, 6, 28, 0, 28, 6, 28, 0, 28, 0, 11, 0, 1, 2, 1, 2, 0, 2, 1, 2, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 2, 0, 2, 0, 2, 0, 2, 1, 2, 1, 0, 1, 0, 1, 0, 1, 0, 2, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2, 0, 1, 25, 2, 25, 2, 1, 25, 2, 25, 2, 1, 25, 2, 25, 2, 1, 25, 2, 25, 2, 1, 25, 2, 25, 2, 1, 2, 0, 9, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 25, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 11, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 5, 0, 5, 0, 5, 0, 5, 0, 16, 0, 16, 0, 6, 0, 18, 0, 18, 0]);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.charTypes$1
});
$c_jl_Character$.prototype.toLowerCase__C__C = (function(c) {
  var thiz = $as_T($g.String.fromCharCode(c));
  var thiz$1 = $as_T(thiz.toLowerCase());
  return (65535 & $uI(thiz$1.charCodeAt(0)))
});
$c_jl_Character$.prototype.init___ = (function() {
  return this
});
$c_jl_Character$.prototype.toChars__I__AC = (function(codePoint) {
  if ((!((codePoint >= 0) && (codePoint <= 1114111)))) {
    throw new $c_jl_IllegalArgumentException().init___()
  };
  return (((codePoint >= 65536) && (codePoint <= 1114111)) ? $makeNativeArrayWrapper($d_C.getArrayOf(), [(65535 & (55296 | (((-64) + (codePoint >> 10)) | 0))), (65535 & (56320 | (1023 & codePoint)))]) : $makeNativeArrayWrapper($d_C.getArrayOf(), [(65535 & codePoint)]))
});
$c_jl_Character$.prototype.getTypeGE256__p1__I__I = (function(codePoint) {
  var idx = ((1 + $m_ju_Arrays$().binarySearch__AI__I__I(this.charTypeIndices__p1__AI(), codePoint)) | 0);
  return this.charTypes__p1__AI().get(((idx < 0) ? ((-idx) | 0) : idx))
});
$c_jl_Character$.prototype.isLetter__I__Z = (function(cp) {
  var tpe = this.getType__I__I(cp);
  return (((((tpe === 1) || (tpe === 2)) || (tpe === 3)) || (tpe === 4)) || (tpe === 5))
});
$c_jl_Character$.prototype.getType__I__I = (function(codePoint) {
  return ((codePoint < 0) ? 0 : ((codePoint < 256) ? this.java$lang$Character$$charTypesFirst256__AI().get(codePoint) : this.getTypeGE256__p1__I__I(codePoint)))
});
$c_jl_Character$.prototype.charTypeIndices__p1__AI = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.charTypeIndices$lzycompute__p1__AI() : this.charTypeIndices$1)
});
$c_jl_Character$.prototype.charTypeIndices$lzycompute__p1__AI = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    var deltas = $makeNativeArrayWrapper($d_I.getArrayOf(), [257, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 3, 2, 1, 1, 1, 2, 1, 3, 2, 4, 1, 2, 1, 3, 3, 2, 1, 2, 1, 1, 1, 1, 1, 2, 1, 1, 2, 1, 1, 2, 1, 3, 1, 1, 1, 2, 2, 1, 1, 3, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 7, 2, 1, 2, 2, 1, 1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 69, 1, 27, 18, 4, 12, 14, 5, 7, 1, 1, 1, 17, 112, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 3, 1, 5, 2, 1, 1, 3, 1, 1, 1, 2, 1, 17, 1, 9, 35, 1, 2, 3, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 5, 1, 1, 1, 1, 1, 2, 2, 51, 48, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 5, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 9, 38, 2, 1, 6, 1, 39, 1, 1, 1, 4, 1, 1, 45, 1, 1, 1, 2, 1, 2, 1, 1, 8, 27, 5, 3, 2, 11, 5, 1, 3, 2, 1, 2, 2, 11, 1, 2, 2, 32, 1, 10, 21, 10, 4, 2, 1, 99, 1, 1, 7, 1, 1, 6, 2, 2, 1, 4, 2, 10, 3, 2, 1, 14, 1, 1, 1, 1, 30, 27, 2, 89, 11, 1, 14, 10, 33, 9, 2, 1, 3, 1, 5, 22, 4, 1, 9, 1, 3, 1, 5, 2, 15, 1, 25, 3, 2, 1, 65, 1, 1, 11, 55, 27, 1, 3, 1, 54, 1, 1, 1, 1, 3, 8, 4, 1, 2, 1, 7, 10, 2, 2, 10, 1, 1, 6, 1, 7, 1, 1, 2, 1, 8, 2, 2, 2, 22, 1, 7, 1, 1, 3, 4, 2, 1, 1, 3, 4, 2, 2, 2, 2, 1, 1, 8, 1, 4, 2, 1, 3, 2, 2, 10, 2, 2, 6, 1, 1, 5, 2, 1, 1, 6, 4, 2, 2, 22, 1, 7, 1, 2, 1, 2, 1, 2, 2, 1, 1, 3, 2, 4, 2, 2, 3, 3, 1, 7, 4, 1, 1, 7, 10, 2, 3, 1, 11, 2, 1, 1, 9, 1, 3, 1, 22, 1, 7, 1, 2, 1, 5, 2, 1, 1, 3, 5, 1, 2, 1, 1, 2, 1, 2, 1, 15, 2, 2, 2, 10, 1, 1, 15, 1, 2, 1, 8, 2, 2, 2, 22, 1, 7, 1, 2, 1, 5, 2, 1, 1, 1, 1, 1, 4, 2, 2, 2, 2, 1, 8, 1, 1, 4, 2, 1, 3, 2, 2, 10, 1, 1, 6, 10, 1, 1, 1, 6, 3, 3, 1, 4, 3, 2, 1, 1, 1, 2, 3, 2, 3, 3, 3, 12, 4, 2, 1, 2, 3, 3, 1, 3, 1, 2, 1, 6, 1, 14, 10, 3, 6, 1, 1, 6, 3, 1, 8, 1, 3, 1, 23, 1, 10, 1, 5, 3, 1, 3, 4, 1, 3, 1, 4, 7, 2, 1, 2, 6, 2, 2, 2, 10, 8, 7, 1, 2, 2, 1, 8, 1, 3, 1, 23, 1, 10, 1, 5, 2, 1, 1, 1, 1, 5, 1, 1, 2, 1, 2, 2, 7, 2, 7, 1, 1, 2, 2, 2, 10, 1, 2, 15, 2, 1, 8, 1, 3, 1, 41, 2, 1, 3, 4, 1, 3, 1, 3, 1, 1, 8, 1, 8, 2, 2, 2, 10, 6, 3, 1, 6, 2, 2, 1, 18, 3, 24, 1, 9, 1, 1, 2, 7, 3, 1, 4, 3, 3, 1, 1, 1, 8, 18, 2, 1, 12, 48, 1, 2, 7, 4, 1, 6, 1, 8, 1, 10, 2, 37, 2, 1, 1, 2, 2, 1, 1, 2, 1, 6, 4, 1, 7, 1, 3, 1, 1, 1, 1, 2, 2, 1, 4, 1, 2, 6, 1, 2, 1, 2, 5, 1, 1, 1, 6, 2, 10, 2, 4, 32, 1, 3, 15, 1, 1, 3, 2, 6, 10, 10, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 8, 1, 36, 4, 14, 1, 5, 1, 2, 5, 11, 1, 36, 1, 8, 1, 6, 1, 2, 5, 4, 2, 37, 43, 2, 4, 1, 6, 1, 2, 2, 2, 1, 10, 6, 6, 2, 2, 4, 3, 1, 3, 2, 7, 3, 4, 13, 1, 2, 2, 6, 1, 1, 1, 10, 3, 1, 2, 38, 1, 1, 5, 1, 2, 43, 1, 1, 332, 1, 4, 2, 7, 1, 1, 1, 4, 2, 41, 1, 4, 2, 33, 1, 4, 2, 7, 1, 1, 1, 4, 2, 15, 1, 57, 1, 4, 2, 67, 2, 3, 9, 20, 3, 16, 10, 6, 85, 11, 1, 620, 2, 17, 1, 26, 1, 1, 3, 75, 3, 3, 15, 13, 1, 4, 3, 11, 18, 3, 2, 9, 18, 2, 12, 13, 1, 3, 1, 2, 12, 52, 2, 1, 7, 8, 1, 2, 11, 3, 1, 3, 1, 1, 1, 2, 10, 6, 10, 6, 6, 1, 4, 3, 1, 1, 10, 6, 35, 1, 52, 8, 41, 1, 1, 5, 70, 10, 29, 3, 3, 4, 2, 3, 4, 2, 1, 6, 3, 4, 1, 3, 2, 10, 30, 2, 5, 11, 44, 4, 17, 7, 2, 6, 10, 1, 3, 34, 23, 2, 3, 2, 2, 53, 1, 1, 1, 7, 1, 1, 1, 1, 2, 8, 6, 10, 2, 1, 10, 6, 10, 6, 7, 1, 6, 82, 4, 1, 47, 1, 1, 5, 1, 1, 5, 1, 2, 7, 4, 10, 7, 10, 9, 9, 3, 2, 1, 30, 1, 4, 2, 2, 1, 1, 2, 2, 10, 44, 1, 1, 2, 3, 1, 1, 3, 2, 8, 4, 36, 8, 8, 2, 2, 3, 5, 10, 3, 3, 10, 30, 6, 2, 64, 8, 8, 3, 1, 13, 1, 7, 4, 1, 4, 2, 1, 2, 9, 44, 63, 13, 1, 34, 37, 39, 21, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 9, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 9, 8, 6, 2, 6, 2, 8, 8, 8, 8, 6, 2, 6, 2, 8, 1, 1, 1, 1, 1, 1, 1, 1, 8, 8, 14, 2, 8, 8, 8, 8, 8, 8, 5, 1, 2, 4, 1, 1, 1, 3, 3, 1, 2, 4, 1, 3, 4, 2, 2, 4, 1, 3, 8, 5, 3, 2, 3, 1, 2, 4, 1, 2, 1, 11, 5, 6, 2, 1, 1, 1, 2, 1, 1, 1, 8, 1, 1, 5, 1, 9, 1, 1, 4, 2, 3, 1, 1, 1, 11, 1, 1, 1, 10, 1, 5, 5, 6, 1, 1, 2, 6, 3, 1, 1, 1, 10, 3, 1, 1, 1, 13, 3, 32, 16, 13, 4, 1, 3, 12, 15, 2, 1, 4, 1, 2, 1, 3, 2, 3, 1, 1, 1, 2, 1, 5, 6, 1, 1, 1, 1, 1, 1, 4, 1, 1, 4, 1, 4, 1, 2, 2, 2, 5, 1, 4, 1, 1, 2, 1, 1, 16, 35, 1, 1, 4, 1, 6, 5, 5, 2, 4, 1, 2, 1, 2, 1, 7, 1, 31, 2, 2, 1, 1, 1, 31, 268, 8, 4, 20, 2, 7, 1, 1, 81, 1, 30, 25, 40, 6, 18, 12, 39, 25, 11, 21, 60, 78, 22, 183, 1, 9, 1, 54, 8, 111, 1, 144, 1, 103, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 30, 44, 5, 1, 1, 31, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 16, 256, 131, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 63, 1, 1, 1, 1, 32, 1, 1, 258, 48, 21, 2, 6, 3, 10, 166, 47, 1, 47, 1, 1, 1, 3, 2, 1, 1, 1, 1, 1, 1, 4, 1, 1, 2, 1, 6, 2, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 6, 1, 1, 1, 1, 3, 1, 1, 5, 4, 1, 2, 38, 1, 1, 5, 1, 2, 56, 7, 1, 1, 14, 1, 23, 9, 7, 1, 7, 1, 7, 1, 7, 1, 7, 1, 7, 1, 7, 1, 7, 1, 32, 2, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 9, 1, 2, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 5, 1, 10, 2, 68, 26, 1, 89, 12, 214, 26, 12, 4, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 9, 4, 2, 1, 5, 2, 3, 1, 1, 1, 2, 1, 86, 2, 2, 2, 2, 1, 1, 90, 1, 3, 1, 5, 41, 3, 94, 1, 2, 4, 10, 27, 5, 36, 12, 16, 31, 1, 10, 30, 8, 1, 15, 32, 10, 39, 15, 320, 6582, 10, 64, 20941, 51, 21, 1, 1143, 3, 55, 9, 40, 6, 2, 268, 1, 3, 16, 10, 2, 20, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 10, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 7, 1, 70, 10, 2, 6, 8, 23, 9, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 8, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 12, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 77, 2, 1, 7, 1, 3, 1, 4, 1, 23, 2, 2, 1, 4, 4, 6, 2, 1, 1, 6, 52, 4, 8, 2, 50, 16, 1, 9, 2, 10, 6, 18, 6, 3, 1, 4, 10, 28, 8, 2, 23, 11, 2, 11, 1, 29, 3, 3, 1, 47, 1, 2, 4, 2, 1, 4, 13, 1, 1, 10, 4, 2, 32, 41, 6, 2, 2, 2, 2, 9, 3, 1, 8, 1, 1, 2, 10, 2, 4, 16, 1, 6, 3, 1, 1, 4, 48, 1, 1, 3, 2, 2, 5, 2, 1, 1, 1, 24, 2, 1, 2, 11, 1, 2, 2, 2, 1, 2, 1, 1, 10, 6, 2, 6, 2, 6, 9, 7, 1, 7, 145, 35, 2, 1, 2, 1, 2, 1, 1, 1, 2, 10, 6, 11172, 12, 23, 4, 49, 4, 2048, 6400, 366, 2, 106, 38, 7, 12, 5, 5, 1, 1, 10, 1, 13, 1, 5, 1, 1, 1, 2, 1, 2, 1, 108, 16, 17, 363, 1, 1, 16, 64, 2, 54, 40, 12, 1, 1, 2, 16, 7, 1, 1, 1, 6, 7, 9, 1, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 4, 3, 3, 1, 4, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 3, 1, 1, 1, 2, 4, 5, 1, 135, 2, 1, 1, 3, 1, 3, 1, 1, 1, 1, 1, 1, 2, 10, 2, 3, 2, 26, 1, 1, 1, 1, 1, 1, 26, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 10, 1, 45, 2, 31, 3, 6, 2, 6, 2, 6, 2, 3, 3, 2, 1, 1, 1, 2, 1, 1, 4, 2, 10, 3, 2, 2, 12, 1, 26, 1, 19, 1, 2, 1, 15, 2, 14, 34, 123, 5, 3, 4, 45, 3, 9, 53, 4, 17, 1, 5, 12, 52, 45, 1, 130, 29, 3, 49, 47, 31, 1, 4, 12, 17, 1, 8, 1, 53, 30, 1, 1, 36, 4, 8, 1, 5, 42, 40, 40, 78, 2, 10, 854, 6, 2, 1, 1, 44, 1, 2, 3, 1, 2, 23, 1, 1, 8, 160, 22, 6, 3, 1, 26, 5, 1, 64, 56, 6, 2, 64, 1, 3, 1, 2, 5, 4, 4, 1, 3, 1, 27, 4, 3, 4, 1, 8, 8, 9, 7, 29, 2, 1, 128, 54, 3, 7, 22, 2, 8, 19, 5, 8, 128, 73, 535, 31, 385, 1, 1, 1, 53, 15, 7, 4, 20, 10, 16, 2, 1, 45, 3, 4, 2, 2, 2, 1, 4, 14, 25, 7, 10, 6, 3, 36, 5, 1, 8, 1, 10, 4, 60, 2, 1, 48, 3, 9, 2, 4, 4, 7, 10, 1190, 43, 1, 1, 1, 2, 6, 1, 1, 8, 10, 2358, 879, 145, 99, 13, 4, 2956, 1071, 13265, 569, 1223, 69, 11, 1, 46, 16, 4, 13, 16480, 2, 8190, 246, 10, 39, 2, 60, 2, 3, 3, 6, 8, 8, 2, 7, 30, 4, 48, 34, 66, 3, 1, 186, 87, 9, 18, 142, 26, 26, 26, 7, 1, 18, 26, 26, 1, 1, 2, 2, 1, 2, 2, 2, 4, 1, 8, 4, 1, 1, 1, 7, 1, 11, 26, 26, 2, 1, 4, 2, 8, 1, 7, 1, 26, 2, 1, 4, 1, 5, 1, 1, 3, 7, 1, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 28, 2, 25, 1, 25, 1, 6, 25, 1, 25, 1, 6, 25, 1, 25, 1, 6, 25, 1, 25, 1, 6, 25, 1, 25, 1, 6, 1, 1, 2, 50, 5632, 4, 1, 27, 1, 2, 1, 1, 2, 1, 1, 10, 1, 4, 1, 1, 1, 1, 6, 1, 4, 1, 1, 1, 1, 1, 1, 3, 1, 2, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 2, 4, 1, 7, 1, 4, 1, 4, 1, 1, 1, 10, 1, 17, 5, 3, 1, 5, 1, 17, 52, 2, 270, 44, 4, 100, 12, 15, 2, 14, 2, 15, 1, 15, 32, 11, 5, 31, 1, 60, 4, 43, 75, 29, 13, 43, 5, 9, 7, 2, 174, 33, 15, 6, 1, 70, 3, 20, 12, 37, 1, 5, 21, 17, 15, 63, 1, 1, 1, 182, 1, 4, 3, 62, 2, 4, 12, 24, 147, 70, 4, 11, 48, 70, 58, 116, 2188, 42711, 41, 4149, 11, 222, 16354, 542, 722403, 1, 30, 96, 128, 240, 65040, 65534, 2, 65534]);
    this.charTypeIndices$1 = this.uncompressDeltas__p1__AI__AI(deltas);
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.charTypeIndices$1
});
$c_jl_Character$.prototype.isWhitespace__I__Z = (function(codePoint) {
  return ((codePoint < 256) ? (((((((codePoint === 9) || (codePoint === 10)) || (codePoint === 11)) || (codePoint === 12)) || (codePoint === 13)) || ((codePoint >= 28) && (codePoint <= 31))) || ((codePoint !== 160) && this.isSeparator$1__p1__I__Z(this.java$lang$Character$$charTypesFirst256__AI().get(codePoint)))) : (((codePoint !== 8199) && (codePoint !== 8239)) && this.isSeparator$1__p1__I__Z(this.getTypeGE256__p1__I__I(codePoint))))
});
$c_jl_Character$.prototype.java$lang$Character$$charTypesFirst256$lzycompute__p1__AI = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.java$lang$Character$$charTypesFirst256$1 = $makeNativeArrayWrapper($d_I.getArrayOf(), [15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 12, 24, 24, 24, 26, 24, 24, 24, 21, 22, 24, 25, 24, 20, 24, 24, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 24, 24, 25, 25, 25, 24, 24, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 21, 24, 22, 27, 23, 27, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 21, 25, 22, 25, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 12, 24, 26, 26, 26, 26, 28, 24, 27, 28, 5, 29, 25, 16, 28, 27, 28, 25, 11, 11, 27, 2, 24, 24, 27, 11, 5, 30, 11, 11, 11, 24, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 25, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 25, 2, 2, 2, 2, 2, 2, 2, 2]);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.java$lang$Character$$charTypesFirst256$1
});
$c_jl_Character$.prototype.charTypes__p1__AI = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.charTypes$lzycompute__p1__AI() : this.charTypes$1)
});
$c_jl_Character$.prototype.java$lang$Character$$charTypesFirst256__AI = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.java$lang$Character$$charTypesFirst256$lzycompute__p1__AI() : this.java$lang$Character$$charTypesFirst256$1)
});
$c_jl_Character$.prototype.digitWithValidRadix__I__I__I = (function(codePoint, radix) {
  if ((codePoint < 256)) {
    var value = (((codePoint >= 48) && (codePoint <= 57)) ? (((-48) + codePoint) | 0) : (((codePoint >= 65) && (codePoint <= 90)) ? (((-55) + codePoint) | 0) : (((codePoint >= 97) && (codePoint <= 122)) ? (((-87) + codePoint) | 0) : (-1))))
  } else if (((codePoint >= 65313) && (codePoint <= 65338))) {
    var value = (((-65303) + codePoint) | 0)
  } else if (((codePoint >= 65345) && (codePoint <= 65370))) {
    var value = (((-65335) + codePoint) | 0)
  } else {
    var p = $m_ju_Arrays$().binarySearch__AI__I__I(this.nonASCIIZeroDigitCodePoints__p1__AI(), codePoint);
    var zeroCodePointIndex = ((p < 0) ? (((-2) - p) | 0) : p);
    if ((zeroCodePointIndex < 0)) {
      var value = (-1)
    } else {
      var v = ((codePoint - this.nonASCIIZeroDigitCodePoints__p1__AI().get(zeroCodePointIndex)) | 0);
      var value = ((v > 9) ? (-1) : v)
    }
  };
  return ((value < radix) ? value : (-1))
});
$c_jl_Character$.prototype.isZeroDigit__C__Z = (function(ch) {
  return ((ch < 256) ? (ch === 48) : ($m_ju_Arrays$().binarySearch__AI__I__I(this.nonASCIIZeroDigitCodePoints__p1__AI(), ch) >= 0))
});
$c_jl_Character$.prototype.isSpaceChar__I__Z = (function(codePoint) {
  var tpe = this.getType__I__I(codePoint);
  return (((tpe === 12) || (tpe === 13)) || (tpe === 14))
});
$c_jl_Character$.prototype.isUpperCase__I__Z = (function(c) {
  return ((((c >= 8544) && (c <= 8559)) || ((c >= 9398) && (c <= 9423))) || (this.getType__I__I(c) === 1))
});
$c_jl_Character$.prototype.nonASCIIZeroDigitCodePoints__p1__AI = (function() {
  return (((((16 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.nonASCIIZeroDigitCodePoints$lzycompute__p1__AI() : this.nonASCIIZeroDigitCodePoints$1)
});
$c_jl_Character$.prototype.toUpperCase__C__C = (function(c) {
  var thiz = $as_T($g.String.fromCharCode(c));
  var thiz$1 = $as_T(thiz.toUpperCase());
  return (65535 & $uI(thiz$1.charCodeAt(0)))
});
$c_jl_Character$.prototype.uncompressDeltas__p1__AI__AI = (function(deltas) {
  var acc = deltas.get(0);
  var i = 1;
  var len = deltas.u.length;
  while ((i !== len)) {
    acc = ((acc + deltas.get(i)) | 0);
    deltas.set(i, acc);
    i = ((1 + i) | 0)
  };
  return deltas
});
$c_jl_Character$.prototype.isSeparator$1__p1__I__Z = (function(tpe) {
  return (((tpe === 12) || (tpe === 13)) || (tpe === 14))
});
$c_jl_Character$.prototype.nonASCIIZeroDigitCodePoints$lzycompute__p1__AI = (function() {
  if (((((16 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.nonASCIIZeroDigitCodePoints$1 = $makeNativeArrayWrapper($d_I.getArrayOf(), [1632, 1776, 1984, 2406, 2534, 2662, 2790, 2918, 3046, 3174, 3302, 3430, 3664, 3792, 3872, 4160, 4240, 6112, 6160, 6470, 6608, 6784, 6800, 6992, 7088, 7232, 7248, 42528, 43216, 43264, 43472, 43600, 44016, 65296, 66720, 69734, 69872, 69942, 70096, 71360, 120782, 120792, 120802, 120812, 120822]);
    this.bitmap$0$1 = (((16 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.nonASCIIZeroDigitCodePoints$1
});
var $d_jl_Character$ = new $TypeData().initClass({
  jl_Character$: 0
}, false, "java.lang.Character$", {
  jl_Character$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_jl_Character$.prototype.$classData = $d_jl_Character$;
var $n_jl_Character$ = (void 0);
function $m_jl_Character$() {
  if ((!$n_jl_Character$)) {
    $n_jl_Character$ = new $c_jl_Character$().init___()
  };
  return $n_jl_Character$
}
/** @constructor */
function $c_jl_Double$() {
  $c_O.call(this);
  this.doubleStrPat$1 = null;
  this.doubleStrHexPat$1 = null;
  this.bitmap$0$1 = 0
}
$c_jl_Double$.prototype = new $h_O();
$c_jl_Double$.prototype.constructor = $c_jl_Double$;
/** @constructor */
function $h_jl_Double$() {
  /*<skip>*/
}
$h_jl_Double$.prototype = $c_jl_Double$.prototype;
$c_jl_Double$.prototype.init___ = (function() {
  return this
});
$c_jl_Double$.prototype.doubleStrPat__p1__sjs_js_RegExp = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.doubleStrPat$lzycompute__p1__sjs_js_RegExp() : this.doubleStrPat$1)
});
$c_jl_Double$.prototype.doubleStrPat$lzycompute__p1__sjs_js_RegExp = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.doubleStrPat$1 = new $g.RegExp("^[\\x00-\\x20]*([+-]?(?:NaN|Infinity|(?:\\d+\\.?\\d*|\\.\\d+)(?:[eE][+-]?\\d+)?)[fFdD]?)[\\x00-\\x20]*$");
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.doubleStrPat$1
});
$c_jl_Double$.prototype.fail$1__p1__T__sr_Nothing$ = (function(s$1) {
  throw new $c_jl_NumberFormatException().init___T((("For input string: \"" + s$1) + "\""))
});
$c_jl_Double$.prototype.compare__D__D__I = (function(a, b) {
  if ((a !== a)) {
    return ((b !== b) ? 0 : 1)
  } else if ((b !== b)) {
    return (-1)
  } else if ((a === b)) {
    if ((a === 0.0)) {
      var ainf = (1.0 / a);
      return ((ainf === (1.0 / b)) ? 0 : ((ainf < 0) ? (-1) : 1))
    } else {
      return 0
    }
  } else {
    return ((a < b) ? (-1) : 1)
  }
});
$c_jl_Double$.prototype.doubleStrHexPat$lzycompute__p1__sjs_js_RegExp = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.doubleStrHexPat$1 = new $g.RegExp("^[\\x00-\\x20]*([+-]?)0[xX]([0-9A-Fa-f]*)\\.?([0-9A-Fa-f]*)[pP]([+-]?\\d+)[fFdD]?[\\x00-\\x20]*$");
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.doubleStrHexPat$1
});
$c_jl_Double$.prototype.parseHexDoubleImpl$1__p1__sjs_js_RegExp$ExecResult__T__D = (function(match2, s$1) {
  var signStr = $as_T(match2[1]);
  var integralPartStr = $as_T(match2[2]);
  var fractionalPartStr = $as_T(match2[3]);
  var binaryExpStr = $as_T(match2[4]);
  if (((integralPartStr === "") && (fractionalPartStr === ""))) {
    this.fail$1__p1__T__sr_Nothing$(s$1)
  };
  var mantissaStr0 = (("" + integralPartStr) + fractionalPartStr);
  var correction1 = ((-($uI(fractionalPartStr.length) << 2)) | 0);
  var i = 0;
  while (true) {
    if ((i !== $uI(mantissaStr0.length))) {
      var index = i;
      var jsx$1 = ((65535 & $uI(mantissaStr0.charCodeAt(index))) === 48)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      i = ((1 + i) | 0)
    } else {
      break
    }
  };
  var beginIndex = i;
  var mantissaStr = $as_T(mantissaStr0.substring(beginIndex));
  if ((mantissaStr === "")) {
    if ((signStr === "-")) {
      return (-0)
    } else {
      return 0.0
    }
  };
  var needsCorrection2 = ($uI(mantissaStr.length) > 15);
  var truncatedMantissaStr = (needsCorrection2 ? $as_T(mantissaStr.substring(0, 15)) : mantissaStr);
  var correction2 = (needsCorrection2 ? ((((-15) + $uI(mantissaStr.length)) | 0) << 2) : 0);
  var fullCorrection = ((correction1 + correction2) | 0);
  var mantissa = $uD($g.parseInt(truncatedMantissaStr, 16));
  var binaryExpDouble = $uD($g.parseInt(binaryExpStr, 10));
  var binaryExp = $doubleToInt(binaryExpDouble);
  var binExpAndCorrection = ((binaryExp + fullCorrection) | 0);
  var binExpAndCorrection_div_3 = ((binExpAndCorrection / 3) | 0);
  var correctingPow = $uD($g.Math.pow(2.0, binExpAndCorrection_div_3));
  var b = ((binExpAndCorrection - (binExpAndCorrection_div_3 << 1)) | 0);
  var correctingPow3 = $uD($g.Math.pow(2.0, b));
  var r = (((mantissa * correctingPow) * correctingPow) * correctingPow3);
  return ((signStr === "-") ? (-r) : r)
});
$c_jl_Double$.prototype.doubleStrHexPat__p1__sjs_js_RegExp = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.doubleStrHexPat$lzycompute__p1__sjs_js_RegExp() : this.doubleStrHexPat$1)
});
$c_jl_Double$.prototype.parseDouble__T__D = (function(s) {
  var match1 = this.doubleStrPat__p1__sjs_js_RegExp().exec(s);
  if ((match1 !== null)) {
    var value = match1[1];
    if ((value === (void 0))) {
      var jsx$2 = (void 0)
    } else {
      var s$2 = $as_T(value);
      var jsx$2 = s$2
    };
    var jsx$1 = $g.parseFloat(jsx$2);
    return $uD(jsx$1)
  } else {
    var match2 = this.doubleStrHexPat__p1__sjs_js_RegExp().exec(s);
    return ((match2 !== null) ? this.parseHexDoubleImpl$1__p1__sjs_js_RegExp$ExecResult__T__D(match2, s) : this.fail$1__p1__T__sr_Nothing$(s))
  }
});
var $d_jl_Double$ = new $TypeData().initClass({
  jl_Double$: 0
}, false, "java.lang.Double$", {
  jl_Double$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_jl_Double$.prototype.$classData = $d_jl_Double$;
var $n_jl_Double$ = (void 0);
function $m_jl_Double$() {
  if ((!$n_jl_Double$)) {
    $n_jl_Double$ = new $c_jl_Double$().init___()
  };
  return $n_jl_Double$
}
/** @constructor */
function $c_jl_Enum() {
  $c_O.call(this);
  this.$$undname$1 = null;
  this.$$undordinal$1 = 0
}
$c_jl_Enum.prototype = new $h_O();
$c_jl_Enum.prototype.constructor = $c_jl_Enum;
/** @constructor */
function $h_jl_Enum() {
  /*<skip>*/
}
$h_jl_Enum.prototype = $c_jl_Enum.prototype;
$c_jl_Enum.prototype.equals__O__Z = (function(that) {
  return (this === that)
});
$c_jl_Enum.prototype.compareTo__O__I = (function(o) {
  return this.compareTo__jl_Enum__I($as_jl_Enum(o))
});
$c_jl_Enum.prototype.toString__T = (function() {
  return this.$$undname$1
});
$c_jl_Enum.prototype.compareTo__jl_Enum__I = (function(o) {
  var x = this.$$undordinal$1;
  var y = o.$$undordinal$1;
  return ((x === y) ? 0 : ((x < y) ? (-1) : 1))
});
$c_jl_Enum.prototype.init___T__I = (function(_name, _ordinal) {
  this.$$undname$1 = _name;
  this.$$undordinal$1 = _ordinal;
  return this
});
$c_jl_Enum.prototype.hashCode__I = (function() {
  return $systemIdentityHashCode(this)
});
function $as_jl_Enum(obj) {
  return (((obj instanceof $c_jl_Enum) || (obj === null)) ? obj : $throwClassCastException(obj, "java.lang.Enum"))
}
function $isArrayOf_jl_Enum(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_Enum)))
}
function $asArrayOf_jl_Enum(obj, depth) {
  return (($isArrayOf_jl_Enum(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.Enum;", depth))
}
/** @constructor */
function $c_jl_Error() {
  $c_jl_Throwable.call(this)
}
$c_jl_Error.prototype = new $h_jl_Throwable();
$c_jl_Error.prototype.constructor = $c_jl_Error;
/** @constructor */
function $h_jl_Error() {
  /*<skip>*/
}
$h_jl_Error.prototype = $c_jl_Error.prototype;
$c_jl_Error.prototype.init___jl_Throwable = (function(e) {
  var s = ((e === null) ? null : e.toString__T());
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, e, true, true);
  return this
});
function $as_jl_Error(obj) {
  return (((obj instanceof $c_jl_Error) || (obj === null)) ? obj : $throwClassCastException(obj, "java.lang.Error"))
}
function $isArrayOf_jl_Error(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_Error)))
}
function $asArrayOf_jl_Error(obj, depth) {
  return (($isArrayOf_jl_Error(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.Error;", depth))
}
/** @constructor */
function $c_jl_Exception() {
  $c_jl_Throwable.call(this)
}
$c_jl_Exception.prototype = new $h_jl_Throwable();
$c_jl_Exception.prototype.constructor = $c_jl_Exception;
/** @constructor */
function $h_jl_Exception() {
  /*<skip>*/
}
$h_jl_Exception.prototype = $c_jl_Exception.prototype;
$c_jl_Exception.prototype.init___T = (function(s) {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
function $as_jl_Exception(obj) {
  return (((obj instanceof $c_jl_Exception) || (obj === null)) ? obj : $throwClassCastException(obj, "java.lang.Exception"))
}
function $isArrayOf_jl_Exception(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_Exception)))
}
function $asArrayOf_jl_Exception(obj, depth) {
  return (($isArrayOf_jl_Exception(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.Exception;", depth))
}
var $d_jl_Exception = new $TypeData().initClass({
  jl_Exception: 0
}, false, "java.lang.Exception", {
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_jl_Exception.prototype.$classData = $d_jl_Exception;
/** @constructor */
function $c_jl_Integer$() {
  $c_O.call(this)
}
$c_jl_Integer$.prototype = new $h_O();
$c_jl_Integer$.prototype.constructor = $c_jl_Integer$;
/** @constructor */
function $h_jl_Integer$() {
  /*<skip>*/
}
$h_jl_Integer$.prototype = $c_jl_Integer$.prototype;
$c_jl_Integer$.prototype.init___ = (function() {
  return this
});
$c_jl_Integer$.prototype.fail$1__p1__T__sr_Nothing$ = (function(s$1) {
  throw new $c_jl_NumberFormatException().init___T((("For input string: \"" + s$1) + "\""))
});
$c_jl_Integer$.prototype.parseInt__T__I__I = (function(s, radix) {
  var len = ((s === null) ? 0 : $uI(s.length));
  if ((((len === 0) || (radix < 2)) || (radix > 36))) {
    this.fail$1__p1__T__sr_Nothing$(s)
  };
  var firstChar = (65535 & $uI(s.charCodeAt(0)));
  var negative = (firstChar === 45);
  var maxAbsValue = (negative ? 2.147483648E9 : 2.147483647E9);
  var i = ((negative || (firstChar === 43)) ? 1 : 0);
  if ((i >= $uI(s.length))) {
    this.fail$1__p1__T__sr_Nothing$(s)
  };
  var result = 0.0;
  while ((i !== len)) {
    var jsx$1 = $m_jl_Character$();
    var index = i;
    var digit = jsx$1.digitWithValidRadix__I__I__I((65535 & $uI(s.charCodeAt(index))), radix);
    result = ((result * radix) + digit);
    if (((digit === (-1)) || (result > maxAbsValue))) {
      this.fail$1__p1__T__sr_Nothing$(s)
    };
    i = ((1 + i) | 0)
  };
  if (negative) {
    var n = (-result);
    return $uI((n | 0))
  } else {
    var n$1 = result;
    return $uI((n$1 | 0))
  }
});
$c_jl_Integer$.prototype.bitCount__I__I = (function(i) {
  var t1 = ((i - (1431655765 & (i >> 1))) | 0);
  var t2 = (((858993459 & t1) + (858993459 & (t1 >> 2))) | 0);
  return ($imul(16843009, (252645135 & ((t2 + (t2 >> 4)) | 0))) >> 24)
});
$c_jl_Integer$.prototype.reverseBytes__I__I = (function(i) {
  var byte3 = ((i >>> 24) | 0);
  var byte2 = (65280 & ((i >>> 8) | 0));
  var byte1 = (16711680 & (i << 8));
  var byte0 = (i << 24);
  return (((byte0 | byte1) | byte2) | byte3)
});
var $d_jl_Integer$ = new $TypeData().initClass({
  jl_Integer$: 0
}, false, "java.lang.Integer$", {
  jl_Integer$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_jl_Integer$.prototype.$classData = $d_jl_Integer$;
var $n_jl_Integer$ = (void 0);
function $m_jl_Integer$() {
  if ((!$n_jl_Integer$)) {
    $n_jl_Integer$ = new $c_jl_Integer$().init___()
  };
  return $n_jl_Integer$
}
/** @constructor */
function $c_jl_Long$() {
  $c_O.call(this);
  this.StringRadixInfos$1 = null;
  this.bitmap$0$1 = false
}
$c_jl_Long$.prototype = new $h_O();
$c_jl_Long$.prototype.constructor = $c_jl_Long$;
/** @constructor */
function $h_jl_Long$() {
  /*<skip>*/
}
$h_jl_Long$.prototype = $c_jl_Long$.prototype;
$c_jl_Long$.prototype.init___ = (function() {
  return this
});
$c_jl_Long$.prototype.StringRadixInfos__p1__sjs_js_Array = (function() {
  return ((!this.bitmap$0$1) ? this.StringRadixInfos$lzycompute__p1__sjs_js_Array() : this.StringRadixInfos$1)
});
$c_jl_Long$.prototype.parseLong__T__I__J = (function(s, radix) {
  if ((s === "")) {
    this.parseLongError__p1__T__sr_Nothing$(s)
  };
  var start = 0;
  var neg = false;
  var x1 = (65535 & $uI(s.charCodeAt(0)));
  switch (x1) {
    case 43: {
      start = 1;
      break
    }
    case 45: {
      start = 1;
      neg = true;
      break
    }
  };
  var t = this.parseUnsignedLongInternal__T__I__I__J(s, radix, start);
  var lo = t.lo$2;
  var hi = t.hi$2;
  if (neg) {
    var lo$1 = ((-lo) | 0);
    var hi$1 = ((lo !== 0) ? (~hi) : ((-hi) | 0));
    if (((hi$1 === 0) ? (lo$1 !== 0) : (hi$1 > 0))) {
      this.parseLongError__p1__T__sr_Nothing$(s)
    };
    return new $c_sjsr_RuntimeLong().init___I__I(lo$1, hi$1)
  } else {
    if ((hi < 0)) {
      this.parseLongError__p1__T__sr_Nothing$(s)
    };
    return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
  }
});
$c_jl_Long$.prototype.java$lang$Long$$toHexString__I__I__T = (function(lo, hi) {
  if ((hi !== 0)) {
    var x = $uD((hi >>> 0));
    var jsx$3 = x.toString(16);
    var jsx$2 = $as_T(jsx$3);
    var x$1 = $uD((lo >>> 0));
    var jsx$1 = x$1.toString(16);
    var s = $as_T(jsx$1);
    var beginIndex = $uI(s.length);
    return (jsx$2 + (("" + $as_T("00000000".substring(beginIndex))) + s))
  } else {
    var x$2 = $uD((lo >>> 0));
    var jsx$4 = x$2.toString(16);
    return $as_T(jsx$4)
  }
});
$c_jl_Long$.prototype.parseLongError__p1__T__sr_Nothing$ = (function(s) {
  throw new $c_jl_NumberFormatException().init___T((("For input string: \"" + s) + "\""))
});
$c_jl_Long$.prototype.parseUnsignedLongInternal__T__I__I__J = (function(s, radix, start) {
  var length = $uI(s.length);
  if ((((start >= length) || (radix < 2)) || (radix > 36))) {
    this.parseLongError__p1__T__sr_Nothing$(s)
  } else {
    var radixInfo = $as_jl_Long$StringRadixInfo(this.StringRadixInfos__p1__sjs_js_Array()[radix]);
    var chunkLen = radixInfo.chunkLength$1;
    var firstChunkStart = start;
    while (true) {
      if ((firstChunkStart < length)) {
        var jsx$2 = $m_jl_Character$();
        var index = firstChunkStart;
        var jsx$1 = jsx$2.isZeroDigit__C__Z((65535 & $uI(s.charCodeAt(index))))
      } else {
        var jsx$1 = false
      };
      if (jsx$1) {
        firstChunkStart = ((1 + firstChunkStart) | 0)
      } else {
        break
      }
    };
    if ((((length - firstChunkStart) | 0) > $imul(3, chunkLen))) {
      this.parseLongError__p1__T__sr_Nothing$(s)
    };
    var firstChunkLength = ((1 + (((((-1) + ((length - firstChunkStart) | 0)) | 0) % chunkLen) | 0)) | 0);
    var firstChunkEnd = ((firstChunkStart + firstChunkLength) | 0);
    var chunkStart = firstChunkStart;
    var x = this.parseChunkAsUInt$1__p1__I__I__T__I__I(chunkStart, firstChunkEnd, s, radix);
    if ((firstChunkEnd === length)) {
      return new $c_sjsr_RuntimeLong().init___I__I(x, 0)
    } else {
      var t = radixInfo.radixPowLength$1;
      var lo = t.lo$2;
      var hi$1 = t.hi$2;
      var secondChunkEnd = ((firstChunkEnd + chunkLen) | 0);
      var a0 = (65535 & x);
      var a1 = ((x >>> 16) | 0);
      var b0 = (65535 & lo);
      var b1 = ((lo >>> 16) | 0);
      var a0b0 = $imul(a0, b0);
      var a1b0 = $imul(a1, b0);
      var a0b1 = $imul(a0, b1);
      var lo$1 = ((a0b0 + (((a1b0 + a0b1) | 0) << 16)) | 0);
      var c1part = ((((a0b0 >>> 16) | 0) + a0b1) | 0);
      var hi$2 = (((((($imul(x, hi$1) + $imul(a1, b1)) | 0) + ((c1part >>> 16) | 0)) | 0) + (((((65535 & c1part) + a1b0) | 0) >>> 16) | 0)) | 0);
      var x$1 = this.parseChunkAsUInt$1__p1__I__I__T__I__I(firstChunkEnd, secondChunkEnd, s, radix);
      var lo$2 = ((lo$1 + x$1) | 0);
      var hi$4 = ((((-2147483648) ^ lo$2) < ((-2147483648) ^ lo$1)) ? ((1 + hi$2) | 0) : hi$2);
      if ((secondChunkEnd === length)) {
        return new $c_sjsr_RuntimeLong().init___I__I(lo$2, hi$4)
      } else {
        var t$1 = radixInfo.overflowBarrier$1;
        var lo$3 = t$1.lo$2;
        var hi$5 = t$1.hi$2;
        var x$2 = this.parseChunkAsUInt$1__p1__I__I__T__I__I(secondChunkEnd, length, s, radix);
        if (((hi$4 === hi$5) ? (((-2147483648) ^ lo$2) > ((-2147483648) ^ lo$3)) : (hi$4 > hi$5))) {
          this.parseLongError__p1__T__sr_Nothing$(s)
        };
        var a0$1 = (65535 & lo$2);
        var a1$1 = ((lo$2 >>> 16) | 0);
        var b0$1 = (65535 & lo);
        var b1$1 = ((lo >>> 16) | 0);
        var a0b0$1 = $imul(a0$1, b0$1);
        var a1b0$1 = $imul(a1$1, b0$1);
        var a0b1$1 = $imul(a0$1, b1$1);
        var lo$4 = ((a0b0$1 + (((a1b0$1 + a0b1$1) | 0) << 16)) | 0);
        var c1part$1 = ((((a0b0$1 >>> 16) | 0) + a0b1$1) | 0);
        var hi$7 = (((((((($imul(lo$2, hi$1) + $imul(hi$4, lo)) | 0) + $imul(a1$1, b1$1)) | 0) + ((c1part$1 >>> 16) | 0)) | 0) + (((((65535 & c1part$1) + a1b0$1) | 0) >>> 16) | 0)) | 0);
        var lo$5 = ((lo$4 + x$2) | 0);
        var hi$8 = ((((-2147483648) ^ lo$5) < ((-2147483648) ^ lo$4)) ? ((1 + hi$7) | 0) : hi$7);
        var hi$9 = ((-2147483648) ^ hi$8);
        if (((hi$9 === (-2147483648)) && (((-2147483648) ^ lo$5) < ((-2147483648) ^ x$2)))) {
          this.parseLongError__p1__T__sr_Nothing$(s)
        };
        return new $c_sjsr_RuntimeLong().init___I__I(lo$5, hi$8)
      }
    }
  }
});
$c_jl_Long$.prototype.parseChunkAsUInt$1__p1__I__I__T__I__I = (function(chunkStart, chunkEnd, s$1, radix$1) {
  var result = 0;
  var i = chunkStart;
  while ((i !== chunkEnd)) {
    var jsx$1 = $m_jl_Character$();
    var index = i;
    var digit = jsx$1.digitWithValidRadix__I__I__I((65535 & $uI(s$1.charCodeAt(index))), radix$1);
    if ((digit === (-1))) {
      this.parseLongError__p1__T__sr_Nothing$(s$1)
    };
    result = (($imul(result, radix$1) + digit) | 0);
    i = ((1 + i) | 0)
  };
  return result
});
$c_jl_Long$.prototype.StringRadixInfos$lzycompute__p1__sjs_js_Array = (function() {
  if ((!this.bitmap$0$1)) {
    var r = [];
    var radix = 0;
    while ((radix < 2)) {
      r.push(null);
      radix = ((1 + radix) | 0)
    };
    while ((radix <= 36)) {
      var barrier = ((2147483647 / radix) | 0);
      var radixPowLength = radix;
      var chunkLength = 1;
      var paddingZeros = "0";
      while ((radixPowLength <= barrier)) {
        radixPowLength = $imul(radixPowLength, radix);
        chunkLength = ((1 + chunkLength) | 0);
        paddingZeros = (paddingZeros + "0")
      };
      var value = radixPowLength;
      var hi = (value >> 31);
      var this$2 = $m_sjsr_RuntimeLong$();
      var lo = this$2.divideUnsignedImpl__I__I__I__I__I((-1), (-1), value, hi);
      var hi$1 = this$2.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
      var elem = new $c_jl_Long$StringRadixInfo().init___I__J__T__J(chunkLength, new $c_sjsr_RuntimeLong().init___I__I(value, hi), paddingZeros, new $c_sjsr_RuntimeLong().init___I__I(lo, hi$1));
      r.push(elem);
      radix = ((1 + radix) | 0)
    };
    this.StringRadixInfos$1 = r;
    this.bitmap$0$1 = true
  };
  return this.StringRadixInfos$1
});
$c_jl_Long$.prototype.java$lang$Long$$toOctalString__I__I__T = (function(lo, hi) {
  var lp = (1073741823 & lo);
  var mp = (1073741823 & ((((lo >>> 30) | 0) + (hi << 2)) | 0));
  var hp = ((hi >>> 28) | 0);
  if ((hp !== 0)) {
    var x = $uD((hp >>> 0));
    var jsx$5 = x.toString(8);
    var jsx$4 = $as_T(jsx$5);
    var x$1 = $uD((mp >>> 0));
    var jsx$2 = x$1.toString(8);
    var s = $as_T(jsx$2);
    var beginIndex = $uI(s.length);
    var jsx$3 = $as_T("0000000000".substring(beginIndex));
    var x$2 = $uD((lp >>> 0));
    var jsx$1 = x$2.toString(8);
    var s$1 = $as_T(jsx$1);
    var beginIndex$1 = $uI(s$1.length);
    return ((jsx$4 + (("" + jsx$3) + s)) + (("" + $as_T("0000000000".substring(beginIndex$1))) + s$1))
  } else if ((mp !== 0)) {
    var x$3 = $uD((mp >>> 0));
    var jsx$8 = x$3.toString(8);
    var jsx$7 = $as_T(jsx$8);
    var x$4 = $uD((lp >>> 0));
    var jsx$6 = x$4.toString(8);
    var s$2 = $as_T(jsx$6);
    var beginIndex$2 = $uI(s$2.length);
    return (jsx$7 + (("" + $as_T("0000000000".substring(beginIndex$2))) + s$2))
  } else {
    var x$5 = $uD((lp >>> 0));
    var jsx$9 = x$5.toString(8);
    return $as_T(jsx$9)
  }
});
var $d_jl_Long$ = new $TypeData().initClass({
  jl_Long$: 0
}, false, "java.lang.Long$", {
  jl_Long$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_jl_Long$.prototype.$classData = $d_jl_Long$;
var $n_jl_Long$ = (void 0);
function $m_jl_Long$() {
  if ((!$n_jl_Long$)) {
    $n_jl_Long$ = new $c_jl_Long$().init___()
  };
  return $n_jl_Long$
}
/** @constructor */
function $c_ju_Date$() {
  $c_O.call(this);
  this.java$util$Date$$Days$1 = null;
  this.java$util$Date$$Months$1 = null
}
$c_ju_Date$.prototype = new $h_O();
$c_ju_Date$.prototype.constructor = $c_ju_Date$;
/** @constructor */
function $h_ju_Date$() {
  /*<skip>*/
}
$h_ju_Date$.prototype = $c_ju_Date$.prototype;
$c_ju_Date$.prototype.init___ = (function() {
  $n_ju_Date$ = this;
  this.java$util$Date$$Days$1 = $makeNativeArrayWrapper($d_T.getArrayOf(), ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"]);
  this.java$util$Date$$Months$1 = $makeNativeArrayWrapper($d_T.getArrayOf(), ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]);
  return this
});
$c_ju_Date$.prototype.java$util$Date$$pad0__I__T = (function(i) {
  var str = ("" + i);
  return (($uI(str.length) < 2) ? ("0" + str) : str)
});
var $d_ju_Date$ = new $TypeData().initClass({
  ju_Date$: 0
}, false, "java.util.Date$", {
  ju_Date$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_ju_Date$.prototype.$classData = $d_ju_Date$;
var $n_ju_Date$ = (void 0);
function $m_ju_Date$() {
  if ((!$n_ju_Date$)) {
    $n_ju_Date$ = new $c_ju_Date$().init___()
  };
  return $n_ju_Date$
}
/** @constructor */
function $c_ju_concurrent_TimeUnit$() {
  $c_O.call(this);
  this.NANOSECONDS$1 = null;
  this.MICROSECONDS$1 = null;
  this.MILLISECONDS$1 = null;
  this.SECONDS$1 = null;
  this.MINUTES$1 = null;
  this.HOURS$1 = null;
  this.DAYS$1 = null;
  this.$$undvalues$1 = null
}
$c_ju_concurrent_TimeUnit$.prototype = new $h_O();
$c_ju_concurrent_TimeUnit$.prototype.constructor = $c_ju_concurrent_TimeUnit$;
/** @constructor */
function $h_ju_concurrent_TimeUnit$() {
  /*<skip>*/
}
$h_ju_concurrent_TimeUnit$.prototype = $c_ju_concurrent_TimeUnit$.prototype;
$c_ju_concurrent_TimeUnit$.prototype.init___ = (function() {
  $n_ju_concurrent_TimeUnit$ = this;
  this.NANOSECONDS$1 = new $c_ju_concurrent_TimeUnit$$anon$1().init___();
  this.MICROSECONDS$1 = new $c_ju_concurrent_TimeUnit$$anon$2().init___();
  this.MILLISECONDS$1 = new $c_ju_concurrent_TimeUnit$$anon$3().init___();
  this.SECONDS$1 = new $c_ju_concurrent_TimeUnit$$anon$4().init___();
  this.MINUTES$1 = new $c_ju_concurrent_TimeUnit$$anon$5().init___();
  this.HOURS$1 = new $c_ju_concurrent_TimeUnit$$anon$6().init___();
  this.DAYS$1 = new $c_ju_concurrent_TimeUnit$$anon$7().init___();
  this.$$undvalues$1 = $makeNativeArrayWrapper($d_ju_concurrent_TimeUnit.getArrayOf(), [this.NANOSECONDS$1, this.MICROSECONDS$1, this.MILLISECONDS$1, this.SECONDS$1, this.MINUTES$1, this.HOURS$1, this.DAYS$1]);
  return this
});
$c_ju_concurrent_TimeUnit$.prototype.java$util$concurrent$TimeUnit$$x__J__J__J__J = (function(a, b, max) {
  var ahi = a.hi$2;
  var bhi = max.hi$2;
  if (((ahi === bhi) ? (((-2147483648) ^ a.lo$2) > ((-2147483648) ^ max.lo$2)) : (ahi > bhi))) {
    return new $c_sjsr_RuntimeLong().init___I__I((-1), 2147483647)
  } else {
    var lo = max.lo$2;
    var hi = max.hi$2;
    var lo$1 = ((-lo) | 0);
    var hi$1 = ((lo !== 0) ? (~hi) : ((-hi) | 0));
    var ahi$1 = a.hi$2;
    if (((ahi$1 === hi$1) ? (((-2147483648) ^ a.lo$2) < ((-2147483648) ^ lo$1)) : (ahi$1 < hi$1))) {
      return new $c_sjsr_RuntimeLong().init___I__I(1, (-2147483648))
    } else {
      var alo = a.lo$2;
      var blo = b.lo$2;
      var a0 = (65535 & alo);
      var a1 = ((alo >>> 16) | 0);
      var b0 = (65535 & blo);
      var b1 = ((blo >>> 16) | 0);
      var a0b0 = $imul(a0, b0);
      var a1b0 = $imul(a1, b0);
      var a0b1 = $imul(a0, b1);
      var lo$2 = ((a0b0 + (((a1b0 + a0b1) | 0) << 16)) | 0);
      var c1part = ((((a0b0 >>> 16) | 0) + a0b1) | 0);
      var hi$2 = (((((((($imul(alo, b.hi$2) + $imul(a.hi$2, blo)) | 0) + $imul(a1, b1)) | 0) + ((c1part >>> 16) | 0)) | 0) + (((((65535 & c1part) + a1b0) | 0) >>> 16) | 0)) | 0);
      return new $c_sjsr_RuntimeLong().init___I__I(lo$2, hi$2)
    }
  }
});
var $d_ju_concurrent_TimeUnit$ = new $TypeData().initClass({
  ju_concurrent_TimeUnit$: 0
}, false, "java.util.concurrent.TimeUnit$", {
  ju_concurrent_TimeUnit$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_ju_concurrent_TimeUnit$.prototype.$classData = $d_ju_concurrent_TimeUnit$;
var $n_ju_concurrent_TimeUnit$ = (void 0);
function $m_ju_concurrent_TimeUnit$() {
  if ((!$n_ju_concurrent_TimeUnit$)) {
    $n_ju_concurrent_TimeUnit$ = new $c_ju_concurrent_TimeUnit$().init___()
  };
  return $n_ju_concurrent_TimeUnit$
}
/** @constructor */
function $c_ju_concurrent_atomic_AtomicReference() {
  $c_O.call(this);
  this.value$1 = null
}
$c_ju_concurrent_atomic_AtomicReference.prototype = new $h_O();
$c_ju_concurrent_atomic_AtomicReference.prototype.constructor = $c_ju_concurrent_atomic_AtomicReference;
/** @constructor */
function $h_ju_concurrent_atomic_AtomicReference() {
  /*<skip>*/
}
$h_ju_concurrent_atomic_AtomicReference.prototype = $c_ju_concurrent_atomic_AtomicReference.prototype;
$c_ju_concurrent_atomic_AtomicReference.prototype.compareAndSet__O__O__Z = (function(expect, update) {
  if ((expect === this.value$1)) {
    this.value$1 = update;
    return true
  } else {
    return false
  }
});
$c_ju_concurrent_atomic_AtomicReference.prototype.init___O = (function(value) {
  this.value$1 = value;
  return this
});
/** @constructor */
function $c_ju_regex_Pattern() {
  $c_O.call(this);
  this.groupCount$1 = 0;
  this.groupStartMapper$1 = null;
  this.jsRegExp$1 = null;
  this.$$undpattern$1 = null;
  this.$$undflags$1 = 0;
  this.bitmap$0$1 = 0
}
$c_ju_regex_Pattern.prototype = new $h_O();
$c_ju_regex_Pattern.prototype.constructor = $c_ju_regex_Pattern;
/** @constructor */
function $h_ju_regex_Pattern() {
  /*<skip>*/
}
$h_ju_regex_Pattern.prototype = $c_ju_regex_Pattern.prototype;
$c_ju_regex_Pattern.prototype.groupStartMapper__ju_regex_GroupStartMapper = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.groupStartMapper$lzycompute__p1__ju_regex_GroupStartMapper() : this.groupStartMapper$1)
});
$c_ju_regex_Pattern.prototype.jsFlags__p1__T = (function() {
  return ((($uZ(this.jsRegExp$1.global) ? "g" : "") + ($uZ(this.jsRegExp$1.ignoreCase) ? "i" : "")) + ($uZ(this.jsRegExp$1.multiline) ? "m" : ""))
});
$c_ju_regex_Pattern.prototype.jsPattern__p1__T = (function() {
  return $as_T(this.jsRegExp$1.source)
});
$c_ju_regex_Pattern.prototype.groupStartMapper$lzycompute__p1__ju_regex_GroupStartMapper = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.groupStartMapper$1 = $m_ju_regex_GroupStartMapper$().apply__T__T__ju_regex_GroupStartMapper(this.jsPattern__p1__T(), this.jsFlags__p1__T());
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.groupStartMapper$1
});
$c_ju_regex_Pattern.prototype.init___sjs_js_RegExp__T__I = (function(jsRegExp, _pattern, _flags) {
  this.jsRegExp$1 = jsRegExp;
  this.$$undpattern$1 = _pattern;
  this.$$undflags$1 = _flags;
  return this
});
$c_ju_regex_Pattern.prototype.toString__T = (function() {
  return this.$$undpattern$1
});
$c_ju_regex_Pattern.prototype.groupCount__I = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.groupCount$lzycompute__p1__I() : this.groupCount$1)
});
$c_ju_regex_Pattern.prototype.split__jl_CharSequence__I__AT = (function(input, limit) {
  var inputStr = $objectToString(input);
  if ((inputStr === "")) {
    return $makeNativeArrayWrapper($d_T.getArrayOf(), [""])
  } else {
    var lim = ((limit > 0) ? limit : 2147483647);
    var matcher = new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this, inputStr, 0, $uI(inputStr.length));
    var elems$2 = null;
    elems$2 = [];
    var prevEnd = 0;
    var size = 0;
    while (((size < (((-1) + lim) | 0)) && matcher.find__Z())) {
      if ((matcher.end__I() !== 0)) {
        var beginIndex = prevEnd;
        var endIndex = matcher.start__I();
        var elem = $as_T(inputStr.substring(beginIndex, endIndex));
        var unboxedElem = ((elem === null) ? null : elem);
        elems$2.push(unboxedElem);
        size = ((1 + size) | 0)
      };
      prevEnd = matcher.end__I()
    };
    var beginIndex$1 = prevEnd;
    var elem$1 = $as_T(inputStr.substring(beginIndex$1));
    var unboxedElem$1 = ((elem$1 === null) ? null : elem$1);
    elems$2.push(unboxedElem$1);
    var result = $makeNativeArrayWrapper($d_T.getArrayOf(), elems$2);
    if ((limit !== 0)) {
      return result
    } else {
      var actualLength = result.u.length;
      while (((actualLength !== 0) && (result.get((((-1) + actualLength) | 0)) === ""))) {
        actualLength = (((-1) + actualLength) | 0)
      };
      if ((actualLength === result.u.length)) {
        return result
      } else {
        var actualResult = $newArrayObject($d_T.getArrayOf(), [actualLength]);
        $systemArraycopy(result, 0, actualResult, 0, actualLength);
        return actualResult
      }
    }
  }
});
$c_ju_regex_Pattern.prototype.groupCount$lzycompute__p1__I = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.groupCount$1 = (((-1) + $uI(new $g.RegExp(("|" + this.jsPattern__p1__T())).exec("").length)) | 0);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.groupCount$1
});
$c_ju_regex_Pattern.prototype.newJSRegExp__sjs_js_RegExp = (function() {
  var r = new $g.RegExp(this.jsRegExp$1);
  return ((r !== this.jsRegExp$1) ? r : new $g.RegExp(this.jsPattern__p1__T(), this.jsFlags__p1__T()))
});
var $d_ju_regex_Pattern = new $TypeData().initClass({
  ju_regex_Pattern: 0
}, false, "java.util.regex.Pattern", {
  ju_regex_Pattern: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_ju_regex_Pattern.prototype.$classData = $d_ju_regex_Pattern;
/** @constructor */
function $c_ju_regex_Pattern$() {
  $c_O.call(this);
  this.java$util$regex$Pattern$$splitHackPat$1 = null;
  this.java$util$regex$Pattern$$flagHackPat$1 = null
}
$c_ju_regex_Pattern$.prototype = new $h_O();
$c_ju_regex_Pattern$.prototype.constructor = $c_ju_regex_Pattern$;
/** @constructor */
function $h_ju_regex_Pattern$() {
  /*<skip>*/
}
$h_ju_regex_Pattern$.prototype = $c_ju_regex_Pattern$.prototype;
$c_ju_regex_Pattern$.prototype.init___ = (function() {
  $n_ju_regex_Pattern$ = this;
  this.java$util$regex$Pattern$$splitHackPat$1 = new $g.RegExp("^\\\\Q(.|\\n|\\r)\\\\E$");
  this.java$util$regex$Pattern$$flagHackPat$1 = new $g.RegExp("^\\(\\?([idmsuxU]*)(?:-([idmsuxU]*))?\\)");
  return this
});
$c_ju_regex_Pattern$.prototype.matches__T__jl_CharSequence__Z = (function(regex, input) {
  var this$1 = this.compile__T__I__ju_regex_Pattern(regex, 0);
  return new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$1, input, 0, $charSequenceLength(input)).matches__Z()
});
$c_ju_regex_Pattern$.prototype.compile__T__I__ju_regex_Pattern = (function(regex, flags) {
  if (((16 & flags) !== 0)) {
    var x1 = new $c_T2().init___O__O(this.quote__T__T(regex), flags)
  } else {
    var m = this.java$util$regex$Pattern$$splitHackPat$1.exec(regex);
    if ((m !== null)) {
      var value = m[1];
      if ((value === (void 0))) {
        throw new $c_ju_NoSuchElementException().init___T("undefined.get")
      };
      var this$5 = new $c_s_Some().init___O(new $c_T2().init___O__O(this.quote__T__T($as_T(value)), flags))
    } else {
      var this$5 = $m_s_None$()
    };
    if (this$5.isEmpty__Z()) {
      var this$6 = $m_ju_regex_Pattern$();
      var m$1 = this$6.java$util$regex$Pattern$$flagHackPat$1.exec(regex);
      if ((m$1 !== null)) {
        var value$1 = m$1[0];
        if ((value$1 === (void 0))) {
          throw new $c_ju_NoSuchElementException().init___T("undefined.get")
        };
        var thiz = $as_T(value$1);
        var beginIndex = $uI(thiz.length);
        var newPat = $as_T(regex.substring(beginIndex));
        var elem$1 = 0;
        elem$1 = flags;
        var value$2 = m$1[1];
        if ((value$2 !== (void 0))) {
          var chars = $as_T(value$2);
          var end = $uI(chars.length);
          var i = 0;
          while ((i < end)) {
            var arg1 = i;
            elem$1 = (elem$1 | $m_ju_regex_Pattern$().java$util$regex$Pattern$$charToFlag__C__I((65535 & $uI(chars.charCodeAt(arg1)))));
            i = ((1 + i) | 0)
          }
        };
        var value$3 = m$1[2];
        if ((value$3 !== (void 0))) {
          var chars$3 = $as_T(value$3);
          var end$1 = $uI(chars$3.length);
          var i$1 = 0;
          while ((i$1 < end$1)) {
            var arg1$1 = i$1;
            elem$1 = (elem$1 & (~$m_ju_regex_Pattern$().java$util$regex$Pattern$$charToFlag__C__I((65535 & $uI(chars$3.charCodeAt(arg1$1))))));
            i$1 = ((1 + i$1) | 0)
          }
        };
        var this$33 = new $c_s_Some().init___O(new $c_T2().init___O__O(newPat, elem$1))
      } else {
        var this$33 = $m_s_None$()
      }
    } else {
      var this$33 = this$5
    };
    var x1 = $as_T2((this$33.isEmpty__Z() ? new $c_T2().init___O__O(regex, flags) : this$33.get__O()))
  };
  if ((x1 === null)) {
    throw new $c_s_MatchError().init___O(x1)
  };
  var jsPattern = $as_T(x1.$$und1__O());
  var flags1 = x1.$$und2$mcI$sp__I();
  var jsFlags = (("g" + (((2 & flags1) !== 0) ? "i" : "")) + (((8 & flags1) !== 0) ? "m" : ""));
  var jsRegExp = new $g.RegExp(jsPattern, jsFlags);
  return new $c_ju_regex_Pattern().init___sjs_js_RegExp__T__I(jsRegExp, regex, flags1)
});
$c_ju_regex_Pattern$.prototype.quote__T__T = (function(s) {
  var result = "";
  var i = 0;
  while ((i < $uI(s.length))) {
    var index = i;
    var c = (65535 & $uI(s.charCodeAt(index)));
    var jsx$2 = result;
    switch (c) {
      case 92:
      case 46:
      case 40:
      case 41:
      case 91:
      case 93:
      case 123:
      case 125:
      case 124:
      case 63:
      case 42:
      case 43:
      case 94:
      case 36: {
        var jsx$1 = ("\\" + new $c_jl_Character().init___C(c));
        break
      }
      default: {
        var jsx$1 = new $c_jl_Character().init___C(c)
      }
    };
    result = (("" + jsx$2) + jsx$1);
    i = ((1 + i) | 0)
  };
  return result
});
$c_ju_regex_Pattern$.prototype.java$util$regex$Pattern$$charToFlag__C__I = (function(c) {
  switch (c) {
    case 105: {
      return 2;
      break
    }
    case 100: {
      return 1;
      break
    }
    case 109: {
      return 8;
      break
    }
    case 115: {
      return 32;
      break
    }
    case 117: {
      return 64;
      break
    }
    case 120: {
      return 4;
      break
    }
    case 85: {
      return 256;
      break
    }
    default: {
      throw new $c_jl_IllegalArgumentException().init___T("bad in-pattern flag")
    }
  }
});
var $d_ju_regex_Pattern$ = new $TypeData().initClass({
  ju_regex_Pattern$: 0
}, false, "java.util.regex.Pattern$", {
  ju_regex_Pattern$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_ju_regex_Pattern$.prototype.$classData = $d_ju_regex_Pattern$;
var $n_ju_regex_Pattern$ = (void 0);
function $m_ju_regex_Pattern$() {
  if ((!$n_ju_regex_Pattern$)) {
    $n_ju_regex_Pattern$ = new $c_ju_regex_Pattern$().init___()
  };
  return $n_ju_regex_Pattern$
}
/** @constructor */
function $c_s_Console$() {
  $c_s_DeprecatedConsole.call(this);
  this.outVar$2 = null;
  this.errVar$2 = null;
  this.inVar$2 = null
}
$c_s_Console$.prototype = new $h_s_DeprecatedConsole();
$c_s_Console$.prototype.constructor = $c_s_Console$;
/** @constructor */
function $h_s_Console$() {
  /*<skip>*/
}
$h_s_Console$.prototype = $c_s_Console$.prototype;
$c_s_Console$.prototype.init___ = (function() {
  $n_s_Console$ = this;
  this.outVar$2 = new $c_s_util_DynamicVariable().init___O($m_jl_System$().out$1);
  this.errVar$2 = new $c_s_util_DynamicVariable().init___O($m_jl_System$().err$1);
  this.inVar$2 = new $c_s_util_DynamicVariable().init___O(null);
  return this
});
var $d_s_Console$ = new $TypeData().initClass({
  s_Console$: 0
}, false, "scala.Console$", {
  s_Console$: 1,
  s_DeprecatedConsole: 1,
  O: 1,
  s_io_AnsiColor: 1
});
$c_s_Console$.prototype.$classData = $d_s_Console$;
var $n_s_Console$ = (void 0);
function $m_s_Console$() {
  if ((!$n_s_Console$)) {
    $n_s_Console$ = new $c_s_Console$().init___()
  };
  return $n_s_Console$
}
/** @constructor */
function $c_s_Enumeration() {
  $c_O.call(this);
  this.ValueOrdering$module$1 = null;
  this.ValueSet$module$1 = null;
  this.scala$Enumeration$$vmap$1 = null;
  this.vset$1 = null;
  this.scala$Enumeration$$vsetDefined$1 = false;
  this.nmap$1 = null;
  this.nextId$1 = 0;
  this.nextName$1 = null;
  this.scala$Enumeration$$topId$1 = 0;
  this.scala$Enumeration$$bottomId$1 = 0
}
$c_s_Enumeration.prototype = new $h_O();
$c_s_Enumeration.prototype.constructor = $c_s_Enumeration;
/** @constructor */
function $h_s_Enumeration() {
  /*<skip>*/
}
$h_s_Enumeration.prototype = $c_s_Enumeration.prototype;
$c_s_Enumeration.prototype.toString__T = (function() {
  var x = $objectGetClass(this).getName__T();
  var this$2 = new $c_sci_StringOps().init___T(x);
  var x$1 = $f_sci_StringLike__stripSuffix__T__T(this$2, "$");
  var this$4 = new $c_sci_StringOps().init___T(x$1);
  var xs = $f_sci_StringLike__split__C__AT(this$4, 46);
  var this$6 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
  var x$2 = $as_T($f_sc_IndexedSeqOptimized__last__O(this$6));
  var this$8 = new $c_sci_StringOps().init___T(x$2);
  var xs$1 = $f_sci_StringLike__split__C__AT(this$8, 36);
  var this$10 = new $c_scm_ArrayOps$ofRef().init___AO(xs$1);
  return $as_T($f_sc_IndexedSeqOptimized__last__O(this$10))
});
$c_s_Enumeration.prototype.init___I = (function(initial) {
  this.scala$Enumeration$$vmap$1 = new $c_scm_HashMap().init___();
  this.vset$1 = null;
  this.scala$Enumeration$$vsetDefined$1 = false;
  this.nmap$1 = new $c_scm_HashMap().init___();
  this.nextId$1 = initial;
  this.scala$Enumeration$$topId$1 = initial;
  this.scala$Enumeration$$bottomId$1 = ((initial < 0) ? initial : 0);
  return this
});
/** @constructor */
function $c_s_Option$() {
  $c_O.call(this)
}
$c_s_Option$.prototype = new $h_O();
$c_s_Option$.prototype.constructor = $c_s_Option$;
/** @constructor */
function $h_s_Option$() {
  /*<skip>*/
}
$h_s_Option$.prototype = $c_s_Option$.prototype;
$c_s_Option$.prototype.init___ = (function() {
  return this
});
$c_s_Option$.prototype.apply__O__s_Option = (function(x) {
  return ((x === null) ? $m_s_None$() : new $c_s_Some().init___O(x))
});
var $d_s_Option$ = new $TypeData().initClass({
  s_Option$: 0
}, false, "scala.Option$", {
  s_Option$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_Option$.prototype.$classData = $d_s_Option$;
var $n_s_Option$ = (void 0);
function $m_s_Option$() {
  if ((!$n_s_Option$)) {
    $n_s_Option$ = new $c_s_Option$().init___()
  };
  return $n_s_Option$
}
/** @constructor */
function $c_s_Predef$() {
  $c_s_LowPriorityImplicits.call(this);
  this.Map$2 = null;
  this.Set$2 = null;
  this.ClassManifest$2 = null;
  this.Manifest$2 = null;
  this.NoManifest$2 = null;
  this.StringCanBuildFrom$2 = null;
  this.singleton$und$less$colon$less$2 = null;
  this.scala$Predef$$singleton$und$eq$colon$eq$f = null
}
$c_s_Predef$.prototype = new $h_s_LowPriorityImplicits();
$c_s_Predef$.prototype.constructor = $c_s_Predef$;
/** @constructor */
function $h_s_Predef$() {
  /*<skip>*/
}
$h_s_Predef$.prototype = $c_s_Predef$.prototype;
$c_s_Predef$.prototype.assert__Z__V = (function(assertion) {
  if ((!assertion)) {
    throw new $c_jl_AssertionError().init___O("assertion failed")
  }
});
$c_s_Predef$.prototype.init___ = (function() {
  $n_s_Predef$ = this;
  $m_s_package$();
  $m_sci_List$();
  this.Map$2 = $m_sci_Map$();
  this.Set$2 = $m_sci_Set$();
  this.ClassManifest$2 = $m_s_reflect_package$().ClassManifest$1;
  this.Manifest$2 = $m_s_reflect_package$().Manifest$1;
  this.NoManifest$2 = $m_s_reflect_NoManifest$();
  this.StringCanBuildFrom$2 = new $c_s_Predef$$anon$1().init___();
  this.singleton$und$less$colon$less$2 = new $c_s_Predef$$anon$2().init___();
  this.scala$Predef$$singleton$und$eq$colon$eq$f = new $c_s_Predef$$anon$3().init___();
  return this
});
$c_s_Predef$.prototype.genericArrayOps__O__scm_ArrayOps = (function(xs) {
  if ($isArrayOf_O(xs, 1)) {
    var x2 = $asArrayOf_O(xs, 1);
    var jsx$1 = new $c_scm_ArrayOps$ofRef().init___AO(x2)
  } else if ($isArrayOf_Z(xs, 1)) {
    var x3 = $asArrayOf_Z(xs, 1);
    var jsx$1 = new $c_scm_ArrayOps$ofBoolean().init___AZ(x3)
  } else if ($isArrayOf_B(xs, 1)) {
    var x4 = $asArrayOf_B(xs, 1);
    var jsx$1 = new $c_scm_ArrayOps$ofByte().init___AB(x4)
  } else if ($isArrayOf_C(xs, 1)) {
    var x5 = $asArrayOf_C(xs, 1);
    var jsx$1 = new $c_scm_ArrayOps$ofChar().init___AC(x5)
  } else if ($isArrayOf_D(xs, 1)) {
    var x6 = $asArrayOf_D(xs, 1);
    var jsx$1 = new $c_scm_ArrayOps$ofDouble().init___AD(x6)
  } else if ($isArrayOf_F(xs, 1)) {
    var x7 = $asArrayOf_F(xs, 1);
    var jsx$1 = new $c_scm_ArrayOps$ofFloat().init___AF(x7)
  } else if ($isArrayOf_I(xs, 1)) {
    var x8 = $asArrayOf_I(xs, 1);
    var jsx$1 = new $c_scm_ArrayOps$ofInt().init___AI(x8)
  } else if ($isArrayOf_J(xs, 1)) {
    var x9 = $asArrayOf_J(xs, 1);
    var jsx$1 = new $c_scm_ArrayOps$ofLong().init___AJ(x9)
  } else if ($isArrayOf_S(xs, 1)) {
    var x10 = $asArrayOf_S(xs, 1);
    var jsx$1 = new $c_scm_ArrayOps$ofShort().init___AS(x10)
  } else if ($isArrayOf_sr_BoxedUnit(xs, 1)) {
    var x11 = $asArrayOf_sr_BoxedUnit(xs, 1);
    var jsx$1 = new $c_scm_ArrayOps$ofUnit().init___Asr_BoxedUnit(x11)
  } else if ((xs === null)) {
    var jsx$1 = null
  } else {
    var jsx$1;
    throw new $c_s_MatchError().init___O(xs)
  };
  return $as_scm_ArrayOps(jsx$1)
});
$c_s_Predef$.prototype.require__Z__V = (function(requirement) {
  if ((!requirement)) {
    throw new $c_jl_IllegalArgumentException().init___T("requirement failed")
  }
});
$c_s_Predef$.prototype.$$qmark$qmark$qmark__sr_Nothing$ = (function() {
  throw new $c_s_NotImplementedError().init___()
});
var $d_s_Predef$ = new $TypeData().initClass({
  s_Predef$: 0
}, false, "scala.Predef$", {
  s_Predef$: 1,
  s_LowPriorityImplicits: 1,
  O: 1,
  s_DeprecatedPredef: 1
});
$c_s_Predef$.prototype.$classData = $d_s_Predef$;
var $n_s_Predef$ = (void 0);
function $m_s_Predef$() {
  if ((!$n_s_Predef$)) {
    $n_s_Predef$ = new $c_s_Predef$().init___()
  };
  return $n_s_Predef$
}
/** @constructor */
function $c_s_concurrent_BatchingExecutor$Batch() {
  $c_O.call(this);
  this.initial$1 = null;
  this.parentBlockContext$1 = null;
  this.$$outer$1 = null
}
$c_s_concurrent_BatchingExecutor$Batch.prototype = new $h_O();
$c_s_concurrent_BatchingExecutor$Batch.prototype.constructor = $c_s_concurrent_BatchingExecutor$Batch;
/** @constructor */
function $h_s_concurrent_BatchingExecutor$Batch() {
  /*<skip>*/
}
$h_s_concurrent_BatchingExecutor$Batch.prototype = $c_s_concurrent_BatchingExecutor$Batch.prototype;
$c_s_concurrent_BatchingExecutor$Batch.prototype.init___s_concurrent_BatchingExecutor__sci_List = (function($$outer, initial) {
  this.initial$1 = initial;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_s_concurrent_BatchingExecutor$Batch.prototype.processBatch$1__p1__sci_List__V = (function(batch) {
  _processBatch: while (true) {
    var x1 = batch;
    var x$2 = $m_sci_Nil$();
    if ((!x$2.equals__O__Z(x1))) {
      if ((x1 instanceof $c_sci_$colon$colon)) {
        var x2 = $as_sci_$colon$colon(x1);
        var head = $as_jl_Runnable(x2.head$5);
        var tail = x2.tl$5;
        this.$$outer$1.scala$concurrent$BatchingExecutor$$$undtasksLocal$1.set__O__V(tail);
        try {
          head.run__V()
        } catch (e) {
          var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
          if ((e$2 !== null)) {
            var remaining = $as_sci_List(this.$$outer$1.scala$concurrent$BatchingExecutor$$$undtasksLocal$1.get__O());
            this.$$outer$1.scala$concurrent$BatchingExecutor$$$undtasksLocal$1.set__O__V($m_sci_Nil$());
            var r = new $c_s_concurrent_BatchingExecutor$Batch().init___s_concurrent_BatchingExecutor__sci_List(this.$$outer$1, remaining);
            r.run__V();
            throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(e$2)
          } else {
            throw e
          }
        };
        batch = $as_sci_List(this.$$outer$1.scala$concurrent$BatchingExecutor$$$undtasksLocal$1.get__O());
        continue _processBatch
      };
      throw new $c_s_MatchError().init___O(x1)
    };
    break
  }
});
$c_s_concurrent_BatchingExecutor$Batch.prototype.run__V = (function() {
  $m_s_Predef$().require__Z__V((this.$$outer$1.scala$concurrent$BatchingExecutor$$$undtasksLocal$1.get__O() === null));
  var prevBlockContext = $m_s_concurrent_BlockContext$().current__s_concurrent_BlockContext();
  var this$1 = $m_s_concurrent_BlockContext$();
  var old = $as_s_concurrent_BlockContext(this$1.contextLocal$1.get__O());
  try {
    this$1.contextLocal$1.set__O__V(this);
    try {
      this.parentBlockContext$1 = prevBlockContext;
      this.processBatch$1__p1__sci_List__V(this.initial$1)
    } finally {
      this.$$outer$1.scala$concurrent$BatchingExecutor$$$undtasksLocal$1.remove__V();
      this.parentBlockContext$1 = null
    }
  } finally {
    this$1.contextLocal$1.set__O__V(old)
  }
});
var $d_s_concurrent_BatchingExecutor$Batch = new $TypeData().initClass({
  s_concurrent_BatchingExecutor$Batch: 0
}, false, "scala.concurrent.BatchingExecutor$Batch", {
  s_concurrent_BatchingExecutor$Batch: 1,
  O: 1,
  jl_Runnable: 1,
  s_concurrent_BlockContext: 1
});
$c_s_concurrent_BatchingExecutor$Batch.prototype.$classData = $d_s_concurrent_BatchingExecutor$Batch;
/** @constructor */
function $c_s_concurrent_duration_Duration$() {
  $c_O.call(this);
  this.timeUnitLabels$1 = null;
  this.timeUnitName$1 = null;
  this.timeUnit$1 = null;
  this.Zero$1 = null;
  this.Undefined$1 = null;
  this.Inf$1 = null;
  this.MinusInf$1 = null
}
$c_s_concurrent_duration_Duration$.prototype = new $h_O();
$c_s_concurrent_duration_Duration$.prototype.constructor = $c_s_concurrent_duration_Duration$;
/** @constructor */
function $h_s_concurrent_duration_Duration$() {
  /*<skip>*/
}
$h_s_concurrent_duration_Duration$.prototype = $c_s_concurrent_duration_Duration$.prototype;
$c_s_concurrent_duration_Duration$.prototype.init___ = (function() {
  $n_s_concurrent_duration_Duration$ = this;
  $m_sci_List$();
  var self = $m_ju_concurrent_TimeUnit$().DAYS$1;
  var jsx$6 = new $c_T2().init___O__O(self, "d day");
  var self$1 = $m_ju_concurrent_TimeUnit$().HOURS$1;
  var jsx$5 = new $c_T2().init___O__O(self$1, "h hour");
  var self$2 = $m_ju_concurrent_TimeUnit$().MINUTES$1;
  var jsx$4 = new $c_T2().init___O__O(self$2, "min minute");
  var self$3 = $m_ju_concurrent_TimeUnit$().SECONDS$1;
  var jsx$3 = new $c_T2().init___O__O(self$3, "s sec second");
  var self$4 = $m_ju_concurrent_TimeUnit$().MILLISECONDS$1;
  var jsx$2 = new $c_T2().init___O__O(self$4, "ms milli millisecond");
  var self$5 = $m_ju_concurrent_TimeUnit$().MICROSECONDS$1;
  var jsx$1 = new $c_T2().init___O__O(self$5, "\u00b5s micro microsecond");
  var self$6 = $m_ju_concurrent_TimeUnit$().NANOSECONDS$1;
  var array = [jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, jsx$1, new $c_T2().init___O__O(self$6, "ns nano nanosecond")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$18 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$18);
    i = (((-1) + i) | 0)
  };
  this.timeUnitLabels$1 = result;
  var this$19 = this.timeUnitLabels$1;
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var these = this$19;
  while ((!these.isEmpty__Z())) {
    var arg1 = these.head__O();
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    these = $as_sci_List(these.tail__O())
  };
  var this$22 = $as_sci_Map(b.elems$1);
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(s$2) {
      var s = $as_T(s$2);
      var this$21 = $m_s_concurrent_duration_Duration$().words__p1__T__sci_List(s);
      return $as_T($f_sc_LinearSeqOptimized__last__O(this$21))
    })
  })(this));
  var this$23 = new $c_sci_MapLike$$anon$2().init___sci_MapLike__F1(this$22, f);
  this.timeUnitName$1 = this$23;
  var this$29 = this.timeUnitLabels$1;
  var f$2 = (function(this$2$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var unit = $as_ju_concurrent_TimeUnit(x0$1.$$und1__O());
        var names = $as_T(x0$1.$$und2__O());
        var this$27 = $m_s_concurrent_duration_Duration$().expandLabels__p1__T__sci_List(names);
        var f$1 = (function($this$1, unit$1) {
          return (function(x$5$2) {
            var x$5 = $as_T(x$5$2);
            return new $c_T2().init___O__O(x$5, unit$1)
          })
        })(this$2$1, unit);
        var this$26 = $m_sci_List$();
        var bf = this$26.ReusableCBFInstance$2;
        if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
          if ((this$27 === $m_sci_Nil$())) {
            var jsx$7 = $m_sci_Nil$()
          } else {
            var arg1$1 = this$27.head__O();
            var h = new $c_sci_$colon$colon().init___O__sci_List(f$1(arg1$1), $m_sci_Nil$());
            var t = h;
            var rest = $as_sci_List(this$27.tail__O());
            while ((rest !== $m_sci_Nil$())) {
              var arg1$2 = rest.head__O();
              var nx = new $c_sci_$colon$colon().init___O__sci_List(f$1(arg1$2), $m_sci_Nil$());
              t.tl$5 = nx;
              t = nx;
              rest = $as_sci_List(rest.tail__O())
            };
            var jsx$7 = h
          }
        } else {
          var b$1 = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$27, bf);
          var these$1 = this$27;
          while ((!these$1.isEmpty__Z())) {
            var arg1$3 = these$1.head__O();
            b$1.$$plus$eq__O__scm_Builder(f$1(arg1$3));
            these$1 = $as_sci_List(these$1.tail__O())
          };
          var jsx$7 = b$1.result__O()
        };
        return $as_sci_List(jsx$7)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this);
  var this$28 = $m_sci_List$();
  var bf$1 = this$28.ReusableCBFInstance$2;
  if ((bf$1 === $m_sci_List$().ReusableCBFInstance$2)) {
    if ((this$29 === $m_sci_Nil$())) {
      var jsx$8 = $m_sci_Nil$()
    } else {
      var rest$1 = this$29;
      var found = new $c_sr_BooleanRef().init___Z(false);
      var h$1 = new $c_sr_ObjectRef().init___O(null);
      var t$1 = new $c_sr_ObjectRef().init___O(null);
      while ((rest$1 !== $m_sci_Nil$())) {
        var arg1$4 = rest$1.head__O();
        $as_sc_GenTraversableOnce(f$2(arg1$4)).seq__sc_TraversableOnce().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, found$1, h$2, t$2) {
          return (function(b$2) {
            if ((!found$1.elem$1)) {
              h$2.elem$1 = new $c_sci_$colon$colon().init___O__sci_List(b$2, $m_sci_Nil$());
              t$2.elem$1 = $as_sci_$colon$colon(h$2.elem$1);
              found$1.elem$1 = true
            } else {
              var nx$1 = new $c_sci_$colon$colon().init___O__sci_List(b$2, $m_sci_Nil$());
              $as_sci_$colon$colon(t$2.elem$1).tl$5 = nx$1;
              t$2.elem$1 = nx$1
            }
          })
        })(this$29, found, h$1, t$1)));
        rest$1 = $as_sci_List(rest$1.tail__O())
      };
      var jsx$8 = ((!found.elem$1) ? $m_sci_Nil$() : $as_sci_$colon$colon(h$1.elem$1))
    }
  } else {
    $m_sci_List$();
    var b$3 = new $c_scm_ListBuffer().init___();
    var these$2 = this$29;
    while ((!these$2.isEmpty__Z())) {
      var arg1$5 = these$2.head__O();
      var xs = $as_sc_GenTraversableOnce(f$2(arg1$5)).seq__sc_TraversableOnce();
      b$3.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(xs);
      these$2 = $as_sci_List(these$2.tail__O())
    };
    var jsx$8 = b$3.toList__sci_List()
  };
  this.timeUnit$1 = $as_sc_TraversableOnce(jsx$8).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2);
  this.Zero$1 = new $c_s_concurrent_duration_FiniteDuration().init___J__ju_concurrent_TimeUnit($m_sjsr_RuntimeLong$().Zero__sjsr_RuntimeLong(), $m_ju_concurrent_TimeUnit$().DAYS$1);
  this.Undefined$1 = new $c_s_concurrent_duration_Duration$$anon$1().init___();
  this.Inf$1 = new $c_s_concurrent_duration_Duration$$anon$2().init___();
  this.MinusInf$1 = new $c_s_concurrent_duration_Duration$$anon$3().init___();
  return this
});
$c_s_concurrent_duration_Duration$.prototype.apply__D__ju_concurrent_TimeUnit__s_concurrent_duration_Duration = (function(length, unit) {
  var t = unit.toNanos__J__J(new $c_sjsr_RuntimeLong().init___I__I(1, 0));
  var lo = t.lo$2;
  var hi = t.hi$2;
  return this.fromNanos__D__s_concurrent_duration_Duration(($m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toDouble__I__I__D(lo, hi) * length))
});
$c_s_concurrent_duration_Duration$.prototype.fromNanos__J__s_concurrent_duration_FiniteDuration = (function(nanos) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.remainderImpl__I__I__I__I__I(nanos.lo$2, nanos.hi$2, (-1857093632), 20116);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  if (((lo === 0) && (hi === 0))) {
    $m_s_concurrent_duration_Duration$();
    var this$2 = $m_sjsr_RuntimeLong$();
    var lo$1 = this$2.divideImpl__I__I__I__I__I(nanos.lo$2, nanos.hi$2, (-1857093632), 20116);
    var hi$1 = this$2.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
    var unit = $m_ju_concurrent_TimeUnit$().DAYS$1;
    return new $c_s_concurrent_duration_FiniteDuration().init___J__ju_concurrent_TimeUnit(new $c_sjsr_RuntimeLong().init___I__I(lo$1, hi$1), unit)
  } else {
    var this$4 = $m_sjsr_RuntimeLong$();
    var lo$2 = this$4.remainderImpl__I__I__I__I__I(nanos.lo$2, nanos.hi$2, 817405952, 838);
    var hi$2 = this$4.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
    if (((lo$2 === 0) && (hi$2 === 0))) {
      $m_s_concurrent_duration_Duration$();
      var this$5 = $m_sjsr_RuntimeLong$();
      var lo$3 = this$5.divideImpl__I__I__I__I__I(nanos.lo$2, nanos.hi$2, 817405952, 838);
      var hi$3 = this$5.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
      var unit$1 = $m_ju_concurrent_TimeUnit$().HOURS$1;
      return new $c_s_concurrent_duration_FiniteDuration().init___J__ju_concurrent_TimeUnit(new $c_sjsr_RuntimeLong().init___I__I(lo$3, hi$3), unit$1)
    } else {
      var this$7 = $m_sjsr_RuntimeLong$();
      var lo$4 = this$7.remainderImpl__I__I__I__I__I(nanos.lo$2, nanos.hi$2, (-129542144), 13);
      var hi$4 = this$7.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
      if (((lo$4 === 0) && (hi$4 === 0))) {
        $m_s_concurrent_duration_Duration$();
        var this$8 = $m_sjsr_RuntimeLong$();
        var lo$5 = this$8.divideImpl__I__I__I__I__I(nanos.lo$2, nanos.hi$2, (-129542144), 13);
        var hi$5 = this$8.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
        var unit$2 = $m_ju_concurrent_TimeUnit$().MINUTES$1;
        return new $c_s_concurrent_duration_FiniteDuration().init___J__ju_concurrent_TimeUnit(new $c_sjsr_RuntimeLong().init___I__I(lo$5, hi$5), unit$2)
      } else {
        var this$10 = $m_sjsr_RuntimeLong$();
        var lo$6 = this$10.remainderImpl__I__I__I__I__I(nanos.lo$2, nanos.hi$2, 1000000000, 0);
        var hi$6 = this$10.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
        if (((lo$6 === 0) && (hi$6 === 0))) {
          $m_s_concurrent_duration_Duration$();
          var this$11 = $m_sjsr_RuntimeLong$();
          var lo$7 = this$11.divideImpl__I__I__I__I__I(nanos.lo$2, nanos.hi$2, 1000000000, 0);
          var hi$7 = this$11.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
          var unit$3 = $m_ju_concurrent_TimeUnit$().SECONDS$1;
          return new $c_s_concurrent_duration_FiniteDuration().init___J__ju_concurrent_TimeUnit(new $c_sjsr_RuntimeLong().init___I__I(lo$7, hi$7), unit$3)
        } else {
          var this$13 = $m_sjsr_RuntimeLong$();
          var lo$8 = this$13.remainderImpl__I__I__I__I__I(nanos.lo$2, nanos.hi$2, 1000000, 0);
          var hi$8 = this$13.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
          if (((lo$8 === 0) && (hi$8 === 0))) {
            $m_s_concurrent_duration_Duration$();
            var this$14 = $m_sjsr_RuntimeLong$();
            var lo$9 = this$14.divideImpl__I__I__I__I__I(nanos.lo$2, nanos.hi$2, 1000000, 0);
            var hi$9 = this$14.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
            var unit$4 = $m_ju_concurrent_TimeUnit$().MILLISECONDS$1;
            return new $c_s_concurrent_duration_FiniteDuration().init___J__ju_concurrent_TimeUnit(new $c_sjsr_RuntimeLong().init___I__I(lo$9, hi$9), unit$4)
          } else {
            var this$16 = $m_sjsr_RuntimeLong$();
            var lo$10 = this$16.remainderImpl__I__I__I__I__I(nanos.lo$2, nanos.hi$2, 1000, 0);
            var hi$10 = this$16.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
            if (((lo$10 === 0) && (hi$10 === 0))) {
              $m_s_concurrent_duration_Duration$();
              var this$17 = $m_sjsr_RuntimeLong$();
              var lo$11 = this$17.divideImpl__I__I__I__I__I(nanos.lo$2, nanos.hi$2, 1000, 0);
              var hi$11 = this$17.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
              var unit$5 = $m_ju_concurrent_TimeUnit$().MICROSECONDS$1;
              return new $c_s_concurrent_duration_FiniteDuration().init___J__ju_concurrent_TimeUnit(new $c_sjsr_RuntimeLong().init___I__I(lo$11, hi$11), unit$5)
            } else {
              $m_s_concurrent_duration_Duration$();
              var unit$6 = $m_ju_concurrent_TimeUnit$().NANOSECONDS$1;
              return new $c_s_concurrent_duration_FiniteDuration().init___J__ju_concurrent_TimeUnit(nanos, unit$6)
            }
          }
        }
      }
    }
  }
});
$c_s_concurrent_duration_Duration$.prototype.words__p1__T__sci_List = (function(s) {
  var thiz = $as_T(s.trim());
  var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "\\s+", 0);
  var i = (((-1) + xs.u.length) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result;
    var index = i;
    var x = xs.get(index);
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  return result
});
$c_s_concurrent_duration_Duration$.prototype.apply__T__s_concurrent_duration_Duration = (function(s) {
  var this$2 = new $c_sci_StringOps().init___T(s);
  var b = new $c_scm_StringBuilder().init___();
  var i = 0;
  var $$this$1 = this$2.repr$1;
  var len = $uI($$this$1.length);
  while ((i < len)) {
    var arg1 = this$2.apply__I__O(i);
    if ((arg1 === null)) {
      var x$1 = 0
    } else {
      var this$8 = $as_jl_Character(arg1);
      var x$1 = this$8.value$1
    };
    var this$11 = $m_jl_Character$();
    if ((this$11.isWhitespace__I__Z(x$1) !== true)) {
      if ((arg1 === null)) {
        var jsx$1 = 0
      } else {
        var this$13 = $as_jl_Character(arg1);
        var jsx$1 = this$13.value$1
      };
      b.$$plus$eq__C__scm_StringBuilder(jsx$1)
    };
    i = ((1 + i) | 0)
  };
  var s1 = b.underlying$5.java$lang$StringBuilder$$content$f;
  if (((s1 === "Inf") || ((s1 === "PlusInf") || (s1 === "+Inf")))) {
    return this.Inf$1
  } else if (((s1 === "MinusInf") || (s1 === "-Inf"))) {
    return this.MinusInf$1
  } else {
    var this$15 = new $c_sci_StringOps().init___T(s1);
    var x = $as_T($f_sc_IndexedSeqOptimized__reverse__O(this$15));
    var this$17 = new $c_sci_StringOps().init___T(x);
    var $$this$2 = this$17.repr$1;
    var len$1 = $uI($$this$2.length);
    var i$1 = 0;
    while (true) {
      if ((i$1 < len$1)) {
        var arg1$1 = this$17.apply__I__O(i$1);
        if ((arg1$1 === null)) {
          var x$2 = 0
        } else {
          var this$21 = $as_jl_Character(arg1$1);
          var x$2 = this$21.value$1
        };
        var this$24 = $m_jl_Character$();
        var jsx$2 = this$24.isLetter__I__Z(x$2)
      } else {
        var jsx$2 = false
      };
      if (jsx$2) {
        i$1 = ((1 + i$1) | 0)
      } else {
        break
      }
    };
    var n = i$1;
    var x$3 = $m_sci_StringOps$().slice$extension__T__I__I__T(this$17.repr$1, 0, n);
    var this$26 = new $c_sci_StringOps().init___T(x$3);
    var unitName = $as_T($f_sc_IndexedSeqOptimized__reverse__O(this$26));
    var x1$2 = this.timeUnit$1.get__O__s_Option(unitName);
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var unit = $as_ju_concurrent_TimeUnit(x2.value$2);
      var this$29 = new $c_sci_StringOps().init___T(s1);
      var n$1 = $uI(unitName.length);
      var valueStr = $as_T($f_sc_IndexedSeqOptimized__dropRight__I__O(this$29, n$1));
      var valueD = $m_jl_Double$().parseDouble__T__D(valueStr);
      if (((valueD >= (-9.007199254740992E15)) && (valueD <= 9.007199254740992E15))) {
        return $m_s_concurrent_duration_Duration$().apply__D__ju_concurrent_TimeUnit__s_concurrent_duration_Duration(valueD, unit)
      } else {
        $m_s_concurrent_duration_Duration$();
        var this$30 = $m_jl_Long$();
        var t = this$30.parseLong__T__I__J(valueStr, 10);
        var lo = t.lo$2;
        var hi = t.hi$2;
        return new $c_s_concurrent_duration_FiniteDuration().init___J__ju_concurrent_TimeUnit(new $c_sjsr_RuntimeLong().init___I__I(lo, hi), unit)
      }
    } else {
      throw new $c_jl_NumberFormatException().init___T(("format error " + s))
    }
  }
});
$c_s_concurrent_duration_Duration$.prototype.expandLabels__p1__T__sci_List = (function(labels) {
  var x1 = this.words__p1__T__sci_List(labels);
  if ((!(x1 instanceof $c_sci_$colon$colon))) {
    throw new $c_s_MatchError().init___O(x1)
  };
  var x2 = $as_sci_$colon$colon(x1);
  var hd = $as_T(x2.head$5);
  var rest = x2.tl$5;
  var f = (function($this) {
    return (function(s$2) {
      var s = $as_T(s$2);
      $m_sci_List$();
      var array = [s, (s + "s")];
      var i = (((-1) + $uI(array.length)) | 0);
      var result = $m_sci_Nil$();
      while ((i >= 0)) {
        var this$4 = result;
        var index = i;
        var x = array[index];
        result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
        i = (((-1) + i) | 0)
      };
      return result
    })
  })(this);
  var this$5 = $m_sci_List$();
  var bf = this$5.ReusableCBFInstance$2;
  if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
    if ((rest === $m_sci_Nil$())) {
      var jsx$1 = $m_sci_Nil$()
    } else {
      var rest$1 = rest;
      var found = new $c_sr_BooleanRef().init___Z(false);
      var h = new $c_sr_ObjectRef().init___O(null);
      var t = new $c_sr_ObjectRef().init___O(null);
      while ((rest$1 !== $m_sci_Nil$())) {
        var arg1 = rest$1.head__O();
        $as_sc_GenTraversableOnce(f(arg1)).seq__sc_TraversableOnce().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, found$1, h$1, t$1) {
          return (function(b$2) {
            if ((!found$1.elem$1)) {
              h$1.elem$1 = new $c_sci_$colon$colon().init___O__sci_List(b$2, $m_sci_Nil$());
              t$1.elem$1 = $as_sci_$colon$colon(h$1.elem$1);
              found$1.elem$1 = true
            } else {
              var nx = new $c_sci_$colon$colon().init___O__sci_List(b$2, $m_sci_Nil$());
              $as_sci_$colon$colon(t$1.elem$1).tl$5 = nx;
              t$1.elem$1 = nx
            }
          })
        })(rest, found, h, t)));
        rest$1 = $as_sci_List(rest$1.tail__O())
      };
      var jsx$1 = ((!found.elem$1) ? $m_sci_Nil$() : $as_sci_$colon$colon(h.elem$1))
    }
  } else {
    $m_sci_List$();
    var b = new $c_scm_ListBuffer().init___();
    var these = rest;
    while ((!these.isEmpty__Z())) {
      var arg1$1 = these.head__O();
      var xs = $as_sc_GenTraversableOnce(f(arg1$1)).seq__sc_TraversableOnce();
      b.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(xs);
      these = $as_sci_List(these.tail__O())
    };
    var jsx$1 = b.toList__sci_List()
  };
  var this$10 = $as_sci_List(jsx$1);
  return new $c_sci_$colon$colon().init___O__sci_List(hd, this$10)
});
$c_s_concurrent_duration_Duration$.prototype.fromNanos__D__s_concurrent_duration_Duration = (function(nanos) {
  if (((nanos === Infinity) || (nanos === (-Infinity)))) {
    return ((nanos > 0) ? this.Inf$1 : this.MinusInf$1)
  } else if ((nanos !== nanos)) {
    return this.Undefined$1
  } else if (((nanos > 9.223372036854776E18) || (nanos < (-9.223372036854776E18)))) {
    throw new $c_jl_IllegalArgumentException().init___T((("trying to construct too large duration with " + nanos) + "ns"))
  } else {
    var this$8 = $m_sjsr_RuntimeLong$();
    var value = $uD($g.Math.round(nanos));
    var lo = this$8.scala$scalajs$runtime$RuntimeLong$$fromDoubleImpl__D__I(value);
    var hi = this$8.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
    return this.fromNanos__J__s_concurrent_duration_FiniteDuration(new $c_sjsr_RuntimeLong().init___I__I(lo, hi))
  }
});
var $d_s_concurrent_duration_Duration$ = new $TypeData().initClass({
  s_concurrent_duration_Duration$: 0
}, false, "scala.concurrent.duration.Duration$", {
  s_concurrent_duration_Duration$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_concurrent_duration_Duration$.prototype.$classData = $d_s_concurrent_duration_Duration$;
var $n_s_concurrent_duration_Duration$ = (void 0);
function $m_s_concurrent_duration_Duration$() {
  if ((!$n_s_concurrent_duration_Duration$)) {
    $n_s_concurrent_duration_Duration$ = new $c_s_concurrent_duration_Duration$().init___()
  };
  return $n_s_concurrent_duration_Duration$
}
/** @constructor */
function $c_s_concurrent_impl_CallbackRunnable() {
  $c_O.call(this);
  this.executor$1 = null;
  this.onComplete$1 = null;
  this.value$1 = null
}
$c_s_concurrent_impl_CallbackRunnable.prototype = new $h_O();
$c_s_concurrent_impl_CallbackRunnable.prototype.constructor = $c_s_concurrent_impl_CallbackRunnable;
/** @constructor */
function $h_s_concurrent_impl_CallbackRunnable() {
  /*<skip>*/
}
$h_s_concurrent_impl_CallbackRunnable.prototype = $c_s_concurrent_impl_CallbackRunnable.prototype;
$c_s_concurrent_impl_CallbackRunnable.prototype.run__V = (function() {
  $m_s_Predef$().require__Z__V((this.value$1 !== null));
  try {
    this.onComplete$1.apply__O__O(this.value$1)
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      matchEnd8: {
        var o11 = $m_s_util_control_NonFatal$().unapply__jl_Throwable__s_Option(e$2);
        if ((!o11.isEmpty__Z())) {
          var e$3 = $as_jl_Throwable(o11.get__O());
          this.executor$1.reportFailure__jl_Throwable__V(e$3);
          break matchEnd8
        };
        throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(e$2)
      }
    } else {
      throw e
    }
  }
});
$c_s_concurrent_impl_CallbackRunnable.prototype.init___s_concurrent_ExecutionContext__F1 = (function(executor, onComplete) {
  this.executor$1 = executor;
  this.onComplete$1 = onComplete;
  this.value$1 = null;
  return this
});
$c_s_concurrent_impl_CallbackRunnable.prototype.executeWithValue__s_util_Try__V = (function(v) {
  $m_s_Predef$().require__Z__V((this.value$1 === null));
  this.value$1 = v;
  try {
    this.executor$1.execute__jl_Runnable__V(this)
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      matchEnd8: {
        var o11 = $m_s_util_control_NonFatal$().unapply__jl_Throwable__s_Option(e$2);
        if ((!o11.isEmpty__Z())) {
          var t = $as_jl_Throwable(o11.get__O());
          this.executor$1.reportFailure__jl_Throwable__V(t);
          break matchEnd8
        };
        throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(e$2)
      }
    } else {
      throw e
    }
  }
});
function $as_s_concurrent_impl_CallbackRunnable(obj) {
  return (((obj instanceof $c_s_concurrent_impl_CallbackRunnable) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.concurrent.impl.CallbackRunnable"))
}
function $isArrayOf_s_concurrent_impl_CallbackRunnable(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_concurrent_impl_CallbackRunnable)))
}
function $asArrayOf_s_concurrent_impl_CallbackRunnable(obj, depth) {
  return (($isArrayOf_s_concurrent_impl_CallbackRunnable(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.concurrent.impl.CallbackRunnable;", depth))
}
var $d_s_concurrent_impl_CallbackRunnable = new $TypeData().initClass({
  s_concurrent_impl_CallbackRunnable: 0
}, false, "scala.concurrent.impl.CallbackRunnable", {
  s_concurrent_impl_CallbackRunnable: 1,
  O: 1,
  jl_Runnable: 1,
  s_concurrent_OnCompleteRunnable: 1
});
$c_s_concurrent_impl_CallbackRunnable.prototype.$classData = $d_s_concurrent_impl_CallbackRunnable;
function $f_s_concurrent_impl_Promise__transformWith__F1__s_concurrent_ExecutionContext__s_concurrent_Future($thiz, f, executor) {
  var p = new $c_s_concurrent_impl_Promise$DefaultPromise().init___();
  $thiz.onComplete__F1__s_concurrent_ExecutionContext__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, f$1, p$1) {
    return (function(v$2) {
      var v = $as_s_util_Try(v$2);
      try {
        var x1 = $as_s_concurrent_Future(f$1.apply__O__O(v));
        if ((x1 === $this)) {
          return $f_s_concurrent_Promise__complete__s_util_Try__s_concurrent_Promise(p$1, v)
        } else if ((x1 instanceof $c_s_concurrent_impl_Promise$DefaultPromise)) {
          var x2 = $as_s_concurrent_impl_Promise$DefaultPromise(x1);
          x2.link__p2__s_concurrent_impl_Promise$DefaultPromise__V(p$1.compressedRoot__p2__s_concurrent_impl_Promise$DefaultPromise());
          return (void 0)
        } else {
          return $f_s_concurrent_Promise__tryCompleteWith__s_concurrent_Future__s_concurrent_Promise(p$1, x1)
        }
      } catch (e) {
        var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
        if ((e$2 !== null)) {
          var o11 = $m_s_util_control_NonFatal$().unapply__jl_Throwable__s_Option(e$2);
          if ((!o11.isEmpty__Z())) {
            var t = $as_jl_Throwable(o11.get__O());
            return $f_s_concurrent_Promise__failure__jl_Throwable__s_concurrent_Promise(p$1, t)
          };
          throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(e$2)
        } else {
          throw e
        }
      }
    })
  })($thiz, f, p)), executor);
  return p
}
function $f_s_concurrent_impl_Promise__toString__T($thiz) {
  var x1 = $thiz.value__s_Option();
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var result = $as_s_util_Try(x2.value$2);
    return (("Future(" + result) + ")")
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return "Future(<not completed>)"
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
}
function $f_s_concurrent_impl_Promise__transform__F1__s_concurrent_ExecutionContext__s_concurrent_Future($thiz, f, executor) {
  var p = new $c_s_concurrent_impl_Promise$DefaultPromise().init___();
  $thiz.onComplete__F1__s_concurrent_ExecutionContext__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, p$1, f$1) {
    return (function(result$2) {
      var result = $as_s_util_Try(result$2);
      var result$1 = $f_s_concurrent_impl_Promise__liftedTree1$1__ps_concurrent_impl_Promise__F1__s_util_Try__s_util_Try($this, f$1, result);
      return $as_s_concurrent_impl_Promise$DefaultPromise($f_s_concurrent_Promise__complete__s_util_Try__s_concurrent_Promise(p$1, result$1))
    })
  })($thiz, p, f)), executor);
  return p
}
function $f_s_concurrent_impl_Promise__liftedTree1$1__ps_concurrent_impl_Promise__F1__s_util_Try__s_util_Try($thiz, f$1, result$1) {
  try {
    return $as_s_util_Try(f$1.apply__O__O(result$1))
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      var o11 = $m_s_util_control_NonFatal$().unapply__jl_Throwable__s_Option(e$2);
      if ((!o11.isEmpty__Z())) {
        var t = $as_jl_Throwable(o11.get__O());
        return new $c_s_util_Failure().init___jl_Throwable(t)
      };
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(e$2)
    } else {
      throw e
    }
  }
}
/** @constructor */
function $c_s_math_BigDecimal$() {
  $c_O.call(this);
  this.cache$1 = null;
  this.minCached$1 = 0;
  this.maxCached$1 = 0;
  this.defaultMathContext$1 = null;
  this.bitmap$0$1 = false
}
$c_s_math_BigDecimal$.prototype = new $h_O();
$c_s_math_BigDecimal$.prototype.constructor = $c_s_math_BigDecimal$;
/** @constructor */
function $h_s_math_BigDecimal$() {
  /*<skip>*/
}
$h_s_math_BigDecimal$.prototype = $c_s_math_BigDecimal$.prototype;
$c_s_math_BigDecimal$.prototype.init___ = (function() {
  $n_s_math_BigDecimal$ = this;
  this.minCached$1 = (-512);
  this.maxCached$1 = 512;
  this.defaultMathContext$1 = $m_Ljava_math_MathContext$().DECIMAL128$1;
  return this
});
$c_s_math_BigDecimal$.prototype.decimal__D__Ljava_math_MathContext__s_math_BigDecimal = (function(d, mc) {
  return new $c_s_math_BigDecimal().init___Ljava_math_BigDecimal__Ljava_math_MathContext(new $c_Ljava_math_BigDecimal().init___T__Ljava_math_MathContext(("" + d), mc), mc)
});
$c_s_math_BigDecimal$.prototype.exact__T__s_math_BigDecimal = (function(s) {
  return this.exact__Ljava_math_BigDecimal__s_math_BigDecimal(new $c_Ljava_math_BigDecimal().init___T(s))
});
$c_s_math_BigDecimal$.prototype.exact__Ljava_math_BigDecimal__s_math_BigDecimal = (function(repr) {
  var jsx$1 = repr.precision__I();
  var this$1 = this.defaultMathContext$1;
  if ((jsx$1 <= this$1.precision$1)) {
    var mc = this.defaultMathContext$1
  } else {
    var mc = new $c_Ljava_math_MathContext().init___I__Ljava_math_RoundingMode(repr.precision__I(), $m_Ljava_math_RoundingMode$().HALF$undEVEN$1)
  };
  return new $c_s_math_BigDecimal().init___Ljava_math_BigDecimal__Ljava_math_MathContext(repr, mc)
});
var $d_s_math_BigDecimal$ = new $TypeData().initClass({
  s_math_BigDecimal$: 0
}, false, "scala.math.BigDecimal$", {
  s_math_BigDecimal$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_math_BigDecimal$.prototype.$classData = $d_s_math_BigDecimal$;
var $n_s_math_BigDecimal$ = (void 0);
function $m_s_math_BigDecimal$() {
  if ((!$n_s_math_BigDecimal$)) {
    $n_s_math_BigDecimal$ = new $c_s_math_BigDecimal$().init___()
  };
  return $n_s_math_BigDecimal$
}
/** @constructor */
function $c_s_math_BigInt$() {
  $c_O.call(this);
  this.minCached$1 = 0;
  this.maxCached$1 = 0;
  this.cache$1 = null;
  this.scala$math$BigInt$$minusOne$1 = null
}
$c_s_math_BigInt$.prototype = new $h_O();
$c_s_math_BigInt$.prototype.constructor = $c_s_math_BigInt$;
/** @constructor */
function $h_s_math_BigInt$() {
  /*<skip>*/
}
$h_s_math_BigInt$.prototype = $c_s_math_BigInt$.prototype;
$c_s_math_BigInt$.prototype.init___ = (function() {
  $n_s_math_BigInt$ = this;
  this.minCached$1 = (-1024);
  this.maxCached$1 = 1024;
  this.cache$1 = $newArrayObject($d_s_math_BigInt.getArrayOf(), [((1 + ((this.maxCached$1 - this.minCached$1) | 0)) | 0)]);
  this.scala$math$BigInt$$minusOne$1 = $m_Ljava_math_BigInteger$().valueOf__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I((-1), (-1)));
  return this
});
$c_s_math_BigInt$.prototype.apply__I__s_math_BigInt = (function(i) {
  if (((this.minCached$1 <= i) && (i <= this.maxCached$1))) {
    var offset = ((i - this.minCached$1) | 0);
    var n = this.cache$1.get(offset);
    if ((n === null)) {
      var jsx$1 = $m_Ljava_math_BigInteger$();
      var hi = (i >> 31);
      n = new $c_s_math_BigInt().init___Ljava_math_BigInteger(jsx$1.valueOf__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(i, hi)));
      this.cache$1.set(offset, n)
    };
    return n
  } else {
    var jsx$2 = $m_Ljava_math_BigInteger$();
    var hi$1 = (i >> 31);
    return new $c_s_math_BigInt().init___Ljava_math_BigInteger(jsx$2.valueOf__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(i, hi$1)))
  }
});
$c_s_math_BigInt$.prototype.apply__T__I__s_math_BigInt = (function(x, radix) {
  return new $c_s_math_BigInt().init___Ljava_math_BigInteger(new $c_Ljava_math_BigInteger().init___T__I(x, radix))
});
$c_s_math_BigInt$.prototype.apply__J__s_math_BigInt = (function(l) {
  var value = this.minCached$1;
  var hi = (value >> 31);
  var bhi = l.hi$2;
  if (((hi === bhi) ? (((-2147483648) ^ value) <= ((-2147483648) ^ l.lo$2)) : (hi < bhi))) {
    var value$1 = this.maxCached$1;
    var hi$1 = (value$1 >> 31);
    var ahi = l.hi$2;
    var jsx$1 = ((ahi === hi$1) ? (((-2147483648) ^ l.lo$2) <= ((-2147483648) ^ value$1)) : (ahi < hi$1))
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return this.apply__I__s_math_BigInt(l.lo$2)
  } else {
    return new $c_s_math_BigInt().init___Ljava_math_BigInteger($m_Ljava_math_BigInteger$().valueOf__J__Ljava_math_BigInteger(l))
  }
});
$c_s_math_BigInt$.prototype.apply__T__s_math_BigInt = (function(x) {
  return new $c_s_math_BigInt().init___Ljava_math_BigInteger(new $c_Ljava_math_BigInteger().init___T(x))
});
var $d_s_math_BigInt$ = new $TypeData().initClass({
  s_math_BigInt$: 0
}, false, "scala.math.BigInt$", {
  s_math_BigInt$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_math_BigInt$.prototype.$classData = $d_s_math_BigInt$;
var $n_s_math_BigInt$ = (void 0);
function $m_s_math_BigInt$() {
  if ((!$n_s_math_BigInt$)) {
    $n_s_math_BigInt$ = new $c_s_math_BigInt$().init___()
  };
  return $n_s_math_BigInt$
}
/** @constructor */
function $c_s_math_Fractional$() {
  $c_O.call(this)
}
$c_s_math_Fractional$.prototype = new $h_O();
$c_s_math_Fractional$.prototype.constructor = $c_s_math_Fractional$;
/** @constructor */
function $h_s_math_Fractional$() {
  /*<skip>*/
}
$h_s_math_Fractional$.prototype = $c_s_math_Fractional$.prototype;
$c_s_math_Fractional$.prototype.init___ = (function() {
  return this
});
var $d_s_math_Fractional$ = new $TypeData().initClass({
  s_math_Fractional$: 0
}, false, "scala.math.Fractional$", {
  s_math_Fractional$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_math_Fractional$.prototype.$classData = $d_s_math_Fractional$;
var $n_s_math_Fractional$ = (void 0);
function $m_s_math_Fractional$() {
  if ((!$n_s_math_Fractional$)) {
    $n_s_math_Fractional$ = new $c_s_math_Fractional$().init___()
  };
  return $n_s_math_Fractional$
}
/** @constructor */
function $c_s_math_Integral$() {
  $c_O.call(this)
}
$c_s_math_Integral$.prototype = new $h_O();
$c_s_math_Integral$.prototype.constructor = $c_s_math_Integral$;
/** @constructor */
function $h_s_math_Integral$() {
  /*<skip>*/
}
$h_s_math_Integral$.prototype = $c_s_math_Integral$.prototype;
$c_s_math_Integral$.prototype.init___ = (function() {
  return this
});
var $d_s_math_Integral$ = new $TypeData().initClass({
  s_math_Integral$: 0
}, false, "scala.math.Integral$", {
  s_math_Integral$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_math_Integral$.prototype.$classData = $d_s_math_Integral$;
var $n_s_math_Integral$ = (void 0);
function $m_s_math_Integral$() {
  if ((!$n_s_math_Integral$)) {
    $n_s_math_Integral$ = new $c_s_math_Integral$().init___()
  };
  return $n_s_math_Integral$
}
/** @constructor */
function $c_s_math_Numeric$() {
  $c_O.call(this)
}
$c_s_math_Numeric$.prototype = new $h_O();
$c_s_math_Numeric$.prototype.constructor = $c_s_math_Numeric$;
/** @constructor */
function $h_s_math_Numeric$() {
  /*<skip>*/
}
$h_s_math_Numeric$.prototype = $c_s_math_Numeric$.prototype;
$c_s_math_Numeric$.prototype.init___ = (function() {
  return this
});
var $d_s_math_Numeric$ = new $TypeData().initClass({
  s_math_Numeric$: 0
}, false, "scala.math.Numeric$", {
  s_math_Numeric$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_math_Numeric$.prototype.$classData = $d_s_math_Numeric$;
var $n_s_math_Numeric$ = (void 0);
function $m_s_math_Numeric$() {
  if ((!$n_s_math_Numeric$)) {
    $n_s_math_Numeric$ = new $c_s_math_Numeric$().init___()
  };
  return $n_s_math_Numeric$
}
/** @constructor */
function $c_s_math_ScalaNumber() {
  $c_jl_Number.call(this)
}
$c_s_math_ScalaNumber.prototype = new $h_jl_Number();
$c_s_math_ScalaNumber.prototype.constructor = $c_s_math_ScalaNumber;
/** @constructor */
function $h_s_math_ScalaNumber() {
  /*<skip>*/
}
$h_s_math_ScalaNumber.prototype = $c_s_math_ScalaNumber.prototype;
function $as_s_math_ScalaNumber(obj) {
  return (((obj instanceof $c_s_math_ScalaNumber) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.math.ScalaNumber"))
}
function $isArrayOf_s_math_ScalaNumber(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_math_ScalaNumber)))
}
function $asArrayOf_s_math_ScalaNumber(obj, depth) {
  return (($isArrayOf_s_math_ScalaNumber(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.math.ScalaNumber;", depth))
}
/** @constructor */
function $c_s_reflect_ClassTag$() {
  $c_O.call(this)
}
$c_s_reflect_ClassTag$.prototype = new $h_O();
$c_s_reflect_ClassTag$.prototype.constructor = $c_s_reflect_ClassTag$;
/** @constructor */
function $h_s_reflect_ClassTag$() {
  /*<skip>*/
}
$h_s_reflect_ClassTag$.prototype = $c_s_reflect_ClassTag$.prototype;
$c_s_reflect_ClassTag$.prototype.init___ = (function() {
  return this
});
$c_s_reflect_ClassTag$.prototype.apply__jl_Class__s_reflect_ClassTag = (function(runtimeClass1) {
  return ((runtimeClass1 === $d_B.getClassOf()) ? $m_s_reflect_ManifestFactory$ByteManifest$() : ((runtimeClass1 === $d_S.getClassOf()) ? $m_s_reflect_ManifestFactory$ShortManifest$() : ((runtimeClass1 === $d_C.getClassOf()) ? $m_s_reflect_ManifestFactory$CharManifest$() : ((runtimeClass1 === $d_I.getClassOf()) ? $m_s_reflect_ManifestFactory$IntManifest$() : ((runtimeClass1 === $d_J.getClassOf()) ? $m_s_reflect_ManifestFactory$LongManifest$() : ((runtimeClass1 === $d_F.getClassOf()) ? $m_s_reflect_ManifestFactory$FloatManifest$() : ((runtimeClass1 === $d_D.getClassOf()) ? $m_s_reflect_ManifestFactory$DoubleManifest$() : ((runtimeClass1 === $d_Z.getClassOf()) ? $m_s_reflect_ManifestFactory$BooleanManifest$() : ((runtimeClass1 === $d_V.getClassOf()) ? $m_s_reflect_ManifestFactory$UnitManifest$() : ((runtimeClass1 === $d_O.getClassOf()) ? $m_s_reflect_ManifestFactory$ObjectManifest$() : ((runtimeClass1 === $d_sr_Nothing$.getClassOf()) ? $m_s_reflect_ManifestFactory$NothingManifest$() : ((runtimeClass1 === $d_sr_Null$.getClassOf()) ? $m_s_reflect_ManifestFactory$NullManifest$() : new $c_s_reflect_ClassTag$GenericClassTag().init___jl_Class(runtimeClass1)))))))))))))
});
var $d_s_reflect_ClassTag$ = new $TypeData().initClass({
  s_reflect_ClassTag$: 0
}, false, "scala.reflect.ClassTag$", {
  s_reflect_ClassTag$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_reflect_ClassTag$.prototype.$classData = $d_s_reflect_ClassTag$;
var $n_s_reflect_ClassTag$ = (void 0);
function $m_s_reflect_ClassTag$() {
  if ((!$n_s_reflect_ClassTag$)) {
    $n_s_reflect_ClassTag$ = new $c_s_reflect_ClassTag$().init___()
  };
  return $n_s_reflect_ClassTag$
}
/** @constructor */
function $c_s_util_Either$() {
  $c_O.call(this)
}
$c_s_util_Either$.prototype = new $h_O();
$c_s_util_Either$.prototype.constructor = $c_s_util_Either$;
/** @constructor */
function $h_s_util_Either$() {
  /*<skip>*/
}
$h_s_util_Either$.prototype = $c_s_util_Either$.prototype;
$c_s_util_Either$.prototype.init___ = (function() {
  return this
});
var $d_s_util_Either$ = new $TypeData().initClass({
  s_util_Either$: 0
}, false, "scala.util.Either$", {
  s_util_Either$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_util_Either$.prototype.$classData = $d_s_util_Either$;
var $n_s_util_Either$ = (void 0);
function $m_s_util_Either$() {
  if ((!$n_s_util_Either$)) {
    $n_s_util_Either$ = new $c_s_util_Either$().init___()
  };
  return $n_s_util_Either$
}
/** @constructor */
function $c_s_util_Left$() {
  $c_O.call(this)
}
$c_s_util_Left$.prototype = new $h_O();
$c_s_util_Left$.prototype.constructor = $c_s_util_Left$;
/** @constructor */
function $h_s_util_Left$() {
  /*<skip>*/
}
$h_s_util_Left$.prototype = $c_s_util_Left$.prototype;
$c_s_util_Left$.prototype.init___ = (function() {
  return this
});
$c_s_util_Left$.prototype.toString__T = (function() {
  return "Left"
});
var $d_s_util_Left$ = new $TypeData().initClass({
  s_util_Left$: 0
}, false, "scala.util.Left$", {
  s_util_Left$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_util_Left$.prototype.$classData = $d_s_util_Left$;
var $n_s_util_Left$ = (void 0);
function $m_s_util_Left$() {
  if ((!$n_s_util_Left$)) {
    $n_s_util_Left$ = new $c_s_util_Left$().init___()
  };
  return $n_s_util_Left$
}
/** @constructor */
function $c_s_util_Right$() {
  $c_O.call(this)
}
$c_s_util_Right$.prototype = new $h_O();
$c_s_util_Right$.prototype.constructor = $c_s_util_Right$;
/** @constructor */
function $h_s_util_Right$() {
  /*<skip>*/
}
$h_s_util_Right$.prototype = $c_s_util_Right$.prototype;
$c_s_util_Right$.prototype.init___ = (function() {
  return this
});
$c_s_util_Right$.prototype.toString__T = (function() {
  return "Right"
});
var $d_s_util_Right$ = new $TypeData().initClass({
  s_util_Right$: 0
}, false, "scala.util.Right$", {
  s_util_Right$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_util_Right$.prototype.$classData = $d_s_util_Right$;
var $n_s_util_Right$ = (void 0);
function $m_s_util_Right$() {
  if ((!$n_s_util_Right$)) {
    $n_s_util_Right$ = new $c_s_util_Right$().init___()
  };
  return $n_s_util_Right$
}
/** @constructor */
function $c_s_util_control_NoStackTrace$() {
  $c_O.call(this);
  this.$$undnoSuppression$1 = false
}
$c_s_util_control_NoStackTrace$.prototype = new $h_O();
$c_s_util_control_NoStackTrace$.prototype.constructor = $c_s_util_control_NoStackTrace$;
/** @constructor */
function $h_s_util_control_NoStackTrace$() {
  /*<skip>*/
}
$h_s_util_control_NoStackTrace$.prototype = $c_s_util_control_NoStackTrace$.prototype;
$c_s_util_control_NoStackTrace$.prototype.init___ = (function() {
  this.$$undnoSuppression$1 = false;
  return this
});
var $d_s_util_control_NoStackTrace$ = new $TypeData().initClass({
  s_util_control_NoStackTrace$: 0
}, false, "scala.util.control.NoStackTrace$", {
  s_util_control_NoStackTrace$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_util_control_NoStackTrace$.prototype.$classData = $d_s_util_control_NoStackTrace$;
var $n_s_util_control_NoStackTrace$ = (void 0);
function $m_s_util_control_NoStackTrace$() {
  if ((!$n_s_util_control_NoStackTrace$)) {
    $n_s_util_control_NoStackTrace$ = new $c_s_util_control_NoStackTrace$().init___()
  };
  return $n_s_util_control_NoStackTrace$
}
/** @constructor */
function $c_s_util_matching_Regex() {
  $c_O.call(this);
  this.pattern$1 = null;
  this.scala$util$matching$Regex$$groupNames$f = null
}
$c_s_util_matching_Regex.prototype = new $h_O();
$c_s_util_matching_Regex.prototype.constructor = $c_s_util_matching_Regex;
/** @constructor */
function $h_s_util_matching_Regex() {
  /*<skip>*/
}
$h_s_util_matching_Regex.prototype = $c_s_util_matching_Regex.prototype;
$c_s_util_matching_Regex.prototype.init___T__sc_Seq = (function(regex, groupNames) {
  var this$1 = $m_ju_regex_Pattern$();
  $c_s_util_matching_Regex.prototype.init___ju_regex_Pattern__sc_Seq.call(this, this$1.compile__T__I__ju_regex_Pattern(regex, 0), groupNames);
  return this
});
$c_s_util_matching_Regex.prototype.findFirstIn__jl_CharSequence__s_Option = (function(source) {
  var this$1 = this.pattern$1;
  var m = new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$1, source, 0, $charSequenceLength(source));
  return (m.find__Z() ? new $c_s_Some().init___O(m.group__T()) : $m_s_None$())
});
$c_s_util_matching_Regex.prototype.init___ju_regex_Pattern__sc_Seq = (function(pattern, groupNames) {
  this.pattern$1 = pattern;
  this.scala$util$matching$Regex$$groupNames$f = groupNames;
  return this
});
$c_s_util_matching_Regex.prototype.toString__T = (function() {
  return this.pattern$1.$$undpattern$1
});
$c_s_util_matching_Regex.prototype.unapplySeq__jl_CharSequence__s_Option = (function(s) {
  if ((s === null)) {
    return $m_s_None$()
  } else {
    var this$1 = this.pattern$1;
    var m = new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$1, s, 0, $charSequenceLength(s));
    return (m.matches__Z() ? $m_s_util_matching_Regex$().scala$util$matching$Regex$$extractGroupsFromMatcher__ju_regex_Matcher__s_Option(m) : $m_s_None$())
  }
});
$c_s_util_matching_Regex.prototype.findAllIn__jl_CharSequence__s_util_matching_Regex$MatchIterator = (function(source) {
  return new $c_s_util_matching_Regex$MatchIterator().init___jl_CharSequence__s_util_matching_Regex__sc_Seq(source, this, this.scala$util$matching$Regex$$groupNames$f)
});
$c_s_util_matching_Regex.prototype.findFirstMatchIn__jl_CharSequence__s_Option = (function(source) {
  var this$1 = this.pattern$1;
  var m = new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$1, source, 0, $charSequenceLength(source));
  return (m.find__Z() ? new $c_s_Some().init___O(new $c_s_util_matching_Regex$Match().init___jl_CharSequence__ju_regex_Matcher__sc_Seq(source, m, this.scala$util$matching$Regex$$groupNames$f)) : $m_s_None$())
});
$c_s_util_matching_Regex.prototype.findAllMatchIn__jl_CharSequence__sc_Iterator = (function(source) {
  var matchIterator = this.findAllIn__jl_CharSequence__s_util_matching_Regex$MatchIterator(source);
  return new $c_s_util_matching_Regex$$anon$1().init___s_util_matching_Regex__s_util_matching_Regex$MatchIterator(this, matchIterator)
});
var $d_s_util_matching_Regex = new $TypeData().initClass({
  s_util_matching_Regex: 0
}, false, "scala.util.matching.Regex", {
  s_util_matching_Regex: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_util_matching_Regex.prototype.$classData = $d_s_util_matching_Regex;
/** @constructor */
function $c_s_util_matching_Regex$() {
  $c_O.call(this)
}
$c_s_util_matching_Regex$.prototype = new $h_O();
$c_s_util_matching_Regex$.prototype.constructor = $c_s_util_matching_Regex$;
/** @constructor */
function $h_s_util_matching_Regex$() {
  /*<skip>*/
}
$h_s_util_matching_Regex$.prototype = $c_s_util_matching_Regex$.prototype;
$c_s_util_matching_Regex$.prototype.init___ = (function() {
  return this
});
$c_s_util_matching_Regex$.prototype.scala$util$matching$Regex$$extractGroupsFromMatcher__ju_regex_Matcher__s_Option = (function(m) {
  $m_sci_List$();
  var res = $m_sci_Nil$();
  var index = $m_ju_regex_Matcher$().java$util$regex$Matcher$$getGroupCount__sjs_js_RegExp$ExecResult__ju_regex_Pattern__I(m.lastMatch$1, m.pattern0$1);
  while ((index > 0)) {
    var this$2 = res;
    var x = m.group__I__T(index);
    res = new $c_sci_$colon$colon().init___O__sci_List(x, this$2);
    index = (((-1) + index) | 0)
  };
  return new $c_s_Some().init___O(res)
});
var $d_s_util_matching_Regex$ = new $TypeData().initClass({
  s_util_matching_Regex$: 0
}, false, "scala.util.matching.Regex$", {
  s_util_matching_Regex$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_util_matching_Regex$.prototype.$classData = $d_s_util_matching_Regex$;
var $n_s_util_matching_Regex$ = (void 0);
function $m_s_util_matching_Regex$() {
  if ((!$n_s_util_matching_Regex$)) {
    $n_s_util_matching_Regex$ = new $c_s_util_matching_Regex$().init___()
  };
  return $n_s_util_matching_Regex$
}
/** @constructor */
function $c_sc_IndexedSeq$$anon$1() {
  $c_scg_GenTraversableFactory$GenericCanBuildFrom.call(this)
}
$c_sc_IndexedSeq$$anon$1.prototype = new $h_scg_GenTraversableFactory$GenericCanBuildFrom();
$c_sc_IndexedSeq$$anon$1.prototype.constructor = $c_sc_IndexedSeq$$anon$1;
/** @constructor */
function $h_sc_IndexedSeq$$anon$1() {
  /*<skip>*/
}
$h_sc_IndexedSeq$$anon$1.prototype = $c_sc_IndexedSeq$$anon$1.prototype;
$c_sc_IndexedSeq$$anon$1.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory$GenericCanBuildFrom.prototype.init___scg_GenTraversableFactory.call(this, $m_sc_IndexedSeq$());
  return this
});
$c_sc_IndexedSeq$$anon$1.prototype.apply__scm_Builder = (function() {
  $m_sc_IndexedSeq$();
  $m_sci_IndexedSeq$();
  $m_sci_Vector$();
  return new $c_sci_VectorBuilder().init___()
});
var $d_sc_IndexedSeq$$anon$1 = new $TypeData().initClass({
  sc_IndexedSeq$$anon$1: 0
}, false, "scala.collection.IndexedSeq$$anon$1", {
  sc_IndexedSeq$$anon$1: 1,
  scg_GenTraversableFactory$GenericCanBuildFrom: 1,
  O: 1,
  scg_CanBuildFrom: 1
});
$c_sc_IndexedSeq$$anon$1.prototype.$classData = $d_sc_IndexedSeq$$anon$1;
/** @constructor */
function $c_sc_Map$() {
  $c_scg_MapFactory.call(this)
}
$c_sc_Map$.prototype = new $h_scg_MapFactory();
$c_sc_Map$.prototype.constructor = $c_sc_Map$;
/** @constructor */
function $h_sc_Map$() {
  /*<skip>*/
}
$h_sc_Map$.prototype = $c_sc_Map$.prototype;
$c_sc_Map$.prototype.init___ = (function() {
  return this
});
$c_sc_Map$.prototype.empty__sc_GenMap = (function() {
  return $m_sci_Map$EmptyMap$()
});
var $d_sc_Map$ = new $TypeData().initClass({
  sc_Map$: 0
}, false, "scala.collection.Map$", {
  sc_Map$: 1,
  scg_MapFactory: 1,
  scg_GenMapFactory: 1,
  O: 1
});
$c_sc_Map$.prototype.$classData = $d_sc_Map$;
var $n_sc_Map$ = (void 0);
function $m_sc_Map$() {
  if ((!$n_sc_Map$)) {
    $n_sc_Map$ = new $c_sc_Map$().init___()
  };
  return $n_sc_Map$
}
/** @constructor */
function $c_sc_TraversableOnce$$anon$1() {
  $c_sr_AbstractFunction1.call(this)
}
$c_sc_TraversableOnce$$anon$1.prototype = new $h_sr_AbstractFunction1();
$c_sc_TraversableOnce$$anon$1.prototype.constructor = $c_sc_TraversableOnce$$anon$1;
/** @constructor */
function $h_sc_TraversableOnce$$anon$1() {
  /*<skip>*/
}
$h_sc_TraversableOnce$$anon$1.prototype = $c_sc_TraversableOnce$$anon$1.prototype;
$c_sc_TraversableOnce$$anon$1.prototype.apply__O__O = (function(v1) {
  return this
});
$c_sc_TraversableOnce$$anon$1.prototype.init___sc_TraversableOnce = (function($$outer) {
  return this
});
var $d_sc_TraversableOnce$$anon$1 = new $TypeData().initClass({
  sc_TraversableOnce$$anon$1: 0
}, false, "scala.collection.TraversableOnce$$anon$1", {
  sc_TraversableOnce$$anon$1: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1
});
$c_sc_TraversableOnce$$anon$1.prototype.$classData = $d_sc_TraversableOnce$$anon$1;
/** @constructor */
function $c_scg_GenSeqFactory() {
  $c_scg_GenTraversableFactory.call(this)
}
$c_scg_GenSeqFactory.prototype = new $h_scg_GenTraversableFactory();
$c_scg_GenSeqFactory.prototype.constructor = $c_scg_GenSeqFactory;
/** @constructor */
function $h_scg_GenSeqFactory() {
  /*<skip>*/
}
$h_scg_GenSeqFactory.prototype = $c_scg_GenSeqFactory.prototype;
/** @constructor */
function $c_scg_GenTraversableFactory$$anon$1() {
  $c_scg_GenTraversableFactory$GenericCanBuildFrom.call(this);
  this.$$outer$2 = null
}
$c_scg_GenTraversableFactory$$anon$1.prototype = new $h_scg_GenTraversableFactory$GenericCanBuildFrom();
$c_scg_GenTraversableFactory$$anon$1.prototype.constructor = $c_scg_GenTraversableFactory$$anon$1;
/** @constructor */
function $h_scg_GenTraversableFactory$$anon$1() {
  /*<skip>*/
}
$h_scg_GenTraversableFactory$$anon$1.prototype = $c_scg_GenTraversableFactory$$anon$1.prototype;
$c_scg_GenTraversableFactory$$anon$1.prototype.apply__scm_Builder = (function() {
  return this.$$outer$2.newBuilder__scm_Builder()
});
$c_scg_GenTraversableFactory$$anon$1.prototype.init___scg_GenTraversableFactory = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  $c_scg_GenTraversableFactory$GenericCanBuildFrom.prototype.init___scg_GenTraversableFactory.call(this, $$outer);
  return this
});
var $d_scg_GenTraversableFactory$$anon$1 = new $TypeData().initClass({
  scg_GenTraversableFactory$$anon$1: 0
}, false, "scala.collection.generic.GenTraversableFactory$$anon$1", {
  scg_GenTraversableFactory$$anon$1: 1,
  scg_GenTraversableFactory$GenericCanBuildFrom: 1,
  O: 1,
  scg_CanBuildFrom: 1
});
$c_scg_GenTraversableFactory$$anon$1.prototype.$classData = $d_scg_GenTraversableFactory$$anon$1;
/** @constructor */
function $c_scg_ImmutableMapFactory() {
  $c_scg_MapFactory.call(this)
}
$c_scg_ImmutableMapFactory.prototype = new $h_scg_MapFactory();
$c_scg_ImmutableMapFactory.prototype.constructor = $c_scg_ImmutableMapFactory;
/** @constructor */
function $h_scg_ImmutableMapFactory() {
  /*<skip>*/
}
$h_scg_ImmutableMapFactory.prototype = $c_scg_ImmutableMapFactory.prototype;
/** @constructor */
function $c_scg_MutableMapFactory() {
  $c_scg_MapFactory.call(this)
}
$c_scg_MutableMapFactory.prototype = new $h_scg_MapFactory();
$c_scg_MutableMapFactory.prototype.constructor = $c_scg_MutableMapFactory;
/** @constructor */
function $h_scg_MutableMapFactory() {
  /*<skip>*/
}
$h_scg_MutableMapFactory.prototype = $c_scg_MutableMapFactory.prototype;
$c_scg_MutableMapFactory.prototype.newBuilder__scm_Builder = (function() {
  return $as_scm_Builder(this.empty__sc_Map())
});
/** @constructor */
function $c_sci_$colon$colon$() {
  $c_O.call(this)
}
$c_sci_$colon$colon$.prototype = new $h_O();
$c_sci_$colon$colon$.prototype.constructor = $c_sci_$colon$colon$;
/** @constructor */
function $h_sci_$colon$colon$() {
  /*<skip>*/
}
$h_sci_$colon$colon$.prototype = $c_sci_$colon$colon$.prototype;
$c_sci_$colon$colon$.prototype.init___ = (function() {
  return this
});
$c_sci_$colon$colon$.prototype.toString__T = (function() {
  return "::"
});
var $d_sci_$colon$colon$ = new $TypeData().initClass({
  sci_$colon$colon$: 0
}, false, "scala.collection.immutable.$colon$colon$", {
  sci_$colon$colon$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_$colon$colon$.prototype.$classData = $d_sci_$colon$colon$;
var $n_sci_$colon$colon$ = (void 0);
function $m_sci_$colon$colon$() {
  if ((!$n_sci_$colon$colon$)) {
    $n_sci_$colon$colon$ = new $c_sci_$colon$colon$().init___()
  };
  return $n_sci_$colon$colon$
}
/** @constructor */
function $c_sci_Range$() {
  $c_O.call(this);
  this.MAX$undPRINT$1 = 0
}
$c_sci_Range$.prototype = new $h_O();
$c_sci_Range$.prototype.constructor = $c_sci_Range$;
/** @constructor */
function $h_sci_Range$() {
  /*<skip>*/
}
$h_sci_Range$.prototype = $c_sci_Range$.prototype;
$c_sci_Range$.prototype.init___ = (function() {
  this.MAX$undPRINT$1 = 512;
  return this
});
$c_sci_Range$.prototype.description__p1__I__I__I__Z__T = (function(start, end, step, isInclusive) {
  return ((((start + (isInclusive ? " to " : " until ")) + end) + " by ") + step)
});
$c_sci_Range$.prototype.scala$collection$immutable$Range$$fail__I__I__I__Z__sr_Nothing$ = (function(start, end, step, isInclusive) {
  throw new $c_jl_IllegalArgumentException().init___T((this.description__p1__I__I__I__Z__T(start, end, step, isInclusive) + ": seqs cannot contain more than Int.MaxValue elements."))
});
var $d_sci_Range$ = new $TypeData().initClass({
  sci_Range$: 0
}, false, "scala.collection.immutable.Range$", {
  sci_Range$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_Range$.prototype.$classData = $d_sci_Range$;
var $n_sci_Range$ = (void 0);
function $m_sci_Range$() {
  if ((!$n_sci_Range$)) {
    $n_sci_Range$ = new $c_sci_Range$().init___()
  };
  return $n_sci_Range$
}
/** @constructor */
function $c_sci_RedBlackTree$Tree() {
  $c_O.call(this);
  this.key$1 = null;
  this.value$1 = null;
  this.left$1 = null;
  this.right$1 = null;
  this.count$1 = 0
}
$c_sci_RedBlackTree$Tree.prototype = new $h_O();
$c_sci_RedBlackTree$Tree.prototype.constructor = $c_sci_RedBlackTree$Tree;
/** @constructor */
function $h_sci_RedBlackTree$Tree() {
  /*<skip>*/
}
$h_sci_RedBlackTree$Tree.prototype = $c_sci_RedBlackTree$Tree.prototype;
$c_sci_RedBlackTree$Tree.prototype.init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree = (function(key, value, left, right) {
  this.key$1 = key;
  this.value$1 = value;
  this.left$1 = left;
  this.right$1 = right;
  this.count$1 = ((((1 + $m_sci_RedBlackTree$().count__sci_RedBlackTree$Tree__I(left)) | 0) + $m_sci_RedBlackTree$().count__sci_RedBlackTree$Tree__I(right)) | 0);
  return this
});
function $as_sci_RedBlackTree$Tree(obj) {
  return (((obj instanceof $c_sci_RedBlackTree$Tree) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.RedBlackTree$Tree"))
}
function $isArrayOf_sci_RedBlackTree$Tree(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_RedBlackTree$Tree)))
}
function $asArrayOf_sci_RedBlackTree$Tree(obj, depth) {
  return (($isArrayOf_sci_RedBlackTree$Tree(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.RedBlackTree$Tree;", depth))
}
var $d_sci_RedBlackTree$Tree = new $TypeData().initClass({
  sci_RedBlackTree$Tree: 0
}, false, "scala.collection.immutable.RedBlackTree$Tree", {
  sci_RedBlackTree$Tree: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_RedBlackTree$Tree.prototype.$classData = $d_sci_RedBlackTree$Tree;
/** @constructor */
function $c_sci_Stream$StreamCanBuildFrom() {
  $c_scg_GenTraversableFactory$GenericCanBuildFrom.call(this)
}
$c_sci_Stream$StreamCanBuildFrom.prototype = new $h_scg_GenTraversableFactory$GenericCanBuildFrom();
$c_sci_Stream$StreamCanBuildFrom.prototype.constructor = $c_sci_Stream$StreamCanBuildFrom;
/** @constructor */
function $h_sci_Stream$StreamCanBuildFrom() {
  /*<skip>*/
}
$h_sci_Stream$StreamCanBuildFrom.prototype = $c_sci_Stream$StreamCanBuildFrom.prototype;
$c_sci_Stream$StreamCanBuildFrom.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory$GenericCanBuildFrom.prototype.init___scg_GenTraversableFactory.call(this, $m_sci_Stream$());
  return this
});
var $d_sci_Stream$StreamCanBuildFrom = new $TypeData().initClass({
  sci_Stream$StreamCanBuildFrom: 0
}, false, "scala.collection.immutable.Stream$StreamCanBuildFrom", {
  sci_Stream$StreamCanBuildFrom: 1,
  scg_GenTraversableFactory$GenericCanBuildFrom: 1,
  O: 1,
  scg_CanBuildFrom: 1
});
$c_sci_Stream$StreamCanBuildFrom.prototype.$classData = $d_sci_Stream$StreamCanBuildFrom;
/** @constructor */
function $c_scm_StringBuilder$() {
  $c_O.call(this)
}
$c_scm_StringBuilder$.prototype = new $h_O();
$c_scm_StringBuilder$.prototype.constructor = $c_scm_StringBuilder$;
/** @constructor */
function $h_scm_StringBuilder$() {
  /*<skip>*/
}
$h_scm_StringBuilder$.prototype = $c_scm_StringBuilder$.prototype;
$c_scm_StringBuilder$.prototype.init___ = (function() {
  return this
});
var $d_scm_StringBuilder$ = new $TypeData().initClass({
  scm_StringBuilder$: 0
}, false, "scala.collection.mutable.StringBuilder$", {
  scm_StringBuilder$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_StringBuilder$.prototype.$classData = $d_scm_StringBuilder$;
var $n_scm_StringBuilder$ = (void 0);
function $m_scm_StringBuilder$() {
  if ((!$n_scm_StringBuilder$)) {
    $n_scm_StringBuilder$ = new $c_scm_StringBuilder$().init___()
  };
  return $n_scm_StringBuilder$
}
/** @constructor */
function $c_sjsr_AnonFunction0() {
  $c_sr_AbstractFunction0.call(this);
  this.f$2 = null
}
$c_sjsr_AnonFunction0.prototype = new $h_sr_AbstractFunction0();
$c_sjsr_AnonFunction0.prototype.constructor = $c_sjsr_AnonFunction0;
/** @constructor */
function $h_sjsr_AnonFunction0() {
  /*<skip>*/
}
$h_sjsr_AnonFunction0.prototype = $c_sjsr_AnonFunction0.prototype;
$c_sjsr_AnonFunction0.prototype.apply__O = (function() {
  return (0, this.f$2)()
});
$c_sjsr_AnonFunction0.prototype.init___sjs_js_Function0 = (function(f) {
  this.f$2 = f;
  return this
});
var $d_sjsr_AnonFunction0 = new $TypeData().initClass({
  sjsr_AnonFunction0: 0
}, false, "scala.scalajs.runtime.AnonFunction0", {
  sjsr_AnonFunction0: 1,
  sr_AbstractFunction0: 1,
  O: 1,
  F0: 1
});
$c_sjsr_AnonFunction0.prototype.$classData = $d_sjsr_AnonFunction0;
/** @constructor */
function $c_sjsr_AnonFunction1() {
  $c_sr_AbstractFunction1.call(this);
  this.f$2 = null
}
$c_sjsr_AnonFunction1.prototype = new $h_sr_AbstractFunction1();
$c_sjsr_AnonFunction1.prototype.constructor = $c_sjsr_AnonFunction1;
/** @constructor */
function $h_sjsr_AnonFunction1() {
  /*<skip>*/
}
$h_sjsr_AnonFunction1.prototype = $c_sjsr_AnonFunction1.prototype;
$c_sjsr_AnonFunction1.prototype.apply__O__O = (function(arg1) {
  return (0, this.f$2)(arg1)
});
$c_sjsr_AnonFunction1.prototype.init___sjs_js_Function1 = (function(f) {
  this.f$2 = f;
  return this
});
var $d_sjsr_AnonFunction1 = new $TypeData().initClass({
  sjsr_AnonFunction1: 0
}, false, "scala.scalajs.runtime.AnonFunction1", {
  sjsr_AnonFunction1: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1
});
$c_sjsr_AnonFunction1.prototype.$classData = $d_sjsr_AnonFunction1;
/** @constructor */
function $c_sjsr_AnonFunction2() {
  $c_sr_AbstractFunction2.call(this);
  this.f$2 = null
}
$c_sjsr_AnonFunction2.prototype = new $h_sr_AbstractFunction2();
$c_sjsr_AnonFunction2.prototype.constructor = $c_sjsr_AnonFunction2;
/** @constructor */
function $h_sjsr_AnonFunction2() {
  /*<skip>*/
}
$h_sjsr_AnonFunction2.prototype = $c_sjsr_AnonFunction2.prototype;
$c_sjsr_AnonFunction2.prototype.init___sjs_js_Function2 = (function(f) {
  this.f$2 = f;
  return this
});
$c_sjsr_AnonFunction2.prototype.apply__O__O__O = (function(arg1, arg2) {
  return (0, this.f$2)(arg1, arg2)
});
var $d_sjsr_AnonFunction2 = new $TypeData().initClass({
  sjsr_AnonFunction2: 0
}, false, "scala.scalajs.runtime.AnonFunction2", {
  sjsr_AnonFunction2: 1,
  sr_AbstractFunction2: 1,
  O: 1,
  F2: 1
});
$c_sjsr_AnonFunction2.prototype.$classData = $d_sjsr_AnonFunction2;
/** @constructor */
function $c_sjsr_AnonFunction3() {
  $c_sr_AbstractFunction3.call(this);
  this.f$2 = null
}
$c_sjsr_AnonFunction3.prototype = new $h_sr_AbstractFunction3();
$c_sjsr_AnonFunction3.prototype.constructor = $c_sjsr_AnonFunction3;
/** @constructor */
function $h_sjsr_AnonFunction3() {
  /*<skip>*/
}
$h_sjsr_AnonFunction3.prototype = $c_sjsr_AnonFunction3.prototype;
$c_sjsr_AnonFunction3.prototype.init___sjs_js_Function3 = (function(f) {
  this.f$2 = f;
  return this
});
$c_sjsr_AnonFunction3.prototype.apply__O__O__O__O = (function(arg1, arg2, arg3) {
  return (0, this.f$2)(arg1, arg2, arg3)
});
var $d_sjsr_AnonFunction3 = new $TypeData().initClass({
  sjsr_AnonFunction3: 0
}, false, "scala.scalajs.runtime.AnonFunction3", {
  sjsr_AnonFunction3: 1,
  sr_AbstractFunction3: 1,
  O: 1,
  F3: 1
});
$c_sjsr_AnonFunction3.prototype.$classData = $d_sjsr_AnonFunction3;
/** @constructor */
function $c_sjsr_AnonFunction4() {
  $c_sr_AbstractFunction4.call(this);
  this.f$2 = null
}
$c_sjsr_AnonFunction4.prototype = new $h_sr_AbstractFunction4();
$c_sjsr_AnonFunction4.prototype.constructor = $c_sjsr_AnonFunction4;
/** @constructor */
function $h_sjsr_AnonFunction4() {
  /*<skip>*/
}
$h_sjsr_AnonFunction4.prototype = $c_sjsr_AnonFunction4.prototype;
$c_sjsr_AnonFunction4.prototype.apply__O__O__O__O__O = (function(arg1, arg2, arg3, arg4) {
  return (0, this.f$2)(arg1, arg2, arg3, arg4)
});
$c_sjsr_AnonFunction4.prototype.init___sjs_js_Function4 = (function(f) {
  this.f$2 = f;
  return this
});
var $d_sjsr_AnonFunction4 = new $TypeData().initClass({
  sjsr_AnonFunction4: 0
}, false, "scala.scalajs.runtime.AnonFunction4", {
  sjsr_AnonFunction4: 1,
  sr_AbstractFunction4: 1,
  O: 1,
  F4: 1
});
$c_sjsr_AnonFunction4.prototype.$classData = $d_sjsr_AnonFunction4;
/** @constructor */
function $c_sjsr_AnonFunction5() {
  $c_sr_AbstractFunction5.call(this);
  this.f$2 = null
}
$c_sjsr_AnonFunction5.prototype = new $h_sr_AbstractFunction5();
$c_sjsr_AnonFunction5.prototype.constructor = $c_sjsr_AnonFunction5;
/** @constructor */
function $h_sjsr_AnonFunction5() {
  /*<skip>*/
}
$h_sjsr_AnonFunction5.prototype = $c_sjsr_AnonFunction5.prototype;
$c_sjsr_AnonFunction5.prototype.init___sjs_js_Function5 = (function(f) {
  this.f$2 = f;
  return this
});
$c_sjsr_AnonFunction5.prototype.apply__O__O__O__O__O__O = (function(arg1, arg2, arg3, arg4, arg5) {
  return (0, this.f$2)(arg1, arg2, arg3, arg4, arg5)
});
var $d_sjsr_AnonFunction5 = new $TypeData().initClass({
  sjsr_AnonFunction5: 0
}, false, "scala.scalajs.runtime.AnonFunction5", {
  sjsr_AnonFunction5: 1,
  sr_AbstractFunction5: 1,
  O: 1,
  F5: 1
});
$c_sjsr_AnonFunction5.prototype.$classData = $d_sjsr_AnonFunction5;
/** @constructor */
function $c_sjsr_RuntimeLong$() {
  $c_O.call(this);
  this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = 0;
  this.Zero$1 = null
}
$c_sjsr_RuntimeLong$.prototype = new $h_O();
$c_sjsr_RuntimeLong$.prototype.constructor = $c_sjsr_RuntimeLong$;
/** @constructor */
function $h_sjsr_RuntimeLong$() {
  /*<skip>*/
}
$h_sjsr_RuntimeLong$.prototype = $c_sjsr_RuntimeLong$.prototype;
$c_sjsr_RuntimeLong$.prototype.init___ = (function() {
  $n_sjsr_RuntimeLong$ = this;
  this.Zero$1 = new $c_sjsr_RuntimeLong().init___I__I(0, 0);
  return this
});
$c_sjsr_RuntimeLong$.prototype.Zero__sjsr_RuntimeLong = (function() {
  return this.Zero$1
});
$c_sjsr_RuntimeLong$.prototype.toUnsignedString__p1__I__I__T = (function(lo, hi) {
  if ((((-2097152) & hi) === 0)) {
    var this$5 = ((4.294967296E9 * hi) + $uD((lo >>> 0)));
    return ("" + this$5)
  } else {
    return $as_T(this.unsignedDivModHelper__p1__I__I__I__I__I__sjs_js_$bar(lo, hi, 1000000000, 0, 2))
  }
});
$c_sjsr_RuntimeLong$.prototype.divideImpl__I__I__I__I__I = (function(alo, ahi, blo, bhi) {
  if (((blo | bhi) === 0)) {
    throw new $c_jl_ArithmeticException().init___T("/ by zero")
  };
  if ((ahi === (alo >> 31))) {
    if ((bhi === (blo >> 31))) {
      if (((alo === (-2147483648)) && (blo === (-1)))) {
        this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = 0;
        return (-2147483648)
      } else {
        var lo = ((alo / blo) | 0);
        this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = (lo >> 31);
        return lo
      }
    } else if (((alo === (-2147483648)) && ((blo === (-2147483648)) && (bhi === 0)))) {
      this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = (-1);
      return (-1)
    } else {
      this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = 0;
      return 0
    }
  } else {
    var neg = (ahi < 0);
    if (neg) {
      var lo$1 = ((-alo) | 0);
      var hi = ((alo !== 0) ? (~ahi) : ((-ahi) | 0));
      var abs_$_lo$2 = lo$1;
      var abs_$_hi$2 = hi
    } else {
      var abs_$_lo$2 = alo;
      var abs_$_hi$2 = ahi
    };
    var neg$1 = (bhi < 0);
    if (neg$1) {
      var lo$2 = ((-blo) | 0);
      var hi$1 = ((blo !== 0) ? (~bhi) : ((-bhi) | 0));
      var abs$1_$_lo$2 = lo$2;
      var abs$1_$_hi$2 = hi$1
    } else {
      var abs$1_$_lo$2 = blo;
      var abs$1_$_hi$2 = bhi
    };
    var absRLo = this.unsigned$und$div__p1__I__I__I__I__I(abs_$_lo$2, abs_$_hi$2, abs$1_$_lo$2, abs$1_$_hi$2);
    if ((neg === neg$1)) {
      return absRLo
    } else {
      var hi$2 = this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
      this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = ((absRLo !== 0) ? (~hi$2) : ((-hi$2) | 0));
      return ((-absRLo) | 0)
    }
  }
});
$c_sjsr_RuntimeLong$.prototype.scala$scalajs$runtime$RuntimeLong$$toDouble__I__I__D = (function(lo, hi) {
  if ((hi < 0)) {
    var x = ((lo !== 0) ? (~hi) : ((-hi) | 0));
    var jsx$1 = $uD((x >>> 0));
    var x$1 = ((-lo) | 0);
    return (-((4.294967296E9 * jsx$1) + $uD((x$1 >>> 0))))
  } else {
    return ((4.294967296E9 * hi) + $uD((lo >>> 0)))
  }
});
$c_sjsr_RuntimeLong$.prototype.fromDouble__D__sjsr_RuntimeLong = (function(value) {
  var lo = this.scala$scalajs$runtime$RuntimeLong$$fromDoubleImpl__D__I(value);
  return new $c_sjsr_RuntimeLong().init___I__I(lo, this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f)
});
$c_sjsr_RuntimeLong$.prototype.scala$scalajs$runtime$RuntimeLong$$fromDoubleImpl__D__I = (function(value) {
  if ((value < (-9.223372036854776E18))) {
    this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = (-2147483648);
    return 0
  } else if ((value >= 9.223372036854776E18)) {
    this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = 2147483647;
    return (-1)
  } else {
    var rawLo = $uI((value | 0));
    var x = (value / 4.294967296E9);
    var rawHi = $uI((x | 0));
    this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = (((value < 0) && (rawLo !== 0)) ? (((-1) + rawHi) | 0) : rawHi);
    return rawLo
  }
});
$c_sjsr_RuntimeLong$.prototype.unsigned$und$div__p1__I__I__I__I__I = (function(alo, ahi, blo, bhi) {
  if ((((-2097152) & ahi) === 0)) {
    if ((((-2097152) & bhi) === 0)) {
      var aDouble = ((4.294967296E9 * ahi) + $uD((alo >>> 0)));
      var bDouble = ((4.294967296E9 * bhi) + $uD((blo >>> 0)));
      var rDouble = (aDouble / bDouble);
      var x = (rDouble / 4.294967296E9);
      this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = $uI((x | 0));
      return $uI((rDouble | 0))
    } else {
      this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = 0;
      return 0
    }
  } else if (((bhi === 0) && ((blo & (((-1) + blo) | 0)) === 0))) {
    var pow = ((31 - $clz32(blo)) | 0);
    this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = ((ahi >>> pow) | 0);
    return (((alo >>> pow) | 0) | ((ahi << 1) << ((31 - pow) | 0)))
  } else if (((blo === 0) && ((bhi & (((-1) + bhi) | 0)) === 0))) {
    var pow$2 = ((31 - $clz32(bhi)) | 0);
    this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = 0;
    return ((ahi >>> pow$2) | 0)
  } else {
    return $uI(this.unsignedDivModHelper__p1__I__I__I__I__I__sjs_js_$bar(alo, ahi, blo, bhi, 0))
  }
});
$c_sjsr_RuntimeLong$.prototype.divideUnsignedImpl__I__I__I__I__I = (function(alo, ahi, blo, bhi) {
  if (((blo | bhi) === 0)) {
    throw new $c_jl_ArithmeticException().init___T("/ by zero")
  };
  if ((ahi === 0)) {
    if ((bhi === 0)) {
      this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = 0;
      var n = ($uD((alo >>> 0)) / $uD((blo >>> 0)));
      return $uI((n | 0))
    } else {
      this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = 0;
      return 0
    }
  } else {
    return this.unsigned$und$div__p1__I__I__I__I__I(alo, ahi, blo, bhi)
  }
});
$c_sjsr_RuntimeLong$.prototype.scala$scalajs$runtime$RuntimeLong$$toString__I__I__T = (function(lo, hi) {
  return ((hi === (lo >> 31)) ? ("" + lo) : ((hi < 0) ? ("-" + this.toUnsignedString__p1__I__I__T(((-lo) | 0), ((lo !== 0) ? (~hi) : ((-hi) | 0)))) : this.toUnsignedString__p1__I__I__T(lo, hi)))
});
$c_sjsr_RuntimeLong$.prototype.scala$scalajs$runtime$RuntimeLong$$compare__I__I__I__I__I = (function(alo, ahi, blo, bhi) {
  return ((ahi === bhi) ? ((alo === blo) ? 0 : ((((-2147483648) ^ alo) < ((-2147483648) ^ blo)) ? (-1) : 1)) : ((ahi < bhi) ? (-1) : 1))
});
$c_sjsr_RuntimeLong$.prototype.unsignedDivModHelper__p1__I__I__I__I__I__sjs_js_$bar = (function(alo, ahi, blo, bhi, ask) {
  var shift = ((((bhi !== 0) ? $clz32(bhi) : ((32 + $clz32(blo)) | 0)) - ((ahi !== 0) ? $clz32(ahi) : ((32 + $clz32(alo)) | 0))) | 0);
  var n = shift;
  var lo = (((32 & n) === 0) ? (blo << n) : 0);
  var hi = (((32 & n) === 0) ? (((((blo >>> 1) | 0) >>> ((31 - n) | 0)) | 0) | (bhi << n)) : (blo << n));
  var bShiftLo = lo;
  var bShiftHi = hi;
  var remLo = alo;
  var remHi = ahi;
  var quotLo = 0;
  var quotHi = 0;
  while (((shift >= 0) && (((-2097152) & remHi) !== 0))) {
    var alo$1 = remLo;
    var ahi$1 = remHi;
    var blo$1 = bShiftLo;
    var bhi$1 = bShiftHi;
    if (((ahi$1 === bhi$1) ? (((-2147483648) ^ alo$1) >= ((-2147483648) ^ blo$1)) : (((-2147483648) ^ ahi$1) >= ((-2147483648) ^ bhi$1)))) {
      var lo$1 = remLo;
      var hi$1 = remHi;
      var lo$2 = bShiftLo;
      var hi$2 = bShiftHi;
      var lo$3 = ((lo$1 - lo$2) | 0);
      var hi$3 = ((((-2147483648) ^ lo$3) > ((-2147483648) ^ lo$1)) ? (((-1) + ((hi$1 - hi$2) | 0)) | 0) : ((hi$1 - hi$2) | 0));
      remLo = lo$3;
      remHi = hi$3;
      if ((shift < 32)) {
        quotLo = (quotLo | (1 << shift))
      } else {
        quotHi = (quotHi | (1 << shift))
      }
    };
    shift = (((-1) + shift) | 0);
    var lo$4 = bShiftLo;
    var hi$4 = bShiftHi;
    var lo$5 = (((lo$4 >>> 1) | 0) | (hi$4 << 31));
    var hi$5 = ((hi$4 >>> 1) | 0);
    bShiftLo = lo$5;
    bShiftHi = hi$5
  };
  var alo$2 = remLo;
  var ahi$2 = remHi;
  if (((ahi$2 === bhi) ? (((-2147483648) ^ alo$2) >= ((-2147483648) ^ blo)) : (((-2147483648) ^ ahi$2) >= ((-2147483648) ^ bhi)))) {
    var lo$6 = remLo;
    var hi$6 = remHi;
    var remDouble = ((4.294967296E9 * hi$6) + $uD((lo$6 >>> 0)));
    var bDouble = ((4.294967296E9 * bhi) + $uD((blo >>> 0)));
    if ((ask !== 1)) {
      var x = (remDouble / bDouble);
      var lo$7 = $uI((x | 0));
      var x$1 = (x / 4.294967296E9);
      var hi$7 = $uI((x$1 | 0));
      var lo$8 = quotLo;
      var hi$8 = quotHi;
      var lo$9 = ((lo$8 + lo$7) | 0);
      var hi$9 = ((((-2147483648) ^ lo$9) < ((-2147483648) ^ lo$8)) ? ((1 + ((hi$8 + hi$7) | 0)) | 0) : ((hi$8 + hi$7) | 0));
      quotLo = lo$9;
      quotHi = hi$9
    };
    if ((ask !== 0)) {
      var rem_mod_bDouble = (remDouble % bDouble);
      remLo = $uI((rem_mod_bDouble | 0));
      var x$2 = (rem_mod_bDouble / 4.294967296E9);
      remHi = $uI((x$2 | 0))
    }
  };
  if ((ask === 0)) {
    this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = quotHi;
    var a = quotLo;
    return a
  } else if ((ask === 1)) {
    this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = remHi;
    var a$1 = remLo;
    return a$1
  } else {
    var lo$10 = quotLo;
    var hi$10 = quotHi;
    var quot = ((4.294967296E9 * hi$10) + $uD((lo$10 >>> 0)));
    var this$25 = remLo;
    var remStr = ("" + this$25);
    var a$2 = ((("" + quot) + $as_T("000000000".substring($uI(remStr.length)))) + remStr);
    return a$2
  }
});
$c_sjsr_RuntimeLong$.prototype.remainderImpl__I__I__I__I__I = (function(alo, ahi, blo, bhi) {
  if (((blo | bhi) === 0)) {
    throw new $c_jl_ArithmeticException().init___T("/ by zero")
  };
  if ((ahi === (alo >> 31))) {
    if ((bhi === (blo >> 31))) {
      if ((blo !== (-1))) {
        var lo = ((alo % blo) | 0);
        this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = (lo >> 31);
        return lo
      } else {
        this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = 0;
        return 0
      }
    } else if (((alo === (-2147483648)) && ((blo === (-2147483648)) && (bhi === 0)))) {
      this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = 0;
      return 0
    } else {
      this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = ahi;
      return alo
    }
  } else {
    var neg = (ahi < 0);
    if (neg) {
      var lo$1 = ((-alo) | 0);
      var hi = ((alo !== 0) ? (~ahi) : ((-ahi) | 0));
      var abs_$_lo$2 = lo$1;
      var abs_$_hi$2 = hi
    } else {
      var abs_$_lo$2 = alo;
      var abs_$_hi$2 = ahi
    };
    var neg$1 = (bhi < 0);
    if (neg$1) {
      var lo$2 = ((-blo) | 0);
      var hi$1 = ((blo !== 0) ? (~bhi) : ((-bhi) | 0));
      var abs$1_$_lo$2 = lo$2;
      var abs$1_$_hi$2 = hi$1
    } else {
      var abs$1_$_lo$2 = blo;
      var abs$1_$_hi$2 = bhi
    };
    var absRLo = this.unsigned$und$percent__p1__I__I__I__I__I(abs_$_lo$2, abs_$_hi$2, abs$1_$_lo$2, abs$1_$_hi$2);
    if (neg) {
      var hi$2 = this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
      this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = ((absRLo !== 0) ? (~hi$2) : ((-hi$2) | 0));
      return ((-absRLo) | 0)
    } else {
      return absRLo
    }
  }
});
$c_sjsr_RuntimeLong$.prototype.unsigned$und$percent__p1__I__I__I__I__I = (function(alo, ahi, blo, bhi) {
  if ((((-2097152) & ahi) === 0)) {
    if ((((-2097152) & bhi) === 0)) {
      var aDouble = ((4.294967296E9 * ahi) + $uD((alo >>> 0)));
      var bDouble = ((4.294967296E9 * bhi) + $uD((blo >>> 0)));
      var rDouble = (aDouble % bDouble);
      var x = (rDouble / 4.294967296E9);
      this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = $uI((x | 0));
      return $uI((rDouble | 0))
    } else {
      this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = ahi;
      return alo
    }
  } else if (((bhi === 0) && ((blo & (((-1) + blo) | 0)) === 0))) {
    this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = 0;
    return (alo & (((-1) + blo) | 0))
  } else if (((blo === 0) && ((bhi & (((-1) + bhi) | 0)) === 0))) {
    this.scala$scalajs$runtime$RuntimeLong$$hiReturn$f = (ahi & (((-1) + bhi) | 0));
    return alo
  } else {
    return $uI(this.unsignedDivModHelper__p1__I__I__I__I__I__sjs_js_$bar(alo, ahi, blo, bhi, 1))
  }
});
var $d_sjsr_RuntimeLong$ = new $TypeData().initClass({
  sjsr_RuntimeLong$: 0
}, false, "scala.scalajs.runtime.RuntimeLong$", {
  sjsr_RuntimeLong$: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sjsr_RuntimeLong$.prototype.$classData = $d_sjsr_RuntimeLong$;
var $n_sjsr_RuntimeLong$ = (void 0);
function $m_sjsr_RuntimeLong$() {
  if ((!$n_sjsr_RuntimeLong$)) {
    $n_sjsr_RuntimeLong$ = new $c_sjsr_RuntimeLong$().init___()
  };
  return $n_sjsr_RuntimeLong$
}
/** @constructor */
function $c_sr_AbstractPartialFunction() {
  $c_O.call(this)
}
$c_sr_AbstractPartialFunction.prototype = new $h_O();
$c_sr_AbstractPartialFunction.prototype.constructor = $c_sr_AbstractPartialFunction;
/** @constructor */
function $h_sr_AbstractPartialFunction() {
  /*<skip>*/
}
$h_sr_AbstractPartialFunction.prototype = $c_sr_AbstractPartialFunction.prototype;
$c_sr_AbstractPartialFunction.prototype.apply__O__O = (function(x) {
  return this.applyOrElse__O__F1__O(x, $m_s_PartialFunction$().empty$undpf$1)
});
$c_sr_AbstractPartialFunction.prototype.runWith__F1__F1 = (function(action) {
  return $f_s_PartialFunction__runWith__F1__F1(this, action)
});
$c_sr_AbstractPartialFunction.prototype.toString__T = (function() {
  return "<function1>"
});
$c_sr_AbstractPartialFunction.prototype.apply$mcZI$sp__I__Z = (function(x) {
  return $uZ(this.applyOrElse__O__F1__O(x, $m_s_PartialFunction$().empty$undpf$1))
});
var $d_sr_Nothing$ = new $TypeData().initClass({
  sr_Nothing$: 0
}, false, "scala.runtime.Nothing$", {
  sr_Nothing$: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
/** @constructor */
function $c_Lamf_client_convert_Amqp091ChannelBindingConverter$Amqp091ChannelBindingMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_Amqp091ChannelBindingConverter$Amqp091ChannelBindingMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_Amqp091ChannelBindingConverter$Amqp091ChannelBindingMatcher$.prototype.constructor = $c_Lamf_client_convert_Amqp091ChannelBindingConverter$Amqp091ChannelBindingMatcher$;
/** @constructor */
function $h_Lamf_client_convert_Amqp091ChannelBindingConverter$Amqp091ChannelBindingMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_Amqp091ChannelBindingConverter$Amqp091ChannelBindingMatcher$.prototype = $c_Lamf_client_convert_Amqp091ChannelBindingConverter$Amqp091ChannelBindingMatcher$.prototype;
$c_Lamf_client_convert_Amqp091ChannelBindingConverter$Amqp091ChannelBindingMatcher$.prototype.init___Lamf_client_convert_Amqp091ChannelBindingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_Amqp091ChannelBindingConverter$Amqp091ChannelBindingMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Amqp091ChannelBinding(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_Amqp091ChannelBindingConverter$Amqp091ChannelBindingMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding__Lamf_client_model_domain_Amqp091ChannelBinding($as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding(from))
});
$c_Lamf_client_convert_Amqp091ChannelBindingConverter$Amqp091ChannelBindingMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding__Lamf_client_model_domain_Amqp091ChannelBinding = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_Amqp091ChannelBinding($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_Amqp091ChannelBindingConverter$Amqp091ChannelBindingMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_Amqp091ChannelBindingConverter$Amqp091ChannelBindingMatcher$: 0
}, false, "amf.client.convert.Amqp091ChannelBindingConverter$Amqp091ChannelBindingMatcher$", {
  Lamf_client_convert_Amqp091ChannelBindingConverter$Amqp091ChannelBindingMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_Amqp091ChannelBindingConverter$Amqp091ChannelBindingMatcher$.prototype.$classData = $d_Lamf_client_convert_Amqp091ChannelBindingConverter$Amqp091ChannelBindingMatcher$;
/** @constructor */
function $c_Lamf_client_convert_Amqp091ChannelExchangeConverter$Amqp091ChannelExchangeMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_Amqp091ChannelExchangeConverter$Amqp091ChannelExchangeMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_Amqp091ChannelExchangeConverter$Amqp091ChannelExchangeMatcher$.prototype.constructor = $c_Lamf_client_convert_Amqp091ChannelExchangeConverter$Amqp091ChannelExchangeMatcher$;
/** @constructor */
function $h_Lamf_client_convert_Amqp091ChannelExchangeConverter$Amqp091ChannelExchangeMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_Amqp091ChannelExchangeConverter$Amqp091ChannelExchangeMatcher$.prototype = $c_Lamf_client_convert_Amqp091ChannelExchangeConverter$Amqp091ChannelExchangeMatcher$.prototype;
$c_Lamf_client_convert_Amqp091ChannelExchangeConverter$Amqp091ChannelExchangeMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange__Lamf_client_model_domain_Amqp091ChannelExchange = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_Amqp091ChannelExchange($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_Amqp091ChannelExchangeConverter$Amqp091ChannelExchangeMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Amqp091ChannelExchange(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_Amqp091ChannelExchangeConverter$Amqp091ChannelExchangeMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange__Lamf_client_model_domain_Amqp091ChannelExchange($as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange(from))
});
$c_Lamf_client_convert_Amqp091ChannelExchangeConverter$Amqp091ChannelExchangeMatcher$.prototype.init___Lamf_client_convert_Amqp091ChannelExchangeConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_Amqp091ChannelExchangeConverter$Amqp091ChannelExchangeMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_Amqp091ChannelExchangeConverter$Amqp091ChannelExchangeMatcher$: 0
}, false, "amf.client.convert.Amqp091ChannelExchangeConverter$Amqp091ChannelExchangeMatcher$", {
  Lamf_client_convert_Amqp091ChannelExchangeConverter$Amqp091ChannelExchangeMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_Amqp091ChannelExchangeConverter$Amqp091ChannelExchangeMatcher$.prototype.$classData = $d_Lamf_client_convert_Amqp091ChannelExchangeConverter$Amqp091ChannelExchangeMatcher$;
/** @constructor */
function $c_Lamf_client_convert_Amqp091MessageBindingConverter$Amqp091MessageBindingMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_Amqp091MessageBindingConverter$Amqp091MessageBindingMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_Amqp091MessageBindingConverter$Amqp091MessageBindingMatcher$.prototype.constructor = $c_Lamf_client_convert_Amqp091MessageBindingConverter$Amqp091MessageBindingMatcher$;
/** @constructor */
function $h_Lamf_client_convert_Amqp091MessageBindingConverter$Amqp091MessageBindingMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_Amqp091MessageBindingConverter$Amqp091MessageBindingMatcher$.prototype = $c_Lamf_client_convert_Amqp091MessageBindingConverter$Amqp091MessageBindingMatcher$.prototype;
$c_Lamf_client_convert_Amqp091MessageBindingConverter$Amqp091MessageBindingMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Amqp091MessageBinding(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_Amqp091MessageBindingConverter$Amqp091MessageBindingMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding__Lamf_client_model_domain_Amqp091MessageBinding($as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding(from))
});
$c_Lamf_client_convert_Amqp091MessageBindingConverter$Amqp091MessageBindingMatcher$.prototype.init___Lamf_client_convert_Amqp091MessageBindingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_Amqp091MessageBindingConverter$Amqp091MessageBindingMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding__Lamf_client_model_domain_Amqp091MessageBinding = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_Amqp091MessageBinding($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_Amqp091MessageBindingConverter$Amqp091MessageBindingMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_Amqp091MessageBindingConverter$Amqp091MessageBindingMatcher$: 0
}, false, "amf.client.convert.Amqp091MessageBindingConverter$Amqp091MessageBindingMatcher$", {
  Lamf_client_convert_Amqp091MessageBindingConverter$Amqp091MessageBindingMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_Amqp091MessageBindingConverter$Amqp091MessageBindingMatcher$.prototype.$classData = $d_Lamf_client_convert_Amqp091MessageBindingConverter$Amqp091MessageBindingMatcher$;
/** @constructor */
function $c_Lamf_client_convert_Amqp091OperationBindingConverter$Amqp091OperationBindingMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_Amqp091OperationBindingConverter$Amqp091OperationBindingMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_Amqp091OperationBindingConverter$Amqp091OperationBindingMatcher$.prototype.constructor = $c_Lamf_client_convert_Amqp091OperationBindingConverter$Amqp091OperationBindingMatcher$;
/** @constructor */
function $h_Lamf_client_convert_Amqp091OperationBindingConverter$Amqp091OperationBindingMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_Amqp091OperationBindingConverter$Amqp091OperationBindingMatcher$.prototype = $c_Lamf_client_convert_Amqp091OperationBindingConverter$Amqp091OperationBindingMatcher$.prototype;
$c_Lamf_client_convert_Amqp091OperationBindingConverter$Amqp091OperationBindingMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding__Lamf_client_model_domain_Amqp091OperationBinding = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_Amqp091OperationBinding($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_Amqp091OperationBindingConverter$Amqp091OperationBindingMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Amqp091OperationBinding(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_Amqp091OperationBindingConverter$Amqp091OperationBindingMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding__Lamf_client_model_domain_Amqp091OperationBinding($as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding(from))
});
$c_Lamf_client_convert_Amqp091OperationBindingConverter$Amqp091OperationBindingMatcher$.prototype.init___Lamf_client_convert_Amqp091OperationBindingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_Amqp091OperationBindingConverter$Amqp091OperationBindingMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_Amqp091OperationBindingConverter$Amqp091OperationBindingMatcher$: 0
}, false, "amf.client.convert.Amqp091OperationBindingConverter$Amqp091OperationBindingMatcher$", {
  Lamf_client_convert_Amqp091OperationBindingConverter$Amqp091OperationBindingMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_Amqp091OperationBindingConverter$Amqp091OperationBindingMatcher$.prototype.$classData = $d_Lamf_client_convert_Amqp091OperationBindingConverter$Amqp091OperationBindingMatcher$;
/** @constructor */
function $c_Lamf_client_convert_Amqp091QueueConverter$Amqp091QueueMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_Amqp091QueueConverter$Amqp091QueueMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_Amqp091QueueConverter$Amqp091QueueMatcher$.prototype.constructor = $c_Lamf_client_convert_Amqp091QueueConverter$Amqp091QueueMatcher$;
/** @constructor */
function $h_Lamf_client_convert_Amqp091QueueConverter$Amqp091QueueMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_Amqp091QueueConverter$Amqp091QueueMatcher$.prototype = $c_Lamf_client_convert_Amqp091QueueConverter$Amqp091QueueMatcher$.prototype;
$c_Lamf_client_convert_Amqp091QueueConverter$Amqp091QueueMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Amqp091Queue(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_Amqp091QueueConverter$Amqp091QueueMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue__Lamf_client_model_domain_Amqp091Queue($as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue(from))
});
$c_Lamf_client_convert_Amqp091QueueConverter$Amqp091QueueMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue__Lamf_client_model_domain_Amqp091Queue = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_Amqp091Queue($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_Amqp091QueueConverter$Amqp091QueueMatcher$.prototype.init___Lamf_client_convert_Amqp091QueueConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_Amqp091QueueConverter$Amqp091QueueMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_Amqp091QueueConverter$Amqp091QueueMatcher$: 0
}, false, "amf.client.convert.Amqp091QueueConverter$Amqp091QueueMatcher$", {
  Lamf_client_convert_Amqp091QueueConverter$Amqp091QueueMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_Amqp091QueueConverter$Amqp091QueueMatcher$.prototype.$classData = $d_Lamf_client_convert_Amqp091QueueConverter$Amqp091QueueMatcher$;
/** @constructor */
function $c_Lamf_client_convert_AnyShapeConverter$AnyShapeMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_AnyShapeConverter$AnyShapeMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_AnyShapeConverter$AnyShapeMatcher$.prototype.constructor = $c_Lamf_client_convert_AnyShapeConverter$AnyShapeMatcher$;
/** @constructor */
function $h_Lamf_client_convert_AnyShapeConverter$AnyShapeMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_AnyShapeConverter$AnyShapeMatcher$.prototype = $c_Lamf_client_convert_AnyShapeConverter$AnyShapeMatcher$.prototype;
$c_Lamf_client_convert_AnyShapeConverter$AnyShapeMatcher$.prototype.init___Lamf_client_convert_AnyShapeConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_AnyShapeConverter$AnyShapeMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_AnyShape(from);
  return from$1.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape()
});
$c_Lamf_client_convert_AnyShapeConverter$AnyShapeMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_client_model_domain_AnyShape($as_Lamf_plugins_domain_shapes_models_AnyShape(from))
});
$c_Lamf_client_convert_AnyShapeConverter$AnyShapeMatcher$.prototype.asClient__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_client_model_domain_AnyShape = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_AnyShape($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_AnyShapeConverter$AnyShapeMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_AnyShapeConverter$AnyShapeMatcher$: 0
}, false, "amf.client.convert.AnyShapeConverter$AnyShapeMatcher$", {
  Lamf_client_convert_AnyShapeConverter$AnyShapeMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_AnyShapeConverter$AnyShapeMatcher$.prototype.$classData = $d_Lamf_client_convert_AnyShapeConverter$AnyShapeMatcher$;
/** @constructor */
function $c_Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$.prototype.constructor = $c_Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$;
/** @constructor */
function $h_Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$.prototype = $c_Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$.prototype;
$c_Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$.prototype.init___Lamf_client_convert_BaseUnitConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_document_BaseUnit(from);
  return from$1.$$undinternal__Lamf_core_model_document_BaseUnit()
});
$c_Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$.prototype.asClient__Lamf_core_model_document_BaseUnit__Lamf_client_model_document_BaseUnit = (function(from) {
  var this$1 = this.$$outer$1.platform__Lamf_core_remote_Platform();
  return $as_Lamf_client_model_document_BaseUnit($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_core_model_document_BaseUnit__Lamf_client_model_document_BaseUnit($as_Lamf_core_model_document_BaseUnit(from))
});
var $d_Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$: 0
}, false, "amf.client.convert.BaseUnitConverter$BaseUnitMatcher$", {
  Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$.prototype.$classData = $d_Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$;
/** @constructor */
function $c_Lamf_client_convert_CachedReferenceConverter$CachedReferenceMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_CachedReferenceConverter$CachedReferenceMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_CachedReferenceConverter$CachedReferenceMatcher$.prototype.constructor = $c_Lamf_client_convert_CachedReferenceConverter$CachedReferenceMatcher$;
/** @constructor */
function $h_Lamf_client_convert_CachedReferenceConverter$CachedReferenceMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_CachedReferenceConverter$CachedReferenceMatcher$.prototype = $c_Lamf_client_convert_CachedReferenceConverter$CachedReferenceMatcher$.prototype;
$c_Lamf_client_convert_CachedReferenceConverter$CachedReferenceMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_reference_CachedReference(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_CachedReferenceConverter$CachedReferenceMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_internal_reference_CachedReference(from);
  return new $c_Lamf_client_reference_CachedReference().init___Lamf_internal_reference_CachedReference(from$1)
});
$c_Lamf_client_convert_CachedReferenceConverter$CachedReferenceMatcher$.prototype.init___Lamf_client_convert_CachedReferenceConverter = (function($$outer) {
  return this
});
var $d_Lamf_client_convert_CachedReferenceConverter$CachedReferenceMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_CachedReferenceConverter$CachedReferenceMatcher$: 0
}, false, "amf.client.convert.CachedReferenceConverter$CachedReferenceMatcher$", {
  Lamf_client_convert_CachedReferenceConverter$CachedReferenceMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_CachedReferenceConverter$CachedReferenceMatcher$.prototype.$classData = $d_Lamf_client_convert_CachedReferenceConverter$CachedReferenceMatcher$;
/** @constructor */
function $c_Lamf_client_convert_CallbackConverter$CallbackMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CallbackConverter$CallbackMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_CallbackConverter$CallbackMatcher$.prototype.constructor = $c_Lamf_client_convert_CallbackConverter$CallbackMatcher$;
/** @constructor */
function $h_Lamf_client_convert_CallbackConverter$CallbackMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_CallbackConverter$CallbackMatcher$.prototype = $c_Lamf_client_convert_CallbackConverter$CallbackMatcher$.prototype;
$c_Lamf_client_convert_CallbackConverter$CallbackMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Callback(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_CallbackConverter$CallbackMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_Callback__Lamf_client_model_domain_Callback = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_Callback($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_CallbackConverter$CallbackMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_Callback__Lamf_client_model_domain_Callback($as_Lamf_plugins_domain_webapi_models_Callback(from))
});
$c_Lamf_client_convert_CallbackConverter$CallbackMatcher$.prototype.init___Lamf_client_convert_CallbackConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_CallbackConverter$CallbackMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_CallbackConverter$CallbackMatcher$: 0
}, false, "amf.client.convert.CallbackConverter$CallbackMatcher$", {
  Lamf_client_convert_CallbackConverter$CallbackMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_CallbackConverter$CallbackMatcher$.prototype.$classData = $d_Lamf_client_convert_CallbackConverter$CallbackMatcher$;
/** @constructor */
function $c_Lamf_client_convert_ChannelBindingConverter$ChannelBindingMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_ChannelBindingConverter$ChannelBindingMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_ChannelBindingConverter$ChannelBindingMatcher$.prototype.constructor = $c_Lamf_client_convert_ChannelBindingConverter$ChannelBindingMatcher$;
/** @constructor */
function $h_Lamf_client_convert_ChannelBindingConverter$ChannelBindingMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ChannelBindingConverter$ChannelBindingMatcher$.prototype = $c_Lamf_client_convert_ChannelBindingConverter$ChannelBindingMatcher$.prototype;
$c_Lamf_client_convert_ChannelBindingConverter$ChannelBindingMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_ChannelBinding(from);
  return from$1.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_ChannelBinding()
});
$c_Lamf_client_convert_ChannelBindingConverter$ChannelBindingMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_ChannelBinding__Lamf_client_model_domain_ChannelBinding = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_ChannelBinding($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_ChannelBindingConverter$ChannelBindingMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_ChannelBinding__Lamf_client_model_domain_ChannelBinding($as_Lamf_plugins_domain_webapi_models_bindings_ChannelBinding(from))
});
$c_Lamf_client_convert_ChannelBindingConverter$ChannelBindingMatcher$.prototype.init___Lamf_client_convert_ChannelBindingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_ChannelBindingConverter$ChannelBindingMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_ChannelBindingConverter$ChannelBindingMatcher$: 0
}, false, "amf.client.convert.ChannelBindingConverter$ChannelBindingMatcher$", {
  Lamf_client_convert_ChannelBindingConverter$ChannelBindingMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_ChannelBindingConverter$ChannelBindingMatcher$.prototype.$classData = $d_Lamf_client_convert_ChannelBindingConverter$ChannelBindingMatcher$;
/** @constructor */
function $c_Lamf_client_convert_ChannelBindingsConverter$ChannelBindingsMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_ChannelBindingsConverter$ChannelBindingsMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_ChannelBindingsConverter$ChannelBindingsMatcher$.prototype.constructor = $c_Lamf_client_convert_ChannelBindingsConverter$ChannelBindingsMatcher$;
/** @constructor */
function $h_Lamf_client_convert_ChannelBindingsConverter$ChannelBindingsMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ChannelBindingsConverter$ChannelBindingsMatcher$.prototype = $c_Lamf_client_convert_ChannelBindingsConverter$ChannelBindingsMatcher$.prototype;
$c_Lamf_client_convert_ChannelBindingsConverter$ChannelBindingsMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_ChannelBindings(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_ChannelBindingsConverter$ChannelBindingsMatcher$.prototype.init___Lamf_client_convert_ChannelBindingsConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_ChannelBindingsConverter$ChannelBindingsMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_ChannelBindings__Lamf_client_model_domain_ChannelBindings($as_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings(from))
});
$c_Lamf_client_convert_ChannelBindingsConverter$ChannelBindingsMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_ChannelBindings__Lamf_client_model_domain_ChannelBindings = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_ChannelBindings($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_ChannelBindingsConverter$ChannelBindingsMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_ChannelBindingsConverter$ChannelBindingsMatcher$: 0
}, false, "amf.client.convert.ChannelBindingsConverter$ChannelBindingsMatcher$", {
  Lamf_client_convert_ChannelBindingsConverter$ChannelBindingsMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_ChannelBindingsConverter$ChannelBindingsMatcher$.prototype.$classData = $d_Lamf_client_convert_ChannelBindingsConverter$ChannelBindingsMatcher$;
/** @constructor */
function $c_Lamf_client_convert_ClassTermMappingConverter$ClassTermMappingConverter$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_ClassTermMappingConverter$ClassTermMappingConverter$.prototype = new $h_O();
$c_Lamf_client_convert_ClassTermMappingConverter$ClassTermMappingConverter$.prototype.constructor = $c_Lamf_client_convert_ClassTermMappingConverter$ClassTermMappingConverter$;
/** @constructor */
function $h_Lamf_client_convert_ClassTermMappingConverter$ClassTermMappingConverter$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ClassTermMappingConverter$ClassTermMappingConverter$.prototype = $c_Lamf_client_convert_ClassTermMappingConverter$ClassTermMappingConverter$.prototype;
$c_Lamf_client_convert_ClassTermMappingConverter$ClassTermMappingConverter$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_ClassTerm(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_ClassTermMappingConverter$ClassTermMappingConverter$.prototype.init___Lamf_client_convert_ClassTermMappingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_ClassTermMappingConverter$ClassTermMappingConverter$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_document_vocabularies_model_domain_ClassTerm__Lamf_client_model_domain_ClassTerm($as_Lamf_plugins_document_vocabularies_model_domain_ClassTerm(from))
});
$c_Lamf_client_convert_ClassTermMappingConverter$ClassTermMappingConverter$.prototype.asClient__Lamf_plugins_document_vocabularies_model_domain_ClassTerm__Lamf_client_model_domain_ClassTerm = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_ClassTerm($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_ClassTermMappingConverter$ClassTermMappingConverter$ = new $TypeData().initClass({
  Lamf_client_convert_ClassTermMappingConverter$ClassTermMappingConverter$: 0
}, false, "amf.client.convert.ClassTermMappingConverter$ClassTermMappingConverter$", {
  Lamf_client_convert_ClassTermMappingConverter$ClassTermMappingConverter$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_ClassTermMappingConverter$ClassTermMappingConverter$.prototype.$classData = $d_Lamf_client_convert_ClassTermMappingConverter$ClassTermMappingConverter$;
/** @constructor */
function $c_Lamf_client_convert_CoreBaseConverter$AnyMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CoreBaseConverter$AnyMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_CoreBaseConverter$AnyMatcher$.prototype.constructor = $c_Lamf_client_convert_CoreBaseConverter$AnyMatcher$;
/** @constructor */
function $h_Lamf_client_convert_CoreBaseConverter$AnyMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_CoreBaseConverter$AnyMatcher$.prototype = $c_Lamf_client_convert_CoreBaseConverter$AnyMatcher$.prototype;
$c_Lamf_client_convert_CoreBaseConverter$AnyMatcher$.prototype.init___Lamf_client_convert_CoreBaseConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_CoreBaseConverter$AnyMatcher$.prototype.asInternal__O__O = (function(from) {
  return from
});
$c_Lamf_client_convert_CoreBaseConverter$AnyMatcher$.prototype.asClient__O__O = (function(from) {
  return from
});
var $d_Lamf_client_convert_CoreBaseConverter$AnyMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_CoreBaseConverter$AnyMatcher$: 0
}, false, "amf.client.convert.CoreBaseConverter$AnyMatcher$", {
  Lamf_client_convert_CoreBaseConverter$AnyMatcher$: 1,
  O: 1,
  Lamf_client_convert_CoreBaseConverter$IdentityMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1
});
$c_Lamf_client_convert_CoreBaseConverter$AnyMatcher$.prototype.$classData = $d_Lamf_client_convert_CoreBaseConverter$AnyMatcher$;
/** @constructor */
function $c_Lamf_client_convert_CoreBaseConverter$BooleanMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CoreBaseConverter$BooleanMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_CoreBaseConverter$BooleanMatcher$.prototype.constructor = $c_Lamf_client_convert_CoreBaseConverter$BooleanMatcher$;
/** @constructor */
function $h_Lamf_client_convert_CoreBaseConverter$BooleanMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_CoreBaseConverter$BooleanMatcher$.prototype = $c_Lamf_client_convert_CoreBaseConverter$BooleanMatcher$.prototype;
$c_Lamf_client_convert_CoreBaseConverter$BooleanMatcher$.prototype.init___Lamf_client_convert_CoreBaseConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_CoreBaseConverter$BooleanMatcher$.prototype.asInternal__O__O = (function(from) {
  return from
});
$c_Lamf_client_convert_CoreBaseConverter$BooleanMatcher$.prototype.asClient__O__O = (function(from) {
  return from
});
var $d_Lamf_client_convert_CoreBaseConverter$BooleanMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_CoreBaseConverter$BooleanMatcher$: 0
}, false, "amf.client.convert.CoreBaseConverter$BooleanMatcher$", {
  Lamf_client_convert_CoreBaseConverter$BooleanMatcher$: 1,
  O: 1,
  Lamf_client_convert_CoreBaseConverter$IdentityMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1
});
$c_Lamf_client_convert_CoreBaseConverter$BooleanMatcher$.prototype.$classData = $d_Lamf_client_convert_CoreBaseConverter$BooleanMatcher$;
/** @constructor */
function $c_Lamf_client_convert_CoreBaseConverter$ContentMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CoreBaseConverter$ContentMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_CoreBaseConverter$ContentMatcher$.prototype.constructor = $c_Lamf_client_convert_CoreBaseConverter$ContentMatcher$;
/** @constructor */
function $h_Lamf_client_convert_CoreBaseConverter$ContentMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_CoreBaseConverter$ContentMatcher$.prototype = $c_Lamf_client_convert_CoreBaseConverter$ContentMatcher$.prototype;
$c_Lamf_client_convert_CoreBaseConverter$ContentMatcher$.prototype.init___Lamf_client_convert_CoreBaseConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_CoreBaseConverter$ContentMatcher$.prototype.asInternal__O__O = (function(from) {
  return from
});
$c_Lamf_client_convert_CoreBaseConverter$ContentMatcher$.prototype.asClient__O__O = (function(from) {
  return from
});
var $d_Lamf_client_convert_CoreBaseConverter$ContentMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_CoreBaseConverter$ContentMatcher$: 0
}, false, "amf.client.convert.CoreBaseConverter$ContentMatcher$", {
  Lamf_client_convert_CoreBaseConverter$ContentMatcher$: 1,
  O: 1,
  Lamf_client_convert_CoreBaseConverter$IdentityMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1
});
$c_Lamf_client_convert_CoreBaseConverter$ContentMatcher$.prototype.$classData = $d_Lamf_client_convert_CoreBaseConverter$ContentMatcher$;
/** @constructor */
function $c_Lamf_client_convert_CoreBaseConverter$DoubleMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CoreBaseConverter$DoubleMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_CoreBaseConverter$DoubleMatcher$.prototype.constructor = $c_Lamf_client_convert_CoreBaseConverter$DoubleMatcher$;
/** @constructor */
function $h_Lamf_client_convert_CoreBaseConverter$DoubleMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_CoreBaseConverter$DoubleMatcher$.prototype = $c_Lamf_client_convert_CoreBaseConverter$DoubleMatcher$.prototype;
$c_Lamf_client_convert_CoreBaseConverter$DoubleMatcher$.prototype.init___Lamf_client_convert_CoreBaseConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_CoreBaseConverter$DoubleMatcher$.prototype.asInternal__O__O = (function(from) {
  return from
});
$c_Lamf_client_convert_CoreBaseConverter$DoubleMatcher$.prototype.asClient__O__O = (function(from) {
  return from
});
var $d_Lamf_client_convert_CoreBaseConverter$DoubleMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_CoreBaseConverter$DoubleMatcher$: 0
}, false, "amf.client.convert.CoreBaseConverter$DoubleMatcher$", {
  Lamf_client_convert_CoreBaseConverter$DoubleMatcher$: 1,
  O: 1,
  Lamf_client_convert_CoreBaseConverter$IdentityMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1
});
$c_Lamf_client_convert_CoreBaseConverter$DoubleMatcher$.prototype.$classData = $d_Lamf_client_convert_CoreBaseConverter$DoubleMatcher$;
/** @constructor */
function $c_Lamf_client_convert_CoreBaseConverter$IntMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CoreBaseConverter$IntMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_CoreBaseConverter$IntMatcher$.prototype.constructor = $c_Lamf_client_convert_CoreBaseConverter$IntMatcher$;
/** @constructor */
function $h_Lamf_client_convert_CoreBaseConverter$IntMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_CoreBaseConverter$IntMatcher$.prototype = $c_Lamf_client_convert_CoreBaseConverter$IntMatcher$.prototype;
$c_Lamf_client_convert_CoreBaseConverter$IntMatcher$.prototype.init___Lamf_client_convert_CoreBaseConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_CoreBaseConverter$IntMatcher$.prototype.asInternal__O__O = (function(from) {
  return from
});
$c_Lamf_client_convert_CoreBaseConverter$IntMatcher$.prototype.asClient__O__O = (function(from) {
  return from
});
var $d_Lamf_client_convert_CoreBaseConverter$IntMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_CoreBaseConverter$IntMatcher$: 0
}, false, "amf.client.convert.CoreBaseConverter$IntMatcher$", {
  Lamf_client_convert_CoreBaseConverter$IntMatcher$: 1,
  O: 1,
  Lamf_client_convert_CoreBaseConverter$IdentityMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1
});
$c_Lamf_client_convert_CoreBaseConverter$IntMatcher$.prototype.$classData = $d_Lamf_client_convert_CoreBaseConverter$IntMatcher$;
/** @constructor */
function $c_Lamf_client_convert_CoreBaseConverter$ProfileNameMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CoreBaseConverter$ProfileNameMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_CoreBaseConverter$ProfileNameMatcher$.prototype.constructor = $c_Lamf_client_convert_CoreBaseConverter$ProfileNameMatcher$;
/** @constructor */
function $h_Lamf_client_convert_CoreBaseConverter$ProfileNameMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_CoreBaseConverter$ProfileNameMatcher$.prototype = $c_Lamf_client_convert_CoreBaseConverter$ProfileNameMatcher$.prototype;
$c_Lamf_client_convert_CoreBaseConverter$ProfileNameMatcher$.prototype.init___Lamf_client_convert_CoreBaseConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_CoreBaseConverter$ProfileNameMatcher$.prototype.asInternal__O__O = (function(from) {
  return from
});
$c_Lamf_client_convert_CoreBaseConverter$ProfileNameMatcher$.prototype.asClient__O__O = (function(from) {
  return from
});
var $d_Lamf_client_convert_CoreBaseConverter$ProfileNameMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_CoreBaseConverter$ProfileNameMatcher$: 0
}, false, "amf.client.convert.CoreBaseConverter$ProfileNameMatcher$", {
  Lamf_client_convert_CoreBaseConverter$ProfileNameMatcher$: 1,
  O: 1,
  Lamf_client_convert_CoreBaseConverter$IdentityMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1
});
$c_Lamf_client_convert_CoreBaseConverter$ProfileNameMatcher$.prototype.$classData = $d_Lamf_client_convert_CoreBaseConverter$ProfileNameMatcher$;
/** @constructor */
function $c_Lamf_client_convert_CoreBaseConverter$StringMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CoreBaseConverter$StringMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_CoreBaseConverter$StringMatcher$.prototype.constructor = $c_Lamf_client_convert_CoreBaseConverter$StringMatcher$;
/** @constructor */
function $h_Lamf_client_convert_CoreBaseConverter$StringMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_CoreBaseConverter$StringMatcher$.prototype = $c_Lamf_client_convert_CoreBaseConverter$StringMatcher$.prototype;
$c_Lamf_client_convert_CoreBaseConverter$StringMatcher$.prototype.init___Lamf_client_convert_CoreBaseConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_CoreBaseConverter$StringMatcher$.prototype.asInternal__O__O = (function(from) {
  return from
});
$c_Lamf_client_convert_CoreBaseConverter$StringMatcher$.prototype.asClient__O__O = (function(from) {
  return from
});
var $d_Lamf_client_convert_CoreBaseConverter$StringMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_CoreBaseConverter$StringMatcher$: 0
}, false, "amf.client.convert.CoreBaseConverter$StringMatcher$", {
  Lamf_client_convert_CoreBaseConverter$StringMatcher$: 1,
  O: 1,
  Lamf_client_convert_CoreBaseConverter$IdentityMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1
});
$c_Lamf_client_convert_CoreBaseConverter$StringMatcher$.prototype.$classData = $d_Lamf_client_convert_CoreBaseConverter$StringMatcher$;
/** @constructor */
function $c_Lamf_client_convert_CoreBaseConverter$UnitMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CoreBaseConverter$UnitMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_CoreBaseConverter$UnitMatcher$.prototype.constructor = $c_Lamf_client_convert_CoreBaseConverter$UnitMatcher$;
/** @constructor */
function $h_Lamf_client_convert_CoreBaseConverter$UnitMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_CoreBaseConverter$UnitMatcher$.prototype = $c_Lamf_client_convert_CoreBaseConverter$UnitMatcher$.prototype;
$c_Lamf_client_convert_CoreBaseConverter$UnitMatcher$.prototype.init___Lamf_client_convert_CoreBaseConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_CoreBaseConverter$UnitMatcher$.prototype.asInternal__O__O = (function(from) {
  return from
});
$c_Lamf_client_convert_CoreBaseConverter$UnitMatcher$.prototype.asClient__O__O = (function(from) {
  return from
});
var $d_Lamf_client_convert_CoreBaseConverter$UnitMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_CoreBaseConverter$UnitMatcher$: 0
}, false, "amf.client.convert.CoreBaseConverter$UnitMatcher$", {
  Lamf_client_convert_CoreBaseConverter$UnitMatcher$: 1,
  O: 1,
  Lamf_client_convert_CoreBaseConverter$IdentityMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1
});
$c_Lamf_client_convert_CoreBaseConverter$UnitMatcher$.prototype.$classData = $d_Lamf_client_convert_CoreBaseConverter$UnitMatcher$;
/** @constructor */
function $c_Lamf_client_convert_CoreBaseConverter$VendorMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CoreBaseConverter$VendorMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_CoreBaseConverter$VendorMatcher$.prototype.constructor = $c_Lamf_client_convert_CoreBaseConverter$VendorMatcher$;
/** @constructor */
function $h_Lamf_client_convert_CoreBaseConverter$VendorMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_CoreBaseConverter$VendorMatcher$.prototype = $c_Lamf_client_convert_CoreBaseConverter$VendorMatcher$.prototype;
$c_Lamf_client_convert_CoreBaseConverter$VendorMatcher$.prototype.init___Lamf_client_convert_CoreBaseConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_CoreBaseConverter$VendorMatcher$.prototype.asInternal__O__O = (function(from) {
  return from
});
$c_Lamf_client_convert_CoreBaseConverter$VendorMatcher$.prototype.asClient__O__O = (function(from) {
  return from
});
var $d_Lamf_client_convert_CoreBaseConverter$VendorMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_CoreBaseConverter$VendorMatcher$: 0
}, false, "amf.client.convert.CoreBaseConverter$VendorMatcher$", {
  Lamf_client_convert_CoreBaseConverter$VendorMatcher$: 1,
  O: 1,
  Lamf_client_convert_CoreBaseConverter$IdentityMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1
});
$c_Lamf_client_convert_CoreBaseConverter$VendorMatcher$.prototype.$classData = $d_Lamf_client_convert_CoreBaseConverter$VendorMatcher$;
/** @constructor */
function $c_Lamf_client_convert_CorrelationIdConverter$CorrelationIdMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CorrelationIdConverter$CorrelationIdMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_CorrelationIdConverter$CorrelationIdMatcher$.prototype.constructor = $c_Lamf_client_convert_CorrelationIdConverter$CorrelationIdMatcher$;
/** @constructor */
function $h_Lamf_client_convert_CorrelationIdConverter$CorrelationIdMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_CorrelationIdConverter$CorrelationIdMatcher$.prototype = $c_Lamf_client_convert_CorrelationIdConverter$CorrelationIdMatcher$.prototype;
$c_Lamf_client_convert_CorrelationIdConverter$CorrelationIdMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_CorrelationId(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_CorrelationIdConverter$CorrelationIdMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_CorrelationId__Lamf_client_model_domain_CorrelationId($as_Lamf_plugins_domain_webapi_models_CorrelationId(from))
});
$c_Lamf_client_convert_CorrelationIdConverter$CorrelationIdMatcher$.prototype.init___Lamf_client_convert_CorrelationIdConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_CorrelationIdConverter$CorrelationIdMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_CorrelationId__Lamf_client_model_domain_CorrelationId = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_CorrelationId($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_CorrelationIdConverter$CorrelationIdMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_CorrelationIdConverter$CorrelationIdMatcher$: 0
}, false, "amf.client.convert.CorrelationIdConverter$CorrelationIdMatcher$", {
  Lamf_client_convert_CorrelationIdConverter$CorrelationIdMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_CorrelationIdConverter$CorrelationIdMatcher$.prototype.$classData = $d_Lamf_client_convert_CorrelationIdConverter$CorrelationIdMatcher$;
/** @constructor */
function $c_Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$.prototype.constructor = $c_Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$;
/** @constructor */
function $h_Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$.prototype = $c_Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$.prototype;
$c_Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$.prototype.init___Lamf_client_convert_CreativeWorkConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_CreativeWork(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_client_model_domain_CreativeWork($as_Lamf_plugins_domain_shapes_models_CreativeWork(from))
});
$c_Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$.prototype.asClient__Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_client_model_domain_CreativeWork = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_CreativeWork($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$: 0
}, false, "amf.client.convert.CreativeWorkConverter$CreativeWorkMatcher$", {
  Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$.prototype.$classData = $d_Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$;
/** @constructor */
function $c_Lamf_client_convert_CustomDomainPropertyConverter$CustomDomainPropertyMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_CustomDomainPropertyConverter$CustomDomainPropertyMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_CustomDomainPropertyConverter$CustomDomainPropertyMatcher$.prototype.constructor = $c_Lamf_client_convert_CustomDomainPropertyConverter$CustomDomainPropertyMatcher$;
/** @constructor */
function $h_Lamf_client_convert_CustomDomainPropertyConverter$CustomDomainPropertyMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_CustomDomainPropertyConverter$CustomDomainPropertyMatcher$.prototype = $c_Lamf_client_convert_CustomDomainPropertyConverter$CustomDomainPropertyMatcher$.prototype;
$c_Lamf_client_convert_CustomDomainPropertyConverter$CustomDomainPropertyMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_CustomDomainProperty(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_CustomDomainPropertyConverter$CustomDomainPropertyMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(from);
  return new $c_Lamf_client_model_domain_CustomDomainProperty().init___Lamf_core_model_domain_extensions_CustomDomainProperty(from$1)
});
$c_Lamf_client_convert_CustomDomainPropertyConverter$CustomDomainPropertyMatcher$.prototype.init___Lamf_client_convert_CustomDomainPropertyConverter = (function($$outer) {
  return this
});
var $d_Lamf_client_convert_CustomDomainPropertyConverter$CustomDomainPropertyMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_CustomDomainPropertyConverter$CustomDomainPropertyMatcher$: 0
}, false, "amf.client.convert.CustomDomainPropertyConverter$CustomDomainPropertyMatcher$", {
  Lamf_client_convert_CustomDomainPropertyConverter$CustomDomainPropertyMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_CustomDomainPropertyConverter$CustomDomainPropertyMatcher$.prototype.$classData = $d_Lamf_client_convert_CustomDomainPropertyConverter$CustomDomainPropertyMatcher$;
/** @constructor */
function $c_Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$.prototype.constructor = $c_Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$;
/** @constructor */
function $h_Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$.prototype = $c_Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$.prototype;
$c_Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_ArrayNode(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_core_model_domain_ArrayNode(from);
  return new $c_Lamf_client_model_domain_ArrayNode().init___Lamf_core_model_domain_ArrayNode(from$1)
});
$c_Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$.prototype.init___Lamf_client_convert_DataNodeConverter = (function($$outer) {
  return this
});
var $d_Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$: 0
}, false, "amf.client.convert.DataNodeConverter$ArrayNodeMatcher$", {
  Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$.prototype.$classData = $d_Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$;
/** @constructor */
function $c_Lamf_client_convert_DataNodeConverter$DataNodeMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_DataNodeConverter$DataNodeMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_DataNodeConverter$DataNodeMatcher$.prototype.constructor = $c_Lamf_client_convert_DataNodeConverter$DataNodeMatcher$;
/** @constructor */
function $h_Lamf_client_convert_DataNodeConverter$DataNodeMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_DataNodeConverter$DataNodeMatcher$.prototype = $c_Lamf_client_convert_DataNodeConverter$DataNodeMatcher$.prototype;
$c_Lamf_client_convert_DataNodeConverter$DataNodeMatcher$.prototype.asClient__Lamf_core_model_domain_DataNode__Lamf_client_model_domain_DataNode = (function(from) {
  if ((from instanceof $c_Lamf_core_model_domain_ObjectNode)) {
    var x2 = $as_Lamf_core_model_domain_ObjectNode(from);
    this.$$outer$1.ObjectNodeMatcher__Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$();
    return new $c_Lamf_client_model_domain_ObjectNode().init___Lamf_core_model_domain_ObjectNode(x2)
  } else if ((from instanceof $c_Lamf_core_model_domain_ScalarNode)) {
    var x3 = $as_Lamf_core_model_domain_ScalarNode(from);
    this.$$outer$1.ScalarNodeMatcher__Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$();
    return new $c_Lamf_client_model_domain_ScalarNode().init___Lamf_core_model_domain_ScalarNode(x3)
  } else if ((from instanceof $c_Lamf_core_model_domain_ArrayNode)) {
    var x4 = $as_Lamf_core_model_domain_ArrayNode(from);
    this.$$outer$1.ArrayNodeMatcher__Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$();
    return new $c_Lamf_client_model_domain_ArrayNode().init___Lamf_core_model_domain_ArrayNode(x4)
  } else {
    return null
  }
});
$c_Lamf_client_convert_DataNodeConverter$DataNodeMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_DataNode(from);
  return from$1.$$undinternal__Lamf_core_model_domain_DataNode()
});
$c_Lamf_client_convert_DataNodeConverter$DataNodeMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_core_model_domain_DataNode__Lamf_client_model_domain_DataNode($as_Lamf_core_model_domain_DataNode(from))
});
$c_Lamf_client_convert_DataNodeConverter$DataNodeMatcher$.prototype.init___Lamf_client_convert_DataNodeConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_DataNodeConverter$DataNodeMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_DataNodeConverter$DataNodeMatcher$: 0
}, false, "amf.client.convert.DataNodeConverter$DataNodeMatcher$", {
  Lamf_client_convert_DataNodeConverter$DataNodeMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_DataNodeConverter$DataNodeMatcher$.prototype.$classData = $d_Lamf_client_convert_DataNodeConverter$DataNodeMatcher$;
/** @constructor */
function $c_Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$.prototype.constructor = $c_Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$;
/** @constructor */
function $h_Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$.prototype = $c_Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$.prototype;
$c_Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_ObjectNode(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_core_model_domain_ObjectNode(from);
  return new $c_Lamf_client_model_domain_ObjectNode().init___Lamf_core_model_domain_ObjectNode(from$1)
});
$c_Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$.prototype.init___Lamf_client_convert_DataNodeConverter = (function($$outer) {
  return this
});
var $d_Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$: 0
}, false, "amf.client.convert.DataNodeConverter$ObjectNodeMatcher$", {
  Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$.prototype.$classData = $d_Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$;
/** @constructor */
function $c_Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$.prototype.constructor = $c_Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$;
/** @constructor */
function $h_Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$.prototype = $c_Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$.prototype;
$c_Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_ScalarNode(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_core_model_domain_ScalarNode(from);
  return new $c_Lamf_client_model_domain_ScalarNode().init___Lamf_core_model_domain_ScalarNode(from$1)
});
$c_Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$.prototype.init___Lamf_client_convert_DataNodeConverter = (function($$outer) {
  return this
});
var $d_Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$: 0
}, false, "amf.client.convert.DataNodeConverter$ScalarNodeMatcher$", {
  Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$.prototype.$classData = $d_Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$;
/** @constructor */
function $c_Lamf_client_convert_DatatypePropertyMappingConverter$DatatypePropertyMappingConverter$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_DatatypePropertyMappingConverter$DatatypePropertyMappingConverter$.prototype = new $h_O();
$c_Lamf_client_convert_DatatypePropertyMappingConverter$DatatypePropertyMappingConverter$.prototype.constructor = $c_Lamf_client_convert_DatatypePropertyMappingConverter$DatatypePropertyMappingConverter$;
/** @constructor */
function $h_Lamf_client_convert_DatatypePropertyMappingConverter$DatatypePropertyMappingConverter$() {
  /*<skip>*/
}
$h_Lamf_client_convert_DatatypePropertyMappingConverter$DatatypePropertyMappingConverter$.prototype = $c_Lamf_client_convert_DatatypePropertyMappingConverter$DatatypePropertyMappingConverter$.prototype;
$c_Lamf_client_convert_DatatypePropertyMappingConverter$DatatypePropertyMappingConverter$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_DatatypePropertyTerm(from);
  return $as_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm(from$1.$$undinternal$1)
});
$c_Lamf_client_convert_DatatypePropertyMappingConverter$DatatypePropertyMappingConverter$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm__Lamf_client_model_domain_DatatypePropertyTerm($as_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm(from))
});
$c_Lamf_client_convert_DatatypePropertyMappingConverter$DatatypePropertyMappingConverter$.prototype.asClient__Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm__Lamf_client_model_domain_DatatypePropertyTerm = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_DatatypePropertyTerm($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_DatatypePropertyMappingConverter$DatatypePropertyMappingConverter$.prototype.init___Lamf_client_convert_DatatypePropertyMappingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_DatatypePropertyMappingConverter$DatatypePropertyMappingConverter$ = new $TypeData().initClass({
  Lamf_client_convert_DatatypePropertyMappingConverter$DatatypePropertyMappingConverter$: 0
}, false, "amf.client.convert.DatatypePropertyMappingConverter$DatatypePropertyMappingConverter$", {
  Lamf_client_convert_DatatypePropertyMappingConverter$DatatypePropertyMappingConverter$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_DatatypePropertyMappingConverter$DatatypePropertyMappingConverter$.prototype.$classData = $d_Lamf_client_convert_DatatypePropertyMappingConverter$DatatypePropertyMappingConverter$;
/** @constructor */
function $c_Lamf_client_convert_DeclarationsConverter$AbstractDeclarationMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_DeclarationsConverter$AbstractDeclarationMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_DeclarationsConverter$AbstractDeclarationMatcher$.prototype.constructor = $c_Lamf_client_convert_DeclarationsConverter$AbstractDeclarationMatcher$;
/** @constructor */
function $h_Lamf_client_convert_DeclarationsConverter$AbstractDeclarationMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_DeclarationsConverter$AbstractDeclarationMatcher$.prototype = $c_Lamf_client_convert_DeclarationsConverter$AbstractDeclarationMatcher$.prototype;
$c_Lamf_client_convert_DeclarationsConverter$AbstractDeclarationMatcher$.prototype.init___Lamf_client_convert_DeclarationsConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_DeclarationsConverter$AbstractDeclarationMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_AbstractDeclaration(from);
  return from$1.$$undinternal__Lamf_core_model_domain_templates_AbstractDeclaration()
});
$c_Lamf_client_convert_DeclarationsConverter$AbstractDeclarationMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_core_model_domain_templates_AbstractDeclaration__Lamf_client_model_domain_AbstractDeclaration($as_Lamf_core_model_domain_templates_AbstractDeclaration(from))
});
$c_Lamf_client_convert_DeclarationsConverter$AbstractDeclarationMatcher$.prototype.asClient__Lamf_core_model_domain_templates_AbstractDeclaration__Lamf_client_model_domain_AbstractDeclaration = (function(from) {
  var this$1 = this.$$outer$1.platform__Lamf_core_remote_Platform();
  return $as_Lamf_client_model_domain_AbstractDeclaration($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_DeclarationsConverter$AbstractDeclarationMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_DeclarationsConverter$AbstractDeclarationMatcher$: 0
}, false, "amf.client.convert.DeclarationsConverter$AbstractDeclarationMatcher$", {
  Lamf_client_convert_DeclarationsConverter$AbstractDeclarationMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_DeclarationsConverter$AbstractDeclarationMatcher$.prototype.$classData = $d_Lamf_client_convert_DeclarationsConverter$AbstractDeclarationMatcher$;
/** @constructor */
function $c_Lamf_client_convert_DeclarationsConverter$ParameterizedDeclarationMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_DeclarationsConverter$ParameterizedDeclarationMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_DeclarationsConverter$ParameterizedDeclarationMatcher$.prototype.constructor = $c_Lamf_client_convert_DeclarationsConverter$ParameterizedDeclarationMatcher$;
/** @constructor */
function $h_Lamf_client_convert_DeclarationsConverter$ParameterizedDeclarationMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_DeclarationsConverter$ParameterizedDeclarationMatcher$.prototype = $c_Lamf_client_convert_DeclarationsConverter$ParameterizedDeclarationMatcher$.prototype;
$c_Lamf_client_convert_DeclarationsConverter$ParameterizedDeclarationMatcher$.prototype.init___Lamf_client_convert_DeclarationsConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_DeclarationsConverter$ParameterizedDeclarationMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_ParametrizedDeclaration(from);
  return from$1.$$undinternal__Lamf_core_model_domain_templates_ParametrizedDeclaration()
});
$c_Lamf_client_convert_DeclarationsConverter$ParameterizedDeclarationMatcher$.prototype.asClient__Lamf_core_model_domain_templates_ParametrizedDeclaration__Lamf_client_model_domain_ParametrizedDeclaration = (function(from) {
  var this$1 = this.$$outer$1.platform__Lamf_core_remote_Platform();
  return $as_Lamf_client_model_domain_ParametrizedDeclaration($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_DeclarationsConverter$ParameterizedDeclarationMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_core_model_domain_templates_ParametrizedDeclaration__Lamf_client_model_domain_ParametrizedDeclaration($as_Lamf_core_model_domain_templates_ParametrizedDeclaration(from))
});
var $d_Lamf_client_convert_DeclarationsConverter$ParameterizedDeclarationMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_DeclarationsConverter$ParameterizedDeclarationMatcher$: 0
}, false, "amf.client.convert.DeclarationsConverter$ParameterizedDeclarationMatcher$", {
  Lamf_client_convert_DeclarationsConverter$ParameterizedDeclarationMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_DeclarationsConverter$ParameterizedDeclarationMatcher$.prototype.$classData = $d_Lamf_client_convert_DeclarationsConverter$ParameterizedDeclarationMatcher$;
/** @constructor */
function $c_Lamf_client_convert_DialectConverter$DialectConverter$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_DialectConverter$DialectConverter$.prototype = new $h_O();
$c_Lamf_client_convert_DialectConverter$DialectConverter$.prototype.constructor = $c_Lamf_client_convert_DialectConverter$DialectConverter$;
/** @constructor */
function $h_Lamf_client_convert_DialectConverter$DialectConverter$() {
  /*<skip>*/
}
$h_Lamf_client_convert_DialectConverter$DialectConverter$.prototype = $c_Lamf_client_convert_DialectConverter$DialectConverter$.prototype;
$c_Lamf_client_convert_DialectConverter$DialectConverter$.prototype.init___Lamf_client_convert_DialectConverter = (function($$outer) {
  return this
});
$c_Lamf_client_convert_DialectConverter$DialectConverter$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_document_Dialect(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_DialectConverter$DialectConverter$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(from);
  return new $c_Lamf_client_model_document_Dialect().init___Lamf_plugins_document_vocabularies_model_document_Dialect(from$1)
});
var $d_Lamf_client_convert_DialectConverter$DialectConverter$ = new $TypeData().initClass({
  Lamf_client_convert_DialectConverter$DialectConverter$: 0
}, false, "amf.client.convert.DialectConverter$DialectConverter$", {
  Lamf_client_convert_DialectConverter$DialectConverter$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_DialectConverter$DialectConverter$.prototype.$classData = $d_Lamf_client_convert_DialectConverter$DialectConverter$;
/** @constructor */
function $c_Lamf_client_convert_DialectDomainElementConverter$DialectDomainElementConvertej$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_DialectDomainElementConverter$DialectDomainElementConvertej$.prototype = new $h_O();
$c_Lamf_client_convert_DialectDomainElementConverter$DialectDomainElementConvertej$.prototype.constructor = $c_Lamf_client_convert_DialectDomainElementConverter$DialectDomainElementConvertej$;
/** @constructor */
function $h_Lamf_client_convert_DialectDomainElementConverter$DialectDomainElementConvertej$() {
  /*<skip>*/
}
$h_Lamf_client_convert_DialectDomainElementConverter$DialectDomainElementConvertej$.prototype = $c_Lamf_client_convert_DialectDomainElementConverter$DialectDomainElementConvertej$.prototype;
$c_Lamf_client_convert_DialectDomainElementConverter$DialectDomainElementConvertej$.prototype.init___Lamf_client_convert_DialectDomainElementConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_DialectDomainElementConverter$DialectDomainElementConvertej$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_DialectDomainElement(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_DialectDomainElementConverter$DialectDomainElementConvertej$.prototype.asClient__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_client_model_domain_DialectDomainElement = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_DialectDomainElement($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_DialectDomainElementConverter$DialectDomainElementConvertej$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_client_model_domain_DialectDomainElement($as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(from))
});
var $d_Lamf_client_convert_DialectDomainElementConverter$DialectDomainElementConvertej$ = new $TypeData().initClass({
  Lamf_client_convert_DialectDomainElementConverter$DialectDomainElementConvertej$: 0
}, false, "amf.client.convert.DialectDomainElementConverter$DialectDomainElementConvertej$", {
  Lamf_client_convert_DialectDomainElementConverter$DialectDomainElementConvertej$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_DialectDomainElementConverter$DialectDomainElementConvertej$.prototype.$classData = $d_Lamf_client_convert_DialectDomainElementConverter$DialectDomainElementConvertej$;
/** @constructor */
function $c_Lamf_client_convert_DocumentMappingConverter$DocumentMappingConverter$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_DocumentMappingConverter$DocumentMappingConverter$.prototype = new $h_O();
$c_Lamf_client_convert_DocumentMappingConverter$DocumentMappingConverter$.prototype.constructor = $c_Lamf_client_convert_DocumentMappingConverter$DocumentMappingConverter$;
/** @constructor */
function $h_Lamf_client_convert_DocumentMappingConverter$DocumentMappingConverter$() {
  /*<skip>*/
}
$h_Lamf_client_convert_DocumentMappingConverter$DocumentMappingConverter$.prototype = $c_Lamf_client_convert_DocumentMappingConverter$DocumentMappingConverter$.prototype;
$c_Lamf_client_convert_DocumentMappingConverter$DocumentMappingConverter$.prototype.init___Lamf_client_convert_DocumentMappingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_DocumentMappingConverter$DocumentMappingConverter$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_DocumentMapping(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_DocumentMappingConverter$DocumentMappingConverter$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_document_vocabularies_model_domain_DocumentMapping__Lamf_client_model_domain_DocumentMapping($as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(from))
});
$c_Lamf_client_convert_DocumentMappingConverter$DocumentMappingConverter$.prototype.asClient__Lamf_plugins_document_vocabularies_model_domain_DocumentMapping__Lamf_client_model_domain_DocumentMapping = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_DocumentMapping($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_DocumentMappingConverter$DocumentMappingConverter$ = new $TypeData().initClass({
  Lamf_client_convert_DocumentMappingConverter$DocumentMappingConverter$: 0
}, false, "amf.client.convert.DocumentMappingConverter$DocumentMappingConverter$", {
  Lamf_client_convert_DocumentMappingConverter$DocumentMappingConverter$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_DocumentMappingConverter$DocumentMappingConverter$.prototype.$classData = $d_Lamf_client_convert_DocumentMappingConverter$DocumentMappingConverter$;
/** @constructor */
function $c_Lamf_client_convert_DocumentsModelConverter$DocumentModelConverter$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_DocumentsModelConverter$DocumentModelConverter$.prototype = new $h_O();
$c_Lamf_client_convert_DocumentsModelConverter$DocumentModelConverter$.prototype.constructor = $c_Lamf_client_convert_DocumentsModelConverter$DocumentModelConverter$;
/** @constructor */
function $h_Lamf_client_convert_DocumentsModelConverter$DocumentModelConverter$() {
  /*<skip>*/
}
$h_Lamf_client_convert_DocumentsModelConverter$DocumentModelConverter$.prototype = $c_Lamf_client_convert_DocumentsModelConverter$DocumentModelConverter$.prototype;
$c_Lamf_client_convert_DocumentsModelConverter$DocumentModelConverter$.prototype.asClient__Lamf_plugins_document_vocabularies_model_domain_DocumentsModel__Lamf_client_model_domain_DocumentsModel = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_DocumentsModel($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_DocumentsModelConverter$DocumentModelConverter$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_DocumentsModel(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_DocumentsModelConverter$DocumentModelConverter$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_document_vocabularies_model_domain_DocumentsModel__Lamf_client_model_domain_DocumentsModel($as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(from))
});
$c_Lamf_client_convert_DocumentsModelConverter$DocumentModelConverter$.prototype.init___Lamf_client_convert_DocumentsModelConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_DocumentsModelConverter$DocumentModelConverter$ = new $TypeData().initClass({
  Lamf_client_convert_DocumentsModelConverter$DocumentModelConverter$: 0
}, false, "amf.client.convert.DocumentsModelConverter$DocumentModelConverter$", {
  Lamf_client_convert_DocumentsModelConverter$DocumentModelConverter$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_DocumentsModelConverter$DocumentModelConverter$.prototype.$classData = $d_Lamf_client_convert_DocumentsModelConverter$DocumentModelConverter$;
/** @constructor */
function $c_Lamf_client_convert_DomainElementConverter$DomainElementMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_DomainElementConverter$DomainElementMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_DomainElementConverter$DomainElementMatcher$.prototype.constructor = $c_Lamf_client_convert_DomainElementConverter$DomainElementMatcher$;
/** @constructor */
function $h_Lamf_client_convert_DomainElementConverter$DomainElementMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_DomainElementConverter$DomainElementMatcher$.prototype = $c_Lamf_client_convert_DomainElementConverter$DomainElementMatcher$.prototype;
$c_Lamf_client_convert_DomainElementConverter$DomainElementMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_DomainElement(from);
  return from$1.$$undinternal__Lamf_core_model_domain_DomainElement()
});
$c_Lamf_client_convert_DomainElementConverter$DomainElementMatcher$.prototype.init___Lamf_client_convert_DomainElementConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_DomainElementConverter$DomainElementMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_core_model_domain_DomainElement__Lamf_client_model_domain_DomainElement($as_Lamf_core_model_domain_DomainElement(from))
});
$c_Lamf_client_convert_DomainElementConverter$DomainElementMatcher$.prototype.asClient__Lamf_core_model_domain_DomainElement__Lamf_client_model_domain_DomainElement = (function(from) {
  var this$1 = this.$$outer$1.platform__Lamf_core_remote_Platform();
  return $as_Lamf_client_model_domain_DomainElement($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_DomainElementConverter$DomainElementMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_DomainElementConverter$DomainElementMatcher$: 0
}, false, "amf.client.convert.DomainElementConverter$DomainElementMatcher$", {
  Lamf_client_convert_DomainElementConverter$DomainElementMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_DomainElementConverter$DomainElementMatcher$.prototype.$classData = $d_Lamf_client_convert_DomainElementConverter$DomainElementMatcher$;
/** @constructor */
function $c_Lamf_client_convert_DomainExtensionConverter$DomainExtensionMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_DomainExtensionConverter$DomainExtensionMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_DomainExtensionConverter$DomainExtensionMatcher$.prototype.constructor = $c_Lamf_client_convert_DomainExtensionConverter$DomainExtensionMatcher$;
/** @constructor */
function $h_Lamf_client_convert_DomainExtensionConverter$DomainExtensionMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_DomainExtensionConverter$DomainExtensionMatcher$.prototype = $c_Lamf_client_convert_DomainExtensionConverter$DomainExtensionMatcher$.prototype;
$c_Lamf_client_convert_DomainExtensionConverter$DomainExtensionMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_DomainExtension(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_DomainExtensionConverter$DomainExtensionMatcher$.prototype.init___Lamf_client_convert_DomainExtensionConverter = (function($$outer) {
  return this
});
$c_Lamf_client_convert_DomainExtensionConverter$DomainExtensionMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_core_model_domain_extensions_DomainExtension(from);
  return new $c_Lamf_client_model_domain_DomainExtension().init___Lamf_core_model_domain_extensions_DomainExtension(from$1)
});
var $d_Lamf_client_convert_DomainExtensionConverter$DomainExtensionMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_DomainExtensionConverter$DomainExtensionMatcher$: 0
}, false, "amf.client.convert.DomainExtensionConverter$DomainExtensionMatcher$", {
  Lamf_client_convert_DomainExtensionConverter$DomainExtensionMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_DomainExtensionConverter$DomainExtensionMatcher$.prototype.$classData = $d_Lamf_client_convert_DomainExtensionConverter$DomainExtensionMatcher$;
/** @constructor */
function $c_Lamf_client_convert_DynamicBindingConverter$DynamicBindingMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_DynamicBindingConverter$DynamicBindingMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_DynamicBindingConverter$DynamicBindingMatcher$.prototype.constructor = $c_Lamf_client_convert_DynamicBindingConverter$DynamicBindingMatcher$;
/** @constructor */
function $h_Lamf_client_convert_DynamicBindingConverter$DynamicBindingMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_DynamicBindingConverter$DynamicBindingMatcher$.prototype = $c_Lamf_client_convert_DynamicBindingConverter$DynamicBindingMatcher$.prototype;
$c_Lamf_client_convert_DynamicBindingConverter$DynamicBindingMatcher$.prototype.init___Lamf_client_convert_DynamicBindingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_DynamicBindingConverter$DynamicBindingMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_DynamicBinding__Lamf_client_model_domain_DynamicBinding = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_DynamicBinding($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_DynamicBindingConverter$DynamicBindingMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_DynamicBinding(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_DynamicBindingConverter$DynamicBindingMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_DynamicBinding__Lamf_client_model_domain_DynamicBinding($as_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding(from))
});
var $d_Lamf_client_convert_DynamicBindingConverter$DynamicBindingMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_DynamicBindingConverter$DynamicBindingMatcher$: 0
}, false, "amf.client.convert.DynamicBindingConverter$DynamicBindingMatcher$", {
  Lamf_client_convert_DynamicBindingConverter$DynamicBindingMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_DynamicBindingConverter$DynamicBindingMatcher$.prototype.$classData = $d_Lamf_client_convert_DynamicBindingConverter$DynamicBindingMatcher$;
/** @constructor */
function $c_Lamf_client_convert_EmptyBindingConverter$EmptyBindingMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_EmptyBindingConverter$EmptyBindingMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_EmptyBindingConverter$EmptyBindingMatcher$.prototype.constructor = $c_Lamf_client_convert_EmptyBindingConverter$EmptyBindingMatcher$;
/** @constructor */
function $h_Lamf_client_convert_EmptyBindingConverter$EmptyBindingMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_EmptyBindingConverter$EmptyBindingMatcher$.prototype = $c_Lamf_client_convert_EmptyBindingConverter$EmptyBindingMatcher$.prototype;
$c_Lamf_client_convert_EmptyBindingConverter$EmptyBindingMatcher$.prototype.init___Lamf_client_convert_EmptyBindingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_EmptyBindingConverter$EmptyBindingMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_EmptyBinding(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_EmptyBindingConverter$EmptyBindingMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_EmptyBinding__Lamf_client_model_domain_EmptyBinding($as_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding(from))
});
$c_Lamf_client_convert_EmptyBindingConverter$EmptyBindingMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_EmptyBinding__Lamf_client_model_domain_EmptyBinding = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_EmptyBinding($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_EmptyBindingConverter$EmptyBindingMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_EmptyBindingConverter$EmptyBindingMatcher$: 0
}, false, "amf.client.convert.EmptyBindingConverter$EmptyBindingMatcher$", {
  Lamf_client_convert_EmptyBindingConverter$EmptyBindingMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_EmptyBindingConverter$EmptyBindingMatcher$.prototype.$classData = $d_Lamf_client_convert_EmptyBindingConverter$EmptyBindingMatcher$;
/** @constructor */
function $c_Lamf_client_convert_EncodingConverter$EncodingMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_EncodingConverter$EncodingMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_EncodingConverter$EncodingMatcher$.prototype.constructor = $c_Lamf_client_convert_EncodingConverter$EncodingMatcher$;
/** @constructor */
function $h_Lamf_client_convert_EncodingConverter$EncodingMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_EncodingConverter$EncodingMatcher$.prototype = $c_Lamf_client_convert_EncodingConverter$EncodingMatcher$.prototype;
$c_Lamf_client_convert_EncodingConverter$EncodingMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Encoding(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_EncodingConverter$EncodingMatcher$.prototype.init___Lamf_client_convert_EncodingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_EncodingConverter$EncodingMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_Encoding__Lamf_client_model_domain_Encoding($as_Lamf_plugins_domain_webapi_models_Encoding(from))
});
$c_Lamf_client_convert_EncodingConverter$EncodingMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_Encoding__Lamf_client_model_domain_Encoding = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_Encoding($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_EncodingConverter$EncodingMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_EncodingConverter$EncodingMatcher$: 0
}, false, "amf.client.convert.EncodingConverter$EncodingMatcher$", {
  Lamf_client_convert_EncodingConverter$EncodingMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_EncodingConverter$EncodingMatcher$.prototype.$classData = $d_Lamf_client_convert_EncodingConverter$EncodingMatcher$;
/** @constructor */
function $c_Lamf_client_convert_EndPointConverter$EndPointMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_EndPointConverter$EndPointMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_EndPointConverter$EndPointMatcher$.prototype.constructor = $c_Lamf_client_convert_EndPointConverter$EndPointMatcher$;
/** @constructor */
function $h_Lamf_client_convert_EndPointConverter$EndPointMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_EndPointConverter$EndPointMatcher$.prototype = $c_Lamf_client_convert_EndPointConverter$EndPointMatcher$.prototype;
$c_Lamf_client_convert_EndPointConverter$EndPointMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_EndPoint(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_EndPointConverter$EndPointMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_client_model_domain_EndPoint($as_Lamf_plugins_domain_webapi_models_EndPoint(from))
});
$c_Lamf_client_convert_EndPointConverter$EndPointMatcher$.prototype.init___Lamf_client_convert_EndPointConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_EndPointConverter$EndPointMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_client_model_domain_EndPoint = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_EndPoint($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_EndPointConverter$EndPointMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_EndPointConverter$EndPointMatcher$: 0
}, false, "amf.client.convert.EndPointConverter$EndPointMatcher$", {
  Lamf_client_convert_EndPointConverter$EndPointMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_EndPointConverter$EndPointMatcher$.prototype.$classData = $d_Lamf_client_convert_EndPointConverter$EndPointMatcher$;
/** @constructor */
function $c_Lamf_client_convert_ExampleConverter$ExampleMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_ExampleConverter$ExampleMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_ExampleConverter$ExampleMatcher$.prototype.constructor = $c_Lamf_client_convert_ExampleConverter$ExampleMatcher$;
/** @constructor */
function $h_Lamf_client_convert_ExampleConverter$ExampleMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ExampleConverter$ExampleMatcher$.prototype = $c_Lamf_client_convert_ExampleConverter$ExampleMatcher$.prototype;
$c_Lamf_client_convert_ExampleConverter$ExampleMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Example(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_ExampleConverter$ExampleMatcher$.prototype.init___Lamf_client_convert_ExampleConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_ExampleConverter$ExampleMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_shapes_models_Example__Lamf_client_model_domain_Example($as_Lamf_plugins_domain_shapes_models_Example(from))
});
$c_Lamf_client_convert_ExampleConverter$ExampleMatcher$.prototype.asClient__Lamf_plugins_domain_shapes_models_Example__Lamf_client_model_domain_Example = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_Example($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_ExampleConverter$ExampleMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_ExampleConverter$ExampleMatcher$: 0
}, false, "amf.client.convert.ExampleConverter$ExampleMatcher$", {
  Lamf_client_convert_ExampleConverter$ExampleMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_ExampleConverter$ExampleMatcher$.prototype.$classData = $d_Lamf_client_convert_ExampleConverter$ExampleMatcher$;
/** @constructor */
function $c_Lamf_client_convert_ExternalConverter$ExternalConverter$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_ExternalConverter$ExternalConverter$.prototype = new $h_O();
$c_Lamf_client_convert_ExternalConverter$ExternalConverter$.prototype.constructor = $c_Lamf_client_convert_ExternalConverter$ExternalConverter$;
/** @constructor */
function $h_Lamf_client_convert_ExternalConverter$ExternalConverter$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ExternalConverter$ExternalConverter$.prototype = $c_Lamf_client_convert_ExternalConverter$ExternalConverter$.prototype;
$c_Lamf_client_convert_ExternalConverter$ExternalConverter$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_External(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_ExternalConverter$ExternalConverter$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_document_vocabularies_model_domain_External__Lamf_client_model_domain_External($as_Lamf_plugins_document_vocabularies_model_domain_External(from))
});
$c_Lamf_client_convert_ExternalConverter$ExternalConverter$.prototype.init___Lamf_client_convert_ExternalConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_ExternalConverter$ExternalConverter$.prototype.asClient__Lamf_plugins_document_vocabularies_model_domain_External__Lamf_client_model_domain_External = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_External($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_ExternalConverter$ExternalConverter$ = new $TypeData().initClass({
  Lamf_client_convert_ExternalConverter$ExternalConverter$: 0
}, false, "amf.client.convert.ExternalConverter$ExternalConverter$", {
  Lamf_client_convert_ExternalConverter$ExternalConverter$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_ExternalConverter$ExternalConverter$.prototype.$classData = $d_Lamf_client_convert_ExternalConverter$ExternalConverter$;
/** @constructor */
function $c_Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$.prototype.constructor = $c_Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$;
/** @constructor */
function $h_Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$.prototype = $c_Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$.prototype;
$c_Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$.prototype.init___Lamf_client_convert_FieldConverter = (function($$outer) {
  return this
});
$c_Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_Annotations(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_core_parser_Annotations(from);
  return new $c_Lamf_client_model_Annotations().init___Lamf_core_parser_Annotations(from$1)
});
var $d_Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$: 0
}, false, "amf.client.convert.FieldConverter$AnnotationsFieldMatcher$", {
  Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$.prototype.$classData = $d_Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$;
/** @constructor */
function $c_Lamf_client_convert_FileShapeConverter$FileShapeMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_FileShapeConverter$FileShapeMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_FileShapeConverter$FileShapeMatcher$.prototype.constructor = $c_Lamf_client_convert_FileShapeConverter$FileShapeMatcher$;
/** @constructor */
function $h_Lamf_client_convert_FileShapeConverter$FileShapeMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_FileShapeConverter$FileShapeMatcher$.prototype = $c_Lamf_client_convert_FileShapeConverter$FileShapeMatcher$.prototype;
$c_Lamf_client_convert_FileShapeConverter$FileShapeMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_FileShape(from);
  return $as_Lamf_plugins_domain_shapes_models_FileShape(from$1.$$undinternal$1)
});
$c_Lamf_client_convert_FileShapeConverter$FileShapeMatcher$.prototype.init___Lamf_client_convert_FileShapeConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_FileShapeConverter$FileShapeMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_shapes_models_FileShape__Lamf_client_model_domain_FileShape($as_Lamf_plugins_domain_shapes_models_FileShape(from))
});
$c_Lamf_client_convert_FileShapeConverter$FileShapeMatcher$.prototype.asClient__Lamf_plugins_domain_shapes_models_FileShape__Lamf_client_model_domain_FileShape = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_FileShape($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_FileShapeConverter$FileShapeMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_FileShapeConverter$FileShapeMatcher$: 0
}, false, "amf.client.convert.FileShapeConverter$FileShapeMatcher$", {
  Lamf_client_convert_FileShapeConverter$FileShapeMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_FileShapeConverter$FileShapeMatcher$.prototype.$classData = $d_Lamf_client_convert_FileShapeConverter$FileShapeMatcher$;
/** @constructor */
function $c_Lamf_client_convert_GraphDomainConverter$GraphDomainConverter$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_GraphDomainConverter$GraphDomainConverter$.prototype = new $h_O();
$c_Lamf_client_convert_GraphDomainConverter$GraphDomainConverter$.prototype.constructor = $c_Lamf_client_convert_GraphDomainConverter$GraphDomainConverter$;
/** @constructor */
function $h_Lamf_client_convert_GraphDomainConverter$GraphDomainConverter$() {
  /*<skip>*/
}
$h_Lamf_client_convert_GraphDomainConverter$GraphDomainConverter$.prototype = $c_Lamf_client_convert_GraphDomainConverter$GraphDomainConverter$.prototype;
$c_Lamf_client_convert_GraphDomainConverter$GraphDomainConverter$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Graph(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_GraphDomainConverter$GraphDomainConverter$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_core_model_domain_Graph(from);
  return new $c_Lamf_client_model_domain_Graph().init___Lamf_core_model_domain_Graph(from$1)
});
$c_Lamf_client_convert_GraphDomainConverter$GraphDomainConverter$.prototype.init___Lamf_client_convert_GraphDomainConverter = (function($$outer) {
  return this
});
var $d_Lamf_client_convert_GraphDomainConverter$GraphDomainConverter$ = new $TypeData().initClass({
  Lamf_client_convert_GraphDomainConverter$GraphDomainConverter$: 0
}, false, "amf.client.convert.GraphDomainConverter$GraphDomainConverter$", {
  Lamf_client_convert_GraphDomainConverter$GraphDomainConverter$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_GraphDomainConverter$GraphDomainConverter$.prototype.$classData = $d_Lamf_client_convert_GraphDomainConverter$GraphDomainConverter$;
/** @constructor */
function $c_Lamf_client_convert_HttpMessageBindingConverter$HttpMessageBindingMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_HttpMessageBindingConverter$HttpMessageBindingMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_HttpMessageBindingConverter$HttpMessageBindingMatcher$.prototype.constructor = $c_Lamf_client_convert_HttpMessageBindingConverter$HttpMessageBindingMatcher$;
/** @constructor */
function $h_Lamf_client_convert_HttpMessageBindingConverter$HttpMessageBindingMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_HttpMessageBindingConverter$HttpMessageBindingMatcher$.prototype = $c_Lamf_client_convert_HttpMessageBindingConverter$HttpMessageBindingMatcher$.prototype;
$c_Lamf_client_convert_HttpMessageBindingConverter$HttpMessageBindingMatcher$.prototype.init___Lamf_client_convert_HttpMessageBindingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_HttpMessageBindingConverter$HttpMessageBindingMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_HttpMessageBinding(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_HttpMessageBindingConverter$HttpMessageBindingMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding__Lamf_client_model_domain_HttpMessageBinding = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_HttpMessageBinding($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_HttpMessageBindingConverter$HttpMessageBindingMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding__Lamf_client_model_domain_HttpMessageBinding($as_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding(from))
});
var $d_Lamf_client_convert_HttpMessageBindingConverter$HttpMessageBindingMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_HttpMessageBindingConverter$HttpMessageBindingMatcher$: 0
}, false, "amf.client.convert.HttpMessageBindingConverter$HttpMessageBindingMatcher$", {
  Lamf_client_convert_HttpMessageBindingConverter$HttpMessageBindingMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_HttpMessageBindingConverter$HttpMessageBindingMatcher$.prototype.$classData = $d_Lamf_client_convert_HttpMessageBindingConverter$HttpMessageBindingMatcher$;
/** @constructor */
function $c_Lamf_client_convert_HttpOperationBindingConverter$HttpOperationBindingMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_HttpOperationBindingConverter$HttpOperationBindingMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_HttpOperationBindingConverter$HttpOperationBindingMatcher$.prototype.constructor = $c_Lamf_client_convert_HttpOperationBindingConverter$HttpOperationBindingMatcher$;
/** @constructor */
function $h_Lamf_client_convert_HttpOperationBindingConverter$HttpOperationBindingMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_HttpOperationBindingConverter$HttpOperationBindingMatcher$.prototype = $c_Lamf_client_convert_HttpOperationBindingConverter$HttpOperationBindingMatcher$.prototype;
$c_Lamf_client_convert_HttpOperationBindingConverter$HttpOperationBindingMatcher$.prototype.init___Lamf_client_convert_HttpOperationBindingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_HttpOperationBindingConverter$HttpOperationBindingMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_HttpOperationBinding(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_HttpOperationBindingConverter$HttpOperationBindingMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding__Lamf_client_model_domain_HttpOperationBinding($as_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding(from))
});
$c_Lamf_client_convert_HttpOperationBindingConverter$HttpOperationBindingMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding__Lamf_client_model_domain_HttpOperationBinding = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_HttpOperationBinding($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_HttpOperationBindingConverter$HttpOperationBindingMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_HttpOperationBindingConverter$HttpOperationBindingMatcher$: 0
}, false, "amf.client.convert.HttpOperationBindingConverter$HttpOperationBindingMatcher$", {
  Lamf_client_convert_HttpOperationBindingConverter$HttpOperationBindingMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_HttpOperationBindingConverter$HttpOperationBindingMatcher$.prototype.$classData = $d_Lamf_client_convert_HttpOperationBindingConverter$HttpOperationBindingMatcher$;
/** @constructor */
function $c_Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$.prototype = new $h_O();
$c_Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$.prototype.constructor = $c_Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$;
/** @constructor */
function $h_Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$() {
  /*<skip>*/
}
$h_Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$.prototype = $c_Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$.prototype;
$c_Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$.prototype.asClient__Lamf_plugins_domain_webapi_models_IriTemplateMapping__Lamf_client_model_domain_IriTemplateMapping = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_IriTemplateMapping($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_IriTemplateMapping(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_IriTemplateMapping__Lamf_client_model_domain_IriTemplateMapping($as_Lamf_plugins_domain_webapi_models_IriTemplateMapping(from))
});
$c_Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$.prototype.init___Lamf_client_convert_IriTemplateMappingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$ = new $TypeData().initClass({
  Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$: 0
}, false, "amf.client.convert.IriTemplateMappingConverter$IriTemplateMappingConverter$", {
  Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$.prototype.$classData = $d_Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$;
/** @constructor */
function $c_Lamf_client_convert_KafkaMessageBindingConverter$KafkaMessageBindingMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_KafkaMessageBindingConverter$KafkaMessageBindingMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_KafkaMessageBindingConverter$KafkaMessageBindingMatcher$.prototype.constructor = $c_Lamf_client_convert_KafkaMessageBindingConverter$KafkaMessageBindingMatcher$;
/** @constructor */
function $h_Lamf_client_convert_KafkaMessageBindingConverter$KafkaMessageBindingMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_KafkaMessageBindingConverter$KafkaMessageBindingMatcher$.prototype = $c_Lamf_client_convert_KafkaMessageBindingConverter$KafkaMessageBindingMatcher$.prototype;
$c_Lamf_client_convert_KafkaMessageBindingConverter$KafkaMessageBindingMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_KafkaMessageBinding(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_KafkaMessageBindingConverter$KafkaMessageBindingMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding__Lamf_client_model_domain_KafkaMessageBinding = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_KafkaMessageBinding($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_KafkaMessageBindingConverter$KafkaMessageBindingMatcher$.prototype.init___Lamf_client_convert_KafkaMessageBindingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_KafkaMessageBindingConverter$KafkaMessageBindingMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding__Lamf_client_model_domain_KafkaMessageBinding($as_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding(from))
});
var $d_Lamf_client_convert_KafkaMessageBindingConverter$KafkaMessageBindingMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_KafkaMessageBindingConverter$KafkaMessageBindingMatcher$: 0
}, false, "amf.client.convert.KafkaMessageBindingConverter$KafkaMessageBindingMatcher$", {
  Lamf_client_convert_KafkaMessageBindingConverter$KafkaMessageBindingMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_KafkaMessageBindingConverter$KafkaMessageBindingMatcher$.prototype.$classData = $d_Lamf_client_convert_KafkaMessageBindingConverter$KafkaMessageBindingMatcher$;
/** @constructor */
function $c_Lamf_client_convert_KafkaOperationBindingConverter$KafkaOperationBindingMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_KafkaOperationBindingConverter$KafkaOperationBindingMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_KafkaOperationBindingConverter$KafkaOperationBindingMatcher$.prototype.constructor = $c_Lamf_client_convert_KafkaOperationBindingConverter$KafkaOperationBindingMatcher$;
/** @constructor */
function $h_Lamf_client_convert_KafkaOperationBindingConverter$KafkaOperationBindingMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_KafkaOperationBindingConverter$KafkaOperationBindingMatcher$.prototype = $c_Lamf_client_convert_KafkaOperationBindingConverter$KafkaOperationBindingMatcher$.prototype;
$c_Lamf_client_convert_KafkaOperationBindingConverter$KafkaOperationBindingMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_KafkaOperationBinding(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_KafkaOperationBindingConverter$KafkaOperationBindingMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding__Lamf_client_model_domain_KafkaOperationBinding($as_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding(from))
});
$c_Lamf_client_convert_KafkaOperationBindingConverter$KafkaOperationBindingMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding__Lamf_client_model_domain_KafkaOperationBinding = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_KafkaOperationBinding($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_KafkaOperationBindingConverter$KafkaOperationBindingMatcher$.prototype.init___Lamf_client_convert_KafkaOperationBindingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_KafkaOperationBindingConverter$KafkaOperationBindingMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_KafkaOperationBindingConverter$KafkaOperationBindingMatcher$: 0
}, false, "amf.client.convert.KafkaOperationBindingConverter$KafkaOperationBindingMatcher$", {
  Lamf_client_convert_KafkaOperationBindingConverter$KafkaOperationBindingMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_KafkaOperationBindingConverter$KafkaOperationBindingMatcher$.prototype.$classData = $d_Lamf_client_convert_KafkaOperationBindingConverter$KafkaOperationBindingMatcher$;
/** @constructor */
function $c_Lamf_client_convert_LicenseConverter$LicenseMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_LicenseConverter$LicenseMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_LicenseConverter$LicenseMatcher$.prototype.constructor = $c_Lamf_client_convert_LicenseConverter$LicenseMatcher$;
/** @constructor */
function $h_Lamf_client_convert_LicenseConverter$LicenseMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_LicenseConverter$LicenseMatcher$.prototype = $c_Lamf_client_convert_LicenseConverter$LicenseMatcher$.prototype;
$c_Lamf_client_convert_LicenseConverter$LicenseMatcher$.prototype.init___Lamf_client_convert_LicenseConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_LicenseConverter$LicenseMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_License(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_LicenseConverter$LicenseMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_License__Lamf_client_model_domain_License = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_License($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_LicenseConverter$LicenseMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_License__Lamf_client_model_domain_License($as_Lamf_plugins_domain_webapi_models_License(from))
});
var $d_Lamf_client_convert_LicenseConverter$LicenseMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_LicenseConverter$LicenseMatcher$: 0
}, false, "amf.client.convert.LicenseConverter$LicenseMatcher$", {
  Lamf_client_convert_LicenseConverter$LicenseMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_LicenseConverter$LicenseMatcher$.prototype.$classData = $d_Lamf_client_convert_LicenseConverter$LicenseMatcher$;
/** @constructor */
function $c_Lamf_client_convert_MessageBindingConverter$MessageBindingMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_MessageBindingConverter$MessageBindingMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_MessageBindingConverter$MessageBindingMatcher$.prototype.constructor = $c_Lamf_client_convert_MessageBindingConverter$MessageBindingMatcher$;
/** @constructor */
function $h_Lamf_client_convert_MessageBindingConverter$MessageBindingMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_MessageBindingConverter$MessageBindingMatcher$.prototype = $c_Lamf_client_convert_MessageBindingConverter$MessageBindingMatcher$.prototype;
$c_Lamf_client_convert_MessageBindingConverter$MessageBindingMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_MessageBinding(from);
  return from$1.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_MessageBinding()
});
$c_Lamf_client_convert_MessageBindingConverter$MessageBindingMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_MessageBinding__Lamf_client_model_domain_MessageBinding($as_Lamf_plugins_domain_webapi_models_bindings_MessageBinding(from))
});
$c_Lamf_client_convert_MessageBindingConverter$MessageBindingMatcher$.prototype.init___Lamf_client_convert_MessageBindingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_MessageBindingConverter$MessageBindingMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_MessageBinding__Lamf_client_model_domain_MessageBinding = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_MessageBinding($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_MessageBindingConverter$MessageBindingMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_MessageBindingConverter$MessageBindingMatcher$: 0
}, false, "amf.client.convert.MessageBindingConverter$MessageBindingMatcher$", {
  Lamf_client_convert_MessageBindingConverter$MessageBindingMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_MessageBindingConverter$MessageBindingMatcher$.prototype.$classData = $d_Lamf_client_convert_MessageBindingConverter$MessageBindingMatcher$;
/** @constructor */
function $c_Lamf_client_convert_MessageBindingsConverter$MessageBindingsMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_MessageBindingsConverter$MessageBindingsMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_MessageBindingsConverter$MessageBindingsMatcher$.prototype.constructor = $c_Lamf_client_convert_MessageBindingsConverter$MessageBindingsMatcher$;
/** @constructor */
function $h_Lamf_client_convert_MessageBindingsConverter$MessageBindingsMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_MessageBindingsConverter$MessageBindingsMatcher$.prototype = $c_Lamf_client_convert_MessageBindingsConverter$MessageBindingsMatcher$.prototype;
$c_Lamf_client_convert_MessageBindingsConverter$MessageBindingsMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_MessageBindings__Lamf_client_model_domain_MessageBindings = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_MessageBindings($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_MessageBindingsConverter$MessageBindingsMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_MessageBindings(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_MessageBindingsConverter$MessageBindingsMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_MessageBindings__Lamf_client_model_domain_MessageBindings($as_Lamf_plugins_domain_webapi_models_bindings_MessageBindings(from))
});
$c_Lamf_client_convert_MessageBindingsConverter$MessageBindingsMatcher$.prototype.init___Lamf_client_convert_MessageBindingsConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_MessageBindingsConverter$MessageBindingsMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_MessageBindingsConverter$MessageBindingsMatcher$: 0
}, false, "amf.client.convert.MessageBindingsConverter$MessageBindingsMatcher$", {
  Lamf_client_convert_MessageBindingsConverter$MessageBindingsMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_MessageBindingsConverter$MessageBindingsMatcher$.prototype.$classData = $d_Lamf_client_convert_MessageBindingsConverter$MessageBindingsMatcher$;
/** @constructor */
function $c_Lamf_client_convert_MessageConverter$MessageMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_MessageConverter$MessageMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_MessageConverter$MessageMatcher$.prototype.constructor = $c_Lamf_client_convert_MessageConverter$MessageMatcher$;
/** @constructor */
function $h_Lamf_client_convert_MessageConverter$MessageMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_MessageConverter$MessageMatcher$.prototype = $c_Lamf_client_convert_MessageConverter$MessageMatcher$.prototype;
$c_Lamf_client_convert_MessageConverter$MessageMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Message(from);
  return from$1.$$undinternal__Lamf_plugins_domain_webapi_models_Message()
});
$c_Lamf_client_convert_MessageConverter$MessageMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_Message__Lamf_client_model_domain_Message($as_Lamf_plugins_domain_webapi_models_Message(from))
});
$c_Lamf_client_convert_MessageConverter$MessageMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_Message__Lamf_client_model_domain_Message = (function(from) {
  if ((from instanceof $c_Lamf_plugins_domain_webapi_models_Request)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_Request(from);
    return this.$$outer$1.RequestMatcher__Lamf_client_convert_MessageConverter$RequestMatcher$().asClient__Lamf_plugins_domain_webapi_models_Request__Lamf_client_model_domain_Request(x2)
  } else if ((from instanceof $c_Lamf_plugins_domain_webapi_models_Response)) {
    var x3 = $as_Lamf_plugins_domain_webapi_models_Response(from);
    return this.$$outer$1.ResponseMatcher__Lamf_client_convert_MessageConverter$ResponseMatcher$().asClient__Lamf_plugins_domain_webapi_models_Response__Lamf_client_model_domain_Response(x3)
  } else {
    return ((from !== null) ? new $c_Lamf_client_model_domain_Message().init___Lamf_plugins_domain_webapi_models_Message(from) : null)
  }
});
$c_Lamf_client_convert_MessageConverter$MessageMatcher$.prototype.init___Lamf_client_convert_MessageConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_MessageConverter$MessageMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_MessageConverter$MessageMatcher$: 0
}, false, "amf.client.convert.MessageConverter$MessageMatcher$", {
  Lamf_client_convert_MessageConverter$MessageMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_MessageConverter$MessageMatcher$.prototype.$classData = $d_Lamf_client_convert_MessageConverter$MessageMatcher$;
/** @constructor */
function $c_Lamf_client_convert_MessageConverter$RequestMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_MessageConverter$RequestMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_MessageConverter$RequestMatcher$.prototype.constructor = $c_Lamf_client_convert_MessageConverter$RequestMatcher$;
/** @constructor */
function $h_Lamf_client_convert_MessageConverter$RequestMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_MessageConverter$RequestMatcher$.prototype = $c_Lamf_client_convert_MessageConverter$RequestMatcher$.prototype;
$c_Lamf_client_convert_MessageConverter$RequestMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Request(from);
  return $as_Lamf_plugins_domain_webapi_models_Request(from$1.$$undinternal$1)
});
$c_Lamf_client_convert_MessageConverter$RequestMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_Request__Lamf_client_model_domain_Request($as_Lamf_plugins_domain_webapi_models_Request(from))
});
$c_Lamf_client_convert_MessageConverter$RequestMatcher$.prototype.init___Lamf_client_convert_MessageConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_MessageConverter$RequestMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_Request__Lamf_client_model_domain_Request = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_Request($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_MessageConverter$RequestMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_MessageConverter$RequestMatcher$: 0
}, false, "amf.client.convert.MessageConverter$RequestMatcher$", {
  Lamf_client_convert_MessageConverter$RequestMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_MessageConverter$RequestMatcher$.prototype.$classData = $d_Lamf_client_convert_MessageConverter$RequestMatcher$;
/** @constructor */
function $c_Lamf_client_convert_MessageConverter$ResponseMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_MessageConverter$ResponseMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_MessageConverter$ResponseMatcher$.prototype.constructor = $c_Lamf_client_convert_MessageConverter$ResponseMatcher$;
/** @constructor */
function $h_Lamf_client_convert_MessageConverter$ResponseMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_MessageConverter$ResponseMatcher$.prototype = $c_Lamf_client_convert_MessageConverter$ResponseMatcher$.prototype;
$c_Lamf_client_convert_MessageConverter$ResponseMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Response(from);
  return $as_Lamf_plugins_domain_webapi_models_Response(from$1.$$undinternal$1)
});
$c_Lamf_client_convert_MessageConverter$ResponseMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_Response__Lamf_client_model_domain_Response($as_Lamf_plugins_domain_webapi_models_Response(from))
});
$c_Lamf_client_convert_MessageConverter$ResponseMatcher$.prototype.init___Lamf_client_convert_MessageConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_MessageConverter$ResponseMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_Response__Lamf_client_model_domain_Response = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_Response($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_MessageConverter$ResponseMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_MessageConverter$ResponseMatcher$: 0
}, false, "amf.client.convert.MessageConverter$ResponseMatcher$", {
  Lamf_client_convert_MessageConverter$ResponseMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_MessageConverter$ResponseMatcher$.prototype.$classData = $d_Lamf_client_convert_MessageConverter$ResponseMatcher$;
/** @constructor */
function $c_Lamf_client_convert_MqttMessageBindingConverter$MqttMessageBindingMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_MqttMessageBindingConverter$MqttMessageBindingMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_MqttMessageBindingConverter$MqttMessageBindingMatcher$.prototype.constructor = $c_Lamf_client_convert_MqttMessageBindingConverter$MqttMessageBindingMatcher$;
/** @constructor */
function $h_Lamf_client_convert_MqttMessageBindingConverter$MqttMessageBindingMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_MqttMessageBindingConverter$MqttMessageBindingMatcher$.prototype = $c_Lamf_client_convert_MqttMessageBindingConverter$MqttMessageBindingMatcher$.prototype;
$c_Lamf_client_convert_MqttMessageBindingConverter$MqttMessageBindingMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_MqttMessageBinding(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_MqttMessageBindingConverter$MqttMessageBindingMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding__Lamf_client_model_domain_MqttMessageBinding($as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding(from))
});
$c_Lamf_client_convert_MqttMessageBindingConverter$MqttMessageBindingMatcher$.prototype.init___Lamf_client_convert_MqttMessageBindingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_MqttMessageBindingConverter$MqttMessageBindingMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding__Lamf_client_model_domain_MqttMessageBinding = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_MqttMessageBinding($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_MqttMessageBindingConverter$MqttMessageBindingMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_MqttMessageBindingConverter$MqttMessageBindingMatcher$: 0
}, false, "amf.client.convert.MqttMessageBindingConverter$MqttMessageBindingMatcher$", {
  Lamf_client_convert_MqttMessageBindingConverter$MqttMessageBindingMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_MqttMessageBindingConverter$MqttMessageBindingMatcher$.prototype.$classData = $d_Lamf_client_convert_MqttMessageBindingConverter$MqttMessageBindingMatcher$;
/** @constructor */
function $c_Lamf_client_convert_MqttOperationBindingConverter$MqttOperationBindingMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_MqttOperationBindingConverter$MqttOperationBindingMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_MqttOperationBindingConverter$MqttOperationBindingMatcher$.prototype.constructor = $c_Lamf_client_convert_MqttOperationBindingConverter$MqttOperationBindingMatcher$;
/** @constructor */
function $h_Lamf_client_convert_MqttOperationBindingConverter$MqttOperationBindingMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_MqttOperationBindingConverter$MqttOperationBindingMatcher$.prototype = $c_Lamf_client_convert_MqttOperationBindingConverter$MqttOperationBindingMatcher$.prototype;
$c_Lamf_client_convert_MqttOperationBindingConverter$MqttOperationBindingMatcher$.prototype.init___Lamf_client_convert_MqttOperationBindingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_MqttOperationBindingConverter$MqttOperationBindingMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_MqttOperationBinding(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_MqttOperationBindingConverter$MqttOperationBindingMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding__Lamf_client_model_domain_MqttOperationBinding($as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding(from))
});
$c_Lamf_client_convert_MqttOperationBindingConverter$MqttOperationBindingMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding__Lamf_client_model_domain_MqttOperationBinding = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_MqttOperationBinding($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_MqttOperationBindingConverter$MqttOperationBindingMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_MqttOperationBindingConverter$MqttOperationBindingMatcher$: 0
}, false, "amf.client.convert.MqttOperationBindingConverter$MqttOperationBindingMatcher$", {
  Lamf_client_convert_MqttOperationBindingConverter$MqttOperationBindingMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_MqttOperationBindingConverter$MqttOperationBindingMatcher$.prototype.$classData = $d_Lamf_client_convert_MqttOperationBindingConverter$MqttOperationBindingMatcher$;
/** @constructor */
function $c_Lamf_client_convert_MqttServerBindingConverter$MqttServerBindingMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_MqttServerBindingConverter$MqttServerBindingMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_MqttServerBindingConverter$MqttServerBindingMatcher$.prototype.constructor = $c_Lamf_client_convert_MqttServerBindingConverter$MqttServerBindingMatcher$;
/** @constructor */
function $h_Lamf_client_convert_MqttServerBindingConverter$MqttServerBindingMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_MqttServerBindingConverter$MqttServerBindingMatcher$.prototype = $c_Lamf_client_convert_MqttServerBindingConverter$MqttServerBindingMatcher$.prototype;
$c_Lamf_client_convert_MqttServerBindingConverter$MqttServerBindingMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_MqttServerBinding(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_MqttServerBindingConverter$MqttServerBindingMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding__Lamf_client_model_domain_MqttServerBinding($as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding(from))
});
$c_Lamf_client_convert_MqttServerBindingConverter$MqttServerBindingMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding__Lamf_client_model_domain_MqttServerBinding = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_MqttServerBinding($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_MqttServerBindingConverter$MqttServerBindingMatcher$.prototype.init___Lamf_client_convert_MqttServerBindingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_MqttServerBindingConverter$MqttServerBindingMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_MqttServerBindingConverter$MqttServerBindingMatcher$: 0
}, false, "amf.client.convert.MqttServerBindingConverter$MqttServerBindingMatcher$", {
  Lamf_client_convert_MqttServerBindingConverter$MqttServerBindingMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_MqttServerBindingConverter$MqttServerBindingMatcher$.prototype.$classData = $d_Lamf_client_convert_MqttServerBindingConverter$MqttServerBindingMatcher$;
/** @constructor */
function $c_Lamf_client_convert_MqttServerLastWillConverter$MqttServerLastWillMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_MqttServerLastWillConverter$MqttServerLastWillMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_MqttServerLastWillConverter$MqttServerLastWillMatcher$.prototype.constructor = $c_Lamf_client_convert_MqttServerLastWillConverter$MqttServerLastWillMatcher$;
/** @constructor */
function $h_Lamf_client_convert_MqttServerLastWillConverter$MqttServerLastWillMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_MqttServerLastWillConverter$MqttServerLastWillMatcher$.prototype = $c_Lamf_client_convert_MqttServerLastWillConverter$MqttServerLastWillMatcher$.prototype;
$c_Lamf_client_convert_MqttServerLastWillConverter$MqttServerLastWillMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_MqttServerLastWill(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_MqttServerLastWillConverter$MqttServerLastWillMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill__Lamf_client_model_domain_MqttServerLastWill($as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill(from))
});
$c_Lamf_client_convert_MqttServerLastWillConverter$MqttServerLastWillMatcher$.prototype.init___Lamf_client_convert_MqttServerLastWillConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_MqttServerLastWillConverter$MqttServerLastWillMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill__Lamf_client_model_domain_MqttServerLastWill = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_MqttServerLastWill($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_MqttServerLastWillConverter$MqttServerLastWillMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_MqttServerLastWillConverter$MqttServerLastWillMatcher$: 0
}, false, "amf.client.convert.MqttServerLastWillConverter$MqttServerLastWillMatcher$", {
  Lamf_client_convert_MqttServerLastWillConverter$MqttServerLastWillMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_MqttServerLastWillConverter$MqttServerLastWillMatcher$.prototype.$classData = $d_Lamf_client_convert_MqttServerLastWillConverter$MqttServerLastWillMatcher$;
/** @constructor */
function $c_Lamf_client_convert_NilShapeConverter$NilShapeMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_NilShapeConverter$NilShapeMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_NilShapeConverter$NilShapeMatcher$.prototype.constructor = $c_Lamf_client_convert_NilShapeConverter$NilShapeMatcher$;
/** @constructor */
function $h_Lamf_client_convert_NilShapeConverter$NilShapeMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_NilShapeConverter$NilShapeMatcher$.prototype = $c_Lamf_client_convert_NilShapeConverter$NilShapeMatcher$.prototype;
$c_Lamf_client_convert_NilShapeConverter$NilShapeMatcher$.prototype.init___Lamf_client_convert_NilShapeConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_NilShapeConverter$NilShapeMatcher$.prototype.asClient__Lamf_plugins_domain_shapes_models_NilShape__Lamf_client_model_domain_NilShape = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_NilShape($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_NilShapeConverter$NilShapeMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_NilShape(from);
  return $as_Lamf_plugins_domain_shapes_models_NilShape(from$1.$$undinternal$1)
});
$c_Lamf_client_convert_NilShapeConverter$NilShapeMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_shapes_models_NilShape__Lamf_client_model_domain_NilShape($as_Lamf_plugins_domain_shapes_models_NilShape(from))
});
var $d_Lamf_client_convert_NilShapeConverter$NilShapeMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_NilShapeConverter$NilShapeMatcher$: 0
}, false, "amf.client.convert.NilShapeConverter$NilShapeMatcher$", {
  Lamf_client_convert_NilShapeConverter$NilShapeMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_NilShapeConverter$NilShapeMatcher$.prototype.$classData = $d_Lamf_client_convert_NilShapeConverter$NilShapeMatcher$;
/** @constructor */
function $c_Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$.prototype = new $h_O();
$c_Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$.prototype.constructor = $c_Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$;
/** @constructor */
function $h_Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$() {
  /*<skip>*/
}
$h_Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$.prototype = $c_Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$.prototype;
$c_Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_NodeMapping(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_client_model_domain_NodeMapping($as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(from))
});
$c_Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$.prototype.init___Lamf_client_convert_NodeMappingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$.prototype.asClient__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_client_model_domain_NodeMapping = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_NodeMapping($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$ = new $TypeData().initClass({
  Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$: 0
}, false, "amf.client.convert.NodeMappingConverter$NodeMappingConverter$", {
  Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$.prototype.$classData = $d_Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$;
/** @constructor */
function $c_Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$.prototype.constructor = $c_Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$;
/** @constructor */
function $h_Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$.prototype = $c_Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$.prototype;
$c_Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$.prototype.asClient__Lamf_plugins_domain_shapes_models_NodeShape__Lamf_client_model_domain_NodeShape = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_NodeShape($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_NodeShape(from);
  return $as_Lamf_plugins_domain_shapes_models_NodeShape(from$1.$$undinternal$1)
});
$c_Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$.prototype.init___Lamf_client_convert_NodeShapeConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_shapes_models_NodeShape__Lamf_client_model_domain_NodeShape($as_Lamf_plugins_domain_shapes_models_NodeShape(from))
});
var $d_Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$: 0
}, false, "amf.client.convert.NodeShapeConverter$NodeShapeMatcher$", {
  Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$.prototype.$classData = $d_Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$;
/** @constructor */
function $c_Lamf_client_convert_OAuth2FlowConverter$OAuth2FlowMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_OAuth2FlowConverter$OAuth2FlowMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_OAuth2FlowConverter$OAuth2FlowMatcher$.prototype.constructor = $c_Lamf_client_convert_OAuth2FlowConverter$OAuth2FlowMatcher$;
/** @constructor */
function $h_Lamf_client_convert_OAuth2FlowConverter$OAuth2FlowMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_OAuth2FlowConverter$OAuth2FlowMatcher$.prototype = $c_Lamf_client_convert_OAuth2FlowConverter$OAuth2FlowMatcher$.prototype;
$c_Lamf_client_convert_OAuth2FlowConverter$OAuth2FlowMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_OAuth2Flow(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_OAuth2FlowConverter$OAuth2FlowMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_security_OAuth2Flow__Lamf_client_model_domain_OAuth2Flow = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_OAuth2Flow($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_OAuth2FlowConverter$OAuth2FlowMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_security_OAuth2Flow__Lamf_client_model_domain_OAuth2Flow($as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow(from))
});
$c_Lamf_client_convert_OAuth2FlowConverter$OAuth2FlowMatcher$.prototype.init___Lamf_client_convert_OAuth2FlowConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_OAuth2FlowConverter$OAuth2FlowMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_OAuth2FlowConverter$OAuth2FlowMatcher$: 0
}, false, "amf.client.convert.OAuth2FlowConverter$OAuth2FlowMatcher$", {
  Lamf_client_convert_OAuth2FlowConverter$OAuth2FlowMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_OAuth2FlowConverter$OAuth2FlowMatcher$.prototype.$classData = $d_Lamf_client_convert_OAuth2FlowConverter$OAuth2FlowMatcher$;
/** @constructor */
function $c_Lamf_client_convert_ObjectPropertyMappingConverter$ObjectPropertyMappingConverter$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_ObjectPropertyMappingConverter$ObjectPropertyMappingConverter$.prototype = new $h_O();
$c_Lamf_client_convert_ObjectPropertyMappingConverter$ObjectPropertyMappingConverter$.prototype.constructor = $c_Lamf_client_convert_ObjectPropertyMappingConverter$ObjectPropertyMappingConverter$;
/** @constructor */
function $h_Lamf_client_convert_ObjectPropertyMappingConverter$ObjectPropertyMappingConverter$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ObjectPropertyMappingConverter$ObjectPropertyMappingConverter$.prototype = $c_Lamf_client_convert_ObjectPropertyMappingConverter$ObjectPropertyMappingConverter$.prototype;
$c_Lamf_client_convert_ObjectPropertyMappingConverter$ObjectPropertyMappingConverter$.prototype.init___Lamf_client_convert_ObjectPropertyMappingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_ObjectPropertyMappingConverter$ObjectPropertyMappingConverter$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_ObjectPropertyTerm(from);
  return $as_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm(from$1.$$undinternal$1)
});
$c_Lamf_client_convert_ObjectPropertyMappingConverter$ObjectPropertyMappingConverter$.prototype.asClient__Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm__Lamf_client_model_domain_ObjectPropertyTerm = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_ObjectPropertyTerm($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_ObjectPropertyMappingConverter$ObjectPropertyMappingConverter$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm__Lamf_client_model_domain_ObjectPropertyTerm($as_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm(from))
});
var $d_Lamf_client_convert_ObjectPropertyMappingConverter$ObjectPropertyMappingConverter$ = new $TypeData().initClass({
  Lamf_client_convert_ObjectPropertyMappingConverter$ObjectPropertyMappingConverter$: 0
}, false, "amf.client.convert.ObjectPropertyMappingConverter$ObjectPropertyMappingConverter$", {
  Lamf_client_convert_ObjectPropertyMappingConverter$ObjectPropertyMappingConverter$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_ObjectPropertyMappingConverter$ObjectPropertyMappingConverter$.prototype.$classData = $d_Lamf_client_convert_ObjectPropertyMappingConverter$ObjectPropertyMappingConverter$;
/** @constructor */
function $c_Lamf_client_convert_OperationBindingConverter$OperationBindingMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_OperationBindingConverter$OperationBindingMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_OperationBindingConverter$OperationBindingMatcher$.prototype.constructor = $c_Lamf_client_convert_OperationBindingConverter$OperationBindingMatcher$;
/** @constructor */
function $h_Lamf_client_convert_OperationBindingConverter$OperationBindingMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_OperationBindingConverter$OperationBindingMatcher$.prototype = $c_Lamf_client_convert_OperationBindingConverter$OperationBindingMatcher$.prototype;
$c_Lamf_client_convert_OperationBindingConverter$OperationBindingMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_OperationBinding(from);
  return from$1.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_OperationBinding()
});
$c_Lamf_client_convert_OperationBindingConverter$OperationBindingMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_OperationBinding__Lamf_client_model_domain_OperationBinding($as_Lamf_plugins_domain_webapi_models_bindings_OperationBinding(from))
});
$c_Lamf_client_convert_OperationBindingConverter$OperationBindingMatcher$.prototype.init___Lamf_client_convert_OperationBindingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_OperationBindingConverter$OperationBindingMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_OperationBinding__Lamf_client_model_domain_OperationBinding = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_OperationBinding($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_OperationBindingConverter$OperationBindingMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_OperationBindingConverter$OperationBindingMatcher$: 0
}, false, "amf.client.convert.OperationBindingConverter$OperationBindingMatcher$", {
  Lamf_client_convert_OperationBindingConverter$OperationBindingMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_OperationBindingConverter$OperationBindingMatcher$.prototype.$classData = $d_Lamf_client_convert_OperationBindingConverter$OperationBindingMatcher$;
/** @constructor */
function $c_Lamf_client_convert_OperationBindingsConverter$OperationBindingsMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_OperationBindingsConverter$OperationBindingsMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_OperationBindingsConverter$OperationBindingsMatcher$.prototype.constructor = $c_Lamf_client_convert_OperationBindingsConverter$OperationBindingsMatcher$;
/** @constructor */
function $h_Lamf_client_convert_OperationBindingsConverter$OperationBindingsMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_OperationBindingsConverter$OperationBindingsMatcher$.prototype = $c_Lamf_client_convert_OperationBindingsConverter$OperationBindingsMatcher$.prototype;
$c_Lamf_client_convert_OperationBindingsConverter$OperationBindingsMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_OperationBindings__Lamf_client_model_domain_OperationBindings = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_OperationBindings($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_OperationBindingsConverter$OperationBindingsMatcher$.prototype.init___Lamf_client_convert_OperationBindingsConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_OperationBindingsConverter$OperationBindingsMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_OperationBindings(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_OperationBindingsConverter$OperationBindingsMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_OperationBindings__Lamf_client_model_domain_OperationBindings($as_Lamf_plugins_domain_webapi_models_bindings_OperationBindings(from))
});
var $d_Lamf_client_convert_OperationBindingsConverter$OperationBindingsMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_OperationBindingsConverter$OperationBindingsMatcher$: 0
}, false, "amf.client.convert.OperationBindingsConverter$OperationBindingsMatcher$", {
  Lamf_client_convert_OperationBindingsConverter$OperationBindingsMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_OperationBindingsConverter$OperationBindingsMatcher$.prototype.$classData = $d_Lamf_client_convert_OperationBindingsConverter$OperationBindingsMatcher$;
/** @constructor */
function $c_Lamf_client_convert_OperationConverter$OperationMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_OperationConverter$OperationMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_OperationConverter$OperationMatcher$.prototype.constructor = $c_Lamf_client_convert_OperationConverter$OperationMatcher$;
/** @constructor */
function $h_Lamf_client_convert_OperationConverter$OperationMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_OperationConverter$OperationMatcher$.prototype = $c_Lamf_client_convert_OperationConverter$OperationMatcher$.prototype;
$c_Lamf_client_convert_OperationConverter$OperationMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Operation(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_OperationConverter$OperationMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_Operation__Lamf_client_model_domain_Operation($as_Lamf_plugins_domain_webapi_models_Operation(from))
});
$c_Lamf_client_convert_OperationConverter$OperationMatcher$.prototype.init___Lamf_client_convert_OperationConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_OperationConverter$OperationMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_Operation__Lamf_client_model_domain_Operation = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_Operation($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_OperationConverter$OperationMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_OperationConverter$OperationMatcher$: 0
}, false, "amf.client.convert.OperationConverter$OperationMatcher$", {
  Lamf_client_convert_OperationConverter$OperationMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_OperationConverter$OperationMatcher$.prototype.$classData = $d_Lamf_client_convert_OperationConverter$OperationMatcher$;
/** @constructor */
function $c_Lamf_client_convert_OrganizationConverter$OrganizationMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_OrganizationConverter$OrganizationMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_OrganizationConverter$OrganizationMatcher$.prototype.constructor = $c_Lamf_client_convert_OrganizationConverter$OrganizationMatcher$;
/** @constructor */
function $h_Lamf_client_convert_OrganizationConverter$OrganizationMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_OrganizationConverter$OrganizationMatcher$.prototype = $c_Lamf_client_convert_OrganizationConverter$OrganizationMatcher$.prototype;
$c_Lamf_client_convert_OrganizationConverter$OrganizationMatcher$.prototype.init___Lamf_client_convert_OrganizationConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_OrganizationConverter$OrganizationMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Organization(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_OrganizationConverter$OrganizationMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_Organization__Lamf_client_model_domain_Organization($as_Lamf_plugins_domain_webapi_models_Organization(from))
});
$c_Lamf_client_convert_OrganizationConverter$OrganizationMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_Organization__Lamf_client_model_domain_Organization = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_Organization($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_OrganizationConverter$OrganizationMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_OrganizationConverter$OrganizationMatcher$: 0
}, false, "amf.client.convert.OrganizationConverter$OrganizationMatcher$", {
  Lamf_client_convert_OrganizationConverter$OrganizationMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_OrganizationConverter$OrganizationMatcher$.prototype.$classData = $d_Lamf_client_convert_OrganizationConverter$OrganizationMatcher$;
/** @constructor */
function $c_Lamf_client_convert_ParameterConverter$ParameterMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_ParameterConverter$ParameterMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_ParameterConverter$ParameterMatcher$.prototype.constructor = $c_Lamf_client_convert_ParameterConverter$ParameterMatcher$;
/** @constructor */
function $h_Lamf_client_convert_ParameterConverter$ParameterMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ParameterConverter$ParameterMatcher$.prototype = $c_Lamf_client_convert_ParameterConverter$ParameterMatcher$.prototype;
$c_Lamf_client_convert_ParameterConverter$ParameterMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Parameter(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_ParameterConverter$ParameterMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_Parameter__Lamf_client_model_domain_Parameter($as_Lamf_plugins_domain_webapi_models_Parameter(from))
});
$c_Lamf_client_convert_ParameterConverter$ParameterMatcher$.prototype.init___Lamf_client_convert_ParameterConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_ParameterConverter$ParameterMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_Parameter__Lamf_client_model_domain_Parameter = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_Parameter($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_ParameterConverter$ParameterMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_ParameterConverter$ParameterMatcher$: 0
}, false, "amf.client.convert.ParameterConverter$ParameterMatcher$", {
  Lamf_client_convert_ParameterConverter$ParameterMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_ParameterConverter$ParameterMatcher$.prototype.$classData = $d_Lamf_client_convert_ParameterConverter$ParameterMatcher$;
/** @constructor */
function $c_Lamf_client_convert_ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$.prototype.constructor = $c_Lamf_client_convert_ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$;
/** @constructor */
function $h_Lamf_client_convert_ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$.prototype = $c_Lamf_client_convert_ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$.prototype;
$c_Lamf_client_convert_ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_ParametrizedSecurityScheme(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme__Lamf_client_model_domain_ParametrizedSecurityScheme($as_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme(from))
});
$c_Lamf_client_convert_ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme__Lamf_client_model_domain_ParametrizedSecurityScheme = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_ParametrizedSecurityScheme($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$.prototype.init___Lamf_client_convert_ParametrizedSecuritySchemeConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$: 0
}, false, "amf.client.convert.ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$", {
  Lamf_client_convert_ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$.prototype.$classData = $d_Lamf_client_convert_ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$;
/** @constructor */
function $c_Lamf_client_convert_PayloadConverter$PayloadMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_PayloadConverter$PayloadMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_PayloadConverter$PayloadMatcher$.prototype.constructor = $c_Lamf_client_convert_PayloadConverter$PayloadMatcher$;
/** @constructor */
function $h_Lamf_client_convert_PayloadConverter$PayloadMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_PayloadConverter$PayloadMatcher$.prototype = $c_Lamf_client_convert_PayloadConverter$PayloadMatcher$.prototype;
$c_Lamf_client_convert_PayloadConverter$PayloadMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Payload(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_PayloadConverter$PayloadMatcher$.prototype.init___Lamf_client_convert_PayloadConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_PayloadConverter$PayloadMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_Payload__Lamf_client_model_domain_Payload($as_Lamf_plugins_domain_webapi_models_Payload(from))
});
$c_Lamf_client_convert_PayloadConverter$PayloadMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_Payload__Lamf_client_model_domain_Payload = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_Payload($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_PayloadConverter$PayloadMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_PayloadConverter$PayloadMatcher$: 0
}, false, "amf.client.convert.PayloadConverter$PayloadMatcher$", {
  Lamf_client_convert_PayloadConverter$PayloadMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_PayloadConverter$PayloadMatcher$.prototype.$classData = $d_Lamf_client_convert_PayloadConverter$PayloadMatcher$;
/** @constructor */
function $c_Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$.prototype.constructor = $c_Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$;
/** @constructor */
function $h_Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$.prototype = $c_Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$.prototype;
$c_Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_document_PayloadFragment(from);
  return $as_Lamf_core_model_document_PayloadFragment(from$1.$$undinternal$1)
});
$c_Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_core_model_document_PayloadFragment__Lamf_client_model_document_PayloadFragment($as_Lamf_core_model_document_PayloadFragment(from))
});
$c_Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$.prototype.asClient__Lamf_core_model_document_PayloadFragment__Lamf_client_model_document_PayloadFragment = (function(from) {
  var this$1 = this.$$outer$1.platform__Lamf_core_remote_Platform();
  return $as_Lamf_client_model_document_PayloadFragment($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$.prototype.init___Lamf_client_convert_PayloadFragmentConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$: 0
}, false, "amf.client.convert.PayloadFragmentConverter$PayloadFragmentMatcher$", {
  Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$.prototype.$classData = $d_Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$;
/** @constructor */
function $c_Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$.prototype.constructor = $c_Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$;
/** @constructor */
function $h_Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$.prototype = $c_Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$.prototype;
$c_Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_validate_PayloadValidator(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$.prototype.init___Lamf_client_convert_PayloadValidatorConverter = (function($$outer) {
  return this
});
$c_Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_core_validation_PayloadValidator(from);
  var this$2 = $m_Lamf_Core$().platform$1;
  return new $c_Lamf_client_validate_PayloadValidator().init___Lamf_core_validation_PayloadValidator__Lamf_client_execution_BaseExecutionEnvironment(from$1, this$2.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment())
});
var $d_Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$: 0
}, false, "amf.client.convert.PayloadValidatorConverter$PayloadValidatorMatcher$", {
  Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$.prototype.$classData = $d_Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$;
/** @constructor */
function $c_Lamf_client_convert_PropertyDependenciesConverter$PropertyDependenciesMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_PropertyDependenciesConverter$PropertyDependenciesMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_PropertyDependenciesConverter$PropertyDependenciesMatcher$.prototype.constructor = $c_Lamf_client_convert_PropertyDependenciesConverter$PropertyDependenciesMatcher$;
/** @constructor */
function $h_Lamf_client_convert_PropertyDependenciesConverter$PropertyDependenciesMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_PropertyDependenciesConverter$PropertyDependenciesMatcher$.prototype = $c_Lamf_client_convert_PropertyDependenciesConverter$PropertyDependenciesMatcher$.prototype;
$c_Lamf_client_convert_PropertyDependenciesConverter$PropertyDependenciesMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_PropertyDependencies(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_PropertyDependenciesConverter$PropertyDependenciesMatcher$.prototype.init___Lamf_client_convert_PropertyDependenciesConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_PropertyDependenciesConverter$PropertyDependenciesMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_shapes_models_PropertyDependencies__Lamf_client_model_domain_PropertyDependencies($as_Lamf_plugins_domain_shapes_models_PropertyDependencies(from))
});
$c_Lamf_client_convert_PropertyDependenciesConverter$PropertyDependenciesMatcher$.prototype.asClient__Lamf_plugins_domain_shapes_models_PropertyDependencies__Lamf_client_model_domain_PropertyDependencies = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_PropertyDependencies($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_PropertyDependenciesConverter$PropertyDependenciesMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_PropertyDependenciesConverter$PropertyDependenciesMatcher$: 0
}, false, "amf.client.convert.PropertyDependenciesConverter$PropertyDependenciesMatcher$", {
  Lamf_client_convert_PropertyDependenciesConverter$PropertyDependenciesMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_PropertyDependenciesConverter$PropertyDependenciesMatcher$.prototype.$classData = $d_Lamf_client_convert_PropertyDependenciesConverter$PropertyDependenciesMatcher$;
/** @constructor */
function $c_Lamf_client_convert_PropertyMappingConverter$PropertyMappingConverter$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_PropertyMappingConverter$PropertyMappingConverter$.prototype = new $h_O();
$c_Lamf_client_convert_PropertyMappingConverter$PropertyMappingConverter$.prototype.constructor = $c_Lamf_client_convert_PropertyMappingConverter$PropertyMappingConverter$;
/** @constructor */
function $h_Lamf_client_convert_PropertyMappingConverter$PropertyMappingConverter$() {
  /*<skip>*/
}
$h_Lamf_client_convert_PropertyMappingConverter$PropertyMappingConverter$.prototype = $c_Lamf_client_convert_PropertyMappingConverter$PropertyMappingConverter$.prototype;
$c_Lamf_client_convert_PropertyMappingConverter$PropertyMappingConverter$.prototype.asClient__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_client_model_domain_PropertyMapping = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_PropertyMapping($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_PropertyMappingConverter$PropertyMappingConverter$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_PropertyMapping(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_PropertyMappingConverter$PropertyMappingConverter$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_client_model_domain_PropertyMapping($as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(from))
});
$c_Lamf_client_convert_PropertyMappingConverter$PropertyMappingConverter$.prototype.init___Lamf_client_convert_PropertyMappingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_PropertyMappingConverter$PropertyMappingConverter$ = new $TypeData().initClass({
  Lamf_client_convert_PropertyMappingConverter$PropertyMappingConverter$: 0
}, false, "amf.client.convert.PropertyMappingConverter$PropertyMappingConverter$", {
  Lamf_client_convert_PropertyMappingConverter$PropertyMappingConverter$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_PropertyMappingConverter$PropertyMappingConverter$.prototype.$classData = $d_Lamf_client_convert_PropertyMappingConverter$PropertyMappingConverter$;
/** @constructor */
function $c_Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$.prototype.constructor = $c_Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$;
/** @constructor */
function $h_Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$.prototype = $c_Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$.prototype;
$c_Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$.prototype.asClient__Lamf_core_model_domain_extensions_PropertyShape__Lamf_client_model_domain_PropertyShape = (function(from) {
  var this$1 = this.$$outer$1.platform__Lamf_core_remote_Platform();
  return $as_Lamf_client_model_domain_PropertyShape($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_PropertyShape(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_core_model_domain_extensions_PropertyShape__Lamf_client_model_domain_PropertyShape($as_Lamf_core_model_domain_extensions_PropertyShape(from))
});
$c_Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$.prototype.init___Lamf_client_convert_PropertyShapeConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$: 0
}, false, "amf.client.convert.PropertyShapeConverter$PropertyShapeMatcher$", {
  Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$.prototype.$classData = $d_Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$;
/** @constructor */
function $c_Lamf_client_convert_PublicNodeMappingConverter$PublicNodeMappingConverter$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_PublicNodeMappingConverter$PublicNodeMappingConverter$.prototype = new $h_O();
$c_Lamf_client_convert_PublicNodeMappingConverter$PublicNodeMappingConverter$.prototype.constructor = $c_Lamf_client_convert_PublicNodeMappingConverter$PublicNodeMappingConverter$;
/** @constructor */
function $h_Lamf_client_convert_PublicNodeMappingConverter$PublicNodeMappingConverter$() {
  /*<skip>*/
}
$h_Lamf_client_convert_PublicNodeMappingConverter$PublicNodeMappingConverter$.prototype = $c_Lamf_client_convert_PublicNodeMappingConverter$PublicNodeMappingConverter$.prototype;
$c_Lamf_client_convert_PublicNodeMappingConverter$PublicNodeMappingConverter$.prototype.init___Lamf_client_convert_PublicNodeMappingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_PublicNodeMappingConverter$PublicNodeMappingConverter$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_PublicNodeMapping(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_PublicNodeMappingConverter$PublicNodeMappingConverter$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping__Lamf_client_model_domain_PublicNodeMapping($as_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping(from))
});
$c_Lamf_client_convert_PublicNodeMappingConverter$PublicNodeMappingConverter$.prototype.asClient__Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping__Lamf_client_model_domain_PublicNodeMapping = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_PublicNodeMapping($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_PublicNodeMappingConverter$PublicNodeMappingConverter$ = new $TypeData().initClass({
  Lamf_client_convert_PublicNodeMappingConverter$PublicNodeMappingConverter$: 0
}, false, "amf.client.convert.PublicNodeMappingConverter$PublicNodeMappingConverter$", {
  Lamf_client_convert_PublicNodeMappingConverter$PublicNodeMappingConverter$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_PublicNodeMappingConverter$PublicNodeMappingConverter$.prototype.$classData = $d_Lamf_client_convert_PublicNodeMappingConverter$PublicNodeMappingConverter$;
/** @constructor */
function $c_Lamf_client_convert_ReferenceResolverConverter$ReferenceResolverMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_ReferenceResolverConverter$ReferenceResolverMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_ReferenceResolverConverter$ReferenceResolverMatcher$.prototype.constructor = $c_Lamf_client_convert_ReferenceResolverConverter$ReferenceResolverMatcher$;
/** @constructor */
function $h_Lamf_client_convert_ReferenceResolverConverter$ReferenceResolverMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ReferenceResolverConverter$ReferenceResolverMatcher$.prototype = $c_Lamf_client_convert_ReferenceResolverConverter$ReferenceResolverMatcher$.prototype;
$c_Lamf_client_convert_ReferenceResolverConverter$ReferenceResolverMatcher$.prototype.asClient__Lamf_internal_reference_ReferenceResolver__s_concurrent_ExecutionContext__Lamf_client_reference_ReferenceResolver = (function(from, executionContext) {
  if ((from instanceof $c_Lamf_internal_reference_ReferenceResolverAdapter)) {
    var x2 = $as_Lamf_internal_reference_ReferenceResolverAdapter(from);
    var adaptee = x2.adaptee$1;
    return adaptee
  } else {
    throw new $c_s_MatchError().init___O(from)
  }
});
$c_Lamf_client_convert_ReferenceResolverConverter$ReferenceResolverMatcher$.prototype.init___Lamf_client_convert_ReferenceResolverConverter = (function($$outer) {
  return this
});
$c_Lamf_client_convert_ReferenceResolverConverter$ReferenceResolverMatcher$.prototype.asInternal__O__s_concurrent_ExecutionContext__O = (function(from, executionContext) {
  var from$1 = $as_Lamf_client_reference_ReferenceResolver(from);
  return new $c_Lamf_internal_reference_ReferenceResolverAdapter().init___Lamf_client_reference_ReferenceResolver__s_concurrent_ExecutionContext(from$1, executionContext)
});
$c_Lamf_client_convert_ReferenceResolverConverter$ReferenceResolverMatcher$.prototype.asClient__O__s_concurrent_ExecutionContext__O = (function(from, executionContext) {
  return this.asClient__Lamf_internal_reference_ReferenceResolver__s_concurrent_ExecutionContext__Lamf_client_reference_ReferenceResolver($as_Lamf_internal_reference_ReferenceResolver(from), executionContext)
});
var $d_Lamf_client_convert_ReferenceResolverConverter$ReferenceResolverMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_ReferenceResolverConverter$ReferenceResolverMatcher$: 0
}, false, "amf.client.convert.ReferenceResolverConverter$ReferenceResolverMatcher$", {
  Lamf_client_convert_ReferenceResolverConverter$ReferenceResolverMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcherWithEC: 1,
  Lamf_client_convert_ClientInternalMatcherWithEC: 1,
  Lamf_client_convert_InternalClientMatcherWithEC: 1
});
$c_Lamf_client_convert_ReferenceResolverConverter$ReferenceResolverMatcher$.prototype.$classData = $d_Lamf_client_convert_ReferenceResolverConverter$ReferenceResolverMatcher$;
/** @constructor */
function $c_Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$.prototype.constructor = $c_Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$;
/** @constructor */
function $h_Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$.prototype = $c_Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$.prototype;
$c_Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$.prototype.asInternal__O__s_concurrent_ExecutionContext__O = (function(from, executionContext) {
  var from$1 = $as_Lamf_client_resource_ResourceLoader(from);
  return new $c_Lamf_internal_resource_ResourceLoaderAdapter().init___Lamf_client_resource_ResourceLoader__s_concurrent_ExecutionContext(from$1, executionContext)
});
$c_Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$.prototype.asClient__O__s_concurrent_ExecutionContext__O = (function(from, executionContext) {
  return this.asClient__Lamf_internal_resource_ResourceLoader__s_concurrent_ExecutionContext__Lamf_client_resource_ResourceLoader($as_Lamf_internal_resource_ResourceLoader(from), executionContext)
});
$c_Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$.prototype.init___Lamf_client_convert_ResourceLoaderConverter = (function($$outer) {
  return this
});
$c_Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$.prototype.asClient__Lamf_internal_resource_ResourceLoader__s_concurrent_ExecutionContext__Lamf_client_resource_ResourceLoader = (function(from, executionContext) {
  if ((from instanceof $c_Lamf_internal_resource_ResourceLoaderAdapter)) {
    var x2 = $as_Lamf_internal_resource_ResourceLoaderAdapter(from);
    var adaptee = x2.adaptee$1;
    return adaptee
  } else {
    throw new $c_s_MatchError().init___O(from)
  }
});
var $d_Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$: 0
}, false, "amf.client.convert.ResourceLoaderConverter$ResourceLoaderMatcher$", {
  Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcherWithEC: 1,
  Lamf_client_convert_ClientInternalMatcherWithEC: 1,
  Lamf_client_convert_InternalClientMatcherWithEC: 1
});
$c_Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$.prototype.$classData = $d_Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$;
/** @constructor */
function $c_Lamf_client_convert_ResourceTypeConverter$ResourceTypeMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_ResourceTypeConverter$ResourceTypeMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_ResourceTypeConverter$ResourceTypeMatcher$.prototype.constructor = $c_Lamf_client_convert_ResourceTypeConverter$ResourceTypeMatcher$;
/** @constructor */
function $h_Lamf_client_convert_ResourceTypeConverter$ResourceTypeMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ResourceTypeConverter$ResourceTypeMatcher$.prototype = $c_Lamf_client_convert_ResourceTypeConverter$ResourceTypeMatcher$.prototype;
$c_Lamf_client_convert_ResourceTypeConverter$ResourceTypeMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_ResourceType(from);
  return $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(from$1.$$undinternal$1)
});
$c_Lamf_client_convert_ResourceTypeConverter$ResourceTypeMatcher$.prototype.init___Lamf_client_convert_ResourceTypeConverter = (function($$outer) {
  return this
});
$c_Lamf_client_convert_ResourceTypeConverter$ResourceTypeMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(from);
  return new $c_Lamf_client_model_domain_ResourceType().init___Lamf_plugins_domain_webapi_models_templates_ResourceType(from$1)
});
var $d_Lamf_client_convert_ResourceTypeConverter$ResourceTypeMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_ResourceTypeConverter$ResourceTypeMatcher$: 0
}, false, "amf.client.convert.ResourceTypeConverter$ResourceTypeMatcher$", {
  Lamf_client_convert_ResourceTypeConverter$ResourceTypeMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_ResourceTypeConverter$ResourceTypeMatcher$.prototype.$classData = $d_Lamf_client_convert_ResourceTypeConverter$ResourceTypeMatcher$;
/** @constructor */
function $c_Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$.prototype.constructor = $c_Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$;
/** @constructor */
function $h_Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$.prototype = $c_Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$.prototype;
$c_Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_ScalarShape(from);
  return $as_Lamf_plugins_domain_shapes_models_ScalarShape(from$1.$$undinternal$1)
});
$c_Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$.prototype.init___Lamf_client_convert_ScalarShapeConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_client_model_domain_ScalarShape($as_Lamf_plugins_domain_shapes_models_ScalarShape(from))
});
$c_Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$.prototype.asClient__Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_client_model_domain_ScalarShape = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_ScalarShape($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$: 0
}, false, "amf.client.convert.ScalarShapeConverter$ScalarShapeMatcher$", {
  Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$.prototype.$classData = $d_Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$;
/** @constructor */
function $c_Lamf_client_convert_SchemaShapeConverter$SchemaShapeMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_SchemaShapeConverter$SchemaShapeMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_SchemaShapeConverter$SchemaShapeMatcher$.prototype.constructor = $c_Lamf_client_convert_SchemaShapeConverter$SchemaShapeMatcher$;
/** @constructor */
function $h_Lamf_client_convert_SchemaShapeConverter$SchemaShapeMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_SchemaShapeConverter$SchemaShapeMatcher$.prototype = $c_Lamf_client_convert_SchemaShapeConverter$SchemaShapeMatcher$.prototype;
$c_Lamf_client_convert_SchemaShapeConverter$SchemaShapeMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_SchemaShape(from);
  return $as_Lamf_plugins_domain_shapes_models_SchemaShape(from$1.$$undinternal$1)
});
$c_Lamf_client_convert_SchemaShapeConverter$SchemaShapeMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_shapes_models_SchemaShape__Lamf_client_model_domain_SchemaShape($as_Lamf_plugins_domain_shapes_models_SchemaShape(from))
});
$c_Lamf_client_convert_SchemaShapeConverter$SchemaShapeMatcher$.prototype.asClient__Lamf_plugins_domain_shapes_models_SchemaShape__Lamf_client_model_domain_SchemaShape = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_SchemaShape($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_SchemaShapeConverter$SchemaShapeMatcher$.prototype.init___Lamf_client_convert_SchemaShapeConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_SchemaShapeConverter$SchemaShapeMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_SchemaShapeConverter$SchemaShapeMatcher$: 0
}, false, "amf.client.convert.SchemaShapeConverter$SchemaShapeMatcher$", {
  Lamf_client_convert_SchemaShapeConverter$SchemaShapeMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_SchemaShapeConverter$SchemaShapeMatcher$.prototype.$classData = $d_Lamf_client_convert_SchemaShapeConverter$SchemaShapeMatcher$;
/** @constructor */
function $c_Lamf_client_convert_ScopeConverter$ScopeMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_ScopeConverter$ScopeMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_ScopeConverter$ScopeMatcher$.prototype.constructor = $c_Lamf_client_convert_ScopeConverter$ScopeMatcher$;
/** @constructor */
function $h_Lamf_client_convert_ScopeConverter$ScopeMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ScopeConverter$ScopeMatcher$.prototype = $c_Lamf_client_convert_ScopeConverter$ScopeMatcher$.prototype;
$c_Lamf_client_convert_ScopeConverter$ScopeMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Scope(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_ScopeConverter$ScopeMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_security_Scope__Lamf_client_model_domain_Scope = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_Scope($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_ScopeConverter$ScopeMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_security_Scope__Lamf_client_model_domain_Scope($as_Lamf_plugins_domain_webapi_models_security_Scope(from))
});
$c_Lamf_client_convert_ScopeConverter$ScopeMatcher$.prototype.init___Lamf_client_convert_ScopeConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_ScopeConverter$ScopeMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_ScopeConverter$ScopeMatcher$: 0
}, false, "amf.client.convert.ScopeConverter$ScopeMatcher$", {
  Lamf_client_convert_ScopeConverter$ScopeMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_ScopeConverter$ScopeMatcher$.prototype.$classData = $d_Lamf_client_convert_ScopeConverter$ScopeMatcher$;
/** @constructor */
function $c_Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$.prototype.constructor = $c_Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$;
/** @constructor */
function $h_Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$.prototype = $c_Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$.prototype;
$c_Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_SecurityRequirement(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$.prototype.init___Lamf_client_convert_SecurityRequirementConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_security_SecurityRequirement__Lamf_client_model_domain_SecurityRequirement($as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(from))
});
$c_Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_security_SecurityRequirement__Lamf_client_model_domain_SecurityRequirement = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_SecurityRequirement($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$: 0
}, false, "amf.client.convert.SecurityRequirementConverter$SecurityRequirementMatcher$", {
  Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$.prototype.$classData = $d_Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$;
/** @constructor */
function $c_Lamf_client_convert_SecuritySchemeConverter$SecuritySchemeMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_SecuritySchemeConverter$SecuritySchemeMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_SecuritySchemeConverter$SecuritySchemeMatcher$.prototype.constructor = $c_Lamf_client_convert_SecuritySchemeConverter$SecuritySchemeMatcher$;
/** @constructor */
function $h_Lamf_client_convert_SecuritySchemeConverter$SecuritySchemeMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_SecuritySchemeConverter$SecuritySchemeMatcher$.prototype = $c_Lamf_client_convert_SecuritySchemeConverter$SecuritySchemeMatcher$.prototype;
$c_Lamf_client_convert_SecuritySchemeConverter$SecuritySchemeMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_client_model_domain_SecurityScheme = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_SecurityScheme($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_SecuritySchemeConverter$SecuritySchemeMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_SecurityScheme(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_SecuritySchemeConverter$SecuritySchemeMatcher$.prototype.init___Lamf_client_convert_SecuritySchemeConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_SecuritySchemeConverter$SecuritySchemeMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_client_model_domain_SecurityScheme($as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(from))
});
var $d_Lamf_client_convert_SecuritySchemeConverter$SecuritySchemeMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_SecuritySchemeConverter$SecuritySchemeMatcher$: 0
}, false, "amf.client.convert.SecuritySchemeConverter$SecuritySchemeMatcher$", {
  Lamf_client_convert_SecuritySchemeConverter$SecuritySchemeMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_SecuritySchemeConverter$SecuritySchemeMatcher$.prototype.$classData = $d_Lamf_client_convert_SecuritySchemeConverter$SecuritySchemeMatcher$;
/** @constructor */
function $c_Lamf_client_convert_ServerBindingConverter$ServerBindingMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_ServerBindingConverter$ServerBindingMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_ServerBindingConverter$ServerBindingMatcher$.prototype.constructor = $c_Lamf_client_convert_ServerBindingConverter$ServerBindingMatcher$;
/** @constructor */
function $h_Lamf_client_convert_ServerBindingConverter$ServerBindingMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ServerBindingConverter$ServerBindingMatcher$.prototype = $c_Lamf_client_convert_ServerBindingConverter$ServerBindingMatcher$.prototype;
$c_Lamf_client_convert_ServerBindingConverter$ServerBindingMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_ServerBinding__Lamf_client_model_domain_ServerBinding = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_ServerBinding($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_ServerBindingConverter$ServerBindingMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_ServerBinding(from);
  return from$1.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_ServerBinding()
});
$c_Lamf_client_convert_ServerBindingConverter$ServerBindingMatcher$.prototype.init___Lamf_client_convert_ServerBindingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_ServerBindingConverter$ServerBindingMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_ServerBinding__Lamf_client_model_domain_ServerBinding($as_Lamf_plugins_domain_webapi_models_bindings_ServerBinding(from))
});
var $d_Lamf_client_convert_ServerBindingConverter$ServerBindingMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_ServerBindingConverter$ServerBindingMatcher$: 0
}, false, "amf.client.convert.ServerBindingConverter$ServerBindingMatcher$", {
  Lamf_client_convert_ServerBindingConverter$ServerBindingMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_ServerBindingConverter$ServerBindingMatcher$.prototype.$classData = $d_Lamf_client_convert_ServerBindingConverter$ServerBindingMatcher$;
/** @constructor */
function $c_Lamf_client_convert_ServerBindingsConverter$ServerBindingsMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_ServerBindingsConverter$ServerBindingsMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_ServerBindingsConverter$ServerBindingsMatcher$.prototype.constructor = $c_Lamf_client_convert_ServerBindingsConverter$ServerBindingsMatcher$;
/** @constructor */
function $h_Lamf_client_convert_ServerBindingsConverter$ServerBindingsMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ServerBindingsConverter$ServerBindingsMatcher$.prototype = $c_Lamf_client_convert_ServerBindingsConverter$ServerBindingsMatcher$.prototype;
$c_Lamf_client_convert_ServerBindingsConverter$ServerBindingsMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_ServerBindings(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_ServerBindingsConverter$ServerBindingsMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_ServerBindings__Lamf_client_model_domain_ServerBindings = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_ServerBindings($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_ServerBindingsConverter$ServerBindingsMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_ServerBindings__Lamf_client_model_domain_ServerBindings($as_Lamf_plugins_domain_webapi_models_bindings_ServerBindings(from))
});
$c_Lamf_client_convert_ServerBindingsConverter$ServerBindingsMatcher$.prototype.init___Lamf_client_convert_ServerBindingsConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_ServerBindingsConverter$ServerBindingsMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_ServerBindingsConverter$ServerBindingsMatcher$: 0
}, false, "amf.client.convert.ServerBindingsConverter$ServerBindingsMatcher$", {
  Lamf_client_convert_ServerBindingsConverter$ServerBindingsMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_ServerBindingsConverter$ServerBindingsMatcher$.prototype.$classData = $d_Lamf_client_convert_ServerBindingsConverter$ServerBindingsMatcher$;
/** @constructor */
function $c_Lamf_client_convert_ServerConverter$ServerMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_ServerConverter$ServerMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_ServerConverter$ServerMatcher$.prototype.constructor = $c_Lamf_client_convert_ServerConverter$ServerMatcher$;
/** @constructor */
function $h_Lamf_client_convert_ServerConverter$ServerMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ServerConverter$ServerMatcher$.prototype = $c_Lamf_client_convert_ServerConverter$ServerMatcher$.prototype;
$c_Lamf_client_convert_ServerConverter$ServerMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Server(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_ServerConverter$ServerMatcher$.prototype.init___Lamf_client_convert_ServerConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_ServerConverter$ServerMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_Server__Lamf_client_model_domain_Server($as_Lamf_plugins_domain_webapi_models_Server(from))
});
$c_Lamf_client_convert_ServerConverter$ServerMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_Server__Lamf_client_model_domain_Server = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_Server($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_ServerConverter$ServerMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_ServerConverter$ServerMatcher$: 0
}, false, "amf.client.convert.ServerConverter$ServerMatcher$", {
  Lamf_client_convert_ServerConverter$ServerMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_ServerConverter$ServerMatcher$.prototype.$classData = $d_Lamf_client_convert_ServerConverter$ServerMatcher$;
/** @constructor */
function $c_Lamf_client_convert_SettingsConverter$ApiKeySettingsMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_SettingsConverter$ApiKeySettingsMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_SettingsConverter$ApiKeySettingsMatcher$.prototype.constructor = $c_Lamf_client_convert_SettingsConverter$ApiKeySettingsMatcher$;
/** @constructor */
function $h_Lamf_client_convert_SettingsConverter$ApiKeySettingsMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_SettingsConverter$ApiKeySettingsMatcher$.prototype = $c_Lamf_client_convert_SettingsConverter$ApiKeySettingsMatcher$.prototype;
$c_Lamf_client_convert_SettingsConverter$ApiKeySettingsMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_ApiKeySettings(from);
  return $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(from$1.$$undinternal$1)
});
$c_Lamf_client_convert_SettingsConverter$ApiKeySettingsMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(from);
  return new $c_Lamf_client_model_domain_ApiKeySettings().init___Lamf_plugins_domain_webapi_models_security_ApiKeySettings(from$1)
});
$c_Lamf_client_convert_SettingsConverter$ApiKeySettingsMatcher$.prototype.init___Lamf_client_convert_SettingsConverter = (function($$outer) {
  return this
});
var $d_Lamf_client_convert_SettingsConverter$ApiKeySettingsMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_SettingsConverter$ApiKeySettingsMatcher$: 0
}, false, "amf.client.convert.SettingsConverter$ApiKeySettingsMatcher$", {
  Lamf_client_convert_SettingsConverter$ApiKeySettingsMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_SettingsConverter$ApiKeySettingsMatcher$.prototype.$classData = $d_Lamf_client_convert_SettingsConverter$ApiKeySettingsMatcher$;
/** @constructor */
function $c_Lamf_client_convert_SettingsConverter$HttpApiKeySettingsMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_SettingsConverter$HttpApiKeySettingsMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_SettingsConverter$HttpApiKeySettingsMatcher$.prototype.constructor = $c_Lamf_client_convert_SettingsConverter$HttpApiKeySettingsMatcher$;
/** @constructor */
function $h_Lamf_client_convert_SettingsConverter$HttpApiKeySettingsMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_SettingsConverter$HttpApiKeySettingsMatcher$.prototype = $c_Lamf_client_convert_SettingsConverter$HttpApiKeySettingsMatcher$.prototype;
$c_Lamf_client_convert_SettingsConverter$HttpApiKeySettingsMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_HttpApiKeySettings(from);
  return $as_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(from$1.$$undinternal$1)
});
$c_Lamf_client_convert_SettingsConverter$HttpApiKeySettingsMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(from);
  return new $c_Lamf_client_model_domain_HttpApiKeySettings().init___Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(from$1)
});
$c_Lamf_client_convert_SettingsConverter$HttpApiKeySettingsMatcher$.prototype.init___Lamf_client_convert_SettingsConverter = (function($$outer) {
  return this
});
var $d_Lamf_client_convert_SettingsConverter$HttpApiKeySettingsMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_SettingsConverter$HttpApiKeySettingsMatcher$: 0
}, false, "amf.client.convert.SettingsConverter$HttpApiKeySettingsMatcher$", {
  Lamf_client_convert_SettingsConverter$HttpApiKeySettingsMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_SettingsConverter$HttpApiKeySettingsMatcher$.prototype.$classData = $d_Lamf_client_convert_SettingsConverter$HttpApiKeySettingsMatcher$;
/** @constructor */
function $c_Lamf_client_convert_SettingsConverter$HttpSettingsMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_SettingsConverter$HttpSettingsMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_SettingsConverter$HttpSettingsMatcher$.prototype.constructor = $c_Lamf_client_convert_SettingsConverter$HttpSettingsMatcher$;
/** @constructor */
function $h_Lamf_client_convert_SettingsConverter$HttpSettingsMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_SettingsConverter$HttpSettingsMatcher$.prototype = $c_Lamf_client_convert_SettingsConverter$HttpSettingsMatcher$.prototype;
$c_Lamf_client_convert_SettingsConverter$HttpSettingsMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_HttpSettings(from);
  return $as_Lamf_plugins_domain_webapi_models_security_HttpSettings(from$1.$$undinternal$1)
});
$c_Lamf_client_convert_SettingsConverter$HttpSettingsMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_plugins_domain_webapi_models_security_HttpSettings(from);
  return new $c_Lamf_client_model_domain_HttpSettings().init___Lamf_plugins_domain_webapi_models_security_HttpSettings(from$1)
});
$c_Lamf_client_convert_SettingsConverter$HttpSettingsMatcher$.prototype.init___Lamf_client_convert_SettingsConverter = (function($$outer) {
  return this
});
var $d_Lamf_client_convert_SettingsConverter$HttpSettingsMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_SettingsConverter$HttpSettingsMatcher$: 0
}, false, "amf.client.convert.SettingsConverter$HttpSettingsMatcher$", {
  Lamf_client_convert_SettingsConverter$HttpSettingsMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_SettingsConverter$HttpSettingsMatcher$.prototype.$classData = $d_Lamf_client_convert_SettingsConverter$HttpSettingsMatcher$;
/** @constructor */
function $c_Lamf_client_convert_SettingsConverter$OAuth1SettingsMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_SettingsConverter$OAuth1SettingsMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_SettingsConverter$OAuth1SettingsMatcher$.prototype.constructor = $c_Lamf_client_convert_SettingsConverter$OAuth1SettingsMatcher$;
/** @constructor */
function $h_Lamf_client_convert_SettingsConverter$OAuth1SettingsMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_SettingsConverter$OAuth1SettingsMatcher$.prototype = $c_Lamf_client_convert_SettingsConverter$OAuth1SettingsMatcher$.prototype;
$c_Lamf_client_convert_SettingsConverter$OAuth1SettingsMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_OAuth1Settings(from);
  return $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(from$1.$$undinternal$1)
});
$c_Lamf_client_convert_SettingsConverter$OAuth1SettingsMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(from);
  return new $c_Lamf_client_model_domain_OAuth1Settings().init___Lamf_plugins_domain_webapi_models_security_OAuth1Settings(from$1)
});
$c_Lamf_client_convert_SettingsConverter$OAuth1SettingsMatcher$.prototype.init___Lamf_client_convert_SettingsConverter = (function($$outer) {
  return this
});
var $d_Lamf_client_convert_SettingsConverter$OAuth1SettingsMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_SettingsConverter$OAuth1SettingsMatcher$: 0
}, false, "amf.client.convert.SettingsConverter$OAuth1SettingsMatcher$", {
  Lamf_client_convert_SettingsConverter$OAuth1SettingsMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_SettingsConverter$OAuth1SettingsMatcher$.prototype.$classData = $d_Lamf_client_convert_SettingsConverter$OAuth1SettingsMatcher$;
/** @constructor */
function $c_Lamf_client_convert_SettingsConverter$OAuth2SettingsMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_SettingsConverter$OAuth2SettingsMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_SettingsConverter$OAuth2SettingsMatcher$.prototype.constructor = $c_Lamf_client_convert_SettingsConverter$OAuth2SettingsMatcher$;
/** @constructor */
function $h_Lamf_client_convert_SettingsConverter$OAuth2SettingsMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_SettingsConverter$OAuth2SettingsMatcher$.prototype = $c_Lamf_client_convert_SettingsConverter$OAuth2SettingsMatcher$.prototype;
$c_Lamf_client_convert_SettingsConverter$OAuth2SettingsMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_OAuth2Settings(from);
  return $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(from$1.$$undinternal$1)
});
$c_Lamf_client_convert_SettingsConverter$OAuth2SettingsMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(from);
  return new $c_Lamf_client_model_domain_OAuth2Settings().init___Lamf_plugins_domain_webapi_models_security_OAuth2Settings(from$1)
});
$c_Lamf_client_convert_SettingsConverter$OAuth2SettingsMatcher$.prototype.init___Lamf_client_convert_SettingsConverter = (function($$outer) {
  return this
});
var $d_Lamf_client_convert_SettingsConverter$OAuth2SettingsMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_SettingsConverter$OAuth2SettingsMatcher$: 0
}, false, "amf.client.convert.SettingsConverter$OAuth2SettingsMatcher$", {
  Lamf_client_convert_SettingsConverter$OAuth2SettingsMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_SettingsConverter$OAuth2SettingsMatcher$.prototype.$classData = $d_Lamf_client_convert_SettingsConverter$OAuth2SettingsMatcher$;
/** @constructor */
function $c_Lamf_client_convert_SettingsConverter$OpenIdConnectSettingsMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_SettingsConverter$OpenIdConnectSettingsMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_SettingsConverter$OpenIdConnectSettingsMatcher$.prototype.constructor = $c_Lamf_client_convert_SettingsConverter$OpenIdConnectSettingsMatcher$;
/** @constructor */
function $h_Lamf_client_convert_SettingsConverter$OpenIdConnectSettingsMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_SettingsConverter$OpenIdConnectSettingsMatcher$.prototype = $c_Lamf_client_convert_SettingsConverter$OpenIdConnectSettingsMatcher$.prototype;
$c_Lamf_client_convert_SettingsConverter$OpenIdConnectSettingsMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_OpenIdConnectSettings(from);
  return $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(from$1.$$undinternal$1)
});
$c_Lamf_client_convert_SettingsConverter$OpenIdConnectSettingsMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(from);
  return new $c_Lamf_client_model_domain_OpenIdConnectSettings().init___Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(from$1)
});
$c_Lamf_client_convert_SettingsConverter$OpenIdConnectSettingsMatcher$.prototype.init___Lamf_client_convert_SettingsConverter = (function($$outer) {
  return this
});
var $d_Lamf_client_convert_SettingsConverter$OpenIdConnectSettingsMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_SettingsConverter$OpenIdConnectSettingsMatcher$: 0
}, false, "amf.client.convert.SettingsConverter$OpenIdConnectSettingsMatcher$", {
  Lamf_client_convert_SettingsConverter$OpenIdConnectSettingsMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_SettingsConverter$OpenIdConnectSettingsMatcher$.prototype.$classData = $d_Lamf_client_convert_SettingsConverter$OpenIdConnectSettingsMatcher$;
/** @constructor */
function $c_Lamf_client_convert_SettingsConverter$SettingsMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_SettingsConverter$SettingsMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_SettingsConverter$SettingsMatcher$.prototype.constructor = $c_Lamf_client_convert_SettingsConverter$SettingsMatcher$;
/** @constructor */
function $h_Lamf_client_convert_SettingsConverter$SettingsMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_SettingsConverter$SettingsMatcher$.prototype = $c_Lamf_client_convert_SettingsConverter$SettingsMatcher$.prototype;
$c_Lamf_client_convert_SettingsConverter$SettingsMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Settings(from);
  return from$1.$$undinternal__Lamf_plugins_domain_webapi_models_security_Settings()
});
$c_Lamf_client_convert_SettingsConverter$SettingsMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_security_Settings__Lamf_client_model_domain_Settings($as_Lamf_plugins_domain_webapi_models_security_Settings(from))
});
$c_Lamf_client_convert_SettingsConverter$SettingsMatcher$.prototype.init___Lamf_client_convert_SettingsConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_SettingsConverter$SettingsMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_security_Settings__Lamf_client_model_domain_Settings = (function(from) {
  if ((from instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(from);
    this.$$outer$1.OAuth1SettingsMatcher__Lamf_client_convert_SettingsConverter$OAuth1SettingsMatcher$();
    return new $c_Lamf_client_model_domain_OAuth1Settings().init___Lamf_plugins_domain_webapi_models_security_OAuth1Settings(x2)
  } else if ((from instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings)) {
    var x3 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(from);
    this.$$outer$1.OAuth2SettingsMatcher__Lamf_client_convert_SettingsConverter$OAuth2SettingsMatcher$();
    return new $c_Lamf_client_model_domain_OAuth2Settings().init___Lamf_plugins_domain_webapi_models_security_OAuth2Settings(x3)
  } else if ((from instanceof $c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings)) {
    var x4 = $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(from);
    this.$$outer$1.ApiKeySettingsMatcher__Lamf_client_convert_SettingsConverter$ApiKeySettingsMatcher$();
    return new $c_Lamf_client_model_domain_ApiKeySettings().init___Lamf_plugins_domain_webapi_models_security_ApiKeySettings(x4)
  } else if ((from instanceof $c_Lamf_plugins_domain_webapi_models_security_HttpSettings)) {
    var x5 = $as_Lamf_plugins_domain_webapi_models_security_HttpSettings(from);
    this.$$outer$1.HttpSettingsMatcher__Lamf_client_convert_SettingsConverter$HttpSettingsMatcher$();
    return new $c_Lamf_client_model_domain_HttpSettings().init___Lamf_plugins_domain_webapi_models_security_HttpSettings(x5)
  } else if ((from instanceof $c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings)) {
    var x6 = $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(from);
    this.$$outer$1.OpenIdConnectSettingsMatcher__Lamf_client_convert_SettingsConverter$OpenIdConnectSettingsMatcher$();
    return new $c_Lamf_client_model_domain_OpenIdConnectSettings().init___Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(x6)
  } else {
    return ((from !== null) ? new $c_Lamf_client_model_domain_Settings().init___Lamf_plugins_domain_webapi_models_security_Settings(from) : null)
  }
});
var $d_Lamf_client_convert_SettingsConverter$SettingsMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_SettingsConverter$SettingsMatcher$: 0
}, false, "amf.client.convert.SettingsConverter$SettingsMatcher$", {
  Lamf_client_convert_SettingsConverter$SettingsMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_SettingsConverter$SettingsMatcher$.prototype.$classData = $d_Lamf_client_convert_SettingsConverter$SettingsMatcher$;
/** @constructor */
function $c_Lamf_client_convert_ShapeConverter$ShapeMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_ShapeConverter$ShapeMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_ShapeConverter$ShapeMatcher$.prototype.constructor = $c_Lamf_client_convert_ShapeConverter$ShapeMatcher$;
/** @constructor */
function $h_Lamf_client_convert_ShapeConverter$ShapeMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ShapeConverter$ShapeMatcher$.prototype = $c_Lamf_client_convert_ShapeConverter$ShapeMatcher$.prototype;
$c_Lamf_client_convert_ShapeConverter$ShapeMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Shape(from);
  return from$1.$$undinternal__Lamf_core_model_domain_Shape()
});
$c_Lamf_client_convert_ShapeConverter$ShapeMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape($as_Lamf_core_model_domain_Shape(from))
});
$c_Lamf_client_convert_ShapeConverter$ShapeMatcher$.prototype.init___Lamf_client_convert_ShapeConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_ShapeConverter$ShapeMatcher$.prototype.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape = (function(from) {
  var this$1 = this.$$outer$1.platform__Lamf_core_remote_Platform();
  return $as_Lamf_client_model_domain_Shape($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_ShapeConverter$ShapeMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_ShapeConverter$ShapeMatcher$: 0
}, false, "amf.client.convert.ShapeConverter$ShapeMatcher$", {
  Lamf_client_convert_ShapeConverter$ShapeMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_ShapeConverter$ShapeMatcher$.prototype.$classData = $d_Lamf_client_convert_ShapeConverter$ShapeMatcher$;
/** @constructor */
function $c_Lamf_client_convert_ShapeExtensionConverter$ShapeExtensionMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_ShapeExtensionConverter$ShapeExtensionMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_ShapeExtensionConverter$ShapeExtensionMatcher$.prototype.constructor = $c_Lamf_client_convert_ShapeExtensionConverter$ShapeExtensionMatcher$;
/** @constructor */
function $h_Lamf_client_convert_ShapeExtensionConverter$ShapeExtensionMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ShapeExtensionConverter$ShapeExtensionMatcher$.prototype = $c_Lamf_client_convert_ShapeExtensionConverter$ShapeExtensionMatcher$.prototype;
$c_Lamf_client_convert_ShapeExtensionConverter$ShapeExtensionMatcher$.prototype.init___Lamf_client_convert_ShapeExtensionConverter = (function($$outer) {
  return this
});
$c_Lamf_client_convert_ShapeExtensionConverter$ShapeExtensionMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_ShapeExtension(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_ShapeExtensionConverter$ShapeExtensionMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_core_model_domain_extensions_ShapeExtension(from);
  return new $c_Lamf_client_model_domain_ShapeExtension().init___Lamf_core_model_domain_extensions_ShapeExtension(from$1)
});
var $d_Lamf_client_convert_ShapeExtensionConverter$ShapeExtensionMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_ShapeExtensionConverter$ShapeExtensionMatcher$: 0
}, false, "amf.client.convert.ShapeExtensionConverter$ShapeExtensionMatcher$", {
  Lamf_client_convert_ShapeExtensionConverter$ShapeExtensionMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_ShapeExtensionConverter$ShapeExtensionMatcher$.prototype.$classData = $d_Lamf_client_convert_ShapeExtensionConverter$ShapeExtensionMatcher$;
/** @constructor */
function $c_Lamf_client_convert_TagConverter$TagMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_TagConverter$TagMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_TagConverter$TagMatcher$.prototype.constructor = $c_Lamf_client_convert_TagConverter$TagMatcher$;
/** @constructor */
function $h_Lamf_client_convert_TagConverter$TagMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_TagConverter$TagMatcher$.prototype = $c_Lamf_client_convert_TagConverter$TagMatcher$.prototype;
$c_Lamf_client_convert_TagConverter$TagMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Tag(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_TagConverter$TagMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_Tag__Lamf_client_model_domain_Tag = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_Tag($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_TagConverter$TagMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_Tag__Lamf_client_model_domain_Tag($as_Lamf_plugins_domain_webapi_models_Tag(from))
});
$c_Lamf_client_convert_TagConverter$TagMatcher$.prototype.init___Lamf_client_convert_TagConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_TagConverter$TagMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_TagConverter$TagMatcher$: 0
}, false, "amf.client.convert.TagConverter$TagMatcher$", {
  Lamf_client_convert_TagConverter$TagMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_TagConverter$TagMatcher$.prototype.$classData = $d_Lamf_client_convert_TagConverter$TagMatcher$;
/** @constructor */
function $c_Lamf_client_convert_TemplatedLinkConverter$TemplatedLinkConverter$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_TemplatedLinkConverter$TemplatedLinkConverter$.prototype = new $h_O();
$c_Lamf_client_convert_TemplatedLinkConverter$TemplatedLinkConverter$.prototype.constructor = $c_Lamf_client_convert_TemplatedLinkConverter$TemplatedLinkConverter$;
/** @constructor */
function $h_Lamf_client_convert_TemplatedLinkConverter$TemplatedLinkConverter$() {
  /*<skip>*/
}
$h_Lamf_client_convert_TemplatedLinkConverter$TemplatedLinkConverter$.prototype = $c_Lamf_client_convert_TemplatedLinkConverter$TemplatedLinkConverter$.prototype;
$c_Lamf_client_convert_TemplatedLinkConverter$TemplatedLinkConverter$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_TemplatedLink(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_TemplatedLinkConverter$TemplatedLinkConverter$.prototype.asClient__Lamf_plugins_domain_webapi_models_TemplatedLink__Lamf_client_model_domain_TemplatedLink = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_TemplatedLink($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_TemplatedLinkConverter$TemplatedLinkConverter$.prototype.init___Lamf_client_convert_TemplatedLinkConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_TemplatedLinkConverter$TemplatedLinkConverter$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_TemplatedLink__Lamf_client_model_domain_TemplatedLink($as_Lamf_plugins_domain_webapi_models_TemplatedLink(from))
});
var $d_Lamf_client_convert_TemplatedLinkConverter$TemplatedLinkConverter$ = new $TypeData().initClass({
  Lamf_client_convert_TemplatedLinkConverter$TemplatedLinkConverter$: 0
}, false, "amf.client.convert.TemplatedLinkConverter$TemplatedLinkConverter$", {
  Lamf_client_convert_TemplatedLinkConverter$TemplatedLinkConverter$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_TemplatedLinkConverter$TemplatedLinkConverter$.prototype.$classData = $d_Lamf_client_convert_TemplatedLinkConverter$TemplatedLinkConverter$;
/** @constructor */
function $c_Lamf_client_convert_TraitConverter$TraitMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_TraitConverter$TraitMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_TraitConverter$TraitMatcher$.prototype.constructor = $c_Lamf_client_convert_TraitConverter$TraitMatcher$;
/** @constructor */
function $h_Lamf_client_convert_TraitConverter$TraitMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_TraitConverter$TraitMatcher$.prototype = $c_Lamf_client_convert_TraitConverter$TraitMatcher$.prototype;
$c_Lamf_client_convert_TraitConverter$TraitMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_Trait(from);
  return $as_Lamf_plugins_domain_webapi_models_templates_Trait(from$1.$$undinternal$1)
});
$c_Lamf_client_convert_TraitConverter$TraitMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_plugins_domain_webapi_models_templates_Trait(from);
  return new $c_Lamf_client_model_domain_Trait().init___Lamf_plugins_domain_webapi_models_templates_Trait(from$1)
});
$c_Lamf_client_convert_TraitConverter$TraitMatcher$.prototype.init___Lamf_client_convert_TraitConverter = (function($$outer) {
  return this
});
var $d_Lamf_client_convert_TraitConverter$TraitMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_TraitConverter$TraitMatcher$: 0
}, false, "amf.client.convert.TraitConverter$TraitMatcher$", {
  Lamf_client_convert_TraitConverter$TraitMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_TraitConverter$TraitMatcher$.prototype.$classData = $d_Lamf_client_convert_TraitConverter$TraitMatcher$;
/** @constructor */
function $c_Lamf_client_convert_TupleShapeConverter$TupleShapeMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_TupleShapeConverter$TupleShapeMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_TupleShapeConverter$TupleShapeMatcher$.prototype.constructor = $c_Lamf_client_convert_TupleShapeConverter$TupleShapeMatcher$;
/** @constructor */
function $h_Lamf_client_convert_TupleShapeConverter$TupleShapeMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_TupleShapeConverter$TupleShapeMatcher$.prototype = $c_Lamf_client_convert_TupleShapeConverter$TupleShapeMatcher$.prototype;
$c_Lamf_client_convert_TupleShapeConverter$TupleShapeMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_TupleShape(from);
  return from$1.$$undinternal$3
});
$c_Lamf_client_convert_TupleShapeConverter$TupleShapeMatcher$.prototype.asClient__Lamf_plugins_domain_shapes_models_TupleShape__Lamf_client_model_domain_TupleShape = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_TupleShape($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_TupleShapeConverter$TupleShapeMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_shapes_models_TupleShape__Lamf_client_model_domain_TupleShape($as_Lamf_plugins_domain_shapes_models_TupleShape(from))
});
$c_Lamf_client_convert_TupleShapeConverter$TupleShapeMatcher$.prototype.init___Lamf_client_convert_TupleShapeConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_client_convert_TupleShapeConverter$TupleShapeMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_TupleShapeConverter$TupleShapeMatcher$: 0
}, false, "amf.client.convert.TupleShapeConverter$TupleShapeMatcher$", {
  Lamf_client_convert_TupleShapeConverter$TupleShapeMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_TupleShapeConverter$TupleShapeMatcher$.prototype.$classData = $d_Lamf_client_convert_TupleShapeConverter$TupleShapeMatcher$;
/** @constructor */
function $c_Lamf_client_convert_ValidationCandidateConverter$ValidationCandidateMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_ValidationCandidateConverter$ValidationCandidateMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_ValidationCandidateConverter$ValidationCandidateMatcher$.prototype.constructor = $c_Lamf_client_convert_ValidationCandidateConverter$ValidationCandidateMatcher$;
/** @constructor */
function $h_Lamf_client_convert_ValidationCandidateConverter$ValidationCandidateMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ValidationCandidateConverter$ValidationCandidateMatcher$.prototype = $c_Lamf_client_convert_ValidationCandidateConverter$ValidationCandidateMatcher$.prototype;
$c_Lamf_client_convert_ValidationCandidateConverter$ValidationCandidateMatcher$.prototype.init___Lamf_client_convert_ValidationCandidateConverter = (function($$outer) {
  return this
});
$c_Lamf_client_convert_ValidationCandidateConverter$ValidationCandidateMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_validate_ValidationCandidate(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_ValidationCandidateConverter$ValidationCandidateMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_core_validation_ValidationCandidate(from);
  return new $c_Lamf_client_validate_ValidationCandidate().init___Lamf_core_validation_ValidationCandidate(from$1)
});
var $d_Lamf_client_convert_ValidationCandidateConverter$ValidationCandidateMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_ValidationCandidateConverter$ValidationCandidateMatcher$: 0
}, false, "amf.client.convert.ValidationCandidateConverter$ValidationCandidateMatcher$", {
  Lamf_client_convert_ValidationCandidateConverter$ValidationCandidateMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_ValidationCandidateConverter$ValidationCandidateMatcher$.prototype.$classData = $d_Lamf_client_convert_ValidationCandidateConverter$ValidationCandidateMatcher$;
/** @constructor */
function $c_Lamf_client_convert_ValidationConverter$ValidationReportMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_ValidationConverter$ValidationReportMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_ValidationConverter$ValidationReportMatcher$.prototype.constructor = $c_Lamf_client_convert_ValidationConverter$ValidationReportMatcher$;
/** @constructor */
function $h_Lamf_client_convert_ValidationConverter$ValidationReportMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ValidationConverter$ValidationReportMatcher$.prototype = $c_Lamf_client_convert_ValidationConverter$ValidationReportMatcher$.prototype;
$c_Lamf_client_convert_ValidationConverter$ValidationReportMatcher$.prototype.init___Lamf_client_convert_ValidationConverter = (function($$outer) {
  return this
});
$c_Lamf_client_convert_ValidationConverter$ValidationReportMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_validate_ValidationReport(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_ValidationConverter$ValidationReportMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_core_validation_AMFValidationReport(from);
  return new $c_Lamf_client_validate_ValidationReport().init___Lamf_core_validation_AMFValidationReport(from$1)
});
var $d_Lamf_client_convert_ValidationConverter$ValidationReportMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_ValidationConverter$ValidationReportMatcher$: 0
}, false, "amf.client.convert.ValidationConverter$ValidationReportMatcher$", {
  Lamf_client_convert_ValidationConverter$ValidationReportMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_ValidationConverter$ValidationReportMatcher$.prototype.$classData = $d_Lamf_client_convert_ValidationConverter$ValidationReportMatcher$;
/** @constructor */
function $c_Lamf_client_convert_ValidationConverter$ValidationResultMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_ValidationConverter$ValidationResultMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_ValidationConverter$ValidationResultMatcher$.prototype.constructor = $c_Lamf_client_convert_ValidationConverter$ValidationResultMatcher$;
/** @constructor */
function $h_Lamf_client_convert_ValidationConverter$ValidationResultMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_ValidationConverter$ValidationResultMatcher$.prototype = $c_Lamf_client_convert_ValidationConverter$ValidationResultMatcher$.prototype;
$c_Lamf_client_convert_ValidationConverter$ValidationResultMatcher$.prototype.init___Lamf_client_convert_ValidationConverter = (function($$outer) {
  return this
});
$c_Lamf_client_convert_ValidationConverter$ValidationResultMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_validate_ValidationResult(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_ValidationConverter$ValidationResultMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_core_validation_AMFValidationResult(from);
  return new $c_Lamf_client_validate_ValidationResult().init___Lamf_core_validation_AMFValidationResult(from$1)
});
var $d_Lamf_client_convert_ValidationConverter$ValidationResultMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_ValidationConverter$ValidationResultMatcher$: 0
}, false, "amf.client.convert.ValidationConverter$ValidationResultMatcher$", {
  Lamf_client_convert_ValidationConverter$ValidationResultMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_ValidationConverter$ValidationResultMatcher$.prototype.$classData = $d_Lamf_client_convert_ValidationConverter$ValidationResultMatcher$;
/** @constructor */
function $c_Lamf_client_convert_VariableValueConverter$VariableValueMatcher$() {
  $c_O.call(this)
}
$c_Lamf_client_convert_VariableValueConverter$VariableValueMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_VariableValueConverter$VariableValueMatcher$.prototype.constructor = $c_Lamf_client_convert_VariableValueConverter$VariableValueMatcher$;
/** @constructor */
function $h_Lamf_client_convert_VariableValueConverter$VariableValueMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_VariableValueConverter$VariableValueMatcher$.prototype = $c_Lamf_client_convert_VariableValueConverter$VariableValueMatcher$.prototype;
$c_Lamf_client_convert_VariableValueConverter$VariableValueMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_VariableValue(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_VariableValueConverter$VariableValueMatcher$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_core_model_domain_templates_VariableValue(from);
  return new $c_Lamf_client_model_domain_VariableValue().init___Lamf_core_model_domain_templates_VariableValue(from$1)
});
$c_Lamf_client_convert_VariableValueConverter$VariableValueMatcher$.prototype.init___Lamf_client_convert_VariableValueConverter = (function($$outer) {
  return this
});
var $d_Lamf_client_convert_VariableValueConverter$VariableValueMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_VariableValueConverter$VariableValueMatcher$: 0
}, false, "amf.client.convert.VariableValueConverter$VariableValueMatcher$", {
  Lamf_client_convert_VariableValueConverter$VariableValueMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_VariableValueConverter$VariableValueMatcher$.prototype.$classData = $d_Lamf_client_convert_VariableValueConverter$VariableValueMatcher$;
/** @constructor */
function $c_Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$.prototype = new $h_O();
$c_Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$.prototype.constructor = $c_Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$;
/** @constructor */
function $h_Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$() {
  /*<skip>*/
}
$h_Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$.prototype = $c_Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$.prototype;
$c_Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$.prototype.init___Lamf_client_convert_VocabularyReferenceConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_VocabularyReference(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_document_vocabularies_model_domain_VocabularyReference__Lamf_client_model_domain_VocabularyReference($as_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference(from))
});
$c_Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$.prototype.asClient__Lamf_plugins_document_vocabularies_model_domain_VocabularyReference__Lamf_client_model_domain_VocabularyReference = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_VocabularyReference($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$ = new $TypeData().initClass({
  Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$: 0
}, false, "amf.client.convert.VocabularyReferenceConverter$VocabularyReferenceConverter$", {
  Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$.prototype.$classData = $d_Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$;
/** @constructor */
function $c_Lamf_client_convert_WebSocketsChannelBindingConverter$WebSocketsChannelBindingMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_WebSocketsChannelBindingConverter$WebSocketsChannelBindingMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_WebSocketsChannelBindingConverter$WebSocketsChannelBindingMatcher$.prototype.constructor = $c_Lamf_client_convert_WebSocketsChannelBindingConverter$WebSocketsChannelBindingMatcher$;
/** @constructor */
function $h_Lamf_client_convert_WebSocketsChannelBindingConverter$WebSocketsChannelBindingMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_WebSocketsChannelBindingConverter$WebSocketsChannelBindingMatcher$.prototype = $c_Lamf_client_convert_WebSocketsChannelBindingConverter$WebSocketsChannelBindingMatcher$.prototype;
$c_Lamf_client_convert_WebSocketsChannelBindingConverter$WebSocketsChannelBindingMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_WebSocketsChannelBinding(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_WebSocketsChannelBindingConverter$WebSocketsChannelBindingMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding__Lamf_client_model_domain_WebSocketsChannelBinding($as_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding(from))
});
$c_Lamf_client_convert_WebSocketsChannelBindingConverter$WebSocketsChannelBindingMatcher$.prototype.init___Lamf_client_convert_WebSocketsChannelBindingConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_WebSocketsChannelBindingConverter$WebSocketsChannelBindingMatcher$.prototype.asClient__Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding__Lamf_client_model_domain_WebSocketsChannelBinding = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_WebSocketsChannelBinding($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
var $d_Lamf_client_convert_WebSocketsChannelBindingConverter$WebSocketsChannelBindingMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_WebSocketsChannelBindingConverter$WebSocketsChannelBindingMatcher$: 0
}, false, "amf.client.convert.WebSocketsChannelBindingConverter$WebSocketsChannelBindingMatcher$", {
  Lamf_client_convert_WebSocketsChannelBindingConverter$WebSocketsChannelBindingMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_WebSocketsChannelBindingConverter$WebSocketsChannelBindingMatcher$.prototype.$classData = $d_Lamf_client_convert_WebSocketsChannelBindingConverter$WebSocketsChannelBindingMatcher$;
/** @constructor */
function $c_Lamf_client_convert_XMLSerializerConverter$XMLSerializerMatcher$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_client_convert_XMLSerializerConverter$XMLSerializerMatcher$.prototype = new $h_O();
$c_Lamf_client_convert_XMLSerializerConverter$XMLSerializerMatcher$.prototype.constructor = $c_Lamf_client_convert_XMLSerializerConverter$XMLSerializerMatcher$;
/** @constructor */
function $h_Lamf_client_convert_XMLSerializerConverter$XMLSerializerMatcher$() {
  /*<skip>*/
}
$h_Lamf_client_convert_XMLSerializerConverter$XMLSerializerMatcher$.prototype = $c_Lamf_client_convert_XMLSerializerConverter$XMLSerializerMatcher$.prototype;
$c_Lamf_client_convert_XMLSerializerConverter$XMLSerializerMatcher$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_client_model_domain_XMLSerializer(from);
  return from$1.$$undinternal$1
});
$c_Lamf_client_convert_XMLSerializerConverter$XMLSerializerMatcher$.prototype.asClient__Lamf_plugins_domain_shapes_models_XMLSerializer__Lamf_client_model_domain_XMLSerializer = (function(from) {
  var this$1 = this.$$outer$1.platform$1;
  return $as_Lamf_client_model_domain_XMLSerializer($f_Lamf_core_remote_Platform__wrap__Lamf_core_model_domain_AmfObject__Lamf_client_model_AmfObjectWrapper(this$1, from))
});
$c_Lamf_client_convert_XMLSerializerConverter$XMLSerializerMatcher$.prototype.init___Lamf_client_convert_XMLSerializerConverter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_client_convert_XMLSerializerConverter$XMLSerializerMatcher$.prototype.asClient__O__O = (function(from) {
  return this.asClient__Lamf_plugins_domain_shapes_models_XMLSerializer__Lamf_client_model_domain_XMLSerializer($as_Lamf_plugins_domain_shapes_models_XMLSerializer(from))
});
var $d_Lamf_client_convert_XMLSerializerConverter$XMLSerializerMatcher$ = new $TypeData().initClass({
  Lamf_client_convert_XMLSerializerConverter$XMLSerializerMatcher$: 0
}, false, "amf.client.convert.XMLSerializerConverter$XMLSerializerMatcher$", {
  Lamf_client_convert_XMLSerializerConverter$XMLSerializerMatcher$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_convert_XMLSerializerConverter$XMLSerializerMatcher$.prototype.$classData = $d_Lamf_client_convert_XMLSerializerConverter$XMLSerializerMatcher$;
function $f_Lamf_client_model_domain_DataNode__name__Lamf_client_model_StrField($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_DataNode();
  var from = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DataNodeModel$().Name$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
}
function $f_Lamf_client_model_domain_DataNode__withName__T__Lamf_client_model_domain_DataNode($thiz, name) {
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_DataNode();
  var field = $m_Lamf_core_metamodel_domain_DataNodeModel$().Name$1;
  $as_Lamf_core_model_domain_DataNode($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name));
  return $thiz
}
function $is_Lamf_client_model_domain_DataNode(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_client_model_domain_DataNode)))
}
function $as_Lamf_client_model_domain_DataNode(obj) {
  return (($is_Lamf_client_model_domain_DataNode(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.DataNode"))
}
function $isArrayOf_Lamf_client_model_domain_DataNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_DataNode)))
}
function $asArrayOf_Lamf_client_model_domain_DataNode(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_DataNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.DataNode;", depth))
}
/** @constructor */
function $c_Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$() {
  $c_O.call(this)
}
$c_Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$.prototype = new $h_O();
$c_Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$.prototype.constructor = $c_Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$;
/** @constructor */
function $h_Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$() {
  /*<skip>*/
}
$h_Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$.prototype = $c_Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$.prototype;
$c_Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$.prototype.asInternal__O__O = (function(from) {
  var from$1 = $as_Lamf_core_parser_Range(from);
  return new $c_Lamf_core_annotations_LexicalInformation().init___Lamf_core_parser_Range(from$1)
});
$c_Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$.prototype.asClient__O__O = (function(from) {
  var from$1 = $as_Lamf_core_annotations_LexicalInformation(from);
  return from$1.range__Lamf_core_parser_Range()
});
var $d_Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$ = new $TypeData().initClass({
  Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$: 0
}, false, "amf.client.resolve.ClientErrorHandlerConverter$RangeToLexicalConverter$", {
  Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$: 1,
  O: 1,
  Lamf_client_convert_BidirectionalMatcher: 1,
  Lamf_client_convert_ClientInternalMatcher: 1,
  Lamf_client_convert_InternalClientMatcher: 1
});
$c_Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$.prototype.$classData = $d_Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$;
var $n_Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$ = (void 0);
function $m_Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$() {
  if ((!$n_Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$)) {
    $n_Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$ = new $c_Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$().init___()
  };
  return $n_Lamf_client_resolve_ClientErrorHandlerConverter$RangeToLexicalConverter$
}
/** @constructor */
function $c_Lamf_client_resource_ResourceNotFound() {
  $c_Lamf_core_remote_FileLoaderException.call(this);
  this.msj$3 = null
}
$c_Lamf_client_resource_ResourceNotFound.prototype = new $h_Lamf_core_remote_FileLoaderException();
$c_Lamf_client_resource_ResourceNotFound.prototype.constructor = $c_Lamf_client_resource_ResourceNotFound;
/** @constructor */
function $h_Lamf_client_resource_ResourceNotFound() {
  /*<skip>*/
}
$h_Lamf_client_resource_ResourceNotFound.prototype = $c_Lamf_client_resource_ResourceNotFound.prototype;
$c_Lamf_client_resource_ResourceNotFound.prototype.init___T = (function(msj) {
  this.msj$3 = msj;
  var e = new $c_jl_Throwable().init___T(msj);
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, msj, e, true, true);
  return this
});
$c_Lamf_client_resource_ResourceNotFound.prototype.$$js$exported$prop$msj__O = (function() {
  return this.msj$3
});
Object.defineProperty($c_Lamf_client_resource_ResourceNotFound.prototype, "msj", {
  "get": (function() {
    return this.$$js$exported$prop$msj__O()
  }),
  "configurable": true
});
var $d_Lamf_client_resource_ResourceNotFound = new $TypeData().initClass({
  Lamf_client_resource_ResourceNotFound: 0
}, false, "amf.client.resource.ResourceNotFound", {
  Lamf_client_resource_ResourceNotFound: 1,
  Lamf_core_remote_FileLoaderException: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_resource_ResourceNotFound.prototype.$classData = $d_Lamf_client_resource_ResourceNotFound;
/** @constructor */
function $c_Lamf_core_annotations_Aliases$() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_Aliases$.prototype = new $h_O();
$c_Lamf_core_annotations_Aliases$.prototype.constructor = $c_Lamf_core_annotations_Aliases$;
/** @constructor */
function $h_Lamf_core_annotations_Aliases$() {
  /*<skip>*/
}
$h_Lamf_core_annotations_Aliases$.prototype = $c_Lamf_core_annotations_Aliases$.prototype;
$c_Lamf_core_annotations_Aliases$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_Aliases$.prototype.unparse__T__sci_Map__s_Option = (function(annotatedValue, objects) {
  var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(annotatedValue, ",", 0);
  var elems$2 = null;
  elems$2 = [];
  var x1 = xs.u.length;
  switch (x1) {
    case (-1): {
      break
    }
  };
  var i = 0;
  var len = xs.u.length;
  while ((i < len)) {
    var index = i;
    var arg1 = xs.get(index);
    var x$2 = $as_T(arg1);
    var x1$1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(x$2, "->", 0);
    matchEnd4$2$1: {
      var elem;
      var o7 = $m_s_Array$().unapplySeq__O__s_Option(x1$1);
      if (((!o7.isEmpty__Z()) && ((o7.get__O() !== null) && ($as_sc_SeqLike(o7.get__O()).lengthCompare__I__I(2) === 0)))) {
        var alias = $as_T($as_sc_SeqLike(o7.get__O()).apply__I__O(0));
        var urls = $as_T($as_sc_SeqLike(o7.get__O()).apply__I__O(1));
        var x1$2 = $m_sjsr_RuntimeString$().split__T__T__I__AT(urls, "::", 0);
        var o7$2 = $m_s_Array$().unapplySeq__O__s_Option(x1$2);
        if (((!o7$2.isEmpty__Z()) && ((o7$2.get__O() !== null) && ($as_sc_SeqLike(o7$2.get__O()).lengthCompare__I__I(2) === 0)))) {
          var fullUrl = $as_T($as_sc_SeqLike(o7$2.get__O()).apply__I__O(0));
          var relativeUrl = $as_T($as_sc_SeqLike(o7$2.get__O()).apply__I__O(1));
          var y = new $c_T2().init___O__O(fullUrl, relativeUrl);
          var elem = new $c_T2().init___O__O(alias, y);
          break matchEnd4$2$1
        };
        throw new $c_s_MatchError().init___O(x1$2)
      };
      throw new $c_s_MatchError().init___O(x1$1)
    };
    var unboxedElem = ((elem === null) ? null : elem);
    elems$2.push(unboxedElem);
    i = ((1 + i) | 0)
  };
  var xs$1 = $makeNativeArrayWrapper($d_T2.getArrayOf(), elems$2);
  var this$15 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$15);
  var b = cbf.apply__scm_Builder();
  var x1$3 = xs$1.u.length;
  switch (x1$3) {
    case (-1): {
      break
    }
    default: {
      b.sizeHint__I__V(x1$3)
    }
  };
  b.$$plus$plus$eq__sc_TraversableOnce__scg_Growable(new $c_scm_WrappedArray$ofRef().init___AO(xs$1));
  return new $c_s_Some().init___O(new $c_Lamf_core_annotations_Aliases().init___sci_Set($as_sci_Set(b.result__O())))
});
var $d_Lamf_core_annotations_Aliases$ = new $TypeData().initClass({
  Lamf_core_annotations_Aliases$: 0
}, false, "amf.core.annotations.Aliases$", {
  Lamf_core_annotations_Aliases$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_Aliases$.prototype.$classData = $d_Lamf_core_annotations_Aliases$;
var $n_Lamf_core_annotations_Aliases$ = (void 0);
function $m_Lamf_core_annotations_Aliases$() {
  if ((!$n_Lamf_core_annotations_Aliases$)) {
    $n_Lamf_core_annotations_Aliases$ = new $c_Lamf_core_annotations_Aliases$().init___()
  };
  return $n_Lamf_core_annotations_Aliases$
}
/** @constructor */
function $c_Lamf_core_annotations_AutoGeneratedName$() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_AutoGeneratedName$.prototype = new $h_O();
$c_Lamf_core_annotations_AutoGeneratedName$.prototype.constructor = $c_Lamf_core_annotations_AutoGeneratedName$;
/** @constructor */
function $h_Lamf_core_annotations_AutoGeneratedName$() {
  /*<skip>*/
}
$h_Lamf_core_annotations_AutoGeneratedName$.prototype = $c_Lamf_core_annotations_AutoGeneratedName$.prototype;
$c_Lamf_core_annotations_AutoGeneratedName$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_AutoGeneratedName$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_core_annotations_AutoGeneratedName().init___())
});
var $d_Lamf_core_annotations_AutoGeneratedName$ = new $TypeData().initClass({
  Lamf_core_annotations_AutoGeneratedName$: 0
}, false, "amf.core.annotations.AutoGeneratedName$", {
  Lamf_core_annotations_AutoGeneratedName$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_AutoGeneratedName$.prototype.$classData = $d_Lamf_core_annotations_AutoGeneratedName$;
var $n_Lamf_core_annotations_AutoGeneratedName$ = (void 0);
function $m_Lamf_core_annotations_AutoGeneratedName$() {
  if ((!$n_Lamf_core_annotations_AutoGeneratedName$)) {
    $n_Lamf_core_annotations_AutoGeneratedName$ = new $c_Lamf_core_annotations_AutoGeneratedName$().init___()
  };
  return $n_Lamf_core_annotations_AutoGeneratedName$
}
/** @constructor */
function $c_Lamf_core_annotations_BasePathLexicalInformation$() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_BasePathLexicalInformation$.prototype = new $h_O();
$c_Lamf_core_annotations_BasePathLexicalInformation$.prototype.constructor = $c_Lamf_core_annotations_BasePathLexicalInformation$;
/** @constructor */
function $h_Lamf_core_annotations_BasePathLexicalInformation$() {
  /*<skip>*/
}
$h_Lamf_core_annotations_BasePathLexicalInformation$.prototype = $c_Lamf_core_annotations_BasePathLexicalInformation$.prototype;
$c_Lamf_core_annotations_BasePathLexicalInformation$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_BasePathLexicalInformation$.prototype.unparse__T__sci_Map__s_Option = (function(annotatedValue, objects) {
  var range = $m_Lamf_core_parser_Range$().apply__T__Lamf_core_parser_Range(annotatedValue);
  return new $c_s_Some().init___O(new $c_Lamf_core_annotations_BasePathLexicalInformation().init___Lamf_core_parser_Range(range))
});
var $d_Lamf_core_annotations_BasePathLexicalInformation$ = new $TypeData().initClass({
  Lamf_core_annotations_BasePathLexicalInformation$: 0
}, false, "amf.core.annotations.BasePathLexicalInformation$", {
  Lamf_core_annotations_BasePathLexicalInformation$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_BasePathLexicalInformation$.prototype.$classData = $d_Lamf_core_annotations_BasePathLexicalInformation$;
var $n_Lamf_core_annotations_BasePathLexicalInformation$ = (void 0);
function $m_Lamf_core_annotations_BasePathLexicalInformation$() {
  if ((!$n_Lamf_core_annotations_BasePathLexicalInformation$)) {
    $n_Lamf_core_annotations_BasePathLexicalInformation$ = new $c_Lamf_core_annotations_BasePathLexicalInformation$().init___()
  };
  return $n_Lamf_core_annotations_BasePathLexicalInformation$
}
/** @constructor */
function $c_Lamf_core_annotations_DataNodePropertiesAnnotations$() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_DataNodePropertiesAnnotations$.prototype = new $h_O();
$c_Lamf_core_annotations_DataNodePropertiesAnnotations$.prototype.constructor = $c_Lamf_core_annotations_DataNodePropertiesAnnotations$;
/** @constructor */
function $h_Lamf_core_annotations_DataNodePropertiesAnnotations$() {
  /*<skip>*/
}
$h_Lamf_core_annotations_DataNodePropertiesAnnotations$.prototype = $c_Lamf_core_annotations_DataNodePropertiesAnnotations$.prototype;
$c_Lamf_core_annotations_DataNodePropertiesAnnotations$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_DataNodePropertiesAnnotations$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(value, "#", 0);
  var elems$2 = null;
  elems$2 = [];
  var x1 = xs.u.length;
  switch (x1) {
    case (-1): {
      break
    }
  };
  var i = 0;
  var len = xs.u.length;
  while ((i < len)) {
    var index = i;
    var arg1 = xs.get(index);
    var x$1 = $as_T(arg1);
    var x1$1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(x$1, "->", 0);
    matchEnd4$1: {
      var elem;
      var o7 = $m_s_Array$().unapplySeq__O__s_Option(x1$1);
      if (((!o7.isEmpty__Z()) && ((o7.get__O() !== null) && ($as_sc_SeqLike(o7.get__O()).lengthCompare__I__I(2) === 0)))) {
        var key = $as_T($as_sc_SeqLike(o7.get__O()).apply__I__O(0));
        var range = $as_T($as_sc_SeqLike(o7.get__O()).apply__I__O(1));
        var y = $m_Lamf_core_annotations_LexicalInformation$().apply__T__Lamf_core_annotations_LexicalInformation(range);
        var elem = new $c_T2().init___O__O(key, y);
        break matchEnd4$1
      };
      throw new $c_s_MatchError().init___O(x1$1)
    };
    var unboxedElem = ((elem === null) ? null : elem);
    elems$2.push(unboxedElem);
    i = ((1 + i) | 0)
  };
  var tuples = $makeNativeArrayWrapper($d_T2.getArrayOf(), elems$2);
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i$1 = 0;
  var len$1 = tuples.u.length;
  while ((i$1 < len$1)) {
    var index$1 = i$1;
    var arg1$1 = tuples.get(index$1);
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1$1));
    i$1 = ((1 + i$1) | 0)
  };
  return new $c_s_Some().init___O(new $c_Lamf_core_annotations_DataNodePropertiesAnnotations().init___sci_Map($as_sci_Map(b.elems$1)))
});
var $d_Lamf_core_annotations_DataNodePropertiesAnnotations$ = new $TypeData().initClass({
  Lamf_core_annotations_DataNodePropertiesAnnotations$: 0
}, false, "amf.core.annotations.DataNodePropertiesAnnotations$", {
  Lamf_core_annotations_DataNodePropertiesAnnotations$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_DataNodePropertiesAnnotations$.prototype.$classData = $d_Lamf_core_annotations_DataNodePropertiesAnnotations$;
var $n_Lamf_core_annotations_DataNodePropertiesAnnotations$ = (void 0);
function $m_Lamf_core_annotations_DataNodePropertiesAnnotations$() {
  if ((!$n_Lamf_core_annotations_DataNodePropertiesAnnotations$)) {
    $n_Lamf_core_annotations_DataNodePropertiesAnnotations$ = new $c_Lamf_core_annotations_DataNodePropertiesAnnotations$().init___()
  };
  return $n_Lamf_core_annotations_DataNodePropertiesAnnotations$
}
/** @constructor */
function $c_Lamf_core_annotations_DeclaredElement$() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_DeclaredElement$.prototype = new $h_O();
$c_Lamf_core_annotations_DeclaredElement$.prototype.constructor = $c_Lamf_core_annotations_DeclaredElement$;
/** @constructor */
function $h_Lamf_core_annotations_DeclaredElement$() {
  /*<skip>*/
}
$h_Lamf_core_annotations_DeclaredElement$.prototype = $c_Lamf_core_annotations_DeclaredElement$.prototype;
$c_Lamf_core_annotations_DeclaredElement$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_DeclaredElement$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_core_annotations_DeclaredElement().init___())
});
var $d_Lamf_core_annotations_DeclaredElement$ = new $TypeData().initClass({
  Lamf_core_annotations_DeclaredElement$: 0
}, false, "amf.core.annotations.DeclaredElement$", {
  Lamf_core_annotations_DeclaredElement$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_DeclaredElement$.prototype.$classData = $d_Lamf_core_annotations_DeclaredElement$;
var $n_Lamf_core_annotations_DeclaredElement$ = (void 0);
function $m_Lamf_core_annotations_DeclaredElement$() {
  if ((!$n_Lamf_core_annotations_DeclaredElement$)) {
    $n_Lamf_core_annotations_DeclaredElement$ = new $c_Lamf_core_annotations_DeclaredElement$().init___()
  };
  return $n_Lamf_core_annotations_DeclaredElement$
}
/** @constructor */
function $c_Lamf_core_annotations_DefaultNode$() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_DefaultNode$.prototype = new $h_O();
$c_Lamf_core_annotations_DefaultNode$.prototype.constructor = $c_Lamf_core_annotations_DefaultNode$;
/** @constructor */
function $h_Lamf_core_annotations_DefaultNode$() {
  /*<skip>*/
}
$h_Lamf_core_annotations_DefaultNode$.prototype = $c_Lamf_core_annotations_DefaultNode$.prototype;
$c_Lamf_core_annotations_DefaultNode$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_DefaultNode$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_core_annotations_DefaultNode().init___())
});
var $d_Lamf_core_annotations_DefaultNode$ = new $TypeData().initClass({
  Lamf_core_annotations_DefaultNode$: 0
}, false, "amf.core.annotations.DefaultNode$", {
  Lamf_core_annotations_DefaultNode$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_DefaultNode$.prototype.$classData = $d_Lamf_core_annotations_DefaultNode$;
var $n_Lamf_core_annotations_DefaultNode$ = (void 0);
function $m_Lamf_core_annotations_DefaultNode$() {
  if ((!$n_Lamf_core_annotations_DefaultNode$)) {
    $n_Lamf_core_annotations_DefaultNode$ = new $c_Lamf_core_annotations_DefaultNode$().init___()
  };
  return $n_Lamf_core_annotations_DefaultNode$
}
/** @constructor */
function $c_Lamf_core_annotations_ExternalFragmentRef$() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_ExternalFragmentRef$.prototype = new $h_O();
$c_Lamf_core_annotations_ExternalFragmentRef$.prototype.constructor = $c_Lamf_core_annotations_ExternalFragmentRef$;
/** @constructor */
function $h_Lamf_core_annotations_ExternalFragmentRef$() {
  /*<skip>*/
}
$h_Lamf_core_annotations_ExternalFragmentRef$.prototype = $c_Lamf_core_annotations_ExternalFragmentRef$.prototype;
$c_Lamf_core_annotations_ExternalFragmentRef$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_ExternalFragmentRef$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_core_annotations_ExternalFragmentRef().init___T(value))
});
var $d_Lamf_core_annotations_ExternalFragmentRef$ = new $TypeData().initClass({
  Lamf_core_annotations_ExternalFragmentRef$: 0
}, false, "amf.core.annotations.ExternalFragmentRef$", {
  Lamf_core_annotations_ExternalFragmentRef$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_ExternalFragmentRef$.prototype.$classData = $d_Lamf_core_annotations_ExternalFragmentRef$;
var $n_Lamf_core_annotations_ExternalFragmentRef$ = (void 0);
function $m_Lamf_core_annotations_ExternalFragmentRef$() {
  if ((!$n_Lamf_core_annotations_ExternalFragmentRef$)) {
    $n_Lamf_core_annotations_ExternalFragmentRef$ = new $c_Lamf_core_annotations_ExternalFragmentRef$().init___()
  };
  return $n_Lamf_core_annotations_ExternalFragmentRef$
}
/** @constructor */
function $c_Lamf_core_annotations_HostLexicalInformation$() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_HostLexicalInformation$.prototype = new $h_O();
$c_Lamf_core_annotations_HostLexicalInformation$.prototype.constructor = $c_Lamf_core_annotations_HostLexicalInformation$;
/** @constructor */
function $h_Lamf_core_annotations_HostLexicalInformation$() {
  /*<skip>*/
}
$h_Lamf_core_annotations_HostLexicalInformation$.prototype = $c_Lamf_core_annotations_HostLexicalInformation$.prototype;
$c_Lamf_core_annotations_HostLexicalInformation$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_HostLexicalInformation$.prototype.unparse__T__sci_Map__s_Option = (function(annotatedValue, objects) {
  var range = $m_Lamf_core_parser_Range$().apply__T__Lamf_core_parser_Range(annotatedValue);
  return new $c_s_Some().init___O(new $c_Lamf_core_annotations_HostLexicalInformation().init___Lamf_core_parser_Range(range))
});
var $d_Lamf_core_annotations_HostLexicalInformation$ = new $TypeData().initClass({
  Lamf_core_annotations_HostLexicalInformation$: 0
}, false, "amf.core.annotations.HostLexicalInformation$", {
  Lamf_core_annotations_HostLexicalInformation$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_HostLexicalInformation$.prototype.$classData = $d_Lamf_core_annotations_HostLexicalInformation$;
var $n_Lamf_core_annotations_HostLexicalInformation$ = (void 0);
function $m_Lamf_core_annotations_HostLexicalInformation$() {
  if ((!$n_Lamf_core_annotations_HostLexicalInformation$)) {
    $n_Lamf_core_annotations_HostLexicalInformation$ = new $c_Lamf_core_annotations_HostLexicalInformation$().init___()
  };
  return $n_Lamf_core_annotations_HostLexicalInformation$
}
/** @constructor */
function $c_Lamf_core_annotations_InheritanceProvenance$() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_InheritanceProvenance$.prototype = new $h_O();
$c_Lamf_core_annotations_InheritanceProvenance$.prototype.constructor = $c_Lamf_core_annotations_InheritanceProvenance$;
/** @constructor */
function $h_Lamf_core_annotations_InheritanceProvenance$() {
  /*<skip>*/
}
$h_Lamf_core_annotations_InheritanceProvenance$.prototype = $c_Lamf_core_annotations_InheritanceProvenance$.prototype;
$c_Lamf_core_annotations_InheritanceProvenance$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_InheritanceProvenance$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_core_annotations_InheritanceProvenance().init___T(value))
});
var $d_Lamf_core_annotations_InheritanceProvenance$ = new $TypeData().initClass({
  Lamf_core_annotations_InheritanceProvenance$: 0
}, false, "amf.core.annotations.InheritanceProvenance$", {
  Lamf_core_annotations_InheritanceProvenance$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_InheritanceProvenance$.prototype.$classData = $d_Lamf_core_annotations_InheritanceProvenance$;
var $n_Lamf_core_annotations_InheritanceProvenance$ = (void 0);
function $m_Lamf_core_annotations_InheritanceProvenance$() {
  if ((!$n_Lamf_core_annotations_InheritanceProvenance$)) {
    $n_Lamf_core_annotations_InheritanceProvenance$ = new $c_Lamf_core_annotations_InheritanceProvenance$().init___()
  };
  return $n_Lamf_core_annotations_InheritanceProvenance$
}
/** @constructor */
function $c_Lamf_core_annotations_InheritedShapes$() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_InheritedShapes$.prototype = new $h_O();
$c_Lamf_core_annotations_InheritedShapes$.prototype.constructor = $c_Lamf_core_annotations_InheritedShapes$;
/** @constructor */
function $h_Lamf_core_annotations_InheritedShapes$() {
  /*<skip>*/
}
$h_Lamf_core_annotations_InheritedShapes$.prototype = $c_Lamf_core_annotations_InheritedShapes$.prototype;
$c_Lamf_core_annotations_InheritedShapes$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_InheritedShapes$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_core_annotations_InheritedShapes().init___sc_Seq($m_s_Predef$().wrapRefArray__AO__scm_WrappedArray($m_sjsr_RuntimeString$().split__T__T__I__AT(value, ",", 0))))
});
var $d_Lamf_core_annotations_InheritedShapes$ = new $TypeData().initClass({
  Lamf_core_annotations_InheritedShapes$: 0
}, false, "amf.core.annotations.InheritedShapes$", {
  Lamf_core_annotations_InheritedShapes$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_InheritedShapes$.prototype.$classData = $d_Lamf_core_annotations_InheritedShapes$;
var $n_Lamf_core_annotations_InheritedShapes$ = (void 0);
function $m_Lamf_core_annotations_InheritedShapes$() {
  if ((!$n_Lamf_core_annotations_InheritedShapes$)) {
    $n_Lamf_core_annotations_InheritedShapes$ = new $c_Lamf_core_annotations_InheritedShapes$().init___()
  };
  return $n_Lamf_core_annotations_InheritedShapes$
}
/** @constructor */
function $c_Lamf_core_annotations_InlineElement$() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_InlineElement$.prototype = new $h_O();
$c_Lamf_core_annotations_InlineElement$.prototype.constructor = $c_Lamf_core_annotations_InlineElement$;
/** @constructor */
function $h_Lamf_core_annotations_InlineElement$() {
  /*<skip>*/
}
$h_Lamf_core_annotations_InlineElement$.prototype = $c_Lamf_core_annotations_InlineElement$.prototype;
$c_Lamf_core_annotations_InlineElement$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_InlineElement$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_core_annotations_InlineElement().init___())
});
var $d_Lamf_core_annotations_InlineElement$ = new $TypeData().initClass({
  Lamf_core_annotations_InlineElement$: 0
}, false, "amf.core.annotations.InlineElement$", {
  Lamf_core_annotations_InlineElement$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_InlineElement$.prototype.$classData = $d_Lamf_core_annotations_InlineElement$;
var $n_Lamf_core_annotations_InlineElement$ = (void 0);
function $m_Lamf_core_annotations_InlineElement$() {
  if ((!$n_Lamf_core_annotations_InlineElement$)) {
    $n_Lamf_core_annotations_InlineElement$ = new $c_Lamf_core_annotations_InlineElement$().init___()
  };
  return $n_Lamf_core_annotations_InlineElement$
}
/** @constructor */
function $c_Lamf_core_annotations_LexicalInformation$() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_LexicalInformation$.prototype = new $h_O();
$c_Lamf_core_annotations_LexicalInformation$.prototype.constructor = $c_Lamf_core_annotations_LexicalInformation$;
/** @constructor */
function $h_Lamf_core_annotations_LexicalInformation$() {
  /*<skip>*/
}
$h_Lamf_core_annotations_LexicalInformation$.prototype = $c_Lamf_core_annotations_LexicalInformation$.prototype;
$c_Lamf_core_annotations_LexicalInformation$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_LexicalInformation$.prototype.unparse__T__sci_Map__s_Option = (function(annotatedValue, objects) {
  return new $c_s_Some().init___O($m_Lamf_core_annotations_LexicalInformation$().apply__T__Lamf_core_annotations_LexicalInformation(annotatedValue))
});
$c_Lamf_core_annotations_LexicalInformation$.prototype.apply__T__Lamf_core_annotations_LexicalInformation = (function(range) {
  return new $c_Lamf_core_annotations_LexicalInformation().init___Lamf_core_parser_Range($m_Lamf_core_parser_Range$().apply__T__Lamf_core_parser_Range(range))
});
var $d_Lamf_core_annotations_LexicalInformation$ = new $TypeData().initClass({
  Lamf_core_annotations_LexicalInformation$: 0
}, false, "amf.core.annotations.LexicalInformation$", {
  Lamf_core_annotations_LexicalInformation$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_LexicalInformation$.prototype.$classData = $d_Lamf_core_annotations_LexicalInformation$;
var $n_Lamf_core_annotations_LexicalInformation$ = (void 0);
function $m_Lamf_core_annotations_LexicalInformation$() {
  if ((!$n_Lamf_core_annotations_LexicalInformation$)) {
    $n_Lamf_core_annotations_LexicalInformation$ = new $c_Lamf_core_annotations_LexicalInformation$().init___()
  };
  return $n_Lamf_core_annotations_LexicalInformation$
}
/** @constructor */
function $c_Lamf_core_annotations_NilUnion$() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_NilUnion$.prototype = new $h_O();
$c_Lamf_core_annotations_NilUnion$.prototype.constructor = $c_Lamf_core_annotations_NilUnion$;
/** @constructor */
function $h_Lamf_core_annotations_NilUnion$() {
  /*<skip>*/
}
$h_Lamf_core_annotations_NilUnion$.prototype = $c_Lamf_core_annotations_NilUnion$.prototype;
$c_Lamf_core_annotations_NilUnion$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_NilUnion$.prototype.unparse__T__sci_Map__s_Option = (function(annotatedValue, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_core_annotations_NilUnion().init___T(annotatedValue))
});
var $d_Lamf_core_annotations_NilUnion$ = new $TypeData().initClass({
  Lamf_core_annotations_NilUnion$: 0
}, false, "amf.core.annotations.NilUnion$", {
  Lamf_core_annotations_NilUnion$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_NilUnion$.prototype.$classData = $d_Lamf_core_annotations_NilUnion$;
var $n_Lamf_core_annotations_NilUnion$ = (void 0);
function $m_Lamf_core_annotations_NilUnion$() {
  if ((!$n_Lamf_core_annotations_NilUnion$)) {
    $n_Lamf_core_annotations_NilUnion$ = new $c_Lamf_core_annotations_NilUnion$().init___()
  };
  return $n_Lamf_core_annotations_NilUnion$
}
/** @constructor */
function $c_Lamf_core_annotations_NullSecurity$() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_NullSecurity$.prototype = new $h_O();
$c_Lamf_core_annotations_NullSecurity$.prototype.constructor = $c_Lamf_core_annotations_NullSecurity$;
/** @constructor */
function $h_Lamf_core_annotations_NullSecurity$() {
  /*<skip>*/
}
$h_Lamf_core_annotations_NullSecurity$.prototype = $c_Lamf_core_annotations_NullSecurity$.prototype;
$c_Lamf_core_annotations_NullSecurity$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_NullSecurity$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_core_annotations_NullSecurity().init___())
});
var $d_Lamf_core_annotations_NullSecurity$ = new $TypeData().initClass({
  Lamf_core_annotations_NullSecurity$: 0
}, false, "amf.core.annotations.NullSecurity$", {
  Lamf_core_annotations_NullSecurity$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_NullSecurity$.prototype.$classData = $d_Lamf_core_annotations_NullSecurity$;
var $n_Lamf_core_annotations_NullSecurity$ = (void 0);
function $m_Lamf_core_annotations_NullSecurity$() {
  if ((!$n_Lamf_core_annotations_NullSecurity$)) {
    $n_Lamf_core_annotations_NullSecurity$ = new $c_Lamf_core_annotations_NullSecurity$().init___()
  };
  return $n_Lamf_core_annotations_NullSecurity$
}
/** @constructor */
function $c_Lamf_core_annotations_ResolvedLinkAnnotation$() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_ResolvedLinkAnnotation$.prototype = new $h_O();
$c_Lamf_core_annotations_ResolvedLinkAnnotation$.prototype.constructor = $c_Lamf_core_annotations_ResolvedLinkAnnotation$;
/** @constructor */
function $h_Lamf_core_annotations_ResolvedLinkAnnotation$() {
  /*<skip>*/
}
$h_Lamf_core_annotations_ResolvedLinkAnnotation$.prototype = $c_Lamf_core_annotations_ResolvedLinkAnnotation$.prototype;
$c_Lamf_core_annotations_ResolvedLinkAnnotation$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_ResolvedLinkAnnotation$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_core_annotations_ResolvedLinkAnnotation().init___T(value))
});
var $d_Lamf_core_annotations_ResolvedLinkAnnotation$ = new $TypeData().initClass({
  Lamf_core_annotations_ResolvedLinkAnnotation$: 0
}, false, "amf.core.annotations.ResolvedLinkAnnotation$", {
  Lamf_core_annotations_ResolvedLinkAnnotation$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_ResolvedLinkAnnotation$.prototype.$classData = $d_Lamf_core_annotations_ResolvedLinkAnnotation$;
var $n_Lamf_core_annotations_ResolvedLinkAnnotation$ = (void 0);
function $m_Lamf_core_annotations_ResolvedLinkAnnotation$() {
  if ((!$n_Lamf_core_annotations_ResolvedLinkAnnotation$)) {
    $n_Lamf_core_annotations_ResolvedLinkAnnotation$ = new $c_Lamf_core_annotations_ResolvedLinkAnnotation$().init___()
  };
  return $n_Lamf_core_annotations_ResolvedLinkAnnotation$
}
/** @constructor */
function $c_Lamf_core_annotations_SingleValueArray$() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_SingleValueArray$.prototype = new $h_O();
$c_Lamf_core_annotations_SingleValueArray$.prototype.constructor = $c_Lamf_core_annotations_SingleValueArray$;
/** @constructor */
function $h_Lamf_core_annotations_SingleValueArray$() {
  /*<skip>*/
}
$h_Lamf_core_annotations_SingleValueArray$.prototype = $c_Lamf_core_annotations_SingleValueArray$.prototype;
$c_Lamf_core_annotations_SingleValueArray$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_SingleValueArray$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_core_annotations_SingleValueArray().init___())
});
var $d_Lamf_core_annotations_SingleValueArray$ = new $TypeData().initClass({
  Lamf_core_annotations_SingleValueArray$: 0
}, false, "amf.core.annotations.SingleValueArray$", {
  Lamf_core_annotations_SingleValueArray$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_SingleValueArray$.prototype.$classData = $d_Lamf_core_annotations_SingleValueArray$;
var $n_Lamf_core_annotations_SingleValueArray$ = (void 0);
function $m_Lamf_core_annotations_SingleValueArray$() {
  if ((!$n_Lamf_core_annotations_SingleValueArray$)) {
    $n_Lamf_core_annotations_SingleValueArray$ = new $c_Lamf_core_annotations_SingleValueArray$().init___()
  };
  return $n_Lamf_core_annotations_SingleValueArray$
}
/** @constructor */
function $c_Lamf_core_annotations_SourceVendor$() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_SourceVendor$.prototype = new $h_O();
$c_Lamf_core_annotations_SourceVendor$.prototype.constructor = $c_Lamf_core_annotations_SourceVendor$;
/** @constructor */
function $h_Lamf_core_annotations_SourceVendor$() {
  /*<skip>*/
}
$h_Lamf_core_annotations_SourceVendor$.prototype = $c_Lamf_core_annotations_SourceVendor$.prototype;
$c_Lamf_core_annotations_SourceVendor$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_SourceVendor$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return $m_Lamf_core_annotations_SourceVendor$().parse__T__s_Option(value)
});
$c_Lamf_core_annotations_SourceVendor$.prototype.parse__T__s_Option = (function(vendor) {
  return (($m_Lamf_core_remote_Raml$().name$1 === vendor) ? new $c_s_Some().init___O(new $c_Lamf_core_annotations_SourceVendor().init___Lamf_core_remote_Vendor($m_Lamf_core_remote_Raml$())) : (($m_Lamf_core_remote_Raml08$().name$1 === vendor) ? new $c_s_Some().init___O(new $c_Lamf_core_annotations_SourceVendor().init___Lamf_core_remote_Vendor($m_Lamf_core_remote_Raml08$())) : (($m_Lamf_core_remote_Raml10$().name$1 === vendor) ? new $c_s_Some().init___O(new $c_Lamf_core_annotations_SourceVendor().init___Lamf_core_remote_Vendor($m_Lamf_core_remote_Raml10$())) : (($m_Lamf_core_remote_Amf$().name$1 === vendor) ? new $c_s_Some().init___O(new $c_Lamf_core_annotations_SourceVendor().init___Lamf_core_remote_Vendor($m_Lamf_core_remote_Amf$())) : (($m_Lamf_core_remote_Oas$().name$1 === vendor) ? new $c_s_Some().init___O(new $c_Lamf_core_annotations_SourceVendor().init___Lamf_core_remote_Vendor($m_Lamf_core_remote_Oas$())) : (($m_Lamf_core_remote_Oas20$().name$1 === vendor) ? new $c_s_Some().init___O(new $c_Lamf_core_annotations_SourceVendor().init___Lamf_core_remote_Vendor($m_Lamf_core_remote_Oas$())) : (($m_Lamf_core_remote_Oas30$().name$1 === vendor) ? new $c_s_Some().init___O(new $c_Lamf_core_annotations_SourceVendor().init___Lamf_core_remote_Vendor($m_Lamf_core_remote_Oas30$())) : $m_s_None$())))))))
});
var $d_Lamf_core_annotations_SourceVendor$ = new $TypeData().initClass({
  Lamf_core_annotations_SourceVendor$: 0
}, false, "amf.core.annotations.SourceVendor$", {
  Lamf_core_annotations_SourceVendor$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_SourceVendor$.prototype.$classData = $d_Lamf_core_annotations_SourceVendor$;
var $n_Lamf_core_annotations_SourceVendor$ = (void 0);
function $m_Lamf_core_annotations_SourceVendor$() {
  if ((!$n_Lamf_core_annotations_SourceVendor$)) {
    $n_Lamf_core_annotations_SourceVendor$ = new $c_Lamf_core_annotations_SourceVendor$().init___()
  };
  return $n_Lamf_core_annotations_SourceVendor$
}
/** @constructor */
function $c_Lamf_core_annotations_SynthesizedField$() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_SynthesizedField$.prototype = new $h_O();
$c_Lamf_core_annotations_SynthesizedField$.prototype.constructor = $c_Lamf_core_annotations_SynthesizedField$;
/** @constructor */
function $h_Lamf_core_annotations_SynthesizedField$() {
  /*<skip>*/
}
$h_Lamf_core_annotations_SynthesizedField$.prototype = $c_Lamf_core_annotations_SynthesizedField$.prototype;
$c_Lamf_core_annotations_SynthesizedField$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_SynthesizedField$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_core_annotations_SynthesizedField().init___())
});
var $d_Lamf_core_annotations_SynthesizedField$ = new $TypeData().initClass({
  Lamf_core_annotations_SynthesizedField$: 0
}, false, "amf.core.annotations.SynthesizedField$", {
  Lamf_core_annotations_SynthesizedField$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_SynthesizedField$.prototype.$classData = $d_Lamf_core_annotations_SynthesizedField$;
var $n_Lamf_core_annotations_SynthesizedField$ = (void 0);
function $m_Lamf_core_annotations_SynthesizedField$() {
  if ((!$n_Lamf_core_annotations_SynthesizedField$)) {
    $n_Lamf_core_annotations_SynthesizedField$ = new $c_Lamf_core_annotations_SynthesizedField$().init___()
  };
  return $n_Lamf_core_annotations_SynthesizedField$
}
/** @constructor */
function $c_Lamf_core_annotations_TrackedElement$() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_TrackedElement$.prototype = new $h_O();
$c_Lamf_core_annotations_TrackedElement$.prototype.constructor = $c_Lamf_core_annotations_TrackedElement$;
/** @constructor */
function $h_Lamf_core_annotations_TrackedElement$() {
  /*<skip>*/
}
$h_Lamf_core_annotations_TrackedElement$.prototype = $c_Lamf_core_annotations_TrackedElement$.prototype;
$c_Lamf_core_annotations_TrackedElement$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_TrackedElement$.prototype.apply__T__Lamf_core_annotations_TrackedElement = (function(parent) {
  var array = [parent];
  if (($uI(array.length) === 0)) {
    var jsx$1 = $m_sci_Set$EmptySet$()
  } else {
    var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      b.$$plus$eq__O__scm_SetBuilder(arg1);
      i = ((1 + i) | 0)
    };
    var jsx$1 = b.elems$1
  };
  return new $c_Lamf_core_annotations_TrackedElement().init___sci_Set($as_sci_Set(jsx$1))
});
$c_Lamf_core_annotations_TrackedElement$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(value, ",", 0);
  var this$3 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$3);
  var b = cbf.apply__scm_Builder();
  var x1 = xs.u.length;
  switch (x1) {
    case (-1): {
      break
    }
    default: {
      b.sizeHint__I__V(x1)
    }
  };
  b.$$plus$plus$eq__sc_TraversableOnce__scg_Growable(new $c_scm_WrappedArray$ofRef().init___AO(xs));
  return new $c_s_Some().init___O(new $c_Lamf_core_annotations_TrackedElement().init___sci_Set($as_sci_Set(b.result__O())))
});
var $d_Lamf_core_annotations_TrackedElement$ = new $TypeData().initClass({
  Lamf_core_annotations_TrackedElement$: 0
}, false, "amf.core.annotations.TrackedElement$", {
  Lamf_core_annotations_TrackedElement$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_TrackedElement$.prototype.$classData = $d_Lamf_core_annotations_TrackedElement$;
var $n_Lamf_core_annotations_TrackedElement$ = (void 0);
function $m_Lamf_core_annotations_TrackedElement$() {
  if ((!$n_Lamf_core_annotations_TrackedElement$)) {
    $n_Lamf_core_annotations_TrackedElement$ = new $c_Lamf_core_annotations_TrackedElement$().init___()
  };
  return $n_Lamf_core_annotations_TrackedElement$
}
function $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "encodes"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "encodes", "The encodes relationship links a parsing Unit with the DomainElement from a particular domain the unit contains.", $m_sci_Nil$()), true))
}
function $f_Lamf_core_metamodel_document_FragmentModel__modelInstance__Lamf_core_model_domain_AmfObject($thiz) {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Fragment is abstract instances cannot be created directly"))
}
function $f_Lamf_core_metamodel_document_ModuleModel__$$init$__V($thiz) {
  var jsx$1 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_domain_DomainElementModel$());
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.amf$core$metamodel$document$ModuleModel$$undsetter$und$Declares$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "declares"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "declares", "The declares relationship exposes a DomainElement as a re-usable unit that can be referenced from other units.\nURIs for the declared DomainElement are considered to be stable and safe to reference from other DomainElements.", $m_sci_Nil$()), true))
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_ExternalSourceElementModel$() {
  $c_O.call(this);
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Raw$1 = null;
  this.ReferenceId$1 = null;
  this.Location$1 = null
}
$c_Lamf_core_metamodel_domain_ExternalSourceElementModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_ExternalSourceElementModel$.prototype.constructor = $c_Lamf_core_metamodel_domain_ExternalSourceElementModel$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_ExternalSourceElementModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_ExternalSourceElementModel$.prototype = $c_Lamf_core_metamodel_domain_ExternalSourceElementModel$.prototype;
$c_Lamf_core_metamodel_domain_ExternalSourceElementModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_ExternalSourceElementModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ExternalSourceElementModel__$$init$__V(this);
  $m_sci_List$();
  var array = [this.Raw$1, this.ReferenceId$1, this.Location$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  this.fields$1 = result;
  $m_sci_List$();
  var this$5 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var array$1 = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$5, "ExternalSource")];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$10 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$10);
    i$1 = (((-1) + i$1) | 0)
  };
  this.type$1 = result$1;
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "External Source Element", "Inlined fragment of information", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_domain_ExternalSourceElementModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Raw$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Raw$1 = x$1
});
$c_Lamf_core_metamodel_domain_ExternalSourceElementModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_domain_ExternalSourceElementModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_domain_ExternalSourceElementModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_core_metamodel_domain_ExternalSourceElementModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_core_metamodel_domain_ExternalSourceElementModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_core_metamodel_domain_ExternalSourceElementModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$ReferenceId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReferenceId$1 = x$1
});
var $d_Lamf_core_metamodel_domain_ExternalSourceElementModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_ExternalSourceElementModel$: 0
}, false, "amf.core.metamodel.domain.ExternalSourceElementModel$", {
  Lamf_core_metamodel_domain_ExternalSourceElementModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_ExternalSourceElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1
});
$c_Lamf_core_metamodel_domain_ExternalSourceElementModel$.prototype.$classData = $d_Lamf_core_metamodel_domain_ExternalSourceElementModel$;
var $n_Lamf_core_metamodel_domain_ExternalSourceElementModel$ = (void 0);
function $m_Lamf_core_metamodel_domain_ExternalSourceElementModel$() {
  if ((!$n_Lamf_core_metamodel_domain_ExternalSourceElementModel$)) {
    $n_Lamf_core_metamodel_domain_ExternalSourceElementModel$ = new $c_Lamf_core_metamodel_domain_ExternalSourceElementModel$().init___()
  };
  return $n_Lamf_core_metamodel_domain_ExternalSourceElementModel$
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_LinkableElementModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null
}
$c_Lamf_core_metamodel_domain_LinkableElementModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_LinkableElementModel$.prototype.constructor = $c_Lamf_core_metamodel_domain_LinkableElementModel$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_LinkableElementModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_LinkableElementModel$.prototype = $c_Lamf_core_metamodel_domain_LinkableElementModel$.prototype;
$c_Lamf_core_metamodel_domain_LinkableElementModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_core_metamodel_domain_LinkableElementModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_core_metamodel_domain_LinkableElementModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_LinkableElementModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $m_sci_List$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "Linkable")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  this.type$1 = result;
  $m_sci_List$();
  var array$1 = [this.TargetId$1, this.Label$1, this.SupportsRecursion$1];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$10 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$10);
    i$1 = (((-1) + i$1) | 0)
  };
  this.fields$1 = result$1;
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "Linkable Element", "Reification of a link between elements in the model. Used when we want to capture the structure of the source document\nin the graph itself. Linkable elements are just replaced by regular links after resolution.", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_domain_LinkableElementModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_domain_LinkableElementModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_core_metamodel_domain_LinkableElementModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_core_metamodel_domain_LinkableElementModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_domain_LinkableElementModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_core_metamodel_domain_LinkableElementModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_core_metamodel_domain_LinkableElementModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_LinkableElementModel$: 0
}, false, "amf.core.metamodel.domain.LinkableElementModel$", {
  Lamf_core_metamodel_domain_LinkableElementModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1
});
$c_Lamf_core_metamodel_domain_LinkableElementModel$.prototype.$classData = $d_Lamf_core_metamodel_domain_LinkableElementModel$;
var $n_Lamf_core_metamodel_domain_LinkableElementModel$ = (void 0);
function $m_Lamf_core_metamodel_domain_LinkableElementModel$() {
  if ((!$n_Lamf_core_metamodel_domain_LinkableElementModel$)) {
    $n_Lamf_core_metamodel_domain_LinkableElementModel$ = new $c_Lamf_core_metamodel_domain_LinkableElementModel$().init___()
  };
  return $n_Lamf_core_metamodel_domain_LinkableElementModel$
}
function $f_Lamf_core_metamodel_domain_ObjectNodeModel__$$init$__V($thiz) {
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
  var x$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "Object");
  var this$3 = $m_Lamf_core_metamodel_domain_DataNodeModel$().type$1;
  $thiz.amf$core$metamodel$domain$ObjectNodeModel$$undsetter$und$type$und$eq__sci_List__V(new $c_sci_$colon$colon().init___O__sci_List(x$2, this$3));
  $thiz.amf$core$metamodel$domain$ObjectNodeModel$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V(new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Data$1, "Object Node", "Node that represents a dynamic object with records data structure", $m_sci_Nil$()))
}
function $f_Lamf_core_model_BoolField__value__Z($thiz) {
  var x1 = $thiz.option$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var v = $uZ(x2.value$2);
    return v
  } else {
    return false
  }
}
function $is_Lamf_core_model_BoolField(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_BoolField)))
}
function $as_Lamf_core_model_BoolField(obj) {
  return (($is_Lamf_core_model_BoolField(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.BoolField"))
}
function $isArrayOf_Lamf_core_model_BoolField(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_BoolField)))
}
function $asArrayOf_Lamf_core_model_BoolField(obj, depth) {
  return (($isArrayOf_Lamf_core_model_BoolField(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.BoolField;", depth))
}
function $is_Lamf_core_model_DoubleField(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_DoubleField)))
}
function $as_Lamf_core_model_DoubleField(obj) {
  return (($is_Lamf_core_model_DoubleField(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.DoubleField"))
}
function $isArrayOf_Lamf_core_model_DoubleField(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_DoubleField)))
}
function $asArrayOf_Lamf_core_model_DoubleField(obj, depth) {
  return (($isArrayOf_Lamf_core_model_DoubleField(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.DoubleField;", depth))
}
function $f_Lamf_core_model_IntField__value__I($thiz) {
  var x1 = $thiz.option$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var v = $uI(x2.value$2);
    return v
  } else {
    return 0
  }
}
function $is_Lamf_core_model_IntField(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_IntField)))
}
function $as_Lamf_core_model_IntField(obj) {
  return (($is_Lamf_core_model_IntField(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.IntField"))
}
function $isArrayOf_Lamf_core_model_IntField(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_IntField)))
}
function $asArrayOf_Lamf_core_model_IntField(obj, depth) {
  return (($isArrayOf_Lamf_core_model_IntField(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.IntField;", depth))
}
function $f_Lamf_core_model_document_BaseUnit__withRaw__T__Lamf_core_model_document_BaseUnit($thiz, raw) {
  $thiz.raw$und$eq__s_Option__V(new $c_s_Some().init___O(raw));
  return $thiz
}
function $f_Lamf_core_model_document_BaseUnit__findById__T__s_Option($thiz, id) {
  var x$1 = $m_Lamf_core_model_document_FieldsFilter$All$();
  var x$2 = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
  var this$1 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator($thiz, x$2, x$1);
  var pf = new $c_Lamf_core_model_document_BaseUnit$$anonfun$findById$1().init___Lamf_core_model_document_BaseUnit__T($thiz, id);
  return $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$1, pf)
}
function $f_Lamf_core_model_document_BaseUnit__findByType__T__sc_Seq($thiz, shapeType) {
  var predicate = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, shapeType$1) {
    return (function(element$2) {
      var element = $as_Lamf_core_model_domain_DomainElement(element$2);
      var this$1 = $f_Lamf_core_metamodel_MetaModelTypeMapping__metaModel__O__Lamf_core_metamodel_Obj($this, element).type__sci_List();
      var these = this$1;
      while ((!these.isEmpty__Z())) {
        var arg1 = these.head__O();
        var valueType = $as_Lamf_core_vocabulary_ValueType(arg1);
        if ((valueType.iri__T() === shapeType$1)) {
          return true
        };
        these = $as_sc_LinearSeqOptimized(these.tail__O())
      };
      return false
    })
  })($thiz, shapeType));
  var strategy = $m_Lamf_core_traversal_iterator_DomainElementStrategy$();
  var fieldsFilter = $m_Lamf_core_model_document_FieldsFilter$Local$();
  var this$2 = $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator($thiz, strategy, fieldsFilter);
  var pf = new $c_Lamf_core_model_document_BaseUnit$$anonfun$findByType$3().init___Lamf_core_model_document_BaseUnit__F1($thiz, predicate);
  var this$3 = new $c_sc_Iterator$$anon$13().init___sc_Iterator__s_PartialFunction(this$2, pf);
  return $f_sc_Iterator__toStream__sci_Stream(this$3)
}
function $f_Lamf_core_model_document_BaseUnit__transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit($thiz, selector, transformation, errorHandler) {
  var domainElementAdapter = new $c_Lamf_core_traversal_DomainElementSelectorAdapter().init___F1(selector);
  var transformationAdapter = new $c_Lamf_core_traversal_DomainElementTransformationAdapter().init___F2(transformation);
  var qual$1 = new $c_Lamf_core_traversal_TransformationTraversal().init___Lamf_core_traversal_TransformationData(new $c_Lamf_core_traversal_TransformationData().init___F1__F2(domainElementAdapter, transformationAdapter));
  var x$2 = new $c_Lamf_core_traversal_ObjectIdTraversalPath().init___scm_Set($as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
  qual$1.traverse__Lamf_core_model_domain_AmfObject__Lamf_core_traversal_TraversalPath__Lamf_core_model_domain_AmfObject($thiz, x$2);
  return $thiz
}
function $f_Lamf_core_model_document_BaseUnit__location__s_Option($thiz) {
  var fieldValue = $as_Lamf_core_model_StrField($thiz.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1));
  var this$1 = fieldValue.option$1;
  return (this$1.isEmpty__Z() ? $f_Lamf_core_model_domain_AmfElement__location__s_Option($thiz) : this$1)
}
function $f_Lamf_core_model_document_BaseUnit__errorHandler__Lamf_core_errorhandling_ErrorHandler($thiz) {
  var x1 = $thiz.amf$core$model$document$BaseUnit$$run__s_Option();
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var num = $uI(x2.value$2);
    return new $c_Lamf_client_parse_DefaultParserErrorHandler().init___I(num)
  } else {
    var eh = new $c_Lamf_client_parse_DefaultParserErrorHandler().init___I($m_Lamf_core_AMFCompilerRunCount$().nextRun__I());
    $thiz.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V(new $c_s_Some().init___O(eh.parserRun$1));
    return eh
  }
}
function $f_Lamf_core_model_document_BaseUnit__$$init$__V($thiz) {
  var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().ModelVersion$1;
  $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject($thiz, field, "2.1.0"));
  var field$1 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Root$1;
  $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject($thiz, field$1, false));
  $thiz.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V($m_s_None$());
  $thiz.raw$und$eq__s_Option__V($m_s_None$())
}
function $f_Lamf_core_model_document_BaseUnit__findInReferences__T__s_Option($thiz, id) {
  return $thiz.references__sc_Seq().find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, id$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_document_BaseUnit(x$1$2);
      return (x$1.id__T() === id$1)
    })
  })($thiz, id)))
}
function $f_Lamf_core_model_document_BaseUnit__iterator__Lamf_core_traversal_iterator_IteratorStrategy__Lamf_core_model_document_FieldsFilter__Lamf_core_traversal_iterator_AmfIterator($thiz, strategy, fieldsFilter) {
  return strategy.iterator__sci_List__Lamf_core_traversal_iterator_AmfIterator(fieldsFilter.filter__Lamf_core_parser_Fields__sci_List($thiz.fields__Lamf_core_parser_Fields()))
}
function $f_Lamf_core_model_document_BaseUnit__addReference__Lamf_core_model_document_BaseUnit__V($thiz, newRef) {
  var jsx$1 = $thiz.references__sc_Seq();
  var this$1 = $m_sc_Seq$();
  var references = $as_sc_Seq(jsx$1.$$colon$plus__O__scg_CanBuildFrom__O(newRef, this$1.ReusableCBFInstance$2));
  var field = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
  $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject($thiz, field, references))
}
function $f_Lamf_core_model_document_BaseUnit__toNativeRdfModel__Lamf_core_emitter_RenderOptions__Lamf_core_rdf_RdfModel($thiz, renderOptions) {
  var x1 = $thiz.platform__Lamf_core_remote_Platform().rdfFramework__s_Option();
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var rdf = $as_Lamf_core_rdf_RdfFramework(x2.value$2);
    return $f_Lamf_core_rdf_RdfFramework__unitToRdfModel__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__Lamf_core_rdf_RdfModel(rdf, $thiz, renderOptions)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("RDF Framework not registered cannot export to native RDF model"))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
}
function $f_Lamf_core_model_document_BaseUnit__withRunNumber__I__Lamf_core_model_document_BaseUnit($thiz, parserRun) {
  var this$1 = $thiz.amf$core$model$document$BaseUnit$$run__s_Option();
  if (this$1.isDefined__Z()) {
    return $thiz
  } else {
    $thiz.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V(new $c_s_Some().init___O(parserRun));
    return $thiz
  }
}
function $f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject($thiz, branch) {
  var cloned = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject($thiz, branch));
  var this$1 = $thiz.amf$core$model$document$BaseUnit$$run__s_Option();
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var parserRun = $uI(arg1);
    $f_Lamf_core_model_document_BaseUnit__withRunNumber__I__Lamf_core_model_document_BaseUnit(cloned, parserRun)
  };
  cloned.raw$und$eq__s_Option__V($thiz.raw__s_Option());
  return cloned
}
function $f_Lamf_core_model_document_BaseUnit__sourceVendor__s_Option($thiz) {
  if ($is_Lamf_core_model_document_EncodesModel($thiz)) {
    if ($m_s_Option$().apply__O__s_Option($as_Lamf_core_model_document_EncodesModel($thiz).encodes__Lamf_core_model_domain_DomainElement()).isDefined__Z()) {
      var this$1 = $as_Lamf_core_model_document_EncodesModel($thiz).encodes__Lamf_core_model_domain_DomainElement().annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_SourceVendor.getClassOf());
      if (this$1.isEmpty__Z()) {
        return $m_s_None$()
      } else {
        var arg1 = this$1.get__O();
        var a = $as_Lamf_core_annotations_SourceVendor(arg1);
        return new $c_s_Some().init___O(a.vendor$1)
      }
    }
  };
  if ($is_Lamf_core_model_document_DeclaresModel($thiz)) {
    var this$2 = $thiz.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_SourceVendor.getClassOf());
    if (this$2.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1$1 = this$2.get__O();
      var a$3 = $as_Lamf_core_annotations_SourceVendor(arg1$1);
      return new $c_s_Some().init___O(a$3.vendor$1)
    }
  };
  return $m_s_None$()
}
function $is_Lamf_core_model_document_BaseUnit(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_document_BaseUnit)))
}
function $as_Lamf_core_model_document_BaseUnit(obj) {
  return (($is_Lamf_core_model_document_BaseUnit(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.document.BaseUnit"))
}
function $isArrayOf_Lamf_core_model_document_BaseUnit(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_document_BaseUnit)))
}
function $asArrayOf_Lamf_core_model_document_BaseUnit(obj, depth) {
  return (($isArrayOf_Lamf_core_model_document_BaseUnit(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.document.BaseUnit;", depth))
}
/** @constructor */
function $c_Lamf_core_model_domain_DataNode() {
  $c_O.call(this);
  this.fields$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_core_model_domain_DataNode.prototype = new $h_O();
$c_Lamf_core_model_domain_DataNode.prototype.constructor = $c_Lamf_core_model_domain_DataNode;
/** @constructor */
function $h_Lamf_core_model_domain_DataNode() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_DataNode.prototype = $c_Lamf_core_model_domain_DataNode.prototype;
$c_Lamf_core_model_domain_DataNode.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_core_model_domain_DataNode.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return this.adopted__T__sc_Seq__Lamf_core_model_domain_DataNode(parent, cycle)
});
$c_Lamf_core_model_domain_DataNode.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_core_model_domain_DataNode.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DataNodeModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "data-node" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_core_model_domain_DataNode.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return this.cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(branch)
});
$c_Lamf_core_model_domain_DataNode.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_core_model_domain_DataNode.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_DataNode = (function(parent, cycle) {
  return ($m_s_Option$().apply__O__s_Option(this.id$1).isEmpty__Z() ? $as_Lamf_core_model_domain_DataNode($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)) : this)
});
$c_Lamf_core_model_domain_DataNode.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_core_model_domain_DataNode.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_core_model_domain_DataNode.prototype.forceAdopted__T__Lamf_core_model_domain_DataNode = (function(parent) {
  var this$1 = $as_Lamf_core_model_StrField(this.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DataNodeModel$().Name$1)).option$1;
  if (this$1.isEmpty__Z()) {
    var this$5 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_T(arg1);
    var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(x$1);
    var this$4 = this$3.platform$1;
    var url = this$3.str$1;
    var this$5 = new $c_s_Some().init___O($f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
  };
  var adoptedId = ((parent + "/") + (this$5.isEmpty__Z() ? null : this$5.get__O()));
  var rc7 = false;
  var x2 = null;
  var x1 = $m_s_Option$().apply__O__s_Option(this.id$1);
  matchEnd8: {
    var newId;
    if ((x1 instanceof $c_s_Some)) {
      rc7 = true;
      x2 = $as_s_Some(x1);
      var oldId = $as_T(x2.value$2);
      if ((oldId !== null)) {
        if ($m_sjsr_RuntimeString$().endsWith__T__T__Z(oldId, "/included")) {
          var newId = (adoptedId + "/included");
          break matchEnd8
        }
      }
    };
    if (rc7) {
      var oldId$2 = $as_T(x2.value$2);
      if ((oldId$2 !== null)) {
        if (this.isEnum$1__p1__T__Z(oldId$2)) {
          var newId = (adoptedId + "/enum");
          break matchEnd8
        }
      }
    };
    var newId = adoptedId
  };
  return $as_Lamf_core_model_domain_DataNode($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, newId))
});
$c_Lamf_core_model_domain_DataNode.prototype.init___Lamf_core_parser_Annotations = (function(annotations) {
  this.fields$1 = new $c_Lamf_core_parser_Fields().init___();
  return this
});
$c_Lamf_core_model_domain_DataNode.prototype.isEnum$1__p1__T__Z = (function(id) {
  var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(id, "/", 0);
  var until = (((-1) + xs.u.length) | 0);
  var x = ((until > 0) ? until : 0);
  var y = xs.u.length;
  var hi = ((x < y) ? x : y);
  var size = ((hi > 0) ? hi : 0);
  var result = $m_jl_reflect_Array$().newInstance__jl_Class__I__O($objectGetClass(xs).getComponentType__jl_Class(), size);
  if ((size > 0)) {
    $m_s_Array$().copy__O__I__O__I__I__V(xs, 0, result, 0, size)
  };
  var xs$1 = $asArrayOf_O(result, 1);
  var this$15 = new $c_scm_ArrayOps$ofRef().init___AO(xs$1);
  var x$1 = $f_sc_IndexedSeqOptimized__last__O(this$15);
  return ((x$1 !== null) && $objectEquals(x$1, "enum"))
});
$c_Lamf_core_model_domain_DataNode.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_core_model_domain_DataNode.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfObject = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_core_model_domain_DataNode.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
function $as_Lamf_core_model_domain_DataNode(obj) {
  return (((obj instanceof $c_Lamf_core_model_domain_DataNode) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.DataNode"))
}
function $isArrayOf_Lamf_core_model_domain_DataNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_DataNode)))
}
function $asArrayOf_Lamf_core_model_domain_DataNode(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_DataNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.DataNode;", depth))
}
/** @constructor */
function $c_Lamf_core_remote_PathResolutionError() {
  $c_jl_Exception.call(this)
}
$c_Lamf_core_remote_PathResolutionError.prototype = new $h_jl_Exception();
$c_Lamf_core_remote_PathResolutionError.prototype.constructor = $c_Lamf_core_remote_PathResolutionError;
/** @constructor */
function $h_Lamf_core_remote_PathResolutionError() {
  /*<skip>*/
}
$h_Lamf_core_remote_PathResolutionError.prototype = $c_Lamf_core_remote_PathResolutionError.prototype;
$c_Lamf_core_remote_PathResolutionError.prototype.init___T = (function(message) {
  var s = ("Error resolving path: " + message);
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
var $d_Lamf_core_remote_PathResolutionError = new $TypeData().initClass({
  Lamf_core_remote_PathResolutionError: 0
}, false, "amf.core.remote.PathResolutionError", {
  Lamf_core_remote_PathResolutionError: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_remote_PathResolutionError.prototype.$classData = $d_Lamf_core_remote_PathResolutionError;
/** @constructor */
function $c_Lamf_core_remote_UnsupportedUrlScheme() {
  $c_jl_Exception.call(this)
}
$c_Lamf_core_remote_UnsupportedUrlScheme.prototype = new $h_jl_Exception();
$c_Lamf_core_remote_UnsupportedUrlScheme.prototype.constructor = $c_Lamf_core_remote_UnsupportedUrlScheme;
/** @constructor */
function $h_Lamf_core_remote_UnsupportedUrlScheme() {
  /*<skip>*/
}
$h_Lamf_core_remote_UnsupportedUrlScheme.prototype = $c_Lamf_core_remote_UnsupportedUrlScheme.prototype;
$c_Lamf_core_remote_UnsupportedUrlScheme.prototype.init___T = (function(url) {
  var s = ("Unsupported Url scheme: " + url);
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
var $d_Lamf_core_remote_UnsupportedUrlScheme = new $TypeData().initClass({
  Lamf_core_remote_UnsupportedUrlScheme: 0
}, false, "amf.core.remote.UnsupportedUrlScheme", {
  Lamf_core_remote_UnsupportedUrlScheme: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_remote_UnsupportedUrlScheme.prototype.$classData = $d_Lamf_core_remote_UnsupportedUrlScheme;
/** @constructor */
function $c_Lamf_core_remote_browser_JsBrowserPlatform() {
  $c_O.call(this);
  this.fs$1 = null;
  this.defaultExecutionEnvironment$1 = null;
  this.testingCommandLine$1 = false;
  this.wrappersRegistry$1 = null;
  this.wrappersRegistryFn$1 = null;
  this.validations$1 = null;
  this.levels$1 = null;
  this.rdfFramework$1 = null
}
$c_Lamf_core_remote_browser_JsBrowserPlatform.prototype = new $h_O();
$c_Lamf_core_remote_browser_JsBrowserPlatform.prototype.constructor = $c_Lamf_core_remote_browser_JsBrowserPlatform;
/** @constructor */
function $h_Lamf_core_remote_browser_JsBrowserPlatform() {
  /*<skip>*/
}
$h_Lamf_core_remote_browser_JsBrowserPlatform.prototype = $c_Lamf_core_remote_browser_JsBrowserPlatform.prototype;
$c_Lamf_core_remote_browser_JsBrowserPlatform.prototype.init___ = (function() {
  $f_Lamf_core_remote_Platform__$$init$__V(this);
  this.defaultExecutionEnvironment$1 = new $c_Lamf_client_execution_ExecutionEnvironment().init___();
  this.fs$1 = $m_Lamf_core_remote_UnsupportedFileSystem$();
  return this
});
$c_Lamf_core_remote_browser_JsBrowserPlatform.prototype.fs__Lorg_mulesoft_common_io_FileSystem = (function() {
  return this.fs$1
});
$c_Lamf_core_remote_browser_JsBrowserPlatform.prototype.levels__scm_Map = (function() {
  return this.levels$1
});
$c_Lamf_core_remote_browser_JsBrowserPlatform.prototype.loaders__Lamf_client_execution_BaseExecutionEnvironment__sc_Seq = (function(exec) {
  var executionContext = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  return this.loaders__s_concurrent_ExecutionContext__sc_Seq(executionContext)
});
$c_Lamf_core_remote_browser_JsBrowserPlatform.prototype.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment = (function() {
  return this.defaultExecutionEnvironment$1
});
$c_Lamf_core_remote_browser_JsBrowserPlatform.prototype.operativeSystem__T = (function() {
  return "web"
});
$c_Lamf_core_remote_browser_JsBrowserPlatform.prototype.testingCommandLine$und$eq__Z__V = (function(x$1) {
  this.testingCommandLine$1 = x$1
});
$c_Lamf_core_remote_browser_JsBrowserPlatform.prototype.loaders__s_concurrent_ExecutionContext__sc_Seq = (function(executionContext) {
  var jsx$1 = $m_sc_Seq$();
  var array = [new $c_Lamf_internal_resource_ResourceLoaderAdapter().init___Lamf_client_resource_ResourceLoader__s_concurrent_ExecutionContext(new $c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader().init___(), executionContext)];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_core_remote_browser_JsBrowserPlatform.prototype.amf$core$remote$Platform$$undsetter$und$levels$und$eq__scm_Map__V = (function(x$1) {
  this.levels$1 = x$1
});
$c_Lamf_core_remote_browser_JsBrowserPlatform.prototype.amf$core$remote$Platform$$undsetter$und$validations$und$eq__scm_Set__V = (function(x$1) {
  this.validations$1 = x$1
});
$c_Lamf_core_remote_browser_JsBrowserPlatform.prototype.rdfFramework__s_Option = (function() {
  return this.rdfFramework$1
});
$c_Lamf_core_remote_browser_JsBrowserPlatform.prototype.wrappersRegistry__scm_HashMap = (function() {
  return this.wrappersRegistry$1
});
$c_Lamf_core_remote_browser_JsBrowserPlatform.prototype.amf$core$remote$Platform$$undsetter$und$wrappersRegistry$und$eq__scm_HashMap__V = (function(x$1) {
  this.wrappersRegistry$1 = x$1
});
$c_Lamf_core_remote_browser_JsBrowserPlatform.prototype.rdfFramework$und$eq__s_Option__V = (function(x$1) {
  this.rdfFramework$1 = x$1
});
$c_Lamf_core_remote_browser_JsBrowserPlatform.prototype.validations__scm_Set = (function() {
  return this.validations$1
});
$c_Lamf_core_remote_browser_JsBrowserPlatform.prototype.wrappersRegistryFn__scm_HashMap = (function() {
  return this.wrappersRegistryFn$1
});
$c_Lamf_core_remote_browser_JsBrowserPlatform.prototype.resolvePath__T__T = (function(path) {
  return path
});
$c_Lamf_core_remote_browser_JsBrowserPlatform.prototype.amf$core$remote$Platform$$undsetter$und$wrappersRegistryFn$und$eq__scm_HashMap__V = (function(x$1) {
  this.wrappersRegistryFn$1 = x$1
});
var $d_Lamf_core_remote_browser_JsBrowserPlatform = new $TypeData().initClass({
  Lamf_core_remote_browser_JsBrowserPlatform: 0
}, false, "amf.core.remote.browser.JsBrowserPlatform", {
  Lamf_core_remote_browser_JsBrowserPlatform: 1,
  O: 1,
  Lamf_core_remote_JsPlatform: 1,
  Lamf_core_remote_Platform: 1,
  Lamf_core_remote_FileMediaType: 1
});
$c_Lamf_core_remote_browser_JsBrowserPlatform.prototype.$classData = $d_Lamf_core_remote_browser_JsBrowserPlatform;
/** @constructor */
function $c_Lamf_core_remote_server_JsServerPlatform() {
  $c_O.call(this);
  this.fs$1 = null;
  this.defaultExecutionEnvironment$1 = null;
  this.testingCommandLine$1 = false;
  this.wrappersRegistry$1 = null;
  this.wrappersRegistryFn$1 = null;
  this.validations$1 = null;
  this.levels$1 = null;
  this.rdfFramework$1 = null
}
$c_Lamf_core_remote_server_JsServerPlatform.prototype = new $h_O();
$c_Lamf_core_remote_server_JsServerPlatform.prototype.constructor = $c_Lamf_core_remote_server_JsServerPlatform;
/** @constructor */
function $h_Lamf_core_remote_server_JsServerPlatform() {
  /*<skip>*/
}
$h_Lamf_core_remote_server_JsServerPlatform.prototype = $c_Lamf_core_remote_server_JsServerPlatform.prototype;
$c_Lamf_core_remote_server_JsServerPlatform.prototype.init___ = (function() {
  $f_Lamf_core_remote_Platform__$$init$__V(this);
  this.defaultExecutionEnvironment$1 = new $c_Lamf_client_execution_ExecutionEnvironment().init___();
  this.fs$1 = $m_Lorg_mulesoft_common_io_Fs$();
  return this
});
$c_Lamf_core_remote_server_JsServerPlatform.prototype.fs__Lorg_mulesoft_common_io_FileSystem = (function() {
  return this.fs$1
});
$c_Lamf_core_remote_server_JsServerPlatform.prototype.levels__scm_Map = (function() {
  return this.levels$1
});
$c_Lamf_core_remote_server_JsServerPlatform.prototype.loaders__Lamf_client_execution_BaseExecutionEnvironment__sc_Seq = (function(exec) {
  var executionContext = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  return this.loaders__s_concurrent_ExecutionContext__sc_Seq(executionContext)
});
$c_Lamf_core_remote_server_JsServerPlatform.prototype.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment = (function() {
  return this.defaultExecutionEnvironment$1
});
$c_Lamf_core_remote_server_JsServerPlatform.prototype.withTrailingSlash__p1__T__T = (function(path) {
  return (((!(($uI(path.length) >= 0) && ($as_T(path.substring(0, $uI("/".length))) === "/"))) ? "/" : "") + path)
});
$c_Lamf_core_remote_server_JsServerPlatform.prototype.operativeSystem__T = (function() {
  var x1 = $as_T($i_os.platform());
  return (($uI(x1.indexOf("darwin")) !== (-1)) ? "mac" : (($uI(x1.indexOf("win")) !== (-1)) ? "win" : "nux"))
});
$c_Lamf_core_remote_server_JsServerPlatform.prototype.testingCommandLine$und$eq__Z__V = (function(x$1) {
  this.testingCommandLine$1 = x$1
});
$c_Lamf_core_remote_server_JsServerPlatform.prototype.loaders__s_concurrent_ExecutionContext__sc_Seq = (function(executionContext) {
  var jsx$1 = $m_sc_Seq$();
  var array = [new $c_Lamf_internal_resource_ResourceLoaderAdapter().init___Lamf_client_resource_ResourceLoader__s_concurrent_ExecutionContext(new $c_Lamf_core_remote_server_JsServerFileResourceLoader().init___(), executionContext), new $c_Lamf_internal_resource_ResourceLoaderAdapter().init___Lamf_client_resource_ResourceLoader__s_concurrent_ExecutionContext(new $c_Lamf_core_remote_server_JsServerHttpResourceLoader().init___(), executionContext)];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_core_remote_server_JsServerPlatform.prototype.amf$core$remote$Platform$$undsetter$und$levels$und$eq__scm_Map__V = (function(x$1) {
  this.levels$1 = x$1
});
$c_Lamf_core_remote_server_JsServerPlatform.prototype.amf$core$remote$Platform$$undsetter$und$validations$und$eq__scm_Set__V = (function(x$1) {
  this.validations$1 = x$1
});
$c_Lamf_core_remote_server_JsServerPlatform.prototype.rdfFramework__s_Option = (function() {
  return this.rdfFramework$1
});
$c_Lamf_core_remote_server_JsServerPlatform.prototype.wrappersRegistry__scm_HashMap = (function() {
  return this.wrappersRegistry$1
});
$c_Lamf_core_remote_server_JsServerPlatform.prototype.amf$core$remote$Platform$$undsetter$und$wrappersRegistry$und$eq__scm_HashMap__V = (function(x$1) {
  this.wrappersRegistry$1 = x$1
});
$c_Lamf_core_remote_server_JsServerPlatform.prototype.rdfFramework$und$eq__s_Option__V = (function(x$1) {
  this.rdfFramework$1 = x$1
});
$c_Lamf_core_remote_server_JsServerPlatform.prototype.validations__scm_Set = (function() {
  return this.validations$1
});
$c_Lamf_core_remote_server_JsServerPlatform.prototype.wrappersRegistryFn__scm_HashMap = (function() {
  return this.wrappersRegistryFn$1
});
$c_Lamf_core_remote_server_JsServerPlatform.prototype.resolvePath__T__T = (function(uri) {
  var o9 = $m_Lamf_core_remote_File$().unapply__T__s_Option(uri);
  if ((!o9.isEmpty__Z())) {
    var path = $as_T(o9.get__O());
    if ((this.fs$1.separatorChar__C() === 47)) {
      return (("" + $m_Lamf_core_remote_File$().FILE$undPROTOCOL$1) + $f_Lamf_core_remote_JsPlatform__normalizeURL__T__T(this, path))
    }
  };
  var o11 = $m_Lamf_core_remote_File$().unapply__T__s_Option(uri);
  if ((!o11.isEmpty__Z())) {
    var path$2 = $as_T(o11.get__O());
    var jsx$1 = $m_Lamf_core_remote_File$().FILE$undPROTOCOL$1;
    var thiz = $f_Lamf_core_remote_JsPlatform__normalizeURL__T__T(this, path$2);
    var c = this.fs$1.separatorChar__C();
    var target = $as_T($g.String.fromCharCode(c));
    return (("" + jsx$1) + $as_T(thiz.split(target).join("/")))
  };
  var o13 = $m_Lamf_core_remote_HttpParts$().unapply__T__s_Option(uri);
  if ((!o13.isEmpty__Z())) {
    var protocol = $as_T($as_T3(o13.get__O()).$$und1$1);
    var host = $as_T($as_T3(o13.get__O()).$$und2$1);
    var path$3 = $as_T($as_T3(o13.get__O()).$$und3$1);
    var url = this.withTrailingSlash__p1__T__T(path$3);
    return ((("" + protocol) + host) + $f_Lamf_core_remote_JsPlatform__normalizePath__T__T(this, url))
  };
  return uri
});
$c_Lamf_core_remote_server_JsServerPlatform.prototype.amf$core$remote$Platform$$undsetter$und$wrappersRegistryFn$und$eq__scm_HashMap__V = (function(x$1) {
  this.wrappersRegistryFn$1 = x$1
});
var $d_Lamf_core_remote_server_JsServerPlatform = new $TypeData().initClass({
  Lamf_core_remote_server_JsServerPlatform: 0
}, false, "amf.core.remote.server.JsServerPlatform", {
  Lamf_core_remote_server_JsServerPlatform: 1,
  O: 1,
  Lamf_core_remote_JsPlatform: 1,
  Lamf_core_remote_Platform: 1,
  Lamf_core_remote_FileMediaType: 1
});
$c_Lamf_core_remote_server_JsServerPlatform.prototype.$classData = $d_Lamf_core_remote_server_JsServerPlatform;
/** @constructor */
function $c_Lamf_internal_environment_Environment$() {
  $c_O.call(this);
  this.platform$1 = null
}
$c_Lamf_internal_environment_Environment$.prototype = new $h_O();
$c_Lamf_internal_environment_Environment$.prototype.constructor = $c_Lamf_internal_environment_Environment$;
/** @constructor */
function $h_Lamf_internal_environment_Environment$() {
  /*<skip>*/
}
$h_Lamf_internal_environment_Environment$.prototype = $c_Lamf_internal_environment_Environment$.prototype;
$c_Lamf_internal_environment_Environment$.prototype.init___ = (function() {
  $n_Lamf_internal_environment_Environment$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_internal_environment_Environment$.prototype.apply__Lamf_client_execution_BaseExecutionEnvironment__Lamf_internal_environment_Environment = (function(exec) {
  exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment();
  return new $c_Lamf_internal_environment_Environment().init___sc_Seq__s_Option__s_Option(this.platform$1.loaders__Lamf_client_execution_BaseExecutionEnvironment__sc_Seq(exec), $m_s_None$(), $m_s_None$())
});
$c_Lamf_internal_environment_Environment$.prototype.apply__Lamf_internal_environment_Environment = (function() {
  var this$1 = this.platform$1;
  var this$2 = this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  var executionContext = this$2.$$undinternal$1.context$1;
  return new $c_Lamf_internal_environment_Environment().init___sc_Seq__s_Option__s_Option(this.platform$1.loaders__s_concurrent_ExecutionContext__sc_Seq(executionContext), $m_s_None$(), $m_s_None$())
});
$c_Lamf_internal_environment_Environment$.prototype.apply__s_concurrent_ExecutionContext__Lamf_internal_environment_Environment = (function(exec) {
  var this$1 = this.platform$1;
  var this$2 = this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  var executionContext = this$2.$$undinternal$1.context$1;
  return new $c_Lamf_internal_environment_Environment().init___sc_Seq__s_Option__s_Option(this.platform$1.loaders__s_concurrent_ExecutionContext__sc_Seq(executionContext), $m_s_None$(), $m_s_None$())
});
var $d_Lamf_internal_environment_Environment$ = new $TypeData().initClass({
  Lamf_internal_environment_Environment$: 0
}, false, "amf.internal.environment.Environment$", {
  Lamf_internal_environment_Environment$: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_internal_environment_Environment$.prototype.$classData = $d_Lamf_internal_environment_Environment$;
var $n_Lamf_internal_environment_Environment$ = (void 0);
function $m_Lamf_internal_environment_Environment$() {
  if ((!$n_Lamf_internal_environment_Environment$)) {
    $n_Lamf_internal_environment_Environment$ = new $c_Lamf_internal_environment_Environment$().init___()
  };
  return $n_Lamf_internal_environment_Environment$
}
/** @constructor */
function $c_Lamf_plugins_document_graph_AMFGraphPlugin$() {
  $c_Lamf_client_plugins_AMFDocumentPlugin.call(this);
  this.ID$2 = null;
  this.vendors$2 = null;
  this.allowRecursiveReferences$2 = false;
  this.platform$2 = null
}
$c_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype = new $h_Lamf_client_plugins_AMFDocumentPlugin();
$c_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype.constructor = $c_Lamf_plugins_document_graph_AMFGraphPlugin$;
/** @constructor */
function $h_Lamf_plugins_document_graph_AMFGraphPlugin$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype = $c_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype;
$c_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype.init___ = (function() {
  $c_Lamf_client_plugins_AMFDocumentPlugin.prototype.init___.call(this);
  $n_Lamf_plugins_document_graph_AMFGraphPlugin$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$2 = this$1.platform$1;
  this.ID$2 = $m_Lamf_core_remote_Amf$().name$1;
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_core_remote_Amf$().name$1];
  this.vendors$2 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  this.allowRecursiveReferences$2 = true;
  return this
});
$c_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype.init__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
    return (function() {
      return $m_Lamf_plugins_document_graph_AMFGraphPlugin$()
    })
  })(this)), executionContext)
});
$c_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype.unparseAsYDocument__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__s_Option = (function(unit, renderOptions, shapeRenderOptions) {
  throw new $c_jl_IllegalStateException().init___T("Unreachable")
});
$c_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype.effectiveUnitUrl__T__Lamf_core_client_ParsingOptions__T = (function(location, options) {
  var x1 = options.baseUnitUrl$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var url = $as_T(x2.value$2);
    return url
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return location
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype.canUnparse__Lamf_core_model_document_BaseUnit__Z = (function(unit) {
  return true
});
$c_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype.modelEntities__sc_Seq = (function() {
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_core_metamodel_domain_ObjectNodeModel$(), $m_Lamf_core_metamodel_domain_ScalarNodeModel$(), $m_Lamf_core_metamodel_domain_ArrayNodeModel$(), $m_Lamf_core_metamodel_domain_LinkNodeModel$(), $m_Lamf_core_metamodel_domain_RecursiveShapeModel$()];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype.parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option = (function(root, ctx, platform, options) {
  var rc6 = false;
  var x2 = null;
  var x1 = root.parsed$1;
  if ((x1 instanceof $c_Lamf_core_parser_SyamlParsedDocument)) {
    rc6 = true;
    x2 = $as_Lamf_core_parser_SyamlParsedDocument(x1);
    if ($m_Lamf_plugins_document_graph_parser_FlattenedGraphParser$().canParse__Lamf_core_parser_SyamlParsedDocument__Z(x2)) {
      return new $c_s_Some().init___O($m_Lamf_plugins_document_graph_parser_FlattenedGraphParser$().apply__Lamf_plugins_document_graph_parser_FlattenedGraphParser().parse__Lorg_yaml_model_YDocument__T__Lamf_core_model_document_BaseUnit(x2.document$2, this.effectiveUnitUrl__T__Lamf_core_client_ParsingOptions__T(root.location$1, options)))
    }
  };
  if ((rc6 && $m_Lamf_plugins_document_graph_parser_ExpandedGraphParser$().canParse__Lamf_core_parser_SyamlParsedDocument__Z(x2))) {
    return new $c_s_Some().init___O($m_Lamf_plugins_document_graph_parser_ExpandedGraphParser$().apply__Lamf_plugins_document_graph_parser_ExpandedGraphParser().parse__Lorg_yaml_model_YDocument__T__Lamf_core_model_document_BaseUnit(x2.document$2, this.effectiveUnitUrl__T__Lamf_core_client_ParsingOptions__T(root.location$1, options)))
  };
  if ((x1 instanceof $c_Lamf_core_rdf_RdfModelDocument)) {
    var x4 = $as_Lamf_core_rdf_RdfModelDocument(x1);
    var jsx$2 = $m_Lamf_core_rdf_RdfModelParser$();
    var jsx$1 = ctx.eh$1;
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$5 = new $c_scm_ListBuffer().init___();
    return new $c_s_Some().init___O(jsx$2.apply__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext__Lamf_core_rdf_RdfModelParser(jsx$1, new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$5.toList__sci_List())).parse__Lamf_core_rdf_RdfModel__T__Lamf_core_model_document_BaseUnit(x4.model$2, this.effectiveUnitUrl__T__Lamf_core_client_ParsingOptions__T(root.location$1, options)))
  };
  return $m_s_None$()
});
$c_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype.documentSyntaxes__sc_Seq = (function() {
  var jsx$1 = $m_sc_Seq$();
  var array = ["application/ld+json", "application/json", "application/amf+json"];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype.emit__Lamf_core_model_document_BaseUnit__Lorg_yaml_builder_DocBuilder__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__Z = (function(unit, builder, renderOptions, shapeRenderOptions) {
  return $m_Lamf_plugins_document_graph_emitter_JsonLdEmitter$().emit__Lamf_core_model_document_BaseUnit__Lorg_yaml_builder_DocBuilder__Lamf_core_emitter_RenderOptions__Z(unit, builder, renderOptions)
});
$c_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype.referenceHandler__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_ReferenceHandler = (function(eh) {
  return $m_Lamf_plugins_document_graph_parser_GraphDependenciesReferenceHandler$()
});
$c_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype.vendors__sc_Seq = (function() {
  return this.vendors$2
});
$c_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype.ID__T = (function() {
  return this.ID$2
});
$c_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype.dependencies__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype.canParse__Lamf_core_Root__Z = (function(root) {
  var x1 = root.parsed$1;
  if ((x1 instanceof $c_Lamf_core_parser_SyamlParsedDocument)) {
    var x2 = $as_Lamf_core_parser_SyamlParsedDocument(x1);
    return ($m_Lamf_plugins_document_graph_parser_FlattenedGraphParser$().canParse__Lamf_core_parser_SyamlParsedDocument__Z(x2) || $m_Lamf_plugins_document_graph_parser_ExpandedGraphParser$().canParse__Lamf_core_parser_SyamlParsedDocument__Z(x2))
  } else {
    return (x1 instanceof $c_Lamf_core_rdf_RdfModelDocument)
  }
});
$c_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype.allowRecursiveReferences__Z = (function() {
  return this.allowRecursiveReferences$2
});
$c_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype.serializableAnnotations__sci_Map = (function() {
  return $m_sci_Map$EmptyMap$()
});
$c_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_errorhandling_ErrorHandler__T__Lamf_core_model_document_BaseUnit = (function(unit, errorHandler, pipelineId) {
  return new $c_Lamf_core_resolution_pipelines_BasicResolutionPipeline().init___Lamf_core_errorhandling_ErrorHandler(errorHandler).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit)
});
var $d_Lamf_plugins_document_graph_AMFGraphPlugin$ = new $TypeData().initClass({
  Lamf_plugins_document_graph_AMFGraphPlugin$: 0
}, false, "amf.plugins.document.graph.AMFGraphPlugin$", {
  Lamf_plugins_document_graph_AMFGraphPlugin$: 1,
  Lamf_client_plugins_AMFDocumentPlugin: 1,
  O: 1,
  Lamf_client_plugins_AMFPlugin: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_plugins_document_graph_AMFGraphPlugin$.prototype.$classData = $d_Lamf_plugins_document_graph_AMFGraphPlugin$;
var $n_Lamf_plugins_document_graph_AMFGraphPlugin$ = (void 0);
function $m_Lamf_plugins_document_graph_AMFGraphPlugin$() {
  if ((!$n_Lamf_plugins_document_graph_AMFGraphPlugin$)) {
    $n_Lamf_plugins_document_graph_AMFGraphPlugin$ = new $c_Lamf_plugins_document_graph_AMFGraphPlugin$().init___()
  };
  return $n_Lamf_plugins_document_graph_AMFGraphPlugin$
}
/** @constructor */
function $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser() {
  $c_Lamf_plugins_document_graph_parser_GraphContextHelper.call(this);
  this.Parser$module$2 = null;
  this.ctx$2 = null;
  this.xsdString$2 = null;
  this.xsdInteger$2 = null;
  this.xsdFloat$2 = null;
  this.amlNumber$2 = null;
  this.xsdDouble$2 = null;
  this.xsdBoolean$2 = null;
  this.xsdDateTime$2 = null;
  this.xsdDate$2 = null;
  this.types$2 = null;
  this.AnnotationName$module$2 = null
}
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser.prototype = new $h_Lamf_plugins_document_graph_parser_GraphContextHelper();
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser.prototype.constructor = $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser;
/** @constructor */
function $h_Lamf_plugins_document_graph_parser_ExpandedGraphParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_parser_ExpandedGraphParser.prototype = $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser.prototype;
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser.prototype.parse__Lorg_yaml_model_YDocument__T__Lamf_core_model_document_BaseUnit = (function(document, location) {
  var parser = new $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser().init___Lamf_plugins_document_graph_parser_ExpandedGraphParser__sci_Map(this, $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())));
  return parser.parse__Lorg_yaml_model_YDocument__T__Lamf_core_model_document_BaseUnit(document, location)
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser.prototype.init___Lamf_plugins_document_graph_parser_GraphParserContext = (function(ctx) {
  this.ctx$2 = ctx;
  this.xsdString$2 = $m_Lamf_core_model_DataType$().String$1;
  this.xsdInteger$2 = $m_Lamf_core_model_DataType$().Integer$1;
  this.xsdFloat$2 = $m_Lamf_core_model_DataType$().Float$1;
  this.amlNumber$2 = $m_Lamf_core_model_DataType$().Number$1;
  this.xsdDouble$2 = $m_Lamf_core_model_DataType$().Double$1;
  this.xsdBoolean$2 = $m_Lamf_core_model_DataType$().Boolean$1;
  this.xsdDateTime$2 = $m_Lamf_core_model_DataType$().DateTime$1;
  this.xsdDate$2 = $m_Lamf_core_model_DataType$().Date$1;
  var this$2 = $m_sci_Map$EmptyMap$();
  var xs = $m_Lamf_core_registries_AMFDomainRegistry$().metadataRegistry$1;
  this.types$2 = $f_sci_MapLike__$$plus$plus__sc_GenTraversableOnce__sci_Map(this$2, xs);
  return this
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser.prototype.contentOfNode__Lorg_yaml_model_YNode__s_Option = (function(n) {
  return $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__contentOfNode__Lorg_yaml_model_YNode__s_Option(this, n)
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser.prototype.amf$plugins$document$graph$parser$ExpandedGraphParser$$any__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar = (function(node) {
  var x1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$2;
    var x1$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$15$2) {
        var x$15 = $as_Lorg_yaml_model_YMapEntry(x$15$2);
        var this$1 = x$15.key$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv$1 = $this.ctx$2;
        var x$1 = $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion$1, iv$1);
        return ((x$1 !== null) && $objectEquals(x$1, "@value"))
      })
    })(this)));
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var this$2 = entry.value$2;
      var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$2 = this.ctx$2;
      var nodeValue = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$2, iv$2)).text$3
    } else {
      var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$3 = this.ctx$2;
      var nodeValue = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$3, iv$3)).text$3
    };
    var conversion$4 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$4 = this.ctx$2;
    var x1$3 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$4, iv$4)).entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(x$16$2) {
        var x$16 = $as_Lorg_yaml_model_YMapEntry(x$16$2);
        var this$3 = x$16.key$2;
        var conversion$5 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv$5 = this$2$1.ctx$2;
        var x$2 = $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion$5, iv$5);
        return ((x$2 !== null) && $objectEquals(x$2, "@type"))
      })
    })(this)));
    if ((x1$3 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$3);
      var typeEntry = $as_Lorg_yaml_model_YMapEntry(x2$2.value$2);
      var this$4 = typeEntry.value$2;
      var conversion$6 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$6 = this.ctx$2;
      var typeUri = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion$6, iv$6)).text$3;
      var expandedUri = this.expandUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T(typeUri, this.ctx$2);
      if ((expandedUri !== null)) {
        if ((expandedUri === this.xsdBoolean$2)) {
          var this$6 = new $c_sci_StringOps().init___T(nodeValue);
          var $$this = this$6.repr$1;
          return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($f_sci_StringLike__parseBoolean__psci_StringLike__T__Z(this$6, $$this), new $c_Lamf_core_parser_Annotations().init___())
        }
      };
      if ((expandedUri !== null)) {
        if ((expandedUri === this.xsdInteger$2)) {
          var this$10 = new $c_sci_StringOps().init___T(nodeValue);
          var this$12 = $m_jl_Integer$();
          var $$this$1 = this$10.repr$1;
          return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(this$12.parseInt__T__I__I($$this$1, 10), new $c_Lamf_core_parser_Annotations().init___())
        }
      };
      if ((expandedUri !== null)) {
        if ((expandedUri === this.xsdFloat$2)) {
          var this$15 = new $c_sci_StringOps().init___T(nodeValue);
          var $$this$2 = this$15.repr$1;
          return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($fround($m_jl_Double$().parseDouble__T__D($$this$2)), new $c_Lamf_core_parser_Annotations().init___())
        }
      };
      if ((expandedUri !== null)) {
        if ((expandedUri === this.xsdDouble$2)) {
          var this$20 = new $c_sci_StringOps().init___T(nodeValue);
          var jsx$1 = $m_jl_Double$();
          var $$this$3 = this$20.repr$1;
          return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(jsx$1.parseDouble__T__D($$this$3), new $c_Lamf_core_parser_Annotations().init___())
        }
      };
      if ((expandedUri !== null)) {
        if ((expandedUri === this.xsdDateTime$2)) {
          var this$23 = $m_Lorg_mulesoft_common_time_SimpleDateTime$().parse__T__s_util_Either(nodeValue);
          return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(new $c_s_util_Either$RightProjection().init___s_util_Either(this$23).get__O(), new $c_Lamf_core_parser_Annotations().init___())
        }
      };
      if ((expandedUri !== null)) {
        if ((expandedUri === this.xsdDate$2)) {
          var this$25 = $m_Lorg_mulesoft_common_time_SimpleDateTime$().parse__T__s_util_Either(nodeValue);
          return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(new $c_s_util_Either$RightProjection().init___s_util_Either(this$25).get__O(), new $c_Lamf_core_parser_Annotations().init___())
        }
      };
      return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(nodeValue, new $c_Lamf_core_parser_Annotations().init___())
    } else {
      return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(nodeValue, new $c_Lamf_core_parser_Annotations().init___())
    }
  } else {
    var conversion$7 = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv$7 = this.ctx$2;
    return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$7, iv$7)).text$3, new $c_Lamf_core_parser_Annotations().init___())
  }
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser.prototype.amf$plugins$document$graph$parser$ExpandedGraphParser$$findType__T__s_Option = (function(typeString) {
  var this$1 = this.types$2.get__O__s_Option(this.expandUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T(typeString, this.ctx$2));
  return (this$1.isEmpty__Z() ? $m_Lamf_core_registries_AMFDomainRegistry$().findType__T__s_Option(typeString) : this$1)
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser.prototype.amf$plugins$document$graph$parser$ExpandedGraphParser$$parseScalarProperty__Lorg_yaml_model_YMap__Lamf_core_metamodel_Field__s_Option = (function(definition, field) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(definition).key__T__s_Option(this.compactUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T(field.value$1.iri__T(), this.ctx$2));
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var t = field.type$1;
    var node = entry.value$2;
    var this$3 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__value__Lamf_core_metamodel_Type__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode(this, t, node);
    var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv = this.ctx$2;
    return new $c_s_Some().init___O($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv)).text$3)
  }
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser.prototype.AnnotationName__Lamf_plugins_document_graph_parser_GraphParserHelpers$AnnotationName$ = (function() {
  if ((this.AnnotationName$module$2 === null)) {
    this.AnnotationName$lzycompute$1__p2__V()
  };
  return this.AnnotationName$module$2
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser.prototype.AnnotationName$lzycompute$1__p2__V = (function() {
  if ((this.AnnotationName$module$2 === null)) {
    this.AnnotationName$module$2 = new $c_Lamf_plugins_document_graph_parser_GraphParserHelpers$AnnotationName$().init___Lamf_plugins_document_graph_parser_GraphParserHelpers(this)
  }
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser.prototype.amf$plugins$document$graph$parser$ExpandedGraphParser$$bool__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar = (function(node) {
  var x1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$2;
    var x1$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$11$2) {
        var x$11 = $as_Lorg_yaml_model_YMapEntry(x$11$2);
        var this$1 = x$11.key$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv$1 = $this.ctx$2;
        var x$1 = $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion$1, iv$1);
        return ((x$1 !== null) && $objectEquals(x$1, "@value"))
      })
    })(this)));
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var this$2 = entry.value$2;
      var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$2 = this.ctx$2;
      var x$2 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$2, iv$2)).text$3;
      var this$4 = new $c_sci_StringOps().init___T(x$2);
      var $$this = this$4.repr$1;
      var value = $f_sci_StringLike__parseBoolean__psci_StringLike__T__Z(this$4, $$this)
    } else {
      var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$3 = this.ctx$2;
      var x$3 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$3, iv$3)).text$3;
      var this$7 = new $c_sci_StringOps().init___T(x$3);
      var $$this$1 = this$7.repr$1;
      var value = $f_sci_StringLike__parseBoolean__psci_StringLike__T__Z(this$7, $$this$1)
    }
  } else {
    var conversion$4 = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv$4 = this.ctx$2;
    var x$4 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$4, iv$4)).text$3;
    var this$10 = new $c_sci_StringOps().init___T(x$4);
    var $$this$2 = this$10.repr$1;
    var value = $f_sci_StringLike__parseBoolean__psci_StringLike__T__Z(this$10, $$this$2)
  };
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, new $c_Lamf_core_parser_Annotations().init___())
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser.prototype.amf$plugins$document$graph$parser$ExpandedGraphParser$$date__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar = (function(node) {
  var x1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$2;
    var x1$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$14$2) {
        var x$14 = $as_Lorg_yaml_model_YMapEntry(x$14$2);
        var this$1 = x$14.key$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv$1 = $this.ctx$2;
        var x$1 = $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion$1, iv$1);
        return ((x$1 !== null) && $objectEquals(x$1, "@value"))
      })
    })(this)));
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var jsx$1 = $m_Lorg_mulesoft_common_time_SimpleDateTime$();
      var this$2 = entry.value$2;
      var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$2 = this.ctx$2;
      var this$3 = jsx$1.parse__T__s_util_Either($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$2, iv$2)).text$3);
      var value = $as_Lorg_mulesoft_common_time_SimpleDateTime(new $c_s_util_Either$RightProjection().init___s_util_Either(this$3).get__O())
    } else {
      var jsx$2 = $m_Lorg_mulesoft_common_time_SimpleDateTime$();
      var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$3 = this.ctx$2;
      var this$4 = jsx$2.parse__T__s_util_Either($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$3, iv$3)).text$3);
      var value = $as_Lorg_mulesoft_common_time_SimpleDateTime(new $c_s_util_Either$RightProjection().init___s_util_Either(this$4).get__O())
    }
  } else {
    var jsx$3 = $m_Lorg_mulesoft_common_time_SimpleDateTime$();
    var conversion$4 = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv$4 = this.ctx$2;
    var this$5 = jsx$3.parse__T__s_util_Either($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$4, iv$4)).text$3);
    var value = $as_Lorg_mulesoft_common_time_SimpleDateTime(new $c_s_util_Either$RightProjection().init___s_util_Either(this$5).get__O())
  };
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, new $c_Lamf_core_parser_Annotations().init___())
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser.prototype.amf$plugins$document$graph$parser$ExpandedGraphParser$$float__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar = (function(node) {
  var x1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$2;
    var x1$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$17$2) {
        var x$17 = $as_Lorg_yaml_model_YMapEntry(x$17$2);
        var this$1 = x$17.key$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv$1 = $this.ctx$2;
        var x$1 = $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion$1, iv$1);
        return ((x$1 !== null) && $objectEquals(x$1, "@value"))
      })
    })(this)));
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var this$2 = entry.value$2;
      var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$2 = this.ctx$2;
      var x$2 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$2, iv$2)).text$3;
      var this$4 = new $c_sci_StringOps().init___T(x$2);
      var jsx$1 = $m_jl_Double$();
      var $$this = this$4.repr$1;
      var value = jsx$1.parseDouble__T__D($$this)
    } else {
      var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$3 = this.ctx$2;
      var x$3 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$3, iv$3)).text$3;
      var this$7 = new $c_sci_StringOps().init___T(x$3);
      var jsx$2 = $m_jl_Double$();
      var $$this$1 = this$7.repr$1;
      var value = jsx$2.parseDouble__T__D($$this$1)
    }
  } else {
    var conversion$4 = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv$4 = this.ctx$2;
    var x$4 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$4, iv$4)).text$3;
    var this$10 = new $c_sci_StringOps().init___T(x$4);
    var jsx$3 = $m_jl_Double$();
    var $$this$2 = this$10.repr$1;
    var value = jsx$3.parseDouble__T__D($$this$2)
  };
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, new $c_Lamf_core_parser_Annotations().init___())
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser.prototype.amf$plugins$document$graph$parser$ExpandedGraphParser$$int__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar = (function(node) {
  var x1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$2;
    var x1$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$12$2) {
        var x$12 = $as_Lorg_yaml_model_YMapEntry(x$12$2);
        var this$1 = x$12.key$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv$1 = $this.ctx$2;
        var x$1 = $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion$1, iv$1);
        return ((x$1 !== null) && $objectEquals(x$1, "@value"))
      })
    })(this)));
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var this$2 = entry.value$2;
      var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$2 = this.ctx$2;
      var x$2 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$2, iv$2)).text$3;
      var this$4 = new $c_sci_StringOps().init___T(x$2);
      var this$6 = $m_jl_Integer$();
      var $$this = this$4.repr$1;
      var value = this$6.parseInt__T__I__I($$this, 10)
    } else {
      var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$3 = this.ctx$2;
      var x$3 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$3, iv$3)).text$3;
      var this$8 = new $c_sci_StringOps().init___T(x$3);
      var this$10 = $m_jl_Integer$();
      var $$this$1 = this$8.repr$1;
      var value = this$10.parseInt__T__I__I($$this$1, 10)
    }
  } else {
    var conversion$4 = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv$4 = this.ctx$2;
    var x$4 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$4, iv$4)).text$3;
    var this$12 = new $c_sci_StringOps().init___T(x$4);
    var this$14 = $m_jl_Integer$();
    var $$this$2 = this$12.repr$1;
    var value = this$14.parseInt__T__I__I($$this$2, 10)
  };
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, new $c_Lamf_core_parser_Annotations().init___())
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser.prototype.amf$plugins$document$graph$parser$ExpandedGraphParser$$double__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar = (function(node) {
  var x1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$2;
    var x1$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$13$2) {
        var x$13 = $as_Lorg_yaml_model_YMapEntry(x$13$2);
        var this$1 = x$13.key$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv$1 = $this.ctx$2;
        var x$1 = $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion$1, iv$1);
        return ((x$1 !== null) && $objectEquals(x$1, "@value"))
      })
    })(this)));
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var this$2 = entry.value$2;
      var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$2 = this.ctx$2;
      var x$2 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$2, iv$2)).text$3;
      var this$4 = new $c_sci_StringOps().init___T(x$2);
      var jsx$1 = $m_jl_Double$();
      var $$this = this$4.repr$1;
      var value = jsx$1.parseDouble__T__D($$this)
    } else {
      var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$3 = this.ctx$2;
      var x$3 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$3, iv$3)).text$3;
      var this$7 = new $c_sci_StringOps().init___T(x$3);
      var jsx$2 = $m_jl_Double$();
      var $$this$1 = this$7.repr$1;
      var value = jsx$2.parseDouble__T__D($$this$1)
    }
  } else {
    var conversion$4 = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv$4 = this.ctx$2;
    var x$4 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$4, iv$4)).text$3;
    var this$10 = new $c_sci_StringOps().init___T(x$4);
    var jsx$3 = $m_jl_Double$();
    var $$this$2 = this$10.repr$1;
    var value = jsx$3.parseDouble__T__D($$this$2)
  };
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, new $c_Lamf_core_parser_Annotations().init___())
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser.prototype.amf$plugins$document$graph$parser$ExpandedGraphParser$$buildType__T__Lorg_yaml_model_YMap__Lamf_core_metamodel_Obj__F1 = (function(id, map, modelType) {
  var x1 = $m_Lamf_core_registries_AMFDomainRegistry$().metadataRegistry$1.get__O__s_Option($as_Lamf_core_vocabulary_ValueType(modelType.type__sci_List().head__O()).iri__T());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var modelType$2 = $as_Lamf_core_metamodel_Obj(x2.value$2);
    if ($is_Lamf_core_metamodel_ModelDefaultBuilder(modelType$2)) {
      return new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x3) {
        return (function(annotations$2) {
          var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
          var instance = $as_Lamf_core_metamodel_ModelDefaultBuilder(x3).modelInstance__Lamf_core_model_domain_AmfObject();
          instance.annotations__Lamf_core_parser_Annotations().$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(annotations);
          return new $c_s_Some().init___O(instance)
        })
      })(this, modelType$2))
    }
  };
  var x1$2 = $m_Lamf_core_registries_AMFDomainRegistry$().buildType__Lamf_core_metamodel_Obj__s_Option(modelType);
  if ((x1$2 instanceof $c_s_Some)) {
    var x2$2 = $as_s_Some(x1$2);
    var builder = $as_F1(x2$2.value$2);
    return new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, builder$1) {
      return (function(a$2) {
        var a = $as_Lamf_core_parser_Annotations(a$2);
        return new $c_s_Some().init___O(builder$1.apply__O__O(a))
      })
    })(this, builder))
  } else {
    var this$1 = this.ctx$2.eh$1;
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().NodeNotFound$1;
    var message = ("Cannot find builder for node type " + modelType);
    var prop = $m_s_None$();
    var l = map.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, id, prop, message, l);
    return new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3) {
      return (function(x$18$2) {
        $as_Lamf_core_parser_Annotations(x$18$2);
        return $m_s_None$()
      })
    })(this))
  }
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser.prototype.amf$plugins$document$graph$parser$ExpandedGraphParser$$str__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar = (function(node) {
  var x1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$2;
    var x1$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$10$2) {
        var x$10 = $as_Lorg_yaml_model_YMapEntry(x$10$2);
        var this$1 = x$10.key$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv$1 = $this.ctx$2;
        var x$1 = $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion$1, iv$1);
        return ((x$1 !== null) && $objectEquals(x$1, "@value"))
      })
    })(this)));
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var this$2 = entry.value$2;
      var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$2 = this.ctx$2;
      var value = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$2, iv$2)).text$3
    } else {
      var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$3 = this.ctx$2;
      var value = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$3, iv$3)).text$3
    }
  } else {
    var conversion$4 = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv$4 = this.ctx$2;
    var value = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$4, iv$4)).text$3
  };
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, new $c_Lamf_core_parser_Annotations().init___())
});
var $d_Lamf_plugins_document_graph_parser_ExpandedGraphParser = new $TypeData().initClass({
  Lamf_plugins_document_graph_parser_ExpandedGraphParser: 0
}, false, "amf.plugins.document.graph.parser.ExpandedGraphParser", {
  Lamf_plugins_document_graph_parser_ExpandedGraphParser: 1,
  Lamf_plugins_document_graph_parser_GraphContextHelper: 1,
  O: 1,
  Lamf_plugins_document_graph_parser_GraphParserHelpers: 1,
  Lamf_plugins_document_graph_parser_GraphParser: 1
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser.prototype.$classData = $d_Lamf_plugins_document_graph_parser_ExpandedGraphParser;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_annotations_AliasesLocation$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_annotations_AliasesLocation$.prototype = $c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation$.prototype;
$c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation$.prototype.unparse__T__sci_Map__s_Option = (function(annotationValue, objects) {
  var this$1 = $m_jl_Integer$();
  return new $c_s_Some().init___O(new $c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation().init___I(this$1.parseInt__T__I__I(annotationValue, 10)))
});
var $d_Lamf_plugins_document_vocabularies_annotations_AliasesLocation$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_annotations_AliasesLocation$: 0
}, false, "amf.plugins.document.vocabularies.annotations.AliasesLocation$", {
  Lamf_plugins_document_vocabularies_annotations_AliasesLocation$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_annotations_AliasesLocation$;
var $n_Lamf_plugins_document_vocabularies_annotations_AliasesLocation$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_annotations_AliasesLocation$() {
  if ((!$n_Lamf_plugins_document_vocabularies_annotations_AliasesLocation$)) {
    $n_Lamf_plugins_document_vocabularies_annotations_AliasesLocation$ = new $c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_annotations_AliasesLocation$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_annotations_CustomId$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_vocabularies_annotations_CustomId$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_annotations_CustomId$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_annotations_CustomId$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_annotations_CustomId$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_annotations_CustomId$.prototype = $c_Lamf_plugins_document_vocabularies_annotations_CustomId$.prototype;
$c_Lamf_plugins_document_vocabularies_annotations_CustomId$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_vocabularies_annotations_CustomId$.prototype.unparse__T__sci_Map__s_Option = (function(annotationValue, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_plugins_document_vocabularies_annotations_CustomId().init___T(annotationValue))
});
var $d_Lamf_plugins_document_vocabularies_annotations_CustomId$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_annotations_CustomId$: 0
}, false, "amf.plugins.document.vocabularies.annotations.CustomId$", {
  Lamf_plugins_document_vocabularies_annotations_CustomId$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_annotations_CustomId$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_annotations_CustomId$;
var $n_Lamf_plugins_document_vocabularies_annotations_CustomId$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_annotations_CustomId$() {
  if ((!$n_Lamf_plugins_document_vocabularies_annotations_CustomId$)) {
    $n_Lamf_plugins_document_vocabularies_annotations_CustomId$ = new $c_Lamf_plugins_document_vocabularies_annotations_CustomId$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_annotations_CustomId$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef$.prototype = $c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef$.prototype;
$c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef().init___())
});
var $d_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_annotations_JsonPointerRef$: 0
}, false, "amf.plugins.document.vocabularies.annotations.JsonPointerRef$", {
  Lamf_plugins_document_vocabularies_annotations_JsonPointerRef$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef$;
var $n_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef$() {
  if ((!$n_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef$)) {
    $n_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef$ = new $c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_annotations_RefInclude$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_vocabularies_annotations_RefInclude$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_annotations_RefInclude$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_annotations_RefInclude$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_annotations_RefInclude$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_annotations_RefInclude$.prototype = $c_Lamf_plugins_document_vocabularies_annotations_RefInclude$.prototype;
$c_Lamf_plugins_document_vocabularies_annotations_RefInclude$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_vocabularies_annotations_RefInclude$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_plugins_document_vocabularies_annotations_RefInclude().init___())
});
var $d_Lamf_plugins_document_vocabularies_annotations_RefInclude$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_annotations_RefInclude$: 0
}, false, "amf.plugins.document.vocabularies.annotations.RefInclude$", {
  Lamf_plugins_document_vocabularies_annotations_RefInclude$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_annotations_RefInclude$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_annotations_RefInclude$;
var $n_Lamf_plugins_document_vocabularies_annotations_RefInclude$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_annotations_RefInclude$() {
  if ((!$n_Lamf_plugins_document_vocabularies_annotations_RefInclude$)) {
    $n_Lamf_plugins_document_vocabularies_annotations_RefInclude$ = new $c_Lamf_plugins_document_vocabularies_annotations_RefInclude$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_annotations_RefInclude$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$() {
  $c_O.call(this);
  this.fields$1 = null;
  this.type$1 = null;
  this.Externals$1 = null;
  this.doc$1 = null
}
$c_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModel__$$init$__V(this);
  var x$1 = this.Externals$1;
  var this$1 = $m_sci_Nil$();
  this.fields$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$1);
  this.type$1 = $m_sci_Nil$();
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  this.doc$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$.prototype.amf$plugins$document$vocabularies$metamodel$document$ExternalContextModel$$undsetter$und$Externals$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Externals$1 = x$1
});
var $d_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$: 0
}, false, "amf.plugins.document.vocabularies.metamodel.document.ExternalContextModelFields$", {
  Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$: 1,
  O: 1,
  Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$;
var $n_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$() {
  if ((!$n_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$)) {
    $n_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$ = new $c_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm() {
  $c_O.call(this);
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm.prototype.withSubClassOf__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_PropertyTerm = (function(superProperties) {
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().SubPropertyOf$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_T(x$1$2);
      return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(x$1, new $c_Lamf_core_parser_Annotations().init___())
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(superProperties.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2)), new $c_Lamf_core_parser_Annotations().init___());
  return $as_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, value))
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return this.adopted__T__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_PropertyTerm(parent, cycle)
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm.prototype.adopted__T__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_PropertyTerm = (function(parent, cycle) {
  if ($m_s_Option$().apply__O__s_Option(this.id$1).isEmpty__Z()) {
    $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
  };
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
function $as_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.domain.PropertyTerm"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_domain_PropertyTerm)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.domain.PropertyTerm;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_UnknownMapKeyProperty() {
  /*<skip>*/
}
function $as_Lamf_plugins_document_vocabularies_model_domain_UnknownMapKeyProperty(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnknownMapKeyProperty) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.domain.UnknownMapKeyProperty"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_domain_UnknownMapKeyProperty(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_domain_UnknownMapKeyProperty)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_domain_UnknownMapKeyProperty(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_domain_UnknownMapKeyProperty(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.domain.UnknownMapKeyProperty;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations() {
  $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations.call(this);
  this.dialectDomainElements$3 = null;
  this.errorHandler$3 = null;
  this.futureDeclarations$3 = null
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations.prototype = new $h_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations.prototype.getOrCreateLibrary__T__Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations = (function(alias) {
  return this.getOrCreateLibrary__T__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations(alias)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations.prototype.getOrCreateLibrary__T__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations = (function(alias) {
  var x1 = this.libraries$1.get__O__s_Option(alias);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var lib = $as_Lamf_core_parser_Declarations(x2.value$2);
    if ((lib instanceof $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations)) {
      var x3 = $as_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations(lib);
      return x3
    }
  };
  var x$1 = this.errorHandler$3;
  var x$2 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
  var x$3 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var result = new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations().init___sci_Map__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations(x$3, x$1, x$2);
  this.libraries$1 = this.libraries$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(alias, result));
  return result
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations.prototype.declarables__sc_Seq = (function() {
  var this$1 = this.dialectDomainElements$3;
  var this$2 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$1);
  var this$3 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$3);
  var this$4 = $as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this$2, cbf));
  return $f_sc_SetLike__toSeq__sc_Seq(this$4)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations.prototype.registerDialectDomainElement__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations = (function(name, dialectDomainElement) {
  this.dialectDomainElements$3 = this.dialectDomainElements$3.$$plus__T2__sci_Map(new $c_T2().init___O__O(name, dialectDomainElement));
  if ((!dialectDomainElement.isUnresolved$1)) {
    var this$3 = this.futureDeclarations$3;
    $f_Lamf_core_parser_FutureDeclarations__resolveRef__T__Lamf_core_model_domain_Linkable__V(this$3, name, dialectDomainElement)
  };
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations.prototype.findAnyDialectDomainElement__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, scope) {
  var this$1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_parser_Declarations(x$2$2);
      return $as_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations(x$2).dialectDomainElements$3
    })
  })(this)), scope);
  var pf = new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findAnyDialectDomainElement$2().init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations(this);
  if ((!this$1.isEmpty__Z())) {
    var this$2 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$1.get__O();
    return this$2.apply__O__s_Option(v1)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations.prototype.findDialectDomainElement__T__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, nodeMapping, scope) {
  var nodeMappingIds = $f_Lamf_plugins_document_vocabularies_parser_instances_NodeMappableHelper__allNodeMappingIds__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__sci_Set(this, nodeMapping);
  var this$1 = this.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_parser_Declarations(x$1$2);
      return $as_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations(x$1).dialectDomainElements$3
    })
  })(this)), scope);
  var pf = new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findDialectDomainElement$2().init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations__sci_Set(this, nodeMappingIds);
  if ((!this$1.isEmpty__Z())) {
    var this$2 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$1.get__O();
    return this$2.apply__O__s_Option(v1)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations.prototype.init___sci_Map__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations = (function(dialectDomainElements, errorHandler, futureDeclarations) {
  this.dialectDomainElements$3 = dialectDomainElements;
  this.errorHandler$3 = errorHandler;
  this.futureDeclarations$3 = futureDeclarations;
  $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations.prototype.init___sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations.call(this, $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())), errorHandler, futureDeclarations);
  return this
});
function $as_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceDeclarations"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.parser.instances.DialectInstanceDeclarations;", depth))
}
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceDeclarations", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations: 1,
  Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations: 1,
  Lamf_core_parser_Declarations: 1,
  O: 1,
  Lamf_plugins_document_vocabularies_parser_instances_NodeMappableHelper: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$.prototype = $c_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$.prototype;
$c_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$.prototype.dialectHeaderDirective__Lamf_core_Root__s_Option = (function(document) {
  var this$1 = document.parsed$1.comment__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$();
    var this$3 = $f_Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor__dialect__Lamf_core_Root__s_Option(this$2, document);
    if (this$3.isEmpty__Z()) {
      var this$4 = $m_s_None$()
    } else {
      var arg1 = this$3.get__O();
      var metaText = $as_T(arg1);
      var this$4 = new $c_s_Some().init___O(("%" + metaText))
    }
  } else {
    var this$4 = this$1
  };
  if (this$4.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1$1 = this$4.get__O();
    var x$1 = $as_T(arg1$1);
    return new $c_s_Some().init___O($m_Lorg_mulesoft_common_core_package$Strings$().stripSpaces$extension__T__T(x$1))
  }
});
$c_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$.prototype.apply__Lamf_core_Root__Lamf_plugins_document_vocabularies_DialectsRegistry__Z = (function(root, registry) {
  var text = this.dialectHeaderDirective__Lamf_core_Root__s_Option(root);
  if (this.isExternal__p1__s_Option__Z(text)) {
    return true
  } else {
    if (text.isEmpty__Z()) {
      var header = $m_s_None$()
    } else {
      var arg1 = text.get__O();
      var h = $as_T(arg1);
      var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(h, "\\|", 0);
      var this$3 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
      var header = new $c_s_Some().init___O($as_T($f_sc_IndexedSeqOptimized__head__O(this$3)))
    };
    matchEnd19: {
      var jsx$1;
      if ((header instanceof $c_s_Some)) {
        var x2 = $as_s_Some(header);
        var p3 = $as_T(x2.value$2);
        if (($m_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$().DialectHeader$1 === p3)) {
          var jsx$1 = true;
          break matchEnd19
        }
      };
      if ((header instanceof $c_s_Some)) {
        var x4 = $as_s_Some(header);
        var p5 = $as_T(x4.value$2);
        if (($m_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$().DialectFragmentHeader$1 === p5)) {
          var jsx$1 = true;
          break matchEnd19
        }
      };
      if ((header instanceof $c_s_Some)) {
        var x6 = $as_s_Some(header);
        var p7 = $as_T(x6.value$2);
        if (($m_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$().DialectLibraryHeader$1 === p7)) {
          var jsx$1 = true;
          break matchEnd19
        }
      };
      if ((header instanceof $c_s_Some)) {
        var x8 = $as_s_Some(header);
        var p9 = $as_T(x8.value$2);
        if (($m_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$().VocabularyHeader$1 === p9)) {
          var jsx$1 = true;
          break matchEnd19
        }
      };
      var jsx$1 = false
    };
    if (jsx$1) {
      return true
    } else if ((header instanceof $c_s_Some)) {
      var x10 = $as_s_Some(header);
      var other = $as_T(x10.value$2);
      return registry.map$1.get__O__s_Option(other).isDefined__Z()
    } else {
      return $f_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor__dialectInKey__Lamf_core_Root__Lamf_plugins_document_vocabularies_DialectsRegistry__s_Option(this, root, registry).isDefined__Z()
    }
  }
});
$c_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$.prototype.isExternal__p1__s_Option__Z = (function(header) {
  if ((!header.isEmpty__Z())) {
    var arg1 = header.get__O();
    var h = $as_T(arg1);
    return ($m_sjsr_RuntimeString$().endsWith__T__T__Z(h, ">") && ($uI(h.indexOf("|<")) !== (-1)))
  } else {
    return false
  }
});
var $d_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$: 0
}, false, "amf.plugins.document.vocabularies.plugin.headers.DialectHeader$", {
  Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$: 1,
  O: 1,
  Lamf_plugins_document_vocabularies_plugin_headers_RamlHeaderExtractor: 1,
  Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor: 1,
  Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor: 1
});
$c_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$;
var $n_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$() {
  if ((!$n_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$)) {
    $n_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$ = new $c_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_JsonSchemaPlugin() {
  $c_Lamf_client_plugins_AMFDocumentPlugin.call(this);
  this.vendors$2 = null;
  this.ID$2 = null;
  this.allowRecursiveReferences$2 = false;
  this.platform$2 = null
}
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype = new $h_Lamf_client_plugins_AMFDocumentPlugin();
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.constructor = $c_Lamf_plugins_document_webapi_JsonSchemaPlugin;
/** @constructor */
function $h_Lamf_plugins_document_webapi_JsonSchemaPlugin() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype = $c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype;
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.init__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  return $m_s_concurrent_Future$().successful__O__s_concurrent_Future(this)
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.init___ = (function() {
  $c_Lamf_client_plugins_AMFDocumentPlugin.prototype.init___.call(this);
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$2 = this$1.platform$1;
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_core_remote_JsonSchema$().name$1];
  this.vendors$2 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  this.ID$2 = "JSON Schema";
  this.allowRecursiveReferences$2 = true;
  return this
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.obtainRootAst__Lamf_core_model_document_Fragment__s_Option__Lamf_plugins_document_webapi_contexts_WebApiContext__s_Option = (function(inputFragment, pointer, ctx) {
  var encoded = this.getYNode__Lamf_core_model_document_Fragment__Lamf_plugins_document_webapi_contexts_WebApiContext__Lorg_yaml_model_YNode(inputFragment, ctx);
  var doc = this.getRoot__p2__Lamf_core_model_document_Fragment__s_Option__Lorg_yaml_model_YNode__Lamf_core_Root(inputFragment, pointer, encoded);
  var x1 = doc.parsed$1;
  if ((x1 instanceof $c_Lamf_core_parser_SyamlParsedDocument)) {
    var x2 = $as_Lamf_core_parser_SyamlParsedDocument(x1);
    var thiz = doc.location$1;
    if (($uI(thiz.indexOf("#")) !== (-1))) {
      var shapeId = doc.location$1
    } else {
      var shapeId = (doc.location$1 + "#/")
    };
    var thiz$1 = doc.location$1;
    var parts = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz$1, "#", 0);
    var this$6 = new $c_scm_ArrayOps$ofRef().init___AO(parts);
    var url = $as_T($f_sc_IndexedSeqOptimized__head__O(this$6));
    if ((parts.u.length === 0)) {
      if ((parts.u.length === 0)) {
        throw new $c_jl_UnsupportedOperationException().init___T("empty.tail")
      };
      var until = parts.u.length;
      var x = ((until > 0) ? until : 0);
      var y = parts.u.length;
      var hi = ((x < y) ? x : y);
      var x$1 = (((-1) + hi) | 0);
      var size = ((x$1 > 0) ? x$1 : 0);
      var result = $m_jl_reflect_Array$().newInstance__jl_Class__I__O($objectGetClass(parts).getComponentType__jl_Class(), size);
      if ((size > 0)) {
        $m_s_Array$().copy__O__I__O__I__I__V(parts, 1, result, 0, size)
      };
      var jsx$1 = result
    } else {
      var until$1 = parts.u.length;
      var x$2 = ((until$1 > 0) ? until$1 : 0);
      var y$1 = parts.u.length;
      var hi$1 = ((x$2 < y$1) ? x$2 : y$1);
      var x$3 = (((-1) + hi$1) | 0);
      var size$1 = ((x$3 > 0) ? x$3 : 0);
      var result$1 = $m_jl_reflect_Array$().newInstance__jl_Class__I__O($objectGetClass(parts).getComponentType__jl_Class(), size$1);
      if ((size$1 > 0)) {
        $m_s_Array$().copy__O__I__O__I__I__V(parts, 1, result$1, 0, size$1)
      };
      var jsx$1 = result$1
    };
    var xs = $asArrayOf_O(jsx$1, 1);
    var this$29 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    var this$30 = $f_sc_TraversableLike__headOption__s_Option(this$29);
    if (this$30.isEmpty__Z()) {
      var hashFragment = $m_s_None$()
    } else {
      var arg1 = this$30.get__O();
      var t = $as_T(arg1);
      if ((($uI(t.length) >= 0) && ($as_T(t.substring(0, $uI("/".length))) === "/"))) {
        var this$37 = new $c_sci_StringOps().init___T(t);
        var jsx$2 = $f_sci_StringLike__stripPrefix__T__T(this$37, "/")
      } else {
        var jsx$2 = t
      };
      var hashFragment = new $c_s_Some().init___O(jsx$2)
    };
    var jsonSchemaContext = this.getJsonSchemaContext__p2__Lamf_core_Root__Lamf_core_parser_ParserContext__T__Lamf_core_client_ParsingOptions__Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext(doc, ctx, url, ctx.options$2);
    var rootAst = this.getRootAst__p2__Lamf_core_parser_SyamlParsedDocument__T__s_Option__T__Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext__Lorg_yaml_model_YNode(x2, shapeId, hashFragment, url, jsonSchemaContext);
    return new $c_s_Some().init___O(rootAst)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.unparseAsYDocument__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__s_Option = (function(unit, renderOptions, shapeRenderOptions) {
  if ($is_Lamf_core_model_document_DeclaresModel(unit)) {
    var root = $as_Lamf_core_model_document_DeclaresModel(unit).declares__sc_Seq().find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(d$2) {
        var d = $as_Lamf_core_model_domain_DomainElement(d$2);
        return (d.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot.getClassOf()) && (d instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape))
      })
    })(this)));
    if ((root instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(root);
      var r = $as_Lamf_core_model_domain_DomainElement(x2$2.value$2);
      if ((r instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
        var x3 = $as_Lamf_plugins_domain_shapes_models_AnyShape(r);
        var x$2 = $as_Lamf_core_model_document_DeclaresModel(unit).declares__sc_Seq();
        var x$4 = $m_Lamf_core_emitter_SpecOrdering$Lexical$();
        return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter().init___Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_core_emitter_ShapeRenderOptions(x3, x$2, x$4, shapeRenderOptions).emitDocument__Lorg_yaml_model_YDocument())
      }
    };
    return $m_s_None$()
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.parseParameterFragment__Lamf_core_model_document_Fragment__s_Option__T__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext__s_Option = (function(inputFragment, pointer, parentId, ctx) {
  var this$1 = this.obtainRootAst__Lamf_core_model_document_Fragment__s_Option__Lamf_plugins_document_webapi_contexts_WebApiContext__s_Option(inputFragment, pointer, ctx);
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var node = $as_Lorg_yaml_model_YNode(arg1);
    return new $c_s_Some().init___O(ctx.factory__Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory().parameterParser__s_util_Either__T__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_parser_spec_domain_OasParameterParser(($m_s_package$(), new $c_s_util_Right().init___O(node)), parentId, $m_s_None$(), new $c_Lamf_core_utils_package$IdCounter().init___()).parse__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter())
  }
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.parseFragment__Lamf_core_model_document_Fragment__s_Option__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__s_Option = (function(inputFragment, pointer, ctx) {
  var encoded = this.getYNode__Lamf_core_model_document_Fragment__Lamf_plugins_document_webapi_contexts_WebApiContext__Lorg_yaml_model_YNode(inputFragment, ctx);
  var doc = this.getRoot__p2__Lamf_core_model_document_Fragment__s_Option__Lorg_yaml_model_YNode__Lamf_core_Root(inputFragment, pointer, encoded);
  var this$1 = this.parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option(doc, ctx, this.platform$2, new $c_Lamf_core_client_ParsingOptions().init___());
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var parsed = $as_Lamf_core_model_document_BaseUnit(arg1);
    if ($is_Lamf_core_model_document_EncodesModel(parsed)) {
      if (($as_Lamf_core_model_document_EncodesModel(parsed).encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
        return new $c_s_Some().init___O($as_Lamf_plugins_domain_shapes_models_AnyShape($as_Lamf_core_model_document_EncodesModel(parsed).encodes__Lamf_core_model_domain_DomainElement()))
      }
    };
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.findRootNode__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext__s_Option__s_Option = (function(ast, ctx, path) {
  if (path.isDefined__Z()) {
    ctx.setJsonSchemaAST__Lorg_yaml_model_YNode__V(ast);
    var res = ctx.findLocalJSONPath__T__s_Option($as_T(path.get__O()));
    ctx.localJSONSchemaContext$2 = $m_s_None$();
    if (res.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1 = res.get__O();
      var x$1 = $as_T2(arg1);
      return new $c_s_Some().init___O($as_Lorg_yaml_model_YNode(x$1.$$und2__O()))
    }
  } else {
    return new $c_s_Some().init___O(ast)
  }
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.getRoot__p2__Lamf_core_model_document_Fragment__s_Option__Lorg_yaml_model_YNode__Lamf_core_Root = (function(inputFragment, pointer, encoded) {
  var jsx$8 = $m_Lamf_core_Root$();
  var jsx$7 = new $c_Lamf_core_parser_SyamlParsedDocument().init___Lorg_yaml_model_YDocument__s_Option($m_Lorg_yaml_model_YDocument$().apply__Lorg_yaml_model_YNode__T__Lorg_yaml_model_YDocument(encoded, ""), $m_s_None$());
  var this$2 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(inputFragment);
  var jsx$6 = $as_T((this$2.isEmpty__Z() ? inputFragment.id__T() : this$2.get__O()));
  var jsx$5 = (pointer.isDefined__Z() ? ("#" + pointer.get__O()) : "");
  var jsx$4 = $as_sc_Seq(inputFragment.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().References$1));
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(ref$2) {
      var ref = $as_Lamf_core_model_document_BaseUnit(ref$2);
      var this$3 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(ref);
      return new $c_Lamf_core_parser_ParsedReference().init___Lamf_core_model_document_BaseUnit__Lamf_core_parser_Reference__s_Option(ref, new $c_Lamf_core_parser_Reference().init___T__sc_Seq($as_T((this$3.isEmpty__Z() ? "" : this$3.get__O())), $m_sci_Nil$()), $m_s_None$())
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  var jsx$2 = $as_sc_Seq(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$4.ReusableCBFInstance$2));
  var jsx$1 = $m_Lamf_core_parser_SchemaReference$();
  var this$5 = inputFragment.raw__s_Option();
  return jsx$8.apply__Lamf_core_parser_ParsedDocument__T__T__sc_Seq__Lamf_core_parser_ReferenceKind__T__Lamf_core_Root(jsx$7, (jsx$6 + jsx$5), "application/json", jsx$2, jsx$1, $as_T((this$5.isEmpty__Z() ? "" : this$5.get__O())))
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.canUnparse__Lamf_core_model_document_BaseUnit__Z = (function(unit) {
  return this.firstAnyShape__p2__Lamf_core_model_document_BaseUnit__s_Option(unit).isDefined__Z()
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.parsedFragment__p2__Lamf_core_model_document_Fragment__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_model_YNode = (function(inputFragment, eh) {
  var this$1 = $m_Lamf_plugins_document_webapi_JsonSchemaParser$().apply__Lamf_core_model_document_Fragment__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_YParser(inputFragment, eh);
  return $f_Lorg_yaml_parser_YParser__document__Lorg_yaml_model_YDocument(this$1).node$2
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option = (function(document, parentContext, platform, options) {
  var x1 = document.parsed$1;
  if ((x1 instanceof $c_Lamf_core_parser_SyamlParsedDocument)) {
    var x2 = $as_Lamf_core_parser_SyamlParsedDocument(x1);
    var thiz = document.location$1;
    if (($uI(thiz.indexOf("#")) !== (-1))) {
      var shapeId = document.location$1
    } else {
      var shapeId = (document.location$1 + "#/")
    };
    var thiz$1 = document.location$1;
    var parts = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz$1, "#", 0);
    var this$6 = new $c_scm_ArrayOps$ofRef().init___AO(parts);
    var url = $as_T($f_sc_IndexedSeqOptimized__head__O(this$6));
    if ((parts.u.length === 0)) {
      if ((parts.u.length === 0)) {
        throw new $c_jl_UnsupportedOperationException().init___T("empty.tail")
      };
      var until = parts.u.length;
      var x = ((until > 0) ? until : 0);
      var y = parts.u.length;
      var hi = ((x < y) ? x : y);
      var x$1 = (((-1) + hi) | 0);
      var size = ((x$1 > 0) ? x$1 : 0);
      var result = $m_jl_reflect_Array$().newInstance__jl_Class__I__O($objectGetClass(parts).getComponentType__jl_Class(), size);
      if ((size > 0)) {
        $m_s_Array$().copy__O__I__O__I__I__V(parts, 1, result, 0, size)
      };
      var jsx$1 = result
    } else {
      var until$1 = parts.u.length;
      var x$2 = ((until$1 > 0) ? until$1 : 0);
      var y$1 = parts.u.length;
      var hi$1 = ((x$2 < y$1) ? x$2 : y$1);
      var x$3 = (((-1) + hi$1) | 0);
      var size$1 = ((x$3 > 0) ? x$3 : 0);
      var result$1 = $m_jl_reflect_Array$().newInstance__jl_Class__I__O($objectGetClass(parts).getComponentType__jl_Class(), size$1);
      if ((size$1 > 0)) {
        $m_s_Array$().copy__O__I__O__I__I__V(parts, 1, result$1, 0, size$1)
      };
      var jsx$1 = result$1
    };
    var xs = $asArrayOf_O(jsx$1, 1);
    var this$29 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    var this$30 = $f_sc_TraversableLike__headOption__s_Option(this$29);
    if (this$30.isEmpty__Z()) {
      var hashFragment = $m_s_None$()
    } else {
      var arg1 = this$30.get__O();
      var t = $as_T(arg1);
      if ((($uI(t.length) >= 0) && ($as_T(t.substring(0, $uI("/definitions".length))) === "/definitions"))) {
        var this$37 = new $c_sci_StringOps().init___T(t);
        var jsx$2 = $f_sci_StringLike__stripPrefix__T__T(this$37, "/")
      } else {
        var jsx$2 = t
      };
      var hashFragment = new $c_s_Some().init___O(jsx$2)
    };
    var jsonSchemaContext = this.getJsonSchemaContext__p2__Lamf_core_Root__Lamf_core_parser_ParserContext__T__Lamf_core_client_ParsingOptions__Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext(document, parentContext, url, options);
    var rootAst = this.getRootAst__p2__Lamf_core_parser_SyamlParsedDocument__T__s_Option__T__Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext__Lorg_yaml_model_YNode(x2, shapeId, hashFragment, url, jsonSchemaContext);
    var x1$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser($m_Lorg_yaml_model_YMapEntry$().apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("schema")), rootAst), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, shapeId$1) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(shape, shapeId$1)
      })
    })(this, shapeId)), jsonSchemaContext.computeJsonSchemaVersion__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion(rootAst), jsonSchemaContext).parse__s_Option();
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var shape$3 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x2$2.value$2);
      var parsed = shape$3
    } else {
      var x$4 = $m_s_None$();
      if ((!(x$4 === x1$2))) {
        throw new $c_s_MatchError().init___O(x1$2)
      };
      var this$39 = jsonSchemaContext.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().UnableToParseJsonSchema$1;
      var message = ("Cannot parse JSON Schema at " + document.location$1);
      var prop = $m_s_None$();
      var l = rootAst.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$39, specification, shapeId, prop, message, l);
      $m_Lamf_core_parser_Annotations$();
      var annotations = new $c_Lamf_core_parser_Annotations().init___();
      var this$43 = new $c_Lamf_plugins_domain_shapes_models_SchemaShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
      var this$44 = $as_Lamf_plugins_domain_shapes_models_SchemaShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$43, shapeId));
      var field = $m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$().MediaType$1;
      var this$45 = $as_Lamf_plugins_domain_shapes_models_SchemaShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$44, field, "application/json"));
      var text = document.raw$1;
      var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$().Raw$1;
      var parsed = $as_Lamf_plugins_domain_shapes_models_SchemaShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$45, field$1, text))
    };
    jsonSchemaContext.localJSONSchemaContext$2 = $m_s_None$();
    $m_Lamf_core_parser_Annotations$();
    var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
    var this$49 = new $c_Lamf_plugins_document_webapi_model_DataTypeFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
    var value = document.location$1;
    var this$50 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$49, value));
    var location = document.location$1;
    var field$2 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
    var this$51 = $as_Lamf_core_model_document_EncodesModel($as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$50, field$2, location)));
    var field$3 = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
    var unit = $as_Lamf_plugins_document_webapi_model_DataTypeFragment($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$51, field$3, parsed)));
    var raw = document.raw$1;
    $f_Lamf_core_model_document_BaseUnit__withRaw__T__Lamf_core_model_document_BaseUnit(unit, raw);
    return new $c_s_Some().init___O(unit)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.modelEntities__sc_Seq = (function() {
  return $m_sci_Nil$()
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.getRootAst__p2__Lamf_core_parser_SyamlParsedDocument__T__s_Option__T__Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext__Lorg_yaml_model_YNode = (function(parsedDoc, shapeId, hashFragment, url, jsonSchemaContext) {
  var documentRoot = parsedDoc.document$2.node$2;
  var this$1 = this.findRootNode__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext__s_Option__s_Option(documentRoot, jsonSchemaContext, hashFragment);
  if (this$1.isEmpty__Z()) {
    var this$2 = jsonSchemaContext.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().UnableToParseJsonSchema$1;
    var message = ((("Cannot find path " + (hashFragment.isEmpty__Z() ? "" : hashFragment.get__O())) + " in JSON schema ") + url);
    var prop = $m_s_None$();
    var l = documentRoot.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$2, specification, shapeId, prop, message, l);
    var jsx$1 = documentRoot
  } else {
    var jsx$1 = this$1.get__O()
  };
  var rootAst = $as_Lorg_yaml_model_YNode(jsx$1);
  jsonSchemaContext.setJsonSchemaAST__Lorg_yaml_model_YNode__V(documentRoot);
  return rootAst
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.documentSyntaxes__sc_Seq = (function() {
  var jsx$1 = $m_sc_Seq$();
  var array = ["application/schema+json", "application/payload+json"];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.vendors__sc_Seq = (function() {
  return this.vendors$2
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.referenceHandler__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_ReferenceHandler = (function(eh) {
  return $m_Lamf_core_parser_SimpleReferenceHandler$()
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.ID__T = (function() {
  return this.ID$2
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.dependencies__sc_Seq = (function() {
  return $m_sci_Nil$()
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.firstAnyShape__p2__Lamf_core_model_document_BaseUnit__s_Option = (function(unit) {
  if ($is_Lamf_core_model_document_DeclaresModel(unit)) {
    var this$1 = $as_Lamf_core_model_document_DeclaresModel(unit).declares__sc_Seq();
    var pf = new $c_Lamf_plugins_document_webapi_JsonSchemaPlugin$$anonfun$firstAnyShape$1().init___Lamf_plugins_document_webapi_JsonSchemaPlugin(this);
    return $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$1, pf)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.getYNode__Lamf_core_model_document_Fragment__Lamf_plugins_document_webapi_contexts_WebApiContext__Lorg_yaml_model_YNode = (function(inputFragment, ctx) {
  if ((inputFragment instanceof $c_Lamf_core_model_document_ExternalFragment)) {
    var x2 = $as_Lamf_core_model_document_ExternalFragment(inputFragment);
    var this$1 = $as_Lamf_core_model_domain_ExternalDomainElement($as_Lamf_core_model_domain_DomainElement(x2.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))).parsed$1;
    return $as_Lorg_yaml_model_YNode((this$1.isEmpty__Z() ? this.parsedFragment__p2__Lamf_core_model_document_Fragment__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_model_YNode(inputFragment, ctx.eh$1) : this$1.get__O()))
  };
  if ((inputFragment instanceof $c_Lamf_core_model_document_RecursiveUnit)) {
    var x3 = $as_Lamf_core_model_document_RecursiveUnit(inputFragment);
    if (x3.raw$1.isDefined__Z()) {
      return this.parsedFragment__p2__Lamf_core_model_document_Fragment__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_model_YNode(inputFragment, ctx.eh$1)
    }
  };
  var this$2 = ctx.eh$1;
  var specification = $m_Lamf_validations_ParserSideValidations$().UnableToParseJsonSchema$1;
  var target = $m_s_None$();
  var node = inputFragment.id__T();
  var lexical = inputFragment.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  var location = $f_Lamf_core_model_document_BaseUnit__location__s_Option(inputFragment);
  this$2.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, target, "Cannot parse JSON Schema from unit with missing syntax information", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
  $m_Lorg_yaml_model_YNode$();
  var map = $m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap($as_sc_IndexedSeq($m_s_package$().IndexedSeq$1.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), "");
  return $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1)
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.canParse__Lamf_core_Root__Z = (function(document) {
  return false
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.getJsonSchemaContext__p2__Lamf_core_Root__Lamf_core_parser_ParserContext__T__Lamf_core_client_ParsingOptions__Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext = (function(document, parentContext, url, options) {
  var jsx$3 = document.references$1;
  var jsx$2 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
  var jsx$1 = parentContext.eh$1;
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$6 = new $c_scm_ListBuffer().init___();
  var cleanNested = new $c_Lamf_core_parser_ParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext(url, jsx$3, jsx$2, jsx$1, new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$6.toList__sci_List()));
  cleanNested.globalSpace$1 = parentContext.globalSpace$1;
  var inheritedDeclarations = ((parentContext instanceof $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext) ? new $c_s_Some().init___O($as_Lamf_plugins_document_webapi_contexts_WebApiContext(parentContext).declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations()) : $m_s_None$());
  var jsx$5 = document.references$1;
  if (inheritedDeclarations.isEmpty__Z()) {
    var jsx$4 = $m_s_None$()
  } else {
    var arg1 = inheritedDeclarations.get__O();
    var d = $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(arg1);
    var jsx$4 = new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_spec_package$().toOasDeclarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations(d))
  };
  return new $c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__Lamf_core_client_ParsingOptions(url, jsx$5, cleanNested, jsx$4, options)
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.serializableAnnotations__sci_Map = (function() {
  return $m_sci_Map$EmptyMap$()
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.allowRecursiveReferences__Z = (function() {
  return this.allowRecursiveReferences$2
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_errorhandling_ErrorHandler__T__Lamf_core_model_document_BaseUnit = (function(unit, errorHandler, pipelineId) {
  return new $c_Lamf_plugins_document_webapi_resolution_pipelines_OasResolutionPipeline().init___Lamf_core_errorhandling_ErrorHandler(errorHandler).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit)
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance$.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_ExtensionProvenance$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_ExtensionProvenance$.prototype = $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance$.prototype;
$c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  var x1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(value, ",", 0);
  var o8 = $m_s_Array$().unapplySeq__O__s_Option(x1);
  if (((!o8.isEmpty__Z()) && ((o8.get__O() !== null) && ($as_sc_SeqLike(o8.get__O()).lengthCompare__I__I(2) === 0)))) {
    var baseId = $as_T($as_sc_SeqLike(o8.get__O()).apply__I__O(0));
    var baseLocation = $as_T($as_sc_SeqLike(o8.get__O()).apply__I__O(1));
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(baseId, "->", 0);
    var this$4 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    var jsx$2 = $as_T($f_sc_IndexedSeqOptimized__last__O(this$4));
    var jsx$1 = $m_s_Option$();
    var xs$1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(baseLocation, "->", 0);
    var this$7 = new $c_scm_ArrayOps$ofRef().init___AO(xs$1);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance().init___T__s_Option(jsx$2, jsx$1.apply__O__s_Option($f_sc_IndexedSeqOptimized__last__O(this$7))))
  };
  var o10 = $m_s_Array$().unapplySeq__O__s_Option(x1);
  if (((!o10.isEmpty__Z()) && ((o10.get__O() !== null) && ($as_sc_SeqLike(o10.get__O()).lengthCompare__I__I(1) === 0)))) {
    var baseId$2 = $as_T($as_sc_SeqLike(o10.get__O()).apply__I__O(0));
    var xs$2 = $m_sjsr_RuntimeString$().split__T__T__I__AT(baseId$2, "->", 0);
    var this$10 = new $c_scm_ArrayOps$ofRef().init___AO(xs$2);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance().init___T__s_Option($as_T($f_sc_IndexedSeqOptimized__last__O(this$10)), $m_s_None$()))
  };
  return $m_s_None$()
});
var $d_Lamf_plugins_document_webapi_annotations_ExtensionProvenance$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_ExtensionProvenance$: 0
}, false, "amf.plugins.document.webapi.annotations.ExtensionProvenance$", {
  Lamf_plugins_document_webapi_annotations_ExtensionProvenance$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance$.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_ExtensionProvenance$;
var $n_Lamf_plugins_document_webapi_annotations_ExtensionProvenance$ = (void 0);
function $m_Lamf_plugins_document_webapi_annotations_ExtensionProvenance$() {
  if ((!$n_Lamf_plugins_document_webapi_annotations_ExtensionProvenance$)) {
    $n_Lamf_plugins_document_webapi_annotations_ExtensionProvenance$ = new $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance$().init___()
  };
  return $n_Lamf_plugins_document_webapi_annotations_ExtensionProvenance$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_FormBodyParameter$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_annotations_FormBodyParameter$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_FormBodyParameter$.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_FormBodyParameter$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_FormBodyParameter$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_FormBodyParameter$.prototype = $c_Lamf_plugins_document_webapi_annotations_FormBodyParameter$.prototype;
$c_Lamf_plugins_document_webapi_annotations_FormBodyParameter$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_annotations_FormBodyParameter$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_annotations_FormBodyParameter().init___())
});
var $d_Lamf_plugins_document_webapi_annotations_FormBodyParameter$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_FormBodyParameter$: 0
}, false, "amf.plugins.document.webapi.annotations.FormBodyParameter$", {
  Lamf_plugins_document_webapi_annotations_FormBodyParameter$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_FormBodyParameter$.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_FormBodyParameter$;
var $n_Lamf_plugins_document_webapi_annotations_FormBodyParameter$ = (void 0);
function $m_Lamf_plugins_document_webapi_annotations_FormBodyParameter$() {
  if ((!$n_Lamf_plugins_document_webapi_annotations_FormBodyParameter$)) {
    $n_Lamf_plugins_document_webapi_annotations_FormBodyParameter$ = new $c_Lamf_plugins_document_webapi_annotations_FormBodyParameter$().init___()
  };
  return $n_Lamf_plugins_document_webapi_annotations_FormBodyParameter$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_JSONSchemaId$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaId$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaId$.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_JSONSchemaId$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_JSONSchemaId$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_JSONSchemaId$.prototype = $c_Lamf_plugins_document_webapi_annotations_JSONSchemaId$.prototype;
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaId$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaId$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_annotations_JSONSchemaId().init___T(value))
});
var $d_Lamf_plugins_document_webapi_annotations_JSONSchemaId$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_JSONSchemaId$: 0
}, false, "amf.plugins.document.webapi.annotations.JSONSchemaId$", {
  Lamf_plugins_document_webapi_annotations_JSONSchemaId$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaId$.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_JSONSchemaId$;
var $n_Lamf_plugins_document_webapi_annotations_JSONSchemaId$ = (void 0);
function $m_Lamf_plugins_document_webapi_annotations_JSONSchemaId$() {
  if ((!$n_Lamf_plugins_document_webapi_annotations_JSONSchemaId$)) {
    $n_Lamf_plugins_document_webapi_annotations_JSONSchemaId$ = new $c_Lamf_plugins_document_webapi_annotations_JSONSchemaId$().init___()
  };
  return $n_Lamf_plugins_document_webapi_annotations_JSONSchemaId$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_LocalLinkPath$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_annotations_LocalLinkPath$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_LocalLinkPath$.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_LocalLinkPath$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_LocalLinkPath$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_LocalLinkPath$.prototype = $c_Lamf_plugins_document_webapi_annotations_LocalLinkPath$.prototype;
$c_Lamf_plugins_document_webapi_annotations_LocalLinkPath$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_annotations_LocalLinkPath$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_annotations_LocalLinkPath().init___T(value))
});
var $d_Lamf_plugins_document_webapi_annotations_LocalLinkPath$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_LocalLinkPath$: 0
}, false, "amf.plugins.document.webapi.annotations.LocalLinkPath$", {
  Lamf_plugins_document_webapi_annotations_LocalLinkPath$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_LocalLinkPath$.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_LocalLinkPath$;
var $n_Lamf_plugins_document_webapi_annotations_LocalLinkPath$ = (void 0);
function $m_Lamf_plugins_document_webapi_annotations_LocalLinkPath$() {
  if ((!$n_Lamf_plugins_document_webapi_annotations_LocalLinkPath$)) {
    $n_Lamf_plugins_document_webapi_annotations_LocalLinkPath$ = new $c_Lamf_plugins_document_webapi_annotations_LocalLinkPath$().init___()
  };
  return $n_Lamf_plugins_document_webapi_annotations_LocalLinkPath$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload$.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload$.prototype = $c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload$.prototype;
$c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  var x1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(value, "->", 0);
  var o7 = $m_s_Array$().unapplySeq__O__s_Option(x1);
  if (((!o7.isEmpty__Z()) && ((o7.get__O() !== null) && ($as_sc_SeqLike(o7.get__O()).lengthCompare__I__I(2) === 0)))) {
    var req = $as_T($as_sc_SeqLike(o7.get__O()).apply__I__O(0));
    var range = $as_T($as_sc_SeqLike(o7.get__O()).apply__I__O(1));
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload().init___T__Lamf_core_parser_Range(req, $m_Lamf_core_parser_Range$().apply__T__Lamf_core_parser_Range(range)))
  };
  return $m_s_None$()
});
var $d_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_ParameterNameForPayload$: 0
}, false, "amf.plugins.document.webapi.annotations.ParameterNameForPayload$", {
  Lamf_plugins_document_webapi_annotations_ParameterNameForPayload$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload$.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload$;
var $n_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload$ = (void 0);
function $m_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload$() {
  if ((!$n_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload$)) {
    $n_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload$ = new $c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload$().init___()
  };
  return $n_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema$.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema$.prototype = $c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema$.prototype;
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema().init___T(value))
});
var $d_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_ParsedJSONSchema$: 0
}, false, "amf.plugins.document.webapi.annotations.ParsedJSONSchema$", {
  Lamf_plugins_document_webapi_annotations_ParsedJSONSchema$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema$.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema$;
var $n_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema$ = (void 0);
function $m_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema$() {
  if ((!$n_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema$)) {
    $n_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema$ = new $c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema$().init___()
  };
  return $n_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype$.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype$.prototype = $c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype$.prototype;
$c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype().init___T(value))
});
var $d_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype$: 0
}, false, "amf.plugins.document.webapi.annotations.ParsedRamlDatatype$", {
  Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype$.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype$;
var $n_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype$ = (void 0);
function $m_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype$() {
  if ((!$n_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype$)) {
    $n_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype$ = new $c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype$().init___()
  };
  return $n_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload$.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_RequiredParamPayload$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_RequiredParamPayload$.prototype = $c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload$.prototype;
$c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  var x1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(value, "->", 0);
  var o7 = $m_s_Array$().unapplySeq__O__s_Option(x1);
  if (((!o7.isEmpty__Z()) && ((o7.get__O() !== null) && ($as_sc_SeqLike(o7.get__O()).lengthCompare__I__I(2) === 0)))) {
    var req = $as_T($as_sc_SeqLike(o7.get__O()).apply__I__O(0));
    var range = $as_T($as_sc_SeqLike(o7.get__O()).apply__I__O(1));
    var required = (req === "true");
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload().init___Z__Lamf_core_parser_Range(required, $m_Lamf_core_parser_Range$().apply__T__Lamf_core_parser_Range(range)))
  };
  return $m_s_None$()
});
var $d_Lamf_plugins_document_webapi_annotations_RequiredParamPayload$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_RequiredParamPayload$: 0
}, false, "amf.plugins.document.webapi.annotations.RequiredParamPayload$", {
  Lamf_plugins_document_webapi_annotations_RequiredParamPayload$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload$.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_RequiredParamPayload$;
var $n_Lamf_plugins_document_webapi_annotations_RequiredParamPayload$ = (void 0);
function $m_Lamf_plugins_document_webapi_annotations_RequiredParamPayload$() {
  if ((!$n_Lamf_plugins_document_webapi_annotations_RequiredParamPayload$)) {
    $n_Lamf_plugins_document_webapi_annotations_RequiredParamPayload$ = new $c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload$().init___()
  };
  return $n_Lamf_plugins_document_webapi_annotations_RequiredParamPayload$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterContext() {
  $c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterContext.call(this);
  this.schemaVersion$4 = null;
  this.factory$4 = null;
  this.vendor$4 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterContext();
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterContext.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterContext.prototype.schemaVersion__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion = (function() {
  return this.schemaVersion$4
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterContext.prototype.vendor__Lamf_core_remote_Vendor = (function() {
  return this.vendor$4
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion = (function(eh, refEmitter, options, schemaVersion) {
  this.schemaVersion$4 = schemaVersion;
  $c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions.call(this, eh, refEmitter, options);
  this.factory$4 = new $c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory().init___Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterContext(this);
  this.vendor$4 = $m_Lamf_core_remote_AsyncApi20$();
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterContext.prototype.factory__Lamf_plugins_document_webapi_contexts_SpecEmitterFactory = (function() {
  return this.factory$4
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterContext.prototype.factory__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory = (function() {
  return this.factory$4
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterContext.prototype.schemasDeclarationsPath__T = (function() {
  return "/definitions/"
});
var $d_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterContext = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterContext: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.async.Async20SpecEmitterContext", {
  Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_SpecEmitterContext: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterContext.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterContext;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext() {
  $c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.call(this);
  this.typeDefMatcher$3 = null;
  this.nameRegex$3 = null;
  this.definitionsQueue$3 = null;
  this.forceEmission$3 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext();
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.prototype.localReference__Lamf_core_model_domain_Linkable__Lamf_core_emitter_PartEmitter = (function(reference) {
  return $as_Lamf_core_emitter_PartEmitter(this.factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory().tagToReferenceEmitter__F3().apply__O__O__O__O($as_Lamf_core_model_domain_DomainElement(reference), $as_Lamf_core_model_StrField(reference.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1, $m_sci_Nil$()))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.prototype.typeDefMatcher__Lamf_plugins_document_webapi_parser_OasTypeDefStringValueMatcher = (function() {
  return this.typeDefMatcher$3
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.prototype.filterLocal__sc_Seq__sc_Seq = (function(elements) {
  return elements
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.prototype.nameRegex__s_util_matching_Regex = (function() {
  return this.nameRegex$3
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions = (function(eh, refEmitter, options) {
  $c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions.call(this, eh, refEmitter, options);
  $f_Lamf_plugins_document_webapi_contexts_emitter_oas_CompactEmissionContext__$$init$__V(this);
  this.typeDefMatcher$3 = $m_Lamf_plugins_document_webapi_parser_CommonOasTypeDefMatcher$();
  return this
});
function $as_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.emitter.oas.OasSpecEmitterContext"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.emitter.oas.OasSpecEmitterContext;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory() {
  $c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory.call(this)
}
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory.prototype = new $h_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory();
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory.prototype.tagToReferenceEmitter__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(target$2, label$2, reference$2) {
      var target = $as_Lamf_core_model_domain_DomainElement(target$2);
      var label = $as_s_Option(label$2);
      var reference = $as_sc_Seq(reference$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter().init___Lamf_core_model_domain_DomainElement__s_Option__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(target, label, reference, $this.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext())
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory.prototype.recursiveShapeEmitter__F3 = (function() {
  return $f_Lamf_plugins_document_webapi_contexts_emitter_oas_OasCompactEmitterFactory__recursiveShapeEmitter__F3(this)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory.prototype.init___Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(spec) {
  $c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory.prototype.init___Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.call(this, spec);
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory.prototype.facetsInstanceEmitter__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(shapeExtension$2, ordering$2) {
      var shapeExtension = $as_Lamf_core_model_domain_extensions_ShapeExtension(shapeExtension$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter().init___Lamf_core_model_domain_extensions_ShapeExtension__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(shapeExtension, ordering, $this.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext())
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory.prototype.annotationTypeEmitter__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(property$2, ordering$2) {
      var property = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(property$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter().init___Lamf_core_model_domain_extensions_CustomDomainProperty__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(property, ordering, $this.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext())
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory.prototype.customFacetsEmitter__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(f$2, ordering$2, references$2) {
      var f = $as_Lamf_core_parser_FieldEntry(f$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      var references = $as_sc_Seq(references$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(f, ordering, references, $this.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext())
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory.prototype.headerEmitter__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(parameter$2, ordering$2, references$2) {
      var parameter = $as_Lamf_plugins_domain_webapi_models_Parameter(parameter$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      var references = $as_sc_Seq(references$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter().init___Lamf_plugins_domain_webapi_models_Parameter__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(parameter, ordering, references, $this.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext())
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory.prototype.declaredTypesEmitter__F3 = (function() {
  return $f_Lamf_plugins_document_webapi_contexts_emitter_oas_OasCompactEmitterFactory__declaredTypesEmitter__F3(this)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory.prototype.securityRequirementEmitter__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(requirement$2, ordering$2) {
      var requirement = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(requirement$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter().init___Lamf_plugins_domain_webapi_models_security_SecurityRequirement__Lamf_core_emitter_SpecOrdering(requirement, ordering)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory.prototype.typeEmitters__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq = (function(shape, ordering, ignored, references, pointer, schemaPath) {
  return $f_Lamf_plugins_document_webapi_contexts_emitter_oas_OasCompactEmitterFactory__typeEmitters__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq(this, shape, ordering, ignored, references, pointer, schemaPath)
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$1() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter.call(this);
  this.key$2 = null;
  this.$$outer$2 = null;
  this.f$1$2 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$1.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter();
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$1.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$1.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$1.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$1.prototype.init___Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering = (function($$outer, f$1, ordering$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.f$1$2 = f$1;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, f$1, ordering$1, $m_sci_Nil$(), $$outer.spec$1);
  this.key$2 = "";
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$1.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.$$outer$2.spec$1;
  var this$3 = this$1.eh$1;
  var specification = $m_Lamf_validations_RenderSideValidations$().RenderValidation$1;
  var property = $m_s_None$();
  var message = ("Custom facets not supported for vendor " + this.$$outer$2.spec$1.vendor__Lamf_core_remote_Vendor());
  var this$2 = this.f$1$2.value$1.value$1;
  var lexical = this$2.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  var location = this.f$1$2.value$1.value$1.location__s_Option();
  this$3.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, "", property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$1.prototype.shapeEmitter__F3 = (function() {
  $m_s_Predef$().$$qmark$qmark$qmark__sr_Nothing$()
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$1.prototype.key__T = (function() {
  return this.key$2
});
var $d_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$1: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.raml.Raml08EmitterVersionFactory$$anon$1", {
  Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$1: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$1.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$2() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter.call(this);
  this.name$2 = null;
  this.$$outer$2 = null;
  this.shapeExtension$1$2 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$2.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter();
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$2.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$2.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$2.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$2.prototype.init___Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory__Lamf_core_model_domain_extensions_ShapeExtension__Lamf_core_emitter_SpecOrdering = (function($$outer, shapeExtension$1, ordering$2) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.shapeExtension$1$2 = shapeExtension$1;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter.prototype.init___Lamf_core_model_domain_extensions_ShapeExtension__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, shapeExtension$1, ordering$2, $$outer.spec$1);
  this.name$2 = "";
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$2.prototype.name__T = (function() {
  return this.name$2
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$2.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.$$outer$2.spec$1;
  var this$4 = this$1.eh$1;
  var specification = $m_Lamf_validations_RenderSideValidations$().RenderValidation$1;
  var node = this.shapeExtension$1$2.id$1;
  var property = $m_s_None$();
  var message = ("Custom facets not supported for vendor " + this.$$outer$2.spec$1.vendor__Lamf_core_remote_Vendor());
  var this$2 = this.shapeExtension$1$2;
  var lexical = this$2.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  var this$3 = this.shapeExtension$1$2;
  var location = $f_Lamf_core_model_domain_AmfElement__location__s_Option(this$3);
  this$4.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
});
var $d_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$2: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.raml.Raml08EmitterVersionFactory$$anon$2", {
  Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$2: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$2.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$3() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter.call(this);
  this.name$2 = null;
  this.$$outer$2 = null;
  this.domainExtension$1$2 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$3.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter();
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$3.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$3;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$3() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$3.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$3.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$3.prototype.name__T = (function() {
  return this.name$2
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$3.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.$$outer$2.spec$1;
  var this$4 = this$1.eh$1;
  var specification = $m_Lamf_validations_RenderSideValidations$().RenderValidation$1;
  var node = this.domainExtension$1$2.id$1;
  var property = $m_s_None$();
  var message = ("Custom facets not supported for vendor " + this.$$outer$2.spec$1.vendor__Lamf_core_remote_Vendor());
  var this$2 = this.domainExtension$1$2;
  var lexical = this$2.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  var this$3 = this.domainExtension$1$2;
  var location = $f_Lamf_core_model_domain_AmfElement__location__s_Option(this$3);
  this$4.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$3.prototype.init___Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory__Lamf_core_model_domain_extensions_DomainExtension__Lamf_core_emitter_SpecOrdering = (function($$outer, domainExtension$1, ordering$3) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.domainExtension$1$2 = domainExtension$1;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter.prototype.init___Lamf_core_model_domain_extensions_DomainExtension__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, domainExtension$1, ordering$3, $$outer.spec$1);
  this.name$2 = "";
  return this
});
var $d_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$3 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$3: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.raml.Raml08EmitterVersionFactory$$anon$3", {
  Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$3: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$3.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08EmitterVersionFactory$$anon$3;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_raml_XRaml10SpecEmitterContext() {
  $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext.call(this);
  this.oasFactory$4 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_XRaml10SpecEmitterContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext();
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_XRaml10SpecEmitterContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_XRaml10SpecEmitterContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_raml_XRaml10SpecEmitterContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_raml_XRaml10SpecEmitterContext.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_XRaml10SpecEmitterContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_XRaml10SpecEmitterContext.prototype.localReference__Lamf_core_model_domain_Linkable__Lamf_core_emitter_PartEmitter = (function(reference) {
  return $as_Lamf_core_emitter_PartEmitter(this.oasFactory$4.tagToReferenceEmitter__F3().apply__O__O__O__O($as_Lamf_core_model_domain_DomainElement(reference), $as_Lamf_core_model_StrField(reference.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1, $m_sci_Nil$()))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_XRaml10SpecEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions = (function(eh, refEmitter, options) {
  $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions.call(this, eh, refEmitter, options);
  this.oasFactory$4 = new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory().init___Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(eh, refEmitter, this.options$1));
  return this
});
var $d_Lamf_plugins_document_webapi_contexts_emitter_raml_XRaml10SpecEmitterContext = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_raml_XRaml10SpecEmitterContext: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.raml.XRaml10SpecEmitterContext", {
  Lamf_plugins_document_webapi_contexts_emitter_raml_XRaml10SpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_SpecEmitterContext: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_XRaml10SpecEmitterContext.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_raml_XRaml10SpecEmitterContext;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$() {
  $c_s_Enumeration.call(this);
  this.DEFAULT$2 = null;
  this.RESOURCE$undTYPE$2 = null;
  this.TRAIT$2 = null;
  this.EXTENSION$2 = null;
  this.OVERLAY$2 = null
}
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$.prototype = new $h_s_Enumeration();
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$.prototype.init___ = (function() {
  $c_s_Enumeration.prototype.init___I.call(this, 0);
  $n_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$ = this;
  var name = (((this.nextName$1 !== null) && this.nextName$1.hasNext__Z()) ? $as_T(this.nextName$1.next__O()) : "DEFAULT");
  var i = this.nextId$1;
  this.DEFAULT$2 = new $c_s_Enumeration$Val().init___s_Enumeration__I__T(this, i, name);
  var name$1 = (((this.nextName$1 !== null) && this.nextName$1.hasNext__Z()) ? $as_T(this.nextName$1.next__O()) : "RESOURCE_TYPE");
  var i$1 = this.nextId$1;
  this.RESOURCE$undTYPE$2 = new $c_s_Enumeration$Val().init___s_Enumeration__I__T(this, i$1, name$1);
  var name$2 = (((this.nextName$1 !== null) && this.nextName$1.hasNext__Z()) ? $as_T(this.nextName$1.next__O()) : "TRAIT");
  var i$2 = this.nextId$1;
  this.TRAIT$2 = new $c_s_Enumeration$Val().init___s_Enumeration__I__T(this, i$2, name$2);
  var name$3 = (((this.nextName$1 !== null) && this.nextName$1.hasNext__Z()) ? $as_T(this.nextName$1.next__O()) : "EXTENSION");
  var i$3 = this.nextId$1;
  this.EXTENSION$2 = new $c_s_Enumeration$Val().init___s_Enumeration__I__T(this, i$3, name$3);
  var name$4 = (((this.nextName$1 !== null) && this.nextName$1.hasNext__Z()) ? $as_T(this.nextName$1.next__O()) : "OVERLAY");
  var i$4 = this.nextId$1;
  this.OVERLAY$2 = new $c_s_Enumeration$Val().init___s_Enumeration__I__T(this, i$4, name$4);
  return this
});
var $d_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$: 0
}, false, "amf.plugins.document.webapi.contexts.parser.raml.RamlWebApiContextType$", {
  Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$: 1,
  s_Enumeration: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$;
var $n_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$ = (void 0);
function $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$() {
  if ((!$n_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$)) {
    $n_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$ = new $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().init___()
  };
  return $n_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations() {
  $c_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations();
$c_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations.prototype = $c_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations.prototype.futureDeclarations__Lamf_core_parser_FutureDeclarations = (function() {
  return this.futureDeclarations$3
});
$c_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations.prototype.init___sci_Map__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations = (function(asts, alias, errorHandler, futureDeclarations) {
  $c_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations.prototype.init___sci_Map__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations.call(this, asts, alias, errorHandler, futureDeclarations);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations.prototype.errorHandler__Lamf_core_errorhandling_ErrorHandler = (function() {
  return this.errorHandler$3
});
$c_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations.prototype.asts__sci_Map = (function() {
  return this.asts$3
});
$c_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations.prototype.alias__s_Option = (function() {
  return this.alias$3
});
function $as_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.AsyncWebApiDeclarations"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.AsyncWebApiDeclarations;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations: 0
}, false, "amf.plugins.document.webapi.parser.spec.AsyncWebApiDeclarations", {
  Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations: 1,
  Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations: 1,
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations: 1,
  Lamf_core_parser_Declarations: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_ExtensionWebApiDeclarations() {
  $c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations.call(this);
  this.parentDeclarations$4 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_ExtensionWebApiDeclarations.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations();
$c_Lamf_plugins_document_webapi_parser_spec_ExtensionWebApiDeclarations.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_ExtensionWebApiDeclarations;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_ExtensionWebApiDeclarations() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_ExtensionWebApiDeclarations.prototype = $c_Lamf_plugins_document_webapi_parser_spec_ExtensionWebApiDeclarations.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_ExtensionWebApiDeclarations.prototype.futureDeclarations__Lamf_core_parser_FutureDeclarations = (function() {
  return this.futureDeclarations$3
});
$c_Lamf_plugins_document_webapi_parser_spec_ExtensionWebApiDeclarations.prototype.init___sci_Map__sci_Map__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations = (function(externalShapes, externalLibs, parentDeclarations, alias, errorHandler, futureDeclarations) {
  this.parentDeclarations$4 = parentDeclarations;
  $c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations.prototype.init___sci_Map__sci_Map__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations.call(this, externalShapes, externalLibs, alias, errorHandler, futureDeclarations);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_ExtensionWebApiDeclarations.prototype.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option = (function(key, map, scope) {
  var x1 = $c_Lamf_core_parser_Declarations.prototype.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option.call(this, key, map, scope);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var x = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    return new $c_s_Some().init___O(x)
  } else {
    var x$2 = $m_s_None$();
    if ((x$2 === x1)) {
      return this.parentDeclarations$4.findForType__T__F1__Lamf_core_parser_SearchScope$Scope__s_Option(key, map, scope)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_ExtensionWebApiDeclarations.prototype.errorHandler__Lamf_core_errorhandling_ErrorHandler = (function() {
  return this.errorHandler$3
});
$c_Lamf_plugins_document_webapi_parser_spec_ExtensionWebApiDeclarations.prototype.alias__s_Option = (function() {
  return this.alias$3
});
var $d_Lamf_plugins_document_webapi_parser_spec_ExtensionWebApiDeclarations = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_ExtensionWebApiDeclarations: 0
}, false, "amf.plugins.document.webapi.parser.spec.ExtensionWebApiDeclarations", {
  Lamf_plugins_document_webapi_parser_spec_ExtensionWebApiDeclarations: 1,
  Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations: 1,
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations: 1,
  Lamf_core_parser_Declarations: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_ExtensionWebApiDeclarations.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_ExtensionWebApiDeclarations;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations() {
  $c_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations();
$c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations.prototype = $c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations.prototype.futureDeclarations__Lamf_core_parser_FutureDeclarations = (function() {
  return this.futureDeclarations$3
});
$c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations.prototype.init___sci_Map__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations = (function(asts, alias, errorHandler, futureDeclarations) {
  $c_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations.prototype.init___sci_Map__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations.call(this, asts, alias, errorHandler, futureDeclarations);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations.prototype.errorHandler__Lamf_core_errorhandling_ErrorHandler = (function() {
  return this.errorHandler$3
});
$c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations.prototype.asts__sci_Map = (function() {
  return this.asts$3
});
$c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations.prototype.alias__s_Option = (function() {
  return this.alias$3
});
function $as_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.OasWebApiDeclarations"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.OasWebApiDeclarations;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations: 0
}, false, "amf.plugins.document.webapi.parser.spec.OasWebApiDeclarations", {
  Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations: 1,
  Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations: 1,
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations: 1,
  Lamf_core_parser_Declarations: 1,
  O: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiSpecParser() {
  $c_O.call(this);
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiSpecParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiSpecParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiSpecParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiSpecParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiSpecParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiSpecParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiSpecParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$2__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiSpecParser.prototype.EmptyTarget$lzycompute$2__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiSpecParser.prototype.init___Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(ctx) {
  return this
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOperationEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationEmitter.call(this);
  this.operation$2 = null;
  this.ordering$2 = null;
  this.isTrait$2 = false
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOperationEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOperationEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOperationEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOperationEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOperationEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOperationEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOperationEmitter.prototype.operationPartEmitter__Lamf_core_emitter_PartEmitter = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter().init___Lamf_plugins_domain_webapi_models_Operation__Z__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.operation$2, this.isTrait$2, this.ordering$2, $as_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.spec$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOperationEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_emitter_SpecOrdering__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(operation, ordering, isTrait, spec) {
  this.operation$2 = operation;
  this.ordering$2 = ordering;
  this.isTrait$2 = isTrait;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, operation, ordering, spec);
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOperationEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOperationEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiOperationEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOperationEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOperationEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOperationEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelBindingEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter.call(this);
  this.binding$2 = null;
  this.ordering$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelBindingEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelBindingEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelBindingEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelBindingEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelBindingEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelBindingEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelBindingEmitter.prototype.emitSpecific__p2__T__sc_Seq = (function(is) {
  if ((is === "routingKey")) {
    var jsx$1 = $m_sc_Seq$();
    var this$1 = this.binding$2;
    var array = [new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelExchangeEmitter().init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange__Lamf_core_emitter_SpecOrdering($as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$().Exchange$1)), this.ordering$2)];
    return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  } else if ((is === "queue")) {
    var jsx$2 = $m_sc_Seq$();
    var this$4 = this.binding$2;
    var array$1 = [new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelQueueEmitter().init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue__Lamf_core_emitter_SpecOrdering($as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue(this$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$().Queue$1)), this.ordering$2)];
    return $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)))
  } else {
    return $m_sci_Nil$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelBindingEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("amqp");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var fs = this.binding$2.fields$1;
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$().Is$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    if ((!f.value$1.value$1.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_SynthesizedField.getClassOf()))) {
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("is", f, $m_s_None$()))
    };
    result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(this.emitSpecific__p2__T__sc_Seq(f.value$1.value$1.toString__T()))
  };
  this.emitBindingVersion__Lamf_core_parser_Fields__scm_ListBuffer__V(fs, result);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$2.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelBindingEmitter.prototype.init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding__Lamf_core_emitter_SpecOrdering = (function(binding, ordering) {
  this.binding$2 = binding;
  this.ordering$2 = ordering;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelBindingEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.binding$2.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelBindingEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelBindingEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.bindings.Amqp091ChannelBindingEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelBindingEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelBindingEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091ChannelBindingEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091MessageEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter.call(this);
  this.binding$2 = null;
  this.ordering$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091MessageEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091MessageEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091MessageEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091MessageEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091MessageEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091MessageEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091MessageEmitter.prototype.init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(binding, ordering, spec) {
  this.binding$2 = binding;
  this.ordering$2 = ordering;
  this.spec$2 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091MessageEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("amqp");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var fs = this.binding$2.fields$1;
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$().ContentEncoding$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("contentEncoding", f, $m_s_None$()))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$().MessageType$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("messageType", f$3, $m_s_None$()))
  };
  this.emitBindingVersion__Lamf_core_parser_Fields__scm_ListBuffer__V(fs, result);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$2.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$8 = v.builder$1;
  var array = [key];
  if ((this$8.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$8.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$8, newSize);
  var len$1 = this$8.size0$6;
  var src = this$8.array$6;
  var dest = this$8.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$8.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$8.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091MessageEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.binding$2.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091MessageEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091MessageEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.bindings.Amqp091MessageEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091MessageEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091MessageEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091MessageEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091OperationBindingEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter.call(this);
  this.binding$2 = null;
  this.ordering$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091OperationBindingEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091OperationBindingEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091OperationBindingEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091OperationBindingEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091OperationBindingEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091OperationBindingEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091OperationBindingEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("amqp");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var fs = this.binding$2.fields$1;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().Expiration$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("expiration", f, $m_s_None$()))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().UserId$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("userId", f$3, $m_s_None$()))
  };
  var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().CC$1);
  if ((!this$6.isEmpty__Z())) {
    var arg1$2 = this$6.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType("cc", f$4, this.ordering$2, false, $m_Lorg_yaml_model_YType$().Str$1))
  };
  var this$8 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().Priority$1);
  if ((!this$8.isEmpty__Z())) {
    var arg1$3 = this$8.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("priority", f$5, $m_s_None$()))
  };
  var this$10 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().DeliveryMode$1);
  if ((!this$10.isEmpty__Z())) {
    var arg1$4 = this$10.get__O();
    var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("deliveryMode", f$6, $m_s_None$()))
  };
  var this$12 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().Mandatory$1);
  if ((!this$12.isEmpty__Z())) {
    var arg1$5 = this$12.get__O();
    var f$7 = $as_Lamf_core_parser_FieldEntry(arg1$5);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("mandatory", f$7, $m_s_None$()))
  };
  var this$14 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().BCC$1);
  if ((!this$14.isEmpty__Z())) {
    var arg1$6 = this$14.get__O();
    var f$8 = $as_Lamf_core_parser_FieldEntry(arg1$6);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType("bcc", f$8, this.ordering$2, false, $m_Lorg_yaml_model_YType$().Str$1))
  };
  var this$16 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().ReplyTo$1);
  if ((!this$16.isEmpty__Z())) {
    var arg1$7 = this$16.get__O();
    var f$9 = $as_Lamf_core_parser_FieldEntry(arg1$7);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("replyTo", f$9, $m_s_None$()))
  };
  var this$18 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().Timestamp$1);
  if ((!this$18.isEmpty__Z())) {
    var arg1$8 = this$18.get__O();
    var f$10 = $as_Lamf_core_parser_FieldEntry(arg1$8);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("timestamp", f$10, $m_s_None$()))
  };
  var this$20 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().Ack$1);
  if ((!this$20.isEmpty__Z())) {
    var arg1$9 = this$20.get__O();
    var f$11 = $as_Lamf_core_parser_FieldEntry(arg1$9);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("ack", f$11, $m_s_None$()))
  };
  this.emitBindingVersion__Lamf_core_parser_Fields__scm_ListBuffer__V(fs, result);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$2.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$24 = v.builder$1;
  var array = [key];
  if ((this$24.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$24.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$24, newSize);
  var len$1 = this$24.size0$6;
  var src = this$24.array$6;
  var dest = this$24.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$24.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$24.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091OperationBindingEmitter.prototype.init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(binding, ordering, spec) {
  this.binding$2 = binding;
  this.ordering$2 = ordering;
  this.spec$2 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091OperationBindingEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.binding$2.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091OperationBindingEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091OperationBindingEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.bindings.Amqp091OperationBindingEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091OperationBindingEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091OperationBindingEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_Amqp091OperationBindingEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpMessageEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter.call(this);
  this.binding$2 = null;
  this.ordering$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpMessageEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpMessageEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpMessageEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpMessageEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpMessageEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpMessageEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpMessageEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("http");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var fs = this.binding$2.fields$1;
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$().Headers$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter().init___T__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__s_Option__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext("headers", $as_Lamf_core_model_domain_Shape(f.value$1.value$1), this.ordering$2, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), $m_s_None$(), this.spec$2))
  };
  this.emitBindingVersion__Lamf_core_parser_Fields__scm_ListBuffer__V(fs, result);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$2.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpMessageEmitter.prototype.init___Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(binding, ordering, spec) {
  this.binding$2 = binding;
  this.ordering$2 = ordering;
  this.spec$2 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpMessageEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.binding$2.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpMessageEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpMessageEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.bindings.HttpMessageEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpMessageEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpMessageEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpMessageEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpOperationBindingEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter.call(this);
  this.binding$2 = null;
  this.ordering$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpOperationBindingEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpOperationBindingEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpOperationBindingEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpOperationBindingEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpOperationBindingEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpOperationBindingEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpOperationBindingEmitter.prototype.init___Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(binding, ordering, spec) {
  this.binding$2 = binding;
  this.ordering$2 = ordering;
  this.spec$2 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpOperationBindingEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("http");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var fs = this.binding$2.fields$1;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$().OperationType$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("type", f, $m_s_None$()))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$().Method$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("method", f$3, $m_s_None$()))
  };
  var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$().Query$1);
  if ((!this$6.isEmpty__Z())) {
    var arg1$2 = this$6.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter().init___T__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__s_Option__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext("query", $as_Lamf_core_model_domain_Shape(f$4.value$1.value$1), this.ordering$2, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), $m_s_None$(), this.spec$2))
  };
  this.emitBindingVersion__Lamf_core_parser_Fields__scm_ListBuffer__V(fs, result);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$2.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$10 = v.builder$1;
  var array = [key];
  if ((this$10.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$10.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$10, newSize);
  var len$1 = this$10.size0$6;
  var src = this$10.array$6;
  var dest = this$10.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$10.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$10.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpOperationBindingEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.binding$2.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpOperationBindingEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpOperationBindingEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.bindings.HttpOperationBindingEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpOperationBindingEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpOperationBindingEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_HttpOperationBindingEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaMessageEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter.call(this);
  this.binding$2 = null;
  this.ordering$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaMessageEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaMessageEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaMessageEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaMessageEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaMessageEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaMessageEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaMessageEmitter.prototype.init___Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(binding, ordering, spec) {
  this.binding$2 = binding;
  this.ordering$2 = ordering;
  this.spec$2 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaMessageEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("kafka");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var fs = this.binding$2.fields$1;
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$().MessageKey$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("key", f, $m_s_None$()))
  };
  this.emitBindingVersion__Lamf_core_parser_Fields__scm_ListBuffer__V(fs, result);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$2.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaMessageEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.binding$2.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaMessageEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaMessageEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.bindings.KafkaMessageEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaMessageEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaMessageEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaMessageEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaOperationBindingEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter.call(this);
  this.binding$2 = null;
  this.ordering$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaOperationBindingEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaOperationBindingEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaOperationBindingEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaOperationBindingEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaOperationBindingEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaOperationBindingEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaOperationBindingEmitter.prototype.init___Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(binding, ordering, spec) {
  this.binding$2 = binding;
  this.ordering$2 = ordering;
  this.spec$2 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaOperationBindingEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("kafka");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var fs = this.binding$2.fields$1;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$().GroupId$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("groupId", f, $m_s_None$()))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$().ClientId$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("clientId", f$3, $m_s_None$()))
  };
  this.emitBindingVersion__Lamf_core_parser_Fields__scm_ListBuffer__V(fs, result);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$2.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$8 = v.builder$1;
  var array = [key];
  if ((this$8.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$8.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$8, newSize);
  var len$1 = this$8.size0$6;
  var src = this$8.array$6;
  var dest = this$8.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$8.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$8.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaOperationBindingEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.binding$2.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaOperationBindingEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaOperationBindingEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.bindings.KafkaOperationBindingEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaOperationBindingEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaOperationBindingEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_KafkaOperationBindingEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttMessageEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter.call(this);
  this.binding$2 = null;
  this.ordering$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttMessageEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttMessageEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttMessageEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttMessageEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttMessageEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttMessageEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttMessageEmitter.prototype.init___Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(binding, ordering, spec) {
  this.binding$2 = binding;
  this.ordering$2 = ordering;
  this.spec$2 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttMessageEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("mqtt");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var fs = this.binding$2.fields$1;
  this.emitBindingVersion__Lamf_core_parser_Fields__scm_ListBuffer__V(fs, result);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$2.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$4 = v.builder$1;
  var array = [key];
  if ((this$4.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$4.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$4, newSize);
  var len$1 = this$4.size0$6;
  var src = this$4.array$6;
  var dest = this$4.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$4.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$4.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttMessageEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.binding$2.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttMessageEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttMessageEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.bindings.MqttMessageEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttMessageEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttMessageEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttMessageEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttOperationBindingEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter.call(this);
  this.binding$2 = null;
  this.ordering$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttOperationBindingEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttOperationBindingEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttOperationBindingEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttOperationBindingEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttOperationBindingEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttOperationBindingEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttOperationBindingEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("mqtt");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var fs = this.binding$2.fields$1;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$().Qos$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("qos", f, $m_s_None$()))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$().Retain$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("retain", f$3, $m_s_None$()))
  };
  this.emitBindingVersion__Lamf_core_parser_Fields__scm_ListBuffer__V(fs, result);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$2.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$8 = v.builder$1;
  var array = [key];
  if ((this$8.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$8.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$8, newSize);
  var len$1 = this$8.size0$6;
  var src = this$8.array$6;
  var dest = this$8.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$8.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$8.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttOperationBindingEmitter.prototype.init___Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(binding, ordering, spec) {
  this.binding$2 = binding;
  this.ordering$2 = ordering;
  this.spec$2 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttOperationBindingEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.binding$2.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttOperationBindingEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttOperationBindingEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.bindings.MqttOperationBindingEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttOperationBindingEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttOperationBindingEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttOperationBindingEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter.call(this);
  this.binding$2 = null;
  this.ordering$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("mqtt");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var fs = this.binding$2.fields$1;
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().ClientId$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("clientId", f, $m_s_None$()))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().CleanSession$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("cleanSession", f$3, $m_s_None$()))
  };
  var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().KeepAlive$1);
  if ((!this$6.isEmpty__Z())) {
    var arg1$2 = this$6.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("keepAlive", f$4, $m_s_None$()))
  };
  var this$8 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().LastWill$1);
  if ((!this$8.isEmpty__Z())) {
    var arg1$3 = this$8.get__O();
    $as_Lamf_core_parser_FieldEntry(arg1$3);
    var this$9 = this.binding$2;
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter$LastWillEmitter().init___Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter__Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill__Lamf_core_emitter_SpecOrdering(this, $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill(this$9.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().LastWill$1)), this.ordering$2))
  };
  this.emitBindingVersion__Lamf_core_parser_Fields__scm_ListBuffer__V(fs, result);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$2.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$12 = v.builder$1;
  var array = [key];
  if ((this$12.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$12.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$12, newSize);
  var len$1 = this$12.size0$6;
  var src = this$12.array$6;
  var dest = this$12.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$12.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$12.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter.prototype.init___Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding__Lamf_core_emitter_SpecOrdering = (function(binding, ordering) {
  this.binding$2 = binding;
  this.ordering$2 = ordering;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.binding$2.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.bindings.MqttServerBindingEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_MqttServerBindingEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_WebSocketChannelBindingEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter.call(this);
  this.binding$2 = null;
  this.ordering$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_WebSocketChannelBindingEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_WebSocketChannelBindingEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_WebSocketChannelBindingEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_WebSocketChannelBindingEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_WebSocketChannelBindingEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_WebSocketChannelBindingEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_WebSocketChannelBindingEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("ws");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var fs = this.binding$2.fields$1;
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$().Method$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("method", f, $m_s_None$()))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$().Query$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter().init___T__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__s_Option__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext("query", $as_Lamf_core_model_domain_Shape(f$3.value$1.value$1), this.ordering$2, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), $m_s_None$(), this.spec$2))
  };
  var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$().Headers$1);
  if ((!this$6.isEmpty__Z())) {
    var arg1$2 = this$6.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter().init___T__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__s_Option__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext("headers", $as_Lamf_core_model_domain_Shape(f$4.value$1.value$1), this.ordering$2, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), $m_s_None$(), this.spec$2))
  };
  this.emitBindingVersion__Lamf_core_parser_Fields__scm_ListBuffer__V(fs, result);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$2.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$10 = v.builder$1;
  var array = [key];
  if ((this$10.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$10.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$10, newSize);
  var len$1 = this$10.size0$6;
  var src = this$10.array$6;
  var dest = this$10.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$10.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$10.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_WebSocketChannelBindingEmitter.prototype.init___Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(binding, ordering, spec) {
  this.binding$2 = binding;
  this.ordering$2 = ordering;
  this.spec$2 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_WebSocketChannelBindingEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.binding$2.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_WebSocketChannelBindingEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_WebSocketChannelBindingEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.bindings.WebSocketChannelBindingEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_WebSocketChannelBindingEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_AsyncApiCommonBindingEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_WebSocketChannelBindingEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_bindings_WebSocketChannelBindingEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteOperationParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser.call(this);
  this.entry$3 = null;
  this.ctx$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteOperationParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteOperationParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteOperationParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteOperationParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteOperationParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteOperationParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteOperationParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(entry, producer, ctx) {
  this.entry$3 = entry;
  this.ctx$3 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext.call(this, entry, producer, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteOperationParser.prototype.parseMessages__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Operation__V = (function(map, operation) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("message");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var messageEntry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = $m_Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$().messageType__T__s_Option(this.entry$3.key$2.value__Lorg_yaml_model_YValue().toString__T());
    if ((!this$4.isEmpty__Z())) {
      var arg1$1 = this$4.get__O();
      var msgType = $as_Lamf_plugins_document_webapi_parser_spec_async_MessageType(arg1$1);
      var this$5 = messageEntry.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = this.ctx$3;
      var messages = new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser().init___Lorg_yaml_model_YMap__T__Lamf_plugins_document_webapi_parser_spec_async_MessageType__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv)), operation.id$1, msgType, this.ctx$3).parse__sci_List();
      var field = msgType.field__Lamf_core_metamodel_Field();
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(messageEntry.value$2);
      $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(operation, field, messages, annotations))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteOperationParser.prototype.parseTraits__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Operation__V = (function(map, operation) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("traits");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var traitEntry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = traitEntry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
    var iv = this.ctx$3;
    var jsx$2 = $as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).nodes$3;
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(node$2) {
        var node = $as_Lorg_yaml_model_YNode(node$2);
        return new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser().init___Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(node, $this.ctx$3).parse__Lamf_plugins_domain_webapi_models_Operation()
      })
    })(this));
    var this$5 = $m_sc_IndexedSeq$();
    var traits = $as_sc_IndexedSeq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBF$6));
    var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Extends__Lamf_core_metamodel_Field();
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(traitEntry);
    $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(operation, field, traits, annotations)
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteOperationParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteOperationParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncConcreteOperationParser", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteOperationParser: 1,
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteOperationParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteOperationParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationTraitParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser.call(this);
  this.entry$3 = null;
  this.ctx$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationTraitParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationTraitParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationTraitParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationTraitParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationTraitParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationTraitParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationTraitParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function() {
  return this.ctx$3
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationTraitParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(entry, producer, ctx) {
  this.entry$3 = entry;
  this.ctx$3 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext.call(this, entry, producer, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationTraitParser.prototype.parse__Lamf_plugins_domain_webapi_models_Operation = (function() {
  var operation = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser.prototype.parse__Lamf_plugins_domain_webapi_models_Operation.call(this);
  var this$1 = this.entry$3.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$3;
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().IsAbstract$1;
  $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(operation, field, true));
  this.ctx$3.closedShape__T__Lorg_yaml_model_YMap__T__V(operation.id$1, map, "operationTrait");
  return operation
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationTraitParser.prototype.parseMessages__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Operation__V = (function(map, operation) {
  /*<skip>*/
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationTraitParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function() {
  return this.ctx$3
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationTraitParser.prototype.parseTraits__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Operation__V = (function(map, operation) {
  /*<skip>*/
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationTraitParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationTraitParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncOperationTraitParser", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationTraitParser: 1,
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationTraitParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationTraitParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator() {
  $c_O.call(this);
  this.buffer$1 = null;
  this.refsCounter$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.next__O = (function() {
  return this.next__Lorg_yaml_model_YNode()
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.toIterator__sc_Iterator = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.isEmpty__Z = (function() {
  return $f_sc_Iterator__isEmpty__Z(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.toList__sci_List = (function() {
  var this$1 = $m_sci_List$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_sci_List($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.take__I__sc_Iterator = (function(n) {
  return $f_sc_Iterator__take__I__sc_Iterator(this, n)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.mkString__T__T = (function(sep) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", sep, "")
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.toString__T = (function() {
  return "<iterator>"
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.sliceIterator__I__I__sc_Iterator = (function(from, until) {
  return $f_sc_Iterator__sliceIterator__I__I__sc_Iterator(this, from, until)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.foreach__F1__V = (function(f) {
  $f_sc_Iterator__foreach__F1__V(this, f)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.foldLeft__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.init___Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(node, ctx) {
  $m_sci_List$();
  var array = [node];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_utils_package$AliasCounter$();
  var this$5 = ctx.options$2;
  $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.init___sci_List__Lamf_core_utils_package$AliasCounter__Lamf_plugins_document_webapi_contexts_WebApiContext.call(this, jsx$2, jsx$1.apply__s_Option__Lamf_core_utils_package$AliasCounter(this$5.maxYamlReferences$1), ctx);
  this.advance__p1__V();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.advance__p1__V = (function() {
  var this$1 = this.buffer$1;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$1)) {
    var head = $as_Lorg_yaml_model_YNode(this.buffer$1.head__O());
    var x1 = head.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x === x1)) {
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = this.ctx$1;
      var m = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(head, conversion, iv));
      var jsx$2 = m.entries$3;
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(entry$2) {
          var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
          $m_sci_List$();
          var array = [entry.key$2, entry.value$2];
          var i = (((-1) + $uI(array.length)) | 0);
          var result = $m_sci_Nil$();
          while ((i >= 0)) {
            var this$5 = result;
            var index = i;
            var x$1 = array[index];
            result = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$5);
            i = (((-1) + i) | 0)
          };
          return result
        })
      })(this));
      var this$6 = $m_sc_IndexedSeq$();
      var nodes = $as_sc_IndexedSeq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBF$6));
      var jsx$4 = nodes.toList__sci_List();
      var jsx$3 = $as_sc_GenTraversableOnce(this.buffer$1.tail__O());
      var this$7 = $m_sci_List$();
      var this$8 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$7.ReusableCBFInstance$2));
      this.buffer$1 = new $c_sci_$colon$colon().init___O__sci_List(head, this$8)
    } else {
      var x$3 = $m_Lorg_yaml_model_YType$().Seq$1;
      if ((x$3 === x1)) {
        var conversion$1 = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
        var iv$1 = this.ctx$1;
        var s = $as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(head, conversion$1, iv$1));
        var jsx$6 = s.nodes$3.toList__sci_List();
        var jsx$5 = $as_sc_GenTraversableOnce(this.buffer$1.tail__O());
        var this$9 = $m_sci_List$();
        var this$12 = $as_sci_List(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$5, this$9.ReusableCBFInstance$2));
        $m_Lorg_yaml_model_YNode$();
        $m_Lorg_yaml_model_YNode$();
        var x$2 = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(s, $m_Lorg_yaml_model_YType$().Seq$1);
        this.buffer$1 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$12)
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.$$plus$plus__F0__sc_Iterator = (function(that) {
  return $f_sc_Iterator__$$plus$plus__F0__sc_Iterator(this, that)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.size__I = (function() {
  return $f_sc_TraversableOnce__size__I(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.toBuffer__scm_Buffer = (function() {
  var this$1 = $m_scm_ArrayBuffer$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_scm_Buffer($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.hasNext__Z = (function() {
  var this$1 = this.buffer$1;
  return $f_sc_TraversableOnce__nonEmpty__Z(this$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.mkString__T = (function() {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", "", "")
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.next__Lorg_yaml_model_YNode = (function() {
  var next = $as_Lorg_yaml_model_YNode(this.buffer$1.head__O());
  if (this.refsCounter$1.exceedsThreshold__Lorg_yaml_model_YNode__Z(next)) {
    var this$1 = this.ctx$1;
    var violationId = $m_Lamf_validations_ParserSideValidations$().ExeededMaxYamlReferences$1;
    var this$2 = this$1.eh$1;
    var location = this$1.rootContextDocument$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__T__V(this$2, violationId, "", "Exceeded maximum yaml references threshold", location);
    this.buffer$1 = $m_sci_Nil$();
    return next
  } else {
    this.buffer$1 = $as_sci_List(this.buffer$1.tail__O());
    this.advance__p1__V();
    return next
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.toStream__sci_Stream = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.toTraversable__sc_Traversable = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.toSeq__sc_Seq = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.init___sci_List__Lamf_core_utils_package$AliasCounter__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(buffer, refsCounter, ctx) {
  this.buffer$1 = buffer;
  this.refsCounter$1 = refsCounter;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.$$div$colon__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_sc_Iterator__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.isTraversableAgain__Z = (function() {
  return false
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.drop__I__sc_Iterator = (function(n) {
  return $f_sc_Iterator__drop__I__sc_Iterator(this, n)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  while (true) {
    var this$2 = this.buffer$1;
    if ($f_sc_TraversableOnce__nonEmpty__Z(this$2)) {
      var arg1 = this.next__Lorg_yaml_model_YNode();
      b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1))
    } else {
      break
    }
  };
  return $as_sci_Map(b.elems$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_sc_TraversableOnce__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_TraversableOnce__reduceLeft__F2__O(this, op)
});
var $d_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.YNodeIterator", {
  Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_YNodeIterator;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser.call(this);
  this.options$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser.prototype.parse__Lamf_core_model_domain_Shape.call(this);
  var shape = this.shape__Lamf_plugins_domain_shapes_models_AnyShape();
  var map = this.map__Lorg_yaml_model_YMap();
  var options = this.options__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions();
  var ctx = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  $f_Lamf_plugins_document_webapi_parser_spec_declaration_ExampleParser__parseExamples__Lamf_plugins_domain_shapes_models_AnyShape__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext__V(this, shape, map, options, ctx);
  return this.shape__Lamf_plugins_domain_shapes_models_AnyShape()
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype.options__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions = (function() {
  return this.options$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser = (function($$outer) {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.call(this, $$outer);
  this.options$2 = $m_Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$();
  return this
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter.call(this);
  this.WebApiEmitter$module$2 = null;
  this.EndpointsEmitter$module$2 = null;
  this.document$2 = null;
  this.EndPointEmitter$module$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter.prototype.emitWebApi__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq = (function(ordering, references) {
  var model = this.retrieveWebApi__p2__Lamf_plugins_domain_webapi_models_WebApi();
  var this$1 = model.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_SourceVendor.getClassOf());
  if (this$1.isEmpty__Z()) {
    var vendor = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$5 = $as_Lamf_core_annotations_SourceVendor(arg1);
    var vendor = new $c_s_Some().init___O(x$5.vendor$1)
  };
  var api = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter__Lamf_plugins_domain_webapi_models_WebApi__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq(this, model, ordering, vendor, references);
  return api.emitters$1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter.prototype.EndPointEmitter$lzycompute$1__p2__V = (function() {
  if ((this.EndPointEmitter$module$2 === null)) {
    this.EndPointEmitter$module$2 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter$().init___Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter.prototype.EndPointEmitter__Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter$ = (function() {
  if ((this.EndPointEmitter$module$2 === null)) {
    this.EndPointEmitter$lzycompute$1__p2__V()
  };
  return this.EndPointEmitter$module$2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter.prototype.extensionEmitter__sc_Seq = (function() {
  var this$1 = this.document$2.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_document_ExtensionLikeModel$().Extends$1);
  if (this$1.isEmpty__Z()) {
    var jsx$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    var jsx$5 = new $c_Lamf_core_utils_package$AmfStrings().init___T("extends").asOasExtension__T();
    var jsx$4 = $as_Lamf_core_model_domain_AmfScalar(f.value$1.value$1).toString__T();
    var this$3 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = f.value$1.annotations$1;
    var jsx$3 = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter().init___T__T__Lamf_core_parser_Position__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(jsx$5, jsx$4, this$3.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()), this.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext()))
  };
  var jsx$2 = jsx$3.toList__sci_List();
  var xo = this.retrieveHeader__p2__s_Option();
  var jsx$1 = xo.toList__sci_List();
  var this$5 = $m_sci_List$();
  return $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter.prototype.retrieveHeader__p2__s_Option = (function() {
  var x1 = this.document$2;
  if ((x1 instanceof $c_Lamf_plugins_document_webapi_model_Extension)) {
    var this$1 = $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$();
    var _1 = this$1.key$1;
    var _2 = this$1.value$1;
    return new $c_s_Some().init___O(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position(_1, _2, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()))
  } else if ((x1 instanceof $c_Lamf_plugins_document_webapi_model_Overlay)) {
    var this$5 = $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$();
    var _1$1 = this$5.key$1;
    var _2$1 = this$5.value$1;
    return new $c_s_Some().init___O(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position(_1$1, _2$1, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()))
  } else if ((x1 instanceof $c_Lamf_core_model_document_Document)) {
    return $m_s_None$()
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Document has no header."))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter.prototype.emitDocument__Lorg_yaml_model_YDocument = (function() {
  var doc = $as_Lamf_core_model_document_Document(this.document$2);
  var ordering = $m_Lamf_core_emitter_SpecOrdering$().ordering__Lamf_core_remote_Vendor__Lamf_core_parser_Annotations__Lamf_core_emitter_SpecOrdering($m_Lamf_core_remote_Oas$(), doc.encodes__Lamf_core_model_domain_DomainElement().annotations__Lamf_core_parser_Annotations());
  var references = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_SpecOrdering(this, this.document$2, ordering);
  var api = this.emitWebApi__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq(ordering, this.document$2.references__sc_Seq());
  var extension = this.extensionEmitter__sc_Seq();
  var this$1 = doc.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1);
  if (this$1.isEmpty__Z()) {
    var usage = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    var usage = new $c_s_Some().init___O(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("usage").asOasExtension__T(), f, $m_s_None$()))
  };
  var this$5 = $m_Lorg_yaml_model_YDocument$().apply__T__Lorg_yaml_model_YDocument$WithComment("");
  var b = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(this$5.org$yaml$model$YDocument$WithComment$$sourceName$f);
  var x = this$5.comment$1;
  var this$7 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$7)) {
    b.comment__T__V(this$5.comment$1)
  };
  var jsx$6 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  this.versionEntry__Lorg_yaml_model_YDocument$EntryBuilder__V(b$1);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(ordering.sorted__sc_Seq__sc_Seq(api), b$1);
  var jsx$5 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var jsx$4 = usage.toList__sci_List();
  var this$10 = $m_sc_Seq$();
  var jsx$3 = $as_sc_TraversableLike(extension.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$10.ReusableCBFInstance$2));
  var jsx$2 = this.declares$1__p2__Lamf_core_model_document_Document__Lamf_core_emitter_SpecOrdering__sc_Seq(doc, ordering);
  var this$11 = $m_sc_Seq$();
  var jsx$1 = $as_sc_SeqLike(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$11.ReusableCBFInstance$2));
  var this$12 = $m_sc_Seq$();
  jsx$5.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(ordering.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$1.$$colon$plus__O__scg_CanBuildFrom__O(references, this$12.ReusableCBFInstance$2))), b$1);
  jsx$6.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  return new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this$5.org$yaml$model$YDocument$WithComment$$sourceName$f), b.builder$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter.prototype.wrapDeclarations__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq = (function(emitters, ordering) {
  return emitters
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter.prototype.retrieveWebApi__p2__Lamf_plugins_domain_webapi_models_WebApi = (function() {
  var x1 = this.document$2;
  if ((x1 instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(x1);
    return $as_Lamf_plugins_domain_webapi_models_WebApi(x2.encodes__Lamf_core_model_domain_DomainElement())
  } else {
    var this$3 = this.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext().eh__Lamf_core_errorhandling_ErrorHandler();
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
    var node = this.document$2.id__T();
    var property = $m_s_None$();
    var this$1 = this.document$2;
    var lexical = this$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var this$2 = this.document$2;
    var location = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$2);
    this$3.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "BaseUnit doesn't encode a WebApi.", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    return new $c_Lamf_plugins_domain_webapi_models_WebApi().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(document, spec) {
  this.document$2 = document;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter.prototype.init___Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter.prototype.declares$1__p2__Lamf_core_model_document_Document__Lamf_core_emitter_SpecOrdering__sc_Seq = (function(doc$1, ordering$2) {
  return this.wrapDeclarations__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext($as_sc_Seq(doc$1.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().Declares$1)), ordering$2, this.document$2.references__sc_Seq(), this.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext()).emitters$1, ordering$2)
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser() {
  $c_O.call(this);
  this.UsageParser$module$1 = null;
  this.AnnotationTypesParser$module$1 = null;
  this.LinkedAnnotationTypeParser$module$1 = null;
  this.UserDocumentationParser$module$1 = null;
  this.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser.prototype.init___Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function(ctx) {
  this.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser.prototype.AnnotationTypesParser__Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser$ = (function() {
  if ((this.AnnotationTypesParser$module$1 === null)) {
    this.AnnotationTypesParser$lzycompute$1__p1__V()
  };
  return this.AnnotationTypesParser$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser.prototype.AnnotationTypesParser$lzycompute$1__p1__V = (function() {
  if ((this.AnnotationTypesParser$module$1 === null)) {
    this.AnnotationTypesParser$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser$().init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser(this)
  }
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas2SecuritySchemesEmitters() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemesEmitters.call(this);
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas2SecuritySchemesEmitters.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemesEmitters();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas2SecuritySchemesEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas2SecuritySchemesEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas2SecuritySchemesEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas2SecuritySchemesEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas2SecuritySchemesEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas2SecuritySchemesEmitters.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(securitySchemes, ordering, spec) {
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemesEmitters.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.call(this, securitySchemes, ordering, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas2SecuritySchemesEmitters.prototype.emitter__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter = (function(securityScheme, mappedType, ordering) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter().init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(securityScheme, mappedType, ordering, this.spec$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas2SecuritySchemesEmitters.prototype.key__T = (function() {
  return "securityDefinitions"
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas2SecuritySchemesEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas2SecuritySchemesEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.Oas2SecuritySchemesEmitters", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas2SecuritySchemesEmitters: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemesEmitters: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas2SecuritySchemesEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas2SecuritySchemesEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemesEmitters() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemesEmitters.call(this);
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemesEmitters.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemesEmitters();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemesEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemesEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemesEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemesEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemesEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemesEmitters.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(securitySchemes, ordering, spec) {
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemesEmitters.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.call(this, securitySchemes, ordering, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemesEmitters.prototype.emitter__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter = (function(securityScheme, mappedType, ordering) {
  return this.emitter__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter(securityScheme, mappedType, ordering)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemesEmitters.prototype.emitter__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter = (function(securityScheme, mappedType, ordering) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter().init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(securityScheme, mappedType, ordering, this.spec$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemesEmitters.prototype.key__T = (function() {
  return "securitySchemes"
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemesEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemesEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.Oas3SecuritySchemesEmitters", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemesEmitters: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemesEmitters: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemesEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemesEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OperationEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationEmitter.call(this);
  this.operation$2 = null;
  this.ordering$2 = null;
  this.endpointPayloadEmitted$2 = false;
  this.references$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OperationEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OperationEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OperationEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OperationEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OperationEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OperationEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OperationEmitter.prototype.operationPartEmitter__Lamf_core_emitter_PartEmitter = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter().init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_emitter_SpecOrdering__Z__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.operation$2, this.ordering$2, this.endpointPayloadEmitted$2, this.references$2, $as_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.spec$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OperationEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_emitter_SpecOrdering__Z__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(operation, ordering, endpointPayloadEmitted, references, spec) {
  this.operation$2 = operation;
  this.ordering$2 = ordering;
  this.endpointPayloadEmitted$2 = endpointPayloadEmitted;
  this.references$2 = references;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, operation, ordering, spec);
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OperationEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OperationEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.OperationEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OperationEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OperationEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OperationEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser() {
  $c_O.call(this);
  this.UsageParser$module$1 = null;
  this.UserDocumentationsParser$module$1 = null;
  this.AnnotationTypesParser$module$1 = null;
  this.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.prototype.init___Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(ctx) {
  this.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.prototype.AnnotationTypesParser__Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser$ = (function() {
  if ((this.AnnotationTypesParser$module$1 === null)) {
    this.AnnotationTypesParser$lzycompute$1__p1__V()
  };
  return this.AnnotationTypesParser$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.prototype.AnnotationTypesParser$lzycompute$1__p1__V = (function() {
  if ((this.AnnotationTypesParser$module$1 === null)) {
    this.AnnotationTypesParser$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser$().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.prototype.nestedTypeOrSchema__Lorg_yaml_model_YMap__s_Option = (function(map) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("type");
  var x1 = (this$2.isEmpty__Z() ? new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("schema") : this$2);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var n = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    var this$4 = n.value$2;
    var x = this$4.tag__Lorg_yaml_model_YTag().tagType$3;
    var x$2 = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x === x$2)) {
      var this$5 = n.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = this.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f;
      return this.nestedTypeOrSchema__Lorg_yaml_model_YMap__s_Option($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv)))
    }
  };
  return x1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.prototype.typeOrSchema__Lorg_yaml_model_YMap__s_Option = (function(map) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("type");
  return (this$2.isEmpty__Z() ? new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("schema") : this$2)
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser$() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser$.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser$.prototype.apply__Lorg_yaml_model_YMapEntry__F1__Lamf_core_model_domain_extensions_CustomDomainProperty = (function(ast, adopt) {
  var this$1 = ast.value$2;
  var x1 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var jsx$2 = this.$$outer$1;
    var this$2 = ast.key$2;
    var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv = this.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f;
    var jsx$1 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv)).text$3;
    var this$3 = ast.value$2;
    var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$1 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f;
    return new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser__Lorg_yaml_model_YPart__T__Lorg_yaml_model_YMap__F1(jsx$2, ast, jsx$1, $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion$1, iv$1)), adopt).parse__Lamf_core_model_domain_extensions_CustomDomainProperty()
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Seq$1;
    if ((x$3 === x1)) {
      var domainProp = $m_Lamf_core_model_domain_extensions_CustomDomainProperty$().apply__Lorg_yaml_model_YPart__Lamf_core_model_domain_extensions_CustomDomainProperty(ast);
      adopt.apply__O__O(domainProp);
      var this$4 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidAnnotationType$1;
      var node = domainProp.id$1;
      var ast$1 = ast.value$2;
      var prop = $m_s_None$();
      var l = ast$1.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$4, specification, node, prop, "Invalid value type for annotation types parser, expected map or scalar reference", l);
      return domainProp
    } else {
      var this$5 = ast.key$2;
      var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$2 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f;
      var key = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion$2, iv$2)).text$3;
      var this$6 = ast.value$2;
      var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$3 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f;
      var scalar = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion$3, iv$3));
      var domainProp$2 = $m_Lamf_core_model_domain_extensions_CustomDomainProperty$().apply__Lorg_yaml_model_YPart__Lamf_core_model_domain_extensions_CustomDomainProperty(ast);
      adopt.apply__O__O(domainProp$2);
      var x1$2 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().findAnnotation__T__Lamf_core_parser_SearchScope$Scope__s_Option(scalar.text$3, $m_Lamf_core_parser_SearchScope$All$());
      if ((x1$2 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1$2);
        var a = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(x2.value$2);
        var label = scalar.text$3;
        var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
        var copied = $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(a, label, annotations));
        copied.id$1 = null;
        $m_Lamf_core_parser_Annotations$();
        var a$1 = new $c_Lamf_core_parser_Annotations().init___();
        adopt.apply__O__O($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(copied, key, a$1));
        return copied
      } else {
        var x1$3 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(ast, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, domainProp$2$1) {
          return (function(shape$2) {
            var shape = $as_Lamf_core_model_domain_Shape(shape$2);
            shape.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(domainProp$2$1.id$1, shape.adopted$default$2__sc_Seq())
          })
        })(this, domainProp$2)), new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo().init___Z__Z(true, false), $m_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$(), this.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f).parse__s_Option();
        if ((x1$3 instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(x1$3);
          var schema = $as_Lamf_core_model_domain_Shape(x2$2.value$2);
          $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(schema, domainProp$2.id$1, $m_s_None$());
          var field = $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Schema$1;
          return $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(domainProp$2, field, schema))
        } else {
          var this$10 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f.eh$1;
          var specification$1 = $m_Lamf_plugins_features_validation_CoreValidations$().DeclarationNotFound$1;
          var node$1 = domainProp$2.id$1;
          var prop$1 = $m_s_None$();
          var l$1 = scalar.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$10, specification$1, node$1, prop$1, "Could not find declared annotation link in references", l$1);
          return domainProp$2
        }
      }
    }
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlSpecParser$AnnotationTypesParser$", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser$: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser$;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage() {
  $c_Lamf_core_resolution_stages_ReferenceResolutionStage.call(this);
  this.errorHandler$3 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage.prototype = new $h_Lamf_core_resolution_stages_ReferenceResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage.prototype.errorHandler__Lamf_core_errorhandling_ErrorHandler = (function() {
  return this.errorHandler$3
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage.prototype.customDomainElementTransformation__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(domain$2, source$2) {
      var domain = $as_Lamf_core_model_domain_DomainElement(domain$2);
      var source = $as_Lamf_core_model_domain_Linkable(source$2);
      if ((source instanceof $c_Lamf_plugins_domain_webapi_models_Response)) {
        var x2 = $as_Lamf_plugins_domain_webapi_models_Response(source);
        if ((domain instanceof $c_Lamf_plugins_domain_webapi_models_Response)) {
          var x2$2 = $as_Lamf_plugins_domain_webapi_models_Response(domain);
          if ($as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1)).option$1.isDefined__Z()) {
            var copy = $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_Linkable__copyElement__Lamf_core_model_domain_Linkable(x2$2));
            var this$3 = $as_Lamf_plugins_domain_webapi_models_Response(copy.withId__T__Lamf_core_model_domain_AmfObject(x2.id$1));
            var this$1 = $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1));
            var this$2 = this$1.option$1;
            var statusCode = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
            var field = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1;
            return $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$3, field, statusCode))
          }
        };
        if ((domain instanceof $c_Lamf_plugins_domain_webapi_models_Message)) {
          var x3 = $as_Lamf_plugins_domain_webapi_models_Message(domain);
          var x = x3.meta__Lamf_core_metamodel_Obj();
          var x$2 = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$();
          if (((x !== null) && (x === x$2))) {
            var arg1 = x3.fields__Lamf_core_parser_Fields().copy__Lamf_core_parser_Fields();
            var this$4 = x3.annotations__Lamf_core_parser_Annotations();
            var arg2 = $m_Lamf_core_parser_Annotations$().apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(this$4);
            var copy$1 = new $c_Lamf_plugins_domain_webapi_models_Response().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(arg1, arg2);
            var value = x2.id$1;
            return $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(copy$1, value))
          }
        };
        return domain
      };
      if ((source instanceof $c_Lamf_plugins_domain_webapi_models_Request)) {
        var x3$2 = $as_Lamf_plugins_domain_webapi_models_Request(source);
        if ((domain instanceof $c_Lamf_plugins_domain_webapi_models_Message)) {
          var x2$3 = $as_Lamf_plugins_domain_webapi_models_Message(domain);
          var x$3 = x2$3.meta__Lamf_core_metamodel_Obj();
          var x$4 = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$();
          if (((x$3 !== null) && (x$3 === x$4))) {
            var arg1$1 = x2$3.fields__Lamf_core_parser_Fields().copy__Lamf_core_parser_Fields();
            var this$6 = x2$3.annotations__Lamf_core_parser_Annotations();
            var arg2$1 = $m_Lamf_core_parser_Annotations$().apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(this$6);
            var copy$2 = new $c_Lamf_plugins_domain_webapi_models_Request().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(arg1$1, arg2$1);
            var value$1 = x3$2.id$1;
            return $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(copy$2, value$1))
          }
        };
        return domain
      };
      if ((source instanceof $c_Lamf_plugins_domain_webapi_models_Parameter)) {
        var x4 = $as_Lamf_plugins_domain_webapi_models_Parameter(source);
        if ($as_Lamf_core_model_StrField(x4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1)).option$1.isDefined__Z()) {
          if ((domain instanceof $c_Lamf_plugins_domain_webapi_models_Parameter)) {
            var x2$4 = $as_Lamf_plugins_domain_webapi_models_Parameter(domain);
            var x$5 = $as_Lamf_core_model_StrField(x4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1)).option$1;
            var x$6 = $as_Lamf_core_model_StrField(x2$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1)).option$1;
            if ((!((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6)))) {
              var copy$2$1 = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_Linkable__copyElement__Lamf_core_model_domain_Linkable(x2$4));
              var qual$1 = $as_Lamf_plugins_domain_webapi_models_Parameter(copy$2$1.withId__T__Lamf_core_model_domain_AmfObject(x4.id$1));
              var this$8 = $as_Lamf_core_model_StrField(x4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
              var this$9 = this$8.option$1;
              var x$1 = $as_T((this$9.isEmpty__Z() ? null : this$9.get__O()));
              $m_Lamf_core_parser_Annotations$();
              var x$2$2 = new $c_Lamf_core_parser_Annotations().init___();
              return $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, x$1, x$2$2)
            } else {
              return domain
            }
          } else {
            return domain
          }
        }
      };
      return domain
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage.prototype.init___Z__Lamf_core_errorhandling_ErrorHandler = (function(keepEditingInfo, errorHandler) {
  this.errorHandler$3 = errorHandler;
  $c_Lamf_core_resolution_stages_ReferenceResolutionStage.prototype.init___Z__Lamf_core_errorhandling_ErrorHandler.call(this, keepEditingInfo, errorHandler);
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.WebApiReferenceResolutionStage", {
  Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage: 1,
  Lamf_core_resolution_stages_ReferenceResolutionStage: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1,
  Lamf_core_resolution_stages_elements_resolution_ElementResolutionStage: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_WebApiReferenceResolutionStage;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeRequiredFieldImplicitForOptionalProperties() {
  $c_Lamf_core_resolution_stages_ResolutionStage.call(this);
  this.m$2 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeRequiredFieldImplicitForOptionalProperties.prototype = new $h_Lamf_core_resolution_stages_ResolutionStage();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeRequiredFieldImplicitForOptionalProperties.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeRequiredFieldImplicitForOptionalProperties;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeRequiredFieldImplicitForOptionalProperties() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeRequiredFieldImplicitForOptionalProperties.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeRequiredFieldImplicitForOptionalProperties.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeRequiredFieldImplicitForOptionalProperties.prototype.transform__Lamf_core_model_domain_DomainElement__Z__s_Option = (function(element, isCycle) {
  if ((element instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_NodeShape(element);
    var this$1 = $m_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ImplicitRequiredTransformer$();
    return this$1.transform__Lamf_plugins_domain_shapes_models_NodeShape__s_Option(x2)
  } else {
    return new $c_s_Some().init___O(element)
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeRequiredFieldImplicitForOptionalProperties.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit = (function(model) {
  this.m$2 = new $c_s_Some().init___O(model);
  return model.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit($m_Lamf_core_resolution_stages_selectors_NodeShapeSelector$(), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(element$2, isCycle$2) {
      var element = $as_Lamf_core_model_domain_DomainElement(element$2);
      var isCycle = $uZ(isCycle$2);
      return $this.transform__Lamf_core_model_domain_DomainElement__Z__s_Option(element, isCycle)
    })
  })(this)), this.errorHandler$1)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeRequiredFieldImplicitForOptionalProperties.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(errorHandler) {
  $c_Lamf_core_resolution_stages_ResolutionStage.prototype.init___Lamf_core_errorhandling_ErrorHandler.call(this, errorHandler);
  this.m$2 = $m_s_None$();
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeRequiredFieldImplicitForOptionalProperties = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeRequiredFieldImplicitForOptionalProperties: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.MakeRequiredFieldImplicitForOptionalProperties", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeRequiredFieldImplicitForOptionalProperties: 1,
  Lamf_core_resolution_stages_ResolutionStage: 1,
  O: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_resolution_stages_elements_resolution_ElementResolutionStage: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeRequiredFieldImplicitForOptionalProperties.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MakeRequiredFieldImplicitForOptionalProperties;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$() {
  $c_O.call(this);
  this.result$1 = null;
  this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$.prototype = $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$.prototype;
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$.prototype.result$lzycompute__p1__sc_Seq = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    var jsx$53 = this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result__sc_Seq();
    var jsx$52 = $m_sc_Seq$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns, "WebAPI");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var x$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$1, "version");
    var x$3 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
    var x$7 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$2 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$9 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$2, "path");
    var x$10 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$51 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$7, "", x$1, x$2, x$9, x$3, "1", "API version is mandatory", "Info object 'version' is mandatory", x$10);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$3 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$11 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$3, "HttpMessageBinding");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$4 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$12 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$4, "headers");
    var x$13 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("mandatory-header-name-pattern");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$5 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    var x$14 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$5, "mandatoryHeaderBindingNamePattern");
    var x$17 = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$6 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$19 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$6, "path");
    var jsx$50 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$13, "", x$11, x$12, x$19, x$14, "0", "Header name must comply RFC-7230", "Header name must comply RFC-7230", x$17);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$7 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var x$22 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$7, "CreativeWork");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$8 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var x$23 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$8, "url");
    var x$24 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
    var x$26 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$9 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$27 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$9, "path");
    var x$30 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$49 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$26, "Documentation 'url' field is mandatory", x$22, x$23, x$27, x$24, "1", "", "", x$30);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$10 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var x$32 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$10, "License");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$11 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var x$33 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$11, "name");
    var x$34 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
    var x$36 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$12 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$37 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$12, "path");
    var x$40 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$48 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$36, "License 'name' is mandatory", x$32, x$33, x$37, x$34, "1", "", "", x$40);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var name = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().doc$1.displayName$1;
    var ns$13 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$42 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$13, name);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$14 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var x$43 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$14, "name");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$15 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$44 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$15, "pattern");
    var this$44 = new $c_sci_StringOps().init___T("^[A-Za-z0-9_\\-]+$");
    var x$45 = $f_sci_StringLike__stripMargin__C__T(this$44, 124);
    var x$46 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$16 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$47 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$16, "path");
    var x$50 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$47 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$46, "Parameter name must comply with regex '^[A-Za-z0-9_\\-]+$'", x$42, x$43, x$47, x$44, x$45, "", "", x$50);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$17 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$52 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$17, "Server");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$18 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var x$53 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$18, "name");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$19 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$54 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$19, "pattern");
    var this$57 = new $c_sci_StringOps().init___T("^[A-Za-z0-9_\\-]+$");
    var x$55 = $f_sci_StringLike__stripMargin__C__T(this$57, 124);
    var x$56 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$20 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$57 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$20, "path");
    var x$60 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$46 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$56, "Server name must comply with regex '^[A-Za-z0-9_\\-]+$'", x$52, x$53, x$57, x$54, x$55, "", "", x$60);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$21 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$62 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$21, "Server");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$22 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$63 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$22, "protocol");
    var x$64 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
    var x$66 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$23 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$67 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$23, "path");
    var x$70 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$45 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$66, "Server 'protocol' field is mandatory", x$62, x$63, x$67, x$64, "1", "", "", x$70);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$24 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$72 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$24, "HttpApiKeySettings");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$25 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var x$73 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$25, "name");
    var x$74 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
    var x$76 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$26 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$77 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$26, "path");
    var x$80 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$44 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$76, "'name' field is mandatory in httpApiKey security scheme", x$72, x$73, x$77, x$74, "1", "", "", x$80);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$27 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var x$82 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$27, "CorrelationId");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$28 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var x$83 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$28, "location");
    var x$84 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
    var x$86 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$29 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$87 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$29, "path");
    var x$90 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$43 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$86, "'location' field is mandatory in CorrelationId", x$82, x$83, x$87, x$84, "1", "", "", x$90);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$30 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$92 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$30, "HttpApiKeySettings");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$31 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$93 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$31, "in");
    var x$94 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
    var x$96 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$32 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$97 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$32, "path");
    var x$100 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$42 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$96, "'in' field is mandatory in ApiKey scheme", x$92, x$93, x$97, x$94, "1", "", "", x$100);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$33 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$102 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$33, "ApiKeySettings");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$34 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$103 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$34, "in");
    var x$104 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
    var x$106 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$35 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$107 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$35, "path");
    var x$110 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$41 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$106, "'in' field is mandatory in HttpApiKey scheme", x$102, x$103, x$107, x$104, "1", "", "", x$110);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$36 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$112 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$36, "HttpApiKeySettings");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$37 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$113 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$37, "in");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$38 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$114 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$38, "pattern");
    var x$116 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$39 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$117 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$39, "path");
    var x$120 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$40 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$116, "Invalid 'in' value. The options are: query, header or cookie", x$112, x$113, x$117, x$114, "^(query|header|cookie)$", "", "", x$120);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$40 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$122 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$40, "ApiKeySettings");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$41 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$123 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$41, "in");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$42 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$124 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$42, "pattern");
    var x$126 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$43 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$127 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$43, "path");
    var x$130 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$39 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$126, "Invalid 'in' value. The options are: user or password", x$122, x$123, x$127, x$124, "^(user|password)$", "", "", x$130);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$44 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$132 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$44, "HttpSettings");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$45 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$133 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$45, "scheme");
    var x$134 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
    var x$136 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$46 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$137 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$46, "path");
    var x$140 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$38 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$136, "'scheme' field is mandatory in http security scheme", x$132, x$133, x$137, x$134, "1", "", "", x$140);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$47 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$141 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$47, "WebSocketsChannelBinding");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$48 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$142 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$48, "method");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$49 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$143 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$49, "in");
    var x$146 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$50 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$148 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$50, "path");
    var x$150 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$37 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$146, "", x$141, x$142, x$148, x$143, "GET,POST", "", "'method' for channel binding object must be one of 'GET' or 'POST'", x$150);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$51 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$151 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$51, "MqttOperationBinding");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$52 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$152 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$52, "qos");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$53 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$153 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$53, "pattern");
    var x$156 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$54 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$158 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$54, "path");
    var x$160 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$36 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$156, "", x$151, x$152, x$158, x$153, "^[0-2]$", "", "'qos' for mqtt operation binding object must be one of 0, 1 or 2", x$160);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$55 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$161 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$55, "Amqp091ChannelBinding");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$56 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$162 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$56, "is");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$57 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$163 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$57, "in");
    var x$166 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$58 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$168 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$58, "path");
    var x$170 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$35 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$166, "", x$161, x$162, x$168, x$163, "routingKey,queue", "", "'is' for amqp 0.9.1 channel binding object must be one of 'queue' or 'routingKey'", x$170);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$59 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$171 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$59, "Amqp091ChannelExchange");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$60 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$172 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$60, "type");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$61 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$173 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$61, "in");
    var x$176 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$62 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$178 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$62, "path");
    var x$180 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$34 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$176, "", x$171, x$172, x$178, x$173, "topic,direct,fanout,default,headers", "", "'type' for amqp 0.9.1 channel exchange object must be one of 'topic', 'direct', 'fanout', 'default' or 'headers'", x$180);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$63 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$181 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$63, "HttpOperationBinding");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$64 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$182 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$64, "method");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$65 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$183 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$65, "in");
    var x$186 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$66 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$188 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$66, "path");
    var x$190 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$33 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$186, "", x$181, x$182, x$188, x$183, "GET,POST,PUT,PATCH,DELETE,HEAD,OPTIONS,CONNECT,TRACE", "", "'method' for http operation binding object must be one of 'GET','POST','PUT','PATCH','DELETE','HEAD','OPTIONS','CONNECT','TRACE'", x$190);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$67 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$191 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$67, "HttpOperationBinding");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$68 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$192 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$68, "operationType");
    var x$193 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
    var x$196 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$69 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$198 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$69, "path");
    var x$200 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$32 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$196, "", x$191, x$192, x$198, x$193, "1", "", "'type' for http operation binding is required", x$200);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$70 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$201 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$70, "Amqp091ChannelExchange");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$71 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$202 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$71, "name");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$72 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$203 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$72, "maxLength");
    var x$206 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$73 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$208 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$73, "path");
    var x$210 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$31 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$206, "", x$201, x$202, x$208, x$203, "255", "", "'type' for http operation binding is required", x$210);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$74 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$211 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$74, "Amqp091ChannelExchange");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$75 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var x$212 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$75, "name");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$76 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$213 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$76, "maxLength");
    var x$216 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$77 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$218 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$77, "path");
    var x$220 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$30 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$216, "", x$211, x$212, x$218, x$213, "255", "", "Amqp channel binding name can't be longer than 255 characters", x$220);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$78 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$221 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$78, "Amqp091ChannelQueue");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$79 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var x$222 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$79, "name");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$80 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$223 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$80, "maxLength");
    var x$226 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$81 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$228 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$81, "path");
    var x$230 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$29 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$226, "", x$221, x$222, x$228, x$223, "255", "", "Amqp channel binding name can't be longer than 255 characters", x$230);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$82 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$231 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$82, "HttpOperationBinding");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$83 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$232 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$83, "operationType");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$84 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$233 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$84, "pattern");
    var this$243 = new $c_sci_StringOps().init___T("^(request|response)$");
    var x$234 = $f_sci_StringLike__stripMargin__C__T(this$243, 124);
    var x$236 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$85 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$238 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$85, "path");
    var x$240 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$28 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$236, "", x$231, x$232, x$238, x$233, x$234, "", "Http operation binding must be either 'request' or 'response'", x$240);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$86 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$241 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$86, "Amqp091ChannelExchange");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$87 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$242 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$87, "name");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$88 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$243 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$88, "pattern");
    var this$256 = new $c_sci_StringOps().init___T("^(request|response)$");
    var x$244 = $f_sci_StringLike__stripMargin__C__T(this$256, 124);
    var x$246 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$89 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$248 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$89, "path");
    var x$250 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$27 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$246, "", x$241, x$242, x$248, x$243, x$244, "", "Http operation binding must be either 'request' or 'response'", x$250);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$90 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$251 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$90, "MqttServerBinding");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$91 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$252 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$91, "keepAlive");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$92 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$253 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$92, "minInclusive");
    var x$255 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$93 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$257 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$93, "path");
    var x$260 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$26 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$255, "", x$251, x$252, x$257, x$253, "0", "", "'keepAlive' must be greater than 0", x$260);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$94 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$261 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$94, "MqttServerLastWill");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$95 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$262 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$95, "qos");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$96 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$263 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$96, "pattern");
    var x$266 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$97 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$268 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$97, "path");
    var x$270 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$25 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$266, "", x$261, x$262, x$268, x$263, "^[0-2]$", "", "'qos' for mqtt server binding last will object must be one of 0, 1 or 2", x$270);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$98 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$271 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$98, "Amqp091OperationBinding");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$99 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$272 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$99, "deliveryMode");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$100 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$273 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$100, "pattern");
    var x$276 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$101 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$278 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$101, "path");
    var x$280 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$24 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$276, "", x$271, x$272, x$278, x$273, "^[1-2]$", "", "'deliveryMode' for amqp 0.9.1 operation binding object must be one of 1 or 2", x$280);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$102 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$281 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$102, "Amqp091OperationBinding");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$103 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$282 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$103, "expiration");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$104 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$283 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$104, "pattern");
    var x$286 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$105 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$288 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$105, "path");
    var x$290 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$23 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$286, "", x$281, x$282, x$288, x$283, "^[0-9]+(.[0-9]+)?$", "", "'expiration' for amqp 0.9.1 operation binding object must greather than or equal to 0", x$290);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$106 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$291 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$106, "MqttServerLastWill");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$107 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$292 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$107, "qos");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$108 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$293 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$108, "pattern");
    var x$296 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$109 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$298 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$109, "path");
    var x$300 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$22 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$296, "", x$291, x$292, x$298, x$293, "^[0-2]$", "", "'qos' for mqtt server last will binding object must be one 0, 1 or 2", x$300);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$110 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$301 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$110, "MqttServerBinding");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$111 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$302 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$111, "expiration");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$112 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$303 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$112, "minInclusive");
    var x$305 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$113 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$307 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$113, "path");
    var x$310 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$21 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$305, "", x$301, x$302, x$307, x$303, "0", "", "'expiration' must be greater than 0", x$310);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$114 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$312 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$114, "SecurityScheme");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$115 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$313 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$115, "settings");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$116 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    var x$314 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$116, "requiredFlowsInOAuth2");
    var x$315 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$117 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$316 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$117, "path");
    var x$320 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$20 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$315, "'flows' field is mandatory in OAuth2 security scheme", x$312, x$313, x$316, x$314, "0", "", "", x$320);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$118 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$322 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$118, "SecurityScheme");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$119 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$323 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$119, "settings");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$120 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    var x$324 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$120, "requiredOpenIdConnectUrl");
    var x$325 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$121 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$326 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$121, "path");
    var x$330 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$19 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$325, "'openIdConnectUrl' field is mandatory in openIdConnect security scheme", x$322, x$323, x$326, x$324, "0", "", "", x$330);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$122 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$332 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$122, "WebSocketsChannelBinding");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$123 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$333 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$123, "query");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$124 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    var x$334 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$124, "mandatoryQueryObjectNodeWithPropertiesFacet");
    var x$335 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$125 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$336 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$125, "path");
    var x$340 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$18 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$335, "'query' property of ws channel binding must be of type object and have properties", x$332, x$333, x$336, x$334, "0", "", "", x$340);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$126 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$342 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$126, "WebSocketsChannelBinding");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$127 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$343 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$127, "headers");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$128 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    var x$344 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$128, "mandatoryHeadersObjectNodeWithPropertiesFacet");
    var x$345 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$129 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$346 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$129, "path");
    var x$350 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$17 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$345, "'headers' property of ws channel binding must be of type object and have properties", x$342, x$343, x$346, x$344, "0", "", "", x$350);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$130 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$352 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$130, "HttpMessageBinding");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$131 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$353 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$131, "headers");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$132 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    var x$354 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$132, "mandatoryHeadersObjectNodeWithPropertiesFacet");
    var x$355 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$133 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$356 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$133, "path");
    var x$360 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$16 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$355, "'headers' property of ws channel binding must be of type object and have properties", x$352, x$353, x$356, x$354, "0", "", "", x$360);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$134 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$362 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$134, "HttpOperationBinding");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$135 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
    var x$363 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$135, "query");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$136 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    var x$364 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$136, "mandatoryQueryObjectNodeWithPropertiesFacet");
    var x$365 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$137 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$366 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$137, "path");
    var x$370 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$15 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$365, "'headers' property of ws channel binding must be of type object and have properties", x$362, x$363, x$366, x$364, "0", "", "", x$370);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$138 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var x$372 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$138, "CorrelationId");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$139 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var x$373 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$139, "location");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$140 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    var x$374 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$140, "validCorrelationIdLocation");
    var x$375 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$141 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$376 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$141, "path");
    var x$380 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$14 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$375, "Does not comply with runtime expression ABNF syntax", x$372, x$373, x$376, x$374, "0", "", "", x$380);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var name$1 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().doc$1.displayName$1;
    var ns$142 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$382 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$142, name$1);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$143 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$383 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$143, "binding");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$144 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    var x$384 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$144, "validParameterLocation");
    var x$385 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$145 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$386 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$145, "path");
    var x$390 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$13 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$385, "Does not comply with runtime expression ABNF syntax", x$382, x$383, x$386, x$384, "0", "", "", x$390);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$146 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$392 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$146, "Message");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$147 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$393 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$147, "headers");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$148 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    var x$394 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$148, "mandatoryHeadersObjectNode");
    var x$395 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$149 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$396 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$149, "path");
    var x$400 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$12 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$395, "Message headers must be of type object", x$392, x$393, x$396, x$394, "0", "", "", x$400);
    var x$401 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("uri-query-param");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$150 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$403 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$150, "EndPoint");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$151 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$404 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$151, "path");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$152 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$405 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$152, "pattern");
    var this$434 = new $c_sci_StringOps().init___T("^(?!(.*\\?.*=.*)$).*$");
    var x$406 = $f_sci_StringLike__stripMargin__C__T(this$434, 124);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$153 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$407 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$153, "path");
    var x$410 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$11 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$401, "Query parameters must not be defined in uri, use bindings instead", x$403, x$404, x$407, x$405, x$406, "", "", x$410);
    var x$411 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("uri-fragment");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$154 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$413 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$154, "EndPoint");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$155 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$414 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$155, "path");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$156 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$415 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$156, "pattern");
    var this$446 = new $c_sci_StringOps().init___T("^(?!(.*#.+)$).*$");
    var x$416 = $f_sci_StringLike__stripMargin__C__T(this$446, 124);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$157 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$417 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$157, "path");
    var x$420 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$10 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$411, "Fragments must not be defined in uri", x$413, x$414, x$417, x$415, x$416, "", "", x$420);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$158 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var owlClass = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$158, "Organization");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$159 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var owlProperty = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$159, "email");
    var jsx$9 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$GenericValidations__emailValidation__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(this, owlClass, owlProperty);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$160 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var owlClass$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$160, "Organization");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$161 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var owlProperty$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$161, "url");
    var jsx$8 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$GenericValidations__urlValidation__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(this, owlClass$1, owlProperty$1);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$162 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var owlClass$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$162, "License");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$163 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var owlProperty$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$163, "url");
    var jsx$7 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$GenericValidations__urlValidation__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(this, owlClass$2, owlProperty$2);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$164 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var owlClass$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$164, "WebAPI");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$165 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var owlProperty$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$165, "termsOfService");
    var jsx$6 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$GenericValidations__urlValidation__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(this, owlClass$3, owlProperty$3);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$166 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var owlClass$4 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$166, "WebAPI");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$167 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var owlProperty$4 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$167, "identifier");
    var jsx$5 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$GenericValidations__uriValidation__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(this, owlClass$4, owlProperty$4);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$168 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var owlClass$5 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$168, "CreativeWork");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$169 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var owlProperty$5 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$169, "url");
    var jsx$4 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$GenericValidations__urlValidation__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(this, owlClass$5, owlProperty$5);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$170 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var owlClass$6 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$170, "OAuth2Flow");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$171 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var owlProperty$6 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$171, "authorizationUri");
    var jsx$3 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$GenericValidations__urlValidation__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(this, owlClass$6, owlProperty$6);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$172 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var owlClass$7 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$172, "OAuth2Flow");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$173 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var owlProperty$7 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$173, "accessTokenUri");
    var jsx$2 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$GenericValidations__urlValidation__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(this, owlClass$7, owlProperty$7);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$174 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var owlClass$8 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$174, "OAuth2Flow");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$175 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var owlProperty$8 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$175, "refreshUri");
    var array = [jsx$51, jsx$50, jsx$49, jsx$48, jsx$47, jsx$46, jsx$45, jsx$44, jsx$43, jsx$42, jsx$41, jsx$40, jsx$39, jsx$38, jsx$37, jsx$36, jsx$35, jsx$34, jsx$33, jsx$32, jsx$31, jsx$30, jsx$29, jsx$28, jsx$27, jsx$26, jsx$25, jsx$24, jsx$23, jsx$22, jsx$21, jsx$20, jsx$19, jsx$18, jsx$17, jsx$16, jsx$15, jsx$14, jsx$13, jsx$12, jsx$11, jsx$10, jsx$9, jsx$8, jsx$7, jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$GenericValidations__urlValidation__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(this, owlClass$8, owlProperty$8)];
    var jsx$1 = jsx$52.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$489 = $m_sc_Seq$();
    this.result$1 = $as_sc_Seq(jsx$53.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$489.ReusableCBFInstance$2));
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.result$1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result__sc_Seq = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$lzycompute__p1__sc_Seq() : this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1)
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$lzycompute__p1__sc_Seq = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfProfileValidations__amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result__sc_Seq(this);
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$.prototype.result__p1__sc_Seq = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.result$lzycompute__p1__sc_Seq() : this.result$1)
});
var $d_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$: 0
}, false, "amf.plugins.document.webapi.validation.AMFRawValidations$Async20Validations$", {
  Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfProfileValidations: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$ProfileValidations: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$GenericValidations: 1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$;
var $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$)) {
    $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$ = new $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$Async20Validations$
}
function $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$OasValidations__amf$plugins$document$webapi$validation$AMFRawValidations$OasValidations$$result__sc_Seq($thiz) {
  var jsx$16 = $thiz.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result__sc_Seq();
  var jsx$15 = $m_sc_Seq$();
  var x$1 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("mandatory-api-version");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns, "WebAPI");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$4 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$1, "version");
  var x$5 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$2 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$9 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$2, "path");
  var x$10 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$14 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$1, "Missing madatory Swagger / info / version", x$3, x$4, x$9, x$5, "1", "API Version is Mandatory", "Version is mandatory in Info object", x$10);
  var x$11 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("openapi-schemes");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$3 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$13 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$3, "WebAPI");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$4 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$14 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$4, "scheme");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$5 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$15 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$5, "in");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$6 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$19 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$6, "path");
  var x$20 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$13 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$11, "Protocols property must be http,https,ws,wss", x$13, x$14, x$19, x$15, "http,https,ws,wss", "Protocols must match a value http, https, ws or wss", "Swagger object 'schemes' property must have a value matching http, https, ws or wss", x$20);
  var x$21 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("mandatory-external-doc-url");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$7 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$23 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$7, "CreativeWork");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$8 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$24 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$8, "url");
  var x$25 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$9 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$29 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$9, "path");
  var x$30 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$12 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$21, "Swagger external-doc element without URL", x$23, x$24, x$29, x$25, "1", "Documentation URL is mandatory in API external documentation", "URL is mandatory in External Documentation object", x$30);
  var x$31 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("mandatory-license-name");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$10 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$33 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$10, "License");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$11 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$34 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$11, "name");
  var x$35 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$12 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$39 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$12, "path");
  var x$40 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$11 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$31, "Swagger License node without name", x$33, x$34, x$39, x$35, "1", "License name is mandatory if license information is included", "Name is mandatory in License object", x$40);
  var x$41 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("empty-responses");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$13 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$43 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$13, "Operation");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$14 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$44 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$14, "returns");
  var x$45 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$15 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$49 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$15, "path");
  var x$50 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$10 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$41, "No responses declared", x$43, x$44, x$49, x$45, "1", "Responses array cannot be empty", "Responses cannot be empty", x$50);
  var x$51 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("empty-enum");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$16 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$53 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$16, "Shape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$17 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$54 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$17, "in");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$18 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$55 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$18, "node");
  var x$56 = $as_Lamf_core_vocabulary_ValueType($m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("NonEmptyList").get__O()).iri__T();
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$19 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$59 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$19, "path");
  var x$60 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$9 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$51, "Enum in types cannot be empty", x$53, x$54, x$59, x$55, x$56, "Property 'enum' must have at least one value", "Property 'enum' for a Schema object must have at least one value", x$60);
  var x$61 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("array-shape-items-mandatory");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$20 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$63 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$20, "ArrayShape");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$21 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$64 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$21, "items");
  var x$65 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$22 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$69 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$22, "path");
  var x$70 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$8 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$61, "Declaration of the type of the items for an array is required", x$63, x$64, x$69, x$65, "1", "items facet of RAML Array type is required", "items property of Schema objects of type 'array' is required", x$70);
  var x$71 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("path-parameter-required");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var name = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().doc$1.displayName$1;
  var ns$23 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$73 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$23, name);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$24 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$74 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$24, "binding");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$25 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$75 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$25, "pathParameterRequiredProperty");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$26 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$76 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$26, "path");
  var x$80 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$7 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$71, "Path parameters must have the required property set to true", x$73, x$74, x$76, x$75, "0", "", "", x$80);
  var x$81 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("file-parameter-in-form-data");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var name$1 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().doc$1.displayName$1;
  var ns$27 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$83 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$27, name$1);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$28 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$84 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$28, "schema");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$29 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var x$85 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$29, "fileParameterMustBeInFormData");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$30 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$86 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$30, "path");
  var x$90 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$6 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$81, "Parameter of type file must set property 'in' to formData", x$83, x$84, x$86, x$85, "0", "", "", x$90);
  var x$91 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("description-is-required-in-response");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$31 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$93 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$31, "Response");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$32 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$94 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$32, "description");
  var x$95 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$33 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$98 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$33, "path");
  var x$100 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  var jsx$5 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$91, "Description must be defined in a response", x$93, x$94, x$98, x$95, "1", "", "Response must have a 'description' field", x$100);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$34 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var owlClass = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$34, "Organization");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$35 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var owlProperty = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$35, "email");
  var jsx$4 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$GenericValidations__emailValidation__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation($thiz, owlClass, owlProperty);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$36 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var owlClass$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$36, "License");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$37 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var owlProperty$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$37, "url");
  var jsx$3 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$GenericValidations__urlValidation__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation($thiz, owlClass$1, owlProperty$1);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$38 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var owlClass$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$38, "Organization");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$39 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var owlProperty$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$39, "url");
  var jsx$2 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$GenericValidations__urlValidation__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation($thiz, owlClass$2, owlProperty$2);
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$40 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var owlClass$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$40, "CreativeWork");
  $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
  var ns$41 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var owlProperty$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$41, "url");
  var array = [jsx$14, jsx$13, jsx$12, jsx$11, jsx$10, jsx$9, jsx$8, jsx$7, jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$GenericValidations__urlValidation__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation($thiz, owlClass$3, owlProperty$3)];
  var jsx$1 = jsx$15.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
  var this$107 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$16.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$107.ReusableCBFInstance$2))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$() {
  $c_O.call(this);
  this.ID$1 = null;
  this.payloadMediaType$1 = null;
  this.defaultCtx$1 = null
}
$c_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$.prototype = $c_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$.prototype;
$c_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$ = this;
  this.ID$1 = "AMF Payload Validation";
  var jsx$1 = $m_sc_Seq$();
  var array = ["application/json", "application/yaml", "text/vnd.yaml"];
  this.payloadMediaType$1 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  var jsx$2 = $m_sci_Nil$();
  var x$1 = new $c_Lamf_client_parse_DefaultParserErrorHandler().init___I($m_Lamf_core_AMFCompilerRunCount$().nextRun__I());
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$7 = new $c_scm_ListBuffer().init___();
  var x$3 = this$7.toList__sci_List();
  var x$4 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$14 = new $c_scm_ListBuffer().init___();
  var x$5 = new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$14.toList__sci_List());
  this.defaultCtx$1 = new $c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions("", jsx$2, new $c_Lamf_core_parser_ParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext("", x$3, x$4, x$1, x$5), $m_s_None$(), $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2, new $c_Lamf_core_client_ParsingOptions().init___());
  return this
});
$c_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$.prototype.init__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  return $m_s_concurrent_Future$().successful__O__s_concurrent_Future(this)
});
$c_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$.prototype.validator__Lamf_core_model_domain_Shape__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__Lamf_core_validation_PayloadValidator = (function(s, env, validationMode) {
  return new $c_Lamf_plugins_document_webapi_validation_remote_JsPayloadValidator().init___Lamf_core_model_domain_Shape__Lamf_client_plugins_ValidationMode__Lamf_internal_environment_Environment(s, validationMode, env)
});
$c_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$.prototype.canValidate__Lamf_core_model_domain_Shape__Lamf_internal_environment_Environment__Z = (function(shape, env) {
  return ((!(shape instanceof $c_Lamf_plugins_domain_shapes_models_SchemaShape)) && (shape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape))
});
$c_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$.prototype.ID__T = (function() {
  return this.ID$1
});
$c_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$.prototype.dependencies__sc_Seq = (function() {
  return $m_sci_Nil$()
});
$c_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$.prototype.payloadMediaType__sc_Seq = (function() {
  return this.payloadMediaType$1
});
var $d_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$: 0
}, false, "amf.plugins.document.webapi.validation.PayloadValidatorPlugin$", {
  Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$: 1,
  O: 1,
  Lamf_core_validation_AMFPayloadValidationPlugin: 1,
  Lamf_client_plugins_AMFPlugin: 1,
  Lamf_plugins_domain_webapi_unsafe_JsonSchemaSecrets: 1
});
$c_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$;
var $n_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$)) {
    $n_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$ = new $c_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_PayloadValidatorPlugin$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner$() {
  $c_O.call(this);
  this.platform$1 = null
}
$c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner$.prototype = $c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner$.prototype;
$c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
var $d_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner$: 0
}, false, "amf.plugins.document.webapi.validation.runner.WebApiValidationsRunner$", {
  Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner$: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner$;
var $n_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner$)) {
    $n_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner$ = new $c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression$.prototype.constructor = $c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression$.prototype = $c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression$.prototype;
$c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression().init___T(value))
});
var $d_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression$: 0
}, false, "amf.plugins.domain.shapes.annotations.ParsedFromTypeExpression$", {
  Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression$.prototype.$classData = $d_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression$;
var $n_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression$ = (void 0);
function $m_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression$() {
  if ((!$n_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression$)) {
    $n_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression$ = new $c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError() {
  $c_jl_Exception.call(this);
  this.message$3 = null;
  this.property$3 = null;
  this.location$3 = null;
  this.position$3 = null;
  this.isViolation$3 = false
}
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError.prototype = new $h_jl_Exception();
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError.prototype.init___T__s_Option__s_Option__s_Option__Z = (function(message, property, location, position, isViolation) {
  this.message$3 = message;
  this.property$3 = property;
  this.location$3 = location;
  this.position$3 = position;
  this.isViolation$3 = isViolation;
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, message, null, true, true);
  return this
});
function $as_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.InheritanceIncompatibleShapeError"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.resolution.stages.shape_normalization.InheritanceIncompatibleShapeError;", depth))
}
var $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.InheritanceIncompatibleShapeError", {
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_InheritanceIncompatibleShapeError;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_annotations_InvalidBinding$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_annotations_InvalidBinding$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_annotations_InvalidBinding$.prototype.constructor = $c_Lamf_plugins_domain_webapi_annotations_InvalidBinding$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_annotations_InvalidBinding$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_annotations_InvalidBinding$.prototype = $c_Lamf_plugins_domain_webapi_annotations_InvalidBinding$.prototype;
$c_Lamf_plugins_domain_webapi_annotations_InvalidBinding$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_annotations_InvalidBinding$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_plugins_domain_webapi_annotations_InvalidBinding().init___T(value))
});
var $d_Lamf_plugins_domain_webapi_annotations_InvalidBinding$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_annotations_InvalidBinding$: 0
}, false, "amf.plugins.domain.webapi.annotations.InvalidBinding$", {
  Lamf_plugins_domain_webapi_annotations_InvalidBinding$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_annotations_InvalidBinding$.prototype.$classData = $d_Lamf_plugins_domain_webapi_annotations_InvalidBinding$;
var $n_Lamf_plugins_domain_webapi_annotations_InvalidBinding$ = (void 0);
function $m_Lamf_plugins_domain_webapi_annotations_InvalidBinding$() {
  if ((!$n_Lamf_plugins_domain_webapi_annotations_InvalidBinding$)) {
    $n_Lamf_plugins_domain_webapi_annotations_InvalidBinding$ = new $c_Lamf_plugins_domain_webapi_annotations_InvalidBinding$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_annotations_InvalidBinding$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension$.prototype.constructor = $c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension$.prototype = $c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension$.prototype;
$c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension().init___T(value))
});
var $d_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_annotations_OrphanOasExtension$: 0
}, false, "amf.plugins.domain.webapi.annotations.OrphanOasExtension$", {
  Lamf_plugins_domain_webapi_annotations_OrphanOasExtension$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension$.prototype.$classData = $d_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension$;
var $n_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension$ = (void 0);
function $m_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension$() {
  if ((!$n_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension$)) {
    $n_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension$ = new $c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo$.prototype.constructor = $c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo$.prototype = $c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo$.prototype;
$c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo().init___Lamf_core_parser_Range($m_Lamf_core_parser_Range$().apply__T__Lamf_core_parser_Range(value)))
});
var $d_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo$: 0
}, false, "amf.plugins.domain.webapi.annotations.ParameterBindingInBodyLexicalInfo$", {
  Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo$.prototype.$classData = $d_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo$;
var $n_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo$ = (void 0);
function $m_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo$() {
  if ((!$n_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo$)) {
    $n_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo$ = new $c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint$.prototype.constructor = $c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_annotations_ParentEndPoint$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_annotations_ParentEndPoint$.prototype = $c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint$.prototype;
$c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint$.prototype.apply__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_domain_webapi_annotations_ParentEndPoint = (function(parent) {
  var result = new $c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint().init___T(parent.id$1);
  result.parent$1 = new $c_s_Some().init___O(parent);
  return result
});
$c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint$.prototype.unparse__T__sci_Map__s_Option = (function(parent, objects) {
  var result = new $c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint().init___T(parent);
  result.resolve__sci_Map__V(objects);
  return new $c_s_Some().init___O(result)
});
var $d_Lamf_plugins_domain_webapi_annotations_ParentEndPoint$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_annotations_ParentEndPoint$: 0
}, false, "amf.plugins.domain.webapi.annotations.ParentEndPoint$", {
  Lamf_plugins_domain_webapi_annotations_ParentEndPoint$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint$.prototype.$classData = $d_Lamf_plugins_domain_webapi_annotations_ParentEndPoint$;
var $n_Lamf_plugins_domain_webapi_annotations_ParentEndPoint$ = (void 0);
function $m_Lamf_plugins_domain_webapi_annotations_ParentEndPoint$() {
  if ((!$n_Lamf_plugins_domain_webapi_annotations_ParentEndPoint$)) {
    $n_Lamf_plugins_domain_webapi_annotations_ParentEndPoint$ = new $c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_annotations_ParentEndPoint$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo$() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo$.prototype.constructor = $c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo$.prototype = $c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo$.prototype;
$c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo$.prototype.unparse__T__sci_Map__s_Option = (function(value, objects) {
  return new $c_s_Some().init___O(new $c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo().init___Lamf_core_parser_Range($m_Lamf_core_parser_Range$().apply__T__Lamf_core_parser_Range(value)))
});
var $d_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo$: 0
}, false, "amf.plugins.domain.webapi.annotations.TypePropertyLexicalInfo$", {
  Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo$: 1,
  O: 1,
  Lamf_core_model_domain_AnnotationGraphLoader: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo$.prototype.$classData = $d_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo$;
var $n_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo$ = (void 0);
function $m_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo$() {
  if ((!$n_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo$)) {
    $n_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo$ = new $c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo$
}
function $is_Lamf_plugins_domain_webapi_models_bindings_ChannelBinding(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_domain_webapi_models_bindings_ChannelBinding)))
}
function $as_Lamf_plugins_domain_webapi_models_bindings_ChannelBinding(obj) {
  return (($is_Lamf_plugins_domain_webapi_models_bindings_ChannelBinding(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.ChannelBinding"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_ChannelBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_ChannelBinding)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_ChannelBinding(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_ChannelBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.ChannelBinding;", depth))
}
function $is_Lamf_plugins_domain_webapi_models_bindings_MessageBinding(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_domain_webapi_models_bindings_MessageBinding)))
}
function $as_Lamf_plugins_domain_webapi_models_bindings_MessageBinding(obj) {
  return (($is_Lamf_plugins_domain_webapi_models_bindings_MessageBinding(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.MessageBinding"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_MessageBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_MessageBinding)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_MessageBinding(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_MessageBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.MessageBinding;", depth))
}
function $is_Lamf_plugins_domain_webapi_models_bindings_OperationBinding(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_domain_webapi_models_bindings_OperationBinding)))
}
function $as_Lamf_plugins_domain_webapi_models_bindings_OperationBinding(obj) {
  return (($is_Lamf_plugins_domain_webapi_models_bindings_OperationBinding(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.OperationBinding"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_OperationBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_OperationBinding)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_OperationBinding(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_OperationBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.OperationBinding;", depth))
}
function $is_Lamf_plugins_domain_webapi_models_bindings_ServerBinding(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_domain_webapi_models_bindings_ServerBinding)))
}
function $as_Lamf_plugins_domain_webapi_models_bindings_ServerBinding(obj) {
  return (($is_Lamf_plugins_domain_webapi_models_bindings_ServerBinding(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.ServerBinding"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_ServerBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_ServerBinding)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_ServerBinding(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_ServerBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.ServerBinding;", depth))
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill.prototype = $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill.prototype;
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$()
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill.prototype.componentId__T = (function() {
  return "/mqtt-last-will"
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.mqtt.MqttServerLastWill"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.mqtt.MqttServerLastWill;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill: 0
}, false, "amf.plugins.domain.webapi.models.bindings.mqtt.MqttServerLastWill", {
  Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_security_Settings() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_security_Settings.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_security_Settings;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_security_Settings() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_security_Settings.prototype = $c_Lamf_plugins_domain_webapi_models_security_Settings.prototype;
$c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$()
});
$c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.componentId__T = (function() {
  return "/settings/default"
});
$c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_domain_webapi_models_security_Settings(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_security_Settings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.security.Settings"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_security_Settings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_security_Settings)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_security_Settings(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_security_Settings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.security.Settings;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_security_Settings = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_security_Settings: 0
}, false, "amf.plugins.domain.webapi.models.security.Settings", {
  Lamf_plugins_domain_webapi_models_security_Settings: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1
});
$c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_security_Settings;
/** @constructor */
function $c_Lamf_plugins_features_validation_SHACLValidator() {
  $c_O.call(this);
  this.functionUrl$1 = null;
  this.functionCode$1 = null;
  this.platform$1 = null
}
$c_Lamf_plugins_features_validation_SHACLValidator.prototype = new $h_O();
$c_Lamf_plugins_features_validation_SHACLValidator.prototype.constructor = $c_Lamf_plugins_features_validation_SHACLValidator;
/** @constructor */
function $h_Lamf_plugins_features_validation_SHACLValidator() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_SHACLValidator.prototype = $c_Lamf_plugins_features_validation_SHACLValidator.prototype;
$c_Lamf_plugins_features_validation_SHACLValidator.prototype.$$js$exported$meth$validate$default$5__Lamf_client_execution_BaseExecutionEnvironment = (function() {
  var this$1 = this.platform$1;
  return this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment()
});
$c_Lamf_plugins_features_validation_SHACLValidator.prototype.init___ = (function() {
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  this.functionUrl$1 = $m_s_None$();
  this.functionCode$1 = $m_s_None$();
  return this
});
$c_Lamf_plugins_features_validation_SHACLValidator.prototype.report__Lamf_core_model_document_BaseUnit__sc_Seq__Lamf_core_services_ValidationOptions__s_concurrent_ExecutionContext__s_concurrent_Future = (function(data, shapes, options, executionContext) {
  var promise = new $c_s_concurrent_impl_Promise$DefaultPromise().init___();
  try {
    $m_Lamf_core_benchmark_ExecutionLog$().log__T__Lamf_core_benchmark_ExecutionLog$("SHACLValidator#validate: Creating SHACL-JS instance and loading JS libraries");
    var validator = new (this.nativeShacl__sjs_js_Dynamic())();
    this.loadLibrary__sjs_js_Dynamic__V(validator);
    $m_Lamf_core_benchmark_ExecutionLog$().log__T__Lamf_core_benchmark_ExecutionLog$("SHACLValidator#validate: loading Jena data model");
    var dataModel = new $c_Lamf_plugins_features_validation_RdflibRdfModel().init___sjs_js_Dynamic($m_Lamf_plugins_features_validation_RdflibRdfModel$().$$lessinit$greater$default$1__sjs_js_Dynamic());
    new $c_Lamf_core_rdf_RdfModelEmitter().init___Lamf_core_rdf_RdfModel(dataModel).emit__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__V(data, new $c_Lamf_core_emitter_RenderOptions().init___().withValidation__Lamf_core_emitter_RenderOptions());
    $m_Lamf_core_benchmark_ExecutionLog$().log__T__Lamf_core_benchmark_ExecutionLog$("SHACLValidator#validate: loading Jena shapes model");
    var shapesModel = new $c_Lamf_plugins_features_validation_RdflibRdfModel().init___sjs_js_Dynamic($m_Lamf_plugins_features_validation_RdflibRdfModel$().$$lessinit$greater$default$1__sjs_js_Dynamic());
    new $c_Lamf_plugins_features_validation_emitters_ValidationRdfModelEmitter().init___Lamf_ProfileName__Lamf_core_rdf_RdfModel__T(options.messageStyle$1.profileName__Lamf_ProfileName(), shapesModel, $m_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$().validationLibraryUrl__T()).emit__sc_Seq__V(shapes);
    validator.validateFromModels(dataModel.model$2, shapesModel.model$2, (function($this, promise$1) {
      return (function(e$2, report$2) {
        if (((e$2 === (void 0)) || (e$2 === null))) {
          var result = new $c_Lamf_plugins_features_validation_JSValidationReport().init___sjs_js_Dynamic(report$2);
          return $f_s_concurrent_Promise__success__O__s_concurrent_Promise(promise$1, result)
        } else {
          var cause = new $c_sjs_js_JavaScriptException().init___O(e$2);
          return $f_s_concurrent_Promise__failure__jl_Throwable__s_concurrent_Promise(promise$1, cause)
        }
      })
    })(this, promise));
    return promise
  } catch (e$3) {
    var e$4 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e$3);
    if ((e$4 instanceof $c_jl_Exception)) {
      var e$5 = $as_jl_Exception(e$4);
      var this$5 = $f_s_concurrent_Promise__failure__jl_Throwable__s_concurrent_Promise(promise, e$5);
      return this$5
    } else {
      throw e$3
    }
  }
});
$c_Lamf_plugins_features_validation_SHACLValidator.prototype.reportJS__T__T__T__T__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise = (function(data, dataMediaType, shapes, shapesMediaType, exec) {
  var executionContext = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  var jsx$1 = $m_sjs_js_JSConverters$JSRichFuture$();
  var f = this.report__T__T__T__T__s_concurrent_ExecutionContext__s_concurrent_Future(data, dataMediaType, shapes, shapesMediaType, executionContext);
  return jsx$1.toJSPromise$extension__s_concurrent_Future__s_concurrent_ExecutionContext__sjs_js_Promise(f, executionContext)
});
$c_Lamf_plugins_features_validation_SHACLValidator.prototype.report__T__T__T__T__s_concurrent_ExecutionContext__s_concurrent_Future = (function(data, dataMediaType, shapes, shapesMediaType, executionContext) {
  var promise = new $c_s_concurrent_impl_Promise$DefaultPromise().init___();
  try {
    var validator = new (this.nativeShacl__sjs_js_Dynamic())();
    this.loadLibrary__sjs_js_Dynamic__V(validator);
    var this$2 = $as_Lamf_core_rdf_RdfFramework(this.platform$1.rdfFramework__s_Option().get__O());
    var dataModel = $as_Lamf_core_rdf_RdfModelDocument($f_Lamf_core_rdf_RdfFramework__syntaxToRdfModel__T__jl_CharSequence__s_Option(this$2, dataMediaType, data).get__O());
    var this$3 = $as_Lamf_core_rdf_RdfFramework(this.platform$1.rdfFramework__s_Option().get__O());
    var shapesModel = $as_Lamf_core_rdf_RdfModelDocument($f_Lamf_core_rdf_RdfFramework__syntaxToRdfModel__T__jl_CharSequence__s_Option(this$3, shapesMediaType, shapes).get__O());
    var this$4 = dataModel.model$2;
    var jsx$1 = this$4.model$2;
    var this$5 = shapesModel.model$2;
    validator.validateFromModels(jsx$1, this$5.model$2, (function($this, promise$1) {
      return (function(e$2, report$2) {
        if (((e$2 === (void 0)) || (e$2 === null))) {
          var result = new $c_Lamf_plugins_features_validation_JSValidationReport().init___sjs_js_Dynamic(report$2);
          return $f_s_concurrent_Promise__success__O__s_concurrent_Promise(promise$1, result)
        } else {
          var cause = new $c_sjs_js_JavaScriptException().init___O(e$2);
          return $f_s_concurrent_Promise__failure__jl_Throwable__s_concurrent_Promise(promise$1, cause)
        }
      })
    })(this, promise));
    return promise
  } catch (e$3) {
    var e$4 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e$3);
    if ((e$4 instanceof $c_jl_Exception)) {
      var e$5 = $as_jl_Exception(e$4);
      var this$7 = $f_s_concurrent_Promise__failure__jl_Throwable__s_concurrent_Promise(promise, e$5);
      return this$7
    } else {
      throw e$3
    }
  }
});
$c_Lamf_plugins_features_validation_SHACLValidator.prototype.loadLibrary__sjs_js_Dynamic__V = (function(validator) {
  if ((this.functionCode$1.isDefined__Z() && this.functionUrl$1.isDefined__Z())) {
    var s = $as_T(this.functionUrl$1.get__O());
    var s$1 = $as_T(this.functionCode$1.get__O());
    validator.registerJSCode(s, s$1)
  }
});
$c_Lamf_plugins_features_validation_SHACLValidator.prototype.$$js$exported$meth$report__T__T__T__T__Lamf_client_execution_BaseExecutionEnvironment__O = (function(data, dataMediaType, shapes, shapesMediaType, exec) {
  return this.reportJS__T__T__T__T__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise(data, dataMediaType, shapes, shapesMediaType, exec)
});
$c_Lamf_plugins_features_validation_SHACLValidator.prototype.$$js$exported$meth$report$default$5__Lamf_client_execution_BaseExecutionEnvironment = (function() {
  var this$1 = this.platform$1;
  return this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment()
});
$c_Lamf_plugins_features_validation_SHACLValidator.prototype.validateJS__T__T__T__T__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise = (function(data, dataMediaType, shapes, shapesMediaType, exec) {
  var executionContext = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  var jsx$1 = $m_sjs_js_JSConverters$JSRichFuture$();
  var f = this.validate__T__T__T__T__s_concurrent_ExecutionContext__s_concurrent_Future(data, dataMediaType, shapes, shapesMediaType, executionContext);
  return jsx$1.toJSPromise$extension__s_concurrent_Future__s_concurrent_ExecutionContext__sjs_js_Promise(f, executionContext)
});
$c_Lamf_plugins_features_validation_SHACLValidator.prototype.registerLibrary__T__T__V = (function(url, code) {
  this.functionUrl$1 = new $c_s_Some().init___O(url);
  this.functionCode$1 = new $c_s_Some().init___O(code)
});
$c_Lamf_plugins_features_validation_SHACLValidator.prototype.nativeShacl__sjs_js_Dynamic = (function() {
  var v = $g.GlobalSHACLValidator;
  if ((v === (void 0))) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Cannot find global SHACLValidator object"))
  } else {
    return $g.GlobalSHACLValidator
  }
});
$c_Lamf_plugins_features_validation_SHACLValidator.prototype.validate__T__T__T__T__s_concurrent_ExecutionContext__s_concurrent_Future = (function(data, dataMediaType, shapes, shapesMediaType, executionContext) {
  var promise = new $c_s_concurrent_impl_Promise$DefaultPromise().init___();
  var validator = new (this.nativeShacl__sjs_js_Dynamic())();
  this.loadLibrary__sjs_js_Dynamic__V(validator);
  validator.validate(data, dataMediaType, shapes, shapesMediaType, (function($this, promise$1) {
    return (function(e$2, r$2) {
      if (((e$2 === (void 0)) || (e$2 === null))) {
        var value = $objectToString($g.JSON.stringify(r$2));
        return $f_s_concurrent_Promise__success__O__s_concurrent_Promise(promise$1, value)
      } else {
        var cause = new $c_sjs_js_JavaScriptException().init___O(e$2);
        return $f_s_concurrent_Promise__failure__jl_Throwable__s_concurrent_Promise(promise$1, cause)
      }
    })
  })(this, promise));
  return promise
});
$c_Lamf_plugins_features_validation_SHACLValidator.prototype.$$js$exported$meth$validate__T__T__T__T__Lamf_client_execution_BaseExecutionEnvironment__O = (function(data, dataMediaType, shapes, shapesMediaType, exec) {
  return this.validateJS__T__T__T__T__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise(data, dataMediaType, shapes, shapesMediaType, exec)
});
$c_Lamf_plugins_features_validation_SHACLValidator.prototype.report = (function(arg, arg$2, arg$3, arg$4) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 4;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = $as_T(arg);
  var prep$2 = $as_T(arg$2);
  var prep$3 = $as_T(arg$3);
  var prep$4 = $as_T(arg$4);
  var prep$5 = ((rest[0] === (void 0)) ? this.$$js$exported$meth$report$default$5__Lamf_client_execution_BaseExecutionEnvironment() : $as_Lamf_client_execution_BaseExecutionEnvironment(rest[0]));
  return this.$$js$exported$meth$report__T__T__T__T__Lamf_client_execution_BaseExecutionEnvironment__O(prep, prep$2, prep$3, prep$4, prep$5)
});
$c_Lamf_plugins_features_validation_SHACLValidator.prototype.validate = (function(arg, arg$2, arg$3, arg$4) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 4;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = $as_T(arg);
  var prep$2 = $as_T(arg$2);
  var prep$3 = $as_T(arg$3);
  var prep$4 = $as_T(arg$4);
  var prep$5 = ((rest[0] === (void 0)) ? this.$$js$exported$meth$validate$default$5__Lamf_client_execution_BaseExecutionEnvironment() : $as_Lamf_client_execution_BaseExecutionEnvironment(rest[0]));
  return this.$$js$exported$meth$validate__T__T__T__T__Lamf_client_execution_BaseExecutionEnvironment__O(prep, prep$2, prep$3, prep$4, prep$5)
});
var $d_Lamf_plugins_features_validation_SHACLValidator = new $TypeData().initClass({
  Lamf_plugins_features_validation_SHACLValidator: 0
}, false, "amf.plugins.features.validation.SHACLValidator", {
  Lamf_plugins_features_validation_SHACLValidator: 1,
  O: 1,
  Lamf_core_validation_core_SHACLValidator: 1,
  Lamf_core_rdf_RdfFramework: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_plugins_features_validation_SHACLValidator.prototype.$classData = $d_Lamf_plugins_features_validation_SHACLValidator;
/** @constructor */
function $c_Lamf_plugins_syntax_RdfSyntaxPlugin$() {
  $c_Lamf_client_plugins_AMFSyntaxPlugin.call(this);
  this.ID$2 = null;
  this.platform$2 = null
}
$c_Lamf_plugins_syntax_RdfSyntaxPlugin$.prototype = new $h_Lamf_client_plugins_AMFSyntaxPlugin();
$c_Lamf_plugins_syntax_RdfSyntaxPlugin$.prototype.constructor = $c_Lamf_plugins_syntax_RdfSyntaxPlugin$;
/** @constructor */
function $h_Lamf_plugins_syntax_RdfSyntaxPlugin$() {
  /*<skip>*/
}
$h_Lamf_plugins_syntax_RdfSyntaxPlugin$.prototype = $c_Lamf_plugins_syntax_RdfSyntaxPlugin$.prototype;
$c_Lamf_plugins_syntax_RdfSyntaxPlugin$.prototype.init___ = (function() {
  $n_Lamf_plugins_syntax_RdfSyntaxPlugin$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$2 = this$1.platform$1;
  this.ID$2 = "Rdf";
  return this
});
$c_Lamf_plugins_syntax_RdfSyntaxPlugin$.prototype.init__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
    return (function() {
      return $m_Lamf_plugins_syntax_RdfSyntaxPlugin$()
    })
  })(this)), executionContext)
});
$c_Lamf_plugins_syntax_RdfSyntaxPlugin$.prototype.parse__T__jl_CharSequence__Lamf_core_parser_ParserContext__Lamf_core_client_ParsingOptions__s_Option = (function(mediaType, text, ctx, options) {
  var x1 = this.platform$2.rdfFramework__s_Option();
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var r = $as_Lamf_core_rdf_RdfFramework(x2.value$2);
    if ((!options.amfJsonLdSerialization$1)) {
      return $f_Lamf_core_rdf_RdfFramework__syntaxToRdfModel__T__jl_CharSequence__s_Option(r, mediaType, text)
    }
  };
  return $m_s_None$()
});
$c_Lamf_plugins_syntax_RdfSyntaxPlugin$.prototype.supportedMediaTypes__sc_Seq = (function() {
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$3 = new $c_scm_ListBuffer().init___();
  return this$3.toList__sci_List()
});
$c_Lamf_plugins_syntax_RdfSyntaxPlugin$.prototype.unparse__T__Lamf_core_parser_ParsedDocument__O__Lorg_mulesoft_common_io_Output__s_Option = (function(mediaType, doc, writer, evidence$1) {
  var _2 = this.platform$2.rdfFramework__s_Option();
  if ((doc instanceof $c_Lamf_core_rdf_RdfModelDocument)) {
    var x4 = $as_Lamf_core_rdf_RdfModelDocument(doc);
    if ((_2 instanceof $c_s_Some)) {
      var x3 = $as_s_Some(_2);
      $as_Lamf_core_rdf_RdfFramework(x3.value$2);
      return x4.model$2.serializeWriter__T__O__Lorg_mulesoft_common_io_Output__s_Option(mediaType, writer, evidence$1)
    }
  };
  return $m_s_None$()
});
$c_Lamf_plugins_syntax_RdfSyntaxPlugin$.prototype.ID__T = (function() {
  return this.ID$2
});
$c_Lamf_plugins_syntax_RdfSyntaxPlugin$.prototype.dependencies__sc_Seq = (function() {
  return $m_sci_Nil$()
});
var $d_Lamf_plugins_syntax_RdfSyntaxPlugin$ = new $TypeData().initClass({
  Lamf_plugins_syntax_RdfSyntaxPlugin$: 0
}, false, "amf.plugins.syntax.RdfSyntaxPlugin$", {
  Lamf_plugins_syntax_RdfSyntaxPlugin$: 1,
  Lamf_client_plugins_AMFSyntaxPlugin: 1,
  O: 1,
  Lamf_client_plugins_AMFPlugin: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_plugins_syntax_RdfSyntaxPlugin$.prototype.$classData = $d_Lamf_plugins_syntax_RdfSyntaxPlugin$;
var $n_Lamf_plugins_syntax_RdfSyntaxPlugin$ = (void 0);
function $m_Lamf_plugins_syntax_RdfSyntaxPlugin$() {
  if ((!$n_Lamf_plugins_syntax_RdfSyntaxPlugin$)) {
    $n_Lamf_plugins_syntax_RdfSyntaxPlugin$ = new $c_Lamf_plugins_syntax_RdfSyntaxPlugin$().init___()
  };
  return $n_Lamf_plugins_syntax_RdfSyntaxPlugin$
}
/** @constructor */
function $c_Lamf_plugins_syntax_SYamlSyntaxPlugin$() {
  $c_Lamf_client_plugins_AMFSyntaxPlugin.call(this);
  this.ID$2 = null;
  this.platform$2 = null
}
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$.prototype = new $h_Lamf_client_plugins_AMFSyntaxPlugin();
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$.prototype.constructor = $c_Lamf_plugins_syntax_SYamlSyntaxPlugin$;
/** @constructor */
function $h_Lamf_plugins_syntax_SYamlSyntaxPlugin$() {
  /*<skip>*/
}
$h_Lamf_plugins_syntax_SYamlSyntaxPlugin$.prototype = $c_Lamf_plugins_syntax_SYamlSyntaxPlugin$.prototype;
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$.prototype.init__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
    return (function() {
      return $m_Lamf_plugins_syntax_SYamlSyntaxPlugin$()
    })
  })(this)), executionContext)
});
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$.prototype.init___ = (function() {
  $n_Lamf_plugins_syntax_SYamlSyntaxPlugin$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$2 = this$1.platform$1;
  this.ID$2 = "SYaml";
  return this
});
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$.prototype.parse__T__jl_CharSequence__Lamf_core_parser_ParserContext__Lamf_core_client_ParsingOptions__s_Option = (function(mediaType, text, ctx, options) {
  if (($charSequenceLength(text) === 0)) {
    return $m_s_None$()
  } else if (((((mediaType === "application/ld+json") || (mediaType === "application/json")) && (!options.amfJsonLdSerialization$1)) && this.platform$2.rdfFramework__s_Option().isDefined__Z())) {
    var this$1 = $as_Lamf_core_rdf_RdfFramework(this.platform$2.rdfFramework__s_Option().get__O());
    return $f_Lamf_core_rdf_RdfFramework__syntaxToRdfModel__T__jl_CharSequence__s_Option(this$1, mediaType, text)
  } else {
    var x1 = this.getFormat__p2__T__T(mediaType);
    var parser = ((x1 === "json") ? $m_Lorg_yaml_parser_JsonParser$().withSource__jl_CharSequence__T__Lorg_mulesoft_lexer_Position__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_JsonParser(text, ctx.rootContextDocument$1, $m_Lorg_mulesoft_lexer_Position$().Zero$1, ctx.eh$1) : $m_Lorg_yaml_parser_YamlParser$().apply__jl_CharSequence__T__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_YamlParser(text, ctx.rootContextDocument$1, ctx.eh$1).withIncludeTag__T__Lorg_yaml_parser_YamlParser("!include"));
    var parts = parser.parse__Z__sc_IndexedSeq(false);
    var pf = new $c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$1().init___();
    var comment = $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(parts, pf);
    var pf$1 = new $c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$2().init___();
    var x1$2 = $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(parts, pf$1);
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var d = $as_Lorg_yaml_model_YDocument(x2.value$2);
      var doc = d
    } else {
      var x = $m_s_None$();
      if ((!(x === x1$2))) {
        throw new $c_s_MatchError().init___O(x1$2)
      };
      var jsx$2 = $m_Lorg_yaml_model_YDocument$();
      var jsx$1 = $m_s_Predef$();
      $m_Lorg_yaml_model_YNode$();
      var map = $m_Lorg_yaml_model_YMap$().empty$1;
      var doc = jsx$2.apply__sc_IndexedSeq__T__Lorg_yaml_model_YDocument(jsx$1.wrapRefArray__AO__scm_WrappedArray($makeNativeArrayWrapper($d_Lorg_yaml_model_YNode.getArrayOf(), [$m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1)])), ctx.rootContextDocument$1)
    };
    return new $c_s_Some().init___O(new $c_Lamf_core_parser_SyamlParsedDocument().init___Lorg_yaml_model_YDocument__s_Option(doc, comment))
  }
});
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$.prototype.supportedMediaTypes__sc_Seq = (function() {
  var jsx$1 = $m_sc_Seq$();
  var array = ["application/yaml", "application/x-yaml", "text/yaml", "text/x-yaml", "application/json", "text/json", "application/raml", "text/vnd.yaml"];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$.prototype.getFormat__p2__T__T = (function(mediaType) {
  return (($uI(mediaType.indexOf("json")) !== (-1)) ? "json" : "yaml")
});
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$.prototype.unparse__T__Lamf_core_parser_ParsedDocument__O__Lorg_mulesoft_common_io_Output__s_Option = (function(mediaType, doc, writer, evidence$1) {
  if ((doc instanceof $c_Lamf_core_parser_SyamlParsedDocument)) {
    var x2 = $as_Lamf_core_parser_SyamlParsedDocument(doc);
    var ast = x2.document$2;
    var format = this.getFormat__p2__T__T(mediaType);
    if ((format === "yaml")) {
      $m_Lorg_yaml_render_YamlRender$().render__O__Lorg_yaml_model_YPart__Z__Lorg_mulesoft_common_io_Output__V(writer, ast, false, evidence$1)
    } else {
      var x$3 = new $c_Lorg_yaml_render_JsonRenderOptions().init___().withoutNonAsciiEncode__Lorg_yaml_render_JsonRenderOptions();
      $m_Lorg_yaml_render_JsonRender$().render__Lorg_yaml_model_YDocument__O__I__Lorg_yaml_render_JsonRenderOptions__Lorg_mulesoft_common_io_Output__V(ast, writer, 0, x$3, evidence$1)
    };
    return new $c_s_Some().init___O(writer)
  };
  if ((doc instanceof $c_Lamf_core_rdf_RdfModelDocument)) {
    var x3 = $as_Lamf_core_rdf_RdfModelDocument(doc);
    if (this.platform$2.rdfFramework__s_Option().isDefined__Z()) {
      $as_Lamf_core_rdf_RdfFramework(this.platform$2.rdfFramework__s_Option().get__O());
      return x3.model$2.serializeWriter__T__O__Lorg_mulesoft_common_io_Output__s_Option(mediaType, writer, evidence$1)
    }
  };
  return $m_s_None$()
});
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$.prototype.ID__T = (function() {
  return this.ID$2
});
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$.prototype.dependencies__sc_Seq = (function() {
  return $m_sci_Nil$()
});
var $d_Lamf_plugins_syntax_SYamlSyntaxPlugin$ = new $TypeData().initClass({
  Lamf_plugins_syntax_SYamlSyntaxPlugin$: 0
}, false, "amf.plugins.syntax.SYamlSyntaxPlugin$", {
  Lamf_plugins_syntax_SYamlSyntaxPlugin$: 1,
  Lamf_client_plugins_AMFSyntaxPlugin: 1,
  O: 1,
  Lamf_client_plugins_AMFPlugin: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$.prototype.$classData = $d_Lamf_plugins_syntax_SYamlSyntaxPlugin$;
var $n_Lamf_plugins_syntax_SYamlSyntaxPlugin$ = (void 0);
function $m_Lamf_plugins_syntax_SYamlSyntaxPlugin$() {
  if ((!$n_Lamf_plugins_syntax_SYamlSyntaxPlugin$)) {
    $n_Lamf_plugins_syntax_SYamlSyntaxPlugin$ = new $c_Lamf_plugins_syntax_SYamlSyntaxPlugin$().init___()
  };
  return $n_Lamf_plugins_syntax_SYamlSyntaxPlugin$
}
/** @constructor */
function $c_Ljava_io_IOException() {
  $c_jl_Exception.call(this)
}
$c_Ljava_io_IOException.prototype = new $h_jl_Exception();
$c_Ljava_io_IOException.prototype.constructor = $c_Ljava_io_IOException;
/** @constructor */
function $h_Ljava_io_IOException() {
  /*<skip>*/
}
$h_Ljava_io_IOException.prototype = $c_Ljava_io_IOException.prototype;
$c_Ljava_io_IOException.prototype.init___T = (function(s) {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
function $as_Ljava_io_IOException(obj) {
  return (((obj instanceof $c_Ljava_io_IOException) || (obj === null)) ? obj : $throwClassCastException(obj, "java.io.IOException"))
}
function $isArrayOf_Ljava_io_IOException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Ljava_io_IOException)))
}
function $asArrayOf_Ljava_io_IOException(obj, depth) {
  return (($isArrayOf_Ljava_io_IOException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.io.IOException;", depth))
}
var $d_Ljava_io_IOException = new $TypeData().initClass({
  Ljava_io_IOException: 0
}, false, "java.io.IOException", {
  Ljava_io_IOException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_Ljava_io_IOException.prototype.$classData = $d_Ljava_io_IOException;
/** @constructor */
function $c_Ljava_io_OutputStream() {
  $c_O.call(this)
}
$c_Ljava_io_OutputStream.prototype = new $h_O();
$c_Ljava_io_OutputStream.prototype.constructor = $c_Ljava_io_OutputStream;
/** @constructor */
function $h_Ljava_io_OutputStream() {
  /*<skip>*/
}
$h_Ljava_io_OutputStream.prototype = $c_Ljava_io_OutputStream.prototype;
$c_Ljava_io_OutputStream.prototype.close__V = (function() {
  /*<skip>*/
});
/** @constructor */
function $c_Ljava_math_BigDecimal() {
  $c_jl_Number.call(this);
  this.$$undtoStringImage$2 = null;
  this.$$undhashCode$2 = 0;
  this.$$undintVal$2 = null;
  this.java$math$BigDecimal$$$undbitLength$2 = 0;
  this.java$math$BigDecimal$$$undsmallValue$2 = $m_sjsr_RuntimeLong$().Zero__sjsr_RuntimeLong();
  this.java$math$BigDecimal$$$undscale$2 = 0;
  this.$$undprecision$2 = 0
}
$c_Ljava_math_BigDecimal.prototype = new $h_jl_Number();
$c_Ljava_math_BigDecimal.prototype.constructor = $c_Ljava_math_BigDecimal;
/** @constructor */
function $h_Ljava_math_BigDecimal() {
  /*<skip>*/
}
$h_Ljava_math_BigDecimal.prototype = $c_Ljava_math_BigDecimal.prototype;
$c_Ljava_math_BigDecimal.prototype.longValue__J = (function() {
  return (((this.java$math$BigDecimal$$$undscale$2 <= (-64)) || (this.java$math$BigDecimal$$$undscale$2 > this.approxPrecision__p2__I())) ? $m_sjsr_RuntimeLong$().Zero__sjsr_RuntimeLong() : this.toBigInteger__Ljava_math_BigInteger().longValue__J())
});
$c_Ljava_math_BigDecimal.prototype.init___ = (function() {
  this.$$undtoStringImage$2 = null;
  this.$$undhashCode$2 = 0;
  this.java$math$BigDecimal$$$undbitLength$2 = 0;
  this.java$math$BigDecimal$$$undsmallValue$2 = $m_sjsr_RuntimeLong$().Zero__sjsr_RuntimeLong();
  this.java$math$BigDecimal$$$undscale$2 = 0;
  this.$$undprecision$2 = 0;
  return this
});
$c_Ljava_math_BigDecimal.prototype.valueExact__p2__I__J = (function(bitLengthOfType) {
  var value = this.java$math$BigDecimal$$$undscale$2;
  var hi = (value >> 31);
  var lo = ((-value) | 0);
  var hi$1 = ((value !== 0) ? (~hi) : ((-hi) | 0));
  var value$1 = this.approxPrecision__p2__I();
  var hi$2 = (value$1 >> 31);
  var lo$1 = ((lo + value$1) | 0);
  var hi$3 = ((((-2147483648) ^ lo$1) < ((-2147483648) ^ lo)) ? ((1 + ((hi$1 + hi$2) | 0)) | 0) : ((hi$1 + hi$2) | 0));
  if (((hi$3 === 0) ? (((-2147483648) ^ lo$1) > (-2147483629)) : (hi$3 > 0))) {
    throw new $c_jl_ArithmeticException().init___T("Rounding necessary")
  };
  var bigInteger = this.toBigIntegerExact__Ljava_math_BigInteger();
  if (($m_Ljava_math_BitLevel$().bitLength__Ljava_math_BigInteger__I(bigInteger) < bitLengthOfType)) {
    return bigInteger.longValue__J()
  } else {
    throw new $c_jl_ArithmeticException().init___T("Rounding necessary")
  }
});
$c_Ljava_math_BigDecimal.prototype.equals__O__Z = (function(x) {
  if ((x instanceof $c_Ljava_math_BigDecimal)) {
    var x2 = $as_Ljava_math_BigDecimal(x);
    if ((x2.java$math$BigDecimal$$$undscale$2 === this.java$math$BigDecimal$$$undscale$2)) {
      if ((this.java$math$BigDecimal$$$undbitLength$2 < 64)) {
        var t = x2.java$math$BigDecimal$$$undsmallValue$2;
        var lo = t.lo$2;
        var hi = t.hi$2;
        var b = this.java$math$BigDecimal$$$undsmallValue$2;
        return ((lo === b.lo$2) && (hi === b.hi$2))
      } else {
        return $m_sr_BoxesRunTime$().equalsNumNum__jl_Number__jl_Number__Z(this.$$undintVal$2, x2.$$undintVal$2)
      }
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Ljava_math_BigDecimal.prototype.intValueExact__I = (function() {
  var t = this.valueExact__p2__I__J(32);
  var lo = t.lo$2;
  return lo
});
$c_Ljava_math_BigDecimal.prototype.isZero__p2__Z = (function() {
  if ((this.java$math$BigDecimal$$$undbitLength$2 === 0)) {
    var t = this.java$math$BigDecimal$$$undsmallValue$2;
    var lo = t.lo$2;
    var hi = t.hi$2;
    return (!((lo === (-1)) && (hi === (-1))))
  } else {
    return false
  }
});
$c_Ljava_math_BigDecimal.prototype.stripTrailingZeros__Ljava_math_BigDecimal = (function() {
  if (this.isZero__p2__Z()) {
    return this
  } else {
    var lastPow = (((-1) + $m_Ljava_math_Multiplication$().BigTenPows$1.u.length) | 0);
    var i = 1;
    var strippedBI = this.java$math$BigDecimal$$getUnscaledValue__Ljava_math_BigInteger();
    var value = this.java$math$BigDecimal$$$undscale$2;
    var hi = (value >> 31);
    var scale_$_lo$2 = value;
    var scale_$_hi$2 = hi;
    var x1_$_$$und1$f;
    var x1_$_$$und2$f;
    _loop: while (true) {
      if ((!strippedBI.testBit__I__Z(0))) {
        var qr = strippedBI.divideAndRemainderImpl__Ljava_math_BigInteger__Ljava_math_BigInteger$QuotAndRem($m_Ljava_math_Multiplication$().BigTenPows$1.get(i));
        var this$1 = qr.rem$1;
        if ((this$1.sign$2 === 0)) {
          var temp$i = ((i < lastPow) ? ((1 + i) | 0) : i);
          var temp$strippedBI = qr.quot$1;
          var this$2_$_lo$2 = scale_$_lo$2;
          var this$2_$_hi$2 = scale_$_hi$2;
          var value$1 = i;
          var hi$1 = (value$1 >> 31);
          var alo = this$2_$_lo$2;
          var ahi = this$2_$_hi$2;
          var lo = ((alo - value$1) | 0);
          var hi$2 = ((((-2147483648) ^ lo) > ((-2147483648) ^ alo)) ? (((-1) + ((ahi - hi$1) | 0)) | 0) : ((ahi - hi$1) | 0));
          i = temp$i;
          strippedBI = temp$strippedBI;
          var jsx$1_$_lo$2 = lo;
          var jsx$1_$_hi$2 = hi$2;
          scale_$_lo$2 = jsx$1_$_lo$2;
          scale_$_hi$2 = jsx$1_$_hi$2;
          continue _loop
        };
        if ((i !== 1)) {
          i = 1;
          continue _loop
        };
        var _1 = strippedBI;
        var _2_$_lo$2 = scale_$_lo$2;
        var _2_$_hi$2 = scale_$_hi$2;
        var x1_$_$$und1$f = _1;
        var x1_$_$$und2$f = new $c_sjsr_RuntimeLong().init___I__I(_2_$_lo$2, _2_$_hi$2);
        break
      } else {
        var _1$1 = strippedBI;
        var _2$1_$_lo$2 = scale_$_lo$2;
        var _2$1_$_hi$2 = scale_$_hi$2;
        var x1_$_$$und1$f = _1$1;
        var x1_$_$$und2$f = new $c_sjsr_RuntimeLong().init___I__I(_2$1_$_lo$2, _2$1_$_hi$2);
        break
      }
    };
    var strippedBI$1 = $as_Ljava_math_BigInteger(x1_$_$$und1$f);
    var t = $uJ(x1_$_$$und2$f);
    var lo$1 = t.lo$2;
    var hi$3 = t.hi$2;
    var t$1 = $uJ(new $c_sjsr_RuntimeLong().init___I__I(lo$1, hi$3));
    var lo$2 = t$1.lo$2;
    var hi$4 = t$1.hi$2;
    return new $c_Ljava_math_BigDecimal().init___Ljava_math_BigInteger__I(strippedBI$1, $m_Ljava_math_BigDecimal$().java$math$BigDecimal$$safeLongToInt__J__I(new $c_sjsr_RuntimeLong().init___I__I(lo$2, hi$4)))
  }
});
$c_Ljava_math_BigDecimal.prototype.inplaceRound__p2__Ljava_math_MathContext__V = (function(mc) {
  var mcPrecision = mc.precision$1;
  var discardedPrecision = ((this.precision__I() - mcPrecision) | 0);
  var mcPrecGood = ((this.approxPrecision__p2__I() < mcPrecision) || (mcPrecision === 0));
  if ((!(mcPrecGood || (discardedPrecision <= 0)))) {
    if ((this.java$math$BigDecimal$$$undbitLength$2 < 64)) {
      this.smallRound__p2__Ljava_math_MathContext__I__V(mc, discardedPrecision)
    } else {
      var jsx$1 = $m_Ljava_math_Multiplication$();
      var hi = (discardedPrecision >> 31);
      var sizeOfFraction = jsx$1.powerOf10__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(discardedPrecision, hi));
      var integerAndFraction = this.java$math$BigDecimal$$getUnscaledValue__Ljava_math_BigInteger().divideAndRemainder__Ljava_math_BigInteger__ALjava_math_BigInteger(sizeOfFraction);
      var value = this.java$math$BigDecimal$$$undscale$2;
      var hi$1 = (value >> 31);
      var hi$2 = (discardedPrecision >> 31);
      var lo = ((value - discardedPrecision) | 0);
      var hi$3 = ((((-2147483648) ^ lo) > ((-2147483648) ^ value)) ? (((-1) + ((hi$1 - hi$2) | 0)) | 0) : ((hi$1 - hi$2) | 0));
      var this$2 = integerAndFraction.get(1);
      if ((this$2.sign$2 !== 0)) {
        var absBi = integerAndFraction.get(1).abs__Ljava_math_BigInteger();
        var compRem = absBi.shiftLeftOneBit__Ljava_math_BigInteger().compareTo__Ljava_math_BigInteger__I(sizeOfFraction);
        var parityBit = (integerAndFraction.get(0).testBit__I__Z(0) ? 1 : 0);
        var this$3 = integerAndFraction.get(1);
        var frac = $imul(this$3.sign$2, ((5 + compRem) | 0));
        var carry = $m_Ljava_math_BigDecimal$().java$math$BigDecimal$$roundingBehavior__I__I__Ljava_math_RoundingMode__I(parityBit, frac, mc.roundingMode$1);
        if ((carry !== 0)) {
          var jsx$2 = $m_Ljava_math_BigInteger$();
          var hi$4 = (carry >> 31);
          var bi = jsx$2.valueOf__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(carry, hi$4));
          var this$4 = integerAndFraction.get(0);
          integerAndFraction.set(0, $m_Ljava_math_Elementary$().add__Ljava_math_BigInteger__Ljava_math_BigInteger__Ljava_math_BigInteger(this$4, bi))
        };
        var tempBD = new $c_Ljava_math_BigDecimal().init___Ljava_math_BigInteger(integerAndFraction.get(0));
        if ((tempBD.precision__I() > mcPrecision)) {
          integerAndFraction.set(0, integerAndFraction.get(0).divide__Ljava_math_BigInteger__Ljava_math_BigInteger($m_Ljava_math_BigInteger$().TEN$1));
          var lo$1 = (((-1) + lo) | 0);
          var hi$5 = ((lo$1 !== (-1)) ? hi$3 : (((-1) + hi$3) | 0));
          var newScale_$_lo$2 = lo$1;
          var newScale_$_hi$2 = hi$5
        } else {
          var newScale_$_lo$2 = lo;
          var newScale_$_hi$2 = hi$3
        }
      } else {
        var newScale_$_lo$2 = lo;
        var newScale_$_hi$2 = hi$3
      };
      this.java$math$BigDecimal$$$undscale$2 = $m_Ljava_math_BigDecimal$().java$math$BigDecimal$$safeLongToInt__J__I(new $c_sjsr_RuntimeLong().init___I__I(newScale_$_lo$2, newScale_$_hi$2));
      this.$$undprecision$2 = mcPrecision;
      this.setUnscaledValue__p2__Ljava_math_BigInteger__V(integerAndFraction.get(0))
    }
  }
});
$c_Ljava_math_BigDecimal.prototype.init___Ljava_math_BigInteger__I = (function(unscaledVal, scale) {
  $c_Ljava_math_BigDecimal.prototype.init___.call(this);
  if ((unscaledVal === null)) {
    throw new $c_jl_NullPointerException().init___T("unscaledVal == null")
  };
  this.java$math$BigDecimal$$$undscale$2 = scale;
  this.setUnscaledValue__p2__Ljava_math_BigInteger__V(unscaledVal);
  return this
});
$c_Ljava_math_BigDecimal.prototype.toString__T = (function() {
  if ((this.$$undtoStringImage$2 !== null)) {
    return this.$$undtoStringImage$2
  } else if ((this.java$math$BigDecimal$$$undbitLength$2 < 32)) {
    this.$$undtoStringImage$2 = $m_Ljava_math_Conversion$().toDecimalScaledString__J__I__T(this.java$math$BigDecimal$$$undsmallValue$2, this.java$math$BigDecimal$$$undscale$2);
    return this.$$undtoStringImage$2
  } else {
    var this$1 = this.java$math$BigDecimal$$getUnscaledValue__Ljava_math_BigInteger();
    var intString = $m_Ljava_math_Conversion$().toDecimalScaledString__Ljava_math_BigInteger__T(this$1);
    if ((this.java$math$BigDecimal$$$undscale$2 === 0)) {
      return intString
    } else {
      var this$2 = this.java$math$BigDecimal$$getUnscaledValue__Ljava_math_BigInteger();
      if ((this$2.sign$2 < 0)) {
        var begin = 2
      } else {
        var begin = 1
      };
      var end = $uI(intString.length);
      var value = this.java$math$BigDecimal$$$undscale$2;
      var hi = (value >> 31);
      var lo = ((-value) | 0);
      var hi$1 = ((value !== 0) ? (~hi) : ((-hi) | 0));
      var hi$2 = (end >> 31);
      var lo$1 = ((lo + end) | 0);
      var hi$3 = ((((-2147483648) ^ lo$1) < ((-2147483648) ^ lo)) ? ((1 + ((hi$1 + hi$2) | 0)) | 0) : ((hi$1 + hi$2) | 0));
      var hi$4 = (begin >> 31);
      var lo$2 = ((lo$1 - begin) | 0);
      var hi$5 = ((((-2147483648) ^ lo$2) > ((-2147483648) ^ lo$1)) ? (((-1) + ((hi$3 - hi$4) | 0)) | 0) : ((hi$3 - hi$4) | 0));
      if (((this.java$math$BigDecimal$$$undscale$2 > 0) && ((hi$5 === (-1)) ? (((-2147483648) ^ lo$2) >= 2147483642) : (hi$5 > (-1))))) {
        if ((hi$5 >= 0)) {
          $m_Ljava_math_BigDecimal$();
          var pos = ((end - this.java$math$BigDecimal$$$undscale$2) | 0);
          $m_Ljava_math_BigDecimal$();
          var result = (($as_T(intString.substring(0, pos)) + ".") + $as_T(intString.substring(pos)))
        } else {
          $m_Ljava_math_BigDecimal$();
          $m_Ljava_math_BigDecimal$();
          var pos$1 = (((-1) + begin) | 0);
          $m_Ljava_math_BigDecimal$();
          var s = (($as_T(intString.substring(0, pos$1)) + "0.") + $as_T(intString.substring(pos$1)));
          var pos$2 = ((1 + begin) | 0);
          var s2 = $m_Ljava_math_BigDecimal$().java$math$BigDecimal$$CharZeros$1;
          var s2Len = (((-1) - lo$2) | 0);
          $m_Ljava_math_BigDecimal$();
          var s2$1 = $as_T(s2.substring(0, s2Len));
          var result = ((("" + $as_T(s.substring(0, pos$2))) + s2$1) + $as_T(s.substring(pos$2)))
        }
      } else {
        var r0 = ((((end - begin) | 0) >= 1) ? ($m_Ljava_math_BigDecimal$(), $m_Ljava_math_BigDecimal$(), (($as_T(intString.substring(0, begin)) + ".") + $as_T(intString.substring(begin)))) : intString);
        var r1 = (r0 + "E");
        var r2 = (((hi$5 === 0) ? (lo$2 !== 0) : (hi$5 > 0)) ? (r1 + "+") : r1);
        var result = (r2 + $m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toString__I__I__T(lo$2, hi$5))
      };
      this.$$undtoStringImage$2 = result;
      return this.$$undtoStringImage$2
    }
  }
});
$c_Ljava_math_BigDecimal.prototype.signum__I = (function() {
  if ((this.java$math$BigDecimal$$$undbitLength$2 < 64)) {
    var t = this.java$math$BigDecimal$$$undsmallValue$2;
    var hi = t.hi$2;
    if ((hi < 0)) {
      return (-1)
    } else {
      var t$1 = this.java$math$BigDecimal$$$undsmallValue$2;
      var lo$1 = t$1.lo$2;
      var hi$1 = t$1.hi$2;
      if (((hi$1 === 0) ? (lo$1 !== 0) : (hi$1 > 0))) {
        return 1
      } else {
        return 0
      }
    }
  } else {
    var this$1 = this.java$math$BigDecimal$$getUnscaledValue__Ljava_math_BigInteger();
    return this$1.sign$2
  }
});
$c_Ljava_math_BigDecimal.prototype.compareTo__O__I = (function(x$1) {
  return this.compareTo__Ljava_math_BigDecimal__I($as_Ljava_math_BigDecimal(x$1))
});
$c_Ljava_math_BigDecimal.prototype.init___I__I = (function(smallValue, scale) {
  $c_Ljava_math_BigDecimal.prototype.init___.call(this);
  var hi = (smallValue >> 31);
  this.java$math$BigDecimal$$$undsmallValue$2 = new $c_sjsr_RuntimeLong().init___I__I(smallValue, hi);
  this.java$math$BigDecimal$$$undscale$2 = scale;
  this.java$math$BigDecimal$$$undbitLength$2 = $m_Ljava_math_BigDecimal$().java$math$BigDecimal$$bitLength__I__I(smallValue);
  return this
});
$c_Ljava_math_BigDecimal.prototype.toBigInteger__Ljava_math_BigInteger = (function() {
  if (((this.java$math$BigDecimal$$$undscale$2 === 0) || this.isZero__p2__Z())) {
    return this.java$math$BigDecimal$$getUnscaledValue__Ljava_math_BigInteger()
  } else if ((this.java$math$BigDecimal$$$undscale$2 < 0)) {
    var jsx$2 = this.java$math$BigDecimal$$getUnscaledValue__Ljava_math_BigInteger();
    var jsx$1 = $m_Ljava_math_Multiplication$();
    var value = this.java$math$BigDecimal$$$undscale$2;
    var hi = (value >> 31);
    var lo = ((-value) | 0);
    var hi$1 = ((value !== 0) ? (~hi) : ((-hi) | 0));
    return jsx$2.multiply__Ljava_math_BigInteger__Ljava_math_BigInteger(jsx$1.powerOf10__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(lo, hi$1)))
  } else {
    var jsx$4 = this.java$math$BigDecimal$$getUnscaledValue__Ljava_math_BigInteger();
    var jsx$3 = $m_Ljava_math_Multiplication$();
    var value$1 = this.java$math$BigDecimal$$$undscale$2;
    var hi$2 = (value$1 >> 31);
    return jsx$4.divide__Ljava_math_BigInteger__Ljava_math_BigInteger(jsx$3.powerOf10__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(value$1, hi$2)))
  }
});
$c_Ljava_math_BigDecimal.prototype.init___T__Ljava_math_MathContext = (function(sVal, mc) {
  $c_Ljava_math_BigDecimal.prototype.init___AC__I__I.call(this, $m_sjsr_RuntimeString$().toCharArray__T__AC(sVal), 0, $uI(sVal.length));
  this.inplaceRound__p2__Ljava_math_MathContext__V(mc);
  return this
});
$c_Ljava_math_BigDecimal.prototype.scaleByPowerOfTen__I__Ljava_math_BigDecimal = (function(n) {
  var value = this.java$math$BigDecimal$$$undscale$2;
  var hi = (value >> 31);
  var hi$1 = (n >> 31);
  var lo = ((value - n) | 0);
  var hi$2 = ((((-2147483648) ^ lo) > ((-2147483648) ^ value)) ? (((-1) + ((hi - hi$1) | 0)) | 0) : ((hi - hi$1) | 0));
  if ((this.java$math$BigDecimal$$$undbitLength$2 < 64)) {
    var t = this.java$math$BigDecimal$$$undsmallValue$2;
    var lo$1 = t.lo$2;
    var hi$3 = t.hi$2;
    if (((lo$1 === 0) && (hi$3 === 0))) {
      return $m_Ljava_math_BigDecimal$().java$math$BigDecimal$$zeroScaledBy__J__Ljava_math_BigDecimal(new $c_sjsr_RuntimeLong().init___I__I(lo, hi$2))
    } else {
      return $m_Ljava_math_BigDecimal$().valueOf__J__I__Ljava_math_BigDecimal(this.java$math$BigDecimal$$$undsmallValue$2, $m_Ljava_math_BigDecimal$().java$math$BigDecimal$$safeLongToInt__J__I(new $c_sjsr_RuntimeLong().init___I__I(lo, hi$2)))
    }
  } else {
    return new $c_Ljava_math_BigDecimal().init___Ljava_math_BigInteger__I(this.java$math$BigDecimal$$getUnscaledValue__Ljava_math_BigInteger(), $m_Ljava_math_BigDecimal$().java$math$BigDecimal$$safeLongToInt__J__I(new $c_sjsr_RuntimeLong().init___I__I(lo, hi$2)))
  }
});
$c_Ljava_math_BigDecimal.prototype.precision__I = (function() {
  if ((this.$$undprecision$2 === 0)) {
    if ((this.java$math$BigDecimal$$$undbitLength$2 === 0)) {
      var jsx$1 = 1
    } else if ((this.java$math$BigDecimal$$$undbitLength$2 < 64)) {
      var jsx$1 = this.decimalDigitsInLong__p2__J__I(this.java$math$BigDecimal$$$undsmallValue$2)
    } else {
      var decimalDigits = ((1 + $doubleToInt((0.3010299956639812 * (((-1) + this.java$math$BigDecimal$$$undbitLength$2) | 0)))) | 0);
      var jsx$3 = this.java$math$BigDecimal$$getUnscaledValue__Ljava_math_BigInteger();
      var jsx$2 = $m_Ljava_math_Multiplication$();
      var hi = (decimalDigits >> 31);
      var this$1 = jsx$3.divide__Ljava_math_BigInteger__Ljava_math_BigInteger(jsx$2.powerOf10__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(decimalDigits, hi)));
      if ((this$1.sign$2 !== 0)) {
        var jsx$1 = ((1 + decimalDigits) | 0)
      } else {
        var jsx$1 = decimalDigits
      }
    };
    this.$$undprecision$2 = jsx$1
  };
  return this.$$undprecision$2
});
$c_Ljava_math_BigDecimal.prototype.toBigIntegerExact__Ljava_math_BigInteger = (function() {
  if (((this.java$math$BigDecimal$$$undscale$2 === 0) || this.isZero__p2__Z())) {
    return this.java$math$BigDecimal$$getUnscaledValue__Ljava_math_BigInteger()
  } else if ((this.java$math$BigDecimal$$$undscale$2 < 0)) {
    var jsx$2 = this.java$math$BigDecimal$$getUnscaledValue__Ljava_math_BigInteger();
    var jsx$1 = $m_Ljava_math_Multiplication$();
    var value = this.java$math$BigDecimal$$$undscale$2;
    var hi = (value >> 31);
    var lo = ((-value) | 0);
    var hi$1 = ((value !== 0) ? (~hi) : ((-hi) | 0));
    return jsx$2.multiply__Ljava_math_BigInteger__Ljava_math_BigInteger(jsx$1.powerOf10__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(lo, hi$1)))
  } else {
    if (((this.java$math$BigDecimal$$$undscale$2 > this.approxPrecision__p2__I()) || (this.java$math$BigDecimal$$$undscale$2 > this.java$math$BigDecimal$$getUnscaledValue__Ljava_math_BigInteger().getLowestSetBit__I()))) {
      throw new $c_jl_ArithmeticException().init___T("Rounding necessary")
    };
    var jsx$4 = this.java$math$BigDecimal$$getUnscaledValue__Ljava_math_BigInteger();
    var jsx$3 = $m_Ljava_math_Multiplication$();
    var value$1 = this.java$math$BigDecimal$$$undscale$2;
    var hi$2 = (value$1 >> 31);
    var integerAndFraction = jsx$4.divideAndRemainder__Ljava_math_BigInteger__ALjava_math_BigInteger(jsx$3.powerOf10__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(value$1, hi$2)));
    var this$3 = integerAndFraction.get(1);
    if ((this$3.sign$2 !== 0)) {
      throw new $c_jl_ArithmeticException().init___T("Rounding necessary")
    };
    return integerAndFraction.get(0)
  }
});
$c_Ljava_math_BigDecimal.prototype.shortValueExact__S = (function() {
  var t = this.valueExact__p2__I__J(16);
  var lo = t.lo$2;
  return ((lo << 16) >> 16)
});
$c_Ljava_math_BigDecimal.prototype.setUnscaledValue__p2__Ljava_math_BigInteger__V = (function(unscaledVal) {
  this.$$undintVal$2 = unscaledVal;
  this.java$math$BigDecimal$$$undbitLength$2 = $m_Ljava_math_BitLevel$().bitLength__Ljava_math_BigInteger__I(unscaledVal);
  if ((this.java$math$BigDecimal$$$undbitLength$2 < 64)) {
    this.java$math$BigDecimal$$$undsmallValue$2 = unscaledVal.longValue__J()
  }
});
$c_Ljava_math_BigDecimal.prototype.byteValueExact__B = (function() {
  var t = this.valueExact__p2__I__J(8);
  var lo = t.lo$2;
  return ((lo << 24) >> 24)
});
$c_Ljava_math_BigDecimal.prototype.smallRound__p2__Ljava_math_MathContext__I__V = (function(mc, discardedPrecision) {
  var t = $m_Ljava_math_BigDecimal$().LongTenPows$1.get(discardedPrecision);
  var lo = t.lo$2;
  var hi = t.hi$2;
  var value = this.java$math$BigDecimal$$$undscale$2;
  var hi$1 = (value >> 31);
  var hi$2 = (discardedPrecision >> 31);
  var lo$1 = ((value - discardedPrecision) | 0);
  var hi$3 = ((((-2147483648) ^ lo$1) > ((-2147483648) ^ value)) ? (((-1) + ((hi$1 - hi$2) | 0)) | 0) : ((hi$1 - hi$2) | 0));
  var t$1 = this.java$math$BigDecimal$$$undsmallValue$2;
  var lo$2 = t$1.lo$2;
  var hi$4 = t$1.hi$2;
  var this$2 = $m_sjsr_RuntimeLong$();
  var lo$3 = this$2.divideImpl__I__I__I__I__I(lo$2, hi$4, lo, hi);
  var hi$5 = this$2.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  var this$3 = $m_sjsr_RuntimeLong$();
  var lo$4 = this$3.remainderImpl__I__I__I__I__I(lo$2, hi$4, lo, hi);
  var hi$6 = this$3.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  if ((!((lo$4 === 0) && (hi$6 === 0)))) {
    var jsx$1 = $m_Ljava_math_BigDecimal$();
    if ((hi$6 < 0)) {
      var lo$5 = ((-lo$4) | 0);
      var hi$7 = ((lo$4 !== 0) ? (~hi$6) : ((-hi$6) | 0));
      var this$7_$_lo$2 = lo$5;
      var this$7_$_hi$2 = hi$7
    } else {
      var this$7_$_lo$2 = lo$4;
      var this$7_$_hi$2 = hi$6
    };
    var lo$6 = (this$7_$_lo$2 << 1);
    var hi$8 = (((this$7_$_lo$2 >>> 31) | 0) | (this$7_$_hi$2 << 1));
    var compRem = jsx$1.java$math$BigDecimal$$longCompareTo__J__J__I(new $c_sjsr_RuntimeLong().init___I__I(lo$6, hi$8), new $c_sjsr_RuntimeLong().init___I__I(lo, hi));
    var frac = $imul(((hi$6 < 0) ? (-1) : (((hi$6 === 0) && (lo$4 === 0)) ? 0 : 1)), ((5 + compRem) | 0));
    var value$1 = $m_Ljava_math_BigDecimal$().java$math$BigDecimal$$roundingBehavior__I__I__Ljava_math_RoundingMode__I((1 & lo$3), frac, mc.roundingMode$1);
    var hi$9 = (value$1 >> 31);
    var lo$7 = ((lo$3 + value$1) | 0);
    var hi$10 = ((((-2147483648) ^ lo$7) < ((-2147483648) ^ lo$3)) ? ((1 + ((hi$5 + hi$9) | 0)) | 0) : ((hi$5 + hi$9) | 0));
    if ((hi$10 < 0)) {
      var lo$8 = ((-lo$7) | 0);
      var hi$11 = ((lo$7 !== 0) ? (~hi$10) : ((-hi$10) | 0));
      var this$13_$_lo$2 = lo$8;
      var this$13_$_hi$2 = hi$11
    } else {
      var this$13_$_lo$2 = lo$7;
      var this$13_$_hi$2 = hi$10
    };
    var a = $m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toDouble__I__I__D(this$13_$_lo$2, this$13_$_hi$2);
    var v = $g.Math.log10;
    if ((((!(v === (void 0))) ? $uD($g.Math.log10(a)) : ($uD($g.Math.log(a)) / 2.302585092994046)) >= mc.precision$1)) {
      var lo$9 = (((-1) + lo$1) | 0);
      var hi$12 = ((lo$9 !== (-1)) ? hi$3 : (((-1) + hi$3) | 0));
      var this$20 = $m_sjsr_RuntimeLong$();
      var lo$10 = this$20.divideImpl__I__I__I__I__I(lo$7, hi$10, 10, 0);
      var hi$13 = this$20.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
      var x1_$_$$und1$f = null;
      var x1_$_$$und2$f = null;
      var x1_$_$$und1$mcJ$sp$f = new $c_sjsr_RuntimeLong().init___I__I(lo$9, hi$12);
      var x1_$_$$und2$mcJ$sp$f = new $c_sjsr_RuntimeLong().init___I__I(lo$10, hi$13)
    } else {
      var x1_$_$$und1$f = null;
      var x1_$_$$und2$f = null;
      var x1_$_$$und1$mcJ$sp$f = new $c_sjsr_RuntimeLong().init___I__I(lo$1, hi$3);
      var x1_$_$$und2$mcJ$sp$f = new $c_sjsr_RuntimeLong().init___I__I(lo$7, hi$10)
    }
  } else {
    var x1_$_$$und1$f = null;
    var x1_$_$$und2$f = null;
    var x1_$_$$und1$mcJ$sp$f = new $c_sjsr_RuntimeLong().init___I__I(lo$1, hi$3);
    var x1_$_$$und2$mcJ$sp$f = new $c_sjsr_RuntimeLong().init___I__I(lo$3, hi$5)
  };
  var t$2 = x1_$_$$und1$mcJ$sp$f;
  var lo$11 = t$2.lo$2;
  var hi$14 = t$2.hi$2;
  var t$3 = x1_$_$$und2$mcJ$sp$f;
  var lo$12 = t$3.lo$2;
  var hi$15 = t$3.hi$2;
  this.java$math$BigDecimal$$$undscale$2 = $m_Ljava_math_BigDecimal$().java$math$BigDecimal$$safeLongToInt__J__I(new $c_sjsr_RuntimeLong().init___I__I(lo$11, hi$14));
  this.$$undprecision$2 = mc.precision$1;
  this.java$math$BigDecimal$$$undsmallValue$2 = new $c_sjsr_RuntimeLong().init___I__I(lo$12, hi$15);
  this.java$math$BigDecimal$$$undbitLength$2 = $m_Ljava_math_BigDecimal$().bitLength__J__I(new $c_sjsr_RuntimeLong().init___I__I(lo$12, hi$15));
  this.$$undintVal$2 = null
});
$c_Ljava_math_BigDecimal.prototype.approxPrecision__p2__I = (function() {
  return ((this.$$undprecision$2 > 0) ? this.$$undprecision$2 : ((1 + $doubleToInt((0.3010299956639812 * (((-1) + this.java$math$BigDecimal$$$undbitLength$2) | 0)))) | 0))
});
$c_Ljava_math_BigDecimal.prototype.doubleValue__D = (function() {
  var sign = this.signum__I();
  var value = this.java$math$BigDecimal$$$undbitLength$2;
  var hi = (value >> 31);
  var this$1 = $m_sjsr_RuntimeLong$();
  var value$1 = (this.java$math$BigDecimal$$$undscale$2 / 0.3010299956639812);
  var lo = this$1.scala$scalajs$runtime$RuntimeLong$$fromDoubleImpl__D__I(value$1);
  var hi$1 = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  var lo$1 = ((value - lo) | 0);
  var hi$2 = ((((-2147483648) ^ lo$1) > ((-2147483648) ^ value)) ? (((-1) + ((hi - hi$1) | 0)) | 0) : ((hi - hi$1) | 0));
  if ((((hi$2 === (-1)) ? (((-2147483648) ^ lo$1) < 2147482574) : (hi$2 < (-1))) || (sign === 0))) {
    return (0.0 * sign)
  } else if (((hi$2 === 0) ? (((-2147483648) ^ lo$1) > (-2147482623)) : (hi$2 > 0))) {
    return (Infinity * sign)
  } else {
    var mantissa0 = this.java$math$BigDecimal$$getUnscaledValue__Ljava_math_BigInteger().abs__Ljava_math_BigInteger();
    var exponent = 1076;
    if ((this.java$math$BigDecimal$$$undscale$2 <= 0)) {
      var jsx$1 = $m_Ljava_math_Multiplication$();
      var value$2 = ((-this.java$math$BigDecimal$$$undscale$2) | 0);
      var hi$3 = (value$2 >> 31);
      var mantissa = mantissa0.multiply__Ljava_math_BigInteger__Ljava_math_BigInteger(jsx$1.powerOf10__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(value$2, hi$3)))
    } else {
      var jsx$2 = $m_Ljava_math_Multiplication$();
      var value$3 = this.java$math$BigDecimal$$$undscale$2;
      var hi$4 = (value$3 >> 31);
      var powerOfTen = jsx$2.powerOf10__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(value$3, hi$4));
      var k = ((100 - lo$1) | 0);
      if ((k > 0)) {
        exponent = ((exponent - k) | 0);
        var m = mantissa0.shiftLeft__I__Ljava_math_BigInteger(k)
      } else {
        var m = mantissa0
      };
      var qr = m.divideAndRemainderImpl__Ljava_math_BigInteger__Ljava_math_BigInteger$QuotAndRem(powerOfTen);
      var compRem = qr.rem$1.shiftLeftOneBit__Ljava_math_BigInteger().compareTo__Ljava_math_BigInteger__I(powerOfTen);
      exponent = (((-2) + exponent) | 0);
      var this$3 = qr.quot$1.shiftLeft__I__Ljava_math_BigInteger(2);
      var jsx$3 = $m_Ljava_math_BigInteger$();
      var value$4 = ((1 + (($imul(compRem, ((3 + compRem) | 0)) / 2) | 0)) | 0);
      var hi$5 = (value$4 >> 31);
      var bi = jsx$3.valueOf__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(value$4, hi$5));
      var mantissa = $m_Ljava_math_Elementary$().add__Ljava_math_BigInteger__Ljava_math_BigInteger__Ljava_math_BigInteger(this$3, bi)
    };
    var lowestSetBit = mantissa.getLowestSetBit__I();
    var discardedSize = (((-54) + $m_Ljava_math_BitLevel$().bitLength__Ljava_math_BigInteger__I(mantissa)) | 0);
    var bits_$_lo$2 = 0;
    var bits_$_hi$2 = 0;
    var tempBits_$_lo$2 = 0;
    var tempBits_$_hi$2 = 0;
    if ((discardedSize > 0)) {
      var t = mantissa.shiftRight__I__Ljava_math_BigInteger(discardedSize).longValue__J();
      var lo$2 = t.lo$2;
      var hi$6 = t.hi$2;
      var jsx$4_$_lo$2 = lo$2;
      var jsx$4_$_hi$2 = hi$6;
      bits_$_lo$2 = jsx$4_$_lo$2;
      bits_$_hi$2 = jsx$4_$_hi$2;
      tempBits_$_lo$2 = bits_$_lo$2;
      tempBits_$_hi$2 = bits_$_hi$2;
      var b_$_lo$2 = bits_$_lo$2;
      var b_$_hi$2 = bits_$_hi$2;
      var lo$3 = (1 & b_$_lo$2);
      if (((lo$3 === 1) && (lowestSetBit < discardedSize))) {
        var jsx$5 = true
      } else {
        var b$1_$_lo$2 = bits_$_lo$2;
        var b$1_$_hi$2 = bits_$_hi$2;
        var lo$4 = (3 & b$1_$_lo$2);
        var jsx$5 = (lo$4 === 3)
      };
      if (jsx$5) {
        var b$2_$_lo$2 = bits_$_lo$2;
        var b$2_$_hi$2 = bits_$_hi$2;
        var bhi = b$2_$_hi$2;
        var lo$5 = ((2 + b$2_$_lo$2) | 0);
        var hi$7 = ((((-2147483648) ^ lo$5) < (-2147483646)) ? ((1 + bhi) | 0) : bhi);
        var jsx$6_$_lo$2 = lo$5;
        var jsx$6_$_hi$2 = hi$7;
        bits_$_lo$2 = jsx$6_$_lo$2;
        bits_$_hi$2 = jsx$6_$_hi$2
      }
    } else {
      var t$1 = mantissa.longValue__J();
      var lo$6 = t$1.lo$2;
      var hi$8 = t$1.hi$2;
      var n = ((-discardedSize) | 0);
      var lo$7 = (((32 & n) === 0) ? (lo$6 << n) : 0);
      var hi$9 = (((32 & n) === 0) ? (((((lo$6 >>> 1) | 0) >>> ((31 - n) | 0)) | 0) | (hi$8 << n)) : (lo$6 << n));
      var jsx$7_$_lo$2 = lo$7;
      var jsx$7_$_hi$2 = hi$9;
      bits_$_lo$2 = jsx$7_$_lo$2;
      bits_$_hi$2 = jsx$7_$_hi$2;
      tempBits_$_lo$2 = bits_$_lo$2;
      tempBits_$_hi$2 = bits_$_hi$2;
      var b$3_$_lo$2 = bits_$_lo$2;
      var b$3_$_hi$2 = bits_$_hi$2;
      var lo$8 = (3 & b$3_$_lo$2);
      if ((lo$8 === 3)) {
        var b$4_$_lo$2 = bits_$_lo$2;
        var b$4_$_hi$2 = bits_$_hi$2;
        var bhi$1 = b$4_$_hi$2;
        var lo$9 = ((2 + b$4_$_lo$2) | 0);
        var hi$10 = ((((-2147483648) ^ lo$9) < (-2147483646)) ? ((1 + bhi$1) | 0) : bhi$1);
        var jsx$8_$_lo$2 = lo$9;
        var jsx$8_$_hi$2 = hi$10;
        bits_$_lo$2 = jsx$8_$_lo$2;
        bits_$_hi$2 = jsx$8_$_hi$2
      }
    };
    var b$5_$_lo$2 = bits_$_lo$2;
    var b$5_$_hi$2 = bits_$_hi$2;
    var hi$11 = (4194304 & b$5_$_hi$2);
    if ((hi$11 === 0)) {
      var this$6_$_lo$2 = bits_$_lo$2;
      var this$6_$_hi$2 = bits_$_hi$2;
      var lo$10 = (((this$6_$_lo$2 >>> 1) | 0) | (this$6_$_hi$2 << 31));
      var hi$12 = (this$6_$_hi$2 >> 1);
      var jsx$9_$_lo$2 = lo$10;
      var jsx$9_$_hi$2 = hi$12;
      bits_$_lo$2 = jsx$9_$_lo$2;
      bits_$_hi$2 = jsx$9_$_hi$2;
      exponent = ((exponent + discardedSize) | 0)
    } else {
      var this$7_$_lo$2 = bits_$_lo$2;
      var this$7_$_hi$2 = bits_$_hi$2;
      var lo$11 = (((this$7_$_lo$2 >>> 2) | 0) | (this$7_$_hi$2 << 30));
      var hi$13 = (this$7_$_hi$2 >> 2);
      var jsx$10_$_lo$2 = lo$11;
      var jsx$10_$_hi$2 = hi$13;
      bits_$_lo$2 = jsx$10_$_lo$2;
      bits_$_hi$2 = jsx$10_$_hi$2;
      exponent = ((exponent + ((1 + discardedSize) | 0)) | 0)
    };
    if ((exponent > 2046)) {
      return (Infinity * sign)
    } else if ((exponent < (-53))) {
      return (0.0 * sign)
    } else {
      if ((exponent <= 0)) {
        var this$8_$_lo$2 = tempBits_$_lo$2;
        var this$8_$_hi$2 = tempBits_$_hi$2;
        var lo$12 = (((this$8_$_lo$2 >>> 1) | 0) | (this$8_$_hi$2 << 31));
        var hi$14 = (this$8_$_hi$2 >> 1);
        var jsx$11_$_lo$2 = lo$12;
        var jsx$11_$_hi$2 = hi$14;
        bits_$_lo$2 = jsx$11_$_lo$2;
        bits_$_hi$2 = jsx$11_$_hi$2;
        var this$9_$_lo$2 = bits_$_lo$2;
        var this$9_$_hi$2 = bits_$_hi$2;
        var n$1 = ((63 + exponent) | 0);
        var lo$13 = (((32 & n$1) === 0) ? ((((-1) >>> n$1) | 0) | ((-2) << ((31 - n$1) | 0))) : (((-1) >>> n$1) | 0));
        var hi$15 = (((32 & n$1) === 0) ? (((-1) >>> n$1) | 0) : 0);
        var lo$14 = (this$9_$_lo$2 & lo$13);
        var hi$16 = (this$9_$_hi$2 & hi$15);
        var jsx$12_$_lo$2 = lo$14;
        var jsx$12_$_hi$2 = hi$16;
        tempBits_$_lo$2 = jsx$12_$_lo$2;
        tempBits_$_hi$2 = jsx$12_$_hi$2;
        var this$10_$_lo$2 = bits_$_lo$2;
        var this$10_$_hi$2 = bits_$_hi$2;
        var n$2 = ((-exponent) | 0);
        var lo$15 = (((32 & n$2) === 0) ? (((this$10_$_lo$2 >>> n$2) | 0) | ((this$10_$_hi$2 << 1) << ((31 - n$2) | 0))) : (this$10_$_hi$2 >> n$2));
        var hi$17 = (((32 & n$2) === 0) ? (this$10_$_hi$2 >> n$2) : (this$10_$_hi$2 >> 31));
        var jsx$13_$_lo$2 = lo$15;
        var jsx$13_$_hi$2 = hi$17;
        bits_$_lo$2 = jsx$13_$_lo$2;
        bits_$_hi$2 = jsx$13_$_hi$2;
        var b$6_$_lo$2 = bits_$_lo$2;
        var b$6_$_hi$2 = bits_$_hi$2;
        var lo$16 = (3 & b$6_$_lo$2);
        if ((lo$16 === 3)) {
          var jsx$14 = true
        } else {
          var b$7_$_lo$2 = bits_$_lo$2;
          var b$7_$_hi$2 = bits_$_hi$2;
          var lo$17 = (1 & b$7_$_lo$2);
          if ((lo$17 === 1)) {
            var this$11_$_lo$2 = tempBits_$_lo$2;
            var this$11_$_hi$2 = tempBits_$_hi$2;
            var jsx$15 = (!((this$11_$_lo$2 === 0) && (this$11_$_hi$2 === 0)))
          } else {
            var jsx$15 = false
          };
          if (jsx$15) {
            var jsx$14 = (lowestSetBit < discardedSize)
          } else {
            var jsx$14 = false
          }
        };
        if (jsx$14) {
          var b$8_$_lo$2 = bits_$_lo$2;
          var b$8_$_hi$2 = bits_$_hi$2;
          var bhi$2 = b$8_$_hi$2;
          var lo$18 = ((1 + b$8_$_lo$2) | 0);
          var hi$18 = ((lo$18 === 0) ? ((1 + bhi$2) | 0) : bhi$2);
          var jsx$16_$_lo$2 = lo$18;
          var jsx$16_$_hi$2 = hi$18;
          bits_$_lo$2 = jsx$16_$_lo$2;
          bits_$_hi$2 = jsx$16_$_hi$2
        };
        exponent = 0;
        var this$13_$_lo$2 = bits_$_lo$2;
        var this$13_$_hi$2 = bits_$_hi$2;
        var lo$19 = (((this$13_$_lo$2 >>> 1) | 0) | (this$13_$_hi$2 << 31));
        var hi$19 = (this$13_$_hi$2 >> 1);
        var jsx$17_$_lo$2 = lo$19;
        var jsx$17_$_hi$2 = hi$19;
        bits_$_lo$2 = jsx$17_$_lo$2;
        bits_$_hi$2 = jsx$17_$_hi$2
      };
      var hi$20 = (sign >> 31);
      var hi$21 = ((-2147483648) & hi$20);
      var value$5 = exponent;
      var hi$23 = (value$5 << 20);
      var hi$24 = (hi$21 | hi$23);
      var b$9_$_lo$2 = bits_$_lo$2;
      var b$9_$_hi$2 = bits_$_hi$2;
      var lo$20 = b$9_$_lo$2;
      var hi$25 = (1048575 & b$9_$_hi$2);
      var hi$26 = (hi$24 | hi$25);
      return $m_sjsr_Bits$().longBitsToDouble__J__D(new $c_sjsr_RuntimeLong().init___I__I(lo$20, hi$26))
    }
  }
});
$c_Ljava_math_BigDecimal.prototype.init___J__I = (function(smallValue, scale) {
  $c_Ljava_math_BigDecimal.prototype.init___.call(this);
  this.java$math$BigDecimal$$$undsmallValue$2 = smallValue;
  this.java$math$BigDecimal$$$undscale$2 = scale;
  this.java$math$BigDecimal$$$undbitLength$2 = $m_Ljava_math_BigDecimal$().bitLength__J__I(smallValue);
  return this
});
$c_Ljava_math_BigDecimal.prototype.hashCode__I = (function() {
  if ((this.$$undhashCode$2 !== 0)) {
    return this.$$undhashCode$2
  } else if ((this.java$math$BigDecimal$$$undbitLength$2 < 64)) {
    var t = this.java$math$BigDecimal$$$undsmallValue$2;
    var lo = t.lo$2;
    this.$$undhashCode$2 = lo;
    var jsx$1 = this.$$undhashCode$2;
    var t$1 = this.java$math$BigDecimal$$$undsmallValue$2;
    var hi$1 = t$1.hi$2;
    this.$$undhashCode$2 = (($imul(33, jsx$1) + hi$1) | 0);
    this.$$undhashCode$2 = (($imul(17, this.$$undhashCode$2) + this.java$math$BigDecimal$$$undscale$2) | 0);
    return this.$$undhashCode$2
  } else {
    this.$$undhashCode$2 = (($imul(17, this.$$undintVal$2.hashCode__I()) + this.java$math$BigDecimal$$$undscale$2) | 0);
    return this.$$undhashCode$2
  }
});
$c_Ljava_math_BigDecimal.prototype.init___T = (function(sVal) {
  $c_Ljava_math_BigDecimal.prototype.init___AC__I__I.call(this, $m_sjsr_RuntimeString$().toCharArray__T__AC(sVal), 0, $uI(sVal.length));
  return this
});
$c_Ljava_math_BigDecimal.prototype.intValue__I = (function() {
  return (((this.java$math$BigDecimal$$$undscale$2 <= (-32)) || (this.java$math$BigDecimal$$$undscale$2 > this.approxPrecision__p2__I())) ? 0 : this.toBigInteger__Ljava_math_BigInteger().intValue__I())
});
$c_Ljava_math_BigDecimal.prototype.init___Ljava_math_BigInteger = (function(bi) {
  $c_Ljava_math_BigDecimal.prototype.init___Ljava_math_BigInteger__I.call(this, bi, 0);
  return this
});
$c_Ljava_math_BigDecimal.prototype.floatValue__F = (function() {
  var value = this.java$math$BigDecimal$$$undbitLength$2;
  var hi = (value >> 31);
  var this$1 = $m_sjsr_RuntimeLong$();
  var value$1 = (this.java$math$BigDecimal$$$undscale$2 / 0.3010299956639812);
  var lo = this$1.scala$scalajs$runtime$RuntimeLong$$fromDoubleImpl__D__I(value$1);
  var hi$1 = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  var lo$1 = ((value - lo) | 0);
  var hi$2 = ((((-2147483648) ^ lo$1) > ((-2147483648) ^ value)) ? (((-1) + ((hi - hi$1) | 0)) | 0) : ((hi - hi$1) | 0));
  var floatResult0 = $fround(this.signum__I());
  var floatResult = ((((hi$2 === (-1)) ? (((-2147483648) ^ lo$1) < 2147483499) : (hi$2 < (-1))) || (floatResult0 === 0.0)) ? $fround((0.0 * floatResult0)) : (((hi$2 === 0) ? (((-2147483648) ^ lo$1) > (-2147483519)) : (hi$2 > 0)) ? $fround((Infinity * floatResult0)) : $fround(this.doubleValue__D())));
  return floatResult
});
$c_Ljava_math_BigDecimal.prototype.init___AC__I__I = (function($in, offset, len) {
  $c_Ljava_math_BigDecimal.prototype.init___.call(this);
  var last = (((-1) + ((offset + len) | 0)) | 0);
  if (($in === null)) {
    throw new $c_jl_NullPointerException().init___T("in == null")
  };
  if (((((last >= $in.u.length) || (offset < 0)) || (len <= 0)) || (last < 0))) {
    throw new $c_jl_NumberFormatException().init___T(((((("Bad offset/length: offset=" + offset) + " len=") + len) + " in.length=") + $in.u.length))
  };
  var index = offset;
  if (((offset <= last) && ($in.get(offset) === 43))) {
    index = ((1 + index) | 0);
    if ((index < last)) {
      $m_Ljava_math_BigDecimal$();
      var c = $in.get(index);
      var array = [new $c_jl_Character().init___C(43), new $c_jl_Character().init___C(45)];
      var elem = new $c_jl_Character().init___C(c);
      var i = 0;
      while (true) {
        if ((i < $uI(array.length))) {
          var index$1 = i;
          var arg1 = array[index$1];
          var jsx$2 = ($m_sr_BoxesRunTime$().equals__O__O__Z(arg1, elem) === false)
        } else {
          var jsx$2 = false
        };
        if (jsx$2) {
          i = ((1 + i) | 0)
        } else {
          break
        }
      };
      var jsx$1 = (i !== $uI(array.length))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      throw new $c_jl_NumberFormatException().init___T(("For input string: " + $in.toString__T()))
    }
  } else {
    var isMinus = ((index <= last) && ($in.get(index) === 45));
    if ((((1 + index) | 0) < last)) {
      $m_Ljava_math_BigDecimal$();
      var c$1 = $in.get(((1 + index) | 0));
      var array$1 = [new $c_jl_Character().init___C(43), new $c_jl_Character().init___C(45)];
      var elem$1 = new $c_jl_Character().init___C(c$1);
      var i$1 = 0;
      while (true) {
        if ((i$1 < $uI(array$1.length))) {
          var index$2 = i$1;
          var arg1$1 = array$1[index$2];
          var jsx$3 = ($m_sr_BoxesRunTime$().equals__O__O__Z(arg1$1, elem$1) === false)
        } else {
          var jsx$3 = false
        };
        if (jsx$3) {
          i$1 = ((1 + i$1) | 0)
        } else {
          break
        }
      };
      var nextIsSign = (i$1 !== $uI(array$1.length))
    } else {
      var nextIsSign = false
    };
    if ((isMinus && nextIsSign)) {
      throw new $c_jl_NumberFormatException().init___T(("For input string: " + $in.toString__T()))
    }
  };
  var begin = index;
  var counter = 0;
  var wasNonZero = false;
  while (true) {
    if ((index <= last)) {
      $m_Ljava_math_BigDecimal$();
      var c$2 = $in.get(index);
      var array$2 = [new $c_jl_Character().init___C(46), new $c_jl_Character().init___C(101), new $c_jl_Character().init___C(69)];
      var elem$2 = new $c_jl_Character().init___C(c$2);
      var i$2 = 0;
      while (true) {
        if ((i$2 < $uI(array$2.length))) {
          var index$3 = i$2;
          var arg1$2 = array$2[index$3];
          var jsx$5 = ($m_sr_BoxesRunTime$().equals__O__O__Z(arg1$2, elem$2) === false)
        } else {
          var jsx$5 = false
        };
        if (jsx$5) {
          i$2 = ((1 + i$2) | 0)
        } else {
          break
        }
      };
      var jsx$4 = (!(i$2 !== $uI(array$2.length)))
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      if ((!wasNonZero)) {
        if (($in.get(index) === 48)) {
          counter = ((1 + counter) | 0)
        } else {
          wasNonZero = true
        }
      };
      index = ((1 + index) | 0)
    } else {
      break
    }
  };
  var this$30 = $m_sjsr_RuntimeString$();
  var count = ((index - begin) | 0);
  var u = this$30.newString__AC__I__I__T($in, begin, count);
  var b = ((index - begin) | 0);
  if (((index <= last) && ($in.get(index) === 46))) {
    index = ((1 + index) | 0);
    var begin$2 = index;
    while (true) {
      if ((index <= last)) {
        $m_Ljava_math_BigDecimal$();
        var c$3 = $in.get(index);
        var array$3 = [new $c_jl_Character().init___C(101), new $c_jl_Character().init___C(69)];
        var elem$3 = new $c_jl_Character().init___C(c$3);
        var i$3 = 0;
        while (true) {
          if ((i$3 < $uI(array$3.length))) {
            var index$4 = i$3;
            var arg1$3 = array$3[index$4];
            var jsx$7 = ($m_sr_BoxesRunTime$().equals__O__O__Z(arg1$3, elem$3) === false)
          } else {
            var jsx$7 = false
          };
          if (jsx$7) {
            i$3 = ((1 + i$3) | 0)
          } else {
            break
          }
        };
        var jsx$6 = (!(i$3 !== $uI(array$3.length)))
      } else {
        var jsx$6 = false
      };
      if (jsx$6) {
        if ((!wasNonZero)) {
          if (($in.get(index) === 48)) {
            counter = ((1 + counter) | 0)
          } else {
            wasNonZero = true
          }
        };
        index = ((1 + index) | 0)
      } else {
        break
      }
    };
    this.java$math$BigDecimal$$$undscale$2 = ((index - begin$2) | 0);
    var this$40 = $m_sjsr_RuntimeString$();
    var count$1 = this.java$math$BigDecimal$$$undscale$2;
    var _1 = (("" + u) + this$40.newString__AC__I__I__T($in, begin$2, count$1));
    var _2 = ((b + this.java$math$BigDecimal$$$undscale$2) | 0);
    var x1_$_$$und1$f = _1;
    var x1_$_$$und2$f = _2
  } else {
    this.java$math$BigDecimal$$$undscale$2 = 0;
    var x1_$_$$und1$f = u;
    var x1_$_$$und2$f = b
  };
  var unscaled = $as_T(x1_$_$$und1$f);
  var bufLength = $uI(x1_$_$$und2$f);
  if ((index <= last)) {
    $m_Ljava_math_BigDecimal$();
    var c$4 = $in.get(index);
    var array$4 = [new $c_jl_Character().init___C(101), new $c_jl_Character().init___C(69)];
    var elem$4 = new $c_jl_Character().init___C(c$4);
    var i$4 = 0;
    while (true) {
      if ((i$4 < $uI(array$4.length))) {
        var index$5 = i$4;
        var arg1$4 = array$4[index$5];
        var jsx$9 = ($m_sr_BoxesRunTime$().equals__O__O__Z(arg1$4, elem$4) === false)
      } else {
        var jsx$9 = false
      };
      if (jsx$9) {
        i$4 = ((1 + i$4) | 0)
      } else {
        break
      }
    };
    var jsx$8 = (i$4 !== $uI(array$4.length))
  } else {
    var jsx$8 = false
  };
  if (jsx$8) {
    index = ((1 + index) | 0);
    var indexIsPlus = ((index <= last) && ($in.get(index) === 43));
    var nextIsNotMinus = ((((1 + index) | 0) <= last) && ($in.get(((1 + index) | 0)) !== 45));
    var begin$3 = ((indexIsPlus && nextIsNotMinus) ? ((1 + index) | 0) : index);
    var this$50 = $m_sjsr_RuntimeString$();
    var count$2 = ((((1 + last) | 0) - begin$3) | 0);
    var scaleString = this$50.newString__AC__I__I__T($in, begin$3, count$2);
    var value = this.java$math$BigDecimal$$$undscale$2;
    var hi = (value >> 31);
    var this$51 = $m_jl_Integer$();
    var value$1 = this$51.parseInt__T__I__I(scaleString, 10);
    var hi$1 = (value$1 >> 31);
    var lo = ((value - value$1) | 0);
    var hi$2 = ((((-2147483648) ^ lo) > ((-2147483648) ^ value)) ? (((-1) + ((hi - hi$1) | 0)) | 0) : ((hi - hi$1) | 0));
    this.java$math$BigDecimal$$$undscale$2 = lo;
    var value$2 = this.java$math$BigDecimal$$$undscale$2;
    var hi$3 = (value$2 >> 31);
    if ((!((lo === value$2) && (hi$2 === hi$3)))) {
      throw new $c_jl_NumberFormatException().init___T("Scale out of range")
    }
  };
  if ((bufLength < 19)) {
    var this$53 = $m_jl_Long$();
    this.java$math$BigDecimal$$$undsmallValue$2 = this$53.parseLong__T__I__J(unscaled, 10);
    this.java$math$BigDecimal$$$undbitLength$2 = $m_Ljava_math_BigDecimal$().bitLength__J__I(this.java$math$BigDecimal$$$undsmallValue$2)
  } else {
    this.setUnscaledValue__p2__Ljava_math_BigInteger__V(new $c_Ljava_math_BigInteger().init___T(unscaled))
  };
  return this
});
$c_Ljava_math_BigDecimal.prototype.decimalDigitsInLong__p2__J__I = (function(value) {
  if (((value.lo$2 === 0) && (value.hi$2 === (-2147483648)))) {
    return 19
  } else {
    var jsx$3 = $m_ju_Arrays$();
    var jsx$2 = $m_Ljava_math_BigDecimal$().LongTenPows$1;
    var ahi = value.hi$2;
    if ((ahi < 0)) {
      var lo = value.lo$2;
      var hi = value.hi$2;
      var lo$1 = ((-lo) | 0);
      var hi$1 = ((lo !== 0) ? (~hi) : ((-hi) | 0));
      var x_$_lo$2 = lo$1;
      var x_$_hi$2 = hi$1;
      var jsx$1 = new $c_sjsr_RuntimeLong().init___I__I(x_$_lo$2, x_$_hi$2)
    } else {
      var jsx$1 = value
    };
    var index = jsx$3.binarySearch__AJ__J__I(jsx$2, jsx$1);
    return ((index < 0) ? (((-1) - index) | 0) : ((1 + index) | 0))
  }
});
$c_Ljava_math_BigDecimal.prototype.java$math$BigDecimal$$getUnscaledValue__Ljava_math_BigInteger = (function() {
  if ((this.$$undintVal$2 === null)) {
    this.$$undintVal$2 = $m_Ljava_math_BigInteger$().valueOf__J__Ljava_math_BigInteger(this.java$math$BigDecimal$$$undsmallValue$2)
  };
  return this.$$undintVal$2
});
$c_Ljava_math_BigDecimal.prototype.compareTo__Ljava_math_BigDecimal__I = (function(bi) {
  var thisSign = this.signum__I();
  var valueSign = bi.signum__I();
  if ((thisSign === valueSign)) {
    if ((((this.java$math$BigDecimal$$$undscale$2 === bi.java$math$BigDecimal$$$undscale$2) && (this.java$math$BigDecimal$$$undbitLength$2 < 64)) && (bi.java$math$BigDecimal$$$undbitLength$2 < 64))) {
      var t = this.java$math$BigDecimal$$$undsmallValue$2;
      var lo = t.lo$2;
      var hi = t.hi$2;
      var b = bi.java$math$BigDecimal$$$undsmallValue$2;
      var bhi = b.hi$2;
      if (((hi === bhi) ? (((-2147483648) ^ lo) < ((-2147483648) ^ b.lo$2)) : (hi < bhi))) {
        return (-1)
      } else {
        var t$1 = this.java$math$BigDecimal$$$undsmallValue$2;
        var lo$1 = t$1.lo$2;
        var hi$1 = t$1.hi$2;
        var b$1 = bi.java$math$BigDecimal$$$undsmallValue$2;
        var bhi$1 = b$1.hi$2;
        if (((hi$1 === bhi$1) ? (((-2147483648) ^ lo$1) > ((-2147483648) ^ b$1.lo$2)) : (hi$1 > bhi$1))) {
          return 1
        } else {
          return 0
        }
      }
    } else {
      var value = this.java$math$BigDecimal$$$undscale$2;
      var hi$2 = (value >> 31);
      var value$1 = bi.java$math$BigDecimal$$$undscale$2;
      var hi$3 = (value$1 >> 31);
      var lo$2 = ((value - value$1) | 0);
      var hi$4 = ((((-2147483648) ^ lo$2) > ((-2147483648) ^ value)) ? (((-1) + ((hi$2 - hi$3) | 0)) | 0) : ((hi$2 - hi$3) | 0));
      var diffPrecision = ((this.approxPrecision__p2__I() - bi.approxPrecision__p2__I()) | 0);
      var hi$5 = (diffPrecision >> 31);
      var lo$3 = ((1 + lo$2) | 0);
      var hi$6 = ((lo$3 === 0) ? ((1 + hi$4) | 0) : hi$4);
      if (((hi$5 === hi$6) ? (((-2147483648) ^ diffPrecision) > ((-2147483648) ^ lo$3)) : (hi$5 > hi$6))) {
        return thisSign
      } else {
        var hi$7 = (diffPrecision >> 31);
        var lo$4 = (((-1) + lo$2) | 0);
        var hi$8 = ((lo$4 !== (-1)) ? hi$4 : (((-1) + hi$4) | 0));
        if (((hi$7 === hi$8) ? (((-2147483648) ^ diffPrecision) < ((-2147483648) ^ lo$4)) : (hi$7 < hi$8))) {
          return ((-thisSign) | 0)
        } else {
          var t$2 = this.java$math$BigDecimal$$getUnscaledValue__Ljava_math_BigInteger();
          var v = bi.java$math$BigDecimal$$getUnscaledValue__Ljava_math_BigInteger();
          if ((hi$4 < 0)) {
            var jsx$1 = $m_Ljava_math_Multiplication$();
            var lo$5 = ((-lo$2) | 0);
            var hi$9 = ((lo$2 !== 0) ? (~hi$4) : ((-hi$4) | 0));
            var _1 = t$2.multiply__Ljava_math_BigInteger__Ljava_math_BigInteger(jsx$1.powerOf10__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(lo$5, hi$9)));
            var x1_$_$$und1$f = _1;
            var x1_$_$$und2$f = v
          } else if (((hi$4 === 0) ? (lo$2 !== 0) : (hi$4 > 0))) {
            var _2 = v.multiply__Ljava_math_BigInteger__Ljava_math_BigInteger($m_Ljava_math_Multiplication$().powerOf10__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(lo$2, hi$4)));
            var x1_$_$$und1$f = t$2;
            var x1_$_$$und2$f = _2
          } else {
            var x1_$_$$und1$f = t$2;
            var x1_$_$$und2$f = v
          };
          var thisUnscaled = $as_Ljava_math_BigInteger(x1_$_$$und1$f);
          var valUnscaled = $as_Ljava_math_BigInteger(x1_$_$$und2$f);
          return thisUnscaled.compareTo__Ljava_math_BigInteger__I(valUnscaled)
        }
      }
    }
  } else {
    return ((thisSign < valueSign) ? (-1) : 1)
  }
});
function $as_Ljava_math_BigDecimal(obj) {
  return (((obj instanceof $c_Ljava_math_BigDecimal) || (obj === null)) ? obj : $throwClassCastException(obj, "java.math.BigDecimal"))
}
function $isArrayOf_Ljava_math_BigDecimal(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Ljava_math_BigDecimal)))
}
function $asArrayOf_Ljava_math_BigDecimal(obj, depth) {
  return (($isArrayOf_Ljava_math_BigDecimal(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.math.BigDecimal;", depth))
}
var $d_Ljava_math_BigDecimal = new $TypeData().initClass({
  Ljava_math_BigDecimal: 0
}, false, "java.math.BigDecimal", {
  Ljava_math_BigDecimal: 1,
  jl_Number: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  jl_Comparable: 1
});
$c_Ljava_math_BigDecimal.prototype.$classData = $d_Ljava_math_BigDecimal;
/** @constructor */
function $c_Ljava_math_BigInteger() {
  $c_jl_Number.call(this);
  this.digits$2 = null;
  this.numberLength$2 = 0;
  this.sign$2 = 0;
  this.java$math$BigInteger$$firstNonzeroDigit$2 = 0;
  this.$$undhashCode$2 = 0
}
$c_Ljava_math_BigInteger.prototype = new $h_jl_Number();
$c_Ljava_math_BigInteger.prototype.constructor = $c_Ljava_math_BigInteger;
/** @constructor */
function $h_Ljava_math_BigInteger() {
  /*<skip>*/
}
$h_Ljava_math_BigInteger.prototype = $c_Ljava_math_BigInteger.prototype;
$c_Ljava_math_BigInteger.prototype.pow__I__Ljava_math_BigInteger = (function(exp) {
  if ((exp < 0)) {
    throw new $c_jl_ArithmeticException().init___T("Negative exponent")
  } else if ((exp === 0)) {
    return $m_Ljava_math_BigInteger$().ONE$1
  } else if ((((exp === 1) || this.equals__O__Z($m_Ljava_math_BigInteger$().ONE$1)) || this.equals__O__Z($m_Ljava_math_BigInteger$().ZERO$1))) {
    return this
  } else if ((!this.testBit__I__Z(0))) {
    var x = 1;
    while ((!this.testBit__I__Z(x))) {
      x = ((1 + x) | 0)
    };
    return $m_Ljava_math_BigInteger$().getPowerOfTwo__I__Ljava_math_BigInteger($imul(x, exp)).multiply__Ljava_math_BigInteger__Ljava_math_BigInteger(this.shiftRight__I__Ljava_math_BigInteger(x).pow__I__Ljava_math_BigInteger(exp))
  } else {
    return $m_Ljava_math_Multiplication$().pow__Ljava_math_BigInteger__I__Ljava_math_BigInteger(this, exp)
  }
});
$c_Ljava_math_BigInteger.prototype.longValue__J = (function() {
  if ((this.numberLength$2 > 1)) {
    var value = this.digits$2.get(1);
    var value$1 = this.digits$2.get(0);
    var value$3_$_lo$2 = value$1;
    var value$3_$_hi$2 = value
  } else {
    var value$2 = this.digits$2.get(0);
    var value$3_$_lo$2 = value$2;
    var value$3_$_hi$2 = 0
  };
  var value$4 = this.sign$2;
  var hi$3 = (value$4 >> 31);
  var blo = value$3_$_lo$2;
  var a0 = (65535 & value$4);
  var a1 = ((value$4 >>> 16) | 0);
  var b0 = (65535 & blo);
  var b1 = ((blo >>> 16) | 0);
  var a0b0 = $imul(a0, b0);
  var a1b0 = $imul(a1, b0);
  var a0b1 = $imul(a0, b1);
  var lo = ((a0b0 + (((a1b0 + a0b1) | 0) << 16)) | 0);
  var c1part = ((((a0b0 >>> 16) | 0) + a0b1) | 0);
  var hi$4 = (((((((($imul(value$4, value$3_$_hi$2) + $imul(hi$3, blo)) | 0) + $imul(a1, b1)) | 0) + ((c1part >>> 16) | 0)) | 0) + (((((65535 & c1part) + a1b0) | 0) >>> 16) | 0)) | 0);
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi$4)
});
$c_Ljava_math_BigInteger.prototype.init___ = (function() {
  this.java$math$BigInteger$$firstNonzeroDigit$2 = (-2);
  this.$$undhashCode$2 = 0;
  return this
});
$c_Ljava_math_BigInteger.prototype.divide__Ljava_math_BigInteger__Ljava_math_BigInteger = (function(divisor) {
  if ((divisor.sign$2 === 0)) {
    throw new $c_jl_ArithmeticException().init___T("BigInteger divide by zero")
  };
  var divisorSign = divisor.sign$2;
  if (divisor.isOne__Z()) {
    return ((divisor.sign$2 > 0) ? this : this.negate__Ljava_math_BigInteger())
  } else {
    var thisSign = this.sign$2;
    var thisLen = this.numberLength$2;
    var divisorLen = divisor.numberLength$2;
    if ((((thisLen + divisorLen) | 0) === 2)) {
      var value = this.digits$2.get(0);
      var value$1 = divisor.digits$2.get(0);
      var this$1 = $m_sjsr_RuntimeLong$();
      var lo = this$1.divideImpl__I__I__I__I__I(value, 0, value$1, 0);
      var hi$2 = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
      var bi_$_lo$2 = lo;
      var bi_$_hi$2 = hi$2;
      if ((thisSign !== divisorSign)) {
        var this$2_$_lo$2 = bi_$_lo$2;
        var this$2_$_hi$2 = bi_$_hi$2;
        var lo$1 = this$2_$_lo$2;
        var hi$3 = this$2_$_hi$2;
        var lo$2 = ((-lo$1) | 0);
        var hi$4 = ((lo$1 !== 0) ? (~hi$3) : ((-hi$3) | 0));
        var jsx$1_$_lo$2 = lo$2;
        var jsx$1_$_hi$2 = hi$4;
        bi_$_lo$2 = jsx$1_$_lo$2;
        bi_$_hi$2 = jsx$1_$_hi$2
      };
      return $m_Ljava_math_BigInteger$().valueOf__J__Ljava_math_BigInteger(new $c_sjsr_RuntimeLong().init___I__I(bi_$_lo$2, bi_$_hi$2))
    } else {
      var cmp = ((thisLen !== divisorLen) ? ((thisLen > divisorLen) ? 1 : (-1)) : $m_Ljava_math_Elementary$().compareArrays__AI__AI__I__I(this.digits$2, divisor.digits$2, thisLen));
      if ((cmp === 0)) {
        return ((thisSign === divisorSign) ? $m_Ljava_math_BigInteger$().ONE$1 : $m_Ljava_math_BigInteger$().MINUS$undONE$1)
      } else if ((cmp === (-1))) {
        return $m_Ljava_math_BigInteger$().ZERO$1
      } else {
        var resLength = ((1 + ((thisLen - divisorLen) | 0)) | 0);
        var resDigits = $newArrayObject($d_I.getArrayOf(), [resLength]);
        var resSign = ((thisSign === divisorSign) ? 1 : (-1));
        if ((divisorLen === 1)) {
          $m_Ljava_math_Division$().divideArrayByInt__AI__AI__I__I__I(resDigits, this.digits$2, thisLen, divisor.digits$2.get(0))
        } else {
          $m_Ljava_math_Division$().divide__AI__I__AI__I__AI__I__AI(resDigits, resLength, this.digits$2, thisLen, divisor.digits$2, divisorLen)
        };
        var result = new $c_Ljava_math_BigInteger().init___I__I__AI(resSign, resLength, resDigits);
        result.cutOffLeadingZeroes__V();
        return result
      }
    }
  }
});
$c_Ljava_math_BigInteger.prototype.equals__O__Z = (function(x) {
  if ((x instanceof $c_Ljava_math_BigInteger)) {
    var x2 = $as_Ljava_math_BigInteger(x);
    return (((this.sign$2 === x2.sign$2) && (this.numberLength$2 === x2.numberLength$2)) && this.equalsArrays__AI__Z(x2.digits$2))
  } else {
    return false
  }
});
$c_Ljava_math_BigInteger.prototype.toString__T = (function() {
  return $m_Ljava_math_Conversion$().toDecimalScaledString__Ljava_math_BigInteger__T(this)
});
$c_Ljava_math_BigInteger.prototype.compareTo__O__I = (function(x$1) {
  return this.compareTo__Ljava_math_BigInteger__I($as_Ljava_math_BigInteger(x$1))
});
$c_Ljava_math_BigInteger.prototype.init___I__I = (function(sign, value) {
  $c_Ljava_math_BigInteger.prototype.init___.call(this);
  this.sign$2 = sign;
  this.numberLength$2 = 1;
  this.digits$2 = $makeNativeArrayWrapper($d_I.getArrayOf(), [value]);
  return this
});
$c_Ljava_math_BigInteger.prototype.getFirstNonzeroDigit__I = (function() {
  if ((this.java$math$BigInteger$$firstNonzeroDigit$2 === (-2))) {
    if ((this.sign$2 === 0)) {
      var jsx$1 = (-1)
    } else {
      var i = 0;
      while ((this.digits$2.get(i) === 0)) {
        i = ((1 + i) | 0)
      };
      var jsx$1 = i
    };
    this.java$math$BigInteger$$firstNonzeroDigit$2 = jsx$1
  };
  return this.java$math$BigInteger$$firstNonzeroDigit$2
});
$c_Ljava_math_BigInteger.prototype.equalsArrays__AI__Z = (function(b) {
  var i = 0;
  while ((i !== this.numberLength$2)) {
    if ((this.digits$2.get(i) !== b.get(i))) {
      return false
    };
    i = ((1 + i) | 0)
  };
  return true
});
$c_Ljava_math_BigInteger.prototype.abs__Ljava_math_BigInteger = (function() {
  return ((this.sign$2 < 0) ? new $c_Ljava_math_BigInteger().init___I__I__AI(1, this.numberLength$2, this.digits$2) : this)
});
$c_Ljava_math_BigInteger.prototype.setFromString__p2__T__I__V = (function(s, radix) {
  if ((((s === "") || (s === "+")) || (s === "-"))) {
    throw new $c_jl_NumberFormatException().init___T("Zero length BigInteger")
  };
  var stringLength0 = $uI(s.length);
  if (((65535 & $uI(s.charCodeAt(0))) === 45)) {
    var _3 = (((-1) + stringLength0) | 0);
    var x1_$_$$und1$1 = (-1);
    var x1_$_$$und2$1 = 1;
    var x1_$_$$und3$1 = _3
  } else if (((65535 & $uI(s.charCodeAt(0))) === 43)) {
    var _3$1 = (((-1) + stringLength0) | 0);
    var x1_$_$$und1$1 = 1;
    var x1_$_$$und2$1 = 1;
    var x1_$_$$und3$1 = _3$1
  } else {
    var x1_$_$$und1$1 = 1;
    var x1_$_$$und2$1 = 0;
    var x1_$_$$und3$1 = stringLength0
  };
  var _sign = $uI(x1_$_$$und1$1);
  var startChar = $uI(x1_$_$$und2$1);
  var stringLength = $uI(x1_$_$$und3$1);
  var i = startChar;
  while ((i < stringLength0)) {
    var arg1 = i;
    var c = (65535 & $uI(s.charCodeAt(arg1)));
    if (((c === 43) || (c === 45))) {
      throw new $c_jl_NumberFormatException().init___T("Illegal embedded sign character")
    };
    i = ((1 + i) | 0)
  };
  var charsPerInt = $m_Ljava_math_Conversion$().DigitFitInInt$1.get(radix);
  var bigRadixDigitsLength = ((stringLength / charsPerInt) | 0);
  var topChars = ((stringLength % charsPerInt) | 0);
  if ((topChars !== 0)) {
    bigRadixDigitsLength = ((1 + bigRadixDigitsLength) | 0)
  };
  var _digits = $newArrayObject($d_I.getArrayOf(), [bigRadixDigitsLength]);
  var bigRadix = $m_Ljava_math_Conversion$().BigRadices$1.get((((-2) + radix) | 0));
  var digitIndex = 0;
  var substrEnd = ((startChar + ((topChars === 0) ? charsPerInt : topChars)) | 0);
  var newDigit = 0;
  var substrStart = startChar;
  while ((substrStart < stringLength0)) {
    var jsx$1 = $m_jl_Integer$();
    var beginIndex = substrStart;
    var endIndex = substrEnd;
    var bigRadixDigit = jsx$1.parseInt__T__I__I($as_T(s.substring(beginIndex, endIndex)), radix);
    var this$9 = $m_Ljava_math_Multiplication$();
    var aSize = digitIndex;
    newDigit = this$9.multiplyByInt__p1__AI__AI__I__I__I(_digits, _digits, aSize, bigRadix);
    newDigit = ((newDigit + $m_Ljava_math_Elementary$().inplaceAdd__AI__I__I__I(_digits, digitIndex, bigRadixDigit)) | 0);
    _digits.set(digitIndex, newDigit);
    digitIndex = ((1 + digitIndex) | 0);
    substrStart = substrEnd;
    substrEnd = ((substrStart + charsPerInt) | 0)
  };
  this.sign$2 = _sign;
  this.numberLength$2 = digitIndex;
  this.digits$2 = _digits;
  this.cutOffLeadingZeroes__V()
});
$c_Ljava_math_BigInteger.prototype.divideAndRemainderImpl__Ljava_math_BigInteger__Ljava_math_BigInteger$QuotAndRem = (function(divisor) {
  var divisorSign = divisor.sign$2;
  if ((divisorSign === 0)) {
    throw new $c_jl_ArithmeticException().init___T("BigInteger divide by zero")
  };
  var divisorLen = divisor.numberLength$2;
  var divisorDigits = divisor.digits$2;
  if ((divisorLen === 1)) {
    return $m_Ljava_math_Division$().divideAndRemainderByInteger__Ljava_math_BigInteger__I__I__Ljava_math_BigInteger$QuotAndRem(this, divisorDigits.get(0), divisorSign)
  } else {
    var thisDigits = this.digits$2;
    var thisLen = this.numberLength$2;
    var cmp = ((thisLen !== divisorLen) ? ((thisLen > divisorLen) ? 1 : (-1)) : $m_Ljava_math_Elementary$().compareArrays__AI__AI__I__I(thisDigits, divisorDigits, thisLen));
    if ((cmp < 0)) {
      return new $c_Ljava_math_BigInteger$QuotAndRem().init___Ljava_math_BigInteger__Ljava_math_BigInteger($m_Ljava_math_BigInteger$().ZERO$1, this)
    } else {
      var thisSign = this.sign$2;
      var quotientLength = ((1 + ((thisLen - divisorLen) | 0)) | 0);
      var quotientSign = ((thisSign === divisorSign) ? 1 : (-1));
      var quotientDigits = $newArrayObject($d_I.getArrayOf(), [quotientLength]);
      var remainderDigits = $m_Ljava_math_Division$().divide__AI__I__AI__I__AI__I__AI(quotientDigits, quotientLength, thisDigits, thisLen, divisorDigits, divisorLen);
      var result0 = new $c_Ljava_math_BigInteger().init___I__I__AI(quotientSign, quotientLength, quotientDigits);
      var result1 = new $c_Ljava_math_BigInteger().init___I__I__AI(thisSign, divisorLen, remainderDigits);
      result0.cutOffLeadingZeroes__V();
      result1.cutOffLeadingZeroes__V();
      return new $c_Ljava_math_BigInteger$QuotAndRem().init___Ljava_math_BigInteger__Ljava_math_BigInteger(result0, result1)
    }
  }
});
$c_Ljava_math_BigInteger.prototype.cutOffLeadingZeroes__V = (function() {
  _loop: while (true) {
    if ((this.numberLength$2 > 0)) {
      this.numberLength$2 = (((-1) + this.numberLength$2) | 0);
      if ((this.digits$2.get(this.numberLength$2) === 0)) {
        continue _loop
      }
    };
    break
  };
  if ((this.digits$2.get(this.numberLength$2) === 0)) {
    this.sign$2 = 0
  };
  this.numberLength$2 = ((1 + this.numberLength$2) | 0)
});
$c_Ljava_math_BigInteger.prototype.testBit__I__Z = (function(n) {
  var intCount = (n >> 5);
  if ((n === 0)) {
    return ((1 & this.digits$2.get(0)) !== 0)
  } else if ((n < 0)) {
    throw new $c_jl_ArithmeticException().init___T("Negative bit address")
  } else if ((intCount >= this.numberLength$2)) {
    return (this.sign$2 < 0)
  } else if ((!((this.sign$2 < 0) && (intCount < this.getFirstNonzeroDigit__I())))) {
    var digit = this.digits$2.get(intCount);
    if ((this.sign$2 < 0)) {
      digit = ((this.getFirstNonzeroDigit__I() === intCount) ? ((-digit) | 0) : (~digit))
    };
    var i = (1 << (31 & n));
    return ((digit & i) !== 0)
  } else {
    return false
  }
});
$c_Ljava_math_BigInteger.prototype.getLowestSetBit__I = (function() {
  if ((this.sign$2 === 0)) {
    return (-1)
  } else {
    var i = this.getFirstNonzeroDigit__I();
    var i$1 = this.digits$2.get(i);
    return (((i << 5) + ((i$1 === 0) ? 32 : ((31 - $clz32((i$1 & ((-i$1) | 0)))) | 0))) | 0)
  }
});
$c_Ljava_math_BigInteger.prototype.negate__Ljava_math_BigInteger = (function() {
  return ((this.sign$2 === 0) ? this : new $c_Ljava_math_BigInteger().init___I__I__AI(((-this.sign$2) | 0), this.numberLength$2, this.digits$2))
});
$c_Ljava_math_BigInteger.prototype.init___I__I__AI = (function(sign, numberLength, digits) {
  $c_Ljava_math_BigInteger.prototype.init___.call(this);
  this.sign$2 = sign;
  this.numberLength$2 = numberLength;
  this.digits$2 = digits;
  return this
});
$c_Ljava_math_BigInteger.prototype.shiftLeftOneBit__Ljava_math_BigInteger = (function() {
  return ((this.sign$2 === 0) ? this : $m_Ljava_math_BitLevel$().shiftLeftOneBit__Ljava_math_BigInteger__Ljava_math_BigInteger(this))
});
$c_Ljava_math_BigInteger.prototype.init___T__I = (function(s, radix) {
  $c_Ljava_math_BigInteger.prototype.init___.call(this);
  $m_Ljava_math_BigInteger$();
  if ((s === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  if (((radix < 2) || (radix > 36))) {
    throw new $c_jl_NumberFormatException().init___T("Radix out of range")
  };
  if ((s === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  if ((s === "")) {
    throw new $c_jl_NumberFormatException().init___T("Zero length BigInteger")
  };
  this.setFromString__p2__T__I__V(s, radix);
  return this
});
$c_Ljava_math_BigInteger.prototype.hashCode__I = (function() {
  if ((this.$$undhashCode$2 !== 0)) {
    return this.$$undhashCode$2
  } else {
    var end = this.numberLength$2;
    var i = 0;
    while ((i < end)) {
      var arg1 = i;
      this.$$undhashCode$2 = (($imul(33, this.$$undhashCode$2) + this.digits$2.get(arg1)) | 0);
      i = ((1 + i) | 0)
    };
    this.$$undhashCode$2 = $imul(this.$$undhashCode$2, this.sign$2);
    return this.$$undhashCode$2
  }
});
$c_Ljava_math_BigInteger.prototype.divideAndRemainder__Ljava_math_BigInteger__ALjava_math_BigInteger = (function(divisor) {
  return this.divideAndRemainderImpl__Ljava_math_BigInteger__Ljava_math_BigInteger$QuotAndRem(divisor).toArray__ALjava_math_BigInteger()
});
$c_Ljava_math_BigInteger.prototype.init___T = (function(s) {
  $c_Ljava_math_BigInteger.prototype.init___T__I.call(this, s, 10);
  return this
});
$c_Ljava_math_BigInteger.prototype.shiftLeft__I__Ljava_math_BigInteger = (function(n) {
  return (((n === 0) || (this.sign$2 === 0)) ? this : ((n > 0) ? $m_Ljava_math_BitLevel$().shiftLeft__Ljava_math_BigInteger__I__Ljava_math_BigInteger(this, n) : $m_Ljava_math_BitLevel$().shiftRight__Ljava_math_BigInteger__I__Ljava_math_BigInteger(this, ((-n) | 0))))
});
$c_Ljava_math_BigInteger.prototype.isOne__Z = (function() {
  return ((this.numberLength$2 === 1) && (this.digits$2.get(0) === 1))
});
$c_Ljava_math_BigInteger.prototype.intValue__I = (function() {
  return $imul(this.sign$2, this.digits$2.get(0))
});
$c_Ljava_math_BigInteger.prototype.multiply__Ljava_math_BigInteger__Ljava_math_BigInteger = (function(bi) {
  if (((bi.sign$2 === 0) || (this.sign$2 === 0))) {
    return $m_Ljava_math_BigInteger$().ZERO$1
  } else {
    var this$1 = $m_Ljava_math_Multiplication$();
    return this$1.karatsuba__Ljava_math_BigInteger__Ljava_math_BigInteger__Ljava_math_BigInteger(this, bi)
  }
});
$c_Ljava_math_BigInteger.prototype.init___I__J = (function(sign, lVal) {
  $c_Ljava_math_BigInteger.prototype.init___.call(this);
  this.sign$2 = sign;
  var lo = lVal.hi$2;
  if ((lo === 0)) {
    this.numberLength$2 = 1;
    this.digits$2 = $makeNativeArrayWrapper($d_I.getArrayOf(), [lVal.lo$2])
  } else {
    this.numberLength$2 = 2;
    this.digits$2 = $makeNativeArrayWrapper($d_I.getArrayOf(), [lVal.lo$2, lo])
  };
  return this
});
$c_Ljava_math_BigInteger.prototype.shiftRight__I__Ljava_math_BigInteger = (function(n) {
  return (((n === 0) || (this.sign$2 === 0)) ? this : ((n > 0) ? $m_Ljava_math_BitLevel$().shiftRight__Ljava_math_BigInteger__I__Ljava_math_BigInteger(this, n) : $m_Ljava_math_BitLevel$().shiftLeft__Ljava_math_BigInteger__I__Ljava_math_BigInteger(this, ((-n) | 0))))
});
$c_Ljava_math_BigInteger.prototype.init___I__AI = (function(signum, digits) {
  $c_Ljava_math_BigInteger.prototype.init___.call(this);
  if ((digits.u.length === 0)) {
    this.sign$2 = 0;
    this.numberLength$2 = 1;
    this.digits$2 = $makeNativeArrayWrapper($d_I.getArrayOf(), [0])
  } else {
    this.sign$2 = signum;
    this.numberLength$2 = digits.u.length;
    this.digits$2 = digits;
    this.cutOffLeadingZeroes__V()
  };
  return this
});
$c_Ljava_math_BigInteger.prototype.compareTo__Ljava_math_BigInteger__I = (function(bi) {
  return ((this.sign$2 > bi.sign$2) ? 1 : ((this.sign$2 < bi.sign$2) ? (-1) : ((this.numberLength$2 > bi.numberLength$2) ? this.sign$2 : ((this.numberLength$2 < bi.numberLength$2) ? ((-bi.sign$2) | 0) : $imul(this.sign$2, $m_Ljava_math_Elementary$().compareArrays__AI__AI__I__I(this.digits$2, bi.digits$2, this.numberLength$2))))))
});
function $as_Ljava_math_BigInteger(obj) {
  return (((obj instanceof $c_Ljava_math_BigInteger) || (obj === null)) ? obj : $throwClassCastException(obj, "java.math.BigInteger"))
}
function $isArrayOf_Ljava_math_BigInteger(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Ljava_math_BigInteger)))
}
function $asArrayOf_Ljava_math_BigInteger(obj, depth) {
  return (($isArrayOf_Ljava_math_BigInteger(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.math.BigInteger;", depth))
}
var $d_Ljava_math_BigInteger = new $TypeData().initClass({
  Ljava_math_BigInteger: 0
}, false, "java.math.BigInteger", {
  Ljava_math_BigInteger: 1,
  jl_Number: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  jl_Comparable: 1
});
$c_Ljava_math_BigInteger.prototype.$classData = $d_Ljava_math_BigInteger;
/** @constructor */
function $c_Ljava_math_RoundingMode() {
  $c_jl_Enum.call(this)
}
$c_Ljava_math_RoundingMode.prototype = new $h_jl_Enum();
$c_Ljava_math_RoundingMode.prototype.constructor = $c_Ljava_math_RoundingMode;
/** @constructor */
function $h_Ljava_math_RoundingMode() {
  /*<skip>*/
}
$h_Ljava_math_RoundingMode.prototype = $c_Ljava_math_RoundingMode.prototype;
$c_Ljava_math_RoundingMode.prototype.init___T__I = (function(name, ordinal) {
  $c_jl_Enum.prototype.init___T__I.call(this, name, ordinal);
  return this
});
var $d_Ljava_math_RoundingMode = new $TypeData().initClass({
  Ljava_math_RoundingMode: 0
}, false, "java.math.RoundingMode", {
  Ljava_math_RoundingMode: 1,
  jl_Enum: 1,
  O: 1,
  jl_Comparable: 1,
  Ljava_io_Serializable: 1
});
$c_Ljava_math_RoundingMode.prototype.$classData = $d_Ljava_math_RoundingMode;
/** @constructor */
function $c_Ljava_net_URI() {
  $c_O.call(this);
  this.origStr$1 = null;
  this.java$net$URI$$$undfld$f = null;
  this.java$net$URI$$$undisAbsolute$1 = false;
  this.$$undisOpaque$1 = false;
  this.java$net$URI$$$undscheme$1 = null;
  this.java$net$URI$$$undschemeSpecificPart$1 = null;
  this.java$net$URI$$$undauthority$1 = null;
  this.java$net$URI$$$unduserInfo$1 = null;
  this.java$net$URI$$$undhost$1 = null;
  this.java$net$URI$$$undport$1 = null;
  this.$$undpath$1 = null;
  this.$$undquery$1 = null;
  this.$$undfragment$1 = null
}
$c_Ljava_net_URI.prototype = new $h_O();
$c_Ljava_net_URI.prototype.constructor = $c_Ljava_net_URI;
/** @constructor */
function $h_Ljava_net_URI() {
  /*<skip>*/
}
$h_Ljava_net_URI.prototype = $c_Ljava_net_URI.prototype;
$c_Ljava_net_URI.prototype.equals__O__Z = (function(that) {
  if ((that instanceof $c_Ljava_net_URI)) {
    var x2 = $as_Ljava_net_URI(that);
    var f = (function($this) {
      return (function(x$2, y$2) {
        var x = $as_T(x$2);
        var y = $as_T(y$2);
        var this$1 = $m_Ljava_net_URI$();
        return this$1.loop$1__p1__I__T__T__I(0, x, y)
      })
    })(this);
    var x$1 = this.java$net$URI$$$undscheme$1;
    var y$1 = x2.java$net$URI$$$undscheme$1;
    if ($m_sr_BoxesRunTime$().equals__O__O__Z(x$1, y$1)) {
      var cmpScheme = 0
    } else if ((x$1 === (void 0))) {
      var cmpScheme = (-1)
    } else if ((y$1 === (void 0))) {
      var cmpScheme = 1
    } else {
      var x$3 = $as_T(x$1);
      var x$4 = $as_T(y$1);
      var cmpScheme = $m_sjsr_RuntimeString$().compareToIgnoreCase__T__T__I(x$3, x$4)
    };
    if ((cmpScheme !== 0)) {
      var jsx$1 = cmpScheme
    } else {
      var x$5 = this.$$undisOpaque$1;
      var y$3 = x2.$$undisOpaque$1;
      var cmpIsOpaque = ((x$5 === y$3) ? 0 : (x$5 ? 1 : (-1)));
      if ((cmpIsOpaque !== 0)) {
        var jsx$1 = cmpIsOpaque
      } else if (this.$$undisOpaque$1) {
        var arg1 = this.java$net$URI$$$undschemeSpecificPart$1;
        var arg2 = x2.java$net$URI$$$undschemeSpecificPart$1;
        var cmpSchemeSpecificPart = $uI(f(arg1, arg2));
        if ((cmpSchemeSpecificPart !== 0)) {
          var jsx$1 = cmpSchemeSpecificPart
        } else {
          var x$6 = this.$$undpath$1;
          var y$4 = x2.$$undpath$1;
          var cmpPath = ($m_sr_BoxesRunTime$().equals__O__O__Z(x$6, y$4) ? 0 : ((x$6 === (void 0)) ? (-1) : ((y$4 === (void 0)) ? 1 : $uI(f(x$6, y$4)))));
          if ((cmpPath !== 0)) {
            var jsx$1 = cmpPath
          } else {
            var x$7 = this.$$undquery$1;
            var y$5 = x2.$$undquery$1;
            var cmpQuery = ($m_sr_BoxesRunTime$().equals__O__O__Z(x$7, y$5) ? 0 : ((x$7 === (void 0)) ? (-1) : ((y$5 === (void 0)) ? 1 : $uI(f(x$7, y$5)))));
            if ((cmpQuery !== 0)) {
              var jsx$1 = cmpQuery
            } else {
              var x$8 = this.$$undfragment$1;
              var y$6 = x2.$$undfragment$1;
              var jsx$1 = ($m_sr_BoxesRunTime$().equals__O__O__Z(x$8, y$6) ? 0 : ((x$8 === (void 0)) ? (-1) : ((y$6 === (void 0)) ? 1 : $uI(f(x$8, y$6)))))
            }
          }
        }
      } else {
        var value = this.java$net$URI$$$undhost$1;
        if ((value !== (void 0))) {
          var value$1 = x2.java$net$URI$$$undhost$1;
          var jsx$2 = (value$1 !== (void 0))
        } else {
          var jsx$2 = false
        };
        if (jsx$2) {
          var x$9 = this.java$net$URI$$$unduserInfo$1;
          var y$7 = x2.java$net$URI$$$unduserInfo$1;
          var cmpUserInfo = ($m_sr_BoxesRunTime$().equals__O__O__Z(x$9, y$7) ? 0 : ((x$9 === (void 0)) ? (-1) : ((y$7 === (void 0)) ? 1 : $uI(f(x$9, y$7)))));
          if ((cmpUserInfo !== 0)) {
            var jsx$1 = cmpUserInfo
          } else {
            var x$10 = this.java$net$URI$$$undhost$1;
            var y$8 = x2.java$net$URI$$$undhost$1;
            if ($m_sr_BoxesRunTime$().equals__O__O__Z(x$10, y$8)) {
              var cmpHost = 0
            } else if ((x$10 === (void 0))) {
              var cmpHost = (-1)
            } else if ((y$8 === (void 0))) {
              var cmpHost = 1
            } else {
              var x$5$1 = $as_T(x$10);
              var x$6$1 = $as_T(y$8);
              var cmpHost = $m_sjsr_RuntimeString$().compareToIgnoreCase__T__T__I(x$5$1, x$6$1)
            };
            if ((cmpHost !== 0)) {
              var jsx$1 = cmpHost
            } else {
              var x$11 = this.java$net$URI$$$undport$1;
              var y$9 = x2.java$net$URI$$$undport$1;
              if ($m_sr_BoxesRunTime$().equals__O__O__Z(x$11, y$9)) {
                var cmpPort = 0
              } else if ((x$11 === (void 0))) {
                var cmpPort = (-1)
              } else if ((y$9 === (void 0))) {
                var cmpPort = 1
              } else {
                var x$7$1 = $uI(x$11);
                var x$8$1 = $uI(y$9);
                var cmpPort = ((x$7$1 - x$8$1) | 0)
              };
              if ((cmpPort !== 0)) {
                var jsx$1 = cmpPort
              } else {
                var x$12 = this.$$undpath$1;
                var y$10 = x2.$$undpath$1;
                var cmpPath$1 = ($m_sr_BoxesRunTime$().equals__O__O__Z(x$12, y$10) ? 0 : ((x$12 === (void 0)) ? (-1) : ((y$10 === (void 0)) ? 1 : $uI(f(x$12, y$10)))));
                if ((cmpPath$1 !== 0)) {
                  var jsx$1 = cmpPath$1
                } else {
                  var x$13 = this.$$undquery$1;
                  var y$11 = x2.$$undquery$1;
                  var cmpQuery$1 = ($m_sr_BoxesRunTime$().equals__O__O__Z(x$13, y$11) ? 0 : ((x$13 === (void 0)) ? (-1) : ((y$11 === (void 0)) ? 1 : $uI(f(x$13, y$11)))));
                  if ((cmpQuery$1 !== 0)) {
                    var jsx$1 = cmpQuery$1
                  } else {
                    var x$14 = this.$$undfragment$1;
                    var y$12 = x2.$$undfragment$1;
                    var jsx$1 = ($m_sr_BoxesRunTime$().equals__O__O__Z(x$14, y$12) ? 0 : ((x$14 === (void 0)) ? (-1) : ((y$12 === (void 0)) ? 1 : $uI(f(x$14, y$12)))))
                  }
                }
              }
            }
          }
        } else {
          var x$15 = this.java$net$URI$$$undauthority$1;
          var y$13 = x2.java$net$URI$$$undauthority$1;
          var cmpAuthority = ($m_sr_BoxesRunTime$().equals__O__O__Z(x$15, y$13) ? 0 : ((x$15 === (void 0)) ? (-1) : ((y$13 === (void 0)) ? 1 : $uI(f(x$15, y$13)))));
          if ((cmpAuthority !== 0)) {
            var jsx$1 = cmpAuthority
          } else {
            var x$16 = this.$$undpath$1;
            var y$14 = x2.$$undpath$1;
            var cmpPath$2 = ($m_sr_BoxesRunTime$().equals__O__O__Z(x$16, y$14) ? 0 : ((x$16 === (void 0)) ? (-1) : ((y$14 === (void 0)) ? 1 : $uI(f(x$16, y$14)))));
            if ((cmpPath$2 !== 0)) {
              var jsx$1 = cmpPath$2
            } else {
              var x$17 = this.$$undquery$1;
              var y$15 = x2.$$undquery$1;
              var cmpQuery$2 = ($m_sr_BoxesRunTime$().equals__O__O__Z(x$17, y$15) ? 0 : ((x$17 === (void 0)) ? (-1) : ((y$15 === (void 0)) ? 1 : $uI(f(x$17, y$15)))));
              if ((cmpQuery$2 !== 0)) {
                var jsx$1 = cmpQuery$2
              } else {
                var x$18 = this.$$undfragment$1;
                var y$16 = x2.$$undfragment$1;
                var jsx$1 = ($m_sr_BoxesRunTime$().equals__O__O__Z(x$18, y$16) ? 0 : ((x$18 === (void 0)) ? (-1) : ((y$16 === (void 0)) ? 1 : $uI(f(x$18, y$16)))))
              }
            }
          }
        }
      }
    };
    return (jsx$1 === 0)
  } else {
    return false
  }
});
$c_Ljava_net_URI.prototype.getQuery__T = (function() {
  var value = this.$$undquery$1;
  if ((value === (void 0))) {
    var value$2 = (void 0)
  } else {
    var str = $as_T(value);
    var value$1 = $m_Ljava_net_URI$().java$net$URI$$decodeComponent__T__T(str);
    var value$2 = value$1
  };
  return $as_T(((value$2 === (void 0)) ? null : value$2))
});
$c_Ljava_net_URI.prototype.toString__T = (function() {
  return this.origStr$1
});
$c_Ljava_net_URI.prototype.compareTo__O__I = (function(x$1) {
  return this.compareTo__Ljava_net_URI__I($as_Ljava_net_URI(x$1))
});
$c_Ljava_net_URI.prototype.getScheme__T = (function() {
  var value = this.java$net$URI$$$undscheme$1;
  return $as_T(((value === (void 0)) ? null : value))
});
$c_Ljava_net_URI.prototype.getRawAuthority__T = (function() {
  var value = this.java$net$URI$$$undauthority$1;
  return $as_T(((value === (void 0)) ? null : value))
});
$c_Ljava_net_URI.prototype.getFragment__T = (function() {
  var value = this.$$undfragment$1;
  if ((value === (void 0))) {
    var value$2 = (void 0)
  } else {
    var str = $as_T(value);
    var value$1 = $m_Ljava_net_URI$().java$net$URI$$decodeComponent__T__T(str);
    var value$2 = value$1
  };
  return $as_T(((value$2 === (void 0)) ? null : value$2))
});
$c_Ljava_net_URI.prototype.init___T__T__T__T__T = (function(scheme, authority, path, query, fragment) {
  $c_Ljava_net_URI.prototype.init___T.call(this, $m_Ljava_net_URI$().java$net$URI$$uriStr__T__T__T__T__T__T(scheme, authority, path, query, fragment));
  return this
});
$c_Ljava_net_URI.prototype.compareTo__Ljava_net_URI__I = (function(that) {
  var f = (function($this) {
    return (function(x$9$2, x$10$2) {
      var x$9 = $as_T(x$9$2);
      var x$10 = $as_T(x$10$2);
      return ((x$9 === x$10) ? 0 : ($uZ((x$9 < x$10)) ? (-1) : 1))
    })
  })(this);
  var x = this.java$net$URI$$$undscheme$1;
  var y = that.java$net$URI$$$undscheme$1;
  if ($m_sr_BoxesRunTime$().equals__O__O__Z(x, y)) {
    var cmpScheme = 0
  } else if ((x === (void 0))) {
    var cmpScheme = (-1)
  } else if ((y === (void 0))) {
    var cmpScheme = 1
  } else {
    var x$3 = $as_T(x);
    var x$4 = $as_T(y);
    var cmpScheme = $m_sjsr_RuntimeString$().compareToIgnoreCase__T__T__I(x$3, x$4)
  };
  if ((cmpScheme !== 0)) {
    return cmpScheme
  } else {
    var x$1 = this.$$undisOpaque$1;
    var y$1 = that.$$undisOpaque$1;
    var cmpIsOpaque = ((x$1 === y$1) ? 0 : (x$1 ? 1 : (-1)));
    if ((cmpIsOpaque !== 0)) {
      return cmpIsOpaque
    } else if (this.$$undisOpaque$1) {
      var arg1 = this.java$net$URI$$$undschemeSpecificPart$1;
      var arg2 = that.java$net$URI$$$undschemeSpecificPart$1;
      var cmpSchemeSpecificPart = $uI(f(arg1, arg2));
      if ((cmpSchemeSpecificPart !== 0)) {
        return cmpSchemeSpecificPart
      } else {
        var x$2 = this.$$undpath$1;
        var y$2 = that.$$undpath$1;
        var cmpPath = ($m_sr_BoxesRunTime$().equals__O__O__Z(x$2, y$2) ? 0 : ((x$2 === (void 0)) ? (-1) : ((y$2 === (void 0)) ? 1 : $uI(f(x$2, y$2)))));
        if ((cmpPath !== 0)) {
          return cmpPath
        } else {
          var x$5 = this.$$undquery$1;
          var y$3 = that.$$undquery$1;
          var cmpQuery = ($m_sr_BoxesRunTime$().equals__O__O__Z(x$5, y$3) ? 0 : ((x$5 === (void 0)) ? (-1) : ((y$3 === (void 0)) ? 1 : $uI(f(x$5, y$3)))));
          if ((cmpQuery !== 0)) {
            return cmpQuery
          } else {
            var x$6 = this.$$undfragment$1;
            var y$4 = that.$$undfragment$1;
            return ($m_sr_BoxesRunTime$().equals__O__O__Z(x$6, y$4) ? 0 : ((x$6 === (void 0)) ? (-1) : ((y$4 === (void 0)) ? 1 : $uI(f(x$6, y$4)))))
          }
        }
      }
    } else {
      var value = this.java$net$URI$$$undhost$1;
      if ((value !== (void 0))) {
        var value$1 = that.java$net$URI$$$undhost$1;
        var jsx$1 = (value$1 !== (void 0))
      } else {
        var jsx$1 = false
      };
      if (jsx$1) {
        var x$7 = this.java$net$URI$$$unduserInfo$1;
        var y$5 = that.java$net$URI$$$unduserInfo$1;
        var cmpUserInfo = ($m_sr_BoxesRunTime$().equals__O__O__Z(x$7, y$5) ? 0 : ((x$7 === (void 0)) ? (-1) : ((y$5 === (void 0)) ? 1 : $uI(f(x$7, y$5)))));
        if ((cmpUserInfo !== 0)) {
          return cmpUserInfo
        } else {
          var x$8 = this.java$net$URI$$$undhost$1;
          var y$6 = that.java$net$URI$$$undhost$1;
          if ($m_sr_BoxesRunTime$().equals__O__O__Z(x$8, y$6)) {
            var cmpHost = 0
          } else if ((x$8 === (void 0))) {
            var cmpHost = (-1)
          } else if ((y$6 === (void 0))) {
            var cmpHost = 1
          } else {
            var x$5$1 = $as_T(x$8);
            var x$6$1 = $as_T(y$6);
            var cmpHost = $m_sjsr_RuntimeString$().compareToIgnoreCase__T__T__I(x$5$1, x$6$1)
          };
          if ((cmpHost !== 0)) {
            return cmpHost
          } else {
            var x$11 = this.java$net$URI$$$undport$1;
            var y$7 = that.java$net$URI$$$undport$1;
            if ($m_sr_BoxesRunTime$().equals__O__O__Z(x$11, y$7)) {
              var cmpPort = 0
            } else if ((x$11 === (void 0))) {
              var cmpPort = (-1)
            } else if ((y$7 === (void 0))) {
              var cmpPort = 1
            } else {
              var x$7$1 = $uI(x$11);
              var x$8$1 = $uI(y$7);
              var cmpPort = ((x$7$1 - x$8$1) | 0)
            };
            if ((cmpPort !== 0)) {
              return cmpPort
            } else {
              var x$12 = this.$$undpath$1;
              var y$8 = that.$$undpath$1;
              var cmpPath$1 = ($m_sr_BoxesRunTime$().equals__O__O__Z(x$12, y$8) ? 0 : ((x$12 === (void 0)) ? (-1) : ((y$8 === (void 0)) ? 1 : $uI(f(x$12, y$8)))));
              if ((cmpPath$1 !== 0)) {
                return cmpPath$1
              } else {
                var x$13 = this.$$undquery$1;
                var y$9 = that.$$undquery$1;
                var cmpQuery$1 = ($m_sr_BoxesRunTime$().equals__O__O__Z(x$13, y$9) ? 0 : ((x$13 === (void 0)) ? (-1) : ((y$9 === (void 0)) ? 1 : $uI(f(x$13, y$9)))));
                if ((cmpQuery$1 !== 0)) {
                  return cmpQuery$1
                } else {
                  var x$14 = this.$$undfragment$1;
                  var y$10 = that.$$undfragment$1;
                  return ($m_sr_BoxesRunTime$().equals__O__O__Z(x$14, y$10) ? 0 : ((x$14 === (void 0)) ? (-1) : ((y$10 === (void 0)) ? 1 : $uI(f(x$14, y$10)))))
                }
              }
            }
          }
        }
      } else {
        var x$15 = this.java$net$URI$$$undauthority$1;
        var y$11 = that.java$net$URI$$$undauthority$1;
        var cmpAuthority = ($m_sr_BoxesRunTime$().equals__O__O__Z(x$15, y$11) ? 0 : ((x$15 === (void 0)) ? (-1) : ((y$11 === (void 0)) ? 1 : $uI(f(x$15, y$11)))));
        if ((cmpAuthority !== 0)) {
          return cmpAuthority
        } else {
          var x$16 = this.$$undpath$1;
          var y$12 = that.$$undpath$1;
          var cmpPath$2 = ($m_sr_BoxesRunTime$().equals__O__O__Z(x$16, y$12) ? 0 : ((x$16 === (void 0)) ? (-1) : ((y$12 === (void 0)) ? 1 : $uI(f(x$16, y$12)))));
          if ((cmpPath$2 !== 0)) {
            return cmpPath$2
          } else {
            var x$17 = this.$$undquery$1;
            var y$13 = that.$$undquery$1;
            var cmpQuery$2 = ($m_sr_BoxesRunTime$().equals__O__O__Z(x$17, y$13) ? 0 : ((x$17 === (void 0)) ? (-1) : ((y$13 === (void 0)) ? 1 : $uI(f(x$17, y$13)))));
            if ((cmpQuery$2 !== 0)) {
              return cmpQuery$2
            } else {
              var x$18 = this.$$undfragment$1;
              var y$14 = that.$$undfragment$1;
              return ($m_sr_BoxesRunTime$().equals__O__O__Z(x$18, y$14) ? 0 : ((x$18 === (void 0)) ? (-1) : ((y$14 === (void 0)) ? 1 : $uI(f(x$18, y$14)))))
            }
          }
        }
      }
    }
  }
});
$c_Ljava_net_URI.prototype.hashCode__I = (function() {
  var acc = 53722356;
  var jsx$4 = $m_s_util_hashing_MurmurHash3$();
  var jsx$3 = acc;
  var jsx$2 = $m_sr_Statics$();
  var value = this.java$net$URI$$$undscheme$1;
  if ((value === (void 0))) {
    var jsx$1 = (void 0)
  } else {
    var x$11 = $as_T(value);
    var value$1 = $as_T(x$11.toLowerCase());
    var jsx$1 = value$1
  };
  acc = jsx$4.mix__I__I__I(jsx$3, jsx$2.anyHash__O__I(jsx$1));
  if (this.$$undisOpaque$1) {
    var jsx$8 = $m_s_util_hashing_MurmurHash3$();
    var jsx$7 = acc;
    var jsx$6 = $m_sr_Statics$();
    var jsx$5 = $m_Ljava_net_URI$();
    var value$2 = this.java$net$URI$$$undschemeSpecificPart$1;
    acc = jsx$8.mix__I__I__I(jsx$7, jsx$6.anyHash__O__I(jsx$5.java$net$URI$$normalizeEscapes__sjs_js_UndefOr__sjs_js_UndefOr(value$2)))
  } else {
    var value$3 = this.java$net$URI$$$undhost$1;
    if ((value$3 !== (void 0))) {
      acc = $m_s_util_hashing_MurmurHash3$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I($m_Ljava_net_URI$().java$net$URI$$normalizeEscapes__sjs_js_UndefOr__sjs_js_UndefOr(this.java$net$URI$$$unduserInfo$1)));
      var jsx$12 = $m_s_util_hashing_MurmurHash3$();
      var jsx$11 = acc;
      var jsx$10 = $m_sr_Statics$();
      var value$4 = this.java$net$URI$$$undhost$1;
      if ((value$4 === (void 0))) {
        var jsx$9 = (void 0)
      } else {
        var x$12 = $as_T(value$4);
        var value$5 = $as_T(x$12.toLowerCase());
        var jsx$9 = value$5
      };
      acc = jsx$12.mix__I__I__I(jsx$11, jsx$10.anyHash__O__I(jsx$9));
      acc = $m_s_util_hashing_MurmurHash3$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.java$net$URI$$$undport$1))
    } else {
      acc = $m_s_util_hashing_MurmurHash3$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I($m_Ljava_net_URI$().java$net$URI$$normalizeEscapes__sjs_js_UndefOr__sjs_js_UndefOr(this.java$net$URI$$$undauthority$1)))
    }
  };
  acc = $m_s_util_hashing_MurmurHash3$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I($m_Ljava_net_URI$().java$net$URI$$normalizeEscapes__sjs_js_UndefOr__sjs_js_UndefOr(this.$$undpath$1)));
  acc = $m_s_util_hashing_MurmurHash3$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I($m_Ljava_net_URI$().java$net$URI$$normalizeEscapes__sjs_js_UndefOr__sjs_js_UndefOr(this.$$undquery$1)));
  acc = $m_s_util_hashing_MurmurHash3$().mixLast__I__I__I(acc, $m_sr_Statics$().anyHash__O__I($m_Ljava_net_URI$().java$net$URI$$normalizeEscapes__sjs_js_UndefOr__sjs_js_UndefOr(this.$$undfragment$1)));
  return $m_s_util_hashing_MurmurHash3$().finalizeHash__I__I__I(acc, 3)
});
$c_Ljava_net_URI.prototype.init___T = (function(origStr) {
  this.origStr$1 = origStr;
  var this$1 = $m_s_Option$().apply__O__s_Option($m_Ljava_net_URI$().java$net$URI$$uriRe$1.exec(origStr));
  if (this$1.isEmpty__Z()) {
    var jsx$1;
    throw new $c_Ljava_net_URISyntaxException().init___T__T(this.origStr$1, "Malformed URI")
  } else {
    var jsx$1 = this$1.get__O()
  };
  this.java$net$URI$$$undfld$f = jsx$1;
  var value = this.java$net$URI$$$undfld$f[1];
  this.java$net$URI$$$undisAbsolute$1 = (value !== (void 0));
  var value$1 = this.java$net$URI$$$undfld$f[10];
  this.$$undisOpaque$1 = (value$1 !== (void 0));
  this.java$net$URI$$$undscheme$1 = this.java$net$URI$$$undfld$f[1];
  var value$2 = ((!this.java$net$URI$$$undisAbsolute$1) ? this.java$net$URI$$$undfld$f[11] : (this.$$undisOpaque$1 ? this.java$net$URI$$$undfld$f[10] : this.java$net$URI$$$undfld$f[2]));
  if ((value$2 === (void 0))) {
    throw new $c_ju_NoSuchElementException().init___T("undefined.get")
  };
  this.java$net$URI$$$undschemeSpecificPart$1 = $as_T(value$2);
  var value$3 = (this.java$net$URI$$$undisAbsolute$1 ? this.java$net$URI$$$undfld$f[3] : this.java$net$URI$$$undfld$f[12]);
  if ((value$3 === (void 0))) {
    var jsx$2 = true
  } else {
    var x$1 = $as_T(value$3);
    var jsx$2 = (x$1 !== "")
  };
  this.java$net$URI$$$undauthority$1 = (jsx$2 ? value$3 : (void 0));
  this.java$net$URI$$$unduserInfo$1 = (this.java$net$URI$$$undisAbsolute$1 ? this.java$net$URI$$$undfld$f[4] : this.java$net$URI$$$undfld$f[13]);
  this.java$net$URI$$$undhost$1 = (this.java$net$URI$$$undisAbsolute$1 ? this.java$net$URI$$$undfld$f[5] : this.java$net$URI$$$undfld$f[14]);
  var value$4 = (this.java$net$URI$$$undisAbsolute$1 ? this.java$net$URI$$$undfld$f[6] : this.java$net$URI$$$undfld$f[15]);
  if ((value$4 === (void 0))) {
    var jsx$3 = (void 0)
  } else {
    var x$2 = $as_T(value$4);
    var this$24 = $m_jl_Integer$();
    var value$5 = this$24.parseInt__T__I__I(x$2, 10);
    var jsx$3 = value$5
  };
  this.java$net$URI$$$undport$1 = jsx$3;
  var value$6 = (this.java$net$URI$$$undisAbsolute$1 ? this.java$net$URI$$$undfld$f[3] : this.java$net$URI$$$undfld$f[12]);
  var useNetPath = (value$6 !== (void 0));
  if (useNetPath) {
    var value$7 = (this.java$net$URI$$$undisAbsolute$1 ? this.java$net$URI$$$undfld$f[7] : this.java$net$URI$$$undfld$f[16]);
    var jsx$4 = ((value$7 === (void 0)) ? "" : value$7)
  } else if (this.java$net$URI$$$undisAbsolute$1) {
    var jsx$4 = this.java$net$URI$$$undfld$f[8]
  } else {
    var value$8 = this.java$net$URI$$$undfld$f[17];
    var jsx$4 = ((value$8 === (void 0)) ? this.java$net$URI$$$undfld$f[18] : value$8)
  };
  this.$$undpath$1 = jsx$4;
  this.$$undquery$1 = (this.java$net$URI$$$undisAbsolute$1 ? this.java$net$URI$$$undfld$f[9] : this.java$net$URI$$$undfld$f[19]);
  this.$$undfragment$1 = this.java$net$URI$$$undfld$f[20];
  this.java$net$URI$$$undfld$f = null;
  return this
});
$c_Ljava_net_URI.prototype.normalize__Ljava_net_URI = (function() {
  if (this.$$undisOpaque$1) {
    var jsx$1 = true
  } else {
    var value = this.$$undpath$1;
    var jsx$1 = (value === (void 0))
  };
  if (jsx$1) {
    return this
  } else {
    var value$1 = this.$$undpath$1;
    if ((value$1 === (void 0))) {
      throw new $c_ju_NoSuchElementException().init___T("undefined.get")
    };
    var origPath = $as_T(value$1);
    var segments = origPath.split("/");
    var inLen = $uI(segments.length);
    if ((inLen !== 0)) {
      var x = segments[0];
      var isAbsPath = ((x !== null) && $objectEquals(x, ""))
    } else {
      var isAbsPath = false
    };
    var startIdx = (isAbsPath ? 1 : 0);
    var inIdx = startIdx;
    var outIdx = startIdx;
    while ((inIdx !== inLen)) {
      var segment = $as_T(segments[inIdx]);
      inIdx = ((1 + inIdx) | 0);
      if ((segment === ".")) {
        if ((inIdx === inLen)) {
          segments[outIdx] = "";
          outIdx = ((1 + outIdx) | 0)
        }
      } else if ((segment === "..")) {
        if ((outIdx !== startIdx)) {
          var lastSegment = $as_T(segments[(((-1) + outIdx) | 0)]);
          var okToDrop = ((lastSegment !== "..") && (lastSegment !== ""))
        } else {
          var okToDrop = false
        };
        if (okToDrop) {
          if ((inIdx === inLen)) {
            segments[(((-1) + outIdx) | 0)] = ""
          } else {
            outIdx = (((-1) + outIdx) | 0)
          }
        } else {
          segments[outIdx] = "..";
          outIdx = ((1 + outIdx) | 0)
        }
      } else if ((!((segment === "") && (inIdx !== inLen)))) {
        segments[outIdx] = segment;
        outIdx = ((1 + outIdx) | 0)
      }
    };
    segments.length = outIdx;
    if ((outIdx !== 0)) {
      var thiz = $as_T(segments[0]);
      var jsx$2 = ($uI(thiz.indexOf(":")) !== (-1))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      $uI(segments.unshift("."))
    };
    var newPath = $as_T(segments.join("/"));
    return ((newPath === origPath) ? this : new $c_Ljava_net_URI().init___T__T__T__T__T(this.getScheme__T(), this.getRawAuthority__T(), newPath, this.getQuery__T(), this.getFragment__T()))
  }
});
function $as_Ljava_net_URI(obj) {
  return (((obj instanceof $c_Ljava_net_URI) || (obj === null)) ? obj : $throwClassCastException(obj, "java.net.URI"))
}
function $isArrayOf_Ljava_net_URI(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Ljava_net_URI)))
}
function $asArrayOf_Ljava_net_URI(obj, depth) {
  return (($isArrayOf_Ljava_net_URI(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.net.URI;", depth))
}
var $d_Ljava_net_URI = new $TypeData().initClass({
  Ljava_net_URI: 0
}, false, "java.net.URI", {
  Ljava_net_URI: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  jl_Comparable: 1
});
$c_Ljava_net_URI.prototype.$classData = $d_Ljava_net_URI;
/** @constructor */
function $c_Ljava_net_URISyntaxException() {
  $c_jl_Exception.call(this);
  this.input$3 = null;
  this.reason$3 = null;
  this.index$3 = 0
}
$c_Ljava_net_URISyntaxException.prototype = new $h_jl_Exception();
$c_Ljava_net_URISyntaxException.prototype.constructor = $c_Ljava_net_URISyntaxException;
/** @constructor */
function $h_Ljava_net_URISyntaxException() {
  /*<skip>*/
}
$h_Ljava_net_URISyntaxException.prototype = $c_Ljava_net_URISyntaxException.prototype;
$c_Ljava_net_URISyntaxException.prototype.init___T__T = (function(input, reason) {
  $c_Ljava_net_URISyntaxException.prototype.init___T__T__I.call(this, input, reason, (-1));
  return this
});
$c_Ljava_net_URISyntaxException.prototype.init___T__T__I = (function(input, reason, index) {
  this.input$3 = input;
  this.reason$3 = reason;
  this.index$3 = index;
  var s = ((((reason + " in ") + input) + " at ") + index);
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
function $as_Ljava_net_URISyntaxException(obj) {
  return (((obj instanceof $c_Ljava_net_URISyntaxException) || (obj === null)) ? obj : $throwClassCastException(obj, "java.net.URISyntaxException"))
}
function $isArrayOf_Ljava_net_URISyntaxException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Ljava_net_URISyntaxException)))
}
function $asArrayOf_Ljava_net_URISyntaxException(obj, depth) {
  return (($isArrayOf_Ljava_net_URISyntaxException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.net.URISyntaxException;", depth))
}
var $d_Ljava_net_URISyntaxException = new $TypeData().initClass({
  Ljava_net_URISyntaxException: 0
}, false, "java.net.URISyntaxException", {
  Ljava_net_URISyntaxException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_Ljava_net_URISyntaxException.prototype.$classData = $d_Ljava_net_URISyntaxException;
/** @constructor */
function $c_Ljava_nio_HeapByteBuffer() {
  $c_Ljava_nio_ByteBuffer.call(this);
  this.$$undreadOnly$3 = false
}
$c_Ljava_nio_HeapByteBuffer.prototype = new $h_Ljava_nio_ByteBuffer();
$c_Ljava_nio_HeapByteBuffer.prototype.constructor = $c_Ljava_nio_HeapByteBuffer;
/** @constructor */
function $h_Ljava_nio_HeapByteBuffer() {
  /*<skip>*/
}
$h_Ljava_nio_HeapByteBuffer.prototype = $c_Ljava_nio_HeapByteBuffer.prototype;
$c_Ljava_nio_HeapByteBuffer.prototype.put__AB__I__I__Ljava_nio_ByteBuffer = (function(src, offset, length) {
  if (this.$$undreadOnly$3) {
    throw new $c_Ljava_nio_ReadOnlyBufferException().init___()
  };
  if ((((offset < 0) || (length < 0)) || (offset > ((src.u.length - length) | 0)))) {
    throw new $c_jl_IndexOutOfBoundsException().init___()
  };
  var p = this.java$nio$Buffer$$$undposition$1;
  var newPos = ((p + length) | 0);
  if ((newPos > this.$$undlimit$1)) {
    throw new $c_Ljava_nio_BufferOverflowException().init___()
  };
  this.java$nio$Buffer$$$undposition$1 = newPos;
  $systemArraycopy(src, offset, this.$$undarray$2, ((this.$$undarrayOffset$2 + p) | 0), length);
  return this
});
$c_Ljava_nio_HeapByteBuffer.prototype.get__AB__I__I__Ljava_nio_ByteBuffer = (function(dst, offset, length) {
  if ((((offset < 0) || (length < 0)) || (offset > ((dst.u.length - length) | 0)))) {
    throw new $c_jl_IndexOutOfBoundsException().init___()
  };
  var p = this.java$nio$Buffer$$$undposition$1;
  var newPos = ((p + length) | 0);
  if ((newPos > this.$$undlimit$1)) {
    throw new $c_Ljava_nio_BufferUnderflowException().init___()
  };
  this.java$nio$Buffer$$$undposition$1 = newPos;
  $systemArraycopy(this.$$undarray$2, ((this.$$undarrayOffset$2 + p) | 0), dst, offset, length);
  return this
});
$c_Ljava_nio_HeapByteBuffer.prototype.init___I__AB__I__I__I__Z = (function(_capacity, _array0, _arrayOffset0, _initialPosition, _initialLimit, _readOnly) {
  this.$$undreadOnly$3 = _readOnly;
  $c_Ljava_nio_ByteBuffer.prototype.init___I__AB__I.call(this, _capacity, _array0, _arrayOffset0);
  $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call(this, _initialPosition);
  $c_Ljava_nio_Buffer.prototype.limit__I__Ljava_nio_Buffer.call(this, _initialLimit);
  return this
});
$c_Ljava_nio_HeapByteBuffer.prototype.compact__Ljava_nio_ByteBuffer = (function() {
  if (this.$$undreadOnly$3) {
    throw new $c_Ljava_nio_ReadOnlyBufferException().init___()
  };
  var len = ((this.$$undlimit$1 - this.java$nio$Buffer$$$undposition$1) | 0);
  $systemArraycopy(this.$$undarray$2, ((this.$$undarrayOffset$2 + this.java$nio$Buffer$$$undposition$1) | 0), this.$$undarray$2, this.$$undarrayOffset$2, len);
  this.$$undmark$1 = (-1);
  var newLimit = this.$$undcapacity$1;
  $c_Ljava_nio_Buffer.prototype.limit__I__Ljava_nio_Buffer.call(this, newLimit);
  $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call(this, len);
  return this
});
$c_Ljava_nio_HeapByteBuffer.prototype.get__B = (function() {
  var p = this.java$nio$Buffer$$$undposition$1;
  if ((p === this.$$undlimit$1)) {
    throw new $c_Ljava_nio_BufferUnderflowException().init___()
  };
  this.java$nio$Buffer$$$undposition$1 = ((1 + p) | 0);
  return $uB($uB(this.$$undarray$2.get(((this.$$undarrayOffset$2 + p) | 0))))
});
$c_Ljava_nio_HeapByteBuffer.prototype.put__B__Ljava_nio_ByteBuffer = (function(b) {
  if (this.$$undreadOnly$3) {
    throw new $c_Ljava_nio_ReadOnlyBufferException().init___()
  };
  var p = this.java$nio$Buffer$$$undposition$1;
  if ((p === this.$$undlimit$1)) {
    throw new $c_Ljava_nio_BufferOverflowException().init___()
  };
  this.java$nio$Buffer$$$undposition$1 = ((1 + p) | 0);
  var elem = $uB(b);
  this.$$undarray$2.set(((this.$$undarrayOffset$2 + p) | 0), $uB(elem));
  return this
});
var $d_Ljava_nio_HeapByteBuffer = new $TypeData().initClass({
  Ljava_nio_HeapByteBuffer: 0
}, false, "java.nio.HeapByteBuffer", {
  Ljava_nio_HeapByteBuffer: 1,
  Ljava_nio_ByteBuffer: 1,
  Ljava_nio_Buffer: 1,
  O: 1,
  jl_Comparable: 1
});
$c_Ljava_nio_HeapByteBuffer.prototype.$classData = $d_Ljava_nio_HeapByteBuffer;
/** @constructor */
function $c_Ljava_nio_charset_CoderMalfunctionError() {
  $c_jl_Error.call(this)
}
$c_Ljava_nio_charset_CoderMalfunctionError.prototype = new $h_jl_Error();
$c_Ljava_nio_charset_CoderMalfunctionError.prototype.constructor = $c_Ljava_nio_charset_CoderMalfunctionError;
/** @constructor */
function $h_Ljava_nio_charset_CoderMalfunctionError() {
  /*<skip>*/
}
$h_Ljava_nio_charset_CoderMalfunctionError.prototype = $c_Ljava_nio_charset_CoderMalfunctionError.prototype;
$c_Ljava_nio_charset_CoderMalfunctionError.prototype.init___jl_Exception = (function(cause) {
  $c_jl_Error.prototype.init___jl_Throwable.call(this, cause);
  return this
});
var $d_Ljava_nio_charset_CoderMalfunctionError = new $TypeData().initClass({
  Ljava_nio_charset_CoderMalfunctionError: 0
}, false, "java.nio.charset.CoderMalfunctionError", {
  Ljava_nio_charset_CoderMalfunctionError: 1,
  jl_Error: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_Ljava_nio_charset_CoderMalfunctionError.prototype.$classData = $d_Ljava_nio_charset_CoderMalfunctionError;
/** @constructor */
function $c_Lorg_yaml_model_YComment() {
  $c_Lorg_yaml_model_YIgnorable.call(this);
  this.metaText$4 = null
}
$c_Lorg_yaml_model_YComment.prototype = new $h_Lorg_yaml_model_YIgnorable();
$c_Lorg_yaml_model_YComment.prototype.constructor = $c_Lorg_yaml_model_YComment;
/** @constructor */
function $h_Lorg_yaml_model_YComment() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YComment.prototype = $c_Lorg_yaml_model_YComment.prototype;
$c_Lorg_yaml_model_YComment.prototype.equals__O__Z = (function(obj) {
  if ((obj instanceof $c_Lorg_yaml_model_YComment)) {
    var x2 = $as_Lorg_yaml_model_YComment(obj);
    return (this.metaText$4 === x2.metaText$4)
  } else {
    return false
  }
});
$c_Lorg_yaml_model_YComment.prototype.toString__T = (function() {
  return this.metaText$4
});
$c_Lorg_yaml_model_YComment.prototype.init___T__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq = (function(metaText, location, tokens) {
  this.metaText$4 = metaText;
  $c_Lorg_yaml_model_YTokens.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq.call(this, location, tokens);
  return this
});
$c_Lorg_yaml_model_YComment.prototype.hashCode__I = (function() {
  var this$1 = this.metaText$4;
  return $m_sjsr_RuntimeString$().hashCode__T__I(this$1)
});
function $as_Lorg_yaml_model_YComment(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YComment) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YComment"))
}
function $isArrayOf_Lorg_yaml_model_YComment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YComment)))
}
function $asArrayOf_Lorg_yaml_model_YComment(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YComment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YComment;", depth))
}
var $d_Lorg_yaml_model_YComment = new $TypeData().initClass({
  Lorg_yaml_model_YComment: 0
}, false, "org.yaml.model.YComment", {
  Lorg_yaml_model_YComment: 1,
  Lorg_yaml_model_YIgnorable: 1,
  Lorg_yaml_model_YTokens: 1,
  Lorg_yaml_model_YPart: 1,
  O: 1
});
$c_Lorg_yaml_model_YComment.prototype.$classData = $d_Lorg_yaml_model_YComment;
/** @constructor */
function $c_Lorg_yaml_model_YDocument() {
  $c_Lorg_yaml_model_YPart.call(this);
  this.node$2 = null;
  this.tagType$2 = null;
  this.headComment$2 = null
}
$c_Lorg_yaml_model_YDocument.prototype = new $h_Lorg_yaml_model_YPart();
$c_Lorg_yaml_model_YDocument.prototype.constructor = $c_Lorg_yaml_model_YDocument;
/** @constructor */
function $h_Lorg_yaml_model_YDocument() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YDocument.prototype = $c_Lorg_yaml_model_YDocument.prototype;
$c_Lorg_yaml_model_YDocument.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq = (function(location, children) {
  $c_Lorg_yaml_model_YPart.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq.call(this, location, children);
  var this$1 = this.children$1;
  var pf = new $c_Lorg_yaml_model_YDocument$$anonfun$1().init___Lorg_yaml_model_YDocument(this);
  var this$2 = $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$1, pf);
  this.node$2 = $as_Lorg_yaml_model_YNode((this$2.isEmpty__Z() ? $m_Lorg_yaml_model_YNode$().Null$1 : this$2.get__O()));
  this.tagType$2 = this.node$2.tag__Lorg_yaml_model_YTag().tagType$3;
  var jsx$2 = $as_sc_TraversableLike(this.children$1.takeWhile__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lorg_yaml_model_YPart(x$1$2);
      return (!(x$1 instanceof $c_Lorg_yaml_model_YNode))
    })
  })(this))));
  var jsx$1 = new $c_Lorg_yaml_model_YDocument$$anonfun$2().init___Lorg_yaml_model_YDocument(this);
  var this$3 = $m_sc_IndexedSeq$();
  this.headComment$2 = $as_sc_TraversableOnce(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBF$6)).mkString__T__T("\n");
  return this
});
$c_Lorg_yaml_model_YDocument.prototype.equals__O__Z = (function(obj) {
  if ((obj instanceof $c_Lorg_yaml_model_YDocument)) {
    var x2 = $as_Lorg_yaml_model_YDocument(obj);
    return x2.node$2.equals__O__Z(this.node$2)
  } else {
    return false
  }
});
$c_Lorg_yaml_model_YDocument.prototype.toString__T = (function() {
  return ("Document: " + this.node$2.toString__T())
});
$c_Lorg_yaml_model_YDocument.prototype.to__Lorg_yaml_convert_YRead__s_util_Either = (function(evidence$1) {
  return this.obj__Lorg_yaml_model_YObj().to__Lorg_yaml_convert_YRead__s_util_Either(evidence$1)
});
$c_Lorg_yaml_model_YDocument.prototype.obj__Lorg_yaml_model_YObj = (function() {
  var this$1 = this.node$2;
  var b = $m_Lorg_yaml_model_YNode$().Null$1;
  if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
    return $m_Lorg_yaml_model_YFail$().apply__Lorg_yaml_model_YNodeLike__F0__Lorg_yaml_model_YFail(this, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
      return (function() {
        return "Empty Document"
      })
    })(this)))
  } else {
    return new $c_Lorg_yaml_model_YSuccess().init___Lorg_yaml_model_YNode(this.node$2)
  }
});
$c_Lorg_yaml_model_YDocument.prototype.thisNode__Lorg_yaml_model_YNode = (function() {
  return this.node$2
});
function $as_Lorg_yaml_model_YDocument(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YDocument) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YDocument"))
}
function $isArrayOf_Lorg_yaml_model_YDocument(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YDocument)))
}
function $asArrayOf_Lorg_yaml_model_YDocument(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YDocument(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YDocument;", depth))
}
var $d_Lorg_yaml_model_YDocument = new $TypeData().initClass({
  Lorg_yaml_model_YDocument: 0
}, false, "org.yaml.model.YDocument", {
  Lorg_yaml_model_YDocument: 1,
  Lorg_yaml_model_YPart: 1,
  O: 1,
  Lorg_yaml_model_YNodeLike: 1,
  Lorg_yaml_model_YValueLike: 1
});
$c_Lorg_yaml_model_YDocument.prototype.$classData = $d_Lorg_yaml_model_YDocument;
/** @constructor */
function $c_Lorg_yaml_model_YMap() {
  $c_Lorg_yaml_model_YValue.call(this);
  this.entries$3 = null;
  this.map$3 = null
}
$c_Lorg_yaml_model_YMap.prototype = new $h_Lorg_yaml_model_YValue();
$c_Lorg_yaml_model_YMap.prototype.constructor = $c_Lorg_yaml_model_YMap;
/** @constructor */
function $h_Lorg_yaml_model_YMap() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YMap.prototype = $c_Lorg_yaml_model_YMap.prototype;
$c_Lorg_yaml_model_YMap.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq = (function(location, parts) {
  $c_Lorg_yaml_model_YValue.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq.call(this, location, parts);
  var jsx$3 = $m_s_Predef$();
  var jsx$2 = this.children$1;
  var jsx$1 = new $c_Lorg_yaml_model_YMap$$anonfun$1().init___Lorg_yaml_model_YMap(this);
  var this$1 = $m_sc_IndexedSeq$();
  this.entries$3 = jsx$3.wrapRefArray__AO__scm_WrappedArray($asArrayOf_O($as_sc_TraversableOnce(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBF$6)).toArray__s_reflect_ClassTag__O(new $c_s_reflect_ClassTag$GenericClassTag().init___jl_Class($d_Lorg_yaml_model_YMapEntry.getClassOf())), 1));
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  this.entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$1) {
    return (function(e$2) {
      var e = $as_Lorg_yaml_model_YMapEntry(e$2);
      return b$1.$$plus$eq__O__scm_Builder(new $c_T2().init___O__O(e.key$2, e.value$2))
    })
  })(this, b)));
  this.map$3 = $as_sci_Map(b.elems$1);
  return this
});
$c_Lorg_yaml_model_YMap.prototype.equals__O__Z = (function(obj) {
  if ((obj instanceof $c_Lorg_yaml_model_YMap)) {
    var x2 = $as_Lorg_yaml_model_YMap(obj);
    var x = this.map$3;
    var x$2 = x2.map$3;
    return ((x === null) ? (x$2 === null) : $f_sc_GenMapLike__equals__O__Z(x, x$2))
  } else if ($is_Lorg_yaml_model_YNodeLike(obj)) {
    var x3 = $as_Lorg_yaml_model_YNodeLike(obj);
    var this$1 = x3.to__Lorg_yaml_convert_YRead__s_util_Either($m_Lorg_yaml_convert_YRead$YMapYRead$());
    if ((this$1 instanceof $c_s_util_Right)) {
      var x2$1 = $as_s_util_Right(this$1);
      var b = x2$1.value$2;
      var x$1 = $as_Lorg_yaml_model_YMap(b);
      var x$3 = this.map$3;
      var x$2$1 = x$1.map$3;
      return ((x$3 === null) ? (x$2$1 === null) : $f_sc_GenMapLike__equals__O__Z(x$3, x$2$1))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_model_YMap.prototype.toString__T = (function() {
  return this.entries$3.mkString__T__T__T__T("{", ", ", "}")
});
$c_Lorg_yaml_model_YMap.prototype.hashCode__I = (function() {
  var this$1 = this.map$3;
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.unorderedHash__sc_TraversableOnce__I__I(this$1, this$2.mapSeed$2)
});
function $as_Lorg_yaml_model_YMap(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YMap) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YMap"))
}
function $isArrayOf_Lorg_yaml_model_YMap(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YMap)))
}
function $asArrayOf_Lorg_yaml_model_YMap(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YMap(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YMap;", depth))
}
var $d_Lorg_yaml_model_YMap = new $TypeData().initClass({
  Lorg_yaml_model_YMap: 0
}, false, "org.yaml.model.YMap", {
  Lorg_yaml_model_YMap: 1,
  Lorg_yaml_model_YValue: 1,
  Lorg_yaml_model_YPart: 1,
  O: 1,
  Lorg_yaml_model_YValueLike: 1
});
$c_Lorg_yaml_model_YMap.prototype.$classData = $d_Lorg_yaml_model_YMap;
/** @constructor */
function $c_Lorg_yaml_model_YNode() {
  $c_Lorg_yaml_model_YPart.call(this)
}
$c_Lorg_yaml_model_YNode.prototype = new $h_Lorg_yaml_model_YPart();
$c_Lorg_yaml_model_YNode.prototype.constructor = $c_Lorg_yaml_model_YNode;
/** @constructor */
function $h_Lorg_yaml_model_YNode() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YNode.prototype = $c_Lorg_yaml_model_YNode.prototype;
$c_Lorg_yaml_model_YNode.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq = (function(location, parts) {
  $c_Lorg_yaml_model_YPart.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq.call(this, location, parts);
  return this
});
$c_Lorg_yaml_model_YNode.prototype.equals__O__Z = (function(obj) {
  if ((!(obj instanceof $c_Lorg_yaml_model_YFail))) {
    if ((obj instanceof $c_Lorg_yaml_model_YNode)) {
      var x3 = $as_Lorg_yaml_model_YNode(obj);
      var x = this.tag__Lorg_yaml_model_YTag().tagType$3;
      var x$2 = x3.tag__Lorg_yaml_model_YTag().tagType$3;
      if ((x === x$2)) {
        var this$1 = this.value__Lorg_yaml_model_YValue();
        var b = x3.value__Lorg_yaml_model_YValue();
        return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
      } else {
        return false
      }
    } else if ($is_Lorg_yaml_model_YNodeLike(obj)) {
      var x4 = $as_Lorg_yaml_model_YNodeLike(obj);
      var b$1 = x4.thisNode__Lorg_yaml_model_YNode();
      return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this, b$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_model_YNode.prototype.toString__T = (function() {
  return this.value__Lorg_yaml_model_YValue().toString__T()
});
$c_Lorg_yaml_model_YNode.prototype.to__Lorg_yaml_convert_YRead__s_util_Either = (function(evidence$2) {
  return $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this, evidence$2)
});
$c_Lorg_yaml_model_YNode.prototype.asScalar__s_Option = (function() {
  var x1 = this.value__Lorg_yaml_model_YValue();
  if ((x1 instanceof $c_Lorg_yaml_model_YScalar)) {
    var x2 = $as_Lorg_yaml_model_YScalar(x1);
    return new $c_s_Some().init___O(x2)
  } else {
    return $m_s_None$()
  }
});
$c_Lorg_yaml_model_YNode.prototype.hashCode__I = (function() {
  var this$1 = this.tag__Lorg_yaml_model_YTag().tagType$3;
  return (($imul(31, $systemIdentityHashCode(this$1)) + this.value__Lorg_yaml_model_YValue().hashCode__I()) | 0)
});
$c_Lorg_yaml_model_YNode.prototype.isNull__Z = (function() {
  var x = this.tag__Lorg_yaml_model_YTag().tagType$3;
  var x$2 = $m_Lorg_yaml_model_YType$().Null$1;
  if ((x === x$2)) {
    return true
  } else {
    return this.asScalar__s_Option().contains__O__Z(null)
  }
});
$c_Lorg_yaml_model_YNode.prototype.thisNode__Lorg_yaml_model_YNode = (function() {
  return this
});
function $as_Lorg_yaml_model_YNode(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YNode) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YNode"))
}
function $isArrayOf_Lorg_yaml_model_YNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YNode)))
}
function $asArrayOf_Lorg_yaml_model_YNode(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YNode;", depth))
}
var $d_Lorg_yaml_model_YNode = new $TypeData().initClass({
  Lorg_yaml_model_YNode: 0
}, false, "org.yaml.model.YNode", {
  Lorg_yaml_model_YNode: 1,
  Lorg_yaml_model_YPart: 1,
  O: 1,
  Lorg_yaml_model_YNodeLike: 1,
  Lorg_yaml_model_YValueLike: 1
});
$c_Lorg_yaml_model_YNode.prototype.$classData = $d_Lorg_yaml_model_YNode;
/** @constructor */
function $c_Lorg_yaml_model_YNonContent() {
  $c_Lorg_yaml_model_YIgnorable.call(this)
}
$c_Lorg_yaml_model_YNonContent.prototype = new $h_Lorg_yaml_model_YIgnorable();
$c_Lorg_yaml_model_YNonContent.prototype.constructor = $c_Lorg_yaml_model_YNonContent;
/** @constructor */
function $h_Lorg_yaml_model_YNonContent() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YNonContent.prototype = $c_Lorg_yaml_model_YNonContent.prototype;
$c_Lorg_yaml_model_YNonContent.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq = (function(location, tokens) {
  $c_Lorg_yaml_model_YTokens.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq.call(this, location, tokens);
  return this
});
$c_Lorg_yaml_model_YNonContent.prototype.toString__T = (function() {
  return this.tokens$2.mkString__T__T(", ")
});
function $as_Lorg_yaml_model_YNonContent(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YNonContent) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YNonContent"))
}
function $isArrayOf_Lorg_yaml_model_YNonContent(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YNonContent)))
}
function $asArrayOf_Lorg_yaml_model_YNonContent(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YNonContent(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YNonContent;", depth))
}
var $d_Lorg_yaml_model_YNonContent = new $TypeData().initClass({
  Lorg_yaml_model_YNonContent: 0
}, false, "org.yaml.model.YNonContent", {
  Lorg_yaml_model_YNonContent: 1,
  Lorg_yaml_model_YIgnorable: 1,
  Lorg_yaml_model_YTokens: 1,
  Lorg_yaml_model_YPart: 1,
  O: 1
});
$c_Lorg_yaml_model_YNonContent.prototype.$classData = $d_Lorg_yaml_model_YNonContent;
/** @constructor */
function $c_Lorg_yaml_model_YObj() {
  $c_O.call(this)
}
$c_Lorg_yaml_model_YObj.prototype = new $h_O();
$c_Lorg_yaml_model_YObj.prototype.constructor = $c_Lorg_yaml_model_YObj;
/** @constructor */
function $h_Lorg_yaml_model_YObj() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YObj.prototype = $c_Lorg_yaml_model_YObj.prototype;
$c_Lorg_yaml_model_YObj.prototype.to__Lorg_yaml_convert_YRead__s_util_Either = (function(evidence$2) {
  return $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this, evidence$2)
});
/** @constructor */
function $c_Lorg_yaml_model_YScalar() {
  $c_Lorg_yaml_model_YValue.call(this);
  this.value$3 = null;
  this.text$3 = null;
  this.mark$3 = null
}
$c_Lorg_yaml_model_YScalar.prototype = new $h_Lorg_yaml_model_YValue();
$c_Lorg_yaml_model_YScalar.prototype.constructor = $c_Lorg_yaml_model_YScalar;
/** @constructor */
function $h_Lorg_yaml_model_YScalar() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YScalar.prototype = $c_Lorg_yaml_model_YScalar.prototype;
$c_Lorg_yaml_model_YScalar.prototype.equals__O__Z = (function(obj) {
  if ((obj instanceof $c_Lorg_yaml_model_YScalar)) {
    var x2 = $as_Lorg_yaml_model_YScalar(obj);
    return $m_sr_BoxesRunTime$().equals__O__O__Z(x2.value$3, this.value$3)
  } else if ($is_Lorg_yaml_model_YNodeLike(obj)) {
    var x3 = $as_Lorg_yaml_model_YNodeLike(obj);
    var this$1 = x3.to__Lorg_yaml_convert_YRead__s_util_Either($m_Lorg_yaml_convert_YRead$YScalarYRead$());
    if ((this$1 instanceof $c_s_util_Right)) {
      var x2$1 = $as_s_util_Right(this$1);
      var b = x2$1.value$2;
      var s = $as_Lorg_yaml_model_YScalar(b);
      var v1 = s.value$3;
      return $m_sr_BoxesRunTime$().equals__O__O__Z(this.value$3, v1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_model_YScalar.prototype.toString__T = (function() {
  return this.mark$3.markText__T__T(this.text$3)
});
$c_Lorg_yaml_model_YScalar.prototype.hashCode__I = (function() {
  var o = this.value$3;
  return ((o === null) ? 0 : $objectHashCode(o))
});
$c_Lorg_yaml_model_YScalar.prototype.init___O__T__Lorg_yaml_model_ScalarMark__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq = (function(value, text, mark, location, parts) {
  this.value$3 = value;
  this.text$3 = text;
  this.mark$3 = mark;
  $c_Lorg_yaml_model_YValue.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq.call(this, location, parts);
  return this
});
function $as_Lorg_yaml_model_YScalar(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YScalar) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YScalar"))
}
function $isArrayOf_Lorg_yaml_model_YScalar(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YScalar)))
}
function $asArrayOf_Lorg_yaml_model_YScalar(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YScalar(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YScalar;", depth))
}
var $d_Lorg_yaml_model_YScalar = new $TypeData().initClass({
  Lorg_yaml_model_YScalar: 0
}, false, "org.yaml.model.YScalar", {
  Lorg_yaml_model_YScalar: 1,
  Lorg_yaml_model_YValue: 1,
  Lorg_yaml_model_YPart: 1,
  O: 1,
  Lorg_yaml_model_YValueLike: 1
});
$c_Lorg_yaml_model_YScalar.prototype.$classData = $d_Lorg_yaml_model_YScalar;
/** @constructor */
function $c_Lorg_yaml_model_YSequence() {
  $c_Lorg_yaml_model_YValue.call(this);
  this.nodes$3 = null
}
$c_Lorg_yaml_model_YSequence.prototype = new $h_Lorg_yaml_model_YValue();
$c_Lorg_yaml_model_YSequence.prototype.constructor = $c_Lorg_yaml_model_YSequence;
/** @constructor */
function $h_Lorg_yaml_model_YSequence() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YSequence.prototype = $c_Lorg_yaml_model_YSequence.prototype;
$c_Lorg_yaml_model_YSequence.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq = (function(location, parts) {
  $c_Lorg_yaml_model_YValue.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq.call(this, location, parts);
  var jsx$3 = $m_s_Predef$();
  var jsx$2 = this.children$1;
  var jsx$1 = new $c_Lorg_yaml_model_YSequence$$anonfun$1().init___Lorg_yaml_model_YSequence(this);
  var this$1 = $m_sc_IndexedSeq$();
  this.nodes$3 = jsx$3.wrapRefArray__AO__scm_WrappedArray($asArrayOf_O($as_sc_TraversableOnce(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBF$6)).toArray__s_reflect_ClassTag__O(new $c_s_reflect_ClassTag$GenericClassTag().init___jl_Class($d_Lorg_yaml_model_YNode.getClassOf())), 1));
  return this
});
$c_Lorg_yaml_model_YSequence.prototype.equals__O__Z = (function(obj) {
  if ((obj instanceof $c_Lorg_yaml_model_YSequence)) {
    var x2 = $as_Lorg_yaml_model_YSequence(obj);
    return this.nodes$3.equals__O__Z(x2.nodes$3)
  } else if ($is_Lorg_yaml_model_YNodeLike(obj)) {
    var x3 = $as_Lorg_yaml_model_YNodeLike(obj);
    var this$1 = x3.to__Lorg_yaml_convert_YRead__s_util_Either($m_Lorg_yaml_convert_YRead$YSeqYRead$());
    if ((this$1 instanceof $c_s_util_Right)) {
      var x2$1 = $as_s_util_Right(this$1);
      var b = x2$1.value$2;
      var x$1 = $as_Lorg_yaml_model_YSequence(b);
      var x = this.nodes$3;
      var x$2 = x$1.nodes$3;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_model_YSequence.prototype.toString__T = (function() {
  return this.nodes$3.mkString__T__T__T__T("[", ", ", "]")
});
$c_Lorg_yaml_model_YSequence.prototype.hashCode__I = (function() {
  return this.nodes$3.hashCode__I()
});
function $as_Lorg_yaml_model_YSequence(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YSequence) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YSequence"))
}
function $isArrayOf_Lorg_yaml_model_YSequence(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YSequence)))
}
function $asArrayOf_Lorg_yaml_model_YSequence(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YSequence(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YSequence;", depth))
}
var $d_Lorg_yaml_model_YSequence = new $TypeData().initClass({
  Lorg_yaml_model_YSequence: 0
}, false, "org.yaml.model.YSequence", {
  Lorg_yaml_model_YSequence: 1,
  Lorg_yaml_model_YValue: 1,
  Lorg_yaml_model_YPart: 1,
  O: 1,
  Lorg_yaml_model_YValueLike: 1
});
$c_Lorg_yaml_model_YSequence.prototype.$classData = $d_Lorg_yaml_model_YSequence;
/** @constructor */
function $c_Lscopt_ParseException() {
  $c_jl_Exception.call(this)
}
$c_Lscopt_ParseException.prototype = new $h_jl_Exception();
$c_Lscopt_ParseException.prototype.constructor = $c_Lscopt_ParseException;
/** @constructor */
function $h_Lscopt_ParseException() {
  /*<skip>*/
}
$h_Lscopt_ParseException.prototype = $c_Lscopt_ParseException.prototype;
$c_Lscopt_ParseException.prototype.init___T__I = (function(s, errorOffset) {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
function $as_Lscopt_ParseException(obj) {
  return (((obj instanceof $c_Lscopt_ParseException) || (obj === null)) ? obj : $throwClassCastException(obj, "scopt.ParseException"))
}
function $isArrayOf_Lscopt_ParseException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lscopt_ParseException)))
}
function $asArrayOf_Lscopt_ParseException(obj, depth) {
  return (($isArrayOf_Lscopt_ParseException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscopt.ParseException;", depth))
}
var $d_Lscopt_ParseException = new $TypeData().initClass({
  Lscopt_ParseException: 0
}, false, "scopt.ParseException", {
  Lscopt_ParseException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_Lscopt_ParseException.prototype.$classData = $d_Lscopt_ParseException;
function $is_T(obj) {
  return ((typeof obj) === "string")
}
function $as_T(obj) {
  return (($is_T(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "java.lang.String"))
}
function $isArrayOf_T(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.T)))
}
function $asArrayOf_T(obj, depth) {
  return (($isArrayOf_T(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.String;", depth))
}
var $d_T = new $TypeData().initClass({
  T: 0
}, false, "java.lang.String", {
  T: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  jl_CharSequence: 1,
  jl_Comparable: 1
}, (void 0), (void 0), $is_T);
/** @constructor */
function $c_jl_AssertionError() {
  $c_jl_Error.call(this)
}
$c_jl_AssertionError.prototype = new $h_jl_Error();
$c_jl_AssertionError.prototype.constructor = $c_jl_AssertionError;
/** @constructor */
function $h_jl_AssertionError() {
  /*<skip>*/
}
$h_jl_AssertionError.prototype = $c_jl_AssertionError.prototype;
$c_jl_AssertionError.prototype.init___ = (function() {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
$c_jl_AssertionError.prototype.init___O = (function(detailMessage) {
  var message = ("" + detailMessage);
  if ((detailMessage instanceof $c_jl_Throwable)) {
    var x2 = $as_jl_Throwable(detailMessage);
    var cause = x2
  } else {
    var cause = null
  };
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, message, cause, true, true);
  return this
});
var $d_jl_AssertionError = new $TypeData().initClass({
  jl_AssertionError: 0
}, false, "java.lang.AssertionError", {
  jl_AssertionError: 1,
  jl_Error: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_jl_AssertionError.prototype.$classData = $d_jl_AssertionError;
function $isArrayOf_jl_Byte(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_Byte)))
}
function $asArrayOf_jl_Byte(obj, depth) {
  return (($isArrayOf_jl_Byte(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.Byte;", depth))
}
var $d_jl_Byte = new $TypeData().initClass({
  jl_Byte: 0
}, false, "java.lang.Byte", {
  jl_Byte: 1,
  jl_Number: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  jl_Comparable: 1
}, (void 0), (void 0), (function(x) {
  return $isByte(x)
}));
/** @constructor */
function $c_jl_CloneNotSupportedException() {
  $c_jl_Exception.call(this)
}
$c_jl_CloneNotSupportedException.prototype = new $h_jl_Exception();
$c_jl_CloneNotSupportedException.prototype.constructor = $c_jl_CloneNotSupportedException;
/** @constructor */
function $h_jl_CloneNotSupportedException() {
  /*<skip>*/
}
$h_jl_CloneNotSupportedException.prototype = $c_jl_CloneNotSupportedException.prototype;
$c_jl_CloneNotSupportedException.prototype.init___ = (function() {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
var $d_jl_CloneNotSupportedException = new $TypeData().initClass({
  jl_CloneNotSupportedException: 0
}, false, "java.lang.CloneNotSupportedException", {
  jl_CloneNotSupportedException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_jl_CloneNotSupportedException.prototype.$classData = $d_jl_CloneNotSupportedException;
function $isArrayOf_jl_Double(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_Double)))
}
function $asArrayOf_jl_Double(obj, depth) {
  return (($isArrayOf_jl_Double(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.Double;", depth))
}
var $d_jl_Double = new $TypeData().initClass({
  jl_Double: 0
}, false, "java.lang.Double", {
  jl_Double: 1,
  jl_Number: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  jl_Comparable: 1
}, (void 0), (void 0), (function(x) {
  return ((typeof x) === "number")
}));
function $isArrayOf_jl_Float(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_Float)))
}
function $asArrayOf_jl_Float(obj, depth) {
  return (($isArrayOf_jl_Float(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.Float;", depth))
}
var $d_jl_Float = new $TypeData().initClass({
  jl_Float: 0
}, false, "java.lang.Float", {
  jl_Float: 1,
  jl_Number: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  jl_Comparable: 1
}, (void 0), (void 0), (function(x) {
  return $isFloat(x)
}));
function $isArrayOf_jl_Integer(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_Integer)))
}
function $asArrayOf_jl_Integer(obj, depth) {
  return (($isArrayOf_jl_Integer(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.Integer;", depth))
}
var $d_jl_Integer = new $TypeData().initClass({
  jl_Integer: 0
}, false, "java.lang.Integer", {
  jl_Integer: 1,
  jl_Number: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  jl_Comparable: 1
}, (void 0), (void 0), (function(x) {
  return $isInt(x)
}));
/** @constructor */
function $c_jl_InterruptedException() {
  /*<skip>*/
}
function $as_jl_InterruptedException(obj) {
  return (((obj instanceof $c_jl_InterruptedException) || (obj === null)) ? obj : $throwClassCastException(obj, "java.lang.InterruptedException"))
}
function $isArrayOf_jl_InterruptedException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_InterruptedException)))
}
function $asArrayOf_jl_InterruptedException(obj, depth) {
  return (($isArrayOf_jl_InterruptedException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.InterruptedException;", depth))
}
/** @constructor */
function $c_jl_LinkageError() {
  /*<skip>*/
}
function $as_jl_LinkageError(obj) {
  return (((obj instanceof $c_jl_LinkageError) || (obj === null)) ? obj : $throwClassCastException(obj, "java.lang.LinkageError"))
}
function $isArrayOf_jl_LinkageError(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_LinkageError)))
}
function $asArrayOf_jl_LinkageError(obj, depth) {
  return (($isArrayOf_jl_LinkageError(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.LinkageError;", depth))
}
function $isArrayOf_jl_Long(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_Long)))
}
function $asArrayOf_jl_Long(obj, depth) {
  return (($isArrayOf_jl_Long(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.Long;", depth))
}
var $d_jl_Long = new $TypeData().initClass({
  jl_Long: 0
}, false, "java.lang.Long", {
  jl_Long: 1,
  jl_Number: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  jl_Comparable: 1
}, (void 0), (void 0), (function(x) {
  return (x instanceof $c_sjsr_RuntimeLong)
}));
/** @constructor */
function $c_jl_RuntimeException() {
  $c_jl_Exception.call(this)
}
$c_jl_RuntimeException.prototype = new $h_jl_Exception();
$c_jl_RuntimeException.prototype.constructor = $c_jl_RuntimeException;
/** @constructor */
function $h_jl_RuntimeException() {
  /*<skip>*/
}
$h_jl_RuntimeException.prototype = $c_jl_RuntimeException.prototype;
$c_jl_RuntimeException.prototype.init___jl_Throwable = (function(e) {
  var s = ((e === null) ? null : e.toString__T());
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, e, true, true);
  return this
});
$c_jl_RuntimeException.prototype.init___T = (function(s) {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
$c_jl_RuntimeException.prototype.init___T__jl_Throwable = (function(s, e) {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, e, true, true);
  return this
});
var $d_jl_RuntimeException = new $TypeData().initClass({
  jl_RuntimeException: 0
}, false, "java.lang.RuntimeException", {
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_jl_RuntimeException.prototype.$classData = $d_jl_RuntimeException;
function $isArrayOf_jl_Short(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_Short)))
}
function $asArrayOf_jl_Short(obj, depth) {
  return (($isArrayOf_jl_Short(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.Short;", depth))
}
var $d_jl_Short = new $TypeData().initClass({
  jl_Short: 0
}, false, "java.lang.Short", {
  jl_Short: 1,
  jl_Number: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  jl_Comparable: 1
}, (void 0), (void 0), (function(x) {
  return $isShort(x)
}));
/** @constructor */
function $c_jl_StringBuffer() {
  $c_O.call(this);
  this.builder$1 = null
}
$c_jl_StringBuffer.prototype = new $h_O();
$c_jl_StringBuffer.prototype.constructor = $c_jl_StringBuffer;
/** @constructor */
function $h_jl_StringBuffer() {
  /*<skip>*/
}
$h_jl_StringBuffer.prototype = $c_jl_StringBuffer.prototype;
$c_jl_StringBuffer.prototype.append__jl_CharSequence__jl_StringBuffer = (function(s) {
  var this$1 = this.builder$1;
  this$1.java$lang$StringBuilder$$content$f = (("" + this$1.java$lang$StringBuilder$$content$f) + s);
  return this
});
$c_jl_StringBuffer.prototype.init___ = (function() {
  $c_jl_StringBuffer.prototype.init___jl_StringBuilder.call(this, new $c_jl_StringBuilder().init___());
  return this
});
$c_jl_StringBuffer.prototype.insert__I__T__jl_StringBuffer = (function(offset, str) {
  this.builder$1.insert__I__T__jl_StringBuilder(offset, str);
  return this
});
$c_jl_StringBuffer.prototype.subSequence__I__I__jl_CharSequence = (function(start, end) {
  var this$1 = this.builder$1;
  return this$1.substring__I__I__T(start, end)
});
$c_jl_StringBuffer.prototype.toString__T = (function() {
  return this.builder$1.java$lang$StringBuilder$$content$f
});
$c_jl_StringBuffer.prototype.init___jl_CharSequence = (function(seq) {
  $c_jl_StringBuffer.prototype.init___T.call(this, $objectToString(seq));
  return this
});
$c_jl_StringBuffer.prototype.append__jl_CharSequence__jl_Appendable = (function(csq) {
  return this.append__jl_CharSequence__jl_StringBuffer(csq)
});
$c_jl_StringBuffer.prototype.length__I = (function() {
  return this.builder$1.length__I()
});
$c_jl_StringBuffer.prototype.append__T__jl_StringBuffer = (function(str) {
  var this$1 = this.builder$1;
  this$1.java$lang$StringBuilder$$content$f = (("" + this$1.java$lang$StringBuilder$$content$f) + str);
  return this
});
$c_jl_StringBuffer.prototype.init___jl_StringBuilder = (function(builder) {
  this.builder$1 = builder;
  return this
});
$c_jl_StringBuffer.prototype.init___T = (function(str) {
  $c_jl_StringBuffer.prototype.init___jl_StringBuilder.call(this, new $c_jl_StringBuilder().init___T(str));
  return this
});
$c_jl_StringBuffer.prototype.charAt__I__C = (function(index) {
  return this.builder$1.charAt__I__C(index)
});
$c_jl_StringBuffer.prototype.append__C__jl_StringBuffer = (function(c) {
  this.builder$1.append__C__jl_StringBuilder(c);
  return this
});
var $d_jl_StringBuffer = new $TypeData().initClass({
  jl_StringBuffer: 0
}, false, "java.lang.StringBuffer", {
  jl_StringBuffer: 1,
  O: 1,
  jl_CharSequence: 1,
  jl_Appendable: 1,
  Ljava_io_Serializable: 1
});
$c_jl_StringBuffer.prototype.$classData = $d_jl_StringBuffer;
/** @constructor */
function $c_jl_StringBuilder() {
  $c_O.call(this);
  this.java$lang$StringBuilder$$content$f = null
}
$c_jl_StringBuilder.prototype = new $h_O();
$c_jl_StringBuilder.prototype.constructor = $c_jl_StringBuilder;
/** @constructor */
function $h_jl_StringBuilder() {
  /*<skip>*/
}
$h_jl_StringBuilder.prototype = $c_jl_StringBuilder.prototype;
$c_jl_StringBuilder.prototype.setLength__I__V = (function(newLength) {
  if ((newLength < 0)) {
    throw new $c_jl_StringIndexOutOfBoundsException().init___I(newLength)
  };
  var newContent = this.java$lang$StringBuilder$$content$f;
  var thiz = newContent;
  var additional = ((newLength - $uI(thiz.length)) | 0);
  if ((additional < 0)) {
    var thiz$1 = newContent;
    newContent = $as_T(thiz$1.substring(0, newLength))
  } else {
    var i = 0;
    while ((i !== additional)) {
      newContent = (newContent + "\u0000");
      i = ((1 + i) | 0)
    }
  };
  this.java$lang$StringBuilder$$content$f = newContent
});
$c_jl_StringBuilder.prototype.init___ = (function() {
  this.java$lang$StringBuilder$$content$f = "";
  return this
});
$c_jl_StringBuilder.prototype.subSequence__I__I__jl_CharSequence = (function(start, end) {
  return this.substring__I__I__T(start, end)
});
$c_jl_StringBuilder.prototype.toString__T = (function() {
  return this.java$lang$StringBuilder$$content$f
});
$c_jl_StringBuilder.prototype.init___jl_CharSequence = (function(seq) {
  $c_jl_StringBuilder.prototype.init___T.call(this, $objectToString(seq));
  return this
});
$c_jl_StringBuilder.prototype.append__jl_CharSequence__jl_Appendable = (function(csq) {
  this.java$lang$StringBuilder$$content$f = (("" + this.java$lang$StringBuilder$$content$f) + csq);
  return this
});
$c_jl_StringBuilder.prototype.insert__I__T__jl_StringBuilder = (function(offset, str) {
  var oldContent = this.java$lang$StringBuilder$$content$f;
  if (((offset < 0) || (offset > $uI(oldContent.length)))) {
    throw new $c_jl_StringIndexOutOfBoundsException().init___I(offset)
  };
  this.java$lang$StringBuilder$$content$f = ((("" + $as_T(oldContent.substring(0, offset))) + str) + $as_T(oldContent.substring(offset)));
  return this
});
$c_jl_StringBuilder.prototype.init___I = (function(initialCapacity) {
  $c_jl_StringBuilder.prototype.init___.call(this);
  if ((initialCapacity < 0)) {
    throw new $c_jl_NegativeArraySizeException().init___()
  };
  return this
});
$c_jl_StringBuilder.prototype.length__I = (function() {
  var thiz = this.java$lang$StringBuilder$$content$f;
  return $uI(thiz.length)
});
$c_jl_StringBuilder.prototype.append__C__jl_StringBuilder = (function(c) {
  var str = $as_T($g.String.fromCharCode(c));
  this.java$lang$StringBuilder$$content$f = (("" + this.java$lang$StringBuilder$$content$f) + str);
  return this
});
$c_jl_StringBuilder.prototype.substring__I__I__T = (function(start, end) {
  var thiz = this.java$lang$StringBuilder$$content$f;
  return $as_T(thiz.substring(start, end))
});
$c_jl_StringBuilder.prototype.init___T = (function(str) {
  $c_jl_StringBuilder.prototype.init___.call(this);
  if ((str === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  this.java$lang$StringBuilder$$content$f = str;
  return this
});
$c_jl_StringBuilder.prototype.reverse__jl_StringBuilder = (function() {
  var original = this.java$lang$StringBuilder$$content$f;
  var result = "";
  var i = (((-1) + $uI(original.length)) | 0);
  while ((i > 0)) {
    var index = i;
    var c = (65535 & $uI(original.charCodeAt(index)));
    if (((64512 & c) === 56320)) {
      var index$1 = (((-1) + i) | 0);
      var c2 = (65535 & $uI(original.charCodeAt(index$1)));
      if (((64512 & c2) === 55296)) {
        result = ((("" + result) + $as_T($g.String.fromCharCode(c2))) + $as_T($g.String.fromCharCode(c)));
        i = (((-2) + i) | 0)
      } else {
        result = (("" + result) + $as_T($g.String.fromCharCode(c)));
        i = (((-1) + i) | 0)
      }
    } else {
      result = (("" + result) + $as_T($g.String.fromCharCode(c)));
      i = (((-1) + i) | 0)
    }
  };
  if ((i === 0)) {
    var jsx$1 = result;
    var c$1 = (65535 & $uI(original.charCodeAt(0)));
    result = (("" + jsx$1) + $as_T($g.String.fromCharCode(c$1)))
  };
  this.java$lang$StringBuilder$$content$f = result;
  return this
});
$c_jl_StringBuilder.prototype.charAt__I__C = (function(index) {
  var thiz = this.java$lang$StringBuilder$$content$f;
  return (65535 & $uI(thiz.charCodeAt(index)))
});
var $d_jl_StringBuilder = new $TypeData().initClass({
  jl_StringBuilder: 0
}, false, "java.lang.StringBuilder", {
  jl_StringBuilder: 1,
  O: 1,
  jl_CharSequence: 1,
  jl_Appendable: 1,
  Ljava_io_Serializable: 1
});
$c_jl_StringBuilder.prototype.$classData = $d_jl_StringBuilder;
/** @constructor */
function $c_jl_ThreadDeath() {
  /*<skip>*/
}
function $as_jl_ThreadDeath(obj) {
  return (((obj instanceof $c_jl_ThreadDeath) || (obj === null)) ? obj : $throwClassCastException(obj, "java.lang.ThreadDeath"))
}
function $isArrayOf_jl_ThreadDeath(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_ThreadDeath)))
}
function $asArrayOf_jl_ThreadDeath(obj, depth) {
  return (($isArrayOf_jl_ThreadDeath(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.ThreadDeath;", depth))
}
/** @constructor */
function $c_jl_VirtualMachineError() {
  /*<skip>*/
}
function $as_jl_VirtualMachineError(obj) {
  return (((obj instanceof $c_jl_VirtualMachineError) || (obj === null)) ? obj : $throwClassCastException(obj, "java.lang.VirtualMachineError"))
}
function $isArrayOf_jl_VirtualMachineError(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_VirtualMachineError)))
}
function $asArrayOf_jl_VirtualMachineError(obj, depth) {
  return (($isArrayOf_jl_VirtualMachineError(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.VirtualMachineError;", depth))
}
/** @constructor */
function $c_ju_Formatter() {
  $c_O.call(this);
  this.dest$1 = null;
  this.stringOutput$1 = null;
  this.java$util$Formatter$$closed$f = false;
  this.java$util$Formatter$$lastIOException$f = null
}
$c_ju_Formatter.prototype = new $h_O();
$c_ju_Formatter.prototype.constructor = $c_ju_Formatter;
/** @constructor */
function $h_ju_Formatter() {
  /*<skip>*/
}
$h_ju_Formatter.prototype = $c_ju_Formatter.prototype;
$c_ju_Formatter.prototype.init___ = (function() {
  $c_ju_Formatter.prototype.init___jl_Appendable.call(this, null);
  return this
});
$c_ju_Formatter.prototype.sendToDest__p1__T__T__V = (function(s1, s2) {
  if ((this.dest$1 === null)) {
    this.stringOutput$1 = ((("" + this.stringOutput$1) + s1) + s2)
  } else {
    this.sendToDestSlowPath__p1__sjs_js_Array__V([s1, s2])
  }
});
$c_ju_Formatter.prototype.flagsConversionMismatch$1__p1__I__I__C__sr_Nothing$ = (function(flags$2, invalidFlags$1, conversion$2) {
  throw new $c_ju_FormatFlagsConversionMismatchException().init___T__C(this.flagsToString__p1__I__T((flags$2 & invalidFlags$1)), conversion$2)
});
$c_ju_Formatter.prototype.computerizedScientificNotation__p1__D__I__Z__T = (function(x, precision, forceDecimalSep) {
  var s1 = $as_T(x.toExponential(precision));
  var s2 = (((x === 0.0) && ((1 / x) < 0)) ? ("-" + s1) : s1);
  var len = $uI(s2.length);
  var index = (((-3) + len) | 0);
  if (((65535 & $uI(s2.charCodeAt(index))) !== 101)) {
    var s3 = s2
  } else {
    var endIndex = (((-1) + len) | 0);
    var jsx$1 = $as_T(s2.substring(0, endIndex));
    var beginIndex = (((-1) + len) | 0);
    var s3 = ((jsx$1 + "0") + $as_T(s2.substring(beginIndex)))
  };
  if (((!forceDecimalSep) || ($uI(s3.indexOf(".")) >= 0))) {
    return s3
  } else {
    var pos = $uI(s3.indexOf("e"));
    return (($as_T(s3.substring(0, pos)) + ".") + $as_T(s3.substring(pos)))
  }
});
$c_ju_Formatter.prototype.strRepeat__p1__T__I__T = (function(s, times) {
  var result = "";
  var i = 0;
  while ((i !== times)) {
    result = (("" + result) + s);
    i = ((1 + i) | 0)
  };
  return result
});
$c_ju_Formatter.prototype.padAndSendToDestNoZeroPad__p1__I__I__T__V = (function(flags, width, str) {
  var len = $uI(str.length);
  if ((len >= width)) {
    this.sendToDest__p1__T__V(str)
  } else if (((1 & flags) !== 0)) {
    this.sendToDest__p1__T__T__V(str, this.strRepeat__p1__T__I__T(" ", ((width - len) | 0)))
  } else {
    this.sendToDest__p1__T__T__V(this.strRepeat__p1__T__I__T(" ", ((width - len) | 0)), str)
  }
});
$c_ju_Formatter.prototype.applyUpperCase__p1__I__T__T = (function(flags, str) {
  return (((256 & flags) !== 0) ? $as_T(str.toUpperCase()) : str)
});
$c_ju_Formatter.prototype.insertGroupingSeps__p1__T__T = (function(s) {
  var len = $uI(s.length);
  var index = 0;
  while (true) {
    if ((index !== len)) {
      var index$1 = index;
      var c = (65535 & $uI(s.charCodeAt(index$1)));
      var jsx$1 = ((c >= 48) && (c <= 57))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      index = ((1 + index) | 0)
    } else {
      break
    }
  };
  index = (((-3) + index) | 0);
  if ((index <= 0)) {
    return s
  } else {
    var beginIndex = index;
    var result = $as_T(s.substring(beginIndex));
    while ((index > 3)) {
      var next = (((-3) + index) | 0);
      var endIndex = index;
      result = (($as_T(s.substring(next, endIndex)) + ",") + result);
      index = next
    };
    var endIndex$1 = index;
    return (($as_T(s.substring(0, endIndex$1)) + ",") + result)
  }
});
$c_ju_Formatter.prototype.toString__T = (function() {
  if (this.java$util$Formatter$$closed$f) {
    throw new $c_ju_FormatterClosedException().init___()
  };
  return ((this.dest$1 === null) ? this.stringOutput$1 : this.dest$1.toString__T())
});
$c_ju_Formatter.prototype.flagsToString__p1__I__T = (function(flags) {
  return ((((((((((1 & flags) !== 0) ? "-" : "") + (((2 & flags) !== 0) ? "#" : "")) + (((4 & flags) !== 0) ? "+" : "")) + (((8 & flags) !== 0) ? " " : "")) + (((16 & flags) !== 0) ? "0" : "")) + (((32 & flags) !== 0) ? "," : "")) + (((64 & flags) !== 0) ? "(" : "")) + (((128 & flags) !== 0) ? "<" : ""))
});
$c_ju_Formatter.prototype.init___jl_Appendable = (function(dest) {
  this.dest$1 = dest;
  this.stringOutput$1 = "";
  this.java$util$Formatter$$closed$f = false;
  this.java$util$Formatter$$lastIOException$f = null;
  return this
});
$c_ju_Formatter.prototype.parsePositiveIntSilent__p1__sjs_js_UndefOr__I__I = (function(capture, $default) {
  if ((capture === (void 0))) {
    return $default
  } else {
    var s = $as_T(capture);
    var x = $uD($g.parseInt(s, 10));
    return ((x <= 2147483647) ? $doubleToInt(x) : (-1))
  }
});
$c_ju_Formatter.prototype.generalScientificNotation__p1__D__I__Z__T = (function(x, precision, forceDecimalSep) {
  var m = $uD($g.Math.abs(x));
  var p = ((precision === 0) ? 1 : precision);
  if (((m >= 1.0E-4) && (m < $uD($g.Math.pow(10.0, p))))) {
    var v = $g.Math.log10;
    if ((!(v === (void 0)))) {
      var a = $uD($g.Math.log10(m))
    } else {
      var a = ($uD($g.Math.log(m)) / 2.302585092994046)
    };
    var sig0 = $doubleToInt($uD($g.Math.ceil(a)));
    var sig = (($uD($g.Math.pow(10.0, sig0)) <= m) ? ((1 + sig0) | 0) : sig0);
    var a$1 = ((p - sig) | 0);
    return this.decimalNotation__p1__D__I__Z__T(x, ((a$1 > 0) ? a$1 : 0), forceDecimalSep)
  } else {
    return this.computerizedScientificNotation__p1__D__I__Z__T(x, (((-1) + p) | 0), forceDecimalSep)
  }
});
$c_ju_Formatter.prototype.formatArg__p1__O__C__I__I__I__V = (function(arg, conversion, flags, width, precision) {
  switch (conversion) {
    case 98:
    case 66: {
      if (((126 & flags) !== 0)) {
        this.flagsConversionMismatch$1__p1__I__I__C__sr_Nothing$(flags, 126, conversion)
      };
      var str = (((arg === false) || (arg === null)) ? "false" : "true");
      this.formatNonNumericString__p1__I__I__I__T__V(flags, width, precision, str);
      break
    }
    case 104:
    case 72: {
      if (((126 & flags) !== 0)) {
        this.flagsConversionMismatch$1__p1__I__I__C__sr_Nothing$(flags, 126, conversion)
      };
      if ((arg === null)) {
        var str$2 = "null"
      } else {
        var i = $objectHashCode(arg);
        var x = $uD((i >>> 0));
        var jsx$1 = x.toString(16);
        var str$2 = $as_T(jsx$1)
      };
      this.formatNonNumericString__p1__I__I__I__T__V(flags, width, precision, str$2);
      break
    }
    case 115:
    case 83: {
      if ($is_ju_Formattable(arg)) {
        var x2 = $as_ju_Formattable(arg);
        if (((124 & flags) !== 0)) {
          this.flagsConversionMismatch$1__p1__I__I__C__sr_Nothing$(flags, 124, conversion)
        };
        var formattableFlags = (((((1 & flags) !== 0) ? 1 : 0) | (((2 & flags) !== 0) ? 4 : 0)) | (((256 & flags) !== 0) ? 2 : 0));
        x2.formatTo__ju_Formatter__I__I__I__V(this, formattableFlags, width, precision)
      } else {
        if (((126 & flags) !== 0)) {
          this.flagsConversionMismatch$1__p1__I__I__C__sr_Nothing$(flags, 126, conversion)
        };
        var str$3 = ("" + arg);
        this.formatNonNumericString__p1__I__I__I__T__V(flags, width, precision, str$3)
      };
      break
    }
    case 99:
    case 67: {
      if (((126 & flags) !== 0)) {
        this.flagsConversionMismatch$1__p1__I__I__C__sr_Nothing$(flags, 126, conversion)
      };
      if ((precision >= 0)) {
        throw new $c_ju_IllegalFormatPrecisionException().init___I(precision)
      };
      if ((arg instanceof $c_jl_Character)) {
        if ((arg === null)) {
          var x2$2 = 0
        } else {
          var this$10 = $as_jl_Character(arg);
          var x2$2 = this$10.value$1
        };
        this.formatNonNumericString__p1__I__I__I__T__V(flags, width, (-1), $as_T($g.String.fromCharCode(x2$2)))
      } else if ($isInt(arg)) {
        var x3 = $uI(arg);
        if ((!((x3 >= 0) && (x3 <= 1114111)))) {
          throw new $c_ju_IllegalFormatCodePointException().init___I(x3)
        };
        if ((x3 < 65536)) {
          var str$4 = $g.String.fromCharCode(x3)
        } else {
          var jsx$2 = $g.String;
          var value = (55296 | (((-64) + (x3 >> 10)) | 0));
          var value$1 = (56320 | (1023 & x3));
          var str$4 = jsx$2.fromCharCode(value, value$1)
        };
        this.formatNonNumericString__p1__I__I__I__T__V(flags, width, (-1), $as_T(str$4))
      } else {
        this.formatNullOrThrowIllegalFormatConversion$1__p1__O__I__I__I__C__V(arg, flags, width, precision, conversion)
      };
      break
    }
    case 100: {
      if (((2 & flags) !== 0)) {
        this.flagsConversionMismatch$1__p1__I__I__C__sr_Nothing$(flags, 2, conversion)
      };
      if ((((17 & flags) === 17) || ((12 & flags) === 12))) {
        this.illegalFlags$1__p1__I__sr_Nothing$(flags)
      };
      if ((precision >= 0)) {
        throw new $c_ju_IllegalFormatPrecisionException().init___I(precision)
      };
      if ($isInt(arg)) {
        var x2$3 = $uI(arg);
        this.java$util$Formatter$$formatNumericString__I__I__T__V(flags, width, ("" + x2$3))
      } else if ((arg instanceof $c_sjsr_RuntimeLong)) {
        var t = $uJ(arg);
        var lo = t.lo$2;
        var hi = t.hi$2;
        this.java$util$Formatter$$formatNumericString__I__I__T__V(flags, width, $m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toString__I__I__T(lo, hi))
      } else {
        this.formatNullOrThrowIllegalFormatConversion$1__p1__O__I__I__I__C__V(arg, flags, width, precision, conversion)
      };
      break
    }
    case 111: {
      if (((108 & flags) !== 0)) {
        this.flagsConversionMismatch$1__p1__I__I__C__sr_Nothing$(flags, 108, conversion)
      };
      if (((17 & flags) === 17)) {
        this.illegalFlags$1__p1__I__sr_Nothing$(flags)
      };
      if ((precision >= 0)) {
        throw new $c_ju_IllegalFormatPrecisionException().init___I(precision)
      };
      var prefix = (((2 & flags) !== 0) ? "0" : "");
      if ($isInt(arg)) {
        var x2$4 = $uI(arg);
        var x$1 = $uD((x2$4 >>> 0));
        var jsx$3 = x$1.toString(8);
        this.padAndSendToDest__p1__I__I__T__T__V(flags, width, prefix, $as_T(jsx$3))
      } else if ((arg instanceof $c_sjsr_RuntimeLong)) {
        var t$1 = $uJ(arg);
        var lo$1 = t$1.lo$2;
        var hi$1 = t$1.hi$2;
        var this$31 = $m_jl_Long$();
        this.padAndSendToDest__p1__I__I__T__T__V(flags, width, prefix, this$31.java$lang$Long$$toOctalString__I__I__T(lo$1, hi$1))
      } else {
        this.formatNullOrThrowIllegalFormatConversion$1__p1__O__I__I__I__C__V(arg, flags, width, precision, conversion)
      };
      break
    }
    case 120:
    case 88: {
      if (((108 & flags) !== 0)) {
        this.flagsConversionMismatch$1__p1__I__I__C__sr_Nothing$(flags, 108, conversion)
      };
      if (((17 & flags) === 17)) {
        this.illegalFlags$1__p1__I__sr_Nothing$(flags)
      };
      if ((precision >= 0)) {
        throw new $c_ju_IllegalFormatPrecisionException().init___I(precision)
      };
      var prefix$2 = (((2 & flags) === 0) ? "" : (((256 & flags) !== 0) ? "0X" : "0x"));
      if ($isInt(arg)) {
        var x2$5 = $uI(arg);
        var x$2 = $uD((x2$5 >>> 0));
        var jsx$4 = x$2.toString(16);
        this.padAndSendToDest__p1__I__I__T__T__V(flags, width, prefix$2, this.applyUpperCase__p1__I__T__T(flags, $as_T(jsx$4)))
      } else if ((arg instanceof $c_sjsr_RuntimeLong)) {
        var t$2 = $uJ(arg);
        var lo$2 = t$2.lo$2;
        var hi$2 = t$2.hi$2;
        var this$38 = $m_jl_Long$();
        this.padAndSendToDest__p1__I__I__T__T__V(flags, width, prefix$2, this.applyUpperCase__p1__I__T__T(flags, this$38.java$lang$Long$$toHexString__I__I__T(lo$2, hi$2)))
      } else {
        this.formatNullOrThrowIllegalFormatConversion$1__p1__O__I__I__I__C__V(arg, flags, width, precision, conversion)
      };
      break
    }
    case 101:
    case 69: {
      if (((32 & flags) !== 0)) {
        this.flagsConversionMismatch$1__p1__I__I__C__sr_Nothing$(flags, 32, conversion)
      };
      if ((((17 & flags) === 17) || ((12 & flags) === 12))) {
        this.illegalFlags$1__p1__I__sr_Nothing$(flags)
      };
      if (((typeof arg) === "number")) {
        var x2$1 = $uD(arg);
        if (((x2$1 !== x2$1) || ((x2$1 === Infinity) || (x2$1 === (-Infinity))))) {
          this.java$util$Formatter$$formatNaNOrInfinite__I__I__D__V(flags, width, x2$1)
        } else {
          var forceDecimalSep = ((2 & flags) !== 0);
          var arg2 = ((precision >= 0) ? precision : 6);
          this.java$util$Formatter$$formatNumericString__I__I__T__V(flags, width, this.computerizedScientificNotation__p1__D__I__Z__T(x2$1, arg2, forceDecimalSep))
        }
      } else {
        this.formatNullOrThrowIllegalFormatConversion$1__p1__O__I__I__I__C__V(arg, flags, width, precision, conversion)
      };
      break
    }
    case 103:
    case 71: {
      if (((2 & flags) !== 0)) {
        this.flagsConversionMismatch$1__p1__I__I__C__sr_Nothing$(flags, 2, conversion)
      };
      if ((((17 & flags) === 17) || ((12 & flags) === 12))) {
        this.illegalFlags$1__p1__I__sr_Nothing$(flags)
      };
      if (((typeof arg) === "number")) {
        var x2$6 = $uD(arg);
        if (((x2$6 !== x2$6) || ((x2$6 === Infinity) || (x2$6 === (-Infinity))))) {
          this.java$util$Formatter$$formatNaNOrInfinite__I__I__D__V(flags, width, x2$6)
        } else {
          var forceDecimalSep$1 = ((2 & flags) !== 0);
          var arg2$1 = ((precision >= 0) ? precision : 6);
          this.java$util$Formatter$$formatNumericString__I__I__T__V(flags, width, this.generalScientificNotation__p1__D__I__Z__T(x2$6, arg2$1, forceDecimalSep$1))
        }
      } else {
        this.formatNullOrThrowIllegalFormatConversion$1__p1__O__I__I__I__C__V(arg, flags, width, precision, conversion)
      };
      break
    }
    case 102: {
      if ((((17 & flags) === 17) || ((12 & flags) === 12))) {
        this.illegalFlags$1__p1__I__sr_Nothing$(flags)
      };
      if (((typeof arg) === "number")) {
        var x2$7 = $uD(arg);
        if (((x2$7 !== x2$7) || ((x2$7 === Infinity) || (x2$7 === (-Infinity))))) {
          this.java$util$Formatter$$formatNaNOrInfinite__I__I__D__V(flags, width, x2$7)
        } else {
          var forceDecimalSep$2 = ((2 & flags) !== 0);
          var arg2$2 = ((precision >= 0) ? precision : 6);
          this.java$util$Formatter$$formatNumericString__I__I__T__V(flags, width, this.decimalNotation__p1__D__I__Z__T(x2$7, arg2$2, forceDecimalSep$2))
        }
      } else {
        this.formatNullOrThrowIllegalFormatConversion$1__p1__O__I__I__I__C__V(arg, flags, width, precision, conversion)
      };
      break
    }
    case 37: {
      if (((254 & flags) !== 0)) {
        this.illegalFlags$2__p1__I__sr_Nothing$(flags)
      };
      if ((precision >= 0)) {
        throw new $c_ju_IllegalFormatPrecisionException().init___I(precision)
      };
      if ((((1 & flags) !== 0) && (width < 0))) {
        throw new $c_ju_MissingFormatWidthException().init___T("%-%")
      };
      this.padAndSendToDestNoZeroPad__p1__I__I__T__V(flags, width, "%");
      break
    }
    case 110: {
      if (((255 & flags) !== 0)) {
        this.illegalFlags$2__p1__I__sr_Nothing$(flags)
      };
      if ((precision >= 0)) {
        throw new $c_ju_IllegalFormatPrecisionException().init___I(precision)
      };
      if ((width >= 0)) {
        throw new $c_ju_IllegalFormatWidthException().init___I(width)
      };
      this.sendToDest__p1__T__V("\n");
      break
    }
    default: {
      throw new $c_ju_UnknownFormatConversionException().init___T($as_T($g.String.fromCharCode(conversion)))
    }
  }
});
$c_ju_Formatter.prototype.sendToDest__p1__T__T__T__V = (function(s1, s2, s3) {
  if ((this.dest$1 === null)) {
    this.stringOutput$1 = ((this.stringOutput$1 + (("" + s1) + s2)) + s3)
  } else {
    this.sendToDestSlowPath__p1__sjs_js_Array__V([s1, s2, s3])
  }
});
$c_ju_Formatter.prototype.padAndSendToDest__p1__I__I__T__T__V = (function(flags, width, prefix, str) {
  var len = (($uI(prefix.length) + $uI(str.length)) | 0);
  if ((len >= width)) {
    this.sendToDest__p1__T__T__V(prefix, str)
  } else if (((16 & flags) !== 0)) {
    this.sendToDest__p1__T__T__T__V(prefix, this.strRepeat__p1__T__I__T("0", ((width - len) | 0)), str)
  } else if (((1 & flags) !== 0)) {
    this.sendToDest__p1__T__T__T__V(prefix, str, this.strRepeat__p1__T__I__T(" ", ((width - len) | 0)))
  } else {
    this.sendToDest__p1__T__T__T__V(this.strRepeat__p1__T__I__T(" ", ((width - len) | 0)), prefix, str)
  }
});
$c_ju_Formatter.prototype.java$util$Formatter$$formatNaNOrInfinite__I__I__D__V = (function(flags, width, x) {
  var str = ((x !== x) ? "NaN" : ((x > 0.0) ? (((4 & flags) !== 0) ? "+Infinity" : (((8 & flags) !== 0) ? " Infinity" : "Infinity")) : (((64 & flags) !== 0) ? "(Infinity)" : "-Infinity")));
  this.padAndSendToDestNoZeroPad__p1__I__I__T__V(flags, width, this.applyUpperCase__p1__I__T__T(flags, str))
});
$c_ju_Formatter.prototype.sendToDestSlowPath__p1__sjs_js_Array__V = (function(ss) {
  try {
    var i = 0;
    var len = $uI(ss.length);
    while ((i < len)) {
      var index = i;
      var arg1 = ss[index];
      var x$1 = $as_T(arg1);
      this.dest$1.append__jl_CharSequence__jl_Appendable(x$1);
      i = ((1 + i) | 0)
    }
  } catch (e) {
    if ((e instanceof $c_Ljava_io_IOException)) {
      var th = $as_Ljava_io_IOException(e);
      this.java$util$Formatter$$lastIOException$f = th
    } else {
      throw e
    }
  }
});
$c_ju_Formatter.prototype.formatNullOrThrowIllegalFormatConversion$1__p1__O__I__I__I__C__V = (function(arg$1, flags$1, width$1, precision$1, conversion$1) {
  if ((arg$1 === null)) {
    this.formatNonNumericString__p1__I__I__I__T__V(flags$1, width$1, precision$1, "null")
  } else {
    throw new $c_ju_IllegalFormatConversionException().init___C__jl_Class(conversion$1, $objectGetClass(arg$1))
  }
});
$c_ju_Formatter.prototype.format__T__AO__ju_Formatter = (function(format, args) {
  if (this.java$util$Formatter$$closed$f) {
    throw new $c_ju_FormatterClosedException().init___()
  };
  var lastImplicitArgIndex = 0;
  var lastArgIndex = 0;
  var fmtLength = $uI(format.length);
  var fmtIndex = 0;
  while ((fmtIndex !== fmtLength)) {
    var fromIndex = fmtIndex;
    var nextPercentIndex = $uI(format.indexOf("%", fromIndex));
    if ((nextPercentIndex < 0)) {
      var beginIndex = fmtIndex;
      this.sendToDest__p1__T__V($as_T(format.substring(beginIndex)));
      return this
    };
    var beginIndex$1 = fmtIndex;
    this.sendToDest__p1__T__V($as_T(format.substring(beginIndex$1, nextPercentIndex)));
    var formatSpecifierIndex = ((1 + nextPercentIndex) | 0);
    var re = $m_ju_Formatter$().java$util$Formatter$$FormatSpecifier$1;
    re.lastIndex = formatSpecifierIndex;
    var execResult = re.exec(format);
    if (((execResult === null) || ($uI(execResult.index) !== formatSpecifierIndex))) {
      if ((formatSpecifierIndex === fmtLength)) {
        var conversion = "%"
      } else {
        var endIndex = ((1 + formatSpecifierIndex) | 0);
        var conversion = $as_T(format.substring(formatSpecifierIndex, endIndex))
      };
      throw new $c_ju_UnknownFormatConversionException().init___T(conversion)
    };
    fmtIndex = $uI(re.lastIndex);
    var index = (((-1) + fmtIndex) | 0);
    var conversion$2 = (65535 & $uI(format.charCodeAt(index)));
    var flags = this.parseFlags__p1__T__C__I($as_T(execResult[2]), conversion$2);
    var width = this.parsePositiveIntSilent__p1__sjs_js_UndefOr__I__I(execResult[3], (-1));
    var precision = this.parsePositiveIntSilent__p1__sjs_js_UndefOr__I__I(execResult[4], (-1));
    if (((conversion$2 === 37) || (conversion$2 === 110))) {
      var arg = null
    } else {
      if ((((1 & flags) !== 0) && (width < 0))) {
        throw new $c_ju_MissingFormatWidthException().init___T(("%" + execResult[0]))
      };
      if (((128 & flags) !== 0)) {
        var argIndex = lastArgIndex
      } else {
        var i = this.parsePositiveIntSilent__p1__sjs_js_UndefOr__I__I(execResult[1], 0);
        if ((i === 0)) {
          lastImplicitArgIndex = ((1 + lastImplicitArgIndex) | 0);
          var argIndex = lastImplicitArgIndex
        } else {
          var argIndex = ((i < 0) ? lastArgIndex : i)
        }
      };
      if (((argIndex <= 0) || (argIndex > args.u.length))) {
        var conversionStr = $as_T($g.String.fromCharCode(conversion$2));
        if (($uI("bBhHsHcCdoxXeEgGfn%".indexOf(conversionStr)) < 0)) {
          throw new $c_ju_UnknownFormatConversionException().init___T(conversionStr)
        } else {
          throw new $c_ju_MissingFormatArgumentException().init___T(("%" + execResult[0]))
        }
      };
      lastArgIndex = argIndex;
      var arg = args.get((((-1) + argIndex) | 0))
    };
    this.formatArg__p1__O__C__I__I__I__V(arg, conversion$2, flags, width, precision)
  };
  return this
});
$c_ju_Formatter.prototype.decimalNotation__p1__D__I__Z__T = (function(x, precision, forceDecimalSep) {
  var s1 = $as_T(x.toFixed(precision));
  var s2 = (((x === 0.0) && ((1 / x) < 0)) ? ("-" + s1) : s1);
  return ((forceDecimalSep && ($uI(s2.indexOf(".")) < 0)) ? (s2 + ".") : s2)
});
$c_ju_Formatter.prototype.formatNonNumericString__p1__I__I__I__T__V = (function(flags, width, precision, str) {
  var truncatedStr = ((precision < 0) ? str : $as_T(str.substring(0, precision)));
  this.padAndSendToDestNoZeroPad__p1__I__I__T__V(flags, width, this.applyUpperCase__p1__I__T__T(flags, truncatedStr))
});
$c_ju_Formatter.prototype.illegalFlags$1__p1__I__sr_Nothing$ = (function(flags$2) {
  throw new $c_ju_IllegalFormatFlagsException().init___T(this.flagsToString__p1__I__T(flags$2))
});
$c_ju_Formatter.prototype.illegalFlags$2__p1__I__sr_Nothing$ = (function(flags$3) {
  throw new $c_ju_IllegalFormatFlagsException().init___T(this.flagsToString__p1__I__T(flags$3))
});
$c_ju_Formatter.prototype.sendToDest__p1__T__V = (function(s) {
  if ((this.dest$1 === null)) {
    this.stringOutput$1 = (("" + this.stringOutput$1) + s)
  } else {
    this.sendToDestSlowPath__p1__sjs_js_Array__V([s])
  }
});
$c_ju_Formatter.prototype.java$util$Formatter$$formatNumericString__I__I__T__V = (function(flags, width, str) {
  if ((($uI(str.length) >= width) && ((108 & flags) === 0))) {
    this.sendToDest__p1__T__V(this.applyUpperCase__p1__I__T__T(flags, str))
  } else if (((124 & flags) === 0)) {
    this.formatNonNumericString__p1__I__I__I__T__V(flags, width, (-1), str)
  } else {
    if (((65535 & $uI(str.charCodeAt(0))) !== 45)) {
      if (((4 & flags) !== 0)) {
        var x1_$_$$und1$f = "+";
        var x1_$_$$und2$f = str
      } else if (((8 & flags) !== 0)) {
        var x1_$_$$und1$f = " ";
        var x1_$_$$und2$f = str
      } else {
        var x1_$_$$und1$f = "";
        var x1_$_$$und2$f = str
      }
    } else if (((64 & flags) !== 0)) {
      var _2 = ($as_T(str.substring(1)) + ")");
      var x1_$_$$und1$f = "(";
      var x1_$_$$und2$f = _2
    } else {
      var _2$1 = $as_T(str.substring(1));
      var x1_$_$$und1$f = "-";
      var x1_$_$$und2$f = _2$1
    };
    var prefix = $as_T(x1_$_$$und1$f);
    var rest0 = $as_T(x1_$_$$und2$f);
    var rest = (((32 & flags) !== 0) ? this.insertGroupingSeps__p1__T__T(rest0) : rest0);
    this.padAndSendToDest__p1__I__I__T__T__V(flags, width, prefix, this.applyUpperCase__p1__I__T__T(flags, rest))
  }
});
$c_ju_Formatter.prototype.parseFlags__p1__T__C__I = (function(flags, conversion) {
  var bits = ((conversion <= 90) ? 256 : 0);
  var len = $uI(flags.length);
  var i = 0;
  while ((i !== len)) {
    var index = i;
    var f = (65535 & $uI(flags.charCodeAt(index)));
    switch (f) {
      case 45: {
        var bit = 1;
        break
      }
      case 35: {
        var bit = 2;
        break
      }
      case 43: {
        var bit = 4;
        break
      }
      case 32: {
        var bit = 8;
        break
      }
      case 48: {
        var bit = 16;
        break
      }
      case 44: {
        var bit = 32;
        break
      }
      case 40: {
        var bit = 64;
        break
      }
      case 60: {
        var bit = 128;
        break
      }
      default: {
        var bit;
        throw new $c_s_MatchError().init___O(new $c_jl_Character().init___C(f))
      }
    };
    if (((bits & bit) !== 0)) {
      throw new $c_ju_DuplicateFormatFlagsException().init___T($as_T($g.String.fromCharCode(f)))
    };
    bits = (bits | bit);
    i = ((1 + i) | 0)
  };
  return bits
});
$c_ju_Formatter.prototype.close__V = (function() {
  if (((!this.java$util$Formatter$$closed$f) && (this.dest$1 !== null))) {
    var x1 = this.dest$1;
    if ($is_Ljava_io_Closeable(x1)) {
      try {
        $as_Ljava_io_Closeable(x1).close__V()
      } catch (e) {
        if ((e instanceof $c_Ljava_io_IOException)) {
          var th = $as_Ljava_io_IOException(e);
          this.java$util$Formatter$$lastIOException$f = th
        } else {
          throw e
        }
      }
    }
  };
  this.java$util$Formatter$$closed$f = true
});
var $d_ju_Formatter = new $TypeData().initClass({
  ju_Formatter: 0
}, false, "java.util.Formatter", {
  ju_Formatter: 1,
  O: 1,
  Ljava_io_Closeable: 1,
  jl_AutoCloseable: 1,
  Ljava_io_Flushable: 1
});
$c_ju_Formatter.prototype.$classData = $d_ju_Formatter;
/** @constructor */
function $c_ju_concurrent_ExecutionException() {
  $c_jl_Exception.call(this)
}
$c_ju_concurrent_ExecutionException.prototype = new $h_jl_Exception();
$c_ju_concurrent_ExecutionException.prototype.constructor = $c_ju_concurrent_ExecutionException;
/** @constructor */
function $h_ju_concurrent_ExecutionException() {
  /*<skip>*/
}
$h_ju_concurrent_ExecutionException.prototype = $c_ju_concurrent_ExecutionException.prototype;
$c_ju_concurrent_ExecutionException.prototype.init___T__jl_Throwable = (function(message, cause) {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, message, cause, true, true);
  return this
});
var $d_ju_concurrent_ExecutionException = new $TypeData().initClass({
  ju_concurrent_ExecutionException: 0
}, false, "java.util.concurrent.ExecutionException", {
  ju_concurrent_ExecutionException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_ju_concurrent_ExecutionException.prototype.$classData = $d_ju_concurrent_ExecutionException;
/** @constructor */
function $c_ju_concurrent_TimeUnit() {
  $c_jl_Enum.call(this)
}
$c_ju_concurrent_TimeUnit.prototype = new $h_jl_Enum();
$c_ju_concurrent_TimeUnit.prototype.constructor = $c_ju_concurrent_TimeUnit;
/** @constructor */
function $h_ju_concurrent_TimeUnit() {
  /*<skip>*/
}
$h_ju_concurrent_TimeUnit.prototype = $c_ju_concurrent_TimeUnit.prototype;
function $as_ju_concurrent_TimeUnit(obj) {
  return (((obj instanceof $c_ju_concurrent_TimeUnit) || (obj === null)) ? obj : $throwClassCastException(obj, "java.util.concurrent.TimeUnit"))
}
function $isArrayOf_ju_concurrent_TimeUnit(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.ju_concurrent_TimeUnit)))
}
function $asArrayOf_ju_concurrent_TimeUnit(obj, depth) {
  return (($isArrayOf_ju_concurrent_TimeUnit(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.util.concurrent.TimeUnit;", depth))
}
var $d_ju_concurrent_TimeUnit = new $TypeData().initClass({
  ju_concurrent_TimeUnit: 0
}, false, "java.util.concurrent.TimeUnit", {
  ju_concurrent_TimeUnit: 1,
  jl_Enum: 1,
  O: 1,
  jl_Comparable: 1,
  Ljava_io_Serializable: 1
});
$c_ju_concurrent_TimeUnit.prototype.$classData = $d_ju_concurrent_TimeUnit;
/** @constructor */
function $c_ju_concurrent_atomic_AtomicInteger() {
  $c_jl_Number.call(this);
  this.java$util$concurrent$atomic$AtomicInteger$$value$f = 0
}
$c_ju_concurrent_atomic_AtomicInteger.prototype = new $h_jl_Number();
$c_ju_concurrent_atomic_AtomicInteger.prototype.constructor = $c_ju_concurrent_atomic_AtomicInteger;
/** @constructor */
function $h_ju_concurrent_atomic_AtomicInteger() {
  /*<skip>*/
}
$h_ju_concurrent_atomic_AtomicInteger.prototype = $c_ju_concurrent_atomic_AtomicInteger.prototype;
$c_ju_concurrent_atomic_AtomicInteger.prototype.init___ = (function() {
  $c_ju_concurrent_atomic_AtomicInteger.prototype.init___I.call(this, 0);
  return this
});
$c_ju_concurrent_atomic_AtomicInteger.prototype.toString__T = (function() {
  var this$1 = this.java$util$concurrent$atomic$AtomicInteger$$value$f;
  return ("" + this$1)
});
$c_ju_concurrent_atomic_AtomicInteger.prototype.init___I = (function(value) {
  this.java$util$concurrent$atomic$AtomicInteger$$value$f = value;
  return this
});
$c_ju_concurrent_atomic_AtomicInteger.prototype.intValue__I = (function() {
  return this.java$util$concurrent$atomic$AtomicInteger$$value$f
});
var $d_ju_concurrent_atomic_AtomicInteger = new $TypeData().initClass({
  ju_concurrent_atomic_AtomicInteger: 0
}, false, "java.util.concurrent.atomic.AtomicInteger", {
  ju_concurrent_atomic_AtomicInteger: 1,
  jl_Number: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  s_Serializable: 1
});
$c_ju_concurrent_atomic_AtomicInteger.prototype.$classData = $d_ju_concurrent_atomic_AtomicInteger;
/** @constructor */
function $c_s_Array$() {
  $c_s_FallbackArrayBuilding.call(this)
}
$c_s_Array$.prototype = new $h_s_FallbackArrayBuilding();
$c_s_Array$.prototype.constructor = $c_s_Array$;
/** @constructor */
function $h_s_Array$() {
  /*<skip>*/
}
$h_s_Array$.prototype = $c_s_Array$.prototype;
$c_s_Array$.prototype.init___ = (function() {
  return this
});
$c_s_Array$.prototype.unapplySeq__O__s_Option = (function(x) {
  if ((x === null)) {
    return $m_s_None$()
  } else {
    var this$1 = $m_s_Predef$().genericArrayOps__O__scm_ArrayOps(x);
    var this$2 = $m_s_Predef$();
    var cbf = new $c_s_LowPriorityImplicits$$anon$4().init___s_LowPriorityImplicits(this$2);
    return new $c_s_Some().init___O($as_sci_IndexedSeq($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this$1, cbf)))
  }
});
$c_s_Array$.prototype.slowcopy__p2__O__I__O__I__I__V = (function(src, srcPos, dest, destPos, length) {
  var i = srcPos;
  var j = destPos;
  var srcUntil = ((srcPos + length) | 0);
  while ((i < srcUntil)) {
    $m_sr_ScalaRunTime$().array$undupdate__O__I__O__V(dest, j, $m_sr_ScalaRunTime$().array$undapply__O__I__O(src, i));
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  }
});
$c_s_Array$.prototype.copy__O__I__O__I__I__V = (function(src, srcPos, dest, destPos, length) {
  var srcClass = $objectGetClass(src);
  if ((srcClass.isArray__Z() && $objectGetClass(dest).isAssignableFrom__jl_Class__Z(srcClass))) {
    $systemArraycopy(src, srcPos, dest, destPos, length)
  } else {
    this.slowcopy__p2__O__I__O__I__I__V(src, srcPos, dest, destPos, length)
  }
});
var $d_s_Array$ = new $TypeData().initClass({
  s_Array$: 0
}, false, "scala.Array$", {
  s_Array$: 1,
  s_FallbackArrayBuilding: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_Array$.prototype.$classData = $d_s_Array$;
var $n_s_Array$ = (void 0);
function $m_s_Array$() {
  if ((!$n_s_Array$)) {
    $n_s_Array$ = new $c_s_Array$().init___()
  };
  return $n_s_Array$
}
/** @constructor */
function $c_s_NotImplementedError() {
  $c_jl_Error.call(this)
}
$c_s_NotImplementedError.prototype = new $h_jl_Error();
$c_s_NotImplementedError.prototype.constructor = $c_s_NotImplementedError;
/** @constructor */
function $h_s_NotImplementedError() {
  /*<skip>*/
}
$h_s_NotImplementedError.prototype = $c_s_NotImplementedError.prototype;
$c_s_NotImplementedError.prototype.init___ = (function() {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, "an implementation is missing", null, true, true);
  return this
});
var $d_s_NotImplementedError = new $TypeData().initClass({
  s_NotImplementedError: 0
}, false, "scala.NotImplementedError", {
  s_NotImplementedError: 1,
  jl_Error: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_s_NotImplementedError.prototype.$classData = $d_s_NotImplementedError;
/** @constructor */
function $c_s_Predef$$eq$colon$eq() {
  $c_O.call(this)
}
$c_s_Predef$$eq$colon$eq.prototype = new $h_O();
$c_s_Predef$$eq$colon$eq.prototype.constructor = $c_s_Predef$$eq$colon$eq;
/** @constructor */
function $h_s_Predef$$eq$colon$eq() {
  /*<skip>*/
}
$h_s_Predef$$eq$colon$eq.prototype = $c_s_Predef$$eq$colon$eq.prototype;
$c_s_Predef$$eq$colon$eq.prototype.toString__T = (function() {
  return "<function1>"
});
$c_s_Predef$$eq$colon$eq.prototype.apply$mcZI$sp__I__Z = (function(v1) {
  return $uZ(v1)
});
/** @constructor */
function $c_s_Predef$$less$colon$less() {
  $c_O.call(this)
}
$c_s_Predef$$less$colon$less.prototype = new $h_O();
$c_s_Predef$$less$colon$less.prototype.constructor = $c_s_Predef$$less$colon$less;
/** @constructor */
function $h_s_Predef$$less$colon$less() {
  /*<skip>*/
}
$h_s_Predef$$less$colon$less.prototype = $c_s_Predef$$less$colon$less.prototype;
$c_s_Predef$$less$colon$less.prototype.toString__T = (function() {
  return "<function1>"
});
$c_s_Predef$$less$colon$less.prototype.apply$mcZI$sp__I__Z = (function(v1) {
  return $uZ(v1)
});
/** @constructor */
function $c_s_concurrent_Future$InternalCallbackExecutor$() {
  $c_O.call(this);
  this.scala$concurrent$BatchingExecutor$$$undtasksLocal$1 = null
}
$c_s_concurrent_Future$InternalCallbackExecutor$.prototype = new $h_O();
$c_s_concurrent_Future$InternalCallbackExecutor$.prototype.constructor = $c_s_concurrent_Future$InternalCallbackExecutor$;
/** @constructor */
function $h_s_concurrent_Future$InternalCallbackExecutor$() {
  /*<skip>*/
}
$h_s_concurrent_Future$InternalCallbackExecutor$.prototype = $c_s_concurrent_Future$InternalCallbackExecutor$.prototype;
$c_s_concurrent_Future$InternalCallbackExecutor$.prototype.init___ = (function() {
  $n_s_concurrent_Future$InternalCallbackExecutor$ = this;
  this.scala$concurrent$BatchingExecutor$$$undtasksLocal$1 = new $c_jl_ThreadLocal().init___();
  return this
});
$c_s_concurrent_Future$InternalCallbackExecutor$.prototype.reportFailure__jl_Throwable__V = (function(t) {
  throw new $c_jl_IllegalStateException().init___T__jl_Throwable("problem in scala.concurrent internal callback", t)
});
$c_s_concurrent_Future$InternalCallbackExecutor$.prototype.execute__jl_Runnable__V = (function(runnable) {
  $f_s_concurrent_BatchingExecutor__execute__jl_Runnable__V(this, runnable)
});
var $d_s_concurrent_Future$InternalCallbackExecutor$ = new $TypeData().initClass({
  s_concurrent_Future$InternalCallbackExecutor$: 0
}, false, "scala.concurrent.Future$InternalCallbackExecutor$", {
  s_concurrent_Future$InternalCallbackExecutor$: 1,
  O: 1,
  s_concurrent_ExecutionContext: 1,
  s_concurrent_BatchingExecutor: 1,
  ju_concurrent_Executor: 1
});
$c_s_concurrent_Future$InternalCallbackExecutor$.prototype.$classData = $d_s_concurrent_Future$InternalCallbackExecutor$;
var $n_s_concurrent_Future$InternalCallbackExecutor$ = (void 0);
function $m_s_concurrent_Future$InternalCallbackExecutor$() {
  if ((!$n_s_concurrent_Future$InternalCallbackExecutor$)) {
    $n_s_concurrent_Future$InternalCallbackExecutor$ = new $c_s_concurrent_Future$InternalCallbackExecutor$().init___()
  };
  return $n_s_concurrent_Future$InternalCallbackExecutor$
}
function $f_s_concurrent_impl_Promise$KeptPromise$Kept__onComplete__F1__s_concurrent_ExecutionContext__V($thiz, func, executor) {
  new $c_s_concurrent_impl_CallbackRunnable().init___s_concurrent_ExecutionContext__F1(executor, func).executeWithValue__s_util_Try__V($thiz.result__s_util_Try())
}
/** @constructor */
function $c_s_math_Equiv$() {
  $c_O.call(this)
}
$c_s_math_Equiv$.prototype = new $h_O();
$c_s_math_Equiv$.prototype.constructor = $c_s_math_Equiv$;
/** @constructor */
function $h_s_math_Equiv$() {
  /*<skip>*/
}
$h_s_math_Equiv$.prototype = $c_s_math_Equiv$.prototype;
$c_s_math_Equiv$.prototype.init___ = (function() {
  return this
});
var $d_s_math_Equiv$ = new $TypeData().initClass({
  s_math_Equiv$: 0
}, false, "scala.math.Equiv$", {
  s_math_Equiv$: 1,
  O: 1,
  s_math_LowPriorityEquiv: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_math_Equiv$.prototype.$classData = $d_s_math_Equiv$;
var $n_s_math_Equiv$ = (void 0);
function $m_s_math_Equiv$() {
  if ((!$n_s_math_Equiv$)) {
    $n_s_math_Equiv$ = new $c_s_math_Equiv$().init___()
  };
  return $n_s_math_Equiv$
}
/** @constructor */
function $c_s_math_Ordering$() {
  $c_O.call(this)
}
$c_s_math_Ordering$.prototype = new $h_O();
$c_s_math_Ordering$.prototype.constructor = $c_s_math_Ordering$;
/** @constructor */
function $h_s_math_Ordering$() {
  /*<skip>*/
}
$h_s_math_Ordering$.prototype = $c_s_math_Ordering$.prototype;
$c_s_math_Ordering$.prototype.init___ = (function() {
  return this
});
var $d_s_math_Ordering$ = new $TypeData().initClass({
  s_math_Ordering$: 0
}, false, "scala.math.Ordering$", {
  s_math_Ordering$: 1,
  O: 1,
  s_math_LowPriorityOrderingImplicits: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_math_Ordering$.prototype.$classData = $d_s_math_Ordering$;
var $n_s_math_Ordering$ = (void 0);
function $m_s_math_Ordering$() {
  if ((!$n_s_math_Ordering$)) {
    $n_s_math_Ordering$ = new $c_s_math_Ordering$().init___()
  };
  return $n_s_math_Ordering$
}
/** @constructor */
function $c_s_reflect_NoManifest$() {
  $c_O.call(this)
}
$c_s_reflect_NoManifest$.prototype = new $h_O();
$c_s_reflect_NoManifest$.prototype.constructor = $c_s_reflect_NoManifest$;
/** @constructor */
function $h_s_reflect_NoManifest$() {
  /*<skip>*/
}
$h_s_reflect_NoManifest$.prototype = $c_s_reflect_NoManifest$.prototype;
$c_s_reflect_NoManifest$.prototype.init___ = (function() {
  return this
});
$c_s_reflect_NoManifest$.prototype.toString__T = (function() {
  return "<?>"
});
var $d_s_reflect_NoManifest$ = new $TypeData().initClass({
  s_reflect_NoManifest$: 0
}, false, "scala.reflect.NoManifest$", {
  s_reflect_NoManifest$: 1,
  O: 1,
  s_reflect_OptManifest: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_reflect_NoManifest$.prototype.$classData = $d_s_reflect_NoManifest$;
var $n_s_reflect_NoManifest$ = (void 0);
function $m_s_reflect_NoManifest$() {
  if ((!$n_s_reflect_NoManifest$)) {
    $n_s_reflect_NoManifest$ = new $c_s_reflect_NoManifest$().init___()
  };
  return $n_s_reflect_NoManifest$
}
/** @constructor */
function $c_s_util_matching_Regex$$anon$1() {
  $c_O.call(this);
  this.matchIterator$1$1 = null
}
$c_s_util_matching_Regex$$anon$1.prototype = new $h_O();
$c_s_util_matching_Regex$$anon$1.prototype.constructor = $c_s_util_matching_Regex$$anon$1;
/** @constructor */
function $h_s_util_matching_Regex$$anon$1() {
  /*<skip>*/
}
$h_s_util_matching_Regex$$anon$1.prototype = $c_s_util_matching_Regex$$anon$1.prototype;
$c_s_util_matching_Regex$$anon$1.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_s_util_matching_Regex$$anon$1.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_s_util_matching_Regex$$anon$1.prototype.next__O = (function() {
  return this.next__s_util_matching_Regex$Match()
});
$c_s_util_matching_Regex$$anon$1.prototype.toIterator__sc_Iterator = (function() {
  return this
});
$c_s_util_matching_Regex$$anon$1.prototype.isEmpty__Z = (function() {
  return $f_sc_Iterator__isEmpty__Z(this)
});
$c_s_util_matching_Regex$$anon$1.prototype.toList__sci_List = (function() {
  var this$1 = $m_sci_List$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_sci_List($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_s_util_matching_Regex$$anon$1.prototype.take__I__sc_Iterator = (function(n) {
  return $f_sc_Iterator__take__I__sc_Iterator(this, n)
});
$c_s_util_matching_Regex$$anon$1.prototype.init___s_util_matching_Regex__s_util_matching_Regex$MatchIterator = (function($$outer, matchIterator$1) {
  this.matchIterator$1$1 = matchIterator$1;
  return this
});
$c_s_util_matching_Regex$$anon$1.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_s_util_matching_Regex$$anon$1.prototype.mkString__T__T = (function(sep) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", sep, "")
});
$c_s_util_matching_Regex$$anon$1.prototype.toString__T = (function() {
  return "<iterator>"
});
$c_s_util_matching_Regex$$anon$1.prototype.sliceIterator__I__I__sc_Iterator = (function(from, until) {
  return $f_sc_Iterator__sliceIterator__I__I__sc_Iterator(this, from, until)
});
$c_s_util_matching_Regex$$anon$1.prototype.foreach__F1__V = (function(f) {
  $f_sc_Iterator__foreach__F1__V(this, f)
});
$c_s_util_matching_Regex$$anon$1.prototype.foldLeft__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_s_util_matching_Regex$$anon$1.prototype.$$plus$plus__F0__sc_Iterator = (function(that) {
  return $f_sc_Iterator__$$plus$plus__F0__sc_Iterator(this, that)
});
$c_s_util_matching_Regex$$anon$1.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_s_util_matching_Regex$$anon$1.prototype.size__I = (function() {
  return $f_sc_TraversableOnce__size__I(this)
});
$c_s_util_matching_Regex$$anon$1.prototype.toBuffer__scm_Buffer = (function() {
  var this$1 = $m_scm_ArrayBuffer$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_scm_Buffer($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_s_util_matching_Regex$$anon$1.prototype.hasNext__Z = (function() {
  return this.matchIterator$1$1.hasNext__Z()
});
$c_s_util_matching_Regex$$anon$1.prototype.mkString__T = (function() {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", "", "")
});
$c_s_util_matching_Regex$$anon$1.prototype.toStream__sci_Stream = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_s_util_matching_Regex$$anon$1.prototype.toTraversable__sc_Traversable = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_s_util_matching_Regex$$anon$1.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_s_util_matching_Regex$$anon$1.prototype.toSeq__sc_Seq = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_s_util_matching_Regex$$anon$1.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_s_util_matching_Regex$$anon$1.prototype.$$div$colon__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_s_util_matching_Regex$$anon$1.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_sc_Iterator__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_s_util_matching_Regex$$anon$1.prototype.isTraversableAgain__Z = (function() {
  return false
});
$c_s_util_matching_Regex$$anon$1.prototype.drop__I__sc_Iterator = (function(n) {
  return $f_sc_Iterator__drop__I__sc_Iterator(this, n)
});
$c_s_util_matching_Regex$$anon$1.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  while (this.hasNext__Z()) {
    var arg1 = this.next__s_util_matching_Regex$Match();
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1))
  };
  return $as_sci_Map(b.elems$1)
});
$c_s_util_matching_Regex$$anon$1.prototype.next__s_util_matching_Regex$Match = (function() {
  this.matchIterator$1$1.next__T();
  return new $c_s_util_matching_Regex$Match().init___jl_CharSequence__ju_regex_Matcher__sc_Seq(this.matchIterator$1$1.source$2, this.matchIterator$1$1.matcher$2, this.matchIterator$1$1.groupNames$2).force__s_util_matching_Regex$Match()
});
$c_s_util_matching_Regex$$anon$1.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_sc_TraversableOnce__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_s_util_matching_Regex$$anon$1.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_s_util_matching_Regex$$anon$1.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_TraversableOnce__reduceLeft__F2__O(this, op)
});
var $d_s_util_matching_Regex$$anon$1 = new $TypeData().initClass({
  s_util_matching_Regex$$anon$1: 0
}, false, "scala.util.matching.Regex$$anon$1", {
  s_util_matching_Regex$$anon$1: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_s_util_matching_Regex$$anon$1.prototype.$classData = $d_s_util_matching_Regex$$anon$1;
/** @constructor */
function $c_sc_AbstractIterator() {
  $c_O.call(this)
}
$c_sc_AbstractIterator.prototype = new $h_O();
$c_sc_AbstractIterator.prototype.constructor = $c_sc_AbstractIterator;
/** @constructor */
function $h_sc_AbstractIterator() {
  /*<skip>*/
}
$h_sc_AbstractIterator.prototype = $c_sc_AbstractIterator.prototype;
$c_sc_AbstractIterator.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sc_AbstractIterator.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_sc_AbstractIterator.prototype.toIterator__sc_Iterator = (function() {
  return this
});
$c_sc_AbstractIterator.prototype.toList__sci_List = (function() {
  var this$1 = $m_sci_List$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_sci_List($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sc_AbstractIterator.prototype.isEmpty__Z = (function() {
  return $f_sc_Iterator__isEmpty__Z(this)
});
$c_sc_AbstractIterator.prototype.take__I__sc_Iterator = (function(n) {
  return $f_sc_Iterator__take__I__sc_Iterator(this, n)
});
$c_sc_AbstractIterator.prototype.mkString__T__T = (function(sep) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", sep, "")
});
$c_sc_AbstractIterator.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_sc_AbstractIterator.prototype.toString__T = (function() {
  return "<iterator>"
});
$c_sc_AbstractIterator.prototype.sliceIterator__I__I__sc_Iterator = (function(from, until) {
  return $f_sc_Iterator__sliceIterator__I__I__sc_Iterator(this, from, until)
});
$c_sc_AbstractIterator.prototype.foreach__F1__V = (function(f) {
  $f_sc_Iterator__foreach__F1__V(this, f)
});
$c_sc_AbstractIterator.prototype.foldLeft__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_sc_AbstractIterator.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sc_AbstractIterator.prototype.$$plus$plus__F0__sc_Iterator = (function(that) {
  return $f_sc_Iterator__$$plus$plus__F0__sc_Iterator(this, that)
});
$c_sc_AbstractIterator.prototype.toBuffer__scm_Buffer = (function() {
  var this$1 = $m_scm_ArrayBuffer$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_scm_Buffer($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sc_AbstractIterator.prototype.size__I = (function() {
  return $f_sc_TraversableOnce__size__I(this)
});
$c_sc_AbstractIterator.prototype.mkString__T = (function() {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", "", "")
});
$c_sc_AbstractIterator.prototype.toStream__sci_Stream = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_sc_AbstractIterator.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_sc_AbstractIterator.prototype.toTraversable__sc_Traversable = (function() {
  return this.toStream__sci_Stream()
});
$c_sc_AbstractIterator.prototype.toSeq__sc_Seq = (function() {
  return this.toStream__sci_Stream()
});
$c_sc_AbstractIterator.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sc_AbstractIterator.prototype.$$div$colon__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_sc_AbstractIterator.prototype.isTraversableAgain__Z = (function() {
  return false
});
$c_sc_AbstractIterator.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_sc_Iterator__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_sc_AbstractIterator.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  while (this.hasNext__Z()) {
    var arg1 = this.next__O();
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1))
  };
  return $as_sci_Map(b.elems$1)
});
$c_sc_AbstractIterator.prototype.drop__I__sc_Iterator = (function(n) {
  return $f_sc_Iterator__drop__I__sc_Iterator(this, n)
});
$c_sc_AbstractIterator.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_sc_TraversableOnce__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_sc_AbstractIterator.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_sc_AbstractIterator.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_TraversableOnce__reduceLeft__F2__O(this, op)
});
/** @constructor */
function $c_sc_Iterator$ConcatIterator() {
  $c_O.call(this);
  this.current$1 = null;
  this.tail$1 = null;
  this.last$1 = null;
  this.currentHasNextChecked$1 = false
}
$c_sc_Iterator$ConcatIterator.prototype = new $h_O();
$c_sc_Iterator$ConcatIterator.prototype.constructor = $c_sc_Iterator$ConcatIterator;
/** @constructor */
function $h_sc_Iterator$ConcatIterator() {
  /*<skip>*/
}
$h_sc_Iterator$ConcatIterator.prototype = $c_sc_Iterator$ConcatIterator.prototype;
$c_sc_Iterator$ConcatIterator.prototype.advance__p1__Z = (function() {
  _advance: while (true) {
    if ((this.tail$1 === null)) {
      this.current$1 = null;
      this.last$1 = null;
      return false
    } else {
      this.current$1 = this.tail$1.headIterator__sc_Iterator();
      this.tail$1 = this.tail$1.tail$1;
      this.merge__p1__V();
      if (this.currentHasNextChecked$1) {
        return true
      } else if (((this.current$1 !== null) && this.current$1.hasNext__Z())) {
        this.currentHasNextChecked$1 = true;
        return true
      } else {
        continue _advance
      }
    }
  }
});
$c_sc_Iterator$ConcatIterator.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sc_Iterator$ConcatIterator.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_sc_Iterator$ConcatIterator.prototype.next__O = (function() {
  if (this.hasNext__Z()) {
    this.currentHasNextChecked$1 = false;
    return this.current$1.next__O()
  } else {
    return $m_sc_Iterator$().empty$1.next__O()
  }
});
$c_sc_Iterator$ConcatIterator.prototype.toIterator__sc_Iterator = (function() {
  return this
});
$c_sc_Iterator$ConcatIterator.prototype.isEmpty__Z = (function() {
  return $f_sc_Iterator__isEmpty__Z(this)
});
$c_sc_Iterator$ConcatIterator.prototype.toList__sci_List = (function() {
  var this$1 = $m_sci_List$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_sci_List($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sc_Iterator$ConcatIterator.prototype.take__I__sc_Iterator = (function(n) {
  return $f_sc_Iterator__take__I__sc_Iterator(this, n)
});
$c_sc_Iterator$ConcatIterator.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_sc_Iterator$ConcatIterator.prototype.mkString__T__T = (function(sep) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", sep, "")
});
$c_sc_Iterator$ConcatIterator.prototype.toString__T = (function() {
  return "<iterator>"
});
$c_sc_Iterator$ConcatIterator.prototype.sliceIterator__I__I__sc_Iterator = (function(from, until) {
  return $f_sc_Iterator__sliceIterator__I__I__sc_Iterator(this, from, until)
});
$c_sc_Iterator$ConcatIterator.prototype.foreach__F1__V = (function(f) {
  $f_sc_Iterator__foreach__F1__V(this, f)
});
$c_sc_Iterator$ConcatIterator.prototype.foldLeft__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_sc_Iterator$ConcatIterator.prototype.$$plus$plus__F0__sc_Iterator = (function(that) {
  var c = new $c_sc_Iterator$ConcatIteratorCell().init___F0__sc_Iterator$ConcatIteratorCell(that, null);
  if ((this.tail$1 === null)) {
    this.tail$1 = c;
    this.last$1 = c
  } else {
    this.last$1.tail$1 = c;
    this.last$1 = c
  };
  if ((this.current$1 === null)) {
    this.current$1 = $m_sc_Iterator$().empty$1
  };
  return this
});
$c_sc_Iterator$ConcatIterator.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sc_Iterator$ConcatIterator.prototype.size__I = (function() {
  return $f_sc_TraversableOnce__size__I(this)
});
$c_sc_Iterator$ConcatIterator.prototype.toBuffer__scm_Buffer = (function() {
  var this$1 = $m_scm_ArrayBuffer$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_scm_Buffer($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sc_Iterator$ConcatIterator.prototype.hasNext__Z = (function() {
  if (this.currentHasNextChecked$1) {
    return true
  } else if ((this.current$1 !== null)) {
    if (this.current$1.hasNext__Z()) {
      this.currentHasNextChecked$1 = true;
      return true
    } else {
      return this.advance__p1__Z()
    }
  } else {
    return false
  }
});
$c_sc_Iterator$ConcatIterator.prototype.mkString__T = (function() {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", "", "")
});
$c_sc_Iterator$ConcatIterator.prototype.toStream__sci_Stream = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_sc_Iterator$ConcatIterator.prototype.toTraversable__sc_Traversable = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_sc_Iterator$ConcatIterator.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_sc_Iterator$ConcatIterator.prototype.toSeq__sc_Seq = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_sc_Iterator$ConcatIterator.prototype.init___sc_Iterator = (function(current) {
  this.current$1 = current;
  this.tail$1 = null;
  this.last$1 = null;
  this.currentHasNextChecked$1 = false;
  return this
});
$c_sc_Iterator$ConcatIterator.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sc_Iterator$ConcatIterator.prototype.$$div$colon__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_sc_Iterator$ConcatIterator.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_sc_Iterator__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_sc_Iterator$ConcatIterator.prototype.isTraversableAgain__Z = (function() {
  return false
});
$c_sc_Iterator$ConcatIterator.prototype.drop__I__sc_Iterator = (function(n) {
  return $f_sc_Iterator__drop__I__sc_Iterator(this, n)
});
$c_sc_Iterator$ConcatIterator.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  while (this.hasNext__Z()) {
    var arg1 = this.next__O();
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1))
  };
  return $as_sci_Map(b.elems$1)
});
$c_sc_Iterator$ConcatIterator.prototype.merge__p1__V = (function() {
  _merge: while (true) {
    if ((this.current$1 instanceof $c_sc_Iterator$ConcatIterator)) {
      var c = $as_sc_Iterator$ConcatIterator(this.current$1);
      this.current$1 = c.current$1;
      this.currentHasNextChecked$1 = c.currentHasNextChecked$1;
      if ((c.tail$1 !== null)) {
        c.last$1.tail$1 = this.tail$1;
        this.tail$1 = c.tail$1
      };
      continue _merge
    };
    break
  }
});
$c_sc_Iterator$ConcatIterator.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_sc_TraversableOnce__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_sc_Iterator$ConcatIterator.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_sc_Iterator$ConcatIterator.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_TraversableOnce__reduceLeft__F2__O(this, op)
});
function $as_sc_Iterator$ConcatIterator(obj) {
  return (((obj instanceof $c_sc_Iterator$ConcatIterator) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.Iterator$ConcatIterator"))
}
function $isArrayOf_sc_Iterator$ConcatIterator(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_Iterator$ConcatIterator)))
}
function $asArrayOf_sc_Iterator$ConcatIterator(obj, depth) {
  return (($isArrayOf_sc_Iterator$ConcatIterator(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.Iterator$ConcatIterator;", depth))
}
var $d_sc_Iterator$ConcatIterator = new $TypeData().initClass({
  sc_Iterator$ConcatIterator: 0
}, false, "scala.collection.Iterator$ConcatIterator", {
  sc_Iterator$ConcatIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sc_Iterator$ConcatIterator.prototype.$classData = $d_sc_Iterator$ConcatIterator;
/** @constructor */
function $c_sc_TraversableView$NoBuilder() {
  $c_O.call(this)
}
$c_sc_TraversableView$NoBuilder.prototype = new $h_O();
$c_sc_TraversableView$NoBuilder.prototype.constructor = $c_sc_TraversableView$NoBuilder;
/** @constructor */
function $h_sc_TraversableView$NoBuilder() {
  /*<skip>*/
}
$h_sc_TraversableView$NoBuilder.prototype = $c_sc_TraversableView$NoBuilder.prototype;
$c_sc_TraversableView$NoBuilder.prototype.init___ = (function() {
  return this
});
$c_sc_TraversableView$NoBuilder.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this
});
$c_sc_TraversableView$NoBuilder.prototype.result__O = (function() {
  this.result__sr_Nothing$()
});
$c_sc_TraversableView$NoBuilder.prototype.sizeHintBounded__I__sc_TraversableLike__V = (function(size, boundingColl) {
  $f_scm_Builder__sizeHintBounded__I__sc_TraversableLike__V(this, size, boundingColl)
});
$c_sc_TraversableView$NoBuilder.prototype.result__sr_Nothing$ = (function() {
  throw new $c_jl_UnsupportedOperationException().init___T("TraversableView.Builder.result")
});
$c_sc_TraversableView$NoBuilder.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this
});
$c_sc_TraversableView$NoBuilder.prototype.sizeHint__I__V = (function(size) {
  /*<skip>*/
});
$c_sc_TraversableView$NoBuilder.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs)
});
var $d_sc_TraversableView$NoBuilder = new $TypeData().initClass({
  sc_TraversableView$NoBuilder: 0
}, false, "scala.collection.TraversableView$NoBuilder", {
  sc_TraversableView$NoBuilder: 1,
  O: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1
});
$c_sc_TraversableView$NoBuilder.prototype.$classData = $d_sc_TraversableView$NoBuilder;
/** @constructor */
function $c_scg_SetFactory() {
  $c_scg_GenSetFactory.call(this)
}
$c_scg_SetFactory.prototype = new $h_scg_GenSetFactory();
$c_scg_SetFactory.prototype.constructor = $c_scg_SetFactory;
/** @constructor */
function $h_scg_SetFactory() {
  /*<skip>*/
}
$h_scg_SetFactory.prototype = $c_scg_SetFactory.prototype;
/** @constructor */
function $c_sci_Map$() {
  $c_scg_ImmutableMapFactory.call(this)
}
$c_sci_Map$.prototype = new $h_scg_ImmutableMapFactory();
$c_sci_Map$.prototype.constructor = $c_sci_Map$;
/** @constructor */
function $h_sci_Map$() {
  /*<skip>*/
}
$h_sci_Map$.prototype = $c_sci_Map$.prototype;
$c_sci_Map$.prototype.init___ = (function() {
  return this
});
$c_sci_Map$.prototype.empty__sc_GenMap = (function() {
  return $m_sci_Map$EmptyMap$()
});
var $d_sci_Map$ = new $TypeData().initClass({
  sci_Map$: 0
}, false, "scala.collection.immutable.Map$", {
  sci_Map$: 1,
  scg_ImmutableMapFactory: 1,
  scg_MapFactory: 1,
  scg_GenMapFactory: 1,
  O: 1
});
$c_sci_Map$.prototype.$classData = $d_sci_Map$;
var $n_sci_Map$ = (void 0);
function $m_sci_Map$() {
  if ((!$n_sci_Map$)) {
    $n_sci_Map$ = new $c_sci_Map$().init___()
  };
  return $n_sci_Map$
}
/** @constructor */
function $c_sci_RedBlackTree$BlackTree() {
  $c_sci_RedBlackTree$Tree.call(this)
}
$c_sci_RedBlackTree$BlackTree.prototype = new $h_sci_RedBlackTree$Tree();
$c_sci_RedBlackTree$BlackTree.prototype.constructor = $c_sci_RedBlackTree$BlackTree;
/** @constructor */
function $h_sci_RedBlackTree$BlackTree() {
  /*<skip>*/
}
$h_sci_RedBlackTree$BlackTree.prototype = $c_sci_RedBlackTree$BlackTree.prototype;
$c_sci_RedBlackTree$BlackTree.prototype.init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree = (function(key, value, left, right) {
  $c_sci_RedBlackTree$Tree.prototype.init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree.call(this, key, value, left, right);
  return this
});
$c_sci_RedBlackTree$BlackTree.prototype.black__sci_RedBlackTree$Tree = (function() {
  return this
});
$c_sci_RedBlackTree$BlackTree.prototype.toString__T = (function() {
  return (((((((("BlackTree(" + this.key$1) + ", ") + this.value$1) + ", ") + this.left$1) + ", ") + this.right$1) + ")")
});
$c_sci_RedBlackTree$BlackTree.prototype.red__sci_RedBlackTree$Tree = (function() {
  var key = this.key$1;
  var value = this.value$1;
  var left = this.left$1;
  var right = this.right$1;
  return new $c_sci_RedBlackTree$RedTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key, value, left, right)
});
function $as_sci_RedBlackTree$BlackTree(obj) {
  return (((obj instanceof $c_sci_RedBlackTree$BlackTree) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.RedBlackTree$BlackTree"))
}
function $isArrayOf_sci_RedBlackTree$BlackTree(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_RedBlackTree$BlackTree)))
}
function $asArrayOf_sci_RedBlackTree$BlackTree(obj, depth) {
  return (($isArrayOf_sci_RedBlackTree$BlackTree(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.RedBlackTree$BlackTree;", depth))
}
var $d_sci_RedBlackTree$BlackTree = new $TypeData().initClass({
  sci_RedBlackTree$BlackTree: 0
}, false, "scala.collection.immutable.RedBlackTree$BlackTree", {
  sci_RedBlackTree$BlackTree: 1,
  sci_RedBlackTree$Tree: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_RedBlackTree$BlackTree.prototype.$classData = $d_sci_RedBlackTree$BlackTree;
/** @constructor */
function $c_sci_RedBlackTree$RedTree() {
  $c_sci_RedBlackTree$Tree.call(this)
}
$c_sci_RedBlackTree$RedTree.prototype = new $h_sci_RedBlackTree$Tree();
$c_sci_RedBlackTree$RedTree.prototype.constructor = $c_sci_RedBlackTree$RedTree;
/** @constructor */
function $h_sci_RedBlackTree$RedTree() {
  /*<skip>*/
}
$h_sci_RedBlackTree$RedTree.prototype = $c_sci_RedBlackTree$RedTree.prototype;
$c_sci_RedBlackTree$RedTree.prototype.init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree = (function(key, value, left, right) {
  $c_sci_RedBlackTree$Tree.prototype.init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree.call(this, key, value, left, right);
  return this
});
$c_sci_RedBlackTree$RedTree.prototype.black__sci_RedBlackTree$Tree = (function() {
  var key = this.key$1;
  var value = this.value$1;
  var left = this.left$1;
  var right = this.right$1;
  return new $c_sci_RedBlackTree$BlackTree().init___O__O__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(key, value, left, right)
});
$c_sci_RedBlackTree$RedTree.prototype.toString__T = (function() {
  return (((((((("RedTree(" + this.key$1) + ", ") + this.value$1) + ", ") + this.left$1) + ", ") + this.right$1) + ")")
});
$c_sci_RedBlackTree$RedTree.prototype.red__sci_RedBlackTree$Tree = (function() {
  return this
});
function $as_sci_RedBlackTree$RedTree(obj) {
  return (((obj instanceof $c_sci_RedBlackTree$RedTree) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.RedBlackTree$RedTree"))
}
function $isArrayOf_sci_RedBlackTree$RedTree(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_RedBlackTree$RedTree)))
}
function $asArrayOf_sci_RedBlackTree$RedTree(obj, depth) {
  return (($isArrayOf_sci_RedBlackTree$RedTree(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.RedBlackTree$RedTree;", depth))
}
var $d_sci_RedBlackTree$RedTree = new $TypeData().initClass({
  sci_RedBlackTree$RedTree: 0
}, false, "scala.collection.immutable.RedBlackTree$RedTree", {
  sci_RedBlackTree$RedTree: 1,
  sci_RedBlackTree$Tree: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_RedBlackTree$RedTree.prototype.$classData = $d_sci_RedBlackTree$RedTree;
/** @constructor */
function $c_sci_RedBlackTree$TreeIterator() {
  $c_O.call(this);
  this.root$1 = null;
  this.ordering$1 = null;
  this.stackOfNexts$1 = null;
  this.index$1 = 0;
  this.lookahead$1 = null
}
$c_sci_RedBlackTree$TreeIterator.prototype = new $h_O();
$c_sci_RedBlackTree$TreeIterator.prototype.constructor = $c_sci_RedBlackTree$TreeIterator;
/** @constructor */
function $h_sci_RedBlackTree$TreeIterator() {
  /*<skip>*/
}
$h_sci_RedBlackTree$TreeIterator.prototype = $c_sci_RedBlackTree$TreeIterator.prototype;
$c_sci_RedBlackTree$TreeIterator.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sci_RedBlackTree$TreeIterator.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_sci_RedBlackTree$TreeIterator.prototype.next__O = (function() {
  var x1 = this.lookahead$1;
  if ((x1 === null)) {
    throw new $c_ju_NoSuchElementException().init___T("next on empty iterator")
  } else {
    this.lookahead$1 = this.findLeftMostOrPopOnEmpty__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(x1.right$1);
    return x1.key$1
  }
});
$c_sci_RedBlackTree$TreeIterator.prototype.findLeftMostOrPopOnEmpty__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree = (function(tree) {
  _findLeftMostOrPopOnEmpty: while (true) {
    if ((tree === null)) {
      return this.popNext__p1__sci_RedBlackTree$Tree()
    } else if ((tree.left$1 === null)) {
      return tree
    } else {
      tree = this.goLeft__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(tree);
      continue _findLeftMostOrPopOnEmpty
    }
  }
});
$c_sci_RedBlackTree$TreeIterator.prototype.toIterator__sc_Iterator = (function() {
  return this
});
$c_sci_RedBlackTree$TreeIterator.prototype.isEmpty__Z = (function() {
  return $f_sc_Iterator__isEmpty__Z(this)
});
$c_sci_RedBlackTree$TreeIterator.prototype.toList__sci_List = (function() {
  var this$1 = $m_sci_List$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_sci_List($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sci_RedBlackTree$TreeIterator.prototype.take__I__sc_Iterator = (function(n) {
  return $f_sc_Iterator__take__I__sc_Iterator(this, n)
});
$c_sci_RedBlackTree$TreeIterator.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_sci_RedBlackTree$TreeIterator.prototype.mkString__T__T = (function(sep) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", sep, "")
});
$c_sci_RedBlackTree$TreeIterator.prototype.init___sci_RedBlackTree$Tree__s_Option__s_math_Ordering = (function(root, start, ordering) {
  this.root$1 = root;
  this.ordering$1 = ordering;
  if ((root === null)) {
    var jsx$1 = null
  } else {
    var maximumHeight = (((-2) + (((32 - $clz32(((1 + root.count$1) | 0))) | 0) << 1)) | 0);
    var jsx$1 = $newArrayObject($d_sci_RedBlackTree$Tree.getArrayOf(), [maximumHeight])
  };
  this.stackOfNexts$1 = jsx$1;
  this.index$1 = 0;
  if (start.isEmpty__Z()) {
    var this$1 = $m_s_None$()
  } else {
    var arg1 = start.get__O();
    var this$1 = new $c_s_Some().init___O(this.startFrom__p1__O__sci_RedBlackTree$Tree(arg1))
  };
  this.lookahead$1 = $as_sci_RedBlackTree$Tree((this$1.isEmpty__Z() ? this.findLeftMostOrPopOnEmpty__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(this.root$1) : this$1.get__O()));
  return this
});
$c_sci_RedBlackTree$TreeIterator.prototype.toString__T = (function() {
  return "<iterator>"
});
$c_sci_RedBlackTree$TreeIterator.prototype.sliceIterator__I__I__sc_Iterator = (function(from, until) {
  return $f_sc_Iterator__sliceIterator__I__I__sc_Iterator(this, from, until)
});
$c_sci_RedBlackTree$TreeIterator.prototype.foreach__F1__V = (function(f) {
  $f_sc_Iterator__foreach__F1__V(this, f)
});
$c_sci_RedBlackTree$TreeIterator.prototype.foldLeft__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_sci_RedBlackTree$TreeIterator.prototype.startFrom__p1__O__sci_RedBlackTree$Tree = (function(key) {
  return ((this.root$1 === null) ? null : this.find$1__p1__sci_RedBlackTree$Tree__O__sci_RedBlackTree$Tree(this.root$1, key))
});
$c_sci_RedBlackTree$TreeIterator.prototype.$$plus$plus__F0__sc_Iterator = (function(that) {
  return $f_sc_Iterator__$$plus$plus__F0__sc_Iterator(this, that)
});
$c_sci_RedBlackTree$TreeIterator.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sci_RedBlackTree$TreeIterator.prototype.popNext__p1__sci_RedBlackTree$Tree = (function() {
  if ((this.index$1 === 0)) {
    return null
  } else {
    this.index$1 = (((-1) + this.index$1) | 0);
    return this.stackOfNexts$1.get(this.index$1)
  }
});
$c_sci_RedBlackTree$TreeIterator.prototype.size__I = (function() {
  return $f_sc_TraversableOnce__size__I(this)
});
$c_sci_RedBlackTree$TreeIterator.prototype.toBuffer__scm_Buffer = (function() {
  var this$1 = $m_scm_ArrayBuffer$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_scm_Buffer($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sci_RedBlackTree$TreeIterator.prototype.hasNext__Z = (function() {
  return (this.lookahead$1 !== null)
});
$c_sci_RedBlackTree$TreeIterator.prototype.mkString__T = (function() {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", "", "")
});
$c_sci_RedBlackTree$TreeIterator.prototype.toStream__sci_Stream = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_sci_RedBlackTree$TreeIterator.prototype.toTraversable__sc_Traversable = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_sci_RedBlackTree$TreeIterator.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_sci_RedBlackTree$TreeIterator.prototype.toSeq__sc_Seq = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_sci_RedBlackTree$TreeIterator.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sci_RedBlackTree$TreeIterator.prototype.$$div$colon__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_sci_RedBlackTree$TreeIterator.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_sc_Iterator__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_sci_RedBlackTree$TreeIterator.prototype.isTraversableAgain__Z = (function() {
  return false
});
$c_sci_RedBlackTree$TreeIterator.prototype.goLeft__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree = (function(tree) {
  this.pushNext__p1__sci_RedBlackTree$Tree__V(tree);
  return tree.left$1
});
$c_sci_RedBlackTree$TreeIterator.prototype.drop__I__sc_Iterator = (function(n) {
  return $f_sc_Iterator__drop__I__sc_Iterator(this, n)
});
$c_sci_RedBlackTree$TreeIterator.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  while (this.hasNext__Z()) {
    var arg1 = this.next__O();
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1))
  };
  return $as_sci_Map(b.elems$1)
});
$c_sci_RedBlackTree$TreeIterator.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_sc_TraversableOnce__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_sci_RedBlackTree$TreeIterator.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_sci_RedBlackTree$TreeIterator.prototype.find$1__p1__sci_RedBlackTree$Tree__O__sci_RedBlackTree$Tree = (function(tree, key$1) {
  _find: while (true) {
    if ((tree === null)) {
      return this.popNext__p1__sci_RedBlackTree$Tree()
    } else {
      if (this.ordering$1.lteq__O__O__Z(key$1, tree.key$1)) {
        tree = this.goLeft__p1__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(tree)
      } else {
        var tree$1 = tree;
        tree = tree$1.right$1
      };
      continue _find
    }
  }
});
$c_sci_RedBlackTree$TreeIterator.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_TraversableOnce__reduceLeft__F2__O(this, op)
});
$c_sci_RedBlackTree$TreeIterator.prototype.pushNext__p1__sci_RedBlackTree$Tree__V = (function(tree) {
  _pushNext: while (true) {
    try {
      this.stackOfNexts$1.set(this.index$1, tree);
      this.index$1 = ((1 + this.index$1) | 0)
    } catch (e) {
      if ((e instanceof $c_jl_ArrayIndexOutOfBoundsException)) {
        $m_s_Predef$().assert__Z__V((this.index$1 >= this.stackOfNexts$1.u.length));
        var xs = this.stackOfNexts$1;
        var currentLength = xs.u.length;
        var len = ((1 + currentLength) | 0);
        var result = $newArrayObject($d_sci_RedBlackTree$Tree.getArrayOf(), [len]);
        $m_s_Array$().copy__O__I__O__I__I__V(xs, 0, result, 0, currentLength);
        result.set(currentLength, null);
        this.stackOfNexts$1 = result;
        continue _pushNext
      } else {
        throw e
      }
    };
    break
  }
});
/** @constructor */
function $c_scm_DefaultEntry() {
  $c_O.call(this);
  this.key$1 = null;
  this.value$1 = null;
  this.next$1 = null
}
$c_scm_DefaultEntry.prototype = new $h_O();
$c_scm_DefaultEntry.prototype.constructor = $c_scm_DefaultEntry;
/** @constructor */
function $h_scm_DefaultEntry() {
  /*<skip>*/
}
$h_scm_DefaultEntry.prototype = $c_scm_DefaultEntry.prototype;
$c_scm_DefaultEntry.prototype.next__O = (function() {
  return this.next$1
});
$c_scm_DefaultEntry.prototype.chainString__T = (function() {
  var jsx$3 = this.key$1;
  var jsx$2 = this.value$1;
  if ((this.next$1 !== null)) {
    var this$1 = this.next$1;
    var jsx$1 = (" -> " + this$1.chainString__T())
  } else {
    var jsx$1 = ""
  };
  return ((((("(kv: " + jsx$3) + ", ") + jsx$2) + ")") + jsx$1)
});
$c_scm_DefaultEntry.prototype.init___O__O = (function(key, value) {
  this.key$1 = key;
  this.value$1 = value;
  return this
});
$c_scm_DefaultEntry.prototype.toString__T = (function() {
  return this.chainString__T()
});
$c_scm_DefaultEntry.prototype.key__O = (function() {
  return this.key$1
});
$c_scm_DefaultEntry.prototype.next$und$eq__O__V = (function(x$1) {
  this.next$1 = $as_scm_DefaultEntry(x$1)
});
function $as_scm_DefaultEntry(obj) {
  return (((obj instanceof $c_scm_DefaultEntry) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.DefaultEntry"))
}
function $isArrayOf_scm_DefaultEntry(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_DefaultEntry)))
}
function $asArrayOf_scm_DefaultEntry(obj, depth) {
  return (($isArrayOf_scm_DefaultEntry(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.DefaultEntry;", depth))
}
var $d_scm_DefaultEntry = new $TypeData().initClass({
  scm_DefaultEntry: 0
}, false, "scala.collection.mutable.DefaultEntry", {
  scm_DefaultEntry: 1,
  O: 1,
  scm_HashEntry: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_DefaultEntry.prototype.$classData = $d_scm_DefaultEntry;
/** @constructor */
function $c_scm_GrowingBuilder() {
  $c_O.call(this);
  this.empty$1 = null;
  this.elems$1 = null
}
$c_scm_GrowingBuilder.prototype = new $h_O();
$c_scm_GrowingBuilder.prototype.constructor = $c_scm_GrowingBuilder;
/** @constructor */
function $h_scm_GrowingBuilder() {
  /*<skip>*/
}
$h_scm_GrowingBuilder.prototype = $c_scm_GrowingBuilder.prototype;
$c_scm_GrowingBuilder.prototype.$$plus$eq__O__scm_GrowingBuilder = (function(x) {
  this.elems$1.$$plus$eq__O__scg_Growable(x);
  return this
});
$c_scm_GrowingBuilder.prototype.init___scg_Growable = (function(empty) {
  this.empty$1 = empty;
  this.elems$1 = empty;
  return this
});
$c_scm_GrowingBuilder.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__O__scm_GrowingBuilder(elem)
});
$c_scm_GrowingBuilder.prototype.result__O = (function() {
  return this.elems$1
});
$c_scm_GrowingBuilder.prototype.sizeHintBounded__I__sc_TraversableLike__V = (function(size, boundingColl) {
  $f_scm_Builder__sizeHintBounded__I__sc_TraversableLike__V(this, size, boundingColl)
});
$c_scm_GrowingBuilder.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__O__scm_GrowingBuilder(elem)
});
$c_scm_GrowingBuilder.prototype.sizeHint__I__V = (function(size) {
  /*<skip>*/
});
$c_scm_GrowingBuilder.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs)
});
var $d_scm_GrowingBuilder = new $TypeData().initClass({
  scm_GrowingBuilder: 0
}, false, "scala.collection.mutable.GrowingBuilder", {
  scm_GrowingBuilder: 1,
  O: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1
});
$c_scm_GrowingBuilder.prototype.$classData = $d_scm_GrowingBuilder;
/** @constructor */
function $c_scm_LinkedEntry() {
  $c_O.call(this);
  this.key$1 = null;
  this.value$1 = null;
  this.earlier$1 = null;
  this.later$1 = null;
  this.next$1 = null
}
$c_scm_LinkedEntry.prototype = new $h_O();
$c_scm_LinkedEntry.prototype.constructor = $c_scm_LinkedEntry;
/** @constructor */
function $h_scm_LinkedEntry() {
  /*<skip>*/
}
$h_scm_LinkedEntry.prototype = $c_scm_LinkedEntry.prototype;
$c_scm_LinkedEntry.prototype.next__O = (function() {
  return this.next$1
});
$c_scm_LinkedEntry.prototype.init___O__O = (function(key, value) {
  this.key$1 = key;
  this.value$1 = value;
  this.earlier$1 = null;
  this.later$1 = null;
  return this
});
$c_scm_LinkedEntry.prototype.key__O = (function() {
  return this.key$1
});
$c_scm_LinkedEntry.prototype.next$und$eq__O__V = (function(x$1) {
  this.next$1 = $as_scm_LinkedEntry(x$1)
});
function $as_scm_LinkedEntry(obj) {
  return (((obj instanceof $c_scm_LinkedEntry) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.LinkedEntry"))
}
function $isArrayOf_scm_LinkedEntry(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_LinkedEntry)))
}
function $asArrayOf_scm_LinkedEntry(obj, depth) {
  return (($isArrayOf_scm_LinkedEntry(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.LinkedEntry;", depth))
}
var $d_scm_LinkedEntry = new $TypeData().initClass({
  scm_LinkedEntry: 0
}, false, "scala.collection.mutable.LinkedEntry", {
  scm_LinkedEntry: 1,
  O: 1,
  scm_HashEntry: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_LinkedEntry.prototype.$classData = $d_scm_LinkedEntry;
/** @constructor */
function $c_scm_LinkedHashSet$Entry() {
  $c_O.call(this);
  this.key$1 = null;
  this.earlier$1 = null;
  this.later$1 = null;
  this.next$1 = null
}
$c_scm_LinkedHashSet$Entry.prototype = new $h_O();
$c_scm_LinkedHashSet$Entry.prototype.constructor = $c_scm_LinkedHashSet$Entry;
/** @constructor */
function $h_scm_LinkedHashSet$Entry() {
  /*<skip>*/
}
$h_scm_LinkedHashSet$Entry.prototype = $c_scm_LinkedHashSet$Entry.prototype;
$c_scm_LinkedHashSet$Entry.prototype.next__O = (function() {
  return this.next$1
});
$c_scm_LinkedHashSet$Entry.prototype.init___O = (function(key) {
  this.key$1 = key;
  this.earlier$1 = null;
  this.later$1 = null;
  return this
});
$c_scm_LinkedHashSet$Entry.prototype.key__O = (function() {
  return this.key$1
});
$c_scm_LinkedHashSet$Entry.prototype.next$und$eq__O__V = (function(x$1) {
  this.next$1 = $as_scm_LinkedHashSet$Entry(x$1)
});
function $as_scm_LinkedHashSet$Entry(obj) {
  return (((obj instanceof $c_scm_LinkedHashSet$Entry) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.LinkedHashSet$Entry"))
}
function $isArrayOf_scm_LinkedHashSet$Entry(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_LinkedHashSet$Entry)))
}
function $asArrayOf_scm_LinkedHashSet$Entry(obj, depth) {
  return (($isArrayOf_scm_LinkedHashSet$Entry(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.LinkedHashSet$Entry;", depth))
}
var $d_scm_LinkedHashSet$Entry = new $TypeData().initClass({
  scm_LinkedHashSet$Entry: 0
}, false, "scala.collection.mutable.LinkedHashSet$Entry", {
  scm_LinkedHashSet$Entry: 1,
  O: 1,
  scm_HashEntry: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_LinkedHashSet$Entry.prototype.$classData = $d_scm_LinkedHashSet$Entry;
/** @constructor */
function $c_scm_Map$() {
  $c_scg_MutableMapFactory.call(this)
}
$c_scm_Map$.prototype = new $h_scg_MutableMapFactory();
$c_scm_Map$.prototype.constructor = $c_scm_Map$;
/** @constructor */
function $h_scm_Map$() {
  /*<skip>*/
}
$h_scm_Map$.prototype = $c_scm_Map$.prototype;
$c_scm_Map$.prototype.init___ = (function() {
  return this
});
$c_scm_Map$.prototype.empty__sc_Map = (function() {
  return new $c_scm_HashMap().init___()
});
$c_scm_Map$.prototype.empty__sc_GenMap = (function() {
  return new $c_scm_HashMap().init___()
});
var $d_scm_Map$ = new $TypeData().initClass({
  scm_Map$: 0
}, false, "scala.collection.mutable.Map$", {
  scm_Map$: 1,
  scg_MutableMapFactory: 1,
  scg_MapFactory: 1,
  scg_GenMapFactory: 1,
  O: 1
});
$c_scm_Map$.prototype.$classData = $d_scm_Map$;
var $n_scm_Map$ = (void 0);
function $m_scm_Map$() {
  if ((!$n_scm_Map$)) {
    $n_scm_Map$ = new $c_scm_Map$().init___()
  };
  return $n_scm_Map$
}
/** @constructor */
function $c_sjs_concurrent_QueueExecutionContext$PromisesExecutionContext() {
  $c_O.call(this);
  this.resolvedUnitPromise$1 = null
}
$c_sjs_concurrent_QueueExecutionContext$PromisesExecutionContext.prototype = new $h_O();
$c_sjs_concurrent_QueueExecutionContext$PromisesExecutionContext.prototype.constructor = $c_sjs_concurrent_QueueExecutionContext$PromisesExecutionContext;
/** @constructor */
function $h_sjs_concurrent_QueueExecutionContext$PromisesExecutionContext() {
  /*<skip>*/
}
$h_sjs_concurrent_QueueExecutionContext$PromisesExecutionContext.prototype = $c_sjs_concurrent_QueueExecutionContext$PromisesExecutionContext.prototype;
$c_sjs_concurrent_QueueExecutionContext$PromisesExecutionContext.prototype.init___ = (function() {
  this.resolvedUnitPromise$1 = $g.Promise.resolve((void 0));
  return this
});
$c_sjs_concurrent_QueueExecutionContext$PromisesExecutionContext.prototype.scala$scalajs$concurrent$QueueExecutionContext$PromisesExecutionContext$$$anonfun$execute$2__sr_BoxedUnit__jl_Runnable__sjs_js_$bar = (function(x$1, runnable$2) {
  try {
    runnable$2.run__V()
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      e$2.printStackTrace__Ljava_io_PrintStream__V($m_jl_System$().err$1)
    } else {
      throw e
    }
  }
});
$c_sjs_concurrent_QueueExecutionContext$PromisesExecutionContext.prototype.reportFailure__jl_Throwable__V = (function(t) {
  t.printStackTrace__Ljava_io_PrintStream__V($m_jl_System$().err$1)
});
$c_sjs_concurrent_QueueExecutionContext$PromisesExecutionContext.prototype.execute__jl_Runnable__V = (function(runnable) {
  this.resolvedUnitPromise$1.then((function(arg$outer, runnable$2) {
    return (function(arg1$2) {
      var arg1 = $asUnit(arg1$2);
      return arg$outer.scala$scalajs$concurrent$QueueExecutionContext$PromisesExecutionContext$$$anonfun$execute$2__sr_BoxedUnit__jl_Runnable__sjs_js_$bar(arg1, runnable$2)
    })
  })(this, runnable))
});
var $d_sjs_concurrent_QueueExecutionContext$PromisesExecutionContext = new $TypeData().initClass({
  sjs_concurrent_QueueExecutionContext$PromisesExecutionContext: 0
}, false, "scala.scalajs.concurrent.QueueExecutionContext$PromisesExecutionContext", {
  sjs_concurrent_QueueExecutionContext$PromisesExecutionContext: 1,
  O: 1,
  s_concurrent_ExecutionContextExecutor: 1,
  s_concurrent_ExecutionContext: 1,
  ju_concurrent_Executor: 1
});
$c_sjs_concurrent_QueueExecutionContext$PromisesExecutionContext.prototype.$classData = $d_sjs_concurrent_QueueExecutionContext$PromisesExecutionContext;
/** @constructor */
function $c_sjs_concurrent_QueueExecutionContext$TimeoutsExecutionContext() {
  $c_O.call(this)
}
$c_sjs_concurrent_QueueExecutionContext$TimeoutsExecutionContext.prototype = new $h_O();
$c_sjs_concurrent_QueueExecutionContext$TimeoutsExecutionContext.prototype.constructor = $c_sjs_concurrent_QueueExecutionContext$TimeoutsExecutionContext;
/** @constructor */
function $h_sjs_concurrent_QueueExecutionContext$TimeoutsExecutionContext() {
  /*<skip>*/
}
$h_sjs_concurrent_QueueExecutionContext$TimeoutsExecutionContext.prototype = $c_sjs_concurrent_QueueExecutionContext$TimeoutsExecutionContext.prototype;
$c_sjs_concurrent_QueueExecutionContext$TimeoutsExecutionContext.prototype.init___ = (function() {
  return this
});
$c_sjs_concurrent_QueueExecutionContext$TimeoutsExecutionContext.prototype.reportFailure__jl_Throwable__V = (function(t) {
  t.printStackTrace__Ljava_io_PrintStream__V($m_jl_System$().err$1)
});
$c_sjs_concurrent_QueueExecutionContext$TimeoutsExecutionContext.prototype.execute__jl_Runnable__V = (function(runnable) {
  $g.setTimeout((function($this, runnable$1) {
    return (function() {
      try {
        runnable$1.run__V()
      } catch (e) {
        var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
        if ((e$2 !== null)) {
          e$2.printStackTrace__Ljava_io_PrintStream__V($m_jl_System$().err$1)
        } else {
          throw e
        }
      }
    })
  })(this, runnable), 0)
});
var $d_sjs_concurrent_QueueExecutionContext$TimeoutsExecutionContext = new $TypeData().initClass({
  sjs_concurrent_QueueExecutionContext$TimeoutsExecutionContext: 0
}, false, "scala.scalajs.concurrent.QueueExecutionContext$TimeoutsExecutionContext", {
  sjs_concurrent_QueueExecutionContext$TimeoutsExecutionContext: 1,
  O: 1,
  s_concurrent_ExecutionContextExecutor: 1,
  s_concurrent_ExecutionContext: 1,
  ju_concurrent_Executor: 1
});
$c_sjs_concurrent_QueueExecutionContext$TimeoutsExecutionContext.prototype.$classData = $d_sjs_concurrent_QueueExecutionContext$TimeoutsExecutionContext;
/** @constructor */
function $c_sjs_concurrent_RunNowExecutionContext$() {
  $c_O.call(this)
}
$c_sjs_concurrent_RunNowExecutionContext$.prototype = new $h_O();
$c_sjs_concurrent_RunNowExecutionContext$.prototype.constructor = $c_sjs_concurrent_RunNowExecutionContext$;
/** @constructor */
function $h_sjs_concurrent_RunNowExecutionContext$() {
  /*<skip>*/
}
$h_sjs_concurrent_RunNowExecutionContext$.prototype = $c_sjs_concurrent_RunNowExecutionContext$.prototype;
$c_sjs_concurrent_RunNowExecutionContext$.prototype.init___ = (function() {
  return this
});
$c_sjs_concurrent_RunNowExecutionContext$.prototype.reportFailure__jl_Throwable__V = (function(t) {
  t.printStackTrace__Ljava_io_PrintStream__V($m_jl_System$().err$1)
});
$c_sjs_concurrent_RunNowExecutionContext$.prototype.execute__jl_Runnable__V = (function(runnable) {
  try {
    runnable.run__V()
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      e$2.printStackTrace__Ljava_io_PrintStream__V($m_jl_System$().err$1)
    } else {
      throw e
    }
  }
});
var $d_sjs_concurrent_RunNowExecutionContext$ = new $TypeData().initClass({
  sjs_concurrent_RunNowExecutionContext$: 0
}, false, "scala.scalajs.concurrent.RunNowExecutionContext$", {
  sjs_concurrent_RunNowExecutionContext$: 1,
  O: 1,
  s_concurrent_ExecutionContextExecutor: 1,
  s_concurrent_ExecutionContext: 1,
  ju_concurrent_Executor: 1
});
$c_sjs_concurrent_RunNowExecutionContext$.prototype.$classData = $d_sjs_concurrent_RunNowExecutionContext$;
var $n_sjs_concurrent_RunNowExecutionContext$ = (void 0);
function $m_sjs_concurrent_RunNowExecutionContext$() {
  if ((!$n_sjs_concurrent_RunNowExecutionContext$)) {
    $n_sjs_concurrent_RunNowExecutionContext$ = new $c_sjs_concurrent_RunNowExecutionContext$().init___()
  };
  return $n_sjs_concurrent_RunNowExecutionContext$
}
/** @constructor */
function $c_sjs_js_WrappedDictionary$DictionaryIterator() {
  $c_O.call(this);
  this.dict$1 = null;
  this.keys$1 = null;
  this.index$1 = 0
}
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype = new $h_O();
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.constructor = $c_sjs_js_WrappedDictionary$DictionaryIterator;
/** @constructor */
function $h_sjs_js_WrappedDictionary$DictionaryIterator() {
  /*<skip>*/
}
$h_sjs_js_WrappedDictionary$DictionaryIterator.prototype = $c_sjs_js_WrappedDictionary$DictionaryIterator.prototype;
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.next__O = (function() {
  return this.next__T2()
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.toIterator__sc_Iterator = (function() {
  return this
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.isEmpty__Z = (function() {
  return $f_sc_Iterator__isEmpty__Z(this)
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.toList__sci_List = (function() {
  var this$1 = $m_sci_List$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_sci_List($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.take__I__sc_Iterator = (function(n) {
  return $f_sc_Iterator__take__I__sc_Iterator(this, n)
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.init___sjs_js_Dictionary = (function(dict) {
  this.dict$1 = dict;
  this.keys$1 = $g.Object.keys(dict);
  this.index$1 = 0;
  return this
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.mkString__T__T = (function(sep) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", sep, "")
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.toString__T = (function() {
  return "<iterator>"
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.sliceIterator__I__I__sc_Iterator = (function(from, until) {
  return $f_sc_Iterator__sliceIterator__I__I__sc_Iterator(this, from, until)
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.foreach__F1__V = (function(f) {
  $f_sc_Iterator__foreach__F1__V(this, f)
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.foldLeft__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.$$plus$plus__F0__sc_Iterator = (function(that) {
  return $f_sc_Iterator__$$plus$plus__F0__sc_Iterator(this, that)
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.size__I = (function() {
  return $f_sc_TraversableOnce__size__I(this)
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.toBuffer__scm_Buffer = (function() {
  var this$1 = $m_scm_ArrayBuffer$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_scm_Buffer($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.next__T2 = (function() {
  var key = $as_T(this.keys$1[this.index$1]);
  this.index$1 = ((1 + this.index$1) | 0);
  var dict = this.dict$1;
  if ($uZ($m_sjs_js_WrappedDictionary$Cache$().safeHasOwnProperty$1.call(dict, key))) {
    var jsx$1 = dict[key]
  } else {
    var jsx$1;
    throw new $c_ju_NoSuchElementException().init___T(("key not found: " + key))
  };
  return new $c_T2().init___O__O(key, jsx$1)
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.hasNext__Z = (function() {
  return (this.index$1 < $uI(this.keys$1.length))
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.mkString__T = (function() {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", "", "")
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.toStream__sci_Stream = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.toTraversable__sc_Traversable = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.toSeq__sc_Seq = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.$$div$colon__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_sc_Iterator__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.isTraversableAgain__Z = (function() {
  return false
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.drop__I__sc_Iterator = (function(n) {
  return $f_sc_Iterator__drop__I__sc_Iterator(this, n)
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  while (this.hasNext__Z()) {
    var arg1 = this.next__T2();
    b.$$plus$eq__T2__scm_MapBuilder(arg1)
  };
  return $as_sci_Map(b.elems$1)
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_sc_TraversableOnce__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_TraversableOnce__reduceLeft__F2__O(this, op)
});
var $d_sjs_js_WrappedDictionary$DictionaryIterator = new $TypeData().initClass({
  sjs_js_WrappedDictionary$DictionaryIterator: 0
}, false, "scala.scalajs.js.WrappedDictionary$DictionaryIterator", {
  sjs_js_WrappedDictionary$DictionaryIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sjs_js_WrappedDictionary$DictionaryIterator.prototype.$classData = $d_sjs_js_WrappedDictionary$DictionaryIterator;
/** @constructor */
function $c_sjsr_RuntimeLong() {
  $c_jl_Number.call(this);
  this.lo$2 = 0;
  this.hi$2 = 0
}
$c_sjsr_RuntimeLong.prototype = new $h_jl_Number();
$c_sjsr_RuntimeLong.prototype.constructor = $c_sjsr_RuntimeLong;
/** @constructor */
function $h_sjsr_RuntimeLong() {
  /*<skip>*/
}
$h_sjsr_RuntimeLong.prototype = $c_sjsr_RuntimeLong.prototype;
$c_sjsr_RuntimeLong.prototype.longValue__J = (function() {
  return $uJ(this)
});
$c_sjsr_RuntimeLong.prototype.$$bar__sjsr_RuntimeLong__sjsr_RuntimeLong = (function(b) {
  return new $c_sjsr_RuntimeLong().init___I__I((this.lo$2 | b.lo$2), (this.hi$2 | b.hi$2))
});
$c_sjsr_RuntimeLong.prototype.$$greater$eq__sjsr_RuntimeLong__Z = (function(b) {
  var ahi = this.hi$2;
  var bhi = b.hi$2;
  return ((ahi === bhi) ? (((-2147483648) ^ this.lo$2) >= ((-2147483648) ^ b.lo$2)) : (ahi > bhi))
});
$c_sjsr_RuntimeLong.prototype.byteValue__B = (function() {
  return ((this.lo$2 << 24) >> 24)
});
$c_sjsr_RuntimeLong.prototype.equals__O__Z = (function(that) {
  if ((that instanceof $c_sjsr_RuntimeLong)) {
    var x2 = $as_sjsr_RuntimeLong(that);
    return ((this.lo$2 === x2.lo$2) && (this.hi$2 === x2.hi$2))
  } else {
    return false
  }
});
$c_sjsr_RuntimeLong.prototype.$$less__sjsr_RuntimeLong__Z = (function(b) {
  var ahi = this.hi$2;
  var bhi = b.hi$2;
  return ((ahi === bhi) ? (((-2147483648) ^ this.lo$2) < ((-2147483648) ^ b.lo$2)) : (ahi < bhi))
});
$c_sjsr_RuntimeLong.prototype.$$times__sjsr_RuntimeLong__sjsr_RuntimeLong = (function(b) {
  var alo = this.lo$2;
  var blo = b.lo$2;
  var a0 = (65535 & alo);
  var a1 = ((alo >>> 16) | 0);
  var b0 = (65535 & blo);
  var b1 = ((blo >>> 16) | 0);
  var a0b0 = $imul(a0, b0);
  var a1b0 = $imul(a1, b0);
  var a0b1 = $imul(a0, b1);
  var lo = ((a0b0 + (((a1b0 + a0b1) | 0) << 16)) | 0);
  var c1part = ((((a0b0 >>> 16) | 0) + a0b1) | 0);
  var hi = (((((((($imul(alo, b.hi$2) + $imul(this.hi$2, blo)) | 0) + $imul(a1, b1)) | 0) + ((c1part >>> 16) | 0)) | 0) + (((((65535 & c1part) + a1b0) | 0) >>> 16) | 0)) | 0);
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_sjsr_RuntimeLong.prototype.init___I__I__I = (function(l, m, h) {
  $c_sjsr_RuntimeLong.prototype.init___I__I.call(this, (l | (m << 22)), ((m >> 10) | (h << 12)));
  return this
});
$c_sjsr_RuntimeLong.prototype.$$percent__sjsr_RuntimeLong__sjsr_RuntimeLong = (function(b) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.remainderImpl__I__I__I__I__I(this.lo$2, this.hi$2, b.lo$2, b.hi$2);
  return new $c_sjsr_RuntimeLong().init___I__I(lo, this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f)
});
$c_sjsr_RuntimeLong.prototype.toString__T = (function() {
  return $m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toString__I__I__T(this.lo$2, this.hi$2)
});
$c_sjsr_RuntimeLong.prototype.init___I__I = (function(lo, hi) {
  this.lo$2 = lo;
  this.hi$2 = hi;
  return this
});
$c_sjsr_RuntimeLong.prototype.compareTo__O__I = (function(x$1) {
  var that = $as_sjsr_RuntimeLong(x$1);
  return $m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$compare__I__I__I__I__I(this.lo$2, this.hi$2, that.lo$2, that.hi$2)
});
$c_sjsr_RuntimeLong.prototype.$$less$eq__sjsr_RuntimeLong__Z = (function(b) {
  var ahi = this.hi$2;
  var bhi = b.hi$2;
  return ((ahi === bhi) ? (((-2147483648) ^ this.lo$2) <= ((-2147483648) ^ b.lo$2)) : (ahi < bhi))
});
$c_sjsr_RuntimeLong.prototype.$$amp__sjsr_RuntimeLong__sjsr_RuntimeLong = (function(b) {
  return new $c_sjsr_RuntimeLong().init___I__I((this.lo$2 & b.lo$2), (this.hi$2 & b.hi$2))
});
$c_sjsr_RuntimeLong.prototype.$$greater$greater$greater__I__sjsr_RuntimeLong = (function(n) {
  return new $c_sjsr_RuntimeLong().init___I__I((((32 & n) === 0) ? (((this.lo$2 >>> n) | 0) | ((this.hi$2 << 1) << ((31 - n) | 0))) : ((this.hi$2 >>> n) | 0)), (((32 & n) === 0) ? ((this.hi$2 >>> n) | 0) : 0))
});
$c_sjsr_RuntimeLong.prototype.$$greater__sjsr_RuntimeLong__Z = (function(b) {
  var ahi = this.hi$2;
  var bhi = b.hi$2;
  return ((ahi === bhi) ? (((-2147483648) ^ this.lo$2) > ((-2147483648) ^ b.lo$2)) : (ahi > bhi))
});
$c_sjsr_RuntimeLong.prototype.$$less$less__I__sjsr_RuntimeLong = (function(n) {
  return new $c_sjsr_RuntimeLong().init___I__I((((32 & n) === 0) ? (this.lo$2 << n) : 0), (((32 & n) === 0) ? (((((this.lo$2 >>> 1) | 0) >>> ((31 - n) | 0)) | 0) | (this.hi$2 << n)) : (this.lo$2 << n)))
});
$c_sjsr_RuntimeLong.prototype.init___I = (function(value) {
  $c_sjsr_RuntimeLong.prototype.init___I__I.call(this, value, (value >> 31));
  return this
});
$c_sjsr_RuntimeLong.prototype.toInt__I = (function() {
  return this.lo$2
});
$c_sjsr_RuntimeLong.prototype.notEquals__sjsr_RuntimeLong__Z = (function(b) {
  return (!((this.lo$2 === b.lo$2) && (this.hi$2 === b.hi$2)))
});
$c_sjsr_RuntimeLong.prototype.unary$und$minus__sjsr_RuntimeLong = (function() {
  var lo = this.lo$2;
  var hi = this.hi$2;
  return new $c_sjsr_RuntimeLong().init___I__I(((-lo) | 0), ((lo !== 0) ? (~hi) : ((-hi) | 0)))
});
$c_sjsr_RuntimeLong.prototype.$$plus__sjsr_RuntimeLong__sjsr_RuntimeLong = (function(b) {
  var alo = this.lo$2;
  var ahi = this.hi$2;
  var bhi = b.hi$2;
  var lo = ((alo + b.lo$2) | 0);
  return new $c_sjsr_RuntimeLong().init___I__I(lo, ((((-2147483648) ^ lo) < ((-2147483648) ^ alo)) ? ((1 + ((ahi + bhi) | 0)) | 0) : ((ahi + bhi) | 0)))
});
$c_sjsr_RuntimeLong.prototype.shortValue__S = (function() {
  return ((this.lo$2 << 16) >> 16)
});
$c_sjsr_RuntimeLong.prototype.$$greater$greater__I__sjsr_RuntimeLong = (function(n) {
  return new $c_sjsr_RuntimeLong().init___I__I((((32 & n) === 0) ? (((this.lo$2 >>> n) | 0) | ((this.hi$2 << 1) << ((31 - n) | 0))) : (this.hi$2 >> n)), (((32 & n) === 0) ? (this.hi$2 >> n) : (this.hi$2 >> 31)))
});
$c_sjsr_RuntimeLong.prototype.toDouble__D = (function() {
  return $m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toDouble__I__I__D(this.lo$2, this.hi$2)
});
$c_sjsr_RuntimeLong.prototype.$$div__sjsr_RuntimeLong__sjsr_RuntimeLong = (function(b) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(this.lo$2, this.hi$2, b.lo$2, b.hi$2);
  return new $c_sjsr_RuntimeLong().init___I__I(lo, this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f)
});
$c_sjsr_RuntimeLong.prototype.doubleValue__D = (function() {
  return $m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toDouble__I__I__D(this.lo$2, this.hi$2)
});
$c_sjsr_RuntimeLong.prototype.hashCode__I = (function() {
  return (this.lo$2 ^ this.hi$2)
});
$c_sjsr_RuntimeLong.prototype.intValue__I = (function() {
  return this.lo$2
});
$c_sjsr_RuntimeLong.prototype.unary$und$tilde__sjsr_RuntimeLong = (function() {
  return new $c_sjsr_RuntimeLong().init___I__I((~this.lo$2), (~this.hi$2))
});
$c_sjsr_RuntimeLong.prototype.compareTo__jl_Long__I = (function(that) {
  return $m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$compare__I__I__I__I__I(this.lo$2, this.hi$2, that.lo$2, that.hi$2)
});
$c_sjsr_RuntimeLong.prototype.floatValue__F = (function() {
  return $fround($m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toDouble__I__I__D(this.lo$2, this.hi$2))
});
$c_sjsr_RuntimeLong.prototype.$$minus__sjsr_RuntimeLong__sjsr_RuntimeLong = (function(b) {
  var alo = this.lo$2;
  var ahi = this.hi$2;
  var bhi = b.hi$2;
  var lo = ((alo - b.lo$2) | 0);
  return new $c_sjsr_RuntimeLong().init___I__I(lo, ((((-2147483648) ^ lo) > ((-2147483648) ^ alo)) ? (((-1) + ((ahi - bhi) | 0)) | 0) : ((ahi - bhi) | 0)))
});
$c_sjsr_RuntimeLong.prototype.$$up__sjsr_RuntimeLong__sjsr_RuntimeLong = (function(b) {
  return new $c_sjsr_RuntimeLong().init___I__I((this.lo$2 ^ b.lo$2), (this.hi$2 ^ b.hi$2))
});
$c_sjsr_RuntimeLong.prototype.equals__sjsr_RuntimeLong__Z = (function(b) {
  return ((this.lo$2 === b.lo$2) && (this.hi$2 === b.hi$2))
});
function $as_sjsr_RuntimeLong(obj) {
  return (((obj instanceof $c_sjsr_RuntimeLong) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.scalajs.runtime.RuntimeLong"))
}
function $isArrayOf_sjsr_RuntimeLong(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sjsr_RuntimeLong)))
}
function $asArrayOf_sjsr_RuntimeLong(obj, depth) {
  return (($isArrayOf_sjsr_RuntimeLong(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.scalajs.runtime.RuntimeLong;", depth))
}
var $d_sjsr_RuntimeLong = new $TypeData().initClass({
  sjsr_RuntimeLong: 0
}, false, "scala.scalajs.runtime.RuntimeLong", {
  sjsr_RuntimeLong: 1,
  jl_Number: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  jl_Comparable: 1
});
$c_sjsr_RuntimeLong.prototype.$classData = $d_sjsr_RuntimeLong;
/** @constructor */
function $c_Lamf_ProfileName() {
  $c_O.call(this);
  this.p$1 = null;
  this.amf$ProfileName$$m$1 = null
}
$c_Lamf_ProfileName.prototype = new $h_O();
$c_Lamf_ProfileName.prototype.constructor = $c_Lamf_ProfileName;
/** @constructor */
function $h_Lamf_ProfileName() {
  /*<skip>*/
}
$h_Lamf_ProfileName.prototype = $c_Lamf_ProfileName.prototype;
$c_Lamf_ProfileName.prototype.productPrefix__T = (function() {
  return "ProfileName"
});
$c_Lamf_ProfileName.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_ProfileName.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_ProfileName)) {
    var ProfileName$1 = $as_Lamf_ProfileName(x$1);
    if ((this.p$1 === ProfileName$1.p$1)) {
      var x = this.amf$ProfileName$$m$1;
      var x$2 = ProfileName$1.amf$ProfileName$$m$1;
      return (x === x$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_ProfileName.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.p$1;
      break
    }
    case 1: {
      return this.amf$ProfileName$$m$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_ProfileName.prototype.toString__T = (function() {
  return this.p$1
});
$c_Lamf_ProfileName.prototype.init___T__Lamf_MessageStyle = (function(p, m) {
  this.p$1 = p;
  this.amf$ProfileName$$m$1 = m;
  return this
});
$c_Lamf_ProfileName.prototype.init___T = (function(profile) {
  $c_Lamf_ProfileName.prototype.init___T__Lamf_MessageStyle.call(this, profile, $m_Lamf_AMFStyle$());
  return this
});
$c_Lamf_ProfileName.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_ProfileName.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_ProfileName(obj) {
  return (((obj instanceof $c_Lamf_ProfileName) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.ProfileName"))
}
function $isArrayOf_Lamf_ProfileName(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_ProfileName)))
}
function $asArrayOf_Lamf_ProfileName(obj, depth) {
  return (($isArrayOf_Lamf_ProfileName(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.ProfileName;", depth))
}
var $d_Lamf_ProfileName = new $TypeData().initClass({
  Lamf_ProfileName: 0
}, false, "amf.ProfileName", {
  Lamf_ProfileName: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_ProfileName.prototype.$classData = $d_Lamf_ProfileName;
/** @constructor */
function $c_Lamf_client_model_Annotations() {
  $c_O.call(this);
  this.$$undinternal$1 = null
}
$c_Lamf_client_model_Annotations.prototype = new $h_O();
$c_Lamf_client_model_Annotations.prototype.constructor = $c_Lamf_client_model_Annotations;
/** @constructor */
function $h_Lamf_client_model_Annotations() {
  /*<skip>*/
}
$h_Lamf_client_model_Annotations.prototype = $c_Lamf_client_model_Annotations.prototype;
$c_Lamf_client_model_Annotations.prototype.isTrackedBy__T__Z = (function(trackId) {
  var this$1 = this.$$undinternal$1;
  var pf = new $c_Lamf_client_model_Annotations$$anonfun$isTrackedBy$1().init___Lamf_client_model_Annotations__T(this, trackId);
  var this$3 = this$1.amf$core$parser$Annotations$$annotations$1;
  var this$2 = $m_scm_ListBuffer$();
  var bf = this$2.ReusableCBFInstance$2;
  return $as_sc_Seq($f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this$3, pf, bf)).nonEmpty__Z()
});
$c_Lamf_client_model_Annotations.prototype.inheritanceProvenance__sjs_js_UndefOr = (function() {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1.find__jl_Class__s_Option($d_Lamf_core_annotations_InheritanceProvenance.getClassOf());
  if (this$1.isEmpty__Z()) {
    var from = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$7 = $as_Lamf_core_annotations_InheritanceProvenance(arg1);
    var from = new $c_s_Some().init___O(x$7.baseId$1)
  };
  var m = $m_Lamf_client_convert_CoreClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_Annotations.prototype.init___ = (function() {
  $c_Lamf_client_model_Annotations.prototype.init___Lamf_core_parser_Annotations.call(this, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
  return this
});
$c_Lamf_client_model_Annotations.prototype.productPrefix__T = (function() {
  return "Annotations"
});
$c_Lamf_client_model_Annotations.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_Annotations.prototype.$$js$exported$prop$$undinternal__O = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_Annotations.prototype.$$js$exported$prop$inlinedElement__O = (function() {
  return this.inlinedElement__Z()
});
$c_Lamf_client_model_Annotations.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_Annotations)) {
    var Annotations$1 = $as_Lamf_client_model_Annotations(x$1);
    var x = this.$$undinternal$1;
    var x$2 = Annotations$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_Annotations.prototype.resolvedLinkTarget__sjs_js_UndefOr = (function() {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1.find__jl_Class__s_Option($d_Lamf_core_annotations_ResolvedLinkTargetAnnotation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var from = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$6 = $as_Lamf_core_annotations_ResolvedLinkTargetAnnotation(arg1);
    var from = new $c_s_Some().init___O(x$6.linkTargetId$1)
  };
  var m = $m_Lamf_client_convert_CoreClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_Annotations.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_Annotations.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_Annotations.prototype.$$js$exported$prop$inheritanceProvenance__O = (function() {
  return this.inheritanceProvenance__sjs_js_UndefOr()
});
$c_Lamf_client_model_Annotations.prototype.$$js$exported$meth$fragmentName__O = (function() {
  return this.fragmentName__sjs_js_UndefOr()
});
$c_Lamf_client_model_Annotations.prototype.lexical__Lamf_core_parser_Range = (function() {
  var this$1 = this.$$undinternal$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_Lamf_core_annotations_LexicalInformation(arg1);
    var this$2 = new $c_s_Some().init___O(x$1.range__Lamf_core_parser_Range())
  };
  return $as_Lamf_core_parser_Range((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Range$NONE$() : this$2.get__O()))
});
$c_Lamf_client_model_Annotations.prototype.$$js$exported$meth$location__O = (function() {
  return this.location__sjs_js_UndefOr()
});
$c_Lamf_client_model_Annotations.prototype.$$js$exported$prop$isTracked__O = (function() {
  return this.isTracked__Z()
});
$c_Lamf_client_model_Annotations.prototype.isTracked__Z = (function() {
  var this$1 = this.$$undinternal$1;
  var pf = new $c_Lamf_client_model_Annotations$$anonfun$isTracked$1().init___Lamf_client_model_Annotations(this);
  var this$3 = this$1.amf$core$parser$Annotations$$annotations$1;
  var this$2 = $m_scm_ListBuffer$();
  var bf = this$2.ReusableCBFInstance$2;
  return $as_sc_Seq($f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this$3, pf, bf)).nonEmpty__Z()
});
$c_Lamf_client_model_Annotations.prototype.autoGeneratedName__Z = (function() {
  return this.$$undinternal$1.find__jl_Class__s_Option($d_Lamf_core_annotations_AutoGeneratedName.getClassOf()).isDefined__Z()
});
$c_Lamf_client_model_Annotations.prototype.custom__sjs_js_Array = (function() {
  var this$5 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var pf = new $c_Lamf_client_model_Annotations$$anonfun$custom$1().init___Lamf_client_model_Annotations(this);
  var this$3 = this$1.amf$core$parser$Annotations$$annotations$1;
  var this$2 = $m_scm_ListBuffer$();
  var bf = this$2.ReusableCBFInstance$2;
  var jsx$2 = $as_sc_Seq($f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this$3, pf, bf));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_annotations_DomainExtensionAnnotation(x$2$2);
      return x$2.extension$1
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  var from = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2));
  var m = $m_Lamf_client_convert_CoreClientConverters$().DomainExtensionMatcher__Lamf_client_convert_DomainExtensionConverter$DomainExtensionMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$5, from, m).asClient__O()
});
$c_Lamf_client_model_Annotations.prototype.$$js$exported$prop$isLocal__O = (function() {
  return this.isLocal__Z()
});
$c_Lamf_client_model_Annotations.prototype.inlinedElement__Z = (function() {
  return this.$$undinternal$1.find__jl_Class__s_Option($d_Lamf_core_annotations_InlineElement.getClassOf()).isDefined__Z()
});
$c_Lamf_client_model_Annotations.prototype.fragmentName__sjs_js_UndefOr = (function() {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1.find__jl_Class__s_Option($d_Lamf_core_annotations_ExternalFragmentRef.getClassOf());
  if (this$1.isEmpty__Z()) {
    var from = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$3 = $as_Lamf_core_annotations_ExternalFragmentRef(arg1);
    var from = new $c_s_Some().init___O(x$3.fragment$1)
  };
  var m = $m_Lamf_client_convert_CoreClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_Annotations.prototype.$$js$exported$meth$custom__O = (function() {
  return this.custom__sjs_js_Array()
});
$c_Lamf_client_model_Annotations.prototype.$$js$exported$prop$autoGeneratedName__O = (function() {
  return this.autoGeneratedName__Z()
});
$c_Lamf_client_model_Annotations.prototype.init___Lamf_core_parser_Annotations = (function(_internal) {
  this.$$undinternal$1 = _internal;
  return this
});
$c_Lamf_client_model_Annotations.prototype.$$js$exported$meth$isTrackedBy__T__O = (function(trackId) {
  return this.isTrackedBy__T__Z(trackId)
});
$c_Lamf_client_model_Annotations.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_Annotations.prototype.$$js$exported$meth$lexical__O = (function() {
  return this.lexical__Lamf_core_parser_Range()
});
$c_Lamf_client_model_Annotations.prototype.resolvedLink__sjs_js_UndefOr = (function() {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1.find__jl_Class__s_Option($d_Lamf_core_annotations_ResolvedLinkAnnotation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var from = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$5 = $as_Lamf_core_annotations_ResolvedLinkAnnotation(arg1);
    var from = new $c_s_Some().init___O(x$5.linkId$1)
  };
  var m = $m_Lamf_client_convert_CoreClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_Annotations.prototype.$$js$exported$prop$resolvedLink__O = (function() {
  return this.resolvedLink__sjs_js_UndefOr()
});
$c_Lamf_client_model_Annotations.prototype.location__sjs_js_UndefOr = (function() {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1.find__jl_Class__s_Option($d_Lamf_core_annotations_SourceLocation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var from = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$4 = $as_Lamf_core_annotations_SourceLocation(arg1);
    var from = new $c_s_Some().init___O(x$4.location$1)
  };
  var m = $m_Lamf_client_convert_CoreClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_Annotations.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_Annotations.prototype.$$js$exported$prop$resolvedLinkTarget__O = (function() {
  return this.resolvedLinkTarget__sjs_js_UndefOr()
});
$c_Lamf_client_model_Annotations.prototype.isLocal__Z = (function() {
  return this.$$undinternal$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LocalElement.getClassOf()).isDefined__Z()
});
Object.defineProperty($c_Lamf_client_model_Annotations.prototype, "autoGeneratedName", {
  "get": (function() {
    return this.$$js$exported$prop$autoGeneratedName__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_Annotations.prototype, "inlinedElement", {
  "get": (function() {
    return this.$$js$exported$prop$inlinedElement__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_Annotations.prototype, "inheritanceProvenance", {
  "get": (function() {
    return this.$$js$exported$prop$inheritanceProvenance__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_Annotations.prototype, "resolvedLinkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$resolvedLinkTarget__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_Annotations.prototype, "resolvedLink", {
  "get": (function() {
    return this.$$js$exported$prop$resolvedLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_Annotations.prototype, "isTracked", {
  "get": (function() {
    return this.$$js$exported$prop$isTracked__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_Annotations.prototype.isTrackedBy = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$isTrackedBy__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_Annotations.prototype, "isLocal", {
  "get": (function() {
    return this.$$js$exported$prop$isLocal__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_Annotations.prototype.location = (function() {
  return this.$$js$exported$meth$location__O()
});
$c_Lamf_client_model_Annotations.prototype.fragmentName = (function() {
  return this.$$js$exported$meth$fragmentName__O()
});
$c_Lamf_client_model_Annotations.prototype.custom = (function() {
  return this.$$js$exported$meth$custom__O()
});
$c_Lamf_client_model_Annotations.prototype.lexical = (function() {
  return this.$$js$exported$meth$lexical__O()
});
Object.defineProperty($c_Lamf_client_model_Annotations.prototype, "_internal", {
  "get": (function() {
    return this.$$js$exported$prop$$undinternal__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_Annotations(obj) {
  return (((obj instanceof $c_Lamf_client_model_Annotations) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.Annotations"))
}
function $isArrayOf_Lamf_client_model_Annotations(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_Annotations)))
}
function $asArrayOf_Lamf_client_model_Annotations(obj, depth) {
  return (($isArrayOf_Lamf_client_model_Annotations(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.Annotations;", depth))
}
var $d_Lamf_client_model_Annotations = new $TypeData().initClass({
  Lamf_client_model_Annotations: 0
}, false, "amf.client.model.Annotations", {
  Lamf_client_model_Annotations: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_Annotations.prototype.$classData = $d_Lamf_client_model_Annotations;
function $is_Lamf_client_model_domain_ChannelBinding(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_client_model_domain_ChannelBinding)))
}
function $as_Lamf_client_model_domain_ChannelBinding(obj) {
  return (($is_Lamf_client_model_domain_ChannelBinding(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.ChannelBinding"))
}
function $isArrayOf_Lamf_client_model_domain_ChannelBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_ChannelBinding)))
}
function $asArrayOf_Lamf_client_model_domain_ChannelBinding(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_ChannelBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.ChannelBinding;", depth))
}
/** @constructor */
function $c_Lamf_client_model_domain_Graph() {
  $c_O.call(this);
  this.$$undinternal$1 = null
}
$c_Lamf_client_model_domain_Graph.prototype = new $h_O();
$c_Lamf_client_model_domain_Graph.prototype.constructor = $c_Lamf_client_model_domain_Graph;
/** @constructor */
function $h_Lamf_client_model_domain_Graph() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_Graph.prototype = $c_Lamf_client_model_domain_Graph.prototype;
$c_Lamf_client_model_domain_Graph.prototype.$$js$exported$meth$properties__O = (function() {
  return this.properties__sjs_js_Array()
});
$c_Lamf_client_model_domain_Graph.prototype.scalarByProperty__T__sjs_js_Array = (function(id) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal$1.scalarByProperty__T__sc_Seq(id);
  var m = $m_Lamf_client_convert_CoreClientConverters$().AnyMatcher__Lamf_client_convert_CoreBaseConverter$AnyMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Graph.prototype.productPrefix__T = (function() {
  return "Graph"
});
$c_Lamf_client_model_domain_Graph.prototype.getObjectByPropertyId__T__sjs_js_Array = (function(id) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal$1.getObjectByPropertyId__T__sc_Seq(id);
  var m = $m_Lamf_client_convert_CoreClientConverters$().DomainElementMatcher__Lamf_client_convert_DomainElementConverter$DomainElementMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Graph.prototype.$$js$exported$meth$types__O = (function() {
  return this.types__sjs_js_Array()
});
$c_Lamf_client_model_domain_Graph.prototype.types__sjs_js_Array = (function() {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal$1.types__sc_Seq();
  var m = $m_Lamf_client_convert_CoreClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Graph.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_Graph.prototype.$$js$exported$meth$remove__T__O = (function(uri) {
  return this.remove__T__Lamf_client_model_domain_Graph(uri)
});
$c_Lamf_client_model_domain_Graph.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_Graph)) {
    var Graph$1 = $as_Lamf_client_model_domain_Graph(x$1);
    var x = this.$$undinternal$1;
    var x$2 = Graph$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_Graph.prototype.properties__sjs_js_Array = (function() {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal$1.properties__sc_Seq();
  var m = $m_Lamf_client_convert_CoreClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Graph.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_Graph.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_Graph.prototype.init___Lamf_core_model_domain_Graph = (function(_internal) {
  this.$$undinternal$1 = _internal;
  return this
});
$c_Lamf_client_model_domain_Graph.prototype.$$js$exported$meth$scalarByProperty__T__O = (function(id) {
  return this.scalarByProperty__T__sjs_js_Array(id)
});
$c_Lamf_client_model_domain_Graph.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_Graph.prototype.$$js$exported$meth$getObjectByPropertyId__T__O = (function(id) {
  return this.getObjectByPropertyId__T__sjs_js_Array(id)
});
$c_Lamf_client_model_domain_Graph.prototype.remove__T__Lamf_client_model_domain_Graph = (function(uri) {
  this.$$undinternal$1.removeField__T__Lamf_core_model_domain_Graph(uri);
  return this
});
$c_Lamf_client_model_domain_Graph.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_Graph.prototype.remove = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$remove__T__O(prep)
});
$c_Lamf_client_model_domain_Graph.prototype.getObjectByPropertyId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$getObjectByPropertyId__T__O(prep)
});
$c_Lamf_client_model_domain_Graph.prototype.scalarByProperty = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$scalarByProperty__T__O(prep)
});
$c_Lamf_client_model_domain_Graph.prototype.properties = (function() {
  return this.$$js$exported$meth$properties__O()
});
$c_Lamf_client_model_domain_Graph.prototype.types = (function() {
  return this.$$js$exported$meth$types__O()
});
function $as_Lamf_client_model_domain_Graph(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_Graph) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Graph"))
}
function $isArrayOf_Lamf_client_model_domain_Graph(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Graph)))
}
function $asArrayOf_Lamf_client_model_domain_Graph(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Graph(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Graph;", depth))
}
var $d_Lamf_client_model_domain_Graph = new $TypeData().initClass({
  Lamf_client_model_domain_Graph: 0
}, false, "amf.client.model.domain.Graph", {
  Lamf_client_model_domain_Graph: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_Graph.prototype.$classData = $d_Lamf_client_model_domain_Graph;
function $is_Lamf_client_model_domain_MessageBinding(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_client_model_domain_MessageBinding)))
}
function $as_Lamf_client_model_domain_MessageBinding(obj) {
  return (($is_Lamf_client_model_domain_MessageBinding(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.MessageBinding"))
}
function $isArrayOf_Lamf_client_model_domain_MessageBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_MessageBinding)))
}
function $asArrayOf_Lamf_client_model_domain_MessageBinding(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_MessageBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.MessageBinding;", depth))
}
function $is_Lamf_client_model_domain_OperationBinding(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_client_model_domain_OperationBinding)))
}
function $as_Lamf_client_model_domain_OperationBinding(obj) {
  return (($is_Lamf_client_model_domain_OperationBinding(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.OperationBinding"))
}
function $isArrayOf_Lamf_client_model_domain_OperationBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_OperationBinding)))
}
function $asArrayOf_Lamf_client_model_domain_OperationBinding(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_OperationBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.OperationBinding;", depth))
}
function $f_Lamf_client_model_domain_ParametrizedDeclaration__name__Lamf_client_model_StrField($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_templates_ParametrizedDeclaration();
  var from = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$().Name$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
}
function $f_Lamf_client_model_domain_ParametrizedDeclaration__variables__sjs_js_Array($thiz) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = $thiz.$$undinternal__Lamf_core_model_domain_templates_ParametrizedDeclaration().variables__sc_Seq();
  var m = $m_Lamf_client_convert_CoreClientConverters$().VariableValueMatcher__Lamf_client_convert_VariableValueConverter$VariableValueMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
}
function $f_Lamf_client_model_domain_ParametrizedDeclaration__withTarget__Lamf_client_model_domain_AbstractDeclaration__Lamf_client_model_domain_ParametrizedDeclaration($thiz, target) {
  var this$2 = $thiz.$$undinternal__Lamf_core_model_domain_templates_ParametrizedDeclaration();
  $m_Lamf_client_convert_CoreClientConverters$();
  $m_Lamf_client_convert_CoreClientConverters$().AbstractDeclarationMatcher__Lamf_client_convert_DeclarationsConverter$AbstractDeclarationMatcher$();
  var target$1 = target.$$undinternal__Lamf_core_model_domain_templates_AbstractDeclaration();
  var field = $m_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$().Target$1;
  $as_Lamf_core_model_domain_templates_ParametrizedDeclaration($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, target$1));
  return $thiz
}
function $f_Lamf_client_model_domain_ParametrizedDeclaration__withName__T__Lamf_client_model_domain_ParametrizedDeclaration($thiz, name) {
  var this$3 = $thiz.$$undinternal__Lamf_core_model_domain_templates_ParametrizedDeclaration();
  $thiz.$$undinternal__Lamf_core_model_domain_templates_ParametrizedDeclaration();
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return $thiz
}
function $f_Lamf_client_model_domain_ParametrizedDeclaration__withVariables__sjs_js_Array__Lamf_client_model_domain_ParametrizedDeclaration($thiz, variables) {
  var this$2 = $thiz.$$undinternal__Lamf_core_model_domain_templates_ParametrizedDeclaration();
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var m = $m_Lamf_client_convert_CoreClientConverters$().VariableValueMatcher__Lamf_client_convert_VariableValueConverter$VariableValueMatcher$();
  var variables$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, variables, m).asInternal__sc_Seq();
  var field = $m_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$().Variables$1;
  $as_Lamf_core_model_domain_templates_ParametrizedDeclaration($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, variables$1));
  return $thiz
}
function $f_Lamf_client_model_domain_ParametrizedDeclaration__target__Lamf_client_model_domain_AbstractDeclaration($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var from = $thiz.$$undinternal__Lamf_core_model_domain_templates_ParametrizedDeclaration().target__Lamf_core_model_domain_templates_AbstractDeclaration();
  var m = $m_Lamf_client_convert_CoreClientConverters$().AbstractDeclarationMatcher__Lamf_client_convert_DeclarationsConverter$AbstractDeclarationMatcher$();
  return m.asClient__Lamf_core_model_domain_templates_AbstractDeclaration__Lamf_client_model_domain_AbstractDeclaration(from)
}
function $is_Lamf_client_model_domain_ParametrizedDeclaration(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_client_model_domain_ParametrizedDeclaration)))
}
function $as_Lamf_client_model_domain_ParametrizedDeclaration(obj) {
  return (($is_Lamf_client_model_domain_ParametrizedDeclaration(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.ParametrizedDeclaration"))
}
function $isArrayOf_Lamf_client_model_domain_ParametrizedDeclaration(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_ParametrizedDeclaration)))
}
function $asArrayOf_Lamf_client_model_domain_ParametrizedDeclaration(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_ParametrizedDeclaration(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.ParametrizedDeclaration;", depth))
}
/** @constructor */
function $c_Lamf_client_model_domain_PropertyTerm() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_PropertyTerm.prototype = new $h_O();
$c_Lamf_client_model_domain_PropertyTerm.prototype.constructor = $c_Lamf_client_model_domain_PropertyTerm;
/** @constructor */
function $h_Lamf_client_model_domain_PropertyTerm() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_PropertyTerm.prototype = $c_Lamf_client_model_domain_PropertyTerm.prototype;
$c_Lamf_client_model_domain_PropertyTerm.prototype.withDisplayName__T__Lamf_client_model_domain_PropertyTerm = (function(displayName) {
  var this$1 = this.$$undinternal__Lamf_plugins_document_vocabularies_model_domain_PropertyTerm();
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().DisplayName$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, displayName));
  return this
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.subPropertyOf__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal__Lamf_plugins_document_vocabularies_model_domain_PropertyTerm();
  var from = $as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().SubPropertyOf$1));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal__Lamf_plugins_document_vocabularies_model_domain_PropertyTerm();
  var from = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().Name$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.$$js$exported$prop$displayName__O = (function() {
  return this.displayName__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.$$js$exported$meth$withRange__T__O = (function(range) {
  return this.withRange__T__Lamf_client_model_domain_PropertyTerm(range)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.description__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal__Lamf_plugins_document_vocabularies_model_domain_PropertyTerm();
  var from = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().Description$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.$$js$exported$prop$range__O = (function() {
  return this.range__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.init___Lamf_plugins_document_vocabularies_model_domain_PropertyTerm = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.$$js$exported$meth$withDisplayName__T__O = (function(displayName) {
  return this.withDisplayName__T__Lamf_client_model_domain_PropertyTerm(displayName)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.withRange__T__Lamf_client_model_domain_PropertyTerm = (function(range) {
  var this$1 = this.$$undinternal__Lamf_plugins_document_vocabularies_model_domain_PropertyTerm();
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().Range$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, range));
  return this
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.$$js$exported$meth$withSubClasOf__sc_Seq__O = (function(superProperties) {
  return this.withSubClasOf__sc_Seq__Lamf_client_model_domain_PropertyTerm(superProperties)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.withName__T__Lamf_client_model_domain_PropertyTerm = (function(name) {
  var this$1 = this.$$undinternal__Lamf_plugins_document_vocabularies_model_domain_PropertyTerm();
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().Name$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name));
  return this
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.range__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal__Lamf_plugins_document_vocabularies_model_domain_PropertyTerm();
  var from = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().Range$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.$$js$exported$meth$withDescription__T__O = (function(description) {
  return this.withDescription__T__Lamf_client_model_domain_PropertyTerm(description)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.withSubClasOf__sc_Seq__Lamf_client_model_domain_PropertyTerm = (function(superProperties) {
  this.$$undinternal__Lamf_plugins_document_vocabularies_model_domain_PropertyTerm().withSubClassOf__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_PropertyTerm(superProperties);
  return this
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal__Lamf_core_model_domain_DomainElement().id__T()
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.$$js$exported$prop$subPropertyOf__O = (function() {
  return this.subPropertyOf__sjs_js_Array()
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.$$js$exported$prop$description__O = (function() {
  return this.description__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.withDescription__T__Lamf_client_model_domain_PropertyTerm = (function(description) {
  var this$1 = this.$$undinternal__Lamf_plugins_document_vocabularies_model_domain_PropertyTerm();
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().Description$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, description));
  return this
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.displayName__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal__Lamf_plugins_document_vocabularies_model_domain_PropertyTerm();
  var from = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().DisplayName$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_PropertyTerm(name)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyTerm.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyTerm.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyTerm.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyTerm.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyTerm.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.withSubClasOf = (function(arg) {
  var prep = $as_sc_Seq(arg);
  return this.$$js$exported$meth$withSubClasOf__sc_Seq__O(prep)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.withRange = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withRange__T__O(prep)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.withDescription = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDescription__T__O(prep)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.withDisplayName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDisplayName__T__O(prep)
});
$c_Lamf_client_model_domain_PropertyTerm.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyTerm.prototype, "subPropertyOf", {
  "get": (function() {
    return this.$$js$exported$prop$subPropertyOf__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyTerm.prototype, "range", {
  "get": (function() {
    return this.$$js$exported$prop$range__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyTerm.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyTerm.prototype, "displayName", {
  "get": (function() {
    return this.$$js$exported$prop$displayName__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyTerm.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $is_Lamf_client_model_domain_ServerBinding(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_client_model_domain_ServerBinding)))
}
function $as_Lamf_client_model_domain_ServerBinding(obj) {
  return (($is_Lamf_client_model_domain_ServerBinding(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.ServerBinding"))
}
function $isArrayOf_Lamf_client_model_domain_ServerBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_ServerBinding)))
}
function $asArrayOf_Lamf_client_model_domain_ServerBinding(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_ServerBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.ServerBinding;", depth))
}
/** @constructor */
function $c_Lamf_client_model_domain_Settings() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_Settings.prototype = new $h_O();
$c_Lamf_client_model_domain_Settings.prototype.constructor = $c_Lamf_client_model_domain_Settings;
/** @constructor */
function $h_Lamf_client_model_domain_Settings() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_Settings.prototype = $c_Lamf_client_model_domain_Settings.prototype;
$c_Lamf_client_model_domain_Settings.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_Settings.prototype.init___Lamf_plugins_domain_webapi_models_security_Settings.call(this, new $c_Lamf_plugins_domain_webapi_models_security_Settings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_Settings.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_Settings.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_Settings.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_Settings.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal__Lamf_plugins_domain_webapi_models_security_Settings()
});
$c_Lamf_client_model_domain_Settings.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_Settings.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_Settings.prototype.$$js$exported$meth$withAdditionalProperties__Lamf_client_model_domain_DataNode__O = (function(properties) {
  return this.withAdditionalProperties__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_Settings(properties)
});
$c_Lamf_client_model_domain_Settings.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_Settings.prototype.$$js$exported$prop$additionalProperties__O = (function() {
  return this.additionalProperties__Lamf_client_model_domain_DataNode()
});
$c_Lamf_client_model_domain_Settings.prototype.additionalProperties__Lamf_client_model_domain_DataNode = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_webapi_models_security_Settings();
  var from = $as_Lamf_core_model_domain_DataNode(this$1.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().AdditionalProperties$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$();
  return m.asClient__Lamf_core_model_domain_DataNode__Lamf_client_model_domain_DataNode(from)
});
$c_Lamf_client_model_domain_Settings.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Settings.prototype.withAdditionalProperties__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_Settings = (function(properties) {
  var this$2 = this.$$undinternal__Lamf_plugins_domain_webapi_models_security_Settings();
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$();
  var additionalProperties = properties.$$undinternal__Lamf_core_model_domain_DataNode();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().AdditionalProperties$1;
  $as_Lamf_plugins_domain_webapi_models_security_Settings($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, additionalProperties));
  return this
});
$c_Lamf_client_model_domain_Settings.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Settings.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_Settings.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_Settings.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal__Lamf_core_model_domain_DomainElement().id__T()
});
$c_Lamf_client_model_domain_Settings.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal__Lamf_plugins_domain_webapi_models_security_Settings()
});
$c_Lamf_client_model_domain_Settings.prototype.init___Lamf_plugins_domain_webapi_models_security_Settings = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_Settings.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_security_Settings = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Settings.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_Settings.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_Settings.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Settings.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Settings.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_Settings.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Settings.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Settings.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Settings.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Settings.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Settings.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Settings.prototype.withAdditionalProperties = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DataNode(arg);
  return this.$$js$exported$meth$withAdditionalProperties__Lamf_client_model_domain_DataNode__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Settings.prototype, "additionalProperties", {
  "get": (function() {
    return this.$$js$exported$prop$additionalProperties__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_Settings(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_Settings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Settings"))
}
function $isArrayOf_Lamf_client_model_domain_Settings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Settings)))
}
function $asArrayOf_Lamf_client_model_domain_Settings(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Settings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Settings;", depth))
}
var $d_Lamf_client_model_domain_Settings = new $TypeData().initClass({
  Lamf_client_model_domain_Settings: 0
}, false, "amf.client.model.domain.Settings", {
  Lamf_client_model_domain_Settings: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_client_model_domain_Settings.prototype.$classData = $d_Lamf_client_model_domain_Settings;
/** @constructor */
function $c_Lamf_client_reference_CachedReference() {
  $c_O.call(this);
  this.$$undinternal$1 = null
}
$c_Lamf_client_reference_CachedReference.prototype = new $h_O();
$c_Lamf_client_reference_CachedReference.prototype.constructor = $c_Lamf_client_reference_CachedReference;
/** @constructor */
function $h_Lamf_client_reference_CachedReference() {
  /*<skip>*/
}
$h_Lamf_client_reference_CachedReference.prototype = $c_Lamf_client_reference_CachedReference.prototype;
$c_Lamf_client_reference_CachedReference.prototype.productPrefix__T = (function() {
  return "CachedReference"
});
$c_Lamf_client_reference_CachedReference.prototype.init___Lamf_internal_reference_CachedReference = (function(_internal) {
  this.$$undinternal$1 = _internal;
  return this
});
$c_Lamf_client_reference_CachedReference.prototype.$$js$exported$prop$resolved__O = (function() {
  return this.$$undinternal$1.resolved$1
});
$c_Lamf_client_reference_CachedReference.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_reference_CachedReference.prototype.$$js$exported$prop$url__O = (function() {
  return this.$$undinternal$1.url$1
});
$c_Lamf_client_reference_CachedReference.prototype.content__Lamf_client_model_document_BaseUnit = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal$1.content$1;
  var m = $m_Lamf_client_convert_CoreClientConverters$().BaseUnitMatcher__Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$();
  return m.asClient__Lamf_core_model_document_BaseUnit__Lamf_client_model_document_BaseUnit(from)
});
$c_Lamf_client_reference_CachedReference.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_reference_CachedReference)) {
    var CachedReference$1 = $as_Lamf_client_reference_CachedReference(x$1);
    var x = this.$$undinternal$1;
    var x$2 = CachedReference$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_reference_CachedReference.prototype.$$js$exported$prop$content__O = (function() {
  return this.content__Lamf_client_model_document_BaseUnit()
});
$c_Lamf_client_reference_CachedReference.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_reference_CachedReference.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_reference_CachedReference.prototype.init___T__Lamf_client_model_document_BaseUnit__Z = (function(url, content, resolved) {
  $c_Lamf_client_reference_CachedReference.prototype.init___Lamf_internal_reference_CachedReference.call(this, new $c_Lamf_internal_reference_CachedReference().init___T__Lamf_core_model_document_BaseUnit__Z(url, content.$$undinternal__Lamf_core_model_document_BaseUnit(), resolved));
  return this
});
$c_Lamf_client_reference_CachedReference.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_reference_CachedReference.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
Object.defineProperty($c_Lamf_client_reference_CachedReference.prototype, "resolved", {
  "get": (function() {
    return this.$$js$exported$prop$resolved__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_reference_CachedReference.prototype, "content", {
  "get": (function() {
    return this.$$js$exported$prop$content__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_reference_CachedReference.prototype, "url", {
  "get": (function() {
    return this.$$js$exported$prop$url__O()
  }),
  "configurable": true
});
function $as_Lamf_client_reference_CachedReference(obj) {
  return (((obj instanceof $c_Lamf_client_reference_CachedReference) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.reference.CachedReference"))
}
function $isArrayOf_Lamf_client_reference_CachedReference(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_reference_CachedReference)))
}
function $asArrayOf_Lamf_client_reference_CachedReference(obj, depth) {
  return (($isArrayOf_Lamf_client_reference_CachedReference(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.reference.CachedReference;", depth))
}
var $d_Lamf_client_reference_CachedReference = new $TypeData().initClass({
  Lamf_client_reference_CachedReference: 0
}, false, "amf.client.reference.CachedReference", {
  Lamf_client_reference_CachedReference: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_reference_CachedReference.prototype.$classData = $d_Lamf_client_reference_CachedReference;
/** @constructor */
function $c_Lamf_client_remote_Content() {
  $c_O.call(this);
  this.stream$1 = null;
  this.url$1 = null;
  this.mime$1 = null
}
$c_Lamf_client_remote_Content.prototype = new $h_O();
$c_Lamf_client_remote_Content.prototype.constructor = $c_Lamf_client_remote_Content;
/** @constructor */
function $h_Lamf_client_remote_Content() {
  /*<skip>*/
}
$h_Lamf_client_remote_Content.prototype = $c_Lamf_client_remote_Content.prototype;
$c_Lamf_client_remote_Content.prototype.init___T__T = (function(stream, url) {
  $c_Lamf_client_remote_Content.prototype.init___Lamf_core_lexer_CharStream__T__s_Option.call(this, new $c_Lamf_core_lexer_CharSequenceStream().init___T__jl_CharSequence(url, stream), url, $m_s_None$());
  return this
});
$c_Lamf_client_remote_Content.prototype.productPrefix__T = (function() {
  return "Content"
});
$c_Lamf_client_remote_Content.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_client_remote_Content.prototype.$$js$exported$prop$url__O = (function() {
  return this.url$1
});
$c_Lamf_client_remote_Content.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_remote_Content)) {
    var Content$1 = $as_Lamf_client_remote_Content(x$1);
    var x = this.stream$1;
    var x$2 = Content$1.stream$1;
    if (((x === x$2) && (this.url$1 === Content$1.url$1))) {
      var x$3 = this.mime$1;
      var x$4 = Content$1.mime$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_client_remote_Content.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.stream$1;
      break
    }
    case 1: {
      return this.url$1;
      break
    }
    case 2: {
      return this.mime$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_remote_Content.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_remote_Content.prototype.init___T__T__T = (function(stream, url, mime) {
  $c_Lamf_client_remote_Content.prototype.init___Lamf_core_lexer_CharStream__T__s_Option.call(this, new $c_Lamf_core_lexer_CharSequenceStream().init___T__jl_CharSequence(url, stream), url, new $c_s_Some().init___O(mime));
  return this
});
$c_Lamf_client_remote_Content.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_remote_Content.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_remote_Content.prototype.init___T__T__s_Option = (function(stream, url, mime) {
  $c_Lamf_client_remote_Content.prototype.init___Lamf_core_lexer_CharStream__T__s_Option.call(this, new $c_Lamf_core_lexer_CharSequenceStream().init___T__jl_CharSequence(url, stream), url, mime);
  return this
});
$c_Lamf_client_remote_Content.prototype.init___Lamf_core_lexer_CharStream__T__s_Option = (function(stream, url, mime) {
  this.stream$1 = stream;
  this.url$1 = url;
  this.mime$1 = mime;
  return this
});
$c_Lamf_client_remote_Content.prototype.$$js$exported$prop$mime__O = (function() {
  return this.mime$1
});
$c_Lamf_client_remote_Content.prototype.$$js$exported$prop$stream__O = (function() {
  return this.stream$1
});
Object.defineProperty($c_Lamf_client_remote_Content.prototype, "mime", {
  "get": (function() {
    return this.$$js$exported$prop$mime__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_remote_Content.prototype, "url", {
  "get": (function() {
    return this.$$js$exported$prop$url__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_remote_Content.prototype, "stream", {
  "get": (function() {
    return this.$$js$exported$prop$stream__O()
  }),
  "configurable": true
});
function $as_Lamf_client_remote_Content(obj) {
  return (((obj instanceof $c_Lamf_client_remote_Content) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.remote.Content"))
}
function $isArrayOf_Lamf_client_remote_Content(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_remote_Content)))
}
function $asArrayOf_Lamf_client_remote_Content(obj, depth) {
  return (($isArrayOf_Lamf_client_remote_Content(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.remote.Content;", depth))
}
var $d_Lamf_client_remote_Content = new $TypeData().initClass({
  Lamf_client_remote_Content: 0
}, false, "amf.client.remote.Content", {
  Lamf_client_remote_Content: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_remote_Content.prototype.$classData = $d_Lamf_client_remote_Content;
/** @constructor */
function $c_Lamf_client_validate_ValidationCandidate() {
  $c_O.call(this);
  this.$$undinternal$1 = null
}
$c_Lamf_client_validate_ValidationCandidate.prototype = new $h_O();
$c_Lamf_client_validate_ValidationCandidate.prototype.constructor = $c_Lamf_client_validate_ValidationCandidate;
/** @constructor */
function $h_Lamf_client_validate_ValidationCandidate() {
  /*<skip>*/
}
$h_Lamf_client_validate_ValidationCandidate.prototype = $c_Lamf_client_validate_ValidationCandidate.prototype;
$c_Lamf_client_validate_ValidationCandidate.prototype.productPrefix__T = (function() {
  return "ValidationCandidate"
});
$c_Lamf_client_validate_ValidationCandidate.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_validate_ValidationCandidate.prototype.$$js$exported$prop$shape__O = (function() {
  return this.shape__Lamf_client_model_domain_Shape()
});
$c_Lamf_client_validate_ValidationCandidate.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_validate_ValidationCandidate)) {
    var ValidationCandidate$1 = $as_Lamf_client_validate_ValidationCandidate(x$1);
    var x = this.$$undinternal$1;
    var x$2 = ValidationCandidate$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_validate_ValidationCandidate.prototype.payload__Lamf_client_model_document_PayloadFragment = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal$1.payload$1;
  var m = $m_Lamf_client_convert_CoreClientConverters$().PayloadFragmentMatcher__Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$();
  return m.asClient__Lamf_core_model_document_PayloadFragment__Lamf_client_model_document_PayloadFragment(from)
});
$c_Lamf_client_validate_ValidationCandidate.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_validate_ValidationCandidate.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_validate_ValidationCandidate.prototype.init___Lamf_core_validation_ValidationCandidate = (function(_internal) {
  this.$$undinternal$1 = _internal;
  return this
});
$c_Lamf_client_validate_ValidationCandidate.prototype.shape__Lamf_client_model_domain_Shape = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal$1.shape$1;
  var m = $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(from)
});
$c_Lamf_client_validate_ValidationCandidate.prototype.$$js$exported$prop$payload__O = (function() {
  return this.payload__Lamf_client_model_document_PayloadFragment()
});
$c_Lamf_client_validate_ValidationCandidate.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_validate_ValidationCandidate.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_validate_ValidationCandidate.prototype.init___Lamf_client_model_domain_Shape__Lamf_client_model_document_PayloadFragment = (function(shape, payload) {
  $c_Lamf_client_validate_ValidationCandidate.prototype.init___Lamf_core_validation_ValidationCandidate.call(this, new $c_Lamf_core_validation_ValidationCandidate().init___Lamf_core_model_domain_Shape__Lamf_core_model_document_PayloadFragment(shape.$$undinternal__Lamf_core_model_domain_Shape(), $as_Lamf_core_model_document_PayloadFragment(payload.$$undinternal$1)));
  return this
});
Object.defineProperty($c_Lamf_client_validate_ValidationCandidate.prototype, "payload", {
  "get": (function() {
    return this.$$js$exported$prop$payload__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_validate_ValidationCandidate.prototype, "shape", {
  "get": (function() {
    return this.$$js$exported$prop$shape__O()
  }),
  "configurable": true
});
function $as_Lamf_client_validate_ValidationCandidate(obj) {
  return (((obj instanceof $c_Lamf_client_validate_ValidationCandidate) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.validate.ValidationCandidate"))
}
function $isArrayOf_Lamf_client_validate_ValidationCandidate(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_validate_ValidationCandidate)))
}
function $asArrayOf_Lamf_client_validate_ValidationCandidate(obj, depth) {
  return (($isArrayOf_Lamf_client_validate_ValidationCandidate(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.validate.ValidationCandidate;", depth))
}
var $d_Lamf_client_validate_ValidationCandidate = new $TypeData().initClass({
  Lamf_client_validate_ValidationCandidate: 0
}, false, "amf.client.validate.ValidationCandidate", {
  Lamf_client_validate_ValidationCandidate: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_validate_ValidationCandidate.prototype.$classData = $d_Lamf_client_validate_ValidationCandidate;
/** @constructor */
function $c_Lamf_client_validate_ValidationShapeSet() {
  $c_O.call(this);
  this.$$undinternal$1 = null
}
$c_Lamf_client_validate_ValidationShapeSet.prototype = new $h_O();
$c_Lamf_client_validate_ValidationShapeSet.prototype.constructor = $c_Lamf_client_validate_ValidationShapeSet;
/** @constructor */
function $h_Lamf_client_validate_ValidationShapeSet() {
  /*<skip>*/
}
$h_Lamf_client_validate_ValidationShapeSet.prototype = $c_Lamf_client_validate_ValidationShapeSet.prototype;
$c_Lamf_client_validate_ValidationShapeSet.prototype.productPrefix__T = (function() {
  return "ValidationShapeSet"
});
$c_Lamf_client_validate_ValidationShapeSet.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_validate_ValidationShapeSet.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_validate_ValidationShapeSet)) {
    var ValidationShapeSet$1 = $as_Lamf_client_validate_ValidationShapeSet(x$1);
    var x = this.$$undinternal$1;
    var x$2 = ValidationShapeSet$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_validate_ValidationShapeSet.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_validate_ValidationShapeSet.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_validate_ValidationShapeSet.prototype.$$js$exported$prop$candidates__O = (function() {
  return this.candidates__sjs_js_Array()
});
$c_Lamf_client_validate_ValidationShapeSet.prototype.candidates__sjs_js_Array = (function() {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal$1.candidates$1;
  var m = $m_Lamf_client_convert_CoreClientConverters$().ValidationCandidateMatcher__Lamf_client_convert_ValidationCandidateConverter$ValidationCandidateMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
});
$c_Lamf_client_validate_ValidationShapeSet.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_validate_ValidationShapeSet.prototype.init___Lamf_core_validation_ValidationShapeSet = (function(_internal) {
  this.$$undinternal$1 = _internal;
  return this
});
$c_Lamf_client_validate_ValidationShapeSet.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_validate_ValidationShapeSet.prototype.$$js$exported$prop$defaultSeverity__O = (function() {
  return this.$$undinternal$1.defaultSeverity$1
});
$c_Lamf_client_validate_ValidationShapeSet.prototype.init___sjs_js_Array__sjs_js_Array__T = (function(candidates, closure, defaultSeverity) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var m = $m_Lamf_client_convert_CoreClientConverters$().ValidationCandidateMatcher__Lamf_client_convert_ValidationCandidateConverter$ValidationCandidateMatcher$();
  $c_Lamf_client_validate_ValidationShapeSet.prototype.init___Lamf_core_validation_ValidationShapeSet.call(this, new $c_Lamf_core_validation_ValidationShapeSet().init___sc_Seq__T(new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, candidates, m).asInternal__sc_Seq(), defaultSeverity));
  return this
});
Object.defineProperty($c_Lamf_client_validate_ValidationShapeSet.prototype, "defaultSeverity", {
  "get": (function() {
    return this.$$js$exported$prop$defaultSeverity__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_validate_ValidationShapeSet.prototype, "candidates", {
  "get": (function() {
    return this.$$js$exported$prop$candidates__O()
  }),
  "configurable": true
});
function $as_Lamf_client_validate_ValidationShapeSet(obj) {
  return (((obj instanceof $c_Lamf_client_validate_ValidationShapeSet) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.validate.ValidationShapeSet"))
}
function $isArrayOf_Lamf_client_validate_ValidationShapeSet(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_validate_ValidationShapeSet)))
}
function $asArrayOf_Lamf_client_validate_ValidationShapeSet(obj, depth) {
  return (($isArrayOf_Lamf_client_validate_ValidationShapeSet(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.validate.ValidationShapeSet;", depth))
}
var $d_Lamf_client_validate_ValidationShapeSet = new $TypeData().initClass({
  Lamf_client_validate_ValidationShapeSet: 0
}, false, "amf.client.validate.ValidationShapeSet", {
  Lamf_client_validate_ValidationShapeSet: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_validate_ValidationShapeSet.prototype.$classData = $d_Lamf_client_validate_ValidationShapeSet;
/** @constructor */
function $c_Lamf_core_Root() {
  $c_O.call(this);
  this.parsed$1 = null;
  this.location$1 = null;
  this.mediatype$1 = null;
  this.references$1 = null;
  this.referenceKind$1 = null;
  this.raw$1 = null
}
$c_Lamf_core_Root.prototype = new $h_O();
$c_Lamf_core_Root.prototype.constructor = $c_Lamf_core_Root;
/** @constructor */
function $h_Lamf_core_Root() {
  /*<skip>*/
}
$h_Lamf_core_Root.prototype = $c_Lamf_core_Root.prototype;
$c_Lamf_core_Root.prototype.productPrefix__T = (function() {
  return "Root"
});
$c_Lamf_core_Root.prototype.productArity__I = (function() {
  return 6
});
$c_Lamf_core_Root.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_Root)) {
    var Root$1 = $as_Lamf_core_Root(x$1);
    var x = this.parsed$1;
    var x$2 = Root$1.parsed$1;
    if (((((x === null) ? (x$2 === null) : x.equals__O__Z(x$2)) && (this.location$1 === Root$1.location$1)) && (this.mediatype$1 === Root$1.mediatype$1))) {
      var x$3 = this.references$1;
      var x$4 = Root$1.references$1;
      var jsx$2 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.referenceKind$1;
      var x$6 = Root$1.referenceKind$1;
      var jsx$1 = (x$5 === x$6)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.raw$1 === Root$1.raw$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_Root.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.parsed$1;
      break
    }
    case 1: {
      return this.location$1;
      break
    }
    case 2: {
      return this.mediatype$1;
      break
    }
    case 3: {
      return this.references$1;
      break
    }
    case 4: {
      return this.referenceKind$1;
      break
    }
    case 5: {
      return this.raw$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_Root.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_Root.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_Root.prototype.init___Lamf_core_parser_ParsedDocument__T__T__sc_Seq__Lamf_core_parser_ReferenceKind__T = (function(parsed, location, mediatype, references, referenceKind, raw) {
  this.parsed$1 = parsed;
  this.location$1 = location;
  this.mediatype$1 = mediatype;
  this.references$1 = references;
  this.referenceKind$1 = referenceKind;
  this.raw$1 = raw;
  return this
});
$c_Lamf_core_Root.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_Root(obj) {
  return (((obj instanceof $c_Lamf_core_Root) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.Root"))
}
function $isArrayOf_Lamf_core_Root(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_Root)))
}
function $asArrayOf_Lamf_core_Root(obj, depth) {
  return (($isArrayOf_Lamf_core_Root(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.Root;", depth))
}
var $d_Lamf_core_Root = new $TypeData().initClass({
  Lamf_core_Root: 0
}, false, "amf.core.Root", {
  Lamf_core_Root: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_Root.prototype.$classData = $d_Lamf_core_Root;
/** @constructor */
function $c_Lamf_core_annotations_DomainExtensionAnnotation$() {
  $c_sr_AbstractFunction1.call(this)
}
$c_Lamf_core_annotations_DomainExtensionAnnotation$.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_core_annotations_DomainExtensionAnnotation$.prototype.constructor = $c_Lamf_core_annotations_DomainExtensionAnnotation$;
/** @constructor */
function $h_Lamf_core_annotations_DomainExtensionAnnotation$() {
  /*<skip>*/
}
$h_Lamf_core_annotations_DomainExtensionAnnotation$.prototype = $c_Lamf_core_annotations_DomainExtensionAnnotation$.prototype;
$c_Lamf_core_annotations_DomainExtensionAnnotation$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_DomainExtensionAnnotation$.prototype.apply__O__O = (function(v1) {
  var extension = $as_Lamf_core_model_domain_extensions_DomainExtension(v1);
  return new $c_Lamf_core_annotations_DomainExtensionAnnotation().init___Lamf_core_model_domain_extensions_DomainExtension(extension)
});
$c_Lamf_core_annotations_DomainExtensionAnnotation$.prototype.toString__T = (function() {
  return "DomainExtensionAnnotation"
});
var $d_Lamf_core_annotations_DomainExtensionAnnotation$ = new $TypeData().initClass({
  Lamf_core_annotations_DomainExtensionAnnotation$: 0
}, false, "amf.core.annotations.DomainExtensionAnnotation$", {
  Lamf_core_annotations_DomainExtensionAnnotation$: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_DomainExtensionAnnotation$.prototype.$classData = $d_Lamf_core_annotations_DomainExtensionAnnotation$;
var $n_Lamf_core_annotations_DomainExtensionAnnotation$ = (void 0);
function $m_Lamf_core_annotations_DomainExtensionAnnotation$() {
  if ((!$n_Lamf_core_annotations_DomainExtensionAnnotation$)) {
    $n_Lamf_core_annotations_DomainExtensionAnnotation$ = new $c_Lamf_core_annotations_DomainExtensionAnnotation$().init___()
  };
  return $n_Lamf_core_annotations_DomainExtensionAnnotation$
}
/** @constructor */
function $c_Lamf_core_annotations_ErrorDeclaration$$anon$1() {
  $c_O.call(this);
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0;
  this.$$outer$1 = null
}
$c_Lamf_core_annotations_ErrorDeclaration$$anon$1.prototype = new $h_O();
$c_Lamf_core_annotations_ErrorDeclaration$$anon$1.prototype.constructor = $c_Lamf_core_annotations_ErrorDeclaration$$anon$1;
/** @constructor */
function $h_Lamf_core_annotations_ErrorDeclaration$$anon$1() {
  /*<skip>*/
}
$h_Lamf_core_annotations_ErrorDeclaration$$anon$1.prototype = $c_Lamf_core_annotations_ErrorDeclaration$$anon$1.prototype;
$c_Lamf_core_annotations_ErrorDeclaration$$anon$1.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_core_annotations_ErrorDeclaration$$anon$1.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_annotations_ErrorDeclaration$$anon$1.prototype.init___Lamf_core_annotations_ErrorDeclaration = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  this.type$1 = $$outer.originalMeta__Lamf_core_metamodel_Obj().type__sci_List();
  this.doc$1 = $$outer.originalMeta__Lamf_core_metamodel_Obj().doc__Lamf_core_metamodel_domain_ModelDoc();
  return this
});
$c_Lamf_core_annotations_ErrorDeclaration$$anon$1.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_annotations_ErrorDeclaration$$anon$1.prototype.fields__sci_List = (function() {
  return this.$$outer$1.originalMeta__Lamf_core_metamodel_Obj().fields__sci_List()
});
$c_Lamf_core_annotations_ErrorDeclaration$$anon$1.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_core_annotations_ErrorDeclaration$$anon$1.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$outer$1.newErrorInstance__Lamf_core_annotations_ErrorDeclaration()
});
$c_Lamf_core_annotations_ErrorDeclaration$$anon$1.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_core_annotations_ErrorDeclaration$$anon$1 = new $TypeData().initClass({
  Lamf_core_annotations_ErrorDeclaration$$anon$1: 0
}, false, "amf.core.annotations.ErrorDeclaration$$anon$1", {
  Lamf_core_annotations_ErrorDeclaration$$anon$1: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_core_annotations_ErrorDeclaration$$anon$1.prototype.$classData = $d_Lamf_core_annotations_ErrorDeclaration$$anon$1;
/** @constructor */
function $c_Lamf_core_benchmark_Execution() {
  $c_O.call(this);
  this.startTime$1 = $m_sjsr_RuntimeLong$().Zero__sjsr_RuntimeLong();
  this.endTime$1 = $m_sjsr_RuntimeLong$().Zero__sjsr_RuntimeLong();
  this.logs$1 = null
}
$c_Lamf_core_benchmark_Execution.prototype = new $h_O();
$c_Lamf_core_benchmark_Execution.prototype.constructor = $c_Lamf_core_benchmark_Execution;
/** @constructor */
function $h_Lamf_core_benchmark_Execution() {
  /*<skip>*/
}
$h_Lamf_core_benchmark_Execution.prototype = $c_Lamf_core_benchmark_Execution.prototype;
$c_Lamf_core_benchmark_Execution.prototype.productPrefix__T = (function() {
  return "Execution"
});
$c_Lamf_core_benchmark_Execution.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_core_benchmark_Execution.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_benchmark_Execution)) {
    var Execution$1 = $as_Lamf_core_benchmark_Execution(x$1);
    var t = this.startTime$1;
    var lo = t.lo$2;
    var hi = t.hi$2;
    var b = Execution$1.startTime$1;
    if (((lo === b.lo$2) && (hi === b.hi$2))) {
      var t$1 = this.endTime$1;
      var lo$1 = t$1.lo$2;
      var hi$1 = t$1.hi$2;
      var b$1 = Execution$1.endTime$1;
      var jsx$1 = ((lo$1 === b$1.lo$2) && (hi$1 === b$1.hi$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x = this.logs$1;
      var x$2 = Execution$1.logs$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_benchmark_Execution.prototype.init___J__J__sc_Seq = (function(startTime, endTime, logs) {
  this.startTime$1 = startTime;
  this.endTime$1 = endTime;
  this.logs$1 = logs;
  return this
});
$c_Lamf_core_benchmark_Execution.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.startTime$1;
      break
    }
    case 1: {
      return this.endTime$1;
      break
    }
    case 2: {
      return this.logs$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_benchmark_Execution.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_benchmark_Execution.prototype.log__T__J__Lamf_core_benchmark_Execution = (function(stage, time) {
  var jsx$3 = this.logs$1;
  var jsx$2 = $m_sc_Seq$();
  var array = [new $c_Lamf_core_benchmark_Log().init___T__J(stage, time)];
  var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
  var this$3 = $m_sc_Seq$();
  var x$1 = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
  var t = this.startTime$1;
  var lo = t.lo$2;
  var hi = t.hi$2;
  return new $c_Lamf_core_benchmark_Execution().init___J__J__sc_Seq(new $c_sjsr_RuntimeLong().init___I__I(lo, hi), time, x$1)
});
$c_Lamf_core_benchmark_Execution.prototype.finish__Lamf_core_benchmark_Execution = (function() {
  var t = new $c_ju_Date().init___().getTime__J();
  var lo = t.lo$2;
  var hi = t.hi$2;
  var t$1 = this.startTime$1;
  var lo$1 = t$1.lo$2;
  var hi$1 = t$1.hi$2;
  var x$3 = this.logs$1;
  return new $c_Lamf_core_benchmark_Execution().init___J__J__sc_Seq(new $c_sjsr_RuntimeLong().init___I__I(lo$1, hi$1), new $c_sjsr_RuntimeLong().init___I__I(lo, hi), x$3)
});
$c_Lamf_core_benchmark_Execution.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().longHash__J__I(this.startTime$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().longHash__J__I(this.endTime$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.logs$1));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 3)
});
$c_Lamf_core_benchmark_Execution.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_benchmark_Execution(obj) {
  return (((obj instanceof $c_Lamf_core_benchmark_Execution) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.benchmark.Execution"))
}
function $isArrayOf_Lamf_core_benchmark_Execution(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_benchmark_Execution)))
}
function $asArrayOf_Lamf_core_benchmark_Execution(obj, depth) {
  return (($isArrayOf_Lamf_core_benchmark_Execution(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.benchmark.Execution;", depth))
}
var $d_Lamf_core_benchmark_Execution = new $TypeData().initClass({
  Lamf_core_benchmark_Execution: 0
}, false, "amf.core.benchmark.Execution", {
  Lamf_core_benchmark_Execution: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_benchmark_Execution.prototype.$classData = $d_Lamf_core_benchmark_Execution;
/** @constructor */
function $c_Lamf_core_benchmark_Log() {
  $c_O.call(this);
  this.stage$1 = null;
  this.time$1 = $m_sjsr_RuntimeLong$().Zero__sjsr_RuntimeLong()
}
$c_Lamf_core_benchmark_Log.prototype = new $h_O();
$c_Lamf_core_benchmark_Log.prototype.constructor = $c_Lamf_core_benchmark_Log;
/** @constructor */
function $h_Lamf_core_benchmark_Log() {
  /*<skip>*/
}
$h_Lamf_core_benchmark_Log.prototype = $c_Lamf_core_benchmark_Log.prototype;
$c_Lamf_core_benchmark_Log.prototype.productPrefix__T = (function() {
  return "Log"
});
$c_Lamf_core_benchmark_Log.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_benchmark_Log.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_benchmark_Log)) {
    var Log$1 = $as_Lamf_core_benchmark_Log(x$1);
    if ((this.stage$1 === Log$1.stage$1)) {
      var t = this.time$1;
      var lo = t.lo$2;
      var hi = t.hi$2;
      var b = Log$1.time$1;
      return ((lo === b.lo$2) && (hi === b.hi$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_benchmark_Log.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.stage$1;
      break
    }
    case 1: {
      return this.time$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_benchmark_Log.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_benchmark_Log.prototype.init___T__J = (function(stage, time) {
  this.stage$1 = stage;
  this.time$1 = time;
  return this
});
$c_Lamf_core_benchmark_Log.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.stage$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().longHash__J__I(this.time$1));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 2)
});
$c_Lamf_core_benchmark_Log.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_benchmark_Log(obj) {
  return (((obj instanceof $c_Lamf_core_benchmark_Log) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.benchmark.Log"))
}
function $isArrayOf_Lamf_core_benchmark_Log(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_benchmark_Log)))
}
function $asArrayOf_Lamf_core_benchmark_Log(obj, depth) {
  return (($isArrayOf_Lamf_core_benchmark_Log(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.benchmark.Log;", depth))
}
var $d_Lamf_core_benchmark_Log = new $TypeData().initClass({
  Lamf_core_benchmark_Log: 0
}, false, "amf.core.benchmark.Log", {
  Lamf_core_benchmark_Log: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_benchmark_Log.prototype.$classData = $d_Lamf_core_benchmark_Log;
/** @constructor */
function $c_Lamf_core_client_ParserConfig() {
  $c_O.call(this);
  this.mode$1 = null;
  this.input$1 = null;
  this.inputFormat$1 = null;
  this.inputMediaType$1 = null;
  this.output$1 = null;
  this.outputFormat$1 = null;
  this.outputMediaType$1 = null;
  this.withSourceMaps$1 = false;
  this.withCompactNamespaces$1 = false;
  this.validate$1 = false;
  this.trace$1 = false;
  this.patchTarget$1 = null;
  this.validationProfile$1 = null;
  this.customProfile$1 = null;
  this.resolve$1 = false;
  this.dialects$1 = null;
  this.stdout$1 = null;
  this.stderr$1 = null;
  this.proc$1 = null;
  this.profile$1 = null
}
$c_Lamf_core_client_ParserConfig.prototype = new $h_O();
$c_Lamf_core_client_ParserConfig.prototype.constructor = $c_Lamf_core_client_ParserConfig;
/** @constructor */
function $h_Lamf_core_client_ParserConfig() {
  /*<skip>*/
}
$h_Lamf_core_client_ParserConfig.prototype = $c_Lamf_core_client_ParserConfig.prototype;
$c_Lamf_core_client_ParserConfig.prototype.productPrefix__T = (function() {
  return "ParserConfig"
});
$c_Lamf_core_client_ParserConfig.prototype.productArity__I = (function() {
  return 19
});
$c_Lamf_core_client_ParserConfig.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_client_ParserConfig)) {
    var ParserConfig$1 = $as_Lamf_core_client_ParserConfig(x$1);
    var x = this.mode$1;
    var x$2 = ParserConfig$1.mode$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.input$1;
      var x$4 = ParserConfig$1.input$1;
      var jsx$11 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$11 = false
    };
    if (jsx$11) {
      var x$5 = this.inputFormat$1;
      var x$6 = ParserConfig$1.inputFormat$1;
      var jsx$10 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$10 = false
    };
    if (jsx$10) {
      var x$7 = this.inputMediaType$1;
      var x$8 = ParserConfig$1.inputMediaType$1;
      var jsx$9 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$9 = false
    };
    if (jsx$9) {
      var x$9 = this.output$1;
      var x$10 = ParserConfig$1.output$1;
      var jsx$8 = ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      var jsx$8 = false
    };
    if (jsx$8) {
      var x$11 = this.outputFormat$1;
      var x$12 = ParserConfig$1.outputFormat$1;
      var jsx$7 = ((x$11 === null) ? (x$12 === null) : x$11.equals__O__Z(x$12))
    } else {
      var jsx$7 = false
    };
    if (jsx$7) {
      var x$13 = this.outputMediaType$1;
      var x$14 = ParserConfig$1.outputMediaType$1;
      var jsx$6 = ((x$13 === null) ? (x$14 === null) : x$13.equals__O__Z(x$14))
    } else {
      var jsx$6 = false
    };
    if (((((jsx$6 && (this.withSourceMaps$1 === ParserConfig$1.withSourceMaps$1)) && (this.withCompactNamespaces$1 === ParserConfig$1.withCompactNamespaces$1)) && (this.validate$1 === ParserConfig$1.validate$1)) && (this.trace$1 === ParserConfig$1.trace$1))) {
      var x$15 = this.patchTarget$1;
      var x$16 = ParserConfig$1.patchTarget$1;
      var jsx$5 = ((x$15 === null) ? (x$16 === null) : x$15.equals__O__Z(x$16))
    } else {
      var jsx$5 = false
    };
    if ((jsx$5 && (this.validationProfile$1 === ParserConfig$1.validationProfile$1))) {
      var x$17 = this.customProfile$1;
      var x$18 = ParserConfig$1.customProfile$1;
      var jsx$4 = ((x$17 === null) ? (x$18 === null) : x$17.equals__O__Z(x$18))
    } else {
      var jsx$4 = false
    };
    if ((jsx$4 && (this.resolve$1 === ParserConfig$1.resolve$1))) {
      var x$19 = this.dialects$1;
      var x$20 = ParserConfig$1.dialects$1;
      var jsx$3 = ((x$19 === null) ? (x$20 === null) : x$19.equals__O__Z(x$20))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$21 = this.stdout$1;
      var x$22 = ParserConfig$1.stdout$1;
      var jsx$2 = (x$21 === x$22)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$23 = this.stderr$1;
      var x$24 = ParserConfig$1.stderr$1;
      var jsx$1 = (x$23 === x$24)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$25 = this.proc$1;
      var x$26 = ParserConfig$1.proc$1;
      return (x$25 === x$26)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_client_ParserConfig.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.mode$1;
      break
    }
    case 1: {
      return this.input$1;
      break
    }
    case 2: {
      return this.inputFormat$1;
      break
    }
    case 3: {
      return this.inputMediaType$1;
      break
    }
    case 4: {
      return this.output$1;
      break
    }
    case 5: {
      return this.outputFormat$1;
      break
    }
    case 6: {
      return this.outputMediaType$1;
      break
    }
    case 7: {
      return this.withSourceMaps$1;
      break
    }
    case 8: {
      return this.withCompactNamespaces$1;
      break
    }
    case 9: {
      return this.validate$1;
      break
    }
    case 10: {
      return this.trace$1;
      break
    }
    case 11: {
      return this.patchTarget$1;
      break
    }
    case 12: {
      return this.validationProfile$1;
      break
    }
    case 13: {
      return this.customProfile$1;
      break
    }
    case 14: {
      return this.resolve$1;
      break
    }
    case 15: {
      return this.dialects$1;
      break
    }
    case 16: {
      return this.stdout$1;
      break
    }
    case 17: {
      return this.stderr$1;
      break
    }
    case 18: {
      return this.proc$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_client_ParserConfig.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_client_ParserConfig.prototype.init___s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__Z__Z__Z__Z__s_Option__T__s_Option__Z__sc_Seq__Lamf_core_client_ProcWriter__Lamf_core_client_ProcWriter__Lamf_core_client_Proc = (function(mode, input, inputFormat, inputMediaType, output, outputFormat, outputMediaType, withSourceMaps, withCompactNamespaces, validate, trace, patchTarget, validationProfile, customProfile, resolve, dialects, stdout, stderr, proc) {
  this.mode$1 = mode;
  this.input$1 = input;
  this.inputFormat$1 = inputFormat;
  this.inputMediaType$1 = inputMediaType;
  this.output$1 = output;
  this.outputFormat$1 = outputFormat;
  this.outputMediaType$1 = outputMediaType;
  this.withSourceMaps$1 = withSourceMaps;
  this.withCompactNamespaces$1 = withCompactNamespaces;
  this.validate$1 = validate;
  this.trace$1 = trace;
  this.patchTarget$1 = patchTarget;
  this.validationProfile$1 = validationProfile;
  this.customProfile$1 = customProfile;
  this.resolve$1 = resolve;
  this.dialects$1 = dialects;
  this.stdout$1 = stdout;
  this.stderr$1 = stderr;
  this.proc$1 = proc;
  this.profile$1 = $m_Lamf_ProfileName$().apply__T__Lamf_ProfileName(validationProfile);
  return this
});
$c_Lamf_core_client_ParserConfig.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.mode$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.input$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.inputFormat$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.inputMediaType$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.output$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.outputFormat$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.outputMediaType$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.withSourceMaps$1 ? 1231 : 1237));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.withCompactNamespaces$1 ? 1231 : 1237));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.validate$1 ? 1231 : 1237));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.trace$1 ? 1231 : 1237));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.patchTarget$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.validationProfile$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.customProfile$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.resolve$1 ? 1231 : 1237));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.dialects$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.stdout$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.stderr$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.proc$1));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 19)
});
$c_Lamf_core_client_ParserConfig.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_client_ParserConfig(obj) {
  return (((obj instanceof $c_Lamf_core_client_ParserConfig) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.client.ParserConfig"))
}
function $isArrayOf_Lamf_core_client_ParserConfig(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_client_ParserConfig)))
}
function $asArrayOf_Lamf_core_client_ParserConfig(obj, depth) {
  return (($isArrayOf_Lamf_core_client_ParserConfig(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.client.ParserConfig;", depth))
}
var $d_Lamf_core_client_ParserConfig = new $TypeData().initClass({
  Lamf_core_client_ParserConfig: 0
}, false, "amf.core.client.ParserConfig", {
  Lamf_core_client_ParserConfig: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_client_ParserConfig.prototype.$classData = $d_Lamf_core_client_ParserConfig;
/** @constructor */
function $c_Lamf_core_exception_CyclicReferenceException() {
  $c_jl_RuntimeException.call(this);
  this.history$4 = null
}
$c_Lamf_core_exception_CyclicReferenceException.prototype = new $h_jl_RuntimeException();
$c_Lamf_core_exception_CyclicReferenceException.prototype.constructor = $c_Lamf_core_exception_CyclicReferenceException;
/** @constructor */
function $h_Lamf_core_exception_CyclicReferenceException() {
  /*<skip>*/
}
$h_Lamf_core_exception_CyclicReferenceException.prototype = $c_Lamf_core_exception_CyclicReferenceException.prototype;
$c_Lamf_core_exception_CyclicReferenceException.prototype.init___sci_List = (function(history) {
  this.history$4 = history;
  var s = ("Cyclic found following references " + $f_sc_TraversableOnce__mkString__T__T__T__T(history, "", " -> ", ""));
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
function $as_Lamf_core_exception_CyclicReferenceException(obj) {
  return (((obj instanceof $c_Lamf_core_exception_CyclicReferenceException) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.exception.CyclicReferenceException"))
}
function $isArrayOf_Lamf_core_exception_CyclicReferenceException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_exception_CyclicReferenceException)))
}
function $asArrayOf_Lamf_core_exception_CyclicReferenceException(obj, depth) {
  return (($isArrayOf_Lamf_core_exception_CyclicReferenceException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.exception.CyclicReferenceException;", depth))
}
var $d_Lamf_core_exception_CyclicReferenceException = new $TypeData().initClass({
  Lamf_core_exception_CyclicReferenceException: 0
}, false, "amf.core.exception.CyclicReferenceException", {
  Lamf_core_exception_CyclicReferenceException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_exception_CyclicReferenceException.prototype.$classData = $d_Lamf_core_exception_CyclicReferenceException;
/** @constructor */
function $c_Lamf_core_exception_UnsupportedMediaTypeException() {
  $c_jl_RuntimeException.call(this);
  this.mime$4 = null
}
$c_Lamf_core_exception_UnsupportedMediaTypeException.prototype = new $h_jl_RuntimeException();
$c_Lamf_core_exception_UnsupportedMediaTypeException.prototype.constructor = $c_Lamf_core_exception_UnsupportedMediaTypeException;
/** @constructor */
function $h_Lamf_core_exception_UnsupportedMediaTypeException() {
  /*<skip>*/
}
$h_Lamf_core_exception_UnsupportedMediaTypeException.prototype = $c_Lamf_core_exception_UnsupportedMediaTypeException.prototype;
$c_Lamf_core_exception_UnsupportedMediaTypeException.prototype.init___T = (function(mime) {
  this.mime$4 = mime;
  var s = ("Cannot parse document with specified media type: " + mime);
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
var $d_Lamf_core_exception_UnsupportedMediaTypeException = new $TypeData().initClass({
  Lamf_core_exception_UnsupportedMediaTypeException: 0
}, false, "amf.core.exception.UnsupportedMediaTypeException", {
  Lamf_core_exception_UnsupportedMediaTypeException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_exception_UnsupportedMediaTypeException.prototype.$classData = $d_Lamf_core_exception_UnsupportedMediaTypeException;
/** @constructor */
function $c_Lamf_core_exception_UnsupportedVendorException() {
  $c_jl_RuntimeException.call(this);
  this.vendor$4 = null
}
$c_Lamf_core_exception_UnsupportedVendorException.prototype = new $h_jl_RuntimeException();
$c_Lamf_core_exception_UnsupportedVendorException.prototype.constructor = $c_Lamf_core_exception_UnsupportedVendorException;
/** @constructor */
function $h_Lamf_core_exception_UnsupportedVendorException() {
  /*<skip>*/
}
$h_Lamf_core_exception_UnsupportedVendorException.prototype = $c_Lamf_core_exception_UnsupportedVendorException.prototype;
$c_Lamf_core_exception_UnsupportedVendorException.prototype.init___T = (function(vendor) {
  this.vendor$4 = vendor;
  var s = ("Cannot parse document with specified vendor: " + vendor);
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
var $d_Lamf_core_exception_UnsupportedVendorException = new $TypeData().initClass({
  Lamf_core_exception_UnsupportedVendorException: 0
}, false, "amf.core.exception.UnsupportedVendorException", {
  Lamf_core_exception_UnsupportedVendorException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_exception_UnsupportedVendorException.prototype.$classData = $d_Lamf_core_exception_UnsupportedVendorException;
/** @constructor */
function $c_Lamf_core_execution_ExecutionEnvironment() {
  $c_O.call(this);
  this.context$1 = null
}
$c_Lamf_core_execution_ExecutionEnvironment.prototype = new $h_O();
$c_Lamf_core_execution_ExecutionEnvironment.prototype.constructor = $c_Lamf_core_execution_ExecutionEnvironment;
/** @constructor */
function $h_Lamf_core_execution_ExecutionEnvironment() {
  /*<skip>*/
}
$h_Lamf_core_execution_ExecutionEnvironment.prototype = $c_Lamf_core_execution_ExecutionEnvironment.prototype;
$c_Lamf_core_execution_ExecutionEnvironment.prototype.productPrefix__T = (function() {
  return "ExecutionEnvironment"
});
$c_Lamf_core_execution_ExecutionEnvironment.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_execution_ExecutionEnvironment.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_execution_ExecutionEnvironment)) {
    var ExecutionEnvironment$1 = $as_Lamf_core_execution_ExecutionEnvironment(x$1);
    var x = this.context$1;
    var x$2 = ExecutionEnvironment$1.context$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_core_execution_ExecutionEnvironment.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.context$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_execution_ExecutionEnvironment.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_execution_ExecutionEnvironment.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_execution_ExecutionEnvironment.prototype.init___s_concurrent_ExecutionContext = (function(context) {
  this.context$1 = context;
  return this
});
$c_Lamf_core_execution_ExecutionEnvironment.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_execution_ExecutionEnvironment(obj) {
  return (((obj instanceof $c_Lamf_core_execution_ExecutionEnvironment) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.execution.ExecutionEnvironment"))
}
function $isArrayOf_Lamf_core_execution_ExecutionEnvironment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_execution_ExecutionEnvironment)))
}
function $asArrayOf_Lamf_core_execution_ExecutionEnvironment(obj, depth) {
  return (($isArrayOf_Lamf_core_execution_ExecutionEnvironment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.execution.ExecutionEnvironment;", depth))
}
var $d_Lamf_core_execution_ExecutionEnvironment = new $TypeData().initClass({
  Lamf_core_execution_ExecutionEnvironment: 0
}, false, "amf.core.execution.ExecutionEnvironment", {
  Lamf_core_execution_ExecutionEnvironment: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_execution_ExecutionEnvironment.prototype.$classData = $d_Lamf_core_execution_ExecutionEnvironment;
/** @constructor */
function $c_Lamf_core_metamodel_Field() {
  $c_O.call(this);
  this.type$1 = null;
  this.value$1 = null;
  this.doc$1 = null;
  this.jsonldField$1 = false
}
$c_Lamf_core_metamodel_Field.prototype = new $h_O();
$c_Lamf_core_metamodel_Field.prototype.constructor = $c_Lamf_core_metamodel_Field;
/** @constructor */
function $h_Lamf_core_metamodel_Field() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_Field.prototype = $c_Lamf_core_metamodel_Field.prototype;
$c_Lamf_core_metamodel_Field.prototype.productPrefix__T = (function() {
  return "Field"
});
$c_Lamf_core_metamodel_Field.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_core_metamodel_Field.prototype.equals__O__Z = (function(that) {
  if ((that instanceof $c_Lamf_core_metamodel_Field)) {
    var x2 = $as_Lamf_core_metamodel_Field(that);
    return (x2.value$1.iri__T() === this.value$1.iri__T())
  } else {
    return false
  }
});
$c_Lamf_core_metamodel_Field.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.type$1;
      break
    }
    case 1: {
      return this.value$1;
      break
    }
    case 2: {
      return this.doc$1;
      break
    }
    case 3: {
      return this.jsonldField$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_metamodel_Field.prototype.toString__T = (function() {
  return this.value$1.iri__T()
});
$c_Lamf_core_metamodel_Field.prototype.init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z = (function(type, value, doc, jsonldField) {
  this.type$1 = type;
  this.value$1 = value;
  this.doc$1 = doc;
  this.jsonldField$1 = jsonldField;
  return this
});
$c_Lamf_core_metamodel_Field.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.type$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.value$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.doc$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.jsonldField$1 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 4)
});
$c_Lamf_core_metamodel_Field.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_metamodel_Field(obj) {
  return (((obj instanceof $c_Lamf_core_metamodel_Field) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.metamodel.Field"))
}
function $isArrayOf_Lamf_core_metamodel_Field(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_metamodel_Field)))
}
function $asArrayOf_Lamf_core_metamodel_Field(obj, depth) {
  return (($isArrayOf_Lamf_core_metamodel_Field(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.metamodel.Field;", depth))
}
var $d_Lamf_core_metamodel_Field = new $TypeData().initClass({
  Lamf_core_metamodel_Field: 0
}, false, "amf.core.metamodel.Field", {
  Lamf_core_metamodel_Field: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_metamodel_Field.prototype.$classData = $d_Lamf_core_metamodel_Field;
/** @constructor */
function $c_Lamf_core_metamodel_document_BaseUnitModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null
}
$c_Lamf_core_metamodel_document_BaseUnitModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_document_BaseUnitModel$.prototype.constructor = $c_Lamf_core_metamodel_document_BaseUnitModel$;
/** @constructor */
function $h_Lamf_core_metamodel_document_BaseUnitModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_document_BaseUnitModel$.prototype = $c_Lamf_core_metamodel_document_BaseUnitModel$.prototype;
$c_Lamf_core_metamodel_document_BaseUnitModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_document_BaseUnitModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $m_sci_List$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "Unit")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  this.type$1 = result;
  $m_sci_List$();
  var array$1 = [this.ModelVersion$1, this.References$1, this.Usage$1, this.DescribedBy$1, this.Root$1];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$10 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$10);
    i$1 = (((-1) + i$1) | 0)
  };
  this.fields$1 = result$1;
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "Base Unit", "Base class for every single document model unit. After parsing a document the parser generate parsing Units. Units encode the domain elements and can reference other units to re-use descriptions.", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_document_BaseUnitModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_core_metamodel_document_BaseUnitModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_core_metamodel_document_BaseUnitModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_document_BaseUnitModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_document_BaseUnitModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_core_metamodel_document_BaseUnitModel$.prototype.modelInstance__sr_Nothing$ = (function() {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("BaseUnit is an abstract class"))
});
$c_Lamf_core_metamodel_document_BaseUnitModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_core_metamodel_document_BaseUnitModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  this.modelInstance__sr_Nothing$()
});
$c_Lamf_core_metamodel_document_BaseUnitModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_core_metamodel_document_BaseUnitModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_core_metamodel_document_BaseUnitModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_core_metamodel_document_BaseUnitModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_core_metamodel_document_BaseUnitModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_document_BaseUnitModel$: 0
}, false, "amf.core.metamodel.document.BaseUnitModel$", {
  Lamf_core_metamodel_document_BaseUnitModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_core_metamodel_document_BaseUnitModel$.prototype.$classData = $d_Lamf_core_metamodel_document_BaseUnitModel$;
var $n_Lamf_core_metamodel_document_BaseUnitModel$ = (void 0);
function $m_Lamf_core_metamodel_document_BaseUnitModel$() {
  if ((!$n_Lamf_core_metamodel_document_BaseUnitModel$)) {
    $n_Lamf_core_metamodel_document_BaseUnitModel$ = new $c_Lamf_core_metamodel_document_BaseUnitModel$().init___()
  };
  return $n_Lamf_core_metamodel_document_BaseUnitModel$
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_ArrayNodeModel$() {
  $c_O.call(this);
  this.Member$1 = null;
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_core_metamodel_domain_ArrayNodeModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_ArrayNodeModel$.prototype.constructor = $c_Lamf_core_metamodel_domain_ArrayNodeModel$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_ArrayNodeModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_ArrayNodeModel$.prototype = $c_Lamf_core_metamodel_domain_ArrayNodeModel$.prototype;
$c_Lamf_core_metamodel_domain_ArrayNodeModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_ArrayNodeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_domain_DataNodeModel$());
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Rdfs$1;
  this.Member$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "member"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Rdf$1, "member", "", $m_sci_Nil$()), true);
  var x$6 = this.Member$1;
  var this$4 = $m_Lamf_core_metamodel_domain_DataNodeModel$().fields$1;
  this.fields$1 = new $c_sci_$colon$colon().init___O__sci_List(x$6, this$4);
  var this$5 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
  var x$8 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$5, "Array");
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
  var x$7 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "Seq");
  var this$9 = $m_Lamf_core_metamodel_domain_DataNodeModel$().type$1;
  var this$10 = new $c_sci_$colon$colon().init___O__sci_List(x$7, this$9);
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$8, this$10);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Data$1, "Array Node", "Node that represents a dynamic array data structure", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_domain_ArrayNodeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_core_metamodel_domain_ArrayNodeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_domain_ArrayNodeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_domain_ArrayNodeModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_core_metamodel_domain_ArrayNodeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_core_metamodel_domain_ArrayNodeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_model_domain_ArrayNode$();
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_core_model_domain_ArrayNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_core_metamodel_domain_ArrayNodeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_core_metamodel_domain_ArrayNodeModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_ArrayNodeModel$: 0
}, false, "amf.core.metamodel.domain.ArrayNodeModel$", {
  Lamf_core_metamodel_domain_ArrayNodeModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_core_metamodel_domain_ArrayNodeModel$.prototype.$classData = $d_Lamf_core_metamodel_domain_ArrayNodeModel$;
var $n_Lamf_core_metamodel_domain_ArrayNodeModel$ = (void 0);
function $m_Lamf_core_metamodel_domain_ArrayNodeModel$() {
  if ((!$n_Lamf_core_metamodel_domain_ArrayNodeModel$)) {
    $n_Lamf_core_metamodel_domain_ArrayNodeModel$ = new $c_Lamf_core_metamodel_domain_ArrayNodeModel$().init___()
  };
  return $n_Lamf_core_metamodel_domain_ArrayNodeModel$
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_DomainElementModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_core_metamodel_domain_DomainElementModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_DomainElementModel$.prototype.constructor = $c_Lamf_core_metamodel_domain_DomainElementModel$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_DomainElementModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_DomainElementModel$.prototype = $c_Lamf_core_metamodel_domain_DomainElementModel$.prototype;
$c_Lamf_core_metamodel_domain_DomainElementModel$.prototype.Extends$lzycompute__p1__Lamf_core_metamodel_Field = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.Extends$1 = $f_Lamf_core_metamodel_domain_DomainElementModel__Extends__Lamf_core_metamodel_Field(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.Extends$1
});
$c_Lamf_core_metamodel_domain_DomainElementModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_DomainElementModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $m_sci_List$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "DomainElement")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  this.type$1 = result;
  $m_sci_List$();
  var array$1 = [this.Extends__Lamf_core_metamodel_Field()];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$10 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$10);
    i$1 = (((-1) + i$1) | 0)
  };
  this.fields$1 = result$1;
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "Domain element", "Base class for any element describing a domain model. Domain Elements are encoded or declared into base units", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_domain_DomainElementModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_core_metamodel_domain_DomainElementModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_domain_DomainElementModel$.prototype.Extends__Lamf_core_metamodel_Field = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.Extends$lzycompute__p1__Lamf_core_metamodel_Field() : this.Extends$1)
});
$c_Lamf_core_metamodel_domain_DomainElementModel$.prototype.CustomDomainProperties__Lamf_core_metamodel_Field = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.CustomDomainProperties$lzycompute__p1__Lamf_core_metamodel_Field() : this.CustomDomainProperties$1)
});
$c_Lamf_core_metamodel_domain_DomainElementModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_core_metamodel_domain_DomainElementModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_domain_DomainElementModel$.prototype.modelInstance__sr_Nothing$ = (function() {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("DomainElement is an abstract class"))
});
$c_Lamf_core_metamodel_domain_DomainElementModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_core_metamodel_domain_DomainElementModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  this.modelInstance__sr_Nothing$()
});
$c_Lamf_core_metamodel_domain_DomainElementModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_core_metamodel_domain_DomainElementModel$.prototype.CustomDomainProperties$lzycompute__p1__Lamf_core_metamodel_Field = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.CustomDomainProperties$1 = $f_Lamf_core_metamodel_domain_DomainElementModel__CustomDomainProperties__Lamf_core_metamodel_Field(this);
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.CustomDomainProperties$1
});
var $d_Lamf_core_metamodel_domain_DomainElementModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_DomainElementModel$: 0
}, false, "amf.core.metamodel.domain.DomainElementModel$", {
  Lamf_core_metamodel_domain_DomainElementModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_core_metamodel_domain_DomainElementModel$.prototype.$classData = $d_Lamf_core_metamodel_domain_DomainElementModel$;
var $n_Lamf_core_metamodel_domain_DomainElementModel$ = (void 0);
function $m_Lamf_core_metamodel_domain_DomainElementModel$() {
  if ((!$n_Lamf_core_metamodel_domain_DomainElementModel$)) {
    $n_Lamf_core_metamodel_domain_DomainElementModel$ = new $c_Lamf_core_metamodel_domain_DomainElementModel$().init___()
  };
  return $n_Lamf_core_metamodel_domain_DomainElementModel$
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_ExternalDomainElementModel$() {
  $c_O.call(this);
  this.Raw$1 = null;
  this.MediaType$1 = null;
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_core_metamodel_domain_ExternalDomainElementModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_ExternalDomainElementModel$.prototype.constructor = $c_Lamf_core_metamodel_domain_ExternalDomainElementModel$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_ExternalDomainElementModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_ExternalDomainElementModel$.prototype = $c_Lamf_core_metamodel_domain_ExternalDomainElementModel$.prototype;
$c_Lamf_core_metamodel_domain_ExternalDomainElementModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_ExternalDomainElementModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  this.Raw$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "raw"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "raw", "Raw textual information that cannot be processed for the current model semantics.", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.MediaType$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "mediaType"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "mediaType", "Media type associated to the encoded fragment information", $m_sci_Nil$()), true);
  $m_sci_List$();
  var array = [this.Raw$1, this.MediaType$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$10 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$10);
    i = (((-1) + i) | 0)
  };
  this.fields$1 = result;
  var this$11 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$11, "ExternalDomainElement");
  var this$13 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$13);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "External Domain Element", "Domain element containing foreign information that cannot be included into the model semantics", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_domain_ExternalDomainElementModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_core_metamodel_domain_ExternalDomainElementModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_domain_ExternalDomainElementModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_domain_ExternalDomainElementModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_core_metamodel_domain_ExternalDomainElementModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_core_metamodel_domain_ExternalDomainElementModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_core_model_domain_ExternalDomainElement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_core_metamodel_domain_ExternalDomainElementModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_core_metamodel_domain_ExternalDomainElementModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_ExternalDomainElementModel$: 0
}, false, "amf.core.metamodel.domain.ExternalDomainElementModel$", {
  Lamf_core_metamodel_domain_ExternalDomainElementModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_core_metamodel_domain_ExternalDomainElementModel$.prototype.$classData = $d_Lamf_core_metamodel_domain_ExternalDomainElementModel$;
var $n_Lamf_core_metamodel_domain_ExternalDomainElementModel$ = (void 0);
function $m_Lamf_core_metamodel_domain_ExternalDomainElementModel$() {
  if ((!$n_Lamf_core_metamodel_domain_ExternalDomainElementModel$)) {
    $n_Lamf_core_metamodel_domain_ExternalDomainElementModel$ = new $c_Lamf_core_metamodel_domain_ExternalDomainElementModel$().init___()
  };
  return $n_Lamf_core_metamodel_domain_ExternalDomainElementModel$
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_LinkNodeModel$() {
  $c_O.call(this);
  this.Value$1 = null;
  this.Alias$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_core_metamodel_domain_LinkNodeModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_LinkNodeModel$.prototype.constructor = $c_Lamf_core_metamodel_domain_LinkNodeModel$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_LinkNodeModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_LinkNodeModel$.prototype = $c_Lamf_core_metamodel_domain_LinkNodeModel$.prototype;
$c_Lamf_core_metamodel_domain_LinkNodeModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_LinkNodeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
  this.Value$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "value"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Data$1, "value", "", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
  this.Alias$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "alias"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Data$1, "alias", "", $m_sci_Nil$()), true);
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
  var x$9 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "Link");
  var this$9 = $m_Lamf_core_metamodel_domain_DataNodeModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$9, this$9);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Data$1, "Link Node", "Node that represents a dynamic link in a data structure", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_domain_LinkNodeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_core_metamodel_domain_LinkNodeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_domain_LinkNodeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_domain_LinkNodeModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Value$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_domain_DataNodeModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_core_metamodel_domain_LinkNodeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_core_metamodel_domain_LinkNodeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  var this$1 = $m_Lamf_core_model_domain_LinkNode$();
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return this$1.apply__T__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_LinkNode("", "", annotations)
});
$c_Lamf_core_metamodel_domain_LinkNodeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_core_metamodel_domain_LinkNodeModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_LinkNodeModel$: 0
}, false, "amf.core.metamodel.domain.LinkNodeModel$", {
  Lamf_core_metamodel_domain_LinkNodeModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_core_metamodel_domain_LinkNodeModel$.prototype.$classData = $d_Lamf_core_metamodel_domain_LinkNodeModel$;
var $n_Lamf_core_metamodel_domain_LinkNodeModel$ = (void 0);
function $m_Lamf_core_metamodel_domain_LinkNodeModel$() {
  if ((!$n_Lamf_core_metamodel_domain_LinkNodeModel$)) {
    $n_Lamf_core_metamodel_domain_LinkNodeModel$ = new $c_Lamf_core_metamodel_domain_LinkNodeModel$().init___()
  };
  return $n_Lamf_core_metamodel_domain_LinkNodeModel$
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_ModelDoc() {
  $c_O.call(this);
  this.vocabulary$1 = null;
  this.displayName$1 = null;
  this.description$1 = null;
  this.superClasses$1 = null
}
$c_Lamf_core_metamodel_domain_ModelDoc.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_ModelDoc.prototype.constructor = $c_Lamf_core_metamodel_domain_ModelDoc;
/** @constructor */
function $h_Lamf_core_metamodel_domain_ModelDoc() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_ModelDoc.prototype = $c_Lamf_core_metamodel_domain_ModelDoc.prototype;
$c_Lamf_core_metamodel_domain_ModelDoc.prototype.productPrefix__T = (function() {
  return "ModelDoc"
});
$c_Lamf_core_metamodel_domain_ModelDoc.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_core_metamodel_domain_ModelDoc.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_metamodel_domain_ModelDoc)) {
    var ModelDoc$1 = $as_Lamf_core_metamodel_domain_ModelDoc(x$1);
    var x = this.vocabulary$1;
    var x$2 = ModelDoc$1.vocabulary$1;
    if (((((x === null) ? (x$2 === null) : x.equals__O__Z(x$2)) && (this.displayName$1 === ModelDoc$1.displayName$1)) && (this.description$1 === ModelDoc$1.description$1))) {
      var x$3 = this.superClasses$1;
      var x$4 = ModelDoc$1.superClasses$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_metamodel_domain_ModelDoc.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.vocabulary$1;
      break
    }
    case 1: {
      return this.displayName$1;
      break
    }
    case 2: {
      return this.description$1;
      break
    }
    case 3: {
      return this.superClasses$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_metamodel_domain_ModelDoc.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_metamodel_domain_ModelDoc.prototype.init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq = (function(vocabulary, displayName, description, superClasses) {
  this.vocabulary$1 = vocabulary;
  this.displayName$1 = displayName;
  this.description$1 = description;
  this.superClasses$1 = superClasses;
  return this
});
$c_Lamf_core_metamodel_domain_ModelDoc.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_metamodel_domain_ModelDoc.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_metamodel_domain_ModelDoc(obj) {
  return (((obj instanceof $c_Lamf_core_metamodel_domain_ModelDoc) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.metamodel.domain.ModelDoc"))
}
function $isArrayOf_Lamf_core_metamodel_domain_ModelDoc(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_metamodel_domain_ModelDoc)))
}
function $asArrayOf_Lamf_core_metamodel_domain_ModelDoc(obj, depth) {
  return (($isArrayOf_Lamf_core_metamodel_domain_ModelDoc(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.metamodel.domain.ModelDoc;", depth))
}
var $d_Lamf_core_metamodel_domain_ModelDoc = new $TypeData().initClass({
  Lamf_core_metamodel_domain_ModelDoc: 0
}, false, "amf.core.metamodel.domain.ModelDoc", {
  Lamf_core_metamodel_domain_ModelDoc: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_metamodel_domain_ModelDoc.prototype.$classData = $d_Lamf_core_metamodel_domain_ModelDoc;
/** @constructor */
function $c_Lamf_core_metamodel_domain_ModelVocabulary() {
  $c_O.call(this);
  this.alias$1 = null;
  this.base$1 = null;
  this.usage$1 = null;
  this.filename$1 = null
}
$c_Lamf_core_metamodel_domain_ModelVocabulary.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_ModelVocabulary.prototype.constructor = $c_Lamf_core_metamodel_domain_ModelVocabulary;
/** @constructor */
function $h_Lamf_core_metamodel_domain_ModelVocabulary() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_ModelVocabulary.prototype = $c_Lamf_core_metamodel_domain_ModelVocabulary.prototype;
$c_Lamf_core_metamodel_domain_ModelVocabulary.prototype.productPrefix__T = (function() {
  return "ModelVocabulary"
});
$c_Lamf_core_metamodel_domain_ModelVocabulary.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_core_metamodel_domain_ModelVocabulary.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_metamodel_domain_ModelVocabulary)) {
    var ModelVocabulary$1 = $as_Lamf_core_metamodel_domain_ModelVocabulary(x$1);
    return ((((this.alias$1 === ModelVocabulary$1.alias$1) && (this.base$1 === ModelVocabulary$1.base$1)) && (this.usage$1 === ModelVocabulary$1.usage$1)) && (this.filename$1 === ModelVocabulary$1.filename$1))
  } else {
    return false
  }
});
$c_Lamf_core_metamodel_domain_ModelVocabulary.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.alias$1;
      break
    }
    case 1: {
      return this.base$1;
      break
    }
    case 2: {
      return this.usage$1;
      break
    }
    case 3: {
      return this.filename$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_metamodel_domain_ModelVocabulary.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_metamodel_domain_ModelVocabulary.prototype.init___T__T__T__T = (function(alias, base, usage, filename) {
  this.alias$1 = alias;
  this.base$1 = base;
  this.usage$1 = usage;
  this.filename$1 = filename;
  return this
});
$c_Lamf_core_metamodel_domain_ModelVocabulary.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_metamodel_domain_ModelVocabulary.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_metamodel_domain_ModelVocabulary(obj) {
  return (((obj instanceof $c_Lamf_core_metamodel_domain_ModelVocabulary) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.metamodel.domain.ModelVocabulary"))
}
function $isArrayOf_Lamf_core_metamodel_domain_ModelVocabulary(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_metamodel_domain_ModelVocabulary)))
}
function $asArrayOf_Lamf_core_metamodel_domain_ModelVocabulary(obj, depth) {
  return (($isArrayOf_Lamf_core_metamodel_domain_ModelVocabulary(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.metamodel.domain.ModelVocabulary;", depth))
}
var $d_Lamf_core_metamodel_domain_ModelVocabulary = new $TypeData().initClass({
  Lamf_core_metamodel_domain_ModelVocabulary: 0
}, false, "amf.core.metamodel.domain.ModelVocabulary", {
  Lamf_core_metamodel_domain_ModelVocabulary: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_metamodel_domain_ModelVocabulary.prototype.$classData = $d_Lamf_core_metamodel_domain_ModelVocabulary;
/** @constructor */
function $c_Lamf_core_metamodel_domain_ScalarNodeModel$() {
  $c_O.call(this);
  this.Value$1 = null;
  this.DataType$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_core_metamodel_domain_ScalarNodeModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_ScalarNodeModel$.prototype.constructor = $c_Lamf_core_metamodel_domain_ScalarNodeModel$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_ScalarNodeModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_ScalarNodeModel$.prototype = $c_Lamf_core_metamodel_domain_ScalarNodeModel$.prototype;
$c_Lamf_core_metamodel_domain_ScalarNodeModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_ScalarNodeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
  this.Value$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "value"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Data$1, "value", "value for an scalar dynamic node", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.DataType$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "datatype"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Data$1, "dataType", "Data type of value for an scalar dynamic node", $m_sci_Nil$()), true);
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
  var x$5 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "Scalar");
  var this$9 = $m_Lamf_core_metamodel_domain_DataNodeModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$5, this$9);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Data$1, "Scalar Node", "Node that represents a dynamic scalar value data structure", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_domain_ScalarNodeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_core_metamodel_domain_ScalarNodeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_domain_ScalarNodeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_domain_ScalarNodeModel$.prototype.fields__sci_List = (function() {
  var x$4 = this.Value$1;
  var x$3 = this.DataType$1;
  var this$1 = $m_Lamf_core_metamodel_domain_DataNodeModel$().fields$1;
  var this$2 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$1);
  return new $c_sci_$colon$colon().init___O__sci_List(x$4, this$2)
});
$c_Lamf_core_metamodel_domain_ScalarNodeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_core_metamodel_domain_ScalarNodeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  var this$1 = $m_Lamf_core_model_domain_ScalarNode$();
  var dataType = $m_s_None$();
  return this$1.apply__T__s_Option__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode("", dataType, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
});
$c_Lamf_core_metamodel_domain_ScalarNodeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_core_metamodel_domain_ScalarNodeModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_ScalarNodeModel$: 0
}, false, "amf.core.metamodel.domain.ScalarNodeModel$", {
  Lamf_core_metamodel_domain_ScalarNodeModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_core_metamodel_domain_ScalarNodeModel$.prototype.$classData = $d_Lamf_core_metamodel_domain_ScalarNodeModel$;
var $n_Lamf_core_metamodel_domain_ScalarNodeModel$ = (void 0);
function $m_Lamf_core_metamodel_domain_ScalarNodeModel$() {
  if ((!$n_Lamf_core_metamodel_domain_ScalarNodeModel$)) {
    $n_Lamf_core_metamodel_domain_ScalarNodeModel$ = new $c_Lamf_core_metamodel_domain_ScalarNodeModel$().init___()
  };
  return $n_Lamf_core_metamodel_domain_ScalarNodeModel$
}
function $f_Lamf_core_metamodel_domain_extensions_DomainExtensionModel__fields__sci_List($thiz) {
  $m_sci_List$();
  var array = [$thiz.Name$1, $thiz.DefinedBy$1, $thiz.Extension$1, $thiz.Element$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
}
function $f_Lamf_core_metamodel_domain_extensions_DomainExtensionModel__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  $thiz.Name$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "extensionName"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "name", "Name of an extension entity", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.DefinedBy$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "definedBy"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "defined by", "Definition for the extended entity", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_core_metamodel_domain_DataNodeModel$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.Extension$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "extension"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "extension", "Data structure associated to the extension", $m_sci_Nil$()), true);
  var jsx$4 = $m_Lamf_core_metamodel_Type$Str$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.Element$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "element"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "element", "Element being extended", $m_sci_Nil$()), true);
  $thiz.key$1 = $thiz.Name$1;
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "DomainExtension");
  var this$15 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  $thiz.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$15)
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$() {
  $c_O.call(this);
  this.DefinedBy$1 = null;
  this.Extension$1 = null;
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$.prototype.constructor = $c_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$.prototype = $c_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$.prototype;
$c_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  this.DefinedBy$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "definedBy"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "defined by", "Definition for the extended entity", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_domain_DataNodeModel$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  this.Extension$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "extension"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "extension", "Data structure associated to the extension", $m_sci_Nil$()), true);
  $m_sci_List$();
  var array = [this.DefinedBy$1, this.Extension$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$10 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$10);
    i = (((-1) + i) | 0)
  };
  var jsx$4 = result;
  var jsx$3 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$11 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$11.ReusableCBFInstance$2));
  var this$12 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$12, "ShapeExtension");
  var this$14 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$14);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Shape Extension", "Custom extensions for a data shape definition inside an API definition", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_core_model_domain_extensions_ShapeExtension().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$: 0
}, false, "amf.core.metamodel.domain.extensions.ShapeExtensionModel$", {
  Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$.prototype.$classData = $d_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$;
var $n_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$ = (void 0);
function $m_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$() {
  if ((!$n_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$)) {
    $n_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$ = new $c_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$().init___()
  };
  return $n_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_templates_VariableValueModel$() {
  $c_O.call(this);
  this.Name$1 = null;
  this.Value$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_core_metamodel_domain_templates_VariableValueModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_templates_VariableValueModel$.prototype.constructor = $c_Lamf_core_metamodel_domain_templates_VariableValueModel$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_templates_VariableValueModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_templates_VariableValueModel$.prototype = $c_Lamf_core_metamodel_domain_templates_VariableValueModel$.prototype;
$c_Lamf_core_metamodel_domain_templates_VariableValueModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_templates_VariableValueModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Name$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "name"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "name", "name of the template variable", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_domain_DataNodeModel$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  this.Value$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "value"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "value", "value of the variables", $m_sci_Nil$()), true);
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "VariableValue");
  var this$9 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$9);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "Variable Value", "Value for a variable in a graph template", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_domain_templates_VariableValueModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_core_metamodel_domain_templates_VariableValueModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_domain_templates_VariableValueModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_domain_templates_VariableValueModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Name$1, this.Value$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_core_metamodel_domain_templates_VariableValueModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_core_metamodel_domain_templates_VariableValueModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_core_model_domain_templates_VariableValue().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_core_metamodel_domain_templates_VariableValueModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_core_metamodel_domain_templates_VariableValueModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_templates_VariableValueModel$: 0
}, false, "amf.core.metamodel.domain.templates.VariableValueModel$", {
  Lamf_core_metamodel_domain_templates_VariableValueModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_core_metamodel_domain_templates_VariableValueModel$.prototype.$classData = $d_Lamf_core_metamodel_domain_templates_VariableValueModel$;
var $n_Lamf_core_metamodel_domain_templates_VariableValueModel$ = (void 0);
function $m_Lamf_core_metamodel_domain_templates_VariableValueModel$() {
  if ((!$n_Lamf_core_metamodel_domain_templates_VariableValueModel$)) {
    $n_Lamf_core_metamodel_domain_templates_VariableValueModel$ = new $c_Lamf_core_metamodel_domain_templates_VariableValueModel$().init___()
  };
  return $n_Lamf_core_metamodel_domain_templates_VariableValueModel$
}
/** @constructor */
function $c_Lamf_core_model_domain_ArrayNode() {
  $c_Lamf_core_model_domain_DataNode.call(this);
  this.fields$2 = null;
  this.annotations$2 = null
}
$c_Lamf_core_model_domain_ArrayNode.prototype = new $h_Lamf_core_model_domain_DataNode();
$c_Lamf_core_model_domain_ArrayNode.prototype.constructor = $c_Lamf_core_model_domain_ArrayNode;
/** @constructor */
function $h_Lamf_core_model_domain_ArrayNode() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_ArrayNode.prototype = $c_Lamf_core_model_domain_ArrayNode.prototype;
$c_Lamf_core_model_domain_ArrayNode.prototype.addMember__Lamf_core_model_domain_DataNode__sc_Seq = (function(member) {
  var jsx$1 = $as_sc_Seq(this.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ArrayNodeModel$().Member$1));
  var this$1 = $m_sc_Seq$();
  var newArray = $as_sc_Seq(jsx$1.$$colon$plus__O__scg_CanBuildFrom__O(member, this$1.ReusableCBFInstance$2));
  var field = $m_Lamf_core_metamodel_domain_ArrayNodeModel$().Member$1;
  var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(newArray, new $c_Lamf_core_parser_Annotations().init___());
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, value);
  return newArray
});
$c_Lamf_core_model_domain_ArrayNode.prototype.withMembers__sc_Seq__Lamf_core_model_domain_ArrayNode = (function(members) {
  var field = $m_Lamf_core_metamodel_domain_ArrayNodeModel$().Member$1;
  var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(members, new $c_Lamf_core_parser_Annotations().init___());
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, value);
  return this
});
$c_Lamf_core_model_domain_ArrayNode.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_core_metamodel_domain_ArrayNodeModel$()
});
$c_Lamf_core_model_domain_ArrayNode.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_core_model_domain_ArrayNode.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_core_model_domain_ArrayNode.prototype.copyNode__Lamf_core_model_domain_ArrayNode = (function() {
  var jsx$1 = this.fields$2.copy__Lamf_core_parser_Fields().filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(e$2) {
      var e = $as_T2(e$2);
      var x = e.$$und1__O();
      var x$2 = $m_Lamf_core_metamodel_domain_ArrayNodeModel$().Member$1;
      return (!((x === null) ? (x$2 === null) : $objectEquals(x, x$2)))
    })
  })(this)));
  var this$1 = this.annotations$2;
  var this$2 = new $c_Lamf_core_model_domain_ArrayNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(jsx$1, $m_Lamf_core_parser_Annotations$().apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(this$1));
  var value = this.id$1;
  var cloned = $as_Lamf_core_model_domain_ArrayNode($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$2, value));
  if ((this.id$1 !== null)) {
    var value$1 = this.id$1;
    $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(cloned, value$1)
  };
  var jsx$3 = $as_sc_Seq(this.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ArrayNodeModel$().Member$1));
  var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$8$2) {
      var x$8 = $as_Lamf_core_model_domain_DataNode(x$8$2);
      return x$8.copyNode__Lamf_core_model_domain_DataNode()
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  cloned.withMembers__sc_Seq__Lamf_core_model_domain_ArrayNode($as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$3.ReusableCBFInstance$2)));
  return cloned
});
$c_Lamf_core_model_domain_ArrayNode.prototype.replaceVariables__sci_Set__sc_Seq__F1__Lamf_core_model_domain_DataNode = (function(values, keys, reportError) {
  var jsx$2 = $as_sc_Seq(this.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ArrayNodeModel$().Member$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, values$1, keys$1, reportError$1) {
    return (function(x$7$2) {
      var x$7 = $as_Lamf_core_model_domain_DataNode(x$7$2);
      return x$7.replaceVariables__sci_Set__sc_Seq__F1__Lamf_core_model_domain_DataNode(values$1, keys$1, reportError$1)
    })
  })(this, values, keys, reportError));
  var this$1 = $m_sc_Seq$();
  var newMembers = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  return this.withMembers__sc_Seq__Lamf_core_model_domain_ArrayNode(newMembers)
});
$c_Lamf_core_model_domain_ArrayNode.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$2 = fields;
  this.annotations$2 = annotations;
  $c_Lamf_core_model_domain_DataNode.prototype.init___Lamf_core_parser_Annotations.call(this, annotations);
  return this
});
$c_Lamf_core_model_domain_ArrayNode.prototype.copyNode__Lamf_core_model_domain_DataNode = (function() {
  return this.copyNode__Lamf_core_model_domain_ArrayNode()
});
function $as_Lamf_core_model_domain_ArrayNode(obj) {
  return (((obj instanceof $c_Lamf_core_model_domain_ArrayNode) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.ArrayNode"))
}
function $isArrayOf_Lamf_core_model_domain_ArrayNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_ArrayNode)))
}
function $asArrayOf_Lamf_core_model_domain_ArrayNode(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_ArrayNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.ArrayNode;", depth))
}
var $d_Lamf_core_model_domain_ArrayNode = new $TypeData().initClass({
  Lamf_core_model_domain_ArrayNode: 0
}, false, "amf.core.model.domain.ArrayNode", {
  Lamf_core_model_domain_ArrayNode: 1,
  Lamf_core_model_domain_DataNode: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1
});
$c_Lamf_core_model_domain_ArrayNode.prototype.$classData = $d_Lamf_core_model_domain_ArrayNode;
/** @constructor */
function $c_Lamf_core_model_domain_ElementTree() {
  $c_O.call(this);
  this.key$1 = null;
  this.subtrees$1 = null
}
$c_Lamf_core_model_domain_ElementTree.prototype = new $h_O();
$c_Lamf_core_model_domain_ElementTree.prototype.constructor = $c_Lamf_core_model_domain_ElementTree;
/** @constructor */
function $h_Lamf_core_model_domain_ElementTree() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_ElementTree.prototype = $c_Lamf_core_model_domain_ElementTree.prototype;
$c_Lamf_core_model_domain_ElementTree.prototype.init___T__sc_Seq = (function(key, subtrees) {
  this.key$1 = key;
  this.subtrees$1 = subtrees;
  return this
});
$c_Lamf_core_model_domain_ElementTree.prototype.productPrefix__T = (function() {
  return "ElementTree"
});
$c_Lamf_core_model_domain_ElementTree.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_model_domain_ElementTree.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_model_domain_ElementTree)) {
    var ElementTree$1 = $as_Lamf_core_model_domain_ElementTree(x$1);
    if ((this.key$1 === ElementTree$1.key$1)) {
      var x = this.subtrees$1;
      var x$2 = ElementTree$1.subtrees$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_model_domain_ElementTree.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.subtrees$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_model_domain_ElementTree.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_model_domain_ElementTree.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_model_domain_ElementTree.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_model_domain_ElementTree(obj) {
  return (((obj instanceof $c_Lamf_core_model_domain_ElementTree) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.ElementTree"))
}
function $isArrayOf_Lamf_core_model_domain_ElementTree(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_ElementTree)))
}
function $asArrayOf_Lamf_core_model_domain_ElementTree(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_ElementTree(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.ElementTree;", depth))
}
var $d_Lamf_core_model_domain_ElementTree = new $TypeData().initClass({
  Lamf_core_model_domain_ElementTree: 0
}, false, "amf.core.model.domain.ElementTree", {
  Lamf_core_model_domain_ElementTree: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_domain_ElementTree.prototype.$classData = $d_Lamf_core_model_domain_ElementTree;
/** @constructor */
function $c_Lamf_core_model_domain_Graph() {
  $c_O.call(this);
  this.e$1 = null
}
$c_Lamf_core_model_domain_Graph.prototype = new $h_O();
$c_Lamf_core_model_domain_Graph.prototype.constructor = $c_Lamf_core_model_domain_Graph;
/** @constructor */
function $h_Lamf_core_model_domain_Graph() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_Graph.prototype = $c_Lamf_core_model_domain_Graph.prototype;
$c_Lamf_core_model_domain_Graph.prototype.productPrefix__T = (function() {
  return "Graph"
});
$c_Lamf_core_model_domain_Graph.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_model_domain_Graph.prototype.patchSeqField__Lamf_core_metamodel_Field__sc_Seq__V = (function(patchField, objs) {
  var this$2 = this.e$1;
  var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(objs, new $c_Lamf_core_parser_Annotations().init___());
  var annotations = this.annotationsForValue__Lamf_core_metamodel_Field__Lamf_core_parser_Annotations(patchField);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$2, patchField, value, annotations)
});
$c_Lamf_core_model_domain_Graph.prototype.patchObj__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfObject__V = (function(patchField, mergedNode) {
  var this$1 = this.e$1;
  var annotations = this.annotationsForValue__Lamf_core_metamodel_Field__Lamf_core_parser_Annotations(patchField);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$1, patchField, mergedNode, annotations)
});
$c_Lamf_core_model_domain_Graph.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_model_domain_Graph)) {
    var Graph$1 = $as_Lamf_core_model_domain_Graph(x$1);
    var x = this.e$1;
    var x$2 = Graph$1.e$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_core_model_domain_Graph.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.e$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_model_domain_Graph.prototype.types__sc_Seq = (function() {
  var this$2 = this.e$1.meta__Lamf_core_metamodel_Obj().type__sci_List();
  var f = (function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_vocabulary_ValueType(x$1$2);
      return x$1.iri__T()
    })
  })(this);
  var this$1 = $m_sci_List$();
  var bf = this$1.ReusableCBFInstance$2;
  if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
    if ((this$2 === $m_sci_Nil$())) {
      var jsx$1 = $m_sci_Nil$()
    } else {
      var arg1 = this$2.head__O();
      var h = new $c_sci_$colon$colon().init___O__sci_List(f(arg1), $m_sci_Nil$());
      var t = h;
      var rest = $as_sci_List(this$2.tail__O());
      while ((rest !== $m_sci_Nil$())) {
        var arg1$1 = rest.head__O();
        var nx = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$1), $m_sci_Nil$());
        t.tl$5 = nx;
        t = nx;
        rest = $as_sci_List(rest.tail__O())
      };
      var jsx$1 = h
    }
  } else {
    var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$2, bf);
    var these = this$2;
    while ((!these.isEmpty__Z())) {
      var arg1$2 = these.head__O();
      b.$$plus$eq__O__scm_Builder(f(arg1$2));
      these = $as_sci_List(these.tail__O())
    };
    var jsx$1 = b.result__O()
  };
  return $as_sc_Seq($as_sc_SeqLike(jsx$1).distinct__O())
});
$c_Lamf_core_model_domain_Graph.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_model_domain_Graph.prototype.init___Lamf_core_model_domain_DomainElement = (function(e) {
  this.e$1 = e;
  return this
});
$c_Lamf_core_model_domain_Graph.prototype.patchField__Lamf_core_metamodel_Field__Lamf_core_parser_Value__V = (function(patchField, patchValue) {
  var this$1 = this.e$1;
  var value = patchValue.value$1;
  var annotations = this.annotationsForValue__Lamf_core_metamodel_Field__Lamf_core_parser_Annotations(patchField);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$1, patchField, value, annotations)
});
$c_Lamf_core_model_domain_Graph.prototype.properties__sc_Seq = (function() {
  var this$1 = this.e$1.fields__Lamf_core_parser_Fields();
  var this$4 = this$1.fs$1;
  var this$2 = $m_Lamf_core_parser_FieldEntry$();
  var f = $f_F2__tupled__F1(this$2);
  var this$3 = $m_sci_Iterable$();
  var bf = this$3.ReusableCBFInstance$2;
  var jsx$2 = $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$4, f, bf));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_parser_FieldEntry(x$2$2);
      return x$2.field$1.value$1.iri__T()
    })
  })(this));
  var this$5 = $m_sc_Iterable$();
  return $as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2)).toSeq__sc_Seq()
});
$c_Lamf_core_model_domain_Graph.prototype.scalarByProperty__T__sc_Seq = (function(propertyId) {
  var this$1 = this.e$1.fields__Lamf_core_parser_Fields();
  var this$4 = this$1.fs$1;
  var this$2 = $m_Lamf_core_parser_FieldEntry$();
  var f = $f_F2__tupled__F1(this$2);
  var this$3 = $m_sci_Iterable$();
  var bf = this$3.ReusableCBFInstance$2;
  var x1 = $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$4, f, bf)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, propertyId$1) {
    return (function(f$2) {
      var f$1 = $as_Lamf_core_parser_FieldEntry(f$2);
      return (f$1.field$1.value$1.iri__T() === $m_Lamf_core_vocabulary_Namespace$().uri__T__Lamf_core_vocabulary_ValueType(propertyId$1).iri__T())
    })
  })(this, propertyId)));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var fieldEntry = $as_Lamf_core_parser_FieldEntry(x2.value$2);
    var x1$2 = fieldEntry.value$1.value$1;
    if ((x1$2 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
      var x2$2 = $as_Lamf_core_model_domain_AmfScalar(x1$2);
      $m_sci_List$();
      var array = [x2$2.value$1];
      var i = (((-1) + $uI(array.length)) | 0);
      var result = $m_sci_Nil$();
      while ((i >= 0)) {
        var this$8 = result;
        var index = i;
        var x = array[index];
        result = new $c_sci_$colon$colon().init___O__sci_List(x, this$8);
        i = (((-1) + i) | 0)
      };
      return result
    };
    if ((x1$2 instanceof $c_Lamf_core_model_domain_AmfArray)) {
      var x3 = $as_Lamf_core_model_domain_AmfArray(x1$2);
      if (x3.values$1.nonEmpty__Z()) {
        return x3.values$1.toList__sci_List()
      }
    };
    return $m_sci_Nil$()
  } else {
    var x$1 = $m_s_None$();
    if ((x$1 === x1)) {
      return $m_sci_Nil$()
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_core_model_domain_Graph.prototype.annotationsForValue__Lamf_core_metamodel_Field__Lamf_core_parser_Annotations = (function(f) {
  var this$1 = this.e$1.fields__Lamf_core_parser_Fields();
  var this$2 = this$1.fs$1.get__O__s_Option(f);
  if (this$2.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var x$4 = $as_Lamf_core_parser_Value(arg1);
    var this$3 = new $c_s_Some().init___O(x$4.annotations$1)
  };
  return $as_Lamf_core_parser_Annotations((this$3.isEmpty__Z() ? ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()) : this$3.get__O()))
});
$c_Lamf_core_model_domain_Graph.prototype.getObjectByPropertyId__T__sc_Seq = (function(propertyId) {
  var this$1 = this.e$1.fields__Lamf_core_parser_Fields();
  var this$4 = this$1.fs$1;
  var this$2 = $m_Lamf_core_parser_FieldEntry$();
  var f = $f_F2__tupled__F1(this$2);
  var this$3 = $m_sci_Iterable$();
  var bf = this$3.ReusableCBFInstance$2;
  var x1 = $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$4, f, bf)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, propertyId$1) {
    return (function(f$2) {
      var f$1 = $as_Lamf_core_parser_FieldEntry(f$2);
      return (f$1.field$1.value$1.iri__T() === $m_Lamf_core_vocabulary_Namespace$().uri__T__Lamf_core_vocabulary_ValueType(propertyId$1).iri__T())
    })
  })(this, propertyId)));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var fieldEntry = $as_Lamf_core_parser_FieldEntry(x2.value$2);
    var x1$2 = fieldEntry.value$1.value$1;
    if ($is_Lamf_core_model_domain_DomainElement(x1$2)) {
      var x2$2 = $as_Lamf_core_model_domain_DomainElement(x1$2);
      $m_sci_List$();
      var array = [x2$2];
      var i = (((-1) + $uI(array.length)) | 0);
      var result = $m_sci_Nil$();
      while ((i >= 0)) {
        var this$8 = result;
        var index = i;
        var x = array[index];
        result = new $c_sci_$colon$colon().init___O__sci_List(x, this$8);
        i = (((-1) + i) | 0)
      };
      return result
    };
    if ((x1$2 instanceof $c_Lamf_core_model_domain_AmfArray)) {
      var x3 = $as_Lamf_core_model_domain_AmfArray(x1$2);
      if ((x3.values$1.nonEmpty__Z() && $is_Lamf_core_model_domain_DomainElement(x3.values$1.head__O()))) {
        var jsx$2 = x3.values$1;
        var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
          return (function(x$3$2) {
            var x$3 = $as_Lamf_core_model_domain_AmfElement(x$3$2);
            return $as_Lamf_core_model_domain_DomainElement(x$3)
          })
        })(this));
        var this$9 = $m_sc_Seq$();
        return $as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$9.ReusableCBFInstance$2)).toList__sci_List()
      }
    };
    return $m_sci_Nil$()
  } else {
    var x$1 = $m_s_None$();
    if ((x$1 === x1)) {
      return $m_sci_Nil$()
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_core_model_domain_Graph.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_model_domain_Graph.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_model_domain_Graph.prototype.removeField__T__Lamf_core_model_domain_Graph = (function(uri) {
  this.e$1.fields__Lamf_core_parser_Fields().remove__T__Lamf_core_parser_Fields(uri);
  return this
});
function $as_Lamf_core_model_domain_Graph(obj) {
  return (((obj instanceof $c_Lamf_core_model_domain_Graph) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.Graph"))
}
function $isArrayOf_Lamf_core_model_domain_Graph(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_Graph)))
}
function $asArrayOf_Lamf_core_model_domain_Graph(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_Graph(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.Graph;", depth))
}
var $d_Lamf_core_model_domain_Graph = new $TypeData().initClass({
  Lamf_core_model_domain_Graph: 0
}, false, "amf.core.model.domain.Graph", {
  Lamf_core_model_domain_Graph: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_domain_Graph.prototype.$classData = $d_Lamf_core_model_domain_Graph;
/** @constructor */
function $c_Lamf_core_model_domain_LinkNode() {
  $c_Lamf_core_model_domain_DataNode.call(this);
  this.fields$2 = null;
  this.annotations$2 = null;
  this.linkedDomainElement$2 = null
}
$c_Lamf_core_model_domain_LinkNode.prototype = new $h_Lamf_core_model_domain_DataNode();
$c_Lamf_core_model_domain_LinkNode.prototype.constructor = $c_Lamf_core_model_domain_LinkNode;
/** @constructor */
function $h_Lamf_core_model_domain_LinkNode() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_LinkNode.prototype = $c_Lamf_core_model_domain_LinkNode.prototype;
$c_Lamf_core_model_domain_LinkNode.prototype.copyNode__Lamf_core_model_domain_LinkNode = (function() {
  var jsx$1 = this.fields$2.copy__Lamf_core_parser_Fields();
  var this$1 = this.annotations$2;
  var this$2 = new $c_Lamf_core_model_domain_LinkNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(jsx$1, $m_Lamf_core_parser_Annotations$().apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(this$1));
  var value = this.id$1;
  var cloned = $as_Lamf_core_model_domain_LinkNode($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$2, value));
  cloned.linkedDomainElement$2 = this.linkedDomainElement$2;
  return cloned
});
$c_Lamf_core_model_domain_LinkNode.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_core_metamodel_domain_LinkNodeModel$()
});
$c_Lamf_core_model_domain_LinkNode.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_core_model_domain_LinkNode.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return this.cloneElement__scm_Map__Lamf_core_model_domain_LinkNode(branch)
});
$c_Lamf_core_model_domain_LinkNode.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_core_model_domain_LinkNode.prototype.withLinkedDomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_LinkNode = (function(domainElement) {
  this.linkedDomainElement$2 = new $c_s_Some().init___O(domainElement);
  return this
});
$c_Lamf_core_model_domain_LinkNode.prototype.replaceVariables__sci_Set__sc_Seq__F1__Lamf_core_model_domain_DataNode = (function(values, keys, reportError) {
  return this
});
$c_Lamf_core_model_domain_LinkNode.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfObject = (function(branch) {
  return this.cloneElement__scm_Map__Lamf_core_model_domain_LinkNode(branch)
});
$c_Lamf_core_model_domain_LinkNode.prototype.cloneElement__scm_Map__Lamf_core_model_domain_LinkNode = (function(branch) {
  var node = $as_Lamf_core_model_domain_LinkNode($f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch));
  var this$1 = this.linkedDomainElement$2;
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var domainElement = $as_Lamf_core_model_domain_DomainElement(arg1);
    node.withLinkedDomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_LinkNode(domainElement)
  };
  return node
});
$c_Lamf_core_model_domain_LinkNode.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$2 = fields;
  this.annotations$2 = annotations;
  $c_Lamf_core_model_domain_DataNode.prototype.init___Lamf_core_parser_Annotations.call(this, annotations);
  this.linkedDomainElement$2 = $m_s_None$();
  return this
});
$c_Lamf_core_model_domain_LinkNode.prototype.copyNode__Lamf_core_model_domain_DataNode = (function() {
  return this.copyNode__Lamf_core_model_domain_LinkNode()
});
function $as_Lamf_core_model_domain_LinkNode(obj) {
  return (((obj instanceof $c_Lamf_core_model_domain_LinkNode) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.LinkNode"))
}
function $isArrayOf_Lamf_core_model_domain_LinkNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_LinkNode)))
}
function $asArrayOf_Lamf_core_model_domain_LinkNode(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_LinkNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.LinkNode;", depth))
}
var $d_Lamf_core_model_domain_LinkNode = new $TypeData().initClass({
  Lamf_core_model_domain_LinkNode: 0
}, false, "amf.core.model.domain.LinkNode", {
  Lamf_core_model_domain_LinkNode: 1,
  Lamf_core_model_domain_DataNode: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1
});
$c_Lamf_core_model_domain_LinkNode.prototype.$classData = $d_Lamf_core_model_domain_LinkNode;
/** @constructor */
function $c_Lamf_core_model_domain_ObjectNode() {
  $c_Lamf_core_model_domain_DataNode.call(this);
  this.fields$2 = null;
  this.annotations$2 = null;
  this.meta$2 = null
}
$c_Lamf_core_model_domain_ObjectNode.prototype = new $h_Lamf_core_model_domain_DataNode();
$c_Lamf_core_model_domain_ObjectNode.prototype.constructor = $c_Lamf_core_model_domain_ObjectNode;
/** @constructor */
function $h_Lamf_core_model_domain_ObjectNode() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_ObjectNode.prototype = $c_Lamf_core_model_domain_ObjectNode.prototype;
$c_Lamf_core_model_domain_ObjectNode.prototype.ensurePlainProperty__T__T = (function(propertyOrUri) {
  var str = $m_Lamf_core_vocabulary_Namespace$().Data$1.base$1;
  if (($uI(propertyOrUri.indexOf(str)) === 0)) {
    var target = $m_Lamf_core_vocabulary_Namespace$().Data$1.base$1;
    return $as_T(propertyOrUri.split(target).join(""))
  } else {
    return propertyOrUri
  }
});
$c_Lamf_core_model_domain_ObjectNode.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return this.meta$2
});
$c_Lamf_core_model_domain_ObjectNode.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_core_model_domain_ObjectNode.prototype.getFromKey__T__s_Option = (function(key) {
  var this$1 = this.fields$2;
  var field = this.createField__p2__T__Lamf_core_metamodel_Field(key);
  var xo = this$1.fs$1.get__O__s_Option(field);
  var this$3 = xo.toList__sci_List();
  var pf = new $c_Lamf_core_model_domain_ObjectNode$$anonfun$getFromKey$1().init___Lamf_core_model_domain_ObjectNode(this);
  return $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$3, pf)
});
$c_Lamf_core_model_domain_ObjectNode.prototype.copyNode__Lamf_core_model_domain_ObjectNode = (function() {
  var jsx$1 = this.fields$2.copy__Lamf_core_parser_Fields();
  var this$1 = this.annotations$2;
  var cloned = new $c_Lamf_core_model_domain_ObjectNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(jsx$1, $m_Lamf_core_parser_Annotations$().apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(this$1));
  if ((this.id$1 !== null)) {
    var value = this.id$1;
    $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(cloned, value)
  };
  var jsx$3 = this.propertyFields__sc_Iterable();
  var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(f$2) {
      var f = $as_Lamf_core_metamodel_Field(f$2);
      var xo = $this.fields$2.entry__Lamf_core_metamodel_Field__s_Option(f);
      return xo.toList__sci_List()
    })
  })(this));
  var this$3 = $m_sc_Iterable$();
  $as_sc_IterableLike(jsx$3.flatMap__F1__scg_CanBuildFrom__O(jsx$2, this$3.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, cloned$1) {
    return (function(entry$2) {
      var entry = $as_Lamf_core_parser_FieldEntry(entry$2);
      var value$1 = entry.value$1;
      var field = entry.field$1;
      var value$2 = $as_Lamf_core_model_domain_DataNode(value$1.value$1).copyNode__Lamf_core_model_domain_DataNode();
      var annotations = value$1.annotations$1;
      return $as_Lamf_core_model_domain_ObjectNode($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(cloned$1, field, value$2, annotations))
    })
  })(this, cloned)));
  return cloned
});
$c_Lamf_core_model_domain_ObjectNode.prototype.propertyFields__sc_Iterable = (function() {
  var this$1 = this.fields$2;
  var this$4 = this$1.fs$1;
  var this$2 = $m_Lamf_core_parser_FieldEntry$();
  var f = $f_F2__tupled__F1(this$2);
  var this$3 = $m_sci_Iterable$();
  var bf = this$3.ReusableCBFInstance$2;
  var jsx$2 = $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$4, f, bf));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_parser_FieldEntry(x0$1$2);
      if ((x0$1 !== null)) {
        var field = x0$1.field$1;
        $m_Lamf_core_metamodel_domain_ObjectNodeModel$();
        var this$6 = $m_Lamf_core_metamodel_domain_DataNodeModel$().fields$1;
        if ((!$f_sc_LinearSeqOptimized__contains__O__Z(this$6, field))) {
          var xo = new $c_s_Some().init___O(field);
          return xo.toList__sci_List()
        }
      };
      var xo$1 = $m_s_None$();
      return xo$1.toList__sci_List()
    })
  })(this));
  var this$9 = $m_sc_Iterable$();
  return $as_sc_Iterable(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$9.ReusableCBFInstance$2))
});
$c_Lamf_core_model_domain_ObjectNode.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_core_model_domain_ObjectNode.prototype.allPropertiesWithName__sci_Map = (function() {
  var jsx$2 = this.propertyFields__sc_Iterable();
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(f$2) {
      var f = $as_Lamf_core_metamodel_Field(f$2);
      var str = f.value$1.name$1;
      var self = new $c_Lamf_core_utils_package$AmfStrings().init___T(str).urlComponentDecoded__T();
      var y = $this.fields$2.apply__Lamf_core_metamodel_Field__O(f);
      return new $c_T2().init___O__O(self, y)
    })
  })(this));
  var this$4 = $m_sc_Iterable$();
  return $as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2)
});
$c_Lamf_core_model_domain_ObjectNode.prototype.replaceVariables__sci_Set__sc_Seq__F1__Lamf_core_model_domain_DataNode = (function(values, keys, reportError) {
  this.propertyFields__sc_Iterable().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, keys$1, values$1, reportError$1) {
    return (function(field$2) {
      var field = $as_Lamf_core_metamodel_Field(field$2);
      var str = field.value$1.name$1;
      var decodedKey = new $c_Lamf_core_utils_package$AmfStrings().init___T(str).urlComponentDecoded__T();
      if ($m_sjsr_RuntimeString$().endsWith__T__T__Z(decodedKey, "?")) {
        var endIndex = (((-1) + $uI(decodedKey.length)) | 0);
        var finalKey = $as_T(decodedKey.substring(0, endIndex))
      } else {
        var finalKey = decodedKey
      };
      var maybeTree = keys$1.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, finalKey$1) {
        return (function(x$3$2) {
          var x$3 = $as_Lamf_core_model_domain_ElementTree(x$3$2);
          var this$5 = x$3.key$1;
          return (this$5 === finalKey$1)
        })
      })($this, finalKey)));
      var x1 = $this.fields$2.entry__Lamf_core_metamodel_Field__s_Option(field);
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var p3 = $as_Lamf_core_parser_FieldEntry(x2.value$2);
        if ((p3 !== null)) {
          var v = p3.value$1;
          var jsx$1 = $as_Lamf_core_model_domain_DataNode(v.value$1);
          if (maybeTree.isEmpty__Z()) {
            var this$6 = $m_s_None$()
          } else {
            var arg1 = maybeTree.get__O();
            var x$4 = $as_Lamf_core_model_domain_ElementTree(arg1);
            var this$6 = new $c_s_Some().init___O(x$4.subtrees$1)
          };
          var value = jsx$1.replaceVariables__sci_Set__sc_Seq__F1__Lamf_core_model_domain_DataNode(values$1, $as_sc_Seq((this$6.isEmpty__Z() ? $m_sci_Nil$() : this$6.get__O())), (($m_sjsr_RuntimeString$().endsWith__T__T__Z(decodedKey, "?") && maybeTree.isEmpty__Z()) ? new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
            return (function(x$5$2) {
              $as_T(x$5$2)
            })
          })($this)) : reportError$1));
          $this.fields$2.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields(field);
          return $this.addProperty__T__Lamf_core_model_domain_DataNode__Lamf_core_parser_Annotations__Lamf_core_model_domain_ObjectNode($m_Lamf_core_resolution_VariableReplacer$().replaceVariablesInKey__T__sci_Set__F1__T(decodedKey, values$1, reportError$1), value, v.annotations$1)
        }
      }
    })
  })(this, keys, values, reportError)));
  return this
});
$c_Lamf_core_model_domain_ObjectNode.prototype.createField__p2__T__Lamf_core_metamodel_Field = (function(property) {
  var jsx$1 = $m_Lamf_core_metamodel_domain_DataNodeModel$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
  var this$2 = new $c_Lamf_core_utils_package$AmfStrings().init___T(property);
  var this$3 = this$2.platform$1;
  var url = this$2.str$1;
  var id = $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$3, url);
  return new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, id), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Data$1, property, "", $m_sci_Nil$()), true)
});
$c_Lamf_core_model_domain_ObjectNode.prototype.addPropertyByField__Lamf_core_metamodel_Field__Lamf_core_model_domain_DataNode__Lamf_core_parser_Annotations__Lamf_core_model_domain_ObjectNode = (function(f, objectValue, annotations) {
  objectValue.adopted__T__sc_Seq__Lamf_core_model_domain_DataNode(this.id$1, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this, f, objectValue, annotations);
  return this
});
$c_Lamf_core_model_domain_ObjectNode.prototype.addProperty__T__Lamf_core_model_domain_DataNode__Lamf_core_parser_Annotations__Lamf_core_model_domain_ObjectNode = (function(propertyOrUri, objectValue, annotations) {
  var property = this.ensurePlainProperty__T__T(propertyOrUri);
  var field = $m_Lamf_core_metamodel_domain_DataNodeModel$().Name$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(objectValue, field, property);
  this.addPropertyByField__Lamf_core_metamodel_Field__Lamf_core_model_domain_DataNode__Lamf_core_parser_Annotations__Lamf_core_model_domain_ObjectNode(this.createField__p2__T__Lamf_core_metamodel_Field(property), objectValue, annotations);
  return this
});
$c_Lamf_core_model_domain_ObjectNode.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$2 = fields;
  this.annotations$2 = annotations;
  $c_Lamf_core_model_domain_DataNode.prototype.init___Lamf_core_parser_Annotations.call(this, annotations);
  this.meta$2 = new $c_Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel().init___Lamf_core_model_domain_ObjectNode(this);
  return this
});
$c_Lamf_core_model_domain_ObjectNode.prototype.copyNode__Lamf_core_model_domain_DataNode = (function() {
  return this.copyNode__Lamf_core_model_domain_ObjectNode()
});
function $as_Lamf_core_model_domain_ObjectNode(obj) {
  return (((obj instanceof $c_Lamf_core_model_domain_ObjectNode) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.ObjectNode"))
}
function $isArrayOf_Lamf_core_model_domain_ObjectNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_ObjectNode)))
}
function $asArrayOf_Lamf_core_model_domain_ObjectNode(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_ObjectNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.ObjectNode;", depth))
}
var $d_Lamf_core_model_domain_ObjectNode = new $TypeData().initClass({
  Lamf_core_model_domain_ObjectNode: 0
}, false, "amf.core.model.domain.ObjectNode", {
  Lamf_core_model_domain_ObjectNode: 1,
  Lamf_core_model_domain_DataNode: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1
});
$c_Lamf_core_model_domain_ObjectNode.prototype.$classData = $d_Lamf_core_model_domain_ObjectNode;
/** @constructor */
function $c_Lamf_core_model_domain_ScalarNode() {
  $c_Lamf_core_model_domain_DataNode.call(this);
  this.fields$2 = null;
  this.annotations$2 = null
}
$c_Lamf_core_model_domain_ScalarNode.prototype = new $h_Lamf_core_model_domain_DataNode();
$c_Lamf_core_model_domain_ScalarNode.prototype.constructor = $c_Lamf_core_model_domain_ScalarNode;
/** @constructor */
function $h_Lamf_core_model_domain_ScalarNode() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_ScalarNode.prototype = $c_Lamf_core_model_domain_ScalarNode.prototype;
$c_Lamf_core_model_domain_ScalarNode.prototype.withDataType__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode = (function(dataType, ann) {
  var field = $m_Lamf_core_metamodel_domain_ScalarNodeModel$().DataType$1;
  var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(dataType, ann);
  return $as_Lamf_core_model_domain_ScalarNode($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, value))
});
$c_Lamf_core_model_domain_ScalarNode.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_core_metamodel_domain_ScalarNodeModel$()
});
$c_Lamf_core_model_domain_ScalarNode.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_core_model_domain_ScalarNode.prototype.withDataType__T__Lamf_core_model_domain_ScalarNode = (function(dataType) {
  var field = $m_Lamf_core_metamodel_domain_ScalarNodeModel$().DataType$1;
  var value = $m_Lamf_core_model_domain_ScalarNode$().forDataType__T__Lamf_core_model_domain_AmfScalar(dataType);
  return $as_Lamf_core_model_domain_ScalarNode($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, value))
});
$c_Lamf_core_model_domain_ScalarNode.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_core_model_domain_ScalarNode.prototype.withValue__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode = (function(v, ann) {
  var field = $m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1;
  var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(v, ann);
  return $as_Lamf_core_model_domain_ScalarNode($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, value))
});
$c_Lamf_core_model_domain_ScalarNode.prototype.replaceVariables__sci_Set__sc_Seq__F1__Lamf_core_model_domain_DataNode = (function(values, keys, reportError) {
  return $m_Lamf_core_resolution_VariableReplacer$().replaceNodeVariables__Lamf_core_model_domain_ScalarNode__sci_Set__F1__Lamf_core_model_domain_DataNode(this, values, reportError)
});
$c_Lamf_core_model_domain_ScalarNode.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$2 = fields;
  this.annotations$2 = annotations;
  $c_Lamf_core_model_domain_DataNode.prototype.init___Lamf_core_parser_Annotations.call(this, annotations);
  return this
});
$c_Lamf_core_model_domain_ScalarNode.prototype.copyNode__Lamf_core_model_domain_DataNode = (function() {
  var jsx$1 = this.fields$2.copy__Lamf_core_parser_Fields();
  var this$1 = this.annotations$2;
  var this$2 = new $c_Lamf_core_model_domain_ScalarNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(jsx$1, $m_Lamf_core_parser_Annotations$().apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(this$1));
  var value = this.id$1;
  return $as_Lamf_core_model_domain_DataNode($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$2, value))
});
function $as_Lamf_core_model_domain_ScalarNode(obj) {
  return (((obj instanceof $c_Lamf_core_model_domain_ScalarNode) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.ScalarNode"))
}
function $isArrayOf_Lamf_core_model_domain_ScalarNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_ScalarNode)))
}
function $asArrayOf_Lamf_core_model_domain_ScalarNode(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_ScalarNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.ScalarNode;", depth))
}
var $d_Lamf_core_model_domain_ScalarNode = new $TypeData().initClass({
  Lamf_core_model_domain_ScalarNode: 0
}, false, "amf.core.model.domain.ScalarNode", {
  Lamf_core_model_domain_ScalarNode: 1,
  Lamf_core_model_domain_DataNode: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1
});
$c_Lamf_core_model_domain_ScalarNode.prototype.$classData = $d_Lamf_core_model_domain_ScalarNode;
/** @constructor */
function $c_Lamf_core_model_domain_templates_ParametrizedDeclaration() {
  $c_O.call(this);
  this.fields$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_core_model_domain_templates_ParametrizedDeclaration.prototype = new $h_O();
$c_Lamf_core_model_domain_templates_ParametrizedDeclaration.prototype.constructor = $c_Lamf_core_model_domain_templates_ParametrizedDeclaration;
/** @constructor */
function $h_Lamf_core_model_domain_templates_ParametrizedDeclaration() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_templates_ParametrizedDeclaration.prototype = $c_Lamf_core_model_domain_templates_ParametrizedDeclaration.prototype;
$c_Lamf_core_model_domain_templates_ParametrizedDeclaration.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_core_model_domain_templates_ParametrizedDeclaration.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_core_model_domain_templates_ParametrizedDeclaration.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_core_model_domain_templates_ParametrizedDeclaration.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-parametrized" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_core_model_domain_templates_ParametrizedDeclaration.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_core_model_domain_templates_ParametrizedDeclaration.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_core_model_domain_templates_ParametrizedDeclaration.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_core_model_domain_templates_ParametrizedDeclaration.prototype.variables__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$().Variables$1))
});
$c_Lamf_core_model_domain_templates_ParametrizedDeclaration.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_core_model_domain_templates_ParametrizedDeclaration.prototype.target__Lamf_core_model_domain_templates_AbstractDeclaration = (function() {
  return $as_Lamf_core_model_domain_templates_AbstractDeclaration(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$().Target$1))
});
$c_Lamf_core_model_domain_templates_ParametrizedDeclaration.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$().Name$1
});
$c_Lamf_core_model_domain_templates_ParametrizedDeclaration.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_core_model_domain_templates_ParametrizedDeclaration.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_core_model_domain_templates_ParametrizedDeclaration.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  return this
});
function $as_Lamf_core_model_domain_templates_ParametrizedDeclaration(obj) {
  return (((obj instanceof $c_Lamf_core_model_domain_templates_ParametrizedDeclaration) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.templates.ParametrizedDeclaration"))
}
function $isArrayOf_Lamf_core_model_domain_templates_ParametrizedDeclaration(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_templates_ParametrizedDeclaration)))
}
function $asArrayOf_Lamf_core_model_domain_templates_ParametrizedDeclaration(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_templates_ParametrizedDeclaration(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.templates.ParametrizedDeclaration;", depth))
}
/** @constructor */
function $c_Lamf_core_model_domain_templates_Variable() {
  $c_O.call(this);
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_core_model_domain_templates_Variable.prototype = new $h_O();
$c_Lamf_core_model_domain_templates_Variable.prototype.constructor = $c_Lamf_core_model_domain_templates_Variable;
/** @constructor */
function $h_Lamf_core_model_domain_templates_Variable() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_templates_Variable.prototype = $c_Lamf_core_model_domain_templates_Variable.prototype;
$c_Lamf_core_model_domain_templates_Variable.prototype.productPrefix__T = (function() {
  return "Variable"
});
$c_Lamf_core_model_domain_templates_Variable.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_model_domain_templates_Variable.prototype.$$js$exported$prop$name__O = (function() {
  return this.name$1
});
$c_Lamf_core_model_domain_templates_Variable.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_model_domain_templates_Variable)) {
    var Variable$1 = $as_Lamf_core_model_domain_templates_Variable(x$1);
    if ((this.name$1 === Variable$1.name$1)) {
      var x = this.value$1;
      var x$2 = Variable$1.value$1;
      return (x === x$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_model_domain_templates_Variable.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.name$1;
      break
    }
    case 1: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_model_domain_templates_Variable.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_model_domain_templates_Variable.prototype.$$js$exported$prop$value__O = (function() {
  return this.value$1
});
$c_Lamf_core_model_domain_templates_Variable.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_model_domain_templates_Variable.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_model_domain_templates_Variable.prototype.init___T__Lamf_core_model_domain_DataNode = (function(name, value) {
  this.name$1 = name;
  this.value$1 = value;
  return this
});
Object.defineProperty($c_Lamf_core_model_domain_templates_Variable.prototype, "value", {
  "get": (function() {
    return this.$$js$exported$prop$value__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_core_model_domain_templates_Variable.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_core_model_domain_templates_Variable(obj) {
  return (((obj instanceof $c_Lamf_core_model_domain_templates_Variable) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.templates.Variable"))
}
function $isArrayOf_Lamf_core_model_domain_templates_Variable(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_templates_Variable)))
}
function $asArrayOf_Lamf_core_model_domain_templates_Variable(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_templates_Variable(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.templates.Variable;", depth))
}
var $d_Lamf_core_model_domain_templates_Variable = new $TypeData().initClass({
  Lamf_core_model_domain_templates_Variable: 0
}, false, "amf.core.model.domain.templates.Variable", {
  Lamf_core_model_domain_templates_Variable: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_domain_templates_Variable.prototype.$classData = $d_Lamf_core_model_domain_templates_Variable;
/** @constructor */
function $c_Lamf_core_parser_DeclarationPromise() {
  $c_O.call(this);
  this.amf$core$parser$DeclarationPromise$$success$1 = null;
  this.amf$core$parser$DeclarationPromise$$failure$1 = null;
  this.resolved$1 = false
}
$c_Lamf_core_parser_DeclarationPromise.prototype = new $h_O();
$c_Lamf_core_parser_DeclarationPromise.prototype.constructor = $c_Lamf_core_parser_DeclarationPromise;
/** @constructor */
function $h_Lamf_core_parser_DeclarationPromise() {
  /*<skip>*/
}
$h_Lamf_core_parser_DeclarationPromise.prototype = $c_Lamf_core_parser_DeclarationPromise.prototype;
$c_Lamf_core_parser_DeclarationPromise.prototype.productPrefix__T = (function() {
  return "DeclarationPromise"
});
$c_Lamf_core_parser_DeclarationPromise.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_core_parser_DeclarationPromise.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_parser_DeclarationPromise)) {
    var DeclarationPromise$1 = $as_Lamf_core_parser_DeclarationPromise(x$1);
    var x = this.amf$core$parser$DeclarationPromise$$success$1;
    var x$2 = DeclarationPromise$1.amf$core$parser$DeclarationPromise$$success$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.amf$core$parser$DeclarationPromise$$failure$1;
      var x$4 = DeclarationPromise$1.amf$core$parser$DeclarationPromise$$failure$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.resolved$1 === DeclarationPromise$1.resolved$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_parser_DeclarationPromise.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.amf$core$parser$DeclarationPromise$$success$1;
      break
    }
    case 1: {
      return this.amf$core$parser$DeclarationPromise$$failure$1;
      break
    }
    case 2: {
      return this.resolved$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_parser_DeclarationPromise.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_parser_DeclarationPromise.prototype.init___F1__F0__Z = (function(success, failure, resolved) {
  this.amf$core$parser$DeclarationPromise$$success$1 = success;
  this.amf$core$parser$DeclarationPromise$$failure$1 = failure;
  this.resolved$1 = resolved;
  return this
});
$c_Lamf_core_parser_DeclarationPromise.prototype.resolve__Lamf_core_model_domain_Linkable__V = (function(element) {
  this.resolved$1 = true;
  this.amf$core$parser$DeclarationPromise$$success$1.apply__O__O(element)
});
$c_Lamf_core_parser_DeclarationPromise.prototype.fail__V = (function() {
  this.resolved$1 = true;
  this.amf$core$parser$DeclarationPromise$$failure$1.apply__O()
});
$c_Lamf_core_parser_DeclarationPromise.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.amf$core$parser$DeclarationPromise$$success$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.amf$core$parser$DeclarationPromise$$failure$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.resolved$1 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 3)
});
$c_Lamf_core_parser_DeclarationPromise.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_parser_DeclarationPromise(obj) {
  return (((obj instanceof $c_Lamf_core_parser_DeclarationPromise) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.DeclarationPromise"))
}
function $isArrayOf_Lamf_core_parser_DeclarationPromise(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_DeclarationPromise)))
}
function $asArrayOf_Lamf_core_parser_DeclarationPromise(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_DeclarationPromise(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.DeclarationPromise;", depth))
}
var $d_Lamf_core_parser_DeclarationPromise = new $TypeData().initClass({
  Lamf_core_parser_DeclarationPromise: 0
}, false, "amf.core.parser.DeclarationPromise", {
  Lamf_core_parser_DeclarationPromise: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_DeclarationPromise.prototype.$classData = $d_Lamf_core_parser_DeclarationPromise;
/** @constructor */
function $c_Lamf_core_parser_FieldEntry() {
  $c_O.call(this);
  this.field$1 = null;
  this.value$1 = null
}
$c_Lamf_core_parser_FieldEntry.prototype = new $h_O();
$c_Lamf_core_parser_FieldEntry.prototype.constructor = $c_Lamf_core_parser_FieldEntry;
/** @constructor */
function $h_Lamf_core_parser_FieldEntry() {
  /*<skip>*/
}
$h_Lamf_core_parser_FieldEntry.prototype = $c_Lamf_core_parser_FieldEntry.prototype;
$c_Lamf_core_parser_FieldEntry.prototype.productPrefix__T = (function() {
  return "FieldEntry"
});
$c_Lamf_core_parser_FieldEntry.prototype.init___Lamf_core_metamodel_Field__Lamf_core_parser_Value = (function(field, value) {
  this.field$1 = field;
  this.value$1 = value;
  return this
});
$c_Lamf_core_parser_FieldEntry.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_parser_FieldEntry.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_parser_FieldEntry)) {
    var FieldEntry$1 = $as_Lamf_core_parser_FieldEntry(x$1);
    var x = this.field$1;
    var x$2 = FieldEntry$1.field$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.value$1;
      var x$4 = FieldEntry$1.value$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_parser_FieldEntry.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.field$1;
      break
    }
    case 1: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_parser_FieldEntry.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_parser_FieldEntry.prototype.negated__Lamf_core_parser_FieldEntry = (function() {
  var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations((!$as_Lamf_core_model_domain_AmfScalar(this.value$1.value$1).toBool__Z()), this.value$1.value$1.annotations__Lamf_core_parser_Annotations());
  var annotations = this.value$1.annotations$1;
  var x$1 = new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value, annotations);
  var x$2 = this.field$1;
  return new $c_Lamf_core_parser_FieldEntry().init___Lamf_core_metamodel_Field__Lamf_core_parser_Value(x$2, x$1)
});
$c_Lamf_core_parser_FieldEntry.prototype.arrayValues__sc_Seq = (function() {
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(this.value$1.value$1).values$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$12$2) {
      var x$12 = $as_Lamf_core_model_domain_AmfElement(x$12$2);
      return x$12
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))
});
$c_Lamf_core_parser_FieldEntry.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_parser_FieldEntry.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_parser_FieldEntry(obj) {
  return (((obj instanceof $c_Lamf_core_parser_FieldEntry) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.FieldEntry"))
}
function $isArrayOf_Lamf_core_parser_FieldEntry(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_FieldEntry)))
}
function $asArrayOf_Lamf_core_parser_FieldEntry(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_FieldEntry(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.FieldEntry;", depth))
}
var $d_Lamf_core_parser_FieldEntry = new $TypeData().initClass({
  Lamf_core_parser_FieldEntry: 0
}, false, "amf.core.parser.FieldEntry", {
  Lamf_core_parser_FieldEntry: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_FieldEntry.prototype.$classData = $d_Lamf_core_parser_FieldEntry;
/** @constructor */
function $c_Lamf_core_parser_FieldEntry$() {
  $c_sr_AbstractFunction2.call(this)
}
$c_Lamf_core_parser_FieldEntry$.prototype = new $h_sr_AbstractFunction2();
$c_Lamf_core_parser_FieldEntry$.prototype.constructor = $c_Lamf_core_parser_FieldEntry$;
/** @constructor */
function $h_Lamf_core_parser_FieldEntry$() {
  /*<skip>*/
}
$h_Lamf_core_parser_FieldEntry$.prototype = $c_Lamf_core_parser_FieldEntry$.prototype;
$c_Lamf_core_parser_FieldEntry$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_parser_FieldEntry$.prototype.toString__T = (function() {
  return "FieldEntry"
});
$c_Lamf_core_parser_FieldEntry$.prototype.apply__O__O__O = (function(v1, v2) {
  var field = $as_Lamf_core_metamodel_Field(v1);
  var value = $as_Lamf_core_parser_Value(v2);
  return new $c_Lamf_core_parser_FieldEntry().init___Lamf_core_metamodel_Field__Lamf_core_parser_Value(field, value)
});
var $d_Lamf_core_parser_FieldEntry$ = new $TypeData().initClass({
  Lamf_core_parser_FieldEntry$: 0
}, false, "amf.core.parser.FieldEntry$", {
  Lamf_core_parser_FieldEntry$: 1,
  sr_AbstractFunction2: 1,
  O: 1,
  F2: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_FieldEntry$.prototype.$classData = $d_Lamf_core_parser_FieldEntry$;
var $n_Lamf_core_parser_FieldEntry$ = (void 0);
function $m_Lamf_core_parser_FieldEntry$() {
  if ((!$n_Lamf_core_parser_FieldEntry$)) {
    $n_Lamf_core_parser_FieldEntry$ = new $c_Lamf_core_parser_FieldEntry$().init___()
  };
  return $n_Lamf_core_parser_FieldEntry$
}
/** @constructor */
function $c_Lamf_core_parser_FragmentRef() {
  $c_O.call(this);
  this.encoded$1 = null;
  this.location$1 = null
}
$c_Lamf_core_parser_FragmentRef.prototype = new $h_O();
$c_Lamf_core_parser_FragmentRef.prototype.constructor = $c_Lamf_core_parser_FragmentRef;
/** @constructor */
function $h_Lamf_core_parser_FragmentRef() {
  /*<skip>*/
}
$h_Lamf_core_parser_FragmentRef.prototype = $c_Lamf_core_parser_FragmentRef.prototype;
$c_Lamf_core_parser_FragmentRef.prototype.productPrefix__T = (function() {
  return "FragmentRef"
});
$c_Lamf_core_parser_FragmentRef.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_parser_FragmentRef.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_parser_FragmentRef)) {
    var FragmentRef$1 = $as_Lamf_core_parser_FragmentRef(x$1);
    var x = this.encoded$1;
    var x$2 = FragmentRef$1.encoded$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.location$1;
      var x$4 = FragmentRef$1.location$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_parser_FragmentRef.prototype.init___Lamf_core_model_domain_DomainElement__s_Option = (function(encoded, location) {
  this.encoded$1 = encoded;
  this.location$1 = location;
  return this
});
$c_Lamf_core_parser_FragmentRef.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.encoded$1;
      break
    }
    case 1: {
      return this.location$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_parser_FragmentRef.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_parser_FragmentRef.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_parser_FragmentRef.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_parser_FragmentRef(obj) {
  return (((obj instanceof $c_Lamf_core_parser_FragmentRef) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.FragmentRef"))
}
function $isArrayOf_Lamf_core_parser_FragmentRef(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_FragmentRef)))
}
function $asArrayOf_Lamf_core_parser_FragmentRef(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_FragmentRef(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.FragmentRef;", depth))
}
var $d_Lamf_core_parser_FragmentRef = new $TypeData().initClass({
  Lamf_core_parser_FragmentRef: 0
}, false, "amf.core.parser.FragmentRef", {
  Lamf_core_parser_FragmentRef: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_FragmentRef.prototype.$classData = $d_Lamf_core_parser_FragmentRef;
/** @constructor */
function $c_Lamf_core_parser_ParsedReference() {
  $c_O.call(this);
  this.unit$1 = null;
  this.origin$1 = null;
  this.ast$1 = null
}
$c_Lamf_core_parser_ParsedReference.prototype = new $h_O();
$c_Lamf_core_parser_ParsedReference.prototype.constructor = $c_Lamf_core_parser_ParsedReference;
/** @constructor */
function $h_Lamf_core_parser_ParsedReference() {
  /*<skip>*/
}
$h_Lamf_core_parser_ParsedReference.prototype = $c_Lamf_core_parser_ParsedReference.prototype;
$c_Lamf_core_parser_ParsedReference.prototype.productPrefix__T = (function() {
  return "ParsedReference"
});
$c_Lamf_core_parser_ParsedReference.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_core_parser_ParsedReference.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_parser_ParsedReference)) {
    var ParsedReference$1 = $as_Lamf_core_parser_ParsedReference(x$1);
    var x = this.unit$1;
    var x$2 = ParsedReference$1.unit$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.origin$1;
      var x$4 = ParsedReference$1.origin$1;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.ast$1;
      var x$6 = ParsedReference$1.ast$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_parser_ParsedReference.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.unit$1;
      break
    }
    case 1: {
      return this.origin$1;
      break
    }
    case 2: {
      return this.ast$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_parser_ParsedReference.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_parser_ParsedReference.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_core_parser_Reference__s_Option = (function(unit, origin, ast) {
  this.unit$1 = unit;
  this.origin$1 = origin;
  this.ast$1 = ast;
  return this
});
$c_Lamf_core_parser_ParsedReference.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_parser_ParsedReference.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_parser_ParsedReference(obj) {
  return (((obj instanceof $c_Lamf_core_parser_ParsedReference) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.ParsedReference"))
}
function $isArrayOf_Lamf_core_parser_ParsedReference(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_ParsedReference)))
}
function $asArrayOf_Lamf_core_parser_ParsedReference(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_ParsedReference(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.ParsedReference;", depth))
}
var $d_Lamf_core_parser_ParsedReference = new $TypeData().initClass({
  Lamf_core_parser_ParsedReference: 0
}, false, "amf.core.parser.ParsedReference", {
  Lamf_core_parser_ParsedReference: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_ParsedReference.prototype.$classData = $d_Lamf_core_parser_ParsedReference;
/** @constructor */
function $c_Lamf_core_parser_Range() {
  $c_O.call(this);
  this.start$1 = null;
  this.end$1 = null
}
$c_Lamf_core_parser_Range.prototype = new $h_O();
$c_Lamf_core_parser_Range.prototype.constructor = $c_Lamf_core_parser_Range;
/** @constructor */
function $h_Lamf_core_parser_Range() {
  /*<skip>*/
}
$h_Lamf_core_parser_Range.prototype = $c_Lamf_core_parser_Range.prototype;
$c_Lamf_core_parser_Range.prototype.productPrefix__T = (function() {
  return "Range"
});
$c_Lamf_core_parser_Range.prototype.$$js$exported$prop$end__O = (function() {
  return this.end$1
});
$c_Lamf_core_parser_Range.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_parser_Range.prototype.$$js$exported$meth$contains__Lamf_core_parser_Range__O = (function(other) {
  return this.contains__Lamf_core_parser_Range__Z(other)
});
$c_Lamf_core_parser_Range.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_parser_Range)) {
    var Range$1 = $as_Lamf_core_parser_Range(x$1);
    var x = this.start$1;
    var x$2 = Range$1.start$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.end$1;
      var x$4 = Range$1.end$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_parser_Range.prototype.$$js$exported$meth$toString__O = (function() {
  return this.toString__T()
});
$c_Lamf_core_parser_Range.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.start$1;
      break
    }
    case 1: {
      return this.end$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_parser_Range.prototype.toString__T = (function() {
  return (((("[" + this.start$1) + "-") + this.end$1) + "]")
});
$c_Lamf_core_parser_Range.prototype.$$js$exported$prop$start__O = (function() {
  return this.start$1
});
$c_Lamf_core_parser_Range.prototype.contains__Lamf_core_parser_Range__Z = (function(other) {
  return ((other.start$1.line$1 >= this.start$1.line$1) && (other.end$1.line$1 <= this.end$1.line$1))
});
$c_Lamf_core_parser_Range.prototype.init___Lamf_core_parser_Position__Lamf_core_parser_Position = (function(start, end) {
  this.start$1 = start;
  this.end$1 = end;
  return this
});
$c_Lamf_core_parser_Range.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_parser_Range.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_parser_Range.prototype.$$js$exported$meth$extent__Lamf_core_parser_Range__O = (function(other) {
  return this.extent__Lamf_core_parser_Range__Lamf_core_parser_Range(other)
});
$c_Lamf_core_parser_Range.prototype.extent__Lamf_core_parser_Range__Lamf_core_parser_Range = (function(other) {
  return new $c_Lamf_core_parser_Range().init___Lamf_core_parser_Position__Lamf_core_parser_Position(this.start$1.min__Lamf_core_parser_Position__Lamf_core_parser_Position(other.start$1), this.end$1.max__Lamf_core_parser_Position__Lamf_core_parser_Position(other.end$1))
});
$c_Lamf_core_parser_Range.prototype.contains = (function(arg) {
  var prep = $as_Lamf_core_parser_Range(arg);
  return this.$$js$exported$meth$contains__Lamf_core_parser_Range__O(prep)
});
$c_Lamf_core_parser_Range.prototype.toString = (function() {
  return this.$$js$exported$meth$toString__O()
});
$c_Lamf_core_parser_Range.prototype.extent = (function(arg) {
  var prep = $as_Lamf_core_parser_Range(arg);
  return this.$$js$exported$meth$extent__Lamf_core_parser_Range__O(prep)
});
Object.defineProperty($c_Lamf_core_parser_Range.prototype, "end", {
  "get": (function() {
    return this.$$js$exported$prop$end__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_core_parser_Range.prototype, "start", {
  "get": (function() {
    return this.$$js$exported$prop$start__O()
  }),
  "configurable": true
});
function $as_Lamf_core_parser_Range(obj) {
  return (((obj instanceof $c_Lamf_core_parser_Range) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.Range"))
}
function $isArrayOf_Lamf_core_parser_Range(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_Range)))
}
function $asArrayOf_Lamf_core_parser_Range(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_Range(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.Range;", depth))
}
var $d_Lamf_core_parser_Range = new $TypeData().initClass({
  Lamf_core_parser_Range: 0
}, false, "amf.core.parser.Range", {
  Lamf_core_parser_Range: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_Range.prototype.$classData = $d_Lamf_core_parser_Range;
/** @constructor */
function $c_Lamf_core_parser_RefContainer() {
  $c_O.call(this);
  this.linkType$1 = null;
  this.node$1 = null;
  this.fragment$1 = null
}
$c_Lamf_core_parser_RefContainer.prototype = new $h_O();
$c_Lamf_core_parser_RefContainer.prototype.constructor = $c_Lamf_core_parser_RefContainer;
/** @constructor */
function $h_Lamf_core_parser_RefContainer() {
  /*<skip>*/
}
$h_Lamf_core_parser_RefContainer.prototype = $c_Lamf_core_parser_RefContainer.prototype;
$c_Lamf_core_parser_RefContainer.prototype.productPrefix__T = (function() {
  return "RefContainer"
});
$c_Lamf_core_parser_RefContainer.prototype.getRefValue__p1__Lorg_yaml_model_YPart = (function() {
  var x1 = this.node$1;
  if ((x1 instanceof $c_Lorg_yaml_model_YNode$MutRef)) {
    var x2 = $as_Lorg_yaml_model_YNode$MutRef(x1);
    return x2.origValue$4
  } else {
    return this.node$1
  }
});
$c_Lamf_core_parser_RefContainer.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_core_parser_RefContainer.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_parser_RefContainer)) {
    var RefContainer$1 = $as_Lamf_core_parser_RefContainer(x$1);
    var x = this.linkType$1;
    var x$2 = RefContainer$1.linkType$1;
    if ((x === x$2)) {
      var this$1 = this.node$1;
      var b = RefContainer$1.node$1;
      var jsx$1 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.fragment$1;
      var x$4 = RefContainer$1.fragment$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_parser_RefContainer.prototype.init___Lamf_core_parser_ReferenceKind__Lorg_yaml_model_YNode__s_Option = (function(linkType, node, fragment) {
  this.linkType$1 = linkType;
  this.node$1 = node;
  this.fragment$1 = fragment;
  return this
});
$c_Lamf_core_parser_RefContainer.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.linkType$1;
      break
    }
    case 1: {
      return this.node$1;
      break
    }
    case 2: {
      return this.fragment$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_parser_RefContainer.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_parser_RefContainer.prototype.reduceStringLength__p1__Lorg_yaml_model_YScalar__I__I__Lamf_core_parser_Range = (function(s, fragmentLenght, markSize) {
  var this$1 = this.node$1.location$1;
  if (($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$1.lineFrom$1, this$1.columnFrom$1, this$1.lineTo$1, this$1.columnTo$1).columnTo$1 < fragmentLenght)) {
    var this$2 = this.node$1.location$1;
    var jsx$2 = $m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$2.lineFrom$1, this$2.columnFrom$1, this$2.lineTo$1, this$2.columnTo$1).lineFrom$1;
    var this$3 = this.node$1.location$1;
    var jsx$1 = (jsx$2 < $m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$3.lineFrom$1, this$3.columnFrom$1, this$3.lineTo$1, this$3.columnTo$1).lineTo$1)
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var x = s.text$3;
    var this$5 = new $c_sci_StringOps().init___T(x);
    var lines = $f_sci_StringLike__split__C__AT(this$5, 10);
    var len = lines.u.length;
    var i = 0;
    while (true) {
      if ((i < len)) {
        var index = i;
        var arg1 = lines.get(index);
        var x$1 = $as_T(arg1);
        var this$12 = new $c_sci_StringOps().init___T(x$1);
        var elem = new $c_jl_Character().init___C(35);
        var jsx$3 = (!$f_sc_SeqLike__contains__O__Z(this$12, elem))
      } else {
        var jsx$3 = false
      };
      if (jsx$3) {
        i = ((1 + i) | 0)
      } else {
        break
      }
    };
    var i$1 = i;
    var x1 = ((i$1 < lines.u.length) ? new $c_s_Some().init___O(lines.get(i$1)) : $m_s_None$());
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var line = $as_T(x2.value$2);
      var this$15 = this.node$1.location$1;
      var qual$1 = $m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$15.lineFrom$1, this$15.columnFrom$1, this$15.lineTo$1, this$15.columnTo$1);
      var this$16 = this.node$1.location$1;
      var jsx$5 = $m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$16.lineFrom$1, this$16.columnFrom$1, this$16.lineTo$1, this$16.columnTo$1).lineFrom$1;
      var len$1 = lines.u.length;
      var i$2 = 0;
      while (true) {
        if ((i$2 < len$1)) {
          var index$1 = i$2;
          var arg1$1 = lines.get(index$1);
          var jsx$4 = (!$m_sr_BoxesRunTime$().equals__O__O__Z(line, arg1$1))
        } else {
          var jsx$4 = false
        };
        if (jsx$4) {
          i$2 = ((1 + i$2) | 0)
        } else {
          break
        }
      };
      var n = i$2;
      var x$1$3 = ((jsx$5 + ((n >= lines.u.length) ? (-1) : n)) | 0);
      var x$2 = (((-1) + $m_sjsr_RuntimeString$().indexOf__T__I__I(line, 35)) | 0);
      var x$3 = qual$1.lineFrom$1;
      var x$4 = qual$1.columnFrom$1;
      var inputRange = new $c_Lorg_mulesoft_lexer_InputRange().init___I__I__I__I(x$3, x$4, x$1$3, x$2)
    } else {
      var this$23 = this.node$1.location$1;
      var inputRange = $m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$23.lineFrom$1, this$23.columnFrom$1, this$23.lineTo$1, this$23.columnTo$1)
    }
  } else {
    var this$24 = this.getRefValue__p1__Lorg_yaml_model_YPart().location$1;
    var qual$2 = $m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$24.lineFrom$1, this$24.columnFrom$1, this$24.lineTo$1, this$24.columnTo$1);
    var this$25 = this.node$1.location$1;
    var x$5 = (($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$25.lineFrom$1, this$25.columnFrom$1, this$25.lineTo$1, this$25.columnTo$1).columnTo$1 - fragmentLenght) | 0);
    var x$6 = qual$2.lineFrom$1;
    var x$7 = qual$2.columnFrom$1;
    var x$8 = qual$2.lineTo$1;
    var inputRange = new $c_Lorg_mulesoft_lexer_InputRange().init___I__I__I__I(x$6, x$7, x$8, x$5)
  };
  var _1$mcI$sp = inputRange.lineFrom$1;
  var _2$mcI$sp = ((inputRange.columnFrom$1 + markSize) | 0);
  var _1$mcI$sp$1 = inputRange.lineTo$1;
  var _2$mcI$sp$1 = ((inputRange.columnTo$1 - markSize) | 0);
  return new $c_Lamf_core_parser_Range().init___Lamf_core_parser_Position__Lamf_core_parser_Position(new $c_Lamf_core_parser_Position().init___I__I(_1$mcI$sp, _2$mcI$sp), new $c_Lamf_core_parser_Position().init___I__I(_1$mcI$sp$1, _2$mcI$sp$1))
});
$c_Lamf_core_parser_RefContainer.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_parser_RefContainer.prototype.reduceToLocation__Lamf_core_parser_Range = (function() {
  var this$1 = this.node$1;
  var evidence$1 = $m_Lamf_core_parser_package$YScalarYRead$();
  var x1 = $f_Lorg_yaml_model_YNodeLike__asOption__Lorg_yaml_convert_YRead__s_Option(this$1, evidence$1);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var s = $as_Lorg_yaml_model_YScalar(x2.value$2);
    var this$2 = this.fragment$1;
    if (this$2.isEmpty__Z()) {
      var this$4 = $m_s_None$()
    } else {
      var arg1 = this$2.get__O();
      var l = $as_T(arg1);
      var this$4 = new $c_s_Some().init___O(((1 + $uI(l.length)) | 0))
    };
    return this.reduceStringLength__p1__Lorg_yaml_model_YScalar__I__I__Lamf_core_parser_Range(s, $uI((this$4.isEmpty__Z() ? 0 : this$4.get__O())), (s.mark$3.plain__Z() ? 0 : 1))
  } else {
    var jsx$1 = $m_Lamf_core_parser_Range$();
    var this$5 = this.node$1.location$1;
    return jsx$1.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$5.lineFrom$1, this$5.columnFrom$1, this$5.lineTo$1, this$5.columnTo$1))
  }
});
$c_Lamf_core_parser_RefContainer.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_parser_RefContainer(obj) {
  return (((obj instanceof $c_Lamf_core_parser_RefContainer) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.RefContainer"))
}
function $isArrayOf_Lamf_core_parser_RefContainer(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_RefContainer)))
}
function $asArrayOf_Lamf_core_parser_RefContainer(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_RefContainer(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.RefContainer;", depth))
}
var $d_Lamf_core_parser_RefContainer = new $TypeData().initClass({
  Lamf_core_parser_RefContainer: 0
}, false, "amf.core.parser.RefContainer", {
  Lamf_core_parser_RefContainer: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_RefContainer.prototype.$classData = $d_Lamf_core_parser_RefContainer;
/** @constructor */
function $c_Lamf_core_parser_ReferenceCollector() {
  $c_O.call(this);
  this.refs$1 = null
}
$c_Lamf_core_parser_ReferenceCollector.prototype = new $h_O();
$c_Lamf_core_parser_ReferenceCollector.prototype.constructor = $c_Lamf_core_parser_ReferenceCollector;
/** @constructor */
function $h_Lamf_core_parser_ReferenceCollector() {
  /*<skip>*/
}
$h_Lamf_core_parser_ReferenceCollector.prototype = $c_Lamf_core_parser_ReferenceCollector.prototype;
$c_Lamf_core_parser_ReferenceCollector.prototype.init___ = (function() {
  this.refs$1 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  return this
});
$c_Lamf_core_parser_ReferenceCollector.prototype.productPrefix__T = (function() {
  return "ReferenceCollector"
});
$c_Lamf_core_parser_ReferenceCollector.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_parser_ReferenceCollector.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_core_parser_ReferenceCollector) && ($as_Lamf_core_parser_ReferenceCollector(x$1), true))
});
$c_Lamf_core_parser_ReferenceCollector.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_parser_ReferenceCollector.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_parser_ReferenceCollector.prototype.toReferences__sc_Seq = (function() {
  return this.refs$1.values__sc_Iterable().toSeq__sc_Seq()
});
$c_Lamf_core_parser_ReferenceCollector.prototype.$$plus$eq__T__Lamf_core_parser_ReferenceKind__Lorg_yaml_model_YNode__V = (function(key, kind, node) {
  var x1 = $m_Lamf_core_parser_ReferenceFragmentPartition$().apply__T__T2(key);
  if ((x1 === null)) {
    throw new $c_s_MatchError().init___O(x1)
  };
  var url = $as_T(x1.$$und1__O());
  var fragment = $as_s_Option(x1.$$und2__O());
  var x1$2 = this.refs$1.get__O__s_Option(url);
  matchEnd6: {
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var reference = $as_Lamf_core_parser_Reference(x2.value$2);
      if ((reference !== null)) {
        this.refs$1.update__O__O__V(url, reference.$$plus__Lamf_core_parser_ReferenceKind__Lorg_yaml_model_YNode__s_Option__Lamf_core_parser_Reference(kind, node, fragment));
        break matchEnd6
      }
    };
    var x = $m_s_None$();
    if ((x === x1$2)) {
      var jsx$1 = this.refs$1;
      var y = $m_Lamf_core_parser_Reference$().apply__T__Lamf_core_parser_ReferenceKind__Lorg_yaml_model_YNode__s_Option__Lamf_core_parser_Reference(url, kind, node, fragment);
      jsx$1.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(url, y));
      break matchEnd6
    };
    throw new $c_s_MatchError().init___O(x1$2)
  }
});
$c_Lamf_core_parser_ReferenceCollector.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_parser_ReferenceCollector.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_parser_ReferenceCollector(obj) {
  return (((obj instanceof $c_Lamf_core_parser_ReferenceCollector) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.ReferenceCollector"))
}
function $isArrayOf_Lamf_core_parser_ReferenceCollector(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_ReferenceCollector)))
}
function $asArrayOf_Lamf_core_parser_ReferenceCollector(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_ReferenceCollector(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.ReferenceCollector;", depth))
}
var $d_Lamf_core_parser_ReferenceCollector = new $TypeData().initClass({
  Lamf_core_parser_ReferenceCollector: 0
}, false, "amf.core.parser.ReferenceCollector", {
  Lamf_core_parser_ReferenceCollector: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_ReferenceCollector.prototype.$classData = $d_Lamf_core_parser_ReferenceCollector;
/** @constructor */
function $c_Lamf_core_parser_ReferenceResolutionResult() {
  $c_O.call(this);
  this.exception$1 = null;
  this.unit$1 = null
}
$c_Lamf_core_parser_ReferenceResolutionResult.prototype = new $h_O();
$c_Lamf_core_parser_ReferenceResolutionResult.prototype.constructor = $c_Lamf_core_parser_ReferenceResolutionResult;
/** @constructor */
function $h_Lamf_core_parser_ReferenceResolutionResult() {
  /*<skip>*/
}
$h_Lamf_core_parser_ReferenceResolutionResult.prototype = $c_Lamf_core_parser_ReferenceResolutionResult.prototype;
$c_Lamf_core_parser_ReferenceResolutionResult.prototype.productPrefix__T = (function() {
  return "ReferenceResolutionResult"
});
$c_Lamf_core_parser_ReferenceResolutionResult.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_parser_ReferenceResolutionResult.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_parser_ReferenceResolutionResult)) {
    var ReferenceResolutionResult$1 = $as_Lamf_core_parser_ReferenceResolutionResult(x$1);
    var x = this.exception$1;
    var x$2 = ReferenceResolutionResult$1.exception$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.unit$1;
      var x$4 = ReferenceResolutionResult$1.unit$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_parser_ReferenceResolutionResult.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.exception$1;
      break
    }
    case 1: {
      return this.unit$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_parser_ReferenceResolutionResult.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_parser_ReferenceResolutionResult.prototype.init___s_Option__s_Option = (function(exception, unit) {
  this.exception$1 = exception;
  this.unit$1 = unit;
  return this
});
$c_Lamf_core_parser_ReferenceResolutionResult.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_parser_ReferenceResolutionResult.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_parser_ReferenceResolutionResult(obj) {
  return (((obj instanceof $c_Lamf_core_parser_ReferenceResolutionResult) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.ReferenceResolutionResult"))
}
function $isArrayOf_Lamf_core_parser_ReferenceResolutionResult(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_ReferenceResolutionResult)))
}
function $asArrayOf_Lamf_core_parser_ReferenceResolutionResult(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_ReferenceResolutionResult(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.ReferenceResolutionResult;", depth))
}
var $d_Lamf_core_parser_ReferenceResolutionResult = new $TypeData().initClass({
  Lamf_core_parser_ReferenceResolutionResult: 0
}, false, "amf.core.parser.ReferenceResolutionResult", {
  Lamf_core_parser_ReferenceResolutionResult: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_ReferenceResolutionResult.prototype.$classData = $d_Lamf_core_parser_ReferenceResolutionResult;
/** @constructor */
function $c_Lamf_core_parser_ValueNode() {
  $c_O.call(this);
  this.node$1 = null;
  this.iv$1 = null
}
$c_Lamf_core_parser_ValueNode.prototype = new $h_O();
$c_Lamf_core_parser_ValueNode.prototype.constructor = $c_Lamf_core_parser_ValueNode;
/** @constructor */
function $h_Lamf_core_parser_ValueNode() {
  /*<skip>*/
}
$h_Lamf_core_parser_ValueNode.prototype = $c_Lamf_core_parser_ValueNode.prototype;
$c_Lamf_core_parser_ValueNode.prototype.productPrefix__T = (function() {
  return "ValueNode"
});
$c_Lamf_core_parser_ValueNode.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_parser_ValueNode.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_parser_ValueNode)) {
    var ValueNode$1 = $as_Lamf_core_parser_ValueNode(x$1);
    var this$1 = this.node$1;
    var b = ValueNode$1.node$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_core_parser_ValueNode.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.node$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_parser_ValueNode.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_parser_ValueNode.prototype.init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler = (function(node, iv) {
  this.node$1 = node;
  this.iv$1 = iv;
  return this
});
$c_Lamf_core_parser_ValueNode.prototype.string__Lamf_core_model_domain_AmfScalar = (function() {
  var this$1 = this.node$1;
  var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
  var iv = this.iv$1;
  var content = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(content, this.annotations__p1__Lamf_core_parser_Annotations())
});
$c_Lamf_core_parser_ValueNode.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_parser_ValueNode.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_parser_ValueNode.prototype.annotations__p1__Lamf_core_parser_Annotations = (function() {
  return $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.node$1.value__Lorg_yaml_model_YValue())
});
function $as_Lamf_core_parser_ValueNode(obj) {
  return (((obj instanceof $c_Lamf_core_parser_ValueNode) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.ValueNode"))
}
function $isArrayOf_Lamf_core_parser_ValueNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_ValueNode)))
}
function $asArrayOf_Lamf_core_parser_ValueNode(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_ValueNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.ValueNode;", depth))
}
var $d_Lamf_core_parser_ValueNode = new $TypeData().initClass({
  Lamf_core_parser_ValueNode: 0
}, false, "amf.core.parser.ValueNode", {
  Lamf_core_parser_ValueNode: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_ValueNode.prototype.$classData = $d_Lamf_core_parser_ValueNode;
function $is_Lamf_core_parser_errorhandler_AmfParserErrorHandler(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_parser_errorhandler_AmfParserErrorHandler)))
}
function $as_Lamf_core_parser_errorhandler_AmfParserErrorHandler(obj) {
  return (($is_Lamf_core_parser_errorhandler_AmfParserErrorHandler(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.errorhandler.AmfParserErrorHandler"))
}
function $isArrayOf_Lamf_core_parser_errorhandler_AmfParserErrorHandler(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_errorhandler_AmfParserErrorHandler)))
}
function $asArrayOf_Lamf_core_parser_errorhandler_AmfParserErrorHandler(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_errorhandler_AmfParserErrorHandler(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.errorhandler.AmfParserErrorHandler;", depth))
}
/** @constructor */
function $c_Lamf_core_parser_errorhandler_RuntimeWrapperErrorHandler() {
  $c_O.call(this);
  this.parent$1 = null
}
$c_Lamf_core_parser_errorhandler_RuntimeWrapperErrorHandler.prototype = new $h_O();
$c_Lamf_core_parser_errorhandler_RuntimeWrapperErrorHandler.prototype.constructor = $c_Lamf_core_parser_errorhandler_RuntimeWrapperErrorHandler;
/** @constructor */
function $h_Lamf_core_parser_errorhandler_RuntimeWrapperErrorHandler() {
  /*<skip>*/
}
$h_Lamf_core_parser_errorhandler_RuntimeWrapperErrorHandler.prototype = $c_Lamf_core_parser_errorhandler_RuntimeWrapperErrorHandler.prototype;
$c_Lamf_core_parser_errorhandler_RuntimeWrapperErrorHandler.prototype.init___Lamf_core_parser_errorhandler_ParserErrorHandler = (function(parent) {
  this.parent$1 = parent;
  return this
});
$c_Lamf_core_parser_errorhandler_RuntimeWrapperErrorHandler.prototype.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V = (function(specification, node, property, message, lexical, location) {
  this.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().WARNING$1, location)
});
$c_Lamf_core_parser_errorhandler_RuntimeWrapperErrorHandler.prototype.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V = (function(id, node, property, message, lexical, level, location) {
  this.parent$1.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(id, node, property, message, lexical, level, location)
});
/** @constructor */
function $c_Lamf_core_plugin_PluginContext() {
  $c_O.call(this);
  this.blacklist$1 = null;
  this.blacklistedTypes$1 = null;
  this.blacklistedResolvers$1 = null;
  this.types$1 = null;
  this.resolvers$1 = null
}
$c_Lamf_core_plugin_PluginContext.prototype = new $h_O();
$c_Lamf_core_plugin_PluginContext.prototype.constructor = $c_Lamf_core_plugin_PluginContext;
/** @constructor */
function $h_Lamf_core_plugin_PluginContext() {
  /*<skip>*/
}
$h_Lamf_core_plugin_PluginContext.prototype = $c_Lamf_core_plugin_PluginContext.prototype;
$c_Lamf_core_plugin_PluginContext.prototype.productPrefix__T = (function() {
  return "PluginContext"
});
$c_Lamf_core_plugin_PluginContext.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_plugin_PluginContext.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_plugin_PluginContext)) {
    var PluginContext$1 = $as_Lamf_core_plugin_PluginContext(x$1);
    var x = this.blacklist$1;
    var x$2 = PluginContext$1.blacklist$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_core_plugin_PluginContext.prototype.buildType__Lamf_core_metamodel_Obj__F1 = (function(type) {
  var x1 = this.types$1.get__O__s_Option($m_Lamf_core_registries_AMFDomainRegistry$().defaultIri__Lamf_core_metamodel_Obj__T(type));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var builder = $as_Lamf_core_metamodel_Obj(x2.value$2);
    if ($is_Lamf_core_metamodel_ModelDefaultBuilder(builder)) {
      return new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x3) {
        return (function(annotations$2) {
          var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
          var instance = $as_Lamf_core_metamodel_ModelDefaultBuilder(x3).modelInstance__Lamf_core_model_domain_AmfObject();
          instance.annotations__Lamf_core_parser_Annotations().$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(annotations);
          return instance
        })
      })(this, builder))
    }
  };
  var this$1 = this.resolvers$1.iterator__sc_Iterator();
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, type$1) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_registries_AMFDomainEntityResolver(x$2$2);
      return x$2.buildType__Lamf_core_metamodel_Obj__s_Option(type$1)
    })
  })(this, type));
  var this$3 = new $c_sc_Iterator$$anon$10().init___sc_Iterator__F1(this$1, f);
  var pf = new $c_Lamf_core_plugin_PluginContext$$anonfun$buildType$3().init___Lamf_core_plugin_PluginContext(this);
  var this$4 = $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$3, pf);
  if (this$4.isEmpty__Z()) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot find builder for type " + type)))
  };
  return $as_F1(this$4.get__O())
});
$c_Lamf_core_plugin_PluginContext.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.blacklist$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_plugin_PluginContext.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_plugin_PluginContext.prototype.findType__T__s_Option = (function(type) {
  var this$1 = this.types$1.get__O__s_Option(type);
  if (this$1.isEmpty__Z()) {
    var this$2 = this.resolvers$1.iterator__sc_Iterator();
    var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, type$1) {
      return (function(x$1$2) {
        var x$1 = $as_Lamf_core_registries_AMFDomainEntityResolver(x$1$2);
        return x$1.findType__T__s_Option(type$1)
      })
    })(this, type));
    var this$3 = new $c_sc_Iterator$$anon$10().init___sc_Iterator__F1(this$2, f);
    var pf = new $c_Lamf_core_plugin_PluginContext$$anonfun$$nestedInanonfun$findType$1$1().init___Lamf_core_plugin_PluginContext(this);
    return $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$3, pf)
  } else {
    return this$1
  }
});
$c_Lamf_core_plugin_PluginContext.prototype.init___sc_Seq = (function(blacklist) {
  this.blacklist$1 = blacklist;
  var jsx$1 = new $c_Lamf_core_plugin_PluginContext$$anonfun$1().init___Lamf_core_plugin_PluginContext(this);
  var this$1 = $m_sc_Seq$();
  this.blacklistedTypes$1 = $as_sc_Seq($as_scg_GenericTraversableTemplate(blacklist.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).flatten__F1__sc_GenTraversable($m_s_Predef$().singleton$und$less$colon$less$2));
  var jsx$2 = new $c_Lamf_core_plugin_PluginContext$$anonfun$2().init___Lamf_core_plugin_PluginContext(this);
  var this$2 = $m_sc_Seq$();
  this.blacklistedResolvers$1 = $as_sc_Seq($as_scg_GenericTraversableTemplate(blacklist.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$2, this$2.ReusableCBFInstance$2)).flatten__F1__sc_GenTraversable(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(xo$2) {
      var xo = $as_s_Option(xo$2);
      return xo.toList__sci_List()
    })
  })(this))));
  var jsx$5 = $m_sci_TreeSet$();
  var jsx$4 = this.blacklistedTypes$1;
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(metadata$2) {
      var metadata = $as_Lamf_core_metamodel_Obj(metadata$2);
      return $m_Lamf_core_registries_AMFDomainRegistry$().defaultIri__Lamf_core_metamodel_Obj__T(metadata)
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  var ignored = $as_sci_TreeSet(jsx$5.apply__sc_Seq__s_math_Ordering__sc_SortedSet($as_sc_Seq(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$4.ReusableCBFInstance$2)), $m_s_math_Ordering$String$()));
  var this$5 = $m_Lamf_core_registries_AMFDomainRegistry$().metadataRegistry$1;
  var ev = $m_s_Predef$().singleton$und$less$colon$less$2;
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  this$5.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, b$1, ev$1) {
    return (function(x$2) {
      return b$1.$$plus$eq__O__scm_Builder(x$2)
    })
  })(this$5, b, ev)));
  var this$7 = $as_sci_Map(b.elems$1);
  var p = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, ignored$1) {
    return (function(k$2) {
      var k = $as_T(k$2);
      return (!ignored$1.contains__O__Z(k))
    })
  })(this, ignored));
  this.types$1 = new $c_sci_MapLike$$anon$1().init___sci_MapLike__F1(this$7, p);
  var this$8 = $m_Lamf_core_registries_AMFDomainRegistry$().metadataResolverRegistry$1;
  var xs = this.blacklistedResolvers$1;
  var this$9 = new $c_scm_ListBuffer().init___().$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(this$8);
  var xs$1 = xs.seq__sc_TraversableOnce();
  this.resolvers$1 = $as_scm_Buffer($f_scg_Shrinkable__$$minus$minus$eq__sc_TraversableOnce__scg_Shrinkable(this$9, xs$1));
  return this
});
$c_Lamf_core_plugin_PluginContext.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_plugin_PluginContext.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_plugin_PluginContext(obj) {
  return (((obj instanceof $c_Lamf_core_plugin_PluginContext) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.plugin.PluginContext"))
}
function $isArrayOf_Lamf_core_plugin_PluginContext(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_plugin_PluginContext)))
}
function $asArrayOf_Lamf_core_plugin_PluginContext(obj, depth) {
  return (($isArrayOf_Lamf_core_plugin_PluginContext(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.plugin.PluginContext;", depth))
}
var $d_Lamf_core_plugin_PluginContext = new $TypeData().initClass({
  Lamf_core_plugin_PluginContext: 0
}, false, "amf.core.plugin.PluginContext", {
  Lamf_core_plugin_PluginContext: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_plugin_PluginContext.prototype.$classData = $d_Lamf_core_plugin_PluginContext;
/** @constructor */
function $c_Lamf_core_rdf_Node() {
  $c_O.call(this);
  this.subject$1 = null;
  this.classes$1 = null;
  this.properties$1 = null
}
$c_Lamf_core_rdf_Node.prototype = new $h_O();
$c_Lamf_core_rdf_Node.prototype.constructor = $c_Lamf_core_rdf_Node;
/** @constructor */
function $h_Lamf_core_rdf_Node() {
  /*<skip>*/
}
$h_Lamf_core_rdf_Node.prototype = $c_Lamf_core_rdf_Node.prototype;
$c_Lamf_core_rdf_Node.prototype.productPrefix__T = (function() {
  return "Node"
});
$c_Lamf_core_rdf_Node.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_core_rdf_Node.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_rdf_Node)) {
    var Node$1 = $as_Lamf_core_rdf_Node(x$1);
    if ((this.subject$1 === Node$1.subject$1)) {
      var x = this.classes$1;
      var x$2 = Node$1.classes$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.properties$1;
      var x$4 = Node$1.properties$1;
      return ((x$3 === null) ? (x$4 === null) : $f_sc_GenMapLike__equals__O__Z(x$3, x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_rdf_Node.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.subject$1;
      break
    }
    case 1: {
      return this.classes$1;
      break
    }
    case 2: {
      return this.properties$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_rdf_Node.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_rdf_Node.prototype.getKeys__sc_Seq = (function() {
  var this$1 = this.properties$1;
  var this$2 = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(this$1);
  return $as_sc_Seq($f_sc_SetLike__toSeq__sc_Seq(this$2).sortWith__F2__O(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(t1$2, t2$2) {
      var t1 = $as_T(t1$2);
      var t2 = $as_T(t2$2);
      var this$4 = new $c_sci_StringOps().init___T(t1);
      var $$this = this$4.repr$1;
      return ((($$this === t2) ? 0 : ($uZ(($$this < t2)) ? (-1) : 1)) > 0)
    })
  })(this))))
});
$c_Lamf_core_rdf_Node.prototype.getProperties__T__s_Option = (function(iri) {
  var this$1 = this.properties$1.get__O__s_Option(iri);
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_sc_Seq(arg1);
    return new $c_s_Some().init___O($as_sc_Seq(x$1.sortWith__F2__O(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
      return (function(t1$2, t2$2) {
        var t1 = $as_Lamf_core_rdf_PropertyObject(t1$2);
        var t2 = $as_Lamf_core_rdf_PropertyObject(t2$2);
        var thiz = t1.value__T();
        var anotherString = t2.value__T();
        return (((thiz === anotherString) ? 0 : ($uZ((thiz < anotherString)) ? (-1) : 1)) > 0)
      })
    })(this)))))
  }
});
$c_Lamf_core_rdf_Node.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_rdf_Node.prototype.init___T__sc_Seq__sci_Map = (function(subject, classes, properties) {
  this.subject$1 = subject;
  this.classes$1 = classes;
  this.properties$1 = properties;
  return this
});
$c_Lamf_core_rdf_Node.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_rdf_Node(obj) {
  return (((obj instanceof $c_Lamf_core_rdf_Node) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.rdf.Node"))
}
function $isArrayOf_Lamf_core_rdf_Node(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_rdf_Node)))
}
function $asArrayOf_Lamf_core_rdf_Node(obj, depth) {
  return (($isArrayOf_Lamf_core_rdf_Node(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.rdf.Node;", depth))
}
var $d_Lamf_core_rdf_Node = new $TypeData().initClass({
  Lamf_core_rdf_Node: 0
}, false, "amf.core.rdf.Node", {
  Lamf_core_rdf_Node: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_rdf_Node.prototype.$classData = $d_Lamf_core_rdf_Node;
/** @constructor */
function $c_Lamf_core_rdf_RdfModelEmitter$Emitter() {
  $c_O.call(this);
  this.options$1 = null;
  this.traversal$1 = null;
  this.rootId$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype = new $h_O();
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.constructor = $c_Lamf_core_rdf_RdfModelEmitter$Emitter;
/** @constructor */
function $h_Lamf_core_rdf_RdfModelEmitter$Emitter() {
  /*<skip>*/
}
$h_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype = $c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype;
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.root__Lamf_core_model_document_BaseUnit__V = (function(unit) {
  this.rootId$1 = new $c_s_Some().init___O(unit.id__T());
  this.traverse__Lamf_core_model_domain_AmfObject__V(unit)
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.createTypeNode__p1__T__Lamf_core_metamodel_Obj__s_Option__V = (function(id, obj, maybeElement) {
  var this$2 = obj.type__sci_List();
  var f = (function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_vocabulary_ValueType(x$1$2);
      return x$1.iri__T()
    })
  })(this);
  var this$1 = $m_sci_List$();
  var bf = this$1.ReusableCBFInstance$2;
  if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
    if ((this$2 === $m_sci_Nil$())) {
      var jsx$1 = $m_sci_Nil$()
    } else {
      var arg1 = this$2.head__O();
      var h = new $c_sci_$colon$colon().init___O__sci_List(f(arg1), $m_sci_Nil$());
      var t = h;
      var rest = $as_sci_List(this$2.tail__O());
      while ((rest !== $m_sci_Nil$())) {
        var arg1$1 = rest.head__O();
        var nx = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$1), $m_sci_Nil$());
        t.tl$5 = nx;
        t = nx;
        rest = $as_sci_List(rest.tail__O())
      };
      var jsx$1 = h
    }
  } else {
    var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$2, bf);
    var these = this$2;
    while ((!these.isEmpty__Z())) {
      var arg1$2 = these.head__O();
      b.$$plus$eq__O__scm_Builder(f(arg1$2));
      these = $as_sci_List(these.tail__O())
    };
    var jsx$1 = b.result__O()
  };
  var allTypes = $as_sci_List(jsx$1);
  var these$1 = allTypes;
  while ((!these$1.isEmpty__Z())) {
    var arg1$3 = these$1.head__O();
    var t$1 = $as_T(arg1$3);
    var jsx$2 = this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f;
    var this$3 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
    jsx$2.addTriple__T__T__T__Lamf_core_rdf_RdfModel(id, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "type").iri__T(), t$1);
    these$1 = $as_sci_List(these$1.tail__O())
  }
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.productPrefix__T = (function() {
  return "Emitter"
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.emitStaticField__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject__Lamf_core_metamodel_Obj__Lamf_core_model_document_SourceMap__V = (function(field, id, element, obj, sources) {
  var x1 = element.fields__Lamf_core_parser_Fields().entryJsonld__Lamf_core_metamodel_Field__s_Option(field);
  matchEnd6: {
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var p3 = $as_Lamf_core_parser_FieldEntry(x2.value$2);
      if ((p3 !== null)) {
        var f = p3.field$1;
        var v = p3.value$1;
        var url = f.value$1.iri__T();
        sources.property__T__Lamf_core_parser_Value__V(url, v);
        this.objectValue__p1__T__T__Lamf_core_metamodel_Type__Lamf_core_parser_Value__V(id, url, f.type$1, v);
        break matchEnd6
      }
    };
    var x = $m_s_None$();
    if ((x === x1)) {
      break matchEnd6
    };
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.traverse__Lamf_core_model_domain_AmfObject__V = (function(element) {
  var this$1 = this.traversal$1;
  var id = element.id__T();
  if (((!this$1.currentPath$1.contains__O__Z(id)) || this.selfEncoded__Lamf_core_model_domain_AmfObject__Z(element))) {
    var id$1 = element.id__T();
    this.traversal$1.$$plus__T__Lamf_core_traversal_ModelTraversalRegistry(id$1);
    var sources = $m_Lamf_core_model_document_SourceMap$().apply__T__Lamf_core_model_domain_AmfElement__Lamf_core_model_document_SourceMap(id$1, element);
    var this$2 = this.$$outer$1;
    var obj = $f_Lamf_core_metamodel_MetaModelTypeMapping__metaModel__O__Lamf_core_metamodel_Obj(this$2, element);
    this.createTypeNode__p1__T__Lamf_core_metamodel_Obj__s_Option__V(id$1, obj, new $c_s_Some().init___O(element));
    var jsx$4 = obj.fields__sci_List();
    if ($is_Lamf_core_metamodel_domain_ShapeModel(obj)) {
      var jsx$3 = $m_sc_Seq$();
      var array = [$m_Lamf_core_metamodel_domain_ShapeModel$().CustomShapePropertyDefinitions__Lamf_core_metamodel_Field(), $m_Lamf_core_metamodel_domain_ShapeModel$().CustomShapeProperties__Lamf_core_metamodel_Field()];
      var jsx$2 = $as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
    } else {
      var jsx$2 = $m_sci_Nil$()
    };
    var jsx$1 = $as_sc_GenTraversableOnce(jsx$2.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(field$2) {
        var field = $as_Lamf_core_metamodel_Field(field$2);
        return $this.options$1.renderField__Lamf_core_metamodel_Field__Z(field)
      })
    })(this))));
    var this$5 = $m_sci_List$();
    var modelFields = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2));
    matchEnd4$2: {
      if ((element instanceof $c_Lamf_core_model_domain_ObjectNode)) {
        var x2 = $as_Lamf_core_model_domain_ObjectNode(element);
        var this$6 = this.options$1;
        if (this$6.validating$1) {
          var url = ($m_Lamf_core_vocabulary_Namespace$().AmfValidation$1.base$1 + "/properties");
          var jsx$5 = $m_Lamf_core_metamodel_Type$Int$();
          var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(x2.propertyFields__sc_Iterable().size__I(), new $c_Lamf_core_parser_Annotations().init___());
          $m_Lamf_core_parser_Annotations$();
          var annotations = new $c_Lamf_core_parser_Annotations().init___();
          this.objectValue__p1__T__T__Lamf_core_metamodel_Type__Lamf_core_parser_Value__V(id$1, url, jsx$5, new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value, annotations));
          break matchEnd4$2
        }
      }
    };
    var these = modelFields;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      var f = $as_Lamf_core_metamodel_Field(arg1);
      this.emitStaticField__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject__Lamf_core_metamodel_Obj__Lamf_core_model_document_SourceMap__V(f, id$1, element, obj, sources);
      these = $as_sci_List(these.tail__O())
    };
    this.createCustomExtensions__p1__Lamf_core_model_domain_AmfObject__V(element);
    var this$10 = this.$$outer$1;
    var sourceMapId = $f_Lamf_plugins_document_graph_emitter_CommonEmitter__sourceMapIdFor__T__T(this$10, id$1);
    this.createSourcesNode__p1__T__Lamf_core_model_document_SourceMap__T__V(id$1, sources, sourceMapId)
  }
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_core_rdf_RdfModelEmitter$Emitter) && ($as_Lamf_core_rdf_RdfModelEmitter$Emitter(x$1).$$outer$1 === this.$$outer$1))) {
    var Emitter$1 = $as_Lamf_core_rdf_RdfModelEmitter$Emitter(x$1);
    var x = this.options$1;
    var x$2 = Emitter$1.options$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.init___Lamf_core_rdf_RdfModelEmitter__Lamf_core_emitter_RenderOptions = (function($$outer, options) {
  this.options$1 = options;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.traversal$1 = new $c_Lamf_core_traversal_ModelTraversalRegistry().init___();
  this.rootId$1 = $m_s_None$();
  return this
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.options$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.iri__p1__T__T__T__V = (function(subject, property, content) {
  this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f.addTriple__T__T__T__Lamf_core_rdf_RdfModel(subject, property, content)
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.safeIri__p1__T__T__T__V = (function(subject, property, content) {
  this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f.addTriple__T__T__T__Lamf_core_rdf_RdfModel(subject, property, content)
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.createAnnotationNodes__p1__T__Lamf_core_model_document_SourceMap__V = (function(id, sources) {
  var this$2 = sources.annotations$1;
  var this$1 = $m_scm_ListMap$();
  var bf = new $c_scg_GenMapFactory$MapCanBuildFrom().init___scg_GenMapFactory(this$1);
  $as_sc_IterableLike($f_sc_IterableLike__zipWithIndex__scg_CanBuildFrom__O(this$2, bf)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, id$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      matchEnd4: {
        if ((x0$1 !== null)) {
          var p2 = $as_T2(x0$1.$$und1__O());
          var i = x0$1.$$und2$mcI$sp__I();
          if ((p2 !== null)) {
            var a = $as_T(p2.$$und1__O());
            var values = $as_scm_ListMap(p2.$$und2__O());
            var this$3 = $m_scm_ListMap$();
            var bf$1 = new $c_scg_GenMapFactory$MapCanBuildFrom().init___scg_GenMapFactory(this$3);
            $as_sc_IterableLike($f_sc_IterableLike__zipWithIndex__scg_CanBuildFrom__O(values, bf$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, id$5, i$1, a$1) {
              return (function(x0$2$2) {
                var x0$2 = $as_T2(x0$2$2);
                if ((x0$2 !== null)) {
                  var p2$1 = $as_T2(x0$2.$$und1__O());
                  var j = x0$2.$$und2$mcI$sp__I();
                  if ((p2$1 !== null)) {
                    var iri = $as_T(p2$1.$$und1__O());
                    var v = $as_T(p2$1.$$und2__O());
                    var valueNodeId = ((((id$5 + "_") + i$1) + "_") + j);
                    var jsx$1 = $this$1.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f;
                    var ns = $m_Lamf_core_vocabulary_Namespace$().SourceMaps$1;
                    jsx$1.addTriple__T__T__T__Lamf_core_rdf_RdfModel(id$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns, a$1).iri__T(), valueNodeId);
                    $this$1.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f.addTriple__T__T__T__Lamf_core_rdf_RdfModel(valueNodeId, $m_Lamf_core_metamodel_document_SourceMapModel$().Element$1.value$1.iri__T(), iri);
                    return $this$1.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(valueNodeId, $m_Lamf_core_metamodel_document_SourceMapModel$().Value$1.value$1.iri__T(), v, $m_s_None$())
                  }
                };
                throw new $c_s_MatchError().init___O(x0$2)
              })
            })($this, id$1, i, a)));
            break matchEnd4
          }
        };
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, id)))
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.emitFloatLiteral__T__T__T__V = (function(subject, property, v) {
  try {
    var jsx$2 = this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f;
    var this$2 = new $c_sci_StringOps().init___T(v);
    var jsx$1 = $m_jl_Double$();
    var $$this = this$2.repr$1;
    var this$4 = jsx$1.parseDouble__T__D($$this);
    jsx$2.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(subject, property, ("" + this$4), new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Double$1))
  } catch (e) {
    if ((e instanceof $c_jl_NumberFormatException)) {
      this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(subject, property, v, $m_s_None$())
    } else {
      throw e
    }
  }
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.createSourcesNode__p1__T__Lamf_core_model_document_SourceMap__T__V = (function(id, sources, sourceMapId) {
  var this$1 = this.options$1;
  if (this$1.amf$core$emitter$RenderOptions$$sources$1) {
    var this$2 = sources.annotations$1;
    var jsx$1 = $f_sc_TraversableOnce__nonEmpty__Z(this$2)
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f.addTriple__T__T__T__Lamf_core_rdf_RdfModel(id, $m_Lamf_core_metamodel_domain_DomainElementModel$().Sources$1.value$1.iri__T(), sourceMapId);
    this.createTypeNode__p1__T__Lamf_core_metamodel_Obj__s_Option__V(sourceMapId, $m_Lamf_core_metamodel_document_SourceMapModel$(), $m_s_None$());
    this.createAnnotationNodes__p1__T__Lamf_core_model_document_SourceMap__V(sourceMapId, sources)
  }
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.obj__p1__T__T__Lamf_core_model_domain_AmfObject__V = (function(subject, property, element) {
  this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f.addTriple__T__T__T__Lamf_core_rdf_RdfModel(subject, property, element.id__T());
  this.traverse__Lamf_core_model_domain_AmfObject__V(element)
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.createCustomExtensions__p1__Lamf_core_model_domain_AmfObject__V = (function(element) {
  var id = element.id__T();
  var customProperties = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = element.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field());
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var x0$1 = $as_Lamf_core_parser_FieldEntry(arg1);
    if ((x0$1 !== null)) {
      var v = x0$1.value$1;
      var x1$2 = v.value$1;
      if ((x1$2 instanceof $c_Lamf_core_model_domain_AmfArray)) {
        var x2 = $as_Lamf_core_model_domain_AmfArray(x1$2);
        var values = x2.values$1;
        values.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, customProperties$1, id$2) {
          return (function(x0$2$2) {
            var x0$2 = $as_Lamf_core_model_domain_AmfElement(x0$2$2);
            if ((x0$2 instanceof $c_Lamf_core_model_domain_extensions_DomainExtension)) {
              var x2$1 = $as_Lamf_core_model_domain_extensions_DomainExtension(x0$2);
              var uri = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(x2$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().DefinedBy$1)).id$1;
              customProperties$1.$$plus$eq__O__scm_ListBuffer(uri);
              $this.createCustomExtension__p1__T__T__Lamf_core_model_domain_extensions_DomainExtension__s_Option__V(id$2, uri, x2$1, $m_s_None$())
            } else {
              throw new $c_s_MatchError().init___O(x0$2)
            }
          })
        })(this, customProperties, id)))
      }
    } else {
      throw new $c_s_MatchError().init___O(x0$1)
    }
  };
  var count = new $c_sr_IntRef().init___I(1);
  var this$8 = element.fields__Lamf_core_parser_Fields();
  var fn = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, element$1, count$1, customProperties$2, id$1) {
    return (function(x0$3$2) {
      var x0$3 = $as_T2(x0$3$2);
      if ((x0$3 !== null)) {
        var f = $as_Lamf_core_metamodel_Field(x0$3.$$und1__O());
        var v$1 = $as_Lamf_core_parser_Value(x0$3.$$und2__O());
        var this$3 = v$1.value$1.annotations__Lamf_core_parser_Annotations();
        var pf = new $c_Lamf_core_rdf_RdfModelEmitter$Emitter$$anonfun$$nestedInanonfun$createCustomExtensions$3$1().init___Lamf_core_rdf_RdfModelEmitter$Emitter(this$2$1);
        var this$5 = this$3.amf$core$parser$Annotations$$annotations$1;
        var this$4 = $m_scm_ListBuffer$();
        var bf = this$4.ReusableCBFInstance$2;
        $as_sc_Seq($f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this$5, pf, bf)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, element$2, count$1$1, customProperties$1$1, id$2$1, f$1) {
          return (function(e$2) {
            var e = $as_Lamf_core_annotations_DomainExtensionAnnotation(e$2);
            var extension = e.extension$1;
            var jsx$2 = element$2.id__T();
            var jsx$1 = count$1$1.elem$1;
            var this$6 = $as_Lamf_core_model_StrField(extension.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1));
            var this$7 = this$6.option$1;
            var uri$1 = ((((jsx$2 + "/scalar-valued/") + jsx$1) + "/") + $as_T((this$7.isEmpty__Z() ? null : this$7.get__O())));
            customProperties$1$1.$$plus$eq__O__scm_ListBuffer(uri$1);
            $m_Lamf_core_model_domain_DataNodeOps$().adoptTree__T__Lamf_core_model_domain_DataNode__Lamf_core_model_domain_DataNode(uri$1, $as_Lamf_core_model_domain_DataNode(extension.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)));
            $this$1.createCustomExtension__p1__T__T__Lamf_core_model_domain_extensions_DomainExtension__s_Option__V(id$2$1, uri$1, extension, new $c_s_Some().init___O(f$1));
            count$1$1.elem$1 = ((1 + count$1$1.elem$1) | 0)
          })
        })(this$2$1, element$1, count$1, customProperties$2, id$1, f)))
      } else {
        throw new $c_s_MatchError().init___O(x0$3)
      }
    })
  })(this, element, count, customProperties, id));
  this$8.fs$1.foreach__F1__V(fn);
  if (customProperties.nonEmpty__Z()) {
    var this$9 = customProperties.scala$collection$mutable$ListBuffer$$start$6;
    var these = this$9;
    while ((!these.isEmpty__Z())) {
      var arg1$1 = these.head__O();
      var customPropertyId = $as_T(arg1$1);
      this.iri__p1__T__T__T__V(id, $m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field().value$1.iri__T(), customPropertyId);
      these = $as_sci_List(these.tail__O())
    }
  }
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.selfEncoded__Lamf_core_model_domain_AmfObject__Z = (function(element) {
  var jsx$1 = element.id__T();
  var this$1 = this.rootId$1;
  if ((jsx$1 === (this$1.isEmpty__Z() ? "" : this$1.get__O()))) {
    return (!$is_Lamf_core_model_document_BaseUnit(element))
  } else {
    return false
  }
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.link__p1__T__T__Lamf_core_model_domain_DomainElement__V = (function(subject, property, elementWithLink) {
  var this$1 = $as_Lamf_core_model_domain_Linkable(elementWithLink);
  var savedLinkTarget = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1);
  var this$2 = $as_Lamf_core_model_domain_Linkable(elementWithLink);
  var this$3 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2);
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var target = $as_Lamf_core_model_domain_DomainElement(arg1);
    var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().TargetId$1;
    var value = target.id__T();
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(elementWithLink, field, value);
    elementWithLink.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_core_metamodel_domain_LinkableElementModel$().Target$1)
  };
  this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f.addTriple__T__T__T__Lamf_core_rdf_RdfModel(subject, property, elementWithLink.id__T());
  this.traverse__Lamf_core_model_domain_AmfObject__V(elementWithLink);
  if ((!savedLinkTarget.isEmpty__Z())) {
    var arg1$1 = savedLinkTarget.get__O();
    var target$3 = $as_Lamf_core_model_domain_DomainElement(arg1$1);
    elementWithLink.fields__Lamf_core_parser_Fields().setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_core_metamodel_domain_LinkableElementModel$().Target$1, target$3, (elementWithLink.fields__Lamf_core_parser_Fields(), $m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
  }
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.emitIntLiteral__T__T__T__V = (function(subject, property, v) {
  try {
    var jsx$1 = this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f;
    var this$2 = new $c_sci_StringOps().init___T(v);
    var this$4 = $m_jl_Integer$();
    var $$this = this$2.repr$1;
    var this$5 = this$4.parseInt__T__I__I($$this, 10);
    jsx$1.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(subject, property, ("" + this$5), new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Long$1))
  } catch (e) {
    if ((e instanceof $c_jl_NumberFormatException)) {
      this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(subject, property, v, $m_s_None$())
    } else {
      throw e
    }
  }
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.createCustomExtension__p1__T__T__Lamf_core_model_domain_extensions_DomainExtension__s_Option__V = (function(subject, uri, extension, field) {
  this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f.addTriple__T__T__T__Lamf_core_rdf_RdfModel(subject, uri, $as_Lamf_core_model_domain_DataNode(extension.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)).id$1);
  var jsx$2 = this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f;
  var jsx$1 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1.value$1.iri__T();
  var this$1 = $as_Lamf_core_model_StrField(extension.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1));
  var this$2 = this$1.option$1;
  jsx$2.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(uri, jsx$1, $as_T((this$2.isEmpty__Z() ? null : this$2.get__O())), $m_s_None$());
  if ((!field.isEmpty__Z())) {
    var arg1 = field.get__O();
    var f = $as_Lamf_core_metamodel_Field(arg1);
    this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f.addTriple__T__T__T__Lamf_core_rdf_RdfModel(uri, $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Element$1.value$1.iri__T(), f.value$1.iri__T())
  };
  this.traverse__Lamf_core_model_domain_AmfObject__V($as_Lamf_core_model_domain_DataNode(extension.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)))
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.typedScalar__p1__T__T__T__T__V = (function(subject, property, content, dataType) {
  if ((dataType === $m_Lamf_core_model_DataType$().Integer$1)) {
    this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(subject, property, content, new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Long$1))
  } else {
    this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(subject, property, content, new $c_s_Some().init___O(dataType))
  }
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.objectValue__p1__T__T__Lamf_core_metamodel_Type__Lamf_core_parser_Value__V = (function(subject, property, t, v) {
  matchEnd19: {
    if ($is_Lamf_core_metamodel_domain_DomainElementModel(t)) {
      if ($is_Lamf_core_model_domain_DomainElement(v.value$1)) {
        var this$1 = $as_Lamf_core_model_domain_DomainElement(v.value$1);
        var this$2 = $as_Lamf_core_model_BoolField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().IsExternalLink$1)).option$1;
        var jsx$1 = $uZ((this$2.isEmpty__Z() ? false : this$2.get__O()))
      } else {
        var jsx$1 = false
      }
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f.addTriple__T__T__T__Lamf_core_rdf_RdfModel(subject, property, $as_Lamf_core_model_domain_DomainElement(v.value$1).id__T());
      break matchEnd19
    };
    if (($is_Lamf_core_model_domain_DomainElement(t) && $is_Lamf_core_model_domain_Linkable(t))) {
      var this$3 = $as_Lamf_core_model_domain_Linkable(t);
      if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$3).isDefined__Z()) {
        this.link__p1__T__T__Lamf_core_model_domain_DomainElement__V(subject, property, $as_Lamf_core_model_domain_DomainElement(t));
        break matchEnd19
      }
    };
    if ($is_Lamf_core_metamodel_Obj(t)) {
      this.obj__p1__T__T__Lamf_core_model_domain_AmfObject__V(subject, property, $as_Lamf_core_model_domain_AmfObject(v.value$1));
      break matchEnd19
    };
    var x = $m_Lamf_core_metamodel_Type$Iri$();
    if (x.equals__O__Z(t)) {
      this.iri__p1__T__T__T__V(subject, property, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T());
      break matchEnd19
    };
    var x$3 = $m_Lamf_core_metamodel_Type$EncodedIri$();
    if (x$3.equals__O__Z(t)) {
      this.safeIri__p1__T__T__T__V(subject, property, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T());
      break matchEnd19
    };
    var x$5 = $m_Lamf_core_metamodel_Type$LiteralUri$();
    if (x$5.equals__O__Z(t)) {
      this.typedScalar__p1__T__T__T__T__V(subject, property, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T(), $m_Lamf_core_model_DataType$().AnyUri$1);
      break matchEnd19
    };
    var x$7 = $m_Lamf_core_metamodel_Type$Str$();
    if (x$7.equals__O__Z(t)) {
      var x1$2 = v.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_ScalarType.getClassOf());
      if ((x1$2 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1$2);
        var annotation = $as_Lamf_core_annotations_ScalarType(x2.value$2);
        this.typedScalar__p1__T__T__T__T__V(subject, property, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T(), annotation.datatype$1)
      } else {
        var x$9 = $m_s_None$();
        if ((!(x$9 === x1$2))) {
          throw new $c_s_MatchError().init___O(x1$2)
        };
        this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(subject, property, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T(), $m_s_None$())
      };
      break matchEnd19
    };
    var x$12 = $m_Lamf_core_metamodel_Type$Bool$();
    if (x$12.equals__O__Z(t)) {
      this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(subject, property, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T(), new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Boolean$1));
      break matchEnd19
    };
    var x$14 = $m_Lamf_core_metamodel_Type$Int$();
    if (x$14.equals__O__Z(t)) {
      this.emitIntLiteral__T__T__T__V(subject, property, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T());
      break matchEnd19
    };
    var x$16 = $m_Lamf_core_metamodel_Type$Double$();
    if (x$16.equals__O__Z(t)) {
      this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(subject, property, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T(), new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Double$1));
      break matchEnd19
    };
    var x$18 = $m_Lamf_core_metamodel_Type$Float$();
    if (x$18.equals__O__Z(t)) {
      this.emitFloatLiteral__T__T__T__V(subject, property, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T());
      break matchEnd19
    };
    var x$20 = $m_Lamf_core_metamodel_Type$DateTime$();
    if (x$20.equals__O__Z(t)) {
      var dateTime = $as_Lorg_mulesoft_common_time_SimpleDateTime($as_Lamf_core_model_domain_AmfScalar(v.value$1).value$1);
      this.typedScalar__p1__T__T__T__T__V(subject, property, dateTime.toString__T(), $m_Lamf_core_model_DataType$().DateTime$1);
      break matchEnd19
    };
    var x$22 = $m_Lamf_core_metamodel_Type$Date$();
    if (x$22.equals__O__Z(t)) {
      var dateTime$2 = $as_Lorg_mulesoft_common_time_SimpleDateTime($as_Lamf_core_model_domain_AmfScalar(v.value$1).value$1);
      if ((dateTime$2.timeOfDay$1.isDefined__Z() || dateTime$2.zoneOffset$1.isDefined__Z())) {
        this.typedScalar__p1__T__T__T__T__V(subject, property, dateTime$2.toString__T(), $m_Lamf_core_model_DataType$().DateTime$1);
        (void 0)
      } else {
        this.typedScalar__p1__T__T__T__T__V(subject, property, dateTime$2.toString__T(), $m_Lamf_core_model_DataType$().Date$1);
        (void 0)
      };
      break matchEnd19
    };
    if ((t instanceof $c_Lamf_core_metamodel_Type$SortedArray)) {
      var x15 = $as_Lamf_core_metamodel_Type$SortedArray(t);
      this.createSortedArray__T__T__sc_Seq__Lamf_core_metamodel_Type__V(subject, property, $as_Lamf_core_model_domain_AmfArray(v.value$1).values$1, x15.element$1);
      break matchEnd19
    };
    if ((t instanceof $c_Lamf_core_metamodel_Type$Array)) {
      var x16 = $as_Lamf_core_metamodel_Type$Array(t);
      $as_Lamf_core_model_domain_AmfArray(v.value$1).values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, subject$1, property$1, x16$1) {
        return (function(e$2) {
          var e = $as_Lamf_core_model_domain_AmfElement(e$2);
          var jsx$2 = x16$1.element$1;
          $m_Lamf_core_parser_Annotations$();
          var annotations = new $c_Lamf_core_parser_Annotations().init___();
          this$2$1.objectValue__p1__T__T__Lamf_core_metamodel_Type__Lamf_core_parser_Value__V(subject$1, property$1, jsx$2, new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(e, annotations))
        })
      })(this, subject, property, x16)));
      break matchEnd19
    };
    var x$24 = $m_Lamf_core_metamodel_Type$Any$();
    if ((x$24 === t)) {
      var x1$3 = $as_Lamf_core_model_domain_AmfScalar(v.value$1).value$1;
      if (((typeof x1$3) === "boolean")) {
        this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(subject, property, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T(), new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Boolean$1))
      } else if ($isInt(x1$3)) {
        this.emitIntLiteral__T__T__T__V(subject, property, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T())
      } else if ($isFloat(x1$3)) {
        this.emitFloatLiteral__T__T__T__V(subject, property, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T())
      } else if (((typeof x1$3) === "number")) {
        this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(subject, property, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T(), new $c_s_Some().init___O($m_Lamf_core_model_DataType$().Double$1))
      } else {
        var x1$4 = v.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_ScalarType.getClassOf());
        if ((x1$4 instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(x1$4);
          var annotation$2 = $as_Lamf_core_annotations_ScalarType(x2$2.value$2);
          this.typedScalar__p1__T__T__T__T__V(subject, property, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T(), annotation$2.datatype$1)
        } else {
          var x$26 = $m_s_None$();
          if ((!(x$26 === x1$4))) {
            throw new $c_s_MatchError().init___O(x1$4)
          };
          this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f.addTriple__T__T__T__s_Option__Lamf_core_rdf_RdfModel(subject, property, $as_Lamf_core_model_domain_AmfScalar(v.value$1).toString__T(), $m_s_None$())
        }
      };
      break matchEnd19
    };
    throw new $c_s_MatchError().init___O(t)
  }
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.createSortedArray__T__T__sc_Seq__Lamf_core_metamodel_Type__V = (function(subject, property, seq, element) {
  var id = (subject + "/list");
  var jsx$2 = this.$$outer$1.amf$core$rdf$RdfModelEmitter$$rdfmodel$f.addTriple__T__T__T__Lamf_core_rdf_RdfModel(subject, property, id);
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
  var jsx$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "type").iri__T();
  var this$3 = $m_Lamf_core_vocabulary_Namespace$().Rdfs$1;
  jsx$2.addTriple__T__T__T__Lamf_core_rdf_RdfModel(id, jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "Seq").iri__T());
  var this$5 = $m_sc_Seq$();
  $as_sc_IterableLike(seq.zipWithIndex__scg_CanBuildFrom__O(this$5.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, id$1, element$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var e = $as_Lamf_core_model_domain_AmfElement(x0$1.$$und1__O());
        var i = x0$1.$$und2$mcI$sp__I();
        var this$6 = $m_Lamf_core_vocabulary_Namespace$().Rdfs$1;
        var id$2 = ("_" + ((1 + i) | 0));
        var memberTriple = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$6, id$2).iri__T();
        $m_Lamf_core_parser_Annotations$();
        var annotations = new $c_Lamf_core_parser_Annotations().init___();
        $this.objectValue__p1__T__T__Lamf_core_metamodel_Type__Lamf_core_parser_Value__V(id$1, memberTriple, element$1, new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(e, annotations))
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, id, element)))
});
function $as_Lamf_core_rdf_RdfModelEmitter$Emitter(obj) {
  return (((obj instanceof $c_Lamf_core_rdf_RdfModelEmitter$Emitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.rdf.RdfModelEmitter$Emitter"))
}
function $isArrayOf_Lamf_core_rdf_RdfModelEmitter$Emitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_rdf_RdfModelEmitter$Emitter)))
}
function $asArrayOf_Lamf_core_rdf_RdfModelEmitter$Emitter(obj, depth) {
  return (($isArrayOf_Lamf_core_rdf_RdfModelEmitter$Emitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.rdf.RdfModelEmitter$Emitter;", depth))
}
var $d_Lamf_core_rdf_RdfModelEmitter$Emitter = new $TypeData().initClass({
  Lamf_core_rdf_RdfModelEmitter$Emitter: 0
}, false, "amf.core.rdf.RdfModelEmitter$Emitter", {
  Lamf_core_rdf_RdfModelEmitter$Emitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter.prototype.$classData = $d_Lamf_core_rdf_RdfModelEmitter$Emitter;
/** @constructor */
function $c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener() {
  $c_O.call(this);
  this.dictionary$1 = null;
  this.c$1 = 0;
  this.$$outer$1 = null
}
$c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener.prototype = new $h_O();
$c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener.prototype.constructor = $c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener;
/** @constructor */
function $h_Lamf_core_resolution_stages_UrlShortenerStage$Shortener() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_UrlShortenerStage$Shortener.prototype = $c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener.prototype;
$c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener.prototype.productPrefix__T = (function() {
  return "Shortener"
});
$c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener) && ($as_Lamf_core_resolution_stages_UrlShortenerStage$Shortener(x$1).$$outer$1 === this.$$outer$1))) {
    var Shortener$1 = $as_Lamf_core_resolution_stages_UrlShortenerStage$Shortener(x$1);
    var x = this.dictionary$1;
    var x$2 = Shortener$1.dictionary$1;
    return ((x === null) ? (x$2 === null) : $f_sc_GenMapLike__equals__O__Z(x, x$2))
  } else {
    return false
  }
});
$c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener.prototype.shorten__T__T = (function(uri) {
  var this$2 = new $c_sci_StringOps().init___T(uri);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$2)) {
    var prefix = (this.$$outer$1.amf$core$resolution$stages$UrlShortenerStage$$base$2 + "#");
    var jsx$1 = (!(($uI(uri.length) >= 0) && ($as_T(uri.substring(0, $uI(prefix.length))) === prefix)))
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return $as_T(this.dictionary$1.getOrElseUpdate__O__F0__O(uri, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
      return (function() {
        $this.c$1 = ((1 + $this.c$1) | 0);
        return (($this.$$outer$1.amf$core$resolution$stages$UrlShortenerStage$$base$2 + "#") + $this.c$1)
      })
    })(this))))
  } else {
    return uri
  }
});
$c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.dictionary$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener.prototype.init___Lamf_core_resolution_stages_UrlShortenerStage__scm_Map = (function($$outer, dictionary) {
  this.dictionary$1 = dictionary;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.c$1 = (-1);
  return this
});
$c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_resolution_stages_UrlShortenerStage$Shortener(obj) {
  return (((obj instanceof $c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.resolution.stages.UrlShortenerStage$Shortener"))
}
function $isArrayOf_Lamf_core_resolution_stages_UrlShortenerStage$Shortener(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_resolution_stages_UrlShortenerStage$Shortener)))
}
function $asArrayOf_Lamf_core_resolution_stages_UrlShortenerStage$Shortener(obj, depth) {
  return (($isArrayOf_Lamf_core_resolution_stages_UrlShortenerStage$Shortener(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.resolution.stages.UrlShortenerStage$Shortener;", depth))
}
var $d_Lamf_core_resolution_stages_UrlShortenerStage$Shortener = new $TypeData().initClass({
  Lamf_core_resolution_stages_UrlShortenerStage$Shortener: 0
}, false, "amf.core.resolution.stages.UrlShortenerStage$Shortener", {
  Lamf_core_resolution_stages_UrlShortenerStage$Shortener: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener.prototype.$classData = $d_Lamf_core_resolution_stages_UrlShortenerStage$Shortener;
/** @constructor */
function $c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener$() {
  $c_sr_AbstractFunction1.call(this);
  this.$$outer$2 = null
}
$c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener$.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener$.prototype.constructor = $c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener$;
/** @constructor */
function $h_Lamf_core_resolution_stages_UrlShortenerStage$Shortener$() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_UrlShortenerStage$Shortener$.prototype = $c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener$.prototype;
$c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener$.prototype.apply__O__O = (function(v1) {
  return this.apply__scm_Map__Lamf_core_resolution_stages_UrlShortenerStage$Shortener($as_scm_Map(v1))
});
$c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener$.prototype.init___Lamf_core_resolution_stages_UrlShortenerStage = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  return this
});
$c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener$.prototype.toString__T = (function() {
  return "Shortener"
});
$c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener$.prototype.apply__scm_Map__Lamf_core_resolution_stages_UrlShortenerStage$Shortener = (function(dictionary) {
  return new $c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener().init___Lamf_core_resolution_stages_UrlShortenerStage__scm_Map(this.$$outer$2, dictionary)
});
var $d_Lamf_core_resolution_stages_UrlShortenerStage$Shortener$ = new $TypeData().initClass({
  Lamf_core_resolution_stages_UrlShortenerStage$Shortener$: 0
}, false, "amf.core.resolution.stages.UrlShortenerStage$Shortener$", {
  Lamf_core_resolution_stages_UrlShortenerStage$Shortener$: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_resolution_stages_UrlShortenerStage$Shortener$.prototype.$classData = $d_Lamf_core_resolution_stages_UrlShortenerStage$Shortener$;
/** @constructor */
function $c_Lamf_core_traversal_ModelTraversalRegistry() {
  $c_O.call(this);
  this.visitedIds$1 = null;
  this.currentPath$1 = null;
  this.whiteList$1 = null;
  this.allowedCycleClasses$1 = null;
  this.skipFn$1 = null
}
$c_Lamf_core_traversal_ModelTraversalRegistry.prototype = new $h_O();
$c_Lamf_core_traversal_ModelTraversalRegistry.prototype.constructor = $c_Lamf_core_traversal_ModelTraversalRegistry;
/** @constructor */
function $h_Lamf_core_traversal_ModelTraversalRegistry() {
  /*<skip>*/
}
$h_Lamf_core_traversal_ModelTraversalRegistry.prototype = $c_Lamf_core_traversal_ModelTraversalRegistry.prototype;
$c_Lamf_core_traversal_ModelTraversalRegistry.prototype.init___ = (function() {
  this.visitedIds$1 = $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  this.currentPath$1 = $m_sci_Set$EmptySet$();
  this.whiteList$1 = $as_sci_Set($m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  this.allowedCycleClasses$1 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  this.skipFn$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      $as_T(x$1$2);
      return false
    })
  })(this));
  return this
});
$c_Lamf_core_traversal_ModelTraversalRegistry.prototype.productPrefix__T = (function() {
  return "ModelTraversalRegistry"
});
$c_Lamf_core_traversal_ModelTraversalRegistry.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_traversal_ModelTraversalRegistry.prototype.withAllowedCyclesInstances__sc_Seq__Lamf_core_traversal_ModelTraversalRegistry = (function(classes) {
  this.allowedCycleClasses$1 = classes;
  return this
});
$c_Lamf_core_traversal_ModelTraversalRegistry.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_core_traversal_ModelTraversalRegistry) && ($as_Lamf_core_traversal_ModelTraversalRegistry(x$1), true))
});
$c_Lamf_core_traversal_ModelTraversalRegistry.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_traversal_ModelTraversalRegistry.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_traversal_ModelTraversalRegistry.prototype.canTraverse__T__Z = (function(id) {
  return (!$uZ(this.skipFn$1.apply__O__O(id)))
});
$c_Lamf_core_traversal_ModelTraversalRegistry.prototype.shouldFailIfRecursive__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Z = (function(root, shape) {
  var x1 = root.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_TypeAlias.getClassOf());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var alias = $as_Lamf_core_annotations_TypeAlias(x2.value$2);
    var this$1 = alias.aliasId$1;
    var that = shape.id$1;
    if ((this$1 === that)) {
      var this$2 = this.currentPath$1;
      var jsx$1 = $f_sc_TraversableOnce__nonEmpty__Z(this$2)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var a = true
    } else {
      var id = shape.id$1;
      var a = this.currentPath$1.contains__O__Z(id)
    };
    var b = (!this.allowedCycleClasses$1.contains__O__Z($objectGetClass(shape)));
    return (a && b)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var id$1 = shape.id$1;
      if (this.currentPath$1.contains__O__Z(id$1)) {
        return (!this.allowedCycleClasses$1.contains__O__Z($objectGetClass(shape)))
      } else {
        return false
      }
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_core_traversal_ModelTraversalRegistry.prototype.$$plus__T__Lamf_core_traversal_ModelTraversalRegistry = (function(id) {
  this.visitedIds$1.$$plus$eq__O__scm_SetLike(id);
  this.currentPath$1 = $as_sci_Set(this.currentPath$1.$$plus__O__sc_Set(id));
  return this
});
$c_Lamf_core_traversal_ModelTraversalRegistry.prototype.avoidError__Lamf_core_model_domain_RecursiveShape__s_Option__Z = (function(r, checkId) {
  var id = r.id$1;
  if (this.whiteList$1.contains__O__Z(id)) {
    var jsx$1 = true
  } else {
    var this$1 = $as_Lamf_core_model_StrField(r.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_RecursiveShapeModel$().FixPoint$1)).option$1;
    var id$1 = $as_T((this$1.isEmpty__Z() ? "" : this$1.get__O()));
    var jsx$1 = this.whiteList$1.contains__O__Z(id$1)
  };
  if (jsx$1) {
    return true
  } else if (checkId.isDefined__Z()) {
    var id$2 = $as_T(checkId.get__O());
    return this.whiteList$1.contains__O__Z(id$2)
  } else {
    return false
  }
});
$c_Lamf_core_traversal_ModelTraversalRegistry.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_traversal_ModelTraversalRegistry.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_traversal_ModelTraversalRegistry(obj) {
  return (((obj instanceof $c_Lamf_core_traversal_ModelTraversalRegistry) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.traversal.ModelTraversalRegistry"))
}
function $isArrayOf_Lamf_core_traversal_ModelTraversalRegistry(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_traversal_ModelTraversalRegistry)))
}
function $asArrayOf_Lamf_core_traversal_ModelTraversalRegistry(obj, depth) {
  return (($isArrayOf_Lamf_core_traversal_ModelTraversalRegistry(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.traversal.ModelTraversalRegistry;", depth))
}
var $d_Lamf_core_traversal_ModelTraversalRegistry = new $TypeData().initClass({
  Lamf_core_traversal_ModelTraversalRegistry: 0
}, false, "amf.core.traversal.ModelTraversalRegistry", {
  Lamf_core_traversal_ModelTraversalRegistry: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_traversal_ModelTraversalRegistry.prototype.$classData = $d_Lamf_core_traversal_ModelTraversalRegistry;
/** @constructor */
function $c_Lamf_core_traversal_TransformationData() {
  $c_O.call(this);
  this.predicate$1 = null;
  this.transformation$1 = null
}
$c_Lamf_core_traversal_TransformationData.prototype = new $h_O();
$c_Lamf_core_traversal_TransformationData.prototype.constructor = $c_Lamf_core_traversal_TransformationData;
/** @constructor */
function $h_Lamf_core_traversal_TransformationData() {
  /*<skip>*/
}
$h_Lamf_core_traversal_TransformationData.prototype = $c_Lamf_core_traversal_TransformationData.prototype;
$c_Lamf_core_traversal_TransformationData.prototype.productPrefix__T = (function() {
  return "TransformationData"
});
$c_Lamf_core_traversal_TransformationData.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_traversal_TransformationData.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_traversal_TransformationData)) {
    var TransformationData$1 = $as_Lamf_core_traversal_TransformationData(x$1);
    var x = this.predicate$1;
    var x$2 = TransformationData$1.predicate$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.transformation$1;
      var x$4 = TransformationData$1.transformation$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_traversal_TransformationData.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.predicate$1;
      break
    }
    case 1: {
      return this.transformation$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_traversal_TransformationData.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_traversal_TransformationData.prototype.init___F1__F2 = (function(predicate, transformation) {
  this.predicate$1 = predicate;
  this.transformation$1 = transformation;
  return this
});
$c_Lamf_core_traversal_TransformationData.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_traversal_TransformationData.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_traversal_TransformationData(obj) {
  return (((obj instanceof $c_Lamf_core_traversal_TransformationData) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.traversal.TransformationData"))
}
function $isArrayOf_Lamf_core_traversal_TransformationData(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_traversal_TransformationData)))
}
function $asArrayOf_Lamf_core_traversal_TransformationData(obj, depth) {
  return (($isArrayOf_Lamf_core_traversal_TransformationData(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.traversal.TransformationData;", depth))
}
var $d_Lamf_core_traversal_TransformationData = new $TypeData().initClass({
  Lamf_core_traversal_TransformationData: 0
}, false, "amf.core.traversal.TransformationData", {
  Lamf_core_traversal_TransformationData: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_traversal_TransformationData.prototype.$classData = $d_Lamf_core_traversal_TransformationData;
/** @constructor */
function $c_Lamf_core_traversal_iterator_AmfElementIterator() {
  $c_O.call(this);
  this.buffer$1 = null;
  this.visited$1 = null
}
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype = new $h_O();
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.constructor = $c_Lamf_core_traversal_iterator_AmfElementIterator;
/** @constructor */
function $h_Lamf_core_traversal_iterator_AmfElementIterator() {
  /*<skip>*/
}
$h_Lamf_core_traversal_iterator_AmfElementIterator.prototype = $c_Lamf_core_traversal_iterator_AmfElementIterator.prototype;
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.next__O = (function() {
  return this.next__Lamf_core_model_domain_AmfElement()
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.toIterator__sc_Iterator = (function() {
  return this
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.next__Lamf_core_model_domain_AmfElement = (function() {
  var current = $as_Lamf_core_model_domain_AmfElement(this.buffer$1.head__O());
  this.buffer$1 = $as_sci_List(this.buffer$1.tail__O());
  this.advance__p1__V();
  return current
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.isEmpty__Z = (function() {
  return $f_sc_Iterator__isEmpty__Z(this)
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.toList__sci_List = (function() {
  var this$1 = $m_sci_List$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_sci_List($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.take__I__sc_Iterator = (function(n) {
  return $f_sc_Iterator__take__I__sc_Iterator(this, n)
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.mkString__T__T = (function(sep) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", sep, "")
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.toString__T = (function() {
  return "<iterator>"
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.sliceIterator__I__I__sc_Iterator = (function(from, until) {
  return $f_sc_Iterator__sliceIterator__I__I__sc_Iterator(this, from, until)
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.foreach__F1__V = (function(f) {
  $f_sc_Iterator__foreach__F1__V(this, f)
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.foldLeft__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.advance__p1__V = (function() {
  _advance: while (true) {
    var this$1 = this.buffer$1;
    if ($f_sc_TraversableOnce__nonEmpty__Z(this$1)) {
      var current = $as_Lamf_core_model_domain_AmfElement(this.buffer$1.head__O());
      this.buffer$1 = $as_sci_List(this.buffer$1.tail__O());
      if ($is_Lamf_core_model_domain_AmfObject(current)) {
        var x2 = $as_Lamf_core_model_domain_AmfObject(current);
        if (this.visited$1.contains__O__Z(x2.id__T())) {
          continue _advance
        };
        var this$2 = x2.fields__Lamf_core_parser_Fields();
        var this$5 = this$2.fs$1;
        var this$3 = $m_Lamf_core_parser_FieldEntry$();
        var f = $f_F2__tupled__F1(this$3);
        var this$4 = $m_sci_Iterable$();
        var bf = this$4.ReusableCBFInstance$2;
        var jsx$2 = $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$5, f, bf));
        var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(x$1$2) {
            var x$1 = $as_Lamf_core_parser_FieldEntry(x$1$2);
            return x$1.value$1.value$1
          })
        })(this));
        var this$6 = $m_sc_Iterable$();
        var elements = $as_sc_Iterable(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2));
        this.visited$1.$$plus$eq__O__scm_SetLike(x2.id__T());
        var jsx$4 = elements.toList__sci_List();
        var jsx$3 = this.buffer$1;
        var this$7 = $m_sci_List$();
        var this$8 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$7.ReusableCBFInstance$2));
        this.buffer$1 = new $c_sci_$colon$colon().init___O__sci_List(current, this$8)
      } else if ((current instanceof $c_Lamf_core_model_domain_AmfArray)) {
        var x3 = $as_Lamf_core_model_domain_AmfArray(current);
        var jsx$6 = x3.values$1.toList__sci_List();
        var jsx$5 = this.buffer$1;
        var this$9 = $m_sci_List$();
        var this$10 = $as_sci_List(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$5, this$9.ReusableCBFInstance$2));
        this.buffer$1 = new $c_sci_$colon$colon().init___O__sci_List(current, this$10)
      } else {
        var this$11 = this.buffer$1;
        this.buffer$1 = new $c_sci_$colon$colon().init___O__sci_List(current, this$11)
      }
    };
    break
  }
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.$$plus$plus__F0__sc_Iterator = (function(that) {
  return $f_sc_Iterator__$$plus$plus__F0__sc_Iterator(this, that)
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.size__I = (function() {
  return $f_sc_TraversableOnce__size__I(this)
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.toBuffer__scm_Buffer = (function() {
  var this$1 = $m_scm_ArrayBuffer$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_scm_Buffer($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.hasNext__Z = (function() {
  var this$1 = this.buffer$1;
  return $f_sc_TraversableOnce__nonEmpty__Z(this$1)
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.mkString__T = (function() {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", "", "")
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.init___sci_List__scm_Set = (function(buffer, visited) {
  this.buffer$1 = buffer;
  this.visited$1 = visited;
  return this
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.toStream__sci_Stream = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.toTraversable__sc_Traversable = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.init___sci_List = (function(elements) {
  $c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.init___sci_List__scm_Set.call(this, elements, $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
  this.advance__p1__V();
  return this
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.toSeq__sc_Seq = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.$$div$colon__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_sc_Iterator__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.isTraversableAgain__Z = (function() {
  return false
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.drop__I__sc_Iterator = (function(n) {
  return $f_sc_Iterator__drop__I__sc_Iterator(this, n)
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  while (true) {
    var this$2 = this.buffer$1;
    if ($f_sc_TraversableOnce__nonEmpty__Z(this$2)) {
      var arg1 = this.next__Lamf_core_model_domain_AmfElement();
      b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1))
    } else {
      break
    }
  };
  return $as_sci_Map(b.elems$1)
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_sc_TraversableOnce__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_TraversableOnce__reduceLeft__F2__O(this, op)
});
var $d_Lamf_core_traversal_iterator_AmfElementIterator = new $TypeData().initClass({
  Lamf_core_traversal_iterator_AmfElementIterator: 0
}, false, "amf.core.traversal.iterator.AmfElementIterator", {
  Lamf_core_traversal_iterator_AmfElementIterator: 1,
  O: 1,
  Lamf_core_traversal_iterator_AmfIterator: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_Lamf_core_traversal_iterator_AmfElementIterator.prototype.$classData = $d_Lamf_core_traversal_iterator_AmfElementIterator;
/** @constructor */
function $c_Lamf_core_traversal_iterator_DomainElementIterator() {
  $c_O.call(this);
  this.buffer$1 = null;
  this.visited$1 = null
}
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype = new $h_O();
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.constructor = $c_Lamf_core_traversal_iterator_DomainElementIterator;
/** @constructor */
function $h_Lamf_core_traversal_iterator_DomainElementIterator() {
  /*<skip>*/
}
$h_Lamf_core_traversal_iterator_DomainElementIterator.prototype = $c_Lamf_core_traversal_iterator_DomainElementIterator.prototype;
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.next__O = (function() {
  return this.next__Lamf_core_model_domain_AmfElement()
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.toIterator__sc_Iterator = (function() {
  return this
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.next__Lamf_core_model_domain_AmfElement = (function() {
  var current = $as_Lamf_core_model_domain_AmfElement(this.buffer$1.head__O());
  this.buffer$1 = $as_sci_List(this.buffer$1.tail__O());
  this.advance__p1__V();
  return current
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.isEmpty__Z = (function() {
  return $f_sc_Iterator__isEmpty__Z(this)
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.toList__sci_List = (function() {
  var this$1 = $m_sci_List$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_sci_List($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.take__I__sc_Iterator = (function(n) {
  return $f_sc_Iterator__take__I__sc_Iterator(this, n)
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.mkString__T__T = (function(sep) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", sep, "")
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.toString__T = (function() {
  return "<iterator>"
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.sliceIterator__I__I__sc_Iterator = (function(from, until) {
  return $f_sc_Iterator__sliceIterator__I__I__sc_Iterator(this, from, until)
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.foreach__F1__V = (function(f) {
  $f_sc_Iterator__foreach__F1__V(this, f)
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.foldLeft__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.advance__p1__V = (function() {
  _advance: while (true) {
    var this$1 = this.buffer$1;
    if ($f_sc_TraversableOnce__nonEmpty__Z(this$1)) {
      var current = $as_Lamf_core_model_domain_AmfElement(this.buffer$1.head__O());
      this.buffer$1 = $as_sci_List(this.buffer$1.tail__O());
      if ((!$is_Lamf_core_model_domain_AmfObject(current))) {
        if ((current instanceof $c_Lamf_core_model_domain_AmfArray)) {
          var x3 = $as_Lamf_core_model_domain_AmfArray(current);
          var jsx$2 = x3.values$1.toList__sci_List();
          var jsx$1 = this.buffer$1;
          var this$10 = $m_sci_List$();
          this.buffer$1 = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$10.ReusableCBFInstance$2));
          continue _advance
        };
        continue _advance
      };
      var x2 = $as_Lamf_core_model_domain_AmfObject(current);
      if (this.visited$1.contains__O__Z(x2.id__T())) {
        continue _advance
      };
      var this$2 = x2.fields__Lamf_core_parser_Fields();
      var this$5 = this$2.fs$1;
      var this$3 = $m_Lamf_core_parser_FieldEntry$();
      var f = $f_F2__tupled__F1(this$3);
      var this$4 = $m_sci_Iterable$();
      var bf = this$4.ReusableCBFInstance$2;
      var jsx$4 = $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$5, f, bf));
      var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x$1$2) {
          var x$1 = $as_Lamf_core_parser_FieldEntry(x$1$2);
          return x$1.value$1.value$1
        })
      })(this));
      var this$6 = $m_sc_Iterable$();
      var elements = $as_sc_TraversableOnce(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$6.ReusableCBFInstance$2)).toList__sci_List();
      this.visited$1.$$plus$eq__O__scm_SetLike(x2.id__T());
      if ((!$is_Lamf_core_model_domain_DomainElement(x2))) {
        var jsx$5 = this.buffer$1;
        var this$9 = $m_sci_List$();
        this.buffer$1 = $as_sci_List(elements.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$5, this$9.ReusableCBFInstance$2));
        continue _advance
      };
      var x2$2 = $as_Lamf_core_model_domain_DomainElement(x2);
      var jsx$6 = this.buffer$1;
      var this$7 = $m_sci_List$();
      var this$8 = $as_sci_List(elements.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$6, this$7.ReusableCBFInstance$2));
      this.buffer$1 = new $c_sci_$colon$colon().init___O__sci_List(x2$2, this$8)
    };
    break
  }
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.$$plus$plus__F0__sc_Iterator = (function(that) {
  return $f_sc_Iterator__$$plus$plus__F0__sc_Iterator(this, that)
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.size__I = (function() {
  return $f_sc_TraversableOnce__size__I(this)
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.toBuffer__scm_Buffer = (function() {
  var this$1 = $m_scm_ArrayBuffer$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_scm_Buffer($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.hasNext__Z = (function() {
  var this$1 = this.buffer$1;
  return $f_sc_TraversableOnce__nonEmpty__Z(this$1)
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.mkString__T = (function() {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", "", "")
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.init___sci_List__scm_Set = (function(buffer, visited) {
  this.buffer$1 = buffer;
  this.visited$1 = visited;
  return this
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.toStream__sci_Stream = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.toTraversable__sc_Traversable = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.init___sci_List = (function(elements) {
  $c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.init___sci_List__scm_Set.call(this, elements, $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
  this.advance__p1__V();
  return this
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.toSeq__sc_Seq = (function() {
  return $f_sc_Iterator__toStream__sci_Stream(this)
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableOnce__to__scg_CanBuildFrom__O(this, cbf))
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.$$div$colon__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_sc_Iterator__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.isTraversableAgain__Z = (function() {
  return false
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.drop__I__sc_Iterator = (function(n) {
  return $f_sc_Iterator__drop__I__sc_Iterator(this, n)
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  while (true) {
    var this$2 = this.buffer$1;
    if ($f_sc_TraversableOnce__nonEmpty__Z(this$2)) {
      var arg1 = this.next__Lamf_core_model_domain_AmfElement();
      b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1))
    } else {
      break
    }
  };
  return $as_sci_Map(b.elems$1)
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_sc_TraversableOnce__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_TraversableOnce__reduceLeft__F2__O(this, op)
});
var $d_Lamf_core_traversal_iterator_DomainElementIterator = new $TypeData().initClass({
  Lamf_core_traversal_iterator_DomainElementIterator: 0
}, false, "amf.core.traversal.iterator.DomainElementIterator", {
  Lamf_core_traversal_iterator_DomainElementIterator: 1,
  O: 1,
  Lamf_core_traversal_iterator_AmfIterator: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_Lamf_core_traversal_iterator_DomainElementIterator.prototype.$classData = $d_Lamf_core_traversal_iterator_DomainElementIterator;
/** @constructor */
function $c_Lamf_core_utils_InflectorBase$Container() {
  $c_O.call(this);
  this.rule$1 = null;
  this.replacement$1 = null
}
$c_Lamf_core_utils_InflectorBase$Container.prototype = new $h_O();
$c_Lamf_core_utils_InflectorBase$Container.prototype.constructor = $c_Lamf_core_utils_InflectorBase$Container;
/** @constructor */
function $h_Lamf_core_utils_InflectorBase$Container() {
  /*<skip>*/
}
$h_Lamf_core_utils_InflectorBase$Container.prototype = $c_Lamf_core_utils_InflectorBase$Container.prototype;
$c_Lamf_core_utils_InflectorBase$Container.prototype.init___T__T = (function(rule, replacement) {
  this.rule$1 = rule;
  this.replacement$1 = replacement;
  return this
});
$c_Lamf_core_utils_InflectorBase$Container.prototype.productPrefix__T = (function() {
  return "Container"
});
$c_Lamf_core_utils_InflectorBase$Container.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_utils_InflectorBase$Container.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_utils_InflectorBase$Container)) {
    var Container$1 = $as_Lamf_core_utils_InflectorBase$Container(x$1);
    return ((this.rule$1 === Container$1.rule$1) && (this.replacement$1 === Container$1.replacement$1))
  } else {
    return false
  }
});
$c_Lamf_core_utils_InflectorBase$Container.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.rule$1;
      break
    }
    case 1: {
      return this.replacement$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_utils_InflectorBase$Container.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_utils_InflectorBase$Container.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_utils_InflectorBase$Container.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_utils_InflectorBase$Container(obj) {
  return (((obj instanceof $c_Lamf_core_utils_InflectorBase$Container) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.utils.InflectorBase$Container"))
}
function $isArrayOf_Lamf_core_utils_InflectorBase$Container(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_utils_InflectorBase$Container)))
}
function $asArrayOf_Lamf_core_utils_InflectorBase$Container(obj, depth) {
  return (($isArrayOf_Lamf_core_utils_InflectorBase$Container(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.utils.InflectorBase$Container;", depth))
}
var $d_Lamf_core_utils_InflectorBase$Container = new $TypeData().initClass({
  Lamf_core_utils_InflectorBase$Container: 0
}, false, "amf.core.utils.InflectorBase$Container", {
  Lamf_core_utils_InflectorBase$Container: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_utils_InflectorBase$Container.prototype.$classData = $d_Lamf_core_utils_InflectorBase$Container;
/** @constructor */
function $c_Lamf_core_utils_package$AliasCounter() {
  $c_O.call(this);
  this.count$1 = 0;
  this.maxThreshold$1 = $m_sjsr_RuntimeLong$().Zero__sjsr_RuntimeLong()
}
$c_Lamf_core_utils_package$AliasCounter.prototype = new $h_O();
$c_Lamf_core_utils_package$AliasCounter.prototype.constructor = $c_Lamf_core_utils_package$AliasCounter;
/** @constructor */
function $h_Lamf_core_utils_package$AliasCounter() {
  /*<skip>*/
}
$h_Lamf_core_utils_package$AliasCounter.prototype = $c_Lamf_core_utils_package$AliasCounter.prototype;
$c_Lamf_core_utils_package$AliasCounter.prototype.exceedsThreshold__Lorg_yaml_model_YNode__Z = (function(node) {
  this.register__Lorg_yaml_model_YNode__V(node);
  var value = this.count$1;
  var hi = (value >> 31);
  var b = this.maxThreshold$1;
  var bhi = b.hi$2;
  return ((hi === bhi) ? (((-2147483648) ^ value) > ((-2147483648) ^ b.lo$2)) : (hi > bhi))
});
$c_Lamf_core_utils_package$AliasCounter.prototype.productPrefix__T = (function() {
  return "AliasCounter"
});
$c_Lamf_core_utils_package$AliasCounter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_utils_package$AliasCounter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_utils_package$AliasCounter)) {
    var AliasCounter$1 = $as_Lamf_core_utils_package$AliasCounter(x$1);
    if ((this.count$1 === AliasCounter$1.count$1)) {
      var t = this.maxThreshold$1;
      var lo = t.lo$2;
      var hi = t.hi$2;
      var b = AliasCounter$1.maxThreshold$1;
      return ((lo === b.lo$2) && (hi === b.hi$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_utils_package$AliasCounter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.count$1;
      break
    }
    case 1: {
      return this.maxThreshold$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_utils_package$AliasCounter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_utils_package$AliasCounter.prototype.register__Lorg_yaml_model_YNode__V = (function(node) {
  if ((node instanceof $c_Lorg_yaml_model_YNode$Alias)) {
    this.count$1 = ((1 + this.count$1) | 0)
  }
});
$c_Lamf_core_utils_package$AliasCounter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.count$1);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().longHash__J__I(this.maxThreshold$1));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 2)
});
$c_Lamf_core_utils_package$AliasCounter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_utils_package$AliasCounter.prototype.init___I__J = (function(count, maxThreshold) {
  this.count$1 = count;
  this.maxThreshold$1 = maxThreshold;
  return this
});
function $as_Lamf_core_utils_package$AliasCounter(obj) {
  return (((obj instanceof $c_Lamf_core_utils_package$AliasCounter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.utils.package$AliasCounter"))
}
function $isArrayOf_Lamf_core_utils_package$AliasCounter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_utils_package$AliasCounter)))
}
function $asArrayOf_Lamf_core_utils_package$AliasCounter(obj, depth) {
  return (($isArrayOf_Lamf_core_utils_package$AliasCounter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.utils.package$AliasCounter;", depth))
}
var $d_Lamf_core_utils_package$AliasCounter = new $TypeData().initClass({
  Lamf_core_utils_package$AliasCounter: 0
}, false, "amf.core.utils.package$AliasCounter", {
  Lamf_core_utils_package$AliasCounter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_utils_package$AliasCounter.prototype.$classData = $d_Lamf_core_utils_package$AliasCounter;
/** @constructor */
function $c_Lamf_core_utils_package$QName() {
  $c_O.call(this);
  this.qualification$1 = null;
  this.name$1 = null;
  this.isQualified$1 = false;
  this.isEmpty$1 = false
}
$c_Lamf_core_utils_package$QName.prototype = new $h_O();
$c_Lamf_core_utils_package$QName.prototype.constructor = $c_Lamf_core_utils_package$QName;
/** @constructor */
function $h_Lamf_core_utils_package$QName() {
  /*<skip>*/
}
$h_Lamf_core_utils_package$QName.prototype = $c_Lamf_core_utils_package$QName.prototype;
$c_Lamf_core_utils_package$QName.prototype.init___T__T = (function(qualification, name) {
  this.qualification$1 = qualification;
  this.name$1 = name;
  var this$2 = new $c_sci_StringOps().init___T(qualification);
  this.isQualified$1 = $f_sc_TraversableOnce__nonEmpty__Z(this$2);
  if ((qualification === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  if ((qualification === "")) {
    if ((name === null)) {
      throw new $c_jl_NullPointerException().init___()
    };
    var jsx$1 = (name === "")
  } else {
    var jsx$1 = false
  };
  this.isEmpty$1 = jsx$1;
  return this
});
$c_Lamf_core_utils_package$QName.prototype.productPrefix__T = (function() {
  return "QName"
});
$c_Lamf_core_utils_package$QName.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_utils_package$QName.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_utils_package$QName)) {
    var QName$1 = $as_Lamf_core_utils_package$QName(x$1);
    return ((this.qualification$1 === QName$1.qualification$1) && (this.name$1 === QName$1.name$1))
  } else {
    return false
  }
});
$c_Lamf_core_utils_package$QName.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.qualification$1;
      break
    }
    case 1: {
      return this.name$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_utils_package$QName.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_utils_package$QName.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_utils_package$QName.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_utils_package$QName(obj) {
  return (((obj instanceof $c_Lamf_core_utils_package$QName) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.utils.package$QName"))
}
function $isArrayOf_Lamf_core_utils_package$QName(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_utils_package$QName)))
}
function $asArrayOf_Lamf_core_utils_package$QName(obj, depth) {
  return (($isArrayOf_Lamf_core_utils_package$QName(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.utils.package$QName;", depth))
}
var $d_Lamf_core_utils_package$QName = new $TypeData().initClass({
  Lamf_core_utils_package$QName: 0
}, false, "amf.core.utils.package$QName", {
  Lamf_core_utils_package$QName: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_utils_package$QName.prototype.$classData = $d_Lamf_core_utils_package$QName;
/** @constructor */
function $c_Lamf_core_validation_AMFValidationReport() {
  $c_O.call(this);
  this.conforms$1 = false;
  this.model$1 = null;
  this.profile$1 = null;
  this.results$1 = null;
  this.DefaultMax$1 = 0
}
$c_Lamf_core_validation_AMFValidationReport.prototype = new $h_O();
$c_Lamf_core_validation_AMFValidationReport.prototype.constructor = $c_Lamf_core_validation_AMFValidationReport;
/** @constructor */
function $h_Lamf_core_validation_AMFValidationReport() {
  /*<skip>*/
}
$h_Lamf_core_validation_AMFValidationReport.prototype = $c_Lamf_core_validation_AMFValidationReport.prototype;
$c_Lamf_core_validation_AMFValidationReport.prototype.productPrefix__T = (function() {
  return "AMFValidationReport"
});
$c_Lamf_core_validation_AMFValidationReport.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_core_validation_AMFValidationReport.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_validation_AMFValidationReport)) {
    var AMFValidationReport$1 = $as_Lamf_core_validation_AMFValidationReport(x$1);
    if (((this.conforms$1 === AMFValidationReport$1.conforms$1) && (this.model$1 === AMFValidationReport$1.model$1))) {
      var x = this.profile$1;
      var x$2 = AMFValidationReport$1.profile$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.results$1;
      var x$4 = AMFValidationReport$1.results$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_validation_AMFValidationReport.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.conforms$1;
      break
    }
    case 1: {
      return this.model$1;
      break
    }
    case 2: {
      return this.profile$1;
      break
    }
    case 3: {
      return this.results$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_validation_AMFValidationReport.prototype.toString__T = (function() {
  return this.toString__I__T(this.DefaultMax$1)
});
$c_Lamf_core_validation_AMFValidationReport.prototype.appendValidations__p1__scm_StringBuilder__sci_Map__T__V = (function(str, validations, level) {
  var x1 = validations.get__O__s_Option(level);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var l = $as_sc_Seq(x2.value$2);
    str.append__T__scm_StringBuilder((("\nLevel: " + level) + "\n"));
    l.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, str$1) {
      return (function(result$2) {
        var result = $as_Lamf_core_validation_AMFValidationResult(result$2);
        return str$1.append__O__scm_StringBuilder(result)
      })
    })(this, str)))
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_core_validation_AMFValidationReport.prototype.init___Z__T__Lamf_ProfileName__sc_Seq = (function(conforms, model, profile, results) {
  this.conforms$1 = conforms;
  this.model$1 = model;
  this.profile$1 = profile;
  this.results$1 = results;
  this.DefaultMax$1 = 30;
  return this
});
$c_Lamf_core_validation_AMFValidationReport.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.conforms$1 ? 1231 : 1237));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.model$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.profile$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.results$1));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 4)
});
$c_Lamf_core_validation_AMFValidationReport.prototype.toString__I__T = (function(max) {
  $m_s_package$();
  var str = new $c_scm_StringBuilder().init___();
  var validations = $as_sc_TraversableLike($as_sc_SeqLike(this.results$1.take__I__O(max)).sortWith__F2__O(new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(c1$2, c2$2) {
      var c1 = $as_Lamf_core_validation_AMFValidationResult(c1$2);
      var c2 = $as_Lamf_core_validation_AMFValidationResult(c2$2);
      return (c1.compare__Lamf_core_validation_AMFValidationResult__I(c2) < 0)
    })
  })(this)))).groupBy__F1__sci_Map(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_validation_AMFValidationResult(x$1$2);
      return x$1.level$1
    })
  })(this)));
  str.append__T__scm_StringBuilder((("Model: " + this.model$1) + "\n"));
  var this$3 = this.profile$1;
  str.append__T__scm_StringBuilder((("Profile: " + this$3.p$1) + "\n"));
  str.append__T__scm_StringBuilder((("Conforms? " + this.conforms$1) + "\n"));
  str.append__T__scm_StringBuilder((("Number of results: " + this.results$1.length__I()) + "\n"));
  this.appendValidations__p1__scm_StringBuilder__sci_Map__T__V(str, validations, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1);
  this.appendValidations__p1__scm_StringBuilder__sci_Map__T__V(str, validations, $m_Lamf_core_validation_SeverityLevels$().WARNING$1);
  this.appendValidations__p1__scm_StringBuilder__sci_Map__T__V(str, validations, $m_Lamf_core_validation_SeverityLevels$().INFO$1);
  return str.underlying$5.java$lang$StringBuilder$$content$f
});
$c_Lamf_core_validation_AMFValidationReport.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_validation_AMFValidationReport(obj) {
  return (((obj instanceof $c_Lamf_core_validation_AMFValidationReport) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.AMFValidationReport"))
}
function $isArrayOf_Lamf_core_validation_AMFValidationReport(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_AMFValidationReport)))
}
function $asArrayOf_Lamf_core_validation_AMFValidationReport(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_AMFValidationReport(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.AMFValidationReport;", depth))
}
var $d_Lamf_core_validation_AMFValidationReport = new $TypeData().initClass({
  Lamf_core_validation_AMFValidationReport: 0
}, false, "amf.core.validation.AMFValidationReport", {
  Lamf_core_validation_AMFValidationReport: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_validation_AMFValidationReport.prototype.$classData = $d_Lamf_core_validation_AMFValidationReport;
/** @constructor */
function $c_Lamf_core_validation_PayloadParsingResult() {
  $c_O.call(this);
  this.fragment$1 = null;
  this.results$1 = null
}
$c_Lamf_core_validation_PayloadParsingResult.prototype = new $h_O();
$c_Lamf_core_validation_PayloadParsingResult.prototype.constructor = $c_Lamf_core_validation_PayloadParsingResult;
/** @constructor */
function $h_Lamf_core_validation_PayloadParsingResult() {
  /*<skip>*/
}
$h_Lamf_core_validation_PayloadParsingResult.prototype = $c_Lamf_core_validation_PayloadParsingResult.prototype;
$c_Lamf_core_validation_PayloadParsingResult.prototype.productPrefix__T = (function() {
  return "PayloadParsingResult"
});
$c_Lamf_core_validation_PayloadParsingResult.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_validation_PayloadParsingResult.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_validation_PayloadParsingResult)) {
    var PayloadParsingResult$1 = $as_Lamf_core_validation_PayloadParsingResult(x$1);
    var x = this.fragment$1;
    var x$2 = PayloadParsingResult$1.fragment$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.results$1;
      var x$4 = PayloadParsingResult$1.results$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_validation_PayloadParsingResult.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fragment$1;
      break
    }
    case 1: {
      return this.results$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_validation_PayloadParsingResult.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_validation_PayloadParsingResult.prototype.init___Lamf_core_model_document_PayloadFragment__sci_List = (function(fragment, results) {
  this.fragment$1 = fragment;
  this.results$1 = results;
  return this
});
$c_Lamf_core_validation_PayloadParsingResult.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_validation_PayloadParsingResult.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_validation_PayloadParsingResult(obj) {
  return (((obj instanceof $c_Lamf_core_validation_PayloadParsingResult) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.PayloadParsingResult"))
}
function $isArrayOf_Lamf_core_validation_PayloadParsingResult(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_PayloadParsingResult)))
}
function $asArrayOf_Lamf_core_validation_PayloadParsingResult(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_PayloadParsingResult(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.PayloadParsingResult;", depth))
}
var $d_Lamf_core_validation_PayloadParsingResult = new $TypeData().initClass({
  Lamf_core_validation_PayloadParsingResult: 0
}, false, "amf.core.validation.PayloadParsingResult", {
  Lamf_core_validation_PayloadParsingResult: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_validation_PayloadParsingResult.prototype.$classData = $d_Lamf_core_validation_PayloadParsingResult;
/** @constructor */
function $c_Lamf_core_validation_ValidationCandidate() {
  $c_O.call(this);
  this.shape$1 = null;
  this.payload$1 = null
}
$c_Lamf_core_validation_ValidationCandidate.prototype = new $h_O();
$c_Lamf_core_validation_ValidationCandidate.prototype.constructor = $c_Lamf_core_validation_ValidationCandidate;
/** @constructor */
function $h_Lamf_core_validation_ValidationCandidate() {
  /*<skip>*/
}
$h_Lamf_core_validation_ValidationCandidate.prototype = $c_Lamf_core_validation_ValidationCandidate.prototype;
$c_Lamf_core_validation_ValidationCandidate.prototype.productPrefix__T = (function() {
  return "ValidationCandidate"
});
$c_Lamf_core_validation_ValidationCandidate.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_validation_ValidationCandidate.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_model_document_PayloadFragment = (function(shape, payload) {
  this.shape$1 = shape;
  this.payload$1 = payload;
  return this
});
$c_Lamf_core_validation_ValidationCandidate.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_validation_ValidationCandidate)) {
    var ValidationCandidate$1 = $as_Lamf_core_validation_ValidationCandidate(x$1);
    var x = this.shape$1;
    var x$2 = ValidationCandidate$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.payload$1;
      var x$4 = ValidationCandidate$1.payload$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_validation_ValidationCandidate.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.payload$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_validation_ValidationCandidate.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_validation_ValidationCandidate.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_validation_ValidationCandidate.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_validation_ValidationCandidate(obj) {
  return (((obj instanceof $c_Lamf_core_validation_ValidationCandidate) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.ValidationCandidate"))
}
function $isArrayOf_Lamf_core_validation_ValidationCandidate(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_ValidationCandidate)))
}
function $asArrayOf_Lamf_core_validation_ValidationCandidate(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_ValidationCandidate(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.ValidationCandidate;", depth))
}
var $d_Lamf_core_validation_ValidationCandidate = new $TypeData().initClass({
  Lamf_core_validation_ValidationCandidate: 0
}, false, "amf.core.validation.ValidationCandidate", {
  Lamf_core_validation_ValidationCandidate: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_validation_ValidationCandidate.prototype.$classData = $d_Lamf_core_validation_ValidationCandidate;
/** @constructor */
function $c_Lamf_core_validation_ValidationShapeSet() {
  $c_O.call(this);
  this.candidates$1 = null;
  this.defaultSeverity$1 = null
}
$c_Lamf_core_validation_ValidationShapeSet.prototype = new $h_O();
$c_Lamf_core_validation_ValidationShapeSet.prototype.constructor = $c_Lamf_core_validation_ValidationShapeSet;
/** @constructor */
function $h_Lamf_core_validation_ValidationShapeSet() {
  /*<skip>*/
}
$h_Lamf_core_validation_ValidationShapeSet.prototype = $c_Lamf_core_validation_ValidationShapeSet.prototype;
$c_Lamf_core_validation_ValidationShapeSet.prototype.productPrefix__T = (function() {
  return "ValidationShapeSet"
});
$c_Lamf_core_validation_ValidationShapeSet.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_validation_ValidationShapeSet.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_validation_ValidationShapeSet)) {
    var ValidationShapeSet$1 = $as_Lamf_core_validation_ValidationShapeSet(x$1);
    var x = this.candidates$1;
    var x$2 = ValidationShapeSet$1.candidates$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      return (this.defaultSeverity$1 === ValidationShapeSet$1.defaultSeverity$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_validation_ValidationShapeSet.prototype.init___sc_Seq__T = (function(candidates, defaultSeverity) {
  this.candidates$1 = candidates;
  this.defaultSeverity$1 = defaultSeverity;
  return this
});
$c_Lamf_core_validation_ValidationShapeSet.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.candidates$1;
      break
    }
    case 1: {
      return this.defaultSeverity$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_validation_ValidationShapeSet.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_validation_ValidationShapeSet.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_validation_ValidationShapeSet.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_validation_ValidationShapeSet(obj) {
  return (((obj instanceof $c_Lamf_core_validation_ValidationShapeSet) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.ValidationShapeSet"))
}
function $isArrayOf_Lamf_core_validation_ValidationShapeSet(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_ValidationShapeSet)))
}
function $asArrayOf_Lamf_core_validation_ValidationShapeSet(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_ValidationShapeSet(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.ValidationShapeSet;", depth))
}
var $d_Lamf_core_validation_ValidationShapeSet = new $TypeData().initClass({
  Lamf_core_validation_ValidationShapeSet: 0
}, false, "amf.core.validation.ValidationShapeSet", {
  Lamf_core_validation_ValidationShapeSet: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_validation_ValidationShapeSet.prototype.$classData = $d_Lamf_core_validation_ValidationShapeSet;
/** @constructor */
function $c_Lamf_core_validation_core_FunctionConstraint() {
  $c_O.call(this);
  this.message$1 = null;
  this.code$1 = null;
  this.libraries$1 = null;
  this.functionName$1 = null;
  this.parameters$1 = null;
  this.internalFunction$1 = null
}
$c_Lamf_core_validation_core_FunctionConstraint.prototype = new $h_O();
$c_Lamf_core_validation_core_FunctionConstraint.prototype.constructor = $c_Lamf_core_validation_core_FunctionConstraint;
/** @constructor */
function $h_Lamf_core_validation_core_FunctionConstraint() {
  /*<skip>*/
}
$h_Lamf_core_validation_core_FunctionConstraint.prototype = $c_Lamf_core_validation_core_FunctionConstraint.prototype;
$c_Lamf_core_validation_core_FunctionConstraint.prototype.productPrefix__T = (function() {
  return "FunctionConstraint"
});
$c_Lamf_core_validation_core_FunctionConstraint.prototype.validatorId__T__T = (function(validationId) {
  return (validationId + "Validator")
});
$c_Lamf_core_validation_core_FunctionConstraint.prototype.productArity__I = (function() {
  return 6
});
$c_Lamf_core_validation_core_FunctionConstraint.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_validation_core_FunctionConstraint)) {
    var FunctionConstraint$1 = $as_Lamf_core_validation_core_FunctionConstraint(x$1);
    var x = this.message$1;
    var x$2 = FunctionConstraint$1.message$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.code$1;
      var x$4 = FunctionConstraint$1.code$1;
      var jsx$4 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      var x$5 = this.libraries$1;
      var x$6 = FunctionConstraint$1.libraries$1;
      var jsx$3 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$7 = this.functionName$1;
      var x$8 = FunctionConstraint$1.functionName$1;
      var jsx$2 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$9 = this.parameters$1;
      var x$10 = FunctionConstraint$1.parameters$1;
      var jsx$1 = ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$11 = this.internalFunction$1;
      var x$12 = FunctionConstraint$1.internalFunction$1;
      return ((x$11 === null) ? (x$12 === null) : x$11.equals__O__Z(x$12))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_validation_core_FunctionConstraint.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.message$1;
      break
    }
    case 1: {
      return this.code$1;
      break
    }
    case 2: {
      return this.libraries$1;
      break
    }
    case 3: {
      return this.functionName$1;
      break
    }
    case 4: {
      return this.parameters$1;
      break
    }
    case 5: {
      return this.internalFunction$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_validation_core_FunctionConstraint.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_validation_core_FunctionConstraint.prototype.validatorPath__T__T = (function(validationId) {
  return (validationId + "Path")
});
$c_Lamf_core_validation_core_FunctionConstraint.prototype.init___s_Option__s_Option__sc_Seq__s_Option__sc_Seq__s_Option = (function(message, code, libraries, functionName, parameters, internalFunction) {
  this.message$1 = message;
  this.code$1 = code;
  this.libraries$1 = libraries;
  this.functionName$1 = functionName;
  this.parameters$1 = parameters;
  this.internalFunction$1 = internalFunction;
  return this
});
$c_Lamf_core_validation_core_FunctionConstraint.prototype.computeFunctionName__T__T = (function(validationId) {
  var x1 = this.functionName$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var fnName = $as_T(x2.value$2);
    return fnName
  } else {
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(validationId, "/", 0);
    var this$3 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    var thiz = $as_T($f_sc_IndexedSeqOptimized__last__O(this$3));
    var xs$1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "#", 0);
    var this$6 = new $c_scm_ArrayOps$ofRef().init___AO(xs$1);
    var localName = $as_T($f_sc_IndexedSeqOptimized__last__O(this$6));
    var thiz$1 = $as_T(localName.split("-").join("_"));
    return ($as_T(thiz$1.split(".").join("_")) + "FnName")
  }
});
$c_Lamf_core_validation_core_FunctionConstraint.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_validation_core_FunctionConstraint.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_validation_core_FunctionConstraint.prototype.constraintId__T__T = (function(validationId) {
  return (validationId + "Constraint")
});
function $as_Lamf_core_validation_core_FunctionConstraint(obj) {
  return (((obj instanceof $c_Lamf_core_validation_core_FunctionConstraint) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.core.FunctionConstraint"))
}
function $isArrayOf_Lamf_core_validation_core_FunctionConstraint(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_core_FunctionConstraint)))
}
function $asArrayOf_Lamf_core_validation_core_FunctionConstraint(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_core_FunctionConstraint(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.core.FunctionConstraint;", depth))
}
var $d_Lamf_core_validation_core_FunctionConstraint = new $TypeData().initClass({
  Lamf_core_validation_core_FunctionConstraint: 0
}, false, "amf.core.validation.core.FunctionConstraint", {
  Lamf_core_validation_core_FunctionConstraint: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_validation_core_FunctionConstraint.prototype.$classData = $d_Lamf_core_validation_core_FunctionConstraint;
/** @constructor */
function $c_Lamf_core_validation_core_FunctionConstraintParameter() {
  /*<skip>*/
}
function $as_Lamf_core_validation_core_FunctionConstraintParameter(obj) {
  return (((obj instanceof $c_Lamf_core_validation_core_FunctionConstraintParameter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.core.FunctionConstraintParameter"))
}
function $isArrayOf_Lamf_core_validation_core_FunctionConstraintParameter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_core_FunctionConstraintParameter)))
}
function $asArrayOf_Lamf_core_validation_core_FunctionConstraintParameter(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_core_FunctionConstraintParameter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.core.FunctionConstraintParameter;", depth))
}
/** @constructor */
function $c_Lamf_core_validation_core_NodeConstraint() {
  $c_O.call(this);
  this.constraint$1 = null;
  this.value$1 = null
}
$c_Lamf_core_validation_core_NodeConstraint.prototype = new $h_O();
$c_Lamf_core_validation_core_NodeConstraint.prototype.constructor = $c_Lamf_core_validation_core_NodeConstraint;
/** @constructor */
function $h_Lamf_core_validation_core_NodeConstraint() {
  /*<skip>*/
}
$h_Lamf_core_validation_core_NodeConstraint.prototype = $c_Lamf_core_validation_core_NodeConstraint.prototype;
$c_Lamf_core_validation_core_NodeConstraint.prototype.init___T__T = (function(constraint, value) {
  this.constraint$1 = constraint;
  this.value$1 = value;
  return this
});
$c_Lamf_core_validation_core_NodeConstraint.prototype.productPrefix__T = (function() {
  return "NodeConstraint"
});
$c_Lamf_core_validation_core_NodeConstraint.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_validation_core_NodeConstraint.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_validation_core_NodeConstraint)) {
    var NodeConstraint$1 = $as_Lamf_core_validation_core_NodeConstraint(x$1);
    return ((this.constraint$1 === NodeConstraint$1.constraint$1) && (this.value$1 === NodeConstraint$1.value$1))
  } else {
    return false
  }
});
$c_Lamf_core_validation_core_NodeConstraint.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.constraint$1;
      break
    }
    case 1: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_validation_core_NodeConstraint.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_validation_core_NodeConstraint.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_validation_core_NodeConstraint.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_validation_core_NodeConstraint(obj) {
  return (((obj instanceof $c_Lamf_core_validation_core_NodeConstraint) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.core.NodeConstraint"))
}
function $isArrayOf_Lamf_core_validation_core_NodeConstraint(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_core_NodeConstraint)))
}
function $asArrayOf_Lamf_core_validation_core_NodeConstraint(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_core_NodeConstraint(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.core.NodeConstraint;", depth))
}
var $d_Lamf_core_validation_core_NodeConstraint = new $TypeData().initClass({
  Lamf_core_validation_core_NodeConstraint: 0
}, false, "amf.core.validation.core.NodeConstraint", {
  Lamf_core_validation_core_NodeConstraint: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_validation_core_NodeConstraint.prototype.$classData = $d_Lamf_core_validation_core_NodeConstraint;
/** @constructor */
function $c_Lamf_core_validation_core_PropertyConstraint() {
  $c_O.call(this);
  this.ramlPropertyId$1 = null;
  this.name$1 = null;
  this.path$1 = null;
  this.message$1 = null;
  this.pattern$1 = null;
  this.patternedProperty$1 = null;
  this.maxCount$1 = null;
  this.minCount$1 = null;
  this.minLength$1 = null;
  this.maxLength$1 = null;
  this.minExclusive$1 = null;
  this.maxExclusive$1 = null;
  this.minInclusive$1 = null;
  this.maxInclusive$1 = null;
  this.multipleOf$1 = null;
  this.node$1 = null;
  this.datatype$1 = null;
  this.class$1 = null;
  this.in$1 = null;
  this.custom$1 = null;
  this.customRdf$1 = null;
  this.atLeast$1 = null;
  this.atMost$1 = null;
  this.value$1 = null;
  this.equalToProperty$1 = null;
  this.disjointWithProperty$1 = null;
  this.lessThanProperty$1 = null;
  this.lessThanOrEqualsToProperty$1 = null
}
$c_Lamf_core_validation_core_PropertyConstraint.prototype = new $h_O();
$c_Lamf_core_validation_core_PropertyConstraint.prototype.constructor = $c_Lamf_core_validation_core_PropertyConstraint;
/** @constructor */
function $h_Lamf_core_validation_core_PropertyConstraint() {
  /*<skip>*/
}
$h_Lamf_core_validation_core_PropertyConstraint.prototype = $c_Lamf_core_validation_core_PropertyConstraint.prototype;
$c_Lamf_core_validation_core_PropertyConstraint.prototype.productPrefix__T = (function() {
  return "PropertyConstraint"
});
$c_Lamf_core_validation_core_PropertyConstraint.prototype.productArity__I = (function() {
  return 28
});
$c_Lamf_core_validation_core_PropertyConstraint.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_validation_core_PropertyConstraint)) {
    var PropertyConstraint$1 = $as_Lamf_core_validation_core_PropertyConstraint(x$1);
    if (((this.ramlPropertyId$1 === PropertyConstraint$1.ramlPropertyId$1) && (this.name$1 === PropertyConstraint$1.name$1))) {
      var x = this.path$1;
      var x$2 = PropertyConstraint$1.path$1;
      var jsx$25 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$25 = false
    };
    if (jsx$25) {
      var x$3 = this.message$1;
      var x$4 = PropertyConstraint$1.message$1;
      var jsx$24 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$24 = false
    };
    if (jsx$24) {
      var x$5 = this.pattern$1;
      var x$6 = PropertyConstraint$1.pattern$1;
      var jsx$23 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$23 = false
    };
    if (jsx$23) {
      var x$7 = this.patternedProperty$1;
      var x$8 = PropertyConstraint$1.patternedProperty$1;
      var jsx$22 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$22 = false
    };
    if (jsx$22) {
      var x$9 = this.maxCount$1;
      var x$10 = PropertyConstraint$1.maxCount$1;
      var jsx$21 = ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      var jsx$21 = false
    };
    if (jsx$21) {
      var x$11 = this.minCount$1;
      var x$12 = PropertyConstraint$1.minCount$1;
      var jsx$20 = ((x$11 === null) ? (x$12 === null) : x$11.equals__O__Z(x$12))
    } else {
      var jsx$20 = false
    };
    if (jsx$20) {
      var x$13 = this.minLength$1;
      var x$14 = PropertyConstraint$1.minLength$1;
      var jsx$19 = ((x$13 === null) ? (x$14 === null) : x$13.equals__O__Z(x$14))
    } else {
      var jsx$19 = false
    };
    if (jsx$19) {
      var x$15 = this.maxLength$1;
      var x$16 = PropertyConstraint$1.maxLength$1;
      var jsx$18 = ((x$15 === null) ? (x$16 === null) : x$15.equals__O__Z(x$16))
    } else {
      var jsx$18 = false
    };
    if (jsx$18) {
      var x$17 = this.minExclusive$1;
      var x$18 = PropertyConstraint$1.minExclusive$1;
      var jsx$17 = ((x$17 === null) ? (x$18 === null) : x$17.equals__O__Z(x$18))
    } else {
      var jsx$17 = false
    };
    if (jsx$17) {
      var x$19 = this.maxExclusive$1;
      var x$20 = PropertyConstraint$1.maxExclusive$1;
      var jsx$16 = ((x$19 === null) ? (x$20 === null) : x$19.equals__O__Z(x$20))
    } else {
      var jsx$16 = false
    };
    if (jsx$16) {
      var x$21 = this.minInclusive$1;
      var x$22 = PropertyConstraint$1.minInclusive$1;
      var jsx$15 = ((x$21 === null) ? (x$22 === null) : x$21.equals__O__Z(x$22))
    } else {
      var jsx$15 = false
    };
    if (jsx$15) {
      var x$23 = this.maxInclusive$1;
      var x$24 = PropertyConstraint$1.maxInclusive$1;
      var jsx$14 = ((x$23 === null) ? (x$24 === null) : x$23.equals__O__Z(x$24))
    } else {
      var jsx$14 = false
    };
    if (jsx$14) {
      var x$25 = this.multipleOf$1;
      var x$26 = PropertyConstraint$1.multipleOf$1;
      var jsx$13 = ((x$25 === null) ? (x$26 === null) : x$25.equals__O__Z(x$26))
    } else {
      var jsx$13 = false
    };
    if (jsx$13) {
      var x$27 = this.node$1;
      var x$28 = PropertyConstraint$1.node$1;
      var jsx$12 = ((x$27 === null) ? (x$28 === null) : x$27.equals__O__Z(x$28))
    } else {
      var jsx$12 = false
    };
    if (jsx$12) {
      var x$29 = this.datatype$1;
      var x$30 = PropertyConstraint$1.datatype$1;
      var jsx$11 = ((x$29 === null) ? (x$30 === null) : x$29.equals__O__Z(x$30))
    } else {
      var jsx$11 = false
    };
    if (jsx$11) {
      var x$31 = this.class$1;
      var x$32 = PropertyConstraint$1.class$1;
      var jsx$10 = ((x$31 === null) ? (x$32 === null) : x$31.equals__O__Z(x$32))
    } else {
      var jsx$10 = false
    };
    if (jsx$10) {
      var x$33 = this.in$1;
      var x$34 = PropertyConstraint$1.in$1;
      var jsx$9 = ((x$33 === null) ? (x$34 === null) : x$33.equals__O__Z(x$34))
    } else {
      var jsx$9 = false
    };
    if (jsx$9) {
      var x$35 = this.custom$1;
      var x$36 = PropertyConstraint$1.custom$1;
      var jsx$8 = ((x$35 === null) ? (x$36 === null) : x$35.equals__O__Z(x$36))
    } else {
      var jsx$8 = false
    };
    if (jsx$8) {
      var x$37 = this.customRdf$1;
      var x$38 = PropertyConstraint$1.customRdf$1;
      var jsx$7 = ((x$37 === null) ? (x$38 === null) : x$37.equals__O__Z(x$38))
    } else {
      var jsx$7 = false
    };
    if (jsx$7) {
      var x$39 = this.atLeast$1;
      var x$40 = PropertyConstraint$1.atLeast$1;
      var jsx$6 = ((x$39 === null) ? (x$40 === null) : x$39.equals__O__Z(x$40))
    } else {
      var jsx$6 = false
    };
    if (jsx$6) {
      var x$41 = this.atMost$1;
      var x$42 = PropertyConstraint$1.atMost$1;
      var jsx$5 = ((x$41 === null) ? (x$42 === null) : x$41.equals__O__Z(x$42))
    } else {
      var jsx$5 = false
    };
    if (jsx$5) {
      var x$43 = this.value$1;
      var x$44 = PropertyConstraint$1.value$1;
      var jsx$4 = ((x$43 === null) ? (x$44 === null) : x$43.equals__O__Z(x$44))
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      var x$45 = this.equalToProperty$1;
      var x$46 = PropertyConstraint$1.equalToProperty$1;
      var jsx$3 = ((x$45 === null) ? (x$46 === null) : x$45.equals__O__Z(x$46))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$47 = this.disjointWithProperty$1;
      var x$48 = PropertyConstraint$1.disjointWithProperty$1;
      var jsx$2 = ((x$47 === null) ? (x$48 === null) : x$47.equals__O__Z(x$48))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$49 = this.lessThanProperty$1;
      var x$50 = PropertyConstraint$1.lessThanProperty$1;
      var jsx$1 = ((x$49 === null) ? (x$50 === null) : x$49.equals__O__Z(x$50))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$51 = this.lessThanOrEqualsToProperty$1;
      var x$52 = PropertyConstraint$1.lessThanOrEqualsToProperty$1;
      return ((x$51 === null) ? (x$52 === null) : x$51.equals__O__Z(x$52))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_validation_core_PropertyConstraint.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.ramlPropertyId$1;
      break
    }
    case 1: {
      return this.name$1;
      break
    }
    case 2: {
      return this.path$1;
      break
    }
    case 3: {
      return this.message$1;
      break
    }
    case 4: {
      return this.pattern$1;
      break
    }
    case 5: {
      return this.patternedProperty$1;
      break
    }
    case 6: {
      return this.maxCount$1;
      break
    }
    case 7: {
      return this.minCount$1;
      break
    }
    case 8: {
      return this.minLength$1;
      break
    }
    case 9: {
      return this.maxLength$1;
      break
    }
    case 10: {
      return this.minExclusive$1;
      break
    }
    case 11: {
      return this.maxExclusive$1;
      break
    }
    case 12: {
      return this.minInclusive$1;
      break
    }
    case 13: {
      return this.maxInclusive$1;
      break
    }
    case 14: {
      return this.multipleOf$1;
      break
    }
    case 15: {
      return this.node$1;
      break
    }
    case 16: {
      return this.datatype$1;
      break
    }
    case 17: {
      return this.class$1;
      break
    }
    case 18: {
      return this.in$1;
      break
    }
    case 19: {
      return this.custom$1;
      break
    }
    case 20: {
      return this.customRdf$1;
      break
    }
    case 21: {
      return this.atLeast$1;
      break
    }
    case 22: {
      return this.atMost$1;
      break
    }
    case 23: {
      return this.value$1;
      break
    }
    case 24: {
      return this.equalToProperty$1;
      break
    }
    case 25: {
      return this.disjointWithProperty$1;
      break
    }
    case 26: {
      return this.lessThanProperty$1;
      break
    }
    case 27: {
      return this.lessThanOrEqualsToProperty$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_validation_core_PropertyConstraint.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_validation_core_PropertyConstraint.prototype.init___T__T__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option = (function(ramlPropertyId, name, path, message, pattern, patternedProperty, maxCount, minCount, minLength, maxLength, minExclusive, maxExclusive, minInclusive, maxInclusive, multipleOf, node, datatype, $class, $in, custom, customRdf, atLeast, atMost, value, equalToProperty, disjointWithProperty, lessThanProperty, lessThanOrEqualsToProperty) {
  this.ramlPropertyId$1 = ramlPropertyId;
  this.name$1 = name;
  this.path$1 = path;
  this.message$1 = message;
  this.pattern$1 = pattern;
  this.patternedProperty$1 = patternedProperty;
  this.maxCount$1 = maxCount;
  this.minCount$1 = minCount;
  this.minLength$1 = minLength;
  this.maxLength$1 = maxLength;
  this.minExclusive$1 = minExclusive;
  this.maxExclusive$1 = maxExclusive;
  this.minInclusive$1 = minInclusive;
  this.maxInclusive$1 = maxInclusive;
  this.multipleOf$1 = multipleOf;
  this.node$1 = node;
  this.datatype$1 = datatype;
  this.class$1 = $class;
  this.in$1 = $in;
  this.custom$1 = custom;
  this.customRdf$1 = customRdf;
  this.atLeast$1 = atLeast;
  this.atMost$1 = atMost;
  this.value$1 = value;
  this.equalToProperty$1 = equalToProperty;
  this.disjointWithProperty$1 = disjointWithProperty;
  this.lessThanProperty$1 = lessThanProperty;
  this.lessThanOrEqualsToProperty$1 = lessThanOrEqualsToProperty;
  return this
});
$c_Lamf_core_validation_core_PropertyConstraint.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_validation_core_PropertyConstraint.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_validation_core_PropertyConstraint(obj) {
  return (((obj instanceof $c_Lamf_core_validation_core_PropertyConstraint) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.core.PropertyConstraint"))
}
function $isArrayOf_Lamf_core_validation_core_PropertyConstraint(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_core_PropertyConstraint)))
}
function $asArrayOf_Lamf_core_validation_core_PropertyConstraint(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_core_PropertyConstraint(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.core.PropertyConstraint;", depth))
}
var $d_Lamf_core_validation_core_PropertyConstraint = new $TypeData().initClass({
  Lamf_core_validation_core_PropertyConstraint: 0
}, false, "amf.core.validation.core.PropertyConstraint", {
  Lamf_core_validation_core_PropertyConstraint: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_validation_core_PropertyConstraint.prototype.$classData = $d_Lamf_core_validation_core_PropertyConstraint;
/** @constructor */
function $c_Lamf_core_validation_core_QueryConstraint() {
  $c_O.call(this);
  this.prefixes$1 = null;
  this.query$1 = null
}
$c_Lamf_core_validation_core_QueryConstraint.prototype = new $h_O();
$c_Lamf_core_validation_core_QueryConstraint.prototype.constructor = $c_Lamf_core_validation_core_QueryConstraint;
/** @constructor */
function $h_Lamf_core_validation_core_QueryConstraint() {
  /*<skip>*/
}
$h_Lamf_core_validation_core_QueryConstraint.prototype = $c_Lamf_core_validation_core_QueryConstraint.prototype;
$c_Lamf_core_validation_core_QueryConstraint.prototype.productPrefix__T = (function() {
  return "QueryConstraint"
});
$c_Lamf_core_validation_core_QueryConstraint.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_validation_core_QueryConstraint.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_validation_core_QueryConstraint)) {
    var QueryConstraint$1 = $as_Lamf_core_validation_core_QueryConstraint(x$1);
    var x = this.prefixes$1;
    var x$2 = QueryConstraint$1.prefixes$1;
    if (((x === null) ? (x$2 === null) : $f_sc_GenMapLike__equals__O__Z(x, x$2))) {
      return (this.query$1 === QueryConstraint$1.query$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_validation_core_QueryConstraint.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.prefixes$1;
      break
    }
    case 1: {
      return this.query$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_validation_core_QueryConstraint.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_validation_core_QueryConstraint.prototype.init___sci_Map__T = (function(prefixes, query) {
  this.prefixes$1 = prefixes;
  this.query$1 = query;
  return this
});
$c_Lamf_core_validation_core_QueryConstraint.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_validation_core_QueryConstraint.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_validation_core_QueryConstraint(obj) {
  return (((obj instanceof $c_Lamf_core_validation_core_QueryConstraint) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.core.QueryConstraint"))
}
function $isArrayOf_Lamf_core_validation_core_QueryConstraint(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_core_QueryConstraint)))
}
function $asArrayOf_Lamf_core_validation_core_QueryConstraint(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_core_QueryConstraint(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.core.QueryConstraint;", depth))
}
var $d_Lamf_core_validation_core_QueryConstraint = new $TypeData().initClass({
  Lamf_core_validation_core_QueryConstraint: 0
}, false, "amf.core.validation.core.QueryConstraint", {
  Lamf_core_validation_core_QueryConstraint: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_validation_core_QueryConstraint.prototype.$classData = $d_Lamf_core_validation_core_QueryConstraint;
/** @constructor */
function $c_Lamf_core_validation_core_ValidationProfile() {
  $c_O.call(this);
  this.name$1 = null;
  this.baseProfile$1 = null;
  this.violationLevel$1 = null;
  this.infoLevel$1 = null;
  this.warningLevel$1 = null;
  this.disabled$1 = null;
  this.validations$1 = null;
  this.prefixes$1 = null
}
$c_Lamf_core_validation_core_ValidationProfile.prototype = new $h_O();
$c_Lamf_core_validation_core_ValidationProfile.prototype.constructor = $c_Lamf_core_validation_core_ValidationProfile;
/** @constructor */
function $h_Lamf_core_validation_core_ValidationProfile() {
  /*<skip>*/
}
$h_Lamf_core_validation_core_ValidationProfile.prototype = $c_Lamf_core_validation_core_ValidationProfile.prototype;
$c_Lamf_core_validation_core_ValidationProfile.prototype.productPrefix__T = (function() {
  return "ValidationProfile"
});
$c_Lamf_core_validation_core_ValidationProfile.prototype.productArity__I = (function() {
  return 8
});
$c_Lamf_core_validation_core_ValidationProfile.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_validation_core_ValidationProfile)) {
    var ValidationProfile$1 = $as_Lamf_core_validation_core_ValidationProfile(x$1);
    var x = this.name$1;
    var x$2 = ValidationProfile$1.name$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.baseProfile$1;
      var x$4 = ValidationProfile$1.baseProfile$1;
      var jsx$6 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$6 = false
    };
    if (jsx$6) {
      var x$5 = this.violationLevel$1;
      var x$6 = ValidationProfile$1.violationLevel$1;
      var jsx$5 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$5 = false
    };
    if (jsx$5) {
      var x$7 = this.infoLevel$1;
      var x$8 = ValidationProfile$1.infoLevel$1;
      var jsx$4 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      var x$9 = this.warningLevel$1;
      var x$10 = ValidationProfile$1.warningLevel$1;
      var jsx$3 = ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$11 = this.disabled$1;
      var x$12 = ValidationProfile$1.disabled$1;
      var jsx$2 = ((x$11 === null) ? (x$12 === null) : x$11.equals__O__Z(x$12))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$13 = this.validations$1;
      var x$14 = ValidationProfile$1.validations$1;
      var jsx$1 = ((x$13 === null) ? (x$14 === null) : x$13.equals__O__Z(x$14))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$15 = this.prefixes$1;
      var x$16 = ValidationProfile$1.prefixes$1;
      return ((x$15 === null) ? (x$16 === null) : $f_sc_GenMapLike__equals__O__Z(x$15, x$16))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_validation_core_ValidationProfile.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.name$1;
      break
    }
    case 1: {
      return this.baseProfile$1;
      break
    }
    case 2: {
      return this.violationLevel$1;
      break
    }
    case 3: {
      return this.infoLevel$1;
      break
    }
    case 4: {
      return this.warningLevel$1;
      break
    }
    case 5: {
      return this.disabled$1;
      break
    }
    case 6: {
      return this.validations$1;
      break
    }
    case 7: {
      return this.prefixes$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_validation_core_ValidationProfile.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_validation_core_ValidationProfile.prototype.init___Lamf_ProfileName__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__scm_Map = (function(name, baseProfile, violationLevel, infoLevel, warningLevel, disabled, validations, prefixes) {
  this.name$1 = name;
  this.baseProfile$1 = baseProfile;
  this.violationLevel$1 = violationLevel;
  this.infoLevel$1 = infoLevel;
  this.warningLevel$1 = warningLevel;
  this.disabled$1 = disabled;
  this.validations$1 = validations;
  this.prefixes$1 = prefixes;
  return this
});
$c_Lamf_core_validation_core_ValidationProfile.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_validation_core_ValidationProfile.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_validation_core_ValidationProfile(obj) {
  return (((obj instanceof $c_Lamf_core_validation_core_ValidationProfile) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.core.ValidationProfile"))
}
function $isArrayOf_Lamf_core_validation_core_ValidationProfile(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_core_ValidationProfile)))
}
function $asArrayOf_Lamf_core_validation_core_ValidationProfile(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_core_ValidationProfile(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.core.ValidationProfile;", depth))
}
var $d_Lamf_core_validation_core_ValidationProfile = new $TypeData().initClass({
  Lamf_core_validation_core_ValidationProfile: 0
}, false, "amf.core.validation.core.ValidationProfile", {
  Lamf_core_validation_core_ValidationProfile: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_validation_core_ValidationProfile.prototype.$classData = $d_Lamf_core_validation_core_ValidationProfile;
/** @constructor */
function $c_Lamf_core_validation_core_ValidationSpecification() {
  $c_O.call(this);
  this.name$1 = null;
  this.message$1 = null;
  this.ramlMessage$1 = null;
  this.oasMessage$1 = null;
  this.targetInstance$1 = null;
  this.targetClass$1 = null;
  this.targetObject$1 = null;
  this.unionConstraints$1 = null;
  this.andConstraints$1 = null;
  this.xoneConstraints$1 = null;
  this.notConstraint$1 = null;
  this.propertyConstraints$1 = null;
  this.nodeConstraints$1 = null;
  this.closed$1 = null;
  this.functionConstraint$1 = null;
  this.custom$1 = null;
  this.nested$1 = null;
  this.replacesFunctionConstraint$1 = null;
  this.query$1 = null;
  this.id$1 = null
}
$c_Lamf_core_validation_core_ValidationSpecification.prototype = new $h_O();
$c_Lamf_core_validation_core_ValidationSpecification.prototype.constructor = $c_Lamf_core_validation_core_ValidationSpecification;
/** @constructor */
function $h_Lamf_core_validation_core_ValidationSpecification() {
  /*<skip>*/
}
$h_Lamf_core_validation_core_ValidationSpecification.prototype = $c_Lamf_core_validation_core_ValidationSpecification.prototype;
$c_Lamf_core_validation_core_ValidationSpecification.prototype.productPrefix__T = (function() {
  return "ValidationSpecification"
});
$c_Lamf_core_validation_core_ValidationSpecification.prototype.productArity__I = (function() {
  return 19
});
$c_Lamf_core_validation_core_ValidationSpecification.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_validation_core_ValidationSpecification)) {
    var ValidationSpecification$1 = $as_Lamf_core_validation_core_ValidationSpecification(x$1);
    if (((this.name$1 === ValidationSpecification$1.name$1) && (this.message$1 === ValidationSpecification$1.message$1))) {
      var x = this.ramlMessage$1;
      var x$2 = ValidationSpecification$1.ramlMessage$1;
      var jsx$16 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$16 = false
    };
    if (jsx$16) {
      var x$3 = this.oasMessage$1;
      var x$4 = ValidationSpecification$1.oasMessage$1;
      var jsx$15 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$15 = false
    };
    if (jsx$15) {
      var x$5 = this.targetInstance$1;
      var x$6 = ValidationSpecification$1.targetInstance$1;
      var jsx$14 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$14 = false
    };
    if (jsx$14) {
      var x$7 = this.targetClass$1;
      var x$8 = ValidationSpecification$1.targetClass$1;
      var jsx$13 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$13 = false
    };
    if (jsx$13) {
      var x$9 = this.targetObject$1;
      var x$10 = ValidationSpecification$1.targetObject$1;
      var jsx$12 = ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      var jsx$12 = false
    };
    if (jsx$12) {
      var x$11 = this.unionConstraints$1;
      var x$12 = ValidationSpecification$1.unionConstraints$1;
      var jsx$11 = ((x$11 === null) ? (x$12 === null) : x$11.equals__O__Z(x$12))
    } else {
      var jsx$11 = false
    };
    if (jsx$11) {
      var x$13 = this.andConstraints$1;
      var x$14 = ValidationSpecification$1.andConstraints$1;
      var jsx$10 = ((x$13 === null) ? (x$14 === null) : x$13.equals__O__Z(x$14))
    } else {
      var jsx$10 = false
    };
    if (jsx$10) {
      var x$15 = this.xoneConstraints$1;
      var x$16 = ValidationSpecification$1.xoneConstraints$1;
      var jsx$9 = ((x$15 === null) ? (x$16 === null) : x$15.equals__O__Z(x$16))
    } else {
      var jsx$9 = false
    };
    if (jsx$9) {
      var x$17 = this.notConstraint$1;
      var x$18 = ValidationSpecification$1.notConstraint$1;
      var jsx$8 = ((x$17 === null) ? (x$18 === null) : x$17.equals__O__Z(x$18))
    } else {
      var jsx$8 = false
    };
    if (jsx$8) {
      var x$19 = this.propertyConstraints$1;
      var x$20 = ValidationSpecification$1.propertyConstraints$1;
      var jsx$7 = ((x$19 === null) ? (x$20 === null) : x$19.equals__O__Z(x$20))
    } else {
      var jsx$7 = false
    };
    if (jsx$7) {
      var x$21 = this.nodeConstraints$1;
      var x$22 = ValidationSpecification$1.nodeConstraints$1;
      var jsx$6 = ((x$21 === null) ? (x$22 === null) : x$21.equals__O__Z(x$22))
    } else {
      var jsx$6 = false
    };
    if (jsx$6) {
      var x$23 = this.closed$1;
      var x$24 = ValidationSpecification$1.closed$1;
      var jsx$5 = ((x$23 === null) ? (x$24 === null) : x$23.equals__O__Z(x$24))
    } else {
      var jsx$5 = false
    };
    if (jsx$5) {
      var x$25 = this.functionConstraint$1;
      var x$26 = ValidationSpecification$1.functionConstraint$1;
      var jsx$4 = ((x$25 === null) ? (x$26 === null) : x$25.equals__O__Z(x$26))
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      var x$27 = this.custom$1;
      var x$28 = ValidationSpecification$1.custom$1;
      var jsx$3 = ((x$27 === null) ? (x$28 === null) : x$27.equals__O__Z(x$28))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$29 = this.nested$1;
      var x$30 = ValidationSpecification$1.nested$1;
      var jsx$2 = ((x$29 === null) ? (x$30 === null) : x$29.equals__O__Z(x$30))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$31 = this.replacesFunctionConstraint$1;
      var x$32 = ValidationSpecification$1.replacesFunctionConstraint$1;
      var jsx$1 = ((x$31 === null) ? (x$32 === null) : x$31.equals__O__Z(x$32))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$33 = this.query$1;
      var x$34 = ValidationSpecification$1.query$1;
      return ((x$33 === null) ? (x$34 === null) : x$33.equals__O__Z(x$34))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_validation_core_ValidationSpecification.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.name$1;
      break
    }
    case 1: {
      return this.message$1;
      break
    }
    case 2: {
      return this.ramlMessage$1;
      break
    }
    case 3: {
      return this.oasMessage$1;
      break
    }
    case 4: {
      return this.targetInstance$1;
      break
    }
    case 5: {
      return this.targetClass$1;
      break
    }
    case 6: {
      return this.targetObject$1;
      break
    }
    case 7: {
      return this.unionConstraints$1;
      break
    }
    case 8: {
      return this.andConstraints$1;
      break
    }
    case 9: {
      return this.xoneConstraints$1;
      break
    }
    case 10: {
      return this.notConstraint$1;
      break
    }
    case 11: {
      return this.propertyConstraints$1;
      break
    }
    case 12: {
      return this.nodeConstraints$1;
      break
    }
    case 13: {
      return this.closed$1;
      break
    }
    case 14: {
      return this.functionConstraint$1;
      break
    }
    case 15: {
      return this.custom$1;
      break
    }
    case 16: {
      return this.nested$1;
      break
    }
    case 17: {
      return this.replacesFunctionConstraint$1;
      break
    }
    case 18: {
      return this.query$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_validation_core_ValidationSpecification.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_validation_core_ValidationSpecification.prototype.withTargets__Lamf_core_validation_core_ValidationSpecification__Lamf_core_validation_core_ValidationSpecification = (function(other) {
  var jsx$2 = this.targetInstance$1;
  var jsx$1 = other.targetInstance$1;
  var this$1 = $m_sc_Seq$();
  var x$1 = $as_sc_Seq($as_sc_SeqLike(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).distinct__O());
  var jsx$4 = this.targetClass$1;
  var jsx$3 = other.targetClass$1;
  var this$2 = $m_sc_Seq$();
  var x$2 = $as_sc_Seq($as_sc_SeqLike(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$2.ReusableCBFInstance$2)).distinct__O());
  var jsx$6 = this.targetObject$1;
  var jsx$5 = other.targetObject$1;
  var this$3 = $m_sc_Seq$();
  var x$3 = $as_sc_Seq($as_sc_SeqLike(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$5, this$3.ReusableCBFInstance$2)).distinct__O());
  var x$4 = this.name$1;
  var x$5 = this.message$1;
  var x$6 = this.ramlMessage$1;
  var x$7 = this.oasMessage$1;
  var x$8 = this.unionConstraints$1;
  var x$9 = this.andConstraints$1;
  var x$10 = this.xoneConstraints$1;
  var x$11 = this.notConstraint$1;
  var x$12 = this.propertyConstraints$1;
  var x$13 = this.nodeConstraints$1;
  var x$14 = this.closed$1;
  var x$15 = this.functionConstraint$1;
  var x$16 = this.custom$1;
  var x$17 = this.nested$1;
  var x$18 = this.replacesFunctionConstraint$1;
  var x$19 = this.query$1;
  return new $c_Lamf_core_validation_core_ValidationSpecification().init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option(x$4, x$5, x$6, x$7, x$1, x$2, x$3, x$8, x$9, x$10, x$11, x$12, x$13, x$14, x$15, x$16, x$17, x$18, x$19)
});
$c_Lamf_core_validation_core_ValidationSpecification.prototype.init___T__T__s_Option__s_Option__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__s_Option__sc_Seq__sc_Seq__s_Option__s_Option__s_Option__s_Option__s_Option__s_Option = (function(name, message, ramlMessage, oasMessage, targetInstance, targetClass, targetObject, unionConstraints, andConstraints, xoneConstraints, notConstraint, propertyConstraints, nodeConstraints, closed, functionConstraint, custom, nested, replacesFunctionConstraint, query) {
  this.name$1 = name;
  this.message$1 = message;
  this.ramlMessage$1 = ramlMessage;
  this.oasMessage$1 = oasMessage;
  this.targetInstance$1 = targetInstance;
  this.targetClass$1 = targetClass;
  this.targetObject$1 = targetObject;
  this.unionConstraints$1 = unionConstraints;
  this.andConstraints$1 = andConstraints;
  this.xoneConstraints$1 = xoneConstraints;
  this.notConstraint$1 = notConstraint;
  this.propertyConstraints$1 = propertyConstraints;
  this.nodeConstraints$1 = nodeConstraints;
  this.closed$1 = closed;
  this.functionConstraint$1 = functionConstraint;
  this.custom$1 = custom;
  this.nested$1 = nested;
  this.replacesFunctionConstraint$1 = replacesFunctionConstraint;
  this.query$1 = query;
  if ((((($uI(name.length) >= 0) && ($as_T(name.substring(0, $uI("http://".length))) === "http://")) || (($uI(name.length) >= 0) && ($as_T(name.substring(0, $uI("https://".length))) === "https://"))) || (($uI(name.length) >= 0) && ($as_T(name.substring(0, $uI("file:".length))) === "file:")))) {
    var jsx$1 = name
  } else {
    var x1 = $m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType(name).iri__T();
    if ((((($uI(x1.length) >= 0) && ($as_T(x1.substring(0, $uI("http://".length))) === "http://")) || (($uI(x1.length) >= 0) && ($as_T(x1.substring(0, $uI("https://".length))) === "https://"))) || (($uI(x1.length) >= 0) && ($as_T(x1.substring(0, $uI("file:".length))) === "file:")))) {
      var jsx$1 = x1
    } else {
      var this$31 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
      var jsx$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$31, x1).iri__T()
    }
  };
  this.id$1 = jsx$1;
  return this
});
$c_Lamf_core_validation_core_ValidationSpecification.prototype.isParserSide__Z = (function() {
  if (this.targetInstance$1.nonEmpty__Z()) {
    var x = this.targetInstance$1.head__O();
    var x$2 = $m_Lamf_core_validation_core_ValidationSpecification$().PARSER$undSIDE$undVALIDATION$1;
    return ((x === null) ? (x$2 === null) : $objectEquals(x, x$2))
  } else {
    return false
  }
});
$c_Lamf_core_validation_core_ValidationSpecification.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_validation_core_ValidationSpecification.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_validation_core_ValidationSpecification(obj) {
  return (((obj instanceof $c_Lamf_core_validation_core_ValidationSpecification) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.core.ValidationSpecification"))
}
function $isArrayOf_Lamf_core_validation_core_ValidationSpecification(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_core_ValidationSpecification)))
}
function $asArrayOf_Lamf_core_validation_core_ValidationSpecification(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_core_ValidationSpecification(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.core.ValidationSpecification;", depth))
}
var $d_Lamf_core_validation_core_ValidationSpecification = new $TypeData().initClass({
  Lamf_core_validation_core_ValidationSpecification: 0
}, false, "amf.core.validation.core.ValidationSpecification", {
  Lamf_core_validation_core_ValidationSpecification: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_validation_core_ValidationSpecification.prototype.$classData = $d_Lamf_core_validation_core_ValidationSpecification;
/** @constructor */
function $c_Lamf_core_vocabulary_Namespace() {
  $c_O.call(this);
  this.base$1 = null
}
$c_Lamf_core_vocabulary_Namespace.prototype = new $h_O();
$c_Lamf_core_vocabulary_Namespace.prototype.constructor = $c_Lamf_core_vocabulary_Namespace;
/** @constructor */
function $h_Lamf_core_vocabulary_Namespace() {
  /*<skip>*/
}
$h_Lamf_core_vocabulary_Namespace.prototype = $c_Lamf_core_vocabulary_Namespace.prototype;
$c_Lamf_core_vocabulary_Namespace.prototype.productPrefix__T = (function() {
  return "Namespace"
});
$c_Lamf_core_vocabulary_Namespace.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_vocabulary_Namespace.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_vocabulary_Namespace)) {
    var Namespace$1 = $as_Lamf_core_vocabulary_Namespace(x$1);
    return (this.base$1 === Namespace$1.base$1)
  } else {
    return false
  }
});
$c_Lamf_core_vocabulary_Namespace.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.base$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_vocabulary_Namespace.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_vocabulary_Namespace.prototype.init___T = (function(base) {
  this.base$1 = base;
  return this
});
$c_Lamf_core_vocabulary_Namespace.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_vocabulary_Namespace.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_vocabulary_Namespace(obj) {
  return (((obj instanceof $c_Lamf_core_vocabulary_Namespace) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.vocabulary.Namespace"))
}
function $isArrayOf_Lamf_core_vocabulary_Namespace(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_vocabulary_Namespace)))
}
function $asArrayOf_Lamf_core_vocabulary_Namespace(obj, depth) {
  return (($isArrayOf_Lamf_core_vocabulary_Namespace(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.vocabulary.Namespace;", depth))
}
var $d_Lamf_core_vocabulary_Namespace = new $TypeData().initClass({
  Lamf_core_vocabulary_Namespace: 0
}, false, "amf.core.vocabulary.Namespace", {
  Lamf_core_vocabulary_Namespace: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_vocabulary_Namespace.prototype.$classData = $d_Lamf_core_vocabulary_Namespace;
/** @constructor */
function $c_Lamf_core_vocabulary_ValueType() {
  $c_O.call(this);
  this.ns$1 = null;
  this.name$1 = null
}
$c_Lamf_core_vocabulary_ValueType.prototype = new $h_O();
$c_Lamf_core_vocabulary_ValueType.prototype.constructor = $c_Lamf_core_vocabulary_ValueType;
/** @constructor */
function $h_Lamf_core_vocabulary_ValueType() {
  /*<skip>*/
}
$h_Lamf_core_vocabulary_ValueType.prototype = $c_Lamf_core_vocabulary_ValueType.prototype;
$c_Lamf_core_vocabulary_ValueType.prototype.productPrefix__T = (function() {
  return "ValueType"
});
$c_Lamf_core_vocabulary_ValueType.prototype.init___Lamf_core_vocabulary_Namespace__T = (function(ns, name) {
  this.ns$1 = ns;
  this.name$1 = name;
  return this
});
$c_Lamf_core_vocabulary_ValueType.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_vocabulary_ValueType.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_vocabulary_ValueType)) {
    var ValueType$1 = $as_Lamf_core_vocabulary_ValueType(x$1);
    var x = this.ns$1;
    var x$2 = ValueType$1.ns$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      return (this.name$1 === ValueType$1.name$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_vocabulary_ValueType.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.ns$1;
      break
    }
    case 1: {
      return this.name$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_vocabulary_ValueType.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_vocabulary_ValueType.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_vocabulary_ValueType.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_vocabulary_ValueType.prototype.iri__T = (function() {
  return (("" + this.ns$1.base$1) + this.name$1)
});
function $as_Lamf_core_vocabulary_ValueType(obj) {
  return (((obj instanceof $c_Lamf_core_vocabulary_ValueType) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.vocabulary.ValueType"))
}
function $isArrayOf_Lamf_core_vocabulary_ValueType(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_vocabulary_ValueType)))
}
function $asArrayOf_Lamf_core_vocabulary_ValueType(obj, depth) {
  return (($isArrayOf_Lamf_core_vocabulary_ValueType(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.vocabulary.ValueType;", depth))
}
var $d_Lamf_core_vocabulary_ValueType = new $TypeData().initClass({
  Lamf_core_vocabulary_ValueType: 0
}, false, "amf.core.vocabulary.ValueType", {
  Lamf_core_vocabulary_ValueType: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_vocabulary_ValueType.prototype.$classData = $d_Lamf_core_vocabulary_ValueType;
/** @constructor */
function $c_Lamf_internal_environment_Environment() {
  $c_O.call(this);
  this.loaders$1 = null;
  this.resolver$1 = null;
  this.maxYamlReferences$1 = null
}
$c_Lamf_internal_environment_Environment.prototype = new $h_O();
$c_Lamf_internal_environment_Environment.prototype.constructor = $c_Lamf_internal_environment_Environment;
/** @constructor */
function $h_Lamf_internal_environment_Environment() {
  /*<skip>*/
}
$h_Lamf_internal_environment_Environment.prototype = $c_Lamf_internal_environment_Environment.prototype;
$c_Lamf_internal_environment_Environment.prototype.productPrefix__T = (function() {
  return "Environment"
});
$c_Lamf_internal_environment_Environment.prototype.init___sc_Seq__s_Option__s_Option = (function(loaders, resolver, maxYamlReferences) {
  this.loaders$1 = loaders;
  this.resolver$1 = resolver;
  this.maxYamlReferences$1 = maxYamlReferences;
  return this
});
$c_Lamf_internal_environment_Environment.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_internal_environment_Environment.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_internal_environment_Environment)) {
    var Environment$1 = $as_Lamf_internal_environment_Environment(x$1);
    var x = this.loaders$1;
    var x$2 = Environment$1.loaders$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.resolver$1;
      var x$4 = Environment$1.resolver$1;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.maxYamlReferences$1;
      var x$6 = Environment$1.maxYamlReferences$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_internal_environment_Environment.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.loaders$1;
      break
    }
    case 1: {
      return this.resolver$1;
      break
    }
    case 2: {
      return this.maxYamlReferences$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_internal_environment_Environment.prototype.withResolver__Lamf_internal_reference_ReferenceResolver__Lamf_internal_environment_Environment = (function(resolver) {
  return new $c_Lamf_internal_environment_Environment().init___sc_Seq__s_Option__s_Option(this.loaders$1, new $c_s_Some().init___O(resolver), this.maxYamlReferences$1)
});
$c_Lamf_internal_environment_Environment.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_internal_environment_Environment.prototype.add__Lamf_internal_resource_ResourceLoader__Lamf_internal_environment_Environment = (function(loader) {
  var jsx$1 = this.loaders$1;
  var this$1 = $m_sc_Seq$();
  return new $c_Lamf_internal_environment_Environment().init___sc_Seq__s_Option__s_Option($as_sc_Seq(jsx$1.$$plus$colon__O__scg_CanBuildFrom__O(loader, this$1.ReusableCBFInstance$2)), this.resolver$1, this.maxYamlReferences$1)
});
$c_Lamf_internal_environment_Environment.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_internal_environment_Environment.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_internal_environment_Environment.prototype.setMaxYamlReferences__J__Lamf_internal_environment_Environment = (function(value) {
  return new $c_Lamf_internal_environment_Environment().init___sc_Seq__s_Option__s_Option(this.loaders$1, this.resolver$1, new $c_s_Some().init___O(value))
});
function $as_Lamf_internal_environment_Environment(obj) {
  return (((obj instanceof $c_Lamf_internal_environment_Environment) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.internal.environment.Environment"))
}
function $isArrayOf_Lamf_internal_environment_Environment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_internal_environment_Environment)))
}
function $asArrayOf_Lamf_internal_environment_Environment(obj, depth) {
  return (($isArrayOf_Lamf_internal_environment_Environment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.internal.environment.Environment;", depth))
}
var $d_Lamf_internal_environment_Environment = new $TypeData().initClass({
  Lamf_internal_environment_Environment: 0
}, false, "amf.internal.environment.Environment", {
  Lamf_internal_environment_Environment: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_internal_environment_Environment.prototype.$classData = $d_Lamf_internal_environment_Environment;
/** @constructor */
function $c_Lamf_internal_reference_CachedReference() {
  $c_O.call(this);
  this.url$1 = null;
  this.content$1 = null;
  this.resolved$1 = false
}
$c_Lamf_internal_reference_CachedReference.prototype = new $h_O();
$c_Lamf_internal_reference_CachedReference.prototype.constructor = $c_Lamf_internal_reference_CachedReference;
/** @constructor */
function $h_Lamf_internal_reference_CachedReference() {
  /*<skip>*/
}
$h_Lamf_internal_reference_CachedReference.prototype = $c_Lamf_internal_reference_CachedReference.prototype;
$c_Lamf_internal_reference_CachedReference.prototype.productPrefix__T = (function() {
  return "CachedReference"
});
$c_Lamf_internal_reference_CachedReference.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_internal_reference_CachedReference.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_internal_reference_CachedReference)) {
    var CachedReference$1 = $as_Lamf_internal_reference_CachedReference(x$1);
    if ((this.url$1 === CachedReference$1.url$1)) {
      var x = this.content$1;
      var x$2 = CachedReference$1.content$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.resolved$1 === CachedReference$1.resolved$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_internal_reference_CachedReference.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.url$1;
      break
    }
    case 1: {
      return this.content$1;
      break
    }
    case 2: {
      return this.resolved$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_internal_reference_CachedReference.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_internal_reference_CachedReference.prototype.init___T__Lamf_core_model_document_BaseUnit__Z = (function(url, content, resolved) {
  this.url$1 = url;
  this.content$1 = content;
  this.resolved$1 = resolved;
  return this
});
$c_Lamf_internal_reference_CachedReference.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.url$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.content$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.resolved$1 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 3)
});
$c_Lamf_internal_reference_CachedReference.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_internal_reference_CachedReference(obj) {
  return (((obj instanceof $c_Lamf_internal_reference_CachedReference) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.internal.reference.CachedReference"))
}
function $isArrayOf_Lamf_internal_reference_CachedReference(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_internal_reference_CachedReference)))
}
function $asArrayOf_Lamf_internal_reference_CachedReference(obj, depth) {
  return (($isArrayOf_Lamf_internal_reference_CachedReference(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.internal.reference.CachedReference;", depth))
}
var $d_Lamf_internal_reference_CachedReference = new $TypeData().initClass({
  Lamf_internal_reference_CachedReference: 0
}, false, "amf.internal.reference.CachedReference", {
  Lamf_internal_reference_CachedReference: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_internal_reference_CachedReference.prototype.$classData = $d_Lamf_internal_reference_CachedReference;
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1$$anonfun$$lessinit$greater$1() {
  $c_sr_AbstractFunction1.call(this);
  this.$$outer$2 = null;
  this.amfObject$1$2 = null
}
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1$$anonfun$$lessinit$greater$1.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1$$anonfun$$lessinit$greater$1.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1$$anonfun$$lessinit$greater$1;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1$$anonfun$$lessinit$greater$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1$$anonfun$$lessinit$greater$1.prototype = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1$$anonfun$$lessinit$greater$1.prototype;
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1$$anonfun$$lessinit$greater$1.prototype.init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__Lamf_core_model_domain_AmfObject = (function($$outer, amfObject$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.amfObject$1$2 = amfObject$1;
  return this
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1$$anonfun$$lessinit$greater$1.prototype.apply__O__O = (function(v1) {
  this.apply__Lorg_yaml_builder_DocBuilder$Part__V($as_Lorg_yaml_builder_DocBuilder$Part(v1))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1$$anonfun$$lessinit$greater$1.prototype.apply__Lorg_yaml_builder_DocBuilder$Part__V = (function(x$6) {
  this.$$outer$2.root$1.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(b$2) {
      var b = $as_Lorg_yaml_builder_DocBuilder$Entry(b$2);
      $this.$$outer$2.emitObject__Lamf_core_model_domain_AmfObject__Lorg_yaml_builder_DocBuilder$Entry__V($this.amfObject$1$2, b)
    })
  })(this)))
});
var $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1$$anonfun$$lessinit$greater$1 = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1$$anonfun$$lessinit$greater$1: 0
}, false, "amf.plugins.document.graph.emitter.FlattenedJsonLdEmitter$$anon$1$$anonfun$$lessinit$greater$1", {
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1$$anonfun$$lessinit$greater$1: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1$$anonfun$$lessinit$greater$1.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$1$$anonfun$$lessinit$greater$1;
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2$$anonfun$$lessinit$greater$2() {
  $c_sr_AbstractFunction1.call(this);
  this.$$outer$2 = null;
  this.extension$1$2 = null;
  this.field$1$2 = null
}
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2$$anonfun$$lessinit$greater$2.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2$$anonfun$$lessinit$greater$2.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2$$anonfun$$lessinit$greater$2;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2$$anonfun$$lessinit$greater$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2$$anonfun$$lessinit$greater$2.prototype = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2$$anonfun$$lessinit$greater$2.prototype;
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2$$anonfun$$lessinit$greater$2.prototype.apply__O__O = (function(v1) {
  this.apply__Lorg_yaml_builder_DocBuilder$Part__V($as_Lorg_yaml_builder_DocBuilder$Part(v1))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2$$anonfun$$lessinit$greater$2.prototype.apply__Lorg_yaml_builder_DocBuilder$Part__V = (function(part) {
  part.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(rb$2) {
      var rb = $as_Lorg_yaml_builder_DocBuilder$Entry(rb$2);
      rb.entry__T__F1__V($this.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emitIri__T__T($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1.value$1.iri__T()), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
        return (function(x$15$2) {
          var x$15 = $as_Lorg_yaml_builder_DocBuilder$Part(x$15$2);
          var this$4 = $this$1.$$outer$2;
          var this$1 = $this$1.extension$1$2;
          var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1));
          var this$3 = this$2.option$1;
          var content = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
          var t = $m_Lorg_yaml_builder_DocBuilder$SType$Str$();
          this$4.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(x$15, content, t)
        })
      })($this)));
      var this$5 = $this.field$1$2;
      if ((!this$5.isEmpty__Z())) {
        var arg1 = this$5.get__O();
        var f = $as_Lamf_core_metamodel_Field(arg1);
        rb.entry__T__F1__V($this.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emitIri__T__T($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Element$1.value$1.iri__T()), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, f$1) {
          return (function(x$16$2) {
            var x$16 = $as_Lorg_yaml_builder_DocBuilder$Part(x$16$2);
            var this$6 = $this$2.$$outer$2;
            var content$1 = f$1.value$1.iri__T();
            var t$1 = $m_Lorg_yaml_builder_DocBuilder$SType$Str$();
            this$6.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(x$16, content$1, t$1)
          })
        })($this, f)))
      };
      var jsx$1 = $this.$$outer$2;
      var this$7 = $this.extension$1$2;
      jsx$1.emitObject__Lamf_core_model_domain_AmfObject__Lorg_yaml_builder_DocBuilder$Entry__V($as_Lamf_core_model_domain_DataNode(this$7.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)), rb)
    })
  })(this)))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2$$anonfun$$lessinit$greater$2.prototype.init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__Lamf_core_model_domain_extensions_DomainExtension__s_Option = (function($$outer, extension$1, field$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.extension$1$2 = extension$1;
  this.field$1$2 = field$1;
  return this
});
var $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2$$anonfun$$lessinit$greater$2 = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2$$anonfun$$lessinit$greater$2: 0
}, false, "amf.plugins.document.graph.emitter.FlattenedJsonLdEmitter$$anon$2$$anonfun$$lessinit$greater$2", {
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2$$anonfun$$lessinit$greater$2: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2$$anonfun$$lessinit$greater$2.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$2$$anonfun$$lessinit$greater$2;
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3$$anonfun$$lessinit$greater$3() {
  $c_sr_AbstractFunction1.call(this);
  this.$$outer$2 = null;
  this.id$7$2 = null;
  this.seq$1$2 = null;
  this.element$3$2 = null
}
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3$$anonfun$$lessinit$greater$3.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3$$anonfun$$lessinit$greater$3.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3$$anonfun$$lessinit$greater$3;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3$$anonfun$$lessinit$greater$3() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3$$anonfun$$lessinit$greater$3.prototype = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3$$anonfun$$lessinit$greater$3.prototype;
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3$$anonfun$$lessinit$greater$3.prototype.apply__O__O = (function(v1) {
  this.apply__Lorg_yaml_builder_DocBuilder$Part__V($as_Lorg_yaml_builder_DocBuilder$Part(v1))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3$$anonfun$$lessinit$greater$3.prototype.apply__Lorg_yaml_builder_DocBuilder$Part__V = (function(part) {
  part.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(rb$2) {
      var rb = $as_Lorg_yaml_builder_DocBuilder$Entry(rb$2);
      $this.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createIdNode__Lorg_yaml_builder_DocBuilder$Entry__T__V(rb, $this.id$7$2);
      var jsx$1 = $this.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f;
      var this$1 = $m_Lamf_core_vocabulary_Namespace$().Rdfs$1;
      rb.entry__T__T__V("@type", jsx$1.emitIri__T__T(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "Seq").iri__T()));
      var jsx$2 = $this.seq$1$2;
      var this$3 = $m_sc_Seq$();
      $as_sc_IterableLike(jsx$2.zipWithIndex__scg_CanBuildFrom__O(this$3.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, rb$1) {
        return (function(x0$1$2) {
          var x0$1 = $as_T2(x0$1$2);
          if ((x0$1 !== null)) {
            var e = $as_Lamf_core_model_domain_AmfElement(x0$1.$$und1__O());
            var i = x0$1.$$und2$mcI$sp__I();
            var jsx$3 = $this$1.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f;
            var this$4 = $m_Lamf_core_vocabulary_Namespace$().Rdfs$1;
            var id = ("_" + ((1 + i) | 0));
            rb$1.entry__T__F1__V(jsx$3.emitIri__T__T(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, id).iri__T()), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, e$1) {
              return (function(b$2) {
                var b = $as_Lorg_yaml_builder_DocBuilder$Part(b$2);
                var x1 = $this$2.element$3$2;
                if ($is_Lamf_core_metamodel_Obj(x1)) {
                  matchEnd5: {
                    if (($is_Lamf_core_model_domain_DomainElement(e$1) && $is_Lamf_core_model_domain_Linkable(e$1))) {
                      var x2 = $as_Lamf_core_model_domain_DomainElement(e$1);
                      var this$6 = $as_Lamf_core_model_domain_Linkable(x2);
                      if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$6).isDefined__Z()) {
                        $this$2.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$link__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_DomainElement__Z__V(b, x2, true);
                        break matchEnd5
                      }
                    };
                    if ($is_Lamf_core_model_domain_AmfObject(e$1)) {
                      var x3 = $as_Lamf_core_model_domain_AmfObject(e$1);
                      var this$7 = $this$2.$$outer$2;
                      this$7.emit$1__p1__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfObject__V(b, x3);
                      break matchEnd5
                    };
                    throw new $c_s_MatchError().init___O(e$1)
                  }
                } else {
                  var x$2 = $m_Lamf_core_metamodel_Type$Str$();
                  if (x$2.equals__O__Z(x1)) {
                    $this$2.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$scalar__Lorg_yaml_builder_DocBuilder$Part__Lamf_core_model_domain_AmfElement__Lorg_yaml_builder_DocBuilder$SType__V(b, e$1, $m_Lorg_yaml_builder_DocBuilder$SType$Str$())
                  } else {
                    var x$4 = $m_Lamf_core_metamodel_Type$EncodedIri$();
                    if (x$4.equals__O__Z(x1)) {
                      $this$2.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$safeIri__Lorg_yaml_builder_DocBuilder$Part__T__Z__V(b, $as_Lamf_core_model_domain_AmfScalar(e$1).toString__T(), true)
                    } else {
                      var x$6 = $m_Lamf_core_metamodel_Type$Iri$();
                      if (x$6.equals__O__Z(x1)) {
                        $this$2.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$iri__Lorg_yaml_builder_DocBuilder$Part__T__Z__V(b, $as_Lamf_core_model_domain_AmfScalar(e$1).toString__T(), true)
                      } else {
                        var x$8 = $m_Lamf_core_metamodel_Type$Any$();
                        if ((x$8 === x1)) {
                          var scalarElement = $as_Lamf_core_model_domain_AmfScalar(e$1);
                          var x1$3 = scalarElement.value$1;
                          if (((typeof x1$3) === "boolean")) {
                            var x2$2 = $uZ(x1$3);
                            $this$2.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, ("" + x2$2), $m_Lamf_core_model_DataType$().Boolean$1, true)
                          } else if ($is_T(x1$3)) {
                            var x3$2 = $as_T(x1$3);
                            $this$2.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, x3$2, $m_Lamf_core_model_DataType$().String$1, true)
                          } else if ($isInt(x1$3)) {
                            var x4 = $uI(x1$3);
                            $this$2.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, ("" + x4), $m_Lamf_core_model_DataType$().Integer$1, true)
                          } else if ($isFloat(x1$3)) {
                            var x5 = $uF(x1$3);
                            $this$2.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, ("" + x5), $m_Lamf_core_model_DataType$().Float$1, true)
                          } else if (((typeof x1$3) === "number")) {
                            var x6 = $uD(x1$3);
                            $this$2.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$typedScalar__Lorg_yaml_builder_DocBuilder$Part__T__T__Z__V(b, ("" + x6), $m_Lamf_core_model_DataType$().Double$1, true)
                          } else {
                            var this$12 = $this$2.$$outer$2;
                            var content = $objectToString(x1$3);
                            this$12.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(b, content, $m_Lorg_yaml_builder_DocBuilder$SType$Str$())
                          }
                        } else {
                          throw new $c_s_MatchError().init___O(x1)
                        }
                      }
                    }
                  }
                }
              })
            })($this$1, e)))
          } else {
            throw new $c_s_MatchError().init___O(x0$1)
          }
        })
      })($this, rb)))
    })
  })(this)))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3$$anonfun$$lessinit$greater$3.prototype.init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__T__sc_Seq__Lamf_core_metamodel_Type = (function($$outer, id$7, seq$1, element$3) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.id$7$2 = id$7;
  this.seq$1$2 = seq$1;
  this.element$3$2 = element$3;
  return this
});
var $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3$$anonfun$$lessinit$greater$3 = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3$$anonfun$$lessinit$greater$3: 0
}, false, "amf.plugins.document.graph.emitter.FlattenedJsonLdEmitter$$anon$3$$anonfun$$lessinit$greater$3", {
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3$$anonfun$$lessinit$greater$3: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3$$anonfun$$lessinit$greater$3.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$3$$anonfun$$lessinit$greater$3;
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4$$anonfun$$lessinit$greater$4() {
  $c_sr_AbstractFunction1.call(this);
  this.$$outer$2 = null;
  this.id$9$2 = null;
  this.sources$6$2 = null
}
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4$$anonfun$$lessinit$greater$4.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4$$anonfun$$lessinit$greater$4.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4$$anonfun$$lessinit$greater$4;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4$$anonfun$$lessinit$greater$4() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4$$anonfun$$lessinit$greater$4.prototype = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4$$anonfun$$lessinit$greater$4.prototype;
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4$$anonfun$$lessinit$greater$4.prototype.apply__O__O = (function(v1) {
  this.apply__Lorg_yaml_builder_DocBuilder$Part__V($as_Lorg_yaml_builder_DocBuilder$Part(v1))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4$$anonfun$$lessinit$greater$4.prototype.apply__Lorg_yaml_builder_DocBuilder$Part__V = (function(part) {
  part.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(rb$2) {
      var rb = $as_Lorg_yaml_builder_DocBuilder$Entry(rb$2);
      $this.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createIdNode__Lorg_yaml_builder_DocBuilder$Entry__T__V(rb, $this.id$9$2);
      var this$1 = $this.$$outer$2;
      var obj = $m_Lamf_core_metamodel_document_SourceMapModel$();
      var ctx = $this.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f;
      $f_Lamf_plugins_document_graph_emitter_CommonEmitter__createTypeNode__Lorg_yaml_builder_DocBuilder$Entry__Lamf_core_metamodel_Obj__Lamf_plugins_document_graph_emitter_EmissionContext__V(this$1, rb, obj, ctx);
      $this.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createAnnotationNodes__T__Lorg_yaml_builder_DocBuilder$Entry__scm_ListMap__V($this.id$9$2, rb, $this.sources$6$2.annotations$1);
      $this.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createAnnotationNodes__T__Lorg_yaml_builder_DocBuilder$Entry__scm_ListMap__V($this.id$9$2, rb, $this.sources$6$2.eternals$1)
    })
  })(this)))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4$$anonfun$$lessinit$greater$4.prototype.init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__T__Lamf_core_model_document_SourceMap = (function($$outer, id$9, sources$6) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.id$9$2 = id$9;
  this.sources$6$2 = sources$6;
  return this
});
var $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4$$anonfun$$lessinit$greater$4 = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4$$anonfun$$lessinit$greater$4: 0
}, false, "amf.plugins.document.graph.emitter.FlattenedJsonLdEmitter$$anon$4$$anonfun$$lessinit$greater$4", {
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4$$anonfun$$lessinit$greater$4: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4$$anonfun$$lessinit$greater$4.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$4$$anonfun$$lessinit$greater$4;
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5$$anonfun$$lessinit$greater$5() {
  $c_sr_AbstractFunction1.call(this);
  this.$$outer$2 = null;
  this.id$10$2 = null;
  this.sources$7$2 = null
}
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5$$anonfun$$lessinit$greater$5.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5$$anonfun$$lessinit$greater$5.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5$$anonfun$$lessinit$greater$5;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5$$anonfun$$lessinit$greater$5() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5$$anonfun$$lessinit$greater$5.prototype = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5$$anonfun$$lessinit$greater$5.prototype;
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5$$anonfun$$lessinit$greater$5.prototype.apply__O__O = (function(v1) {
  this.apply__Lorg_yaml_builder_DocBuilder$Part__V($as_Lorg_yaml_builder_DocBuilder$Part(v1))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5$$anonfun$$lessinit$greater$5.prototype.apply__Lorg_yaml_builder_DocBuilder$Part__V = (function(part) {
  part.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(rb$2) {
      var rb = $as_Lorg_yaml_builder_DocBuilder$Entry(rb$2);
      $this.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createIdNode__Lorg_yaml_builder_DocBuilder$Entry__T__V(rb, $this.id$10$2);
      var this$1 = $this.$$outer$2;
      var obj = $m_Lamf_core_metamodel_document_SourceMapModel$();
      var ctx = $this.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f;
      $f_Lamf_plugins_document_graph_emitter_CommonEmitter__createTypeNode__Lorg_yaml_builder_DocBuilder$Entry__Lamf_core_metamodel_Obj__Lamf_plugins_document_graph_emitter_EmissionContext__V(this$1, rb, obj, ctx);
      $this.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createAnnotationNodes__T__Lorg_yaml_builder_DocBuilder$Entry__scm_ListMap__V($this.id$10$2, rb, $this.sources$7$2.eternals$1)
    })
  })(this)))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5$$anonfun$$lessinit$greater$5.prototype.init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__T__Lamf_core_model_document_SourceMap = (function($$outer, id$10, sources$7) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.id$10$2 = id$10;
  this.sources$7$2 = sources$7;
  return this
});
var $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5$$anonfun$$lessinit$greater$5 = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5$$anonfun$$lessinit$greater$5: 0
}, false, "amf.plugins.document.graph.emitter.FlattenedJsonLdEmitter$$anon$5$$anonfun$$lessinit$greater$5", {
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5$$anonfun$$lessinit$greater$5: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5$$anonfun$$lessinit$greater$5.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$5$$anonfun$$lessinit$greater$5;
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6$$anonfun$$lessinit$greater$6() {
  $c_sr_AbstractFunction1.call(this);
  this.$$outer$2 = null;
  this.id$12$2 = null;
  this.iri$1$2 = null;
  this.v$6$2 = null
}
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6$$anonfun$$lessinit$greater$6.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6$$anonfun$$lessinit$greater$6.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6$$anonfun$$lessinit$greater$6;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6$$anonfun$$lessinit$greater$6() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6$$anonfun$$lessinit$greater$6.prototype = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6$$anonfun$$lessinit$greater$6.prototype;
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6$$anonfun$$lessinit$greater$6.prototype.apply__O__O = (function(v1) {
  this.apply__Lorg_yaml_builder_DocBuilder$Part__V($as_Lorg_yaml_builder_DocBuilder$Part(v1))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6$$anonfun$$lessinit$greater$6.prototype.apply__Lorg_yaml_builder_DocBuilder$Part__V = (function(part) {
  part.obj__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(b$2) {
      var b = $as_Lorg_yaml_builder_DocBuilder$Entry(b$2);
      $this.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$createIdNode__Lorg_yaml_builder_DocBuilder$Entry__T__V(b, $this.id$12$2);
      b.entry__T__F1__V($this.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emitIri__T__T($m_Lamf_core_metamodel_document_SourceMapModel$().Element$1.value$1.iri__T()), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
        return (function(x$34$2) {
          var x$34 = $as_Lorg_yaml_builder_DocBuilder$Part(x$34$2);
          var this$1 = $this$1.$$outer$2;
          var content = $this$1.iri$1$2;
          var t = $m_Lorg_yaml_builder_DocBuilder$SType$Str$();
          this$1.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(x$34, content, t)
        })
      })($this)));
      b.entry__T__F1__V($this.$$outer$2.amf$plugins$document$graph$emitter$FlattenedJsonLdEmitter$$ctx$f.emitIri__T__T($m_Lamf_core_metamodel_document_SourceMapModel$().Value$1.value$1.iri__T()), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
        return (function(x$35$2) {
          var x$35 = $as_Lorg_yaml_builder_DocBuilder$Part(x$35$2);
          var this$3 = this$2.$$outer$2;
          var content$1 = this$2.v$6$2;
          var t$1 = $m_Lorg_yaml_builder_DocBuilder$SType$Str$();
          this$3.scalar__p1__Lorg_yaml_builder_DocBuilder$Part__T__Lorg_yaml_builder_DocBuilder$SType__V(x$35, content$1, t$1)
        })
      })($this)))
    })
  })(this)))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6$$anonfun$$lessinit$greater$6.prototype.init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter__T__T__T = (function($$outer, id$12, iri$1, v$6) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.id$12$2 = id$12;
  this.iri$1$2 = iri$1;
  this.v$6$2 = v$6;
  return this
});
var $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6$$anonfun$$lessinit$greater$6 = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6$$anonfun$$lessinit$greater$6: 0
}, false, "amf.plugins.document.graph.emitter.FlattenedJsonLdEmitter$$anon$6$$anonfun$$lessinit$greater$6", {
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6$$anonfun$$lessinit$greater$6: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6$$anonfun$$lessinit$greater$6.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anon$6$$anonfun$$lessinit$greater$6;
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue() {
  $c_O.call(this);
  this.queue$1 = null;
  this.knownIds$1 = null;
  this.pendingExternalLinks$1 = null
}
$c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue.prototype = new $h_O();
$c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue.prototype = $c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue.prototype;
$c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue.prototype.init___ = (function() {
  this.queue$1 = new $c_Lorg_mulesoft_lexer_Queue().init___();
  this.knownIds$1 = $as_scm_HashSet($m_scm_HashSet$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  this.pendingExternalLinks$1 = $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  return this
});
$c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue.prototype.productPrefix__T = (function() {
  return "EmissionQueue"
});
$c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue.prototype.tryEnqueue__Lamf_plugins_document_graph_emitter_flattened_utils_Emission__s_util_Try = (function(e) {
  if ($as_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata(e).isExternal__Z()) {
    var this$1 = $as_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata(e).id__s_Option();
    if ((!this$1.isEmpty__Z())) {
      var arg1 = this$1.get__O();
      var id = $as_T(arg1);
      var this$2 = this.knownIds$1;
      new $c_s_Some().init___O(((!$f_scm_FlatHashTable__containsElem__O__Z(this$2, id)) ? this.pendingExternalLinks$1.put__O__O__s_Option(id, e) : (void 0)))
    };
    return new $c_s_util_Success().init___O((void 0))
  } else if (this.accepts__Lamf_plugins_document_graph_emitter_flattened_utils_Emission__Z(e)) {
    this.queue$1.$$plus$eq__O__Lorg_mulesoft_lexer_Queue(e);
    var this$3 = $as_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata(e).id__s_Option();
    if ((!this$3.isEmpty__Z())) {
      var arg1$1 = this$3.get__O();
      var id$3 = $as_T(arg1$1);
      this.knownIds$1.$$plus$eq__O__scm_HashSet(id$3);
      new $c_s_Some().init___O(this.pendingExternalLinks$1.remove__O__s_Option(id$3))
    };
    return new $c_s_util_Success().init___O((void 0))
  } else {
    return new $c_s_util_Failure().init___jl_Throwable(new $c_jl_IllegalArgumentException().init___T("Element already emitted"))
  }
});
$c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue) && ($as_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue(x$1), true))
});
$c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue.prototype.nextExternalEmission__Lamf_plugins_document_graph_emitter_flattened_utils_Emission = (function() {
  var this$1 = this.pendingExternalLinks$1;
  var x1 = $as_T2(this$1.iterator__sc_Iterator().next__O());
  if ((x1 === null)) {
    throw new $c_s_MatchError().init___O(x1)
  };
  var id = $as_T(x1.$$und1__O());
  var next = $as_Lamf_plugins_document_graph_emitter_flattened_utils_Emission(x1.$$und2__O());
  this.pendingExternalLinks$1.remove__O__s_Option(id);
  return next
});
$c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue.prototype.hasPendingEmissions__Z = (function() {
  return (!this.queue$1.isEmpty__Z())
});
$c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue.prototype.accepts__Lamf_plugins_document_graph_emitter_flattened_utils_Emission__Z = (function(e) {
  var this$1 = $as_Lamf_plugins_document_graph_emitter_flattened_utils_Metadata(e).id__s_Option();
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var id = $as_T(arg1);
    var this$2 = this.knownIds$1;
    var jsx$1 = $f_scm_FlatHashTable__containsElem__O__Z(this$2, id)
  } else {
    var jsx$1 = false
  };
  return (!jsx$1)
});
$c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue.prototype.nextEmission__Lamf_plugins_document_graph_emitter_flattened_utils_Emission = (function() {
  var next = $as_Lamf_plugins_document_graph_emitter_flattened_utils_Emission(this.queue$1.dequeue__O());
  return next
});
function $as_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.graph.emitter.flattened.utils.EmissionQueue"))
}
function $isArrayOf_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue)))
}
function $asArrayOf_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.graph.emitter.flattened.utils.EmissionQueue;", depth))
}
var $d_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue: 0
}, false, "amf.plugins.document.graph.emitter.flattened.utils.EmissionQueue", {
  Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_flattened_utils_EmissionQueue;
/** @constructor */
function $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser() {
  $c_O.call(this);
  this.nodes$1 = null;
  this.unresolvedReferences$1 = null;
  this.unresolvedExtReferencesMap$1 = null;
  this.referencesMap$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype = new $h_O();
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype.constructor = $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser;
/** @constructor */
function $h_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype = $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype;
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype.parse__Lorg_yaml_model_YDocument__T__Lamf_core_model_document_BaseUnit = (function(document, location) {
  var node = document.node$2;
  var jsx$1 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node);
  var reader = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var this$3 = $m_sc_IndexedSeq$();
  var bf = this$3.ReusableCBF$6;
  var maybeMaps = jsx$1.toOption__Lorg_yaml_convert_YRead__s_Option(new $c_Lorg_yaml_convert_YRead$$anon$1().init___scg_CanBuildFrom__Lorg_yaml_convert_YRead(bf, reader));
  if (maybeMaps.isEmpty__Z()) {
    var maybeMap = $m_s_None$()
  } else {
    var arg1 = maybeMaps.get__O();
    var s = $as_sc_Seq(arg1);
    var maybeMap = s.headOption__s_Option()
  };
  if (maybeMap.isEmpty__Z()) {
    var maybeMaybeObject = $m_s_None$()
  } else {
    var arg1$1 = maybeMap.get__O();
    var map = $as_Lorg_yaml_model_YMap(arg1$1);
    var this$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("@context");
    if ((!this$5.isEmpty__Z())) {
      var arg1$2 = this$5.get__O();
      var e = $as_Lorg_yaml_model_YMapEntry(arg1$2);
      this.$$outer$1.parseCompactUris__Lorg_yaml_model_YNode__Lamf_plugins_document_graph_parser_GraphParserContext__V(e.value$2, this.$$outer$1.ctx$2)
    };
    var maybeMaybeObject = this.parse__p1__Lorg_yaml_model_YMap__s_Option(map)
  };
  if ((maybeMaybeObject instanceof $c_s_Some)) {
    var x2 = $as_s_Some(maybeMaybeObject);
    var unit = $as_Lamf_core_model_domain_AmfObject(x2.value$2);
    if ($is_Lamf_core_model_document_BaseUnit(unit)) {
      var x3 = $as_Lamf_core_model_document_BaseUnit(unit);
      var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
      return $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x3, field, location))
    }
  };
  var this$6 = this.$$outer$1.ctx$2.eh$1;
  var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnableToParseDocument$1;
  var message = ("Unable to parse " + document);
  var prop = $m_s_None$();
  var l = document.location$1;
  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$6, specification, location, prop, message, l);
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_core_model_document_Document().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype.productPrefix__T = (function() {
  return "Parser"
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype.applyScalarDomainProperties__p1__Lamf_core_model_domain_DomainElement__sc_Seq__V = (function(instance, scalars) {
  scalars.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, instance$1) {
    return (function(e$2) {
      var e = $as_Lamf_core_model_domain_extensions_DomainExtension(e$2);
      var this$1 = instance$1.fields__Lamf_core_parser_Fields().fieldsMeta__sci_List();
      inlinereturn$2: {
        var these = this$1;
        while ((!these.isEmpty__Z())) {
          var arg1 = these.head__O();
          var f = $as_Lamf_core_metamodel_Field(arg1);
          var this$2 = $as_Lamf_core_model_StrField(e.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Element$1));
          var other = f.value$1.iri__T();
          if ($f_Lamf_core_model_ValueField__is__O__Z(this$2, other)) {
            var this$3 = new $c_s_Some().init___O(these.head__O());
            break inlinereturn$2
          };
          these = $as_sc_LinearSeqOptimized(these.tail__O())
        };
        var this$3 = $m_s_None$()
      };
      if ((!this$3.isEmpty__Z())) {
        var arg1$1 = this$3.get__O();
        var f$3 = $as_Lamf_core_metamodel_Field(arg1$1);
        var this$4 = instance$1.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option(f$3);
        if ((!this$4.isEmpty__Z())) {
          var arg1$2 = this$4.get__O();
          var x0$1 = $as_Lamf_core_parser_FieldEntry(arg1$2);
          if ((x0$1 !== null)) {
            var value = x0$1.value$1;
            value.value$1.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_DomainExtensionAnnotation().init___Lamf_core_model_domain_extensions_DomainExtension(e))
          } else {
            throw new $c_s_MatchError().init___O(x0$1)
          }
        }
      }
    })
  })(this, instance)))
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype.traverse__p1__Lamf_core_model_domain_AmfObject__Lamf_core_metamodel_Field__Lorg_yaml_model_YNode__Lamf_core_model_document_SourceMap__T__Lamf_core_model_domain_AmfObject = (function(instance, f, node, sources, key) {
  var x1 = f.type$1;
  if ($is_Lamf_core_metamodel_Obj(x1)) {
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.$$outer$1.ctx$2;
    var this$1 = this.parse__p1__Lorg_yaml_model_YMap__s_Option($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)));
    if ((!this$1.isEmpty__Z())) {
      var arg1 = this$1.get__O();
      var n = $as_Lamf_core_model_domain_AmfObject(arg1);
      var this$2 = this.$$outer$1;
      var nodes = this.nodes$1;
      var annotations = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this$2, nodes, sources, key);
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, n, annotations)
    };
    return instance
  } else {
    var x = $m_Lamf_core_metamodel_Type$Str$();
    if (x.equals__O__Z(x1)) {
      var jsx$1 = true
    } else {
      var x$3 = $m_Lamf_core_metamodel_Type$RegExp$();
      if (x$3.equals__O__Z(x1)) {
        var jsx$1 = true
      } else {
        var x$5 = $m_Lamf_core_metamodel_Type$Iri$();
        if (x$5.equals__O__Z(x1)) {
          var jsx$1 = true
        } else {
          var x$7 = $m_Lamf_core_metamodel_Type$LiteralUri$();
          var jsx$1 = x$7.equals__O__Z(x1)
        }
      }
    };
    if (jsx$1) {
      var value = this.$$outer$1.amf$plugins$document$graph$parser$ExpandedGraphParser$$str__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(node);
      var this$3 = this.$$outer$1;
      var nodes$1 = this.nodes$1;
      var annotations$1 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this$3, nodes$1, sources, key);
      return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, value, annotations$1)
    } else {
      var x$9 = $m_Lamf_core_metamodel_Type$Bool$();
      if (x$9.equals__O__Z(x1)) {
        var value$1 = this.$$outer$1.amf$plugins$document$graph$parser$ExpandedGraphParser$$bool__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(node);
        var this$4 = this.$$outer$1;
        var nodes$2 = this.nodes$1;
        var annotations$2 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this$4, nodes$2, sources, key);
        return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, value$1, annotations$2)
      } else {
        var x$11 = $m_Lamf_core_metamodel_Type$Int$();
        if (x$11.equals__O__Z(x1)) {
          var value$2 = this.$$outer$1.amf$plugins$document$graph$parser$ExpandedGraphParser$$int__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(node);
          var this$5 = this.$$outer$1;
          var nodes$3 = this.nodes$1;
          var annotations$3 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this$5, nodes$3, sources, key);
          return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, value$2, annotations$3)
        } else {
          var x$13 = $m_Lamf_core_metamodel_Type$Float$();
          if (x$13.equals__O__Z(x1)) {
            var value$3 = this.$$outer$1.amf$plugins$document$graph$parser$ExpandedGraphParser$$float__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(node);
            var this$6 = this.$$outer$1;
            var nodes$4 = this.nodes$1;
            var annotations$4 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this$6, nodes$4, sources, key);
            return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, value$3, annotations$4)
          } else {
            var x$15 = $m_Lamf_core_metamodel_Type$Double$();
            if (x$15.equals__O__Z(x1)) {
              var value$4 = this.$$outer$1.amf$plugins$document$graph$parser$ExpandedGraphParser$$double__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(node);
              var this$7 = this.$$outer$1;
              var nodes$5 = this.nodes$1;
              var annotations$5 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this$7, nodes$5, sources, key);
              return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, value$4, annotations$5)
            } else {
              var x$17 = $m_Lamf_core_metamodel_Type$DateTime$();
              if (x$17.equals__O__Z(x1)) {
                var value$5 = this.$$outer$1.amf$plugins$document$graph$parser$ExpandedGraphParser$$date__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(node);
                var this$8 = this.$$outer$1;
                var nodes$6 = this.nodes$1;
                var annotations$6 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this$8, nodes$6, sources, key);
                return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, value$5, annotations$6)
              } else {
                var x$19 = $m_Lamf_core_metamodel_Type$Date$();
                if (x$19.equals__O__Z(x1)) {
                  var value$6 = this.$$outer$1.amf$plugins$document$graph$parser$ExpandedGraphParser$$date__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(node);
                  var this$9 = this.$$outer$1;
                  var nodes$7 = this.nodes$1;
                  var annotations$7 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this$9, nodes$7, sources, key);
                  return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, value$6, annotations$7)
                } else {
                  var x$21 = $m_Lamf_core_metamodel_Type$Any$();
                  if ((x$21 === x1)) {
                    var value$7 = this.$$outer$1.amf$plugins$document$graph$parser$ExpandedGraphParser$$any__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(node);
                    var this$10 = this.$$outer$1;
                    var nodes$8 = this.nodes$1;
                    var annotations$8 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this$10, nodes$8, sources, key);
                    return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, value$7, annotations$8)
                  } else if ((x1 instanceof $c_Lamf_core_metamodel_Type$SortedArray)) {
                    var x14 = $as_Lamf_core_metamodel_Type$SortedArray(x1);
                    var jsx$3 = instance.id__T();
                    var jsx$2 = x14.element$1;
                    var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
                    var iv$1 = this.$$outer$1.ctx$2;
                    var values = this.parseList__p1__T__Lamf_core_metamodel_Type__Lorg_yaml_model_YMap__sc_Seq(jsx$3, jsx$2, $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$1, iv$1)));
                    var this$11 = this.$$outer$1;
                    var nodes$9 = this.nodes$1;
                    var annotations$9 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this$11, nodes$9, sources, key);
                    return $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, values, annotations$9)
                  } else if ((x1 instanceof $c_Lamf_core_metamodel_Type$Array)) {
                    var x15 = $as_Lamf_core_metamodel_Type$Array(x1);
                    var conversion$2 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
                    var iv$2 = this.$$outer$1.ctx$2;
                    var items = $as_sc_Seq($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$2, iv$2));
                    var x1$2 = x15.element$1;
                    if ($is_Lamf_core_metamodel_Obj(x1$2)) {
                      var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
                        return (function(n$3$2) {
                          var n$3 = $as_Lorg_yaml_model_YNode(n$3$2);
                          var conversion$3 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
                          var iv$3 = this$2$1.$$outer$1.ctx$2;
                          var xo = this$2$1.parse__p1__Lorg_yaml_model_YMap__s_Option($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(n$3, conversion$3, iv$3)));
                          return xo.toList__sci_List()
                        })
                      })(this));
                      var this$13 = $m_sc_Seq$();
                      var values$1 = $as_sc_Seq(items.flatMap__F1__scg_CanBuildFrom__O(jsx$4, this$13.ReusableCBFInstance$2))
                    } else {
                      var x$23 = $m_Lamf_core_metamodel_Type$Str$();
                      if (x$23.equals__O__Z(x1$2)) {
                        var jsx$5 = true
                      } else {
                        var x$25 = $m_Lamf_core_metamodel_Type$Iri$();
                        var jsx$5 = x$25.equals__O__Z(x1$2)
                      };
                      if ((!jsx$5)) {
                        throw new $c_s_MatchError().init___O(x1$2)
                      };
                      var jsx$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, x15$1) {
                        return (function(n$4$2) {
                          var n$4 = $as_Lorg_yaml_model_YNode(n$4$2);
                          var jsx$7 = this$3$1.$$outer$1;
                          var this$14 = this$3$1.$$outer$1;
                          var t = x15$1.element$1;
                          return jsx$7.amf$plugins$document$graph$parser$ExpandedGraphParser$$str__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar($f_Lamf_plugins_document_graph_parser_GraphParserHelpers__value__Lamf_core_metamodel_Type__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode(this$14, t, n$4))
                        })
                      })(this, x15));
                      var this$15 = $m_sc_Seq$();
                      var values$1 = $as_sc_Seq(items.map__F1__scg_CanBuildFrom__O(jsx$6, this$15.ReusableCBFInstance$2))
                    };
                    var x1$3 = x15.element$1;
                    if ($is_Lamf_core_metamodel_domain_DomainElementModel(x1$3)) {
                      var x$28 = $m_Lamf_core_metamodel_document_DocumentModel$().Declares$1;
                      var jsx$8 = ((f === null) ? (x$28 === null) : f.equals__O__Z(x$28))
                    } else {
                      var jsx$8 = false
                    };
                    if (jsx$8) {
                      var this$16 = this.$$outer$1;
                      var nodes$10 = this.nodes$1;
                      var annotations$10 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this$16, nodes$10, sources, key);
                      return $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, values$1, annotations$10)
                    } else if ($is_Lamf_core_metamodel_document_BaseUnitModel(x1$3)) {
                      var this$17 = this.$$outer$1;
                      var nodes$11 = this.nodes$1;
                      var annotations$11 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this$17, nodes$11, sources, key);
                      return $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, values$1, annotations$11)
                    } else {
                      var this$18 = this.$$outer$1;
                      var nodes$12 = this.nodes$1;
                      var annotations$12 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this$18, nodes$12, sources, key);
                      return $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, values$1, annotations$12)
                    }
                  } else {
                    throw new $c_s_MatchError().init___O(x1)
                  }
                }
              }
            }
          }
        }
      }
    }
  }
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser) && ($as_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser(x$1).$$outer$1 === this.$$outer$1))) {
    var Parser$1 = $as_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser(x$1);
    var x = this.nodes$1;
    var x$2 = Parser$1.nodes$1;
    return ((x === null) ? (x$2 === null) : $f_sc_GenMapLike__equals__O__Z(x, x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.nodes$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype.parseObjectNodeProperties__p1__Lamf_core_model_domain_ObjectNode__Lorg_yaml_model_YMap__sci_List__V = (function(obj, map, fields) {
  map.entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, fields$1, obj$1) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var jsx$1 = $this.$$outer$1;
      var this$1 = entry.key$2;
      var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
      var iv = $this.$$outer$1.ctx$2;
      var uri = jsx$1.expandUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T($as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)), $this.$$outer$1.ctx$2);
      var v = entry.value$2;
      if (((((uri !== "@type") && (uri !== "@id")) && (uri !== $m_Lamf_core_metamodel_domain_DomainElementModel$().Sources$1.value$1.iri__T())) && (uri !== "smaps"))) {
        var this$2 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
        var jsx$3 = (uri !== new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$2, "extensionName").iri__T())
      } else {
        var jsx$3 = false
      };
      if (jsx$3) {
        inlinereturn$5: {
          var these = fields$1;
          while ((!these.isEmpty__Z())) {
            var arg1 = these.head__O();
            var x$9 = $as_Lamf_core_metamodel_Field(arg1);
            if ((x$9.value$1.iri__T() === uri)) {
              var jsx$4 = true;
              break inlinereturn$5
            };
            these = $as_sc_LinearSeqOptimized(these.tail__O())
          };
          var jsx$4 = false
        };
        var jsx$2 = (!jsx$4)
      } else {
        var jsx$2 = false
      };
      if (jsx$2) {
        var reader = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var this$5 = $m_sc_IndexedSeq$();
        var bf = this$5.ReusableCBF$6;
        var conversion$1 = new $c_Lorg_yaml_convert_YRead$$anon$1().init___scg_CanBuildFrom__Lorg_yaml_convert_YRead(bf, reader);
        var iv$1 = $this.$$outer$1.ctx$2;
        var this$6 = $as_sc_TraversableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(v, conversion$1, iv$1)).headOption__s_Option();
        if (this$6.isEmpty__Z()) {
          var this$7 = $m_s_None$()
        } else {
          var arg1$1 = this$6.get__O();
          var map$1 = $as_Lorg_yaml_model_YMap(arg1$1);
          var this$7 = $this.parse__p1__Lorg_yaml_model_YMap__s_Option(map$1)
        };
        var pf = new $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1().init___Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser__Lamf_core_model_domain_ObjectNode__T($this, obj$1, uri);
        if ((!this$7.isEmpty__Z())) {
          var this$8 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
          var v1 = this$7.get__O();
          return this$8.apply__O__s_Option(v1)
        } else {
          return $m_s_None$()
        }
      } else {
        return (void 0)
      }
    })
  })(this, fields, obj)))
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype.init___Lamf_plugins_document_graph_parser_ExpandedGraphParser__sci_Map = (function($$outer, nodes) {
  this.nodes$1 = nodes;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.unresolvedReferences$1 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.unresolvedExtReferencesMap$1 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.referencesMap$1 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  return this
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype.retrieveType__p1__T__Lorg_yaml_model_YMap__s_Option = (function(id, map) {
  var this$1 = this.$$outer$1;
  var ctx = this.$$outer$1.ctx$2;
  var stringTypes = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__ts__Lorg_yaml_model_YMap__T__Lamf_plugins_document_graph_parser_GraphParserContext__sc_Seq(this$1, map, id, ctx);
  var x1 = stringTypes.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_T(x$1$2);
      return $this.$$outer$1.amf$plugins$document$graph$parser$ExpandedGraphParser$$findType__T__s_Option(x$1).isDefined__Z()
    })
  })(this)));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var t = $as_T(x2.value$2);
    return this.$$outer$1.amf$plugins$document$graph$parser$ExpandedGraphParser$$findType__T__s_Option(t)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$2 = this.$$outer$1.ctx$2.eh$1;
      var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnableToParseNode$1;
      var message = ("Error parsing JSON-LD node, unknown @types " + stringTypes);
      var prop = $m_s_None$();
      var l = map.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$2, specification, id, prop, message, l);
      return $m_s_None$()
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype.checkLinkables__p1__Lamf_core_model_domain_AmfObject__V = (function(instance) {
  if (($is_Lamf_core_model_domain_DomainElement(instance) && $is_Lamf_core_model_domain_Linkable(instance))) {
    var x2 = $as_Lamf_core_model_domain_DomainElement(instance);
    var jsx$1 = this.referencesMap$1;
    var self = x2.id__T();
    jsx$1.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(self, x2));
    var this$3 = this.unresolvedReferences$1;
    var key = x2.id__T();
    var x1 = this$3.get__O__s_Option(key);
    if ((x1 instanceof $c_s_Some)) {
      var x2$1 = $as_s_Some(x1);
      var v = x2$1.value$2;
      var jsx$2 = v
    } else {
      var x = $m_s_None$();
      if ((!(x === x1))) {
        throw new $c_s_MatchError().init___O(x1)
      };
      var jsx$2 = $m_sci_Nil$()
    };
    $as_sc_IterableLike(jsx$2).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, x2$2, instance$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_model_domain_DomainElement(x0$1$2);
        if ($is_Lamf_core_model_domain_Linkable(x0$1)) {
          var this$4 = $as_Lamf_core_model_domain_Linkable(x0$1);
          return $f_Lamf_core_model_domain_Linkable__withLinkTarget__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(this$4, x2$2)
        } else if ((x0$1 instanceof $c_Lamf_core_model_domain_LinkNode)) {
          var x3 = $as_Lamf_core_model_domain_LinkNode(x0$1);
          return x3.withLinkedDomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_LinkNode(x2$2)
        } else {
          var this$5 = this$2$1.$$outer$1.ctx$2.eh$1;
          var specification = $m_Lamf_plugins_features_validation_CoreValidations$().NotLinkable$1;
          var node = instance$1.id__T();
          var annotations = instance$1.annotations__Lamf_core_parser_Annotations();
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$5, specification, node, "Only linkable elements can be linked", annotations);
          return (void 0)
        }
      })
    })(this, x2, instance)));
    this.unresolvedReferences$1.update__O__O__V(x2.id__T(), $m_sci_Nil$())
  } else if ($is_Lamf_core_model_domain_ExternalSourceElement(instance)) {
    var x3$1 = $as_Lamf_core_model_domain_ExternalSourceElement(instance);
    var jsx$3 = this.unresolvedExtReferencesMap$1;
    var this$6 = $as_Lamf_core_model_StrField(x3$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().ReferenceId$1));
    var this$7 = this$6.option$1;
    var self$1 = $as_T((this$7.isEmpty__Z() ? null : this$7.get__O()));
    jsx$3.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(self$1, x3$1))
  }
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype.setLinkTarget__p1__Lamf_core_model_domain_DomainElement__T__O = (function(instance, targetId) {
  var x1 = this.referencesMap$1.get__O__s_Option(targetId);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var target = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    var this$1 = $as_Lamf_core_model_domain_Linkable(instance);
    return $f_Lamf_core_model_domain_Linkable__withLinkTarget__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(this$1, target)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$2 = this.unresolvedReferences$1;
      var x1$1 = this$2.get__O__s_Option(targetId);
      if ((x1$1 instanceof $c_s_Some)) {
        var x2$1 = $as_s_Some(x1$1);
        var v = x2$1.value$2;
        var jsx$1 = v
      } else {
        var x$1 = $m_s_None$();
        if ((!(x$1 === x1$1))) {
          throw new $c_s_MatchError().init___O(x1$1)
        };
        var jsx$1 = $m_sci_Nil$()
      };
      var unresolved = $as_sc_Seq(jsx$1);
      var jsx$4 = this.unresolvedReferences$1;
      var jsx$3 = $m_sc_Seq$();
      var array = [instance];
      var jsx$2 = jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
      var this$6 = $m_sc_Seq$();
      var y = unresolved.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$6.ReusableCBFInstance$2);
      return jsx$4.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(targetId, y))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype.parseCustomProperties__p1__Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__V = (function(map, instance) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(this.$$outer$1.compactUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T($m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field().value$1.iri__T(), this.$$outer$1.ctx$2));
  if (this$2.isEmpty__Z()) {
    var this$7 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var x$6 = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$3 = x$6.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var iv = this.$$outer$1.ctx$2;
    var jsx$2 = $as_sc_TraversableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$7$2) {
        var x$7 = $as_Lorg_yaml_model_YNode(x$7$2);
        var this$4 = $this.$$outer$1;
        var t = $m_Lamf_core_metamodel_Type$Iri$();
        var this$5 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__value__Lamf_core_metamodel_Type__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode(this$4, t, x$7);
        var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
        var iv$1 = $this.$$outer$1.ctx$2;
        return $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion$1, iv$1)).text$3
      })
    })(this));
    var this$6 = $m_sc_Seq$();
    var this$7 = new $c_s_Some().init___O($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2)))
  };
  var properties = $as_sc_Seq((this$7.isEmpty__Z() ? $m_sci_Nil$() : this$7.get__O()));
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, map$1) {
    return (function(uri$2) {
      var uri = $as_T(uri$2);
      var this$9 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option(this$3$1.$$outer$1.compactUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T(uri, this$3$1.$$outer$1.ctx$2));
      if (this$9.isEmpty__Z()) {
        var xo = $m_s_None$()
      } else {
        var arg1$1 = this$9.get__O();
        var entry = $as_Lorg_yaml_model_YMapEntry(arg1$1);
        $m_Lamf_core_parser_Annotations$();
        var annotations = new $c_Lamf_core_parser_Annotations().init___();
        var extension = new $c_Lamf_core_model_domain_extensions_DomainExtension().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
        var this$13 = entry.value$2;
        var conversion$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv$2 = this$3$1.$$outer$1.ctx$2;
        var obj = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$13, conversion$2, iv$2));
        var this$14 = this$3$1.$$outer$1.amf$plugins$document$graph$parser$ExpandedGraphParser$$parseScalarProperty__Lorg_yaml_model_YMap__Lamf_core_metamodel_Field__s_Option(obj, $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1);
        if ((!this$14.isEmpty__Z())) {
          var arg1$2 = this$14.get__O();
          var name = $as_T(arg1$2);
          var field = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1;
          new $c_s_Some().init___O($as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(extension, field, name)))
        };
        var this$15 = this$3$1.$$outer$1.amf$plugins$document$graph$parser$ExpandedGraphParser$$parseScalarProperty__Lorg_yaml_model_YMap__Lamf_core_metamodel_Field__s_Option(obj, $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Element$1);
        if ((!this$15.isEmpty__Z())) {
          var arg1$3 = this$15.get__O();
          var element = $as_T(arg1$3);
          var field$1 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Element$1;
          new $c_s_Some().init___O($as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(extension, field$1, element)))
        };
        $m_Lamf_core_parser_Annotations$();
        var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
        var definition = new $c_Lamf_core_model_domain_extensions_CustomDomainProperty().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
        definition.id$1 = uri;
        var field$2 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().DefinedBy$1;
        $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(extension, field$2, definition));
        var this$19 = this$3$1.parse__p1__Lorg_yaml_model_YMap__s_Option(obj);
        var pf = new $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1().init___Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser(this$3$1);
        if ((!this$19.isEmpty__Z())) {
          var this$20 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
          var v1 = this$19.get__O();
          var this$21 = this$20.apply__O__s_Option(v1)
        } else {
          var this$21 = $m_s_None$()
        };
        if ((!this$21.isEmpty__Z())) {
          var arg1$4 = this$21.get__O();
          var pn = $as_Lamf_core_model_domain_DataNode(arg1$4);
          var value = pn.id$1;
          $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(extension, value);
          var field$3 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1;
          $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(extension, field$3, pn))
        };
        var this$22 = this$3$1.$$outer$1;
        var id = extension.id$1;
        var ctx = this$3$1.$$outer$1.ctx$2;
        var sources = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__retrieveSources__T__Lorg_yaml_model_YMap__Lamf_plugins_document_graph_parser_GraphParserContext__Lamf_core_model_document_SourceMap(this$22, id, map$1, ctx);
        var jsx$4 = extension.annotations$1;
        var this$23 = this$3$1.$$outer$1;
        var nodes = this$3$1.nodes$1;
        var key = extension.id$1;
        jsx$4.$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations($f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this$23, nodes, sources, key));
        var xo = new $c_s_Some().init___O(extension)
      };
      return xo.toList__sci_List()
    })
  })(this, map));
  var this$25 = $m_sc_Seq$();
  var extensions = $as_sc_Seq(properties.flatMap__F1__scg_CanBuildFrom__O(jsx$3, this$25.ReusableCBFInstance$2));
  if (extensions.nonEmpty__Z()) {
    var x1 = extensions.partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
      return (function(x$8$2) {
        var x$8 = $as_Lamf_core_model_domain_extensions_DomainExtension(x$8$2);
        return x$8.isScalarExtension__Z()
      })
    })(this)));
    if ((x1 !== null)) {
      var scalars = $as_sc_Seq(x1.$$und1__O());
      var objects = $as_sc_Seq(x1.$$und2__O());
      var field$4 = $m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field();
      $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(instance, field$4, objects));
      this.applyScalarDomainProperties__p1__Lamf_core_model_domain_DomainElement__sc_Seq__V(instance, scalars)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype.parse__p1__Lorg_yaml_model_YMap__s_Option = (function(map) {
  var this$1 = this.$$outer$1;
  var ctx = this.$$outer$1.ctx$2;
  var this$2 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__retrieveId__Lorg_yaml_model_YMap__Lamf_core_parser_ParserContext__s_Option(this$1, map, ctx);
  if (this$2.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var value = $as_T(arg1);
    var this$3 = this.retrieveType__p1__T__Lorg_yaml_model_YMap__s_Option(value, map);
    if (this$3.isEmpty__Z()) {
      var this$4 = $m_s_None$()
    } else {
      var arg1$1 = this$3.get__O();
      var value2 = $as_Lamf_core_metamodel_Obj(arg1$1);
      var this$4 = new $c_s_Some().init___O(new $c_T2().init___O__O(value, value2))
    }
  };
  if (this$4.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1$2 = this$4.get__O();
    var x0$1 = $as_T2(arg1$2);
    if ((x0$1 === null)) {
      throw new $c_s_MatchError().init___O(x0$1)
    };
    var id = $as_T(x0$1.$$und1__O());
    var model = $as_Lamf_core_metamodel_Obj(x0$1.$$und2__O());
    var this$5 = this.$$outer$1;
    var ctx$1 = this.$$outer$1.ctx$2;
    var sources = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__retrieveSources__T__Lorg_yaml_model_YMap__Lamf_plugins_document_graph_parser_GraphParserContext__Lamf_core_model_document_SourceMap(this$5, id, map, ctx$1);
    var transformedId = this.$$outer$1.transformIdFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T(id, this.$$outer$1.ctx$2);
    var jsx$1 = this.$$outer$1.amf$plugins$document$graph$parser$ExpandedGraphParser$$buildType__T__Lorg_yaml_model_YMap__Lamf_core_metamodel_Obj__F1(transformedId, map, model);
    var this$6 = this.$$outer$1;
    var nodes = this.nodes$1;
    var x1$2 = $as_s_Option(jsx$1.apply__O__O($f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this$6, nodes, sources, transformedId)));
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var builder = $as_Lamf_core_model_domain_AmfObject(x2.value$2);
      builder.withId__T__Lamf_core_model_domain_AmfObject(transformedId);
      this.checkLinkables__p1__Lamf_core_model_domain_AmfObject__V(builder);
      if ($is_Lamf_core_metamodel_domain_ShapeModel(model)) {
        var x2$2 = $as_Lamf_core_metamodel_domain_ShapeModel(model);
        var jsx$4 = x2$2.fields__sci_List();
        var jsx$3 = $m_sc_Seq$();
        var array = [$m_Lamf_core_metamodel_domain_ShapeModel$().CustomShapePropertyDefinitions__Lamf_core_metamodel_Field(), $m_Lamf_core_metamodel_domain_ShapeModel$().CustomShapeProperties__Lamf_core_metamodel_Field()];
        var jsx$2 = jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
        var this$9 = $m_sci_List$();
        var modelFields = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$9.ReusableCBFInstance$2))
      } else {
        var modelFields = model.fields__sci_List()
      };
      var these = modelFields;
      while ((!these.isEmpty__Z())) {
        var arg1$3 = these.head__O();
        var f = $as_Lamf_core_metamodel_Field(arg1$3);
        var k = this.$$outer$1.compactUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T(f.value$1.iri__T(), this.$$outer$1.ctx$2);
        var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(k);
        if ((x1 instanceof $c_s_Some)) {
          var x2$1 = $as_s_Some(x1);
          var entry = $as_Lorg_yaml_model_YMapEntry(x2$1.value$2);
          var this$11 = this.$$outer$1;
          var t = f.type$1;
          var node = entry.value$2;
          this.traverse__p1__Lamf_core_model_domain_AmfObject__Lamf_core_metamodel_Field__Lorg_yaml_model_YNode__Lamf_core_model_document_SourceMap__T__Lamf_core_model_domain_AmfObject(builder, f, $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__value__Lamf_core_metamodel_Type__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode(this$11, t, node), sources, k)
        };
        these = $as_sci_List(these.tail__O())
      };
      matchEnd6: {
        if (($is_Lamf_core_model_domain_DomainElement(builder) && $is_Lamf_core_model_domain_Linkable(builder))) {
          var x2$3 = $as_Lamf_core_model_domain_DomainElement(builder);
          this.parseLinkableProperties__p1__Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__V(map, x2$3);
          break matchEnd6
        };
        if ((builder instanceof $c_Lamf_core_model_domain_ExternalDomainElement)) {
          var x3 = $as_Lamf_core_model_domain_ExternalDomainElement(builder);
          if (this.unresolvedExtReferencesMap$1.get__O__s_Option(x3.id$1).isDefined__Z()) {
            var this$12 = this.unresolvedExtReferencesMap$1.get__O__s_Option(x3.id$1);
            if ((!this$12.isEmpty__Z())) {
              var arg1$4 = this$12.get__O();
              var element = $as_Lamf_core_model_domain_ExternalSourceElement(arg1$4);
              var this$13 = $as_Lamf_core_model_StrField(x3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1)).option$1;
              if ((!this$13.isEmpty__Z())) {
                var arg1$5 = this$13.get__O();
                var x$3 = $as_T(arg1$5);
                var field = $m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1;
                $as_Lamf_core_model_domain_ExternalSourceElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(element, field, x$3))
              }
            };
            break matchEnd6
          }
        };
        if ((builder instanceof $c_Lamf_core_model_domain_ObjectNode)) {
          var x4 = $as_Lamf_core_model_domain_ObjectNode(builder);
          this.parseObjectNodeProperties__p1__Lamf_core_model_domain_ObjectNode__Lorg_yaml_model_YMap__sci_List__V(x4, map, modelFields);
          break matchEnd6
        }
      };
      if ($is_Lamf_core_model_domain_DomainElement(builder)) {
        var x2$4 = $as_Lamf_core_model_domain_DomainElement(builder);
        this.parseCustomProperties__p1__Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__V(map, x2$4)
      };
      this.nodes$1 = this.nodes$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(transformedId, builder));
      return new $c_s_Some().init___O(builder)
    } else {
      return $m_s_None$()
    }
  }
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype.parseList__p1__T__Lamf_core_metamodel_Type__Lorg_yaml_model_YMap__sc_Seq = (function(id, listElement, node) {
  var buffer = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $as_sc_IterableLike(node.entries$3.sortBy__F1__s_math_Ordering__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_Lorg_yaml_model_YMapEntry(x$2$2);
      var this$1 = x$2.key$2;
      var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
      var iv = $this.$$outer$1.ctx$2;
      return $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv))
    })
  })(this)), $m_s_math_Ordering$String$())).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, buffer$1) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var this$3 = entry.key$2;
      var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
      var iv$1 = this$2.$$outer$1.ctx$2;
      var thiz = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion$1, iv$1));
      var jsx$1 = this$2.$$outer$1;
      var this$4 = $m_Lamf_core_vocabulary_Namespace$().Rdfs$1;
      var prefix = jsx$1.compactUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "_").iri__T(), this$2.$$outer$1.ctx$2);
      if ((($uI(thiz.length) >= 0) && ($as_T(thiz.substring(0, $uI(prefix.length))) === prefix))) {
        var this$11 = entry.value$2;
        var conversion$2 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
        var iv$2 = this$2.$$outer$1.ctx$2;
        return buffer$1.$$plus$eq__O__scm_ListBuffer($as_sc_IterableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$11, conversion$2, iv$2)).head__O())
      } else {
        return (void 0)
      }
    })
  })(this, buffer)));
  $m_scm_ListBuffer$();
  $m_scm_ListBuffer$();
  var b = new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_ListBuffer().init___());
  var this$14 = buffer.scala$collection$mutable$ListBuffer$$start$6;
  var these = this$14;
  while ((!these.isEmpty__Z())) {
    var arg1 = these.head__O();
    var n = $as_Lorg_yaml_model_YNode(arg1);
    if ($is_Lamf_core_metamodel_Obj(listElement)) {
      var conversion$3 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv$3 = this.$$outer$1.ctx$2;
      var xo = this.parse__p1__Lorg_yaml_model_YMap__s_Option($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(n, conversion$3, iv$3)));
      var this$19 = xo.toList__sci_List()
    } else {
      try {
        var jsx$2 = this.$$outer$1;
        var this$16 = this.$$outer$1;
        var xo$1 = new $c_s_Some().init___O(jsx$2.amf$plugins$document$graph$parser$ExpandedGraphParser$$str__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar($f_Lamf_plugins_document_graph_parser_GraphParserHelpers__value__Lamf_core_metamodel_Type__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode(this$16, listElement, n)));
        var this$19 = xo$1.toList__sci_List()
      } catch (e) {
        var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
        if ((e$2 instanceof $c_jl_Exception)) {
          var xo$2 = $m_s_None$();
          var this$19 = xo$2.toList__sci_List()
        } else {
          var this$19;
          throw e
        }
      }
    };
    $as_scm_Builder($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(b, this$19));
    these = $as_sci_List(these.tail__O())
  };
  return $as_sc_Seq(b.elems$1)
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype.parseLinkableProperties__p1__Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__V = (function(map, instance) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(this.$$outer$1.compactUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T($m_Lamf_core_metamodel_domain_LinkableElementModel$().TargetId$1.value$1.iri__T(), this.$$outer$1.ctx$2));
  if (this$2.isEmpty__Z()) {
    var this$7 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$6 = this.$$outer$1;
    var this$5 = entry.value$2;
    var reader = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var this$4 = $m_sc_IndexedSeq$();
    var bf = this$4.ReusableCBF$6;
    var conversion = new $c_Lorg_yaml_convert_YRead$$anon$1().init___scg_CanBuildFrom__Lorg_yaml_convert_YRead(bf, reader);
    var iv = this.$$outer$1.ctx$2;
    var map$1 = $as_Lorg_yaml_model_YMap($as_sc_IterableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv)).head__O());
    var ctx = this.$$outer$1.ctx$2;
    var this$7 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__retrieveId__Lorg_yaml_model_YMap__Lamf_core_parser_ParserContext__s_Option(this$6, map$1, ctx)
  };
  if ((!this$7.isEmpty__Z())) {
    var arg1$1 = this$7.get__O();
    var targetId = $as_T(arg1$1);
    var transformedId = this.$$outer$1.transformIdFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T(targetId, this.$$outer$1.ctx$2);
    this.setLinkTarget__p1__Lamf_core_model_domain_DomainElement__T__O(instance, transformedId)
  };
  var this$9 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(this.$$outer$1.compactUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1.value$1.iri__T(), this.$$outer$1.ctx$2));
  if (this$9.isEmpty__Z()) {
    var this$18 = $m_s_None$()
  } else {
    var arg1$2 = this$9.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var node = entry$3.value$2;
    var this$11 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$SeqNodeYRead$());
    if (this$11.isEmpty__Z()) {
      var this$13 = $m_s_None$()
    } else {
      var arg1$3 = this$11.get__O();
      var nodes = $as_sc_Seq(arg1$3);
      var node$1 = $as_Lorg_yaml_model_YNodeLike(nodes.head__O());
      var this$13 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node$1).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YMapYRead$())
    };
    if (this$13.isEmpty__Z()) {
      var this$15 = $m_s_None$()
    } else {
      var arg1$4 = this$13.get__O();
      var map$2 = $as_Lorg_yaml_model_YMap(arg1$4);
      var this$15 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2).key__T__s_Option("@value")
    };
    if (this$15.isEmpty__Z()) {
      var this$18 = $m_s_None$()
    } else {
      var arg1$5 = this$15.get__O();
      var x$4 = $as_Lorg_yaml_model_YMapEntry(arg1$5);
      var node$2 = x$4.value$2;
      var this$17 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node$2).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lamf_core_parser_package$YScalarYRead$());
      if (this$17.isEmpty__Z()) {
        var this$18 = $m_s_None$()
      } else {
        var arg1$6 = this$17.get__O();
        var x$5 = $as_Lorg_yaml_model_YScalar(arg1$6);
        var this$18 = new $c_s_Some().init___O(x$5.text$3)
      }
    }
  };
  if ((!this$18.isEmpty__Z())) {
    var arg1$7 = this$18.get__O();
    var s = $as_T(arg1$7);
    var this$19 = $as_Lamf_core_model_domain_Linkable(instance);
    var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1;
    $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$19, field, s))
  }
});
function $as_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.graph.parser.ExpandedGraphParser$Parser"))
}
function $isArrayOf_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser)))
}
function $asArrayOf_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.graph.parser.ExpandedGraphParser$Parser;", depth))
}
var $d_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser = new $TypeData().initClass({
  Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser: 0
}, false, "amf.plugins.document.graph.parser.ExpandedGraphParser$Parser", {
  Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser.prototype.$classData = $d_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper() {
  $c_O.call(this);
  this.mapping$1 = null;
  this.dialectEmitter$1 = null;
  this.discriminator$1 = null;
  this.discriminatorName$1 = null;
  this.discriminatorMappings$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper.prototype = $c_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper.prototype.productPrefix__T = (function() {
  return "DiscriminatorHelper"
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper)) {
    var DiscriminatorHelper$1 = $as_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper(x$1);
    var x = this.mapping$1;
    var x$2 = DiscriminatorHelper$1.mapping$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.dialectEmitter$1;
      var x$4 = DiscriminatorHelper$1.dialectEmitter$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.mapping$1;
      break
    }
    case 1: {
      return this.dialectEmitter$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper.prototype.init___Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper = (function(mapping, dialectEmitter) {
  this.mapping$1 = mapping;
  this.dialectEmitter$1 = dialectEmitter;
  var this$1 = $m_s_Option$().apply__O__s_Option($f_Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__typeDiscriminator__sci_Map(mapping));
  if (this$1.isEmpty__Z()) {
    var this$2 = this.mapping$1;
    var this$3 = $as_Lamf_core_model_StrField($as_sc_Seq(this$2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1)).head__O());
    var this$4 = this$3.option$1;
    var rangeId = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
    var this$5 = this.dialectEmitter$1;
    var x1 = $f_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__findNodeMappingById__T__T2(this$5, rangeId);
    matchEnd5: {
      var jsx$1;
      if ((x1 !== null)) {
        var unionMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1.$$und2__O());
        if ((unionMapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping)) {
          var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(unionMapping);
          var jsx$1 = $m_s_Option$().apply__O__s_Option($f_Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__typeDiscriminator__sci_Map(x3));
          break matchEnd5
        }
      };
      var jsx$1 = $m_s_None$()
    }
  } else {
    var jsx$1 = this$1
  };
  this.discriminator$1 = jsx$1;
  var this$6 = $as_Lamf_core_model_StrField(mapping.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().TypeDiscriminatorName$1)).option$1;
  if (this$6.isEmpty__Z()) {
    var this$7 = this.mapping$1;
    var this$8 = $as_Lamf_core_model_StrField($as_sc_Seq(this$7.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1)).head__O());
    var this$9 = this$8.option$1;
    var rangeId$1 = $as_T((this$9.isEmpty__Z() ? null : this$9.get__O()));
    var this$10 = this.dialectEmitter$1;
    var x1$1 = $f_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__findNodeMappingById__T__T2(this$10, rangeId$1);
    matchEnd5$1: {
      var jsx$2;
      if ((x1$1 !== null)) {
        var unionMapping$1 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1$1.$$und2__O());
        if ((unionMapping$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping)) {
          var x3$1 = $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(unionMapping$1);
          var jsx$2 = $as_Lamf_core_model_StrField(x3$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().TypeDiscriminatorName$1)).option$1;
          break matchEnd5$1
        }
      };
      var jsx$2 = $m_s_None$()
    }
  } else {
    var jsx$2 = this$6
  };
  this.discriminatorName$1 = jsx$2;
  var this$11 = this.discriminator$1;
  this.discriminatorMappings$1 = $as_sci_Map($as_sc_TraversableOnce((this$11.isEmpty__Z() ? $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())) : this$11.get__O())).foldLeft__O__F2__O($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$4$1) {
    return (function(x0$1$2, x1$1$2) {
      var x0$1 = $as_sci_Map(x0$1$2);
      var x1$1$1 = $as_T2(x1$1$2);
      var x1$2 = new $c_T2().init___O__O(x0$1, x1$1$1);
      var acc = $as_sci_Map(x1$2.$$und1$f);
      var p2 = $as_T2(x1$2.$$und2$f);
      if ((p2 !== null)) {
        var alias = $as_T(p2.$$und1__O());
        var mappingId = $as_T(p2.$$und2__O());
        var this$12 = this$4$1.dialectEmitter$1;
        var x1$2$1 = $f_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__findNodeMappingById__T__T2(this$12, mappingId);
        if ((x1$2$1 !== null)) {
          var nodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1$2$1.$$und2__O());
          if ((nodeMapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
            var x3$2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(nodeMapping);
            return acc.$$plus__T2__sci_Map(new $c_T2().init___O__O(alias, x3$2))
          }
        };
        return acc
      };
      throw new $c_s_MatchError().init___O(x1$2)
    })
  })(this))));
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper.prototype.compute__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__s_Option = (function(dialectDomainElement) {
  var this$2 = dialectDomainElement.meta__Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel().type$1;
  var f = (function($this) {
    return (function(x$8$2) {
      var x$8 = $as_Lamf_core_vocabulary_ValueType(x$8$2);
      return x$8.iri__T()
    })
  })(this);
  var this$1 = $m_sci_List$();
  var bf = this$1.ReusableCBFInstance$2;
  if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
    if ((this$2 === $m_sci_Nil$())) {
      var jsx$1 = $m_sci_Nil$()
    } else {
      var arg1 = this$2.head__O();
      var h = new $c_sci_$colon$colon().init___O__sci_List(f(arg1), $m_sci_Nil$());
      var t = h;
      var rest = $as_sci_List(this$2.tail__O());
      while ((rest !== $m_sci_Nil$())) {
        var arg1$1 = rest.head__O();
        var nx = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$1), $m_sci_Nil$());
        t.tl$5 = nx;
        t = nx;
        rest = $as_sci_List(rest.tail__O())
      };
      var jsx$1 = h
    }
  } else {
    var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$2, bf);
    var these = this$2;
    while ((!these.isEmpty__Z())) {
      var arg1$2 = these.head__O();
      b.$$plus$eq__O__scm_Builder(f(arg1$2));
      these = $as_sci_List(these.tail__O())
    };
    var jsx$1 = b.result__O()
  };
  var elementTypes = $as_sci_List(jsx$1);
  var this$3 = this.discriminatorMappings$1;
  var this$4 = this$3.iterator__sc_Iterator();
  inlinereturn$16: {
    while (this$4.hasNext__Z()) {
      var a = this$4.next__O();
      var x0$1 = $as_T2(a);
      if ((x0$1 === null)) {
        throw new $c_s_MatchError().init___O(x0$1)
      };
      var discriminatorMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x0$1.$$und2__O());
      var this$5 = $as_Lamf_core_model_StrField(discriminatorMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().NodeTypeMapping$1));
      var this$6 = this$5.option$1;
      var elem = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
      if ($f_sc_LinearSeqOptimized__contains__O__Z(elementTypes, elem)) {
        var x1 = new $c_s_Some().init___O(a);
        break inlinereturn$16
      }
    };
    var x1 = $m_s_None$()
  };
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var p3 = $as_T2(x2.value$2);
    if ((p3 !== null)) {
      var alias = $as_T(p3.$$und1__O());
      var this$7 = this.discriminatorName$1;
      return new $c_s_Some().init___O(new $c_T2().init___O__O((this$7.isEmpty__Z() ? "type" : this$7.get__O()), alias))
    }
  };
  return $m_s_None$()
});
function $as_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.instances.DiscriminatorHelper"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.instances.DiscriminatorHelper;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper: 0
}, false, "amf.plugins.document.vocabularies.emitters.instances.DiscriminatorHelper", {
  Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$() {
  $c_O.call(this);
  this.Name$1 = null;
  this.DisplayName$1 = null;
  this.Description$1 = null;
  this.Properties$1 = null;
  this.SubClassOf$1 = null;
  this.type$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.doc$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Name$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "name"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "name", "Name of the ClassTerm", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.DisplayName$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "displayName"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "displayName", "Human readable name for the term", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_core_metamodel_Type$Str$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Description$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "description"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "description", "Human readable description for the term", $m_sci_Nil$()), true);
  var jsx$4 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Iri$());
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.Properties$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "properties"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "properties", "Properties that have the ClassTerm in the domain", $m_sci_Nil$()), true);
  var jsx$5 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Iri$());
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().Rdfs$1;
  this.SubClassOf$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "subClassOf"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Rdfs$1, "subClassOf", "Subsumption relationship across terms", $m_sci_Nil$()), true);
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().Owl$1;
  var x$6 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "Class");
  var this$18 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$6, this$18);
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  this.doc$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$.prototype.fields__sci_List = (function() {
  var x$5 = this.Name$1;
  var x$4 = this.DisplayName$1;
  var x$3 = this.Description$1;
  var x$2 = this.Properties$1;
  var x$1 = this.SubClassOf$1;
  var this$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$2 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$1);
  var this$3 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$2);
  var this$4 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$3);
  var this$5 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$4);
  return new $c_sci_$colon$colon().init___O__sci_List(x$5, this$5)
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$: 0
}, false, "amf.plugins.document.vocabularies.metamodel.domain.ClassTermModel$", {
  Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$;
var $n_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$() {
  if ((!$n_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$)) {
    $n_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$ = new $c_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$() {
  $c_O.call(this);
  this.DocumentName$1 = null;
  this.EncodedNode$1 = null;
  this.DeclaredNodes$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.DocumentName$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "name"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "name", "Name of the document for a dialect base unit", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.EncodedNode$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "encodedNode"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "encoded node", "Node in the dialect encoded in the target mapped base unit", $m_sci_Nil$()), true);
  var jsx$3 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$());
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.DeclaredNodes$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "declaredNode"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "declared node", "Node in the dialect declared in the target mappend base unit", $m_sci_Nil$()), true);
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  var x$7 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "DocumentMapping");
  var this$12 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$7, this$12);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "Document Mapping", "Mapping for a particular dialect document into a graph base unit", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$.prototype.fields__sci_List = (function() {
  var x$6 = this.DocumentName$1;
  var x$5 = this.EncodedNode$1;
  var x$4 = this.DeclaredNodes$1;
  var this$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$2 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$1);
  var this$3 = new $c_sci_$colon$colon().init___O__sci_List(x$5, this$2);
  return new $c_sci_$colon$colon().init___O__sci_List(x$6, this$3)
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$: 0
}, false, "amf.plugins.document.vocabularies.metamodel.domain.DocumentMappingModel$", {
  Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$;
var $n_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$() {
  if ((!$n_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$)) {
    $n_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$ = new $c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$() {
  $c_O.call(this);
  this.Root$1 = null;
  this.Fragments$1 = null;
  this.Library$1 = null;
  this.SelfEncoded$1 = null;
  this.DeclarationsPath$1 = null;
  this.KeyProperty$1 = null;
  this.ReferenceStyle$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.Root$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "rootDocument"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "root document", "Root node encoded in a mapped document base unit", $m_sci_Nil$()), true);
  var jsx$2 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$());
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.Fragments$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "fragments"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "fragments", "Mapping of fragment base unit for a particular dialect", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.Library$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "library"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "library", "Mappig of module base unit for a particular dialect", $m_sci_Nil$()), true);
  var jsx$4 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.SelfEncoded$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "selfEncoded"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "self encoded", "Information about if the base unit URL should be the same as the URI of the parsed root nodes in the unit", $m_sci_Nil$()), true);
  var jsx$5 = $m_Lamf_core_metamodel_Type$Str$();
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.DeclarationsPath$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "declarationsPath"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "declarations path", "Information about the AST location of the declarations to be parsed as declared domain elements", $m_sci_Nil$()), true);
  var jsx$6 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.KeyProperty$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$6, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "keyProperty"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "key property", "Information about whether the dialect is defined by the header or a key property", $m_sci_Nil$()), true);
  var jsx$7 = $m_Lamf_core_metamodel_Type$Str$();
  var this$19 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.ReferenceStyle$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$7, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$19, "referenceStyle"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "reference style", "Determines the style for inclusions (RamlStyle or JsonSchemaStyle)", $m_sci_Nil$()), true);
  var this$22 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  var x$15 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$22, "DocumentsModel");
  var this$24 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$15, this$24);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "Documents Model", "Mapping from different type of dialect documents to base units in the parsed graph", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$.prototype.fields__sci_List = (function() {
  var x$14 = this.Root$1;
  var x$13 = this.Fragments$1;
  var x$12 = this.Library$1;
  var x$11 = this.SelfEncoded$1;
  var x$10 = this.DeclarationsPath$1;
  var x$9 = this.KeyProperty$1;
  var x$8 = this.ReferenceStyle$1;
  var this$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$2 = new $c_sci_$colon$colon().init___O__sci_List(x$8, this$1);
  var this$3 = new $c_sci_$colon$colon().init___O__sci_List(x$9, this$2);
  var this$4 = new $c_sci_$colon$colon().init___O__sci_List(x$10, this$3);
  var this$5 = new $c_sci_$colon$colon().init___O__sci_List(x$11, this$4);
  var this$6 = new $c_sci_$colon$colon().init___O__sci_List(x$12, this$5);
  var this$7 = new $c_sci_$colon$colon().init___O__sci_List(x$13, this$6);
  return new $c_sci_$colon$colon().init___O__sci_List(x$14, this$7)
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$: 0
}, false, "amf.plugins.document.vocabularies.metamodel.domain.DocumentsModelModel$", {
  Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$;
var $n_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$() {
  if ((!$n_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$)) {
    $n_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$ = new $c_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$() {
  $c_O.call(this);
  this.DisplayName$1 = null;
  this.Base$1 = null;
  this.type$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.doc$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.DisplayName$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "displayName"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "displayName", "The display name of the item", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.Base$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "base"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "base", "Base URI for the external model", $m_sci_Nil$()), true);
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Owl$1;
  var x$4 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "Ontology");
  var this$9 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  var x$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$9, "ExternalVocabulary");
  var this$11 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  var this$12 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$11);
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$12);
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  this.doc$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$.prototype.fields__sci_List = (function() {
  var x$2 = this.DisplayName$1;
  var x$1 = this.Base$1;
  var this$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$2 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$1);
  return new $c_sci_$colon$colon().init___O__sci_List(x$2, this$2)
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_vocabularies_model_domain_External().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$: 0
}, false, "amf.plugins.document.vocabularies.metamodel.domain.ExternalModel$", {
  Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$;
var $n_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$() {
  if ((!$n_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$)) {
    $n_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$ = new $c_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyTermModel() {
  $c_O.call(this);
  this.Name$1 = null;
  this.DisplayName$1 = null;
  this.Description$1 = null;
  this.Range$1 = null;
  this.SubPropertyOf$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.doc$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyTermModel.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyTermModel.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyTermModel;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyTermModel() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyTermModel.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyTermModel.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyTermModel.prototype.init___ = (function() {
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Name$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "name"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "name", "Name of the property term", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.DisplayName$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "displayName"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "display name", "Human readable name for the property term", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_core_metamodel_Type$Str$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Description$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "description"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "description", "Human readable description of the property term", $m_sci_Nil$()), true);
  var jsx$4 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Rdfs$1;
  this.Range$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "range"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Rdfs$1, "range", "Range of the proeprty term, scalar or object", $m_sci_Nil$()), true);
  var jsx$5 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Iri$());
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().Rdfs$1;
  this.SubPropertyOf$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "subPropertyOf"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Rdfs$1, "subPropertyOf", "Subsumption relationship for terms", $m_sci_Nil$()), true);
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyTermModel.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyTermModel.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  this.doc$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyTermModel.prototype.fields__sci_List = (function() {
  var x$4 = this.DisplayName$1;
  var x$3 = this.Description$1;
  var x$2 = this.Range$1;
  var x$1 = this.SubPropertyOf$1;
  var this$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$2 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$1);
  var this$3 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$2);
  var this$4 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$3);
  return new $c_sci_$colon$colon().init___O__sci_List(x$4, this$4)
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyTermModel.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyTermModel.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$() {
  $c_O.call(this);
  this.Name$1 = null;
  this.MappedNode$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Name$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "name"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "name", "Name of the mapping", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.MappedNode$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "mappedNode"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "mapped node", "Node in the dialect definition associated to this mapping", $m_sci_Nil$()), true);
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  var x$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "PublicNodeMapping");
  var this$9 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$9);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "Public Node Mapping", "Mapping for a graph node mapping to a particular function in a dialect", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$.prototype.fields__sci_List = (function() {
  var x$2 = this.Name$1;
  var x$1 = this.MappedNode$1;
  var this$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$2 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$1);
  return new $c_sci_$colon$colon().init___O__sci_List(x$2, this$2)
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$: 0
}, false, "amf.plugins.document.vocabularies.metamodel.domain.PublicNodeMappingModel$", {
  Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$;
var $n_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$() {
  if ((!$n_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$)) {
    $n_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$ = new $c_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$() {
  $c_O.call(this);
  this.Alias$1 = null;
  this.Reference$1 = null;
  this.Base$1 = null;
  this.fields$1 = null;
  this.type$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.doc$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  this.Alias$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "alias"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$6 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  this.Reference$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$6, "reference"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_core_metamodel_Type$Str$();
  var this$11 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.Base$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$11, "base"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true);
  var x$3 = this.Alias$1;
  var x$2 = this.Reference$1;
  var x$1 = this.Base$1;
  var this$16 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$17 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$16);
  var this$18 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$17);
  this.fields$1 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$18);
  var this$19 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  var x$4 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$19, "VocabularyReference");
  var this$21 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$21);
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  this.doc$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$: 0
}, false, "amf.plugins.document.vocabularies.metamodel.domain.VocabularyReferenceModel$", {
  Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$;
var $n_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$() {
  if ((!$n_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$)) {
    $n_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$ = new $c_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$
}
function $is_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_document_vocabularies_model_domain_NodeMappable)))
}
function $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(obj) {
  return (($is_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.domain.NodeMappable"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_domain_NodeMappable)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.domain.NodeMappable;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser() {
  $c_O.call(this);
  this.node$1 = null;
  this.parent$1 = null;
  this.idCounter$1 = null;
  this.aliasCounter$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser.prototype = $c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser.prototype;
$c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser.prototype.parseObject__Lorg_yaml_model_YMap__Lamf_core_model_domain_DataNode = (function(value) {
  $m_Lamf_core_model_domain_ObjectNode$();
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(value);
  var this$3 = new $c_Lamf_core_model_domain_ObjectNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var name = this.idCounter$1.genId__T__T("object");
  var field = $m_Lamf_core_metamodel_domain_DataNodeModel$().Name$1;
  var node = $as_Lamf_core_model_domain_ObjectNode($as_Lamf_core_model_domain_DataNode($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$3, field, name)));
  var this$4 = this.parent$1;
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var p = $as_T(arg1);
    $as_Lamf_core_model_domain_ObjectNode(node.adopted__T__sc_Seq__Lamf_core_model_domain_DataNode(p, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))))
  };
  var jsx$2 = value.entries$3;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, node$1) {
    return (function(ast$2) {
      var ast = $as_Lorg_yaml_model_YMapEntry(ast$2);
      var this$5 = ast.key$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
      var iv = this$2$1.ctx$1;
      var key = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv)).text$3;
      var value$1 = ast.value$2;
      var propertyAnnotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
      var propertyNode = new $c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser().init___Lorg_yaml_model_YNode__s_Option__Lamf_core_utils_package$IdCounter__Lamf_core_utils_package$AliasCounter__Lamf_core_parser_ParserContext(value$1, new $c_s_Some().init___O(node$1.id$1), this$2$1.idCounter$1, this$2$1.aliasCounter$1, this$2$1.ctx$1).parse__Lamf_core_model_domain_DataNode().forceAdopted__T__Lamf_core_model_domain_DataNode(node$1.id$1);
      return node$1.addProperty__T__Lamf_core_model_domain_DataNode__Lamf_core_parser_Annotations__Lamf_core_model_domain_ObjectNode(key, propertyNode, propertyAnnotations)
    })
  })(this, node));
  var this$6 = $m_sc_IndexedSeq$();
  jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBF$6);
  return node
});
$c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser.prototype.productPrefix__T = (function() {
  return "DynamicExtensionParser"
});
$c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser)) {
    var DynamicExtensionParser$1 = $as_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser(x$1);
    var this$1 = this.node$1;
    var b = DynamicExtensionParser$1.node$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.parent$1;
      var x$2 = DynamicExtensionParser$1.parent$1;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$3 = this.idCounter$1;
      var x$4 = DynamicExtensionParser$1.idCounter$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.aliasCounter$1;
      var x$6 = DynamicExtensionParser$1.aliasCounter$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser.prototype.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode = (function(ast, dataType) {
  var finalDataType = new $c_s_Some().init___O($m_Lamf_core_model_DataType$().apply__T__T(dataType));
  var this$1 = $m_Lamf_core_model_domain_ScalarNode$().apply__T__s_Option__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode(ast.text$3, finalDataType, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast));
  var name = this.idCounter$1.genId__T__T("scalar");
  var field = $m_Lamf_core_metamodel_domain_DataNodeModel$().Name$1;
  var node = $as_Lamf_core_model_domain_ScalarNode($as_Lamf_core_model_domain_DataNode($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name)));
  var this$2 = this.parent$1;
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var p = $as_T(arg1);
    $as_Lamf_core_model_domain_ScalarNode(node.adopted__T__sc_Seq__Lamf_core_model_domain_DataNode(p, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))))
  };
  return node
});
$c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.node$1;
      break
    }
    case 1: {
      return this.parent$1;
      break
    }
    case 2: {
      return this.idCounter$1;
      break
    }
    case 3: {
      return this.aliasCounter$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser.prototype.parse__Lamf_core_model_domain_DataNode = (function() {
  if (this.aliasCounter$1.exceedsThreshold__Lorg_yaml_model_YNode__Z(this.node$1)) {
    var this$2 = this.ctx$1;
    var violationId = $m_Lamf_plugins_features_validation_CoreValidations$().SyamlError$1;
    var this$1 = this.parent$1;
    var node = $as_T((this$1.isEmpty__Z() ? "" : this$1.get__O()));
    var this$3 = this$2.eh$1;
    var location = this$2.rootContextDocument$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__T__V(this$3, violationId, node, "Exceeded maximum yaml references threshold", location);
    $m_Lamf_core_model_domain_ObjectNode$();
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    return new $c_Lamf_core_model_domain_ObjectNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
  } else {
    var x1 = this.node$1.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Str$1;
    if ((x === x1)) {
      var this$7 = this.node$1;
      var conversion = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
      var iv = this.ctx$1;
      return this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$7, conversion, iv)), "string")
    } else {
      var x$3 = $m_Lorg_yaml_model_YType$().Int$1;
      if ((x$3 === x1)) {
        var this$8 = this.node$1;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
        var iv$1 = this.ctx$1;
        return this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$8, conversion$1, iv$1)), "integer")
      } else {
        var x$5 = $m_Lorg_yaml_model_YType$().Float$1;
        if ((x$5 === x1)) {
          var this$9 = this.node$1;
          var conversion$2 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
          var iv$2 = this.ctx$1;
          return this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$9, conversion$2, iv$2)), "double")
        } else {
          var x$7 = $m_Lorg_yaml_model_YType$().Bool$1;
          if ((x$7 === x1)) {
            var this$10 = this.node$1;
            var conversion$3 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
            var iv$3 = this.ctx$1;
            return this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$10, conversion$3, iv$3)), "boolean")
          } else {
            var x$9 = $m_Lorg_yaml_model_YType$().Null$1;
            if ((x$9 === x1)) {
              var this$11 = this.node$1;
              var conversion$4 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
              var iv$4 = this.ctx$1;
              return this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$11, conversion$4, iv$4)), "nil")
            } else {
              var x$11 = $m_Lorg_yaml_model_YType$().Seq$1;
              if ((x$11 === x1)) {
                var this$12 = this.node$1;
                var conversion$5 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
                var iv$5 = this.ctx$1;
                return this.parseArray__sc_Seq__Lorg_yaml_model_YPart__Lamf_core_model_domain_DataNode($as_sc_Seq($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$12, conversion$5, iv$5)), this.node$1)
              } else {
                var x$13 = $m_Lorg_yaml_model_YType$().Map$1;
                if ((x$13 === x1)) {
                  var this$13 = this.node$1;
                  var conversion$6 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
                  var iv$6 = this.ctx$1;
                  return this.parseObject__Lorg_yaml_model_YMap__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$13, conversion$6, iv$6)))
                } else {
                  var x$15 = $m_Lorg_yaml_model_YType$().Timestamp$1;
                  if ((x$15 === x1)) {
                    var x1$2 = $m_Lorg_mulesoft_common_time_SimpleDateTime$().parse__T__s_util_Either(this.node$1.toString__T()).toOption__s_Option();
                    if ((x1$2 instanceof $c_s_Some)) {
                      var x2 = $as_s_Some(x1$2);
                      var sdt = $as_Lorg_mulesoft_common_time_SimpleDateTime(x2.value$2);
                      try {
                        $m_Lorg_mulesoft_common_time_package$DateTimes$().toDate$extension__Lorg_mulesoft_common_time_SimpleDateTime__ju_Date(sdt);
                        if (sdt.timeOfDay$1.isEmpty__Z()) {
                          var this$15 = this.node$1;
                          var conversion$7 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
                          var iv$7 = this.ctx$1;
                          return this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$15, conversion$7, iv$7)), "date")
                        } else if (sdt.zoneOffset$1.isEmpty__Z()) {
                          var this$16 = this.node$1;
                          var conversion$8 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
                          var iv$8 = this.ctx$1;
                          return this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$16, conversion$8, iv$8)), "dateTimeOnly")
                        } else {
                          var this$17 = this.node$1;
                          var conversion$9 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
                          var iv$9 = this.ctx$1;
                          return this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$17, conversion$9, iv$9)), "dateTime")
                        }
                      } catch (e) {
                        var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
                        if ((e$2 instanceof $c_jl_Exception)) {
                          var this$18 = this.node$1;
                          var conversion$10 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
                          var iv$10 = this.ctx$1;
                          return this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$18, conversion$10, iv$10)), "string")
                        } else {
                          throw e
                        }
                      }
                    } else {
                      var x$17 = $m_s_None$();
                      if ((x$17 === x1$2)) {
                        var this$19 = this.node$1;
                        var conversion$11 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
                        var iv$11 = this.ctx$1;
                        return this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$19, conversion$11, iv$11)), "string")
                      } else {
                        throw new $c_s_MatchError().init___O(x1$2)
                      }
                    }
                  } else {
                    var parsed = this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($m_Lorg_yaml_model_YScalar$().apply__O__Lorg_yaml_model_YScalar(x1.org$yaml$model$YType$$tag$und$1.text$3), "string");
                    var this$20 = this.ctx$1.eh$1;
                    var spec = $m_Lamf_validation_DialectValidations$().DialectError$1;
                    var node$1 = parsed.id$1;
                    var prop = $m_s_None$();
                    var msg = (("Cannot parse data node from AST structure '" + x1) + "'");
                    var ast = this.node$1;
                    var l = ast.location$1;
                    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$20, spec, node$1, prop, msg, l);
                    return parsed
                  }
                }
              }
            }
          }
        }
      }
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser.prototype.parseArray__sc_Seq__Lorg_yaml_model_YPart__Lamf_core_model_domain_DataNode = (function(seq, ast) {
  $m_Lamf_core_model_domain_ArrayNode$();
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  var this$3 = new $c_Lamf_core_model_domain_ArrayNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var name = this.idCounter$1.genId__T__T("array");
  var field = $m_Lamf_core_metamodel_domain_DataNodeModel$().Name$1;
  var node = $as_Lamf_core_model_domain_ArrayNode($as_Lamf_core_model_domain_DataNode($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$3, field, name)));
  var this$4 = this.parent$1;
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var p = $as_T(arg1);
    $as_Lamf_core_model_domain_ArrayNode(node.adopted__T__sc_Seq__Lamf_core_model_domain_DataNode(p, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))))
  };
  seq.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, node$1) {
    return (function(v$2) {
      var v = $as_Lorg_yaml_model_YNode(v$2);
      var element = new $c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser().init___Lorg_yaml_model_YNode__s_Option__Lamf_core_utils_package$IdCounter__Lamf_core_utils_package$AliasCounter__Lamf_core_parser_ParserContext(v, new $c_s_Some().init___O(node$1.id$1), this$2$1.idCounter$1, this$2$1.aliasCounter$1, this$2$1.ctx$1).parse__Lamf_core_model_domain_DataNode().forceAdopted__T__Lamf_core_model_domain_DataNode(node$1.id$1);
      return node$1.addMember__Lamf_core_model_domain_DataNode__sc_Seq(element)
    })
  })(this, node)));
  return node
});
$c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser.prototype.init___Lorg_yaml_model_YNode__s_Option__Lamf_core_utils_package$IdCounter__Lamf_core_utils_package$AliasCounter__Lamf_core_parser_ParserContext = (function(node, parent, idCounter, aliasCounter, ctx) {
  this.node$1 = node;
  this.parent$1 = parent;
  this.idCounter$1 = idCounter;
  this.aliasCounter$1 = aliasCounter;
  this.ctx$1 = ctx;
  return this
});
function $as_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.parser.DynamicExtensionParser"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.parser.DynamicExtensionParser;", depth))
}
var $d_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser: 0
}, false, "amf.plugins.document.vocabularies.parser.DynamicExtensionParser", {
  Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_DynamicExtensionParser;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser() {
  $c_O.call(this);
  this.dialect$1 = null;
  this.map$1 = null;
  this.references$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser.prototype = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser.prototype;
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser.prototype.productPrefix__T = (function() {
  return "DialectsReferencesParser"
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser.prototype.parseExternals__p1__Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations__T__V = (function(result, id) {
  var map = this.map$1;
  var this$2 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("external");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$1;
    $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, result$3) {
      return (function(e$2) {
        var e = $as_Lorg_yaml_model_YMapEntry(e$2);
        var this$5 = e.key$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
        var iv$1 = $this.ctx$1;
        var alias = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion$1, iv$1)).text$3;
        $m_Lorg_yaml_model_YNode$();
        var node = e.value$2;
        var iv$2 = $this.ctx$1;
        var conversion$2 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var base = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$2, iv$2));
        $m_Lamf_core_parser_Annotations$();
        var annotations = new $c_Lamf_core_parser_Annotations().init___();
        var external = new $c_Lamf_plugins_document_vocabularies_model_domain_External().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
        var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().DisplayName$1;
        var this$10 = $as_Lamf_plugins_document_vocabularies_model_domain_External($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(external, field, alias));
        var field$1 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().Base$1;
        result$3.$$plus$eq__Lamf_plugins_document_vocabularies_model_domain_External__V($as_Lamf_plugins_document_vocabularies_model_domain_External($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$10, field$1, base)))
      })
    })(this, result)))
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser.prototype.parseLibraries__p1__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations__T__V = (function(dialect, result, id) {
  var map = this.map$1;
  var this$2 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("uses");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$1;
    $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, dialect$1, result$2, id$2) {
      return (function(e$2) {
        var e = $as_Lorg_yaml_model_YMapEntry(e$2);
        var this$5 = e.key$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
        var iv$1 = $this.ctx$1;
        var alias = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion$1, iv$1)).text$3;
        var url = $this.library__p1__Lorg_yaml_model_YMapEntry__T(e);
        var this$6 = $this.target__p1__T__s_Option(url);
        if ((!this$6.isEmpty__Z())) {
          var arg1$1 = this$6.get__O();
          var x0$1 = $as_Lamf_core_model_document_BaseUnit(arg1$1);
          if ((x0$1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary)) {
            var x2 = $as_Lamf_plugins_document_vocabularies_model_document_Vocabulary(x0$1);
            var this$8 = $as_Lamf_core_model_StrField(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Base$1));
            var this$9 = this$8.option$1;
            var y = new $c_T2().init___O__O($as_T((this$9.isEmpty__Z() ? null : this$9.get__O())), url);
            $this.collectAlias__p1__Lamf_core_model_document_BaseUnit__T2__Lamf_core_model_document_BaseUnit(dialect$1, new $c_T2().init___O__O(alias, y));
            result$2.$$plus$eq__T__Lamf_core_model_document_BaseUnit__V(alias, x2)
          } else if ($is_Lamf_core_model_document_DeclaresModel(x0$1)) {
            var y$1 = new $c_T2().init___O__O(x0$1.id__T(), url);
            $this.collectAlias__p1__Lamf_core_model_document_BaseUnit__T2__Lamf_core_model_document_BaseUnit(dialect$1, new $c_T2().init___O__O(alias, y$1));
            result$2.$$plus$eq__T__Lamf_core_model_document_BaseUnit__V(alias, x0$1)
          } else {
            var x1$2 = $this.ctx$1.recursiveDeclarations$2.get__O__s_Option(url);
            matchEnd6: {
              if ((x1$2 instanceof $c_s_Some)) {
                var x2$2 = $as_s_Some(x1$2);
                var r = $as_Lamf_core_model_document_RecursiveUnit(x2$2.value$2);
                if ((r !== null)) {
                  result$2.$$plus$eq__T__Lamf_core_model_document_BaseUnit__V(alias, r);
                  break matchEnd6
                }
              };
              var x = $m_s_None$();
              if ((x === x1$2)) {
                var this$13 = $this.ctx$1.eh$1;
                var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
                var message = ("Expected vocabulary module but found: " + x0$1);
                var prop = $m_s_None$();
                var l = e.location$1;
                $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$13, specification, id$2, prop, message, l);
                break matchEnd6
              };
              throw new $c_s_MatchError().init___O(x1$2)
            }
          }
        }
      })
    })(this, dialect, result, id)))
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser)) {
    var DialectsReferencesParser$1 = $as_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser(x$1);
    var x = this.dialect$1;
    var x$2 = DialectsReferencesParser$1.dialect$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var this$1 = this.map$1;
      var b = DialectsReferencesParser$1.map$1;
      var jsx$1 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.references$1;
      var x$4 = DialectsReferencesParser$1.references$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.dialect$1;
      break
    }
    case 1: {
      return this.map$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser.prototype.target__p1__T__s_Option = (function(url) {
  var this$2 = this.references$1.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, url$1) {
    return (function(r$2) {
      var r = $as_Lamf_core_parser_ParsedReference(r$2);
      var this$1 = r.origin$1.url$1;
      return (this$1 === url$1)
    })
  })(this, url)));
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var x$9 = $as_Lamf_core_parser_ParsedReference(arg1);
    return new $c_s_Some().init___O(x$9.unit$1)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser.prototype.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations = (function(location) {
  var result = new $c_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations().init___scm_Map__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext($as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.ctx$1);
  this.references$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, result$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_parser_ParsedReference(x0$1$2);
      matchEnd10: {
        if ((x0$1 !== null)) {
          var f = x0$1.unit$1;
          var origin = x0$1.origin$1;
          var p2 = x0$1.ast$1;
          if ((f instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectFragment)) {
            var x4 = $as_Lamf_plugins_document_vocabularies_model_document_DialectFragment(f);
            if ((origin !== null)) {
              var x = $m_s_None$();
              if ((x === p2)) {
                result$1.$$plus$eq__T__Lamf_core_model_document_BaseUnit__V(origin.url$1, x4);
                break matchEnd10
              }
            }
          }
        };
        if ((x0$1 !== null)) {
          var r = x0$1.unit$1;
          var origin$2 = x0$1.origin$1;
          if ((r instanceof $c_Lamf_core_model_document_RecursiveUnit)) {
            var x7 = $as_Lamf_core_model_document_RecursiveUnit(r);
            if ((origin$2 !== null)) {
              result$1.$$plus$eq__T__Lamf_core_model_document_BaseUnit__V(origin$2.url$1, x7);
              break matchEnd10
            }
          }
        }
      }
    })
  })(this, result)));
  this.parseLibraries__p1__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations__T__V(this.dialect$1, result, location);
  this.parseExternals__p1__Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations__T__V(result, location);
  return result
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser.prototype.collectAlias__p1__Lamf_core_model_document_BaseUnit__T2__Lamf_core_model_document_BaseUnit = (function(aliasCollectorUnit, alias) {
  var x1 = aliasCollectorUnit.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_Aliases.getClassOf());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var aliases = $as_Lamf_core_annotations_Aliases(x2.value$2);
    aliasCollectorUnit.annotations__Lamf_core_parser_Annotations().reject__F1__Lamf_core_parser_Annotations(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$10$2) {
        var x$10 = $as_Lamf_core_model_domain_Annotation(x$10$2);
        return (x$10 instanceof $c_Lamf_core_annotations_Aliases)
      })
    })(this)));
    var aliases$1 = $as_sci_Set(aliases.aliases$1.$$plus__O__sc_Set(alias));
    var annotation = new $c_Lamf_core_annotations_Aliases().init___sci_Set(aliases$1);
    return $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(aliasCollectorUnit, annotation))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var array = [alias];
      if (($uI(array.length) === 0)) {
        var jsx$1 = $m_sci_Set$EmptySet$()
      } else {
        var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
        var i = 0;
        var len = $uI(array.length);
        while ((i < len)) {
          var index = i;
          var arg1 = array[index];
          b.$$plus$eq__O__scm_SetBuilder(arg1);
          i = ((1 + i) | 0)
        };
        var jsx$1 = b.elems$1
      };
      var annotation$1 = new $c_Lamf_core_annotations_Aliases().init___sci_Set($as_sci_Set(jsx$1));
      return $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(aliasCollectorUnit, annotation$1))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser.prototype.init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lorg_yaml_model_YMap__sc_Seq__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext = (function(dialect, map, references, ctx) {
  this.dialect$1 = dialect;
  this.map$1 = map;
  this.references$1 = references;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser.prototype.library__p1__Lorg_yaml_model_YMapEntry__T = (function(e) {
  var this$1 = e.value$2;
  var x1 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Include$1;
  if ((x === x1)) {
    var this$2 = e.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
    var iv = this.ctx$1;
    return $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv)).text$3
  } else {
    $m_Lorg_yaml_model_YNode$();
    var node = e.value$2;
    var iv$1 = this.ctx$1;
    var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
    return $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$1, iv$1))
  }
});
function $as_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.parser.dialects.DialectsReferencesParser"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.parser.dialects.DialectsReferencesParser;", depth))
}
var $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser: 0
}, false, "amf.plugins.document.vocabularies.parser.dialects.DialectsReferencesParser", {
  Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectsReferencesParser;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.parentId$1 = null;
  this.name$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser.prototype = $c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser.prototype;
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser.prototype.productPrefix__T = (function() {
  return "DocumentsModelParser"
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser)) {
    var DocumentsModelParser$1 = $as_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser(x$1);
    var this$1 = this.map$1;
    var b = DocumentsModelParser$1.map$1;
    if (($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b) && (this.parentId$1 === DocumentsModelParser$1.parentId$1))) {
      return (this.name$1 === DocumentsModelParser$1.name$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.parentId$1;
      break
    }
    case 2: {
      return this.name$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser.prototype.parse__Lamf_plugins_document_vocabularies_model_domain_DocumentsModel = (function() {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.map$1);
  var this$3 = new $c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = (this.parentId$1 + "#/documents");
  var documentsMapping = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$3, value));
  var this$4 = this.ctx$1;
  var id = documentsMapping.id$1;
  var map = this.map$1;
  $f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__closedNode__T__T__Lorg_yaml_model_YMap__V(this$4, "documentsMapping", id, map);
  var map$1 = this.map$1;
  new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$1).parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("root", new $c_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser().init___Lamf_plugins_document_vocabularies_model_domain_DocumentsModel__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(documentsMapping, this.name$1, this.ctx$1));
  var map$2 = this.map$1;
  new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$2).parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("fragments", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser().init___Lamf_plugins_document_vocabularies_model_domain_DocumentsModel__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(documentsMapping, this.ctx$1));
  var map$3 = this.map$1;
  new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$3).parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("library", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser().init___Lamf_plugins_document_vocabularies_model_domain_DocumentsModel__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(documentsMapping, this.name$1, this.ctx$1));
  var map$4 = this.map$1;
  new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map$4).parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("options", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser().init___Lamf_plugins_document_vocabularies_model_domain_DocumentsModel__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(documentsMapping, this.ctx$1));
  return documentsMapping
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser.prototype.init___Lorg_yaml_model_YMap__T__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext = (function(map, parentId, name, ctx) {
  this.map$1 = map;
  this.parentId$1 = parentId;
  this.name$1 = name;
  this.ctx$1 = ctx;
  return this
});
function $as_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.parser.dialects.DocumentsModelParser"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.parser.dialects.DocumentsModelParser;", depth))
}
var $d_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser: 0
}, false, "amf.plugins.document.vocabularies.parser.dialects.DocumentsModelParser", {
  Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_dialects_DocumentsModelParser;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations() {
  $c_O.call(this);
  this.references$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations.prototype = $c_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations.prototype;
$c_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations.prototype.productPrefix__T = (function() {
  return "ReferenceDeclarations"
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations)) {
    var ReferenceDeclarations$1 = $as_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations(x$1);
    var x = this.references$1;
    var x$2 = ReferenceDeclarations$1.references$1;
    return ((x === null) ? (x$2 === null) : $f_sc_GenMapLike__equals__O__Z(x, x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations.prototype.$$plus$eq__T__Lamf_core_model_document_BaseUnit__V = (function(alias, unit) {
  this.references$1.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(alias, unit));
  if ((unit instanceof $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_document_Vocabulary(unit);
    this.ctx$1.declarations$2.registerUsedVocabulary__T__Lamf_plugins_document_vocabularies_model_document_Vocabulary__V(alias, x2);
    var library = this.ctx$1.declarations$2.getOrCreateLibrary__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations(alias);
    $as_sc_Seq(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Declares$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, library$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_model_domain_DomainElement(x0$1$2);
        if ((x0$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm)) {
          var x2$1 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm(x0$1);
          library$1.registerTerm__Lamf_plugins_document_vocabularies_model_domain_PropertyTerm__V(x2$1)
        } else if ((x0$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm)) {
          var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_ClassTerm(x0$1);
          library$1.registerTerm__Lamf_plugins_document_vocabularies_model_domain_ClassTerm__V(x3)
        } else {
          throw new $c_s_MatchError().init___O(x0$1)
        }
      })
    })(this, library)))
  } else if ($is_Lamf_core_model_document_DeclaresModel(unit)) {
    var library$2 = this.ctx$1.declarations$2.getOrCreateLibrary__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations(alias);
    $as_Lamf_core_model_document_DeclaresModel(unit).declares__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, library$2$1) {
      return (function(x0$2$2) {
        var x0$2 = $as_Lamf_core_model_domain_DomainElement(x0$2$2);
        if ($is_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x0$2)) {
          var x2$2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x0$2);
          return library$2$1.registerNodeMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations(x2$2)
        } else {
          return library$2$1.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_core_parser_Declarations(x0$2)
        }
      })
    })(this, library$2)))
  } else if ((unit instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectFragment)) {
    var x4 = $as_Lamf_plugins_document_vocabularies_model_document_DialectFragment(unit);
    var jsx$2 = this.ctx$1.declarations$2;
    var jsx$1 = this.ctx$1.declarations$2.fragments$1;
    var y = new $c_Lamf_core_parser_FragmentRef().init___Lamf_core_model_domain_DomainElement__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Encodes$1)), $f_Lamf_core_model_document_BaseUnit__location__s_Option(x4));
    jsx$2.fragments$1 = jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(alias, y))
  } else if ((unit instanceof $c_Lamf_core_model_document_RecursiveUnit)) {
    var x5 = $as_Lamf_core_model_document_RecursiveUnit(unit);
    this.ctx$1.recursiveDeclarations$2 = this.ctx$1.recursiveDeclarations$2.updated__O__O__sci_Map(alias, x5)
  } else {
    throw new $c_s_MatchError().init___O(unit)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations.prototype.init___scm_Map__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext = (function(references, ctx) {
  this.references$1 = references;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations.prototype.baseUnitReferences__sc_Seq = (function() {
  return $as_sc_SetLike(this.references$1.values__sc_Iterable().toSet__sci_Set().filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$8$2) {
      return $is_Lamf_core_model_document_BaseUnit(x$8$2)
    })
  })(this)))).toSeq__sc_Seq()
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations.prototype.$$plus$eq__Lamf_plugins_document_vocabularies_model_domain_External__V = (function(external) {
  var jsx$1 = this.references$1;
  var this$1 = $as_Lamf_core_model_StrField(external.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().DisplayName$1));
  var this$2 = this$1.option$1;
  var self = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  jsx$1.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(self, external));
  var jsx$3 = this.ctx$1.declarations$2;
  var jsx$2 = this.ctx$1.declarations$2.externals$2;
  var this$5 = $as_Lamf_core_model_StrField(external.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().DisplayName$1));
  var this$6 = this$5.option$1;
  var self$1 = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
  jsx$3.externals$2 = jsx$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$1, external))
});
function $as_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.parser.dialects.ReferenceDeclarations"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.parser.dialects.ReferenceDeclarations;", depth))
}
var $d_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations: 0
}, false, "amf.plugins.document.vocabularies.parser.dialects.ReferenceDeclarations", {
  Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_dialects_ReferenceDeclarations;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser() {
  $c_O.call(this);
  this.dialectInstance$1 = null;
  this.map$1 = null;
  this.references$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser.prototype.productPrefix__T = (function() {
  return "DialectInstanceReferencesParser"
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser)) {
    var DialectInstanceReferencesParser$1 = $as_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser(x$1);
    var x = this.dialectInstance$1;
    var x$2 = DialectInstanceReferencesParser$1.dialectInstance$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var this$1 = this.map$1;
      var b = DialectInstanceReferencesParser$1.map$1;
      var jsx$1 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.references$1;
      var x$4 = DialectInstanceReferencesParser$1.references$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.dialectInstance$1;
      break
    }
    case 1: {
      return this.map$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser.prototype.parseExternalEntry__p1__Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations__Lorg_yaml_model_YMapEntry__V = (function(result, entry) {
  var this$1 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$1;
  $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, result$1) {
    return (function(e$2) {
      var e = $as_Lorg_yaml_model_YMapEntry(e$2);
      var this$2 = e.key$2;
      var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$1 = $this.ctx$1;
      var alias = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$1, iv$1)).text$3;
      $m_Lorg_yaml_model_YNode$();
      var node = e.value$2;
      var iv$2 = $this.ctx$1;
      var conversion$2 = $m_Lorg_yaml_convert_YRead$StringYRead$();
      var base = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$2, iv$2));
      $m_Lamf_core_parser_Annotations$();
      var annotations = new $c_Lamf_core_parser_Annotations().init___();
      var external = new $c_Lamf_plugins_document_vocabularies_model_domain_External().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
      var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().DisplayName$1;
      var this$7 = $as_Lamf_plugins_document_vocabularies_model_domain_External($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(external, field, alias));
      var field$1 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().Base$1;
      result$1.$$plus$eq__Lamf_plugins_document_vocabularies_model_domain_External__V($as_Lamf_plugins_document_vocabularies_model_domain_External($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$7, field$1, base)))
    })
  })(this, result)))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser.prototype.parseLibraries__p1__Lamf_core_model_document_BaseUnit__Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations__T__V = (function(dialectInstance, result, id) {
  var parsedLibraries = $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("uses");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.key$2).find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    if (this$4.isEmpty__Z()) {
      var this$5 = $m_s_None$()
    } else {
      var arg1$1 = this$4.get__O();
      var x$2 = $as_Lamf_core_annotations_LexicalInformation(arg1$1);
      var this$5 = new $c_s_Some().init___O(x$2.range__Lamf_core_parser_Range().start$1.line$1)
    };
    var annotation = new $c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation().init___I($uI((this$5.isEmpty__Z() ? 0 : this$5.get__O())));
    dialectInstance.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(annotation);
    var this$6 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$1;
    $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, parsedLibraries$1, dialectInstance$1, result$2, id$1) {
      return (function(e$2) {
        var e = $as_Lorg_yaml_model_YMapEntry(e$2);
        var this$7 = e.key$2;
        var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
        var iv$1 = this$3$1.ctx$1;
        var alias = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$7, conversion$1, iv$1)).text$3;
        var url = this$3$1.library__p1__Lorg_yaml_model_YMapEntry__T(e);
        var this$8 = this$3$1.target__p1__T__s_Option(url);
        if ((!this$8.isEmpty__Z())) {
          var arg1$2 = this$8.get__O();
          var x0$1 = $as_Lamf_core_model_document_BaseUnit(arg1$2);
          if ($is_Lamf_core_model_document_DeclaresModel(x0$1)) {
            parsedLibraries$1.$$plus$eq__O__scm_SetLike(url);
            var y = new $c_T2().init___O__O(x0$1.id__T(), url);
            this$3$1.collectAlias__p1__Lamf_core_model_document_BaseUnit__T2__Lamf_core_model_document_BaseUnit(dialectInstance$1, new $c_T2().init___O__O(alias, y));
            result$2.$$plus$eq__T__Lamf_core_model_document_BaseUnit__V(alias, x0$1)
          } else {
            var this$11 = this$3$1.ctx$1.eh$1;
            var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
            var message = (("Expected vocabulary module but found: '" + x0$1) + "'");
            var prop = $m_s_None$();
            var l = e.location$1;
            $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$11, specification, id$1, prop, message, l)
          }
        }
      })
    })(this, parsedLibraries, dialectInstance, result, id)))
  };
  this.references$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, parsedLibraries$2, result$1) {
    return (function(x0$2$2) {
      var x0$2 = $as_Lamf_core_parser_ParsedReference(x0$2$2);
      matchEnd6: {
        if ((x0$2 !== null)) {
          var lib = x0$2.unit$1;
          if ((lib instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary)) {
            var x4 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary(lib);
            var this$12 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(x4);
            if ((!parsedLibraries$2.contains__O__Z((this$12.isEmpty__Z() ? x4.id$1 : this$12.get__O())))) {
              result$1.$$plus$eq__T__Lamf_core_model_document_BaseUnit__V(x4.id$1, x4);
              break matchEnd6
            }
          }
        }
      }
    })
  })(this, parsedLibraries, result)))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser.prototype.parse__T__Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations = (function(location) {
  var result = new $c_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations().init___scm_Map__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext($as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.ctx$1);
  this.parseLibraries__p1__Lamf_core_model_document_BaseUnit__Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations__T__V(this.dialectInstance$1, result, location);
  this.parseExternals__p1__Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations__T__V(result, location);
  this.references$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, result$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_parser_ParsedReference(x0$1$2);
      matchEnd7: {
        if ((x0$1 !== null)) {
          var f = x0$1.unit$1;
          var origin = x0$1.origin$1;
          var p2 = x0$1.ast$1;
          if ((f instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment)) {
            var x3 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment(f);
            if ((origin !== null)) {
              var x = $m_s_None$();
              if ((x === p2)) {
                result$1.$$plus$eq__T__Lamf_core_model_document_BaseUnit__V(origin.url$1, x3);
                break matchEnd7
              }
            }
          }
        }
      }
    })
  })(this, result)));
  if (this.ctx$1.isPatch$2) {
    this.references$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, result$2) {
      return (function(x0$2$2) {
        var x0$2 = $as_Lamf_core_parser_ParsedReference(x0$2$2);
        matchEnd7$1: {
          if ((x0$2 !== null)) {
            var f$1 = x0$2.unit$1;
            var origin$1 = x0$2.origin$1;
            var p2$1 = x0$2.ast$1;
            if ((f$1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstance)) {
              var x3$1 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstance(f$1);
              if ((origin$1 !== null)) {
                var x$1 = $m_s_None$();
                if ((x$1 === p2$1)) {
                  result$2.$$plus$eq__T__Lamf_core_model_document_BaseUnit__V(origin$1.url$1, x3$1);
                  break matchEnd7$1
                }
              }
            }
          }
        }
      })
    })(this, result)))
  };
  return result
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser.prototype.target__p1__T__s_Option = (function(url) {
  var this$2 = this.references$1.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, url$1) {
    return (function(r$2) {
      var r = $as_Lamf_core_parser_ParsedReference(r$2);
      var this$1 = r.origin$1.url$1;
      return (this$1 === url$1)
    })
  })(this, url)));
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var x$1 = $as_Lamf_core_parser_ParsedReference(arg1);
    return new $c_s_Some().init___O(x$1.unit$1)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser.prototype.collectAlias__p1__Lamf_core_model_document_BaseUnit__T2__Lamf_core_model_document_BaseUnit = (function(aliasCollectorUnit, alias) {
  var x1 = aliasCollectorUnit.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_Aliases.getClassOf());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var aliases = $as_Lamf_core_annotations_Aliases(x2.value$2);
    aliasCollectorUnit.annotations__Lamf_core_parser_Annotations().reject__F1__Lamf_core_parser_Annotations(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$3$2) {
        var x$3 = $as_Lamf_core_model_domain_Annotation(x$3$2);
        return (x$3 instanceof $c_Lamf_core_annotations_Aliases)
      })
    })(this)));
    var aliases$1 = $as_sci_Set(aliases.aliases$1.$$plus__O__sc_Set(alias));
    var annotation = new $c_Lamf_core_annotations_Aliases().init___sci_Set(aliases$1);
    return $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(aliasCollectorUnit, annotation))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var array = [alias];
      if (($uI(array.length) === 0)) {
        var jsx$1 = $m_sci_Set$EmptySet$()
      } else {
        var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
        var i = 0;
        var len = $uI(array.length);
        while ((i < len)) {
          var index = i;
          var arg1 = array[index];
          b.$$plus$eq__O__scm_SetBuilder(arg1);
          i = ((1 + i) | 0)
        };
        var jsx$1 = b.elems$1
      };
      var annotation$1 = new $c_Lamf_core_annotations_Aliases().init___sci_Set($as_sci_Set(jsx$1));
      return $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(aliasCollectorUnit, annotation$1))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser.prototype.init___Lamf_core_model_document_BaseUnit__Lorg_yaml_model_YMap__sc_Seq__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext = (function(dialectInstance, map, references, ctx) {
  this.dialectInstance$1 = dialectInstance;
  this.map$1 = map;
  this.references$1 = references;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser.prototype.parseExternals__p1__Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations__T__V = (function(result, id) {
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("external");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    this.parseExternalEntry__p1__Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations__Lorg_yaml_model_YMapEntry__V(result, entry)
  };
  var map$1 = this.map$1;
  var this$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var this$6 = this$5.key__T__s_Option("$external");
  if ((!this$6.isEmpty__Z())) {
    var arg1$1 = this$6.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    this.parseExternalEntry__p1__Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations__Lorg_yaml_model_YMapEntry__V(result, entry$3)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser.prototype.library__p1__Lorg_yaml_model_YMapEntry__T = (function(e) {
  var this$1 = e.value$2;
  var x1 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Include$1;
  if ((x === x1)) {
    var this$2 = e.value$2;
    var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv = this.ctx$1;
    return $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv)).text$3
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x$3 === x1)) {
      var this$3 = e.value$2;
      var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv$1 = this.ctx$1;
      var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion$1, iv$1));
      var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("$include").isDefined__Z()
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var this$5 = e.value$2;
      var conversion$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv$2 = this.ctx$1;
      var map$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion$2, iv$2));
      var this$7 = $as_Lorg_yaml_model_YMapEntry(new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option("$include").get__O()).value$2;
      var conversion$3 = $m_Lorg_yaml_convert_YRead$StringYRead$();
      var iv$3 = this.ctx$1;
      return $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$7, conversion$3, iv$3))
    } else {
      $m_Lorg_yaml_model_YNode$();
      var node = e.value$2;
      var iv$4 = this.ctx$1;
      var conversion$4 = $m_Lorg_yaml_convert_YRead$StringYRead$();
      return $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$4, iv$4))
    }
  }
});
function $as_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceReferencesParser"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.parser.instances.DialectInstanceReferencesParser;", depth))
}
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceReferencesParser", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations() {
  $c_O.call(this);
  this.references$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations.prototype.productPrefix__T = (function() {
  return "ReferenceDeclarations"
});
$c_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations)) {
    var ReferenceDeclarations$1 = $as_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations(x$1);
    var x = this.references$1;
    var x$2 = ReferenceDeclarations$1.references$1;
    return ((x === null) ? (x$2 === null) : $f_sc_GenMapLike__equals__O__Z(x, x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations.prototype.$$plus$eq__T__Lamf_core_model_document_BaseUnit__V = (function(alias, unit) {
  this.references$1.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(alias, unit));
  if ((unit instanceof $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_document_Vocabulary(unit);
    this.ctx$1.declarations$2.registerUsedVocabulary__T__Lamf_plugins_document_vocabularies_model_document_Vocabulary__V(alias, x2)
  };
  if ($is_Lamf_core_model_document_DeclaresModel(unit)) {
    var library = this.ctx$1.declarations$2.getOrCreateLibrary__T__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations(alias);
    $as_Lamf_core_model_document_DeclaresModel(unit).declares__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, library$1, alias$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_model_domain_DomainElement(x0$1$2);
        if ((x0$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
          var x2$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x0$1);
          var localName = x2$1.localRefName__T();
          library$1.registerDialectDomainElement__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations(localName, x2$1);
          var this$3 = $this.ctx$1.futureDeclarations$1;
          var name = ((alias$1 + ".") + localName);
          $f_Lamf_core_parser_FutureDeclarations__resolveRef__T__Lamf_core_model_domain_Linkable__V(this$3, name, x2$1);
          return (void 0)
        } else {
          return library$1.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_core_parser_Declarations(x0$1)
        }
      })
    })(this, library, alias)))
  } else if ((unit instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment)) {
    var x3 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment(unit);
    var jsx$2 = this.ctx$1.declarations$2;
    var jsx$1 = this.ctx$1.declarations$2.fragments$1;
    var y = new $c_Lamf_core_parser_FragmentRef().init___Lamf_core_model_domain_DomainElement__s_Option($as_Lamf_core_model_domain_DomainElement(x3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().Encodes$1)), $f_Lamf_core_model_document_BaseUnit__location__s_Option(x3));
    jsx$2.fragments$1 = jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(alias, y))
  } else {
    throw new $c_s_MatchError().init___O(unit)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations.prototype.init___scm_Map__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext = (function(references, ctx) {
  this.references$1 = references;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations.prototype.baseUnitReferences__sc_Seq = (function() {
  return $as_sc_SetLike(this.references$1.values__sc_Iterable().toSet__sci_Set().filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      return $is_Lamf_core_model_document_BaseUnit(x$1$2)
    })
  })(this)))).toSeq__sc_Seq()
});
$c_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations.prototype.$$plus$eq__Lamf_plugins_document_vocabularies_model_domain_External__V = (function(external) {
  var jsx$1 = this.references$1;
  var this$1 = $as_Lamf_core_model_StrField(external.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().DisplayName$1));
  var this$2 = this$1.option$1;
  var self = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  jsx$1.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(self, external));
  var jsx$3 = this.ctx$1.declarations$2;
  var jsx$2 = this.ctx$1.declarations$2.externals$2;
  var this$5 = $as_Lamf_core_model_StrField(external.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().DisplayName$1));
  var this$6 = this$5.option$1;
  var self$1 = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
  jsx$3.externals$2 = jsx$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$1, external))
});
function $as_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.parser.instances.ReferenceDeclarations"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.parser.instances.ReferenceDeclarations;", depth))
}
var $d_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.ReferenceDeclarations", {
  Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations() {
  $c_O.call(this);
  this.references$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations.prototype = $c_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations.prototype;
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations.prototype.productPrefix__T = (function() {
  return "ReferenceDeclarations"
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations.prototype.init___scm_Map__Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext = (function(references, ctx) {
  this.references$1 = references;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations)) {
    var ReferenceDeclarations$1 = $as_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations(x$1);
    var x = this.references$1;
    var x$2 = ReferenceDeclarations$1.references$1;
    return ((x === null) ? (x$2 === null) : $f_sc_GenMapLike__equals__O__Z(x, x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations.prototype.$$plus$eq__T__Lamf_core_model_document_BaseUnit__V = (function(alias, unit) {
  this.references$1.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(alias, unit));
  var library = this.ctx$1.declarations$2.getOrCreateLibrary__T__Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations(alias);
  if ((unit instanceof $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_document_Vocabulary(unit);
    this.ctx$1.registerVocabulary__T__Lamf_plugins_document_vocabularies_model_document_Vocabulary__V(alias, x2);
    $as_sc_Seq(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Declares$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, library$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_model_domain_DomainElement(x0$1$2);
        if ((x0$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm)) {
          var x2$1 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm(x0$1);
          library$1.registerTerm__Lamf_plugins_document_vocabularies_model_domain_PropertyTerm__V(x2$1)
        } else if ((x0$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm)) {
          var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_ClassTerm(x0$1);
          library$1.registerTerm__Lamf_plugins_document_vocabularies_model_domain_ClassTerm__V(x3)
        } else {
          throw new $c_s_MatchError().init___O(x0$1)
        }
      })
    })(this, library)))
  } else {
    throw new $c_s_MatchError().init___O(unit)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations.prototype.baseUnitReferences__sc_Seq = (function() {
  return $as_sc_SetLike(this.references$1.values__sc_Iterable().toSet__sci_Set().filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      return $is_Lamf_core_model_document_BaseUnit(x$1$2)
    })
  })(this)))).toSeq__sc_Seq()
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations.prototype.$$plus$eq__Lamf_plugins_document_vocabularies_model_domain_External__V = (function(external) {
  var jsx$1 = this.references$1;
  var this$1 = $as_Lamf_core_model_StrField(external.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().DisplayName$1));
  var this$2 = this$1.option$1;
  var self = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  jsx$1.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(self, external));
  var jsx$3 = this.ctx$1.declarations$2;
  var jsx$2 = this.ctx$1.declarations$2.externals$2;
  var this$5 = $as_Lamf_core_model_StrField(external.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().DisplayName$1));
  var this$6 = this$5.option$1;
  var self$1 = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
  jsx$3.externals$2 = jsx$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$1, external))
});
function $as_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.parser.vocabularies.ReferenceDeclarations"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.parser.vocabularies.ReferenceDeclarations;", depth))
}
var $d_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations: 0
}, false, "amf.plugins.document.vocabularies.parser.vocabularies.ReferenceDeclarations", {
  Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.references$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser.prototype = $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser.prototype;
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser.prototype.productPrefix__T = (function() {
  return "VocabulariesReferencesParser"
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser)) {
    var VocabulariesReferencesParser$1 = $as_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser(x$1);
    var this$1 = this.map$1;
    var b = VocabulariesReferencesParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.references$1;
      var x$2 = VocabulariesReferencesParser$1.references$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser.prototype.parseExternals__p1__Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations__T__V = (function(result, id) {
  var map = this.map$1;
  var this$2 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("external");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$1;
    $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, result$2) {
      return (function(e$2) {
        var e = $as_Lorg_yaml_model_YMapEntry(e$2);
        var this$5 = e.key$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
        var iv$1 = $this.ctx$1;
        var alias = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion$1, iv$1)).text$3;
        var this$6 = e.value$2;
        var conversion$2 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
        var iv$2 = $this.ctx$1;
        var base = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion$2, iv$2)).text$3;
        $m_Lamf_core_parser_Annotations$();
        var annotations = new $c_Lamf_core_parser_Annotations().init___();
        var external = new $c_Lamf_plugins_document_vocabularies_model_domain_External().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
        var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().DisplayName$1;
        var this$10 = $as_Lamf_plugins_document_vocabularies_model_domain_External($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(external, field, alias));
        var field$1 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().Base$1;
        result$2.$$plus$eq__Lamf_plugins_document_vocabularies_model_domain_External__V($as_Lamf_plugins_document_vocabularies_model_domain_External($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$10, field$1, base)))
      })
    })(this, result)))
  }
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser.prototype.parseLibraries__p1__Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations__T__V = (function(result, id) {
  var map = this.map$1;
  var this$2 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("uses");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$1;
    $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, result$1, id$1) {
      return (function(e$2) {
        var e = $as_Lorg_yaml_model_YMapEntry(e$2);
        var this$5 = e.key$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
        var iv$1 = $this.ctx$1;
        var alias = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion$1, iv$1)).text$3;
        var this$6 = e.value$2;
        var conversion$2 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
        var iv$2 = $this.ctx$1;
        var url = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion$2, iv$2)).text$3;
        var this$7 = $this.target__p1__T__s_Option(url);
        if ((!this$7.isEmpty__Z())) {
          var arg1$1 = this$7.get__O();
          var x0$1 = $as_Lamf_core_model_document_BaseUnit(arg1$1);
          if ($is_Lamf_core_model_document_DeclaresModel(x0$1)) {
            var y = new $c_T2().init___O__O(x0$1.id__T(), url);
            result$1.$$plus$eq__T__Lamf_core_model_document_BaseUnit__V(alias, $this.collectAlias__p1__Lamf_core_model_document_BaseUnit__T2__Lamf_core_model_document_BaseUnit(x0$1, new $c_T2().init___O__O(alias, y)))
          } else {
            var this$10 = $this.ctx$1.eh$1;
            var specification = $m_Lamf_validation_DialectValidations$().ExpectedVocabularyModule$1;
            var message = ("Expected vocabulary module but found: " + x0$1);
            var prop = $m_s_None$();
            var l = e.location$1;
            $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$10, specification, id$1, prop, message, l)
          }
        }
      })
    })(this, result, id)))
  }
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser.prototype.init___Lorg_yaml_model_YMap__sc_Seq__Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext = (function(map, references, ctx) {
  this.map$1 = map;
  this.references$1 = references;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser.prototype.parse__T__Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations = (function(location) {
  var result = new $c_Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations().init___scm_Map__Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext($as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.ctx$1);
  this.parseLibraries__p1__Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations__T__V(result, location);
  this.parseExternals__p1__Lamf_plugins_document_vocabularies_parser_vocabularies_ReferenceDeclarations__T__V(result, location);
  return result
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser.prototype.target__p1__T__s_Option = (function(url) {
  var this$2 = this.references$1.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, url$1) {
    return (function(r$2) {
      var r = $as_Lamf_core_parser_ParsedReference(r$2);
      var this$1 = r.origin$1.url$1;
      return (this$1 === url$1)
    })
  })(this, url)));
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var x$1 = $as_Lamf_core_parser_ParsedReference(arg1);
    return new $c_s_Some().init___O(x$1.unit$1)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser.prototype.collectAlias__p1__Lamf_core_model_document_BaseUnit__T2__Lamf_core_model_document_BaseUnit = (function(module, alias) {
  var x1 = module.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_Aliases.getClassOf());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var aliases = $as_Lamf_core_annotations_Aliases(x2.value$2);
    module.annotations__Lamf_core_parser_Annotations().reject__F1__Lamf_core_parser_Annotations(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$2$2) {
        var x$2 = $as_Lamf_core_model_domain_Annotation(x$2$2);
        return (x$2 instanceof $c_Lamf_core_annotations_Aliases)
      })
    })(this)));
    var aliases$1 = $as_sci_Set(aliases.aliases$1.$$plus__O__sc_Set(alias));
    var annotation = new $c_Lamf_core_annotations_Aliases().init___sci_Set(aliases$1);
    return $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(module, annotation))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var array = [alias];
      if (($uI(array.length) === 0)) {
        var jsx$1 = $m_sci_Set$EmptySet$()
      } else {
        var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
        var i = 0;
        var len = $uI(array.length);
        while ((i < len)) {
          var index = i;
          var arg1 = array[index];
          b.$$plus$eq__O__scm_SetBuilder(arg1);
          i = ((1 + i) | 0)
        };
        var jsx$1 = b.elems$1
      };
      var annotation$1 = new $c_Lamf_core_annotations_Aliases().init___sci_Set($as_sci_Set(jsx$1));
      return $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(module, annotation$1))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.parser.vocabularies.VocabulariesReferencesParser"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.parser.vocabularies.VocabulariesReferencesParser;", depth))
}
var $d_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser: 0
}, false, "amf.plugins.document.vocabularies.parser.vocabularies.VocabulariesReferencesParser", {
  Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesReferencesParser;
function $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__modelEntities__sc_Seq($thiz) {
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_document_webapi_metamodel_ExtensionModel$(), $m_Lamf_plugins_document_webapi_metamodel_OverlayModel$(), $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$(), $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$(), $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$(), $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$(), $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$(), $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$(), $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$()];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
}
function $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__$$init$__V($thiz) {
  $thiz.amf$plugins$document$webapi$BaseWebApiPlugin$$undsetter$und$ID$und$eq__T__V($thiz.vendor__Lamf_core_remote_Vendor().name__T());
  $thiz.amf$plugins$document$webapi$BaseWebApiPlugin$$undsetter$und$allowRecursiveReferences$und$eq__Z__V(false)
}
function $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__dependencies__sc_Seq($thiz) {
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_domain_webapi_WebAPIDomainPlugin$(), $m_Lamf_plugins_domain_shapes_DataShapesDomainPlugin$(), $m_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin$()];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
}
function $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__validationRequest__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_validation_EffectiveValidations__Lamf_core_remote_Platform__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future($thiz, baseUnit, profile, validations, platform, env, resolved, executionEnv) {
  var this$1 = $thiz.validationProfile__Lamf_ProfileName();
  var messageStyle = this$1.amf$ProfileName$$m$1;
  return $f_Lamf_plugins_document_webapi_validation_WebApiValidations__validationRequestsForBaseUnit__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_validation_EffectiveValidations__Lamf_MessageStyle__Lamf_core_remote_Platform__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future($thiz, baseUnit, profile, validations, messageStyle, platform, env, resolved, executionEnv)
}
function $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__serializableAnnotations__sci_Map($thiz) {
  var y = $m_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema$();
  var jsx$11 = new $c_T2().init___O__O("parsed-json-schema", y);
  var y$1 = $m_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype$();
  var jsx$10 = new $c_T2().init___O__O("parsed-raml-datatype", y$1);
  var y$2 = $m_Lamf_core_annotations_ExternalFragmentRef$();
  var jsx$9 = new $c_T2().init___O__O("external-fragment-ref", y$2);
  var y$3 = $m_Lamf_plugins_document_webapi_annotations_JSONSchemaId$();
  var jsx$8 = new $c_T2().init___O__O("json-schema-id", y$3);
  var y$4 = $m_Lamf_core_annotations_DeclaredElement$();
  var jsx$7 = new $c_T2().init___O__O("declared-element", y$4);
  var y$5 = $m_Lamf_core_annotations_InlineElement$();
  var jsx$6 = new $c_T2().init___O__O("inline-element", y$5);
  var y$6 = $m_Lamf_plugins_document_webapi_annotations_LocalLinkPath$();
  var jsx$5 = new $c_T2().init___O__O("local-link-path", y$6);
  var y$7 = $m_Lamf_plugins_document_webapi_annotations_ExtensionProvenance$();
  var jsx$4 = new $c_T2().init___O__O("extension-provenance", y$7);
  var y$8 = $m_Lamf_plugins_document_webapi_annotations_FormBodyParameter$();
  var jsx$3 = new $c_T2().init___O__O("form-body-parameter", y$8);
  var y$9 = $m_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload$();
  var jsx$2 = new $c_T2().init___O__O("parameter-name-for-payload", y$9);
  var y$10 = $m_Lamf_plugins_document_webapi_annotations_RequiredParamPayload$();
  var jsx$1 = new $c_T2().init___O__O("required-param-payload", y$10);
  var y$11 = $m_Lamf_core_annotations_AutoGeneratedName$();
  var array = [jsx$11, jsx$10, jsx$9, jsx$8, jsx$7, jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, jsx$1, new $c_T2().init___O__O("auto-generated-name", y$11)];
  var this$28 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$28.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  return $as_sci_Map(this$28.elems$1)
}
function $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__resolve__Lamf_core_model_document_BaseUnit__Lamf_core_errorhandling_ErrorHandler__T__Lamf_core_model_document_BaseUnit($thiz, unit, errorHandler, pipelineId) {
  var specification = $m_Lamf_validations_ResolutionSideValidations$().UnsupportedPipeline$1;
  var node = (((("Unsupported '" + pipelineId) + "' on ") + $thiz.ID__T()) + " plugin");
  var this$1 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(unit);
  var message = $as_T((this$1.isEmpty__Z() ? unit.id__T() : this$1.get__O()));
  var property = $m_s_None$();
  var lexical = $m_s_None$();
  var location = $m_s_None$();
  errorHandler.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
  return unit
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin() {
  $c_Lamf_plugins_document_webapi_JsonSchemaPlugin.call(this);
  this.priority$3 = 0;
  this.ID$3 = null;
  this.vendors$3 = null;
  this.allowRecursiveReferences$3 = false
}
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.prototype = new $h_Lamf_plugins_document_webapi_JsonSchemaPlugin();
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.prototype.constructor = $c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin;
/** @constructor */
function $h_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.prototype = $c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.prototype;
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.init___.call(this);
  this.priority$3 = $m_Lamf_client_plugins_AMFDocumentPluginSettings$PluginPriorities$().low$1;
  this.ID$3 = "JSON + Refs";
  var jsx$1 = $m_sc_Seq$();
  var array = [this.ID$3];
  this.vendors$3 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  this.allowRecursiveReferences$3 = true;
  return this
});
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.prototype.init__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  return $m_s_concurrent_Future$().successful__O__s_concurrent_Future(this)
});
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.prototype.modelEntities__sc_Seq = (function() {
  return $m_sci_Nil$()
});
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.prototype.parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option = (function(document, ctx, platform, options) {
  var x1 = document.parsed$1;
  if ((x1 instanceof $c_Lamf_core_parser_SyamlParsedDocument)) {
    var x2 = $as_Lamf_core_parser_SyamlParsedDocument(x1);
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var this$4 = new $c_Lamf_core_model_domain_ExternalDomainElement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
    var value = (document.location$1 + "#/");
    var this$5 = $as_Lamf_core_model_domain_ExternalDomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value));
    var text = document.raw$1;
    var field = $m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1;
    var this$6 = $as_Lamf_core_model_domain_ExternalDomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$5, field, text));
    var mediaType = this.docMediaType__p3__Lamf_core_Root__T(document);
    var field$1 = $m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().MediaType$1;
    var result = $as_Lamf_core_model_domain_ExternalDomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$6, field$1, mediaType));
    result.parsed$1 = new $c_s_Some().init___O(x2.document$2.node$2);
    var jsx$2 = document.references$1;
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$2$2) {
        var x$2 = $as_Lamf_core_parser_ParsedReference(x$2$2);
        return x$2.unit$1
      })
    })(this));
    var this$7 = $m_sc_Seq$();
    var references = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
    $m_Lamf_core_parser_Annotations$();
    var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
    var this$11 = new $c_Lamf_core_model_document_ExternalFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
    var location = document.location$1;
    var field$2 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
    var this$12 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$11, field$2, location));
    var value$1 = document.location$1;
    var this$13 = $as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$12, value$1));
    var field$3 = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
    var this$14 = $as_Lamf_core_model_document_BaseUnit($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$13, field$3, result)));
    var location$1 = document.location$1;
    var field$4 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
    var fragment = $as_Lamf_core_model_document_ExternalFragment($as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$14, field$4, location$1)));
    if (references.nonEmpty__Z()) {
      var field$5 = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
      $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(fragment, field$5, references))
    };
    return new $c_s_Some().init___O(fragment)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.prototype.documentSyntaxes__sc_Seq = (function() {
  var jsx$1 = $m_sc_Seq$();
  var array = ["application/json", "application/yaml"];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.prototype.priority__I = (function() {
  return this.priority$3
});
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.prototype.vendors__sc_Seq = (function() {
  return this.vendors$3
});
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.prototype.referenceHandler__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_ReferenceHandler = (function(eh) {
  return new $c_Lamf_plugins_document_webapi_JsonRefsReferenceHandler().init___()
});
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.prototype.ID__T = (function() {
  return this.ID$3
});
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.prototype.dependencies__sc_Seq = (function() {
  return $m_sci_Nil$()
});
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.prototype.canParse__Lamf_core_Root__Z = (function(document) {
  var jsx$1 = $m_Lamf_core_utils_package$MediaTypeMatcher$();
  var content = document.raw$1;
  return (!jsx$1.isXml$extension__T__Z(content))
});
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.prototype.docMediaType__p3__Lamf_core_Root__T = (function(doc) {
  var jsx$1 = $m_Lamf_core_utils_package$MediaTypeMatcher$();
  var content = doc.raw$1;
  if (jsx$1.isJson$extension__T__Z(content)) {
    return "application/json"
  } else {
    return "application/yaml"
  }
});
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.prototype.allowRecursiveReferences__Z = (function() {
  return this.allowRecursiveReferences$3
});
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.prototype.serializableAnnotations__sci_Map = (function() {
  return $m_sci_Map$EmptyMap$()
});
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_errorhandling_ErrorHandler__T__Lamf_core_model_document_BaseUnit = (function(unit, errorHandler, pipelineId) {
  return unit
});
var $d_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin = new $TypeData().initClass({
  Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin: 0
}, false, "amf.plugins.document.webapi.ExternalJsonYamlRefsPlugin", {
  Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin: 1,
  Lamf_plugins_document_webapi_JsonSchemaPlugin: 1,
  Lamf_client_plugins_AMFDocumentPlugin: 1,
  O: 1,
  Lamf_client_plugins_AMFPlugin: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.prototype.$classData = $d_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin;
/** @constructor */
function $c_Lamf_plugins_document_webapi_JsonSchemaPlugin$() {
  $c_Lamf_plugins_document_webapi_JsonSchemaPlugin.call(this)
}
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin$.prototype = new $h_Lamf_plugins_document_webapi_JsonSchemaPlugin();
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin$.prototype.constructor = $c_Lamf_plugins_document_webapi_JsonSchemaPlugin$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_JsonSchemaPlugin$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_JsonSchemaPlugin$.prototype = $c_Lamf_plugins_document_webapi_JsonSchemaPlugin$.prototype;
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_JsonSchemaPlugin.prototype.init___.call(this);
  return this
});
var $d_Lamf_plugins_document_webapi_JsonSchemaPlugin$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_JsonSchemaPlugin$: 0
}, false, "amf.plugins.document.webapi.JsonSchemaPlugin$", {
  Lamf_plugins_document_webapi_JsonSchemaPlugin$: 1,
  Lamf_plugins_document_webapi_JsonSchemaPlugin: 1,
  Lamf_client_plugins_AMFDocumentPlugin: 1,
  O: 1,
  Lamf_client_plugins_AMFPlugin: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin$.prototype.$classData = $d_Lamf_plugins_document_webapi_JsonSchemaPlugin$;
var $n_Lamf_plugins_document_webapi_JsonSchemaPlugin$ = (void 0);
function $m_Lamf_plugins_document_webapi_JsonSchemaPlugin$() {
  if ((!$n_Lamf_plugins_document_webapi_JsonSchemaPlugin$)) {
    $n_Lamf_plugins_document_webapi_JsonSchemaPlugin$ = new $c_Lamf_plugins_document_webapi_JsonSchemaPlugin$().init___()
  };
  return $n_Lamf_plugins_document_webapi_JsonSchemaPlugin$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue() {
  $c_O.call(this);
  this.pendingEmission$1 = null;
  this.queuedIdsWithLabel$1 = null;
  this.ctx$1 = null;
  this.counter$1 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue.prototype.productPrefix__T = (function() {
  return "DefinitionsQueue"
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue)) {
    var DefinitionsQueue$1 = $as_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue(x$1);
    var x = this.pendingEmission$1;
    var x$2 = DefinitionsQueue$1.pendingEmission$1;
    if (((x === null) ? (x$2 === null) : $f_sc_GenSeqLike__equals__O__Z(x, x$2))) {
      var x$3 = this.queuedIdsWithLabel$1;
      var x$4 = DefinitionsQueue$1.queuedIdsWithLabel$1;
      return ((x$3 === null) ? (x$4 === null) : $f_sc_GenMapLike__equals__O__Z(x$3, x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.pendingEmission$1;
      break
    }
    case 1: {
      return this.queuedIdsWithLabel$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue.prototype.createLabel__p1__Lamf_core_model_domain_Shape__T = (function(shape) {
  var name = this.normalizeName__s_Option__T($as_Lamf_core_model_StrField(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1);
  var this$1 = this.queuedIdsWithLabel$1.valuesIterator__sc_Iterator();
  if ($f_sc_Iterator__contains__O__Z(this$1, name)) {
    return this.counter$1.genId__T__T(name)
  } else {
    return name
  }
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue.prototype.enqueue__Lamf_core_model_domain_Shape__T = (function(shape) {
  var this$1 = this.queuedIdsWithLabel$1;
  var key = shape.id$1;
  var x1 = this$1.get__O__s_Option(key);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var v = x2.value$2;
    var jsx$1 = v
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var label = this.createLabel__p1__Lamf_core_model_domain_Shape__T(shape);
    var labeledShape = new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape().init___T__Lamf_core_model_domain_Shape(label, shape);
    this.pendingEmission$1.$$plus$eq__O__scm_MutableList(labeledShape);
    var jsx$2 = this.queuedIdsWithLabel$1;
    var self = labeledShape.shape$1.id$1;
    var y = labeledShape.label$1;
    jsx$2.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(self, y));
    var jsx$1 = labeledShape.label$1
  };
  return $as_T(jsx$1)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue.prototype.normalizeName__s_Option__T = (function(name) {
  if (name.isEmpty__Z()) {
    var jsx$1 = true
  } else {
    var arg1 = name.get__O();
    var s = $as_T(arg1);
    var jsx$1 = this.isValidName__p1__T__Z(s)
  };
  if (jsx$1) {
    var this$1 = name
  } else {
    var this$1 = $m_s_None$()
  };
  return $as_T((this$1.isEmpty__Z() ? "default" : this$1.get__O()))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue.prototype.init___scm_Queue__scm_Map__Lamf_plugins_document_webapi_contexts_emitter_oas_CompactEmissionContext = (function(pendingEmission, queuedIdsWithLabel, ctx) {
  this.pendingEmission$1 = pendingEmission;
  this.queuedIdsWithLabel$1 = queuedIdsWithLabel;
  this.ctx$1 = ctx;
  this.counter$1 = new $c_Lamf_core_utils_package$IdCounter().init___();
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue.prototype.isValidName__p1__T__Z = (function(s) {
  var this$1 = this.ctx$1.nameRegex__s_util_matching_Regex().pattern$1;
  return new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$1, s, 0, $uI(s.length)).matches__Z()
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.emitter.oas.DefinitionsQueue"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.emitter.oas.DefinitionsQueue;", depth))
}
var $d_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.oas.DefinitionsQueue", {
  Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_oas_DefinitionsQueue;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape() {
  $c_O.call(this);
  this.label$1 = null;
  this.shape$1 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape.prototype.productPrefix__T = (function() {
  return "LabeledShape"
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape)) {
    var LabeledShape$1 = $as_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape(x$1);
    if ((this.label$1 === LabeledShape$1.label$1)) {
      var x = this.shape$1;
      var x$2 = LabeledShape$1.shape$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.label$1;
      break
    }
    case 1: {
      return this.shape$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape.prototype.init___T__Lamf_core_model_domain_Shape = (function(label, shape) {
  this.label$1 = label;
  this.shape$1 = shape;
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.emitter.oas.LabeledShape"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.emitter.oas.LabeledShape;", depth))
}
var $d_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.oas.LabeledShape", {
  Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext() {
  $c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.call(this);
  this.schemaVersion$4 = null;
  this.factory$4 = null;
  this.vendor$4 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext();
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext.prototype.schemaVersion__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion = (function() {
  return this.schemaVersion$4
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext.prototype.factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory = (function() {
  return this.factory$4
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext.prototype.vendor__Lamf_core_remote_Vendor = (function() {
  return this.vendor$4
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions = (function(eh, refEmitter, options) {
  $c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions.call(this, eh, refEmitter, options);
  var eh$1 = this.eh$1;
  this.schemaVersion$4 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion().init___T__Lamf_core_errorhandling_ErrorHandler("schema", eh$1);
  this.factory$4 = new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory().init___Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this);
  this.vendor$4 = $m_Lamf_core_remote_Oas20$();
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext.prototype.factory__Lamf_plugins_document_webapi_contexts_SpecEmitterFactory = (function() {
  return this.factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory()
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext.prototype.factory__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory = (function() {
  return this.factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory()
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext.prototype.schemasDeclarationsPath__T = (function() {
  return "/definitions/"
});
var $d_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.oas.Oas2SpecEmitterContext", {
  Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_SpecEmitterContext: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_emitter_oas_CompactEmissionContext: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory() {
  $c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory.call(this);
  this.spec$3 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory.prototype = new $h_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory();
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory.prototype.init___Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(spec) {
  this.spec$3 = spec;
  $c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory.prototype.init___Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.call(this, spec);
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory.prototype.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function() {
  return this.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext()
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory.prototype.serversEmitter__Lamf_plugins_domain_webapi_models_Operation__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter = (function(operation, f, ordering, references) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter().init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(operation, f, ordering, references, this.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext())
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory.prototype.serversEmitter__Lamf_plugins_domain_webapi_models_WebApi__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter = (function(api, f, ordering, references) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter().init___Lamf_plugins_domain_webapi_models_WebApi__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(api, f, ordering, references, this.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext())
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory.prototype.securitySchemesEmitters__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemesEmitters = (function(securitySchemes, ordering) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas2SecuritySchemesEmitters().init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(securitySchemes, ordering, this.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext())
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory.prototype.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function() {
  return this.spec$3
});
function $as_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.emitter.oas.Oas2SpecEmitterFactory"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.emitter.oas.Oas2SpecEmitterFactory;", depth))
}
var $d_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.oas.Oas2SpecEmitterFactory", {
  Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory: 1,
  Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory: 1,
  Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_SpecEmitterFactory: 1,
  Lamf_plugins_document_webapi_contexts_emitter_oas_OasCompactEmitterFactory: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext() {
  $c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.call(this);
  this.anyOfKey$4 = null;
  this.schemaVersion$4 = null;
  this.factory$4 = null;
  this.vendor$4 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext();
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext.prototype.schemaVersion__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion = (function() {
  return this.schemaVersion$4
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext.prototype.factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory = (function() {
  return this.factory$4
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext.prototype.vendor__Lamf_core_remote_Vendor = (function() {
  return this.vendor$4
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions = (function(eh, refEmitter, options) {
  $c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions.call(this, eh, refEmitter, options);
  this.anyOfKey$4 = "anyOf";
  var eh$1 = this.eh$1;
  this.schemaVersion$4 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion().init___T__Lamf_core_errorhandling_ErrorHandler("schema", eh$1);
  this.factory$4 = new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory().init___Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this);
  this.vendor$4 = $m_Lamf_core_remote_Oas30$();
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext.prototype.anyOfKey__T = (function() {
  return this.anyOfKey$4
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext.prototype.factory__Lamf_plugins_document_webapi_contexts_SpecEmitterFactory = (function() {
  return this.factory$4
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext.prototype.factory__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory = (function() {
  return this.factory$4
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext.prototype.schemasDeclarationsPath__T = (function() {
  return "/components/schemas/"
});
function $as_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.emitter.oas.Oas3SpecEmitterContext"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.emitter.oas.Oas3SpecEmitterContext;", depth))
}
var $d_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.oas.Oas3SpecEmitterContext", {
  Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_SpecEmitterContext: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_emitter_oas_CompactEmissionContext: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation() {
  $c_O.call(this);
  this.remoteNode$1 = null;
  this.context$1 = null
}
$c_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation.prototype.productPrefix__T = (function() {
  return "RemoteNodeNavigation"
});
$c_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation)) {
    var RemoteNodeNavigation$1 = $as_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation(x$1);
    var this$1 = this.remoteNode$1;
    var b = RemoteNodeNavigation$1.remoteNode$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.context$1;
      var x$2 = RemoteNodeNavigation$1.context$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.remoteNode$1;
      break
    }
    case 1: {
      return this.context$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation.prototype.init___Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function(remoteNode, context) {
  this.remoteNode$1 = remoteNode;
  this.context$1 = context;
  return this
});
$c_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.parser.RemoteNodeNavigation"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.parser.RemoteNodeNavigation;", depth))
}
var $d_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation: 0
}, false, "amf.plugins.document.webapi.contexts.parser.RemoteNodeNavigation", {
  Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_RamlHeader() {
  $c_O.call(this);
  this.text$1 = null
}
$c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_RamlHeader;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_RamlHeader() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_RamlHeader.prototype = $c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype;
$c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.productPrefix__T = (function() {
  return "RamlHeader"
});
$c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_RamlHeader)) {
    var RamlHeader$1 = $as_Lamf_plugins_document_webapi_parser_RamlHeader(x$1);
    return (this.text$1 === RamlHeader$1.text$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.text$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.init___T = (function(text) {
  this.text$1 = text;
  return this
});
$c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.asRegExp__s_util_matching_Regex = (function() {
  var x = (("\\s*" + $m_sjsr_RuntimeString$().replaceAll__T__T__T__T(this.text$1, " ", "\\\\s*")) + "\\s*");
  var this$2 = new $c_sci_StringOps().init___T(x);
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  return new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames)
});
function $as_Lamf_plugins_document_webapi_parser_RamlHeader(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_RamlHeader) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.RamlHeader"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_RamlHeader(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_RamlHeader)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_RamlHeader(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_RamlHeader(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.RamlHeader;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_RamlHeader = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_RamlHeader: 0
}, false, "amf.plugins.document.webapi.parser.RamlHeader", {
  Lamf_plugins_document_webapi_parser_RamlHeader: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_RamlHeader;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_TypeName() {
  $c_O.call(this);
  this.typeDef$1 = null;
  this.format$1 = null
}
$c_Lamf_plugins_document_webapi_parser_TypeName.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_TypeName.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_TypeName;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_TypeName() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_TypeName.prototype = $c_Lamf_plugins_document_webapi_parser_TypeName.prototype;
$c_Lamf_plugins_document_webapi_parser_TypeName.prototype.productPrefix__T = (function() {
  return "TypeName"
});
$c_Lamf_plugins_document_webapi_parser_TypeName.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_TypeName.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_TypeName)) {
    var TypeName$1 = $as_Lamf_plugins_document_webapi_parser_TypeName(x$1);
    if ((this.typeDef$1 === TypeName$1.typeDef$1)) {
      var x = this.format$1;
      var x$2 = TypeName$1.format$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_TypeName.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.typeDef$1;
      break
    }
    case 1: {
      return this.format$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_TypeName.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_TypeName.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_TypeName.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_TypeName.prototype.init___T__s_Option = (function(typeDef, format) {
  this.typeDef$1 = typeDef;
  this.format$1 = format;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_TypeName(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_TypeName) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.TypeName"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_TypeName(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_TypeName)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_TypeName(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_TypeName(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.TypeName;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_TypeName = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_TypeName: 0
}, false, "amf.plugins.document.webapi.parser.TypeName", {
  Lamf_plugins_document_webapi_parser_TypeName: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_TypeName.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_TypeName;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter() {
  $c_O.call(this);
  this.api$1 = null;
  this.ordering$1 = null;
  this.vendor$1 = null;
  this.references$1 = null;
  this.emitters$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter.prototype.productPrefix__T = (function() {
  return "WebApiEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var WebApiEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter(x$1);
    var x = this.api$1;
    var x$2 = WebApiEmitter$1.api$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = WebApiEmitter$1.ordering$1;
      var jsx$2 = (x$3 === x$4)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.vendor$1;
      var x$6 = WebApiEmitter$1.vendor$1;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.references$1;
      var x$8 = WebApiEmitter$1.references$1;
      return ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.api$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.vendor$1;
      break
    }
    case 3: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter__Lamf_plugins_domain_webapi_models_WebApi__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq = (function($$outer, api, ordering, vendor, references) {
  this.api$1 = api;
  this.ordering$1 = ordering;
  this.vendor$1 = vendor;
  this.references$1 = references;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  var fs = api.fields$1;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Identifier$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("id", f, $m_s_None$()))
  };
  result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter().init___Lamf_core_parser_Fields__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(fs, ordering, $$outer.spec$1));
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Servers$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiServersEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(f$3, this.ordering$1, this.$$outer$1.spec$1)))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Tags$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$2 = this$4.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("tags", $as_Lamf_core_model_domain_AmfArray(f$4.value$1.value$1).values$1, this.ordering$1, this.$$outer$1.spec$1)))
  };
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Documentations$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1$3 = this$5.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCreativeWorksEmitter().init___Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext($as_Lamf_plugins_domain_shapes_models_CreativeWork(f$5.arrayValues__sc_Seq().head__O()), this.ordering$1, this.$$outer$1.spec$1)))
  };
  var x1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1);
  matchEnd6: {
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var f$6 = $as_Lamf_core_parser_FieldEntry(x2.value$2);
      if ((f$6 !== null)) {
        result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiEndpointsEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(f$6, ordering, $$outer.spec$1));
        break matchEnd6
      }
    };
    var x = $m_s_None$();
    if ((x === x1)) {
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position("channels", new $c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter().init___Lamf_core_parser_Position($m_Lamf_core_parser_Position$ZERO$()), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()));
      break matchEnd6
    };
    throw new $c_s_MatchError().init___O(x1)
  };
  var this$9 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Security$1);
  if ((!this$9.isEmpty__Z())) {
    var arg1$4 = this$9.get__O();
    var f$7 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("security", f$7, this.ordering$1, this.$$outer$1.spec$1)))
  };
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(api, ordering, $$outer.spec$1).emitters__sc_Seq());
  this.emitters$1 = ordering.sorted__sc_Seq__sc_Seq(result);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.AsyncApi20DocumentEmitter$WebApiEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.AsyncApi20DocumentEmitter$WebApiEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.AsyncApi20DocumentEmitter$WebApiEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter$WebApiEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters() {
  $c_O.call(this);
  this.settings$1 = null;
  this.ordering$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters.prototype.productPrefix__T = (function() {
  return "ApiKeySettingsEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters)) {
    var ApiKeySettingsEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters(x$1);
    var x = this.settings$1;
    var x$2 = ApiKeySettingsEmitters$1.settings$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = ApiKeySettingsEmitters$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.settings$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters.prototype.emitters__sc_Seq = (function() {
  var this$1 = this.settings$1;
  var fs = this$1.fields$1;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().In$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("in", f, $m_s_None$())))
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters.prototype.init___Lamf_plugins_domain_webapi_models_security_ApiKeySettings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(settings, ordering, spec) {
  this.settings$1 = settings;
  this.ordering$1 = ordering;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.emitters.ApiKeySettingsEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.emitters.ApiKeySettingsEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.ApiKeySettingsEmitters", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_ApiKeySettingsEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters() {
  $c_O.call(this);
  this.settings$1 = null;
  this.ordering$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters.prototype.productPrefix__T = (function() {
  return "HttpApiKeySettingsEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters)) {
    var HttpApiKeySettingsEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters(x$1);
    var x = this.settings$1;
    var x$2 = HttpApiKeySettingsEmitters$1.settings$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = HttpApiKeySettingsEmitters$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.settings$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters.prototype.emitters__sc_Seq = (function() {
  var this$1 = this.settings$1;
  var fs = this$1.fields$1;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$().Name$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("name", f, $m_s_None$())))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$().In$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("in", f$3, $m_s_None$())))
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters.prototype.init___Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(settings, ordering, spec) {
  this.settings$1 = settings;
  this.ordering$1 = ordering;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.emitters.HttpApiKeySettingsEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.emitters.HttpApiKeySettingsEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.HttpApiKeySettingsEmitters", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpApiKeySettingsEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters() {
  $c_O.call(this);
  this.settings$1 = null;
  this.ordering$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters.prototype.productPrefix__T = (function() {
  return "HttpSettingsEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters)) {
    var HttpSettingsEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters(x$1);
    var x = this.settings$1;
    var x$2 = HttpSettingsEmitters$1.settings$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = HttpSettingsEmitters$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.settings$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters.prototype.emitters__sc_Seq = (function() {
  var this$1 = this.settings$1;
  var fs = this$1.fields$1;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$().Scheme$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("scheme", f, $m_s_None$())))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$().BearerFormat$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("bearerFormat", f$3, $m_s_None$())))
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters.prototype.init___Lamf_plugins_domain_webapi_models_security_HttpSettings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(settings, ordering, spec) {
  this.settings$1 = settings;
  this.ordering$1 = ordering;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.emitters.HttpSettingsEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.emitters.HttpSettingsEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.HttpSettingsEmitters", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_HttpSettingsEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters() {
  $c_O.call(this);
  this.settings$1 = null;
  this.ordering$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters.prototype.productPrefix__T = (function() {
  return "OpenIdConnectSettingsEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters)) {
    var OpenIdConnectSettingsEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters(x$1);
    var x = this.settings$1;
    var x$2 = OpenIdConnectSettingsEmitters$1.settings$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OpenIdConnectSettingsEmitters$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.settings$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters.prototype.emitters__sc_Seq = (function() {
  var this$1 = this.settings$1;
  var fs = this$1.fields$1;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$().Url$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("openIdConnectUrl", f, $m_s_None$())))
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters.prototype.init___Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(settings, ordering, spec) {
  this.settings$1 = settings;
  this.ordering$1 = ordering;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.emitters.OpenIdConnectSettingsEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.emitters.OpenIdConnectSettingsEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.OpenIdConnectSettingsEmitters", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_OpenIdConnectSettingsEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.parent$1 = null;
  this.messageType$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser.prototype.init___Lorg_yaml_model_YMap__T__Lamf_plugins_document_webapi_parser_spec_async_MessageType__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(map, parent, messageType, ctx) {
  this.map$1 = map;
  this.parent$1 = parent;
  this.messageType$1 = messageType;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser.prototype.productPrefix__T = (function() {
  return "AsyncMultipleMessageParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser)) {
    var AsyncMultipleMessageParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser(x$1);
    var this$1 = this.map$1;
    var b = AsyncMultipleMessageParser$1.map$1;
    if (($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b) && (this.parent$1 === AsyncMultipleMessageParser$1.parent$1))) {
      var x = this.messageType$1;
      var x$2 = AsyncMultipleMessageParser$1.messageType$1;
      return (x === x$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.parent$1;
      break
    }
    case 2: {
      return this.messageType$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser.prototype.parse__sci_List = (function() {
  var map = this.map$1;
  var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("oneOf");
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    var this$2 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
    var iv = this.ctx$1;
    var jsx$4 = $as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv)).nodes$3;
    var this$3 = $m_sc_IndexedSeq$();
    var jsx$3 = $as_sc_TraversableLike(jsx$4.zipWithIndex__scg_CanBuildFrom__O(this$3.ReusableCBF$6));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x0$1$2) {
        var x0$1 = $as_T2(x0$1$2);
        if ((x0$1 !== null)) {
          var node = $as_Lorg_yaml_model_YNode(x0$1.$$und1__O());
          var index = x0$1.$$und2$mcI$sp__I();
          var jsx$2 = $m_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$();
          var errorHandler = $this.ctx$1;
          return jsx$2.apply__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__s_Option__Z__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser(new $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, errorHandler), (($this.parent$1 + "/") + index), new $c_s_Some().init___O($this.messageType$1), false, $this.ctx$1).parse__Lamf_plugins_domain_webapi_models_Message()
        } else {
          throw new $c_s_MatchError().init___O(x0$1)
        }
      })
    })(this));
    var this$5 = $m_sc_IndexedSeq$();
    return $as_sc_TraversableOnce(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBF$6)).toList__sci_List()
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      $m_sci_List$();
      var jsx$5 = $m_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$();
      $m_Lorg_yaml_model_YNode$();
      var map$1 = this.map$1;
      $m_Lorg_yaml_model_YNode$();
      var node$1 = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map$1, $m_Lorg_yaml_model_YType$().Map$1);
      var errorHandler$1 = this.ctx$1;
      var array = [jsx$5.apply__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__s_Option__Z__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser(new $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$1, errorHandler$1), this.parent$1, new $c_s_Some().init___O(this.messageType$1), false, this.ctx$1).parse__Lamf_plugins_domain_webapi_models_Message()];
      var i = (((-1) + $uI(array.length)) | 0);
      var result = $m_sci_Nil$();
      while ((i >= 0)) {
        var this$12 = result;
        var index$1 = i;
        var x$1 = array[index$1];
        result = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$12);
        i = (((-1) + i) | 0)
      };
      return result
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncMultipleMessageParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.parser.AsyncMultipleMessageParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncMultipleMessageParser", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMultipleMessageParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser() {
  $c_O.call(this);
  this.node$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser.prototype.remote__p1__T__Lorg_yaml_model_YNode__Lamf_plugins_domain_webapi_models_Operation = (function(url, node) {
  var this$3 = this.ctx$1;
  $m_Lamf_core_parser_Annotations$();
  new $c_Lamf_core_parser_Annotations().init___();
  var x1 = this$3.jsonSchemaRefGuide$2.obtainRemoteYNode__T__s_Option(url);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var correlationIdNode = $as_Lorg_yaml_model_YNode(x2.value$2);
    return $m_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$().apply__Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser($m_Lorg_yaml_model_YMapEntry$().apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(url)), correlationIdNode), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(name$2) {
        var name = $as_T(name$2);
        $m_Lamf_core_parser_Annotations$();
        var annotations = new $c_Lamf_core_parser_Annotations().init___();
        var qual$1 = new $c_Lamf_plugins_domain_webapi_models_Operation().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
        $m_Lamf_core_parser_Annotations$();
        var x$2 = new $c_Lamf_core_parser_Annotations().init___();
        return $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2))
      })
    })(this)), true, this.ctx$1).parse__Lamf_plugins_domain_webapi_models_Operation()
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return this.linkError__p1__T__Lorg_yaml_model_YNode__Lamf_plugins_domain_webapi_models_Operation(url, node)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser.prototype.productPrefix__T = (function() {
  return "AsyncOperationRefParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser)) {
    var AsyncOperationRefParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser(x$1);
    var this$1 = this.node$1;
    var b = AsyncOperationRefParser$1.node$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.node$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser.prototype.parse__Lamf_plugins_domain_webapi_models_Operation = (function() {
  var x1 = this.ctx$1.link__Lorg_yaml_model_YNode__s_util_Either(this.node$1);
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var url = $as_T(x2.value$2);
    var operation = this.parseLink__p1__T__Lorg_yaml_model_YNode__Lamf_plugins_domain_webapi_models_Operation(url, this.node$1);
    return operation
  } else if ((x1 instanceof $c_s_util_Right)) {
    var x3 = $as_s_util_Right(x1);
    var url$2 = $as_Lorg_yaml_model_YNode(x3.value$2);
    var jsx$1 = this.node$1;
    $m_Lorg_yaml_model_YNode$();
    var iv = this.ctx$1;
    var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
    return this.expectedRef__p1__Lorg_yaml_model_YNode__T__Lamf_plugins_domain_webapi_models_Operation(jsx$1, $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(url$2, conversion, iv)))
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser.prototype.linkError__p1__T__Lorg_yaml_model_YNode__Lamf_plugins_domain_webapi_models_Operation = (function(url, node) {
  var this$1 = this.ctx$1.eh$1;
  var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnresolvedReference$1;
  var message = ("Cannot find operation trait reference " + url);
  var prop = $m_s_None$();
  var l = node.location$1;
  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, "", prop, message, l);
  var this$2 = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait().init___T__Lorg_yaml_model_YPart(url, node);
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(node);
  return $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this$2, url, annotations))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser.prototype.expectedRef__p1__Lorg_yaml_model_YNode__T__Lamf_plugins_domain_webapi_models_Operation = (function(node, name) {
  var this$1 = this.ctx$1.eh$1;
  var specification = $m_Lamf_validations_ParserSideValidations$().ExpectedReference$1;
  var prop = $m_s_None$();
  var l = node.location$1;
  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, "", prop, "Expected reference", l);
  var this$2 = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait().init___T__Lorg_yaml_model_YPart(name, node);
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(node);
  return $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this$2, name, annotations))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser.prototype.parseLink__p1__T__Lorg_yaml_model_YNode__Lamf_plugins_domain_webapi_models_Operation = (function(url, node) {
  var label = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().stripOas3ComponentsPrefix__T__T__T(url, "operationTraits");
  var this$1 = this.ctx$1.declarations$4.findOperationTrait__T__Lamf_core_parser_SearchScope$Scope__s_Option(label, $m_Lamf_core_parser_SearchScope$Named$());
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var res = $as_Lamf_plugins_domain_webapi_models_Operation(arg1);
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var resLink = $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(res, label, annotations));
    var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(node);
    var this$3 = new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(resLink, other)))
  };
  var operation = $as_Lamf_plugins_domain_webapi_models_Operation((this$3.isEmpty__Z() ? this.remote__p1__T__Lorg_yaml_model_YNode__Lamf_plugins_domain_webapi_models_Operation(url, node) : this$3.get__O()));
  return operation
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser.prototype.init___Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(node, ctx) {
  this.node$1 = node;
  this.ctx$1 = ctx;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncOperationRefParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.parser.AsyncOperationRefParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncOperationRefParser", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationRefParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser() {
  $c_O.call(this);
  this.parentId$1 = null;
  this.map$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser.prototype.productPrefix__T = (function() {
  return "AsyncParametersParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser)) {
    var AsyncParametersParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser(x$1);
    if ((this.parentId$1 === AsyncParametersParser$1.parentId$1)) {
      var this$1 = this.map$1;
      var b = AsyncParametersParser$1.map$1;
      return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser.prototype.init___T__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(parentId, map, ctx) {
  this.parentId$1 = parentId;
  this.map$1 = map;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.parentId$1;
      break
    }
    case 1: {
      return this.map$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser.prototype.parse__sc_Seq = (function() {
  var jsx$3 = this.map$1.entries$3;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var jsx$2 = $this.parentId$1;
      var errorHandler = $this.ctx$1;
      return new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser().init___T__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(jsx$2, new $c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike().init___Lorg_yaml_model_YMapEntry__Lorg_yaml_model_IllegalTypeHandler(entry, errorHandler), $this.ctx$1).parse__Lamf_plugins_domain_webapi_models_Parameter()
    })
  })(this));
  var this$2 = $m_sc_IndexedSeq$();
  return $as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBF$6))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncParametersParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.parser.AsyncParametersParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncParametersParser", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.api$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser.prototype.productPrefix__T = (function() {
  return "AsyncServersParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser)) {
    var AsyncServersParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser(x$1);
    var this$1 = this.map$1;
    var b = AsyncServersParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.api$1;
      var x$2 = AsyncServersParser$1.api$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.api$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser.prototype.parse__sc_Seq = (function() {
  var jsx$3 = this.map$1.entries$3;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var jsx$2 = $this.api$1.id$1;
      var this$1 = entry.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = $this.ctx$1;
      var this$3 = new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser().init___T__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(jsx$2, $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)), $this.ctx$1).parse__Lamf_plugins_domain_webapi_models_Server();
      $m_Lorg_yaml_model_YNode$();
      var node = entry.key$2;
      var iv$1 = $this.ctx$1;
      var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
      var name = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$1, iv$1));
      var field = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Name$1;
      return $as_Lamf_plugins_domain_webapi_models_Server($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$3, field, name))
    })
  })(this));
  var this$4 = $m_sc_IndexedSeq$();
  return $as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBF$6))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser.prototype.init___Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_WebApi__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(map, api, ctx) {
  this.map$1 = map;
  this.api$1 = api;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncServersParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.parser.AsyncServersParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncServersParser", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables() {
  $c_O.call(this);
  this.variables$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables.prototype.init___ = (function() {
  this.variables$1 = $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables.prototype.productPrefix__T = (function() {
  return "AbstractVariables"
});
$c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables) && ($as_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables(x$1), true))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables.prototype.parseVariables__T__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables = (function(s) {
  var this$1 = $m_Lamf_core_resolution_VariableReplacer$().VariableRegex$1.findAllMatchIn__jl_CharSequence__sc_Iterator(s);
  while (this$1.hasNext__Z()) {
    var arg1 = this$1.next__O();
    var m = $as_s_util_matching_Regex$Match(arg1);
    $as_scm_Set(this.variables$1.$$plus$eq__O__scm_SetLike($f_s_util_matching_Regex$MatchData__group__I__T(m, 1)))
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.common.AbstractVariables"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.common.AbstractVariables;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.AbstractVariables", {
  Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser() {
  $c_O.call(this);
  this.element$1 = null;
  this.map$1 = null;
  this.target$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser.prototype.productPrefix__T = (function() {
  return "AnnotationParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser)) {
    var AnnotationParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser(x$1);
    var x = this.element$1;
    var x$2 = AnnotationParser$1.element$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var this$1 = this.map$1;
      var b = AnnotationParser$1.map$1;
      var jsx$1 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.target$1;
      var x$4 = AnnotationParser$1.target$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.element$1;
      break
    }
    case 1: {
      return this.map$1;
      break
    }
    case 2: {
      return this.target$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser.prototype.init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(element, map, target, ctx) {
  this.element$1 = element;
  this.map$1 = map;
  this.target$1 = target;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser.prototype.parseOrphanNode__T__V = (function(orphanNodeName) {
  var map = this.map$1;
  var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(orphanNodeName);
  matchEnd4: {
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var orphanMapEntry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var this$2 = orphanMapEntry.value$2;
      var x = this$2.tag__Lorg_yaml_model_YTag().tagType$3;
      var x$2 = $m_Lorg_yaml_model_YType$().Map$1;
      if ((x === x$2)) {
        var jsx$2 = $m_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$();
        var jsx$1 = this.element$1.id__T();
        var this$3 = orphanMapEntry.value$2;
        var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv = this.ctx$1;
        var extensions = jsx$2.parseExtensions__T__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext__sc_Seq(jsx$1, $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv)), $m_sci_Nil$(), this.ctx$1);
        extensions.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, orphanNodeName$1) {
          return (function(extension$2) {
            var extension = $as_Lamf_core_model_domain_extensions_DomainExtension(extension$2);
            var this$5 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_DataNode(extension.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)));
            if ((!this$5.isEmpty__Z())) {
              var arg1 = this$5.get__O();
              var x$1 = $as_Lamf_core_model_domain_DataNode(arg1);
              x$1.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension().init___T(orphanNodeName$1))
            }
          })
        })(this, orphanNodeName)));
        var jsx$3 = $m_s_Option$();
        var this$6 = this.element$1;
        var this$7 = jsx$3.apply__O__s_Option($as_sc_Seq(this$6.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field())));
        var oldExtensions = $as_sc_Seq((this$7.isEmpty__Z() ? $m_sci_Nil$() : this$7.get__O()));
        if (extensions.nonEmpty__Z()) {
          var this$9 = this.element$1;
          var this$8 = $m_sc_Seq$();
          var extensions$1 = $as_sc_Seq(oldExtensions.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(extensions, this$8.ReusableCBFInstance$2));
          var field = $m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field();
          $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$9, field, extensions$1));
          break matchEnd4
        } else {
          break matchEnd4
        }
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser.prototype.parse__V = (function() {
  var extensions = $m_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser$().parseExtensions__T__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext__sc_Seq(this.element$1.id__T(), this.map$1, this.target$1, this.ctx$1);
  var jsx$1 = $m_s_Option$();
  var this$1 = this.element$1;
  var this$2 = jsx$1.apply__O__s_Option($as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field())));
  var oldExtensions = $as_sc_Seq((this$2.isEmpty__Z() ? $m_sci_Nil$() : this$2.get__O()));
  if (extensions.nonEmpty__Z()) {
    var this$4 = this.element$1;
    var this$3 = $m_sc_Seq$();
    var extensions$1 = $as_sc_Seq(oldExtensions.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(extensions, this$3.ReusableCBFInstance$2));
    var field = $m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field();
    $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$4, field, extensions$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.common.AnnotationParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.common.AnnotationParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.AnnotationParser", {
  Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser() {
  $c_O.call(this);
  this.annotation$1 = null;
  this.parent$1 = null;
  this.entry$1 = null;
  this.target$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser.prototype.productPrefix__T = (function() {
  return "ExtensionParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser.prototype.init___T__T__Lorg_yaml_model_YMapEntry__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(annotation, parent, entry, target, ctx) {
  this.annotation$1 = annotation;
  this.parent$1 = parent;
  this.entry$1 = entry;
  this.target$1 = target;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser)) {
    var ExtensionParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser(x$1);
    if (((this.annotation$1 === ExtensionParser$1.annotation$1) && (this.parent$1 === ExtensionParser$1.parent$1))) {
      var x = this.entry$1;
      var x$2 = ExtensionParser$1.entry$1;
      var jsx$1 = (x === x$2)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.target$1;
      var x$4 = ExtensionParser$1.target$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.annotation$1;
      break
    }
    case 1: {
      return this.parent$1;
      break
    }
    case 2: {
      return this.entry$1;
      break
    }
    case 3: {
      return this.target$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser.prototype.validateAllowedTargets__p1__Lamf_core_model_domain_extensions_CustomDomainProperty__V = (function(customDomainProperty) {
  var _1 = $m_s_Option$().apply__O__s_Option($as_sc_Seq(customDomainProperty.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Domain$1)));
  matchEnd6: {
    if ((_1 instanceof $c_s_Some)) {
      var x4 = $as_s_Some(_1);
      var allowedTargets = $as_sc_Seq(x4.value$2);
      if (allowedTargets.nonEmpty__Z()) {
        var this$1 = this.target$1;
        var jsx$1 = $f_sc_TraversableOnce__nonEmpty__Z(this$1)
      } else {
        var jsx$1 = false
      };
      if (jsx$1) {
        var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(x$4$2) {
            var x$4 = $as_Lamf_core_model_StrField(x$4$2);
            var this$2 = x$4.option$1;
            return $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()))
          })
        })(this));
        var this$3 = $m_sc_Seq$();
        if ($as_sc_SeqLike($as_sc_SeqLike(allowedTargets.map__F1__scg_CanBuildFrom__O(jsx$2, this$3.ReusableCBFInstance$2)).intersect__sc_GenSeq__O(this.target$1)).isEmpty__Z()) {
          var ramlTarget = $m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().uriToRaml$1.get__O__s_Option(this.target$1.head__O());
          var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
            return (function(uri$2) {
              var uri = $as_Lamf_core_model_StrField(uri$2);
              var jsx$4 = $m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().uriToRaml$1;
              var this$4 = uri.option$1;
              var xo = jsx$4.get__O__s_Option($as_T((this$4.isEmpty__Z() ? null : this$4.get__O())));
              return xo.toList__sci_List()
            })
          })(this));
          var this$6 = $m_sc_Seq$();
          var ramlAllowedTargets = $as_sc_Seq(allowedTargets.flatMap__F1__scg_CanBuildFrom__O(jsx$3, this$6.ReusableCBFInstance$2));
          var this$7 = this.ctx$1.eh$1;
          var specification = $m_Lamf_validations_ParserSideValidations$().InvalidAnnotationTarget$1;
          var node = this.parent$1;
          var message = ((((("Annotation " + this.annotation$1) + " not allowed in target ") + (ramlTarget.isEmpty__Z() ? "" : ramlTarget.get__O())) + ", allowed targets: ") + ramlAllowedTargets.mkString__T__T(", "));
          var ast = this.entry$1;
          var prop = $m_s_None$();
          var l = ast.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$7, specification, node, prop, message, l);
          break matchEnd6
        } else {
          break matchEnd6
        }
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser.prototype.parse__Lamf_core_model_domain_extensions_DomainExtension = (function() {
  var id = ((this.parent$1 + "/extension/") + this.annotation$1);
  var propertyId = ((this.parent$1 + "/") + this.annotation$1);
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_core_model_domain_extensions_DomainExtension().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var domainExtension = $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, id));
  var x$1 = this.entry$1.value$2;
  var x$2 = new $c_s_Some().init___O(propertyId);
  var x$3 = new $c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables().init___();
  var dataNode = $m_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser(x$1, x$3, x$2, this.ctx$1).parse__Lamf_core_model_domain_DataNode();
  var this$6 = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations().findAnnotation__T__Lamf_core_parser_SearchScope$Scope__s_Option(this.annotation$1, $m_Lamf_core_parser_SearchScope$All$());
  if (this$6.isEmpty__Z()) {
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1);
    var this$9 = new $c_Lamf_core_model_domain_extensions_CustomDomainProperty().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
    var qual$1 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$9, propertyId));
    var x$4 = this.annotation$1;
    $m_Lamf_core_parser_Annotations$();
    var x$5 = new $c_Lamf_core_parser_Annotations().init___();
    var jsx$1 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, x$4, x$5))
  } else {
    var jsx$1 = this$6.get__O()
  };
  var customDomainProperty = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(jsx$1);
  this.validateAllowedTargets__p1__Lamf_core_model_domain_extensions_CustomDomainProperty__V(customDomainProperty);
  domainExtension.adopted__T__sc_Seq__Lamf_core_model_domain_extensions_DomainExtension(this.parent$1, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
  var field = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1;
  var this$11 = $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(domainExtension, field, dataNode));
  var name = this.annotation$1;
  var field$1 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1;
  $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$11, field$1, name));
  domainExtension.fields$1.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().DefinedBy$1, customDomainProperty, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
  return domainExtension
});
function $as_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.common.ExtensionParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.common.ExtensionParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.ExtensionParser", {
  Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_ExtensionParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter() {
  $c_O.call(this);
  this.root$1 = null;
  this.declarations$1 = null;
  this.ordering$1 = null;
  this.options$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter.prototype.productPrefix__T = (function() {
  return "JsonSchemaEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter.prototype.sortedTypeEntries__p1__Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext__sc_Seq = (function(ctx) {
  return this.ordering$1.sorted__sc_Seq__sc_Seq(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.declarations$1, $m_Lamf_core_emitter_SpecOrdering$Lexical$(), $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), ctx).emitters$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter)) {
    var JsonSchemaEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter(x$1);
    var x = this.root$1;
    var x$2 = JsonSchemaEmitter$1.root$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.declarations$1;
      var x$4 = JsonSchemaEmitter$1.declarations$1;
      var jsx$2 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.ordering$1;
      var x$6 = JsonSchemaEmitter$1.ordering$1;
      var jsx$1 = (x$5 === x$6)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.options$1;
      var x$8 = JsonSchemaEmitter$1.options$1;
      return (x$7 === x$8)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.root$1;
      break
    }
    case 1: {
      return this.declarations$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.options$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter.prototype.init___Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_core_emitter_ShapeRenderOptions = (function(root, declarations, ordering, options) {
  this.root$1 = root;
  this.declarations$1 = declarations;
  this.ordering$1 = ordering;
  this.options$1 = options;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter.prototype.emitDocument__Lorg_yaml_model_YDocument = (function() {
  var jsx$1 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion$();
  var this$1 = this.options$1;
  var schemaVersion = jsx$1.fromClientOptions__Lamf_client_render_JSONSchemaVersion__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion(this$1.schema$1);
  var this$2 = this.options$1;
  if (this$2.amf$core$emitter$ShapeRenderOptions$$compactedEmission$1) {
    var this$3 = this.options$1;
    var context = new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_core_emitter_ShapeRenderOptions__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion(this$3.amf$core$emitter$ShapeRenderOptions$$eh$1, this.options$1, schemaVersion)
  } else {
    var this$4 = this.options$1;
    var context = new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_core_emitter_ShapeRenderOptions__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion(this$4.amf$core$emitter$ShapeRenderOptions$$eh$1, this.options$1, schemaVersion)
  };
  var jsx$4 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry().init___Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion(schemaVersion), new $c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter$$anon$1().init___Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter__Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext(this, context)];
  var jsx$3 = $as_sc_TraversableLike(jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  var jsx$2 = this.sortedTypeEntries__p1__Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext__sc_Seq(context);
  var this$7 = $m_sc_Seq$();
  var emitters = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$7.ReusableCBFInstance$2));
  var this$9 = $m_Lorg_yaml_model_YDocument$().apply__T__Lorg_yaml_model_YDocument$WithComment("");
  var b = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(this$9.org$yaml$model$YDocument$WithComment$$sourceName$f);
  var x = this$9.comment$1;
  var this$11 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$11)) {
    b.comment__T__V(this$9.comment$1)
  };
  var jsx$5 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(emitters, b$1);
  jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  return new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this$9.org$yaml$model$YDocument$WithComment$$sourceName$f), b.builder$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.common.JsonSchemaEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.common.JsonSchemaEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.JsonSchemaEmitter", {
  Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField() {
  $c_O.call(this);
  this.name$1 = null;
  this.field$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField.prototype.productPrefix__T = (function() {
  return "FlowField"
});
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField)) {
    var FlowField$1 = $as_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField(x$1);
    if ((this.name$1 === FlowField$1.name$1)) {
      var x = this.field$1;
      var x$2 = FlowField$1.field$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.name$1;
      break
    }
    case 1: {
      return this.field$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField.prototype.init___T__Lamf_core_metamodel_Field = (function(name, field) {
  this.name$1 = name;
  this.field$1 = field;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.common.OAuth2FlowValidations$FlowField"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.common.OAuth2FlowValidations$FlowField;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.OAuth2FlowValidations$FlowField", {
  Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$FlowField;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow() {
  $c_O.call(this);
  this.name$1 = null;
  this.requiredFields$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow.prototype.productPrefix__T = (function() {
  return "ParticularFlow"
});
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow)) {
    var ParticularFlow$1 = $as_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow(x$1);
    if ((this.name$1 === ParticularFlow$1.name$1)) {
      var x = this.requiredFields$1;
      var x$2 = ParticularFlow$1.requiredFields$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.name$1;
      break
    }
    case 1: {
      return this.requiredFields$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow.prototype.init___T__sci_List = (function(name, requiredFields) {
  this.name$1 = name;
  this.requiredFields$1 = requiredFields;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.common.OAuth2FlowValidations$ParticularFlow"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.common.OAuth2FlowValidations$ParticularFlow;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.OAuth2FlowValidations$ParticularFlow", {
  Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_OAuth2FlowValidations$ParticularFlow;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter() {
  $c_O.call(this);
  this.dataNode$1 = null;
  this.ordering$1 = null;
  this.eh$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter.prototype.productPrefix__T = (function() {
  return "PayloadEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter.prototype.init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Lamf_core_errorhandling_ErrorHandler = (function(dataNode, ordering, eh) {
  this.dataNode$1 = dataNode;
  this.ordering$1 = ordering;
  this.eh$1 = eh;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter)) {
    var PayloadEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter(x$1);
    var x = this.dataNode$1;
    var x$2 = PayloadEmitter$1.dataNode$1;
    if ((x === x$2)) {
      var x$3 = this.ordering$1;
      var x$4 = PayloadEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.dataNode$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter.prototype.emitDocument__Lorg_yaml_model_YDocument = (function() {
  var eta$0$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler(this.dataNode$1, this.ordering$1, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.eh$1);
  var this$3 = $m_Lorg_yaml_model_YDocument$().apply__T__Lorg_yaml_model_YDocument$WithComment("");
  var b = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(this$3.org$yaml$model$YDocument$WithComment$$sourceName$f);
  var x = this$3.comment$1;
  var this$5 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$5)) {
    b.comment__T__V(this$3.comment$1)
  };
  eta$0$1.emit__Lorg_yaml_model_YDocument$PartBuilder__V(b);
  return new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this$3.org$yaml$model$YDocument$WithComment$$sourceName$f), b.builder$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.common.PayloadEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.common.PayloadEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.PayloadEmitter", {
  Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_PayloadEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser() {
  $c_O.call(this);
  this.parameters$1 = null;
  this.parent$1 = null;
  this.idCounter$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser.prototype.productPrefix__T = (function() {
  return "ScalarNodeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser.prototype.parseIncludedAST__T__Lorg_yaml_model_YNode__Lamf_core_model_domain_DataNode = (function(raw, node) {
  var this$1 = $m_Lorg_yaml_parser_YamlParser$().apply__jl_CharSequence__T__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_YamlParser(raw, node.location$1.sourceName$1, this.ctx$1).withIncludeTag__T__Lorg_yaml_parser_YamlParser("!include");
  var n = $f_Lorg_yaml_parser_YParser__document__Lorg_yaml_model_YDocument(this$1).node$2;
  if (n.isNull__Z()) {
    var this$2 = $m_Lamf_core_model_domain_ScalarNode$();
    var dataType = new $c_s_Some().init___O($m_Lamf_core_model_DataType$().String$1);
    var this$5 = this$2.apply__T__s_Option__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode(raw, dataType, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
    var this$4 = this.parent$1;
    var value = ($as_T((this$4.isEmpty__Z() ? "" : this$4.get__O())) + "/included");
    return $as_Lamf_core_model_domain_DataNode($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value))
  } else {
    return $m_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser(n, this.parameters$1, this.parent$1, this.idCounter$1, this.ctx$1).parse__Lamf_core_model_domain_DataNode()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser.prototype.normalizeUrl__T__T = (function(url) {
  if (($uI(url.indexOf("://")) !== (-1))) {
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(url, "://", 0);
    var this$6 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    var protocol = $as_T($f_sc_IndexedSeqOptimized__head__O(this$6));
    var xs$1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(url, "://", 0);
    var this$9 = new $c_scm_ArrayOps$ofRef().init___AO(xs$1);
    var path = $as_T($f_sc_IndexedSeqOptimized__last__O(this$9));
    var remaining = $m_sjsr_RuntimeString$().split__T__T__I__AT(path, "/", 0);
    var elem = new $c_scm_ListBuffer().init___();
    var elem$1 = null;
    elem$1 = elem;
    var i = 0;
    var len = remaining.u.length;
    while ((i < len)) {
      var index = i;
      var arg1 = remaining.get(index);
      var x0$1 = $as_T(arg1);
      if ((x0$1 !== ".")) {
        if ((x0$1 === "..")) {
          var this$15 = $as_scm_ListBuffer(elem$1);
          elem$1 = $as_scm_ListBuffer($f_sc_IterableLike__dropRight__I__O(this$15, 1))
        } else {
          $as_scm_ListBuffer(elem$1).$$plus$eq__O__scm_ListBuffer(x0$1)
        }
      };
      i = ((1 + i) | 0)
    };
    var this$16 = $as_scm_ListBuffer(elem$1);
    var this$17 = this$16.scala$collection$mutable$ListBuffer$$start$6;
    return ((protocol + "://") + $f_sc_TraversableOnce__mkString__T__T__T__T(this$17, "", "/", ""))
  } else {
    return url
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser)) {
    var ScalarNodeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser(x$1);
    var x = this.parameters$1;
    var x$2 = ScalarNodeParser$1.parameters$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.parent$1;
      var x$4 = ScalarNodeParser$1.parent$1;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.idCounter$1;
      var x$6 = ScalarNodeParser$1.idCounter$1;
      return (x$5 === x$6)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.parameters$1;
      break
    }
    case 1: {
      return this.parent$1;
      break
    }
    case 2: {
      return this.idCounter$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser.prototype.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode = (function(ast, dataType) {
  var finalDataType = new $c_s_Some().init___O($m_Lamf_core_model_DataType$().apply__T__T(dataType));
  var this$1 = $m_Lamf_core_model_domain_ScalarNode$().apply__T__s_Option__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode(ast.text$3, finalDataType, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast));
  var name = this.idCounter$1.genId__T__T("scalar");
  var field = $m_Lamf_core_metamodel_domain_DataNodeModel$().Name$1;
  var node = $as_Lamf_core_model_domain_ScalarNode($as_Lamf_core_model_domain_DataNode($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name)));
  var this$2 = this.parent$1;
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var p = $as_T(arg1);
    $as_Lamf_core_model_domain_ScalarNode(node.adopted__T__sc_Seq__Lamf_core_model_domain_DataNode(p, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))))
  };
  var this$3 = this.parameters$1;
  this$3.parseVariables__T__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables(ast.text$3);
  return node
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser.prototype.parse__Lorg_yaml_model_YNode__Lamf_core_model_domain_DataNode = (function(node) {
  var x1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Str$1;
  if ((x === x1)) {
    var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv = this.ctx$1;
    return this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)), "string")
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Int$1;
    if ((x$3 === x1)) {
      var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$1 = this.ctx$1;
      return this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$1, iv$1)), "integer")
    } else {
      var x$5 = $m_Lorg_yaml_model_YType$().Float$1;
      if ((x$5 === x1)) {
        var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
        var iv$2 = this.ctx$1;
        return this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$2, iv$2)), "double")
      } else {
        var x$7 = $m_Lorg_yaml_model_YType$().Bool$1;
        if ((x$7 === x1)) {
          var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
          var iv$3 = this.ctx$1;
          return this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$3, iv$3)), "boolean")
        } else {
          var x$9 = $m_Lorg_yaml_model_YType$().Null$1;
          if ((x$9 === x1)) {
            var this$2 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lamf_core_parser_package$YScalarYRead$());
            return this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YScalar((this$2.isEmpty__Z() ? $m_Lorg_yaml_model_YScalar$().apply__O__Lorg_yaml_model_YScalar("null") : this$2.get__O())), "nil")
          } else {
            var x$11 = $m_Lorg_yaml_model_YType$().Timestamp$1;
            if ((x$11 === x1)) {
              var x1$2 = $m_Lorg_mulesoft_common_time_SimpleDateTime$().parse__T__s_util_Either(node.toString__T()).toOption__s_Option();
              if ((x1$2 instanceof $c_s_Some)) {
                var x2 = $as_s_Some(x1$2);
                var sdt = $as_Lorg_mulesoft_common_time_SimpleDateTime(x2.value$2);
                try {
                  $m_Lorg_mulesoft_common_time_package$DateTimes$().toDate$extension__Lorg_mulesoft_common_time_SimpleDateTime__ju_Date(sdt);
                  if (sdt.timeOfDay$1.isEmpty__Z()) {
                    var conversion$4 = $m_Lamf_core_parser_package$YScalarYRead$();
                    var iv$4 = this.ctx$1;
                    return this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$4, iv$4)), "date")
                  } else if (sdt.zoneOffset$1.isEmpty__Z()) {
                    var conversion$5 = $m_Lamf_core_parser_package$YScalarYRead$();
                    var iv$5 = this.ctx$1;
                    return this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$5, iv$5)), "dateTimeOnly")
                  } else {
                    var conversion$6 = $m_Lamf_core_parser_package$YScalarYRead$();
                    var iv$6 = this.ctx$1;
                    return this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$6, iv$6)), "dateTime")
                  }
                } catch (e) {
                  var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
                  if ((e$2 instanceof $c_jl_Exception)) {
                    var conversion$7 = $m_Lamf_core_parser_package$YScalarYRead$();
                    var iv$7 = this.ctx$1;
                    return this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$7, iv$7)), "string")
                  } else {
                    throw e
                  }
                }
              } else {
                var x$13 = $m_s_None$();
                if ((x$13 === x1$2)) {
                  var conversion$8 = $m_Lamf_core_parser_package$YScalarYRead$();
                  var iv$8 = this.ctx$1;
                  return this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$8, iv$8)), "string")
                } else {
                  throw new $c_s_MatchError().init___O(x1$2)
                }
              }
            } else {
              var x$15 = node.tag__Lorg_yaml_model_YTag().tagType$3;
              var x$16 = $m_Lorg_yaml_model_YType$().Include$1;
              if ((x$15 === x$16)) {
                return this.parseInclusion__Lorg_yaml_model_YNode__Lamf_core_model_domain_DataNode(node)
              } else {
                var parsed = this.parseScalar__Lorg_yaml_model_YScalar__T__Lamf_core_model_domain_DataNode($m_Lorg_yaml_model_YScalar$().apply__O__Lorg_yaml_model_YScalar(x1.org$yaml$model$YType$$tag$und$1.text$3), "string");
                var this$4 = this.ctx$1.eh$1;
                var spec = $m_Lamf_plugins_features_validation_CoreValidations$().SyamlError$1;
                var node$1 = parsed.id$1;
                var prop = $m_s_None$();
                var msg = (("Cannot parse scalar node from AST structure '" + x1) + "'");
                var l = node.location$1;
                $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$4, spec, node$1, prop, msg, l);
                return parsed
              }
            }
          }
        }
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(parameters, parent, idCounter, ctx) {
  this.parameters$1 = parameters;
  this.parent$1 = parent;
  this.idCounter$1 = idCounter;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser.prototype.parseInclusion__Lorg_yaml_model_YNode__Lamf_core_model_domain_DataNode = (function(node) {
  var x1 = node.value__Lorg_yaml_model_YValue();
  if ((x1 instanceof $c_Lorg_yaml_model_YScalar)) {
    var x2 = $as_Lorg_yaml_model_YScalar(x1);
    var rc5 = false;
    var x2$2 = null;
    var x1$2 = this.ctx$1.refs$1.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x2$1) {
      return (function(ref$2) {
        var ref = $as_Lamf_core_parser_ParsedReference(ref$2);
        return (ref.origin$1.url$1 === x2$1.text$3)
      })
    })(this, x2)));
    if ((x1$2 instanceof $c_s_Some)) {
      rc5 = true;
      x2$2 = $as_s_Some(x1$2);
      var ref$3 = $as_Lamf_core_parser_ParsedReference(x2$2.value$2);
      if ((ref$3.unit$1 instanceof $c_Lamf_core_model_document_ExternalFragment)) {
        var this$1 = $as_Lamf_core_model_document_ExternalFragment(ref$3.unit$1);
        var this$2 = $as_Lamf_core_model_domain_ExternalDomainElement($as_Lamf_core_model_domain_DomainElement(this$1.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)));
        var this$3 = $as_Lamf_core_model_StrField(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1));
        var this$4 = this$3.option$1;
        var includedText = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
        return this.parseIncludedAST__T__Lorg_yaml_model_YNode__Lamf_core_model_domain_DataNode(includedText, node)
      }
    };
    if (rc5) {
      var ref$4 = $as_Lamf_core_parser_ParsedReference(x2$2.value$2);
      if ($is_Lamf_core_model_document_EncodesModel(ref$4.unit$1)) {
        return this.parseLink__T__Lamf_core_model_domain_LinkNode(x2.text$3).withLinkedDomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_LinkNode($as_Lamf_core_model_document_EncodesModel(ref$4.unit$1).encodes__Lamf_core_model_domain_DomainElement())
      }
    };
    var this$5 = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations().fragments$1.get__O__s_Option(x2.text$3);
    if (this$5.isEmpty__Z()) {
      var x1$3 = $m_s_None$()
    } else {
      var arg1 = this$5.get__O();
      var x$1 = $as_Lamf_core_parser_FragmentRef(arg1);
      var x1$3 = new $c_s_Some().init___O(x$1.encoded$1)
    };
    if ((x1$3 instanceof $c_s_Some)) {
      var x2$3 = $as_s_Some(x1$3);
      var domainElement = $as_Lamf_core_model_domain_DomainElement(x2$3.value$2);
      return this.parseLink__T__Lamf_core_model_domain_LinkNode(x2.text$3).withLinkedDomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_LinkNode(domainElement)
    } else {
      return this.parseLink__T__Lamf_core_model_domain_LinkNode(x2.text$3)
    }
  } else {
    return this.parseLink__T__Lamf_core_model_domain_LinkNode(node.value__Lorg_yaml_model_YValue().toString__T())
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser.prototype.baseUrl__T__T = (function(url) {
  if (($uI(url.indexOf("://")) !== (-1))) {
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(url, "://", 0);
    var this$6 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    var protocol = $as_T($f_sc_IndexedSeqOptimized__head__O(this$6));
    var xs$1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(url, "://", 0);
    var this$9 = new $c_scm_ArrayOps$ofRef().init___AO(xs$1);
    var path = $as_T($f_sc_IndexedSeqOptimized__last__O(this$9));
    var xs$2 = $m_sjsr_RuntimeString$().split__T__T__I__AT(path, "/", 0);
    var until = (((-1) + xs$2.u.length) | 0);
    var x = ((until > 0) ? until : 0);
    var y = xs$2.u.length;
    var hi = ((x < y) ? x : y);
    var size = ((hi > 0) ? hi : 0);
    var result = $m_jl_reflect_Array$().newInstance__jl_Class__I__O($objectGetClass(xs$2).getComponentType__jl_Class(), size);
    if ((size > 0)) {
      $m_s_Array$().copy__O__I__O__I__I__V(xs$2, 0, result, 0, size)
    };
    var remaining = $asArrayOf_T(result, 1);
    var b = new $c_scm_StringBuilder().init___();
    var elem$1 = false;
    elem$1 = true;
    b.append__T__scm_StringBuilder("");
    var i = 0;
    var len = remaining.u.length;
    while ((i < len)) {
      var index = i;
      var arg1 = remaining.get(index);
      if (elem$1) {
        b.append__O__scm_StringBuilder(arg1);
        elem$1 = false
      } else {
        b.append__T__scm_StringBuilder("/");
        b.append__O__scm_StringBuilder(arg1)
      };
      i = ((1 + i) | 0)
    };
    b.append__T__scm_StringBuilder("");
    return ((protocol + "://") + b.underlying$5.java$lang$StringBuilder$$content$f)
  } else {
    var xs$3 = $m_sjsr_RuntimeString$().split__T__T__I__AT(url, "/", 0);
    var until$1 = (((-1) + xs$3.u.length) | 0);
    var x$1 = ((until$1 > 0) ? until$1 : 0);
    var y$1 = xs$3.u.length;
    var hi$1 = ((x$1 < y$1) ? x$1 : y$1);
    var size$1 = ((hi$1 > 0) ? hi$1 : 0);
    var result$1 = $m_jl_reflect_Array$().newInstance__jl_Class__I__O($objectGetClass(xs$3).getComponentType__jl_Class(), size$1);
    if ((size$1 > 0)) {
      $m_s_Array$().copy__O__I__O__I__I__V(xs$3, 0, result$1, 0, size$1)
    };
    var xs$4 = $asArrayOf_O(result$1, 1);
    var b$1 = new $c_scm_StringBuilder().init___();
    var elem$1$1 = false;
    elem$1$1 = true;
    b$1.append__T__scm_StringBuilder("");
    var i$1 = 0;
    var len$1 = xs$4.u.length;
    while ((i$1 < len$1)) {
      var index$1 = i$1;
      var arg1$1 = xs$4.get(index$1);
      if (elem$1$1) {
        b$1.append__O__scm_StringBuilder(arg1$1);
        elem$1$1 = false
      } else {
        b$1.append__T__scm_StringBuilder("/");
        b$1.append__O__scm_StringBuilder(arg1$1)
      };
      i$1 = ((1 + i$1) | 0)
    };
    b$1.append__T__scm_StringBuilder("");
    return b$1.underlying$5.java$lang$StringBuilder$$content$f
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser.prototype.parseLink__T__Lamf_core_model_domain_LinkNode = (function(linkText) {
  if (($uI(linkText.indexOf(":")) !== (-1))) {
    var this$4 = $m_Lamf_core_model_domain_LinkNode$();
    var this$7 = this$4.apply__T__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_LinkNode(linkText, linkText, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
    var value = new $c_Lamf_core_utils_package$AmfStrings().init___T(linkText).normalizeUrl__T();
    return $as_Lamf_core_model_domain_LinkNode($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$7, value))
  } else {
    var this$8 = this.parent$1;
    var thiz = $as_T((this$8.isEmpty__Z() ? "#" : this$8.get__O()));
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "#", 0);
    var this$11 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    var localUrl = $as_T($f_sc_IndexedSeqOptimized__head__O(this$11));
    var leftLink = ($m_sjsr_RuntimeString$().endsWith__T__T__Z(localUrl, "/") ? localUrl : (this.baseUrl__T__T(localUrl) + "/"));
    if ((($uI(linkText.length) >= 0) && ($as_T(linkText.substring(0, $uI("/".length))) === "/"))) {
      var this$18 = new $c_sci_StringOps().init___T(linkText);
      var $$this = this$18.repr$1;
      var until = $uI($$this.length);
      var rightLink = $m_sci_StringOps$().slice$extension__T__I__I__T(this$18.repr$1, 1, until)
    } else {
      var rightLink = linkText
    };
    var finalLink = this.normalizeUrl__T__T((("" + leftLink) + rightLink));
    var this$21 = $m_Lamf_core_model_domain_LinkNode$();
    var this$23 = this$21.apply__T__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_LinkNode(linkText, finalLink, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
    return $as_Lamf_core_model_domain_LinkNode($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$23, finalLink))
  }
});
function $as_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.common.ScalarNodeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.common.ScalarNodeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.ScalarNodeParser", {
  Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser() {
  $c_O.call(this);
  this.shape$1 = null;
  this.map$1 = null;
  this.ctx$1 = null;
  this.typeInfo$1 = null;
  this.overrideSyntax$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser.prototype.productPrefix__T = (function() {
  return "ShapeExtensionParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser)) {
    var ShapeExtensionParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser(x$1);
    var x = this.shape$1;
    var x$2 = ShapeExtensionParser$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var this$1 = this.map$1;
      var b = ShapeExtensionParser$1.map$1;
      var jsx$3 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$3 = this.ctx$1;
      var x$4 = ShapeExtensionParser$1.ctx$1;
      var jsx$2 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.typeInfo$1;
      var x$6 = ShapeExtensionParser$1.typeInfo$1;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.overrideSyntax$1;
      var x$8 = ShapeExtensionParser$1.overrideSyntax$1;
      return ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.map$1;
      break
    }
    case 2: {
      return this.ctx$1;
      break
    }
    case 3: {
      return this.typeInfo$1;
      break
    }
    case 4: {
      return this.overrideSyntax$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser.prototype.validateCustomFacetDefinitions__T__V = (function(syntax) {
  var this$1 = this.ctx$1.syntax__Lamf_plugins_document_webapi_parser_spec_SpecSyntax().nodes__sci_Map().get__O__s_Option(syntax);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var builtInFacets = $as_sci_Set(arg1);
    var this$2 = this.shape$1;
    var jsx$2 = $as_sc_Seq(this$2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().CustomShapePropertyDefinitions__Lamf_core_metamodel_Field()));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$5$2) {
        var x$5 = $as_Lamf_core_model_domain_extensions_PropertyShape(x$5$2);
        var xo = $as_Lamf_core_model_StrField(x$5.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
        return xo.toList__sci_List()
      })
    })(this));
    var this$4 = $m_sc_Seq$();
    var definedCustomFacets = $as_sc_Seq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2));
    var jsx$4 = $as_sc_TraversableLike(this.shape$1.collectCustomShapePropertyDefinitions__Z__scm_Set__sc_Seq(true, $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))).flatten__F1__sc_GenTraversable($m_s_Predef$().singleton$und$less$colon$less$2));
    var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(x$6$2) {
        var x$6 = $as_T2(x$6$2);
        return $as_T(x$6.$$und1__O())
      })
    })(this));
    var this$6 = $m_sc_Seq$();
    var inheritedCustomFacets = $as_sc_Seq(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$6.ReusableCBFInstance$2));
    $as_sc_IterableLike(definedCustomFacets.toSet__sci_Set().intersect__sc_GenSet__O(builtInFacets)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
      return (function(name$2) {
        var name = $as_T(name$2);
        var this$7 = this$3$1.ctx$1.eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().UserDefinedFacetMatchesBuiltInFacets$1;
        var node = this$3$1.shape$1.id$1;
        var message = (("Custom defined facet '" + name) + "' matches built-in type facets");
        var ast = this$3$1.map$1;
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$7, specification, node, prop, message, l)
      })
    })(this)));
    $as_sc_IterableLike(definedCustomFacets.intersect__sc_GenSeq__O(inheritedCustomFacets)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
      return (function(name$3$2) {
        var name$3 = $as_T(name$3$2);
        var this$8 = this$4$1.ctx$1.eh$1;
        var specification$1 = $m_Lamf_validations_ParserSideValidations$().UserDefinedFacetMatchesAncestorsTypeFacets$1;
        var node$1 = this$4$1.shape$1.id$1;
        var message$1 = (("Custom defined facet '" + name$3) + "' matches custom facet from inherited type");
        var ast$1 = this$4$1.map$1;
        var prop$1 = $m_s_None$();
        var l$1 = ast$1.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$8, specification$1, node$1, prop$1, message$1, l$1)
      })
    })(this)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser.prototype.parse__V = (function() {
  var jsx$2 = this.shape$1.collectCustomShapePropertyDefinitions__Z__scm_Set__sc_Seq(true, $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_sci_Map(x$1$2);
      return new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(x$1)
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  var inheritedDefinitions = $as_sc_Seq($as_sc_SeqLike(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2)).distinct__O());
  var jsx$4 = this.shape$1.effectiveInherits__sc_Seq();
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_model_domain_Shape(x$2$2);
      return $as_sc_Seq(x$2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().CustomShapePropertyDefinitions__Lamf_core_metamodel_Field()))
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  var directlyInherited = $as_sc_Seq(jsx$4.flatMap__F1__scg_CanBuildFrom__O(jsx$3, this$3.ReusableCBFInstance$2));
  inheritedDefinitions.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, directlyInherited$1) {
    return (function(shapeExtensionDefinition$2) {
      var shapeExtensionDefinition = $as_Lamf_core_model_domain_extensions_PropertyShape(shapeExtensionDefinition$2);
      var x1 = this$3$1.ctx$1.vendor__Lamf_core_remote_Vendor();
      if ($is_Lamf_core_remote_Raml(x1)) {
        var this$4 = $as_Lamf_core_model_StrField(shapeExtensionDefinition.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
        var this$5 = this$4.option$1;
        var extensionKey = $as_T((this$5.isEmpty__Z() ? null : this$5.get__O()))
      } else if ($is_Lamf_core_remote_Oas(x1)) {
        var this$6 = $as_Lamf_core_model_StrField(shapeExtensionDefinition.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
        var this$7 = this$6.option$1;
        var str = ("facet-" + $as_T((this$7.isEmpty__Z() ? null : this$7.get__O())));
        var extensionKey = new $c_Lamf_core_utils_package$AmfStrings().init___T(str).asOasExtension__T()
      } else {
        var this$9 = this$3$1.ctx$1.eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().UnableToParseShapeExtensions$1;
        var node = this$3$1.shape$1.id$1;
        var message = ("Cannot parse shape extension for vendor " + this$3$1.ctx$1.vendor__Lamf_core_remote_Vendor());
        var ast = this$3$1.map$1;
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$9, specification, node, prop, message, l);
        var this$10 = $as_Lamf_core_model_StrField(shapeExtensionDefinition.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
        var this$11 = this$10.option$1;
        var extensionKey = $as_T((this$11.isEmpty__Z() ? null : this$11.get__O()))
      };
      var map = this$3$1.map$1;
      var x1$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(extensionKey);
      if ((x1$2 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1$2);
        var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
        var x$1$1 = entry.value$2;
        var x$2$1 = new $c_s_Some().init___O(((this$3$1.shape$1.id$1 + "/extension/") + extensionKey));
        var x$3 = new $c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables().init___();
        var x$4 = this$3$1.ctx$1;
        var dataNode = $m_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser(x$1$1, x$3, x$2$1, x$4).parse__Lamf_core_model_domain_DataNode();
        var this$14 = $m_Lamf_core_model_domain_extensions_ShapeExtension$().apply__Lorg_yaml_model_YPart__Lamf_core_model_domain_extensions_ShapeExtension(entry);
        var field = $m_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$().DefinedBy$1;
        var this$15 = $as_Lamf_core_model_domain_extensions_ShapeExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$14, field, shapeExtensionDefinition));
        var field$1 = $m_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$().Extension$1;
        var extension = $as_Lamf_core_model_domain_extensions_ShapeExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$15, field$1, dataNode));
        var this$16 = this$3$1.shape$1;
        var field$2 = $m_Lamf_core_metamodel_domain_ShapeModel$().CustomShapeProperties__Lamf_core_metamodel_Field();
        return $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$16, field$2, extension)
      } else {
        var x = $m_s_None$();
        if (((x === x1$2) && directlyInherited$1.contains__O__Z(shapeExtensionDefinition))) {
          var this$17 = $as_Lamf_core_model_IntField(shapeExtensionDefinition.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1)).option$1;
          if ((!this$17.isEmpty__Z())) {
            var arg1 = this$17.get__O();
            var x$3$2 = $uI(arg1);
            var jsx$5 = (x$3$2 > 0)
          } else {
            var jsx$5 = false
          };
          if (jsx$5) {
            var this$18 = this$3$1.ctx$1.eh$1;
            var specification$1 = $m_Lamf_validations_ParserSideValidations$().MissingRequiredUserDefinedFacet$1;
            var node$1 = this$3$1.shape$1.id$1;
            var message$1 = (("Missing required facet '" + extensionKey) + "'");
            var ast$1 = this$3$1.map$1;
            var prop$1 = $m_s_None$();
            var l$1 = ast$1.location$1;
            $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$18, specification$1, node$1, prop$1, message$1, l$1);
            return (void 0)
          } else {
            return (void 0)
          }
        } else {
          return (void 0)
        }
      }
    })
  })(this, directlyInherited)));
  var this$19 = this.shape$1;
  if ((!$as_sc_Seq(this$19.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
    return (function(s$2) {
      var s = $as_Lamf_core_model_domain_Shape(s$2);
      return s.isUnresolved$1
    })
  })(this))))) {
    var x1$1 = this.overrideSyntax$1;
    matchEnd14: {
      var jsx$6;
      if ((x1$1 instanceof $c_s_Some)) {
        var x2$1 = $as_s_Some(x1$1);
        var p3 = $as_T(x2$1.value$2);
        if ((p3 === "anyShape")) {
          var jsx$6 = true;
          break matchEnd14
        }
      };
      if ((x1$1 instanceof $c_s_Some)) {
        var x4 = $as_s_Some(x1$1);
        var p5 = $as_T(x4.value$2);
        if ((p5 === "shape")) {
          var jsx$6 = true;
          break matchEnd14
        }
      };
      var jsx$6 = false
    };
    if (jsx$6) {
      var syntax = this.shape$1.ramlSyntaxKey__T()
    } else if ((x1$1 instanceof $c_s_Some)) {
      var x6 = $as_s_Some(x1$1);
      var other = $as_T(x6.value$2);
      var syntax = other
    } else {
      var x$5 = $m_s_None$();
      if ((!(x$5 === x1$1))) {
        throw new $c_s_MatchError().init___O(x1$1)
      };
      var syntax = this.shape$1.ramlSyntaxKey__T()
    };
    var jsx$7 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1) {
      return (function(x$4$2) {
        var x$4$1 = $as_Lamf_core_model_domain_extensions_PropertyShape(x$4$2);
        var xo = $as_Lamf_core_model_StrField(x$4$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
        return xo.toList__sci_List()
      })
    })(this));
    var this$21 = $m_sc_Seq$();
    var extensionsNames = $as_sc_Seq(inheritedDefinitions.flatMap__F1__scg_CanBuildFrom__O(jsx$7, this$21.ReusableCBFInstance$2));
    var m = $m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap($as_sc_IndexedSeq(this.map$1.entries$3.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1, extensionsNames$1) {
      return (function(e$2) {
        var e = $as_Lorg_yaml_model_YMapEntry(e$2);
        return (!extensionsNames$1.contains__O__Z(e.key$2.value__Lorg_yaml_model_YValue().toString__T()))
      })
    })(this, extensionsNames)))), "");
    this.ctx$1.closedRamlTypeShape__Lamf_core_model_domain_Shape__Lorg_yaml_model_YMap__T__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__V(this.shape$1, m, syntax, this.typeInfo$1);
    this.validateCustomFacetDefinitions__T__V(syntax)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser.prototype.init___Lamf_core_model_domain_Shape__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__s_Option = (function(shape, map, ctx, typeInfo, overrideSyntax) {
  this.shape$1 = shape;
  this.map$1 = map;
  this.ctx$1 = ctx;
  this.typeInfo$1 = typeInfo;
  this.overrideSyntax$1 = overrideSyntax;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.common.ShapeExtensionParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.common.ShapeExtensionParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.ShapeExtensionParser", {
  Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser() {
  $c_O.call(this);
  this.declaration$1 = null;
  this.parent$1 = null;
  this.map$1 = null;
  this.ctx$1 = null;
  this.key$1 = null;
  this.annotations$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser.prototype.productPrefix__T = (function() {
  return "AbstractDeclarationParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser)) {
    var AbstractDeclarationParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser(x$1);
    var x = this.declaration$1;
    var x$2 = AbstractDeclarationParser$1.declaration$1;
    if ((((x === null) ? (x$2 === null) : x.equals__O__Z(x$2)) && (this.parent$1 === AbstractDeclarationParser$1.parent$1))) {
      var x$3 = this.map$1;
      var x$4 = AbstractDeclarationParser$1.map$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.declaration$1;
      break
    }
    case 1: {
      return this.parent$1;
      break
    }
    case 2: {
      return this.map$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser.prototype.init___Lamf_core_model_domain_templates_AbstractDeclaration__T__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(declaration, parent, map, ctx) {
  this.declaration$1 = declaration;
  this.parent$1 = parent;
  this.map$1 = map;
  this.ctx$1 = ctx;
  var this$1 = map.key__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_Lorg_yaml_model_YNode(arg1);
    var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv = this.ctx$1;
    var this$2 = new $c_s_Some().init___O($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(x$1, conversion, iv)).text$3)
  };
  if (this$2.isEmpty__Z()) {
    var x1 = this.declaration$1;
    var jsx$1 = ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_templates_Trait) ? "trait" : ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_templates_ResourceType) ? "resourceType" : "abstractDeclaration"))
  } else {
    var jsx$1 = this$2.get__O()
  };
  this.key$1 = $as_T(jsx$1);
  this.annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(map.annotations__Lamf_core_parser_Annotations());
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser.prototype.parseReferenced__Lamf_core_model_domain_templates_AbstractDeclaration__T__Lorg_yaml_model_YPart__Lamf_core_model_domain_templates_AbstractDeclaration = (function(declared, parsedUrl, ast) {
  if ((declared instanceof $c_Lamf_plugins_domain_webapi_models_templates_Trait)) {
    var d = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations().findTraitOrError__Lorg_yaml_model_YPart__T__Lamf_core_parser_SearchScope$Scope__Lamf_plugins_domain_webapi_models_templates_Trait(ast, parsedUrl, $m_Lamf_core_parser_SearchScope$Fragments$())
  } else {
    if ((!(declared instanceof $c_Lamf_plugins_domain_webapi_models_templates_ResourceType))) {
      throw new $c_s_MatchError().init___O(declared)
    };
    var d = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations().findResourceTypeOrError__Lorg_yaml_model_YPart__T__Lamf_core_parser_SearchScope$Scope__Lamf_plugins_domain_webapi_models_templates_ResourceType(ast, parsedUrl, $m_Lamf_core_parser_SearchScope$Fragments$())
  };
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast);
  var copied = $as_Lamf_core_model_domain_templates_AbstractDeclaration($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(d, parsedUrl, annotations));
  copied.withId__T__Lamf_core_model_domain_AmfObject(d.id$1);
  var name = this.key$1;
  var a = this.annotations$1;
  return $as_Lamf_core_model_domain_templates_AbstractDeclaration($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(copied, name, a))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser.prototype.parse__Lamf_core_model_domain_templates_AbstractDeclaration = (function() {
  var entryValue = this.map$1.value__Lorg_yaml_model_YNode();
  var x = entryValue.tag__Lorg_yaml_model_YTag().tagType$3;
  var x$2 = $m_Lorg_yaml_model_YType$().Null$1;
  if ((x === x$2)) {
    var this$1 = this.ctx$1.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().NullAbstractDeclaration$1;
    var node = this.parent$1;
    var property = $m_s_None$();
    var location = entryValue.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, node, property, "Generating abstract declaration (resource type / trait)  with null value", location)
  };
  var x1 = this.ctx$1.link__Lorg_yaml_model_YNode__s_util_Either(entryValue);
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var link = $as_T(x2.value$2);
    var qual$1 = this.parseReferenced__Lamf_core_model_domain_templates_AbstractDeclaration__T__Lorg_yaml_model_YPart__Lamf_core_model_domain_templates_AbstractDeclaration(this.declaration$1, link, entryValue);
    var x$1 = this.parent$1;
    $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    return $as_Lamf_core_model_domain_templates_AbstractDeclaration($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1))
  } else if ((x1 instanceof $c_s_util_Right)) {
    var x3 = $as_s_util_Right(x1);
    var value = $as_Lorg_yaml_model_YNode(x3.value$2);
    var variables = new $c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables().init___();
    var thiz = this.parent$1;
    if (($uI(thiz.indexOf("#")) !== (-1))) {
      var parentUri = ((this.parent$1 + "/") + this.key$1)
    } else {
      var parentUri = ((this.parent$1 + "#/") + this.key$1)
    };
    var x1$2 = value.tag__Lorg_yaml_model_YTag().tagType$3;
    var x$3 = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x$3 === x1$2)) {
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = this.ctx$1;
      var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(value, conversion, iv));
      var this$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
      var this$7 = this$6.key__T__s_Option("usage");
      if ((!this$7.isEmpty__Z())) {
        var arg1 = this$7.get__O();
        var usage = $as_Lorg_yaml_model_YMapEntry(arg1);
        var this$9 = this.declaration$1;
        var field = $m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().Description$1;
        var this$8 = usage.value$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv$1 = this.ctx$1;
        var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$8, conversion$1, iv$1), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(usage));
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$9, field, value$1)
      };
      var conversion$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv$2 = this.ctx$1;
      var fields = $as_sc_IndexedSeq($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(value, conversion$2, iv$2)).entries$3.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
        return (function(x$2$3$2) {
          var x$2$3 = $as_Lorg_yaml_model_YMapEntry(x$2$3$2);
          var this$10 = x$2$3.key$2;
          var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
          var iv$3 = this$2$1.ctx$1;
          return ($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$10, conversion$3, iv$3)).text$3 !== "usage")
        })
      })(this))));
      $m_Lorg_yaml_model_YNode$();
      var jsx$1 = $m_Lorg_yaml_model_YMap$();
      var this$11 = fields.headOption__s_Option();
      if (this$11.isEmpty__Z()) {
        var this$12 = $m_s_None$()
      } else {
        var arg1$1 = this$11.get__O();
        var x$3$2 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
        var this$12 = new $c_s_Some().init___O(x$3$2.location$1.sourceName$1)
      };
      var map$1 = jsx$1.apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(fields, $as_T((this$12.isEmpty__Z() ? "" : this$12.get__O())));
      $m_Lorg_yaml_model_YNode$();
      var filteredNode = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map$1, $m_Lorg_yaml_model_YType$().Map$1)
    } else {
      var filteredNode = value
    };
    var dataNode = $m_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser(filteredNode, variables, new $c_s_Some().init___O(parentUri), this.ctx$1).parse__Lamf_core_model_domain_DataNode();
    var this$15 = this.declaration$1;
    var name = this.key$1;
    var a = this.annotations$1;
    var qual$2 = $as_Lamf_core_model_domain_templates_AbstractDeclaration($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$15, name, a));
    var x$3$3 = this.parent$1;
    $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var this$16 = $as_Lamf_core_model_domain_templates_AbstractDeclaration($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$2, x$3$3));
    var field$1 = $m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().DataNode$1;
    $as_Lamf_core_model_domain_templates_AbstractDeclaration($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$16, field$1, dataNode));
    var this$17 = variables.variables$1;
    if ($f_sc_TraversableOnce__nonEmpty__Z(this$17)) {
      var this$18 = variables.variables$1;
      var arg1$2 = $f_scm_SetLike__toSeq__sc_Seq(this$18);
      var this$19 = this.declaration$1;
      var field$2 = $m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().Variables$1;
      $as_Lamf_core_model_domain_templates_AbstractDeclaration($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$19, field$2, arg1$2))
    };
    return this.declaration$1
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.AbstractDeclarationParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.AbstractDeclarationParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.AbstractDeclarationParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser() {
  $c_O.call(this);
  this.key$1 = null;
  this.producer$1 = null;
  this.map$1 = null;
  this.customProperties$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser.prototype.productPrefix__T = (function() {
  return "AbstractDeclarationsParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser)) {
    var AbstractDeclarationsParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser(x$1);
    if ((this.key$1 === AbstractDeclarationsParser$1.key$1)) {
      var x = this.producer$1;
      var x$2 = AbstractDeclarationsParser$1.producer$1;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var this$1 = this.map$1;
      var b = AbstractDeclarationsParser$1.map$1;
      var jsx$1 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.customProperties$1 === AbstractDeclarationsParser$1.customProperties$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.producer$1;
      break
    }
    case 2: {
      return this.map$1;
      break
    }
    case 3: {
      return this.customProperties$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser.prototype.parse__V = (function() {
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword = this.key$1;
  var this$3 = this$2.key__T__s_Option(keyword);
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = e.value$2;
    var x1 = this$4.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x === x1)) {
      var this$5 = e.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = this.ctx$1;
      var jsx$3 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv)).entries$3;
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(entry$2) {
          var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
          var jsx$2 = $this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations();
          var this$6 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$().apply__Lamf_core_model_domain_templates_AbstractDeclaration__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser($as_Lamf_core_model_domain_templates_AbstractDeclaration($this.producer$1.apply__O__O(entry)), $this.customProperties$1, entry, $this.ctx$1).parse__Lamf_core_model_domain_templates_AbstractDeclaration();
          var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
          return jsx$2.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$6, annotation)))
        })
      })(this));
      var this$7 = $m_sc_IndexedSeq$();
      jsx$3.map__F1__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBF$6)
    } else {
      var x$3 = $m_Lorg_yaml_model_YType$().Null$1;
      if ((!(x$3 === x1))) {
        var this$8 = this.ctx$1.eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().InvalidAbstractDeclarationType$1;
        var node = this.customProperties$1;
        var message = (((("Invalid type " + x1) + " for '") + this.key$1) + "' node.");
        var ast = e.value$2;
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$8, specification, node, prop, message, l)
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser.prototype.init___T__F1__Lorg_yaml_model_YMap__T__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(key, producer, map, customProperties, ctx) {
  this.key$1 = key;
  this.producer$1 = producer;
  this.map$1 = map;
  this.customProperties$1 = customProperties;
  this.ctx$1 = ctx;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.AbstractDeclarationsParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.AbstractDeclarationsParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.AbstractDeclarationsParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter() {
  $c_O.call(this);
  this.element$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter.prototype.productPrefix__T = (function() {
  return "AnnotationsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter)) {
    var AnnotationsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter(x$1);
    var x = this.element$1;
    var x$2 = AnnotationsEmitter$1.element$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = AnnotationsEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.element$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter.prototype.emitters__sc_Seq = (function() {
  var this$1 = this.element$1;
  var jsx$2 = $as_sc_TraversableLike($as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field())).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_domain_extensions_DomainExtension(x$1$2);
      return (!$as_Lamf_core_model_domain_DataNode(x$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)).annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.getClassOf()))
    })
  })(this))));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_model_domain_extensions_DomainExtension(x$2$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter(this$2.spec$1.factory__Lamf_plugins_document_webapi_contexts_SpecEmitterFactory().annotationEmitter__F2().apply__O__O__O(x$2, this$2.ordering$1))
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter.prototype.init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(element, ordering, spec) {
  this.element$1 = element;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.AnnotationsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.AnnotationsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.AnnotationsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter() {
  $c_O.call(this);
  this.field$1 = null;
  this.ordering$1 = null;
  this.oasExtension$1 = false;
  this.eh$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter.prototype.productPrefix__T = (function() {
  return "ExtendsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter)) {
    var ExtendsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter(x$1);
    var x = this.field$1;
    var x$2 = ExtendsEmitter$1.field$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = ExtendsEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.oasExtension$1 === ExtendsEmitter$1.oasExtension$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.field$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.oasExtension$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter.prototype.emitters__sc_Seq = (function() {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = this.field$1;
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(this$1.value$1.value$1).values$1;
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter(this);
  var this$2 = $m_sc_Seq$();
  var resourceTypes = $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  if (resourceTypes.nonEmpty__Z()) {
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_core_errorhandling_ErrorHandler(this.extension__p1__T__T("type"), resourceTypes, this.ordering$1, this.eh$1))
  };
  var this$3 = this.field$1;
  var jsx$4 = $as_Lamf_core_model_domain_AmfArray(this$3.value$1.value$1).values$1;
  var jsx$3 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$2().init___Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter(this);
  var this$4 = $m_sc_Seq$();
  var traits = $as_sc_Seq(jsx$4.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$3, this$4.ReusableCBFInstance$2));
  if (traits.nonEmpty__Z()) {
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_core_errorhandling_ErrorHandler(this.extension__p1__T__T("is"), this.field$1, this.ordering$1, this.eh$1))
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter.prototype.extension__p1__T__T = (function(key) {
  return (this.oasExtension$1 ? new $c_Lamf_core_utils_package$AmfStrings().init___T(key).asOasExtension__T() : key)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lamf_core_errorhandling_ErrorHandler = (function(field, ordering, oasExtension, eh) {
  this.field$1 = field;
  this.ordering$1 = ordering;
  this.oasExtension$1 = oasExtension;
  this.eh$1 = eh;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.field$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ordering$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.oasExtension$1 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 3)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.ExtendsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.ExtendsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.ExtendsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter() {
  $c_O.call(this);
  this.element$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter.prototype.productPrefix__T = (function() {
  return "FacetsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(element, ordering, spec) {
  this.element$1 = element;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter)) {
    var FacetsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter(x$1);
    var x = this.element$1;
    var x$2 = FacetsEmitter$1.element$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = FacetsEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.element$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter.prototype.emitters__sc_Seq = (function() {
  var this$1 = this.element$1;
  var jsx$2 = $as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().CustomShapeProperties__Lamf_core_metamodel_Field()));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(extension$2) {
      var extension = $as_Lamf_core_model_domain_extensions_ShapeExtension(extension$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter($this.spec$1.factory__Lamf_plugins_document_webapi_contexts_SpecEmitterFactory().facetsInstanceEmitter__F2().apply__O__O__O(extension, $this.ordering$1))
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.FacetsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.FacetsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.FacetsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser() {
  $c_O.call(this);
  this.e$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser.prototype.productPrefix__T = (function() {
  return "LibraryLocationParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser)) {
    var LibraryLocationParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser(x$1);
    var x = this.e$1;
    var x$2 = LibraryLocationParser$1.e$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.e$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser.prototype.parse__Lamf_core_parser_ParserContext__s_Option = (function(ctx) {
  var this$1 = this.e$1.value$2;
  var x1 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Null$1;
  if ((x === x1)) {
    var jsx$1 = true
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x$3 === x1)) {
      var jsx$1 = true
    } else {
      var x$5 = $m_Lorg_yaml_model_YType$().Seq$1;
      var jsx$1 = (x$5 === x1)
    }
  };
  if (jsx$1) {
    return $m_s_None$()
  } else {
    var this$2 = this.e$1.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
    return new $c_s_Some().init___O($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, ctx)).text$3)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser.prototype.init___Lorg_yaml_model_YMapEntry = (function(e) {
  this.e$1 = e;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.LibraryLocationParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.LibraryLocationParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.LibraryLocationParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser() {
  $c_O.call(this);
  this.entry$1 = null;
  this.properties$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser.prototype.productPrefix__T = (function() {
  return "NodeDependencyParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser)) {
    var NodeDependencyParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser(x$1);
    var x = this.entry$1;
    var x$2 = NodeDependencyParser$1.entry$1;
    if ((x === x$2)) {
      var x$3 = this.properties$1;
      var x$4 = NodeDependencyParser$1.properties$1;
      return ((x$3 === null) ? (x$4 === null) : $f_sc_GenMapLike__equals__O__Z(x$3, x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$1;
      break
    }
    case 1: {
      return this.properties$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser.prototype.init___Lorg_yaml_model_YMapEntry__scm_LinkedHashMap__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(entry, properties, ctx) {
  this.entry$1 = entry;
  this.properties$1 = properties;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser.prototype.parse__s_Option = (function() {
  var jsx$1 = this.properties$1;
  var this$1 = this.entry$1.key$2;
  var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
  var iv = this.ctx$1;
  var this$2 = jsx$1.get__O__s_Option($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3);
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var p = $as_Lamf_core_model_domain_extensions_PropertyShape(arg1);
    var this$4 = $m_Lamf_plugins_domain_shapes_models_PropertyDependencies$().apply__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_shapes_models_PropertyDependencies(this.entry$1);
    var field = $m_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$().PropertySource$1;
    var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(p.id$1, new $c_Lamf_core_parser_Annotations().init___());
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1.key$2);
    var this$6 = $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$4, field, value, annotations);
    var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$().PropertyTarget$1;
    var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(this.targets__p1__sc_Seq(), new $c_Lamf_core_parser_Annotations().init___());
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1.value$2);
    return new $c_s_Some().init___O($as_Lamf_plugins_domain_shapes_models_PropertyDependencies($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$6, field$1, value$1, annotations$1)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser.prototype.targets__p1__sc_Seq = (function() {
  var this$1 = $m_Lamf_plugins_document_webapi_parser_spec_common_SingleArrayNode$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_core_parser_ArrayNode(this.entry$1.value$2, this.ctx$1);
  var jsx$2 = this$1.text__Lamf_core_model_domain_AmfArray().scalars__sc_Seq();
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(v$2) {
      var v = $as_Lamf_core_model_domain_AmfScalar(v$2);
      var this$2 = $this.properties$1.get__O__s_Option($objectToString(v.value$1));
      if (this$2.isEmpty__Z()) {
        var xo = $m_s_None$()
      } else {
        var arg1 = this$2.get__O();
        var p = $as_Lamf_core_model_domain_extensions_PropertyShape(arg1);
        var xo = new $c_s_Some().init___O(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(p.id$1, v.annotations$1))
      };
      return xo.toList__sci_List()
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.NodeDependencyParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.NodeDependencyParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.NodeDependencyParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter() {
  $c_O.call(this);
  this.document$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter.prototype.init___Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(document, ordering, spec) {
  this.document$1 = document;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter.prototype.productPrefix__T = (function() {
  return "OasCreativeWorkItemsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter)) {
    var OasCreativeWorkItemsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter(x$1);
    var x = this.document$1;
    var x$2 = OasCreativeWorkItemsEmitter$1.document$1;
    if ((x === x$2)) {
      var x$3 = this.ordering$1;
      var x$4 = OasCreativeWorkItemsEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.document$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter.prototype.emitters__sc_Seq = (function() {
  var fs = this.document$1.fields$1;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Url$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("url", f, $m_s_None$())))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Description$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f$3, $m_s_None$())))
  };
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Title$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1$2 = this$5.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("title").asOasExtension__T(), f$4, $m_s_None$())))
  };
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.document$1, this.ordering$1, this.spec$1).emitters__sc_Seq());
  return this.ordering$1.sorted__sc_Seq__sc_Seq(result)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasCreativeWorkItemsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasCreativeWorkItemsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasCreativeWorkItemsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser() {
  $c_O.call(this);
  this.array$1 = null;
  this.adopt$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser.prototype.productPrefix__T = (function() {
  return "AllOfParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__sc_Seq__F1 = (function($$outer, array, adopt) {
  this.array$1 = array;
  this.adopt$1 = adopt;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser(x$1).$$outer$1 === this.$$outer$1))) {
    var AllOfParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser(x$1);
    var x = this.array$1;
    var x$2 = AllOfParser$1.array$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.adopt$1;
      var x$4 = AllOfParser$1.adopt$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.array$1;
      break
    }
    case 1: {
      return this.adopt$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser.prototype.declarationsRef__p1__Lorg_yaml_model_YMap__s_Option = (function(entries) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(entries).key__T__s_Option("$ref");
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var jsx$1 = this.$$outer$1.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations().shapes$2;
    var this$3 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
    var iv = this.$$outer$1.ctx$2;
    var x = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv));
    var this$5 = new $c_sci_StringOps().init___T(x);
    var this$6 = jsx$1.get__O__s_Option($f_sci_StringLike__stripPrefix__T__T(this$5, "#/definitions/"));
    if (this$6.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1$1 = this$6.get__O();
      var declaration = $as_Lamf_core_model_domain_Shape(arg1$1);
      var this$7 = entry.value$2;
      var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
      var iv$1 = this.$$outer$1.ctx$2;
      var this$10 = $as_Lamf_plugins_domain_shapes_models_AnyShape(declaration.link__T__Lamf_core_parser_Annotations__O($as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$7, conversion$1, iv$1)), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2)));
      var this$8 = $as_Lamf_core_model_StrField(declaration.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
      var name = $as_T((this$8.isEmpty__Z() ? "schema" : this$8.get__O()));
      $m_Lamf_core_parser_Annotations$();
      var a = new $c_Lamf_core_parser_Annotations().init___();
      return new $c_s_Some().init___O($as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$10, name, a)))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser.prototype.parse__sc_Seq = (function() {
  var jsx$2 = this.array$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(n$2) {
      var n = $as_Lorg_yaml_model_YNode(n$2);
      var this$2 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(n).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YMapYRead$());
      if (this$2.isEmpty__Z()) {
        var this$3 = $m_s_None$()
      } else {
        var arg1 = this$2.get__O();
        var entries = $as_Lorg_yaml_model_YMap(arg1);
        var this$3 = $this.declarationsRef__p1__Lorg_yaml_model_YMap__s_Option(entries)
      };
      var xo = (this$3.isEmpty__Z() ? $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YNode__T__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(n, "", $this.adopt$1, $this.$$outer$1.version$2, $this.$$outer$1.ctx$2).parse__s_Option() : this$3);
      return xo.toList__sci_List()
    })
  })(this));
  var this$5 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$AllOfParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$AllOfParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$AllOfParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.shape$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser.prototype.productPrefix__T = (function() {
  return "AndConstraintParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser(x$1).$$outer$1 === this.$$outer$1))) {
    var AndConstraintParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser(x$1);
    var this$1 = this.map$1;
    var b = AndConstraintParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.shape$1;
      var x$2 = AndConstraintParser$1.shape$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.shape$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape = (function($$outer, map, shape) {
  this.map$1 = map;
  this.shape$1 = shape;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser.prototype.parse__V = (function() {
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("allOf");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    this.$$outer$1.adopt$2.apply__O__O(this.shape$1);
    var this$4 = entry.value$2;
    var evidence$2 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var x1 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$4, evidence$2);
    if ((x1 instanceof $c_s_util_Right)) {
      var x2 = $as_s_util_Right(x1);
      var seq = $as_sc_Seq(x2.value$2);
      var this$5 = $m_sc_Seq$();
      var jsx$4 = $as_sc_TraversableLike(seq.zipWithIndex__scg_CanBuildFrom__O(this$5.ReusableCBFInstance$2));
      var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x0$1$2) {
          var x0$1 = $as_T2(x0$1$2);
          if ((x0$1 !== null)) {
            var node = $as_Lorg_yaml_model_YNode(x0$1.$$und1__O());
            var index = x0$1.$$und2$mcI$sp__I();
            var entry$1 = $m_Lorg_yaml_model_YMapEntry$().apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry($m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(("item" + index)), node);
            return $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(entry$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, index$1) {
              return (function(item$2) {
                var item = $as_Lamf_core_model_domain_Shape(item$2);
                item.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject((($this$1.shape$1.id$1 + "/and/") + index$1), item.adopted$default$2__sc_Seq())
              })
            })($this, index)), $this.$$outer$1.version$2, $this.$$outer$1.ctx$2).parse__s_Option()
          } else {
            throw new $c_s_MatchError().init___O(x0$1)
          }
        })
      })(this));
      var this$6 = $m_sc_Seq$();
      var jsx$2 = $as_sc_TraversableLike($as_sc_TraversableLike(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$6.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
        return (function(x$14$2) {
          var x$14 = $as_s_Option(x$14$2);
          return x$14.isDefined__Z()
        })
      })(this))));
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
        return (function(x$15$2) {
          var x$15 = $as_s_Option(x$15$2);
          return $as_Lamf_plugins_domain_shapes_models_AnyShape(x$15.get__O())
        })
      })(this));
      var this$7 = $m_sc_Seq$();
      var andNodes = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
      var this$8 = this.shape$1;
      var field = $m_Lamf_core_metamodel_domain_ShapeModel$().And$1;
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
      $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$8, field, andNodes, annotations)
    } else {
      var this$9 = this.$$outer$1.ctx$2.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidAndType$1;
      var node$1 = this.shape$1.id$1;
      var ast = entry.value$2;
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$9, specification, node$1, prop, "And constraints are built from multiple shape nodes", l)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$AndConstraintParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$AndConstraintParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$AndConstraintParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AndConstraintParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser() {
  $c_O.call(this);
  this.name$1 = null;
  this.ast$1 = null;
  this.map$1 = null;
  this.adopt$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser.prototype.productPrefix__T = (function() {
  return "DataArrangementParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser.prototype.lookAhead__s_Option = (function() {
  var map = this.map$1;
  var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("items");
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    var this$2 = entry.value$2;
    var evidence$2 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var x1$2 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$2, evidence$2);
    if ((x1$2 instanceof $c_s_util_Right)) {
      $m_s_package$();
      var this$3 = $m_Lamf_plugins_domain_shapes_models_TupleShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_TupleShape(this.ast$1);
      var name = this.name$1;
      var a = this.$$outer$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
      var value = $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
      return new $c_s_Some().init___O(new $c_s_util_Left().init___O(value))
    } else {
      $m_s_package$();
      var this$5 = $m_Lamf_plugins_domain_shapes_models_ArrayShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_ArrayShape(this.ast$1);
      var name$1 = this.name$1;
      var a$1 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
      var value$1 = $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$5, name$1, a$1);
      return new $c_s_Some().init___O(new $c_s_util_Right().init___O(value$1))
    }
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return $m_s_None$()
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser(x$1).$$outer$1 === this.$$outer$1))) {
    var DataArrangementParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser(x$1);
    if ((this.name$1 === DataArrangementParser$1.name$1)) {
      var x = this.ast$1;
      var x$2 = DataArrangementParser$1.ast$1;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var this$1 = this.map$1;
      var b = DataArrangementParser$1.map$1;
      var jsx$1 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.adopt$1;
      var x$4 = DataArrangementParser$1.adopt$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.name$1;
      break
    }
    case 1: {
      return this.ast$1;
      break
    }
    case 2: {
      return this.map$1;
      break
    }
    case 3: {
      return this.adopt$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  var rc10 = false;
  var x2 = null;
  var x1 = this.lookAhead__s_Option();
  var x = $m_s_None$();
  if ((x === x1)) {
    var this$1 = $m_Lamf_plugins_domain_shapes_models_ArrayShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_ArrayShape(this.ast$1);
    var name = this.name$1;
    var a = this.$$outer$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
    var array = $as_Lamf_plugins_domain_shapes_models_ArrayShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$1, name, a));
    var shape = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_ArrayShape__Lorg_yaml_model_YMap__F1(this.$$outer$1, array, this.map$1, this.adopt$1).parse__Lamf_plugins_domain_shapes_models_AnyShape();
    this.validateMissingItemsField__p1__Lamf_core_model_domain_Shape__V(shape);
    return shape
  };
  if ((x1 instanceof $c_s_Some)) {
    rc10 = true;
    x2 = $as_s_Some(x1);
    var p3 = $as_s_util_Either(x2.value$2);
    if ((p3 instanceof $c_s_util_Left)) {
      var x4 = $as_s_util_Left(p3);
      var tuple = $as_Lamf_plugins_domain_shapes_models_TupleShape(x4.value$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_TupleShape__Lorg_yaml_model_YMap__F1(this.$$outer$1, tuple, this.map$1, this.adopt$1).parse__Lamf_plugins_domain_shapes_models_AnyShape()
    }
  };
  if (rc10) {
    var p6 = $as_s_util_Either(x2.value$2);
    if ((p6 instanceof $c_s_util_Right)) {
      var x7 = $as_s_util_Right(p6);
      var array$2 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(x7.value$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_ArrayShape__Lorg_yaml_model_YMap__F1(this.$$outer$1, array$2, this.map$1, this.adopt$1).parse__Lamf_plugins_domain_shapes_models_AnyShape()
    }
  };
  throw new $c_s_MatchError().init___O(x1)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__T__Lorg_yaml_model_YPart__Lorg_yaml_model_YMap__F1 = (function($$outer, name, ast, map, adopt) {
  this.name$1 = name;
  this.ast$1 = ast;
  this.map$1 = map;
  this.adopt$1 = adopt;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser.prototype.validateMissingItemsField__p1__Lamf_core_model_domain_Shape__V = (function(shape) {
  if ((this.$$outer$1.version$2 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion)) {
    var this$1 = this.$$outer$1.ctx$2.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().ItemsFieldRequired$1;
    var node = shape.id$1;
    var ast = this.map$1;
    var prop = $m_s_None$();
    var l = ast.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, node, prop, "'items' field is required when schema type is array", l)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$DataArrangementParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$DataArrangementParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$DataArrangementParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser() {
  $c_O.call(this);
  this.shape$1 = null;
  this.entry$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser.prototype.parseMappings__p1__Lorg_yaml_model_YMapEntry__V = (function(mappingEntry) {
  var this$1 = mappingEntry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.$$outer$1.ctx$2;
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var jsx$4 = map.entries$3;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var jsx$3 = $m_Lamf_plugins_domain_webapi_models_IriTemplateMapping$();
      var this$2 = entry.key$2;
      var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
      var iv$1 = $this.$$outer$1.ctx$2;
      var jsx$2 = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$1, iv$1));
      var this$3 = entry.value$2;
      var conversion$2 = $m_Lorg_yaml_convert_YRead$StringYRead$();
      var iv$2 = $this.$$outer$1.ctx$2;
      return jsx$3.apply__T__T__Lamf_plugins_domain_webapi_models_IriTemplateMapping(jsx$2, $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion$2, iv$2)))
    })
  })(this));
  var this$4 = $m_sc_IndexedSeq$();
  var mappings = $as_sc_IndexedSeq(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBF$6));
  var this$5 = this.shape$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().DiscriminatorMapping$1;
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(mappingEntry);
  $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$5, field, mappings, annotations)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser.prototype.productPrefix__T = (function() {
  return "DiscriminatorParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser(x$1).$$outer$1 === this.$$outer$1))) {
    var DiscriminatorParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser(x$1);
    var x = this.shape$1;
    var x$2 = DiscriminatorParser$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.entry$1;
      var x$4 = DiscriminatorParser$1.entry$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.entry$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser.prototype.parse__V = (function() {
  var this$1 = this.entry$1.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.$$outer$1.ctx$2;
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("propertyName");
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    var this$3 = this.$$outer$1;
    var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Discriminator$1;
    var iv$1 = this.$$outer$1.ctx$2;
    new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$3, field, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$1).apply__Lorg_yaml_model_YMapEntry__V(entry)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$4 = this.$$outer$1.ctx$2.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().DiscriminatorNameRequired$1;
      var node = this.shape$1.id$1;
      var prop = $m_s_None$();
      var l = map.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$4, specification, node, prop, "Discriminator must have a propertyName defined", l)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  var this$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$7 = this$6.key__T__s_Option("mapping");
  if ((!this$7.isEmpty__Z())) {
    var arg1 = this$7.get__O();
    var mappingEntry = $as_Lorg_yaml_model_YMapEntry(arg1);
    this.parseMappings__p1__Lorg_yaml_model_YMapEntry__V(mappingEntry)
  };
  this.$$outer$1.ctx$2.closedShape__T__Lorg_yaml_model_YMap__T__V(this.shape$1.id$1, map, "discriminator")
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_NodeShape__Lorg_yaml_model_YMapEntry = (function($$outer, shape, entry) {
  this.shape$1 = shape;
  this.entry$1 = entry;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$DiscriminatorParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$DiscriminatorParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$DiscriminatorParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser() {
  $c_O.call(this);
  this.key$1 = null;
  this.field$1 = null;
  this.map$1 = null;
  this.shape$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser.prototype.productPrefix__T = (function() {
  return "InnerShapeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__T__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape = (function($$outer, key, field, map, shape) {
  this.key$1 = key;
  this.field$1 = field;
  this.map$1 = map;
  this.shape$1 = shape;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser(x$1).$$outer$1 === this.$$outer$1))) {
    var InnerShapeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser(x$1);
    if ((this.key$1 === InnerShapeParser$1.key$1)) {
      var x = this.field$1;
      var x$2 = InnerShapeParser$1.field$1;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var this$1 = this.map$1;
      var b = InnerShapeParser$1.map$1;
      var jsx$1 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.shape$1;
      var x$4 = InnerShapeParser$1.shape$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.field$1;
      break
    }
    case 2: {
      return this.map$1;
      break
    }
    case 3: {
      return this.shape$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser.prototype.parse__V = (function() {
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword = this.key$1;
  var this$3 = this$2.key__T__s_Option(keyword);
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    this.$$outer$1.adopt$2.apply__O__O(this.shape$1);
    var x1 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(item$2) {
        var item = $as_Lamf_core_model_domain_Shape(item$2);
        item.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject((($this.shape$1.id$1 + "/") + $this.key$1), item.adopted$default$2__sc_Seq())
      })
    })(this)), this.$$outer$1.version$2, this.$$outer$1.ctx$2).parse__s_Option();
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var parsedShape = $as_Lamf_plugins_domain_shapes_models_AnyShape(x2.value$2);
      var this$4 = this.shape$1;
      var field = this.field$1;
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$4, field, parsedShape)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$InnerShapeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$InnerShapeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$InnerShapeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.shape$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser.prototype.productPrefix__T = (function() {
  return "OrConstraintParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser(x$1).$$outer$1 === this.$$outer$1))) {
    var OrConstraintParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser(x$1);
    var this$1 = this.map$1;
    var b = OrConstraintParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.shape$1;
      var x$2 = OrConstraintParser$1.shape$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.shape$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape = (function($$outer, map, shape) {
  this.map$1 = map;
  this.shape$1 = shape;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser.prototype.parse__V = (function() {
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("anyOf");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var evidence$2 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var x1 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$4, evidence$2);
    if ((x1 instanceof $c_s_util_Right)) {
      var x2 = $as_s_util_Right(x1);
      var seq = $as_sc_Seq(x2.value$2);
      var this$5 = $m_sc_Seq$();
      var jsx$4 = $as_sc_TraversableLike(seq.zipWithIndex__scg_CanBuildFrom__O(this$5.ReusableCBFInstance$2));
      var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x0$1$2) {
          var x0$1 = $as_T2(x0$1$2);
          if ((x0$1 !== null)) {
            var node = $as_Lorg_yaml_model_YNode(x0$1.$$und1__O());
            var index = x0$1.$$und2$mcI$sp__I();
            var entry$1 = $m_Lorg_yaml_model_YMapEntry$().apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry($m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(("item" + index)), node);
            return $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(entry$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, index$1) {
              return (function(item$2) {
                var item = $as_Lamf_core_model_domain_Shape(item$2);
                item.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject((($this$1.shape$1.id$1 + "/or/") + index$1), item.adopted$default$2__sc_Seq())
              })
            })($this, index)), $this.$$outer$1.version$2, $this.$$outer$1.ctx$2).parse__s_Option()
          } else {
            throw new $c_s_MatchError().init___O(x0$1)
          }
        })
      })(this));
      var this$6 = $m_sc_Seq$();
      var jsx$2 = $as_sc_TraversableLike($as_sc_TraversableLike(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$6.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
        return (function(x$12$2) {
          var x$12 = $as_s_Option(x$12$2);
          return x$12.isDefined__Z()
        })
      })(this))));
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
        return (function(x$13$2) {
          var x$13 = $as_s_Option(x$13$2);
          return $as_Lamf_plugins_domain_shapes_models_AnyShape(x$13.get__O())
        })
      })(this));
      var this$7 = $m_sc_Seq$();
      var unionNodes = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
      var this$8 = this.shape$1;
      var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Or$1;
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
      $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$8, field, unionNodes, annotations)
    } else {
      var this$9 = this.$$outer$1.ctx$2.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidOrType$1;
      var node$1 = this.shape$1.id$1;
      var ast = entry.value$2;
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$9, specification, node$1, prop, "Or constraints are built from multiple shape nodes", l)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$OrConstraintParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$OrConstraintParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$OrConstraintParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$OrConstraintParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.producer$1 = null;
  this.requiredFields$1 = null;
  this.patterned$1 = false;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lorg_yaml_model_YMap__F1__sci_Map__Z = (function($$outer, map, producer, requiredFields, patterned) {
  this.map$1 = map;
  this.producer$1 = producer;
  this.requiredFields$1 = requiredFields;
  this.patterned$1 = patterned;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser.prototype.productPrefix__T = (function() {
  return "PropertiesParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser(x$1).$$outer$1 === this.$$outer$1))) {
    var PropertiesParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser(x$1);
    var this$1 = this.map$1;
    var b = PropertiesParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.producer$1;
      var x$2 = PropertiesParser$1.producer$1;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$3 = this.requiredFields$1;
      var x$4 = PropertiesParser$1.requiredFields$1;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : $f_sc_GenMapLike__equals__O__Z(x$3, x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.patterned$1 === PropertiesParser$1.patterned$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.producer$1;
      break
    }
    case 2: {
      return this.requiredFields$1;
      break
    }
    case 3: {
      return this.patterned$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser.prototype.parse__sc_Seq = (function() {
  var jsx$2 = this.map$1.entries$3;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lorg_yaml_model_YMapEntry__F1__sci_Map__Z($this.$$outer$1, entry, $this.producer$1, $this.requiredFields$1, $this.patterned$1).parse__Lamf_core_model_domain_extensions_PropertyShape()
    })
  })(this));
  var this$1 = $m_sc_IndexedSeq$();
  return $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBF$6))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.map$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.producer$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.requiredFields$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.patterned$1 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 4)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$PropertiesParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$PropertiesParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$PropertiesParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser$() {
  $c_sr_AbstractFunction4.call(this);
  this.$$outer$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser$.prototype = new $h_sr_AbstractFunction4();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser$.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser$.prototype.apply__O__O__O__O__O = (function(v1, v2, v3, v4) {
  return this.apply__Lorg_yaml_model_YMap__F1__sci_Map__Z__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser($as_Lorg_yaml_model_YMap(v1), $as_F1(v2), $as_sci_Map(v3), $uZ(v4))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser$.prototype.toString__T = (function() {
  return "PropertiesParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser$.prototype.apply__Lorg_yaml_model_YMap__F1__sci_Map__Z__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser = (function(map, producer, requiredFields, patterned) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lorg_yaml_model_YMap__F1__sci_Map__Z(this.$$outer$2, map, producer, requiredFields, patterned)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$PropertiesParser$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser$: 1,
  sr_AbstractFunction4: 1,
  O: 1,
  F4: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser$;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser() {
  $c_O.call(this);
  this.entry$1 = null;
  this.producer$1 = null;
  this.requiredFields$1 = null;
  this.patterned$1 = false;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser.prototype.productPrefix__T = (function() {
  return "PropertyShapeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lorg_yaml_model_YMapEntry__F1__sci_Map__Z = (function($$outer, entry, producer, requiredFields, patterned) {
  this.entry$1 = entry;
  this.producer$1 = producer;
  this.requiredFields$1 = requiredFields;
  this.patterned$1 = patterned;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser(x$1).$$outer$1 === this.$$outer$1))) {
    var PropertyShapeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser(x$1);
    var x = this.entry$1;
    var x$2 = PropertyShapeParser$1.entry$1;
    if ((x === x$2)) {
      var x$3 = this.producer$1;
      var x$4 = PropertyShapeParser$1.producer$1;
      var jsx$2 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.requiredFields$1;
      var x$6 = PropertyShapeParser$1.requiredFields$1;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : $f_sc_GenMapLike__equals__O__Z(x$5, x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.patterned$1 === PropertyShapeParser$1.patterned$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$1;
      break
    }
    case 1: {
      return this.producer$1;
      break
    }
    case 2: {
      return this.requiredFields$1;
      break
    }
    case 3: {
      return this.patterned$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser.prototype.parse__Lamf_core_model_domain_extensions_PropertyShape = (function() {
  var this$1 = this.entry$1.key$2;
  var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
  var iv = this.$$outer$1.ctx$2;
  var name = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3;
  var required = this.requiredFields$1.contains__O__Z(name);
  var this$2 = this.requiredFields$1.get__O__s_Option(name);
  if (this$2.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var node = $as_Lorg_yaml_model_YNode(arg1);
    var this$3 = new $c_s_Some().init___O($m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(node))
  };
  var requiredAnnotations = $as_Lamf_core_parser_Annotations((this$3.isEmpty__Z() ? ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()) : this$3.get__O()));
  var this$5 = $as_Lamf_core_model_domain_AmfElement(this.producer$1.apply__O__O(name));
  var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1);
  var this$7 = $as_Lamf_core_model_domain_AmfObject($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$5, other));
  var field = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1;
  var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations((required ? 1 : 0), new $c_Lamf_core_parser_Annotations().init___());
  var annotations = requiredAnnotations.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ExplicitField().init___());
  var property = $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$7, field, value, annotations));
  var field$1 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Path$1;
  var this$12 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
  var this$8 = this.entry$1.key$2;
  var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
  var iv$1 = this.$$outer$1.ctx$2;
  var str = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$8, conversion$1, iv$1)).text$3;
  var this$10 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$11 = this$10.platform$1;
  var url = this$10.str$1;
  var id = $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$11, url);
  var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$12, id).iri__T(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1.key$2));
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(property, field$1, value$1);
  if ((this.$$outer$1.version$2 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion)) {
    var node$1 = this.entry$1.value$2;
    this.validateReadOnlyAndRequired__p1__s_Option__Lamf_core_model_domain_extensions_PropertyShape__Z__V(new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node$1).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YMapYRead$()), property, required)
  };
  var node$2 = this.entry$1.value$2;
  var this$16 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node$2).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YMapYRead$());
  if ((!this$16.isEmpty__Z())) {
    var arg1$1 = this$16.get__O();
    var x$27 = $as_Lorg_yaml_model_YMap(arg1$1);
    var this$18 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(x$27);
    var this$19 = this$18.key__T__s_Option("required");
    if ((!this$19.isEmpty__Z())) {
      var arg1$2 = this$19.get__O();
      var entry = $as_Lorg_yaml_model_YMapEntry(arg1$2);
      var this$20 = entry.value$2;
      var x = this$20.tag__Lorg_yaml_model_YTag().tagType$3;
      var x$2 = $m_Lorg_yaml_model_YType$().Bool$1;
      if ((x === x$2)) {
        var x$3 = this.$$outer$1.version$2;
        var x$4 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$();
        if ((((x$3 !== null) && x$3.equals__O__Z(x$4)) || (this.$$outer$1.version$2 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion))) {
          var this$21 = this.$$outer$1.ctx$2.eh$1;
          var specification = $m_Lamf_validations_ParserSideValidations$().InvalidRequiredBooleanForSchemaVersion$1;
          var node$3 = property.id$1;
          var prop = $m_s_None$();
          var l = entry.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$21, specification, node$3, prop, "Required property boolean value is only supported in JSON Schema draft-3", l)
        };
        var node$4 = entry.value$2;
        var iv$2 = this.$$outer$1.ctx$2;
        var this$23 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$4, iv$2);
        var required$1 = $uZ(this$23.$boolean__Lamf_core_model_domain_AmfScalar().value$1);
        var field$2 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1;
        var value$2 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations((required$1 ? 1 : 0), new $c_Lamf_core_parser_Annotations().init___());
        var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ExplicitField().init___());
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(property, field$2, value$2, annotations$1)
      }
    }
  };
  var this$25 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(this.entry$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, property$1) {
    return (function(shape$2) {
      var shape = $as_Lamf_core_model_domain_Shape(shape$2);
      shape.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(property$1.id$1, shape.adopted$default$2__sc_Seq())
    })
  })(this, property)), this.$$outer$1.version$2, this.$$outer$1.ctx$2).parse__s_Option();
  if ((!this$25.isEmpty__Z())) {
    var arg1$3 = this$25.get__O();
    var x$28 = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1$3);
    var field$3 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1;
    $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(property, field$3, x$28))
  };
  if (this.patterned$1) {
    var field$4 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().PatternName$1;
    $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(property, field$4, name))
  };
  return property
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser.prototype.validateReadOnlyAndRequired__p1__s_Option__Lamf_core_model_domain_extensions_PropertyShape__Z__V = (function(map, property, isRequired) {
  if ((!map.isEmpty__Z())) {
    var arg1 = map.get__O();
    var x$29 = $as_Lorg_yaml_model_YMap(arg1);
    var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(x$29);
    var this$3 = this$2.key__T__s_Option("readOnly");
    if ((!this$3.isEmpty__Z())) {
      var arg1$1 = this$3.get__O();
      var readOnlyEntry = $as_Lorg_yaml_model_YMapEntry(arg1$1);
      try {
        var this$5 = readOnlyEntry.value$2;
        var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
        var iv = this.$$outer$1.ctx$2;
        var x = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv)).text$3;
        var this$7 = new $c_sci_StringOps().init___T(x);
        var $$this = this$7.repr$1;
        var jsx$1 = new $c_s_util_Success().init___O($f_sci_StringLike__parseBoolean__psci_StringLike__T__Z(this$7, $$this))
      } catch (e) {
        var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
        if ((e$2 !== null)) {
          matchEnd8: {
            var jsx$1;
            var o11 = $m_s_util_control_NonFatal$().unapply__jl_Throwable__s_Option(e$2);
            if ((!o11.isEmpty__Z())) {
              var e$3 = $as_jl_Throwable(o11.get__O());
              var jsx$1 = new $c_s_util_Failure().init___jl_Throwable(e$3);
              break matchEnd8
            };
            throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(e$2)
          }
        } else {
          var jsx$1;
          throw e
        }
      };
      var readOnly = $uZ(jsx$1.getOrElse__F0__O(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$2$1) {
        return (function() {
          return false
        })
      })(this))));
      if ((readOnly && isRequired)) {
        var this$9 = this.$$outer$1.ctx$2.eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().ReadOnlyPropertyMarkedRequired$1;
        var node = property.id$1;
        var property$1 = $m_s_None$();
        var location = readOnlyEntry.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$9, specification, node, property$1, "Read only property should not be marked as required by a schema", location)
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.entry$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.producer$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.requiredFields$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.patterned$1 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 4)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$PropertyShapeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$PropertyShapeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$PropertyShapeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertyShapeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.shape$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser.prototype.productPrefix__T = (function() {
  return "XoneConstraintParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser(x$1).$$outer$1 === this.$$outer$1))) {
    var XoneConstraintParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser(x$1);
    var this$1 = this.map$1;
    var b = XoneConstraintParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.shape$1;
      var x$2 = XoneConstraintParser$1.shape$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.shape$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape = (function($$outer, map, shape) {
  this.map$1 = map;
  this.shape$1 = shape;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser.prototype.parse__V = (function() {
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("oneOf");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    this.$$outer$1.adopt$2.apply__O__O(this.shape$1);
    var this$4 = entry.value$2;
    var evidence$2 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var x1 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$4, evidence$2);
    if ((x1 instanceof $c_s_util_Right)) {
      var x2 = $as_s_util_Right(x1);
      var seq = $as_sc_Seq(x2.value$2);
      var this$5 = $m_sc_Seq$();
      var jsx$4 = $as_sc_TraversableLike(seq.zipWithIndex__scg_CanBuildFrom__O(this$5.ReusableCBFInstance$2));
      var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x0$1$2) {
          var x0$1 = $as_T2(x0$1$2);
          if ((x0$1 !== null)) {
            var node = $as_Lorg_yaml_model_YNode(x0$1.$$und1__O());
            var index = x0$1.$$und2$mcI$sp__I();
            var entry$1 = $m_Lorg_yaml_model_YMapEntry$().apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry($m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(("item" + index)), node);
            return $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(entry$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, index$1) {
              return (function(item$2) {
                var item = $as_Lamf_core_model_domain_Shape(item$2);
                item.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject((($this$1.shape$1.id$1 + "/xone/") + index$1), item.adopted$default$2__sc_Seq())
              })
            })($this, index)), $this.$$outer$1.version$2, $this.$$outer$1.ctx$2).parse__s_Option()
          } else {
            throw new $c_s_MatchError().init___O(x0$1)
          }
        })
      })(this));
      var this$6 = $m_sc_Seq$();
      var jsx$2 = $as_sc_TraversableLike($as_sc_TraversableLike(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$6.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
        return (function(x$16$2) {
          var x$16 = $as_s_Option(x$16$2);
          return x$16.isDefined__Z()
        })
      })(this))));
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
        return (function(x$17$2) {
          var x$17 = $as_s_Option(x$17$2);
          return $as_Lamf_plugins_domain_shapes_models_AnyShape(x$17.get__O())
        })
      })(this));
      var this$7 = $m_sc_Seq$();
      var nodes = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
      var this$8 = this.shape$1;
      var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Xone$1;
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
      $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$8, field, nodes, annotations)
    } else {
      var this$9 = this.$$outer$1.ctx$2.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidXoneType$1;
      var node$1 = this.shape$1.id$1;
      var ast = entry.value$2;
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$9, specification, node$1, prop, "Xone constraints are built from multiple shape nodes", l)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$XoneConstraintParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$XoneConstraintParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$XoneConstraintParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$XoneConstraintParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter() {
  $c_O.call(this);
  this.orphans$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(orphans, ordering, spec) {
  this.orphans$1 = orphans;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter.prototype.productPrefix__T = (function() {
  return "OrphanAnnotationsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter)) {
    var OrphanAnnotationsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter(x$1);
    var x = this.orphans$1;
    var x$2 = OrphanAnnotationsEmitter$1.orphans$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OrphanAnnotationsEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.orphans$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter.prototype.emitters__sc_Seq = (function() {
  var jsx$2 = this.orphans$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_core_model_domain_extensions_DomainExtension(x$3$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter($this.spec$1.factory__Lamf_plugins_document_webapi_contexts_SpecEmitterFactory().annotationEmitter__F2().apply__O__O__O(x$3, $this.ordering$1))
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OrphanAnnotationsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OrphanAnnotationsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OrphanAnnotationsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser() {
  $c_O.call(this);
  this.defaultType$1 = null;
  this.name$1 = null;
  this.ast$1 = null;
  this.adopt$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser.prototype.productPrefix__T = (function() {
  return "Raml08DefaultTypeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser)) {
    var Raml08DefaultTypeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser(x$1);
    var x = this.defaultType$1;
    var x$2 = Raml08DefaultTypeParser$1.defaultType$1;
    if (((x === x$2) && (this.name$1 === Raml08DefaultTypeParser$1.name$1))) {
      var x$3 = this.ast$1;
      var x$4 = Raml08DefaultTypeParser$1.ast$1;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.adopt$1;
      var x$6 = Raml08DefaultTypeParser$1.adopt$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.defaultType$1;
      break
    }
    case 1: {
      return this.name$1;
      break
    }
    case 2: {
      return this.ast$1;
      break
    }
    case 3: {
      return this.adopt$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser.prototype.parse__s_Option = (function() {
  var x1 = this.defaultType$1;
  var x = $m_Lamf_plugins_domain_shapes_models_TypeDef$NilType$();
  if ((x === x1)) {
    var this$2 = $m_Lamf_plugins_domain_shapes_models_NilShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_NilShape(this.ast$1);
    var name = this.name$1;
    $m_Lamf_core_parser_Annotations$();
    var a = new $c_Lamf_core_parser_Annotations().init___();
    var this$3 = $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$2, name, a);
    var annotation = new $c_Lamf_plugins_document_webapi_annotations_Inferred().init___();
    var product = new $c_s_Some().init___O($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$3, annotation))
  } else {
    var x$3 = $m_Lamf_plugins_domain_shapes_models_TypeDef$FileType$();
    if ((x$3 === x1)) {
      var this$5 = $m_Lamf_plugins_domain_shapes_models_FileShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_FileShape(this.ast$1);
      var name$1 = this.name$1;
      $m_Lamf_core_parser_Annotations$();
      var a$1 = new $c_Lamf_core_parser_Annotations().init___();
      var product = new $c_s_Some().init___O($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$5, name$1, a$1))
    } else if ($is_Lamf_plugins_domain_shapes_models_ScalarType(x1)) {
      var this$7 = $m_Lamf_plugins_domain_shapes_models_ScalarShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_ScalarShape(this.ast$1);
      var name$2 = this.name$1;
      $m_Lamf_core_parser_Annotations$();
      var a$2 = new $c_Lamf_core_parser_Annotations().init___();
      var this$10 = $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$7, name$2, a$2);
      var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
      var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$().xsd__Lamf_plugins_domain_shapes_models_TypeDef__T(this.defaultType$1), new $c_Lamf_core_parser_Annotations().init___());
      var annotations = ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_Inferred().init___());
      var product = new $c_s_Some().init___O($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$10, field, value, annotations))
    } else {
      var x$5 = $m_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$();
      if ((x$5 === x1)) {
        var this$12 = $m_Lamf_plugins_domain_shapes_models_AnyShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_AnyShape(this.ast$1);
        var name$3 = this.name$1;
        $m_Lamf_core_parser_Annotations$();
        var a$3 = new $c_Lamf_core_parser_Annotations().init___();
        var this$13 = $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$12, name$3, a$3);
        var annotation$1 = new $c_Lamf_plugins_document_webapi_annotations_Inferred().init___();
        var product = new $c_s_Some().init___O($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$13, annotation$1))
      } else {
        var this$14 = this.ctx$1.eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().UnableToSetDefaultType$1;
        var message = (("Cannot set default type " + this.defaultType$1) + " in raml 08");
        var ast = this.ast$1;
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$14, specification, "", prop, message, l);
        var product = $m_s_None$()
      }
    }
  };
  var f = this.adopt$1;
  if ((!product.isEmpty__Z())) {
    f.apply__O__O(product.get__O())
  };
  return product
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser.prototype.init___Lamf_plugins_domain_shapes_models_TypeDef__T__Lorg_yaml_model_YPart__F1__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(defaultType, name, ast, adopt, ctx) {
  this.defaultType$1 = defaultType;
  this.name$1 = name;
  this.ast$1 = ast;
  this.adopt$1 = adopt;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.Raml08DefaultTypeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.Raml08DefaultTypeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.Raml08DefaultTypeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser() {
  $c_O.call(this);
  this.text$1 = null;
  this.node$1 = null;
  this.name$1 = null;
  this.ctx$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser.prototype.productPrefix__T = (function() {
  return "Raml08ReferenceParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser.prototype.parse__s_Some = (function() {
  var x1 = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().findType__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option(this.text$1, $m_Lamf_core_parser_SearchScope$All$(), (this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations(), $m_s_None$()));
  matchEnd6: {
    var shape$2;
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var s = $as_Lamf_plugins_domain_shapes_models_AnyShape(x2.value$2);
      if ((s !== null)) {
        var this$2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(s.link__T__Lamf_core_parser_Annotations__O(this.text$1, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.node$1.value__Lorg_yaml_model_YValue())));
        var name = this.name$1;
        var a = $as_Lamf_core_model_StrField(s.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).annotations$1;
        var shape$2 = $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$2, name, a));
        break matchEnd6
      }
    };
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$4 = $m_Lamf_plugins_domain_shapes_models_UnresolvedShape$().apply__T__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_UnresolvedShape(this.text$1, this.node$1);
      var name$1 = this.text$1;
      $m_Lamf_core_parser_Annotations$();
      var a$1 = new $c_Lamf_core_parser_Annotations().init___();
      var shape = $as_Lamf_plugins_domain_shapes_models_UnresolvedShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$4, name$1, a$1));
      var c = this.ctx$1;
      $f_Lamf_core_parser_UnresolvedReference__withContext__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(shape, c);
      this.$$outer$1.adopt$3.apply__O__O(shape);
      var str = this.text$1;
      if ((!new $c_Lamf_core_utils_package$AmfStrings().init___T(str).validReferencePath__Z())) {
        var this$6 = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().libraries$1;
        var this$7 = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(this$6);
        var this$8 = this$7.$$outer$4.keysIterator__sc_Iterator();
        var res = false;
        while (((!res) && this$8.hasNext__Z())) {
          var arg1 = this$8.next__O();
          var x$3 = $as_T(arg1);
          var thiz = this.text$1;
          var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "\\.", 0);
          var this$11 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
          res = (x$3 === $f_sc_IndexedSeqOptimized__head__O(this$11))
        };
        var jsx$1 = res
      } else {
        var jsx$1 = false
      };
      if (jsx$1) {
        var this$12 = this.ctx$1.eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().ChainedReferenceSpecification$1;
        var node = shape.id$1;
        var message = ("Chained reference '" + this.text$1);
        var ast = this.node$1;
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$12, specification, node, prop, message, l)
      } else {
        var refName = this.text$1;
        var refAst = this.node$1;
        var ctx = this.ctx$1;
        $f_Lamf_core_model_domain_Linkable__unresolved__T__Lorg_yaml_model_YPart__T__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(shape, refName, refAst, "error", ctx)
      };
      var shape$2 = shape;
      break matchEnd6
    };
    throw new $c_s_MatchError().init___O(x1)
  };
  return new $c_s_Some().init___O(shape$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser(x$1).$$outer$1 === this.$$outer$1))) {
    var Raml08ReferenceParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser(x$1);
    if ((this.text$1 === Raml08ReferenceParser$1.text$1)) {
      var this$1 = this.node$1;
      var b = Raml08ReferenceParser$1.node$1;
      var jsx$1 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.name$1 === Raml08ReferenceParser$1.name$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.text$1;
      break
    }
    case 1: {
      return this.node$1;
      break
    }
    case 2: {
      return this.name$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser__T__Lorg_yaml_model_YNode__T__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function($$outer, text, node, name, ctx) {
  this.text$1 = text;
  this.node$1 = node;
  this.name$1 = name;
  this.ctx$1 = ctx;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.Raml08TypeParser$Raml08ReferenceParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.Raml08TypeParser$Raml08ReferenceParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.Raml08TypeParser$Raml08ReferenceParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.adopt$1 = null;
  this.ctx$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser.prototype.productPrefix__T = (function() {
  return "Raml08SchemaParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser(x$1).$$outer$1 === this.$$outer$1))) {
    var Raml08SchemaParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser(x$1);
    var this$1 = this.map$1;
    var b = Raml08SchemaParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.adopt$1;
      var x$2 = Raml08SchemaParser$1.adopt$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.adopt$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser.prototype.parse__s_Option = (function() {
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("schema");
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$3 = e.value$2;
    var x1 = this$3.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x === x1)) {
      var jsx$1 = true
    } else {
      var x$3 = $m_Lorg_yaml_model_YType$().Seq$1;
      var jsx$1 = (x$3 === x1)
    };
    if (jsx$1) {
      return $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser(e, this.adopt$1, false, $m_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$(), this.ctx$1).parse__s_Option()
    } else {
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser__Lorg_yaml_model_YNode__F1__T__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this.$$outer$1, e.value$2, this.adopt$1, "schema", this.$$outer$1.defaultType$3, this.ctx$1).parse__s_Option()
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser__Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function($$outer, map, adopt, ctx) {
  this.map$1 = map;
  this.adopt$1 = adopt;
  this.ctx$1 = ctx;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.Raml08TypeParser$Raml08SchemaParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.Raml08TypeParser$Raml08SchemaParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.Raml08TypeParser$Raml08SchemaParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser() {
  $c_O.call(this);
  this.value$1 = null;
  this.adopt$1 = null;
  this.name$1 = null;
  this.defaultType$1 = null;
  this.ctx$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser.prototype.productPrefix__T = (function() {
  return "Raml08TextParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser(x$1).$$outer$1 === this.$$outer$1))) {
    var Raml08TextParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser(x$1);
    var this$1 = this.value$1;
    var b = Raml08TextParser$1.value$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.adopt$1;
      var x$2 = Raml08TextParser$1.adopt$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if ((jsx$1 && (this.name$1 === Raml08TextParser$1.name$1))) {
      var x$3 = this.defaultType$1;
      var x$4 = Raml08TextParser$1.defaultType$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    case 1: {
      return this.adopt$1;
      break
    }
    case 2: {
      return this.name$1;
      break
    }
    case 3: {
      return this.defaultType$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser.prototype.parse__s_Option = (function() {
  var this$1 = this.value$1;
  var x1 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Null$1;
  if ((x === x1)) {
    var this$2 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser().init___Lamf_plugins_domain_shapes_models_TypeDef__T__Lorg_yaml_model_YPart__F1__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this.defaultType$1.typeDef__Lamf_plugins_domain_shapes_models_TypeDef(), this.name$1, this.value$1, this.adopt$1, this.ctx$1).parse__s_Option();
    if (this$2.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1 = this$2.get__O();
      var s = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1);
      var annotation = new $c_Lamf_core_annotations_SourceAST().init___Lorg_yaml_model_YPart(this.value$1);
      var this$4 = $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(s, annotation);
      var this$3 = this.value$1;
      var annotation$1 = new $c_Lamf_core_annotations_SourceLocation().init___T(this$3.location$1.sourceName$1);
      return new $c_s_Some().init___O($as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$4, annotation$1)))
    }
  } else {
    var this$5 = this.value$1;
    var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv = this.ctx$1;
    var x1$2 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv)).text$3;
    var o10 = $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$().unapply__T__s_Option(x1$2);
    if ((!o10.isEmpty__Z())) {
      var jsx$1 = $m_s_Option$();
      var this$6 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression().init___Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this.$$outer$1.key$3, this.value$1, this.adopt$1, false, this.ctx$1);
      return jsx$1.apply__O__s_Option($f_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__parse__Lamf_plugins_domain_shapes_models_AnyShape(this$6))
    };
    var o12 = $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$().unapply__T__s_Option(x1$2);
    if ((!o12.isEmpty__Z())) {
      var jsx$2 = $m_s_Option$();
      var this$7 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression().init___Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this.$$outer$1.key$3, this.value$1, this.adopt$1, false, this.ctx$1);
      return jsx$2.apply__O__s_Option($f_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__parse__Lamf_plugins_domain_shapes_models_AnyShape(this$7))
    };
    if ($m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$().match08Type__T__s_Option(x1$2).isDefined__Z()) {
      return $m_s_Option$().apply__O__s_Option(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser().init___T__F1__Lorg_yaml_model_YMap__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this.name$1, this.adopt$1, $m_Lorg_yaml_model_YMap$().empty$1, $as_Lamf_plugins_domain_shapes_models_TypeDef($m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$().match08Type__T__s_Option(x1$2).get__O()), this.ctx$1).parse__Lamf_plugins_domain_shapes_models_AnyShape())
    };
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08ReferenceParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser__T__Lorg_yaml_model_YNode__T__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this.$$outer$1, x1$2, this.$$outer$1.node$2, this.name$1, this.ctx$1).parse__s_Some()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser__Lorg_yaml_model_YNode__F1__T__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function($$outer, value, adopt, name, defaultType, ctx) {
  this.value$1 = value;
  this.adopt$1 = adopt;
  this.name$1 = name;
  this.defaultType$1 = defaultType;
  this.ctx$1 = ctx;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.Raml08TypeParser$Raml08TextParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.Raml08TypeParser$Raml08TextParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.Raml08TypeParser$Raml08TextParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser() {
  $c_O.call(this);
  this.shape$1 = null;
  this.types$1 = null;
  this.ast$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser.prototype.init___Lamf_plugins_domain_shapes_models_UnionShape__sc_Seq__Lorg_yaml_model_YPart__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(shape, types, ast, ctx) {
  this.shape$1 = shape;
  this.types$1 = types;
  this.ast$1 = ast;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser.prototype.productPrefix__T = (function() {
  return "Raml08UnionTypeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser)) {
    var Raml08UnionTypeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser(x$1);
    var x = this.shape$1;
    var x$2 = Raml08UnionTypeParser$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.types$1;
      var x$4 = Raml08UnionTypeParser$1.types$1;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.ast$1;
      var x$6 = Raml08UnionTypeParser$1.ast$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.types$1;
      break
    }
    case 2: {
      return this.ast$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser.prototype.parse__Lamf_plugins_domain_shapes_models_UnionShape = (function() {
  var jsx$5 = this.types$1;
  var this$1 = $m_sc_Seq$();
  var jsx$4 = $as_sc_TraversableLike(jsx$5.zipWithIndex__scg_CanBuildFrom__O(this$1.ReusableCBFInstance$2));
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var unionNode = $as_Lorg_yaml_model_YNode(x0$1.$$und1__O());
        var index = x0$1.$$und2$mcI$sp__I();
        var adopt = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, index$1) {
          return (function(item$2) {
            var item = $as_Lamf_core_model_domain_Shape(item$2);
            item.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject((($this$1.shape$1.id$1 + "/items/") + index$1), item.adopted$default$2__sc_Seq())
          })
        })($this, index));
        return $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$().apply__Lorg_yaml_model_YNode__T__F1__Z__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser(unionNode, ("item" + index), adopt, false, $m_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$(), $this.ctx$1).parse__s_Option()
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike($as_sc_TraversableLike(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$2.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$4$2) {
      var x$4 = $as_s_Option(x$4$2);
      return x$4.isDefined__Z()
    })
  })(this))));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3) {
    return (function(x$5$2) {
      var x$5 = $as_s_Option(x$5$2);
      return $as_Lamf_plugins_domain_shapes_models_AnyShape(x$5.get__O())
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  var unionNodes = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2));
  var this$5 = this.shape$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1;
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.ast$1);
  return $as_Lamf_plugins_domain_shapes_models_UnionShape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$5, field, unionNodes, annotations))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.Raml08UnionTypeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.Raml08UnionTypeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.Raml08UnionTypeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter() {
  $c_O.call(this);
  this.documentation$1 = null;
  this.ordering$1 = null;
  this.withExtention$1 = false;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter.prototype.productPrefix__T = (function() {
  return "RamlCreativeWorkItemsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter.prototype.init___Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Z__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(documentation, ordering, withExtention, spec) {
  this.documentation$1 = documentation;
  this.ordering$1 = ordering;
  this.withExtention$1 = withExtention;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter)) {
    var RamlCreativeWorkItemsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter(x$1);
    var x = this.documentation$1;
    var x$2 = RamlCreativeWorkItemsEmitter$1.documentation$1;
    if ((x === x$2)) {
      var x$3 = this.ordering$1;
      var x$4 = RamlCreativeWorkItemsEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.withExtention$1 === RamlCreativeWorkItemsEmitter$1.withExtention$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.documentation$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.withExtention$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter.prototype.emitters__sc_Seq = (function() {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var fs = this.documentation$1.fields$1;
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Url$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option((this.withExtention$1 ? new $c_Lamf_core_utils_package$AmfStrings().init___T("url").asRamlAnnotation__T() : "url"), f, $m_s_None$())))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Description$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("content", f$3, $m_s_None$(), this.spec$1)))
  };
  var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Title$1);
  if ((!this$6.isEmpty__Z())) {
    var arg1$2 = this$6.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("title", f$4, $m_s_None$(), this.spec$1)))
  };
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.documentation$1, this.ordering$1, this.spec$1).emitters__sc_Seq());
  return this.ordering$1.sorted__sc_Seq__sc_Seq(result)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.documentation$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ordering$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.withExtention$1 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 3)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlCreativeWorkItemsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlCreativeWorkItemsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlCreativeWorkItemsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser() {
  $c_O.call(this);
  this.key$1 = null;
  this.map$1 = null;
  this.scheme$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser.prototype.productPrefix__T = (function() {
  return "RamlDescribedByParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser)) {
    var RamlDescribedByParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser(x$1);
    if ((this.key$1 === RamlDescribedByParser$1.key$1)) {
      var this$1 = this.map$1;
      var b = RamlDescribedByParser$1.map$1;
      var jsx$1 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x = this.scheme$1;
      var x$2 = RamlDescribedByParser$1.scheme$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.map$1;
      break
    }
    case 2: {
      return this.scheme$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser.prototype.init___T__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(key, map, scheme, ctx) {
  this.key$1 = key;
  this.map$1 = map;
  this.scheme$1 = scheme;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser.prototype.parse__V = (function() {
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword = this.key$1;
  var this$3 = this$2.key__T__s_Option(keyword);
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var x1 = this$4.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x === x1)) {
      var this$5 = entry.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = this.ctx$1;
      var value = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv));
      this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(this.scheme$1.id$1, value, "describedBy");
      var this$7 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(value);
      var this$8 = this$7.key__T__s_Option("headers");
      if ((!this$8.isEmpty__Z())) {
        var arg1$1 = this$8.get__O();
        var entry$2 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
        var this$9 = entry$2.value$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv$1 = this.ctx$1;
        var jsx$2 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser().init___Lorg_yaml_model_YMap__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$9, conversion$1, iv$1)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(p$2) {
            var p = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2);
            var parent = $this.scheme$1.id$1;
            $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
            $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(p, parent)
          })
        })(this)), false, this.ctx$1).parse__sc_Seq();
        var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
          return (function(x$1$2) {
            var x$1 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$1$2);
            var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
            return $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x$1, field, "header"))
          })
        })(this));
        var this$10 = $m_sc_Seq$();
        var parameters = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$10.ReusableCBFInstance$2));
        var this$11 = this.scheme$1;
        var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Headers$1;
        var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(parameters, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$2.value$2));
        var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$2);
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$11, field$1, value$1, annotations)
      };
      if ((new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(value).key__T__s_Option("queryParameters").isDefined__Z() && new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(value).key__T__s_Option("queryString").isDefined__Z())) {
        var this$14 = this.ctx$1.eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().ExclusivePropertiesSpecification$1;
        var node = this.scheme$1.id$1;
        var prop = $m_s_None$();
        var l = value.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$14, specification, node, prop, "Properties 'queryString' and 'queryParameters' are exclusive and cannot be declared together", l)
      };
      var this$16 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(value);
      var this$17 = this$16.key__T__s_Option("queryParameters");
      if ((!this$17.isEmpty__Z())) {
        var arg1$2 = this$17.get__O();
        var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
        var this$18 = entry$3.value$2;
        var conversion$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv$2 = this.ctx$1;
        var jsx$4 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser().init___Lorg_yaml_model_YMap__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$18, conversion$2, iv$2)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
          return (function(p$2$1) {
            var p$1 = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2$1);
            var parent$1 = $this$1.scheme$1.id$1;
            $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
            $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(p$1, parent$1)
          })
        })(this)), false, this.ctx$1).parse__sc_Seq();
        var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$2) {
          return (function(x$2$2) {
            var x$2 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$2$2);
            var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
            return $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x$2, field$2, "query"))
          })
        })(this));
        var this$19 = $m_sc_Seq$();
        var parameters$1 = $as_sc_Seq(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$19.ReusableCBFInstance$2));
        var this$20 = this.scheme$1;
        var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().QueryParameters$1;
        var value$2 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(parameters$1, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3.value$2));
        var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$20, field$3, value$2, annotations$1)
      };
      var this$22 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(value);
      var this$23 = this$22.key__T__s_Option("queryString");
      if ((!this$23.isEmpty__Z())) {
        var arg1$3 = this$23.get__O();
        var queryEntry = $as_Lorg_yaml_model_YMapEntry(arg1$3);
        var this$26 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(queryEntry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2) {
          return (function(shape$2) {
            var shape = $as_Lamf_core_model_domain_Shape(shape$2);
            shape.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject($this$2.scheme$1.id$1, shape.adopted$default$2__sc_Seq())
          })
        })(this)), new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo().init___Z__Z(false, false), $m_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$(), this.ctx$1).parse__s_Option();
        if ((!this$26.isEmpty__Z())) {
          var arg1$4 = this$26.get__O();
          var s = $as_Lamf_core_model_domain_Shape(arg1$4);
          var this$28 = this.scheme$1;
          var queryString = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(s, this.scheme$1.id$1, $m_s_None$());
          var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().QueryString$1;
          $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$28, field$4, queryString))
        }
      };
      var this$30 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(value);
      var this$31 = this$30.key__T__s_Option("responses");
      if ((!this$31.isEmpty__Z())) {
        var arg1$5 = this$31.get__O();
        var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$5);
        var responses = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        var this$32 = entry$4.value$2;
        var x1$1 = this$32.tag__Lorg_yaml_model_YTag().tagType$3;
        var x$3 = $m_Lorg_yaml_model_YType$().Null$1;
        if ((!(x$3 === x1$1))) {
          var this$33 = entry$4.value$2;
          var conversion$3 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
          var iv$3 = this.ctx$1;
          var entries = $as_sc_IndexedSeq($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$33, conversion$3, iv$3)).entries$3.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3) {
            return (function(y$2) {
              var y = $as_Lorg_yaml_model_YMapEntry(y$2);
              var jsx$5 = $m_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$();
              var this$34 = y.key$2;
              var conversion$4 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
              var iv$4 = $this$3.ctx$1;
              return (!jsx$5.isRamlAnnotation__T__Z($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$34, conversion$4, iv$4)).text$3))
            })
          })(this))));
          entries.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$3, responses$1) {
            return (function(entry$2$2) {
              var entry$2$1 = $as_Lorg_yaml_model_YMapEntry(entry$2$2);
              return responses$1.$$plus$eq__O__scm_ListBuffer($as_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser(this$2$3.ctx$1.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().responseParser__F3().apply__O__O__O__O(entry$2$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$4) {
                return (function(r$2) {
                  var r = $as_Lamf_plugins_domain_webapi_models_Response(r$2);
                  var parent$2 = $this$4.scheme$1.id$1;
                  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
                  $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(r, parent$2)
                })
              })(this$2$3)), false)).parse__Lamf_plugins_domain_webapi_models_Response())
            })
          })(this, responses)))
        };
        var this$35 = this.scheme$1;
        var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Responses$1;
        var value$3 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(responses, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4.value$2));
        var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4);
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$35, field$5, value$3, annotations$2)
      };
      new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(this.scheme$1, value, $m_sci_Nil$(), this.ctx$1).parse__V()
    } else {
      var x$3$1 = $m_Lorg_yaml_model_YType$().Null$1;
      if ((!(x$3$1 === x1))) {
        var this$37 = this.ctx$1.eh$1;
        var specification$1 = $m_Lamf_validations_ParserSideValidations$().InvalidSecuritySchemeDescribedByType$1;
        var node$1 = this.scheme$1.id$1;
        var ast = entry.value$2;
        var prop$1 = $m_s_None$();
        var l$1 = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$37, specification$1, node$1, prop$1, "Invalid 'describedBy' type, map expected", l$1)
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlDescribedByParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlDescribedByParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlDescribedByParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.call(this);
  this.AnyTypeShapeParser$module$2 = null;
  this.NilShapeParser$module$2 = null;
  this.ScalarShapeParser$module$2 = null;
  this.UnionShapeParser$module$2 = null;
  this.OrConstraintParser$module$2 = null;
  this.AndConstraintParser$module$2 = null;
  this.XoneConstraintParser$module$2 = null;
  this.NotConstraintParser$module$2 = null;
  this.FileShapeParser$module$2 = null;
  this.DataArrangementParser$module$2 = null;
  this.ArrayShapeParser$module$2 = null;
  this.TupleShapeParser$module$2 = null;
  this.InheritanceParser$module$2 = null;
  this.NodeShapeParser$module$2 = null;
  this.PropertiesParser$module$2 = null;
  this.PropertyShapeParser$module$2 = null;
  this.key$2 = null;
  this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$adopt$f = null;
  this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$typeInfo$f = null;
  this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$defaultType$f = null;
  this.ctx$2 = null;
  this.name$2 = null;
  this.x$7$2 = null;
  this.ast$2 = null;
  this.node$2 = null;
  this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$nameAnnotations$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.prototype.parseAnyType__p2__Lamf_core_model_domain_Shape = (function() {
  var this$1 = $m_Lamf_plugins_domain_shapes_models_AnyShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_AnyShape(this.ast$2);
  var name = this.name$2;
  var a = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$nameAnnotations$2;
  var shape = $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$1, name, a));
  this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$adopt$f.apply__O__O(shape);
  var x1 = this.ast$2;
  if ((x1 instanceof $c_Lorg_yaml_model_YMapEntry)) {
    var x2 = $as_Lorg_yaml_model_YMapEntry(x1);
    if ((x2.value$2.value__Lorg_yaml_model_YValue() instanceof $c_Lorg_yaml_model_YMap)) {
      var this$2 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lamf_plugins_domain_shapes_models_AnyShape__Lorg_yaml_model_YMap(this, shape, $as_Lorg_yaml_model_YMap(x2.value$2.value__Lorg_yaml_model_YValue()));
      return $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape.call(this$2)
    }
  };
  return shape
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.prototype.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$isPlainArrayTypeExpression__Lorg_yaml_model_YMapEntry__Z = (function(typeEntry) {
  var text = typeEntry.value$2.toString__T();
  return ($m_sjsr_RuntimeString$().endsWith__T__T__Z(text, "[]") && ($uI(text.indexOf("|")) === (-1)))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.prototype.parseArrayType__Lamf_core_model_domain_Shape = (function() {
  var this$1 = this.node$2;
  var evidence$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var x1 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$1, evidence$2);
  if ((x1 instanceof $c_s_util_Right)) {
    var x2 = $as_s_util_Right(x1);
    var map = $as_Lorg_yaml_model_YMap(x2.value$2);
    var shape$3 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__T__Lorg_yaml_model_YPart__Lorg_yaml_model_YMap__F1(this, this.name$2, this.ast$2, map, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        $this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$adopt$f.apply__O__O(shape)
      })
    })(this))).parse__Lamf_core_model_domain_Shape()
  } else {
    if ((!(x1 instanceof $c_s_util_Left))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var this$2 = $m_Lamf_plugins_domain_shapes_models_ArrayShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_ArrayShape(this.ast$2);
    var name = this.name$2;
    var a = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$nameAnnotations$2;
    var toAdopt = $as_Lamf_plugins_domain_shapes_models_ArrayShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$2, name, a));
    this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$adopt$f.apply__O__O(toAdopt);
    var shape$3 = toAdopt
  };
  return shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.prototype.parse__s_Option = (function() {
  var jsx$3 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetection$();
  var jsx$2 = this.node$2;
  var node = this.node$2;
  var this$2 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YMapYRead$());
  if (this$2.isEmpty__Z()) {
    var jsx$1 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var m = $as_Lorg_yaml_model_YMap(arg1);
    var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(m).key__T__s_Option("format");
    var this$7 = (this$4.isEmpty__Z() ? new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(m).key__T__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("format").asRamlAnnotation__T()) : this$4);
    if (this$7.isEmpty__Z()) {
      var jsx$1 = $m_s_None$()
    } else {
      var arg1$1 = this$7.get__O();
      var x$8 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
      var jsx$1 = new $c_s_Some().init___O(x$8.value$2.toString__T())
    }
  };
  var info = jsx$3.apply__Lorg_yaml_model_YNode__T__s_Option__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__s_Option(jsx$2, "", jsx$1, this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$defaultType$f, this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext());
  if (info.isEmpty__Z()) {
    var result = $m_s_None$()
  } else {
    var arg1$2 = info.get__O();
    var x0$1 = $as_Lamf_plugins_domain_shapes_models_TypeDef(arg1$2);
    var x = $m_Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$();
    if ((x === x0$1)) {
      var this$8 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression().init___Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this.key$2, this.node$2, this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$adopt$f, true, this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext());
      var jsx$4 = $f_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__parse__Lamf_plugins_domain_shapes_models_AnyShape(this$8)
    } else {
      var x$3 = $m_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$();
      if ((x$3 === x0$1)) {
        var this$9 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression().init___Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this.key$2, this.node$2, this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$adopt$f, true, this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext());
        var jsx$4 = $f_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__parse__Lamf_plugins_domain_shapes_models_AnyShape(this$9)
      } else {
        var x$5 = $m_Lamf_plugins_domain_shapes_models_TypeDef$NilUnionType$();
        if ((x$5 === x0$1)) {
          var jsx$4 = this.parseNilUnion__p2__Lamf_plugins_domain_shapes_models_UnionShape()
        } else {
          var x$7 = $m_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$();
          if ((x$7 === x0$1)) {
            var jsx$4 = this.parseTypeExpression__p2__Lamf_core_model_domain_Shape()
          } else {
            var x$9 = $m_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$();
            if ((x$9 === x0$1)) {
              var jsx$4 = this.parseUnionType__p2__Lamf_plugins_domain_shapes_models_UnionShape()
            } else {
              var x$11 = $m_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$();
              if ((x$11 === x0$1)) {
                var jsx$5 = true
              } else {
                var x$13 = $m_Lamf_plugins_domain_shapes_models_TypeDef$FileType$();
                if ((x$13 === x0$1)) {
                  var jsx$5 = true
                } else {
                  var x$15 = $m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$();
                  var jsx$5 = (x$15 === x0$1)
                }
              };
              if (jsx$5) {
                var jsx$4 = this.parseObjectType__p2__Lamf_core_model_domain_Shape()
              } else {
                var x$17 = $m_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$();
                if ((x$17 === x0$1)) {
                  var jsx$4 = this.parseArrayType__Lamf_core_model_domain_Shape()
                } else {
                  var x$19 = $m_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$();
                  if ((x$19 === x0$1)) {
                    var jsx$4 = this.parseAnyType__p2__Lamf_core_model_domain_Shape()
                  } else if ($f_Lamf_plugins_domain_shapes_models_TypeDef__isScalar__Z(x0$1)) {
                    var jsx$4 = this.parseScalarType__p2__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_core_model_domain_Shape(x0$1)
                  } else {
                    var x$21 = $m_Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$();
                    if ((!(x$21 === x0$1))) {
                      throw new $c_s_MatchError().init___O(x0$1)
                    };
                    var jsx$4 = this.parseDefaultType__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_core_model_domain_Shape(this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$defaultType$f)
                  }
                }
              }
            }
          }
        }
      }
    };
    var result = new $c_s_Some().init___O(jsx$4)
  };
  if ((!result.isEmpty__Z())) {
    var arg1$3 = result.get__O();
    var shape = $as_Lamf_core_model_domain_Shape(arg1$3);
    var x1 = this.node$2.value__Lorg_yaml_model_YValue();
    if (((x1 instanceof $c_Lorg_yaml_model_YScalar) && (!info.contains__O__Z($m_Lamf_plugins_domain_shapes_models_TypeDef$MultipleMatch$())))) {
      var annotation = new $c_Lamf_plugins_document_webapi_annotations_InlineDefinition().init___();
      $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(shape, annotation))
    }
  };
  this.parseCustomShapeFacetInstances__p2__s_Option__V(result);
  var x1$1 = this.node$2.value__Lorg_yaml_model_YValue();
  matchEnd4: {
    if ((x1$1 instanceof $c_Lorg_yaml_model_YMap)) {
      var x2 = $as_Lorg_yaml_model_YMap(x1$1);
      if (result.isDefined__Z()) {
        var jsx$9 = $as_Lamf_core_model_domain_DomainElement(result.get__O());
        if (this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$typeInfo$f.isAnnotation$1) {
          $m_sci_List$();
          var array = [$m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().customDomainProperty$1];
          var i = (((-1) + $uI(array.length)) | 0);
          var result$1 = $m_sci_Nil$();
          while ((i >= 0)) {
            var this$13 = result$1;
            var index = i;
            var x$1 = array[index];
            result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$13);
            i = (((-1) + i) | 0)
          };
          var jsx$6 = result$1
        } else {
          var jsx$8 = $m_sci_Nil$();
          $m_sci_List$();
          var array$1 = [$m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().shape$1, $m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().payload$1, $m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().request$1];
          var i$1 = (((-1) + $uI(array$1.length)) | 0);
          var result$2 = $m_sci_Nil$();
          while ((i$1 >= 0)) {
            var this$17 = result$2;
            var index$1 = i$1;
            var x$2 = array$1[index$1];
            result$2 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$17);
            i$1 = (((-1) + i$1) | 0)
          };
          var jsx$7 = result$2;
          var this$18 = $m_sci_List$();
          var jsx$6 = $as_sci_List(jsx$8.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$7, this$18.ReusableCBFInstance$2))
        };
        new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(jsx$9, x2, jsx$6, this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext()).parse__V();
        break matchEnd4
      }
    }
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.prototype.parseTypeExpression__p2__Lamf_core_model_domain_Shape = (function() {
  var x1 = this.node$2.value__Lorg_yaml_model_YValue();
  if ((x1 instanceof $c_Lorg_yaml_model_YScalar)) {
    var x2 = $as_Lorg_yaml_model_YScalar(x1);
    var adopt = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$adopt$f;
    var part = new $c_s_Some().init___O(this.ast$2);
    var expression = x2.text$3;
    var ctx = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
    var shape = $as_Lamf_core_model_domain_Shape(new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser().init___F1__I__s_Option__Z__T__Lamf_plugins_document_webapi_contexts_WebApiContext(adopt, 0, part, false, expression, ctx).parse__s_Option().get__O());
    if (((this.name$2 !== "schema") && (this.name$2 !== "type"))) {
      var jsx$1 = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$adopt$f;
      var name = this.name$2;
      var a = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$nameAnnotations$2;
      jsx$1.apply__O__O($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, name, a))
    };
    return shape
  } else if ((x1 instanceof $c_Lorg_yaml_model_YMap)) {
    return this.parseObjectType__p2__Lamf_core_model_domain_Shape()
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.prototype.parseCustomShapeFacetInstances__p2__s_Option__V = (function(shapeResult) {
  var x1 = this.node$2.value__Lorg_yaml_model_YValue();
  matchEnd4: {
    if ((x1 instanceof $c_Lorg_yaml_model_YMap)) {
      var x2 = $as_Lorg_yaml_model_YMap(x1);
      if (shapeResult.isDefined__Z()) {
        new $c_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser().init___Lamf_core_model_domain_Shape__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__s_Option($as_Lamf_core_model_domain_Shape(shapeResult.get__O()), x2, this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(), this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$typeInfo$f, $m_s_None$()).parse__V();
        break matchEnd4
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.prototype.parseNilUnion__p2__Lamf_plugins_domain_shapes_models_UnionShape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_UnionShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var name = this.name$2;
  var a = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$nameAnnotations$2;
  var union = $as_Lamf_plugins_domain_shapes_models_UnionShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$4, name, a));
  this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$adopt$f.apply__O__O(union);
  var x1 = this.node$2.value__Lorg_yaml_model_YValue();
  if ((x1 instanceof $c_Lorg_yaml_model_YScalar)) {
    var x2 = $as_Lorg_yaml_model_YScalar(x1);
    var jsx$3 = $m_Lorg_yaml_model_YMapEntry$();
    var jsx$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("");
    var jsx$1 = $m_Lorg_yaml_model_YNode$();
    var x = x2.text$3;
    var this$6 = new $c_sci_StringOps().init___T(x);
    var toParse = jsx$3.apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry(jsx$2, jsx$1.apply__T__Lorg_yaml_model_YNode($f_sci_StringLike__stripSuffix__T__T(this$6, "?")));
    var parsed = $as_Lamf_core_model_domain_Shape($as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser(this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().typeParser__F4().apply__O__O__O__O__O(toParse, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, union$1) {
      return (function(s$2) {
        var s = $as_Lamf_core_model_domain_Shape(s$2);
        var value = union$1.id$1;
        $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(s, value)
      })
    })(this, union)), this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$typeInfo$f.isAnnotation$1, this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$defaultType$f)).parse__s_Option().get__O())
  } else {
    if ((!(x1 instanceof $c_Lorg_yaml_model_YMap))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var x3 = $as_Lorg_yaml_model_YMap(x1);
    var jsx$7 = x3.entries$3;
    var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(entry$2) {
        var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
        var this$7 = entry.key$2;
        var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
        var iv = this$2$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
        if (($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$7, conversion, iv)).text$3 === "type")) {
          var jsx$6 = $m_Lorg_yaml_model_YMapEntry$();
          $m_Lorg_yaml_model_YNode$();
          var jsx$5 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("type");
          $m_Lorg_yaml_model_YNode$();
          var this$9 = entry.value$2;
          var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
          var iv$1 = this$2$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
          var x$1 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$9, conversion$1, iv$1)).text$3;
          var this$11 = new $c_sci_StringOps().init___T(x$1);
          var str = $f_sci_StringLike__stripSuffix__T__T(this$11, "?");
          return jsx$6.apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry(jsx$5, $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str))
        } else {
          return entry
        }
      })
    })(this));
    var this$13 = $m_sc_IndexedSeq$();
    var newEntries = $as_sc_IndexedSeq(jsx$7.map__F1__scg_CanBuildFrom__O(jsx$4, this$13.ReusableCBF$6));
    var jsx$10 = $m_Lorg_yaml_model_YMapEntry$();
    var jsx$9 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("");
    $m_Lorg_yaml_model_YNode$();
    var jsx$8 = $m_Lorg_yaml_model_YMap$();
    var this$14 = newEntries.headOption__s_Option();
    if (this$14.isEmpty__Z()) {
      var this$15 = $m_s_None$()
    } else {
      var arg1 = this$14.get__O();
      var x$9 = $as_Lorg_yaml_model_YMapEntry(arg1);
      var this$15 = new $c_s_Some().init___O(x$9.location$1.sourceName$1)
    };
    var map = jsx$8.apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(newEntries, $as_T((this$15.isEmpty__Z() ? "" : this$15.get__O())));
    $m_Lorg_yaml_model_YNode$();
    var toParse$2 = jsx$10.apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry(jsx$9, $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1));
    var parsed = $as_Lamf_core_model_domain_Shape($as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser(this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().typeParser__F4().apply__O__O__O__O__O(toParse$2, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1, union$2) {
      return (function(s$3$2) {
        var s$3 = $as_Lamf_core_model_domain_Shape(s$3$2);
        var value$1 = union$2.id$1;
        $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(s$3, value$1)
      })
    })(this, union)), this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$typeInfo$f.isAnnotation$1, this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$defaultType$f)).parse__s_Option().get__O())
  };
  var jsx$11 = $m_sc_Seq$();
  $m_Lamf_core_parser_Annotations$();
  var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
  var this$21 = new $c_Lamf_plugins_domain_shapes_models_NilShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
  var value$2 = union.id$1;
  var array = [parsed, $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$21, value$2))];
  var elements = $as_sc_Seq(jsx$11.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  var field = $m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1;
  return $as_Lamf_plugins_domain_shapes_models_UnionShape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(union, field, elements))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.prototype.parseScalarType__p2__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_core_model_domain_Shape = (function(typeDef) {
  if ($f_Lamf_plugins_domain_shapes_models_TypeDef__isNil__Z(typeDef)) {
    var this$1 = $m_Lamf_plugins_domain_shapes_models_NilShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_NilShape(this.ast$2);
    var name = this.name$2;
    var a = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$nameAnnotations$2;
    var nilShape = $as_Lamf_plugins_domain_shapes_models_NilShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$1, name, a));
    this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$adopt$f.apply__O__O(nilShape);
    var this$2 = this.node$2;
    var x1 = this$2.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x === x1)) {
      var this$3 = this.node$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lamf_plugins_domain_shapes_models_NilShape__Lorg_yaml_model_YMap(this, nilShape, $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv))).parse__Lamf_plugins_domain_shapes_models_AnyShape()
    } else {
      return nilShape
    }
  } else {
    var this$4 = $m_Lamf_plugins_domain_shapes_models_ScalarShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_ScalarShape(this.ast$2);
    var name$1 = this.name$2;
    var a$1 = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$nameAnnotations$2;
    var shape = $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$4, name$1, a$1));
    this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$adopt$f.apply__O__O(shape);
    var this$5 = this.node$2;
    var x1$2 = this$5.tag__Lorg_yaml_model_YTag().tagType$3;
    var x$3 = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x$3 === x1$2)) {
      var this$6 = this.node$2;
      var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv$1 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_domain_shapes_models_ScalarShape__Lorg_yaml_model_YMap(this, typeDef, shape, $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion$1, iv$1))).parse__Lamf_plugins_domain_shapes_models_ScalarShape()
    } else {
      var x$5 = $m_Lorg_yaml_model_YType$().Seq$1;
      if ((x$5 === x1$2)) {
        var entry = $as_Lorg_yaml_model_YMapEntry(this.ast$2);
        new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YMapEntry__Lamf_core_model_domain_Shape__s_Option__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this, entry, shape, $m_s_None$(), this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext()).parse__V();
        var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
        var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$().xsd__Lamf_plugins_domain_shapes_models_TypeDef__T(typeDef), new $c_Lamf_core_parser_Annotations().init___());
        var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(shape, field, value, annotations);
        return shape
      } else {
        var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
        var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$().xsd__Lamf_plugins_domain_shapes_models_TypeDef__T(typeDef), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.node$2.value__Lorg_yaml_model_YValue()));
        return $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(shape, field$1, value$1))
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.prototype.init___s_util_Either__Lorg_yaml_model_YNode__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(entryOrNode, key, adopt, typeInfo, defaultType, ctx) {
  this.key$2 = key;
  this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$adopt$f = adopt;
  this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$typeInfo$f = typeInfo;
  this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$defaultType$f = defaultType;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.prototype.init___Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, ctx);
  var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
  this.name$2 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(key, conversion, ctx)).text$3;
  if ((entryOrNode instanceof $c_s_util_Right)) {
    var x2 = $as_s_util_Right(entryOrNode);
    var n = $as_Lorg_yaml_model_YNode(x2.value$2);
    var x1$2_$_$$und1$f = n;
    var x1$2_$_$$und2$f = n
  } else {
    if ((!(entryOrNode instanceof $c_s_util_Left))) {
      throw new $c_s_MatchError().init___O(entryOrNode)
    };
    var x3 = $as_s_util_Left(entryOrNode);
    var e = $as_Lorg_yaml_model_YMapEntry(x3.value$2);
    var _2 = e.value$2;
    var x1$2_$_$$und1$f = e;
    var x1$2_$_$$und2$f = _2
  };
  var ast = $as_Lorg_yaml_model_YPart(x1$2_$_$$und1$f);
  var node = $as_Lorg_yaml_model_YNode(x1$2_$_$$und2$f);
  this.x$7$2 = new $c_T2().init___O__O(ast, node);
  this.ast$2 = $as_Lorg_yaml_model_YPart(this.x$7$2.$$und1__O());
  this.node$2 = $as_Lorg_yaml_model_YNode(this.x$7$2.$$und2__O());
  var this$1 = new $c_s_util_Either$LeftProjection().init___s_util_Either(entryOrNode).toOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var e$2 = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$2 = new $c_s_Some().init___O($m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(e$2.key$2))
  };
  this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$nameAnnotations$2 = $as_Lamf_core_parser_Annotations((this$2.isEmpty__Z() ? ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()) : this$2.get__O()));
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.prototype.parseObjectType__p2__Lamf_core_model_domain_Shape = (function() {
  if (this.isFileType__p2__Z()) {
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.node$2);
    var this$3 = new $c_Lamf_plugins_domain_shapes_models_FileShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
    var name = this.name$2;
    var a = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$nameAnnotations$2;
    var shape = $as_Lamf_plugins_domain_shapes_models_FileShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a));
    var this$4 = this.node$2;
    var x1 = this$4.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Str$1;
    if ((x === x1)) {
      this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$adopt$f.apply__O__O(shape)
    } else {
      var x$3 = $m_Lorg_yaml_model_YType$().Map$1;
      if ((x$3 === x1)) {
        new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YNode__Lamf_plugins_domain_shapes_models_FileShape__F1(this, this.node$2, shape, this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$adopt$f).parse__Lamf_plugins_domain_shapes_models_FileShape()
      } else {
        throw new $c_s_MatchError().init___O(x1)
      }
    };
    return shape
  } else {
    var this$5 = $m_Lamf_plugins_domain_shapes_models_NodeShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_NodeShape(this.ast$2);
    var name$1 = this.name$2;
    var a$1 = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$nameAnnotations$2;
    var shape$2 = $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$5, name$1, a$1));
    this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$adopt$f.apply__O__O(shape$2);
    var this$6 = this.node$2;
    var x1$2 = this$6.tag__Lorg_yaml_model_YTag().tagType$3;
    var x$5 = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x$5 === x1$2)) {
      var this$7 = this.node$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lamf_plugins_domain_shapes_models_NodeShape__Lorg_yaml_model_YMap(this, shape$2, $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$7, conversion, iv))).parse__Lamf_plugins_domain_shapes_models_AnyShape()
    } else {
      var x$7 = $m_Lorg_yaml_model_YType$().Seq$1;
      if ((x$7 === x1$2)) {
        new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YMapEntry__Lamf_core_model_domain_Shape__s_Option__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this, $as_Lorg_yaml_model_YMapEntry(this.ast$2), shape$2, $m_s_None$(), this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext()).parse__V();
        return shape$2
      } else {
        var node = this.node$2;
        if (new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lamf_core_parser_package$YScalarYRead$()).isDefined__Z()) {
          var x1$3 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().link__Lorg_yaml_model_YNode__s_util_Either(this.node$2);
          if ((x1$3 instanceof $c_s_util_Left)) {
            var x2 = $as_s_util_Left(x1$3);
            var key = $as_T(x2.value$2);
            var refTuple = new $c_T2().init___O__O(key, this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().findType__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option(key, $m_Lamf_core_parser_SearchScope$Fragments$(), new $c_s_Some().init___O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, shape$2$1) {
              return (function(s$2) {
                var s = $as_T(s$2);
                var this$9 = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1;
                var specification = $m_Lamf_validations_ParserSideValidations$().InvalidFragmentType$1;
                var node$1 = shape$2$1.id$1;
                var ast = $this.node$2;
                var prop = $m_s_None$();
                var l = ast.location$1;
                $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$9, specification, node$1, prop, s, l)
              })
            })(this, shape$2)))))
          } else {
            var this$10 = this.node$2;
            var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
            var iv$1 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
            var text = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$10, conversion$1, iv$1)).text$3;
            var refTuple = new $c_T2().init___O__O(text, this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().findType__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option(text, $m_Lamf_core_parser_SearchScope$Named$(), (this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations(), $m_s_None$())))
          };
          if ((refTuple !== null)) {
            var text$2 = $as_T(refTuple.$$und1__O());
            var p2 = $as_s_Option(refTuple.$$und2__O());
            if ((text$2 !== null)) {
              if ((p2 instanceof $c_s_Some)) {
                var x3 = $as_s_Some(p2);
                var s$3 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x3.value$2);
                var this$12 = $as_Lamf_core_model_domain_Shape(s$3.link__T__Lamf_core_parser_Annotations__O(text$2, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.node$2)));
                var name$2 = this.name$2;
                var a$2 = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$nameAnnotations$2;
                return $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$12, name$2, a$2).withId__T__Lamf_core_model_domain_AmfObject(shape$2.id$1))
              }
            }
          };
          if ((refTuple !== null)) {
            var text$3 = $as_T(refTuple.$$und1__O());
            if ((text$3 !== null)) {
              var x$9 = $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$().matchType__Lamf_plugins_document_webapi_parser_TypeName__Lamf_plugins_domain_shapes_models_TypeDef__Z__Lamf_plugins_domain_shapes_models_TypeDef(new $c_Lamf_plugins_document_webapi_parser_TypeName().init___T__s_Option(text$3, $m_s_None$()), $m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$(), ($m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$(), false));
              var x$10 = $m_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$();
              if (((x$9 !== null) && (x$9 === x$10))) {
                shape$2.annotations$2.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ExplicitField().init___());
                return shape$2
              }
            }
          };
          if ((refTuple !== null)) {
            var text$4 = $as_T(refTuple.$$und1__O());
            if ((text$4 !== null)) {
              var this$15 = new $c_Lamf_plugins_domain_shapes_models_UnresolvedShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations__T__s_Option__s_Option__Z(new $c_Lamf_core_parser_Fields().init___(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.node$2), text$4, $m_s_None$(), new $c_s_Some().init___O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, shape$2$2) {
                return (function(k$2) {
                  var k = $as_T(k$2);
                  var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().TargetId$1;
                  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(shape$2$2, field, k)
                })
              })(this, shape$2))), false);
              var a$3 = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$nameAnnotations$2;
              var unresolve = $as_Lamf_plugins_domain_shapes_models_UnresolvedShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$15, text$4, a$3));
              var c = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
              $f_Lamf_core_parser_UnresolvedReference__withContext__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(unresolve, c);
              this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$adopt$f.apply__O__O(unresolve);
              if ((!new $c_Lamf_core_utils_package$AmfStrings().init___T(text$4).validReferencePath__Z())) {
                var this$17 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().libraries$1;
                var this$18 = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(this$17);
                var this$19 = this$18.$$outer$4.keysIterator__sc_Iterator();
                var res = false;
                while (((!res) && this$19.hasNext__Z())) {
                  var arg1 = this$19.next__O();
                  var x$10$2 = $as_T(arg1);
                  var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(text$4, "\\.", 0);
                  var this$22 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
                  res = (x$10$2 === $f_sc_IndexedSeqOptimized__head__O(this$22))
                };
                var jsx$1 = res
              } else {
                var jsx$1 = false
              };
              if (jsx$1) {
                var this$23 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1;
                var specification$1 = $m_Lamf_validations_ParserSideValidations$().ChainedReferenceSpecification$1;
                var node$2 = shape$2.id$1;
                var message = ("Chained reference '" + text$4);
                var ast$1 = this.node$2;
                var prop$1 = $m_s_None$();
                var l$1 = ast$1.location$1;
                $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$23, specification$1, node$2, prop$1, message, l$1)
              } else {
                var refAst = this.node$2;
                var ctx = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
                $f_Lamf_core_model_domain_Linkable__unresolved__T__Lorg_yaml_model_YPart__T__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(unresolve, text$4, refAst, "error", ctx)
              };
              var this$24 = $as_Lamf_core_model_domain_Linkable($f_Lamf_core_model_domain_Linkable__withLinkTarget__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(shape$2, unresolve));
              var field$1 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1;
              return $as_Lamf_core_model_domain_Shape($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$24, field$1, text$4)))
            }
          };
          throw new $c_s_MatchError().init___O(refTuple)
        } else {
          throw new $c_s_MatchError().init___O(x1$2)
        }
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.prototype.parseUnionType__p2__Lamf_plugins_domain_shapes_models_UnionShape = (function() {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.node$2);
  var this$3 = new $c_Lamf_plugins_domain_shapes_models_UnionShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var name = this.name$2;
  var a = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$nameAnnotations$2;
  var shape = $as_Lamf_plugins_domain_shapes_models_UnionShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a));
  this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$adopt$f.apply__O__O(shape);
  var this$4 = this.node$2;
  var x1 = this$4.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var this$5 = this.node$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YMap__Lamf_plugins_domain_shapes_models_UnionShape(this, $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv)), shape).parse__Lamf_plugins_domain_shapes_models_UnionShape()
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Seq$1;
    if ((x$3 === x1)) {
      new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YMapEntry__Lamf_core_model_domain_Shape__s_Option__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this, $as_Lorg_yaml_model_YMapEntry(this.ast$2), shape, $m_s_None$(), this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext()).parse__V();
      return shape
    } else {
      var this$6 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1;
      var specification = $m_Lamf_validation_DialectValidations$().InvalidUnionType$1;
      var node = shape.id$1;
      var message = ("Invalid node for union shape '" + this.node$2.toString__T());
      var ast = this.node$2;
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$6, specification, node, prop, message, l);
      return shape
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.prototype.parseDefaultType__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_core_model_domain_Shape = (function(defaultType) {
  var x1 = defaultType.typeDef__Lamf_plugins_domain_shapes_models_TypeDef();
  if ($f_Lamf_plugins_domain_shapes_models_TypeDef__isScalar__Z(x1)) {
    var defaultShape = this.parseScalarType__p2__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_core_model_domain_Shape(x1)
  } else {
    var x = $m_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$();
    if ((x === x1)) {
      var defaultShape = this.parseObjectType__p2__Lamf_core_model_domain_Shape()
    } else {
      var defaultShape = this.parseAnyType__p2__Lamf_core_model_domain_Shape()
    }
  };
  defaultShape.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_DefaultNode().init___());
  return defaultShape
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.prototype.isFileType__p2__Z = (function() {
  var this$1 = this.node$2;
  var evidence$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var x1 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$1, evidence$2);
  if ((x1 instanceof $c_s_util_Right)) {
    var x2 = $as_s_util_Right(x1);
    var map = $as_Lorg_yaml_model_YMap(x2.value$2);
    var this$2 = this.typeOrSchema__Lorg_yaml_model_YMap__s_Option(map);
    if ((!this$2.isEmpty__Z())) {
      var arg1 = this$2.get__O();
      var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
      var this$3 = entry.value$2;
      var evidence$2$1 = $m_Lamf_core_parser_package$YScalarYRead$();
      var x1$1 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$3, evidence$2$1);
      if ((x1$1 instanceof $c_s_util_Right)) {
        var x2$1 = $as_s_util_Right(x1$1);
        var scalar = $as_Lorg_yaml_model_YScalar(x2$1.value$2);
        var jsx$1 = (scalar.text$3 === "file")
      } else {
        var jsx$1 = false
      }
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return true
    } else {
      return new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("fileTypes").isDefined__Z()
    }
  } else if ((x1 instanceof $c_s_util_Left)) {
    var this$5 = this.node$2;
    var evidence$2$2 = $m_Lamf_core_parser_package$YScalarYRead$();
    var x1$2 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$5, evidence$2$2);
    if ((x1$2 instanceof $c_s_util_Right)) {
      var x2$2 = $as_s_util_Right(x1$2);
      var scalar$1 = $as_Lorg_yaml_model_YScalar(x2$2.value$2);
      return (scalar$1.text$3 === "file")
    } else {
      return false
    }
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.shape$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser.prototype.productPrefix__T = (function() {
  return "AndConstraintParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser(x$1).$$outer$1 === this.$$outer$1))) {
    var AndConstraintParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser(x$1);
    var this$1 = this.map$1;
    var b = AndConstraintParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.shape$1;
      var x$2 = AndConstraintParser$1.shape$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.shape$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape = (function($$outer, map, shape) {
  this.map$1 = map;
  this.shape$1 = shape;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser.prototype.parse__V = (function() {
  var map = this.map$1;
  var this$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("and").asRamlAnnotation__T();
  var this$4 = this$3.key__T__s_Option(keyword);
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$5 = entry.value$2;
    var evidence$2 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var x1 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$5, evidence$2);
    if ((x1 instanceof $c_s_util_Right)) {
      var x2 = $as_s_util_Right(x1);
      var seq = $as_sc_Seq(x2.value$2);
      var this$6 = $m_sc_Seq$();
      var jsx$4 = $as_sc_TraversableLike(seq.zipWithIndex__scg_CanBuildFrom__O(this$6.ReusableCBFInstance$2));
      var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x0$1$2) {
          var x0$1 = $as_T2(x0$1$2);
          if ((x0$1 !== null)) {
            var unionNode = $as_Lorg_yaml_model_YNode(x0$1.$$und1__O());
            var index = x0$1.$$und2$mcI$sp__I();
            return $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser($this.$$outer$1.typeParser__F5().apply__O__O__O__O__O__O(($m_s_package$(), new $c_s_util_Right().init___O(unionNode)), ("item" + index), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, index$1) {
              return (function(item$2) {
                var item = $as_Lamf_core_model_domain_Shape(item$2);
                item.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject((($this$1.shape$1.id$1 + "/and/") + index$1), item.adopted$default$2__sc_Seq())
              })
            })($this, index)), $this.$$outer$1.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$typeInfo$f.isAnnotation$1, $m_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$())).parse__s_Option()
          } else {
            throw new $c_s_MatchError().init___O(x0$1)
          }
        })
      })(this));
      var this$8 = $m_sc_Seq$();
      var jsx$2 = $as_sc_TraversableLike($as_sc_TraversableLike(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$8.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
        return (function(x$16$2) {
          var x$16 = $as_s_Option(x$16$2);
          return x$16.isDefined__Z()
        })
      })(this))));
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
        return (function(x$17$2) {
          var x$17 = $as_s_Option(x$17$2);
          return $as_Lamf_core_model_domain_Shape(x$17.get__O())
        })
      })(this));
      var this$9 = $m_sc_Seq$();
      var nodes = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$9.ReusableCBFInstance$2));
      var this$10 = this.shape$1;
      var field = $m_Lamf_core_metamodel_domain_ShapeModel$().And$1;
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
      $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$10, field, nodes, annotations)
    } else {
      var this$11 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidAndType$1;
      var node = this.shape$1.id$1;
      var prop = $m_s_None$();
      var l = entry.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$11, specification, node, prop, "And constraints are built from multiple shape nodes", l)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$AndConstraintParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$AndConstraintParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$AndConstraintParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AndConstraintParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser() {
  $c_O.call(this);
  this.name$1 = null;
  this.ast$1 = null;
  this.map$1 = null;
  this.adopt$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser.prototype.productPrefix__T = (function() {
  return "DataArrangementParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser(x$1).$$outer$1 === this.$$outer$1))) {
    var DataArrangementParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser(x$1);
    if ((this.name$1 === DataArrangementParser$1.name$1)) {
      var x = this.ast$1;
      var x$2 = DataArrangementParser$1.ast$1;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var this$1 = this.map$1;
      var b = DataArrangementParser$1.map$1;
      var jsx$1 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.adopt$1;
      var x$4 = DataArrangementParser$1.adopt$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.name$1;
      break
    }
    case 1: {
      return this.ast$1;
      break
    }
    case 2: {
      return this.map$1;
      break
    }
    case 3: {
      return this.adopt$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser.prototype.lookAhead__s_util_Either = (function() {
  var map = this.map$1;
  var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("tuple").asRamlAnnotation__T());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    var this$3 = entry.value$2;
    var evidence$2 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var x1$2 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$3, evidence$2);
    if ((x1$2 instanceof $c_s_util_Right)) {
      $m_s_package$();
      var this$4 = $m_Lamf_plugins_domain_shapes_models_TupleShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_TupleShape(this.ast$1);
      var name = this.name$1;
      var a = this.$$outer$1.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$nameAnnotations$2;
      var value = $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$4, name, a);
      return new $c_s_util_Left().init___O(value)
    } else {
      var this$6 = $m_Lamf_plugins_domain_shapes_models_TupleShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_TupleShape(this.ast$1);
      var name$1 = this.name$1;
      var a$1 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$nameAnnotations$2;
      var tuple = $as_Lamf_plugins_domain_shapes_models_TupleShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$6, name$1, a$1));
      var this$7 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidTupleType$1;
      var node = tuple.id$1;
      var ast = this.ast$1;
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$7, specification, node, prop, "Tuples must have a list of types", l);
      $m_s_package$();
      return new $c_s_util_Left().init___O(tuple)
    }
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      $m_s_package$();
      var this$9 = $m_Lamf_plugins_domain_shapes_models_ArrayShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_ArrayShape(this.ast$1);
      var name$2 = this.name$1;
      var a$2 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$nameAnnotations$2;
      var value$1 = $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$9, name$2, a$2);
      return new $c_s_util_Right().init___O(value$1)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser.prototype.parse__Lamf_core_model_domain_Shape = (function() {
  var x1 = this.lookAhead__s_util_Either();
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var tuple = $as_Lamf_plugins_domain_shapes_models_TupleShape(x2.value$2);
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lamf_plugins_domain_shapes_models_TupleShape__Lorg_yaml_model_YMap__F1(this.$$outer$1, tuple, this.map$1, this.adopt$1).parse__Lamf_plugins_domain_shapes_models_TupleShape()
  } else if ((x1 instanceof $c_s_util_Right)) {
    var x3 = $as_s_util_Right(x1);
    var array = $as_Lamf_plugins_domain_shapes_models_ArrayShape(x3.value$2);
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lamf_plugins_domain_shapes_models_ArrayShape__Lorg_yaml_model_YMap__F1(this.$$outer$1, array, this.map$1, this.adopt$1).parse__Lamf_plugins_domain_shapes_models_AnyShape()
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__T__Lorg_yaml_model_YPart__Lorg_yaml_model_YMap__F1 = (function($$outer, name, ast, map, adopt) {
  this.name$1 = name;
  this.ast$1 = ast;
  this.map$1 = map;
  this.adopt$1 = adopt;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$DataArrangementParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$DataArrangementParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$DataArrangementParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$DataArrangementParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.shape$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser.prototype.productPrefix__T = (function() {
  return "NotConstraintParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser(x$1).$$outer$1 === this.$$outer$1))) {
    var NotConstraintParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser(x$1);
    var this$1 = this.map$1;
    var b = NotConstraintParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.shape$1;
      var x$2 = NotConstraintParser$1.shape$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.shape$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape = (function($$outer, map, shape) {
  this.map$1 = map;
  this.shape$1 = shape;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser.prototype.parse__V = (function() {
  var map = this.map$1;
  var this$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("not").asRamlAnnotation__T();
  var this$4 = this$3.key__T__s_Option(keyword);
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var x1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser(this.$$outer$1.typeParser__F5().apply__O__O__O__O__O__O(($m_s_package$(), new $c_s_util_Left().init___O(entry)), "not", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(s$2) {
        var s = $as_Lamf_core_model_domain_Shape(s$2);
        var value = ($this.shape$1.id$1 + "/not");
        $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(s, value)
      })
    })(this)), false, this.$$outer$1.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$defaultType$f)).parse__s_Option();
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var negated = $as_Lamf_core_model_domain_Shape(x2.value$2);
      var this$6 = this.shape$1;
      var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Not$1;
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$6, field, negated, annotations)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$NotConstraintParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$NotConstraintParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$NotConstraintParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NotConstraintParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.shape$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser.prototype.productPrefix__T = (function() {
  return "OrConstraintParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser(x$1).$$outer$1 === this.$$outer$1))) {
    var OrConstraintParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser(x$1);
    var this$1 = this.map$1;
    var b = OrConstraintParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.shape$1;
      var x$2 = OrConstraintParser$1.shape$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.shape$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape = (function($$outer, map, shape) {
  this.map$1 = map;
  this.shape$1 = shape;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser.prototype.parse__V = (function() {
  var map = this.map$1;
  var this$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("or").asRamlAnnotation__T();
  var this$4 = this$3.key__T__s_Option(keyword);
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$5 = entry.value$2;
    var evidence$2 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var x1 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$5, evidence$2);
    if ((x1 instanceof $c_s_util_Right)) {
      var x2 = $as_s_util_Right(x1);
      var seq = $as_sc_Seq(x2.value$2);
      var this$6 = $m_sc_Seq$();
      var jsx$4 = $as_sc_TraversableLike(seq.zipWithIndex__scg_CanBuildFrom__O(this$6.ReusableCBFInstance$2));
      var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x0$1$2) {
          var x0$1 = $as_T2(x0$1$2);
          if ((x0$1 !== null)) {
            var unionNode = $as_Lorg_yaml_model_YNode(x0$1.$$und1__O());
            var index = x0$1.$$und2$mcI$sp__I();
            return $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser($this.$$outer$1.typeParser__F5().apply__O__O__O__O__O__O(($m_s_package$(), new $c_s_util_Right().init___O(unionNode)), ("item" + index), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, index$1) {
              return (function(item$2) {
                var item = $as_Lamf_core_model_domain_Shape(item$2);
                item.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject((($this$1.shape$1.id$1 + "/or/") + index$1), item.adopted$default$2__sc_Seq())
              })
            })($this, index)), $this.$$outer$1.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$typeInfo$f.isAnnotation$1, $m_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$())).parse__s_Option()
          } else {
            throw new $c_s_MatchError().init___O(x0$1)
          }
        })
      })(this));
      var this$8 = $m_sc_Seq$();
      var jsx$2 = $as_sc_TraversableLike($as_sc_TraversableLike(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$8.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
        return (function(x$14$2) {
          var x$14 = $as_s_Option(x$14$2);
          return x$14.isDefined__Z()
        })
      })(this))));
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
        return (function(x$15$2) {
          var x$15 = $as_s_Option(x$15$2);
          return $as_Lamf_core_model_domain_Shape(x$15.get__O())
        })
      })(this));
      var this$9 = $m_sc_Seq$();
      var nodes = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$9.ReusableCBFInstance$2));
      var this$10 = this.shape$1;
      var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Or$1;
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
      $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$10, field, nodes, annotations)
    } else {
      var this$11 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidOrType$1;
      var node = this.shape$1.id$1;
      var prop = $m_s_None$();
      var l = entry.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$11, specification, node, prop, "Or constraints are built from multiple shape nodes", l)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$OrConstraintParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$OrConstraintParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$OrConstraintParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$OrConstraintParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser() {
  $c_O.call(this);
  this.ast$1 = null;
  this.producer$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser.prototype.productPrefix__T = (function() {
  return "PropertiesParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser(x$1).$$outer$1 === this.$$outer$1))) {
    var PropertiesParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser(x$1);
    var this$1 = this.ast$1;
    var b = PropertiesParser$1.ast$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.producer$1;
      var x$2 = PropertiesParser$1.producer$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.ast$1;
      break
    }
    case 1: {
      return this.producer$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser.prototype.parse__sc_Seq = (function() {
  var jsx$2 = this.ast$1.entries$3;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var xo = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YMapEntry__F1($this.$$outer$1, entry, $this.producer$1).parse__s_Option();
      return xo.toList__sci_List()
    })
  })(this));
  var this$2 = $m_sc_IndexedSeq$();
  return $as_sc_Seq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBF$6))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YMap__F1 = (function($$outer, ast, producer) {
  this.ast$1 = ast;
  this.producer$1 = producer;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$PropertiesParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$PropertiesParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$PropertiesParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser() {
  $c_O.call(this);
  this.entry$1 = null;
  this.producer$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser.prototype.productPrefix__T = (function() {
  return "PropertyShapeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser(x$1).$$outer$1 === this.$$outer$1))) {
    var PropertyShapeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser(x$1);
    var x = this.entry$1;
    var x$2 = PropertyShapeParser$1.entry$1;
    if ((x === x$2)) {
      var x$3 = this.producer$1;
      var x$4 = PropertyShapeParser$1.producer$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$1;
      break
    }
    case 1: {
      return this.producer$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser.prototype.parse__s_Option = (function() {
  var x1 = this.entry$1.key$2.asScalar__s_Option();
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var scalarKey = $as_Lorg_yaml_model_YScalar(x2.value$2);
    var propName = scalarKey.text$3;
    var this$1 = $as_Lamf_core_model_domain_AmfElement(this.producer$1.apply__O__O(propName));
    var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1);
    var property = $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$1, other));
    if (((($uI(propName.length) >= 0) && ($as_T(propName.substring(0, $uI("/".length))) === "/")) && $m_sjsr_RuntimeString$().endsWith__T__T__Z(propName, "/"))) {
      if ((propName === "//")) {
        var field = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().PatternName$1;
        $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(property, field, "^.*$"))
      } else {
        var this$8 = new $c_sci_StringOps().init___T(propName);
        var $$this = this$8.repr$1;
        var until = $uI($$this.length);
        var x = $m_sci_StringOps$().slice$extension__T__I__I__T(this$8.repr$1, 1, until);
        var this$12 = new $c_sci_StringOps().init___T(x);
        var pattern = $as_T($f_sc_IndexedSeqOptimized__dropRight__I__O(this$12, 1));
        var field$1 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().PatternName$1;
        $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(property, field$1, pattern))
      }
    };
    var node = this.entry$1.value$2;
    var x1$2 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YMapYRead$());
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var map = $as_Lorg_yaml_model_YMap(x2$2.value$2);
      var this$15 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
      var this$16 = this$15.key__T__s_Option("required");
      if ((!this$16.isEmpty__Z())) {
        var arg1 = this$16.get__O();
        var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
        var node$1 = entry.value$2;
        var iv = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
        var this$18 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$1, iv);
        var required = $uZ(this$18.$boolean__Lamf_core_model_domain_AmfScalar().value$1);
        var field$2 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1;
        var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations((required ? 1 : 0), new $c_Lamf_core_parser_Annotations().init___());
        var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ExplicitField().init___());
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(property, field$2, value, annotations)
      }
    };
    var field$3 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Path$1;
    var this$24 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
    var this$20 = this.entry$1.key$2;
    var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv$1 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
    var str = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$20, conversion, iv$1)).text$3;
    var this$22 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
    var this$23 = this$22.platform$1;
    var url = this$22.str$1;
    var id = $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$23, url);
    var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$24, id).iri__T(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1.key$2));
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(property, field$3, value$1);
    if (property.fields$2.$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1).isEmpty__Z()) {
      if ($as_Lamf_core_model_StrField(property.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().PatternName$1)).option$1.isDefined__Z()) {
        var field$4 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1;
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject(property, field$4, 0)
      } else {
        var required$1 = (!$m_sjsr_RuntimeString$().endsWith__T__T__Z(propName, "?"));
        var field$5 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1;
        var value$2 = (required$1 ? 1 : 0);
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject(property, field$5, value$2);
        var field$6 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Name$1;
        if (required$1) {
          var value$3 = propName
        } else {
          var this$27 = new $c_sci_StringOps().init___T(propName);
          var x$1 = $f_sci_StringLike__stripSuffix__T__T(this$27, "?");
          var this$29 = new $c_sci_StringOps().init___T(x$1);
          var x$2 = $f_sci_StringLike__stripPrefix__T__T(this$29, "/");
          var this$31 = new $c_sci_StringOps().init___T(x$2);
          var value$3 = $f_sci_StringLike__stripSuffix__T__T(this$31, "/")
        };
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(property, field$6, value$3);
        var field$7 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Path$1;
        var this$35 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
        var this$32 = this.entry$1.key$2;
        var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
        var iv$2 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
        var x$3 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$32, conversion$1, iv$2)).text$3;
        var this$34 = new $c_sci_StringOps().init___T(x$3);
        var id$1 = $f_sci_StringLike__stripSuffix__T__T(this$34, "?");
        var value$4 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$35, id$1).iri__T();
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(property, field$7, value$4)
      }
    };
    var this$37 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(this.entry$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, property$1) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        shape.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(property$1.id$1, shape.adopted$default$2__sc_Seq())
      })
    })(this, property)), new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo().init___Z__Z(false, true), $m_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$(), this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext()).parse__s_Option();
    if ((!this$37.isEmpty__Z())) {
      var arg1$1 = this$37.get__O();
      var range = $as_Lamf_core_model_domain_Shape(arg1$1);
      var this$38 = this.entry$1.value$2;
      var x$4 = this$38.tag__Lorg_yaml_model_YTag().tagType$3;
      var x$2$1 = $m_Lorg_yaml_model_YType$().Null$1;
      if ((x$4 === x$2$1)) {
        range.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SynthesizedField().init___())
      };
      var field$8 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1;
      $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(property, field$8, range))
    };
    return new $c_s_Some().init___O(property)
  } else {
    var x$5 = $m_s_None$();
    if ((x$5 === x1)) {
      var this$39 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidPropertyType$1;
      var ast = this.entry$1.key$2;
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$39, specification, "", prop, "Invalid property name", l);
      return $m_s_None$()
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YMapEntry__F1 = (function($$outer, entry, producer) {
  this.entry$1 = entry;
  this.producer$1 = producer;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$PropertyShapeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$PropertyShapeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$PropertyShapeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertyShapeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.shape$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser.prototype.productPrefix__T = (function() {
  return "XoneConstraintParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser(x$1).$$outer$1 === this.$$outer$1))) {
    var XoneConstraintParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser(x$1);
    var this$1 = this.map$1;
    var b = XoneConstraintParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.shape$1;
      var x$2 = XoneConstraintParser$1.shape$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.shape$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape = (function($$outer, map, shape) {
  this.map$1 = map;
  this.shape$1 = shape;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser.prototype.parse__V = (function() {
  this.$$outer$1.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$adopt$f.apply__O__O(this.shape$1);
  var map = this.map$1;
  var this$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("xor").asRamlAnnotation__T();
  var this$4 = this$3.key__T__s_Option(keyword);
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$5 = entry.value$2;
    var evidence$2 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var x1 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$5, evidence$2);
    if ((x1 instanceof $c_s_util_Right)) {
      var x2 = $as_s_util_Right(x1);
      var seq = $as_sc_Seq(x2.value$2);
      var this$6 = $m_sc_Seq$();
      var jsx$4 = $as_sc_TraversableLike(seq.zipWithIndex__scg_CanBuildFrom__O(this$6.ReusableCBFInstance$2));
      var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x0$1$2) {
          var x0$1 = $as_T2(x0$1$2);
          if ((x0$1 !== null)) {
            var unionNode = $as_Lorg_yaml_model_YNode(x0$1.$$und1__O());
            var index = x0$1.$$und2$mcI$sp__I();
            return $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser($this.$$outer$1.typeParser__F5().apply__O__O__O__O__O__O(($m_s_package$(), new $c_s_util_Right().init___O(unionNode)), ("item" + index), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, index$1) {
              return (function(item$2) {
                var item = $as_Lamf_core_model_domain_Shape(item$2);
                item.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject((($this$1.shape$1.id$1 + "/xor/") + index$1), item.adopted$default$2__sc_Seq())
              })
            })($this, index)), $this.$$outer$1.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$typeInfo$f.isAnnotation$1, $m_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$())).parse__s_Option()
          } else {
            throw new $c_s_MatchError().init___O(x0$1)
          }
        })
      })(this));
      var this$8 = $m_sc_Seq$();
      var jsx$2 = $as_sc_TraversableLike($as_sc_TraversableLike(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$8.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
        return (function(x$18$2) {
          var x$18 = $as_s_Option(x$18$2);
          return x$18.isDefined__Z()
        })
      })(this))));
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
        return (function(x$19$2) {
          var x$19 = $as_s_Option(x$19$2);
          return $as_Lamf_core_model_domain_Shape(x$19.get__O())
        })
      })(this));
      var this$9 = $m_sc_Seq$();
      var nodes = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$9.ReusableCBFInstance$2));
      var this$10 = this.shape$1;
      var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Xone$1;
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
      $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$10, field, nodes, annotations)
    } else {
      var this$11 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidXoneType$1;
      var node = this.shape$1.id$1;
      var prop = $m_s_None$();
      var l = entry.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$11, specification, node, prop, "Xone constraints are built from multiple shape nodes", l)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$XoneConstraintParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$XoneConstraintParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$XoneConstraintParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$XoneConstraintParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations() {
  $c_O.call(this);
  this.references$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations.prototype.$$plus$eq__T__Lamf_core_model_document_Fragment__V = (function(url, fragment) {
  this.references$1.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(url, fragment));
  var this$5 = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations();
  var jsx$1 = this$5.fragments$1;
  var y = new $c_Lamf_core_parser_FragmentRef().init___Lamf_core_model_domain_DomainElement__s_Option(fragment.encodes__Lamf_core_model_domain_DomainElement(), $f_Lamf_core_model_document_BaseUnit__location__s_Option(fragment));
  this$5.fragments$1 = jsx$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(url, y))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations.prototype.productPrefix__T = (function() {
  return "ReferenceDeclarations"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations.prototype.$$plus$eq__T__Lamf_core_model_document_Document__V = (function(url, fragment) {
  this.references$1.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(url, fragment))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations)) {
    var ReferenceDeclarations$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations(x$1);
    var x = this.references$1;
    var x$2 = ReferenceDeclarations$1.references$1;
    return ((x === null) ? (x$2 === null) : $f_sc_GenMapLike__equals__O__Z(x, x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations.prototype.init___scm_Map__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(references, ctx) {
  this.references$1 = references;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations.prototype.$$plus$eq__T__Lamf_core_model_document_BaseUnit__V = (function(alias, unit) {
  this.references$1.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(alias, unit));
  var library = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations().getOrCreateLibrary__T__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(alias);
  if (((unit instanceof $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary) || (unit instanceof $c_Lamf_client_model_document_Dialect))) {
    this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations().others$2 = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations().others$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(alias, unit))
  } else if ($is_Lamf_core_model_document_DeclaresModel(unit)) {
    $as_Lamf_core_model_document_DeclaresModel(unit).declares__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, library$1) {
      return (function(x$1$2) {
        var x$1 = $as_Lamf_core_model_domain_DomainElement(x$1$2);
        return library$1.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$1)
      })
    })(this, library)))
  } else {
    throw new $c_s_MatchError().init___O(unit)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations.prototype.solvedReferences__sc_Seq = (function() {
  var this$1 = this.references$1.values__sc_Iterable().toSet__sci_Set();
  return $f_sc_SetLike__toSeq__sc_Seq(this$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.ReferenceDeclarations"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.ReferenceDeclarations;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.ReferenceDeclarations", {
  Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser() {
  $c_O.call(this);
  this.baseUnit$1 = null;
  this.key$1 = null;
  this.map$1 = null;
  this.references$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser.prototype.productPrefix__T = (function() {
  return "ReferencesParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser.prototype.parse__T__Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations = (function(location) {
  var result = this.parseLibraries__p1__T__Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations(location);
  this.references$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, result$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_parser_ParsedReference(x0$1$2);
      matchEnd16: {
        if ((x0$1 !== null)) {
          var f = x0$1.unit$1;
          var origin = x0$1.origin$1;
          if ($is_Lamf_core_model_document_Fragment(f)) {
            var x6 = $as_Lamf_core_model_document_Fragment(f);
            if ((origin !== null)) {
              result$1.$$plus$eq__T__Lamf_core_model_document_Fragment__V(origin.url$1, x6);
              break matchEnd16
            }
          }
        };
        if ((x0$1 !== null)) {
          var d = x0$1.unit$1;
          var origin$2 = x0$1.origin$1;
          if ((d instanceof $c_Lamf_core_model_document_Document)) {
            var x8 = $as_Lamf_core_model_document_Document(d);
            if ((origin$2 !== null)) {
              result$1.$$plus$eq__T__Lamf_core_model_document_Document__V(origin$2.url$1, x8);
              break matchEnd16
            }
          }
        };
        if ((x0$1 !== null)) {
          var m = x0$1.unit$1;
          var origin$3 = x0$1.origin$1;
          if ((m instanceof $c_Lamf_core_model_document_Module)) {
            var x10 = $as_Lamf_core_model_document_Module(m);
            if ((origin$3 !== null)) {
              result$1.$$plus$eq__T__Lamf_core_model_document_BaseUnit__V(origin$3.url$1, x10);
              break matchEnd16
            }
          }
        };
        if ((x0$1 !== null)) {
          var other = x0$1.unit$1;
          var origin$4 = x0$1.origin$1;
          if ((((other instanceof $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary) || (other instanceof $c_Lamf_client_model_document_Dialect)) && (origin$4 !== null))) {
            result$1.$$plus$eq__T__Lamf_core_model_document_BaseUnit__V(origin$4.url$1, other);
            break matchEnd16
          }
        }
      }
    })
  })(this, result)));
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser)) {
    var ReferencesParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser(x$1);
    var x = this.baseUnit$1;
    var x$2 = ReferencesParser$1.baseUnit$1;
    if ((((x === null) ? (x$2 === null) : x.equals__O__Z(x$2)) && (this.key$1 === ReferencesParser$1.key$1))) {
      var this$1 = this.map$1;
      var b = ReferencesParser$1.map$1;
      var jsx$1 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.references$1;
      var x$4 = ReferencesParser$1.references$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.baseUnit$1;
      break
    }
    case 1: {
      return this.key$1;
      break
    }
    case 2: {
      return this.map$1;
      break
    }
    case 3: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser.prototype.target__p1__T__s_Option = (function(url) {
  var this$2 = this.references$1.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, url$1) {
    return (function(r$2) {
      var r = $as_Lamf_core_parser_ParsedReference(r$2);
      var this$1 = r.origin$1.url$1;
      return (this$1 === url$1)
    })
  })(this, url)));
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var x$2 = $as_Lamf_core_parser_ParsedReference(arg1);
    return new $c_s_Some().init___O(x$2.unit$1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser.prototype.init___Lamf_core_model_document_BaseUnit__T__Lorg_yaml_model_YMap__sc_Seq__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(baseUnit, key, map, references, ctx) {
  this.baseUnit$1 = baseUnit;
  this.key$1 = key;
  this.map$1 = map;
  this.references$1 = references;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser.prototype.collectAlias__p1__Lamf_core_model_document_BaseUnit__T2__Lamf_core_model_document_BaseUnit = (function(module, alias) {
  var x1 = module.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_Aliases.getClassOf());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var aliases = $as_Lamf_core_annotations_Aliases(x2.value$2);
    module.annotations__Lamf_core_parser_Annotations().reject__F1__Lamf_core_parser_Annotations(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$3$2) {
        var x$3 = $as_Lamf_core_model_domain_Annotation(x$3$2);
        return (x$3 instanceof $c_Lamf_core_annotations_Aliases)
      })
    })(this)));
    var aliases$1 = $as_sci_Set(aliases.aliases$1.$$plus__O__sc_Set(alias));
    var annotation = new $c_Lamf_core_annotations_Aliases().init___sci_Set(aliases$1);
    return $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(module, annotation))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var array = [alias];
      if (($uI(array.length) === 0)) {
        var jsx$1 = $m_sci_Set$EmptySet$()
      } else {
        var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
        var i = 0;
        var len = $uI(array.length);
        while ((i < len)) {
          var index = i;
          var arg1 = array[index];
          b.$$plus$eq__O__scm_SetBuilder(arg1);
          i = ((1 + i) | 0)
        };
        var jsx$1 = b.elems$1
      };
      var annotation$1 = new $c_Lamf_core_annotations_Aliases().init___sci_Set($as_sci_Set(jsx$1));
      return $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(module, annotation$1))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser.prototype.parseLibraries__p1__T__Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations = (function(id) {
  var result = $m_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations$().apply__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations(this.ctx$1);
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword = this.key$1;
  var this$3 = this$2.key__T__s_Option(keyword);
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var x1 = this$4.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x === x1)) {
      var this$5 = entry.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = this.ctx$1;
      $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, result$2, id$1) {
        return (function(e$2) {
          var e = $as_Lorg_yaml_model_YMapEntry(e$2);
          var this$6 = e.key$2;
          var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
          var iv$1 = $this.ctx$1;
          var alias = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion$1, iv$1)).text$3;
          var urlOption = $m_Lamf_plugins_document_webapi_parser_spec_declaration_LibraryLocationParser$().apply__Lorg_yaml_model_YMapEntry__Lamf_core_parser_ParserContext__s_Option(e, $this.ctx$1);
          if ((!urlOption.isEmpty__Z())) {
            var arg1$1 = urlOption.get__O();
            var url = $as_T(arg1$1);
            var this$7 = $this.target__p1__T__s_Option(url);
            if ((!this$7.isEmpty__Z())) {
              var arg1$2 = this$7.get__O();
              var x0$1 = $as_Lamf_core_model_document_BaseUnit(arg1$2);
              if ($is_Lamf_core_model_document_DeclaresModel(x0$1)) {
                var jsx$1 = $this.baseUnit$1;
                var y = new $c_T2().init___O__O(x0$1.id__T(), url);
                $this.collectAlias__p1__Lamf_core_model_document_BaseUnit__T2__Lamf_core_model_document_BaseUnit(jsx$1, new $c_T2().init___O__O(alias, y));
                result$2.$$plus$eq__T__Lamf_core_model_document_BaseUnit__V(alias, x0$1)
              } else {
                var this$10 = $this.ctx$1.eh$1;
                var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ExpectedModule$1;
                var message = ("Expected module but found: " + x0$1);
                var prop = $m_s_None$();
                var l = e.location$1;
                $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$10, specification, id$1, prop, message, l)
              }
            }
          }
        })
      })(this, result, id)))
    } else {
      var x$3 = $m_Lorg_yaml_model_YType$().Null$1;
      if ((!(x$3 === x1))) {
        var this$12 = this.ctx$1.eh$1;
        var specification$1 = $m_Lamf_validation_DialectValidations$().InvalidModuleType$1;
        var this$11 = entry.value$2;
        var message$1 = ("Invalid ast type for uses: " + this$11.tag__Lorg_yaml_model_YTag().tagType$3);
        var ast = entry.value$2;
        var prop$1 = $m_s_None$();
        var l$1 = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$12, specification$1, id, prop$1, message$1, l$1)
      }
    }
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.ReferencesParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.ReferencesParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.ReferencesParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.properties$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser.prototype.productPrefix__T = (function() {
  return "ShapeDependenciesParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser)) {
    var ShapeDependenciesParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser(x$1);
    var this$1 = this.map$1;
    var b = ShapeDependenciesParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.properties$1;
      var x$2 = ShapeDependenciesParser$1.properties$1;
      return ((x === null) ? (x$2 === null) : $f_sc_GenMapLike__equals__O__Z(x, x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.properties$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser.prototype.init___Lorg_yaml_model_YMap__scm_LinkedHashMap__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(map, properties, ctx) {
  this.map$1 = map;
  this.properties$1 = properties;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser.prototype.parse__sc_Seq = (function() {
  var jsx$2 = this.map$1.entries$3;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var xo = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_NodeDependencyParser().init___Lorg_yaml_model_YMapEntry__scm_LinkedHashMap__Lamf_plugins_document_webapi_contexts_WebApiContext(entry, $this.properties$1, $this.ctx$1).parse__s_Option();
      return xo.toList__sci_List()
    })
  })(this));
  var this$2 = $m_sc_IndexedSeq$();
  return $as_sc_Seq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBF$6))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.ShapeDependenciesParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.ShapeDependenciesParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.ShapeDependenciesParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo() {
  $c_O.call(this);
  this.isAnnotation$1 = false;
  this.isPropertyOrParameter$1 = false
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo.prototype.productPrefix__T = (function() {
  return "TypeInfo"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo)) {
    var TypeInfo$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo(x$1);
    return ((this.isAnnotation$1 === TypeInfo$1.isAnnotation$1) && (this.isPropertyOrParameter$1 === TypeInfo$1.isPropertyOrParameter$1))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.isAnnotation$1;
      break
    }
    case 1: {
      return this.isPropertyOrParameter$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.isAnnotation$1 ? 1231 : 1237));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.isPropertyOrParameter$1 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 2)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo.prototype.init___Z__Z = (function(isAnnotation, isPropertyOrParameter) {
  this.isAnnotation$1 = isAnnotation;
  this.isPropertyOrParameter$1 = isPropertyOrParameter;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.TypeInfo"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.TypeInfo;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.TypeInfo", {
  Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser() {
  $c_O.call(this);
  this.defaultName$1 = null;
  this.node$1 = null;
  this.ctx$1 = null;
  this.map$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser.prototype.productPrefix__T = (function() {
  return "XMLSerializerParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser)) {
    var XMLSerializerParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser(x$1);
    if ((this.defaultName$1 === XMLSerializerParser$1.defaultName$1)) {
      var this$1 = this.node$1;
      var b = XMLSerializerParser$1.node$1;
      return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.defaultName$1;
      break
    }
    case 1: {
      return this.node$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser.prototype.parse__Lamf_plugins_domain_shapes_models_XMLSerializer = (function() {
  var this$1 = $m_Lamf_plugins_domain_shapes_models_XMLSerializer$().apply__Lorg_yaml_model_YNode__Lamf_plugins_domain_shapes_models_XMLSerializer(this.node$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Attribute$1;
  var this$2 = $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, false);
  var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Wrapped$1;
  var serializer = $as_Lamf_plugins_domain_shapes_models_XMLSerializer($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$2, field$1, false));
  var map = this.map$1;
  var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$5 = this$4.key__T__s_Option("attribute");
  if ((!this$5.isEmpty__Z())) {
    var arg1 = this$5.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var node = entry.value$2;
    var iv = this.ctx$1;
    var value = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
    var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Attribute$1;
    var value$1 = value.$boolean__Lamf_core_model_domain_AmfScalar();
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ExplicitField().init___());
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(serializer, field$2, value$1, annotations)
  };
  var map$1 = this.map$1;
  var this$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var this$9 = this$8.key__T__s_Option("wrapped");
  if ((!this$9.isEmpty__Z())) {
    var arg1$1 = this$9.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var node$1 = entry$3.value$2;
    var iv$1 = this.ctx$1;
    var value$2 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$1, iv$1);
    var field$3 = $m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Wrapped$1;
    var value$3 = value$2.$boolean__Lamf_core_model_domain_AmfScalar();
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ExplicitField().init___());
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(serializer, field$3, value$3, annotations$1)
  };
  var map$2 = this.map$1;
  var this$12 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var this$13 = this$12.key__T__s_Option("name");
  if ((!this$13.isEmpty__Z())) {
    var arg1$2 = this$13.get__O();
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var node$2 = entry$4.value$2;
    var iv$2 = this.ctx$1;
    var value$4 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$2, iv$2);
    var field$4 = $m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Name$1;
    var value$5 = value$4.string__Lamf_core_model_domain_AmfScalar();
    var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ExplicitField().init___());
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(serializer, field$4, value$5, annotations$2)
  };
  var map$3 = this.map$1;
  var this$16 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3);
  var this$17 = this$16.key__T__s_Option("namespace");
  if ((!this$17.isEmpty__Z())) {
    var arg1$3 = this$17.get__O();
    var entry$5 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
    var node$3 = entry$5.value$2;
    var iv$3 = this.ctx$1;
    var value$6 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$3, iv$3);
    var field$5 = $m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Namespace$1;
    var value$7 = value$6.string__Lamf_core_model_domain_AmfScalar();
    var annotations$3 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$5);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(serializer, field$5, value$7, annotations$3)
  };
  var map$4 = this.map$1;
  var this$20 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$4);
  var this$21 = this$20.key__T__s_Option("prefix");
  if ((!this$21.isEmpty__Z())) {
    var arg1$4 = this$21.get__O();
    var entry$6 = $as_Lorg_yaml_model_YMapEntry(arg1$4);
    var node$4 = entry$6.value$2;
    var iv$4 = this.ctx$1;
    var value$8 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$4, iv$4);
    var field$6 = $m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Prefix$1;
    var value$9 = value$8.string__Lamf_core_model_domain_AmfScalar();
    var annotations$4 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$6);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(serializer, field$6, value$9, annotations$4)
  };
  this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(serializer.id$1, this.map$1, "xmlSerialization");
  return serializer
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser.prototype.init___T__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(defaultName, node, ctx) {
  this.defaultName$1 = defaultName;
  this.node$1 = node;
  this.ctx$1 = ctx;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  this.map$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, ctx));
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.XMLSerializerParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.XMLSerializerParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.XMLSerializerParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_XMLSerializerParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter.prototype.productPrefix__T = (function() {
  return "OasSchemaShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter)) {
    var OasSchemaShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter(x$1);
    var x = this.shape$1;
    var x$2 = OasSchemaShapeEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasSchemaShapeEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter.prototype.emitters__sc_Seq = (function() {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = this.shape$1;
  var fs = this$1.fields$2;
  result.$$plus$eq__O__scm_ListBuffer(this.spec$1.oasTypePropertyEmitter__T__Lamf_core_model_domain_Shape__Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter("object", this.shape$1));
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$().MediaType$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("mediaType").asOasExtension__T(), f, $m_s_None$())))
  };
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$().Raw$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1$1 = this$5.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("schema").asOasExtension__T(), f$3, $m_s_None$())))
  };
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.shape$1, this.ordering$1, this.spec$1).emitters__sc_Seq());
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.shape$1, this.ordering$1, this.spec$1).emitters__sc_Seq());
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_SchemaShape__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(shape, ordering, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasSchemaShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasSchemaShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasSchemaShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.ignored$1 = null;
  this.references$1 = null;
  this.pointer$1 = null;
  this.schemaPath$1 = null;
  this.isHeader$1 = false;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter.prototype.productPrefix__T = (function() {
  return "OasTypeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter.prototype.productArity__I = (function() {
  return 7
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter)) {
    var OasTypeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter(x$1);
    var x = this.shape$1;
    var x$2 = OasTypeEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasTypeEmitter$1.ordering$1;
      var jsx$5 = (x$3 === x$4)
    } else {
      var jsx$5 = false
    };
    if (jsx$5) {
      var x$5 = this.ignored$1;
      var x$6 = OasTypeEmitter$1.ignored$1;
      var jsx$4 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      var x$7 = this.references$1;
      var x$8 = OasTypeEmitter$1.references$1;
      var jsx$3 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$9 = this.pointer$1;
      var x$10 = OasTypeEmitter$1.pointer$1;
      var jsx$2 = ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$11 = this.schemaPath$1;
      var x$12 = OasTypeEmitter$1.schemaPath$1;
      var jsx$1 = ((x$11 === null) ? (x$12 === null) : x$11.equals__O__Z(x$12))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.isHeader$1 === OasTypeEmitter$1.isHeader$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.ignored$1;
      break
    }
    case 3: {
      return this.references$1;
      break
    }
    case 4: {
      return this.pointer$1;
      break
    }
    case 5: {
      return this.schemaPath$1;
      break
    }
    case 6: {
      return this.isHeader$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter.prototype.nilUnion__Lamf_plugins_domain_shapes_models_UnionShape__Z = (function(union) {
  return (($as_sc_Seq(union.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1)).size__I() === 1) && $as_Lamf_core_model_domain_AmfElement($as_sc_Seq(union.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1)).head__O()).annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_NilUnion.getClassOf()))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter.prototype.emitters__sc_Seq = (function() {
  var jsx$2 = this.pointer$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(p$2) {
      var p = $as_T(p$2);
      return ("/" + p)
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var nextPointerStr = ("#" + $as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).mkString__T());
  var jsx$4 = this.schemaPath$1;
  var jsx$3 = new $c_T2().init___O__O(this.shape$1.id$1, nextPointerStr);
  var this$2 = $m_sc_Seq$();
  var updatedSchemaPath = $as_sc_Seq(jsx$4.$$colon$plus__O__scg_CanBuildFrom__O(jsx$3, this$2.ReusableCBFInstance$2));
  var x1 = this.shape$1;
  matchEnd4: {
    if ($is_Lamf_plugins_domain_shapes_models_InheritanceChain(x1)) {
      if (this.shape$1.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf())) {
        var jsx$8 = updatedSchemaPath;
        var jsx$7 = $as_Lamf_plugins_domain_shapes_models_InheritanceChain(x1).inheritedIds$2;
        var jsx$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, nextPointerStr$1) {
          return (function(x$1$2) {
            var x$1 = $as_T(x$1$2);
            return new $c_T2().init___O__O(x$1, nextPointerStr$1)
          })
        })(this, nextPointerStr));
        var this$3 = $m_scm_Seq$();
        var jsx$5 = $as_sc_GenTraversableOnce(jsx$7.map__F1__scg_CanBuildFrom__O(jsx$6, this$3.ReusableCBFInstance$2));
        var this$4 = $m_sc_Seq$();
        updatedSchemaPath = $as_sc_Seq(jsx$8.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$5, this$4.ReusableCBFInstance$2));
        break matchEnd4
      }
    }
  };
  var rc16 = false;
  var x5 = null;
  var x1$2 = this.shape$1;
  if ((x1$2 !== null)) {
    if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x1$2).isDefined__Z()) {
      var jsx$9 = $m_sc_Seq$();
      var array = [new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter().init___Lamf_core_model_domain_DomainElement__s_Option__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.shape$1, $as_Lamf_core_model_StrField(x1$2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1, $m_sci_Nil$(), this.spec$1)];
      return $as_sc_Seq(jsx$9.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
    }
  };
  if ((x1$2 instanceof $c_Lamf_plugins_domain_shapes_models_SchemaShape)) {
    var x3 = $as_Lamf_plugins_domain_shapes_models_SchemaShape(x1$2);
    var fields = x3.fields$2.filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
      return (function(f$2) {
        var f = $as_T2(f$2);
        return (!this$3$1.ignored$1.contains__O__Z(f.$$und1__O()))
      })
    })(this)));
    var annotations = x3.annotations$2;
    var copiedNode = new $c_Lamf_plugins_domain_shapes_models_SchemaShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaShapeEmitter().init___Lamf_plugins_domain_shapes_models_SchemaShape__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(copiedNode, this.ordering$1, this.spec$1).emitters__sc_Seq()
  };
  if ((x1$2 instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
    var x4 = $as_Lamf_plugins_domain_shapes_models_NodeShape(x1$2);
    var fields$1 = x4.fields$2.filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
      return (function(f$3$2) {
        var f$3 = $as_T2(f$3$2);
        return (!this$4$1.ignored$1.contains__O__Z(f$3.$$und1__O()))
      })
    })(this)));
    var annotations$1 = x4.annotations$2;
    var copiedNode$2 = new $c_Lamf_plugins_domain_shapes_models_NodeShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields$1, annotations$1);
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter().init___Lamf_plugins_domain_shapes_models_NodeShape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(copiedNode$2, this.ordering$1, this.references$1, this.pointer$1, updatedSchemaPath, this.isHeader$1, this.spec$1).emitters__sc_Seq()
  };
  if ((x1$2 instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
    rc16 = true;
    x5 = $as_Lamf_plugins_domain_shapes_models_UnionShape(x1$2);
    if (this.nilUnion__Lamf_plugins_domain_shapes_models_UnionShape__Z(x5)) {
      var this$7 = x5;
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext($as_Lamf_core_model_domain_Shape($as_sc_Seq(this$7.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1)).head__O()), this.ordering$1, this.ignored$1, this.references$1, $m_sci_Nil$(), $m_sci_Nil$(), false, this.spec$1).emitters__sc_Seq()
    }
  };
  if (rc16) {
    var this$10 = x5;
    var fields$2 = this$10.fields$2.filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1) {
      return (function(f$4$2) {
        var f$4 = $as_T2(f$4$2);
        return (!this$5$1.ignored$1.contains__O__Z(f$4.$$und1__O()))
      })
    })(this)));
    var this$11 = x5;
    var annotations$2 = this$11.annotations$2;
    var copiedNode$3 = new $c_Lamf_plugins_domain_shapes_models_UnionShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields$2, annotations$2);
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter().init___Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(copiedNode$3, this.ordering$1, this.references$1, this.pointer$1, updatedSchemaPath, false, this.spec$1).emitters__sc_Seq()
  };
  if ((x1$2 instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
    var x7 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(x1$2);
    var fields$3 = x7.fields$2.filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1) {
      return (function(f$5$2) {
        var f$5 = $as_T2(f$5$2);
        return (!this$6$1.ignored$1.contains__O__Z(f$5.$$und1__O()))
      })
    })(this)));
    var annotations$3 = x7.annotations$2;
    var copiedArray = new $c_Lamf_plugins_domain_shapes_models_ArrayShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields$3, annotations$3);
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter().init___Lamf_plugins_domain_shapes_models_ArrayShape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(copiedArray, this.ordering$1, this.references$1, this.pointer$1, updatedSchemaPath, this.isHeader$1, this.spec$1).emitters__sc_Seq()
  };
  if ((x1$2 instanceof $c_Lamf_plugins_domain_shapes_models_MatrixShape)) {
    var x8 = $as_Lamf_plugins_domain_shapes_models_MatrixShape(x1$2);
    var fields$4 = x8.fields$2.filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$7$1) {
      return (function(f$6$2) {
        var f$6 = $as_T2(f$6$2);
        return (!this$7$1.ignored$1.contains__O__Z(f$6.$$und1__O()))
      })
    })(this)));
    var annotations$4 = x8.annotations$2;
    var this$13 = new $c_Lamf_plugins_domain_shapes_models_MatrixShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields$4, annotations$4);
    var value = x8.id$1;
    var copiedMatrix = $as_Lamf_plugins_domain_shapes_models_MatrixShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$13, value));
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter().init___Lamf_plugins_domain_shapes_models_ArrayShape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(copiedMatrix.toArrayShape__Lamf_plugins_domain_shapes_models_ArrayShape(), this.ordering$1, this.references$1, this.pointer$1, updatedSchemaPath, this.isHeader$1, this.spec$1).emitters__sc_Seq()
  };
  if ((x1$2 instanceof $c_Lamf_plugins_domain_shapes_models_TupleShape)) {
    var x9 = $as_Lamf_plugins_domain_shapes_models_TupleShape(x1$2);
    var fields$5 = x9.fields$2.filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$8$1) {
      return (function(f$7$2) {
        var f$7 = $as_T2(f$7$2);
        return (!this$8$1.ignored$1.contains__O__Z(f$7.$$und1__O()))
      })
    })(this)));
    var annotations$5 = x9.annotations$2;
    var copiedArray$2 = new $c_Lamf_plugins_domain_shapes_models_TupleShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields$5, annotations$5);
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter().init___Lamf_plugins_domain_shapes_models_TupleShape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(copiedArray$2, this.ordering$1, this.references$1, this.pointer$1, updatedSchemaPath, this.isHeader$1, this.spec$1).emitters__sc_Seq()
  };
  if ((x1$2 instanceof $c_Lamf_plugins_domain_shapes_models_NilShape)) {
    var x10 = $as_Lamf_plugins_domain_shapes_models_NilShape(x1$2);
    var fields$6 = x10.fields$2.filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$9$1) {
      return (function(f$8$2) {
        var f$8 = $as_T2(f$8$2);
        return (!this$9$1.ignored$1.contains__O__Z(f$8.$$und1__O()))
      })
    })(this)));
    var annotations$6 = x10.annotations$2;
    var copiedNil = new $c_Lamf_plugins_domain_shapes_models_NilShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields$6, annotations$6);
    var jsx$10 = $m_sc_Seq$();
    var array$1 = [new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter().init___Lamf_plugins_domain_shapes_models_NilShape__Lamf_core_emitter_SpecOrdering(copiedNil, this.ordering$1)];
    return $as_sc_Seq(jsx$10.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)))
  };
  if ((x1$2 instanceof $c_Lamf_plugins_domain_shapes_models_FileShape)) {
    var x11 = $as_Lamf_plugins_domain_shapes_models_FileShape(x1$2);
    var x1$3 = this.spec$1;
    if ((x1$3 instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext)) {
      var this$16 = new $c_Lamf_plugins_domain_shapes_models_ScalarShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(x11.fields$2, x11.annotations$2);
      var dataType = $m_Lamf_core_model_DataType$().String$1;
      var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
      var qual$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$16, field, dataType));
      var x$1$3 = x11.fields$2.filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$10$1) {
        return (function(f$9$2) {
          var f$9 = $as_T2(f$9$2);
          return (!this$10$1.ignored$1.contains__O__Z(f$9.$$und1__O()))
        })
      })(this)));
      var x$2 = qual$1.annotations$2;
      var scalar = new $c_Lamf_plugins_domain_shapes_models_ScalarShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(x$1$3, x$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter().init___Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(scalar, this.ordering$1, this.references$1, this.isHeader$1, this.spec$1).emitters__sc_Seq()
    } else {
      var fields$7 = x11.fields$2.filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$11$1) {
        return (function(f$10$2) {
          var f$10 = $as_T2(f$10$2);
          return (!this$11$1.ignored$1.contains__O__Z(f$10.$$und1__O()))
        })
      })(this)));
      var annotations$7 = x11.annotations$2;
      var copiedScalar = new $c_Lamf_plugins_domain_shapes_models_FileShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields$7, annotations$7);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter().init___Lamf_plugins_domain_shapes_models_FileShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(copiedScalar, this.ordering$1, this.references$1, this.isHeader$1, this.spec$1).emitters__sc_Seq()
    }
  };
  if ((x1$2 instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
    var x12 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(x1$2);
    var fields$8 = x12.fields$2.filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$12$1) {
      return (function(f$11$2) {
        var f$11 = $as_T2(f$11$2);
        return (!this$12$1.ignored$1.contains__O__Z(f$11.$$und1__O()))
      })
    })(this)));
    var annotations$8 = x12.annotations$2;
    var copiedScalar$2 = new $c_Lamf_plugins_domain_shapes_models_ScalarShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields$8, annotations$8);
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter().init___Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(copiedScalar$2, this.ordering$1, this.references$1, this.isHeader$1, this.spec$1).emitters__sc_Seq()
  };
  if ((x1$2 instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
    var x13 = $as_Lamf_core_model_domain_RecursiveShape(x1$2);
    var jsx$11 = $m_sc_Seq$();
    var array$2 = [$as_Lamf_core_emitter_EntryEmitter(this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory().recursiveShapeEmitter__F3().apply__O__O__O__O(x13, this.ordering$1, this.schemaPath$1))];
    return $as_sc_Seq(jsx$11.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2)))
  };
  if ((x1$2 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
    var x14 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x1$2);
    var copiedNode$4 = x14.copyAnyShape__Lamf_core_parser_Fields__Lamf_core_parser_Annotations__Lamf_plugins_domain_shapes_models_AnyShape(x14.fields__Lamf_core_parser_Fields().filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$13$1) {
      return (function(f$12$2) {
        var f$12 = $as_T2(f$12$2);
        return (!this$13$1.ignored$1.contains__O__Z(f$12.$$und1__O()))
      })
    })(this))), x14.annotations__Lamf_core_parser_Annotations());
    var ordering = this.ordering$1;
    var references = this.references$1;
    var pointer = this.pointer$1;
    var schemaPath = updatedSchemaPath;
    var isHeader = this.isHeader$1;
    var spec = this.spec$1;
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter().init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(copiedNode$4, ordering, references, pointer, schemaPath, isHeader, spec).emitters__sc_Seq()
  };
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.shape$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ordering$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ignored$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.references$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.pointer$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.schemaPath$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.isHeader$1 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 7)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter.prototype.entries__sc_Seq = (function() {
  var jsx$2 = this.emitters__sc_Seq();
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter$$anonfun$entries$1().init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter(this);
  var this$1 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(shape, ordering, ignored, references, pointer, schemaPath, isHeader, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.ignored$1 = ignored;
  this.references$1 = references;
  this.pointer$1 = pointer;
  this.schemaPath$1 = schemaPath;
  this.isHeader$1 = isHeader;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasTypeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasTypeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasTypeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.ignored$1 = null;
  this.references$1 = null;
  this.forceEntry$1 = false;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter.prototype.productPrefix__T = (function() {
  return "Raml10TypeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter)) {
    var Raml10TypeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter(x$1);
    var x = this.shape$1;
    var x$2 = Raml10TypeEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = Raml10TypeEmitter$1.ordering$1;
      var jsx$3 = (x$3 === x$4)
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$5 = this.ignored$1;
      var x$6 = Raml10TypeEmitter$1.ignored$1;
      var jsx$2 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$7 = this.references$1;
      var x$8 = Raml10TypeEmitter$1.references$1;
      var jsx$1 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.forceEntry$1 === Raml10TypeEmitter$1.forceEntry$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.ignored$1;
      break
    }
    case 3: {
      return this.references$1;
      break
    }
    case 4: {
      return this.forceEntry$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(shape, ordering, ignored, references, forceEntry, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.ignored$1 = ignored;
  this.references$1 = references;
  this.forceEntry$1 = forceEntry;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter.prototype.emitters__sc_Seq = (function() {
  var rc16 = false;
  var x4 = null;
  var x1 = this.shape$1;
  if (($m_s_Option$().apply__O__s_Option(this.shape$1).isDefined__Z() && (this.shape$1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape))) {
    var this$1 = $as_Lamf_plugins_domain_shapes_models_AnyShape(this.shape$1);
    var jsx$2 = $f_Lamf_plugins_domain_shapes_models_ShapeHelpers__fromExternalSource__Z(this$1)
  } else {
    var jsx$2 = false
  };
  if ((jsx$2 && this.references$1.nonEmpty__Z())) {
    var this$2 = this.references$1;
    var pf = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$emitters$1().init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter(this);
    var jsx$1 = $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$2, pf).isDefined__Z()
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var jsx$3 = $m_sc_Seq$();
    var array = [new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter().init___Lamf_core_model_domain_Shape__sc_Seq($as_Lamf_plugins_domain_shapes_models_AnyShape(this.shape$1), this.references$1)];
    return $as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  };
  if ((x1 !== null)) {
    if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x1).isDefined__Z()) {
      var x1$2 = this.spec$1.externalLink__Lamf_core_model_domain_Linkable__sc_Seq__s_Option(this.shape$1, this.references$1);
      if ((x1$2 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$2);
        var fragment = $as_Lamf_core_model_document_BaseUnit(x2$2.value$2);
        if ($is_Lamf_core_model_document_EncodesModel(fragment)) {
          var jsx$4 = $m_sc_Seq$();
          var this$7 = this.spec$1;
          var this$5 = this.shape$1;
          var this$6 = $as_Lamf_core_model_StrField(this$5.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1;
          $as_T((this$6.isEmpty__Z() ? $as_T($f_Lamf_core_model_document_BaseUnit__location__s_Option(fragment).get__O()) : this$6.get__O()));
          var reference = this.shape$1;
          var array$1 = [new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext$$anon$6().init___Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext__Lamf_core_model_domain_Linkable(this$7, reference)];
          return $as_sc_Seq(jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)))
        }
      };
      if (this.forceEntry$1) {
        var jsx$5 = $m_sc_Seq$();
        var reference$1 = this.shape$1;
        var array$2 = [new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEntryEmitter().init___T__Lamf_core_model_domain_Linkable("type", reference$1)];
        return $as_sc_Seq(jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2)))
      };
      var jsx$6 = $m_sc_Seq$();
      var array$3 = [this.spec$1.localReference__Lamf_core_model_domain_Linkable__Lamf_core_emitter_PartEmitter(this.shape$1)];
      return $as_sc_Seq(jsx$6.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$3)))
    }
  };
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_SchemaShape)) {
    var x3$2 = $as_Lamf_plugins_domain_shapes_models_SchemaShape(x1);
    var jsx$7 = $m_sc_Seq$();
    var array$4 = [new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter().init___Lamf_plugins_domain_shapes_models_SchemaShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x3$2, this.ordering$1, this.references$1, this.spec$1)];
    return $as_sc_Seq(jsx$7.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$4)))
  };
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
    rc16 = true;
    x4 = $as_Lamf_plugins_domain_shapes_models_NodeShape(x1);
    var this$17 = x4;
    if (this$17.annotations$2.find__jl_Class__s_Option($d_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.getClassOf()).isDefined__Z()) {
      var jsx$8 = $m_sc_Seq$();
      var array$5 = [new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter().init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__T__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x4, this.ordering$1, this.references$1, "type", this.spec$1)];
      return $as_sc_Seq(jsx$8.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$5)))
    }
  };
  if (rc16) {
    var this$20 = x4;
    var fields = this$20.fields$2.filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(f$2) {
        var f = $as_T2(f$2);
        return (!this$2$1.ignored$1.contains__O__Z(f.$$und1__O()))
      })
    })(this)));
    var this$21 = x4;
    var annotations = this$21.annotations$2;
    var copiedNode = new $c_Lamf_plugins_domain_shapes_models_NodeShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter().init___Lamf_plugins_domain_shapes_models_NodeShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(copiedNode, this.ordering$1, this.references$1, this.spec$1).emitters__sc_Seq()
  };
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
    var x6 = $as_Lamf_plugins_domain_shapes_models_UnionShape(x1);
    var fields$1 = x6.fields$2.filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
      return (function(f$3$2) {
        var f$3 = $as_T2(f$3$2);
        return (!this$3$1.ignored$1.contains__O__Z(f$3.$$und1__O()))
      })
    })(this)));
    var annotations$1 = x6.annotations$2;
    var copiedNode$2 = new $c_Lamf_plugins_domain_shapes_models_UnionShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields$1, annotations$1);
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter().init___Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(copiedNode$2, this.ordering$1, this.references$1, this.spec$1).emitters__sc_Seq()
  };
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_FileShape)) {
    var x7 = $as_Lamf_plugins_domain_shapes_models_FileShape(x1);
    var fields$2 = x7.fields$2.filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
      return (function(f$4$2) {
        var f$4 = $as_T2(f$4$2);
        return (!this$4$1.ignored$1.contains__O__Z(f$4.$$und1__O()))
      })
    })(this)));
    var annotations$2 = x7.annotations$2;
    var copiedFile = new $c_Lamf_plugins_domain_shapes_models_FileShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields$2, annotations$2);
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter().init___Lamf_plugins_domain_shapes_models_FileShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(copiedFile, this.ordering$1, this.references$1, this.spec$1).emitters__sc_Seq()
  };
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
    var x8 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(x1);
    var fields$3 = x8.fields$2.filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1) {
      return (function(f$5$2) {
        var f$5 = $as_T2(f$5$2);
        return (!this$5$1.ignored$1.contains__O__Z(f$5.$$und1__O()))
      })
    })(this)));
    var annotations$3 = x8.annotations$2;
    var copiedScalar = new $c_Lamf_plugins_domain_shapes_models_ScalarShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields$3, annotations$3);
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter().init___Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(copiedScalar, this.ordering$1, this.references$1, this.spec$1).emitters__sc_Seq()
  };
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
    var x9 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(x1);
    var fields$4 = x9.fields$2.filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1) {
      return (function(f$6$2) {
        var f$6 = $as_T2(f$6$2);
        return (!this$6$1.ignored$1.contains__O__Z(f$6.$$und1__O()))
      })
    })(this)));
    var annotations$4 = x9.annotations$2;
    var copiedArray = new $c_Lamf_plugins_domain_shapes_models_ArrayShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields$4, annotations$4);
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter().init___Lamf_plugins_domain_shapes_models_ArrayShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(copiedArray, this.ordering$1, this.references$1, this.spec$1).emitters__sc_Seq()
  };
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_TupleShape)) {
    var x10 = $as_Lamf_plugins_domain_shapes_models_TupleShape(x1);
    var fields$5 = x10.fields$2.filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$7$1) {
      return (function(f$7$2) {
        var f$7 = $as_T2(f$7$2);
        return (!this$7$1.ignored$1.contains__O__Z(f$7.$$und1__O()))
      })
    })(this)));
    var annotations$5 = x10.annotations$2;
    var copiedTuple = new $c_Lamf_plugins_domain_shapes_models_TupleShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields$5, annotations$5);
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter().init___Lamf_plugins_domain_shapes_models_TupleShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(copiedTuple, this.ordering$1, this.references$1, this.spec$1).emitters__sc_Seq()
  };
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_MatrixShape)) {
    var x11 = $as_Lamf_plugins_domain_shapes_models_MatrixShape(x1);
    var fields$6 = x11.fields$2.filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$8$1) {
      return (function(f$8$2) {
        var f$8 = $as_T2(f$8$2);
        return (!this$8$1.ignored$1.contains__O__Z(f$8.$$und1__O()))
      })
    })(this)));
    var annotations$6 = x11.annotations$2;
    var copiedMatrix = new $c_Lamf_plugins_domain_shapes_models_MatrixShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields$6, annotations$6);
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter().init___Lamf_plugins_domain_shapes_models_ArrayShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(copiedMatrix.toArrayShape__Lamf_plugins_domain_shapes_models_ArrayShape(), this.ordering$1, this.references$1, this.spec$1).emitters__sc_Seq()
  };
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_NilShape)) {
    var x12 = $as_Lamf_plugins_domain_shapes_models_NilShape(x1);
    var fields$7 = x12.fields$2.filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$9$1) {
      return (function(f$9$2) {
        var f$9 = $as_T2(f$9$2);
        return (!this$9$1.ignored$1.contains__O__Z(f$9.$$und1__O()))
      })
    })(this)));
    var annotations$7 = x12.annotations$2;
    var copiedNode$3 = new $c_Lamf_plugins_domain_shapes_models_NilShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields$7, annotations$7);
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter().init___Lamf_plugins_domain_shapes_models_NilShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(copiedNode$3, this.ordering$1, this.references$1, this.spec$1).emitters__sc_Seq()
  };
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
    var x13 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x1);
    var copiedNode$4 = x13.copyAnyShape__Lamf_core_parser_Fields__Lamf_core_parser_Annotations__Lamf_plugins_domain_shapes_models_AnyShape(x13.fields__Lamf_core_parser_Fields().filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$10$1) {
      return (function(f$10$2) {
        var f$10 = $as_T2(f$10$2);
        return (!this$10$1.ignored$1.contains__O__Z(f$10.$$und1__O()))
      })
    })(this))), x13.annotations__Lamf_core_parser_Annotations());
    var ordering = this.ordering$1;
    var references = this.references$1;
    var spec = this.spec$1;
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeInstanceEmitter().init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(copiedNode$4, ordering, references, spec).emitters__sc_Seq()
  };
  if ((x1 instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
    var x14 = $as_Lamf_core_model_domain_RecursiveShape(x1);
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter().init___Lamf_core_model_domain_RecursiveShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x14, this.ordering$1, this.references$1, this.spec$1).emitters__sc_Seq()
  };
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.shape$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ordering$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ignored$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.references$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.forceEntry$1 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 5)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter.prototype.entries__sc_Seq = (function() {
  var jsx$2 = this.emitters__sc_Seq();
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1().init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter(this);
  var this$1 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.Raml10TypeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.Raml10TypeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.Raml10TypeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters() {
  $c_O.call(this);
  this.entries$1 = null;
  this.parts$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters.prototype.productPrefix__T = (function() {
  return "MixedEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters(x$1).$$outer$1 === this.$$outer$1))) {
    var MixedEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters(x$1);
    var x = this.entries$1;
    var x$2 = MixedEmitters$1.entries$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.parts$1;
      var x$4 = MixedEmitters$1.parts$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter__sc_Seq__sc_Seq = (function($$outer, entries, parts) {
  this.entries$1 = entries;
  this.parts$1 = parts;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entries$1;
      break
    }
    case 1: {
      return this.parts$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters.prototype.emitAll__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  this.parts$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_emitter_PartEmitter(x$1$2);
      x$1.emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$1)
    })
  })(this, b)));
  if (this.entries$1.nonEmpty__Z()) {
    var jsx$1 = b.builder$1;
    var sourceName = b.sourceName$2;
    var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    this.entries$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, b$3) {
      return (function(x$2$2) {
        var x$2 = $as_Lamf_core_emitter_EntryEmitter(x$2$2);
        x$2.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$3)
      })
    })(this, b$2)));
    jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlInlinedUnionShapeEmitter$MixedEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlInlinedUnionShapeEmitter$MixedEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlInlinedUnionShapeEmitter$MixedEmitters", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.references$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter.prototype.productPrefix__T = (function() {
  return "RamlRecursiveShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter.prototype.init___Lamf_core_model_domain_RecursiveShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(shape, ordering, references, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.references$1 = references;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter)) {
    var RamlRecursiveShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter(x$1);
    var x = this.shape$1;
    var x$2 = RamlRecursiveShapeEmitter$1.shape$1;
    if ((x === x$2)) {
      var x$3 = this.ordering$1;
      var x$4 = RamlRecursiveShapeEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = RamlRecursiveShapeEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter.prototype.emitters__sc_Seq = (function() {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", "object", $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()));
  var jsx$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T("recursive").asRamlAnnotation__T();
  var this$4 = this.shape$1;
  var this$5 = $as_Lamf_core_model_StrField(this$4.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_RecursiveShapeModel$().FixPoint$1));
  var this$6 = this$5.option$1;
  result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position(jsx$1, $as_T((this$6.isEmpty__Z() ? null : this$6.get__O())), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()));
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlRecursiveShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlRecursiveShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlRecursiveShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.minCount$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter.prototype.productPrefix__T = (function() {
  return "RamlRequiredShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter)) {
    var RamlRequiredShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter(x$1);
    var x = this.shape$1;
    var x$2 = RamlRequiredShapeEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.minCount$1;
      var x$4 = RamlRequiredShapeEmitter$1.minCount$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.minCount$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter.prototype.init___Lamf_core_model_domain_Shape__s_Option = (function(shape, minCount) {
  this.shape$1 = shape;
  this.minCount$1 = minCount;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter.prototype.emitter__s_Option = (function() {
  var this$1 = this.minCount$1;
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var entry = $as_Lamf_core_parser_FieldEntry(arg1);
    return (entry.value$1.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_ExplicitField.getClassOf()) ? new $c_s_Some().init___O(new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position("required", new $c_Lamf_core_emitter_BaseEmitters_package$RawEmitter().init___T__Lorg_yaml_model_YType__Lamf_core_parser_Annotations((($numberIntValue($as_Lamf_core_model_domain_AmfScalar(entry.value$1.value$1).toNumber__jl_Number()) > 0) ? "true" : "false"), $m_Lorg_yaml_model_YType$().Bool$1, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___())), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$())) : $m_s_None$())
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlRequiredShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlRequiredShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlRequiredShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.ignored$1 = null;
  this.references$1 = null;
  this.pointer$1 = null;
  this.schemaPath$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter.prototype.productPrefix__T = (function() {
  return "CompactOasTypeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter.prototype.productArity__I = (function() {
  return 6
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(shape, ordering, ignored, references, pointer, schemaPath, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.ignored$1 = ignored;
  this.references$1 = references;
  this.pointer$1 = pointer;
  this.schemaPath$1 = schemaPath;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter)) {
    var CompactOasTypeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter(x$1);
    var x = this.shape$1;
    var x$2 = CompactOasTypeEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = CompactOasTypeEmitter$1.ordering$1;
      var jsx$4 = (x$3 === x$4)
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      var x$5 = this.ignored$1;
      var x$6 = CompactOasTypeEmitter$1.ignored$1;
      var jsx$3 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$7 = this.references$1;
      var x$8 = CompactOasTypeEmitter$1.references$1;
      var jsx$2 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$9 = this.pointer$1;
      var x$10 = CompactOasTypeEmitter$1.pointer$1;
      var jsx$1 = ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$11 = this.schemaPath$1;
      var x$12 = CompactOasTypeEmitter$1.schemaPath$1;
      return ((x$11 === null) ? (x$12 === null) : x$11.equals__O__Z(x$12))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.ignored$1;
      break
    }
    case 3: {
      return this.references$1;
      break
    }
    case 4: {
      return this.pointer$1;
      break
    }
    case 5: {
      return this.schemaPath$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter.prototype.emitters__sc_Seq = (function() {
  var definitionQueue = this.spec$1.definitionsQueue$3;
  if ((this.spec$1.forceEmission$3.contains__O__Z(this.shape$1.id$1) || this.emitInlined__Z())) {
    this.spec$1.forceEmission$3 = $m_s_None$();
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.shape$1, this.ordering$1, this.ignored$1, this.references$1, this.pointer$1, this.schemaPath$1, false, this.spec$1).emitters__sc_Seq()
  } else {
    var label = definitionQueue.enqueue__Lamf_core_model_domain_Shape__T(this.shape$1);
    var tag = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().appendDefinitionsPrefix__T__s_Option__T(label, new $c_s_Some().init___O(this.spec$1.vendor__Lamf_core_remote_Vendor()));
    var jsx$1 = $m_sc_Seq$();
    var array = [new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter().init___Lamf_core_model_domain_DomainElement__s_Option__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.shape$1, new $c_s_Some().init___O(tag), $m_sci_Nil$(), this.spec$1)];
    return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter.prototype.emitInlined__Z = (function() {
  var this$1 = this.shape$1.annotations__Lamf_core_parser_Annotations();
  var this$2 = this$1.amf$core$parser$Annotations$$annotations$1;
  var this$3 = this$2.scala$collection$mutable$ListBuffer$$start$6;
  inlinereturn$6: {
    var these = this$3;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      var a = $as_Lamf_core_model_domain_Annotation(arg1);
      if (((a instanceof $c_Lamf_core_annotations_DeclaredElement) || (a instanceof $c_Lamf_core_annotations_ResolvedInheritance))) {
        var this$4 = new $c_s_Some().init___O(these.head__O());
        break inlinereturn$6
      };
      these = $as_sc_LinearSeqOptimized(these.tail__O())
    };
    var this$4 = $m_s_None$()
  };
  if (this$4.isEmpty__Z()) {
    var jsx$1 = $m_s_None$()
  } else {
    var arg1$1 = this$4.get__O();
    var x$1 = $as_Lamf_core_model_domain_Annotation(arg1$1);
    var jsx$1 = new $c_s_Some().init___O(x$1)
  };
  if (jsx$1.isEmpty__Z()) {
    return true
  } else {
    return (this.shape$1 instanceof $c_Lamf_core_model_domain_RecursiveShape)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.schema.json.CompactOasTypeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.schema.json.CompactOasTypeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.schema.json.CompactOasTypeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasTypeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin() {
  $c_O.call(this);
  this.text$1 = null;
  this.valueAST$1 = null;
  this.oriUrl$1 = null;
  this.errorShape$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin.prototype.productPrefix__T = (function() {
  return "ValueAndOrigin"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__T__Lorg_yaml_model_YNode__s_Option__s_Option = (function($$outer, text, valueAST, oriUrl, errorShape) {
  this.text$1 = text;
  this.valueAST$1 = valueAST;
  this.oriUrl$1 = oriUrl;
  this.errorShape$1 = errorShape;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin(x$1).$$outer$1 === this.$$outer$1))) {
    var ValueAndOrigin$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin(x$1);
    if ((this.text$1 === ValueAndOrigin$1.text$1)) {
      var this$1 = this.valueAST$1;
      var b = ValueAndOrigin$1.valueAST$1;
      var jsx$2 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x = this.oriUrl$1;
      var x$2 = ValueAndOrigin$1.oriUrl$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.errorShape$1;
      var x$4 = ValueAndOrigin$1.errorShape$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.text$1;
      break
    }
    case 1: {
      return this.valueAST$1;
      break
    }
    case 2: {
      return this.oriUrl$1;
      break
    }
    case 3: {
      return this.errorShape$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.external.raml.RamlExternalTypesParser$ValueAndOrigin"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.external.raml.RamlExternalTypesParser$ValueAndOrigin;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.external.raml.RamlExternalTypesParser$ValueAndOrigin", {
  Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$() {
  $c_sr_AbstractFunction4.call(this);
  this.$$outer$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$.prototype = new $h_sr_AbstractFunction4();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$.prototype.apply__O__O__O__O__O = (function(v1, v2, v3, v4) {
  return this.apply__T__Lorg_yaml_model_YNode__s_Option__s_Option__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin($as_T(v1), $as_Lorg_yaml_model_YNode(v2), $as_s_Option(v3), $as_s_Option(v4))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$.prototype.apply__T__Lorg_yaml_model_YNode__s_Option__s_Option__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin = (function(text, valueAST, oriUrl, errorShape) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin().init___Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__T__Lorg_yaml_model_YNode__s_Option__s_Option(this.$$outer$2, text, valueAST, oriUrl, errorShape)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$.prototype.toString__T = (function() {
  return "ValueAndOrigin"
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.external.raml.RamlExternalTypesParser$ValueAndOrigin$", {
  Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$: 1,
  sr_AbstractFunction4: 1,
  O: 1,
  F4: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser() {
  $c_O.call(this);
  this.ctx$1 = null;
  this.text$1 = null;
  this.valueAST$1 = null;
  this.path$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser.prototype.productPrefix__T = (function() {
  return "RamlExternalOasLibParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser(x$1).$$outer$1 === this.$$outer$1))) {
    var RamlExternalOasLibParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser(x$1);
    var x = this.ctx$1;
    var x$2 = RamlExternalOasLibParser$1.ctx$1;
    if ((((x === null) ? (x$2 === null) : x.equals__O__Z(x$2)) && (this.text$1 === RamlExternalOasLibParser$1.text$1))) {
      var this$1 = this.valueAST$1;
      var b = RamlExternalOasLibParser$1.valueAST$1;
      var jsx$1 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.path$1 === RamlExternalOasLibParser$1.path$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.ctx$1;
      break
    }
    case 1: {
      return this.text$1;
      break
    }
    case 2: {
      return this.valueAST$1;
      break
    }
    case 3: {
      return this.path$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__T__Lorg_yaml_model_YNode__T = (function($$outer, ctx, text, valueAST, path) {
  this.ctx$1 = ctx;
  this.text$1 = text;
  this.valueAST$1 = valueAST;
  this.path$1 = path;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser.prototype.parse__V = (function() {
  var str = this.path$1;
  var url = (new $c_Lamf_core_utils_package$AmfStrings().init___T(str).normalizeUrl__T() + ((!$m_sjsr_RuntimeString$().endsWith__T__T__Z(this.path$1, "/")) ? "/" : ""));
  var jsx$2 = $m_Lorg_yaml_parser_JsonParser$();
  var jsx$1 = this.text$1;
  var this$2 = this.valueAST$1;
  var this$4 = jsx$2.withSource__jl_CharSequence__T__Lorg_mulesoft_lexer_Position__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_JsonParser(jsx$1, this$2.location$1.sourceName$1, $m_Lorg_mulesoft_lexer_Position$().Zero$1, this.ctx$1.eh$1);
  var schemaEntry = $f_Lorg_yaml_parser_YParser__document__Lorg_yaml_model_YDocument(this$4);
  var jsonSchemaContext = this.$$outer$1.toSchemaContext__Lamf_plugins_document_webapi_contexts_WebApiContext__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.ctx$1, this.valueAST$1);
  jsonSchemaContext.localJSONSchemaContext$2 = new $c_s_Some().init___O(schemaEntry.node$2);
  jsonSchemaContext.setJsonSchemaAST__Lorg_yaml_model_YNode__V(schemaEntry.node$2);
  var this$7 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser().init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($m_Lamf_core_Root$().apply__Lamf_core_parser_ParsedDocument__T__T__sc_Seq__Lamf_core_parser_ReferenceKind__T__Lamf_core_Root(new $c_Lamf_core_parser_SyamlParsedDocument().init___Lorg_yaml_model_YDocument__s_Option(schemaEntry, $m_s_None$()), url, "application/json", $m_sci_Nil$(), $m_Lamf_core_parser_InferredLinkReference$(), this.text$1), jsonSchemaContext);
  var this$6 = schemaEntry.node$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion, iv));
  var typesPrefix = (url + "#/definitions/");
  $f_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeDeclarationsHelper__parseTypeDeclarations__Lorg_yaml_model_YMap__T__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__V(this$7, map, typesPrefix, jsonSchemaContext);
  var this$8 = jsonSchemaContext.declarations$4.shapes$2;
  var this$9 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$8);
  var resolvedShapes = this$9.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream();
  var shapesMap = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(s$2) {
      var s = $as_Lamf_core_model_domain_Shape(s$2);
      return new $c_T2().init___O__O(s, s.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_plugins_document_webapi_annotations_JSONSchemaId.getClassOf()))
    })
  })(this));
  var this$10 = $m_sc_Seq$();
  $as_sc_IterableLike(resolvedShapes.map__F1__scg_CanBuildFrom__O(jsx$3, this$10.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, shapesMap$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var s$1 = $as_Lamf_core_model_domain_Shape(x0$1.$$und1__O());
        var p2 = $as_s_Option(x0$1.$$und2__O());
        if ((s$1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
          var x7 = $as_Lamf_plugins_domain_shapes_models_AnyShape(s$1);
          if ((p2 instanceof $c_s_Some)) {
            var x3 = $as_s_Some(p2);
            var a = $as_Lamf_plugins_document_webapi_annotations_JSONSchemaId(x3.value$2);
            var this$13 = a.id$1;
            var this$11 = $as_Lamf_core_model_StrField(x7.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
            var this$12 = this$11.option$1;
            var that = $as_T((this$12.isEmpty__Z() ? null : this$12.get__O()));
            if ((this$13 === that)) {
              var this$14 = $as_Lamf_core_model_StrField(x7.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
              var this$15 = this$14.option$1;
              var self = $as_T((this$15.isEmpty__Z() ? null : this$15.get__O()));
              return $as_scm_Map(shapesMap$1.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(self, x7)))
            }
          }
        }
      };
      if ((x0$1 !== null)) {
        var s$2$1 = $as_Lamf_core_model_domain_Shape(x0$1.$$und1__O());
        var p4 = $as_s_Option(x0$1.$$und2__O());
        if ((s$2$1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
          var x8 = $as_Lamf_plugins_domain_shapes_models_AnyShape(s$2$1);
          if ((p4 instanceof $c_s_Some)) {
            var x5 = $as_s_Some(p4);
            var a$2 = $as_Lamf_plugins_document_webapi_annotations_JSONSchemaId(x5.value$2);
            var this$18 = $as_Lamf_core_model_StrField(x8.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
            var this$19 = this$18.option$1;
            var self$1 = $as_T((this$19.isEmpty__Z() ? null : this$19.get__O()));
            shapesMap$1.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(self$1, x8));
            var self$2 = a$2.id$1;
            return $as_scm_Map(shapesMap$1.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(self$2, x8)))
          }
        }
      };
      if ((x0$1 !== null)) {
        var s$3 = $as_Lamf_core_model_domain_Shape(x0$1.$$und1__O());
        var p6 = $as_s_Option(x0$1.$$und2__O());
        if ((s$3 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
          var x9 = $as_Lamf_plugins_domain_shapes_models_AnyShape(s$3);
          var x = $m_s_None$();
          if ((x === p6)) {
            var this$24 = $as_Lamf_core_model_StrField(x9.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
            var this$25 = this$24.option$1;
            var self$3 = $as_T((this$25.isEmpty__Z() ? null : this$25.get__O()));
            return $as_scm_Map(shapesMap$1.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(self$3, x9)))
          }
        }
      };
      throw new $c_s_MatchError().init___O(x0$1)
    })
  })(this, shapesMap)));
  var jsx$5 = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations();
  var jsx$4 = this.path$1;
  var ev$4 = $m_s_Predef$().singleton$und$less$colon$less$2;
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  shapesMap.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, b$1, ev$5) {
    return (function(x$2) {
      return b$1.$$plus$eq__O__scm_Builder(x$2)
    })
  })(shapesMap, b, ev$4)));
  jsx$5.registerExternalLib__T__sci_Map__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(jsx$4, $as_sci_Map(b.elems$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.external.raml.RamlJsonSchemaExpression$RamlExternalOasLibParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.external.raml.RamlJsonSchemaExpression$RamlExternalOasLibParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.external.raml.RamlJsonSchemaExpression$RamlExternalOasLibParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult() {
  $c_O.call(this);
  this.exampleNode$1 = null;
  this.dataNode$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult.prototype.productPrefix__T = (function() {
  return "DataNodeParserResult"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult)) {
    var DataNodeParserResult$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult(x$1);
    var x = this.exampleNode$1;
    var x$2 = DataNodeParserResult$1.exampleNode$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.dataNode$1;
      var x$4 = DataNodeParserResult$1.dataNode$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.exampleNode$1;
      break
    }
    case 1: {
      return this.dataNode$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult.prototype.init___s_Option__s_Option = (function(exampleNode, dataNode) {
  this.exampleNode$1 = exampleNode;
  this.dataNode$1 = dataNode;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.DataNodeParserResult"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.DataNodeParserResult;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.DataNodeParserResult", {
  Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser() {
  $c_O.call(this);
  this.yMapEntry$1 = null;
  this.parentId$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser.prototype.productPrefix__T = (function() {
  return "ExampleByMediaTypeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser.prototype.parse__Lamf_plugins_domain_shapes_models_Example = (function() {
  var example = $m_Lamf_plugins_domain_shapes_models_Example$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_Example(this.yMapEntry$1);
  var this$1 = this.yMapEntry$1.key$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
  var iv = this.ctx$1;
  var mediaType = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(example, mediaType, a));
  var x$1 = this.parentId$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().MediaType$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(example, field, mediaType);
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser().init___Lorg_yaml_model_YNode__Lamf_plugins_domain_shapes_models_Example__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext(this.yMapEntry$1.value$2, example, new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions().init___Z__Z__Z(false, true, false), this.ctx$1).parse__Lamf_plugins_domain_shapes_models_Example()
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser)) {
    var ExampleByMediaTypeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser(x$1);
    var x = this.yMapEntry$1;
    var x$2 = ExampleByMediaTypeParser$1.yMapEntry$1;
    if ((x === x$2)) {
      return (this.parentId$1 === ExampleByMediaTypeParser$1.parentId$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.yMapEntry$1;
      break
    }
    case 1: {
      return this.parentId$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser.prototype.init___Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(yMapEntry, parentId, ctx) {
  this.yMapEntry$1 = yMapEntry;
  this.parentId$1 = parentId;
  this.ctx$1 = ctx;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.ExampleByMediaTypeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.ExampleByMediaTypeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.ExampleByMediaTypeParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser() {
  $c_O.call(this);
  this.node$1 = null;
  this.example$1 = null;
  this.options$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser.prototype.parse__Lamf_plugins_domain_shapes_models_Example = (function() {
  if (this.example$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Strict$1).isEmpty__Z()) {
    var this$3 = this.example$1;
    var field = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Strict$1;
    var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(this.options$1.strictDefault$1, new $c_Lamf_core_parser_Annotations().init___());
    var annotations = ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SynthesizedField().init___());
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$3, field, value, annotations)
  };
  var x1 = this.node$1;
  if ((x1 instanceof $c_Lorg_yaml_model_YNode$MutRef)) {
    var x2 = $as_Lorg_yaml_model_YNode$MutRef(x1);
    var this$4 = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations().fragments$1.get__O__s_Option($as_Lorg_yaml_model_YScalar(x2.origValue$4).text$3);
    if ((!this$4.isEmpty__Z())) {
      var arg1 = this$4.get__O();
      var e = $as_Lamf_core_parser_FragmentRef(arg1);
      var this$5 = this.example$1;
      var id = e.encoded$1.id__T();
      var field$1 = $m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().ReferenceId$1;
      $as_Lamf_core_model_domain_ExternalSourceElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$5, field$1, id));
      var this$8 = this.example$1;
      var field$2 = $m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Location$1;
      var this$6 = e.location$1;
      if (this$6.isEmpty__Z()) {
        var this$7 = this.ctx$1;
        var jsx$1 = this$7.rootContextDocument$1
      } else {
        var jsx$1 = this$6.get__O()
      };
      var value$1 = $as_T(jsx$1);
      $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$8, field$2, value$1))
    };
    var this$9 = x2.target$4;
    var _1 = (this$9.isEmpty__Z() ? this.node$1 : this$9.get__O());
    var x1$2_$_$$und1$f = _1;
    var x1$2_$_$$und2$f = true
  } else {
    var _1$1 = this.node$1;
    var x1$2_$_$$und1$f = _1$1;
    var x1$2_$_$$und2$f = false
  };
  var targetNode = $as_Lorg_yaml_model_YNode(x1$2_$_$$und1$f);
  var mutTarget = $uZ(x1$2_$_$$und2$f);
  var rc6 = false;
  var x2$2 = null;
  var node = this.node$1;
  var x1$3 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YScalarYRead$());
  matchEnd7: {
    if ((x1$3 instanceof $c_s_Some)) {
      rc6 = true;
      x2$2 = $as_s_Some(x1$3);
      var this$11 = this.node$1;
      var x = this$11.tag__Lorg_yaml_model_YTag().tagType$3;
      var x$2 = $m_Lorg_yaml_model_YType$().Null$1;
      if ((x === x$2)) {
        var this$12 = this.example$1;
        var field$3 = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Raw$1;
        var value$2 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations("null", $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(this.node$1));
        var annotations$1 = $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(this.node$1);
        $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$12, field$3, value$2, annotations$1));
        break matchEnd7
      }
    };
    if (rc6) {
      var scalar = $as_Lorg_yaml_model_YScalar(x2$2.value$2);
      var this$13 = this.example$1;
      var field$4 = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Raw$1;
      var value$3 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(scalar.text$3, $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(this.node$1));
      var annotations$2 = $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(this.node$1);
      $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$13, field$4, value$3, annotations$2));
      break matchEnd7
    };
    var this$15 = this.example$1;
    var field$5 = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Raw$1;
    var this$14 = $m_Lorg_yaml_render_YamlRender$();
    var value$4 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(this$14.render__Lorg_yaml_model_YPart__Z__T(targetNode, false), $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(this.node$1));
    var annotations$3 = $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(this.node$1);
    $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$15, field$5, value$4, annotations$3))
  };
  var result = new $c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser().init___Lorg_yaml_model_YNode__T__Z__Z__Z__Lamf_plugins_document_webapi_contexts_WebApiContext(targetNode, this.example$1.id$1, this.options$1.quiet$1, mutTarget, this.options$1.isScalar$1, this.ctx$1).parse__Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult();
  var this$16 = result.dataNode$1;
  if ((!this$16.isEmpty__Z())) {
    var arg1$1 = this$16.get__O();
    var dataNode = $as_Lamf_core_model_domain_DataNode(arg1$1);
    var this$17 = this.example$1;
    var field$6 = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1;
    var annotations$4 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.node$1);
    $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$17, field$6, dataNode, annotations$4))
  };
  return this.example$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser.prototype.productPrefix__T = (function() {
  return "ExampleDataParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser)) {
    var ExampleDataParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser(x$1);
    var this$1 = this.node$1;
    var b = ExampleDataParser$1.node$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.example$1;
      var x$2 = ExampleDataParser$1.example$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.options$1;
      var x$4 = ExampleDataParser$1.options$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.node$1;
      break
    }
    case 1: {
      return this.example$1;
      break
    }
    case 2: {
      return this.options$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser.prototype.init___Lorg_yaml_model_YNode__Lamf_plugins_domain_shapes_models_Example__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(node, example, options, ctx) {
  this.node$1 = node;
  this.example$1 = example;
  this.options$1 = options;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.ExampleDataParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.ExampleDataParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.ExampleDataParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions() {
  $c_O.call(this);
  this.strictDefault$1 = false;
  this.quiet$1 = false;
  this.isScalar$1 = false
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions.prototype.productPrefix__T = (function() {
  return "ExampleOptions"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions)) {
    var ExampleOptions$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions(x$1);
    return (((this.strictDefault$1 === ExampleOptions$1.strictDefault$1) && (this.quiet$1 === ExampleOptions$1.quiet$1)) && (this.isScalar$1 === ExampleOptions$1.isScalar$1))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.strictDefault$1;
      break
    }
    case 1: {
      return this.quiet$1;
      break
    }
    case 2: {
      return this.isScalar$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions.prototype.checkScalar__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions = (function(shape) {
  return ((shape instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape) ? new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions().init___Z__Z__Z(this.strictDefault$1, this.quiet$1, true) : this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.strictDefault$1 ? 1231 : 1237));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.quiet$1 ? 1231 : 1237));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.isScalar$1 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 3)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions.prototype.init___Z__Z__Z = (function(strictDefault, quiet, isScalar) {
  this.strictDefault$1 = strictDefault;
  this.quiet$1 = quiet;
  this.isScalar$1 = isScalar;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.ExampleOptions"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.ExampleOptions;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.ExampleOptions", {
  Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser() {
  $c_O.call(this);
  this.entry$1 = null;
  this.parentId$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser.prototype.productPrefix__T = (function() {
  return "ExamplesByMediaTypeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser)) {
    var ExamplesByMediaTypeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser(x$1);
    var x = this.entry$1;
    var x$2 = ExamplesByMediaTypeParser$1.entry$1;
    if ((x === x$2)) {
      return (this.parentId$1 === ExamplesByMediaTypeParser$1.parentId$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$1;
      break
    }
    case 1: {
      return this.parentId$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser.prototype.parse__sc_Seq = (function() {
  var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = this.entry$1.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$1;
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).regex__T__sc_Iterable(".*/.*");
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, results$1) {
    return (function(e$2) {
      var e = $as_Lorg_yaml_model_YMapEntry(e$2);
      return results$1.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleByMediaTypeParser().init___Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_WebApiContext(e, $this.parentId$1, $this.ctx$1).parse__Lamf_plugins_domain_shapes_models_Example())
    })
  })(this, results));
  var this$3 = $m_sc_Iterable$();
  jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2);
  return results
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser.prototype.init___Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(entry, parentId, ctx) {
  this.entry$1 = entry;
  this.parentId$1 = parentId;
  this.ctx$1 = ctx;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.ExamplesByMediaTypeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.ExamplesByMediaTypeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.ExamplesByMediaTypeParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser() {
  $c_O.call(this);
  this.node$1 = null;
  this.parentId$1 = null;
  this.quiet$1 = false;
  this.fromExternal$1 = false;
  this.isScalar$1 = false;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser.prototype.productPrefix__T = (function() {
  return "NodeDataNodeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser.prototype.init___Lorg_yaml_model_YNode__T__Z__Z__Z__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(node, parentId, quiet, fromExternal, isScalar, ctx) {
  this.node$1 = node;
  this.parentId$1 = parentId;
  this.quiet$1 = quiet;
  this.fromExternal$1 = fromExternal;
  this.isScalar$1 = isScalar;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser)) {
    var NodeDataNodeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser(x$1);
    var this$1 = this.node$1;
    var b = NodeDataNodeParser$1.node$1;
    if (((($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b) && (this.parentId$1 === NodeDataNodeParser$1.parentId$1)) && (this.quiet$1 === NodeDataNodeParser$1.quiet$1)) && (this.fromExternal$1 === NodeDataNodeParser$1.fromExternal$1))) {
      return (this.isScalar$1 === NodeDataNodeParser$1.isScalar$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.node$1;
      break
    }
    case 1: {
      return this.parentId$1;
      break
    }
    case 2: {
      return this.quiet$1;
      break
    }
    case 3: {
      return this.fromExternal$1;
      break
    }
    case 4: {
      return this.isScalar$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser.prototype.parse__Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult = (function() {
  var errorHandler = (this.quiet$1 ? new $c_Lamf_core_parser_errorhandler_WarningOnlyHandler().init___Lamf_core_parser_errorhandler_ParserErrorHandler(this.ctx$1.eh$1) : this.ctx$1.eh$1);
  var jsonText = $m_s_None$();
  var rc8 = false;
  var x2 = null;
  var node = this.node$1;
  var x1 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lamf_core_parser_package$YScalarYRead$());
  matchEnd9: {
    var exampleNode;
    if ((x1 instanceof $c_s_Some)) {
      rc8 = true;
      x2 = $as_s_Some(x1);
      var scalar = $as_Lorg_yaml_model_YScalar(x2.value$2);
      if ($is_Lorg_yaml_model_QuotedMark(scalar.mark$3)) {
        var exampleNode = new $c_s_Some().init___O(this.node$1);
        break matchEnd9
      }
    };
    if ((rc8 && this.isScalar$1)) {
      var exampleNode = new $c_s_Some().init___O(this.node$1);
      break matchEnd9
    };
    if (rc8) {
      var scalar$2 = $as_Lorg_yaml_model_YScalar(x2.value$2);
      if ($m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$().unapply__T__s_Option(scalar$2.text$3).isDefined__Z()) {
        jsonText = new $c_s_Some().init___O(scalar$2.text$3);
        var node$1 = this.node$1;
        var this$3 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node$1).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lamf_core_parser_package$YScalarYRead$());
        if (this$3.isEmpty__Z()) {
          var exampleNode = $m_s_None$();
          break matchEnd9
        } else {
          var arg1 = this$3.get__O();
          var scalar$3 = $as_Lorg_yaml_model_YScalar(arg1);
          if ((!this.fromExternal$1)) {
            var jsx$5 = $m_Lorg_yaml_parser_JsonParser$();
            var jsx$4 = scalar$3.text$3;
            var jsx$3 = scalar$3.location$1.sourceName$1;
            var jsx$2 = $m_Lorg_mulesoft_lexer_Position$();
            var this$4 = this.node$1;
            var this$5 = this$4.location$1;
            var jsx$1 = $m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$5.lineFrom$1, this$5.columnFrom$1, this$5.lineTo$1, this$5.columnTo$1).lineFrom$1;
            var this$6 = this.node$1;
            var this$7 = this$6.location$1;
            var parser = jsx$5.withSource__jl_CharSequence__T__Lorg_mulesoft_lexer_Position__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_JsonParser(jsx$4, jsx$3, jsx$2.apply__I__I__I__Lorg_mulesoft_lexer_Position(jsx$1, $m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$7.lineFrom$1, this$7.columnFrom$1, this$7.lineTo$1, this$7.columnTo$1).columnFrom$1, ($m_Lorg_mulesoft_lexer_Position$(), 0)), errorHandler)
          } else {
            var parser = $m_Lorg_yaml_parser_JsonParser$().withSource__jl_CharSequence__T__Lorg_mulesoft_lexer_Position__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_JsonParser(scalar$3.text$3, scalar$3.location$1.sourceName$1, $m_Lorg_mulesoft_lexer_Position$().Zero$1, this.ctx$1)
          };
          var exampleNode = new $c_s_Some().init___O($f_Lorg_yaml_parser_YParser__document__Lorg_yaml_model_YDocument(parser).node$2);
          break matchEnd9
        }
      }
    };
    if (rc8) {
      var scalar$4 = $as_Lorg_yaml_model_YScalar(x2.value$2);
      if ($m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$().unapply__T__s_Option(scalar$4.text$3).isDefined__Z()) {
        var exampleNode = $m_s_None$();
        break matchEnd9
      }
    };
    var exampleNode = new $c_s_Some().init___O(this.node$1)
  };
  var rc5 = false;
  var x2$2 = null;
  if ((errorHandler instanceof $c_Lamf_core_parser_errorhandler_WarningOnlyHandler)) {
    rc5 = true;
    x2$2 = $as_Lamf_core_parser_errorhandler_WarningOnlyHandler(errorHandler);
    var this$9 = x2$2;
    if ((this$9.warningRegister$2 && jsonText.isDefined__Z())) {
      var this$10 = jsonText;
      if (this$10.isEmpty__Z()) {
        var xo = $m_s_None$()
      } else {
        var arg1$1 = this$10.get__O();
        var x$2 = $as_T(arg1$1);
        var xo = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_annotations_ParsedJSONExample().init___T(x$2))
      };
      var this$12 = xo.toList__sci_List();
      return this.parseDataNode__p1__s_Option__sc_Seq__Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult(exampleNode, this$12)
    }
  };
  if (rc5) {
    var this$13 = x2$2;
    var jsx$6 = this$13.warningRegister$2
  } else {
    var jsx$6 = false
  };
  if (jsx$6) {
    return new $c_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult().init___s_Option__s_Option(exampleNode, $m_s_None$())
  };
  var this$14 = jsonText;
  if (this$14.isEmpty__Z()) {
    var xo$1 = $m_s_None$()
  } else {
    var arg1$2 = this$14.get__O();
    var x$3 = $as_T(arg1$2);
    var xo$1 = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_annotations_ParsedJSONExample().init___T(x$3))
  };
  var this$16 = xo$1.toList__sci_List();
  return this.parseDataNode__p1__s_Option__sc_Seq__Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult(exampleNode, this$16)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.node$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.parentId$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.quiet$1 ? 1231 : 1237));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.fromExternal$1 ? 1231 : 1237));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.isScalar$1 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 5)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser.prototype.parseDataNode__p1__s_Option__sc_Seq__Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult = (function(exampleNode, ann) {
  if (exampleNode.isEmpty__Z()) {
    var dataNode$2 = $m_s_None$()
  } else {
    var arg1 = exampleNode.get__O();
    var ex = $as_Lorg_yaml_model_YNode(arg1);
    var x$2 = new $c_s_Some().init___O(this.parentId$1);
    var x$3 = new $c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables().init___();
    var dataNode = $m_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser(ex, x$3, x$2, this.ctx$1).parse__Lamf_core_model_domain_DataNode();
    dataNode.annotations__Lamf_core_parser_Annotations().reject__F1__Lamf_core_parser_Annotations(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$4$2) {
        var x$4 = $as_Lamf_core_model_domain_Annotation(x$4$2);
        return (x$4 instanceof $c_Lamf_core_annotations_LexicalInformation)
      })
    })(this)));
    var jsx$2 = dataNode.annotations__Lamf_core_parser_Annotations();
    var jsx$1 = $m_Lamf_core_parser_Range$();
    var this$2 = ex.value__Lorg_yaml_model_YValue();
    var this$3 = this$2.location$1;
    jsx$2.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_LexicalInformation().init___Lamf_core_parser_Range(jsx$1.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$3.lineFrom$1, this$3.columnFrom$1, this$3.lineTo$1, this$3.columnTo$1))));
    ann.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, dataNode$1) {
      return (function(a$2) {
        var a = $as_Lamf_core_model_domain_Annotation(a$2);
        return dataNode$1.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(a)
      })
    })(this, dataNode)));
    var dataNode$2 = new $c_s_Some().init___O(dataNode)
  };
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult().init___s_Option__s_Option(exampleNode, dataNode$2)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.NodeDataNodeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.NodeDataNodeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.NodeDataNodeParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser() {
  $c_O.call(this);
  this.entry$1 = null;
  this.parentId$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser.prototype.productPrefix__T = (function() {
  return "Oas3NamedExamplesParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser)) {
    var Oas3NamedExamplesParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser(x$1);
    var x = this.entry$1;
    var x$2 = Oas3NamedExamplesParser$1.entry$1;
    if ((x === x$2)) {
      return (this.parentId$1 === Oas3NamedExamplesParser$1.parentId$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$1;
      break
    }
    case 1: {
      return this.parentId$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser.prototype.parse__sc_Seq = (function() {
  var this$1 = this.entry$1.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$1;
  var jsx$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).entries$3;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(e$2) {
      var e = $as_Lorg_yaml_model_YMapEntry(e$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser().init___Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext(e, $this.parentId$1, $m_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$(), $this.ctx$1).parse__Lamf_plugins_domain_shapes_models_Example()
    })
  })(this));
  var this$2 = $m_sc_IndexedSeq$();
  return $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBF$6))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser.prototype.init___Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(entry, parentId, ctx) {
  this.entry$1 = entry;
  this.parentId$1 = parentId;
  this.ctx$1 = ctx;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Oas3NamedExamplesParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Oas3NamedExamplesParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Oas3NamedExamplesParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser() {
  $c_O.call(this);
  this.entry$1 = null;
  this.producer$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser.prototype.productPrefix__T = (function() {
  return "OasContentsParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser)) {
    var OasContentsParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser(x$1);
    var x = this.entry$1;
    var x$2 = OasContentsParser$1.entry$1;
    if ((x === x$2)) {
      var x$3 = this.producer$1;
      var x$4 = OasContentsParser$1.producer$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$1;
      break
    }
    case 1: {
      return this.producer$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(entry, producer, ctx) {
  this.entry$1 = entry;
  this.producer$1 = producer;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser.prototype.parse__sci_List = (function() {
  var payloads = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = this.entry$1.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$1;
  $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, payloads$1) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      return payloads$1.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser().init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(entry, $this.producer$1, $this.ctx$1).parse__Lamf_plugins_domain_webapi_models_Payload())
    })
  })(this, payloads)));
  return payloads.toList__sci_List()
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasContentsParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasContentsParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasContentsParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.exemplifiedDomainElement$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser.prototype.productPrefix__T = (function() {
  return "OasExamplesParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser)) {
    var OasExamplesParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser(x$1);
    var this$1 = this.map$1;
    var b = OasExamplesParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.exemplifiedDomainElement$1;
      var x$2 = OasExamplesParser$1.exemplifiedDomainElement$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.exemplifiedDomainElement$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser.prototype.parseExample__p1__Lorg_yaml_model_YNode__Lamf_plugins_domain_shapes_models_Example = (function(yNode) {
  var qual$1 = $m_Lamf_plugins_domain_shapes_models_Example$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_Example(yNode);
  var x$1 = this.exemplifiedDomainElement$1.id__T();
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var example = $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser().init___Lorg_yaml_model_YNode__Lamf_plugins_domain_shapes_models_Example__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext(yNode, example, $m_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$(), this.ctx$1).parse__Lamf_plugins_domain_shapes_models_Example()
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser.prototype.parse__V = (function() {
  var map = this.map$1;
  var _1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("example");
  var map$1 = this.map$1;
  var _2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option("examples");
  matchEnd17: {
    if ((_1 instanceof $c_s_Some)) {
      var x4 = $as_s_Some(_1);
      var exampleEntry = $as_Lorg_yaml_model_YMapEntry(x4.value$2);
      var x = $m_s_None$();
      if ((x === _2)) {
        $m_sci_List$();
        var array = [this.parseExample__p1__Lorg_yaml_model_YNode__Lamf_plugins_domain_shapes_models_Example(exampleEntry.value$2)];
        var i = (((-1) + $uI(array.length)) | 0);
        var result = $m_sci_Nil$();
        while ((i >= 0)) {
          var this$6 = result;
          var index = i;
          var x$1 = array[index];
          result = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$6);
          i = (((-1) + i) | 0)
        };
        var examples = result;
        var this$7 = this.exemplifiedDomainElement$1;
        var field = $m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1;
        var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(examples, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(exampleEntry));
        var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(exampleEntry);
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$7, field, value, annotations);
        break matchEnd17
      }
    };
    var x$3 = $m_s_None$();
    if (((x$3 === _1) && (_2 instanceof $c_s_Some))) {
      var x7 = $as_s_Some(_2);
      var examplesEntry = $as_Lorg_yaml_model_YMapEntry(x7.value$2);
      var examples$2 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser().init___Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_WebApiContext(examplesEntry, this.exemplifiedDomainElement$1.id__T(), this.ctx$1).parse__sc_Seq();
      var this$8 = this.exemplifiedDomainElement$1;
      var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1;
      var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(examples$2, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(examplesEntry.value$2));
      var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(examplesEntry);
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$8, field$1, value$1, annotations$1);
      break matchEnd17
    };
    if (((_1 instanceof $c_s_Some) && (_2 instanceof $c_s_Some))) {
      var this$9 = this.ctx$1.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().ExclusivePropertiesSpecification$1;
      var node = this.exemplifiedDomainElement$1.id__T();
      var ast = this.map$1;
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$9, specification, node, prop, "Properties 'example' and 'examples' are exclusive and cannot be declared together", l);
      break matchEnd17
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser.prototype.init___Lorg_yaml_model_YMap__Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(map, exemplifiedDomainElement, ctx) {
  this.map$1 = map;
  this.exemplifiedDomainElement$1 = exemplifiedDomainElement;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasExamplesParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasExamplesParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasExamplesParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.adopt$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser.prototype.productPrefix__T = (function() {
  return "OasHeaderParametersParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser)) {
    var OasHeaderParametersParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser(x$1);
    var this$1 = this.map$1;
    var b = OasHeaderParametersParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.adopt$1;
      var x$2 = OasHeaderParametersParser$1.adopt$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.adopt$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser.prototype.parse__sc_Seq = (function() {
  var jsx$2 = this.map$1.entries$3;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var this$1 = entry.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = $this.ctx$1;
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser().init___Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, entry$1) {
        return (function(header$2) {
          var header = $as_Lamf_plugins_domain_webapi_models_Parameter(header$2);
          var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$1);
          $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(header, other);
          var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1;
          var node = entry$1.key$2;
          var iv$1 = $this$1.ctx$1;
          var this$3 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv$1);
          var value = this$3.string__Lamf_core_model_domain_AmfScalar();
          $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(header, field, value);
          $this$1.adopt$1.apply__O__O(header)
        })
      })($this, entry)), $this.ctx$1).parse__Lamf_plugins_domain_webapi_models_Parameter()
    })
  })(this));
  var this$4 = $m_sc_IndexedSeq$();
  return $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBF$6))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser.prototype.init___Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(map, adopt, ctx) {
  this.map$1 = map;
  this.adopt$1 = adopt;
  this.ctx$1 = ctx;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasHeaderParametersParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasHeaderParametersParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasHeaderParametersParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser() {
  $c_O.call(this);
  this.OasLikeParametrizedSecuritySchemeParser$module$1 = null;
  this.node$1 = null;
  this.producer$1 = null;
  this.idCounter$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser.prototype.amf$plugins$document$webapi$parser$spec$domain$OasLikeSecurityRequirementParser$$getScopes__Lorg_yaml_model_YMapEntry__sc_Seq = (function(schemeEntry) {
  var this$1 = schemeEntry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
  var iv = this.ctx$1;
  var jsx$2 = $as_sc_TraversableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(n$2) {
      var n = $as_Lorg_yaml_model_YNode(n$2);
      var this$3 = $m_Lamf_plugins_domain_webapi_models_security_Scope$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_security_Scope(n);
      var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Name$1;
      var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
      var iv$1 = $this.ctx$1;
      var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(n, conversion$1, iv$1), new $c_Lamf_core_parser_Annotations().init___());
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(n);
      return $as_Lamf_plugins_domain_webapi_models_security_Scope($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$3, field, value, annotations))
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser.prototype.productPrefix__T = (function() {
  return "OasLikeSecurityRequirementParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser)) {
    var OasLikeSecurityRequirementParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser(x$1);
    var this$1 = this.node$1;
    var b = OasLikeSecurityRequirementParser$1.node$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.producer$1;
      var x$2 = OasLikeSecurityRequirementParser$1.producer$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.idCounter$1;
      var x$4 = OasLikeSecurityRequirementParser$1.idCounter$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.node$1;
      break
    }
    case 1: {
      return this.producer$1;
      break
    }
    case 2: {
      return this.idCounter$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser.prototype.init___Lorg_yaml_model_YNode__F1__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function(node, producer, idCounter, ctx) {
  this.node$1 = node;
  this.producer$1 = producer;
  this.idCounter$1 = idCounter;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser.prototype.parse__s_Option = (function() {
  var rc5 = false;
  var x2 = null;
  var this$1 = this.node$1;
  var evidence$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var x1 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$1, evidence$2);
  if ((x1 instanceof $c_s_util_Right)) {
    rc5 = true;
    x2 = $as_s_util_Right(x1);
    var map = $as_Lorg_yaml_model_YMap(x2.value$2);
    var this$2 = map.entries$3;
    if ($f_sc_TraversableOnce__nonEmpty__Z(this$2)) {
      var this$3 = $as_Lamf_core_model_domain_AmfElement(this.producer$1.apply__O__O(this.idCounter$1.genId__T__T("requirement")));
      var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.node$1);
      var securityRequirement = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$3, other));
      map.entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, securityRequirement$1) {
        return (function(entry$2) {
          var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
          return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser().init___Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser__Lorg_yaml_model_YMapEntry__F1($this, entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, securityRequirement$1$1) {
            return (function(name$2) {
              var name = $as_T(name$2);
              return securityRequirement$1$1.withScheme__T__Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme(name)
            })
          })($this, securityRequirement$1))).parse__s_Option()
        })
      })(this, securityRequirement)));
      return new $c_s_Some().init___O(securityRequirement)
    }
  };
  if (rc5) {
    var map$2 = $as_Lorg_yaml_model_YMap(x2.value$2);
    if (map$2.entries$3.isEmpty__Z()) {
      return $m_s_None$()
    }
  };
  var requirement = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(this.producer$1.apply__O__O(this.node$1.toString__T()));
  var this$4 = this.ctx$1.eh$1;
  var specification = $m_Lamf_validations_ParserSideValidations$().InvalidSecurityRequirementObject$1;
  var node = requirement.id$1;
  var message = ("Invalid security requirement " + this.node$1);
  var ast = this.node$1;
  var prop = $m_s_None$();
  var l = ast.location$1;
  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$4, specification, node, prop, message, l);
  return $m_s_None$()
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasLikeSecurityRequirementParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasLikeSecurityRequirementParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasLikeSecurityRequirementParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser() {
  $c_O.call(this);
  this.schemeEntry$1 = null;
  this.producer$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser.prototype.productPrefix__T = (function() {
  return "OasLikeParametrizedSecuritySchemeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser.prototype.isValidScope__p1__s_Option__Lamf_plugins_domain_webapi_models_security_Scope__Z = (function(maybeFlow, scope) {
  if ((!maybeFlow.isEmpty__Z())) {
    var arg1 = maybeFlow.get__O();
    var flow = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow(arg1);
    if ($as_sc_Seq(flow.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Scopes$1)).nonEmpty__Z()) {
      var jsx$3 = $as_sc_Seq(flow.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Scopes$1));
      var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x$1$2) {
          var x$1 = $as_Lamf_plugins_domain_webapi_models_security_Scope(x$1$2);
          var this$1 = $as_Lamf_core_model_StrField(x$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Name$1));
          var this$2 = this$1.option$1;
          return $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()))
        })
      })(this));
      var this$3 = $m_sc_Seq$();
      var jsx$1 = $as_sc_SeqLike(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$3.ReusableCBFInstance$2));
      var this$4 = $as_Lamf_core_model_StrField(scope.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Name$1));
      var this$5 = this$4.option$1;
      return jsx$1.contains__O__Z($as_T((this$5.isEmpty__Z() ? null : this$5.get__O())))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser) && ($as_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser(x$1).$$outer$1 === this.$$outer$1))) {
    var OasLikeParametrizedSecuritySchemeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser(x$1);
    var x = this.schemeEntry$1;
    var x$2 = OasLikeParametrizedSecuritySchemeParser$1.schemeEntry$1;
    if ((x === x$2)) {
      var x$3 = this.producer$1;
      var x$4 = OasLikeParametrizedSecuritySchemeParser$1.producer$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.schemeEntry$1;
      break
    }
    case 1: {
      return this.producer$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser.prototype.parse__s_Option = (function() {
  var this$1 = this.schemeEntry$1.key$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
  var iv = this.$$outer$1.ctx$1;
  var name = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3;
  var this$2 = $as_Lamf_core_model_domain_AmfElement(this.producer$1.apply__O__O(name));
  var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.schemeEntry$1);
  var scheme = $as_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$2, other));
  var declaration = this.parseTarget__p1__T__Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_security_SecurityScheme(name, scheme, this.schemeEntry$1);
  var this$3 = declaration;
  var x1 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$3);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var d = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    declaration = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(d)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      declaration = declaration
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  this.parseScopes__p1__Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lorg_yaml_model_YMapEntry__O(scheme, declaration, this.schemeEntry$1);
  return new $c_s_Some().init___O(scheme)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser__Lorg_yaml_model_YMapEntry__F1 = (function($$outer, schemeEntry, producer) {
  this.schemeEntry$1 = schemeEntry;
  this.producer$1 = producer;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser.prototype.parseScopes__p1__Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lorg_yaml_model_YMapEntry__O = (function(scheme, declaration, schemeEntry) {
  var this$1 = $as_Lamf_core_model_StrField(declaration.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1));
  if ($f_Lamf_core_model_ValueField__is__O__Z(this$1, "OAuth 2.0")) {
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var qual$1 = new $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
    var x$1 = scheme.id$1;
    $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var this$5 = $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1);
    var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(schemeEntry);
    var settings = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$5, other));
    var scopes = this.$$outer$1.amf$plugins$document$webapi$parser$spec$domain$OasLikeSecurityRequirementParser$$getScopes__Lorg_yaml_model_YMapEntry__sc_Seq(schemeEntry);
    var jsx$1 = $m_sc_Seq$();
    var this$6 = settings.withFlow__Lamf_plugins_domain_webapi_models_security_OAuth2Flow();
    var annotation = new $c_Lamf_core_annotations_VirtualObject().init___();
    var this$7 = $as_Lamf_core_model_domain_AmfObject($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$6, annotation));
    var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Scopes$1;
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(schemeEntry.value$2);
    var array = [$as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$7, field, scopes, annotations$1))];
    var flows = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
    var this$10 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(scheme.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Scheme$1));
    var x1 = $as_Lamf_plugins_domain_webapi_models_security_Settings(this$10.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1));
    if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings)) {
      var x2 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(x1);
      scopes.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x2$1, scheme$1) {
        return (function(s$2) {
          var s = $as_Lamf_plugins_domain_webapi_models_security_Scope(s$2);
          if ((!$this.isValidScope__p1__s_Option__Lamf_plugins_domain_webapi_models_security_Scope__Z($as_sc_Seq(x2$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1)).headOption__s_Option(), s))) {
            var this$17 = $this.$$outer$1.ctx$1.eh$1;
            var specification = $m_Lamf_validations_ParserSideValidations$().UnknownScopeErrorSpecification$1;
            var node = s.id$1;
            var this$11 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Scopes$1.value$1;
            var property = new $c_s_Some().init___O($m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this$11));
            var this$12 = $as_Lamf_core_model_StrField(s.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Name$1));
            var this$13 = this$12.option$1;
            var jsx$2 = $as_T((this$13.isEmpty__Z() ? null : this$13.get__O()));
            var this$14 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(scheme$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Scheme$1));
            var this$15 = $as_Lamf_core_model_StrField(this$14.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Name$1));
            var this$16 = this$15.option$1;
            var message = (((("Scope '" + jsx$2) + "' not found in settings of declared secured by ") + $as_T((this$16.isEmpty__Z() ? null : this$16.get__O()))) + ".");
            var lexical = s.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
            var location = $f_Lamf_core_model_domain_AmfElement__location__s_Option(s);
            this$17.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
          }
        })
      })(this, x2, scheme)))
    };
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Settings$1;
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1;
    var value = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(settings, field$1, flows));
    var this$18 = $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(scheme, field$2, value);
    var other$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(schemeEntry);
    return $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$18, other$1)
  } else {
    var this$19 = $as_Lamf_core_model_StrField(declaration.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1));
    if ($f_Lamf_core_model_ValueField__is__O__Z(this$19, "openIdConnect")) {
      $m_Lamf_core_parser_Annotations$();
      var annotations$2 = new $c_Lamf_core_parser_Annotations().init___();
      var qual$2 = new $c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$2);
      var x$3 = scheme.id$1;
      $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      var settings$2 = $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$2, x$3));
      var scopes$2 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$domain$OasLikeSecurityRequirementParser$$getScopes__Lorg_yaml_model_YMapEntry__sc_Seq(schemeEntry);
      var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Settings$1;
      var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$().Scopes$1;
      var annotations$3 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(schemeEntry.value$2);
      var value$1 = $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(settings$2, field$3, scopes$2, annotations$3);
      return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(scheme, field$4, value$1)
    } else {
      var this$23 = schemeEntry.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
      var iv = this.$$outer$1.ctx$1;
      if ($as_sc_TraversableOnce($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$23, conversion, iv)).nonEmpty__Z()) {
        var x1$2 = $as_Lamf_core_model_StrField(declaration.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1)).option$1;
        if ((x1$2 instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(x1$2);
          var schemeType = $as_T(x2$2.value$2);
          var msg = ("Scopes array must be empty for security scheme type " + schemeType)
        } else {
          var x = $m_s_None$();
          if ((!(x === x1$2))) {
            throw new $c_s_MatchError().init___O(x1$2)
          };
          var msg = "Scopes array must be empty for given security scheme"
        };
        var this$24 = this.$$outer$1.ctx$1.eh$1;
        var specification$1 = $m_Lamf_validations_ParserSideValidations$().ScopeNamesMustBeEmpty$1;
        var node$1 = scheme.id$1;
        var ast = this.$$outer$1.node$1;
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$24, specification$1, node$1, prop, msg, l);
        return (void 0)
      } else {
        return (void 0)
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser.prototype.parseTarget__p1__T__Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_security_SecurityScheme = (function(name, scheme, part) {
  var x1 = this.$$outer$1.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations().findSecurityScheme__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option(name, $m_Lamf_core_parser_SearchScope$All$(), (this.$$outer$1.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations(), $m_s_None$()));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var declaration = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(x2.value$2);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Scheme$1;
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(scheme, field, declaration);
    return declaration
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      $m_Lamf_core_parser_Annotations$();
      var annotations = new $c_Lamf_core_parser_Annotations().init___();
      var fields = new $c_Lamf_core_parser_Fields().init___();
      var securityScheme = new $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
      var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Scheme$1;
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(scheme, field$1, securityScheme);
      var this$6 = this.$$outer$1.ctx$1.eh$1;
      var specification = $m_Lamf_plugins_features_validation_CoreValidations$().DeclarationNotFound$1;
      var node = securityScheme.id$1;
      var message = (("Security scheme '" + name) + "' not found in declarations.");
      var prop = $m_s_None$();
      var l = part.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$6, specification, node, prop, message, l);
      return securityScheme
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser$OasLikeParametrizedSecuritySchemeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter() {
  $c_O.call(this);
  this.OasParameterEmitter$module$1 = null;
  this.XRamlParameterEmitter$module$1 = null;
  this.key$1 = null;
  this.parameters$1 = null;
  this.ordering$1 = null;
  this.payloads$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter.prototype.productPrefix__T = (function() {
  return "OasParametersEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter.prototype.isValidOasParam__p1__Lamf_plugins_domain_webapi_models_Parameter__Z = (function(p) {
  var x1 = this.spec$1.vendor__Lamf_core_remote_Vendor();
  var x = $m_Lamf_core_remote_Vendor$().OAS30$1;
  if ((x === x1)) {
    var this$1 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
    if ($f_Lamf_core_model_ValueField__is__O__Z(this$1, "query")) {
      var jsx$2 = true
    } else {
      var this$2 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
      var jsx$2 = $f_Lamf_core_model_ValueField__is__O__Z(this$2, "header")
    };
    if (jsx$2) {
      var jsx$1 = true
    } else {
      var this$3 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
      var jsx$1 = $f_Lamf_core_model_ValueField__is__O__Z(this$3, "path")
    };
    if (jsx$1) {
      return true
    } else {
      var this$4 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
      return $f_Lamf_core_model_ValueField__is__O__Z(this$4, "cookie")
    }
  } else {
    return ((($m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1))).isEmpty__Z() || ($as_Lamf_core_model_domain_Shape(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1)) instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) || ($as_Lamf_core_model_domain_Shape(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1)) instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) || ($as_Lamf_core_model_domain_Shape(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1)) instanceof $c_Lamf_plugins_domain_shapes_models_FileShape))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter.prototype.init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(key, parameters, ordering, payloads, references, spec) {
  this.key$1 = key;
  this.parameters$1 = parameters;
  this.ordering$1 = ordering;
  this.payloads$1 = payloads;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter.prototype.ramlEndpointEmitters__sc_Seq = (function() {
  var jsx$1 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter().init___Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter__sc_Seq__sc_Seq(this, this.parameters$1, this.references$1)];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter)) {
    var OasParametersEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter(x$1);
    if ((this.key$1 === OasParametersEmitter$1.key$1)) {
      var x = this.parameters$1;
      var x$2 = OasParametersEmitter$1.parameters$1;
      var jsx$3 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$3 = this.ordering$1;
      var x$4 = OasParametersEmitter$1.ordering$1;
      var jsx$2 = (x$3 === x$4)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.payloads$1;
      var x$6 = OasParametersEmitter$1.payloads$1;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.references$1;
      var x$8 = OasParametersEmitter$1.references$1;
      return ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.parameters$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.payloads$1;
      break
    }
    case 4: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter.prototype.oasEndpointEmitters__sc_Seq = (function() {
  var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var x1 = this.parameters$1.partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(p$2) {
      var p = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2);
      return $this.isValidOasParam__p1__Lamf_plugins_domain_webapi_models_Parameter__Z(p)
    })
  })(this)));
  if ((x1 === null)) {
    throw new $c_s_MatchError().init___O(x1)
  };
  var oasParameters = $as_sc_Seq(x1.$$und1__O());
  var ramlParameters = $as_sc_Seq(x1.$$und2__O());
  if ((oasParameters.nonEmpty__Z() || this.payloads$1.nonEmpty__Z())) {
    results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter().init___Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter__sc_Seq__sc_Seq(this, oasParameters, this.references$1))
  };
  if (ramlParameters.nonEmpty__Z()) {
    var path = $as_sc_Seq(ramlParameters.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
      return (function(x$15$2) {
        var x$15 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$15$2);
        var this$1 = $as_Lamf_core_model_StrField(x$15.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
        return $f_Lamf_core_model_ValueField__is__O__Z(this$1, "path")
      })
    })(this))));
    if (path.nonEmpty__Z()) {
      results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter().init___Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter__T__sc_Seq(this, new $c_Lamf_core_utils_package$AmfStrings().init___T("uriParameters").asOasExtension__T(), path))
    }
  };
  return results
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter.prototype.emitters__sc_Seq = (function() {
  var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var x1 = this.parameters$1.partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(p$2) {
      var p = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2);
      return ((($m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1))).isEmpty__Z() || ($as_Lamf_core_model_domain_Shape(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1)) instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) || ($as_Lamf_core_model_domain_Shape(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1)) instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) || ($as_Lamf_core_model_domain_Shape(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1)) instanceof $c_Lamf_plugins_domain_shapes_models_FileShape))
    })
  })(this)));
  if ((x1 === null)) {
    throw new $c_s_MatchError().init___O(x1)
  };
  var oasParameters = $as_sc_Seq(x1.$$und1__O());
  var ramlParameters = $as_sc_Seq(x1.$$und2__O());
  if ((oasParameters.nonEmpty__Z() || this.payloads$1.nonEmpty__Z())) {
    results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter().init___Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter__sc_Seq__sc_Seq(this, oasParameters, this.references$1))
  };
  if (ramlParameters.nonEmpty__Z()) {
    var query = $as_sc_Seq(ramlParameters.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
      return (function(x$17$2) {
        var x$17 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$17$2);
        var this$1 = $as_Lamf_core_model_StrField(x$17.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
        return $f_Lamf_core_model_ValueField__is__O__Z(this$1, "query")
      })
    })(this))));
    var header = $as_sc_Seq(ramlParameters.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3) {
      return (function(x$18$2) {
        var x$18 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$18$2);
        var this$4 = $as_Lamf_core_model_StrField(x$18.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
        return $f_Lamf_core_model_ValueField__is__O__Z(this$4, "header")
      })
    })(this))));
    var path = $as_sc_Seq(ramlParameters.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
      return (function(x$19$2) {
        var x$19 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$19$2);
        var this$5 = $as_Lamf_core_model_StrField(x$19.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
        return $f_Lamf_core_model_ValueField__is__O__Z(this$5, "path")
      })
    })(this))));
    if (query.nonEmpty__Z()) {
      results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter().init___Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter__T__sc_Seq(this, new $c_Lamf_core_utils_package$AmfStrings().init___T("queryParameters").asOasExtension__T(), query))
    };
    if (header.nonEmpty__Z()) {
      results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter().init___Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter__T__sc_Seq(this, new $c_Lamf_core_utils_package$AmfStrings().init___T("headers").asOasExtension__T(), header))
    };
    if (path.nonEmpty__Z()) {
      results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter().init___Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter__T__sc_Seq(this, new $c_Lamf_core_utils_package$AmfStrings().init___T("baseUriParameters").asOasExtension__T(), path))
    }
  };
  return results
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter.prototype.amf$plugins$document$webapi$parser$spec$domain$OasParametersEmitter$$parameters__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq = (function(parameters, ordering, references) {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  parameters.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, result$1, ordering$1, references$1) {
    return (function(e$2) {
      var e = $as_Lamf_plugins_domain_webapi_models_Parameter(e$2);
      return result$1.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter().init___Lamf_plugins_domain_webapi_models_Parameter__Lamf_core_emitter_SpecOrdering__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(e, ordering$1, references$1, false, $this.spec$1))
    })
  })(this, result, ordering, references)));
  this.payloads$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, result$2, ordering$2, references$2) {
    return (function(payload$2) {
      var payload = $as_Lamf_plugins_domain_webapi_models_Payload(payload$2);
      return result$2.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter().init___Lamf_plugins_domain_webapi_models_Payload__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(payload, ordering$2, references$2, this$2.spec$1))
    })
  })(this, result, ordering, references)));
  return ordering.sorted__sc_Seq__sc_Seq(result)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasParametersEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasParametersEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasParametersEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser() {
  $c_O.call(this);
  this.ParameterInformation$module$1 = null;
  this.values$1 = null;
  this.parentId$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser.prototype.productPrefix__T = (function() {
  return "OasParametersParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser.prototype.formDataPayload__sc_Seq__s_Option = (function(formData) {
  if (formData.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var shape = new $c_Lamf_plugins_domain_shapes_models_NodeShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
    $m_Lamf_core_parser_Annotations$();
    var a = new $c_Lamf_core_parser_Annotations().init___();
    var qual$1 = $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, "formData", a));
    var x$1 = this.parentId$1;
    var x$2 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var schema = qual$1.adopted__T__sc_Seq__Lamf_plugins_domain_shapes_models_NodeShape(x$1, x$2);
    formData.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, schema$1) {
      return (function(p$2) {
        var p = $as_Lamf_plugins_domain_webapi_models_Payload(p$2);
        if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(p).isDefined__Z()) {
          var links = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
          var payload = $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(p, links))
        } else {
          var payload = p
        };
        var this$5 = $as_Lamf_core_model_StrField(payload.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Name$1));
        var this$6 = this$5.option$1;
        var property = schema$1.withProperty__T__Lamf_core_model_domain_extensions_PropertyShape($as_T((this$6.isEmpty__Z() ? null : this$6.get__O())));
        var rc6 = false;
        var x2 = null;
        var x1 = payload.annotations$1.find__jl_Class__s_Option($d_Lamf_plugins_document_webapi_annotations_RequiredParamPayload.getClassOf());
        matchEnd7: {
          var x = $m_s_None$();
          if ((x === x1)) {
            var field = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1;
            $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject(property, field, 0));
            break matchEnd7
          };
          if ((x1 instanceof $c_s_Some)) {
            rc6 = true;
            x2 = $as_s_Some(x1);
            var a$1 = $as_Lamf_plugins_document_webapi_annotations_RequiredParamPayload(x2.value$2);
            if ((!a$1.required$1)) {
              var field$1 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1;
              var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(0, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_LexicalInformation().init___Lamf_core_parser_Range(a$1.range$1)).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ExplicitField().init___()));
              $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(property, field$1, value));
              break matchEnd7
            }
          };
          if (rc6) {
            var a$2 = $as_Lamf_plugins_document_webapi_annotations_RequiredParamPayload(x2.value$2);
            var field$2 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1;
            var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(1, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_LexicalInformation().init___Lamf_core_parser_Range(a$2.range$1)).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ExplicitField().init___()));
            $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(property, field$2, value$1));
            break matchEnd7
          };
          throw new $c_s_MatchError().init___O(x1)
        };
        var this$9 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(payload.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1)));
        if ((!this$9.isEmpty__Z())) {
          var arg1 = this$9.get__O();
          var x$10 = $as_Lamf_core_model_domain_Shape(arg1);
          var field$3 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1;
          var qual$2 = $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(property, field$3, x$10));
          var x$3 = property.id$1;
          var x$4 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
          qual$2.adopted__T__sc_Seq__Lamf_core_model_domain_extensions_PropertyShape(x$3, x$4)
        }
      })
    })(this, schema)));
    $m_Lamf_core_parser_Annotations$();
    var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
    var qual$3 = new $c_Lamf_plugins_domain_webapi_models_Payload().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
    $m_Lamf_core_parser_Annotations$();
    var x$6 = new $c_Lamf_core_parser_Annotations().init___();
    var qual$4 = $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$3, "formData", x$6));
    var x$7 = this.parentId$1;
    $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var this$14 = $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$4, x$7);
    var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
    var this$15 = $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$14, field$4, schema);
    var annotation = new $c_Lamf_plugins_document_webapi_annotations_FormBodyParameter().init___();
    return new $c_s_Some().init___O($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$15, annotation))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser)) {
    var OasParametersParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser(x$1);
    var x = this.values$1;
    var x$2 = OasParametersParser$1.values$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      return (this.parentId$1 === OasParametersParser$1.parentId$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.values$1;
      break
    }
    case 1: {
      return this.parentId$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser.prototype.validateDuplicated__p1__sc_Seq__V = (function(oasParameters) {
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(oasParam$2) {
      var oasParam = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(oasParam$2);
      var x1 = oasParam.element$1;
      if ((x1 instanceof $c_s_util_Left)) {
        var x2 = $as_s_util_Left(x1);
        var parameter = $as_Lamf_plugins_domain_webapi_models_Parameter(x2.value$2);
        var links = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        var effectiveParam = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(parameter, links));
        var jsx$2 = $m_s_Option$();
        var this$1 = $as_Lamf_core_model_StrField(effectiveParam.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().ParameterName$1));
        var this$2 = this$1.option$1;
        var this$3 = jsx$2.apply__O__s_Option($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())));
        if (this$3.isEmpty__Z()) {
          var xo = $m_s_None$()
        } else {
          var arg1 = this$3.get__O();
          var name = $as_T(arg1);
          var jsx$3 = $m_s_Option$();
          var this$4 = $as_Lamf_core_model_StrField(effectiveParam.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
          var this$5 = this$4.option$1;
          var this$6 = jsx$3.apply__O__s_Option($as_T((this$5.isEmpty__Z() ? null : this$5.get__O())));
          if (this$6.isEmpty__Z()) {
            var xo = $m_s_None$()
          } else {
            var arg1$1 = this$6.get__O();
            var binding = $as_T(arg1$1);
            var xo = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation().init___Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter__T__T($this, oasParam, name, binding))
          }
        };
        return xo.toList__sci_List()
      } else if ((x1 instanceof $c_s_util_Right)) {
        var x3 = $as_s_util_Right(x1);
        var payload = $as_Lamf_plugins_domain_webapi_models_Payload(x3.value$2);
        var links$1 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        var effectivePayload = $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(payload, links$1));
        var name$3 = $this.obtainName__p1__Lamf_plugins_domain_webapi_models_Payload__T(effectivePayload);
        var xo$1 = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation().init___Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter__T__T($this, oasParam, name$3, (oasParam.isFormData$1 ? "formData" : "body")));
        return xo$1.toList__sci_List()
      } else {
        throw new $c_s_MatchError().init___O(x1)
      }
    })
  })(this));
  var this$9 = $m_sc_Seq$();
  var paramsInformation = $as_sc_Seq(oasParameters.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$9.ReusableCBFInstance$2));
  var this$10 = paramsInformation.groupBy__F1__sci_Map(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation(x0$1$2);
      if ((x0$1 !== null)) {
        var name$1 = x0$1.name$1;
        var binding$1 = x0$1.binding$1;
        return new $c_T2().init___O__O(name$1, binding$1)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this)));
  var groupedByBinding = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$10);
  var this$11 = groupedByBinding.$$outer$3.valuesIterator__sc_Iterator();
  while (this$11.hasNext__Z()) {
    var arg1$2 = this$11.next__O();
    var x0$2 = $as_sc_Seq(arg1$2);
    if ((x0$2.length__I() > 1)) {
      $as_sc_IterableLike(x0$2.tail__O()).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
        return (function(x0$3$2) {
          var x0$3 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation(x0$3$2);
          if ((x0$3 !== null)) {
            var oasParam$1 = x0$3.oasParam$1;
            var name$2 = x0$3.name$1;
            var binding$2 = x0$3.binding$1;
            var x1$2 = oasParam$1.ast$1;
            if ((x1$2 instanceof $c_s_Some)) {
              var x2$1 = $as_s_Some(x1$2);
              var ast = $as_Lorg_yaml_model_YPart(x2$1.value$2);
              var this$12 = $this$1.ctx$1.eh$1;
              var specification = $m_Lamf_validations_ParserSideValidations$().DuplicatedParameters$1;
              var node = oasParam$1.domainElement$1.id__T();
              var message = (((("Parameter " + name$2) + " of type ") + binding$2) + " was found duplicated");
              var prop = $m_s_None$();
              var l = ast.location$1;
              $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$12, specification, node, prop, message, l)
            } else {
              var x = $m_s_None$();
              if ((!(x === x1$2))) {
                throw new $c_s_MatchError().init___O(x1$2)
              };
              var this$13 = $this$1.ctx$1.eh$1;
              var specification$1 = $m_Lamf_validations_ParserSideValidations$().DuplicatedParameters$1;
              var node$1 = oasParam$1.domainElement$1.id__T();
              var message$1 = (((("Parameter " + name$2) + " of type ") + binding$2) + " was found duplicated");
              var property = $m_s_None$();
              var lexical = $m_s_None$();
              var location = $m_s_None$();
              this$13.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification$1.id$1, node$1, property, message$1, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
            }
          } else {
            throw new $c_s_MatchError().init___O(x0$3)
          }
        })
      })(this)))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser.prototype.validateOasPayloads__p1__sc_Seq__Lamf_core_validation_core_ValidationSpecification__V = (function(params, id) {
  if ((params.length__I() > 1)) {
    $as_sc_IterableLike(params.tail__O()).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, id$1) {
      return (function(param$2) {
        var param = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(param$2);
        var this$1 = $this.ctx$1.eh$1;
        var node = param.domainElement$1.id__T();
        var ast = $as_Lorg_yaml_model_YPart(param.ast$1.get__O());
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, id$1, node, prop, "Cannot declare more than one 'body' parameter for a request or a resource", l)
      })
    })(this, id)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser.prototype.parse__Z__Lamf_plugins_document_webapi_parser_spec_domain_Parameters = (function(inRequestOrEndpoint) {
  var nameGenerator = new $c_Lamf_core_utils_package$IdCounter().init___();
  var jsx$2 = this.values$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, nameGenerator$1) {
    return (function(value$2) {
      var value = $as_Lorg_yaml_model_YNode(value$2);
      return $this.ctx$1.factory__Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory().parameterParser__s_util_Either__T__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_parser_spec_domain_OasParameterParser(($m_s_package$(), new $c_s_util_Right().init___O(value)), $this.parentId$1, $m_s_None$(), nameGenerator$1).parse__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter()
    })
  })(this, nameGenerator));
  var this$2 = $m_sc_Seq$();
  var oasParameters = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$11$2) {
      var x$11 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(x$11$2);
      var xo = x$11.formData__s_Option();
      return xo.toList__sci_List()
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  var formData = $as_sc_Seq(oasParameters.flatMap__F1__scg_CanBuildFrom__O(jsx$3, this$4.ReusableCBFInstance$2));
  var body = $as_sc_Seq(oasParameters.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x$12$2) {
      var x$12 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(x$12$2);
      return x$12.isBody$1
    })
  })(this))));
  body.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
    return (function(x$13$2) {
      var x$13 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(x$13$2);
      return x$13.domainElement$1.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_BodyParameter().init___())
    })
  })(this)));
  this.validateDuplicated__p1__sc_Seq__V(oasParameters);
  if (inRequestOrEndpoint) {
    if ((body.nonEmpty__Z() && formData.nonEmpty__Z())) {
      var bodyParam = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(body.head__O());
      var this$5 = this.ctx$1.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().OasBodyAndFormDataParameterSpecification$1;
      var node = bodyParam.domainElement$1.id__T();
      var ast = $as_Lorg_yaml_model_YPart(bodyParam.ast$1.get__O());
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$5, specification, node, prop, "Cannot declare 'body' and 'formData' params at the same time for a request or resource", l)
    };
    this.validateOasPayloads__p1__sc_Seq__Lamf_core_validation_core_ValidationSpecification__V(body, $m_Lamf_validations_ParserSideValidations$().OasInvalidBodyParameter$1)
  };
  var jsx$18 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1) {
    return (function(x$14$2) {
      var x$14 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(x$14$2);
      var xo$1 = x$14.query__s_Option();
      return xo$1.toList__sci_List()
    })
  })(this));
  var this$7 = $m_sc_Seq$();
  var jsx$17 = $as_sc_TraversableLike(oasParameters.flatMap__F1__scg_CanBuildFrom__O(jsx$18, this$7.ReusableCBFInstance$2));
  var jsx$16 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1) {
    return (function(x$15$2) {
      var x$15 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(x$15$2);
      var xo$2 = x$15.invalids__s_Option();
      return xo$2.toList__sci_List()
    })
  })(this));
  var this$9 = $m_sc_Seq$();
  var jsx$15 = $as_sc_GenTraversableOnce(oasParameters.flatMap__F1__scg_CanBuildFrom__O(jsx$16, this$9.ReusableCBFInstance$2));
  var this$10 = $m_sc_Seq$();
  var jsx$14 = $as_sc_Seq(jsx$17.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$15, this$10.ReusableCBFInstance$2));
  var jsx$13 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$7$1) {
    return (function(x$16$2) {
      var x$16 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(x$16$2);
      var xo$3 = x$16.path__s_Option();
      return xo$3.toList__sci_List()
    })
  })(this));
  var this$12 = $m_sc_Seq$();
  var jsx$12 = $as_sc_Seq(oasParameters.flatMap__F1__scg_CanBuildFrom__O(jsx$13, this$12.ReusableCBFInstance$2));
  var jsx$11 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$8$1) {
    return (function(x$17$2) {
      var x$17 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(x$17$2);
      var xo$4 = x$17.header__s_Option();
      return xo$4.toList__sci_List()
    })
  })(this));
  var this$14 = $m_sc_Seq$();
  var jsx$10 = $as_sc_Seq(oasParameters.flatMap__F1__scg_CanBuildFrom__O(jsx$11, this$14.ReusableCBFInstance$2));
  var jsx$9 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$9$1) {
    return (function(x$18$2) {
      var x$18 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(x$18$2);
      var xo$5 = x$18.cookie__s_Option();
      return xo$5.toList__sci_List()
    })
  })(this));
  var this$16 = $m_sc_Seq$();
  var jsx$8 = $as_sc_Seq(oasParameters.flatMap__F1__scg_CanBuildFrom__O(jsx$9, this$16.ReusableCBFInstance$2));
  var jsx$7 = $m_sci_Nil$();
  var jsx$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$10$1) {
    return (function(x$19$2) {
      var x$19 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(x$19$2);
      var xo$6 = x$19.body__s_Option();
      return xo$6.toList__sci_List()
    })
  })(this));
  var this$18 = $m_sc_Seq$();
  var jsx$5 = $as_sc_TraversableLike(body.flatMap__F1__scg_CanBuildFrom__O(jsx$6, this$18.ReusableCBFInstance$2));
  var xo$7 = this.formDataPayload__sc_Seq__s_Option(formData);
  var jsx$4 = xo$7.toList__sci_List();
  var this$20 = $m_sc_Seq$();
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters().init___sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq(jsx$14, jsx$12, jsx$10, jsx$8, jsx$7, $as_sc_Seq(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$20.ReusableCBFInstance$2)))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser.prototype.init___sc_Seq__T__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(values, parentId, ctx) {
  this.values$1 = values;
  this.parentId$1 = parentId;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser.prototype.obtainName__p1__Lamf_plugins_domain_webapi_models_Payload__T = (function(payload) {
  var this$1 = payload.fields$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Name$1;
  var this$2 = this$1.fs$1.get__O__s_Option(field);
  if (this$2.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var x$20 = $as_Lamf_core_parser_Value(arg1);
    var this$3 = x$20.annotations$1.find__jl_Class__s_Option($d_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload.getClassOf());
    if (this$3.isEmpty__Z()) {
      var this$4 = $m_s_None$()
    } else {
      var arg1$1 = this$3.get__O();
      var x$21 = $as_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload(arg1$1);
      var this$4 = new $c_s_Some().init___O(x$21.paramName$1)
    }
  };
  if (this$4.isEmpty__Z()) {
    var this$5 = $as_Lamf_core_model_StrField(payload.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Name$1));
    var this$6 = this$5.option$1;
    var jsx$1 = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()))
  } else {
    var jsx$1 = this$4.get__O()
  };
  return $as_T(jsx$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasParametersParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasParametersParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasParametersParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation() {
  $c_O.call(this);
  this.oasParam$1 = null;
  this.name$1 = null;
  this.binding$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation.prototype.productPrefix__T = (function() {
  return "ParameterInformation"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation) && ($as_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation(x$1).$$outer$1 === this.$$outer$1))) {
    var ParameterInformation$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation(x$1);
    var x = this.oasParam$1;
    var x$2 = ParameterInformation$1.oasParam$1;
    if (((x === x$2) && (this.name$1 === ParameterInformation$1.name$1))) {
      return (this.binding$1 === ParameterInformation$1.binding$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.oasParam$1;
      break
    }
    case 1: {
      return this.name$1;
      break
    }
    case 2: {
      return this.binding$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation.prototype.init___Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter__T__T = (function($$outer, oasParam, name, binding) {
  this.oasParam$1 = oasParam;
  this.name$1 = name;
  this.binding$1 = binding;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasParametersParser$ParameterInformation"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasParametersParser$ParameterInformation;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasParametersParser$ParameterInformation", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser$ParameterInformation;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads() {
  $c_O.call(this);
  this.default$1 = null;
  this.other$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads.prototype.productPrefix__T = (function() {
  return "OasPayloads"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads.prototype.init___s_Option__sc_Seq = (function($default, other) {
  this.default$1 = $default;
  this.other$1 = other;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads)) {
    var OasPayloads$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads(x$1);
    var x = this.default$1;
    var x$2 = OasPayloads$1.default$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.other$1;
      var x$4 = OasPayloads$1.other$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.default$1;
      break
    }
    case 1: {
      return this.other$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasPayloads"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasPayloads;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasPayloads", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters() {
  $c_O.call(this);
  this.query$1 = null;
  this.path$1 = null;
  this.header$1 = null;
  this.cookie$1 = null;
  this.baseUri08$1 = null;
  this.body$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Parameters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Parameters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters.prototype.productPrefix__T = (function() {
  return "Parameters"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters.prototype.addParams__p1__sc_Seq__sc_Seq__sc_Seq = (function(global, inner) {
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(p$2) {
      var p = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2);
      var this$1 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
      var this$2 = this$1.option$1;
      var self = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
      return new $c_T2().init___O__O(self, p)
    })
  })(this));
  var this$5 = $m_sc_Seq$();
  var globalMap = $as_sc_TraversableOnce(global.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2);
  var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(p$3$2) {
      var p$3 = $as_Lamf_plugins_domain_webapi_models_Parameter(p$3$2);
      var this$6 = $as_Lamf_core_model_StrField(p$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
      var this$7 = this$6.option$1;
      var self$1 = $as_T((this$7.isEmpty__Z() ? null : this$7.get__O()));
      return new $c_T2().init___O__O(self$1, p$3)
    })
  })(this));
  var this$10 = $m_sc_Seq$();
  var innerMap = $as_sc_TraversableOnce(inner.map__F1__scg_CanBuildFrom__O(jsx$2, this$10.ReusableCBFInstance$2)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2);
  var this$11 = globalMap.$$plus$plus__sc_GenTraversableOnce__sci_Map(innerMap);
  var this$12 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$11);
  return this$12.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream()
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters.prototype.productArity__I = (function() {
  return 6
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters)) {
    var Parameters$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Parameters(x$1);
    var x = this.query$1;
    var x$2 = Parameters$1.query$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.path$1;
      var x$4 = Parameters$1.path$1;
      var jsx$4 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      var x$5 = this.header$1;
      var x$6 = Parameters$1.header$1;
      var jsx$3 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$7 = this.cookie$1;
      var x$8 = Parameters$1.cookie$1;
      var jsx$2 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$9 = this.baseUri08$1;
      var x$10 = Parameters$1.baseUri08$1;
      var jsx$1 = ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$11 = this.body$1;
      var x$12 = Parameters$1.body$1;
      return ((x$11 === null) ? (x$12 === null) : x$11.equals__O__Z(x$12))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.query$1;
      break
    }
    case 1: {
      return this.path$1;
      break
    }
    case 2: {
      return this.header$1;
      break
    }
    case 3: {
      return this.cookie$1;
      break
    }
    case 4: {
      return this.baseUri08$1;
      break
    }
    case 5: {
      return this.body$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters.prototype.merge__Lamf_plugins_document_webapi_parser_spec_domain_Parameters__Lamf_plugins_document_webapi_parser_spec_domain_Parameters = (function(inner) {
  var jsx$5 = this.mergeParams__p1__sc_Seq__sc_Seq__sc_Seq(this.query$1, inner.query$1);
  var jsx$4 = this.mergeParams__p1__sc_Seq__sc_Seq__sc_Seq(this.path$1, inner.path$1);
  var jsx$3 = this.mergeParams__p1__sc_Seq__sc_Seq__sc_Seq(this.header$1, inner.header$1);
  var jsx$2 = this.mergeParams__p1__sc_Seq__sc_Seq__sc_Seq(this.cookie$1, inner.cookie$1);
  var jsx$1 = this.mergeParams__p1__sc_Seq__sc_Seq__sc_Seq(this.baseUri08$1, inner.baseUri08$1);
  var inner$1 = inner.body$1;
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters().init___sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq(jsx$5, jsx$4, jsx$3, jsx$2, jsx$1, inner$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters.prototype.init___sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq = (function(query, path, header, cookie, baseUri08, body) {
  this.query$1 = query;
  this.path$1 = path;
  this.header$1 = header;
  this.cookie$1 = cookie;
  this.baseUri08$1 = baseUri08;
  this.body$1 = body;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters.prototype.add__Lamf_plugins_document_webapi_parser_spec_domain_Parameters__Lamf_plugins_document_webapi_parser_spec_domain_Parameters = (function(inner) {
  var jsx$5 = this.addParams__p1__sc_Seq__sc_Seq__sc_Seq(this.query$1, inner.query$1);
  var jsx$4 = this.addParams__p1__sc_Seq__sc_Seq__sc_Seq(this.path$1, inner.path$1);
  var jsx$3 = this.addParams__p1__sc_Seq__sc_Seq__sc_Seq(this.header$1, inner.header$1);
  var jsx$2 = this.addParams__p1__sc_Seq__sc_Seq__sc_Seq(this.cookie$1, inner.cookie$1);
  var jsx$1 = this.addParams__p1__sc_Seq__sc_Seq__sc_Seq(this.baseUri08$1, inner.baseUri08$1);
  var global = this.body$1;
  var inner$1 = inner.body$1;
  var this$1 = $m_sc_Seq$();
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters().init___sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq(jsx$5, jsx$4, jsx$3, jsx$2, jsx$1, $as_sc_Seq(global.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(inner$1, this$1.ReusableCBFInstance$2)))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters.prototype.nonEmpty__Z = (function() {
  return ((((this.query$1.nonEmpty__Z() || this.path$1.nonEmpty__Z()) || this.header$1.nonEmpty__Z()) || this.body$1.nonEmpty__Z()) || this.cookie$1.nonEmpty__Z())
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters.prototype.mergeParams__p1__sc_Seq__sc_Seq__sc_Seq = (function(global, inner) {
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(p$2) {
      var p = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2);
      var this$1 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
      var this$2 = this$1.option$1;
      var self = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
      return new $c_T2().init___O__O(self, p)
    })
  })(this));
  var this$5 = $m_sc_Seq$();
  var globalMap = $as_sc_TraversableOnce(global.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2);
  var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(p$3$2) {
      var p$3 = $as_Lamf_plugins_domain_webapi_models_Parameter(p$3$2);
      var this$6 = $as_Lamf_core_model_StrField(p$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
      var this$7 = this$6.option$1;
      var self$1 = $as_T((this$7.isEmpty__Z() ? null : this$7.get__O()));
      return new $c_T2().init___O__O(self$1, p$3)
    })
  })(this));
  var this$10 = $m_sc_Seq$();
  var innerMap = $as_sc_TraversableOnce(inner.map__F1__scg_CanBuildFrom__O(jsx$2, this$10.ReusableCBFInstance$2)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2);
  var this$11 = globalMap.$$plus$plus__sc_GenTraversableOnce__sci_Map(innerMap);
  var this$12 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$11);
  return this$12.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream()
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Parameters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Parameters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Parameters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Parameters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Parameters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Parameters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Parameters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Parameters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Parameters: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Parameters", {
  Lamf_plugins_document_webapi_parser_spec_domain_Parameters: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Parameters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser() {
  $c_O.call(this);
  this.node$1 = null;
  this.producer$1 = null;
  this.declarations$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser.prototype.productPrefix__T = (function() {
  return "ParametrizedDeclarationParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser)) {
    var ParametrizedDeclarationParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser(x$1);
    var this$1 = this.node$1;
    var b = ParametrizedDeclarationParser$1.node$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.producer$1;
      var x$2 = ParametrizedDeclarationParser$1.producer$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.declarations$1;
      var x$4 = ParametrizedDeclarationParser$1.declarations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser.prototype.fromStringNode__p1__Lorg_yaml_model_YNode__Lamf_core_model_domain_templates_ParametrizedDeclaration = (function(node) {
  var x1 = this.ctx$1.link__Lorg_yaml_model_YNode__s_util_Either(node);
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var value = $as_T(x2.value$2);
    var this$1 = $as_Lamf_core_model_domain_AmfElement(this.producer$1.apply__O__O(value));
    var other = $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(node);
    var this$3 = $as_Lamf_core_model_domain_AmfObject($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$1, other));
    var field = $m_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$().Target$1;
    var qual$1 = $as_Lamf_core_model_domain_templates_AbstractDeclaration(this.declarations$1.apply__O__O__O(value, $m_Lamf_core_parser_SearchScope$Fragments$()));
    $m_Lamf_core_parser_Annotations$();
    var x$2 = new $c_Lamf_core_parser_Annotations().init___();
    var value$1 = $as_Lamf_core_model_domain_templates_AbstractDeclaration($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(qual$1, value, x$2));
    return $as_Lamf_core_model_domain_templates_ParametrizedDeclaration($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$3, field, value$1))
  } else if ((x1 instanceof $c_s_util_Right)) {
    var x3 = $as_s_util_Right(x1);
    var n = $as_Lorg_yaml_model_YNode(x3.value$2);
    var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv = this.ctx$1;
    var text = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(n, conversion, iv)).text$3;
    var qual$2 = $as_Lamf_core_model_domain_templates_AbstractDeclaration(this.declarations$1.apply__O__O__O(text, $m_Lamf_core_parser_SearchScope$All$()));
    $m_Lamf_core_parser_Annotations$();
    var x$4 = new $c_Lamf_core_parser_Annotations().init___();
    var target = $as_Lamf_core_model_domain_templates_AbstractDeclaration($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(qual$2, text, x$4));
    var parametrized = $as_Lamf_core_model_domain_templates_ParametrizedDeclaration(this.producer$1.apply__O__O(text));
    this.setName__Lamf_core_model_domain_templates_ParametrizedDeclaration__T__Lorg_yaml_model_YNode__V(parametrized, text, n);
    var other$1 = $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(node);
    var this$5 = $as_Lamf_core_model_domain_AmfObject($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(parametrized, other$1));
    var field$1 = $m_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$().Target$1;
    return $as_Lamf_core_model_domain_templates_ParametrizedDeclaration($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$5, field$1, target))
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.node$1;
      break
    }
    case 1: {
      return this.producer$1;
      break
    }
    case 2: {
      return this.declarations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser.prototype.setName__Lamf_core_model_domain_templates_ParametrizedDeclaration__T__Lorg_yaml_model_YNode__V = (function(declaration, name, key) {
  var field = $m_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$().Name$1;
  var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(name, new $c_Lamf_core_parser_Annotations().init___());
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(key);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(declaration, field, value, annotations)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser.prototype.init___Lorg_yaml_model_YNode__F1__F2__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(node, producer, declarations, ctx) {
  this.node$1 = node;
  this.producer$1 = producer;
  this.declarations$1 = declarations;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser.prototype.parse__Lamf_core_model_domain_templates_ParametrizedDeclaration = (function() {
  var node = this.node$1;
  var this$2 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YMapYRead$());
  if (this$2.isEmpty__Z()) {
    var x1 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var x$1 = $as_Lorg_yaml_model_YMap(arg1);
    var x1 = x$1.entries$3.headOption__s_Option()
  };
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    var this$3 = entry.value$2;
    var x1$2 = this$3.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Null$1;
    if ((x === x1$2)) {
      return this.fromStringNode__p1__Lorg_yaml_model_YNode__Lamf_core_model_domain_templates_ParametrizedDeclaration(entry.key$2)
    } else {
      var this$4 = entry.key$2;
      var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv = this.ctx$1;
      var name = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).text$3;
      var this$5 = $as_Lamf_core_model_domain_AmfElement(this.producer$1.apply__O__O(name));
      var other = $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(this.node$1);
      var declaration = $as_Lamf_core_model_domain_templates_ParametrizedDeclaration($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$5, other));
      this.setName__Lamf_core_model_domain_templates_ParametrizedDeclaration__T__Lorg_yaml_model_YNode__V(declaration, name, entry.key$2);
      declaration.fields__Lamf_core_parser_Fields().setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$().Target$1, $as_Lamf_core_model_domain_AmfElement(this.declarations$1.apply__O__O__O(name, $m_Lamf_core_parser_SearchScope$Named$())), (declaration.fields__Lamf_core_parser_Fields(), $m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
      var this$8 = entry.value$2;
      var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv$1 = this.ctx$1;
      var jsx$3 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$8, conversion$1, iv$1)).entries$3;
      var this$9 = $m_sc_IndexedSeq$();
      var jsx$2 = $as_sc_TraversableLike(jsx$3.zipWithIndex__scg_CanBuildFrom__O(this$9.ReusableCBF$6));
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, declaration$1) {
        return (function(x0$1$2) {
          var x0$1 = $as_T2(x0$1$2);
          if ((x0$1 !== null)) {
            var variableEntry = $as_Lorg_yaml_model_YMapEntry(x0$1.$$und1__O());
            var index = x0$1.$$und2$mcI$sp__I();
            var x$1$1 = variableEntry.value$2;
            var x$2 = new $c_s_Some().init___O(((declaration$1.id$1 + "_") + index));
            var x$3 = new $c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables().init___();
            var node$1 = $m_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser(x$1$1, x$3, x$2, this$2$1.ctx$1).parse__Lamf_core_model_domain_DataNode();
            var this$12 = $m_Lamf_core_model_domain_templates_VariableValue$().apply__Lorg_yaml_model_YPart__Lamf_core_model_domain_templates_VariableValue(variableEntry);
            var this$11 = variableEntry.key$2;
            var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
            var iv$2 = this$2$1.ctx$1;
            var name$1 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$11, conversion$2, iv$2)).text$3;
            var field = $m_Lamf_core_metamodel_domain_templates_VariableValueModel$().Name$1;
            var this$13 = $as_Lamf_core_model_domain_templates_VariableValue($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$12, field, name$1));
            var field$1 = $m_Lamf_core_metamodel_domain_templates_VariableValueModel$().Value$1;
            return $as_Lamf_core_model_domain_templates_VariableValue($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$13, field$1, node$1))
          } else {
            throw new $c_s_MatchError().init___O(x0$1)
          }
        })
      })(this, declaration));
      var this$14 = $m_sc_IndexedSeq$();
      var variables = $as_sc_IndexedSeq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$14.ReusableCBF$6));
      var field$2 = $m_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$().Variables$1;
      return $as_Lamf_core_model_domain_templates_ParametrizedDeclaration($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(declaration, field$2, variables))
    }
  } else {
    var this$15 = this.node$1;
    var x$3$1 = this$15.tag__Lorg_yaml_model_YTag().tagType$3;
    var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
    if ((x$3$1 === x$4)) {
      return this.fromStringNode__p1__Lorg_yaml_model_YNode__Lamf_core_model_domain_templates_ParametrizedDeclaration(this.node$1)
    } else {
      var declaration$2 = $as_Lamf_core_model_domain_templates_ParametrizedDeclaration(this.producer$1.apply__O__O(""));
      var this$16 = this.ctx$1.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidAbstractDeclarationType$1;
      var node$2 = declaration$2.id$1;
      var ast = this.node$1;
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$16, specification, node$2, prop, "Invalid model extension.", l);
      return declaration$2
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.ParametrizedDeclarationParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.ParametrizedDeclarationParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.ParametrizedDeclarationParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter() {
  $c_O.call(this);
  this.payload$1 = null;
  this.ordering$1 = null;
  this.amf$plugins$document$webapi$parser$spec$domain$Raml08PayloadEmitter$$spec$f = null;
  this.typeEmitters$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter.prototype.productPrefix__T = (function() {
  return "Raml08PayloadEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Payload__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(payload, ordering, spec) {
  this.payload$1 = payload;
  this.ordering$1 = ordering;
  this.amf$plugins$document$webapi$parser$spec$domain$Raml08PayloadEmitter$$spec$f = spec;
  var rc11 = false;
  var x2 = null;
  var x1 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(payload.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1)));
  matchEnd12: {
    var jsx$1;
    if ((x1 instanceof $c_s_Some)) {
      rc11 = true;
      x2 = $as_s_Some(x1);
      var s = $as_Lamf_core_model_domain_Shape(x2.value$2);
      if ((s !== null)) {
        if (s.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_SynthesizedField.getClassOf())) {
          var jsx$1 = $m_sci_Nil$();
          break matchEnd12
        }
      }
    };
    if (rc11) {
      var node = $as_Lamf_core_model_domain_Shape(x2.value$2);
      if ((node instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
        var x7 = $as_Lamf_plugins_domain_shapes_models_NodeShape(node);
        if (((!$f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x7).isDefined__Z()) && x7.annotations$2.find__jl_Class__s_Option($d_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.getClassOf()).isEmpty__Z())) {
          var jsx$2 = $m_sc_Seq$();
          var array = [new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter().init___Lamf_plugins_domain_shapes_models_NodeShape__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x7, ordering, spec)];
          var jsx$1 = $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
          break matchEnd12
        }
      }
    };
    if (rc11) {
      var anyShape = $as_Lamf_core_model_domain_Shape(x2.value$2);
      if ((anyShape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
        var x8 = $as_Lamf_plugins_domain_shapes_models_AnyShape(anyShape);
        var jsx$1 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$().apply__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext__Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter(x8, ordering, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), spec).emitters__sc_Seq();
        break matchEnd12
      }
    };
    if (rc11) {
      var other = $as_Lamf_core_model_domain_Shape(x2.value$2);
      var jsx$3 = $m_sc_Seq$();
      var array$1 = [new $c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter().init___Lamf_core_model_domain_AmfElement__T(other, (("Cannot emit schema " + $objectGetClass(other).toString__T()) + " in raml 08 body request"))];
      var jsx$1 = $as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)));
      break matchEnd12
    };
    var x = $m_s_None$();
    if ((x === x1)) {
      var jsx$4 = $m_sc_Seq$();
      var array$2 = [new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$2().init___Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter(this)];
      var jsx$1 = $as_sc_Seq(jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2)));
      break matchEnd12
    };
    throw new $c_s_MatchError().init___O(x1)
  };
  this.typeEmitters$1 = jsx$1;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter)) {
    var Raml08PayloadEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter(x$1);
    var x = this.payload$1;
    var x$2 = Raml08PayloadEmitter$1.payload$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = Raml08PayloadEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.payload$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter.prototype.emitters__sc_Seq = (function() {
  var x1 = this.payload$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1);
  if ((x1 instanceof $c_s_Some)) {
    var jsx$1 = $m_sc_Seq$();
    var array = [new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1().init___Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter(this)];
    return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return this.typeEmitters$1
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml08PayloadEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml08PayloadEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml08PayloadEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.parentId$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser.prototype.productPrefix__T = (function() {
  return "Raml08WebFormParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser)) {
    var Raml08WebFormParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser(x$1);
    var this$1 = this.map$1;
    var b = Raml08WebFormParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      return (this.parentId$1 === Raml08WebFormParser$1.parentId$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.parentId$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser.prototype.parse__s_Option = (function() {
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("formParameters");
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$3 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$1;
    var entries = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv)).entries$3;
    var this$4 = entries.headOption__s_Option();
    if (this$4.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1$1 = this$4.get__O();
      $as_Lorg_yaml_model_YMapEntry(arg1$1);
      var nodeShape = $m_Lamf_plugins_domain_shapes_models_NodeShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_NodeShape(entry.value$2);
      $m_Lamf_core_parser_Annotations$();
      var a = new $c_Lamf_core_parser_Annotations().init___();
      var qual$1 = $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(nodeShape, "schema", a));
      var x$1$2 = this.parentId$1;
      var x$2 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      var webFormShape = qual$1.adopted__T__sc_Seq__Lamf_plugins_domain_shapes_models_NodeShape(x$1$2, x$2);
      entries.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, webFormShape$1) {
        return (function(e$2) {
          var e = $as_Lorg_yaml_model_YMapEntry(e$2);
          var this$6 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser(e, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, webFormShape$1$1) {
            return (function(shape$2) {
              var shape = $as_Lamf_core_model_domain_Shape(shape$2);
              shape.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(webFormShape$1$1.id$1, shape.adopted$default$2__sc_Seq())
            })
          })($this, webFormShape$1)), false, $m_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$(), $this.ctx$1).parse__s_Option();
          if ((!this$6.isEmpty__Z())) {
            var arg1$2 = this$6.get__O();
            var s = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1$2);
            var property = webFormShape$1.withProperty__T__Lamf_core_model_domain_extensions_PropertyShape(e.key$2.toString__T());
            var field = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1;
            $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject(property, field, 0));
            var this$7 = e.value$2;
            var evidence$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
            var x1 = $f_Lorg_yaml_model_YNodeLike__asOption__Lorg_yaml_convert_YRead__s_Option(this$7, evidence$1);
            if ((x1 instanceof $c_s_Some)) {
              var x2 = $as_s_Some(x1);
              var nestedMap = $as_Lorg_yaml_model_YMap(x2.value$2);
              var this$9 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(nestedMap);
              var this$10 = this$9.key__T__s_Option("required");
              if ((!this$10.isEmpty__Z())) {
                var arg1$3 = this$10.get__O();
                var entry$1 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
                var node = entry$1.value$2;
                var iv$1 = $this.ctx$1;
                var this$12 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv$1);
                var required = $uZ(this$12.$boolean__Lamf_core_model_domain_AmfScalar().value$1);
                var field$1 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1;
                var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations((required ? 1 : 0), new $c_Lamf_core_parser_Annotations().init___());
                var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$1).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ExplicitField().init___());
                $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(property, field$1, value, annotations)
              }
            };
            var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(e);
            var this$14 = $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(property, other));
            var field$2 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1;
            var qual$2 = $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$14, field$2, s));
            var x$3 = property.id$1;
            var x$4 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
            qual$2.adopted__T__sc_Seq__Lamf_core_model_domain_extensions_PropertyShape(x$3, x$4)
          }
        })
      })(this, webFormShape)));
      var field$3 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1;
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(webFormShape, field$3, true);
      return new $c_s_Some().init___O(webFormShape)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser.prototype.init___Lorg_yaml_model_YMap__T__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(map, parentId, ctx) {
  this.map$1 = map;
  this.parentId$1 = parentId;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml08WebFormParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml08WebFormParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml08WebFormParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads() {
  $c_O.call(this);
  this.payload$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads.prototype.productPrefix__T = (function() {
  return "Raml10Payloads"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads)) {
    var Raml10Payloads$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads(x$1);
    var x = this.payload$1;
    var x$2 = Raml10Payloads$1.payload$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = Raml10Payloads$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = Raml10Payloads$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.payload$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads.prototype.emitters__sc_Seq = (function() {
  if (this.payload$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1).isDefined__Z()) {
    var jsx$1 = $m_sc_Seq$();
    var array = [new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter().init___Lamf_plugins_domain_webapi_models_Payload__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(this.payload$1, this.ordering$1, this.references$1, this.spec$1)];
    return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  } else {
    var rc6 = false;
    var x2 = null;
    var jsx$2 = $m_s_Option$();
    var this$3 = this.payload$1;
    var x1 = jsx$2.apply__O__s_Option($as_Lamf_core_model_domain_Shape(this$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1)));
    if ((x1 instanceof $c_s_Some)) {
      rc6 = true;
      x2 = $as_s_Some(x1);
      var shape = $as_Lamf_core_model_domain_Shape(x2.value$2);
      if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
        var x4 = $as_Lamf_plugins_domain_shapes_models_AnyShape(shape);
        var x$2 = this.ordering$1;
        var x$3 = this.references$1;
        var x$4 = $m_sci_Nil$();
        return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x4, x$2, x$4, x$3, false, this.spec$1).emitters__sc_Seq()
      }
    };
    if (rc6) {
      var other = $as_Lamf_core_model_domain_Shape(x2.value$2);
      var this$5 = this.spec$1;
      var this$8 = this$5.eh$1;
      var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
      var node = other.id$1;
      var property = $m_s_None$();
      var this$6 = this.payload$1;
      var lexical = this$6.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      var this$7 = this.payload$1;
      var location = $f_Lamf_core_model_domain_AmfElement__location__s_Option(this$7);
      this$8.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "Cannot emit a non WebAPI shape", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
      return $m_sci_Nil$()
    };
    return $m_sci_Nil$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads.prototype.init___Lamf_plugins_domain_webapi_models_Payload__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(payload, ordering, references, spec) {
  this.payload$1 = payload;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml10Payloads"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml10Payloads;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml10Payloads", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.singleExampleKey$1 = null;
  this.multipleExamplesKey$1 = null;
  this.exemplified$1 = null;
  this.options$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser.prototype.productPrefix__T = (function() {
  return "RamlExamplesParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser)) {
    var RamlExamplesParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser(x$1);
    var this$1 = this.map$1;
    var b = RamlExamplesParser$1.map$1;
    if ((($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b) && (this.singleExampleKey$1 === RamlExamplesParser$1.singleExampleKey$1)) && (this.multipleExamplesKey$1 === RamlExamplesParser$1.multipleExamplesKey$1))) {
      var x = this.exemplified$1;
      var x$2 = RamlExamplesParser$1.exemplified$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.options$1;
      var x$4 = RamlExamplesParser$1.options$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.singleExampleKey$1;
      break
    }
    case 2: {
      return this.multipleExamplesKey$1;
      break
    }
    case 3: {
      return this.exemplified$1;
      break
    }
    case 4: {
      return this.options$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser.prototype.init___Lorg_yaml_model_YMap__T__T__Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(map, singleExampleKey, multipleExamplesKey, exemplified, options, ctx) {
  this.map$1 = map;
  this.singleExampleKey$1 = singleExampleKey;
  this.multipleExamplesKey$1 = multipleExamplesKey;
  this.exemplified$1 = exemplified;
  this.options$1 = options;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser.prototype.parse__V = (function() {
  var map = this.map$1;
  if (new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(this.singleExampleKey$1).isDefined__Z()) {
    var map$1 = this.map$1;
    var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option(this.multipleExamplesKey$1).isDefined__Z()
  } else {
    var jsx$2 = false
  };
  if (jsx$2) {
    var x = this.exemplified$1.id__T();
    var this$4 = new $c_sci_StringOps().init___T(x);
    var jsx$1 = $f_sc_TraversableOnce__nonEmpty__Z(this$4)
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var this$5 = this.ctx$1.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().ExclusivePropertiesSpecification$1;
    var node = this.exemplified$1.id__T();
    var message = (((("Properties '" + this.singleExampleKey$1) + "' and '") + this.multipleExamplesKey$1) + "' are exclusive and cannot be declared together");
    var ast = this.map$1;
    var prop = $m_s_None$();
    var l = ast.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$5, specification, node, prop, message, l)
  };
  var jsx$4 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser().init___T__Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext(this.multipleExamplesKey$1, this.map$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(name$2) {
      var name = $as_s_Option(name$2);
      var this$6 = $this.exemplified$1;
      return $f_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement__withExample__s_Option__Lamf_plugins_domain_shapes_models_Example(this$6, name)
    })
  })(this)), this.options$1, this.ctx$1).parse__sc_Seq();
  var xo = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser().init___T__Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext(this.singleExampleKey$1, this.map$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(name$3$2) {
      var name$3 = $as_s_Option(name$3$2);
      var this$7 = this$2$1.exemplified$1;
      return $f_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement__withExample__s_Option__Lamf_plugins_domain_shapes_models_Example(this$7, name$3)
    })
  })(this)), this.options$1, this.ctx$1).parse__s_Option();
  var jsx$3 = xo.toList__sci_List();
  var this$9 = $m_sc_Seq$();
  var examples = $as_sc_Seq(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$9.ReusableCBFInstance$2));
  var map$2 = this.map$1;
  var this$11 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2).key__T__s_Option(this.multipleExamplesKey$1);
  if (this$11.isEmpty__Z()) {
    var map$3 = this.map$1;
    var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3).key__T__s_Option(this.singleExampleKey$1)
  } else {
    var x1 = this$11
  };
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var e = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    var this$14 = this.exemplified$1;
    var field = $m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1;
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(examples, new $c_Lamf_core_parser_Annotations().init___());
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(e);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$14, field, value, annotations)
  } else if (examples.nonEmpty__Z()) {
    var this$16 = this.exemplified$1;
    var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1;
    var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(examples, new $c_Lamf_core_parser_Annotations().init___());
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$16, field$1, value$1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlExamplesParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlExamplesParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlExamplesParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlExamplesParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser() {
  $c_O.call(this);
  this.key$1 = null;
  this.map$1 = null;
  this.producer$1 = null;
  this.options$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser.prototype.productPrefix__T = (function() {
  return "RamlMultipleExampleParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser)) {
    var RamlMultipleExampleParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser(x$1);
    if ((this.key$1 === RamlMultipleExampleParser$1.key$1)) {
      var this$1 = this.map$1;
      var b = RamlMultipleExampleParser$1.map$1;
      var jsx$2 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x = this.producer$1;
      var x$2 = RamlMultipleExampleParser$1.producer$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.options$1;
      var x$4 = RamlMultipleExampleParser$1.options$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.map$1;
      break
    }
    case 2: {
      return this.producer$1;
      break
    }
    case 3: {
      return this.options$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser.prototype.parse__sc_Seq = (function() {
  var examples = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(this.key$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var x1 = this.ctx$1.link__Lorg_yaml_model_YNode__s_util_Either(entry.value$2);
    if ((x1 instanceof $c_s_util_Left)) {
      var x2 = $as_s_util_Left(x1);
      var s = $as_T(x2.value$2);
      var qual$1 = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations().findNamedExampleOrError__Lorg_yaml_model_YPart__T__Lamf_plugins_domain_shapes_models_Example(entry.value$2, s);
      $m_Lamf_core_parser_Annotations$();
      var x$2 = new $c_Lamf_core_parser_Annotations().init___();
      examples.$$plus$eq__O__scm_ListBuffer($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(qual$1, s, x$2))
    } else if ((x1 instanceof $c_s_util_Right)) {
      var x3 = $as_s_util_Right(x1);
      var node = $as_Lorg_yaml_model_YNode(x3.value$2);
      var x1$2 = node.tag__Lorg_yaml_model_YTag().tagType$3;
      var x = $m_Lorg_yaml_model_YType$().Map$1;
      if ((x === x1$2)) {
        var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv = this.ctx$1;
        var jsx$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).entries$3;
        var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(x$1$2$2) {
            var x$1$2 = $as_Lorg_yaml_model_YMapEntry(x$1$2$2);
            return new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser().init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext(x$1$2, $this.producer$1, $this.options$1, $this.ctx$1).parse__Lamf_plugins_domain_shapes_models_Example()
          })
        })(this));
        var this$4 = $m_sc_IndexedSeq$();
        examples.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer($as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBF$6)))
      } else {
        var x$4 = $m_Lorg_yaml_model_YType$().Null$1;
        if ((!(x$4 === x1$2))) {
          var x$6 = $m_Lorg_yaml_model_YType$().Str$1;
          if ((x$6 === x1$2)) {
            var thiz = node.toString__T();
            if ((thiz === null)) {
              throw new $c_jl_NullPointerException().init___()
            };
            if ($m_ju_regex_Pattern$().matches__T__jl_CharSequence__Z("<<.*>>", thiz)) {
              var x$8 = $as_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this.ctx$1).contextType$3;
              var x$9 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2;
              var jsx$3 = (!((x$8 === null) ? (x$9 === null) : x$8.equals__O__Z(x$9)))
            } else {
              var jsx$3 = false
            }
          } else {
            var jsx$3 = false
          };
          if ((!jsx$3)) {
            var this$6 = this.ctx$1.eh$1;
            var specification = $m_Lamf_validations_ParserSideValidations$().ExamplesMustBeAMap$1;
            var message = (("Property '" + this.key$1) + "' should be a map");
            var prop = $m_s_None$();
            var l = entry.location$1;
            $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$6, specification, "", prop, message, l)
          }
        }
      }
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  return examples
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser.prototype.init___T__Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(key, map, producer, options, ctx) {
  this.key$1 = key;
  this.map$1 = map;
  this.producer$1 = producer;
  this.options$1 = options;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlMultipleExampleParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlMultipleExampleParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlMultipleExampleParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlMultipleExampleParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser() {
  $c_O.call(this);
  this.entry$1 = null;
  this.producer$1 = null;
  this.options$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser.prototype.parse__Lamf_plugins_domain_shapes_models_Example = (function() {
  var node = this.entry$1.key$2;
  var iv = this.ctx$1;
  var name = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
  var simpleProducer = new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, name$1) {
    return (function() {
      return $as_Lamf_plugins_domain_shapes_models_Example($this.producer$1.apply__O__O(new $c_s_Some().init___O(name$1.text__Lamf_core_model_domain_AmfScalar().toString__T())))
    })
  })(this, name));
  var x1 = this.ctx$1.link__Lorg_yaml_model_YNode__s_util_Either(this.entry$1.value$2);
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var s = $as_T(x2.value$2);
    var this$3 = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations().findNamedExample__T__s_Option__s_Option(s, (this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(), $m_s_None$()));
    if (this$3.isEmpty__Z()) {
      var this$5 = $m_s_None$()
    } else {
      var arg1 = this$3.get__O();
      var e = $as_Lamf_plugins_domain_shapes_models_Example(arg1);
      $m_Lamf_core_parser_Annotations$();
      var annotations = new $c_Lamf_core_parser_Annotations().init___();
      var this$5 = new $c_s_Some().init___O($as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(e, s, annotations)))
    };
    var example = $as_Lamf_plugins_domain_shapes_models_Example((this$5.isEmpty__Z() ? new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser().init___Lorg_yaml_model_YMapEntry__F0__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext(this.entry$1, simpleProducer, this.options$1, this.ctx$1).parse__Lamf_plugins_domain_shapes_models_Example() : this$5.get__O()))
  } else {
    if ((!(x1 instanceof $c_s_util_Right))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var example = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser().init___Lorg_yaml_model_YMapEntry__F0__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext(this.entry$1, simpleProducer, this.options$1, this.ctx$1).parse__Lamf_plugins_domain_shapes_models_Example()
  };
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Name$1;
  var value = name.text__Lamf_core_model_domain_AmfScalar();
  var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1);
  return $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(example, field, value, annotations$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser.prototype.productPrefix__T = (function() {
  return "RamlNamedExampleParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser)) {
    var RamlNamedExampleParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser(x$1);
    var x = this.entry$1;
    var x$2 = RamlNamedExampleParser$1.entry$1;
    if ((x === x$2)) {
      var x$3 = this.producer$1;
      var x$4 = RamlNamedExampleParser$1.producer$1;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.options$1;
      var x$6 = RamlNamedExampleParser$1.options$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$1;
      break
    }
    case 1: {
      return this.producer$1;
      break
    }
    case 2: {
      return this.options$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(entry, producer, options, ctx) {
  this.entry$1 = entry;
  this.producer$1 = producer;
  this.options$1 = options;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlNamedExampleParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlNamedExampleParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlNamedExampleParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.adopted$1 = null;
  this.parseOptional$1 = false;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser.prototype.productPrefix__T = (function() {
  return "RamlParametersParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser)) {
    var RamlParametersParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser(x$1);
    var this$1 = this.map$1;
    var b = RamlParametersParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.adopted$1;
      var x$2 = RamlParametersParser$1.adopted$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.parseOptional$1 === RamlParametersParser$1.parseOptional$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.adopted$1;
      break
    }
    case 2: {
      return this.parseOptional$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser.prototype.init___Lorg_yaml_model_YMap__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(map, adopted, parseOptional, ctx) {
  this.map$1 = map;
  this.adopted$1 = adopted;
  this.parseOptional$1 = parseOptional;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser.prototype.parse__sc_Seq = (function() {
  var jsx$2 = this.map$1.entries$3;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser($this.ctx$1.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().parameterParser__F3().apply__O__O__O__O(entry, $this.adopted$1, $this.parseOptional$1)).parse__Lamf_plugins_domain_webapi_models_Parameter()
    })
  })(this));
  var this$1 = $m_sc_IndexedSeq$();
  return $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBF$6))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.map$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.adopted$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.parseOptional$1 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 3)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlParametersParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlParametersParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlParametersParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser() {
  $c_O.call(this);
  this.node$1 = null;
  this.producer$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser.prototype.productPrefix__T = (function() {
  return "RamlParametrizedSecuritySchemeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser)) {
    var RamlParametrizedSecuritySchemeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser(x$1);
    var this$1 = this.node$1;
    var b = RamlParametrizedSecuritySchemeParser$1.node$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.producer$1;
      var x$2 = RamlParametrizedSecuritySchemeParser$1.producer$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.node$1;
      break
    }
    case 1: {
      return this.producer$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser.prototype.init___Lorg_yaml_model_YNode__F1__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(node, producer, ctx) {
  this.node$1 = node;
  this.producer$1 = producer;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser.prototype.parse__Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme = (function() {
  var this$1 = this.node$1;
  var x1 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Null$1;
  if ((x === x1)) {
    var this$2 = $as_Lamf_core_model_domain_AmfElement(this.producer$1.apply__O__O("null"));
    var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.node$1).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_NullSecurity().init___());
    return $as_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$2, other))
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x$3 === x1)) {
      var this$3 = this.node$1;
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = this.ctx$1;
      var schemeEntry = $as_Lorg_yaml_model_YMapEntry($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv)).entries$3.head__O());
      var this$4 = schemeEntry.key$2;
      var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$1 = this.ctx$1;
      var name = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion$1, iv$1)).text$3;
      var this$5 = $as_Lamf_core_model_domain_AmfElement(this.producer$1.apply__O__O(name));
      var other$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.node$1);
      var scheme = $as_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$5, other$1));
      var x1$2 = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations().findSecurityScheme__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option(name, $m_Lamf_core_parser_SearchScope$Named$(), (this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(), $m_s_None$()));
      if ((x1$2 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1$2);
        var declaration = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(x2.value$2);
        var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Scheme$1;
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(scheme, field, declaration);
        var this$7 = schemeEntry.value$2;
        var conversion$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv$2 = this.ctx$1;
        var jsx$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$7, conversion$2, iv$2));
        var this$8 = $as_Lamf_core_model_StrField(declaration.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1));
        var this$9 = this$8.option$1;
        var settings = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser().init___Lorg_yaml_model_YMap__T__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_contexts_WebApiContext(jsx$1, $as_T((this$9.isEmpty__Z() ? null : this$9.get__O())), scheme, this.ctx$1).parse__Lamf_plugins_domain_webapi_models_security_Settings();
        var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Settings$1;
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(scheme, field$1, settings)
      } else {
        var x$5 = $m_s_None$();
        if ((x$5 === x1$2)) {
          var this$10 = this.ctx$1.eh$1;
          var specification = $m_Lamf_validations_ParserSideValidations$().UnknownSecuritySchemeErrorSpecification$1;
          var node = scheme.id$1;
          var message = (("Security scheme '" + name) + "' not found in declarations (and name cannot be 'null').");
          var ast = this.node$1;
          var prop = $m_s_None$();
          var l = ast.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$10, specification, node, prop, message, l)
        } else {
          throw new $c_s_MatchError().init___O(x1$2)
        }
      };
      return scheme
    } else {
      var x$7 = $m_Lorg_yaml_model_YType$().Include$1;
      if ((x$7 === x1)) {
        var this$11 = this.ctx$1.eh$1;
        var specification$1 = $m_Lamf_validations_ParserSideValidations$().UnknownSecuritySchemeErrorSpecification$1;
        var ast$1 = this.node$1;
        var prop$1 = $m_s_None$();
        var l$1 = ast$1.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$11, specification$1, "", prop$1, "'securedBy' property doesn't accept !include tag, only references to security schemes.", l$1);
        var this$12 = $as_Lamf_core_model_domain_AmfElement(this.producer$1.apply__O__O("invalid"));
        var other$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.node$1);
        return $as_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$12, other$2))
      } else {
        var this$13 = this.node$1;
        var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
        var iv$3 = this.ctx$1;
        var name$2 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$13, conversion$3, iv$3)).text$3;
        var this$14 = $as_Lamf_core_model_domain_AmfElement(this.producer$1.apply__O__O(name$2));
        var other$3 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.node$1);
        var scheme$2 = $as_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$14, other$3));
        var x1$3 = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations().findSecurityScheme__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option(name$2, $m_Lamf_core_parser_SearchScope$Named$(), (this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(), $m_s_None$()));
        if ((x1$3 instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(x1$3);
          var declaration$2 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(x2$2.value$2);
          scheme$2.fields$1.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Scheme$1, declaration$2, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
          return scheme$2
        } else {
          var x$9 = $m_s_None$();
          if ((x$9 === x1$3)) {
            var this$17 = this.ctx$1.eh$1;
            var specification$2 = $m_Lamf_validations_ParserSideValidations$().UnknownSecuritySchemeErrorSpecification$1;
            var node$1 = scheme$2.id$1;
            var message$1 = (("Security scheme '" + name$2) + "' not found in declarations.");
            var ast$2 = this.node$1;
            var prop$2 = $m_s_None$();
            var l$2 = ast$2.location$1;
            $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$17, specification$2, node$1, prop$2, message$1, l$2);
            return scheme$2
          } else {
            throw new $c_s_MatchError().init___O(x1$3)
          }
        }
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlParametrizedSecuritySchemeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlParametrizedSecuritySchemeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlParametrizedSecuritySchemeParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser() {
  $c_O.call(this);
  this.node$1 = null;
  this.producer$1 = null;
  this.idCounter$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser.prototype.init___Lorg_yaml_model_YNode__F1__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(node, producer, idCounter, ctx) {
  this.node$1 = node;
  this.producer$1 = producer;
  this.idCounter$1 = idCounter;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser.prototype.productPrefix__T = (function() {
  return "RamlSecurityRequirementParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser.prototype.parse__Lamf_plugins_domain_webapi_models_security_SecurityRequirement = (function() {
  var this$1 = $as_Lamf_core_model_domain_AmfElement(this.producer$1.apply__O__O(this.idCounter$1.genId__T__T("default-requirement")));
  var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.node$1);
  var requirement = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$1, other));
  new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeParser().init___Lorg_yaml_model_YNode__F1__Lamf_plugins_document_webapi_contexts_WebApiContext(this.node$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, requirement$1) {
    return (function(name$2) {
      var name = $as_T(name$2);
      return requirement$1.withScheme__T__Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme(name)
    })
  })(this, requirement)), this.ctx$1).parse__Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme();
  return requirement
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser)) {
    var RamlSecurityRequirementParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser(x$1);
    var this$1 = this.node$1;
    var b = RamlSecurityRequirementParser$1.node$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.producer$1;
      var x$2 = RamlSecurityRequirementParser$1.producer$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.idCounter$1;
      var x$4 = RamlSecurityRequirementParser$1.idCounter$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.node$1;
      break
    }
    case 1: {
      return this.producer$1;
      break
    }
    case 2: {
      return this.idCounter$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlSecurityRequirementParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlSecurityRequirementParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlSecurityRequirementParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter() {
  $c_O.call(this);
  this.f$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter.prototype.productPrefix__T = (function() {
  return "RamlServersEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter)) {
    var RamlServersEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter(x$1);
    var x = this.f$1;
    var x$2 = RamlServersEmitter$1.f$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlServersEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = RamlServersEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.f$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter.prototype.defaultServer__p1__Lamf_plugins_domain_webapi_models_Server__scm_ListBuffer__s_Option = (function($default, result) {
  var fs = $default.fields$1;
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Url$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("baseUri", f, $m_s_None$(), this.spec$1)))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Description$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter(new $c_Lamf_core_utils_package$AmfStrings().init___T("serverDescription").asRamlAnnotation__T(), f$3, $m_s_None$(), this.spec$1)))
  };
  var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Variables$1);
  if (this$6.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1$2 = this$6.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    return new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("baseUriParameters", f$4, this.ordering$1, this.references$1, this.spec$1)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter.prototype.emitters__sc_Seq = (function() {
  var servers = $m_Lamf_plugins_document_webapi_parser_spec_domain_Servers$().apply__Lamf_core_parser_FieldEntry__Lamf_plugins_document_webapi_parser_spec_domain_Servers(this.f$1);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var rc6 = false;
  var x3 = null;
  var x1 = servers.default$1;
  matchEnd7: {
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var server = $as_Lamf_plugins_domain_webapi_models_Server(x2.value$2);
      this.defaultServer__p1__Lamf_plugins_domain_webapi_models_Server__scm_ListBuffer__s_Option(server, result);
      this.asExtension__p1__sc_Seq__scm_ListBuffer__O(servers.servers$1, result);
      break matchEnd7
    };
    var x = $m_s_None$();
    if ((x === x1)) {
      rc6 = true;
      x3 = x1;
      if (servers.servers$1.nonEmpty__Z()) {
        this.defaultServer__p1__Lamf_plugins_domain_webapi_models_Server__scm_ListBuffer__s_Option($as_Lamf_plugins_domain_webapi_models_Server(servers.servers$1.head__O()), result);
        this.asExtension__p1__sc_Seq__scm_ListBuffer__O($as_sc_Seq(servers.servers$1.tail__O()), result);
        break matchEnd7
      }
    };
    if (rc6) {
      break matchEnd7
    };
    throw new $c_s_MatchError().init___O(x1)
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(f, ordering, references, spec) {
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter.prototype.asExtension__p1__sc_Seq__scm_ListBuffer__O = (function(servers, result) {
  return (servers.nonEmpty__Z() ? result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(new $c_Lamf_core_utils_package$AmfStrings().init___T("servers").asRamlAnnotation__T(), servers, this.ordering$1, this.spec$1)) : (void 0))
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlServersEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlServersEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlServersEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser() {
  $c_O.call(this);
  this.key$1 = null;
  this.map$1 = null;
  this.producer$1 = null;
  this.options$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser.prototype.productPrefix__T = (function() {
  return "RamlSingleExampleParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser)) {
    var RamlSingleExampleParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser(x$1);
    if ((this.key$1 === RamlSingleExampleParser$1.key$1)) {
      var this$1 = this.map$1;
      var b = RamlSingleExampleParser$1.map$1;
      var jsx$2 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x = this.producer$1;
      var x$2 = RamlSingleExampleParser$1.producer$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.options$1;
      var x$4 = RamlSingleExampleParser$1.options$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.map$1;
      break
    }
    case 2: {
      return this.producer$1;
      break
    }
    case 3: {
      return this.options$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser.prototype.parse__s_Option = (function() {
  var newProducer = new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
    return (function() {
      return $as_Lamf_plugins_domain_shapes_models_Example($this.producer$1.apply__O__O($m_s_None$()))
    })
  })(this));
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(this.key$1);
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var x1 = this.ctx$1.link__Lorg_yaml_model_YNode__s_util_Either(entry.value$2);
    if ((x1 instanceof $c_s_util_Left)) {
      var x2 = $as_s_util_Left(x1);
      var s = $as_T(x2.value$2);
      var this$4 = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations().findNamedExample__T__s_Option__s_Option(s, new $c_s_Some().init___O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, s$1, entry$1) {
        return (function(errMsg$2) {
          var errMsg = $as_T(errMsg$2);
          var this$3 = $this$1.ctx$1.eh$1;
          var specification = $m_Lamf_validations_ParserSideValidations$().InvalidFragmentType$1;
          var ast = entry$1.value$2;
          var prop = $m_s_None$();
          var l = ast.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$3, specification, s$1, prop, errMsg, l)
        })
      })(this, s, entry))));
      if (this$4.isEmpty__Z()) {
        return $m_s_None$()
      } else {
        var arg1$1 = this$4.get__O();
        var e = $as_Lamf_plugins_domain_shapes_models_Example(arg1$1);
        $m_Lamf_core_parser_Annotations$();
        var annotations = new $c_Lamf_core_parser_Annotations().init___();
        return new $c_s_Some().init___O($as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(e, s, annotations)))
      }
    } else {
      if ((!(x1 instanceof $c_s_util_Right))) {
        throw new $c_s_MatchError().init___O(x1)
      };
      var x3 = $as_s_util_Right(x1);
      var node = $as_Lorg_yaml_model_YNode(x3.value$2);
      var x1$2 = node.tag__Lorg_yaml_model_YTag().tagType$3;
      var x = $m_Lorg_yaml_model_YType$().Map$1;
      if ((x === x1$2)) {
        return $m_s_Option$().apply__O__s_Option(new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser().init___Lorg_yaml_model_YMapEntry__F0__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext(entry, newProducer, this.options$1, this.ctx$1).parse__Lamf_plugins_domain_shapes_models_Example())
      } else {
        var x$3 = $m_Lorg_yaml_model_YType$().Null$1;
        if ((x$3 === x1$2)) {
          return $m_s_None$()
        } else {
          var jsx$1 = $m_s_Option$();
          var this$6 = $as_Lamf_core_model_domain_AmfElement(newProducer.apply__O());
          var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
          return jsx$1.apply__O__s_Option(new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser().init___Lorg_yaml_model_YNode__Lamf_plugins_domain_shapes_models_Example__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext(node, $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$6, other)), this.options$1, this.ctx$1).parse__Lamf_plugins_domain_shapes_models_Example())
        }
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser.prototype.init___T__Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(key, map, producer, options, ctx) {
  this.key$1 = key;
  this.map$1 = map;
  this.producer$1 = producer;
  this.options$1 = options;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlSingleExampleParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlSingleExampleParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlSingleExampleParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Servers() {
  $c_O.call(this);
  this.default$1 = null;
  this.servers$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Servers.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Servers.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Servers;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Servers() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Servers.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Servers.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Servers.prototype.productPrefix__T = (function() {
  return "Servers"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Servers.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Servers.prototype.init___s_Option__sc_Seq = (function($default, servers) {
  this.default$1 = $default;
  this.servers$1 = servers;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Servers.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Servers)) {
    var Servers$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Servers(x$1);
    var x = this.default$1;
    var x$2 = Servers$1.default$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.servers$1;
      var x$4 = Servers$1.servers$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Servers.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.default$1;
      break
    }
    case 1: {
      return this.servers$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Servers.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Servers.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Servers.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Servers(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Servers) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Servers"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Servers(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Servers)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Servers(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Servers(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Servers;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Servers = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Servers: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Servers", {
  Lamf_plugins_document_webapi_parser_spec_domain_Servers: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Servers.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Servers;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser() {
  $c_O.call(this);
  this.seq$1 = null;
  this.parentId$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser.prototype.productPrefix__T = (function() {
  return "StringTagsParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser)) {
    var StringTagsParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser(x$1);
    var this$1 = this.seq$1;
    var b = StringTagsParser$1.seq$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      return (this.parentId$1 === StringTagsParser$1.parentId$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.seq$1;
      break
    }
    case 1: {
      return this.parentId$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser.prototype.parse__sc_Seq = (function() {
  var tags = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  this.seq$1.nodes$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, tags$1) {
    return (function(node$2) {
      var node = $as_Lorg_yaml_model_YNode(node$2);
      var x1 = node.value__Lorg_yaml_model_YValue();
      if ((x1 instanceof $c_Lorg_yaml_model_YScalar)) {
        var x2 = $as_Lorg_yaml_model_YScalar(x1);
        var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(x2);
        var qual$1 = new $c_Lamf_plugins_domain_webapi_models_Tag().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
        var x$1 = x2.text$3;
        $m_Lamf_core_parser_Annotations$();
        var x$2 = new $c_Lamf_core_parser_Annotations().init___();
        var tag = $as_Lamf_plugins_domain_webapi_models_Tag($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, x$1, x$2));
        var parent = $this.parentId$1;
        $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(tag, parent);
        return tags$1.$$plus$eq__O__scm_ListBuffer(tag)
      } else {
        var this$4 = $this.ctx$1.eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().InvalidTagType$1;
        var node$1 = $this.parentId$1;
        var prop = $m_s_None$();
        var l = node.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$4, specification, node$1, prop, "Tag value must be of type string", l);
        return (void 0)
      }
    })
  })(this, tags)));
  return tags
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser.prototype.init___Lorg_yaml_model_YSequence__T__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(seq, parentId, ctx) {
  this.seq$1 = seq;
  this.parentId$1 = parentId;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.StringTagsParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.StringTagsParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.StringTagsParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.adopt$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser.prototype.productPrefix__T = (function() {
  return "Oas20RequestParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser)) {
    var Oas20RequestParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser(x$1);
    var this$1 = this.map$1;
    var b = Oas20RequestParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.adopt$1;
      var x$2 = Oas20RequestParser$1.adopt$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.adopt$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser.prototype.parse__s_Option = (function() {
  var request = new $c_Lamf_core_utils_Lazy().init___F0(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
    return (function() {
      var this$1 = $m_Lamf_plugins_domain_webapi_models_Request$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_Request($this.map$1);
      var annotation = new $c_Lamf_core_annotations_VirtualObject().init___();
      var req = $as_Lamf_plugins_domain_webapi_models_Request($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$1, annotation));
      $this.adopt$1.apply__O__O(req);
      return req
    })
  })(this)));
  var elem = new $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters().init___sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq($m_sci_Nil$(), $m_sci_Nil$(), $m_sci_Nil$(), $m_sci_Nil$(), $m_sci_Nil$(), $m_sci_Nil$());
  var elem$1 = null;
  elem$1 = elem;
  var elem$2 = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var elem$1$1 = null;
  elem$1$1 = elem$2;
  var map = this.map$1;
  var this$11 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("parameters");
  if ((!this$11.isEmpty__Z())) {
    var arg1 = this$11.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    $as_scm_ListBuffer(elem$1$1).$$plus$eq__O__scm_ListBuffer(entry);
    var jsx$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Parameters(elem$1);
    var this$12 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var iv = this.ctx$1;
    elem$1 = jsx$1.add__Lamf_plugins_document_webapi_parser_spec_domain_Parameters__Lamf_plugins_document_webapi_parser_spec_domain_Parameters(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser().init___sc_Seq__T__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($as_sc_Seq($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$12, conversion, iv)), $as_Lamf_core_model_domain_AmfObject(request.getOrCreate__O()).id__T(), this.ctx$1).parse__Z__Lamf_plugins_document_webapi_parser_spec_domain_Parameters(true))
  };
  var map$1 = this.map$1;
  var this$15 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("queryParameters").asOasExtension__T());
  if ((!this$15.isEmpty__Z())) {
    var arg1$1 = this$15.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    $as_scm_ListBuffer(elem$1$1).$$plus$eq__O__scm_ListBuffer(entry$3);
    var this$16 = entry$3.value$2;
    var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$1 = this.ctx$1;
    var jsx$3 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser().init___Lorg_yaml_model_YMap__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$16, conversion$1, iv$1)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, request$1) {
      return (function(p$2) {
        var p = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2);
        var parent = $as_Lamf_core_model_domain_AmfObject(request$1.getOrCreate__O()).id__T();
        $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(p, parent)
      })
    })(this, request)), false, $m_Lamf_plugins_document_webapi_parser_spec_package$().toRaml__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this.ctx$1)).parse__sc_Seq();
    var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(x$1$2) {
        var x$1 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$1$2);
        var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
        return $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x$1, field, "query"))
      })
    })(this));
    var this$17 = $m_sc_Seq$();
    var queryParameters = $as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$17.ReusableCBFInstance$2));
    elem$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Parameters(elem$1).add__Lamf_plugins_document_webapi_parser_spec_domain_Parameters__Lamf_plugins_document_webapi_parser_spec_domain_Parameters(new $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters().init___sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq(queryParameters, $m_sci_Nil$(), $m_sci_Nil$(), $m_sci_Nil$(), $m_sci_Nil$(), $m_sci_Nil$()))
  };
  var map$2 = this.map$1;
  var this$25 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2).key__T__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("headers").asOasExtension__T());
  if ((!this$25.isEmpty__Z())) {
    var arg1$2 = this$25.get__O();
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    $as_scm_ListBuffer(elem$1$1).$$plus$eq__O__scm_ListBuffer(entry$4);
    var this$26 = entry$4.value$2;
    var conversion$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$2 = this.ctx$1;
    var jsx$5 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser().init___Lorg_yaml_model_YMap__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$26, conversion$2, iv$2)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, request$1$1) {
      return (function(p$2$1) {
        var p$1 = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2$1);
        var parent$1 = $as_Lamf_core_model_domain_AmfObject(request$1$1.getOrCreate__O()).id__T();
        $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(p$1, parent$1)
      })
    })(this, request)), false, $m_Lamf_plugins_document_webapi_parser_spec_package$().toRaml__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this.ctx$1)).parse__sc_Seq();
    var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$2) {
      return (function(x$2$2) {
        var x$2 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$2$2);
        var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
        return $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x$2, field$1, "header"))
      })
    })(this));
    var this$27 = $m_sc_Seq$();
    var headers = $as_sc_Seq(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$4, this$27.ReusableCBFInstance$2));
    var jsx$6 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Parameters(elem$1);
    var x$2$3 = $m_sci_Nil$();
    var x$3 = $m_sci_Nil$();
    var x$4 = $m_sci_Nil$();
    var x$5 = $m_sci_Nil$();
    var x$6 = $m_sci_Nil$();
    elem$1 = jsx$6.add__Lamf_plugins_document_webapi_parser_spec_domain_Parameters__Lamf_plugins_document_webapi_parser_spec_domain_Parameters(new $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters().init___sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq(x$2$3, x$3, headers, x$4, x$5, x$6))
  };
  var map$3 = this.map$1;
  var this$35 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("baseUriParameters").asOasExtension__T();
  var this$36 = this$35.key__T__s_Option(keyword);
  if ((!this$36.isEmpty__Z())) {
    var arg1$3 = this$36.get__O();
    var entry$5 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
    var this$37 = entry$5.value$2;
    var conversion$3 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$3 = this.ctx$1;
    var this$38 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$37, conversion$3, iv$3)).entries$3.headOption__s_Option();
    if ((!this$38.isEmpty__Z())) {
      var arg1$4 = this$38.get__O();
      var paramEntry = $as_Lorg_yaml_model_YMapEntry(arg1$4);
      var this$39 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser().init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(paramEntry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, request$1$2) {
        return (function(p$2$2) {
          var p$3 = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2$2);
          var parent$2 = $as_Lamf_core_model_domain_AmfObject(request$1$2.getOrCreate__O()).id__T();
          $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
          $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(p$3, parent$2)
        })
      })(this, request)), false, $m_Lamf_plugins_document_webapi_parser_spec_package$().toRaml__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this.ctx$1)).parse__Lamf_plugins_domain_webapi_models_Parameter();
      var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
      var parameter = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$39, field$2, "path"));
      var jsx$8 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Parameters(elem$1);
      var jsx$7 = $m_sc_Seq$();
      var array = [parameter];
      var x$7 = $as_sc_Seq(jsx$7.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
      var x$8 = $m_sci_Nil$();
      var x$9 = $m_sci_Nil$();
      var x$10 = $m_sci_Nil$();
      var x$11 = $m_sci_Nil$();
      var x$12 = $m_sci_Nil$();
      elem$1 = jsx$8.add__Lamf_plugins_document_webapi_parser_spec_domain_Parameters__Lamf_plugins_document_webapi_parser_spec_domain_Parameters(new $c_Lamf_plugins_document_webapi_parser_spec_domain_Parameters().init___sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq(x$8, x$9, x$10, x$11, x$7, x$12))
    }
  };
  var x1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Parameters(elem$1);
  if ((x1 !== null)) {
    var query = x1.query$1;
    var path = x1.path$1;
    var header = x1.header$1;
    var baseUri08 = x1.baseUri08$1;
    if (query.nonEmpty__Z()) {
      var this$49 = $as_Lamf_core_model_domain_AmfObject(request.getOrCreate__O());
      var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryParameters$1;
      var jsx$9 = $m_Lamf_core_parser_Annotations$();
      var this$47 = $as_scm_ListBuffer(elem$1$1);
      var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(query, jsx$9.apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations($as_Lorg_yaml_model_YPart(this$47.scala$collection$mutable$ListBuffer$$start$6.head__O())));
      var jsx$10 = $m_Lamf_core_parser_Annotations$();
      var this$48 = $as_scm_ListBuffer(elem$1$1);
      var annotations = jsx$10.apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations($as_Lorg_yaml_model_YPart(this$48.scala$collection$mutable$ListBuffer$$start$6.head__O()));
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$49, field$3, value, annotations)
    };
    if (header.nonEmpty__Z()) {
      var this$52 = $as_Lamf_core_model_domain_AmfObject(request.getOrCreate__O());
      var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Headers$1;
      var jsx$11 = $m_Lamf_core_parser_Annotations$();
      var this$50 = $as_scm_ListBuffer(elem$1$1);
      var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(header, jsx$11.apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations($as_Lorg_yaml_model_YPart(this$50.scala$collection$mutable$ListBuffer$$start$6.head__O())));
      var jsx$12 = $m_Lamf_core_parser_Annotations$();
      var this$51 = $as_scm_ListBuffer(elem$1$1);
      var annotations$1 = jsx$12.apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations($as_Lorg_yaml_model_YPart(this$51.scala$collection$mutable$ListBuffer$$start$6.head__O()));
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$52, field$4, value$1, annotations$1)
    };
    if ((path.nonEmpty__Z() || baseUri08.nonEmpty__Z())) {
      var this$56 = $as_Lamf_core_model_domain_AmfObject(request.getOrCreate__O());
      var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().UriParameters$1;
      var this$53 = $m_sc_Seq$();
      var jsx$14 = $as_sc_Seq(path.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(baseUri08, this$53.ReusableCBFInstance$2));
      var jsx$13 = $m_Lamf_core_parser_Annotations$();
      var this$54 = $as_scm_ListBuffer(elem$1$1);
      var value$2 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(jsx$14, jsx$13.apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations($as_Lorg_yaml_model_YPart(this$54.scala$collection$mutable$ListBuffer$$start$6.head__O())));
      var jsx$15 = $m_Lamf_core_parser_Annotations$();
      var this$55 = $as_scm_ListBuffer(elem$1$1);
      var annotations$2 = jsx$15.apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations($as_Lorg_yaml_model_YPart(this$55.scala$collection$mutable$ListBuffer$$start$6.head__O()));
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$56, field$5, value$2, annotations$2)
    }
  } else {
    throw new $c_s_MatchError().init___O(x1)
  };
  var payloads = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $as_Lamf_plugins_document_webapi_parser_spec_domain_Parameters(elem$1).body$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1, payloads$1) {
    return (function(x$3$2) {
      var x$3$1 = $as_Lamf_plugins_domain_webapi_models_Payload(x$3$2);
      return payloads$1.$$plus$eq__O__scm_ListBuffer(x$3$1)
    })
  })(this, payloads)));
  var map$4 = this.map$1;
  var this$59 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$4);
  var keyword$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T("requestPayloads").asOasExtension__T();
  var this$60 = this$59.key__T__s_Option(keyword$1);
  if ((!this$60.isEmpty__Z())) {
    var arg1$5 = this$60.get__O();
    var entry$6 = $as_Lorg_yaml_model_YMapEntry(arg1$5);
    $as_scm_ListBuffer(elem$1$1).$$plus$eq__O__scm_ListBuffer(entry$6);
    var this$61 = entry$6.value$2;
    var conversion$4 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var iv$4 = this.ctx$1;
    var jsx$17 = $as_sc_TraversableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$61, conversion$4, iv$4));
    var jsx$16 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$4, payloads$1$1, request$1$3) {
      return (function(value$2$1) {
        var value$3 = $as_Lorg_yaml_model_YNode(value$2$1);
        var eta$0$1 = $as_Lamf_plugins_domain_webapi_models_Request(request$1$3.getOrCreate__O());
        return payloads$1$1.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser().init___Lorg_yaml_model_YNode__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(value$3, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$5, eta$0$1$1) {
          return (function(mediaType$2) {
            var mediaType = $as_s_Option(mediaType$2);
            return eta$0$1$1.withPayload__s_Option__Lamf_plugins_domain_webapi_models_Payload(mediaType)
          })
        })($this$4, eta$0$1)), $this$4.ctx$1).parse__Lamf_plugins_domain_webapi_models_Payload())
      })
    })(this, payloads, request));
    var this$62 = $m_sc_Seq$();
    jsx$17.map__F1__scg_CanBuildFrom__O(jsx$16, this$62.ReusableCBFInstance$2)
  };
  if (payloads.nonEmpty__Z()) {
    var this$65 = $as_Lamf_core_model_domain_AmfObject(request.getOrCreate__O());
    var field$6 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Payloads$1;
    var jsx$18 = $m_Lamf_core_parser_Annotations$();
    var this$63 = $as_scm_ListBuffer(elem$1$1);
    var value$4 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(payloads, jsx$18.apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations($as_Lorg_yaml_model_YMapEntry(this$63.scala$collection$mutable$ListBuffer$$start$6.head__O()).value$2));
    var jsx$19 = $m_Lamf_core_parser_Annotations$();
    var this$64 = $as_scm_ListBuffer(elem$1$1);
    var annotations$3 = jsx$19.apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations($as_Lorg_yaml_model_YPart(this$64.scala$collection$mutable$ListBuffer$$start$6.head__O()));
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$65, field$6, value$4, annotations$3)
  };
  var map$5 = this.map$1;
  var this$68 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$5);
  var keyword$2 = new $c_Lamf_core_utils_package$AmfStrings().init___T("queryString").asOasExtension__T();
  var this$69 = this$68.key__T__s_Option(keyword$2);
  if ((!this$69.isEmpty__Z())) {
    var arg1$6 = this$69.get__O();
    var queryEntry = $as_Lorg_yaml_model_YMapEntry(arg1$6);
    var this$72 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(queryEntry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$6, request$1$4) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        shape.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject($as_Lamf_core_model_domain_AmfObject(request$1$4.getOrCreate__O()).id__T(), shape.adopted$default$2__sc_Seq())
      })
    })(this, request)), new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo().init___Z__Z(false, false), $m_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$(), $m_Lamf_plugins_document_webapi_parser_spec_package$().toRaml__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this.ctx$1)).parse__s_Option();
    if ((!this$72.isEmpty__Z())) {
      var arg1$7 = this$72.get__O();
      var s = $as_Lamf_core_model_domain_Shape(arg1$7);
      var this$74 = $as_Lamf_plugins_domain_webapi_models_Request(request.getOrCreate__O());
      var queryString = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(s, $as_Lamf_core_model_domain_AmfObject(request.getOrCreate__O()).id__T(), $m_s_None$());
      var field$7 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryString$1;
      new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_Request($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$74, field$7, queryString)))
    }
  };
  return request.value$1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser.prototype.init___Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(map, adopt, ctx) {
  this.map$1 = map;
  this.adopt$1 = adopt;
  this.ctx$1 = ctx;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.Oas20RequestParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.Oas20RequestParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.Oas20RequestParser", {
  Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.adopt$1 = null;
  this.name$1 = null;
  this.rootEntry$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser.prototype.productPrefix__T = (function() {
  return "Oas30CallbackParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser)) {
    var Oas30CallbackParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser(x$1);
    var this$1 = this.map$1;
    var b = Oas30CallbackParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.adopt$1;
      var x$2 = Oas30CallbackParser$1.adopt$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if ((jsx$1 && (this.name$1 === Oas30CallbackParser$1.name$1))) {
      var x$3 = this.rootEntry$1;
      var x$4 = Oas30CallbackParser$1.rootEntry$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.adopt$1;
      break
    }
    case 2: {
      return this.name$1;
      break
    }
    case 3: {
      return this.rootEntry$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser.prototype.parse__sci_List = (function() {
  var jsx$1 = this.ctx$1;
  $m_Lorg_yaml_model_YNode$();
  var map = this.map$1;
  $m_Lorg_yaml_model_YNode$();
  var x1 = jsx$1.link__Lorg_yaml_model_YNode__s_util_Either($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1));
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var fullRef = $as_T(x2.value$2);
    var label = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().stripOas3ComponentsPrefix__T__T__T(fullRef, "callbacks");
    var this$3 = this.ctx$1.declarations$4;
    var this$4 = this$3.callbacks$2.get__O__s_Option(label);
    if (this$4.isEmpty__Z()) {
      var this$6 = $m_s_None$()
    } else {
      var arg1 = this$4.get__O();
      var callbacks = $as_sci_List(arg1);
      var f = (function($this, label$1) {
        return (function(callback$2) {
          var callback = $as_Lamf_plugins_domain_webapi_models_Callback(callback$2);
          var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations($this.map$1);
          var linkCallback = $as_Lamf_plugins_domain_webapi_models_Callback($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(callback, label$1, annotations));
          $this.adopt$1.apply__O__O(linkCallback);
          return linkCallback
        })
      })(this, label);
      var this$5 = $m_sci_List$();
      var bf = this$5.ReusableCBFInstance$2;
      if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
        if ((callbacks === $m_sci_Nil$())) {
          var jsx$2 = $m_sci_Nil$()
        } else {
          var arg1$1 = callbacks.head__O();
          var h = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$1), $m_sci_Nil$());
          var t = h;
          var rest = $as_sci_List(callbacks.tail__O());
          while ((rest !== $m_sci_Nil$())) {
            var arg1$2 = rest.head__O();
            var nx = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$2), $m_sci_Nil$());
            t.tl$5 = nx;
            t = nx;
            rest = $as_sci_List(rest.tail__O())
          };
          var jsx$2 = h
        }
      } else {
        var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(callbacks, bf);
        var these = callbacks;
        while ((!these.isEmpty__Z())) {
          var arg1$3 = these.head__O();
          b.$$plus$eq__O__scm_Builder(f(arg1$3));
          these = $as_sci_List(these.tail__O())
        };
        var jsx$2 = b.result__O()
      };
      var this$6 = new $c_s_Some().init___O($as_sci_List(jsx$2))
    };
    if (this$6.isEmpty__Z()) {
      var x1$1 = this.ctx$1.navigateToRemoteYNode__T__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__s_Option(fullRef, this.ctx$1);
      if ((x1$1 instanceof $c_s_Some)) {
        var x2$1 = $as_s_Some(x1$1);
        var navigation = $as_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation(x2$1.value$2);
        var this$7 = navigation.remoteNode$1;
        var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv = this.ctx$1;
        var jsx$3 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser().init___Lorg_yaml_model_YMap__F1__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$7, conversion, iv)), this.adopt$1, this.name$1, this.rootEntry$1, $as_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(navigation.context$1)).parse__sci_List()
      } else {
        var x = $m_s_None$();
        if ((!(x === x1$1))) {
          throw new $c_s_MatchError().init___O(x1$1)
        };
        var this$8 = this.ctx$1.eh$1;
        var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnresolvedReference$1;
        var message = ("Cannot find callback reference " + fullRef);
        var ast = this.map$1;
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$8, specification, "", prop, message, l);
        var this$9 = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCallback().init___T__Lorg_yaml_model_YPart(label, this.map$1);
        var label$2 = this.name$1;
        var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.rootEntry$1);
        var callback$1 = $as_Lamf_plugins_domain_webapi_models_Callback($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this$9, label$2, annotations$1));
        this.adopt$1.apply__O__O(callback$1);
        $m_sci_List$();
        var array = [callback$1];
        var i = (((-1) + $uI(array.length)) | 0);
        var result = $m_sci_Nil$();
        while ((i >= 0)) {
          var this$13 = result;
          var index = i;
          var x$1 = array[index];
          result = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$13);
          i = (((-1) + i) | 0)
        };
        var jsx$3 = result
      }
    } else {
      var jsx$3 = this$6.get__O()
    };
    return $as_sci_List(jsx$3)
  } else if ((x1 instanceof $c_s_util_Right)) {
    var callbackEntries = this.map$1.entries$3;
    var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
      return (function(entry$2) {
        var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
        var this$14 = entry.key$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
        var iv$1 = this$3$1.ctx$1;
        var expression = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$14, conversion$1, iv$1)).text$3;
        $m_Lamf_core_parser_Annotations$();
        var annotations$2 = new $c_Lamf_core_parser_Annotations().init___();
        var this$18 = new $c_Lamf_plugins_domain_webapi_models_Callback().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$2);
        var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
        var callback$3 = $as_Lamf_plugins_domain_webapi_models_Callback($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$18, other));
        callback$3.fields$1.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$().Expression$1, new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(expression, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.key$2)), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
        this$3$1.adopt$1.apply__O__O(callback$3);
        var collected = this$3$1.ctx$1.factory__Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory().endPointParser__Lorg_yaml_model_YMapEntry__F1__sci_List__Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, callback$4) {
          return (function(path$2) {
            var path = $as_T(path$2);
            return callback$4.withEndpoint__T__Lamf_plugins_domain_webapi_models_EndPoint(path)
          })
        })(this$3$1, callback$3)), $m_sci_Nil$()).parse__s_Option();
        if ((!collected.isEmpty__Z())) {
          var arg1$4 = collected.get__O();
          var x$1$1 = $as_Lamf_plugins_domain_webapi_models_EndPoint(arg1$4);
          var path$1 = ("/" + expression);
          var field = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1;
          $as_Lamf_plugins_domain_webapi_models_EndPoint($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x$1$1, field, path$1))
        };
        return callback$3
      })
    })(this));
    var this$21 = $m_sc_IndexedSeq$();
    return $as_sc_TraversableOnce(callbackEntries.map__F1__scg_CanBuildFrom__O(jsx$4, this$21.ReusableCBF$6)).toList__sci_List()
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser.prototype.init___Lorg_yaml_model_YMap__F1__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(map, adopt, name, rootEntry, ctx) {
  this.map$1 = map;
  this.adopt$1 = adopt;
  this.name$1 = name;
  this.rootEntry$1 = rootEntry;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.Oas30CallbackParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.Oas30CallbackParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.Oas30CallbackParser", {
  Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.producer$1 = null;
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser.prototype.productPrefix__T = (function() {
  return "Oas30ParametersParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser)) {
    var Oas30ParametersParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser(x$1);
    var this$1 = this.map$1;
    var b = Oas30ParametersParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.producer$1;
      var x$2 = Oas30ParametersParser$1.producer$1;
      return (x === x$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.producer$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser.prototype.init___Lorg_yaml_model_YMap__F0__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(map, producer, ctx) {
  this.map$1 = map;
  this.producer$1 = producer;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser.prototype.parseParameters__V = (function() {
  var request = new $c_Lamf_core_utils_Lazy().init___F0(this.producer$1);
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("parameters");
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$3 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var iv = this.ctx$1;
    var parameters = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersParser().init___sc_Seq__T__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($as_sc_Seq($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv)), $as_Lamf_core_model_domain_AmfObject(request.getOrCreate__O()).id__T(), this.ctx$1).parse__Z__Lamf_plugins_document_webapi_parser_spec_domain_Parameters(true);
    if ((parameters !== null)) {
      var query = parameters.query$1;
      var path = parameters.path$1;
      var header = parameters.header$1;
      var cookie = parameters.cookie$1;
      var baseUri08 = parameters.baseUri08$1;
      if (query.nonEmpty__Z()) {
        var this$4 = $as_Lamf_core_model_domain_AmfObject(request.getOrCreate__O());
        var field = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryParameters$1;
        var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(query, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry));
        var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$4, field, value, annotations)
      };
      if (header.nonEmpty__Z()) {
        var this$5 = $as_Lamf_core_model_domain_AmfObject(request.getOrCreate__O());
        var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Headers$1;
        var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(header, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry));
        var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$5, field$1, value$1, annotations$1)
      };
      if ((path.nonEmpty__Z() || baseUri08.nonEmpty__Z())) {
        var this$7 = $as_Lamf_core_model_domain_AmfObject(request.getOrCreate__O());
        var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().UriParameters$1;
        var this$6 = $m_sc_Seq$();
        var value$2 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(path.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(baseUri08, this$6.ReusableCBFInstance$2)), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry));
        var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$7, field$2, value$2, annotations$2)
      };
      if (cookie.nonEmpty__Z()) {
        var this$8 = $as_Lamf_core_model_domain_AmfObject(request.getOrCreate__O());
        var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().CookieParameters$1;
        var value$3 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(cookie, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry));
        var annotations$3 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$8, field$3, value$3, annotations$3)
      }
    } else {
      throw new $c_s_MatchError().init___O(parameters)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.Oas30ParametersParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.Oas30ParametersParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.Oas30ParametersParser", {
  Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter() {
  $c_O.call(this);
  this.api$1 = null;
  this.ordering$1 = null;
  this.vendor$1 = null;
  this.references$1 = null;
  this.emitters$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter.prototype.productPrefix__T = (function() {
  return "WebApiEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var WebApiEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter(x$1);
    var x = this.api$1;
    var x$2 = WebApiEmitter$1.api$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = WebApiEmitter$1.ordering$1;
      var jsx$2 = (x$3 === x$4)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.vendor$1;
      var x$6 = WebApiEmitter$1.vendor$1;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.references$1;
      var x$8 = WebApiEmitter$1.references$1;
      return ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.api$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.vendor$1;
      break
    }
    case 3: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter__Lamf_plugins_domain_webapi_models_WebApi__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq = (function($$outer, api, ordering, vendor, references) {
  this.api$1 = api;
  this.ordering$1 = ordering;
  this.vendor$1 = vendor;
  this.references$1 = references;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  var fs = api.fields$1;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter().init___Lamf_core_parser_Fields__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(fs, ordering, $$outer.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext()));
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Servers$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(this.$$outer$1.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext().factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory().serversEmitter__Lamf_plugins_domain_webapi_models_WebApi__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter(this.api$1, f, this.ordering$1, this.references$1).emitters__sc_Seq()))
  };
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Accepts$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1$1 = this$2.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType("consumes", f$3, this.ordering$1, true, $m_Lorg_yaml_model_YType$().Str$1)))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().ContentType$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$2 = this$4.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType("produces", f$4, this.ordering$1, true, $m_Lorg_yaml_model_YType$().Str$1)))
  };
  var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Schemes$1);
  if ((!this$6.isEmpty__Z())) {
    var arg1$3 = this$6.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType("schemes", f$5, this.ordering$1, false, $m_Lorg_yaml_model_YType$().Str$1)))
  };
  var this$8 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Tags$1);
  if ((!this$8.isEmpty__Z())) {
    var arg1$4 = this$8.get__O();
    var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("tags", $as_Lamf_core_model_domain_AmfArray(f$6.value$1.value$1).values$1, this.ordering$1, this.$$outer$1.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext())))
  };
  var this$9 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Documentations$1);
  if ((!this$9.isEmpty__Z())) {
    var arg1$5 = this$9.get__O();
    var f$7 = $as_Lamf_core_parser_FieldEntry(arg1$5);
    new $c_s_Some().init___O(result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(f$7, this.ordering$1, this.$$outer$1.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext()).emitters__sc_Seq()))
  };
  var orphanAnnotations = $as_sc_Seq($as_sc_Seq(api.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field())).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$7$1) {
    return (function(x$6$2) {
      var x$6 = $as_Lamf_core_model_domain_extensions_DomainExtension(x$6$2);
      return $as_Lamf_core_model_domain_DataNode(x$6.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)).annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.getClassOf())
    })
  })(this))));
  var this$10 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1);
  if (this$10.isEmpty__Z()) {
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position("paths", new $c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter().init___Lamf_core_parser_Position($m_Lamf_core_parser_Position$ZERO$()), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()))
  } else {
    var arg1$6 = this$10.get__O();
    var f$8 = $as_Lamf_core_parser_FieldEntry(arg1$6);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter__T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq(this.$$outer$1, "paths", f$8, this.ordering$1, this.references$1, orphanAnnotations))
  };
  var this$14 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Security$1);
  if ((!this$14.isEmpty__Z())) {
    var arg1$7 = this$14.get__O();
    var f$9 = $as_Lamf_core_parser_FieldEntry(arg1$7);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("security", f$9, this.ordering$1, this.$$outer$1.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext())))
  };
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(api, ordering, $$outer.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext()).emitters__sc_Seq());
  this.emitters$1 = ordering.sorted__sc_Seq__sc_Seq(result);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasDocumentEmitter$WebApiEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasDocumentEmitter$WebApiEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasDocumentEmitter$WebApiEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$WebApiEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter.call(this);
  this.DocumentationItemFragmentEmitter$module$3 = null;
  this.DataTypeFragmentEmitter$module$3 = null;
  this.AnnotationFragmentEmitter$module$3 = null;
  this.ResourceTypeFragmentEmitter$module$3 = null;
  this.TraitFragmentEmitter$module$3 = null;
  this.SecuritySchemeFragmentEmitter$module$3 = null;
  this.NamedExampleFragmentEmitter$module$3 = null;
  this.OasHeaderEmitter$module$3 = null;
  this.fragment$3 = null;
  this.spec$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter.prototype.init___Lamf_core_model_document_Fragment__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(fragment, spec) {
  this.fragment$3 = fragment;
  this.spec$3 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.call(this, fragment, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter.prototype.emitFragment__Lorg_yaml_model_YDocument = (function() {
  var ordering = $m_Lamf_core_emitter_SpecOrdering$().ordering__Lamf_core_remote_Vendor__Lamf_core_parser_Annotations__Lamf_core_emitter_SpecOrdering($m_Lamf_core_remote_Oas$(), this.fragment$3.annotations__Lamf_core_parser_Annotations());
  var x1 = this.fragment$3;
  if ((x1 instanceof $c_Lamf_plugins_document_webapi_model_DocumentationItemFragment)) {
    var x2 = $as_Lamf_plugins_document_webapi_model_DocumentationItemFragment(x1);
    var typeEmitter = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_model_DocumentationItemFragment__Lamf_core_emitter_SpecOrdering(this, x2, ordering)
  } else if ((x1 instanceof $c_Lamf_plugins_document_webapi_model_DataTypeFragment)) {
    var x3 = $as_Lamf_plugins_document_webapi_model_DataTypeFragment(x1);
    var typeEmitter = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_model_DataTypeFragment__Lamf_core_emitter_SpecOrdering(this, x3, ordering)
  } else if ((x1 instanceof $c_Lamf_plugins_document_webapi_model_ResourceTypeFragment)) {
    var x4 = $as_Lamf_plugins_document_webapi_model_ResourceTypeFragment(x1);
    var typeEmitter = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_model_ResourceTypeFragment__Lamf_core_emitter_SpecOrdering__Lamf_core_errorhandling_ErrorHandler(this, x4, ordering, this.spec$3.eh__Lamf_core_errorhandling_ErrorHandler())
  } else if ((x1 instanceof $c_Lamf_plugins_document_webapi_model_TraitFragment)) {
    var x5 = $as_Lamf_plugins_document_webapi_model_TraitFragment(x1);
    var typeEmitter = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_model_TraitFragment__Lamf_core_emitter_SpecOrdering__Lamf_core_errorhandling_ErrorHandler(this, x5, ordering, this.spec$3.eh__Lamf_core_errorhandling_ErrorHandler())
  } else if ((x1 instanceof $c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment)) {
    var x6 = $as_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment(x1);
    var typeEmitter = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment__Lamf_core_emitter_SpecOrdering(this, x6, ordering)
  } else if ((x1 instanceof $c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment)) {
    var x7 = $as_Lamf_plugins_document_webapi_model_SecuritySchemeFragment(x1);
    var typeEmitter = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_model_SecuritySchemeFragment__Lamf_core_emitter_SpecOrdering(this, x7, ordering)
  } else {
    if ((!(x1 instanceof $c_Lamf_plugins_document_webapi_model_NamedExampleFragment))) {
      throw new $c_jl_UnsupportedOperationException().init___T("Unsupported fragment type")
    };
    var x8 = $as_Lamf_plugins_document_webapi_model_NamedExampleFragment(x1);
    var typeEmitter = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_model_NamedExampleFragment__Lamf_core_emitter_SpecOrdering(this, x8, ordering)
  };
  var references = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_SpecOrdering(this, this.fragment$3, ordering);
  var this$1 = this.fragment$3.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1);
  if (this$1.isEmpty__Z()) {
    var usage = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    var usage = new $c_s_Some().init___O(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("usage").asOasExtension__T(), f, $m_s_None$()))
  };
  var this$5 = $m_Lorg_yaml_model_YDocument$().apply__T__Lorg_yaml_model_YDocument$WithComment("");
  var b = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(this$5.org$yaml$model$YDocument$WithComment$$sourceName$f);
  var x = this$5.comment$1;
  var this$7 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$7)) {
    b.comment__T__V(this$5.comment$1)
  };
  var jsx$8 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$7 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var jsx$6 = $m_sc_Seq$();
  var array = [typeEmitter.header__Lamf_core_emitter_EntryEmitter()];
  var jsx$5 = $as_sc_TraversableLike(jsx$6.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  var jsx$4 = typeEmitter.emitters__sc_Seq();
  var this$11 = $m_sc_Seq$();
  var jsx$3 = $as_sc_TraversableLike(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$11.ReusableCBFInstance$2));
  var jsx$2 = usage.toList__sci_List();
  var this$13 = $m_sc_Seq$();
  var jsx$1 = $as_sc_SeqLike(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$13.ReusableCBFInstance$2));
  var this$14 = $m_sc_Seq$();
  jsx$7.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V($as_sc_Seq(jsx$1.$$colon$plus__O__scg_CanBuildFrom__O(references, this$14.ReusableCBFInstance$2)), b$1);
  jsx$8.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  return new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this$5.org$yaml$model$YDocument$WithComment$$sourceName$f), b.builder$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter.prototype.versionEntry__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  b.updateDynamic__T__Lorg_yaml_model_YNode__V("swagger", $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YScalar$().apply__O__Lorg_yaml_model_YScalar("2.0"), $m_Lorg_yaml_model_YType$().Str$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter.prototype.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function() {
  return this.spec$3
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_BaseSpecEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser.prototype.productPrefix__T = (function() {
  return "AnnotationFragmentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser(x$1).$$outer$1 === this.$$outer$1))) {
    var AnnotationFragmentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser(x$1);
    var this$1 = this.map$1;
    var b = AnnotationFragmentParser$1.map$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser__Lorg_yaml_model_YMap = (function($$outer, map) {
  this.map$1 = map;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser.prototype.parse__Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var x$1 = this.$$outer$1.root$2.location$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var annotation = $as_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
  var property = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser().init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser__Lorg_yaml_model_YPart__T__Lorg_yaml_model_YMap__F1(this.$$outer$1, this.map$1, "annotation", this.map$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(annotation$2$2) {
      var annotation$2 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(annotation$2$2);
      annotation$2.adopted__T__sc_Seq__Lamf_core_model_domain_extensions_CustomDomainProperty(($this.$$outer$1.root$2.location$1 + "#/"), $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())))
    })
  })(this))).parse__Lamf_core_model_domain_extensions_CustomDomainProperty();
  var field = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
  return $as_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(annotation, field, property)))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentParser$AnnotationFragmentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasFragmentParser$AnnotationFragmentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentParser$AnnotationFragmentParser", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser.prototype.productPrefix__T = (function() {
  return "DataTypeFragmentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser(x$1).$$outer$1 === this.$$outer$1))) {
    var DataTypeFragmentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser(x$1);
    var this$1 = this.map$1;
    var b = DataTypeFragmentParser$1.map$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser__Lorg_yaml_model_YMap = (function($$outer, map) {
  this.map$1 = map;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser.prototype.parse__Lamf_plugins_document_webapi_model_DataTypeFragment = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_document_webapi_model_DataTypeFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var x$1 = this.$$outer$1.root$2.location$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var dataType = $as_Lamf_plugins_document_webapi_model_DataTypeFragment($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
  var jsx$2 = $m_Lorg_yaml_model_YMap$();
  var jsx$1 = $as_sc_IndexedSeq(this.map$1.entries$3.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lorg_yaml_model_YMapEntry(x0$1$2);
      if ((x0$1 === null)) {
        return true
      } else {
        var node = x0$1.key$2;
        var iv = $this.$$outer$1.ctx$2;
        var this$5 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
        var key = this$5.text__Lamf_core_model_domain_AmfScalar().toString__T();
        var that = $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$().key$1;
        if ((!(key === that))) {
          var that$1 = $m_Lamf_plugins_document_webapi_parser_OasHeader$().swagger$1;
          return (!(key === that$1))
        } else {
          return false
        }
      }
    })
  })(this))));
  var this$6 = this.map$1;
  var filterMap = jsx$2.apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(jsx$1, this$6.location$1.sourceName$1);
  var jsx$5 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$();
  $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YNode$();
  var jsx$4 = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(filterMap, $m_Lorg_yaml_model_YType$().Map$1);
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(shape$2) {
      var shape = $as_Lamf_core_model_domain_Shape(shape$2);
      var value = (this$2$1.$$outer$1.root$2.location$1 + "#/shape");
      $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(shape, value)
    })
  })(this));
  var eh = this.$$outer$1.ctx$2.eh$1;
  var shapeOption = jsx$5.apply__Lorg_yaml_model_YNode__T__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(jsx$4, "type", jsx$3, new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion().init___T__Lamf_core_errorhandling_ErrorHandler("schema", eh), this.$$outer$1.ctx$2).parse__s_Option();
  if ((!shapeOption.isEmpty__Z())) {
    var arg1 = shapeOption.get__O();
    var x$1$2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1);
    var field = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
    new $c_s_Some().init___O($as_Lamf_plugins_document_webapi_model_DataTypeFragment($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(dataType, field, x$1$2))))
  };
  return dataType
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentParser$DataTypeFragmentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasFragmentParser$DataTypeFragmentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentParser$DataTypeFragmentParser", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser.prototype.productPrefix__T = (function() {
  return "DocumentationItemFragmentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser.prototype.parse__Lamf_plugins_document_webapi_model_DocumentationItemFragment = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_document_webapi_model_DocumentationItemFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var x$1 = (this.$$outer$1.root$2.location$1 + "#/");
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var item = $as_Lamf_plugins_document_webapi_model_DocumentationItemFragment($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
  $m_Lorg_yaml_model_YNode$();
  var map = this.map$1;
  $m_Lorg_yaml_model_YNode$();
  var encoded = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser().init___Lorg_yaml_model_YNode__T__Lamf_plugins_document_webapi_contexts_WebApiContext($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1), item.id$1, this.$$outer$1.ctx$2).parse__Lamf_plugins_domain_shapes_models_CreativeWork();
  var field = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
  $as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(item, field, encoded));
  return item
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser(x$1).$$outer$1 === this.$$outer$1))) {
    var DocumentationItemFragmentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser(x$1);
    var this$1 = this.map$1;
    var b = DocumentationItemFragmentParser$1.map$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser__Lorg_yaml_model_YMap = (function($$outer, map) {
  this.map$1 = map;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentParser$DocumentationItemFragmentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasFragmentParser$DocumentationItemFragmentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentParser$DocumentationItemFragmentParser", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser.prototype.productPrefix__T = (function() {
  return "NamedExampleFragmentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser(x$1).$$outer$1 === this.$$outer$1))) {
    var NamedExampleFragmentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser(x$1);
    var this$1 = this.map$1;
    var b = NamedExampleFragmentParser$1.map$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser__Lorg_yaml_model_YMap = (function($$outer, map) {
  this.map$1 = map;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser.prototype.parse__Lamf_plugins_document_webapi_model_NamedExampleFragment = (function() {
  var entries = $as_sc_IndexedSeq(this.map$1.entries$3.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(e$2) {
      var e = $as_Lorg_yaml_model_YMapEntry(e$2);
      var this$1 = e.key$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
      var iv = $this.$$outer$1.ctx$2;
      return ($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3 !== new $c_Lamf_core_utils_package$AmfStrings().init___T("fragmentType").asOasExtension__T())
    })
  })(this))));
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_document_webapi_model_NamedExampleFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var x$1 = (this.$$outer$1.root$2.location$1 + "#/");
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var namedExample = $as_Lamf_plugins_document_webapi_model_NamedExampleFragment($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
  var producer = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, namedExample$1) {
    return (function(name$2) {
      var name = $as_s_Option(name$2);
      $m_Lamf_core_parser_Annotations$();
      var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
      var fields = new $c_Lamf_core_parser_Fields().init___();
      var example = new $c_Lamf_plugins_domain_shapes_models_Example().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations$1);
      if ((!name.isEmpty__Z())) {
        var arg1 = name.get__O();
        var x$2$1 = $as_T(arg1);
        $m_Lamf_core_parser_Annotations$();
        var a = new $c_Lamf_core_parser_Annotations().init___();
        $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(example, x$2$1, a))
      };
      var field = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
      $as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(namedExample$1, field, example));
      return example
    })
  })(this, namedExample));
  var encoded = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlNamedExampleParser().init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext($as_Lorg_yaml_model_YMapEntry(entries.head__O()), producer, new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions().init___Z__Z__Z(true, true, false), this.$$outer$1.ctx$2).parse__Lamf_plugins_domain_shapes_models_Example();
  var field$1 = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
  return $as_Lamf_plugins_document_webapi_model_NamedExampleFragment($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(namedExample, field$1, encoded)))
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentParser$NamedExampleFragmentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasFragmentParser$NamedExampleFragmentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentParser$NamedExampleFragmentParser", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser.prototype.productPrefix__T = (function() {
  return "ResourceTypeFragmentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser(x$1).$$outer$1 === this.$$outer$1))) {
    var ResourceTypeFragmentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser(x$1);
    var this$1 = this.map$1;
    var b = ResourceTypeFragmentParser$1.map$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser__Lorg_yaml_model_YMap = (function($$outer, map) {
  this.map$1 = map;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser.prototype.parse__Lamf_plugins_document_webapi_model_ResourceTypeFragment = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_document_webapi_model_ResourceTypeFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var x$1 = this.$$outer$1.root$2.location$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var resourceType = $as_Lamf_plugins_document_webapi_model_ResourceTypeFragment($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
  var jsx$2 = $as_Lamf_core_model_domain_templates_AbstractDeclaration($m_Lamf_plugins_domain_webapi_models_templates_ResourceType$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_templates_ResourceType(this.map$1).withId__T__Lamf_core_model_domain_AmfObject((resourceType.id$1 + "#/")));
  var jsx$1 = resourceType.id$1;
  $m_Lorg_yaml_model_YNode$();
  var map = this.map$1;
  $m_Lorg_yaml_model_YNode$();
  var node = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1);
  var errorHandler = this.$$outer$1.ctx$2;
  var abstractDeclaration = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser().init___Lamf_core_model_domain_templates_AbstractDeclaration__T__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_plugins_document_webapi_contexts_WebApiContext(jsx$2, jsx$1, new $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, errorHandler), this.$$outer$1.ctx$2).parse__Lamf_core_model_domain_templates_AbstractDeclaration();
  var field = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
  return $as_Lamf_plugins_document_webapi_model_ResourceTypeFragment($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(resourceType, field, abstractDeclaration)))
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentParser$ResourceTypeFragmentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasFragmentParser$ResourceTypeFragmentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentParser$ResourceTypeFragmentParser", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser.prototype.productPrefix__T = (function() {
  return "SecuritySchemeFragmentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser(x$1).$$outer$1 === this.$$outer$1))) {
    var SecuritySchemeFragmentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser(x$1);
    var this$1 = this.map$1;
    var b = SecuritySchemeFragmentParser$1.map$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser__Lorg_yaml_model_YMap = (function($$outer, map) {
  this.map$1 = map;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser.prototype.parse__Lamf_plugins_document_webapi_model_SecuritySchemeFragment = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var x$1 = this.$$outer$1.root$2.location$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var security = $as_Lamf_plugins_document_webapi_model_SecuritySchemeFragment($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
  var encoded = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser().init___Lorg_yaml_model_YPart__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.map$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(security$2$2) {
      var security$2 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(security$2$2);
      return security$2.adopted__T__sc_Seq__Lamf_plugins_domain_webapi_models_security_SecurityScheme(($this.$$outer$1.root$2.location$1 + "#/"), $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())))
    })
  })(this)), this.$$outer$1.ctx$2).parse__Lamf_plugins_domain_webapi_models_security_SecurityScheme();
  var field = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
  return $as_Lamf_plugins_document_webapi_model_SecuritySchemeFragment($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(security, field, encoded)))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentParser$SecuritySchemeFragmentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasFragmentParser$SecuritySchemeFragmentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentParser$SecuritySchemeFragmentParser", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser.prototype.productPrefix__T = (function() {
  return "TraitFragmentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser(x$1).$$outer$1 === this.$$outer$1))) {
    var TraitFragmentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser(x$1);
    var this$1 = this.map$1;
    var b = TraitFragmentParser$1.map$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser__Lorg_yaml_model_YMap = (function($$outer, map) {
  this.map$1 = map;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser.prototype.parse__Lamf_plugins_document_webapi_model_TraitFragment = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_document_webapi_model_TraitFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var x$1 = this.$$outer$1.root$2.location$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var traitFragment = $as_Lamf_plugins_document_webapi_model_TraitFragment($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
  var jsx$2 = $as_Lamf_core_model_domain_templates_AbstractDeclaration($m_Lamf_plugins_domain_webapi_models_templates_Trait$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_templates_Trait(this.map$1).withId__T__Lamf_core_model_domain_AmfObject((traitFragment.id$1 + "#/")));
  var jsx$1 = traitFragment.id$1;
  $m_Lorg_yaml_model_YNode$();
  var map = this.map$1;
  $m_Lorg_yaml_model_YNode$();
  var node = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1);
  var errorHandler = this.$$outer$1.ctx$2;
  var abstractDeclaration = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser().init___Lamf_core_model_domain_templates_AbstractDeclaration__T__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_plugins_document_webapi_contexts_WebApiContext(jsx$2, jsx$1, new $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, errorHandler), this.$$outer$1.ctx$2).parse__Lamf_core_model_domain_templates_AbstractDeclaration();
  var field = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
  return $as_Lamf_plugins_document_webapi_model_TraitFragment($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(traitFragment, field, abstractDeclaration)))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentParser$TraitFragmentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasFragmentParser$TraitFragmentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentParser$TraitFragmentParser", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser() {
  $c_O.call(this);
  this.ast$1 = null;
  this.annotationName$1 = null;
  this.map$1 = null;
  this.adopt$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser.prototype.productPrefix__T = (function() {
  return "AnnotationTypesParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser(x$1).$$outer$1 === this.$$outer$1))) {
    var AnnotationTypesParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser(x$1);
    var x = this.ast$1;
    var x$2 = AnnotationTypesParser$1.ast$1;
    if ((((x === null) ? (x$2 === null) : x.equals__O__Z(x$2)) && (this.annotationName$1 === AnnotationTypesParser$1.annotationName$1))) {
      var this$1 = this.map$1;
      var b = AnnotationTypesParser$1.map$1;
      var jsx$1 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.adopt$1;
      var x$4 = AnnotationTypesParser$1.adopt$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser__Lorg_yaml_model_YPart__T__Lorg_yaml_model_YMap__F1 = (function($$outer, ast, annotationName, map, adopt) {
  this.ast$1 = ast;
  this.annotationName$1 = annotationName;
  this.map$1 = map;
  this.adopt$1 = adopt;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.ast$1;
      break
    }
    case 1: {
      return this.annotationName$1;
      break
    }
    case 2: {
      return this.map$1;
      break
    }
    case 3: {
      return this.adopt$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser.prototype.parse__Lamf_core_model_domain_extensions_CustomDomainProperty = (function() {
  var custom = $m_Lamf_core_model_domain_extensions_CustomDomainProperty$().apply__Lorg_yaml_model_YPart__Lamf_core_model_domain_extensions_CustomDomainProperty(this.ast$1);
  var name = this.annotationName$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(custom, name, a);
  this.adopt$1.apply__O__O(custom);
  var map = this.map$1;
  var this$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$4 = this$3.key__T__s_Option("allowedTargets");
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    var x1 = entry.value$2.value__Lorg_yaml_model_YValue();
    if ((x1 instanceof $c_Lorg_yaml_model_YScalar)) {
      annotations.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SingleValueArray().init___());
      var jsx$1 = $m_sc_Seq$();
      var node = entry.value$2;
      var iv = this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f;
      var this$6 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
      var array = [this$6.text__Lamf_core_model_domain_AmfScalar()];
      var targets = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))), new $c_Lamf_core_parser_Annotations().init___())
    } else {
      if ((!(x1 instanceof $c_Lorg_yaml_model_YSequence))) {
        throw new $c_s_MatchError().init___O(x1)
      };
      var x3 = $as_Lorg_yaml_model_YSequence(x1);
      $m_Lorg_yaml_model_YNode$();
      $m_Lorg_yaml_model_YNode$();
      var node$1 = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(x3, $m_Lorg_yaml_model_YType$().Seq$1);
      var iv$1 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f;
      var this$13 = new $c_Lamf_core_parser_DefaultArrayNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$1, iv$1);
      var targets = $f_Lamf_core_parser_BaseArrayNode__text__Lamf_core_model_domain_AmfArray(this$13)
    };
    var jsx$3 = targets.values$1;
    var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_model_domain_AmfElement(x0$1$2);
        if ((x0$1 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
          var x2 = $as_Lamf_core_model_domain_AmfScalar(x0$1);
          var x1$2 = $m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().ramlToUri$1.get__O__s_Option(x2.toString__T());
          if ((x1$2 instanceof $c_s_Some)) {
            var x2$2 = $as_s_Some(x1$2);
            var uri = $as_T(x2$2.value$2);
            return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(uri, x2.annotations$1)
          } else {
            var x = $m_s_None$();
            if ((x === x1$2)) {
              return x2
            } else {
              throw new $c_s_MatchError().init___O(x1$2)
            }
          }
        } else {
          return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(x0$1.toString__T(), x0$1.annotations__Lamf_core_parser_Annotations())
        }
      })
    })(this));
    var this$14 = $m_sc_Seq$();
    var targetUris = $as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$14.ReusableCBFInstance$2));
    var field = $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Domain$1;
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(targetUris, new $c_Lamf_core_parser_Annotations().init___());
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(custom, field, value, annotations)
  };
  var map$1 = this.map$1;
  var this$17 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var this$18 = this$17.key__T__s_Option("displayName");
  if ((!this$18.isEmpty__Z())) {
    var arg1$1 = this$18.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var node$2 = entry$3.value$2;
    var iv$2 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f;
    var value$1 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$2, iv$2);
    var field$1 = $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().DisplayName$1;
    var value$2 = value$1.string__Lamf_core_model_domain_AmfScalar();
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(custom, field$1, value$2, annotations$1)
  };
  var map$2 = this.map$1;
  var this$21 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var this$22 = this$21.key__T__s_Option("description");
  if ((!this$22.isEmpty__Z())) {
    var arg1$2 = this$22.get__O();
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var node$3 = entry$4.value$2;
    var iv$3 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f;
    var value$3 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$3, iv$3);
    var field$2 = $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Description$1;
    var value$4 = value$3.string__Lamf_core_model_domain_AmfScalar();
    var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(custom, field$2, value$4, annotations$2)
  };
  var map$3 = this.map$1;
  var this$25 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3);
  var this$26 = this$25.key__T__s_Option("schema");
  if ((!this$26.isEmpty__Z())) {
    var arg1$3 = this$26.get__O();
    var entry$5 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
    var this$27 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(entry$5, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, custom$1) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        shape.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(custom$1.id$1, shape.adopted$default$2__sc_Seq())
      })
    })(this, custom)), this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f).parse__s_Option();
    if ((!this$27.isEmpty__Z())) {
      var arg1$4 = this$27.get__O();
      var shape$3 = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1$4);
      $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(shape$3, custom.id$1, $m_s_None$());
      var field$3 = $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Schema$1;
      var annotations$3 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$5);
      $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(custom, field$3, shape$3, annotations$3))
    }
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(custom, this.map$1, $m_sci_Nil$(), this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f).parse__V();
  return custom
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasSpecParser$AnnotationTypesParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasSpecParser$AnnotationTypesParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasSpecParser$AnnotationTypesParser", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser() {
  $c_O.call(this);
  this.ast$1 = null;
  this.annotationName$1 = null;
  this.scalar$1 = null;
  this.adopt$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser.prototype.productPrefix__T = (function() {
  return "LinkedAnnotationTypeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser(x$1).$$outer$1 === this.$$outer$1))) {
    var LinkedAnnotationTypeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser(x$1);
    var x = this.ast$1;
    var x$2 = LinkedAnnotationTypeParser$1.ast$1;
    if ((((x === null) ? (x$2 === null) : x.equals__O__Z(x$2)) && (this.annotationName$1 === LinkedAnnotationTypeParser$1.annotationName$1))) {
      var this$1 = this.scalar$1;
      var b = LinkedAnnotationTypeParser$1.scalar$1;
      var jsx$1 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.adopt$1;
      var x$4 = LinkedAnnotationTypeParser$1.adopt$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.ast$1;
      break
    }
    case 1: {
      return this.annotationName$1;
      break
    }
    case 2: {
      return this.scalar$1;
      break
    }
    case 3: {
      return this.adopt$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser__Lorg_yaml_model_YPart__T__Lorg_yaml_model_YScalar__F1 = (function($$outer, ast, annotationName, scalar, adopt) {
  this.ast$1 = ast;
  this.annotationName$1 = annotationName;
  this.scalar$1 = scalar;
  this.adopt$1 = adopt;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser.prototype.parse__Lamf_core_model_domain_extensions_CustomDomainProperty = (function() {
  var this$1 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f.declarations__Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations().findAnnotation__T__Lamf_core_parser_SearchScope$Scope__s_Option(this.scalar$1.text$3, $m_Lamf_core_parser_SearchScope$All$());
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var a = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(arg1);
    var label = this.scalar$1.text$3;
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.ast$1);
    var copied = $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(a, label, annotations));
    copied.id$1 = null;
    var jsx$1 = this.adopt$1;
    var name = this.annotationName$1;
    $m_Lamf_core_parser_Annotations$();
    var a$1 = new $c_Lamf_core_parser_Annotations().init___();
    jsx$1.apply__O__O($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(copied, name, a$1));
    var this$3 = new $c_s_Some().init___O(copied)
  };
  if (this$3.isEmpty__Z()) {
    $m_Lamf_core_parser_Annotations$();
    var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
    var qual$1 = new $c_Lamf_core_model_domain_extensions_CustomDomainProperty().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
    var x$1 = this.annotationName$1;
    $m_Lamf_core_parser_Annotations$();
    var x$2 = new $c_Lamf_core_parser_Annotations().init___();
    var customDomainProperty = $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, x$1, x$2));
    this.adopt$1.apply__O__O(customDomainProperty);
    var this$8 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f.eh$1;
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().DeclarationNotFound$1;
    var node = customDomainProperty.id$1;
    var ast = this.scalar$1;
    var prop = $m_s_None$();
    var l = ast.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$8, specification, node, prop, "Could not find declared annotation link in references", l);
    var jsx$2 = customDomainProperty
  } else {
    var jsx$2 = this$3.get__O()
  };
  return $as_Lamf_core_model_domain_extensions_CustomDomainProperty(jsx$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasSpecParser$LinkedAnnotationTypeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasSpecParser$LinkedAnnotationTypeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasSpecParser$LinkedAnnotationTypeParser", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$LinkedAnnotationTypeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.baseUnit$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser.prototype.productPrefix__T = (function() {
  return "UsageParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser(x$1).$$outer$1 === this.$$outer$1))) {
    var UsageParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser(x$1);
    var this$1 = this.map$1;
    var b = UsageParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.baseUnit$1;
      var x$2 = UsageParser$1.baseUnit$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.baseUnit$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser.prototype.parse__V = (function() {
  var map = this.map$1;
  var this$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("usage").asOasExtension__T();
  var this$4 = this$3.key__T__s_Option(keyword);
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var node = entry.value$2;
    var iv = this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f;
    var value = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
    var this$6 = this.baseUnit$1;
    var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1;
    var value$1 = value.string__Lamf_core_model_domain_AmfScalar();
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$6, field, value$1, annotations)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser__Lorg_yaml_model_YMap__Lamf_core_model_document_BaseUnit = (function($$outer, map, baseUnit) {
  this.map$1 = map;
  this.baseUnit$1 = baseUnit;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasSpecParser$UsageParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasSpecParser$UsageParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasSpecParser$UsageParser", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser() {
  $c_O.call(this);
  this.seq$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser.prototype.productPrefix__T = (function() {
  return "UserDocumentationParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser(x$1).$$outer$1 === this.$$outer$1))) {
    var UserDocumentationParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser(x$1);
    var x = this.seq$1;
    var x$2 = UserDocumentationParser$1.seq$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.seq$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser.prototype.parse__sc_Seq = (function() {
  var jsx$2 = this.seq$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(n$2) {
      var n = $as_Lorg_yaml_model_YNode(n$2);
      var x1 = n.tag__Lorg_yaml_model_YTag().tagType$3;
      var x = $m_Lorg_yaml_model_YType$().Map$1;
      if ((x === x1)) {
        return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser().init___Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext(n, $this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f).parse__Lamf_plugins_domain_shapes_models_CreativeWork()
      } else {
        var x$3 = $m_Lorg_yaml_model_YType$().Str$1;
        if ((x$3 === x1)) {
          var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
          var iv = $this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f;
          var text = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(n, conversion, iv)).text$3;
          var x1$2 = $this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f.declarations__Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations().findDocumentations__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option(text, $m_Lamf_core_parser_SearchScope$All$(), ($this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f.declarations__Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations(), $m_s_None$()));
          if ((x1$2 instanceof $c_s_Some)) {
            var x2 = $as_s_Some(x1$2);
            var doc = $as_Lamf_plugins_domain_shapes_models_CreativeWork(x2.value$2);
            var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(n);
            return $as_Lamf_plugins_domain_shapes_models_CreativeWork($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(doc, text, annotations))
          } else {
            $m_Lorg_yaml_model_YNode$();
            var map = $m_Lorg_yaml_model_YMap$().empty$1;
            var documentation = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser().init___Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1), $this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f).parse__Lamf_plugins_domain_shapes_models_CreativeWork();
            var this$3 = $this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$OasSpecParser$$ctx$f.eh$1;
            var specification = $m_Lamf_plugins_features_validation_CoreValidations$().DeclarationNotFound$1;
            var node = documentation.id$1;
            var message = (("not supported scalar " + n) + ".text for documentation item");
            var prop = $m_s_None$();
            var l = n.location$1;
            $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$3, specification, node, prop, message, l);
            return documentation
          }
        } else {
          throw new $c_s_MatchError().init___O(x1)
        }
      }
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser__sc_Seq = (function($$outer, seq) {
  this.seq$1 = seq;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasSpecParser$UserDocumentationParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasSpecParser$UserDocumentationParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasSpecParser$UserDocumentationParser", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters() {
  $c_O.call(this);
  this.settings$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters.prototype.productPrefix__T = (function() {
  return "Oas3OAuth2SettingsEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters)) {
    var Oas3OAuth2SettingsEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters(x$1);
    var x = this.settings$1;
    var x$2 = Oas3OAuth2SettingsEmitters$1.settings$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = Oas3OAuth2SettingsEmitters$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.settings$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters.prototype.emitters__sc_Seq = (function() {
  var externals = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  externals.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter().init___Lamf_plugins_domain_webapi_models_security_OAuth2Settings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.settings$1, this.ordering$1, this.spec$1));
  return externals
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters.prototype.init___Lamf_plugins_domain_webapi_models_security_OAuth2Settings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(settings, ordering, spec) {
  this.settings$1 = settings;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.Oas3OAuth2SettingsEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.Oas3OAuth2SettingsEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.Oas3OAuth2SettingsEmitters", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters() {
  $c_O.call(this);
  this.apiKey$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters.prototype.productPrefix__T = (function() {
  return "OasApiKeySettingsEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters)) {
    var OasApiKeySettingsEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters(x$1);
    var x = this.apiKey$1;
    var x$2 = OasApiKeySettingsEmitters$1.apiKey$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasApiKeySettingsEmitters$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.apiKey$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters.prototype.emitters__sc_Seq = (function() {
  var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())).$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters().init___Lamf_plugins_domain_webapi_models_security_ApiKeySettings__Lamf_core_emitter_SpecOrdering(this.apiKey$1, this.ordering$1).emitters__sc_Seq());
  var internals = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = this.apiKey$1;
  var this$2 = this$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().AdditionalProperties$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    internals.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler($as_Lamf_core_model_domain_DataNode(f.value$1.value$1), this.ordering$1, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler()).emitters__sc_Seq())
  };
  if (internals.nonEmpty__Z()) {
    results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter().init___sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings__Lamf_core_emitter_SpecOrdering(internals, this.apiKey$1, this.ordering$1))
  };
  return results
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters.prototype.init___Lamf_plugins_domain_webapi_models_security_ApiKeySettings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(apiKey, ordering, spec) {
  this.apiKey$1 = apiKey;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasApiKeySettingsEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.OasApiKeySettingsEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasApiKeySettingsEmitters", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters() {
  $c_O.call(this);
  this.settings$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters.prototype.productPrefix__T = (function() {
  return "OasHttpSettingsEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters)) {
    var OasHttpSettingsEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters(x$1);
    var x = this.settings$1;
    var x$2 = OasHttpSettingsEmitters$1.settings$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasHttpSettingsEmitters$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.settings$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters.prototype.emitters__sc_Seq = (function() {
  var fs = this.settings$1.fields__Lamf_core_parser_Fields();
  var externals = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$().Scheme$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(externals.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("scheme", f, $m_s_None$())))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$().BearerFormat$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(externals.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("bearerFormat", f$3, $m_s_None$())))
  };
  return externals.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.settings$1, this.ordering$1, this.spec$1).emitters__sc_Seq())
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters.prototype.init___Lamf_plugins_domain_webapi_models_security_Settings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(settings, ordering, spec) {
  this.settings$1 = settings;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasHttpSettingsEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.OasHttpSettingsEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasHttpSettingsEmitters", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters() {
  $c_O.call(this);
  this.o1$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters.prototype.productPrefix__T = (function() {
  return "OasOAuth1SettingsEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters)) {
    var OasOAuth1SettingsEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters(x$1);
    var x = this.o1$1;
    var x$2 = OasOAuth1SettingsEmitters$1.o1$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasOAuth1SettingsEmitters$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.o1$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters.prototype.emitters__sc_Seq = (function() {
  var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())).$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters().init___Lamf_plugins_domain_webapi_models_security_OAuth1Settings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.o1$1, this.ordering$1, this.spec$1).emitters__sc_Seq());
  var this$1 = this.o1$1;
  var this$2 = this$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().AdditionalProperties$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    results.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler($as_Lamf_core_model_domain_DataNode(f.value$1.value$1), this.ordering$1, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler()).emitters__sc_Seq())
  };
  var jsx$1 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter().init___sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings__Lamf_core_emitter_SpecOrdering(results, this.o1$1, this.ordering$1)];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters.prototype.init___Lamf_plugins_domain_webapi_models_security_OAuth1Settings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(o1, ordering, spec) {
  this.o1$1 = o1;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasOAuth1SettingsEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.OasOAuth1SettingsEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasOAuth1SettingsEmitters", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters() {
  $c_O.call(this);
  this.settings$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters.prototype.productPrefix__T = (function() {
  return "OasOAuth2SettingsEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters)) {
    var OasOAuth2SettingsEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters(x$1);
    var x = this.settings$1;
    var x$2 = OasOAuth2SettingsEmitters$1.settings$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasOAuth2SettingsEmitters$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.settings$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters.prototype.emitters__sc_Seq = (function() {
  var this$1 = this.settings$1;
  var fs = this$1.fields$1;
  var externals = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = this.settings$1;
  var this$3 = $as_sc_Seq(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1)).headOption__s_Option();
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var x$1 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow(arg1);
    this.flowEmitters__Lamf_plugins_domain_webapi_models_security_OAuth2Flow__scm_ListBuffer__V(x$1, externals)
  };
  var internals = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().AuthorizationGrants$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(internals.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType("authorizationGrants", f, this.ordering$1, false, $m_Lorg_yaml_model_YType$().Str$1)))
  };
  var this$6 = this.settings$1;
  var this$7 = this$6.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().AdditionalProperties$1);
  if ((!this$7.isEmpty__Z())) {
    var arg1$2 = this$7.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    internals.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler($as_Lamf_core_model_domain_DataNode(f$3.value$1.value$1), this.ordering$1, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler()).emitters__sc_Seq())
  };
  if (internals.nonEmpty__Z()) {
    externals.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter().init___sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings__Lamf_core_emitter_SpecOrdering(internals, this.settings$1, this.ordering$1))
  };
  externals.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.settings$1, this.ordering$1, this.spec$1).emitters__sc_Seq());
  return externals
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters.prototype.init___Lamf_plugins_domain_webapi_models_security_OAuth2Settings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(settings, ordering, spec) {
  this.settings$1 = settings;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters.prototype.flowEmitters__Lamf_plugins_domain_webapi_models_security_OAuth2Flow__scm_ListBuffer__V = (function(flow, externals) {
  var fs = flow.fields$1;
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(externals.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("authorizationUrl", f, $m_s_None$())))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(externals.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("tokenUrl", f$3, $m_s_None$())))
  };
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Flow$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1$2 = this$5.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(externals.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("flow", f$4, $m_s_None$())))
  };
  var this$7 = this.settings$1;
  var orphanAnnotations = $as_sc_Seq($as_sc_Seq(this$7.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field())).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_model_domain_extensions_DomainExtension(x$2$2);
      return $as_Lamf_core_model_domain_DataNode(x$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)).annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.getClassOf())
    })
  })(this))));
  var this$8 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Scopes$1);
  if ((!this$8.isEmpty__Z())) {
    var arg1$3 = this$8.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    externals.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("scopes", f$5, this.ordering$1, orphanAnnotations, this.spec$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasOAuth2SettingsEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.OasOAuth2SettingsEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasOAuth2SettingsEmitters", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters() {
  $c_O.call(this);
  this.settings$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters.prototype.productPrefix__T = (function() {
  return "OasOpenIdConnectSettingsEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters)) {
    var OasOpenIdConnectSettingsEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters(x$1);
    var x = this.settings$1;
    var x$2 = OasOpenIdConnectSettingsEmitters$1.settings$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasOpenIdConnectSettingsEmitters$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.settings$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters.prototype.emitters__sc_Seq = (function() {
  var fs = this.settings$1.fields__Lamf_core_parser_Fields();
  var externals = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$().Url$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(externals.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("openIdConnectUrl", f, $m_s_None$())))
  };
  return externals.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.settings$1, this.ordering$1, this.spec$1).emitters__sc_Seq())
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters.prototype.init___Lamf_plugins_domain_webapi_models_security_Settings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(settings, ordering, spec) {
  this.settings$1 = settings;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasOpenIdConnectSettingsEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.OasOpenIdConnectSettingsEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasOpenIdConnectSettingsEmitters", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters() {
  $c_O.call(this);
  this.f$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters.prototype.productPrefix__T = (function() {
  return "OasScopeValuesEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters.prototype.init___Lamf_core_parser_FieldEntry = (function(f) {
  this.f$1 = f;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters)) {
    var OasScopeValuesEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters(x$1);
    var x = this.f$1;
    var x$2 = OasScopeValuesEmitters$1.f$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.f$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters.prototype.emitters__sc_Seq = (function() {
  var this$1 = this.f$1;
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(this$1.value$1.value$1).values$1;
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters$$anonfun$emitters$9().init___Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters(this);
  var this$2 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasScopeValuesEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.OasScopeValuesEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasScopeValuesEmitters", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter() {
  $c_O.call(this);
  this.f$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter.prototype.productPrefix__T = (function() {
  return "OasSecuritySettingsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(f, ordering, spec) {
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter)) {
    var OasSecuritySettingsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter(x$1);
    var x = this.f$1;
    var x$2 = OasSecuritySettingsEmitter$1.f$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasSecuritySettingsEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.f$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter.prototype.emitters__sc_Seq = (function() {
  var settings = $as_Lamf_plugins_domain_webapi_models_security_Settings(this.f$1.value$1.value$1);
  var rc9 = false;
  var x3 = null;
  if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(settings);
    return new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth1SettingsEmitters().init___Lamf_plugins_domain_webapi_models_security_OAuth1Settings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x2, this.ordering$1, this.spec$1).emitters__sc_Seq()
  };
  if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings)) {
    rc9 = true;
    x3 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(settings);
    var x = this.spec$1.vendor__Lamf_core_remote_Vendor();
    var x$2 = $m_Lamf_core_remote_Vendor$().OAS30$1;
    if ((x === x$2)) {
      return new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2SettingsEmitters().init___Lamf_plugins_domain_webapi_models_security_OAuth2Settings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x3, this.ordering$1, this.spec$1).emitters__sc_Seq()
    }
  };
  if (rc9) {
    return new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2SettingsEmitters().init___Lamf_plugins_domain_webapi_models_security_OAuth2Settings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x3, this.ordering$1, this.spec$1).emitters__sc_Seq()
  };
  if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings)) {
    var x5 = $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(settings);
    return new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasApiKeySettingsEmitters().init___Lamf_plugins_domain_webapi_models_security_ApiKeySettings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x5, this.ordering$1, this.spec$1).emitters__sc_Seq()
  };
  if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_HttpSettings)) {
    var x6 = $as_Lamf_plugins_domain_webapi_models_security_HttpSettings(settings);
    return new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasHttpSettingsEmitters().init___Lamf_plugins_domain_webapi_models_security_Settings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x6, this.ordering$1, this.spec$1).emitters__sc_Seq()
  };
  if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings)) {
    var x7 = $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(settings);
    return new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOpenIdConnectSettingsEmitters().init___Lamf_plugins_domain_webapi_models_security_Settings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x7, this.ordering$1, this.spec$1).emitters__sc_Seq()
  };
  var internals = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = settings.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().AdditionalProperties$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    internals.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler($as_Lamf_core_model_domain_DataNode(f.value$1.value$1), this.ordering$1, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler()).emitters__sc_Seq())
  };
  if (internals.nonEmpty__Z()) {
    var jsx$1 = $m_sc_Seq$();
    var array = [new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter().init___sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings__Lamf_core_emitter_SpecOrdering(internals, settings, this.ordering$1)];
    return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  } else {
    return $m_sci_Nil$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasSecuritySettingsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.OasSecuritySettingsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasSecuritySettingsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySettingsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter() {
  $c_O.call(this);
  this.f$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter.prototype.productPrefix__T = (function() {
  return "UserDocumentationsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(f, ordering, spec) {
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter)) {
    var UserDocumentationsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter(x$1);
    var x = this.f$1;
    var x$2 = UserDocumentationsEmitter$1.f$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = UserDocumentationsEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.f$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter.prototype.emitters__sc_Seq = (function() {
  var this$1 = this.f$1;
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(this$1.value$1.value$1).values$1;
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter(this);
  var this$2 = $m_sc_Seq$();
  var documents = $as_sc_TraversableOnce(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2)).toList__sci_List();
  var rc7 = false;
  var x2 = null;
  if ((documents instanceof $c_sci_$colon$colon)) {
    rc7 = true;
    x2 = $as_sci_$colon$colon(documents);
    var head = $as_Lamf_plugins_domain_shapes_models_CreativeWork(x2.head$5);
    var p3 = x2.tl$5;
    var x = $m_sci_Nil$();
    if (x.equals__O__Z(p3)) {
      var jsx$3 = $m_sc_Seq$();
      var array = [new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter().init___T__Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("externalDocs", head, this.ordering$1, this.spec$1)];
      return $as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
    }
  };
  if (rc7) {
    var head$2 = $as_Lamf_plugins_domain_shapes_models_CreativeWork(x2.head$5);
    var tail = x2.tl$5;
    var jsx$4 = $m_sc_Seq$();
    var array$1 = [new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter().init___T__Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("externalDocs", head$2, this.ordering$1, this.spec$1), new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters().init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(tail, this.ordering$1, this.spec$1)];
    return $as_sc_Seq(jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)))
  };
  return $m_sci_Nil$()
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.UserDocumentationsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.UserDocumentationsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.UserDocumentationsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult() {
  $c_O.call(this);
  this.result$1 = null;
  this.remaining$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult.prototype.productPrefix__T = (function() {
  return "ParsingResult"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult.prototype.init___s_Option__sc_Seq = (function(result, remaining) {
  this.result$1 = result;
  this.remaining$1 = remaining;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult)) {
    var ParsingResult$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult(x$1);
    var x = this.result$1;
    var x$2 = ParsingResult$1.result$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.remaining$1;
      var x$4 = ParsingResult$1.remaining$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.result$1;
      break
    }
    case 1: {
      return this.remaining$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.ParsingResult"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.ParsingResult;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.ParsingResult", {
  Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_ParsingResult;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter() {
  $c_O.call(this);
  this.WebApiEmitter$module$1 = null;
  this.LicenseEmitter$module$1 = null;
  this.OrganizationEmitter$module$1 = null;
  this.document$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter.prototype.productPrefix__T = (function() {
  return "RamlDocumentEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter)) {
    var RamlDocumentEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter(x$1);
    var x = this.document$1;
    var x$2 = RamlDocumentEmitter$1.document$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.document$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter.prototype.retrieveWebApi__p1__Lamf_plugins_domain_webapi_models_WebApi = (function() {
  var x1 = this.document$1;
  if ((x1 instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(x1);
    return $as_Lamf_plugins_domain_webapi_models_WebApi(x2.encodes__Lamf_core_model_domain_DomainElement())
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("BaseUnit doesn't encode a WebApi."))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter.prototype.emitDocument__Lorg_yaml_model_YDocument = (function() {
  var doc = $as_Lamf_core_model_document_Document(this.document$1);
  var ordering = $m_Lamf_core_emitter_SpecOrdering$().ordering__Lamf_core_remote_Vendor__Lamf_core_parser_Annotations__Lamf_core_emitter_SpecOrdering($m_Lamf_core_remote_Raml$(), doc.encodes__Lamf_core_model_domain_DomainElement().annotations__Lamf_core_parser_Annotations());
  var jsx$2 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters(this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory().rootLevelEmitters__F2().apply__O__O__O(doc, ordering)).emitters__sc_Seq();
  var jsx$1 = this.apiEmitters__Lamf_core_emitter_SpecOrdering__sc_Seq(ordering);
  var this$1 = $m_sc_Seq$();
  var content = $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  var this$3 = $m_Lorg_yaml_model_YDocument$().apply__T__Lorg_yaml_model_YDocument$WithComment("");
  var b = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(this$3.org$yaml$model$YDocument$WithComment$$sourceName$f);
  var x = this$3.comment$1;
  var this$5 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$5)) {
    b.comment__T__V(this$3.comment$1)
  };
  var this$6 = this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory().retrieveHeader__Lamf_core_model_document_BaseUnit__s_Option(this.document$1);
  if ((!this$6.isEmpty__Z())) {
    var arg1 = this$6.get__O();
    var text = $as_T(arg1);
    b.comment__T__V(text)
  };
  var jsx$3 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(ordering.sorted__sc_Seq__sc_Seq(content), b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  return new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this$3.org$yaml$model$YDocument$WithComment$$sourceName$f), b.builder$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter.prototype.apiEmitters__Lamf_core_emitter_SpecOrdering__sc_Seq = (function(ordering) {
  var model = this.retrieveWebApi__p1__Lamf_plugins_domain_webapi_models_WebApi();
  var this$1 = model.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_SourceVendor.getClassOf());
  if (this$1.isEmpty__Z()) {
    var vendor = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$6 = $as_Lamf_core_annotations_SourceVendor(arg1);
    var vendor = new $c_s_Some().init___O(x$6.vendor$1)
  };
  return new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter__Lamf_plugins_domain_webapi_models_WebApi__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(this, model, ordering, vendor, this.document$1.references__sc_Seq(), this.spec$1).emitters$1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(document, spec) {
  this.document$1 = document;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlDocumentEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlDocumentEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlDocumentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter() {
  $c_O.call(this);
  this.api$1 = null;
  this.ordering$1 = null;
  this.vendor$1 = null;
  this.references$1 = null;
  this.spec$1 = null;
  this.emitters$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter.prototype.productPrefix__T = (function() {
  return "WebApiEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter.prototype.defaultOrder$1__p1__sc_Seq__sc_Seq = (function(emitters) {
  return $as_sc_Seq(emitters.sorted__s_math_Ordering__O(new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter$$anonfun$defaultOrder$1$1().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter(this)))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var WebApiEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter(x$1);
    var x = this.api$1;
    var x$2 = WebApiEmitter$1.api$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = WebApiEmitter$1.ordering$1;
      var jsx$2 = (x$3 === x$4)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.vendor$1;
      var x$6 = WebApiEmitter$1.vendor$1;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.references$1;
      var x$8 = WebApiEmitter$1.references$1;
      return ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.api$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.vendor$1;
      break
    }
    case 3: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter.prototype.amf$plugins$document$webapi$parser$spec$raml$RamlDocumentEmitter$WebApiEmitter$$$anonfun$endpoints$1__Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter__Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter__I = (function(x, y) {
  var this$1 = x.endpoint__Lamf_plugins_domain_webapi_models_EndPoint();
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1));
  var this$3 = this$2.option$1;
  var x$1 = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
  var this$5 = new $c_sci_StringOps().init___T(x$1);
  var elem$1 = 0;
  elem$1 = 0;
  var i = 0;
  var $$this = this$5.repr$1;
  var len = $uI($$this.length);
  while ((i < len)) {
    var arg1 = this$5.apply__I__O(i);
    if ((arg1 === null)) {
      var x$7 = 0
    } else {
      var this$10 = $as_jl_Character(arg1);
      var x$7 = this$10.value$1
    };
    if ((x$7 === 47)) {
      elem$1 = ((1 + elem$1) | 0)
    };
    i = ((1 + i) | 0)
  };
  var x$2 = elem$1;
  var this$12 = y.endpoint__Lamf_plugins_domain_webapi_models_EndPoint();
  var this$13 = $as_Lamf_core_model_StrField(this$12.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1));
  var this$14 = this$13.option$1;
  var x$3 = $as_T((this$14.isEmpty__Z() ? null : this$14.get__O()));
  var this$16 = new $c_sci_StringOps().init___T(x$3);
  var elem$1$1 = 0;
  elem$1$1 = 0;
  var i$1 = 0;
  var $$this$1 = this$16.repr$1;
  var len$1 = $uI($$this$1.length);
  while ((i$1 < len$1)) {
    var arg1$1 = this$16.apply__I__O(i$1);
    if ((arg1$1 === null)) {
      var x$8 = 0
    } else {
      var this$21 = $as_jl_Character(arg1$1);
      var x$8 = this$21.value$1
    };
    if ((x$8 === 47)) {
      elem$1$1 = ((1 + elem$1$1) | 0)
    };
    i$1 = ((1 + i$1) | 0)
  };
  var x$4 = elem$1$1;
  var x1 = ((x$2 === x$4) ? 0 : ((x$2 < x$4) ? (-1) : 1));
  switch (x1) {
    case 0: {
      var this$24 = x.endpoint__Lamf_plugins_domain_webapi_models_EndPoint();
      var this$25 = $as_Lamf_core_model_StrField(this$24.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1));
      var this$26 = this$25.option$1;
      var thiz = $as_T((this$26.isEmpty__Z() ? null : this$26.get__O()));
      var this$27 = y.endpoint__Lamf_plugins_domain_webapi_models_EndPoint();
      var this$28 = $as_Lamf_core_model_StrField(this$27.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1));
      var this$29 = this$28.option$1;
      var anotherString = $as_T((this$29.isEmpty__Z() ? null : this$29.get__O()));
      return ((thiz === anotherString) ? 0 : ($uZ((thiz < anotherString)) ? (-1) : 1));
      break
    }
    default: {
      return x1
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter__Lamf_plugins_domain_webapi_models_WebApi__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function($$outer, api, ordering, vendor, references, spec) {
  this.api$1 = api;
  this.ordering$1 = ordering;
  this.vendor$1 = vendor;
  this.references$1 = references;
  this.spec$1 = spec;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  var fs = api.fields$1;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Name$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("title", f, $m_s_None$(), this.spec$1)))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Servers$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(f$3, this.ordering$1, this.references$1, this.spec$1).emitters__sc_Seq()))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Description$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$2 = this$4.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("description", f$4, $m_s_None$(), this.spec$1)))
  };
  var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().ContentType$1);
  if ((!this$6.isEmpty__Z())) {
    var arg1$3 = this$6.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType("mediaType", f$5, this.ordering$1, false, $m_Lorg_yaml_model_YType$().Str$1)))
  };
  var this$8 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Version$1);
  if ((!this$8.isEmpty__Z())) {
    var arg1$4 = this$8.get__O();
    var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("version", f$6, $m_s_None$(), this.spec$1)))
  };
  var this$10 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().TermsOfService$1);
  if ((!this$10.isEmpty__Z())) {
    var arg1$5 = this$10.get__O();
    var f$7 = $as_Lamf_core_parser_FieldEntry(arg1$5);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("termsOfService").asRamlAnnotation__T(), f$7, $m_s_None$())))
  };
  var this$13 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Schemes$1);
  if ((!this$13.isEmpty__Z())) {
    var arg1$6 = this$13.get__O();
    var f$8 = $as_Lamf_core_parser_FieldEntry(arg1$6);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType("protocols", f$8, this.ordering$1, false, $m_Lorg_yaml_model_YType$().Str$1)))
  };
  var this$15 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Provider$1);
  if ((!this$15.isEmpty__Z())) {
    var arg1$7 = this$15.get__O();
    var f$9 = $as_Lamf_core_parser_FieldEntry(arg1$7);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter__T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering(this.$$outer$1, new $c_Lamf_core_utils_package$AmfStrings().init___T("contact").asRamlAnnotation__T(), f$9, this.ordering$1)))
  };
  var this$17 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Tags$1);
  if ((!this$17.isEmpty__Z())) {
    var arg1$8 = this$17.get__O();
    var f$10 = $as_Lamf_core_parser_FieldEntry(arg1$8);
    var jsx$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T("tags").asRamlAnnotation__T();
    var jsx$2 = $as_Lamf_core_model_domain_AmfArray(f$10.value$1.value$1).values$1;
    var jsx$1 = this.ordering$1;
    var spec$1 = this.spec$1;
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(jsx$3, jsx$2, jsx$1, new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(spec$1.eh$1, spec$1.refEmitter$1, new $c_Lamf_core_emitter_ShapeRenderOptions().init___()))))
  };
  var this$22 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Documentations$1);
  if ((!this$22.isEmpty__Z())) {
    var arg1$9 = this$22.get__O();
    var f$11 = $as_Lamf_core_parser_FieldEntry(arg1$9);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(f$11, this.ordering$1, this.spec$1)))
  };
  var this$23 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().License$1);
  if ((!this$23.isEmpty__Z())) {
    var arg1$10 = this$23.get__O();
    var f$12 = $as_Lamf_core_parser_FieldEntry(arg1$10);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter__T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering(this.$$outer$1, new $c_Lamf_core_utils_package$AmfStrings().init___T("license").asRamlAnnotation__T(), f$12, this.ordering$1)))
  };
  var this$25 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1);
  if ((!this$25.isEmpty__Z())) {
    var arg1$11 = this$25.get__O();
    var f$13 = $as_Lamf_core_parser_FieldEntry(arg1$11);
    new $c_s_Some().init___O(result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(this.endpoints__p1__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq(f$13, this.ordering$1, this.vendor$1)))
  };
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(api, ordering, spec).emitters__sc_Seq());
  var this$26 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Security$1);
  if ((!this$26.isEmpty__Z())) {
    var arg1$12 = this$26.get__O();
    var f$14 = $as_Lamf_core_parser_FieldEntry(arg1$12);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("securedBy", f$14, this.ordering$1, this.spec$1)))
  };
  this.emitters$1 = ordering.sorted__sc_Seq__sc_Seq(result);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter.prototype.endpoints__p1__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq = (function(f, ordering, vendor) {
  var endpoints = $as_Lamf_core_model_domain_AmfArray(f.value$1.value$1).values$1;
  var notOas = (!vendor.contains__O__Z($m_Lamf_core_remote_Oas$()));
  if (notOas) {
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(e$2) {
        var e = $as_Lamf_plugins_domain_webapi_models_EndPoint(e$2);
        var xo = e.parent__s_Option();
        var this$2 = xo.toList__sci_List();
        var this$3 = $m_sci_Set$();
        var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$3);
        return new $c_T2().init___O__O(e, $as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this$2, cbf)))
      })
    })(this));
    var this$4 = $m_sc_Seq$();
    var graph = $as_sc_TraversableOnce(endpoints.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2);
    var all = $as_scm_ListMap($m_scm_ListMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var this$5 = $m_Lamf_core_utils_TSort$().tsort__sci_Map__sc_Iterable__s_util_Either(graph, $as_sc_Iterable($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
    if ((this$5 instanceof $c_s_util_Right)) {
      var x2 = $as_s_util_Right(this$5);
      var b = x2.value$2;
      var x$9 = $as_sc_Iterable(b);
      x$9.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, ordering$2, all$1) {
        return (function(e$2$1) {
          var e$1 = $as_Lamf_plugins_domain_webapi_models_EndPoint(e$2$1);
          var emitter = $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter($this$1.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory().endpointEmitter__F4().apply__O__O__O__O__O(e$1, ordering$2, $m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()), $this$1.references$1));
          var x1 = e$1.parent__s_Option();
          if ((x1 instanceof $c_s_Some)) {
            var x2$1 = $as_s_Some(x1);
            var parent = $as_Lamf_plugins_domain_webapi_models_EndPoint(x2$1.value$2);
            $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter($f_sc_MapLike__apply__O__O(all$1, parent)).$$plus$eq__Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter__V(emitter);
            return all$1.$$plus$eq__T2__scm_ListMap(new $c_T2().init___O__O(e$1, emitter))
          } else {
            return all$1.$$plus$eq__T2__scm_ListMap(new $c_T2().init___O__O(e$1, emitter))
          }
        })
      })(this, ordering, all)))
    };
    var p = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
      return (function(x$10$2) {
        var x$10 = $as_Lamf_plugins_domain_webapi_models_EndPoint(x$10$2);
        return x$10.parent__s_Option().isEmpty__Z()
      })
    })(this));
    var this$10 = new $c_sc_MapLike$FilteredKeys().init___sc_MapLike__F1(all, p);
    var this$11 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$10);
    return this.defaultOrder$1__p1__sc_Seq__sc_Seq(this$11.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream())
  } else {
    var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, ordering$1) {
      return (function(x$11$2) {
        var x$11 = $as_Lamf_plugins_domain_webapi_models_EndPoint(x$11$2);
        return $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter(this$4$1.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory().endpointEmitter__F4().apply__O__O__O__O__O(x$11, ordering$1, $m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()), this$4$1.references$1))
      })
    })(this, ordering));
    var this$12 = $m_sc_Seq$();
    return $as_sc_Seq(endpoints.map__F1__scg_CanBuildFrom__O(jsx$2, this$12.ReusableCBFInstance$2))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlDocumentEmitter$WebApiEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlDocumentEmitter$WebApiEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlDocumentEmitter$WebApiEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser.prototype.productPrefix__T = (function() {
  return "AnnotationFragmentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser__Lorg_yaml_model_YMap = (function($$outer, map) {
  this.map$1 = map;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser(x$1).$$outer$1 === this.$$outer$1))) {
    var AnnotationFragmentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser(x$1);
    var this$1 = this.map$1;
    var b = AnnotationFragmentParser$1.map$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser.prototype.parse__Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var x$1 = this.$$outer$1.root$2.location$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var annotation = $as_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
  var property = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser__Lorg_yaml_model_YPart__T__Lorg_yaml_model_YMap__F1(this.$$outer$1, this.map$1, "annotation", this.map$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(annotation$2$2) {
      var annotation$2 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(annotation$2$2);
      annotation$2.adopted__T__sc_Seq__Lamf_core_model_domain_extensions_CustomDomainProperty(($this.$$outer$1.root$2.location$1 + "#/"), $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())))
    })
  })(this))).parse__Lamf_core_model_domain_extensions_CustomDomainProperty();
  var field = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
  return $as_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(annotation, field, property)))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser$AnnotationFragmentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser$AnnotationFragmentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser$AnnotationFragmentParser", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser.prototype.productPrefix__T = (function() {
  return "DataTypeFragmentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser__Lorg_yaml_model_YMap = (function($$outer, map) {
  this.map$1 = map;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser(x$1).$$outer$1 === this.$$outer$1))) {
    var DataTypeFragmentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser(x$1);
    var this$1 = this.map$1;
    var b = DataTypeFragmentParser$1.map$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser.prototype.parse__Lamf_plugins_document_webapi_model_DataTypeFragment = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_document_webapi_model_DataTypeFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var x$1 = this.$$outer$1.root$2.location$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var dataType = $as_Lamf_plugins_document_webapi_model_DataTypeFragment($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
  var jsx$1 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$();
  $m_Lorg_yaml_model_YNode$();
  var map = this.map$1;
  $m_Lorg_yaml_model_YNode$();
  var this$6 = jsx$1.apply__Lorg_yaml_model_YNode__T__F1__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1), "type", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(shape$2) {
      var shape = $as_Lamf_core_model_domain_Shape(shape$2);
      var value = ($this.$$outer$1.root$2.location$1 + "#/shape");
      $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(shape, value)
    })
  })(this)), $m_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$(), this.$$outer$1.ctx$2).parse__s_Option();
  if ((!this$6.isEmpty__Z())) {
    var arg1 = this$6.get__O();
    var encoded = $as_Lamf_core_model_domain_DomainElement(arg1);
    var field = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
    $as_Lamf_plugins_document_webapi_model_DataTypeFragment($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(dataType, field, encoded)))
  };
  return dataType
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser$DataTypeFragmentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser$DataTypeFragmentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser$DataTypeFragmentParser", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser.prototype.productPrefix__T = (function() {
  return "DocumentationItemFragmentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser__Lorg_yaml_model_YMap = (function($$outer, map) {
  this.map$1 = map;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser.prototype.parse__Lamf_plugins_document_webapi_model_DocumentationItemFragment = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_document_webapi_model_DocumentationItemFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var x$1 = this.$$outer$1.root$2.location$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var item = $as_Lamf_plugins_document_webapi_model_DocumentationItemFragment($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
  $m_Lorg_yaml_model_YNode$();
  var map = this.map$1;
  $m_Lorg_yaml_model_YNode$();
  var encoded = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser().init___Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1), this.$$outer$1.ctx$2).parse__Lamf_plugins_domain_shapes_models_CreativeWork();
  var field = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
  $as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(item, field, encoded));
  return item
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser(x$1).$$outer$1 === this.$$outer$1))) {
    var DocumentationItemFragmentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser(x$1);
    var this$1 = this.map$1;
    var b = DocumentationItemFragmentParser$1.map$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser$DocumentationItemFragmentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser$DocumentationItemFragmentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser$DocumentationItemFragmentParser", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser.prototype.productPrefix__T = (function() {
  return "NamedExampleFragmentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser__Lorg_yaml_model_YMap = (function($$outer, map) {
  this.map$1 = map;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser(x$1).$$outer$1 === this.$$outer$1))) {
    var NamedExampleFragmentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser(x$1);
    var this$1 = this.map$1;
    var b = NamedExampleFragmentParser$1.map$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser$NamedExampleFragmentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser$NamedExampleFragmentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser$NamedExampleFragmentParser", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser.prototype.productPrefix__T = (function() {
  return "ResourceTypeFragmentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser__Lorg_yaml_model_YMap = (function($$outer, map) {
  this.map$1 = map;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser(x$1).$$outer$1 === this.$$outer$1))) {
    var ResourceTypeFragmentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser(x$1);
    var this$1 = this.map$1;
    var b = ResourceTypeFragmentParser$1.map$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser.prototype.parse__Lamf_plugins_document_webapi_model_ResourceTypeFragment = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_document_webapi_model_ResourceTypeFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var x$1 = (this.$$outer$1.root$2.location$1 + "#");
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var resourceType = $as_Lamf_plugins_document_webapi_model_ResourceTypeFragment($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
  var jsx$2 = $as_Lamf_core_model_domain_templates_AbstractDeclaration($m_Lamf_plugins_domain_webapi_models_templates_ResourceType$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_templates_ResourceType(this.map$1).withId__T__Lamf_core_model_domain_AmfObject(resourceType.id$1));
  var jsx$1 = resourceType.id$1;
  $m_Lorg_yaml_model_YNode$();
  var map = this.map$1;
  $m_Lorg_yaml_model_YNode$();
  var node = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1);
  var errorHandler = this.$$outer$1.ctx$2;
  var abstractDeclaration = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser().init___Lamf_core_model_domain_templates_AbstractDeclaration__T__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_plugins_document_webapi_contexts_WebApiContext(jsx$2, jsx$1, new $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, errorHandler), this.$$outer$1.ctx$2).parse__Lamf_core_model_domain_templates_AbstractDeclaration();
  var field = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
  return $as_Lamf_plugins_document_webapi_model_ResourceTypeFragment($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(resourceType, field, abstractDeclaration)))
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser$ResourceTypeFragmentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser$ResourceTypeFragmentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser$ResourceTypeFragmentParser", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser.prototype.productPrefix__T = (function() {
  return "SecuritySchemeFragmentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser__Lorg_yaml_model_YMap = (function($$outer, map) {
  this.map$1 = map;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser(x$1).$$outer$1 === this.$$outer$1))) {
    var SecuritySchemeFragmentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser(x$1);
    var this$1 = this.map$1;
    var b = SecuritySchemeFragmentParser$1.map$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser.prototype.parse__Lamf_plugins_document_webapi_model_SecuritySchemeFragment = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var x$1 = this.$$outer$1.root$2.location$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var security = $as_Lamf_plugins_document_webapi_model_SecuritySchemeFragment($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
  var encoded = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser().init___Lorg_yaml_model_YPart__F1__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this.map$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(security$2$2) {
      var security$2 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(security$2$2);
      return security$2.adopted__T__sc_Seq__Lamf_plugins_domain_webapi_models_security_SecurityScheme(($this.$$outer$1.root$2.location$1 + "#/"), $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())))
    })
  })(this)), this.$$outer$1.ctx$2).parse__Lamf_plugins_domain_webapi_models_security_SecurityScheme();
  var field = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
  return $as_Lamf_plugins_document_webapi_model_SecuritySchemeFragment($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(security, field, encoded)))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser$SecuritySchemeFragmentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser$SecuritySchemeFragmentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser$SecuritySchemeFragmentParser", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser.prototype.productPrefix__T = (function() {
  return "TraitFragmentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser__Lorg_yaml_model_YMap = (function($$outer, map) {
  this.map$1 = map;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser(x$1).$$outer$1 === this.$$outer$1))) {
    var TraitFragmentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser(x$1);
    var this$1 = this.map$1;
    var b = TraitFragmentParser$1.map$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser.prototype.parse__Lamf_plugins_document_webapi_model_TraitFragment = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_document_webapi_model_TraitFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var x$1 = (this.$$outer$1.root$2.location$1 + "#");
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var traitFragment = $as_Lamf_plugins_document_webapi_model_TraitFragment($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
  var jsx$2 = $as_Lamf_core_model_domain_templates_AbstractDeclaration($m_Lamf_plugins_domain_webapi_models_templates_Trait$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_templates_Trait(this.map$1).withId__T__Lamf_core_model_domain_AmfObject(traitFragment.id$1));
  var jsx$1 = traitFragment.id$1;
  $m_Lorg_yaml_model_YNode$();
  var map = this.map$1;
  $m_Lorg_yaml_model_YNode$();
  var node = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1);
  var errorHandler = this.$$outer$1.ctx$2;
  var abstractDeclaration = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser().init___Lamf_core_model_domain_templates_AbstractDeclaration__T__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_plugins_document_webapi_contexts_WebApiContext(jsx$2, jsx$1, new $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, errorHandler), this.$$outer$1.ctx$2).parse__Lamf_core_model_domain_templates_AbstractDeclaration();
  var field = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
  return $as_Lamf_plugins_document_webapi_model_TraitFragment($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(traitFragment, field, abstractDeclaration)))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser$TraitFragmentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser$TraitFragmentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser$TraitFragmentParser", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter() {
  $c_O.call(this);
  this.module$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter.prototype.productPrefix__T = (function() {
  return "RamlModuleEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter)) {
    var RamlModuleEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter(x$1);
    var x = this.module$1;
    var x$2 = RamlModuleEmitter$1.module$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.module$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter.prototype.init___Lamf_core_model_document_Module__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(module, spec) {
  this.module$1 = module;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter.prototype.emitModule__Lorg_yaml_model_YDocument = (function() {
  var ordering = $m_Lamf_core_emitter_SpecOrdering$().ordering__Lamf_core_remote_Vendor__Lamf_core_parser_Annotations__Lamf_core_emitter_SpecOrdering($m_Lamf_core_remote_Raml$(), this.module$1.annotations$1);
  var emitters = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters(this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory().rootLevelEmitters__F2().apply__O__O__O(this.module$1, ordering)).emitters__sc_Seq();
  var this$2 = $m_Lorg_yaml_model_YDocument$().apply__T__Lorg_yaml_model_YDocument$WithComment("");
  var b = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(this$2.org$yaml$model$YDocument$WithComment$$sourceName$f);
  var x = this$2.comment$1;
  var this$4 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$4)) {
    b.comment__T__V(this$2.comment$1)
  };
  b.comment__T__V($m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$().text$1);
  if (emitters.nonEmpty__Z()) {
    var jsx$1 = b.builder$1;
    var sourceName = b.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(ordering.sorted__sc_Seq__sc_Seq(emitters), b$1);
    jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  };
  return new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this$2.org$yaml$model$YDocument$WithComment$$sourceName$f), b.builder$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlModuleEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlModuleEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlModuleEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser() {
  $c_O.call(this);
  this.ast$1 = null;
  this.annotationName$1 = null;
  this.map$1 = null;
  this.adopt$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser.prototype.productPrefix__T = (function() {
  return "AnnotationTypesParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser(x$1).$$outer$1 === this.$$outer$1))) {
    var AnnotationTypesParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser(x$1);
    var x = this.ast$1;
    var x$2 = AnnotationTypesParser$1.ast$1;
    if ((((x === null) ? (x$2 === null) : x.equals__O__Z(x$2)) && (this.annotationName$1 === AnnotationTypesParser$1.annotationName$1))) {
      var this$1 = this.map$1;
      var b = AnnotationTypesParser$1.map$1;
      var jsx$1 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.adopt$1;
      var x$4 = AnnotationTypesParser$1.adopt$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.ast$1;
      break
    }
    case 1: {
      return this.annotationName$1;
      break
    }
    case 2: {
      return this.map$1;
      break
    }
    case 3: {
      return this.adopt$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser__Lorg_yaml_model_YPart__T__Lorg_yaml_model_YMap__F1 = (function($$outer, ast, annotationName, map, adopt) {
  this.ast$1 = ast;
  this.annotationName$1 = annotationName;
  this.map$1 = map;
  this.adopt$1 = adopt;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser.prototype.parse__Lamf_core_model_domain_extensions_CustomDomainProperty = (function() {
  var custom = $m_Lamf_core_model_domain_extensions_CustomDomainProperty$().apply__Lorg_yaml_model_YPart__Lamf_core_model_domain_extensions_CustomDomainProperty(this.ast$1);
  var name = this.annotationName$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(custom, name, a);
  this.adopt$1.apply__O__O(custom);
  var x1 = this.ast$1;
  if ((x1 instanceof $c_Lorg_yaml_model_YMapEntry)) {
    var x2 = $as_Lorg_yaml_model_YMapEntry(x1);
    var maybeAnnotationType = new $c_s_Some().init___O(x2)
  } else if ((x1 instanceof $c_Lorg_yaml_model_YMap)) {
    var x3 = $as_Lorg_yaml_model_YMap(x1);
    var maybeAnnotationType = new $c_s_Some().init___O($m_Lorg_yaml_model_YMapEntry$().apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry($m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("annotationType"), ($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(x3, $m_Lorg_yaml_model_YType$().Map$1))))
  } else {
    var maybeAnnotationType = $m_s_None$()
  };
  if ((maybeAnnotationType instanceof $c_s_Some)) {
    var x2$2 = $as_s_Some(maybeAnnotationType);
    var annotationType = $as_Lorg_yaml_model_YMapEntry(x2$2.value$2);
    var this$5 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(annotationType, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, custom$1) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        $m_Lamf_core_parser_Annotations$();
        var a$1 = new $c_Lamf_core_parser_Annotations().init___();
        var qual$1 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, "schema", a$1));
        var x$1 = custom$1.id$1;
        var x$2 = qual$1.adopted$default$2__sc_Seq();
        qual$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$1, x$2)
      })
    })(this, custom)), new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo().init___Z__Z(true, false), $m_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$(), this.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f).parse__s_Option();
    if ((!this$5.isEmpty__Z())) {
      var arg1 = this$5.get__O();
      var shape$3 = $as_Lamf_core_model_domain_Shape(arg1);
      $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(shape$3, custom.id$1, $m_s_None$());
      var field = $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Schema$1;
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.ast$1);
      $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(custom, field, shape$3, annotations))
    };
    var map = this.map$1;
    var this$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var this$9 = this$8.key__T__s_Option("allowedTargets");
    if ((!this$9.isEmpty__Z())) {
      var arg1$1 = this$9.get__O();
      var entry = $as_Lorg_yaml_model_YMapEntry(arg1$1);
      var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
      var this$10 = entry.value$2;
      var x1$1 = this$10.tag__Lorg_yaml_model_YTag().tagType$3;
      var x = $m_Lorg_yaml_model_YType$().Seq$1;
      if ((x === x1$1)) {
        var node = entry.value$2;
        var iv = this.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f;
        var this$12 = new $c_Lamf_core_parser_DefaultArrayNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
        var targets = $f_Lamf_core_parser_BaseArrayNode__string__Lamf_core_model_domain_AmfArray(this$12)
      } else {
        var x$3 = $m_Lorg_yaml_model_YType$().Map$1;
        if ((x$3 === x1$1)) {
          var this$13 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f.eh$1;
          var specification = $m_Lamf_validations_ParserSideValidations$().InvalidAllowedTargetsType$1;
          var node$1 = custom.id$1;
          var ast = entry.value$2;
          var prop = $m_s_None$();
          var l = ast.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$13, specification, node$1, prop, "Property 'allowedTargets' in a RAML annotation can only be a valid scalar or an array of valid scalars", l);
          var targets = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), new $c_Lamf_core_parser_Annotations().init___())
        } else {
          annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SingleValueArray().init___());
          var jsx$1 = $m_sc_Seq$();
          var node$2 = entry.value$2;
          var iv$1 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f;
          var this$16 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$2, iv$1);
          var array = [this$16.string__Lamf_core_model_domain_AmfScalar()];
          var targets = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))), new $c_Lamf_core_parser_Annotations().init___())
        }
      };
      var jsx$3 = targets.values$1;
      var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
        return (function(x0$1$2) {
          var x0$1 = $as_Lamf_core_model_domain_AmfElement(x0$1$2);
          if ((x0$1 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
            var x2$1 = $as_Lamf_core_model_domain_AmfScalar(x0$1);
            var x1$2 = $m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().ramlToUri$1.get__O__s_Option(x2$1.toString__T());
            if ((x1$2 instanceof $c_s_Some)) {
              var x2$2$1 = $as_s_Some(x1$2);
              var uri = $as_T(x2$2$1.value$2);
              return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(uri, x2$1.annotations$1)
            } else {
              var x$4 = $m_s_None$();
              if ((x$4 === x1$2)) {
                return x2$1
              } else {
                throw new $c_s_MatchError().init___O(x1$2)
              }
            }
          } else {
            return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(x0$1.toString__T(), x0$1.annotations__Lamf_core_parser_Annotations())
          }
        })
      })(this));
      var this$20 = $m_sc_Seq$();
      var targetUris = $as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$20.ReusableCBFInstance$2));
      var field$1 = $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Domain$1;
      var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(targetUris, new $c_Lamf_core_parser_Annotations().init___());
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(custom, field$1, value, annotations$1)
    };
    var map$1 = this.map$1;
    var this$23 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
    var this$24 = this$23.key__T__s_Option("description");
    if ((!this$24.isEmpty__Z())) {
      var arg1$2 = this$24.get__O();
      var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
      var node$3 = entry$3.value$2;
      var iv$2 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f;
      var value$1 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$3, iv$2);
      var field$2 = $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Description$1;
      var value$2 = value$1.string__Lamf_core_model_domain_AmfScalar();
      var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(custom, field$2, value$2, annotations$2)
    };
    new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(custom, this.map$1, $m_sci_Nil$(), this.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f).parse__V();
    return custom
  } else {
    var x$5 = $m_s_None$();
    if ((x$5 === maybeAnnotationType)) {
      var this$27 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f.eh$1;
      var specification$1 = $m_Lamf_validations_ParserSideValidations$().InvalidAnnotationType$1;
      var node$4 = custom.id$1;
      var ast$1 = this.ast$1;
      var prop$1 = $m_s_None$();
      var l$1 = ast$1.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$27, specification$1, node$4, prop$1, "Cannot parse annotation type fragment, cannot find information map", l$1);
      return custom
    } else {
      throw new $c_s_MatchError().init___O(maybeAnnotationType)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlSpecParser$AnnotationTypesParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlSpecParser$AnnotationTypesParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlSpecParser$AnnotationTypesParser", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.baseUnit$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser.prototype.productPrefix__T = (function() {
  return "UsageParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser(x$1).$$outer$1 === this.$$outer$1))) {
    var UsageParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser(x$1);
    var this$1 = this.map$1;
    var b = UsageParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.baseUnit$1;
      var x$2 = UsageParser$1.baseUnit$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.baseUnit$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser__Lorg_yaml_model_YMap__Lamf_core_model_document_BaseUnit = (function($$outer, map, baseUnit) {
  this.map$1 = map;
  this.baseUnit$1 = baseUnit;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser.prototype.parse__V = (function() {
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("usage");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var x1 = this$4.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Str$1;
    if ((x === x1)) {
      var node = entry.value$2;
      var iv = this.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f;
      var value = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
      var this$6 = this.baseUnit$1;
      var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1;
      var value$1 = value.string__Lamf_core_model_domain_AmfScalar();
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$6, field, value$1, annotations)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlSpecParser$UsageParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlSpecParser$UsageParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlSpecParser$UsageParser", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser() {
  $c_O.call(this);
  this.seq$1 = null;
  this.declarations$1 = null;
  this.parent$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser.prototype.productPrefix__T = (function() {
  return "UserDocumentationsParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser__sc_Seq__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__T = (function($$outer, seq, declarations, parent) {
  this.seq$1 = seq;
  this.declarations$1 = declarations;
  this.parent$1 = parent;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser(x$1).$$outer$1 === this.$$outer$1))) {
    var UserDocumentationsParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser(x$1);
    var x = this.seq$1;
    var x$2 = UserDocumentationsParser$1.seq$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.declarations$1;
      var x$4 = UserDocumentationsParser$1.declarations$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.parent$1 === UserDocumentationsParser$1.parent$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.seq$1;
      break
    }
    case 1: {
      return this.declarations$1;
      break
    }
    case 2: {
      return this.parent$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser.prototype.parse__sc_Seq = (function() {
  var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  this.seq$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, results$1) {
    return (function(n$2) {
      var n = $as_Lorg_yaml_model_YNode(n$2);
      var x1 = n.tag__Lorg_yaml_model_YTag().tagType$3;
      var x = $m_Lorg_yaml_model_YType$().Map$1;
      if ((x === x1)) {
        return results$1.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser().init___Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext(n, $this.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f).parse__Lamf_plugins_domain_shapes_models_CreativeWork())
      } else {
        var x$3 = $m_Lorg_yaml_model_YType$().Seq$1;
        if ((x$3 === x1)) {
          var this$1 = $this.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f.eh$1;
          var specification = $m_Lamf_validations_ParserSideValidations$().InvalidDocumentationType$1;
          var node = $this.parent$1;
          var prop = $m_s_None$();
          var l = n.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, node, prop, "Unexpected sequence. Options are object or scalar ", l);
          return (void 0)
        } else {
          var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
          var iv = $this.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f;
          var scalar = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(n, conversion, iv));
          var x1$2 = $this.declarations$1.findDocumentations__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option(scalar.text$3, $m_Lamf_core_parser_SearchScope$Fragments$(), new $c_s_Some().init___O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, scalar$1) {
            return (function(s$2) {
              var s = $as_T(s$2);
              var this$2 = $this$1.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f.eh$1;
              var specification$1 = $m_Lamf_validations_ParserSideValidations$().InvalidFragmentType$1;
              var prop$1 = $m_s_None$();
              var l$1 = scalar$1.location$1;
              $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$2, specification$1, "", prop$1, s, l$1)
            })
          })($this, scalar))));
          if ((x1$2 instanceof $c_s_Some)) {
            var x2 = $as_s_Some(x1$2);
            var doc = $as_Lamf_plugins_domain_shapes_models_CreativeWork(x2.value$2);
            var label = scalar.text$3;
            $m_Lamf_core_parser_Annotations$();
            var annotations = new $c_Lamf_core_parser_Annotations().init___();
            return results$1.$$plus$eq__O__scm_ListBuffer($as_Lamf_plugins_domain_shapes_models_CreativeWork($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(doc, label, annotations)))
          } else {
            var this$4 = $this.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlSpecParser$$ctx$f.eh$1;
            var specification$2 = $m_Lamf_plugins_features_validation_CoreValidations$().DeclarationNotFound$1;
            var node$1 = $this.parent$1;
            var message = (("not supported scalar " + scalar.text$3) + " for documentation");
            var prop$2 = $m_s_None$();
            var l$2 = scalar.location$1;
            $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$4, specification$2, node$1, prop$2, message, l$2);
            return (void 0)
          }
        }
      }
    })
  })(this, results)));
  return results
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlSpecParser$UserDocumentationsParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlSpecParser$UserDocumentationsParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlSpecParser$UserDocumentationsParser", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters() {
  $c_O.call(this);
  this.apiKey$1 = null;
  this.ordering$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters.prototype.productPrefix__T = (function() {
  return "RamlApiKeySettingsEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters)) {
    var RamlApiKeySettingsEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters(x$1);
    var x = this.apiKey$1;
    var x$2 = RamlApiKeySettingsEmitters$1.apiKey$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlApiKeySettingsEmitters$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.apiKey$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters.prototype.emitters__sc_Seq = (function() {
  var this$1 = this.apiKey$1;
  var fs = this$1.fields$1;
  var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().Name$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("name", f, $m_s_None$())))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().In$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("in", f$3, $m_s_None$())))
  };
  return results
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters.prototype.init___Lamf_plugins_domain_webapi_models_security_ApiKeySettings__Lamf_core_emitter_SpecOrdering = (function(apiKey, ordering) {
  this.apiKey$1 = apiKey;
  this.ordering$1 = ordering;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.emitters.RamlApiKeySettingsEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.emitters.RamlApiKeySettingsEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.emitters.RamlApiKeySettingsEmitters", {
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters() {
  $c_O.call(this);
  this.o1$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters.prototype.productPrefix__T = (function() {
  return "RamlOAuth1SettingsEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters)) {
    var RamlOAuth1SettingsEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters(x$1);
    var x = this.o1$1;
    var x$2 = RamlOAuth1SettingsEmitters$1.o1$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlOAuth1SettingsEmitters$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.o1$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters.prototype.emitters__sc_Seq = (function() {
  var this$1 = this.o1$1;
  var fs = this$1.fields$1;
  var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$().RequestTokenUri$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(results.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("requestTokenUri", f, $m_s_None$(), this.spec$1)))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$().AuthorizationUri$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(results.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("authorizationUri", f$3, $m_s_None$(), this.spec$1)))
  };
  var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$().TokenCredentialsUri$1);
  if ((!this$6.isEmpty__Z())) {
    var arg1$2 = this$6.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(results.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("tokenCredentialsUri", f$4, $m_s_None$(), this.spec$1)))
  };
  var this$8 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$().Signatures$1);
  if ((!this$8.isEmpty__Z())) {
    var arg1$3 = this$8.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    new $c_s_Some().init___O(results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType("signatures", f$5, this.ordering$1, false, $m_Lorg_yaml_model_YType$().Str$1)))
  };
  return results
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters.prototype.init___Lamf_plugins_domain_webapi_models_security_OAuth1Settings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(o1, ordering, spec) {
  this.o1$1 = o1;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.emitters.RamlOAuth1SettingsEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.emitters.RamlOAuth1SettingsEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.emitters.RamlOAuth1SettingsEmitters", {
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters() {
  $c_O.call(this);
  this.o2$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters.prototype.productPrefix__T = (function() {
  return "RamlOAuth2SettingsEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters)) {
    var RamlOAuth2SettingsEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters(x$1);
    var x = this.o2$1;
    var x$2 = RamlOAuth2SettingsEmitters$1.o2$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlOAuth2SettingsEmitters$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.o2$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters.prototype.emitters__sc_Seq = (function() {
  var this$1 = this.o2$1;
  var fs = this$1.fields$1;
  var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = this.o2$1;
  var this$3 = $as_sc_Seq(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1)).headOption__s_Option();
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var x$6 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow(arg1);
    this.flowEmitters__Lamf_plugins_domain_webapi_models_security_OAuth2Flow__scm_ListBuffer__V(x$6, results)
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().AuthorizationGrants$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType("authorizationGrants", f, this.ordering$1, false, $m_Lorg_yaml_model_YType$().Str$1)))
  };
  return results
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters.prototype.init___Lamf_plugins_domain_webapi_models_security_OAuth2Settings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(o2, ordering, spec) {
  this.o2$1 = o2;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters.prototype.flowEmitters__Lamf_plugins_domain_webapi_models_security_OAuth2Flow__scm_ListBuffer__V = (function(flow, results) {
  var fs = flow.fields$1;
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("authorizationUri", f, $m_s_None$())))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(results.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("accessTokenUri", f$3, $m_s_None$(), this.spec$1)))
  };
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Scopes$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1$2 = this$5.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering("scopes", f$4, this.ordering$1)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.emitters.RamlOAuth2SettingsEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.emitters.RamlOAuth2SettingsEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.emitters.RamlOAuth2SettingsEmitters", {
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters() {
  $c_O.call(this);
  this.f$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters.prototype.productPrefix__T = (function() {
  return "RamlSecuritySettingsValuesEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(f, ordering, spec) {
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters)) {
    var RamlSecuritySettingsValuesEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters(x$1);
    var x = this.f$1;
    var x$2 = RamlSecuritySettingsValuesEmitters$1.f$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlSecuritySettingsValuesEmitters$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.f$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters.prototype.emitters__sc_Seq = (function() {
  var settings = $as_Lamf_plugins_domain_webapi_models_security_Settings(this.f$1.value$1.value$1);
  var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(settings);
    var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth1SettingsEmitters().init___Lamf_plugins_domain_webapi_models_security_OAuth1Settings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x2, this.ordering$1, this.spec$1).emitters__sc_Seq()
  } else if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings)) {
    var x3 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(settings);
    var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2SettingsEmitters().init___Lamf_plugins_domain_webapi_models_security_OAuth2Settings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x3, this.ordering$1, this.spec$1).emitters__sc_Seq()
  } else if ((settings instanceof $c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings)) {
    var x4 = $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(settings);
    var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlApiKeySettingsEmitters().init___Lamf_plugins_domain_webapi_models_security_ApiKeySettings__Lamf_core_emitter_SpecOrdering(x4, this.ordering$1).emitters__sc_Seq()
  } else {
    var jsx$1 = $m_sci_Nil$()
  };
  results.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(jsx$1);
  var this$1 = settings.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().AdditionalProperties$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    results.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler($as_Lamf_core_model_domain_DataNode(f.value$1.value$1), this.ordering$1, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler()).emitters__sc_Seq())
  };
  return results
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.emitters.RamlSecuritySettingsValuesEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.emitters.RamlSecuritySettingsValuesEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.emitters.RamlSecuritySettingsValuesEmitters", {
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer() {
  $c_O.call(this);
  this.branches$1 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_BranchContainer() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_BranchContainer.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer.prototype.productPrefix__T = (function() {
  return "BranchContainer"
});
$c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer)) {
    var BranchContainer$1 = $as_Lamf_plugins_document_webapi_resolution_stages_BranchContainer(x$1);
    var x = this.branches$1;
    var x$2 = BranchContainer$1.branches$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.branches$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer.prototype.collect__p1__scm_Set__scm_ListBuffer__sc_Seq__V = (function(visited, queue, previous) {
  _collect: while (true) {
    var branches = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    previous.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, visited$1, branches$1) {
      return (function(prev$2) {
        var prev = $as_Lamf_plugins_document_webapi_resolution_stages_Branch(prev$2);
        $as_sc_IterableLike(prev.children$1.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, visited$1$1) {
          return (function(c$2) {
            var c = $as_Lamf_plugins_document_webapi_resolution_stages_Branch(c$2);
            return visited$1$1.add__O__Z(c.key$1)
          })
        })($this, visited$1)))).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, branches$1$1) {
          return (function(x$4$2) {
            var x$4 = $as_Lamf_plugins_document_webapi_resolution_stages_Branch(x$4$2);
            return branches$1$1.$$plus$eq__O__scm_ListBuffer(x$4)
          })
        })($this, branches$1)))
      })
    })(this, visited, branches)));
    queue.$$plus$eq__O__scm_ListBuffer(branches);
    if (branches.nonEmpty__Z()) {
      previous = branches;
      continue _collect
    };
    break
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer.prototype.flatten__sc_Seq = (function() {
  var visited = $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var queue = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  queue.$$plus$eq__O__scm_ListBuffer(this.branches$1);
  var jsx$2 = this.branches$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_plugins_document_webapi_resolution_stages_Branch(x$1$2);
      return x$1.key$1
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var xs = $as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(visited, xs);
  this.collect__p1__scm_Set__scm_ListBuffer__sc_Seq__V(visited, queue, this.branches$1);
  var z = $m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$());
  var this$2 = queue.scala$collection$mutable$ListBuffer$$start$6;
  var acc = z;
  var these = this$2;
  while ((!these.isEmpty__Z())) {
    var arg1 = acc;
    var arg2 = these.head__O();
    var x$2 = $as_sc_Seq(arg1);
    var x$3 = $as_sc_Seq(arg2);
    var this$3 = $m_sc_Seq$();
    acc = $as_sc_Seq(x$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(x$3, this$3.ReusableCBFInstance$2));
    these = $as_sc_LinearSeqOptimized(these.tail__O())
  };
  return $as_sc_Seq(acc)
});
$c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer.prototype.init___sc_Seq = (function(branches) {
  this.branches$1 = branches;
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_resolution_stages_BranchContainer(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.resolution.stages.BranchContainer"))
}
function $isArrayOf_Lamf_plugins_document_webapi_resolution_stages_BranchContainer(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_resolution_stages_BranchContainer)))
}
function $asArrayOf_Lamf_plugins_document_webapi_resolution_stages_BranchContainer(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_resolution_stages_BranchContainer(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.resolution.stages.BranchContainer;", depth))
}
var $d_Lamf_plugins_document_webapi_resolution_stages_BranchContainer = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_BranchContainer: 0
}, false, "amf.plugins.document.webapi.resolution.stages.BranchContainer", {
  Lamf_plugins_document_webapi_resolution_stages_BranchContainer: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_BranchContainer;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_Context() {
  $c_O.call(this);
  this.model$1 = null;
  this.variables$1 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_Context.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_resolution_stages_Context.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_Context;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_Context() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_Context.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_Context.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_Context.prototype.productPrefix__T = (function() {
  return "Context"
});
$c_Lamf_plugins_document_webapi_resolution_stages_Context.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_resolution_stages_Context.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_resolution_stages_Context)) {
    var Context$1 = $as_Lamf_plugins_document_webapi_resolution_stages_Context(x$1);
    var x = this.model$1;
    var x$2 = Context$1.model$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.variables$1;
      var x$4 = Context$1.variables$1;
      return ((x$3 === null) ? (x$4 === null) : $f_sc_GenSetLike__equals__O__Z(x$3, x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_Context.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.model$1;
      break
    }
    case 1: {
      return this.variables$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_Context.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_resolution_stages_Context.prototype.add__T__T__Lamf_plugins_document_webapi_resolution_stages_Context = (function(name, value) {
  var jsx$1 = this.variables$1;
  var this$1 = $m_Lamf_core_model_domain_ScalarNode$();
  var dataType = $m_s_None$();
  var x$1 = $as_sci_Set(jsx$1.$$plus__O__sc_Set(new $c_Lamf_core_model_domain_templates_Variable().init___T__Lamf_core_model_domain_DataNode(name, this$1.apply__T__s_Option__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode(value, dataType, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___())))));
  var x$2 = this.model$1;
  return new $c_Lamf_plugins_document_webapi_resolution_stages_Context().init___Lamf_core_model_document_BaseUnit__sci_Set(x$2, x$1)
});
$c_Lamf_plugins_document_webapi_resolution_stages_Context.prototype.init___Lamf_core_model_document_BaseUnit__sci_Set = (function(model, variables) {
  this.model$1 = model;
  this.variables$1 = variables;
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_Context.prototype.add__sc_Seq__Lamf_plugins_document_webapi_resolution_stages_Context = (function(vs) {
  var jsx$2 = this.variables$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(v$2) {
      var v = $as_Lamf_core_model_domain_templates_VariableValue(v$2);
      var this$1 = $as_Lamf_core_model_StrField(v.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_VariableValueModel$().Name$1));
      var this$2 = this$1.option$1;
      return new $c_Lamf_core_model_domain_templates_Variable().init___T__Lamf_core_model_domain_DataNode($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())), $as_Lamf_core_model_domain_DataNode(v.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_VariableValueModel$().Value$1)))
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  var x$1 = $as_sci_Set(jsx$2.$$plus$plus__sc_GenTraversableOnce__sc_Set($as_sc_GenTraversableOnce(vs.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))));
  var x$2 = this.model$1;
  return new $c_Lamf_plugins_document_webapi_resolution_stages_Context().init___Lamf_core_model_document_BaseUnit__sci_Set(x$2, x$1)
});
$c_Lamf_plugins_document_webapi_resolution_stages_Context.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_resolution_stages_Context.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_resolution_stages_Context(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_resolution_stages_Context) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.resolution.stages.Context"))
}
function $isArrayOf_Lamf_plugins_document_webapi_resolution_stages_Context(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_resolution_stages_Context)))
}
function $asArrayOf_Lamf_plugins_document_webapi_resolution_stages_Context(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_resolution_stages_Context(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.resolution.stages.Context;", depth))
}
var $d_Lamf_plugins_document_webapi_resolution_stages_Context = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_Context: 0
}, false, "amf.plugins.document.webapi.resolution.stages.Context", {
  Lamf_plugins_document_webapi_resolution_stages_Context: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_Context.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_Context;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches() {
  $c_O.call(this);
  this.extendsContext$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches.prototype.productPrefix__T = (function() {
  return "Branches"
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches.prototype.init___Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function($$outer, extendsContext) {
  this.extendsContext$1 = extendsContext;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches.prototype.equals__O__Z = (function(x$1) {
  return (((x$1 instanceof $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches) && ($as_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches(x$1).$$outer$1 === this.$$outer$1)) && ($as_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches(x$1), true))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches.prototype.method__Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver__Lamf_plugins_domain_webapi_models_Operation__Lamf_plugins_document_webapi_resolution_stages_Context__Lamf_core_model_domain_ElementTree__Lamf_plugins_document_webapi_resolution_stages_BranchContainer = (function(resolver, operation, context, tree) {
  return new $c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer().init___sc_Seq(this.resolveTraits__p1__Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver__sc_Seq__Lamf_plugins_document_webapi_resolution_stages_Context__sc_Seq__sc_Seq(resolver, operation.traits__sc_Seq(), context, tree.subtrees$1))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches.prototype.resourceType__Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_document_webapi_resolution_stages_Context__T__Lamf_core_model_domain_ElementTree__Lamf_plugins_document_webapi_resolution_stages_BranchContainer = (function(traits, resourceType, context, operation, tree) {
  var this$3 = $as_sc_Seq(resourceType.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, operation$1) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_plugins_domain_webapi_models_Operation(x$2$2);
      var this$1 = $as_Lamf_core_model_StrField(x$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Method$1));
      var this$2 = this$1.option$1;
      return ($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())) === operation$1)
    })
  })(this, operation)));
  if (this$3.isEmpty__Z()) {
    var this$6 = $m_s_None$()
  } else {
    var arg1 = this$3.get__O();
    var op = $as_Lamf_plugins_domain_webapi_models_Operation(arg1);
    var this$5 = tree.subtrees$1.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, operation$2) {
      return (function(x$3$2) {
        var x$3 = $as_Lamf_core_model_domain_ElementTree(x$3$2);
        var this$4 = x$3.key$1;
        return (this$4 === operation$2)
      })
    })(this, operation)));
    var this$6 = new $c_s_Some().init___O(this.method__Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver__Lamf_plugins_domain_webapi_models_Operation__Lamf_plugins_document_webapi_resolution_stages_Context__Lamf_core_model_domain_ElementTree__Lamf_plugins_document_webapi_resolution_stages_BranchContainer(traits, op, context, $as_Lamf_core_model_domain_ElementTree((this$5.isEmpty__Z() ? new $c_Lamf_core_model_domain_ElementTree().init___T__sc_Seq(operation, $m_sci_Nil$()) : this$5.get__O()))).flatten__sc_Seq())
  };
  var o = $as_sc_Seq((this$6.isEmpty__Z() ? $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())) : this$6.get__O()));
  var e = this.endpoint__Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_document_webapi_resolution_stages_Context__Lamf_core_model_domain_ElementTree__Lamf_plugins_document_webapi_resolution_stages_BranchContainer(traits, resourceType, context, tree).flatten__sc_Seq();
  return new $c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer().init___sc_Seq($m_Lamf_plugins_document_webapi_resolution_stages_BranchContainer$().merge__sc_Seq__sc_Seq__sc_Seq(o, e))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches.prototype.resolveTraits__p1__Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver__sc_Seq__Lamf_plugins_document_webapi_resolution_stages_Context__sc_Seq__sc_Seq = (function(resolver, parameterized, context, subTree) {
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, resolver$1, context$1, subTree$1) {
    return (function(x$4$2) {
      var x$4 = $as_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait(x$4$2);
      var xo = resolver$1.resolve__Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait__Lamf_plugins_document_webapi_resolution_stages_Context__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__sc_Seq__s_Option(x$4, context$1, $this.extendsContext$1, subTree$1);
      return xo.toList__sci_List()
    })
  })(this, resolver, context, subTree));
  var this$2 = $m_sc_Seq$();
  return $as_sc_Seq(parameterized.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches.prototype.endpoint__Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_document_webapi_resolution_stages_Context__Lamf_core_model_domain_ElementTree__Lamf_plugins_document_webapi_resolution_stages_BranchContainer = (function(resolver, endpoint, context, tree) {
  return new $c_Lamf_plugins_document_webapi_resolution_stages_BranchContainer().init___sc_Seq(this.resolveTraits__p1__Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver__sc_Seq__Lamf_plugins_document_webapi_resolution_stages_Context__sc_Seq__sc_Seq(resolver, endpoint.traits__sc_Seq(), context, tree.subtrees$1))
});
function $as_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.resolution.stages.ExtendsResolutionStage$Branches"))
}
function $isArrayOf_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches)))
}
function $asArrayOf_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.resolution.stages.ExtendsResolutionStage$Branches;", depth))
}
var $d_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches: 0
}, false, "amf.plugins.document.webapi.resolution.stages.ExtendsResolutionStage$Branches", {
  Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$Branches;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver() {
  $c_O.call(this);
  this.resolved$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver.prototype.resolve__Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait__Lamf_plugins_document_webapi_resolution_stages_Context__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__sc_Seq__s_Option = (function(t, context, apiContext, subTree) {
  var local = context.add__sc_Seq__Lamf_plugins_document_webapi_resolution_stages_Context(t.variables__sc_Seq());
  var name = t.target__Lamf_core_model_domain_templates_AbstractDeclaration().id$1;
  var variables = local.variables$1;
  var key = new $c_Lamf_plugins_document_webapi_resolution_stages_Key().init___T__sci_Set(name, variables);
  var x1 = this.resolveOperation__p1__Lamf_plugins_document_webapi_resolution_stages_Key__Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait__Lamf_plugins_document_webapi_resolution_stages_Context__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__sc_Seq__s_Option(key, t, context, apiContext, subTree);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var ro = $as_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch(x2.value$2);
    return new $c_s_Some().init___O(this.resolved$1.getOrElseUpdate__O__F0__O(key, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, ro$1) {
      return (function() {
        return ro$1
      })
    })(this, ro))))
  } else {
    this.resolved$1.$$minus$eq__O__scm_MapLike(key);
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver.prototype.resolveOperation__p1__Lamf_plugins_document_webapi_resolution_stages_Key__Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait__Lamf_plugins_document_webapi_resolution_stages_Context__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__sc_Seq__s_Option = (function(key, parameterized, context, apiContext, subTree) {
  var local = context.add__sc_Seq__Lamf_plugins_document_webapi_resolution_stages_Context(parameterized.variables__sc_Seq());
  var rc8 = false;
  var x2 = null;
  var x1 = $m_s_Option$().apply__O__s_Option(parameterized.target__Lamf_core_model_domain_templates_AbstractDeclaration());
  if ((x1 instanceof $c_s_Some)) {
    rc8 = true;
    x2 = $as_s_Some(x1);
    var ev$1 = $as_Lamf_core_model_domain_templates_AbstractDeclaration(x2.value$2);
    if ($is_Lamf_core_annotations_ErrorDeclaration(ev$1)) {
      var jsx$1 = this.$$outer$1;
      $m_Lamf_core_parser_Annotations$();
      var annotations = new $c_Lamf_core_parser_Annotations().init___();
      return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch().init___Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage__Lamf_plugins_document_webapi_resolution_stages_Key__Lamf_plugins_domain_webapi_models_Operation__sc_Seq(jsx$1, key, new $c_Lamf_plugins_domain_webapi_models_Operation().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations), $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))))
    }
  };
  if (rc8) {
    var potentialTrait = $as_Lamf_core_model_domain_templates_AbstractDeclaration(x2.value$2);
    if ((potentialTrait instanceof $c_Lamf_plugins_domain_webapi_models_templates_Trait)) {
      var x6 = $as_Lamf_plugins_domain_webapi_models_templates_Trait(potentialTrait);
      var links = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      var x1$2 = $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(x6, links);
      if ((x1$2 instanceof $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait)) {
        var x2$2 = $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait(x1$2);
        var jsx$2 = this.$$outer$1;
        $m_Lamf_core_parser_Annotations$();
        var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
        var this$7 = new $c_Lamf_plugins_domain_webapi_models_Operation().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
        var value = (x2$2.id$1 + "_op");
        return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch().init___Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage__Lamf_plugins_document_webapi_resolution_stages_Key__Lamf_plugins_domain_webapi_models_Operation__sc_Seq(jsx$2, key, $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$7, value)), $m_sci_Nil$()))
      } else if ((x1$2 instanceof $c_Lamf_plugins_domain_webapi_models_templates_Trait)) {
        var x3 = $as_Lamf_plugins_domain_webapi_models_templates_Trait(x1$2);
        var node = x3.dataNode__Lamf_core_model_domain_DataNode().copyNode__Lamf_core_model_domain_DataNode();
        node.replaceVariables__sci_Set__sc_Seq__F1__Lamf_core_model_domain_DataNode(local.variables$1, subTree, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, apiContext$1, x3$1, parameterized$1) {
          return (function(message$2) {
            var message = $as_T(message$2);
            var this$8 = apiContext$1.eh$1;
            var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
            var node$1 = x3$1.id$1;
            var property = $m_s_None$();
            var lexical = parameterized$1.annotations$2.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
            var location = $f_Lamf_core_model_domain_AmfElement__location__s_Option(parameterized$1);
            this$8.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node$1, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
          })
        })(this, apiContext, x3, parameterized)));
        var jsx$11 = $m_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$();
        var jsx$10 = this.$$outer$1.amf$plugins$document$webapi$resolution$stages$ExtendsResolutionStage$$profile$f;
        var jsx$9 = context.model$1;
        var this$9 = $as_Lamf_core_model_StrField(parameterized.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$().Name$1)).option$1;
        var jsx$8 = $as_T((this$9.isEmpty__Z() ? "" : this$9.get__O()));
        var jsx$7 = parameterized.annotations$2;
        var jsx$6 = x3.id$1;
        var jsx$5 = $m_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$().findUnitLocationOfElement__T__Lamf_core_model_document_BaseUnit__s_Option(x3.id$1, context.model$1);
        var jsx$4 = this.$$outer$1.keepEditingInfo$2;
        var jsx$3 = new $c_s_Some().init___O(apiContext);
        var this$10 = this.$$outer$1;
        var op = jsx$11.asOperation__Lamf_ProfileName__Lamf_core_model_domain_DataNode__Lamf_core_model_document_BaseUnit__T__Lamf_core_parser_Annotations__T__s_Option__Z__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_domain_webapi_models_Operation(jsx$10, node, jsx$9, jsx$8, jsx$7, jsx$6, jsx$5, jsx$4, jsx$3, this$10.errorHandler$1);
        var jsx$13 = op.traits__sc_Seq();
        var jsx$12 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, context$1, apiContext$2, subTree$1) {
          return (function(x$5$2) {
            var x$5 = $as_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait(x$5$2);
            var xo = this$3$1.resolve__Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait__Lamf_plugins_document_webapi_resolution_stages_Context__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__sc_Seq__s_Option(x$5, context$1, apiContext$2, subTree$1);
            return xo.toList__sci_List()
          })
        })(this, context, apiContext, subTree));
        var this$12 = $m_sc_Seq$();
        var children = $as_sc_Seq(jsx$13.flatMap__F1__scg_CanBuildFrom__O(jsx$12, this$12.ReusableCBFInstance$2));
        return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch().init___Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage__Lamf_plugins_document_webapi_resolution_stages_Key__Lamf_plugins_domain_webapi_models_Operation__sc_Seq(this.$$outer$1, key, op, children))
      } else {
        throw new $c_s_MatchError().init___O(x1$2)
      }
    }
  };
  var this$13 = this.$$outer$1;
  var this$14 = this$13.errorHandler$1;
  var specification$1 = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
  var node$2 = parameterized.id$1;
  var message$1 = ((("Looking for trait but " + x1) + " was found on model ") + context.model$1);
  var annotations$2 = parameterized.annotations$2;
  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$14, specification$1, node$2, message$1, annotations$2);
  return $m_s_None$()
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver.prototype.productPrefix__T = (function() {
  return "TraitResolver"
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver.prototype.init___Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.resolved$1 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver.prototype.equals__O__Z = (function(x$1) {
  return (((x$1 instanceof $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver) && ($as_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver(x$1).$$outer$1 === this.$$outer$1)) && ($as_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver(x$1), true))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.resolution.stages.ExtendsResolutionStage$TraitResolver"))
}
function $isArrayOf_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver)))
}
function $asArrayOf_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.resolution.stages.ExtendsResolutionStage$TraitResolver;", depth))
}
var $d_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver: 0
}, false, "amf.plugins.document.webapi.resolution.stages.ExtendsResolutionStage$TraitResolver", {
  Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitResolver;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger() {
  $c_O.call(this);
  this.master$1 = null;
  this.extension$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger.prototype.productPrefix__T = (function() {
  return "IriMerger"
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger) && ($as_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger(x$1).$$outer$1 === this.$$outer$1))) {
    var IriMerger$1 = $as_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger(x$1);
    return ((this.master$1 === IriMerger$1.master$1) && (this.extension$1 === IriMerger$1.extension$1))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.master$1;
      break
    }
    case 1: {
      return this.extension$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger.prototype.merge__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__V = (function(element, field, value) {
  var value$1 = $m_sjsr_RuntimeString$().replaceFirst__T__T__T__T($as_Lamf_core_model_domain_AmfScalar(value).toString__T(), this.extension$1, this.master$1);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(element, field, value$1)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger.prototype.init___Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage__T__T = (function($$outer, master, extension) {
  this.master$1 = master;
  this.extension$1 = extension;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.resolution.stages.ExtensionLikeResolutionStage$IriMerger"))
}
function $isArrayOf_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger)))
}
function $asArrayOf_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.resolution.stages.ExtensionLikeResolutionStage$IriMerger;", depth))
}
var $d_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger: 0
}, false, "amf.plugins.document.webapi.resolution.stages.ExtensionLikeResolutionStage$IriMerger", {
  Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$IriMerger;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_IdTracker() {
  $c_O.call(this);
  this.knownIds$1 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_IdTracker.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_resolution_stages_IdTracker.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_IdTracker;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_IdTracker() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_IdTracker.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_IdTracker.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_IdTracker.prototype.init___ = (function() {
  this.knownIds$1 = $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_IdTracker.prototype.productPrefix__T = (function() {
  return "IdTracker"
});
$c_Lamf_plugins_document_webapi_resolution_stages_IdTracker.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_resolution_stages_IdTracker.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_webapi_resolution_stages_IdTracker) && ($as_Lamf_plugins_document_webapi_resolution_stages_IdTracker(x$1), true))
});
$c_Lamf_plugins_document_webapi_resolution_stages_IdTracker.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_resolution_stages_IdTracker.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_resolution_stages_IdTracker.prototype.notTracking__sc_Seq__Z = (function(ids) {
  return ids.forall__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(id$2) {
      var id = $as_T(id$2);
      return $this.notTracking__T__Z(id)
    })
  })(this)))
});
$c_Lamf_plugins_document_webapi_resolution_stages_IdTracker.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_resolution_stages_IdTracker.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_resolution_stages_IdTracker.prototype.notTracking__T__Z = (function(id) {
  return (!this.knownIds$1.contains__O__Z(id))
});
function $as_Lamf_plugins_document_webapi_resolution_stages_IdTracker(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_resolution_stages_IdTracker) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.resolution.stages.IdTracker"))
}
function $isArrayOf_Lamf_plugins_document_webapi_resolution_stages_IdTracker(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_resolution_stages_IdTracker)))
}
function $asArrayOf_Lamf_plugins_document_webapi_resolution_stages_IdTracker(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_resolution_stages_IdTracker(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.resolution.stages.IdTracker;", depth))
}
var $d_Lamf_plugins_document_webapi_resolution_stages_IdTracker = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_IdTracker: 0
}, false, "amf.plugins.document.webapi.resolution.stages.IdTracker", {
  Lamf_plugins_document_webapi_resolution_stages_IdTracker: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_IdTracker.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_IdTracker;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform$ParserErrorHandlerAdapter() {
  $c_O.call(this);
  this.parserRun$1 = 0;
  this.errorHandler$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform$ParserErrorHandlerAdapter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform$ParserErrorHandlerAdapter.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform$ParserErrorHandlerAdapter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform$ParserErrorHandlerAdapter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform$ParserErrorHandlerAdapter.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform$ParserErrorHandlerAdapter.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform$ParserErrorHandlerAdapter.prototype.handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V = (function(location, e) {
  $f_Lamf_core_parser_errorhandler_ParserErrorHandler__handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V(this, location, e)
});
$c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform$ParserErrorHandlerAdapter.prototype.handle__Lorg_yaml_model_YError__O__O = (function(error, defaultValue) {
  return $f_Lamf_core_parser_errorhandler_ParserErrorHandler__handle__Lorg_yaml_model_YError__O__O(this, error, defaultValue)
});
$c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform$ParserErrorHandlerAdapter.prototype.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V = (function(specification, node, property, message, lexical, location) {
  this.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().WARNING$1, location)
});
$c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform$ParserErrorHandlerAdapter.prototype.parserRun__I = (function() {
  return this.parserRun$1
});
$c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform$ParserErrorHandlerAdapter.prototype.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V = (function(id, node, property, message, lexical, level, location) {
  this.errorHandler$1.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(id, node, property, message, lexical, level, location)
});
$c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform$ParserErrorHandlerAdapter.prototype.init___Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform__I__Lamf_core_errorhandling_ErrorHandler = (function($$outer, parserRun, errorHandler) {
  this.parserRun$1 = parserRun;
  this.errorHandler$1 = errorHandler;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform$ParserErrorHandlerAdapter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform$ParserErrorHandlerAdapter: 0
}, false, "amf.plugins.document.webapi.resolution.stages.InferredOverlayTypeExampleTransform$ParserErrorHandlerAdapter", {
  Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform$ParserErrorHandlerAdapter: 1,
  O: 1,
  Lamf_core_parser_errorhandler_ParserErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  Lorg_yaml_model_ParseErrorHandler: 1,
  Lamf_core_errorhandling_ErrorHandler: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform$ParserErrorHandlerAdapter.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_InferredOverlayTypeExampleTransform$ParserErrorHandlerAdapter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_Key() {
  $c_O.call(this);
  this.name$1 = null;
  this.variables$1 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_Key.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_resolution_stages_Key.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_Key;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_Key() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_Key.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_Key.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_Key.prototype.productPrefix__T = (function() {
  return "Key"
});
$c_Lamf_plugins_document_webapi_resolution_stages_Key.prototype.init___T__sci_Set = (function(name, variables) {
  this.name$1 = name;
  this.variables$1 = variables;
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_Key.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_resolution_stages_Key.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_resolution_stages_Key)) {
    var Key$1 = $as_Lamf_plugins_document_webapi_resolution_stages_Key(x$1);
    if ((this.name$1 === Key$1.name$1)) {
      var x = this.variables$1;
      var x$2 = Key$1.variables$1;
      return ((x === null) ? (x$2 === null) : $f_sc_GenSetLike__equals__O__Z(x, x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_Key.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.name$1;
      break
    }
    case 1: {
      return this.variables$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_Key.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_resolution_stages_Key.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_resolution_stages_Key.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_resolution_stages_Key(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_resolution_stages_Key) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.resolution.stages.Key"))
}
function $isArrayOf_Lamf_plugins_document_webapi_resolution_stages_Key(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_resolution_stages_Key)))
}
function $asArrayOf_Lamf_plugins_document_webapi_resolution_stages_Key(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_resolution_stages_Key(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.resolution.stages.Key;", depth))
}
var $d_Lamf_plugins_document_webapi_resolution_stages_Key = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_Key: 0
}, false, "amf.plugins.document.webapi.resolution.stages.Key", {
  Lamf_plugins_document_webapi_resolution_stages_Key: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_Key.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_Key;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$() {
  $c_O.call(this);
  this.result$1 = null;
  this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlValidations$$result$1 = null;
  this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$1 = null;
  this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$.prototype = $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$.prototype;
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$lzycompute__p1__sc_Seq = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$1 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$RamlAndOasValidations__amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result__sc_Seq(this);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$.prototype.result$lzycompute__p1__sc_Seq = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    var jsx$5 = this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlValidations$$result__sc_Seq();
    var jsx$4 = $m_sc_Seq$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns, "Settings");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$1 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$1, "authorizationGrant");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$2 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$4 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$2, "pattern");
    var x$6 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$3 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$7 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$3, "path");
    var x$10 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$3 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$6, "Invalid authorization grant. The options are: code, token, owner or credentials", x$2, x$3, x$7, x$4, "^code|token|owner|credentials$", "", "", x$10);
    var x$11 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("raml-schemes");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$4 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$13 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$4, "WebAPI");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$5 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$14 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$5, "scheme");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$6 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$15 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$6, "in");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$7 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$19 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$7, "path");
    var x$20 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$2 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$11, "Protocols property must be http or https", x$13, x$14, x$19, x$15, "http,https,HTTP,HTTPS", "Protocols must have a case insensitive value matching http or https", "Swagger object 'schemes' property must have a case insensitive value matching http or https", x$20);
    var x$21 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("min-max-properties");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$8 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$23 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$8, "NodeShape");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$9 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    var x$24 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$9, "minProperties");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$10 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    var x$25 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$10, "minMaxPropertiesValidation");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$11 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$26 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$11, "path");
    var x$30 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var array = [jsx$3, jsx$2, $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$21, "MaxProperties must be greater than or equal to minProperties", x$23, x$24, x$26, x$25, "0", "", "", x$30)];
    var jsx$1 = jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$34 = $m_sc_Seq$();
    this.result$1 = $as_sc_Seq(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$34.ReusableCBFInstance$2));
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.result$1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result__sc_Seq = (function() {
  return (((((8 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$lzycompute__p1__sc_Seq() : this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1)
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$RamlValidations$$result__sc_Seq = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlValidations$$result$lzycompute__p1__sc_Seq() : this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlValidations$$result$1)
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$lzycompute__p1__sc_Seq = (function() {
  if (((((8 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfProfileValidations__amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result__sc_Seq(this);
    this.bitmap$0$1 = (((8 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$.prototype.result__p1__sc_Seq = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.result$lzycompute__p1__sc_Seq() : this.result$1)
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$RamlValidations$$result$lzycompute__p1__sc_Seq = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlValidations$$result$1 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$RamlValidations__amf$plugins$document$webapi$validation$AMFRawValidations$RamlValidations$$result__sc_Seq(this);
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlValidations$$result$1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result__sc_Seq = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$lzycompute__p1__sc_Seq() : this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$1)
});
var $d_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$: 0
}, false, "amf.plugins.document.webapi.validation.AMFRawValidations$Raml08Validations$", {
  Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$RamlValidations: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$RamlAndOasValidations: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfProfileValidations: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$ProfileValidations: 1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$;
var $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$)) {
    $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$ = new $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml08Validations$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$() {
  $c_O.call(this);
  this.result$1 = null;
  this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlValidations$$result$1 = null;
  this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$1 = null;
  this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$.prototype = $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$.prototype;
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$lzycompute__p1__sc_Seq = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$1 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$RamlAndOasValidations__amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result__sc_Seq(this);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$.prototype.result$lzycompute__p1__sc_Seq = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    var jsx$2 = this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlValidations$$result__sc_Seq();
    var jsx$1 = $m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$());
    var this$1 = $m_sc_Seq$();
    this.result$1 = $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.result$1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result__sc_Seq = (function() {
  return (((((8 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$lzycompute__p1__sc_Seq() : this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1)
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$RamlValidations$$result__sc_Seq = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlValidations$$result$lzycompute__p1__sc_Seq() : this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlValidations$$result$1)
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$lzycompute__p1__sc_Seq = (function() {
  if (((((8 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfProfileValidations__amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result__sc_Seq(this);
    this.bitmap$0$1 = (((8 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$.prototype.result__p1__sc_Seq = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.result$lzycompute__p1__sc_Seq() : this.result$1)
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$RamlValidations$$result$lzycompute__p1__sc_Seq = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlValidations$$result$1 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$RamlValidations__amf$plugins$document$webapi$validation$AMFRawValidations$RamlValidations$$result__sc_Seq(this);
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlValidations$$result$1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result__sc_Seq = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$lzycompute__p1__sc_Seq() : this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$1)
});
var $d_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$: 0
}, false, "amf.plugins.document.webapi.validation.AMFRawValidations$Raml10Validations$", {
  Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$RamlValidations: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$RamlAndOasValidations: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfProfileValidations: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$ProfileValidations: 1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$;
var $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$)) {
    $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$ = new $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$Raml10Validations$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_DataNodeEntry() {
  $c_O.call(this);
  this.d$1 = null;
  this.sonsKeys$1 = null
}
$c_Lamf_plugins_document_webapi_validation_DataNodeEntry.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_DataNodeEntry.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_DataNodeEntry;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_DataNodeEntry() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_DataNodeEntry.prototype = $c_Lamf_plugins_document_webapi_validation_DataNodeEntry.prototype;
$c_Lamf_plugins_document_webapi_validation_DataNodeEntry.prototype.aggregate__sci_Map__s_Option = (function(indexedResult) {
  var sonsResults = this.collectResults__p1__sci_Map__sc_Seq(indexedResult);
  var rc6 = false;
  var x2 = null;
  var x1 = indexedResult.get__O__s_Option(this.d$1.id$1);
  if ((x1 instanceof $c_s_Some)) {
    rc6 = true;
    x2 = $as_s_Some(x1);
    var rootResults = $as_sci_List(x2.value$2);
    if (sonsResults.nonEmpty__Z()) {
      return new $c_s_Some().init___O(this.buildRootResult__p1__sci_List__s_Option__Lamf_core_validation_AMFValidationResult(rootResults, this.sonsToString__p1__sc_Seq__s_Option(sonsResults)))
    }
  };
  if (rc6) {
    var rootResult = $as_sci_List(x2.value$2);
    return new $c_s_Some().init___O(this.buildRootResult__p1__sci_List__s_Option__Lamf_core_validation_AMFValidationResult(rootResult, $m_s_None$()))
  };
  var x = $m_s_None$();
  if (((x === x1) && sonsResults.nonEmpty__Z())) {
    var this$1 = this.sonsToString__p1__sc_Seq__s_Option(sonsResults);
    var message = $as_T((this$1.isEmpty__Z() ? "" : this$1.get__O()));
    var level = (sonsResults.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
      return (function(x$5$2) {
        var x$5 = $as_Lamf_core_validation_AMFValidationResult(x$5$2);
        return (x$5.level$1 === $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1)
      })
    })(this))) ? $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1 : $m_Lamf_core_validation_SeverityLevels$().WARNING$1);
    var targetNode = this.d$1.id$1;
    var targetProperty = $as_Lamf_core_validation_AMFValidationResult(sonsResults.head__O()).targetProperty$1;
    var validationId = $as_Lamf_core_validation_AMFValidationResult(sonsResults.head__O()).validationId$1;
    var this$3 = this.d$1;
    var position = this$3.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var this$4 = this.d$1;
    var location = $f_Lamf_core_model_domain_AmfElement__location__s_Option(this$4);
    return new $c_s_Some().init___O(new $c_Lamf_core_validation_AMFValidationResult().init___T__T__T__s_Option__T__s_Option__s_Option__O(message, level, targetNode, targetProperty, validationId, position, location, null))
  };
  return $m_s_None$()
});
$c_Lamf_plugins_document_webapi_validation_DataNodeEntry.prototype.productPrefix__T = (function() {
  return "DataNodeEntry"
});
$c_Lamf_plugins_document_webapi_validation_DataNodeEntry.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_validation_DataNodeEntry.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_DataNodeEntry)) {
    var DataNodeEntry$1 = $as_Lamf_plugins_document_webapi_validation_DataNodeEntry(x$1);
    var x = this.d$1;
    var x$2 = DataNodeEntry$1.d$1;
    if ((x === x$2)) {
      var x$3 = this.sonsKeys$1;
      var x$4 = DataNodeEntry$1.sonsKeys$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_DataNodeEntry.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.d$1;
      break
    }
    case 1: {
      return this.sonsKeys$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_DataNodeEntry.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_DataNodeEntry.prototype.sonsToString__p1__sc_Seq__s_Option = (function(sonsResult) {
  var message = new $c_sr_ObjectRef().init___O("");
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$8$2) {
      var x$8 = $as_Lamf_core_validation_AMFValidationResult(x$8$2);
      return x$8.message$1
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  $as_sc_IterableLike($as_sc_SeqLike(sonsResult.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2)).distinct__O()).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, message$1) {
    return (function(r$2) {
      var r = $as_T(r$2);
      var thiz = $as_T(message$1.elem$1);
      var s = (r + "\n");
      if ((thiz === null)) {
        throw new $c_jl_NullPointerException().init___()
      };
      message$1.elem$1 = (thiz + s)
    })
  })(this, message)));
  return $m_s_Option$().apply__O__s_Option($as_T(message.elem$1))
});
$c_Lamf_plugins_document_webapi_validation_DataNodeEntry.prototype.init___Lamf_core_model_domain_DataNode__sc_Seq = (function(d, sonsKeys) {
  this.d$1 = d;
  this.sonsKeys$1 = sonsKeys;
  return this
});
$c_Lamf_plugins_document_webapi_validation_DataNodeEntry.prototype.sorted__p1__sc_Seq__sc_Seq = (function(elements) {
  var this$1 = $m_s_math_Ordering$();
  var evidence$1 = $m_s_Predef$().singleton$und$less$colon$less$2;
  return $as_sc_Seq(elements.sorted__s_math_Ordering__O(new $c_s_math_LowPriorityOrderingImplicits$$anon$3().init___s_math_LowPriorityOrderingImplicits__F1(this$1, evidence$1)))
});
$c_Lamf_plugins_document_webapi_validation_DataNodeEntry.prototype.buildRootResult__p1__sci_List__s_Option__Lamf_core_validation_AMFValidationResult = (function(rootResults, additionalMessage) {
  var sortedResults = this.sorted__p1__sc_Seq__sc_Seq(rootResults);
  var rc12 = false;
  var x2 = null;
  if ((sortedResults instanceof $c_sci_$colon$colon)) {
    rc12 = true;
    x2 = $as_sci_$colon$colon(sortedResults);
    var rootResult = $as_Lamf_core_validation_AMFValidationResult(x2.head$5);
    var p3 = x2.tl$5;
    var x = $m_sci_Nil$();
    if ((x.equals__O__Z(p3) && additionalMessage.isDefined__Z())) {
      var message = ((rootResult.message$1 + "\n") + (additionalMessage.isEmpty__Z() ? "" : additionalMessage.get__O()));
      var level = rootResult.level$1;
      var targetNode = rootResult.targetNode$1;
      var targetProperty = rootResult.targetProperty$1;
      var validationId = rootResult.validationId$1;
      var position = rootResult.position$1;
      var location = rootResult.location$1;
      var source = rootResult.source$1;
      return new $c_Lamf_core_validation_AMFValidationResult().init___T__T__T__s_Option__T__s_Option__s_Option__O(message, level, targetNode, targetProperty, validationId, position, location, source)
    }
  };
  if (rc12) {
    var rootResult$2 = $as_Lamf_core_validation_AMFValidationResult(x2.head$5);
    var p5 = x2.tl$5;
    var x$3 = $m_sci_Nil$();
    if (x$3.equals__O__Z(p5)) {
      return rootResult$2
    }
  };
  if (rc12) {
    var severity = (sortedResults.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
      return (function(x$6$2) {
        var x$6 = $as_Lamf_core_validation_AMFValidationResult(x$6$2);
        return (x$6.level$1 === $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1)
      })
    })(this))) ? $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1 : $m_Lamf_core_validation_SeverityLevels$().WARNING$1);
    var messages = new $c_sr_ObjectRef().init___O("");
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3) {
      return (function(x$7$2) {
        var x$7 = $as_Lamf_core_validation_AMFValidationResult(x$7$2);
        return x$7.message$1
      })
    })(this));
    var this$4 = $m_sc_Seq$();
    $as_sc_IterableLike($as_sc_SeqLike(sortedResults.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2)).distinct__O()).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, messages$1) {
      return (function(r$2) {
        var r = $as_T(r$2);
        messages$1.elem$1 = ((("" + $as_T(messages$1.elem$1)) + r) + "\n")
      })
    })(this, messages)));
    if (additionalMessage.isEmpty__Z()) {
      var jsx$2 = $as_T(messages.elem$1)
    } else {
      var arg1 = additionalMessage.get__O();
      var a = $as_T(arg1);
      var jsx$2 = (("" + $as_T(messages.elem$1)) + a)
    };
    var finalMessage = $as_T(jsx$2);
    var targetNode$1 = $as_Lamf_core_validation_AMFValidationResult(sortedResults.head__O()).targetNode$1;
    var targetProperty$1 = $m_s_Option$().apply__O__s_Option(this.d$1.id$1);
    var validationId$1 = $as_Lamf_core_validation_AMFValidationResult(sortedResults.head__O()).validationId$1;
    var this$5 = this.d$1;
    var position$1 = this$5.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var this$6 = this.d$1;
    var location$1 = $f_Lamf_core_model_domain_AmfElement__location__s_Option(this$6);
    return new $c_Lamf_core_validation_AMFValidationResult().init___T__T__T__s_Option__T__s_Option__s_Option__O(finalMessage, severity, targetNode$1, targetProperty$1, validationId$1, position$1, location$1, null)
  };
  throw new $c_s_MatchError().init___O(sortedResults)
});
$c_Lamf_plugins_document_webapi_validation_DataNodeEntry.prototype.collectResults__p1__sci_Map__sc_Seq = (function(indexedResults) {
  var jsx$2 = this.sonsKeys$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, indexedResults$1) {
    return (function(k$2) {
      var k = $as_T(k$2);
      return $as_sc_Seq(indexedResults$1.getOrElse__O__F0__O(k, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this$1) {
        return (function() {
          return $m_sci_Nil$()
        })
      })($this))))
    })
  })(this, indexedResults));
  var this$1 = $m_sc_Seq$();
  return this.sorted__p1__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)))
});
$c_Lamf_plugins_document_webapi_validation_DataNodeEntry.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_DataNodeEntry.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_validation_DataNodeEntry(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_DataNodeEntry) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.DataNodeEntry"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_DataNodeEntry(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_DataNodeEntry)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_DataNodeEntry(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_DataNodeEntry(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.DataNodeEntry;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_DataNodeEntry = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_DataNodeEntry: 0
}, false, "amf.plugins.document.webapi.validation.DataNodeEntry", {
  Lamf_plugins_document_webapi_validation_DataNodeEntry: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_DataNodeEntry.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_DataNodeEntry;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_DataNodeIndex() {
  $c_O.call(this);
  this.amf$plugins$document$webapi$validation$DataNodeIndex$$dataNodes$1 = null;
  this.index$1 = null
}
$c_Lamf_plugins_document_webapi_validation_DataNodeIndex.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_DataNodeIndex.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_DataNodeIndex;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_DataNodeIndex() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_DataNodeIndex.prototype = $c_Lamf_plugins_document_webapi_validation_DataNodeIndex.prototype;
$c_Lamf_plugins_document_webapi_validation_DataNodeIndex.prototype.productPrefix__T = (function() {
  return "DataNodeIndex"
});
$c_Lamf_plugins_document_webapi_validation_DataNodeIndex.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_DataNodeIndex.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_DataNodeIndex)) {
    var DataNodeIndex$1 = $as_Lamf_plugins_document_webapi_validation_DataNodeIndex(x$1);
    var x = this.amf$plugins$document$webapi$validation$DataNodeIndex$$dataNodes$1;
    var x$2 = DataNodeIndex$1.amf$plugins$document$webapi$validation$DataNodeIndex$$dataNodes$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_DataNodeIndex.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.amf$plugins$document$webapi$validation$DataNodeIndex$$dataNodes$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_DataNodeIndex.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_DataNodeIndex.prototype.aggregate__sci_Map__sc_Seq = (function(indexedResult) {
  var this$3 = this.index$1;
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, indexedResult$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var entry = $as_Lamf_plugins_document_webapi_validation_DataNodeEntry(x0$1.$$und2__O());
        var xo = entry.aggregate__sci_Map__s_Option(indexedResult$1);
        return xo.toList__sci_List()
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, indexedResult));
  var this$2 = $m_sci_Iterable$();
  var bf = this$2.ReusableCBFInstance$2;
  return $as_sc_TraversableOnce($f_sc_TraversableLike__flatMap__F1__scg_CanBuildFrom__O(this$3, f, bf)).toSeq__sc_Seq()
});
$c_Lamf_plugins_document_webapi_validation_DataNodeIndex.prototype.init___sc_Seq = (function(dataNodes) {
  this.amf$plugins$document$webapi$validation$DataNodeIndex$$dataNodes$1 = dataNodes;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(d$2) {
      var d = $as_Lamf_core_model_domain_DataNode(d$2);
      var self = d.id$1;
      var y = new $c_Lamf_plugins_document_webapi_validation_DataNodeEntry().init___Lamf_core_model_domain_DataNode__sc_Seq(d, $this.indexSons__p1__Lamf_core_model_domain_DataNode__sc_Seq(d));
      return new $c_T2().init___O__O(self, y)
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  this.index$1 = $as_sc_TraversableOnce(dataNodes.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2);
  return this
});
$c_Lamf_plugins_document_webapi_validation_DataNodeIndex.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_DataNodeIndex.prototype.indexSons__p1__Lamf_core_model_domain_DataNode__sc_Seq = (function(dataNode) {
  if ((dataNode instanceof $c_Lamf_core_model_domain_ObjectNode)) {
    var x2 = $as_Lamf_core_model_domain_ObjectNode(dataNode);
    var this$1 = x2.allPropertiesWithName__sci_Map();
    var this$3 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$1);
    $m_sc_Iterable$();
    $m_sc_Iterable$();
    $m_sci_Iterable$();
    var b = new $c_scm_ListBuffer().init___();
    var this$6 = this$3.$$outer$3.valuesIterator__sc_Iterator();
    while (this$6.hasNext__Z()) {
      var arg1 = this$6.next__O();
      var p = $as_Lamf_core_model_domain_DataNode(arg1);
      var x$9 = p.id$1;
      var jsx$1 = this.indexSons__p1__Lamf_core_model_domain_DataNode__sc_Seq(p);
      var this$7 = $m_sc_Seq$();
      var xs = $as_sc_Seq(jsx$1.$$plus$colon__O__scg_CanBuildFrom__O(x$9, this$7.ReusableCBFInstance$2)).seq__sc_TraversableOnce();
      b.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(xs)
    };
    var this$8 = b.toList__sci_List();
    return this$8
  } else if ((dataNode instanceof $c_Lamf_core_model_domain_ArrayNode)) {
    var x3 = $as_Lamf_core_model_domain_ArrayNode(dataNode);
    var jsx$4 = $as_sc_Seq(x3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ArrayNodeModel$().Member$1));
    var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(m$2) {
        var m = $as_Lamf_core_model_domain_DataNode(m$2);
        var x$10 = m.id$1;
        var jsx$3 = this$2$1.indexSons__p1__Lamf_core_model_domain_DataNode__sc_Seq(m);
        var this$9 = $m_sc_Seq$();
        return $as_sc_Seq(jsx$3.$$plus$colon__O__scg_CanBuildFrom__O(x$10, this$9.ReusableCBFInstance$2))
      })
    })(this));
    var this$10 = $m_sc_Seq$();
    return $as_sc_Seq(jsx$4.flatMap__F1__scg_CanBuildFrom__O(jsx$2, this$10.ReusableCBFInstance$2))
  } else {
    return $m_sci_Nil$()
  }
});
$c_Lamf_plugins_document_webapi_validation_DataNodeIndex.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_validation_DataNodeIndex(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_DataNodeIndex) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.DataNodeIndex"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_DataNodeIndex(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_DataNodeIndex)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_DataNodeIndex(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_DataNodeIndex(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.DataNodeIndex;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_DataNodeIndex = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_DataNodeIndex: 0
}, false, "amf.plugins.document.webapi.validation.DataNodeIndex", {
  Lamf_plugins_document_webapi_validation_DataNodeIndex: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_DataNodeIndex.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_DataNodeIndex;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation() {
  $c_O.call(this);
  this.baseUnit$1 = null;
  this.platform$1 = null;
  this.candidates$1 = null;
  this.index$1 = null
}
$c_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation.prototype = $c_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation.prototype;
$c_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation.prototype.productPrefix__T = (function() {
  return "UnitPayloadsValidation"
});
$c_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation.prototype.validate__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future = (function(env, executionContext) {
  $m_Lamf_core_benchmark_ExecutionLog$().log__T__Lamf_core_benchmark_ExecutionLog$(("UnitPayloadsValidation#validate: Validating all candidates " + this.candidates$1.size__I()));
  return $m_Lamf_plugins_domain_shapes_validation_ShapesNodesValidator$().validateAll__sc_Seq__T__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future(this.candidates$1, $m_Lamf_core_validation_SeverityLevels$().WARNING$1, env, executionContext).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(report$2) {
      var report = $as_Lamf_core_validation_AMFValidationReport(report$2);
      return $this.groupResults__p1__Lamf_core_validation_AMFValidationReport__sc_Seq(report)
    })
  })(this)), executionContext)
});
$c_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation)) {
    var UnitPayloadsValidation$1 = $as_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation(x$1);
    var x = this.baseUnit$1;
    var x$2 = UnitPayloadsValidation$1.baseUnit$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.platform$1;
      var x$4 = UnitPayloadsValidation$1.platform$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.baseUnit$1;
      break
    }
    case 1: {
      return this.platform$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation.prototype.groupResults__p1__Lamf_core_validation_AMFValidationReport__sc_Seq = (function(report) {
  var this$2 = report.results$1.toList__sci_List();
  var this$1 = $m_s_math_Ordering$();
  var evidence$1 = $m_s_Predef$().singleton$und$less$colon$less$2;
  var ord = new $c_s_math_LowPriorityOrderingImplicits$$anon$3().init___s_math_LowPriorityOrderingImplicits__F1(this$1, evidence$1);
  var indexedResults = $as_sc_TraversableLike($f_sc_SeqLike__sorted__s_math_Ordering__O(this$2, ord)).groupBy__F1__sci_Map(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(r$2) {
      var r = $as_Lamf_core_validation_AMFValidationResult(r$2);
      return r.targetNode$1
    })
  })(this)));
  var payloadResults = this.index$1.aggregate__sci_Map__sc_Seq(indexedResults);
  var jsx$2 = $as_sc_TraversableLike(indexedResults.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var validations = $as_sci_List(x0$1.$$und2__O());
        var these = validations;
        while ((!these.isEmpty__Z())) {
          var arg1 = these.head__O();
          var x$3 = $as_Lamf_core_validation_AMFValidationResult(arg1);
          if ((x$3.validationId$1 === $m_Lamf_validations_PayloadValidations$().SchemaException$1.id$1)) {
            return true
          };
          these = $as_sc_LinearSeqOptimized(these.tail__O())
        };
        return false
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this))));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3) {
    return (function(x$4$2) {
      var x$4 = $as_T2(x$4$2);
      return $as_sci_List(x$4.$$und2__O())
    })
  })(this));
  var this$4 = $m_sci_Iterable$();
  var schemaResults = $as_sci_Iterable(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2));
  var this$5 = $m_sc_Seq$();
  return $as_sc_Seq(payloadResults.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(schemaResults, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_core_remote_Platform = (function(baseUnit, platform) {
  this.baseUnit$1 = baseUnit;
  this.platform$1 = platform;
  var jsx$4 = $m_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$().apply__Lamf_core_model_document_BaseUnit__sc_Seq(baseUnit);
  var jsx$3 = $m_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$().apply__Lamf_core_model_document_BaseUnit__Lamf_core_remote_Platform__sc_Seq(baseUnit, platform);
  var this$1 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$1.ReusableCBFInstance$2));
  var jsx$1 = $m_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$().apply__Lamf_core_model_document_BaseUnit__Lamf_core_remote_Platform__sc_Seq(baseUnit, platform);
  var this$2 = $m_sc_Seq$();
  this.candidates$1 = $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  var jsx$10 = $as_sc_TraversableLike(this.candidates$1.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_validation_ValidationCandidate(x$1$2);
      var this$3 = x$1.payload$1.fields$1;
      var f = $m_Lamf_core_metamodel_document_PayloadFragmentModel$().Encodes$1;
      return this$3.fs$1.contains__O__Z(f)
    })
  })(this))));
  var jsx$9 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_validation_ValidationCandidate(x$2$2);
      var this$4 = x$2.payload$1;
      return $as_Lamf_core_model_domain_DataNode(this$4.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().Encodes$1))
    })
  })(this));
  var this$5 = $m_sc_Seq$();
  var jsx$8 = $as_sc_TraversableLike(jsx$10.map__F1__scg_CanBuildFrom__O(jsx$9, this$5.ReusableCBFInstance$2));
  var jsx$7 = this.candidates$1;
  var jsx$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(c$2) {
      var c = $as_Lamf_core_validation_ValidationCandidate(c$2);
      var this$6 = c.shape$1;
      return $as_sc_Seq(this$6.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Values$1))
    })
  })(this));
  var this$7 = $m_sc_Seq$();
  var jsx$5 = $as_sc_GenTraversableOnce(jsx$7.flatMap__F1__scg_CanBuildFrom__O(jsx$6, this$7.ReusableCBFInstance$2));
  var this$8 = $m_sc_Seq$();
  var nodes = $as_sc_Seq(jsx$8.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$5, this$8.ReusableCBFInstance$2));
  this.index$1 = new $c_Lamf_plugins_document_webapi_validation_DataNodeIndex().init___sc_Seq(nodes);
  return this
});
$c_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.UnitPayloadsValidation"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_UnitPayloadsValidation)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.UnitPayloadsValidation;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_UnitPayloadsValidation: 0
}, false, "amf.plugins.document.webapi.validation.UnitPayloadsValidation", {
  Lamf_plugins_document_webapi_validation_UnitPayloadsValidation: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_remote_ExampleUnknownException() {
  /*<skip>*/
}
function $as_Lamf_plugins_document_webapi_validation_remote_ExampleUnknownException(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_remote_ExampleUnknownException) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.remote.ExampleUnknownException"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_remote_ExampleUnknownException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_remote_ExampleUnknownException)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_remote_ExampleUnknownException(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_remote_ExampleUnknownException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.remote.ExampleUnknownException;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject() {
  $c_jl_RuntimeException.call(this)
}
$c_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject.prototype = new $h_jl_RuntimeException();
$c_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject.prototype = $c_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject.prototype;
$c_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject.prototype.init___jl_Throwable = (function(e) {
  $c_jl_RuntimeException.prototype.init___jl_Throwable.call(this, e);
  return this
});
function $as_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.remote.InvalidJsonObject"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.remote.InvalidJsonObject;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject: 0
}, false, "amf.plugins.document.webapi.validation.remote.InvalidJsonObject", {
  Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_remote_InvalidJsonObject;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_remote_InvalidJsonValue() {
  /*<skip>*/
}
function $as_Lamf_plugins_document_webapi_validation_remote_InvalidJsonValue(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_remote_InvalidJsonValue) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.remote.InvalidJsonValue"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_remote_InvalidJsonValue(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_remote_InvalidJsonValue)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_remote_InvalidJsonValue(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_remote_InvalidJsonValue(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.remote.InvalidJsonValue;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_remote_UnknownDiscriminator() {
  /*<skip>*/
}
function $as_Lamf_plugins_document_webapi_validation_remote_UnknownDiscriminator(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_remote_UnknownDiscriminator) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.remote.UnknownDiscriminator"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_remote_UnknownDiscriminator(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_remote_UnknownDiscriminator)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_remote_UnknownDiscriminator(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_remote_UnknownDiscriminator(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.remote.UnknownDiscriminator;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runner_ResultContainer() {
  $c_O.call(this);
  this.results$1 = null;
  this.errors$1 = false;
  this.valid$1 = false
}
$c_Lamf_plugins_document_webapi_validation_runner_ResultContainer.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runner_ResultContainer.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runner_ResultContainer;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runner_ResultContainer() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runner_ResultContainer.prototype = $c_Lamf_plugins_document_webapi_validation_runner_ResultContainer.prototype;
$c_Lamf_plugins_document_webapi_validation_runner_ResultContainer.prototype.productPrefix__T = (function() {
  return "ResultContainer"
});
$c_Lamf_plugins_document_webapi_validation_runner_ResultContainer.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runner_ResultContainer.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runner_ResultContainer)) {
    var ResultContainer$1 = $as_Lamf_plugins_document_webapi_validation_runner_ResultContainer(x$1);
    var x = this.results$1;
    var x$2 = ResultContainer$1.results$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runner_ResultContainer.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.results$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runner_ResultContainer.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runner_ResultContainer.prototype.init___sc_Seq = (function(results) {
  this.results$1 = results;
  this.errors$1 = results.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_validation_AMFValidationResult(x$1$2);
      return (x$1.level$1 === $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1)
    })
  })(this)));
  this.valid$1 = (!this.errors$1);
  return this
});
$c_Lamf_plugins_document_webapi_validation_runner_ResultContainer.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runner_ResultContainer.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_validation_runner_ResultContainer(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runner_ResultContainer) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runner.ResultContainer"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runner_ResultContainer(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runner_ResultContainer)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runner_ResultContainer(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runner_ResultContainer(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runner.ResultContainer;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runner_ResultContainer = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runner_ResultContainer: 0
}, false, "amf.plugins.document.webapi.validation.runner.ResultContainer", {
  Lamf_plugins_document_webapi_validation_runner_ResultContainer: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runner_ResultContainer.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runner_ResultContainer;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runner_ValidationContext() {
  $c_O.call(this);
  this.baseUnit$1 = null;
  this.profile$1 = null;
  this.platform$1 = null;
  this.messageStyle$1 = null;
  this.validations$1 = null;
  this.env$1 = null
}
$c_Lamf_plugins_document_webapi_validation_runner_ValidationContext.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runner_ValidationContext.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runner_ValidationContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runner_ValidationContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runner_ValidationContext.prototype = $c_Lamf_plugins_document_webapi_validation_runner_ValidationContext.prototype;
$c_Lamf_plugins_document_webapi_validation_runner_ValidationContext.prototype.productPrefix__T = (function() {
  return "ValidationContext"
});
$c_Lamf_plugins_document_webapi_validation_runner_ValidationContext.prototype.productArity__I = (function() {
  return 6
});
$c_Lamf_plugins_document_webapi_validation_runner_ValidationContext.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_remote_Platform__Lamf_MessageStyle__Lamf_core_validation_EffectiveValidations__Lamf_internal_environment_Environment = (function(baseUnit, profile, platform, messageStyle, validations, env) {
  this.baseUnit$1 = baseUnit;
  this.profile$1 = profile;
  this.platform$1 = platform;
  this.messageStyle$1 = messageStyle;
  this.validations$1 = validations;
  this.env$1 = env;
  return this
});
$c_Lamf_plugins_document_webapi_validation_runner_ValidationContext.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runner_ValidationContext)) {
    var ValidationContext$1 = $as_Lamf_plugins_document_webapi_validation_runner_ValidationContext(x$1);
    var x = this.baseUnit$1;
    var x$2 = ValidationContext$1.baseUnit$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.profile$1;
      var x$4 = ValidationContext$1.profile$1;
      var jsx$4 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      var x$5 = this.platform$1;
      var x$6 = ValidationContext$1.platform$1;
      var jsx$3 = (x$5 === x$6)
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$7 = this.messageStyle$1;
      var x$8 = ValidationContext$1.messageStyle$1;
      var jsx$2 = (x$7 === x$8)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$9 = this.validations$1;
      var x$10 = ValidationContext$1.validations$1;
      var jsx$1 = (x$9 === x$10)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$11 = this.env$1;
      var x$12 = ValidationContext$1.env$1;
      return ((x$11 === null) ? (x$12 === null) : x$11.equals__O__Z(x$12))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runner_ValidationContext.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.baseUnit$1;
      break
    }
    case 1: {
      return this.profile$1;
      break
    }
    case 2: {
      return this.platform$1;
      break
    }
    case 3: {
      return this.messageStyle$1;
      break
    }
    case 4: {
      return this.validations$1;
      break
    }
    case 5: {
      return this.env$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runner_ValidationContext.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runner_ValidationContext.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runner_ValidationContext.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_validation_runner_ValidationContext(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runner_ValidationContext) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runner.ValidationContext"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runner_ValidationContext(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runner_ValidationContext)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runner_ValidationContext(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runner_ValidationContext(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runner.ValidationContext;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runner_ValidationContext = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runner_ValidationContext: 0
}, false, "amf.plugins.document.webapi.validation.runner.ValidationContext", {
  Lamf_plugins_document_webapi_validation_runner_ValidationContext: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runner_ValidationContext.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runner_ValidationContext;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner() {
  $c_O.call(this);
  this.validationContext$1 = null;
  this.exec$1 = null;
  this.executionContext$1 = null;
  this.modelStep$1 = null;
  this.examplesStep$1 = null;
  this.parserStep$1 = null
}
$c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner.prototype = $c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner.prototype;
$c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner.prototype.productPrefix__T = (function() {
  return "WebApiValidationsRunner"
});
$c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner)) {
    var WebApiValidationsRunner$1 = $as_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner(x$1);
    var x = this.validationContext$1;
    var x$2 = WebApiValidationsRunner$1.validationContext$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.exec$1;
      var x$4 = WebApiValidationsRunner$1.exec$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner.prototype.init___Lamf_plugins_document_webapi_validation_runner_ValidationContext__Lamf_client_execution_BaseExecutionEnvironment = (function(validationContext, exec) {
  this.validationContext$1 = validationContext;
  this.exec$1 = exec;
  this.executionContext$1 = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  this.modelStep$1 = new $c_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep().init___Lamf_plugins_document_webapi_validation_runner_ValidationContext__s_concurrent_ExecutionContext(validationContext, this.executionContext$1);
  this.examplesStep$1 = new $c_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep().init___Lamf_plugins_document_webapi_validation_runner_ValidationContext__s_concurrent_ExecutionContext(validationContext, this.executionContext$1);
  this.parserStep$1 = new $c_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep().init___Lamf_plugins_document_webapi_validation_runner_ValidationContext(validationContext);
  return this
});
$c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.validationContext$1;
      break
    }
    case 1: {
      return this.exec$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner.prototype.runSteps__s_concurrent_Future = (function() {
  var this$1 = this.parserStep$1;
  var previous = $m_Lamf_plugins_document_webapi_validation_runner_EmptyResultContainer$();
  var executionContext = this.executionContext$1;
  return $f_Lamf_plugins_document_webapi_validation_runner_steps_ValidationStep__run__Lamf_plugins_document_webapi_validation_runner_ResultContainer__s_concurrent_ExecutionContext__s_concurrent_Future(this$1, previous, executionContext).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(rc$2) {
      var rc = $as_Lamf_plugins_document_webapi_validation_runner_ResultContainer(rc$2);
      if ((rc.errors$1 && $this.parserStep$1.endStep__Z())) {
        var jsx$1 = $m_s_concurrent_Future$().successful__O__s_concurrent_Future(rc)
      } else {
        var this$2 = $this.modelStep$1;
        var executionContext$1 = $this.executionContext$1;
        var jsx$1 = $f_Lamf_plugins_document_webapi_validation_runner_steps_ValidationStep__run__Lamf_plugins_document_webapi_validation_runner_ResultContainer__s_concurrent_ExecutionContext__s_concurrent_Future(this$2, rc, executionContext$1)
      };
      return jsx$1.flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
        return (function(rc$2$2) {
          var rc$2$1 = $as_Lamf_plugins_document_webapi_validation_runner_ResultContainer(rc$2$2);
          if ((rc$2$1.errors$1 && $this$1.modelStep$1.endStep__Z())) {
            var jsx$2 = $m_s_concurrent_Future$().successful__O__s_concurrent_Future(rc$2$1)
          } else {
            var this$3 = $this$1.examplesStep$1;
            var executionContext$2 = $this$1.executionContext$1;
            var jsx$2 = $f_Lamf_plugins_document_webapi_validation_runner_steps_ValidationStep__run__Lamf_plugins_document_webapi_validation_runner_ResultContainer__s_concurrent_ExecutionContext__s_concurrent_Future(this$3, rc$2$1, executionContext$2)
          };
          return jsx$2.map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2) {
            return (function(rc$2$2$1) {
              var rc$2$3 = $as_Lamf_plugins_document_webapi_validation_runner_ResultContainer(rc$2$2$1);
              return new $c_Lamf_core_validation_AMFValidationReport().init___Z__T__Lamf_ProfileName__sc_Seq(rc$2$3.valid$1, $this$2.validationContext$1.baseUnit$1.id__T(), $this$2.validationContext$1.profile$1, rc$2$3.results$1)
            })
          })($this$1)), $this$1.executionContext$1)
        })
      })($this)), $this.executionContext$1)
    })
  })(this)), this.executionContext$1)
});
function $as_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runner.WebApiValidationsRunner"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runner.WebApiValidationsRunner;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner: 0
}, false, "amf.plugins.document.webapi.validation.runner.WebApiValidationsRunner", {
  Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runner_WebApiValidationsRunner;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$() {
  $c_sr_AbstractFunction1.call(this)
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$.prototype.apply__O__O = (function(v1) {
  var value = $as_T(v1);
  return new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken().init___T(value)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$.prototype.toString__T = (function() {
  return "BodyNoFragmentCodeBaseExpressionToken"
});
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.BodyNoFragmentCodeBaseExpressionToken$", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$;
var $n_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$)) {
    $n_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$ = new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$() {
  $c_sr_AbstractFunction1.call(this)
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$.prototype.apply__O__O = (function(v1) {
  var value = $as_T(v1);
  return new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken().init___T(value)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$.prototype.toString__T = (function() {
  return "BodyWithFragmentCodeBaseExpressionToken"
});
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.BodyWithFragmentCodeBaseExpressionToken$", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$;
var $n_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$)) {
    $n_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$ = new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$() {
  $c_sr_AbstractFunction1.call(this)
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$.prototype.apply__O__O = (function(v1) {
  var value = $as_T(v1);
  return new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken().init___T(value)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$.prototype.toString__T = (function() {
  return "FragmentExpressionToken"
});
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.FragmentExpressionToken$", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$;
var $n_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$)) {
    $n_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$ = new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$() {
  $c_sr_AbstractFunction1.call(this)
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$.prototype.apply__O__O = (function(v1) {
  var value = $as_T(v1);
  return new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken().init___T(value)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$.prototype.toString__T = (function() {
  return "HeaderCodeBaseExpressionToken"
});
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.HeaderCodeBaseExpressionToken$", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$;
var $n_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$)) {
    $n_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$ = new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$() {
  $c_sr_AbstractFunction1.call(this)
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$.prototype.apply__O__O = (function(v1) {
  var value = $as_T(v1);
  return new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken().init___T(value)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$.prototype.toString__T = (function() {
  return "HeaderExpressionToken"
});
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.HeaderExpressionToken$", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$;
var $n_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$)) {
    $n_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$ = new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$() {
  $c_sr_AbstractFunction1.call(this)
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$.prototype.apply__O__O = (function(v1) {
  var value = $as_T(v1);
  return new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken().init___T(value)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$.prototype.toString__T = (function() {
  return "MessageBaseExpressionToken"
});
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.MessageBaseExpressionToken$", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$;
var $n_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$)) {
    $n_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$ = new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$() {
  $c_sr_AbstractFunction1.call(this)
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$.prototype.apply__O__O = (function(v1) {
  var value = $as_T(v1);
  return new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken().init___T(value)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$.prototype.toString__T = (function() {
  return "MethodBaseExpressionToken"
});
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.MethodBaseExpressionToken$", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$;
var $n_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$)) {
    $n_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$ = new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$() {
  $c_sr_AbstractFunction1.call(this)
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$.prototype.apply__O__O = (function(v1) {
  var value = $as_T(v1);
  return new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken().init___T(value)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$.prototype.toString__T = (function() {
  return "NameExpressionToken"
});
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.NameExpressionToken$", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$;
var $n_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$)) {
    $n_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$ = new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$() {
  $c_sr_AbstractFunction1.call(this)
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$.prototype.apply__O__O = (function(v1) {
  var value = $as_T(v1);
  return new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression().init___T(value)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$.prototype.toString__T = (function() {
  return "PathExpression"
});
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.PathExpression$", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$;
var $n_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$)) {
    $n_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$ = new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$() {
  $c_sr_AbstractFunction1.call(this)
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$.prototype.apply__O__O = (function(v1) {
  var value = $as_T(v1);
  return new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken().init___T(value)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$.prototype.toString__T = (function() {
  return "PayloadExpressionToken"
});
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.PayloadExpressionToken$", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$;
var $n_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$)) {
    $n_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$ = new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$() {
  $c_sr_AbstractFunction1.call(this)
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$.prototype.apply__O__O = (function(v1) {
  var value = $as_T(v1);
  return new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression().init___T(value)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$.prototype.toString__T = (function() {
  return "QueryExpression"
});
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.QueryExpression$", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$;
var $n_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$)) {
    $n_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$ = new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$() {
  $c_sr_AbstractFunction1.call(this)
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$.prototype.apply__O__O = (function(v1) {
  var value = $as_T(v1);
  return new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken().init___T(value)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$.prototype.toString__T = (function() {
  return "RequestCodeBaseExpressionToken"
});
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.RequestCodeBaseExpressionToken$", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$;
var $n_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$)) {
    $n_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$ = new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$() {
  $c_sr_AbstractFunction1.call(this)
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$.prototype.apply__O__O = (function(v1) {
  var value = $as_T(v1);
  return new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken().init___T(value)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$.prototype.toString__T = (function() {
  return "ResponseCodeBaseExpressionToken"
});
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.ResponseCodeBaseExpressionToken$", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$;
var $n_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$)) {
    $n_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$ = new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$() {
  $c_sr_AbstractFunction1.call(this)
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$.prototype.apply__O__O = (function(v1) {
  var value = $as_T(v1);
  return new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken().init___T(value)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$.prototype.toString__T = (function() {
  return "StatusCodeBaseExpressionToken"
});
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.StatusCodeBaseExpressionToken$", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$;
var $n_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$)) {
    $n_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$ = new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$() {
  $c_sr_AbstractFunction1.call(this)
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$.prototype.apply__O__O = (function(v1) {
  var value = $as_T(v1);
  return new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken().init___T(value)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$.prototype.toString__T = (function() {
  return "TokenExpressionToken"
});
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.TokenExpressionToken$", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$;
var $n_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$)) {
    $n_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$ = new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$() {
  $c_sr_AbstractFunction1.call(this)
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$.prototype = new $h_sr_AbstractFunction1();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$.prototype.apply__O__O = (function(v1) {
  var value = $as_T(v1);
  return new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken().init___T(value)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$.prototype.toString__T = (function() {
  return "URLBaseExpressionToken"
});
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.URLBaseExpressionToken$", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$;
var $n_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$)) {
    $n_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$ = new $c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$() {
  $c_O.call(this);
  this.PropertySource$1 = null;
  this.PropertyTarget$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$.prototype.constructor = $c_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$.prototype = $c_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$.prototype;
$c_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.PropertySource$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "propertySource"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "property source", "Source property shape in the dependency", $m_sci_Nil$()), true);
  var jsx$2 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Iri$());
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.PropertyTarget$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "propertyTarget"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "property target", "Target property shape in the dependency", $m_sci_Nil$()), true);
  $m_sci_List$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "PropertyDependencies")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$12 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$12);
    i = (((-1) + i) | 0)
  };
  var jsx$4 = result;
  var jsx$3 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  var this$13 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$13.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "Property Dependencies", "Dependency between sets of property shapes", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.PropertySource$1, this.PropertyTarget$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_shapes_models_PropertyDependencies().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$: 0
}, false, "amf.plugins.domain.shapes.metamodel.PropertyDependenciesModel$", {
  Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$.prototype.$classData = $d_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$;
var $n_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$ = (void 0);
function $m_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$() {
  if ((!$n_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$)) {
    $n_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$ = new $c_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$() {
  $c_O.call(this);
  this.Attribute$1 = null;
  this.Wrapped$1 = null;
  this.Name$1 = null;
  this.Namespace$1 = null;
  this.Prefix$1 = null;
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$.prototype.constructor = $c_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$.prototype = $c_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$.prototype;
$c_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.Attribute$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "xmlAttribute"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "xml attribute", "XML attribute mapping", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.Wrapped$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "xmlWrapped"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "xml wrapped", "XML wrapped mapping flag", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_core_metamodel_Type$Str$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.Name$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "xmlName"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "xml name", "XML name mapping", $m_sci_Nil$()), true);
  var jsx$4 = $m_Lamf_core_metamodel_Type$Str$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.Namespace$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "xmlNamespace"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "xml namespace", "XML namespace mapping", $m_sci_Nil$()), true);
  var jsx$5 = $m_Lamf_core_metamodel_Type$Str$();
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.Prefix$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "xmlPrefix"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "xml prefix", "XML prefix mapping", $m_sci_Nil$()), true);
  $m_sci_List$();
  var array = [this.Attribute$1, this.Wrapped$1, this.Name$1, this.Namespace$1, this.Prefix$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$19 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$19);
    i = (((-1) + i) | 0)
  };
  var jsx$7 = result;
  var jsx$6 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$20 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$7.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$6, this$20.ReusableCBFInstance$2));
  $m_sci_List$();
  var this$21 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var array$1 = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$21, "XMLSerializer")];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$26 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$26);
    i$1 = (((-1) + i$1) | 0)
  };
  var jsx$9 = result$1;
  var jsx$8 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  var this$27 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$9.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$8, this$27.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "XML Serializer", "Information about how to encode into XML a particular data shape", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_shapes_models_XMLSerializer().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$: 0
}, false, "amf.plugins.domain.shapes.metamodel.XMLSerializerModel$", {
  Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$.prototype.$classData = $d_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$;
var $n_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$ = (void 0);
function $m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$() {
  if ((!$n_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$)) {
    $n_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$ = new $c_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_CreativeWork() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_CreativeWork;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_CreativeWork() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_CreativeWork.prototype = $c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype;
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_CreativeWork().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this.id$1;
  return $as_Lamf_core_model_domain_Linkable($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$()
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.searchIdPart__p1__s_Option = (function() {
  var x1 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var target = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    if ((target instanceof $c_Lamf_plugins_domain_shapes_models_CreativeWork)) {
      var x3 = $as_Lamf_plugins_domain_shapes_models_CreativeWork(target);
      var this$1 = $as_Lamf_core_model_StrField(x3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Title$1)).option$1;
      var this$2 = (this$1.isEmpty__Z() ? $as_Lamf_core_model_StrField(x3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Url$1)).option$1 : this$1);
      if (this$2.isEmpty__Z()) {
        return $m_s_None$()
      } else {
        var arg1 = this$2.get__O();
        var x$1 = $as_T(arg1);
        var this$4 = new $c_Lamf_core_utils_package$AmfStrings().init___T(x$1);
        var this$5 = this$4.platform$1;
        var url = this$4.str$1;
        return new $c_s_Some().init___O($f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$5, url))
      }
    }
  };
  var this$6 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Title$1)).option$1;
  var this$7 = (this$6.isEmpty__Z() ? $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Url$1)).option$1 : this$6);
  if (this$7.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1$1 = this$7.get__O();
    var x$2 = $as_T(arg1$1);
    var this$9 = new $c_Lamf_core_utils_package$AmfStrings().init___T(x$2);
    var this$10 = this$9.platform$1;
    var url$1 = this$9.str$1;
    return new $c_s_Some().init___O($f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$10, url$1))
  }
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.componentId__T = (function() {
  var this$1 = this.searchIdPart__p1__s_Option();
  return ("/creative-work/" + (this$1.isEmpty__Z() ? null : this$1.get__O()))
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_shapes_models_CreativeWork().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_shapes_models_CreativeWork(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_models_CreativeWork) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.models.CreativeWork"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_models_CreativeWork(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_models_CreativeWork)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_models_CreativeWork(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_models_CreativeWork(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.models.CreativeWork;", depth))
}
var $d_Lamf_plugins_domain_shapes_models_CreativeWork = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_CreativeWork: 0
}, false, "amf.plugins.domain.shapes.models.CreativeWork", {
  Lamf_plugins_domain_shapes_models_CreativeWork: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1
});
$c_Lamf_plugins_domain_shapes_models_CreativeWork.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_CreativeWork;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch() {
  $c_O.call(this);
  this.isNull$1 = null;
  this.keyCriteria$1 = null;
  this.ignoredFields$1 = null
}
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch.prototype.skipRecursiveMerge__p1__Lamf_core_metamodel_Field__Z = (function(field) {
  return ($is_Lamf_core_metamodel_domain_ShapeModel(field.type$1) || field.type$1.equals__O__Z($m_Lamf_core_metamodel_domain_DataNodeModel$()))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch.prototype.productPrefix__T = (function() {
  return "JsonMergePatch"
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch.prototype.init___F1__Lamf_plugins_domain_shapes_resolution_stages_merge_KeyCriteria__sc_Seq = (function(isNull, keyCriteria, ignoredFields) {
  this.isNull$1 = isNull;
  this.keyCriteria$1 = keyCriteria;
  this.ignoredFields$1 = ignoredFields;
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch)) {
    var JsonMergePatch$1 = $as_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch(x$1);
    var x = this.isNull$1;
    var x$2 = JsonMergePatch$1.isNull$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.keyCriteria$1;
      var x$4 = JsonMergePatch$1.keyCriteria$1;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.ignoredFields$1;
      var x$6 = JsonMergePatch$1.ignoredFields$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.isNull$1;
      break
    }
    case 1: {
      return this.keyCriteria$1;
      break
    }
    case 2: {
      return this.ignoredFields$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch.prototype.mergeObjects__p1__Lamf_core_model_domain_AmfObject__Lamf_core_model_domain_AmfObject__Lamf_core_model_domain_AmfObject = (function(target, patch) {
  var this$1 = patch.fields__Lamf_core_parser_Fields();
  var this$4 = this$1.fs$1;
  var this$2 = $m_Lamf_core_parser_FieldEntry$();
  var f = $f_F2__tupled__F1(this$2);
  var this$3 = $m_sci_Iterable$();
  var bf = this$3.ReusableCBFInstance$2;
  $as_sc_IterableLike($as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$4, f, bf)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(entry$2) {
      var entry = $as_Lamf_core_parser_FieldEntry(entry$2);
      return (!$this.ignoredFields$1.contains__O__Z(entry.field$1))
    })
  })(this)))).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, target$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_parser_FieldEntry(x0$1$2);
      if ((x0$1 !== null)) {
        var field = x0$1.field$1;
        var fieldValue = x0$1.value$1;
        var element = fieldValue.value$1;
        if ($uZ(this$2$1.isNull$1.apply__O__O(element))) {
          return target$1.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields(field)
        } else if (this$2$1.skipRecursiveMerge__p1__Lamf_core_metamodel_Field__Z(field)) {
          var value = fieldValue.value$1;
          return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(target$1, field, value)
        } else {
          var nextValue = this$2$1.merge__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement(target$1.fields__Lamf_core_parser_Fields().get__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement(field), element);
          return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(target$1, field, nextValue)
        }
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, target)));
  return target
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch.prototype.mergeArrays__p1__Lamf_core_model_domain_AmfArray__Lamf_core_model_domain_AmfArray__sc_Seq = (function(patch, target) {
  var targetMap = this.getTargetMap__p1__Lamf_core_model_domain_AmfArray__sci_Map(target);
  return $as_sc_MapLike(patch.values$1.foldLeft__O__F2__O(targetMap, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(acc$2, p$2) {
      var acc = $as_sci_Map(acc$2);
      var p = $as_Lamf_core_model_domain_AmfElement(p$2);
      var targetElement = $as_Lamf_core_model_domain_AmfElement(acc.getOrElse__O__F0__O($this.keyCriteria$1.getKeyFor__Lamf_core_model_domain_AmfElement__s_Option(p).get__O(), new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this$1) {
        return (function() {
          return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(0, new $c_Lamf_core_parser_Annotations().init___())
        })
      })($this))));
      var self = $this.keyCriteria$1.getKeyFor__Lamf_core_model_domain_AmfElement__s_Option(p).get__O();
      var y = $this.merge__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement(targetElement, p);
      return acc.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, y))
    })
  })(this)))).values__sc_Iterable().toSeq__sc_Seq()
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch.prototype.getTargetMap__p1__Lamf_core_model_domain_AmfArray__sci_Map = (function(target) {
  var jsx$2 = target.values$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(t$2) {
      var t = $as_Lamf_core_model_domain_AmfElement(t$2);
      return new $c_T2().init___O__O($this.keyCriteria$1.getKeyFor__Lamf_core_model_domain_AmfElement__s_Option(t).get__O(), t)
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  return $as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2)
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch.prototype.mergeObjectLikeArrays__p1__Lamf_core_model_domain_AmfArray__Lamf_core_model_domain_AmfArray__Lamf_core_model_domain_AmfArray = (function(target, patch) {
  var this$1 = this.keyCriteria$1;
  if ($f_Lamf_plugins_domain_shapes_resolution_stages_merge_KeyCriteria__hasKeysForAll__Lamf_core_model_domain_AmfArray__Z(this$1, target)) {
    var this$2 = this.keyCriteria$1;
    var jsx$1 = $f_Lamf_plugins_domain_shapes_resolution_stages_merge_KeyCriteria__hasKeysForAll__Lamf_core_model_domain_AmfArray__Z(this$2, patch)
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var mergedArray = this.mergeArrays__p1__Lamf_core_model_domain_AmfArray__Lamf_core_model_domain_AmfArray__sc_Seq(patch, target);
    return new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(mergedArray, new $c_Lamf_core_parser_Annotations().init___())
  } else {
    return patch
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch.prototype.merge__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfElement = (function(target, patch) {
  if ($is_Lamf_core_model_domain_AmfObject(target)) {
    if ($is_Lamf_core_model_domain_AmfObject(patch)) {
      return this.mergeObjects__p1__Lamf_core_model_domain_AmfObject__Lamf_core_model_domain_AmfObject__Lamf_core_model_domain_AmfObject($as_Lamf_core_model_domain_AmfObject(target), $as_Lamf_core_model_domain_AmfObject(patch))
    }
  };
  if ((target instanceof $c_Lamf_core_model_domain_AmfArray)) {
    var x6 = $as_Lamf_core_model_domain_AmfArray(target);
    if ((patch instanceof $c_Lamf_core_model_domain_AmfArray)) {
      var x7 = $as_Lamf_core_model_domain_AmfArray(patch);
      return this.mergeObjectLikeArrays__p1__Lamf_core_model_domain_AmfArray__Lamf_core_model_domain_AmfArray__Lamf_core_model_domain_AmfArray(x6, x7)
    }
  };
  return patch
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.resolution.stages.merge.JsonMergePatch"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.resolution.stages.merge.JsonMergePatch;", depth))
}
var $d_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.merge.JsonMergePatch", {
  Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_merge_JsonMergePatch;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster() {
  $c_O.call(this);
  this.any$1 = null
}
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster.prototype.productPrefix__T = (function() {
  return "AnyShapeAdjuster"
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape = (function(any) {
  this.any$1 = any;
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster.prototype.adjust__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  if (this.checkModelFields__p1__sci_List__Z($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().specificFields$1)) {
    var any = this.any$1;
    return new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter().init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster__Lamf_plugins_domain_shapes_models_AnyShape(this, any).toNodeShape__Lamf_plugins_domain_shapes_models_NodeShape()
  } else if (this.checkModelFields__p1__sci_List__Z($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().specificFields$1)) {
    var any$1 = this.any$1;
    return new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter().init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster__Lamf_plugins_domain_shapes_models_AnyShape(this, any$1).toArrayShape__Lamf_plugins_domain_shapes_models_ArrayShape()
  } else if (this.checkModelFields__p1__sci_List__Z($m_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$().specificFields$1)) {
    var any$2 = this.any$1;
    return new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter().init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster__Lamf_plugins_domain_shapes_models_AnyShape(this, any$2).toFileShape__Lamf_plugins_domain_shapes_models_FileShape()
  } else if (this.checkModelFields__p1__sci_List__Z($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().specificFields$1)) {
    var any$3 = this.any$1;
    return new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter().init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster__Lamf_plugins_domain_shapes_models_AnyShape(this, any$3).toScalarShape__Lamf_plugins_domain_shapes_models_ScalarShape()
  } else if (this.checkModelFields__p1__sci_List__Z($m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$().specificFields$1)) {
    var any$4 = this.any$1;
    return new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter().init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster__Lamf_plugins_domain_shapes_models_AnyShape(this, any$4).toSchemaShape__Lamf_plugins_domain_shapes_models_SchemaShape()
  } else if (this.checkModelFields__p1__sci_List__Z($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().specificFields$1)) {
    var any$5 = this.any$1;
    return new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$AnyShapeConverter().init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster__Lamf_plugins_domain_shapes_models_AnyShape(this, any$5).toUnionShape__Lamf_plugins_domain_shapes_models_UnionShape()
  } else {
    return this.any$1
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster)) {
    var AnyShapeAdjuster$1 = $as_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster(x$1);
    var x = this.any$1;
    var x$2 = AnyShapeAdjuster$1.any$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.any$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster.prototype.checkModelFields__p1__sci_List__Z = (function(specificFields) {
  var these = specificFields;
  while ((!these.isEmpty__Z())) {
    var arg1 = these.head__O();
    var f = $as_Lamf_core_metamodel_Field(arg1);
    var this$1 = this.any$1.fields__Lamf_core_parser_Fields();
    if (this$1.fs$1.contains__O__Z(f)) {
      return true
    };
    these = $as_sc_LinearSeqOptimized(these.tail__O())
  };
  return false
});
function $as_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.AnyShapeAdjuster"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.resolution.stages.shape_normalization.AnyShapeAdjuster;", depth))
}
var $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.AnyShapeAdjuster", {
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$() {
  $c_O.call(this);
  this.parserRun$1 = 0
}
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$.prototype.handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V = (function(location, e) {
  $f_Lamf_core_parser_errorhandler_ParserErrorHandler__handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V(this, location, e)
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$.prototype.handle__Lorg_yaml_model_YError__O__O = (function(error, defaultValue) {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("raising exceptions in union processing"))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$.prototype.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V = (function(specification, node, property, message, lexical, location) {
  this.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().WARNING$1, location)
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$.prototype.parserRun__I = (function() {
  return this.parserRun$1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$.prototype.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V = (function(id, node, property, message, lexical, level, location) {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("raising exceptions in union processing"))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$.prototype.init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm = (function($$outer) {
  this.parserRun$1 = $m_Lamf_core_AMFCompilerRunCount$().NONE$1;
  return this
});
var $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.MinShapeAlgorithm$UnionErrorHandler$", {
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$: 1,
  O: 1,
  Lamf_core_parser_errorhandler_ParserErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  Lorg_yaml_model_ParseErrorHandler: 1,
  Lamf_core_errorhandling_ErrorHandler: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$UnionErrorHandler$;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache() {
  $c_O.call(this);
  this.cache$1 = null;
  this.fixPointCache$1 = null;
  this.mappings$1 = null
}
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache.prototype.init___ = (function() {
  this.cache$1 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.fixPointCache$1 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.mappings$1 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache.prototype.productPrefix__T = (function() {
  return "NormalizationCache"
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache) && ($as_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache(x$1), true))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache.prototype.$$plus__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache = (function(shape) {
  if ((shape instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
    var x2 = $as_Lamf_core_model_domain_RecursiveShape(shape);
    this.registerFixPoint__p1__Lamf_core_model_domain_RecursiveShape__Lamf_core_model_domain_RecursiveShape(x2)
  };
  this.cache$1.put__O__O__s_Option(shape.id$1, shape);
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache.prototype.updateRecursiveTargets__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache = (function(newShape) {
  $as_sc_IterableLike($as_sc_TraversableLike(this.fixPointCache$1.values__sc_Iterable().flatten__F1__sc_GenTraversable($m_s_Predef$().singleton$und$less$colon$less$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, newShape$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_domain_RecursiveShape(x$1$2);
      var this$1 = x$1.internalFixpointTarget$2;
      if ((!this$1.isEmpty__Z())) {
        var arg1 = this$1.get__O();
        var x$2 = $as_Lamf_core_model_domain_Shape(arg1);
        return (x$2.id$1 === newShape$1.id$1)
      } else {
        return false
      }
    })
  })(this, newShape)))).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, newShape$2) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_core_model_domain_RecursiveShape(x$3$2);
      return x$3.withFixpointTarget__Lamf_core_model_domain_Shape__Lamf_core_model_domain_RecursiveShape(newShape$2)
    })
  })(this, newShape)));
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache.prototype.registerFixPoint__p1__Lamf_core_model_domain_RecursiveShape__Lamf_core_model_domain_RecursiveShape = (function(r) {
  var this$1 = $as_Lamf_core_model_StrField(r.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_RecursiveShapeModel$().FixPoint$1)).option$1;
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var fp = $as_T(arg1);
    var alias = this.mappings$1.get__O__s_Option(fp);
    var x1 = this.fixPointCache$1.get__O__s_Option(fp);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var s = $as_sc_Seq(x2.value$2);
      var this$2 = $m_sc_Seq$();
      var shapes = $as_sc_Seq(s.$$colon$plus__O__scg_CanBuildFrom__O(r, this$2.ReusableCBFInstance$2));
      if (alias.isEmpty__Z()) {
        var newAlias = fp
      } else {
        var arg1$1 = alias.get__O();
        var a = $as_T(arg1$1);
        shapes.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, a$1) {
          return (function(x$5$2) {
            var x$5 = $as_Lamf_core_model_domain_RecursiveShape(x$5$2);
            var field = $m_Lamf_core_metamodel_domain_RecursiveShapeModel$().FixPoint$1;
            return $as_Lamf_core_model_domain_RecursiveShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x$5, field, a$1))
          })
        })(this, a)));
        this.fixPointCache$1.remove__O__s_Option(fp);
        var newAlias = a
      };
      this.fixPointCache$1.put__O__O__s_Option(newAlias, shapes)
    } else if (alias.isEmpty__Z()) {
      var jsx$2 = this.fixPointCache$1;
      var jsx$1 = $m_sc_Seq$();
      var array = [r];
      jsx$2.put__O__O__s_Option(fp, jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
    } else {
      var arg1$2 = alias.get__O();
      var a$3 = $as_T(arg1$2);
      var field$1 = $m_Lamf_core_metamodel_domain_RecursiveShapeModel$().FixPoint$1;
      $as_Lamf_core_model_domain_RecursiveShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(r, field$1, a$3));
      var jsx$4 = this.fixPointCache$1;
      var jsx$3 = $m_sc_Seq$();
      var array$1 = [r];
      jsx$4.put__O__O__s_Option(a$3, jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)))
    }
  };
  return r
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache.prototype.updateFixPoints__Lamf_core_model_domain_Shape__Z__V = (function(canonical, withoutCaching) {
  matchEnd4: {
    if ((canonical instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
      var x2 = $as_Lamf_core_model_domain_RecursiveShape(canonical);
      if ((x2.internalFixpointTarget$2.isDefined__Z() && ($as_Lamf_core_model_domain_AmfObject(x2.internalFixpointTarget$2.get__O()).id__T() === canonical.id$1))) {
        x2.withFixpointTarget__Lamf_core_model_domain_Shape__Lamf_core_model_domain_RecursiveShape(canonical);
        break matchEnd4
      }
    }
  };
  if ((!withoutCaching)) {
    this.updateRecursiveTargets__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache(canonical)
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache.prototype.registerMapping__T__T__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache = (function(id, alias) {
  var x1 = this.mappings$1.get__O__s_Option(alias);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var a = $as_T(x2.value$2);
    this.mappings$1.remove__O__s_Option(alias);
    this.mappings$1.put__O__O__s_Option(id, a)
  } else {
    this.mappings$1.put__O__O__s_Option(id, alias);
    var this$1 = this.fixPointCache$1.get__O__s_Option(id);
    if ((!this$1.isEmpty__Z())) {
      var arg1 = this$1.get__O();
      var seq = $as_sc_Seq(arg1);
      this.fixPointCache$1.remove__O__s_Option(id);
      var jsx$2 = this.fixPointCache$1;
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, alias$1) {
        return (function(x$4$2) {
          var x$4 = $as_Lamf_core_model_domain_RecursiveShape(x$4$2);
          var field = $m_Lamf_core_metamodel_domain_RecursiveShapeModel$().FixPoint$1;
          return $as_Lamf_core_model_domain_RecursiveShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x$4, field, alias$1))
        })
      })(this, alias));
      var this$2 = $m_sc_Seq$();
      jsx$2.put__O__O__s_Option(alias, seq.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2))
    }
  };
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.NormalizationCache"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.resolution.stages.shape_normalization.NormalizationCache;", depth))
}
var $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.NormalizationCache", {
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$() {
  $c_O.call(this);
  this.TemplateVariable$1 = null;
  this.LinkExpression$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.TemplateVariable$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "templateVariable"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "templateVariable", "Variable defined inside an URL template", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.LinkExpression$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "linkExpression"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "link expression", "OAS 3 link expression", $m_sci_Nil$()), true);
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "IriTemplateMapping");
  var this$9 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$9);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Iri Template", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$.prototype.fields__sci_List = (function() {
  var x$3 = this.TemplateVariable$1;
  var x$2 = this.LinkExpression$1;
  var this$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$2 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$1);
  return new $c_sci_$colon$colon().init___O__sci_List(x$3, this$2)
});
$c_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_IriTemplateMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.IriTemplateMappingModel$", {
  Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$() {
  $c_O.call(this);
  this.Topic$1 = null;
  this.Qos$1 = null;
  this.Retain$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Topic$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "topic"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "topic", "The topic where the Last Will and Testament message will be sent", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Int$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Qos$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "qos"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "qos", "Defines how hard the broker/client will try to ensure that the Last Will and Testament message is received", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Retain$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "retain"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "retain", "Whether the broker should retain the Last Will and Testament message or not", $m_sci_Nil$()), true);
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "MqttServerLastWill");
  var this$12 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$12);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "MqttServerLastWill", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Topic$1, this.Qos$1, this.Retain$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.MqttServerLastWillModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$() {
  $c_O.call(this);
  this.Name$1 = null;
  this.Description$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Name$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "name"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "name", "Name of the scope", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Description$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "description"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "description", "Human readable description for the scope", $m_sci_Nil$()), true);
  $m_sci_List$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "Scope")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$12 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$12);
    i = (((-1) + i) | 0)
  };
  var jsx$4 = result;
  var jsx$3 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  var this$13 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$13.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "Scope", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Name$1, this.Description$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_security_Scope().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.security.ScopeModel$", {
  Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange.prototype = $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange.prototype;
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$()
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange.prototype.componentId__T = (function() {
  return "/amqp091-exchange"
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$().Name$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.amqp.Amqp091ChannelExchange"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.amqp.Amqp091ChannelExchange;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange: 0
}, false, "amf.plugins.domain.webapi.models.bindings.amqp.Amqp091ChannelExchange", {
  Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_NamedDomainElement: 1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue.prototype = $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue.prototype;
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$()
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue.prototype.componentId__T = (function() {
  return "/amqp091-queue"
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$().Name$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.amqp.Amqp091Queue"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.amqp.Amqp091Queue;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue: 0
}, false, "amf.plugins.domain.webapi.models.bindings.amqp.Amqp091Queue", {
  Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_NamedDomainElement: 1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging() {
  $c_O.call(this);
  this.Adopted$module$1 = null;
  this.ctx$1 = null;
  this.whiteListFields$1 = null;
  this.possibleImplicitFields$1 = null
}
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.productPrefix__T = (function() {
  return "DomainElementMerging"
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.mergeDataNodes__p1__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfArray__Lamf_core_model_domain_AmfArray__V = (function(target, field, main, other) {
  var mainNodes = main.values$1;
  var otherNodes = other.values$1;
  otherNodes.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, mainNodes$1, target$1, field$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_domain_DataNode(x0$1$2);
      if ((x0$1 instanceof $c_Lamf_core_model_domain_ScalarNode)) {
        var x2 = $as_Lamf_core_model_domain_ScalarNode(x0$1);
        var pf = new $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$$anonfun$$nestedInanonfun$mergeDataNodes$1$1().init___Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging__Lamf_core_model_domain_ScalarNode($this, x2);
        if ($f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(mainNodes$1, pf).isEmpty__Z()) {
          return $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(target$1, field$1, x2)
        } else {
          return (void 0)
        }
      } else if ((x0$1 !== null)) {
        return $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(target$1, field$1, x0$1)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, mainNodes, target, field)))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.adoptNonOptionalArrayElements__p1__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Value__Lamf_core_metamodel_Type__V = (function(target, arrayField, otherArrayValue, otherArrayElementsType) {
  if ($is_Lamf_core_metamodel_domain_templates_OptionalField(otherArrayElementsType)) {
    var x2 = $as_Lamf_core_metamodel_domain_templates_OptionalField(otherArrayElementsType);
    var nonOptionalElements = $as_sc_Seq($as_Lamf_core_model_domain_AmfArray(otherArrayValue.value$1).values$1.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x2$1) {
      return (function(v$2) {
        var v = $as_Lamf_core_model_domain_AmfElement(v$2);
        return (!$this.isOptional__p1__Lamf_core_metamodel_Type__Lamf_core_model_domain_DomainElement__Z(x2$1, $as_Lamf_core_model_domain_DomainElement(v)))
      })
    })(this, x2))));
    var value = this.adoptInner__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted__Lamf_core_model_domain_AmfElement(target.id__T(), new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(nonOptionalElements, new $c_Lamf_core_parser_Annotations().init___()), new $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted().init___Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging(this));
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(target, arrayField, value)
  } else {
    var value$1 = this.adoptInner__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted__Lamf_core_model_domain_AmfElement(target.id__T(), otherArrayValue.value$1, new $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted().init___Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging(this));
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(target, arrayField, value$1)
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.init___Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(ctx) {
  this.ctx$1 = ctx;
  $m_sci_List$();
  var array = [$m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field(), $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Optional$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  this.whiteListFields$1 = result;
  $m_sci_List$();
  var array$1 = [$m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1, $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1, $m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$8 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$8);
    i$1 = (((-1) + i$1) | 0)
  };
  this.possibleImplicitFields$1 = result$1;
  return this
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging) && ($as_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging(x$1), true))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.handleNewFieldEntry__Lamf_core_model_domain_DomainElement__Lamf_core_parser_FieldEntry__Lamf_core_errorhandling_ErrorHandler__V = (function(main, otherFieldEntry, errorHandler) {
  var otherField = otherFieldEntry.field$1;
  var otherValue = otherFieldEntry.value$1;
  var x$2 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1;
  if (((otherField === null) ? (x$2 === null) : otherField.equals__O__Z(x$2))) {
    $as_Lamf_core_model_domain_AmfArray(otherValue.value$1).values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_model_domain_AmfElement(x0$1$2);
        matchEnd4: {
          if ((x0$1 instanceof $c_Lamf_plugins_domain_webapi_models_Operation)) {
            var x2 = $as_Lamf_plugins_domain_webapi_models_Operation(x0$1);
            if ((!$this.isOptional__p1__Lamf_core_metamodel_Type__Lamf_core_model_domain_DomainElement__Z($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$(), x2))) {
              $this.ctx$1.mergeOperationContext__T__V(x2.id$1);
              break matchEnd4
            }
          }
        }
      })
    })(this)))
  };
  if (this.isValidToAdd__p1__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Z(main, otherField)) {
    var x1 = otherField.type$1;
    matchEnd6: {
      if ($is_Lamf_core_metamodel_domain_templates_OptionalField(x1)) {
        var x4 = $as_Lamf_core_metamodel_domain_templates_OptionalField(x1);
        if (this.isOptional__p1__Lamf_core_metamodel_Type__Lamf_core_model_domain_DomainElement__Z(x4, $as_Lamf_core_model_domain_DomainElement(otherValue.value$1))) {
          break matchEnd6
        }
      };
      if ((x1 instanceof $c_Lamf_core_metamodel_Type$ArrayLike)) {
        var x2$1 = $as_Lamf_core_metamodel_Type$ArrayLike(x1);
        var o10 = new $c_s_Some().init___O(x2$1.element__Lamf_core_metamodel_Type());
        var otherElement = $as_Lamf_core_metamodel_Type(o10.value$2);
        this.adoptNonOptionalArrayElements__p1__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Value__Lamf_core_metamodel_Type__V(main, otherField, otherValue, otherElement);
        break matchEnd6
      };
      var value = this.adoptInner__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted__Lamf_core_model_domain_AmfElement(main.id__T(), otherValue.value$1, new $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted().init___Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging(this));
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(main, otherField, value)
    }
  } else if (this.isExplicitField__p1__Lamf_core_parser_FieldEntry__Z(otherFieldEntry)) {
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
    var node = main.id__T();
    var message = ((("Cannot merge '" + otherField.value$1.name$1) + "' into ") + main.meta__Lamf_core_metamodel_Obj().doc__Lamf_core_metamodel_domain_ModelDoc().displayName$1);
    var annotations = main.annotations__Lamf_core_parser_Annotations();
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(errorHandler, specification, node, message, annotations)
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.mergeByKeyValue__p1__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_metamodel_Type__Lamf_core_metamodel_domain_templates_KeyField__Lamf_core_model_domain_AmfArray__Lamf_core_model_domain_AmfArray__V = (function(target, field, element, key, main, other) {
  var jsx$2 = main.values$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, key$1) {
    return (function(m$2) {
      var m = $as_Lamf_core_model_domain_AmfElement(m$2);
      var obj = $as_Lamf_core_model_domain_DomainElement(m);
      var this$1 = obj.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option(key$1.key__Lamf_core_metamodel_Field());
      if (this$1.isEmpty__Z()) {
        var this$2 = $m_s_None$()
      } else {
        var arg1 = this$1.get__O();
        var x$5 = $as_Lamf_core_parser_FieldEntry(arg1);
        var this$2 = new $c_s_Some().init___O($as_Lamf_core_model_domain_AmfScalar(x$5.value$1.value$1).value$1)
      };
      var self = (this$2.isEmpty__Z() ? $m_s_None$() : this$2.get__O());
      return new $c_T2().init___O__O(self, obj)
    })
  })(this, key));
  var this$5 = $m_sc_Seq$();
  var existing = $as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2);
  other.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, key$2, existing$1, field$1, target$1, element$1) {
    return (function(o$2) {
      var o = $as_Lamf_core_model_domain_AmfElement(o$2);
      var otherObj = $as_Lamf_core_model_domain_DomainElement(o);
      var x1 = otherObj.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option(key$2.key__Lamf_core_metamodel_Field());
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var value = $as_Lamf_core_parser_FieldEntry(x2.value$2);
        if ((!existing$1.contains__O__Z($m_s_None$()))) {
          if (existing$1.contains__O__Z($as_Lamf_core_model_domain_AmfScalar(value.value$1.value$1).value$1)) {
            var x$2 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1;
            if (((field$1 === null) ? (x$2 === null) : field$1.equals__O__Z(x$2))) {
              this$2$1.ctx$1.mergeOperationContext__T__V(otherObj.id__T())
            };
            var adopted = $as_Lamf_core_model_domain_DomainElement(this$2$1.adoptInner__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted__Lamf_core_model_domain_AmfElement(target$1.id__T(), otherObj, new $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted().init___Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging(this$2$1)));
            return this$2$1.merge__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement($as_Lamf_core_model_domain_DomainElement(existing$1.apply__O__O($as_Lamf_core_model_domain_AmfScalar(value.value$1.value$1).value$1)), adopted)
          } else if ((!this$2$1.isOptional__p1__Lamf_core_metamodel_Type__Lamf_core_model_domain_DomainElement__Z(element$1, otherObj))) {
            var x$4 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1;
            if (((field$1 === null) ? (x$4 === null) : field$1.equals__O__Z(x$4))) {
              this$2$1.ctx$1.mergeOperationContext__T__V(otherObj.id__T())
            };
            var value$1 = this$2$1.adoptInner__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted__Lamf_core_model_domain_AmfElement(target$1.id__T(), o, new $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted().init___Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging(this$2$1));
            return $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(target$1, field$1, value$1)
          } else {
            return (void 0)
          }
        }
      };
      var x$5$1 = $m_s_None$();
      if ((x$5$1 === x1)) {
        var this$6 = existing$1.iterator__sc_Iterator();
        var res = true;
        while ((res && this$6.hasNext__Z())) {
          var arg1$1 = this$6.next__O();
          var x$6$2 = $as_T2(arg1$1);
          var x = x$6$2.$$und1__O();
          var x$2$1 = $m_s_None$();
          res = (!((x !== null) && $objectEquals(x, x$2$1)))
        };
        var jsx$3 = (!res)
      } else {
        var jsx$3 = false
      };
      if (jsx$3) {
        if (existing$1.contains__O__Z($m_s_None$())) {
          return this$2$1.merge__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement($as_Lamf_core_model_domain_DomainElement(existing$1.apply__O__O($m_s_None$())), $as_Lamf_core_model_domain_DomainElement(otherObj.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(target$1.id__T(), otherObj.adopted$default$2__sc_Seq())))
        } else if ((!this$2$1.isOptional__p1__Lamf_core_metamodel_Type__Lamf_core_model_domain_DomainElement__Z(element$1, otherObj))) {
          var value$2 = this$2$1.adoptInner__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted__Lamf_core_model_domain_AmfElement(target$1.id__T(), o, new $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted().init___Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging(this$2$1));
          return $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(target$1, field$1, value$2)
        } else {
          return (void 0)
        }
      }
    })
  })(this, key, existing, field, target, element)))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.mergeByValue__p1__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfArray__Lamf_core_model_domain_AmfArray__V = (function(target, field, main, other) {
  var jsx$2 = main.values$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$4$2) {
      var x$4 = $as_Lamf_core_model_domain_AmfElement(x$4$2);
      return $as_Lamf_core_model_domain_AmfScalar(x$4).value$1
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var existing = $as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).toSet__sci_Set();
  other.values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, existing$1, target$1, field$1) {
    return (function(value$2) {
      var value = $as_Lamf_core_model_domain_AmfElement(value$2);
      var scalar = $as_Lamf_core_model_domain_AmfScalar(value).value$1;
      if ((!existing$1.contains__O__Z(scalar))) {
        var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(scalar, new $c_Lamf_core_parser_Annotations().init___());
        return $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(target$1, field$1, value$1)
      } else {
        return (void 0)
      }
    })
  })(this, existing, target, field)))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.handleExistingFieldEntries__Lamf_core_model_domain_DomainElement__Lamf_core_parser_FieldEntry__Lamf_core_parser_FieldEntry__Lamf_core_errorhandling_ErrorHandler__Z = (function(main, mainFieldEntry, otherFieldEntry, errorHandler) {
  var otherField = otherFieldEntry.field$1;
  var otherValue = otherFieldEntry.value$1;
  var mainValue = mainFieldEntry.value$1;
  var mainFieldEntryHasValue = $m_s_Option$().apply__O__s_Option(mainValue).isDefined__Z();
  var x1 = $m_s_Option$().apply__O__s_Option(mainValue);
  if ((x1 instanceof $c_s_Some)) {
    var mainFieldEntryValueIsDefined = $m_s_Option$().apply__O__s_Option(mainValue.value$1).isDefined__Z()
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var mainFieldEntryValueIsDefined = false
  };
  var shouldMerge = true;
  if ((mainFieldEntryHasValue && mainFieldEntryValueIsDefined)) {
    var mainValueIsAnyShape = (mainValue.value$1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape);
    var otherValueIsAnyShape = (otherValue.value$1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape);
    var mainValueIsInferred = mainValue.value$1.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_plugins_document_webapi_annotations_Inferred.getClassOf());
    var mainValueIsDefault = mainValue.value$1.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_DefaultNode.getClassOf());
    if (((mainValueIsAnyShape && otherValueIsAnyShape) && mainValueIsInferred)) {
      var target = $as_Lamf_plugins_domain_shapes_models_AnyShape(mainFieldEntry.value$1.value$1);
      var shape = $as_Lamf_plugins_domain_shapes_models_AnyShape(otherValue.value$1);
      var recursionErrorHandler = $m_s_None$();
      var withRecursionBase = $m_s_None$();
      var traversal = new $c_Lamf_core_traversal_ModelTraversalRegistry().init___();
      var qual$1 = $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_plugins_domain_shapes_models_ShapeHelpers__cloneShape__s_Option__s_Option__Lamf_core_traversal_ModelTraversalRegistry__Z__Lamf_core_model_domain_Shape(shape, recursionErrorHandler, withRecursionBase, traversal, false));
      var this$1 = $as_Lamf_core_model_StrField(target.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
      var this$2 = this$1.option$1;
      var x$1 = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
      $m_Lamf_core_parser_Annotations$();
      var x$2$2 = new $c_Lamf_core_parser_Annotations().init___();
      var cloned = $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, x$1, x$2$2));
      if ($as_sc_Seq(target.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).nonEmpty__Z()) {
        var examples = $as_sc_Seq(target.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1));
        var field = $m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1;
        $as_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(cloned, field, examples))
      };
      var value = this.adoptInner__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted__Lamf_core_model_domain_AmfElement(main.id__T(), cloned, new $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted().init___Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging(this));
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(main, otherField, value);
      shouldMerge = false
    } else if (mainValueIsDefault) {
      var x1$2 = otherField.type$1;
      matchEnd7: {
        if ($is_Lamf_core_metamodel_domain_templates_OptionalField(x1$2)) {
          var x4 = $as_Lamf_core_metamodel_domain_templates_OptionalField(x1$2);
          if (this.isOptional__p1__Lamf_core_metamodel_Type__Lamf_core_model_domain_DomainElement__Z(x4, $as_Lamf_core_model_domain_DomainElement(otherValue.value$1))) {
            break matchEnd7
          }
        };
        if ((x1$2 instanceof $c_Lamf_core_metamodel_Type$ArrayLike)) {
          var x2 = $as_Lamf_core_metamodel_Type$ArrayLike(x1$2);
          var o11 = new $c_s_Some().init___O(x2.element__Lamf_core_metamodel_Type());
          var otherElement = $as_Lamf_core_metamodel_Type(o11.value$2);
          this.adoptNonOptionalArrayElements__p1__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Value__Lamf_core_metamodel_Type__V(main, otherField, otherValue, otherElement);
          break matchEnd7
        };
        if ($is_Lamf_core_metamodel_domain_DomainElementModel(x1$2)) {
          var x1$3 = mainValue.value$1;
          if ((x1$3 instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
            var x2$2 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(x1$3);
            var this$5 = $as_Lamf_core_model_StrField(x2$2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1));
            var this$6 = this$5.option$1;
            if (($as_T((this$6.isEmpty__Z() ? null : this$6.get__O())) === $m_Lamf_core_model_DataType$().String$1)) {
              var rc6 = false;
              var x2$3 = null;
              var x1$4 = otherValue.value$1;
              if ((x1$4 instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
                rc6 = true;
                x2$3 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(x1$4);
                var this$7 = x2$3;
                var this$8 = $as_Lamf_core_model_StrField(this$7.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1));
                var this$9 = this$8.option$1;
                if (($as_T((this$9.isEmpty__Z() ? null : this$9.get__O())) === $m_Lamf_core_model_DataType$().String$1)) {
                  this.merge__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement($as_Lamf_core_model_domain_DomainElement(mainFieldEntry.value$1.value$1), $as_Lamf_core_model_domain_DomainElement(otherFieldEntry.value$1.value$1));
                  break matchEnd7
                }
              };
              if (rc6) {
                var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
                var this$10 = x2$3;
                var this$11 = $as_Lamf_core_model_StrField(this$10.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1));
                var this$12 = this$11.option$1;
                var value$1 = $as_T((this$12.isEmpty__Z() ? null : this$12.get__O()));
                $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x2$2, field$1, value$1);
                this.merge__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement($as_Lamf_core_model_domain_DomainElement(mainFieldEntry.value$1.value$1), $as_Lamf_core_model_domain_DomainElement(otherFieldEntry.value$1.value$1));
                break matchEnd7
              };
              if ((x1$4 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
                var x4$2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x1$4);
                var examples$1 = $as_sc_Seq(x2$2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1));
                var value$2 = this.adoptInner__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted__Lamf_core_model_domain_AmfElement(main.id__T(), x4$2, new $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted().init___Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging(this));
                $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(main, otherField, value$2);
                if (examples$1.nonEmpty__Z()) {
                  var this$13 = main.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option(otherField);
                  if ((!this$13.isEmpty__Z())) {
                    var arg1 = this$13.get__O();
                    var x$2$3 = $as_Lamf_core_parser_FieldEntry(arg1);
                    var this$14 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x$2$3.value$1.value$1);
                    var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1;
                    $as_Lamf_plugins_domain_shapes_models_AnyShape($as_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$14, field$2, examples$1)))
                  };
                  break matchEnd7
                } else {
                  break matchEnd7
                }
              };
              var value$3 = this.adoptInner__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted__Lamf_core_model_domain_AmfElement(main.id__T(), x1$4, new $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted().init___Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging(this));
              $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(main, otherField, value$3);
              break matchEnd7
            }
          };
          if ((x1$3 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
            this.merge__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement($as_Lamf_core_model_domain_DomainElement(mainFieldEntry.value$1.value$1), $as_Lamf_core_model_domain_DomainElement(otherFieldEntry.value$1.value$1));
            break matchEnd7
          };
          var value$4 = this.adoptInner__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted__Lamf_core_model_domain_AmfElement(main.id__T(), otherValue.value$1, new $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted().init___Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging(this));
          $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(main, otherField, value$4);
          break matchEnd7
        };
        var value$5 = this.adoptInner__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted__Lamf_core_model_domain_AmfElement(main.id__T(), otherValue.value$1, new $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted().init___Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging(this));
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(main, otherField, value$5)
      };
      shouldMerge = false
    }
  };
  if ((shouldMerge && (mainValue !== otherValue))) {
    var x1$5 = otherField.type$1;
    if ((!(x1$5 instanceof $c_Lamf_core_metamodel_Type$Scalar))) {
      if ((x1$5 instanceof $c_Lamf_core_metamodel_Type$ArrayLike)) {
        var x4$3 = $as_Lamf_core_metamodel_Type$ArrayLike(x1$5);
        var o12 = new $c_s_Some().init___O(x4$3.element__Lamf_core_metamodel_Type());
        var element = $as_Lamf_core_metamodel_Type(o12.value$2);
        this.mergeByValue__p1__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_metamodel_Type__Lamf_core_parser_Value__Lamf_core_parser_Value__V(main, otherField, element, mainValue, otherValue)
      } else if ($is_Lamf_core_metamodel_domain_DomainElementModel(x1$5)) {
        this.merge__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement($as_Lamf_core_model_domain_DomainElement(mainFieldEntry.value$1.value$1), $as_Lamf_core_model_domain_DomainElement(otherFieldEntry.value$1.value$1))
      } else {
        var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
        var node = main.id__T();
        var message = (("Cannot merge '" + otherField.type$1) + "':not a (Scalar|Array|Object)");
        var annotations = main.annotations__Lamf_core_parser_Annotations();
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(errorHandler, specification, node, message, annotations)
      }
    }
  };
  return shouldMerge
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.isValidToAdd__p1__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Z = (function(main, field) {
  if ((!((main instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape) || (main instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)))) {
    return true
  } else {
    var x$1 = this.whiteListFields$1;
    var this$1 = main.meta__Lamf_core_metamodel_Obj().fields__sci_List().$$colon$colon$colon__sci_List__sci_List(x$1);
    return $f_sc_LinearSeqOptimized__contains__O__Z(this$1, field)
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.isExplicitField__p1__Lamf_core_parser_FieldEntry__Z = (function(fe) {
  var this$1 = this.possibleImplicitFields$1;
  var elem = fe.field$1;
  if ((!$f_sc_LinearSeqOptimized__contains__O__Z(this$1, elem))) {
    return true
  } else {
    return fe.value$1.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_ExplicitField.getClassOf())
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.adoptInner__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted__Lamf_core_model_domain_AmfElement = (function(parentId, target, adopted) {
  if ((target instanceof $c_Lamf_core_model_domain_AmfArray)) {
    var x2 = $as_Lamf_core_model_domain_AmfArray(target);
    var jsx$2 = x2.values$1;
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3, parentId$1, adopted$1) {
      return (function(x$3$2) {
        var x$3 = $as_Lamf_core_model_domain_AmfElement(x$3$2);
        return this$3.adoptInner__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted__Lamf_core_model_domain_AmfElement(parentId$1, x$3, adopted$1)
      })
    })(this, parentId, adopted));
    var this$1 = $m_sc_Seq$();
    return new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)), x2.annotations$1)
  };
  if ($is_Lamf_core_model_domain_DomainElement(target)) {
    var x3 = $as_Lamf_core_model_domain_DomainElement(target);
    if (adopted.notYet__T__Z(x3.id__T())) {
      if ((x3 instanceof $c_Lamf_core_model_domain_Shape)) {
        var x2$1 = $as_Lamf_core_model_domain_Shape(x3);
        var jsx$4 = x2$1.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf())
      } else {
        var jsx$4 = false
      };
      var jsx$3 = (!jsx$4)
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var previousId = x3.id__T();
      this.adoptElementByType__p1__Lamf_core_model_domain_DomainElement__T__Lamf_core_model_domain_DomainElement(x3, parentId);
      adopted.$$plus$eq__T__Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted(x3.id__T());
      var this$2 = x3.fields__Lamf_core_parser_Fields();
      var fn = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4, x3$1, adopted$2) {
        return (function(x0$1$2) {
          var x0$1 = $as_T2(x0$1$2);
          if ((x0$1 !== null)) {
            var f = $as_Lamf_core_metamodel_Field(x0$1.$$und1__O());
            var value = $as_Lamf_core_parser_Value(x0$1.$$und2__O());
            if (this$4.isNotIgnored__p1__Lamf_core_parser_FieldEntry__Z(new $c_Lamf_core_parser_FieldEntry().init___Lamf_core_metamodel_Field__Lamf_core_parser_Value(f, value))) {
              this$4.adoptInner__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted__Lamf_core_model_domain_AmfElement(x3$1.id__T(), value.value$1, adopted$2)
            }
          } else {
            throw new $c_s_MatchError().init___O(x0$1)
          }
        })
      })(this, x3, adopted));
      this$2.fs$1.foreach__F1__V(fn);
      if ((x3 instanceof $c_Lamf_plugins_domain_webapi_models_Payload)) {
        var x2$2 = $as_Lamf_plugins_domain_webapi_models_Payload(x3);
        $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape($as_Lamf_core_model_domain_Shape(x2$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1)), x3.id__T(), ((x3.id__T() !== previousId) ? new $c_s_Some().init___O(previousId) : $m_s_None$()))
      };
      return x3
    }
  };
  return target
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.isNotIgnored__p1__Lamf_core_parser_FieldEntry__Z = (function(entry) {
  var x1 = entry.field$1;
  var x = $m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field();
  if (((x === null) ? (x1 === null) : x.equals__O__Z(x1))) {
    var jsx$1 = true
  } else {
    var x$3 = $m_Lamf_core_metamodel_domain_DomainElementModel$().Sources$1;
    if (((x$3 === null) ? (x1 === null) : x$3.equals__O__Z(x1))) {
      var jsx$1 = true
    } else {
      var x$5 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().Target$1;
      var jsx$1 = ((x$5 === null) ? (x1 === null) : x$5.equals__O__Z(x1))
    }
  };
  return (!jsx$1)
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.mergeByValue__p1__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_metamodel_Type__Lamf_core_parser_Value__Lamf_core_parser_Value__V = (function(target, field, element, main, other) {
  var m = $as_Lamf_core_model_domain_AmfArray(main.value$1);
  var o = $as_Lamf_core_model_domain_AmfArray(other.value$1);
  if ((element instanceof $c_Lamf_core_metamodel_Type$Scalar)) {
    this.mergeByValue__p1__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfArray__Lamf_core_model_domain_AmfArray__V(target, field, m, o)
  } else if ($is_Lamf_core_metamodel_domain_templates_KeyField(element)) {
    var x3 = $as_Lamf_core_metamodel_domain_templates_KeyField(element);
    this.mergeByKeyValue__p1__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_metamodel_Type__Lamf_core_metamodel_domain_templates_KeyField__Lamf_core_model_domain_AmfArray__Lamf_core_model_domain_AmfArray__V(target, field, element, x3, m, o)
  } else {
    var x = $m_Lamf_core_metamodel_domain_DataNodeModel$();
    if ((x === element)) {
      this.mergeDataNodes__p1__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfArray__Lamf_core_model_domain_AmfArray__V(target, field, m, o)
    } else {
      var this$1 = this.ctx$1.eh$1;
      var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
      var node = target.id__T();
      var message = (("Cannot merge '" + element) + "': not a KeyField nor a Scalar");
      var annotations = target.annotations__Lamf_core_parser_Annotations();
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$1, specification, node, message, annotations)
    }
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.isOptional__p1__Lamf_core_metamodel_Type__Lamf_core_model_domain_DomainElement__Z = (function(type, obj) {
  if ($is_Lamf_core_metamodel_domain_templates_OptionalField(type)) {
    var this$1 = obj.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($as_Lamf_core_metamodel_domain_templates_OptionalField(type).Optional__Lamf_core_metamodel_Field());
    if ((!this$1.isEmpty__Z())) {
      var arg1 = this$1.get__O();
      var x$7 = $as_Lamf_core_parser_FieldEntry(arg1);
      return $as_Lamf_core_model_domain_AmfScalar(x$7.value$1.value$1).toBool__Z()
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.adoptElementByType__p1__Lamf_core_model_domain_DomainElement__T__Lamf_core_model_domain_DomainElement = (function(target, parentId) {
  if ((target instanceof $c_Lamf_core_model_domain_Shape)) {
    var x2 = $as_Lamf_core_model_domain_Shape(target);
    return $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(x2, parentId))
  } else if ((target instanceof $c_Lamf_core_model_domain_DataNode)) {
    var x3 = $as_Lamf_core_model_domain_DataNode(target);
    return $m_Lamf_core_model_domain_DataNodeOps$().adoptTree__T__Lamf_core_model_domain_DataNode__Lamf_core_model_domain_DataNode(parentId, x3)
  } else {
    return $as_Lamf_core_model_domain_DomainElement(target.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(parentId, target.adopted$default$2__sc_Seq()))
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.merge__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement = (function(main, other) {
  $m_Lamf_plugins_domain_webapi_resolution_stages_MergingValidator$().validate__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_errorhandling_ErrorHandler__V(main, other, this.ctx$1.eh$1);
  var merged = new $c_sr_BooleanRef().init___Z(false);
  var this$2 = other.fields__Lamf_core_parser_Fields();
  var this$5 = this$2.fs$1;
  var this$3 = $m_Lamf_core_parser_FieldEntry$();
  var f = $f_F2__tupled__F1(this$3);
  var this$4 = $m_sci_Iterable$();
  var bf = this$4.ReusableCBFInstance$2;
  $as_sc_IterableLike($as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$5, f, bf)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(entry$2) {
      var entry = $as_Lamf_core_parser_FieldEntry(entry$2);
      return $this.isNotIgnored__p1__Lamf_core_parser_FieldEntry__Z(entry)
    })
  })(this)))).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, main$1, merged$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_parser_FieldEntry(x0$1$2);
      if ((x0$1 !== null)) {
        var otherField = x0$1.field$1;
        var x1$2 = main$1.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option(otherField);
        var x = $m_s_None$();
        if ((x === x1$2)) {
          this$2$1.handleNewFieldEntry__Lamf_core_model_domain_DomainElement__Lamf_core_parser_FieldEntry__Lamf_core_errorhandling_ErrorHandler__V(main$1, x0$1, this$2$1.ctx$1.eh$1)
        } else {
          if ((!(x1$2 instanceof $c_s_Some))) {
            throw new $c_s_MatchError().init___O(x1$2)
          };
          var x2 = $as_s_Some(x1$2);
          var mainFieldEntry = $as_Lamf_core_parser_FieldEntry(x2.value$2);
          merged$1.elem$1 = this$2$1.handleExistingFieldEntries__Lamf_core_model_domain_DomainElement__Lamf_core_parser_FieldEntry__Lamf_core_parser_FieldEntry__Lamf_core_errorhandling_ErrorHandler__Z(main$1, mainFieldEntry, x0$1, this$2$1.ctx$1.eh$1)
        }
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, main, merged)));
  return main
});
function $as_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.resolution.stages.DomainElementMerging"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.resolution.stages.DomainElementMerging;", depth))
}
var $d_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.DomainElementMerging", {
  Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted() {
  $c_O.call(this);
  this.adopted$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted.prototype.productPrefix__T = (function() {
  return "Adopted"
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted.prototype.equals__O__Z = (function(x$1) {
  return (((x$1 instanceof $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted) && ($as_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted(x$1).$$outer$1 === this.$$outer$1)) && ($as_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted(x$1), true))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted.prototype.notYet__T__Z = (function(id) {
  return (!this.adopted$1.contains__O__Z(id))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted.prototype.$$plus$eq__T__Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted = (function(id) {
  this.adopted$1.add__O__Z(id);
  return this
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted.prototype.init___Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.adopted$1 = $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  return this
});
function $as_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.resolution.stages.DomainElementMerging$Adopted"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.resolution.stages.DomainElementMerging$Adopted;", depth))
}
var $d_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.DomainElementMerging$Adopted", {
  Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$Adopted;
/** @constructor */
function $c_Ljava_io_FilterOutputStream() {
  $c_Ljava_io_OutputStream.call(this);
  this.out$2 = null
}
$c_Ljava_io_FilterOutputStream.prototype = new $h_Ljava_io_OutputStream();
$c_Ljava_io_FilterOutputStream.prototype.constructor = $c_Ljava_io_FilterOutputStream;
/** @constructor */
function $h_Ljava_io_FilterOutputStream() {
  /*<skip>*/
}
$h_Ljava_io_FilterOutputStream.prototype = $c_Ljava_io_FilterOutputStream.prototype;
$c_Ljava_io_FilterOutputStream.prototype.init___Ljava_io_OutputStream = (function(out) {
  this.out$2 = out;
  return this
});
/** @constructor */
function $c_Ljava_io_Writer() {
  $c_O.call(this);
  this.lock$1 = null
}
$c_Ljava_io_Writer.prototype = new $h_O();
$c_Ljava_io_Writer.prototype.constructor = $c_Ljava_io_Writer;
/** @constructor */
function $h_Ljava_io_Writer() {
  /*<skip>*/
}
$h_Ljava_io_Writer.prototype = $c_Ljava_io_Writer.prototype;
$c_Ljava_io_Writer.prototype.init___s_Option = (function(_lock) {
  this.lock$1 = (_lock.isEmpty__Z() ? this : _lock.get__O());
  return this
});
function $as_Ljava_io_Writer(obj) {
  return (((obj instanceof $c_Ljava_io_Writer) || (obj === null)) ? obj : $throwClassCastException(obj, "java.io.Writer"))
}
function $isArrayOf_Ljava_io_Writer(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Ljava_io_Writer)))
}
function $asArrayOf_Ljava_io_Writer(obj, depth) {
  return (($isArrayOf_Ljava_io_Writer(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.io.Writer;", depth))
}
/** @constructor */
function $c_Ljava_nio_BufferOverflowException() {
  $c_jl_RuntimeException.call(this)
}
$c_Ljava_nio_BufferOverflowException.prototype = new $h_jl_RuntimeException();
$c_Ljava_nio_BufferOverflowException.prototype.constructor = $c_Ljava_nio_BufferOverflowException;
/** @constructor */
function $h_Ljava_nio_BufferOverflowException() {
  /*<skip>*/
}
$h_Ljava_nio_BufferOverflowException.prototype = $c_Ljava_nio_BufferOverflowException.prototype;
$c_Ljava_nio_BufferOverflowException.prototype.init___ = (function() {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
function $as_Ljava_nio_BufferOverflowException(obj) {
  return (((obj instanceof $c_Ljava_nio_BufferOverflowException) || (obj === null)) ? obj : $throwClassCastException(obj, "java.nio.BufferOverflowException"))
}
function $isArrayOf_Ljava_nio_BufferOverflowException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Ljava_nio_BufferOverflowException)))
}
function $asArrayOf_Ljava_nio_BufferOverflowException(obj, depth) {
  return (($isArrayOf_Ljava_nio_BufferOverflowException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.nio.BufferOverflowException;", depth))
}
var $d_Ljava_nio_BufferOverflowException = new $TypeData().initClass({
  Ljava_nio_BufferOverflowException: 0
}, false, "java.nio.BufferOverflowException", {
  Ljava_nio_BufferOverflowException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_Ljava_nio_BufferOverflowException.prototype.$classData = $d_Ljava_nio_BufferOverflowException;
/** @constructor */
function $c_Ljava_nio_BufferUnderflowException() {
  $c_jl_RuntimeException.call(this)
}
$c_Ljava_nio_BufferUnderflowException.prototype = new $h_jl_RuntimeException();
$c_Ljava_nio_BufferUnderflowException.prototype.constructor = $c_Ljava_nio_BufferUnderflowException;
/** @constructor */
function $h_Ljava_nio_BufferUnderflowException() {
  /*<skip>*/
}
$h_Ljava_nio_BufferUnderflowException.prototype = $c_Ljava_nio_BufferUnderflowException.prototype;
$c_Ljava_nio_BufferUnderflowException.prototype.init___ = (function() {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
function $as_Ljava_nio_BufferUnderflowException(obj) {
  return (((obj instanceof $c_Ljava_nio_BufferUnderflowException) || (obj === null)) ? obj : $throwClassCastException(obj, "java.nio.BufferUnderflowException"))
}
function $isArrayOf_Ljava_nio_BufferUnderflowException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Ljava_nio_BufferUnderflowException)))
}
function $asArrayOf_Ljava_nio_BufferUnderflowException(obj, depth) {
  return (($isArrayOf_Ljava_nio_BufferUnderflowException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.nio.BufferUnderflowException;", depth))
}
var $d_Ljava_nio_BufferUnderflowException = new $TypeData().initClass({
  Ljava_nio_BufferUnderflowException: 0
}, false, "java.nio.BufferUnderflowException", {
  Ljava_nio_BufferUnderflowException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_Ljava_nio_BufferUnderflowException.prototype.$classData = $d_Ljava_nio_BufferUnderflowException;
/** @constructor */
function $c_Ljava_nio_charset_CharacterCodingException() {
  $c_Ljava_io_IOException.call(this)
}
$c_Ljava_nio_charset_CharacterCodingException.prototype = new $h_Ljava_io_IOException();
$c_Ljava_nio_charset_CharacterCodingException.prototype.constructor = $c_Ljava_nio_charset_CharacterCodingException;
/** @constructor */
function $h_Ljava_nio_charset_CharacterCodingException() {
  /*<skip>*/
}
$h_Ljava_nio_charset_CharacterCodingException.prototype = $c_Ljava_nio_charset_CharacterCodingException.prototype;
/** @constructor */
function $c_Lorg_mulesoft_common_io_JsAsyncFile() {
  $c_Lorg_mulesoft_common_io_JsBaseFile.call(this)
}
$c_Lorg_mulesoft_common_io_JsAsyncFile.prototype = new $h_Lorg_mulesoft_common_io_JsBaseFile();
$c_Lorg_mulesoft_common_io_JsAsyncFile.prototype.constructor = $c_Lorg_mulesoft_common_io_JsAsyncFile;
/** @constructor */
function $h_Lorg_mulesoft_common_io_JsAsyncFile() {
  /*<skip>*/
}
$h_Lorg_mulesoft_common_io_JsAsyncFile.prototype = $c_Lorg_mulesoft_common_io_JsAsyncFile.prototype;
$c_Lorg_mulesoft_common_io_JsAsyncFile.prototype.org$mulesoft$common$io$JsAsyncFile$$$anonfun$write$1__Lorg_mulesoft_common_js_SysError__s_concurrent_Promise__O = (function(x$3, promise$5) {
  if ((x$3 === null)) {
    return $f_s_concurrent_Promise__success__O__s_concurrent_Promise(promise$5, (void 0))
  } else {
    var cause = new $c_Ljava_io_IOException().init___T($as_T(x$3.message));
    return $f_s_concurrent_Promise__failure__jl_Throwable__s_concurrent_Promise(promise$5, cause)
  }
});
$c_Lorg_mulesoft_common_io_JsAsyncFile.prototype.init___Lorg_mulesoft_common_io_JsServerFileSystem__T = (function(fs, path) {
  $c_Lorg_mulesoft_common_io_JsBaseFile.prototype.init___Lorg_mulesoft_common_io_JsServerFileSystem__T.call(this, fs, path);
  return this
});
$c_Lorg_mulesoft_common_io_JsAsyncFile.prototype.org$mulesoft$common$io$JsAsyncFile$$$anonfun$read$1__Lorg_mulesoft_common_js_SysError__O__s_concurrent_Promise__O = (function(err, data, promise$4) {
  if ((err === null)) {
    var value = $as_T(data);
    return $f_s_concurrent_Promise__success__O__s_concurrent_Promise(promise$4, value)
  } else {
    var cause = new $c_Ljava_io_IOException().init___T($as_T(err.message));
    return $f_s_concurrent_Promise__failure__jl_Throwable__s_concurrent_Promise(promise$4, cause)
  }
});
$c_Lorg_mulesoft_common_io_JsAsyncFile.prototype.read__T__s_concurrent_ExecutionContext__s_concurrent_Future = (function(encoding, ctx) {
  var promise = new $c_s_concurrent_impl_Promise$DefaultPromise().init___();
  $i_fs.readFile(this.path$1, encoding, (function(arg$outer, promise$4) {
    return (function(arg1$2, arg2$2) {
      return arg$outer.org$mulesoft$common$io$JsAsyncFile$$$anonfun$read$1__Lorg_mulesoft_common_js_SysError__O__s_concurrent_Promise__O(arg1$2, arg2$2, promise$4)
    })
  })(this, promise));
  return promise
});
$c_Lorg_mulesoft_common_io_JsAsyncFile.prototype.write__jl_CharSequence__T__s_concurrent_ExecutionContext__s_concurrent_Future = (function(data, encoding, ctx) {
  var promise = new $c_s_concurrent_impl_Promise$DefaultPromise().init___();
  $i_fs.writeFile(this.path$1, $objectToString(data), encoding, (function(arg$outer, promise$5) {
    return (function(arg1$2) {
      return arg$outer.org$mulesoft$common$io$JsAsyncFile$$$anonfun$write$1__Lorg_mulesoft_common_js_SysError__s_concurrent_Promise__O(arg1$2, promise$5)
    })
  })(this, promise));
  return promise
});
var $d_Lorg_mulesoft_common_io_JsAsyncFile = new $TypeData().initClass({
  Lorg_mulesoft_common_io_JsAsyncFile: 0
}, false, "org.mulesoft.common.io.JsAsyncFile", {
  Lorg_mulesoft_common_io_JsAsyncFile: 1,
  Lorg_mulesoft_common_io_JsBaseFile: 1,
  O: 1,
  Lorg_mulesoft_common_io_File: 1,
  Lorg_mulesoft_common_io_AsyncFile: 1,
  Lorg_mulesoft_common_io_FileProto: 1
});
$c_Lorg_mulesoft_common_io_JsAsyncFile.prototype.$classData = $d_Lorg_mulesoft_common_io_JsAsyncFile;
/** @constructor */
function $c_Lorg_mulesoft_common_io_LimitedStringBuffer() {
  $c_O.call(this);
  this.limit$1 = 0;
  this.buf$1 = null
}
$c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype = new $h_O();
$c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype.constructor = $c_Lorg_mulesoft_common_io_LimitedStringBuffer;
/** @constructor */
function $h_Lorg_mulesoft_common_io_LimitedStringBuffer() {
  /*<skip>*/
}
$h_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype = $c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype;
$c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype.productPrefix__T = (function() {
  return "LimitedStringBuffer"
});
$c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype.productArity__I = (function() {
  return 1
});
$c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lorg_mulesoft_common_io_LimitedStringBuffer)) {
    var LimitedStringBuffer$1 = $as_Lorg_mulesoft_common_io_LimitedStringBuffer(x$1);
    return (this.limit$1 === LimitedStringBuffer$1.limit$1)
  } else {
    return false
  }
});
$c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype.$$js$exported$meth$toString__O = (function() {
  return this.buf$1.toString__T()
});
$c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.limit$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype.$$js$exported$prop$limit__O = (function() {
  return this.limit$1
});
$c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype.$$js$exported$prop$length__O = (function() {
  return this.buf$1.length__I()
});
$c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype.toString__T = (function() {
  return this.buf$1.toString__T()
});
$c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype.init___I = (function(limit) {
  this.limit$1 = limit;
  this.buf$1 = new $c_jl_StringBuffer().init___();
  return this
});
$c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype.$$js$exported$meth$append__jl_CharSequence__O = (function(s) {
  return this.append__jl_CharSequence__Lorg_mulesoft_common_io_LimitedStringBuffer(s)
});
$c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype.append__jl_CharSequence__Lorg_mulesoft_common_io_LimitedStringBuffer = (function(s) {
  if (((($charSequenceLength(s) + this.buf$1.length__I()) | 0) > this.limit$1)) {
    throw new $c_Lorg_mulesoft_common_io_LimitReachedException().init___()
  };
  this.buf$1.append__jl_CharSequence__jl_StringBuffer(s);
  return this
});
$c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.limit$1);
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 1)
});
$c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype.append = (function(arg) {
  var prep = $as_jl_CharSequence(arg);
  return this.$$js$exported$meth$append__jl_CharSequence__O(prep)
});
$c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype.toString = (function() {
  return this.$$js$exported$meth$toString__O()
});
Object.defineProperty($c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype, "length", {
  "get": (function() {
    return this.$$js$exported$prop$length__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype, "limit", {
  "get": (function() {
    return this.$$js$exported$prop$limit__O()
  }),
  "configurable": true
});
function $as_Lorg_mulesoft_common_io_LimitedStringBuffer(obj) {
  return (((obj instanceof $c_Lorg_mulesoft_common_io_LimitedStringBuffer) || (obj === null)) ? obj : $throwClassCastException(obj, "org.mulesoft.common.io.LimitedStringBuffer"))
}
function $isArrayOf_Lorg_mulesoft_common_io_LimitedStringBuffer(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_mulesoft_common_io_LimitedStringBuffer)))
}
function $asArrayOf_Lorg_mulesoft_common_io_LimitedStringBuffer(obj, depth) {
  return (($isArrayOf_Lorg_mulesoft_common_io_LimitedStringBuffer(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.mulesoft.common.io.LimitedStringBuffer;", depth))
}
var $d_Lorg_mulesoft_common_io_LimitedStringBuffer = new $TypeData().initClass({
  Lorg_mulesoft_common_io_LimitedStringBuffer: 0
}, false, "org.mulesoft.common.io.LimitedStringBuffer", {
  Lorg_mulesoft_common_io_LimitedStringBuffer: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype.$classData = $d_Lorg_mulesoft_common_io_LimitedStringBuffer;
/** @constructor */
function $c_Lorg_mulesoft_common_time_SimpleDateTime() {
  $c_O.call(this);
  this.year$1 = 0;
  this.month$1 = 0;
  this.day$1 = 0;
  this.timeOfDay$1 = null;
  this.zoneOffset$1 = null
}
$c_Lorg_mulesoft_common_time_SimpleDateTime.prototype = new $h_O();
$c_Lorg_mulesoft_common_time_SimpleDateTime.prototype.constructor = $c_Lorg_mulesoft_common_time_SimpleDateTime;
/** @constructor */
function $h_Lorg_mulesoft_common_time_SimpleDateTime() {
  /*<skip>*/
}
$h_Lorg_mulesoft_common_time_SimpleDateTime.prototype = $c_Lorg_mulesoft_common_time_SimpleDateTime.prototype;
$c_Lorg_mulesoft_common_time_SimpleDateTime.prototype.productPrefix__T = (function() {
  return "SimpleDateTime"
});
$c_Lorg_mulesoft_common_time_SimpleDateTime.prototype.productArity__I = (function() {
  return 5
});
$c_Lorg_mulesoft_common_time_SimpleDateTime.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lorg_mulesoft_common_time_SimpleDateTime)) {
    var SimpleDateTime$1 = $as_Lorg_mulesoft_common_time_SimpleDateTime(x$1);
    if ((((this.year$1 === SimpleDateTime$1.year$1) && (this.month$1 === SimpleDateTime$1.month$1)) && (this.day$1 === SimpleDateTime$1.day$1))) {
      var x = this.timeOfDay$1;
      var x$2 = SimpleDateTime$1.timeOfDay$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.zoneOffset$1;
      var x$4 = SimpleDateTime$1.zoneOffset$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lorg_mulesoft_common_time_SimpleDateTime.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.year$1;
      break
    }
    case 1: {
      return this.month$1;
      break
    }
    case 2: {
      return this.day$1;
      break
    }
    case 3: {
      return this.timeOfDay$1;
      break
    }
    case 4: {
      return this.zoneOffset$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lorg_mulesoft_common_time_SimpleDateTime.prototype.toString__T = (function() {
  var arg$macro$1 = this.year$1;
  var arg$macro$2 = this.month$1;
  var arg$macro$3 = this.day$1;
  var this$3 = new $c_sci_StringOps().init___T("%04d-%02d-%02d");
  var array = [arg$macro$1, arg$macro$2, arg$macro$3];
  var jsx$2 = $m_sjsr_RuntimeString$();
  var $$this = this$3.repr$1;
  $m_sc_Seq$();
  $m_sjs_js_WrappedArray$();
  var array$1 = [];
  var x1 = $uI(array.length);
  switch (x1) {
    case (-1): {
      break
    }
  };
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    var elem = $f_sci_StringLike__unwrapArg__psci_StringLike__O__O(this$3, arg1);
    array$1.push(elem);
    i = ((1 + i) | 0)
  };
  $m_s_reflect_ManifestFactory$ObjectManifest$();
  var len$1 = $uI(array$1.length);
  var result = $newArrayObject($d_O.getArrayOf(), [len$1]);
  var len$2 = result.u.length;
  var i$1 = 0;
  var j = 0;
  var x = $uI(array$1.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = result.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i$1 < end)) {
    var jsx$1 = j;
    var index$1 = i$1;
    result.set(jsx$1, array$1[index$1]);
    i$1 = ((1 + i$1) | 0);
    j = ((1 + j) | 0)
  };
  var date = jsx$2.format__T__AO__T($$this, result);
  var this$17 = this.timeOfDay$1;
  if (this$17.isEmpty__Z()) {
    var this$18 = $m_s_None$()
  } else {
    var arg1$1 = this$17.get__O();
    var x$1$1 = $as_Lorg_mulesoft_common_time_TimeOfDay(arg1$1);
    var this$18 = new $c_s_Some().init___O(("T" + x$1$1.toString__T()))
  };
  var time = $as_T((this$18.isEmpty__Z() ? "" : this$18.get__O()));
  var this$19 = this.zoneOffset$1;
  if (this$19.isEmpty__Z()) {
    var this$20 = $m_s_None$()
  } else {
    var arg1$2 = this$19.get__O();
    var zoneOffset = $uI(arg1$2);
    var this$20 = new $c_s_Some().init___O($m_Lorg_mulesoft_common_time_SimpleDateTime$().org$mulesoft$common$time$SimpleDateTime$$zoneOffsetToString__I__T(zoneOffset))
  };
  var zone = $as_T((this$20.isEmpty__Z() ? "" : this$20.get__O()));
  return ((("" + date) + time) + zone)
});
$c_Lorg_mulesoft_common_time_SimpleDateTime.prototype.init___I__I__I__s_Option__s_Option = (function(year, month, day, timeOfDay, zoneOffset) {
  this.year$1 = year;
  this.month$1 = month;
  this.day$1 = day;
  this.timeOfDay$1 = timeOfDay;
  this.zoneOffset$1 = zoneOffset;
  $m_Lorg_mulesoft_common_time_SimpleDateTime$().org$mulesoft$common$time$SimpleDateTime$$validateDate__I__I__I__V(year, month, day);
  return this
});
$c_Lorg_mulesoft_common_time_SimpleDateTime.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.year$1);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.month$1);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.day$1);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.timeOfDay$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.zoneOffset$1));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 5)
});
$c_Lorg_mulesoft_common_time_SimpleDateTime.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lorg_mulesoft_common_time_SimpleDateTime(obj) {
  return (((obj instanceof $c_Lorg_mulesoft_common_time_SimpleDateTime) || (obj === null)) ? obj : $throwClassCastException(obj, "org.mulesoft.common.time.SimpleDateTime"))
}
function $isArrayOf_Lorg_mulesoft_common_time_SimpleDateTime(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_mulesoft_common_time_SimpleDateTime)))
}
function $asArrayOf_Lorg_mulesoft_common_time_SimpleDateTime(obj, depth) {
  return (($isArrayOf_Lorg_mulesoft_common_time_SimpleDateTime(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.mulesoft.common.time.SimpleDateTime;", depth))
}
var $d_Lorg_mulesoft_common_time_SimpleDateTime = new $TypeData().initClass({
  Lorg_mulesoft_common_time_SimpleDateTime: 0
}, false, "org.mulesoft.common.time.SimpleDateTime", {
  Lorg_mulesoft_common_time_SimpleDateTime: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_mulesoft_common_time_SimpleDateTime.prototype.$classData = $d_Lorg_mulesoft_common_time_SimpleDateTime;
/** @constructor */
function $c_Lorg_mulesoft_common_time_TimeOfDay() {
  $c_O.call(this);
  this.hour$1 = 0;
  this.minute$1 = 0;
  this.second$1 = 0;
  this.nano$1 = 0
}
$c_Lorg_mulesoft_common_time_TimeOfDay.prototype = new $h_O();
$c_Lorg_mulesoft_common_time_TimeOfDay.prototype.constructor = $c_Lorg_mulesoft_common_time_TimeOfDay;
/** @constructor */
function $h_Lorg_mulesoft_common_time_TimeOfDay() {
  /*<skip>*/
}
$h_Lorg_mulesoft_common_time_TimeOfDay.prototype = $c_Lorg_mulesoft_common_time_TimeOfDay.prototype;
$c_Lorg_mulesoft_common_time_TimeOfDay.prototype.productPrefix__T = (function() {
  return "TimeOfDay"
});
$c_Lorg_mulesoft_common_time_TimeOfDay.prototype.productArity__I = (function() {
  return 4
});
$c_Lorg_mulesoft_common_time_TimeOfDay.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lorg_mulesoft_common_time_TimeOfDay)) {
    var TimeOfDay$1 = $as_Lorg_mulesoft_common_time_TimeOfDay(x$1);
    return ((((this.hour$1 === TimeOfDay$1.hour$1) && (this.minute$1 === TimeOfDay$1.minute$1)) && (this.second$1 === TimeOfDay$1.second$1)) && (this.nano$1 === TimeOfDay$1.nano$1))
  } else {
    return false
  }
});
$c_Lorg_mulesoft_common_time_TimeOfDay.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.hour$1;
      break
    }
    case 1: {
      return this.minute$1;
      break
    }
    case 2: {
      return this.second$1;
      break
    }
    case 3: {
      return this.nano$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lorg_mulesoft_common_time_TimeOfDay.prototype.toString__T = (function() {
  var arg$macro$1 = this.hour$1;
  var arg$macro$2 = this.minute$1;
  var arg$macro$3 = this.second$1;
  var this$3 = new $c_sci_StringOps().init___T("%02d:%02d:%02d");
  var array = [arg$macro$1, arg$macro$2, arg$macro$3];
  var jsx$2 = $m_sjsr_RuntimeString$();
  var $$this = this$3.repr$1;
  $m_sc_Seq$();
  $m_sjs_js_WrappedArray$();
  var array$1 = [];
  var x1 = $uI(array.length);
  switch (x1) {
    case (-1): {
      break
    }
  };
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    var elem = $f_sci_StringLike__unwrapArg__psci_StringLike__O__O(this$3, arg1);
    array$1.push(elem);
    i = ((1 + i) | 0)
  };
  $m_s_reflect_ManifestFactory$ObjectManifest$();
  var len$1 = $uI(array$1.length);
  var result = $newArrayObject($d_O.getArrayOf(), [len$1]);
  var len$2 = result.u.length;
  var i$1 = 0;
  var j = 0;
  var x = $uI(array$1.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = result.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i$1 < end)) {
    var jsx$1 = j;
    var index$1 = i$1;
    result.set(jsx$1, array$1[index$1]);
    i$1 = ((1 + i$1) | 0);
    j = ((1 + j) | 0)
  };
  var intPart = jsx$2.format__T__AO__T($$this, result);
  var x$2 = (this.nano$1 / 1000000.0);
  var this$21 = $m_sjsr_RuntimeLong$();
  var value = $uD($g.Math.round(x$2));
  var lo = this$21.scala$scalajs$runtime$RuntimeLong$$fromDoubleImpl__D__I(value);
  if ((lo === 0)) {
    return intPart
  } else {
    if ((((lo % 100) | 0) === 0)) {
      var this$22 = ((lo / 100) | 0);
      var m = ("" + this$22)
    } else if ((((lo % 10) | 0) === 0)) {
      var arg$macro$4 = ((lo / 10) | 0);
      var this$26 = new $c_sci_StringOps().init___T("%02d");
      var array$2 = [arg$macro$4];
      var jsx$4 = $m_sjsr_RuntimeString$();
      var $$this$1 = this$26.repr$1;
      $m_sc_Seq$();
      $m_sjs_js_WrappedArray$();
      var array$3 = [];
      var x1$1 = $uI(array$2.length);
      switch (x1$1) {
        case (-1): {
          break
        }
      };
      var i$2 = 0;
      var len$3 = $uI(array$2.length);
      while ((i$2 < len$3)) {
        var index$2 = i$2;
        var arg1$1 = array$2[index$2];
        var elem$1 = $f_sci_StringLike__unwrapArg__psci_StringLike__O__O(this$26, arg1$1);
        array$3.push(elem$1);
        i$2 = ((1 + i$2) | 0)
      };
      $m_s_reflect_ManifestFactory$ObjectManifest$();
      var len$4 = $uI(array$3.length);
      var result$1 = $newArrayObject($d_O.getArrayOf(), [len$4]);
      var len$5 = result$1.u.length;
      var i$3 = 0;
      var j$1 = 0;
      var x$3 = $uI(array$3.length);
      var x$4 = ((x$3 < len$5) ? x$3 : len$5);
      var that$1 = result$1.u.length;
      var end$1 = ((x$4 < that$1) ? x$4 : that$1);
      while ((i$3 < end$1)) {
        var jsx$3 = j$1;
        var index$3 = i$3;
        result$1.set(jsx$3, array$3[index$3]);
        i$3 = ((1 + i$3) | 0);
        j$1 = ((1 + j$1) | 0)
      };
      var m = jsx$4.format__T__AO__T($$this$1, result$1)
    } else {
      var this$42 = new $c_sci_StringOps().init___T("%03d");
      var array$4 = [lo];
      var jsx$6 = $m_sjsr_RuntimeString$();
      var $$this$2 = this$42.repr$1;
      $m_sc_Seq$();
      $m_sjs_js_WrappedArray$();
      var array$5 = [];
      var x1$2 = $uI(array$4.length);
      switch (x1$2) {
        case (-1): {
          break
        }
      };
      var i$4 = 0;
      var len$6 = $uI(array$4.length);
      while ((i$4 < len$6)) {
        var index$4 = i$4;
        var arg1$2 = array$4[index$4];
        var elem$2 = $f_sci_StringLike__unwrapArg__psci_StringLike__O__O(this$42, arg1$2);
        array$5.push(elem$2);
        i$4 = ((1 + i$4) | 0)
      };
      $m_s_reflect_ManifestFactory$ObjectManifest$();
      var len$7 = $uI(array$5.length);
      var result$2 = $newArrayObject($d_O.getArrayOf(), [len$7]);
      var len$8 = result$2.u.length;
      var i$5 = 0;
      var j$2 = 0;
      var x$5 = $uI(array$5.length);
      var x$6 = ((x$5 < len$8) ? x$5 : len$8);
      var that$2 = result$2.u.length;
      var end$2 = ((x$6 < that$2) ? x$6 : that$2);
      while ((i$5 < end$2)) {
        var jsx$5 = j$2;
        var index$5 = i$5;
        result$2.set(jsx$5, array$5[index$5]);
        i$5 = ((1 + i$5) | 0);
        j$2 = ((1 + j$2) | 0)
      };
      var m = jsx$6.format__T__AO__T($$this$2, result$2)
    };
    return ((("" + intPart) + new $c_jl_Character().init___C(46)) + m)
  }
});
$c_Lorg_mulesoft_common_time_TimeOfDay.prototype.init___I__I__I__I = (function(hour, minute, second, nano) {
  this.hour$1 = hour;
  this.minute$1 = minute;
  this.second$1 = second;
  this.nano$1 = nano;
  $m_Lorg_mulesoft_common_time_TimeOfDay$().org$mulesoft$common$time$TimeOfDay$$validateTimeOfDay__I__I__I__I__V(hour, minute, second, nano);
  return this
});
$c_Lorg_mulesoft_common_time_TimeOfDay.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.hour$1);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.minute$1);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.second$1);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.nano$1);
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 4)
});
$c_Lorg_mulesoft_common_time_TimeOfDay.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lorg_mulesoft_common_time_TimeOfDay(obj) {
  return (((obj instanceof $c_Lorg_mulesoft_common_time_TimeOfDay) || (obj === null)) ? obj : $throwClassCastException(obj, "org.mulesoft.common.time.TimeOfDay"))
}
function $isArrayOf_Lorg_mulesoft_common_time_TimeOfDay(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_mulesoft_common_time_TimeOfDay)))
}
function $asArrayOf_Lorg_mulesoft_common_time_TimeOfDay(obj, depth) {
  return (($isArrayOf_Lorg_mulesoft_common_time_TimeOfDay(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.mulesoft.common.time.TimeOfDay;", depth))
}
var $d_Lorg_mulesoft_common_time_TimeOfDay = new $TypeData().initClass({
  Lorg_mulesoft_common_time_TimeOfDay: 0
}, false, "org.mulesoft.common.time.TimeOfDay", {
  Lorg_mulesoft_common_time_TimeOfDay: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_mulesoft_common_time_TimeOfDay.prototype.$classData = $d_Lorg_mulesoft_common_time_TimeOfDay;
/** @constructor */
function $c_Lorg_mulesoft_lexer_AstToken() {
  $c_O.call(this);
  this.tokenType$1 = null;
  this.text$1 = null;
  this.range$1 = null
}
$c_Lorg_mulesoft_lexer_AstToken.prototype = new $h_O();
$c_Lorg_mulesoft_lexer_AstToken.prototype.constructor = $c_Lorg_mulesoft_lexer_AstToken;
/** @constructor */
function $h_Lorg_mulesoft_lexer_AstToken() {
  /*<skip>*/
}
$h_Lorg_mulesoft_lexer_AstToken.prototype = $c_Lorg_mulesoft_lexer_AstToken.prototype;
$c_Lorg_mulesoft_lexer_AstToken.prototype.productPrefix__T = (function() {
  return "AstToken"
});
$c_Lorg_mulesoft_lexer_AstToken.prototype.productArity__I = (function() {
  return 3
});
$c_Lorg_mulesoft_lexer_AstToken.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lorg_mulesoft_lexer_AstToken)) {
    var AstToken$1 = $as_Lorg_mulesoft_lexer_AstToken(x$1);
    var x = this.tokenType$1;
    var x$2 = AstToken$1.tokenType$1;
    if (((x === x$2) && (this.text$1 === AstToken$1.text$1))) {
      var x$3 = this.range$1;
      var x$4 = AstToken$1.range$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lorg_mulesoft_lexer_AstToken.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.tokenType$1;
      break
    }
    case 1: {
      return this.text$1;
      break
    }
    case 2: {
      return this.range$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lorg_mulesoft_lexer_AstToken.prototype.toString__T = (function() {
  var jsx$1 = this.tokenType$1;
  var str = this.text$1;
  return (((jsx$1 + " '") + $m_Lorg_mulesoft_common_core_package$Strings$().encode$extension1__T__Z__T(str, true)) + "'")
});
$c_Lorg_mulesoft_lexer_AstToken.prototype.init___Lorg_mulesoft_lexer_Token__T__Lorg_mulesoft_lexer_SourceLocation = (function(tokenType, text, range) {
  this.tokenType$1 = tokenType;
  this.text$1 = text;
  this.range$1 = range;
  return this
});
$c_Lorg_mulesoft_lexer_AstToken.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lorg_mulesoft_lexer_AstToken.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lorg_mulesoft_lexer_AstToken(obj) {
  return (((obj instanceof $c_Lorg_mulesoft_lexer_AstToken) || (obj === null)) ? obj : $throwClassCastException(obj, "org.mulesoft.lexer.AstToken"))
}
function $isArrayOf_Lorg_mulesoft_lexer_AstToken(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_mulesoft_lexer_AstToken)))
}
function $asArrayOf_Lorg_mulesoft_lexer_AstToken(obj, depth) {
  return (($isArrayOf_Lorg_mulesoft_lexer_AstToken(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.mulesoft.lexer.AstToken;", depth))
}
var $d_Lorg_mulesoft_lexer_AstToken = new $TypeData().initClass({
  Lorg_mulesoft_lexer_AstToken: 0
}, false, "org.mulesoft.lexer.AstToken", {
  Lorg_mulesoft_lexer_AstToken: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_mulesoft_lexer_AstToken.prototype.$classData = $d_Lorg_mulesoft_lexer_AstToken;
/** @constructor */
function $c_Lorg_mulesoft_lexer_InputRange() {
  $c_O.call(this);
  this.lineFrom$1 = 0;
  this.columnFrom$1 = 0;
  this.lineTo$1 = 0;
  this.columnTo$1 = 0
}
$c_Lorg_mulesoft_lexer_InputRange.prototype = new $h_O();
$c_Lorg_mulesoft_lexer_InputRange.prototype.constructor = $c_Lorg_mulesoft_lexer_InputRange;
/** @constructor */
function $h_Lorg_mulesoft_lexer_InputRange() {
  /*<skip>*/
}
$h_Lorg_mulesoft_lexer_InputRange.prototype = $c_Lorg_mulesoft_lexer_InputRange.prototype;
$c_Lorg_mulesoft_lexer_InputRange.prototype.productPrefix__T = (function() {
  return "InputRange"
});
$c_Lorg_mulesoft_lexer_InputRange.prototype.productArity__I = (function() {
  return 4
});
$c_Lorg_mulesoft_lexer_InputRange.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lorg_mulesoft_lexer_InputRange)) {
    var InputRange$1 = $as_Lorg_mulesoft_lexer_InputRange(x$1);
    return ((((this.lineFrom$1 === InputRange$1.lineFrom$1) && (this.columnFrom$1 === InputRange$1.columnFrom$1)) && (this.lineTo$1 === InputRange$1.lineTo$1)) && (this.columnTo$1 === InputRange$1.columnTo$1))
  } else {
    return false
  }
});
$c_Lorg_mulesoft_lexer_InputRange.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.lineFrom$1;
      break
    }
    case 1: {
      return this.columnFrom$1;
      break
    }
    case 2: {
      return this.lineTo$1;
      break
    }
    case 3: {
      return this.columnTo$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lorg_mulesoft_lexer_InputRange.prototype.toString__T = (function() {
  return (((((((("[" + this.lineFrom$1) + ",") + this.columnFrom$1) + "..") + this.lineTo$1) + ",") + this.columnTo$1) + "]")
});
$c_Lorg_mulesoft_lexer_InputRange.prototype.init___I__I__I__I = (function(lineFrom, columnFrom, lineTo, columnTo) {
  this.lineFrom$1 = lineFrom;
  this.columnFrom$1 = columnFrom;
  this.lineTo$1 = lineTo;
  this.columnTo$1 = columnTo;
  return this
});
$c_Lorg_mulesoft_lexer_InputRange.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.lineFrom$1);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.columnFrom$1);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.lineTo$1);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.columnTo$1);
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 4)
});
$c_Lorg_mulesoft_lexer_InputRange.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lorg_mulesoft_lexer_InputRange(obj) {
  return (((obj instanceof $c_Lorg_mulesoft_lexer_InputRange) || (obj === null)) ? obj : $throwClassCastException(obj, "org.mulesoft.lexer.InputRange"))
}
function $isArrayOf_Lorg_mulesoft_lexer_InputRange(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_mulesoft_lexer_InputRange)))
}
function $asArrayOf_Lorg_mulesoft_lexer_InputRange(obj, depth) {
  return (($isArrayOf_Lorg_mulesoft_lexer_InputRange(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.mulesoft.lexer.InputRange;", depth))
}
var $d_Lorg_mulesoft_lexer_InputRange = new $TypeData().initClass({
  Lorg_mulesoft_lexer_InputRange: 0
}, false, "org.mulesoft.lexer.InputRange", {
  Lorg_mulesoft_lexer_InputRange: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_mulesoft_lexer_InputRange.prototype.$classData = $d_Lorg_mulesoft_lexer_InputRange;
/** @constructor */
function $c_Lorg_mulesoft_lexer_TokenData() {
  $c_O.call(this);
  this.token$1 = null;
  this.range$1 = null
}
$c_Lorg_mulesoft_lexer_TokenData.prototype = new $h_O();
$c_Lorg_mulesoft_lexer_TokenData.prototype.constructor = $c_Lorg_mulesoft_lexer_TokenData;
/** @constructor */
function $h_Lorg_mulesoft_lexer_TokenData() {
  /*<skip>*/
}
$h_Lorg_mulesoft_lexer_TokenData.prototype = $c_Lorg_mulesoft_lexer_TokenData.prototype;
$c_Lorg_mulesoft_lexer_TokenData.prototype.productPrefix__T = (function() {
  return "TokenData"
});
$c_Lorg_mulesoft_lexer_TokenData.prototype.productArity__I = (function() {
  return 2
});
$c_Lorg_mulesoft_lexer_TokenData.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lorg_mulesoft_lexer_TokenData)) {
    var TokenData$1 = $as_Lorg_mulesoft_lexer_TokenData(x$1);
    var x = this.token$1;
    var x$2 = TokenData$1.token$1;
    if ((x === x$2)) {
      var x$3 = this.range$1;
      var x$4 = TokenData$1.range$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lorg_mulesoft_lexer_TokenData.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.token$1;
      break
    }
    case 1: {
      return this.range$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lorg_mulesoft_lexer_TokenData.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lorg_mulesoft_lexer_TokenData.prototype.init___Lorg_mulesoft_lexer_Token__Lorg_mulesoft_lexer_SourceLocation = (function(token, range) {
  this.token$1 = token;
  this.range$1 = range;
  return this
});
$c_Lorg_mulesoft_lexer_TokenData.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lorg_mulesoft_lexer_TokenData.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lorg_mulesoft_lexer_TokenData(obj) {
  return (((obj instanceof $c_Lorg_mulesoft_lexer_TokenData) || (obj === null)) ? obj : $throwClassCastException(obj, "org.mulesoft.lexer.TokenData"))
}
function $isArrayOf_Lorg_mulesoft_lexer_TokenData(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_mulesoft_lexer_TokenData)))
}
function $asArrayOf_Lorg_mulesoft_lexer_TokenData(obj, depth) {
  return (($isArrayOf_Lorg_mulesoft_lexer_TokenData(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.mulesoft.lexer.TokenData;", depth))
}
var $d_Lorg_mulesoft_lexer_TokenData = new $TypeData().initClass({
  Lorg_mulesoft_lexer_TokenData: 0
}, false, "org.mulesoft.lexer.TokenData", {
  Lorg_mulesoft_lexer_TokenData: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_mulesoft_lexer_TokenData.prototype.$classData = $d_Lorg_mulesoft_lexer_TokenData;
/** @constructor */
function $c_Lorg_yaml_builder_DocBuilder$Scalar() {
  $c_O.call(this);
  this.t$1 = null;
  this.value$1 = null
}
$c_Lorg_yaml_builder_DocBuilder$Scalar.prototype = new $h_O();
$c_Lorg_yaml_builder_DocBuilder$Scalar.prototype.constructor = $c_Lorg_yaml_builder_DocBuilder$Scalar;
/** @constructor */
function $h_Lorg_yaml_builder_DocBuilder$Scalar() {
  /*<skip>*/
}
$h_Lorg_yaml_builder_DocBuilder$Scalar.prototype = $c_Lorg_yaml_builder_DocBuilder$Scalar.prototype;
$c_Lorg_yaml_builder_DocBuilder$Scalar.prototype.productPrefix__T = (function() {
  return "Scalar"
});
$c_Lorg_yaml_builder_DocBuilder$Scalar.prototype.productArity__I = (function() {
  return 2
});
$c_Lorg_yaml_builder_DocBuilder$Scalar.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lorg_yaml_builder_DocBuilder$Scalar)) {
    var Scalar$1 = $as_Lorg_yaml_builder_DocBuilder$Scalar(x$1);
    var x = this.t$1;
    var x$2 = Scalar$1.t$1;
    if ((x === x$2)) {
      return $m_sr_BoxesRunTime$().equals__O__O__Z(this.value$1, Scalar$1.value$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_builder_DocBuilder$Scalar.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.t$1;
      break
    }
    case 1: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lorg_yaml_builder_DocBuilder$Scalar.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lorg_yaml_builder_DocBuilder$Scalar.prototype.init___Lorg_yaml_builder_DocBuilder$SType__O = (function(t, value) {
  this.t$1 = t;
  this.value$1 = value;
  return this
});
$c_Lorg_yaml_builder_DocBuilder$Scalar.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lorg_yaml_builder_DocBuilder$Scalar.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lorg_yaml_builder_DocBuilder$Scalar(obj) {
  return (((obj instanceof $c_Lorg_yaml_builder_DocBuilder$Scalar) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.builder.DocBuilder$Scalar"))
}
function $isArrayOf_Lorg_yaml_builder_DocBuilder$Scalar(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_builder_DocBuilder$Scalar)))
}
function $asArrayOf_Lorg_yaml_builder_DocBuilder$Scalar(obj, depth) {
  return (($isArrayOf_Lorg_yaml_builder_DocBuilder$Scalar(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.builder.DocBuilder$Scalar;", depth))
}
var $d_Lorg_yaml_builder_DocBuilder$Scalar = new $TypeData().initClass({
  Lorg_yaml_builder_DocBuilder$Scalar: 0
}, false, "org.yaml.builder.DocBuilder$Scalar", {
  Lorg_yaml_builder_DocBuilder$Scalar: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_builder_DocBuilder$Scalar.prototype.$classData = $d_Lorg_yaml_builder_DocBuilder$Scalar;
/** @constructor */
function $c_Lorg_yaml_model_SyamlException() {
  $c_jl_RuntimeException.call(this)
}
$c_Lorg_yaml_model_SyamlException.prototype = new $h_jl_RuntimeException();
$c_Lorg_yaml_model_SyamlException.prototype.constructor = $c_Lorg_yaml_model_SyamlException;
/** @constructor */
function $h_Lorg_yaml_model_SyamlException() {
  /*<skip>*/
}
$h_Lorg_yaml_model_SyamlException.prototype = $c_Lorg_yaml_model_SyamlException.prototype;
function $as_Lorg_yaml_model_SyamlException(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_SyamlException) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.SyamlException"))
}
function $isArrayOf_Lorg_yaml_model_SyamlException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_SyamlException)))
}
function $asArrayOf_Lorg_yaml_model_SyamlException(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_SyamlException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.SyamlException;", depth))
}
/** @constructor */
function $c_Lorg_yaml_model_YException() {
  $c_jl_RuntimeException.call(this);
  this.yError$4 = null
}
$c_Lorg_yaml_model_YException.prototype = new $h_jl_RuntimeException();
$c_Lorg_yaml_model_YException.prototype.constructor = $c_Lorg_yaml_model_YException;
/** @constructor */
function $h_Lorg_yaml_model_YException() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YException.prototype = $c_Lorg_yaml_model_YException.prototype;
$c_Lorg_yaml_model_YException.prototype.init___Lorg_yaml_model_YError = (function(yError) {
  this.yError$4 = yError;
  var s = yError.error__T();
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
function $as_Lorg_yaml_model_YException(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YException) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YException"))
}
function $isArrayOf_Lorg_yaml_model_YException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YException)))
}
function $asArrayOf_Lorg_yaml_model_YException(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YException;", depth))
}
var $d_Lorg_yaml_model_YException = new $TypeData().initClass({
  Lorg_yaml_model_YException: 0
}, false, "org.yaml.model.YException", {
  Lorg_yaml_model_YException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_model_YException.prototype.$classData = $d_Lorg_yaml_model_YException;
/** @constructor */
function $c_Lorg_yaml_model_YNode$Ref() {
  $c_Lorg_yaml_model_YNode.call(this);
  this.anchor$3 = null
}
$c_Lorg_yaml_model_YNode$Ref.prototype = new $h_Lorg_yaml_model_YNode();
$c_Lorg_yaml_model_YNode$Ref.prototype.constructor = $c_Lorg_yaml_model_YNode$Ref;
/** @constructor */
function $h_Lorg_yaml_model_YNode$Ref() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YNode$Ref.prototype = $c_Lorg_yaml_model_YNode$Ref.prototype;
$c_Lorg_yaml_model_YNode$Ref.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq = (function(location, cs) {
  $c_Lorg_yaml_model_YNode.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq.call(this, location, cs);
  this.anchor$3 = $m_s_None$();
  return this
});
$c_Lorg_yaml_model_YNode$Ref.prototype.anchor__s_Option = (function() {
  return this.anchor$3
});
function $as_Lorg_yaml_model_YNode$Ref(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YNode$Ref) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YNode$Ref"))
}
function $isArrayOf_Lorg_yaml_model_YNode$Ref(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YNode$Ref)))
}
function $asArrayOf_Lorg_yaml_model_YNode$Ref(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YNode$Ref(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YNode$Ref;", depth))
}
/** @constructor */
function $c_Lorg_yaml_model_YNodePlain() {
  $c_Lorg_yaml_model_YNode.call(this);
  this.value$3 = null;
  this.tag$3 = null;
  this.anchor$3 = null
}
$c_Lorg_yaml_model_YNodePlain.prototype = new $h_Lorg_yaml_model_YNode();
$c_Lorg_yaml_model_YNodePlain.prototype.constructor = $c_Lorg_yaml_model_YNodePlain;
/** @constructor */
function $h_Lorg_yaml_model_YNodePlain() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YNodePlain.prototype = $c_Lorg_yaml_model_YNodePlain.prototype;
$c_Lorg_yaml_model_YNodePlain.prototype.init___Lorg_yaml_model_YValue__Lorg_yaml_model_YTag__s_Option__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq = (function(value, tag, anchor, location, parts) {
  this.value$3 = value;
  this.tag$3 = tag;
  this.anchor$3 = anchor;
  $c_Lorg_yaml_model_YNode.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq.call(this, location, parts);
  return this
});
$c_Lorg_yaml_model_YNodePlain.prototype.tag__Lorg_yaml_model_YTag = (function() {
  return this.tag$3
});
$c_Lorg_yaml_model_YNodePlain.prototype.anchor__s_Option = (function() {
  return this.anchor$3
});
$c_Lorg_yaml_model_YNodePlain.prototype.value__Lorg_yaml_model_YValue = (function() {
  return this.value$3
});
var $d_Lorg_yaml_model_YNodePlain = new $TypeData().initClass({
  Lorg_yaml_model_YNodePlain: 0
}, false, "org.yaml.model.YNodePlain", {
  Lorg_yaml_model_YNodePlain: 1,
  Lorg_yaml_model_YNode: 1,
  Lorg_yaml_model_YPart: 1,
  O: 1,
  Lorg_yaml_model_YNodeLike: 1,
  Lorg_yaml_model_YValueLike: 1
});
$c_Lorg_yaml_model_YNodePlain.prototype.$classData = $d_Lorg_yaml_model_YNodePlain;
/** @constructor */
function $c_Lorg_yaml_parser_ParserResult() {
  $c_O.call(this);
  this.tag$1 = null;
  this.value$1 = null
}
$c_Lorg_yaml_parser_ParserResult.prototype = new $h_O();
$c_Lorg_yaml_parser_ParserResult.prototype.constructor = $c_Lorg_yaml_parser_ParserResult;
/** @constructor */
function $h_Lorg_yaml_parser_ParserResult() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_ParserResult.prototype = $c_Lorg_yaml_parser_ParserResult.prototype;
$c_Lorg_yaml_parser_ParserResult.prototype.productPrefix__T = (function() {
  return "ParserResult"
});
$c_Lorg_yaml_parser_ParserResult.prototype.productArity__I = (function() {
  return 2
});
$c_Lorg_yaml_parser_ParserResult.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lorg_yaml_parser_ParserResult)) {
    var ParserResult$1 = $as_Lorg_yaml_parser_ParserResult(x$1);
    var x = this.tag$1;
    var x$2 = ParserResult$1.tag$1;
    if ((x === x$2)) {
      return $m_sr_BoxesRunTime$().equals__O__O__Z(this.value$1, ParserResult$1.value$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_parser_ParserResult.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.tag$1;
      break
    }
    case 1: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lorg_yaml_parser_ParserResult.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lorg_yaml_parser_ParserResult.prototype.init___Lorg_yaml_model_YTag__O = (function(tag, value) {
  this.tag$1 = tag;
  this.value$1 = value;
  return this
});
$c_Lorg_yaml_parser_ParserResult.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lorg_yaml_parser_ParserResult.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lorg_yaml_parser_ParserResult(obj) {
  return (((obj instanceof $c_Lorg_yaml_parser_ParserResult) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.parser.ParserResult"))
}
function $isArrayOf_Lorg_yaml_parser_ParserResult(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_parser_ParserResult)))
}
function $asArrayOf_Lorg_yaml_parser_ParserResult(obj, depth) {
  return (($isArrayOf_Lorg_yaml_parser_ParserResult(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.parser.ParserResult;", depth))
}
var $d_Lorg_yaml_parser_ParserResult = new $TypeData().initClass({
  Lorg_yaml_parser_ParserResult: 0
}, false, "org.yaml.parser.ParserResult", {
  Lorg_yaml_parser_ParserResult: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_parser_ParserResult.prototype.$classData = $d_Lorg_yaml_parser_ParserResult;
/** @constructor */
function $c_jl_ArithmeticException() {
  $c_jl_RuntimeException.call(this)
}
$c_jl_ArithmeticException.prototype = new $h_jl_RuntimeException();
$c_jl_ArithmeticException.prototype.constructor = $c_jl_ArithmeticException;
/** @constructor */
function $h_jl_ArithmeticException() {
  /*<skip>*/
}
$h_jl_ArithmeticException.prototype = $c_jl_ArithmeticException.prototype;
$c_jl_ArithmeticException.prototype.init___T = (function(s) {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
function $as_jl_ArithmeticException(obj) {
  return (((obj instanceof $c_jl_ArithmeticException) || (obj === null)) ? obj : $throwClassCastException(obj, "java.lang.ArithmeticException"))
}
function $isArrayOf_jl_ArithmeticException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_ArithmeticException)))
}
function $asArrayOf_jl_ArithmeticException(obj, depth) {
  return (($isArrayOf_jl_ArithmeticException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.ArithmeticException;", depth))
}
var $d_jl_ArithmeticException = new $TypeData().initClass({
  jl_ArithmeticException: 0
}, false, "java.lang.ArithmeticException", {
  jl_ArithmeticException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_jl_ArithmeticException.prototype.$classData = $d_jl_ArithmeticException;
/** @constructor */
function $c_jl_ClassCastException() {
  $c_jl_RuntimeException.call(this)
}
$c_jl_ClassCastException.prototype = new $h_jl_RuntimeException();
$c_jl_ClassCastException.prototype.constructor = $c_jl_ClassCastException;
/** @constructor */
function $h_jl_ClassCastException() {
  /*<skip>*/
}
$h_jl_ClassCastException.prototype = $c_jl_ClassCastException.prototype;
$c_jl_ClassCastException.prototype.init___T = (function(s) {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
function $as_jl_ClassCastException(obj) {
  return (((obj instanceof $c_jl_ClassCastException) || (obj === null)) ? obj : $throwClassCastException(obj, "java.lang.ClassCastException"))
}
function $isArrayOf_jl_ClassCastException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_ClassCastException)))
}
function $asArrayOf_jl_ClassCastException(obj, depth) {
  return (($isArrayOf_jl_ClassCastException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.ClassCastException;", depth))
}
var $d_jl_ClassCastException = new $TypeData().initClass({
  jl_ClassCastException: 0
}, false, "java.lang.ClassCastException", {
  jl_ClassCastException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_jl_ClassCastException.prototype.$classData = $d_jl_ClassCastException;
/** @constructor */
function $c_jl_IllegalArgumentException() {
  $c_jl_RuntimeException.call(this)
}
$c_jl_IllegalArgumentException.prototype = new $h_jl_RuntimeException();
$c_jl_IllegalArgumentException.prototype.constructor = $c_jl_IllegalArgumentException;
/** @constructor */
function $h_jl_IllegalArgumentException() {
  /*<skip>*/
}
$h_jl_IllegalArgumentException.prototype = $c_jl_IllegalArgumentException.prototype;
$c_jl_IllegalArgumentException.prototype.init___ = (function() {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
$c_jl_IllegalArgumentException.prototype.init___T = (function(s) {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
var $d_jl_IllegalArgumentException = new $TypeData().initClass({
  jl_IllegalArgumentException: 0
}, false, "java.lang.IllegalArgumentException", {
  jl_IllegalArgumentException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_jl_IllegalArgumentException.prototype.$classData = $d_jl_IllegalArgumentException;
/** @constructor */
function $c_jl_IllegalStateException() {
  $c_jl_RuntimeException.call(this)
}
$c_jl_IllegalStateException.prototype = new $h_jl_RuntimeException();
$c_jl_IllegalStateException.prototype.constructor = $c_jl_IllegalStateException;
/** @constructor */
function $h_jl_IllegalStateException() {
  /*<skip>*/
}
$h_jl_IllegalStateException.prototype = $c_jl_IllegalStateException.prototype;
$c_jl_IllegalStateException.prototype.init___ = (function() {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
$c_jl_IllegalStateException.prototype.init___T = (function(s) {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
$c_jl_IllegalStateException.prototype.init___T__jl_Throwable = (function(s, e) {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, e, true, true);
  return this
});
var $d_jl_IllegalStateException = new $TypeData().initClass({
  jl_IllegalStateException: 0
}, false, "java.lang.IllegalStateException", {
  jl_IllegalStateException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_jl_IllegalStateException.prototype.$classData = $d_jl_IllegalStateException;
/** @constructor */
function $c_jl_IndexOutOfBoundsException() {
  $c_jl_RuntimeException.call(this)
}
$c_jl_IndexOutOfBoundsException.prototype = new $h_jl_RuntimeException();
$c_jl_IndexOutOfBoundsException.prototype.constructor = $c_jl_IndexOutOfBoundsException;
/** @constructor */
function $h_jl_IndexOutOfBoundsException() {
  /*<skip>*/
}
$h_jl_IndexOutOfBoundsException.prototype = $c_jl_IndexOutOfBoundsException.prototype;
$c_jl_IndexOutOfBoundsException.prototype.init___ = (function() {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
$c_jl_IndexOutOfBoundsException.prototype.init___T = (function(s) {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
var $d_jl_IndexOutOfBoundsException = new $TypeData().initClass({
  jl_IndexOutOfBoundsException: 0
}, false, "java.lang.IndexOutOfBoundsException", {
  jl_IndexOutOfBoundsException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_jl_IndexOutOfBoundsException.prototype.$classData = $d_jl_IndexOutOfBoundsException;
/** @constructor */
function $c_jl_JSConsoleBasedPrintStream$DummyOutputStream() {
  $c_Ljava_io_OutputStream.call(this)
}
$c_jl_JSConsoleBasedPrintStream$DummyOutputStream.prototype = new $h_Ljava_io_OutputStream();
$c_jl_JSConsoleBasedPrintStream$DummyOutputStream.prototype.constructor = $c_jl_JSConsoleBasedPrintStream$DummyOutputStream;
/** @constructor */
function $h_jl_JSConsoleBasedPrintStream$DummyOutputStream() {
  /*<skip>*/
}
$h_jl_JSConsoleBasedPrintStream$DummyOutputStream.prototype = $c_jl_JSConsoleBasedPrintStream$DummyOutputStream.prototype;
$c_jl_JSConsoleBasedPrintStream$DummyOutputStream.prototype.init___ = (function() {
  return this
});
var $d_jl_JSConsoleBasedPrintStream$DummyOutputStream = new $TypeData().initClass({
  jl_JSConsoleBasedPrintStream$DummyOutputStream: 0
}, false, "java.lang.JSConsoleBasedPrintStream$DummyOutputStream", {
  jl_JSConsoleBasedPrintStream$DummyOutputStream: 1,
  Ljava_io_OutputStream: 1,
  O: 1,
  Ljava_io_Closeable: 1,
  jl_AutoCloseable: 1,
  Ljava_io_Flushable: 1
});
$c_jl_JSConsoleBasedPrintStream$DummyOutputStream.prototype.$classData = $d_jl_JSConsoleBasedPrintStream$DummyOutputStream;
/** @constructor */
function $c_jl_NegativeArraySizeException() {
  $c_jl_RuntimeException.call(this)
}
$c_jl_NegativeArraySizeException.prototype = new $h_jl_RuntimeException();
$c_jl_NegativeArraySizeException.prototype.constructor = $c_jl_NegativeArraySizeException;
/** @constructor */
function $h_jl_NegativeArraySizeException() {
  /*<skip>*/
}
$h_jl_NegativeArraySizeException.prototype = $c_jl_NegativeArraySizeException.prototype;
$c_jl_NegativeArraySizeException.prototype.init___ = (function() {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
var $d_jl_NegativeArraySizeException = new $TypeData().initClass({
  jl_NegativeArraySizeException: 0
}, false, "java.lang.NegativeArraySizeException", {
  jl_NegativeArraySizeException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_jl_NegativeArraySizeException.prototype.$classData = $d_jl_NegativeArraySizeException;
/** @constructor */
function $c_jl_NullPointerException() {
  $c_jl_RuntimeException.call(this)
}
$c_jl_NullPointerException.prototype = new $h_jl_RuntimeException();
$c_jl_NullPointerException.prototype.constructor = $c_jl_NullPointerException;
/** @constructor */
function $h_jl_NullPointerException() {
  /*<skip>*/
}
$h_jl_NullPointerException.prototype = $c_jl_NullPointerException.prototype;
$c_jl_NullPointerException.prototype.init___ = (function() {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
$c_jl_NullPointerException.prototype.init___T = (function(s) {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
var $d_jl_NullPointerException = new $TypeData().initClass({
  jl_NullPointerException: 0
}, false, "java.lang.NullPointerException", {
  jl_NullPointerException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_jl_NullPointerException.prototype.$classData = $d_jl_NullPointerException;
/** @constructor */
function $c_jl_SecurityException() {
  $c_jl_RuntimeException.call(this)
}
$c_jl_SecurityException.prototype = new $h_jl_RuntimeException();
$c_jl_SecurityException.prototype.constructor = $c_jl_SecurityException;
/** @constructor */
function $h_jl_SecurityException() {
  /*<skip>*/
}
$h_jl_SecurityException.prototype = $c_jl_SecurityException.prototype;
$c_jl_SecurityException.prototype.init___T = (function(s) {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
var $d_jl_SecurityException = new $TypeData().initClass({
  jl_SecurityException: 0
}, false, "java.lang.SecurityException", {
  jl_SecurityException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_jl_SecurityException.prototype.$classData = $d_jl_SecurityException;
/** @constructor */
function $c_jl_UnsupportedOperationException() {
  $c_jl_RuntimeException.call(this)
}
$c_jl_UnsupportedOperationException.prototype = new $h_jl_RuntimeException();
$c_jl_UnsupportedOperationException.prototype.constructor = $c_jl_UnsupportedOperationException;
/** @constructor */
function $h_jl_UnsupportedOperationException() {
  /*<skip>*/
}
$h_jl_UnsupportedOperationException.prototype = $c_jl_UnsupportedOperationException.prototype;
$c_jl_UnsupportedOperationException.prototype.init___ = (function() {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
$c_jl_UnsupportedOperationException.prototype.init___T = (function(s) {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
var $d_jl_UnsupportedOperationException = new $TypeData().initClass({
  jl_UnsupportedOperationException: 0
}, false, "java.lang.UnsupportedOperationException", {
  jl_UnsupportedOperationException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_jl_UnsupportedOperationException.prototype.$classData = $d_jl_UnsupportedOperationException;
/** @constructor */
function $c_ju_NoSuchElementException() {
  $c_jl_RuntimeException.call(this)
}
$c_ju_NoSuchElementException.prototype = new $h_jl_RuntimeException();
$c_ju_NoSuchElementException.prototype.constructor = $c_ju_NoSuchElementException;
/** @constructor */
function $h_ju_NoSuchElementException() {
  /*<skip>*/
}
$h_ju_NoSuchElementException.prototype = $c_ju_NoSuchElementException.prototype;
$c_ju_NoSuchElementException.prototype.init___ = (function() {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
$c_ju_NoSuchElementException.prototype.init___T = (function(s) {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
var $d_ju_NoSuchElementException = new $TypeData().initClass({
  ju_NoSuchElementException: 0
}, false, "java.util.NoSuchElementException", {
  ju_NoSuchElementException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_ju_NoSuchElementException.prototype.$classData = $d_ju_NoSuchElementException;
/** @constructor */
function $c_ju_concurrent_TimeUnit$$anon$1() {
  $c_ju_concurrent_TimeUnit.call(this)
}
$c_ju_concurrent_TimeUnit$$anon$1.prototype = new $h_ju_concurrent_TimeUnit();
$c_ju_concurrent_TimeUnit$$anon$1.prototype.constructor = $c_ju_concurrent_TimeUnit$$anon$1;
/** @constructor */
function $h_ju_concurrent_TimeUnit$$anon$1() {
  /*<skip>*/
}
$h_ju_concurrent_TimeUnit$$anon$1.prototype = $c_ju_concurrent_TimeUnit$$anon$1.prototype;
$c_ju_concurrent_TimeUnit$$anon$1.prototype.init___ = (function() {
  $c_jl_Enum.prototype.init___T__I.call(this, "NANOSECONDS", 0);
  return this
});
$c_ju_concurrent_TimeUnit$$anon$1.prototype.toMinutes__J__J = (function(a) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(a.lo$2, a.hi$2, (-129542144), 13);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_concurrent_TimeUnit$$anon$1.prototype.toHours__J__J = (function(a) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(a.lo$2, a.hi$2, 817405952, 838);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_concurrent_TimeUnit$$anon$1.prototype.toSeconds__J__J = (function(a) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(a.lo$2, a.hi$2, 1000000000, 0);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_concurrent_TimeUnit$$anon$1.prototype.toMicros__J__J = (function(a) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(a.lo$2, a.hi$2, 1000, 0);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_concurrent_TimeUnit$$anon$1.prototype.toDays__J__J = (function(a) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(a.lo$2, a.hi$2, (-1857093632), 20116);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_concurrent_TimeUnit$$anon$1.prototype.toMillis__J__J = (function(a) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(a.lo$2, a.hi$2, 1000000, 0);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_concurrent_TimeUnit$$anon$1.prototype.convert__J__ju_concurrent_TimeUnit__J = (function(a, u) {
  return u.toNanos__J__J(a)
});
$c_ju_concurrent_TimeUnit$$anon$1.prototype.toNanos__J__J = (function(a) {
  return a
});
var $d_ju_concurrent_TimeUnit$$anon$1 = new $TypeData().initClass({
  ju_concurrent_TimeUnit$$anon$1: 0
}, false, "java.util.concurrent.TimeUnit$$anon$1", {
  ju_concurrent_TimeUnit$$anon$1: 1,
  ju_concurrent_TimeUnit: 1,
  jl_Enum: 1,
  O: 1,
  jl_Comparable: 1,
  Ljava_io_Serializable: 1
});
$c_ju_concurrent_TimeUnit$$anon$1.prototype.$classData = $d_ju_concurrent_TimeUnit$$anon$1;
/** @constructor */
function $c_ju_concurrent_TimeUnit$$anon$2() {
  $c_ju_concurrent_TimeUnit.call(this)
}
$c_ju_concurrent_TimeUnit$$anon$2.prototype = new $h_ju_concurrent_TimeUnit();
$c_ju_concurrent_TimeUnit$$anon$2.prototype.constructor = $c_ju_concurrent_TimeUnit$$anon$2;
/** @constructor */
function $h_ju_concurrent_TimeUnit$$anon$2() {
  /*<skip>*/
}
$h_ju_concurrent_TimeUnit$$anon$2.prototype = $c_ju_concurrent_TimeUnit$$anon$2.prototype;
$c_ju_concurrent_TimeUnit$$anon$2.prototype.init___ = (function() {
  $c_jl_Enum.prototype.init___T__I.call(this, "MICROSECONDS", 1);
  return this
});
$c_ju_concurrent_TimeUnit$$anon$2.prototype.toMinutes__J__J = (function(a) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(a.lo$2, a.hi$2, 60000000, 0);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_concurrent_TimeUnit$$anon$2.prototype.toHours__J__J = (function(a) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(a.lo$2, a.hi$2, (-694967296), 0);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_concurrent_TimeUnit$$anon$2.prototype.toSeconds__J__J = (function(a) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(a.lo$2, a.hi$2, 1000000, 0);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_concurrent_TimeUnit$$anon$2.prototype.toMicros__J__J = (function(a) {
  return a
});
$c_ju_concurrent_TimeUnit$$anon$2.prototype.toDays__J__J = (function(a) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(a.lo$2, a.hi$2, 500654080, 20);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_concurrent_TimeUnit$$anon$2.prototype.toMillis__J__J = (function(a) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(a.lo$2, a.hi$2, 1000, 0);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_concurrent_TimeUnit$$anon$2.prototype.convert__J__ju_concurrent_TimeUnit__J = (function(a, u) {
  return u.toMicros__J__J(a)
});
$c_ju_concurrent_TimeUnit$$anon$2.prototype.toNanos__J__J = (function(a) {
  return $m_ju_concurrent_TimeUnit$().java$util$concurrent$TimeUnit$$x__J__J__J__J(a, new $c_sjsr_RuntimeLong().init___I__I(1000, 0), new $c_sjsr_RuntimeLong().init___I__I((-1511828489), 2147483))
});
var $d_ju_concurrent_TimeUnit$$anon$2 = new $TypeData().initClass({
  ju_concurrent_TimeUnit$$anon$2: 0
}, false, "java.util.concurrent.TimeUnit$$anon$2", {
  ju_concurrent_TimeUnit$$anon$2: 1,
  ju_concurrent_TimeUnit: 1,
  jl_Enum: 1,
  O: 1,
  jl_Comparable: 1,
  Ljava_io_Serializable: 1
});
$c_ju_concurrent_TimeUnit$$anon$2.prototype.$classData = $d_ju_concurrent_TimeUnit$$anon$2;
/** @constructor */
function $c_ju_concurrent_TimeUnit$$anon$3() {
  $c_ju_concurrent_TimeUnit.call(this)
}
$c_ju_concurrent_TimeUnit$$anon$3.prototype = new $h_ju_concurrent_TimeUnit();
$c_ju_concurrent_TimeUnit$$anon$3.prototype.constructor = $c_ju_concurrent_TimeUnit$$anon$3;
/** @constructor */
function $h_ju_concurrent_TimeUnit$$anon$3() {
  /*<skip>*/
}
$h_ju_concurrent_TimeUnit$$anon$3.prototype = $c_ju_concurrent_TimeUnit$$anon$3.prototype;
$c_ju_concurrent_TimeUnit$$anon$3.prototype.init___ = (function() {
  $c_jl_Enum.prototype.init___T__I.call(this, "MILLISECONDS", 2);
  return this
});
$c_ju_concurrent_TimeUnit$$anon$3.prototype.toMinutes__J__J = (function(a) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(a.lo$2, a.hi$2, 60000, 0);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_concurrent_TimeUnit$$anon$3.prototype.toHours__J__J = (function(a) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(a.lo$2, a.hi$2, 3600000, 0);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_concurrent_TimeUnit$$anon$3.prototype.toSeconds__J__J = (function(a) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(a.lo$2, a.hi$2, 1000, 0);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_concurrent_TimeUnit$$anon$3.prototype.toMicros__J__J = (function(a) {
  return $m_ju_concurrent_TimeUnit$().java$util$concurrent$TimeUnit$$x__J__J__J__J(a, new $c_sjsr_RuntimeLong().init___I__I(1000, 0), new $c_sjsr_RuntimeLong().init___I__I((-1511828489), 2147483))
});
$c_ju_concurrent_TimeUnit$$anon$3.prototype.toDays__J__J = (function(a) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(a.lo$2, a.hi$2, 86400000, 0);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_concurrent_TimeUnit$$anon$3.prototype.toMillis__J__J = (function(a) {
  return a
});
$c_ju_concurrent_TimeUnit$$anon$3.prototype.convert__J__ju_concurrent_TimeUnit__J = (function(a, u) {
  return u.toMillis__J__J(a)
});
$c_ju_concurrent_TimeUnit$$anon$3.prototype.toNanos__J__J = (function(a) {
  return $m_ju_concurrent_TimeUnit$().java$util$concurrent$TimeUnit$$x__J__J__J__J(a, new $c_sjsr_RuntimeLong().init___I__I(1000000, 0), new $c_sjsr_RuntimeLong().init___I__I(2077252342, 2147))
});
var $d_ju_concurrent_TimeUnit$$anon$3 = new $TypeData().initClass({
  ju_concurrent_TimeUnit$$anon$3: 0
}, false, "java.util.concurrent.TimeUnit$$anon$3", {
  ju_concurrent_TimeUnit$$anon$3: 1,
  ju_concurrent_TimeUnit: 1,
  jl_Enum: 1,
  O: 1,
  jl_Comparable: 1,
  Ljava_io_Serializable: 1
});
$c_ju_concurrent_TimeUnit$$anon$3.prototype.$classData = $d_ju_concurrent_TimeUnit$$anon$3;
/** @constructor */
function $c_ju_concurrent_TimeUnit$$anon$4() {
  $c_ju_concurrent_TimeUnit.call(this)
}
$c_ju_concurrent_TimeUnit$$anon$4.prototype = new $h_ju_concurrent_TimeUnit();
$c_ju_concurrent_TimeUnit$$anon$4.prototype.constructor = $c_ju_concurrent_TimeUnit$$anon$4;
/** @constructor */
function $h_ju_concurrent_TimeUnit$$anon$4() {
  /*<skip>*/
}
$h_ju_concurrent_TimeUnit$$anon$4.prototype = $c_ju_concurrent_TimeUnit$$anon$4.prototype;
$c_ju_concurrent_TimeUnit$$anon$4.prototype.init___ = (function() {
  $c_jl_Enum.prototype.init___T__I.call(this, "SECONDS", 3);
  return this
});
$c_ju_concurrent_TimeUnit$$anon$4.prototype.toMinutes__J__J = (function(a) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(a.lo$2, a.hi$2, 60, 0);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_concurrent_TimeUnit$$anon$4.prototype.toHours__J__J = (function(a) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(a.lo$2, a.hi$2, 3600, 0);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_concurrent_TimeUnit$$anon$4.prototype.toSeconds__J__J = (function(a) {
  return a
});
$c_ju_concurrent_TimeUnit$$anon$4.prototype.toMicros__J__J = (function(a) {
  return $m_ju_concurrent_TimeUnit$().java$util$concurrent$TimeUnit$$x__J__J__J__J(a, new $c_sjsr_RuntimeLong().init___I__I(1000000, 0), new $c_sjsr_RuntimeLong().init___I__I(2077252342, 2147))
});
$c_ju_concurrent_TimeUnit$$anon$4.prototype.toDays__J__J = (function(a) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(a.lo$2, a.hi$2, 86400, 0);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_concurrent_TimeUnit$$anon$4.prototype.toMillis__J__J = (function(a) {
  return $m_ju_concurrent_TimeUnit$().java$util$concurrent$TimeUnit$$x__J__J__J__J(a, new $c_sjsr_RuntimeLong().init___I__I(1000, 0), new $c_sjsr_RuntimeLong().init___I__I((-1511828489), 2147483))
});
$c_ju_concurrent_TimeUnit$$anon$4.prototype.convert__J__ju_concurrent_TimeUnit__J = (function(a, u) {
  return u.toSeconds__J__J(a)
});
$c_ju_concurrent_TimeUnit$$anon$4.prototype.toNanos__J__J = (function(a) {
  return $m_ju_concurrent_TimeUnit$().java$util$concurrent$TimeUnit$$x__J__J__J__J(a, new $c_sjsr_RuntimeLong().init___I__I(1000000000, 0), new $c_sjsr_RuntimeLong().init___I__I(633437444, 2))
});
var $d_ju_concurrent_TimeUnit$$anon$4 = new $TypeData().initClass({
  ju_concurrent_TimeUnit$$anon$4: 0
}, false, "java.util.concurrent.TimeUnit$$anon$4", {
  ju_concurrent_TimeUnit$$anon$4: 1,
  ju_concurrent_TimeUnit: 1,
  jl_Enum: 1,
  O: 1,
  jl_Comparable: 1,
  Ljava_io_Serializable: 1
});
$c_ju_concurrent_TimeUnit$$anon$4.prototype.$classData = $d_ju_concurrent_TimeUnit$$anon$4;
/** @constructor */
function $c_ju_concurrent_TimeUnit$$anon$5() {
  $c_ju_concurrent_TimeUnit.call(this)
}
$c_ju_concurrent_TimeUnit$$anon$5.prototype = new $h_ju_concurrent_TimeUnit();
$c_ju_concurrent_TimeUnit$$anon$5.prototype.constructor = $c_ju_concurrent_TimeUnit$$anon$5;
/** @constructor */
function $h_ju_concurrent_TimeUnit$$anon$5() {
  /*<skip>*/
}
$h_ju_concurrent_TimeUnit$$anon$5.prototype = $c_ju_concurrent_TimeUnit$$anon$5.prototype;
$c_ju_concurrent_TimeUnit$$anon$5.prototype.init___ = (function() {
  $c_jl_Enum.prototype.init___T__I.call(this, "MINUTES", 4);
  return this
});
$c_ju_concurrent_TimeUnit$$anon$5.prototype.toMinutes__J__J = (function(a) {
  return a
});
$c_ju_concurrent_TimeUnit$$anon$5.prototype.toHours__J__J = (function(a) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(a.lo$2, a.hi$2, 60, 0);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_concurrent_TimeUnit$$anon$5.prototype.toSeconds__J__J = (function(a) {
  return $m_ju_concurrent_TimeUnit$().java$util$concurrent$TimeUnit$$x__J__J__J__J(a, new $c_sjsr_RuntimeLong().init___I__I(60, 0), new $c_sjsr_RuntimeLong().init___I__I(572662306, 35791394))
});
$c_ju_concurrent_TimeUnit$$anon$5.prototype.toMicros__J__J = (function(a) {
  return $m_ju_concurrent_TimeUnit$().java$util$concurrent$TimeUnit$$x__J__J__J__J(a, new $c_sjsr_RuntimeLong().init___I__I(60000000, 0), new $c_sjsr_RuntimeLong().init___I__I((-895955376), 35))
});
$c_ju_concurrent_TimeUnit$$anon$5.prototype.toDays__J__J = (function(a) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(a.lo$2, a.hi$2, 1440, 0);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_concurrent_TimeUnit$$anon$5.prototype.toMillis__J__J = (function(a) {
  return $m_ju_concurrent_TimeUnit$().java$util$concurrent$TimeUnit$$x__J__J__J__J(a, new $c_sjsr_RuntimeLong().init___I__I(60000, 0), new $c_sjsr_RuntimeLong().init___I__I(1692789776, 35791))
});
$c_ju_concurrent_TimeUnit$$anon$5.prototype.convert__J__ju_concurrent_TimeUnit__J = (function(a, u) {
  return u.toMinutes__J__J(a)
});
$c_ju_concurrent_TimeUnit$$anon$5.prototype.toNanos__J__J = (function(a) {
  return $m_ju_concurrent_TimeUnit$().java$util$concurrent$TimeUnit$$x__J__J__J__J(a, new $c_sjsr_RuntimeLong().init___I__I((-129542144), 13), new $c_sjsr_RuntimeLong().init___I__I(153722867, 0))
});
var $d_ju_concurrent_TimeUnit$$anon$5 = new $TypeData().initClass({
  ju_concurrent_TimeUnit$$anon$5: 0
}, false, "java.util.concurrent.TimeUnit$$anon$5", {
  ju_concurrent_TimeUnit$$anon$5: 1,
  ju_concurrent_TimeUnit: 1,
  jl_Enum: 1,
  O: 1,
  jl_Comparable: 1,
  Ljava_io_Serializable: 1
});
$c_ju_concurrent_TimeUnit$$anon$5.prototype.$classData = $d_ju_concurrent_TimeUnit$$anon$5;
/** @constructor */
function $c_ju_concurrent_TimeUnit$$anon$6() {
  $c_ju_concurrent_TimeUnit.call(this)
}
$c_ju_concurrent_TimeUnit$$anon$6.prototype = new $h_ju_concurrent_TimeUnit();
$c_ju_concurrent_TimeUnit$$anon$6.prototype.constructor = $c_ju_concurrent_TimeUnit$$anon$6;
/** @constructor */
function $h_ju_concurrent_TimeUnit$$anon$6() {
  /*<skip>*/
}
$h_ju_concurrent_TimeUnit$$anon$6.prototype = $c_ju_concurrent_TimeUnit$$anon$6.prototype;
$c_ju_concurrent_TimeUnit$$anon$6.prototype.init___ = (function() {
  $c_jl_Enum.prototype.init___T__I.call(this, "HOURS", 5);
  return this
});
$c_ju_concurrent_TimeUnit$$anon$6.prototype.toMinutes__J__J = (function(a) {
  return $m_ju_concurrent_TimeUnit$().java$util$concurrent$TimeUnit$$x__J__J__J__J(a, new $c_sjsr_RuntimeLong().init___I__I(60, 0), new $c_sjsr_RuntimeLong().init___I__I(572662306, 35791394))
});
$c_ju_concurrent_TimeUnit$$anon$6.prototype.toHours__J__J = (function(a) {
  return a
});
$c_ju_concurrent_TimeUnit$$anon$6.prototype.toSeconds__J__J = (function(a) {
  return $m_ju_concurrent_TimeUnit$().java$util$concurrent$TimeUnit$$x__J__J__J__J(a, new $c_sjsr_RuntimeLong().init___I__I(3600, 0), new $c_sjsr_RuntimeLong().init___I__I(1011703407, 596523))
});
$c_ju_concurrent_TimeUnit$$anon$6.prototype.toMicros__J__J = (function(a) {
  return $m_ju_concurrent_TimeUnit$().java$util$concurrent$TimeUnit$$x__J__J__J__J(a, new $c_sjsr_RuntimeLong().init___I__I((-694967296), 0), new $c_sjsr_RuntimeLong().init___I__I((-1732919508), 0))
});
$c_ju_concurrent_TimeUnit$$anon$6.prototype.toDays__J__J = (function(a) {
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo = this$1.divideImpl__I__I__I__I__I(a.lo$2, a.hi$2, 24, 0);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_concurrent_TimeUnit$$anon$6.prototype.toMillis__J__J = (function(a) {
  return $m_ju_concurrent_TimeUnit$().java$util$concurrent$TimeUnit$$x__J__J__J__J(a, new $c_sjsr_RuntimeLong().init___I__I(3600000, 0), new $c_sjsr_RuntimeLong().init___I__I((-2047687697), 596))
});
$c_ju_concurrent_TimeUnit$$anon$6.prototype.convert__J__ju_concurrent_TimeUnit__J = (function(a, u) {
  return u.toHours__J__J(a)
});
$c_ju_concurrent_TimeUnit$$anon$6.prototype.toNanos__J__J = (function(a) {
  return $m_ju_concurrent_TimeUnit$().java$util$concurrent$TimeUnit$$x__J__J__J__J(a, new $c_sjsr_RuntimeLong().init___I__I(817405952, 838), new $c_sjsr_RuntimeLong().init___I__I(2562047, 0))
});
var $d_ju_concurrent_TimeUnit$$anon$6 = new $TypeData().initClass({
  ju_concurrent_TimeUnit$$anon$6: 0
}, false, "java.util.concurrent.TimeUnit$$anon$6", {
  ju_concurrent_TimeUnit$$anon$6: 1,
  ju_concurrent_TimeUnit: 1,
  jl_Enum: 1,
  O: 1,
  jl_Comparable: 1,
  Ljava_io_Serializable: 1
});
$c_ju_concurrent_TimeUnit$$anon$6.prototype.$classData = $d_ju_concurrent_TimeUnit$$anon$6;
/** @constructor */
function $c_ju_concurrent_TimeUnit$$anon$7() {
  $c_ju_concurrent_TimeUnit.call(this)
}
$c_ju_concurrent_TimeUnit$$anon$7.prototype = new $h_ju_concurrent_TimeUnit();
$c_ju_concurrent_TimeUnit$$anon$7.prototype.constructor = $c_ju_concurrent_TimeUnit$$anon$7;
/** @constructor */
function $h_ju_concurrent_TimeUnit$$anon$7() {
  /*<skip>*/
}
$h_ju_concurrent_TimeUnit$$anon$7.prototype = $c_ju_concurrent_TimeUnit$$anon$7.prototype;
$c_ju_concurrent_TimeUnit$$anon$7.prototype.init___ = (function() {
  $c_jl_Enum.prototype.init___T__I.call(this, "DAYS", 6);
  return this
});
$c_ju_concurrent_TimeUnit$$anon$7.prototype.toMinutes__J__J = (function(a) {
  return $m_ju_concurrent_TimeUnit$().java$util$concurrent$TimeUnit$$x__J__J__J__J(a, new $c_sjsr_RuntimeLong().init___I__I(1440, 0), new $c_sjsr_RuntimeLong().init___I__I(381774870, 1491308))
});
$c_ju_concurrent_TimeUnit$$anon$7.prototype.toHours__J__J = (function(a) {
  return $m_ju_concurrent_TimeUnit$().java$util$concurrent$TimeUnit$$x__J__J__J__J(a, new $c_sjsr_RuntimeLong().init___I__I(24, 0), new $c_sjsr_RuntimeLong().init___I__I(1431655765, 89478485))
});
$c_ju_concurrent_TimeUnit$$anon$7.prototype.toSeconds__J__J = (function(a) {
  return $m_ju_concurrent_TimeUnit$().java$util$concurrent$TimeUnit$$x__J__J__J__J(a, new $c_sjsr_RuntimeLong().init___I__I(86400, 0), new $c_sjsr_RuntimeLong().init___I__I(579025220, 24855))
});
$c_ju_concurrent_TimeUnit$$anon$7.prototype.toMicros__J__J = (function(a) {
  return $m_ju_concurrent_TimeUnit$().java$util$concurrent$TimeUnit$$x__J__J__J__J(a, new $c_sjsr_RuntimeLong().init___I__I(500654080, 20), new $c_sjsr_RuntimeLong().init___I__I(106751991, 0))
});
$c_ju_concurrent_TimeUnit$$anon$7.prototype.toDays__J__J = (function(a) {
  return a
});
$c_ju_concurrent_TimeUnit$$anon$7.prototype.toMillis__J__J = (function(a) {
  return $m_ju_concurrent_TimeUnit$().java$util$concurrent$TimeUnit$$x__J__J__J__J(a, new $c_sjsr_RuntimeLong().init___I__I(86400000, 0), new $c_sjsr_RuntimeLong().init___I__I((-622191233), 24))
});
$c_ju_concurrent_TimeUnit$$anon$7.prototype.convert__J__ju_concurrent_TimeUnit__J = (function(a, u) {
  return u.toDays__J__J(a)
});
$c_ju_concurrent_TimeUnit$$anon$7.prototype.toNanos__J__J = (function(a) {
  return $m_ju_concurrent_TimeUnit$().java$util$concurrent$TimeUnit$$x__J__J__J__J(a, new $c_sjsr_RuntimeLong().init___I__I((-1857093632), 20116), new $c_sjsr_RuntimeLong().init___I__I(106751, 0))
});
var $d_ju_concurrent_TimeUnit$$anon$7 = new $TypeData().initClass({
  ju_concurrent_TimeUnit$$anon$7: 0
}, false, "java.util.concurrent.TimeUnit$$anon$7", {
  ju_concurrent_TimeUnit$$anon$7: 1,
  ju_concurrent_TimeUnit: 1,
  jl_Enum: 1,
  O: 1,
  jl_Comparable: 1,
  Ljava_io_Serializable: 1
});
$c_ju_concurrent_TimeUnit$$anon$7.prototype.$classData = $d_ju_concurrent_TimeUnit$$anon$7;
/** @constructor */
function $c_s_Enumeration$Value() {
  $c_O.call(this);
  this.scala$Enumeration$$outerEnum$1 = null;
  this.$$outer$1 = null
}
$c_s_Enumeration$Value.prototype = new $h_O();
$c_s_Enumeration$Value.prototype.constructor = $c_s_Enumeration$Value;
/** @constructor */
function $h_s_Enumeration$Value() {
  /*<skip>*/
}
$h_s_Enumeration$Value.prototype = $c_s_Enumeration$Value.prototype;
$c_s_Enumeration$Value.prototype.equals__O__Z = (function(other) {
  if ((other instanceof $c_s_Enumeration$Value)) {
    var x2 = $as_s_Enumeration$Value(other);
    return ((this.scala$Enumeration$$outerEnum$1 === x2.scala$Enumeration$$outerEnum$1) && (this.i$2 === x2.i$2))
  } else {
    return false
  }
});
$c_s_Enumeration$Value.prototype.compareTo__O__I = (function(that) {
  return this.compare__s_Enumeration$Value__I($as_s_Enumeration$Value(that))
});
$c_s_Enumeration$Value.prototype.compare__O__I = (function(that) {
  return this.compare__s_Enumeration$Value__I($as_s_Enumeration$Value(that))
});
$c_s_Enumeration$Value.prototype.init___s_Enumeration = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.scala$Enumeration$$outerEnum$1 = $$outer;
  return this
});
$c_s_Enumeration$Value.prototype.compare__s_Enumeration$Value__I = (function(that) {
  return ((this.i$2 < that.i$2) ? (-1) : ((this.i$2 === that.i$2) ? 0 : 1))
});
$c_s_Enumeration$Value.prototype.hashCode__I = (function() {
  return this.i$2
});
function $as_s_Enumeration$Value(obj) {
  return (((obj instanceof $c_s_Enumeration$Value) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.Enumeration$Value"))
}
function $isArrayOf_s_Enumeration$Value(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_Enumeration$Value)))
}
function $asArrayOf_s_Enumeration$Value(obj, depth) {
  return (($isArrayOf_s_Enumeration$Value(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.Enumeration$Value;", depth))
}
/** @constructor */
function $c_s_MatchError() {
  $c_jl_RuntimeException.call(this);
  this.objString$4 = null;
  this.obj$4 = null;
  this.bitmap$0$4 = false
}
$c_s_MatchError.prototype = new $h_jl_RuntimeException();
$c_s_MatchError.prototype.constructor = $c_s_MatchError;
/** @constructor */
function $h_s_MatchError() {
  /*<skip>*/
}
$h_s_MatchError.prototype = $c_s_MatchError.prototype;
$c_s_MatchError.prototype.objString$lzycompute__p4__T = (function() {
  if ((!this.bitmap$0$4)) {
    this.objString$4 = ((this.obj$4 === null) ? "null" : this.liftedTree1$1__p4__T());
    this.bitmap$0$4 = true
  };
  return this.objString$4
});
$c_s_MatchError.prototype.ofClass$1__p4__T = (function() {
  var this$1 = this.obj$4;
  return ("of class " + $objectGetClass(this$1).getName__T())
});
$c_s_MatchError.prototype.liftedTree1$1__p4__T = (function() {
  try {
    return ((($objectToString(this.obj$4) + " (") + this.ofClass$1__p4__T()) + ")")
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      return ("an instance " + this.ofClass$1__p4__T())
    } else {
      throw e
    }
  }
});
$c_s_MatchError.prototype.getMessage__T = (function() {
  return this.objString__p4__T()
});
$c_s_MatchError.prototype.objString__p4__T = (function() {
  return ((!this.bitmap$0$4) ? this.objString$lzycompute__p4__T() : this.objString$4)
});
$c_s_MatchError.prototype.init___O = (function(obj) {
  this.obj$4 = obj;
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
var $d_s_MatchError = new $TypeData().initClass({
  s_MatchError: 0
}, false, "scala.MatchError", {
  s_MatchError: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_s_MatchError.prototype.$classData = $d_s_MatchError;
/** @constructor */
function $c_s_Option() {
  $c_O.call(this)
}
$c_s_Option.prototype = new $h_O();
$c_s_Option.prototype.constructor = $c_s_Option;
/** @constructor */
function $h_s_Option() {
  /*<skip>*/
}
$h_s_Option.prototype = $c_s_Option.prototype;
$c_s_Option.prototype.toList__sci_List = (function() {
  return (this.isEmpty__Z() ? $m_sci_Nil$() : new $c_sci_$colon$colon().init___O__sci_List(this.get__O(), $m_sci_Nil$()))
});
$c_s_Option.prototype.isDefined__Z = (function() {
  return (!this.isEmpty__Z())
});
$c_s_Option.prototype.contains__O__Z = (function(elem) {
  return ((!this.isEmpty__Z()) && $m_sr_BoxesRunTime$().equals__O__O__Z(this.get__O(), elem))
});
function $as_s_Option(obj) {
  return (((obj instanceof $c_s_Option) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.Option"))
}
function $isArrayOf_s_Option(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_Option)))
}
function $asArrayOf_s_Option(obj, depth) {
  return (($isArrayOf_s_Option(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.Option;", depth))
}
/** @constructor */
function $c_s_PartialFunction$$anon$1() {
  $c_O.call(this);
  this.lift$1 = null
}
$c_s_PartialFunction$$anon$1.prototype = new $h_O();
$c_s_PartialFunction$$anon$1.prototype.constructor = $c_s_PartialFunction$$anon$1;
/** @constructor */
function $h_s_PartialFunction$$anon$1() {
  /*<skip>*/
}
$h_s_PartialFunction$$anon$1.prototype = $c_s_PartialFunction$$anon$1.prototype;
$c_s_PartialFunction$$anon$1.prototype.init___ = (function() {
  this.lift$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2) {
      return $m_s_None$()
    })
  })(this));
  return this
});
$c_s_PartialFunction$$anon$1.prototype.apply__O__O = (function(v1) {
  this.apply__O__sr_Nothing$(v1)
});
$c_s_PartialFunction$$anon$1.prototype.runWith__F1__F1 = (function(action) {
  return $m_s_PartialFunction$().scala$PartialFunction$$constFalse$f
});
$c_s_PartialFunction$$anon$1.prototype.toString__T = (function() {
  return "<function1>"
});
$c_s_PartialFunction$$anon$1.prototype.apply$mcZI$sp__I__Z = (function(v1) {
  return $uZ(this.apply__O__sr_Nothing$(v1))
});
$c_s_PartialFunction$$anon$1.prototype.isDefinedAt__O__Z = (function(x) {
  return false
});
$c_s_PartialFunction$$anon$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return $f_s_PartialFunction__applyOrElse__O__F1__O(this, x, $default)
});
$c_s_PartialFunction$$anon$1.prototype.apply__O__sr_Nothing$ = (function(x) {
  throw new $c_s_MatchError().init___O(x)
});
var $d_s_PartialFunction$$anon$1 = new $TypeData().initClass({
  s_PartialFunction$$anon$1: 0
}, false, "scala.PartialFunction$$anon$1", {
  s_PartialFunction$$anon$1: 1,
  O: 1,
  s_PartialFunction: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_PartialFunction$$anon$1.prototype.$classData = $d_s_PartialFunction$$anon$1;
/** @constructor */
function $c_s_PartialFunction$Lifted() {
  $c_sr_AbstractFunction1.call(this);
  this.pf$2 = null
}
$c_s_PartialFunction$Lifted.prototype = new $h_sr_AbstractFunction1();
$c_s_PartialFunction$Lifted.prototype.constructor = $c_s_PartialFunction$Lifted;
/** @constructor */
function $h_s_PartialFunction$Lifted() {
  /*<skip>*/
}
$h_s_PartialFunction$Lifted.prototype = $c_s_PartialFunction$Lifted.prototype;
$c_s_PartialFunction$Lifted.prototype.apply__O__O = (function(v1) {
  return this.apply__O__s_Option(v1)
});
$c_s_PartialFunction$Lifted.prototype.init___s_PartialFunction = (function(pf) {
  this.pf$2 = pf;
  return this
});
$c_s_PartialFunction$Lifted.prototype.apply__O__s_Option = (function(x) {
  var z = this.pf$2.applyOrElse__O__F1__O(x, $m_s_PartialFunction$().scala$PartialFunction$$fallback$undpf$f);
  return ((!$m_s_PartialFunction$().scala$PartialFunction$$fallbackOccurred__O__Z(z)) ? new $c_s_Some().init___O(z) : $m_s_None$())
});
var $d_s_PartialFunction$Lifted = new $TypeData().initClass({
  s_PartialFunction$Lifted: 0
}, false, "scala.PartialFunction$Lifted", {
  s_PartialFunction$Lifted: 1,
  sr_AbstractFunction1: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_PartialFunction$Lifted.prototype.$classData = $d_s_PartialFunction$Lifted;
/** @constructor */
function $c_s_Predef$$anon$2() {
  $c_s_Predef$$less$colon$less.call(this)
}
$c_s_Predef$$anon$2.prototype = new $h_s_Predef$$less$colon$less();
$c_s_Predef$$anon$2.prototype.constructor = $c_s_Predef$$anon$2;
/** @constructor */
function $h_s_Predef$$anon$2() {
  /*<skip>*/
}
$h_s_Predef$$anon$2.prototype = $c_s_Predef$$anon$2.prototype;
$c_s_Predef$$anon$2.prototype.init___ = (function() {
  return this
});
$c_s_Predef$$anon$2.prototype.apply__O__O = (function(x) {
  return x
});
var $d_s_Predef$$anon$2 = new $TypeData().initClass({
  s_Predef$$anon$2: 0
}, false, "scala.Predef$$anon$2", {
  s_Predef$$anon$2: 1,
  s_Predef$$less$colon$less: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_Predef$$anon$2.prototype.$classData = $d_s_Predef$$anon$2;
/** @constructor */
function $c_s_Predef$$anon$3() {
  $c_s_Predef$$eq$colon$eq.call(this)
}
$c_s_Predef$$anon$3.prototype = new $h_s_Predef$$eq$colon$eq();
$c_s_Predef$$anon$3.prototype.constructor = $c_s_Predef$$anon$3;
/** @constructor */
function $h_s_Predef$$anon$3() {
  /*<skip>*/
}
$h_s_Predef$$anon$3.prototype = $c_s_Predef$$anon$3.prototype;
$c_s_Predef$$anon$3.prototype.init___ = (function() {
  return this
});
$c_s_Predef$$anon$3.prototype.apply__O__O = (function(x) {
  return x
});
var $d_s_Predef$$anon$3 = new $TypeData().initClass({
  s_Predef$$anon$3: 0
}, false, "scala.Predef$$anon$3", {
  s_Predef$$anon$3: 1,
  s_Predef$$eq$colon$eq: 1,
  O: 1,
  F1: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_Predef$$anon$3.prototype.$classData = $d_s_Predef$$anon$3;
/** @constructor */
function $c_s_concurrent_duration_Duration() {
  $c_O.call(this)
}
$c_s_concurrent_duration_Duration.prototype = new $h_O();
$c_s_concurrent_duration_Duration.prototype.constructor = $c_s_concurrent_duration_Duration;
/** @constructor */
function $h_s_concurrent_duration_Duration() {
  /*<skip>*/
}
$h_s_concurrent_duration_Duration.prototype = $c_s_concurrent_duration_Duration.prototype;
$c_s_concurrent_duration_Duration.prototype.compareTo__O__I = (function(that) {
  return this.compare__s_concurrent_duration_Duration__I($as_s_concurrent_duration_Duration(that))
});
function $as_s_concurrent_duration_Duration(obj) {
  return (((obj instanceof $c_s_concurrent_duration_Duration) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.concurrent.duration.Duration"))
}
function $isArrayOf_s_concurrent_duration_Duration(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_concurrent_duration_Duration)))
}
function $asArrayOf_s_concurrent_duration_Duration(obj, depth) {
  return (($isArrayOf_s_concurrent_duration_Duration(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.concurrent.duration.Duration;", depth))
}
function $f_s_math_Ordering__gteq__O__O__Z($thiz, x, y) {
  return ($thiz.compare__O__O__I(x, y) >= 0)
}
function $f_s_math_Ordering__lteq__O__O__Z($thiz, x, y) {
  return ($thiz.compare__O__O__I(x, y) <= 0)
}
function $f_s_reflect_ClassTag__newArray__I__O($thiz, len) {
  var x1 = $thiz.runtimeClass__jl_Class();
  return ((x1 === $d_B.getClassOf()) ? $newArrayObject($d_B.getArrayOf(), [len]) : ((x1 === $d_S.getClassOf()) ? $newArrayObject($d_S.getArrayOf(), [len]) : ((x1 === $d_C.getClassOf()) ? $newArrayObject($d_C.getArrayOf(), [len]) : ((x1 === $d_I.getClassOf()) ? $newArrayObject($d_I.getArrayOf(), [len]) : ((x1 === $d_J.getClassOf()) ? $newArrayObject($d_J.getArrayOf(), [len]) : ((x1 === $d_F.getClassOf()) ? $newArrayObject($d_F.getArrayOf(), [len]) : ((x1 === $d_D.getClassOf()) ? $newArrayObject($d_D.getArrayOf(), [len]) : ((x1 === $d_Z.getClassOf()) ? $newArrayObject($d_Z.getArrayOf(), [len]) : ((x1 === $d_V.getClassOf()) ? $newArrayObject($d_sr_BoxedUnit.getArrayOf(), [len]) : $m_jl_reflect_Array$().newInstance__jl_Class__I__O($thiz.runtimeClass__jl_Class(), len))))))))))
}
function $f_s_reflect_ClassTag__equals__O__Z($thiz, x) {
  if ($is_s_reflect_ClassTag(x)) {
    var x$2 = $thiz.runtimeClass__jl_Class();
    var x$3 = $as_s_reflect_ClassTag(x).runtimeClass__jl_Class();
    return (x$2 === x$3)
  } else {
    return false
  }
}
function $f_s_reflect_ClassTag__prettyprint$1__ps_reflect_ClassTag__jl_Class__T($thiz, clazz) {
  if (clazz.isArray__Z()) {
    var clazz$1 = clazz.getComponentType__jl_Class();
    return (("Array[" + $f_s_reflect_ClassTag__prettyprint$1__ps_reflect_ClassTag__jl_Class__T($thiz, clazz$1)) + "]")
  } else {
    return clazz.getName__T()
  }
}
function $is_s_reflect_ClassTag(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.s_reflect_ClassTag)))
}
function $as_s_reflect_ClassTag(obj) {
  return (($is_s_reflect_ClassTag(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.reflect.ClassTag"))
}
function $isArrayOf_s_reflect_ClassTag(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_reflect_ClassTag)))
}
function $asArrayOf_s_reflect_ClassTag(obj, depth) {
  return (($isArrayOf_s_reflect_ClassTag(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.reflect.ClassTag;", depth))
}
/** @constructor */
function $c_s_util_Either() {
  $c_O.call(this)
}
$c_s_util_Either.prototype = new $h_O();
$c_s_util_Either.prototype.constructor = $c_s_util_Either;
/** @constructor */
function $h_s_util_Either() {
  /*<skip>*/
}
$h_s_util_Either.prototype = $c_s_util_Either.prototype;
$c_s_util_Either.prototype.toOption__s_Option = (function() {
  if ((this instanceof $c_s_util_Right)) {
    var x2 = $as_s_util_Right(this);
    var b = x2.value$2;
    return new $c_s_Some().init___O(b)
  } else {
    return $m_s_None$()
  }
});
function $as_s_util_Either(obj) {
  return (((obj instanceof $c_s_util_Either) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.util.Either"))
}
function $isArrayOf_s_util_Either(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_util_Either)))
}
function $asArrayOf_s_util_Either(obj, depth) {
  return (($isArrayOf_s_util_Either(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.util.Either;", depth))
}
/** @constructor */
function $c_s_util_Either$LeftProjection() {
  $c_O.call(this);
  this.e$1 = null
}
$c_s_util_Either$LeftProjection.prototype = new $h_O();
$c_s_util_Either$LeftProjection.prototype.constructor = $c_s_util_Either$LeftProjection;
/** @constructor */
function $h_s_util_Either$LeftProjection() {
  /*<skip>*/
}
$h_s_util_Either$LeftProjection.prototype = $c_s_util_Either$LeftProjection.prototype;
$c_s_util_Either$LeftProjection.prototype.productPrefix__T = (function() {
  return "LeftProjection"
});
$c_s_util_Either$LeftProjection.prototype.productArity__I = (function() {
  return 1
});
$c_s_util_Either$LeftProjection.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_s_util_Either$LeftProjection)) {
    var LeftProjection$1 = $as_s_util_Either$LeftProjection(x$1);
    var x = this.e$1;
    var x$2 = LeftProjection$1.e$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_s_util_Either$LeftProjection.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.e$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_s_util_Either$LeftProjection.prototype.get__O = (function() {
  var x1 = this.e$1;
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var a = x2.value$2;
    return a
  } else {
    throw new $c_ju_NoSuchElementException().init___T("Either.left.get on Right")
  }
});
$c_s_util_Either$LeftProjection.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_s_util_Either$LeftProjection.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_s_util_Either$LeftProjection.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_s_util_Either$LeftProjection.prototype.init___s_util_Either = (function(e) {
  this.e$1 = e;
  return this
});
$c_s_util_Either$LeftProjection.prototype.toOption__s_Option = (function() {
  var x1 = this.e$1;
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var a = x2.value$2;
    return new $c_s_Some().init___O(a)
  } else {
    return $m_s_None$()
  }
});
function $as_s_util_Either$LeftProjection(obj) {
  return (((obj instanceof $c_s_util_Either$LeftProjection) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.util.Either$LeftProjection"))
}
function $isArrayOf_s_util_Either$LeftProjection(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_util_Either$LeftProjection)))
}
function $asArrayOf_s_util_Either$LeftProjection(obj, depth) {
  return (($isArrayOf_s_util_Either$LeftProjection(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.util.Either$LeftProjection;", depth))
}
var $d_s_util_Either$LeftProjection = new $TypeData().initClass({
  s_util_Either$LeftProjection: 0
}, false, "scala.util.Either$LeftProjection", {
  s_util_Either$LeftProjection: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_util_Either$LeftProjection.prototype.$classData = $d_s_util_Either$LeftProjection;
/** @constructor */
function $c_s_util_Either$RightProjection() {
  $c_O.call(this);
  this.e$1 = null
}
$c_s_util_Either$RightProjection.prototype = new $h_O();
$c_s_util_Either$RightProjection.prototype.constructor = $c_s_util_Either$RightProjection;
/** @constructor */
function $h_s_util_Either$RightProjection() {
  /*<skip>*/
}
$h_s_util_Either$RightProjection.prototype = $c_s_util_Either$RightProjection.prototype;
$c_s_util_Either$RightProjection.prototype.productPrefix__T = (function() {
  return "RightProjection"
});
$c_s_util_Either$RightProjection.prototype.productArity__I = (function() {
  return 1
});
$c_s_util_Either$RightProjection.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_s_util_Either$RightProjection)) {
    var RightProjection$1 = $as_s_util_Either$RightProjection(x$1);
    var x = this.e$1;
    var x$2 = RightProjection$1.e$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_s_util_Either$RightProjection.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.e$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_s_util_Either$RightProjection.prototype.get__O = (function() {
  var x1 = this.e$1;
  if ((x1 instanceof $c_s_util_Right)) {
    var x2 = $as_s_util_Right(x1);
    var b = x2.value$2;
    return b
  } else {
    throw new $c_ju_NoSuchElementException().init___T("Either.right.get on Left")
  }
});
$c_s_util_Either$RightProjection.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_s_util_Either$RightProjection.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_s_util_Either$RightProjection.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_s_util_Either$RightProjection.prototype.init___s_util_Either = (function(e) {
  this.e$1 = e;
  return this
});
$c_s_util_Either$RightProjection.prototype.toOption__s_Option = (function() {
  var x1 = this.e$1;
  if ((x1 instanceof $c_s_util_Right)) {
    var x2 = $as_s_util_Right(x1);
    var b = x2.value$2;
    return new $c_s_Some().init___O(b)
  } else {
    return $m_s_None$()
  }
});
function $as_s_util_Either$RightProjection(obj) {
  return (((obj instanceof $c_s_util_Either$RightProjection) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.util.Either$RightProjection"))
}
function $isArrayOf_s_util_Either$RightProjection(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_util_Either$RightProjection)))
}
function $asArrayOf_s_util_Either$RightProjection(obj, depth) {
  return (($isArrayOf_s_util_Either$RightProjection(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.util.Either$RightProjection;", depth))
}
var $d_s_util_Either$RightProjection = new $TypeData().initClass({
  s_util_Either$RightProjection: 0
}, false, "scala.util.Either$RightProjection", {
  s_util_Either$RightProjection: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_util_Either$RightProjection.prototype.$classData = $d_s_util_Either$RightProjection;
/** @constructor */
function $c_s_util_Try() {
  $c_O.call(this)
}
$c_s_util_Try.prototype = new $h_O();
$c_s_util_Try.prototype.constructor = $c_s_util_Try;
/** @constructor */
function $h_s_util_Try() {
  /*<skip>*/
}
$h_s_util_Try.prototype = $c_s_util_Try.prototype;
function $as_s_util_Try(obj) {
  return (((obj instanceof $c_s_util_Try) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.util.Try"))
}
function $isArrayOf_s_util_Try(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_util_Try)))
}
function $asArrayOf_s_util_Try(obj, depth) {
  return (($isArrayOf_s_util_Try(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.util.Try;", depth))
}
/** @constructor */
function $c_s_util_control_BreakControl() {
  $c_jl_Throwable.call(this)
}
$c_s_util_control_BreakControl.prototype = new $h_jl_Throwable();
$c_s_util_control_BreakControl.prototype.constructor = $c_s_util_control_BreakControl;
/** @constructor */
function $h_s_util_control_BreakControl() {
  /*<skip>*/
}
$h_s_util_control_BreakControl.prototype = $c_s_util_control_BreakControl.prototype;
$c_s_util_control_BreakControl.prototype.init___ = (function() {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
$c_s_util_control_BreakControl.prototype.fillInStackTrace__jl_Throwable = (function() {
  return $f_s_util_control_NoStackTrace__fillInStackTrace__jl_Throwable(this)
});
var $d_s_util_control_BreakControl = new $TypeData().initClass({
  s_util_control_BreakControl: 0
}, false, "scala.util.control.BreakControl", {
  s_util_control_BreakControl: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  s_util_control_ControlThrowable: 1,
  s_util_control_NoStackTrace: 1
});
$c_s_util_control_BreakControl.prototype.$classData = $d_s_util_control_BreakControl;
function $f_sc_GenMapLike__equals__O__Z($thiz, that) {
  if ($is_sc_GenMap(that)) {
    var x2 = $as_sc_GenMap(that);
    return (($thiz === x2) || (($thiz.size__I() === x2.size__I()) && $f_sc_GenMapLike__liftedTree1$1__psc_GenMapLike__sc_GenMap__Z($thiz, x2)))
  } else {
    return false
  }
}
function $f_sc_GenMapLike__liftedTree1$1__psc_GenMapLike__sc_GenMap__Z($thiz, x2$1) {
  try {
    var this$1 = $thiz.iterator__sc_Iterator();
    var res = true;
    while ((res && this$1.hasNext__Z())) {
      var arg1 = this$1.next__O();
      var x0$1 = $as_T2(arg1);
      if ((x0$1 === null)) {
        throw new $c_s_MatchError().init___O(x0$1)
      };
      var k = x0$1.$$und1__O();
      var v = x0$1.$$und2__O();
      var x1$2 = x2$1.get__O__s_Option(k);
      matchEnd6: {
        if ((x1$2 instanceof $c_s_Some)) {
          var x2 = $as_s_Some(x1$2);
          var p3 = x2.value$2;
          if ($m_sr_BoxesRunTime$().equals__O__O__Z(v, p3)) {
            res = true;
            break matchEnd6
          }
        };
        res = false
      }
    };
    return res
  } catch (e) {
    if ((e instanceof $c_jl_ClassCastException)) {
      $as_jl_ClassCastException(e);
      return false
    } else {
      throw e
    }
  }
}
function $f_sc_GenSeqLike__indexOf__O__I__I($thiz, elem, from) {
  return $thiz.indexWhere__F1__I__I(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, elem$1) {
    return (function(x$1$2) {
      return $m_sr_BoxesRunTime$().equals__O__O__Z(elem$1, x$1$2)
    })
  })($thiz, elem)), from)
}
function $f_sc_GenSeqLike__equals__O__Z($thiz, that) {
  if ($is_sc_GenSeq(that)) {
    var x2 = $as_sc_GenSeq(that);
    return ((x2 === $thiz) || $thiz.sameElements__sc_GenIterable__Z(x2))
  } else {
    return false
  }
}
function $f_sc_GenSeqLike__isDefinedAt__I__Z($thiz, idx) {
  return ((idx >= 0) && (idx < $thiz.length__I()))
}
function $is_sc_GenTraversable(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_GenTraversable)))
}
function $as_sc_GenTraversable(obj) {
  return (($is_sc_GenTraversable(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.GenTraversable"))
}
function $isArrayOf_sc_GenTraversable(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_GenTraversable)))
}
function $asArrayOf_sc_GenTraversable(obj, depth) {
  return (($isArrayOf_sc_GenTraversable(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.GenTraversable;", depth))
}
/** @constructor */
function $c_sc_Iterable$() {
  $c_scg_GenTraversableFactory.call(this)
}
$c_sc_Iterable$.prototype = new $h_scg_GenTraversableFactory();
$c_sc_Iterable$.prototype.constructor = $c_sc_Iterable$;
/** @constructor */
function $h_sc_Iterable$() {
  /*<skip>*/
}
$h_sc_Iterable$.prototype = $c_sc_Iterable$.prototype;
$c_sc_Iterable$.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory.prototype.init___.call(this);
  return this
});
$c_sc_Iterable$.prototype.newBuilder__scm_Builder = (function() {
  $m_sci_Iterable$();
  return new $c_scm_ListBuffer().init___()
});
var $d_sc_Iterable$ = new $TypeData().initClass({
  sc_Iterable$: 0
}, false, "scala.collection.Iterable$", {
  sc_Iterable$: 1,
  scg_GenTraversableFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_TraversableFactory: 1,
  scg_GenericSeqCompanion: 1
});
$c_sc_Iterable$.prototype.$classData = $d_sc_Iterable$;
var $n_sc_Iterable$ = (void 0);
function $m_sc_Iterable$() {
  if ((!$n_sc_Iterable$)) {
    $n_sc_Iterable$ = new $c_sc_Iterable$().init___()
  };
  return $n_sc_Iterable$
}
/** @constructor */
function $c_sc_Iterator$$anon$10() {
  $c_sc_AbstractIterator.call(this);
  this.$$outer$2 = null;
  this.f$3$2 = null
}
$c_sc_Iterator$$anon$10.prototype = new $h_sc_AbstractIterator();
$c_sc_Iterator$$anon$10.prototype.constructor = $c_sc_Iterator$$anon$10;
/** @constructor */
function $h_sc_Iterator$$anon$10() {
  /*<skip>*/
}
$h_sc_Iterator$$anon$10.prototype = $c_sc_Iterator$$anon$10.prototype;
$c_sc_Iterator$$anon$10.prototype.next__O = (function() {
  return this.f$3$2.apply__O__O(this.$$outer$2.next__O())
});
$c_sc_Iterator$$anon$10.prototype.init___sc_Iterator__F1 = (function($$outer, f$3) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.f$3$2 = f$3;
  return this
});
$c_sc_Iterator$$anon$10.prototype.hasNext__Z = (function() {
  return this.$$outer$2.hasNext__Z()
});
var $d_sc_Iterator$$anon$10 = new $TypeData().initClass({
  sc_Iterator$$anon$10: 0
}, false, "scala.collection.Iterator$$anon$10", {
  sc_Iterator$$anon$10: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sc_Iterator$$anon$10.prototype.$classData = $d_sc_Iterator$$anon$10;
/** @constructor */
function $c_sc_Iterator$$anon$11() {
  $c_sc_AbstractIterator.call(this);
  this.cur$2 = null;
  this.$$outer$2 = null;
  this.f$4$2 = null
}
$c_sc_Iterator$$anon$11.prototype = new $h_sc_AbstractIterator();
$c_sc_Iterator$$anon$11.prototype.constructor = $c_sc_Iterator$$anon$11;
/** @constructor */
function $h_sc_Iterator$$anon$11() {
  /*<skip>*/
}
$h_sc_Iterator$$anon$11.prototype = $c_sc_Iterator$$anon$11.prototype;
$c_sc_Iterator$$anon$11.prototype.next__O = (function() {
  return (this.hasNext__Z() ? this.cur$2 : $m_sc_Iterator$().empty$1).next__O()
});
$c_sc_Iterator$$anon$11.prototype.init___sc_Iterator__F1 = (function($$outer, f$4) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.f$4$2 = f$4;
  this.cur$2 = $m_sc_Iterator$().empty$1;
  return this
});
$c_sc_Iterator$$anon$11.prototype.hasNext__Z = (function() {
  while ((!this.cur$2.hasNext__Z())) {
    if ((!this.$$outer$2.hasNext__Z())) {
      return false
    };
    this.nextCur__p2__V()
  };
  return true
});
$c_sc_Iterator$$anon$11.prototype.nextCur__p2__V = (function() {
  this.cur$2 = null;
  this.cur$2 = $as_sc_GenTraversableOnce(this.f$4$2.apply__O__O(this.$$outer$2.next__O())).toIterator__sc_Iterator()
});
var $d_sc_Iterator$$anon$11 = new $TypeData().initClass({
  sc_Iterator$$anon$11: 0
}, false, "scala.collection.Iterator$$anon$11", {
  sc_Iterator$$anon$11: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sc_Iterator$$anon$11.prototype.$classData = $d_sc_Iterator$$anon$11;
/** @constructor */
function $c_sc_Iterator$$anon$12() {
  $c_sc_AbstractIterator.call(this);
  this.hd$2 = null;
  this.hdDefined$2 = false;
  this.$$outer$2 = null;
  this.p$1$2 = null
}
$c_sc_Iterator$$anon$12.prototype = new $h_sc_AbstractIterator();
$c_sc_Iterator$$anon$12.prototype.constructor = $c_sc_Iterator$$anon$12;
/** @constructor */
function $h_sc_Iterator$$anon$12() {
  /*<skip>*/
}
$h_sc_Iterator$$anon$12.prototype = $c_sc_Iterator$$anon$12.prototype;
$c_sc_Iterator$$anon$12.prototype.next__O = (function() {
  if (this.hasNext__Z()) {
    this.hdDefined$2 = false;
    return this.hd$2
  } else {
    return $m_sc_Iterator$().empty$1.next__O()
  }
});
$c_sc_Iterator$$anon$12.prototype.init___sc_Iterator__F1 = (function($$outer, p$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.p$1$2 = p$1;
  this.hdDefined$2 = false;
  return this
});
$c_sc_Iterator$$anon$12.prototype.hasNext__Z = (function() {
  if (this.hdDefined$2) {
    return true
  } else {
    do {
      if ((!this.$$outer$2.hasNext__Z())) {
        return false
      };
      this.hd$2 = this.$$outer$2.next__O()
    } while ((!$uZ(this.p$1$2.apply__O__O(this.hd$2))));
    this.hdDefined$2 = true;
    return true
  }
});
var $d_sc_Iterator$$anon$12 = new $TypeData().initClass({
  sc_Iterator$$anon$12: 0
}, false, "scala.collection.Iterator$$anon$12", {
  sc_Iterator$$anon$12: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sc_Iterator$$anon$12.prototype.$classData = $d_sc_Iterator$$anon$12;
/** @constructor */
function $c_sc_Iterator$$anon$13() {
  $c_sc_AbstractIterator.call(this);
  this.hd$2 = null;
  this.status$2 = 0;
  this.$$outer$2 = null;
  this.pf$1$2 = null
}
$c_sc_Iterator$$anon$13.prototype = new $h_sc_AbstractIterator();
$c_sc_Iterator$$anon$13.prototype.constructor = $c_sc_Iterator$$anon$13;
/** @constructor */
function $h_sc_Iterator$$anon$13() {
  /*<skip>*/
}
$h_sc_Iterator$$anon$13.prototype = $c_sc_Iterator$$anon$13.prototype;
$c_sc_Iterator$$anon$13.prototype.next__O = (function() {
  if (this.hasNext__Z()) {
    this.status$2 = 0;
    return this.pf$1$2.apply__O__O(this.hd$2)
  } else {
    return $m_sc_Iterator$().empty$1.next__O()
  }
});
$c_sc_Iterator$$anon$13.prototype.init___sc_Iterator__s_PartialFunction = (function($$outer, pf$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.pf$1$2 = pf$1;
  this.status$2 = 0;
  return this
});
$c_sc_Iterator$$anon$13.prototype.hasNext__Z = (function() {
  while ((this.status$2 === 0)) {
    if (this.$$outer$2.hasNext__Z()) {
      this.hd$2 = this.$$outer$2.next__O();
      if (this.pf$1$2.isDefinedAt__O__Z(this.hd$2)) {
        this.status$2 = 1
      }
    } else {
      this.status$2 = (-1)
    }
  };
  return (this.status$2 === 1)
});
var $d_sc_Iterator$$anon$13 = new $TypeData().initClass({
  sc_Iterator$$anon$13: 0
}, false, "scala.collection.Iterator$$anon$13", {
  sc_Iterator$$anon$13: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sc_Iterator$$anon$13.prototype.$classData = $d_sc_Iterator$$anon$13;
/** @constructor */
function $c_sc_Iterator$$anon$15() {
  $c_sc_AbstractIterator.call(this);
  this.hd$2 = null;
  this.hdDefined$2 = false;
  this.tail$2 = null;
  this.p$3$2 = null
}
$c_sc_Iterator$$anon$15.prototype = new $h_sc_AbstractIterator();
$c_sc_Iterator$$anon$15.prototype.constructor = $c_sc_Iterator$$anon$15;
/** @constructor */
function $h_sc_Iterator$$anon$15() {
  /*<skip>*/
}
$h_sc_Iterator$$anon$15.prototype = $c_sc_Iterator$$anon$15.prototype;
$c_sc_Iterator$$anon$15.prototype.next__O = (function() {
  if (this.hasNext__Z()) {
    this.hdDefined$2 = false;
    return this.hd$2
  } else {
    return $m_sc_Iterator$().empty$1.next__O()
  }
});
$c_sc_Iterator$$anon$15.prototype.init___sc_Iterator__F1 = (function($$outer, p$3) {
  this.p$3$2 = p$3;
  this.hdDefined$2 = false;
  this.tail$2 = $$outer;
  return this
});
$c_sc_Iterator$$anon$15.prototype.hasNext__Z = (function() {
  if (this.hdDefined$2) {
    return true
  } else if (this.tail$2.hasNext__Z()) {
    this.hd$2 = this.tail$2.next__O();
    if ($uZ(this.p$3$2.apply__O__O(this.hd$2))) {
      this.hdDefined$2 = true
    } else {
      this.tail$2 = $m_sc_Iterator$().empty$1
    };
    return this.hdDefined$2
  } else {
    return false
  }
});
var $d_sc_Iterator$$anon$15 = new $TypeData().initClass({
  sc_Iterator$$anon$15: 0
}, false, "scala.collection.Iterator$$anon$15", {
  sc_Iterator$$anon$15: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sc_Iterator$$anon$15.prototype.$classData = $d_sc_Iterator$$anon$15;
/** @constructor */
function $c_sc_Iterator$$anon$17() {
  $c_sc_AbstractIterator.call(this);
  this.status$2 = 0;
  this.fst$2 = null;
  this.$$outer$2 = null;
  this.p$6$2 = null
}
$c_sc_Iterator$$anon$17.prototype = new $h_sc_AbstractIterator();
$c_sc_Iterator$$anon$17.prototype.constructor = $c_sc_Iterator$$anon$17;
/** @constructor */
function $h_sc_Iterator$$anon$17() {
  /*<skip>*/
}
$h_sc_Iterator$$anon$17.prototype = $c_sc_Iterator$$anon$17.prototype;
$c_sc_Iterator$$anon$17.prototype.next__O = (function() {
  if (this.hasNext__Z()) {
    if ((this.status$2 === 1)) {
      return this.$$outer$2.next__O()
    } else {
      this.status$2 = 1;
      return this.fst$2
    }
  } else {
    return $m_sc_Iterator$().empty$1.next__O()
  }
});
$c_sc_Iterator$$anon$17.prototype.init___sc_Iterator__F1 = (function($$outer, p$6) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.p$6$2 = p$6;
  this.status$2 = (-1);
  return this
});
$c_sc_Iterator$$anon$17.prototype.hasNext__Z = (function() {
  if ((this.status$2 === 1)) {
    return this.$$outer$2.hasNext__Z()
  } else if ((this.status$2 === 0)) {
    return true
  } else {
    while (this.$$outer$2.hasNext__Z()) {
      var a = this.$$outer$2.next__O();
      if ((!$uZ(this.p$6$2.apply__O__O(a)))) {
        this.fst$2 = a;
        this.status$2 = 0;
        return true
      }
    };
    this.status$2 = 1;
    return false
  }
});
var $d_sc_Iterator$$anon$17 = new $TypeData().initClass({
  sc_Iterator$$anon$17: 0
}, false, "scala.collection.Iterator$$anon$17", {
  sc_Iterator$$anon$17: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sc_Iterator$$anon$17.prototype.$classData = $d_sc_Iterator$$anon$17;
/** @constructor */
function $c_sc_Iterator$$anon$18() {
  $c_sc_AbstractIterator.call(this);
  this.$$outer$2 = null;
  this.that$1$2 = null
}
$c_sc_Iterator$$anon$18.prototype = new $h_sc_AbstractIterator();
$c_sc_Iterator$$anon$18.prototype.constructor = $c_sc_Iterator$$anon$18;
/** @constructor */
function $h_sc_Iterator$$anon$18() {
  /*<skip>*/
}
$h_sc_Iterator$$anon$18.prototype = $c_sc_Iterator$$anon$18.prototype;
$c_sc_Iterator$$anon$18.prototype.next__O = (function() {
  return this.next__T2()
});
$c_sc_Iterator$$anon$18.prototype.init___sc_Iterator__sc_Iterator = (function($$outer, that$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.that$1$2 = that$1;
  return this
});
$c_sc_Iterator$$anon$18.prototype.next__T2 = (function() {
  return new $c_T2().init___O__O(this.$$outer$2.next__O(), this.that$1$2.next__O())
});
$c_sc_Iterator$$anon$18.prototype.hasNext__Z = (function() {
  return (this.$$outer$2.hasNext__Z() && this.that$1$2.hasNext__Z())
});
var $d_sc_Iterator$$anon$18 = new $TypeData().initClass({
  sc_Iterator$$anon$18: 0
}, false, "scala.collection.Iterator$$anon$18", {
  sc_Iterator$$anon$18: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sc_Iterator$$anon$18.prototype.$classData = $d_sc_Iterator$$anon$18;
/** @constructor */
function $c_sc_Iterator$$anon$2() {
  $c_sc_AbstractIterator.call(this)
}
$c_sc_Iterator$$anon$2.prototype = new $h_sc_AbstractIterator();
$c_sc_Iterator$$anon$2.prototype.constructor = $c_sc_Iterator$$anon$2;
/** @constructor */
function $h_sc_Iterator$$anon$2() {
  /*<skip>*/
}
$h_sc_Iterator$$anon$2.prototype = $c_sc_Iterator$$anon$2.prototype;
$c_sc_Iterator$$anon$2.prototype.next__O = (function() {
  this.next__sr_Nothing$()
});
$c_sc_Iterator$$anon$2.prototype.init___ = (function() {
  return this
});
$c_sc_Iterator$$anon$2.prototype.next__sr_Nothing$ = (function() {
  throw new $c_ju_NoSuchElementException().init___T("next on empty iterator")
});
$c_sc_Iterator$$anon$2.prototype.hasNext__Z = (function() {
  return false
});
var $d_sc_Iterator$$anon$2 = new $TypeData().initClass({
  sc_Iterator$$anon$2: 0
}, false, "scala.collection.Iterator$$anon$2", {
  sc_Iterator$$anon$2: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sc_Iterator$$anon$2.prototype.$classData = $d_sc_Iterator$$anon$2;
/** @constructor */
function $c_sc_Iterator$$anon$3() {
  $c_sc_AbstractIterator.call(this);
  this.hasnext$2 = false;
  this.elem$1$2 = null
}
$c_sc_Iterator$$anon$3.prototype = new $h_sc_AbstractIterator();
$c_sc_Iterator$$anon$3.prototype.constructor = $c_sc_Iterator$$anon$3;
/** @constructor */
function $h_sc_Iterator$$anon$3() {
  /*<skip>*/
}
$h_sc_Iterator$$anon$3.prototype = $c_sc_Iterator$$anon$3.prototype;
$c_sc_Iterator$$anon$3.prototype.next__O = (function() {
  if (this.hasnext$2) {
    this.hasnext$2 = false;
    return this.elem$1$2
  } else {
    return $m_sc_Iterator$().empty$1.next__O()
  }
});
$c_sc_Iterator$$anon$3.prototype.init___O = (function(elem$1) {
  this.elem$1$2 = elem$1;
  this.hasnext$2 = true;
  return this
});
$c_sc_Iterator$$anon$3.prototype.hasNext__Z = (function() {
  return this.hasnext$2
});
var $d_sc_Iterator$$anon$3 = new $TypeData().initClass({
  sc_Iterator$$anon$3: 0
}, false, "scala.collection.Iterator$$anon$3", {
  sc_Iterator$$anon$3: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sc_Iterator$$anon$3.prototype.$classData = $d_sc_Iterator$$anon$3;
/** @constructor */
function $c_sc_Iterator$SliceIterator() {
  $c_sc_AbstractIterator.call(this);
  this.underlying$2 = null;
  this.scala$collection$Iterator$SliceIterator$$remaining$2 = 0;
  this.dropping$2 = 0
}
$c_sc_Iterator$SliceIterator.prototype = new $h_sc_AbstractIterator();
$c_sc_Iterator$SliceIterator.prototype.constructor = $c_sc_Iterator$SliceIterator;
/** @constructor */
function $h_sc_Iterator$SliceIterator() {
  /*<skip>*/
}
$h_sc_Iterator$SliceIterator.prototype = $c_sc_Iterator$SliceIterator.prototype;
$c_sc_Iterator$SliceIterator.prototype.next__O = (function() {
  this.skip__p2__V();
  if ((this.scala$collection$Iterator$SliceIterator$$remaining$2 > 0)) {
    this.scala$collection$Iterator$SliceIterator$$remaining$2 = (((-1) + this.scala$collection$Iterator$SliceIterator$$remaining$2) | 0);
    return this.underlying$2.next__O()
  } else {
    return ((this.scala$collection$Iterator$SliceIterator$$remaining$2 < 0) ? this.underlying$2.next__O() : $m_sc_Iterator$().empty$1.next__O())
  }
});
$c_sc_Iterator$SliceIterator.prototype.adjustedBound$1__p2__I__I = (function(lo$1) {
  if ((this.scala$collection$Iterator$SliceIterator$$remaining$2 < 0)) {
    return (-1)
  } else {
    var that = ((this.scala$collection$Iterator$SliceIterator$$remaining$2 - lo$1) | 0);
    return ((that < 0) ? 0 : that)
  }
});
$c_sc_Iterator$SliceIterator.prototype.sliceIterator__I__I__sc_Iterator = (function(from, until) {
  var lo = ((from > 0) ? from : 0);
  if ((until < 0)) {
    var rest = this.adjustedBound$1__p2__I__I(lo)
  } else if ((until <= lo)) {
    var rest = 0
  } else if ((this.scala$collection$Iterator$SliceIterator$$remaining$2 < 0)) {
    var rest = ((until - lo) | 0)
  } else {
    var x = this.adjustedBound$1__p2__I__I(lo);
    var that = ((until - lo) | 0);
    var rest = ((x < that) ? x : that)
  };
  if ((rest === 0)) {
    return $m_sc_Iterator$().empty$1
  } else {
    this.dropping$2 = ((this.dropping$2 + lo) | 0);
    this.scala$collection$Iterator$SliceIterator$$remaining$2 = rest;
    return this
  }
});
$c_sc_Iterator$SliceIterator.prototype.skip__p2__V = (function() {
  while ((this.dropping$2 > 0)) {
    if (this.underlying$2.hasNext__Z()) {
      this.underlying$2.next__O();
      this.dropping$2 = (((-1) + this.dropping$2) | 0)
    } else {
      this.dropping$2 = 0
    }
  }
});
$c_sc_Iterator$SliceIterator.prototype.hasNext__Z = (function() {
  this.skip__p2__V();
  return ((this.scala$collection$Iterator$SliceIterator$$remaining$2 !== 0) && this.underlying$2.hasNext__Z())
});
$c_sc_Iterator$SliceIterator.prototype.init___sc_Iterator__I__I = (function(underlying, start, limit) {
  this.underlying$2 = underlying;
  this.scala$collection$Iterator$SliceIterator$$remaining$2 = limit;
  this.dropping$2 = start;
  return this
});
var $d_sc_Iterator$SliceIterator = new $TypeData().initClass({
  sc_Iterator$SliceIterator: 0
}, false, "scala.collection.Iterator$SliceIterator", {
  sc_Iterator$SliceIterator: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sc_Iterator$SliceIterator.prototype.$classData = $d_sc_Iterator$SliceIterator;
/** @constructor */
function $c_sc_LinearSeqLike$$anon$1() {
  $c_sc_AbstractIterator.call(this);
  this.these$2 = null
}
$c_sc_LinearSeqLike$$anon$1.prototype = new $h_sc_AbstractIterator();
$c_sc_LinearSeqLike$$anon$1.prototype.constructor = $c_sc_LinearSeqLike$$anon$1;
/** @constructor */
function $h_sc_LinearSeqLike$$anon$1() {
  /*<skip>*/
}
$h_sc_LinearSeqLike$$anon$1.prototype = $c_sc_LinearSeqLike$$anon$1.prototype;
$c_sc_LinearSeqLike$$anon$1.prototype.next__O = (function() {
  if (this.hasNext__Z()) {
    var result = this.these$2.head__O();
    this.these$2 = $as_sc_LinearSeqLike(this.these$2.tail__O());
    return result
  } else {
    return $m_sc_Iterator$().empty$1.next__O()
  }
});
$c_sc_LinearSeqLike$$anon$1.prototype.init___sc_LinearSeqLike = (function($$outer) {
  this.these$2 = $$outer;
  return this
});
$c_sc_LinearSeqLike$$anon$1.prototype.toList__sci_List = (function() {
  var xs = this.these$2.toList__sci_List();
  this.these$2 = $as_sc_LinearSeqLike(this.these$2.take__I__O(0));
  return xs
});
$c_sc_LinearSeqLike$$anon$1.prototype.hasNext__Z = (function() {
  return (!this.these$2.isEmpty__Z())
});
var $d_sc_LinearSeqLike$$anon$1 = new $TypeData().initClass({
  sc_LinearSeqLike$$anon$1: 0
}, false, "scala.collection.LinearSeqLike$$anon$1", {
  sc_LinearSeqLike$$anon$1: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sc_LinearSeqLike$$anon$1.prototype.$classData = $d_sc_LinearSeqLike$$anon$1;
/** @constructor */
function $c_sc_MapLike$$anon$1() {
  $c_sc_AbstractIterator.call(this);
  this.iter$2 = null
}
$c_sc_MapLike$$anon$1.prototype = new $h_sc_AbstractIterator();
$c_sc_MapLike$$anon$1.prototype.constructor = $c_sc_MapLike$$anon$1;
/** @constructor */
function $h_sc_MapLike$$anon$1() {
  /*<skip>*/
}
$h_sc_MapLike$$anon$1.prototype = $c_sc_MapLike$$anon$1.prototype;
$c_sc_MapLike$$anon$1.prototype.next__O = (function() {
  return $as_T2(this.iter$2.next__O()).$$und1__O()
});
$c_sc_MapLike$$anon$1.prototype.hasNext__Z = (function() {
  return this.iter$2.hasNext__Z()
});
$c_sc_MapLike$$anon$1.prototype.init___sc_MapLike = (function($$outer) {
  this.iter$2 = $$outer.iterator__sc_Iterator();
  return this
});
var $d_sc_MapLike$$anon$1 = new $TypeData().initClass({
  sc_MapLike$$anon$1: 0
}, false, "scala.collection.MapLike$$anon$1", {
  sc_MapLike$$anon$1: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sc_MapLike$$anon$1.prototype.$classData = $d_sc_MapLike$$anon$1;
/** @constructor */
function $c_sc_MapLike$$anon$2() {
  $c_sc_AbstractIterator.call(this);
  this.iter$2 = null
}
$c_sc_MapLike$$anon$2.prototype = new $h_sc_AbstractIterator();
$c_sc_MapLike$$anon$2.prototype.constructor = $c_sc_MapLike$$anon$2;
/** @constructor */
function $h_sc_MapLike$$anon$2() {
  /*<skip>*/
}
$h_sc_MapLike$$anon$2.prototype = $c_sc_MapLike$$anon$2.prototype;
$c_sc_MapLike$$anon$2.prototype.next__O = (function() {
  return $as_T2(this.iter$2.next__O()).$$und2__O()
});
$c_sc_MapLike$$anon$2.prototype.hasNext__Z = (function() {
  return this.iter$2.hasNext__Z()
});
$c_sc_MapLike$$anon$2.prototype.init___sc_MapLike = (function($$outer) {
  this.iter$2 = $$outer.iterator__sc_Iterator();
  return this
});
var $d_sc_MapLike$$anon$2 = new $TypeData().initClass({
  sc_MapLike$$anon$2: 0
}, false, "scala.collection.MapLike$$anon$2", {
  sc_MapLike$$anon$2: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sc_MapLike$$anon$2.prototype.$classData = $d_sc_MapLike$$anon$2;
/** @constructor */
function $c_sc_Set$() {
  $c_scg_SetFactory.call(this)
}
$c_sc_Set$.prototype = new $h_scg_SetFactory();
$c_sc_Set$.prototype.constructor = $c_sc_Set$;
/** @constructor */
function $h_sc_Set$() {
  /*<skip>*/
}
$h_sc_Set$.prototype = $c_sc_Set$.prototype;
$c_sc_Set$.prototype.init___ = (function() {
  return this
});
$c_sc_Set$.prototype.empty__sc_GenTraversable = (function() {
  return $m_sci_Set$EmptySet$()
});
$c_sc_Set$.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$())
});
var $d_sc_Set$ = new $TypeData().initClass({
  sc_Set$: 0
}, false, "scala.collection.Set$", {
  sc_Set$: 1,
  scg_SetFactory: 1,
  scg_GenSetFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_GenericSeqCompanion: 1
});
$c_sc_Set$.prototype.$classData = $d_sc_Set$;
var $n_sc_Set$ = (void 0);
function $m_sc_Set$() {
  if ((!$n_sc_Set$)) {
    $n_sc_Set$ = new $c_sc_Set$().init___()
  };
  return $n_sc_Set$
}
/** @constructor */
function $c_sc_Traversable$() {
  $c_scg_GenTraversableFactory.call(this);
  this.breaks$3 = null
}
$c_sc_Traversable$.prototype = new $h_scg_GenTraversableFactory();
$c_sc_Traversable$.prototype.constructor = $c_sc_Traversable$;
/** @constructor */
function $h_sc_Traversable$() {
  /*<skip>*/
}
$h_sc_Traversable$.prototype = $c_sc_Traversable$.prototype;
$c_sc_Traversable$.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory.prototype.init___.call(this);
  $n_sc_Traversable$ = this;
  this.breaks$3 = new $c_s_util_control_Breaks().init___();
  return this
});
$c_sc_Traversable$.prototype.newBuilder__scm_Builder = (function() {
  $m_sci_Traversable$();
  return new $c_scm_ListBuffer().init___()
});
var $d_sc_Traversable$ = new $TypeData().initClass({
  sc_Traversable$: 0
}, false, "scala.collection.Traversable$", {
  sc_Traversable$: 1,
  scg_GenTraversableFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_TraversableFactory: 1,
  scg_GenericSeqCompanion: 1
});
$c_sc_Traversable$.prototype.$classData = $d_sc_Traversable$;
var $n_sc_Traversable$ = (void 0);
function $m_sc_Traversable$() {
  if ((!$n_sc_Traversable$)) {
    $n_sc_Traversable$ = new $c_sc_Traversable$().init___()
  };
  return $n_sc_Traversable$
}
/** @constructor */
function $c_sc_TraversableOnce$FlattenOps$$anon$2() {
  $c_sc_AbstractIterator.call(this);
  this.its$2 = null;
  this.it$2 = null
}
$c_sc_TraversableOnce$FlattenOps$$anon$2.prototype = new $h_sc_AbstractIterator();
$c_sc_TraversableOnce$FlattenOps$$anon$2.prototype.constructor = $c_sc_TraversableOnce$FlattenOps$$anon$2;
/** @constructor */
function $h_sc_TraversableOnce$FlattenOps$$anon$2() {
  /*<skip>*/
}
$h_sc_TraversableOnce$FlattenOps$$anon$2.prototype = $c_sc_TraversableOnce$FlattenOps$$anon$2.prototype;
$c_sc_TraversableOnce$FlattenOps$$anon$2.prototype.next__O = (function() {
  return (this.hasNext__Z() ? this.it$2.next__O() : $m_sc_Iterator$().empty$1.next__O())
});
$c_sc_TraversableOnce$FlattenOps$$anon$2.prototype.hasNext__Z = (function() {
  _hasNext: while (true) {
    if (this.it$2.hasNext__Z()) {
      return true
    } else if (this.its$2.hasNext__Z()) {
      this.it$2 = $as_sc_GenTraversableOnce(this.its$2.next__O()).toIterator__sc_Iterator();
      continue _hasNext
    } else {
      return false
    }
  }
});
$c_sc_TraversableOnce$FlattenOps$$anon$2.prototype.init___sc_TraversableOnce$FlattenOps = (function($$outer) {
  this.its$2 = $$outer.scala$collection$TraversableOnce$FlattenOps$$travs$f.toIterator__sc_Iterator();
  this.it$2 = $m_sc_Iterator$().empty$1;
  return this
});
var $d_sc_TraversableOnce$FlattenOps$$anon$2 = new $TypeData().initClass({
  sc_TraversableOnce$FlattenOps$$anon$2: 0
}, false, "scala.collection.TraversableOnce$FlattenOps$$anon$2", {
  sc_TraversableOnce$FlattenOps$$anon$2: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sc_TraversableOnce$FlattenOps$$anon$2.prototype.$classData = $d_sc_TraversableOnce$FlattenOps$$anon$2;
/** @constructor */
function $c_scg_ImmutableSetFactory() {
  $c_scg_SetFactory.call(this)
}
$c_scg_ImmutableSetFactory.prototype = new $h_scg_SetFactory();
$c_scg_ImmutableSetFactory.prototype.constructor = $c_scg_ImmutableSetFactory;
/** @constructor */
function $h_scg_ImmutableSetFactory() {
  /*<skip>*/
}
$h_scg_ImmutableSetFactory.prototype = $c_scg_ImmutableSetFactory.prototype;
$c_scg_ImmutableSetFactory.prototype.empty__sc_GenTraversable = (function() {
  return this.emptyInstance__sci_Set()
});
$c_scg_ImmutableSetFactory.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_SetBuilder().init___sc_Set(this.emptyInstance__sci_Set())
});
/** @constructor */
function $c_scg_MutableSetFactory() {
  $c_scg_SetFactory.call(this)
}
$c_scg_MutableSetFactory.prototype = new $h_scg_SetFactory();
$c_scg_MutableSetFactory.prototype.constructor = $c_scg_MutableSetFactory;
/** @constructor */
function $h_scg_MutableSetFactory() {
  /*<skip>*/
}
$h_scg_MutableSetFactory.prototype = $c_scg_MutableSetFactory.prototype;
$c_scg_MutableSetFactory.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_GrowingBuilder().init___scg_Growable($as_scg_Growable(this.empty__sc_GenTraversable()))
});
/** @constructor */
function $c_sci_Iterable$() {
  $c_scg_GenTraversableFactory.call(this)
}
$c_sci_Iterable$.prototype = new $h_scg_GenTraversableFactory();
$c_sci_Iterable$.prototype.constructor = $c_sci_Iterable$;
/** @constructor */
function $h_sci_Iterable$() {
  /*<skip>*/
}
$h_sci_Iterable$.prototype = $c_sci_Iterable$.prototype;
$c_sci_Iterable$.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory.prototype.init___.call(this);
  return this
});
$c_sci_Iterable$.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_ListBuffer().init___()
});
var $d_sci_Iterable$ = new $TypeData().initClass({
  sci_Iterable$: 0
}, false, "scala.collection.immutable.Iterable$", {
  sci_Iterable$: 1,
  scg_GenTraversableFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_TraversableFactory: 1,
  scg_GenericSeqCompanion: 1
});
$c_sci_Iterable$.prototype.$classData = $d_sci_Iterable$;
var $n_sci_Iterable$ = (void 0);
function $m_sci_Iterable$() {
  if ((!$n_sci_Iterable$)) {
    $n_sci_Iterable$ = new $c_sci_Iterable$().init___()
  };
  return $n_sci_Iterable$
}
/** @constructor */
function $c_sci_RedBlackTree$KeysIterator() {
  $c_sci_RedBlackTree$TreeIterator.call(this)
}
$c_sci_RedBlackTree$KeysIterator.prototype = new $h_sci_RedBlackTree$TreeIterator();
$c_sci_RedBlackTree$KeysIterator.prototype.constructor = $c_sci_RedBlackTree$KeysIterator;
/** @constructor */
function $h_sci_RedBlackTree$KeysIterator() {
  /*<skip>*/
}
$h_sci_RedBlackTree$KeysIterator.prototype = $c_sci_RedBlackTree$KeysIterator.prototype;
$c_sci_RedBlackTree$KeysIterator.prototype.init___sci_RedBlackTree$Tree__s_Option__s_math_Ordering = (function(tree, focus, evidence$17) {
  $c_sci_RedBlackTree$TreeIterator.prototype.init___sci_RedBlackTree$Tree__s_Option__s_math_Ordering.call(this, tree, focus, evidence$17);
  return this
});
var $d_sci_RedBlackTree$KeysIterator = new $TypeData().initClass({
  sci_RedBlackTree$KeysIterator: 0
}, false, "scala.collection.immutable.RedBlackTree$KeysIterator", {
  sci_RedBlackTree$KeysIterator: 1,
  sci_RedBlackTree$TreeIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sci_RedBlackTree$KeysIterator.prototype.$classData = $d_sci_RedBlackTree$KeysIterator;
/** @constructor */
function $c_sci_StreamIterator() {
  $c_sc_AbstractIterator.call(this);
  this.these$2 = null
}
$c_sci_StreamIterator.prototype = new $h_sc_AbstractIterator();
$c_sci_StreamIterator.prototype.constructor = $c_sci_StreamIterator;
/** @constructor */
function $h_sci_StreamIterator() {
  /*<skip>*/
}
$h_sci_StreamIterator.prototype = $c_sci_StreamIterator.prototype;
$c_sci_StreamIterator.prototype.next__O = (function() {
  if ($f_sc_Iterator__isEmpty__Z(this)) {
    return $m_sc_Iterator$().empty$1.next__O()
  } else {
    var cur = this.these$2.v__sci_Stream();
    var result = cur.head__O();
    this.these$2 = new $c_sci_StreamIterator$LazyCell().init___sci_StreamIterator__F0(this, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, cur$1) {
      return (function() {
        return $as_sci_Stream(cur$1.tail__O())
      })
    })(this, cur)));
    return result
  }
});
$c_sci_StreamIterator.prototype.toList__sci_List = (function() {
  var this$1 = this.toStream__sci_Stream();
  var this$2 = $m_sci_List$();
  var cbf = this$2.ReusableCBFInstance$2;
  return $as_sci_List($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this$1, cbf))
});
$c_sci_StreamIterator.prototype.init___sci_Stream = (function(self) {
  this.these$2 = new $c_sci_StreamIterator$LazyCell().init___sci_StreamIterator__F0(this, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, self$1) {
    return (function() {
      return self$1
    })
  })(this, self)));
  return this
});
$c_sci_StreamIterator.prototype.hasNext__Z = (function() {
  var this$1 = this.these$2.v__sci_Stream();
  return $f_sc_TraversableOnce__nonEmpty__Z(this$1)
});
$c_sci_StreamIterator.prototype.toStream__sci_Stream = (function() {
  var result = this.these$2.v__sci_Stream();
  this.these$2 = new $c_sci_StreamIterator$LazyCell().init___sci_StreamIterator__F0(this, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
    return (function() {
      $m_sci_Stream$();
      return $m_sci_Stream$Empty$()
    })
  })(this)));
  return result
});
var $d_sci_StreamIterator = new $TypeData().initClass({
  sci_StreamIterator: 0
}, false, "scala.collection.immutable.StreamIterator", {
  sci_StreamIterator: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sci_StreamIterator.prototype.$classData = $d_sci_StreamIterator;
/** @constructor */
function $c_sci_StringLike$$anon$1() {
  $c_sc_AbstractIterator.call(this);
  this.str$2 = null;
  this.len$2 = 0;
  this.index$2 = 0;
  this.$$outer$2 = null
}
$c_sci_StringLike$$anon$1.prototype = new $h_sc_AbstractIterator();
$c_sci_StringLike$$anon$1.prototype.constructor = $c_sci_StringLike$$anon$1;
/** @constructor */
function $h_sci_StringLike$$anon$1() {
  /*<skip>*/
}
$h_sci_StringLike$$anon$1.prototype = $c_sci_StringLike$$anon$1.prototype;
$c_sci_StringLike$$anon$1.prototype.next__O = (function() {
  return this.next__T()
});
$c_sci_StringLike$$anon$1.prototype.next__T = (function() {
  if ((this.index$2 >= this.len$2)) {
    throw new $c_ju_NoSuchElementException().init___T("next on empty iterator")
  };
  var start = this.index$2;
  while (true) {
    if ((this.index$2 < this.len$2)) {
      var this$1 = this.$$outer$2;
      var c = this.$$outer$2.apply__I__C(this.index$2);
      var jsx$1 = (!$f_sci_StringLike__scala$collection$immutable$StringLike$$isLineBreak__C__Z(this$1, c))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      this.index$2 = ((1 + this.index$2) | 0)
    } else {
      break
    }
  };
  this.index$2 = ((1 + this.index$2) | 0);
  var thiz = this.str$2;
  var x = this.index$2;
  var that = this.len$2;
  var endIndex = ((x < that) ? x : that);
  return $as_T(thiz.substring(start, endIndex))
});
$c_sci_StringLike$$anon$1.prototype.hasNext__Z = (function() {
  return (this.index$2 < this.len$2)
});
$c_sci_StringLike$$anon$1.prototype.init___sci_StringLike = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.str$2 = $$outer.toString__T();
  var thiz = this.str$2;
  this.len$2 = $uI(thiz.length);
  this.index$2 = 0;
  return this
});
var $d_sci_StringLike$$anon$1 = new $TypeData().initClass({
  sci_StringLike$$anon$1: 0
}, false, "scala.collection.immutable.StringLike$$anon$1", {
  sci_StringLike$$anon$1: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sci_StringLike$$anon$1.prototype.$classData = $d_sci_StringLike$$anon$1;
/** @constructor */
function $c_sci_Traversable$() {
  $c_scg_GenTraversableFactory.call(this)
}
$c_sci_Traversable$.prototype = new $h_scg_GenTraversableFactory();
$c_sci_Traversable$.prototype.constructor = $c_sci_Traversable$;
/** @constructor */
function $h_sci_Traversable$() {
  /*<skip>*/
}
$h_sci_Traversable$.prototype = $c_sci_Traversable$.prototype;
$c_sci_Traversable$.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory.prototype.init___.call(this);
  return this
});
$c_sci_Traversable$.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_ListBuffer().init___()
});
var $d_sci_Traversable$ = new $TypeData().initClass({
  sci_Traversable$: 0
}, false, "scala.collection.immutable.Traversable$", {
  sci_Traversable$: 1,
  scg_GenTraversableFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_TraversableFactory: 1,
  scg_GenericSeqCompanion: 1
});
$c_sci_Traversable$.prototype.$classData = $d_sci_Traversable$;
var $n_sci_Traversable$ = (void 0);
function $m_sci_Traversable$() {
  if ((!$n_sci_Traversable$)) {
    $n_sci_Traversable$ = new $c_sci_Traversable$().init___()
  };
  return $n_sci_Traversable$
}
/** @constructor */
function $c_sci_TreeSet$() {
  $c_scg_ImmutableSortedSetFactory.call(this)
}
$c_sci_TreeSet$.prototype = new $h_scg_ImmutableSortedSetFactory();
$c_sci_TreeSet$.prototype.constructor = $c_sci_TreeSet$;
/** @constructor */
function $h_sci_TreeSet$() {
  /*<skip>*/
}
$h_sci_TreeSet$.prototype = $c_sci_TreeSet$.prototype;
$c_sci_TreeSet$.prototype.init___ = (function() {
  return this
});
$c_sci_TreeSet$.prototype.newBuilder__s_math_Ordering__scm_Builder = (function(ordering) {
  return new $c_scm_SetBuilder().init___sc_Set(new $c_sci_TreeSet().init___s_math_Ordering(ordering))
});
var $d_sci_TreeSet$ = new $TypeData().initClass({
  sci_TreeSet$: 0
}, false, "scala.collection.immutable.TreeSet$", {
  sci_TreeSet$: 1,
  scg_ImmutableSortedSetFactory: 1,
  scg_SortedSetFactory: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_TreeSet$.prototype.$classData = $d_sci_TreeSet$;
var $n_sci_TreeSet$ = (void 0);
function $m_sci_TreeSet$() {
  if ((!$n_sci_TreeSet$)) {
    $n_sci_TreeSet$ = new $c_sci_TreeSet$().init___()
  };
  return $n_sci_TreeSet$
}
/** @constructor */
function $c_sci_TrieIterator() {
  $c_sc_AbstractIterator.call(this);
  this.elems$2 = null;
  this.scala$collection$immutable$TrieIterator$$depth$f = 0;
  this.scala$collection$immutable$TrieIterator$$arrayStack$f = null;
  this.scala$collection$immutable$TrieIterator$$posStack$f = null;
  this.scala$collection$immutable$TrieIterator$$arrayD$f = null;
  this.scala$collection$immutable$TrieIterator$$posD$f = 0;
  this.scala$collection$immutable$TrieIterator$$subIter$f = null
}
$c_sci_TrieIterator.prototype = new $h_sc_AbstractIterator();
$c_sci_TrieIterator.prototype.constructor = $c_sci_TrieIterator;
/** @constructor */
function $h_sci_TrieIterator() {
  /*<skip>*/
}
$h_sci_TrieIterator.prototype = $c_sci_TrieIterator.prototype;
$c_sci_TrieIterator.prototype.isContainer__p2__O__Z = (function(x) {
  return ((x instanceof $c_sci_HashMap$HashMap1) || (x instanceof $c_sci_HashSet$HashSet1))
});
$c_sci_TrieIterator.prototype.next__O = (function() {
  if ((this.scala$collection$immutable$TrieIterator$$subIter$f !== null)) {
    var el = this.scala$collection$immutable$TrieIterator$$subIter$f.next__O();
    if ((!this.scala$collection$immutable$TrieIterator$$subIter$f.hasNext__Z())) {
      this.scala$collection$immutable$TrieIterator$$subIter$f = null
    };
    return el
  } else {
    return this.next0__p2__Asci_Iterable__I__O(this.scala$collection$immutable$TrieIterator$$arrayD$f, this.scala$collection$immutable$TrieIterator$$posD$f)
  }
});
$c_sci_TrieIterator.prototype.initPosStack__AI = (function() {
  return $newArrayObject($d_I.getArrayOf(), [6])
});
$c_sci_TrieIterator.prototype.hasNext__Z = (function() {
  return ((this.scala$collection$immutable$TrieIterator$$subIter$f !== null) || (this.scala$collection$immutable$TrieIterator$$depth$f >= 0))
});
$c_sci_TrieIterator.prototype.next0__p2__Asci_Iterable__I__O = (function(elems, i) {
  _next0: while (true) {
    if ((i === (((-1) + elems.u.length) | 0))) {
      this.scala$collection$immutable$TrieIterator$$depth$f = (((-1) + this.scala$collection$immutable$TrieIterator$$depth$f) | 0);
      if ((this.scala$collection$immutable$TrieIterator$$depth$f >= 0)) {
        this.scala$collection$immutable$TrieIterator$$arrayD$f = this.scala$collection$immutable$TrieIterator$$arrayStack$f.get(this.scala$collection$immutable$TrieIterator$$depth$f);
        this.scala$collection$immutable$TrieIterator$$posD$f = this.scala$collection$immutable$TrieIterator$$posStack$f.get(this.scala$collection$immutable$TrieIterator$$depth$f);
        this.scala$collection$immutable$TrieIterator$$arrayStack$f.set(this.scala$collection$immutable$TrieIterator$$depth$f, null)
      } else {
        this.scala$collection$immutable$TrieIterator$$arrayD$f = null;
        this.scala$collection$immutable$TrieIterator$$posD$f = 0
      }
    } else {
      this.scala$collection$immutable$TrieIterator$$posD$f = ((1 + this.scala$collection$immutable$TrieIterator$$posD$f) | 0)
    };
    var m = elems.get(i);
    if (this.isContainer__p2__O__Z(m)) {
      return this.getElem__O__O(m)
    } else if (this.isTrie__p2__O__Z(m)) {
      if ((this.scala$collection$immutable$TrieIterator$$depth$f >= 0)) {
        this.scala$collection$immutable$TrieIterator$$arrayStack$f.set(this.scala$collection$immutable$TrieIterator$$depth$f, this.scala$collection$immutable$TrieIterator$$arrayD$f);
        this.scala$collection$immutable$TrieIterator$$posStack$f.set(this.scala$collection$immutable$TrieIterator$$depth$f, this.scala$collection$immutable$TrieIterator$$posD$f)
      };
      this.scala$collection$immutable$TrieIterator$$depth$f = ((1 + this.scala$collection$immutable$TrieIterator$$depth$f) | 0);
      this.scala$collection$immutable$TrieIterator$$arrayD$f = this.getElems__p2__sci_Iterable__Asci_Iterable(m);
      this.scala$collection$immutable$TrieIterator$$posD$f = 0;
      var temp$elems = this.getElems__p2__sci_Iterable__Asci_Iterable(m);
      elems = temp$elems;
      i = 0;
      continue _next0
    } else {
      this.scala$collection$immutable$TrieIterator$$subIter$f = m.iterator__sc_Iterator();
      return this.next__O()
    }
  }
});
$c_sci_TrieIterator.prototype.getElems__p2__sci_Iterable__Asci_Iterable = (function(x) {
  if ((x instanceof $c_sci_HashMap$HashTrieMap)) {
    var x2 = $as_sci_HashMap$HashTrieMap(x);
    var jsx$1 = x2.elems$6
  } else {
    if ((!(x instanceof $c_sci_HashSet$HashTrieSet))) {
      throw new $c_s_MatchError().init___O(x)
    };
    var x3 = $as_sci_HashSet$HashTrieSet(x);
    var jsx$1 = x3.elems$5
  };
  return $asArrayOf_sci_Iterable(jsx$1, 1)
});
$c_sci_TrieIterator.prototype.init___Asci_Iterable = (function(elems) {
  this.elems$2 = elems;
  this.scala$collection$immutable$TrieIterator$$depth$f = 0;
  this.scala$collection$immutable$TrieIterator$$arrayStack$f = this.initArrayStack__AAsci_Iterable();
  this.scala$collection$immutable$TrieIterator$$posStack$f = this.initPosStack__AI();
  this.scala$collection$immutable$TrieIterator$$arrayD$f = this.elems$2;
  this.scala$collection$immutable$TrieIterator$$posD$f = 0;
  this.scala$collection$immutable$TrieIterator$$subIter$f = null;
  return this
});
$c_sci_TrieIterator.prototype.isTrie__p2__O__Z = (function(x) {
  return ((x instanceof $c_sci_HashMap$HashTrieMap) || (x instanceof $c_sci_HashSet$HashTrieSet))
});
$c_sci_TrieIterator.prototype.initArrayStack__AAsci_Iterable = (function() {
  return $newArrayObject($d_sci_Iterable.getArrayOf().getArrayOf(), [6])
});
/** @constructor */
function $c_sci_Vector$$anon$1() {
  $c_sc_AbstractIterator.call(this);
  this.i$2 = 0;
  this.$$outer$2 = null
}
$c_sci_Vector$$anon$1.prototype = new $h_sc_AbstractIterator();
$c_sci_Vector$$anon$1.prototype.constructor = $c_sci_Vector$$anon$1;
/** @constructor */
function $h_sci_Vector$$anon$1() {
  /*<skip>*/
}
$h_sci_Vector$$anon$1.prototype = $c_sci_Vector$$anon$1.prototype;
$c_sci_Vector$$anon$1.prototype.next__O = (function() {
  if ((this.i$2 > 0)) {
    this.i$2 = (((-1) + this.i$2) | 0);
    return this.$$outer$2.apply__I__O(this.i$2)
  } else {
    return $m_sc_Iterator$().empty$1.next__O()
  }
});
$c_sci_Vector$$anon$1.prototype.hasNext__Z = (function() {
  return (this.i$2 > 0)
});
$c_sci_Vector$$anon$1.prototype.init___sci_Vector = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.i$2 = $$outer.length__I();
  return this
});
var $d_sci_Vector$$anon$1 = new $TypeData().initClass({
  sci_Vector$$anon$1: 0
}, false, "scala.collection.immutable.Vector$$anon$1", {
  sci_Vector$$anon$1: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sci_Vector$$anon$1.prototype.$classData = $d_sci_Vector$$anon$1;
/** @constructor */
function $c_scm_Builder$$anon$1() {
  $c_O.call(this);
  this.self$1 = null;
  this.f$1$1 = null
}
$c_scm_Builder$$anon$1.prototype = new $h_O();
$c_scm_Builder$$anon$1.prototype.constructor = $c_scm_Builder$$anon$1;
/** @constructor */
function $h_scm_Builder$$anon$1() {
  /*<skip>*/
}
$h_scm_Builder$$anon$1.prototype = $c_scm_Builder$$anon$1.prototype;
$c_scm_Builder$$anon$1.prototype.init___scm_Builder__F1 = (function($$outer, f$1) {
  this.f$1$1 = f$1;
  this.self$1 = $$outer;
  return this
});
$c_scm_Builder$$anon$1.prototype.equals__O__Z = (function(that) {
  return $f_s_Proxy__equals__O__Z(this, that)
});
$c_scm_Builder$$anon$1.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__O__scm_Builder$$anon$1(elem)
});
$c_scm_Builder$$anon$1.prototype.toString__T = (function() {
  return $f_s_Proxy__toString__T(this)
});
$c_scm_Builder$$anon$1.prototype.$$plus$plus$eq__sc_TraversableOnce__scm_Builder$$anon$1 = (function(xs) {
  this.self$1.$$plus$plus$eq__sc_TraversableOnce__scg_Growable(xs);
  return this
});
$c_scm_Builder$$anon$1.prototype.result__O = (function() {
  return this.f$1$1.apply__O__O(this.self$1.result__O())
});
$c_scm_Builder$$anon$1.prototype.self__O = (function() {
  return this.self$1
});
$c_scm_Builder$$anon$1.prototype.sizeHintBounded__I__sc_TraversableLike__V = (function(size, boundColl) {
  this.self$1.sizeHintBounded__I__sc_TraversableLike__V(size, boundColl)
});
$c_scm_Builder$$anon$1.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__O__scm_Builder$$anon$1(elem)
});
$c_scm_Builder$$anon$1.prototype.$$plus$eq__O__scm_Builder$$anon$1 = (function(x) {
  this.self$1.$$plus$eq__O__scm_Builder(x);
  return this
});
$c_scm_Builder$$anon$1.prototype.hashCode__I = (function() {
  return this.self$1.hashCode__I()
});
$c_scm_Builder$$anon$1.prototype.sizeHint__I__V = (function(size) {
  this.self$1.sizeHint__I__V(size)
});
$c_scm_Builder$$anon$1.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return this.$$plus$plus$eq__sc_TraversableOnce__scm_Builder$$anon$1(xs)
});
var $d_scm_Builder$$anon$1 = new $TypeData().initClass({
  scm_Builder$$anon$1: 0
}, false, "scala.collection.mutable.Builder$$anon$1", {
  scm_Builder$$anon$1: 1,
  O: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  s_Proxy: 1
});
$c_scm_Builder$$anon$1.prototype.$classData = $d_scm_Builder$$anon$1;
/** @constructor */
function $c_scm_FlatHashTable$$anon$1() {
  $c_sc_AbstractIterator.call(this);
  this.i$2 = 0;
  this.$$outer$2 = null
}
$c_scm_FlatHashTable$$anon$1.prototype = new $h_sc_AbstractIterator();
$c_scm_FlatHashTable$$anon$1.prototype.constructor = $c_scm_FlatHashTable$$anon$1;
/** @constructor */
function $h_scm_FlatHashTable$$anon$1() {
  /*<skip>*/
}
$h_scm_FlatHashTable$$anon$1.prototype = $c_scm_FlatHashTable$$anon$1.prototype;
$c_scm_FlatHashTable$$anon$1.prototype.next__O = (function() {
  if (this.hasNext__Z()) {
    this.i$2 = ((1 + this.i$2) | 0);
    var this$1 = this.$$outer$2;
    var entry = this.$$outer$2.table$5.get((((-1) + this.i$2) | 0));
    return $f_scm_FlatHashTable$HashUtils__entryToElem__O__O(this$1, entry)
  } else {
    return $m_sc_Iterator$().empty$1.next__O()
  }
});
$c_scm_FlatHashTable$$anon$1.prototype.init___scm_FlatHashTable = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.i$2 = 0;
  return this
});
$c_scm_FlatHashTable$$anon$1.prototype.hasNext__Z = (function() {
  while (((this.i$2 < this.$$outer$2.table$5.u.length) && (this.$$outer$2.table$5.get(this.i$2) === null))) {
    this.i$2 = ((1 + this.i$2) | 0)
  };
  return (this.i$2 < this.$$outer$2.table$5.u.length)
});
var $d_scm_FlatHashTable$$anon$1 = new $TypeData().initClass({
  scm_FlatHashTable$$anon$1: 0
}, false, "scala.collection.mutable.FlatHashTable$$anon$1", {
  scm_FlatHashTable$$anon$1: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_scm_FlatHashTable$$anon$1.prototype.$classData = $d_scm_FlatHashTable$$anon$1;
/** @constructor */
function $c_scm_HashMap$$anon$3() {
  $c_sc_AbstractIterator.call(this);
  this.iter$2 = null
}
$c_scm_HashMap$$anon$3.prototype = new $h_sc_AbstractIterator();
$c_scm_HashMap$$anon$3.prototype.constructor = $c_scm_HashMap$$anon$3;
/** @constructor */
function $h_scm_HashMap$$anon$3() {
  /*<skip>*/
}
$h_scm_HashMap$$anon$3.prototype = $c_scm_HashMap$$anon$3.prototype;
$c_scm_HashMap$$anon$3.prototype.next__O = (function() {
  return $as_scm_DefaultEntry(this.iter$2.next__O()).key$1
});
$c_scm_HashMap$$anon$3.prototype.hasNext__Z = (function() {
  return this.iter$2.hasNext__Z()
});
$c_scm_HashMap$$anon$3.prototype.init___scm_HashMap = (function($$outer) {
  this.iter$2 = new $c_scm_HashTable$$anon$1().init___scm_HashTable($$outer);
  return this
});
var $d_scm_HashMap$$anon$3 = new $TypeData().initClass({
  scm_HashMap$$anon$3: 0
}, false, "scala.collection.mutable.HashMap$$anon$3", {
  scm_HashMap$$anon$3: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_scm_HashMap$$anon$3.prototype.$classData = $d_scm_HashMap$$anon$3;
/** @constructor */
function $c_scm_HashMap$$anon$4() {
  $c_sc_AbstractIterator.call(this);
  this.iter$2 = null
}
$c_scm_HashMap$$anon$4.prototype = new $h_sc_AbstractIterator();
$c_scm_HashMap$$anon$4.prototype.constructor = $c_scm_HashMap$$anon$4;
/** @constructor */
function $h_scm_HashMap$$anon$4() {
  /*<skip>*/
}
$h_scm_HashMap$$anon$4.prototype = $c_scm_HashMap$$anon$4.prototype;
$c_scm_HashMap$$anon$4.prototype.next__O = (function() {
  return $as_scm_DefaultEntry(this.iter$2.next__O()).value$1
});
$c_scm_HashMap$$anon$4.prototype.hasNext__Z = (function() {
  return this.iter$2.hasNext__Z()
});
$c_scm_HashMap$$anon$4.prototype.init___scm_HashMap = (function($$outer) {
  this.iter$2 = new $c_scm_HashTable$$anon$1().init___scm_HashTable($$outer);
  return this
});
var $d_scm_HashMap$$anon$4 = new $TypeData().initClass({
  scm_HashMap$$anon$4: 0
}, false, "scala.collection.mutable.HashMap$$anon$4", {
  scm_HashMap$$anon$4: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_scm_HashMap$$anon$4.prototype.$classData = $d_scm_HashMap$$anon$4;
/** @constructor */
function $c_scm_HashTable$$anon$1() {
  $c_sc_AbstractIterator.call(this);
  this.iterTable$2 = null;
  this.idx$2 = 0;
  this.es$2 = null
}
$c_scm_HashTable$$anon$1.prototype = new $h_sc_AbstractIterator();
$c_scm_HashTable$$anon$1.prototype.constructor = $c_scm_HashTable$$anon$1;
/** @constructor */
function $h_scm_HashTable$$anon$1() {
  /*<skip>*/
}
$h_scm_HashTable$$anon$1.prototype = $c_scm_HashTable$$anon$1.prototype;
$c_scm_HashTable$$anon$1.prototype.next__O = (function() {
  return this.next__scm_HashEntry()
});
$c_scm_HashTable$$anon$1.prototype.init___scm_HashTable = (function($$outer) {
  this.iterTable$2 = $$outer.table__Ascm_HashEntry();
  this.idx$2 = $f_scm_HashTable__scala$collection$mutable$HashTable$$lastPopulatedIndex__I($$outer);
  this.es$2 = this.iterTable$2.get(this.idx$2);
  return this
});
$c_scm_HashTable$$anon$1.prototype.next__scm_HashEntry = (function() {
  var res = this.es$2;
  this.es$2 = $as_scm_HashEntry(this.es$2.next__O());
  while (((this.es$2 === null) && (this.idx$2 > 0))) {
    this.idx$2 = (((-1) + this.idx$2) | 0);
    this.es$2 = this.iterTable$2.get(this.idx$2)
  };
  return res
});
$c_scm_HashTable$$anon$1.prototype.hasNext__Z = (function() {
  return (this.es$2 !== null)
});
var $d_scm_HashTable$$anon$1 = new $TypeData().initClass({
  scm_HashTable$$anon$1: 0
}, false, "scala.collection.mutable.HashTable$$anon$1", {
  scm_HashTable$$anon$1: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_scm_HashTable$$anon$1.prototype.$classData = $d_scm_HashTable$$anon$1;
/** @constructor */
function $c_scm_Iterable$() {
  $c_scg_GenTraversableFactory.call(this)
}
$c_scm_Iterable$.prototype = new $h_scg_GenTraversableFactory();
$c_scm_Iterable$.prototype.constructor = $c_scm_Iterable$;
/** @constructor */
function $h_scm_Iterable$() {
  /*<skip>*/
}
$h_scm_Iterable$.prototype = $c_scm_Iterable$.prototype;
$c_scm_Iterable$.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory.prototype.init___.call(this);
  return this
});
$c_scm_Iterable$.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_ArrayBuffer().init___()
});
var $d_scm_Iterable$ = new $TypeData().initClass({
  scm_Iterable$: 0
}, false, "scala.collection.mutable.Iterable$", {
  scm_Iterable$: 1,
  scg_GenTraversableFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_TraversableFactory: 1,
  scg_GenericSeqCompanion: 1
});
$c_scm_Iterable$.prototype.$classData = $d_scm_Iterable$;
var $n_scm_Iterable$ = (void 0);
function $m_scm_Iterable$() {
  if ((!$n_scm_Iterable$)) {
    $n_scm_Iterable$ = new $c_scm_Iterable$().init___()
  };
  return $n_scm_Iterable$
}
/** @constructor */
function $c_scm_LazyBuilder() {
  $c_O.call(this);
  this.parts$1 = null
}
$c_scm_LazyBuilder.prototype = new $h_O();
$c_scm_LazyBuilder.prototype.constructor = $c_scm_LazyBuilder;
/** @constructor */
function $h_scm_LazyBuilder() {
  /*<skip>*/
}
$h_scm_LazyBuilder.prototype = $c_scm_LazyBuilder.prototype;
$c_scm_LazyBuilder.prototype.init___ = (function() {
  this.parts$1 = new $c_scm_ListBuffer().init___();
  return this
});
$c_scm_LazyBuilder.prototype.$$plus$plus$eq__sc_TraversableOnce__scm_LazyBuilder = (function(xs) {
  this.parts$1.$$plus$eq__O__scm_ListBuffer(xs);
  return this
});
$c_scm_LazyBuilder.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__O__scm_LazyBuilder(elem)
});
$c_scm_LazyBuilder.prototype.$$plus$eq__O__scm_LazyBuilder = (function(x) {
  var jsx$1 = this.parts$1;
  $m_sci_List$();
  var array = [x];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x$1 = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$4);
    i = (((-1) + i) | 0)
  };
  jsx$1.$$plus$eq__O__scm_ListBuffer(result);
  return this
});
$c_scm_LazyBuilder.prototype.sizeHintBounded__I__sc_TraversableLike__V = (function(size, boundingColl) {
  $f_scm_Builder__sizeHintBounded__I__sc_TraversableLike__V(this, size, boundingColl)
});
$c_scm_LazyBuilder.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__O__scm_LazyBuilder(elem)
});
$c_scm_LazyBuilder.prototype.sizeHint__I__V = (function(size) {
  /*<skip>*/
});
$c_scm_LazyBuilder.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return this.$$plus$plus$eq__sc_TraversableOnce__scm_LazyBuilder(xs)
});
/** @constructor */
function $c_scm_LinkedHashMap$$anon$1() {
  $c_sc_AbstractIterator.call(this);
  this.cur$2 = null
}
$c_scm_LinkedHashMap$$anon$1.prototype = new $h_sc_AbstractIterator();
$c_scm_LinkedHashMap$$anon$1.prototype.constructor = $c_scm_LinkedHashMap$$anon$1;
/** @constructor */
function $h_scm_LinkedHashMap$$anon$1() {
  /*<skip>*/
}
$h_scm_LinkedHashMap$$anon$1.prototype = $c_scm_LinkedHashMap$$anon$1.prototype;
$c_scm_LinkedHashMap$$anon$1.prototype.next__O = (function() {
  return this.next__T2()
});
$c_scm_LinkedHashMap$$anon$1.prototype.next__T2 = (function() {
  if (this.hasNext__Z()) {
    var res = new $c_T2().init___O__O(this.cur$2.key$1, this.cur$2.value$1);
    this.cur$2 = this.cur$2.later$1;
    return res
  } else {
    return $as_T2($m_sc_Iterator$().empty$1.next__O())
  }
});
$c_scm_LinkedHashMap$$anon$1.prototype.hasNext__Z = (function() {
  return (this.cur$2 !== null)
});
$c_scm_LinkedHashMap$$anon$1.prototype.init___scm_LinkedHashMap = (function($$outer) {
  this.cur$2 = $$outer.firstEntry$5;
  return this
});
var $d_scm_LinkedHashMap$$anon$1 = new $TypeData().initClass({
  scm_LinkedHashMap$$anon$1: 0
}, false, "scala.collection.mutable.LinkedHashMap$$anon$1", {
  scm_LinkedHashMap$$anon$1: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_scm_LinkedHashMap$$anon$1.prototype.$classData = $d_scm_LinkedHashMap$$anon$1;
/** @constructor */
function $c_scm_LinkedHashMap$$anon$2() {
  $c_sc_AbstractIterator.call(this);
  this.cur$2 = null
}
$c_scm_LinkedHashMap$$anon$2.prototype = new $h_sc_AbstractIterator();
$c_scm_LinkedHashMap$$anon$2.prototype.constructor = $c_scm_LinkedHashMap$$anon$2;
/** @constructor */
function $h_scm_LinkedHashMap$$anon$2() {
  /*<skip>*/
}
$h_scm_LinkedHashMap$$anon$2.prototype = $c_scm_LinkedHashMap$$anon$2.prototype;
$c_scm_LinkedHashMap$$anon$2.prototype.next__O = (function() {
  if (this.hasNext__Z()) {
    var res = this.cur$2.key$1;
    this.cur$2 = this.cur$2.later$1;
    return res
  } else {
    return $m_sc_Iterator$().empty$1.next__O()
  }
});
$c_scm_LinkedHashMap$$anon$2.prototype.hasNext__Z = (function() {
  return (this.cur$2 !== null)
});
$c_scm_LinkedHashMap$$anon$2.prototype.init___scm_LinkedHashMap = (function($$outer) {
  this.cur$2 = $$outer.firstEntry$5;
  return this
});
var $d_scm_LinkedHashMap$$anon$2 = new $TypeData().initClass({
  scm_LinkedHashMap$$anon$2: 0
}, false, "scala.collection.mutable.LinkedHashMap$$anon$2", {
  scm_LinkedHashMap$$anon$2: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_scm_LinkedHashMap$$anon$2.prototype.$classData = $d_scm_LinkedHashMap$$anon$2;
/** @constructor */
function $c_scm_LinkedHashMap$$anon$3() {
  $c_sc_AbstractIterator.call(this);
  this.cur$2 = null
}
$c_scm_LinkedHashMap$$anon$3.prototype = new $h_sc_AbstractIterator();
$c_scm_LinkedHashMap$$anon$3.prototype.constructor = $c_scm_LinkedHashMap$$anon$3;
/** @constructor */
function $h_scm_LinkedHashMap$$anon$3() {
  /*<skip>*/
}
$h_scm_LinkedHashMap$$anon$3.prototype = $c_scm_LinkedHashMap$$anon$3.prototype;
$c_scm_LinkedHashMap$$anon$3.prototype.next__O = (function() {
  if (this.hasNext__Z()) {
    var res = this.cur$2.value$1;
    this.cur$2 = this.cur$2.later$1;
    return res
  } else {
    return $m_sc_Iterator$().empty$1.next__O()
  }
});
$c_scm_LinkedHashMap$$anon$3.prototype.hasNext__Z = (function() {
  return (this.cur$2 !== null)
});
$c_scm_LinkedHashMap$$anon$3.prototype.init___scm_LinkedHashMap = (function($$outer) {
  this.cur$2 = $$outer.firstEntry$5;
  return this
});
var $d_scm_LinkedHashMap$$anon$3 = new $TypeData().initClass({
  scm_LinkedHashMap$$anon$3: 0
}, false, "scala.collection.mutable.LinkedHashMap$$anon$3", {
  scm_LinkedHashMap$$anon$3: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_scm_LinkedHashMap$$anon$3.prototype.$classData = $d_scm_LinkedHashMap$$anon$3;
/** @constructor */
function $c_scm_LinkedHashSet$$anon$1() {
  $c_sc_AbstractIterator.call(this);
  this.cur$2 = null
}
$c_scm_LinkedHashSet$$anon$1.prototype = new $h_sc_AbstractIterator();
$c_scm_LinkedHashSet$$anon$1.prototype.constructor = $c_scm_LinkedHashSet$$anon$1;
/** @constructor */
function $h_scm_LinkedHashSet$$anon$1() {
  /*<skip>*/
}
$h_scm_LinkedHashSet$$anon$1.prototype = $c_scm_LinkedHashSet$$anon$1.prototype;
$c_scm_LinkedHashSet$$anon$1.prototype.next__O = (function() {
  if (this.hasNext__Z()) {
    var res = this.cur$2.key$1;
    this.cur$2 = this.cur$2.later$1;
    return res
  } else {
    return $m_sc_Iterator$().empty$1.next__O()
  }
});
$c_scm_LinkedHashSet$$anon$1.prototype.hasNext__Z = (function() {
  return (this.cur$2 !== null)
});
$c_scm_LinkedHashSet$$anon$1.prototype.init___scm_LinkedHashSet = (function($$outer) {
  this.cur$2 = $$outer.firstEntry$5;
  return this
});
var $d_scm_LinkedHashSet$$anon$1 = new $TypeData().initClass({
  scm_LinkedHashSet$$anon$1: 0
}, false, "scala.collection.mutable.LinkedHashSet$$anon$1", {
  scm_LinkedHashSet$$anon$1: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_scm_LinkedHashSet$$anon$1.prototype.$classData = $d_scm_LinkedHashSet$$anon$1;
/** @constructor */
function $c_scm_LinkedListLike$$anon$1() {
  $c_sc_AbstractIterator.call(this);
  this.elems$2 = null
}
$c_scm_LinkedListLike$$anon$1.prototype = new $h_sc_AbstractIterator();
$c_scm_LinkedListLike$$anon$1.prototype.constructor = $c_scm_LinkedListLike$$anon$1;
/** @constructor */
function $h_scm_LinkedListLike$$anon$1() {
  /*<skip>*/
}
$h_scm_LinkedListLike$$anon$1.prototype = $c_scm_LinkedListLike$$anon$1.prototype;
$c_scm_LinkedListLike$$anon$1.prototype.next__O = (function() {
  var res = this.elems$2.elem$5;
  var this$1 = this.elems$2;
  this.elems$2 = this$1.next$5;
  return res
});
$c_scm_LinkedListLike$$anon$1.prototype.hasNext__Z = (function() {
  var this$1 = this.elems$2;
  return $f_sc_TraversableOnce__nonEmpty__Z(this$1)
});
$c_scm_LinkedListLike$$anon$1.prototype.init___scm_LinkedListLike = (function($$outer) {
  this.elems$2 = $$outer;
  return this
});
var $d_scm_LinkedListLike$$anon$1 = new $TypeData().initClass({
  scm_LinkedListLike$$anon$1: 0
}, false, "scala.collection.mutable.LinkedListLike$$anon$1", {
  scm_LinkedListLike$$anon$1: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_scm_LinkedListLike$$anon$1.prototype.$classData = $d_scm_LinkedListLike$$anon$1;
/** @constructor */
function $c_scm_ListBuffer$$anon$1() {
  $c_sc_AbstractIterator.call(this);
  this.cursor$2 = null
}
$c_scm_ListBuffer$$anon$1.prototype = new $h_sc_AbstractIterator();
$c_scm_ListBuffer$$anon$1.prototype.constructor = $c_scm_ListBuffer$$anon$1;
/** @constructor */
function $h_scm_ListBuffer$$anon$1() {
  /*<skip>*/
}
$h_scm_ListBuffer$$anon$1.prototype = $c_scm_ListBuffer$$anon$1.prototype;
$c_scm_ListBuffer$$anon$1.prototype.next__O = (function() {
  if ((!this.hasNext__Z())) {
    throw new $c_ju_NoSuchElementException().init___T("next on empty Iterator")
  } else {
    var ans = this.cursor$2.head__O();
    this.cursor$2 = $as_sci_List(this.cursor$2.tail__O());
    return ans
  }
});
$c_scm_ListBuffer$$anon$1.prototype.init___scm_ListBuffer = (function($$outer) {
  this.cursor$2 = ($$outer.isEmpty__Z() ? $m_sci_Nil$() : $$outer.scala$collection$mutable$ListBuffer$$start$6);
  return this
});
$c_scm_ListBuffer$$anon$1.prototype.hasNext__Z = (function() {
  return (this.cursor$2 !== $m_sci_Nil$())
});
var $d_scm_ListBuffer$$anon$1 = new $TypeData().initClass({
  scm_ListBuffer$$anon$1: 0
}, false, "scala.collection.mutable.ListBuffer$$anon$1", {
  scm_ListBuffer$$anon$1: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_scm_ListBuffer$$anon$1.prototype.$classData = $d_scm_ListBuffer$$anon$1;
/** @constructor */
function $c_scm_MapBuilder() {
  $c_O.call(this);
  this.empty$1 = null;
  this.elems$1 = null
}
$c_scm_MapBuilder.prototype = new $h_O();
$c_scm_MapBuilder.prototype.constructor = $c_scm_MapBuilder;
/** @constructor */
function $h_scm_MapBuilder() {
  /*<skip>*/
}
$h_scm_MapBuilder.prototype = $c_scm_MapBuilder.prototype;
$c_scm_MapBuilder.prototype.$$plus$eq__T2__scm_MapBuilder = (function(x) {
  this.elems$1 = this.elems$1.$$plus__T2__sc_GenMap(x);
  return this
});
$c_scm_MapBuilder.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__T2__scm_MapBuilder($as_T2(elem))
});
$c_scm_MapBuilder.prototype.result__O = (function() {
  return this.elems$1
});
$c_scm_MapBuilder.prototype.sizeHintBounded__I__sc_TraversableLike__V = (function(size, boundingColl) {
  $f_scm_Builder__sizeHintBounded__I__sc_TraversableLike__V(this, size, boundingColl)
});
$c_scm_MapBuilder.prototype.init___sc_GenMap = (function(empty) {
  this.empty$1 = empty;
  this.elems$1 = empty;
  return this
});
$c_scm_MapBuilder.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__T2__scm_MapBuilder($as_T2(elem))
});
$c_scm_MapBuilder.prototype.sizeHint__I__V = (function(size) {
  /*<skip>*/
});
$c_scm_MapBuilder.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs)
});
var $d_scm_MapBuilder = new $TypeData().initClass({
  scm_MapBuilder: 0
}, false, "scala.collection.mutable.MapBuilder", {
  scm_MapBuilder: 1,
  O: 1,
  scm_ReusableBuilder: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1
});
$c_scm_MapBuilder.prototype.$classData = $d_scm_MapBuilder;
/** @constructor */
function $c_scm_MutableList$$anon$1() {
  $c_sc_AbstractIterator.call(this);
  this.elems$2 = null;
  this.count$2 = 0
}
$c_scm_MutableList$$anon$1.prototype = new $h_sc_AbstractIterator();
$c_scm_MutableList$$anon$1.prototype.constructor = $c_scm_MutableList$$anon$1;
/** @constructor */
function $h_scm_MutableList$$anon$1() {
  /*<skip>*/
}
$h_scm_MutableList$$anon$1.prototype = $c_scm_MutableList$$anon$1.prototype;
$c_scm_MutableList$$anon$1.prototype.next__O = (function() {
  if ((!this.hasNext__Z())) {
    throw new $c_ju_NoSuchElementException().init___()
  };
  this.count$2 = (((-1) + this.count$2) | 0);
  var e = this.elems$2.elem$5;
  if ((this.count$2 === 0)) {
    var jsx$1 = null
  } else {
    var this$1 = this.elems$2;
    var jsx$1 = this$1.next$5
  };
  this.elems$2 = jsx$1;
  return e
});
$c_scm_MutableList$$anon$1.prototype.init___scm_MutableList = (function($$outer) {
  this.elems$2 = $$outer.first0$5;
  this.count$2 = $$outer.len$5;
  return this
});
$c_scm_MutableList$$anon$1.prototype.hasNext__Z = (function() {
  if ((this.count$2 > 0)) {
    var this$1 = this.elems$2;
    return $f_sc_TraversableOnce__nonEmpty__Z(this$1)
  } else {
    return false
  }
});
var $d_scm_MutableList$$anon$1 = new $TypeData().initClass({
  scm_MutableList$$anon$1: 0
}, false, "scala.collection.mutable.MutableList$$anon$1", {
  scm_MutableList$$anon$1: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_scm_MutableList$$anon$1.prototype.$classData = $d_scm_MutableList$$anon$1;
/** @constructor */
function $c_scm_SetBuilder() {
  $c_O.call(this);
  this.empty$1 = null;
  this.elems$1 = null
}
$c_scm_SetBuilder.prototype = new $h_O();
$c_scm_SetBuilder.prototype.constructor = $c_scm_SetBuilder;
/** @constructor */
function $h_scm_SetBuilder() {
  /*<skip>*/
}
$h_scm_SetBuilder.prototype = $c_scm_SetBuilder.prototype;
$c_scm_SetBuilder.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__O__scm_SetBuilder(elem)
});
$c_scm_SetBuilder.prototype.result__O = (function() {
  return this.elems$1
});
$c_scm_SetBuilder.prototype.sizeHintBounded__I__sc_TraversableLike__V = (function(size, boundingColl) {
  $f_scm_Builder__sizeHintBounded__I__sc_TraversableLike__V(this, size, boundingColl)
});
$c_scm_SetBuilder.prototype.$$plus$eq__O__scm_SetBuilder = (function(x) {
  this.elems$1 = this.elems$1.$$plus__O__sc_Set(x);
  return this
});
$c_scm_SetBuilder.prototype.init___sc_Set = (function(empty) {
  this.empty$1 = empty;
  this.elems$1 = empty;
  return this
});
$c_scm_SetBuilder.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__O__scm_SetBuilder(elem)
});
$c_scm_SetBuilder.prototype.sizeHint__I__V = (function(size) {
  /*<skip>*/
});
$c_scm_SetBuilder.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs)
});
var $d_scm_SetBuilder = new $TypeData().initClass({
  scm_SetBuilder: 0
}, false, "scala.collection.mutable.SetBuilder", {
  scm_SetBuilder: 1,
  O: 1,
  scm_ReusableBuilder: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1
});
$c_scm_SetBuilder.prototype.$classData = $d_scm_SetBuilder;
/** @constructor */
function $c_scm_WrappedArrayBuilder() {
  $c_O.call(this);
  this.tag$1 = null;
  this.manifest$1 = null;
  this.elems$1 = null;
  this.capacity$1 = 0;
  this.size$1 = 0
}
$c_scm_WrappedArrayBuilder.prototype = new $h_O();
$c_scm_WrappedArrayBuilder.prototype.constructor = $c_scm_WrappedArrayBuilder;
/** @constructor */
function $h_scm_WrappedArrayBuilder() {
  /*<skip>*/
}
$h_scm_WrappedArrayBuilder.prototype = $c_scm_WrappedArrayBuilder.prototype;
$c_scm_WrappedArrayBuilder.prototype.init___s_reflect_ClassTag = (function(tag) {
  this.tag$1 = tag;
  this.manifest$1 = tag;
  this.capacity$1 = 0;
  this.size$1 = 0;
  return this
});
$c_scm_WrappedArrayBuilder.prototype.ensureSize__p1__I__V = (function(size) {
  if ((this.capacity$1 < size)) {
    var newsize = ((this.capacity$1 === 0) ? 16 : (this.capacity$1 << 1));
    while ((newsize < size)) {
      newsize = (newsize << 1)
    };
    this.resize__p1__I__V(newsize)
  }
});
$c_scm_WrappedArrayBuilder.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__O__scm_WrappedArrayBuilder(elem)
});
$c_scm_WrappedArrayBuilder.prototype.$$plus$eq__O__scm_WrappedArrayBuilder = (function(elem) {
  this.ensureSize__p1__I__V(((1 + this.size$1) | 0));
  this.elems$1.update__I__O__V(this.size$1, elem);
  this.size$1 = ((1 + this.size$1) | 0);
  return this
});
$c_scm_WrappedArrayBuilder.prototype.mkArray__p1__I__scm_WrappedArray = (function(size) {
  var runtimeClass = this.tag$1.runtimeClass__jl_Class();
  var newelems = ((runtimeClass === $d_B.getClassOf()) ? new $c_scm_WrappedArray$ofByte().init___AB($newArrayObject($d_B.getArrayOf(), [size])) : ((runtimeClass === $d_S.getClassOf()) ? new $c_scm_WrappedArray$ofShort().init___AS($newArrayObject($d_S.getArrayOf(), [size])) : ((runtimeClass === $d_C.getClassOf()) ? new $c_scm_WrappedArray$ofChar().init___AC($newArrayObject($d_C.getArrayOf(), [size])) : ((runtimeClass === $d_I.getClassOf()) ? new $c_scm_WrappedArray$ofInt().init___AI($newArrayObject($d_I.getArrayOf(), [size])) : ((runtimeClass === $d_J.getClassOf()) ? new $c_scm_WrappedArray$ofLong().init___AJ($newArrayObject($d_J.getArrayOf(), [size])) : ((runtimeClass === $d_F.getClassOf()) ? new $c_scm_WrappedArray$ofFloat().init___AF($newArrayObject($d_F.getArrayOf(), [size])) : ((runtimeClass === $d_D.getClassOf()) ? new $c_scm_WrappedArray$ofDouble().init___AD($newArrayObject($d_D.getArrayOf(), [size])) : ((runtimeClass === $d_Z.getClassOf()) ? new $c_scm_WrappedArray$ofBoolean().init___AZ($newArrayObject($d_Z.getArrayOf(), [size])) : ((runtimeClass === $d_V.getClassOf()) ? new $c_scm_WrappedArray$ofUnit().init___Asr_BoxedUnit($newArrayObject($d_sr_BoxedUnit.getArrayOf(), [size])) : new $c_scm_WrappedArray$ofRef().init___AO($asArrayOf_O(this.tag$1.newArray__I__O(size), 1)))))))))));
  if ((this.size$1 > 0)) {
    $m_s_Array$().copy__O__I__O__I__I__V(this.elems$1.array__O(), 0, newelems.array__O(), 0, this.size$1)
  };
  return newelems
});
$c_scm_WrappedArrayBuilder.prototype.result__O = (function() {
  return this.result__scm_WrappedArray()
});
$c_scm_WrappedArrayBuilder.prototype.sizeHintBounded__I__sc_TraversableLike__V = (function(size, boundingColl) {
  $f_scm_Builder__sizeHintBounded__I__sc_TraversableLike__V(this, size, boundingColl)
});
$c_scm_WrappedArrayBuilder.prototype.resize__p1__I__V = (function(size) {
  this.elems$1 = this.mkArray__p1__I__scm_WrappedArray(size);
  this.capacity$1 = size
});
$c_scm_WrappedArrayBuilder.prototype.result__scm_WrappedArray = (function() {
  if (((this.capacity$1 !== 0) && (this.capacity$1 === this.size$1))) {
    this.capacity$1 = 0;
    return this.elems$1
  } else {
    return this.mkArray__p1__I__scm_WrappedArray(this.size$1)
  }
});
$c_scm_WrappedArrayBuilder.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__O__scm_WrappedArrayBuilder(elem)
});
$c_scm_WrappedArrayBuilder.prototype.sizeHint__I__V = (function(size) {
  if ((this.capacity$1 < size)) {
    this.resize__p1__I__V(size)
  }
});
$c_scm_WrappedArrayBuilder.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs)
});
var $d_scm_WrappedArrayBuilder = new $TypeData().initClass({
  scm_WrappedArrayBuilder: 0
}, false, "scala.collection.mutable.WrappedArrayBuilder", {
  scm_WrappedArrayBuilder: 1,
  O: 1,
  scm_ReusableBuilder: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1
});
$c_scm_WrappedArrayBuilder.prototype.$classData = $d_scm_WrappedArrayBuilder;
/** @constructor */
function $c_sr_NonLocalReturnControl() {
  $c_jl_Throwable.call(this);
  this.key$2 = null;
  this.value$f = null
}
$c_sr_NonLocalReturnControl.prototype = new $h_jl_Throwable();
$c_sr_NonLocalReturnControl.prototype.constructor = $c_sr_NonLocalReturnControl;
/** @constructor */
function $h_sr_NonLocalReturnControl() {
  /*<skip>*/
}
$h_sr_NonLocalReturnControl.prototype = $c_sr_NonLocalReturnControl.prototype;
$c_sr_NonLocalReturnControl.prototype.fillInStackTrace__jl_Throwable = (function() {
  return this
});
$c_sr_NonLocalReturnControl.prototype.value__O = (function() {
  return this.value$f
});
$c_sr_NonLocalReturnControl.prototype.value$mcV$sp__V = (function() {
  this.value__O()
});
$c_sr_NonLocalReturnControl.prototype.init___O__O = (function(key, value) {
  this.key$2 = key;
  this.value$f = value;
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
$c_sr_NonLocalReturnControl.prototype.value$mcZ$sp__Z = (function() {
  return $uZ(this.value__O())
});
function $as_sr_NonLocalReturnControl(obj) {
  return (((obj instanceof $c_sr_NonLocalReturnControl) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.runtime.NonLocalReturnControl"))
}
function $isArrayOf_sr_NonLocalReturnControl(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sr_NonLocalReturnControl)))
}
function $asArrayOf_sr_NonLocalReturnControl(obj, depth) {
  return (($isArrayOf_sr_NonLocalReturnControl(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.runtime.NonLocalReturnControl;", depth))
}
var $d_sr_NonLocalReturnControl = new $TypeData().initClass({
  sr_NonLocalReturnControl: 0
}, false, "scala.runtime.NonLocalReturnControl", {
  sr_NonLocalReturnControl: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  s_util_control_ControlThrowable: 1,
  s_util_control_NoStackTrace: 1
});
$c_sr_NonLocalReturnControl.prototype.$classData = $d_sr_NonLocalReturnControl;
/** @constructor */
function $c_sr_ScalaRunTime$$anon$1() {
  $c_sc_AbstractIterator.call(this);
  this.c$2 = 0;
  this.cmax$2 = 0;
  this.x$2$2 = null
}
$c_sr_ScalaRunTime$$anon$1.prototype = new $h_sc_AbstractIterator();
$c_sr_ScalaRunTime$$anon$1.prototype.constructor = $c_sr_ScalaRunTime$$anon$1;
/** @constructor */
function $h_sr_ScalaRunTime$$anon$1() {
  /*<skip>*/
}
$h_sr_ScalaRunTime$$anon$1.prototype = $c_sr_ScalaRunTime$$anon$1.prototype;
$c_sr_ScalaRunTime$$anon$1.prototype.next__O = (function() {
  var result = this.x$2$2.productElement__I__O(this.c$2);
  this.c$2 = ((1 + this.c$2) | 0);
  return result
});
$c_sr_ScalaRunTime$$anon$1.prototype.init___s_Product = (function(x$2) {
  this.x$2$2 = x$2;
  this.c$2 = 0;
  this.cmax$2 = x$2.productArity__I();
  return this
});
$c_sr_ScalaRunTime$$anon$1.prototype.hasNext__Z = (function() {
  return (this.c$2 < this.cmax$2)
});
var $d_sr_ScalaRunTime$$anon$1 = new $TypeData().initClass({
  sr_ScalaRunTime$$anon$1: 0
}, false, "scala.runtime.ScalaRunTime$$anon$1", {
  sr_ScalaRunTime$$anon$1: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sr_ScalaRunTime$$anon$1.prototype.$classData = $d_sr_ScalaRunTime$$anon$1;
/** @constructor */
function $c_Lamf_AmfProfile$() {
  $c_Lamf_ProfileName.call(this)
}
$c_Lamf_AmfProfile$.prototype = new $h_Lamf_ProfileName();
$c_Lamf_AmfProfile$.prototype.constructor = $c_Lamf_AmfProfile$;
/** @constructor */
function $h_Lamf_AmfProfile$() {
  /*<skip>*/
}
$h_Lamf_AmfProfile$.prototype = $c_Lamf_AmfProfile$.prototype;
$c_Lamf_AmfProfile$.prototype.init___ = (function() {
  var profile = $m_Lamf_core_remote_Amf$().name$1;
  $c_Lamf_ProfileName.prototype.init___T__Lamf_MessageStyle.call(this, profile, $m_Lamf_AMFStyle$());
  return this
});
var $d_Lamf_AmfProfile$ = new $TypeData().initClass({
  Lamf_AmfProfile$: 0
}, false, "amf.AmfProfile$", {
  Lamf_AmfProfile$: 1,
  Lamf_ProfileName: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_AmfProfile$.prototype.$classData = $d_Lamf_AmfProfile$;
var $n_Lamf_AmfProfile$ = (void 0);
function $m_Lamf_AmfProfile$() {
  if ((!$n_Lamf_AmfProfile$)) {
    $n_Lamf_AmfProfile$ = new $c_Lamf_AmfProfile$().init___()
  };
  return $n_Lamf_AmfProfile$
}
/** @constructor */
function $c_Lamf_AmlProfile$() {
  $c_Lamf_ProfileName.call(this)
}
$c_Lamf_AmlProfile$.prototype = new $h_Lamf_ProfileName();
$c_Lamf_AmlProfile$.prototype.constructor = $c_Lamf_AmlProfile$;
/** @constructor */
function $h_Lamf_AmlProfile$() {
  /*<skip>*/
}
$h_Lamf_AmlProfile$.prototype = $c_Lamf_AmlProfile$.prototype;
$c_Lamf_AmlProfile$.prototype.init___ = (function() {
  var profile = $m_Lamf_core_remote_Aml$().name$1;
  $c_Lamf_ProfileName.prototype.init___T__Lamf_MessageStyle.call(this, profile, $m_Lamf_AMFStyle$());
  return this
});
var $d_Lamf_AmlProfile$ = new $TypeData().initClass({
  Lamf_AmlProfile$: 0
}, false, "amf.AmlProfile$", {
  Lamf_AmlProfile$: 1,
  Lamf_ProfileName: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_AmlProfile$.prototype.$classData = $d_Lamf_AmlProfile$;
var $n_Lamf_AmlProfile$ = (void 0);
function $m_Lamf_AmlProfile$() {
  if ((!$n_Lamf_AmlProfile$)) {
    $n_Lamf_AmlProfile$ = new $c_Lamf_AmlProfile$().init___()
  };
  return $n_Lamf_AmlProfile$
}
/** @constructor */
function $c_Lamf_Async20Profile$() {
  $c_Lamf_ProfileName.call(this)
}
$c_Lamf_Async20Profile$.prototype = new $h_Lamf_ProfileName();
$c_Lamf_Async20Profile$.prototype.constructor = $c_Lamf_Async20Profile$;
/** @constructor */
function $h_Lamf_Async20Profile$() {
  /*<skip>*/
}
$h_Lamf_Async20Profile$.prototype = $c_Lamf_Async20Profile$.prototype;
$c_Lamf_Async20Profile$.prototype.init___ = (function() {
  $c_Lamf_ProfileName.prototype.init___T__Lamf_MessageStyle.call(this, $m_Lamf_core_remote_AsyncApi20$().name$1, $m_Lamf_OASStyle$());
  return this
});
var $d_Lamf_Async20Profile$ = new $TypeData().initClass({
  Lamf_Async20Profile$: 0
}, false, "amf.Async20Profile$", {
  Lamf_Async20Profile$: 1,
  Lamf_ProfileName: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_Async20Profile$.prototype.$classData = $d_Lamf_Async20Profile$;
var $n_Lamf_Async20Profile$ = (void 0);
function $m_Lamf_Async20Profile$() {
  if ((!$n_Lamf_Async20Profile$)) {
    $n_Lamf_Async20Profile$ = new $c_Lamf_Async20Profile$().init___()
  };
  return $n_Lamf_Async20Profile$
}
/** @constructor */
function $c_Lamf_AsyncProfile$() {
  $c_Lamf_ProfileName.call(this)
}
$c_Lamf_AsyncProfile$.prototype = new $h_Lamf_ProfileName();
$c_Lamf_AsyncProfile$.prototype.constructor = $c_Lamf_AsyncProfile$;
/** @constructor */
function $h_Lamf_AsyncProfile$() {
  /*<skip>*/
}
$h_Lamf_AsyncProfile$.prototype = $c_Lamf_AsyncProfile$.prototype;
$c_Lamf_AsyncProfile$.prototype.init___ = (function() {
  $c_Lamf_ProfileName.prototype.init___T__Lamf_MessageStyle.call(this, $m_Lamf_core_remote_AsyncApi$().name$1, $m_Lamf_OASStyle$());
  return this
});
var $d_Lamf_AsyncProfile$ = new $TypeData().initClass({
  Lamf_AsyncProfile$: 0
}, false, "amf.AsyncProfile$", {
  Lamf_AsyncProfile$: 1,
  Lamf_ProfileName: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_AsyncProfile$.prototype.$classData = $d_Lamf_AsyncProfile$;
var $n_Lamf_AsyncProfile$ = (void 0);
function $m_Lamf_AsyncProfile$() {
  if ((!$n_Lamf_AsyncProfile$)) {
    $n_Lamf_AsyncProfile$ = new $c_Lamf_AsyncProfile$().init___()
  };
  return $n_Lamf_AsyncProfile$
}
/** @constructor */
function $c_Lamf_Oas20Profile$() {
  $c_Lamf_ProfileName.call(this)
}
$c_Lamf_Oas20Profile$.prototype = new $h_Lamf_ProfileName();
$c_Lamf_Oas20Profile$.prototype.constructor = $c_Lamf_Oas20Profile$;
/** @constructor */
function $h_Lamf_Oas20Profile$() {
  /*<skip>*/
}
$h_Lamf_Oas20Profile$.prototype = $c_Lamf_Oas20Profile$.prototype;
$c_Lamf_Oas20Profile$.prototype.init___ = (function() {
  $c_Lamf_ProfileName.prototype.init___T__Lamf_MessageStyle.call(this, $m_Lamf_core_remote_Oas20$().name$1, $m_Lamf_OASStyle$());
  return this
});
var $d_Lamf_Oas20Profile$ = new $TypeData().initClass({
  Lamf_Oas20Profile$: 0
}, false, "amf.Oas20Profile$", {
  Lamf_Oas20Profile$: 1,
  Lamf_ProfileName: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_Oas20Profile$.prototype.$classData = $d_Lamf_Oas20Profile$;
var $n_Lamf_Oas20Profile$ = (void 0);
function $m_Lamf_Oas20Profile$() {
  if ((!$n_Lamf_Oas20Profile$)) {
    $n_Lamf_Oas20Profile$ = new $c_Lamf_Oas20Profile$().init___()
  };
  return $n_Lamf_Oas20Profile$
}
/** @constructor */
function $c_Lamf_Oas30Profile$() {
  $c_Lamf_ProfileName.call(this)
}
$c_Lamf_Oas30Profile$.prototype = new $h_Lamf_ProfileName();
$c_Lamf_Oas30Profile$.prototype.constructor = $c_Lamf_Oas30Profile$;
/** @constructor */
function $h_Lamf_Oas30Profile$() {
  /*<skip>*/
}
$h_Lamf_Oas30Profile$.prototype = $c_Lamf_Oas30Profile$.prototype;
$c_Lamf_Oas30Profile$.prototype.init___ = (function() {
  $c_Lamf_ProfileName.prototype.init___T__Lamf_MessageStyle.call(this, $m_Lamf_core_remote_Oas30$().name$1, $m_Lamf_OASStyle$());
  return this
});
var $d_Lamf_Oas30Profile$ = new $TypeData().initClass({
  Lamf_Oas30Profile$: 0
}, false, "amf.Oas30Profile$", {
  Lamf_Oas30Profile$: 1,
  Lamf_ProfileName: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_Oas30Profile$.prototype.$classData = $d_Lamf_Oas30Profile$;
var $n_Lamf_Oas30Profile$ = (void 0);
function $m_Lamf_Oas30Profile$() {
  if ((!$n_Lamf_Oas30Profile$)) {
    $n_Lamf_Oas30Profile$ = new $c_Lamf_Oas30Profile$().init___()
  };
  return $n_Lamf_Oas30Profile$
}
/** @constructor */
function $c_Lamf_OasProfile$() {
  $c_Lamf_ProfileName.call(this)
}
$c_Lamf_OasProfile$.prototype = new $h_Lamf_ProfileName();
$c_Lamf_OasProfile$.prototype.constructor = $c_Lamf_OasProfile$;
/** @constructor */
function $h_Lamf_OasProfile$() {
  /*<skip>*/
}
$h_Lamf_OasProfile$.prototype = $c_Lamf_OasProfile$.prototype;
$c_Lamf_OasProfile$.prototype.init___ = (function() {
  $c_Lamf_ProfileName.prototype.init___T__Lamf_MessageStyle.call(this, $m_Lamf_core_remote_Oas$().name$1, $m_Lamf_OASStyle$());
  return this
});
var $d_Lamf_OasProfile$ = new $TypeData().initClass({
  Lamf_OasProfile$: 0
}, false, "amf.OasProfile$", {
  Lamf_OasProfile$: 1,
  Lamf_ProfileName: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_OasProfile$.prototype.$classData = $d_Lamf_OasProfile$;
var $n_Lamf_OasProfile$ = (void 0);
function $m_Lamf_OasProfile$() {
  if ((!$n_Lamf_OasProfile$)) {
    $n_Lamf_OasProfile$ = new $c_Lamf_OasProfile$().init___()
  };
  return $n_Lamf_OasProfile$
}
/** @constructor */
function $c_Lamf_PayloadProfile$() {
  $c_Lamf_ProfileName.call(this)
}
$c_Lamf_PayloadProfile$.prototype = new $h_Lamf_ProfileName();
$c_Lamf_PayloadProfile$.prototype.constructor = $c_Lamf_PayloadProfile$;
/** @constructor */
function $h_Lamf_PayloadProfile$() {
  /*<skip>*/
}
$h_Lamf_PayloadProfile$.prototype = $c_Lamf_PayloadProfile$.prototype;
$c_Lamf_PayloadProfile$.prototype.init___ = (function() {
  var profile = $m_Lamf_core_remote_Payload$().name$1;
  $c_Lamf_ProfileName.prototype.init___T__Lamf_MessageStyle.call(this, profile, $m_Lamf_AMFStyle$());
  return this
});
var $d_Lamf_PayloadProfile$ = new $TypeData().initClass({
  Lamf_PayloadProfile$: 0
}, false, "amf.PayloadProfile$", {
  Lamf_PayloadProfile$: 1,
  Lamf_ProfileName: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_PayloadProfile$.prototype.$classData = $d_Lamf_PayloadProfile$;
var $n_Lamf_PayloadProfile$ = (void 0);
function $m_Lamf_PayloadProfile$() {
  if ((!$n_Lamf_PayloadProfile$)) {
    $n_Lamf_PayloadProfile$ = new $c_Lamf_PayloadProfile$().init___()
  };
  return $n_Lamf_PayloadProfile$
}
/** @constructor */
function $c_Lamf_Raml08Profile$() {
  $c_Lamf_ProfileName.call(this)
}
$c_Lamf_Raml08Profile$.prototype = new $h_Lamf_ProfileName();
$c_Lamf_Raml08Profile$.prototype.constructor = $c_Lamf_Raml08Profile$;
/** @constructor */
function $h_Lamf_Raml08Profile$() {
  /*<skip>*/
}
$h_Lamf_Raml08Profile$.prototype = $c_Lamf_Raml08Profile$.prototype;
$c_Lamf_Raml08Profile$.prototype.init___ = (function() {
  $c_Lamf_ProfileName.prototype.init___T__Lamf_MessageStyle.call(this, $m_Lamf_core_remote_Raml08$().name$1, $m_Lamf_RAMLStyle$());
  return this
});
var $d_Lamf_Raml08Profile$ = new $TypeData().initClass({
  Lamf_Raml08Profile$: 0
}, false, "amf.Raml08Profile$", {
  Lamf_Raml08Profile$: 1,
  Lamf_ProfileName: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_Raml08Profile$.prototype.$classData = $d_Lamf_Raml08Profile$;
var $n_Lamf_Raml08Profile$ = (void 0);
function $m_Lamf_Raml08Profile$() {
  if ((!$n_Lamf_Raml08Profile$)) {
    $n_Lamf_Raml08Profile$ = new $c_Lamf_Raml08Profile$().init___()
  };
  return $n_Lamf_Raml08Profile$
}
/** @constructor */
function $c_Lamf_Raml10Profile$() {
  $c_Lamf_ProfileName.call(this)
}
$c_Lamf_Raml10Profile$.prototype = new $h_Lamf_ProfileName();
$c_Lamf_Raml10Profile$.prototype.constructor = $c_Lamf_Raml10Profile$;
/** @constructor */
function $h_Lamf_Raml10Profile$() {
  /*<skip>*/
}
$h_Lamf_Raml10Profile$.prototype = $c_Lamf_Raml10Profile$.prototype;
$c_Lamf_Raml10Profile$.prototype.init___ = (function() {
  $c_Lamf_ProfileName.prototype.init___T__Lamf_MessageStyle.call(this, $m_Lamf_core_remote_Raml10$().name$1, $m_Lamf_RAMLStyle$());
  return this
});
var $d_Lamf_Raml10Profile$ = new $TypeData().initClass({
  Lamf_Raml10Profile$: 0
}, false, "amf.Raml10Profile$", {
  Lamf_Raml10Profile$: 1,
  Lamf_ProfileName: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_Raml10Profile$.prototype.$classData = $d_Lamf_Raml10Profile$;
var $n_Lamf_Raml10Profile$ = (void 0);
function $m_Lamf_Raml10Profile$() {
  if ((!$n_Lamf_Raml10Profile$)) {
    $n_Lamf_Raml10Profile$ = new $c_Lamf_Raml10Profile$().init___()
  };
  return $n_Lamf_Raml10Profile$
}
/** @constructor */
function $c_Lamf_RamlProfile$() {
  $c_Lamf_ProfileName.call(this)
}
$c_Lamf_RamlProfile$.prototype = new $h_Lamf_ProfileName();
$c_Lamf_RamlProfile$.prototype.constructor = $c_Lamf_RamlProfile$;
/** @constructor */
function $h_Lamf_RamlProfile$() {
  /*<skip>*/
}
$h_Lamf_RamlProfile$.prototype = $c_Lamf_RamlProfile$.prototype;
$c_Lamf_RamlProfile$.prototype.init___ = (function() {
  $c_Lamf_ProfileName.prototype.init___T__Lamf_MessageStyle.call(this, $m_Lamf_core_remote_Raml$().name$1, $m_Lamf_RAMLStyle$());
  return this
});
var $d_Lamf_RamlProfile$ = new $TypeData().initClass({
  Lamf_RamlProfile$: 0
}, false, "amf.RamlProfile$", {
  Lamf_RamlProfile$: 1,
  Lamf_ProfileName: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_RamlProfile$.prototype.$classData = $d_Lamf_RamlProfile$;
var $n_Lamf_RamlProfile$ = (void 0);
function $m_Lamf_RamlProfile$() {
  if ((!$n_Lamf_RamlProfile$)) {
    $n_Lamf_RamlProfile$ = new $c_Lamf_RamlProfile$().init___()
  };
  return $n_Lamf_RamlProfile$
}
/** @constructor */
function $c_Lamf_client_environment_Environment() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.amf$client$environment$Environment$$exec$1 = null;
  this.executionContext$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_environment_Environment.prototype = new $h_O();
$c_Lamf_client_environment_Environment.prototype.constructor = $c_Lamf_client_environment_Environment;
/** @constructor */
function $h_Lamf_client_environment_Environment() {
  /*<skip>*/
}
$h_Lamf_client_environment_Environment.prototype = $c_Lamf_client_environment_Environment.prototype;
$c_Lamf_client_environment_Environment.prototype.init___ = (function() {
  $c_Lamf_client_environment_Environment.prototype.init___Lamf_internal_environment_Environment__s_Option.call(this, ($m_Lamf_internal_environment_Environment$(), new $c_Lamf_internal_environment_Environment().init___sc_Seq__s_Option__s_Option($m_sci_Nil$(), $m_s_None$(), $m_s_None$())), $m_s_None$());
  return this
});
$c_Lamf_client_environment_Environment.prototype.productPrefix__T = (function() {
  return "Environment"
});
$c_Lamf_client_environment_Environment.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_client_environment_Environment.prototype.withResolver__Lamf_client_reference_ClientReferenceResolver__Lamf_client_environment_Environment = (function(resolver) {
  var jsx$1 = this.$$undinternal$1;
  $m_Lamf_client_convert_CoreClientConverters$().ReferenceResolverMatcher__Lamf_client_convert_ReferenceResolverConverter$ReferenceResolverMatcher$();
  var from = $as_Lamf_client_reference_ReferenceResolver(resolver);
  var executionContext = this.executionContext$1;
  var _internal = jsx$1.withResolver__Lamf_internal_reference_ReferenceResolver__Lamf_internal_environment_Environment(new $c_Lamf_internal_reference_ReferenceResolverAdapter().init___Lamf_client_reference_ReferenceResolver__s_concurrent_ExecutionContext(from, executionContext));
  var exec = this.amf$client$environment$Environment$$exec$1;
  return new $c_Lamf_client_environment_Environment().init___Lamf_internal_environment_Environment__s_Option(_internal, exec)
});
$c_Lamf_client_environment_Environment.prototype.init___Lamf_internal_environment_Environment__s_Option = (function(_internal, exec) {
  this.$$undinternal$1 = _internal;
  this.amf$client$environment$Environment$$exec$1 = exec;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  var this$2 = this.executionEnvironment__Lamf_client_execution_BaseExecutionEnvironment();
  this.executionContext$1 = this$2.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  return this
});
$c_Lamf_client_environment_Environment.prototype.$$js$exported$meth$withLoaders__sjs_js_Array__O = (function(loaders) {
  return this.withLoaders__sjs_js_Array__Lamf_client_environment_Environment(loaders)
});
$c_Lamf_client_environment_Environment.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_environment_Environment)) {
    var Environment$1 = $as_Lamf_client_environment_Environment(x$1);
    var x = this.$$undinternal$1;
    var x$2 = Environment$1.$$undinternal$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.amf$client$environment$Environment$$exec$1;
      var x$4 = Environment$1.amf$client$environment$Environment$$exec$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_client_environment_Environment.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    case 1: {
      return this.amf$client$environment$Environment$$exec$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_environment_Environment.prototype.init___Lamf_client_execution_BaseExecutionEnvironment = (function(execEnv) {
  $c_Lamf_client_environment_Environment.prototype.init___Lamf_internal_environment_Environment__s_Option.call(this, ($m_Lamf_internal_environment_Environment$(), new $c_Lamf_internal_environment_Environment().init___sc_Seq__s_Option__s_Option($m_sci_Nil$(), $m_s_None$(), $m_s_None$())), new $c_s_Some().init___O(execEnv));
  return this
});
$c_Lamf_client_environment_Environment.prototype.init___Lamf_internal_environment_Environment = (function(internal) {
  $c_Lamf_client_environment_Environment.prototype.init___Lamf_internal_environment_Environment__s_Option.call(this, internal, $m_s_None$());
  return this
});
$c_Lamf_client_environment_Environment.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_environment_Environment.prototype.$$js$exported$prop$loaders__O = (function() {
  return this.loaders__sjs_js_Array()
});
$c_Lamf_client_environment_Environment.prototype.$$js$exported$prop$reference__O = (function() {
  return this.reference__sjs_js_UndefOr()
});
$c_Lamf_client_environment_Environment.prototype.withClientResolver__Lamf_client_reference_ClientReferenceResolver__Lamf_client_environment_Environment = (function(resolver) {
  var r = new $c_Lamf_client_environment_Environment$$anon$2().init___Lamf_client_environment_Environment__Lamf_client_reference_ClientReferenceResolver(this, resolver);
  var jsx$1 = this.$$undinternal$1;
  $m_Lamf_client_convert_CoreClientConverters$().ReferenceResolverMatcher__Lamf_client_convert_ReferenceResolverConverter$ReferenceResolverMatcher$();
  var executionContext = this.executionContext$1;
  var _internal = jsx$1.withResolver__Lamf_internal_reference_ReferenceResolver__Lamf_internal_environment_Environment(new $c_Lamf_internal_reference_ReferenceResolverAdapter().init___Lamf_client_reference_ReferenceResolver__s_concurrent_ExecutionContext(r, executionContext));
  var exec = this.amf$client$environment$Environment$$exec$1;
  return new $c_Lamf_client_environment_Environment().init___Lamf_internal_environment_Environment__s_Option(_internal, exec)
});
$c_Lamf_client_environment_Environment.prototype.setMaxYamlReferences__J__Lamf_client_environment_Environment = (function(value) {
  var $int = this.$$undinternal$1.setMaxYamlReferences__J__Lamf_internal_environment_Environment(value);
  return new $c_Lamf_client_environment_Environment().init___Lamf_internal_environment_Environment($int)
});
$c_Lamf_client_environment_Environment.prototype.loaders__sjs_js_Array = (function() {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal$1.loaders$1;
  var m = $m_Lamf_client_convert_CoreClientConverters$().ResourceLoaderMatcher__Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$();
  var executionContext = this.executionContext$1;
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOpsWithEC().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcherWithEC__s_concurrent_ExecutionContext(this$1, from, m, executionContext).asClient__O()
});
$c_Lamf_client_environment_Environment.prototype.$$js$exported$meth$add__Lamf_client_resource_ClientResourceLoader__O = (function(loader) {
  return this.add__Lamf_client_resource_ClientResourceLoader__Lamf_client_environment_Environment(loader)
});
$c_Lamf_client_environment_Environment.prototype.$$js$exported$meth$setMaxYamlReferences__J__O = (function(value) {
  return this.setMaxYamlReferences__J__Lamf_client_environment_Environment(value)
});
$c_Lamf_client_environment_Environment.prototype.add__Lamf_client_resource_ClientResourceLoader__Lamf_client_environment_Environment = (function(loader) {
  var jsx$1 = this.$$undinternal$1;
  $m_Lamf_client_convert_CoreClientConverters$().ResourceLoaderMatcher__Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$();
  var from = $as_Lamf_client_resource_ResourceLoader(loader);
  var executionContext = this.executionContext$1;
  var _internal = jsx$1.add__Lamf_internal_resource_ResourceLoader__Lamf_internal_environment_Environment(new $c_Lamf_internal_resource_ResourceLoaderAdapter().init___Lamf_client_resource_ResourceLoader__s_concurrent_ExecutionContext(from, executionContext));
  var exec = this.amf$client$environment$Environment$$exec$1;
  return new $c_Lamf_client_environment_Environment().init___Lamf_internal_environment_Environment__s_Option(_internal, exec)
});
$c_Lamf_client_environment_Environment.prototype.executionEnvironment__Lamf_client_execution_BaseExecutionEnvironment = (function() {
  var this$1 = this.amf$client$environment$Environment$$exec$1;
  if (this$1.isEmpty__Z()) {
    var this$2 = this.platform$1;
    var jsx$1 = this$2.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment()
  } else {
    var jsx$1 = this$1.get__O()
  };
  return $as_Lamf_client_execution_BaseExecutionEnvironment(jsx$1)
});
$c_Lamf_client_environment_Environment.prototype.reference__sjs_js_UndefOr = (function() {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal$1.resolver$1;
  var m = $m_Lamf_client_convert_CoreClientConverters$().ReferenceResolverMatcher__Lamf_client_convert_ReferenceResolverConverter$ReferenceResolverMatcher$();
  var executionContext = this.executionContext$1;
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOpsWithEC().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcherWithEC__s_concurrent_ExecutionContext(this$1, from, m, executionContext).asClient__O()
});
$c_Lamf_client_environment_Environment.prototype.$$js$exported$meth$addClientLoader__Lamf_client_resource_ClientResourceLoader__O = (function(loader) {
  return this.addClientLoader__Lamf_client_resource_ClientResourceLoader__Lamf_client_environment_Environment(loader)
});
$c_Lamf_client_environment_Environment.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_environment_Environment.prototype.$$js$exported$meth$withResolver__Lamf_client_reference_ClientReferenceResolver__O = (function(resolver) {
  return this.withResolver__Lamf_client_reference_ClientReferenceResolver__Lamf_client_environment_Environment(resolver)
});
$c_Lamf_client_environment_Environment.prototype.$$js$exported$prop$executionEnvironment__O = (function() {
  return this.executionEnvironment__Lamf_client_execution_BaseExecutionEnvironment()
});
$c_Lamf_client_environment_Environment.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_environment_Environment.prototype.withLoaders__sjs_js_Array__Lamf_client_environment_Environment = (function(loaders) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var m = $m_Lamf_client_convert_CoreClientConverters$().ResourceLoaderMatcher__Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$();
  var executionContext = this.executionContext$1;
  var loaders$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOpsWithEC().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcherWithEC__s_concurrent_ExecutionContext(this$1, loaders, m, executionContext).asInternal__sc_Seq();
  var _internal = new $c_Lamf_internal_environment_Environment().init___sc_Seq__s_Option__s_Option(loaders$1, this$2.resolver$1, this$2.maxYamlReferences$1);
  var exec = this.amf$client$environment$Environment$$exec$1;
  return new $c_Lamf_client_environment_Environment().init___Lamf_internal_environment_Environment__s_Option(_internal, exec)
});
$c_Lamf_client_environment_Environment.prototype.addClientLoader__Lamf_client_resource_ClientResourceLoader__Lamf_client_environment_Environment = (function(loader) {
  var l = new $c_Lamf_client_environment_Environment$$anon$1().init___Lamf_client_environment_Environment__Lamf_client_resource_ClientResourceLoader(this, loader);
  var jsx$1 = this.$$undinternal$1;
  $m_Lamf_client_convert_CoreClientConverters$().ResourceLoaderMatcher__Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$();
  var executionContext = this.executionContext$1;
  var _internal = jsx$1.add__Lamf_internal_resource_ResourceLoader__Lamf_internal_environment_Environment(new $c_Lamf_internal_resource_ResourceLoaderAdapter().init___Lamf_client_resource_ResourceLoader__s_concurrent_ExecutionContext(l, executionContext));
  var exec = this.amf$client$environment$Environment$$exec$1;
  return new $c_Lamf_client_environment_Environment().init___Lamf_internal_environment_Environment__s_Option(_internal, exec)
});
$c_Lamf_client_environment_Environment.prototype.$$js$exported$meth$withClientResolver__Lamf_client_reference_ClientReferenceResolver__O = (function(resolver) {
  return this.withClientResolver__Lamf_client_reference_ClientReferenceResolver__Lamf_client_environment_Environment(resolver)
});
$c_Lamf_client_environment_Environment.prototype.setMaxYamlReferences = (function(arg) {
  var prep = $uJ(arg);
  return this.$$js$exported$meth$setMaxYamlReferences__J__O(prep)
});
$c_Lamf_client_environment_Environment.prototype.withResolver = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withResolver__Lamf_client_reference_ClientReferenceResolver__O(prep)
});
$c_Lamf_client_environment_Environment.prototype.withLoaders = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withLoaders__sjs_js_Array__O(prep)
});
$c_Lamf_client_environment_Environment.prototype.add = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$add__Lamf_client_resource_ClientResourceLoader__O(prep)
});
$c_Lamf_client_environment_Environment.prototype.withClientResolver = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withClientResolver__Lamf_client_reference_ClientReferenceResolver__O(prep)
});
$c_Lamf_client_environment_Environment.prototype.addClientLoader = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$addClientLoader__Lamf_client_resource_ClientResourceLoader__O(prep)
});
Object.defineProperty($c_Lamf_client_environment_Environment.prototype, "executionEnvironment", {
  "get": (function() {
    return this.$$js$exported$prop$executionEnvironment__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_environment_Environment.prototype, "reference", {
  "get": (function() {
    return this.$$js$exported$prop$reference__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_environment_Environment.prototype, "loaders", {
  "get": (function() {
    return this.$$js$exported$prop$loaders__O()
  }),
  "configurable": true
});
function $as_Lamf_client_environment_Environment(obj) {
  return (((obj instanceof $c_Lamf_client_environment_Environment) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.environment.Environment"))
}
function $isArrayOf_Lamf_client_environment_Environment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_environment_Environment)))
}
function $asArrayOf_Lamf_client_environment_Environment(obj, depth) {
  return (($isArrayOf_Lamf_client_environment_Environment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.environment.Environment;", depth))
}
var $d_Lamf_client_environment_Environment = new $TypeData().initClass({
  Lamf_client_environment_Environment: 0
}, false, "amf.client.environment.Environment", {
  Lamf_client_environment_Environment: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_environment_Environment.prototype.$classData = $d_Lamf_client_environment_Environment;
/** @constructor */
function $c_Lamf_client_execution_ExecutionEnvironment() {
  $c_Lamf_client_execution_BaseExecutionEnvironment.call(this)
}
$c_Lamf_client_execution_ExecutionEnvironment.prototype = new $h_Lamf_client_execution_BaseExecutionEnvironment();
$c_Lamf_client_execution_ExecutionEnvironment.prototype.constructor = $c_Lamf_client_execution_ExecutionEnvironment;
/** @constructor */
function $h_Lamf_client_execution_ExecutionEnvironment() {
  /*<skip>*/
}
$h_Lamf_client_execution_ExecutionEnvironment.prototype = $c_Lamf_client_execution_ExecutionEnvironment.prototype;
$c_Lamf_client_execution_ExecutionEnvironment.prototype.init___ = (function() {
  var context = $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext();
  $c_Lamf_client_execution_ExecutionEnvironment.prototype.init___Lamf_core_execution_ExecutionEnvironment.call(this, new $c_Lamf_core_execution_ExecutionEnvironment().init___s_concurrent_ExecutionContext(context));
  return this
});
$c_Lamf_client_execution_ExecutionEnvironment.prototype.productPrefix__T = (function() {
  return "ExecutionEnvironment"
});
$c_Lamf_client_execution_ExecutionEnvironment.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_execution_ExecutionEnvironment.prototype.$$undinternal__Lamf_core_execution_ExecutionEnvironment = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_execution_ExecutionEnvironment.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_execution_ExecutionEnvironment)) {
    var ExecutionEnvironment$1 = $as_Lamf_client_execution_ExecutionEnvironment(x$1);
    var x = this.$$undinternal$1;
    var x$2 = ExecutionEnvironment$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_execution_ExecutionEnvironment.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_execution_ExecutionEnvironment.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_execution_ExecutionEnvironment.prototype.init___Lamf_core_execution_ExecutionEnvironment = (function(_internal) {
  $c_Lamf_client_execution_BaseExecutionEnvironment.prototype.init___Lamf_core_execution_ExecutionEnvironment.call(this, _internal);
  return this
});
$c_Lamf_client_execution_ExecutionEnvironment.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_execution_ExecutionEnvironment.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_client_execution_ExecutionEnvironment(obj) {
  return (((obj instanceof $c_Lamf_client_execution_ExecutionEnvironment) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.execution.ExecutionEnvironment"))
}
function $isArrayOf_Lamf_client_execution_ExecutionEnvironment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_execution_ExecutionEnvironment)))
}
function $asArrayOf_Lamf_client_execution_ExecutionEnvironment(obj, depth) {
  return (($isArrayOf_Lamf_client_execution_ExecutionEnvironment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.execution.ExecutionEnvironment;", depth))
}
var $d_Lamf_client_execution_ExecutionEnvironment = new $TypeData().initClass({
  Lamf_client_execution_ExecutionEnvironment: 0
}, false, "amf.client.execution.ExecutionEnvironment", {
  Lamf_client_execution_ExecutionEnvironment: 1,
  Lamf_client_execution_BaseExecutionEnvironment: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_execution_ExecutionEnvironment.prototype.$classData = $d_Lamf_client_execution_ExecutionEnvironment;
/** @constructor */
function $c_Lamf_client_model_Annotations$$anonfun$custom$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_client_model_Annotations$$anonfun$custom$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_client_model_Annotations$$anonfun$custom$1.prototype.constructor = $c_Lamf_client_model_Annotations$$anonfun$custom$1;
/** @constructor */
function $h_Lamf_client_model_Annotations$$anonfun$custom$1() {
  /*<skip>*/
}
$h_Lamf_client_model_Annotations$$anonfun$custom$1.prototype = $c_Lamf_client_model_Annotations$$anonfun$custom$1.prototype;
$c_Lamf_client_model_Annotations$$anonfun$custom$1.prototype.applyOrElse__Lamf_core_model_domain_Annotation__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_annotations_DomainExtensionAnnotation)) {
    var x2 = $as_Lamf_core_annotations_DomainExtensionAnnotation(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_client_model_Annotations$$anonfun$custom$1.prototype.init___Lamf_client_model_Annotations = (function($$outer) {
  return this
});
$c_Lamf_client_model_Annotations$$anonfun$custom$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_Annotation__Z($as_Lamf_core_model_domain_Annotation(x))
});
$c_Lamf_client_model_Annotations$$anonfun$custom$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_Annotation__F1__O($as_Lamf_core_model_domain_Annotation(x), $default)
});
$c_Lamf_client_model_Annotations$$anonfun$custom$1.prototype.isDefinedAt__Lamf_core_model_domain_Annotation__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_core_annotations_DomainExtensionAnnotation)
});
var $d_Lamf_client_model_Annotations$$anonfun$custom$1 = new $TypeData().initClass({
  Lamf_client_model_Annotations$$anonfun$custom$1: 0
}, false, "amf.client.model.Annotations$$anonfun$custom$1", {
  Lamf_client_model_Annotations$$anonfun$custom$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_Annotations$$anonfun$custom$1.prototype.$classData = $d_Lamf_client_model_Annotations$$anonfun$custom$1;
/** @constructor */
function $c_Lamf_client_model_Annotations$$anonfun$isTracked$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_client_model_Annotations$$anonfun$isTracked$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_client_model_Annotations$$anonfun$isTracked$1.prototype.constructor = $c_Lamf_client_model_Annotations$$anonfun$isTracked$1;
/** @constructor */
function $h_Lamf_client_model_Annotations$$anonfun$isTracked$1() {
  /*<skip>*/
}
$h_Lamf_client_model_Annotations$$anonfun$isTracked$1.prototype = $c_Lamf_client_model_Annotations$$anonfun$isTracked$1.prototype;
$c_Lamf_client_model_Annotations$$anonfun$isTracked$1.prototype.applyOrElse__Lamf_core_model_domain_Annotation__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_annotations_TrackedElement)) {
    var x2 = $as_Lamf_core_annotations_TrackedElement(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_client_model_Annotations$$anonfun$isTracked$1.prototype.init___Lamf_client_model_Annotations = (function($$outer) {
  return this
});
$c_Lamf_client_model_Annotations$$anonfun$isTracked$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_Annotation__Z($as_Lamf_core_model_domain_Annotation(x))
});
$c_Lamf_client_model_Annotations$$anonfun$isTracked$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_Annotation__F1__O($as_Lamf_core_model_domain_Annotation(x), $default)
});
$c_Lamf_client_model_Annotations$$anonfun$isTracked$1.prototype.isDefinedAt__Lamf_core_model_domain_Annotation__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_core_annotations_TrackedElement)
});
var $d_Lamf_client_model_Annotations$$anonfun$isTracked$1 = new $TypeData().initClass({
  Lamf_client_model_Annotations$$anonfun$isTracked$1: 0
}, false, "amf.client.model.Annotations$$anonfun$isTracked$1", {
  Lamf_client_model_Annotations$$anonfun$isTracked$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_Annotations$$anonfun$isTracked$1.prototype.$classData = $d_Lamf_client_model_Annotations$$anonfun$isTracked$1;
/** @constructor */
function $c_Lamf_client_model_Annotations$$anonfun$isTrackedBy$1() {
  $c_sr_AbstractPartialFunction.call(this);
  this.trackId$1$2 = null
}
$c_Lamf_client_model_Annotations$$anonfun$isTrackedBy$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_client_model_Annotations$$anonfun$isTrackedBy$1.prototype.constructor = $c_Lamf_client_model_Annotations$$anonfun$isTrackedBy$1;
/** @constructor */
function $h_Lamf_client_model_Annotations$$anonfun$isTrackedBy$1() {
  /*<skip>*/
}
$h_Lamf_client_model_Annotations$$anonfun$isTrackedBy$1.prototype = $c_Lamf_client_model_Annotations$$anonfun$isTrackedBy$1.prototype;
$c_Lamf_client_model_Annotations$$anonfun$isTrackedBy$1.prototype.init___Lamf_client_model_Annotations__T = (function($$outer, trackId$1) {
  this.trackId$1$2 = trackId$1;
  return this
});
$c_Lamf_client_model_Annotations$$anonfun$isTrackedBy$1.prototype.applyOrElse__Lamf_core_model_domain_Annotation__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_annotations_TrackedElement)) {
    var x2 = $as_Lamf_core_annotations_TrackedElement(x1);
    if (x2.parents$1.contains__O__Z(this.trackId$1$2)) {
      return x2
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_client_model_Annotations$$anonfun$isTrackedBy$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_Annotation__Z($as_Lamf_core_model_domain_Annotation(x))
});
$c_Lamf_client_model_Annotations$$anonfun$isTrackedBy$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_Annotation__F1__O($as_Lamf_core_model_domain_Annotation(x), $default)
});
$c_Lamf_client_model_Annotations$$anonfun$isTrackedBy$1.prototype.isDefinedAt__Lamf_core_model_domain_Annotation__Z = (function(x1) {
  if ((x1 instanceof $c_Lamf_core_annotations_TrackedElement)) {
    var x2 = $as_Lamf_core_annotations_TrackedElement(x1);
    if (x2.parents$1.contains__O__Z(this.trackId$1$2)) {
      return true
    }
  };
  return false
});
var $d_Lamf_client_model_Annotations$$anonfun$isTrackedBy$1 = new $TypeData().initClass({
  Lamf_client_model_Annotations$$anonfun$isTrackedBy$1: 0
}, false, "amf.client.model.Annotations$$anonfun$isTrackedBy$1", {
  Lamf_client_model_Annotations$$anonfun$isTrackedBy$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_Annotations$$anonfun$isTrackedBy$1.prototype.$classData = $d_Lamf_client_model_Annotations$$anonfun$isTrackedBy$1;
/** @constructor */
function $c_Lamf_client_model_document_DialectFragment() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_document_DialectFragment.prototype = new $h_O();
$c_Lamf_client_model_document_DialectFragment.prototype.constructor = $c_Lamf_client_model_document_DialectFragment;
/** @constructor */
function $h_Lamf_client_model_document_DialectFragment() {
  /*<skip>*/
}
$h_Lamf_client_model_document_DialectFragment.prototype = $c_Lamf_client_model_document_DialectFragment.prototype;
$c_Lamf_client_model_document_DialectFragment.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_document_DialectFragment.prototype.init___Lamf_plugins_document_vocabularies_model_document_DialectFragment.call(this, new $c_Lamf_plugins_document_vocabularies_model_document_DialectFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$meth$withRaw__T__O = (function(raw) {
  return $f_Lamf_client_model_document_BaseUnit__withRaw__T__Lamf_client_model_document_BaseUnit(this, raw)
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$meth$findById__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__findById__T__sjs_js_UndefOr(this, id)
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$meth$withReferences__sjs_js_Array__O = (function(references) {
  return $f_Lamf_client_model_document_BaseUnit__withReferences__sjs_js_Array__Lamf_client_model_document_BaseUnit(this, references)
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$meth$references__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__references__sjs_js_Array(this)
});
$c_Lamf_client_model_document_DialectFragment.prototype.withEncodes__Lamf_client_model_domain_NodeMapping__Lamf_client_model_document_DialectFragment = (function(nodeMapping) {
  var this$1 = this.$$undinternal$1;
  var nodeMapping$1 = nodeMapping.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Encodes$1;
  $as_Lamf_plugins_document_vocabularies_model_document_DialectFragment($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$1, field, nodeMapping$1));
  return this
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$prop$modelVersion__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__modelVersion__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$prop$location__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__location__T(this)
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$undinternal__Lamf_core_model_document_EncodesModel = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__withId__T__Lamf_client_model_document_BaseUnit(this, id)
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$meth$cloneUnit__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__cloneUnit__Lamf_client_model_document_BaseUnit(this)
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$prop$encodes__O = (function() {
  return this.encodes__Lamf_client_model_domain_NodeMapping()
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$meth$withEncodes__Lamf_client_model_domain_DomainElement__O = (function(encoded) {
  return $f_Lamf_client_model_document_EncodesModel__withEncodes__Lamf_client_model_domain_DomainElement__Lamf_client_model_document_EncodesModel(this, encoded)
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$meth$findByType__T__O = (function(typeId) {
  return $f_Lamf_client_model_document_BaseUnit__findByType__T__sjs_js_Array(this, typeId)
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$meth$withLocation__T__O = (function(location) {
  return $f_Lamf_client_model_document_BaseUnit__withLocation__T__Lamf_client_model_document_BaseUnit(this, location)
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$prop$raw__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__raw__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_DialectFragment.prototype.withExternals__sjs_js_Array__Lamf_client_model_document_DialectFragment = (function(externals) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().ExternalConverter__Lamf_client_convert_ExternalConverter$ExternalConverter$();
  var externals$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, externals, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$().Externals$1;
  $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, externals$1);
  return this
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O = (function(renderOptions) {
  return $f_Lamf_client_model_document_BaseUnit__toNativeRdfModel__Lamf_client_render_RenderOptions__Lamf_core_rdf_RdfModel(this, renderOptions)
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$meth$withEncodes__Lamf_client_model_domain_NodeMapping__O = (function(nodeMapping) {
  return this.withEncodes__Lamf_client_model_domain_NodeMapping__Lamf_client_model_document_DialectFragment(nodeMapping)
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions = (function() {
  return new $c_Lamf_client_render_RenderOptions().init___()
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$meth$withUsage__T__O = (function(usage) {
  return $f_Lamf_client_model_document_BaseUnit__withUsage__T__Lamf_client_model_document_BaseUnit(this, usage)
});
$c_Lamf_client_model_document_DialectFragment.prototype.init___Lamf_plugins_document_vocabularies_model_document_DialectFragment = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$meth$withReferenceAlias__T__T__T__O = (function(alias, fullUrl, relativeUrl) {
  return $f_Lamf_client_model_document_BaseUnit__withReferenceAlias__T__T__T__Lamf_client_model_document_BaseUnit(this, alias, fullUrl, relativeUrl)
});
$c_Lamf_client_model_document_DialectFragment.prototype.encodes__Lamf_client_model_domain_NodeMapping = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Encodes$1));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().NodeMappingConverter__Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$();
  return m.asClient__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_client_model_domain_NodeMapping(from)
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$meth$withExternals__sjs_js_Array__O = (function(externals) {
  return this.withExternals__sjs_js_Array__Lamf_client_model_document_DialectFragment(externals)
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$prop$sourceVendor__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__sourceVendor__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$prop$usage__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__usage__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_DialectFragment.prototype.$$js$exported$prop$externals__O = (function() {
  return this.externals__sjs_js_Array()
});
$c_Lamf_client_model_document_DialectFragment.prototype.externals__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(this$1);
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().ExternalConverter__Lamf_client_convert_ExternalConverter$ExternalConverter$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_document_DialectFragment.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_document_DialectFragment.prototype.withReferenceAlias = (function(arg, arg$2, arg$3) {
  var prep = $as_T(arg);
  var prep$2 = $as_T(arg$2);
  var prep$3 = $as_T(arg$3);
  return this.$$js$exported$meth$withReferenceAlias__T__T__T__O(prep, prep$2, prep$3)
});
$c_Lamf_client_model_document_DialectFragment.prototype.cloneUnit = (function() {
  return this.$$js$exported$meth$cloneUnit__O()
});
Object.defineProperty($c_Lamf_client_model_document_DialectFragment.prototype, "sourceVendor", {
  "get": (function() {
    return this.$$js$exported$prop$sourceVendor__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectFragment.prototype.findByType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findByType__T__O(prep)
});
$c_Lamf_client_model_document_DialectFragment.prototype.findById = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findById__T__O(prep)
});
$c_Lamf_client_model_document_DialectFragment.prototype.toNativeRdfModel = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions() : $as_Lamf_client_render_RenderOptions(rest[0]));
  return this.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O(prep)
});
$c_Lamf_client_model_document_DialectFragment.prototype.withUsage = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withUsage__T__O(prep)
});
$c_Lamf_client_model_document_DialectFragment.prototype.withLocation = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLocation__T__O(prep)
});
$c_Lamf_client_model_document_DialectFragment.prototype.withRaw = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withRaw__T__O(prep)
});
$c_Lamf_client_model_document_DialectFragment.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_document_DialectFragment.prototype.withReferences = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withReferences__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_DialectFragment.prototype, "modelVersion", {
  "get": (function() {
    return this.$$js$exported$prop$modelVersion__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_DialectFragment.prototype, "usage", {
  "get": (function() {
    return this.$$js$exported$prop$usage__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_DialectFragment.prototype, "location", {
  "get": (function() {
    return this.$$js$exported$prop$location__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_DialectFragment.prototype, "raw", {
  "get": (function() {
    return this.$$js$exported$prop$raw__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectFragment.prototype.references = (function() {
  return this.$$js$exported$meth$references__O()
});
Object.defineProperty($c_Lamf_client_model_document_DialectFragment.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectFragment.prototype.withEncodes = (function(arg) {
  if ((arg instanceof $c_Lamf_client_model_domain_NodeMapping)) {
    var prep$2 = $as_Lamf_client_model_domain_NodeMapping(arg);
    return this.$$js$exported$meth$withEncodes__Lamf_client_model_domain_NodeMapping__O(prep$2)
  } else if ($is_Lamf_client_model_domain_DomainElement(arg)) {
    var prep = $as_Lamf_client_model_domain_DomainElement(arg);
    return this.$$js$exported$meth$withEncodes__Lamf_client_model_domain_DomainElement__O(prep)
  } else {
    throw "No matching overload"
  }
});
$c_Lamf_client_model_document_DialectFragment.prototype.withExternals = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExternals__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_DialectFragment.prototype, "externals", {
  "get": (function() {
    return this.$$js$exported$prop$externals__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_DialectFragment.prototype, "encodes", {
  "get": (function() {
    return this.$$js$exported$prop$encodes__O()
  }),
  "configurable": true
});
var $d_Lamf_client_model_document_DialectFragment = new $TypeData().initClass({
  Lamf_client_model_document_DialectFragment: 0
}, false, "amf.client.model.document.DialectFragment", {
  Lamf_client_model_document_DialectFragment: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_EncodesModel: 1
});
$c_Lamf_client_model_document_DialectFragment.prototype.$classData = $d_Lamf_client_model_document_DialectFragment;
/** @constructor */
function $c_Lamf_client_model_document_DialectInstanceFragment() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_document_DialectInstanceFragment.prototype = new $h_O();
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.constructor = $c_Lamf_client_model_document_DialectInstanceFragment;
/** @constructor */
function $h_Lamf_client_model_document_DialectInstanceFragment() {
  /*<skip>*/
}
$h_Lamf_client_model_document_DialectInstanceFragment.prototype = $c_Lamf_client_model_document_DialectInstanceFragment.prototype;
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_document_DialectInstanceFragment.prototype.init___Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.call(this, new $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$meth$withRaw__T__O = (function(raw) {
  return $f_Lamf_client_model_document_BaseUnit__withRaw__T__Lamf_client_model_document_BaseUnit(this, raw)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$meth$findById__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__findById__T__sjs_js_UndefOr(this, id)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$meth$withReferences__sjs_js_Array__O = (function(references) {
  return $f_Lamf_client_model_document_BaseUnit__withReferences__sjs_js_Array__Lamf_client_model_document_BaseUnit(this, references)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$meth$references__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__references__sjs_js_Array(this)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.withEncodes__Lamf_client_model_domain_DialectDomainElement__Lamf_client_model_document_DialectInstanceFragment = (function(encoded) {
  var this$1 = this.$$undinternal$1;
  var encoded$1 = encoded.$$undinternal$1;
  var field = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
  $as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$1, field, encoded$1));
  return this
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$meth$withEncodes__Lamf_client_model_domain_DialectDomainElement__O = (function(encoded) {
  return this.withEncodes__Lamf_client_model_domain_DialectDomainElement__Lamf_client_model_document_DialectInstanceFragment(encoded)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.init___Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$prop$modelVersion__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__modelVersion__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$prop$location__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__location__T(this)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.encodes__Lamf_client_model_domain_DialectDomainElement = (function() {
  var this$1 = this.$$undinternal$1;
  return new $c_Lamf_client_model_domain_DialectDomainElement().init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_Lamf_core_model_domain_DomainElement(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().Encodes$1))))
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$undinternal__Lamf_core_model_document_EncodesModel = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__withId__T__Lamf_client_model_document_BaseUnit(this, id)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$meth$cloneUnit__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__cloneUnit__Lamf_client_model_document_BaseUnit(this)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$prop$encodes__O = (function() {
  return this.encodes__Lamf_client_model_domain_DialectDomainElement()
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$meth$withEncodes__Lamf_client_model_domain_DomainElement__O = (function(encoded) {
  return $f_Lamf_client_model_document_EncodesModel__withEncodes__Lamf_client_model_domain_DomainElement__Lamf_client_model_document_EncodesModel(this, encoded)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$meth$findByType__T__O = (function(typeId) {
  return $f_Lamf_client_model_document_BaseUnit__findByType__T__sjs_js_Array(this, typeId)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$meth$withLocation__T__O = (function(location) {
  return $f_Lamf_client_model_document_BaseUnit__withLocation__T__Lamf_client_model_document_BaseUnit(this, location)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$prop$raw__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__raw__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O = (function(renderOptions) {
  return $f_Lamf_client_model_document_BaseUnit__toNativeRdfModel__Lamf_client_render_RenderOptions__Lamf_core_rdf_RdfModel(this, renderOptions)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions = (function() {
  return new $c_Lamf_client_render_RenderOptions().init___()
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$meth$withUsage__T__O = (function(usage) {
  return $f_Lamf_client_model_document_BaseUnit__withUsage__T__Lamf_client_model_document_BaseUnit(this, usage)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$meth$withReferenceAlias__T__T__T__O = (function(alias, fullUrl, relativeUrl) {
  return $f_Lamf_client_model_document_BaseUnit__withReferenceAlias__T__T__T__Lamf_client_model_document_BaseUnit(this, alias, fullUrl, relativeUrl)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$prop$sourceVendor__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__sourceVendor__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$$js$exported$prop$usage__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__usage__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.withReferenceAlias = (function(arg, arg$2, arg$3) {
  var prep = $as_T(arg);
  var prep$2 = $as_T(arg$2);
  var prep$3 = $as_T(arg$3);
  return this.$$js$exported$meth$withReferenceAlias__T__T__T__O(prep, prep$2, prep$3)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.cloneUnit = (function() {
  return this.$$js$exported$meth$cloneUnit__O()
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstanceFragment.prototype, "sourceVendor", {
  "get": (function() {
    return this.$$js$exported$prop$sourceVendor__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.findByType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findByType__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.findById = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findById__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.toNativeRdfModel = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions() : $as_Lamf_client_render_RenderOptions(rest[0]));
  return this.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O(prep)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.withUsage = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withUsage__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.withLocation = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLocation__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.withRaw = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withRaw__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.withReferences = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withReferences__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstanceFragment.prototype, "modelVersion", {
  "get": (function() {
    return this.$$js$exported$prop$modelVersion__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstanceFragment.prototype, "usage", {
  "get": (function() {
    return this.$$js$exported$prop$usage__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstanceFragment.prototype, "location", {
  "get": (function() {
    return this.$$js$exported$prop$location__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstanceFragment.prototype, "raw", {
  "get": (function() {
    return this.$$js$exported$prop$raw__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.references = (function() {
  return this.$$js$exported$meth$references__O()
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstanceFragment.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.withEncodes = (function(arg) {
  if ((arg instanceof $c_Lamf_client_model_domain_DialectDomainElement)) {
    var prep$2 = $as_Lamf_client_model_domain_DialectDomainElement(arg);
    return this.$$js$exported$meth$withEncodes__Lamf_client_model_domain_DialectDomainElement__O(prep$2)
  } else if ($is_Lamf_client_model_domain_DomainElement(arg)) {
    var prep = $as_Lamf_client_model_domain_DomainElement(arg);
    return this.$$js$exported$meth$withEncodes__Lamf_client_model_domain_DomainElement__O(prep)
  } else {
    throw "No matching overload"
  }
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstanceFragment.prototype, "encodes", {
  "get": (function() {
    return this.$$js$exported$prop$encodes__O()
  }),
  "configurable": true
});
var $d_Lamf_client_model_document_DialectInstanceFragment = new $TypeData().initClass({
  Lamf_client_model_document_DialectInstanceFragment: 0
}, false, "amf.client.model.document.DialectInstanceFragment", {
  Lamf_client_model_document_DialectInstanceFragment: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_EncodesModel: 1
});
$c_Lamf_client_model_document_DialectInstanceFragment.prototype.$classData = $d_Lamf_client_model_document_DialectInstanceFragment;
/** @constructor */
function $c_Lamf_client_model_document_DialectInstanceLibrary() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype = new $h_O();
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.constructor = $c_Lamf_client_model_document_DialectInstanceLibrary;
/** @constructor */
function $h_Lamf_client_model_document_DialectInstanceLibrary() {
  /*<skip>*/
}
$h_Lamf_client_model_document_DialectInstanceLibrary.prototype = $c_Lamf_client_model_document_DialectInstanceLibrary.prototype;
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_document_DialectInstanceLibrary.prototype.init___Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.call(this, new $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$meth$withRaw__T__O = (function(raw) {
  return $f_Lamf_client_model_document_BaseUnit__withRaw__T__Lamf_client_model_document_BaseUnit(this, raw)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$meth$findById__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__findById__T__sjs_js_UndefOr(this, id)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$meth$withReferences__sjs_js_Array__O = (function(references) {
  return $f_Lamf_client_model_document_BaseUnit__withReferences__sjs_js_Array__Lamf_client_model_document_BaseUnit(this, references)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.init___Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$meth$references__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__references__sjs_js_Array(this)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$prop$modelVersion__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__modelVersion__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$prop$location__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__location__T(this)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$meth$withDeclares__sjs_js_Array__O = (function(declares) {
  return $f_Lamf_client_model_document_DeclaresModel__withDeclares__sjs_js_Array__Lamf_client_model_document_DeclaresModel(this, declares)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__withId__T__Lamf_client_model_document_BaseUnit(this, id)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$meth$cloneUnit__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__cloneUnit__Lamf_client_model_document_BaseUnit(this)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$meth$findByType__T__O = (function(typeId) {
  return $f_Lamf_client_model_document_BaseUnit__findByType__T__sjs_js_Array(this, typeId)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$meth$withLocation__T__O = (function(location) {
  return $f_Lamf_client_model_document_BaseUnit__withLocation__T__Lamf_client_model_document_BaseUnit(this, location)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$prop$raw__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__raw__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$undinternal__Lamf_core_model_document_DeclaresModel = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O = (function(renderOptions) {
  return $f_Lamf_client_model_document_BaseUnit__toNativeRdfModel__Lamf_client_render_RenderOptions__Lamf_core_rdf_RdfModel(this, renderOptions)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions = (function() {
  return new $c_Lamf_client_render_RenderOptions().init___()
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$meth$withUsage__T__O = (function(usage) {
  return $f_Lamf_client_model_document_BaseUnit__withUsage__T__Lamf_client_model_document_BaseUnit(this, usage)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$meth$withReferenceAlias__T__T__T__O = (function(alias, fullUrl, relativeUrl) {
  return $f_Lamf_client_model_document_BaseUnit__withReferenceAlias__T__T__T__Lamf_client_model_document_BaseUnit(this, alias, fullUrl, relativeUrl)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$prop$declares__O = (function() {
  return $f_Lamf_client_model_document_DeclaresModel__declares__sjs_js_Array(this)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$meth$withDeclaredElement__Lamf_client_model_domain_DomainElement__O = (function(declared) {
  return $f_Lamf_client_model_document_DeclaresModel__withDeclaredElement__Lamf_client_model_domain_DomainElement__Lamf_client_model_document_DeclaresModel(this, declared)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$prop$sourceVendor__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__sourceVendor__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$$js$exported$prop$usage__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__usage__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.withReferenceAlias = (function(arg, arg$2, arg$3) {
  var prep = $as_T(arg);
  var prep$2 = $as_T(arg$2);
  var prep$3 = $as_T(arg$3);
  return this.$$js$exported$meth$withReferenceAlias__T__T__T__O(prep, prep$2, prep$3)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.cloneUnit = (function() {
  return this.$$js$exported$meth$cloneUnit__O()
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstanceLibrary.prototype, "sourceVendor", {
  "get": (function() {
    return this.$$js$exported$prop$sourceVendor__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.findByType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findByType__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.findById = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findById__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.toNativeRdfModel = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions() : $as_Lamf_client_render_RenderOptions(rest[0]));
  return this.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O(prep)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.withUsage = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withUsage__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.withLocation = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLocation__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.withRaw = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withRaw__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.withReferences = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withReferences__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstanceLibrary.prototype, "modelVersion", {
  "get": (function() {
    return this.$$js$exported$prop$modelVersion__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstanceLibrary.prototype, "usage", {
  "get": (function() {
    return this.$$js$exported$prop$usage__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstanceLibrary.prototype, "location", {
  "get": (function() {
    return this.$$js$exported$prop$location__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstanceLibrary.prototype, "raw", {
  "get": (function() {
    return this.$$js$exported$prop$raw__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.references = (function() {
  return this.$$js$exported$meth$references__O()
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstanceLibrary.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.withDeclares = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withDeclares__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.withDeclaredElement = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withDeclaredElement__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstanceLibrary.prototype, "declares", {
  "get": (function() {
    return this.$$js$exported$prop$declares__O()
  }),
  "configurable": true
});
var $d_Lamf_client_model_document_DialectInstanceLibrary = new $TypeData().initClass({
  Lamf_client_model_document_DialectInstanceLibrary: 0
}, false, "amf.client.model.document.DialectInstanceLibrary", {
  Lamf_client_model_document_DialectInstanceLibrary: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_DeclaresModel: 1
});
$c_Lamf_client_model_document_DialectInstanceLibrary.prototype.$classData = $d_Lamf_client_model_document_DialectInstanceLibrary;
/** @constructor */
function $c_Lamf_client_model_document_DialectLibrary() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_document_DialectLibrary.prototype = new $h_O();
$c_Lamf_client_model_document_DialectLibrary.prototype.constructor = $c_Lamf_client_model_document_DialectLibrary;
/** @constructor */
function $h_Lamf_client_model_document_DialectLibrary() {
  /*<skip>*/
}
$h_Lamf_client_model_document_DialectLibrary.prototype = $c_Lamf_client_model_document_DialectLibrary.prototype;
$c_Lamf_client_model_document_DialectLibrary.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_document_DialectLibrary.prototype.init___Lamf_plugins_document_vocabularies_model_document_DialectLibrary.call(this, new $c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$meth$withRaw__T__O = (function(raw) {
  return $f_Lamf_client_model_document_BaseUnit__withRaw__T__Lamf_client_model_document_BaseUnit(this, raw)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$meth$findById__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__findById__T__sjs_js_UndefOr(this, id)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$meth$withReferences__sjs_js_Array__O = (function(references) {
  return $f_Lamf_client_model_document_BaseUnit__withReferences__sjs_js_Array__Lamf_client_model_document_BaseUnit(this, references)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$meth$references__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__references__sjs_js_Array(this)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$prop$modelVersion__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__modelVersion__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$prop$location__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__location__T(this)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_DialectLibrary.prototype.nodeMappings__sjs_js_Array = (function() {
  var this$3 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var jsx$2 = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Declares$1));
  var jsx$1 = new $c_Lamf_client_model_document_DialectLibrary$$anonfun$nodeMappings$1().init___Lamf_client_model_document_DialectLibrary(this);
  var this$2 = $m_sc_Seq$();
  var from = $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().NodeMappingConverter__Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$3, from, m).asClient__O()
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$meth$withDeclares__sjs_js_Array__O = (function(declares) {
  return $f_Lamf_client_model_document_DeclaresModel__withDeclares__sjs_js_Array__Lamf_client_model_document_DeclaresModel(this, declares)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__withId__T__Lamf_client_model_document_BaseUnit(this, id)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$meth$cloneUnit__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__cloneUnit__Lamf_client_model_document_BaseUnit(this)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$meth$findByType__T__O = (function(typeId) {
  return $f_Lamf_client_model_document_BaseUnit__findByType__T__sjs_js_Array(this, typeId)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.init___Lamf_plugins_document_vocabularies_model_document_DialectLibrary = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$meth$nodeMappings__O = (function() {
  return this.nodeMappings__sjs_js_Array()
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$meth$withLocation__T__O = (function(location) {
  return $f_Lamf_client_model_document_BaseUnit__withLocation__T__Lamf_client_model_document_BaseUnit(this, location)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$prop$raw__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__raw__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$undinternal__Lamf_core_model_document_DeclaresModel = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O = (function(renderOptions) {
  return $f_Lamf_client_model_document_BaseUnit__toNativeRdfModel__Lamf_client_render_RenderOptions__Lamf_core_rdf_RdfModel(this, renderOptions)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions = (function() {
  return new $c_Lamf_client_render_RenderOptions().init___()
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$meth$withUsage__T__O = (function(usage) {
  return $f_Lamf_client_model_document_BaseUnit__withUsage__T__Lamf_client_model_document_BaseUnit(this, usage)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_DialectLibrary.prototype.withExternals__sjs_js_Array__Lamf_client_model_document_DialectLibrary = (function(externals) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().ExternalConverter__Lamf_client_convert_ExternalConverter$ExternalConverter$();
  var externals$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, externals, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$().Externals$1;
  $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, externals$1);
  return this
});
$c_Lamf_client_model_document_DialectLibrary.prototype.withNodeMappings__sjs_js_Array__Lamf_client_model_document_DialectLibrary = (function(nodeMappings) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().NodeMappingConverter__Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$();
  var declarations = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, nodeMappings, m).asInternal__sc_Seq();
  var field = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
  $as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, declarations));
  return this
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$meth$withReferenceAlias__T__T__T__O = (function(alias, fullUrl, relativeUrl) {
  return $f_Lamf_client_model_document_BaseUnit__withReferenceAlias__T__T__T__Lamf_client_model_document_BaseUnit(this, alias, fullUrl, relativeUrl)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$meth$withExternals__sjs_js_Array__O = (function(externals) {
  return this.withExternals__sjs_js_Array__Lamf_client_model_document_DialectLibrary(externals)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$prop$declares__O = (function() {
  return $f_Lamf_client_model_document_DeclaresModel__declares__sjs_js_Array(this)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$meth$withDeclaredElement__Lamf_client_model_domain_DomainElement__O = (function(declared) {
  return $f_Lamf_client_model_document_DeclaresModel__withDeclaredElement__Lamf_client_model_domain_DomainElement__Lamf_client_model_document_DeclaresModel(this, declared)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$meth$withNodeMappings__sjs_js_Array__O = (function(nodeMappings) {
  return this.withNodeMappings__sjs_js_Array__Lamf_client_model_document_DialectLibrary(nodeMappings)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$prop$sourceVendor__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__sourceVendor__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$prop$usage__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__usage__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$$js$exported$prop$externals__O = (function() {
  return this.externals__sjs_js_Array()
});
$c_Lamf_client_model_document_DialectLibrary.prototype.externals__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(this$1);
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().ExternalConverter__Lamf_client_convert_ExternalConverter$ExternalConverter$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_document_DialectLibrary.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_document_DialectLibrary.prototype.withReferenceAlias = (function(arg, arg$2, arg$3) {
  var prep = $as_T(arg);
  var prep$2 = $as_T(arg$2);
  var prep$3 = $as_T(arg$3);
  return this.$$js$exported$meth$withReferenceAlias__T__T__T__O(prep, prep$2, prep$3)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.cloneUnit = (function() {
  return this.$$js$exported$meth$cloneUnit__O()
});
Object.defineProperty($c_Lamf_client_model_document_DialectLibrary.prototype, "sourceVendor", {
  "get": (function() {
    return this.$$js$exported$prop$sourceVendor__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectLibrary.prototype.findByType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findByType__T__O(prep)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.findById = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findById__T__O(prep)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.toNativeRdfModel = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions() : $as_Lamf_client_render_RenderOptions(rest[0]));
  return this.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O(prep)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.withUsage = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withUsage__T__O(prep)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.withLocation = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLocation__T__O(prep)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.withRaw = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withRaw__T__O(prep)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.withReferences = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withReferences__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_DialectLibrary.prototype, "modelVersion", {
  "get": (function() {
    return this.$$js$exported$prop$modelVersion__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_DialectLibrary.prototype, "usage", {
  "get": (function() {
    return this.$$js$exported$prop$usage__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_DialectLibrary.prototype, "location", {
  "get": (function() {
    return this.$$js$exported$prop$location__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_DialectLibrary.prototype, "raw", {
  "get": (function() {
    return this.$$js$exported$prop$raw__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectLibrary.prototype.references = (function() {
  return this.$$js$exported$meth$references__O()
});
Object.defineProperty($c_Lamf_client_model_document_DialectLibrary.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectLibrary.prototype.withDeclares = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withDeclares__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.withDeclaredElement = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withDeclaredElement__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_DialectLibrary.prototype, "declares", {
  "get": (function() {
    return this.$$js$exported$prop$declares__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectLibrary.prototype.withNodeMappings = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withNodeMappings__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.withExternals = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExternals__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_document_DialectLibrary.prototype.nodeMappings = (function() {
  return this.$$js$exported$meth$nodeMappings__O()
});
Object.defineProperty($c_Lamf_client_model_document_DialectLibrary.prototype, "externals", {
  "get": (function() {
    return this.$$js$exported$prop$externals__O()
  }),
  "configurable": true
});
var $d_Lamf_client_model_document_DialectLibrary = new $TypeData().initClass({
  Lamf_client_model_document_DialectLibrary: 0
}, false, "amf.client.model.document.DialectLibrary", {
  Lamf_client_model_document_DialectLibrary: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_DeclaresModel: 1
});
$c_Lamf_client_model_document_DialectLibrary.prototype.$classData = $d_Lamf_client_model_document_DialectLibrary;
/** @constructor */
function $c_Lamf_client_model_document_DialectLibrary$$anonfun$nodeMappings$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_client_model_document_DialectLibrary$$anonfun$nodeMappings$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_client_model_document_DialectLibrary$$anonfun$nodeMappings$1.prototype.constructor = $c_Lamf_client_model_document_DialectLibrary$$anonfun$nodeMappings$1;
/** @constructor */
function $h_Lamf_client_model_document_DialectLibrary$$anonfun$nodeMappings$1() {
  /*<skip>*/
}
$h_Lamf_client_model_document_DialectLibrary$$anonfun$nodeMappings$1.prototype = $c_Lamf_client_model_document_DialectLibrary$$anonfun$nodeMappings$1.prototype;
$c_Lamf_client_model_document_DialectLibrary$$anonfun$nodeMappings$1.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_client_model_document_DialectLibrary$$anonfun$nodeMappings$1.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)
});
$c_Lamf_client_model_document_DialectLibrary$$anonfun$nodeMappings$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_client_model_document_DialectLibrary$$anonfun$nodeMappings$1.prototype.init___Lamf_client_model_document_DialectLibrary = (function($$outer) {
  return this
});
$c_Lamf_client_model_document_DialectLibrary$$anonfun$nodeMappings$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_client_model_document_DialectLibrary$$anonfun$nodeMappings$1 = new $TypeData().initClass({
  Lamf_client_model_document_DialectLibrary$$anonfun$nodeMappings$1: 0
}, false, "amf.client.model.document.DialectLibrary$$anonfun$nodeMappings$1", {
  Lamf_client_model_document_DialectLibrary$$anonfun$nodeMappings$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_document_DialectLibrary$$anonfun$nodeMappings$1.prototype.$classData = $d_Lamf_client_model_document_DialectLibrary$$anonfun$nodeMappings$1;
/** @constructor */
function $c_Lamf_client_model_document_Fragment() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_document_Fragment.prototype = new $h_O();
$c_Lamf_client_model_document_Fragment.prototype.constructor = $c_Lamf_client_model_document_Fragment;
/** @constructor */
function $h_Lamf_client_model_document_Fragment() {
  /*<skip>*/
}
$h_Lamf_client_model_document_Fragment.prototype = $c_Lamf_client_model_document_Fragment.prototype;
$c_Lamf_client_model_document_Fragment.prototype.$$js$exported$meth$withRaw__T__O = (function(raw) {
  return $f_Lamf_client_model_document_BaseUnit__withRaw__T__Lamf_client_model_document_BaseUnit(this, raw)
});
$c_Lamf_client_model_document_Fragment.prototype.$$js$exported$meth$findById__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__findById__T__sjs_js_UndefOr(this, id)
});
$c_Lamf_client_model_document_Fragment.prototype.$$js$exported$meth$withReferences__sjs_js_Array__O = (function(references) {
  return $f_Lamf_client_model_document_BaseUnit__withReferences__sjs_js_Array__Lamf_client_model_document_BaseUnit(this, references)
});
$c_Lamf_client_model_document_Fragment.prototype.$$js$exported$meth$references__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__references__sjs_js_Array(this)
});
$c_Lamf_client_model_document_Fragment.prototype.$$js$exported$prop$modelVersion__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__modelVersion__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_Fragment.prototype.$$js$exported$prop$location__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__location__T(this)
});
$c_Lamf_client_model_document_Fragment.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return this.$$undinternal__Lamf_core_model_document_Fragment()
});
$c_Lamf_client_model_document_Fragment.prototype.$$js$exported$prop$encodes__O = (function() {
  return $f_Lamf_client_model_document_EncodesModel__encodes__Lamf_client_model_domain_DomainElement(this)
});
$c_Lamf_client_model_document_Fragment.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__withId__T__Lamf_client_model_document_BaseUnit(this, id)
});
$c_Lamf_client_model_document_Fragment.prototype.$$js$exported$meth$cloneUnit__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__cloneUnit__Lamf_client_model_document_BaseUnit(this)
});
$c_Lamf_client_model_document_Fragment.prototype.$$undinternal__Lamf_core_model_document_EncodesModel = (function() {
  return this.$$undinternal__Lamf_core_model_document_Fragment()
});
$c_Lamf_client_model_document_Fragment.prototype.init___Lamf_core_model_document_Fragment = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_document_Fragment.prototype.$$js$exported$meth$withEncodes__Lamf_client_model_domain_DomainElement__O = (function(encoded) {
  return $f_Lamf_client_model_document_EncodesModel__withEncodes__Lamf_client_model_domain_DomainElement__Lamf_client_model_document_EncodesModel(this, encoded)
});
$c_Lamf_client_model_document_Fragment.prototype.$$js$exported$meth$findByType__T__O = (function(typeId) {
  return $f_Lamf_client_model_document_BaseUnit__findByType__T__sjs_js_Array(this, typeId)
});
$c_Lamf_client_model_document_Fragment.prototype.$$js$exported$meth$withLocation__T__O = (function(location) {
  return $f_Lamf_client_model_document_BaseUnit__withLocation__T__Lamf_client_model_document_BaseUnit(this, location)
});
$c_Lamf_client_model_document_Fragment.prototype.$$js$exported$prop$raw__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__raw__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_Fragment.prototype.$$undinternal__Lamf_core_model_document_Fragment = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_Fragment.prototype.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O = (function(renderOptions) {
  return $f_Lamf_client_model_document_BaseUnit__toNativeRdfModel__Lamf_client_render_RenderOptions__Lamf_core_rdf_RdfModel(this, renderOptions)
});
$c_Lamf_client_model_document_Fragment.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_document_Fragment.prototype.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions = (function() {
  return new $c_Lamf_client_render_RenderOptions().init___()
});
$c_Lamf_client_model_document_Fragment.prototype.$$js$exported$meth$withUsage__T__O = (function(usage) {
  return $f_Lamf_client_model_document_BaseUnit__withUsage__T__Lamf_client_model_document_BaseUnit(this, usage)
});
$c_Lamf_client_model_document_Fragment.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal__Lamf_core_model_document_BaseUnit().id__T()
});
$c_Lamf_client_model_document_Fragment.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal__Lamf_core_model_document_Fragment()
});
$c_Lamf_client_model_document_Fragment.prototype.$$js$exported$meth$withReferenceAlias__T__T__T__O = (function(alias, fullUrl, relativeUrl) {
  return $f_Lamf_client_model_document_BaseUnit__withReferenceAlias__T__T__T__Lamf_client_model_document_BaseUnit(this, alias, fullUrl, relativeUrl)
});
$c_Lamf_client_model_document_Fragment.prototype.$$js$exported$prop$sourceVendor__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__sourceVendor__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_Fragment.prototype.$$js$exported$prop$usage__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__usage__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_Fragment.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_document_Fragment.prototype.withReferenceAlias = (function(arg, arg$2, arg$3) {
  var prep = $as_T(arg);
  var prep$2 = $as_T(arg$2);
  var prep$3 = $as_T(arg$3);
  return this.$$js$exported$meth$withReferenceAlias__T__T__T__O(prep, prep$2, prep$3)
});
$c_Lamf_client_model_document_Fragment.prototype.cloneUnit = (function() {
  return this.$$js$exported$meth$cloneUnit__O()
});
Object.defineProperty($c_Lamf_client_model_document_Fragment.prototype, "sourceVendor", {
  "get": (function() {
    return this.$$js$exported$prop$sourceVendor__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_Fragment.prototype.findByType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findByType__T__O(prep)
});
$c_Lamf_client_model_document_Fragment.prototype.findById = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findById__T__O(prep)
});
$c_Lamf_client_model_document_Fragment.prototype.toNativeRdfModel = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions() : $as_Lamf_client_render_RenderOptions(rest[0]));
  return this.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O(prep)
});
$c_Lamf_client_model_document_Fragment.prototype.withUsage = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withUsage__T__O(prep)
});
$c_Lamf_client_model_document_Fragment.prototype.withLocation = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLocation__T__O(prep)
});
$c_Lamf_client_model_document_Fragment.prototype.withRaw = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withRaw__T__O(prep)
});
$c_Lamf_client_model_document_Fragment.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_document_Fragment.prototype.withReferences = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withReferences__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_Fragment.prototype, "modelVersion", {
  "get": (function() {
    return this.$$js$exported$prop$modelVersion__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Fragment.prototype, "usage", {
  "get": (function() {
    return this.$$js$exported$prop$usage__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Fragment.prototype, "location", {
  "get": (function() {
    return this.$$js$exported$prop$location__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Fragment.prototype, "raw", {
  "get": (function() {
    return this.$$js$exported$prop$raw__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_Fragment.prototype.references = (function() {
  return this.$$js$exported$meth$references__O()
});
Object.defineProperty($c_Lamf_client_model_document_Fragment.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_Fragment.prototype.withEncodes = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withEncodes__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_Fragment.prototype, "encodes", {
  "get": (function() {
    return this.$$js$exported$prop$encodes__O()
  }),
  "configurable": true
});
var $d_Lamf_client_model_document_Fragment = new $TypeData().initClass({
  Lamf_client_model_document_Fragment: 0
}, false, "amf.client.model.document.Fragment", {
  Lamf_client_model_document_Fragment: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_EncodesModel: 1
});
$c_Lamf_client_model_document_Fragment.prototype.$classData = $d_Lamf_client_model_document_Fragment;
/** @constructor */
function $c_Lamf_client_model_document_Vocabulary() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_document_Vocabulary.prototype = new $h_O();
$c_Lamf_client_model_document_Vocabulary.prototype.constructor = $c_Lamf_client_model_document_Vocabulary;
/** @constructor */
function $h_Lamf_client_model_document_Vocabulary() {
  /*<skip>*/
}
$h_Lamf_client_model_document_Vocabulary.prototype = $c_Lamf_client_model_document_Vocabulary.prototype;
$c_Lamf_client_model_document_Vocabulary.prototype.withBase__T__Lamf_client_model_document_Vocabulary = (function(base) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Base$1;
  $as_Lamf_plugins_document_vocabularies_model_document_Vocabulary($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, base));
  return this
});
$c_Lamf_client_model_document_Vocabulary.prototype.init___Lamf_plugins_document_vocabularies_model_document_Vocabulary = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_document_Vocabulary.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_document_Vocabulary.prototype.init___Lamf_plugins_document_vocabularies_model_document_Vocabulary.call(this, new $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_document_Vocabulary.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Name$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$withRaw__T__O = (function(raw) {
  return $f_Lamf_client_model_document_BaseUnit__withRaw__T__Lamf_client_model_document_BaseUnit(this, raw)
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$findById__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__findById__T__sjs_js_UndefOr(this, id)
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$withReferences__sjs_js_Array__O = (function(references) {
  return $f_Lamf_client_model_document_BaseUnit__withReferences__sjs_js_Array__Lamf_client_model_document_BaseUnit(this, references)
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$references__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__references__sjs_js_Array(this)
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$withImports__sjs_js_Array__O = (function(vocabularies) {
  return this.withImports__sjs_js_Array__Lamf_client_model_document_Vocabulary(vocabularies)
});
$c_Lamf_client_model_document_Vocabulary.prototype.withName__T__Lamf_client_model_document_Vocabulary = (function(name) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Name$1;
  $as_Lamf_plugins_document_vocabularies_model_document_Vocabulary($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name));
  return this
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$datatypePropertyTerms__O = (function() {
  return this.datatypePropertyTerms__sjs_js_Array()
});
$c_Lamf_client_model_document_Vocabulary.prototype.datatypePropertyTerms__sjs_js_Array = (function() {
  var this$3 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var jsx$2 = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Declares$1));
  var jsx$1 = new $c_Lamf_client_model_document_Vocabulary$$anonfun$datatypePropertyTerms$1().init___Lamf_client_model_document_Vocabulary(this);
  var this$2 = $m_sc_Seq$();
  var from = $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().DatatypePropertyMappingConverter__Lamf_client_convert_DatatypePropertyMappingConverter$DatatypePropertyMappingConverter$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$3, from, m).asClient__O()
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$prop$modelVersion__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__modelVersion__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$prop$location__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__location__T(this)
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$withBase__T__O = (function(base) {
  return this.withBase__T__Lamf_client_model_document_Vocabulary(base)
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$prop$base__O = (function() {
  return this.base__Lamf_client_model_StrField()
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$withDeclares__sjs_js_Array__O = (function(declares) {
  return $f_Lamf_client_model_document_DeclaresModel__withDeclares__sjs_js_Array__Lamf_client_model_document_DeclaresModel(this, declares)
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__withId__T__Lamf_client_model_document_BaseUnit(this, id)
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$cloneUnit__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__cloneUnit__Lamf_client_model_document_BaseUnit(this)
});
$c_Lamf_client_model_document_Vocabulary.prototype.description__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_document_Vocabulary.prototype.classTerms__sjs_js_Array = (function() {
  var this$3 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var jsx$2 = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Declares$1));
  var jsx$1 = new $c_Lamf_client_model_document_Vocabulary$$anonfun$classTerms$1().init___Lamf_client_model_document_Vocabulary(this);
  var this$2 = $m_sc_Seq$();
  var from = $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().ClassTermMappingConverter__Lamf_client_convert_ClassTermMappingConverter$ClassTermMappingConverter$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$3, from, m).asClient__O()
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$classTerms__O = (function() {
  return this.classTerms__sjs_js_Array()
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$findByType__T__O = (function(typeId) {
  return $f_Lamf_client_model_document_BaseUnit__findByType__T__sjs_js_Array(this, typeId)
});
$c_Lamf_client_model_document_Vocabulary.prototype.imports__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Imports$1));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().VocabularyReferenceConverter__Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$withLocation__T__O = (function(location) {
  return $f_Lamf_client_model_document_BaseUnit__withLocation__T__Lamf_client_model_document_BaseUnit(this, location)
});
$c_Lamf_client_model_document_Vocabulary.prototype.withExternals__sjs_js_Array__Lamf_client_model_document_Vocabulary = (function(externals) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().ExternalConverter__Lamf_client_convert_ExternalConverter$ExternalConverter$();
  var externals$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, externals, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$().Externals$1;
  $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, externals$1);
  return this
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$prop$raw__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__raw__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_Vocabulary.prototype.withImports__sjs_js_Array__Lamf_client_model_document_Vocabulary = (function(vocabularies) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().VocabularyReferenceConverter__Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$();
  var vocabularies$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, vocabularies, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Imports$1;
  $as_Lamf_plugins_document_vocabularies_model_document_Vocabulary($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, vocabularies$1));
  return this
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$undinternal__Lamf_core_model_document_DeclaresModel = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_Vocabulary.prototype.base__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Base$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$prop$imports__O = (function() {
  return this.imports__sjs_js_Array()
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O = (function(renderOptions) {
  return $f_Lamf_client_model_document_BaseUnit__toNativeRdfModel__Lamf_client_render_RenderOptions__Lamf_core_rdf_RdfModel(this, renderOptions)
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions = (function() {
  return new $c_Lamf_client_render_RenderOptions().init___()
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$withUsage__T__O = (function(usage) {
  return $f_Lamf_client_model_document_BaseUnit__withUsage__T__Lamf_client_model_document_BaseUnit(this, usage)
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$withReferenceAlias__T__T__T__O = (function(alias, fullUrl, relativeUrl) {
  return $f_Lamf_client_model_document_BaseUnit__withReferenceAlias__T__T__T__Lamf_client_model_document_BaseUnit(this, alias, fullUrl, relativeUrl)
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$prop$description__O = (function() {
  return this.description__Lamf_client_model_StrField()
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$objectPropertyTerms__O = (function() {
  return this.objectPropertyTerms__sjs_js_Array()
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$withExternals__sjs_js_Array__O = (function(externals) {
  return this.withExternals__sjs_js_Array__Lamf_client_model_document_Vocabulary(externals)
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$prop$declares__O = (function() {
  return $f_Lamf_client_model_document_DeclaresModel__declares__sjs_js_Array(this)
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_document_Vocabulary(name)
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$meth$withDeclaredElement__Lamf_client_model_domain_DomainElement__O = (function(declared) {
  return $f_Lamf_client_model_document_DeclaresModel__withDeclaredElement__Lamf_client_model_domain_DomainElement__Lamf_client_model_document_DeclaresModel(this, declared)
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$prop$sourceVendor__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__sourceVendor__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$prop$usage__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__usage__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_Vocabulary.prototype.$$js$exported$prop$externals__O = (function() {
  return this.externals__sjs_js_Array()
});
$c_Lamf_client_model_document_Vocabulary.prototype.externals__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(this$1);
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().ExternalConverter__Lamf_client_convert_ExternalConverter$ExternalConverter$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_document_Vocabulary.prototype.objectPropertyTerms__sjs_js_Array = (function() {
  var this$3 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var jsx$2 = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Declares$1));
  var jsx$1 = new $c_Lamf_client_model_document_Vocabulary$$anonfun$objectPropertyTerms$1().init___Lamf_client_model_document_Vocabulary(this);
  var this$2 = $m_sc_Seq$();
  var from = $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().ObjectPropertyMappingConverter__Lamf_client_convert_ObjectPropertyMappingConverter$ObjectPropertyMappingConverter$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$3, from, m).asClient__O()
});
$c_Lamf_client_model_document_Vocabulary.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_document_Vocabulary.prototype.withReferenceAlias = (function(arg, arg$2, arg$3) {
  var prep = $as_T(arg);
  var prep$2 = $as_T(arg$2);
  var prep$3 = $as_T(arg$3);
  return this.$$js$exported$meth$withReferenceAlias__T__T__T__O(prep, prep$2, prep$3)
});
$c_Lamf_client_model_document_Vocabulary.prototype.cloneUnit = (function() {
  return this.$$js$exported$meth$cloneUnit__O()
});
Object.defineProperty($c_Lamf_client_model_document_Vocabulary.prototype, "sourceVendor", {
  "get": (function() {
    return this.$$js$exported$prop$sourceVendor__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_Vocabulary.prototype.findByType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findByType__T__O(prep)
});
$c_Lamf_client_model_document_Vocabulary.prototype.findById = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findById__T__O(prep)
});
$c_Lamf_client_model_document_Vocabulary.prototype.toNativeRdfModel = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions() : $as_Lamf_client_render_RenderOptions(rest[0]));
  return this.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O(prep)
});
$c_Lamf_client_model_document_Vocabulary.prototype.withUsage = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withUsage__T__O(prep)
});
$c_Lamf_client_model_document_Vocabulary.prototype.withLocation = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLocation__T__O(prep)
});
$c_Lamf_client_model_document_Vocabulary.prototype.withRaw = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withRaw__T__O(prep)
});
$c_Lamf_client_model_document_Vocabulary.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_document_Vocabulary.prototype.withReferences = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withReferences__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_Vocabulary.prototype, "modelVersion", {
  "get": (function() {
    return this.$$js$exported$prop$modelVersion__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Vocabulary.prototype, "usage", {
  "get": (function() {
    return this.$$js$exported$prop$usage__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Vocabulary.prototype, "location", {
  "get": (function() {
    return this.$$js$exported$prop$location__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Vocabulary.prototype, "raw", {
  "get": (function() {
    return this.$$js$exported$prop$raw__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_Vocabulary.prototype.references = (function() {
  return this.$$js$exported$meth$references__O()
});
Object.defineProperty($c_Lamf_client_model_document_Vocabulary.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_Vocabulary.prototype.withDeclares = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withDeclares__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_document_Vocabulary.prototype.withDeclaredElement = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withDeclaredElement__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_Vocabulary.prototype, "declares", {
  "get": (function() {
    return this.$$js$exported$prop$declares__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_Vocabulary.prototype.classTerms = (function() {
  return this.$$js$exported$meth$classTerms__O()
});
$c_Lamf_client_model_document_Vocabulary.prototype.datatypePropertyTerms = (function() {
  return this.$$js$exported$meth$datatypePropertyTerms__O()
});
$c_Lamf_client_model_document_Vocabulary.prototype.objectPropertyTerms = (function() {
  return this.$$js$exported$meth$objectPropertyTerms__O()
});
$c_Lamf_client_model_document_Vocabulary.prototype.withImports = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withImports__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_document_Vocabulary.prototype.withExternals = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExternals__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_document_Vocabulary.prototype.withBase = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withBase__T__O(prep)
});
$c_Lamf_client_model_document_Vocabulary.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_Vocabulary.prototype, "externals", {
  "get": (function() {
    return this.$$js$exported$prop$externals__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Vocabulary.prototype, "imports", {
  "get": (function() {
    return this.$$js$exported$prop$imports__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Vocabulary.prototype, "base", {
  "get": (function() {
    return this.$$js$exported$prop$base__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Vocabulary.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Vocabulary.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
var $d_Lamf_client_model_document_Vocabulary = new $TypeData().initClass({
  Lamf_client_model_document_Vocabulary: 0
}, false, "amf.client.model.document.Vocabulary", {
  Lamf_client_model_document_Vocabulary: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_DeclaresModel: 1
});
$c_Lamf_client_model_document_Vocabulary.prototype.$classData = $d_Lamf_client_model_document_Vocabulary;
/** @constructor */
function $c_Lamf_client_model_document_Vocabulary$$anonfun$classTerms$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_client_model_document_Vocabulary$$anonfun$classTerms$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_client_model_document_Vocabulary$$anonfun$classTerms$1.prototype.constructor = $c_Lamf_client_model_document_Vocabulary$$anonfun$classTerms$1;
/** @constructor */
function $h_Lamf_client_model_document_Vocabulary$$anonfun$classTerms$1() {
  /*<skip>*/
}
$h_Lamf_client_model_document_Vocabulary$$anonfun$classTerms$1.prototype = $c_Lamf_client_model_document_Vocabulary$$anonfun$classTerms$1.prototype;
$c_Lamf_client_model_document_Vocabulary$$anonfun$classTerms$1.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_ClassTerm(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_client_model_document_Vocabulary$$anonfun$classTerms$1.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm)
});
$c_Lamf_client_model_document_Vocabulary$$anonfun$classTerms$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_client_model_document_Vocabulary$$anonfun$classTerms$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
$c_Lamf_client_model_document_Vocabulary$$anonfun$classTerms$1.prototype.init___Lamf_client_model_document_Vocabulary = (function($$outer) {
  return this
});
var $d_Lamf_client_model_document_Vocabulary$$anonfun$classTerms$1 = new $TypeData().initClass({
  Lamf_client_model_document_Vocabulary$$anonfun$classTerms$1: 0
}, false, "amf.client.model.document.Vocabulary$$anonfun$classTerms$1", {
  Lamf_client_model_document_Vocabulary$$anonfun$classTerms$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_document_Vocabulary$$anonfun$classTerms$1.prototype.$classData = $d_Lamf_client_model_document_Vocabulary$$anonfun$classTerms$1;
/** @constructor */
function $c_Lamf_client_model_document_Vocabulary$$anonfun$datatypePropertyTerms$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_client_model_document_Vocabulary$$anonfun$datatypePropertyTerms$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_client_model_document_Vocabulary$$anonfun$datatypePropertyTerms$1.prototype.constructor = $c_Lamf_client_model_document_Vocabulary$$anonfun$datatypePropertyTerms$1;
/** @constructor */
function $h_Lamf_client_model_document_Vocabulary$$anonfun$datatypePropertyTerms$1() {
  /*<skip>*/
}
$h_Lamf_client_model_document_Vocabulary$$anonfun$datatypePropertyTerms$1.prototype = $c_Lamf_client_model_document_Vocabulary$$anonfun$datatypePropertyTerms$1.prototype;
$c_Lamf_client_model_document_Vocabulary$$anonfun$datatypePropertyTerms$1.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_client_model_document_Vocabulary$$anonfun$datatypePropertyTerms$1.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm)
});
$c_Lamf_client_model_document_Vocabulary$$anonfun$datatypePropertyTerms$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_client_model_document_Vocabulary$$anonfun$datatypePropertyTerms$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
$c_Lamf_client_model_document_Vocabulary$$anonfun$datatypePropertyTerms$1.prototype.init___Lamf_client_model_document_Vocabulary = (function($$outer) {
  return this
});
var $d_Lamf_client_model_document_Vocabulary$$anonfun$datatypePropertyTerms$1 = new $TypeData().initClass({
  Lamf_client_model_document_Vocabulary$$anonfun$datatypePropertyTerms$1: 0
}, false, "amf.client.model.document.Vocabulary$$anonfun$datatypePropertyTerms$1", {
  Lamf_client_model_document_Vocabulary$$anonfun$datatypePropertyTerms$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_document_Vocabulary$$anonfun$datatypePropertyTerms$1.prototype.$classData = $d_Lamf_client_model_document_Vocabulary$$anonfun$datatypePropertyTerms$1;
/** @constructor */
function $c_Lamf_client_model_document_Vocabulary$$anonfun$objectPropertyTerms$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_client_model_document_Vocabulary$$anonfun$objectPropertyTerms$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_client_model_document_Vocabulary$$anonfun$objectPropertyTerms$1.prototype.constructor = $c_Lamf_client_model_document_Vocabulary$$anonfun$objectPropertyTerms$1;
/** @constructor */
function $h_Lamf_client_model_document_Vocabulary$$anonfun$objectPropertyTerms$1() {
  /*<skip>*/
}
$h_Lamf_client_model_document_Vocabulary$$anonfun$objectPropertyTerms$1.prototype = $c_Lamf_client_model_document_Vocabulary$$anonfun$objectPropertyTerms$1.prototype;
$c_Lamf_client_model_document_Vocabulary$$anonfun$objectPropertyTerms$1.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_client_model_document_Vocabulary$$anonfun$objectPropertyTerms$1.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm)
});
$c_Lamf_client_model_document_Vocabulary$$anonfun$objectPropertyTerms$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_client_model_document_Vocabulary$$anonfun$objectPropertyTerms$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
$c_Lamf_client_model_document_Vocabulary$$anonfun$objectPropertyTerms$1.prototype.init___Lamf_client_model_document_Vocabulary = (function($$outer) {
  return this
});
var $d_Lamf_client_model_document_Vocabulary$$anonfun$objectPropertyTerms$1 = new $TypeData().initClass({
  Lamf_client_model_document_Vocabulary$$anonfun$objectPropertyTerms$1: 0
}, false, "amf.client.model.document.Vocabulary$$anonfun$objectPropertyTerms$1", {
  Lamf_client_model_document_Vocabulary$$anonfun$objectPropertyTerms$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_document_Vocabulary$$anonfun$objectPropertyTerms$1.prototype.$classData = $d_Lamf_client_model_document_Vocabulary$$anonfun$objectPropertyTerms$1;
/** @constructor */
function $c_Lamf_client_model_domain_DialectDomainElement$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_client_model_domain_DialectDomainElement$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_client_model_domain_DialectDomainElement$$anonfun$1.prototype.constructor = $c_Lamf_client_model_domain_DialectDomainElement$$anonfun$1;
/** @constructor */
function $h_Lamf_client_model_domain_DialectDomainElement$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_DialectDomainElement$$anonfun$1.prototype = $c_Lamf_client_model_domain_DialectDomainElement$$anonfun$1.prototype;
$c_Lamf_client_model_domain_DialectDomainElement$$anonfun$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)
});
$c_Lamf_client_model_domain_DialectDomainElement$$anonfun$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_client_model_domain_DialectDomainElement$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_client_model_domain_DialectDomainElement$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
$c_Lamf_client_model_domain_DialectDomainElement$$anonfun$1.prototype.init___Lamf_client_model_domain_DialectDomainElement = (function($$outer) {
  return this
});
var $d_Lamf_client_model_domain_DialectDomainElement$$anonfun$1 = new $TypeData().initClass({
  Lamf_client_model_domain_DialectDomainElement$$anonfun$1: 0
}, false, "amf.client.model.domain.DialectDomainElement$$anonfun$1", {
  Lamf_client_model_domain_DialectDomainElement$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_DialectDomainElement$$anonfun$1.prototype.$classData = $d_Lamf_client_model_domain_DialectDomainElement$$anonfun$1;
function $f_Lamf_client_model_domain_Shape__name__Lamf_client_model_StrField($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var from = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
}
function $f_Lamf_client_model_domain_Shape__withName__T__Lamf_client_model_domain_Shape($thiz, name) {
  var this$3 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return $thiz
}
function $f_Lamf_client_model_domain_Shape__deprecated__Lamf_client_model_BoolField($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var from = $as_Lamf_core_model_BoolField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Deprecated$1));
  $m_Lamf_client_convert_CoreClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
}
function $f_Lamf_client_model_domain_Shape__elseShape__Lamf_client_model_domain_Shape($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var from = $as_Lamf_core_model_domain_Shape(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Else$1));
  var m = $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(from)
}
function $f_Lamf_client_model_domain_Shape__not__Lamf_client_model_domain_Shape($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var from = $as_Lamf_core_model_domain_Shape(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Not$1));
  var m = $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(from)
}
function $f_Lamf_client_model_domain_Shape__withDisplayName__T__Lamf_client_model_domain_Shape($thiz, name) {
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().DisplayName$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name));
  return $thiz
}
function $f_Lamf_client_model_domain_Shape__defaultValue__Lamf_client_model_domain_DataNode($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var from = $as_Lamf_core_model_domain_DataNode(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Default$1));
  var m = $m_Lamf_client_convert_CoreClientConverters$().DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$();
  return m.asClient__Lamf_core_model_domain_DataNode__Lamf_client_model_domain_DataNode(from)
}
function $f_Lamf_client_model_domain_Shape__withInherits__sjs_js_Array__Lamf_client_model_domain_Shape($thiz, inherits) {
  var this$2 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var m = $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var inherits$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, inherits, m).asInternal__sc_Seq();
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, inherits$1));
  return $thiz
}
function $f_Lamf_client_model_domain_Shape__or__sjs_js_Array($thiz) {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var from = $as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Or$1));
  var m = $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
}
function $f_Lamf_client_model_domain_Shape__readOnly__Lamf_client_model_BoolField($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var from = $as_Lamf_core_model_BoolField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().ReadOnly$1));
  $m_Lamf_client_convert_CoreClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
}
function $f_Lamf_client_model_domain_Shape__description__Lamf_client_model_StrField($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var from = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Description$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
}
function $f_Lamf_client_model_domain_Shape__withWriteOnly__Z__Lamf_client_model_domain_Shape($thiz, writeOnly) {
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().WriteOnly$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, writeOnly));
  return $thiz
}
function $f_Lamf_client_model_domain_Shape__inherits__sjs_js_Array($thiz) {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var from = $as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1));
  var m = $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
}
function $f_Lamf_client_model_domain_Shape__withAnd__sjs_js_Array__Lamf_client_model_domain_Shape($thiz, subShapes) {
  var this$2 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var m = $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var subShapes$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, subShapes, m).asInternal__sc_Seq();
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().And$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, subShapes$1));
  return $thiz
}
function $f_Lamf_client_model_domain_Shape__withXone__sjs_js_Array__Lamf_client_model_domain_Shape($thiz, subShapes) {
  var this$2 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var m = $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var subShapes$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, subShapes, m).asInternal__sc_Seq();
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Xone$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, subShapes$1));
  return $thiz
}
function $f_Lamf_client_model_domain_Shape__customShapeProperties__sjs_js_Array($thiz) {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var from = $as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().CustomShapeProperties__Lamf_core_metamodel_Field()));
  var m = $m_Lamf_client_convert_CoreClientConverters$().ShapeExtensionMatcher__Lamf_client_convert_ShapeExtensionConverter$ShapeExtensionMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
}
function $f_Lamf_client_model_domain_Shape__withDefaultStr__T__Lamf_client_model_domain_Shape($thiz, value) {
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().DefaultValueString$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, value));
  return $thiz
}
function $f_Lamf_client_model_domain_Shape__withNode__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Shape($thiz, shape) {
  var this$2 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  $m_Lamf_client_convert_CoreClientConverters$();
  $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var shape$1 = shape.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Not$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, shape$1));
  return $thiz
}
function $f_Lamf_client_model_domain_Shape__withElse__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Shape($thiz, elseShape) {
  var this$2 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  $m_Lamf_client_convert_CoreClientConverters$();
  $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var elseShape$1 = elseShape.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Else$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, elseShape$1));
  return $thiz
}
function $f_Lamf_client_model_domain_Shape__withReadOnly__Z__Lamf_client_model_domain_Shape($thiz, readOnly) {
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().ReadOnly$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, readOnly));
  return $thiz
}
function $f_Lamf_client_model_domain_Shape__values__sjs_js_Array($thiz) {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var from = $as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Values$1));
  var m = $m_Lamf_client_convert_CoreClientConverters$().DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
}
function $f_Lamf_client_model_domain_Shape__withCustomShapePropertyDefinition__T__Lamf_client_model_domain_PropertyShape($thiz, name) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var from = $thiz.$$undinternal__Lamf_core_model_domain_Shape().withCustomShapePropertyDefinition__T__Lamf_core_model_domain_extensions_PropertyShape(name);
  var m = $m_Lamf_client_convert_CoreClientConverters$().PropertyShapeMatcher__Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_extensions_PropertyShape__Lamf_client_model_domain_PropertyShape(from)
}
function $f_Lamf_client_model_domain_Shape__withIf__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Shape($thiz, ifShape) {
  var this$2 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  $m_Lamf_client_convert_CoreClientConverters$();
  $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var ifShape$1 = ifShape.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().If$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, ifShape$1));
  return $thiz
}
function $f_Lamf_client_model_domain_Shape__withCustomShapeProperties__sjs_js_Array__Lamf_client_model_domain_Shape($thiz, customShapeProperties) {
  var this$2 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var m = $m_Lamf_client_convert_CoreClientConverters$().ShapeExtensionMatcher__Lamf_client_convert_ShapeExtensionConverter$ShapeExtensionMatcher$();
  var properties = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, customShapeProperties, m).asInternal__sc_Seq();
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().CustomShapeProperties__Lamf_core_metamodel_Field();
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, properties));
  return $thiz
}
function $f_Lamf_client_model_domain_Shape__withDescription__T__Lamf_client_model_domain_Shape($thiz, description) {
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Description$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, description));
  return $thiz
}
function $f_Lamf_client_model_domain_Shape__customShapePropertyDefinitions__sjs_js_Array($thiz) {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var from = $as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().CustomShapePropertyDefinitions__Lamf_core_metamodel_Field()));
  var m = $m_Lamf_client_convert_CoreClientConverters$().PropertyShapeMatcher__Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
}
function $f_Lamf_client_model_domain_Shape__defaultValueStr__Lamf_client_model_StrField($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var from = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().DefaultValueString$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
}
function $f_Lamf_client_model_domain_Shape__ifShape__Lamf_client_model_domain_Shape($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var from = $as_Lamf_core_model_domain_Shape(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().If$1));
  var m = $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(from)
}
function $f_Lamf_client_model_domain_Shape__thenShape__Lamf_client_model_domain_Shape($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var from = $as_Lamf_core_model_domain_Shape(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Then$1));
  var m = $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(from)
}
function $f_Lamf_client_model_domain_Shape__xone__sjs_js_Array($thiz) {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var from = $as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Xone$1));
  var m = $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
}
function $f_Lamf_client_model_domain_Shape__displayName__Lamf_client_model_StrField($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var from = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().DisplayName$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
}
function $f_Lamf_client_model_domain_Shape__withOr__sjs_js_Array__Lamf_client_model_domain_Shape($thiz, subShapes) {
  var this$2 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var m = $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var subShapes$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, subShapes, m).asInternal__sc_Seq();
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Or$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, subShapes$1));
  return $thiz
}
function $f_Lamf_client_model_domain_Shape__withCustomShapePropertyDefinitions__sjs_js_Array__Lamf_client_model_domain_Shape($thiz, propertyDefinitions) {
  var this$2 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var m = $m_Lamf_client_convert_CoreClientConverters$().PropertyShapeMatcher__Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$();
  var propertyDefinitions$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, propertyDefinitions, m).asInternal__sc_Seq();
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().CustomShapePropertyDefinitions__Lamf_core_metamodel_Field();
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, propertyDefinitions$1));
  return $thiz
}
function $f_Lamf_client_model_domain_Shape__withDeprecated__Z__Lamf_client_model_domain_Shape($thiz, deprecated) {
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Deprecated$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, deprecated));
  return $thiz
}
function $f_Lamf_client_model_domain_Shape__withDefaultValue__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_Shape($thiz, $default) {
  var this$2 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  $m_Lamf_client_convert_CoreClientConverters$();
  $m_Lamf_client_convert_CoreClientConverters$().DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$();
  var $default$1 = $default.$$undinternal__Lamf_core_model_domain_DataNode();
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Default$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, $default$1));
  return $thiz
}
function $f_Lamf_client_model_domain_Shape__writeOnly__Lamf_client_model_BoolField($thiz) {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var from = $as_Lamf_core_model_BoolField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().WriteOnly$1));
  $m_Lamf_client_convert_CoreClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
}
function $f_Lamf_client_model_domain_Shape__and__sjs_js_Array($thiz) {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var from = $as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().And$1));
  var m = $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
}
function $f_Lamf_client_model_domain_Shape__withThen__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Shape($thiz, thenShape) {
  var this$2 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  $m_Lamf_client_convert_CoreClientConverters$();
  $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var thenShape$1 = thenShape.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Then$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, thenShape$1));
  return $thiz
}
function $f_Lamf_client_model_domain_Shape__withValues__sjs_js_Array__Lamf_client_model_domain_Shape($thiz, values) {
  var this$2 = $thiz.$$undinternal__Lamf_core_model_domain_Shape();
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var m = $m_Lamf_client_convert_CoreClientConverters$().DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$();
  var values$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, values, m).asInternal__sc_Seq();
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Values$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, values$1));
  return $thiz
}
function $is_Lamf_client_model_domain_Shape(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_client_model_domain_Shape)))
}
function $as_Lamf_client_model_domain_Shape(obj) {
  return (($is_Lamf_client_model_domain_Shape(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Shape"))
}
function $isArrayOf_Lamf_client_model_domain_Shape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Shape)))
}
function $asArrayOf_Lamf_client_model_domain_Shape(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Shape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Shape;", depth))
}
/** @constructor */
function $c_Lamf_core_annotations_Declares() {
  $c_O.call(this);
  this.declares$1 = null
}
$c_Lamf_core_annotations_Declares.prototype = new $h_O();
$c_Lamf_core_annotations_Declares.prototype.constructor = $c_Lamf_core_annotations_Declares;
/** @constructor */
function $h_Lamf_core_annotations_Declares() {
  /*<skip>*/
}
$h_Lamf_core_annotations_Declares.prototype = $c_Lamf_core_annotations_Declares.prototype;
$c_Lamf_core_annotations_Declares.prototype.productPrefix__T = (function() {
  return "Declares"
});
$c_Lamf_core_annotations_Declares.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_annotations_Declares.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_annotations_Declares)) {
    var Declares$1 = $as_Lamf_core_annotations_Declares(x$1);
    var x = this.declares$1;
    var x$2 = Declares$1.declares$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_core_annotations_Declares.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.declares$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_annotations_Declares.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_Declares.prototype.init___sc_Seq = (function(declares) {
  this.declares$1 = declares;
  return this
});
$c_Lamf_core_annotations_Declares.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_Declares.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_Declares(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_Declares) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.Declares"))
}
function $isArrayOf_Lamf_core_annotations_Declares(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_Declares)))
}
function $asArrayOf_Lamf_core_annotations_Declares(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_Declares(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.Declares;", depth))
}
var $d_Lamf_core_annotations_Declares = new $TypeData().initClass({
  Lamf_core_annotations_Declares: 0
}, false, "amf.core.annotations.Declares", {
  Lamf_core_annotations_Declares: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_Declares.prototype.$classData = $d_Lamf_core_annotations_Declares;
/** @constructor */
function $c_Lamf_core_annotations_DomainExtensionAnnotation() {
  $c_O.call(this);
  this.extension$1 = null
}
$c_Lamf_core_annotations_DomainExtensionAnnotation.prototype = new $h_O();
$c_Lamf_core_annotations_DomainExtensionAnnotation.prototype.constructor = $c_Lamf_core_annotations_DomainExtensionAnnotation;
/** @constructor */
function $h_Lamf_core_annotations_DomainExtensionAnnotation() {
  /*<skip>*/
}
$h_Lamf_core_annotations_DomainExtensionAnnotation.prototype = $c_Lamf_core_annotations_DomainExtensionAnnotation.prototype;
$c_Lamf_core_annotations_DomainExtensionAnnotation.prototype.init___Lamf_core_model_domain_extensions_DomainExtension = (function(extension) {
  this.extension$1 = extension;
  return this
});
$c_Lamf_core_annotations_DomainExtensionAnnotation.prototype.productPrefix__T = (function() {
  return "DomainExtensionAnnotation"
});
$c_Lamf_core_annotations_DomainExtensionAnnotation.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_annotations_DomainExtensionAnnotation.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_annotations_DomainExtensionAnnotation)) {
    var DomainExtensionAnnotation$1 = $as_Lamf_core_annotations_DomainExtensionAnnotation(x$1);
    var x = this.extension$1;
    var x$2 = DomainExtensionAnnotation$1.extension$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_core_annotations_DomainExtensionAnnotation.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.extension$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_annotations_DomainExtensionAnnotation.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_DomainExtensionAnnotation.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_DomainExtensionAnnotation.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_DomainExtensionAnnotation(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_DomainExtensionAnnotation) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.DomainExtensionAnnotation"))
}
function $isArrayOf_Lamf_core_annotations_DomainExtensionAnnotation(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_DomainExtensionAnnotation)))
}
function $asArrayOf_Lamf_core_annotations_DomainExtensionAnnotation(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_DomainExtensionAnnotation(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.DomainExtensionAnnotation;", depth))
}
var $d_Lamf_core_annotations_DomainExtensionAnnotation = new $TypeData().initClass({
  Lamf_core_annotations_DomainExtensionAnnotation: 0
}, false, "amf.core.annotations.DomainExtensionAnnotation", {
  Lamf_core_annotations_DomainExtensionAnnotation: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_DomainExtensionAnnotation.prototype.$classData = $d_Lamf_core_annotations_DomainExtensionAnnotation;
/** @constructor */
function $c_Lamf_core_annotations_ErrorRegistered() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_ErrorRegistered.prototype = new $h_O();
$c_Lamf_core_annotations_ErrorRegistered.prototype.constructor = $c_Lamf_core_annotations_ErrorRegistered;
/** @constructor */
function $h_Lamf_core_annotations_ErrorRegistered() {
  /*<skip>*/
}
$h_Lamf_core_annotations_ErrorRegistered.prototype = $c_Lamf_core_annotations_ErrorRegistered.prototype;
$c_Lamf_core_annotations_ErrorRegistered.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_ErrorRegistered.prototype.productPrefix__T = (function() {
  return "ErrorRegistered"
});
$c_Lamf_core_annotations_ErrorRegistered.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_annotations_ErrorRegistered.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_core_annotations_ErrorRegistered) && ($as_Lamf_core_annotations_ErrorRegistered(x$1), true))
});
$c_Lamf_core_annotations_ErrorRegistered.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_annotations_ErrorRegistered.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_ErrorRegistered.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_ErrorRegistered.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_ErrorRegistered(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_ErrorRegistered) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.ErrorRegistered"))
}
function $isArrayOf_Lamf_core_annotations_ErrorRegistered(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_ErrorRegistered)))
}
function $asArrayOf_Lamf_core_annotations_ErrorRegistered(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_ErrorRegistered(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.ErrorRegistered;", depth))
}
var $d_Lamf_core_annotations_ErrorRegistered = new $TypeData().initClass({
  Lamf_core_annotations_ErrorRegistered: 0
}, false, "amf.core.annotations.ErrorRegistered", {
  Lamf_core_annotations_ErrorRegistered: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_ErrorRegistered.prototype.$classData = $d_Lamf_core_annotations_ErrorRegistered;
/** @constructor */
function $c_Lamf_core_annotations_ExplicitField() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_ExplicitField.prototype = new $h_O();
$c_Lamf_core_annotations_ExplicitField.prototype.constructor = $c_Lamf_core_annotations_ExplicitField;
/** @constructor */
function $h_Lamf_core_annotations_ExplicitField() {
  /*<skip>*/
}
$h_Lamf_core_annotations_ExplicitField.prototype = $c_Lamf_core_annotations_ExplicitField.prototype;
$c_Lamf_core_annotations_ExplicitField.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_ExplicitField.prototype.productPrefix__T = (function() {
  return "ExplicitField"
});
$c_Lamf_core_annotations_ExplicitField.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_annotations_ExplicitField.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_core_annotations_ExplicitField) && ($as_Lamf_core_annotations_ExplicitField(x$1), true))
});
$c_Lamf_core_annotations_ExplicitField.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_annotations_ExplicitField.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_ExplicitField.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_ExplicitField.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_ExplicitField(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_ExplicitField) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.ExplicitField"))
}
function $isArrayOf_Lamf_core_annotations_ExplicitField(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_ExplicitField)))
}
function $asArrayOf_Lamf_core_annotations_ExplicitField(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_ExplicitField(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.ExplicitField;", depth))
}
var $d_Lamf_core_annotations_ExplicitField = new $TypeData().initClass({
  Lamf_core_annotations_ExplicitField: 0
}, false, "amf.core.annotations.ExplicitField", {
  Lamf_core_annotations_ExplicitField: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_ExplicitField.prototype.$classData = $d_Lamf_core_annotations_ExplicitField;
/** @constructor */
function $c_Lamf_core_annotations_ReferenceTargets() {
  $c_O.call(this);
  this.targets$1 = null
}
$c_Lamf_core_annotations_ReferenceTargets.prototype = new $h_O();
$c_Lamf_core_annotations_ReferenceTargets.prototype.constructor = $c_Lamf_core_annotations_ReferenceTargets;
/** @constructor */
function $h_Lamf_core_annotations_ReferenceTargets() {
  /*<skip>*/
}
$h_Lamf_core_annotations_ReferenceTargets.prototype = $c_Lamf_core_annotations_ReferenceTargets.prototype;
$c_Lamf_core_annotations_ReferenceTargets.prototype.productPrefix__T = (function() {
  return "ReferenceTargets"
});
$c_Lamf_core_annotations_ReferenceTargets.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_annotations_ReferenceTargets.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_annotations_ReferenceTargets)) {
    var ReferenceTargets$1 = $as_Lamf_core_annotations_ReferenceTargets(x$1);
    var x = this.targets$1;
    var x$2 = ReferenceTargets$1.targets$1;
    return ((x === null) ? (x$2 === null) : $f_sc_GenMapLike__equals__O__Z(x, x$2))
  } else {
    return false
  }
});
$c_Lamf_core_annotations_ReferenceTargets.prototype.init___sci_Map = (function(targets) {
  this.targets$1 = targets;
  return this
});
$c_Lamf_core_annotations_ReferenceTargets.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.targets$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_annotations_ReferenceTargets.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_ReferenceTargets.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_ReferenceTargets.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_annotations_ReferenceTargets.prototype.$$plus$plus__sci_Map__Lamf_core_annotations_ReferenceTargets = (function(t) {
  var targets = this.targets$1.$$plus$plus__sc_GenTraversableOnce__sci_Map(t);
  return new $c_Lamf_core_annotations_ReferenceTargets().init___sci_Map(targets)
});
function $as_Lamf_core_annotations_ReferenceTargets(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_ReferenceTargets) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.ReferenceTargets"))
}
function $isArrayOf_Lamf_core_annotations_ReferenceTargets(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_ReferenceTargets)))
}
function $asArrayOf_Lamf_core_annotations_ReferenceTargets(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_ReferenceTargets(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.ReferenceTargets;", depth))
}
var $d_Lamf_core_annotations_ReferenceTargets = new $TypeData().initClass({
  Lamf_core_annotations_ReferenceTargets: 0
}, false, "amf.core.annotations.ReferenceTargets", {
  Lamf_core_annotations_ReferenceTargets: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_ReferenceTargets.prototype.$classData = $d_Lamf_core_annotations_ReferenceTargets;
/** @constructor */
function $c_Lamf_core_annotations_References() {
  $c_O.call(this);
  this.references$1 = null
}
$c_Lamf_core_annotations_References.prototype = new $h_O();
$c_Lamf_core_annotations_References.prototype.constructor = $c_Lamf_core_annotations_References;
/** @constructor */
function $h_Lamf_core_annotations_References() {
  /*<skip>*/
}
$h_Lamf_core_annotations_References.prototype = $c_Lamf_core_annotations_References.prototype;
$c_Lamf_core_annotations_References.prototype.productPrefix__T = (function() {
  return "References"
});
$c_Lamf_core_annotations_References.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_annotations_References.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_annotations_References)) {
    var References$1 = $as_Lamf_core_annotations_References(x$1);
    var x = this.references$1;
    var x$2 = References$1.references$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_core_annotations_References.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_annotations_References.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_References.prototype.init___sc_Seq = (function(references) {
  this.references$1 = references;
  return this
});
$c_Lamf_core_annotations_References.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_References.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_References(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_References) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.References"))
}
function $isArrayOf_Lamf_core_annotations_References(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_References)))
}
function $asArrayOf_Lamf_core_annotations_References(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_References(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.References;", depth))
}
var $d_Lamf_core_annotations_References = new $TypeData().initClass({
  Lamf_core_annotations_References: 0
}, false, "amf.core.annotations.References", {
  Lamf_core_annotations_References: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_References.prototype.$classData = $d_Lamf_core_annotations_References;
/** @constructor */
function $c_Lamf_core_annotations_ScalarType() {
  $c_O.call(this);
  this.datatype$1 = null
}
$c_Lamf_core_annotations_ScalarType.prototype = new $h_O();
$c_Lamf_core_annotations_ScalarType.prototype.constructor = $c_Lamf_core_annotations_ScalarType;
/** @constructor */
function $h_Lamf_core_annotations_ScalarType() {
  /*<skip>*/
}
$h_Lamf_core_annotations_ScalarType.prototype = $c_Lamf_core_annotations_ScalarType.prototype;
$c_Lamf_core_annotations_ScalarType.prototype.productPrefix__T = (function() {
  return "ScalarType"
});
$c_Lamf_core_annotations_ScalarType.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_annotations_ScalarType.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_annotations_ScalarType)) {
    var ScalarType$1 = $as_Lamf_core_annotations_ScalarType(x$1);
    return (this.datatype$1 === ScalarType$1.datatype$1)
  } else {
    return false
  }
});
$c_Lamf_core_annotations_ScalarType.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.datatype$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_annotations_ScalarType.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_ScalarType.prototype.init___T = (function(datatype) {
  this.datatype$1 = datatype;
  return this
});
$c_Lamf_core_annotations_ScalarType.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_ScalarType.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_ScalarType(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_ScalarType) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.ScalarType"))
}
function $isArrayOf_Lamf_core_annotations_ScalarType(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_ScalarType)))
}
function $asArrayOf_Lamf_core_annotations_ScalarType(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_ScalarType(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.ScalarType;", depth))
}
var $d_Lamf_core_annotations_ScalarType = new $TypeData().initClass({
  Lamf_core_annotations_ScalarType: 0
}, false, "amf.core.annotations.ScalarType", {
  Lamf_core_annotations_ScalarType: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_ScalarType.prototype.$classData = $d_Lamf_core_annotations_ScalarType;
/** @constructor */
function $c_Lamf_core_annotations_SourceAST() {
  $c_O.call(this);
  this.ast$1 = null
}
$c_Lamf_core_annotations_SourceAST.prototype = new $h_O();
$c_Lamf_core_annotations_SourceAST.prototype.constructor = $c_Lamf_core_annotations_SourceAST;
/** @constructor */
function $h_Lamf_core_annotations_SourceAST() {
  /*<skip>*/
}
$h_Lamf_core_annotations_SourceAST.prototype = $c_Lamf_core_annotations_SourceAST.prototype;
$c_Lamf_core_annotations_SourceAST.prototype.productPrefix__T = (function() {
  return "SourceAST"
});
$c_Lamf_core_annotations_SourceAST.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_annotations_SourceAST.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_annotations_SourceAST)) {
    var SourceAST$1 = $as_Lamf_core_annotations_SourceAST(x$1);
    var x = this.ast$1;
    var x$2 = SourceAST$1.ast$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_core_annotations_SourceAST.prototype.init___Lorg_yaml_model_YPart = (function(ast) {
  this.ast$1 = ast;
  return this
});
$c_Lamf_core_annotations_SourceAST.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.ast$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_annotations_SourceAST.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_SourceAST.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_SourceAST.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_SourceAST(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_SourceAST) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.SourceAST"))
}
function $isArrayOf_Lamf_core_annotations_SourceAST(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_SourceAST)))
}
function $asArrayOf_Lamf_core_annotations_SourceAST(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_SourceAST(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.SourceAST;", depth))
}
var $d_Lamf_core_annotations_SourceAST = new $TypeData().initClass({
  Lamf_core_annotations_SourceAST: 0
}, false, "amf.core.annotations.SourceAST", {
  Lamf_core_annotations_SourceAST: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_SourceAST.prototype.$classData = $d_Lamf_core_annotations_SourceAST;
/** @constructor */
function $c_Lamf_core_annotations_SourceNode() {
  $c_O.call(this);
  this.node$1 = null
}
$c_Lamf_core_annotations_SourceNode.prototype = new $h_O();
$c_Lamf_core_annotations_SourceNode.prototype.constructor = $c_Lamf_core_annotations_SourceNode;
/** @constructor */
function $h_Lamf_core_annotations_SourceNode() {
  /*<skip>*/
}
$h_Lamf_core_annotations_SourceNode.prototype = $c_Lamf_core_annotations_SourceNode.prototype;
$c_Lamf_core_annotations_SourceNode.prototype.productPrefix__T = (function() {
  return "SourceNode"
});
$c_Lamf_core_annotations_SourceNode.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_annotations_SourceNode.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_annotations_SourceNode)) {
    var SourceNode$1 = $as_Lamf_core_annotations_SourceNode(x$1);
    var this$1 = this.node$1;
    var b = SourceNode$1.node$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_core_annotations_SourceNode.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.node$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_annotations_SourceNode.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_SourceNode.prototype.init___Lorg_yaml_model_YNode = (function(node) {
  this.node$1 = node;
  return this
});
$c_Lamf_core_annotations_SourceNode.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_SourceNode.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_SourceNode(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_SourceNode) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.SourceNode"))
}
function $isArrayOf_Lamf_core_annotations_SourceNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_SourceNode)))
}
function $asArrayOf_Lamf_core_annotations_SourceNode(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_SourceNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.SourceNode;", depth))
}
var $d_Lamf_core_annotations_SourceNode = new $TypeData().initClass({
  Lamf_core_annotations_SourceNode: 0
}, false, "amf.core.annotations.SourceNode", {
  Lamf_core_annotations_SourceNode: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_SourceNode.prototype.$classData = $d_Lamf_core_annotations_SourceNode;
/** @constructor */
function $c_Lamf_core_annotations_TypeAlias() {
  $c_O.call(this);
  this.aliasId$1 = null
}
$c_Lamf_core_annotations_TypeAlias.prototype = new $h_O();
$c_Lamf_core_annotations_TypeAlias.prototype.constructor = $c_Lamf_core_annotations_TypeAlias;
/** @constructor */
function $h_Lamf_core_annotations_TypeAlias() {
  /*<skip>*/
}
$h_Lamf_core_annotations_TypeAlias.prototype = $c_Lamf_core_annotations_TypeAlias.prototype;
$c_Lamf_core_annotations_TypeAlias.prototype.productPrefix__T = (function() {
  return "TypeAlias"
});
$c_Lamf_core_annotations_TypeAlias.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_annotations_TypeAlias.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_annotations_TypeAlias)) {
    var TypeAlias$1 = $as_Lamf_core_annotations_TypeAlias(x$1);
    return (this.aliasId$1 === TypeAlias$1.aliasId$1)
  } else {
    return false
  }
});
$c_Lamf_core_annotations_TypeAlias.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.aliasId$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_annotations_TypeAlias.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_TypeAlias.prototype.init___T = (function(aliasId) {
  this.aliasId$1 = aliasId;
  return this
});
$c_Lamf_core_annotations_TypeAlias.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_TypeAlias.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_TypeAlias(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_TypeAlias) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.TypeAlias"))
}
function $isArrayOf_Lamf_core_annotations_TypeAlias(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_TypeAlias)))
}
function $asArrayOf_Lamf_core_annotations_TypeAlias(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_TypeAlias(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.TypeAlias;", depth))
}
var $d_Lamf_core_annotations_TypeAlias = new $TypeData().initClass({
  Lamf_core_annotations_TypeAlias: 0
}, false, "amf.core.annotations.TypeAlias", {
  Lamf_core_annotations_TypeAlias: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_TypeAlias.prototype.$classData = $d_Lamf_core_annotations_TypeAlias;
/** @constructor */
function $c_Lamf_core_annotations_VirtualObject() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_VirtualObject.prototype = new $h_O();
$c_Lamf_core_annotations_VirtualObject.prototype.constructor = $c_Lamf_core_annotations_VirtualObject;
/** @constructor */
function $h_Lamf_core_annotations_VirtualObject() {
  /*<skip>*/
}
$h_Lamf_core_annotations_VirtualObject.prototype = $c_Lamf_core_annotations_VirtualObject.prototype;
$c_Lamf_core_annotations_VirtualObject.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_VirtualObject.prototype.productPrefix__T = (function() {
  return "VirtualObject"
});
$c_Lamf_core_annotations_VirtualObject.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_annotations_VirtualObject.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_core_annotations_VirtualObject) && ($as_Lamf_core_annotations_VirtualObject(x$1), true))
});
$c_Lamf_core_annotations_VirtualObject.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_annotations_VirtualObject.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_VirtualObject.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_VirtualObject.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_VirtualObject(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_VirtualObject) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.VirtualObject"))
}
function $isArrayOf_Lamf_core_annotations_VirtualObject(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_VirtualObject)))
}
function $asArrayOf_Lamf_core_annotations_VirtualObject(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_VirtualObject(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.VirtualObject;", depth))
}
var $d_Lamf_core_annotations_VirtualObject = new $TypeData().initClass({
  Lamf_core_annotations_VirtualObject: 0
}, false, "amf.core.annotations.VirtualObject", {
  Lamf_core_annotations_VirtualObject: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_VirtualObject.prototype.$classData = $d_Lamf_core_annotations_VirtualObject;
function $is_Lamf_core_emitter_SpecOrdering(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_emitter_SpecOrdering)))
}
function $as_Lamf_core_emitter_SpecOrdering(obj) {
  return (($is_Lamf_core_emitter_SpecOrdering(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.emitter.SpecOrdering"))
}
function $isArrayOf_Lamf_core_emitter_SpecOrdering(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_emitter_SpecOrdering)))
}
function $asArrayOf_Lamf_core_emitter_SpecOrdering(obj, depth) {
  return (($isArrayOf_Lamf_core_emitter_SpecOrdering(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.emitter.SpecOrdering;", depth))
}
/** @constructor */
function $c_Lamf_core_metamodel_Type$Scalar() {
  $c_O.call(this);
  this.id$1 = null;
  this.type$1 = null
}
$c_Lamf_core_metamodel_Type$Scalar.prototype = new $h_O();
$c_Lamf_core_metamodel_Type$Scalar.prototype.constructor = $c_Lamf_core_metamodel_Type$Scalar;
/** @constructor */
function $h_Lamf_core_metamodel_Type$Scalar() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_Type$Scalar.prototype = $c_Lamf_core_metamodel_Type$Scalar.prototype;
$c_Lamf_core_metamodel_Type$Scalar.prototype.productPrefix__T = (function() {
  return "Scalar"
});
$c_Lamf_core_metamodel_Type$Scalar.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_metamodel_Type$Scalar.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_metamodel_Type$Scalar)) {
    var Scalar$1 = $as_Lamf_core_metamodel_Type$Scalar(x$1);
    return (this.id$1 === Scalar$1.id$1)
  } else {
    return false
  }
});
$c_Lamf_core_metamodel_Type$Scalar.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.id$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_metamodel_Type$Scalar.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_metamodel_Type$Scalar.prototype.init___T = (function(id) {
  this.id$1 = id;
  $m_sci_List$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Xsd$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, id)];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  this.type$1 = result;
  return this
});
$c_Lamf_core_metamodel_Type$Scalar.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_metamodel_Type$Scalar.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_metamodel_Type$Scalar.prototype.type__sci_List = (function() {
  return this.type$1
});
function $as_Lamf_core_metamodel_Type$Scalar(obj) {
  return (((obj instanceof $c_Lamf_core_metamodel_Type$Scalar) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.metamodel.Type$Scalar"))
}
function $isArrayOf_Lamf_core_metamodel_Type$Scalar(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_metamodel_Type$Scalar)))
}
function $asArrayOf_Lamf_core_metamodel_Type$Scalar(obj, depth) {
  return (($isArrayOf_Lamf_core_metamodel_Type$Scalar(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.metamodel.Type$Scalar;", depth))
}
function $f_Lamf_core_metamodel_document_DocumentModel__$$init$__V($thiz) {
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var x$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "Document");
  var this$3 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var x$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "Fragment");
  var this$5 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$5, "Module");
  var this$7 = $m_Lamf_core_metamodel_document_BaseUnitModel$().type$1;
  var this$8 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$7);
  var this$9 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$8);
  $thiz.amf$core$metamodel$document$DocumentModel$$undsetter$und$type$und$eq__sci_List__V(new $c_sci_$colon$colon().init___O__sci_List(x$3, this$9));
  var x$5 = $thiz.Encodes__Lamf_core_metamodel_Field();
  var x$4 = $thiz.Declares__Lamf_core_metamodel_Field();
  var this$10 = $m_Lamf_core_metamodel_document_BaseUnitModel$().fields$1;
  var this$11 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$10);
  $thiz.amf$core$metamodel$document$DocumentModel$$undsetter$und$fields$und$eq__sci_List__V(new $c_sci_$colon$colon().init___O__sci_List(x$5, this$11))
}
function $is_Lamf_core_metamodel_document_DocumentModel(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_metamodel_document_DocumentModel)))
}
function $as_Lamf_core_metamodel_document_DocumentModel(obj) {
  return (($is_Lamf_core_metamodel_document_DocumentModel(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.metamodel.document.DocumentModel"))
}
function $isArrayOf_Lamf_core_metamodel_document_DocumentModel(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_metamodel_document_DocumentModel)))
}
function $asArrayOf_Lamf_core_metamodel_document_DocumentModel(obj, depth) {
  return (($isArrayOf_Lamf_core_metamodel_document_DocumentModel(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.metamodel.document.DocumentModel;", depth))
}
/** @constructor */
function $c_Lamf_core_metamodel_document_ExternalFragmentModel$() {
  $c_O.call(this);
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Encodes$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null
}
$c_Lamf_core_metamodel_document_ExternalFragmentModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_document_ExternalFragmentModel$.prototype.constructor = $c_Lamf_core_metamodel_document_ExternalFragmentModel$;
/** @constructor */
function $h_Lamf_core_metamodel_document_ExternalFragmentModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_document_ExternalFragmentModel$.prototype = $c_Lamf_core_metamodel_document_ExternalFragmentModel$.prototype;
$c_Lamf_core_metamodel_document_ExternalFragmentModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_document_ExternalFragmentModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V(this);
  this.fields$1 = $m_Lamf_core_metamodel_document_FragmentModel$().fields$1;
  $m_sci_List$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "ExternalFragment")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_document_FragmentModel$().type$1;
  var this$7 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "External Fragment", "Fragment encoding an external entity", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_document_ExternalFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_core_metamodel_document_ExternalFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_core_metamodel_document_ExternalFragmentModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_document_ExternalFragmentModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_core_metamodel_document_ExternalFragmentModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_document_ExternalFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_core_metamodel_document_ExternalFragmentModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_core_model_document_ExternalFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_core_metamodel_document_ExternalFragmentModel$.prototype.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Encodes$1 = x$1
});
$c_Lamf_core_metamodel_document_ExternalFragmentModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_core_metamodel_document_ExternalFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_core_metamodel_document_ExternalFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_core_metamodel_document_ExternalFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_core_metamodel_document_ExternalFragmentModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_document_ExternalFragmentModel$: 0
}, false, "amf.core.metamodel.document.ExternalFragmentModel$", {
  Lamf_core_metamodel_document_ExternalFragmentModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_FragmentModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_core_metamodel_document_ExternalFragmentModel$.prototype.$classData = $d_Lamf_core_metamodel_document_ExternalFragmentModel$;
var $n_Lamf_core_metamodel_document_ExternalFragmentModel$ = (void 0);
function $m_Lamf_core_metamodel_document_ExternalFragmentModel$() {
  if ((!$n_Lamf_core_metamodel_document_ExternalFragmentModel$)) {
    $n_Lamf_core_metamodel_document_ExternalFragmentModel$ = new $c_Lamf_core_metamodel_document_ExternalFragmentModel$().init___()
  };
  return $n_Lamf_core_metamodel_document_ExternalFragmentModel$
}
/** @constructor */
function $c_Lamf_core_metamodel_document_FragmentModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.Encodes$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null
}
$c_Lamf_core_metamodel_document_FragmentModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_document_FragmentModel$.prototype.constructor = $c_Lamf_core_metamodel_document_FragmentModel$;
/** @constructor */
function $h_Lamf_core_metamodel_document_FragmentModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_document_FragmentModel$.prototype = $c_Lamf_core_metamodel_document_FragmentModel$.prototype;
$c_Lamf_core_metamodel_document_FragmentModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_document_FragmentModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V(this);
  $m_sci_List$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "Fragment")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_document_BaseUnitModel$().type$1;
  var this$7 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
  var x$1 = this.Encodes$1;
  var this$8 = $m_Lamf_core_metamodel_document_BaseUnitModel$().fields$1;
  this.fields$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$8);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "Fragment", "A Fragment is a parsing Unit that encodes a DomainElement", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_document_FragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_core_metamodel_document_FragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_core_metamodel_document_FragmentModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_document_FragmentModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_document_FragmentModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_core_metamodel_document_FragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_core_metamodel_document_FragmentModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  return $f_Lamf_core_metamodel_document_FragmentModel__modelInstance__Lamf_core_model_domain_AmfObject(this)
});
$c_Lamf_core_metamodel_document_FragmentModel$.prototype.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Encodes$1 = x$1
});
$c_Lamf_core_metamodel_document_FragmentModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_core_metamodel_document_FragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_core_metamodel_document_FragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_core_metamodel_document_FragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_core_metamodel_document_FragmentModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_document_FragmentModel$: 0
}, false, "amf.core.metamodel.document.FragmentModel$", {
  Lamf_core_metamodel_document_FragmentModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_FragmentModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_core_metamodel_document_FragmentModel$.prototype.$classData = $d_Lamf_core_metamodel_document_FragmentModel$;
var $n_Lamf_core_metamodel_document_FragmentModel$ = (void 0);
function $m_Lamf_core_metamodel_document_FragmentModel$() {
  if ((!$n_Lamf_core_metamodel_document_FragmentModel$)) {
    $n_Lamf_core_metamodel_document_FragmentModel$ = new $c_Lamf_core_metamodel_document_FragmentModel$().init___()
  };
  return $n_Lamf_core_metamodel_document_FragmentModel$
}
/** @constructor */
function $c_Lamf_core_metamodel_document_ModuleModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.Declares$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null
}
$c_Lamf_core_metamodel_document_ModuleModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_document_ModuleModel$.prototype.constructor = $c_Lamf_core_metamodel_document_ModuleModel$;
/** @constructor */
function $h_Lamf_core_metamodel_document_ModuleModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_document_ModuleModel$.prototype = $c_Lamf_core_metamodel_document_ModuleModel$.prototype;
$c_Lamf_core_metamodel_document_ModuleModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_document_ModuleModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_ModuleModel__$$init$__V(this);
  $m_sci_List$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "Module")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_document_BaseUnitModel$().type$1;
  var this$7 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
  var x$1 = this.Declares$1;
  var this$8 = $m_Lamf_core_metamodel_document_BaseUnitModel$().fields$1;
  this.fields$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$8);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "Module", "A Module is a parsing Unit that declares DomainElements that can be referenced from the DomainElements in other parsing Units.\nIt main purpose is to expose the declared references so they can be re-used", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_document_ModuleModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_core_metamodel_document_ModuleModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_core_metamodel_document_ModuleModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_document_ModuleModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_document_ModuleModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_core_metamodel_document_ModuleModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_core_metamodel_document_ModuleModel$.prototype.amf$core$metamodel$document$ModuleModel$$undsetter$und$Declares$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Declares$1 = x$1
});
$c_Lamf_core_metamodel_document_ModuleModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_core_model_document_Module().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_core_metamodel_document_ModuleModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_core_metamodel_document_ModuleModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_core_metamodel_document_ModuleModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_core_metamodel_document_ModuleModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_core_metamodel_document_ModuleModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_document_ModuleModel$: 0
}, false, "amf.core.metamodel.document.ModuleModel$", {
  Lamf_core_metamodel_document_ModuleModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_ModuleModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_core_metamodel_document_ModuleModel$.prototype.$classData = $d_Lamf_core_metamodel_document_ModuleModel$;
var $n_Lamf_core_metamodel_document_ModuleModel$ = (void 0);
function $m_Lamf_core_metamodel_document_ModuleModel$() {
  if ((!$n_Lamf_core_metamodel_document_ModuleModel$)) {
    $n_Lamf_core_metamodel_document_ModuleModel$ = new $c_Lamf_core_metamodel_document_ModuleModel$().init___()
  };
  return $n_Lamf_core_metamodel_document_ModuleModel$
}
/** @constructor */
function $c_Lamf_core_metamodel_document_PayloadFragmentModel$() {
  $c_O.call(this);
  this.MediaType$1 = null;
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Encodes$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null
}
$c_Lamf_core_metamodel_document_PayloadFragmentModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_document_PayloadFragmentModel$.prototype.constructor = $c_Lamf_core_metamodel_document_PayloadFragmentModel$;
/** @constructor */
function $h_Lamf_core_metamodel_document_PayloadFragmentModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_document_PayloadFragmentModel$.prototype = $c_Lamf_core_metamodel_document_PayloadFragmentModel$.prototype;
$c_Lamf_core_metamodel_document_PayloadFragmentModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_document_PayloadFragmentModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.MediaType$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "mediaType"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "mediaType", "HTTP Media type associated to the encoded fragment information", $m_sci_Nil$()), true);
  var x$3 = this.Encodes$1;
  var x$2 = this.MediaType$1;
  var this$4 = $m_Lamf_core_metamodel_document_BaseUnitModel$().fields$1;
  var this$5 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$4);
  this.fields$1 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$5);
  $m_sci_List$();
  var this$6 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$6, "PayloadFragment")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$11 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$11);
    i = (((-1) + i) | 0)
  };
  var jsx$3 = result;
  var jsx$2 = $m_Lamf_core_metamodel_document_FragmentModel$().type$1;
  var this$12 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$12.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Payload Fragment", "Fragment encoding HTTP payload information", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_document_PayloadFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_core_metamodel_document_PayloadFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_core_metamodel_document_PayloadFragmentModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_document_PayloadFragmentModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_document_PayloadFragmentModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_core_metamodel_document_PayloadFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_core_metamodel_document_PayloadFragmentModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  return $f_Lamf_core_metamodel_document_FragmentModel__modelInstance__Lamf_core_model_domain_AmfObject(this)
});
$c_Lamf_core_metamodel_document_PayloadFragmentModel$.prototype.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Encodes$1 = x$1
});
$c_Lamf_core_metamodel_document_PayloadFragmentModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_core_metamodel_document_PayloadFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_core_metamodel_document_PayloadFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_core_metamodel_document_PayloadFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_core_metamodel_document_PayloadFragmentModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_document_PayloadFragmentModel$: 0
}, false, "amf.core.metamodel.document.PayloadFragmentModel$", {
  Lamf_core_metamodel_document_PayloadFragmentModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_FragmentModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_core_metamodel_document_PayloadFragmentModel$.prototype.$classData = $d_Lamf_core_metamodel_document_PayloadFragmentModel$;
var $n_Lamf_core_metamodel_document_PayloadFragmentModel$ = (void 0);
function $m_Lamf_core_metamodel_document_PayloadFragmentModel$() {
  if ((!$n_Lamf_core_metamodel_document_PayloadFragmentModel$)) {
    $n_Lamf_core_metamodel_document_PayloadFragmentModel$ = new $c_Lamf_core_metamodel_document_PayloadFragmentModel$().init___()
  };
  return $n_Lamf_core_metamodel_document_PayloadFragmentModel$
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_DataNodeModel$() {
  $c_O.call(this);
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_core_metamodel_domain_DataNodeModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_DataNodeModel$.prototype.constructor = $c_Lamf_core_metamodel_domain_DataNodeModel$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_DataNodeModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_DataNodeModel$.prototype = $c_Lamf_core_metamodel_domain_DataNodeModel$.prototype;
$c_Lamf_core_metamodel_domain_DataNodeModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_DataNodeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  $m_sci_List$();
  var array = [this.Name$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2));
  var this$6 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$6, "Node");
  var this$8 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$8);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Data$1, "Data Node", "Base class for all data nodes parsed from the data structure", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_domain_DataNodeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_core_metamodel_domain_DataNodeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_domain_DataNodeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_domain_DataNodeModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_core_metamodel_domain_DataNodeModel$.prototype.modelInstance__sr_Nothing$ = (function() {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("DataNode is an abstract class and it cannot be instantiated directly"))
});
$c_Lamf_core_metamodel_domain_DataNodeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_core_metamodel_domain_DataNodeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  this.modelInstance__sr_Nothing$()
});
$c_Lamf_core_metamodel_domain_DataNodeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_core_metamodel_domain_DataNodeModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_core_metamodel_domain_DataNodeModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_DataNodeModel$: 0
}, false, "amf.core.metamodel.domain.DataNodeModel$", {
  Lamf_core_metamodel_domain_DataNodeModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1
});
$c_Lamf_core_metamodel_domain_DataNodeModel$.prototype.$classData = $d_Lamf_core_metamodel_domain_DataNodeModel$;
var $n_Lamf_core_metamodel_domain_DataNodeModel$ = (void 0);
function $m_Lamf_core_metamodel_domain_DataNodeModel$() {
  if ((!$n_Lamf_core_metamodel_domain_DataNodeModel$)) {
    $n_Lamf_core_metamodel_domain_DataNodeModel$ = new $c_Lamf_core_metamodel_domain_DataNodeModel$().init___()
  };
  return $n_Lamf_core_metamodel_domain_DataNodeModel$
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_ObjectNodeModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_core_metamodel_domain_ObjectNodeModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_ObjectNodeModel$.prototype.constructor = $c_Lamf_core_metamodel_domain_ObjectNodeModel$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_ObjectNodeModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_ObjectNodeModel$.prototype = $c_Lamf_core_metamodel_domain_ObjectNodeModel$.prototype;
$c_Lamf_core_metamodel_domain_ObjectNodeModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_ObjectNodeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ObjectNodeModel__$$init$__V(this);
  return this
});
$c_Lamf_core_metamodel_domain_ObjectNodeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_core_metamodel_domain_ObjectNodeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_domain_ObjectNodeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_domain_ObjectNodeModel$.prototype.fields__sci_List = (function() {
  return $m_Lamf_core_metamodel_domain_DataNodeModel$().fields$1
});
$c_Lamf_core_metamodel_domain_ObjectNodeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_core_metamodel_domain_ObjectNodeModel$.prototype.amf$core$metamodel$domain$ObjectNodeModel$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  this.doc$1 = x$1
});
$c_Lamf_core_metamodel_domain_ObjectNodeModel$.prototype.amf$core$metamodel$domain$ObjectNodeModel$$undsetter$und$type$und$eq__sci_List__V = (function(x$1) {
  this.type$1 = x$1
});
$c_Lamf_core_metamodel_domain_ObjectNodeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_model_domain_ObjectNode$();
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_core_model_domain_ObjectNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_core_metamodel_domain_ObjectNodeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_core_metamodel_domain_ObjectNodeModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_ObjectNodeModel$: 0
}, false, "amf.core.metamodel.domain.ObjectNodeModel$", {
  Lamf_core_metamodel_domain_ObjectNodeModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_ObjectNodeModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_core_metamodel_domain_ObjectNodeModel$.prototype.$classData = $d_Lamf_core_metamodel_domain_ObjectNodeModel$;
var $n_Lamf_core_metamodel_domain_ObjectNodeModel$ = (void 0);
function $m_Lamf_core_metamodel_domain_ObjectNodeModel$() {
  if ((!$n_Lamf_core_metamodel_domain_ObjectNodeModel$)) {
    $n_Lamf_core_metamodel_domain_ObjectNodeModel$ = new $c_Lamf_core_metamodel_domain_ObjectNodeModel$().init___()
  };
  return $n_Lamf_core_metamodel_domain_ObjectNodeModel$
}
function $f_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel__fields__sci_List($thiz) {
  $m_sci_List$();
  var array = [$thiz.Name__Lamf_core_metamodel_Field(), $thiz.Target__Lamf_core_metamodel_Field(), $thiz.Variables__Lamf_core_metamodel_Field()];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
}
function $f_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.amf$core$metamodel$domain$templates$ParametrizedDeclarationModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "target"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "target", "Target node for the parameter", $m_sci_Nil$()), true));
  var jsx$2 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_domain_templates_VariableValueModel$());
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.amf$core$metamodel$domain$templates$ParametrizedDeclarationModel$$undsetter$und$Variables$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "variable"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "variable", "Variables to be replaced in the graph template introduced by an AbstractDeclaration", $m_sci_Nil$()), true));
  $thiz.amf$core$metamodel$domain$templates$ParametrizedDeclarationModel$$undsetter$und$key$und$eq__Lamf_core_metamodel_Field__V($thiz.Name__Lamf_core_metamodel_Field())
}
/** @constructor */
function $c_Lamf_core_model_document_BaseUnit$$anonfun$findById$1() {
  $c_sr_AbstractPartialFunction.call(this);
  this.id$1$2 = null
}
$c_Lamf_core_model_document_BaseUnit$$anonfun$findById$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_model_document_BaseUnit$$anonfun$findById$1.prototype.constructor = $c_Lamf_core_model_document_BaseUnit$$anonfun$findById$1;
/** @constructor */
function $h_Lamf_core_model_document_BaseUnit$$anonfun$findById$1() {
  /*<skip>*/
}
$h_Lamf_core_model_document_BaseUnit$$anonfun$findById$1.prototype = $c_Lamf_core_model_document_BaseUnit$$anonfun$findById$1.prototype;
$c_Lamf_core_model_document_BaseUnit$$anonfun$findById$1.prototype.init___Lamf_core_model_document_BaseUnit__T = (function($$outer, id$1) {
  this.id$1$2 = id$1;
  return this
});
$c_Lamf_core_model_document_BaseUnit$$anonfun$findById$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  if ($is_Lamf_core_model_domain_DomainElement(x1)) {
    var x2 = $as_Lamf_core_model_domain_DomainElement(x1);
    if ((x2.id__T() === this.id$1$2)) {
      return true
    }
  };
  return false
});
$c_Lamf_core_model_document_BaseUnit$$anonfun$findById$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ($is_Lamf_core_model_domain_DomainElement(x1)) {
    var x2 = $as_Lamf_core_model_domain_DomainElement(x1);
    if ((x2.id__T() === this.id$1$2)) {
      return x2
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_core_model_document_BaseUnit$$anonfun$findById$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_core_model_document_BaseUnit$$anonfun$findById$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_core_model_document_BaseUnit$$anonfun$findById$1 = new $TypeData().initClass({
  Lamf_core_model_document_BaseUnit$$anonfun$findById$1: 0
}, false, "amf.core.model.document.BaseUnit$$anonfun$findById$1", {
  Lamf_core_model_document_BaseUnit$$anonfun$findById$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_document_BaseUnit$$anonfun$findById$1.prototype.$classData = $d_Lamf_core_model_document_BaseUnit$$anonfun$findById$1;
/** @constructor */
function $c_Lamf_core_model_document_BaseUnit$$anonfun$findByType$3() {
  $c_sr_AbstractPartialFunction.call(this);
  this.predicate$1$2 = null
}
$c_Lamf_core_model_document_BaseUnit$$anonfun$findByType$3.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_model_document_BaseUnit$$anonfun$findByType$3.prototype.constructor = $c_Lamf_core_model_document_BaseUnit$$anonfun$findByType$3;
/** @constructor */
function $h_Lamf_core_model_document_BaseUnit$$anonfun$findByType$3() {
  /*<skip>*/
}
$h_Lamf_core_model_document_BaseUnit$$anonfun$findByType$3.prototype = $c_Lamf_core_model_document_BaseUnit$$anonfun$findByType$3.prototype;
$c_Lamf_core_model_document_BaseUnit$$anonfun$findByType$3.prototype.init___Lamf_core_model_document_BaseUnit__F1 = (function($$outer, predicate$1) {
  this.predicate$1$2 = predicate$1;
  return this
});
$c_Lamf_core_model_document_BaseUnit$$anonfun$findByType$3.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  if ($is_Lamf_core_model_domain_DomainElement(x1)) {
    var x2 = $as_Lamf_core_model_domain_DomainElement(x1);
    if ($uZ(this.predicate$1$2.apply__O__O(x2))) {
      return true
    }
  };
  return false
});
$c_Lamf_core_model_document_BaseUnit$$anonfun$findByType$3.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ($is_Lamf_core_model_domain_DomainElement(x1)) {
    var x2 = $as_Lamf_core_model_domain_DomainElement(x1);
    if ($uZ(this.predicate$1$2.apply__O__O(x2))) {
      return x2
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_core_model_document_BaseUnit$$anonfun$findByType$3.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_core_model_document_BaseUnit$$anonfun$findByType$3.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_core_model_document_BaseUnit$$anonfun$findByType$3 = new $TypeData().initClass({
  Lamf_core_model_document_BaseUnit$$anonfun$findByType$3: 0
}, false, "amf.core.model.document.BaseUnit$$anonfun$findByType$3", {
  Lamf_core_model_document_BaseUnit$$anonfun$findByType$3: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_document_BaseUnit$$anonfun$findByType$3.prototype.$classData = $d_Lamf_core_model_document_BaseUnit$$anonfun$findByType$3;
/** @constructor */
function $c_Lamf_core_model_document_FieldsFilter$Local$$anonfun$filter$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_core_model_document_FieldsFilter$Local$$anonfun$filter$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_model_document_FieldsFilter$Local$$anonfun$filter$1.prototype.constructor = $c_Lamf_core_model_document_FieldsFilter$Local$$anonfun$filter$1;
/** @constructor */
function $h_Lamf_core_model_document_FieldsFilter$Local$$anonfun$filter$1() {
  /*<skip>*/
}
$h_Lamf_core_model_document_FieldsFilter$Local$$anonfun$filter$1.prototype = $c_Lamf_core_model_document_FieldsFilter$Local$$anonfun$filter$1.prototype;
$c_Lamf_core_model_document_FieldsFilter$Local$$anonfun$filter$1.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_model_document_FieldsFilter$Local$$anonfun$filter$1.prototype.applyOrElse__Lamf_core_parser_FieldEntry__F1__O = (function(x1, $default) {
  var x = x1.field$1;
  var x$2 = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
  if ((!((x === null) ? (x$2 === null) : x.equals__O__Z(x$2)))) {
    return x1.value$1.value$1
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_core_model_document_FieldsFilter$Local$$anonfun$filter$1.prototype.isDefinedAt__Lamf_core_parser_FieldEntry__Z = (function(x1) {
  var x = x1.field$1;
  var x$2 = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
  return (!((x === null) ? (x$2 === null) : x.equals__O__Z(x$2)))
});
$c_Lamf_core_model_document_FieldsFilter$Local$$anonfun$filter$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_parser_FieldEntry__Z($as_Lamf_core_parser_FieldEntry(x))
});
$c_Lamf_core_model_document_FieldsFilter$Local$$anonfun$filter$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_parser_FieldEntry__F1__O($as_Lamf_core_parser_FieldEntry(x), $default)
});
var $d_Lamf_core_model_document_FieldsFilter$Local$$anonfun$filter$1 = new $TypeData().initClass({
  Lamf_core_model_document_FieldsFilter$Local$$anonfun$filter$1: 0
}, false, "amf.core.model.document.FieldsFilter$Local$$anonfun$filter$1", {
  Lamf_core_model_document_FieldsFilter$Local$$anonfun$filter$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_document_FieldsFilter$Local$$anonfun$filter$1.prototype.$classData = $d_Lamf_core_model_document_FieldsFilter$Local$$anonfun$filter$1;
function $is_Lamf_core_model_document_Fragment(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_model_document_Fragment)))
}
function $as_Lamf_core_model_document_Fragment(obj) {
  return (($is_Lamf_core_model_document_Fragment(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.document.Fragment"))
}
function $isArrayOf_Lamf_core_model_document_Fragment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_document_Fragment)))
}
function $asArrayOf_Lamf_core_model_document_Fragment(obj, depth) {
  return (($isArrayOf_Lamf_core_model_document_Fragment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.document.Fragment;", depth))
}
/** @constructor */
function $c_Lamf_core_model_document_RecursiveUnit$$anon$1() {
  $c_O.call(this);
  this.type$1 = null;
  this.doc$1 = null;
  this.Encodes$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null
}
$c_Lamf_core_model_document_RecursiveUnit$$anon$1.prototype = new $h_O();
$c_Lamf_core_model_document_RecursiveUnit$$anon$1.prototype.constructor = $c_Lamf_core_model_document_RecursiveUnit$$anon$1;
/** @constructor */
function $h_Lamf_core_model_document_RecursiveUnit$$anon$1() {
  /*<skip>*/
}
$h_Lamf_core_model_document_RecursiveUnit$$anon$1.prototype = $c_Lamf_core_model_document_RecursiveUnit$$anon$1.prototype;
$c_Lamf_core_model_document_RecursiveUnit$$anon$1.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_core_model_document_RecursiveUnit$$anon$1.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_core_model_document_RecursiveUnit$$anon$1.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_model_document_RecursiveUnit$$anon$1.prototype.init___Lamf_core_model_document_RecursiveUnit = (function($$outer) {
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V(this);
  this.type$1 = $m_Lamf_core_metamodel_document_FragmentModel$().type$1;
  this.doc$1 = $m_Lamf_core_metamodel_document_FragmentModel$().doc$1;
  return this
});
$c_Lamf_core_model_document_RecursiveUnit$$anon$1.prototype.fields__sci_List = (function() {
  return $m_Lamf_core_metamodel_document_FragmentModel$().fields$1
});
$c_Lamf_core_model_document_RecursiveUnit$$anon$1.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_model_document_RecursiveUnit$$anon$1.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_core_model_document_RecursiveUnit$$anon$1.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  return new $c_Lamf_core_model_document_RecursiveUnit().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
});
$c_Lamf_core_model_document_RecursiveUnit$$anon$1.prototype.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Encodes$1 = x$1
});
$c_Lamf_core_model_document_RecursiveUnit$$anon$1.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_core_model_document_RecursiveUnit$$anon$1.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_core_model_document_RecursiveUnit$$anon$1.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_core_model_document_RecursiveUnit$$anon$1.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_core_model_document_RecursiveUnit$$anon$1 = new $TypeData().initClass({
  Lamf_core_model_document_RecursiveUnit$$anon$1: 0
}, false, "amf.core.model.document.RecursiveUnit$$anon$1", {
  Lamf_core_model_document_RecursiveUnit$$anon$1: 1,
  O: 1,
  Lamf_core_metamodel_document_FragmentModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_core_model_document_RecursiveUnit$$anon$1.prototype.$classData = $d_Lamf_core_model_document_RecursiveUnit$$anon$1;
/** @constructor */
function $c_Lamf_core_model_domain_AmfArray() {
  $c_O.call(this);
  this.values$1 = null;
  this.annotations$1 = null
}
$c_Lamf_core_model_domain_AmfArray.prototype = new $h_O();
$c_Lamf_core_model_domain_AmfArray.prototype.constructor = $c_Lamf_core_model_domain_AmfArray;
/** @constructor */
function $h_Lamf_core_model_domain_AmfArray() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_AmfArray.prototype = $c_Lamf_core_model_domain_AmfArray.prototype;
$c_Lamf_core_model_domain_AmfArray.prototype.productPrefix__T = (function() {
  return "AmfArray"
});
$c_Lamf_core_model_domain_AmfArray.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_model_domain_AmfArray.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_model_domain_AmfArray)) {
    var AmfArray$1 = $as_Lamf_core_model_domain_AmfArray(x$1);
    var x = this.values$1;
    var x$2 = AmfArray$1.values$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.annotations$1;
      var x$4 = AmfArray$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_model_domain_AmfArray.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.values$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_model_domain_AmfArray.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_model_domain_AmfArray.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_core_model_domain_AmfArray.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return this.cloneElement__scm_Map__Lamf_core_model_domain_AmfArray(branch)
});
$c_Lamf_core_model_domain_AmfArray.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_core_model_domain_AmfArray.prototype.init___sc_Seq__Lamf_core_parser_Annotations = (function(values, annotations) {
  this.values$1 = values;
  this.annotations$1 = annotations;
  return this
});
$c_Lamf_core_model_domain_AmfArray.prototype.$$plus$eq__Lamf_core_model_domain_AmfElement__V = (function(value) {
  var jsx$1 = this.values$1;
  var this$1 = $m_sc_Seq$();
  this.values$1 = $as_sc_Seq(jsx$1.$$colon$plus__O__scg_CanBuildFrom__O(value, this$1.ReusableCBFInstance$2))
});
$c_Lamf_core_model_domain_AmfArray.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_model_domain_AmfArray.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfArray = (function(branch) {
  var jsx$3 = this.values$1;
  var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, branch$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_domain_AmfElement(x$1$2);
      return x$1.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement(branch$1)
    })
  })(this, branch));
  var this$1 = $m_sc_Seq$();
  var jsx$1 = $as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$1.ReusableCBFInstance$2));
  var this$2 = this.annotations$1;
  return new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(jsx$1, $m_Lamf_core_parser_Annotations$().apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(this$2))
});
$c_Lamf_core_model_domain_AmfArray.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_model_domain_AmfArray.prototype.scalars__sc_Seq = (function() {
  var jsx$2 = this.values$1;
  var jsx$1 = new $c_Lamf_core_model_domain_AmfArray$$anonfun$scalars$1().init___Lamf_core_model_domain_AmfArray(this);
  var this$1 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))
});
function $as_Lamf_core_model_domain_AmfArray(obj) {
  return (((obj instanceof $c_Lamf_core_model_domain_AmfArray) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.AmfArray"))
}
function $isArrayOf_Lamf_core_model_domain_AmfArray(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_AmfArray)))
}
function $asArrayOf_Lamf_core_model_domain_AmfArray(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_AmfArray(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.AmfArray;", depth))
}
var $d_Lamf_core_model_domain_AmfArray = new $TypeData().initClass({
  Lamf_core_model_domain_AmfArray: 0
}, false, "amf.core.model.domain.AmfArray", {
  Lamf_core_model_domain_AmfArray: 1,
  O: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_domain_AmfArray.prototype.$classData = $d_Lamf_core_model_domain_AmfArray;
/** @constructor */
function $c_Lamf_core_model_domain_AmfArray$$anonfun$scalars$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_core_model_domain_AmfArray$$anonfun$scalars$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_model_domain_AmfArray$$anonfun$scalars$1.prototype.constructor = $c_Lamf_core_model_domain_AmfArray$$anonfun$scalars$1;
/** @constructor */
function $h_Lamf_core_model_domain_AmfArray$$anonfun$scalars$1() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_AmfArray$$anonfun$scalars$1.prototype = $c_Lamf_core_model_domain_AmfArray$$anonfun$scalars$1.prototype;
$c_Lamf_core_model_domain_AmfArray$$anonfun$scalars$1.prototype.init___Lamf_core_model_domain_AmfArray = (function($$outer) {
  return this
});
$c_Lamf_core_model_domain_AmfArray$$anonfun$scalars$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_core_model_domain_AmfScalar)
});
$c_Lamf_core_model_domain_AmfArray$$anonfun$scalars$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
    var x2 = $as_Lamf_core_model_domain_AmfScalar(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_core_model_domain_AmfArray$$anonfun$scalars$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_core_model_domain_AmfArray$$anonfun$scalars$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_core_model_domain_AmfArray$$anonfun$scalars$1 = new $TypeData().initClass({
  Lamf_core_model_domain_AmfArray$$anonfun$scalars$1: 0
}, false, "amf.core.model.domain.AmfArray$$anonfun$scalars$1", {
  Lamf_core_model_domain_AmfArray$$anonfun$scalars$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_domain_AmfArray$$anonfun$scalars$1.prototype.$classData = $d_Lamf_core_model_domain_AmfArray$$anonfun$scalars$1;
/** @constructor */
function $c_Lamf_core_model_domain_AmfElement$$anonfun$isTrackedBy$1() {
  $c_sr_AbstractPartialFunction.call(this);
  this.trackId$1$2 = null
}
$c_Lamf_core_model_domain_AmfElement$$anonfun$isTrackedBy$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_model_domain_AmfElement$$anonfun$isTrackedBy$1.prototype.constructor = $c_Lamf_core_model_domain_AmfElement$$anonfun$isTrackedBy$1;
/** @constructor */
function $h_Lamf_core_model_domain_AmfElement$$anonfun$isTrackedBy$1() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_AmfElement$$anonfun$isTrackedBy$1.prototype = $c_Lamf_core_model_domain_AmfElement$$anonfun$isTrackedBy$1.prototype;
$c_Lamf_core_model_domain_AmfElement$$anonfun$isTrackedBy$1.prototype.applyOrElse__Lamf_core_model_domain_Annotation__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_annotations_TrackedElement)) {
    var x2 = $as_Lamf_core_annotations_TrackedElement(x1);
    if (x2.parents$1.contains__O__Z(this.trackId$1$2)) {
      return x2
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_core_model_domain_AmfElement$$anonfun$isTrackedBy$1.prototype.init___Lamf_core_model_domain_AmfElement__T = (function($$outer, trackId$1) {
  this.trackId$1$2 = trackId$1;
  return this
});
$c_Lamf_core_model_domain_AmfElement$$anonfun$isTrackedBy$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_Annotation__Z($as_Lamf_core_model_domain_Annotation(x))
});
$c_Lamf_core_model_domain_AmfElement$$anonfun$isTrackedBy$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_Annotation__F1__O($as_Lamf_core_model_domain_Annotation(x), $default)
});
$c_Lamf_core_model_domain_AmfElement$$anonfun$isTrackedBy$1.prototype.isDefinedAt__Lamf_core_model_domain_Annotation__Z = (function(x1) {
  if ((x1 instanceof $c_Lamf_core_annotations_TrackedElement)) {
    var x2 = $as_Lamf_core_annotations_TrackedElement(x1);
    if (x2.parents$1.contains__O__Z(this.trackId$1$2)) {
      return true
    }
  };
  return false
});
var $d_Lamf_core_model_domain_AmfElement$$anonfun$isTrackedBy$1 = new $TypeData().initClass({
  Lamf_core_model_domain_AmfElement$$anonfun$isTrackedBy$1: 0
}, false, "amf.core.model.domain.AmfElement$$anonfun$isTrackedBy$1", {
  Lamf_core_model_domain_AmfElement$$anonfun$isTrackedBy$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_domain_AmfElement$$anonfun$isTrackedBy$1.prototype.$classData = $d_Lamf_core_model_domain_AmfElement$$anonfun$isTrackedBy$1;
/** @constructor */
function $c_Lamf_core_model_domain_AmfScalar() {
  $c_O.call(this);
  this.value$1 = null;
  this.annotations$1 = null
}
$c_Lamf_core_model_domain_AmfScalar.prototype = new $h_O();
$c_Lamf_core_model_domain_AmfScalar.prototype.constructor = $c_Lamf_core_model_domain_AmfScalar;
/** @constructor */
function $h_Lamf_core_model_domain_AmfScalar() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_AmfScalar.prototype = $c_Lamf_core_model_domain_AmfScalar.prototype;
$c_Lamf_core_model_domain_AmfScalar.prototype.toNumberOption__s_Option = (function() {
  var this$1 = $m_s_Option$().apply__O__s_Option(this.value$1);
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    if ($is_T(arg1)) {
      var x2 = $as_T(arg1);
      var this$3 = new $c_sci_StringOps().init___T(x2);
      var jsx$2 = $m_jl_Double$();
      var $$this = this$3.repr$1;
      var x = jsx$2.parseDouble__T__D($$this);
      var jsx$1 = x
    } else {
      var jsx$1 = $as_jl_Number(arg1)
    };
    return new $c_s_Some().init___O(jsx$1)
  }
});
$c_Lamf_core_model_domain_AmfScalar.prototype.productPrefix__T = (function() {
  return "AmfScalar"
});
$c_Lamf_core_model_domain_AmfScalar.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_model_domain_AmfScalar.prototype.toNumber__jl_Number = (function() {
  var x1 = this.toNumberOption__s_Option();
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var v = $as_jl_Number(x2.value$2);
    if ((v !== null)) {
      return v
    }
  };
  var x = $m_s_None$();
  if ((x === x1)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Cannot transform null value into Number"))
  };
  throw new $c_s_MatchError().init___O(x1)
});
$c_Lamf_core_model_domain_AmfScalar.prototype.equals__O__Z = (function(obj) {
  if ((obj instanceof $c_Lamf_core_model_domain_AmfScalar)) {
    var x2 = $as_Lamf_core_model_domain_AmfScalar(obj);
    var otherValue = x2.value$1;
    return $objectEquals(this.value$1, otherValue)
  } else {
    return false
  }
});
$c_Lamf_core_model_domain_AmfScalar.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_model_domain_AmfScalar.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_core_model_domain_AmfScalar.prototype.toString__T = (function() {
  var x1 = $m_s_Option$().apply__O__s_Option(this.value$1);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var v = x2.value$2;
    return $objectToString(v)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return ""
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_core_model_domain_AmfScalar.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfScalar = (function(branch) {
  var jsx$1 = this.value$1;
  var this$1 = this.annotations$1;
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(jsx$1, $m_Lamf_core_parser_Annotations$().apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(this$1))
});
$c_Lamf_core_model_domain_AmfScalar.prototype.init___O__Lamf_core_parser_Annotations = (function(value, annotations) {
  this.value$1 = value;
  this.annotations$1 = annotations;
  return this
});
$c_Lamf_core_model_domain_AmfScalar.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return this.cloneElement__scm_Map__Lamf_core_model_domain_AmfScalar(branch)
});
$c_Lamf_core_model_domain_AmfScalar.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_core_model_domain_AmfScalar.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_model_domain_AmfScalar.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_model_domain_AmfScalar.prototype.toBool__Z = (function() {
  var rc11 = false;
  var x2 = null;
  var x1 = $m_s_Option$().apply__O__s_Option(this.value$1);
  if ((x1 instanceof $c_s_Some)) {
    rc11 = true;
    x2 = $as_s_Some(x1);
    var v = x2.value$2;
    if ($is_T(v)) {
      var x7 = $as_T(v);
      var this$2 = new $c_sci_StringOps().init___T(x7);
      var $$this = this$2.repr$1;
      return $f_sci_StringLike__parseBoolean__psci_StringLike__T__Z(this$2, $$this)
    }
  };
  if (rc11) {
    var p4 = x2.value$2;
    if ($m_sr_BoxesRunTime$().equals__O__O__Z(true, p4)) {
      return true
    }
  };
  if (rc11) {
    var p6 = x2.value$2;
    if ($m_sr_BoxesRunTime$().equals__O__O__Z(false, p6)) {
      return false
    }
  };
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Cannot transform scalar value into Boolean"))
});
function $as_Lamf_core_model_domain_AmfScalar(obj) {
  return (((obj instanceof $c_Lamf_core_model_domain_AmfScalar) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.AmfScalar"))
}
function $isArrayOf_Lamf_core_model_domain_AmfScalar(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_AmfScalar)))
}
function $asArrayOf_Lamf_core_model_domain_AmfScalar(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_AmfScalar(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.AmfScalar;", depth))
}
var $d_Lamf_core_model_domain_AmfScalar = new $TypeData().initClass({
  Lamf_core_model_domain_AmfScalar: 0
}, false, "amf.core.model.domain.AmfScalar", {
  Lamf_core_model_domain_AmfScalar: 1,
  O: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_domain_AmfScalar.prototype.$classData = $d_Lamf_core_model_domain_AmfScalar;
/** @constructor */
function $c_Lamf_core_model_domain_ObjectNode$$anonfun$getFromKey$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_core_model_domain_ObjectNode$$anonfun$getFromKey$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_model_domain_ObjectNode$$anonfun$getFromKey$1.prototype.constructor = $c_Lamf_core_model_domain_ObjectNode$$anonfun$getFromKey$1;
/** @constructor */
function $h_Lamf_core_model_domain_ObjectNode$$anonfun$getFromKey$1() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_ObjectNode$$anonfun$getFromKey$1.prototype = $c_Lamf_core_model_domain_ObjectNode$$anonfun$getFromKey$1.prototype;
$c_Lamf_core_model_domain_ObjectNode$$anonfun$getFromKey$1.prototype.applyOrElse__Lamf_core_parser_Value__F1__O = (function(x1, $default) {
  var o9 = $m_Lamf_core_parser_Value$().unapply__Lamf_core_parser_Value__s_Option(x1);
  if ((!o9.isEmpty__Z())) {
    var e = $as_Lamf_core_model_domain_AmfElement($as_T2(o9.get__O()).$$und1__O());
    if ((e instanceof $c_Lamf_core_model_domain_DataNode)) {
      var x4 = $as_Lamf_core_model_domain_DataNode(e);
      return x4
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_core_model_domain_ObjectNode$$anonfun$getFromKey$1.prototype.init___Lamf_core_model_domain_ObjectNode = (function($$outer) {
  return this
});
$c_Lamf_core_model_domain_ObjectNode$$anonfun$getFromKey$1.prototype.isDefinedAt__Lamf_core_parser_Value__Z = (function(x1) {
  var o9 = $m_Lamf_core_parser_Value$().unapply__Lamf_core_parser_Value__s_Option(x1);
  if ((!o9.isEmpty__Z())) {
    var e = $as_Lamf_core_model_domain_AmfElement($as_T2(o9.get__O()).$$und1__O());
    if ((e instanceof $c_Lamf_core_model_domain_DataNode)) {
      return true
    }
  };
  return false
});
$c_Lamf_core_model_domain_ObjectNode$$anonfun$getFromKey$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_parser_Value__Z($as_Lamf_core_parser_Value(x))
});
$c_Lamf_core_model_domain_ObjectNode$$anonfun$getFromKey$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_parser_Value__F1__O($as_Lamf_core_parser_Value(x), $default)
});
var $d_Lamf_core_model_domain_ObjectNode$$anonfun$getFromKey$1 = new $TypeData().initClass({
  Lamf_core_model_domain_ObjectNode$$anonfun$getFromKey$1: 0
}, false, "amf.core.model.domain.ObjectNode$$anonfun$getFromKey$1", {
  Lamf_core_model_domain_ObjectNode$$anonfun$getFromKey$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_domain_ObjectNode$$anonfun$getFromKey$1.prototype.$classData = $d_Lamf_core_model_domain_ObjectNode$$anonfun$getFromKey$1;
/** @constructor */
function $c_Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel() {
  $c_O.call(this);
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0;
  this.$$outer$1 = null
}
$c_Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel.prototype = new $h_O();
$c_Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel.prototype.constructor = $c_Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel;
/** @constructor */
function $h_Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel.prototype = $c_Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel.prototype;
$c_Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel.prototype.init___Lamf_core_model_domain_ObjectNode = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ObjectNodeModel__$$init$__V(this);
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
  var x$6 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "Object");
  var this$3 = $m_Lamf_core_metamodel_domain_DataNodeModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$6, this$3);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Data$1, "Object Node", "Node that represents a dynamic object with records data structure", $m_sci_Nil$());
  return this
});
$c_Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel.prototype.fields__sci_List = (function() {
  var jsx$2 = this.$$outer$1.propertyFields__sc_Iterable().toList__sci_List();
  var jsx$1 = $m_Lamf_core_metamodel_domain_DataNodeModel$().fields$1;
  var this$1 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))
});
$c_Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel.prototype.amf$core$metamodel$domain$ObjectNodeModel$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_model_domain_ObjectNode$();
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_core_model_domain_ObjectNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel.prototype.amf$core$metamodel$domain$ObjectNodeModel$$undsetter$und$type$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel = new $TypeData().initClass({
  Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel: 0
}, false, "amf.core.model.domain.ObjectNode$ObjectNodeDynamicModel", {
  Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel: 1,
  O: 1,
  Lamf_core_metamodel_domain_ObjectNodeModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel.prototype.$classData = $d_Lamf_core_model_domain_ObjectNode$ObjectNodeDynamicModel;
/** @constructor */
function $c_Lamf_core_model_domain_templates_AbstractDeclaration() {
  $c_O.call(this);
  this.fields$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype = new $h_O();
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.constructor = $c_Lamf_core_model_domain_templates_AbstractDeclaration;
/** @constructor */
function $h_Lamf_core_model_domain_templates_AbstractDeclaration() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_templates_AbstractDeclaration.prototype = $c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype;
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.description__Lamf_core_model_StrField = (function() {
  return $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().Description$1))
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-abstract" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.dataNode__Lamf_core_model_domain_DataNode = (function() {
  return $as_Lamf_core_model_domain_DataNode(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().DataNode$1))
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.variables__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().Variables$1))
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().Name$1
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_core_model_domain_templates_AbstractDeclaration(obj) {
  return (((obj instanceof $c_Lamf_core_model_domain_templates_AbstractDeclaration) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.templates.AbstractDeclaration"))
}
function $isArrayOf_Lamf_core_model_domain_templates_AbstractDeclaration(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_templates_AbstractDeclaration)))
}
function $asArrayOf_Lamf_core_model_domain_templates_AbstractDeclaration(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_templates_AbstractDeclaration(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.templates.AbstractDeclaration;", depth))
}
/** @constructor */
function $c_Lamf_core_parser_Annotations$$anonfun$eternals$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_core_parser_Annotations$$anonfun$eternals$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_parser_Annotations$$anonfun$eternals$1.prototype.constructor = $c_Lamf_core_parser_Annotations$$anonfun$eternals$1;
/** @constructor */
function $h_Lamf_core_parser_Annotations$$anonfun$eternals$1() {
  /*<skip>*/
}
$h_Lamf_core_parser_Annotations$$anonfun$eternals$1.prototype = $c_Lamf_core_parser_Annotations$$anonfun$eternals$1.prototype;
$c_Lamf_core_parser_Annotations$$anonfun$eternals$1.prototype.applyOrElse__Lamf_core_model_domain_Annotation__F1__O = (function(x1, $default) {
  if ($is_Lamf_core_model_domain_EternalSerializedAnnotation(x1)) {
    var x2 = $as_Lamf_core_model_domain_EternalSerializedAnnotation(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_core_parser_Annotations$$anonfun$eternals$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_Annotation__Z($as_Lamf_core_model_domain_Annotation(x))
});
$c_Lamf_core_parser_Annotations$$anonfun$eternals$1.prototype.init___Lamf_core_parser_Annotations = (function($$outer) {
  return this
});
$c_Lamf_core_parser_Annotations$$anonfun$eternals$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_Annotation__F1__O($as_Lamf_core_model_domain_Annotation(x), $default)
});
$c_Lamf_core_parser_Annotations$$anonfun$eternals$1.prototype.isDefinedAt__Lamf_core_model_domain_Annotation__Z = (function(x1) {
  return $is_Lamf_core_model_domain_EternalSerializedAnnotation(x1)
});
var $d_Lamf_core_parser_Annotations$$anonfun$eternals$1 = new $TypeData().initClass({
  Lamf_core_parser_Annotations$$anonfun$eternals$1: 0
}, false, "amf.core.parser.Annotations$$anonfun$eternals$1", {
  Lamf_core_parser_Annotations$$anonfun$eternals$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_Annotations$$anonfun$eternals$1.prototype.$classData = $d_Lamf_core_parser_Annotations$$anonfun$eternals$1;
/** @constructor */
function $c_Lamf_core_parser_Annotations$$anonfun$serializables$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_core_parser_Annotations$$anonfun$serializables$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_parser_Annotations$$anonfun$serializables$1.prototype.constructor = $c_Lamf_core_parser_Annotations$$anonfun$serializables$1;
/** @constructor */
function $h_Lamf_core_parser_Annotations$$anonfun$serializables$1() {
  /*<skip>*/
}
$h_Lamf_core_parser_Annotations$$anonfun$serializables$1.prototype = $c_Lamf_core_parser_Annotations$$anonfun$serializables$1.prototype;
$c_Lamf_core_parser_Annotations$$anonfun$serializables$1.prototype.applyOrElse__Lamf_core_model_domain_Annotation__F1__O = (function(x1, $default) {
  if ($is_Lamf_core_model_domain_SerializableAnnotation(x1)) {
    var x2 = $as_Lamf_core_model_domain_SerializableAnnotation(x1);
    if ((!$is_Lamf_core_model_domain_EternalSerializedAnnotation(x2))) {
      return x2
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_core_parser_Annotations$$anonfun$serializables$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_Annotation__Z($as_Lamf_core_model_domain_Annotation(x))
});
$c_Lamf_core_parser_Annotations$$anonfun$serializables$1.prototype.init___Lamf_core_parser_Annotations = (function($$outer) {
  return this
});
$c_Lamf_core_parser_Annotations$$anonfun$serializables$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_Annotation__F1__O($as_Lamf_core_model_domain_Annotation(x), $default)
});
$c_Lamf_core_parser_Annotations$$anonfun$serializables$1.prototype.isDefinedAt__Lamf_core_model_domain_Annotation__Z = (function(x1) {
  if ($is_Lamf_core_model_domain_SerializableAnnotation(x1)) {
    var x2 = $as_Lamf_core_model_domain_SerializableAnnotation(x1);
    if ((!$is_Lamf_core_model_domain_EternalSerializedAnnotation(x2))) {
      return true
    }
  };
  return false
});
var $d_Lamf_core_parser_Annotations$$anonfun$serializables$1 = new $TypeData().initClass({
  Lamf_core_parser_Annotations$$anonfun$serializables$1: 0
}, false, "amf.core.parser.Annotations$$anonfun$serializables$1", {
  Lamf_core_parser_Annotations$$anonfun$serializables$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_Annotations$$anonfun$serializables$1.prototype.$classData = $d_Lamf_core_parser_Annotations$$anonfun$serializables$1;
/** @constructor */
function $c_Lamf_core_parser_Declarations$$anonfun$findAnnotation$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_core_parser_Declarations$$anonfun$findAnnotation$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_parser_Declarations$$anonfun$findAnnotation$2.prototype.constructor = $c_Lamf_core_parser_Declarations$$anonfun$findAnnotation$2;
/** @constructor */
function $h_Lamf_core_parser_Declarations$$anonfun$findAnnotation$2() {
  /*<skip>*/
}
$h_Lamf_core_parser_Declarations$$anonfun$findAnnotation$2.prototype = $c_Lamf_core_parser_Declarations$$anonfun$findAnnotation$2.prototype;
$c_Lamf_core_parser_Declarations$$anonfun$findAnnotation$2.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_model_domain_extensions_CustomDomainProperty)) {
    var x2 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_core_parser_Declarations$$anonfun$findAnnotation$2.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_core_model_domain_extensions_CustomDomainProperty)
});
$c_Lamf_core_parser_Declarations$$anonfun$findAnnotation$2.prototype.init___Lamf_core_parser_Declarations = (function($$outer) {
  return this
});
$c_Lamf_core_parser_Declarations$$anonfun$findAnnotation$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_core_parser_Declarations$$anonfun$findAnnotation$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_core_parser_Declarations$$anonfun$findAnnotation$2 = new $TypeData().initClass({
  Lamf_core_parser_Declarations$$anonfun$findAnnotation$2: 0
}, false, "amf.core.parser.Declarations$$anonfun$findAnnotation$2", {
  Lamf_core_parser_Declarations$$anonfun$findAnnotation$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_Declarations$$anonfun$findAnnotation$2.prototype.$classData = $d_Lamf_core_parser_Declarations$$anonfun$findAnnotation$2;
/** @constructor */
function $c_Lamf_core_parser_EmptyReferenceCollector$() {
  $c_Lamf_core_parser_ReferenceCollector.call(this)
}
$c_Lamf_core_parser_EmptyReferenceCollector$.prototype = new $h_Lamf_core_parser_ReferenceCollector();
$c_Lamf_core_parser_EmptyReferenceCollector$.prototype.constructor = $c_Lamf_core_parser_EmptyReferenceCollector$;
/** @constructor */
function $h_Lamf_core_parser_EmptyReferenceCollector$() {
  /*<skip>*/
}
$h_Lamf_core_parser_EmptyReferenceCollector$.prototype = $c_Lamf_core_parser_EmptyReferenceCollector$.prototype;
$c_Lamf_core_parser_EmptyReferenceCollector$.prototype.init___ = (function() {
  $c_Lamf_core_parser_ReferenceCollector.prototype.init___.call(this);
  return this
});
var $d_Lamf_core_parser_EmptyReferenceCollector$ = new $TypeData().initClass({
  Lamf_core_parser_EmptyReferenceCollector$: 0
}, false, "amf.core.parser.EmptyReferenceCollector$", {
  Lamf_core_parser_EmptyReferenceCollector$: 1,
  Lamf_core_parser_ReferenceCollector: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_EmptyReferenceCollector$.prototype.$classData = $d_Lamf_core_parser_EmptyReferenceCollector$;
var $n_Lamf_core_parser_EmptyReferenceCollector$ = (void 0);
function $m_Lamf_core_parser_EmptyReferenceCollector$() {
  if ((!$n_Lamf_core_parser_EmptyReferenceCollector$)) {
    $n_Lamf_core_parser_EmptyReferenceCollector$ = new $c_Lamf_core_parser_EmptyReferenceCollector$().init___()
  };
  return $n_Lamf_core_parser_EmptyReferenceCollector$
}
/** @constructor */
function $c_Lamf_core_parser_Position() {
  $c_O.call(this);
  this.line$1 = 0;
  this.column$1 = 0
}
$c_Lamf_core_parser_Position.prototype = new $h_O();
$c_Lamf_core_parser_Position.prototype.constructor = $c_Lamf_core_parser_Position;
/** @constructor */
function $h_Lamf_core_parser_Position() {
  /*<skip>*/
}
$h_Lamf_core_parser_Position.prototype = $c_Lamf_core_parser_Position.prototype;
$c_Lamf_core_parser_Position.prototype.productPrefix__T = (function() {
  return "Position"
});
$c_Lamf_core_parser_Position.prototype.compareTo__Lamf_core_parser_Position__I = (function(o) {
  var result = ((this.line$1 - o.line$1) | 0);
  return ((result === 0) ? ((this.column$1 - o.column$1) | 0) : result)
});
$c_Lamf_core_parser_Position.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_parser_Position.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_parser_Position)) {
    var Position$1 = $as_Lamf_core_parser_Position(x$1);
    return ((this.line$1 === Position$1.line$1) && (this.column$1 === Position$1.column$1))
  } else {
    return false
  }
});
$c_Lamf_core_parser_Position.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.line$1;
      break
    }
    case 1: {
      return this.column$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_parser_Position.prototype.min__Lamf_core_parser_Position__Lamf_core_parser_Position = (function(other) {
  return (((this.line$1 < other.line$1) || ((this.line$1 === other.line$1) && (this.column$1 <= other.column$1))) ? this : other)
});
$c_Lamf_core_parser_Position.prototype.$$js$exported$meth$toString__O = (function() {
  return this.toString__T()
});
$c_Lamf_core_parser_Position.prototype.isZero__Z = (function() {
  var x$2 = $m_Lamf_core_parser_Position$ZERO$();
  return this.equals__O__Z(x$2)
});
$c_Lamf_core_parser_Position.prototype.toString__T = (function() {
  return (((("(" + this.line$1) + ",") + this.column$1) + ")")
});
$c_Lamf_core_parser_Position.prototype.compareTo__O__I = (function(x$1) {
  return this.compareTo__Lamf_core_parser_Position__I($as_Lamf_core_parser_Position(x$1))
});
$c_Lamf_core_parser_Position.prototype.init___I__I = (function(line, column) {
  this.line$1 = line;
  this.column$1 = column;
  return this
});
$c_Lamf_core_parser_Position.prototype.$$js$exported$meth$max__Lamf_core_parser_Position__O = (function(other) {
  return this.max__Lamf_core_parser_Position__Lamf_core_parser_Position(other)
});
$c_Lamf_core_parser_Position.prototype.$$js$exported$meth$min__Lamf_core_parser_Position__O = (function(other) {
  return this.min__Lamf_core_parser_Position__Lamf_core_parser_Position(other)
});
$c_Lamf_core_parser_Position.prototype.max__Lamf_core_parser_Position__Lamf_core_parser_Position = (function(other) {
  return (((this.line$1 > other.line$1) || ((this.line$1 === other.line$1) && (this.column$1 >= other.column$1))) ? this : other)
});
$c_Lamf_core_parser_Position.prototype.$$js$exported$prop$column__O = (function() {
  return this.column$1
});
$c_Lamf_core_parser_Position.prototype.$$js$exported$prop$line__O = (function() {
  return this.line$1
});
$c_Lamf_core_parser_Position.prototype.$$js$exported$prop$isZero__O = (function() {
  return this.isZero__Z()
});
$c_Lamf_core_parser_Position.prototype.$$js$exported$meth$lt__Lamf_core_parser_Position__O = (function(o) {
  return this.lt__Lamf_core_parser_Position__Z(o)
});
$c_Lamf_core_parser_Position.prototype.lt__Lamf_core_parser_Position__Z = (function(o) {
  return (this.compareTo__Lamf_core_parser_Position__I(o) < 0)
});
$c_Lamf_core_parser_Position.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.line$1);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.column$1);
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 2)
});
$c_Lamf_core_parser_Position.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_parser_Position.prototype.$$js$exported$meth$compareTo__Lamf_core_parser_Position__O = (function(o) {
  return this.compareTo__Lamf_core_parser_Position__I(o)
});
$c_Lamf_core_parser_Position.prototype.toString = (function() {
  return this.$$js$exported$meth$toString__O()
});
Object.defineProperty($c_Lamf_core_parser_Position.prototype, "isZero", {
  "get": (function() {
    return this.$$js$exported$prop$isZero__O()
  }),
  "configurable": true
});
$c_Lamf_core_parser_Position.prototype.compareTo = (function(arg) {
  var prep = $as_Lamf_core_parser_Position(arg);
  return this.$$js$exported$meth$compareTo__Lamf_core_parser_Position__O(prep)
});
$c_Lamf_core_parser_Position.prototype.max = (function(arg) {
  var prep = $as_Lamf_core_parser_Position(arg);
  return this.$$js$exported$meth$max__Lamf_core_parser_Position__O(prep)
});
$c_Lamf_core_parser_Position.prototype.min = (function(arg) {
  var prep = $as_Lamf_core_parser_Position(arg);
  return this.$$js$exported$meth$min__Lamf_core_parser_Position__O(prep)
});
$c_Lamf_core_parser_Position.prototype.lt = (function(arg) {
  var prep = $as_Lamf_core_parser_Position(arg);
  return this.$$js$exported$meth$lt__Lamf_core_parser_Position__O(prep)
});
Object.defineProperty($c_Lamf_core_parser_Position.prototype, "column", {
  "get": (function() {
    return this.$$js$exported$prop$column__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_core_parser_Position.prototype, "line", {
  "get": (function() {
    return this.$$js$exported$prop$line__O()
  }),
  "configurable": true
});
function $as_Lamf_core_parser_Position(obj) {
  return (((obj instanceof $c_Lamf_core_parser_Position) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.Position"))
}
function $isArrayOf_Lamf_core_parser_Position(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_Position)))
}
function $asArrayOf_Lamf_core_parser_Position(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_Position(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.Position;", depth))
}
var $d_Lamf_core_parser_Position = new $TypeData().initClass({
  Lamf_core_parser_Position: 0
}, false, "amf.core.parser.Position", {
  Lamf_core_parser_Position: 1,
  O: 1,
  jl_Comparable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_Position.prototype.$classData = $d_Lamf_core_parser_Position;
/** @constructor */
function $c_Lamf_core_parser_Range$NONE$() {
  $c_Lamf_core_parser_Range.call(this)
}
$c_Lamf_core_parser_Range$NONE$.prototype = new $h_Lamf_core_parser_Range();
$c_Lamf_core_parser_Range$NONE$.prototype.constructor = $c_Lamf_core_parser_Range$NONE$;
/** @constructor */
function $h_Lamf_core_parser_Range$NONE$() {
  /*<skip>*/
}
$h_Lamf_core_parser_Range$NONE$.prototype = $c_Lamf_core_parser_Range$NONE$.prototype;
$c_Lamf_core_parser_Range$NONE$.prototype.init___ = (function() {
  $c_Lamf_core_parser_Range.prototype.init___Lamf_core_parser_Position__Lamf_core_parser_Position.call(this, $m_Lamf_core_parser_Position$ZERO$(), $m_Lamf_core_parser_Position$ZERO$());
  return this
});
var $d_Lamf_core_parser_Range$NONE$ = new $TypeData().initClass({
  Lamf_core_parser_Range$NONE$: 0
}, false, "amf.core.parser.Range$NONE$", {
  Lamf_core_parser_Range$NONE$: 1,
  Lamf_core_parser_Range: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_Range$NONE$.prototype.$classData = $d_Lamf_core_parser_Range$NONE$;
var $n_Lamf_core_parser_Range$NONE$ = (void 0);
function $m_Lamf_core_parser_Range$NONE$() {
  if ((!$n_Lamf_core_parser_Range$NONE$)) {
    $n_Lamf_core_parser_Range$NONE$ = new $c_Lamf_core_parser_Range$NONE$().init___()
  };
  return $n_Lamf_core_parser_Range$NONE$
}
/** @constructor */
function $c_Lamf_core_parser_Reference() {
  $c_O.call(this);
  this.url$1 = null;
  this.refs$1 = null;
  this.platform$1 = null
}
$c_Lamf_core_parser_Reference.prototype = new $h_O();
$c_Lamf_core_parser_Reference.prototype.constructor = $c_Lamf_core_parser_Reference;
/** @constructor */
function $h_Lamf_core_parser_Reference() {
  /*<skip>*/
}
$h_Lamf_core_parser_Reference.prototype = $c_Lamf_core_parser_Reference.prototype;
$c_Lamf_core_parser_Reference.prototype.init___T__sc_Seq = (function(url, refs) {
  this.url$1 = url;
  this.refs$1 = refs;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_core_parser_Reference.prototype.productPrefix__T = (function() {
  return "Reference"
});
$c_Lamf_core_parser_Reference.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_parser_Reference.prototype.amf$core$parser$Reference$$resolveReference__Lamf_core_CompilerContext__sc_Seq__Z__s_concurrent_ExecutionContext__s_concurrent_Future = (function(compilerContext, nodes, allowRecursiveRefs, executionContext) {
  var jsx$2 = this.refs$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_parser_RefContainer(x$1$2);
      return x$1.linkType$1
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var kinds = $as_sc_Seq($as_sc_SeqLike(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).distinct__O());
  var kind = ((kinds.size__I() > 1) ? $m_Lamf_core_parser_UnspecifiedReference$() : $as_Lamf_core_parser_ReferenceKind(kinds.head__O()));
  try {
    var context = compilerContext.forReference__T__Z__s_concurrent_ExecutionContext__Lamf_core_CompilerContext(this.url$1, true, executionContext);
    var res = $m_Lamf_core_services_RuntimeCompiler$().forContext__Lamf_core_CompilerContext__s_Option__s_Option__Lamf_core_parser_ReferenceKind__Lamf_core_client_ParsingOptions__s_concurrent_ExecutionContext__s_concurrent_Future(context, $m_s_None$(), $m_s_None$(), kind, ($m_Lamf_core_services_RuntimeCompiler$(), new $c_Lamf_core_client_ParsingOptions().init___()), executionContext).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, kind$1, kinds$1, nodes$1, context$1, executionContext$1) {
      return (function(eventualUnit$2) {
        var eventualUnit = $as_Lamf_core_model_document_BaseUnit(eventualUnit$2);
        this$2$1.verifyMatchingKind__p1__Lamf_core_model_document_BaseUnit__Lamf_core_parser_ReferenceKind__sc_Seq__sc_Seq__Lamf_core_parser_ParserContext__Lamf_core_model_document_BaseUnit(eventualUnit, kind$1, kinds$1, nodes$1, context$1.parserContext$1);
        return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this$1, eventualUnit$1) {
          return (function() {
            return new $c_Lamf_core_parser_ReferenceResolutionResult().init___s_Option__s_Option($m_s_None$(), new $c_s_Some().init___O(eventualUnit$1))
          })
        })(this$2$1, eventualUnit)), executionContext$1)
      })
    })(this, kind, kinds, nodes, context, executionContext)), executionContext).recover__s_PartialFunction__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_Lamf_core_parser_Reference$$anonfun$1().init___Lamf_core_parser_Reference__Z__Lamf_core_CompilerContext__s_concurrent_ExecutionContext(this, allowRecursiveRefs, compilerContext, executionContext), executionContext);
    return res.flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
      return (function(x$2) {
        var x = $as_s_concurrent_Future(x$2);
        return x
      })
    })(this)), executionContext)
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$4$1, e$3) {
        return (function() {
          return new $c_Lamf_core_parser_ReferenceResolutionResult().init___s_Option__s_Option(new $c_s_Some().init___O(e$3), $m_s_None$())
        })
      })(this, e$2)), executionContext)
    } else {
      throw e
    }
  }
});
$c_Lamf_core_parser_Reference.prototype.$$plus__Lamf_core_parser_ReferenceKind__Lorg_yaml_model_YNode__s_Option__Lamf_core_parser_Reference = (function(kind, ast, fragment) {
  var jsx$2 = this.refs$1;
  var jsx$1 = new $c_Lamf_core_parser_RefContainer().init___Lamf_core_parser_ReferenceKind__Lorg_yaml_model_YNode__s_Option(kind, ast, fragment);
  var this$1 = $m_sc_Seq$();
  var x$1 = $as_sc_Seq(jsx$2.$$colon$plus__O__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  var x$2 = this.url$1;
  return new $c_Lamf_core_parser_Reference().init___T__sc_Seq(x$2, x$1)
});
$c_Lamf_core_parser_Reference.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_parser_Reference)) {
    var Reference$1 = $as_Lamf_core_parser_Reference(x$1);
    if ((this.url$1 === Reference$1.url$1)) {
      var x = this.refs$1;
      var x$2 = Reference$1.refs$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_parser_Reference.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.url$1;
      break
    }
    case 1: {
      return this.refs$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_parser_Reference.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_parser_Reference.prototype.resolveRecursiveUnit__T__Lamf_core_CompilerContext__s_concurrent_ExecutionContext__s_concurrent_Future = (function(fulllUrl, compilerContext, executionContext) {
  $m_Lamf_core_benchmark_ExecutionLog$().log__T__Lamf_core_benchmark_ExecutionLog$(("AMFCompiler#parserReferences: Recursive reference " + fulllUrl));
  var this$1 = this.platform$1;
  var env = compilerContext.environment$1;
  return $f_Lamf_core_remote_Platform__resolve__T__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future(this$1, fulllUrl, env, executionContext).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, fulllUrl$1) {
    return (function(content$2) {
      var content = $as_Lamf_client_remote_Content(content$2);
      var qual$1 = new $c_Lamf_core_model_document_RecursiveUnit().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
      $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      var this$5 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, fulllUrl$1));
      var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
      var recUnit = $as_Lamf_core_model_document_RecursiveUnit($as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$5, field, fulllUrl$1)));
      var raw = content.stream$1.toString__T();
      $f_Lamf_core_model_document_BaseUnit__withRaw__T__Lamf_core_model_document_BaseUnit(recUnit, raw);
      return recUnit
    })
  })(this, fulllUrl)), executionContext)
});
$c_Lamf_core_parser_Reference.prototype.resolve__Lamf_core_CompilerContext__sc_Seq__Z__s_concurrent_ExecutionContext__s_concurrent_Future = (function(compilerContext, nodes, allowRecursiveRefs, executionContext) {
  try {
    var x1 = compilerContext.environment$1.resolver$1;
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var resolver = $as_Lamf_internal_reference_ReferenceResolver(x2.value$2);
      return resolver.fetch__T__s_concurrent_Future(compilerContext.resolvePath__T__T(this.url$1)).flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, executionContext$1) {
        return (function(cachedReference$2) {
          var cachedReference = $as_Lamf_internal_reference_CachedReference(cachedReference$2);
          return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this$1, cachedReference$1) {
            return (function() {
              return new $c_Lamf_core_parser_ReferenceResolutionResult().init___s_Option__s_Option($m_s_None$(), new $c_s_Some().init___O(cachedReference$1.content$1))
            })
          })($this, cachedReference)), executionContext$1)
        })
      })(this, executionContext)), executionContext).recoverWith__s_PartialFunction__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_Lamf_core_parser_Reference$$anonfun$resolve$3().init___Lamf_core_parser_Reference__Lamf_core_CompilerContext__sc_Seq__Z__s_concurrent_ExecutionContext(this, compilerContext, nodes, allowRecursiveRefs, executionContext), executionContext)
    } else {
      var x = $m_s_None$();
      if ((x === x1)) {
        return this.amf$core$parser$Reference$$resolveReference__Lamf_core_CompilerContext__sc_Seq__Z__s_concurrent_ExecutionContext__s_concurrent_Future(compilerContext, nodes, allowRecursiveRefs, executionContext)
      } else {
        throw new $c_s_MatchError().init___O(x1)
      }
    }
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      return this.amf$core$parser$Reference$$resolveReference__Lamf_core_CompilerContext__sc_Seq__Z__s_concurrent_ExecutionContext__s_concurrent_Future(compilerContext, nodes, allowRecursiveRefs, executionContext)
    } else {
      throw e
    }
  }
});
$c_Lamf_core_parser_Reference.prototype.verifyMatchingKind__p1__Lamf_core_model_document_BaseUnit__Lamf_core_parser_ReferenceKind__sc_Seq__sc_Seq__Lamf_core_parser_ParserContext__Lamf_core_model_document_BaseUnit = (function(unit, definedKind, allKinds, nodes, ctx) {
  if ((unit instanceof $c_Lamf_core_model_document_Module)) {
    if ((allKinds.contains__O__Z($m_Lamf_core_parser_LibraryReference$()) && allKinds.contains__O__Z($m_Lamf_core_parser_LinkReference$()))) {
      nodes.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ctx$1, unit$1) {
        return (function(x$3$2) {
          var x$3 = $as_Lorg_yaml_model_YNode(x$3$2);
          var this$1 = ctx$1.eh$1;
          var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ExpectedModule$1;
          var node = unit$1.id__T();
          var prop = $m_s_None$();
          var l = x$3.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, node, prop, "The !include tag must be avoided when referencing a library", l)
        })
      })(this, ctx, unit)))
    } else if (($m_Lamf_core_parser_LibraryReference$() !== definedKind)) {
      nodes.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, ctx$2, unit$2) {
        return (function(x$4$2) {
          var x$4 = $as_Lorg_yaml_model_YNode(x$4$2);
          var this$3 = ctx$2.eh$1;
          var specification$1 = $m_Lamf_plugins_features_validation_CoreValidations$().ExpectedModule$1;
          var node$1 = unit$2.id__T();
          var prop$1 = $m_s_None$();
          var l$1 = x$4.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$3, specification$1, node$1, prop$1, "Libraries must be applied by using 'uses'", l$1)
        })
      })(this, ctx, unit)))
    }
  } else {
    var this$4 = unit.meta__Lamf_core_metamodel_Obj().type__sci_List();
    inlinereturn$13: {
      var these = this$4;
      while ((!these.isEmpty__Z())) {
        var arg1 = these.head__O();
        var x$5 = $as_Lamf_core_vocabulary_ValueType(arg1);
        var thiz = x$5.iri__T();
        var s = $m_Lamf_core_vocabulary_Namespace$().Meta$1.base$1;
        if (($uI(thiz.indexOf(s)) !== (-1))) {
          var jsx$1 = true;
          break inlinereturn$13
        };
        these = $as_sc_LinearSeqOptimized(these.tail__O())
      };
      var jsx$1 = false
    };
    if ((!jsx$1)) {
      if (($m_Lamf_core_parser_LibraryReference$() === definedKind)) {
        nodes.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, ctx$3, unit$3) {
          return (function(x$6$2) {
            var x$6 = $as_Lorg_yaml_model_YNode(x$6$2);
            var this$8 = ctx$3.eh$1;
            var specification$2 = $m_Lamf_plugins_features_validation_CoreValidations$().InvalidInclude$1;
            var node$2 = unit$3.id__T();
            var prop$2 = $m_s_None$();
            var l$2 = x$6.location$1;
            $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$8, specification$2, node$2, prop$2, "Fragments must be imported by using '!include'", l$2)
          })
        })(this, ctx, unit)))
      }
    }
  };
  return unit
});
$c_Lamf_core_parser_Reference.prototype.isRemote__Z = (function() {
  var thiz = this.url$1;
  return (!(($uI(thiz.length) >= 0) && ($as_T(thiz.substring(0, $uI("#".length))) === "#")))
});
$c_Lamf_core_parser_Reference.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_parser_Reference.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_parser_Reference.prototype.isInferred__Z = (function() {
  return this.refs$1.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_parser_RefContainer(x$2$2);
      var x = x$2.linkType$1;
      var x$3 = $m_Lamf_core_parser_InferredLinkReference$();
      return ((x !== null) && (x === x$3))
    })
  })(this)))
});
function $as_Lamf_core_parser_Reference(obj) {
  return (((obj instanceof $c_Lamf_core_parser_Reference) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.Reference"))
}
function $isArrayOf_Lamf_core_parser_Reference(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_Reference)))
}
function $asArrayOf_Lamf_core_parser_Reference(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_Reference(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.Reference;", depth))
}
var $d_Lamf_core_parser_Reference = new $TypeData().initClass({
  Lamf_core_parser_Reference: 0
}, false, "amf.core.parser.Reference", {
  Lamf_core_parser_Reference: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_Reference.prototype.$classData = $d_Lamf_core_parser_Reference;
/** @constructor */
function $c_Lamf_core_parser_Reference$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this);
  this.$$outer$2 = null;
  this.allowRecursiveRefs$2$2 = false;
  this.compilerContext$2$2 = null;
  this.executionContext$2$2 = null
}
$c_Lamf_core_parser_Reference$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_parser_Reference$$anonfun$1.prototype.constructor = $c_Lamf_core_parser_Reference$$anonfun$1;
/** @constructor */
function $h_Lamf_core_parser_Reference$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_core_parser_Reference$$anonfun$1.prototype = $c_Lamf_core_parser_Reference$$anonfun$1.prototype;
$c_Lamf_core_parser_Reference$$anonfun$1.prototype.isDefinedAt__jl_Throwable__Z = (function(x1) {
  return (((x1 instanceof $c_Lamf_core_exception_CyclicReferenceException) && this.allowRecursiveRefs$2$2) || (x1 !== null))
});
$c_Lamf_core_parser_Reference$$anonfun$1.prototype.applyOrElse__jl_Throwable__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_exception_CyclicReferenceException)) {
    var x2 = $as_Lamf_core_exception_CyclicReferenceException(x1);
    if (this.allowRecursiveRefs$2$2) {
      var this$1 = x2.history$4;
      var fullUrl = $as_T($f_sc_LinearSeqOptimized__last__O(this$1));
      return this.$$outer$2.resolveRecursiveUnit__T__Lamf_core_CompilerContext__s_concurrent_ExecutionContext__s_concurrent_Future(fullUrl, this.compilerContext$2$2, this.executionContext$2$2).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(u$2) {
          var u = $as_Lamf_core_model_document_RecursiveUnit(u$2);
          return new $c_Lamf_core_parser_ReferenceResolutionResult().init___s_Option__s_Option($m_s_None$(), new $c_s_Some().init___O(u))
        })
      })(this)), this.executionContext$2$2)
    }
  };
  if ((x1 !== null)) {
    return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$2, x3) {
      return (function() {
        return new $c_Lamf_core_parser_ReferenceResolutionResult().init___s_Option__s_Option(new $c_s_Some().init___O(x3), $m_s_None$())
      })
    })(this, x1)), this.executionContext$2$2)
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_core_parser_Reference$$anonfun$1.prototype.init___Lamf_core_parser_Reference__Z__Lamf_core_CompilerContext__s_concurrent_ExecutionContext = (function($$outer, allowRecursiveRefs$2, compilerContext$2, executionContext$2) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.allowRecursiveRefs$2$2 = allowRecursiveRefs$2;
  this.compilerContext$2$2 = compilerContext$2;
  this.executionContext$2$2 = executionContext$2;
  return this
});
$c_Lamf_core_parser_Reference$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__jl_Throwable__Z($as_jl_Throwable(x))
});
$c_Lamf_core_parser_Reference$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__jl_Throwable__F1__O($as_jl_Throwable(x), $default)
});
var $d_Lamf_core_parser_Reference$$anonfun$1 = new $TypeData().initClass({
  Lamf_core_parser_Reference$$anonfun$1: 0
}, false, "amf.core.parser.Reference$$anonfun$1", {
  Lamf_core_parser_Reference$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_Reference$$anonfun$1.prototype.$classData = $d_Lamf_core_parser_Reference$$anonfun$1;
/** @constructor */
function $c_Lamf_core_parser_Reference$$anonfun$resolve$3() {
  $c_sr_AbstractPartialFunction.call(this);
  this.$$outer$2 = null;
  this.compilerContext$1$2 = null;
  this.nodes$1$2 = null;
  this.allowRecursiveRefs$1$2 = false;
  this.executionContext$1$2 = null
}
$c_Lamf_core_parser_Reference$$anonfun$resolve$3.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_parser_Reference$$anonfun$resolve$3.prototype.constructor = $c_Lamf_core_parser_Reference$$anonfun$resolve$3;
/** @constructor */
function $h_Lamf_core_parser_Reference$$anonfun$resolve$3() {
  /*<skip>*/
}
$h_Lamf_core_parser_Reference$$anonfun$resolve$3.prototype = $c_Lamf_core_parser_Reference$$anonfun$resolve$3.prototype;
$c_Lamf_core_parser_Reference$$anonfun$resolve$3.prototype.isDefinedAt__jl_Throwable__Z = (function(x1) {
  return true
});
$c_Lamf_core_parser_Reference$$anonfun$resolve$3.prototype.applyOrElse__jl_Throwable__F1__O = (function(x1, $default) {
  return this.$$outer$2.amf$core$parser$Reference$$resolveReference__Lamf_core_CompilerContext__sc_Seq__Z__s_concurrent_ExecutionContext__s_concurrent_Future(this.compilerContext$1$2, this.nodes$1$2, this.allowRecursiveRefs$1$2, this.executionContext$1$2)
});
$c_Lamf_core_parser_Reference$$anonfun$resolve$3.prototype.init___Lamf_core_parser_Reference__Lamf_core_CompilerContext__sc_Seq__Z__s_concurrent_ExecutionContext = (function($$outer, compilerContext$1, nodes$1, allowRecursiveRefs$1, executionContext$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.compilerContext$1$2 = compilerContext$1;
  this.nodes$1$2 = nodes$1;
  this.allowRecursiveRefs$1$2 = allowRecursiveRefs$1;
  this.executionContext$1$2 = executionContext$1;
  return this
});
$c_Lamf_core_parser_Reference$$anonfun$resolve$3.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__jl_Throwable__Z($as_jl_Throwable(x))
});
$c_Lamf_core_parser_Reference$$anonfun$resolve$3.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__jl_Throwable__F1__O($as_jl_Throwable(x), $default)
});
var $d_Lamf_core_parser_Reference$$anonfun$resolve$3 = new $TypeData().initClass({
  Lamf_core_parser_Reference$$anonfun$resolve$3: 0
}, false, "amf.core.parser.Reference$$anonfun$resolve$3", {
  Lamf_core_parser_Reference$$anonfun$resolve$3: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_Reference$$anonfun$resolve$3.prototype.$classData = $d_Lamf_core_parser_Reference$$anonfun$resolve$3;
/** @constructor */
function $c_Lamf_core_parser_SyamlParsedDocument() {
  $c_Lamf_core_parser_ParsedDocument.call(this);
  this.document$2 = null;
  this.comment$2 = null
}
$c_Lamf_core_parser_SyamlParsedDocument.prototype = new $h_Lamf_core_parser_ParsedDocument();
$c_Lamf_core_parser_SyamlParsedDocument.prototype.constructor = $c_Lamf_core_parser_SyamlParsedDocument;
/** @constructor */
function $h_Lamf_core_parser_SyamlParsedDocument() {
  /*<skip>*/
}
$h_Lamf_core_parser_SyamlParsedDocument.prototype = $c_Lamf_core_parser_SyamlParsedDocument.prototype;
$c_Lamf_core_parser_SyamlParsedDocument.prototype.init___Lorg_yaml_model_YDocument__s_Option = (function(document, comment) {
  this.document$2 = document;
  this.comment$2 = comment;
  return this
});
$c_Lamf_core_parser_SyamlParsedDocument.prototype.productPrefix__T = (function() {
  return "SyamlParsedDocument"
});
$c_Lamf_core_parser_SyamlParsedDocument.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_parser_SyamlParsedDocument.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_parser_SyamlParsedDocument)) {
    var SyamlParsedDocument$1 = $as_Lamf_core_parser_SyamlParsedDocument(x$1);
    var this$1 = this.document$2;
    var b = SyamlParsedDocument$1.document$2;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.comment$2;
      var x$2 = SyamlParsedDocument$1.comment$2;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_parser_SyamlParsedDocument.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.document$2;
      break
    }
    case 1: {
      return this.comment$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_parser_SyamlParsedDocument.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_parser_SyamlParsedDocument.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_parser_SyamlParsedDocument.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_parser_SyamlParsedDocument.prototype.comment__s_Option = (function() {
  return this.comment$2
});
function $as_Lamf_core_parser_SyamlParsedDocument(obj) {
  return (((obj instanceof $c_Lamf_core_parser_SyamlParsedDocument) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.SyamlParsedDocument"))
}
function $isArrayOf_Lamf_core_parser_SyamlParsedDocument(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_SyamlParsedDocument)))
}
function $asArrayOf_Lamf_core_parser_SyamlParsedDocument(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_SyamlParsedDocument(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.SyamlParsedDocument;", depth))
}
var $d_Lamf_core_parser_SyamlParsedDocument = new $TypeData().initClass({
  Lamf_core_parser_SyamlParsedDocument: 0
}, false, "amf.core.parser.SyamlParsedDocument", {
  Lamf_core_parser_SyamlParsedDocument: 1,
  Lamf_core_parser_ParsedDocument: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_SyamlParsedDocument.prototype.$classData = $d_Lamf_core_parser_SyamlParsedDocument;
function $f_Lamf_core_parser_errorhandler_UnhandledAmfParserErrorHandler__handlerAmfResult__Lamf_core_validation_AMFValidationResult__Z($thiz, result) {
  var jsx$3 = $m_sjsr_package$();
  var jsx$2 = result.message$1;
  var jsx$1 = result.targetNode$1;
  var this$1 = result.targetProperty$1;
  throw jsx$3.unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(((((((((("  Message: " + jsx$2) + "\n  Target: ") + jsx$1) + "\nProperty: ") + (this$1.isEmpty__Z() ? "" : this$1.get__O())) + "\n  Position: ") + result.position$1) + "\n at location: ") + result.location$1)))
}
/** @constructor */
function $c_Lamf_core_plugin_PluginContext$$anonfun$$nestedInanonfun$findType$1$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_core_plugin_PluginContext$$anonfun$$nestedInanonfun$findType$1$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_plugin_PluginContext$$anonfun$$nestedInanonfun$findType$1$1.prototype.constructor = $c_Lamf_core_plugin_PluginContext$$anonfun$$nestedInanonfun$findType$1$1;
/** @constructor */
function $h_Lamf_core_plugin_PluginContext$$anonfun$$nestedInanonfun$findType$1$1() {
  /*<skip>*/
}
$h_Lamf_core_plugin_PluginContext$$anonfun$$nestedInanonfun$findType$1$1.prototype = $c_Lamf_core_plugin_PluginContext$$anonfun$$nestedInanonfun$findType$1$1.prototype;
$c_Lamf_core_plugin_PluginContext$$anonfun$$nestedInanonfun$findType$1$1.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var obj = $as_Lamf_core_metamodel_Obj(x2.value$2);
    return obj
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_core_plugin_PluginContext$$anonfun$$nestedInanonfun$findType$1$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_core_plugin_PluginContext$$anonfun$$nestedInanonfun$findType$1$1.prototype.init___Lamf_core_plugin_PluginContext = (function($$outer) {
  return this
});
$c_Lamf_core_plugin_PluginContext$$anonfun$$nestedInanonfun$findType$1$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_core_plugin_PluginContext$$anonfun$$nestedInanonfun$findType$1$1.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  return (x1 instanceof $c_s_Some)
});
var $d_Lamf_core_plugin_PluginContext$$anonfun$$nestedInanonfun$findType$1$1 = new $TypeData().initClass({
  Lamf_core_plugin_PluginContext$$anonfun$$nestedInanonfun$findType$1$1: 0
}, false, "amf.core.plugin.PluginContext$$anonfun$$nestedInanonfun$findType$1$1", {
  Lamf_core_plugin_PluginContext$$anonfun$$nestedInanonfun$findType$1$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_plugin_PluginContext$$anonfun$$nestedInanonfun$findType$1$1.prototype.$classData = $d_Lamf_core_plugin_PluginContext$$anonfun$$nestedInanonfun$findType$1$1;
/** @constructor */
function $c_Lamf_core_plugin_PluginContext$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_core_plugin_PluginContext$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_plugin_PluginContext$$anonfun$1.prototype.constructor = $c_Lamf_core_plugin_PluginContext$$anonfun$1;
/** @constructor */
function $h_Lamf_core_plugin_PluginContext$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_core_plugin_PluginContext$$anonfun$1.prototype = $c_Lamf_core_plugin_PluginContext$$anonfun$1.prototype;
$c_Lamf_core_plugin_PluginContext$$anonfun$1.prototype.isDefinedAt__Lamf_client_plugins_AMFPlugin__Z = (function(x1) {
  return ((x1 instanceof $c_Lamf_client_plugins_AMFDomainPlugin) || (x1 instanceof $c_Lamf_client_plugins_AMFDocumentPlugin))
});
$c_Lamf_core_plugin_PluginContext$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_client_plugins_AMFPlugin__Z($as_Lamf_client_plugins_AMFPlugin(x))
});
$c_Lamf_core_plugin_PluginContext$$anonfun$1.prototype.init___Lamf_core_plugin_PluginContext = (function($$outer) {
  return this
});
$c_Lamf_core_plugin_PluginContext$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_client_plugins_AMFPlugin__F1__O($as_Lamf_client_plugins_AMFPlugin(x), $default)
});
$c_Lamf_core_plugin_PluginContext$$anonfun$1.prototype.applyOrElse__Lamf_client_plugins_AMFPlugin__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_client_plugins_AMFDomainPlugin)) {
    var x2 = $as_Lamf_client_plugins_AMFDomainPlugin(x1);
    return x2.modelEntities__sc_Seq()
  } else if ((x1 instanceof $c_Lamf_client_plugins_AMFDocumentPlugin)) {
    var x3 = $as_Lamf_client_plugins_AMFDocumentPlugin(x1);
    return x3.modelEntities__sc_Seq()
  } else {
    return $default.apply__O__O(x1)
  }
});
var $d_Lamf_core_plugin_PluginContext$$anonfun$1 = new $TypeData().initClass({
  Lamf_core_plugin_PluginContext$$anonfun$1: 0
}, false, "amf.core.plugin.PluginContext$$anonfun$1", {
  Lamf_core_plugin_PluginContext$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_plugin_PluginContext$$anonfun$1.prototype.$classData = $d_Lamf_core_plugin_PluginContext$$anonfun$1;
/** @constructor */
function $c_Lamf_core_plugin_PluginContext$$anonfun$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_core_plugin_PluginContext$$anonfun$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_plugin_PluginContext$$anonfun$2.prototype.constructor = $c_Lamf_core_plugin_PluginContext$$anonfun$2;
/** @constructor */
function $h_Lamf_core_plugin_PluginContext$$anonfun$2() {
  /*<skip>*/
}
$h_Lamf_core_plugin_PluginContext$$anonfun$2.prototype = $c_Lamf_core_plugin_PluginContext$$anonfun$2.prototype;
$c_Lamf_core_plugin_PluginContext$$anonfun$2.prototype.isDefinedAt__Lamf_client_plugins_AMFPlugin__Z = (function(x2) {
  return ((x2 instanceof $c_Lamf_client_plugins_AMFDomainPlugin) || (x2 instanceof $c_Lamf_client_plugins_AMFDocumentPlugin))
});
$c_Lamf_core_plugin_PluginContext$$anonfun$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_client_plugins_AMFPlugin__Z($as_Lamf_client_plugins_AMFPlugin(x))
});
$c_Lamf_core_plugin_PluginContext$$anonfun$2.prototype.init___Lamf_core_plugin_PluginContext = (function($$outer) {
  return this
});
$c_Lamf_core_plugin_PluginContext$$anonfun$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_client_plugins_AMFPlugin__F1__O($as_Lamf_client_plugins_AMFPlugin(x), $default)
});
$c_Lamf_core_plugin_PluginContext$$anonfun$2.prototype.applyOrElse__Lamf_client_plugins_AMFPlugin__F1__O = (function(x2, $default) {
  if ((x2 instanceof $c_Lamf_client_plugins_AMFDomainPlugin)) {
    $as_Lamf_client_plugins_AMFDomainPlugin(x2);
    return $m_s_None$()
  } else if ((x2 instanceof $c_Lamf_client_plugins_AMFDocumentPlugin)) {
    var x3 = $as_Lamf_client_plugins_AMFDocumentPlugin(x2);
    return x3.modelEntitiesResolver__s_Option()
  } else {
    return $default.apply__O__O(x2)
  }
});
var $d_Lamf_core_plugin_PluginContext$$anonfun$2 = new $TypeData().initClass({
  Lamf_core_plugin_PluginContext$$anonfun$2: 0
}, false, "amf.core.plugin.PluginContext$$anonfun$2", {
  Lamf_core_plugin_PluginContext$$anonfun$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_plugin_PluginContext$$anonfun$2.prototype.$classData = $d_Lamf_core_plugin_PluginContext$$anonfun$2;
/** @constructor */
function $c_Lamf_core_plugin_PluginContext$$anonfun$buildType$3() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_core_plugin_PluginContext$$anonfun$buildType$3.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_plugin_PluginContext$$anonfun$buildType$3.prototype.constructor = $c_Lamf_core_plugin_PluginContext$$anonfun$buildType$3;
/** @constructor */
function $h_Lamf_core_plugin_PluginContext$$anonfun$buildType$3() {
  /*<skip>*/
}
$h_Lamf_core_plugin_PluginContext$$anonfun$buildType$3.prototype = $c_Lamf_core_plugin_PluginContext$$anonfun$buildType$3.prototype;
$c_Lamf_core_plugin_PluginContext$$anonfun$buildType$3.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var builder = $as_F1(x2.value$2);
    return builder
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_core_plugin_PluginContext$$anonfun$buildType$3.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_core_plugin_PluginContext$$anonfun$buildType$3.prototype.init___Lamf_core_plugin_PluginContext = (function($$outer) {
  return this
});
$c_Lamf_core_plugin_PluginContext$$anonfun$buildType$3.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_core_plugin_PluginContext$$anonfun$buildType$3.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  return (x1 instanceof $c_s_Some)
});
var $d_Lamf_core_plugin_PluginContext$$anonfun$buildType$3 = new $TypeData().initClass({
  Lamf_core_plugin_PluginContext$$anonfun$buildType$3: 0
}, false, "amf.core.plugin.PluginContext$$anonfun$buildType$3", {
  Lamf_core_plugin_PluginContext$$anonfun$buildType$3: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_plugin_PluginContext$$anonfun$buildType$3.prototype.$classData = $d_Lamf_core_plugin_PluginContext$$anonfun$buildType$3;
/** @constructor */
function $c_Lamf_core_rdf_Literal() {
  $c_Lamf_core_rdf_PropertyObject.call(this);
  this.literalType$2 = null
}
$c_Lamf_core_rdf_Literal.prototype = new $h_Lamf_core_rdf_PropertyObject();
$c_Lamf_core_rdf_Literal.prototype.constructor = $c_Lamf_core_rdf_Literal;
/** @constructor */
function $h_Lamf_core_rdf_Literal() {
  /*<skip>*/
}
$h_Lamf_core_rdf_Literal.prototype = $c_Lamf_core_rdf_Literal.prototype;
$c_Lamf_core_rdf_Literal.prototype.productPrefix__T = (function() {
  return "Literal"
});
$c_Lamf_core_rdf_Literal.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_rdf_Literal.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_rdf_Literal)) {
    var Literal$1 = $as_Lamf_core_rdf_Literal(x$1);
    if ((this.value$1 === Literal$1.value$1)) {
      var x = this.literalType$2;
      var x$2 = Literal$1.literalType$2;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_rdf_Literal.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    case 1: {
      return this.literalType$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_rdf_Literal.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_rdf_Literal.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_rdf_Literal.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_rdf_Literal.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_rdf_Literal.prototype.init___T__s_Option = (function(value, literalType) {
  this.literalType$2 = literalType;
  $c_Lamf_core_rdf_PropertyObject.prototype.init___T.call(this, value);
  return this
});
function $as_Lamf_core_rdf_Literal(obj) {
  return (((obj instanceof $c_Lamf_core_rdf_Literal) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.rdf.Literal"))
}
function $isArrayOf_Lamf_core_rdf_Literal(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_rdf_Literal)))
}
function $asArrayOf_Lamf_core_rdf_Literal(obj, depth) {
  return (($isArrayOf_Lamf_core_rdf_Literal(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.rdf.Literal;", depth))
}
var $d_Lamf_core_rdf_Literal = new $TypeData().initClass({
  Lamf_core_rdf_Literal: 0
}, false, "amf.core.rdf.Literal", {
  Lamf_core_rdf_Literal: 1,
  Lamf_core_rdf_PropertyObject: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_rdf_Literal.prototype.$classData = $d_Lamf_core_rdf_Literal;
/** @constructor */
function $c_Lamf_core_rdf_RdfModelDocument() {
  $c_Lamf_core_parser_ParsedDocument.call(this);
  this.model$2 = null
}
$c_Lamf_core_rdf_RdfModelDocument.prototype = new $h_Lamf_core_parser_ParsedDocument();
$c_Lamf_core_rdf_RdfModelDocument.prototype.constructor = $c_Lamf_core_rdf_RdfModelDocument;
/** @constructor */
function $h_Lamf_core_rdf_RdfModelDocument() {
  /*<skip>*/
}
$h_Lamf_core_rdf_RdfModelDocument.prototype = $c_Lamf_core_rdf_RdfModelDocument.prototype;
$c_Lamf_core_rdf_RdfModelDocument.prototype.productPrefix__T = (function() {
  return "RdfModelDocument"
});
$c_Lamf_core_rdf_RdfModelDocument.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_rdf_RdfModelDocument.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_rdf_RdfModelDocument)) {
    var RdfModelDocument$1 = $as_Lamf_core_rdf_RdfModelDocument(x$1);
    var x = this.model$2;
    var x$2 = RdfModelDocument$1.model$2;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_core_rdf_RdfModelDocument.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.model$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_rdf_RdfModelDocument.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_rdf_RdfModelDocument.prototype.init___Lamf_core_rdf_RdfModel = (function(model) {
  this.model$2 = model;
  return this
});
$c_Lamf_core_rdf_RdfModelDocument.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_rdf_RdfModelDocument.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_rdf_RdfModelDocument(obj) {
  return (((obj instanceof $c_Lamf_core_rdf_RdfModelDocument) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.rdf.RdfModelDocument"))
}
function $isArrayOf_Lamf_core_rdf_RdfModelDocument(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_rdf_RdfModelDocument)))
}
function $asArrayOf_Lamf_core_rdf_RdfModelDocument(obj, depth) {
  return (($isArrayOf_Lamf_core_rdf_RdfModelDocument(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.rdf.RdfModelDocument;", depth))
}
var $d_Lamf_core_rdf_RdfModelDocument = new $TypeData().initClass({
  Lamf_core_rdf_RdfModelDocument: 0
}, false, "amf.core.rdf.RdfModelDocument", {
  Lamf_core_rdf_RdfModelDocument: 1,
  Lamf_core_parser_ParsedDocument: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_rdf_RdfModelDocument.prototype.$classData = $d_Lamf_core_rdf_RdfModelDocument;
/** @constructor */
function $c_Lamf_core_rdf_RdfModelEmitter$Emitter$$anonfun$$nestedInanonfun$createCustomExtensions$3$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_core_rdf_RdfModelEmitter$Emitter$$anonfun$$nestedInanonfun$createCustomExtensions$3$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_rdf_RdfModelEmitter$Emitter$$anonfun$$nestedInanonfun$createCustomExtensions$3$1.prototype.constructor = $c_Lamf_core_rdf_RdfModelEmitter$Emitter$$anonfun$$nestedInanonfun$createCustomExtensions$3$1;
/** @constructor */
function $h_Lamf_core_rdf_RdfModelEmitter$Emitter$$anonfun$$nestedInanonfun$createCustomExtensions$3$1() {
  /*<skip>*/
}
$h_Lamf_core_rdf_RdfModelEmitter$Emitter$$anonfun$$nestedInanonfun$createCustomExtensions$3$1.prototype = $c_Lamf_core_rdf_RdfModelEmitter$Emitter$$anonfun$$nestedInanonfun$createCustomExtensions$3$1.prototype;
$c_Lamf_core_rdf_RdfModelEmitter$Emitter$$anonfun$$nestedInanonfun$createCustomExtensions$3$1.prototype.applyOrElse__Lamf_core_model_domain_Annotation__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_annotations_DomainExtensionAnnotation)) {
    var x2 = $as_Lamf_core_annotations_DomainExtensionAnnotation(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter$$anonfun$$nestedInanonfun$createCustomExtensions$3$1.prototype.init___Lamf_core_rdf_RdfModelEmitter$Emitter = (function($$outer) {
  return this
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter$$anonfun$$nestedInanonfun$createCustomExtensions$3$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_Annotation__Z($as_Lamf_core_model_domain_Annotation(x))
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter$$anonfun$$nestedInanonfun$createCustomExtensions$3$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_Annotation__F1__O($as_Lamf_core_model_domain_Annotation(x), $default)
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter$$anonfun$$nestedInanonfun$createCustomExtensions$3$1.prototype.isDefinedAt__Lamf_core_model_domain_Annotation__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_core_annotations_DomainExtensionAnnotation)
});
var $d_Lamf_core_rdf_RdfModelEmitter$Emitter$$anonfun$$nestedInanonfun$createCustomExtensions$3$1 = new $TypeData().initClass({
  Lamf_core_rdf_RdfModelEmitter$Emitter$$anonfun$$nestedInanonfun$createCustomExtensions$3$1: 0
}, false, "amf.core.rdf.RdfModelEmitter$Emitter$$anonfun$$nestedInanonfun$createCustomExtensions$3$1", {
  Lamf_core_rdf_RdfModelEmitter$Emitter$$anonfun$$nestedInanonfun$createCustomExtensions$3$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_rdf_RdfModelEmitter$Emitter$$anonfun$$nestedInanonfun$createCustomExtensions$3$1.prototype.$classData = $d_Lamf_core_rdf_RdfModelEmitter$Emitter$$anonfun$$nestedInanonfun$createCustomExtensions$3$1;
/** @constructor */
function $c_Lamf_core_rdf_RdfModelParser$$anonfun$parse$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_core_rdf_RdfModelParser$$anonfun$parse$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_rdf_RdfModelParser$$anonfun$parse$1.prototype.constructor = $c_Lamf_core_rdf_RdfModelParser$$anonfun$parse$1;
/** @constructor */
function $h_Lamf_core_rdf_RdfModelParser$$anonfun$parse$1() {
  /*<skip>*/
}
$h_Lamf_core_rdf_RdfModelParser$$anonfun$parse$1.prototype = $c_Lamf_core_rdf_RdfModelParser$$anonfun$parse$1.prototype;
$c_Lamf_core_rdf_RdfModelParser$$anonfun$parse$1.prototype.applyOrElse__Lamf_core_model_domain_Annotation__F1__O = (function(x1, $default) {
  if ($is_Lamf_core_model_domain_ResolvableAnnotation(x1)) {
    var x2 = $as_Lamf_core_model_domain_ResolvableAnnotation(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_core_rdf_RdfModelParser$$anonfun$parse$1.prototype.init___Lamf_core_rdf_RdfModelParser = (function($$outer) {
  return this
});
$c_Lamf_core_rdf_RdfModelParser$$anonfun$parse$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_Annotation__Z($as_Lamf_core_model_domain_Annotation(x))
});
$c_Lamf_core_rdf_RdfModelParser$$anonfun$parse$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_Annotation__F1__O($as_Lamf_core_model_domain_Annotation(x), $default)
});
$c_Lamf_core_rdf_RdfModelParser$$anonfun$parse$1.prototype.isDefinedAt__Lamf_core_model_domain_Annotation__Z = (function(x1) {
  return $is_Lamf_core_model_domain_ResolvableAnnotation(x1)
});
var $d_Lamf_core_rdf_RdfModelParser$$anonfun$parse$1 = new $TypeData().initClass({
  Lamf_core_rdf_RdfModelParser$$anonfun$parse$1: 0
}, false, "amf.core.rdf.RdfModelParser$$anonfun$parse$1", {
  Lamf_core_rdf_RdfModelParser$$anonfun$parse$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_rdf_RdfModelParser$$anonfun$parse$1.prototype.$classData = $d_Lamf_core_rdf_RdfModelParser$$anonfun$parse$1;
/** @constructor */
function $c_Lamf_core_rdf_Uri() {
  $c_Lamf_core_rdf_PropertyObject.call(this)
}
$c_Lamf_core_rdf_Uri.prototype = new $h_Lamf_core_rdf_PropertyObject();
$c_Lamf_core_rdf_Uri.prototype.constructor = $c_Lamf_core_rdf_Uri;
/** @constructor */
function $h_Lamf_core_rdf_Uri() {
  /*<skip>*/
}
$h_Lamf_core_rdf_Uri.prototype = $c_Lamf_core_rdf_Uri.prototype;
$c_Lamf_core_rdf_Uri.prototype.productPrefix__T = (function() {
  return "Uri"
});
$c_Lamf_core_rdf_Uri.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_rdf_Uri.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_rdf_Uri)) {
    var Uri$1 = $as_Lamf_core_rdf_Uri(x$1);
    return (this.value$1 === Uri$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_core_rdf_Uri.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_rdf_Uri.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_rdf_Uri.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_rdf_Uri.prototype.init___T = (function(value) {
  $c_Lamf_core_rdf_PropertyObject.prototype.init___T.call(this, value);
  return this
});
$c_Lamf_core_rdf_Uri.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_rdf_Uri.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_rdf_Uri(obj) {
  return (((obj instanceof $c_Lamf_core_rdf_Uri) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.rdf.Uri"))
}
function $isArrayOf_Lamf_core_rdf_Uri(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_rdf_Uri)))
}
function $asArrayOf_Lamf_core_rdf_Uri(obj, depth) {
  return (($isArrayOf_Lamf_core_rdf_Uri(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.rdf.Uri;", depth))
}
var $d_Lamf_core_rdf_Uri = new $TypeData().initClass({
  Lamf_core_rdf_Uri: 0
}, false, "amf.core.rdf.Uri", {
  Lamf_core_rdf_Uri: 1,
  Lamf_core_rdf_PropertyObject: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_rdf_Uri.prototype.$classData = $d_Lamf_core_rdf_Uri;
/** @constructor */
function $c_Lamf_core_rdf_parsers_ObjectParser$$anonfun$parseList$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_core_rdf_parsers_ObjectParser$$anonfun$parseList$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_rdf_parsers_ObjectParser$$anonfun$parseList$2.prototype.constructor = $c_Lamf_core_rdf_parsers_ObjectParser$$anonfun$parseList$2;
/** @constructor */
function $h_Lamf_core_rdf_parsers_ObjectParser$$anonfun$parseList$2() {
  /*<skip>*/
}
$h_Lamf_core_rdf_parsers_ObjectParser$$anonfun$parseList$2.prototype = $c_Lamf_core_rdf_parsers_ObjectParser$$anonfun$parseList$2.prototype;
$c_Lamf_core_rdf_parsers_ObjectParser$$anonfun$parseList$2.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var x = $as_Lamf_core_model_domain_AmfElement(x2.value$2);
    return x
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_core_rdf_parsers_ObjectParser$$anonfun$parseList$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_core_rdf_parsers_ObjectParser$$anonfun$parseList$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_core_rdf_parsers_ObjectParser$$anonfun$parseList$2.prototype.init___Lamf_core_rdf_parsers_ObjectParser = (function($$outer) {
  return this
});
$c_Lamf_core_rdf_parsers_ObjectParser$$anonfun$parseList$2.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  return (x1 instanceof $c_s_Some)
});
var $d_Lamf_core_rdf_parsers_ObjectParser$$anonfun$parseList$2 = new $TypeData().initClass({
  Lamf_core_rdf_parsers_ObjectParser$$anonfun$parseList$2: 0
}, false, "amf.core.rdf.parsers.ObjectParser$$anonfun$parseList$2", {
  Lamf_core_rdf_parsers_ObjectParser$$anonfun$parseList$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_rdf_parsers_ObjectParser$$anonfun$parseList$2.prototype.$classData = $d_Lamf_core_rdf_parsers_ObjectParser$$anonfun$parseList$2;
/** @constructor */
function $c_Lamf_core_remote_Platform$$anonfun$amf$core$remote$Platform$$loaderConcat$1() {
  $c_sr_AbstractPartialFunction.call(this);
  this.$$outer$2 = null;
  this.url$1$2 = null;
  this.tail$1$2 = null;
  this.executionContext$1$2 = null
}
$c_Lamf_core_remote_Platform$$anonfun$amf$core$remote$Platform$$loaderConcat$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_remote_Platform$$anonfun$amf$core$remote$Platform$$loaderConcat$1.prototype.constructor = $c_Lamf_core_remote_Platform$$anonfun$amf$core$remote$Platform$$loaderConcat$1;
/** @constructor */
function $h_Lamf_core_remote_Platform$$anonfun$amf$core$remote$Platform$$loaderConcat$1() {
  /*<skip>*/
}
$h_Lamf_core_remote_Platform$$anonfun$amf$core$remote$Platform$$loaderConcat$1.prototype = $c_Lamf_core_remote_Platform$$anonfun$amf$core$remote$Platform$$loaderConcat$1.prototype;
$c_Lamf_core_remote_Platform$$anonfun$amf$core$remote$Platform$$loaderConcat$1.prototype.isDefinedAt__jl_Throwable__Z = (function(x1) {
  return true
});
$c_Lamf_core_remote_Platform$$anonfun$amf$core$remote$Platform$$loaderConcat$1.prototype.applyOrElse__jl_Throwable__F1__O = (function(x1, $default) {
  var this$1 = this.$$outer$2;
  var url = this.url$1$2;
  var loaders = this.tail$1$2;
  var executionContext = this.executionContext$1$2;
  return $f_Lamf_core_remote_Platform__amf$core$remote$Platform$$loaderConcat__T__sc_Seq__s_concurrent_ExecutionContext__s_concurrent_Future(this$1, url, loaders, executionContext)
});
$c_Lamf_core_remote_Platform$$anonfun$amf$core$remote$Platform$$loaderConcat$1.prototype.init___Lamf_core_remote_Platform__T__sci_List__s_concurrent_ExecutionContext = (function($$outer, url$1, tail$1, executionContext$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.url$1$2 = url$1;
  this.tail$1$2 = tail$1;
  this.executionContext$1$2 = executionContext$1;
  return this
});
$c_Lamf_core_remote_Platform$$anonfun$amf$core$remote$Platform$$loaderConcat$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__jl_Throwable__Z($as_jl_Throwable(x))
});
$c_Lamf_core_remote_Platform$$anonfun$amf$core$remote$Platform$$loaderConcat$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__jl_Throwable__F1__O($as_jl_Throwable(x), $default)
});
var $d_Lamf_core_remote_Platform$$anonfun$amf$core$remote$Platform$$loaderConcat$1 = new $TypeData().initClass({
  Lamf_core_remote_Platform$$anonfun$amf$core$remote$Platform$$loaderConcat$1: 0
}, false, "amf.core.remote.Platform$$anonfun$amf$core$remote$Platform$$loaderConcat$1", {
  Lamf_core_remote_Platform$$anonfun$amf$core$remote$Platform$$loaderConcat$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_remote_Platform$$anonfun$amf$core$remote$Platform$$loaderConcat$1.prototype.$classData = $d_Lamf_core_remote_Platform$$anonfun$amf$core$remote$Platform$$loaderConcat$1;
/** @constructor */
function $c_Lamf_core_remote_Syntax$Json$() {
  $c_O.call(this);
  this.extension$1 = null
}
$c_Lamf_core_remote_Syntax$Json$.prototype = new $h_O();
$c_Lamf_core_remote_Syntax$Json$.prototype.constructor = $c_Lamf_core_remote_Syntax$Json$;
/** @constructor */
function $h_Lamf_core_remote_Syntax$Json$() {
  /*<skip>*/
}
$h_Lamf_core_remote_Syntax$Json$.prototype = $c_Lamf_core_remote_Syntax$Json$.prototype;
$c_Lamf_core_remote_Syntax$Json$.prototype.init___ = (function() {
  this.extension$1 = "json";
  return this
});
$c_Lamf_core_remote_Syntax$Json$.prototype.productPrefix__T = (function() {
  return "Json"
});
$c_Lamf_core_remote_Syntax$Json$.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_remote_Syntax$Json$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_remote_Syntax$Json$.prototype.toString__T = (function() {
  return "Json"
});
$c_Lamf_core_remote_Syntax$Json$.prototype.hashCode__I = (function() {
  return 2318600
});
$c_Lamf_core_remote_Syntax$Json$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lamf_core_remote_Syntax$Json$ = new $TypeData().initClass({
  Lamf_core_remote_Syntax$Json$: 0
}, false, "amf.core.remote.Syntax$Json$", {
  Lamf_core_remote_Syntax$Json$: 1,
  O: 1,
  Lamf_core_remote_Syntax$Syntax: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_remote_Syntax$Json$.prototype.$classData = $d_Lamf_core_remote_Syntax$Json$;
var $n_Lamf_core_remote_Syntax$Json$ = (void 0);
function $m_Lamf_core_remote_Syntax$Json$() {
  if ((!$n_Lamf_core_remote_Syntax$Json$)) {
    $n_Lamf_core_remote_Syntax$Json$ = new $c_Lamf_core_remote_Syntax$Json$().init___()
  };
  return $n_Lamf_core_remote_Syntax$Json$
}
/** @constructor */
function $c_Lamf_core_remote_Syntax$Yaml$() {
  $c_O.call(this);
  this.extension$1 = null
}
$c_Lamf_core_remote_Syntax$Yaml$.prototype = new $h_O();
$c_Lamf_core_remote_Syntax$Yaml$.prototype.constructor = $c_Lamf_core_remote_Syntax$Yaml$;
/** @constructor */
function $h_Lamf_core_remote_Syntax$Yaml$() {
  /*<skip>*/
}
$h_Lamf_core_remote_Syntax$Yaml$.prototype = $c_Lamf_core_remote_Syntax$Yaml$.prototype;
$c_Lamf_core_remote_Syntax$Yaml$.prototype.init___ = (function() {
  this.extension$1 = "yaml";
  return this
});
$c_Lamf_core_remote_Syntax$Yaml$.prototype.productPrefix__T = (function() {
  return "Yaml"
});
$c_Lamf_core_remote_Syntax$Yaml$.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_remote_Syntax$Yaml$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_remote_Syntax$Yaml$.prototype.toString__T = (function() {
  return "Yaml"
});
$c_Lamf_core_remote_Syntax$Yaml$.prototype.hashCode__I = (function() {
  return 2748103
});
$c_Lamf_core_remote_Syntax$Yaml$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lamf_core_remote_Syntax$Yaml$ = new $TypeData().initClass({
  Lamf_core_remote_Syntax$Yaml$: 0
}, false, "amf.core.remote.Syntax$Yaml$", {
  Lamf_core_remote_Syntax$Yaml$: 1,
  O: 1,
  Lamf_core_remote_Syntax$Syntax: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_remote_Syntax$Yaml$.prototype.$classData = $d_Lamf_core_remote_Syntax$Yaml$;
var $n_Lamf_core_remote_Syntax$Yaml$ = (void 0);
function $m_Lamf_core_remote_Syntax$Yaml$() {
  if ((!$n_Lamf_core_remote_Syntax$Yaml$)) {
    $n_Lamf_core_remote_Syntax$Yaml$ = new $c_Lamf_core_remote_Syntax$Yaml$().init___()
  };
  return $n_Lamf_core_remote_Syntax$Yaml$
}
/** @constructor */
function $c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader$$anonfun$fetch$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader$$anonfun$fetch$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader$$anonfun$fetch$2.prototype.constructor = $c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader$$anonfun$fetch$2;
/** @constructor */
function $h_Lamf_core_remote_browser_JsBrowserHttpResourceLoader$$anonfun$fetch$2() {
  /*<skip>*/
}
$h_Lamf_core_remote_browser_JsBrowserHttpResourceLoader$$anonfun$fetch$2.prototype = $c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader$$anonfun$fetch$2.prototype;
$c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader$$anonfun$fetch$2.prototype.isDefinedAt__jl_Throwable__Z = (function(x1) {
  return (x1 !== null)
});
$c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader$$anonfun$fetch$2.prototype.init___Lamf_core_remote_browser_JsBrowserHttpResourceLoader = (function($$outer) {
  return this
});
$c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader$$anonfun$fetch$2.prototype.applyOrElse__jl_Throwable__F1__O = (function(x1, $default) {
  if ((x1 !== null)) {
    throw new $c_Lamf_core_remote_NetworkError().init___jl_Throwable(x1)
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader$$anonfun$fetch$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__jl_Throwable__Z($as_jl_Throwable(x))
});
$c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader$$anonfun$fetch$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__jl_Throwable__F1__O($as_jl_Throwable(x), $default)
});
var $d_Lamf_core_remote_browser_JsBrowserHttpResourceLoader$$anonfun$fetch$2 = new $TypeData().initClass({
  Lamf_core_remote_browser_JsBrowserHttpResourceLoader$$anonfun$fetch$2: 0
}, false, "amf.core.remote.browser.JsBrowserHttpResourceLoader$$anonfun$fetch$2", {
  Lamf_core_remote_browser_JsBrowserHttpResourceLoader$$anonfun$fetch$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader$$anonfun$fetch$2.prototype.$classData = $d_Lamf_core_remote_browser_JsBrowserHttpResourceLoader$$anonfun$fetch$2;
/** @constructor */
function $c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3() {
  $c_sr_AbstractPartialFunction.call(this);
  this.$$outer$2 = null;
  this.resource$1$2 = null
}
$c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3.prototype.constructor = $c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3;
/** @constructor */
function $h_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3() {
  /*<skip>*/
}
$h_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3.prototype = $c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3.prototype;
$c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3.prototype.isDefinedAt__jl_Throwable__Z = (function(x1) {
  return (x1 instanceof $c_Ljava_io_IOException)
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3.prototype.init___Lamf_core_remote_server_JsServerFileResourceLoader__T = (function($$outer, resource$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.resource$1$2 = resource$1;
  return this
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3.prototype.applyOrElse__jl_Throwable__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Ljava_io_IOException)) {
    var jsx$1 = $m_Lorg_mulesoft_common_io_Fs$();
    var str = this.resource$1$2;
    var this$2 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
    var this$3 = this$2.platform$1;
    var url = this$2.str$1;
    var qual$1 = jsx$1.asyncFile__T__Lorg_mulesoft_common_io_AsyncFile($f_Lamf_core_remote_JsPlatform__decodeURI__T__T(this$3, url));
    var ctx = $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext();
    return qual$1.read__T__s_concurrent_ExecutionContext__s_concurrent_Future("UTF-8", ctx).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(content$2) {
        var content = $as_jl_CharSequence(content$2);
        var jsx$4 = new $c_Lamf_core_lexer_CharSequenceStream().init___T__jl_CharSequence($this.resource$1$2, content);
        var jsx$3 = $this.$$outer$2.ensureFileAuthority__T__T($this.resource$1$2);
        var this$4 = $m_Lamf_core_remote_FileMediaType$();
        var path = $this.resource$1$2;
        var this$5 = $f_Lamf_core_remote_FileMediaType__extension__T__s_Option(this$4, path);
        if (this$5.isEmpty__Z()) {
          var jsx$2 = $m_s_None$()
        } else {
          var arg1 = this$5.get__O();
          var extension = $as_T(arg1);
          var this$6 = $m_Lamf_core_remote_FileMediaType$();
          var jsx$2 = $f_Lamf_core_remote_FileMediaType__mimeFromExtension__T__s_Option(this$6, extension)
        };
        return new $c_Lamf_client_remote_Content().init___Lamf_core_lexer_CharStream__T__s_Option(jsx$4, jsx$3, jsx$2)
      })
    })(this)), $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext()).recover__s_PartialFunction__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3$$anonfun$applyOrElse$3().init___Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3(this), $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext())
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__jl_Throwable__Z($as_jl_Throwable(x))
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__jl_Throwable__F1__O($as_jl_Throwable(x), $default)
});
var $d_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3 = new $TypeData().initClass({
  Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3: 0
}, false, "amf.core.remote.server.JsServerFileResourceLoader$$anonfun$fetchFile$3", {
  Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3.prototype.$classData = $d_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3;
/** @constructor */
function $c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3$$anonfun$applyOrElse$3() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3$$anonfun$applyOrElse$3.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3$$anonfun$applyOrElse$3.prototype.constructor = $c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3$$anonfun$applyOrElse$3;
/** @constructor */
function $h_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3$$anonfun$applyOrElse$3() {
  /*<skip>*/
}
$h_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3$$anonfun$applyOrElse$3.prototype = $c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3$$anonfun$applyOrElse$3.prototype;
$c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3$$anonfun$applyOrElse$3.prototype.init___Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3 = (function($$outer) {
  return this
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3$$anonfun$applyOrElse$3.prototype.isDefinedAt__jl_Throwable__Z = (function(x1) {
  return (x1 instanceof $c_Ljava_io_IOException)
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3$$anonfun$applyOrElse$3.prototype.applyOrElse__jl_Throwable__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Ljava_io_IOException)) {
    var x2 = $as_Ljava_io_IOException(x1);
    throw new $c_Lamf_core_remote_FileNotFound().init___jl_Throwable(x2)
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3$$anonfun$applyOrElse$3.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__jl_Throwable__Z($as_jl_Throwable(x))
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3$$anonfun$applyOrElse$3.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__jl_Throwable__F1__O($as_jl_Throwable(x), $default)
});
var $d_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3$$anonfun$applyOrElse$3 = new $TypeData().initClass({
  Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3$$anonfun$applyOrElse$3: 0
}, false, "amf.core.remote.server.JsServerFileResourceLoader$$anonfun$fetchFile$3$$anonfun$applyOrElse$3", {
  Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3$$anonfun$applyOrElse$3: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3$$anonfun$applyOrElse$3.prototype.$classData = $d_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3$$anonfun$applyOrElse$3;
/** @constructor */
function $c_Lamf_core_remote_server_JsServerHttpResourceLoader$$anonfun$fetch$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_core_remote_server_JsServerHttpResourceLoader$$anonfun$fetch$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_remote_server_JsServerHttpResourceLoader$$anonfun$fetch$1.prototype.constructor = $c_Lamf_core_remote_server_JsServerHttpResourceLoader$$anonfun$fetch$1;
/** @constructor */
function $h_Lamf_core_remote_server_JsServerHttpResourceLoader$$anonfun$fetch$1() {
  /*<skip>*/
}
$h_Lamf_core_remote_server_JsServerHttpResourceLoader$$anonfun$fetch$1.prototype = $c_Lamf_core_remote_server_JsServerHttpResourceLoader$$anonfun$fetch$1.prototype;
$c_Lamf_core_remote_server_JsServerHttpResourceLoader$$anonfun$fetch$1.prototype.isDefinedAt__jl_Throwable__Z = (function(x1) {
  return (x1 !== null)
});
$c_Lamf_core_remote_server_JsServerHttpResourceLoader$$anonfun$fetch$1.prototype.applyOrElse__jl_Throwable__F1__O = (function(x1, $default) {
  if ((x1 !== null)) {
    throw new $c_Lamf_core_remote_NetworkError().init___jl_Throwable(x1)
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_core_remote_server_JsServerHttpResourceLoader$$anonfun$fetch$1.prototype.init___Lamf_core_remote_server_JsServerHttpResourceLoader = (function($$outer) {
  return this
});
$c_Lamf_core_remote_server_JsServerHttpResourceLoader$$anonfun$fetch$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__jl_Throwable__Z($as_jl_Throwable(x))
});
$c_Lamf_core_remote_server_JsServerHttpResourceLoader$$anonfun$fetch$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__jl_Throwable__F1__O($as_jl_Throwable(x), $default)
});
var $d_Lamf_core_remote_server_JsServerHttpResourceLoader$$anonfun$fetch$1 = new $TypeData().initClass({
  Lamf_core_remote_server_JsServerHttpResourceLoader$$anonfun$fetch$1: 0
}, false, "amf.core.remote.server.JsServerHttpResourceLoader$$anonfun$fetch$1", {
  Lamf_core_remote_server_JsServerHttpResourceLoader$$anonfun$fetch$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_remote_server_JsServerHttpResourceLoader$$anonfun$fetch$1.prototype.$classData = $d_Lamf_core_remote_server_JsServerHttpResourceLoader$$anonfun$fetch$1;
/** @constructor */
function $c_Lamf_core_resolution_VariableReplacer$$anonfun$$nestedInanonfun$replaceMatch$1$1() {
  $c_sr_AbstractPartialFunction.call(this);
  this.isKey$1$2 = false;
  this.strict$1$2 = false;
  this.errorFunction$4$2 = null;
  this.name$2$2 = null
}
$c_Lamf_core_resolution_VariableReplacer$$anonfun$$nestedInanonfun$replaceMatch$1$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_resolution_VariableReplacer$$anonfun$$nestedInanonfun$replaceMatch$1$1.prototype.constructor = $c_Lamf_core_resolution_VariableReplacer$$anonfun$$nestedInanonfun$replaceMatch$1$1;
/** @constructor */
function $h_Lamf_core_resolution_VariableReplacer$$anonfun$$nestedInanonfun$replaceMatch$1$1() {
  /*<skip>*/
}
$h_Lamf_core_resolution_VariableReplacer$$anonfun$$nestedInanonfun$replaceMatch$1$1.prototype = $c_Lamf_core_resolution_VariableReplacer$$anonfun$$nestedInanonfun$replaceMatch$1$1.prototype;
$c_Lamf_core_resolution_VariableReplacer$$anonfun$$nestedInanonfun$replaceMatch$1$1.prototype.isDefinedAt__Lorg_yaml_model_YPart__Z = (function(x1) {
  if ((x1 instanceof $c_Lorg_yaml_model_YScalar)) {
    var x2 = $as_Lorg_yaml_model_YScalar(x1);
    if ($is_Lorg_yaml_model_QuotedMark(x2.mark$3)) {
      return true
    }
  };
  return false
});
$c_Lamf_core_resolution_VariableReplacer$$anonfun$$nestedInanonfun$replaceMatch$1$1.prototype.applyOrElse__Lorg_yaml_model_YPart__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lorg_yaml_model_YScalar)) {
    var x2 = $as_Lorg_yaml_model_YScalar(x1);
    if ($is_Lorg_yaml_model_QuotedMark(x2.mark$3)) {
      var this$1 = $m_Lorg_yaml_render_YamlRender$();
      var part = $m_Lorg_yaml_model_YScalar$().apply__O__Lorg_yaml_model_YScalar(x2.text$3);
      var variableValue = this$1.render__Lorg_yaml_model_YPart__Z__T(part, false);
      if ((variableValue === null)) {
        throw new $c_jl_NullPointerException().init___()
      };
      if ((($m_ju_regex_Pattern$().matches__T__jl_CharSequence__Z(" *", variableValue) && this.isKey$1$2) && this.strict$1$2)) {
        this.errorFunction$4$2.apply__O__O((("Variable '" + this.name$2$2) + "' cannot have an empty value"))
      };
      return variableValue
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_core_resolution_VariableReplacer$$anonfun$$nestedInanonfun$replaceMatch$1$1.prototype.init___Z__Z__F1__T = (function(isKey$1, strict$1, errorFunction$4, name$2) {
  this.isKey$1$2 = isKey$1;
  this.strict$1$2 = strict$1;
  this.errorFunction$4$2 = errorFunction$4;
  this.name$2$2 = name$2;
  return this
});
$c_Lamf_core_resolution_VariableReplacer$$anonfun$$nestedInanonfun$replaceMatch$1$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lorg_yaml_model_YPart__Z($as_Lorg_yaml_model_YPart(x))
});
$c_Lamf_core_resolution_VariableReplacer$$anonfun$$nestedInanonfun$replaceMatch$1$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lorg_yaml_model_YPart__F1__O($as_Lorg_yaml_model_YPart(x), $default)
});
var $d_Lamf_core_resolution_VariableReplacer$$anonfun$$nestedInanonfun$replaceMatch$1$1 = new $TypeData().initClass({
  Lamf_core_resolution_VariableReplacer$$anonfun$$nestedInanonfun$replaceMatch$1$1: 0
}, false, "amf.core.resolution.VariableReplacer$$anonfun$$nestedInanonfun$replaceMatch$1$1", {
  Lamf_core_resolution_VariableReplacer$$anonfun$$nestedInanonfun$replaceMatch$1$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_resolution_VariableReplacer$$anonfun$$nestedInanonfun$replaceMatch$1$1.prototype.$classData = $d_Lamf_core_resolution_VariableReplacer$$anonfun$$nestedInanonfun$replaceMatch$1$1;
/** @constructor */
function $c_Lamf_core_resolution_stages_CleanReferencesStage$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_core_resolution_stages_CleanReferencesStage$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_core_resolution_stages_CleanReferencesStage$$anonfun$1.prototype.constructor = $c_Lamf_core_resolution_stages_CleanReferencesStage$$anonfun$1;
/** @constructor */
function $h_Lamf_core_resolution_stages_CleanReferencesStage$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_CleanReferencesStage$$anonfun$1.prototype = $c_Lamf_core_resolution_stages_CleanReferencesStage$$anonfun$1.prototype;
$c_Lamf_core_resolution_stages_CleanReferencesStage$$anonfun$1.prototype.init___Lamf_core_resolution_stages_CleanReferencesStage = (function($$outer) {
  return this
});
$c_Lamf_core_resolution_stages_CleanReferencesStage$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_document_BaseUnit__Z($as_Lamf_core_model_document_BaseUnit(x))
});
$c_Lamf_core_resolution_stages_CleanReferencesStage$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O($as_Lamf_core_model_document_BaseUnit(x), $default)
});
$c_Lamf_core_resolution_stages_CleanReferencesStage$$anonfun$1.prototype.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O = (function(x1, $default) {
  if ($is_Lamf_core_model_document_Fragment(x1)) {
    var x2 = $as_Lamf_core_model_document_Fragment(x1);
    var jsx$1 = $m_sc_Seq$();
    var array = [x2.encodes__Lamf_core_model_domain_DomainElement().id__T()];
    return jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))
  } else if ((x1 instanceof $c_Lamf_core_model_document_Module)) {
    var x3 = $as_Lamf_core_model_document_Module(x1);
    var jsx$3 = $as_sc_Seq(x3.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_ModuleModel$().Declares$1));
    var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$1$2) {
        var x$1 = $as_Lamf_core_model_domain_DomainElement(x$1$2);
        return x$1.id__T()
      })
    })(this));
    var this$3 = $m_sc_Seq$();
    return jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$3.ReusableCBFInstance$2)
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_core_resolution_stages_CleanReferencesStage$$anonfun$1.prototype.isDefinedAt__Lamf_core_model_document_BaseUnit__Z = (function(x1) {
  return ($is_Lamf_core_model_document_Fragment(x1) || (x1 instanceof $c_Lamf_core_model_document_Module))
});
var $d_Lamf_core_resolution_stages_CleanReferencesStage$$anonfun$1 = new $TypeData().initClass({
  Lamf_core_resolution_stages_CleanReferencesStage$$anonfun$1: 0
}, false, "amf.core.resolution.stages.CleanReferencesStage$$anonfun$1", {
  Lamf_core_resolution_stages_CleanReferencesStage$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_resolution_stages_CleanReferencesStage$$anonfun$1.prototype.$classData = $d_Lamf_core_resolution_stages_CleanReferencesStage$$anonfun$1;
/** @constructor */
function $c_Lamf_core_resolution_stages_helpers_ResolvedLinkNode() {
  $c_Lamf_core_model_domain_LinkNode.call(this);
  this.source$3 = null;
  this.resolved$3 = null
}
$c_Lamf_core_resolution_stages_helpers_ResolvedLinkNode.prototype = new $h_Lamf_core_model_domain_LinkNode();
$c_Lamf_core_resolution_stages_helpers_ResolvedLinkNode.prototype.constructor = $c_Lamf_core_resolution_stages_helpers_ResolvedLinkNode;
/** @constructor */
function $h_Lamf_core_resolution_stages_helpers_ResolvedLinkNode() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_helpers_ResolvedLinkNode.prototype = $c_Lamf_core_resolution_stages_helpers_ResolvedLinkNode.prototype;
$c_Lamf_core_resolution_stages_helpers_ResolvedLinkNode.prototype.init___Lamf_core_model_domain_LinkNode__Lamf_core_model_domain_DomainElement = (function(source, resolved) {
  this.source$3 = source;
  this.resolved$3 = resolved;
  $c_Lamf_core_model_domain_LinkNode.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, source.fields$2, source.annotations$2);
  this.linkedDomainElement$2 = new $c_s_Some().init___O(resolved);
  return this
});
function $as_Lamf_core_resolution_stages_helpers_ResolvedLinkNode(obj) {
  return (((obj instanceof $c_Lamf_core_resolution_stages_helpers_ResolvedLinkNode) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.resolution.stages.helpers.ResolvedLinkNode"))
}
function $isArrayOf_Lamf_core_resolution_stages_helpers_ResolvedLinkNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_resolution_stages_helpers_ResolvedLinkNode)))
}
function $asArrayOf_Lamf_core_resolution_stages_helpers_ResolvedLinkNode(obj, depth) {
  return (($isArrayOf_Lamf_core_resolution_stages_helpers_ResolvedLinkNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.resolution.stages.helpers.ResolvedLinkNode;", depth))
}
var $d_Lamf_core_resolution_stages_helpers_ResolvedLinkNode = new $TypeData().initClass({
  Lamf_core_resolution_stages_helpers_ResolvedLinkNode: 0
}, false, "amf.core.resolution.stages.helpers.ResolvedLinkNode", {
  Lamf_core_resolution_stages_helpers_ResolvedLinkNode: 1,
  Lamf_core_model_domain_LinkNode: 1,
  Lamf_core_model_domain_DataNode: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1
});
$c_Lamf_core_resolution_stages_helpers_ResolvedLinkNode.prototype.$classData = $d_Lamf_core_resolution_stages_helpers_ResolvedLinkNode;
/** @constructor */
function $c_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity() {
  $c_O.call(this);
  this.vals$1 = null
}
$c_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity.prototype = new $h_O();
$c_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity.prototype.constructor = $c_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity;
/** @constructor */
function $h_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity.prototype = $c_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity.prototype;
$c_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity.prototype.productPrefix__T = (function() {
  return "ResolvedNamedEntity"
});
$c_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity)) {
    var ResolvedNamedEntity$1 = $as_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity(x$1);
    var x = this.vals$1;
    var x$2 = ResolvedNamedEntity$1.vals$1;
    return ((x === null) ? (x$2 === null) : $f_sc_GenMapLike__equals__O__Z(x, x$2))
  } else {
    return false
  }
});
$c_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.vals$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity.prototype.init___scm_HashMap = (function(vals) {
  this.vals$1 = vals;
  return this
});
$c_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity(obj) {
  return (((obj instanceof $c_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.resolution.stages.helpers.ResolvedNamedEntity"))
}
function $isArrayOf_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_resolution_stages_helpers_ResolvedNamedEntity)))
}
function $asArrayOf_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity(obj, depth) {
  return (($isArrayOf_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.resolution.stages.helpers.ResolvedNamedEntity;", depth))
}
var $d_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity = new $TypeData().initClass({
  Lamf_core_resolution_stages_helpers_ResolvedNamedEntity: 0
}, false, "amf.core.resolution.stages.helpers.ResolvedNamedEntity", {
  Lamf_core_resolution_stages_helpers_ResolvedNamedEntity: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity.prototype.$classData = $d_Lamf_core_resolution_stages_helpers_ResolvedNamedEntity;
/** @constructor */
function $c_Lamf_core_resolution_stages_selectors_Selector() {
  $c_O.call(this)
}
$c_Lamf_core_resolution_stages_selectors_Selector.prototype = new $h_O();
$c_Lamf_core_resolution_stages_selectors_Selector.prototype.constructor = $c_Lamf_core_resolution_stages_selectors_Selector;
/** @constructor */
function $h_Lamf_core_resolution_stages_selectors_Selector() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_selectors_Selector.prototype = $c_Lamf_core_resolution_stages_selectors_Selector.prototype;
$c_Lamf_core_resolution_stages_selectors_Selector.prototype.productPrefix__T = (function() {
  return "Selector"
});
$c_Lamf_core_resolution_stages_selectors_Selector.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_resolution_stages_selectors_Selector.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_core_resolution_stages_selectors_Selector) && ($as_Lamf_core_resolution_stages_selectors_Selector(x$1), true))
});
$c_Lamf_core_resolution_stages_selectors_Selector.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_resolution_stages_selectors_Selector.prototype.toString__T = (function() {
  return "<function1>"
});
$c_Lamf_core_resolution_stages_selectors_Selector.prototype.apply$mcZI$sp__I__Z = (function(v1) {
  return this.apply__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(v1))
});
$c_Lamf_core_resolution_stages_selectors_Selector.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_resolution_stages_selectors_Selector.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_resolution_stages_selectors_Selector(obj) {
  return (((obj instanceof $c_Lamf_core_resolution_stages_selectors_Selector) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.resolution.stages.selectors.Selector"))
}
function $isArrayOf_Lamf_core_resolution_stages_selectors_Selector(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_resolution_stages_selectors_Selector)))
}
function $asArrayOf_Lamf_core_resolution_stages_selectors_Selector(obj, depth) {
  return (($isArrayOf_Lamf_core_resolution_stages_selectors_Selector(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.resolution.stages.selectors.Selector;", depth))
}
/** @constructor */
function $c_Lamf_core_traversal_ObjectIdTraversalPath() {
  $c_O.call(this);
  this.traversed$1 = null
}
$c_Lamf_core_traversal_ObjectIdTraversalPath.prototype = new $h_O();
$c_Lamf_core_traversal_ObjectIdTraversalPath.prototype.constructor = $c_Lamf_core_traversal_ObjectIdTraversalPath;
/** @constructor */
function $h_Lamf_core_traversal_ObjectIdTraversalPath() {
  /*<skip>*/
}
$h_Lamf_core_traversal_ObjectIdTraversalPath.prototype = $c_Lamf_core_traversal_ObjectIdTraversalPath.prototype;
$c_Lamf_core_traversal_ObjectIdTraversalPath.prototype.productPrefix__T = (function() {
  return "ObjectIdTraversalPath"
});
$c_Lamf_core_traversal_ObjectIdTraversalPath.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_traversal_ObjectIdTraversalPath.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_traversal_ObjectIdTraversalPath)) {
    var ObjectIdTraversalPath$1 = $as_Lamf_core_traversal_ObjectIdTraversalPath(x$1);
    var x = this.traversed$1;
    var x$2 = ObjectIdTraversalPath$1.traversed$1;
    return ((x === null) ? (x$2 === null) : $f_sc_GenSetLike__equals__O__Z(x, x$2))
  } else {
    return false
  }
});
$c_Lamf_core_traversal_ObjectIdTraversalPath.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.traversed$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_traversal_ObjectIdTraversalPath.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_traversal_ObjectIdTraversalPath.prototype.init___scm_Set = (function(traversed) {
  this.traversed$1 = traversed;
  return this
});
$c_Lamf_core_traversal_ObjectIdTraversalPath.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_traversal_ObjectIdTraversalPath.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_traversal_ObjectIdTraversalPath(obj) {
  return (((obj instanceof $c_Lamf_core_traversal_ObjectIdTraversalPath) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.traversal.ObjectIdTraversalPath"))
}
function $isArrayOf_Lamf_core_traversal_ObjectIdTraversalPath(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_traversal_ObjectIdTraversalPath)))
}
function $asArrayOf_Lamf_core_traversal_ObjectIdTraversalPath(obj, depth) {
  return (($isArrayOf_Lamf_core_traversal_ObjectIdTraversalPath(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.traversal.ObjectIdTraversalPath;", depth))
}
var $d_Lamf_core_traversal_ObjectIdTraversalPath = new $TypeData().initClass({
  Lamf_core_traversal_ObjectIdTraversalPath: 0
}, false, "amf.core.traversal.ObjectIdTraversalPath", {
  Lamf_core_traversal_ObjectIdTraversalPath: 1,
  O: 1,
  Lamf_core_traversal_TraversalPath: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_traversal_ObjectIdTraversalPath.prototype.$classData = $d_Lamf_core_traversal_ObjectIdTraversalPath;
/** @constructor */
function $c_Lamf_core_validation_model_AlternatePath() {
  $c_Lamf_core_validation_model_PropertyPath.call(this);
  this.elements$2 = null
}
$c_Lamf_core_validation_model_AlternatePath.prototype = new $h_Lamf_core_validation_model_PropertyPath();
$c_Lamf_core_validation_model_AlternatePath.prototype.constructor = $c_Lamf_core_validation_model_AlternatePath;
/** @constructor */
function $h_Lamf_core_validation_model_AlternatePath() {
  /*<skip>*/
}
$h_Lamf_core_validation_model_AlternatePath.prototype = $c_Lamf_core_validation_model_AlternatePath.prototype;
$c_Lamf_core_validation_model_AlternatePath.prototype.productPrefix__T = (function() {
  return "AlternatePath"
});
$c_Lamf_core_validation_model_AlternatePath.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_validation_model_AlternatePath.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_validation_model_AlternatePath)) {
    var AlternatePath$1 = $as_Lamf_core_validation_model_AlternatePath(x$1);
    var x = this.elements$2;
    var x$2 = AlternatePath$1.elements$2;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_core_validation_model_AlternatePath.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.elements$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_validation_model_AlternatePath.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_validation_model_AlternatePath.prototype.init___sci_List = (function(elements) {
  this.elements$2 = elements;
  return this
});
$c_Lamf_core_validation_model_AlternatePath.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_validation_model_AlternatePath.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_validation_model_AlternatePath(obj) {
  return (((obj instanceof $c_Lamf_core_validation_model_AlternatePath) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.model.AlternatePath"))
}
function $isArrayOf_Lamf_core_validation_model_AlternatePath(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_model_AlternatePath)))
}
function $asArrayOf_Lamf_core_validation_model_AlternatePath(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_model_AlternatePath(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.model.AlternatePath;", depth))
}
var $d_Lamf_core_validation_model_AlternatePath = new $TypeData().initClass({
  Lamf_core_validation_model_AlternatePath: 0
}, false, "amf.core.validation.model.AlternatePath", {
  Lamf_core_validation_model_AlternatePath: 1,
  Lamf_core_validation_model_PropertyPath: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_validation_model_AlternatePath.prototype.$classData = $d_Lamf_core_validation_model_AlternatePath;
/** @constructor */
function $c_Lamf_core_validation_model_OpenGroup() {
  $c_Lamf_core_validation_model_PropertyPath.call(this)
}
$c_Lamf_core_validation_model_OpenGroup.prototype = new $h_Lamf_core_validation_model_PropertyPath();
$c_Lamf_core_validation_model_OpenGroup.prototype.constructor = $c_Lamf_core_validation_model_OpenGroup;
/** @constructor */
function $h_Lamf_core_validation_model_OpenGroup() {
  /*<skip>*/
}
$h_Lamf_core_validation_model_OpenGroup.prototype = $c_Lamf_core_validation_model_OpenGroup.prototype;
$c_Lamf_core_validation_model_OpenGroup.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_validation_model_OpenGroup.prototype.productPrefix__T = (function() {
  return "OpenGroup"
});
$c_Lamf_core_validation_model_OpenGroup.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_validation_model_OpenGroup.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_core_validation_model_OpenGroup) && ($as_Lamf_core_validation_model_OpenGroup(x$1), true))
});
$c_Lamf_core_validation_model_OpenGroup.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_validation_model_OpenGroup.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_validation_model_OpenGroup.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_validation_model_OpenGroup.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_validation_model_OpenGroup(obj) {
  return (((obj instanceof $c_Lamf_core_validation_model_OpenGroup) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.model.OpenGroup"))
}
function $isArrayOf_Lamf_core_validation_model_OpenGroup(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_model_OpenGroup)))
}
function $asArrayOf_Lamf_core_validation_model_OpenGroup(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_model_OpenGroup(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.model.OpenGroup;", depth))
}
var $d_Lamf_core_validation_model_OpenGroup = new $TypeData().initClass({
  Lamf_core_validation_model_OpenGroup: 0
}, false, "amf.core.validation.model.OpenGroup", {
  Lamf_core_validation_model_OpenGroup: 1,
  Lamf_core_validation_model_PropertyPath: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_validation_model_OpenGroup.prototype.$classData = $d_Lamf_core_validation_model_OpenGroup;
/** @constructor */
function $c_Lamf_core_validation_model_PredicatePath() {
  $c_Lamf_core_validation_model_PropertyPath.call(this);
  this.property$2 = null;
  this.inverse$2 = false;
  this.zeroOrMore$2 = false
}
$c_Lamf_core_validation_model_PredicatePath.prototype = new $h_Lamf_core_validation_model_PropertyPath();
$c_Lamf_core_validation_model_PredicatePath.prototype.constructor = $c_Lamf_core_validation_model_PredicatePath;
/** @constructor */
function $h_Lamf_core_validation_model_PredicatePath() {
  /*<skip>*/
}
$h_Lamf_core_validation_model_PredicatePath.prototype = $c_Lamf_core_validation_model_PredicatePath.prototype;
$c_Lamf_core_validation_model_PredicatePath.prototype.productPrefix__T = (function() {
  return "PredicatePath"
});
$c_Lamf_core_validation_model_PredicatePath.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_core_validation_model_PredicatePath.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_validation_model_PredicatePath)) {
    var PredicatePath$1 = $as_Lamf_core_validation_model_PredicatePath(x$1);
    return (((this.property$2 === PredicatePath$1.property$2) && (this.inverse$2 === PredicatePath$1.inverse$2)) && (this.zeroOrMore$2 === PredicatePath$1.zeroOrMore$2))
  } else {
    return false
  }
});
$c_Lamf_core_validation_model_PredicatePath.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.property$2;
      break
    }
    case 1: {
      return this.inverse$2;
      break
    }
    case 2: {
      return this.zeroOrMore$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_validation_model_PredicatePath.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_validation_model_PredicatePath.prototype.init___T__Z__Z = (function(property, inverse, zeroOrMore) {
  this.property$2 = property;
  this.inverse$2 = inverse;
  this.zeroOrMore$2 = zeroOrMore;
  return this
});
$c_Lamf_core_validation_model_PredicatePath.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.property$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.inverse$2 ? 1231 : 1237));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.zeroOrMore$2 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 3)
});
$c_Lamf_core_validation_model_PredicatePath.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_validation_model_PredicatePath(obj) {
  return (((obj instanceof $c_Lamf_core_validation_model_PredicatePath) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.model.PredicatePath"))
}
function $isArrayOf_Lamf_core_validation_model_PredicatePath(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_model_PredicatePath)))
}
function $asArrayOf_Lamf_core_validation_model_PredicatePath(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_model_PredicatePath(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.model.PredicatePath;", depth))
}
var $d_Lamf_core_validation_model_PredicatePath = new $TypeData().initClass({
  Lamf_core_validation_model_PredicatePath: 0
}, false, "amf.core.validation.model.PredicatePath", {
  Lamf_core_validation_model_PredicatePath: 1,
  Lamf_core_validation_model_PropertyPath: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_validation_model_PredicatePath.prototype.$classData = $d_Lamf_core_validation_model_PredicatePath;
/** @constructor */
function $c_Lamf_core_validation_model_SequencePath() {
  $c_Lamf_core_validation_model_PropertyPath.call(this);
  this.elements$2 = null
}
$c_Lamf_core_validation_model_SequencePath.prototype = new $h_Lamf_core_validation_model_PropertyPath();
$c_Lamf_core_validation_model_SequencePath.prototype.constructor = $c_Lamf_core_validation_model_SequencePath;
/** @constructor */
function $h_Lamf_core_validation_model_SequencePath() {
  /*<skip>*/
}
$h_Lamf_core_validation_model_SequencePath.prototype = $c_Lamf_core_validation_model_SequencePath.prototype;
$c_Lamf_core_validation_model_SequencePath.prototype.productPrefix__T = (function() {
  return "SequencePath"
});
$c_Lamf_core_validation_model_SequencePath.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_validation_model_SequencePath.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_validation_model_SequencePath)) {
    var SequencePath$1 = $as_Lamf_core_validation_model_SequencePath(x$1);
    var x = this.elements$2;
    var x$2 = SequencePath$1.elements$2;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_core_validation_model_SequencePath.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.elements$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_validation_model_SequencePath.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_validation_model_SequencePath.prototype.init___sci_List = (function(elements) {
  this.elements$2 = elements;
  return this
});
$c_Lamf_core_validation_model_SequencePath.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_validation_model_SequencePath.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_validation_model_SequencePath(obj) {
  return (((obj instanceof $c_Lamf_core_validation_model_SequencePath) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.model.SequencePath"))
}
function $isArrayOf_Lamf_core_validation_model_SequencePath(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_model_SequencePath)))
}
function $asArrayOf_Lamf_core_validation_model_SequencePath(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_model_SequencePath(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.model.SequencePath;", depth))
}
var $d_Lamf_core_validation_model_SequencePath = new $TypeData().initClass({
  Lamf_core_validation_model_SequencePath: 0
}, false, "amf.core.validation.model.SequencePath", {
  Lamf_core_validation_model_SequencePath: 1,
  Lamf_core_validation_model_PropertyPath: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_validation_model_SequencePath.prototype.$classData = $d_Lamf_core_validation_model_SequencePath;
/** @constructor */
function $c_Lamf_internal_reference_ReferenceResolverAdapter() {
  $c_O.call(this);
  this.adaptee$1 = null;
  this.executionContext$1 = null
}
$c_Lamf_internal_reference_ReferenceResolverAdapter.prototype = new $h_O();
$c_Lamf_internal_reference_ReferenceResolverAdapter.prototype.constructor = $c_Lamf_internal_reference_ReferenceResolverAdapter;
/** @constructor */
function $h_Lamf_internal_reference_ReferenceResolverAdapter() {
  /*<skip>*/
}
$h_Lamf_internal_reference_ReferenceResolverAdapter.prototype = $c_Lamf_internal_reference_ReferenceResolverAdapter.prototype;
$c_Lamf_internal_reference_ReferenceResolverAdapter.prototype.productPrefix__T = (function() {
  return "ReferenceResolverAdapter"
});
$c_Lamf_internal_reference_ReferenceResolverAdapter.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_internal_reference_ReferenceResolverAdapter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_internal_reference_ReferenceResolverAdapter)) {
    var ReferenceResolverAdapter$1 = $as_Lamf_internal_reference_ReferenceResolverAdapter(x$1);
    var x = this.adaptee$1;
    var x$2 = ReferenceResolverAdapter$1.adaptee$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_internal_reference_ReferenceResolverAdapter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.adaptee$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_internal_reference_ReferenceResolverAdapter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_internal_reference_ReferenceResolverAdapter.prototype.fetch__T__s_concurrent_Future = (function(url) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.adaptee$1.fetch__T__sjs_js_Promise(url);
  var m = $m_Lamf_client_convert_CoreClientConverters$().CachedReferenceMatcher__Lamf_client_convert_CachedReferenceConverter$CachedReferenceMatcher$();
  var executionContext = this.executionContext$1;
  return new $c_Lamf_client_convert_FutureConverter$ClientFutureOps().init___Lamf_client_convert_FutureConverter__O__Lamf_client_convert_ClientInternalMatcher__s_concurrent_ExecutionContext(this$1, from, m, executionContext).asInternal__s_concurrent_Future()
});
$c_Lamf_internal_reference_ReferenceResolverAdapter.prototype.init___Lamf_client_reference_ReferenceResolver__s_concurrent_ExecutionContext = (function(adaptee, executionContext) {
  this.adaptee$1 = adaptee;
  this.executionContext$1 = executionContext;
  return this
});
$c_Lamf_internal_reference_ReferenceResolverAdapter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_internal_reference_ReferenceResolverAdapter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_internal_reference_ReferenceResolverAdapter(obj) {
  return (((obj instanceof $c_Lamf_internal_reference_ReferenceResolverAdapter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.internal.reference.ReferenceResolverAdapter"))
}
function $isArrayOf_Lamf_internal_reference_ReferenceResolverAdapter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_internal_reference_ReferenceResolverAdapter)))
}
function $asArrayOf_Lamf_internal_reference_ReferenceResolverAdapter(obj, depth) {
  return (($isArrayOf_Lamf_internal_reference_ReferenceResolverAdapter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.internal.reference.ReferenceResolverAdapter;", depth))
}
var $d_Lamf_internal_reference_ReferenceResolverAdapter = new $TypeData().initClass({
  Lamf_internal_reference_ReferenceResolverAdapter: 0
}, false, "amf.internal.reference.ReferenceResolverAdapter", {
  Lamf_internal_reference_ReferenceResolverAdapter: 1,
  O: 1,
  Lamf_internal_reference_ReferenceResolver: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_internal_reference_ReferenceResolverAdapter.prototype.$classData = $d_Lamf_internal_reference_ReferenceResolverAdapter;
/** @constructor */
function $c_Lamf_internal_resource_ResourceLoaderAdapter() {
  $c_O.call(this);
  this.adaptee$1 = null;
  this.executionContext$1 = null
}
$c_Lamf_internal_resource_ResourceLoaderAdapter.prototype = new $h_O();
$c_Lamf_internal_resource_ResourceLoaderAdapter.prototype.constructor = $c_Lamf_internal_resource_ResourceLoaderAdapter;
/** @constructor */
function $h_Lamf_internal_resource_ResourceLoaderAdapter() {
  /*<skip>*/
}
$h_Lamf_internal_resource_ResourceLoaderAdapter.prototype = $c_Lamf_internal_resource_ResourceLoaderAdapter.prototype;
$c_Lamf_internal_resource_ResourceLoaderAdapter.prototype.productPrefix__T = (function() {
  return "ResourceLoaderAdapter"
});
$c_Lamf_internal_resource_ResourceLoaderAdapter.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_internal_resource_ResourceLoaderAdapter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_internal_resource_ResourceLoaderAdapter)) {
    var ResourceLoaderAdapter$1 = $as_Lamf_internal_resource_ResourceLoaderAdapter(x$1);
    var x = this.adaptee$1;
    var x$2 = ResourceLoaderAdapter$1.adaptee$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_internal_resource_ResourceLoaderAdapter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.adaptee$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_internal_resource_ResourceLoaderAdapter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_internal_resource_ResourceLoaderAdapter.prototype.fetch__T__s_concurrent_Future = (function(resource) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.adaptee$1.fetch__T__sjs_js_Promise(resource);
  var m = $m_Lamf_client_convert_CoreClientConverters$().ContentMatcher__Lamf_client_convert_CoreBaseConverter$ContentMatcher$();
  var executionContext = this.executionContext$1;
  return new $c_Lamf_client_convert_FutureConverter$ClientFutureOps().init___Lamf_client_convert_FutureConverter__O__Lamf_client_convert_ClientInternalMatcher__s_concurrent_ExecutionContext(this$1, from, m, executionContext).asInternal__s_concurrent_Future()
});
$c_Lamf_internal_resource_ResourceLoaderAdapter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_internal_resource_ResourceLoaderAdapter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_internal_resource_ResourceLoaderAdapter.prototype.accepts__T__Z = (function(resource) {
  return this.adaptee$1.accepts__T__Z(resource)
});
$c_Lamf_internal_resource_ResourceLoaderAdapter.prototype.init___Lamf_client_resource_ResourceLoader__s_concurrent_ExecutionContext = (function(adaptee, executionContext) {
  this.adaptee$1 = adaptee;
  this.executionContext$1 = executionContext;
  return this
});
function $as_Lamf_internal_resource_ResourceLoaderAdapter(obj) {
  return (((obj instanceof $c_Lamf_internal_resource_ResourceLoaderAdapter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.internal.resource.ResourceLoaderAdapter"))
}
function $isArrayOf_Lamf_internal_resource_ResourceLoaderAdapter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_internal_resource_ResourceLoaderAdapter)))
}
function $asArrayOf_Lamf_internal_resource_ResourceLoaderAdapter(obj, depth) {
  return (($isArrayOf_Lamf_internal_resource_ResourceLoaderAdapter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.internal.resource.ResourceLoaderAdapter;", depth))
}
var $d_Lamf_internal_resource_ResourceLoaderAdapter = new $TypeData().initClass({
  Lamf_internal_resource_ResourceLoaderAdapter: 0
}, false, "amf.internal.resource.ResourceLoaderAdapter", {
  Lamf_internal_resource_ResourceLoaderAdapter: 1,
  O: 1,
  Lamf_internal_resource_ResourceLoader: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_internal_resource_ResourceLoaderAdapter.prototype.$classData = $d_Lamf_internal_resource_ResourceLoaderAdapter;
/** @constructor */
function $c_Lamf_internal_resource_StringResourceLoader() {
  $c_O.call(this);
  this.url$1 = null;
  this.content$1 = null;
  this.$$undcontent$1 = null
}
$c_Lamf_internal_resource_StringResourceLoader.prototype = new $h_O();
$c_Lamf_internal_resource_StringResourceLoader.prototype.constructor = $c_Lamf_internal_resource_StringResourceLoader;
/** @constructor */
function $h_Lamf_internal_resource_StringResourceLoader() {
  /*<skip>*/
}
$h_Lamf_internal_resource_StringResourceLoader.prototype = $c_Lamf_internal_resource_StringResourceLoader.prototype;
$c_Lamf_internal_resource_StringResourceLoader.prototype.init___T__T = (function(url, content) {
  this.url$1 = url;
  this.content$1 = content;
  this.$$undcontent$1 = new $c_Lamf_client_remote_Content().init___T__T(content, url);
  return this
});
$c_Lamf_internal_resource_StringResourceLoader.prototype.productPrefix__T = (function() {
  return "StringResourceLoader"
});
$c_Lamf_internal_resource_StringResourceLoader.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_internal_resource_StringResourceLoader.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_internal_resource_StringResourceLoader)) {
    var StringResourceLoader$1 = $as_Lamf_internal_resource_StringResourceLoader(x$1);
    return ((this.url$1 === StringResourceLoader$1.url$1) && (this.content$1 === StringResourceLoader$1.content$1))
  } else {
    return false
  }
});
$c_Lamf_internal_resource_StringResourceLoader.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.url$1;
      break
    }
    case 1: {
      return this.content$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_internal_resource_StringResourceLoader.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_internal_resource_StringResourceLoader.prototype.fetch__T__s_concurrent_Future = (function(resource) {
  return $m_s_concurrent_Future$().successful__O__s_concurrent_Future(this.$$undcontent$1)
});
$c_Lamf_internal_resource_StringResourceLoader.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_internal_resource_StringResourceLoader.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_internal_resource_StringResourceLoader.prototype.accepts__T__Z = (function(resource) {
  return (resource === this.url$1)
});
function $as_Lamf_internal_resource_StringResourceLoader(obj) {
  return (((obj instanceof $c_Lamf_internal_resource_StringResourceLoader) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.internal.resource.StringResourceLoader"))
}
function $isArrayOf_Lamf_internal_resource_StringResourceLoader(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_internal_resource_StringResourceLoader)))
}
function $asArrayOf_Lamf_internal_resource_StringResourceLoader(obj, depth) {
  return (($isArrayOf_Lamf_internal_resource_StringResourceLoader(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.internal.resource.StringResourceLoader;", depth))
}
var $d_Lamf_internal_resource_StringResourceLoader = new $TypeData().initClass({
  Lamf_internal_resource_StringResourceLoader: 0
}, false, "amf.internal.resource.StringResourceLoader", {
  Lamf_internal_resource_StringResourceLoader: 1,
  O: 1,
  Lamf_internal_resource_ResourceLoader: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_internal_resource_StringResourceLoader.prototype.$classData = $d_Lamf_internal_resource_StringResourceLoader;
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_EmissionContext$$anonfun$addReferences$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_graph_emitter_EmissionContext$$anonfun$addReferences$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_graph_emitter_EmissionContext$$anonfun$addReferences$1.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_EmissionContext$$anonfun$addReferences$1;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_EmissionContext$$anonfun$addReferences$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_EmissionContext$$anonfun$addReferences$1.prototype = $c_Lamf_plugins_document_graph_emitter_EmissionContext$$anonfun$addReferences$1.prototype;
$c_Lamf_plugins_document_graph_emitter_EmissionContext$$anonfun$addReferences$1.prototype.init___Lamf_plugins_document_graph_emitter_EmissionContext = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext$$anonfun$addReferences$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return ($is_Lamf_core_model_document_Fragment(x1) || (x1 instanceof $c_Lamf_core_model_document_Module))
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext$$anonfun$addReferences$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ($is_Lamf_core_model_document_Fragment(x1)) {
    var x2 = $as_Lamf_core_model_document_Fragment(x1);
    var jsx$1 = $m_sc_Seq$();
    var array = [x2.encodes__Lamf_core_model_domain_DomainElement()];
    return jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))
  } else if ((x1 instanceof $c_Lamf_core_model_document_Module)) {
    var x3 = $as_Lamf_core_model_document_Module(x1);
    return $as_sc_Seq(x3.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_ModuleModel$().Declares$1))
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext$$anonfun$addReferences$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext$$anonfun$addReferences$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_plugins_document_graph_emitter_EmissionContext$$anonfun$addReferences$1 = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_EmissionContext$$anonfun$addReferences$1: 0
}, false, "amf.plugins.document.graph.emitter.EmissionContext$$anonfun$addReferences$1", {
  Lamf_plugins_document_graph_emitter_EmissionContext$$anonfun$addReferences$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_graph_emitter_EmissionContext$$anonfun$addReferences$1.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_EmissionContext$$anonfun$addReferences$1;
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1.prototype = $c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1.prototype;
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1.prototype.init___Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1.prototype.applyOrElse__Lamf_core_model_domain_Annotation__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_annotations_DomainExtensionAnnotation)) {
    var x2 = $as_Lamf_core_annotations_DomainExtensionAnnotation(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_Annotation__Z($as_Lamf_core_model_domain_Annotation(x))
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_Annotation__F1__O($as_Lamf_core_model_domain_Annotation(x), $default)
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1.prototype.isDefinedAt__Lamf_core_model_domain_Annotation__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_core_annotations_DomainExtensionAnnotation)
});
var $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1 = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1: 0
}, false, "amf.plugins.document.graph.emitter.FlattenedJsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1", {
  Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_FlattenedJsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1;
/** @constructor */
function $c_Lamf_plugins_document_graph_emitter_JsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1.prototype.constructor = $c_Lamf_plugins_document_graph_emitter_JsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1;
/** @constructor */
function $h_Lamf_plugins_document_graph_emitter_JsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_emitter_JsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1.prototype = $c_Lamf_plugins_document_graph_emitter_JsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1.prototype;
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1.prototype.applyOrElse__Lamf_core_model_domain_Annotation__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_annotations_DomainExtensionAnnotation)) {
    var x2 = $as_Lamf_core_annotations_DomainExtensionAnnotation(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_Annotation__Z($as_Lamf_core_model_domain_Annotation(x))
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_Annotation__F1__O($as_Lamf_core_model_domain_Annotation(x), $default)
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1.prototype.init___Lamf_plugins_document_graph_emitter_JsonLdEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1.prototype.isDefinedAt__Lamf_core_model_domain_Annotation__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_core_annotations_DomainExtensionAnnotation)
});
var $d_Lamf_plugins_document_graph_emitter_JsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1 = new $TypeData().initClass({
  Lamf_plugins_document_graph_emitter_JsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1: 0
}, false, "amf.plugins.document.graph.emitter.JsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1", {
  Lamf_plugins_document_graph_emitter_JsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_graph_emitter_JsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1.prototype.$classData = $d_Lamf_plugins_document_graph_emitter_JsonLdEmitter$$anonfun$$nestedInanonfun$createCustomExtensions$4$1;
/** @constructor */
function $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1.prototype.constructor = $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1;
/** @constructor */
function $h_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1.prototype = $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1.prototype;
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1.prototype.applyOrElse__Lamf_core_model_domain_AmfObject__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_model_domain_DataNode)) {
    var x2 = $as_Lamf_core_model_domain_DataNode(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfObject__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_core_model_domain_DataNode)
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfObject__Z($as_Lamf_core_model_domain_AmfObject(x))
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfObject__F1__O($as_Lamf_core_model_domain_AmfObject(x), $default)
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1.prototype.init___Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser = (function($$outer) {
  return this
});
var $d_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1 = new $TypeData().initClass({
  Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1: 0
}, false, "amf.plugins.document.graph.parser.ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1", {
  Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1.prototype.$classData = $d_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1;
/** @constructor */
function $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1() {
  $c_sr_AbstractPartialFunction.call(this);
  this.obj$1$2 = null;
  this.uri$2$2 = null
}
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1.prototype.constructor = $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1;
/** @constructor */
function $h_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1.prototype = $c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1.prototype;
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1.prototype.applyOrElse__Lamf_core_model_domain_AmfObject__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_model_domain_DataNode)) {
    var x2 = $as_Lamf_core_model_domain_DataNode(x1);
    return this.obj$1$2.addProperty__T__Lamf_core_model_domain_DataNode__Lamf_core_parser_Annotations__Lamf_core_model_domain_ObjectNode(this.uri$2$2, x2, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfObject__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_core_model_domain_DataNode)
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1.prototype.init___Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser__Lamf_core_model_domain_ObjectNode__T = (function($$outer, obj$1, uri$2) {
  this.obj$1$2 = obj$1;
  this.uri$2$2 = uri$2;
  return this
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfObject__Z($as_Lamf_core_model_domain_AmfObject(x))
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfObject__F1__O($as_Lamf_core_model_domain_AmfObject(x), $default)
});
var $d_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1 = new $TypeData().initClass({
  Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1: 0
}, false, "amf.plugins.document.graph.parser.ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1", {
  Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1.prototype.$classData = $d_Lamf_plugins_document_graph_parser_ExpandedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1;
/** @constructor */
function $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1.prototype.constructor = $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1;
/** @constructor */
function $h_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1.prototype = $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1.prototype;
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1.prototype.applyOrElse__Lamf_core_model_domain_AmfObject__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_model_domain_DataNode)) {
    var x2 = $as_Lamf_core_model_domain_DataNode(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfObject__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_core_model_domain_DataNode)
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1.prototype.init___Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfObject__Z($as_Lamf_core_model_domain_AmfObject(x))
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfObject__F1__O($as_Lamf_core_model_domain_AmfObject(x), $default)
});
var $d_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1 = new $TypeData().initClass({
  Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1: 0
}, false, "amf.plugins.document.graph.parser.FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1", {
  Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1.prototype.$classData = $d_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1;
/** @constructor */
function $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1() {
  $c_sr_AbstractPartialFunction.call(this);
  this.obj$1$2 = null;
  this.fieldUri$1$2 = null
}
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1.prototype.constructor = $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1;
/** @constructor */
function $h_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1.prototype = $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1.prototype;
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1.prototype.applyOrElse__Lamf_core_model_domain_AmfObject__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_model_domain_DataNode)) {
    var x2 = $as_Lamf_core_model_domain_DataNode(x1);
    return this.obj$1$2.addProperty__T__Lamf_core_model_domain_DataNode__Lamf_core_parser_Annotations__Lamf_core_model_domain_ObjectNode(this.fieldUri$1$2, x2, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1.prototype.init___Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser__Lamf_core_model_domain_ObjectNode__T = (function($$outer, obj$1, fieldUri$1) {
  this.obj$1$2 = obj$1;
  this.fieldUri$1$2 = fieldUri$1;
  return this
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfObject__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_core_model_domain_DataNode)
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfObject__Z($as_Lamf_core_model_domain_AmfObject(x))
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfObject__F1__O($as_Lamf_core_model_domain_AmfObject(x), $default)
});
var $d_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1 = new $TypeData().initClass({
  Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1: 0
}, false, "amf.plugins.document.graph.parser.FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1", {
  Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1.prototype.$classData = $d_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_AMLPlugin$$anonfun$apply$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_AMLPlugin$$anonfun$apply$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_AMLPlugin$$anonfun$apply$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_AMLPlugin$$anonfun$apply$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_AMLPlugin$$anonfun$apply$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_AMLPlugin$$anonfun$apply$1.prototype = $c_Lamf_plugins_document_vocabularies_AMLPlugin$$anonfun$apply$1.prototype;
$c_Lamf_plugins_document_vocabularies_AMLPlugin$$anonfun$apply$1.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$$anonfun$apply$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_client_plugins_AMFDocumentPlugin__Z($as_Lamf_client_plugins_AMFDocumentPlugin(x))
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$$anonfun$apply$1.prototype.applyOrElse__Lamf_client_plugins_AMFDocumentPlugin__F1__O = (function(x1, $default) {
  if ($is_Lamf_plugins_document_vocabularies_AMLPlugin(x1)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_AMLPlugin(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$$anonfun$apply$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_client_plugins_AMFDocumentPlugin__F1__O($as_Lamf_client_plugins_AMFDocumentPlugin(x), $default)
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$$anonfun$apply$1.prototype.isDefinedAt__Lamf_client_plugins_AMFDocumentPlugin__Z = (function(x1) {
  return $is_Lamf_plugins_document_vocabularies_AMLPlugin(x1)
});
var $d_Lamf_plugins_document_vocabularies_AMLPlugin$$anonfun$apply$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_AMLPlugin$$anonfun$apply$1: 0
}, false, "amf.plugins.document.vocabularies.AMLPlugin$$anonfun$apply$1", {
  Lamf_plugins_document_vocabularies_AMLPlugin$$anonfun$apply$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$$anonfun$apply$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_AMLPlugin$$anonfun$apply$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this);
  this.typeString$1$2 = null
}
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$1.prototype = $c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$1.prototype;
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$1.prototype.isDefinedAt__Lamf_plugins_document_vocabularies_model_document_Dialect__Z = (function(x1) {
  return (x1 !== null)
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$1.prototype.init___Lamf_plugins_document_vocabularies_DialectsRegistry__T = (function($$outer, typeString$1) {
  this.typeString$1$2 = typeString$1;
  return this
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$1.prototype.applyOrElse__Lamf_plugins_document_vocabularies_model_document_Dialect__F1__O = (function(x1, $default) {
  if ((x1 !== null)) {
    var this$1 = $as_sc_Seq(x1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Declares$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_model_domain_DomainElement(x0$1$2);
        if ((x0$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
          var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x0$1);
          return (x2.id$1 === $this.typeString$1$2)
        } else {
          return false
        }
      })
    })(this)));
    if (this$1.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1 = this$1.get__O();
      var nodeMapping = $as_Lamf_core_model_domain_DomainElement(arg1);
      return new $c_s_Some().init___O(new $c_T2().init___O__O(x1, nodeMapping))
    }
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_plugins_document_vocabularies_model_document_Dialect__Z($as_Lamf_plugins_document_vocabularies_model_document_Dialect(x))
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_plugins_document_vocabularies_model_document_Dialect__F1__O($as_Lamf_plugins_document_vocabularies_model_document_Dialect(x), $default)
});
var $d_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$1: 0
}, false, "amf.plugins.document.vocabularies.DialectsRegistry$$anonfun$1", {
  Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$2.prototype.constructor = $c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$2;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$2.prototype = $c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$2.prototype;
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$2.prototype.applyOrElse__s_Option__F1__O = (function(x2, $default) {
  if ((x2 instanceof $c_s_Some)) {
    var x2$2 = $as_s_Some(x2);
    var x = $as_T2(x2$2.value$2);
    return x
  } else {
    return $default.apply__O__O(x2)
  }
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$2.prototype.init___Lamf_plugins_document_vocabularies_DialectsRegistry = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$2.prototype.isDefinedAt__s_Option__Z = (function(x2) {
  return (x2 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$2 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$2: 0
}, false, "amf.plugins.document.vocabularies.DialectsRegistry$$anonfun$2", {
  Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$2.prototype.$classData = $d_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$2;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$3() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$3.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$3.prototype.constructor = $c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$3;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$3() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$3.prototype = $c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$3.prototype;
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$3.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x1);
    return $as_sc_Seq(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$5$2) {
        var x$5 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$5$2);
        var x = x$5.classification__Lamf_plugins_document_vocabularies_model_domain_PropertyClassification();
        var x$2 = $m_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$();
        return ((x !== null) && (x === x$2))
      })
    })(this)))
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$3.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$3.prototype.init___Lamf_plugins_document_vocabularies_DialectsRegistry = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$3.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$3.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$3 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$3: 0
}, false, "amf.plugins.document.vocabularies.DialectsRegistry$$anonfun$3", {
  Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$3: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$3.prototype.$classData = $d_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$3;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$findNode$4() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$findNode$4.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$findNode$4.prototype.constructor = $c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$findNode$4;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$findNode$4() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$findNode$4.prototype = $c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$findNode$4.prototype;
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$findNode$4.prototype.applyOrElse__T2__F1__O = (function(x1, $default) {
  if ((x1 !== null)) {
    var dialect = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(x1.$$und1__O());
    var p2 = $as_s_Option(x1.$$und2__O());
    if ((p2 instanceof $c_s_Some)) {
      var x3 = $as_s_Some(p2);
      var nodeMapping = $as_Lamf_core_model_domain_DomainElement(x3.value$2);
      if ((nodeMapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
        var x4 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(nodeMapping);
        return new $c_T2().init___O__O(dialect, x4)
      }
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$findNode$4.prototype.init___Lamf_plugins_document_vocabularies_DialectsRegistry = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$findNode$4.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__T2__Z($as_T2(x))
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$findNode$4.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__T2__F1__O($as_T2(x), $default)
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$findNode$4.prototype.isDefinedAt__T2__Z = (function(x1) {
  if ((x1 !== null)) {
    var p2 = $as_s_Option(x1.$$und2__O());
    if ((p2 instanceof $c_s_Some)) {
      var x3 = $as_s_Some(p2);
      var nodeMapping = $as_Lamf_core_model_domain_DomainElement(x3.value$2);
      if ((nodeMapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
        return true
      }
    }
  };
  return false
});
var $d_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$findNode$4 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$findNode$4: 0
}, false, "amf.plugins.document.vocabularies.DialectsRegistry$$anonfun$findNode$4", {
  Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$findNode$4: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$findNode$4.prototype.$classData = $d_Lamf_plugins_document_vocabularies_DialectsRegistry$$anonfun$findNode$4;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anonfun$7() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anonfun$7.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anonfun$7.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anonfun$7;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anonfun$7() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anonfun$7.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anonfun$7.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anonfun$7.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ($is_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anonfun$7.prototype.init___Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anonfun$7.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return $is_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anonfun$7.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anonfun$7.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anonfun$7 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anonfun$7: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.DialectDocumentsEmitters$$anonfun$7", {
  Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anonfun$7: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anonfun$7.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters$$anonfun$7;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter() {
  $c_O.call(this);
  this.dialect$1 = null;
  this.ordering$1 = null;
  this.aliases$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter.prototype.productPrefix__T = (function() {
  return "DialectEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter.prototype.emitDialect__Lorg_yaml_model_YDocument = (function() {
  var ordering = this.ordering$1;
  var jsx$2 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters__rootLevelEmitters__Lamf_core_emitter_SpecOrdering__sc_Seq(this, ordering);
  var ordering$1 = this.ordering$1;
  var jsx$1 = this.dialectPropertiesEmitter__Lamf_core_emitter_SpecOrdering__sc_Seq(ordering$1);
  var this$1 = $m_sc_Seq$();
  var content = $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  var this$3 = $m_Lorg_yaml_model_YDocument$().apply__T__Lorg_yaml_model_YDocument$WithComment("");
  var b = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(this$3.org$yaml$model$YDocument$WithComment$$sourceName$f);
  var x = this$3.comment$1;
  var this$5 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$5)) {
    b.comment__T__V(this$3.comment$1)
  };
  b.comment__T__V("%Dialect 1.0");
  var jsx$3 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(content), b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  return new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this$3.org$yaml$model$YDocument$WithComment$$sourceName$f), b.builder$1)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter)) {
    var DialectEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter(x$1);
    var x = this.dialect$1;
    var x$2 = DialectEmitter$1.dialect$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.dialect$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter.prototype.aliases__sci_Map = (function() {
  return this.aliases$1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter.prototype.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect = (function() {
  return this.dialect$1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter.prototype.dialectPropertiesEmitter__Lamf_core_emitter_SpecOrdering__sc_Seq = (function(ordering) {
  var emitters = $m_sci_Nil$();
  var jsx$3 = emitters;
  var jsx$2 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$8().init___Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter(this)];
  var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
  var this$3 = $m_sc_Seq$();
  emitters = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
  var jsx$6 = emitters;
  var jsx$5 = $m_sc_Seq$();
  var array$1 = [new $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$9().init___Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter(this)];
  var jsx$4 = jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
  var this$6 = $m_sc_Seq$();
  emitters = $as_sc_Seq(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$6.ReusableCBFInstance$2));
  var this$7 = this.dialect$1;
  var this$8 = $as_Lamf_core_model_StrField(this$7.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1));
  if ($f_Lamf_core_model_StrField__nonEmpty__Z(this$8)) {
    var jsx$9 = emitters;
    var jsx$8 = $m_sc_Seq$();
    var array$2 = [new $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter$$anon$10().init___Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter(this)];
    var jsx$7 = jsx$8.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2));
    var this$11 = $m_sc_Seq$();
    emitters = $as_sc_Seq(jsx$9.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$7, this$11.ReusableCBFInstance$2))
  };
  var jsx$10 = $m_s_Option$();
  var this$12 = this.dialect$1;
  if (jsx$10.apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(this$12.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1))).isDefined__Z()) {
    var jsx$13 = emitters;
    var jsx$12 = $m_sc_Seq$();
    var array$3 = [new $c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter().init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sci_Map(this.dialect$1, ordering, this.aliases$1)];
    var jsx$11 = jsx$12.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$3));
    var this$15 = $m_sc_Seq$();
    emitters = $as_sc_Seq(jsx$13.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$11, this$15.ReusableCBFInstance$2))
  };
  return emitters
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter.prototype.init___Lamf_plugins_document_vocabularies_model_document_Dialect = (function(dialect) {
  this.dialect$1 = dialect;
  this.ordering$1 = $m_Lamf_core_emitter_SpecOrdering$Lexical$();
  this.aliases$1 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters__collectAliases__sci_Map(this);
  return this
});
function $as_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.dialects.DialectEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.dialects.DialectEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.DialectEmitter", {
  Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter: 1,
  O: 1,
  Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter$$anonfun$3() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter$$anonfun$3.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter$$anonfun$3.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter$$anonfun$3;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter$$anonfun$3() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter$$anonfun$3.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter$$anonfun$3.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter$$anonfun$3.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var pos = $as_Lamf_core_parser_Position(x2.value$2);
    return pos
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter$$anonfun$3.prototype.init___Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter$$anonfun$3.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter$$anonfun$3.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter$$anonfun$3.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  return (x1 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter$$anonfun$3 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter$$anonfun$3: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.DocumentsModelEmitter$$anonfun$3", {
  Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter$$anonfun$3: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter$$anonfun$3.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter$$anonfun$3;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter$$anonfun$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter$$anonfun$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter$$anonfun$2.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter$$anonfun$2;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter$$anonfun$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter$$anonfun$2.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter$$anonfun$2.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter$$anonfun$2.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var node = $as_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter(x2.value$2);
    return node
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter$$anonfun$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter$$anonfun$2.prototype.init___Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter$$anonfun$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter$$anonfun$2.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  return (x1 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter$$anonfun$2 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter$$anonfun$2: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.DocumentsModelOptionsEmitter$$anonfun$2", {
  Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter$$anonfun$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter$$anonfun$2.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter$$anonfun$2;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anonfun$1.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anonfun$1.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anonfun$1.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var pos = $as_Lamf_core_parser_Position(x2.value$2);
    return pos
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anonfun$1.prototype.init___Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anonfun$1.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  return (x1 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anonfun$1: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.LibraryDocumentModelEmitter$$anonfun$1", {
  Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anonfun$5() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anonfun$5.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anonfun$5.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anonfun$5;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anonfun$5() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anonfun$5.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anonfun$5.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anonfun$5.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var alias = $as_T(x2.value$2);
    return alias
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anonfun$5.prototype.init___Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anonfun$5.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anonfun$5.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anonfun$5.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  return (x1 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anonfun$5 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anonfun$5: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.NodeMappingEmitter$$anonfun$5", {
  Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anonfun$5: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anonfun$5.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anonfun$5;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anonfun$4() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anonfun$4.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anonfun$4.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anonfun$4;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anonfun$4() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anonfun$4.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anonfun$4.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anonfun$4.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var alias = $as_T(x2.value$2);
    return alias
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anonfun$4.prototype.init___Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anonfun$4.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anonfun$4.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anonfun$4.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  return (x1 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anonfun$4 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anonfun$4: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.PropertyMappingEmitter$$anonfun$4", {
  Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anonfun$4: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anonfun$4.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anonfun$4;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter() {
  $c_O.call(this);
  this.library$1 = null;
  this.ordering$1 = null;
  this.dialect$1 = null;
  this.aliases$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter.prototype.productPrefix__T = (function() {
  return "RamlDialectLibraryEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter)) {
    var RamlDialectLibraryEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter(x$1);
    var x = this.library$1;
    var x$2 = RamlDialectLibraryEmitter$1.library$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.library$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter.prototype.aliases__sci_Map = (function() {
  return this.aliases$1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter.prototype.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect = (function() {
  return this.dialect$1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter.prototype.emitDialectLibrary__Lorg_yaml_model_YDocument = (function() {
  var ordering = this.ordering$1;
  var jsx$2 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters__rootLevelEmitters__Lamf_core_emitter_SpecOrdering__sc_Seq(this, ordering);
  var ordering$1 = this.ordering$1;
  var jsx$1 = this.dialectPropertiesEmitter__Lamf_core_emitter_SpecOrdering__sc_Seq(ordering$1);
  var this$1 = $m_sc_Seq$();
  var content = $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  var this$3 = $m_Lorg_yaml_model_YDocument$().apply__T__Lorg_yaml_model_YDocument$WithComment("");
  var b = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(this$3.org$yaml$model$YDocument$WithComment$$sourceName$f);
  var x = this$3.comment$1;
  var this$5 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$5)) {
    b.comment__T__V(this$3.comment$1)
  };
  b.comment__T__V("%Library / Dialect 1.0");
  var jsx$3 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(content), b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  return new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this$3.org$yaml$model$YDocument$WithComment$$sourceName$f), b.builder$1)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter.prototype.init___Lamf_plugins_document_vocabularies_model_document_DialectLibrary = (function(library) {
  this.library$1 = library;
  this.ordering$1 = $m_Lamf_core_emitter_SpecOrdering$Lexical$();
  this.dialect$1 = this.toDialect__Lamf_plugins_document_vocabularies_model_document_DialectLibrary__Lamf_plugins_document_vocabularies_model_document_Dialect(library);
  this.aliases$1 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters__collectAliases__sci_Map(this);
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter.prototype.dialectPropertiesEmitter__Lamf_core_emitter_SpecOrdering__sc_Seq = (function(ordering) {
  var emitters = $m_sci_Nil$();
  var this$1 = this.dialect$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1));
  if ($f_Lamf_core_model_StrField__nonEmpty__Z(this$2)) {
    var jsx$3 = emitters;
    var jsx$2 = $m_sc_Seq$();
    var array = [new $c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter$$anon$11().init___Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter(this)];
    var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$5 = $m_sc_Seq$();
    emitters = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
  };
  return emitters
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter.prototype.toDialect__Lamf_plugins_document_vocabularies_model_document_DialectLibrary__Lamf_plugins_document_vocabularies_model_document_Dialect = (function(library) {
  var this$1 = new $c_Lamf_plugins_document_vocabularies_model_document_Dialect().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(library.fields$1, library.annotations$1);
  var value = library.id$1;
  return $as_Lamf_plugins_document_vocabularies_model_document_Dialect($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$1, value))
});
function $as_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.dialects.RamlDialectLibraryEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.dialects.RamlDialectLibraryEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.RamlDialectLibraryEmitter", {
  Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter: 1,
  O: 1,
  Lamf_plugins_document_vocabularies_emitters_dialects_DialectDocumentsEmitters: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter$$anonfun$6() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter$$anonfun$6.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter$$anonfun$6.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter$$anonfun$6;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter$$anonfun$6() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter$$anonfun$6.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter$$anonfun$6.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter$$anonfun$6.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_document_BaseUnit__Z($as_Lamf_core_model_document_BaseUnit(x))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter$$anonfun$6.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O($as_Lamf_core_model_document_BaseUnit(x), $default)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter$$anonfun$6.prototype.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O = (function(x1, $default) {
  return ($is_Lamf_core_model_document_DeclaresModel(x1) ? x1 : $default.apply__O__O(x1))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter$$anonfun$6.prototype.init___Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter$$anonfun$6.prototype.isDefinedAt__Lamf_core_model_document_BaseUnit__Z = (function(x1) {
  return $is_Lamf_core_model_document_DeclaresModel(x1)
});
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter$$anonfun$6 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter$$anonfun$6: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.ReferencesEmitter$$anonfun$6", {
  Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter$$anonfun$6: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter$$anonfun$6.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter$$anonfun$6;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$1() {
  $c_sr_AbstractPartialFunction.call(this);
  this.nodeMappingId$2$2 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$1.prototype = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$1.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_document_BaseUnit__Z($as_Lamf_core_model_document_BaseUnit(x))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O($as_Lamf_core_model_document_BaseUnit(x), $default)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$1.prototype.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_document_DialectLibrary(x1);
    return $as_sc_Seq(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Declares$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$6$2) {
        var x$6 = $as_Lamf_core_model_domain_DomainElement(x$6$2);
        return (x$6.id__T() === $this.nodeMappingId$2$2)
      })
    })(this)))
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$1.prototype.init___Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__T = (function($$outer, nodeMappingId$2) {
  this.nodeMappingId$2$2 = nodeMappingId$2;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$1.prototype.isDefinedAt__Lamf_core_model_document_BaseUnit__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary)
});
var $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$1: 0
}, false, "amf.plugins.document.vocabularies.emitters.instances.DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$1", {
  Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$2() {
  $c_sr_AbstractPartialFunction.call(this);
  this.$$outer$2 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$2.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$2;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$2.prototype = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$2.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$2.prototype.applyOrElse__s_Option__F1__O = (function(x2, $default) {
  if ((x2 instanceof $c_s_Some)) {
    var x2$2 = $as_s_Some(x2);
    var mapping = $as_Lamf_core_model_domain_DomainElement(x2$2.value$2);
    if ($is_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(mapping)) {
      var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(mapping);
      return new $c_T2().init___O__O(this.$$outer$2.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect(), x3)
    }
  };
  return $default.apply__O__O(x2)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$2.prototype.init___Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$2.prototype.isDefinedAt__s_Option__Z = (function(x2) {
  if ((x2 instanceof $c_s_Some)) {
    var x2$2 = $as_s_Some(x2);
    var mapping = $as_Lamf_core_model_domain_DomainElement(x2$2.value$2);
    if ($is_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(mapping)) {
      return true
    }
  };
  return false
});
var $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$2 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$2: 0
}, false, "amf.plugins.document.vocabularies.emitters.instances.DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$2", {
  Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$2.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper$$anonfun$$nestedInanonfun$maybeFindNodeMappingById$3$2;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter() {
  $c_O.call(this);
  this.instance$1 = null;
  this.dialect$1 = null;
  this.renderOptions$1 = null;
  this.ordering$1 = null;
  this.aliases$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter.prototype.emitEncoded__p1__Lorg_yaml_model_YDocument$PartBuilder__Lamf_core_model_document_EncodesModel__V = (function(b, encoded) {
  var this$1 = this.dialect$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Name$1));
  var this$3 = this$2.option$1;
  var jsx$1 = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
  var this$4 = this.dialect$1;
  var this$5 = $as_Lamf_core_model_StrField(this$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Version$1));
  var this$6 = this$5.option$1;
  var schema = ((jsx$1 + " ") + $as_T((this$6.isEmpty__Z() ? null : this$6.get__O())));
  if ((encoded instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstance)) {
    var this$7 = this.dialect$1;
    var this$8 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(this$7.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1));
    var this$9 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(this$8.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Root$1));
    var this$10 = $as_Lamf_core_model_StrField(this$9.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().EncodedNode$1));
    var this$11 = this$10.option$1;
    var r = $as_T((this$11.isEmpty__Z() ? null : this$11.get__O()));
    var this$12 = this.dialect$1;
    var this$13 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(this$12.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1));
    var this$14 = $as_Lamf_core_model_BoolField(this$13.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().KeyProperty$1));
    if ($f_Lamf_core_model_BoolField__value__Z(this$14)) {
      var _1 = this.headerEntry__p1__sc_Seq();
      var x1$2_$_$$und1$f = _1;
      var x1$2_$_$$und2$f = r
    } else {
      b.comment__T__V(("%" + schema));
      var _1$1 = $m_sci_Nil$();
      var x1$2_$_$$und1$f = _1$1;
      var x1$2_$_$$und2$f = r
    }
  } else {
    if ((!(encoded instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment))) {
      throw new $c_s_MatchError().init___O(encoded)
    };
    var x3 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment(encoded);
    b.comment__T__V(((("%" + $as_Lamf_core_model_StrField(x3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$().Fragment$1))) + " / ") + schema));
    var _1$2 = $m_sci_Nil$();
    var this$15 = this.dialect$1;
    var this$16 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(this$15.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1));
    var this$20 = $as_sc_Seq(this$16.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Fragments$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x3$1) {
      return (function(x$9$2) {
        var x$9 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(x$9$2);
        var this$19 = $as_Lamf_core_model_StrField(x$9.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DocumentName$1));
        var this$17 = $as_Lamf_core_model_StrField(x3$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$().Fragment$1));
        var this$18 = this$17.option$1;
        var other = $as_T((this$18.isEmpty__Z() ? null : this$18.get__O()));
        return $f_Lamf_core_model_ValueField__is__O__Z(this$19, other)
      })
    })(this, x3)));
    if (this$20.isEmpty__Z()) {
      var jsx$2 = $m_s_None$()
    } else {
      var arg1 = this$20.get__O();
      var x$10 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(arg1);
      var this$21 = $as_Lamf_core_model_StrField(x$10.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().EncodedNode$1));
      var this$22 = this$21.option$1;
      var jsx$2 = new $c_s_Some().init___O($as_T((this$22.isEmpty__Z() ? null : this$22.get__O())))
    };
    var _2 = jsx$2.get__O();
    var x1$2_$_$$und1$f = _1$2;
    var x1$2_$_$$und2$f = _2
  };
  var entry = $as_sc_Seq(x1$2_$_$$und1$f);
  var root = $as_T(x1$2_$_$$und2$f);
  var x1$3 = $f_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__findNodeMappingById__T__T2(this, root);
  if ((x1$3 === null)) {
    throw new $c_s_MatchError().init___O(x1$3)
  };
  var rootNodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1$3.$$und2__O());
  if ((rootNodeMapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(rootNodeMapping);
    var discriminator = new $c_s_Some().init___O(new $c_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper().init___Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper(x2, this))
  } else {
    var discriminator = $m_s_None$()
  };
  var element = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(encoded.encodes__Lamf_core_model_domain_DomainElement());
  var x$3 = this.instance$1;
  var x$4 = this.dialect$1;
  var x$5 = this.ordering$1;
  var x$6 = this.aliases$1;
  var x$7 = $m_s_None$();
  var model = this.instance$1;
  var ordering = this.ordering$1;
  var jsx$3 = $f_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__externalEmitters__Lamf_plugins_document_vocabularies_model_document_ExternalContext__Lamf_core_emitter_SpecOrdering__sc_Seq(this, model, ordering);
  var this$23 = $m_sc_Seq$();
  var x$9$3 = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(entry, this$23.ReusableCBFInstance$2));
  if (discriminator.isEmpty__Z()) {
    var x$10$3 = $m_s_None$()
  } else {
    var arg1$1 = discriminator.get__O();
    var x$12 = $as_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper(arg1$1);
    var x$10$3 = x$12.compute__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__s_Option(element)
  };
  var x$11$2 = this.renderOptions$1;
  var x$12$3 = $m_s_None$();
  new $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter().init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sci_Map__s_Option__Z__s_Option__s_Option__Z__sc_Seq__Lamf_core_emitter_RenderOptions(element, rootNodeMapping, x$3, x$4, x$5, x$6, x$7, true, x$12$3, x$10$3, false, x$9$3, x$11$2).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter.prototype.productPrefix__T = (function() {
  return "DialectInstancesEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter)) {
    var DialectInstancesEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter(x$1);
    var x = this.instance$1;
    var x$2 = DialectInstancesEmitter$1.instance$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.dialect$1;
      var x$4 = DialectInstancesEmitter$1.dialect$1;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.renderOptions$1;
      var x$6 = DialectInstancesEmitter$1.renderOptions$1;
      return (x$5 === x$6)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter.prototype.emitInstance__Lorg_yaml_model_YDocument = (function() {
  var this$2 = $m_Lorg_yaml_model_YDocument$().apply__T__Lorg_yaml_model_YDocument$WithComment("");
  var b = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(this$2.org$yaml$model$YDocument$WithComment$$sourceName$f);
  var x = this$2.comment$1;
  var this$4 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$4)) {
    b.comment__T__V(this$2.comment$1)
  };
  var x1 = this.instance$1;
  if ($is_Lamf_core_model_document_EncodesModel(x1)) {
    this.emitEncoded__p1__Lorg_yaml_model_YDocument$PartBuilder__Lamf_core_model_document_EncodesModel__V(b, $as_Lamf_core_model_document_EncodesModel(x1))
  };
  return new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this$2.org$yaml$model$YDocument$WithComment$$sourceName$f), b.builder$1)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.instance$1;
      break
    }
    case 1: {
      return this.dialect$1;
      break
    }
    case 2: {
      return this.renderOptions$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter.prototype.headerEntry__p1__sc_Seq = (function() {
  var jsx$1 = $m_sc_Seq$();
  var this$1 = this.dialect$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Name$1));
  var this$3 = this$2.option$1;
  var x$1 = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
  var this$4 = this.dialect$1;
  var this$5 = $as_Lamf_core_model_StrField(this$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Version$1));
  var this$6 = this$5.option$1;
  var x$2 = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
  var x$3 = new $c_Lamf_core_parser_Position().init___I__I(0, 1);
  var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
  var array = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position(x$1, x$2, x$4, x$3)];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter.prototype.init___Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_RenderOptions = (function(instance, dialect, renderOptions) {
  this.instance$1 = instance;
  this.dialect$1 = dialect;
  this.renderOptions$1 = renderOptions;
  this.ordering$1 = $m_Lamf_core_emitter_SpecOrdering$Lexical$();
  this.aliases$1 = this.collectAliases__sci_Map();
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter.prototype.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect = (function() {
  return this.dialect$1
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter.prototype.collectAliases__sci_Map = (function() {
  var this$1 = this.instance$1;
  var this$2 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$1);
  var thiz = $as_T((this$2.isEmpty__Z() ? this.instance$1.id__T() : this$2.get__O()));
  var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "/", 0);
  var this$5 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
  var vocabFile = $as_T($f_sc_IndexedSeqOptimized__last__O(this$5));
  var this$6 = this.instance$1;
  var this$7 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$6);
  var thiz$1 = $as_T((this$7.isEmpty__Z() ? this.instance$1.id__T() : this$7.get__O()));
  var vocabFilePrefix = $as_T(thiz$1.split(vocabFile).join(""));
  var this$10 = this.instance$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_Aliases.getClassOf());
  if (this$10.isEmpty__Z()) {
    var this$14 = $m_s_None$()
  } else {
    var arg1 = this$10.get__O();
    var aliases = $as_Lamf_core_annotations_Aliases(arg1);
    var this$13 = aliases.aliases$1;
    var z = $m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$());
    var op = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
      return (function(x0$1$2, x1$1$2) {
        var x0$1 = $as_sci_Map(x0$1$2);
        var x1$1 = $as_T2(x1$1$2);
        var x1 = new $c_T2().init___O__O(x0$1, x1$1);
        var acc = $as_sci_Map(x1.$$und1$f);
        var p2 = $as_T2(x1.$$und2$f);
        if ((p2 !== null)) {
          var alias = $as_T(p2.$$und1__O());
          var p3 = $as_T2(p2.$$und2__O());
          if ((p3 !== null)) {
            var fullUrl = $as_T(p3.$$und1__O());
            return acc.$$plus__T2__sci_Map(new $c_T2().init___O__O(fullUrl, alias))
          }
        };
        throw new $c_s_MatchError().init___O(x1)
      })
    })(this));
    var this$14 = new $c_s_Some().init___O($as_sci_Map($f_sc_TraversableOnce__foldLeft__O__F2__O(this$13, z, op)))
  };
  var maps = $as_sci_Map((this$14.isEmpty__Z() ? $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())) : this$14.get__O()));
  var idCounter = new $c_Lamf_plugins_document_vocabularies_emitters_common_IdCounter().init___();
  return $as_sci_Map(this.instance$1.references__sc_Seq().foldLeft__O__F2__O($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$5$1, vocabFilePrefix$1, maps$1, idCounter$1) {
    return (function(x0$2$2, x1$2$2) {
      var x0$2 = $as_sci_Map(x0$2$2);
      var x1$2 = $as_Lamf_core_model_document_BaseUnit(x1$2$2);
      var x1$3 = new $c_T2().init___O__O(x0$2, x1$2);
      var acc$1 = $as_sci_Map(x1$3.$$und1$f);
      var m = $as_Lamf_core_model_document_BaseUnit(x1$3.$$und2$f);
      if ((acc$1 !== null)) {
        if ($is_Lamf_core_model_document_DeclaresModel(m)) {
          var this$15 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(m);
          var thiz$2 = $as_T((this$15.isEmpty__Z() ? m.id__T() : this$15.get__O()));
          var location = $as_T(thiz$2.split("#").join(""));
          var importLocation = (($uI(location.indexOf(vocabFilePrefix$1)) !== (-1)) ? $as_T(location.split(vocabFilePrefix$1).join("")) : $as_T(location.split("file://").join("")));
          if (maps$1.get__O__s_Option(m.id__T()).isDefined__Z()) {
            var alias$1 = $as_T(maps$1.apply__O__O(m.id__T()));
            var self = m.id__T();
            var y = new $c_T2().init___O__O(alias$1, importLocation);
            return acc$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, y))
          } else {
            var nextAlias = idCounter$1.genId__T__T("uses_");
            var self$1 = m.id__T();
            var y$1 = new $c_T2().init___O__O(nextAlias, importLocation);
            return acc$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$1, y$1))
          }
        }
      };
      var acc$2 = $as_sci_Map(x1$3.$$und1$f);
      if ((acc$2 !== null)) {
        return acc$2
      };
      throw new $c_s_MatchError().init___O(x1$3)
    })
  })(this, vocabFilePrefix, maps, idCounter))))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.instances.DialectInstancesEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.instances.DialectInstancesEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.instances.DialectInstancesEmitter", {
  Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter: 1,
  O: 1,
  Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$2() {
  $c_sr_AbstractPartialFunction.call(this);
  this.publicMappings$1$2 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$2.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$2;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$2.prototype = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$2.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$2.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x1);
    if (this.publicMappings$1$2.contains__O__Z(x2.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping().id$1)) {
      return x2
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$2.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x1);
    if (this.publicMappings$1$2.contains__O__Z(x2.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping().id$1)) {
      return true
    }
  };
  return false
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$2.prototype.init___Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter__sci_Set = (function($$outer, publicMappings$1) {
  this.publicMappings$1$2 = publicMappings$1;
  return this
});
var $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$2 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$2: 0
}, false, "amf.plugins.document.vocabularies.emitters.instances.DialectNodeEmitter$$anonfun$2", {
  Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$2.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$2;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$3() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$3.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$3.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$3;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$3() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$3.prototype = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$3.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$3.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var nodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x2.value$2);
    if ((nodeMapping !== null)) {
      return nodeMapping
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$3.prototype.init___Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$3.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$3.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$3.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var nodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x2.value$2);
    if ((nodeMapping !== null)) {
      return true
    }
  };
  return false
});
var $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$3 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$3: 0
}, false, "amf.plugins.document.vocabularies.emitters.instances.DialectNodeEmitter$$anonfun$3", {
  Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$3: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$3.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$3;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$findAllNodeMappings$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$findAllNodeMappings$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$findAllNodeMappings$2.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$findAllNodeMappings$2;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$findAllNodeMappings$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$findAllNodeMappings$2.prototype = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$findAllNodeMappings$2.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$findAllNodeMappings$2.prototype.init___Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$findAllNodeMappings$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Z($as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$findAllNodeMappings$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__F1__O($as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x), $default)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$findAllNodeMappings$2.prototype.applyOrElse__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$findAllNodeMappings$2.prototype.isDefinedAt__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)
});
var $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$findAllNodeMappings$2 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$findAllNodeMappings$2: 0
}, false, "amf.plugins.document.vocabularies.emitters.instances.DialectNodeEmitter$$anonfun$findAllNodeMappings$2", {
  Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$findAllNodeMappings$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$findAllNodeMappings$2.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$findAllNodeMappings$2;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter$$anonfun$1.prototype = $c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter$$anonfun$1.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter$$anonfun$1.prototype.init___Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_document_BaseUnit__Z($as_Lamf_core_model_document_BaseUnit(x))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O($as_Lamf_core_model_document_BaseUnit(x), $default)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter$$anonfun$1.prototype.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O = (function(x1, $default) {
  return ($is_Lamf_core_model_document_DeclaresModel(x1) ? x1 : $default.apply__O__O(x1))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter$$anonfun$1.prototype.isDefinedAt__Lamf_core_model_document_BaseUnit__Z = (function(x1) {
  return $is_Lamf_core_model_document_DeclaresModel(x1)
});
var $d_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter$$anonfun$1: 0
}, false, "amf.plugins.document.vocabularies.emitters.instances.ReferencesEmitter$$anonfun$1", {
  Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter() {
  $c_O.call(this);
  this.vocabulary$1 = null;
  this.aliasMapping$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter.prototype.propertyTermsEmitter__Lamf_core_emitter_SpecOrdering__sc_Seq = (function(ordering) {
  var this$1 = this.vocabulary$1;
  var propertyTerms = $as_sc_Seq($as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Declares$1)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$31$2) {
      var x$31 = $as_Lamf_core_model_domain_DomainElement(x$31$2);
      return (x$31 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm)
    })
  })(this))));
  if (propertyTerms.nonEmpty__Z()) {
    var jsx$1 = $m_sc_Seq$();
    var array = [new $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$11().init___Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter__Lamf_core_emitter_SpecOrdering__sc_Seq(this, ordering, propertyTerms)];
    return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  } else {
    return $m_sci_Nil$()
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter.prototype.productPrefix__T = (function() {
  return "VocabularyEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter.prototype.externalEmitters__Lamf_core_emitter_SpecOrdering__sc_Seq = (function(ordering) {
  var this$1 = this.vocabulary$1;
  if ($f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(this$1).nonEmpty__Z()) {
    var jsx$1 = $m_sc_Seq$();
    var array = [new $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$5().init___Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter__Lamf_core_emitter_SpecOrdering(this, ordering)];
    return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  } else {
    return $m_sci_Nil$()
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter.prototype.init___Lamf_plugins_document_vocabularies_model_document_Vocabulary = (function(vocabulary) {
  this.vocabulary$1 = vocabulary;
  this.aliasMapping$1 = $f_Lamf_plugins_document_vocabularies_emitters_vocabularies_AliasMapper__buildAliasMapping__Lamf_plugins_document_vocabularies_model_document_Vocabulary__sci_Map(this, vocabulary);
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter)) {
    var VocabularyEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter(x$1);
    var x = this.vocabulary$1;
    var x$2 = VocabularyEmitter$1.vocabulary$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter.prototype.importEmitters__Lamf_core_emitter_SpecOrdering__sc_Seq = (function(ordering) {
  var this$1 = this.vocabulary$1;
  if ($as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Imports$1)).nonEmpty__Z()) {
    var jsx$1 = $m_sc_Seq$();
    var array = [new $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$6().init___Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter__Lamf_core_emitter_SpecOrdering(this, ordering)];
    return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  } else {
    return $m_sci_Nil$()
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.vocabulary$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter.prototype.emitVocabulary__Lorg_yaml_model_YDocument = (function() {
  var ordering = $m_Lamf_core_emitter_SpecOrdering$().ordering__Lamf_core_remote_Vendor__Lamf_core_parser_Annotations__Lamf_core_emitter_SpecOrdering($m_Lamf_core_remote_Raml$(), this.vocabulary$1.annotations$1);
  var jsx$2 = this.rootLevelEmitters__Lamf_core_emitter_SpecOrdering__sc_Seq(ordering);
  var jsx$1 = this.vocabularyEmitters__Lamf_core_emitter_SpecOrdering__sc_Seq(ordering);
  var this$1 = $m_sc_Seq$();
  var content = $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  var this$3 = $m_Lorg_yaml_model_YDocument$().apply__T__Lorg_yaml_model_YDocument$WithComment("");
  var b = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(this$3.org$yaml$model$YDocument$WithComment$$sourceName$f);
  var x = this$3.comment$1;
  var this$5 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$5)) {
    b.comment__T__V(this$3.comment$1)
  };
  b.comment__T__V("%Vocabulary 1.0");
  var jsx$3 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(ordering.sorted__sc_Seq__sc_Seq(content), b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  return new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this$3.org$yaml$model$YDocument$WithComment$$sourceName$f), b.builder$1)
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter.prototype.vocabularyEmitters__Lamf_core_emitter_SpecOrdering__sc_Seq = (function(ordering) {
  var jsx$4 = this.vocabularyPropertiesEmitter__p1__Lamf_core_emitter_SpecOrdering__sc_Seq(ordering);
  var jsx$3 = this.classTermsEmitter__Lamf_core_emitter_SpecOrdering__sc_Seq(ordering);
  var this$1 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$1.ReusableCBFInstance$2));
  var jsx$1 = this.propertyTermsEmitter__Lamf_core_emitter_SpecOrdering__sc_Seq(ordering);
  var this$2 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter.prototype.vocabularyPropertiesEmitter__p1__Lamf_core_emitter_SpecOrdering__sc_Seq = (function(ordering) {
  var emitters = $m_sci_Nil$();
  var jsx$3 = emitters;
  var jsx$2 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$7().init___Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter(this)];
  var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
  var this$3 = $m_sc_Seq$();
  emitters = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
  var jsx$6 = emitters;
  var jsx$5 = $m_sc_Seq$();
  var array$1 = [new $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$8().init___Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter(this)];
  var jsx$4 = jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
  var this$6 = $m_sc_Seq$();
  emitters = $as_sc_Seq(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$6.ReusableCBFInstance$2));
  var this$7 = this.vocabulary$1;
  var this$8 = $as_Lamf_core_model_StrField(this$7.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1));
  if ($f_Lamf_core_model_StrField__nonEmpty__Z(this$8)) {
    var jsx$9 = emitters;
    var jsx$8 = $m_sc_Seq$();
    var array$2 = [new $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$9().init___Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter(this)];
    var jsx$7 = jsx$8.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2));
    var this$11 = $m_sc_Seq$();
    emitters = $as_sc_Seq(jsx$9.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$7, this$11.ReusableCBFInstance$2))
  };
  return emitters
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter.prototype.rootLevelEmitters__Lamf_core_emitter_SpecOrdering__sc_Seq = (function(ordering) {
  var jsx$2 = this.externalEmitters__Lamf_core_emitter_SpecOrdering__sc_Seq(ordering);
  var jsx$1 = this.importEmitters__Lamf_core_emitter_SpecOrdering__sc_Seq(ordering);
  var this$1 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter.prototype.classTermsEmitter__Lamf_core_emitter_SpecOrdering__sc_Seq = (function(ordering) {
  var this$1 = this.vocabulary$1;
  var classTerms = $as_sc_Seq($as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Declares$1)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$26$2) {
      var x$26 = $as_Lamf_core_model_domain_DomainElement(x$26$2);
      return (x$26 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm)
    })
  })(this))));
  if (classTerms.nonEmpty__Z()) {
    var jsx$1 = $m_sc_Seq$();
    var array = [new $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter$$anon$10().init___Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter__Lamf_core_emitter_SpecOrdering__sc_Seq(this, ordering, classTerms)];
    return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  } else {
    return $m_sci_Nil$()
  }
});
function $as_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.vocabularies.VocabularyEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.vocabularies.VocabularyEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.vocabularies.VocabularyEmitter", {
  Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter: 1,
  O: 1,
  Lamf_plugins_document_vocabularies_emitters_vocabularies_AliasMapper: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$() {
  $c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyTermModel.call(this);
  this.type$2 = null
}
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$.prototype = new $h_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyTermModel();
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyTermModel.prototype.init___.call(this);
  $n_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$ = this;
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Owl$1;
  var x$8 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "DatatypeProperty");
  var this$3 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  var x$7 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "Property");
  var this$5 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  var this$6 = new $c_sci_$colon$colon().init___O__sci_List(x$7, this$5);
  this.type$2 = new $c_sci_$colon$colon().init___O__sci_List(x$8, this$6);
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$.prototype.type__sci_List = (function() {
  return this.type$2
});
var $d_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$: 0
}, false, "amf.plugins.document.vocabularies.metamodel.domain.DatatypePropertyTermModel$", {
  Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$: 1,
  Lamf_plugins_document_vocabularies_metamodel_domain_PropertyTermModel: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$;
var $n_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$() {
  if ((!$n_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$)) {
    $n_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$ = new $c_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel() {
  $c_O.call(this);
  this.typeIri$1 = null;
  this.typeFields$1 = null;
  this.nodeMapping$1 = null;
  this.fields$1 = null;
  this.type$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.doc$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  this.doc$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var element = new $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var this$4 = this.nodeMapping$1;
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var nodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(arg1);
    element.withDefinedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(nodeMapping)
  };
  element.withInstanceTypes__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(this.typeIri$1);
  return element
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel.prototype.init___sc_Seq__sc_Seq__s_Option = (function(typeIri, typeFields, nodeMapping) {
  this.typeIri$1 = typeIri;
  this.typeFields$1 = typeFields;
  this.nodeMapping$1 = nodeMapping;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  var x$2 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$().Abstract$1;
  var x$1 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$().DeclarationName$1;
  var jsx$3 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var jsx$2 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().fields$1;
  var this$1 = $m_sci_List$();
  var jsx$1 = $as_sci_List(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$1.ReusableCBFInstance$2));
  var this$2 = $m_sci_List$();
  var this$3 = $as_sci_List(jsx$1.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(typeFields, this$2.ReusableCBFInstance$2));
  var this$4 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$3);
  this.fields$1 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$4);
  var jsx$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(iri$2) {
      var iri = $as_T(iri$2);
      return $m_Lamf_core_vocabulary_ValueType$().apply__T__Lamf_core_vocabulary_ValueType(iri)
    })
  })(this));
  var this$5 = $m_sc_Seq$();
  var jsx$5 = $as_sc_TraversableOnce(typeIri.map__F1__scg_CanBuildFrom__O(jsx$6, this$5.ReusableCBFInstance$2)).toList__sci_List();
  var this$6 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  var x$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$6, "DialectDomainElement");
  var this$8 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  var jsx$4 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$8);
  var this$9 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$9.ReusableCBFInstance$2));
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel.prototype.type__sci_List = (function() {
  return this.type$1
});
function $as_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.metamodel.domain.DialectDomainElementModel"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.metamodel.domain.DialectDomainElementModel;", depth))
}
var $d_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel: 0
}, false, "amf.plugins.document.vocabularies.metamodel.domain.DialectDomainElementModel", {
  Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$() {
  $c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyTermModel.call(this);
  this.type$2 = null
}
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$.prototype = new $h_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyTermModel();
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyTermModel.prototype.init___.call(this);
  $n_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$ = this;
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Owl$1;
  var x$6 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "ObjectProperty");
  var this$3 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  var x$5 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "Property");
  var this$5 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  var this$6 = new $c_sci_$colon$colon().init___O__sci_List(x$5, this$5);
  this.type$2 = new $c_sci_$colon$colon().init___O__sci_List(x$6, this$6);
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$.prototype.type__sci_List = (function() {
  return this.type$2
});
var $d_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$: 0
}, false, "amf.plugins.document.vocabularies.metamodel.domain.ObjectPropertyTermModel$", {
  Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$: 1,
  Lamf_plugins_document_vocabularies_metamodel_domain_PropertyTermModel: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$;
var $n_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$() {
  if ((!$n_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$)) {
    $n_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$ = new $c_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$
}
function $is_Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit)))
}
function $as_Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit(obj) {
  return (($is_Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.document.DialectInstanceUnit"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.document.DialectInstanceUnit;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer$$anonfun$findNodeMapping$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer$$anonfun$findNodeMapping$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer$$anonfun$findNodeMapping$2.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer$$anonfun$findNodeMapping$2;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer$$anonfun$findNodeMapping$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer$$anonfun$findNodeMapping$2.prototype = $c_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer$$anonfun$findNodeMapping$2.prototype;
$c_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer$$anonfun$findNodeMapping$2.prototype.init___Lamf_plugins_document_vocabularies_model_document_MappingDeclarer = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer$$anonfun$findNodeMapping$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_document_BaseUnit__Z($as_Lamf_core_model_document_BaseUnit(x))
});
$c_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer$$anonfun$findNodeMapping$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O($as_Lamf_core_model_document_BaseUnit(x), $default)
});
$c_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer$$anonfun$findNodeMapping$2.prototype.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O = (function(x1, $default) {
  return ($is_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer(x1) ? x1 : $default.apply__O__O(x1))
});
$c_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer$$anonfun$findNodeMapping$2.prototype.isDefinedAt__Lamf_core_model_document_BaseUnit__Z = (function(x1) {
  return $is_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer(x1)
});
var $d_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer$$anonfun$findNodeMapping$2 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_document_MappingDeclarer$$anonfun$findNodeMapping$2: 0
}, false, "amf.plugins.document.vocabularies.model.document.MappingDeclarer$$anonfun$findNodeMapping$2", {
  Lamf_plugins_document_vocabularies_model_document_MappingDeclarer$$anonfun$findNodeMapping$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer$$anonfun$findNodeMapping$2.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_document_MappingDeclarer$$anonfun$findNodeMapping$2;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1.prototype.applyOrElse__Lamf_core_parser_Value__F1__O = (function(x1, $default) {
  var o9 = $m_Lamf_core_parser_Value$().unapply__Lamf_core_parser_Value__s_Option(x1);
  if ((!o9.isEmpty__Z())) {
    var v = $as_Lamf_core_model_domain_AmfElement($as_T2(o9.get__O()).$$und1__O());
    if ((v instanceof $c_Lamf_core_model_domain_AmfArray)) {
      var x4 = $as_Lamf_core_model_domain_AmfArray(v);
      var jsx$2 = x4.values$1;
      var jsx$1 = new $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1$$anonfun$applyOrElse$2().init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1(this);
      var this$1 = $m_sc_Seq$();
      return jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1.prototype.isDefinedAt__Lamf_core_parser_Value__Z = (function(x1) {
  var o9 = $m_Lamf_core_parser_Value$().unapply__Lamf_core_parser_Value__s_Option(x1);
  if ((!o9.isEmpty__Z())) {
    var v = $as_Lamf_core_model_domain_AmfElement($as_T2(o9.get__O()).$$und1__O());
    if ((v instanceof $c_Lamf_core_model_domain_AmfArray)) {
      return true
    }
  };
  return false
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1.prototype.init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_parser_Value__Z($as_Lamf_core_parser_Value(x))
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_parser_Value__F1__O($as_Lamf_core_parser_Value(x), $default)
});
var $d_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1: 0
}, false, "amf.plugins.document.vocabularies.model.domain.DialectDomainElement$$anonfun$literalProperties$1", {
  Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1$$anonfun$applyOrElse$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1$$anonfun$applyOrElse$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1$$anonfun$applyOrElse$2.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1$$anonfun$applyOrElse$2;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1$$anonfun$applyOrElse$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1$$anonfun$applyOrElse$2.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1$$anonfun$applyOrElse$2.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1$$anonfun$applyOrElse$2.prototype.init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1 = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1$$anonfun$applyOrElse$2.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_core_model_domain_AmfScalar)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1$$anonfun$applyOrElse$2.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
    var x2 = $as_Lamf_core_model_domain_AmfScalar(x1);
    return x2.value$1
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1$$anonfun$applyOrElse$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1$$anonfun$applyOrElse$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1$$anonfun$applyOrElse$2 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1$$anonfun$applyOrElse$2: 0
}, false, "amf.plugins.document.vocabularies.model.domain.DialectDomainElement$$anonfun$literalProperties$1$$anonfun$applyOrElse$2", {
  Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1$$anonfun$applyOrElse$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1$$anonfun$applyOrElse$2.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1$$anonfun$applyOrElse$2;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperty$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperty$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperty$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperty$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperty$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperty$1.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperty$1.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperty$1.prototype.applyOrElse__Lamf_core_parser_Value__F1__O = (function(x1, $default) {
  var o9 = $m_Lamf_core_parser_Value$().unapply__Lamf_core_parser_Value__s_Option(x1);
  if ((!o9.isEmpty__Z())) {
    var v = $as_Lamf_core_model_domain_AmfElement($as_T2(o9.get__O()).$$und1__O());
    if ((v instanceof $c_Lamf_core_model_domain_AmfScalar)) {
      var x4 = $as_Lamf_core_model_domain_AmfScalar(v);
      return x4.value$1
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperty$1.prototype.isDefinedAt__Lamf_core_parser_Value__Z = (function(x1) {
  var o9 = $m_Lamf_core_parser_Value$().unapply__Lamf_core_parser_Value__s_Option(x1);
  if ((!o9.isEmpty__Z())) {
    var v = $as_Lamf_core_model_domain_AmfElement($as_T2(o9.get__O()).$$und1__O());
    if ((v instanceof $c_Lamf_core_model_domain_AmfScalar)) {
      return true
    }
  };
  return false
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperty$1.prototype.init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperty$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_parser_Value__Z($as_Lamf_core_parser_Value(x))
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperty$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_parser_Value__F1__O($as_Lamf_core_parser_Value(x), $default)
});
var $d_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperty$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperty$1: 0
}, false, "amf.plugins.document.vocabularies.model.domain.DialectDomainElement$$anonfun$literalProperty$1", {
  Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperty$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperty$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperty$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1.prototype.applyOrElse__Lamf_core_parser_Value__F1__O = (function(x1, $default) {
  var o9 = $m_Lamf_core_parser_Value$().unapply__Lamf_core_parser_Value__s_Option(x1);
  if ((!o9.isEmpty__Z())) {
    var arr = $as_Lamf_core_model_domain_AmfElement($as_T2(o9.get__O()).$$und1__O());
    if ((arr instanceof $c_Lamf_core_model_domain_AmfArray)) {
      var x4 = $as_Lamf_core_model_domain_AmfArray(arr);
      var jsx$2 = x4.values$1;
      var jsx$1 = new $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1$$anonfun$applyOrElse$1().init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1(this);
      var this$1 = $m_sc_Seq$();
      return jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1.prototype.isDefinedAt__Lamf_core_parser_Value__Z = (function(x1) {
  var o9 = $m_Lamf_core_parser_Value$().unapply__Lamf_core_parser_Value__s_Option(x1);
  if ((!o9.isEmpty__Z())) {
    var arr = $as_Lamf_core_model_domain_AmfElement($as_T2(o9.get__O()).$$und1__O());
    if ((arr instanceof $c_Lamf_core_model_domain_AmfArray)) {
      return true
    }
  };
  return false
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1.prototype.init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_parser_Value__Z($as_Lamf_core_parser_Value(x))
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_parser_Value__F1__O($as_Lamf_core_parser_Value(x), $default)
});
var $d_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1: 0
}, false, "amf.plugins.document.vocabularies.model.domain.DialectDomainElement$$anonfun$objectCollectionProperty$1", {
  Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1$$anonfun$applyOrElse$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1$$anonfun$applyOrElse$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1$$anonfun$applyOrElse$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1$$anonfun$applyOrElse$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1$$anonfun$applyOrElse$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1$$anonfun$applyOrElse$1.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1$$anonfun$applyOrElse$1.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1$$anonfun$applyOrElse$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1$$anonfun$applyOrElse$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1$$anonfun$applyOrElse$1.prototype.init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1 = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1$$anonfun$applyOrElse$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1$$anonfun$applyOrElse$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1$$anonfun$applyOrElse$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1$$anonfun$applyOrElse$1: 0
}, false, "amf.plugins.document.vocabularies.model.domain.DialectDomainElement$$anonfun$objectCollectionProperty$1$$anonfun$applyOrElse$1", {
  Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1$$anonfun$applyOrElse$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1$$anonfun$applyOrElse$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1$$anonfun$applyOrElse$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectProperty$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectProperty$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectProperty$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectProperty$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectProperty$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectProperty$1.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectProperty$1.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectProperty$1.prototype.applyOrElse__Lamf_core_parser_Value__F1__O = (function(x1, $default) {
  var o9 = $m_Lamf_core_parser_Value$().unapply__Lamf_core_parser_Value__s_Option(x1);
  if ((!o9.isEmpty__Z())) {
    var d = $as_Lamf_core_model_domain_AmfElement($as_T2(o9.get__O()).$$und1__O());
    if ((d instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
      var x4 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(d);
      return x4
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectProperty$1.prototype.isDefinedAt__Lamf_core_parser_Value__Z = (function(x1) {
  var o9 = $m_Lamf_core_parser_Value$().unapply__Lamf_core_parser_Value__s_Option(x1);
  if ((!o9.isEmpty__Z())) {
    var d = $as_Lamf_core_model_domain_AmfElement($as_T2(o9.get__O()).$$und1__O());
    if ((d instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
      return true
    }
  };
  return false
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectProperty$1.prototype.init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectProperty$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_parser_Value__Z($as_Lamf_core_parser_Value(x))
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectProperty$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_parser_Value__F1__O($as_Lamf_core_parser_Value(x), $default)
});
var $d_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectProperty$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectProperty$1: 0
}, false, "amf.plugins.document.vocabularies.model.domain.DialectDomainElement$$anonfun$objectProperty$1", {
  Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectProperty$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectProperty$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectProperty$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$1.prototype = $c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$1.prototype;
$c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$1.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var parsed = $as_T3(x2.value$2);
    return parsed
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$1.prototype.init___Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$1.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  return (x1 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$1: 0
}, false, "amf.plugins.document.vocabularies.parser.common.AnnotationsParser$$anonfun$1", {
  Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$2.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$2;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$2.prototype = $c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$2.prototype;
$c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$2.prototype.applyOrElse__s_Option__F1__O = (function(x2, $default) {
  if ((x2 instanceof $c_s_Some)) {
    var x2$2 = $as_s_Some(x2);
    var parsed = $as_Lamf_core_model_domain_extensions_DomainExtension(x2$2.value$2);
    return parsed
  } else {
    return $default.apply__O__O(x2)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$2.prototype.init___Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$2.prototype.isDefinedAt__s_Option__Z = (function(x2) {
  return (x2 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$2 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$2: 0
}, false, "amf.plugins.document.vocabularies.parser.common.AnnotationsParser$$anonfun$2", {
  Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$2.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser$$anonfun$2;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$$anonfun$findNodeMapping$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$$anonfun$findNodeMapping$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$$anonfun$findNodeMapping$2.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$$anonfun$findNodeMapping$2;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$$anonfun$findNodeMapping$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$$anonfun$findNodeMapping$2.prototype = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$$anonfun$findNodeMapping$2.prototype;
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$$anonfun$findNodeMapping$2.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ($is_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$$anonfun$findNodeMapping$2.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return $is_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$$anonfun$findNodeMapping$2.prototype.init___Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$$anonfun$findNodeMapping$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$$anonfun$findNodeMapping$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$$anonfun$findNodeMapping$2 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$$anonfun$findNodeMapping$2: 0
}, false, "amf.plugins.document.vocabularies.parser.dialects.DialectDeclarations$$anonfun$findNodeMapping$2", {
  Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$$anonfun$findNodeMapping$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$$anonfun$findNodeMapping$2.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$$anonfun$findNodeMapping$2;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser() {
  $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser.call(this);
  this.into$2 = null
}
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser.prototype = new $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser();
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser.prototype = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser.prototype;
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser.prototype.productPrefix__T = (function() {
  return "DialectDeclaresParser"
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser)) {
    var DialectDeclaresParser$1 = $as_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser(x$1);
    var x = this.into$2;
    var x$2 = DialectDeclaresParser$1.into$2;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.into$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser.prototype.parse__Lorg_yaml_model_YMapEntry__V = (function(entry) {
  var this$1 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$1;
  var declaresMap = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var jsx$4 = declaresMap.entries$3;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, entry$1) {
    return (function(declarationEntry$2) {
      var declarationEntry = $as_Lorg_yaml_model_YMapEntry(declarationEntry$2);
      var this$2 = declarationEntry.value$2;
      var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$1 = $this.ctx$1;
      var declarationId = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$1, iv$1)).text$3;
      var node = declarationEntry.key$2;
      var iv$2 = $this.ctx$1;
      var this$4 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv$2);
      var declarationName = this$4.string__Lamf_core_model_domain_AmfScalar();
      var this$5 = $m_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping$().apply__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping(declarationEntry);
      var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().Name$1;
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(declarationEntry.key$2);
      var jsx$3 = $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$5, field, declarationName, annotations);
      var jsx$2 = $this.into$2.id$1;
      var str = declarationName.toString__T();
      var this$7 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
      var this$8 = this$7.platform$1;
      var url = this$7.str$1;
      var declarationMapping = $as_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping(jsx$3.withId__T__Lamf_core_model_domain_AmfObject(((jsx$2 + "/declaration/") + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$8, url))));
      var nodeMapping = $this.ctx$1.declarations$2.findNodeMappingOrError__Lorg_yaml_model_YPart__T__Lamf_core_parser_SearchScope$Scope__Lamf_plugins_document_vocabularies_model_domain_NodeMappable(entry$1.value$2, declarationId, $m_Lamf_core_parser_SearchScope$All$());
      var field$1 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().MappedNode$1;
      var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(nodeMapping.id__T(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(declarationEntry.value$2));
      var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(declarationEntry.value$2);
      return $as_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(declarationMapping, field$1, value, annotations$1))
    })
  })(this, entry));
  var this$9 = $m_sc_IndexedSeq$();
  var declarations = $as_sc_Seq(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$1, this$9.ReusableCBF$6));
  var this$10 = this.into$2;
  var field$2 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DeclaredNodes$1;
  var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(declarations, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
  var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$10, field$2, value$1, annotations$2)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser.prototype.init___Lamf_plugins_document_vocabularies_model_domain_DocumentMapping__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext = (function(into, ctx) {
  this.into$2 = into;
  $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser.prototype.init___Lamf_plugins_document_vocabularies_parser_dialects_DialectContext.call(this, ctx);
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser.prototype.parse__Lorg_yaml_model_YMap__V = (function(map) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("declares");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    this.parse__Lorg_yaml_model_YMapEntry__V(entry)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.parser.dialects.DialectDeclaresParser"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.parser.dialects.DialectDeclaresParser;", depth))
}
var $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser: 0
}, false, "amf.plugins.document.vocabularies.parser.dialects.DialectDeclaresParser", {
  Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser: 1,
  Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser() {
  $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser.call(this);
  this.into$2 = null
}
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser.prototype = new $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser();
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser.prototype = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser.prototype;
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser.prototype.productPrefix__T = (function() {
  return "DialectEncodesParser"
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser)) {
    var DialectEncodesParser$1 = $as_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser(x$1);
    var x = this.into$2;
    var x$2 = DialectEncodesParser$1.into$2;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.into$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser.prototype.init___Lamf_plugins_document_vocabularies_model_domain_DocumentMapping__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext = (function(into, ctx) {
  this.into$2 = into;
  $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser.prototype.init___Lamf_plugins_document_vocabularies_parser_dialects_DialectContext.call(this, ctx);
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser.prototype.parse__Lorg_yaml_model_YMapEntry__V = (function(entry) {
  var this$1 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
  var iv = this.ctx$1;
  var nodeId = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3;
  var nodeMapping = this.ctx$1.declarations$2.findNodeMappingOrError__Lorg_yaml_model_YPart__T__Lamf_core_parser_SearchScope$Scope__Lamf_plugins_document_vocabularies_model_domain_NodeMappable(entry.value$2, nodeId, $m_Lamf_core_parser_SearchScope$All$());
  var this$2 = this.into$2;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().EncodedNode$1;
  var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(nodeMapping.id__T(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$2, field, value, annotations)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.parser.dialects.DialectEncodesParser"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.parser.dialects.DialectEncodesParser;", depth))
}
var $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser: 0
}, false, "amf.plugins.document.vocabularies.parser.dialects.DialectEncodesParser", {
  Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser: 1,
  Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser() {
  $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser.call(this);
  this.into$2 = null;
  this.parseFragmentEncodesParser$2 = null
}
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser.prototype = new $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser();
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser.prototype = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser.prototype;
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser.prototype.productPrefix__T = (function() {
  return "DialectFragmentParser"
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser)) {
    var DialectFragmentParser$1 = $as_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser(x$1);
    var x = this.into$2;
    var x$2 = DialectFragmentParser$1.into$2;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser.prototype.init___Lamf_plugins_document_vocabularies_model_domain_DocumentsModel__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext = (function(into, ctx) {
  this.into$2 = into;
  $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser.prototype.init___Lamf_plugins_document_vocabularies_parser_dialects_DialectContext.call(this, ctx);
  this.parseFragmentEncodesParser$2 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser$$anon$1().init___Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser(this);
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.into$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser.prototype.parse__Lorg_yaml_model_YMapEntry__V = (function(entry) {
  var this$1 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$1;
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map).parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("encodes", this.parseFragmentEncodesParser$2)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.parser.dialects.DialectFragmentParser"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.parser.dialects.DialectFragmentParser;", depth))
}
var $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser: 0
}, false, "amf.plugins.document.vocabularies.parser.dialects.DialectFragmentParser", {
  Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser: 1,
  Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectFragmentParser;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser() {
  $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser.call(this);
  this.into$2 = null;
  this.dialectName$2 = null;
  this.name$2 = null
}
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser.prototype = new $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser();
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser.prototype = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser.prototype;
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser.prototype.productPrefix__T = (function() {
  return "DialectLibrariesParser"
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser)) {
    var DialectLibrariesParser$1 = $as_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser(x$1);
    var x = this.into$2;
    var x$2 = DialectLibrariesParser$1.into$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      return (this.dialectName$2 === DialectLibrariesParser$1.dialectName$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.into$2;
      break
    }
    case 1: {
      return this.dialectName$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser.prototype.parse__Lorg_yaml_model_YMapEntry__V = (function(entry) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  var this$3 = new $c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var name = this.name$2;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DocumentName$1;
  var this$4 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$3, field, name));
  var value = (this.into$2.id$1 + "/modules");
  var documentsMapping = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value));
  var jsx$1 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser().init___Lamf_plugins_document_vocabularies_model_domain_DocumentMapping__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(documentsMapping, this.ctx$1);
  var this$5 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$1;
  jsx$1.parse__Lorg_yaml_model_YMap__V($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv)));
  var this$6 = this.into$2;
  var field$1 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Library$1;
  var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$6, field$1, documentsMapping, annotations$1)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser.prototype.init___Lamf_plugins_document_vocabularies_model_domain_DocumentsModel__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext = (function(into, dialectName, ctx) {
  this.into$2 = into;
  this.dialectName$2 = dialectName;
  $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser.prototype.init___Lamf_plugins_document_vocabularies_parser_dialects_DialectContext.call(this, ctx);
  this.name$2 = (dialectName + " / Library");
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.parser.dialects.DialectLibrariesParser"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.parser.dialects.DialectLibrariesParser;", depth))
}
var $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser: 0
}, false, "amf.plugins.document.vocabularies.parser.dialects.DialectLibrariesParser", {
  Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser: 1,
  Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectLibrariesParser;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser$$anonfun$1.prototype = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser$$anonfun$1.prototype;
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser$$anonfun$1.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var ref = $as_T(x2.value$2);
    return ref
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser$$anonfun$1.prototype.init___Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser$$anonfun$1.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  return (x1 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser$$anonfun$1: 0
}, false, "amf.plugins.document.vocabularies.parser.dialects.DialectsParser$$anonfun$1", {
  Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser() {
  $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser.call(this);
  this.into$2 = null
}
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser.prototype = new $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser();
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser.prototype = $c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser.prototype;
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser.prototype.productPrefix__T = (function() {
  return "DocumentOptionsParser"
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser.prototype.parseOptions__p2__Lorg_yaml_model_YMap__V = (function(map) {
  var jsx$1 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map);
  var target = this.into$2;
  var ctx = this.ctx$1;
  jsx$1.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("selfEncoded", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(target, ctx).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().SelfEncoded$1));
  var jsx$2 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map);
  var target$1 = this.into$2;
  var ctx$1 = this.ctx$1;
  jsx$2.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("declarationsPath", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(target$1, ctx$1).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().DeclarationsPath$1));
  var jsx$3 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map);
  var target$2 = this.into$2;
  var ctx$2 = this.ctx$1;
  jsx$3.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("keyProperty", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(target$2, ctx$2).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().KeyProperty$1));
  var jsx$4 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(map);
  var target$3 = this.into$2;
  var ctx$3 = this.ctx$1;
  jsx$4.parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("referenceStyle", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectScalarValueEntryParserOpts().init___Lamf_core_model_domain_AmfObject__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(target$3, ctx$3).setParsing__Lamf_core_metamodel_Field__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().ReferenceStyle$1))
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser)) {
    var DocumentOptionsParser$1 = $as_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser(x$1);
    var x = this.into$2;
    var x$2 = DocumentOptionsParser$1.into$2;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser.prototype.init___Lamf_plugins_document_vocabularies_model_domain_DocumentsModel__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext = (function(into, ctx) {
  this.into$2 = into;
  $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser.prototype.init___Lamf_plugins_document_vocabularies_parser_dialects_DialectContext.call(this, ctx);
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.into$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser.prototype.parse__Lorg_yaml_model_YMapEntry__V = (function(entry) {
  var node = entry.value$2;
  var x1 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YMapYRead$());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var optionsMap = $as_Lorg_yaml_model_YMap(x2.value$2);
    var this$2 = this.ctx$1;
    var id = this.into$2.id$1;
    $f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__closedNode__T__T__Lorg_yaml_model_YMap__V(this$2, "documentsMappingOptions", id, optionsMap);
    this.parseOptions__p2__Lorg_yaml_model_YMap__V(optionsMap)
  } else {
    var this$3 = this.ctx$1.eh$1;
    var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
    var node$1 = this.into$2.id$1;
    var ast = entry.value$2;
    var prop = $m_s_None$();
    var l = ast.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$3, specification, node$1, prop, "Options for a documents mapping must be a map", l)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.parser.dialects.DocumentOptionsParser"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.parser.dialects.DocumentOptionsParser;", depth))
}
var $d_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser: 0
}, false, "amf.plugins.document.vocabularies.parser.dialects.DocumentOptionsParser", {
  Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser: 1,
  Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_dialects_DocumentOptionsParser;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser() {
  $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser.call(this);
  this.into$2 = null;
  this.name$2 = null
}
$c_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser.prototype = new $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser();
$c_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser.prototype = $c_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser.prototype;
$c_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser.prototype.productPrefix__T = (function() {
  return "RootDocumentParser"
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser)) {
    var RootDocumentParser$1 = $as_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser(x$1);
    var x = this.into$2;
    var x$2 = RootDocumentParser$1.into$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      return (this.name$2 === RootDocumentParser$1.name$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.into$2;
      break
    }
    case 1: {
      return this.name$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser.prototype.parse__Lorg_yaml_model_YMapEntry__V = (function(entry) {
  var this$1 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$1;
  var rootMap = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
  var this$4 = new $c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var name = this.name$2;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DocumentName$1;
  var this$5 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, name));
  var value = (this.into$2.id$1 + "/root");
  var documentsMapping = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectAstOps$DialectYMapOps().init___Lorg_yaml_model_YMap(rootMap).parse__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser__V("encodes", new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEncodesParser().init___Lamf_plugins_document_vocabularies_model_domain_DocumentMapping__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(documentsMapping, this.ctx$1));
  new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclaresParser().init___Lamf_plugins_document_vocabularies_model_domain_DocumentMapping__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(documentsMapping, this.ctx$1).parse__Lorg_yaml_model_YMap__V(rootMap);
  var this$7 = this.into$2;
  var field$1 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Root$1;
  var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$7, field$1, documentsMapping, annotations$1)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser.prototype.init___Lamf_plugins_document_vocabularies_model_domain_DocumentsModel__T__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext = (function(into, name, ctx) {
  this.into$2 = into;
  this.name$2 = name;
  $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser.prototype.init___Lamf_plugins_document_vocabularies_parser_dialects_DialectContext.call(this, ctx);
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.parser.dialects.RootDocumentParser"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.parser.dialects.RootDocumentParser;", depth))
}
var $d_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser: 0
}, false, "amf.plugins.document.vocabularies.parser.dialects.RootDocumentParser", {
  Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser: 1,
  Lamf_plugins_document_vocabularies_parser_dialects_DialectEntryParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_dialects_RootDocumentParser;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$$nestedInanonfun$parseDeclaredNodeMappings$2$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$$nestedInanonfun$parseDeclaredNodeMappings$2$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$$nestedInanonfun$parseDeclaredNodeMappings$2$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$$nestedInanonfun$parseDeclaredNodeMappings$2$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$$nestedInanonfun$parseDeclaredNodeMappings$2$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$$nestedInanonfun$parseDeclaredNodeMappings$2$1.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$$nestedInanonfun$parseDeclaredNodeMappings$2$1.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$$nestedInanonfun$parseDeclaredNodeMappings$2$1.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var res = $as_T2(x2.value$2);
    if ((res !== null)) {
      return res
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$$nestedInanonfun$parseDeclaredNodeMappings$2$1.prototype.init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$$nestedInanonfun$parseDeclaredNodeMappings$2$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$$nestedInanonfun$parseDeclaredNodeMappings$2$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$$nestedInanonfun$parseDeclaredNodeMappings$2$1.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var res = $as_T2(x2.value$2);
    if ((res !== null)) {
      return true
    }
  };
  return false
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$$nestedInanonfun$parseDeclaredNodeMappings$2$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$$nestedInanonfun$parseDeclaredNodeMappings$2$1: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceContext$$anonfun$$nestedInanonfun$parseDeclaredNodeMappings$2$1", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$$nestedInanonfun$parseDeclaredNodeMappings$2$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$$nestedInanonfun$parseDeclaredNodeMappings$2$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$$nestedInanonfun$parseDeclaredNodeMappings$2$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$findNodeMapping$1() {
  $c_sr_AbstractPartialFunction.call(this);
  this.mappingId$1$2 = null
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$findNodeMapping$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$findNodeMapping$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$findNodeMapping$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$findNodeMapping$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$findNodeMapping$1.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$findNodeMapping$1.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$findNodeMapping$1.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ($is_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1);
    if ((x2.id__T() === this.mappingId$1$2)) {
      return x2
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$findNodeMapping$1.prototype.init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext__T = (function($$outer, mappingId$1) {
  this.mappingId$1$2 = mappingId$1;
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$findNodeMapping$1.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  if ($is_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1);
    if ((x2.id__T() === this.mappingId$1$2)) {
      return true
    }
  };
  return false
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$findNodeMapping$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$findNodeMapping$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$findNodeMapping$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$findNodeMapping$1: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceContext$$anonfun$findNodeMapping$1", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$findNodeMapping$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$findNodeMapping$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$findNodeMapping$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findAnyDialectDomainElement$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findAnyDialectDomainElement$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findAnyDialectDomainElement$2.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findAnyDialectDomainElement$2;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findAnyDialectDomainElement$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findAnyDialectDomainElement$2.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findAnyDialectDomainElement$2.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findAnyDialectDomainElement$2.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findAnyDialectDomainElement$2.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findAnyDialectDomainElement$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findAnyDialectDomainElement$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findAnyDialectDomainElement$2.prototype.init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations = (function($$outer) {
  return this
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findAnyDialectDomainElement$2 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findAnyDialectDomainElement$2: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceDeclarations$$anonfun$findAnyDialectDomainElement$2", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findAnyDialectDomainElement$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findAnyDialectDomainElement$2.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findAnyDialectDomainElement$2;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findDialectDomainElement$2() {
  $c_sr_AbstractPartialFunction.call(this);
  this.nodeMappingIds$1$2 = null
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findDialectDomainElement$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findDialectDomainElement$2.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findDialectDomainElement$2;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findDialectDomainElement$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findDialectDomainElement$2.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findDialectDomainElement$2.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findDialectDomainElement$2.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x1);
    if (this.nodeMappingIds$1$2.contains__O__Z(x2.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping().id$1)) {
      return x2
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findDialectDomainElement$2.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x1);
    if (this.nodeMappingIds$1$2.contains__O__Z(x2.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping().id$1)) {
      return true
    }
  };
  return false
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findDialectDomainElement$2.prototype.init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations__sci_Set = (function($$outer, nodeMappingIds$1) {
  this.nodeMappingIds$1$2 = nodeMappingIds$1;
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findDialectDomainElement$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findDialectDomainElement$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findDialectDomainElement$2 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findDialectDomainElement$2: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceDeclarations$$anonfun$findDialectDomainElement$2", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findDialectDomainElement$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findDialectDomainElement$2.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations$$anonfun$findDialectDomainElement$2;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser() {
  $c_O.call(this);
  this.root$1 = null;
  this.ctx$1 = null;
  this.map$1 = null;
  this.platform$1 = null
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.parseDialectExtension__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__V = (function(id, propertyEntry, property, node) {
  $m_sci_List$();
  var this$1 = propertyEntry.key$2;
  var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
  var iv = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
  var array = [$as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$5 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$5);
    i = (((-1) + i) | 0)
  };
  var nestedObjectId = this.pathSegment__T__sci_List__T(id, result);
  var this$6 = propertyEntry.value$2;
  var x1 = this$6.tag__Lorg_yaml_model_YTag().tagType$3;
  var x$1 = $m_Lorg_yaml_model_YType$().Str$1;
  if ((x$1 === x1)) {
    var jsx$1 = true
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Include$1;
    var jsx$1 = (x$3 === x1)
  };
  if (jsx$1) {
    this.resolveLinkProperty__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Z__V(propertyEntry, property, nestedObjectId, node, false)
  } else {
    var x$5 = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x$5 === x1)) {
      var this$7 = propertyEntry.value$2;
      var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv$1 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
      var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$7, conversion$1, iv$1));
      var x1$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("$dialect");
      matchEnd5: {
        if ((x1$2 instanceof $c_s_Some)) {
          var x2 = $as_s_Some(x1$2);
          var nested = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
          var this$9 = nested.value$2;
          var x$7 = this$9.tag__Lorg_yaml_model_YTag().tagType$3;
          var x$8 = $m_Lorg_yaml_model_YType$().Str$1;
          if ((x$7 === x$8)) {
            var this$10 = nested.value$2;
            var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
            var iv$2 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
            var dialectNode = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$10, conversion$2, iv$2)).text$3;
            var x1$3 = $m_Lamf_plugins_document_vocabularies_AMLPlugin$().apply__Lamf_plugins_document_vocabularies_AMLPlugin().registry$2.findNode__T__s_Option(dialectNode);
            matchEnd6$2: {
              if ((x1$3 instanceof $c_s_Some)) {
                var x2$2 = $as_s_Some(x1$3);
                var p3 = $as_T2(x2$2.value$2);
                if ((p3 !== null)) {
                  var dialect = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(p3.$$und1__O());
                  var nodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(p3.$$und2__O());
                  var jsx$5 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
                  var jsx$4 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().nestedDialects$2;
                  var jsx$3 = $m_sc_Seq$();
                  var array$1 = [dialect];
                  var jsx$2 = jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
                  var this$13 = $m_sc_Seq$();
                  jsx$5.nestedDialects$2 = $as_sc_Seq(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$13.ReusableCBFInstance$2));
                  var this$14 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
                  var oldDialect = this$14.dialect$2;
                  this$14.dialect$2 = dialect;
                  this$14.rootProps$2 = this$14.computeRootProps__sci_Set();
                  var x1$1 = this.parseNestedNode__T__T__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__sci_Map__s_Option(id, nestedObjectId, propertyEntry.value$2, nodeMapping, $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())));
                  if ((x1$1 instanceof $c_s_Some)) {
                    var x2$1 = $as_s_Some(x1$1);
                    var dialectDomainElement = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2$1.value$2);
                    node.setObjectField__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(property, dialectDomainElement, propertyEntry.value$2)
                  } else {
                    var x$2 = $m_s_None$();
                    if ((!(x$2 === x1$1))) {
                      throw new $c_s_MatchError().init___O(x1$1)
                    }
                  };
                  this$14.dialect$2 = oldDialect;
                  this$14.rootProps$2 = this$14.computeRootProps__sci_Set();
                  break matchEnd6$2
                }
              };
              var x$9 = $m_s_None$();
              if ((x$9 === x1$3)) {
                var this$15 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
                var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
                var message = ("Cannot find dialect for nested anyNode mapping " + dialectNode);
                var ast = nested.value$2;
                var prop = $m_s_None$();
                var l = ast.location$1;
                $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$15, specification, id, prop, message, l);
                break matchEnd6$2
              };
              throw new $c_s_MatchError().init___O(x1$3)
            };
            break matchEnd5
          }
        };
        var x$12 = $m_s_None$();
        if ((x$12 === x1$2)) {
          var x1$4 = this.dispatchNodeMap__Lorg_yaml_model_YMap__T(map);
          if ((x1$4 === "$include")) {
            var includeEntry = $as_Lorg_yaml_model_YMapEntry(new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("$include").get__O());
            this.resolveLinkProperty__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Z__V(includeEntry, property, nestedObjectId, node, true)
          } else if ((x1$4 === "$ref")) {
            this.resolveJSONPointerProperty__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__V(map, property, nestedObjectId, node)
          } else {
            var this$17 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
            var specification$1 = $m_Lamf_validation_DialectValidations$().DialectError$1;
            var prop$1 = $m_s_None$();
            var l$1 = map.location$1;
            $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$17, specification$1, id, prop$1, "$dialect key without string value or link", l$1)
          };
          break matchEnd5
        };
        throw new $c_s_MatchError().init___O(x1$2)
      }
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.parseNode__T__T__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__sci_Map__Z__s_Option__s_Option__s_Option = (function(path, defaultId, ast, mappable, additionalProperties, rootNode, givenAnnotations, additionalKey) {
  var x1 = ast.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    var nodeMap = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(ast, conversion, iv));
    var x1$2 = this.dispatchNodeMap__Lorg_yaml_model_YMap__T(nodeMap);
    if ((x1$2 === "$ref")) {
      var this$1 = $f_Lamf_plugins_document_vocabularies_parser_instances_JsonPointerResolver__resolveJSONPointer__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__s_Option(this, nodeMap, mappable, defaultId);
      if (this$1.isEmpty__Z()) {
        var result = $m_s_None$()
      } else {
        var arg1 = this$1.get__O();
        var ref = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(arg1);
        ref.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef().init___());
        if ((mappable instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
          var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(mappable);
          ref.withDefinedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2)
        };
        var result = new $c_s_Some().init___O(ref)
      }
    } else if ((x1$2 === "$include")) {
      var this$2 = this.resolveLink__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__s_Option__s_Option(ast, mappable, defaultId, givenAnnotations);
      if (this$2.isEmpty__Z()) {
        var result = $m_s_None$()
      } else {
        var arg1$1 = this$2.get__O();
        var link = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(arg1$1);
        link.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_vocabularies_annotations_RefInclude().init___());
        var result = new $c_s_Some().init___O(link)
      }
    } else if ((mappable instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
      var x2$1 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(mappable);
      var annotations = $as_Lamf_core_parser_Annotations((givenAnnotations.isEmpty__Z() ? $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(nodeMap) : givenAnnotations.get__O()));
      var node = new $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations).withDefinedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2$1);
      var jsx$1 = $m_sc_Seq$();
      var array = [defaultId];
      var finalId = this.generateNodeId__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YMap__sc_Seq__T__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__sci_Map__Z__T(node, nodeMap, $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))), defaultId, x2$1, additionalProperties, rootNode);
      $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(node, finalId);
      var declarations = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().declarations$2;
      var ctx = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
      $f_Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser__parseAnnotations__Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations__Lamf_core_parser_ParserContext__O(this, nodeMap, node, declarations, ctx);
      $as_sc_Seq(x2$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, nodeMap$1, rootNode$1, defaultId$1, node$1) {
        return (function(propertyMapping$2) {
          var propertyMapping = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(propertyMapping$2);
          var this$7 = $as_Lamf_core_model_StrField(propertyMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
          var this$8 = this$7.option$1;
          var propertyName = $as_T((this$8.isEmpty__Z() ? null : this$8.get__O()));
          var x1$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(nodeMap$1).key__T__s_Option(propertyName);
          if ((x1$1 instanceof $c_s_Some)) {
            var x2$2 = $as_s_Some(x1$1);
            var entry = $as_Lorg_yaml_model_YMapEntry(x2$2.value$2);
            var jsx$2 = $m_s_Option$();
            var this$10 = this$4$1.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().dialect$2;
            var this$11 = jsx$2.apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(this$10.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1)));
            if (this$11.isEmpty__Z()) {
              var this$12 = $m_s_None$()
            } else {
              var arg1$2 = this$11.get__O();
              var x$8 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(arg1$2);
              var this$12 = $as_Lamf_core_model_BoolField(x$8.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().SelfEncoded$1)).option$1
            };
            if (($uZ((this$12.isEmpty__Z() ? false : this$12.get__O())) && rootNode$1)) {
              var nestedId = (defaultId$1 + "#/")
            } else {
              var nestedId = defaultId$1
            };
            this$4$1.parseProperty__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__V(nestedId, entry, propertyMapping, node$1)
          } else {
            var x$1 = $m_s_None$();
            if ((!(x$1 === x1$1))) {
              throw new $c_s_MatchError().init___O(x1$1)
            }
          }
        })
      })(this, nodeMap, rootNode, defaultId, node)));
      this.checkClosedNode__T__T__sci_Map__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lorg_yaml_model_YPart__Z__s_Option__V(finalId, x2$1.id$1, nodeMap.map$3, x2$1, nodeMap, rootNode, additionalKey);
      var result = new $c_s_Some().init___O(node)
    } else {
      if ((!(mappable instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping))) {
        throw new $c_s_MatchError().init___O(mappable)
      };
      var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(mappable);
      var jsx$3 = $m_sc_Seq$();
      var array$1 = [path];
      var result = this.parseObjectUnion__T__sc_Seq__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__sci_Map__s_Option(defaultId, $as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1))), ast, x3, additionalProperties)
    }
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Str$1;
    if ((x$3 === x1)) {
      var jsx$4 = true
    } else {
      var x$5 = $m_Lorg_yaml_model_YType$().Null$1;
      var jsx$4 = (x$5 === x1)
    };
    if (jsx$4) {
      var result = this.resolveLink__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__s_Option__s_Option(ast, mappable, defaultId, givenAnnotations)
    } else {
      var x$7 = $m_Lorg_yaml_model_YType$().Include$1;
      if ((x$7 === x1)) {
        var result = this.resolveLink__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__s_Option__s_Option(ast, mappable, defaultId, givenAnnotations)
      } else {
        var this$15 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
        var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$15, specification, defaultId, prop, "Cannot parse AST node for node in dialect instance", l);
        var result = $m_s_None$()
      }
    }
  };
  if ((result instanceof $c_s_Some)) {
    var x2$2$1 = $as_s_Some(result);
    var node$2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2$2$1.value$2);
    if (this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().isPatch$2) {
      node$2.withAbstract__Z__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(true)
    };
    if ((mappable instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
      var x2$3 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(mappable);
      var jsx$8 = node$2.withDefinedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2$3);
      var jsx$7 = $m_sc_Seq$();
      var array$2 = [$as_Lamf_core_model_StrField(x2$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().NodeTypeMapping$1)).option$1, new $c_s_Some().init___O(x2$3.id$1)];
      var jsx$6 = $as_sc_TraversableLike(jsx$7.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2)));
      var jsx$5 = new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseNode$7().init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser(this);
      var this$18 = $m_sc_Seq$();
      jsx$8.withInstanceTypes__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_sc_Seq(jsx$6.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$5, this$18.ReusableCBFInstance$2)))
    }
  };
  return result
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.findHashProperties__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lorg_yaml_model_YMapEntry__s_Option = (function(propertyMapping, propertyEntry) {
  var x1 = $as_Lamf_core_model_StrField(propertyMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermKeyProperty$1)).option$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var propId = $as_T(x2.value$2);
    var this$1 = propertyEntry.key$2;
    var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    return new $c_s_Some().init___O(new $c_T2().init___O__O(propId, $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return $m_s_None$()
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.parseObjectProperty__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__sci_Map__V = (function(id, propertyEntry, property, node, additionalProperties) {
  var this$1 = propertyEntry.key$2;
  var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
  var iv = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
  var path = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3;
  $m_sci_List$();
  var array = [path];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$5 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$5);
    i = (((-1) + i) | 0)
  };
  var nestedObjectId = this.pathSegment__T__sci_List__T(id, result);
  var x1 = property.nodesInRange__sc_Seq();
  matchEnd5$2: {
    if ((x1 !== null)) {
      if ((x1.size__I() > 1)) {
        var jsx$1 = $m_sc_Seq$();
        var array$1 = [path];
        var x1$2 = this.parseObjectUnion__T__sc_Seq__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__sci_Map__s_Option(nestedObjectId, $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1))), propertyEntry.value$2, property, additionalProperties);
        if ((x1$2 instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(x1$2);
          var parsedRange = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2$2.value$2);
          node.setObjectField__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(property, parsedRange, propertyEntry.value$2)
        } else {
          var x$1 = $m_s_None$();
          if ((!(x$1 === x1$2))) {
            throw new $c_s_MatchError().init___O(x1$2)
          }
        };
        break matchEnd5$2
      }
    };
    if ((x1 !== null)) {
      if ((x1.size__I() === 1)) {
        var this$8 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().dialect$2;
        var x1$3 = $as_sc_Seq(this$8.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Declares$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x3) {
          return (function(x$20$2) {
            var x$20 = $as_Lamf_core_model_domain_DomainElement(x$20$2);
            return (x$20.id__T() === x3.head__O())
          })
        })(this, x1)));
        matchEnd5$3: {
          if ((x1$3 instanceof $c_s_Some)) {
            var x2$3 = $as_s_Some(x1$3);
            var nodeMapping = $as_Lamf_core_model_domain_DomainElement(x2$3.value$2);
            if ($is_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(nodeMapping)) {
              var x3$2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(nodeMapping);
              var x1$4 = this.parseNestedNode__T__T__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__sci_Map__s_Option(id, nestedObjectId, propertyEntry.value$2, x3$2, additionalProperties);
              if ((x1$4 instanceof $c_s_Some)) {
                var x2$4 = $as_s_Some(x1$4);
                var dialectDomainElement = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2$4.value$2);
                node.setObjectField__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(property, dialectDomainElement, propertyEntry.value$2)
              };
              break matchEnd5$3
            }
          }
        };
        break matchEnd5$2
      }
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.parseDeclarations__T__V = (function(documentType) {
  var declarationsNodeMappings = ((documentType === "root") ? this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().rootDeclarationsNodeMappings$2 : this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().libraryDeclarationsNodeMappings$2);
  var jsx$1 = $m_s_Option$();
  var this$1 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().dialect$2;
  var this$2 = jsx$1.apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1)));
  if (this$2.isEmpty__Z()) {
    var pathOption = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var d = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(arg1);
    var pathOption = $as_Lamf_core_model_StrField(d.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().DeclarationsPath$1)).option$1
  };
  if (pathOption.isEmpty__Z()) {
    var this$8 = $m_s_None$()
  } else {
    var arg1$1 = pathOption.get__O();
    var p = $as_T(arg1$1);
    var this$8 = new $c_s_Some().init___O(((($uI(p.length) >= 0) && ($as_T(p.substring(0, $uI("/".length))) === "/")) ? p : ("/" + p)))
  };
  if (this$8.isEmpty__Z()) {
    var normalizedPath = $m_s_None$()
  } else {
    var arg1$2 = this$8.get__O();
    var p$3 = $as_T(arg1$2);
    var normalizedPath = new $c_s_Some().init___O(($m_sjsr_RuntimeString$().endsWith__T__T__Z(p$3, "/") ? p$3 : (p$3 + "/")))
  };
  if (pathOption.isEmpty__Z()) {
    var this$14 = $m_s_None$()
  } else {
    var arg1$3 = pathOption.get__O();
    var x$1 = $as_T(arg1$3);
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(x$1, "/", 0);
    var i = (((-1) + xs.u.length) | 0);
    var result = $m_sci_Nil$();
    while ((i >= 0)) {
      var this$13 = result;
      var index = i;
      var x = xs.get(index);
      result = new $c_sci_$colon$colon().init___O__sci_List(x, this$13);
      i = (((-1) + i) | 0)
    };
    var this$14 = new $c_s_Some().init___O(result)
  };
  var paths = $as_sci_List((this$14.isEmpty__Z() ? $m_sci_Nil$() : this$14.get__O()));
  var this$15 = this.findDeclarationsMap__p1__sci_List__Lorg_yaml_model_YMap__s_Option(paths, this.map$1);
  if ((!this$15.isEmpty__Z())) {
    var arg1$4 = this$15.get__O();
    var declarationsMap = $as_Lorg_yaml_model_YMap(arg1$4);
    declarationsNodeMappings.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, declarationsMap$1, normalizedPath$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_T2(x0$1$2);
        if ((x0$1 !== null)) {
          var name = $as_T(x0$1.$$und1__O());
          var nodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x0$1.$$und2__O());
          var this$17 = declarationsMap$1.entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, name$1) {
            return (function(x$2$2) {
              var x$2 = $as_Lorg_yaml_model_YMapEntry(x$2$2);
              var this$16 = x$2.key$2;
              var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
              var iv = $this$1.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
              return ($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$16, conversion, iv)).text$3 === name$1)
            })
          })($this, name)));
          if ((!this$17.isEmpty__Z())) {
            var arg1$5 = this$17.get__O();
            var entry = $as_Lorg_yaml_model_YMapEntry(arg1$5);
            var jsx$3 = $this.root$1.location$1;
            var jsx$2 = (normalizedPath$1.isEmpty__Z() ? "/" : normalizedPath$1.get__O());
            var this$19 = new $c_Lamf_core_utils_package$AmfStrings().init___T(name);
            var this$20 = this$19.platform$1;
            var url = this$19.str$1;
            var declarationsId = (((jsx$3 + "#") + jsx$2) + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$20, url));
            var this$21 = entry.value$2;
            var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
            var iv$1 = $this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
            $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$21, conversion$1, iv$1)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, declarationsId$1, nodeMapping$1, entry$1) {
              return (function(declarationEntry$2) {
                var declarationEntry = $as_Lorg_yaml_model_YMapEntry(declarationEntry$2);
                var this$22 = declarationEntry.key$2;
                var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
                var iv$2 = this$2$1.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
                var declarationName = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$22, conversion$2, iv$2)).text$3;
                $m_sci_List$();
                var array = [declarationName];
                var i$1 = (((-1) + $uI(array.length)) | 0);
                var result$1 = $m_sci_Nil$();
                while ((i$1 >= 0)) {
                  var this$26 = result$1;
                  var index$1 = i$1;
                  var x$3 = array[index$1];
                  result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$26);
                  i$1 = (((-1) + i$1) | 0)
                };
                var id = this$2$1.pathSegment__T__sci_List__T(declarationsId$1, result$1);
                var x$3$1 = declarationEntry.value$2;
                var x$5 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
                var x$6 = new $c_s_Some().init___O($m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(declarationEntry));
                var x$8 = $m_s_None$();
                var x1 = this$2$1.parseNode__T__T__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__sci_Map__Z__s_Option__s_Option__s_Option(declarationsId$1, id, x$3$1, nodeMapping$1, x$5, false, x$6, x$8);
                if ((x1 instanceof $c_s_Some)) {
                  var x2 = $as_s_Some(x1);
                  var node = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2.value$2);
                  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$().DeclarationName$1;
                  var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(declarationName, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(declarationEntry.key$2));
                  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(declarationEntry.key$2);
                  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(node, field, value, annotations);
                  var jsx$4 = this$2$1.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().declarations$2;
                  $m_Lorg_yaml_model_YNode$();
                  var node$1 = declarationEntry.key$2;
                  var iv$3 = this$2$1.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
                  var conversion$3 = $m_Lorg_yaml_convert_YRead$StringYRead$();
                  jsx$4.registerDialectDomainElement__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations($as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node$1, conversion$3, iv$3)), node);
                  var this$28 = this$2$1.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
                  this$28.globalSpace$1.update__O__O__V(id, node)
                } else {
                  var this$29 = this$2$1.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
                  var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
                  var message = (("Cannot parse declaration for node with key '" + declarationName) + "'");
                  var ast = entry$1.value$2;
                  var prop = $m_s_None$();
                  var l = ast.location$1;
                  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$29, specification, id, prop, message, l)
                }
              })
            })($this, declarationsId, nodeMapping, entry)))
          }
        } else {
          throw new $c_s_MatchError().init___O(x0$1)
        }
      })
    })(this, declarationsMap, normalizedPath)))
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.encodedElementDefaultId__Lamf_core_model_document_EncodesModel__T = (function(dialectInstance) {
  var jsx$1 = $m_s_Option$();
  var this$1 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().dialect$2;
  var this$2 = jsx$1.apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1)));
  if (this$2.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var x$3 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(arg1);
    var this$3 = $as_Lamf_core_model_BoolField(x$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().SelfEncoded$1)).option$1
  };
  if ($uZ((this$3.isEmpty__Z() ? false : this$3.get__O()))) {
    var this$4 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(dialectInstance);
    return $as_T((this$4.isEmpty__Z() ? dialectInstance.id__T() : this$4.get__O()))
  } else {
    return (dialectInstance.id__T() + "#/encodes")
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext = (function() {
  return this.ctx$1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.scalarYType__Lorg_yaml_model_YMapEntry__Z = (function(entry) {
  var this$1 = entry.value$2;
  var x1 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Bool$1;
  if ((x === x1)) {
    return true
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Float$1;
    if ((x$3 === x1)) {
      return true
    } else {
      var x$5 = $m_Lorg_yaml_model_YType$().Str$1;
      if ((x$5 === x1)) {
        return true
      } else {
        var x$7 = $m_Lorg_yaml_model_YType$().Int$1;
        if ((x$7 === x1)) {
          return true
        } else {
          var x$9 = $m_Lorg_yaml_model_YType$().Timestamp$1;
          return (x$9 === x1)
        }
      }
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.parseExternalLinkProperty__p1__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__V = (function(id, propertyEntry, property, node) {
  var x1 = $as_sc_Seq(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1));
  if ((x1.length__I() === 1)) {
    var this$1 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().dialect$2;
    var x1$2 = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Declares$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x1$1) {
      return (function(x$9$2) {
        var x$9 = $as_Lamf_core_model_domain_DomainElement(x$9$2);
        var jsx$1 = x$9.id__T();
        var this$2 = $as_Lamf_core_model_StrField(x1$1.head__O());
        var this$3 = this$2.option$1;
        return (jsx$1 === $as_T((this$3.isEmpty__Z() ? null : this$3.get__O())))
      })
    })(this, x1)));
    matchEnd5: {
      var maybeMapping;
      if ((x1$2 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1$2);
        var nodeMapping = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
        if ((nodeMapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
          var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(nodeMapping);
          var maybeMapping = new $c_s_Some().init___O(x3);
          break matchEnd5
        }
      };
      var this$6 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
      var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
      var this$4 = $as_Lamf_core_model_StrField(x1.head__O());
      var this$5 = this$4.option$1;
      var message = ("Cannot find object range " + $as_T((this$5.isEmpty__Z() ? null : this$5.get__O())));
      var prop = $m_s_None$();
      var l = propertyEntry.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$6, specification, id, prop, message, l);
      var maybeMapping = $m_s_None$()
    }
  } else {
    var this$7 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
    var specification$1 = $m_Lamf_validation_DialectValidations$().DialectError$1;
    var prop$1 = $m_s_None$();
    var l$1 = propertyEntry.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$7, specification$1, id, prop$1, "Individual object range required for external link property", l$1);
    var maybeMapping = $m_s_None$()
  };
  var this$8 = $as_Lamf_core_model_BoolField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().AllowMultiple$1)).option$1;
  var allowMultiple = $uZ((this$8.isEmpty__Z() ? false : this$8.get__O()));
  if ((maybeMapping instanceof $c_s_Some)) {
    var x2$2 = $as_s_Some(maybeMapping);
    var mapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x2$2.value$2);
    var rangeNode = propertyEntry.value$2;
    var rc7 = false;
    var x4 = null;
    var x1$4 = rangeNode.tag__Lorg_yaml_model_YTag().tagType$3;
    matchEnd8: {
      var x = $m_Lorg_yaml_model_YType$().Str$1;
      if (((x === x1$4) && (!allowMultiple))) {
        var this$9 = this.generateExternalLink__p1__T__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__s_Option(id, rangeNode, mapping);
        if ((!this$9.isEmpty__Z())) {
          var arg1 = this$9.get__O();
          var elem = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(arg1);
          node.setObjectField__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(property, elem, propertyEntry.value$2)
        };
        break matchEnd8
      };
      var x$3 = $m_Lorg_yaml_model_YType$().Map$1;
      if (((x$3 === x1$4) && (!allowMultiple))) {
        var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
        var refMap = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(rangeNode, conversion, iv));
        var this$12 = this.generateExternalLink__p1__T__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__s_Option(id, ($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(refMap, $m_Lorg_yaml_model_YType$().Map$1)), mapping);
        if ((!this$12.isEmpty__Z())) {
          var arg1$1 = this$12.get__O();
          var elem$3 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(arg1$1);
          node.setObjectField__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(property, elem$3, propertyEntry.value$2)
        };
        break matchEnd8
      };
      var x$5 = $m_Lorg_yaml_model_YType$().Seq$1;
      if ((x$5 === x1$4)) {
        rc7 = true;
        x4 = x1$4;
        if (allowMultiple) {
          var conversion$1 = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
          var iv$1 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
          var seq = $as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(rangeNode, conversion$1, iv$1));
          var jsx$5 = seq.nodes$3;
          var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1, id$1, mapping$1) {
            return (function(node$2$2) {
              var node$2 = $as_Lorg_yaml_model_YNode(node$2$2);
              return this$5$1.generateExternalLink__p1__T__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__s_Option(id$1, node$2, mapping$1)
            })
          })(this, id, mapping));
          var this$13 = $m_sc_IndexedSeq$();
          var jsx$3 = $as_sc_TraversableLike(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$4, this$13.ReusableCBF$6));
          var jsx$2 = new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$2().init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser(this);
          var this$14 = $m_sc_IndexedSeq$();
          var elems = $as_sc_IndexedSeq(jsx$3.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$2, this$14.ReusableCBF$6));
          if ($f_sc_TraversableOnce__nonEmpty__Z(elems)) {
            node.setObjectField__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__sc_Seq__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(property, elems, propertyEntry.value$2);
            (void 0)
          } else {
            (void 0)
          };
          break matchEnd8
        }
      };
      if ((rc7 && (!allowMultiple))) {
        var this$15 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
        var specification$2 = $m_Lamf_validation_DialectValidations$().DialectError$1;
        var prop$2 = $m_s_None$();
        var l$2 = propertyEntry.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$15, specification$2, id, prop$2, "AllowMultiple not enable, sequence of external links not supported", l$2);
        break matchEnd8
      };
      var this$16 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
      var specification$3 = $m_Lamf_validation_DialectValidations$().DialectError$1;
      var prop$3 = $m_s_None$();
      var l$3 = propertyEntry.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$16, specification$3, id, prop$3, "Not supported external link range", l$3)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.resolveJSONPointerProperty__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__V = (function(map, mapping, id, node) {
  var entry = $as_Lorg_yaml_model_YMapEntry(new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("$ref").get__O());
  var this$2 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
  var iv = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
  var pointer = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv));
  var fullPointer = ((($uI(pointer.length) >= 0) && ($as_T(pointer.substring(0, $uI("#".length))) === "#")) ? (("" + this.root$1.location$1) + pointer) : pointer);
  var this$8 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().findJsonPointer__T__s_Option(fullPointer);
  if (this$8.isEmpty__Z()) {
    var x1 = $m_s_None$()
  } else {
    var arg1 = this$8.get__O();
    var node$2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(arg1);
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(map);
    var this$9 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(node$2, pointer, annotations));
    var x1 = new $c_s_Some().init___O($as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$9, id)))
  };
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var s = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2.value$2);
    var x1$2 = $m_Lamf_plugins_document_vocabularies_AMLPlugin$().apply__Lamf_plugins_document_vocabularies_AMLPlugin().registry$2.findNode__T__s_Option(s.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping().id$1);
    matchEnd7: {
      if ((x1$2 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$2);
        var p3 = $as_T2(x2$2.value$2);
        if ((p3 !== null)) {
          var dialect = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(p3.$$und1__O());
          var jsx$4 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
          var jsx$3 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().nestedDialects$2;
          var jsx$2 = $m_sc_Seq$();
          var array = [dialect];
          var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
          var this$12 = $m_sc_Seq$();
          jsx$4.nestedDialects$2 = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$12.ReusableCBFInstance$2));
          var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(map);
          var this$13 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(s, pointer, annotations$1));
          var linkedExternal = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$13, id));
          node.setObjectField__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(mapping, linkedExternal, ($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1)));
          break matchEnd7
        }
      };
      var x = $m_s_None$();
      if ((x === x1$2)) {
        var this$16 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
        var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
        var message = ("Cannot find dialect for anyNode node mapping " + s.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping().id$1);
        var prop = $m_s_None$();
        var l = map.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$16, specification, id, prop, message, l);
        break matchEnd7
      };
      throw new $c_s_MatchError().init___O(x1$2)
    }
  } else {
    var x$4 = $m_s_None$();
    if ((x$4 === x1)) {
      var this$17 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
      var specification$1 = $m_Lamf_validation_DialectValidations$().DialectError$1;
      var message$1 = (("anyNode reference must be to a known node or an external fragment, unknown JSON Pointer: '" + pointer) + "'");
      var prop$1 = $m_s_None$();
      var l$1 = map.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$17, specification$1, id, prop$1, message$1, l$1)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.parseObjectUnion__T__sc_Seq__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__sci_Map__s_Option = (function(defaultId, path, ast, mappableWithDiscriminator, additionalProperties) {
  var jsx$5 = $as_sc_Seq(mappableWithDiscriminator.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1));
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, defaultId$1, mappableWithDiscriminator$1, ast$1) {
    return (function(nodeMappingId$2) {
      var nodeMappingId = $as_Lamf_core_model_StrField(nodeMappingId$2);
      var this$1 = $this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().dialect$2;
      var x1 = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Declares$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, nodeMappingId$1) {
        return (function(x$15$2) {
          var x$15 = $as_Lamf_core_model_domain_DomainElement(x$15$2);
          var jsx$4 = x$15.id__T();
          var this$2 = nodeMappingId$1.option$1;
          return (jsx$4 === $as_T((this$2.isEmpty__Z() ? null : this$2.get__O())))
        })
      })($this, nodeMappingId)));
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var nodeMapping = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
        return new $c_s_Some().init___O(nodeMapping)
      } else {
        var x = $m_s_None$();
        if ((x === x1)) {
          var this$3 = $this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
          var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
          var message = (("Cannot find mapping for property " + mappableWithDiscriminator$1.id__T()) + " in union");
          var prop = $m_s_None$();
          var l = ast$1.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$3, specification, defaultId$1, prop, message, l);
          return $m_s_None$()
        } else {
          throw new $c_s_MatchError().init___O(x1)
        }
      }
    })
  })(this, defaultId, mappableWithDiscriminator, ast));
  var this$4 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$3, this$4.ReusableCBFInstance$2));
  var jsx$1 = new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$3().init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser(this);
  var this$5 = $m_sc_Seq$();
  var unionMappings = $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2));
  var this$6 = $m_s_Option$().apply__O__s_Option($f_Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__typeDiscriminator__sci_Map(mappableWithDiscriminator));
  var discriminatorsMapping = $as_sci_Map($as_sc_TraversableOnce((this$6.isEmpty__Z() ? $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())) : this$6.get__O())).foldLeft__O__F2__O($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$3$1, defaultId$2, ast$2) {
    return (function(x0$1$2, x1$1$2) {
      var x0$1 = $as_sci_Map(x0$1$2);
      var x1$1 = $as_T2(x1$1$2);
      var x1$2 = new $c_T2().init___O__O(x0$1, x1$1);
      var acc = $as_sci_Map(x1$2.$$und1$f);
      var p2 = $as_T2(x1$2.$$und2$f);
      if ((p2 !== null)) {
        var alias = $as_T(p2.$$und1__O());
        var mappingId = $as_T(p2.$$und2__O());
        var this$7 = this$3$1.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().dialect$2;
        var x1$2$1 = $as_sc_Seq(this$7.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Declares$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, mappingId$1) {
          return (function(x$16$2) {
            var x$16 = $as_Lamf_core_model_domain_DomainElement(x$16$2);
            return (x$16.id__T() === mappingId$1)
          })
        })(this$3$1, mappingId)));
        if ((x1$2$1 instanceof $c_s_Some)) {
          var x2$1 = $as_s_Some(x1$2$1);
          var nodeMapping$1 = $as_Lamf_core_model_domain_DomainElement(x2$1.value$2);
          if ((nodeMapping$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
            var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(nodeMapping$1);
            return acc.$$plus__T2__sci_Map(new $c_T2().init___O__O(alias, x3))
          }
        };
        var this$10 = this$3$1.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
        var specification$1 = $m_Lamf_validation_DialectValidations$().DialectError$1;
        var message$1 = (((("Cannot find mapping for property " + mappingId) + " in discriminator value '") + alias) + "' in union");
        var prop$1 = $m_s_None$();
        var l$1 = ast$2.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$10, specification$1, defaultId$2, prop$1, message$1, l$1);
        return acc
      };
      throw new $c_s_MatchError().init___O(x1$2)
    })
  })(this, defaultId, ast))));
  var jsx$6 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(discriminatorsMapping);
  var this$11 = $m_sc_Seq$();
  var allPossibleMappings = $as_sc_Seq($as_sc_SeqLike(unionMappings.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$6, this$11.ReusableCBFInstance$2)).distinct__O());
  var x1$3 = ast.tag__Lorg_yaml_model_YTag().tagType$3;
  var x$1 = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x$1 === x1$3)) {
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    var nodeMap = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(ast, conversion, iv));
    var x1$2$2 = this.dispatchNodeMap__Lorg_yaml_model_YMap__T(nodeMap);
    if ((x1$2$2 === "$include")) {
      var this$12 = this.resolveLinkUnion__Lorg_yaml_model_YNode__sc_Seq__T__s_Some(ast, allPossibleMappings, defaultId);
      var arg1 = this$12.value$2;
      var link = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(arg1);
      link.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_vocabularies_annotations_RefInclude().init___());
      return new $c_s_Some().init___O(link)
    } else if ((x1$2$2 === "$ref")) {
      var this$13 = this.resolveJSONPointerUnion__Lorg_yaml_model_YMap__sc_Seq__T__s_Option(nodeMap, allPossibleMappings, defaultId);
      if (this$13.isEmpty__Z()) {
        return $m_s_None$()
      } else {
        var arg1$1 = this$13.get__O();
        var ref = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(arg1$1);
        ref.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef().init___());
        return new $c_s_Some().init___O(ref)
      }
    } else {
      var jsx$7 = $as_Lamf_core_model_StrField(mappableWithDiscriminator.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().TypeDiscriminatorName$1)).option$1;
      var this$14 = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(additionalProperties);
      var mappings = this.findCompatibleMapping__T__sc_Seq__sci_Map__s_Option__Lorg_yaml_model_YMap__sc_Seq__sc_Seq(defaultId, unionMappings, discriminatorsMapping, jsx$7, nodeMap, $f_sc_SetLike__toSeq__sc_Seq(this$14));
      if (mappings.isEmpty__Z()) {
        var this$16 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
        var specification$2 = $m_Lamf_validation_DialectValidations$().DialectAmbiguousRangeSpecification$1;
        var jsx$9 = allPossibleMappings.size__I();
        var jsx$8 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1) {
          return (function(x$17$2) {
            var x$17 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x$17$2);
            return x$17.id$1
          })
        })(this));
        var this$15 = $m_sc_Seq$();
        var message$2 = (((("Ambiguous node in union range, found 0 compatible mappings from " + jsx$9) + " mappings: [") + $as_sc_TraversableOnce(allPossibleMappings.map__F1__scg_CanBuildFrom__O(jsx$8, this$15.ReusableCBFInstance$2)).mkString__T__T(",")) + "]");
        var prop$2 = $m_s_None$();
        var l$2 = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$16, specification$2, defaultId, prop$2, message$2, l$2);
        return $m_s_None$()
      } else if ((mappings.size__I() === 1)) {
        var node = $m_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$().apply__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(nodeMap).withDefinedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(mappings.head__O()));
        var finalId = this.generateNodeId__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YMap__sc_Seq__T__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__sci_Map__Z__T(node, nodeMap, path, defaultId, $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(mappings.head__O()), additionalProperties, false);
        $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(node, finalId);
        var elem = $m_sci_Nil$();
        var instanceTypes = new $c_sr_ObjectRef().init___O(elem);
        mappings.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$7$1, node$1, nodeMap$1, finalId$1, instanceTypes$1) {
          return (function(mapping$2) {
            var mapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(mapping$2);
            var this$18 = node$1.fields$1;
            var this$21 = this$18.fs$1;
            var this$19 = $m_Lamf_core_parser_FieldEntry$();
            var f = $f_F2__tupled__F1(this$19);
            var this$20 = $m_sci_Iterable$();
            var bf = this$20.ReusableCBFInstance$2;
            var beforeValues = $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$21, f, bf)).size__I();
            $as_sc_Seq(mapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, node$4, nodeMap$2, finalId$1$1) {
              return (function(propertyMapping$2) {
                var propertyMapping = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(propertyMapping$2);
                var this$22 = node$4.fields$1;
                var f$1 = propertyMapping.toField__Lamf_core_metamodel_Field();
                if ((!this$22.fs$1.contains__O__Z(f$1))) {
                  var this$23 = $as_Lamf_core_model_StrField(propertyMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
                  var this$24 = this$23.option$1;
                  var propertyName = $as_T((this$24.isEmpty__Z() ? null : this$24.get__O()));
                  var x1$4 = nodeMap$2.entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$4, propertyName$1) {
                    return (function(x$18$2) {
                      var x$18 = $as_Lorg_yaml_model_YMapEntry(x$18$2);
                      var this$25 = x$18.key$2;
                      var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
                      var iv$1 = $this$4.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
                      return ($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$25, conversion$1, iv$1)).text$3 === propertyName$1)
                    })
                  })($this$3, propertyName)));
                  if ((x1$4 instanceof $c_s_Some)) {
                    var x2$2 = $as_s_Some(x1$4);
                    var entry = $as_Lorg_yaml_model_YMapEntry(x2$2.value$2);
                    $this$3.parseProperty__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__V(finalId$1$1, entry, propertyMapping, node$4)
                  } else {
                    var x$2 = $m_s_None$();
                    if ((!(x$2 === x1$4))) {
                      throw new $c_s_MatchError().init___O(x1$4)
                    }
                  }
                }
              })
            })(this$7$1, node$1, nodeMap$1, finalId$1)));
            var this$26 = node$1.fields$1;
            var this$29 = this$26.fs$1;
            var this$27 = $m_Lamf_core_parser_FieldEntry$();
            var f$2 = $f_F2__tupled__F1(this$27);
            var this$28 = $m_sci_Iterable$();
            var bf$1 = this$28.ReusableCBFInstance$2;
            var afterValues = $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$29, f$2, bf$1)).size__I();
            if ((afterValues !== beforeValues)) {
              var this$30 = $as_Lamf_core_model_StrField(mapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().NodeTypeMapping$1));
              var jsx$10 = $f_Lamf_core_model_StrField__nonEmpty__Z(this$30)
            } else {
              var jsx$10 = false
            };
            if (jsx$10) {
              var jsx$13 = $as_sc_Seq(instanceTypes$1.elem$1);
              var jsx$12 = $m_sc_Seq$();
              var this$31 = $as_Lamf_core_model_StrField(mapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().NodeTypeMapping$1));
              var this$32 = this$31.option$1;
              var array = [$as_T((this$32.isEmpty__Z() ? null : this$32.get__O()))];
              var jsx$11 = jsx$12.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
              var this$35 = $m_sc_Seq$();
              instanceTypes$1.elem$1 = $as_sc_Seq(jsx$13.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$11, this$35.ReusableCBFInstance$2))
            }
          })
        })(this, node, nodeMap, finalId, instanceTypes)));
        var jsx$16 = $as_sc_Seq(instanceTypes.elem$1);
        var jsx$15 = $m_sc_Seq$();
        var array$1 = [$as_Lamf_core_model_domain_AmfObject(mappings.head__O()).id__T()];
        var jsx$14 = jsx$15.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
        var this$38 = $m_sc_Seq$();
        node.withInstanceTypes__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_sc_Seq(jsx$16.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$14, this$38.ReusableCBFInstance$2)));
        return new $c_s_Some().init___O(node)
      } else {
        var this$40 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
        var spec = $m_Lamf_validation_DialectValidations$().DialectAmbiguousRangeSpecification$1;
        var prop$3 = $m_s_None$();
        var jsx$17 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$8$1) {
          return (function(x$19$2) {
            var x$19 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x$19$2);
            return x$19.id$1
          })
        })(this));
        var this$39 = $m_sc_Seq$();
        var msg = (("Ambiguous node, please provide a type disambiguator. Nodes " + $as_sc_TraversableOnce(mappings.map__F1__scg_CanBuildFrom__O(jsx$17, this$39.ReusableCBFInstance$2)).mkString__T__T(",")) + " have been found compatible, only one is allowed");
        var ast$3 = this.map$1;
        var l$3 = ast$3.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$40, spec, defaultId, prop$3, msg, l$3);
        return $m_s_None$()
      }
    }
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Str$1;
    if ((x$3 === x1$3)) {
      var jsx$18 = true
    } else {
      var x$5 = $m_Lorg_yaml_model_YType$().Include$1;
      var jsx$18 = (x$5 === x1$3)
    };
    if (jsx$18) {
      return this.resolveLinkUnion__Lorg_yaml_model_YNode__sc_Seq__T__s_Some(ast, allPossibleMappings, defaultId)
    } else {
      var this$41 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
      var specification$3 = $m_Lamf_validation_DialectValidations$().InvalidUnionType$1;
      var prop$4 = $m_s_None$();
      var l$4 = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$41, specification$3, defaultId, prop$4, "Cannot parse AST for union node mapping", l$4);
      return $m_s_None$()
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.explicitNodeId__s_Option__Lorg_yaml_model_YMap__sc_Seq__T__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__T = (function(node, nodeMap, path, defaultId, mapping) {
  var entry = $as_Lorg_yaml_model_YMapEntry(new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(nodeMap).key__T__s_Option("$id").get__O());
  var this$2 = entry.value$2;
  var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
  var iv = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
  var rawId = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv)).text$3;
  if (($uI(rawId.indexOf("://")) !== (-1))) {
    var externalId = rawId
  } else {
    var this$6 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().dialect$2;
    var this$7 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$6);
    var thiz = $as_T((this$7.isEmpty__Z() ? this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().dialect$2.id$1 : this$7.get__O()));
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "#", 0);
    var this$10 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    var thiz$1 = (($as_T($f_sc_IndexedSeqOptimized__head__O(this$10)) + "#") + rawId);
    var externalId = $as_T(thiz$1.split("##").join("#"))
  };
  if ((!node.isEmpty__Z())) {
    var arg1 = node.get__O();
    var n = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(arg1);
    n.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_vocabularies_annotations_CustomId().init___T("true"))
  };
  return externalId
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.resolveJSONPointerUnion__Lorg_yaml_model_YMap__sc_Seq__T__s_Option = (function(map, allPossibleMappings, id) {
  var entry = $as_Lorg_yaml_model_YMapEntry(new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("$ref").get__O());
  var this$2 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
  var iv = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
  var pointer = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv));
  var fullPointer = ((($uI(pointer.length) >= 0) && ($as_T(pointer.substring(0, $uI("#".length))) === "#")) ? (("" + this.root$1.location$1) + pointer) : pointer);
  var this$8 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().findJsonPointer__T__s_Option(fullPointer);
  if (this$8.isEmpty__Z()) {
    var this$11 = $m_s_None$()
  } else {
    var arg1 = this$8.get__O();
    var node = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(arg1);
    if (allPossibleMappings.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, node$1) {
      return (function(x$26$2) {
        var x$26 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x$26$2);
        return (x$26.id$1 === node$1.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping().id$1)
      })
    })(this, node)))) {
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(map);
      var this$9 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(node, pointer, annotations));
      var jsx$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$9, id))
    } else {
      var this$10 = $m_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$().apply__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(map);
      var linkedNode = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$10, id));
      var ctx = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
      $f_Lamf_core_model_domain_Linkable__unresolved__T__Lorg_yaml_model_YPart__T__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(linkedNode, fullPointer, map, "error", ctx);
      var jsx$1 = linkedNode
    };
    var this$11 = new $c_s_Some().init___O(jsx$1)
  };
  if (this$11.isEmpty__Z()) {
    var this$12 = $m_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$().apply__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(map);
    var linkedNode$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$12, id));
    var ctx$1 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    $f_Lamf_core_model_domain_Linkable__unresolved__T__Lorg_yaml_model_YPart__T__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(linkedNode$1, fullPointer, map, "error", ctx$1);
    return new $c_s_Some().init___O(linkedNode$1)
  } else {
    return this$11
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.parseNestedNode__T__T__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__sci_Map__s_Option = (function(path, id, entry, mapping, additionalProperties) {
  var x$6 = $m_s_None$();
  var x$8 = $m_s_None$();
  return this.parseNode__T__T__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__sci_Map__Z__s_Option__s_Option__s_Option(path, id, entry, mapping, additionalProperties, false, x$6, x$8)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.parseEncoded__Lamf_core_model_document_EncodesModel__s_Option = (function(dialectInstance) {
  var jsx$1 = $m_s_Option$();
  var this$1 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().dialect$2;
  var this$2 = jsx$1.apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1)));
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var documents = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(arg1);
    var this$3 = $m_s_Option$().apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(documents.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Root$1)));
    if (this$3.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1$1 = this$3.get__O();
      var mapping = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(arg1$1);
      var jsx$2 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
      var this$4 = $as_Lamf_core_model_StrField(mapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().EncodedNode$1));
      var this$5 = this$4.option$1;
      var x1 = jsx$2.findNodeMapping__T__s_Option($as_T((this$5.isEmpty__Z() ? null : this$5.get__O())));
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var nodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x2.value$2);
        var path = (dialectInstance.id__T() + "#");
        var this$6 = $as_Lamf_core_model_BoolField(documents.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().KeyProperty$1));
        if ($f_Lamf_core_model_BoolField__value__Z(this$6)) {
          var this$7 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().dialect$2;
          var this$8 = $as_Lamf_core_model_StrField(this$7.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Name$1));
          var this$9 = this$8.option$1;
          var additionalKey = new $c_s_Some().init___O($as_T((this$9.isEmpty__Z() ? null : this$9.get__O())))
        } else {
          var additionalKey = $m_s_None$()
        };
        var jsx$3 = this.encodedElementDefaultId__Lamf_core_model_document_EncodesModel__T(dialectInstance);
        $m_Lorg_yaml_model_YNode$();
        var map = this.map$1;
        $m_Lorg_yaml_model_YNode$();
        return this.parseNode__T__T__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__sci_Map__Z__s_Option__s_Option__s_Option(path, jsx$3, $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1), nodeMapping, $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())), true, $m_s_None$(), additionalKey)
      } else {
        return $m_s_None$()
      }
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.parseDocument__s_Option = (function() {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.map$1);
  var this$3 = new $c_Lamf_plugins_document_vocabularies_model_document_DialectInstance().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var location = this.root$1.location$1;
  var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
  var this$4 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$3, field, location));
  var value = this.root$1.location$1;
  var this$5 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstance($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value));
  var dialectId = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().dialect$2.id$1;
  var field$1 = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().DefinedBy$1;
  var dialectInstance = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstance($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$5, field$1, dialectId));
  this.parseDeclarations__T__V("root");
  var jsx$1 = new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser().init___Lamf_core_model_document_BaseUnit__Lorg_yaml_model_YMap__sc_Seq__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext(dialectInstance, this.map$1, this.root$1.references$1, this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext());
  var this$6 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(dialectInstance);
  var references = jsx$1.parse__T__Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations($as_T((this$6.isEmpty__Z() ? dialectInstance.id$1 : this$6.get__O())));
  var this$7 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().declarations$2.externals$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$7)) {
    var this$8 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().declarations$2.externals$2;
    var this$9 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$8);
    var externals = this$9.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream();
    var field$2 = $m_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$().Externals$1;
    $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(dialectInstance, field$2, externals)
  };
  var x1 = this.parseEncoded__Lamf_core_model_document_EncodesModel__s_Option(dialectInstance);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var dialectDomainElement = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2.value$2);
    var this$10 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    var pointer = (this.root$1.location$1 + "#/");
    this$10.globalSpace$1.update__O__O__V(pointer, dialectDomainElement);
    var field$3 = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
    $as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(dialectInstance, field$3, dialectDomainElement));
    if (this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().declarations$2.declarables__sc_Seq().nonEmpty__Z()) {
      var declarations = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().declarations$2.declarables__sc_Seq();
      var field$4 = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
      $as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(dialectInstance, field$4, declarations))
    };
    if (references.baseUnitReferences__sc_Seq().nonEmpty__Z()) {
      var references$1 = references.baseUnitReferences__sc_Seq();
      var field$5 = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
      $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(dialectInstance, field$5, references$1))
    };
    if (this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().nestedDialects$2.nonEmpty__Z()) {
      var jsx$3 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().nestedDialects$2;
      var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
        return (function(nd$2) {
          var nd = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(nd$2);
          var this$11 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(nd);
          return $as_T((this$11.isEmpty__Z() ? nd.id$1 : this$11.get__O()))
        })
      })(this));
      var this$12 = $m_sc_Seq$();
      var ids = $as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$12.ReusableCBFInstance$2));
      var field$6 = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().GraphDependencies$1;
      $as_Lamf_plugins_document_vocabularies_model_document_DialectInstance($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(dialectInstance, field$6, ids))
    };
    var document = new $c_s_Some().init___O(dialectInstance)
  } else {
    var document = $m_s_None$()
  };
  var this$13 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().futureDeclarations$1;
  $f_Lamf_core_parser_FutureDeclarations__resolve__V(this$13);
  return document
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.parseObjectPairProperty__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__V = (function(id, propertyEntry, property, node) {
  var propertyKeyMapping = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermKeyProperty$1)).option$1;
  var propertyValueMapping = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermValueProperty$1)).option$1;
  if ((propertyKeyMapping.isDefined__Z() && propertyValueMapping.isDefined__Z())) {
    var this$1 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().dialect$2;
    var x1 = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Declares$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, property$1) {
      return (function(x$22$2) {
        var x$22 = $as_Lamf_core_model_domain_DomainElement(x$22$2);
        var jsx$1 = x$22.id__T();
        var this$2 = $as_Lamf_core_model_StrField($as_sc_Seq(property$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1)).head__O());
        var this$3 = this$2.option$1;
        return (jsx$1 === $as_T((this$3.isEmpty__Z() ? null : this$3.get__O())))
      })
    })(this, property)));
    matchEnd5: {
      var nested;
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var nodeMapping = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
        if ((nodeMapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
          var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(nodeMapping);
          var this$4 = propertyEntry.value$2;
          var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
          var iv = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
          var jsx$9 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).entries$3;
          var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, id$1, propertyEntry$1, x3$1, propertyKeyMapping$1, propertyValueMapping$1) {
            return (function(pair$2) {
              var pair = $as_Lorg_yaml_model_YMapEntry(pair$2);
              var this$5 = propertyEntry$1.key$2;
              var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
              var iv$1 = this$2$1.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
              var str = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion$1, iv$1)).text$3;
              var this$7 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
              var this$8 = this$7.platform$1;
              var url = this$7.str$1;
              var jsx$5 = $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$8, url);
              var this$9 = pair.key$2;
              var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
              var iv$2 = this$2$1.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
              var str$1 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$9, conversion$2, iv$2)).text$3;
              var this$11 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str$1);
              var this$12 = this$11.platform$1;
              var url$1 = this$11.str$1;
              var nestedId = ((((id$1 + "/") + jsx$5) + "/") + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$12, url$1));
              var jsx$8 = $m_sc_Seq$();
              var array = [$as_Lamf_core_model_StrField(x3$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().NodeTypeMapping$1)).option$1, new $c_s_Some().init___O(x3$1.id$1)];
              var jsx$7 = $as_sc_TraversableLike(jsx$8.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
              var jsx$6 = new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$4().init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser(this$2$1);
              var this$15 = $m_sc_Seq$();
              var effectiveTypes = $as_sc_Seq(jsx$7.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$6, this$15.ReusableCBFInstance$2));
              var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(pair);
              var this$18 = new $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
              var nestedNode = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$18, nestedId)).withDefinedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x3$1).withInstanceTypes__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(effectiveTypes);
              try {
                var field = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z($m_Lamf_core_metamodel_Type$Str$(), $m_Lamf_core_vocabulary_ValueType$().apply__T__Lamf_core_vocabulary_ValueType($as_T(propertyKeyMapping$1.get__O())), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true);
                var this$22 = pair.key$2;
                var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
                var iv$3 = this$2$1.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
                var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$22, conversion$3, iv$3)).text$3, new $c_Lamf_core_parser_Annotations().init___());
                var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(pair.key$2);
                $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(nestedNode, field, value, annotations$1);
                var field$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z($m_Lamf_core_metamodel_Type$Str$(), $m_Lamf_core_vocabulary_ValueType$().apply__T__Lamf_core_vocabulary_ValueType($as_T(propertyValueMapping$1.get__O())), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true);
                var this$27 = pair.value$2;
                var conversion$4 = $m_Lamf_core_parser_package$YScalarYRead$();
                var iv$4 = this$2$1.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
                var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$27, conversion$4, iv$4)).text$3, new $c_Lamf_core_parser_Annotations().init___());
                var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(pair.value$2);
                $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(nestedNode, field$1, value$1, annotations$2)
              } catch (e) {
                if ((e instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnknownMapKeyProperty)) {
                  var e$2 = $as_Lamf_plugins_document_vocabularies_model_domain_UnknownMapKeyProperty(e);
                  var this$29 = this$2$1.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
                  var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
                  var node$1 = e$2.id__T();
                  var message = ("Cannot find mapping for key map property " + e$2.id__T());
                  var prop = $m_s_None$();
                  var l = pair.location$1;
                  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$29, specification, node$1, prop, message, l)
                } else {
                  throw e
                }
              };
              return new $c_s_Some().init___O(nestedNode)
            })
          })(this, id, propertyEntry, x3, propertyKeyMapping, propertyValueMapping));
          var this$30 = $m_sc_IndexedSeq$();
          var jsx$3 = $as_sc_TraversableLike(jsx$9.map__F1__scg_CanBuildFrom__O(jsx$4, this$30.ReusableCBF$6));
          var jsx$2 = new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$5().init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser(this);
          var this$31 = $m_sc_IndexedSeq$();
          var nested = $as_sc_Seq(jsx$3.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$2, this$31.ReusableCBF$6));
          break matchEnd5
        }
      };
      var this$34 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
      var specification$1 = $m_Lamf_validation_DialectValidations$().DialectError$1;
      var this$32 = $as_Lamf_core_model_StrField($as_sc_Seq(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1)).head__O());
      var this$33 = this$32.option$1;
      var message$1 = ("Cannot find mapping for property range of mapValue property: " + $as_T((this$33.isEmpty__Z() ? null : this$33.get__O())));
      var prop$1 = $m_s_None$();
      var l$1 = propertyEntry.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$34, specification$1, id, prop$1, message$1, l$1);
      var nested = $m_sci_Nil$()
    };
    node.setObjectField__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__sc_Seq__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(property, nested, propertyEntry.key$2)
  } else {
    var this$35 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
    var specification$2 = $m_Lamf_validation_DialectValidations$().DialectError$1;
    var prop$2 = $m_s_None$();
    var l$2 = propertyEntry.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$35, specification$2, id, prop$2, "Both 'mapKey' and 'mapValue' are mandatory in a map pair property mapping", l$2)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.checkDuplicated__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YNode__scm_Map__V = (function(dialectDomainElement, elementNode, idsMap) {
  var x1 = idsMap.get__O__s_Option(dialectDomainElement.id$1);
  var x = $m_s_None$();
  if ((x === x1)) {
    idsMap.update__O__O__V(dialectDomainElement.id$1, true)
  } else {
    var this$1 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
    var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
    var node = dialectDomainElement.id$1;
    var message = ("Duplicated element in collection " + dialectDomainElement.id$1);
    var prop = $m_s_None$();
    var l = elementNode.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, node, prop, message, l)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.findDeclarationsMap__p1__sci_List__Lorg_yaml_model_YMap__s_Option = (function(paths, map) {
  _findDeclarationsMap: while (true) {
    var x1 = paths;
    var x$2 = $m_sci_Nil$();
    if (x$2.equals__O__Z(x1)) {
      return new $c_s_Some().init___O(map)
    } else if ((x1 instanceof $c_sci_$colon$colon)) {
      var x2 = $as_sci_$colon$colon(x1);
      var head = $as_T(x2.head$5);
      var tail = x2.tl$5;
      var rc5 = false;
      var x2$2 = null;
      var map$1 = map;
      var x1$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option(head);
      if ((x1$2 instanceof $c_s_Some)) {
        rc5 = true;
        x2$2 = $as_s_Some(x1$2);
        var m = $as_Lorg_yaml_model_YMapEntry(x2$2.value$2);
        var this$2 = m.value$2;
        var x$4 = this$2.tag__Lorg_yaml_model_YTag().tagType$3;
        var x$5 = $m_Lorg_yaml_model_YType$().Map$1;
        if ((x$4 === x$5)) {
          if ($f_sc_TraversableOnce__nonEmpty__Z(tail)) {
            var this$3 = m.value$2;
            var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
            var iv = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
            var temp$map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv));
            paths = tail;
            map = temp$map;
            continue _findDeclarationsMap
          } else {
            var node = m.value$2;
            return new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YMapYRead$())
          }
        }
      };
      if (rc5) {
        var o = $as_Lorg_yaml_model_YMapEntry(x2$2.value$2);
        var this$7 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
        var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
        var this$5 = o.value$2;
        var this$6 = this$5.tag__Lorg_yaml_model_YTag().tagType$3;
        var message = ("Invalid node type for declarations path " + this$6.org$yaml$model$YType$$tag$und$1.text$3);
        var prop = $m_s_None$();
        var l = o.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$7, specification, "", prop, message, l);
        return $m_s_None$()
      };
      return $m_s_None$()
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.setLiteralValue__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__V = (function(entry, property, node) {
  var rc21 = false;
  var x2 = null;
  var x1 = this.parseLiteralValue__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__s_Option(entry.value$2, property, node);
  matchEnd22: {
    if ((x1 instanceof $c_s_Some)) {
      rc21 = true;
      x2 = $as_s_Some(x1);
      var b = x2.value$2;
      if (((typeof b) === "boolean")) {
        var x12 = $uZ(b);
        node.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Z__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(property, x12, entry);
        break matchEnd22
      }
    };
    if (rc21) {
      var i = x2.value$2;
      if ($isInt(i)) {
        var x13 = $uI(i);
        node.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__I__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(property, x13, entry);
        break matchEnd22
      }
    };
    if (rc21) {
      var f = x2.value$2;
      if ($isFloat(f)) {
        var x14 = $uF(f);
        node.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__F__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(property, x14, entry);
        break matchEnd22
      }
    };
    if (rc21) {
      var d = x2.value$2;
      if (((typeof d) === "number")) {
        var x15 = $uD(d);
        node.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__D__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(property, x15, entry);
        break matchEnd22
      }
    };
    if (rc21) {
      var s = x2.value$2;
      if ($is_T(s)) {
        var x16 = $as_T(s);
        node.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(property, x16, entry);
        break matchEnd22
      }
    };
    if (rc21) {
      var p8 = x2.value$2;
      if ((p8 instanceof $c_T2)) {
        var x9 = $as_T2(p8);
        var p10 = x9.$$und1__O();
        var l = x9.$$und2__O();
        if (((p10 === "link") && $is_T(l))) {
          var x18 = $as_T(l);
          node.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(property, x18, entry);
          break matchEnd22
        }
      }
    };
    if (rc21) {
      var d$2 = x2.value$2;
      if ((d$2 instanceof $c_Lorg_mulesoft_common_time_SimpleDateTime)) {
        var x19 = $as_Lorg_mulesoft_common_time_SimpleDateTime(d$2);
        node.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lorg_mulesoft_common_time_SimpleDateTime__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(property, x19, entry);
        break matchEnd22
      }
    };
    node.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(property, entry)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.resolveLink__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__T__s_Option__s_Option = (function(ast, mapping, id, givenAnnotations) {
  var x1 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().link__Lorg_yaml_model_YNode__s_util_Either(ast);
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var key = $as_T(x2.value$2);
    var refTuple = new $c_T2().init___O__O(key, this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().declarations$2.findDialectDomainElement__T__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_core_parser_SearchScope$Scope__s_Option(key, mapping, $m_Lamf_core_parser_SearchScope$Fragments$()))
  } else {
    var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    var text = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(ast, conversion, iv)).text$3;
    var refTuple = new $c_T2().init___O__O(text, this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().declarations$2.findDialectDomainElement__T__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_core_parser_SearchScope$Scope__s_Option(text, mapping, $m_Lamf_core_parser_SearchScope$Named$()))
  };
  if ((refTuple !== null)) {
    var text$2 = $as_T(refTuple.$$und1__O());
    var p2 = $as_s_Option(refTuple.$$und2__O());
    if ((text$2 !== null)) {
      if ((p2 instanceof $c_s_Some)) {
        var x3 = $as_s_Some(p2);
        var s = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x3.value$2);
        var annotations = $as_Lamf_core_parser_Annotations((givenAnnotations.isEmpty__Z() ? $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast) : givenAnnotations.get__O()));
        var jsx$2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(s, text$2, annotations));
        var jsx$1 = $m_sc_Seq$();
        var array = [mapping.id__T()];
        var this$3 = jsx$2.withInstanceTypes__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))));
        var linkedNode = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$3, id));
        return new $c_s_Some().init___O(linkedNode)
      }
    }
  };
  if ((refTuple !== null)) {
    var text$3 = $as_T(refTuple.$$und1__O());
    if ((text$3 !== null)) {
      var annotations$1 = $as_Lamf_core_parser_Annotations((givenAnnotations.isEmpty__Z() ? $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast) : givenAnnotations.get__O()));
      var this$6 = new $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
      var jsx$4 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$6, id));
      var jsx$3 = $m_sc_Seq$();
      var array$1 = [mapping.id__T()];
      var linkedNode$2 = jsx$4.withInstanceTypes__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1))));
      if (givenAnnotations.isEmpty__Z()) {
        var this$9 = $m_s_None$()
      } else {
        var arg1 = givenAnnotations.get__O();
        var x$24 = $as_Lamf_core_parser_Annotations(arg1);
        var this$9 = x$24.find__jl_Class__s_Option($d_Lamf_core_annotations_SourceAST.getClassOf())
      };
      if (this$9.isEmpty__Z()) {
        var this$10 = $m_s_None$()
      } else {
        var arg1$1 = this$9.get__O();
        var x$25 = $as_Lamf_core_annotations_SourceAST(arg1$1);
        var this$10 = new $c_s_Some().init___O(x$25.ast$1)
      };
      var refAst = $as_Lorg_yaml_model_YPart((this$10.isEmpty__Z() ? ast : this$10.get__O()));
      var ctx = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
      $f_Lamf_core_model_domain_Linkable__unresolved__T__Lorg_yaml_model_YPart__T__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(linkedNode$2, text$3, refAst, "error", ctx);
      return new $c_s_Some().init___O(linkedNode$2)
    }
  };
  throw new $c_s_MatchError().init___O(refTuple)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.checkClosedNode__T__T__sci_Map__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lorg_yaml_model_YPart__Z__s_Option__V = (function(id, nodetype, entries, mapping, ast, rootNode, additionalKey) {
  var rootProps = (rootNode ? this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().rootProps$2 : $as_sci_Set($m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
  var jsx$2 = $as_sc_Seq(mapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$4$2) {
      var x$4 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$4$2);
      var this$1 = $as_Lamf_core_model_StrField(x$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
      var this$2 = this$1.option$1;
      return $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()))
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  var props = $as_sci_Set($as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2)).toSet__sci_Set().union__sc_GenSet__sc_Set(rootProps));
  var this$5 = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(entries);
  var this$4 = $m_sc_Iterable$();
  var bf = this$4.ReusableCBFInstance$2;
  var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$5, bf);
  var this$6 = this$5.$$outer$4.keysIterator__sc_Iterator();
  while (this$6.hasNext__Z()) {
    var arg1 = this$6.next__O();
    var x$5 = $as_Lorg_yaml_model_YNode(arg1);
    b.$$plus$eq__O__scm_Builder($as_Lorg_yaml_model_YScalar(x$5.value__Lorg_yaml_model_YValue()).text$3)
  };
  var inNode = $as_sc_TraversableOnce($as_sc_TraversableLike($as_sc_TraversableLike(b.result__O()).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(p$2) {
      var p = $as_T(p$2);
      return (((!(($uI(p.length) >= 0) && ($as_T(p.substring(0, $uI("$".length))) === "$"))) && (!(($uI(p.length) >= 0) && ($as_T(p.substring(0, $uI("(".length))) === "(")))) && (!(($uI(p.length) >= 0) && ($as_T(p.substring(0, $uI("x-".length))) === "x-"))))
    })
  })(this)))).filterNot__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, additionalKey$1) {
    return (function(elem$2) {
      return additionalKey$1.contains__O__Z(elem$2)
    })
  })(this, additionalKey)))).toSet__sci_Set();
  var outside = $as_sci_Set(inNode.diff__sc_GenSet__sc_Set(props));
  if ($f_sc_TraversableOnce__nonEmpty__Z(outside)) {
    outside.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1, entries$1, ast$1, id$1, nodetype$1) {
      return (function(prop$2) {
        var prop = $as_T(prop$2);
        var this$22 = entries$1.iterator__sc_Iterator();
        inlinereturn$61: {
          while (this$22.hasNext__Z()) {
            var a = this$22.next__O();
            var x$6 = $as_T2(a);
            if (($as_Lorg_yaml_model_YNode(x$6.$$und1__O()).toString__T() === prop)) {
              var this$23 = new $c_s_Some().init___O(a);
              break inlinereturn$61
            }
          };
          var this$23 = $m_s_None$()
        };
        if (this$23.isEmpty__Z()) {
          var this$24 = $m_s_None$()
        } else {
          var arg1$1 = this$23.get__O();
          var x$7 = $as_T2(arg1$1);
          var this$24 = new $c_s_Some().init___O($as_Lorg_yaml_model_YNode(x$7.$$und2__O()))
        };
        var posAst = $as_Lorg_yaml_model_YPart((this$24.isEmpty__Z() ? ast$1 : this$24.get__O()));
        var this$25 = this$5$1.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
        $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__closedNodeViolation__T__T__T__Lorg_yaml_model_YPart__V(this$25, id$1, prop, nodetype$1, posAst)
      })
    })(this, entries, ast, id, nodetype)))
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.parseLiteralCollectionProperty__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__V = (function(id, propertyEntry, property, node) {
  var this$1 = propertyEntry.value$2;
  var x1 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Seq$1;
  if ((x === x1)) {
    var this$2 = propertyEntry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
    var iv = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    var jsx$2 = $as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv)).nodes$3;
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, property$1, node$1) {
      return (function(elemValue$2) {
        var elemValue = $as_Lorg_yaml_model_YNode(elemValue$2);
        var xo = $this.parseLiteralValue__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__s_Option(elemValue, property$1, node$1);
        return xo.toList__sci_List()
      })
    })(this, property, node));
    var this$4 = $m_sc_IndexedSeq$();
    var values = $as_sc_IndexedSeq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBF$6));
    var x1$2 = values.headOption__s_Option();
    matchEnd10: {
      var finalValues;
      if ((x1$2 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1$2);
        var p3 = x2.value$2;
        if ((p3 instanceof $c_T2)) {
          var x4 = $as_T2(p3);
          var p5 = x4.$$und1__O();
          if (((p5 === "link") && $is_T(x4.$$und2__O()))) {
            var jsx$3 = new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$7().init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser(this);
            var this$5 = $m_sc_IndexedSeq$();
            var finalValues = $as_sc_Seq(values.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$3, this$5.ReusableCBF$6));
            break matchEnd10
          }
        }
      };
      var finalValues = values
    }
  } else {
    var rc9 = false;
    var x2$2 = null;
    var x1$3 = this.parseLiteralValue__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__s_Option(propertyEntry.value$2, property, node);
    matchEnd10$2: {
      var finalValues;
      if ((x1$3 instanceof $c_s_Some)) {
        rc9 = true;
        x2$2 = $as_s_Some(x1$3);
        var p3$2 = x2$2.value$2;
        if ((p3$2 instanceof $c_T2)) {
          var x4$2 = $as_T2(p3$2);
          var p5$2 = x4$2.$$und1__O();
          var v = x4$2.$$und2__O();
          if ((p5$2 === "link")) {
            var jsx$4 = $m_sc_Seq$();
            var array = [v];
            var finalValues = $as_sc_Seq(jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
            break matchEnd10$2
          }
        }
      };
      if (rc9) {
        var v$2 = x2$2.value$2;
        var jsx$5 = $m_sc_Seq$();
        var array$1 = [v$2];
        var finalValues = $as_sc_Seq(jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)));
        break matchEnd10$2
      };
      var finalValues = $m_sci_Nil$()
    }
  };
  node.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__sc_Seq__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(property, finalValues, propertyEntry)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.checkHashProperties__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(node, propertyMapping, propertyEntry) {
  var x1 = $as_Lamf_core_model_StrField(propertyMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermKeyProperty$1)).option$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var propId = $as_T(x2.value$2);
    try {
      var field = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z($m_Lamf_core_metamodel_Type$Str$(), $m_Lamf_core_vocabulary_ValueType$().apply__T__Lamf_core_vocabulary_ValueType(propId), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true);
      var this$4 = propertyEntry.key$2;
      var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
      var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).text$3, new $c_Lamf_core_parser_Annotations().init___());
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(propertyEntry.key$2);
      return $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(node, field, value, annotations))
    } catch (e) {
      if ((e instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnknownMapKeyProperty)) {
        var e$2 = $as_Lamf_plugins_document_vocabularies_model_domain_UnknownMapKeyProperty(e);
        var this$6 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
        var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
        var node$1 = e$2.id__T();
        var message = ("Cannot find mapping for key map property " + e$2.id__T());
        var property = $m_s_None$();
        var lexical = $m_s_None$();
        var location = $m_s_None$();
        this$6.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node$1, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
        return node
      } else {
        throw e
      }
    }
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return node
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.resolveLinkProperty__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Z__V = (function(propertyEntry, mapping, id, node, isRef) {
  var x1 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().link__Lorg_yaml_model_YNode__s_util_Either(propertyEntry.value$2);
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var key = $as_T(x2.value$2);
    var _2 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().declarations$2.findAnyDialectDomainElement__T__Lamf_core_parser_SearchScope$Scope__s_Option(key, $m_Lamf_core_parser_SearchScope$Fragments$());
    var refTuple_$_$$und1$f = key;
    var refTuple_$_$$und2$f = _2
  } else {
    var this$1 = propertyEntry.value$2;
    var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    var text = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3;
    var _2$1 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().declarations$2.findAnyDialectDomainElement__T__Lamf_core_parser_SearchScope$Scope__s_Option(text, $m_Lamf_core_parser_SearchScope$All$());
    var refTuple_$_$$und1$f = text;
    var refTuple_$_$$und2$f = _2$1
  };
  matchEnd6: {
    var text$2 = $as_T(refTuple_$_$$und1$f);
    var p2 = $as_s_Option(refTuple_$_$$und2$f);
    if ((text$2 !== null)) {
      if ((p2 instanceof $c_s_Some)) {
        var x3 = $as_s_Some(p2);
        var s = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x3.value$2);
        var x1$3 = $m_Lamf_plugins_document_vocabularies_AMLPlugin$().apply__Lamf_plugins_document_vocabularies_AMLPlugin().registry$2.findNode__T__s_Option(s.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping().id$1);
        matchEnd7: {
          if ((x1$3 instanceof $c_s_Some)) {
            var x2$2 = $as_s_Some(x1$3);
            var p3 = $as_T2(x2$2.value$2);
            if ((p3 !== null)) {
              var dialect = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(p3.$$und1__O());
              var jsx$4 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
              var jsx$3 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().nestedDialects$2;
              var jsx$2 = $m_sc_Seq$();
              var array = [dialect];
              var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
              var this$4 = $m_sc_Seq$();
              jsx$4.nestedDialects$2 = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2));
              var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(propertyEntry.value$2);
              var this$5 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(s, text$2, annotations));
              var linkedExternal = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, id));
              if (isRef) {
                linkedExternal.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_vocabularies_annotations_RefInclude().init___())
              };
              node.setObjectField__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(mapping, linkedExternal, propertyEntry.value$2);
              break matchEnd7
            }
          };
          var x = $m_s_None$();
          if ((x === x1$3)) {
            var this$6 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
            var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
            var message = ("Cannot find dialect for anyNode node mapping " + s.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping().id$1);
            var ast = propertyEntry.value$2;
            var prop = $m_s_None$();
            var l = ast.location$1;
            $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$6, specification, id, prop, message, l);
            break matchEnd7
          };
          throw new $c_s_MatchError().init___O(x1$3)
        };
        break matchEnd6
      }
    };
    var this$7 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
    var specification$1 = $m_Lamf_validation_DialectValidations$().DialectError$1;
    var message$1 = (("anyNode reference must be to a known node or an external fragment, unknown value: '" + propertyEntry.value$2) + "'");
    var ast$1 = propertyEntry.value$2;
    var prop$1 = $m_s_None$();
    var l$1 = ast$1.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$7, specification$1, id, prop$1, message$1, l$1)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.templateNodeId__T__Lorg_yaml_model_YMap__T__T = (function(nodeId, nodeMap, originalTemplate) {
  var elem$1 = null;
  elem$1 = originalTemplate;
  var this$3 = new $c_sci_StringOps().init___T("(\\{[^}]+\\})");
  var groupNames = $m_sci_Nil$();
  var $$this = this$3.repr$1;
  var regex = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  var this$5 = regex.findAllIn__jl_CharSequence__s_util_matching_Regex$MatchIterator($as_T(elem$1));
  while (this$5.hasNext__Z()) {
    var arg1 = this$5.next__T();
    var thiz = $as_T(arg1.split("{").join(""));
    var variable = $as_T(thiz.split("}").join(""));
    var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(nodeMap).key__T__s_Option(variable);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var this$11 = entry.value$2;
      var x1$2 = this$11.tag__Lorg_yaml_model_YTag().tagType$3;
      var x = $m_Lorg_yaml_model_YType$().Str$1;
      if ((x === x1$2)) {
        var this$12 = entry.value$2;
        var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
        var value = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$12, conversion, iv))
      } else {
        var value = entry.value$2.value__Lorg_yaml_model_YValue().toString__T()
      };
      var thiz$1 = $as_T(elem$1);
      elem$1 = $as_T(thiz$1.split(arg1).join(value))
    } else {
      var x$3 = $m_s_None$();
      if ((x$3 === x1)) {
        var this$15 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
        var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
        var message = (("Missing ID template variable '" + variable) + "' in node");
        var prop = $m_s_None$();
        var l = nodeMap.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$15, specification, nodeId, prop, message, l)
      } else {
        throw new $c_s_MatchError().init___O(x1)
      }
    }
  };
  return $as_T(elem$1)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.generateNodeId__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YMap__sc_Seq__T__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__sci_Map__Z__T = (function(node, nodeMap, path, defaultId, mapping, additionalProperties, rootNode) {
  if (rootNode) {
    var jsx$2 = $m_s_Option$();
    var this$1 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().dialect$2;
    var this$2 = jsx$2.apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1)));
    if (this$2.isEmpty__Z()) {
      var this$3 = $m_s_None$()
    } else {
      var arg1 = this$2.get__O();
      var x$27 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(arg1);
      var this$3 = $as_Lamf_core_model_BoolField(x$27.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().SelfEncoded$1)).option$1
    };
    var jsx$1 = $uZ((this$3.isEmpty__Z() ? false : this$3.get__O()))
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return defaultId
  } else if (new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(nodeMap).key__T__s_Option("$id").isDefined__Z()) {
    return this.explicitNodeId__s_Option__Lorg_yaml_model_YMap__sc_Seq__T__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__T(new $c_s_Some().init___O(node), nodeMap, path, defaultId, mapping)
  } else {
    var this$5 = $as_Lamf_core_model_StrField(mapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().IdTemplate$1));
    if ($f_Lamf_core_model_StrField__nonEmpty__Z(this$5)) {
      var jsx$3 = node.id$1;
      var this$6 = $as_Lamf_core_model_StrField(mapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().IdTemplate$1));
      var this$7 = this$6.option$1;
      var template = this.templateNodeId__T__Lorg_yaml_model_YMap__T__T(jsx$3, nodeMap, $as_T((this$7.isEmpty__Z() ? null : this$7.get__O())));
      return this.finalTemplateId__T__sc_Seq__T(template, path)
    } else {
      return (mapping.primaryKey__sc_Seq().nonEmpty__Z() ? this.primaryKeyNodeId__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YMap__sc_Seq__T__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__sci_Map__T(node, nodeMap, path, defaultId, mapping, additionalProperties) : defaultId)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.generateExternalLink__p1__T__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__s_Option = (function(id, node, mapping) {
  var rc6 = false;
  var x3 = null;
  var x1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Str$1;
  if ((x === x1)) {
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var this$5 = new $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations).withDefinedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(mapping);
    $m_Lorg_yaml_model_YNode$();
    var iv = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
    var value = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv));
    var this$6 = $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
    var field = $m_Lamf_core_metamodel_domain_DomainElementModel$().IsExternalLink$1;
    var jsx$4 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$6, field, true)));
    var jsx$3 = $m_sc_Seq$();
    var array = [$as_Lamf_core_model_StrField(mapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().NodeTypeMapping$1)).option$1, new $c_s_Some().init___O(mapping.id$1)];
    var jsx$2 = $as_sc_TraversableLike(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
    var jsx$1 = new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$1().init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser(this);
    var this$9 = $m_sc_Seq$();
    var elem = jsx$4.withInstanceTypes__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$9.ReusableCBFInstance$2)));
    return new $c_s_Some().init___O(elem)
  };
  var x$3 = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x$3 === x1)) {
    rc6 = true;
    x3 = x1;
    var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$1 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    if (($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$1, iv$1)).entries$3.length__I() === 1)) {
      var conversion$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv$2 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
      var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$2, iv$2));
      var jsx$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("$id").isDefined__Z()
    } else {
      var jsx$5 = false
    };
    if (jsx$5) {
      var conversion$3 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv$3 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
      var refMap = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$3, iv$3));
      if (new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(refMap).key__T__s_Option("$id").isDefined__Z()) {
        var id$2 = this.explicitNodeId__s_Option__Lorg_yaml_model_YMap__sc_Seq__T__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__T($m_s_None$(), refMap, $m_sci_Nil$(), "", mapping);
        $m_Lamf_core_parser_Annotations$();
        var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
        var this$15 = new $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1).withDefinedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(mapping);
        var this$16 = $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$15, id$2));
        var field$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().IsExternalLink$1;
        var elem$2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$16, field$1, true)));
        var jsx$8 = $m_sc_Seq$();
        var array$1 = [$as_Lamf_core_model_StrField(mapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().NodeTypeMapping$1)).option$1, new $c_s_Some().init___O(mapping.id$1)];
        var jsx$7 = $as_sc_TraversableLike(jsx$8.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)));
        var jsx$6 = new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$1().init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser(this);
        var this$19 = $m_sc_Seq$();
        elem$2.withInstanceTypes__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_sc_Seq(jsx$7.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$6, this$19.ReusableCBFInstance$2)));
        elem$2.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_vocabularies_annotations_CustomId().init___T("true"));
        return new $c_s_Some().init___O(elem$2)
      } else {
        var this$20 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
        var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
        var property = $m_s_None$();
        var lexical = $m_s_None$();
        var location = $m_s_None$();
        this$20.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, id, property, "Map link references must contain a '$id' property", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
        return $m_s_None$()
      }
    }
  };
  if (rc6) {
    var conversion$4 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$4 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    var refMap$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$4, iv$4));
    var base = $m_s_None$();
    var x1$2 = $as_Lamf_core_model_StrField(mapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().IdTemplate$1)).option$1;
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var idTemplate = $as_T(x2.value$2);
      var rc6$2 = false;
      var x2$2 = null;
      var x1$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(refMap$2).key__T__s_Option("$id");
      matchEnd7$2: {
        if ((x1$3 instanceof $c_s_Some)) {
          rc6$2 = true;
          x2$2 = $as_s_Some(x1$3);
          var baseId = $as_Lorg_yaml_model_YMapEntry(x2$2.value$2);
          var this$22 = baseId.value$2;
          var x$5 = this$22.tag__Lorg_yaml_model_YTag().tagType$3;
          var x$6 = $m_Lorg_yaml_model_YType$().Str$1;
          if ((x$5 === x$6)) {
            var this$23 = baseId.value$2;
            var conversion$5 = $m_Lorg_yaml_convert_YRead$StringYRead$();
            var iv$5 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
            var thiz = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$23, conversion$5, iv$5));
            if (($uI(thiz.indexOf("://")) !== (-1))) {
              var jsx$9 = true
            } else {
              var this$27 = baseId.value$2;
              var conversion$6 = $m_Lorg_yaml_convert_YRead$StringYRead$();
              var iv$6 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
              var thiz$1 = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$27, conversion$6, iv$6));
              var jsx$9 = (($uI(thiz$1.length) >= 0) && ($as_T(thiz$1.substring(0, $uI("//".length))) === "//"))
            }
          } else {
            var jsx$9 = false
          };
          if (jsx$9) {
            var this$33 = baseId.value$2;
            var conversion$7 = $m_Lorg_yaml_convert_YRead$StringYRead$();
            var iv$7 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
            base = new $c_s_Some().init___O($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$33, conversion$7, iv$7));
            break matchEnd7$2
          }
        };
        if (rc6$2) {
          var this$34 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
          var specification$1 = $m_Lamf_validation_DialectValidations$().DialectError$1;
          var property$1 = $m_s_None$();
          var lexical$1 = $m_s_None$();
          var location$1 = $m_s_None$();
          this$34.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification$1.id$1, id, property$1, "External link with map values and relative $id, $id must be absolute if provided with a link map $id", lexical$1, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location$1);
          base = $m_s_None$();
          break matchEnd7$2
        };
        base = $m_s_None$()
      };
      if (($uI(idTemplate.indexOf("://")) !== (-1))) {
        var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(idTemplate, "://", 0);
        var this$40 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
        var template = $as_T($f_sc_IndexedSeqOptimized__last__O(this$40))
      } else {
        var template = idTemplate
      };
      var thiz$2 = template;
      if ((($uI(thiz$2.length) >= 0) && ($as_T(thiz$2.substring(0, $uI("//".length))) === "//"))) {
        var x$1 = template;
        var this$47 = new $c_sci_StringOps().init___T(x$1);
        var $$this = this$47.repr$1;
        var until = $uI($$this.length);
        template = $m_sci_StringOps$().slice$extension__T__I__I__T(this$47.repr$1, 2, until)
      };
      var separator = "";
      if (base.isEmpty__Z()) {
        template = idTemplate
      } else {
        var thiz$3 = template;
        if (($uI(thiz$3.indexOf("/")) !== (-1))) {
          var thiz$4 = template;
          var parts = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz$4, "/", 0);
          separator = "/";
          var until$1 = parts.u.length;
          var x$2 = ((until$1 > 0) ? until$1 : 0);
          var y = parts.u.length;
          var hi = ((x$2 < y) ? x$2 : y);
          var x$4 = (((-1) + hi) | 0);
          var size = ((x$4 > 0) ? x$4 : 0);
          var result = $m_jl_reflect_Array$().newInstance__jl_Class__I__O($objectGetClass(parts).getComponentType__jl_Class(), size);
          if ((size > 0)) {
            $m_s_Array$().copy__O__I__O__I__I__V(parts, 1, result, 0, size)
          };
          var xs$1 = $asArrayOf_O(result, 1);
          var b = new $c_scm_StringBuilder().init___();
          var elem$1 = false;
          elem$1 = true;
          b.append__T__scm_StringBuilder("");
          var i = 0;
          var len = xs$1.u.length;
          while ((i < len)) {
            var index = i;
            var arg1 = xs$1.get(index);
            if (elem$1) {
              b.append__O__scm_StringBuilder(arg1);
              elem$1 = false
            } else {
              b.append__T__scm_StringBuilder("/");
              b.append__O__scm_StringBuilder(arg1)
            };
            i = ((1 + i) | 0)
          };
          b.append__T__scm_StringBuilder("");
          template = b.underlying$5.java$lang$StringBuilder$$content$f
        } else {
          var thiz$5 = template;
          if (($uI(thiz$5.indexOf("#")) !== (-1))) {
            var thiz$6 = template;
            var parts$2 = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz$6, "#", 0);
            separator = "#";
            var until$2 = parts$2.u.length;
            var x$7 = ((until$2 > 0) ? until$2 : 0);
            var y$1 = parts$2.u.length;
            var hi$1 = ((x$7 < y$1) ? x$7 : y$1);
            var x$8 = (((-1) + hi$1) | 0);
            var size$1 = ((x$8 > 0) ? x$8 : 0);
            var result$1 = $m_jl_reflect_Array$().newInstance__jl_Class__I__O($objectGetClass(parts$2).getComponentType__jl_Class(), size$1);
            if ((size$1 > 0)) {
              $m_s_Array$().copy__O__I__O__I__I__V(parts$2, 1, result$1, 0, size$1)
            };
            var xs$2 = $asArrayOf_O(result$1, 1);
            var b$1 = new $c_scm_StringBuilder().init___();
            var elem$1$1 = false;
            elem$1$1 = true;
            b$1.append__T__scm_StringBuilder("");
            var i$1 = 0;
            var len$1 = xs$2.u.length;
            while ((i$1 < len$1)) {
              var index$1 = i$1;
              var arg1$1 = xs$2.get(index$1);
              if (elem$1$1) {
                b$1.append__O__scm_StringBuilder(arg1$1);
                elem$1$1 = false
              } else {
                b$1.append__T__scm_StringBuilder("#");
                b$1.append__O__scm_StringBuilder(arg1$1)
              };
              i$1 = ((1 + i$1) | 0)
            };
            b$1.append__T__scm_StringBuilder("");
            template = b$1.underlying$5.java$lang$StringBuilder$$content$f
          } else {
            template = template
          }
        }
      };
      var finalPath = this.templateNodeId__T__Lorg_yaml_model_YMap__T__T(id, refMap$2, template);
      if (base.isEmpty__Z()) {
        var computedNodeId = finalPath
      } else {
        var this$86 = base;
        var x$9 = $as_T((this$86.isEmpty__Z() ? this.root$1.location$1 : this$86.get__O()));
        var this$89 = new $c_sci_StringOps().init___T(x$9);
        var x$10 = separator;
        var that = new $c_sci_StringOps().init___T(x$10);
        var bf = $m_s_Predef$().StringCanBuildFrom$2;
        var x$11 = $as_T($f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this$89, that, bf));
        var this$92 = new $c_sci_StringOps().init___T(x$11);
        var that$1 = new $c_sci_StringOps().init___T(finalPath);
        var bf$1 = $m_s_Predef$().StringCanBuildFrom$2;
        var computedNodeId = $as_T($f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this$92, that$1, bf$1))
      }
    } else {
      var x$7$1 = $m_s_None$();
      if ((!(x$7$1 === x1$2))) {
        throw new $c_s_MatchError().init___O(x1$2)
      };
      var this$93 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
      var specification$2 = $m_Lamf_validation_DialectValidations$().DialectError$1;
      var property$2 = $m_s_None$();
      var lexical$2 = $m_s_None$();
      var location$2 = $m_s_None$();
      this$93.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification$2.id$1, id, property$2, "External link with map values and no idTemplate defined for the node in the dialect", lexical$2, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location$2);
      var computedNodeId = "/anon-node-error"
    };
    var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(refMap$2);
    var this$96 = new $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$2).withDefinedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(mapping);
    var linkReference = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$96, computedNodeId));
    var jsx$12 = $m_sc_Seq$();
    var array$2 = [$as_Lamf_core_model_StrField(mapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().NodeTypeMapping$1)).option$1, new $c_s_Some().init___O(mapping.id$1)];
    var jsx$11 = $as_sc_TraversableLike(jsx$12.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2)));
    var jsx$10 = new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$3().init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser(this);
    var this$99 = $m_sc_Seq$();
    linkReference.withInstanceTypes__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_sc_Seq(jsx$11.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$10, this$99.ReusableCBFInstance$2)));
    var field$2 = $m_Lamf_core_metamodel_domain_DomainElementModel$().IsExternalLink$1;
    $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(linkReference, field$2, true));
    if (base.isDefined__Z()) {
      linkReference.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_vocabularies_annotations_CustomId().init___T($as_T(base.get__O())))
    };
    $as_sc_Seq(mapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, refMap$2$1, computedNodeId$1, linkReference$1) {
      return (function(propertyMapping$2) {
        var propertyMapping = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(propertyMapping$2);
        var this$100 = $as_Lamf_core_model_StrField(propertyMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
        var this$101 = this$100.option$1;
        var propertyName = $as_T((this$101.isEmpty__Z() ? null : this$101.get__O()));
        var x1$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(refMap$2$1).key__T__s_Option(propertyName);
        if ((x1$1 instanceof $c_s_Some)) {
          var x2$1 = $as_s_Some(x1$1);
          var entry = $as_Lorg_yaml_model_YMapEntry(x2$1.value$2);
          this$2$1.parseProperty__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__V(computedNodeId$1, entry, propertyMapping, linkReference$1)
        } else {
          var x$12 = $m_s_None$();
          if ((!(x$12 === x1$1))) {
            throw new $c_s_MatchError().init___O(x1$1)
          }
        }
      })
    })(this, refMap$2, computedNodeId, linkReference)));
    return new $c_s_Some().init___O(linkReference)
  };
  var this$103 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
  var specification$3 = $m_Lamf_validation_DialectValidations$().DialectError$1;
  var property$3 = $m_s_None$();
  var lexical$3 = $m_s_None$();
  var location$3 = $m_s_None$();
  this$103.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification$3.id$1, id, property$3, "External Links must be strings or maps with idTemplate and optional $id for the base URL", lexical$3, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location$3);
  return $m_s_None$()
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext = (function(root, ctx) {
  this.root$1 = root;
  this.ctx$1 = ctx;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  var this$2 = $as_Lamf_core_parser_SyamlParsedDocument(root.parsed$1).document$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  this.map$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, ctx));
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.resolveLinkUnion__Lorg_yaml_model_YNode__sc_Seq__T__s_Some = (function(ast, allPossibleMappings, id) {
  var x1 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().link__Lorg_yaml_model_YNode__s_util_Either(ast);
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var key = $as_T(x2.value$2);
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, key$1) {
      return (function(mapping$2) {
        var mapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(mapping$2);
        return $this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().declarations$2.findDialectDomainElement__T__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_core_parser_SearchScope$Scope__s_Option(key$1, mapping, $m_Lamf_core_parser_SearchScope$Fragments$())
      })
    })(this, key));
    var this$1 = $m_sc_Seq$();
    var this$2 = $as_sc_TraversableOnce(allPossibleMappings.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
    var pf = new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$8().init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser(this);
    var refTuple = new $c_T2().init___O__O(key, $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$2, pf))
  } else {
    var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    var text = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(ast, conversion, iv)).text$3;
    var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, text$1) {
      return (function(mapping$3$2) {
        var mapping$3 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(mapping$3$2);
        return this$2$1.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().declarations$2.findDialectDomainElement__T__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_core_parser_SearchScope$Scope__s_Option(text$1, mapping$3, $m_Lamf_core_parser_SearchScope$Named$())
      })
    })(this, text));
    var this$3 = $m_sc_Seq$();
    var this$4 = $as_sc_TraversableOnce(allPossibleMappings.map__F1__scg_CanBuildFrom__O(jsx$2, this$3.ReusableCBFInstance$2));
    var pf$1 = new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$9().init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser(this);
    var refTuple = new $c_T2().init___O__O(text, $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$4, pf$1))
  };
  if ((refTuple !== null)) {
    var text$2 = $as_T(refTuple.$$und1__O());
    var p2 = $as_s_Option(refTuple.$$und2__O());
    if ((text$2 !== null)) {
      if ((p2 instanceof $c_s_Some)) {
        var x3 = $as_s_Some(p2);
        var s = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x3.value$2);
        var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast.value__Lorg_yaml_model_YValue());
        var this$5 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(s, text$2, annotations));
        var linkedNode = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, id));
        return new $c_s_Some().init___O(linkedNode)
      }
    }
  };
  if ((refTuple !== null)) {
    var text$3 = $as_T(refTuple.$$und1__O());
    if ((text$3 !== null)) {
      var this$6 = $m_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$().apply__Lorg_yaml_model_YMap__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(this.map$1);
      var linkedNode$2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$6, id));
      var refAst = this.map$1;
      var ctx = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
      $f_Lamf_core_model_domain_Linkable__unresolved__T__Lorg_yaml_model_YPart__T__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(linkedNode$2, text$3, refAst, "error", ctx);
      return new $c_s_Some().init___O(linkedNode$2)
    }
  };
  throw new $c_s_MatchError().init___O(refTuple)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.parseProperty__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__V = (function(id, propertyEntry, property, node) {
  var x1 = property.classification__Lamf_plugins_document_vocabularies_model_domain_PropertyClassification();
  var x = $m_Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$();
  if ((x === x1)) {
    this.parseDialectExtension__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__V(id, propertyEntry, property, node)
  } else {
    var x$3 = $m_Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$();
    if ((x$3 === x1)) {
      this.setLiteralValue__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__V(propertyEntry, property, node)
    } else {
      var x$5 = $m_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$();
      if ((x$5 === x1)) {
        this.parseLiteralCollectionProperty__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__V(id, propertyEntry, property, node)
      } else {
        var x$7 = $m_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$();
        if ((x$7 === x1)) {
          this.parseObjectProperty__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__sci_Map__V(id, propertyEntry, property, node, $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())))
        } else {
          var x$9 = $m_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$();
          if ((x$9 === x1)) {
            this.parseObjectCollectionProperty__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__sci_Map__V(id, propertyEntry, property, node, $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())))
          } else {
            var x$11 = $m_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$();
            if ((x$11 === x1)) {
              this.parseObjectMapProperty__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__sci_Map__V(id, propertyEntry, property, node, $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())))
            } else {
              var x$13 = $m_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$();
              if ((x$13 === x1)) {
                this.parseObjectPairProperty__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__V(id, propertyEntry, property, node)
              } else {
                var x$15 = $m_Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$();
                if ((x$15 === x1)) {
                  this.parseExternalLinkProperty__p1__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__V(id, propertyEntry, property, node)
                } else {
                  var this$1 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
                  var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
                  var message = ("Unknown type of node property " + property.id$1);
                  var prop = $m_s_None$();
                  var l = propertyEntry.location$1;
                  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, id, prop, message, l)
                }
              }
            }
          }
        }
      }
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.pathSegment__T__sci_List__T = (function(parent, nexts) {
  var elem$1 = null;
  elem$1 = parent;
  var these = nexts;
  while ((!these.isEmpty__Z())) {
    var arg1 = these.head__O();
    var n = $as_T(arg1);
    if ($m_sjsr_RuntimeString$().endsWith__T__T__Z($as_T(elem$1), "/")) {
      var jsx$1 = $as_T(elem$1);
      var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(n);
      var this$4 = this$3.platform$1;
      var url = this$3.str$1;
      elem$1 = (("" + jsx$1) + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
    } else {
      var jsx$2 = $as_T(elem$1);
      var this$6 = new $c_Lamf_core_utils_package$AmfStrings().init___T(n);
      var this$7 = this$6.platform$1;
      var url$1 = this$6.str$1;
      elem$1 = ((jsx$2 + "/") + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$7, url$1))
    };
    these = $as_sci_List(these.tail__O())
  };
  return $as_T(elem$1)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.primaryKeyNodeId__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YMap__sc_Seq__T__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__sci_Map__T = (function(node, nodeMap, path, defaultId, mapping, additionalProperties) {
  var allFound = new $c_sr_BooleanRef().init___Z(true);
  var elem = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var keyId = new $c_sr_ObjectRef().init___O(elem);
  mapping.primaryKey__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, nodeMap$1, keyId$1, additionalProperties$1, node$1, allFound$1) {
    return (function(key$2) {
      var key = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(key$2);
      var this$3 = $as_Lamf_core_model_StrField(key.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
      var this$4 = this$3.option$1;
      var propertyName = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
      var x1 = nodeMap$1.entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, propertyName$1) {
        return (function(x$28$2) {
          var x$28 = $as_Lorg_yaml_model_YMapEntry(x$28$2);
          var this$5 = x$28.key$2;
          var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
          var iv = $this$1.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
          return ($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv)).text$3 === propertyName$1)
        })
      })($this, propertyName)));
      matchEnd4: {
        if ((x1 instanceof $c_s_Some)) {
          var x2 = $as_s_Some(x1);
          var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
          if ($this.scalarYType__Lorg_yaml_model_YMapEntry__Z(entry)) {
            var jsx$3 = $as_sc_Seq(keyId$1.elem$1);
            var jsx$2 = $m_sc_Seq$();
            var array = [$as_Lorg_yaml_model_YScalar(entry.value$2.value__Lorg_yaml_model_YValue()).text$3];
            var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
            var this$8 = $m_sc_Seq$();
            keyId$1.elem$1 = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$8.ReusableCBFInstance$2));
            break matchEnd4
          }
        };
        var this$9 = $as_Lamf_core_model_StrField(key.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
        var this$10 = this$9.option$1;
        var x1$2 = additionalProperties$1.get__O__s_Option($as_T((this$10.isEmpty__Z() ? null : this$10.get__O())));
        if ((x1$2 instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(x1$2);
          var v = x2$2.value$2;
          var jsx$6 = $as_sc_Seq(keyId$1.elem$1);
          var jsx$5 = $m_sc_Seq$();
          var array$1 = [$objectToString(v)];
          var jsx$4 = jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
          var this$13 = $m_sc_Seq$();
          keyId$1.elem$1 = $as_sc_Seq(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$13.ReusableCBFInstance$2))
        } else {
          var this$14 = $this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
          var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
          var node$2 = node$1.id$1;
          var message = (("Cannot find unique mandatory property '" + propertyName) + "'");
          var prop = $m_s_None$();
          var l = nodeMap$1.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$14, specification, node$2, prop, message, l);
          allFound$1.elem$1 = false
        }
      }
    })
  })(this, nodeMap, keyId, additionalProperties, node, allFound)));
  if (allFound.elem$1) {
    var jsx$8 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(x$29$2) {
        var x$29 = $as_T(x$29$2);
        var this$16 = new $c_Lamf_core_utils_package$AmfStrings().init___T(x$29);
        var this$17 = this$16.platform$1;
        var url = this$16.str$1;
        return $f_Lamf_core_remote_JsPlatform__encodeURI__T__T(this$17, url)
      })
    })(this));
    var this$18 = $m_sc_Seq$();
    var jsx$7 = $as_sc_TraversableOnce(path.map__F1__scg_CanBuildFrom__O(jsx$8, this$18.ReusableCBFInstance$2)).mkString__T__T("/");
    var str = $as_sc_Seq(keyId.elem$1).mkString__T__T("_");
    var this$20 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
    var this$21 = this$20.platform$1;
    var url$1 = this$20.str$1;
    return ((jsx$7 + "/") + $f_Lamf_core_remote_JsPlatform__encodeURI__T__T(this$21, url$1))
  } else {
    return defaultId
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext()
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.parseLiteralValue__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__s_Option = (function(value, property, node) {
  var rc20 = false;
  var x2 = null;
  var rc21 = false;
  var x4 = null;
  var rc22 = false;
  var x7 = null;
  var rc23 = false;
  var x13 = null;
  var rc24 = false;
  var x15 = null;
  var x1 = value.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Bool$1;
  if ((x === x1)) {
    rc20 = true;
    x2 = x1;
    var this$1 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
    var this$2 = this$1.option$1;
    if (($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())) === $m_Lamf_core_model_DataType$().Boolean$1)) {
      var jsx$1 = true
    } else {
      var this$3 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
      var this$4 = this$3.option$1;
      var jsx$1 = ($as_T((this$4.isEmpty__Z() ? null : this$4.get__O())) === $m_Lamf_core_model_DataType$().Any$1)
    };
    if (jsx$1) {
      var conversion = $m_Lorg_yaml_convert_YRead$BooleanYRead$();
      var iv = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
      return new $c_s_Some().init___O($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(value, conversion, iv))
    }
  };
  if (rc20) {
    var this$7 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    var node$1 = node.id$1;
    var this$5 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
    var this$6 = this$5.option$1;
    var expected = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
    var found = $m_Lamf_core_model_DataType$().Boolean$1;
    $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__inconsistentPropertyRangeValueViolation__T__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__T__Lorg_yaml_model_YNode__V(this$7, node$1, property, expected, found, value);
    return $m_s_None$()
  };
  var x$3 = $m_Lorg_yaml_model_YType$().Int$1;
  if ((x$3 === x1)) {
    rc21 = true;
    x4 = x1;
    var this$8 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
    var this$9 = this$8.option$1;
    if (($as_T((this$9.isEmpty__Z() ? null : this$9.get__O())) === $m_Lamf_core_model_DataType$().Integer$1)) {
      var jsx$3 = true
    } else {
      var this$10 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
      var this$11 = this$10.option$1;
      var jsx$3 = ($as_T((this$11.isEmpty__Z() ? null : this$11.get__O())) === $m_Lamf_core_model_DataType$().Number$1)
    };
    if (jsx$3) {
      var jsx$2 = true
    } else {
      var this$12 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
      var this$13 = this$12.option$1;
      var jsx$2 = ($as_T((this$13.isEmpty__Z() ? null : this$13.get__O())) === $m_Lamf_core_model_DataType$().Any$1)
    };
    if (jsx$2) {
      var conversion$1 = $m_Lorg_yaml_convert_YRead$IntYRead$();
      var iv$1 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
      return new $c_s_Some().init___O($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(value, conversion$1, iv$1))
    }
  };
  if (rc21) {
    var this$14 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
    var this$15 = this$14.option$1;
    if (($as_T((this$15.isEmpty__Z() ? null : this$15.get__O())) === $m_Lamf_core_model_DataType$().Float$1)) {
      var jsx$4 = true
    } else {
      var this$16 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
      var this$17 = this$16.option$1;
      var jsx$4 = ($as_T((this$17.isEmpty__Z() ? null : this$17.get__O())) === $m_Lamf_core_model_DataType$().Double$1)
    }
  } else {
    var jsx$4 = false
  };
  if (jsx$4) {
    var conversion$2 = $m_Lorg_yaml_convert_YRead$DoubleYRead$();
    var iv$2 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    return new $c_s_Some().init___O($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(value, conversion$2, iv$2))
  };
  if (rc21) {
    var this$20 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    var node$2 = node.id$1;
    var this$18 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
    var this$19 = this$18.option$1;
    var expected$1 = $as_T((this$19.isEmpty__Z() ? null : this$19.get__O()));
    var found$1 = $m_Lamf_core_model_DataType$().Integer$1;
    $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__inconsistentPropertyRangeValueViolation__T__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__T__Lorg_yaml_model_YNode__V(this$20, node$2, property, expected$1, found$1, value);
    return $m_s_None$()
  };
  var x$5 = $m_Lorg_yaml_model_YType$().Str$1;
  if ((x$5 === x1)) {
    rc22 = true;
    x7 = x1;
    var this$21 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
    var this$22 = this$21.option$1;
    if (($as_T((this$22.isEmpty__Z() ? null : this$22.get__O())) === $m_Lamf_core_model_DataType$().String$1)) {
      var jsx$5 = true
    } else {
      var this$23 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
      var this$24 = this$23.option$1;
      var jsx$5 = ($as_T((this$24.isEmpty__Z() ? null : this$24.get__O())) === $m_Lamf_core_model_DataType$().Any$1)
    };
    if (jsx$5) {
      var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$3 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
      return new $c_s_Some().init___O($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(value, conversion$3, iv$3)).text$3)
    }
  };
  if (rc22) {
    var this$25 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
    var this$26 = this$25.option$1;
    var jsx$6 = ($as_T((this$26.isEmpty__Z() ? null : this$26.get__O())) === $m_Lamf_core_model_DataType$().AnyUri$1)
  } else {
    var jsx$6 = false
  };
  if (jsx$6) {
    var conversion$4 = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv$4 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    return new $c_s_Some().init___O($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(value, conversion$4, iv$4)).text$3)
  };
  if (rc22) {
    var this$27 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
    var this$28 = this$27.option$1;
    var jsx$8 = $as_T((this$28.isEmpty__Z() ? null : this$28.get__O()));
    var this$29 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    var jsx$7 = (jsx$8 === new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$29, "link").iri__T())
  } else {
    var jsx$7 = false
  };
  if (jsx$7) {
    var conversion$5 = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv$5 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    return new $c_s_Some().init___O(new $c_T2().init___O__O("link", $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(value, conversion$5, iv$5)).text$3))
  };
  if (rc22) {
    var this$31 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
    var this$32 = this$31.option$1;
    if (($as_T((this$32.isEmpty__Z() ? null : this$32.get__O())) === $m_Lamf_core_model_DataType$().Time$1)) {
      var jsx$10 = true
    } else {
      var this$33 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
      var this$34 = this$33.option$1;
      var jsx$10 = ($as_T((this$34.isEmpty__Z() ? null : this$34.get__O())) === $m_Lamf_core_model_DataType$().Date$1)
    };
    if (jsx$10) {
      var jsx$9 = true
    } else {
      var this$35 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
      var this$36 = this$35.option$1;
      var jsx$9 = ($as_T((this$36.isEmpty__Z() ? null : this$36.get__O())) === $m_Lamf_core_model_DataType$().DateTime$1)
    }
  } else {
    var jsx$9 = false
  };
  if (jsx$9) {
    var this$37 = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(value.value__Lorg_yaml_model_YValue(), $m_Lorg_yaml_model_YType$().Timestamp$1);
    var conversion$6 = $m_Lorg_yaml_convert_YRead$DTYRead$();
    var iv$6 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    return new $c_s_Some().init___O($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$37, conversion$6, iv$6))
  };
  if (rc22) {
    var this$38 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
    var this$39 = this$38.option$1;
    var jsx$12 = $as_T((this$39.isEmpty__Z() ? null : this$39.get__O()));
    var this$40 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    var jsx$11 = (jsx$12 === new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$40, "guid").iri__T())
  } else {
    var jsx$11 = false
  };
  if (jsx$11) {
    var conversion$7 = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv$7 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    return new $c_s_Some().init___O($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(value, conversion$7, iv$7)).text$3)
  };
  if (rc22) {
    var this$44 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    var node$3 = node.id$1;
    var this$42 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
    var this$43 = this$42.option$1;
    var expected$2 = $as_T((this$43.isEmpty__Z() ? null : this$43.get__O()));
    var found$2 = $m_Lamf_core_model_DataType$().String$1;
    $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__inconsistentPropertyRangeValueViolation__T__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__T__Lorg_yaml_model_YNode__V(this$44, node$3, property, expected$2, found$2, value);
    return $m_s_None$()
  };
  var x$7 = $m_Lorg_yaml_model_YType$().Float$1;
  if ((x$7 === x1)) {
    rc23 = true;
    x13 = x1;
    var this$45 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
    var this$46 = this$45.option$1;
    if (($as_T((this$46.isEmpty__Z() ? null : this$46.get__O())) === $m_Lamf_core_model_DataType$().Float$1)) {
      var jsx$15 = true
    } else {
      var this$47 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
      var this$48 = this$47.option$1;
      var jsx$15 = ($as_T((this$48.isEmpty__Z() ? null : this$48.get__O())) === $m_Lamf_core_model_DataType$().Number$1)
    };
    if (jsx$15) {
      var jsx$14 = true
    } else {
      var this$49 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
      var this$50 = this$49.option$1;
      var jsx$14 = ($as_T((this$50.isEmpty__Z() ? null : this$50.get__O())) === $m_Lamf_core_model_DataType$().Double$1)
    };
    if (jsx$14) {
      var jsx$13 = true
    } else {
      var this$51 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
      var this$52 = this$51.option$1;
      var jsx$13 = ($as_T((this$52.isEmpty__Z() ? null : this$52.get__O())) === $m_Lamf_core_model_DataType$().Any$1)
    };
    if (jsx$13) {
      var conversion$8 = $m_Lorg_yaml_convert_YRead$DoubleYRead$();
      var iv$8 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
      return new $c_s_Some().init___O($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(value, conversion$8, iv$8))
    }
  };
  if (rc23) {
    var this$55 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    var node$4 = node.id$1;
    var this$53 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
    var this$54 = this$53.option$1;
    var expected$3 = $as_T((this$54.isEmpty__Z() ? null : this$54.get__O()));
    var found$3 = $m_Lamf_core_model_DataType$().Float$1;
    $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__inconsistentPropertyRangeValueViolation__T__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__T__Lorg_yaml_model_YNode__V(this$55, node$4, property, expected$3, found$3, value);
    return $m_s_None$()
  };
  var x$9 = $m_Lorg_yaml_model_YType$().Timestamp$1;
  if ((x$9 === x1)) {
    rc24 = true;
    x15 = x1;
    var this$56 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
    var this$57 = this$56.option$1;
    if (($as_T((this$57.isEmpty__Z() ? null : this$57.get__O())) === $m_Lamf_core_model_DataType$().Time$1)) {
      var jsx$18 = true
    } else {
      var this$58 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
      var this$59 = this$58.option$1;
      var jsx$18 = ($as_T((this$59.isEmpty__Z() ? null : this$59.get__O())) === $m_Lamf_core_model_DataType$().Date$1)
    };
    if (jsx$18) {
      var jsx$17 = true
    } else {
      var this$60 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
      var this$61 = this$60.option$1;
      var jsx$17 = ($as_T((this$61.isEmpty__Z() ? null : this$61.get__O())) === $m_Lamf_core_model_DataType$().DateTime$1)
    };
    if (jsx$17) {
      var jsx$16 = true
    } else {
      var this$62 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
      var this$63 = this$62.option$1;
      var jsx$16 = ($as_T((this$63.isEmpty__Z() ? null : this$63.get__O())) === $m_Lamf_core_model_DataType$().Any$1)
    };
    if (jsx$16) {
      var conversion$9 = $m_Lorg_yaml_convert_YRead$DTYRead$();
      var iv$9 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
      return new $c_s_Some().init___O($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(value, conversion$9, iv$9))
    }
  };
  if (rc24) {
    var this$64 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
    var this$65 = this$64.option$1;
    var jsx$19 = ($as_T((this$65.isEmpty__Z() ? null : this$65.get__O())) === $m_Lamf_core_model_DataType$().String$1)
  } else {
    var jsx$19 = false
  };
  if (jsx$19) {
    var conversion$10 = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv$10 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    return new $c_s_Some().init___O($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(value, conversion$10, iv$10)).text$3)
  };
  if (rc24) {
    var this$68 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    var node$5 = node.id$1;
    var this$66 = $as_Lamf_core_model_StrField(property.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
    var this$67 = this$66.option$1;
    var expected$4 = $as_T((this$67.isEmpty__Z() ? null : this$67.get__O()));
    var found$4 = $m_Lamf_core_model_DataType$().DateTime$1;
    $f_Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter__inconsistentPropertyRangeValueViolation__T__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__T__Lorg_yaml_model_YNode__V(this$68, node$5, property, expected$4, found$4, value);
    var conversion$11 = $m_Lorg_yaml_convert_YRead$StringYRead$();
    var iv$11 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    return new $c_s_Some().init___O($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(value, conversion$11, iv$11))
  };
  var x$11 = $m_Lorg_yaml_model_YType$().Null$1;
  if ((x$11 === x1)) {
    return $m_s_None$()
  };
  var this$69 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
  var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
  var node$6 = node.id$1;
  var message = ("Unsupported scalar type " + value.tag__Lorg_yaml_model_YTag().tagType$3);
  var prop = $m_s_None$();
  var l = value.location$1;
  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$69, specification, node$6, prop, message, l);
  var conversion$12 = $m_Lorg_yaml_convert_YRead$StringYRead$();
  var iv$12 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
  return new $c_s_Some().init___O($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(value, conversion$12, iv$12))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.dispatchNodeMap__Lorg_yaml_model_YMap__T = (function(nodeMap) {
  return (new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(nodeMap).key__T__s_Option("$include").isDefined__Z() ? "$include" : (new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(nodeMap).key__T__s_Option("$ref").isDefined__Z() ? "$ref" : "inline"))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.findCompatibleMapping__T__sc_Seq__sci_Map__s_Option__Lorg_yaml_model_YMap__sc_Seq__sc_Seq = (function(id, unionMappings, discriminatorMapping, discriminator, nodeMap, mapProperties) {
  if ((discriminator instanceof $c_s_Some)) {
    var x2 = $as_s_Some(discriminator);
    var propertyName = $as_T(x2.value$2);
    var this$2 = nodeMap.entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, propertyName$1) {
      return (function(x$10$2) {
        var x$10 = $as_Lorg_yaml_model_YMapEntry(x$10$2);
        var this$1 = x$10.key$2;
        var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
        var iv = $this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
        return ($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3 === propertyName$1)
      })
    })(this, propertyName)));
    if (this$2.isEmpty__Z()) {
      var explicitMapping = $m_s_None$()
    } else {
      var arg1 = this$2.get__O();
      var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
      var this$3 = entry.value$2;
      var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$1 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
      var explicitMapping = discriminatorMapping.get__O__s_Option($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion$1, iv$1)).text$3)
    };
    if ((explicitMapping instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(explicitMapping);
      var nodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x2$2.value$2);
      var jsx$1 = $m_sc_Seq$();
      var array = [nodeMapping];
      return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
    } else {
      var x = $m_s_None$();
      if ((x === explicitMapping)) {
        var this$6 = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().eh$1;
        var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
        var message = (("Cannot find discriminator value for discriminator '" + propertyName) + "'");
        var prop = $m_s_None$();
        var l = nodeMap.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$6, specification, id, prop, message, l);
        return $m_sci_Nil$()
      } else {
        throw new $c_s_MatchError().init___O(explicitMapping)
      }
    }
  } else {
    var x$3 = $m_s_None$();
    if ((x$3 === discriminator)) {
      var jsx$3 = nodeMap.entries$3;
      var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
        return (function(x$11$2) {
          var x$11 = $as_Lorg_yaml_model_YMapEntry(x$11$2);
          var this$7 = x$11.key$2;
          var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
          var iv$2 = this$3$1.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
          return $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$7, conversion$2, iv$2)).text$3
        })
      })(this));
      var this$8 = $m_sc_IndexedSeq$();
      var properties = $as_sc_TraversableOnce(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$8.ReusableCBF$6)).toSet__sci_Set();
      return $as_sc_Seq(unionMappings.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, mapProperties$1, properties$1) {
        return (function(mapping$2) {
          var mapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(mapping$2);
          var baseProperties = $as_sc_Seq($as_sc_Seq(mapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, mapProperties$1$1) {
            return (function(pm$2) {
              var pm = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(pm$2);
              var this$9 = $as_Lamf_core_model_StrField(pm.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
              var this$10 = this$9.option$1;
              return (!mapProperties$1$1.contains__O__Z($as_T((this$10.isEmpty__Z() ? null : this$10.get__O()))))
            })
          })(this$4$1, mapProperties$1))));
          var jsx$5 = $as_sc_TraversableLike(baseProperties.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
            return (function(x$12$2) {
              var x$12 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$12$2);
              var this$11 = $as_Lamf_core_model_IntField(x$12.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MinCount$1));
              return ($f_Lamf_core_model_IntField__value__I(this$11) > 0)
            })
          })(this$4$1))));
          var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$2) {
            return (function(x$13$2) {
              var x$13 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$13$2);
              var this$12 = $as_Lamf_core_model_StrField(x$13.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
              var this$13 = this$12.option$1;
              return $as_T((this$13.isEmpty__Z() ? null : this$13.get__O()))
            })
          })(this$4$1));
          var this$14 = $m_sc_Seq$();
          var mappingRequiredSet = $as_sc_TraversableOnce(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$4, this$14.ReusableCBFInstance$2)).toSet__sci_Set();
          var jsx$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$2) {
            return (function(x$14$2) {
              var x$14 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$14$2);
              var this$15 = $as_Lamf_core_model_StrField(x$14.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
              var this$16 = this$15.option$1;
              return $as_T((this$16.isEmpty__Z() ? null : this$16.get__O()))
            })
          })(this$4$1));
          var this$17 = $m_sc_Seq$();
          var mappingSet = $as_sc_TraversableOnce(baseProperties.map__F1__scg_CanBuildFrom__O(jsx$6, this$17.ReusableCBFInstance$2)).toSet__sci_Set();
          return (properties$1.diff__sc_GenSet__sc_Set(mappingSet).isEmpty__Z() && mappingRequiredSet.diff__sc_GenSet__sc_Set(properties$1).isEmpty__Z())
        })
      })(this, mapProperties, properties))))
    } else {
      throw new $c_s_MatchError().init___O(discriminator)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.parseObjectCollectionProperty__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__sci_Map__V = (function(id, propertyEntry, property, node, additionalProperties) {
  var idsMap = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var this$1 = propertyEntry.value$2;
  var x1 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Seq$1;
  if ((x === x1)) {
    var this$2 = propertyEntry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
    var iv = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
    var entries = $as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv)).nodes$3
  } else {
    var jsx$1 = $m_sc_Seq$();
    var array = [propertyEntry.value$2];
    var entries = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  };
  var this$5 = $m_sc_Seq$();
  var jsx$3 = $as_sc_TraversableLike(entries.zipWithIndex__scg_CanBuildFrom__O(this$5.ReusableCBFInstance$2));
  var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, propertyEntry$1, id$1, property$1, additionalProperties$1, idsMap$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var elementNode = $as_Lorg_yaml_model_YNode(x0$1.$$und1__O());
        var nextElem = x0$1.$$und2$mcI$sp__I();
        $m_sci_List$();
        var this$6 = propertyEntry$1.key$2;
        var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
        var iv$1 = $this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
        var array$1 = [$as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion$1, iv$1)).text$3, ("" + nextElem)];
        var i = (((-1) + $uI(array$1.length)) | 0);
        var result = $m_sci_Nil$();
        while ((i >= 0)) {
          var this$11 = result;
          var index = i;
          var x$1 = array$1[index];
          result = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$11);
          i = (((-1) + i) | 0)
        };
        var path = result;
        var nestedObjectId = $this.pathSegment__T__sci_List__T(id$1, path);
        var x1$2 = property$1.nodesInRange__sc_Seq();
        if ((x1$2 !== null)) {
          if ((x1$2.size__I() > 1)) {
            var this$12 = $this.parseObjectUnion__T__sc_Seq__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__sci_Map__s_Option(nestedObjectId, path, elementNode, property$1, additionalProperties$1);
            if (this$12.isEmpty__Z()) {
              return $m_s_None$()
            } else {
              var arg1 = this$12.get__O();
              var parsed = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(arg1);
              $this.checkDuplicated__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YNode__scm_Map__V(parsed, elementNode, idsMap$1);
              return new $c_s_Some().init___O(parsed)
            }
          }
        };
        if ((x1$2 !== null)) {
          if ((x1$2.size__I() === 1)) {
            var this$13 = $this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().dialect$2;
            var x1$3 = $as_sc_Seq(this$13.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Declares$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, x3) {
              return (function(x$23$2) {
                var x$23 = $as_Lamf_core_model_domain_DomainElement(x$23$2);
                return (x$23.id__T() === x3.head__O())
              })
            })($this, x1$2)));
            if ((x1$3 instanceof $c_s_Some)) {
              var x2$2 = $as_s_Some(x1$3);
              var nodeMapping = $as_Lamf_core_model_domain_DomainElement(x2$2.value$2);
              if ($is_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(nodeMapping)) {
                var x3$2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(nodeMapping);
                var x1$4 = $this.parseNestedNode__T__T__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__sci_Map__s_Option(id$1, nestedObjectId, elementNode, x3$2, additionalProperties$1);
                if ((x1$4 instanceof $c_s_Some)) {
                  var x2$3 = $as_s_Some(x1$4);
                  var dialectDomainElement = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2$3.value$2);
                  $this.checkDuplicated__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YNode__scm_Map__V(dialectDomainElement, elementNode, idsMap$1);
                  return new $c_s_Some().init___O(dialectDomainElement)
                } else {
                  var x$2 = $m_s_None$();
                  if ((x$2 === x1$4)) {
                    return $m_s_None$()
                  } else {
                    throw new $c_s_MatchError().init___O(x1$4)
                  }
                }
              }
            };
            return $m_s_None$()
          }
        };
        return $m_s_None$()
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, propertyEntry, id, property, additionalProperties, idsMap));
  var this$14 = $m_sc_Seq$();
  var res = $as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$14.ReusableCBFInstance$2));
  var jsx$4 = new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$6().init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser(this);
  var this$15 = $m_sc_Seq$();
  var elems = $as_sc_Seq(res.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$4, this$15.ReusableCBFInstance$2));
  node.setObjectField__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__sc_Seq__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(property, elems, propertyEntry.value$2)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.finalTemplateId__T__sc_Seq__T = (function(template, path) {
  var templateRoot = this.root$1.location$1;
  if (($uI(template.indexOf("://")) !== (-1))) {
    return template
  } else if ((($uI(template.length) >= 0) && ($as_T(template.substring(0, $uI("/".length))) === "/"))) {
    return ((templateRoot + "#") + template)
  } else if ((($uI(template.length) >= 0) && ($as_T(template.substring(0, $uI("#".length))) === "#"))) {
    return (("" + templateRoot) + template)
  } else {
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(template, "/", 0);
    var jsx$1 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    var this$16 = $m_sc_Seq$();
    var pathLocation = $as_sc_TraversableOnce(path.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$16.ReusableCBFInstance$2)).mkString__T__T("/");
    return (((($uI(pathLocation.length) >= 0) && ($as_T(pathLocation.substring(0, $uI(templateRoot.length))) === templateRoot)) || ($uI(pathLocation.indexOf("#")) !== (-1))) ? pathLocation : ((templateRoot + "#") + pathLocation))
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.parseObjectMapProperty__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__sci_Map__V = (function(id, propertyEntry, property, node, additionalProperties) {
  var this$1 = propertyEntry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
  var jsx$3 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).entries$3;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, propertyEntry$1, id$1, property$1, additionalProperties$1) {
    return (function(keyEntry$2) {
      var keyEntry = $as_Lorg_yaml_model_YMapEntry(keyEntry$2);
      $m_sci_List$();
      var this$2 = propertyEntry$1.key$2;
      var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$1 = $this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
      var jsx$2 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$1, iv$1)).text$3;
      var this$3 = keyEntry.key$2;
      var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$2 = $this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext();
      var array = [jsx$2, $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion$2, iv$2)).text$3];
      var i = (((-1) + $uI(array.length)) | 0);
      var result = $m_sci_Nil$();
      while ((i >= 0)) {
        var this$7 = result;
        var index = i;
        var x = array[index];
        result = new $c_sci_$colon$colon().init___O__sci_List(x, this$7);
        i = (((-1) + i) | 0)
      };
      var path = result;
      var nestedObjectId = $this.pathSegment__T__sci_List__T(id$1, path);
      var x1 = $this.findHashProperties__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lorg_yaml_model_YMapEntry__s_Option(property$1, keyEntry);
      matchEnd5: {
        var keyAdditionalProperties;
        if ((x1 instanceof $c_s_Some)) {
          var x2 = $as_s_Some(x1);
          var p3 = $as_T2(x2.value$2);
          if ((p3 !== null)) {
            var k = $as_T(p3.$$und1__O());
            var v = p3.$$und2__O();
            var keyAdditionalProperties = additionalProperties$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(k, v));
            break matchEnd5
          }
        };
        var keyAdditionalProperties = additionalProperties$1
      };
      var x1$2 = property$1.nodesInRange__sc_Seq();
      matchEnd5$2: {
        var parsedNode;
        if ((x1$2 !== null)) {
          if ((x1$2.size__I() > 1)) {
            var x1$3 = $as_Lamf_core_model_StrField(property$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermValueProperty$1)).option$1;
            if ((x1$3 instanceof $c_s_Some)) {
              var x2$3 = $as_s_Some(x1$3);
              var mapValueProperty = $as_T(x2$3.value$2);
              var keyValueAdditionalProperties = keyAdditionalProperties.$$plus__T2__sci_Map(new $c_T2().init___O__O(mapValueProperty, ""))
            } else {
              var keyValueAdditionalProperties = keyAdditionalProperties
            };
            var parsedNode = $this.parseObjectUnion__T__sc_Seq__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__sci_Map__s_Option(nestedObjectId, path, keyEntry.value$2, property$1, keyValueAdditionalProperties);
            break matchEnd5$2
          }
        };
        if ((x1$2 !== null)) {
          if ((x1$2.size__I() === 1)) {
            var this$12 = $this.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().dialect$2;
            var x1$4 = $as_sc_Seq(this$12.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Declares$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, x3) {
              return (function(x$21$2) {
                var x$21 = $as_Lamf_core_model_domain_DomainElement(x$21$2);
                return (x$21.id__T() === x3.head__O())
              })
            })($this, x1$2)));
            if ((x1$4 instanceof $c_s_Some)) {
              var x2$4 = $as_s_Some(x1$4);
              var nodeMapping = $as_Lamf_core_model_domain_DomainElement(x2$4.value$2);
              if ($is_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(nodeMapping)) {
                var x3$2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(nodeMapping);
                var this$13 = keyEntry.value$2;
                var x$1 = this$13.tag__Lorg_yaml_model_YTag().tagType$3;
                var x$2 = $m_Lorg_yaml_model_YType$().Null$1;
                if ((!(x$1 === x$2))) {
                  var parsedNode = $this.parseNestedNode__T__T__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__sci_Map__s_Option(id$1, nestedObjectId, keyEntry.value$2, x3$2, keyAdditionalProperties);
                  break matchEnd5$2
                }
              }
            };
            var parsedNode = $m_s_None$();
            break matchEnd5$2
          }
        };
        var parsedNode = $m_s_None$()
      };
      if ((parsedNode instanceof $c_s_Some)) {
        var x2$5 = $as_s_Some(parsedNode);
        var dialectDomainElement = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2$5.value$2);
        return new $c_s_Some().init___O($this.checkHashProperties__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(dialectDomainElement, property$1, keyEntry))
      } else {
        var x$3 = $m_s_None$();
        if ((x$3 === parsedNode)) {
          return $m_s_None$()
        } else {
          throw new $c_s_MatchError().init___O(parsedNode)
        }
      }
    })
  })(this, propertyEntry, id, property, additionalProperties));
  var this$14 = $m_sc_IndexedSeq$();
  var nested = $as_sc_IndexedSeq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$1, this$14.ReusableCBF$6));
  var jsx$4 = new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseObjectMapProperty$3().init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser(this);
  var this$15 = $m_sc_IndexedSeq$();
  node.setObjectField__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__sc_Seq__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(property, $as_sc_Seq(nested.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$4, this$15.ReusableCBF$6)), propertyEntry.value$2)
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceParser", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser: 1,
  O: 1,
  Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser: 1,
  Lamf_plugins_document_vocabularies_parser_instances_JsonPointerResolver: 1,
  Lamf_plugins_document_vocabularies_parser_instances_NodeMappableHelper: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_parser_BaseSpecParser: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$1.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$1.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$1.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var t = $as_T(x2.value$2);
    return t
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$1.prototype.init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$1.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  return (x1 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$1: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceParser$$anonfun$1", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$2.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$2;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$2.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$2.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$2.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var e = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2.value$2);
    return e
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$2.prototype.init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$2.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  return (x1 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$2 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$2: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceParser$$anonfun$2", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$2.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$2;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$3() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$3.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$3.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$3;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$3() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$3.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$3.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$3.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var mapping = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    if ((mapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
      var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(mapping);
      return x3
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$3.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$3.prototype.init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$3.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$3.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var mapping = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    if ((mapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
      return true
    }
  };
  return false
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$3 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$3: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceParser$$anonfun$3", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$3: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$3.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$3;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$4() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$4.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$4.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$4;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$4() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$4.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$4.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$4.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var t = $as_T(x2.value$2);
    return t
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$4.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$4.prototype.init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$4.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$4.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  return (x1 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$4 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$4: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceParser$$anonfun$4", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$4: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$4.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$4;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$5() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$5.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$5.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$5;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$5() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$5.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$5.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$5.prototype.isDefinedAt__s_Some__Z = (function(x2) {
  if ((x2 !== null)) {
    var elem = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2.value$2);
    if ((elem !== null)) {
      return true
    }
  };
  return false
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$5.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Some__Z($as_s_Some(x))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$5.prototype.init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$5.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Some__F1__O($as_s_Some(x), $default)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$5.prototype.applyOrElse__s_Some__F1__O = (function(x2, $default) {
  if ((x2 !== null)) {
    var elem = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2.value$2);
    if ((elem !== null)) {
      return elem
    }
  };
  return $default.apply__O__O(x2)
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$5 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$5: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceParser$$anonfun$5", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$5: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$5.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$5;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$6() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$6.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$6.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$6;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$6() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$6.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$6.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$6.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var x = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2.value$2);
    if ((x !== null)) {
      return x
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$6.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$6.prototype.init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$6.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$6.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var x = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2.value$2);
    if ((x !== null)) {
      return true
    }
  };
  return false
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$6 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$6: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceParser$$anonfun$6", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$6: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$6.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$6;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$7() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$7.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$7.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$7;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$7() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$7.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$7.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$7.prototype.isDefinedAt__O__Z = (function(x1) {
  return (x1 instanceof $c_T2)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$7.prototype.init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$7.prototype.applyOrElse__O__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_T2)) {
    var x2 = $as_T2(x1);
    var link = x2.$$und2__O();
    return link
  } else {
    return $default.apply__O__O(x1)
  }
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$7 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$7: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceParser$$anonfun$7", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$7: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$7.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$7;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$8() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$8.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$8.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$8;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$8() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$8.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$8.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$8.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var x = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2.value$2);
    return x
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$8.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$8.prototype.init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$8.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$8.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  return (x1 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$8 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$8: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceParser$$anonfun$8", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$8: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$8.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$8;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$9() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$9.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$9.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$9;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$9() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$9.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$9.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$9.prototype.applyOrElse__s_Option__F1__O = (function(x2, $default) {
  if ((x2 instanceof $c_s_Some)) {
    var x2$2 = $as_s_Some(x2);
    var x = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2$2.value$2);
    return x
  } else {
    return $default.apply__O__O(x2)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$9.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$9.prototype.init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$9.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$9.prototype.isDefinedAt__s_Option__Z = (function(x2) {
  return (x2 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$9 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$9: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceParser$$anonfun$9", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$9: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$9.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$9;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$1.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$1.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$1.prototype.applyOrElse__s_Option__F1__O = (function(x2, $default) {
  if ((x2 instanceof $c_s_Some)) {
    var x2$2 = $as_s_Some(x2);
    var t = $as_T(x2$2.value$2);
    return t
  } else {
    return $default.apply__O__O(x2)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$1.prototype.init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$1.prototype.isDefinedAt__s_Option__Z = (function(x2) {
  return (x2 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$1: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceParser$$anonfun$generateExternalLink$1", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$3() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$3.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$3.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$3;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$3() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$3.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$3.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$3.prototype.applyOrElse__s_Option__F1__O = (function(x3, $default) {
  if ((x3 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x3);
    var t = $as_T(x2.value$2);
    return t
  } else {
    return $default.apply__O__O(x3)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$3.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$3.prototype.init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$3.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$3.prototype.isDefinedAt__s_Option__Z = (function(x3) {
  return (x3 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$3 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$3: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceParser$$anonfun$generateExternalLink$3", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$3: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$3.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$generateExternalLink$3;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseNode$7() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseNode$7.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseNode$7.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseNode$7;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseNode$7() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseNode$7.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseNode$7.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseNode$7.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var t = $as_T(x2.value$2);
    return t
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseNode$7.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseNode$7.prototype.init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseNode$7.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseNode$7.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  return (x1 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseNode$7 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseNode$7: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceParser$$anonfun$parseNode$7", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseNode$7: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseNode$7.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseNode$7;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseObjectMapProperty$3() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseObjectMapProperty$3.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseObjectMapProperty$3.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseObjectMapProperty$3;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseObjectMapProperty$3() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseObjectMapProperty$3.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseObjectMapProperty$3.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseObjectMapProperty$3.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var node = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2.value$2);
    if ((node !== null)) {
      return node
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseObjectMapProperty$3.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseObjectMapProperty$3.prototype.init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseObjectMapProperty$3.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseObjectMapProperty$3.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var node = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2.value$2);
    if ((node !== null)) {
      return true
    }
  };
  return false
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseObjectMapProperty$3 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseObjectMapProperty$3: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceParser$$anonfun$parseObjectMapProperty$3", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseObjectMapProperty$3: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseObjectMapProperty$3.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser$$anonfun$parseObjectMapProperty$3;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor$$anonfun$dialectForDoc$3() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor$$anonfun$dialectForDoc$3.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor$$anonfun$dialectForDoc$3.prototype.constructor = $c_Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor$$anonfun$dialectForDoc$3;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor$$anonfun$dialectForDoc$3() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor$$anonfun$dialectForDoc$3.prototype = $c_Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor$$anonfun$dialectForDoc$3.prototype;
$c_Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor$$anonfun$dialectForDoc$3.prototype.init___Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor$$anonfun$dialectForDoc$3.prototype.isDefinedAt__Lorg_yaml_model_YMapEntry__Z = (function(x1) {
  var this$1 = x1.key$2.asScalar__s_Option();
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var x$2 = $as_Lorg_yaml_model_YScalar(arg1);
    return (x$2.text$3 === "$dialect")
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor$$anonfun$dialectForDoc$3.prototype.applyOrElse__Lorg_yaml_model_YMapEntry__F1__O = (function(x1, $default) {
  var this$1 = x1.key$2.asScalar__s_Option();
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var x$2 = $as_Lorg_yaml_model_YScalar(arg1);
    var jsx$1 = (x$2.text$3 === "$dialect")
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return x1
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor$$anonfun$dialectForDoc$3.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lorg_yaml_model_YMapEntry__Z($as_Lorg_yaml_model_YMapEntry(x))
});
$c_Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor$$anonfun$dialectForDoc$3.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lorg_yaml_model_YMapEntry__F1__O($as_Lorg_yaml_model_YMapEntry(x), $default)
});
var $d_Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor$$anonfun$dialectForDoc$3 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor$$anonfun$dialectForDoc$3: 0
}, false, "amf.plugins.document.vocabularies.plugin.headers.JsonHeaderExtractor$$anonfun$dialectForDoc$3", {
  Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor$$anonfun$dialectForDoc$3: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor$$anonfun$dialectForDoc$3.prototype.$classData = $d_Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor$$anonfun$dialectForDoc$3;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor$$anonfun$containsVersion$3() {
  $c_sr_AbstractPartialFunction.call(this);
  this.d$1$2 = null
}
$c_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor$$anonfun$containsVersion$3.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor$$anonfun$containsVersion$3.prototype.constructor = $c_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor$$anonfun$containsVersion$3;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor$$anonfun$containsVersion$3() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor$$anonfun$containsVersion$3.prototype = $c_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor$$anonfun$containsVersion$3.prototype;
$c_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor$$anonfun$containsVersion$3.prototype.init___Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor__Lamf_plugins_document_vocabularies_model_document_Dialect = (function($$outer, d$1) {
  this.d$1$2 = d$1;
  return this
});
$c_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor$$anonfun$containsVersion$3.prototype.isDefinedAt__Lorg_yaml_model_YMapEntry__Z = (function(x1) {
  var this$1 = x1.key$2.asScalar__s_Option();
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var scalar = $as_Lorg_yaml_model_YScalar(arg1);
    var this$2 = this.d$1$2;
    var this$3 = $as_Lamf_core_model_StrField(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Name$1));
    var other = scalar.text$3;
    return $f_Lamf_core_model_ValueField__is__O__Z(this$3, other)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor$$anonfun$containsVersion$3.prototype.applyOrElse__Lorg_yaml_model_YMapEntry__F1__O = (function(x1, $default) {
  var this$1 = x1.key$2.asScalar__s_Option();
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var scalar = $as_Lorg_yaml_model_YScalar(arg1);
    var this$2 = this.d$1$2;
    var this$3 = $as_Lamf_core_model_StrField(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Name$1));
    var other = scalar.text$3;
    var jsx$1 = $f_Lamf_core_model_ValueField__is__O__Z(this$3, other)
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return x1
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor$$anonfun$containsVersion$3.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lorg_yaml_model_YMapEntry__Z($as_Lorg_yaml_model_YMapEntry(x))
});
$c_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor$$anonfun$containsVersion$3.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lorg_yaml_model_YMapEntry__F1__O($as_Lorg_yaml_model_YMapEntry(x), $default)
});
var $d_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor$$anonfun$containsVersion$3 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor$$anonfun$containsVersion$3: 0
}, false, "amf.plugins.document.vocabularies.plugin.headers.KeyPropertyHeaderExtractor$$anonfun$containsVersion$3", {
  Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor$$anonfun$containsVersion$3: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor$$anonfun$containsVersion$3.prototype.$classData = $d_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor$$anonfun$containsVersion$3;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$1.prototype = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$1.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$1.prototype.init___Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$1: 0
}, false, "amf.plugins.document.vocabularies.resolution.stages.DialectPatchApplicationStage$$anonfun$1", {
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$10() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$10.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$10.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$10;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$10() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$10.prototype = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$10.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$10.prototype.init___Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$10.prototype.applyOrElse__s_Option__F1__O = (function(x10, $default) {
  if ((x10 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x10);
    var pair = $as_T2(x2.value$2);
    return pair
  } else {
    return $default.apply__O__O(x10)
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$10.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$10.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$10.prototype.isDefinedAt__s_Option__Z = (function(x10) {
  return (x10 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$10 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$10: 0
}, false, "amf.plugins.document.vocabularies.resolution.stages.DialectPatchApplicationStage$$anonfun$10", {
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$10: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$10.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$10;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$2.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$2;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$2.prototype = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$2.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$2.prototype.init___Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$2.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x2) {
  return (x2 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$2.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x2, $default) {
  if ((x2 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
    var x2$2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2);
    return x2$2
  } else {
    return $default.apply__O__O(x2)
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$2 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$2: 0
}, false, "amf.plugins.document.vocabularies.resolution.stages.DialectPatchApplicationStage$$anonfun$2", {
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$2.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$2;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$3() {
  $c_sr_AbstractPartialFunction.call(this);
  this.$$outer$2 = null;
  this.targetPropertyValueIds$1$2 = null;
  this.patchLocation$1$2 = null
}
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$3.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$3.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$3;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$3() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$3.prototype = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$3.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$3.prototype.applyOrElse__T2__F1__O = (function(x3, $default) {
  if ((x3 !== null)) {
    var id = $as_T(x3.$$und1__O());
    var elem = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x3.$$und2__O());
    var jsx$1 = this.targetPropertyValueIds$1$2;
    var location = this.patchLocation$1$2;
    var x1$2 = jsx$1.get__O__s_Option($as_T(id.split(location).join("")));
    if ((x1$2 instanceof $c_s_Some)) {
      return $m_s_None$()
    } else {
      var x = $m_s_None$();
      if ((x === x1$2)) {
        return new $c_s_Some().init___O(elem)
      } else {
        throw new $c_s_MatchError().init___O(x1$2)
      }
    }
  } else {
    return $default.apply__O__O(x3)
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$3.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__T2__Z($as_T2(x))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$3.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__T2__F1__O($as_T2(x), $default)
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$3.prototype.init___Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage__sci_Map__T = (function($$outer, targetPropertyValueIds$1, patchLocation$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.targetPropertyValueIds$1$2 = targetPropertyValueIds$1;
  this.patchLocation$1$2 = patchLocation$1;
  return this
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$3.prototype.isDefinedAt__T2__Z = (function(x3) {
  return (x3 !== null)
});
var $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$3 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$3: 0
}, false, "amf.plugins.document.vocabularies.resolution.stages.DialectPatchApplicationStage$$anonfun$3", {
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$3: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$3.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$3;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$4() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$4.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$4.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$4;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$4() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$4.prototype = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$4.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$4.prototype.init___Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$4.prototype.applyOrElse__s_Option__F1__O = (function(x4, $default) {
  if ((x4 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x4);
    var elem = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2.value$2);
    return elem
  } else {
    return $default.apply__O__O(x4)
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$4.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$4.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$4.prototype.isDefinedAt__s_Option__Z = (function(x4) {
  return (x4 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$4 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$4: 0
}, false, "amf.plugins.document.vocabularies.resolution.stages.DialectPatchApplicationStage$$anonfun$4", {
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$4: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$4.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$4;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$5() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$5.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$5.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$5;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$5() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$5.prototype = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$5.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$5.prototype.init___Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$5.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x5) {
  return (x5 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$5.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x5, $default) {
  if ((x5 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x5);
    return x2
  } else {
    return $default.apply__O__O(x5)
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$5.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$5.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$5 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$5: 0
}, false, "amf.plugins.document.vocabularies.resolution.stages.DialectPatchApplicationStage$$anonfun$5", {
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$5: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$5.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$5;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$6() {
  $c_sr_AbstractPartialFunction.call(this);
  this.$$outer$2 = null;
  this.targetPropertyValueIds$1$2 = null;
  this.patchLocation$1$2 = null
}
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$6.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$6.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$6;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$6() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$6.prototype = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$6.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$6.prototype.applyOrElse__T2__F1__O = (function(x6, $default) {
  if ((x6 !== null)) {
    var id = $as_T(x6.$$und1__O());
    var jsx$1 = this.targetPropertyValueIds$1$2;
    var location = this.patchLocation$1$2;
    return jsx$1.get__O__s_Option($as_T(id.split(location).join("")))
  } else {
    return $default.apply__O__O(x6)
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$6.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__T2__Z($as_T2(x))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$6.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__T2__F1__O($as_T2(x), $default)
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$6.prototype.init___Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage__sci_Map__T = (function($$outer, targetPropertyValueIds$1, patchLocation$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.targetPropertyValueIds$1$2 = targetPropertyValueIds$1;
  this.patchLocation$1$2 = patchLocation$1;
  return this
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$6.prototype.isDefinedAt__T2__Z = (function(x6) {
  return (x6 !== null)
});
var $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$6 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$6: 0
}, false, "amf.plugins.document.vocabularies.resolution.stages.DialectPatchApplicationStage$$anonfun$6", {
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$6: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$6.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$6;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$7() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$7.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$7.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$7;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$7() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$7.prototype = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$7.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$7.prototype.init___Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$7.prototype.applyOrElse__s_Option__F1__O = (function(x7, $default) {
  if ((x7 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x7);
    var elem = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2.value$2);
    return elem
  } else {
    return $default.apply__O__O(x7)
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$7.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$7.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$7.prototype.isDefinedAt__s_Option__Z = (function(x7) {
  return (x7 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$7 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$7: 0
}, false, "amf.plugins.document.vocabularies.resolution.stages.DialectPatchApplicationStage$$anonfun$7", {
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$7: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$7.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$7;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$8() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$8.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$8.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$8;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$8() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$8.prototype = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$8.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$8.prototype.init___Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$8.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x8) {
  return (x8 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$8.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x8, $default) {
  if ((x8 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x8);
    return x2
  } else {
    return $default.apply__O__O(x8)
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$8.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$8.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$8 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$8: 0
}, false, "amf.plugins.document.vocabularies.resolution.stages.DialectPatchApplicationStage$$anonfun$8", {
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$8: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$8.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$8;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$9() {
  $c_sr_AbstractPartialFunction.call(this);
  this.$$outer$2 = null;
  this.targetPropertyValueIds$1$2 = null;
  this.patchLocation$1$2 = null
}
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$9.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$9.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$9;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$9() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$9.prototype = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$9.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$9.prototype.applyOrElse__T2__F1__O = (function(x9, $default) {
  if ((x9 !== null)) {
    var id = $as_T(x9.$$und1__O());
    var elem = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x9.$$und2__O());
    var jsx$1 = this.targetPropertyValueIds$1$2;
    var location = this.patchLocation$1$2;
    var x1$2 = jsx$1.get__O__s_Option($as_T(id.split(location).join("")));
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var targetElem = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2.value$2);
      return new $c_s_Some().init___O(new $c_T2().init___O__O(targetElem, elem))
    } else {
      var x = $m_s_None$();
      if ((x === x1$2)) {
        return $m_s_None$()
      } else {
        throw new $c_s_MatchError().init___O(x1$2)
      }
    }
  } else {
    return $default.apply__O__O(x9)
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$9.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__T2__Z($as_T2(x))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$9.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__T2__F1__O($as_T2(x), $default)
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$9.prototype.init___Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage__sci_Map__T = (function($$outer, targetPropertyValueIds$1, patchLocation$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.targetPropertyValueIds$1$2 = targetPropertyValueIds$1;
  this.patchLocation$1$2 = patchLocation$1;
  return this
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$9.prototype.isDefinedAt__T2__Z = (function(x9) {
  return (x9 !== null)
});
var $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$9 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$9: 0
}, false, "amf.plugins.document.vocabularies.resolution.stages.DialectPatchApplicationStage$$anonfun$9", {
  Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$9: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$9.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectPatchApplicationStage$$anonfun$9;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$$nestedInanonfun$findVocabularies$1$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$$nestedInanonfun$findVocabularies$1$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$$nestedInanonfun$findVocabularies$1$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$$nestedInanonfun$findVocabularies$1$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$$nestedInanonfun$findVocabularies$1$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$$nestedInanonfun$findVocabularies$1$1.prototype = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$$nestedInanonfun$findVocabularies$1$1.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$$nestedInanonfun$findVocabularies$1$1.prototype.init___Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$$nestedInanonfun$findVocabularies$1$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_document_BaseUnit__Z($as_Lamf_core_model_document_BaseUnit(x))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$$nestedInanonfun$findVocabularies$1$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O($as_Lamf_core_model_document_BaseUnit(x), $default)
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$$nestedInanonfun$findVocabularies$1$1.prototype.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_document_Vocabulary(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$$nestedInanonfun$findVocabularies$1$1.prototype.isDefinedAt__Lamf_core_model_document_BaseUnit__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary)
});
var $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$$nestedInanonfun$findVocabularies$1$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$$nestedInanonfun$findVocabularies$1$1: 0
}, false, "amf.plugins.document.vocabularies.resolution.stages.DialectReferencesResolutionStage$$anonfun$$nestedInanonfun$findVocabularies$1$1", {
  Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$$nestedInanonfun$findVocabularies$1$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$$nestedInanonfun$findVocabularies$1$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$$nestedInanonfun$findVocabularies$1$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$1.prototype = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$1.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$1.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ($is_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$1.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return $is_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1)
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$1.prototype.init___Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$1: 0
}, false, "amf.plugins.document.vocabularies.resolution.stages.DialectReferencesResolutionStage$$anonfun$1", {
  Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$2.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$2;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$2.prototype = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$2.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$2.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var x = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x2.value$2);
    return x
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$2.prototype.init___Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$2.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  return (x1 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$2 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$2: 0
}, false, "amf.plugins.document.vocabularies.resolution.stages.DialectReferencesResolutionStage$$anonfun$2", {
  Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$2.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$2;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$3() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$3.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$3.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$3;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$3() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$3.prototype = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$3.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$3.prototype.applyOrElse__s_Option__F1__O = (function(x2, $default) {
  if ((x2 instanceof $c_s_Some)) {
    var x2$2 = $as_s_Some(x2);
    var x = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x2$2.value$2);
    return x
  } else {
    return $default.apply__O__O(x2)
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$3.prototype.init___Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$3.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$3.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$3.prototype.isDefinedAt__s_Option__Z = (function(x2) {
  return (x2 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$3 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$3: 0
}, false, "amf.plugins.document.vocabularies.resolution.stages.DialectReferencesResolutionStage$$anonfun$3", {
  Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$3: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$3.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$3;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findDeclarations$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findDeclarations$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findDeclarations$2.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findDeclarations$2;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findDeclarations$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findDeclarations$2.prototype = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findDeclarations$2.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findDeclarations$2.prototype.init___Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findDeclarations$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_document_BaseUnit__Z($as_Lamf_core_model_document_BaseUnit(x))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findDeclarations$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O($as_Lamf_core_model_document_BaseUnit(x), $default)
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findDeclarations$2.prototype.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O = (function(x2, $default) {
  return ($is_Lamf_core_model_document_DeclaresModel(x2) ? x2 : $default.apply__O__O(x2))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findDeclarations$2.prototype.isDefinedAt__Lamf_core_model_document_BaseUnit__Z = (function(x2) {
  return $is_Lamf_core_model_document_DeclaresModel(x2)
});
var $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findDeclarations$2 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findDeclarations$2: 0
}, false, "amf.plugins.document.vocabularies.resolution.stages.DialectReferencesResolutionStage$$anonfun$findDeclarations$2", {
  Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findDeclarations$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findDeclarations$2.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findDeclarations$2;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findVocabularies$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findVocabularies$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findVocabularies$2.prototype.constructor = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findVocabularies$2;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findVocabularies$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findVocabularies$2.prototype = $c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findVocabularies$2.prototype;
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findVocabularies$2.prototype.init___Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findVocabularies$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_document_BaseUnit__Z($as_Lamf_core_model_document_BaseUnit(x))
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findVocabularies$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O($as_Lamf_core_model_document_BaseUnit(x), $default)
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findVocabularies$2.prototype.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O = (function(x2, $default) {
  if ((x2 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary)) {
    var x2$2 = $as_Lamf_plugins_document_vocabularies_model_document_DialectLibrary(x2);
    return x2$2
  } else {
    return $default.apply__O__O(x2)
  }
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findVocabularies$2.prototype.isDefinedAt__Lamf_core_model_document_BaseUnit__Z = (function(x2) {
  return (x2 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary)
});
var $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findVocabularies$2 = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findVocabularies$2: 0
}, false, "amf.plugins.document.vocabularies.resolution.stages.DialectReferencesResolutionStage$$anonfun$findVocabularies$2", {
  Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findVocabularies$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findVocabularies$2.prototype.$classData = $d_Lamf_plugins_document_vocabularies_resolution_stages_DialectReferencesResolutionStage$$anonfun$findVocabularies$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin$() {
  $c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.call(this)
}
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin$.prototype = new $h_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin();
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin$.prototype.constructor = $c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin$.prototype = $c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin$.prototype;
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin.prototype.init___.call(this);
  return this
});
var $d_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin$: 0
}, false, "amf.plugins.document.webapi.ExternalJsonYamlRefsPlugin$", {
  Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin$: 1,
  Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin: 1,
  Lamf_plugins_document_webapi_JsonSchemaPlugin: 1,
  Lamf_client_plugins_AMFDocumentPlugin: 1,
  O: 1,
  Lamf_client_plugins_AMFPlugin: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin$.prototype.$classData = $d_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin$;
var $n_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin$ = (void 0);
function $m_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin$() {
  if ((!$n_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin$)) {
    $n_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin$ = new $c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin$().init___()
  };
  return $n_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_JsonSchemaPlugin$$anonfun$firstAnyShape$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin$$anonfun$firstAnyShape$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin$$anonfun$firstAnyShape$1.prototype.constructor = $c_Lamf_plugins_document_webapi_JsonSchemaPlugin$$anonfun$firstAnyShape$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_JsonSchemaPlugin$$anonfun$firstAnyShape$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_JsonSchemaPlugin$$anonfun$firstAnyShape$1.prototype = $c_Lamf_plugins_document_webapi_JsonSchemaPlugin$$anonfun$firstAnyShape$1.prototype;
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin$$anonfun$firstAnyShape$1.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin$$anonfun$firstAnyShape$1.prototype.init___Lamf_plugins_document_webapi_JsonSchemaPlugin = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin$$anonfun$firstAnyShape$1.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin$$anonfun$firstAnyShape$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin$$anonfun$firstAnyShape$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_JsonSchemaPlugin$$anonfun$firstAnyShape$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_JsonSchemaPlugin$$anonfun$firstAnyShape$1: 0
}, false, "amf.plugins.document.webapi.JsonSchemaPlugin$$anonfun$firstAnyShape$1", {
  Lamf_plugins_document_webapi_JsonSchemaPlugin$$anonfun$firstAnyShape$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_JsonSchemaPlugin$$anonfun$firstAnyShape$1.prototype.$classData = $d_Lamf_plugins_document_webapi_JsonSchemaPlugin$$anonfun$firstAnyShape$1;
function $f_Lamf_plugins_document_webapi_OasLikePlugin__promoteFragments__Lamf_core_model_document_BaseUnit__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_core_model_document_BaseUnit($thiz, unit, ctx) {
  var elem = $as_sci_Map(unit.references__sc_Seq().foldLeft__O__F2__O($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(x0$1$2, x1$1$2) {
      var x0$1 = $as_sci_Map(x0$1$2);
      var x1$1 = $as_Lamf_core_model_document_BaseUnit(x1$1$2);
      var x1 = new $c_T2().init___O__O(x0$1, x1$1);
      var acc = $as_sci_Map(x1.$$und1$f);
      var e = $as_Lamf_core_model_document_BaseUnit(x1.$$und2$f);
      if ((acc !== null)) {
        if ((e !== null)) {
          var this$1 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(e);
          var self = (this$1.isEmpty__Z() ? e.id__T() : this$1.get__O());
          return acc.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, e))
        }
      };
      throw new $c_s_MatchError().init___O(x1)
    })
  })($thiz))));
  var oldReferences = new $c_sr_ObjectRef().init___O(elem);
  ctx.declarations__Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations().promotedFragments$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, oldReferences$1) {
    return (function(promoted$2) {
      var promoted = $as_Lamf_core_model_document_Fragment(promoted$2);
      var this$5 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(promoted);
      var key = $as_T((this$5.isEmpty__Z() ? promoted.id__T() : this$5.get__O()));
      oldReferences$1.elem$1 = $as_sci_Map(oldReferences$1.elem$1).$$plus__T2__sci_Map(new $c_T2().init___O__O(key, promoted))
    })
  })($thiz, oldReferences)));
  var this$8 = $as_sci_Map(oldReferences.elem$1);
  var this$9 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$8);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$9)) {
    var this$10 = $as_sci_Map(oldReferences.elem$1);
    var this$11 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$10);
    var references = this$11.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream();
    var field = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
    return $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(unit, field, references))
  } else {
    return unit
  }
}
function $f_Lamf_plugins_document_webapi_RamlPlugin__cleanContext__Lamf_core_parser_ParserContext__Lamf_core_Root__Lamf_core_client_ParsingOptions__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext($thiz, wrapped, root, options) {
  var jsx$4 = root.location$1;
  var jsx$3 = root.references$1;
  var jsx$2 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
  var jsx$1 = wrapped.eh$1;
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$6 = new $c_scm_ListBuffer().init___();
  var cleanNested = new $c_Lamf_core_parser_ParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext(jsx$4, jsx$3, jsx$2, jsx$1, new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$6.toList__sci_List()));
  var clean = $thiz.context__Lamf_core_parser_ParserContext__Lamf_core_Root__Lamf_core_client_ParsingOptions__s_Option__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(cleanNested, root, options, $thiz.context$default$4__s_Option());
  clean.globalSpace$1 = wrapped.globalSpace$1;
  return clean
}
function $f_Lamf_plugins_document_webapi_RamlPlugin__parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option($thiz, root, parentContext, platform, options) {
  var updated = $thiz.context__Lamf_core_parser_ParserContext__Lamf_core_Root__Lamf_core_client_ParsingOptions__s_Option__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(parentContext, root, options, $thiz.context$default$4__s_Option());
  $f_Lamf_plugins_document_webapi_RamlPlugin__inlineExternalReferences__pLamf_plugins_document_webapi_RamlPlugin__Lamf_core_Root__Lamf_core_parser_ParserContext__V($thiz, root, updated);
  var clean = $f_Lamf_plugins_document_webapi_RamlPlugin__cleanContext__Lamf_core_parser_ParserContext__Lamf_core_Root__Lamf_core_client_ParsingOptions__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext($thiz, parentContext, root, options);
  var this$1 = $m_Lamf_plugins_document_webapi_parser_RamlHeader$().apply__Lamf_core_Root__s_Option(root);
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x0$1 = $as_Lamf_plugins_document_webapi_parser_RamlHeader(arg1);
    var rc10 = false;
    var x2 = null;
    var x = $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$();
    if (x.equals__O__Z(x0$1)) {
      rc10 = true;
      x2 = x0$1;
      var x$3 = root.referenceKind$1;
      var x$4 = $m_Lamf_core_parser_LinkReference$();
      if (((x$3 !== null) && (x$3 === x$4))) {
        return $m_s_None$()
      }
    };
    if (rc10) {
      var this$2 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser().init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(root, updated);
      $m_Lamf_core_parser_Annotations$();
      var annotations = new $c_Lamf_core_parser_Annotations().init___();
      return new $c_s_Some().init___O(this$2.parseDocument__Lamf_core_model_document_Document__Lamf_core_model_document_Document(new $c_Lamf_core_model_document_Document().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)))
    };
    var x$5 = $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$();
    if (x$5.equals__O__Z(x0$1)) {
      var this$6 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser().init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(root, updated);
      $m_Lamf_core_parser_Annotations$();
      var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
      return new $c_s_Some().init___O(this$6.parseDocument__Lamf_core_model_document_Document__Lamf_core_model_document_Document(new $c_Lamf_core_model_document_Document().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1)))
    };
    var x$7 = $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$();
    if (x$7.equals__O__Z(x0$1)) {
      return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$().apply__Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser(root, updated).parseOverlay__Lamf_plugins_document_webapi_model_Overlay())
    };
    var x$9 = $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$();
    if (x$9.equals__O__Z(x0$1)) {
      return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$().apply__Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser(root, updated).parseExtension__Lamf_plugins_document_webapi_model_Extension())
    };
    var x$11 = $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$();
    if (x$11.equals__O__Z(x0$1)) {
      return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser().init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(root, clean).parseModule__Lamf_core_model_document_Module())
    };
    if ($is_Lamf_plugins_document_webapi_parser_RamlFragment(x0$1)) {
      return new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser().init___Lamf_core_Root__Lamf_plugins_document_webapi_parser_RamlFragment__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(root, $as_Lamf_plugins_document_webapi_parser_RamlFragment(x0$1), updated).parseFragment__s_Option()
    };
    return $m_s_None$()
  }
}
function $f_Lamf_plugins_document_webapi_RamlPlugin__documentSyntaxes__sc_Seq($thiz) {
  var jsx$1 = $m_sc_Seq$();
  var array = ["application/raml", "application/raml+json", "application/raml+yaml", "text/yaml", "text/x-yaml", "application/yaml", "application/x-yaml", "text/vnd.yaml"];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
}
function $f_Lamf_plugins_document_webapi_RamlPlugin__$$init$__V($thiz) {
  var jsx$1 = $m_sc_Seq$();
  var array = [$thiz.vendor__Lamf_core_remote_Vendor().name__T(), $m_Lamf_core_remote_Raml$().name$1];
  $thiz.amf$plugins$document$webapi$RamlPlugin$$undsetter$und$vendors$und$eq__sc_Seq__V($as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))))
}
function $f_Lamf_plugins_document_webapi_RamlPlugin__inlineFragment__pLamf_plugins_document_webapi_RamlPlugin__sc_Seq__s_Option__Lamf_core_model_domain_ExternalDomainElement__sc_Seq__Lamf_core_parser_ParserContext__V($thiz, origins, document, encodes, elementRef, ctx) {
  origins.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, elementRef$1, ctx$1, document$1, encodes$1) {
    return (function(refContainer$2) {
      var refContainer = $as_Lamf_core_parser_RefContainer(refContainer$2);
      var x1 = refContainer.node$1;
      if ((x1 instanceof $c_Lorg_yaml_model_YNode$MutRef)) {
        var x2 = $as_Lorg_yaml_model_YNode$MutRef(x1);
        elementRef$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, ctx$2) {
          return (function(u$2) {
            var u = $as_Lamf_core_model_document_BaseUnit(u$2);
            return ctx$2.addSonRef__Lamf_core_model_document_BaseUnit__Lamf_core_parser_ParserContext(u)
          })
        })($this, ctx$1)));
        var x = $m_s_None$();
        if ((x === document$1)) {
          var jsx$1 = $m_Lorg_yaml_model_YNode$();
          var this$1 = $as_Lamf_core_model_StrField(encodes$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1));
          var this$2 = this$1.option$1;
          x2.target$4 = new $c_s_Some().init___O(jsx$1.apply__T__Lorg_yaml_model_YNode($as_T((this$2.isEmpty__Z() ? null : this$2.get__O()))))
        } else {
          x2.target$4 = document$1
        }
      }
    })
  })($thiz, elementRef, ctx, document, encodes)))
}
function $f_Lamf_plugins_document_webapi_RamlPlugin__inlineExternalReferences__pLamf_plugins_document_webapi_RamlPlugin__Lamf_core_Root__Lamf_core_parser_ParserContext__V($thiz, root, ctx) {
  root.references$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ctx$1, root$1) {
    return (function(ref$2) {
      var ref = $as_Lamf_core_parser_ParsedReference(ref$2);
      var x1 = ref.unit$1;
      if ((x1 instanceof $c_Lamf_core_model_document_ExternalFragment)) {
        var x2 = $as_Lamf_core_model_document_ExternalFragment(x1);
        var origins = ref.origin$1.refs$1;
        var document = ref.ast$1;
        var encodes = $as_Lamf_core_model_domain_ExternalDomainElement($as_Lamf_core_model_domain_DomainElement(x2.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)));
        var elementRef = ref.unit$1.references__sc_Seq();
        $f_Lamf_plugins_document_webapi_RamlPlugin__inlineFragment__pLamf_plugins_document_webapi_RamlPlugin__sc_Seq__s_Option__Lamf_core_model_domain_ExternalDomainElement__sc_Seq__Lamf_core_parser_ParserContext__V($this, origins, document, encodes, elementRef, ctx$1)
      } else if (((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary) || (x1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_Dialect))) {
        var this$1 = x1.raw__s_Option();
        var content = $as_T((this$1.isEmpty__Z() ? "" : this$1.get__O()));
        $m_Lamf_core_parser_Annotations$();
        var annotations = new $c_Lamf_core_parser_Annotations().init___();
        var this$6 = new $c_Lamf_core_model_document_ExternalFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
        var this$5 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(x1);
        var location = $as_T((this$5.isEmpty__Z() ? root$1.location$1 : this$5.get__O()));
        var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
        var this$7 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$6, field, location));
        var value = x1.id__T();
        var this$18 = $as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$7, value));
        $m_Lamf_core_parser_Annotations$();
        var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
        var this$11 = new $c_Lamf_core_model_domain_ExternalDomainElement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
        var field$1 = $m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1;
        var this$17 = $as_Lamf_core_model_domain_ExternalDomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$11, field$1, content));
        var mediaType = ((($uI(content.length) >= 0) && ($as_T(content.substring(0, $uI("#%".length))) === "#%")) ? "application/yaml" : "application/json");
        var field$2 = $m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().MediaType$1;
        var encoded = $as_Lamf_core_model_domain_ExternalDomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$17, field$2, mediaType));
        var field$3 = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
        var fragment = $as_Lamf_core_model_document_ExternalFragment($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$18, field$3, encoded)));
        var origins$1 = ref.origin$1.refs$1;
        var document$1 = $m_s_None$();
        var encodes$1 = $as_Lamf_core_model_domain_ExternalDomainElement($as_Lamf_core_model_domain_DomainElement(fragment.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)));
        var elementRef$1 = ref.unit$1.references__sc_Seq();
        $f_Lamf_plugins_document_webapi_RamlPlugin__inlineFragment__pLamf_plugins_document_webapi_RamlPlugin__sc_Seq__s_Option__Lamf_core_model_domain_ExternalDomainElement__sc_Seq__Lamf_core_parser_ParserContext__V($this, origins$1, document$1, encodes$1, elementRef$1, ctx$1)
      }
    })
  })($thiz, ctx, root)))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems.prototype = $c_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems.prototype;
$c_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems.prototype.productPrefix__T = (function() {
  return "CollectionFormatFromItems"
});
$c_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems) && ($as_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems(x$1), true))
});
$c_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.CollectionFormatFromItems"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.CollectionFormatFromItems;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems: 0
}, false, "amf.plugins.document.webapi.annotations.CollectionFormatFromItems", {
  Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems;
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_DefaultPayload() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_annotations_DefaultPayload.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_DefaultPayload.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_DefaultPayload;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_DefaultPayload() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_DefaultPayload.prototype = $c_Lamf_plugins_document_webapi_annotations_DefaultPayload.prototype;
$c_Lamf_plugins_document_webapi_annotations_DefaultPayload.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_annotations_DefaultPayload.prototype.productPrefix__T = (function() {
  return "DefaultPayload"
});
$c_Lamf_plugins_document_webapi_annotations_DefaultPayload.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_annotations_DefaultPayload.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_DefaultPayload) && ($as_Lamf_plugins_document_webapi_annotations_DefaultPayload(x$1), true))
});
$c_Lamf_plugins_document_webapi_annotations_DefaultPayload.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_annotations_DefaultPayload.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_DefaultPayload.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_DefaultPayload.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_annotations_DefaultPayload(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_DefaultPayload) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.DefaultPayload"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_DefaultPayload(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_DefaultPayload)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_DefaultPayload(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_DefaultPayload(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.DefaultPayload;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_DefaultPayload = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_DefaultPayload: 0
}, false, "amf.plugins.document.webapi.annotations.DefaultPayload", {
  Lamf_plugins_document_webapi_annotations_DefaultPayload: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_DefaultPayload.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_DefaultPayload;
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_EmptyPayload() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_annotations_EmptyPayload.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_EmptyPayload.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_EmptyPayload;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_EmptyPayload() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_EmptyPayload.prototype = $c_Lamf_plugins_document_webapi_annotations_EmptyPayload.prototype;
$c_Lamf_plugins_document_webapi_annotations_EmptyPayload.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_annotations_EmptyPayload.prototype.productPrefix__T = (function() {
  return "EmptyPayload"
});
$c_Lamf_plugins_document_webapi_annotations_EmptyPayload.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_annotations_EmptyPayload.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_EmptyPayload) && ($as_Lamf_plugins_document_webapi_annotations_EmptyPayload(x$1), true))
});
$c_Lamf_plugins_document_webapi_annotations_EmptyPayload.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_annotations_EmptyPayload.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_EmptyPayload.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_EmptyPayload.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_annotations_EmptyPayload(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_EmptyPayload) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.EmptyPayload"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_EmptyPayload(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_EmptyPayload)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_EmptyPayload(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_EmptyPayload(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.EmptyPayload;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_EmptyPayload = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_EmptyPayload: 0
}, false, "amf.plugins.document.webapi.annotations.EmptyPayload", {
  Lamf_plugins_document_webapi_annotations_EmptyPayload: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_EmptyPayload.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_EmptyPayload;
var $d_Lamf_plugins_document_webapi_annotations_EndPointBodyParameter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_EndPointBodyParameter: 0
}, false, "amf.plugins.document.webapi.annotations.EndPointBodyParameter", {
  Lamf_plugins_document_webapi_annotations_EndPointBodyParameter: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry() {
  $c_O.call(this);
  this.range$1 = null
}
$c_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry.prototype = $c_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry.prototype;
$c_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry.prototype.productPrefix__T = (function() {
  return "EndPointResourceTypeEntry"
});
$c_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry)) {
    var EndPointResourceTypeEntry$1 = $as_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry(x$1);
    var x = this.range$1;
    var x$2 = EndPointResourceTypeEntry$1.range$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.range$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry.prototype.init___Lamf_core_parser_Range = (function(range) {
  this.range$1 = range;
  return this
});
$c_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.EndPointResourceTypeEntry"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.EndPointResourceTypeEntry;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry: 0
}, false, "amf.plugins.document.webapi.annotations.EndPointResourceTypeEntry", {
  Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_EndPointResourceTypeEntry;
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry() {
  $c_O.call(this);
  this.range$1 = null
}
$c_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry.prototype = $c_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry.prototype;
$c_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry.prototype.productPrefix__T = (function() {
  return "EndPointTraitEntry"
});
$c_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry)) {
    var EndPointTraitEntry$1 = $as_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry(x$1);
    var x = this.range$1;
    var x$2 = EndPointTraitEntry$1.range$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.range$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry.prototype.init___Lamf_core_parser_Range = (function(range) {
  this.range$1 = range;
  return this
});
$c_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.EndPointTraitEntry"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_EndPointTraitEntry)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.EndPointTraitEntry;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_EndPointTraitEntry: 0
}, false, "amf.plugins.document.webapi.annotations.EndPointTraitEntry", {
  Lamf_plugins_document_webapi_annotations_EndPointTraitEntry: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_EndPointTraitEntry;
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape() {
  $c_O.call(this);
  this.original$1 = null
}
$c_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape.prototype = $c_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape.prototype;
$c_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape.prototype.productPrefix__T = (function() {
  return "ExternalJsonSchemaShape"
});
$c_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape)) {
    var ExternalJsonSchemaShape$1 = $as_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape(x$1);
    var x = this.original$1;
    var x$2 = ExternalJsonSchemaShape$1.original$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.original$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape.prototype.init___Lorg_yaml_model_YMapEntry = (function(original) {
  this.original$1 = original;
  return this
});
function $as_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.ExternalJsonSchemaShape"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.ExternalJsonSchemaShape;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape: 0
}, false, "amf.plugins.document.webapi.annotations.ExternalJsonSchemaShape", {
  Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_ExternalJsonSchemaShape;
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema() {
  $c_O.call(this);
  this.rawText$1 = null
}
$c_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema.prototype = $c_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema.prototype;
$c_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema.prototype.productPrefix__T = (function() {
  return "GeneratedJSONSchema"
});
$c_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema)) {
    var GeneratedJSONSchema$1 = $as_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema(x$1);
    return (this.rawText$1 === GeneratedJSONSchema$1.rawText$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.rawText$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema.prototype.init___T = (function(rawText) {
  this.rawText$1 = rawText;
  return this
});
$c_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.GeneratedJSONSchema"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.GeneratedJSONSchema;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema: 0
}, false, "amf.plugins.document.webapi.annotations.GeneratedJSONSchema", {
  Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_GeneratedJSONSchema;
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype() {
  $c_O.call(this);
  this.rawText$1 = null
}
$c_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype.prototype = $c_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype.prototype;
$c_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype.prototype.productPrefix__T = (function() {
  return "GeneratedRamlDatatype"
});
$c_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype)) {
    var GeneratedRamlDatatype$1 = $as_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype(x$1);
    return (this.rawText$1 === GeneratedRamlDatatype$1.rawText$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.rawText$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype.prototype.init___T = (function(rawText) {
  this.rawText$1 = rawText;
  return this
});
$c_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.GeneratedRamlDatatype"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.GeneratedRamlDatatype;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype: 0
}, false, "amf.plugins.document.webapi.annotations.GeneratedRamlDatatype", {
  Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_GeneratedRamlDatatype;
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_Inferred() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_annotations_Inferred.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_Inferred.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_Inferred;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_Inferred() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_Inferred.prototype = $c_Lamf_plugins_document_webapi_annotations_Inferred.prototype;
$c_Lamf_plugins_document_webapi_annotations_Inferred.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_annotations_Inferred.prototype.productPrefix__T = (function() {
  return "Inferred"
});
$c_Lamf_plugins_document_webapi_annotations_Inferred.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_annotations_Inferred.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_Inferred) && ($as_Lamf_plugins_document_webapi_annotations_Inferred(x$1), true))
});
$c_Lamf_plugins_document_webapi_annotations_Inferred.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_annotations_Inferred.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_Inferred.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_Inferred.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_annotations_Inferred(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_Inferred) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.Inferred"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_Inferred(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_Inferred)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_Inferred(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_Inferred(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.Inferred;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_Inferred = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_Inferred: 0
}, false, "amf.plugins.document.webapi.annotations.Inferred", {
  Lamf_plugins_document_webapi_annotations_Inferred: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_Inferred.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_Inferred;
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_InlineDefinition() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_annotations_InlineDefinition.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_InlineDefinition.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_InlineDefinition;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_InlineDefinition() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_InlineDefinition.prototype = $c_Lamf_plugins_document_webapi_annotations_InlineDefinition.prototype;
$c_Lamf_plugins_document_webapi_annotations_InlineDefinition.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_annotations_InlineDefinition.prototype.productPrefix__T = (function() {
  return "InlineDefinition"
});
$c_Lamf_plugins_document_webapi_annotations_InlineDefinition.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_annotations_InlineDefinition.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_InlineDefinition) && ($as_Lamf_plugins_document_webapi_annotations_InlineDefinition(x$1), true))
});
$c_Lamf_plugins_document_webapi_annotations_InlineDefinition.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_annotations_InlineDefinition.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_InlineDefinition.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_InlineDefinition.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_annotations_InlineDefinition(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_InlineDefinition) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.InlineDefinition"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_InlineDefinition(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_InlineDefinition)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_InlineDefinition(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_InlineDefinition(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.InlineDefinition;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_InlineDefinition = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_InlineDefinition: 0
}, false, "amf.plugins.document.webapi.annotations.InlineDefinition", {
  Lamf_plugins_document_webapi_annotations_InlineDefinition: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_InlineDefinition.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_InlineDefinition;
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot.prototype = $c_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot.prototype;
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot.prototype.productPrefix__T = (function() {
  return "JSONSchemaRoot"
});
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot) && ($as_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot(x$1), true))
});
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.JSONSchemaRoot"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_JSONSchemaRoot)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.JSONSchemaRoot;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_JSONSchemaRoot: 0
}, false, "amf.plugins.document.webapi.annotations.JSONSchemaRoot", {
  Lamf_plugins_document_webapi_annotations_JSONSchemaRoot: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_JSONSchemaRoot;
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_OperationTraitEntry() {
  $c_O.call(this);
  this.range$1 = null
}
$c_Lamf_plugins_document_webapi_annotations_OperationTraitEntry.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_OperationTraitEntry.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_OperationTraitEntry;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_OperationTraitEntry() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_OperationTraitEntry.prototype = $c_Lamf_plugins_document_webapi_annotations_OperationTraitEntry.prototype;
$c_Lamf_plugins_document_webapi_annotations_OperationTraitEntry.prototype.productPrefix__T = (function() {
  return "OperationTraitEntry"
});
$c_Lamf_plugins_document_webapi_annotations_OperationTraitEntry.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_annotations_OperationTraitEntry.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_OperationTraitEntry)) {
    var OperationTraitEntry$1 = $as_Lamf_plugins_document_webapi_annotations_OperationTraitEntry(x$1);
    var x = this.range$1;
    var x$2 = OperationTraitEntry$1.range$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_annotations_OperationTraitEntry.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.range$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_annotations_OperationTraitEntry.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_OperationTraitEntry.prototype.init___Lamf_core_parser_Range = (function(range) {
  this.range$1 = range;
  return this
});
$c_Lamf_plugins_document_webapi_annotations_OperationTraitEntry.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_OperationTraitEntry.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_annotations_OperationTraitEntry(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_OperationTraitEntry) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.OperationTraitEntry"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_OperationTraitEntry(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_OperationTraitEntry)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_OperationTraitEntry(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_OperationTraitEntry(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.OperationTraitEntry;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_OperationTraitEntry = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_OperationTraitEntry: 0
}, false, "amf.plugins.document.webapi.annotations.OperationTraitEntry", {
  Lamf_plugins_document_webapi_annotations_OperationTraitEntry: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_OperationTraitEntry.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_OperationTraitEntry;
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema.prototype = $c_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema.prototype;
$c_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema.prototype.productPrefix__T = (function() {
  return "SchemaIsJsonSchema"
});
$c_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema) && ($as_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema(x$1), true))
});
$c_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.SchemaIsJsonSchema"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.SchemaIsJsonSchema;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema: 0
}, false, "amf.plugins.document.webapi.annotations.SchemaIsJsonSchema", {
  Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema: 1,
  O: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide() {
  $c_O.call(this);
  this.currentLoc$1 = null;
  this.references$1 = null;
  this.context$1 = null;
  this.platform$1 = null
}
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide.prototype = $c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide.prototype;
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide.prototype.getReferenceUrl__p1__T__s_Option = (function(fileUrl) {
  var x1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(fileUrl, "#", 0);
  if ((x1 !== null)) {
    if ((x1.u.length > 1)) {
      var this$5 = new $c_scm_ArrayOps$ofRef().init___AO(x1);
      return new $c_s_Some().init___O($f_sc_IndexedSeqOptimized__last__O(this$5))
    }
  };
  return $m_s_None$()
});
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide.prototype.obtainFragmentFromFullRef__p1__T__s_Option = (function(fileUrl) {
  var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(fileUrl, "#", 0);
  var this$3 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
  var baseFileUrl = $as_T($f_sc_IndexedSeqOptimized__head__O(this$3));
  var xo = $as_sc_IterableLike(this.references$1.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(r$2) {
      var r = $as_Lamf_core_parser_ParsedReference(r$2);
      var this$4 = r.unit$1;
      return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$4).isDefined__Z()
    })
  })(this)))).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, baseFileUrl$1) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_core_parser_ParsedReference(x$3$2);
      var this$5 = x$3.unit$1;
      var x = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$5).get__O();
      return ((x === null) ? (baseFileUrl$1 === null) : $objectEquals(x, baseFileUrl$1))
    })
  })(this, baseFileUrl)));
  var this$7 = xo.toList__sci_List();
  var pf = new $c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide$$anonfun$obtainFragmentFromFullRef$3().init___Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide(this);
  return $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$7, pf)
});
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide.prototype.productPrefix__T = (function() {
  return "JsonSchemaRefGuide"
});
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide)) {
    var JsonSchemaRefGuide$1 = $as_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide(x$1);
    if ((this.currentLoc$1 === JsonSchemaRefGuide$1.currentLoc$1)) {
      var x = this.references$1;
      var x$2 = JsonSchemaRefGuide$1.references$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.currentLoc$1;
      break
    }
    case 1: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide.prototype.changeJsonSchemaSearchDestination__T__Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide = (function(loc) {
  var optionalRef = $as_sc_IterableLike(this.references$1.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(r$2) {
      var r = $as_Lamf_core_parser_ParsedReference(r$2);
      var this$1 = r.unit$1;
      return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$1).isDefined__Z()
    })
  })(this)))).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, loc$1) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_parser_ParsedReference(x$2$2);
      var this$3 = x$2.unit$1;
      var x = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$3).get__O();
      return ((x === null) ? (loc$1 === null) : $objectEquals(x, loc$1))
    })
  })(this, loc)));
  if (optionalRef.isEmpty__Z()) {
    var this$6 = $m_s_None$()
  } else {
    var arg1 = optionalRef.get__O();
    var r$3 = $as_Lamf_core_parser_ParsedReference(arg1);
    var jsx$2 = r$3.unit$1.references__sc_Seq();
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, r$1) {
      return (function(unit$2) {
        var unit = $as_Lamf_core_model_document_BaseUnit(unit$2);
        return new $c_Lamf_core_parser_ParsedReference().init___Lamf_core_model_document_BaseUnit__Lamf_core_parser_Reference__s_Option(unit, r$1.origin$1, $m_s_None$())
      })
    })(this, r$3));
    var this$5 = $m_sc_Seq$();
    var this$6 = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide().init___T__sc_Seq__Lamf_plugins_document_webapi_contexts_WebApiContext(loc, $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2)), this.context$1))
  };
  return $as_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide((this$6.isEmpty__Z() ? this : this$6.get__O()))
});
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide.prototype.getRootYNode__T__s_Option = (function(ref) {
  if ((!this.context$1.validateRefFormatWithError__T__Z(ref))) {
    return $m_s_None$()
  };
  var fileUrl = this.context$1.resolvedPath__T__T__T(this.currentLoc$1, ref);
  this.getReferenceUrl__p1__T__s_Option(fileUrl);
  var this$1 = this.obtainFragmentFromFullRef__p1__T__s_Option(fileUrl);
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var fragment = $as_Lamf_core_model_document_Fragment(arg1);
    return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_JsonSchemaPlugin$().getYNode__Lamf_core_model_document_Fragment__Lamf_plugins_document_webapi_contexts_WebApiContext__Lorg_yaml_model_YNode(fragment, this.context$1))
  }
});
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide.prototype.init___T__sc_Seq__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(currentLoc, references, context) {
  this.currentLoc$1 = currentLoc;
  this.references$1 = references;
  this.context$1 = context;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide.prototype.obtainRemoteYNode__T__s_Option = (function(ref) {
  if ((!this.context$1.validateRefFormatWithError__T__Z(ref))) {
    return $m_s_None$()
  };
  var fileUrl = this.context$1.resolvedPath__T__T__T(this.currentLoc$1, ref);
  var referenceUrl = this.getReferenceUrl__p1__T__s_Option(fileUrl);
  var this$1 = this.obtainFragmentFromFullRef__p1__T__s_Option(fileUrl);
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var fragment = $as_Lamf_core_model_document_Fragment(arg1);
    return $m_Lamf_plugins_document_webapi_JsonSchemaPlugin$().obtainRootAst__Lamf_core_model_document_Fragment__s_Option__Lamf_plugins_document_webapi_contexts_WebApiContext__s_Option(fragment, referenceUrl, this.context$1)
  }
});
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.JsonSchemaRefGuide"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.JsonSchemaRefGuide;", depth))
}
var $d_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide: 0
}, false, "amf.plugins.document.webapi.contexts.JsonSchemaRefGuide", {
  Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide$$anonfun$obtainFragmentFromFullRef$3() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide$$anonfun$obtainFragmentFromFullRef$3.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide$$anonfun$obtainFragmentFromFullRef$3.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide$$anonfun$obtainFragmentFromFullRef$3;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide$$anonfun$obtainFragmentFromFullRef$3() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide$$anonfun$obtainFragmentFromFullRef$3.prototype = $c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide$$anonfun$obtainFragmentFromFullRef$3.prototype;
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide$$anonfun$obtainFragmentFromFullRef$3.prototype.init___Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide$$anonfun$obtainFragmentFromFullRef$3.prototype.isDefinedAt__Lamf_core_parser_ParsedReference__Z = (function(x1) {
  return ((x1.unit$1 instanceof $c_Lamf_core_model_document_ExternalFragment) || (x1.unit$1 instanceof $c_Lamf_core_model_document_RecursiveUnit))
});
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide$$anonfun$obtainFragmentFromFullRef$3.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_parser_ParsedReference__Z($as_Lamf_core_parser_ParsedReference(x))
});
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide$$anonfun$obtainFragmentFromFullRef$3.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_parser_ParsedReference__F1__O($as_Lamf_core_parser_ParsedReference(x), $default)
});
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide$$anonfun$obtainFragmentFromFullRef$3.prototype.applyOrElse__Lamf_core_parser_ParsedReference__F1__O = (function(x1, $default) {
  return ((x1.unit$1 instanceof $c_Lamf_core_model_document_ExternalFragment) ? $as_Lamf_core_model_document_ExternalFragment(x1.unit$1) : ((x1.unit$1 instanceof $c_Lamf_core_model_document_RecursiveUnit) ? $as_Lamf_core_model_document_RecursiveUnit(x1.unit$1) : $default.apply__O__O(x1)))
});
var $d_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide$$anonfun$obtainFragmentFromFullRef$3 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide$$anonfun$obtainFragmentFromFullRef$3: 0
}, false, "amf.plugins.document.webapi.contexts.JsonSchemaRefGuide$$anonfun$obtainFragmentFromFullRef$3", {
  Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide$$anonfun$obtainFragmentFromFullRef$3: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide$$anonfun$obtainFragmentFromFullRef$3.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide$$anonfun$obtainFragmentFromFullRef$3;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_WebApiContext$$anonfun$obtainFragment$3() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_contexts_WebApiContext$$anonfun$obtainFragment$3.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_contexts_WebApiContext$$anonfun$obtainFragment$3.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_WebApiContext$$anonfun$obtainFragment$3;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_WebApiContext$$anonfun$obtainFragment$3() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_WebApiContext$$anonfun$obtainFragment$3.prototype = $c_Lamf_plugins_document_webapi_contexts_WebApiContext$$anonfun$obtainFragment$3.prototype;
$c_Lamf_plugins_document_webapi_contexts_WebApiContext$$anonfun$obtainFragment$3.prototype.isDefinedAt__Lamf_core_parser_ParsedReference__Z = (function(x1) {
  return ((x1.unit$1 instanceof $c_Lamf_core_model_document_ExternalFragment) || (x1.unit$1 instanceof $c_Lamf_core_model_document_RecursiveUnit))
});
$c_Lamf_plugins_document_webapi_contexts_WebApiContext$$anonfun$obtainFragment$3.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_parser_ParsedReference__Z($as_Lamf_core_parser_ParsedReference(x))
});
$c_Lamf_plugins_document_webapi_contexts_WebApiContext$$anonfun$obtainFragment$3.prototype.init___Lamf_plugins_document_webapi_contexts_WebApiContext = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_contexts_WebApiContext$$anonfun$obtainFragment$3.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_parser_ParsedReference__F1__O($as_Lamf_core_parser_ParsedReference(x), $default)
});
$c_Lamf_plugins_document_webapi_contexts_WebApiContext$$anonfun$obtainFragment$3.prototype.applyOrElse__Lamf_core_parser_ParsedReference__F1__O = (function(x1, $default) {
  return ((x1.unit$1 instanceof $c_Lamf_core_model_document_ExternalFragment) ? $as_Lamf_core_model_document_ExternalFragment(x1.unit$1) : ((x1.unit$1 instanceof $c_Lamf_core_model_document_RecursiveUnit) ? $as_Lamf_core_model_document_RecursiveUnit(x1.unit$1) : $default.apply__O__O(x1)))
});
var $d_Lamf_plugins_document_webapi_contexts_WebApiContext$$anonfun$obtainFragment$3 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_WebApiContext$$anonfun$obtainFragment$3: 0
}, false, "amf.plugins.document.webapi.contexts.WebApiContext$$anonfun$obtainFragment$3", {
  Lamf_plugins_document_webapi_contexts_WebApiContext$$anonfun$obtainFragment$3: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_contexts_WebApiContext$$anonfun$obtainFragment$3.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_WebApiContext$$anonfun$obtainFragment$3;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext() {
  $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext.call(this);
  this.eh$5 = null;
  this.options$5 = null;
  this.schemaVersion$5 = null;
  this.typeDefMatcher$5 = null;
  this.anyOfKey$5 = null;
  this.nameRegex$5 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext();
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext.prototype.schemaVersion__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion = (function() {
  return this.schemaVersion$5
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_core_emitter_ShapeRenderOptions__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion = (function(eh, options, schemaVersion) {
  this.eh$5 = eh;
  this.options$5 = options;
  this.schemaVersion$5 = schemaVersion;
  var x$3 = $m_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$();
  $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions.call(this, eh, x$3, options);
  this.typeDefMatcher$5 = $m_Lamf_plugins_document_webapi_parser_JsonSchemaTypeDefMatcher$();
  this.anyOfKey$5 = "anyOf";
  var this$3 = new $c_sci_StringOps().init___T("^[a-zA-Z0-9\\.\\-_]+$");
  var groupNames = $m_sci_Nil$();
  var $$this = this$3.repr$1;
  this.nameRegex$5 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext.prototype.options__Lamf_core_emitter_ShapeRenderOptions = (function() {
  return this.options$5
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext.prototype.typeDefMatcher__Lamf_plugins_document_webapi_parser_OasTypeDefStringValueMatcher = (function() {
  return this.typeDefMatcher$5
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext.prototype.eh__Lamf_core_errorhandling_ErrorHandler = (function() {
  return this.eh$5
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext.prototype.nameRegex__s_util_matching_Regex = (function() {
  return this.nameRegex$5
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext.prototype.anyOfKey__T = (function() {
  return this.anyOfKey$5
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext.prototype.schemasDeclarationsPath__T = (function() {
  return "/definitions/"
});
function $as_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.emitter.oas.JsonSchemaEmitterContext"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.emitter.oas.JsonSchemaEmitterContext;", depth))
}
var $d_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.oas.JsonSchemaEmitterContext", {
  Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_SpecEmitterContext: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_emitter_oas_CompactEmissionContext: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$$anonfun$1.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$$anonfun$1.prototype.applyOrElse__Lamf_core_model_domain_Annotation__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_annotations_DomainExtensionAnnotation)) {
    var x2 = $as_Lamf_core_annotations_DomainExtensionAnnotation(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_Annotation__Z($as_Lamf_core_model_domain_Annotation(x))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_Annotation__F1__O($as_Lamf_core_model_domain_Annotation(x), $default)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$$anonfun$1.prototype.isDefinedAt__Lamf_core_model_domain_Annotation__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_core_annotations_DomainExtensionAnnotation)
});
var $d_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.raml.RamlScalarEmitter$$anonfun$1", {
  Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$() {
  $c_O.call(this);
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Encodes$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null
}
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$.prototype.constructor = $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$.prototype = $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$.prototype;
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V(this);
  this.fields$1 = $m_Lamf_core_metamodel_document_FragmentModel$().fields$1;
  $m_sci_List$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "AnnotationTypeDeclarationFragment")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_document_FragmentModel$().type$1;
  var this$7 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Annotation Type Fragment", "Fragment encoding a RAML annotation type", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$.prototype.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Encodes$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$: 0
}, false, "amf.plugins.document.webapi.metamodel.FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$", {
  Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_FragmentModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$.prototype.$classData = $d_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$;
var $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$ = (void 0);
function $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$() {
  if ((!$n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$)) {
    $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$ = new $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$().init___()
  };
  return $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$() {
  $c_O.call(this);
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Encodes$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null
}
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$.prototype.constructor = $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$.prototype = $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$.prototype;
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V(this);
  this.fields$1 = $m_Lamf_core_metamodel_document_FragmentModel$().fields$1;
  $m_sci_List$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "DataTypeFragment")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_document_FragmentModel$().type$1;
  var this$7 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "Data Type Fragment", "Fragment encoding a RAML data type", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_webapi_model_DataTypeFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$.prototype.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Encodes$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$: 0
}, false, "amf.plugins.document.webapi.metamodel.FragmentsTypesModels$DataTypeFragmentModel$", {
  Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_FragmentModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$.prototype.$classData = $d_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$;
var $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$ = (void 0);
function $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$() {
  if ((!$n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$)) {
    $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$ = new $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$().init___()
  };
  return $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$() {
  $c_O.call(this);
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Encodes$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null
}
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$.prototype.constructor = $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$.prototype = $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$.prototype;
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V(this);
  this.fields$1 = $m_Lamf_core_metamodel_document_FragmentModel$().fields$1;
  $m_sci_List$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "UserDocumentationFragment")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_document_FragmentModel$().type$1;
  var this$7 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Documentation Item Fragment", "Fragment encoding a RAML documentation item", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_webapi_model_DocumentationItemFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$.prototype.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Encodes$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$: 0
}, false, "amf.plugins.document.webapi.metamodel.FragmentsTypesModels$DocumentationItemFragmentModel$", {
  Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_FragmentModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$.prototype.$classData = $d_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$;
var $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$ = (void 0);
function $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$() {
  if ((!$n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$)) {
    $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$ = new $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$().init___()
  };
  return $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$() {
  $c_O.call(this);
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Encodes$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null
}
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$.prototype.constructor = $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$.prototype = $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$.prototype;
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V(this);
  this.fields$1 = $m_Lamf_core_metamodel_document_FragmentModel$().fields$1;
  $m_sci_List$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "NamedExampleFragment")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_document_FragmentModel$().type$1;
  var this$7 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Named Example Fragment", "Fragment encoding a RAML named example", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_webapi_model_NamedExampleFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$.prototype.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Encodes$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$: 0
}, false, "amf.plugins.document.webapi.metamodel.FragmentsTypesModels$NamedExampleFragmentModel$", {
  Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_FragmentModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$.prototype.$classData = $d_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$;
var $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$ = (void 0);
function $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$() {
  if ((!$n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$)) {
    $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$ = new $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$().init___()
  };
  return $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$() {
  $c_O.call(this);
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Encodes$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null
}
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$.prototype.constructor = $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$.prototype = $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$.prototype;
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V(this);
  this.fields$1 = $m_Lamf_core_metamodel_document_FragmentModel$().fields$1;
  $m_sci_List$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "ResourceTypeFragment")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_document_FragmentModel$().type$1;
  var this$7 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Resource Type Fragment", "Fragment encoding a RAML resource type", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_webapi_model_ResourceTypeFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$.prototype.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Encodes$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$: 0
}, false, "amf.plugins.document.webapi.metamodel.FragmentsTypesModels$ResourceTypeFragmentModel$", {
  Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_FragmentModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$.prototype.$classData = $d_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$;
var $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$ = (void 0);
function $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$() {
  if ((!$n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$)) {
    $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$ = new $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$().init___()
  };
  return $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$() {
  $c_O.call(this);
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Encodes$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null
}
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$.prototype.constructor = $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$.prototype = $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$.prototype;
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V(this);
  this.fields$1 = $m_Lamf_core_metamodel_document_FragmentModel$().fields$1;
  $m_sci_List$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "SecuritySchemeFragment")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_document_FragmentModel$().type$1;
  var this$7 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "Security Scheme Fragment", "Fragment encoding a RAML security scheme", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$.prototype.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Encodes$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$: 0
}, false, "amf.plugins.document.webapi.metamodel.FragmentsTypesModels$SecuritySchemeFragmentModel$", {
  Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_FragmentModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$.prototype.$classData = $d_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$;
var $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$ = (void 0);
function $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$() {
  if ((!$n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$)) {
    $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$ = new $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$().init___()
  };
  return $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$() {
  $c_O.call(this);
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Encodes$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null
}
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$.prototype.constructor = $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$.prototype = $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$.prototype;
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V(this);
  this.fields$1 = $m_Lamf_core_metamodel_document_FragmentModel$().fields$1;
  $m_sci_List$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "TraitFragment")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_document_FragmentModel$().type$1;
  var this$7 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Trait Fragment", "Fragment encoding a RAML trait", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_webapi_model_TraitFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$.prototype.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Encodes$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$: 0
}, false, "amf.plugins.document.webapi.metamodel.FragmentsTypesModels$TraitFragmentModel$", {
  Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_FragmentModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$.prototype.$classData = $d_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$;
var $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$ = (void 0);
function $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$() {
  if ((!$n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$)) {
    $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$ = new $c_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$().init___()
  };
  return $n_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$.prototype = new $h_Lamf_plugins_document_webapi_parser_RamlHeader();
$c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$.prototype = $c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$.prototype;
$c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.init___T.call(this, "%RAML 0.8");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$: 0
}, false, "amf.plugins.document.webapi.parser.RamlHeader$Raml08$", {
  Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$: 1,
  Lamf_plugins_document_webapi_parser_RamlHeader: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$;
var $n_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$)) {
    $n_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$ = new $c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$.prototype = new $h_Lamf_plugins_document_webapi_parser_RamlHeader();
$c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$.prototype = $c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$.prototype;
$c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.init___T.call(this, "%RAML 1.0");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$: 0
}, false, "amf.plugins.document.webapi.parser.RamlHeader$Raml10$", {
  Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$: 1,
  Lamf_plugins_document_webapi_parser_RamlHeader: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$;
var $n_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$)) {
    $n_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$ = new $c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$.prototype = new $h_Lamf_plugins_document_webapi_parser_RamlHeader();
$c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$.prototype = $c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$.prototype;
$c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.init___T.call(this, "%RAML 1.0 Extension");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$: 0
}, false, "amf.plugins.document.webapi.parser.RamlHeader$Raml10Extension$", {
  Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$: 1,
  Lamf_plugins_document_webapi_parser_RamlHeader: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$;
var $n_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$)) {
    $n_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$ = new $c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$.prototype = new $h_Lamf_plugins_document_webapi_parser_RamlHeader();
$c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$.prototype = $c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$.prototype;
$c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.init___T.call(this, "%RAML 1.0 Library");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$: 0
}, false, "amf.plugins.document.webapi.parser.RamlHeader$Raml10Library$", {
  Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$: 1,
  Lamf_plugins_document_webapi_parser_RamlHeader: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$;
var $n_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$)) {
    $n_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$ = new $c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$.prototype = new $h_Lamf_plugins_document_webapi_parser_RamlHeader();
$c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$.prototype = $c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$.prototype;
$c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.init___T.call(this, "%RAML 1.0 Overlay");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$: 0
}, false, "amf.plugins.document.webapi.parser.RamlHeader$Raml10Overlay$", {
  Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$: 1,
  Lamf_plugins_document_webapi_parser_RamlHeader: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$;
var $n_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$)) {
    $n_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$ = new $c_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findChannelBindings$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findChannelBindings$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findChannelBindings$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findChannelBindings$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findChannelBindings$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findChannelBindings$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findChannelBindings$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findChannelBindings$2.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findChannelBindings$2.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findChannelBindings$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findChannelBindings$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findChannelBindings$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findChannelBindings$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findChannelBindings$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$$anonfun$findChannelBindings$2", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findChannelBindings$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findChannelBindings$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findChannelBindings$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findCorrelationId$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findCorrelationId$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findCorrelationId$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findCorrelationId$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findCorrelationId$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findCorrelationId$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findCorrelationId$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findCorrelationId$2.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_CorrelationId)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_CorrelationId(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findCorrelationId$2.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_CorrelationId)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findCorrelationId$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findCorrelationId$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findCorrelationId$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findCorrelationId$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findCorrelationId$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$$anonfun$findCorrelationId$2", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findCorrelationId$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findCorrelationId$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findCorrelationId$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findExample$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findExample$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findExample$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findExample$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findExample$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findExample$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findExample$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findExample$2.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_Example)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_Example(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findExample$2.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_shapes_models_Example)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findExample$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findExample$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findExample$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findExample$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findExample$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$$anonfun$findExample$2", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findExample$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findExample$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findExample$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findHeader$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findHeader$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findHeader$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findHeader$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findHeader$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findHeader$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findHeader$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findHeader$2.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Parameter)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_Parameter(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findHeader$2.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_Parameter)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findHeader$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findHeader$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findHeader$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findHeader$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findHeader$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$$anonfun$findHeader$2", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findHeader$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findHeader$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findHeader$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessage$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessage$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessage$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessage$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessage$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessage$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessage$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessage$2.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Message)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_Message(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessage$2.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_Message)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessage$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessage$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessage$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessage$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessage$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$$anonfun$findMessage$2", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessage$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessage$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessage$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageBindings$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageBindings$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageBindings$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageBindings$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageBindings$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageBindings$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageBindings$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageBindings$2.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_bindings_MessageBindings(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageBindings$2.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageBindings$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageBindings$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageBindings$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageBindings$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageBindings$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$$anonfun$findMessageBindings$2", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageBindings$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageBindings$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageBindings$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageTrait$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageTrait$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageTrait$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageTrait$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageTrait$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageTrait$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageTrait$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageTrait$2.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Message)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_Message(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageTrait$2.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_Message)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageTrait$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageTrait$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageTrait$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageTrait$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageTrait$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$$anonfun$findMessageTrait$2", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageTrait$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageTrait$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findMessageTrait$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationBindings$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationBindings$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationBindings$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationBindings$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationBindings$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationBindings$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationBindings$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationBindings$2.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_bindings_OperationBindings(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationBindings$2.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationBindings$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationBindings$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationBindings$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationBindings$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationBindings$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$$anonfun$findOperationBindings$2", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationBindings$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationBindings$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationBindings$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationTrait$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationTrait$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationTrait$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationTrait$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationTrait$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationTrait$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationTrait$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationTrait$2.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Operation)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_Operation(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationTrait$2.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_Operation)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationTrait$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationTrait$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationTrait$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationTrait$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationTrait$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$$anonfun$findOperationTrait$2", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationTrait$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationTrait$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findOperationTrait$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findParameter$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findParameter$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findParameter$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findParameter$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findParameter$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findParameter$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findParameter$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findParameter$2.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Parameter)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_Parameter(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findParameter$2.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_Parameter)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findParameter$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findParameter$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findParameter$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findParameter$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findParameter$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$$anonfun$findParameter$2", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findParameter$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findParameter$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findParameter$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findPayload$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findPayload$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findPayload$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findPayload$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findPayload$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findPayload$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findPayload$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findPayload$2.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Payload)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_Payload(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findPayload$2.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_Payload)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findPayload$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findPayload$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findPayload$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findPayload$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findPayload$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$$anonfun$findPayload$2", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findPayload$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findPayload$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findPayload$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findRequestBody$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findRequestBody$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findRequestBody$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findRequestBody$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findRequestBody$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findRequestBody$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findRequestBody$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findRequestBody$2.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Request)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_Request(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findRequestBody$2.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_Request)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findRequestBody$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findRequestBody$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findRequestBody$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findRequestBody$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findRequestBody$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$$anonfun$findRequestBody$2", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findRequestBody$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findRequestBody$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findRequestBody$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findResponse$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findResponse$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findResponse$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findResponse$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findResponse$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findResponse$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findResponse$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findResponse$2.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Response)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_Response(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findResponse$2.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_Response)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findResponse$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findResponse$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findResponse$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findResponse$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findResponse$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$$anonfun$findResponse$2", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findResponse$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findResponse$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findResponse$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findServerBindings$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findServerBindings$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findServerBindings$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findServerBindings$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findServerBindings$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findServerBindings$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findServerBindings$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findServerBindings$2.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_bindings_ServerBindings(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findServerBindings$2.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findServerBindings$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findServerBindings$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findServerBindings$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findServerBindings$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findServerBindings$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$$anonfun$findServerBindings$2", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findServerBindings$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findServerBindings$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findServerBindings$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findTemplatedLink$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findTemplatedLink$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findTemplatedLink$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findTemplatedLink$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findTemplatedLink$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findTemplatedLink$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findTemplatedLink$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findTemplatedLink$2.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_TemplatedLink)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_TemplatedLink(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findTemplatedLink$2.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_TemplatedLink)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findTemplatedLink$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findTemplatedLink$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findTemplatedLink$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findTemplatedLink$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findTemplatedLink$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$$anonfun$findTemplatedLink$2", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findTemplatedLink$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findTemplatedLink$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$$anonfun$findTemplatedLink$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiSpecParser.call(this);
  this.root$2 = null;
  this.ctx$2 = null;
  this.definitionsKey$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiSpecParser();
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype.parseCorrelationIdDeclarations__Lorg_yaml_model_YMap__T__V = (function(componentsMap, parent) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(componentsMap);
  var this$3 = this$2.key__T__s_Option("correlationIds");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = e.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
    $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$6) {
      return (function(entry$2) {
        var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
        var errorHandler = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
        var correlationId = new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser().init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(new $c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike().init___Lorg_yaml_model_YMapEntry__Lorg_yaml_model_IllegalTypeHandler(entry, errorHandler), parent$6, $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext()).parse__Lamf_plugins_domain_webapi_models_CorrelationId();
        var jsx$1 = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext().declarations$4;
        var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
        return jsx$1.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(correlationId, annotation)))
      })
    })(this, parent)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype.parseDeclarations__Lorg_yaml_model_YMap__V = (function(map) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("components");
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var components = $as_Lorg_yaml_model_YMapEntry(arg1);
    var parent = (this.root$2.location$1 + "#/declarations");
    var this$3 = components.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
    var componentsMap = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv));
    this.parseSecuritySchemeDeclarations__Lorg_yaml_model_YMap__T__V(componentsMap, (parent + "/securitySchemes"));
    this.parseCorrelationIdDeclarations__Lorg_yaml_model_YMap__T__V(componentsMap, (parent + "/correlationIds"));
    var typesPrefix = (parent + "/types");
    var ctx = this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
    $f_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeDeclarationsHelper__parseTypeDeclarations__Lorg_yaml_model_YMap__T__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__V(this, componentsMap, typesPrefix, ctx);
    this.parseParameterDeclarations__Lorg_yaml_model_YMap__T__V(componentsMap, (parent + "/parameters"));
    this.parseMessageBindingsDeclarations__Lorg_yaml_model_YMap__T__V(componentsMap, (parent + "/messageBindings"));
    this.parseServerBindingsDeclarations__Lorg_yaml_model_YMap__T__V(componentsMap, (parent + "/serverBindings"));
    this.parseOperationBindingsDeclarations__Lorg_yaml_model_YMap__T__V(componentsMap, (parent + "/operationBindings"));
    this.parseChannelBindingsDeclarations__Lorg_yaml_model_YMap__T__V(componentsMap, (parent + "/channelBindings"));
    this.parseOperationTraits__Lorg_yaml_model_YMap__T__V(componentsMap, (parent + "/operationTraits"));
    this.parseMessageTraits__Lorg_yaml_model_YMap__T__V(componentsMap, (parent + "/messageTraits"));
    this.parseMessageDeclarations__Lorg_yaml_model_YMap__T__V(componentsMap, (parent + "/messages"))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype.parseParameterDeclarations__Lorg_yaml_model_YMap__T__V = (function(componentsMap, parent) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(componentsMap);
  var this$3 = this$2.key__T__s_Option("parameters");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var paramsMap = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = paramsMap.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
    var parameters = new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser().init___T__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(parent, $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)), this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext()).parse__sc_Seq();
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(param$2) {
        var param = $as_Lamf_plugins_domain_webapi_models_Parameter(param$2);
        var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
        $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(param, annotation);
        return $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext().declarations$4.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(param)
      })
    })(this));
    var this$5 = $m_sc_Seq$();
    parameters.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype.parseMessageTraits__Lorg_yaml_model_YMap__T__V = (function(componentsMap, parent) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(componentsMap);
  var this$3 = this$2.key__T__s_Option("messageTraits");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
    $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$3) {
      return (function(entry$2$2) {
        var entry$2 = $as_Lorg_yaml_model_YMapEntry(entry$2$2);
        var jsx$1 = $m_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$();
        var errorHandler = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
        var message = jsx$1.apply__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__s_Option__Z__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser(new $c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike().init___Lorg_yaml_model_YMapEntry__Lorg_yaml_model_IllegalTypeHandler(entry$2, errorHandler), parent$3, $m_s_None$(), true, $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext()).parse__Lamf_plugins_domain_webapi_models_Message();
        var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
        $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(message, annotation);
        return $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext().declarations$4.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(message)
      })
    })(this, parent)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype.parseChannelBindingsDeclarations__Lorg_yaml_model_YMap__T__V = (function(componentsMap, parent) {
  this.parseBindingsDeclarations__T__Lorg_yaml_model_YMap__F1__V("channelBindings", componentsMap, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$1) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var errorHandler = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
      return $as_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings(new $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser().init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(new $c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike().init___Lorg_yaml_model_YMapEntry__Lorg_yaml_model_IllegalTypeHandler(entry, errorHandler), parent$1, $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext()).parse__Lamf_core_model_domain_NamedDomainElement())
    })
  })(this, parent)))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype.definitionsKey__T = (function() {
  return this.definitionsKey$2
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype.parseDocument__p2__Lamf_core_model_document_Document__Lamf_core_model_document_Document = (function(document) {
  var parent = this.root$2.location$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(document, parent));
  var location = this.root$2.location$1;
  var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
  $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, location));
  var this$2 = $as_Lamf_core_parser_SyamlParsedDocument(this.root$2.parsed$1).document$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv));
  this.parseDeclarations__Lorg_yaml_model_YMap__V(map);
  var this$3 = this.parseWebApi__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_WebApi(map);
  var annotation = new $c_Lamf_core_annotations_SourceVendor().init___Lamf_core_remote_Vendor(this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext().vendor$5);
  var api = $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$3, annotation));
  var field$1 = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
  var qual$1 = $as_Lamf_core_model_document_Document($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(document, field$1, api)));
  var x$1 = this.root$2.location$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1);
  var declarable = this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext().declarations$4.declarables__sc_Seq();
  if (declarable.nonEmpty__Z()) {
    var field$2 = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
    $as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(document, field$2, declarable))
  };
  return document
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(root, ctx) {
  this.root$2 = root;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiSpecParser.prototype.init___Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext.call(this, ctx);
  this.definitionsKey$2 = "schemas";
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype.parseServerBindingsDeclarations__Lorg_yaml_model_YMap__T__V = (function(componentsMap, parent) {
  this.parseBindingsDeclarations__T__Lorg_yaml_model_YMap__F1__V("serverBindings", componentsMap, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$1) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var errorHandler = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
      return $as_Lamf_plugins_domain_webapi_models_bindings_ServerBindings(new $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser().init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(new $c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike().init___Lorg_yaml_model_YMapEntry__Lorg_yaml_model_IllegalTypeHandler(entry, errorHandler), parent$1, $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext()).parse__Lamf_core_model_domain_NamedDomainElement())
    })
  })(this, parent)))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype.parseChannels__p2__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_WebApi__V = (function(entry, api) {
  var this$1 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
  var paths = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var endpoints = $as_sci_List(paths.entries$3.foldLeft__O__F2__O($m_sci_Nil$(), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this, api$1) {
    return (function(acc$2, curr$2) {
      var acc = $as_sci_List(acc$2);
      var curr = $as_Lorg_yaml_model_YMapEntry(curr$2);
      var this$2 = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
      var xo = this$2.factory$5.endPointParser__Lorg_yaml_model_YMapEntry__F1__sci_List__Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser(curr, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, api$2) {
        return (function(path$2) {
          var path = $as_T(path$2);
          return api$2.withEndPoint__T__Lamf_plugins_domain_webapi_models_EndPoint(path)
        })
      })($this, api$1)), acc).parse__s_Option();
      var jsx$1 = xo.toList__sci_List();
      var this$4 = $m_sci_List$();
      return $as_sci_List(acc.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2))
    })
  })(this, api))));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1;
  var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(endpoints, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(api, field, value, annotations)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype.parseBindingsDeclarations__T__Lorg_yaml_model_YMap__F1__V = (function(keyword, componentsMap, parse) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(componentsMap);
  var this$3 = this$2.key__T__s_Option(keyword);
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = e.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
    $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parse$1) {
      return (function(entry$2) {
        var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
        var bindings = $as_Lamf_core_model_domain_DomainElement(parse$1.apply__O__O(entry));
        var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
        $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(bindings, annotation);
        return $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext().declarations$4.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(bindings)
      })
    })(this, parse)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype.parseMessageDeclarations__Lorg_yaml_model_YMap__T__V = (function(componentsMap, parent) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(componentsMap);
  var this$3 = this$2.key__T__s_Option("messages");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = e.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
    $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$1) {
      return (function(entry$2) {
        var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
        var jsx$1 = $m_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$();
        var errorHandler = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
        var message = jsx$1.apply__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__s_Option__Z__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser(new $c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike().init___Lorg_yaml_model_YMapEntry__Lorg_yaml_model_IllegalTypeHandler(entry, errorHandler), parent$1, $m_s_None$(), false, $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext()).parse__Lamf_plugins_domain_webapi_models_Message();
        var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
        $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(message, annotation);
        return $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext().declarations$4.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(message)
      })
    })(this, parent)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype.parseMessageBindingsDeclarations__Lorg_yaml_model_YMap__T__V = (function(componentsMap, parent) {
  this.parseBindingsDeclarations__T__Lorg_yaml_model_YMap__F1__V("messageBindings", componentsMap, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$1) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var errorHandler = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
      return $as_Lamf_plugins_domain_webapi_models_bindings_MessageBindings(new $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser().init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(new $c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike().init___Lorg_yaml_model_YMapEntry__Lorg_yaml_model_IllegalTypeHandler(entry, errorHandler), parent$1, $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext()).parse__Lamf_core_model_domain_NamedDomainElement())
    })
  })(this, parent)))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype.parseOperationTraits__Lorg_yaml_model_YMap__T__V = (function(componentsMap, parent) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(componentsMap);
  var this$3 = this$2.key__T__s_Option("operationTraits");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
    $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$2) {
      return (function(entry$2$2) {
        var entry$2 = $as_Lorg_yaml_model_YMapEntry(entry$2$2);
        var produceOperation = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, parent$2$1) {
          return (function(name$2) {
            var name = $as_T(name$2);
            $m_Lamf_core_parser_Annotations$();
            var annotations = new $c_Lamf_core_parser_Annotations().init___();
            var qual$1 = new $c_Lamf_plugins_domain_webapi_models_Operation().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
            $m_Lamf_core_parser_Annotations$();
            var x$2 = new $c_Lamf_core_parser_Annotations().init___();
            var this$9 = $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2));
            var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Method$1;
            var qual$2 = $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$9, field, name));
            $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
            return $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$2, parent$2$1))
          })
        })($this, parent$2));
        var operation = $m_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$().apply__Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser(entry$2, produceOperation, true, $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext()).parse__Lamf_plugins_domain_webapi_models_Operation();
        var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
        $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(operation, annotation);
        return $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext().declarations$4.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(operation)
      })
    })(this, parent)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype.parseWebApi__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_WebApi = (function(map) {
  $m_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$().validate__Lamf_core_Root__Lamf_plugins_document_webapi_contexts_WebApiContext__V(this.root$2, this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext());
  var qual$1 = $m_Lamf_plugins_domain_webapi_models_WebApi$().apply__Lorg_yaml_model_YNode__Lamf_plugins_domain_webapi_models_WebApi($as_Lamf_core_parser_SyamlParsedDocument(this.root$2.parsed$1).document$2.node$2);
  var x$1 = this.root$2.location$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var api = $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("info");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser().init___Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_WebApi__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(entry, api, this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext()).parse__V()
  };
  var this$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$6 = this$5.key__T__s_Option("id");
  if ((!this$6.isEmpty__Z())) {
    var arg1$1 = this$6.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    new $c_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser().init___Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_WebApi__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(entry$3, api, this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext()).parse__V()
  };
  var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("channels");
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    this.parseChannels__p2__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_WebApi__V(entry$4, api)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$8 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext().eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().MandatoryChannelsProperty$1;
      var node = api.id$1;
      var property = $m_s_None$();
      var lexical = $m_s_None$();
      var location = $m_s_None$();
      this$8.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "'channels' is mandatory in async spec", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  var this$10 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$11 = this$10.key__T__s_Option("externalDocs");
  if ((!this$11.isEmpty__Z())) {
    var arg1$2 = this$11.get__O();
    var entry$5 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Documentations$1;
    var jsx$1 = $m_sc_Seq$();
    var array = [new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser().init___Lorg_yaml_model_YNode__T__Lamf_plugins_document_webapi_contexts_WebApiContext(entry$5.value$2, api.id$1, this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext()).parse__Lamf_plugins_domain_shapes_models_CreativeWork()];
    var values = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
    $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(api, field, values)
  };
  var this$15 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$16 = this$15.key__T__s_Option("servers");
  if ((!this$16.isEmpty__Z())) {
    var arg1$3 = this$16.get__O();
    var entry$6 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
    var this$17 = entry$6.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
    var servers = new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServersParser().init___Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_WebApi__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$17, conversion, iv)), api, this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext()).parse__sc_Seq();
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Servers$1;
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(servers, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$6.value$2));
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$6);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(api, field$1, value, annotations)
  };
  var this$19 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$20 = this$19.key__T__s_Option("tags");
  if ((!this$20.isEmpty__Z())) {
    var arg1$4 = this$20.get__O();
    var entry$7 = $as_Lorg_yaml_model_YMapEntry(arg1$4);
    var tags = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser().init___T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(api.id$1, entry$7, this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext()).parse__sc_Seq();
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Tags$1;
    var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(tags, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$7.value$2));
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$7);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(api, field$2, value$1, annotations$1)
  };
  var this$22 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$23 = this$22.key__T__s_Option("defaultContentType");
  if ((!this$23.isEmpty__Z())) {
    var arg1$5 = this$23.get__O();
    var entry$8 = $as_Lorg_yaml_model_YMapEntry(arg1$5);
    var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$8);
    var node$1 = entry$8.value$2;
    var iv$1 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
    var this$25 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$1, iv$1);
    var contentType = this$25.string__Lamf_core_model_domain_AmfScalar();
    var jsx$2 = $m_sc_Seq$();
    var array$1 = [contentType];
    var value$2 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1))), new $c_Lamf_core_parser_Annotations().init___());
    var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().ContentType$1;
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(api, field$3, value$2, annotations$2);
    var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Accepts$1;
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(api, field$4, value$2, annotations$2)
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(api, map, $m_sci_Nil$(), this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext()).parse__V();
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(api, map, $m_sci_Nil$(), this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext()).parseOrphanNode__T__V("channels");
  this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext().closedShape__T__Lorg_yaml_model_YMap__T__V(api.id$1, map, "webApi");
  return api
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype.parseOperationBindingsDeclarations__Lorg_yaml_model_YMap__T__V = (function(componentsMap, parent) {
  this.parseBindingsDeclarations__T__Lorg_yaml_model_YMap__F1__V("operationBindings", componentsMap, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$1) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var errorHandler = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
      return $as_Lamf_plugins_domain_webapi_models_bindings_OperationBindings(new $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser().init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(new $c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike().init___Lorg_yaml_model_YMapEntry__Lorg_yaml_model_IllegalTypeHandler(entry, errorHandler), parent$1, $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext()).parse__Lamf_core_model_domain_NamedDomainElement())
    })
  })(this, parent)))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype.parseSecuritySchemeDeclarations__Lorg_yaml_model_YMap__T__V = (function(map, parent) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("securitySchemes");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = e.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
    $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$4) {
      return (function(entry$2) {
        var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
        var jsx$1 = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext().declarations$4;
        var this$5 = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
        var this$7 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser(this$5.factory$5.securitySchemeParser__F2().apply__O__O__O(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, entry$1, parent$4$1) {
          return (function(scheme$2) {
            var scheme = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(scheme$2);
            var this$6 = entry$1.key$2;
            var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
            var iv$1 = $this$1.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
            var name = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion$1, iv$1));
            var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Name$1;
            var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(name, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$1.key$2.value__Lorg_yaml_model_YValue()));
            var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$1.key$2);
            $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(scheme, field, value, annotations);
            return scheme.adopted__T__sc_Seq__Lamf_plugins_domain_webapi_models_security_SecurityScheme(parent$4$1, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())))
          })
        })($this, entry, parent$4)))).parse__Lamf_plugins_domain_webapi_models_security_SecurityScheme();
        var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
        return jsx$1.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$7, annotation)))
      })
    })(this, parent)))
  }
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_Publish$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_async_Publish$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_Publish$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_Publish$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_Publish$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_Publish$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_Publish$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_Publish$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_Publish$.prototype.productPrefix__T = (function() {
  return "Publish"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_Publish$.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_parser_spec_async_Publish$.prototype.field__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Request$1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_Publish$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_Publish$.prototype.toString__T = (function() {
  return "Publish"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_Publish$.prototype.hashCode__I = (function() {
  return 1429288175
});
$c_Lamf_plugins_document_webapi_parser_spec_async_Publish$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_Publish$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_Publish$: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.Publish$", {
  Lamf_plugins_document_webapi_parser_spec_async_Publish$: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_async_MessageType: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_Publish$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_Publish$;
var $n_Lamf_plugins_document_webapi_parser_spec_async_Publish$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_async_Publish$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_async_Publish$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_async_Publish$ = new $c_Lamf_plugins_document_webapi_parser_spec_async_Publish$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_async_Publish$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$.prototype.productPrefix__T = (function() {
  return "Subscribe"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$.prototype.field__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$.prototype.toString__T = (function() {
  return "Subscribe"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$.prototype.hashCode__I = (function() {
  return (-1776157398)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_Subscribe$: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.Subscribe$", {
  Lamf_plugins_document_webapi_parser_spec_async_Subscribe$: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_async_MessageType: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$;
var $n_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$ = new $c_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_async_Subscribe$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters() {
  $c_O.call(this);
  this.declares$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.emitters$1 = null;
  this.platform$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters.prototype.productPrefix__T = (function() {
  return "AsyncDeclarationsEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters)) {
    var AsyncDeclarationsEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters(x$1);
    var x = this.declares$1;
    var x$2 = AsyncDeclarationsEmitters$1.declares$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = AsyncDeclarationsEmitters$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = AsyncDeclarationsEmitters$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.declares$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(declares, ordering, references, spec) {
  this.declares$1 = declares;
  this.ordering$1 = ordering;
  this.references$1 = references;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  var declarations = $m_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$().apply__sc_Seq__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(declares, $m_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$(), new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___());
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$3 = declarations.securitySchemes$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$3)) {
    var this$4 = declarations.securitySchemes$2;
    var this$5 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$4);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySchemesEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this$5.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), ordering, spec))
  };
  var this$6 = declarations.messageTraits$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$6)) {
    var this$7 = declarations.messageTraits$2;
    var this$8 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$7);
    var this$9 = $m_sci_List$();
    var cbf = this$9.ReusableCBFInstance$2;
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter().init___sc_Seq__Z__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext($as_sci_List($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this$8, cbf)), true, ordering, spec))
  };
  var this$10 = declarations.messages$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$10)) {
    var this$11 = declarations.messages$2;
    var this$12 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$11);
    var this$13 = $m_sci_List$();
    var cbf$1 = this$13.ReusableCBFInstance$2;
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter().init___sc_Seq__Z__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext($as_sci_List($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this$12, cbf$1)), false, ordering, spec))
  };
  var this$14 = declarations.operationTraits$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$14)) {
    var this$15 = declarations.operationTraits$2;
    var this$16 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$15);
    var this$17 = $m_sci_List$();
    var cbf$2 = this$17.ReusableCBFInstance$2;
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext($as_sci_List($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this$16, cbf$2)), ordering, spec))
  };
  var this$18 = declarations.shapes$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$18)) {
    var jsx$1 = spec.factory__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory().declaredTypesEmitter__F3();
    var this$19 = declarations.shapes$2;
    var this$20 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$19);
    result.$$plus$eq__O__scm_ListBuffer(jsx$1.apply__O__O__O__O(this$20.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), references, ordering))
  };
  var this$21 = declarations.parameters$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$21)) {
    var this$22 = declarations.parameters$2;
    var this$23 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$22);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiParametersEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this$23.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), ordering, spec))
  };
  var this$24 = declarations.correlationIds$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$24)) {
    var this$25 = declarations.correlationIds$2;
    var this$26 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$25);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this$26.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), ordering, spec))
  };
  var this$27 = declarations.serverBindings$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$27)) {
    var this$28 = declarations.serverBindings$2;
    var this$29 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$28);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext("serverBindings", this$29.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), ordering, spec))
  };
  var this$30 = declarations.messageBindings$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$30)) {
    var this$31 = declarations.messageBindings$2;
    var this$32 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$31);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext("messageBindings", this$32.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), ordering, spec))
  };
  var this$33 = declarations.channelBindings$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$33)) {
    var this$34 = declarations.channelBindings$2;
    var this$35 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$34);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext("channelBindings", this$35.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), ordering, spec))
  };
  var this$36 = declarations.operationBindings$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$36)) {
    var this$37 = declarations.operationBindings$2;
    var this$38 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$37);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext("operationBindings", this$38.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), ordering, spec))
  };
  this.emitters$1 = result;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncDeclarationsEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.emitters.AsyncDeclarationsEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncDeclarationsEmitters", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncDeclarationsEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser() {
  $c_O.call(this);
  this.entryLike$1 = null;
  this.parentId$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser.prototype.productPrefix__T = (function() {
  return "AsyncCorrelationIdParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser)) {
    var AsyncCorrelationIdParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser(x$1);
    var x = this.entryLike$1;
    var x$2 = AsyncCorrelationIdParser$1.entryLike$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      return (this.parentId$1 === AsyncCorrelationIdParser$1.parentId$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entryLike$1;
      break
    }
    case 1: {
      return this.parentId$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser.prototype.nameAndAdopt__p1__Lamf_plugins_domain_webapi_models_CorrelationId__s_Option__Lamf_plugins_domain_webapi_models_CorrelationId = (function(correlationId, key) {
  if ((!key.isEmpty__Z())) {
    var arg1 = key.get__O();
    var k = $as_Lorg_yaml_model_YNode(arg1);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$().Name$1;
    var iv = this.ctx$1;
    var this$2 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(k, iv);
    var value = this$2.string__Lamf_core_model_domain_AmfScalar();
    $as_Lamf_plugins_domain_webapi_models_CorrelationId($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(correlationId, field, value))
  };
  var parent = this.parentId$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$3 = $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(correlationId, parent);
  var other = this.entryLike$1.annotations__Lamf_core_parser_Annotations();
  return $as_Lamf_plugins_domain_webapi_models_CorrelationId($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$3, other))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(entryLike, parentId, ctx) {
  this.entryLike$1 = entryLike;
  this.parentId$1 = parentId;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser.prototype.parse__Lamf_plugins_domain_webapi_models_CorrelationId = (function() {
  var map = this.entryLike$1.asMap__Lorg_yaml_model_YMap();
  var x1 = this.ctx$1.link__Lorg_yaml_model_YNode__s_util_Either(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1)));
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var fullRef = $as_T(x2.value$2);
    return this.handleRef__p1__Lorg_yaml_model_YMap__T__Lamf_plugins_domain_webapi_models_CorrelationId(map, fullRef)
  } else if ((x1 instanceof $c_s_util_Right)) {
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var correlationId = new $c_Lamf_plugins_domain_webapi_models_CorrelationId().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
    this.nameAndAdopt__p1__Lamf_plugins_domain_webapi_models_CorrelationId__s_Option__Lamf_plugins_domain_webapi_models_CorrelationId(correlationId, this.entryLike$1.key__s_Option());
    return new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator().init___Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_CorrelationId__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(map, correlationId, this.ctx$1).populate__Lamf_plugins_domain_webapi_models_CorrelationId()
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser.prototype.handleRef__p1__Lorg_yaml_model_YMap__T__Lamf_plugins_domain_webapi_models_CorrelationId = (function(map, fullRef) {
  var label = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().stripOas3ComponentsPrefix__T__T__T(fullRef, "correlationIds");
  var this$1 = this.ctx$1.declarations$4.findCorrelationId__T__Lamf_core_parser_SearchScope$Scope__s_Option(label, $m_Lamf_core_parser_SearchScope$Named$());
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var correlationId = $as_Lamf_plugins_domain_webapi_models_CorrelationId(arg1);
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var this$3 = new $c_s_Some().init___O(this.nameAndAdopt__p1__Lamf_plugins_domain_webapi_models_CorrelationId__s_Option__Lamf_plugins_domain_webapi_models_CorrelationId($as_Lamf_plugins_domain_webapi_models_CorrelationId($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(correlationId, label, annotations)), this.entryLike$1.key__s_Option()))
  };
  return $as_Lamf_plugins_domain_webapi_models_CorrelationId((this$3.isEmpty__Z() ? this.remote__p1__T__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_CorrelationId(fullRef, map) : this$3.get__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser.prototype.remote__p1__T__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_CorrelationId = (function(fullRef, map) {
  var this$3 = this.ctx$1;
  $m_Lamf_core_parser_Annotations$();
  new $c_Lamf_core_parser_Annotations().init___();
  var x1 = this$3.jsonSchemaRefGuide$2.obtainRemoteYNode__T__s_Option(fullRef);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var correlationIdNode = $as_Lorg_yaml_model_YNode(x2.value$2);
    var errorHandler = this.ctx$1;
    var external = new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser().init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(new $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(correlationIdNode, errorHandler), this.parentId$1, this.ctx$1).parse__Lamf_plugins_domain_webapi_models_CorrelationId();
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    return this.nameAndAdopt__p1__Lamf_plugins_domain_webapi_models_CorrelationId__s_Option__Lamf_plugins_domain_webapi_models_CorrelationId($as_Lamf_plugins_domain_webapi_models_CorrelationId($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(external, fullRef, annotations)), this.entryLike$1.key__s_Option())
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$6 = this.ctx$1.eh$1;
      var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnresolvedReference$1;
      var message = ("Cannot find link reference " + fullRef);
      var prop = $m_s_None$();
      var l = map.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$6, specification, "", prop, message, l);
      var errorCorrelation = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCorrelationId().init___T__Lorg_yaml_model_YPart(fullRef, map);
      var annotations$1 = errorCorrelation.annotations$1;
      return this.nameAndAdopt__p1__Lamf_plugins_domain_webapi_models_CorrelationId__s_Option__Lamf_plugins_domain_webapi_models_CorrelationId($as_Lamf_plugins_domain_webapi_models_CorrelationId($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(errorCorrelation, fullRef, annotations$1)), this.entryLike$1.key__s_Option())
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncCorrelationIdParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.parser.AsyncCorrelationIdParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncCorrelationIdParser", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncCorrelationIdParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser() {
  $c_O.call(this);
  this.parentId$1 = null;
  this.entryLike$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype.parse__Lamf_plugins_domain_webapi_models_Parameter = (function() {
  var map = this.entryLike$1.asMap__Lorg_yaml_model_YMap();
  var x1 = this.ctx$1.link__Lorg_yaml_model_YNode__s_util_Either(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1)));
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var fullRef = $as_T(x2.value$2);
    return this.handleRef__p1__Lorg_yaml_model_YMap__T__Lamf_plugins_domain_webapi_models_Parameter(map, fullRef)
  } else if ((x1 instanceof $c_s_util_Right)) {
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var param = new $c_Lamf_plugins_domain_webapi_models_Parameter().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
    this.nameAndAdopt__p1__Lamf_plugins_domain_webapi_models_Parameter__Lamf_plugins_domain_webapi_models_Parameter(param);
    return this.populateParam__Lamf_plugins_domain_webapi_models_Parameter__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Parameter(param, map)
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype.productPrefix__T = (function() {
  return "AsyncParameterParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype.handleRef__p1__Lorg_yaml_model_YMap__T__Lamf_plugins_domain_webapi_models_Parameter = (function(map, fullRef) {
  var label = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().stripOas3ComponentsPrefix__T__T__T(fullRef, "parameters");
  var this$1 = this.ctx$1.declarations$4.findParameter__T__Lamf_core_parser_SearchScope$Scope__s_Option(label, $m_Lamf_core_parser_SearchScope$Named$());
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var param = $as_Lamf_plugins_domain_webapi_models_Parameter(arg1);
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var this$3 = new $c_s_Some().init___O(this.nameAndAdopt__p1__Lamf_plugins_domain_webapi_models_Parameter__Lamf_plugins_domain_webapi_models_Parameter($as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(param, label, annotations))))
  };
  return $as_Lamf_plugins_domain_webapi_models_Parameter((this$3.isEmpty__Z() ? this.remote__p1__T__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Parameter(fullRef, map) : this$3.get__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype.init___T__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(parentId, entryLike, ctx) {
  this.parentId$1 = parentId;
  this.entryLike$1 = entryLike;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser)) {
    var AsyncParameterParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser(x$1);
    if ((this.parentId$1 === AsyncParameterParser$1.parentId$1)) {
      var x = this.entryLike$1;
      var x$2 = AsyncParameterParser$1.entryLike$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.parentId$1;
      break
    }
    case 1: {
      return this.entryLike$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype.inferAsUriParameter__p1__Lamf_plugins_domain_webapi_models_Parameter__Lamf_plugins_domain_webapi_models_Parameter = (function(param) {
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
  var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations("path", new $c_Lamf_core_parser_Annotations().init___());
  var annotations = ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SynthesizedField().init___());
  return $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(param, field, value, annotations))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype.parseSchema__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Parameter__V = (function(map, param) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("schema");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$5 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, param$2) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        $m_Lamf_core_parser_Annotations$();
        var a = new $c_Lamf_core_parser_Annotations().init___();
        var qual$1 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, "schema", a));
        var x$1 = param$2.id$1;
        var x$2 = qual$1.adopted$default$2__sc_Seq();
        qual$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$1, x$2)
      })
    })(this, param)), $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$(), this.ctx$1).parse__s_Option();
    if ((!this$5.isEmpty__Z())) {
      var arg1$1 = this$5.get__O();
      var schema = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1$1);
      var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1;
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
      $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(param, field, schema, annotations))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype.nameAndAdopt__p1__Lamf_plugins_domain_webapi_models_Parameter__Lamf_plugins_domain_webapi_models_Parameter = (function(param) {
  var this$1 = this.entryLike$1.key__s_Option();
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var k = $as_Lorg_yaml_model_YNode(arg1);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1;
    var iv = this.ctx$1;
    var this$3 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(k, iv);
    var value = this$3.string__Lamf_core_model_domain_AmfScalar();
    $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(param, field, value))
  };
  var parent = this.parentId$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$4 = $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(param, parent);
  var other = this.entryLike$1.annotations__Lamf_core_parser_Annotations();
  return $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$4, other))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype.populateParam__Lamf_plugins_domain_webapi_models_Parameter__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Parameter = (function(param, map) {
  this.parseSchema__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Parameter__V(map, param);
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Description$1;
  var iv = this.ctx$1;
  jsx$1.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(param));
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
  var iv$1 = this.ctx$1;
  jsx$2.key__T__F1__V("location", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(param));
  var this$3 = $as_Lamf_core_model_StrField(param.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
  if ($f_Lamf_core_model_StrField__isNullOrEmpty__Z(this$3)) {
    this.inferAsUriParameter__p1__Lamf_plugins_domain_webapi_models_Parameter__Lamf_plugins_domain_webapi_models_Parameter(param)
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(param, map, $m_sci_Nil$(), this.ctx$1).parse__V();
  this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(param.id$1, map, "parameter");
  return param
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype.remote__p1__T__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Parameter = (function(fullRef, map) {
  var this$3 = this.ctx$1;
  $m_Lamf_core_parser_Annotations$();
  new $c_Lamf_core_parser_Annotations().init___();
  var x1 = this$3.jsonSchemaRefGuide$2.obtainRemoteYNode__T__s_Option(fullRef);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var paramNode = $as_Lorg_yaml_model_YNode(x2.value$2);
    var jsx$1 = this.parentId$1;
    var errorHandler = this.ctx$1;
    var external = new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser().init___T__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(jsx$1, new $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(paramNode, errorHandler), this.ctx$1).parse__Lamf_plugins_domain_webapi_models_Parameter();
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    return this.nameAndAdopt__p1__Lamf_plugins_domain_webapi_models_Parameter__Lamf_plugins_domain_webapi_models_Parameter($as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(external, fullRef, annotations)))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$6 = this.ctx$1.eh$1;
      var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnresolvedReference$1;
      var message = ("Cannot find link reference " + fullRef);
      var prop = $m_s_None$();
      var l = map.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$6, specification, "", prop, message, l);
      var this$7 = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter().init___T__Lorg_yaml_model_YPart(fullRef, map);
      var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(map);
      return this.nameAndAdopt__p1__Lamf_plugins_domain_webapi_models_Parameter__Lamf_plugins_domain_webapi_models_Parameter($as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this$7, fullRef, annotations$1)))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncParameterParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.parser.AsyncParameterParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncParameterParser", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParameterParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser$$anonfun$1.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var s = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(x2.value$2);
    return s
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser$$anonfun$1.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  return (x1 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncServerParser$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator() {
  $c_O.call(this);
  this.map$1 = null;
  this.correlationId$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator.prototype.init___Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_CorrelationId__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(map, correlationId, ctx) {
  this.map$1 = map;
  this.correlationId$1 = correlationId;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator.prototype.productPrefix__T = (function() {
  return "CorrelationIdPopulator"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator)) {
    var CorrelationIdPopulator$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator(x$1);
    var this$1 = this.map$1;
    var b = CorrelationIdPopulator$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.correlationId$1;
      var x$2 = CorrelationIdPopulator$1.correlationId$1;
      return (x === x$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.correlationId$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$2__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator.prototype.EmptyTarget$lzycompute$2__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator.prototype.populate__Lamf_plugins_domain_webapi_models_CorrelationId = (function() {
  var map = this.map$1;
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$().Description$1;
  var iv = this.ctx$1;
  jsx$1.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.correlationId$1));
  var map$1 = this.map$1;
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$().Location$1;
  var iv$1 = this.ctx$1;
  jsx$2.key__T__F1__V("location", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.correlationId$1));
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(this.correlationId$1, this.map$1, $m_sci_Nil$(), this.ctx$1).parse__V();
  this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(this.correlationId$1.id$1, this.map$1, "correlationId");
  return this.correlationId$1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.parser.CorrelationIdPopulator"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.parser.CorrelationIdPopulator;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.CorrelationIdPopulator", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_CorrelationIdPopulator;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder() {
  $c_O.call(this);
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder.prototype.productPrefix__T = (function() {
  return "MessageFinder"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder) && ($as_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder(x$1), true))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder.prototype.findInComponents__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(label, scope) {
  return this.ctx$1.declarations$4.findMessage__T__Lamf_core_parser_SearchScope$Scope__s_Option(label, $m_Lamf_core_parser_SearchScope$Named$())
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder.prototype.label__T__T = (function(fullRef) {
  return $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().stripOas3ComponentsPrefix__T__T__T(fullRef, "messages")
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder.prototype.init___Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(ctx) {
  this.ctx$1 = ctx;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.parser.MessageFinder"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.parser.MessageFinder;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.MessageFinder", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_async_parser_Finder: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageFinder;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder() {
  $c_O.call(this);
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder.prototype.productPrefix__T = (function() {
  return "MessageTraitFinder"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder) && ($as_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder(x$1), true))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder.prototype.findInComponents__T__Lamf_core_parser_SearchScope$Scope__s_Option = (function(label, scope) {
  return this.ctx$1.declarations$4.findMessageTrait__T__Lamf_core_parser_SearchScope$Scope__s_Option(label, $m_Lamf_core_parser_SearchScope$Named$())
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder.prototype.label__T__T = (function(fullRef) {
  return $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().stripOas3ComponentsPrefix__T__T__T(fullRef, "messageTraits")
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder.prototype.init___Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(ctx) {
  this.ctx$1 = ctx;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.parser.MessageTraitFinder"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.parser.MessageTraitFinder;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.MessageTraitFinder", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_async_parser_Finder: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_MessageTraitFinder;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike() {
  $c_O.call(this);
  this.e$1 = null;
  this.errorHandler$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike.prototype.init___Lorg_yaml_model_YMapEntry__Lorg_yaml_model_IllegalTypeHandler = (function(e, errorHandler) {
  this.e$1 = e;
  this.errorHandler$1 = errorHandler;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike.prototype.productPrefix__T = (function() {
  return "RealYMapEntryLike"
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike)) {
    var RealYMapEntryLike$1 = $as_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike(x$1);
    var x = this.e$1;
    var x$2 = RealYMapEntryLike$1.e$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike.prototype.asMap__Lorg_yaml_model_YMap = (function() {
  var this$1 = this.e$1.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.errorHandler$1;
  return $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.e$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.e$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike.prototype.key__s_Option = (function() {
  return new $c_s_Some().init___O(this.e$1.key$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike.prototype.value__Lorg_yaml_model_YNode = (function() {
  return this.e$1.value$2
});
function $as_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.common.RealYMapEntryLike"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.common.RealYMapEntryLike;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.RealYMapEntryLike", {
  Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_RealYMapEntryLike;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$() {
  $c_O.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$.prototype.productPrefix__T = (function() {
  return "EmptyTarget"
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$.prototype.toString__T = (function() {
  return "EmptyTarget"
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$.prototype.foreach__F1__V = (function(fn) {
  /*<skip>*/
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$.prototype.hashCode__I = (function() {
  return (-1432904418)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$.prototype.init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps = (function($$outer) {
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.SpecParserOps$EmptyTarget$", {
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$Target: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget() {
  $c_O.call(this);
  this.elem$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget.prototype.productPrefix__T = (function() {
  return "SingleTarget"
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget) && ($as_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget(x$1).$$outer$1 === this.$$outer$1))) {
    var SingleTarget$1 = $as_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget(x$1);
    var x = this.elem$1;
    var x$2 = SingleTarget$1.elem$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.elem$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget.prototype.foreach__F1__V = (function(fn) {
  fn.apply__O__O(this.elem$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget.prototype.init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_model_domain_DomainElement = (function($$outer, elem) {
  this.elem$1 = elem;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.common.SpecParserOps$SingleTarget"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.common.SpecParserOps$SingleTarget;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.SpecParserOps$SingleTarget", {
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$Target: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$SingleTarget;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike() {
  $c_O.call(this);
  this.n$1 = null;
  this.errorHandler$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike.prototype.productPrefix__T = (function() {
  return "YNodeYMapEntryLike"
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike)) {
    var YNodeYMapEntryLike$1 = $as_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike(x$1);
    var this$1 = this.n$1;
    var b = YNodeYMapEntryLike$1.n$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike.prototype.asMap__Lorg_yaml_model_YMap = (function() {
  var this$1 = this.n$1;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.errorHandler$1;
  return $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.n$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.n$1.value__Lorg_yaml_model_YValue())
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike.prototype.key__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike.prototype.init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler = (function(n, errorHandler) {
  this.n$1 = n;
  this.errorHandler$1 = errorHandler;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike.prototype.value__Lorg_yaml_model_YNode = (function() {
  return this.n$1
});
function $as_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.common.YNodeYMapEntryLike"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.common.YNodeYMapEntryLike;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.YNodeYMapEntryLike", {
  Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this);
  this.$$outer$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1.prototype.applyOrElse__Lamf_core_emitter_Emitter__F1__O = (function(x1, $default) {
  if ($is_Lamf_core_emitter_EntryEmitter(x1)) {
    var x2 = $as_Lamf_core_emitter_EntryEmitter(x1);
    return new $c_s_Some().init___O(x2)
  } else if ((x1 instanceof $c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter)) {
    var x3 = $as_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter(x1);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$1().init___Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1__Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter(this, x3))
  } else if ((x1 instanceof $c_Lamf_core_emitter_BaseEmitters_package$NullEmitter)) {
    var x4 = $as_Lamf_core_emitter_BaseEmitters_package$NullEmitter(x1);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1$$anon$2().init___Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1__Lamf_core_emitter_BaseEmitters_package$NullEmitter(this, x4))
  } else {
    var this$3 = this.$$outer$2.amf$plugins$document$webapi$parser$spec$declaration$DataNodeEmitter$$eh$f;
    var specification = $m_Lamf_validations_RenderSideValidations$().RenderValidation$1;
    var node = this.$$outer$2.dataNode$1.id$1;
    var property = $m_s_None$();
    var message = ("Unsupported seq of emitter type in data node emitters " + x1);
    var this$1 = this.$$outer$2.dataNode$1;
    var lexical = this$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var this$2 = this.$$outer$2.dataNode$1;
    var location = $f_Lamf_core_model_domain_AmfElement__location__s_Option(this$2);
    this$3.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1.prototype.isDefinedAt__Lamf_core_emitter_Emitter__Z = (function(x1) {
  return ($is_Lamf_core_emitter_EntryEmitter(x1) || ((x1 instanceof $c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter) || true))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_emitter_Emitter__Z($as_Lamf_core_emitter_Emitter(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_emitter_Emitter__F1__O($as_Lamf_core_emitter_Emitter(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.DataNodeEmitter$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter$$anonfun$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter$$anonfun$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter$$anonfun$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter$$anonfun$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter$$anonfun$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter$$anonfun$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter$$anonfun$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter$$anonfun$2.prototype.isDefinedAt__Lorg_yaml_model_YPart__Z = (function(x1) {
  return (x1 instanceof $c_Lorg_yaml_model_YMapEntry)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter$$anonfun$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter$$anonfun$2.prototype.applyOrElse__Lorg_yaml_model_YPart__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lorg_yaml_model_YMapEntry)) {
    var x2 = $as_Lorg_yaml_model_YMapEntry(x1);
    return $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(x2.key$2)
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter$$anonfun$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lorg_yaml_model_YPart__Z($as_Lorg_yaml_model_YPart(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter$$anonfun$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lorg_yaml_model_YPart__F1__O($as_Lorg_yaml_model_YPart(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter$$anonfun$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter$$anonfun$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.DataPropertyEmitter$$anonfun$2", {
  Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter$$anonfun$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter$$anonfun$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter$$anonfun$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter = (function($$outer) {
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.ExtendsEmitter$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$2.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x2) {
  return (x2 instanceof $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$2.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x2, $default) {
  if ((x2 instanceof $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait)) {
    var x2$2 = $as_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait(x2);
    return x2$2
  } else {
    return $default.apply__O__O(x2)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter = (function($$outer) {
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.ExtendsEmitter$$anonfun$2", {
  Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter$$anonfun$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter.call(this);
  this.property$2 = null;
  this.ordering$2 = null;
  this.spec$2 = null;
  this.fs$2 = null;
  this.shapeEmitters$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter.prototype.productPrefix__T = (function() {
  return "OasAnnotationTypeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter)) {
    var OasAnnotationTypeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter(x$1);
    var x = this.property$2;
    var x$2 = OasAnnotationTypeEmitter$1.property$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = OasAnnotationTypeEmitter$1.ordering$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.property$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter.prototype.shapeEmitters__sc_Seq = (function() {
  return this.shapeEmitters$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter.prototype.init___Lamf_core_model_domain_extensions_CustomDomainProperty__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(property, ordering, spec) {
  this.property$2 = property;
  this.ordering$2 = ordering;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter.prototype.init___Lamf_core_model_domain_extensions_CustomDomainProperty__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, property, ordering, spec);
  this.fs$2 = property.fields$1;
  var this$1 = this.fs$2.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Schema$1);
  if (this$1.isEmpty__Z()) {
    var xo = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    var xo = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(f, this.ordering$2, $m_sci_Nil$(), this.spec$2))
  };
  var this$3 = xo.toList__sci_List();
  this.shapeEmitters$2 = this$3;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasAnnotationTypeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasAnnotationTypeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasAnnotationTypeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationTypeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser() {
  $c_O.call(this);
  this.node$1 = null;
  this.parentId$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser.prototype.productPrefix__T = (function() {
  return "OasLikeCreativeWorkParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser)) {
    var OasLikeCreativeWorkParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser(x$1);
    var this$1 = this.node$1;
    var b = OasLikeCreativeWorkParser$1.node$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      return (this.parentId$1 === OasLikeCreativeWorkParser$1.parentId$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.node$1;
      break
    }
    case 1: {
      return this.parentId$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser.prototype.parse__Lamf_plugins_domain_shapes_models_CreativeWork = (function() {
  var this$1 = this.node$1;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$1;
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var creativeWork = $m_Lamf_plugins_domain_shapes_models_CreativeWork$().apply__Lorg_yaml_model_YNode__Lamf_plugins_domain_shapes_models_CreativeWork(this.node$1);
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Url$1;
  var iv$1 = this.ctx$1;
  jsx$1.key__T__F1__V("url", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(creativeWork));
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Description$1;
  var iv$2 = this.ctx$1;
  jsx$2.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(creativeWork));
  var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var jsx$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T("title").asOasExtension__T();
  var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Title$1;
  var iv$3 = this.ctx$1;
  jsx$4.key__T__F1__V(jsx$3, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(creativeWork));
  var parent = this.parentId$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(creativeWork, parent);
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(creativeWork, map, $m_sci_Nil$(), this.ctx$1).parse__V();
  var x = this.ctx$1.syntax__Lamf_plugins_document_webapi_parser_spec_SpecSyntax();
  var x$2 = $m_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$();
  if (((x !== null) && (x === x$2))) {
    var jsx$5 = true
  } else {
    var x$3 = this.ctx$1.syntax__Lamf_plugins_document_webapi_parser_spec_SpecSyntax();
    var x$4 = $m_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$();
    var jsx$5 = ((x$3 !== null) && (x$3 === x$4))
  };
  if (jsx$5) {
    this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(creativeWork.id$1, map, "externalDoc")
  };
  return creativeWork
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser.prototype.init___Lorg_yaml_model_YNode__T__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(node, parentId, ctx) {
  this.node$1 = node;
  this.parentId$1 = parentId;
  this.ctx$1 = ctx;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasLikeCreativeWorkParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasLikeCreativeWorkParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasLikeCreativeWorkParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser() {
  $c_O.call(this);
  this.parentId$1 = null;
  this.entry$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser.prototype.productPrefix__T = (function() {
  return "OasLikeTagsParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser)) {
    var OasLikeTagsParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser(x$1);
    if ((this.parentId$1 === OasLikeTagsParser$1.parentId$1)) {
      var x = this.entry$1;
      var x$2 = OasLikeTagsParser$1.entry$1;
      return (x === x$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.parentId$1;
      break
    }
    case 1: {
      return this.entry$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser.prototype.init___T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function(parentId, entry, ctx) {
  this.parentId$1 = parentId;
  this.entry$1 = entry;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser.prototype.parse__sc_Seq = (function() {
  var this$3 = this.entry$1.value$2;
  var reader = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var this$2 = $m_sc_IndexedSeq$();
  var bf = this$2.ReusableCBF$6;
  var conversion = new $c_Lorg_yaml_convert_YRead$$anon$1().init___scg_CanBuildFrom__Lorg_yaml_convert_YRead(bf, reader);
  var iv = this.ctx$1;
  var jsx$2 = $as_sc_TraversableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(tag$2) {
      var tag = $as_Lorg_yaml_model_YMap(tag$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$().apply__Lorg_yaml_model_YNode__F1__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_domain_TagsParser(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(tag, $m_Lorg_yaml_model_YType$().Map$1)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
        return (function(tag$2$2) {
          var tag$2$1 = $as_Lamf_plugins_domain_webapi_models_Tag(tag$2$2);
          var parent = $this$1.parentId$1;
          $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
          return $as_Lamf_plugins_domain_webapi_models_Tag($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(tag$2$1, parent))
        })
      })($this)), $this.ctx$1).parse__Lamf_plugins_domain_webapi_models_Tag()
    })
  })(this));
  var this$6 = $m_sc_Seq$();
  var tags = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2));
  this.validateDuplicated__p1__sc_Seq__Lorg_yaml_model_YMapEntry__V(tags, this.entry$1);
  return tags
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser.prototype.validateDuplicated__p1__sc_Seq__Lorg_yaml_model_YMapEntry__V = (function(tags, entry) {
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(tag$2) {
      var tag = $as_Lamf_plugins_domain_webapi_models_Tag(tag$2);
      var this$1 = $as_Lamf_core_model_StrField(tag.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TagModel$().Name$1)).option$1;
      if (this$1.isEmpty__Z()) {
        var xo = $m_s_None$()
      } else {
        var arg1 = this$1.get__O();
        var x$1 = $as_T(arg1);
        var xo = new $c_s_Some().init___O(new $c_T2().init___O__O(x$1, tag))
      };
      return xo.toList__sci_List()
    })
  })(this));
  var this$5 = $m_sc_Seq$();
  var groupedByName = $as_sc_TraversableLike(tags.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2)).groupBy__F1__sci_Map(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var name = $as_T(x0$1.$$und1__O());
        return name
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this)));
  var pf = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser(this);
  var this$6 = $m_sci_Iterable$();
  var bf = this$6.ReusableCBFInstance$2;
  var namesWithTag = $as_sci_Iterable($as_scg_GenericTraversableTemplate($f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(groupedByName, pf, bf)).flatten__F1__sc_GenTraversable($m_s_Predef$().singleton$und$less$colon$less$2));
  namesWithTag.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x0$2$2) {
      var x0$2 = $as_T2(x0$2$2);
      if ((x0$2 !== null)) {
        var name$1 = $as_T(x0$2.$$und1__O());
        var tag$1 = $as_Lamf_plugins_domain_webapi_models_Tag(x0$2.$$und2__O());
        var this$7 = this$3$1.ctx$1.eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().DuplicatedTags$1;
        var node = tag$1.id$1;
        var message = (("Tag with name '" + name$1) + "' was found duplicated");
        var annotations = tag$1.annotations$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$7, specification, node, message, annotations)
      } else {
        throw new $c_s_MatchError().init___O(x0$2)
      }
    })
  })(this)))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasLikeTagsParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasLikeTagsParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasLikeTagsParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser$$anonfun$1.prototype.applyOrElse__T2__F1__O = (function(x1, $default) {
  if ((x1 !== null)) {
    var ys = $as_sc_Seq(x1.$$und2__O());
    if ((ys.lengthCompare__I__I(1) > 0)) {
      return ys.tail__O()
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__T2__Z($as_T2(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__T2__F1__O($as_T2(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser$$anonfun$1.prototype.isDefinedAt__T2__Z = (function(x1) {
  if ((x1 !== null)) {
    var ys = $as_sc_Seq(x1.$$und2__O());
    if ((ys.lengthCompare__I__I(1) > 0)) {
      return true
    }
  };
  return false
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasLikeTagsParser$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$$anonfun$1.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var t = $as_Lamf_plugins_domain_shapes_models_AnyShape(x2.value$2);
    if ((t !== null)) {
      return t
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$$anonfun$1.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var t = $as_Lamf_plugins_domain_shapes_models_AnyShape(x2.value$2);
    if ((t !== null)) {
      return true
    }
  };
  return false
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser$$anonfun$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser$$anonfun$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser$$anonfun$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser$$anonfun$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser$$anonfun$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser$$anonfun$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser$$anonfun$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser$$anonfun$2.prototype.isDefinedAt__Lorg_yaml_model_YNode__Z = (function(x1) {
  var x = x1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x$2 = $m_Lorg_yaml_model_YType$().Map$1;
  return (x === x$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser$$anonfun$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser$$anonfun$2.prototype.applyOrElse__Lorg_yaml_model_YNode__F1__O = (function(x1, $default) {
  var x = x1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x$2 = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x$2)) {
    return x1
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser$$anonfun$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lorg_yaml_model_YNode__Z($as_Lorg_yaml_model_YNode(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser$$anonfun$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lorg_yaml_model_YNode__F1__O($as_Lorg_yaml_model_YNode(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser$$anonfun$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser$$anonfun$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$TupleShapeParser$$anonfun$2", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser$$anonfun$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser$$anonfun$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser$$anonfun$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter.call(this);
  this.property$2 = null;
  this.ordering$2 = null;
  this.spec$2 = null;
  this.fs$2 = null;
  this.shapeEmitters$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter.prototype.productPrefix__T = (function() {
  return "RamlAnnotationTypeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter)) {
    var RamlAnnotationTypeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter(x$1);
    var x = this.property$2;
    var x$2 = RamlAnnotationTypeEmitter$1.property$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = RamlAnnotationTypeEmitter$1.ordering$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.property$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter.prototype.init___Lamf_core_model_domain_extensions_CustomDomainProperty__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(property, ordering, spec) {
  this.property$2 = property;
  this.ordering$2 = ordering;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter.prototype.init___Lamf_core_model_domain_extensions_CustomDomainProperty__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, property, ordering, spec);
  this.fs$2 = property.fields$1;
  var this$1 = this.fs$2.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Schema$1);
  if (this$1.isEmpty__Z()) {
    var x1$1 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    var rc8 = false;
    var x2 = null;
    var x1 = $m_s_Option$().apply__O__s_Option(f.value$1.value$1);
    matchEnd9: {
      var jsx$1;
      if ((x1 instanceof $c_s_Some)) {
        rc8 = true;
        x2 = $as_s_Some(x1);
        var shape = $as_Lamf_core_model_domain_AmfElement(x2.value$2);
        if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
          var x5 = $as_Lamf_plugins_domain_shapes_models_AnyShape(shape);
          var x1$2 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x5, this.ordering$2, $m_sci_Nil$(), $m_sci_Nil$(), false, this.spec$2).emitters__sc_Seq();
          if (x1$2.forall__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
            return (function(x$13$2) {
              var x$13 = $as_Lamf_core_emitter_Emitter(x$13$2);
              return (x$13 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypeExpressionEmitter)
            })
          })(this)))) {
            var jsx$1 = x1$2;
            break matchEnd9
          } else {
            if ((!x1$2.forall__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
              return (function(x$14$2) {
                var x$14 = $as_Lamf_core_emitter_Emitter(x$14$2);
                return $is_Lamf_core_emitter_EntryEmitter(x$14)
              })
            })(this))))) {
              throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("IllegalTypeDeclarations found: " + x1$2)))
            };
            var jsx$2 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter$$anonfun$$nestedInanonfun$shapeEmitters$1$1().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter(this);
            var this$3 = $m_sc_Seq$();
            var jsx$1 = $as_sc_Seq(x1$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$2, this$3.ReusableCBFInstance$2));
            break matchEnd9
          }
        }
      };
      if (rc8) {
        var shape$2 = $as_Lamf_core_model_domain_AmfElement(x2.value$2);
        if ((shape$2 instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
          var x6 = $as_Lamf_core_model_domain_RecursiveShape(shape$2);
          var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter().init___Lamf_core_model_domain_RecursiveShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x6, this.ordering$2, $m_sci_Nil$(), this.spec$2).emitters__sc_Seq();
          break matchEnd9
        }
      };
      if (rc8) {
        var x = $as_Lamf_core_model_domain_AmfElement(x2.value$2);
        var this$4 = this.spec$2;
        var this$5 = this$4.eh$1;
        var specification = $m_Lamf_validations_RenderSideValidations$().RenderValidation$1;
        var node = this.property$2.id$1;
        var property$1 = $m_s_None$();
        var lexical = x.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
        var location = x.location__s_Option();
        this$5.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property$1, "Cannot emit raml type for a shape that is not an AnyShape", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
        var jsx$1 = $m_sci_Nil$();
        break matchEnd9
      };
      var jsx$1 = $m_sci_Nil$()
    };
    var x1$1 = new $c_s_Some().init___O(jsx$1)
  };
  if ((x1$1 instanceof $c_s_Some)) {
    var x2$1 = $as_s_Some(x1$1);
    var emitters = $as_sc_Seq(x2$1.value$2);
    var jsx$3 = emitters
  } else {
    var jsx$3 = $m_sci_Nil$()
  };
  this.shapeEmitters$2 = jsx$3;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter.prototype.shapeEmitters__sc_Seq = (function() {
  return this.shapeEmitters$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlAnnotationTypeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlAnnotationTypeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlAnnotationTypeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter$$anonfun$$nestedInanonfun$shapeEmitters$1$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter$$anonfun$$nestedInanonfun$shapeEmitters$1$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter$$anonfun$$nestedInanonfun$shapeEmitters$1$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter$$anonfun$$nestedInanonfun$shapeEmitters$1$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter$$anonfun$$nestedInanonfun$shapeEmitters$1$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter$$anonfun$$nestedInanonfun$shapeEmitters$1$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter$$anonfun$$nestedInanonfun$shapeEmitters$1$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter$$anonfun$$nestedInanonfun$shapeEmitters$1$1.prototype.applyOrElse__Lamf_core_emitter_Emitter__F1__O = (function(x1, $default) {
  if ($is_Lamf_core_emitter_EntryEmitter(x1)) {
    var x2 = $as_Lamf_core_emitter_EntryEmitter(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter$$anonfun$$nestedInanonfun$shapeEmitters$1$1.prototype.isDefinedAt__Lamf_core_emitter_Emitter__Z = (function(x1) {
  return $is_Lamf_core_emitter_EntryEmitter(x1)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter$$anonfun$$nestedInanonfun$shapeEmitters$1$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter$$anonfun$$nestedInanonfun$shapeEmitters$1$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_emitter_Emitter__Z($as_Lamf_core_emitter_Emitter(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter$$anonfun$$nestedInanonfun$shapeEmitters$1$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_emitter_Emitter__F1__O($as_Lamf_core_emitter_Emitter(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter$$anonfun$$nestedInanonfun$shapeEmitters$1$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter$$anonfun$$nestedInanonfun$shapeEmitters$1$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlAnnotationTypeEmitter$$anonfun$$nestedInanonfun$shapeEmitters$1$1", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter$$anonfun$$nestedInanonfun$shapeEmitters$1$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter$$anonfun$$nestedInanonfun$shapeEmitters$1$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationTypeEmitter$$anonfun$$nestedInanonfun$shapeEmitters$1$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser() {
  $c_O.call(this);
  this.node$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser.prototype.productPrefix__T = (function() {
  return "RamlCreativeWorkParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser)) {
    var RamlCreativeWorkParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser(x$1);
    var this$1 = this.node$1;
    var b = RamlCreativeWorkParser$1.node$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.node$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser.prototype.init___Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(node, ctx) {
  this.node$1 = node;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$2__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser.prototype.EmptyTarget$lzycompute$2__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser.prototype.parse__Lamf_plugins_domain_shapes_models_CreativeWork = (function() {
  var this$1 = this.node$1;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$1;
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var annotations = $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(this.node$1);
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var documentation = new $c_Lamf_plugins_domain_shapes_models_CreativeWork().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Title$1;
  var iv$1 = this.ctx$1;
  jsx$1.key__T__F1__V("title", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(documentation).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Description$1;
  var iv$2 = this.ctx$1;
  jsx$2.key__T__F1__V("content", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(documentation).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var x1 = this.ctx$1.vendor__Lamf_core_remote_Vendor();
  if ($is_Lamf_core_remote_Oas(x1)) {
    var url = "url"
  } else if ($is_Lamf_core_remote_Raml(x1)) {
    var url = new $c_Lamf_core_utils_package$AmfStrings().init___T("url").asRamlAnnotation__T()
  } else {
    var this$8 = this.ctx$1.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().UnexpectedVendor$1;
    var node$1 = (("Unexpected vendor '" + x1) + "'");
    $m_Lorg_yaml_model_YNode$();
    var node = this.node$1;
    var iv$3 = this.ctx$1;
    var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
    var message = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$1, iv$3));
    var property = $m_s_None$();
    var lexical = $m_s_None$();
    var location = $m_s_None$();
    this$8.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node$1, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
    var url = "url"
  };
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Url$1;
  var iv$4 = this.ctx$1;
  jsx$3.key__T__F1__V(url, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$4).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(documentation));
  $m_sci_List$();
  var array = [$m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().documentationItem$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$13 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$13);
    i = (((-1) + i) | 0)
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(documentation, map, result, this.ctx$1).parse__V();
  return documentation
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlCreativeWorkParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlCreativeWorkParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlCreativeWorkParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher() {
  $c_O.call(this);
  this.union$1 = null;
  this.ctx$1 = null;
  this.platform$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher.prototype.productPrefix__T = (function() {
  return "InheritsUnionMatcher"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher(x$1).$$outer$1 === this.$$outer$1))) {
    var InheritsUnionMatcher$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher(x$1);
    var x = this.union$1;
    var x$2 = InheritsUnionMatcher$1.union$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.union$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher.prototype.matchUnionFather__Lorg_yaml_model_YPart__s_Option = (function(part) {
  var this$1 = this.union$1;
  var jsx$2 = $as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, part$1) {
    return (function(t$2) {
      var t = $as_Lamf_core_model_domain_Shape(t$2);
      var xo = $this.$$outer$1.$$outer$1.ShapeClassTypeDefMatcher__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$().apply__Lamf_core_model_domain_Shape__Lorg_yaml_model_YNode__Z__Lamf_core_parser_ParserContext__s_Option(t, $as_Lorg_yaml_model_YNode(part$1), true, $this.ctx$1);
      return xo.toList__sci_List()
    })
  })(this, part));
  var this$3 = $m_sc_Seq$();
  var typeSet = $as_sc_TraversableOnce(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2)).toSet__sci_Set();
  return ((typeSet.size__I() === 1) ? new $c_s_Some().init___O(typeSet.head__O()) : new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$()))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$__Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_parser_ParserContext = (function($$outer, union, ctx) {
  this.union$1 = union;
  this.ctx$1 = ctx;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$InheritsUnionMatcher;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser$$anonfun$1.prototype.isDefinedAt__Lorg_yaml_model_YNode__Z = (function(x1) {
  var x = x1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x$2 = $m_Lorg_yaml_model_YType$().Map$1;
  return (x === x$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser$$anonfun$1.prototype.applyOrElse__Lorg_yaml_model_YNode__F1__O = (function(x1, $default) {
  var x = x1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x$2 = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x$2)) {
    return x1
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lorg_yaml_model_YNode__Z($as_Lorg_yaml_model_YNode(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lorg_yaml_model_YNode__F1__O($as_Lorg_yaml_model_YNode(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$TupleShapeParser$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType() {
  $c_O.call(this);
  this.shape$1 = null;
  this.typeDef$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType.prototype.formatType__p1__T__s_Option = (function(format) {
  return (((format === "int") || ((format === "int8") || ((format === "int16") || (format === "int32")))) ? new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$IntType$()) : (((format === "int64") || (format === "long")) ? new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$LongType$()) : ((format === "double") ? new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$DoubleType$()) : ((format === "float") ? new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$FloatType$()) : $m_s_None$()))))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType.prototype.productPrefix__T = (function() {
  return "ScalarFormatType"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType)) {
    var ScalarFormatType$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType(x$1);
    var x = this.shape$1;
    var x$2 = ScalarFormatType$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.typeDef$1;
      var x$4 = ScalarFormatType$1.typeDef$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.typeDef$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType.prototype.fromFormat__p1__T__Lamf_plugins_domain_shapes_models_TypeDef = (function(format) {
  var this$1 = this.typeDef$1;
  if ($f_Lamf_plugins_domain_shapes_models_TypeDef__isNumber__Z(this$1)) {
    var this$2 = this.formatType__p1__T__s_Option(format);
    return $as_Lamf_plugins_domain_shapes_models_TypeDef((this$2.isEmpty__Z() ? this.typeDef$1 : this$2.get__O()))
  } else {
    return this.typeDef$1
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType.prototype.parse__Lorg_yaml_model_YMap__Lamf_plugins_domain_shapes_models_TypeDef = (function(map) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("format");
  if (this$2.isEmpty__Z()) {
    var this$5 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var n = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$3 = n.value$2;
    var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv = this.ctx$1;
    var format = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv)).text$3;
    if ((!$m_Lamf_plugins_document_webapi_parser_spec_declaration_FormatValidator$().isValid__T__Lamf_plugins_domain_shapes_models_TypeDef__Z(format, this.typeDef$1))) {
      var this$4 = this.ctx$1.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidShapeFormat$1;
      var node = this.shape$1.id$1;
      var message = ((("Format " + format) + " is not valid for type ") + $m_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$().xsd__Lamf_plugins_domain_shapes_models_TypeDef__T(this.typeDef$1));
      var property = $m_s_None$();
      var location = n.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$4, specification, node, property, message, location)
    };
    var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Format$1;
    var iv$1 = this.ctx$1;
    new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$1).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField().apply__Lorg_yaml_model_YMapEntry__V(n);
    var this$5 = new $c_s_Some().init___O(this.fromFormat__p1__T__Lamf_plugins_domain_shapes_models_TypeDef(format))
  };
  return $as_Lamf_plugins_domain_shapes_models_TypeDef((this$5.isEmpty__Z() ? this.typeDef$1 : this$5.get__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType.prototype.init___Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(shape, typeDef, ctx) {
  this.shape$1 = shape;
  this.typeDef$1 = typeDef;
  this.ctx$1 = ctx;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.ScalarFormatType"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.ScalarFormatType;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.ScalarFormatType", {
  Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser() {
  $c_O.call(this);
  this.name$1 = null;
  this.adopt$1 = null;
  this.map$1 = null;
  this.defaultType$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser.prototype.productPrefix__T = (function() {
  return "SimpleTypeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser)) {
    var SimpleTypeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser(x$1);
    if ((this.name$1 === SimpleTypeParser$1.name$1)) {
      var x = this.adopt$1;
      var x$2 = SimpleTypeParser$1.adopt$1;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var this$1 = this.map$1;
      var b = SimpleTypeParser$1.map$1;
      var jsx$1 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.defaultType$1;
      var x$4 = SimpleTypeParser$1.defaultType$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.name$1;
      break
    }
    case 1: {
      return this.adopt$1;
      break
    }
    case 2: {
      return this.map$1;
      break
    }
    case 3: {
      return this.defaultType$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("repeat");
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$3 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$BooleanYRead$();
    var iv = this.ctx$1;
    var jsx$1 = $uZ($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv))
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var this$5 = $m_Lamf_plugins_domain_shapes_models_ArrayShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_ArrayShape(this.map$1);
    var name = this.name$1;
    $m_Lamf_core_parser_Annotations$();
    var a = new $c_Lamf_core_parser_Annotations().init___();
    var shape = $as_Lamf_plugins_domain_shapes_models_ArrayShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$5, name, a));
    this.adopt$1.apply__O__O(shape);
    var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, shape$1) {
      return (function(s$2) {
        var s = $as_Lamf_core_model_domain_Shape(s$2);
        s.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(shape$1.id$1, s.adopted$default$2__sc_Seq())
      })
    })(this, shape));
    var jsx$3 = $m_Lorg_yaml_model_YMap$();
    var jsx$2 = $as_sc_IndexedSeq(this.map$1.entries$3.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
      return (function(entry$3$2) {
        var entry$3 = $as_Lorg_yaml_model_YMapEntry(entry$3$2);
        var this$6 = entry$3.key$2;
        var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
        var iv$1 = this$3$1.ctx$1;
        var this$7 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion$1, iv$1)).text$3;
        return (!(this$7 === "repeat"))
      })
    })(this))));
    var this$8 = this.map$1.entries$3.headOption__s_Option();
    if (this$8.isEmpty__Z()) {
      var this$9 = $m_s_None$()
    } else {
      var arg1$1 = this$8.get__O();
      var x$6 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
      var this$9 = new $c_s_Some().init___O(x$6.location$1.sourceName$1)
    };
    var items = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser().init___T__F1__Lorg_yaml_model_YMap__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext("items", jsx$4, jsx$3.apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(jsx$2, $as_T((this$9.isEmpty__Z() ? "" : this$9.get__O()))), this.defaultType$1, this.ctx$1).parse__Lamf_plugins_domain_shapes_models_AnyShape();
    shape.withItems__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_ArrayShape(items);
    return shape
  } else {
    var map$1 = this.map$1;
    var this$11 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option("type");
    if (this$11.isEmpty__Z()) {
      var this$14 = $m_s_None$()
    } else {
      var arg1$2 = this$11.get__O();
      var e = $as_Lorg_yaml_model_YMapEntry(arg1$2);
      var this$12 = e.value$2;
      var x1 = this$12.tag__Lorg_yaml_model_YTag().tagType$3;
      var x = $m_Lorg_yaml_model_YType$().Null$1;
      if ((x === x1)) {
        var this$14 = $m_s_None$()
      } else {
        var node = e.value$2;
        var this$14 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lamf_core_parser_package$YScalarYRead$())
      }
    };
    if (this$14.isEmpty__Z()) {
      var this$24 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08DefaultTypeParser().init___Lamf_plugins_domain_shapes_models_TypeDef__T__Lorg_yaml_model_YPart__F1__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this.defaultType$1, this.name$1, this.map$1, this.adopt$1, this.ctx$1).parse__s_Option()
    } else {
      var arg1$3 = this$14.get__O();
      var value = $as_Lorg_yaml_model_YScalar(arg1$3);
      var x1$1 = $m_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$().xsdFromString__T__T2(value.text$3);
      matchEnd12: {
        var this$24;
        if ((x1$1 !== null)) {
          var p2 = $as_s_Option(x1$1.$$und1__O());
          if ((p2 instanceof $c_s_Some)) {
            var x4 = $as_s_Some(p2);
            var iri = $as_T(x4.value$2);
            if ((iri !== null)) {
              if ((x1$1.$$und2__O() !== null)) {
                var this$15 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
                var that = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$15, "file").iri__T();
                var jsx$5 = (iri === that)
              } else {
                var jsx$5 = false
              };
              if (jsx$5) {
                var shape$2 = $m_Lamf_plugins_domain_shapes_models_FileShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_FileShape(value);
                var name$1 = this.name$1;
                $m_Lamf_core_parser_Annotations$();
                var a$1 = new $c_Lamf_core_parser_Annotations().init___();
                var this$24 = new $c_s_Some().init___O($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape$2, name$1, a$1));
                break matchEnd12
              }
            }
          }
        };
        if ((x1$1 !== null)) {
          var p5 = $as_s_Option(x1$1.$$und1__O());
          var format = $as_s_Option(x1$1.$$und2__O());
          if ((p5 instanceof $c_s_Some)) {
            var x6 = $as_s_Some(p5);
            var iri$2 = $as_T(x6.value$2);
            if ((iri$2 !== null)) {
              if ((format !== null)) {
                var this$19 = $m_Lamf_plugins_domain_shapes_models_ScalarShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_ScalarShape(value);
                var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
                var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(iri$2, new $c_Lamf_core_parser_Annotations().init___());
                var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(value);
                var shape$2$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$19, field, value$1, annotations));
                if ((!format.isEmpty__Z())) {
                  var arg1$4 = format.get__O();
                  var f = $as_T(arg1$4);
                  if ((f !== "")) {
                    var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Format$1;
                    var value$2 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(f, new $c_Lamf_core_parser_Annotations().init___());
                    $m_Lamf_core_parser_Annotations$();
                    var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
                    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(shape$2$1, field$1, value$2, annotations$1)
                  }
                };
                var name$2 = this.name$1;
                $m_Lamf_core_parser_Annotations$();
                var a$2 = new $c_Lamf_core_parser_Annotations().init___();
                var this$24 = new $c_s_Some().init___O($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape$2$1, name$2, a$2));
                break matchEnd12
              }
            }
          }
        };
        var this$23 = this.ctx$1.eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().InvalidTypeDefinition$1;
        var message = ((("Invalid type def " + value.text$3) + " for ") + $m_Lamf_core_remote_Raml08$().name$1);
        var prop = $m_s_None$();
        var l = value.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$23, specification, "", prop, message, l);
        var this$24 = $m_s_None$()
      }
    };
    if (this$24.isEmpty__Z()) {
      var this$25 = $m_Lamf_plugins_domain_shapes_models_ScalarShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_ScalarShape(this.map$1);
      var dataType = $m_Lamf_core_model_DataType$().String$1;
      var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
      var this$27 = $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$25, field$2, dataType));
      var name$3 = this.name$1;
      $m_Lamf_core_parser_Annotations$();
      var a$3 = new $c_Lamf_core_parser_Annotations().init___();
      var jsx$6 = $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$27, name$3, a$3))
    } else {
      var jsx$6 = this$24.get__O()
    };
    var shape$2$2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(jsx$6);
    var map$2 = this.map$1;
    var this$29 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
    var this$30 = this$29.key__T__s_Option("type");
    if ((!this$30.isEmpty__Z())) {
      var arg1$5 = this$30.get__O();
      var e$3 = $as_Lorg_yaml_model_YMapEntry(arg1$5);
      var jsx$8 = shape$2$2.annotations__Lamf_core_parser_Annotations();
      var jsx$7 = $m_Lamf_core_parser_Range$();
      var this$31 = e$3.key$2;
      var this$32 = this$31.location$1;
      jsx$8.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo().init___Lamf_core_parser_Range(jsx$7.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$32.lineFrom$1, this$32.columnFrom$1, this$32.lineTo$1, this$32.columnTo$1))))
    };
    this.adopt$1.apply__O__O(shape$2$2);
    this.parseMap__p1__Lamf_plugins_domain_shapes_models_AnyShape__V(shape$2$2);
    if ((shape$2$2 instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
      var x2 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(shape$2$2);
      var this$33 = $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1));
      var this$34 = this$33.option$1;
      var str = $as_T((this$34.isEmpty__Z() ? null : this$34.get__O()))
    } else {
      var str = "#shape"
    };
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(str, "#", 0);
    var this$37 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    var x1$2 = $as_T($f_sc_IndexedSeqOptimized__last__O(this$37));
    var syntaxType = (((x1$2 === "integer") || ((x1$2 === "float") || ((x1$2 === "double") || ((x1$2 === "long") || (x1$2 === "number"))))) ? "numberScalarShape" : ((x1$2 === "string") ? "stringScalarShape" : ((x1$2 === "dateTime") ? "dateScalarShape" : "shape")));
    this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(shape$2$2.id$1, this.map$1, syntaxType);
    return shape$2$2
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser.prototype.init___T__F1__Lorg_yaml_model_YMap__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(name, adopt, map, defaultType, ctx) {
  this.name$1 = name;
  this.adopt$1 = adopt;
  this.map$1 = map;
  this.defaultType$1 = defaultType;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser.prototype.parseMap__p1__Lamf_plugins_domain_shapes_models_AnyShape__V = (function(shape) {
  var map = this.map$1;
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().DisplayName$1;
  var iv = this.ctx$1;
  jsx$1.key__T__F1__V("displayName", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(shape));
  var map$1 = this.map$1;
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var field$1 = $m_Lamf_core_metamodel_domain_ShapeModel$().Description$1;
  var iv$1 = this.ctx$1;
  jsx$2.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(shape));
  var counter = new $c_Lamf_core_utils_package$IdCounter().init___();
  var map$2 = this.map$1;
  var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var field$2 = $m_Lamf_core_metamodel_domain_ShapeModel$().Values$1;
  var iv$2 = this.ctx$1;
  var jsx$3 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(shape);
  var eta$0$1 = new $c_s_Some().init___O((shape.id$1 + "/list"));
  jsx$4.key__T__F1__V("enum", jsx$3.using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, eta$0$1$1, counter$1) {
    return (function(node$2) {
      var node = $as_Lorg_yaml_model_YNode(node$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$().parse__s_Option__Lamf_core_utils_package$IdCounter__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_core_model_domain_DataNode(eta$0$1$1, counter$1, node, $this.ctx$1)
    })
  })(this, eta$0$1, counter))));
  var map$3 = this.map$1;
  var this$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3);
  var this$6 = this$5.key__T__s_Option("pattern");
  if ((!this$6.isEmpty__Z())) {
    var arg1 = this$6.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$7 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
    var iv$3 = this.ctx$1;
    var regex = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$7, conversion, iv$3));
    var thiz = regex;
    if ((!(($uI(thiz.length) >= 0) && ($as_T(thiz.substring(0, $uI("^".length))) === "^")))) {
      regex = ("^" + regex)
    };
    if ((!$m_sjsr_RuntimeString$().endsWith__T__T__Z(regex, "$"))) {
      regex = (regex + "$")
    };
    $m_Lorg_yaml_model_YNode$();
    var str = regex;
    var node$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    var iv$4 = this.ctx$1;
    var this$15 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$1, iv$4);
    var qual$1 = this$15.text__Lamf_core_model_domain_AmfScalar();
    var x$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    var x$2 = qual$1.value$1;
    var pattern = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(x$2, x$1);
    var field$3 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Pattern$1;
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(shape, field$3, pattern, annotations)
  };
  var map$4 = this.map$1;
  var jsx$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$4);
  var field$4 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MinLength$1;
  var iv$5 = this.ctx$1;
  jsx$5.key__T__F1__V("minLength", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$4, iv$5).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(shape));
  var map$5 = this.map$1;
  var jsx$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$5);
  var field$5 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MaxLength$1;
  var iv$6 = this.ctx$1;
  jsx$6.key__T__F1__V("maxLength", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$5, iv$6).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(shape));
  var map$6 = this.map$1;
  var this$19 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$6);
  var this$20 = this$19.key__T__s_Option("minimum");
  if ((!this$20.isEmpty__Z())) {
    var arg1$1 = this$20.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var node$3 = entry$3.value$2;
    var iv$7 = this.ctx$1;
    var value = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$3, iv$7);
    var field$6 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Minimum$1;
    var value$1 = value.text__Lamf_core_model_domain_AmfScalar();
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(shape, field$6, value$1, annotations$1)
  };
  var map$7 = this.map$1;
  var this$23 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$7);
  var this$24 = this$23.key__T__s_Option("maximum");
  if ((!this$24.isEmpty__Z())) {
    var arg1$2 = this$24.get__O();
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var node$4 = entry$4.value$2;
    var iv$8 = this.ctx$1;
    var value$2 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$4, iv$8);
    var field$7 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Maximum$1;
    var value$3 = value$2.text__Lamf_core_model_domain_AmfScalar();
    var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(shape, field$7, value$3, annotations$2)
  };
  if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
    var this$26 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(shape);
    var this$27 = $as_Lamf_core_model_StrField(this$26.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1)).option$1;
    var x = (this$27.isEmpty__Z() ? "" : this$27.get__O());
    var x$2$1 = $m_Lamf_core_model_DataType$().String$1;
    if ((x === null)) {
      /*<skip>*/
    } else {
      $objectEquals(x, x$2$1)
    }
  };
  var this$28 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser().init___T__Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext("example", this.map$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1, shape$1) {
    return (function(name$2) {
      var name = $as_s_Option(name$2);
      return $f_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement__withExample__s_Option__Lamf_plugins_domain_shapes_models_Example(shape$1, name)
    })
  })(this, shape)), new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions().init___Z__Z__Z(true, true, false).checkScalar__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions(shape), this.ctx$1).parse__s_Option();
  if ((!this$28.isEmpty__Z())) {
    var arg1$3 = this$28.get__O();
    var e = $as_Lamf_plugins_domain_shapes_models_Example(arg1$3);
    var field$8 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Examples$1;
    var jsx$7 = $m_sc_Seq$();
    var array = [e];
    var values = $as_sc_Seq(jsx$7.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
    $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(shape, field$8, values))
  };
  var map$8 = this.map$1;
  var this$32 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$8);
  var this$33 = this$32.key__T__s_Option("default");
  if ((!this$33.isEmpty__Z())) {
    var arg1$4 = this$33.get__O();
    var entry$5 = $as_Lorg_yaml_model_YMapEntry(arg1$4);
    var this$34 = entry$5.value$2;
    var x1 = this$34.tag__Lorg_yaml_model_YTag().tagType$3;
    var x$3 = $m_Lorg_yaml_model_YType$().Null$1;
    if ((!(x$3 === x1))) {
      var this$35 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser().init___Lorg_yaml_model_YNode__T__Z__Z__Z__Lamf_plugins_document_webapi_contexts_WebApiContext(entry$5.value$2, shape.id$1, false, false, false, this.ctx$1).parse__Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult().dataNode$1;
      if ((!this$35.isEmpty__Z())) {
        var arg1$5 = this$35.get__O();
        var dn = $as_Lamf_core_model_domain_DataNode(arg1$5);
        var field$9 = $m_Lamf_core_metamodel_domain_ShapeModel$().Default$1;
        var annotations$3 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$5);
        $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(shape, field$9, dn, annotations$3))
      };
      $f_Lamf_plugins_domain_shapes_models_ShapeHelper__setDefaultStrValue__Lorg_yaml_model_YMapEntry__V(shape, entry$5)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.SimpleTypeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.SimpleTypeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.SimpleTypeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter$$anonfun$collect$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter$$anonfun$collect$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter$$anonfun$collect$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter$$anonfun$collect$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter$$anonfun$collect$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter$$anonfun$collect$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter$$anonfun$collect$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter$$anonfun$collect$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter$$anonfun$collect$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter$$anonfun$collect$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter$$anonfun$collect$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter$$anonfun$collect$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter$$anonfun$collect$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter$$anonfun$collect$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.TraitExtendsEmitter$$anonfun$collect$1", {
  Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter$$anonfun$collect$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter$$anonfun$collect$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter$$anonfun$collect$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter$$anonfun$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_shapes_models_Example)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter$$anonfun$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_Example)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_Example(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.ExamplesEmitter$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter.prototype.productPrefix__T = (function() {
  return "SimpleTypeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter)) {
    var SimpleTypeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter(x$1);
    var x = this.shape$1;
    var x$2 = SimpleTypeEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = SimpleTypeEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter.prototype.emitters__sc_Seq = (function() {
  var this$1 = this.shape$1;
  var fs = this$1.fields$2;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DisplayName$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("displayName", f, $m_s_None$())))
  };
  var this$4 = this.shape$1;
  var this$5 = $as_Lamf_core_model_StrField(this$4.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1)).option$1;
  if (this$5.isEmpty__Z()) {
    var typeDef = $m_s_None$()
  } else {
    var arg1$1 = this$5.get__O();
    var iri = $as_T(arg1$1);
    var typeDef = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$().type08Def__T__Lamf_plugins_domain_shapes_models_TypeDef(iri))
  };
  var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1);
  if ((!this$6.isEmpty__Z())) {
    var arg1$2 = this$6.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    var jsx$1 = $m_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$();
    var this$7 = this.shape$1;
    var this$8 = $as_Lamf_core_model_StrField(this$7.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1));
    var this$9 = this$8.option$1;
    var rawTypeDef = jsx$1.typeDef08__T__T($as_T((this$9.isEmpty__Z() ? null : this$9.get__O())));
    var this$10 = this.shape$1;
    var x1 = this$10.annotations$2.find__jl_Class__s_Option($d_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo.getClassOf());
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var lexicalInfo = $as_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo(x2.value$2);
      var x$3 = lexicalInfo.range$1.start$1;
      var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
      var jsx$2 = result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", rawTypeDef, x$4, x$3))
    } else {
      var this$12 = $m_Lamf_core_emitter_BaseEmitters_package$();
      var annotations = f$3.value$1.annotations$1;
      var x$7 = this$12.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf());
      var x$8 = $m_Lorg_yaml_model_YType$().Str$1;
      var jsx$2 = result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", rawTypeDef, x$8, x$7))
    };
    new $c_s_Some().init___O(jsx$2)
  };
  var this$14 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Description$1);
  if ((!this$14.isEmpty__Z())) {
    var arg1$3 = this$14.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f$4, $m_s_None$())))
  };
  var this$16 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Values$1);
  if ((!this$16.isEmpty__Z())) {
    var arg1$4 = this$16.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter().init___T__Lamf_core_parser_Value__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("enum", f$5.value$1, this.ordering$1, this.spec$1)))
  };
  var this$17 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Pattern$1);
  if ((!this$17.isEmpty__Z())) {
    var arg1$5 = this$17.get__O();
    var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$5);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("pattern", $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlCommonOASFieldsEmitter__processRamlPattern__Lamf_core_parser_FieldEntry__Lamf_core_parser_FieldEntry(this, f$6), $m_s_None$(), this.spec$1)))
  };
  var this$19 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MinLength$1);
  if ((!this$19.isEmpty__Z())) {
    var arg1$6 = this$19.get__O();
    var f$7 = $as_Lamf_core_parser_FieldEntry(arg1$6);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("minLength", f$7, $m_s_None$())))
  };
  var this$21 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MaxLength$1);
  if ((!this$21.isEmpty__Z())) {
    var arg1$7 = this$21.get__O();
    var f$8 = $as_Lamf_core_parser_FieldEntry(arg1$7);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("maxLength", f$8, $m_s_None$())))
  };
  var this$23 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Minimum$1);
  if ((!this$23.isEmpty__Z())) {
    var arg1$8 = this$23.get__O();
    var f$9 = $as_Lamf_core_parser_FieldEntry(arg1$8);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("minimum", f$9, new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$().convert__s_Option__Lorg_yaml_model_YType(typeDef)))))
  };
  var this$24 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Maximum$1);
  if ((!this$24.isEmpty__Z())) {
    var arg1$9 = this$24.get__O();
    var f$10 = $as_Lamf_core_parser_FieldEntry(arg1$9);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("maximum", f$10, new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$().convert__s_Option__Lorg_yaml_model_YType(typeDef)))))
  };
  var this$25 = this.shape$1;
  var this$26 = $as_sc_Seq(this$25.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).headOption__s_Option();
  if ((!this$26.isEmpty__Z())) {
    var arg1$10 = this$26.get__O();
    var e = $as_Lamf_plugins_domain_shapes_models_Example(arg1$10);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter().init___T__Lamf_plugins_domain_shapes_models_Example__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("example", e, this.ordering$1, this.spec$1))
  };
  var this$27 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ShapeModel$().Default$1);
  if ((!this$27.isEmpty__Z())) {
    var arg1$11 = this$27.get__O();
    var f$11 = $as_Lamf_core_parser_FieldEntry(arg1$11);
    var this$28 = this.shape$1;
    var jsx$5 = $as_Lamf_core_model_domain_DataNode(this$28.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Default$1));
    var jsx$4 = this.ordering$1;
    var jsx$3 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var this$30 = this.spec$1;
    var x$10 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler(jsx$5, jsx$4, false, jsx$3, this$30.eh$1);
    var this$31 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations$1 = f$11.value$1.annotations$1;
    var x$11 = this$31.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations$1, $d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var x$12 = $m_Lorg_yaml_model_YType$().Str$1;
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position("default", x$10, x$12, x$11)))
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(shape, ordering, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.SimpleTypeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.SimpleTypeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.SimpleTypeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlCommonOASFieldsEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter$$anonfun$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_shapes_models_Example)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter$$anonfun$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_Example)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_Example(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasAnyShapeEmitter$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter$$anonfun$1.prototype.applyOrElse__Lamf_core_emitter_Emitter__F1__O = (function(x1, $default) {
  if ($is_Lamf_core_emitter_EntryEmitter(x1)) {
    var x2 = $as_Lamf_core_emitter_EntryEmitter(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter$$anonfun$1.prototype.isDefinedAt__Lamf_core_emitter_Emitter__Z = (function(x1) {
  return $is_Lamf_core_emitter_EntryEmitter(x1)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_emitter_Emitter__Z($as_Lamf_core_emitter_Emitter(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_emitter_Emitter__F1__O($as_Lamf_core_emitter_Emitter(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasTupleItemsShapeEmitter$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter$$anonfun$entries$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter$$anonfun$entries$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter$$anonfun$entries$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter$$anonfun$entries$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter$$anonfun$entries$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter$$anonfun$entries$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter$$anonfun$entries$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter$$anonfun$entries$1.prototype.applyOrElse__Lamf_core_emitter_Emitter__F1__O = (function(x1, $default) {
  if ($is_Lamf_core_emitter_EntryEmitter(x1)) {
    var x2 = $as_Lamf_core_emitter_EntryEmitter(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter$$anonfun$entries$1.prototype.isDefinedAt__Lamf_core_emitter_Emitter__Z = (function(x1) {
  return $is_Lamf_core_emitter_EntryEmitter(x1)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter$$anonfun$entries$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter$$anonfun$entries$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_emitter_Emitter__Z($as_Lamf_core_emitter_Emitter(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter$$anonfun$entries$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_emitter_Emitter__F1__O($as_Lamf_core_emitter_Emitter(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter$$anonfun$entries$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter$$anonfun$entries$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasTypeEmitter$$anonfun$entries$1", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter$$anonfun$entries$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter$$anonfun$entries$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter$$anonfun$entries$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector$$anonfun$emitter$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector$$anonfun$emitter$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector$$anonfun$emitter$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector$$anonfun$emitter$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector$$anonfun$emitter$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector$$anonfun$emitter$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector$$anonfun$emitter$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector$$anonfun$emitter$2.prototype.applyOrElse__Lamf_core_emitter_Emitter__F1__O = (function(x1, $default) {
  if ($is_Lamf_core_emitter_EntryEmitter(x1)) {
    var x2 = $as_Lamf_core_emitter_EntryEmitter(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector$$anonfun$emitter$2.prototype.isDefinedAt__Lamf_core_emitter_Emitter__Z = (function(x1) {
  return $is_Lamf_core_emitter_EntryEmitter(x1)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector$$anonfun$emitter$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_emitter_Emitter__Z($as_Lamf_core_emitter_Emitter(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector$$anonfun$emitter$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_emitter_Emitter__F1__O($as_Lamf_core_emitter_Emitter(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector$$anonfun$emitter$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector = (function($$outer) {
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector$$anonfun$emitter$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector$$anonfun$emitter$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasTypePartCollector$$anonfun$emitter$2", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector$$anonfun$emitter$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector$$anonfun$emitter$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector$$anonfun$emitter$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.amf$plugins$document$webapi$parser$spec$declaration$emitters$raml$Raml08TypeEmitter$$spec$f = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter.prototype.productPrefix__T = (function() {
  return "Raml08TypeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter)) {
    var Raml08TypeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter(x$1);
    var x = this.shape$1;
    var x$2 = Raml08TypeEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = Raml08TypeEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter.prototype.emitters__sc_Seq = (function() {
  var rc13 = false;
  var x4 = null;
  var x1 = this.shape$1;
  if ((x1 !== null)) {
    if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x1).isDefined__Z()) {
      var jsx$1 = $m_sc_Seq$();
      var array = [this.amf$plugins$document$webapi$parser$spec$declaration$emitters$raml$Raml08TypeEmitter$$spec$f.localReference__Lamf_core_model_domain_Linkable__Lamf_core_emitter_PartEmitter(x1)];
      return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
    }
  };
  if ((x1 !== null)) {
    if ($as_sc_Seq(x1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$1$2) {
        var x$1 = $as_Lamf_core_model_domain_Shape(x$1$2);
        return x$1.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.getClassOf())
      })
    })(this)))) {
      return this.inheritsEmitters__sc_Seq()
    }
  };
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
    rc13 = true;
    x4 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x1);
    if (x4.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.getClassOf()).isDefined__Z()) {
      var jsx$2 = $m_sc_Seq$();
      var array$1 = [new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter().init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__T__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x4, this.ordering$1, $m_sci_Nil$(), "schema", this.amf$plugins$document$webapi$parser$spec$declaration$emitters$raml$Raml08TypeEmitter$$spec$f)];
      return $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)))
    }
  };
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
    var x5 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(x1);
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter().init___Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x5, this.ordering$1, this.amf$plugins$document$webapi$parser$spec$declaration$emitters$raml$Raml08TypeEmitter$$spec$f).emitters__sc_Seq()
  };
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
    var x6 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(x1);
    var x1$2 = $as_Lamf_core_model_domain_Shape(x6.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1));
    if ((x1$2 instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
      var x2$2 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(x1$2);
      var jsx$4 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter().init___Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x2$2, this.ordering$1, this.amf$plugins$document$webapi$parser$spec$declaration$emitters$raml$Raml08TypeEmitter$$spec$f).emitters__sc_Seq();
      var jsx$3 = new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("repeat", "true", $m_Lorg_yaml_model_YType$().Bool$1, $m_Lamf_core_parser_Position$ZERO$());
      var this$6 = $m_sc_Seq$();
      return $as_sc_Seq(jsx$4.$$colon$plus__O__scg_CanBuildFrom__O(jsx$3, this$6.ReusableCBFInstance$2))
    } else if ((x1$2 instanceof $c_Lamf_plugins_domain_shapes_models_FileShape)) {
      var x3$2 = $as_Lamf_plugins_domain_shapes_models_FileShape(x1$2);
      var this$7 = new $c_Lamf_plugins_domain_shapes_models_ScalarShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(x3$2.fields$2, x3$2.annotations$2);
      var dataType = $as_T($as_s_Option($m_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$().xsdFromString__T__T2("file").$$und1__O()).get__O());
      var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
      var scalar = $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$7, field, dataType));
      var jsx$6 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter().init___Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(scalar, this.ordering$1, this.amf$plugins$document$webapi$parser$spec$declaration$emitters$raml$Raml08TypeEmitter$$spec$f).emitters__sc_Seq();
      var jsx$5 = new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("repeat", "true", $m_Lorg_yaml_model_YType$().Bool$1, $m_Lamf_core_parser_Position$ZERO$());
      var this$9 = $m_sc_Seq$();
      return $as_sc_Seq(jsx$6.$$colon$plus__O__scg_CanBuildFrom__O(jsx$5, this$9.ReusableCBFInstance$2))
    } else {
      var jsx$7 = $m_sc_Seq$();
      var array$2 = [new $c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter().init___Lamf_core_model_domain_AmfElement__T(x1$2, (("Cannot emit array shape with items " + $objectGetClass(x1$2).toString__T()) + " in raml 08"))];
      return $as_sc_Seq(jsx$7.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2)))
    }
  };
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
    var x7 = $as_Lamf_plugins_domain_shapes_models_UnionShape(x1);
    var jsx$8 = $m_sc_Seq$();
    var array$3 = [new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2().init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter__Lamf_plugins_domain_shapes_models_UnionShape(this, x7)];
    return $as_sc_Seq(jsx$8.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$3)))
  };
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_SchemaShape)) {
    var x8 = $as_Lamf_plugins_domain_shapes_models_SchemaShape(x1);
    var jsx$9 = $m_sc_Seq$();
    var array$4 = [new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter().init___Lamf_plugins_domain_shapes_models_SchemaShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x8, this.ordering$1, $m_sci_Nil$(), this.amf$plugins$document$webapi$parser$spec$declaration$emitters$raml$Raml08TypeEmitter$$spec$f)];
    return $as_sc_Seq(jsx$9.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$4)))
  };
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_NilShape)) {
    var x9 = $as_Lamf_plugins_domain_shapes_models_NilShape(x1);
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter().init___Lamf_plugins_domain_shapes_models_NilShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x9, this.ordering$1, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), this.amf$plugins$document$webapi$parser$spec$declaration$emitters$raml$Raml08TypeEmitter$$spec$f).emitters__sc_Seq()
  };
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_FileShape)) {
    var x10 = $as_Lamf_plugins_domain_shapes_models_FileShape(x1);
    var this$16 = new $c_Lamf_plugins_domain_shapes_models_ScalarShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(x10.fields$2, x10.annotations$2);
    var dataType$1 = $as_T($as_s_Option($m_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$().xsdFromString__T__T2("file").$$und1__O()).get__O());
    var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
    var scalar$2 = $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$16, field$1, dataType$1));
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_SimpleTypeEmitter().init___Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(scalar$2, this.ordering$1, this.amf$plugins$document$webapi$parser$spec$declaration$emitters$raml$Raml08TypeEmitter$$spec$f).emitters__sc_Seq()
  };
  if (rc13) {
    var shape = x4;
    var ordering = this.ordering$1;
    var references = $m_sci_Nil$();
    var spec = this.amf$plugins$document$webapi$parser$spec$declaration$emitters$raml$Raml08TypeEmitter$$spec$f;
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter().init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(shape, ordering, references, spec).emitters__sc_Seq()
  };
  var jsx$10 = $m_sc_Seq$();
  var array$5 = [new $c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter().init___Lamf_core_model_domain_AmfElement__T(x1, (("Unsupported shape class for emit raml 08 spec " + $objectGetClass(x1).toString__T()) + "`"))];
  return $as_sc_Seq(jsx$10.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$5)))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(shape, ordering, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.amf$plugins$document$webapi$parser$spec$declaration$emitters$raml$Raml08TypeEmitter$$spec$f = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter.prototype.inheritsEmitters__sc_Seq = (function() {
  var this$1 = this.shape$1;
  var this$2 = $as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1));
  var pf = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter(this);
  var father = $as_Lamf_core_model_domain_Shape($f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$2, pf).get__O());
  var emitter = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$1().init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter__Lamf_core_model_domain_Shape(this, father);
  var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  results.$$plus$eq__O__scm_ListBuffer(emitter);
  var x1 = this.shape$1;
  matchEnd4: {
    if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
      var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x1);
      if ($as_sc_Seq(x2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).nonEmpty__Z()) {
        var ordering = this.ordering$1;
        var references = $m_sci_Nil$();
        var spec = this.amf$plugins$document$webapi$parser$spec$declaration$emitters$raml$Raml08TypeEmitter$$spec$f;
        $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter__emitExamples__Lamf_plugins_domain_shapes_models_AnyShape__scm_ListBuffer__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__V(this, x2, results, ordering, references, spec);
        break matchEnd4
      }
    }
  };
  return results
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.Raml08TypeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.Raml08TypeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.Raml08TypeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2$$anonfun$$nestedInanonfun$emit$2$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2$$anonfun$$nestedInanonfun$emit$2$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2$$anonfun$$nestedInanonfun$emit$2$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2$$anonfun$$nestedInanonfun$emit$2$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2$$anonfun$$nestedInanonfun$emit$2$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2$$anonfun$$nestedInanonfun$emit$2$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2$$anonfun$$nestedInanonfun$emit$2$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2$$anonfun$$nestedInanonfun$emit$2$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2 = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2$$anonfun$$nestedInanonfun$emit$2$1.prototype.isDefinedAt__Lamf_core_model_domain_Shape__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2$$anonfun$$nestedInanonfun$emit$2$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_Shape__Z($as_Lamf_core_model_domain_Shape(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2$$anonfun$$nestedInanonfun$emit$2$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_Shape__F1__O($as_Lamf_core_model_domain_Shape(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2$$anonfun$$nestedInanonfun$emit$2$1.prototype.applyOrElse__Lamf_core_model_domain_Shape__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2$$anonfun$$nestedInanonfun$emit$2$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2$$anonfun$$nestedInanonfun$emit$2$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.Raml08TypeEmitter$$anon$2$$anonfun$$nestedInanonfun$emit$2$1", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2$$anonfun$$nestedInanonfun$emit$2$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2$$anonfun$$nestedInanonfun$emit$2$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anon$2$$anonfun$$nestedInanonfun$emit$2$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anonfun$1.prototype.isDefinedAt__Lamf_core_model_domain_Shape__Z = (function(x1) {
  if ((x1 !== null)) {
    if (x1.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.getClassOf())) {
      return true
    }
  };
  return false
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_Shape__Z($as_Lamf_core_model_domain_Shape(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_Shape__F1__O($as_Lamf_core_model_domain_Shape(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anonfun$1.prototype.applyOrElse__Lamf_core_model_domain_Shape__F1__O = (function(x1, $default) {
  if ((x1 !== null)) {
    if (x1.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.getClassOf())) {
      return x1
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter = (function($$outer) {
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.Raml08TypeEmitter$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$emitters$1() {
  $c_sr_AbstractPartialFunction.call(this);
  this.$$outer$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$emitters$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$emitters$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$emitters$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$emitters$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$emitters$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$emitters$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$emitters$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$emitters$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_document_BaseUnit__Z($as_Lamf_core_model_document_BaseUnit(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$emitters$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O($as_Lamf_core_model_document_BaseUnit(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$emitters$1.prototype.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_model_document_ExternalFragment)) {
    var x2 = $as_Lamf_core_model_document_ExternalFragment(x1);
    var this$3 = $as_Lamf_core_model_domain_ExternalDomainElement($as_Lamf_core_model_domain_DomainElement(x2.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))).id$1;
    var this$1 = $as_Lamf_plugins_domain_shapes_models_AnyShape(this.$$outer$2.shape$1);
    var this$2 = $f_Lamf_plugins_domain_shapes_models_ShapeHelpers__externalSourceID__s_Option(this$1);
    var that = (this$2.isEmpty__Z() ? "" : this$2.get__O());
    if ((this$3 === that)) {
      return x2
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$emitters$1.prototype.isDefinedAt__Lamf_core_model_document_BaseUnit__Z = (function(x1) {
  if ((x1 instanceof $c_Lamf_core_model_document_ExternalFragment)) {
    var x2 = $as_Lamf_core_model_document_ExternalFragment(x1);
    var this$3 = $as_Lamf_core_model_domain_ExternalDomainElement($as_Lamf_core_model_domain_DomainElement(x2.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))).id$1;
    var this$1 = $as_Lamf_plugins_domain_shapes_models_AnyShape(this.$$outer$2.shape$1);
    var this$2 = $f_Lamf_plugins_domain_shapes_models_ShapeHelpers__externalSourceID__s_Option(this$1);
    var that = (this$2.isEmpty__Z() ? "" : this$2.get__O());
    if ((this$3 === that)) {
      return true
    }
  };
  return false
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$emitters$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$emitters$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.Raml10TypeEmitter$$anonfun$emitters$1", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$emitters$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$emitters$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$emitters$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1.prototype.applyOrElse__Lamf_core_emitter_Emitter__F1__O = (function(x1, $default) {
  if ($is_Lamf_core_emitter_EntryEmitter(x1)) {
    var x2 = $as_Lamf_core_emitter_EntryEmitter(x1);
    return x2
  } else if ($is_Lamf_core_emitter_PartEmitter(x1)) {
    var x3 = $as_Lamf_core_emitter_PartEmitter(x1);
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1$$anon$1().init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1__Lamf_core_emitter_PartEmitter(this, x3)
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1.prototype.isDefinedAt__Lamf_core_emitter_Emitter__Z = (function(x1) {
  return ($is_Lamf_core_emitter_EntryEmitter(x1) || $is_Lamf_core_emitter_PartEmitter(x1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_emitter_Emitter__Z($as_Lamf_core_emitter_Emitter(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_emitter_Emitter__F1__O($as_Lamf_core_emitter_Emitter(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.Raml10TypeEmitter$$anonfun$entries$1", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter$$anonfun$entries$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter$$anonfun$emit$1() {
  $c_sr_AbstractPartialFunction.call(this);
  this.$$outer$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter$$anonfun$emit$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter$$anonfun$emit$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter$$anonfun$emit$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter$$anonfun$emit$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter$$anonfun$emit$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter$$anonfun$emit$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter$$anonfun$emit$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter$$anonfun$emit$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_document_BaseUnit__Z($as_Lamf_core_model_document_BaseUnit(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter$$anonfun$emit$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O($as_Lamf_core_model_document_BaseUnit(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter$$anonfun$emit$1.prototype.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_model_document_ExternalFragment)) {
    var x2 = $as_Lamf_core_model_document_ExternalFragment(x1);
    var this$3 = $as_Lamf_core_model_domain_ExternalDomainElement($as_Lamf_core_model_domain_DomainElement(x2.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))).id$1;
    var this$1 = $as_Lamf_plugins_domain_shapes_models_ShapeHelpers(this.$$outer$2.shape$1);
    var this$2 = $f_Lamf_plugins_domain_shapes_models_ShapeHelpers__externalSourceID__s_Option(this$1);
    var that = (this$2.isEmpty__Z() ? "" : this$2.get__O());
    if ((this$3 === that)) {
      return $as_Lamf_core_model_domain_ExternalDomainElement($as_Lamf_core_model_domain_DomainElement(x2.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)))
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter$$anonfun$emit$1.prototype.isDefinedAt__Lamf_core_model_document_BaseUnit__Z = (function(x1) {
  if ((x1 instanceof $c_Lamf_core_model_document_ExternalFragment)) {
    var x2 = $as_Lamf_core_model_document_ExternalFragment(x1);
    var this$3 = $as_Lamf_core_model_domain_ExternalDomainElement($as_Lamf_core_model_domain_DomainElement(x2.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))).id$1;
    var this$1 = $as_Lamf_plugins_domain_shapes_models_ShapeHelpers(this.$$outer$2.shape$1);
    var this$2 = $f_Lamf_plugins_domain_shapes_models_ShapeHelpers__externalSourceID__s_Option(this$1);
    var that = (this$2.isEmpty__Z() ? "" : this$2.get__O());
    if ((this$3 === that)) {
      return true
    }
  };
  return false
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter$$anonfun$emit$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter$$anonfun$emit$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlExternalSourceEmitter$$anonfun$emit$1", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter$$anonfun$emit$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter$$anonfun$emit$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter$$anonfun$emit$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter$$anonfun$1.prototype.isDefinedAt__Lamf_core_model_domain_Shape__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_core_model_domain_RecursiveShape)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_Shape__Z($as_Lamf_core_model_domain_Shape(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_Shape__F1__O($as_Lamf_core_model_domain_Shape(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter$$anonfun$1.prototype.applyOrElse__Lamf_core_model_domain_Shape__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
    var x2 = $as_Lamf_core_model_domain_RecursiveShape(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlShapeEmitter$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter$$anonfun$1.prototype.applyOrElse__Lamf_core_emitter_Emitter__F1__O = (function(x1, $default) {
  if ($is_Lamf_core_emitter_EntryEmitter(x1)) {
    var x2 = $as_Lamf_core_emitter_EntryEmitter(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter$$anonfun$1.prototype.isDefinedAt__Lamf_core_emitter_Emitter__Z = (function(x1) {
  return $is_Lamf_core_emitter_EntryEmitter(x1)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_emitter_Emitter__Z($as_Lamf_core_emitter_Emitter(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_emitter_Emitter__F1__O($as_Lamf_core_emitter_Emitter(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlTypePartEmitter$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions();
$c_Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions.prototype.init___Z__Z__Z.call(this, true, false, false);
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.DefaultExampleOptions$", {
  Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$;
var $n_Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$ = new $c_Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter$$anonfun$1.prototype.applyOrElse__Lamf_core_emitter_Emitter__F1__O = (function(x1, $default) {
  if ($is_Lamf_core_emitter_EntryEmitter(x1)) {
    var x2 = $as_Lamf_core_emitter_EntryEmitter(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter$$anonfun$1.prototype.isDefinedAt__Lamf_core_emitter_Emitter__Z = (function(x1) {
  return $is_Lamf_core_emitter_EntryEmitter(x1)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_emitter_Emitter__Z($as_Lamf_core_emitter_Emitter(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_emitter_Emitter__F1__O($as_Lamf_core_emitter_Emitter(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter = (function($$outer) {
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.ExampleValuesEmitter$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter.call(this);
  this.api$2 = null;
  this.f$2 = null;
  this.ordering$2 = null;
  this.references$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter.prototype.productPrefix__T = (function() {
  return "Oas2ServersEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter)) {
    var Oas2ServersEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter(x$1);
    var x = this.api$2;
    var x$2 = Oas2ServersEmitter$1.api$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.f$2;
      var x$4 = Oas2ServersEmitter$1.f$2;
      var jsx$2 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.ordering$2;
      var x$6 = Oas2ServersEmitter$1.ordering$2;
      var jsx$1 = (x$5 === x$6)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.references$2;
      var x$8 = Oas2ServersEmitter$1.references$2;
      return ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.api$2;
      break
    }
    case 1: {
      return this.f$2;
      break
    }
    case 2: {
      return this.ordering$2;
      break
    }
    case 3: {
      return this.references$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter.prototype.emitters__sc_Seq = (function() {
  var servers = $m_Lamf_plugins_document_webapi_parser_spec_domain_Servers$().apply__Lamf_core_parser_FieldEntry__Lamf_plugins_document_webapi_parser_spec_domain_Servers(this.f$2);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = servers.default$1;
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var server = $as_Lamf_plugins_domain_webapi_models_Server(arg1);
    this.defaultServer__p2__Lamf_plugins_domain_webapi_models_Server__scm_ListBuffer__s_Option(server, result)
  };
  this.asExtension__T__sc_Seq__scm_ListBuffer__V(new $c_Lamf_core_utils_package$AmfStrings().init___T("servers").asOasExtension__T(), servers.servers$1, result);
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter.prototype.init___Lamf_plugins_domain_webapi_models_WebApi__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(api, f, ordering, references, spec) {
  this.api$2 = api;
  this.f$2 = f;
  this.ordering$2 = ordering;
  this.references$2 = references;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter.prototype.init___Lamf_core_model_domain_DomainElement__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.call(this, api, f, ordering, references, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter.prototype.defaultServer__p2__Lamf_plugins_domain_webapi_models_Server__scm_ListBuffer__s_Option = (function($default, result) {
  var fs = $default.fields$1;
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Url$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    var uri = $m_Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter$().apply__T__Lamf_plugins_document_webapi_parser_spec_BaseUriSplitter($as_Lamf_core_model_domain_AmfScalar(f.value$1.value$1).toString__T());
    var x = uri.domain$1;
    var this$3 = new $c_sci_StringOps().init___T(x);
    if ($f_sc_TraversableOnce__nonEmpty__Z(this$3)) {
      var x$2 = uri.domain$1;
      var x$3 = $m_Lamf_core_emitter_BaseEmitters_package$().pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(f.value$1.annotations$1, $d_Lamf_core_annotations_HostLexicalInformation.getClassOf());
      var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("host", x$2, x$4, x$3))
    };
    var x$1 = uri.path$1;
    var this$6 = new $c_sci_StringOps().init___T(x$1);
    if ($f_sc_TraversableOnce__nonEmpty__Z(this$6)) {
      var x$6 = uri.path$1;
      var x$7 = $m_Lamf_core_emitter_BaseEmitters_package$().pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(f.value$1.annotations$1, $d_Lamf_core_annotations_BasePathLexicalInformation.getClassOf());
      var x$8 = $m_Lorg_yaml_model_YType$().Str$1;
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("basePath", x$6, x$8, x$7))
    };
    var x$5 = uri.protocol$1;
    var this$9 = new $c_sci_StringOps().init___T(x$5);
    if ($f_sc_TraversableOnce__nonEmpty__Z(this$9)) {
      var this$10 = this.api$2.fields$1;
      var f$1 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Schemes$1;
      var jsx$2 = (!this$10.fs$1.contains__O__Z(f$1))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var jsx$4 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Schemes$1;
      var jsx$3 = $m_sc_Seq$();
      var array = [new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(uri.protocol$1, new $c_Lamf_core_parser_Annotations().init___())];
      var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))), new $c_Lamf_core_parser_Annotations().init___());
      var annotations = f.value$1.annotations$1;
      var jsx$1 = result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType("schemes", new $c_Lamf_core_parser_FieldEntry().init___Lamf_core_metamodel_Field__Lamf_core_parser_Value(jsx$4, new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value, annotations)), this.ordering$2, false, $m_Lorg_yaml_model_YType$().Str$1))
    } else {
      var jsx$1 = (void 0)
    };
    new $c_s_Some().init___O(jsx$1)
  };
  var this$17 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Description$1);
  if ((!this$17.isEmpty__Z())) {
    var arg1$1 = this$17.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter(new $c_Lamf_core_utils_package$AmfStrings().init___T("serverDescription").asOasExtension__T(), f$3, $m_s_None$(), this.spec$2)))
  };
  var this$20 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Variables$1);
  if (this$20.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1$2 = this$20.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    var jsx$7 = new $c_Lamf_core_utils_package$AmfStrings().init___T("baseUriParameters").asOasExtension__T();
    var jsx$6 = this.ordering$2;
    var jsx$5 = this.references$2;
    var spec = this.spec$2;
    return new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(jsx$7, f$4, jsx$6, jsx$5, new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(spec.eh__Lamf_core_errorhandling_ErrorHandler(), spec.refEmitter$1, new $c_Lamf_core_emitter_ShapeRenderOptions().init___()))))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Oas2ServersEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Oas2ServersEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Oas2ServersEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter.call(this);
  this.endpoint$2 = null;
  this.f$2 = null;
  this.ordering$2 = null;
  this.references$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter.prototype.productPrefix__T = (function() {
  return "Oas3EndPointServersEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter)) {
    var Oas3EndPointServersEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter(x$1);
    var x = this.endpoint$2;
    var x$2 = Oas3EndPointServersEmitter$1.endpoint$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.f$2;
      var x$4 = Oas3EndPointServersEmitter$1.f$2;
      var jsx$2 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.ordering$2;
      var x$6 = Oas3EndPointServersEmitter$1.ordering$2;
      var jsx$1 = (x$5 === x$6)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.references$2;
      var x$8 = Oas3EndPointServersEmitter$1.references$2;
      return ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.endpoint$2;
      break
    }
    case 1: {
      return this.f$2;
      break
    }
    case 2: {
      return this.ordering$2;
      break
    }
    case 3: {
      return this.references$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter.prototype.emitters__sc_Seq = (function() {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = this.endpoint$2;
  this.asExtension__T__sc_Seq__scm_ListBuffer__V("servers", $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Servers$1)), result);
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter.prototype.init___Lamf_plugins_domain_webapi_models_EndPoint__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(endpoint, f, ordering, references, spec) {
  this.endpoint$2 = endpoint;
  this.f$2 = f;
  this.ordering$2 = ordering;
  this.references$2 = references;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter.prototype.init___Lamf_core_model_domain_DomainElement__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.call(this, endpoint, f, ordering, references, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Oas3EndPointServersEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Oas3EndPointServersEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Oas3EndPointServersEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions.prototype.init___Z__Z__Z.call(this, true, true, false);
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Oas3ExampleOptions$", {
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$;
var $n_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$)) {
    $n_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$ = new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleOptions$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.example$1 = null;
  this.options$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser.prototype.parse__Lamf_plugins_domain_shapes_models_Example = (function() {
  var map = this.map$1;
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Summary$1;
  var iv = this.ctx$1;
  jsx$1.key__T__F1__V("summary", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.example$1).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var map$1 = this.map$1;
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Description$1;
  var iv$1 = this.ctx$1;
  jsx$2.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.example$1).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var map$2 = this.map$1;
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().ExternalValue$1;
  var iv$2 = this.ctx$1;
  jsx$3.key__T__F1__V("externalValue", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.example$1).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var this$4 = this.example$1;
  var strict = this.options$1.strictDefault$1;
  var field$3 = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Strict$1;
  $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$4, field$3, strict));
  var map$3 = this.map$1;
  var this$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3).key__T__s_Option("value");
  if ((!this$6.isEmpty__Z())) {
    var arg1 = this$6.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser().init___Lorg_yaml_model_YNode__Lamf_plugins_domain_shapes_models_Example__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext(entry.value$2, this.example$1, this.options$1, this.ctx$1).parse__Lamf_plugins_domain_shapes_models_Example()
  };
  var jsx$5 = this.example$1;
  var jsx$4 = this.map$1;
  $m_sci_List$();
  var array = [$m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().example$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$10 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$10);
    i = (((-1) + i) | 0)
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(jsx$5, jsx$4, result, this.ctx$1).parse__V();
  this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(this.example$1.id$1, this.map$1, "example");
  return this.example$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser.prototype.productPrefix__T = (function() {
  return "Oas3ExampleValueParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser)) {
    var Oas3ExampleValueParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser(x$1);
    var this$1 = this.map$1;
    var b = Oas3ExampleValueParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.example$1;
      var x$2 = Oas3ExampleValueParser$1.example$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.options$1;
      var x$4 = Oas3ExampleValueParser$1.options$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.example$1;
      break
    }
    case 2: {
      return this.options$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser.prototype.EmptyTarget$lzycompute$3__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$3__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser.prototype.init___Lorg_yaml_model_YMap__Lamf_plugins_domain_shapes_models_Example__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(map, example, options, ctx) {
  this.map$1 = map;
  this.example$1 = example;
  this.options$1 = options;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Oas3ExampleValueParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Oas3ExampleValueParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Oas3ExampleValueParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser() {
  $c_O.call(this);
  this.entry$1 = null;
  this.parentId$1 = null;
  this.options$1 = null;
  this.ctx$1 = null;
  this.keyName$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser.prototype.parse__Lamf_plugins_domain_shapes_models_Example = (function() {
  var this$1 = this.entry$1.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$1;
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var x1 = this.ctx$1.link__Lorg_yaml_model_YNode__s_util_Either(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1)));
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var fullRef = $as_T(x2.value$2);
    var this$4 = this.parseLink__p1__T__Lorg_yaml_model_YMap__Lamf_plugins_domain_shapes_models_Example(fullRef, map);
    var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1);
    return $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$4, other))
  } else if ((x1 instanceof $c_s_util_Right)) {
    return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser().init___Lorg_yaml_model_YMap__Lamf_plugins_domain_shapes_models_Example__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext(map, this.newExample__p1__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_Example(map), this.options$1, this.ctx$1).parse__Lamf_plugins_domain_shapes_models_Example()
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser.prototype.productPrefix__T = (function() {
  return "Oas3NameExampleParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser)) {
    var Oas3NameExampleParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser(x$1);
    var x = this.entry$1;
    var x$2 = Oas3NameExampleParser$1.entry$1;
    if (((x === x$2) && (this.parentId$1 === Oas3NameExampleParser$1.parentId$1))) {
      var x$3 = this.options$1;
      var x$4 = Oas3NameExampleParser$1.options$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser.prototype.parseLink__p1__T__Lorg_yaml_model_YMap__Lamf_plugins_domain_shapes_models_Example = (function(fullRef, map) {
  var name = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().stripOas3ComponentsPrefix__T__T__T(fullRef, "examples");
  var this$1 = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations().findExample__T__Lamf_core_parser_SearchScope$Scope__s_Option(name, $m_Lamf_core_parser_SearchScope$All$());
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var found = $as_Lamf_plugins_domain_shapes_models_Example(arg1);
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var this$3 = new $c_s_Some().init___O(this.setName__p1__Lamf_plugins_domain_shapes_models_Example__Lamf_plugins_domain_shapes_models_Example($as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(found, name, annotations))))
  };
  if (this$3.isEmpty__Z()) {
    var this$6 = this.ctx$1;
    $m_Lamf_core_parser_Annotations$();
    new $c_Lamf_core_parser_Annotations().init___();
    var x1 = this$6.jsonSchemaRefGuide$2.obtainRemoteYNode__T__s_Option(fullRef);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var exampleNode = $as_Lorg_yaml_model_YNode(x2.value$2);
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = this.ctx$1;
      var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValueParser().init___Lorg_yaml_model_YMap__Lamf_plugins_domain_shapes_models_Example__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(exampleNode, conversion, iv)), this.newExample__p1__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_Example(exampleNode), this.options$1, this.ctx$1).parse__Lamf_plugins_domain_shapes_models_Example()
    } else {
      var x = $m_s_None$();
      if ((!(x === x1))) {
        throw new $c_s_MatchError().init___O(x1)
      };
      var this$7 = this.ctx$1.eh$1;
      var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnresolvedReference$1;
      var message = ("Cannot find example reference " + fullRef);
      var prop = $m_s_None$();
      var l = map.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$7, specification, "", prop, message, l);
      var qual$1 = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample().init___T__Lorg_yaml_model_YPart(name, map);
      $m_Lamf_core_parser_Annotations$();
      var x$2$2 = new $c_Lamf_core_parser_Annotations().init___();
      var qual$2 = this.setName__p1__Lamf_plugins_domain_shapes_models_Example__Lamf_plugins_domain_shapes_models_Example($as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(qual$1, name, x$2$2)));
      var x$3 = this.parentId$1;
      $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      var errorExample = $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$2, x$3));
      var jsx$1 = errorExample
    }
  } else {
    var jsx$1 = this$3.get__O()
  };
  return $as_Lamf_plugins_domain_shapes_models_Example(jsx$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$1;
      break
    }
    case 1: {
      return this.parentId$1;
      break
    }
    case 2: {
      return this.options$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$2__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser.prototype.setName__p1__Lamf_plugins_domain_shapes_models_Example__Lamf_plugins_domain_shapes_models_Example = (function(e) {
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Name$1;
  var this$1 = this.keyName$1;
  var value = this$1.string__Lamf_core_model_domain_AmfScalar();
  return $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(e, field, value))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser.prototype.init___Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(entry, parentId, options, ctx) {
  this.entry$1 = entry;
  this.parentId$1 = parentId;
  this.options$1 = options;
  this.ctx$1 = ctx;
  var node = entry.key$2;
  this.keyName$1 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser.prototype.EmptyTarget$lzycompute$2__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser.prototype.newExample__p1__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_Example = (function(ast) {
  var qual$1 = this.setName__p1__Lamf_plugins_domain_shapes_models_Example__Lamf_plugins_domain_shapes_models_Example($m_Lamf_plugins_domain_shapes_models_Example$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_Example(this.entry$1));
  var x$1 = this.parentId$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  return $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Oas3NameExampleParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Oas3NameExampleParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Oas3NameExampleParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NameExampleParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter.call(this);
  this.api$2 = null;
  this.f$2 = null;
  this.ordering$2 = null;
  this.references$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter.prototype.productPrefix__T = (function() {
  return "Oas3WebApiServersEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter)) {
    var Oas3WebApiServersEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter(x$1);
    var x = this.api$2;
    var x$2 = Oas3WebApiServersEmitter$1.api$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.f$2;
      var x$4 = Oas3WebApiServersEmitter$1.f$2;
      var jsx$2 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.ordering$2;
      var x$6 = Oas3WebApiServersEmitter$1.ordering$2;
      var jsx$1 = (x$5 === x$6)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.references$2;
      var x$8 = Oas3WebApiServersEmitter$1.references$2;
      return ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.api$2;
      break
    }
    case 1: {
      return this.f$2;
      break
    }
    case 2: {
      return this.ordering$2;
      break
    }
    case 3: {
      return this.references$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter.prototype.emitters__sc_Seq = (function() {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = this.f$2;
  this.asExtension__T__sc_Seq__scm_ListBuffer__V("servers", this$1.arrayValues__sc_Seq(), result);
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter.prototype.init___Lamf_plugins_domain_webapi_models_WebApi__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(api, f, ordering, references, spec) {
  this.api$2 = api;
  this.f$2 = f;
  this.ordering$2 = ordering;
  this.references$2 = references;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter.prototype.init___Lamf_core_model_domain_DomainElement__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.call(this, api, f, ordering, references, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Oas3WebApiServersEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Oas3WebApiServersEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Oas3WebApiServersEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser() {
  $c_O.call(this);
  this.entry$1 = null;
  this.producer$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser.prototype.productPrefix__T = (function() {
  return "OasContentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser)) {
    var OasContentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser(x$1);
    var x = this.entry$1;
    var x$2 = OasContentParser$1.entry$1;
    if ((x === x$2)) {
      var x$3 = this.producer$1;
      var x$4 = OasContentParser$1.producer$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$1;
      break
    }
    case 1: {
      return this.producer$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(entry, producer, ctx) {
  this.entry$1 = entry;
  this.producer$1 = producer;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser.prototype.buildPayload__p1__Lamf_plugins_domain_webapi_models_Payload = (function() {
  var node = this.entry$1.key$2;
  var iv = this.ctx$1;
  var mediaTypeNode = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
  var mediaTypeText = mediaTypeNode.text__Lamf_core_model_domain_AmfScalar().toString__T();
  var this$2 = $as_Lamf_core_model_domain_AmfElement(this.producer$1.apply__O__O(new $c_s_Some().init___O(mediaTypeText)));
  var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1);
  var payload = $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$2, other));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1;
  var value = mediaTypeNode.string__Lamf_core_model_domain_AmfScalar();
  return $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(payload, field, value))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser.prototype.parse__Lamf_plugins_domain_webapi_models_Payload = (function() {
  var this$1 = this.entry$1.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$1;
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var payload = this.buildPayload__p1__Lamf_plugins_domain_webapi_models_Payload();
  this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(payload.id$1, map, "content");
  var this$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$4 = this$3.key__T__s_Option("schema");
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$6 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, payload$1) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        $m_Lamf_core_parser_Annotations$();
        var a = new $c_Lamf_core_parser_Annotations().init___();
        var qual$1 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, "schema", a));
        var x$1 = payload$1.id$1;
        var x$2 = qual$1.adopted$default$2__sc_Seq();
        qual$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$1, x$2)
      })
    })(this, payload)), this.ctx$1).parse__s_Option();
    if ((!this$6.isEmpty__Z())) {
      var arg1$1 = this$6.get__O();
      var s = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1$1);
      $m_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$().oasAutoGeneratedAnnotation__Lamf_core_model_domain_Shape__V(s);
      var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
      var value = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(s, payload.id$1, $m_s_None$());
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
      new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(payload, field, value, annotations)))
    }
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser().init___Lorg_yaml_model_YMap__Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement__Lamf_plugins_document_webapi_contexts_WebApiContext(map, payload, this.ctx$1).parse__V();
  $as_sc_Seq(payload.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, payload$2) {
    return (function(ex$2) {
      var ex = $as_Lamf_plugins_domain_shapes_models_Example(ex$2);
      var this$9 = $as_Lamf_core_model_StrField(payload$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1)).option$1;
      if ((!this$9.isEmpty__Z())) {
        var arg1$2 = this$9.get__O();
        var mediaType = $as_T(arg1$2);
        var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().MediaType$1;
        $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(ex, field$1, mediaType))
      };
      return ex.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations($m_Lamf_core_annotations_TrackedElement$().apply__T__Lamf_core_annotations_TrackedElement(payload$2.id$1))
    })
  })(this, payload)));
  var this$11 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$12 = this$11.key__T__s_Option("encoding");
  if ((!this$12.isEmpty__Z())) {
    var arg1$3 = this$12.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
    var this$13 = entry$3.value$2;
    var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$1 = this.ctx$1;
    var encodings = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser().init___Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$13, conversion$1, iv$1)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, payload$1$1) {
      return (function(name$2) {
        var name = $as_T(name$2);
        return payload$1$1.withEncoding__T__Lamf_plugins_domain_webapi_models_Encoding(name)
      })
    })(this, payload)), this.ctx$1).parse__sc_Seq();
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Encoding$1;
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
    $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(payload, field$2, encodings, annotations$1)
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(payload, map, $m_sci_Nil$(), this.ctx$1).parse__V();
  this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(payload.id$1, map, "content");
  return payload
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasContentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasContentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasContentParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasContentParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.producer$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser.prototype.productPrefix__T = (function() {
  return "OasEncodingParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser)) {
    var OasEncodingParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser(x$1);
    var this$1 = this.map$1;
    var b = OasEncodingParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.producer$1;
      var x$2 = OasEncodingParser$1.producer$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser.prototype.newEncoding__p1__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_Encoding = (function(entry) {
  var node = entry.key$2;
  var iv = this.ctx$1;
  var keyNode = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
  var this$2 = $as_Lamf_core_model_domain_AmfElement(this.producer$1.apply__O__O(keyNode.text__Lamf_core_model_domain_AmfScalar().toString__T()));
  var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  var encoding = $as_Lamf_plugins_domain_webapi_models_Encoding($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$2, other));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().PropertyName$1;
  var value = keyNode.string__Lamf_core_model_domain_AmfScalar();
  return $as_Lamf_plugins_domain_webapi_models_Encoding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(encoding, field, value))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.producer$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser.prototype.parse__sc_Seq = (function() {
  var jsx$6 = this.map$1.entries$3;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var this$1 = entry.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = $this.ctx$1;
      var m = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
      var encoding = $this.newEncoding__p1__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_Encoding(entry);
      var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(m);
      var field = $m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().ContentType$1;
      var iv$1 = $this.ctx$1;
      jsx$2.key__T__F1__V("contentType", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext($this, field, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(encoding));
      var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(m);
      var this$5 = this$4.key__T__s_Option("headers");
      if ((!this$5.isEmpty__Z())) {
        var arg1 = this$5.get__O();
        var entry$2$1 = $as_Lorg_yaml_model_YMapEntry(arg1);
        var this$6 = entry$2$1.value$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv$2 = $this.ctx$1;
        var parameters = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser().init___Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion$1, iv$2)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, encoding$1) {
          return (function(header$2) {
            var header = $as_Lamf_plugins_domain_webapi_models_Parameter(header$2);
            var parent = encoding$1.id$1;
            $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
            $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(header, parent);
            var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Headers$1;
            $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(encoding$1, field$1, header)
          })
        })($this, encoding)), $this.ctx$1).parse__sc_Seq();
        var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().Headers$1;
        var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$2$1);
        $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(encoding, field$2, parameters, annotations)
      };
      var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(m);
      var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().Style$1;
      var iv$3 = $this.ctx$1;
      jsx$3.key__T__F1__V("style", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext($this, field$3, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(encoding));
      var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(m);
      var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().Explode$1;
      var iv$4 = $this.ctx$1;
      jsx$4.key__T__F1__V("explode", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext($this, field$4, iv$4).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(encoding));
      var jsx$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(m);
      var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().AllowReserved$1;
      var iv$5 = $this.ctx$1;
      jsx$5.key__T__F1__V("allowReserved", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext($this, field$5, iv$5).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(encoding));
      new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(encoding, m, $m_sci_Nil$(), $this.ctx$1).parse__V();
      $this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(encoding.id$1, m, "encoding");
      return encoding
    })
  })(this));
  var this$11 = $m_sc_IndexedSeq$();
  return $as_sc_Seq(jsx$6.map__F1__scg_CanBuildFrom__O(jsx$1, this$11.ReusableCBF$6))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser.prototype.init___Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(map, producer, ctx) {
  this.map$1 = map;
  this.producer$1 = producer;
  this.ctx$1 = ctx;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasEncodingParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasEncodingParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasEncodingParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser$$anonfun$1.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var s = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(x2.value$2);
    return s
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser$$anonfun$1.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  return (x1 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasEndpointParser$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.adopt$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser.prototype.parse__Lamf_plugins_domain_webapi_models_Parameter = (function() {
  var x = this.ctx$1.syntax__Lamf_plugins_document_webapi_parser_spec_SpecSyntax();
  var x$2 = $m_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$();
  if (((x !== null) && (x === x$2))) {
    var jsx$1 = this.ctx$1;
    $m_Lorg_yaml_model_YNode$();
    var map = this.map$1;
    $m_Lorg_yaml_model_YNode$();
    var x1 = jsx$1.link__Lorg_yaml_model_YNode__s_util_Either($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1));
    if ((x1 instanceof $c_s_util_Left)) {
      var x2 = $as_s_util_Left(x1);
      var fullRef = $as_T(x2.value$2);
      var label = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().stripOas3ComponentsPrefix__T__T__T(fullRef, "headers");
      var this$3 = this.ctx$1.declarations$4.findHeader__T__Lamf_core_parser_SearchScope$Scope__s_Option(label, $m_Lamf_core_parser_SearchScope$Named$());
      if (this$3.isEmpty__Z()) {
        var this$5 = $m_s_None$()
      } else {
        var arg1 = this$3.get__O();
        var header = $as_Lamf_plugins_domain_webapi_models_Parameter(arg1);
        $m_Lamf_core_parser_Annotations$();
        var annotations = new $c_Lamf_core_parser_Annotations().init___();
        var linkHeader = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(header, label, annotations));
        this.adopt$1.apply__O__O(linkHeader);
        var this$5 = new $c_s_Some().init___O(linkHeader)
      };
      if (this$5.isEmpty__Z()) {
        var this$8 = this.ctx$1;
        $m_Lamf_core_parser_Annotations$();
        new $c_Lamf_core_parser_Annotations().init___();
        var x1$1 = this$8.jsonSchemaRefGuide$2.obtainRemoteYNode__T__s_Option(fullRef);
        if ((x1$1 instanceof $c_s_Some)) {
          var x2$1 = $as_s_Some(x1$1);
          var requestNode = $as_Lorg_yaml_model_YNode(x2$1.value$2);
          var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
          var iv = this.ctx$1;
          var jsx$2 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser().init___Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(requestNode, conversion, iv)), this.adopt$1, this.ctx$1).parse__Lamf_plugins_domain_webapi_models_Parameter()
        } else {
          var x$1 = $m_s_None$();
          if ((!(x$1 === x1$1))) {
            throw new $c_s_MatchError().init___O(x1$1)
          };
          var this$9 = this.ctx$1.eh$1;
          var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnresolvedReference$1;
          var message = ("Cannot find header reference " + fullRef);
          var ast = this.map$1;
          var prop = $m_s_None$();
          var l = ast.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$9, specification, "", prop, message, l);
          var error = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter().init___T__Lorg_yaml_model_YPart(label, this.map$1);
          this.adopt$1.apply__O__O(error);
          var jsx$2 = error
        }
      } else {
        var jsx$2 = this$5.get__O()
      };
      var header$5 = $as_Lamf_plugins_domain_webapi_models_Parameter(jsx$2)
    } else {
      if ((!(x1 instanceof $c_s_util_Right))) {
        throw new $c_s_MatchError().init___O(x1)
      };
      var header$3 = this.commonHeader$1__p1__Lamf_plugins_domain_webapi_models_Parameter();
      this.parseOas3Header__Lamf_plugins_domain_webapi_models_Parameter__Lorg_yaml_model_YMap__V(header$3, this.map$1);
      var header$5 = header$3
    }
  } else {
    var header$4 = this.commonHeader$1__p1__Lamf_plugins_domain_webapi_models_Parameter();
    this.parseOas2Header__Lamf_plugins_domain_webapi_models_Parameter__Lorg_yaml_model_YMap__V(header$4, this.map$1);
    var header$5 = header$4
  };
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
  var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations("header", new $c_Lamf_core_parser_Annotations().init___());
  var annotations$1 = ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SynthesizedField().init___());
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(header$5, field, value, annotations$1);
  return header$5
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser.prototype.productPrefix__T = (function() {
  return "OasHeaderParameterParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser)) {
    var OasHeaderParameterParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser(x$1);
    var this$1 = this.map$1;
    var b = OasHeaderParameterParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.adopt$1;
      var x$2 = OasHeaderParameterParser$1.adopt$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.adopt$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser.prototype.commonHeader$1__p1__Lamf_plugins_domain_webapi_models_Parameter = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var parameter = new $c_Lamf_plugins_domain_webapi_models_Parameter().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  this.adopt$1.apply__O__O(parameter);
  var map = this.map$1;
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Description$1;
  var iv = this.ctx$1;
  jsx$1.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(parameter));
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(parameter, this.map$1, $m_sci_Nil$(), this.ctx$1).parse__V();
  return parameter
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser.prototype.parseOas2Header__Lamf_plugins_domain_webapi_models_Parameter__Lorg_yaml_model_YMap__V = (function(parameter, map) {
  var this$1 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_StrField(parameter.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1)));
  if (this$1.isEmpty__Z()) {
    var name = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_Lamf_core_model_StrField(arg1);
    var this$2 = x$1.option$1;
    var name = new $c_s_Some().init___O($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())))
  };
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1;
  if ((!name.isEmpty__Z())) {
    var arg1$1 = name.get__O();
    var x$2 = $as_T(arg1$1);
    var jsx$1 = $m_sjsr_RuntimeString$().endsWith__T__T__Z(x$2, "?")
  } else {
    var jsx$1 = false
  };
  var value = (!jsx$1);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(parameter, field, value);
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1;
  var iv = this.ctx$1;
  var this$4 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(parameter);
  jsx$2.key__T__F1__V("x-amf-required", this$4.withAnnotation__Lamf_core_model_domain_Annotation__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_Lamf_core_annotations_ExplicitField().init___()));
  var this$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$7 = this$6.key__T__s_Option("type");
  if ((!this$7.isEmpty__Z())) {
    var arg1$2 = this$7.get__O();
    $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var this$11 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YNode__T__F1__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1)), $as_T((name.isEmpty__Z() ? "default" : name.get__O())), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, parameter$1) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        $m_Lamf_core_parser_Annotations$();
        var a = new $c_Lamf_core_parser_Annotations().init___();
        var qual$1 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, "schema", a));
        var x$1$1 = parameter$1.id$1;
        var x$2$1 = qual$1.adopted$default$2__sc_Seq();
        qual$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$1$1, x$2$1)
      })
    })(this, parameter)), this.ctx$1).parse__s_Option();
    if ((!this$11.isEmpty__Z())) {
      var arg1$3 = this$11.get__O();
      var s = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1$3);
      var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1;
      var value$1 = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(s, parameter.id$1, $m_s_None$());
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(map);
      new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(parameter, field$2, value$1, annotations)))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser.prototype.parseOas3Header__Lamf_plugins_domain_webapi_models_Parameter__Lorg_yaml_model_YMap__V = (function(parameter, map) {
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1;
  var iv = this.ctx$1;
  var this$2 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(parameter);
  jsx$1.key__T__F1__V("required", this$2.withAnnotation__Lamf_core_model_domain_Annotation__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_Lamf_core_annotations_ExplicitField().init___()));
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Deprecated$1;
  var iv$1 = this.ctx$1;
  var this$4 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(parameter);
  jsx$2.key__T__F1__V("deprecated", this$4.withAnnotation__Lamf_core_model_domain_Annotation__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_Lamf_core_annotations_ExplicitField().init___()));
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().AllowEmptyValue$1;
  var iv$2 = this.ctx$1;
  var this$6 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(parameter);
  jsx$3.key__T__F1__V("allowEmptyValue", this$6.withAnnotation__Lamf_core_model_domain_Annotation__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_Lamf_core_annotations_ExplicitField().init___()));
  var this$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$9 = this$8.key__T__s_Option("schema");
  if ((!this$9.isEmpty__Z())) {
    var arg1 = this$9.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$11 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parameter$2) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        $m_Lamf_core_parser_Annotations$();
        var a = new $c_Lamf_core_parser_Annotations().init___();
        var qual$1 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, "schema", a));
        var x$1 = parameter$2.id$1;
        var x$2 = qual$1.adopted$default$2__sc_Seq();
        qual$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$1, x$2)
      })
    })(this, parameter)), this.ctx$1).parse__s_Option();
    if ((!this$11.isEmpty__Z())) {
      var arg1$1 = this$11.get__O();
      var s = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1$1);
      var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1;
      var value = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(s, parameter.id$1, $m_s_None$());
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
      new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(parameter, field$3, value, annotations)))
    }
  };
  var this$14 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$15 = this$14.key__T__s_Option("content");
  if ((!this$15.isEmpty__Z())) {
    var arg1$2 = this$15.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var payloadProducer = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, parameter$2$1) {
      return (function(mediaType$2) {
        var mediaType = $as_s_Option(mediaType$2);
        $m_Lamf_core_parser_Annotations$();
        var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
        var res = new $c_Lamf_plugins_domain_webapi_models_Payload().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
        if ((!mediaType.isEmpty__Z())) {
          var arg1$3 = mediaType.get__O();
          var mediaType$2$1 = $as_T(arg1$3);
          var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1;
          new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(res, field$4, mediaType$2$1)))
        };
        var parent = parameter$2$1.id$1;
        $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        return $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(res, parent))
      })
    })(this, parameter));
    var payloads = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser().init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(entry$3, payloadProducer, this.ctx$1).parse__sci_List();
    if ($f_sc_TraversableOnce__nonEmpty__Z(payloads)) {
      var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Payloads$1;
      var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(payloads, new $c_Lamf_core_parser_Annotations().init___());
      var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(parameter, field$5, value$1, annotations$2)
    }
  };
  $m_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$().validateSchemaOrContent__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Parameter__Lamf_plugins_document_webapi_contexts_WebApiContext__V(map, parameter, this.ctx$1);
  new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser().init___Lorg_yaml_model_YMap__Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement__Lamf_plugins_document_webapi_contexts_WebApiContext(map, parameter, this.ctx$1).parse__V();
  var field$6 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
  $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(parameter, field$6, "header"));
  $m_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$().parseStyleField__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Parameter__Lamf_plugins_document_webapi_contexts_WebApiContext__V(map, parameter, this.ctx$1);
  $m_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$().parseExplodeField__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Parameter__V(map, parameter);
  this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(parameter.id$1, map, "header")
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser.prototype.init___Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(map, adopt, ctx) {
  this.map$1 = map;
  this.adopt$1 = adopt;
  this.ctx$1 = ctx;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasHeaderParameterParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasHeaderParameterParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasHeaderParameterParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParameterParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser() {
  $c_O.call(this);
  this.parentId$1 = null;
  this.definitionEntry$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser.prototype.productPrefix__T = (function() {
  return "OasLinkParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser)) {
    var OasLinkParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser(x$1);
    if ((this.parentId$1 === OasLinkParser$1.parentId$1)) {
      var x = this.definitionEntry$1;
      var x$2 = OasLinkParser$1.definitionEntry$1;
      return (x === x$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.parentId$1;
      break
    }
    case 1: {
      return this.definitionEntry$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser.prototype.nameAndAdopt__p1__Lamf_plugins_domain_webapi_models_TemplatedLink__Lamf_plugins_domain_webapi_models_TemplatedLink = (function(templateLink) {
  var field = $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Name$1;
  var node = this.definitionEntry$1.key$2;
  var iv = this.ctx$1;
  var this$2 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
  var value = this$2.string__Lamf_core_model_domain_AmfScalar();
  var qual$1 = $as_Lamf_plugins_domain_webapi_models_TemplatedLink($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(templateLink, field, value));
  var x$1 = this.parentId$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$3 = $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1);
  var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.definitionEntry$1);
  return $as_Lamf_plugins_domain_webapi_models_TemplatedLink($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$3, other))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser.prototype.init___T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(parentId, definitionEntry, ctx) {
  this.parentId$1 = parentId;
  this.definitionEntry$1 = definitionEntry;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser.prototype.parse__Lamf_plugins_domain_webapi_models_TemplatedLink = (function() {
  var this$1 = this.definitionEntry$1.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$1;
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var x1 = this.ctx$1.link__Lorg_yaml_model_YNode__s_util_Either(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1)));
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var fullRef = $as_T(x2.value$2);
    var label = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().stripOas3ComponentsPrefix__T__T__T(fullRef, "links");
    var this$4 = this.ctx$1.declarations$4.findTemplatedLink__T__Lamf_core_parser_SearchScope$Scope__s_Option(label, $m_Lamf_core_parser_SearchScope$Named$());
    if (this$4.isEmpty__Z()) {
      var this$6 = $m_s_None$()
    } else {
      var arg1 = this$4.get__O();
      var templatedLink = $as_Lamf_plugins_domain_webapi_models_TemplatedLink(arg1);
      $m_Lamf_core_parser_Annotations$();
      var annotations = new $c_Lamf_core_parser_Annotations().init___();
      var this$6 = new $c_s_Some().init___O(this.nameAndAdopt__p1__Lamf_plugins_domain_webapi_models_TemplatedLink__Lamf_plugins_domain_webapi_models_TemplatedLink($as_Lamf_plugins_domain_webapi_models_TemplatedLink($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(templatedLink, label, annotations))))
    };
    return $as_Lamf_plugins_domain_webapi_models_TemplatedLink((this$6.isEmpty__Z() ? this.remote__p1__T__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_TemplatedLink(fullRef, map) : this$6.get__O()))
  } else if ((x1 instanceof $c_s_util_Right)) {
    return this.buildAndPopulate__p1__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_TemplatedLink(map)
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser.prototype.remote__p1__T__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_TemplatedLink = (function(fullRef, map) {
  var this$3 = this.ctx$1;
  $m_Lamf_core_parser_Annotations$();
  new $c_Lamf_core_parser_Annotations().init___();
  var x1 = this$3.jsonSchemaRefGuide$2.obtainRemoteYNode__T__s_Option(fullRef);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var requestNode = $as_Lorg_yaml_model_YNode(x2.value$2);
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$1;
    return this.buildAndPopulate__p1__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_TemplatedLink($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(requestNode, conversion, iv)))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$4 = this.ctx$1.eh$1;
      var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnresolvedReference$1;
      var message = ("Cannot find link reference " + fullRef);
      var prop = $m_s_None$();
      var l = map.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$4, specification, "", prop, message, l);
      var qual$1 = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorLink().init___T__Lorg_yaml_model_YPart(fullRef, map);
      $m_Lamf_core_parser_Annotations$();
      var x$2$2 = new $c_Lamf_core_parser_Annotations().init___();
      return this.nameAndAdopt__p1__Lamf_plugins_domain_webapi_models_TemplatedLink__Lamf_plugins_domain_webapi_models_TemplatedLink($as_Lamf_plugins_domain_webapi_models_TemplatedLink($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(qual$1, fullRef, x$2$2)))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser.prototype.buildAndPopulate__p1__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_TemplatedLink = (function(map) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator().init___Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_TemplatedLink__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(map, this.nameAndAdopt__p1__Lamf_plugins_domain_webapi_models_TemplatedLink__Lamf_plugins_domain_webapi_models_TemplatedLink(new $c_Lamf_plugins_domain_webapi_models_TemplatedLink().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)), this.ctx$1).populate__Lamf_plugins_domain_webapi_models_TemplatedLink()
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasLinkParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasLinkParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasLinkParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator() {
  $c_O.call(this);
  this.map$1 = null;
  this.templatedLink$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator.prototype.productPrefix__T = (function() {
  return "OasLinkPopulator"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator)) {
    var OasLinkPopulator$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator(x$1);
    var this$1 = this.map$1;
    var b = OasLinkPopulator$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.templatedLink$1;
      var x$2 = OasLinkPopulator$1.templatedLink$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.templatedLink$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$2__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator.prototype.EmptyTarget$lzycompute$2__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator.prototype.populate__Lamf_plugins_domain_webapi_models_TemplatedLink = (function() {
  var map = this.map$1;
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().OperationRef$1;
  var iv = this.ctx$1;
  jsx$1.key__T__F1__V("operationRef", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.templatedLink$1));
  var map$1 = this.map$1;
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().OperationId$1;
  var iv$1 = this.ctx$1;
  jsx$2.key__T__F1__V("operationId", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.templatedLink$1));
  var this$3 = this.templatedLink$1;
  if ($as_Lamf_core_model_StrField(this$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().OperationRef$1)).option$1.isDefined__Z()) {
    var this$4 = this.templatedLink$1;
    var jsx$3 = $as_Lamf_core_model_StrField(this$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().OperationId$1)).option$1.isDefined__Z()
  } else {
    var jsx$3 = false
  };
  if (jsx$3) {
    var this$5 = this.ctx$1.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().ExclusiveLinkTargetError$1;
    var node = this.templatedLink$1.id$1;
    var message = $m_Lamf_validations_ParserSideValidations$().ExclusiveLinkTargetError$1.message$1;
    var annotations = this.templatedLink$1.annotations$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$5, specification, node, message, annotations)
  };
  var map$2 = this.map$1;
  var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Description$1;
  var iv$2 = this.ctx$1;
  jsx$4.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.templatedLink$1));
  var map$3 = this.map$1;
  var this$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3).key__T__s_Option("server");
  if ((!this$8.isEmpty__Z())) {
    var arg1 = this$8.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$9 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$3 = this.ctx$1;
    var m = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$9, conversion, iv$3));
    var server = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser().init___T__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(this.templatedLink$1.id$1, m, this.ctx$1).parse__Lamf_plugins_domain_webapi_models_Server();
    var this$10 = this.templatedLink$1;
    var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Server$1;
    $as_Lamf_plugins_domain_webapi_models_TemplatedLink($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$10, field$3, server))
  };
  var map$4 = this.map$1;
  var this$12 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$4);
  var this$13 = this$12.key__T__s_Option("parameters");
  if ((!this$13.isEmpty__Z())) {
    var arg1$1 = this$13.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var this$14 = entry$3.value$2;
    var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$4 = this.ctx$1;
    var jsx$6 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$14, conversion$1, iv$4)).entries$3;
    var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(entry$2$2) {
        var entry$2 = $as_Lorg_yaml_model_YMapEntry(entry$2$2);
        var node$1 = entry$2.key$2;
        var iv$5 = $this.ctx$1;
        var this$16 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$1, iv$5);
        var variable = this$16.string__Lamf_core_model_domain_AmfScalar();
        var node$2 = entry$2.value$2;
        var iv$6 = $this.ctx$1;
        var this$18 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$2, iv$6);
        var expression = this$18.string__Lamf_core_model_domain_AmfScalar();
        var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$2);
        var this$21 = new $c_Lamf_plugins_domain_webapi_models_IriTemplateMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
        var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$().TemplateVariable$1;
        var this$22 = $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$21, field$4, variable);
        var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$().LinkExpression$1;
        return $as_Lamf_plugins_domain_webapi_models_IriTemplateMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$22, field$5, expression))
      })
    })(this));
    var this$23 = $m_sc_IndexedSeq$();
    var parameters = $as_sc_Seq(jsx$6.map__F1__scg_CanBuildFrom__O(jsx$5, this$23.ReusableCBF$6));
    var this$24 = this.templatedLink$1;
    var field$6 = $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Mapping$1;
    var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3.value$2);
    $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$24, field$6, parameters, annotations$2)
  };
  var map$5 = this.map$1;
  var jsx$7 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$5);
  var field$7 = $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().RequestBody$1;
  var iv$7 = this.ctx$1;
  jsx$7.key__T__F1__V("requestBody", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$7, iv$7).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.templatedLink$1));
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(this.templatedLink$1, this.map$1, $m_sci_Nil$(), this.ctx$1).parse__V();
  this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(this.templatedLink$1.id$1, this.map$1, "link");
  return this.templatedLink$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator.prototype.init___Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_TemplatedLink__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(map, templatedLink, ctx) {
  this.map$1 = map;
  this.templatedLink$1 = templatedLink;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasLinkPopulator"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasLinkPopulator;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasLinkPopulator", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkPopulator;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser() {
  $c_O.call(this);
  this.node$1 = null;
  this.producer$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser.prototype.productPrefix__T = (function() {
  return "OasPayloadParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser.prototype.init___Lorg_yaml_model_YNode__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(node, producer, ctx) {
  this.node$1 = node;
  this.producer$1 = producer;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser)) {
    var OasPayloadParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser(x$1);
    var this$1 = this.node$1;
    var b = OasPayloadParser$1.node$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.producer$1;
      var x$2 = OasPayloadParser$1.producer$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.node$1;
      break
    }
    case 1: {
      return this.producer$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser.prototype.parse__Lamf_plugins_domain_webapi_models_Payload = (function() {
  var this$1 = this.node$1;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$1;
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var jsx$2 = this.producer$1;
  var this$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("mediaType");
  if (this$3.isEmpty__Z()) {
    var jsx$1 = $m_s_None$()
  } else {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var node = entry.value$2;
    var iv$1 = this.ctx$1;
    var this$5 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv$1);
    var jsx$1 = new $c_s_Some().init___O($objectToString(this$5.text__Lamf_core_model_domain_AmfScalar().value$1))
  };
  var this$8 = $as_Lamf_core_model_domain_AmfElement(jsx$2.apply__O__O(jsx$1));
  var other = $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1)));
  var payload = $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$8, other));
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Name$1;
  var iv$2 = this.ctx$1;
  jsx$3.key__T__F1__V("name", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(payload));
  var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1;
  var iv$3 = this.ctx$1;
  jsx$4.key__T__F1__V("mediaType", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(payload));
  var this$12 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$13 = this$12.key__T__s_Option("schema");
  if ((!this$13.isEmpty__Z())) {
    var arg1$1 = this$13.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var this$15 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(entry$3, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, payload$1) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        $m_Lamf_core_parser_Annotations$();
        var a = new $c_Lamf_core_parser_Annotations().init___();
        var qual$1 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, "schema", a));
        var x$1 = payload$1.id$1;
        var x$2 = qual$1.adopted$default$2__sc_Seq();
        qual$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$1, x$2)
      })
    })(this, payload)), this.ctx$1).parse__s_Option();
    if ((!this$15.isEmpty__Z())) {
      var arg1$2 = this$15.get__O();
      var s = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1$2);
      var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
      var value = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(s, payload.id$1, $m_s_None$());
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
      new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(payload, field$2, value, annotations)))
    }
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(payload, map, $m_sci_Nil$(), this.ctx$1).parse__V();
  return payload
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasPayloadParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasPayloadParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasPayloadParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$$anonfun$apply$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$$anonfun$apply$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$$anonfun$apply$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$$anonfun$apply$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$$anonfun$apply$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$$anonfun$apply$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$$anonfun$apply$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$$anonfun$apply$1.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$$anonfun$apply$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_shapes_models_Example)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$$anonfun$apply$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_Example)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_Example(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$$anonfun$apply$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$$anonfun$apply$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$$anonfun$apply$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$$anonfun$apply$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasResponseExamplesEmitter$$anonfun$apply$1", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$$anonfun$apply$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$$anonfun$apply$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$$anonfun$apply$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.adopted$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser.prototype.productPrefix__T = (function() {
  return "OasResponseParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser.prototype.defaultPayload__p1__Lorg_yaml_model_YMap__T__s_Option = (function(entries, parentId) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_Payload().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var annotation = new $c_Lamf_plugins_document_webapi_annotations_DefaultPayload().init___();
  var payload = $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$4, annotation));
  var this$7 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(entries);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("mediaType").asOasExtension__T();
  var this$8 = this$7.key__T__s_Option(keyword);
  if ((!this$8.isEmpty__Z())) {
    var arg1 = this$8.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1;
    var node = entry.value$2;
    var iv = this.ctx$1;
    var this$10 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
    var value = this$10.string__Lamf_core_model_domain_AmfScalar();
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(payload, field, value, annotations$1)
  };
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(payload, parentId);
  var this$12 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(entries);
  var this$13 = this$12.key__T__s_Option("schema");
  if ((!this$13.isEmpty__Z())) {
    var arg1$1 = this$13.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var this$15 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(entry$3, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, payload$1) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        $m_Lamf_core_parser_Annotations$();
        var a = new $c_Lamf_core_parser_Annotations().init___();
        var qual$1 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, "default", a));
        var x$1 = payload$1.id$1;
        var x$2 = qual$1.adopted$default$2__sc_Seq();
        qual$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$1, x$2)
      })
    })(this, payload)), this.ctx$1).parse__s_Option();
    if (this$15.isEmpty__Z()) {
      var shape$3 = $m_s_None$()
    } else {
      var arg1$2 = this$15.get__O();
      var s = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1$2);
      $m_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$().oasAutoGeneratedAnnotation__Lamf_core_model_domain_Shape__V(s);
      var shape$3 = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(s, payload.id$1, $m_s_None$()))
    };
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
    var value$1 = $as_Lamf_core_model_domain_AmfElement((shape$3.isEmpty__Z() ? $m_Lamf_plugins_domain_shapes_models_AnyShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_AnyShape(entry$3.value$2) : shape$3.get__O()));
    var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(payload, field$1, value$1, annotations$2);
    payload.annotations$1.$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations($m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3))
  };
  var this$18 = payload.fields$1;
  var this$19 = this$18.fs$1;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$19)) {
    return new $c_s_Some().init___O(payload)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser.prototype.parse__Lamf_plugins_domain_webapi_models_Response = (function() {
  var jsx$1 = this.ctx$1;
  $m_Lorg_yaml_model_YNode$();
  var map = this.map$1;
  $m_Lorg_yaml_model_YNode$();
  var x1 = jsx$1.link__Lorg_yaml_model_YNode__s_util_Either($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1));
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var url = $as_T(x2.value$2);
    var name = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().stripResponsesDefinitionsPrefix__T__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext__T(url, this.ctx$1);
    var this$3 = this.ctx$1.declarations$4.findResponse__T__Lamf_core_parser_SearchScope$Scope__s_Option(name, $m_Lamf_core_parser_SearchScope$Named$());
    if (this$3.isEmpty__Z()) {
      var this$5 = $m_s_None$()
    } else {
      var arg1 = this$3.get__O();
      var res = $as_Lamf_plugins_domain_webapi_models_Response(arg1);
      $m_Lamf_core_parser_Annotations$();
      var annotations = new $c_Lamf_core_parser_Annotations().init___();
      var resLink = $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(res, name, annotations));
      this.adopted$1.apply__O__O(resLink);
      var this$5 = new $c_s_Some().init___O(resLink)
    };
    if (this$5.isEmpty__Z()) {
      var x1$1 = this.ctx$1.navigateToRemoteYNode__T__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__s_Option(url, this.ctx$1);
      if ((x1$1 instanceof $c_s_Some)) {
        var x2$1 = $as_s_Some(x1$1);
        var result = $as_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation(x2$1.value$2);
        var this$6 = result.remoteNode$1;
        var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv = this.ctx$1;
        var jsx$2 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser().init___Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion, iv)), this.adopted$1, $as_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(result.context$1)).parse__Lamf_plugins_domain_webapi_models_Response()
      } else {
        var x = $m_s_None$();
        if ((!(x === x1$1))) {
          throw new $c_s_MatchError().init___O(x1$1)
        };
        var this$7 = this.ctx$1.eh$1;
        var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnresolvedReference$1;
        var message = ("Cannot find response reference " + url);
        var ast = this.map$1;
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$7, specification, "", prop, message, l);
        var qual$1 = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse().init___T__Lorg_yaml_model_YPart(url, this.map$1);
        $m_Lamf_core_parser_Annotations$();
        var x$2$2 = new $c_Lamf_core_parser_Annotations().init___();
        var errorRes = $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(qual$1, name, x$2$2));
        this.adopted$1.apply__O__O(errorRes);
        var jsx$2 = errorRes
      }
    } else {
      var jsx$2 = this$5.get__O()
    };
    return $as_Lamf_plugins_domain_webapi_models_Response(jsx$2)
  } else if ((x1 instanceof $c_s_util_Right)) {
    $m_Lamf_core_parser_Annotations$();
    var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
    var res$3 = new $c_Lamf_plugins_domain_webapi_models_Response().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
    this.adopted$1.apply__O__O(res$3);
    this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(res$3.id$1, this.map$1, "response");
    var map$1 = this.map$1;
    var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Description$1;
    var iv$1 = this.ctx$1;
    jsx$3.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(res$3));
    var map$2 = this.map$1;
    var this$14 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
    var this$15 = this$14.key__T__s_Option("headers");
    if ((!this$15.isEmpty__Z())) {
      var arg1$1 = this$15.get__O();
      var entry = $as_Lorg_yaml_model_YMapEntry(arg1$1);
      var this$16 = entry.value$2;
      var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv$2 = this.ctx$1;
      var parameters = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser().init___Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$16, conversion$1, iv$2)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, res$1) {
        return (function(header$2) {
          var header = $as_Lamf_plugins_domain_webapi_models_Parameter(header$2);
          var parent = res$1.id$1;
          $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
          $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(header, parent);
          var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Headers$1;
          $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(res$1, field$1, header)
        })
      })(this, res$3)), this.ctx$1).parse__sc_Seq();
      var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Headers$1;
      var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(parameters, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
      var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(res$3, field$2, value, annotations$2)
    };
    var payloads = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var x$1 = this.ctx$1.syntax__Lamf_plugins_document_webapi_parser_spec_SpecSyntax();
    var x$2 = $m_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$();
    if (((x$1 !== null) && (x$1 === x$2))) {
      var this$17 = this.defaultPayload__p1__Lorg_yaml_model_YMap__T__s_Option(this.map$1, res$3.id$1);
      if ((!this$17.isEmpty__Z())) {
        var arg1$2 = this$17.get__O();
        var x$1$1 = $as_Lamf_plugins_domain_webapi_models_Payload(arg1$2);
        payloads.$$plus$eq__O__scm_ListBuffer(x$1$1)
      };
      var map$3 = this.map$1;
      var this$19 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3);
      var this$20 = this$19.key__T__s_Option("examples");
      if ((!this$20.isEmpty__Z())) {
        var arg1$3 = this$20.get__O();
        var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
        var examples = new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExamplesByMediaTypeParser().init___Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_WebApiContext(entry$3, res$3.id$1, this.ctx$1).parse__sc_Seq();
        if (examples.nonEmpty__Z()) {
          examples.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, res$1$1) {
            return (function(x$2$2$1) {
              var x$2$1 = $as_Lamf_plugins_domain_shapes_models_Example(x$2$2$1);
              return x$2$1.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations($m_Lamf_core_annotations_TrackedElement$().apply__T__Lamf_core_annotations_TrackedElement(res$1$1.id$1))
            })
          })(this, res$3)))
        };
        var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Examples$1;
        var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(examples, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3.value$2));
        var annotations$3 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(res$3, field$3, value$1, annotations$3)
      };
      this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(res$3.id$1, this.map$1, "response")
    };
    var map$4 = this.map$1;
    var this$23 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$4);
    var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("responsePayloads").asOasExtension__T();
    var this$24 = this$23.key__T__s_Option(keyword);
    if ((!this$24.isEmpty__Z())) {
      var arg1$4 = this$24.get__O();
      var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$4);
      var this$27 = entry$4.value$2;
      var reader = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var this$26 = $m_sc_IndexedSeq$();
      var bf = this$26.ReusableCBF$6;
      var conversion$2 = new $c_Lorg_yaml_convert_YRead$$anon$1().init___scg_CanBuildFrom__Lorg_yaml_convert_YRead(bf, reader);
      var iv$3 = this.ctx$1;
      var jsx$5 = $as_sc_TraversableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$27, conversion$2, iv$3));
      var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, payloads$1, res$1$2) {
        return (function(value$2) {
          var value$3 = $as_Lorg_yaml_model_YMap(value$2);
          return payloads$1.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadParser().init___Lorg_yaml_model_YNode__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(value$3, $m_Lorg_yaml_model_YType$().Map$1)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, res$1$3) {
            return (function(mediaType$2) {
              var mediaType = $as_s_Option(mediaType$2);
              return res$1$3.withPayload__s_Option__Lamf_plugins_domain_webapi_models_Payload(mediaType)
            })
          })($this$2, res$1$2)), $this$2.ctx$1).parse__Lamf_plugins_domain_webapi_models_Payload())
        })
      })(this, payloads, res$3));
      var this$30 = $m_sc_Seq$();
      jsx$5.map__F1__scg_CanBuildFrom__O(jsx$4, this$30.ReusableCBFInstance$2)
    };
    var x$3 = this.ctx$1.syntax__Lamf_plugins_document_webapi_parser_spec_SpecSyntax();
    var x$4 = $m_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$();
    if (((x$3 !== null) && (x$3 === x$4))) {
      var map$5 = this.map$1;
      var this$32 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$5);
      var this$33 = this$32.key__T__s_Option("content");
      if ((!this$33.isEmpty__Z())) {
        var arg1$5 = this$33.get__O();
        var entry$5 = $as_Lorg_yaml_model_YMapEntry(arg1$5);
        payloads.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser().init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(entry$5, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$4, res$1$4) {
          return (function(mediaType$2$1) {
            var mediaType$1 = $as_s_Option(mediaType$2$1);
            return res$1$4.withPayload__s_Option__Lamf_plugins_domain_webapi_models_Payload(mediaType$1)
          })
        })(this, res$3)), this.ctx$1).parse__sci_List())
      };
      var map$6 = this.map$1;
      var this$35 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$6);
      var this$36 = this$35.key__T__s_Option("links");
      if ((!this$36.isEmpty__Z())) {
        var arg1$6 = this$36.get__O();
        var entry$6 = $as_Lorg_yaml_model_YMapEntry(arg1$6);
        var this$37 = entry$6.value$2;
        var conversion$3 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv$4 = this.ctx$1;
        var jsx$7 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$37, conversion$3, iv$4)).entries$3;
        var jsx$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$5, res$1$5) {
          return (function(e$2) {
            var e = $as_Lorg_yaml_model_YMapEntry(e$2);
            return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser().init___T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(res$1$5.id$1, e, $this$5.ctx$1).parse__Lamf_plugins_domain_webapi_models_TemplatedLink()
          })
        })(this, res$3));
        var this$38 = $m_sc_IndexedSeq$();
        var links = $as_sc_IndexedSeq(jsx$7.map__F1__scg_CanBuildFrom__O(jsx$6, this$38.ReusableCBF$6));
        var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Links$1;
        var value$4 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(links, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$6));
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(res$3, field$4, value$4)
      }
    };
    if (payloads.nonEmpty__Z()) {
      var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Payloads$1;
      var value$5 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(payloads, new $c_Lamf_core_parser_Annotations().init___());
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(res$3, field$5, value$5)
    };
    new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(res$3, this.map$1, $m_sci_Nil$(), this.ctx$1).parse__V();
    return res$3
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser)) {
    var OasResponseParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser(x$1);
    var this$1 = this.map$1;
    var b = OasResponseParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.adopted$1;
      var x$2 = OasResponseParser$1.adopted$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.adopted$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser.prototype.init___Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(map, adopted, ctx) {
  this.map$1 = map;
  this.adopted$1 = adopted;
  this.ctx$1 = ctx;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasResponseParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasResponseParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasResponseParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter$$anonfun$collect$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter$$anonfun$collect$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter$$anonfun$collect$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter$$anonfun$collect$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter$$anonfun$collect$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter$$anonfun$collect$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter$$anonfun$collect$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter$$anonfun$collect$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter$$anonfun$collect$2.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter$$anonfun$collect$2.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter$$anonfun$collect$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter$$anonfun$collect$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter$$anonfun$collect$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter$$anonfun$collect$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasWithExtensionsSecurityRequirementsEmitter$$anonfun$collect$2", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter$$anonfun$collect$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter$$anonfun$collect$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter$$anonfun$collect$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1$$anonfun$$nestedInanonfun$emit$14$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1$$anonfun$$nestedInanonfun$emit$14$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1$$anonfun$$nestedInanonfun$emit$14$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1$$anonfun$$nestedInanonfun$emit$14$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1$$anonfun$$nestedInanonfun$emit$14$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1$$anonfun$$nestedInanonfun$emit$14$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1$$anonfun$$nestedInanonfun$emit$14$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1$$anonfun$$nestedInanonfun$emit$14$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1 = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1$$anonfun$$nestedInanonfun$emit$14$1.prototype.applyOrElse__Lamf_core_emitter_Emitter__F1__O = (function(x1, $default) {
  if ($is_Lamf_core_emitter_EntryEmitter(x1)) {
    var x2 = $as_Lamf_core_emitter_EntryEmitter(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1$$anonfun$$nestedInanonfun$emit$14$1.prototype.isDefinedAt__Lamf_core_emitter_Emitter__Z = (function(x1) {
  return $is_Lamf_core_emitter_EntryEmitter(x1)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1$$anonfun$$nestedInanonfun$emit$14$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_emitter_Emitter__Z($as_Lamf_core_emitter_Emitter(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1$$anonfun$$nestedInanonfun$emit$14$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_emitter_Emitter__F1__O($as_Lamf_core_emitter_Emitter(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1$$anonfun$$nestedInanonfun$emit$14$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1$$anonfun$$nestedInanonfun$emit$14$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml08PayloadEmitter$$anon$1$$anonfun$$nestedInanonfun$emit$14$1", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1$$anonfun$$nestedInanonfun$emit$14$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1$$anonfun$$nestedInanonfun$emit$14$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter$$anon$1$$anonfun$$nestedInanonfun$emit$14$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser.call(this);
  this.entry$2 = null;
  this.producer$2 = null;
  this.parseOptional$2 = false;
  this.ctx$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(entry, producer, parseOptional, ctx) {
  this.entry$2 = entry;
  this.producer$2 = producer;
  this.parseOptional$2 = parseOptional;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, entry, producer, parseOptional, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser.prototype.productPrefix__T = (function() {
  return "Raml08PayloadParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser)) {
    var Raml08PayloadParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser(x$1);
    var x = this.entry$2;
    var x$2 = Raml08PayloadParser$1.entry$2;
    if ((x === x$2)) {
      var x$3 = this.producer$2;
      var x$4 = Raml08PayloadParser$1.producer$2;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.parseOptional$2 === Raml08PayloadParser$1.parseOptional$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$2;
      break
    }
    case 1: {
      return this.producer$2;
      break
    }
    case 2: {
      return this.parseOptional$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.entry$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.producer$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.parseOptional$2 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 3)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser.prototype.parse__Lamf_plugins_domain_webapi_models_Payload = (function() {
  var payload = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser.prototype.parse__Lamf_plugins_domain_webapi_models_Payload.call(this);
  var this$1 = $as_Lamf_core_model_StrField(payload.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1));
  var this$2 = this$1.option$1;
  var mediaType = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  if ($m_sjsr_RuntimeString$().endsWith__T__T__Z(mediaType, "?")) {
    var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Optional$1;
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(payload, field, true);
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1;
    var this$4 = new $c_sci_StringOps().init___T(mediaType);
    var value = $f_sci_StringLike__stripSuffix__T__T(this$4, "?");
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(payload, field$1, value)
  };
  var this$5 = this.entry$2.value$2;
  var x1 = this$5.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Null$1;
  if ((x === x1)) {
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var fields = new $c_Lamf_core_parser_Fields().init___();
    var shape = new $c_Lamf_plugins_domain_shapes_models_AnyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
    $m_Lamf_core_parser_Annotations$();
    var a = new $c_Lamf_core_parser_Annotations().init___();
    var qual$1 = $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, "schema", a));
    var x$1 = payload.id$1;
    var x$2$2 = qual$1.adopted$default$2__sc_Seq();
    var anyShape = $as_Lamf_plugins_domain_shapes_models_AnyShape(qual$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$1, x$2$2));
    anyShape.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SynthesizedField().init___());
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
    $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(payload, field$2, anyShape))
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x$3 === x1)) {
      $m_sci_List$();
      var array = ["application/x-www-form-urlencoded", "multipart/form-data"];
      var i = (((-1) + $uI(array.length)) | 0);
      var result = $m_sci_Nil$();
      while ((i >= 0)) {
        var this$14 = result;
        var index = i;
        var x$2 = array[index];
        result = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$14);
        i = (((-1) + i) | 0)
      };
      var this$15 = result;
      if ($f_sc_LinearSeqOptimized__contains__O__Z(this$15, mediaType)) {
        var this$16 = this.entry$2.value$2;
        var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv = this.ctx$2;
        var this$17 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08WebFormParser().init___Lorg_yaml_model_YMap__T__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$16, conversion, iv)), payload.id$1, this.ctx$2).parse__s_Option();
        if ((!this$17.isEmpty__Z())) {
          var arg1 = this$17.get__O();
          var schema = $as_Lamf_core_model_domain_Shape(arg1);
          var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
          $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(payload, field$3, schema))
        }
      } else {
        var this$18 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser(this.entry$2, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, payload$1) {
          return (function(shape$2$2) {
            var shape$2 = $as_Lamf_core_model_domain_Shape(shape$2$2);
            shape$2.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(payload$1.id$1, shape$2.adopted$default$2__sc_Seq())
          })
        })(this, payload)), false, $m_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$(), this.ctx$2).parse__s_Option();
        if ((!this$18.isEmpty__Z())) {
          var arg1$1 = this$18.get__O();
          var s = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1$1);
          var schema$1 = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(s, payload.id$1, $m_s_None$());
          var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
          $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(payload, field$4, schema$1))
        }
      }
    } else {
      var this$20 = this.ctx$2;
      var violationId = $m_Lamf_validations_ParserSideValidations$().InvalidPayload$1;
      var node = payload.id$1;
      var this$21 = this$20.eh$1;
      var location = this$20.rootContextDocument$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__T__V(this$21, violationId, node, "Invalid payload. Payload must be a map or null", location)
    }
  };
  return payload
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml08PayloadParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml08PayloadParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml08PayloadParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$$nestedInanonfun$emit$11$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$$nestedInanonfun$emit$11$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$$nestedInanonfun$emit$11$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$$nestedInanonfun$emit$11$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$$nestedInanonfun$emit$11$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$$nestedInanonfun$emit$11$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$$nestedInanonfun$emit$11$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$$nestedInanonfun$emit$11$1.prototype.applyOrElse__Lamf_core_emitter_Emitter__F1__O = (function(x2, $default) {
  if ($is_Lamf_core_emitter_EntryEmitter(x2)) {
    var x2$2 = $as_Lamf_core_emitter_EntryEmitter(x2);
    return x2$2
  } else {
    return $default.apply__O__O(x2)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$$nestedInanonfun$emit$11$1.prototype.isDefinedAt__Lamf_core_emitter_Emitter__Z = (function(x2) {
  return $is_Lamf_core_emitter_EntryEmitter(x2)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$$nestedInanonfun$emit$11$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_emitter_Emitter__Z($as_Lamf_core_emitter_Emitter(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$$nestedInanonfun$emit$11$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_emitter_Emitter__F1__O($as_Lamf_core_emitter_Emitter(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$$nestedInanonfun$emit$11$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter = (function($$outer) {
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$$nestedInanonfun$emit$11$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$$nestedInanonfun$emit$11$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml08PayloadsEmitter$$anonfun$$nestedInanonfun$emit$11$1", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$$nestedInanonfun$emit$11$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$$nestedInanonfun$emit$11$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$$nestedInanonfun$emit$11$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_Payload)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Payload)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_Payload(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter = (function($$outer) {
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml08PayloadsEmitter$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser.call(this);
  this.entry$2 = null;
  this.producer$2 = null;
  this.parseOptional$2 = false;
  this.ctx$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(entry, producer, parseOptional, ctx) {
  this.entry$2 = entry;
  this.producer$2 = producer;
  this.parseOptional$2 = parseOptional;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, entry, producer, parseOptional, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser.prototype.productPrefix__T = (function() {
  return "Raml10PayloadParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser)) {
    var Raml10PayloadParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser(x$1);
    var x = this.entry$2;
    var x$2 = Raml10PayloadParser$1.entry$2;
    if ((x === x$2)) {
      var x$3 = this.producer$2;
      var x$4 = Raml10PayloadParser$1.producer$2;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.parseOptional$2 === Raml10PayloadParser$1.parseOptional$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$2;
      break
    }
    case 1: {
      return this.producer$2;
      break
    }
    case 2: {
      return this.parseOptional$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.entry$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.producer$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.parseOptional$2 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 3)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser.prototype.parse__Lamf_plugins_domain_webapi_models_Payload = (function() {
  var payload = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser.prototype.parse__Lamf_plugins_domain_webapi_models_Payload.call(this);
  var this$1 = this.entry$2.value$2;
  var x1 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((!(x === x1))) {
    var this$2 = this.entry$2.value$2;
    var evidence$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var x1$2 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$2, evidence$2);
    if ((x1$2 instanceof $c_s_util_Right)) {
      var x2 = $as_s_util_Right(x1$2);
      var map = $as_Lorg_yaml_model_YMap(x2.value$2);
      new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(payload, map, $m_sci_Nil$(), this.ctx$2).parse__V()
    }
  };
  var this$4 = this.entry$2.value$2;
  var x1$3 = this$4.tag__Lorg_yaml_model_YTag().tagType$3;
  var x$4 = $m_Lorg_yaml_model_YType$().Null$1;
  if ((x$4 === x1$3)) {
    var this$6 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(this.entry$2, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, payload$1) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        $m_Lamf_core_parser_Annotations$();
        var a = new $c_Lamf_core_parser_Annotations().init___();
        var qual$1 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, "schema", a));
        var x$1 = payload$1.id$1;
        var x$2 = qual$1.adopted$default$2__sc_Seq();
        qual$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$1, x$2)
      })
    })(this, payload)), new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo().init___Z__Z(false, false), $m_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$(), this.ctx$2).parse__s_Option();
    if ((!this$6.isEmpty__Z())) {
      var arg1 = this$6.get__O();
      var schema = $as_Lamf_core_model_domain_Shape(arg1);
      schema.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SynthesizedField().init___());
      $m_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$().ramlAutoGeneratedAnnotation__Lamf_core_model_domain_Shape__V(schema);
      var schema$1 = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(schema, payload.id$1, $m_s_None$());
      var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
      $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(payload, field, schema$1))
    }
  } else {
    var this$10 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(this.entry$2, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, payload$2) {
      return (function(shape$3$2) {
        var shape$3 = $as_Lamf_core_model_domain_Shape(shape$3$2);
        $m_Lamf_core_parser_Annotations$();
        var a$1 = new $c_Lamf_core_parser_Annotations().init___();
        var qual$2 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape$3, "schema", a$1));
        var x$3$1 = payload$2.id$1;
        var x$4$1 = qual$2.adopted$default$2__sc_Seq();
        qual$2.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$3$1, x$4$1)
      })
    })(this, payload)), new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo().init___Z__Z(false, false), $m_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$(), this.ctx$2).parse__s_Option();
    if ((!this$10.isEmpty__Z())) {
      var arg1$1 = this$10.get__O();
      var s = $as_Lamf_core_model_domain_Shape(arg1$1);
      $m_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$().ramlAutoGeneratedAnnotation__Lamf_core_model_domain_Shape__V(s);
      var schema$2 = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(s, payload.id$1, $m_s_None$());
      var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
      $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(payload, field$1, schema$2))
    }
  };
  return payload
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml10PayloadParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml10PayloadParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml10PayloadParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter$$anonfun$$nestedInanonfun$emit$26$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter$$anonfun$$nestedInanonfun$emit$26$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter$$anonfun$$nestedInanonfun$emit$26$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter$$anonfun$$nestedInanonfun$emit$26$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter$$anonfun$$nestedInanonfun$emit$26$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter$$anonfun$$nestedInanonfun$emit$26$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter$$anonfun$$nestedInanonfun$emit$26$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter$$anonfun$$nestedInanonfun$emit$26$1.prototype.applyOrElse__Lamf_core_emitter_Emitter__F1__O = (function(x1, $default) {
  if ($is_Lamf_core_emitter_EntryEmitter(x1)) {
    var x2 = $as_Lamf_core_emitter_EntryEmitter(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter$$anonfun$$nestedInanonfun$emit$26$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter$$anonfun$$nestedInanonfun$emit$26$1.prototype.isDefinedAt__Lamf_core_emitter_Emitter__Z = (function(x1) {
  return $is_Lamf_core_emitter_EntryEmitter(x1)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter$$anonfun$$nestedInanonfun$emit$26$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_emitter_Emitter__Z($as_Lamf_core_emitter_Emitter(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter$$anonfun$$nestedInanonfun$emit$26$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_emitter_Emitter__F1__O($as_Lamf_core_emitter_Emitter(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter$$anonfun$$nestedInanonfun$emit$26$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter$$anonfun$$nestedInanonfun$emit$26$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml10PayloadsEmitter$$anonfun$$nestedInanonfun$emit$26$1", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter$$anonfun$$nestedInanonfun$emit$26$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter$$anonfun$$nestedInanonfun$emit$26$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter$$anonfun$$nestedInanonfun$emit$26$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser$$anonfun$1.prototype.isDefinedAt__Lorg_yaml_model_YMapEntry__Z = (function(x1) {
  var this$1 = x1.value$2;
  var x = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x$2 = $m_Lorg_yaml_model_YType$().Map$1;
  return (x === x$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser$$anonfun$1.prototype.applyOrElse__Lorg_yaml_model_YMapEntry__F1__O = (function(x1, $default) {
  var this$1 = x1.value$2;
  var x = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x$2 = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x$2)) {
    return x1
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lorg_yaml_model_YMapEntry__Z($as_Lorg_yaml_model_YMapEntry(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lorg_yaml_model_YMapEntry__F1__O($as_Lorg_yaml_model_YMapEntry(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser = (function($$outer) {
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlEndpointParser$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser() {
  $c_O.call(this);
  this.entry$1 = null;
  this.producer$1 = null;
  this.parseOptional$1 = false;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(entry, producer, parseOptional, ctx) {
  this.entry$1 = entry;
  this.producer$1 = producer;
  this.parseOptional$1 = parseOptional;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser.prototype.productPrefix__T = (function() {
  return "RamlOperationParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser)) {
    var RamlOperationParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser(x$1);
    var x = this.entry$1;
    var x$2 = RamlOperationParser$1.entry$1;
    if ((x === x$2)) {
      var x$3 = this.producer$1;
      var x$4 = RamlOperationParser$1.producer$1;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.parseOptional$1 === RamlOperationParser$1.parseOptional$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$1;
      break
    }
    case 1: {
      return this.producer$1;
      break
    }
    case 2: {
      return this.parseOptional$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser.prototype.parse__Lamf_plugins_domain_webapi_models_Operation = (function() {
  var this$1 = this.entry$1.key$2;
  var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
  var iv = this.ctx$1;
  var method = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3;
  var this$2 = $as_Lamf_core_model_domain_AmfElement(this.producer$1.apply__O__O(method));
  var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1);
  var operation = $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$2, other));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Method$1;
  var node = this.entry$1.key$2;
  var iv$1 = this.ctx$1;
  var this$4 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv$1);
  var value = this$4.string__Lamf_core_model_domain_AmfScalar();
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(operation, field, value);
  if ((this.parseOptional$1 && $m_sjsr_RuntimeString$().endsWith__T__T__Z(method, "?"))) {
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Optional$1;
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(operation, field$1, true);
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Method$1;
    var this$6 = new $c_sci_StringOps().init___T(method);
    var value$1 = $f_sci_StringLike__stripSuffix__T__T(this$6, "?");
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(operation, field$2, value$1)
  };
  var this$7 = this.entry$1.value$2;
  var x1 = this$7.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var this$8 = this.entry$1.value$2;
    var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$2 = this.ctx$1;
    return this.parseMap__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Operation__Lamf_plugins_domain_webapi_models_Operation($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$8, conversion$1, iv$2)), operation)
  } else {
    var node$1 = this.entry$1.value$2;
    var this$10 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node$1).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lamf_core_parser_package$YScalarYRead$());
    if (this$10.isEmpty__Z()) {
      var this$11 = $m_s_None$()
    } else {
      var arg1 = this$10.get__O();
      var x$1 = $as_Lorg_yaml_model_YScalar(arg1);
      var this$11 = new $c_s_Some().init___O(x$1.text$3)
    };
    if ((!this$11.isEmpty__Z())) {
      var arg1$1 = this$11.get__O();
      var s = $as_T(arg1$1);
      var jsx$1 = ((s === "") || (s === "null"))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return operation
    } else {
      var this$12 = this.ctx$1.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidOperationType$1;
      var node$2 = operation.id$1;
      var message = ((("Invalid node " + this.entry$1.value$2) + " for method ") + method);
      var ast = this.entry$1.value$2;
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$12, specification, node$2, prop, message, l);
      return operation
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.entry$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.producer$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.parseOptional$1 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 3)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser.prototype.parseMap__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Operation__Lamf_plugins_domain_webapi_models_Operation = (function(map, operation) {
  var this$1 = this.entry$1.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$1;
  var map$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var x = this.ctx$1.contextType$3;
  var x$2 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().TRAIT$2;
  var isTrait = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2));
  this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(operation.id$1, map$2, (isTrait ? "trait" : "operation"));
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Name$1;
  var iv$1 = this.ctx$1;
  jsx$1.key__T__F1__V("displayName", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(operation));
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var jsx$2 = new $c_Lamf_core_utils_package$AmfStrings().init___T("oasDeprecated").asRamlAnnotation__T();
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Deprecated$1;
  var iv$2 = this.ctx$1;
  jsx$3.key__T__F1__V(jsx$2, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(operation));
  var jsx$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var jsx$4 = new $c_Lamf_core_utils_package$AmfStrings().init___T("summary").asRamlAnnotation__T();
  var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Summary$1;
  var iv$3 = this.ctx$1;
  jsx$5.key__T__F1__V(jsx$4, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(operation));
  var jsx$7 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var jsx$6 = new $c_Lamf_core_utils_package$AmfStrings().init___T("externalDocs").asRamlAnnotation__T();
  var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Documentation$1;
  var iv$4 = this.ctx$1;
  jsx$7.key__T__F1__V(jsx$6, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$3, iv$4).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(operation).using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, operation$1) {
    return (function(x$2$2$2) {
      var x$2$2 = $as_Lorg_yaml_model_YNode(x$2$2$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser$().parse__Lorg_yaml_model_YNode__T__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_domain_shapes_models_CreativeWork(x$2$2, operation$1.id$1, $this.ctx$1)
    })
  })(this, operation))));
  var jsx$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Schemes$1;
  var iv$5 = this.ctx$1;
  jsx$8.key__T__F1__V("protocols", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$4, iv$5).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(operation).allowingSingleValue__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var jsx$10 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var jsx$9 = new $c_Lamf_core_utils_package$AmfStrings().init___T("consumes").asRamlAnnotation__T();
  var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Accepts$1;
  var iv$6 = this.ctx$1;
  jsx$10.key__T__F1__V(jsx$9, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$5, iv$6).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(operation));
  var jsx$12 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var jsx$11 = new $c_Lamf_core_utils_package$AmfStrings().init___T("produces").asRamlAnnotation__T();
  var field$6 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().ContentType$1;
  var iv$7 = this.ctx$1;
  jsx$12.key__T__F1__V(jsx$11, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$6, iv$7).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(operation));
  var this$16 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("tags").asRamlAnnotation__T();
  var this$17 = this$16.key__T__s_Option(keyword);
  if ((!this$17.isEmpty__Z())) {
    var arg1 = this$17.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$18 = entry.value$2;
    var conversion$1 = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
    var iv$8 = this.ctx$1;
    var tags = new $c_Lamf_plugins_document_webapi_parser_spec_domain_StringTagsParser().init___Lorg_yaml_model_YSequence__T__Lamf_plugins_document_webapi_contexts_WebApiContext($as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$18, conversion$1, iv$8)), operation.id$1, this.ctx$1).parse__sc_Seq();
    var field$7 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Tags$1;
    $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(operation, field$7, tags))
  };
  var eta$0$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, operation$2) {
    return (function(name$2) {
      var name = $as_T(name$2);
      return $f_Lamf_plugins_domain_webapi_models_ExtensibleWebApiDomainElement__withTrait__T__Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait(operation$2, name)
    })
  })(this, operation));
  var DeclarationParser = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, eta$0$1$1) {
    return (function(node$2) {
      var node = $as_Lorg_yaml_model_YNode(node$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedDeclarationParser$().parse__F1__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_core_model_domain_templates_ParametrizedDeclaration(eta$0$1$1, node, this$4$1.ctx$1)
    })
  })(this, eta$0$1));
  var this$20 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var this$21 = this$20.key__T__s_Option("is");
  if ((!this$21.isEmpty__Z())) {
    var arg1$1 = this$21.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var jsx$14 = operation.annotations$1;
    var jsx$13 = $m_Lamf_core_parser_Range$();
    var this$22 = e.location$1;
    jsx$14.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_OperationTraitEntry().init___Lamf_core_parser_Range(jsx$13.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$22.lineFrom$1, this$22.columnFrom$1, this$22.lineTo$1, this$22.columnTo$1))));
    var field$8 = $m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field();
    var iv$9 = this.ctx$1;
    new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$8, iv$9).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(operation).using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(DeclarationParser).allowingSingleValue__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField().optional__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField().apply__Lorg_yaml_model_YMapEntry__V(e)
  };
  var this$23 = $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser(this.ctx$1.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().requestParser__F3().apply__O__O__O__O(map$2, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$6$1, operation$3) {
    return (function() {
      return operation$3.withRequest__Lamf_plugins_domain_webapi_models_Request()
    })
  })(this, operation)), this.parseOptional$1)).parse__s_Option();
  if ((!this$23.isEmpty__Z())) {
    var arg1$2 = this$23.get__O();
    var req = $as_Lamf_plugins_domain_webapi_models_Request(arg1$2);
    var field$9 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Request$1;
    $m_sci_List$();
    var array = [req];
    var i = (((-1) + $uI(array.length)) | 0);
    var result = $m_sci_Nil$();
    while ((i >= 0)) {
      var this$27 = result;
      var index = i;
      var x$1 = array[index];
      result = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$27);
      i = (((-1) + i) | 0)
    };
    var values = result;
    var annotations = ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SynthesizedField().init___());
    $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(operation, field$9, values, annotations))
  };
  var this$31 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var keyword$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T("defaultResponse").asRamlAnnotation__T();
  var this$32 = this$31.key__T__s_Option(keyword$1);
  if ((!this$32.isEmpty__Z())) {
    var arg1$3 = this$32.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
    var this$33 = entry$3.value$2;
    var x$3 = this$33.tag__Lorg_yaml_model_YTag().tagType$3;
    var x$2$1 = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x$3 === x$2$1)) {
      var responses = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      var this$34 = entry$3.value$2;
      var conversion$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv$10 = this.ctx$1;
      $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$34, conversion$2, iv$10)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, responses$1, operation$1$1) {
        return (function(entry$2$2) {
          var entry$2 = $as_Lorg_yaml_model_YMapEntry(entry$2$2);
          return responses$1.$$plus$eq__O__scm_ListBuffer($as_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser($this$1.ctx$1.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().responseParser__F3().apply__O__O__O__O(entry$2, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, operation$1$2) {
            return (function(r$2) {
              var r = $as_Lamf_plugins_domain_webapi_models_Response(r$2);
              var parent = operation$1$2.id$1;
              $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
              $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(r, parent)
            })
          })($this$1, operation$1$1)), $this$1.parseOptional$1)).parse__Lamf_plugins_domain_webapi_models_Response())
        })
      })(this, responses, operation)));
      var field$10 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1;
      $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(operation, field$10, responses))
    }
  };
  var this$36 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var this$37 = this$36.key__T__s_Option("responses");
  if ((!this$37.isEmpty__Z())) {
    var arg1$4 = this$37.get__O();
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$4);
    var responses$2 = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var this$38 = entry$4.value$2;
    var x1 = this$38.tag__Lorg_yaml_model_YTag().tagType$3;
    var x$4 = $m_Lorg_yaml_model_YType$().Null$1;
    if ((!(x$4 === x1))) {
      var this$39 = entry$4.value$2;
      var conversion$3 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv$11 = this.ctx$1;
      var entries = $as_sc_IndexedSeq($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$39, conversion$3, iv$11)).entries$3.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3) {
        return (function(y$2) {
          var y = $as_Lorg_yaml_model_YMapEntry(y$2);
          var jsx$15 = $m_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$();
          var this$40 = y.key$2;
          var conversion$4 = $m_Lamf_core_parser_package$YScalarYRead$();
          var iv$12 = $this$3.ctx$1;
          return (!jsx$15.isRamlAnnotation__T__Z($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$40, conversion$4, iv$12)).text$3))
        })
      })(this))));
      entries.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, responses$3, operation$1$3) {
        return (function(entry$2$2$1) {
          var entry$2$1 = $as_Lorg_yaml_model_YMapEntry(entry$2$2$1);
          return responses$3.$$plus$eq__O__scm_ListBuffer($as_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser(this$2$1.ctx$1.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().responseParser__F3().apply__O__O__O__O(entry$2$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$4, operation$1$4) {
            return (function(x$3$2) {
              var x$3$1 = $as_Lamf_plugins_domain_webapi_models_Response(x$3$2);
              var parent$1 = operation$1$4.id$1;
              $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
              $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(x$3$1, parent$1)
            })
          })(this$2$1, operation$1$3)), this$2$1.parseOptional$1)).parse__Lamf_plugins_domain_webapi_models_Response())
        })
      })(this, responses$2, operation)))
    };
    var defaultResponses = $as_sc_Seq(operation.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1));
    var field$11 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1;
    var this$41 = new $c_scm_ListBuffer().init___().$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(responses$2);
    var xs = defaultResponses.seq__sc_TraversableOnce();
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(this$41.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(xs), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4.value$2));
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(operation, field$11, value, annotations$1)
  };
  var this$44 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var keyword$2 = new $c_Lamf_core_utils_package$AmfStrings().init___T("callbacks").asRamlAnnotation__T();
  var this$45 = this$44.key__T__s_Option(keyword$2);
  if ((!this$45.isEmpty__Z())) {
    var arg1$5 = this$45.get__O();
    var entry$5 = $as_Lorg_yaml_model_YMapEntry(arg1$5);
    var this$46 = entry$5.value$2;
    var conversion$5 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$13 = this.ctx$1;
    var jsx$17 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$46, conversion$5, iv$13)).entries$3;
    var jsx$16 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$5, operation$1$5) {
      return (function(callbackEntry$2) {
        var callbackEntry = $as_Lorg_yaml_model_YMapEntry(callbackEntry$2);
        var this$47 = callbackEntry.key$2;
        var conversion$6 = $m_Lamf_core_parser_package$YScalarYRead$();
        var iv$14 = $this$5.ctx$1;
        var name$1 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$47, conversion$6, iv$14)).text$3;
        var this$48 = callbackEntry.value$2;
        var conversion$7 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv$15 = $this$5.ctx$1;
        return new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser().init___Lorg_yaml_model_YMap__F1__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$48, conversion$7, iv$15)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$6, name$3, operation$1$6) {
          return (function(x$4$2) {
            var x$4$1 = $as_Lamf_plugins_domain_webapi_models_Callback(x$4$2);
            $m_Lamf_core_parser_Annotations$();
            var a = new $c_Lamf_core_parser_Annotations().init___();
            var qual$1 = $as_Lamf_plugins_domain_webapi_models_Callback($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(x$4$1, name$3, a));
            var x$1$1 = operation$1$6.id$1;
            $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
            $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1$1)
          })
        })($this$5, name$1, operation$1$5)), name$1, callbackEntry, $m_Lamf_plugins_document_webapi_parser_spec_package$().toOas__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($this$5.ctx$1)).parse__sci_List()
      })
    })(this, operation));
    var this$50 = $m_sc_IndexedSeq$();
    var callbacks = $as_sc_IndexedSeq(jsx$17.flatMap__F1__scg_CanBuildFrom__O(jsx$16, this$50.ReusableCBF$6));
    var field$12 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Callbacks$1;
    $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(operation, field$12, callbacks))
  };
  var idCounter = new $c_Lamf_core_utils_package$IdCounter().init___();
  var eta$0$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$11$1, operation$4) {
    return (function(name$3$2) {
      var name$3$1 = $as_T(name$3$2);
      return operation$4.withSecurity__T__Lamf_plugins_domain_webapi_models_security_SecurityRequirement(name$3$1)
    })
  })(this, operation));
  var RequirementParser = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$12$1, eta$0$2$1, idCounter$1) {
    return (function(node$3$2) {
      var node$3 = $as_Lorg_yaml_model_YNode(node$3$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$().parse__F1__Lamf_core_utils_package$IdCounter__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_domain_webapi_models_security_SecurityRequirement(eta$0$2$1, idCounter$1, node$3, this$12$1.ctx$1)
    })
  })(this, eta$0$2, idCounter));
  var jsx$18 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var field$13 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Security$1;
  var iv$16 = this.ctx$1;
  jsx$18.key__T__F1__V("securedBy", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$13, iv$16).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(operation).using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(RequirementParser).allowingSingleValue__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var jsx$19 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var field$14 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Description$1;
  var iv$17 = this.ctx$1;
  jsx$19.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$14, iv$17).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(operation).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  if (isTrait) {
    $m_sci_List$();
    var array$1 = [$m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().trait$1];
    var i$1 = (((-1) + $uI(array$1.length)) | 0);
    var result$1 = $m_sci_Nil$();
    while ((i$1 >= 0)) {
      var this$56 = result$1;
      var index$1 = i$1;
      var x$5 = array$1[index$1];
      result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$5, this$56);
      i$1 = (((-1) + i$1) | 0)
    };
    var jsx$20 = result$1
  } else {
    $m_sci_List$();
    var array$2 = [$m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().operation$1];
    var i$2 = (((-1) + $uI(array$2.length)) | 0);
    var result$2 = $m_sci_Nil$();
    while ((i$2 >= 0)) {
      var this$60 = result$2;
      var index$2 = i$2;
      var x$6 = array$2[index$2];
      result$2 = new $c_sci_$colon$colon().init___O__sci_List(x$6, this$60);
      i$2 = (((-1) + i$2) | 0)
    };
    var jsx$20 = result$2
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(operation, map$2, jsx$20, this.ctx$1).parse__V();
  return operation
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlOperationParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlOperationParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlOperationParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.type$1 = null;
  this.scheme$1 = null;
  this.ctx$1 = null;
  this.apiKeyConst$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser.prototype.productPrefix__T = (function() {
  return "RamlSecuritySettingsParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser.prototype.apiKey__p1__Lamf_plugins_domain_webapi_models_security_Settings = (function() {
  var settings = $as_Lamf_plugins_domain_webapi_models_security_WithSettings(this.scheme$1).withApiKeySettings__Lamf_plugins_domain_webapi_models_security_ApiKeySettings();
  var map = this.map$1;
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().Name$1;
  var iv = this.ctx$1;
  jsx$1.key__T__F1__V("name", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(settings));
  var map$1 = this.map$1;
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().In$1;
  var iv$1 = this.ctx$1;
  jsx$2.key__T__F1__V("in", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(settings));
  var array = ["name", "in"];
  return this.dynamicSettings__Lamf_plugins_domain_webapi_models_security_Settings__sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings(settings, new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser.prototype.isValidScope__p1__s_Option__T__Z = (function(maybeFlow, scope) {
  if ((!maybeFlow.isEmpty__Z())) {
    var arg1 = maybeFlow.get__O();
    var flow = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow(arg1);
    if ($as_sc_Seq(flow.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Scopes$1)).isEmpty__Z()) {
      return true
    } else {
      var jsx$2 = $as_sc_Seq(flow.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Scopes$1));
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x$2$2) {
          var x$2 = $as_Lamf_plugins_domain_webapi_models_security_Scope(x$2$2);
          var this$1 = $as_Lamf_core_model_StrField(x$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Name$1));
          var this$2 = this$1.option$1;
          return $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()))
        })
      })(this));
      var this$3 = $m_sc_Seq$();
      return $as_sc_SeqLike(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2)).contains__O__Z(scope)
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser)) {
    var RamlSecuritySettingsParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser(x$1);
    var this$1 = this.map$1;
    var b = RamlSecuritySettingsParser$1.map$1;
    if (($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b) && (this.type$1 === RamlSecuritySettingsParser$1.type$1))) {
      var x = this.scheme$1;
      var x$2 = RamlSecuritySettingsParser$1.scheme$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser.prototype.dynamicSettings__Lamf_plugins_domain_webapi_models_security_Settings__sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings = (function(settings, properties) {
  var entries = $as_sc_IndexedSeq(this.map$1.entries$3.filterNot__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, properties$1) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var this$1 = entry.key$2;
      var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv = $this.ctx$1;
      var key = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3;
      return (properties$1.contains__O__Z(key) || $m_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$().isRamlAnnotation__T__Z(key))
    })
  })(this, properties))));
  if ($f_sc_TraversableOnce__nonEmpty__Z(entries)) {
    $m_Lorg_yaml_model_YNode$();
    var jsx$1 = $m_Lorg_yaml_model_YMap$();
    var this$2 = entries.headOption__s_Option();
    if (this$2.isEmpty__Z()) {
      var this$3 = $m_s_None$()
    } else {
      var arg1 = this$2.get__O();
      var x$1 = $as_Lorg_yaml_model_YMapEntry(arg1);
      var this$3 = new $c_s_Some().init___O(x$1.location$1.sourceName$1)
    };
    var map = jsx$1.apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(entries, $as_T((this$3.isEmpty__Z() ? "" : this$3.get__O())));
    var x$1$3 = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1);
    var x$2 = new $c_s_Some().init___O(settings.id$1);
    var x$3 = new $c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables().init___();
    var node = $m_Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_common_DataNodeParser(x$1$3, x$3, x$2, this.ctx$1).parse__Lamf_core_model_domain_DataNode();
    var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().AdditionalProperties$1;
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(settings, field, node)
  };
  return settings
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.type$1;
      break
    }
    case 2: {
      return this.scheme$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser.prototype.parse__Lamf_plugins_domain_webapi_models_security_Settings = (function() {
  var x1 = this.type$1;
  if ((x1 === "OAuth 1.0")) {
    var result = this.oauth1__p1__Lamf_plugins_domain_webapi_models_security_Settings()
  } else if ((x1 === "OAuth 2.0")) {
    var result = this.oauth2__p1__Lamf_plugins_domain_webapi_models_security_Settings()
  } else if ((this.apiKeyConst$1 === x1)) {
    var result = this.apiKey__p1__Lamf_plugins_domain_webapi_models_security_Settings()
  } else {
    var jsx$1 = $as_Lamf_plugins_domain_webapi_models_security_WithSettings(this.scheme$1).withDefaultSettings__Lamf_plugins_domain_webapi_models_security_Settings();
    var array = [];
    var result = this.dynamicSettings__Lamf_plugins_domain_webapi_models_security_Settings__sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings(jsx$1, new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))
  };
  var jsx$2 = this.map$1;
  $m_sci_List$();
  var array$1 = [$m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().securitySettings$1];
  var i = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result$1;
    var index = i;
    var x = array$1[index];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(result, jsx$2, result$1, this.ctx$1).parse__V();
  var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.map$1);
  return $as_Lamf_plugins_domain_webapi_models_security_Settings($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(result, other))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser.prototype.oauth1__p1__Lamf_plugins_domain_webapi_models_security_Settings = (function() {
  var settings = $as_Lamf_plugins_domain_webapi_models_security_WithSettings(this.scheme$1).withOAuth1Settings__Lamf_plugins_domain_webapi_models_security_OAuth1Settings();
  var map = this.map$1;
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$().RequestTokenUri$1;
  var iv = this.ctx$1;
  jsx$1.key__T__F1__V("requestTokenUri", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(settings).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var map$1 = this.map$1;
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$().AuthorizationUri$1;
  var iv$1 = this.ctx$1;
  jsx$2.key__T__F1__V("authorizationUri", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(settings).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var map$2 = this.map$1;
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$().TokenCredentialsUri$1;
  var iv$2 = this.ctx$1;
  jsx$3.key__T__F1__V("tokenCredentialsUri", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(settings).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var map$3 = this.map$1;
  var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3);
  var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$().Signatures$1;
  var iv$3 = this.ctx$1;
  jsx$4.key__T__F1__V("signatures", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$3, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(settings));
  var array = ["requestTokenUri", "authorizationUri", "tokenCredentialsUri", "signatures"];
  return this.dynamicSettings__Lamf_plugins_domain_webapi_models_security_Settings__sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings(settings, new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser.prototype.oauth2__p1__Lamf_plugins_domain_webapi_models_security_Settings = (function() {
  var settings = $as_Lamf_plugins_domain_webapi_models_security_WithSettings(this.scheme$1).withOAuth2Settings__Lamf_plugins_domain_webapi_models_security_OAuth2Settings();
  var flow = new $c_Lamf_core_utils_Lazy().init___F0(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, settings$1) {
    return (function() {
      var qual$1 = $m_Lamf_plugins_domain_webapi_models_security_OAuth2Flow$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_security_OAuth2Flow($this.map$1);
      var x$1 = settings$1.id$1;
      $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      return $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1))
    })
  })(this, settings)));
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("authorizationUri");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1;
    var iv = this.ctx$1;
    new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField($as_Lamf_core_model_domain_DomainElement(flow.getOrCreate__O())).apply__Lorg_yaml_model_YMapEntry__V(entry)
  };
  var map$1 = this.map$1;
  var this$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var this$6 = this$5.key__T__s_Option("accessTokenUri");
  if ((!this$6.isEmpty__Z())) {
    var arg1$1 = this$6.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1;
    var iv$1 = this.ctx$1;
    new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField($as_Lamf_core_model_domain_DomainElement(flow.getOrCreate__O())).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField().apply__Lorg_yaml_model_YMapEntry__V(entry$3)
  };
  var map$2 = this.map$1;
  var this$9 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("flow").asRamlAnnotation__T();
  var this$10 = this$9.key__T__s_Option(keyword);
  if ((!this$10.isEmpty__Z())) {
    var arg1$2 = this$10.get__O();
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Flow$1;
    var iv$2 = this.ctx$1;
    new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField($as_Lamf_core_model_domain_DomainElement(flow.getOrCreate__O())).apply__Lorg_yaml_model_YMapEntry__V(entry$4)
  };
  var map$3 = this.map$1;
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3);
  var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().AuthorizationGrants$1;
  var iv$3 = this.ctx$1;
  jsx$1.key__T__F1__V("authorizationGrants", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$3, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(settings).allowingSingleValue__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var ScopeParser = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1, flow$1) {
    return (function(n$2) {
      var n = $as_Lorg_yaml_model_YNode(n$2);
      var iv$4 = this$5$1.ctx$1;
      var this$13 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(n, iv$4);
      var element = this$13.text__Lamf_core_model_domain_AmfScalar();
      var x1 = this$5$1.scheme$1;
      if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme)) {
        var x2 = $as_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme(x1);
        var rc5 = false;
        var x2$2 = null;
        var this$14 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Scheme$1));
        var x1$2 = $as_Lamf_plugins_domain_webapi_models_security_Settings(this$14.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1));
        if ((x1$2 instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings)) {
          rc5 = true;
          x2$2 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(x1$2);
          var this$15 = x2$2;
          if (this$5$1.isValidScope__p1__s_Option__T__Z($as_sc_Seq(this$15.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1)).headOption__s_Option(), element.toString__T())) {
            $m_Lamf_core_parser_Annotations$();
            var annotations = new $c_Lamf_core_parser_Annotations().init___();
            var this$21 = new $c_Lamf_plugins_domain_webapi_models_security_Scope().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
            var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Name$1;
            var iv$5 = this$5$1.ctx$1;
            var this$20 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(n, iv$5);
            var value = this$20.text__Lamf_core_model_domain_AmfScalar();
            var qual$2 = $as_Lamf_plugins_domain_webapi_models_security_Scope($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$21, field$4, value));
            var x$3 = $as_Lamf_core_model_domain_AmfObject(flow$1.getOrCreate__O()).id__T();
            $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
            return $as_Lamf_plugins_domain_webapi_models_security_Scope($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$2, x$3))
          }
        };
        if (rc5) {
          $m_Lamf_core_parser_Annotations$();
          var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
          var qual$3 = new $c_Lamf_plugins_domain_webapi_models_security_Scope().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
          var x$5 = $as_Lamf_core_model_domain_AmfObject(flow$1.getOrCreate__O()).id__T();
          $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
          var scope = $as_Lamf_plugins_domain_webapi_models_security_Scope($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$3, x$5));
          var this$28 = this$5$1.ctx$1.eh$1;
          var specification = $m_Lamf_validations_ParserSideValidations$().UnknownScopeErrorSpecification$1;
          var node = scope.id$1;
          var jsx$2 = element.toString__T();
          var this$25 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Scheme$1));
          var this$26 = $as_Lamf_core_model_StrField(this$25.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Name$1));
          var this$27 = this$26.option$1;
          var message = (((("Scope '" + jsx$2) + "' not found in settings of declared secured by ") + $as_T((this$27.isEmpty__Z() ? null : this$27.get__O()))) + ".");
          var prop = $m_s_None$();
          var l = n.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$28, specification, node, prop, message, l);
          return scope
        };
        $m_Lamf_core_parser_Annotations$();
        var annotations$2 = new $c_Lamf_core_parser_Annotations().init___();
        var this$34 = new $c_Lamf_plugins_domain_webapi_models_security_Scope().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$2);
        var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Name$1;
        var iv$6 = this$5$1.ctx$1;
        var this$33 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(n, iv$6);
        var value$1 = this$33.text__Lamf_core_model_domain_AmfScalar();
        var qual$4 = $as_Lamf_plugins_domain_webapi_models_security_Scope($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$34, field$5, value$1));
        var x$7 = $as_Lamf_core_model_domain_AmfObject(flow$1.getOrCreate__O()).id__T();
        $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        return $as_Lamf_plugins_domain_webapi_models_security_Scope($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$4, x$7))
      } else {
        $m_Lamf_core_parser_Annotations$();
        var annotations$3 = new $c_Lamf_core_parser_Annotations().init___();
        var this$40 = new $c_Lamf_plugins_domain_webapi_models_security_Scope().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$3);
        var field$6 = $m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Name$1;
        var iv$7 = this$5$1.ctx$1;
        var this$39 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(n, iv$7);
        var value$2 = this$39.text__Lamf_core_model_domain_AmfScalar();
        var qual$5 = $as_Lamf_plugins_domain_webapi_models_security_Scope($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$40, field$6, value$2));
        var x$9 = $as_Lamf_core_model_domain_AmfObject(flow$1.getOrCreate__O()).id__T();
        $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        return $as_Lamf_plugins_domain_webapi_models_security_Scope($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$5, x$9))
      }
    })
  })(this, flow));
  var map$4 = this.map$1;
  var this$42 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$4).key__T__s_Option("scopes");
  if ((!this$42.isEmpty__Z())) {
    var arg1$3 = this$42.get__O();
    var entry$5 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
    var field$7 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Scopes$1;
    var iv$8 = this.ctx$1;
    new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$7, iv$8).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField($as_Lamf_core_model_domain_DomainElement(flow.getOrCreate__O())).using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(ScopeParser).allowingSingleValue__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField().apply__Lorg_yaml_model_YMapEntry__V(entry$5)
  };
  var this$43 = flow.value$1;
  if ((!this$43.isEmpty__Z())) {
    var arg1$4 = this$43.get__O();
    var f = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow(arg1$4);
    var field$8 = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1;
    var jsx$3 = $m_sc_Seq$();
    var array = [f];
    var values = $as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
    $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(settings, field$8, values))
  };
  var array$1 = ["authorizationUri", "accessTokenUri", "authorizationGrants", "scopes"];
  return this.dynamicSettings__Lamf_plugins_domain_webapi_models_security_Settings__sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings(settings, new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser.prototype.init___Lorg_yaml_model_YMap__T__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(map, type, scheme, ctx) {
  this.map$1 = map;
  this.type$1 = type;
  this.scheme$1 = scheme;
  this.ctx$1 = ctx;
  this.apiKeyConst$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T("apiKey").asOasExtension__T();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlSecuritySettingsParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlSecuritySettingsParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlSecuritySettingsParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.api$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser.prototype.parseBaseUriParameters__p1__Lamf_plugins_domain_webapi_models_Server__sc_Seq__V = (function(server, orderedVariables) {
  var map = this.map$1;
  var maybeEntry = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("baseUriParameters");
  if ((maybeEntry instanceof $c_s_Some)) {
    var x2 = $as_s_Some(maybeEntry);
    var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    var this$2 = entry.value$2;
    var x1$2 = this$2.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x === x1$2)) {
      var this$3 = entry.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = this.ctx$1;
      var jsx$2 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser().init___Lorg_yaml_model_YMap__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, server$1) {
        return (function(p$2) {
          var p = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2);
          var parent = server$1.id$1;
          $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
          $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(p, parent)
        })
      })(this, server)), false, this.ctx$1).parse__sc_Seq();
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
        return (function(x$2$2$2) {
          var x$2$2 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$2$2$2);
          var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
          return $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x$2$2, field, "path"))
        })
      })(this));
      var this$4 = $m_sc_Seq$();
      var parameters = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2));
      var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, parameters$1, server$2) {
        return (function(v$2) {
          var v = $as_T(v$2);
          var x1 = parameters$1.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, v$1) {
            return (function(x$3$2) {
              var x$3 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$3$2);
              var this$5 = $as_Lamf_core_model_StrField(x$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
              var this$6 = this$5.option$1;
              var this$7 = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
              return (this$7 === v$1)
            })
          })(this$3$1, v)));
          if ((x1 instanceof $c_s_Some)) {
            var x2$1 = $as_s_Some(x1);
            var p$1 = $as_Lamf_plugins_domain_webapi_models_Parameter(x2$1.value$2);
            return p$1
          } else {
            return this$3$1.buildParamFromVar__p1__T__T__Lamf_plugins_domain_webapi_models_Parameter(v, server$2.id$1)
          }
        })
      })(this, parameters, server));
      var this$8 = $m_sc_Seq$();
      var flatten = $as_sc_Seq(orderedVariables.map__F1__scg_CanBuildFrom__O(jsx$3, this$8.ReusableCBFInstance$2));
      var x1$3 = parameters.partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, flatten$1) {
        return (function(x$4$2) {
          var x$4 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$4$2);
          return flatten$1.contains__O__Z(x$4)
        })
      })(this, flatten)));
      if ((x1$3 === null)) {
        throw new $c_s_MatchError().init___O(x1$3)
      };
      var unused = $as_sc_Seq(x1$3.$$und2__O());
      var this$9 = $m_sc_Seq$();
      var finalParams = $as_sc_Seq(flatten.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(unused, this$9.ReusableCBFInstance$2));
      var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Variables$1;
      var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(finalParams, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(server, field$1, value, annotations);
      unused.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1) {
        return (function(p$3$2) {
          var p$3 = $as_Lamf_plugins_domain_webapi_models_Parameter(p$3$2);
          var jsx$7 = this$5$1.ctx$1.eh$1;
          var jsx$6 = $m_Lamf_validations_ParserSideValidations$().UnusedBaseUriParameter$1;
          var jsx$5 = p$3.id$1;
          var jsx$4 = $m_s_None$();
          var this$10 = $as_Lamf_core_model_StrField(p$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
          var this$11 = this$10.option$1;
          jsx$7.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V(jsx$6, jsx$5, jsx$4, ("Unused base uri parameter " + $as_T((this$11.isEmpty__Z() ? null : this$11.get__O()))), p$3.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), $f_Lamf_core_model_domain_AmfElement__location__s_Option(p$3))
        })
      })(this)))
    } else {
      var x$3$1 = $m_Lorg_yaml_model_YType$().Null$1;
      if ((x$3$1 === x1$2)) {
        /*<skip>*/
      } else {
        var this$12 = this.ctx$1.eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().InvalidBaseUriParametersType$1;
        var ast = entry.value$2;
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$12, specification, "", prop, "Invalid node for baseUriParameters", l)
      }
    }
  } else {
    var x$7 = $m_s_None$();
    if ((x$7 === maybeEntry)) {
      if (orderedVariables.nonEmpty__Z()) {
        var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Variables$1;
        var jsx$8 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1, server$3) {
          return (function(x$5$2$2) {
            var x$5$2 = $as_T(x$5$2$2);
            return this$6$1.buildParamFromVar__p1__T__T__Lamf_plugins_domain_webapi_models_Parameter(x$5$2, server$3.id$1)
          })
        })(this, server));
        var this$13 = $m_sc_Seq$();
        var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(orderedVariables.map__F1__scg_CanBuildFrom__O(jsx$8, this$13.ReusableCBFInstance$2)), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
        $m_Lamf_core_parser_Annotations$();
        var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(server, field$2, value$1, annotations$1)
      }
    } else {
      throw new $c_s_MatchError().init___O(maybeEntry)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser.prototype.productPrefix__T = (function() {
  return "RamlServersParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser.prototype.init___Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_WebApi__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(map, api, ctx) {
  this.map$1 = map;
  this.api$1 = api;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser.prototype.buildParamFromVar__p1__T__T__Lamf_plugins_domain_webapi_models_Parameter = (function(v, serverId) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_Parameter().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var this$5 = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, v, x$2));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
  var this$6 = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$5, field, "path"));
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1;
  var param = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$6, field$1, true));
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(param, serverId);
  var this$7 = param.withScalarSchema__T__Lamf_plugins_domain_shapes_models_ScalarShape(v);
  var dataType = $m_Lamf_core_model_DataType$().String$1;
  var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
  $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$7, field$2, dataType));
  param.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SynthesizedField().init___());
  return param
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser)) {
    var RamlServersParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser(x$1);
    var this$1 = this.map$1;
    var b = RamlServersParser$1.map$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.api$1;
      var x$2 = RamlServersParser$1.api$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.api$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser.prototype.parse__V = (function() {
  var map = this.map$1;
  var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("baseUri");
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    var node = $m_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_core_parser_ScalarNode(entry.value$2, this.ctx$1);
    var value = node.text__Lamf_core_model_domain_AmfScalar().toString__T();
    var server = this.api$1.withServer__T__Lamf_plugins_domain_webapi_models_Server(value);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Url$1;
    var iv = this.ctx$1;
    new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(server).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField().apply__Lorg_yaml_model_YMapEntry__V(entry);
    var value$1 = entry.value$2;
    var node$1 = server.id$1;
    var property = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Url$1.value$1.iri__T();
    var ctx = this.ctx$1;
    $f_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__checkBalancedParams__T__Lorg_yaml_model_YNode__T__T__Lamf_plugins_document_webapi_contexts_WebApiContext__V(this, value, value$1, node$1, property, ctx);
    if ((!$m_Lamf_core_utils_package$TemplateUri$().isValid__T__Z(value))) {
      var this$2 = this.ctx$1.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidServerPath$1;
      var node$2 = this.api$1.id$1;
      var message = $m_Lamf_core_utils_package$TemplateUri$().invalidMsg__T__T(value);
      var ast = entry.value$2;
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$2, specification, node$2, prop, message, l)
    };
    var map$1 = this.map$1;
    var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
    var jsx$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T("serverDescription").asRamlAnnotation__T();
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Description$1;
    var iv$1 = this.ctx$1;
    jsx$2.key__T__F1__V(jsx$1, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(server));
    this.parseBaseUriParameters__p1__Lamf_plugins_domain_webapi_models_Server__sc_Seq__V(server, $m_Lamf_core_utils_package$TemplateUri$().variables__T__sc_Seq(value));
    var this$7 = this.api$1;
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Servers$1;
    var jsx$3 = $m_sc_Seq$();
    var annotation = new $c_Lamf_core_annotations_SynthesizedField().init___();
    var array = [$as_Lamf_plugins_domain_webapi_models_Server($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(server, annotation))];
    var value$2 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$7, field$2, value$2, annotations)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var map$2 = this.map$1;
      var this$9 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2).key__T__s_Option("baseUriParameters");
      if ((!this$9.isEmpty__Z())) {
        var arg1 = this$9.get__O();
        var entry$2 = $as_Lorg_yaml_model_YMapEntry(arg1);
        var this$10 = this.ctx$1.eh$1;
        var specification$1 = $m_Lamf_validations_ParserSideValidations$().ParametersWithoutBaseUri$1;
        var node$3 = this.api$1.id$1;
        var prop$1 = $m_s_None$();
        var l$1 = entry$2.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$10, specification$1, node$3, prop$1, "'baseUri' not defined and 'baseUriParameters' defined.", l$1);
        $m_Lamf_core_parser_Annotations$();
        var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
        var qual$1 = new $c_Lamf_plugins_domain_webapi_models_Server().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
        var x$1 = this.api$1.id$1;
        $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        var server$1 = $as_Lamf_plugins_domain_webapi_models_Server($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
        this.parseBaseUriParameters__p1__Lamf_plugins_domain_webapi_models_Server__sc_Seq__V(server$1, $m_sci_Nil$());
        var this$16 = this.api$1;
        var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Servers$1;
        var jsx$4 = $m_sc_Seq$();
        var annotation$1 = new $c_Lamf_core_annotations_SynthesizedField().init___();
        var array$1 = [$as_Lamf_plugins_domain_webapi_models_Server($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(server$1, annotation$1))];
        var value$3 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1))), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$2.value$2));
        var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$2);
        $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$16, field$3, value$3, annotations$2))
      }
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  var map$3 = this.map$1;
  var this$19 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3).key__T__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("servers").asRamlAnnotation__T());
  if ((!this$19.isEmpty__Z())) {
    var arg1$1 = this$19.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var this$22 = entry$3.value$2;
    var reader = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var this$21 = $m_sc_IndexedSeq$();
    var bf = this$21.ReusableCBF$6;
    var conversion = new $c_Lorg_yaml_convert_YRead$$anon$1().init___scg_CanBuildFrom__Lorg_yaml_convert_YRead(bf, reader);
    var iv$2 = this.ctx$1;
    var jsx$6 = $as_sc_TraversableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$22, conversion, iv$2));
    var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$1$2) {
        var x$1$1 = $as_Lorg_yaml_model_YMap(x$1$2);
        return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser().init___T__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext($this.api$1.id$1, x$1$1, $m_Lamf_plugins_document_webapi_parser_spec_package$().toOas__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($this.ctx$1)).parse__Lamf_plugins_domain_webapi_models_Server()
      })
    })(this));
    var this$23 = $m_sc_Seq$();
    $as_sc_IterableLike(jsx$6.map__F1__scg_CanBuildFrom__O(jsx$5, this$23.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(server$2) {
        var server$3 = $as_Lamf_plugins_domain_webapi_models_Server(server$2);
        var this$24 = this$2$1.api$1;
        var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Servers$1;
        return $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$24, field$4, server$3))
      })
    })(this)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlServersParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlServersParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlServersParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser() {
  $c_O.call(this);
  this.entry$1 = null;
  this.producer$1 = null;
  this.options$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser.prototype.parse__Lamf_plugins_domain_shapes_models_Example = (function() {
  var this$1 = $as_Lamf_core_model_domain_AmfElement(this.producer$1.apply__O());
  var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1);
  var example = $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$1, other));
  var this$2 = this.entry$1.value$2;
  var x1 = this$2.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var this$3 = this.entry$1.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$1;
    var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv));
    var this$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("value");
    if (this$5.isDefined__Z()) {
      var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
      var field = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().DisplayName$1;
      var iv$1 = this.ctx$1;
      jsx$1.key__T__F1__V("displayName", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(example).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
      var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
      var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Description$1;
      var iv$2 = this.ctx$1;
      jsx$2.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(example).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
      var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
      var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Strict$1;
      var iv$3 = this.ctx$1;
      jsx$3.key__T__F1__V("strict", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(example).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
      var this$10 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("value");
      if ((!this$10.isEmpty__Z())) {
        var arg1 = this$10.get__O();
        var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
        new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser().init___Lorg_yaml_model_YNode__Lamf_plugins_domain_shapes_models_Example__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext(entry.value$2, example, this.options$1, this.ctx$1).parse__Lamf_plugins_domain_shapes_models_Example()
      };
      $m_sci_List$();
      var array = [$m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().example$1];
      var i = (((-1) + $uI(array.length)) | 0);
      var result = $m_sci_Nil$();
      while ((i >= 0)) {
        var this$14 = result;
        var index = i;
        var x$1 = array[index];
        result = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$14);
        i = (((-1) + i) | 0)
      };
      new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(example, map, result, this.ctx$1).parse__V();
      var this$15 = this.ctx$1.vendor__Lamf_core_remote_Vendor();
      if ($f_Lamf_core_remote_Vendor__isRaml__Z(this$15)) {
        this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(example.id$1, map, "example")
      }
    } else {
      new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser().init___Lorg_yaml_model_YNode__Lamf_plugins_domain_shapes_models_Example__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext(this.entry$1.value$2, example, this.options$1, this.ctx$1).parse__Lamf_plugins_domain_shapes_models_Example()
    }
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Null$1;
    if ((!(x$3 === x1))) {
      new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleDataParser().init___Lorg_yaml_model_YNode__Lamf_plugins_domain_shapes_models_Example__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext(this.entry$1.value$2, example, this.options$1, this.ctx$1).parse__Lamf_plugins_domain_shapes_models_Example()
    }
  };
  return example
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser.prototype.productPrefix__T = (function() {
  return "RamlSingleExampleValueParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser)) {
    var RamlSingleExampleValueParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser(x$1);
    var x = this.entry$1;
    var x$2 = RamlSingleExampleValueParser$1.entry$1;
    if ((x === x$2)) {
      var x$3 = this.producer$1;
      var x$4 = RamlSingleExampleValueParser$1.producer$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.options$1;
      var x$6 = RamlSingleExampleValueParser$1.options$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$1;
      break
    }
    case 1: {
      return this.producer$1;
      break
    }
    case 2: {
      return this.options$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser.prototype.init___Lorg_yaml_model_YMapEntry__F0__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(entry, producer, options, ctx) {
  this.entry$1 = entry;
  this.producer$1 = producer;
  this.options$1 = options;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlSingleExampleValueParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlSingleExampleValueParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlSingleExampleValueParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleValueParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter$$anonfun$collect$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter$$anonfun$collect$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter$$anonfun$collect$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter$$anonfun$collect$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter$$anonfun$collect$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter$$anonfun$collect$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter$$anonfun$collect$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter$$anonfun$collect$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter$$anonfun$collect$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter$$anonfun$collect$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter$$anonfun$collect$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter$$anonfun$collect$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter = (function($$outer) {
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter$$anonfun$collect$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter$$anonfun$collect$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.SecurityRequirementsEmitter$$anonfun$collect$1", {
  Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter$$anonfun$collect$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter$$anonfun$collect$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter$$anonfun$collect$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser() {
  $c_O.call(this);
  this.map$1 = null;
  this.parentId$1 = null;
  this.definitionEntry$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser.prototype.productPrefix__T = (function() {
  return "Oas30RequestParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser)) {
    var Oas30RequestParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser(x$1);
    var this$1 = this.map$1;
    var b = Oas30RequestParser$1.map$1;
    if (($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b) && (this.parentId$1 === Oas30RequestParser$1.parentId$1))) {
      var x = this.definitionEntry$1;
      var x$2 = Oas30RequestParser$1.definitionEntry$1;
      return (x === x$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$1;
      break
    }
    case 1: {
      return this.parentId$1;
      break
    }
    case 2: {
      return this.definitionEntry$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser.prototype.parseRef__p1__T__Lamf_plugins_domain_webapi_models_Request = (function(fullRef) {
  var name = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().stripOas3ComponentsPrefix__T__T__T(fullRef, "requestBodies");
  var this$1 = this.ctx$1.declarations$4.findRequestBody__T__Lamf_core_parser_SearchScope$Scope__s_Option(name, $m_Lamf_core_parser_SearchScope$Named$());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var req = $as_Lamf_plugins_domain_webapi_models_Request(arg1);
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.map$1);
    var this$2 = new $c_s_Some().init___O(this.adopt__p1__Lamf_plugins_domain_webapi_models_Request__Lamf_plugins_domain_webapi_models_Request($as_Lamf_plugins_domain_webapi_models_Request($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(req, name, annotations))))
  };
  if (this$2.isEmpty__Z()) {
    var x1 = this.ctx$1.navigateToRemoteYNode__T__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__s_Option(fullRef, this.ctx$1);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var navigation = $as_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation(x2.value$2);
      var this$3 = navigation.remoteNode$1;
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = this.ctx$1;
      var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser().init___Lorg_yaml_model_YMap__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv)), this.parentId$1, this.definitionEntry$1, $as_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(navigation.context$1)).parse__Lamf_plugins_domain_webapi_models_Request()
    } else {
      var x = $m_s_None$();
      if ((!(x === x1))) {
        throw new $c_s_MatchError().init___O(x1)
      };
      var this$4 = this.ctx$1.eh$1;
      var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnresolvedReference$1;
      var message = ("Cannot find requestBody reference " + fullRef);
      var ast = this.map$1;
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$4, specification, "", prop, message, l);
      var qual$1 = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest().init___T__Lorg_yaml_model_YPart(fullRef, this.map$1);
      $m_Lamf_core_parser_Annotations$();
      var x$2$2 = new $c_Lamf_core_parser_Annotations().init___();
      var jsx$1 = this.adopt__p1__Lamf_plugins_domain_webapi_models_Request__Lamf_plugins_domain_webapi_models_Request($as_Lamf_plugins_domain_webapi_models_Request($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(qual$1, name, x$2$2)))
    }
  } else {
    var jsx$1 = this$2.get__O()
  };
  return $as_Lamf_plugins_domain_webapi_models_Request(jsx$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser.prototype.parse__Lamf_plugins_domain_webapi_models_Request = (function() {
  var jsx$1 = this.ctx$1;
  $m_Lorg_yaml_model_YNode$();
  var map = this.map$1;
  $m_Lorg_yaml_model_YNode$();
  var x1 = jsx$1.link__Lorg_yaml_model_YNode__s_util_Either($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1));
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var fullRef = $as_T(x2.value$2);
    return this.parseRef__p1__T__Lamf_plugins_domain_webapi_models_Request(fullRef)
  } else if ((x1 instanceof $c_s_util_Right)) {
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var request = this.adopt__p1__Lamf_plugins_domain_webapi_models_Request__Lamf_plugins_domain_webapi_models_Request(new $c_Lamf_plugins_domain_webapi_models_Request().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
    var map$1 = this.map$1;
    var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Description$1;
    var iv = this.ctx$1;
    jsx$2.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(request));
    var map$2 = this.map$1;
    var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Required$1;
    var iv$1 = this.ctx$1;
    jsx$3.key__T__F1__V("required", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(request));
    var payloads = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var map$3 = this.map$1;
    var x1$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3).key__T__s_Option("content");
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var entry = $as_Lorg_yaml_model_YMapEntry(x2$2.value$2);
      payloads.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser().init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, request$1) {
        return (function(mediaType$2) {
          var mediaType = $as_s_Option(mediaType$2);
          return request$1.withPayload__s_Option__Lamf_plugins_domain_webapi_models_Payload(mediaType)
        })
      })(this, request)), this.ctx$1).parse__sci_List())
    } else {
      var x = $m_s_None$();
      if ((x === x1$2)) {
        var this$9 = this.ctx$1.eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().RequestBodyContentRequired$1;
        var node = request.id$1;
        var ast = this.map$1;
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$9, specification, node, prop, "Request body must have a 'content' field defined", l)
      } else {
        throw new $c_s_MatchError().init___O(x1$2)
      }
    };
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Payloads$1;
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(payloads, new $c_Lamf_core_parser_Annotations().init___());
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(request, field$2, value);
    new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(request, this.map$1, $m_sci_Nil$(), this.ctx$1).parse__V();
    this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(request.id$1, this.map$1, "request");
    return request
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser.prototype.adopt__p1__Lamf_plugins_domain_webapi_models_Request__Lamf_plugins_domain_webapi_models_Request = (function(request) {
  var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.definitionEntry$1);
  var this$3 = $as_Lamf_core_model_domain_AmfObject($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(request, other));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Name$1;
  var node = this.definitionEntry$1.key$2;
  var iv = this.ctx$1;
  var this$2 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
  var value = this$2.string__Lamf_core_model_domain_AmfScalar();
  var qual$1 = $as_Lamf_plugins_domain_webapi_models_Request($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$3, field, value));
  var x$1 = this.parentId$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  return $as_Lamf_plugins_domain_webapi_models_Request($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser.prototype.init___Lorg_yaml_model_YMap__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(map, parentId, definitionEntry, ctx) {
  this.map$1 = map;
  this.parentId$1 = parentId;
  this.definitionEntry$1 = definitionEntry;
  this.ctx$1 = ctx;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.Oas30RequestParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.Oas30RequestParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.Oas30RequestParser", {
  Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter() {
  $c_O.call(this);
  this.declares$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.emitters$1 = null;
  this.platform$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter.prototype.productPrefix__T = (function() {
  return "OasDeclarationsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter)) {
    var OasDeclarationsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter(x$1);
    var x = this.declares$1;
    var x$2 = OasDeclarationsEmitter$1.declares$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasDeclarationsEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = OasDeclarationsEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.declares$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(declares, ordering, references, spec) {
  this.declares$1 = declares;
  this.ordering$1 = ordering;
  this.references$1 = references;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  var declarations = $m_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$().apply__sc_Seq__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(declares, $m_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$(), new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___());
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$3 = declarations.shapes$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$3)) {
    var jsx$1 = true
  } else {
    var this$4 = spec.definitionsQueue$3;
    var this$5 = this$4.pendingEmission$1;
    var jsx$1 = $f_sc_TraversableOnce__nonEmpty__Z(this$5)
  };
  if (jsx$1) {
    var this$6 = spec.factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory();
    var jsx$2 = $f_Lamf_plugins_document_webapi_contexts_emitter_oas_OasCompactEmitterFactory__declaredTypesEmitter__F3(this$6);
    var this$7 = declarations.shapes$2;
    var this$8 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$7);
    result.$$plus$eq__O__scm_ListBuffer(jsx$2.apply__O__O__O__O(this$8.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), references, ordering))
  };
  var this$9 = declarations.annotations$1;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$9)) {
    var this$10 = declarations.annotations$1;
    var this$11 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$10);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this$11.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), ordering, spec))
  };
  var this$12 = declarations.resourceTypes$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$12)) {
    var jsx$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T("resourceTypes").asOasExtension__T();
    var this$14 = declarations.resourceTypes$2;
    var this$15 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$14);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(jsx$3, this$15.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), ordering, $m_sci_Nil$(), spec))
  };
  var this$16 = declarations.traits$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$16)) {
    var jsx$4 = new $c_Lamf_core_utils_package$AmfStrings().init___T("traits").asOasExtension__T();
    var this$18 = declarations.traits$2;
    var this$19 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$18);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(jsx$4, this$19.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), ordering, $m_sci_Nil$(), spec))
  };
  var this$20 = declarations.securitySchemes$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$20)) {
    var jsx$5 = spec.factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory();
    var this$21 = declarations.securitySchemes$2;
    var this$22 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$21);
    result.$$plus$eq__O__scm_ListBuffer(jsx$5.securitySchemesEmitters__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemesEmitters(this$22.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), ordering))
  };
  var this$23 = declarations.parameters$2;
  var this$25 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$23);
  var this$24 = $m_sc_Iterable$();
  var bf = this$24.ReusableCBFInstance$2;
  var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$25, bf);
  var this$26 = this$25.$$outer$3.valuesIterator__sc_Iterator();
  while (this$26.hasNext__Z()) {
    var arg1 = this$26.next__O();
    var x$1 = $as_Lamf_plugins_domain_webapi_models_Parameter(arg1);
    b.$$plus$eq__O__scm_Builder($m_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$().apply__Lamf_plugins_domain_webapi_models_Parameter__s_Option__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(x$1, $m_s_None$()))
  };
  var jsx$7 = $as_sc_TraversableLike(b.result__O());
  var this$28 = declarations.payloads$2;
  var this$30 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$28);
  var this$29 = $m_sc_Iterable$();
  var bf$1 = this$29.ReusableCBFInstance$2;
  var b$1 = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$30, bf$1);
  var this$31 = this$30.$$outer$3.valuesIterator__sc_Iterator();
  while (this$31.hasNext__Z()) {
    var arg1$1 = this$31.next__O();
    var x$2 = $as_Lamf_plugins_domain_webapi_models_Payload(arg1$1);
    b$1.$$plus$eq__O__scm_Builder($m_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$().apply__Lamf_plugins_domain_webapi_models_Payload__s_Option__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(x$2, $m_s_None$()))
  };
  var jsx$6 = $as_sc_GenTraversableOnce(b$1.result__O());
  var this$33 = $m_sc_Iterable$();
  var oasParams = $as_sc_Iterable(jsx$7.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$6, this$33.ReusableCBFInstance$2));
  if (oasParams.nonEmpty__Z()) {
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__T__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(oasParams.toSeq__sc_Seq(), ordering, references, "parameters", spec))
  };
  var this$34 = declarations.headers$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$34)) {
    var this$35 = declarations.headers$2;
    var this$36 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$35);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this$36.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), ordering, references, spec))
  };
  var this$37 = declarations.responses$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$37)) {
    var this$38 = declarations.responses$2;
    var this$39 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$38);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext("responses", this$39.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), ordering, references, spec))
  };
  var this$40 = declarations.examples$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$40)) {
    var this$41 = declarations.examples$2;
    var this$42 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$41);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("examples", this$42.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), ordering, spec))
  };
  var this$43 = declarations.requests$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$43)) {
    var this$44 = declarations.requests$2;
    var this$45 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$44);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this$45.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), ordering, references, spec))
  };
  var this$46 = declarations.links$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$46)) {
    var this$47 = declarations.links$2;
    var this$48 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$47);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this$48.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), ordering, references, spec))
  };
  var this$49 = declarations.callbacks$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$49)) {
    var this$50 = declarations.callbacks$2;
    var this$51 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$50);
    $m_sc_Iterable$();
    $m_sci_Iterable$();
    var b$2 = new $c_scm_ListBuffer().init___();
    var this$54 = this$51.$$outer$3.valuesIterator__sc_Iterator();
    while (this$54.hasNext__Z()) {
      var arg1$2 = this$54.next__O();
      var xs = $as_sc_GenTraversableOnce(arg1$2).seq__sc_TraversableOnce();
      b$2.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(xs)
    };
    var this$55 = b$2.toList__sci_List();
    var this$56 = $f_sc_TraversableLike__headOption__s_Option(this$55);
    if (this$56.isEmpty__Z()) {
      var this$57 = $m_s_None$()
    } else {
      var arg1$3 = this$56.get__O();
      var x$3 = $as_Lamf_plugins_domain_webapi_models_Callback(arg1$3);
      var this$57 = new $c_s_Some().init___O(x$3.annotations$1)
    };
    var annotations = $as_Lamf_core_parser_Annotations((this$57.isEmpty__Z() ? ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()) : this$57.get__O()));
    var x$2$3 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_core_parser_Annotations__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this$55, ordering, references, annotations, spec);
    var this$59 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var x$3$3 = this$59.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position("callbacks", x$2$3, x$4, x$3$3))
  };
  this.emitters$1 = result;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasDeclarationsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasDeclarationsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasDeclarationsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter: 1,
  O: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclarationsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser.call(this);
  this.root$2 = null;
  this.ctx$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(root, ctx) {
  this.root$2 = root;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser.prototype.init___Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.call(this, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.parseParameterDeclarations__Lorg_yaml_model_YMap__T__V = (function(map, parentPath) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("parameters");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
    $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parentPath$1) {
      return (function(e$2) {
        var e = $as_Lorg_yaml_model_YMapEntry(e$2);
        var typeName = e.key$2;
        var nameGenerator = new $c_Lamf_core_utils_package$IdCounter().init___();
        var this$5 = e.value$2;
        var evidence$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var x1 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$5, evidence$2);
        if ((x1 instanceof $c_s_util_Right)) {
          var oasParameter = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().factory__Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory().parameterParser__s_util_Either__T__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_parser_spec_domain_OasParameterParser(($m_s_package$(), new $c_s_util_Left().init___O(e)), parentPath$1, new $c_s_Some().init___O(typeName), nameGenerator).parse__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter()
        } else {
          var jsx$1 = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().factory__Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory();
          $m_s_package$();
          $m_Lorg_yaml_model_YNode$();
          var map$1 = $m_Lorg_yaml_model_YMap$().empty$1;
          $m_Lorg_yaml_model_YNode$();
          var value = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map$1, $m_Lorg_yaml_model_YType$().Map$1);
          var parameter = jsx$1.parameterParser__s_util_Either__T__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_parser_spec_domain_OasParameterParser(new $c_s_util_Right().init___O(value), parentPath$1, new $c_s_Some().init___O(typeName), nameGenerator).parse__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter();
          var this$10 = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().eh$1;
          var specification = $m_Lamf_validations_ParserSideValidations$().InvalidParameterType$1;
          var node = parameter.domainElement$1.id__T();
          var prop = $m_s_None$();
          var l = e.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$10, specification, node, prop, "Map needed to parse a parameter declaration", l);
          var oasParameter = parameter
        };
        $this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().declarations$4.registerOasParameter__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter__V(oasParameter)
      })
    })(this, parentPath)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.parseExtension__p2__Lamf_core_model_document_Document__Lamf_core_metamodel_Field__V = (function(document, field) {
  var this$1 = $as_Lamf_core_parser_SyamlParsedDocument(this.root$2.parsed$1).document$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser().init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser__Lorg_yaml_model_YMap__Lamf_core_model_document_BaseUnit(this, map, document).parse__V();
  var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("extends").asOasExtension__T());
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var x1 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().link__Lorg_yaml_model_YNode__s_util_Either(e.value$2);
    if ((x1 instanceof $c_s_util_Left)) {
      var x2 = $as_s_util_Left(x1);
      var url = $as_T(x2.value$2);
      var this$5 = this.root$2.references$1.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, url$1) {
        return (function(x$1$2) {
          var x$1 = $as_Lamf_core_parser_ParsedReference(x$1$2);
          return (x$1.origin$1.url$1 === url$1)
        })
      })(this, url)));
      if ((!this$5.isEmpty__Z())) {
        var arg1$1 = this$5.get__O();
        var extend = $as_Lamf_core_parser_ParsedReference(arg1$1);
        var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(extend.unit$1.id__T(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(e.value$2));
        var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(e);
        $as_Lamf_core_model_document_Document($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(document, field, value, annotations))
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.parseDocument__p2__Lamf_core_model_document_Document__Lamf_core_model_document_Document = (function(document) {
  var parent = this.root$2.location$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(document, parent));
  var location = this.root$2.location$1;
  var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
  $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, location));
  var this$2 = $as_Lamf_core_parser_SyamlParsedDocument(this.root$2.parsed$1).document$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv));
  this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().setJsonSchemaAST__Lorg_yaml_model_YNode__V(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1)));
  var references = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser().init___Lamf_core_model_document_BaseUnit__T__Lorg_yaml_model_YMap__sc_Seq__Lamf_plugins_document_webapi_contexts_WebApiContext(document, new $c_Lamf_core_utils_package$AmfStrings().init___T("uses").asOasExtension__T(), map, this.root$2.references$1, this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext()).parse__T__Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations(this.root$2.location$1);
  this.parseDeclarations__Lamf_core_Root__Lorg_yaml_model_YMap__V(this.root$2, map);
  var this$6 = this.parseWebApi__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_WebApi(map);
  var annotation = new $c_Lamf_core_annotations_SourceVendor().init___Lamf_core_remote_Vendor(this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().vendor__Lamf_core_remote_Vendor());
  var api = $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$6, annotation));
  var field$1 = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
  var qual$1 = $as_Lamf_core_model_document_Document($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(document, field$1, api)));
  var x$1 = this.root$2.location$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1);
  var declarable = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().declarations$4.declarables__sc_Seq();
  if (declarable.nonEmpty__Z()) {
    var field$2 = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
    $as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(document, field$2, declarable))
  };
  var this$7 = references.references$1;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$7)) {
    var references$1 = references.solvedReferences__sc_Seq();
    var field$3 = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
    $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(document, field$3, references$1))
  };
  var this$8 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().futureDeclarations$1;
  $f_Lamf_core_parser_FutureDeclarations__resolve__V(this$8);
  return document
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.parseEndpoints__p2__Lamf_plugins_domain_webapi_models_WebApi__Lorg_yaml_model_YMapEntry__V = (function(api, entry) {
  var this$1 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
  var paths = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var endpoints = $as_sci_List(new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(paths).regex__T__sc_Iterable("^/.*").foldLeft__O__F2__O($m_sci_Nil$(), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this, api$1) {
    return (function(acc$2, curr$2) {
      var acc = $as_sci_List(acc$2);
      var curr = $as_Lorg_yaml_model_YMapEntry(curr$2);
      var xo = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().factory__Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory().endPointParser__Lorg_yaml_model_YMapEntry__F1__sci_List__Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser(curr, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, api$3) {
        return (function(path$2) {
          var path = $as_T(path$2);
          return api$3.withEndPoint__T__Lamf_plugins_domain_webapi_models_EndPoint(path)
        })
      })($this, api$1)), acc).parse__s_Option();
      var jsx$1 = xo.toList__sci_List();
      var this$4 = $m_sci_List$();
      return $as_sci_List(acc.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2))
    })
  })(this, api))));
  if ($f_sc_TraversableOnce__nonEmpty__Z(endpoints)) {
    var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1;
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(endpoints, new $c_Lamf_core_parser_Annotations().init___());
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(api, field, value, annotations)
  };
  this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().closedShape__T__Lorg_yaml_model_YMap__T__V(api.id$1, paths, "paths")
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.parseExtension__Lamf_plugins_document_webapi_model_Extension = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var extension = $as_Lamf_plugins_document_webapi_model_Extension(this.parseDocument__p2__Lamf_core_model_document_Document__Lamf_core_model_document_Document(new $c_Lamf_plugins_document_webapi_model_Extension().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)));
  this.parseExtension__p2__Lamf_core_model_document_Document__Lamf_core_metamodel_Field__V(extension, $m_Lamf_core_metamodel_document_ExtensionLikeModel$().Extends$1);
  return extension
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.validateSchemeType$1__p2__Lamf_plugins_domain_webapi_models_security_SecurityScheme__V = (function(scheme) {
  var schemeType = $as_Lamf_core_model_StrField(scheme.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1));
  if ($f_Lamf_core_model_StrField__nonEmpty__Z(schemeType)) {
    var jsx$2 = $m_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$().validTypesFor__Lamf_core_remote_Vendor__sci_Set(this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().vendor__Lamf_core_remote_Vendor());
    var this$1 = schemeType.option$1;
    var jsx$1 = (!jsx$2.contains__O__Z($as_T((this$1.isEmpty__Z() ? null : this$1.get__O()))))
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var this$2 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().InvalidSecuritySchemeType$1;
    var node = scheme.id$1;
    var property = new $c_s_Some().init___O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1.value$1.iri__T());
    var message = ((("'" + schemeType) + "' is not a valid security scheme type in ") + this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().vendor__Lamf_core_remote_Vendor().name__T());
    var lexical = $as_Lamf_core_model_StrField(scheme.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1)).annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var location = new $c_s_Some().init___O(this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().rootContextDocument$1);
    this$2.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.parseResponsesDeclarations__T__Lorg_yaml_model_YMap__T__V = (function(key, map, parentPath) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option(key);
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
    $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parentPath$2) {
      return (function(e$2) {
        var e = $as_Lorg_yaml_model_YMapEntry(e$2);
        var node = e.key$2;
        var iv$1 = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
        var this$6 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv$1);
        var node$1 = this$6.text__Lamf_core_model_domain_AmfScalar();
        var jsx$1 = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().declarations$4;
        var this$7 = e.value$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv$2 = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
        return jsx$1.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser().init___Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$7, conversion$1, iv$2)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, node$2, parentPath$2$1, e$1) {
          return (function(r$2) {
            var r = $as_Lamf_plugins_domain_webapi_models_Response(r$2);
            var field = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Name$1;
            var qual$1 = $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(r, field, node$2));
            $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
            var this$8 = $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, parentPath$2$1);
            var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
            $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$8, annotation);
            r.annotations$2.$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations($m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(e$1))
          })
        })($this, node$1, parentPath$2, e)), $this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext()).parse__Lamf_plugins_domain_webapi_models_Response())
      })
    })(this, parentPath)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.parseOverlay__Lamf_plugins_document_webapi_model_Overlay = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var overlay = $as_Lamf_plugins_document_webapi_model_Overlay(this.parseDocument__p2__Lamf_core_model_document_Document__Lamf_core_model_document_Document(new $c_Lamf_plugins_document_webapi_model_Overlay().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)));
  this.parseExtension__p2__Lamf_core_model_document_Document__Lamf_core_metamodel_Field__V(overlay, $m_Lamf_core_metamodel_document_ExtensionLikeModel$().Extends$1);
  return overlay
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.parseSecuritySchemeDeclarationsFromKey__T__Lorg_yaml_model_YMap__T__V = (function(key, map, parent) {
  var isExtension = (($uI(key.length) >= 0) && ($as_T(key.substring(0, $uI("x-amf-".length))) === "x-amf-"));
  var this$7 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$8 = this$7.key__T__s_Option(key);
  if ((!this$8.isEmpty__Z())) {
    var arg1 = this$8.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$9 = e.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
    $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$9, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$1, isExtension$1) {
      return (function(entry$2) {
        var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
        var this$11 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser($this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().factory__Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory().securitySchemeParser__F2().apply__O__O__O(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, entry$1, parent$1$1) {
          return (function(scheme$2) {
            var scheme = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(scheme$2);
            var this$10 = entry$1.key$2;
            var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
            var iv$1 = $this$1.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
            var name = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$10, conversion$1, iv$1));
            var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Name$1;
            var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(name, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$1.key$2.value__Lorg_yaml_model_YValue()));
            var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$1.key$2);
            $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(scheme, field, value, annotations);
            return scheme.adopted__T__sc_Seq__Lamf_plugins_domain_webapi_models_security_SecurityScheme(parent$1$1, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())))
          })
        })($this, entry, parent$1)))).parse__Lamf_plugins_domain_webapi_models_security_SecurityScheme();
        var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
        var securityScheme = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$11, annotation));
        if ((!isExtension$1)) {
          $this.validateSchemeType$1__p2__Lamf_plugins_domain_webapi_models_security_SecurityScheme__V(securityScheme)
        };
        return $this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().declarations$4.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(securityScheme)
      })
    })(this, parent, isExtension)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.parseDeclarations__Lamf_core_Root__Lorg_yaml_model_YMap__V = (function(root, map) {
  var parent = (root.location$1 + "#/declarations");
  var typesPrefix = (parent + "/types");
  var ctx = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
  $f_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeDeclarationsHelper__parseTypeDeclarations__Lorg_yaml_model_YMap__T__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__V(this, map, typesPrefix, ctx);
  this.parseAnnotationTypeDeclarations__Lorg_yaml_model_YMap__T__V(map, parent);
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser().init___T__F1__Lorg_yaml_model_YMap__T__Lamf_plugins_document_webapi_contexts_WebApiContext(new $c_Lamf_core_utils_package$AmfStrings().init___T("resourceTypes").asOasExtension__T(), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      return $m_Lamf_plugins_domain_webapi_models_templates_ResourceType$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_templates_ResourceType(entry)
    })
  })(this)), map, (parent + "/resourceTypes"), this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext()).parse__V();
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser().init___T__F1__Lorg_yaml_model_YMap__T__Lamf_plugins_document_webapi_contexts_WebApiContext(new $c_Lamf_core_utils_package$AmfStrings().init___T("traits").asOasExtension__T(), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(entry$3$2) {
      var entry$3 = $as_Lorg_yaml_model_YMapEntry(entry$3$2);
      return $m_Lamf_plugins_domain_webapi_models_templates_Trait$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_templates_Trait(entry$3)
    })
  })(this)), map, (parent + "/traits"), this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext()).parse__V();
  this.parseSecuritySchemeDeclarations__Lorg_yaml_model_YMap__T__V(map, (parent + "/securitySchemes"));
  this.parseParameterDeclarations__Lorg_yaml_model_YMap__T__V(map, (parent + "/parameters"));
  this.parseResponsesDeclarations__T__Lorg_yaml_model_YMap__T__V("responses", map, (parent + "/responses"))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.parseAnnotationTypeDeclarations__Lorg_yaml_model_YMap__T__V = (function(map, customProperties) {
  var this$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("annotationTypes").asOasExtension__T();
  var this$4 = this$3.key__T__s_Option(keyword);
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$5 = e.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
    var jsx$3 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv)).entries$3;
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, customProperties$1) {
      return (function(entry$2) {
        var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
        var this$6 = entry.key$2;
        var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
        var iv$1 = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
        var typeName = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion$1, iv$1)).text$3;
        var customProperty$3 = $this.AnnotationTypesParser__Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$AnnotationTypesParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_core_model_domain_extensions_CustomDomainProperty(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, typeName$1, customProperties$1$1) {
          return (function(customProperty$2) {
            var customProperty = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(customProperty$2);
            $m_Lamf_core_parser_Annotations$();
            var a = new $c_Lamf_core_parser_Annotations().init___();
            var qual$1 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(customProperty, typeName$1, a));
            var x$2 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
            qual$1.adopted__T__sc_Seq__Lamf_core_model_domain_extensions_CustomDomainProperty(customProperties$1$1, x$2)
          })
        })($this, typeName, customProperties$1)));
        var jsx$2 = $this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().declarations$4;
        var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
        return jsx$2.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(customProperty$3, annotation)))
      })
    })(this, customProperties));
    var this$8 = $m_sc_IndexedSeq$();
    jsx$3.map__F1__scg_CanBuildFrom__O(jsx$1, this$8.ReusableCBF$6)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.parseWebApi__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_WebApi = (function(map) {
  var qual$1 = $m_Lamf_plugins_domain_webapi_models_WebApi$().apply__Lorg_yaml_model_YNode__Lamf_plugins_domain_webapi_models_WebApi($as_Lamf_core_parser_SyamlParsedDocument(this.root$2.parsed$1).document$2.node$2);
  var x$1 = this.root$2.location$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var api = $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("info");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser().init___Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_WebApi__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(entry, api, this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext()).parse__V()
  };
  this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().factory__Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory().serversParser__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_WebApi__Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser(map, api).parse__V();
  var this$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$6 = this$5.key__T__s_Option("tags");
  if ((!this$6.isEmpty__Z())) {
    var arg1$1 = this$6.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var tags = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeTagsParser().init___T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(api.id$1, entry$3, this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext()).parse__sc_Seq();
    var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Tags$1;
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(tags, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3.value$2));
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(api, field, value, annotations)
  };
  var this$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$9 = this$8.key__T__s_Option("security");
  if ((!this$9.isEmpty__Z())) {
    var arg1$2 = this$9.get__O();
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Security$1;
    var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4.value$2));
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(api, field$1, value$1, annotations$1);
    this.parseSecurity__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_WebApi__V(entry$4, api)
  };
  var this$12 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("security").asOasExtension__T();
  var this$13 = this$12.key__T__s_Option(keyword);
  if ((!this$13.isEmpty__Z())) {
    var arg1$3 = this$13.get__O();
    var entry$5 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
    this.parseSecurity__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_WebApi__V(entry$5, api)
  };
  var documentations = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$15 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$16 = this$15.key__T__s_Option("externalDocs");
  if ((!this$16.isEmpty__Z())) {
    var arg1$4 = this$16.get__O();
    var entry$6 = $as_Lorg_yaml_model_YMapEntry(arg1$4);
    var array = [new $c_T2().init___O__O(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeCreativeWorkParser().init___Lorg_yaml_model_YNode__T__Lamf_plugins_document_webapi_contexts_WebApiContext(entry$6.value$2, api.id$1, this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext()).parse__Lamf_plugins_domain_shapes_models_CreativeWork(), entry$6)];
    var elems = new $c_sjs_js_WrappedArray().init___sjs_js_Array(array);
    documentations.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(elems)
  };
  var this$21 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T("userDocumentation").asOasExtension__T();
  var this$22 = this$21.key__T__s_Option(keyword$1);
  if ((!this$22.isEmpty__Z())) {
    var arg1$5 = this$22.get__O();
    var entry$7 = $as_Lorg_yaml_model_YMapEntry(arg1$5);
    var this$23 = entry$7.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
    var jsx$2 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UserDocumentationParser().init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser__sc_Seq(this, $as_sc_Seq($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$23, conversion, iv))).parse__sc_Seq();
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, entry$1) {
      return (function(c$2) {
        var c = $as_Lamf_plugins_domain_shapes_models_CreativeWork(c$2);
        return new $c_T2().init___O__O(c, entry$1)
      })
    })(this, entry$7));
    var this$24 = $m_sc_Seq$();
    var xs = $as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$24.ReusableCBFInstance$2));
    documentations.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(xs)
  };
  if (documentations.nonEmpty__Z()) {
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Documentations$1;
    var this$25 = $m_scm_ListBuffer$();
    var bf = this$25.ReusableCBFInstance$2;
    var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(documentations, bf);
    var this$26 = documentations.scala$collection$mutable$ListBuffer$$start$6;
    var these = this$26;
    while ((!these.isEmpty__Z())) {
      var arg1$6 = these.head__O();
      var x$2$2 = $as_T2(arg1$6);
      b.$$plus$eq__O__scm_Builder($as_Lamf_plugins_domain_shapes_models_CreativeWork(x$2$2.$$und1__O()));
      these = $as_sci_List(these.tail__O())
    };
    var values = $as_sc_Seq(b.result__O());
    var jsx$3 = $m_Lamf_core_parser_Annotations$();
    var this$27 = $m_scm_ListBuffer$();
    var bf$1 = this$27.ReusableCBFInstance$2;
    var b$1 = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(documentations, bf$1);
    var this$28 = documentations.scala$collection$mutable$ListBuffer$$start$6;
    var these$1 = this$28;
    while ((!these$1.isEmpty__Z())) {
      var arg1$7 = these$1.head__O();
      var x$3 = $as_T2(arg1$7);
      b$1.$$plus$eq__O__scm_Builder($as_Lorg_yaml_model_YMapEntry(x$3.$$und2__O()));
      these$1 = $as_sci_List(these$1.tail__O())
    };
    var this$29 = $as_scg_TraversableForwarder(b$1.result__O());
    var annotations$2 = jsx$3.apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations($as_Lorg_yaml_model_YPart(this$29.scala$collection$mutable$ListBuffer$$start$6.head__O()));
    $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(api, field$2, values, annotations$2)
  };
  var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("paths");
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var entry$8 = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    this.parseEndpoints__p2__Lamf_plugins_domain_webapi_models_WebApi__Lorg_yaml_model_YMapEntry__V(api, entry$8)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$31 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().MandatoryPathsProperty$1;
      var node = api.id$1;
      var property = $m_s_None$();
      var lexical = $m_s_None$();
      var location = $m_s_None$();
      this$31.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "'paths' is mandatory in OAS spec", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(api, map, $m_sci_Nil$(), this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext()).parse__V();
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(api, map, $m_sci_Nil$(), this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext()).parseOrphanNode__T__V("paths");
  this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().closedShape__T__Lorg_yaml_model_YMap__T__V(api.id$1, map, "webApi");
  return api
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.parseSecurity__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_WebApi__V = (function(entry, api) {
  var this$1 = entry.value$2;
  var x1 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Seq$1;
  if ((x === x1)) {
    var idCounter = new $c_Lamf_core_utils_package$IdCounter().init___();
    var this$2 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
    var jsx$4 = $as_sc_TraversableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv));
    var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, api$1, idCounter$1) {
      return (function(s$2) {
        var s = $as_Lorg_yaml_model_YNode(s$2);
        return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser().init___Lorg_yaml_model_YNode__F1__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(s, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, api$2) {
          return (function(name$2) {
            var name = $as_T(name$2);
            return api$2.withSecurity__T__Lamf_plugins_domain_webapi_models_security_SecurityRequirement(name)
          })
        })($this, api$1)), idCounter$1, $this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext()).parse__s_Option()
      })
    })(this, api, idCounter));
    var this$3 = $m_sc_Seq$();
    var jsx$2 = $as_sc_TraversableLike(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$3.ReusableCBFInstance$2));
    var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser(this);
    var this$4 = $m_sc_Seq$();
    $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2))
  } else {
    var this$6 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext().eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().InvalidSecurityRequirementsSeq$1;
    $m_Lorg_yaml_model_YNode$();
    var node = entry.value$2;
    var iv$1 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
    var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
    var node$1 = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$1, iv$1));
    var property = $m_s_None$();
    var lexical = $m_s_None$();
    var location = $m_s_None$();
    this$6.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node$1, property, "'security' must be an array of security requirement object", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.parseSecuritySchemeDeclarations__Lorg_yaml_model_YMap__T__V = (function(map, parent) {
  this.parseSecuritySchemeDeclarationsFromKey__T__Lorg_yaml_model_YMap__T__V(this.securityKey__T(), map, parent);
  this.parseSecuritySchemeDeclarationsFromKey__T__Lorg_yaml_model_YMap__T__V(new $c_Lamf_core_utils_package$AmfStrings().init___T("securitySchemes").asOasExtension__T(), map, parent)
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser$$anonfun$1.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var s = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(x2.value$2);
    return s
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser$$anonfun$1.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  return (x1 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasDocumentParser$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter() {
  $c_O.call(this);
  this.annotation$1 = null;
  this.ordering$1 = null;
  this.header$1 = null;
  this.emitters$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter.prototype.productPrefix__T = (function() {
  return "AnnotationFragmentEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter.prototype.header__Lamf_core_emitter_EntryEmitter = (function() {
  return this.header$1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var AnnotationFragmentEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter(x$1);
    var x = this.annotation$1;
    var x$2 = AnnotationFragmentEmitter$1.annotation$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = AnnotationFragmentEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.annotation$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter.prototype.emitters__sc_Seq = (function() {
  return this.emitters$1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment__Lamf_core_emitter_SpecOrdering = (function($$outer, annotation, ordering) {
  this.annotation$1 = annotation;
  this.ordering$1 = ordering;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.header$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_parser_OasHeader($$outer, $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$());
  var x1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter($$outer.spec$3.factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory().annotationTypeEmitter__F2().apply__O__O__O($as_Lamf_core_model_domain_extensions_CustomDomainProperty($as_Lamf_core_model_domain_DomainElement(annotation.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))), ordering)).emitters__s_util_Either();
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var list = $as_sc_Seq(x2.value$2);
    var jsx$1 = list
  } else if ((x1 instanceof $c_s_util_Right)) {
    var x3 = $as_s_util_Right(x1);
    var part = $as_Lamf_core_emitter_PartEmitter(x3.value$2);
    var jsx$2 = $m_sc_Seq$();
    var array = [new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", part, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$())];
    var jsx$1 = $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  } else {
    var jsx$1;
    throw new $c_s_MatchError().init___O(x1)
  };
  this.emitters$1 = jsx$1;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$AnnotationFragmentEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$AnnotationFragmentEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$AnnotationFragmentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasFragmentTypeEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$AnnotationFragmentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter() {
  $c_O.call(this);
  this.dataType$1 = null;
  this.ordering$1 = null;
  this.header$1 = null;
  this.emitters$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter.prototype.productPrefix__T = (function() {
  return "DataTypeFragmentEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_model_DataTypeFragment__Lamf_core_emitter_SpecOrdering = (function($$outer, dataType, ordering) {
  this.dataType$1 = dataType;
  this.ordering$1 = ordering;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.header$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_parser_OasHeader($$outer, $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$());
  var x$1 = $as_Lamf_core_model_domain_Shape($as_Lamf_core_model_domain_DomainElement(dataType.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)));
  var x$3 = $as_sc_Seq(dataType.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().References$1));
  var x$4 = $m_sci_Nil$();
  var x$5 = $m_sci_Nil$();
  var x$6 = $m_sci_Nil$();
  this.emitters$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x$1, ordering, x$4, x$3, x$5, x$6, false, $$outer.spec$3).entries__sc_Seq();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter.prototype.header__Lamf_core_emitter_EntryEmitter = (function() {
  return this.header$1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var DataTypeFragmentEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter(x$1);
    var x = this.dataType$1;
    var x$2 = DataTypeFragmentEmitter$1.dataType$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = DataTypeFragmentEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.dataType$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter.prototype.emitters__sc_Seq = (function() {
  return this.emitters$1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$DataTypeFragmentEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$DataTypeFragmentEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$DataTypeFragmentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasFragmentTypeEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DataTypeFragmentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter() {
  $c_O.call(this);
  this.documentationItem$1 = null;
  this.ordering$1 = null;
  this.header$1 = null;
  this.emitters$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter.prototype.productPrefix__T = (function() {
  return "DocumentationItemFragmentEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter.prototype.header__Lamf_core_emitter_EntryEmitter = (function() {
  return this.header$1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var DocumentationItemFragmentEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter(x$1);
    var x = this.documentationItem$1;
    var x$2 = DocumentationItemFragmentEmitter$1.documentationItem$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = DocumentationItemFragmentEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.documentationItem$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter.prototype.emitters__sc_Seq = (function() {
  return this.emitters$1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_model_DocumentationItemFragment__Lamf_core_emitter_SpecOrdering = (function($$outer, documentationItem, ordering) {
  this.documentationItem$1 = documentationItem;
  this.ordering$1 = ordering;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.header$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_parser_OasHeader($$outer, $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$());
  this.emitters$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter().init___Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext($as_Lamf_plugins_domain_shapes_models_CreativeWork($as_Lamf_core_model_domain_DomainElement(documentationItem.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))), ordering, $$outer.spec$3).emitters__sc_Seq();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$DocumentationItemFragmentEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$DocumentationItemFragmentEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$DocumentationItemFragmentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasFragmentTypeEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$DocumentationItemFragmentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter() {
  $c_O.call(this);
  this.namedExample$1 = null;
  this.ordering$1 = null;
  this.header$1 = null;
  this.emitters$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter.prototype.productPrefix__T = (function() {
  return "NamedExampleFragmentEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter.prototype.header__Lamf_core_emitter_EntryEmitter = (function() {
  return this.header$1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var NamedExampleFragmentEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter(x$1);
    var x = this.namedExample$1;
    var x$2 = NamedExampleFragmentEmitter$1.namedExample$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = NamedExampleFragmentEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.namedExample$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter.prototype.emitters__sc_Seq = (function() {
  return this.emitters$1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_model_NamedExampleFragment__Lamf_core_emitter_SpecOrdering = (function($$outer, namedExample, ordering) {
  this.namedExample$1 = namedExample;
  this.ordering$1 = ordering;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.header$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_parser_OasHeader($$outer, $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$());
  var jsx$1 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter().init___Lamf_plugins_domain_shapes_models_Example__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext($as_Lamf_plugins_domain_shapes_models_Example($as_Lamf_core_model_domain_DomainElement(namedExample.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))), ordering, $$outer.spec$3)];
  this.emitters$1 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$NamedExampleFragmentEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$NamedExampleFragmentEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$NamedExampleFragmentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasFragmentTypeEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$NamedExampleFragmentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter() {
  $c_O.call(this);
  this.resourceTypeFragment$1 = null;
  this.ordering$1 = null;
  this.header$1 = null;
  this.emitters$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter.prototype.productPrefix__T = (function() {
  return "ResourceTypeFragmentEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter.prototype.header__Lamf_core_emitter_EntryEmitter = (function() {
  return this.header$1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var ResourceTypeFragmentEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter(x$1);
    var x = this.resourceTypeFragment$1;
    var x$2 = ResourceTypeFragmentEmitter$1.resourceTypeFragment$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = ResourceTypeFragmentEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.resourceTypeFragment$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter.prototype.emitters__sc_Seq = (function() {
  return this.emitters$1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_model_ResourceTypeFragment__Lamf_core_emitter_SpecOrdering__Lamf_core_errorhandling_ErrorHandler = (function($$outer, resourceTypeFragment, ordering, eh) {
  this.resourceTypeFragment$1 = resourceTypeFragment;
  this.ordering$1 = ordering;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.header$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_parser_OasHeader($$outer, $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$());
  var jsx$2 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler($as_Lamf_core_model_domain_templates_AbstractDeclaration($as_Lamf_core_model_domain_DomainElement(resourceTypeFragment.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))).dataNode__Lamf_core_model_domain_DataNode(), ordering, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), eh).emitters__sc_Seq();
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter(this);
  var this$2 = $m_sc_Seq$();
  this.emitters$1 = $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$ResourceTypeFragmentEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$ResourceTypeFragmentEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$ResourceTypeFragmentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasFragmentTypeEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$1.prototype.isDefinedAt__Lamf_core_emitter_EntryEmitter__Z = (function(x1) {
  return true
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$1.prototype.applyOrElse__Lamf_core_emitter_EntryEmitter__F1__O = (function(x1, $default) {
  if ((x1 !== null)) {
    return x1
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Fragment not encoding DataObjectNode but " + x1)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_emitter_EntryEmitter__Z($as_Lamf_core_emitter_EntryEmitter(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_emitter_EntryEmitter__F1__O($as_Lamf_core_emitter_EntryEmitter(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter() {
  $c_O.call(this);
  this.securityScheme$1 = null;
  this.ordering$1 = null;
  this.header$1 = null;
  this.emitters$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.productPrefix__T = (function() {
  return "SecuritySchemeFragmentEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.header__Lamf_core_emitter_EntryEmitter = (function() {
  return this.header$1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var SecuritySchemeFragmentEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter(x$1);
    var x = this.securityScheme$1;
    var x$2 = SecuritySchemeFragmentEmitter$1.securityScheme$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = SecuritySchemeFragmentEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.securityScheme$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.emitters__sc_Seq = (function() {
  return this.emitters$1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_model_SecuritySchemeFragment__Lamf_core_emitter_SpecOrdering = (function($$outer, securityScheme, ordering) {
  this.securityScheme$1 = securityScheme;
  this.ordering$1 = ordering;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.header$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_parser_OasHeader($$outer, $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$());
  var jsx$3 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme($as_Lamf_core_model_domain_DomainElement(securityScheme.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)));
  var jsx$2 = $m_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$();
  var jsx$1 = $$outer.spec$3.vendor__Lamf_core_remote_Vendor();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme($as_Lamf_core_model_domain_DomainElement(securityScheme.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)));
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1));
  var this$3 = this$2.option$1;
  this.emitters$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter().init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(jsx$3, jsx$2.mapsTo__Lamf_core_remote_Vendor__T__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType(jsx$1, $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()))), ordering, $$outer.spec$3).emitters__sc_Seq();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$SecuritySchemeFragmentEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$SecuritySchemeFragmentEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$SecuritySchemeFragmentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasFragmentTypeEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$SecuritySchemeFragmentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter() {
  $c_O.call(this);
  this.traitFragment$1 = null;
  this.ordering$1 = null;
  this.header$1 = null;
  this.emitters$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter.prototype.productPrefix__T = (function() {
  return "TraitFragmentEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter.prototype.header__Lamf_core_emitter_EntryEmitter = (function() {
  return this.header$1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var TraitFragmentEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter(x$1);
    var x = this.traitFragment$1;
    var x$2 = TraitFragmentEmitter$1.traitFragment$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = TraitFragmentEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.traitFragment$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter.prototype.emitters__sc_Seq = (function() {
  return this.emitters$1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_model_TraitFragment__Lamf_core_emitter_SpecOrdering__Lamf_core_errorhandling_ErrorHandler = (function($$outer, traitFragment, ordering, eh) {
  this.traitFragment$1 = traitFragment;
  this.ordering$1 = ordering;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.header$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_parser_OasHeader($$outer, $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$());
  var jsx$2 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler($as_Lamf_core_model_domain_templates_AbstractDeclaration($as_Lamf_core_model_domain_DomainElement(traitFragment.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))).dataNode__Lamf_core_model_domain_DataNode(), ordering, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), eh).emitters__sc_Seq();
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter$$anonfun$2().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter(this);
  var this$2 = $m_sc_Seq$();
  this.emitters$1 = $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$TraitFragmentEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$TraitFragmentEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$TraitFragmentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasFragmentTypeEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter$$anonfun$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter$$anonfun$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter$$anonfun$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter$$anonfun$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter$$anonfun$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter$$anonfun$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter$$anonfun$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter$$anonfun$2.prototype.isDefinedAt__Lamf_core_emitter_EntryEmitter__Z = (function(x1) {
  return true
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter$$anonfun$2.prototype.applyOrElse__Lamf_core_emitter_EntryEmitter__F1__O = (function(x1, $default) {
  if ((x1 !== null)) {
    return x1
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Fragment not encoding DataObjectNode but " + x1)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter$$anonfun$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter$$anonfun$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_emitter_EntryEmitter__Z($as_Lamf_core_emitter_EntryEmitter(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter$$anonfun$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_emitter_EntryEmitter__F1__O($as_Lamf_core_emitter_EntryEmitter(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter$$anonfun$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter$$anonfun$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$TraitFragmentEmitter$$anonfun$2", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter$$anonfun$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter$$anonfun$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$TraitFragmentEmitter$$anonfun$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType.prototype.productPrefix__T = (function() {
  return "OasSecuritySchemeType"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType)) {
    var OasSecuritySchemeType$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType(x$1);
    return (this.text$1 === OasSecuritySchemeType$1.text$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.text$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType.prototype.text__T = (function() {
  return this.text$1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType.prototype.init___T = (function(text) {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType.prototype.init___T.call(this, text);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasSecuritySchemeType"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasSecuritySchemeType;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasSecuritySchemeType", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasSecuritySchemeType;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_document_BaseUnit__Z($as_Lamf_core_model_document_BaseUnit(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O($as_Lamf_core_model_document_BaseUnit(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$1.prototype.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_model_document_Module)) {
    var x2 = $as_Lamf_core_model_document_Module(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$1.prototype.isDefinedAt__Lamf_core_model_document_BaseUnit__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_core_model_document_Module)
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasSpecEmitter$ReferencesEmitter$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$2.prototype.applyOrElse__s_Option__F1__O = (function(x2, $default) {
  if ((x2 instanceof $c_s_Some)) {
    var x2$2 = $as_s_Some(x2);
    var e = $as_Lamf_core_emitter_EntryEmitter(x2$2.value$2);
    return e
  } else {
    return $default.apply__O__O(x2)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$2.prototype.isDefinedAt__s_Option__Z = (function(x2) {
  return (x2 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasSpecEmitter$ReferencesEmitter$$anonfun$2", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType();
$c_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType.prototype.productPrefix__T = (function() {
  return "UnknownSecuritySchemeType"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType)) {
    var UnknownSecuritySchemeType$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType(x$1);
    return (this.text$1 === UnknownSecuritySchemeType$1.text$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.text$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType.prototype.text__T = (function() {
  return this.text$1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType.prototype.init___T = (function(text) {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType.prototype.init___T.call(this, text);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.UnknownSecuritySchemeType"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.UnknownSecuritySchemeType;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.UnknownSecuritySchemeType", {
  Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_UnknownSecuritySchemeType;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter.call(this);
  this.securityScheme$2 = null;
  this.mappedType$2 = null;
  this.ordering$2 = null;
  this.httpSchemaMappings$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter.prototype.productPrefix__T = (function() {
  return "Oas3SecuritySchemeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter)) {
    var Oas3SecuritySchemeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter(x$1);
    var x = this.securityScheme$2;
    var x$2 = Oas3SecuritySchemeEmitter$1.securityScheme$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.mappedType$2;
      var x$4 = Oas3SecuritySchemeEmitter$1.mappedType$2;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.ordering$2;
      var x$6 = Oas3SecuritySchemeEmitter$1.ordering$2;
      return (x$5 === x$6)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.securityScheme$2;
      break
    }
    case 1: {
      return this.mappedType$2;
      break
    }
    case 2: {
      return this.ordering$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(securityScheme, mappedType, ordering, spec) {
  this.securityScheme$2 = securityScheme;
  this.mappedType$2 = mappedType;
  this.ordering$2 = ordering;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.call(this, securityScheme, mappedType, ordering, spec);
  var array = [new $c_T2().init___O__O("Basic Authentication", "basic"), new $c_T2().init___O__O("Digest Authentication", "digest")];
  var this$8 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$8.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  this.httpSchemaMappings$2 = $as_sci_Map(this$8.elems$1);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter.prototype.emitSettings__scm_ListBuffer__Lamf_core_parser_Fields__V = (function(results, fs) {
  var this$1 = this.securityScheme$2;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1));
  var this$3 = this$2.option$1;
  var schemaType = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
  if (this.httpSchemaMappings$2.contains__O__Z(schemaType)) {
    var this$4 = this.securityScheme$2.withHttpSettings__Lamf_plugins_domain_webapi_models_security_HttpSettings();
    var scheme = $as_T(this.httpSchemaMappings$2.getOrElse__O__F0__O(schemaType, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
      return (function() {
        return ""
      })
    })(this))));
    var field = $m_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$().Scheme$1;
    $as_Lamf_plugins_domain_webapi_models_security_HttpSettings($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, scheme))
  };
  $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter.prototype.emitSettings__scm_ListBuffer__Lamf_core_parser_Fields__V.call(this, results, fs)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.Oas3SecuritySchemeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.Oas3SecuritySchemeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.Oas3SecuritySchemeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemeEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters$$anonfun$emitters$9() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters$$anonfun$emitters$9.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters$$anonfun$emitters$9.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters$$anonfun$emitters$9;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters$$anonfun$emitters$9() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters$$anonfun$emitters$9.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters$$anonfun$emitters$9.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters$$anonfun$emitters$9.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_security_Scope)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters$$anonfun$emitters$9.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters$$anonfun$emitters$9.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_security_Scope)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_security_Scope(x1);
    var this$1 = $as_Lamf_core_model_StrField(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Name$1));
    var this$2 = this$1.option$1;
    var jsx$1 = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
    var this$3 = $as_Lamf_core_model_StrField(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Description$1));
    var this$4 = this$3.option$1;
    return new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position(jsx$1, $as_T((this$4.isEmpty__Z() ? null : this$4.get__O())), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$())
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters$$anonfun$emitters$9.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters$$anonfun$emitters$9.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters$$anonfun$emitters$9 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters$$anonfun$emitters$9: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasScopeValuesEmitters$$anonfun$emitters$9", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters$$anonfun$emitters$9: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters$$anonfun$emitters$9.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters$$anonfun$emitters$9;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter$$anonfun$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_shapes_models_CreativeWork)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter$$anonfun$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_CreativeWork)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_CreativeWork(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.UserDocumentationsEmitter$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_UserDocumentationsEmitter$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$$anonfun$getParent$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$$anonfun$getParent$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$$anonfun$getParent$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$$anonfun$getParent$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$$anonfun$getParent$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$$anonfun$getParent$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$$anonfun$getParent$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$$anonfun$getParent$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$$anonfun$getParent$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_document_BaseUnit__Z($as_Lamf_core_model_document_BaseUnit(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$$anonfun$getParent$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O($as_Lamf_core_model_document_BaseUnit(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$$anonfun$getParent$2.prototype.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O = (function(x1, $default) {
  return (((x1 instanceof $c_Lamf_core_model_document_ExtensionLike) || (x1 instanceof $c_Lamf_core_model_document_Document)) ? x1 : $default.apply__O__O(x1))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$$anonfun$getParent$2.prototype.isDefinedAt__Lamf_core_model_document_BaseUnit__Z = (function(x1) {
  return ((x1 instanceof $c_Lamf_core_model_document_ExtensionLike) || (x1 instanceof $c_Lamf_core_model_document_Document))
});
var $d_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$$anonfun$getParent$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$$anonfun$getParent$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.ExtensionLikeParser$$anonfun$getParent$2", {
  Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$$anonfun$getParent$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$$anonfun$getParent$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$$anonfun$getParent$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters() {
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters.call(this);
  this.document$2 = null;
  this.ordering$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters();
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters.prototype.productPrefix__T = (function() {
  return "Raml08RootLevelEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(document, ordering, spec) {
  this.document$2 = document;
  this.ordering$2 = ordering;
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this, document, ordering, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters)) {
    var Raml08RootLevelEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters(x$1);
    var x = this.document$2;
    var x$2 = Raml08RootLevelEmitters$1.document$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = Raml08RootLevelEmitters$1.ordering$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.document$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters.prototype.emitters__sc_Seq = (function() {
  return this.declarationsEmitter__sc_Seq()
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters.prototype.declarationsEmitter__sc_Seq = (function() {
  var declarations = $m_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$().apply__sc_Seq__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations($as_Lamf_core_model_document_DeclaresModel(this.document$2).declares__sc_Seq(), $m_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$(), new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___());
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = declarations.shapes$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$2)) {
    var this$3 = this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory();
    var jsx$1 = $f_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory__declaredTypesEmitter__F3(this$3);
    var this$4 = declarations.shapes$2;
    var this$5 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$4);
    result.$$plus$eq__O__scm_ListBuffer(jsx$1.apply__O__O__O__O(this$5.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), this.document$2.references__sc_Seq(), this.ordering$2))
  };
  var this$6 = declarations.resourceTypes$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$6)) {
    var this$7 = declarations.resourceTypes$2;
    var this$8 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$7);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("resourceTypes", this$8.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), this.ordering$2, this.document$2.references__sc_Seq(), this.spec$1))
  };
  var this$9 = declarations.traits$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$9)) {
    var this$10 = declarations.traits$2;
    var this$11 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$10);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("traits", this$11.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), this.ordering$2, this.document$2.references__sc_Seq(), this.spec$1))
  };
  var this$12 = declarations.securitySchemes$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$12)) {
    var this$13 = declarations.securitySchemes$2;
    var this$14 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$13);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters().init___sc_Seq__sc_Seq__Lamf_core_emitter_SpecOrdering__F3__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this$14.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), this.document$2.references__sc_Seq(), this.ordering$2, this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory().namedSecurityEmitter__F3(), this.spec$1))
  };
  var this$15 = declarations.responses$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$15)) {
    var jsx$5 = new $c_Lamf_core_utils_package$AmfStrings().init___T("responses").asRamlAnnotation__T();
    var this$17 = declarations.responses$2;
    var this$18 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$17);
    var jsx$4 = this$18.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream();
    var jsx$3 = this.ordering$2;
    var jsx$2 = this.document$2.references__sc_Seq();
    var spec = this.spec$1;
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(jsx$5, jsx$4, jsx$3, jsx$2, new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(spec.eh$1, spec.refEmitter$1, new $c_Lamf_core_emitter_ShapeRenderOptions().init___())))
  };
  return result
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.Raml08RootLevelEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.Raml08RootLevelEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.Raml08RootLevelEmitters", {
  Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_Raml08RootLevelEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters() {
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters.call(this);
  this.AnnotationsTypesEmitter$module$2 = null;
  this.NamedPropertyTypeEmitter$module$2 = null;
  this.NamedParameterEmitter$module$2 = null;
  this.document$2 = null;
  this.ordering$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters();
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters.prototype.productPrefix__T = (function() {
  return "Raml10RootLevelEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters.prototype.extensionEmitter__s_Option = (function() {
  var this$1 = this.document$2.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_document_ExtensionLikeModel$().Extends$1);
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    var x$2 = $as_Lamf_core_model_domain_AmfScalar(f.value$1.value$1).toString__T();
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = f.value$1.annotations$1;
    var x$3 = this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
    return new $c_s_Some().init___O(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("extends", x$2, x$4, x$3))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(document, ordering, spec) {
  this.document$2 = document;
  this.ordering$2 = ordering;
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this, document, ordering, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters)) {
    var Raml10RootLevelEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters(x$1);
    var x = this.document$2;
    var x$2 = Raml10RootLevelEmitters$1.document$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = Raml10RootLevelEmitters$1.ordering$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.document$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters.prototype.emitters__sc_Seq = (function() {
  var declares = this.declarationsEmitter__sc_Seq();
  var references = new $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter().init___Lamf_core_model_document_BaseUnit__Lamf_core_emitter_SpecOrdering(this.document$2, this.ordering$2);
  var extension = this.extensionEmitter__s_Option();
  var this$1 = this.document$2.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_document_BaseUnitModel$().Usage$1);
  if (this$1.isEmpty__Z()) {
    var usage = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    var usage = new $c_s_Some().init___O(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("usage", f, $m_s_None$()))
  };
  var jsx$4 = extension.toList__sci_List();
  var this$4 = $m_sc_Seq$();
  var jsx$3 = $as_sc_TraversableLike(declares.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$4.ReusableCBFInstance$2));
  var jsx$2 = usage.toList__sci_List();
  var this$6 = $m_sc_Seq$();
  var jsx$1 = $as_sc_SeqLike(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$6.ReusableCBFInstance$2));
  var this$7 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$1.$$colon$plus__O__scg_CanBuildFrom__O(references, this$7.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters.prototype.declarationsEmitter__sc_Seq = (function() {
  var declarations = $m_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$().apply__sc_Seq__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations($as_Lamf_core_model_document_DeclaresModel(this.document$2).declares__sc_Seq(), $m_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$(), new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___());
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = declarations.shapes$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$2)) {
    var this$3 = this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory();
    var jsx$1 = $f_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory__declaredTypesEmitter__F3(this$3);
    var this$4 = declarations.shapes$2;
    var this$5 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$4);
    result.$$plus$eq__O__scm_ListBuffer(jsx$1.apply__O__O__O__O(this$5.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), this.document$2.references__sc_Seq(), this.ordering$2))
  };
  var this$6 = declarations.annotations$1;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$6)) {
    var this$7 = declarations.annotations$1;
    var this$8 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$7);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter().init___Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters__sc_Seq__sc_Seq__Lamf_core_emitter_SpecOrdering(this, this$8.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), this.document$2.references__sc_Seq(), this.ordering$2))
  };
  var this$9 = declarations.resourceTypes$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$9)) {
    var this$10 = declarations.resourceTypes$2;
    var this$11 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$10);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("resourceTypes", this$11.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), this.ordering$2, this.document$2.references__sc_Seq(), this.spec$1))
  };
  var this$12 = declarations.traits$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$12)) {
    var this$13 = declarations.traits$2;
    var this$14 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$13);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("traits", this$14.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), this.ordering$2, this.document$2.references__sc_Seq(), this.spec$1))
  };
  var this$15 = declarations.securitySchemes$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$15)) {
    var this$16 = declarations.securitySchemes$2;
    var this$17 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$16);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters().init___sc_Seq__sc_Seq__Lamf_core_emitter_SpecOrdering__F3__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this$17.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), this.document$2.references__sc_Seq(), this.ordering$2, this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory().namedSecurityEmitter__F3(), this.spec$1))
  };
  var this$18 = declarations.parameters$2;
  var this$20 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$18);
  var this$19 = $m_sc_Iterable$();
  var bf = this$19.ReusableCBFInstance$2;
  var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$20, bf);
  var this$21 = this$20.$$outer$3.valuesIterator__sc_Iterator();
  while (this$21.hasNext__Z()) {
    var arg1 = this$21.next__O();
    var x$2 = $as_Lamf_plugins_domain_webapi_models_Parameter(arg1);
    b.$$plus$eq__O__scm_Builder($m_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$().apply__Lamf_plugins_domain_webapi_models_Parameter__s_Option__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(x$2, $m_s_None$()))
  };
  var jsx$3 = $as_sc_TraversableLike(b.result__O());
  var this$23 = declarations.payloads$2;
  var this$25 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$23);
  var this$24 = $m_sc_Iterable$();
  var bf$1 = this$24.ReusableCBFInstance$2;
  var b$1 = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$25, bf$1);
  var this$26 = this$25.$$outer$3.valuesIterator__sc_Iterator();
  while (this$26.hasNext__Z()) {
    var arg1$1 = this$26.next__O();
    var x$3 = $as_Lamf_plugins_domain_webapi_models_Payload(arg1$1);
    b$1.$$plus$eq__O__scm_Builder($m_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$().apply__Lamf_plugins_domain_webapi_models_Payload__s_Option__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(x$3, $m_s_None$()))
  };
  var jsx$2 = $as_sc_GenTraversableOnce(b$1.result__O());
  var this$28 = $m_sc_Iterable$();
  var oasParams = $as_sc_Iterable(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$28.ReusableCBFInstance$2));
  if (oasParams.nonEmpty__Z()) {
    var jsx$7 = oasParams.toSeq__sc_Seq();
    var jsx$6 = this.ordering$2;
    var jsx$5 = this.document$2.references__sc_Seq();
    var jsx$4 = new $c_Lamf_core_utils_package$AmfStrings().init___T("parameters").asRamlAnnotation__T();
    var spec = this.spec$1;
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__T__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(jsx$7, jsx$6, jsx$5, jsx$4, new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(spec.eh$1, spec.refEmitter$1, new $c_Lamf_core_emitter_ShapeRenderOptions().init___())))
  };
  var this$33 = declarations.responses$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$33)) {
    var jsx$11 = new $c_Lamf_core_utils_package$AmfStrings().init___T("responses").asRamlAnnotation__T();
    var this$35 = declarations.responses$2;
    var this$36 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$35);
    var jsx$10 = this$36.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream();
    var jsx$9 = this.ordering$2;
    var jsx$8 = this.document$2.references__sc_Seq();
    var spec$1 = this.spec$1;
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(jsx$11, jsx$10, jsx$9, jsx$8, new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(spec$1.eh$1, spec$1.refEmitter$1, new $c_Lamf_core_emitter_ShapeRenderOptions().init___())))
  };
  return result
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.Raml10RootLevelEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.Raml10RootLevelEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.Raml10RootLevelEmitters", {
  Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlRootLevelEmitters: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.call(this);
  this.ctx$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser.prototype.init___Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(ctx) {
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.prototype.init___Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser.prototype.parseTypeDeclarations__p2__Lorg_yaml_model_YMap__T__V = (function(map, parent) {
  var this$1 = this.typeOrSchema__Lorg_yaml_model_YMap__s_Option(map);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$2 = e.value$2;
    var x1 = this$2.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x === x1)) {
      var this$3 = e.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = this.ctx$2;
      $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$3) {
        return (function(entry$2) {
          var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
          var this$4 = entry.key$2;
          var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
          var iv$1 = $this.ctx$2;
          var typeName = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion$1, iv$1)).text$3;
          if ($f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax__wellKnownType__T__Z__Z($this, typeName, false)) {
            var this$5 = $this.ctx$2.eh$1;
            var specification = $m_Lamf_validations_ParserSideValidations$().InvalidTypeDefinition$1;
            var message = (("'" + typeName) + "' cannot be used to name a custom type");
            var ast = entry.key$2;
            var prop = $m_s_None$();
            var l = ast.location$1;
            $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$5, specification, parent$3, prop, message, l)
          };
          var parser = $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, typeName$1, entry$1, parent$3$1) {
            return (function(shape$2) {
              var shape = $as_Lamf_core_model_domain_Shape(shape$2);
              var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Name$1;
              var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(typeName$1, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$1.key$2.value__Lorg_yaml_model_YValue()));
              var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$1.key$2);
              $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(shape, field, value, annotations);
              shape.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(parent$3$1, shape.adopted$default$2__sc_Seq())
            })
          })($this, typeName, entry, parent$3)), new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo().init___Z__Z(false, false), $m_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$(), $this.ctx$2);
          var x1$1 = parser.parse__s_Option();
          if ((x1$1 instanceof $c_s_Some)) {
            var x2 = $as_s_Some(x1$1);
            var shape$3 = $as_Lamf_core_model_domain_Shape(x2.value$2);
            var this$8 = entry.value$2;
            var x$1 = this$8.tag__Lorg_yaml_model_YTag().tagType$3;
            var x$2 = $m_Lorg_yaml_model_YType$().Null$1;
            if ((x$1 === x$2)) {
              shape$3.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SynthesizedField().init___())
            };
            var jsx$1 = $this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations();
            var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
            return jsx$1.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(shape$3, annotation)))
          } else {
            var x$3 = $m_s_None$();
            if ((x$3 === x1$1)) {
              var this$9 = $this.ctx$2.eh$1;
              var specification$1 = $m_Lamf_validations_ParserSideValidations$().UnableToParseShape$1;
              var message$1 = (("Error parsing shape '" + entry) + "'");
              var prop$1 = $m_s_None$();
              var l$1 = entry.location$1;
              $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$9, specification$1, parent$3, prop$1, message$1, l$1);
              return (void 0)
            } else {
              throw new $c_s_MatchError().init___O(x1$1)
            }
          }
        })
      })(this, parent)))
    } else {
      var x$3$1 = $m_Lorg_yaml_model_YType$().Null$1;
      if ((!(x$3$1 === x1))) {
        var this$10 = this.ctx$2.eh$1;
        var specification$2 = $m_Lamf_validations_ParserSideValidations$().InvalidTypesType$1;
        var message$2 = (("Invalid type " + x1) + " for 'types' node.");
        var ast$1 = e.value$2;
        var prop$2 = $m_s_None$();
        var l$2 = ast$1.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$10, specification$2, parent, prop$2, message$2, l$2)
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser.prototype.parseResponsesDeclarations__T__Lorg_yaml_model_YMap__T__V = (function(key, map, parentPath) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option(key);
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$2;
    $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parentPath$1) {
      return (function(e$2) {
        var e = $as_Lorg_yaml_model_YMapEntry(e$2);
        var node = e.key$2;
        var iv$1 = $this.ctx$2;
        var this$6 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv$1);
        var node$1 = this$6.text__Lamf_core_model_domain_AmfScalar();
        var this$7 = e.value$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv$2 = $this.ctx$2;
        var res = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseParser().init___Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$7, conversion$1, iv$2)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, node$2, parentPath$1$1, e$1) {
          return (function(r$2) {
            var r = $as_Lamf_plugins_domain_webapi_models_Response(r$2);
            var field = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Name$1;
            var qual$1 = $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(r, field, node$2));
            $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
            $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, parentPath$1$1);
            r.annotations$2.$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations($m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(e$1))
          })
        })($this, node$1, parentPath$1, e)), $m_Lamf_plugins_document_webapi_parser_spec_package$().toOas__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($this.ctx$2)).parse__Lamf_plugins_domain_webapi_models_Response();
        var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
        $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(res, annotation);
        return $this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(res)
      })
    })(this, parentPath)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser.prototype.parseDeclarations__Lamf_core_Root__Lorg_yaml_model_YMap__V = (function(root, map) {
  var parent = (root.location$1 + "#/declarations");
  this.parseAnnotationTypeDeclarations__Lorg_yaml_model_YMap__T__V(map, (parent + "/annotations"));
  this.parseTypeDeclarations__p2__Lorg_yaml_model_YMap__T__V(map, (parent + "/types"));
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser().init___T__F1__Lorg_yaml_model_YMap__T__Lamf_plugins_document_webapi_contexts_WebApiContext("traits", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$1) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var qual$1 = $m_Lamf_plugins_domain_webapi_models_templates_Trait$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_templates_Trait(entry);
      var this$1 = entry.key$2;
      var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv = $this.ctx$2;
      var x$1 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3;
      $m_Lamf_core_parser_Annotations$();
      var x$2 = new $c_Lamf_core_parser_Annotations().init___();
      var jsx$1 = $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, x$1, x$2);
      var this$3 = entry.key$2;
      var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$1 = $this.ctx$2;
      var str = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion$1, iv$1)).text$3;
      var this$5 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
      var this$6 = this$5.platform$1;
      var url = this$5.str$1;
      return $as_Lamf_plugins_domain_webapi_models_templates_Trait(jsx$1.withId__T__Lamf_core_model_domain_AmfObject(((parent$1 + "/traits/") + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$6, url))))
    })
  })(this, parent)), map, (parent + "/traits"), this.ctx$2).parse__V();
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser().init___T__F1__Lorg_yaml_model_YMap__T__Lamf_plugins_document_webapi_contexts_WebApiContext("resourceTypes", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, parent$2) {
    return (function(entry$3$2) {
      var entry$3 = $as_Lorg_yaml_model_YMapEntry(entry$3$2);
      var qual$2 = $m_Lamf_plugins_domain_webapi_models_templates_ResourceType$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_templates_ResourceType(entry$3);
      var this$7 = entry$3.key$2;
      var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$2 = this$2$1.ctx$2;
      var x$3 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$7, conversion$2, iv$2)).text$3;
      $m_Lamf_core_parser_Annotations$();
      var x$4 = new $c_Lamf_core_parser_Annotations().init___();
      var jsx$2 = $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$2, x$3, x$4);
      var this$9 = entry$3.key$2;
      var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$3 = this$2$1.ctx$2;
      var str$1 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$9, conversion$3, iv$3)).text$3;
      var this$11 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str$1);
      var this$12 = this$11.platform$1;
      var url$1 = this$11.str$1;
      return $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(jsx$2.withId__T__Lamf_core_model_domain_AmfObject(((parent$2 + "/resourceTypes/") + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$12, url$1))))
    })
  })(this, parent)), map, (parent + "/resourceTypes"), this.ctx$2).parse__V();
  this.parseSecuritySchemeDeclarations__Lorg_yaml_model_YMap__T__V(map, (parent + "/securitySchemes"));
  this.parseParameterDeclarations__T__Lorg_yaml_model_YMap__T__V(new $c_Lamf_core_utils_package$AmfStrings().init___T("parameters").asRamlAnnotation__T(), map, (root.location$1 + "#/parameters"));
  this.parseResponsesDeclarations__T__Lorg_yaml_model_YMap__T__V(new $c_Lamf_core_utils_package$AmfStrings().init___T("responses").asRamlAnnotation__T(), map, (root.location$1 + "#/responses"))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser.prototype.parseParameterDeclarations__T__Lorg_yaml_model_YMap__T__V = (function(key, map, parentPath) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option(key);
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$2;
    $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parentPath$2) {
      return (function(e$2) {
        var e = $as_Lorg_yaml_model_YMapEntry(e$2);
        var typeName = e.key$2;
        var nameGenerator = new $c_Lamf_core_utils_package$IdCounter().init___();
        var this$5 = e.value$2;
        var evidence$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var x1 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$5, evidence$2);
        if ((x1 instanceof $c_s_util_Right)) {
          var oasParameter = new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser().init___s_util_Either__T__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_WebApiContext(($m_s_package$(), new $c_s_util_Left().init___O(e)), parentPath$2, new $c_s_Some().init___O(typeName), nameGenerator, $m_Lamf_plugins_document_webapi_parser_spec_package$().toOas__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($this.ctx$2)).parse__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter()
        } else {
          $m_s_package$();
          $m_Lorg_yaml_model_YNode$();
          var map$1 = $m_Lorg_yaml_model_YMap$().empty$1;
          $m_Lorg_yaml_model_YNode$();
          var value = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map$1, $m_Lorg_yaml_model_YType$().Map$1);
          var parameter = new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser().init___s_util_Either__T__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_WebApiContext(new $c_s_util_Right().init___O(value), parentPath$2, new $c_s_Some().init___O(typeName), nameGenerator, $m_Lamf_plugins_document_webapi_parser_spec_package$().toOas__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($this.ctx$2)).parse__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter();
          var this$10 = $this.ctx$2.eh$1;
          var specification = $m_Lamf_validations_ParserSideValidations$().InvalidParameterType$1;
          var node = parameter.domainElement$1.id__T();
          var prop = $m_s_None$();
          var l = e.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$10, specification, node, prop, "Map needed to parse a parameter declaration", l);
          var oasParameter = parameter
        };
        $this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().registerOasParameter__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter__V(oasParameter)
      })
    })(this, parentPath)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser.prototype.typeOrSchema__Lorg_yaml_model_YMap__s_Option = (function(map) {
  var types = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("types");
  var schemas = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("schemas");
  if ((!types.isEmpty__Z())) {
    var arg1 = types.get__O();
    $as_Lorg_yaml_model_YMapEntry(arg1);
    if ((!schemas.isEmpty__Z())) {
      var arg1$1 = schemas.get__O();
      var s = $as_Lorg_yaml_model_YMapEntry(arg1$1);
      var this$3 = this.ctx$2.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().ExclusiveSchemasType$1;
      var ast = s.key$2;
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$3, specification, "", prop, "'schemas' and 'types' properties are mutually exclusive", l)
    }
  };
  if ((!schemas.isEmpty__Z())) {
    var arg1$2 = schemas.get__O();
    var s$1 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var this$4 = this.ctx$2.eh$1;
    var specification$1 = $m_Lamf_validations_ParserSideValidations$().SchemasDeprecated$1;
    var ast$1 = s$1.key$2;
    var property = $m_s_None$();
    var location = ast$1.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$4, specification$1, "", property, "'schemas' keyword it's deprecated for 1.0 version, should use 'types' instead", location)
  };
  return (types.isEmpty__Z() ? schemas : types)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser.prototype.parseAnnotationTypeDeclarations__Lorg_yaml_model_YMap__T__V = (function(map, customProperties) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("annotationTypes");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = e.value$2;
    var x1 = this$4.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x === x1)) {
      var this$5 = e.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = this.ctx$2;
      var jsx$3 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv)).entries$3;
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, customProperties$1) {
        return (function(entry$2) {
          var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
          var this$6 = entry.key$2;
          var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
          var iv$1 = $this.ctx$2;
          var typeName = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion$1, iv$1)).text$3;
          var customProperty$3 = $this.AnnotationTypesParser__Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$AnnotationTypesParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_core_model_domain_extensions_CustomDomainProperty(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, typeName$1, entry$1, customProperties$1$1) {
            return (function(customProperty$2) {
              var customProperty = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(customProperty$2);
              var field = $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Name$1;
              var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(typeName$1, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$1.key$2.value__Lorg_yaml_model_YValue()));
              var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$1.key$2);
              $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(customProperty, field, value, annotations);
              customProperty.adopted__T__sc_Seq__Lamf_core_model_domain_extensions_CustomDomainProperty(customProperties$1$1, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())))
            })
          })($this, typeName, entry, customProperties$1)));
          var jsx$2 = $this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations();
          var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
          return jsx$2.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(customProperty$3, annotation)))
        })
      })(this, customProperties));
      var this$7 = $m_sc_IndexedSeq$();
      jsx$3.map__F1__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBF$6)
    } else {
      var x$3 = $m_Lorg_yaml_model_YType$().Null$1;
      if ((!(x$3 === x1))) {
        var this$8 = this.ctx$2.eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().InvalidAnnotationType$1;
        var message = (("Invalid type " + x1) + " for 'annotationTypes' node.");
        var ast = e.value$2;
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$8, specification, customProperties, prop, message, l)
      }
    }
  }
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter() {
  $c_O.call(this);
  this.annotation$1 = null;
  this.ordering$1 = null;
  this.header$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter.prototype.productPrefix__T = (function() {
  return "AnnotationFragmentEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter__Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment__Lamf_core_emitter_SpecOrdering = (function($$outer, annotation, ordering) {
  this.annotation$1 = annotation;
  this.ordering$1 = ordering;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.header$1 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var AnnotationFragmentEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter(x$1);
    var x = this.annotation$1;
    var x$2 = AnnotationFragmentEmitter$1.annotation$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = AnnotationFragmentEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.annotation$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter.prototype.header__Lamf_plugins_document_webapi_parser_RamlHeader = (function() {
  return this.header$1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter.prototype.emitters__sc_Seq__sc_Seq = (function(references) {
  var jsx$1 = this.$$outer$1.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory().annotationTypeEmitter__F2();
  var this$1 = this.annotation$1;
  var x1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter(jsx$1.apply__O__O__O($as_Lamf_core_model_domain_extensions_CustomDomainProperty($as_Lamf_core_model_domain_DomainElement(this$1.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))), this.ordering$1)).emitters__s_util_Either();
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var emitters = $as_sc_Seq(x2.value$2);
    return emitters
  } else if ((x1 instanceof $c_s_util_Right)) {
    var x3 = $as_s_util_Right(x1);
    var part = $as_Lamf_core_emitter_PartEmitter(x3.value$2);
    var jsx$2 = $m_sc_Seq$();
    var array = [new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", part, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$())];
    return $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$AnnotationFragmentEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$AnnotationFragmentEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$AnnotationFragmentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$RamlFragmentTypeEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$AnnotationFragmentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter() {
  $c_O.call(this);
  this.dataType$1 = null;
  this.ordering$1 = null;
  this.header$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter.prototype.productPrefix__T = (function() {
  return "DataTypeFragmentEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var DataTypeFragmentEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter(x$1);
    var x = this.dataType$1;
    var x$2 = DataTypeFragmentEmitter$1.dataType$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = DataTypeFragmentEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.dataType$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter__Lamf_plugins_document_webapi_model_DataTypeFragment__Lamf_core_emitter_SpecOrdering = (function($$outer, dataType, ordering) {
  this.dataType$1 = dataType;
  this.ordering$1 = ordering;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.header$1 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter.prototype.header__Lamf_plugins_document_webapi_parser_RamlHeader = (function() {
  return this.header$1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter.prototype.emitters__sc_Seq__sc_Seq = (function(references) {
  var rc6 = false;
  var x2 = null;
  var jsx$1 = $m_s_Option$();
  var this$1 = this.dataType$1;
  var x1 = jsx$1.apply__O__s_Option($as_Lamf_core_model_domain_Shape($as_Lamf_core_model_domain_DomainElement(this$1.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))));
  if ((x1 instanceof $c_s_Some)) {
    rc6 = true;
    x2 = $as_s_Some(x1);
    var shape = $as_Lamf_core_model_domain_Shape(x2.value$2);
    if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
      var x4 = $as_Lamf_plugins_domain_shapes_models_AnyShape(shape);
      var x$2 = this.ordering$1;
      var x$3 = $m_sci_Nil$();
      var x$4 = $m_sci_Nil$();
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x4, x$2, x$4, x$3, false, this.$$outer$1.spec$1).entries__sc_Seq()
    }
  };
  if (rc6) {
    var other = $as_Lamf_core_model_domain_Shape(x2.value$2);
    var this$3 = this.$$outer$1.spec$1;
    var this$4 = this$3.eh$1;
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
    var node = other.id$1;
    var property = $m_s_None$();
    var lexical = other.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var location = other.location__s_Option();
    this$4.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "Cannot emit non WebApi Shape", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
    return $m_sci_Nil$()
  };
  return $m_sci_Nil$()
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$DataTypeFragmentEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$DataTypeFragmentEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$DataTypeFragmentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$RamlFragmentTypeEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DataTypeFragmentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter() {
  $c_O.call(this);
  this.documentationItem$1 = null;
  this.ordering$1 = null;
  this.header$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter.prototype.productPrefix__T = (function() {
  return "DocumentationItemFragmentEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var DocumentationItemFragmentEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter(x$1);
    var x = this.documentationItem$1;
    var x$2 = DocumentationItemFragmentEmitter$1.documentationItem$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = DocumentationItemFragmentEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.documentationItem$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter.prototype.header__Lamf_plugins_document_webapi_parser_RamlHeader = (function() {
  return this.header$1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter.prototype.emitters__sc_Seq__sc_Seq = (function(references) {
  var this$1 = this.documentationItem$1;
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter().init___Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Z__Lamf_plugins_document_webapi_contexts_SpecEmitterContext($as_Lamf_plugins_domain_shapes_models_CreativeWork($as_Lamf_core_model_domain_DomainElement(this$1.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))), this.ordering$1, true, this.$$outer$1.spec$1).emitters__sc_Seq()
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter__Lamf_plugins_document_webapi_model_DocumentationItemFragment__Lamf_core_emitter_SpecOrdering = (function($$outer, documentationItem, ordering) {
  this.documentationItem$1 = documentationItem;
  this.ordering$1 = ordering;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.header$1 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$DocumentationItemFragmentEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$DocumentationItemFragmentEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$DocumentationItemFragmentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$RamlFragmentTypeEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$DocumentationItemFragmentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter() {
  $c_O.call(this);
  this.example$1 = null;
  this.ordering$1 = null;
  this.header$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter.prototype.productPrefix__T = (function() {
  return "FragmentNamedExampleEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var FragmentNamedExampleEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter(x$1);
    var x = this.example$1;
    var x$2 = FragmentNamedExampleEmitter$1.example$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = FragmentNamedExampleEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.example$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter__Lamf_plugins_document_webapi_model_NamedExampleFragment__Lamf_core_emitter_SpecOrdering = (function($$outer, example, ordering) {
  this.example$1 = example;
  this.ordering$1 = ordering;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.header$1 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter.prototype.header__Lamf_plugins_document_webapi_parser_RamlHeader = (function() {
  return this.header$1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter.prototype.emitters__sc_Seq__sc_Seq = (function(references) {
  var jsx$1 = $m_sc_Seq$();
  var this$1 = this.example$1;
  var array = [new $c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter().init___Lamf_plugins_domain_shapes_models_Example__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext($as_Lamf_plugins_domain_shapes_models_Example($as_Lamf_core_model_domain_DomainElement(this$1.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))), this.ordering$1, this.$$outer$1.spec$1)];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$FragmentNamedExampleEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$FragmentNamedExampleEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$FragmentNamedExampleEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$RamlFragmentTypeEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$FragmentNamedExampleEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter() {
  $c_O.call(this);
  this.fragment$1 = null;
  this.ordering$1 = null;
  this.eh$1 = null;
  this.header$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter.prototype.productPrefix__T = (function() {
  return "ResourceTypeFragmentEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var ResourceTypeFragmentEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter(x$1);
    var x = this.fragment$1;
    var x$2 = ResourceTypeFragmentEmitter$1.fragment$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = ResourceTypeFragmentEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fragment$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter.prototype.header__Lamf_plugins_document_webapi_parser_RamlHeader = (function() {
  return this.header$1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter.prototype.emitters__sc_Seq__sc_Seq = (function(references) {
  var this$1 = this.fragment$1;
  var jsx$2 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler($as_Lamf_core_model_domain_templates_AbstractDeclaration($as_Lamf_core_model_domain_DomainElement(this$1.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))).dataNode__Lamf_core_model_domain_DataNode(), this.ordering$1, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.eh$1).emitters__sc_Seq();
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$emitters$1().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter(this);
  var this$3 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter__Lamf_plugins_document_webapi_model_ResourceTypeFragment__Lamf_core_emitter_SpecOrdering__Lamf_core_errorhandling_ErrorHandler = (function($$outer, fragment, ordering, eh) {
  this.fragment$1 = fragment;
  this.ordering$1 = ordering;
  this.eh$1 = eh;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.header$1 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$ResourceTypeFragmentEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$ResourceTypeFragmentEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$ResourceTypeFragmentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$RamlFragmentTypeEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$emitters$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$emitters$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$emitters$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$emitters$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$emitters$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$emitters$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$emitters$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$emitters$1.prototype.isDefinedAt__Lamf_core_emitter_EntryEmitter__Z = (function(x1) {
  return true
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$emitters$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$emitters$1.prototype.applyOrElse__Lamf_core_emitter_EntryEmitter__F1__O = (function(x1, $default) {
  if ((x1 !== null)) {
    return x1
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Fragment not encoding DataObjectNode but " + x1)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$emitters$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_emitter_EntryEmitter__Z($as_Lamf_core_emitter_EntryEmitter(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$emitters$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_emitter_EntryEmitter__F1__O($as_Lamf_core_emitter_EntryEmitter(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$emitters$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$emitters$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$emitters$1", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$emitters$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$emitters$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$ResourceTypeFragmentEmitter$$anonfun$emitters$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter() {
  $c_O.call(this);
  this.securityScheme$1 = null;
  this.ordering$1 = null;
  this.header$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.productPrefix__T = (function() {
  return "SecuritySchemeFragmentEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var SecuritySchemeFragmentEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter(x$1);
    var x = this.securityScheme$1;
    var x$2 = SecuritySchemeFragmentEmitter$1.securityScheme$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = SecuritySchemeFragmentEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.securityScheme$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter__Lamf_plugins_document_webapi_model_SecuritySchemeFragment__Lamf_core_emitter_SpecOrdering = (function($$outer, securityScheme, ordering) {
  this.securityScheme$1 = securityScheme;
  this.ordering$1 = ordering;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.header$1 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.header__Lamf_plugins_document_webapi_parser_RamlHeader = (function() {
  return this.header$1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.emitters__sc_Seq__sc_Seq = (function(references) {
  var this$1 = this.securityScheme$1;
  return new $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter().init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext($as_Lamf_plugins_domain_webapi_models_security_SecurityScheme($as_Lamf_core_model_domain_DomainElement(this$1.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))), references, this.ordering$1, this.$$outer$1.spec$1).emitters__sc_Seq()
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$SecuritySchemeFragmentEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$SecuritySchemeFragmentEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$SecuritySchemeFragmentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$RamlFragmentTypeEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$SecuritySchemeFragmentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter() {
  $c_O.call(this);
  this.fragment$1 = null;
  this.ordering$1 = null;
  this.eh$1 = null;
  this.header$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter.prototype.productPrefix__T = (function() {
  return "TraitFragmentEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var TraitFragmentEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter(x$1);
    var x = this.fragment$1;
    var x$2 = TraitFragmentEmitter$1.fragment$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = TraitFragmentEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fragment$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter.prototype.header__Lamf_plugins_document_webapi_parser_RamlHeader = (function() {
  return this.header$1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter.prototype.emitters__sc_Seq__sc_Seq = (function(references) {
  var this$1 = this.fragment$1;
  var jsx$2 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler($as_Lamf_core_model_domain_templates_AbstractDeclaration($as_Lamf_core_model_domain_DomainElement(this$1.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))).dataNode__Lamf_core_model_domain_DataNode(), this.ordering$1, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.eh$1).emitters__sc_Seq();
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter$$anonfun$emitters$2().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter(this);
  var this$3 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter__Lamf_plugins_document_webapi_model_TraitFragment__Lamf_core_emitter_SpecOrdering__Lamf_core_errorhandling_ErrorHandler = (function($$outer, fragment, ordering, eh) {
  this.fragment$1 = fragment;
  this.ordering$1 = ordering;
  this.eh$1 = eh;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.header$1 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$TraitFragmentEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$TraitFragmentEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$TraitFragmentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$RamlFragmentTypeEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter$$anonfun$emitters$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter$$anonfun$emitters$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter$$anonfun$emitters$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter$$anonfun$emitters$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter$$anonfun$emitters$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter$$anonfun$emitters$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter$$anonfun$emitters$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter$$anonfun$emitters$2.prototype.isDefinedAt__Lamf_core_emitter_EntryEmitter__Z = (function(x1) {
  return true
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter$$anonfun$emitters$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter$$anonfun$emitters$2.prototype.applyOrElse__Lamf_core_emitter_EntryEmitter__F1__O = (function(x1, $default) {
  if ((x1 !== null)) {
    return x1
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Fragment not encoding DataObjectNode but " + x1)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter$$anonfun$emitters$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_emitter_EntryEmitter__Z($as_Lamf_core_emitter_EntryEmitter(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter$$anonfun$emitters$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_emitter_EntryEmitter__F1__O($as_Lamf_core_emitter_EntryEmitter(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter$$anonfun$emitters$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter$$anonfun$emitters$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentEmitter$TraitFragmentEmitter$$anonfun$emitters$2", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter$$anonfun$emitters$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter$$anonfun$emitters$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter$TraitFragmentEmitter$$anonfun$emitters$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_document_BaseUnit__Z($as_Lamf_core_model_document_BaseUnit(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O($as_Lamf_core_model_document_BaseUnit(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$1.prototype.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_model_document_Module)) {
    var x2 = $as_Lamf_core_model_document_Module(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$1.prototype.isDefinedAt__Lamf_core_model_document_BaseUnit__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_core_model_document_Module)
});
var $d_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.ReferencesEmitter$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$2.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$2.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$2.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$2.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$2.prototype.applyOrElse__s_Option__F1__O = (function(x2, $default) {
  if ((x2 instanceof $c_s_Some)) {
    var x2$2 = $as_s_Some(x2);
    var e = $as_Lamf_core_emitter_EntryEmitter(x2$2.value$2);
    return e
  } else {
    return $default.apply__O__O(x2)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$2.prototype.isDefinedAt__s_Option__Z = (function(x2) {
  return (x2 instanceof $c_s_Some)
});
var $d_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$2: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.ReferencesEmitter$$anonfun$2", {
  Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$2.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter$$anonfun$$nestedInanonfun$emit$31$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter$$anonfun$$nestedInanonfun$emit$31$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter$$anonfun$$nestedInanonfun$emit$31$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter$$anonfun$$nestedInanonfun$emit$31$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter$$anonfun$$nestedInanonfun$emit$31$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter$$anonfun$$nestedInanonfun$emit$31$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter$$anonfun$$nestedInanonfun$emit$31$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter$$anonfun$$nestedInanonfun$emit$31$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter$$anonfun$$nestedInanonfun$emit$31$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_shapes_models_CreativeWork)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter$$anonfun$$nestedInanonfun$emit$31$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_CreativeWork)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_CreativeWork(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter$$anonfun$$nestedInanonfun$emit$31$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter$$anonfun$$nestedInanonfun$emit$31$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter$$anonfun$$nestedInanonfun$emit$31$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter$$anonfun$$nestedInanonfun$emit$31$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.UserDocumentationsEmitter$$anonfun$$nestedInanonfun$emit$31$1", {
  Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter$$anonfun$$nestedInanonfun$emit$31$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter$$anonfun$$nestedInanonfun$emit$31$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter$$anonfun$$nestedInanonfun$emit$31$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter.call(this);
  this.securityScheme$2 = null;
  this.references$2 = null;
  this.ordering$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter.prototype.productPrefix__T = (function() {
  return "Raml08SecuritySchemeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter)) {
    var Raml08SecuritySchemeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter(x$1);
    var x = this.securityScheme$2;
    var x$2 = Raml08SecuritySchemeEmitter$1.securityScheme$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.references$2;
      var x$4 = Raml08SecuritySchemeEmitter$1.references$2;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.ordering$2;
      var x$6 = Raml08SecuritySchemeEmitter$1.ordering$2;
      return (x$5 === x$6)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.securityScheme$2;
      break
    }
    case 1: {
      return this.references$2;
      break
    }
    case 2: {
      return this.ordering$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(securityScheme, references, ordering, spec) {
  this.securityScheme$2 = securityScheme;
  this.references$2 = references;
  this.ordering$2 = ordering;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, securityScheme, references, ordering, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter.prototype.describedByEmitter__F4 = (function() {
  return new $c_sjsr_AnonFunction4().init___sjs_js_Function4((function($this) {
    return (function(key$2, securityScheme$2, ordering$2, references$2) {
      var key = $as_T(key$2);
      var securityScheme = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(securityScheme$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      var references = $as_sc_Seq(references$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter().init___T__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(key, securityScheme, ordering, references, $this.spec$2)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.emitters.Raml08SecuritySchemeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.emitters.Raml08SecuritySchemeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.emitters.Raml08SecuritySchemeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter.call(this);
  this.securityScheme$2 = null;
  this.references$2 = null;
  this.ordering$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter.prototype.productPrefix__T = (function() {
  return "Raml10SecuritySchemeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter)) {
    var Raml10SecuritySchemeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter(x$1);
    var x = this.securityScheme$2;
    var x$2 = Raml10SecuritySchemeEmitter$1.securityScheme$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.references$2;
      var x$4 = Raml10SecuritySchemeEmitter$1.references$2;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.ordering$2;
      var x$6 = Raml10SecuritySchemeEmitter$1.ordering$2;
      return (x$5 === x$6)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.securityScheme$2;
      break
    }
    case 1: {
      return this.references$2;
      break
    }
    case 2: {
      return this.ordering$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(securityScheme, references, ordering, spec) {
  this.securityScheme$2 = securityScheme;
  this.references$2 = references;
  this.ordering$2 = ordering;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, securityScheme, references, ordering, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter.prototype.describedByEmitter__F4 = (function() {
  return new $c_sjsr_AnonFunction4().init___sjs_js_Function4((function($this) {
    return (function(key$2, securityScheme$2, ordering$2, references$2) {
      var key = $as_T(key$2);
      var securityScheme = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(securityScheme$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      var references = $as_sc_Seq(references$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter().init___T__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(key, securityScheme, ordering, references, $this.spec$2)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.emitters.Raml10SecuritySchemeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.emitters.Raml10SecuritySchemeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.emitters.Raml10SecuritySchemeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemeEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter$$anonfun$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_security_Scope)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter$$anonfun$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_security_Scope)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_security_Scope(x1);
    var this$1 = $as_Lamf_core_model_StrField(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Name$1));
    var this$2 = this$1.option$1;
    return new $c_Lamf_core_emitter_BaseEmitters_package$RawEmitter().init___T__Lorg_yaml_model_YType__Lamf_core_parser_Annotations($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())), $m_Lorg_yaml_model_YType$().Str$1, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()))
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.emitters.RamlOAuth2ScopeEmitter$$anonfun$1", {
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds$$anonfun$getOperationsFromModel$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds$$anonfun$getOperationsFromModel$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds$$anonfun$getOperationsFromModel$1.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds$$anonfun$getOperationsFromModel$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds$$anonfun$getOperationsFromModel$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds$$anonfun$getOperationsFromModel$1.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds$$anonfun$getOperationsFromModel$1.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds$$anonfun$getOperationsFromModel$1.prototype.init___Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds$$anonfun$getOperationsFromModel$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_Operation)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds$$anonfun$getOperationsFromModel$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Operation)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_Operation(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds$$anonfun$getOperationsFromModel$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds$$anonfun$getOperationsFromModel$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds$$anonfun$getOperationsFromModel$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds$$anonfun$getOperationsFromModel$1: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.oas3.CleanRepeatedOperationIds$$anonfun$getOperationsFromModel$1", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds$$anonfun$getOperationsFromModel$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds$$anonfun$getOperationsFromModel$1.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_oas3_CleanRepeatedOperationIds$$anonfun$getOperationsFromModel$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle$$anonfun$extractDocumentedElements$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle$$anonfun$extractDocumentedElements$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle$$anonfun$extractDocumentedElements$1.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle$$anonfun$extractDocumentedElements$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle$$anonfun$extractDocumentedElements$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle$$anonfun$extractDocumentedElements$1.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle$$anonfun$extractDocumentedElements$1.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle$$anonfun$extractDocumentedElements$1.prototype.init___Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle$$anonfun$extractDocumentedElements$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return $is_Lamf_plugins_domain_webapi_models_DocumentedElement(x1)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle$$anonfun$extractDocumentedElements$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  return ($is_Lamf_plugins_domain_webapi_models_DocumentedElement(x1) ? x1 : $default.apply__O__O(x1))
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle$$anonfun$extractDocumentedElements$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle$$anonfun$extractDocumentedElements$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle$$anonfun$extractDocumentedElements$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle$$anonfun$extractDocumentedElements$1: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.MandatoryDocumentationTitle$$anonfun$extractDocumentedElements$1", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle$$anonfun$extractDocumentedElements$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle$$anonfun$extractDocumentedElements$1.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_MandatoryDocumentationTitle$$anonfun$extractDocumentedElements$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames$$anonfun$resolve$1() {
  $c_sr_AbstractPartialFunction.call(this);
  this.$$outer$2 = null
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames$$anonfun$resolve$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames$$anonfun$resolve$1.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames$$anonfun$resolve$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames$$anonfun$resolve$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames$$anonfun$resolve$1.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames$$anonfun$resolve$1.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames$$anonfun$resolve$1.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ($is_Lamf_core_model_domain_NamedDomainElement(x1)) {
    var x2 = $as_Lamf_core_model_domain_NamedDomainElement(x1);
    var jsx$1 = this.$$outer$2;
    var this$1 = $as_Lamf_core_model_StrField(x2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(x2.nameField__Lamf_core_metamodel_Field()));
    var this$2 = this$1.option$1;
    var x1$3 = jsx$1.sanitizeName__T__s_Option($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())));
    if ((x1$3 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$3);
      var name = $as_T(x2$2.value$2);
      $m_Lamf_core_parser_Annotations$();
      var a = new $c_Lamf_core_parser_Annotations().init___();
      return $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(x2, name, a)
    } else {
      var x = $m_s_None$();
      if ((x === x1$3)) {
        return (void 0)
      } else {
        throw new $c_s_MatchError().init___O(x1$3)
      }
    }
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames$$anonfun$resolve$1.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return $is_Lamf_core_model_domain_NamedDomainElement(x1)
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames$$anonfun$resolve$1.prototype.init___Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames$$anonfun$resolve$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames$$anonfun$resolve$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames$$anonfun$resolve$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames$$anonfun$resolve$1: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.SanitizeCustomTypeNames$$anonfun$resolve$1", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames$$anonfun$resolve$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames$$anonfun$resolve$1.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_SanitizeCustomTypeNames$$anonfun$resolve$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$$anonfun$$nestedInanonfun$convert$3$1() {
  $c_sr_AbstractPartialFunction.call(this);
  this.$$outer$2 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$$anonfun$$nestedInanonfun$convert$3$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$$anonfun$$nestedInanonfun$convert$3$1.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$$anonfun$$nestedInanonfun$convert$3$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$$anonfun$$nestedInanonfun$convert$3$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$$anonfun$$nestedInanonfun$convert$3$1.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$$anonfun$$nestedInanonfun$convert$3$1.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$$anonfun$$nestedInanonfun$convert$3$1.prototype.isDefinedAt__Lamf_plugins_document_webapi_resolution_stages_Branch__Z = (function(x1) {
  return ((x1 instanceof $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch) && ($as_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch(x1).$$outer$1 === this.$$outer$2))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$$anonfun$$nestedInanonfun$convert$3$1.prototype.init___Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$$anonfun$$nestedInanonfun$convert$3$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_plugins_document_webapi_resolution_stages_Branch__Z($as_Lamf_plugins_document_webapi_resolution_stages_Branch(x))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$$anonfun$$nestedInanonfun$convert$3$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_plugins_document_webapi_resolution_stages_Branch__F1__O($as_Lamf_plugins_document_webapi_resolution_stages_Branch(x), $default)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$$anonfun$$nestedInanonfun$convert$3$1.prototype.applyOrElse__Lamf_plugins_document_webapi_resolution_stages_Branch__F1__O = (function(x1, $default) {
  if (((x1 instanceof $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch) && ($as_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch(x1).$$outer$1 === this.$$outer$2))) {
    var x2 = $as_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
var $d_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$$anonfun$$nestedInanonfun$convert$3$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$$anonfun$$nestedInanonfun$convert$3$1: 0
}, false, "amf.plugins.document.webapi.resolution.stages.ExtendsResolutionStage$$anonfun$$nestedInanonfun$convert$3$1", {
  Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$$anonfun$$nestedInanonfun$convert$3$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$$anonfun$$nestedInanonfun$convert$3$1.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$$anonfun$$nestedInanonfun$convert$3$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder$$anonfun$1.prototype.isDefinedAt__Lorg_yaml_model_YPart__Z = (function(x1) {
  return (x1 instanceof $c_Lorg_yaml_model_YMapEntry)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder$$anonfun$1.prototype.applyOrElse__Lorg_yaml_model_YPart__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lorg_yaml_model_YMapEntry)) {
    var x2 = $as_Lorg_yaml_model_YMapEntry(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lorg_yaml_model_YPart__Z($as_Lorg_yaml_model_YPart(x))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lorg_yaml_model_YPart__F1__O($as_Lorg_yaml_model_YPart(x), $default)
});
var $d_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.resolution.stages.ExtendsResolutionStage$ElementTreeBuilder$$anonfun$1", {
  Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder() {
  $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder.call(this);
  this.endpoint$2 = null;
  this.rootKey$2 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder.prototype = new $h_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder();
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder.prototype.productPrefix__T = (function() {
  return "EndPointTreeBuilder"
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder) && ($as_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder(x$1).$$outer$1 === this.$$outer$1))) {
    var EndPointTreeBuilder$1 = $as_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder(x$1);
    var x = this.endpoint$2;
    var x$2 = EndPointTreeBuilder$1.endpoint$2;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.endpoint$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder.prototype.rootKey__T = (function() {
  return this.rootKey$2
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder.prototype.astFromEmition__Lorg_yaml_model_YNode = (function() {
  var this$2 = $m_Lorg_yaml_model_YDocument$().apply__T__Lorg_yaml_model_YDocument$WithComment("");
  var b = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(this$2.org$yaml$model$YDocument$WithComment$$sourceName$f);
  var x = this$2.comment$1;
  var this$4 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$4)) {
    b.comment__T__V(this$2.comment$1)
  };
  var jsx$4 = this.endpoint$2;
  var jsx$3 = $m_Lamf_core_emitter_SpecOrdering$Lexical$();
  var jsx$2 = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var jsx$1 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$7 = this.$$outer$1;
  var eta$0$1 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter().init___Lamf_plugins_domain_webapi_models_EndPoint__Lamf_core_emitter_SpecOrdering__scm_ListBuffer__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(jsx$4, jsx$3, jsx$2, jsx$1, new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(this$7.errorHandler$1, $m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$(), new $c_Lamf_core_emitter_ShapeRenderOptions().init___()));
  var jsx$5 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  eta$0$1.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$1);
  jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var node = new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this$2.org$yaml$model$YDocument$WithComment$$sourceName$f), b.builder$1).node$2;
  var this$13 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YMapYRead$());
  if (this$13.isEmpty__Z()) {
    var this$14 = $m_s_None$()
  } else {
    var arg1 = this$13.get__O();
    var x$7 = $as_Lorg_yaml_model_YMap(arg1);
    var this$14 = new $c_s_Some().init___O(x$7.entries$3)
  };
  var this$15 = $as_sc_TraversableLike((this$14.isEmpty__Z() ? $m_sci_Nil$() : this$14.get__O())).headOption__s_Option();
  if (this$15.isEmpty__Z()) {
    var this$16 = $m_s_None$()
  } else {
    var arg1$1 = this$15.get__O();
    var x$8 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var this$16 = new $c_s_Some().init___O(x$8.value$2)
  };
  return $as_Lorg_yaml_model_YNode((this$16.isEmpty__Z() ? $m_Lorg_yaml_model_YNode$().Null$1 : this$16.get__O()))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder.prototype.init___Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage__Lamf_plugins_domain_webapi_models_EndPoint = (function($$outer, endpoint) {
  this.endpoint$2 = endpoint;
  $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder.prototype.init___Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage__Lamf_core_model_domain_DomainElement.call(this, $$outer, endpoint);
  var this$1 = $as_Lamf_core_model_StrField(endpoint.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1));
  var this$2 = this$1.option$1;
  this.rootKey$2 = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.resolution.stages.ExtendsResolutionStage$EndPointTreeBuilder"))
}
function $isArrayOf_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder)))
}
function $asArrayOf_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.resolution.stages.ExtendsResolutionStage$EndPointTreeBuilder;", depth))
}
var $d_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder: 0
}, false, "amf.plugins.document.webapi.resolution.stages.ExtendsResolutionStage$EndPointTreeBuilder", {
  Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder: 1,
  Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$EndPointTreeBuilder;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder() {
  $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder.call(this);
  this.operation$2 = null;
  this.rootKey$2 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder.prototype = new $h_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder();
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder.prototype.productPrefix__T = (function() {
  return "OperationTreeBuilder"
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder) && ($as_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder(x$1).$$outer$1 === this.$$outer$1))) {
    var OperationTreeBuilder$1 = $as_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder(x$1);
    var x = this.operation$2;
    var x$2 = OperationTreeBuilder$1.operation$2;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.operation$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder.prototype.rootKey__T = (function() {
  return this.rootKey$2
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder.prototype.astFromEmition__Lorg_yaml_model_YNode = (function() {
  var this$2 = $m_Lorg_yaml_model_YDocument$().apply__T__Lorg_yaml_model_YDocument$WithComment("");
  var b = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(this$2.org$yaml$model$YDocument$WithComment$$sourceName$f);
  var x = this$2.comment$1;
  var this$4 = new $c_sci_StringOps().init___T(x);
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$4)) {
    b.comment__T__V(this$2.comment$1)
  };
  var jsx$3 = this.operation$2;
  var jsx$2 = $m_Lamf_core_emitter_SpecOrdering$Lexical$();
  var jsx$1 = $m_sci_Nil$();
  var this$5 = this.$$outer$1;
  var eta$0$1 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter().init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(jsx$3, jsx$2, jsx$1, new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(this$5.errorHandler$1, $m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$(), new $c_Lamf_core_emitter_ShapeRenderOptions().init___()));
  var jsx$4 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  eta$0$1.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$1);
  jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$10 = new $c_Lorg_yaml_model_YDocument().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq($m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(this$2.org$yaml$model$YDocument$WithComment$$sourceName$f), b.builder$1).node$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
  var this$11 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$10, conversion, iv)).entries$3.headOption__s_Option();
  if (this$11.isEmpty__Z()) {
    var this$12 = $m_s_None$()
  } else {
    var arg1 = this$11.get__O();
    var x$9 = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$12 = new $c_s_Some().init___O(x$9.value$2)
  };
  return $as_Lorg_yaml_model_YNode((this$12.isEmpty__Z() ? $m_Lorg_yaml_model_YNode$().Null$1 : this$12.get__O()))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder.prototype.init___Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage__Lamf_plugins_domain_webapi_models_Operation = (function($$outer, operation) {
  this.operation$2 = operation;
  $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder.prototype.init___Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage__Lamf_core_model_domain_DomainElement.call(this, $$outer, operation);
  var this$1 = $as_Lamf_core_model_StrField(operation.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Method$1));
  var this$2 = this$1.option$1;
  this.rootKey$2 = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  return this
});
function $as_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.resolution.stages.ExtendsResolutionStage$OperationTreeBuilder"))
}
function $isArrayOf_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder)))
}
function $asArrayOf_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.resolution.stages.ExtendsResolutionStage$OperationTreeBuilder;", depth))
}
var $d_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder: 0
}, false, "amf.plugins.document.webapi.resolution.stages.ExtendsResolutionStage$OperationTreeBuilder", {
  Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder: 1,
  Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$ElementTreeBuilder: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$OperationTreeBuilder;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch() {
  $c_O.call(this);
  this.key$1 = null;
  this.operation$1 = null;
  this.children$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch.prototype.productPrefix__T = (function() {
  return "TraitBranch"
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch) && ($as_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch(x$1).$$outer$1 === this.$$outer$1))) {
    var TraitBranch$1 = $as_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch(x$1);
    var x = this.key$1;
    var x$2 = TraitBranch$1.key$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.operation$1;
      var x$4 = TraitBranch$1.operation$1;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.children$1;
      var x$6 = TraitBranch$1.children$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.operation$1;
      break
    }
    case 2: {
      return this.children$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch.prototype.init___Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage__Lamf_plugins_document_webapi_resolution_stages_Key__Lamf_plugins_domain_webapi_models_Operation__sc_Seq = (function($$outer, key, operation, children) {
  this.key$1 = key;
  this.operation$1 = operation;
  this.children$1 = children;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
function $as_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.resolution.stages.ExtendsResolutionStage$TraitBranch"))
}
function $isArrayOf_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch)))
}
function $asArrayOf_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.resolution.stages.ExtendsResolutionStage$TraitBranch;", depth))
}
var $d_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch: 0
}, false, "amf.plugins.document.webapi.resolution.stages.ExtendsResolutionStage$TraitBranch", {
  Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch: 1,
  O: 1,
  Lamf_plugins_document_webapi_resolution_stages_Branch: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_ExtendsResolutionStage$TraitBranch;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$$nestedInanonfun$adoptIris$1$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$$nestedInanonfun$adoptIris$1$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$$nestedInanonfun$adoptIris$1$1.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$$nestedInanonfun$adoptIris$1$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$$nestedInanonfun$adoptIris$1$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$$nestedInanonfun$adoptIris$1$1.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$$nestedInanonfun$adoptIris$1$1.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$$nestedInanonfun$adoptIris$1$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return $is_Lamf_core_model_domain_DomainElement(x1)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$$nestedInanonfun$adoptIris$1$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ($is_Lamf_core_model_domain_DomainElement(x1)) {
    var x2 = $as_Lamf_core_model_domain_DomainElement(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$$nestedInanonfun$adoptIris$1$1.prototype.init___Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$$nestedInanonfun$adoptIris$1$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$$nestedInanonfun$adoptIris$1$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$$nestedInanonfun$adoptIris$1$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$$nestedInanonfun$adoptIris$1$1: 0
}, false, "amf.plugins.document.webapi.resolution.stages.ExtensionLikeResolutionStage$$anonfun$$nestedInanonfun$adoptIris$1$1", {
  Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$$nestedInanonfun$adoptIris$1$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$$nestedInanonfun$adoptIris$1$1.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$$nestedInanonfun$adoptIris$1$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_document_BaseUnit__Z($as_Lamf_core_model_document_BaseUnit(x))
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O($as_Lamf_core_model_document_BaseUnit(x), $default)
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$1.prototype.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_model_document_Module)) {
    var x2 = $as_Lamf_core_model_document_Module(x1);
    return x2
  } else if ($is_Lamf_core_model_document_Fragment(x1)) {
    var x3 = $as_Lamf_core_model_document_Fragment(x1);
    return x3
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$1.prototype.isDefinedAt__Lamf_core_model_document_BaseUnit__Z = (function(x1) {
  return ((x1 instanceof $c_Lamf_core_model_document_Module) || $is_Lamf_core_model_document_Fragment(x1))
});
var $d_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.resolution.stages.ExtensionLikeResolutionStage$$anonfun$1", {
  Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_stages_ExtensionLikeResolutionStage$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$() {
  $c_O.call(this);
  this.result$1 = null;
  this.amf$plugins$document$webapi$validation$AMFRawValidations$OasValidations$$result$1 = null;
  this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$1 = null;
  this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$.prototype = $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$.prototype;
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$lzycompute__p1__sc_Seq = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$1 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$RamlAndOasValidations__amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result__sc_Seq(this);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$.prototype.result$lzycompute__p1__sc_Seq = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    var jsx$5 = this.amf$plugins$document$webapi$validation$AMFRawValidations$OasValidations$$result__sc_Seq();
    var jsx$4 = $m_sc_Seq$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns, "Response");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$1, "statusCode");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$2 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$2, "pattern");
    var x$6 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$3 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$8 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$3, "path");
    var x$10 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$3 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$6, "", x$1, x$2, x$8, x$3, "^([1-5]{1}[0-9]{2})$|^(default)$", "", "Status code for a Response must be a value between 100 and 599 or 'default'", x$10);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$4 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$12 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$4, "OAuth2Flow");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$5 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$13 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$5, "flow");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$6 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$14 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$6, "pattern");
    var x$16 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$7 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$17 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$7, "path");
    var x$20 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$2 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$16, "Invalid flow. The options are: implicit, password, application or accessCode", x$12, x$13, x$17, x$14, "^(implicit|password|application|accessCode)$", "", "", x$20);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$8 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$22 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$8, "Settings");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$9 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$23 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$9, "in");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$10 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$24 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$10, "pattern");
    var x$26 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$11 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$27 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$11, "path");
    var x$30 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var array = [jsx$3, jsx$2, $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$26, "Invalid 'in' value. The options are: query or header", x$22, x$23, x$27, x$24, "^(query|header)$", "", "", x$30), $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().schemaRequiredInParameter$1];
    var jsx$1 = jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$36 = $m_sc_Seq$();
    this.result$1 = $as_sc_Seq(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$36.ReusableCBFInstance$2));
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.result$1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result__sc_Seq = (function() {
  return (((((8 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$lzycompute__p1__sc_Seq() : this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1)
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$OasValidations$$result$lzycompute__p1__sc_Seq = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.amf$plugins$document$webapi$validation$AMFRawValidations$OasValidations$$result$1 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$OasValidations__amf$plugins$document$webapi$validation$AMFRawValidations$OasValidations$$result__sc_Seq(this);
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.amf$plugins$document$webapi$validation$AMFRawValidations$OasValidations$$result$1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$OasValidations$$result__sc_Seq = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.amf$plugins$document$webapi$validation$AMFRawValidations$OasValidations$$result$lzycompute__p1__sc_Seq() : this.amf$plugins$document$webapi$validation$AMFRawValidations$OasValidations$$result$1)
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$lzycompute__p1__sc_Seq = (function() {
  if (((((8 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfProfileValidations__amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result__sc_Seq(this);
    this.bitmap$0$1 = (((8 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$.prototype.result__p1__sc_Seq = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.result$lzycompute__p1__sc_Seq() : this.result$1)
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result__sc_Seq = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$lzycompute__p1__sc_Seq() : this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$1)
});
var $d_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$: 0
}, false, "amf.plugins.document.webapi.validation.AMFRawValidations$Oas20Validations$", {
  Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$OasValidations: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$RamlAndOasValidations: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfProfileValidations: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$ProfileValidations: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$GenericValidations: 1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$;
var $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$)) {
    $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$ = new $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas20Validations$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$() {
  $c_O.call(this);
  this.result$1 = null;
  this.amf$plugins$document$webapi$validation$AMFRawValidations$OasValidations$$result$1 = null;
  this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$1 = null;
  this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$.prototype = $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$.prototype;
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$lzycompute__p1__sc_Seq = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$1 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$RamlAndOasValidations__amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result__sc_Seq(this);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$.prototype.result$lzycompute__p1__sc_Seq = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    var jsx$17 = this.amf$plugins$document$webapi$validation$AMFRawValidations$OasValidations$$result__sc_Seq();
    var jsx$16 = $m_sc_Seq$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns, "Response");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$1, "statusCode");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$2 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$2, "pattern");
    var x$6 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$3 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$8 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$3, "path");
    var x$10 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$15 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$6, "", x$1, x$2, x$8, x$3, "^([1-5]{1}(([0-9]{2})|XX))$|^(default)$", "", "Status code for a Response must be a value between 100 and 599, a [1-5]XX wildcard, or 'default'", x$10);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$4 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$12 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$4, "OAuth2Flow");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$5 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$13 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$5, "flow");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$6 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$14 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$6, "pattern");
    var x$16 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$7 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$17 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$7, "path");
    var x$20 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$14 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$16, "Invalid flow. The options are: implicit, password, clientCredentials or authorizationCode", x$12, x$13, x$17, x$14, "^(implicit|password|clientCredentials|authorizationCode)$", "", "", x$20);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$8 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$22 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$8, "Settings");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$9 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$23 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$9, "in");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$10 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$24 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$10, "pattern");
    var x$26 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$11 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$27 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$11, "path");
    var x$30 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$13 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$26, "Invalid 'in' value. The options are: query, header or cookie", x$22, x$23, x$27, x$24, "^(query|header|cookie)$", "", "", x$30);
    var x$31 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().amfParser__T__s_Option("example-mutually-exclusive-fields");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$12 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$33 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$12, "Example");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$13 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
    var x$34 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$13, "externalValue");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$14 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    var x$35 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$14, "exampleMutuallyExclusiveFields");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$15 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$37 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$15, "path");
    var x$40 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$12 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$31, "Example 'value' and 'externalValue' fields are mutually exclusive", x$33, x$34, x$37, x$35, "0", "", "Example 'value' and 'externalValue' fields are mutually exclusive", x$40);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var name = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().doc$1.displayName$1;
    var ns$16 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$41 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$16, name);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$17 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$42 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$17, "payload");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$18 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$43 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$18, "maxCount");
    var x$46 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$19 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$48 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$19, "path");
    var x$50 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$11 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$46, "", x$41, x$42, x$48, x$43, "1", "", "Parameters 'content' field must only have one entry", x$50);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$20 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var owlClass = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$20, "WebAPI");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$21 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var owlProperty = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$21, "termsOfService");
    var jsx$10 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$GenericValidations__urlValidation__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(this, owlClass, owlProperty);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$22 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$52 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$22, "HttpSettings");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$23 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$53 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$23, "scheme");
    var x$54 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
    var x$56 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$24 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$57 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$24, "path");
    var x$60 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$9 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$56, "'scheme' field is mandatory in http security scheme", x$52, x$53, x$57, x$54, "1", "", "", x$60);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$25 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$62 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$25, "ApiKeySettings");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$26 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var x$63 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$26, "name");
    var x$64 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
    var x$66 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$27 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$67 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$27, "path");
    var x$70 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$8 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$66, "'name' field is mandatory in apiKey security scheme", x$62, x$63, x$67, x$64, "1", "", "", x$70);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$28 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$72 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$28, "ApiKeySettings");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$29 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$73 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$29, "in");
    var x$74 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$().minCount$1;
    var x$76 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$30 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$77 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$30, "path");
    var x$80 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$7 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$76, "'in' field is mandatory in apiKey security scheme", x$72, x$73, x$77, x$74, "1", "", "", x$80);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$31 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$82 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$31, "SecurityScheme");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$32 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$83 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$32, "settings");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$33 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    var x$84 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$33, "requiredOpenIdConnectUrl");
    var x$85 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$34 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$86 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$34, "path");
    var x$90 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$6 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$85, "'openIdConnectUrl' field is mandatory in openIdConnect security scheme", x$82, x$83, x$86, x$84, "0", "", "", x$90);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$35 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$92 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$35, "SecurityScheme");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$36 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
    var x$93 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$36, "settings");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$37 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    var x$94 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$37, "requiredFlowsInOAuth2");
    var x$95 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$38 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$96 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$38, "path");
    var x$100 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$5 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$95, "'flows' field is mandatory in OAuth2 security scheme", x$92, x$93, x$96, x$94, "0", "", "", x$100);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$39 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$102 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$39, "Callback");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$40 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$103 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$40, "expression");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$41 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    var x$104 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$41, "validCallbackExpression");
    var x$105 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$42 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$106 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$42, "path");
    var x$110 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$4 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$105, "Does not comply with runtime expression ABNF syntax", x$102, x$103, x$106, x$104, "0", "", "", x$110);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$43 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$112 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$43, "TemplatedLink");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$44 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$113 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$44, "requestBody");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$45 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    var x$114 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$45, "validLinkRequestBody");
    var x$115 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$46 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$116 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$46, "path");
    var x$120 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$3 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$115, "Does not comply with runtime expression ABNF syntax", x$112, x$113, x$116, x$114, "0", "", "", x$120);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$47 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$122 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$47, "TemplatedLink");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$48 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$123 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$48, "mapping");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$49 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    var x$124 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$49, "validLinkParameterExpressions");
    var x$125 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$50 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$126 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$50, "path");
    var x$130 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var jsx$2 = $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$125, "Does not comply with runtime expression ABNF syntax", x$122, x$123, x$126, x$124, "0", "", "", x$130);
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$51 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
    var x$132 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$51, "Tag");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$52 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
    var x$133 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$52, "name");
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$53 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$134 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$53, "minLength");
    var x$136 = $m_s_None$();
    $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$();
    var ns$54 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
    var x$137 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(ns$54, "path");
    var x$140 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    var array = [jsx$15, jsx$14, jsx$13, jsx$12, jsx$11, jsx$10, jsx$9, jsx$8, jsx$7, jsx$6, jsx$5, jsx$4, jsx$3, jsx$2, $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation$().apply__s_Option__T__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__Lamf_core_vocabulary_ValueType__T__T__T__T__Lamf_plugins_document_webapi_validation_AMFRawValidations$AMFValidation(x$136, "Property 'name' in Tag object cannot be empty", x$132, x$133, x$137, x$134, "1", "", "", x$140)];
    var jsx$1 = jsx$16.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$154 = $m_sc_Seq$();
    this.result$1 = $as_sc_Seq(jsx$17.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$154.ReusableCBFInstance$2));
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.result$1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result__sc_Seq = (function() {
  return (((((8 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$lzycompute__p1__sc_Seq() : this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1)
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$OasValidations$$result$lzycompute__p1__sc_Seq = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.amf$plugins$document$webapi$validation$AMFRawValidations$OasValidations$$result$1 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$OasValidations__amf$plugins$document$webapi$validation$AMFRawValidations$OasValidations$$result__sc_Seq(this);
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.amf$plugins$document$webapi$validation$AMFRawValidations$OasValidations$$result$1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$OasValidations$$result__sc_Seq = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.amf$plugins$document$webapi$validation$AMFRawValidations$OasValidations$$result$lzycompute__p1__sc_Seq() : this.amf$plugins$document$webapi$validation$AMFRawValidations$OasValidations$$result$1)
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$lzycompute__p1__sc_Seq = (function() {
  if (((((8 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1 = $f_Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfProfileValidations__amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result__sc_Seq(this);
    this.bitmap$0$1 = (((8 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.amf$plugins$document$webapi$validation$AMFRawValidations$AmfProfileValidations$$result$1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$.prototype.result__p1__sc_Seq = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.result$lzycompute__p1__sc_Seq() : this.result$1)
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$.prototype.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result__sc_Seq = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$lzycompute__p1__sc_Seq() : this.amf$plugins$document$webapi$validation$AMFRawValidations$RamlAndOasValidations$$result$1)
});
var $d_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$: 0
}, false, "amf.plugins.document.webapi.validation.AMFRawValidations$Oas30Validations$", {
  Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$OasValidations: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$RamlAndOasValidations: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$AmfProfileValidations: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$ProfileValidations: 1,
  Lamf_plugins_document_webapi_validation_AMFRawValidations$GenericValidations: 1
});
$c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$;
var $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$)) {
    $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$ = new $c_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_AMFRawValidations$Oas30Validations$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1.prototype = $c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1.prototype;
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  if ((x1 instanceof $c_Lamf_core_model_domain_extensions_DomainExtension)) {
    var x2 = $as_Lamf_core_model_domain_extensions_DomainExtension(x1);
    var this$1 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_extensions_CustomDomainProperty(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().DefinedBy$1)));
    if ((!this$1.isEmpty__Z())) {
      var arg1 = this$1.get__O();
      var definition = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(arg1);
      if ($m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(definition.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Schema$1))).isDefined__Z()) {
        var jsx$2 = $m_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$();
        var this$2 = $as_Lamf_core_model_StrField(definition.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Name$1));
        var this$3 = this$2.option$1;
        var jsx$1 = jsx$2.resolveAnnotation__T__s_Option((("(" + $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()))) + ")")).isDefined__Z()
      } else {
        var jsx$1 = false
      }
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return true
    }
  };
  if ((x1 instanceof $c_Lamf_core_model_domain_extensions_ShapeExtension)) {
    var x3 = $as_Lamf_core_model_domain_extensions_ShapeExtension(x1);
    if ($m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_extensions_PropertyShape(x3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$().DefinedBy$1))).isDefined__Z()) {
      var jsx$4 = $m_s_Option$();
      var this$4 = $as_Lamf_core_model_domain_extensions_PropertyShape(x3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$().DefinedBy$1));
      var jsx$3 = jsx$4.apply__O__s_Option($as_Lamf_core_model_domain_Shape(this$4.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1))).isDefined__Z()
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      return true
    }
  };
  if ((x1 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
    var x4 = $as_Lamf_core_model_domain_AmfScalar(x1);
    if (x4.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_DomainExtensionAnnotation.getClassOf())) {
      return true
    }
  };
  return false
});
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_model_domain_extensions_DomainExtension)) {
    var x2 = $as_Lamf_core_model_domain_extensions_DomainExtension(x1);
    var this$1 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_extensions_CustomDomainProperty(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().DefinedBy$1)));
    if ((!this$1.isEmpty__Z())) {
      var arg1 = this$1.get__O();
      var definition = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(arg1);
      if ($m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(definition.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Schema$1))).isDefined__Z()) {
        var jsx$2 = $m_Lamf_plugins_document_webapi_parser_spec_common_WellKnownAnnotation$();
        var this$2 = $as_Lamf_core_model_StrField(definition.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Name$1));
        var this$3 = this$2.option$1;
        var jsx$1 = jsx$2.resolveAnnotation__T__s_Option((("(" + $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()))) + ")")).isDefined__Z()
      } else {
        var jsx$1 = false
      }
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var jsx$3 = $m_sc_Seq$();
      var array = [x2];
      return jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))
    }
  };
  if ((x1 instanceof $c_Lamf_core_model_domain_extensions_ShapeExtension)) {
    var x3 = $as_Lamf_core_model_domain_extensions_ShapeExtension(x1);
    if ($m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_extensions_PropertyShape(x3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$().DefinedBy$1))).isDefined__Z()) {
      var jsx$5 = $m_s_Option$();
      var this$6 = $as_Lamf_core_model_domain_extensions_PropertyShape(x3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$().DefinedBy$1));
      var jsx$4 = jsx$5.apply__O__s_Option($as_Lamf_core_model_domain_Shape(this$6.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1))).isDefined__Z()
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      var jsx$6 = $m_sc_Seq$();
      var array$1 = [x3];
      return jsx$6.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1))
    }
  };
  if ((x1 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
    var x4 = $as_Lamf_core_model_domain_AmfScalar(x1);
    if (x4.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_DomainExtensionAnnotation.getClassOf())) {
      var this$9 = x4.annotations$1;
      var pf = new $c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1$$anonfun$applyOrElse$2().init___Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1(this);
      var this$11 = this$9.amf$core$parser$Annotations$$annotations$1;
      var this$10 = $m_scm_ListBuffer$();
      var bf = this$10.ReusableCBFInstance$2;
      return $as_sc_Seq($f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this$11, pf, bf))
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1.prototype.init___Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector = (function($$outer) {
  return this
});
var $d_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1: 0
}, false, "amf.plugins.document.webapi.validation.ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1", {
  Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1$$anonfun$applyOrElse$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1$$anonfun$applyOrElse$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1$$anonfun$applyOrElse$2.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1$$anonfun$applyOrElse$2;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1$$anonfun$applyOrElse$2() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1$$anonfun$applyOrElse$2.prototype = $c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1$$anonfun$applyOrElse$2.prototype;
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1$$anonfun$applyOrElse$2.prototype.applyOrElse__Lamf_core_model_domain_Annotation__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_annotations_DomainExtensionAnnotation)) {
    var x2 = $as_Lamf_core_annotations_DomainExtensionAnnotation(x1);
    return x2.extension$1
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1$$anonfun$applyOrElse$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_Annotation__Z($as_Lamf_core_model_domain_Annotation(x))
});
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1$$anonfun$applyOrElse$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_Annotation__F1__O($as_Lamf_core_model_domain_Annotation(x), $default)
});
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1$$anonfun$applyOrElse$2.prototype.init___Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1 = (function($$outer) {
  return this
});
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1$$anonfun$applyOrElse$2.prototype.isDefinedAt__Lamf_core_model_domain_Annotation__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_core_annotations_DomainExtensionAnnotation)
});
var $d_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1$$anonfun$applyOrElse$2 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1$$anonfun$applyOrElse$2: 0
}, false, "amf.plugins.document.webapi.validation.ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1$$anonfun$applyOrElse$2", {
  Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1$$anonfun$applyOrElse$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1$$anonfun$applyOrElse$2.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_ExtensionsCandidatesCollector$$anonfun$findExtensionsWithTypes$1$$anonfun$applyOrElse$2;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this);
  this.$$outer$2 = null
}
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_validation_PayloadsInApiCollector = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$$anonfun$1.prototype.isDefinedAt__Lamf_plugins_domain_shapes_models_Example__Z = (function(x1) {
  if ((x1 !== null)) {
    var this$1 = x1.fields$1;
    var f = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1;
    if (this$1.fs$1.contains__O__Z(f)) {
      var this$2 = $as_Lamf_core_model_BoolField(x1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Strict$1)).option$1;
      var jsx$1 = $uZ((this$2.isEmpty__Z() || this$2.get__O()))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return true
    }
  };
  if ((x1 !== null)) {
    var this$3 = x1.fields$1;
    var f$1 = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Raw$1;
    if (this$3.fs$1.contains__O__Z(f$1)) {
      var this$4 = $as_Lamf_core_model_BoolField(x1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Strict$1)).option$1;
      var jsx$2 = $uZ((this$4.isEmpty__Z() || this$4.get__O()))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      return true
    }
  };
  return false
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$$anonfun$1.prototype.applyOrElse__Lamf_plugins_domain_shapes_models_Example__F1__O = (function(x1, $default) {
  if ((x1 !== null)) {
    var this$1 = x1.fields$1;
    var f = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1;
    if (this$1.fs$1.contains__O__Z(f)) {
      var this$2 = $as_Lamf_core_model_BoolField(x1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Strict$1)).option$1;
      var jsx$1 = $uZ((this$2.isEmpty__Z() || this$2.get__O()))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var jsx$4 = this.$$outer$2;
      var jsx$3 = $as_Lamf_core_model_domain_DataNode(x1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1));
      var jsx$2 = x1.id$1;
      var this$3 = $as_Lamf_core_model_StrField(x1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1));
      var this$4 = this$3.option$1;
      return new $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement().init___Lamf_plugins_document_webapi_validation_PayloadsInApiCollector__Lamf_core_model_domain_DataNode__T__T__Lamf_core_parser_Annotations(jsx$4, jsx$3, jsx$2, $as_T((this$4.isEmpty__Z() ? null : this$4.get__O())), x1.annotations$1)
    }
  };
  if ((x1 !== null)) {
    var this$5 = x1.fields$1;
    var f$1 = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Raw$1;
    if (this$5.fs$1.contains__O__Z(f$1)) {
      var this$6 = $as_Lamf_core_model_BoolField(x1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Strict$1)).option$1;
      var jsx$5 = $uZ((this$6.isEmpty__Z() || this$6.get__O()))
    } else {
      var jsx$5 = false
    };
    if (jsx$5) {
      var jsx$7 = this.$$outer$2;
      var jsx$6 = x1.id$1;
      var this$7 = $as_Lamf_core_model_StrField(x1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1));
      var this$8 = this$7.option$1;
      return new $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement().init___Lamf_plugins_document_webapi_validation_PayloadsInApiCollector__T__T__Lamf_core_parser_Annotations(jsx$7, jsx$6, $as_T((this$8.isEmpty__Z() ? null : this$8.get__O())), x1.annotations$1)
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_plugins_domain_shapes_models_Example__Z($as_Lamf_plugins_domain_shapes_models_Example(x))
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_plugins_domain_shapes_models_Example__F1__O($as_Lamf_plugins_domain_shapes_models_Example(x), $default)
});
var $d_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.validation.PayloadsInApiCollector$$anonfun$1", {
  Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement() {
  $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement.call(this);
  this.dataNode$2 = null
}
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement.prototype = new $h_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement();
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement.prototype = $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement.prototype;
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement.prototype.productPrefix__T = (function() {
  return "DataNodeCollectedElement"
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement.prototype.init___Lamf_plugins_document_webapi_validation_PayloadsInApiCollector__Lamf_core_model_domain_DataNode__T__T__Lamf_core_parser_Annotations = (function($$outer, dataNode, id, raw, a) {
  this.dataNode$2 = dataNode;
  $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement.prototype.init___Lamf_plugins_document_webapi_validation_PayloadsInApiCollector__T__T__Lamf_core_parser_Annotations.call(this, $$outer, id, raw, a);
  return this
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement) && ($as_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement(x$1).$$outer$1 === this.$$outer$1))) {
    var DataNodeCollectedElement$1 = $as_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement(x$1);
    var x = this.dataNode$2;
    var x$2 = DataNodeCollectedElement$1.dataNode$2;
    if ((((x === x$2) && (this.id$1 === DataNodeCollectedElement$1.id$1)) && (this.raw$1 === DataNodeCollectedElement$1.raw$1))) {
      var x$3 = this.a$1;
      var x$4 = DataNodeCollectedElement$1.a$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.dataNode$2;
      break
    }
    case 1: {
      return this.id$1;
      break
    }
    case 2: {
      return this.raw$1;
      break
    }
    case 3: {
      return this.a$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.PayloadsInApiCollector$DataNodeCollectedElement"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.PayloadsInApiCollector$DataNodeCollectedElement;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement: 0
}, false, "amf.plugins.document.webapi.validation.PayloadsInApiCollector$DataNodeCollectedElement", {
  Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement: 1,
  Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$DataNodeCollectedElement;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement() {
  $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement.call(this)
}
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement.prototype = new $h_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement();
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement.prototype = $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement.prototype;
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement.prototype.init___Lamf_plugins_document_webapi_validation_PayloadsInApiCollector__T__T__Lamf_core_parser_Annotations = (function($$outer, id, raw, a) {
  $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement.prototype.init___Lamf_plugins_document_webapi_validation_PayloadsInApiCollector__T__T__Lamf_core_parser_Annotations.call(this, $$outer, id, raw, a);
  return this
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement.prototype.productPrefix__T = (function() {
  return "StringCollectedElement"
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement) && ($as_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement(x$1).$$outer$1 === this.$$outer$1))) {
    var StringCollectedElement$1 = $as_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement(x$1);
    if (((this.id$1 === StringCollectedElement$1.id$1) && (this.raw$1 === StringCollectedElement$1.raw$1))) {
      var x = this.a$1;
      var x$2 = StringCollectedElement$1.a$1;
      return (x === x$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.id$1;
      break
    }
    case 1: {
      return this.raw$1;
      break
    }
    case 2: {
      return this.a$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.PayloadsInApiCollector$StringCollectedElement"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.PayloadsInApiCollector$StringCollectedElement;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement: 0
}, false, "amf.plugins.document.webapi.validation.PayloadsInApiCollector$StringCollectedElement", {
  Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement: 1,
  Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$CollectedElement: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_PayloadsInApiCollector$StringCollectedElement;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this);
  this.typesWithShapes$1$2 = null
}
$c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$$anonfun$1.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$$anonfun$1.prototype = $c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$$anonfun$1.prototype;
$c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$$anonfun$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  if ($is_Lamf_core_model_domain_DomainElement(x1)) {
    var x2 = $as_Lamf_core_model_domain_DomainElement(x1);
    if (x2.graph__Lamf_core_model_domain_Graph().types__sc_Seq().exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$1$2) {
        var x$1 = $as_T(x$1$2);
        return $this.typesWithShapes$1$2.contains__O__Z(x$1)
      })
    })(this)))) {
      return true
    }
  };
  return false
});
$c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$$anonfun$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ($is_Lamf_core_model_domain_DomainElement(x1)) {
    var x2 = $as_Lamf_core_model_domain_DomainElement(x1);
    if (x2.graph__Lamf_core_model_domain_Graph().types__sc_Seq().exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$1$2) {
        var x$1 = $as_T(x$1$2);
        return $this.typesWithShapes$1$2.contains__O__Z(x$1)
      })
    })(this)))) {
      return x2
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$$anonfun$1.prototype.init___Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector__sc_Seq = (function($$outer, typesWithShapes$1) {
  this.typesWithShapes$1$2 = typesWithShapes$1;
  return this
});
$c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$$anonfun$1: 0
}, false, "amf.plugins.document.webapi.validation.ShapeFacetsCandidatesCollector$$anonfun$1", {
  Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$$anonfun$1.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_ShapeFacetsCandidatesCollector$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runner_EmptyResultContainer$() {
  $c_Lamf_plugins_document_webapi_validation_runner_ResultContainer.call(this)
}
$c_Lamf_plugins_document_webapi_validation_runner_EmptyResultContainer$.prototype = new $h_Lamf_plugins_document_webapi_validation_runner_ResultContainer();
$c_Lamf_plugins_document_webapi_validation_runner_EmptyResultContainer$.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runner_EmptyResultContainer$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runner_EmptyResultContainer$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runner_EmptyResultContainer$.prototype = $c_Lamf_plugins_document_webapi_validation_runner_EmptyResultContainer$.prototype;
$c_Lamf_plugins_document_webapi_validation_runner_EmptyResultContainer$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_validation_runner_ResultContainer.prototype.init___sc_Seq.call(this, $m_sci_Nil$());
  return this
});
var $d_Lamf_plugins_document_webapi_validation_runner_EmptyResultContainer$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runner_EmptyResultContainer$: 0
}, false, "amf.plugins.document.webapi.validation.runner.EmptyResultContainer$", {
  Lamf_plugins_document_webapi_validation_runner_EmptyResultContainer$: 1,
  Lamf_plugins_document_webapi_validation_runner_ResultContainer: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runner_EmptyResultContainer$.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runner_EmptyResultContainer$;
var $n_Lamf_plugins_document_webapi_validation_runner_EmptyResultContainer$ = (void 0);
function $m_Lamf_plugins_document_webapi_validation_runner_EmptyResultContainer$() {
  if ((!$n_Lamf_plugins_document_webapi_validation_runner_EmptyResultContainer$)) {
    $n_Lamf_plugins_document_webapi_validation_runner_EmptyResultContainer$ = new $c_Lamf_plugins_document_webapi_validation_runner_EmptyResultContainer$().init___()
  };
  return $n_Lamf_plugins_document_webapi_validation_runner_EmptyResultContainer$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions() {
  $c_Lamf_core_services_ValidationOptions.call(this);
  this.filterFields$2 = null
}
$c_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions.prototype = new $h_Lamf_core_services_ValidationOptions();
$c_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions.prototype = $c_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions.prototype;
$c_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions.prototype.init___ = (function() {
  $c_Lamf_core_services_ValidationOptions.prototype.init___.call(this);
  this.filterFields$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(f$2) {
      var f = $as_Lamf_core_metamodel_Field(f$2);
      var x = f.type$1;
      var x$2 = $m_Lamf_core_metamodel_domain_DataNodeModel$();
      return ((x !== null) && x.equals__O__Z(x$2))
    })
  })(this));
  return this
});
$c_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions.prototype.productPrefix__T = (function() {
  return "FilterDataNodeOptions"
});
$c_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions) && ($as_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions(x$1), true))
});
$c_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runner.FilterDataNodeOptions"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runner.FilterDataNodeOptions;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions: 0
}, false, "amf.plugins.document.webapi.validation.runner.FilterDataNodeOptions", {
  Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions: 1,
  Lamf_core_services_ValidationOptions: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken() {
  $c_O.call(this);
  this.value$1 = null;
  this.rx$1 = null;
  this.followedBy$1 = null;
  this.extraValue$1 = null;
  this.possibleApplications$1 = null;
  this.next$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype.productPrefix__T = (function() {
  return "FragmentExpressionToken"
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken)) {
    var FragmentExpressionToken$1 = $as_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken(x$1);
    return (this.value$1 === FragmentExpressionToken$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype.nodeIsValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__nodeIsValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype.next__s_Option = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.next$lzycompute__p1__s_Option() : this.next$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype.completelyValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__completelyValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype.rx__s_util_matching_Regex = (function() {
  return this.rx$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype.extraValue__T = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.extraValue$lzycompute__p1__T() : this.extraValue$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype.extraValue$lzycompute__p1__T = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.extraValue$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__extraValue__T(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.extraValue$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype.init___T = (function(value) {
  this.value$1 = value;
  var this$2 = new $c_sci_StringOps().init___T("(.+)");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.rx$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  this.followedBy$1 = $m_sci_Nil$();
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype.followedBy__sc_Seq = (function() {
  return this.followedBy$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype.next$lzycompute__p1__s_Option = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.next$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__next__s_Option(this);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.next$1
});
function $as_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runtimeexpression.FragmentExpressionToken"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runtimeexpression.FragmentExpressionToken;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.FragmentExpressionToken", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken() {
  $c_O.call(this);
  this.next$1 = null;
  this.value$1 = null;
  this.rx$1 = null;
  this.followedBy$1 = null;
  this.extraValue$1 = null;
  this.possibleApplications$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype.productPrefix__T = (function() {
  return "InvalidExpressionToken"
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken)) {
    var InvalidExpressionToken$1 = $as_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken(x$1);
    return (this.value$1 === InvalidExpressionToken$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype.nodeIsValid__Z = (function() {
  return false
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype.next__s_Option = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.next$lzycompute__p1__s_Option() : this.next$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype.rx__s_util_matching_Regex = (function() {
  return this.rx$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype.completelyValid__Z = (function() {
  return false
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype.extraValue__T = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.extraValue$lzycompute__p1__T() : this.extraValue$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype.extraValue$lzycompute__p1__T = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.extraValue$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__extraValue__T(this);
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.extraValue$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype.init___T = (function(value) {
  this.value$1 = value;
  var this$2 = new $c_sci_StringOps().init___T("(.*)");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.rx$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  this.followedBy$1 = $m_sci_Nil$();
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype.followedBy__sc_Seq = (function() {
  return this.followedBy$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype.next$lzycompute__p1__s_Option = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.next$1 = $m_s_None$();
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.next$1
});
function $as_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runtimeexpression.InvalidExpressionToken"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runtimeexpression.InvalidExpressionToken;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.InvalidExpressionToken", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_InvalidExpressionToken;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken() {
  $c_O.call(this);
  this.value$1 = null;
  this.rx$1 = null;
  this.followedBy$1 = null;
  this.extraValue$1 = null;
  this.possibleApplications$1 = null;
  this.next$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype.productPrefix__T = (function() {
  return "NameExpressionToken"
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken)) {
    var NameExpressionToken$1 = $as_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken(x$1);
    return (this.value$1 === NameExpressionToken$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype.nodeIsValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__nodeIsValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype.next__s_Option = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.next$lzycompute__p1__s_Option() : this.next$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype.completelyValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__completelyValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype.rx__s_util_matching_Regex = (function() {
  return this.rx$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype.extraValue__T = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.extraValue$lzycompute__p1__T() : this.extraValue$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype.extraValue$lzycompute__p1__T = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.extraValue$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__extraValue__T(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.extraValue$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype.init___T = (function(value) {
  this.value$1 = value;
  var this$2 = new $c_sci_StringOps().init___T("(.+)");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.rx$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  this.followedBy$1 = $m_sci_Nil$();
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype.followedBy__sc_Seq = (function() {
  return this.followedBy$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype.next$lzycompute__p1__s_Option = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.next$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__next__s_Option(this);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.next$1
});
function $as_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runtimeexpression.NameExpressionToken"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runtimeexpression.NameExpressionToken;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.NameExpressionToken", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_NameExpressionToken;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken() {
  $c_O.call(this);
  this.value$1 = null;
  this.rx$1 = null;
  this.followedBy$1 = null;
  this.extraValue$1 = null;
  this.possibleApplications$1 = null;
  this.next$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype.productPrefix__T = (function() {
  return "TokenExpressionToken"
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken)) {
    var TokenExpressionToken$1 = $as_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken(x$1);
    return (this.value$1 === TokenExpressionToken$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype.nodeIsValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__nodeIsValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype.next__s_Option = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.next$lzycompute__p1__s_Option() : this.next$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype.completelyValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__completelyValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype.rx__s_util_matching_Regex = (function() {
  return this.rx$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype.extraValue__T = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.extraValue$lzycompute__p1__T() : this.extraValue$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype.extraValue$lzycompute__p1__T = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.extraValue$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__extraValue__T(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.extraValue$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype.init___T = (function(value) {
  this.value$1 = value;
  var this$2 = new $c_sci_StringOps().init___T("(.+)");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.rx$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  this.followedBy$1 = $m_sci_Nil$();
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype.followedBy__sc_Seq = (function() {
  return this.followedBy$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype.next$lzycompute__p1__s_Option = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.next$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__next__s_Option(this);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.next$1
});
function $as_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runtimeexpression.TokenExpressionToken"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runtimeexpression.TokenExpressionToken;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.TokenExpressionToken", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria() {
  $c_O.call(this)
}
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria.prototype.productPrefix__T = (function() {
  return "AsyncKeyCriteria"
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria) && ($as_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria(x$1), true))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria.prototype.getKeyFor__Lamf_core_model_domain_AmfElement__s_Option = (function(element) {
  return ((element instanceof $c_Lamf_plugins_domain_webapi_models_Payload) ? $m_s_Option$().apply__O__s_Option("sameKey") : ($is_Lamf_plugins_domain_webapi_models_Key(element) ? $as_Lamf_plugins_domain_webapi_models_Key(element).key__Lamf_core_model_StrField().option$1 : $m_s_None$()))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.resolution.stages.merge.AsyncKeyCriteria"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.resolution.stages.merge.AsyncKeyCriteria;", depth))
}
var $d_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.merge.AsyncKeyCriteria", {
  Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria: 1,
  O: 1,
  Lamf_plugins_domain_shapes_resolution_stages_merge_KeyCriteria: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_merge_AsyncKeyCriteria;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$1.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$1.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$1.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$1.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var s = $as_Lamf_core_model_domain_Shape(x2.value$2);
    return s
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$1.prototype.init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm = (function($$outer) {
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$1.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  return (x1 instanceof $c_s_Some)
});
var $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$1: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.MinShapeAlgorithm$$anonfun$1", {
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$1.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$2.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$2;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$2() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$2.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$2.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$2.prototype.applyOrElse__s_Option__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var s = $as_Lamf_core_model_domain_Shape(x2.value$2);
    return s
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$2.prototype.init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm = (function($$outer) {
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__s_Option__Z($as_s_Option(x))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__s_Option__F1__O($as_s_Option(x), $default)
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$2.prototype.isDefinedAt__s_Option__Z = (function(x1) {
  return (x1 instanceof $c_s_Some)
});
var $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$2 = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$2: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.MinShapeAlgorithm$$anonfun$2", {
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$2.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_MinShapeAlgorithm$$anonfun$2;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation$$anonfun$1.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation$$anonfun$1.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation$$anonfun$1.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation$$anonfun$1.prototype.init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation = (function($$outer) {
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation$$anonfun$1.prototype.isDefinedAt__Lamf_core_model_domain_AmfElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_core_model_domain_ScalarNode)
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation$$anonfun$1.prototype.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_model_domain_ScalarNode)) {
    var x2 = $as_Lamf_core_model_domain_ScalarNode(x1);
    var this$1 = $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1));
    var this$2 = this$1.option$1;
    return $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()))
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_AmfElement__Z($as_Lamf_core_model_domain_AmfElement(x))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_AmfElement__F1__O($as_Lamf_core_model_domain_AmfElement(x), $default)
});
var $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation$$anonfun$1: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.RestrictionComputation$$anonfun$1", {
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation$$anonfun$1.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_RestrictionComputation$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer() {
  $c_O.call(this);
  this.context$1 = null;
  this.withoutCaching$1 = false
}
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext = (function(context) {
  this.context$1 = context;
  this.withoutCaching$1 = false;
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.canonicalTuple__Lamf_plugins_domain_shapes_models_TupleShape__Lamf_core_model_domain_Shape = (function(tuple) {
  this.canonicalLogicalConstraints__Lamf_core_model_domain_Shape__V(tuple);
  if ($as_sc_Seq(tuple.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).nonEmpty__Z()) {
    return this.canonicalInheritance__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(tuple)
  } else {
    var jsx$1 = $m_sc_Seq$();
    var array = [$as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))];
    var elem = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
    var acc = new $c_sr_ObjectRef().init___O(elem);
    var jsx$4 = $as_sc_Seq(tuple.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().TupleItems$2));
    var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        var x1 = $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeNormalizer__normalize__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape($this, shape);
        if ((x1 !== null)) {
          var jsx$3 = $m_sc_Seq$();
          var array$1 = [x1];
          return $as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)))
        } else {
          throw new $c_s_MatchError().init___O(x1)
        }
      })
    })(this));
    var this$6 = $m_sc_Seq$();
    var sources = $as_sc_Seq(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$2, this$6.ReusableCBFInstance$2));
    sources.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, acc$1) {
      return (function(source$2) {
        var source = $as_sc_Seq(source$2);
        source.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, acc$1$1) {
          return (function(shape$2$1) {
            var shape$1 = $as_Lamf_core_model_domain_Shape(shape$2$1);
            var jsx$8 = $as_sc_Seq(acc$1$1.elem$1);
            var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, shape$3) {
              return (function(x$5$2) {
                var x$5 = $as_sc_Seq(x$5$2);
                var jsx$7 = $m_sc_Seq$();
                var array$2 = [shape$3];
                var jsx$6 = jsx$7.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2));
                var this$9 = $m_sc_Seq$();
                return $as_sc_Seq(x$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$6, this$9.ReusableCBFInstance$2))
              })
            })($this$1, shape$1));
            var this$10 = $m_sc_Seq$();
            acc$1$1.elem$1 = $as_sc_Seq(jsx$8.map__F1__scg_CanBuildFrom__O(jsx$5, this$10.ReusableCBFInstance$2))
          })
        })(this$2$1, acc$1)))
      })
    })(this, acc)));
    if (($as_sc_Seq(acc.elem$1).length__I() === 1)) {
      var jsx$11 = tuple.fields$2;
      var jsx$10 = $m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().TupleItems$2;
      var jsx$9 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq($as_sc_Seq(acc.elem$1).head__O()), new $c_Lamf_core_parser_Annotations().init___());
      var this$12 = $m_s_Option$().apply__O__s_Option(tuple.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().TupleItems$2));
      if (this$12.isEmpty__Z()) {
        var this$13 = $m_s_None$()
      } else {
        var arg1 = this$12.get__O();
        var x$6 = $as_Lamf_core_parser_Value(arg1);
        var this$13 = new $c_s_Some().init___O(x$6.annotations$1)
      };
      jsx$11.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(jsx$10, jsx$9, $as_Lamf_core_parser_Annotations((this$13.isEmpty__Z() ? ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()) : this$13.get__O())));
      return tuple
    } else {
      var jsx$16 = $as_sc_Seq(acc.elem$1);
      var jsx$12 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1, tuple$1) {
        return (function(items$2) {
          var items = $as_sc_Seq(items$2);
          var recursionErrorHandler = new $c_s_Some().init___O(this$5$1.context$1.errorHandler$1);
          var withRecursionBase = $m_s_None$();
          var traversal = new $c_Lamf_core_traversal_ModelTraversalRegistry().init___();
          var newTuple = $as_Lamf_plugins_domain_shapes_models_TupleShape($f_Lamf_plugins_domain_shapes_models_ShapeHelpers__cloneShape__s_Option__s_Option__Lamf_core_traversal_ModelTraversalRegistry__Z__Lamf_core_model_domain_Shape(tuple$1, recursionErrorHandler, withRecursionBase, traversal, false));
          var jsx$15 = newTuple.fields$2;
          var jsx$14 = $m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().Items$1;
          var jsx$13 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(items, new $c_Lamf_core_parser_Annotations().init___());
          var this$16 = $m_s_Option$().apply__O__s_Option(tuple$1.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().Items$1));
          if (this$16.isEmpty__Z()) {
            var this$17 = $m_s_None$()
          } else {
            var arg1$1 = this$16.get__O();
            var x$7 = $as_Lamf_core_parser_Value(arg1$1);
            var this$17 = new $c_s_Some().init___O(x$7.annotations$1)
          };
          return jsx$15.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(jsx$14, jsx$13, $as_Lamf_core_parser_Annotations((this$17.isEmpty__Z() ? ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()) : this$17.get__O())))
        })
      })(this, tuple));
      var this$19 = $m_sc_Seq$();
      jsx$16.map__F1__scg_CanBuildFrom__O(jsx$12, this$19.ReusableCBFInstance$2);
      $m_Lamf_core_parser_Annotations$();
      var annotations = new $c_Lamf_core_parser_Annotations().init___();
      var union = new $c_Lamf_plugins_domain_shapes_models_UnionShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
      union.id$1 = (tuple.id$1 + "resolved");
      var this$23 = $as_Lamf_core_model_StrField(tuple.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
      var this$24 = this$23.option$1;
      var name = $as_T((this$24.isEmpty__Z() ? null : this$24.get__O()));
      $m_Lamf_core_parser_Annotations$();
      var a = new $c_Lamf_core_parser_Annotations().init___();
      $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(union, name, a);
      return union
    }
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.cleanUnnecessarySyntax__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape = (function(shape) {
  shape.annotations__Lamf_core_parser_Annotations().reject__F1__Lamf_core_parser_Annotations(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(a$2) {
      var a = $as_Lamf_core_model_domain_Annotation(a$2);
      return (!$is_Lamf_core_model_domain_PerpetualAnnotation(a))
    })
  })(this)));
  return shape
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.productPrefix__T = (function() {
  return "ShapeCanonizer"
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.canonicalScalar__Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_core_model_domain_Shape = (function(scalar) {
  this.canonicalLogicalConstraints__Lamf_core_model_domain_Shape__V(scalar);
  return (($m_s_Option$().apply__O__s_Option($as_sc_Seq(scalar.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1))).isDefined__Z() && $as_sc_Seq(scalar.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).nonEmpty__Z()) ? this.canonicalInheritance__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(scalar) : scalar)
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.ensureInheritanceAnnotations$1__p1__Lamf_core_model_domain_extensions_PropertyShape__Lamf_core_model_domain_extensions_PropertyShape__O = (function(property, canonicalProperty) {
  var annotationOption = property.annotations$2.find__jl_Class__s_Option($d_Lamf_core_annotations_InheritanceProvenance.getClassOf());
  var annotationOptionFromCanonical = canonicalProperty.annotations$2.find__jl_Class__s_Option($d_Lamf_core_annotations_InheritanceProvenance.getClassOf());
  if ((annotationOption instanceof $c_s_Some)) {
    var x4 = $as_s_Some(annotationOption);
    var annotation = $as_Lamf_core_annotations_InheritanceProvenance(x4.value$2);
    var x = $m_s_None$();
    if ((x === annotationOptionFromCanonical)) {
      return canonicalProperty.annotations$2.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(annotation)
    }
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.canonicalInheritance__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape = (function(shape) {
  if (this.endpointSimpleInheritance__Lamf_core_model_domain_Shape__Z(shape)) {
    var referencedShape = $as_Lamf_core_model_domain_Shape($as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).head__O());
    this.aggregateExamples__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__V(shape, referencedShape);
    if (shape.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_AutoGeneratedName.getClassOf())) {
      var annotation = new $c_Lamf_core_annotations_AutoGeneratedName().init___();
      $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(referencedShape, annotation)
    };
    if ((!(referencedShape instanceof $c_Lamf_core_model_domain_RecursiveShape))) {
      referencedShape.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ResolvedInheritance().init___())
    };
    return $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeNormalizer__normalize__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(this, referencedShape)
  } else {
    var superTypes = $as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1));
    if (this.context$1.keepEditingInfo$1) {
      var jsx$2 = $as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1));
      var jsx$1 = new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$$anonfun$1().init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer(this);
      var this$1 = $m_sc_Seq$();
      var oldInherits = $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))
    } else {
      var oldInherits = $m_sci_Nil$()
    };
    shape.fields__Lamf_core_parser_Fields().removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1);
    var elem = this.normalizeWithoutCaching__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(shape);
    var accShape = new $c_sr_ObjectRef().init___O(elem);
    var elem$1 = $m_sci_Nil$();
    var superShapeswithDiscriminator = new $c_sr_ObjectRef().init___O(elem$1);
    var elem$2 = $m_sci_Nil$();
    var inheritedIds = new $c_sr_ObjectRef().init___O(elem$2);
    superTypes.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, superShapeswithDiscriminator$1, inheritedIds$1, accShape$1) {
      return (function(superNode$2) {
        var superNode = $as_Lamf_core_model_domain_Shape(superNode$2);
        var canonicalSuperNode = $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeNormalizer__normalize__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape($this, superNode);
        if ($this.hasDiscriminator__Lamf_core_model_domain_Shape__Z(canonicalSuperNode)) {
          var jsx$5 = $as_sc_Seq(superShapeswithDiscriminator$1.elem$1);
          var jsx$4 = $m_sc_Seq$();
          var array = [$as_Lamf_plugins_domain_shapes_models_NodeShape(canonicalSuperNode)];
          var jsx$3 = jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
          var this$7 = $m_sc_Seq$();
          superShapeswithDiscriminator$1.elem$1 = $as_sc_Seq(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$7.ReusableCBFInstance$2))
        };
        if ($is_Lamf_plugins_domain_shapes_models_InheritanceChain(canonicalSuperNode)) {
          var jsx$10 = $as_sc_Seq(inheritedIds$1.elem$1);
          var jsx$9 = $m_sc_Seq$();
          var array$1 = [canonicalSuperNode.id$1];
          var jsx$8 = $as_sc_TraversableLike(jsx$9.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)));
          var jsx$7 = $as_Lamf_plugins_domain_shapes_models_InheritanceChain(canonicalSuperNode).inheritedIds$2;
          var this$10 = $m_sc_Seq$();
          var jsx$6 = $as_sc_GenTraversableOnce(jsx$8.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$7, this$10.ReusableCBFInstance$2));
          var this$11 = $m_sc_Seq$();
          inheritedIds$1.elem$1 = $as_sc_Seq(jsx$10.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$6, this$11.ReusableCBFInstance$2))
        } else {
          var jsx$12 = $as_sc_Seq(inheritedIds$1.elem$1);
          var jsx$11 = canonicalSuperNode.id$1;
          var this$12 = $m_sc_Seq$();
          inheritedIds$1.elem$1 = $as_sc_Seq(jsx$12.$$colon$plus__O__scg_CanBuildFrom__O(jsx$11, this$12.ReusableCBFInstance$2))
        };
        var newMinShape = $this.context$1.minShape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape($as_Lamf_core_model_domain_Shape(accShape$1.elem$1), canonicalSuperNode);
        accShape$1.elem$1 = $this.actionWithoutCaching__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(newMinShape)
      })
    })(this, superShapeswithDiscriminator, inheritedIds, accShape)));
    if (this.context$1.keepEditingInfo$1) {
      var jsx$14 = $as_Lamf_core_model_domain_Shape(accShape.elem$1).annotations__Lamf_core_parser_Annotations();
      var jsx$13 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
        return (function(x$1$2) {
          var x$1 = $as_Lamf_core_model_domain_Shape(x$1$2);
          return x$1.id$1
        })
      })(this));
      var this$13 = $m_sc_Seq$();
      jsx$14.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_InheritedShapes().init___sc_Seq($as_sc_Seq(oldInherits.map__F1__scg_CanBuildFrom__O(jsx$13, this$13.ReusableCBFInstance$2))))
    };
    var this$14 = shape.id$1;
    var that = $as_Lamf_core_model_domain_Shape(accShape.elem$1).id$1;
    if ((!(this$14 === that))) {
      this.context$1.cache$1.registerMapping__T__T__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache(shape.id$1, $as_Lamf_core_model_domain_Shape(accShape.elem$1).id$1);
      var this$15 = $as_Lamf_core_model_domain_Shape(accShape.elem$1);
      var value = shape.id$1;
      $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$15, value)
    };
    var x1 = $as_Lamf_core_model_domain_Shape(accShape.elem$1);
    if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
      var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x1);
      $as_sc_Seq(superShapeswithDiscriminator.elem$1).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, x2$1) {
        return (function(x$2$2) {
          var x$2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x$2$2);
          $f_Lamf_plugins_domain_shapes_models_InheritanceChain__linkSubType__Lamf_plugins_domain_shapes_models_AnyShape__V(x$2, x2$1)
        })
      })(this, x2)))
    };
    var x1$2 = $as_Lamf_core_model_domain_Shape(accShape.elem$1);
    if ($is_Lamf_plugins_domain_shapes_models_InheritanceChain(x1$2)) {
      var jsx$17 = $as_Lamf_plugins_domain_shapes_models_InheritanceChain(x1$2);
      var jsx$16 = $as_Lamf_plugins_domain_shapes_models_InheritanceChain(x1$2).inheritedIds$2;
      var jsx$15 = $as_sc_Seq(inheritedIds.elem$1);
      var this$16 = $m_scm_Seq$();
      jsx$17.inheritedIds$2 = $as_scm_Seq(jsx$16.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$15, this$16.ReusableCBFInstance$2))
    };
    matchEnd4$3: {
      if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
        var x2$3 = $as_Lamf_plugins_domain_shapes_models_NodeShape(shape);
        if (this.isSimpleInheritanceDeclaration__p1__Lamf_plugins_domain_shapes_models_NodeShape__sc_Seq__Z(x2$3, superTypes)) {
          this.aggregateExamples__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__V($as_Lamf_core_model_domain_Shape(accShape.elem$1), $as_Lamf_core_model_domain_Shape(superTypes.head__O()));
          break matchEnd4$3
        }
      }
    };
    return $as_Lamf_core_model_domain_Shape(accShape.elem$1)
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer) && ($as_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer(x$1), true))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.normalizeAction__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape = (function(shape) {
  this.cleanUnnecessarySyntax__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(shape);
  if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_UnionShape(shape);
    var canonical = this.canonicalUnion__Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_model_domain_Shape(x2)
  } else if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
    var x3 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(shape);
    var canonical = this.canonicalScalar__Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_core_model_domain_Shape(x3)
  } else if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
    var x4 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(shape);
    var canonical = this.canonicalArray__Lamf_plugins_domain_shapes_models_ArrayShape__Lamf_core_model_domain_Shape(x4)
  } else if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_MatrixShape)) {
    var x5 = $as_Lamf_plugins_domain_shapes_models_MatrixShape(shape);
    var canonical = this.canonicalMatrix__Lamf_plugins_domain_shapes_models_MatrixShape__Lamf_core_model_domain_Shape(x5)
  } else if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_TupleShape)) {
    var x6 = $as_Lamf_plugins_domain_shapes_models_TupleShape(shape);
    var canonical = this.canonicalTuple__Lamf_plugins_domain_shapes_models_TupleShape__Lamf_core_model_domain_Shape(x6)
  } else if ((shape instanceof $c_Lamf_core_model_domain_extensions_PropertyShape)) {
    var x7 = $as_Lamf_core_model_domain_extensions_PropertyShape(shape);
    var canonical = this.canonicalProperty__Lamf_core_model_domain_extensions_PropertyShape__Lamf_core_model_domain_Shape(x7)
  } else if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_FileShape)) {
    var x8 = $as_Lamf_plugins_domain_shapes_models_FileShape(shape);
    var canonical = this.canonicalShape__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(x8)
  } else if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_NilShape)) {
    var x9 = $as_Lamf_plugins_domain_shapes_models_NilShape(shape);
    var canonical = this.canonicalShape__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(x9)
  } else if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
    var x10 = $as_Lamf_plugins_domain_shapes_models_NodeShape(shape);
    var canonical = this.canonicalNode__Lamf_plugins_domain_shapes_models_NodeShape__Lamf_core_model_domain_Shape(x10)
  } else if ((shape instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
    var x11 = $as_Lamf_core_model_domain_RecursiveShape(shape);
    var canonical = x11
  } else {
    if ((!(shape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape))) {
      throw new $c_s_MatchError().init___O(shape)
    };
    var x12 = $as_Lamf_plugins_domain_shapes_models_AnyShape(shape);
    var canonical = this.canonicalAny__p1__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_model_domain_Shape(x12)
  };
  if ((!this.withoutCaching$1)) {
    this.context$1.cache$1.$$plus__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationCache(canonical)
  };
  this.context$1.cache$1.updateFixPoints__Lamf_core_model_domain_Shape__Z__V(canonical, this.withoutCaching$1);
  return canonical
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.normalizeWithoutCaching__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape = (function(s) {
  this.withoutCaching$1 = true;
  var t = $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeNormalizer__normalize__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(this, s);
  this.withoutCaching$1 = false;
  return t
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.actionWithoutCaching__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape = (function(s) {
  this.withoutCaching$1 = true;
  var t = this.normalizeAction__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(s);
  this.withoutCaching$1 = false;
  return t
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.canonicalMatrix__Lamf_plugins_domain_shapes_models_MatrixShape__Lamf_core_model_domain_Shape = (function(matrix) {
  this.canonicalLogicalConstraints__Lamf_core_model_domain_Shape__V(matrix);
  if ($as_sc_Seq(matrix.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).nonEmpty__Z()) {
    return this.canonicalInheritance__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(matrix)
  } else {
    var x1 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(matrix.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1)));
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var items = $as_Lamf_core_model_domain_Shape(x2.value$2);
      var newItems = $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeNormalizer__normalize__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(this, items);
      matrix.fields$2.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1);
      if ((newItems instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
        var x2$2 = $as_Lamf_plugins_domain_shapes_models_UnionShape(newItems);
        var jsx$2 = $as_sc_Seq(x2$2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1));
        var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, matrix$1) {
          return (function(x0$1$2) {
            var x0$1 = $as_Lamf_core_model_domain_Shape(x0$1$2);
            if ((x0$1 instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
              var x2$1 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(x0$1);
              var recursionErrorHandler = new $c_s_Some().init___O($this.context$1.errorHandler$1);
              var withRecursionBase = $m_s_None$();
              var traversal = new $c_Lamf_core_traversal_ModelTraversalRegistry().init___();
              var this$1 = $as_Lamf_plugins_domain_shapes_models_MatrixShape($f_Lamf_plugins_domain_shapes_models_ShapeHelpers__cloneShape__s_Option__s_Option__Lamf_core_traversal_ModelTraversalRegistry__Z__Lamf_core_model_domain_Shape(matrix$1, recursionErrorHandler, withRecursionBase, traversal, false));
              var field = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1;
              return $as_Lamf_plugins_domain_shapes_models_MatrixShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$1, field, x2$1))
            } else {
              var recursionErrorHandler$1 = new $c_s_Some().init___O($this.context$1.errorHandler$1);
              var withRecursionBase$1 = $m_s_None$();
              var traversal$1 = new $c_Lamf_core_traversal_ModelTraversalRegistry().init___();
              return $as_Lamf_plugins_domain_shapes_models_MatrixShape($f_Lamf_plugins_domain_shapes_models_ShapeHelpers__cloneShape__s_Option__s_Option__Lamf_core_traversal_ModelTraversalRegistry__Z__Lamf_core_model_domain_Shape(matrix$1, recursionErrorHandler$1, withRecursionBase$1, traversal$1, false)).toArrayShape__Lamf_plugins_domain_shapes_models_ArrayShape().withItems__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_ArrayShape(x0$1)
            }
          })
        })(this, matrix));
        var this$2 = $m_sc_Seq$();
        var newUnionItems = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
        var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1;
        $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(x2$2, field$1, newUnionItems);
        var x1$3 = $m_s_Option$().apply__O__s_Option(matrix.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
        if ((x1$3 instanceof $c_s_Some)) {
          var x2$3 = $as_s_Some(x1$3);
          var name = $as_Lamf_core_parser_Value(x2$3.value$2);
          var name$1 = name.value$1.toString__T();
          $m_Lamf_core_parser_Annotations$();
          var a = new $c_Lamf_core_parser_Annotations().init___();
          return $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(x2$2, name$1, a))
        } else {
          return x2$2
        }
      } else if ((newItems instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
        var x3 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(newItems);
        var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1;
        return $as_Lamf_plugins_domain_shapes_models_MatrixShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(matrix, field$2, x3))
      } else {
        return matrix.toArrayShape__Lamf_plugins_domain_shapes_models_ArrayShape().withItems__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_ArrayShape(newItems)
      }
    } else {
      return matrix
    }
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.hasDiscriminator__Lamf_core_model_domain_Shape__Z = (function(shape) {
  if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_NodeShape(shape);
    return $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Discriminator$1)).option$1.isDefined__Z()
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.aggregateExamples__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__V = (function(shape, referencedShape) {
  matchEnd5: {
    if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
      var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(shape);
      if ((referencedShape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
        var x3 = $as_Lamf_plugins_domain_shapes_models_AnyShape(referencedShape);
        if (x2.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf())) {
          var x1$2_$_$$und1$f = x3;
          var x1$2_$_$$und2$f = x2
        } else {
          var x1$2_$_$$und1$f = x2;
          var x1$2_$_$$und2$f = x3
        };
        var from = $as_Lamf_plugins_domain_shapes_models_AnyShape(x1$2_$_$$und1$f);
        var to = $as_Lamf_plugins_domain_shapes_models_AnyShape(x1$2_$_$$und2$f);
        this.copyExamples__p1__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_domain_shapes_models_AnyShape__V(from, to);
        var namesCache = $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        if (($as_sc_Seq(to.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).size__I() > 1)) {
          $as_sc_Seq(to.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, namesCache$1) {
            return (function(example$2) {
              var example = $as_Lamf_plugins_domain_shapes_models_Example(example$2);
              if ($as_Lamf_core_model_StrField(example.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Name$1)).option$1.isEmpty__Z()) {
                var jsx$1 = true
              } else {
                var this$1 = $as_Lamf_core_model_StrField(example.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Name$1));
                var this$2 = this$1.option$1;
                var jsx$1 = namesCache$1.contains__O__Z($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())))
              };
              if (jsx$1) {
                var i = 0;
                var name = ("example_" + i);
                while (namesCache$1.contains__O__Z(name)) {
                  i = ((1 + i) | 0);
                  name = ("example_" + i)
                };
                namesCache$1.add__O__Z(name);
                var name$1 = name;
                $m_Lamf_core_parser_Annotations$();
                var a = new $c_Lamf_core_parser_Annotations().init___();
                return $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(example, name$1, a)
              } else {
                var this$4 = $as_Lamf_core_model_StrField(example.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Name$1));
                var this$5 = this$4.option$1;
                return namesCache$1.add__O__Z($as_T((this$5.isEmpty__Z() ? null : this$5.get__O())))
              }
            })
          })(this, namesCache)));
          (void 0)
        } else {
          (void 0)
        };
        break matchEnd5
      }
    }
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.context__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext = (function() {
  return this.context$1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.endpointSimpleInheritance__Lamf_core_model_domain_Shape__Z = (function(shape) {
  var rc5 = false;
  var x2 = null;
  if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
    rc5 = true;
    x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(shape);
    if (x2.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf())) {
      return false
    }
  };
  if (rc5) {
    var this$1 = x2;
    var jsx$1 = ($as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).size__I() === 1)
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var this$2 = x2;
    var superType = $as_Lamf_core_model_domain_Shape($as_sc_Seq(this$2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).head__O());
    var jsx$2 = $m_sc_Seq$();
    var array = [$m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1, $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Examples$1, $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Name$1];
    var ignoredFields = $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
    var this$5 = shape.fields__Lamf_core_parser_Fields();
    var this$8 = this$5.fs$1;
    var this$6 = $m_Lamf_core_parser_FieldEntry$();
    var f = $f_F2__tupled__F1(this$6);
    var this$7 = $m_sci_Iterable$();
    var bf = this$7.ReusableCBFInstance$2;
    var effectiveFields = $as_sc_Iterable($as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$8, f, bf)).filterNot__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ignoredFields$1) {
      return (function(f$2) {
        var f$1 = $as_Lamf_core_parser_FieldEntry(f$2);
        return ignoredFields$1.contains__O__Z(f$1.field$1)
      })
    })(this, ignoredFields))));
    return this.validFields__p1__sc_Iterable__Lamf_core_model_domain_Shape__Z(effectiveFields, superType)
  };
  return false
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.isSimpleInheritanceDeclaration__p1__Lamf_plugins_domain_shapes_models_NodeShape__sc_Seq__Z = (function(n, inherits) {
  return ((n.annotations$2.contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf()) && (inherits.size__I() === 1)) && $as_sc_Seq(n.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1)).isEmpty__Z())
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.canonicalUnion__Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_model_domain_Shape = (function(union) {
  if ($as_sc_Seq(union.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).nonEmpty__Z()) {
    return this.canonicalInheritance__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(union)
  } else {
    var anyOfAcc = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    $as_sc_Seq(union.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, anyOfAcc$1) {
      return (function(unionMember$2) {
        var unionMember = $as_Lamf_core_model_domain_Shape(unionMember$2);
        var normalizedUnionMember = $this.normalizeWithoutCaching__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(unionMember);
        if ((normalizedUnionMember instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
          var x2 = $as_Lamf_plugins_domain_shapes_models_UnionShape(normalizedUnionMember);
          $as_sc_Seq(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, anyOfAcc$1$1) {
            return (function(e$2) {
              var e = $as_Lamf_core_model_domain_Shape(e$2);
              return anyOfAcc$1$1.$$plus$eq__O__scm_ListBuffer(e)
            })
          })($this, anyOfAcc$1)));
          return (void 0)
        } else if ((normalizedUnionMember !== null)) {
          return anyOfAcc$1.$$plus$eq__O__scm_ListBuffer(normalizedUnionMember)
        } else {
          throw new $c_s_MatchError().init___O(normalizedUnionMember)
        }
      })
    })(this, anyOfAcc)));
    var x1 = $m_s_Option$().apply__O__s_Option(union.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1));
    if ((x1 instanceof $c_s_Some)) {
      var x2$1 = $as_s_Some(x1);
      var anyOf = $as_Lamf_core_parser_Value(x2$1.value$2);
      var anyOfAnnotations = anyOf.annotations$1
    } else {
      $m_Lamf_core_parser_Annotations$();
      var anyOfAnnotations = new $c_Lamf_core_parser_Annotations().init___()
    };
    union.fields$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(anyOfAcc, new $c_Lamf_core_parser_Annotations().init___()), anyOfAnnotations);
    return union
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.copyTracking__p1__Lamf_plugins_domain_shapes_models_Example__Lamf_plugins_domain_shapes_models_Example__V = (function(duplicate, receiver) {
  var this$1 = duplicate.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_TrackedElement.getClassOf());
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var dupAnnotation = $as_Lamf_core_annotations_TrackedElement(arg1);
    var jsx$2 = receiver.annotations$1;
    var this$2 = receiver.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_TrackedElement.getClassOf());
    if (this$2.isEmpty__Z()) {
      var jsx$1 = new $c_Lamf_core_annotations_TrackedElement().init___sci_Set(dupAnnotation.parents$1)
    } else {
      var arg1$1 = this$2.get__O();
      var receiverAnnotation = $as_Lamf_core_annotations_TrackedElement(arg1$1);
      receiver.annotations$1.reject__F1__Lamf_core_parser_Annotations(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x$3$2) {
          var x$3 = $as_Lamf_core_model_domain_Annotation(x$3$2);
          return (x$3 instanceof $c_Lamf_core_annotations_TrackedElement)
        })
      })(this)));
      var jsx$1 = new $c_Lamf_core_annotations_TrackedElement().init___sci_Set($as_sci_Set(receiverAnnotation.parents$1.$$plus$plus__sc_GenTraversableOnce__sc_Set(dupAnnotation.parents$1)))
    };
    jsx$2.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(jsx$1)
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.canonicalAny__p1__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_model_domain_Shape = (function(any) {
  this.canonicalLogicalConstraints__Lamf_core_model_domain_Shape__V(any);
  return ($as_sc_Seq(any.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).nonEmpty__Z() ? this.canonicalInheritance__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(any) : $m_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_AnyShapeAdjuster$().apply__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_domain_shapes_models_AnyShape(any))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.canonicalLogicalConstraints__Lamf_core_model_domain_Shape__V = (function(shape) {
  var oldLogicalConstraints = shape.fields__Lamf_core_parser_Fields().getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_core_metamodel_domain_ShapeModel$().And$1);
  if ($m_s_Option$().apply__O__s_Option(oldLogicalConstraints).isDefined__Z()) {
    var jsx$2 = $as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().And$1));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(shape$2$2) {
        var shape$2 = $as_Lamf_core_model_domain_Shape(shape$2$2);
        return $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeNormalizer__normalize__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape($this, shape$2)
      })
    })(this));
    var this$1 = $m_sc_Seq$();
    var newLogicalConstraints = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
    var field = $m_Lamf_core_metamodel_domain_ShapeModel$().And$1;
    var annotations = oldLogicalConstraints.annotations$1;
    $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(shape, field, newLogicalConstraints, annotations)
  };
  oldLogicalConstraints = shape.fields__Lamf_core_parser_Fields().getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_core_metamodel_domain_ShapeModel$().Or$1);
  if ($m_s_Option$().apply__O__s_Option(oldLogicalConstraints).isDefined__Z()) {
    var jsx$4 = $as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Or$1));
    var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
      return (function(shape$3$2) {
        var shape$3 = $as_Lamf_core_model_domain_Shape(shape$3$2);
        return $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeNormalizer__normalize__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(this$2, shape$3)
      })
    })(this));
    var this$3 = $m_sc_Seq$();
    var newLogicalConstraints$2 = $as_sc_Seq(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$3.ReusableCBFInstance$2));
    var field$1 = $m_Lamf_core_metamodel_domain_ShapeModel$().Or$1;
    var annotations$1 = oldLogicalConstraints.annotations$1;
    $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(shape, field$1, newLogicalConstraints$2, annotations$1)
  };
  oldLogicalConstraints = shape.fields__Lamf_core_parser_Fields().getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_core_metamodel_domain_ShapeModel$().Xone$1);
  if ($m_s_Option$().apply__O__s_Option(oldLogicalConstraints).isDefined__Z()) {
    var jsx$6 = $as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Xone$1));
    var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
      return (function(shape$4$2) {
        var shape$4 = $as_Lamf_core_model_domain_Shape(shape$4$2);
        return $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeNormalizer__normalize__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(this$3$1, shape$4)
      })
    })(this));
    var this$4 = $m_sc_Seq$();
    var newLogicalConstraints$3 = $as_sc_Seq(jsx$6.map__F1__scg_CanBuildFrom__O(jsx$5, this$4.ReusableCBFInstance$2));
    var field$2 = $m_Lamf_core_metamodel_domain_ShapeModel$().Xone$1;
    var annotations$2 = oldLogicalConstraints.annotations$1;
    $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(shape, field$2, newLogicalConstraints$3, annotations$2)
  };
  var notConstraint = shape.fields__Lamf_core_parser_Fields().getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_core_metamodel_domain_ShapeModel$().Not$1);
  if ($m_s_Option$().apply__O__s_Option(notConstraint).isDefined__Z()) {
    var shape$1 = $as_Lamf_core_model_domain_Shape(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Not$1));
    var newLogicalConstraint = $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeNormalizer__normalize__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(this, shape$1);
    var field$3 = $m_Lamf_core_metamodel_domain_ShapeModel$().Not$1;
    var annotations$3 = notConstraint.annotations$1;
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(shape, field$3, newLogicalConstraint, annotations$3)
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.copyExamples__p1__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_domain_shapes_models_AnyShape__V = (function(from, to) {
  $as_sc_Seq(from.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, to$1) {
    return (function(e1$2) {
      var e1 = $as_Lamf_plugins_domain_shapes_models_Example(e1$2);
      var x1 = $as_sc_Seq(to$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, e1$1) {
        return (function(e2$2) {
          var e2 = $as_Lamf_plugins_domain_shapes_models_Example(e2$2);
          var exampleIdsAreEqual = (e1$1.id$1 === e2.id$1);
          var this$1 = $as_Lamf_core_model_StrField(e1$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1)).option$1;
          var thiz = $as_T((this$1.isEmpty__Z() ? "" : this$1.get__O()));
          var jsx$1 = $as_T(thiz.trim());
          var this$3 = $as_Lamf_core_model_StrField(e2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1)).option$1;
          var thiz$1 = $as_T((this$3.isEmpty__Z() ? "" : this$3.get__O()));
          var rawExamplesAreEqual = (jsx$1 === $as_T(thiz$1.trim()));
          var this$5 = $as_Lamf_core_model_StrField(e1$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Name$1));
          var this$6 = this$5.option$1;
          var jsx$2 = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
          var this$7 = $as_Lamf_core_model_StrField(e2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Name$1));
          var this$8 = this$7.option$1;
          var examplesHaveSameName = (jsx$2 === $as_T((this$8.isEmpty__Z() ? null : this$8.get__O())));
          return (exampleIdsAreEqual || (rawExamplesAreEqual && examplesHaveSameName))
        })
      })($this, e1)));
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var toExample = $as_Lamf_plugins_domain_shapes_models_Example(x2.value$2);
        $this.copyTracking__p1__Lamf_plugins_domain_shapes_models_Example__Lamf_plugins_domain_shapes_models_Example__V(e1, toExample);
        return (void 0)
      } else {
        var x = $m_s_None$();
        if ((x === x1)) {
          e1.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_LocalElement().init___());
          var field = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Examples$1;
          var jsx$5 = $as_sc_Seq(to$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1));
          var jsx$4 = $m_sc_Seq$();
          var array = [e1];
          var jsx$3 = jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
          var this$11 = $m_sc_Seq$();
          var values = $as_sc_Seq(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$11.ReusableCBFInstance$2));
          return $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(to$1, field, values)
        } else {
          throw new $c_s_MatchError().init___O(x1)
        }
      }
    })
  })(this, to)))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.validFields__p1__sc_Iterable__Lamf_core_model_domain_Shape__Z = (function(entries, superType) {
  var nonLocalReturnKey1 = new $c_O().init___();
  try {
    entries.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, superType$1, nonLocalReturnKey1$1) {
      return (function(e$2) {
        var e = $as_Lamf_core_parser_FieldEntry(e$2);
        var x1 = superType$1.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option(e.field$1);
        matchEnd4: {
          if ((x1 instanceof $c_s_Some)) {
            var x2 = $as_s_Some(x1);
            var s = $as_Lamf_core_parser_FieldEntry(x2.value$2);
            if (s.value$1.value$1.equals__O__Z(e.value$1.value$1)) {
              break matchEnd4
            }
          };
          var x = e.field$1;
          var x$2 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1;
          if ((((x === null) ? (x$2 === null) : x.equals__O__Z(x$2)) && (!(superType$1 instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)))) {
            break matchEnd4
          };
          throw new $c_sr_NonLocalReturnControl$mcZ$sp().init___O__Z(nonLocalReturnKey1$1, false)
        }
      })
    })(this, superType, nonLocalReturnKey1)));
    return true
  } catch (e$3) {
    if ((e$3 instanceof $c_sr_NonLocalReturnControl)) {
      var ex = $as_sr_NonLocalReturnControl(e$3);
      if ((ex.key$2 === nonLocalReturnKey1)) {
        return ex.value$mcZ$sp__Z()
      } else {
        throw ex
      }
    } else {
      throw e$3
    }
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.canonicalShape__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape = (function(any) {
  this.canonicalLogicalConstraints__Lamf_core_model_domain_Shape__V(any);
  return ($as_sc_Seq(any.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).nonEmpty__Z() ? this.canonicalInheritance__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(any) : any)
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.canonicalArray__Lamf_plugins_domain_shapes_models_ArrayShape__Lamf_core_model_domain_Shape = (function(array) {
  this.canonicalLogicalConstraints__Lamf_core_model_domain_Shape__V(array);
  if ($as_sc_Seq(array.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).nonEmpty__Z()) {
    return this.canonicalInheritance__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(array)
  } else {
    var this$1 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(array.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1)));
    if (this$1.isEmpty__Z()) {
      var jsx$1 = array
    } else {
      var arg1 = this$1.get__O();
      var i = $as_Lamf_core_model_domain_Shape(arg1);
      var newItems = $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeNormalizer__normalize__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(this, i);
      array.annotations$2.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ExplicitField().init___());
      array.fields$2.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1);
      var jsx$1 = ((newItems instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape) ? (array.fields$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1, newItems, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___())), array.toMatrixShape__Lamf_plugins_domain_shapes_models_MatrixShape()) : (array.fields$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1, newItems, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___())), array))
    };
    return $as_Lamf_core_model_domain_Shape(jsx$1)
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.canonicalProperty__Lamf_core_model_domain_extensions_PropertyShape__Lamf_core_model_domain_Shape = (function(property) {
  var jsx$2 = property.fields$2;
  var jsx$1 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1;
  var shape = $as_Lamf_core_model_domain_Shape(property.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1));
  jsx$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(jsx$1, $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeNormalizer__normalize__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(this, shape), property.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1).annotations$1);
  return property
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.canonicalNode__Lamf_plugins_domain_shapes_models_NodeShape__Lamf_core_model_domain_Shape = (function(node) {
  this.canonicalLogicalConstraints__Lamf_core_model_domain_Shape__V(node);
  var annotation = new $c_Lamf_core_annotations_ExplicitField().init___();
  $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(node, annotation);
  if ($as_sc_Seq(node.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).nonEmpty__Z()) {
    return this.canonicalInheritance__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(node)
  } else {
    var jsx$2 = $as_sc_Seq(node.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(propertyShape$2) {
        var propertyShape = $as_Lamf_core_model_domain_extensions_PropertyShape(propertyShape$2);
        var x1 = $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeNormalizer__normalize__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape($this, propertyShape);
        if ((x1 instanceof $c_Lamf_core_model_domain_extensions_PropertyShape)) {
          var x2 = $as_Lamf_core_model_domain_extensions_PropertyShape(x1);
          $this.ensureInheritanceAnnotations$1__p1__Lamf_core_model_domain_extensions_PropertyShape__Lamf_core_model_domain_extensions_PropertyShape__O(propertyShape, x2);
          return x2
        } else {
          var this$1 = $this.context$1.errorHandler$1;
          var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
          var node$1 = x1.id$1;
          var property = $m_s_None$();
          var message = ("Resolution error: Expecting property shape, found " + x1);
          var lexical = x1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
          var location = x1.location__s_Option();
          this$1.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node$1, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
          return propertyShape
        }
      })
    })(this));
    var this$2 = $m_sc_Seq$();
    var canonicalProperties = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
    var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1;
    return $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(node, field, canonicalProperties))
  }
});
function $as_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.ShapeCanonizer"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.resolution.stages.shape_normalization.ShapeCanonizer;", depth))
}
var $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.ShapeCanonizer", {
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer: 1,
  O: 1,
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeNormalizer: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$$anonfun$1.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$$anonfun$1.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$$anonfun$1.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$$anonfun$1.prototype.init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer = (function($$outer) {
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$$anonfun$1.prototype.isDefinedAt__Lamf_core_model_domain_Shape__Z = (function(x1) {
  return ((x1 instanceof $c_Lamf_core_model_domain_RecursiveShape) || (x1 !== null))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_Shape__Z($as_Lamf_core_model_domain_Shape(x))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_Shape__F1__O($as_Lamf_core_model_domain_Shape(x), $default)
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$$anonfun$1.prototype.applyOrElse__Lamf_core_model_domain_Shape__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
    var x2 = $as_Lamf_core_model_domain_RecursiveShape(x1);
    return x2
  } else if ((x1 !== null)) {
    var this$1 = $as_Lamf_core_model_StrField(x1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
    var this$2 = this$1.option$1;
    return $as_Lamf_core_model_domain_Shape(x1.link__T__Lamf_core_parser_Annotations__O($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___())))
  } else {
    return $default.apply__O__O(x1)
  }
});
var $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$$anonfun$1: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.ShapeCanonizer$$anonfun$1", {
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$$anonfun$1.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeCanonizer$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander() {
  $c_O.call(this);
  this.root$1 = null;
  this.recursionRegister$1 = null;
  this.context$1 = null;
  this.traversal$1 = null
}
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.isRequired__p1__Lamf_core_model_domain_extensions_PropertyShape__Z = (function(prop) {
  var this$1 = $as_Lamf_core_model_IntField(prop.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1)).option$1;
  if (this$1.isEmpty__Z()) {
    return true
  } else {
    var arg1 = this$1.get__O();
    var x$5 = $uI(arg1);
    return (x$5 > 0)
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.productPrefix__T = (function() {
  return "ShapeExpander"
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.expandInherits__Lamf_core_model_domain_Shape__V = (function(shape) {
  var oldInherits = shape.fields__Lamf_core_parser_Fields().getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1);
  if ($m_s_Option$().apply__O__s_Option(oldInherits).isDefined__Z()) {
    var jsx$3 = $as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, shape$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_model_domain_Shape(x0$1$2);
        var rc5 = false;
        var x2 = null;
        if ((x0$1 instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
          rc5 = true;
          x2 = $as_Lamf_core_model_domain_RecursiveShape(x0$1);
          var this$1 = x2;
          var this$2 = $as_Lamf_core_model_StrField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_RecursiveShapeModel$().FixPoint$1)).option$1;
          if ((!this$2.isEmpty__Z())) {
            var arg1 = this$2.get__O();
            var x$3 = $as_T(arg1);
            var that = shape$1.id$1;
            var jsx$2 = (x$3 === that)
          } else {
            var jsx$2 = false
          };
          if (jsx$2) {
            return $this.recursionRegister$1.recursionError__Lamf_core_model_domain_Shape__Lamf_core_model_domain_RecursiveShape__Lamf_core_traversal_ModelTraversalRegistry__s_Option__Lamf_core_model_domain_RecursiveShape(shape$1, x2, $this.traversal$1, $m_s_None$())
          }
        };
        if (rc5) {
          return x2
        };
        var normalizedParent = $this.recursiveNormalization__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(x0$1);
        return normalizedParent
      })
    })(this, shape));
    var this$4 = $m_sc_Seq$();
    var newInherits = $as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2));
    var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1;
    var annotations = oldInherits.annotations$1;
    $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(shape, field, newInherits, annotations)
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.traverseOptionalShapeFacet__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape = (function(shape, from) {
  if ($as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).nonEmpty__Z()) {
    var this$3 = this.traversal$1;
    var jsx$2 = $as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
      return (function(x$6$2) {
        var x$6 = $as_Lamf_core_model_domain_Shape(x$6$2);
        return x$6.id$1
      })
    })(this));
    var this$1 = $m_sc_Seq$();
    var shapeIds = $as_sci_Set($as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).toSet__sci_Set().$$plus__O__sc_Set(this.root$1.id$1));
    var previousWhiteList = this$3.whiteList$1;
    this$3.whiteList$1 = $as_sci_Set(this$3.whiteList$1.$$plus$plus__sc_GenTraversableOnce__sc_Set(shapeIds));
    var previousPath = this$3.currentPath$1;
    var element = $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeNormalizer__normalize__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(this, shape);
    this$3.currentPath$1 = previousPath;
    this$3.whiteList$1 = previousWhiteList;
    return element
  } else if ((shape instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
    return shape
  } else {
    var this$4 = this.traversal$1;
    var shapeId = from.id$1;
    var actual = $as_sci_Set(this$4.currentPath$1.$$plus__O__sc_Set(shapeId));
    var previousWhiteList$1 = this$4.whiteList$1;
    this$4.whiteList$1 = $as_sci_Set(this$4.whiteList$1.$$plus$plus__sc_GenTraversableOnce__sc_Set(actual));
    var previousPath$1 = this$4.currentPath$1;
    var element$1 = $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeNormalizer__normalize__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(this, shape);
    this$4.currentPath$1 = previousPath$1;
    this$4.whiteList$1 = previousWhiteList$1;
    return element$1
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander)) {
    var ShapeExpander$1 = $as_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander(x$1);
    var x = this.root$1;
    var x$2 = ShapeExpander$1.root$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.recursionRegister$1;
      var x$4 = ShapeExpander$1.recursionRegister$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.normalizeAction__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape = (function(shape) {
  if ((shape !== null)) {
    if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(shape).isDefined__Z()) {
      return this.recursionRegister$1.recursionAndError__Lamf_core_model_domain_Shape__s_Option__Lamf_core_model_domain_Shape__Lamf_core_traversal_ModelTraversalRegistry__Lamf_core_model_domain_RecursiveShape(this.root$1, new $c_s_Some().init___O(this.root$1.id$1), shape, this.traversal$1)
    }
  };
  if ((this.traversal$1.shouldFailIfRecursive__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Z(this.root$1, shape) && (!(shape instanceof $c_Lamf_core_model_domain_RecursiveShape)))) {
    return this.recursionRegister$1.recursionAndError__Lamf_core_model_domain_Shape__s_Option__Lamf_core_model_domain_Shape__Lamf_core_traversal_ModelTraversalRegistry__Lamf_core_model_domain_RecursiveShape(this.root$1, $m_s_None$(), shape, this.traversal$1)
  };
  var this$1 = this.traversal$1;
  var id = shape.id$1;
  if (this$1.visitedIds$1.contains__O__Z(id)) {
    return shape
  };
  this.ensureHasId__Lamf_core_model_domain_Shape__V(shape);
  this.traversal$1.$$plus__T__Lamf_core_traversal_ModelTraversalRegistry(shape.id$1);
  var this$2 = this.traversal$1;
  var previousPath = this$2.currentPath$1;
  if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_UnionShape(shape);
    var element = this.expandUnion__Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_model_domain_Shape(x2)
  } else if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
    var x3 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(shape);
    var element = this.expandAny__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_domain_shapes_models_AnyShape(x3)
  } else if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
    var x4 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(shape);
    var element = this.expandArray__Lamf_plugins_domain_shapes_models_ArrayShape__Lamf_plugins_domain_shapes_models_ArrayShape(x4)
  } else if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_MatrixShape)) {
    var x5 = $as_Lamf_plugins_domain_shapes_models_MatrixShape(shape);
    var element = this.expandMatrix__Lamf_plugins_domain_shapes_models_MatrixShape__Lamf_plugins_domain_shapes_models_MatrixShape(x5)
  } else if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_TupleShape)) {
    var x6 = $as_Lamf_plugins_domain_shapes_models_TupleShape(shape);
    var element = this.expandTuple__Lamf_plugins_domain_shapes_models_TupleShape__Lamf_plugins_domain_shapes_models_TupleShape(x6)
  } else if ((shape instanceof $c_Lamf_core_model_domain_extensions_PropertyShape)) {
    var x7 = $as_Lamf_core_model_domain_extensions_PropertyShape(shape);
    var element = this.expandProperty__Lamf_core_model_domain_extensions_PropertyShape__Lamf_core_model_domain_extensions_PropertyShape(x7)
  } else if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_FileShape)) {
    var x8 = $as_Lamf_plugins_domain_shapes_models_FileShape(shape);
    var element = this.expandAny__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_domain_shapes_models_AnyShape(x8)
  } else if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_NilShape)) {
    var x9 = $as_Lamf_plugins_domain_shapes_models_NilShape(shape);
    var element = x9
  } else if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
    var x10 = $as_Lamf_plugins_domain_shapes_models_NodeShape(shape);
    var element = this.expandNode__Lamf_plugins_domain_shapes_models_NodeShape__Lamf_plugins_domain_shapes_models_NodeShape(x10)
  } else if ((shape instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
    var x11 = $as_Lamf_core_model_domain_RecursiveShape(shape);
    var element = this.recursionRegister$1.recursionError__Lamf_core_model_domain_Shape__Lamf_core_model_domain_RecursiveShape__Lamf_core_traversal_ModelTraversalRegistry__s_Option__Lamf_core_model_domain_RecursiveShape(x11, x11, this.traversal$1, $m_s_None$())
  } else {
    if ((!(shape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape))) {
      throw new $c_s_MatchError().init___O(shape)
    };
    var x12 = $as_Lamf_plugins_domain_shapes_models_AnyShape(shape);
    var element = this.expandAny__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_domain_shapes_models_AnyShape(x12)
  };
  this$2.currentPath$1 = previousPath;
  return element
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.expandProperty__Lamf_core_model_domain_extensions_PropertyShape__Lamf_core_model_domain_extensions_PropertyShape = (function(property) {
  var required = false;
  var x1 = property.fields$2.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1);
  var x = $m_s_None$();
  if ((!(x === x1))) {
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var entry = $as_Lamf_core_parser_FieldEntry(x2.value$2);
      entry.value$1.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ExplicitField().init___());
      if (($numberIntValue($as_Lamf_core_model_domain_AmfScalar(entry.value$1.value$1).toNumber__jl_Number()) !== 0)) {
        required = true
      }
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  var oldRange = property.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1);
  if ($m_s_Option$().apply__O__s_Option(oldRange).isDefined__Z()) {
    var expandedRange = this.recursiveNormalization__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape($as_Lamf_core_model_domain_Shape(property.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1)));
    property.fields$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1, expandedRange, oldRange.annotations$1)
  } else {
    var this$1 = this.context$1.errorHandler$1;
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
    var node = property.id$1;
    var message = ("Resolution error: Property shape with missing range: " + property);
    var annotations = property.annotations$2;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$1, specification, node, message, annotations)
  };
  return property
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.root$1;
      break
    }
    case 1: {
      return this.recursionRegister$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.init___Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_resolution_stages_recursion_RecursionErrorRegister__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext = (function(root, recursionRegister, context) {
  this.root$1 = root;
  this.recursionRegister$1 = recursionRegister;
  this.context$1 = context;
  var jsx$2 = new $c_Lamf_core_traversal_ModelTraversalRegistry().init___();
  var jsx$1 = $m_sc_Seq$();
  var array = [$d_Lamf_plugins_domain_shapes_models_UnresolvedShape.getClassOf()];
  this.traversal$1 = jsx$2.withAllowedCyclesInstances__sc_Seq__Lamf_core_traversal_ModelTraversalRegistry($as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))));
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.ensureHasId__Lamf_core_model_domain_Shape__V = (function(shape) {
  if ($m_s_Option$().apply__O__s_Option(shape.id$1).isEmpty__Z()) {
    var this$1 = this.context$1.errorHandler$1;
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
    var node = shape.id$1;
    var property = $m_s_None$();
    var message = ("Resolution error: Found shape without ID: " + shape);
    var lexical = shape.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var location = shape.location__s_Option();
    this$1.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.expandArray__Lamf_plugins_domain_shapes_models_ArrayShape__Lamf_plugins_domain_shapes_models_ArrayShape = (function(array) {
  this.expandInherits__Lamf_core_model_domain_Shape__V(array);
  this.expandLogicalConstraints__Lamf_core_model_domain_Shape__V(array);
  var this$1 = $as_Lamf_core_model_IntField(array.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MinItems$1)).option$1;
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var x$4 = $uI(arg1);
    var mandatory = (x$4 > 0)
  } else {
    var mandatory = false
  };
  var oldItems = array.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1);
  if (mandatory) {
    var jsx$2 = $as_sc_Seq(array.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1));
    var jsx$1 = new $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$$anonfun$expandArray$2().init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander(this);
    var this$2 = $m_sc_Seq$();
    $as_sc_IterableLike(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, array$1) {
      return (function(f$2) {
        var f = $as_Lamf_plugins_domain_shapes_models_ArrayShape(f$2);
        var r = $as_Lamf_core_model_domain_RecursiveShape($as_Lamf_core_model_domain_Shape(f.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1)));
        return this$2$1.recursionRegister$1.recursionError__Lamf_core_model_domain_Shape__Lamf_core_model_domain_RecursiveShape__Lamf_core_traversal_ModelTraversalRegistry__s_Option__Lamf_core_model_domain_RecursiveShape(array$1, r, this$2$1.traversal$1, new $c_s_Some().init___O(array$1.id$1))
      })
    })(this, array)))
  };
  if ($m_s_Option$().apply__O__s_Option(oldItems).isDefined__Z()) {
    var newItems = (mandatory ? this.recursiveNormalization__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape($as_Lamf_core_model_domain_Shape(array.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1))) : this.traverseOptionalShapeFacet__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape($as_Lamf_core_model_domain_Shape(array.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1)), array));
    array.fields$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1, newItems, oldItems.annotations$1)
  };
  return array
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.context__Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_NormalizationContext = (function() {
  return this.context$1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.expandLogicalConstraints__Lamf_core_model_domain_Shape__V = (function(shape) {
  var oldLogicalConstraints = shape.fields__Lamf_core_parser_Fields().getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_core_metamodel_domain_ShapeModel$().And$1);
  if ($m_s_Option$().apply__O__s_Option(oldLogicalConstraints).isDefined__Z()) {
    var jsx$2 = $as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().And$1));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(elem$2) {
        var elem = $as_Lamf_core_model_domain_Shape(elem$2);
        var constraint = $this.recursiveNormalization__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(elem);
        return constraint
      })
    })(this));
    var this$1 = $m_sc_Seq$();
    var newLogicalConstraints = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
    var field = $m_Lamf_core_metamodel_domain_ShapeModel$().And$1;
    var annotations = oldLogicalConstraints.annotations$1;
    $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(shape, field, newLogicalConstraints, annotations)
  };
  oldLogicalConstraints = shape.fields__Lamf_core_parser_Fields().getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_core_metamodel_domain_ShapeModel$().Or$1);
  if ($m_s_Option$().apply__O__s_Option(oldLogicalConstraints).isDefined__Z()) {
    var jsx$4 = $as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Or$1));
    var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
      return (function(elem$3$2) {
        var elem$3 = $as_Lamf_core_model_domain_Shape(elem$3$2);
        var constraint$1 = this$2.recursiveNormalization__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(elem$3);
        return constraint$1
      })
    })(this));
    var this$3 = $m_sc_Seq$();
    var newLogicalConstraints$2 = $as_sc_Seq(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$3.ReusableCBFInstance$2));
    var field$1 = $m_Lamf_core_metamodel_domain_ShapeModel$().Or$1;
    var annotations$1 = oldLogicalConstraints.annotations$1;
    $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(shape, field$1, newLogicalConstraints$2, annotations$1)
  };
  oldLogicalConstraints = shape.fields__Lamf_core_parser_Fields().getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_core_metamodel_domain_ShapeModel$().Xone$1);
  if ($m_s_Option$().apply__O__s_Option(oldLogicalConstraints).isDefined__Z()) {
    var jsx$6 = $as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Xone$1));
    var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
      return (function(elem$4$2) {
        var elem$4 = $as_Lamf_core_model_domain_Shape(elem$4$2);
        var constraint$2 = this$3$1.recursiveNormalization__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(elem$4);
        return constraint$2
      })
    })(this));
    var this$4 = $m_sc_Seq$();
    var newLogicalConstraints$3 = $as_sc_Seq(jsx$6.map__F1__scg_CanBuildFrom__O(jsx$5, this$4.ReusableCBFInstance$2));
    var field$2 = $m_Lamf_core_metamodel_domain_ShapeModel$().Xone$1;
    var annotations$2 = oldLogicalConstraints.annotations$1;
    $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(shape, field$2, newLogicalConstraints$3, annotations$2)
  };
  var notConstraint = shape.fields__Lamf_core_parser_Fields().getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_core_metamodel_domain_ShapeModel$().Not$1);
  if ($m_s_Option$().apply__O__s_Option(notConstraint).isDefined__Z()) {
    var constraint$3 = this.recursiveNormalization__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape($as_Lamf_core_model_domain_Shape(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Not$1)));
    var field$3 = $m_Lamf_core_metamodel_domain_ShapeModel$().Not$1;
    var annotations$3 = notConstraint.annotations$1;
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(shape, field$3, constraint$3, annotations$3)
  }
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.expandTuple__Lamf_plugins_domain_shapes_models_TupleShape__Lamf_plugins_domain_shapes_models_TupleShape = (function(tuple) {
  this.expandLogicalConstraints__Lamf_core_model_domain_Shape__V(tuple);
  var oldItems = tuple.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().TupleItems$2);
  if ($m_s_Option$().apply__O__s_Option(oldItems).isDefined__Z()) {
    var jsx$2 = $as_sc_Seq(tuple.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().TupleItems$2));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(item$2) {
        var item = $as_Lamf_core_model_domain_Shape(item$2);
        var newItem = $this.recursiveNormalization__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(item);
        return newItem
      })
    })(this));
    var this$1 = $m_sc_Seq$();
    var newItemShapes = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
    var field = $m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().TupleItems$2;
    var annotations = oldItems.annotations$1;
    $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(tuple, field, newItemShapes, annotations)
  };
  return tuple
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.expandNode__Lamf_plugins_domain_shapes_models_NodeShape__Lamf_plugins_domain_shapes_models_NodeShape = (function(node) {
  var oldProperties = node.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1);
  if ($m_s_Option$().apply__O__s_Option(oldProperties).isDefined__Z()) {
    var jsx$2 = $as_sc_Seq(node.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, node$1) {
      return (function(prop$2) {
        var prop = $as_Lamf_core_model_domain_extensions_PropertyShape(prop$2);
        var newPropertyShape = ($this.isRequired__p1__Lamf_core_model_domain_extensions_PropertyShape__Z(prop) ? $as_Lamf_core_model_domain_extensions_PropertyShape($this.recursiveNormalization__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(prop)) : $as_Lamf_core_model_domain_extensions_PropertyShape($this.traverseOptionalShapeFacet__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(prop, node$1)));
        return newPropertyShape
      })
    })(this, node));
    var this$1 = $m_sc_Seq$();
    var newProperties = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
    var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1;
    var annotations = oldProperties.annotations$1;
    $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(node, field, newProperties, annotations)
  };
  var this$2 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(node.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().AdditionalPropertiesSchema$1)));
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var x = $as_Lamf_core_model_domain_Shape(arg1);
    var resultantShape = this.traverseOptionalShapeFacet__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(x, node);
    var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().AdditionalPropertiesSchema$1;
    $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(node, field$1, resultantShape))
  };
  this.expandInherits__Lamf_core_model_domain_Shape__V(node);
  this.expandLogicalConstraints__Lamf_core_model_domain_Shape__V(node);
  var x1 = node.fields$2.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var entry = $as_Lamf_core_parser_FieldEntry(x2.value$2);
    node.fields$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1, entry.value$1.value$1, entry.value$1.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ExplicitField().init___()))
  } else {
    var x$3 = $m_s_None$();
    if ((x$3 === x1)) {
      var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1;
      var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(false, new $c_Lamf_core_parser_Annotations().init___());
      var annotations$1 = ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ExplicitField().init___());
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(node, field$2, value, annotations$1)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  return node
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.recursiveNormalization__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape = (function(shape) {
  var this$1 = this.traversal$1;
  var previousPath = this$1.currentPath$1;
  var element = $f_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeNormalizer__normalize__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(this, shape);
  this$1.currentPath$1 = previousPath;
  return element
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.expandMatrix__Lamf_plugins_domain_shapes_models_MatrixShape__Lamf_plugins_domain_shapes_models_MatrixShape = (function(matrix) {
  this.expandLogicalConstraints__Lamf_core_model_domain_Shape__V(matrix);
  var oldItems = matrix.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$().Items$1);
  if ($m_s_Option$().apply__O__s_Option(oldItems).isDefined__Z()) {
    var arrangement = this.recursiveNormalization__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape($as_Lamf_core_model_domain_Shape(matrix.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1)));
    matrix.fields$2.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$().Items$1, arrangement, oldItems.annotations$1)
  };
  return matrix
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.expandUnion__Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_model_domain_Shape = (function(union) {
  this.expandInherits__Lamf_core_model_domain_Shape__V(union);
  var oldAnyOf = union.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1);
  if ($m_s_Option$().apply__O__s_Option(oldAnyOf).isDefined__Z()) {
    var jsx$2 = $as_sc_Seq(union.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(u$2) {
        var u = $as_Lamf_core_model_domain_Shape(u$2);
        var this$1 = $this.traversal$1;
        var shapeId = u.id$1;
        var actual = $as_sci_Set(this$1.currentPath$1.$$plus__O__sc_Set(shapeId));
        var previousWhiteList = this$1.whiteList$1;
        this$1.whiteList$1 = $as_sci_Set(this$1.whiteList$1.$$plus$plus__sc_GenTraversableOnce__sc_Set(actual));
        var previousPath = this$1.currentPath$1;
        var element = $this.recursiveNormalization__p1__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(u);
        this$1.currentPath$1 = previousPath;
        this$1.whiteList$1 = previousWhiteList;
        return element
      })
    })(this));
    var this$2 = $m_sc_Seq$();
    var newAnyOf = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
    var field = $m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1;
    var annotations = oldAnyOf.annotations$1;
    $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(union, field, newAnyOf, annotations)
  } else if (($m_s_Option$().apply__O__s_Option($as_sc_Seq(union.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1))).isEmpty__Z() || $as_sc_Seq(union.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).isEmpty__Z())) {
    var this$3 = this.context$1.errorHandler$1;
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
    var node = union.id$1;
    var message = ("Resolution error: Union shape with missing anyof: " + union);
    var annotations$1 = union.annotations$2;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$3, specification, node, message, annotations$1)
  };
  return union
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.expandAny__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_domain_shapes_models_AnyShape = (function(any) {
  this.expandInherits__Lamf_core_model_domain_Shape__V(any);
  this.expandLogicalConstraints__Lamf_core_model_domain_Shape__V(any);
  return any
});
function $as_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.ShapeExpander"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.resolution.stages.shape_normalization.ShapeExpander;", depth))
}
var $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.ShapeExpander", {
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander: 1,
  O: 1,
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeNormalizer: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$$anonfun$expandArray$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$$anonfun$expandArray$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$$anonfun$expandArray$2.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$$anonfun$expandArray$2;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$$anonfun$expandArray$2() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$$anonfun$expandArray$2.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$$anonfun$expandArray$2.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$$anonfun$expandArray$2.prototype.init___Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander = (function($$outer) {
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$$anonfun$expandArray$2.prototype.isDefinedAt__Lamf_core_model_domain_Shape__Z = (function(x1) {
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(x1);
    if (($as_Lamf_core_model_domain_Shape(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1)) instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
      return true
    }
  };
  return false
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$$anonfun$expandArray$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_Shape__Z($as_Lamf_core_model_domain_Shape(x))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$$anonfun$expandArray$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_Shape__F1__O($as_Lamf_core_model_domain_Shape(x), $default)
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$$anonfun$expandArray$2.prototype.applyOrElse__Lamf_core_model_domain_Shape__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(x1);
    if (($as_Lamf_core_model_domain_Shape(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1)) instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
      return x2
    }
  };
  return $default.apply__O__O(x1)
});
var $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$$anonfun$expandArray$2 = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$$anonfun$expandArray$2: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.shape_normalization.ShapeExpander$$anonfun$expandArray$2", {
  Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$$anonfun$expandArray$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$$anonfun$expandArray$2.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_shape$undnormalization_ShapeExpander$$anonfun$expandArray$2;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator() {
  $c_O.call(this);
  this.shape$1 = null;
  this.defaultSeverity$1 = null;
  this.validationMode$1 = null;
  this.env$1 = null
}
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator.prototype.constructor = $c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator.prototype = $c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator.prototype;
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator.prototype.productPrefix__T = (function() {
  return "AnyMathPayloadValidator"
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator.prototype.validate__T__T__s_concurrent_ExecutionContext__s_concurrent_Future = (function(payload, mediaType, executionContext) {
  var message = ((("Unsupported validation for mediatype: " + mediaType) + " and shape ") + this.shape$1.id$1);
  var level = this.defaultSeverity$1;
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var targetProperty = new $c_s_Some().init___O(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "value").iri__T());
  var validationId = ((this.defaultSeverity$1 === $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1) ? $m_Lamf_validations_ParserSideValidations$().UnsupportedExampleMediaTypeErrorSpecification$1.id$1 : $m_Lamf_validations_PayloadValidations$().UnsupportedExampleMediaTypeWarningSpecification$1.id$1);
  var position = $m_s_None$();
  var location = $m_s_None$();
  var results = new $c_Lamf_core_validation_AMFValidationResult().init___T__T__T__s_Option__T__s_Option__s_Option__O(message, level, "", targetProperty, validationId, position, location, null);
  return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, results$1) {
    return (function() {
      var jsx$3 = $m_Lamf_core_validation_AMFValidationReport$();
      var jsx$2 = $m_Lamf_ProfileName$().apply__T__Lamf_ProfileName("");
      var jsx$1 = $m_sc_Seq$();
      var array = [results$1];
      return jsx$3.apply__T__Lamf_ProfileName__sc_Seq__Lamf_core_validation_AMFValidationReport("", jsx$2, $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))))
    })
  })(this, results)), executionContext)
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator)) {
    var AnyMathPayloadValidator$1 = $as_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator(x$1);
    var x = this.shape$1;
    var x$2 = AnyMathPayloadValidator$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      return (this.defaultSeverity$1 === AnyMathPayloadValidator$1.defaultSeverity$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.defaultSeverity$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator.prototype.validate__Lamf_core_model_document_PayloadFragment__s_concurrent_ExecutionContext__s_concurrent_Future = (function(payloadFragment, executionContext) {
  var this$1 = $as_Lamf_core_model_StrField(payloadFragment.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().MediaType$1));
  var this$2 = this$1.option$1;
  var message = ((("Unsupported validation for mediatype: " + $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()))) + " and shape ") + this.shape$1.id$1);
  var level = this.defaultSeverity$1;
  var targetNode = $as_Lamf_core_model_domain_DataNode(payloadFragment.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().Encodes$1)).id$1;
  var this$3 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var targetProperty = new $c_s_Some().init___O(new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "value").iri__T());
  var validationId = ((this.defaultSeverity$1 === $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1) ? $m_Lamf_validations_ParserSideValidations$().UnsupportedExampleMediaTypeErrorSpecification$1.id$1 : $m_Lamf_validations_PayloadValidations$().UnsupportedExampleMediaTypeWarningSpecification$1.id$1);
  var this$5 = $as_Lamf_core_model_domain_DataNode(payloadFragment.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().Encodes$1));
  var position = this$5.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  var this$6 = $as_Lamf_core_model_domain_DataNode(payloadFragment.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().Encodes$1));
  var location = $f_Lamf_core_model_domain_AmfElement__location__s_Option(this$6);
  var results = new $c_Lamf_core_validation_AMFValidationResult().init___T__T__T__s_Option__T__s_Option__s_Option__O(message, level, targetNode, targetProperty, validationId, position, location, null);
  return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, results$1) {
    return (function() {
      var jsx$3 = $m_Lamf_core_validation_AMFValidationReport$();
      var jsx$2 = $m_Lamf_ProfileName$().apply__T__Lamf_ProfileName("");
      var jsx$1 = $m_sc_Seq$();
      var array = [results$1];
      return jsx$3.apply__T__Lamf_ProfileName__sc_Seq__Lamf_core_validation_AMFValidationReport("", jsx$2, $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))))
    })
  })(this, results)), executionContext)
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator.prototype.isValid__T__T__s_concurrent_ExecutionContext__s_concurrent_Future = (function(mediaType, payload, executionContext) {
  return this.validate__T__T__s_concurrent_ExecutionContext__s_concurrent_Future(mediaType, payload, executionContext).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_core_validation_AMFValidationReport(x$3$2);
      return x$3.conforms$1
    })
  })(this)), executionContext)
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator.prototype.syncValidate__T__T__Lamf_core_validation_AMFValidationReport = (function(mediaType, payload) {
  return $m_Lamf_core_validation_AMFValidationReport$().apply__T__Lamf_ProfileName__sc_Seq__Lamf_core_validation_AMFValidationReport("", $m_Lamf_ProfileName$().apply__T__Lamf_ProfileName(""), $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())))
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator.prototype.init___Lamf_core_model_domain_Shape__T = (function(shape, defaultSeverity) {
  this.shape$1 = shape;
  this.defaultSeverity$1 = defaultSeverity;
  this.validationMode$1 = $m_Lamf_client_plugins_StrictValidationMode$();
  this.env$1 = $m_Lamf_internal_environment_Environment$().apply__Lamf_internal_environment_Environment();
  return this
});
function $as_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.validation.PayloadValidationPluginsHandler$AnyMathPayloadValidator"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.validation.PayloadValidationPluginsHandler$AnyMathPayloadValidator;", depth))
}
var $d_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator: 0
}, false, "amf.plugins.domain.shapes.validation.PayloadValidationPluginsHandler$AnyMathPayloadValidator", {
  Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator: 1,
  O: 1,
  Lamf_core_validation_PayloadValidator: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator.prototype.$classData = $d_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_EncodingModel$() {
  $c_O.call(this);
  this.PropertyName$1 = null;
  this.ContentType$1 = null;
  this.Headers$1 = null;
  this.Style$1 = null;
  this.Explode$1 = null;
  this.AllowReserved$1 = null;
  this.type$1 = null;
  this.key$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_EncodingModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_EncodingModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_EncodingModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_EncodingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_EncodingModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_EncodingModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_EncodingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_EncodingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.PropertyName$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "propertyName"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "property name", "", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.ContentType$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "contentType"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "content type", "", $m_sci_Nil$()), true);
  var jsx$3 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$());
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Headers$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "header"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "header", "", $m_sci_Nil$()), true);
  var jsx$4 = $m_Lamf_core_metamodel_Type$Str$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Style$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "style"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "style", "Describes how a specific property value will be serialized depending on its type.", $m_sci_Nil$()), true);
  var jsx$5 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Explode$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "explode"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "explode", "", $m_sci_Nil$()), true);
  var jsx$6 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.AllowReserved$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$6, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "allowReserved"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "allow reserved", "", $m_sci_Nil$()), true);
  var this$19 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$19, "Encoding");
  var this$21 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$21);
  this.key$1 = this.PropertyName$1;
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Encoding", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_EncodingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_EncodingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_EncodingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_EncodingModel$.prototype.fields__sci_List = (function() {
  var x$7 = this.PropertyName$1;
  var x$6 = this.ContentType$1;
  var x$5 = this.Headers$1;
  var x$4 = this.Style$1;
  var x$3 = this.Explode$1;
  var x$2 = this.AllowReserved$1;
  var this$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$2 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$1);
  var this$3 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$2);
  var this$4 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$3);
  var this$5 = new $c_sci_$colon$colon().init___O__sci_List(x$5, this$4);
  var this$6 = new $c_sci_$colon$colon().init___O__sci_List(x$6, this$5);
  return new $c_sci_$colon$colon().init___O__sci_List(x$7, this$6)
});
$c_Lamf_plugins_domain_webapi_metamodel_EncodingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_EncodingModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_EncodingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_Encoding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_EncodingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_EncodingModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_EncodingModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.EncodingModel$", {
  Lamf_plugins_domain_webapi_metamodel_EncodingModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_EncodingModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_EncodingModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_EncodingModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_EncodingModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_EncodingModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_EncodingModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_LicenseModel$() {
  $c_O.call(this);
  this.Url$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_LicenseModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_LicenseModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_LicenseModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_LicenseModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_LicenseModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_LicenseModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_LicenseModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_LicenseModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Url$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "url"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "url", "URL identifying the organization", $m_sci_Nil$()), true);
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "License");
  var this$6 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$6);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "License", "Licensing information for a resource", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_LicenseModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_LicenseModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_LicenseModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_LicenseModel$.prototype.fields__sci_List = (function() {
  var x$3 = this.Url$1;
  var x$2 = this.Name$1;
  var this$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$2 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$1);
  return new $c_sci_$colon$colon().init___O__sci_List(x$3, this$2)
});
$c_Lamf_plugins_domain_webapi_metamodel_LicenseModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_LicenseModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_License().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_LicenseModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_LicenseModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_LicenseModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_LicenseModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.LicenseModel$", {
  Lamf_plugins_domain_webapi_metamodel_LicenseModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_LicenseModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_LicenseModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_LicenseModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_LicenseModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_LicenseModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_LicenseModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_LicenseModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_LicenseModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$() {
  $c_O.call(this);
  this.Url$1 = null;
  this.Email$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Url$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "url"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "url", "URL identifying the organization", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Email$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "email"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "email", "Contact email for the organization", $m_sci_Nil$()), true);
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "Organization");
  var this$9 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$9);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "Organization", "Organization providing an good or service", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Url$1, this.Name$1, this.Email$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_Organization().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_OrganizationModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.OrganizationModel$", {
  Lamf_plugins_domain_webapi_metamodel_OrganizationModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$() {
  $c_O.call(this);
  this.Type$1 = null;
  this.Durable$1 = null;
  this.AutoDelete$1 = null;
  this.VHost$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Type$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "type"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "type", "The type of the exchange", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Durable$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "durable"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "durable", "Whether the exchange should survive broker restarts or not", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.AutoDelete$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "autoDelete"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "autoDelete", "Whether the exchange should be deleted when the last queue is unbound from it", $m_sci_Nil$()), true);
  var jsx$4 = $m_Lamf_core_metamodel_Type$Str$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.VHost$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "vhost"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "vhost", "The virtual host of the exchange", $m_sci_Nil$()), true);
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "Amqp091ChannelExchange");
  var this$15 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$15);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "Amqp091ChannelExchange", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Name$1, this.Type$1, this.Durable$1, this.AutoDelete$1, this.VHost$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.Amqp091ChannelExchangeModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$() {
  $c_O.call(this);
  this.Durable$1 = null;
  this.Exclusive$1 = null;
  this.AutoDelete$1 = null;
  this.VHost$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Durable$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "durable"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "durable", "Whether the exchange should survive broker restarts or not", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Exclusive$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "exclusive"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "exclusive", "Whether the queue should be used only by one connection or not", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.AutoDelete$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "autoDelete"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "autoDelete", "Whether the exchange should be deleted when the last queue is unbound from it", $m_sci_Nil$()), true);
  var jsx$4 = $m_Lamf_core_metamodel_Type$Str$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.VHost$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "vhost"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "vhost", "The virtual host of the exchange", $m_sci_Nil$()), true);
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "Amqp091ChannelQueue");
  var this$15 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$15);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "Amqp091Queue", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Name$1, this.Durable$1, this.Exclusive$1, this.AutoDelete$1, this.VHost$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.Amqp091QueueModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.Bindings$1 = null;
  this.doc$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "ChannelBindings");
  var this$3 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$3);
  var jsx$1 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$());
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Bindings$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "binding"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "binding", "List of channel bindings", $m_sci_Nil$()), true);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "ChannelBindings", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Name$1, this.Bindings$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$4 = result;
  var jsx$3 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  var jsx$2 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$5.ReusableCBFInstance$2));
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$6 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.ChannelBindingsModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.Bindings$1 = null;
  this.doc$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "MessageBindings");
  var this$3 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$3);
  var jsx$1 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$());
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Bindings$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "binding"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "binding", "List of message bindings", $m_sci_Nil$()), true);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "MessageBindings", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Name$1, this.Bindings$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$4 = result;
  var jsx$3 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  var jsx$2 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$5.ReusableCBFInstance$2));
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$6 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.MessageBindingsModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.Bindings$1 = null;
  this.doc$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "OperationBindings");
  var this$3 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$3);
  var jsx$1 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$());
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Bindings$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "binding"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "binding", "List of operation bindings", $m_sci_Nil$()), true);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "OperationBindings", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Name$1, this.Bindings$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$4 = result;
  var jsx$3 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  var jsx$2 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$5.ReusableCBFInstance$2));
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$6 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.OperationBindingsModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.Bindings$1 = null;
  this.doc$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "ServerBindings");
  var this$3 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$3);
  var jsx$1 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$());
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Bindings$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "binding"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "binding", "List of server bindings", $m_sci_Nil$()), true);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "ServerBindings", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Name$1, this.Bindings$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$4 = result;
  var jsx$3 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  var jsx$2 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$5.ReusableCBFInstance$2));
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$6 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.ServerBindingsModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$() {
  $c_O.call(this);
  this.Name$1 = null;
  this.In$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Name$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "name"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "name", "", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.In$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "in"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "in", "", $m_sci_Nil$()), true);
  $m_sci_List$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "ApiKeySettings")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$12 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$12);
    i = (((-1) + i) | 0)
  };
  var jsx$4 = result;
  var jsx$3 = $m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().type$1;
  var this$13 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$13.ReusableCBFInstance$2));
  $m_sci_List$();
  var array$1 = [this.Name$1, this.In$1];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$17 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$17);
    i$1 = (((-1) + i$1) | 0)
  };
  var jsx$6 = result$1;
  var jsx$5 = $m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().fields$1;
  var this$18 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$5, this$18.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "API Key Settings", "Settings for an API Key security scheme", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.security.ApiKeySettingsModel$", {
  Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_security_SettingsModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$() {
  $c_O.call(this);
  this.Name$1 = null;
  this.In$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Name$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "name"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "name", "", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.In$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "in"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "in", "", $m_sci_Nil$()), true);
  $m_sci_List$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "HttpApiKeySettings")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$12 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$12);
    i = (((-1) + i) | 0)
  };
  var jsx$4 = result;
  var jsx$3 = $m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().type$1;
  var this$13 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$13.ReusableCBFInstance$2));
  $m_sci_List$();
  var array$1 = [this.Name$1, this.In$1];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$17 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$17);
    i$1 = (((-1) + i$1) | 0)
  };
  var jsx$6 = result$1;
  var jsx$5 = $m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().fields$1;
  var this$18 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$5, this$18.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "Http API Key Settings", "Settings for an Http API Key security scheme", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.security.HttpApiKeySettingsModel$", {
  Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_security_SettingsModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$() {
  $c_O.call(this);
  this.Scheme$1 = null;
  this.BearerFormat$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.Scheme$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "scheme"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "scheme", "", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.BearerFormat$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "bearerFormat"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "bearer format", "", $m_sci_Nil$()), true);
  $m_sci_List$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "HttpSettings")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$12 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$12);
    i = (((-1) + i) | 0)
  };
  var jsx$4 = result;
  var jsx$3 = $m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().type$1;
  var this$13 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$13.ReusableCBFInstance$2));
  $m_sci_List$();
  var array$1 = [this.Scheme$1, this.BearerFormat$1];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$17 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$17);
    i$1 = (((-1) + i$1) | 0)
  };
  var jsx$6 = result$1;
  var jsx$5 = $m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().fields$1;
  var this$18 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$5, this$18.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "HTTP Settings", "Settings for an HTTP security scheme", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_security_HttpSettings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.security.HttpSettingsModel$", {
  Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_security_SettingsModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$() {
  $c_O.call(this);
  this.RequestTokenUri$1 = null;
  this.AuthorizationUri$1 = null;
  this.TokenCredentialsUri$1 = null;
  this.Signatures$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.RequestTokenUri$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "requestTokenUri"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "request token URI", "", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.AuthorizationUri$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "authorizationUri"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "authorization URI", "", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_core_metamodel_Type$Str$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.TokenCredentialsUri$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "tokenCredentialsUri"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "token credentials URI", "", $m_sci_Nil$()), true);
  var jsx$4 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Str$());
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.Signatures$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "signature"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "signature", "", $m_sci_Nil$()), true);
  $m_sci_List$();
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "OAuth1Settings")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$18 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$18);
    i = (((-1) + i) | 0)
  };
  var jsx$6 = result;
  var jsx$5 = $m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().type$1;
  var this$19 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$5, this$19.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "OAuth1 Settings", "Settings for an OAuth1 security scheme", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.RequestTokenUri$1, this.AuthorizationUri$1, this.TokenCredentialsUri$1, this.Signatures$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.security.OAuth1SettingsModel$", {
  Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_security_SettingsModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$() {
  $c_O.call(this);
  this.AuthorizationUri$1 = null;
  this.AccessTokenUri$1 = null;
  this.Flow$1 = null;
  this.RefreshUri$1 = null;
  this.Scopes$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.key$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.AuthorizationUri$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "authorizationUri"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "authorization URI", "", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.AccessTokenUri$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "accessTokenUri"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "access token URI", "", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_core_metamodel_Type$Str$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.Flow$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "flow"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "flow", "", $m_sci_Nil$()), true);
  var jsx$4 = $m_Lamf_core_metamodel_Type$Str$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.RefreshUri$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "refreshUri"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "refresh URI", "", $m_sci_Nil$()), true);
  var jsx$5 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$());
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.Scopes$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "scope"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "scope", "", $m_sci_Nil$()), true);
  $m_sci_List$();
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "OAuth2Flow")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$21 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$21);
    i = (((-1) + i) | 0)
  };
  var jsx$7 = result;
  var jsx$6 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  var this$22 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$7.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$6, this$22.ReusableCBFInstance$2));
  $m_sci_List$();
  var array$1 = [this.AuthorizationUri$1, this.AccessTokenUri$1, this.Flow$1, this.RefreshUri$1, this.Scopes$1];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$26 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$26);
    i$1 = (((-1) + i$1) | 0)
  };
  var jsx$9 = result$1;
  var jsx$8 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$27 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$9.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$8, this$27.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "OAuth2 Flow", "Flow for an OAuth2 security scheme setting", $m_sci_Nil$());
  this.key$1 = this.Flow$1;
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.security.OAuth2FlowModel$", {
  Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$() {
  $c_O.call(this);
  this.AuthorizationGrants$1 = null;
  this.Flows$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Str$());
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.AuthorizationGrants$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "authorizationGrant"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "authorization grant", "", $m_sci_Nil$()), true);
  var jsx$2 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$());
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.Flows$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "flows"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "flows", "", $m_sci_Nil$()), true);
  $m_sci_List$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "OAuth2Settings")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$12 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$12);
    i = (((-1) + i) | 0)
  };
  var jsx$4 = result;
  var jsx$3 = $m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().type$1;
  var this$13 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$13.ReusableCBFInstance$2));
  $m_sci_List$();
  var array$1 = [this.AuthorizationGrants$1, this.Flows$1];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$17 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$17);
    i$1 = (((-1) + i$1) | 0)
  };
  var jsx$6 = result$1;
  var jsx$5 = $m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().fields$1;
  var this$18 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$5, this$18.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "OAuth2 Settings", "Settings for an OAuth2 security scheme", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.security.OAuth2SettingsModel$", {
  Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_security_SettingsModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$() {
  $c_O.call(this);
  this.Url$1 = null;
  this.Scopes$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.Url$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "openIdConnectUrl"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "OpenID connect URL", "", $m_sci_Nil$()), true);
  var jsx$2 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$());
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.Scopes$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "scope"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "scope", "", $m_sci_Nil$()), true);
  $m_sci_List$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "OpenIdConnectSettings")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$12 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$12);
    i = (((-1) + i) | 0)
  };
  var jsx$4 = result;
  var jsx$3 = $m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().type$1;
  var this$13 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$13.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "OpenID Settings", "Settings for an OpenID security scheme", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Url$1, this.Scopes$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.security.OpenIdConnectSettingsModel$", {
  Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_security_SettingsModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$() {
  $c_O.call(this);
  this.Name$1 = null;
  this.Description$1 = null;
  this.Scheme$1 = null;
  this.Settings$1 = null;
  this.key$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$4 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var jsx$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "name");
  var jsx$2 = $m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1;
  var jsx$1 = $m_sc_Seq$();
  var this$3 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "name").iri__T()];
  this.Name$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, jsx$3, new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq(jsx$2, "name", "Name for the security scheme", $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))), true);
  var jsx$8 = $m_Lamf_core_metamodel_Type$Str$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var jsx$7 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "description");
  var jsx$6 = $m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1;
  var jsx$5 = $m_sc_Seq$();
  var this$9 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var array$1 = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$9, "description").iri__T()];
  this.Description$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$8, jsx$7, new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq(jsx$6, "description", "Name for the security scheme", $as_sc_Seq(jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)))), true);
  var jsx$9 = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$();
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.Scheme$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$9, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "scheme"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "scheme", "", $m_sci_Nil$()), true);
  var jsx$10 = $m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$();
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.Settings$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$10, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "settings"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "settings", "Security scheme settings", $m_sci_Nil$()), true);
  this.key$1 = this.Name$1;
  $m_sci_List$();
  var this$19 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var array$2 = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$19, "ParametrizedSecurityScheme")];
  var i = (((-1) + $uI(array$2.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$24 = result;
    var index = i;
    var x = array$2[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$24);
    i = (((-1) + i) | 0)
  };
  var jsx$12 = result;
  var jsx$11 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  var this$25 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$12.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$11, this$25.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "Parametrized Security Scheme", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Name$1, this.Scheme$1, this.Settings$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.security.ParametrizedSecuritySchemeModel$", {
  Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$() {
  $c_O.call(this);
  this.AdditionalProperties$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_domain_DataNodeModel$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.AdditionalProperties$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "additionalProperties"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "additional properties", "", $m_sci_Nil$()), true);
  $m_sci_List$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "Settings")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$9 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$9);
    i = (((-1) + i) | 0)
  };
  var jsx$3 = result;
  var jsx$2 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  var this$10 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$10.ReusableCBFInstance$2));
  $m_sci_List$();
  var array$1 = [this.AdditionalProperties$1];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$14 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$14);
    i$1 = (((-1) + i$1) | 0)
  };
  var jsx$5 = result$1;
  var jsx$4 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$15 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$15.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "Settings", "Settings for a security scheme", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_security_Settings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.security.SettingsModel$", {
  Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_security_SettingsModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_CorrelationId() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_CorrelationId;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_CorrelationId() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_CorrelationId.prototype = $c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype;
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_CorrelationId().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_CorrelationId($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$()
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$().Name$1)).option$1;
  return ("/" + (this$1.isEmpty__Z() ? "default-id" : this$1.get__O()))
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_CorrelationId().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$().Name$1
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_CorrelationId(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_CorrelationId) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.CorrelationId"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_CorrelationId(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_CorrelationId)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_CorrelationId(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_CorrelationId(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.CorrelationId;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_CorrelationId = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_CorrelationId: 0
}, false, "amf.plugins.domain.webapi.models.CorrelationId", {
  Lamf_plugins_domain_webapi_models_CorrelationId: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1
});
$c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_CorrelationId;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$resourceType$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$resourceType$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$resourceType$1.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$resourceType$1;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$resourceType$1() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$resourceType$1.prototype = $c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$resourceType$1.prototype;
$c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$resourceType$1.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$resourceType$1.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType)
});
$c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$resourceType$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$resourceType$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
$c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$resourceType$1.prototype.init___Lamf_plugins_domain_webapi_models_EndPoint = (function($$outer) {
  return this
});
var $d_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$resourceType$1 = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$resourceType$1: 0
}, false, "amf.plugins.domain.webapi.models.EndPoint$$anonfun$resourceType$1", {
  Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$resourceType$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$resourceType$1.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$resourceType$1;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$traits$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$traits$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$traits$1.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$traits$1;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$traits$1() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$traits$1.prototype = $c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$traits$1.prototype;
$c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$traits$1.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$traits$1.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait)
});
$c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$traits$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$traits$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
$c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$traits$1.prototype.init___Lamf_plugins_domain_webapi_models_EndPoint = (function($$outer) {
  return this
});
var $d_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$traits$1 = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$traits$1: 0
}, false, "amf.plugins.domain.webapi.models.EndPoint$$anonfun$traits$1", {
  Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$traits$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$traits$1.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$traits$1;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_Operation$$anonfun$traits$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_domain_webapi_models_Operation$$anonfun$traits$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_domain_webapi_models_Operation$$anonfun$traits$1.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_Operation$$anonfun$traits$1;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_Operation$$anonfun$traits$1() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_Operation$$anonfun$traits$1.prototype = $c_Lamf_plugins_domain_webapi_models_Operation$$anonfun$traits$1.prototype;
$c_Lamf_plugins_domain_webapi_models_Operation$$anonfun$traits$1.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_domain_webapi_models_Operation$$anonfun$traits$1.prototype.init___Lamf_plugins_domain_webapi_models_Operation = (function($$outer) {
  return this
});
$c_Lamf_plugins_domain_webapi_models_Operation$$anonfun$traits$1.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait)
});
$c_Lamf_plugins_domain_webapi_models_Operation$$anonfun$traits$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_domain_webapi_models_Operation$$anonfun$traits$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_domain_webapi_models_Operation$$anonfun$traits$1 = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_Operation$$anonfun$traits$1: 0
}, false, "amf.plugins.domain.webapi.models.Operation$$anonfun$traits$1", {
  Lamf_plugins_domain_webapi_models_Operation$$anonfun$traits$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_Operation$$anonfun$traits$1.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_Operation$$anonfun$traits$1;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$annotateExtensionId$1$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$annotateExtensionId$1$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$annotateExtensionId$1$1.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$annotateExtensionId$1$1;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$annotateExtensionId$1$1() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$annotateExtensionId$1$1.prototype = $c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$annotateExtensionId$1$1.prototype;
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$annotateExtensionId$1$1.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$annotateExtensionId$1$1.prototype.applyOrElse__Lamf_core_model_domain_Annotation__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance)) {
    var x2 = $as_Lamf_plugins_document_webapi_annotations_ExtensionProvenance(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$annotateExtensionId$1$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_Annotation__Z($as_Lamf_core_model_domain_Annotation(x))
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$annotateExtensionId$1$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_Annotation__F1__O($as_Lamf_core_model_domain_Annotation(x), $default)
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$annotateExtensionId$1$1.prototype.isDefinedAt__Lamf_core_model_domain_Annotation__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance)
});
var $d_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$annotateExtensionId$1$1 = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$annotateExtensionId$1$1: 0
}, false, "amf.plugins.domain.webapi.resolution.ExtendsHelper$$anonfun$$nestedInanonfun$annotateExtensionId$1$1", {
  Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$annotateExtensionId$1$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$annotateExtensionId$1$1.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$annotateExtensionId$1$1;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asEndpoint$3$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asEndpoint$3$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asEndpoint$3$1.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asEndpoint$3$1;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asEndpoint$3$1() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asEndpoint$3$1.prototype = $c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asEndpoint$3$1.prototype;
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asEndpoint$3$1.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asEndpoint$3$1.prototype.isDefinedAt__Lorg_yaml_model_YPart__Z = (function(x1) {
  return (x1 instanceof $c_Lorg_yaml_model_YMapEntry)
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asEndpoint$3$1.prototype.applyOrElse__Lorg_yaml_model_YPart__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lorg_yaml_model_YMapEntry)) {
    var x2 = $as_Lorg_yaml_model_YMapEntry(x1);
    return $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(x2.key$2)
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asEndpoint$3$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lorg_yaml_model_YPart__Z($as_Lorg_yaml_model_YPart(x))
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asEndpoint$3$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lorg_yaml_model_YPart__F1__O($as_Lorg_yaml_model_YPart(x), $default)
});
var $d_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asEndpoint$3$1 = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asEndpoint$3$1: 0
}, false, "amf.plugins.domain.webapi.resolution.ExtendsHelper$$anonfun$$nestedInanonfun$asEndpoint$3$1", {
  Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asEndpoint$3$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asEndpoint$3$1.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asEndpoint$3$1;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asOperation$3$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asOperation$3$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asOperation$3$1.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asOperation$3$1;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asOperation$3$1() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asOperation$3$1.prototype = $c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asOperation$3$1.prototype;
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asOperation$3$1.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asOperation$3$1.prototype.isDefinedAt__Lorg_yaml_model_YPart__Z = (function(x1) {
  return (x1 instanceof $c_Lorg_yaml_model_YMapEntry)
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asOperation$3$1.prototype.applyOrElse__Lorg_yaml_model_YPart__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lorg_yaml_model_YMapEntry)) {
    var x2 = $as_Lorg_yaml_model_YMapEntry(x1);
    return $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(x2.key$2)
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asOperation$3$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lorg_yaml_model_YPart__Z($as_Lorg_yaml_model_YPart(x))
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asOperation$3$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lorg_yaml_model_YPart__F1__O($as_Lorg_yaml_model_YPart(x), $default)
});
var $d_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asOperation$3$1 = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asOperation$3$1: 0
}, false, "amf.plugins.domain.webapi.resolution.ExtendsHelper$$anonfun$$nestedInanonfun$asOperation$3$1", {
  Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asOperation$3$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asOperation$3$1.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$$nestedInanonfun$asOperation$3$1;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$findUnitLocationOfElement$1() {
  $c_sr_AbstractPartialFunction.call(this);
  this.elementId$1$2 = null
}
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$findUnitLocationOfElement$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$findUnitLocationOfElement$1.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$findUnitLocationOfElement$1;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$findUnitLocationOfElement$1() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$findUnitLocationOfElement$1.prototype = $c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$findUnitLocationOfElement$1.prototype;
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$findUnitLocationOfElement$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_document_BaseUnit__Z($as_Lamf_core_model_document_BaseUnit(x))
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$findUnitLocationOfElement$1.prototype.init___T = (function(elementId$1) {
  this.elementId$1$2 = elementId$1;
  return this
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$findUnitLocationOfElement$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O($as_Lamf_core_model_document_BaseUnit(x), $default)
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$findUnitLocationOfElement$1.prototype.applyOrElse__Lamf_core_model_document_BaseUnit__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_model_document_Module)) {
    var x2 = $as_Lamf_core_model_document_Module(x1);
    if ($as_sc_Seq(x2.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_ModuleModel$().Declares$1)).exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$11$2) {
        var x$11 = $as_Lamf_core_model_domain_DomainElement(x$11$2);
        return (x$11.id__T() === $this.elementId$1$2)
      })
    })(this)))) {
      var this$1 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(x2);
      return (this$1.isEmpty__Z() ? x2.id$1 : this$1.get__O())
    }
  };
  if ($is_Lamf_core_model_document_Fragment(x1)) {
    var x3 = $as_Lamf_core_model_document_Fragment(x1);
    if ((x3.encodes__Lamf_core_model_domain_DomainElement().id__T() === this.elementId$1$2)) {
      var this$2 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(x3);
      return (this$2.isEmpty__Z() ? x3.id__T() : this$2.get__O())
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$findUnitLocationOfElement$1.prototype.isDefinedAt__Lamf_core_model_document_BaseUnit__Z = (function(x1) {
  if ((x1 instanceof $c_Lamf_core_model_document_Module)) {
    var x2 = $as_Lamf_core_model_document_Module(x1);
    if ($as_sc_Seq(x2.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_ModuleModel$().Declares$1)).exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$11$2) {
        var x$11 = $as_Lamf_core_model_domain_DomainElement(x$11$2);
        return (x$11.id__T() === $this.elementId$1$2)
      })
    })(this)))) {
      return true
    }
  };
  if ($is_Lamf_core_model_document_Fragment(x1)) {
    var x3 = $as_Lamf_core_model_document_Fragment(x1);
    if ((x3.encodes__Lamf_core_model_domain_DomainElement().id__T() === this.elementId$1$2)) {
      return true
    }
  };
  return false
});
var $d_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$findUnitLocationOfElement$1 = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$findUnitLocationOfElement$1: 0
}, false, "amf.plugins.domain.webapi.resolution.ExtendsHelper$$anonfun$findUnitLocationOfElement$1", {
  Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$findUnitLocationOfElement$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$findUnitLocationOfElement$1.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$$anonfun$findUnitLocationOfElement$1;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$$anonfun$1.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$$anonfun$1.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$$anonfun$1.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$$anonfun$1.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$$anonfun$1.prototype.isDefinedAt__Lamf_core_model_domain_DataNode__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_core_model_domain_ScalarNode)
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$$anonfun$1.prototype.applyOrElse__Lamf_core_model_domain_DataNode__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_model_domain_ScalarNode)) {
    var x2 = $as_Lamf_core_model_domain_ScalarNode(x1);
    return $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1))
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DataNode__Z($as_Lamf_core_model_domain_DataNode(x))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DataNode__F1__O($as_Lamf_core_model_domain_DataNode(x), $default)
});
var $d_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$$anonfun$1: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.DataNodeMerging$$anonfun$1", {
  Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$$anonfun$1.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_DataNodeMerging$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$$anonfun$$nestedInanonfun$mergeDataNodes$1$1() {
  $c_sr_AbstractPartialFunction.call(this);
  this.x2$2$2 = null
}
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$$anonfun$$nestedInanonfun$mergeDataNodes$1$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$$anonfun$$nestedInanonfun$mergeDataNodes$1$1.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$$anonfun$$nestedInanonfun$mergeDataNodes$1$1;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$$anonfun$$nestedInanonfun$mergeDataNodes$1$1() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$$anonfun$$nestedInanonfun$mergeDataNodes$1$1.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$$anonfun$$nestedInanonfun$mergeDataNodes$1$1.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$$anonfun$$nestedInanonfun$mergeDataNodes$1$1.prototype.isDefinedAt__Lamf_core_model_domain_DataNode__Z = (function(x1) {
  if ((x1 instanceof $c_Lamf_core_model_domain_ScalarNode)) {
    var x2 = $as_Lamf_core_model_domain_ScalarNode(x1);
    var jsx$1 = $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1)).option$1;
    var this$1 = this.x2$2$2;
    var this$2 = $as_Lamf_core_model_StrField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1)).option$1;
    if (jsx$1.contains__O__Z((this$2.isEmpty__Z() ? "" : this$2.get__O()))) {
      return true
    }
  };
  return false
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$$anonfun$$nestedInanonfun$mergeDataNodes$1$1.prototype.applyOrElse__Lamf_core_model_domain_DataNode__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_core_model_domain_ScalarNode)) {
    var x2 = $as_Lamf_core_model_domain_ScalarNode(x1);
    var jsx$1 = $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1)).option$1;
    var this$1 = this.x2$2$2;
    var this$2 = $as_Lamf_core_model_StrField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1)).option$1;
    if (jsx$1.contains__O__Z((this$2.isEmpty__Z() ? "" : this$2.get__O()))) {
      return x2
    }
  };
  return $default.apply__O__O(x1)
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$$anonfun$$nestedInanonfun$mergeDataNodes$1$1.prototype.init___Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging__Lamf_core_model_domain_ScalarNode = (function($$outer, x2$2) {
  this.x2$2$2 = x2$2;
  return this
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$$anonfun$$nestedInanonfun$mergeDataNodes$1$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DataNode__Z($as_Lamf_core_model_domain_DataNode(x))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$$anonfun$$nestedInanonfun$mergeDataNodes$1$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DataNode__F1__O($as_Lamf_core_model_domain_DataNode(x), $default)
});
var $d_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$$anonfun$$nestedInanonfun$mergeDataNodes$1$1 = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$$anonfun$$nestedInanonfun$mergeDataNodes$1$1: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.DomainElementMerging$$anonfun$$nestedInanonfun$mergeDataNodes$1$1", {
  Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$$anonfun$$nestedInanonfun$mergeDataNodes$1$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$$anonfun$$nestedInanonfun$mergeDataNodes$1$1.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_DomainElementMerging$$anonfun$$nestedInanonfun$mergeDataNodes$1$1;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getMessageTraits$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getMessageTraits$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getMessageTraits$1.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getMessageTraits$1;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getMessageTraits$1() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getMessageTraits$1.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getMessageTraits$1.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getMessageTraits$1.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Message)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_Message(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getMessageTraits$1.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_Message)
});
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getMessageTraits$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getMessageTraits$1.prototype.init___Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage = (function($$outer) {
  return this
});
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getMessageTraits$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getMessageTraits$1 = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getMessageTraits$1: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.JsonMergePatchStage$$anonfun$getMessageTraits$1", {
  Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getMessageTraits$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getMessageTraits$1.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getMessageTraits$1;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getOperationTraits$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getOperationTraits$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getOperationTraits$1.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getOperationTraits$1;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getOperationTraits$1() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getOperationTraits$1.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getOperationTraits$1.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getOperationTraits$1.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Operation)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_Operation(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getOperationTraits$1.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return (x1 instanceof $c_Lamf_plugins_domain_webapi_models_Operation)
});
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getOperationTraits$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getOperationTraits$1.prototype.init___Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage = (function($$outer) {
  return this
});
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getOperationTraits$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
var $d_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getOperationTraits$1 = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getOperationTraits$1: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.JsonMergePatchStage$$anonfun$getOperationTraits$1", {
  Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getOperationTraits$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getOperationTraits$1.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_JsonMergePatchStage$$anonfun$getOperationTraits$1;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage$$anonfun$searchDeclarations$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage$$anonfun$searchDeclarations$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage$$anonfun$searchDeclarations$1.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage$$anonfun$searchDeclarations$1;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage$$anonfun$searchDeclarations$1() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage$$anonfun$searchDeclarations$1.prototype = $c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage$$anonfun$searchDeclarations$1.prototype;
$c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage$$anonfun$searchDeclarations$1.prototype.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Parameter)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_Parameter(x1);
    var jsx$1 = $as_sc_Seq(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Payloads$1));
    var this$1 = $m_sc_Seq$();
    return jsx$1.$$colon$plus__O__scg_CanBuildFrom__O(x2, this$1.ReusableCBFInstance$2)
  } else if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Request)) {
    var x3 = $as_Lamf_plugins_domain_webapi_models_Request(x1);
    return $as_sc_Seq(x3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1))
  } else if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Response)) {
    var x4 = $as_Lamf_plugins_domain_webapi_models_Response(x1);
    return $as_sc_Seq(x4.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1))
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage$$anonfun$searchDeclarations$1.prototype.isDefinedAt__Lamf_core_model_domain_DomainElement__Z = (function(x1) {
  return ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Parameter) || ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Request) || (x1 instanceof $c_Lamf_plugins_domain_webapi_models_Response)))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage$$anonfun$searchDeclarations$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(x))
});
$c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage$$anonfun$searchDeclarations$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lamf_core_model_domain_DomainElement__F1__O($as_Lamf_core_model_domain_DomainElement(x), $default)
});
$c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage$$anonfun$searchDeclarations$1.prototype.init___Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage = (function($$outer) {
  return this
});
var $d_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage$$anonfun$searchDeclarations$1 = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage$$anonfun$searchDeclarations$1: 0
}, false, "amf.plugins.domain.webapi.resolution.stages.PayloadAndParameterResolutionStage$$anonfun$searchDeclarations$1", {
  Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage$$anonfun$searchDeclarations$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage$$anonfun$searchDeclarations$1.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_stages_PayloadAndParameterResolutionStage$$anonfun$searchDeclarations$1;
/** @constructor */
function $c_Lamf_plugins_features_validation_AMFValidatorPlugin$() {
  $c_O.call(this);
  this.ID$1 = null;
  this.url$1 = null;
  this.customValidationProfiles$1 = null;
  this.customValidationProfilesPlugins$1 = null;
  this.platform$1 = null
}
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype = new $h_O();
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype.constructor = $c_Lamf_plugins_features_validation_AMFValidatorPlugin$;
/** @constructor */
function $h_Lamf_plugins_features_validation_AMFValidatorPlugin$() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype = $c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype;
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype.init__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  $m_Lamf_core_services_RuntimeValidator$().register__Lamf_core_services_RuntimeValidator__V($m_Lamf_plugins_features_validation_AMFValidatorPlugin$());
  $m_Lamf_core_benchmark_ExecutionLog$().log__T__Lamf_core_benchmark_ExecutionLog$("Register RDF framework");
  this.platform$1.rdfFramework$und$eq__s_Option__V(new $c_s_Some().init___O($m_Lamf_plugins_features_validation_PlatformValidator$().instance$1));
  $m_Lamf_core_benchmark_ExecutionLog$().log__T__Lamf_core_benchmark_ExecutionLog$("AMFValidatorPlugin#init: registering validation dialect");
  return $m_Lamf_plugins_document_vocabularies_AMLPlugin$().apply__Lamf_plugins_document_vocabularies_AMLPlugin().registry$2.registerDialect__T__T__s_concurrent_ExecutionContext__s_concurrent_Future(this.url$1, $m_Lamf_plugins_features_validation_model_ValidationDialectText$().text__T(), executionContext).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      $as_Lamf_plugins_document_vocabularies_model_document_Dialect(x$1$2);
      $m_Lamf_core_benchmark_ExecutionLog$().log__T__Lamf_core_benchmark_ExecutionLog$("AMFValidatorPlugin#init: validation dialect registered");
      return $m_Lamf_plugins_features_validation_AMFValidatorPlugin$()
    })
  })(this)), executionContext)
});
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype.init___ = (function() {
  $n_Lamf_plugins_features_validation_AMFValidatorPlugin$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  this.ID$1 = "AMF Validation";
  this.url$1 = "http://a.ml/dialects/profile.raml";
  this.customValidationProfiles$1 = $m_sci_Map$EmptyMap$();
  this.customValidationProfilesPlugins$1 = $m_sci_Map$EmptyMap$();
  return this
});
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype.shaclValidation__Lamf_core_model_document_BaseUnit__Lamf_core_validation_EffectiveValidations__sci_Map__Lamf_core_services_ValidationOptions__s_concurrent_ExecutionContext__s_concurrent_Future = (function(model, validations, customFunctions, options, executionContext) {
  return (options.isPartialValidation__Z() ? this.partialShaclValidation__Lamf_core_model_document_BaseUnit__Lamf_core_validation_EffectiveValidations__sci_Map__Lamf_core_services_ValidationOptions__s_concurrent_ExecutionContext__s_concurrent_Future(model, validations, customFunctions, options, executionContext) : this.fullShaclValidation__Lamf_core_model_document_BaseUnit__Lamf_core_validation_EffectiveValidations__Lamf_core_services_ValidationOptions__s_concurrent_ExecutionContext__s_concurrent_Future(model, validations, options, executionContext))
});
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype.loadValidationProfile__T__Lamf_internal_environment_Environment__Lamf_core_errorhandling_ErrorHandler__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future = (function(validationProfilePath, env, errorHandler, exec) {
  var executionContext = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  var x$2 = new $c_s_Some().init___O("application/yaml");
  var x$3 = new $c_s_Some().init___O($m_Lamf_plugins_document_vocabularies_AMLPlugin$().ID$2);
  var x$4 = $m_Lamf_core_remote_Context$().apply__Lamf_core_remote_Platform__Lamf_core_remote_Context(this.platform$1);
  var x$5 = new $c_Lamf_core_remote_Cache().init___();
  var x$7 = $m_Lamf_client_parse_DefaultParserErrorHandler$().fromErrorHandler__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_errorhandler_AmfParserErrorHandler(errorHandler);
  $m_Lamf_core_services_RuntimeCompiler$();
  var x$8 = $m_Lamf_core_parser_UnspecifiedReference$();
  $m_Lamf_core_services_RuntimeCompiler$();
  var x$9 = $m_s_None$();
  $m_Lamf_core_services_RuntimeCompiler$();
  var x$10 = new $c_Lamf_core_client_ParsingOptions().init___();
  return $m_Lamf_core_services_RuntimeCompiler$().apply__T__s_Option__s_Option__Lamf_core_remote_Context__Lamf_core_remote_Cache__Lamf_core_parser_ReferenceKind__s_Option__Lamf_internal_environment_Environment__Lamf_core_client_ParsingOptions__Lamf_core_parser_errorhandler_AmfParserErrorHandler__s_concurrent_ExecutionContext__s_concurrent_Future(validationProfilePath, x$2, x$3, x$4, x$5, x$8, x$9, env, x$10, x$7, executionContext).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_document_BaseUnit(x0$1$2);
      if ((x0$1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstance)) {
        var x2 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstance(x0$1);
        var this$6 = $as_Lamf_core_model_StrField(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().DefinedBy$1));
        var other = $m_Lamf_plugins_features_validation_AMFValidatorPlugin$().url$1;
        if ($f_Lamf_core_model_ValueField__is__O__Z(this$6, other)) {
          return $as_Lamf_core_model_domain_DomainElement(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().Encodes$1))
        }
      };
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Trying to load as a validation profile that does not match the Validation Profile dialect"))
    })
  })(this)), executionContext).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x0$2$2) {
      var x0$2 = $as_Lamf_core_model_domain_DomainElement(x0$2$2);
      if ((x0$2 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
        var x2$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x0$2);
        var this$7 = x2$1.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping();
        var this$8 = $as_Lamf_core_model_StrField(this$7.fields$1.field__Lamf_core_metamodel_Field__O(this$7.Name$1));
        if ($f_Lamf_core_model_ValueField__is__O__Z(this$8, "profileNode")) {
          var profile = $m_Lamf_plugins_features_validation_model_ParsedValidationProfile$().apply__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_core_validation_core_ValidationProfile(x2$1);
          var jsx$1 = $m_Lamf_plugins_features_validation_AMFValidatorPlugin$().profilesPlugins__sci_Map();
          var this$9 = profile.name$1;
          var x1$2 = jsx$1.get__O__s_Option(this$9.p$1);
          if ((x1$2 instanceof $c_s_Some)) {
            var x2$2 = $as_s_Some(x1$2);
            var plugin = $as_Lamf_client_plugins_AMFDocumentPlugin(x2$2.value$2);
            var domainPlugin = plugin
          } else {
            var x = $m_s_None$();
            if ((!(x === x1$2))) {
              throw new $c_s_MatchError().init___O(x1$2)
            };
            var jsx$2 = $m_Lamf_plugins_features_validation_AMFValidatorPlugin$().profilesPlugins__sci_Map();
            var this$10 = profile.baseProfile$1;
            var this$11 = $as_Lamf_ProfileName((this$10.isEmpty__Z() ? $m_Lamf_AmfProfile$() : this$10.get__O()));
            var x1$3 = jsx$2.get__O__s_Option(this$11.p$1);
            if ((x1$3 instanceof $c_s_Some)) {
              var x2$3 = $as_s_Some(x1$3);
              var plugin$2 = $as_Lamf_client_plugins_AMFDocumentPlugin(x2$3.value$2);
              var domainPlugin = plugin$2
            } else {
              var x$3$1 = $m_s_None$();
              if ((!(x$3$1 === x1$3))) {
                throw new $c_s_MatchError().init___O(x1$3)
              };
              var domainPlugin = $as_Lamf_client_plugins_AMFDocumentPlugin($m_Lamf_plugins_document_vocabularies_AMLPlugin$().apply__Lamf_plugins_document_vocabularies_AMLPlugin())
            }
          };
          var jsx$4 = $m_Lamf_plugins_features_validation_AMFValidatorPlugin$();
          var jsx$3 = $m_Lamf_plugins_features_validation_AMFValidatorPlugin$().customValidationProfiles$1;
          var this$12 = profile.name$1;
          var self = this$12.p$1;
          var y = new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$2$2, profile$1) {
            return (function() {
              return profile$1
            })
          })(this$2$1, profile));
          jsx$4.customValidationProfiles$1 = jsx$3.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, y));
          var jsx$6 = $m_Lamf_plugins_features_validation_AMFValidatorPlugin$();
          var jsx$5 = $m_Lamf_plugins_features_validation_AMFValidatorPlugin$().customValidationProfilesPlugins$1;
          var this$15 = profile.name$1;
          var self$1 = this$15.p$1;
          jsx$6.customValidationProfilesPlugins$1 = jsx$5.$$plus__T2__sci_Map(new $c_T2().init___O__O(self$1, domainPlugin));
          return profile.name$1
        }
      };
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Trying to load as a validation profile that does not match the Validation Profile dialect"))
    })
  })(this)), executionContext)
});
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype.computeValidations__Lamf_ProfileName__Lamf_core_validation_EffectiveValidations__Lamf_core_validation_EffectiveValidations = (function(profileName, computed) {
  var x1 = this.profiles__sci_Map().get__O__s_Option(profileName.p$1);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var profileGenerator = $as_F0(x2.value$2);
    var maybeProfile = new $c_s_Some().init___O(profileGenerator.apply__O())
  } else {
    var maybeProfile = $m_s_None$()
  };
  if ((maybeProfile instanceof $c_s_Some)) {
    var x2$2 = $as_s_Some(maybeProfile);
    var foundProfile = $as_Lamf_core_validation_core_ValidationProfile(x2$2.value$2);
    return (foundProfile.baseProfile$1.isDefined__Z() ? this.computeValidations__Lamf_ProfileName__Lamf_core_validation_EffectiveValidations__Lamf_core_validation_EffectiveValidations($as_Lamf_ProfileName(foundProfile.baseProfile$1.get__O()), computed).someEffective__Lamf_core_validation_core_ValidationProfile__Lamf_core_validation_EffectiveValidations(foundProfile) : computed.someEffective__Lamf_core_validation_core_ValidationProfile__Lamf_core_validation_EffectiveValidations(foundProfile))
  } else {
    var x = $m_s_None$();
    if ((x === maybeProfile)) {
      return computed
    } else {
      throw new $c_s_MatchError().init___O(maybeProfile)
    }
  }
});
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype.getSource__p1__Lamf_core_model_document_BaseUnit__s_Option = (function(unit) {
  if ((unit instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(unit);
    var this$1 = x2.encodes__Lamf_core_model_domain_DomainElement().annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_SourceVendor.getClassOf());
    if (this$1.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1 = this$1.get__O();
      var x$2 = $as_Lamf_core_annotations_SourceVendor(arg1);
      return new $c_s_Some().init___O(x$2.vendor$1)
    }
  } else if ((unit instanceof $c_Lamf_core_model_document_Module)) {
    var x3 = $as_Lamf_core_model_document_Module(unit);
    var this$2 = x3.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_SourceVendor.getClassOf());
    if (this$2.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1$1 = this$2.get__O();
      var x$3 = $as_Lamf_core_annotations_SourceVendor(arg1$1);
      return new $c_s_Some().init___O(x$3.vendor$1)
    }
  } else if ($is_Lamf_core_model_document_Fragment(unit)) {
    var x4 = $as_Lamf_core_model_document_Fragment(unit);
    var this$3 = x4.encodes__Lamf_core_model_domain_DomainElement().annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_SourceVendor.getClassOf());
    if (this$3.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1$2 = this$3.get__O();
      var x$4 = $as_Lamf_core_annotations_SourceVendor(arg1$2);
      return new $c_s_Some().init___O(x$4.vendor$1)
    }
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype.profiles__sci_Map = (function() {
  var this$1 = $m_Lamf_core_registries_AMFPluginsRegistry$();
  var this$2 = this$1.documentPluginIDRegistry$1;
  var this$3 = new $c_scm_HashMap$$anon$2().init___scm_HashMap(this$2);
  var z = $m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$());
  var elem$1 = null;
  elem$1 = z;
  var this$5 = this$3.$$outer$4;
  var iterTable = this$5.table$5;
  var idx = $f_scm_HashTable__scala$collection$mutable$HashTable$$lastPopulatedIndex__I(this$5);
  var es = iterTable.get(idx);
  while ((es !== null)) {
    var next = $as_scm_HashEntry(es.next__O());
    var arg1 = es;
    var e = $as_scm_DefaultEntry(arg1);
    var arg1$1 = e.value$1;
    var arg1$2 = elem$1;
    var x0$1 = $as_sci_Map(arg1$2);
    var x1$1 = $as_Lamf_client_plugins_AMFDocumentPlugin(arg1$1);
    elem$1 = ($is_Lamf_client_plugins_AMFValidationPlugin(x1$1) ? x0$1.$$plus$plus__sc_GenTraversableOnce__sci_Map($as_Lamf_client_plugins_AMFValidationPlugin(x1$1).domainValidationProfiles__Lamf_core_remote_Platform__sci_Map($m_Lamf_plugins_features_validation_AMFValidatorPlugin$().platform$1)) : x0$1);
    es = next;
    while (((es === null) && (idx > 0))) {
      idx = (((-1) + idx) | 0);
      es = iterTable.get(idx)
    }
  };
  return $as_sci_MapLike(elem$1).$$plus$plus__sc_GenTraversableOnce__sci_Map(this.customValidationProfiles$1)
});
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype.shapesGraph__Lamf_core_validation_EffectiveValidations__Lamf_ProfileName__T = (function(validations, profileName) {
  return new $c_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter().init___Lamf_ProfileName(profileName).emitJSON__sc_Seq__T(this.customValidations__Lamf_core_validation_EffectiveValidations__sc_Seq(validations))
});
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype.customValidations__Lamf_core_validation_EffectiveValidations__sc_Seq = (function(validations) {
  var this$1 = validations.effective$1;
  var this$2 = new $c_scm_HashMap$$anon$2().init___scm_HashMap(this$1);
  var this$3 = this$2.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream();
  var p = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(s$2) {
      var s = $as_Lamf_core_validation_core_ValidationSpecification(s$2);
      return (!s.isParserSide__Z())
    })
  })(this));
  return this$3.filterImpl__F1__Z__sci_Stream(p, false)
});
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype.ID__T = (function() {
  return this.ID$1
});
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype.dependencies__sc_Seq = (function() {
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_syntax_SYamlSyntaxPlugin$(), $m_Lamf_plugins_document_vocabularies_AMLPlugin$(), $m_Lamf_plugins_document_graph_AMFGraphPlugin$()];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype.partialShaclValidation__Lamf_core_model_document_BaseUnit__Lamf_core_validation_EffectiveValidations__sci_Map__Lamf_core_services_ValidationOptions__s_concurrent_ExecutionContext__s_concurrent_Future = (function(model, validations, customFunctions, options, executionContext) {
  return new $c_Lamf_plugins_features_validation_CustomShaclValidator().init___Lamf_core_model_document_BaseUnit__Lamf_core_validation_EffectiveValidations__sci_Map__Lamf_core_services_ValidationOptions__s_concurrent_ExecutionContext(model, validations, customFunctions, options, executionContext).run__s_concurrent_Future()
});
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype.profileForUnit__p1__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_ProfileName = (function(unit, given) {
  var x = $m_Lamf_OasProfile$();
  if (x.equals__O__Z(given)) {
    var x1$2 = this.getSource__p1__Lamf_core_model_document_BaseUnit__s_Option(unit);
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var p3 = $as_Lamf_core_remote_Vendor(x2.value$2);
      var x$3 = $m_Lamf_core_remote_Oas30$();
      if ((x$3 === p3)) {
        return $m_Lamf_Oas30Profile$()
      }
    };
    return $m_Lamf_Oas20Profile$()
  } else {
    var x$5 = $m_Lamf_RamlProfile$();
    if (x$5.equals__O__Z(given)) {
      var x1$3 = this.getSource__p1__Lamf_core_model_document_BaseUnit__s_Option(unit);
      if ((x1$3 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$3);
        var p3$2 = $as_Lamf_core_remote_Vendor(x2$2.value$2);
        var x$7 = $m_Lamf_core_remote_Raml08$();
        if ((x$7 === p3$2)) {
          return $m_Lamf_Raml08Profile$()
        }
      };
      return $m_Lamf_Raml10Profile$()
    } else {
      return given
    }
  }
});
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype.modelValidation__p1__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future = (function(model, profileName, messageStyle, env, resolved, exec) {
  var executionContext = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  var x1 = this.profilesPlugins__sci_Map().get__O__s_Option(profileName.p$1);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var domainPlugin = $as_Lamf_client_plugins_AMFDocumentPlugin(x2.value$2);
    if ($is_Lamf_client_plugins_AMFValidationPlugin(domainPlugin)) {
      var validations = this.computeValidations__Lamf_ProfileName__Lamf_core_validation_EffectiveValidations__Lamf_core_validation_EffectiveValidations(profileName, new $c_Lamf_core_validation_EffectiveValidations().init___scm_HashMap__scm_HashMap__scm_HashMap__scm_HashMap__scm_HashMap($as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()))));
      return $as_Lamf_client_plugins_AMFValidationPlugin(domainPlugin).validationRequest__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_validation_EffectiveValidations__Lamf_core_remote_Platform__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(model, profileName, validations, this.platform$1, env, resolved, exec)
    }
  };
  return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, model$1, profileName$1) {
    return (function() {
      return $m_Lamf_plugins_features_validation_AMFValidatorPlugin$().profileNotFoundWarningReport__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_validation_AMFValidationReport(model$1, profileName$1)
    })
  })(this, model, profileName)), executionContext)
});
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype.profilesPlugins__sci_Map = (function() {
  var this$1 = $m_Lamf_core_registries_AMFPluginsRegistry$();
  var this$2 = this$1.documentPluginIDRegistry$1;
  var this$3 = new $c_scm_HashMap$$anon$2().init___scm_HashMap(this$2);
  var z = $m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$());
  var elem$1 = null;
  elem$1 = z;
  var this$5 = this$3.$$outer$4;
  var iterTable = this$5.table$5;
  var idx = $f_scm_HashTable__scala$collection$mutable$HashTable$$lastPopulatedIndex__I(this$5);
  var es = iterTable.get(idx);
  while ((es !== null)) {
    var next = $as_scm_HashEntry(es.next__O());
    var arg1 = es;
    var e = $as_scm_DefaultEntry(arg1);
    var arg1$1 = e.value$1;
    var arg1$2 = elem$1;
    var x0$1 = $as_sci_Map(arg1$2);
    var x1$1 = $as_Lamf_client_plugins_AMFDocumentPlugin(arg1$1);
    if ($is_Lamf_client_plugins_AMFValidationPlugin(x1$1)) {
      var this$6 = $as_Lamf_client_plugins_AMFValidationPlugin(x1$1).domainValidationProfiles__Lamf_core_remote_Platform__sci_Map($m_Lamf_plugins_features_validation_AMFValidatorPlugin$().platform$1);
      var this$7 = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(this$6);
      var z$1 = $m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$());
      var op = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this, x3) {
        return (function(x0$2$2, x1$2$2) {
          var x0$2 = $as_sci_Map(x0$2$2);
          var x1$2 = $as_T(x1$2$2);
          return x0$2.updated__O__O__sci_Map(x1$2, x3)
        })
      })(this, x1$1));
      var toPut = $as_sci_Map($f_sc_TraversableOnce__foldLeft__O__F2__O(this$7, z$1, op));
      elem$1 = x0$1.$$plus$plus__sc_GenTraversableOnce__sci_Map(toPut)
    } else {
      elem$1 = x0$1
    };
    es = next;
    while (((es === null) && (idx > 0))) {
      idx = (((-1) + idx) | 0);
      es = iterTable.get(idx)
    }
  };
  return $as_sci_MapLike(elem$1).$$plus$plus__sc_GenTraversableOnce__sci_Map(this.customValidationProfilesPlugins$1)
});
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype.fullShaclValidation__Lamf_core_model_document_BaseUnit__Lamf_core_validation_EffectiveValidations__Lamf_core_services_ValidationOptions__s_concurrent_ExecutionContext__s_concurrent_Future = (function(model, validations, options, executionContext) {
  var jsx$1 = $m_Lamf_core_benchmark_ExecutionLog$();
  var this$1 = validations.effective$1;
  var this$2 = new $c_scm_HashMap$$anon$2().init___scm_HashMap(this$1);
  jsx$1.log__T__Lamf_core_benchmark_ExecutionLog$((("AMFValidatorPlugin#shaclValidation: shacl validation for " + this$2.$$outer$3.size__I()) + " validations"));
  if (($m_Lamf_plugins_features_validation_PlatformValidator$(), true)) {
    var jsx$2 = new $c_Lamf_plugins_features_validation_emitters_JSLibraryEmitter().init___s_Option($m_s_None$());
    var this$3 = validations.effective$1;
    var this$4 = new $c_scm_HashMap$$anon$2().init___scm_HashMap(this$3);
    var jsLibrary = jsx$2.emitJS__sc_Seq__s_Option(this$4.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream());
    if ((jsLibrary instanceof $c_s_Some)) {
      var x2 = $as_s_Some(jsLibrary);
      var code = $as_T(x2.value$2);
      $m_Lamf_plugins_features_validation_PlatformValidator$().instance$1.registerLibrary__T__T__V($m_Lamf_plugins_features_validation_emitters_ValidationJSONLDEmitter$().validationLibraryUrl__T(), code)
    }
  };
  $m_Lamf_core_benchmark_ExecutionLog$().log__T__Lamf_core_benchmark_ExecutionLog$("AMFValidatorPlugin#shaclValidation: jsLibrary generated");
  var shapes = this.customValidations__Lamf_core_validation_EffectiveValidations__sc_Seq(validations);
  $m_Lamf_core_benchmark_ExecutionLog$().log__T__Lamf_core_benchmark_ExecutionLog$("AMFValidatorPlugin#shaclValidation: Invoking platform validation");
  return $m_Lamf_plugins_features_validation_PlatformValidator$().instance$1.report__Lamf_core_model_document_BaseUnit__sc_Seq__Lamf_core_services_ValidationOptions__s_concurrent_ExecutionContext__s_concurrent_Future(model, shapes, options, executionContext).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_validation_core_ValidationReport(x0$1$2);
      $m_Lamf_core_benchmark_ExecutionLog$().log__T__Lamf_core_benchmark_ExecutionLog$("AMFValidatorPlugin#shaclValidation: validation finished");
      return x0$1
    })
  })(this)), executionContext)
});
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype.profileNotFoundWarningReport__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_validation_AMFValidationReport = (function(model, profileName) {
  var this$1 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(model);
  return new $c_Lamf_core_validation_AMFValidationReport().init___Z__T__Lamf_ProfileName__sc_Seq(true, $as_T((this$1.isEmpty__Z() ? model.id__T() : this$1.get__O())), profileName, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())))
});
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype.validate__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future = (function(model, given, messageStyle, env, resolved, exec) {
  var profileName = this.profileForUnit__p1__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_ProfileName(model, given);
  var report = new $c_Lamf_core_errorhandling_AmfStaticReportBuilder().init___Lamf_core_model_document_BaseUnit__Lamf_ProfileName(model, profileName).buildFromStatic__Lamf_core_validation_AMFValidationReport();
  return ((!report.conforms$1) ? $m_s_concurrent_Future$().successful__O__s_concurrent_Future(report) : this.modelValidation__p1__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_MessageStyle__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(model, profileName, messageStyle, env, resolved, exec))
});
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype.emitShapesGraph__Lamf_ProfileName__T = (function(profileName) {
  var effectiveValidations = this.computeValidations__Lamf_ProfileName__Lamf_core_validation_EffectiveValidations__Lamf_core_validation_EffectiveValidations(profileName, new $c_Lamf_core_validation_EffectiveValidations().init___scm_HashMap__scm_HashMap__scm_HashMap__scm_HashMap__scm_HashMap($as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $as_scm_HashMap($m_scm_HashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()))));
  return this.shapesGraph__Lamf_core_validation_EffectiveValidations__Lamf_ProfileName__T(effectiveValidations, profileName)
});
var $d_Lamf_plugins_features_validation_AMFValidatorPlugin$ = new $TypeData().initClass({
  Lamf_plugins_features_validation_AMFValidatorPlugin$: 0
}, false, "amf.plugins.features.validation.AMFValidatorPlugin$", {
  Lamf_plugins_features_validation_AMFValidatorPlugin$: 1,
  O: 1,
  Lamf_client_plugins_AMFFeaturePlugin: 1,
  Lamf_client_plugins_AMFPlugin: 1,
  Lamf_core_services_RuntimeValidator: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_validation_ValidationResultProcessor: 1
});
$c_Lamf_plugins_features_validation_AMFValidatorPlugin$.prototype.$classData = $d_Lamf_plugins_features_validation_AMFValidatorPlugin$;
var $n_Lamf_plugins_features_validation_AMFValidatorPlugin$ = (void 0);
function $m_Lamf_plugins_features_validation_AMFValidatorPlugin$() {
  if ((!$n_Lamf_plugins_features_validation_AMFValidatorPlugin$)) {
    $n_Lamf_plugins_features_validation_AMFValidatorPlugin$ = new $c_Lamf_plugins_features_validation_AMFValidatorPlugin$().init___()
  };
  return $n_Lamf_plugins_features_validation_AMFValidatorPlugin$
}
/** @constructor */
function $c_Lamf_plugins_features_validation_CustomValidationResult() {
  $c_O.call(this);
  this.message$1 = null;
  this.path$1 = null;
  this.sourceConstraintComponent$1 = null;
  this.focusNode$1 = null;
  this.severity$1 = null;
  this.sourceShape$1 = null
}
$c_Lamf_plugins_features_validation_CustomValidationResult.prototype = new $h_O();
$c_Lamf_plugins_features_validation_CustomValidationResult.prototype.constructor = $c_Lamf_plugins_features_validation_CustomValidationResult;
/** @constructor */
function $h_Lamf_plugins_features_validation_CustomValidationResult() {
  /*<skip>*/
}
$h_Lamf_plugins_features_validation_CustomValidationResult.prototype = $c_Lamf_plugins_features_validation_CustomValidationResult.prototype;
$c_Lamf_plugins_features_validation_CustomValidationResult.prototype.productPrefix__T = (function() {
  return "CustomValidationResult"
});
$c_Lamf_plugins_features_validation_CustomValidationResult.prototype.severity__T = (function() {
  return this.severity$1
});
$c_Lamf_plugins_features_validation_CustomValidationResult.prototype.productArity__I = (function() {
  return 6
});
$c_Lamf_plugins_features_validation_CustomValidationResult.prototype.path__T = (function() {
  return this.path$1
});
$c_Lamf_plugins_features_validation_CustomValidationResult.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_features_validation_CustomValidationResult)) {
    var CustomValidationResult$1 = $as_Lamf_plugins_features_validation_CustomValidationResult(x$1);
    var x = this.message$1;
    var x$2 = CustomValidationResult$1.message$1;
    if (((((((x === null) ? (x$2 === null) : x.equals__O__Z(x$2)) && (this.path$1 === CustomValidationResult$1.path$1)) && (this.sourceConstraintComponent$1 === CustomValidationResult$1.sourceConstraintComponent$1)) && (this.focusNode$1 === CustomValidationResult$1.focusNode$1)) && (this.severity$1 === CustomValidationResult$1.severity$1))) {
      return (this.sourceShape$1 === CustomValidationResult$1.sourceShape$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_features_validation_CustomValidationResult.prototype.message__s_Option = (function() {
  return this.message$1
});
$c_Lamf_plugins_features_validation_CustomValidationResult.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.message$1;
      break
    }
    case 1: {
      return this.path$1;
      break
    }
    case 2: {
      return this.sourceConstraintComponent$1;
      break
    }
    case 3: {
      return this.focusNode$1;
      break
    }
    case 4: {
      return this.severity$1;
      break
    }
    case 5: {
      return this.sourceShape$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_features_validation_CustomValidationResult.prototype.sourceConstraintComponent__T = (function() {
  return this.sourceConstraintComponent$1
});
$c_Lamf_plugins_features_validation_CustomValidationResult.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_features_validation_CustomValidationResult.prototype.focusNode__T = (function() {
  return this.focusNode$1
});
$c_Lamf_plugins_features_validation_CustomValidationResult.prototype.init___s_Option__T__T__T__T__T = (function(message, path, sourceConstraintComponent, focusNode, severity, sourceShape) {
  this.message$1 = message;
  this.path$1 = path;
  this.sourceConstraintComponent$1 = sourceConstraintComponent;
  this.focusNode$1 = focusNode;
  this.severity$1 = severity;
  this.sourceShape$1 = sourceShape;
  return this
});
$c_Lamf_plugins_features_validation_CustomValidationResult.prototype.sourceShape__T = (function() {
  return this.sourceShape$1
});
$c_Lamf_plugins_features_validation_CustomValidationResult.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_features_validation_CustomValidationResult.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_features_validation_CustomValidationResult(obj) {
  return (((obj instanceof $c_Lamf_plugins_features_validation_CustomValidationResult) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.features.validation.CustomValidationResult"))
}
function $isArrayOf_Lamf_plugins_features_validation_CustomValidationResult(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_features_validation_CustomValidationResult)))
}
function $asArrayOf_Lamf_plugins_features_validation_CustomValidationResult(obj, depth) {
  return (($isArrayOf_Lamf_plugins_features_validation_CustomValidationResult(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.features.validation.CustomValidationResult;", depth))
}
var $d_Lamf_plugins_features_validation_CustomValidationResult = new $TypeData().initClass({
  Lamf_plugins_features_validation_CustomValidationResult: 0
}, false, "amf.plugins.features.validation.CustomValidationResult", {
  Lamf_plugins_features_validation_CustomValidationResult: 1,
  O: 1,
  Lamf_core_validation_core_ValidationResult: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_features_validation_CustomValidationResult.prototype.$classData = $d_Lamf_plugins_features_validation_CustomValidationResult;
/** @constructor */
function $c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$1.prototype.constructor = $c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$1;
/** @constructor */
function $h_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$1() {
  /*<skip>*/
}
$h_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$1.prototype = $c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$1.prototype;
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$1.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$1.prototype.isDefinedAt__Lorg_yaml_model_YPart__Z = (function(x1) {
  return (x1 instanceof $c_Lorg_yaml_model_YComment)
});
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$1.prototype.applyOrElse__Lorg_yaml_model_YPart__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lorg_yaml_model_YComment)) {
    var x2 = $as_Lorg_yaml_model_YComment(x1);
    return x2.metaText$4
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lorg_yaml_model_YPart__Z($as_Lorg_yaml_model_YPart(x))
});
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lorg_yaml_model_YPart__F1__O($as_Lorg_yaml_model_YPart(x), $default)
});
var $d_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$1 = new $TypeData().initClass({
  Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$1: 0
}, false, "amf.plugins.syntax.SYamlSyntaxPlugin$$anonfun$1", {
  Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$1.prototype.$classData = $d_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$1;
/** @constructor */
function $c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$2.prototype.constructor = $c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$2;
/** @constructor */
function $h_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$2() {
  /*<skip>*/
}
$h_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$2.prototype = $c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$2.prototype;
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$2.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$2.prototype.isDefinedAt__Lorg_yaml_model_YPart__Z = (function(x2) {
  return (x2 instanceof $c_Lorg_yaml_model_YDocument)
});
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$2.prototype.applyOrElse__Lorg_yaml_model_YPart__F1__O = (function(x2, $default) {
  if ((x2 instanceof $c_Lorg_yaml_model_YDocument)) {
    var x2$2 = $as_Lorg_yaml_model_YDocument(x2);
    return x2$2
  } else {
    return $default.apply__O__O(x2)
  }
});
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lorg_yaml_model_YPart__Z($as_Lorg_yaml_model_YPart(x))
});
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lorg_yaml_model_YPart__F1__O($as_Lorg_yaml_model_YPart(x), $default)
});
var $d_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$2 = new $TypeData().initClass({
  Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$2: 0
}, false, "amf.plugins.syntax.SYamlSyntaxPlugin$$anonfun$2", {
  Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$2.prototype.$classData = $d_Lamf_plugins_syntax_SYamlSyntaxPlugin$$anonfun$2;
/** @constructor */
function $c_Ljava_io_StringWriter() {
  $c_Ljava_io_Writer.call(this);
  this.buf$2 = null
}
$c_Ljava_io_StringWriter.prototype = new $h_Ljava_io_Writer();
$c_Ljava_io_StringWriter.prototype.constructor = $c_Ljava_io_StringWriter;
/** @constructor */
function $h_Ljava_io_StringWriter() {
  /*<skip>*/
}
$h_Ljava_io_StringWriter.prototype = $c_Ljava_io_StringWriter.prototype;
$c_Ljava_io_StringWriter.prototype.init___ = (function() {
  $c_Ljava_io_Writer.prototype.init___s_Option.call(this, $m_s_None$());
  this.buf$2 = new $c_jl_StringBuffer().init___();
  return this
});
$c_Ljava_io_StringWriter.prototype.append__C__Ljava_io_StringWriter = (function(c) {
  this.buf$2.append__C__jl_StringBuffer(c);
  return this
});
$c_Ljava_io_StringWriter.prototype.toString__T = (function() {
  return this.buf$2.toString__T()
});
$c_Ljava_io_StringWriter.prototype.append__jl_CharSequence__jl_Appendable = (function(x$1) {
  return this.append__jl_CharSequence__Ljava_io_StringWriter(x$1)
});
$c_Ljava_io_StringWriter.prototype.append__jl_CharSequence__Ljava_io_StringWriter = (function(csq) {
  this.buf$2.append__jl_CharSequence__jl_StringBuffer(csq);
  return this
});
$c_Ljava_io_StringWriter.prototype.close__V = (function() {
  /*<skip>*/
});
function $as_Ljava_io_StringWriter(obj) {
  return (((obj instanceof $c_Ljava_io_StringWriter) || (obj === null)) ? obj : $throwClassCastException(obj, "java.io.StringWriter"))
}
function $isArrayOf_Ljava_io_StringWriter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Ljava_io_StringWriter)))
}
function $asArrayOf_Ljava_io_StringWriter(obj, depth) {
  return (($isArrayOf_Ljava_io_StringWriter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.io.StringWriter;", depth))
}
var $d_Ljava_io_StringWriter = new $TypeData().initClass({
  Ljava_io_StringWriter: 0
}, false, "java.io.StringWriter", {
  Ljava_io_StringWriter: 1,
  Ljava_io_Writer: 1,
  O: 1,
  jl_Appendable: 1,
  Ljava_io_Closeable: 1,
  jl_AutoCloseable: 1,
  Ljava_io_Flushable: 1
});
$c_Ljava_io_StringWriter.prototype.$classData = $d_Ljava_io_StringWriter;
/** @constructor */
function $c_Ljava_nio_CharBuffer() {
  $c_Ljava_nio_Buffer.call(this);
  this.$$undarray$2 = null;
  this.$$undarrayOffset$2 = 0
}
$c_Ljava_nio_CharBuffer.prototype = new $h_Ljava_nio_Buffer();
$c_Ljava_nio_CharBuffer.prototype.constructor = $c_Ljava_nio_CharBuffer;
/** @constructor */
function $h_Ljava_nio_CharBuffer() {
  /*<skip>*/
}
$h_Ljava_nio_CharBuffer.prototype = $c_Ljava_nio_CharBuffer.prototype;
$c_Ljava_nio_CharBuffer.prototype.put__T__I__I__Ljava_nio_CharBuffer = (function(src, start, end) {
  return this.put__Ljava_nio_CharBuffer__Ljava_nio_CharBuffer($m_Ljava_nio_CharBuffer$().wrap__jl_CharSequence__I__I__Ljava_nio_CharBuffer(src, start, end))
});
$c_Ljava_nio_CharBuffer.prototype.put__Ljava_nio_CharBuffer__Ljava_nio_CharBuffer = (function(src) {
  if ((src === this)) {
    throw new $c_jl_IllegalArgumentException().init___()
  };
  if (this.isReadOnly__Z()) {
    throw new $c_Ljava_nio_ReadOnlyBufferException().init___()
  };
  var srcLimit = src.$$undlimit$1;
  var srcPos = src.java$nio$Buffer$$$undposition$1;
  var length = ((srcLimit - srcPos) | 0);
  var p = this.java$nio$Buffer$$$undposition$1;
  var newPos = ((p + length) | 0);
  if ((newPos > this.$$undlimit$1)) {
    throw new $c_Ljava_nio_BufferOverflowException().init___()
  };
  this.java$nio$Buffer$$$undposition$1 = newPos;
  var selfPos = p;
  $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call(src, srcLimit);
  var srcArray = src.$$undarray$2;
  if ((srcArray !== null)) {
    var startIndex = selfPos;
    var offset = ((src.$$undarrayOffset$2 + srcPos) | 0);
    this.store__I__AC__I__I__V(startIndex, srcArray, offset, length)
  } else {
    while ((srcPos !== srcLimit)) {
      var index$1 = selfPos;
      var index = srcPos;
      var c = src.load__I__C(index);
      this.store__I__C__V(index$1, c);
      srcPos = ((1 + srcPos) | 0);
      selfPos = ((1 + selfPos) | 0)
    }
  };
  return this
});
$c_Ljava_nio_CharBuffer.prototype.equals__O__Z = (function(that) {
  if ((that instanceof $c_Ljava_nio_CharBuffer)) {
    var x2 = $as_Ljava_nio_CharBuffer(that);
    return (this.compareTo__Ljava_nio_CharBuffer__I(x2) === 0)
  } else {
    return false
  }
});
$c_Ljava_nio_CharBuffer.prototype.toString__T = (function() {
  if ((this.$$undarray$2 !== null)) {
    return $m_sjsr_RuntimeString$().newString__AC__I__I__T(this.$$undarray$2, ((this.java$nio$Buffer$$$undposition$1 + this.$$undarrayOffset$2) | 0), ((this.$$undlimit$1 - this.java$nio$Buffer$$$undposition$1) | 0))
  } else {
    var chars = $newArrayObject($d_C.getArrayOf(), [((this.$$undlimit$1 - this.java$nio$Buffer$$$undposition$1) | 0)]);
    var savedPos = this.java$nio$Buffer$$$undposition$1;
    this.get__AC__I__I__Ljava_nio_CharBuffer(chars, 0, chars.u.length);
    $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call(this, savedPos);
    var this$1 = $m_sjsr_RuntimeString$();
    return this$1.newString__AC__I__I__T(chars, 0, chars.u.length)
  }
});
$c_Ljava_nio_CharBuffer.prototype.compareTo__O__I = (function(x$1) {
  return this.compareTo__Ljava_nio_CharBuffer__I($as_Ljava_nio_CharBuffer(x$1))
});
$c_Ljava_nio_CharBuffer.prototype.append__jl_CharSequence__jl_Appendable = (function(x$1) {
  return this.put__T__Ljava_nio_CharBuffer($objectToString(x$1))
});
$c_Ljava_nio_CharBuffer.prototype.put__T__Ljava_nio_CharBuffer = (function(src) {
  return this.put__T__I__I__Ljava_nio_CharBuffer(src, 0, $uI(src.length))
});
$c_Ljava_nio_CharBuffer.prototype.length__I = (function() {
  return ((this.$$undlimit$1 - this.java$nio$Buffer$$$undposition$1) | 0)
});
$c_Ljava_nio_CharBuffer.prototype.compareTo__Ljava_nio_CharBuffer__I = (function(that) {
  if ((this === that)) {
    return 0
  } else {
    var thisStart = this.java$nio$Buffer$$$undposition$1;
    var thisRemaining = ((this.$$undlimit$1 - thisStart) | 0);
    var thatStart = that.java$nio$Buffer$$$undposition$1;
    var thatRemaining = ((that.$$undlimit$1 - thatStart) | 0);
    var shortestLength = ((thisRemaining < thatRemaining) ? thisRemaining : thatRemaining);
    var i = 0;
    while ((i !== shortestLength)) {
      var index = ((thisStart + i) | 0);
      var c = this.load__I__C(index);
      var index$1 = ((thatStart + i) | 0);
      var c$1 = that.load__I__C(index$1);
      var cmp = ((c - c$1) | 0);
      if ((cmp !== 0)) {
        return cmp
      };
      i = ((1 + i) | 0)
    };
    return ((thisRemaining === thatRemaining) ? 0 : ((thisRemaining < thatRemaining) ? (-1) : 1))
  }
});
$c_Ljava_nio_CharBuffer.prototype.init___I__AC__I = (function(_capacity, _array, _arrayOffset) {
  this.$$undarray$2 = _array;
  this.$$undarrayOffset$2 = _arrayOffset;
  $c_Ljava_nio_Buffer.prototype.init___I.call(this, _capacity);
  return this
});
$c_Ljava_nio_CharBuffer.prototype.hashCode__I = (function() {
  var start = this.java$nio$Buffer$$$undposition$1;
  var end = this.$$undlimit$1;
  var h = (-182887236);
  var i = start;
  while ((i !== end)) {
    var jsx$3 = $m_s_util_hashing_MurmurHash3$();
    var jsx$2 = h;
    var jsx$1 = $m_sr_Statics$();
    var index = i;
    var c = this.load__I__C(index);
    h = jsx$3.mix__I__I__I(jsx$2, jsx$1.anyHash__O__I(new $c_jl_Character().init___C(c)));
    i = ((1 + i) | 0)
  };
  return $m_s_util_hashing_MurmurHash3$().finalizeHash__I__I__I(h, ((end - start) | 0))
});
$c_Ljava_nio_CharBuffer.prototype.charAt__I__C = (function(index) {
  return this.get__I__C(((this.java$nio$Buffer$$$undposition$1 + index) | 0))
});
function $as_Ljava_nio_CharBuffer(obj) {
  return (((obj instanceof $c_Ljava_nio_CharBuffer) || (obj === null)) ? obj : $throwClassCastException(obj, "java.nio.CharBuffer"))
}
function $isArrayOf_Ljava_nio_CharBuffer(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Ljava_nio_CharBuffer)))
}
function $asArrayOf_Ljava_nio_CharBuffer(obj, depth) {
  return (($isArrayOf_Ljava_nio_CharBuffer(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.nio.CharBuffer;", depth))
}
/** @constructor */
function $c_Ljava_nio_ReadOnlyBufferException() {
  $c_jl_UnsupportedOperationException.call(this)
}
$c_Ljava_nio_ReadOnlyBufferException.prototype = new $h_jl_UnsupportedOperationException();
$c_Ljava_nio_ReadOnlyBufferException.prototype.constructor = $c_Ljava_nio_ReadOnlyBufferException;
/** @constructor */
function $h_Ljava_nio_ReadOnlyBufferException() {
  /*<skip>*/
}
$h_Ljava_nio_ReadOnlyBufferException.prototype = $c_Ljava_nio_ReadOnlyBufferException.prototype;
$c_Ljava_nio_ReadOnlyBufferException.prototype.init___ = (function() {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
var $d_Ljava_nio_ReadOnlyBufferException = new $TypeData().initClass({
  Ljava_nio_ReadOnlyBufferException: 0
}, false, "java.nio.ReadOnlyBufferException", {
  Ljava_nio_ReadOnlyBufferException: 1,
  jl_UnsupportedOperationException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_Ljava_nio_ReadOnlyBufferException.prototype.$classData = $d_Ljava_nio_ReadOnlyBufferException;
/** @constructor */
function $c_Ljava_nio_charset_MalformedInputException() {
  $c_Ljava_nio_charset_CharacterCodingException.call(this);
  this.inputLength$5 = 0
}
$c_Ljava_nio_charset_MalformedInputException.prototype = new $h_Ljava_nio_charset_CharacterCodingException();
$c_Ljava_nio_charset_MalformedInputException.prototype.constructor = $c_Ljava_nio_charset_MalformedInputException;
/** @constructor */
function $h_Ljava_nio_charset_MalformedInputException() {
  /*<skip>*/
}
$h_Ljava_nio_charset_MalformedInputException.prototype = $c_Ljava_nio_charset_MalformedInputException.prototype;
$c_Ljava_nio_charset_MalformedInputException.prototype.getMessage__T = (function() {
  return ("Input length = " + this.inputLength$5)
});
$c_Ljava_nio_charset_MalformedInputException.prototype.init___I = (function(inputLength) {
  this.inputLength$5 = inputLength;
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
var $d_Ljava_nio_charset_MalformedInputException = new $TypeData().initClass({
  Ljava_nio_charset_MalformedInputException: 0
}, false, "java.nio.charset.MalformedInputException", {
  Ljava_nio_charset_MalformedInputException: 1,
  Ljava_nio_charset_CharacterCodingException: 1,
  Ljava_io_IOException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_Ljava_nio_charset_MalformedInputException.prototype.$classData = $d_Ljava_nio_charset_MalformedInputException;
/** @constructor */
function $c_Ljava_nio_charset_UnmappableCharacterException() {
  $c_Ljava_nio_charset_CharacterCodingException.call(this);
  this.inputLength$5 = 0
}
$c_Ljava_nio_charset_UnmappableCharacterException.prototype = new $h_Ljava_nio_charset_CharacterCodingException();
$c_Ljava_nio_charset_UnmappableCharacterException.prototype.constructor = $c_Ljava_nio_charset_UnmappableCharacterException;
/** @constructor */
function $h_Ljava_nio_charset_UnmappableCharacterException() {
  /*<skip>*/
}
$h_Ljava_nio_charset_UnmappableCharacterException.prototype = $c_Ljava_nio_charset_UnmappableCharacterException.prototype;
$c_Ljava_nio_charset_UnmappableCharacterException.prototype.getMessage__T = (function() {
  return ("Input length = " + this.inputLength$5)
});
$c_Ljava_nio_charset_UnmappableCharacterException.prototype.init___I = (function(inputLength) {
  this.inputLength$5 = inputLength;
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
var $d_Ljava_nio_charset_UnmappableCharacterException = new $TypeData().initClass({
  Ljava_nio_charset_UnmappableCharacterException: 0
}, false, "java.nio.charset.UnmappableCharacterException", {
  Ljava_nio_charset_UnmappableCharacterException: 1,
  Ljava_nio_charset_CharacterCodingException: 1,
  Ljava_io_IOException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_Ljava_nio_charset_UnmappableCharacterException.prototype.$classData = $d_Ljava_nio_charset_UnmappableCharacterException;
/** @constructor */
function $c_Lorg_mulesoft_common_parse_FormatError() {
  $c_O.call(this);
  this.value$1 = null;
  this.msg$1 = null
}
$c_Lorg_mulesoft_common_parse_FormatError.prototype = new $h_O();
$c_Lorg_mulesoft_common_parse_FormatError.prototype.constructor = $c_Lorg_mulesoft_common_parse_FormatError;
/** @constructor */
function $h_Lorg_mulesoft_common_parse_FormatError() {
  /*<skip>*/
}
$h_Lorg_mulesoft_common_parse_FormatError.prototype = $c_Lorg_mulesoft_common_parse_FormatError.prototype;
$c_Lorg_mulesoft_common_parse_FormatError.prototype.init___T__T = (function(value, msg) {
  this.value$1 = value;
  this.msg$1 = msg;
  return this
});
$c_Lorg_mulesoft_common_parse_FormatError.prototype.productPrefix__T = (function() {
  return "FormatError"
});
$c_Lorg_mulesoft_common_parse_FormatError.prototype.productArity__I = (function() {
  return 2
});
$c_Lorg_mulesoft_common_parse_FormatError.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lorg_mulesoft_common_parse_FormatError)) {
    var FormatError$1 = $as_Lorg_mulesoft_common_parse_FormatError(x$1);
    return ((this.value$1 === FormatError$1.value$1) && (this.msg$1 === FormatError$1.msg$1))
  } else {
    return false
  }
});
$c_Lorg_mulesoft_common_parse_FormatError.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    case 1: {
      return this.msg$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lorg_mulesoft_common_parse_FormatError.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lorg_mulesoft_common_parse_FormatError.prototype.message__T = (function() {
  var thiz = this.msg$1;
  if ((thiz === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  if ((thiz === "")) {
    var m = ""
  } else {
    var m = ((" (" + this.msg$1) + ")")
  };
  return (((("Format Error" + m) + " in '") + this.value$1) + "'")
});
$c_Lorg_mulesoft_common_parse_FormatError.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lorg_mulesoft_common_parse_FormatError.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lorg_mulesoft_common_parse_FormatError(obj) {
  return (((obj instanceof $c_Lorg_mulesoft_common_parse_FormatError) || (obj === null)) ? obj : $throwClassCastException(obj, "org.mulesoft.common.parse.FormatError"))
}
function $isArrayOf_Lorg_mulesoft_common_parse_FormatError(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_mulesoft_common_parse_FormatError)))
}
function $asArrayOf_Lorg_mulesoft_common_parse_FormatError(obj, depth) {
  return (($isArrayOf_Lorg_mulesoft_common_parse_FormatError(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.mulesoft.common.parse.FormatError;", depth))
}
var $d_Lorg_mulesoft_common_parse_FormatError = new $TypeData().initClass({
  Lorg_mulesoft_common_parse_FormatError: 0
}, false, "org.mulesoft.common.parse.FormatError", {
  Lorg_mulesoft_common_parse_FormatError: 1,
  O: 1,
  Lorg_mulesoft_common_parse_ParseError: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_mulesoft_common_parse_FormatError.prototype.$classData = $d_Lorg_mulesoft_common_parse_FormatError;
/** @constructor */
function $c_Lorg_mulesoft_common_parse_RangeError() {
  $c_O.call(this);
  this.value$1 = 0
}
$c_Lorg_mulesoft_common_parse_RangeError.prototype = new $h_O();
$c_Lorg_mulesoft_common_parse_RangeError.prototype.constructor = $c_Lorg_mulesoft_common_parse_RangeError;
/** @constructor */
function $h_Lorg_mulesoft_common_parse_RangeError() {
  /*<skip>*/
}
$h_Lorg_mulesoft_common_parse_RangeError.prototype = $c_Lorg_mulesoft_common_parse_RangeError.prototype;
$c_Lorg_mulesoft_common_parse_RangeError.prototype.productPrefix__T = (function() {
  return "RangeError"
});
$c_Lorg_mulesoft_common_parse_RangeError.prototype.productArity__I = (function() {
  return 1
});
$c_Lorg_mulesoft_common_parse_RangeError.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lorg_mulesoft_common_parse_RangeError)) {
    var RangeError$1 = $as_Lorg_mulesoft_common_parse_RangeError(x$1);
    return (this.value$1 === RangeError$1.value$1)
  } else {
    return false
  }
});
$c_Lorg_mulesoft_common_parse_RangeError.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lorg_mulesoft_common_parse_RangeError.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lorg_mulesoft_common_parse_RangeError.prototype.init___I = (function(value) {
  this.value$1 = value;
  return this
});
$c_Lorg_mulesoft_common_parse_RangeError.prototype.message__T = (function() {
  return (("Value '" + this.value$1) + "' out of range")
});
$c_Lorg_mulesoft_common_parse_RangeError.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.value$1);
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 1)
});
$c_Lorg_mulesoft_common_parse_RangeError.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lorg_mulesoft_common_parse_RangeError(obj) {
  return (((obj instanceof $c_Lorg_mulesoft_common_parse_RangeError) || (obj === null)) ? obj : $throwClassCastException(obj, "org.mulesoft.common.parse.RangeError"))
}
function $isArrayOf_Lorg_mulesoft_common_parse_RangeError(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_mulesoft_common_parse_RangeError)))
}
function $asArrayOf_Lorg_mulesoft_common_parse_RangeError(obj, depth) {
  return (($isArrayOf_Lorg_mulesoft_common_parse_RangeError(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.mulesoft.common.parse.RangeError;", depth))
}
var $d_Lorg_mulesoft_common_parse_RangeError = new $TypeData().initClass({
  Lorg_mulesoft_common_parse_RangeError: 0
}, false, "org.mulesoft.common.parse.RangeError", {
  Lorg_mulesoft_common_parse_RangeError: 1,
  O: 1,
  Lorg_mulesoft_common_parse_ParseError: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_mulesoft_common_parse_RangeError.prototype.$classData = $d_Lorg_mulesoft_common_parse_RangeError;
/** @constructor */
function $c_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState() {
  $c_O.call(this);
  this.column$1 = 0;
  this.line$1 = 0;
  this.offset$1 = 0;
  this.nextOffset$1 = 0;
  this.current$1 = 0
}
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState.prototype = new $h_O();
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState.prototype.constructor = $c_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState;
/** @constructor */
function $h_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState() {
  /*<skip>*/
}
$h_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState.prototype = $c_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState.prototype;
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState.prototype.productPrefix__T = (function() {
  return "InputState"
});
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState.prototype.productArity__I = (function() {
  return 5
});
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState.prototype.init__jl_CharSequence__I__Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState = (function(data, endOffset) {
  if ((endOffset !== 0)) {
    this.column$1 = (-1);
    this.offset$1 = (-1);
    this.consume__jl_CharSequence__I__V(data, endOffset)
  };
  return this
});
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState)) {
    var InputState$1 = $as_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState(x$1);
    return (((((this.column$1 === InputState$1.column$1) && (this.line$1 === InputState$1.line$1)) && (this.offset$1 === InputState$1.offset$1)) && (this.nextOffset$1 === InputState$1.nextOffset$1)) && (this.current$1 === InputState$1.current$1))
  } else {
    return false
  }
});
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState.prototype.consume__jl_CharSequence__I__V = (function(data, endOffset) {
  if ((this.current$1 === 10)) {
    this.column$1 = 0;
    this.line$1 = ((1 + this.line$1) | 0)
  } else {
    this.column$1 = ((this.column$1 + ((this.nextOffset$1 - this.offset$1) | 0)) | 0)
  };
  this.offset$1 = this.nextOffset$1;
  if ((this.offset$1 >= endOffset)) {
    this.current$1 = $m_Lorg_mulesoft_lexer_LexerInput$().EofChar$1;
    return (void 0)
  };
  var chr = $charSequenceCharAt(data, this.offset$1);
  this.nextOffset$1 = ((1 + this.nextOffset$1) | 0);
  if ((((64512 & chr) === 55296) && (this.nextOffset$1 < endOffset))) {
    var c2 = $charSequenceCharAt(data, this.nextOffset$1);
    if (((64512 & c2) === 56320)) {
      this.nextOffset$1 = ((1 + this.nextOffset$1) | 0);
      this.current$1 = ((65536 + ((((1023 & chr) << 10) + (1023 & c2)) | 0)) | 0);
      return (void 0)
    }
  };
  this.current$1 = chr
});
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.column$1;
      break
    }
    case 1: {
      return this.line$1;
      break
    }
    case 2: {
      return this.offset$1;
      break
    }
    case 3: {
      return this.nextOffset$1;
      break
    }
    case 4: {
      return this.current$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState.prototype.nonEof__Z = (function() {
  return (this.current$1 !== $m_Lorg_mulesoft_lexer_LexerInput$().EofChar$1)
});
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState.prototype.init___I__I__I__I__I = (function(column, line, offset, nextOffset, current) {
  this.column$1 = column;
  this.line$1 = line;
  this.offset$1 = offset;
  this.nextOffset$1 = nextOffset;
  this.current$1 = current;
  return this
});
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.column$1);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.line$1);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.offset$1);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.nextOffset$1);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.current$1);
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 5)
});
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState(obj) {
  return (((obj instanceof $c_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState) || (obj === null)) ? obj : $throwClassCastException(obj, "org.mulesoft.lexer.CharSequenceLexerInput$InputState"))
}
function $isArrayOf_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState)))
}
function $asArrayOf_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState(obj, depth) {
  return (($isArrayOf_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.mulesoft.lexer.CharSequenceLexerInput$InputState;", depth))
}
var $d_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState = new $TypeData().initClass({
  Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState: 0
}, false, "org.mulesoft.lexer.CharSequenceLexerInput$InputState", {
  Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState: 1,
  O: 1,
  Lorg_mulesoft_lexer_LexerInput$Mark: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState.prototype.$classData = $d_Lorg_mulesoft_lexer_CharSequenceLexerInput$InputState;
/** @constructor */
function $c_Lorg_yaml_builder_DocBuilder$SType$Bool$() {
  $c_O.call(this)
}
$c_Lorg_yaml_builder_DocBuilder$SType$Bool$.prototype = new $h_O();
$c_Lorg_yaml_builder_DocBuilder$SType$Bool$.prototype.constructor = $c_Lorg_yaml_builder_DocBuilder$SType$Bool$;
/** @constructor */
function $h_Lorg_yaml_builder_DocBuilder$SType$Bool$() {
  /*<skip>*/
}
$h_Lorg_yaml_builder_DocBuilder$SType$Bool$.prototype = $c_Lorg_yaml_builder_DocBuilder$SType$Bool$.prototype;
$c_Lorg_yaml_builder_DocBuilder$SType$Bool$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_builder_DocBuilder$SType$Bool$.prototype.productPrefix__T = (function() {
  return "Bool"
});
$c_Lorg_yaml_builder_DocBuilder$SType$Bool$.prototype.productArity__I = (function() {
  return 0
});
$c_Lorg_yaml_builder_DocBuilder$SType$Bool$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lorg_yaml_builder_DocBuilder$SType$Bool$.prototype.toString__T = (function() {
  return "Bool"
});
$c_Lorg_yaml_builder_DocBuilder$SType$Bool$.prototype.hashCode__I = (function() {
  return 2076426
});
$c_Lorg_yaml_builder_DocBuilder$SType$Bool$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lorg_yaml_builder_DocBuilder$SType$Bool$ = new $TypeData().initClass({
  Lorg_yaml_builder_DocBuilder$SType$Bool$: 0
}, false, "org.yaml.builder.DocBuilder$SType$Bool$", {
  Lorg_yaml_builder_DocBuilder$SType$Bool$: 1,
  O: 1,
  Lorg_yaml_builder_DocBuilder$SType: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_builder_DocBuilder$SType$Bool$.prototype.$classData = $d_Lorg_yaml_builder_DocBuilder$SType$Bool$;
var $n_Lorg_yaml_builder_DocBuilder$SType$Bool$ = (void 0);
function $m_Lorg_yaml_builder_DocBuilder$SType$Bool$() {
  if ((!$n_Lorg_yaml_builder_DocBuilder$SType$Bool$)) {
    $n_Lorg_yaml_builder_DocBuilder$SType$Bool$ = new $c_Lorg_yaml_builder_DocBuilder$SType$Bool$().init___()
  };
  return $n_Lorg_yaml_builder_DocBuilder$SType$Bool$
}
/** @constructor */
function $c_Lorg_yaml_builder_DocBuilder$SType$Float$() {
  $c_O.call(this)
}
$c_Lorg_yaml_builder_DocBuilder$SType$Float$.prototype = new $h_O();
$c_Lorg_yaml_builder_DocBuilder$SType$Float$.prototype.constructor = $c_Lorg_yaml_builder_DocBuilder$SType$Float$;
/** @constructor */
function $h_Lorg_yaml_builder_DocBuilder$SType$Float$() {
  /*<skip>*/
}
$h_Lorg_yaml_builder_DocBuilder$SType$Float$.prototype = $c_Lorg_yaml_builder_DocBuilder$SType$Float$.prototype;
$c_Lorg_yaml_builder_DocBuilder$SType$Float$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_builder_DocBuilder$SType$Float$.prototype.productPrefix__T = (function() {
  return "Float"
});
$c_Lorg_yaml_builder_DocBuilder$SType$Float$.prototype.productArity__I = (function() {
  return 0
});
$c_Lorg_yaml_builder_DocBuilder$SType$Float$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lorg_yaml_builder_DocBuilder$SType$Float$.prototype.toString__T = (function() {
  return "Float"
});
$c_Lorg_yaml_builder_DocBuilder$SType$Float$.prototype.hashCode__I = (function() {
  return 67973692
});
$c_Lorg_yaml_builder_DocBuilder$SType$Float$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lorg_yaml_builder_DocBuilder$SType$Float$ = new $TypeData().initClass({
  Lorg_yaml_builder_DocBuilder$SType$Float$: 0
}, false, "org.yaml.builder.DocBuilder$SType$Float$", {
  Lorg_yaml_builder_DocBuilder$SType$Float$: 1,
  O: 1,
  Lorg_yaml_builder_DocBuilder$SType: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_builder_DocBuilder$SType$Float$.prototype.$classData = $d_Lorg_yaml_builder_DocBuilder$SType$Float$;
var $n_Lorg_yaml_builder_DocBuilder$SType$Float$ = (void 0);
function $m_Lorg_yaml_builder_DocBuilder$SType$Float$() {
  if ((!$n_Lorg_yaml_builder_DocBuilder$SType$Float$)) {
    $n_Lorg_yaml_builder_DocBuilder$SType$Float$ = new $c_Lorg_yaml_builder_DocBuilder$SType$Float$().init___()
  };
  return $n_Lorg_yaml_builder_DocBuilder$SType$Float$
}
/** @constructor */
function $c_Lorg_yaml_builder_DocBuilder$SType$Int$() {
  $c_O.call(this)
}
$c_Lorg_yaml_builder_DocBuilder$SType$Int$.prototype = new $h_O();
$c_Lorg_yaml_builder_DocBuilder$SType$Int$.prototype.constructor = $c_Lorg_yaml_builder_DocBuilder$SType$Int$;
/** @constructor */
function $h_Lorg_yaml_builder_DocBuilder$SType$Int$() {
  /*<skip>*/
}
$h_Lorg_yaml_builder_DocBuilder$SType$Int$.prototype = $c_Lorg_yaml_builder_DocBuilder$SType$Int$.prototype;
$c_Lorg_yaml_builder_DocBuilder$SType$Int$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_builder_DocBuilder$SType$Int$.prototype.productPrefix__T = (function() {
  return "Int"
});
$c_Lorg_yaml_builder_DocBuilder$SType$Int$.prototype.productArity__I = (function() {
  return 0
});
$c_Lorg_yaml_builder_DocBuilder$SType$Int$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lorg_yaml_builder_DocBuilder$SType$Int$.prototype.toString__T = (function() {
  return "Int"
});
$c_Lorg_yaml_builder_DocBuilder$SType$Int$.prototype.hashCode__I = (function() {
  return 73679
});
$c_Lorg_yaml_builder_DocBuilder$SType$Int$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lorg_yaml_builder_DocBuilder$SType$Int$ = new $TypeData().initClass({
  Lorg_yaml_builder_DocBuilder$SType$Int$: 0
}, false, "org.yaml.builder.DocBuilder$SType$Int$", {
  Lorg_yaml_builder_DocBuilder$SType$Int$: 1,
  O: 1,
  Lorg_yaml_builder_DocBuilder$SType: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_builder_DocBuilder$SType$Int$.prototype.$classData = $d_Lorg_yaml_builder_DocBuilder$SType$Int$;
var $n_Lorg_yaml_builder_DocBuilder$SType$Int$ = (void 0);
function $m_Lorg_yaml_builder_DocBuilder$SType$Int$() {
  if ((!$n_Lorg_yaml_builder_DocBuilder$SType$Int$)) {
    $n_Lorg_yaml_builder_DocBuilder$SType$Int$ = new $c_Lorg_yaml_builder_DocBuilder$SType$Int$().init___()
  };
  return $n_Lorg_yaml_builder_DocBuilder$SType$Int$
}
/** @constructor */
function $c_Lorg_yaml_builder_DocBuilder$SType$Str$() {
  $c_O.call(this)
}
$c_Lorg_yaml_builder_DocBuilder$SType$Str$.prototype = new $h_O();
$c_Lorg_yaml_builder_DocBuilder$SType$Str$.prototype.constructor = $c_Lorg_yaml_builder_DocBuilder$SType$Str$;
/** @constructor */
function $h_Lorg_yaml_builder_DocBuilder$SType$Str$() {
  /*<skip>*/
}
$h_Lorg_yaml_builder_DocBuilder$SType$Str$.prototype = $c_Lorg_yaml_builder_DocBuilder$SType$Str$.prototype;
$c_Lorg_yaml_builder_DocBuilder$SType$Str$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_builder_DocBuilder$SType$Str$.prototype.productPrefix__T = (function() {
  return "Str"
});
$c_Lorg_yaml_builder_DocBuilder$SType$Str$.prototype.productArity__I = (function() {
  return 0
});
$c_Lorg_yaml_builder_DocBuilder$SType$Str$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lorg_yaml_builder_DocBuilder$SType$Str$.prototype.toString__T = (function() {
  return "Str"
});
$c_Lorg_yaml_builder_DocBuilder$SType$Str$.prototype.hashCode__I = (function() {
  return 83473
});
$c_Lorg_yaml_builder_DocBuilder$SType$Str$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lorg_yaml_builder_DocBuilder$SType$Str$ = new $TypeData().initClass({
  Lorg_yaml_builder_DocBuilder$SType$Str$: 0
}, false, "org.yaml.builder.DocBuilder$SType$Str$", {
  Lorg_yaml_builder_DocBuilder$SType$Str$: 1,
  O: 1,
  Lorg_yaml_builder_DocBuilder$SType: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_builder_DocBuilder$SType$Str$.prototype.$classData = $d_Lorg_yaml_builder_DocBuilder$SType$Str$;
var $n_Lorg_yaml_builder_DocBuilder$SType$Str$ = (void 0);
function $m_Lorg_yaml_builder_DocBuilder$SType$Str$() {
  if ((!$n_Lorg_yaml_builder_DocBuilder$SType$Str$)) {
    $n_Lorg_yaml_builder_DocBuilder$SType$Str$ = new $c_Lorg_yaml_builder_DocBuilder$SType$Str$().init___()
  };
  return $n_Lorg_yaml_builder_DocBuilder$SType$Str$
}
/** @constructor */
function $c_Lorg_yaml_lexer_BlockIn$() {
  $c_Lorg_yaml_lexer_YamlContext.call(this)
}
$c_Lorg_yaml_lexer_BlockIn$.prototype = new $h_Lorg_yaml_lexer_YamlContext();
$c_Lorg_yaml_lexer_BlockIn$.prototype.constructor = $c_Lorg_yaml_lexer_BlockIn$;
/** @constructor */
function $h_Lorg_yaml_lexer_BlockIn$() {
  /*<skip>*/
}
$h_Lorg_yaml_lexer_BlockIn$.prototype = $c_Lorg_yaml_lexer_BlockIn$.prototype;
$c_Lorg_yaml_lexer_BlockIn$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_lexer_BlockIn$.prototype.productPrefix__T = (function() {
  return "BlockIn"
});
$c_Lorg_yaml_lexer_BlockIn$.prototype.productArity__I = (function() {
  return 0
});
$c_Lorg_yaml_lexer_BlockIn$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lorg_yaml_lexer_BlockIn$.prototype.toString__T = (function() {
  return "BlockIn"
});
$c_Lorg_yaml_lexer_BlockIn$.prototype.hashCode__I = (function() {
  return 1643214450
});
$c_Lorg_yaml_lexer_BlockIn$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lorg_yaml_lexer_BlockIn$ = new $TypeData().initClass({
  Lorg_yaml_lexer_BlockIn$: 0
}, false, "org.yaml.lexer.BlockIn$", {
  Lorg_yaml_lexer_BlockIn$: 1,
  Lorg_yaml_lexer_YamlContext: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_lexer_BlockIn$.prototype.$classData = $d_Lorg_yaml_lexer_BlockIn$;
var $n_Lorg_yaml_lexer_BlockIn$ = (void 0);
function $m_Lorg_yaml_lexer_BlockIn$() {
  if ((!$n_Lorg_yaml_lexer_BlockIn$)) {
    $n_Lorg_yaml_lexer_BlockIn$ = new $c_Lorg_yaml_lexer_BlockIn$().init___()
  };
  return $n_Lorg_yaml_lexer_BlockIn$
}
/** @constructor */
function $c_Lorg_yaml_lexer_BlockKey$() {
  $c_Lorg_yaml_lexer_YamlContext.call(this)
}
$c_Lorg_yaml_lexer_BlockKey$.prototype = new $h_Lorg_yaml_lexer_YamlContext();
$c_Lorg_yaml_lexer_BlockKey$.prototype.constructor = $c_Lorg_yaml_lexer_BlockKey$;
/** @constructor */
function $h_Lorg_yaml_lexer_BlockKey$() {
  /*<skip>*/
}
$h_Lorg_yaml_lexer_BlockKey$.prototype = $c_Lorg_yaml_lexer_BlockKey$.prototype;
$c_Lorg_yaml_lexer_BlockKey$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_lexer_BlockKey$.prototype.productPrefix__T = (function() {
  return "BlockKey"
});
$c_Lorg_yaml_lexer_BlockKey$.prototype.productArity__I = (function() {
  return 0
});
$c_Lorg_yaml_lexer_BlockKey$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lorg_yaml_lexer_BlockKey$.prototype.toString__T = (function() {
  return "BlockKey"
});
$c_Lorg_yaml_lexer_BlockKey$.prototype.hashCode__I = (function() {
  return (-599957838)
});
$c_Lorg_yaml_lexer_BlockKey$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lorg_yaml_lexer_BlockKey$ = new $TypeData().initClass({
  Lorg_yaml_lexer_BlockKey$: 0
}, false, "org.yaml.lexer.BlockKey$", {
  Lorg_yaml_lexer_BlockKey$: 1,
  Lorg_yaml_lexer_YamlContext: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_lexer_BlockKey$.prototype.$classData = $d_Lorg_yaml_lexer_BlockKey$;
var $n_Lorg_yaml_lexer_BlockKey$ = (void 0);
function $m_Lorg_yaml_lexer_BlockKey$() {
  if ((!$n_Lorg_yaml_lexer_BlockKey$)) {
    $n_Lorg_yaml_lexer_BlockKey$ = new $c_Lorg_yaml_lexer_BlockKey$().init___()
  };
  return $n_Lorg_yaml_lexer_BlockKey$
}
/** @constructor */
function $c_Lorg_yaml_lexer_BlockOut$() {
  $c_Lorg_yaml_lexer_YamlContext.call(this)
}
$c_Lorg_yaml_lexer_BlockOut$.prototype = new $h_Lorg_yaml_lexer_YamlContext();
$c_Lorg_yaml_lexer_BlockOut$.prototype.constructor = $c_Lorg_yaml_lexer_BlockOut$;
/** @constructor */
function $h_Lorg_yaml_lexer_BlockOut$() {
  /*<skip>*/
}
$h_Lorg_yaml_lexer_BlockOut$.prototype = $c_Lorg_yaml_lexer_BlockOut$.prototype;
$c_Lorg_yaml_lexer_BlockOut$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_lexer_BlockOut$.prototype.productPrefix__T = (function() {
  return "BlockOut"
});
$c_Lorg_yaml_lexer_BlockOut$.prototype.productArity__I = (function() {
  return 0
});
$c_Lorg_yaml_lexer_BlockOut$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lorg_yaml_lexer_BlockOut$.prototype.toString__T = (function() {
  return "BlockOut"
});
$c_Lorg_yaml_lexer_BlockOut$.prototype.hashCode__I = (function() {
  return (-599953503)
});
$c_Lorg_yaml_lexer_BlockOut$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lorg_yaml_lexer_BlockOut$ = new $TypeData().initClass({
  Lorg_yaml_lexer_BlockOut$: 0
}, false, "org.yaml.lexer.BlockOut$", {
  Lorg_yaml_lexer_BlockOut$: 1,
  Lorg_yaml_lexer_YamlContext: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_lexer_BlockOut$.prototype.$classData = $d_Lorg_yaml_lexer_BlockOut$;
var $n_Lorg_yaml_lexer_BlockOut$ = (void 0);
function $m_Lorg_yaml_lexer_BlockOut$() {
  if ((!$n_Lorg_yaml_lexer_BlockOut$)) {
    $n_Lorg_yaml_lexer_BlockOut$ = new $c_Lorg_yaml_lexer_BlockOut$().init___()
  };
  return $n_Lorg_yaml_lexer_BlockOut$
}
/** @constructor */
function $c_Lorg_yaml_lexer_FlowIn$() {
  $c_Lorg_yaml_lexer_YamlContext.call(this)
}
$c_Lorg_yaml_lexer_FlowIn$.prototype = new $h_Lorg_yaml_lexer_YamlContext();
$c_Lorg_yaml_lexer_FlowIn$.prototype.constructor = $c_Lorg_yaml_lexer_FlowIn$;
/** @constructor */
function $h_Lorg_yaml_lexer_FlowIn$() {
  /*<skip>*/
}
$h_Lorg_yaml_lexer_FlowIn$.prototype = $c_Lorg_yaml_lexer_FlowIn$.prototype;
$c_Lorg_yaml_lexer_FlowIn$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_lexer_FlowIn$.prototype.productPrefix__T = (function() {
  return "FlowIn"
});
$c_Lorg_yaml_lexer_FlowIn$.prototype.productArity__I = (function() {
  return 0
});
$c_Lorg_yaml_lexer_FlowIn$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lorg_yaml_lexer_FlowIn$.prototype.toString__T = (function() {
  return "FlowIn"
});
$c_Lorg_yaml_lexer_FlowIn$.prototype.hashCode__I = (function() {
  return 2107204371
});
$c_Lorg_yaml_lexer_FlowIn$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lorg_yaml_lexer_FlowIn$ = new $TypeData().initClass({
  Lorg_yaml_lexer_FlowIn$: 0
}, false, "org.yaml.lexer.FlowIn$", {
  Lorg_yaml_lexer_FlowIn$: 1,
  Lorg_yaml_lexer_YamlContext: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_lexer_FlowIn$.prototype.$classData = $d_Lorg_yaml_lexer_FlowIn$;
var $n_Lorg_yaml_lexer_FlowIn$ = (void 0);
function $m_Lorg_yaml_lexer_FlowIn$() {
  if ((!$n_Lorg_yaml_lexer_FlowIn$)) {
    $n_Lorg_yaml_lexer_FlowIn$ = new $c_Lorg_yaml_lexer_FlowIn$().init___()
  };
  return $n_Lorg_yaml_lexer_FlowIn$
}
/** @constructor */
function $c_Lorg_yaml_lexer_FlowKey$() {
  $c_Lorg_yaml_lexer_YamlContext.call(this)
}
$c_Lorg_yaml_lexer_FlowKey$.prototype = new $h_Lorg_yaml_lexer_YamlContext();
$c_Lorg_yaml_lexer_FlowKey$.prototype.constructor = $c_Lorg_yaml_lexer_FlowKey$;
/** @constructor */
function $h_Lorg_yaml_lexer_FlowKey$() {
  /*<skip>*/
}
$h_Lorg_yaml_lexer_FlowKey$.prototype = $c_Lorg_yaml_lexer_FlowKey$.prototype;
$c_Lorg_yaml_lexer_FlowKey$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_lexer_FlowKey$.prototype.productPrefix__T = (function() {
  return "FlowKey"
});
$c_Lorg_yaml_lexer_FlowKey$.prototype.productArity__I = (function() {
  return 0
});
$c_Lorg_yaml_lexer_FlowKey$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lorg_yaml_lexer_FlowKey$.prototype.toString__T = (function() {
  return "FlowKey"
});
$c_Lorg_yaml_lexer_FlowKey$.prototype.hashCode__I = (function() {
  return 898827825
});
$c_Lorg_yaml_lexer_FlowKey$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lorg_yaml_lexer_FlowKey$ = new $TypeData().initClass({
  Lorg_yaml_lexer_FlowKey$: 0
}, false, "org.yaml.lexer.FlowKey$", {
  Lorg_yaml_lexer_FlowKey$: 1,
  Lorg_yaml_lexer_YamlContext: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_lexer_FlowKey$.prototype.$classData = $d_Lorg_yaml_lexer_FlowKey$;
var $n_Lorg_yaml_lexer_FlowKey$ = (void 0);
function $m_Lorg_yaml_lexer_FlowKey$() {
  if ((!$n_Lorg_yaml_lexer_FlowKey$)) {
    $n_Lorg_yaml_lexer_FlowKey$ = new $c_Lorg_yaml_lexer_FlowKey$().init___()
  };
  return $n_Lorg_yaml_lexer_FlowKey$
}
/** @constructor */
function $c_Lorg_yaml_lexer_FlowOut$() {
  $c_Lorg_yaml_lexer_YamlContext.call(this)
}
$c_Lorg_yaml_lexer_FlowOut$.prototype = new $h_Lorg_yaml_lexer_YamlContext();
$c_Lorg_yaml_lexer_FlowOut$.prototype.constructor = $c_Lorg_yaml_lexer_FlowOut$;
/** @constructor */
function $h_Lorg_yaml_lexer_FlowOut$() {
  /*<skip>*/
}
$h_Lorg_yaml_lexer_FlowOut$.prototype = $c_Lorg_yaml_lexer_FlowOut$.prototype;
$c_Lorg_yaml_lexer_FlowOut$.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_lexer_FlowOut$.prototype.productPrefix__T = (function() {
  return "FlowOut"
});
$c_Lorg_yaml_lexer_FlowOut$.prototype.productArity__I = (function() {
  return 0
});
$c_Lorg_yaml_lexer_FlowOut$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lorg_yaml_lexer_FlowOut$.prototype.toString__T = (function() {
  return "FlowOut"
});
$c_Lorg_yaml_lexer_FlowOut$.prototype.hashCode__I = (function() {
  return 898832160
});
$c_Lorg_yaml_lexer_FlowOut$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lorg_yaml_lexer_FlowOut$ = new $TypeData().initClass({
  Lorg_yaml_lexer_FlowOut$: 0
}, false, "org.yaml.lexer.FlowOut$", {
  Lorg_yaml_lexer_FlowOut$: 1,
  Lorg_yaml_lexer_YamlContext: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_lexer_FlowOut$.prototype.$classData = $d_Lorg_yaml_lexer_FlowOut$;
var $n_Lorg_yaml_lexer_FlowOut$ = (void 0);
function $m_Lorg_yaml_lexer_FlowOut$() {
  if ((!$n_Lorg_yaml_lexer_FlowOut$)) {
    $n_Lorg_yaml_lexer_FlowOut$ = new $c_Lorg_yaml_lexer_FlowOut$().init___()
  };
  return $n_Lorg_yaml_lexer_FlowOut$
}
/** @constructor */
function $c_Lorg_yaml_model_YDocument$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lorg_yaml_model_YDocument$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lorg_yaml_model_YDocument$$anonfun$1.prototype.constructor = $c_Lorg_yaml_model_YDocument$$anonfun$1;
/** @constructor */
function $h_Lorg_yaml_model_YDocument$$anonfun$1() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YDocument$$anonfun$1.prototype = $c_Lorg_yaml_model_YDocument$$anonfun$1.prototype;
$c_Lorg_yaml_model_YDocument$$anonfun$1.prototype.isDefinedAt__Lorg_yaml_model_YPart__Z = (function(x1) {
  return (x1 instanceof $c_Lorg_yaml_model_YNode)
});
$c_Lorg_yaml_model_YDocument$$anonfun$1.prototype.applyOrElse__Lorg_yaml_model_YPart__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lorg_yaml_model_YNode)) {
    var x2 = $as_Lorg_yaml_model_YNode(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lorg_yaml_model_YDocument$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lorg_yaml_model_YPart__Z($as_Lorg_yaml_model_YPart(x))
});
$c_Lorg_yaml_model_YDocument$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lorg_yaml_model_YPart__F1__O($as_Lorg_yaml_model_YPart(x), $default)
});
$c_Lorg_yaml_model_YDocument$$anonfun$1.prototype.init___Lorg_yaml_model_YDocument = (function($$outer) {
  return this
});
var $d_Lorg_yaml_model_YDocument$$anonfun$1 = new $TypeData().initClass({
  Lorg_yaml_model_YDocument$$anonfun$1: 0
}, false, "org.yaml.model.YDocument$$anonfun$1", {
  Lorg_yaml_model_YDocument$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_model_YDocument$$anonfun$1.prototype.$classData = $d_Lorg_yaml_model_YDocument$$anonfun$1;
/** @constructor */
function $c_Lorg_yaml_model_YDocument$$anonfun$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lorg_yaml_model_YDocument$$anonfun$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lorg_yaml_model_YDocument$$anonfun$2.prototype.constructor = $c_Lorg_yaml_model_YDocument$$anonfun$2;
/** @constructor */
function $h_Lorg_yaml_model_YDocument$$anonfun$2() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YDocument$$anonfun$2.prototype = $c_Lorg_yaml_model_YDocument$$anonfun$2.prototype;
$c_Lorg_yaml_model_YDocument$$anonfun$2.prototype.isDefinedAt__Lorg_yaml_model_YPart__Z = (function(x2) {
  return (x2 instanceof $c_Lorg_yaml_model_YComment)
});
$c_Lorg_yaml_model_YDocument$$anonfun$2.prototype.applyOrElse__Lorg_yaml_model_YPart__F1__O = (function(x2, $default) {
  if ((x2 instanceof $c_Lorg_yaml_model_YComment)) {
    var x2$2 = $as_Lorg_yaml_model_YComment(x2);
    return x2$2.metaText$4
  } else {
    return $default.apply__O__O(x2)
  }
});
$c_Lorg_yaml_model_YDocument$$anonfun$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lorg_yaml_model_YPart__Z($as_Lorg_yaml_model_YPart(x))
});
$c_Lorg_yaml_model_YDocument$$anonfun$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lorg_yaml_model_YPart__F1__O($as_Lorg_yaml_model_YPart(x), $default)
});
$c_Lorg_yaml_model_YDocument$$anonfun$2.prototype.init___Lorg_yaml_model_YDocument = (function($$outer) {
  return this
});
var $d_Lorg_yaml_model_YDocument$$anonfun$2 = new $TypeData().initClass({
  Lorg_yaml_model_YDocument$$anonfun$2: 0
}, false, "org.yaml.model.YDocument$$anonfun$2", {
  Lorg_yaml_model_YDocument$$anonfun$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_model_YDocument$$anonfun$2.prototype.$classData = $d_Lorg_yaml_model_YDocument$$anonfun$2;
/** @constructor */
function $c_Lorg_yaml_model_YMap$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lorg_yaml_model_YMap$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lorg_yaml_model_YMap$$anonfun$1.prototype.constructor = $c_Lorg_yaml_model_YMap$$anonfun$1;
/** @constructor */
function $h_Lorg_yaml_model_YMap$$anonfun$1() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YMap$$anonfun$1.prototype = $c_Lorg_yaml_model_YMap$$anonfun$1.prototype;
$c_Lorg_yaml_model_YMap$$anonfun$1.prototype.isDefinedAt__Lorg_yaml_model_YPart__Z = (function(x1) {
  return (x1 instanceof $c_Lorg_yaml_model_YMapEntry)
});
$c_Lorg_yaml_model_YMap$$anonfun$1.prototype.applyOrElse__Lorg_yaml_model_YPart__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lorg_yaml_model_YMapEntry)) {
    var x2 = $as_Lorg_yaml_model_YMapEntry(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lorg_yaml_model_YMap$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lorg_yaml_model_YPart__Z($as_Lorg_yaml_model_YPart(x))
});
$c_Lorg_yaml_model_YMap$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lorg_yaml_model_YPart__F1__O($as_Lorg_yaml_model_YPart(x), $default)
});
$c_Lorg_yaml_model_YMap$$anonfun$1.prototype.init___Lorg_yaml_model_YMap = (function($$outer) {
  return this
});
var $d_Lorg_yaml_model_YMap$$anonfun$1 = new $TypeData().initClass({
  Lorg_yaml_model_YMap$$anonfun$1: 0
}, false, "org.yaml.model.YMap$$anonfun$1", {
  Lorg_yaml_model_YMap$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_model_YMap$$anonfun$1.prototype.$classData = $d_Lorg_yaml_model_YMap$$anonfun$1;
/** @constructor */
function $c_Lorg_yaml_model_YMapEntry$$anonfun$2() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lorg_yaml_model_YMapEntry$$anonfun$2.prototype = new $h_sr_AbstractPartialFunction();
$c_Lorg_yaml_model_YMapEntry$$anonfun$2.prototype.constructor = $c_Lorg_yaml_model_YMapEntry$$anonfun$2;
/** @constructor */
function $h_Lorg_yaml_model_YMapEntry$$anonfun$2() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YMapEntry$$anonfun$2.prototype = $c_Lorg_yaml_model_YMapEntry$$anonfun$2.prototype;
$c_Lorg_yaml_model_YMapEntry$$anonfun$2.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_model_YMapEntry$$anonfun$2.prototype.isDefinedAt__Lorg_yaml_model_YPart__Z = (function(x1) {
  return (x1 instanceof $c_Lorg_yaml_model_YNode)
});
$c_Lorg_yaml_model_YMapEntry$$anonfun$2.prototype.applyOrElse__Lorg_yaml_model_YPart__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lorg_yaml_model_YNode)) {
    var x2 = $as_Lorg_yaml_model_YNode(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lorg_yaml_model_YMapEntry$$anonfun$2.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lorg_yaml_model_YPart__Z($as_Lorg_yaml_model_YPart(x))
});
$c_Lorg_yaml_model_YMapEntry$$anonfun$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lorg_yaml_model_YPart__F1__O($as_Lorg_yaml_model_YPart(x), $default)
});
var $d_Lorg_yaml_model_YMapEntry$$anonfun$2 = new $TypeData().initClass({
  Lorg_yaml_model_YMapEntry$$anonfun$2: 0
}, false, "org.yaml.model.YMapEntry$$anonfun$2", {
  Lorg_yaml_model_YMapEntry$$anonfun$2: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_model_YMapEntry$$anonfun$2.prototype.$classData = $d_Lorg_yaml_model_YMapEntry$$anonfun$2;
/** @constructor */
function $c_Lorg_yaml_model_YMapEntry$$anonfun$3() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lorg_yaml_model_YMapEntry$$anonfun$3.prototype = new $h_sr_AbstractPartialFunction();
$c_Lorg_yaml_model_YMapEntry$$anonfun$3.prototype.constructor = $c_Lorg_yaml_model_YMapEntry$$anonfun$3;
/** @constructor */
function $h_Lorg_yaml_model_YMapEntry$$anonfun$3() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YMapEntry$$anonfun$3.prototype = $c_Lorg_yaml_model_YMapEntry$$anonfun$3.prototype;
$c_Lorg_yaml_model_YMapEntry$$anonfun$3.prototype.init___ = (function() {
  return this
});
$c_Lorg_yaml_model_YMapEntry$$anonfun$3.prototype.isDefinedAt__Lorg_yaml_model_YPart__Z = (function(x1) {
  return (x1 instanceof $c_Lorg_yaml_model_YNode)
});
$c_Lorg_yaml_model_YMapEntry$$anonfun$3.prototype.applyOrElse__Lorg_yaml_model_YPart__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lorg_yaml_model_YNode)) {
    var x2 = $as_Lorg_yaml_model_YNode(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lorg_yaml_model_YMapEntry$$anonfun$3.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lorg_yaml_model_YPart__Z($as_Lorg_yaml_model_YPart(x))
});
$c_Lorg_yaml_model_YMapEntry$$anonfun$3.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lorg_yaml_model_YPart__F1__O($as_Lorg_yaml_model_YPart(x), $default)
});
var $d_Lorg_yaml_model_YMapEntry$$anonfun$3 = new $TypeData().initClass({
  Lorg_yaml_model_YMapEntry$$anonfun$3: 0
}, false, "org.yaml.model.YMapEntry$$anonfun$3", {
  Lorg_yaml_model_YMapEntry$$anonfun$3: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_model_YMapEntry$$anonfun$3.prototype.$classData = $d_Lorg_yaml_model_YMapEntry$$anonfun$3;
/** @constructor */
function $c_Lorg_yaml_model_YNode$Alias() {
  $c_Lorg_yaml_model_YNode$Ref.call(this);
  this.name$4 = null;
  this.target$4 = null
}
$c_Lorg_yaml_model_YNode$Alias.prototype = new $h_Lorg_yaml_model_YNode$Ref();
$c_Lorg_yaml_model_YNode$Alias.prototype.constructor = $c_Lorg_yaml_model_YNode$Alias;
/** @constructor */
function $h_Lorg_yaml_model_YNode$Alias() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YNode$Alias.prototype = $c_Lorg_yaml_model_YNode$Alias.prototype;
$c_Lorg_yaml_model_YNode$Alias.prototype.init___T__Lorg_yaml_model_YNode__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq = (function(name, target, location, cs) {
  this.name$4 = name;
  this.target$4 = target;
  $c_Lorg_yaml_model_YNode$Ref.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq.call(this, location, cs);
  return this
});
$c_Lorg_yaml_model_YNode$Alias.prototype.toString__T = (function() {
  return ("*" + this.name$4)
});
$c_Lorg_yaml_model_YNode$Alias.prototype.tag__Lorg_yaml_model_YTag = (function() {
  return this.target$4.tag__Lorg_yaml_model_YTag()
});
$c_Lorg_yaml_model_YNode$Alias.prototype.value__Lorg_yaml_model_YValue = (function() {
  return this.target$4.value__Lorg_yaml_model_YValue()
});
function $as_Lorg_yaml_model_YNode$Alias(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YNode$Alias) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YNode$Alias"))
}
function $isArrayOf_Lorg_yaml_model_YNode$Alias(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YNode$Alias)))
}
function $asArrayOf_Lorg_yaml_model_YNode$Alias(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YNode$Alias(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YNode$Alias;", depth))
}
var $d_Lorg_yaml_model_YNode$Alias = new $TypeData().initClass({
  Lorg_yaml_model_YNode$Alias: 0
}, false, "org.yaml.model.YNode$Alias", {
  Lorg_yaml_model_YNode$Alias: 1,
  Lorg_yaml_model_YNode$Ref: 1,
  Lorg_yaml_model_YNode: 1,
  Lorg_yaml_model_YPart: 1,
  O: 1,
  Lorg_yaml_model_YNodeLike: 1,
  Lorg_yaml_model_YValueLike: 1
});
$c_Lorg_yaml_model_YNode$Alias.prototype.$classData = $d_Lorg_yaml_model_YNode$Alias;
/** @constructor */
function $c_Lorg_yaml_model_YNode$MutRef() {
  $c_Lorg_yaml_model_YNode$Ref.call(this);
  this.origValue$4 = null;
  this.origTag$4 = null;
  this.target$4 = null
}
$c_Lorg_yaml_model_YNode$MutRef.prototype = new $h_Lorg_yaml_model_YNode$Ref();
$c_Lorg_yaml_model_YNode$MutRef.prototype.constructor = $c_Lorg_yaml_model_YNode$MutRef;
/** @constructor */
function $h_Lorg_yaml_model_YNode$MutRef() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YNode$MutRef.prototype = $c_Lorg_yaml_model_YNode$MutRef.prototype;
$c_Lorg_yaml_model_YNode$MutRef.prototype.init___Lorg_yaml_model_YValue__Lorg_yaml_model_YTag__Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq = (function(origValue, origTag, location, cs) {
  this.origValue$4 = origValue;
  this.origTag$4 = origTag;
  $c_Lorg_yaml_model_YNode$Ref.prototype.init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq.call(this, location, cs);
  this.target$4 = $m_s_None$();
  return this
});
$c_Lorg_yaml_model_YNode$MutRef.prototype.tag__Lorg_yaml_model_YTag = (function() {
  var this$1 = this.target$4;
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$2 = $as_Lorg_yaml_model_YNode(arg1);
    var this$2 = new $c_s_Some().init___O(x$2.tag__Lorg_yaml_model_YTag())
  };
  return $as_Lorg_yaml_model_YTag((this$2.isEmpty__Z() ? this.origTag$4 : this$2.get__O()))
});
$c_Lorg_yaml_model_YNode$MutRef.prototype.value__Lorg_yaml_model_YValue = (function() {
  var this$1 = this.target$4;
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_Lorg_yaml_model_YNode(arg1);
    var this$2 = new $c_s_Some().init___O(x$1.value__Lorg_yaml_model_YValue())
  };
  return $as_Lorg_yaml_model_YValue((this$2.isEmpty__Z() ? this.origValue$4 : this$2.get__O()))
});
function $as_Lorg_yaml_model_YNode$MutRef(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YNode$MutRef) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YNode$MutRef"))
}
function $isArrayOf_Lorg_yaml_model_YNode$MutRef(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YNode$MutRef)))
}
function $asArrayOf_Lorg_yaml_model_YNode$MutRef(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YNode$MutRef(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YNode$MutRef;", depth))
}
var $d_Lorg_yaml_model_YNode$MutRef = new $TypeData().initClass({
  Lorg_yaml_model_YNode$MutRef: 0
}, false, "org.yaml.model.YNode$MutRef", {
  Lorg_yaml_model_YNode$MutRef: 1,
  Lorg_yaml_model_YNode$Ref: 1,
  Lorg_yaml_model_YNode: 1,
  Lorg_yaml_model_YPart: 1,
  O: 1,
  Lorg_yaml_model_YNodeLike: 1,
  Lorg_yaml_model_YValueLike: 1
});
$c_Lorg_yaml_model_YNode$MutRef.prototype.$classData = $d_Lorg_yaml_model_YNode$MutRef;
/** @constructor */
function $c_Lorg_yaml_model_YSequence$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lorg_yaml_model_YSequence$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lorg_yaml_model_YSequence$$anonfun$1.prototype.constructor = $c_Lorg_yaml_model_YSequence$$anonfun$1;
/** @constructor */
function $h_Lorg_yaml_model_YSequence$$anonfun$1() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YSequence$$anonfun$1.prototype = $c_Lorg_yaml_model_YSequence$$anonfun$1.prototype;
$c_Lorg_yaml_model_YSequence$$anonfun$1.prototype.isDefinedAt__Lorg_yaml_model_YPart__Z = (function(x1) {
  return (x1 instanceof $c_Lorg_yaml_model_YNode)
});
$c_Lorg_yaml_model_YSequence$$anonfun$1.prototype.applyOrElse__Lorg_yaml_model_YPart__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lorg_yaml_model_YNode)) {
    var x2 = $as_Lorg_yaml_model_YNode(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lorg_yaml_model_YSequence$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lorg_yaml_model_YPart__Z($as_Lorg_yaml_model_YPart(x))
});
$c_Lorg_yaml_model_YSequence$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lorg_yaml_model_YPart__F1__O($as_Lorg_yaml_model_YPart(x), $default)
});
$c_Lorg_yaml_model_YSequence$$anonfun$1.prototype.init___Lorg_yaml_model_YSequence = (function($$outer) {
  return this
});
var $d_Lorg_yaml_model_YSequence$$anonfun$1 = new $TypeData().initClass({
  Lorg_yaml_model_YSequence$$anonfun$1: 0
}, false, "org.yaml.model.YSequence$$anonfun$1", {
  Lorg_yaml_model_YSequence$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_model_YSequence$$anonfun$1.prototype.$classData = $d_Lorg_yaml_model_YSequence$$anonfun$1;
/** @constructor */
function $c_Lorg_yaml_parser_JsonParser$MapEntryParser() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lorg_yaml_parser_JsonParser$MapEntryParser.prototype = new $h_O();
$c_Lorg_yaml_parser_JsonParser$MapEntryParser.prototype.constructor = $c_Lorg_yaml_parser_JsonParser$MapEntryParser;
/** @constructor */
function $h_Lorg_yaml_parser_JsonParser$MapEntryParser() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_JsonParser$MapEntryParser.prototype = $c_Lorg_yaml_parser_JsonParser$MapEntryParser.prototype;
$c_Lorg_yaml_parser_JsonParser$MapEntryParser.prototype.productPrefix__T = (function() {
  return "MapEntryParser"
});
$c_Lorg_yaml_parser_JsonParser$MapEntryParser.prototype.productArity__I = (function() {
  return 0
});
$c_Lorg_yaml_parser_JsonParser$MapEntryParser.prototype.equals__O__Z = (function(x$1) {
  return (((x$1 instanceof $c_Lorg_yaml_parser_JsonParser$MapEntryParser) && ($as_Lorg_yaml_parser_JsonParser$MapEntryParser(x$1).$$outer$1 === this.$$outer$1)) && ($as_Lorg_yaml_parser_JsonParser$MapEntryParser(x$1), true))
});
$c_Lorg_yaml_parser_JsonParser$MapEntryParser.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lorg_yaml_parser_JsonParser$MapEntryParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lorg_yaml_parser_JsonParser$MapEntryParser.prototype.parseEntry__p1__Z = (function() {
  var k = this.parseKey__p1__Z();
  if ((k || this.$$outer$1.org$yaml$parser$JsonParser$$currentByText__Lorg_yaml_lexer_YamlToken__T__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1, ":"))) {
    if (this.$$outer$1.org$yaml$parser$JsonParser$$currentByTextOrError__Lorg_yaml_lexer_YamlToken__T__Z($m_Lorg_yaml_lexer_YamlToken$().Indicator$1, ":")) {
      this.$$outer$1.org$yaml$parser$JsonParser$$consume__Z();
      this.$$outer$1.org$yaml$parser$JsonParser$$skipWhiteSpace__V();
      this.$$outer$1.org$yaml$parser$JsonParser$$current$1.addNonContent__V()
    };
    return (!(!(k & this.parseValue__p1__Z())))
  } else {
    var this$3 = this.$$outer$1;
    var array = [new $c_T2().init___O__O($m_Lorg_yaml_lexer_YamlToken$().Indicator$1, new $c_s_Some().init___O(",")), new $c_T2().init___O__O($m_Lorg_yaml_lexer_YamlToken$().EndMapping$1, $m_s_None$())];
    while (true) {
      if ((!this$3.eof__p1__Z())) {
        var i = 0;
        while (true) {
          if ((i < $uI(array.length))) {
            var index = i;
            var arg1 = array[index];
            var t = $as_T2(arg1);
            var jsx$2 = (this$3.current$1__p1__T2__Z(t) === false)
          } else {
            var jsx$2 = false
          };
          if (jsx$2) {
            i = ((1 + i) | 0)
          } else {
            break
          }
        };
        var jsx$1 = (i === $uI(array.length))
      } else {
        var jsx$1 = false
      };
      if (jsx$1) {
        this$3.org$yaml$parser$JsonParser$$consume__Z()
      } else {
        break
      }
    };
    return false
  }
});
$c_Lorg_yaml_parser_JsonParser$MapEntryParser.prototype.parseValue__p1__Z = (function() {
  var r = this.$$outer$1.org$yaml$parser$JsonParser$$process__Z();
  if (r) {
    this.$$outer$1.org$yaml$parser$JsonParser$$current$1.addNonContent__V()
  } else {
    this.$$outer$1.org$yaml$parser$JsonParser$$discardIf__Lorg_yaml_lexer_YamlToken__V($m_Lorg_yaml_lexer_YamlToken$().Error$1);
    var this$3 = this.$$outer$1;
    var array = [$m_Lorg_yaml_lexer_YamlToken$().Indicator$1, $m_Lorg_yaml_lexer_YamlToken$().EndMapping$1];
    while (true) {
      if ((!this$3.eof__p1__Z())) {
        var elem = this$3.currentToken__p1__Lorg_yaml_lexer_YamlToken();
        var i = 0;
        while (true) {
          if ((i < $uI(array.length))) {
            var index = i;
            var arg1 = array[index];
            var jsx$2 = ($m_sr_BoxesRunTime$().equals__O__O__Z(arg1, elem) === false)
          } else {
            var jsx$2 = false
          };
          if (jsx$2) {
            i = ((1 + i) | 0)
          } else {
            break
          }
        };
        var jsx$1 = (!(i !== $uI(array.length)))
      } else {
        var jsx$1 = false
      };
      if (jsx$1) {
        this$3.org$yaml$parser$JsonParser$$consume__Z()
      } else {
        break
      }
    }
  };
  return r
});
$c_Lorg_yaml_parser_JsonParser$MapEntryParser.prototype.init___Lorg_yaml_parser_JsonParser = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lorg_yaml_parser_JsonParser$MapEntryParser.prototype.parse__V = (function() {
  this.$$outer$1.org$yaml$parser$JsonParser$$current$1.addNonContent__V();
  this.$$outer$1.org$yaml$parser$JsonParser$$push__V();
  if (this.parseEntry__p1__Z()) {
    var parts = this.$$outer$1.org$yaml$parser$JsonParser$$current$1.buildParts__ALorg_yaml_model_YPart();
    this.$$outer$1.org$yaml$parser$JsonParser$$stackParts__Lorg_yaml_model_YPart__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry($m_s_Predef$().wrapRefArray__AO__scm_WrappedArray(parts)))
  } else {
    this.$$outer$1.org$yaml$parser$JsonParser$$current$1.buildParts__ALorg_yaml_model_YPart();
    this.$$outer$1.org$yaml$parser$JsonParser$$pop__V()
  }
});
$c_Lorg_yaml_parser_JsonParser$MapEntryParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lorg_yaml_parser_JsonParser$MapEntryParser.prototype.parseKey__p1__Z = (function() {
  var r = this.$$outer$1.org$yaml$parser$JsonParser$$parseScalar__Z();
  if ((!r)) {
    this.$$outer$1.org$yaml$parser$JsonParser$$discardIf__Lorg_yaml_lexer_YamlToken__V($m_Lorg_yaml_lexer_YamlToken$().Error$1);
    var this$3 = this.$$outer$1;
    var array = [$m_Lorg_yaml_lexer_YamlToken$().Indicator$1, $m_Lorg_yaml_lexer_YamlToken$().EndMapping$1];
    while (true) {
      if ((!this$3.eof__p1__Z())) {
        var elem = this$3.currentToken__p1__Lorg_yaml_lexer_YamlToken();
        var i = 0;
        while (true) {
          if ((i < $uI(array.length))) {
            var index = i;
            var arg1 = array[index];
            var jsx$2 = ($m_sr_BoxesRunTime$().equals__O__O__Z(arg1, elem) === false)
          } else {
            var jsx$2 = false
          };
          if (jsx$2) {
            i = ((1 + i) | 0)
          } else {
            break
          }
        };
        var jsx$1 = (!(i !== $uI(array.length)))
      } else {
        var jsx$1 = false
      };
      if (jsx$1) {
        this$3.org$yaml$parser$JsonParser$$consume__Z()
      } else {
        break
      }
    }
  };
  return r
});
$c_Lorg_yaml_parser_JsonParser$MapEntryParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lorg_yaml_parser_JsonParser$MapEntryParser(obj) {
  return (((obj instanceof $c_Lorg_yaml_parser_JsonParser$MapEntryParser) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.parser.JsonParser$MapEntryParser"))
}
function $isArrayOf_Lorg_yaml_parser_JsonParser$MapEntryParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_parser_JsonParser$MapEntryParser)))
}
function $asArrayOf_Lorg_yaml_parser_JsonParser$MapEntryParser(obj, depth) {
  return (($isArrayOf_Lorg_yaml_parser_JsonParser$MapEntryParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.parser.JsonParser$MapEntryParser;", depth))
}
var $d_Lorg_yaml_parser_JsonParser$MapEntryParser = new $TypeData().initClass({
  Lorg_yaml_parser_JsonParser$MapEntryParser: 0
}, false, "org.yaml.parser.JsonParser$MapEntryParser", {
  Lorg_yaml_parser_JsonParser$MapEntryParser: 1,
  O: 1,
  Lorg_yaml_parser_JsonParser$ElementParser: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_parser_JsonParser$MapEntryParser.prototype.$classData = $d_Lorg_yaml_parser_JsonParser$MapEntryParser;
/** @constructor */
function $c_Lorg_yaml_parser_JsonParser$SequenceValueParser() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lorg_yaml_parser_JsonParser$SequenceValueParser.prototype = new $h_O();
$c_Lorg_yaml_parser_JsonParser$SequenceValueParser.prototype.constructor = $c_Lorg_yaml_parser_JsonParser$SequenceValueParser;
/** @constructor */
function $h_Lorg_yaml_parser_JsonParser$SequenceValueParser() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_JsonParser$SequenceValueParser.prototype = $c_Lorg_yaml_parser_JsonParser$SequenceValueParser.prototype;
$c_Lorg_yaml_parser_JsonParser$SequenceValueParser.prototype.productPrefix__T = (function() {
  return "SequenceValueParser"
});
$c_Lorg_yaml_parser_JsonParser$SequenceValueParser.prototype.productArity__I = (function() {
  return 0
});
$c_Lorg_yaml_parser_JsonParser$SequenceValueParser.prototype.equals__O__Z = (function(x$1) {
  return (((x$1 instanceof $c_Lorg_yaml_parser_JsonParser$SequenceValueParser) && ($as_Lorg_yaml_parser_JsonParser$SequenceValueParser(x$1).$$outer$1 === this.$$outer$1)) && ($as_Lorg_yaml_parser_JsonParser$SequenceValueParser(x$1), true))
});
$c_Lorg_yaml_parser_JsonParser$SequenceValueParser.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lorg_yaml_parser_JsonParser$SequenceValueParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lorg_yaml_parser_JsonParser$SequenceValueParser.prototype.init___Lorg_yaml_parser_JsonParser = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lorg_yaml_parser_JsonParser$SequenceValueParser.prototype.parse__V = (function() {
  var r = this.$$outer$1.org$yaml$parser$JsonParser$$process__Z();
  if ((!r)) {
    this.$$outer$1.org$yaml$parser$JsonParser$$discardIf__Lorg_yaml_lexer_YamlToken__V($m_Lorg_yaml_lexer_YamlToken$().Error$1);
    var this$3 = this.$$outer$1;
    var array = [new $c_T2().init___O__O($m_Lorg_yaml_lexer_YamlToken$().Indicator$1, new $c_s_Some().init___O(",")), new $c_T2().init___O__O($m_Lorg_yaml_lexer_YamlToken$().EndSequence$1, $m_s_None$())];
    while (true) {
      if ((!this$3.eof__p1__Z())) {
        var i = 0;
        while (true) {
          if ((i < $uI(array.length))) {
            var index = i;
            var arg1 = array[index];
            var t = $as_T2(arg1);
            var jsx$2 = (this$3.current$1__p1__T2__Z(t) === false)
          } else {
            var jsx$2 = false
          };
          if (jsx$2) {
            i = ((1 + i) | 0)
          } else {
            break
          }
        };
        var jsx$1 = (i === $uI(array.length))
      } else {
        var jsx$1 = false
      };
      if (jsx$1) {
        this$3.org$yaml$parser$JsonParser$$consume__Z()
      } else {
        break
      }
    }
  }
});
$c_Lorg_yaml_parser_JsonParser$SequenceValueParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lorg_yaml_parser_JsonParser$SequenceValueParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lorg_yaml_parser_JsonParser$SequenceValueParser(obj) {
  return (((obj instanceof $c_Lorg_yaml_parser_JsonParser$SequenceValueParser) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.parser.JsonParser$SequenceValueParser"))
}
function $isArrayOf_Lorg_yaml_parser_JsonParser$SequenceValueParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_parser_JsonParser$SequenceValueParser)))
}
function $asArrayOf_Lorg_yaml_parser_JsonParser$SequenceValueParser(obj, depth) {
  return (($isArrayOf_Lorg_yaml_parser_JsonParser$SequenceValueParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.parser.JsonParser$SequenceValueParser;", depth))
}
var $d_Lorg_yaml_parser_JsonParser$SequenceValueParser = new $TypeData().initClass({
  Lorg_yaml_parser_JsonParser$SequenceValueParser: 0
}, false, "org.yaml.parser.JsonParser$SequenceValueParser", {
  Lorg_yaml_parser_JsonParser$SequenceValueParser: 1,
  O: 1,
  Lorg_yaml_parser_JsonParser$ElementParser: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_parser_JsonParser$SequenceValueParser.prototype.$classData = $d_Lorg_yaml_parser_JsonParser$SequenceValueParser;
/** @constructor */
function $c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder$$anonfun$create$3() {
  $c_sr_AbstractPartialFunction.call(this);
  this.$$outer$2 = null
}
$c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder$$anonfun$create$3.prototype = new $h_sr_AbstractPartialFunction();
$c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder$$anonfun$create$3.prototype.constructor = $c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder$$anonfun$create$3;
/** @constructor */
function $h_Lorg_yaml_parser_YamlLoader$DirectiveBuilder$$anonfun$create$3() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_YamlLoader$DirectiveBuilder$$anonfun$create$3.prototype = $c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder$$anonfun$create$3.prototype;
$c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder$$anonfun$create$3.prototype.isDefinedAt__Lorg_yaml_model_YPart__Z = (function(x1) {
  return (x1 instanceof $c_Lorg_yaml_model_YTag)
});
$c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder$$anonfun$create$3.prototype.init___Lorg_yaml_parser_YamlLoader$DirectiveBuilder = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  return this
});
$c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder$$anonfun$create$3.prototype.applyOrElse__Lorg_yaml_model_YPart__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lorg_yaml_model_YTag)) {
    var x2 = $as_Lorg_yaml_model_YTag(x1);
    return this.$$outer$2.org$yaml$parser$YamlLoader$DirectiveBuilder$$args$2.$$plus$eq__O__scm_ListBuffer(x2.text$3)
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder$$anonfun$create$3.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lorg_yaml_model_YPart__Z($as_Lorg_yaml_model_YPart(x))
});
$c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder$$anonfun$create$3.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lorg_yaml_model_YPart__F1__O($as_Lorg_yaml_model_YPart(x), $default)
});
var $d_Lorg_yaml_parser_YamlLoader$DirectiveBuilder$$anonfun$create$3 = new $TypeData().initClass({
  Lorg_yaml_parser_YamlLoader$DirectiveBuilder$$anonfun$create$3: 0
}, false, "org.yaml.parser.YamlLoader$DirectiveBuilder$$anonfun$create$3", {
  Lorg_yaml_parser_YamlLoader$DirectiveBuilder$$anonfun$create$3: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_parser_YamlLoader$DirectiveBuilder$$anonfun$create$3.prototype.$classData = $d_Lorg_yaml_parser_YamlLoader$DirectiveBuilder$$anonfun$create$3;
/** @constructor */
function $c_Lorg_yaml_parser_YamlParser$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lorg_yaml_parser_YamlParser$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lorg_yaml_parser_YamlParser$$anonfun$1.prototype.constructor = $c_Lorg_yaml_parser_YamlParser$$anonfun$1;
/** @constructor */
function $h_Lorg_yaml_parser_YamlParser$$anonfun$1() {
  /*<skip>*/
}
$h_Lorg_yaml_parser_YamlParser$$anonfun$1.prototype = $c_Lorg_yaml_parser_YamlParser$$anonfun$1.prototype;
$c_Lorg_yaml_parser_YamlParser$$anonfun$1.prototype.isDefinedAt__Lorg_yaml_model_YPart__Z = (function(x1) {
  return (x1 instanceof $c_Lorg_yaml_model_YDocument)
});
$c_Lorg_yaml_parser_YamlParser$$anonfun$1.prototype.applyOrElse__Lorg_yaml_model_YPart__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lorg_yaml_model_YDocument)) {
    var x2 = $as_Lorg_yaml_model_YDocument(x1);
    return x2
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lorg_yaml_parser_YamlParser$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lorg_yaml_model_YPart__Z($as_Lorg_yaml_model_YPart(x))
});
$c_Lorg_yaml_parser_YamlParser$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lorg_yaml_model_YPart__F1__O($as_Lorg_yaml_model_YPart(x), $default)
});
$c_Lorg_yaml_parser_YamlParser$$anonfun$1.prototype.init___Lorg_yaml_parser_YamlParser = (function($$outer) {
  return this
});
var $d_Lorg_yaml_parser_YamlParser$$anonfun$1 = new $TypeData().initClass({
  Lorg_yaml_parser_YamlParser$$anonfun$1: 0
}, false, "org.yaml.parser.YamlParser$$anonfun$1", {
  Lorg_yaml_parser_YamlParser$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_parser_YamlParser$$anonfun$1.prototype.$classData = $d_Lorg_yaml_parser_YamlParser$$anonfun$1;
/** @constructor */
function $c_Lorg_yaml_render_YamlRender$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_Lorg_yaml_render_YamlRender$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lorg_yaml_render_YamlRender$$anonfun$1.prototype.constructor = $c_Lorg_yaml_render_YamlRender$$anonfun$1;
/** @constructor */
function $h_Lorg_yaml_render_YamlRender$$anonfun$1() {
  /*<skip>*/
}
$h_Lorg_yaml_render_YamlRender$$anonfun$1.prototype = $c_Lorg_yaml_render_YamlRender$$anonfun$1.prototype;
$c_Lorg_yaml_render_YamlRender$$anonfun$1.prototype.isDefinedAt__Lorg_yaml_model_YPart__Z = (function(x1) {
  return (x1 instanceof $c_Lorg_yaml_model_YComment)
});
$c_Lorg_yaml_render_YamlRender$$anonfun$1.prototype.applyOrElse__Lorg_yaml_model_YPart__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_Lorg_yaml_model_YComment)) {
    var x2 = $as_Lorg_yaml_model_YComment(x1);
    return (" #" + x2.metaText$4)
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lorg_yaml_render_YamlRender$$anonfun$1.prototype.init___Lorg_yaml_render_YamlRender = (function($$outer) {
  return this
});
$c_Lorg_yaml_render_YamlRender$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__Lorg_yaml_model_YPart__Z($as_Lorg_yaml_model_YPart(x))
});
$c_Lorg_yaml_render_YamlRender$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__Lorg_yaml_model_YPart__F1__O($as_Lorg_yaml_model_YPart(x), $default)
});
var $d_Lorg_yaml_render_YamlRender$$anonfun$1 = new $TypeData().initClass({
  Lorg_yaml_render_YamlRender$$anonfun$1: 0
}, false, "org.yaml.render.YamlRender$$anonfun$1", {
  Lorg_yaml_render_YamlRender$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_render_YamlRender$$anonfun$1.prototype.$classData = $d_Lorg_yaml_render_YamlRender$$anonfun$1;
/** @constructor */
function $c_Lscopt_Arg$() {
  $c_O.call(this)
}
$c_Lscopt_Arg$.prototype = new $h_O();
$c_Lscopt_Arg$.prototype.constructor = $c_Lscopt_Arg$;
/** @constructor */
function $h_Lscopt_Arg$() {
  /*<skip>*/
}
$h_Lscopt_Arg$.prototype = $c_Lscopt_Arg$.prototype;
$c_Lscopt_Arg$.prototype.init___ = (function() {
  return this
});
$c_Lscopt_Arg$.prototype.productPrefix__T = (function() {
  return "Arg"
});
$c_Lscopt_Arg$.prototype.productArity__I = (function() {
  return 0
});
$c_Lscopt_Arg$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lscopt_Arg$.prototype.toString__T = (function() {
  return "Arg"
});
$c_Lscopt_Arg$.prototype.hashCode__I = (function() {
  return 66102
});
$c_Lscopt_Arg$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lscopt_Arg$ = new $TypeData().initClass({
  Lscopt_Arg$: 0
}, false, "scopt.Arg$", {
  Lscopt_Arg$: 1,
  O: 1,
  Lscopt_OptionDefKind: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lscopt_Arg$.prototype.$classData = $d_Lscopt_Arg$;
var $n_Lscopt_Arg$ = (void 0);
function $m_Lscopt_Arg$() {
  if ((!$n_Lscopt_Arg$)) {
    $n_Lscopt_Arg$ = new $c_Lscopt_Arg$().init___()
  };
  return $n_Lscopt_Arg$
}
/** @constructor */
function $c_Lscopt_Check$() {
  $c_O.call(this)
}
$c_Lscopt_Check$.prototype = new $h_O();
$c_Lscopt_Check$.prototype.constructor = $c_Lscopt_Check$;
/** @constructor */
function $h_Lscopt_Check$() {
  /*<skip>*/
}
$h_Lscopt_Check$.prototype = $c_Lscopt_Check$.prototype;
$c_Lscopt_Check$.prototype.init___ = (function() {
  return this
});
$c_Lscopt_Check$.prototype.productPrefix__T = (function() {
  return "Check"
});
$c_Lscopt_Check$.prototype.productArity__I = (function() {
  return 0
});
$c_Lscopt_Check$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lscopt_Check$.prototype.toString__T = (function() {
  return "Check"
});
$c_Lscopt_Check$.prototype.hashCode__I = (function() {
  return 65074408
});
$c_Lscopt_Check$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lscopt_Check$ = new $TypeData().initClass({
  Lscopt_Check$: 0
}, false, "scopt.Check$", {
  Lscopt_Check$: 1,
  O: 1,
  Lscopt_OptionDefKind: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lscopt_Check$.prototype.$classData = $d_Lscopt_Check$;
var $n_Lscopt_Check$ = (void 0);
function $m_Lscopt_Check$() {
  if ((!$n_Lscopt_Check$)) {
    $n_Lscopt_Check$ = new $c_Lscopt_Check$().init___()
  };
  return $n_Lscopt_Check$
}
/** @constructor */
function $c_Lscopt_Cmd$() {
  $c_O.call(this)
}
$c_Lscopt_Cmd$.prototype = new $h_O();
$c_Lscopt_Cmd$.prototype.constructor = $c_Lscopt_Cmd$;
/** @constructor */
function $h_Lscopt_Cmd$() {
  /*<skip>*/
}
$h_Lscopt_Cmd$.prototype = $c_Lscopt_Cmd$.prototype;
$c_Lscopt_Cmd$.prototype.init___ = (function() {
  return this
});
$c_Lscopt_Cmd$.prototype.productPrefix__T = (function() {
  return "Cmd"
});
$c_Lscopt_Cmd$.prototype.productArity__I = (function() {
  return 0
});
$c_Lscopt_Cmd$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lscopt_Cmd$.prototype.toString__T = (function() {
  return "Cmd"
});
$c_Lscopt_Cmd$.prototype.hashCode__I = (function() {
  return 67866
});
$c_Lscopt_Cmd$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lscopt_Cmd$ = new $TypeData().initClass({
  Lscopt_Cmd$: 0
}, false, "scopt.Cmd$", {
  Lscopt_Cmd$: 1,
  O: 1,
  Lscopt_OptionDefKind: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lscopt_Cmd$.prototype.$classData = $d_Lscopt_Cmd$;
var $n_Lscopt_Cmd$ = (void 0);
function $m_Lscopt_Cmd$() {
  if ((!$n_Lscopt_Cmd$)) {
    $n_Lscopt_Cmd$ = new $c_Lscopt_Cmd$().init___()
  };
  return $n_Lscopt_Cmd$
}
/** @constructor */
function $c_Lscopt_Head$() {
  $c_O.call(this)
}
$c_Lscopt_Head$.prototype = new $h_O();
$c_Lscopt_Head$.prototype.constructor = $c_Lscopt_Head$;
/** @constructor */
function $h_Lscopt_Head$() {
  /*<skip>*/
}
$h_Lscopt_Head$.prototype = $c_Lscopt_Head$.prototype;
$c_Lscopt_Head$.prototype.init___ = (function() {
  return this
});
$c_Lscopt_Head$.prototype.productPrefix__T = (function() {
  return "Head"
});
$c_Lscopt_Head$.prototype.productArity__I = (function() {
  return 0
});
$c_Lscopt_Head$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lscopt_Head$.prototype.toString__T = (function() {
  return "Head"
});
$c_Lscopt_Head$.prototype.hashCode__I = (function() {
  return 2245120
});
$c_Lscopt_Head$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lscopt_Head$ = new $TypeData().initClass({
  Lscopt_Head$: 0
}, false, "scopt.Head$", {
  Lscopt_Head$: 1,
  O: 1,
  Lscopt_OptionDefKind: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lscopt_Head$.prototype.$classData = $d_Lscopt_Head$;
var $n_Lscopt_Head$ = (void 0);
function $m_Lscopt_Head$() {
  if ((!$n_Lscopt_Head$)) {
    $n_Lscopt_Head$ = new $c_Lscopt_Head$().init___()
  };
  return $n_Lscopt_Head$
}
/** @constructor */
function $c_Lscopt_Note$() {
  $c_O.call(this)
}
$c_Lscopt_Note$.prototype = new $h_O();
$c_Lscopt_Note$.prototype.constructor = $c_Lscopt_Note$;
/** @constructor */
function $h_Lscopt_Note$() {
  /*<skip>*/
}
$h_Lscopt_Note$.prototype = $c_Lscopt_Note$.prototype;
$c_Lscopt_Note$.prototype.init___ = (function() {
  return this
});
$c_Lscopt_Note$.prototype.productPrefix__T = (function() {
  return "Note"
});
$c_Lscopt_Note$.prototype.productArity__I = (function() {
  return 0
});
$c_Lscopt_Note$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lscopt_Note$.prototype.toString__T = (function() {
  return "Note"
});
$c_Lscopt_Note$.prototype.hashCode__I = (function() {
  return 2434066
});
$c_Lscopt_Note$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lscopt_Note$ = new $TypeData().initClass({
  Lscopt_Note$: 0
}, false, "scopt.Note$", {
  Lscopt_Note$: 1,
  O: 1,
  Lscopt_OptionDefKind: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lscopt_Note$.prototype.$classData = $d_Lscopt_Note$;
var $n_Lscopt_Note$ = (void 0);
function $m_Lscopt_Note$() {
  if ((!$n_Lscopt_Note$)) {
    $n_Lscopt_Note$ = new $c_Lscopt_Note$().init___()
  };
  return $n_Lscopt_Note$
}
/** @constructor */
function $c_Lscopt_Opt$() {
  $c_O.call(this)
}
$c_Lscopt_Opt$.prototype = new $h_O();
$c_Lscopt_Opt$.prototype.constructor = $c_Lscopt_Opt$;
/** @constructor */
function $h_Lscopt_Opt$() {
  /*<skip>*/
}
$h_Lscopt_Opt$.prototype = $c_Lscopt_Opt$.prototype;
$c_Lscopt_Opt$.prototype.init___ = (function() {
  return this
});
$c_Lscopt_Opt$.prototype.productPrefix__T = (function() {
  return "Opt"
});
$c_Lscopt_Opt$.prototype.productArity__I = (function() {
  return 0
});
$c_Lscopt_Opt$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lscopt_Opt$.prototype.toString__T = (function() {
  return "Opt"
});
$c_Lscopt_Opt$.prototype.hashCode__I = (function() {
  return 79507
});
$c_Lscopt_Opt$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lscopt_Opt$ = new $TypeData().initClass({
  Lscopt_Opt$: 0
}, false, "scopt.Opt$", {
  Lscopt_Opt$: 1,
  O: 1,
  Lscopt_OptionDefKind: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lscopt_Opt$.prototype.$classData = $d_Lscopt_Opt$;
var $n_Lscopt_Opt$ = (void 0);
function $m_Lscopt_Opt$() {
  if ((!$n_Lscopt_Opt$)) {
    $n_Lscopt_Opt$ = new $c_Lscopt_Opt$().init___()
  };
  return $n_Lscopt_Opt$
}
/** @constructor */
function $c_Lscopt_RenderingMode$OneColumn$() {
  $c_O.call(this)
}
$c_Lscopt_RenderingMode$OneColumn$.prototype = new $h_O();
$c_Lscopt_RenderingMode$OneColumn$.prototype.constructor = $c_Lscopt_RenderingMode$OneColumn$;
/** @constructor */
function $h_Lscopt_RenderingMode$OneColumn$() {
  /*<skip>*/
}
$h_Lscopt_RenderingMode$OneColumn$.prototype = $c_Lscopt_RenderingMode$OneColumn$.prototype;
$c_Lscopt_RenderingMode$OneColumn$.prototype.init___ = (function() {
  return this
});
$c_Lscopt_RenderingMode$OneColumn$.prototype.productPrefix__T = (function() {
  return "OneColumn"
});
$c_Lscopt_RenderingMode$OneColumn$.prototype.productArity__I = (function() {
  return 0
});
$c_Lscopt_RenderingMode$OneColumn$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lscopt_RenderingMode$OneColumn$.prototype.toString__T = (function() {
  return "OneColumn"
});
$c_Lscopt_RenderingMode$OneColumn$.prototype.hashCode__I = (function() {
  return (-1151817412)
});
$c_Lscopt_RenderingMode$OneColumn$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lscopt_RenderingMode$OneColumn$ = new $TypeData().initClass({
  Lscopt_RenderingMode$OneColumn$: 0
}, false, "scopt.RenderingMode$OneColumn$", {
  Lscopt_RenderingMode$OneColumn$: 1,
  O: 1,
  Lscopt_RenderingMode: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lscopt_RenderingMode$OneColumn$.prototype.$classData = $d_Lscopt_RenderingMode$OneColumn$;
var $n_Lscopt_RenderingMode$OneColumn$ = (void 0);
function $m_Lscopt_RenderingMode$OneColumn$() {
  if ((!$n_Lscopt_RenderingMode$OneColumn$)) {
    $n_Lscopt_RenderingMode$OneColumn$ = new $c_Lscopt_RenderingMode$OneColumn$().init___()
  };
  return $n_Lscopt_RenderingMode$OneColumn$
}
/** @constructor */
function $c_Lscopt_RenderingMode$TwoColumns$() {
  $c_O.call(this)
}
$c_Lscopt_RenderingMode$TwoColumns$.prototype = new $h_O();
$c_Lscopt_RenderingMode$TwoColumns$.prototype.constructor = $c_Lscopt_RenderingMode$TwoColumns$;
/** @constructor */
function $h_Lscopt_RenderingMode$TwoColumns$() {
  /*<skip>*/
}
$h_Lscopt_RenderingMode$TwoColumns$.prototype = $c_Lscopt_RenderingMode$TwoColumns$.prototype;
$c_Lscopt_RenderingMode$TwoColumns$.prototype.init___ = (function() {
  return this
});
$c_Lscopt_RenderingMode$TwoColumns$.prototype.productPrefix__T = (function() {
  return "TwoColumns"
});
$c_Lscopt_RenderingMode$TwoColumns$.prototype.productArity__I = (function() {
  return 0
});
$c_Lscopt_RenderingMode$TwoColumns$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lscopt_RenderingMode$TwoColumns$.prototype.toString__T = (function() {
  return "TwoColumns"
});
$c_Lscopt_RenderingMode$TwoColumns$.prototype.hashCode__I = (function() {
  return (-1168155631)
});
$c_Lscopt_RenderingMode$TwoColumns$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_Lscopt_RenderingMode$TwoColumns$ = new $TypeData().initClass({
  Lscopt_RenderingMode$TwoColumns$: 0
}, false, "scopt.RenderingMode$TwoColumns$", {
  Lscopt_RenderingMode$TwoColumns$: 1,
  O: 1,
  Lscopt_RenderingMode: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lscopt_RenderingMode$TwoColumns$.prototype.$classData = $d_Lscopt_RenderingMode$TwoColumns$;
var $n_Lscopt_RenderingMode$TwoColumns$ = (void 0);
function $m_Lscopt_RenderingMode$TwoColumns$() {
  if ((!$n_Lscopt_RenderingMode$TwoColumns$)) {
    $n_Lscopt_RenderingMode$TwoColumns$ = new $c_Lscopt_RenderingMode$TwoColumns$().init___()
  };
  return $n_Lscopt_RenderingMode$TwoColumns$
}
/** @constructor */
function $c_Lscopt_platform$$anonfun$applyArgumentExHandler$1() {
  $c_sr_AbstractPartialFunction.call(this);
  this.desc$1$2 = null;
  this.arg$1$2 = null
}
$c_Lscopt_platform$$anonfun$applyArgumentExHandler$1.prototype = new $h_sr_AbstractPartialFunction();
$c_Lscopt_platform$$anonfun$applyArgumentExHandler$1.prototype.constructor = $c_Lscopt_platform$$anonfun$applyArgumentExHandler$1;
/** @constructor */
function $h_Lscopt_platform$$anonfun$applyArgumentExHandler$1() {
  /*<skip>*/
}
$h_Lscopt_platform$$anonfun$applyArgumentExHandler$1.prototype = $c_Lscopt_platform$$anonfun$applyArgumentExHandler$1.prototype;
$c_Lscopt_platform$$anonfun$applyArgumentExHandler$1.prototype.init___T__T = (function(desc$1, arg$1) {
  this.desc$1$2 = desc$1;
  this.arg$1$2 = arg$1;
  return this
});
$c_Lscopt_platform$$anonfun$applyArgumentExHandler$1.prototype.isDefinedAt__jl_Throwable__Z = (function(x1) {
  return ((x1 instanceof $c_jl_NumberFormatException) || ((x1 instanceof $c_Lscopt_ParseException) || (x1 !== null)))
});
$c_Lscopt_platform$$anonfun$applyArgumentExHandler$1.prototype.applyOrElse__jl_Throwable__F1__O = (function(x1, $default) {
  if ((x1 instanceof $c_jl_NumberFormatException)) {
    $m_s_package$();
    var value = $m_sc_Seq$().apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array([(((this.desc$1$2 + " expects a number but was given '") + this.arg$1$2) + "'")]));
    return new $c_s_util_Left().init___O(value)
  } else if ((x1 instanceof $c_Lscopt_ParseException)) {
    $m_s_package$();
    var value$1 = $m_sc_Seq$().apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array([(((this.desc$1$2 + " expects a Scala duration but was given '") + this.arg$1$2) + "'")]));
    return new $c_s_util_Left().init___O(value$1)
  } else if ((x1 !== null)) {
    $m_s_package$();
    var value$2 = $m_sc_Seq$().apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array([((((this.desc$1$2 + " failed when given '") + this.arg$1$2) + "'. ") + x1.getMessage__T())]));
    return new $c_s_util_Left().init___O(value$2)
  } else {
    return $default.apply__O__O(x1)
  }
});
$c_Lscopt_platform$$anonfun$applyArgumentExHandler$1.prototype.isDefinedAt__O__Z = (function(x) {
  return this.isDefinedAt__jl_Throwable__Z($as_jl_Throwable(x))
});
$c_Lscopt_platform$$anonfun$applyArgumentExHandler$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return this.applyOrElse__jl_Throwable__F1__O($as_jl_Throwable(x), $default)
});
var $d_Lscopt_platform$$anonfun$applyArgumentExHandler$1 = new $TypeData().initClass({
  Lscopt_platform$$anonfun$applyArgumentExHandler$1: 0
}, false, "scopt.platform$$anonfun$applyArgumentExHandler$1", {
  Lscopt_platform$$anonfun$applyArgumentExHandler$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lscopt_platform$$anonfun$applyArgumentExHandler$1.prototype.$classData = $d_Lscopt_platform$$anonfun$applyArgumentExHandler$1;
/** @constructor */
function $c_T2() {
  $c_O.call(this);
  this.$$und1$f = null;
  this.$$und2$f = null
}
$c_T2.prototype = new $h_O();
$c_T2.prototype.constructor = $c_T2;
/** @constructor */
function $h_T2() {
  /*<skip>*/
}
$h_T2.prototype = $c_T2.prototype;
$c_T2.prototype.productPrefix__T = (function() {
  return "Tuple2"
});
$c_T2.prototype.$$und1$mcI$sp__I = (function() {
  return $uI(this.$$und1__O())
});
$c_T2.prototype.$$und2$mcC$sp__C = (function() {
  var c = this.$$und2__O();
  if ((c === null)) {
    return 0
  } else {
    var this$2 = $as_jl_Character(c);
    return this$2.value$1
  }
});
$c_T2.prototype.productArity__I = (function() {
  return 2
});
$c_T2.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_T2)) {
    var Tuple2$1 = $as_T2(x$1);
    return ($m_sr_BoxesRunTime$().equals__O__O__Z(this.$$und1__O(), Tuple2$1.$$und1__O()) && $m_sr_BoxesRunTime$().equals__O__O__Z(this.$$und2__O(), Tuple2$1.$$und2__O()))
  } else {
    return false
  }
});
$c_T2.prototype.productElement__I__O = (function(n) {
  return $f_s_Product2__productElement__I__O(this, n)
});
$c_T2.prototype.$$und1$mcD$sp__D = (function() {
  return $uD(this.$$und1__O())
});
$c_T2.prototype.init___O__O = (function(_1, _2) {
  this.$$und1$f = _1;
  this.$$und2$f = _2;
  return this
});
$c_T2.prototype.toString__T = (function() {
  return (((("(" + this.$$und1__O()) + ",") + this.$$und2__O()) + ")")
});
$c_T2.prototype.$$und2$mcD$sp__D = (function() {
  return $uD(this.$$und2__O())
});
$c_T2.prototype.$$und2__O = (function() {
  return this.$$und2$f
});
$c_T2.prototype.$$und2$mcI$sp__I = (function() {
  return $uI(this.$$und2__O())
});
$c_T2.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_T2.prototype.$$und1__O = (function() {
  return this.$$und1$f
});
$c_T2.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_T2(obj) {
  return (((obj instanceof $c_T2) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.Tuple2"))
}
function $isArrayOf_T2(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.T2)))
}
function $asArrayOf_T2(obj, depth) {
  return (($isArrayOf_T2(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.Tuple2;", depth))
}
var $d_T2 = new $TypeData().initClass({
  T2: 0
}, false, "scala.Tuple2", {
  T2: 1,
  O: 1,
  s_Product2: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_T2.prototype.$classData = $d_T2;
/** @constructor */
function $c_T3() {
  $c_O.call(this);
  this.$$und1$1 = null;
  this.$$und2$1 = null;
  this.$$und3$1 = null
}
$c_T3.prototype = new $h_O();
$c_T3.prototype.constructor = $c_T3;
/** @constructor */
function $h_T3() {
  /*<skip>*/
}
$h_T3.prototype = $c_T3.prototype;
$c_T3.prototype.productPrefix__T = (function() {
  return "Tuple3"
});
$c_T3.prototype.productArity__I = (function() {
  return 3
});
$c_T3.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_T3)) {
    var Tuple3$1 = $as_T3(x$1);
    return (($m_sr_BoxesRunTime$().equals__O__O__Z(this.$$und1$1, Tuple3$1.$$und1$1) && $m_sr_BoxesRunTime$().equals__O__O__Z(this.$$und2$1, Tuple3$1.$$und2$1)) && $m_sr_BoxesRunTime$().equals__O__O__Z(this.$$und3$1, Tuple3$1.$$und3$1))
  } else {
    return false
  }
});
$c_T3.prototype.productElement__I__O = (function(n) {
  return $f_s_Product3__productElement__I__O(this, n)
});
$c_T3.prototype.toString__T = (function() {
  return (((((("(" + this.$$und1$1) + ",") + this.$$und2$1) + ",") + this.$$und3$1) + ")")
});
$c_T3.prototype.init___O__O__O = (function(_1, _2, _3) {
  this.$$und1$1 = _1;
  this.$$und2$1 = _2;
  this.$$und3$1 = _3;
  return this
});
$c_T3.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_T3.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_T3(obj) {
  return (((obj instanceof $c_T3) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.Tuple3"))
}
function $isArrayOf_T3(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.T3)))
}
function $asArrayOf_T3(obj, depth) {
  return (($isArrayOf_T3(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.Tuple3;", depth))
}
var $d_T3 = new $TypeData().initClass({
  T3: 0
}, false, "scala.Tuple3", {
  T3: 1,
  O: 1,
  s_Product3: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_T3.prototype.$classData = $d_T3;
/** @constructor */
function $c_T4() {
  $c_O.call(this);
  this.$$und1$1 = null;
  this.$$und2$1 = null;
  this.$$und3$1 = null;
  this.$$und4$1 = null
}
$c_T4.prototype = new $h_O();
$c_T4.prototype.constructor = $c_T4;
/** @constructor */
function $h_T4() {
  /*<skip>*/
}
$h_T4.prototype = $c_T4.prototype;
$c_T4.prototype.productPrefix__T = (function() {
  return "Tuple4"
});
$c_T4.prototype.productArity__I = (function() {
  return 4
});
$c_T4.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_T4)) {
    var Tuple4$1 = $as_T4(x$1);
    return ((($m_sr_BoxesRunTime$().equals__O__O__Z(this.$$und1$1, Tuple4$1.$$und1$1) && $m_sr_BoxesRunTime$().equals__O__O__Z(this.$$und2$1, Tuple4$1.$$und2$1)) && $m_sr_BoxesRunTime$().equals__O__O__Z(this.$$und3$1, Tuple4$1.$$und3$1)) && $m_sr_BoxesRunTime$().equals__O__O__Z(this.$$und4$1, Tuple4$1.$$und4$1))
  } else {
    return false
  }
});
$c_T4.prototype.productElement__I__O = (function(n) {
  return $f_s_Product4__productElement__I__O(this, n)
});
$c_T4.prototype.toString__T = (function() {
  return (((((((("(" + this.$$und1$1) + ",") + this.$$und2$1) + ",") + this.$$und3$1) + ",") + this.$$und4$1) + ")")
});
$c_T4.prototype.init___O__O__O__O = (function(_1, _2, _3, _4) {
  this.$$und1$1 = _1;
  this.$$und2$1 = _2;
  this.$$und3$1 = _3;
  this.$$und4$1 = _4;
  return this
});
$c_T4.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_T4.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_T4(obj) {
  return (((obj instanceof $c_T4) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.Tuple4"))
}
function $isArrayOf_T4(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.T4)))
}
function $asArrayOf_T4(obj, depth) {
  return (($isArrayOf_T4(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.Tuple4;", depth))
}
var $d_T4 = new $TypeData().initClass({
  T4: 0
}, false, "scala.Tuple4", {
  T4: 1,
  O: 1,
  s_Product4: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_T4.prototype.$classData = $d_T4;
/** @constructor */
function $c_jl_ArrayIndexOutOfBoundsException() {
  $c_jl_IndexOutOfBoundsException.call(this)
}
$c_jl_ArrayIndexOutOfBoundsException.prototype = new $h_jl_IndexOutOfBoundsException();
$c_jl_ArrayIndexOutOfBoundsException.prototype.constructor = $c_jl_ArrayIndexOutOfBoundsException;
/** @constructor */
function $h_jl_ArrayIndexOutOfBoundsException() {
  /*<skip>*/
}
$h_jl_ArrayIndexOutOfBoundsException.prototype = $c_jl_ArrayIndexOutOfBoundsException.prototype;
$c_jl_ArrayIndexOutOfBoundsException.prototype.init___T = (function(s) {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
function $as_jl_ArrayIndexOutOfBoundsException(obj) {
  return (((obj instanceof $c_jl_ArrayIndexOutOfBoundsException) || (obj === null)) ? obj : $throwClassCastException(obj, "java.lang.ArrayIndexOutOfBoundsException"))
}
function $isArrayOf_jl_ArrayIndexOutOfBoundsException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_ArrayIndexOutOfBoundsException)))
}
function $asArrayOf_jl_ArrayIndexOutOfBoundsException(obj, depth) {
  return (($isArrayOf_jl_ArrayIndexOutOfBoundsException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.ArrayIndexOutOfBoundsException;", depth))
}
var $d_jl_ArrayIndexOutOfBoundsException = new $TypeData().initClass({
  jl_ArrayIndexOutOfBoundsException: 0
}, false, "java.lang.ArrayIndexOutOfBoundsException", {
  jl_ArrayIndexOutOfBoundsException: 1,
  jl_IndexOutOfBoundsException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_jl_ArrayIndexOutOfBoundsException.prototype.$classData = $d_jl_ArrayIndexOutOfBoundsException;
/** @constructor */
function $c_jl_NumberFormatException() {
  $c_jl_IllegalArgumentException.call(this)
}
$c_jl_NumberFormatException.prototype = new $h_jl_IllegalArgumentException();
$c_jl_NumberFormatException.prototype.constructor = $c_jl_NumberFormatException;
/** @constructor */
function $h_jl_NumberFormatException() {
  /*<skip>*/
}
$h_jl_NumberFormatException.prototype = $c_jl_NumberFormatException.prototype;
$c_jl_NumberFormatException.prototype.init___T = (function(s) {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
function $as_jl_NumberFormatException(obj) {
  return (((obj instanceof $c_jl_NumberFormatException) || (obj === null)) ? obj : $throwClassCastException(obj, "java.lang.NumberFormatException"))
}
function $isArrayOf_jl_NumberFormatException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.jl_NumberFormatException)))
}
function $asArrayOf_jl_NumberFormatException(obj, depth) {
  return (($isArrayOf_jl_NumberFormatException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.lang.NumberFormatException;", depth))
}
var $d_jl_NumberFormatException = new $TypeData().initClass({
  jl_NumberFormatException: 0
}, false, "java.lang.NumberFormatException", {
  jl_NumberFormatException: 1,
  jl_IllegalArgumentException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_jl_NumberFormatException.prototype.$classData = $d_jl_NumberFormatException;
/** @constructor */
function $c_jl_StringIndexOutOfBoundsException() {
  $c_jl_IndexOutOfBoundsException.call(this)
}
$c_jl_StringIndexOutOfBoundsException.prototype = new $h_jl_IndexOutOfBoundsException();
$c_jl_StringIndexOutOfBoundsException.prototype.constructor = $c_jl_StringIndexOutOfBoundsException;
/** @constructor */
function $h_jl_StringIndexOutOfBoundsException() {
  /*<skip>*/
}
$h_jl_StringIndexOutOfBoundsException.prototype = $c_jl_StringIndexOutOfBoundsException.prototype;
$c_jl_StringIndexOutOfBoundsException.prototype.init___ = (function() {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
$c_jl_StringIndexOutOfBoundsException.prototype.init___I = (function(index) {
  var s = ("String index out of range: " + index);
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
var $d_jl_StringIndexOutOfBoundsException = new $TypeData().initClass({
  jl_StringIndexOutOfBoundsException: 0
}, false, "java.lang.StringIndexOutOfBoundsException", {
  jl_StringIndexOutOfBoundsException: 1,
  jl_IndexOutOfBoundsException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_jl_StringIndexOutOfBoundsException.prototype.$classData = $d_jl_StringIndexOutOfBoundsException;
/** @constructor */
function $c_ju_Date() {
  $c_O.call(this);
  this.date$1 = null
}
$c_ju_Date.prototype = new $h_O();
$c_ju_Date.prototype.constructor = $c_ju_Date;
/** @constructor */
function $h_ju_Date() {
  /*<skip>*/
}
$h_ju_Date.prototype = $c_ju_Date.prototype;
$c_ju_Date.prototype.init___ = (function() {
  $c_ju_Date.prototype.init___sjs_js_Date.call(this, new $g.Date());
  return this
});
$c_ju_Date.prototype.getTime__J = (function() {
  var this$1 = $m_sjsr_RuntimeLong$();
  var value = $uD(this.date$1.getTime());
  var lo = this$1.scala$scalajs$runtime$RuntimeLong$$fromDoubleImpl__D__I(value);
  var hi = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_ju_Date.prototype.init___J = (function(date) {
  $c_ju_Date.prototype.init___sjs_js_Date.call(this, new $g.Date($m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$toDouble__I__I__D(date.lo$2, date.hi$2)));
  return this
});
$c_ju_Date.prototype.equals__O__Z = (function(obj) {
  if ((obj instanceof $c_ju_Date)) {
    var x2 = $as_ju_Date(obj);
    return ($uD(x2.date$1.getTime()) === $uD(this.date$1.getTime()))
  } else {
    return false
  }
});
$c_ju_Date.prototype.compareTo__O__I = (function(x$1) {
  return this.compareTo__ju_Date__I($as_ju_Date(x$1))
});
$c_ju_Date.prototype.toString__T = (function() {
  var offset = ((-$uI(this.date$1.getTimezoneOffset())) | 0);
  $m_ju_Date$().java$util$Date$$pad0__I__T(((((offset < 0) ? ((-offset) | 0) : offset) / 60) | 0));
  $m_ju_Date$().java$util$Date$$pad0__I__T(((((offset < 0) ? ((-offset) | 0) : offset) % 60) | 0));
  return (((((((((((($m_ju_Date$().java$util$Date$$Days$1.get($uI(this.date$1.getDay())) + " ") + $m_ju_Date$().java$util$Date$$Months$1.get($uI(this.date$1.getMonth()))) + " ") + $m_ju_Date$().java$util$Date$$pad0__I__T($uI(this.date$1.getDate()))) + " ") + $m_ju_Date$().java$util$Date$$pad0__I__T($uI(this.date$1.getHours()))) + ":") + $m_ju_Date$().java$util$Date$$pad0__I__T($uI(this.date$1.getMinutes()))) + ":") + $m_ju_Date$().java$util$Date$$pad0__I__T($uI(this.date$1.getSeconds()))) + " GMT ") + $uI(this.date$1.getFullYear()))
});
$c_ju_Date.prototype.init___sjs_js_Date = (function(date) {
  this.date$1 = date;
  return this
});
$c_ju_Date.prototype.hashCode__I = (function() {
  var this$1 = $uD(this.date$1.getTime());
  return $m_sjsr_Bits$().numberHashCode__D__I(this$1)
});
$c_ju_Date.prototype.compareTo__ju_Date__I = (function(anotherDate) {
  return $m_jl_Double$().compare__D__D__I($uD(this.date$1.getTime()), $uD(anotherDate.date$1.getTime()))
});
function $as_ju_Date(obj) {
  return (((obj instanceof $c_ju_Date) || (obj === null)) ? obj : $throwClassCastException(obj, "java.util.Date"))
}
function $isArrayOf_ju_Date(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.ju_Date)))
}
function $asArrayOf_ju_Date(obj, depth) {
  return (($isArrayOf_ju_Date(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.util.Date;", depth))
}
var $d_ju_Date = new $TypeData().initClass({
  ju_Date: 0
}, false, "java.util.Date", {
  ju_Date: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  jl_Comparable: 1
});
$c_ju_Date.prototype.$classData = $d_ju_Date;
/** @constructor */
function $c_ju_FormatterClosedException() {
  $c_jl_IllegalStateException.call(this)
}
$c_ju_FormatterClosedException.prototype = new $h_jl_IllegalStateException();
$c_ju_FormatterClosedException.prototype.constructor = $c_ju_FormatterClosedException;
/** @constructor */
function $h_ju_FormatterClosedException() {
  /*<skip>*/
}
$h_ju_FormatterClosedException.prototype = $c_ju_FormatterClosedException.prototype;
$c_ju_FormatterClosedException.prototype.init___ = (function() {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
var $d_ju_FormatterClosedException = new $TypeData().initClass({
  ju_FormatterClosedException: 0
}, false, "java.util.FormatterClosedException", {
  ju_FormatterClosedException: 1,
  jl_IllegalStateException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_ju_FormatterClosedException.prototype.$classData = $d_ju_FormatterClosedException;
/** @constructor */
function $c_ju_IllegalFormatException() {
  $c_jl_IllegalArgumentException.call(this)
}
$c_ju_IllegalFormatException.prototype = new $h_jl_IllegalArgumentException();
$c_ju_IllegalFormatException.prototype.constructor = $c_ju_IllegalFormatException;
/** @constructor */
function $h_ju_IllegalFormatException() {
  /*<skip>*/
}
$h_ju_IllegalFormatException.prototype = $c_ju_IllegalFormatException.prototype;
/** @constructor */
function $c_s_Enumeration$Val() {
  $c_s_Enumeration$Value.call(this);
  this.i$2 = 0;
  this.name$2 = null
}
$c_s_Enumeration$Val.prototype = new $h_s_Enumeration$Value();
$c_s_Enumeration$Val.prototype.constructor = $c_s_Enumeration$Val;
/** @constructor */
function $h_s_Enumeration$Val() {
  /*<skip>*/
}
$h_s_Enumeration$Val.prototype = $c_s_Enumeration$Val.prototype;
$c_s_Enumeration$Val.prototype.toString__T = (function() {
  return ((this.name$2 !== null) ? this.name$2 : (((("<Unknown name for enum field #" + this.i$2) + " of class ") + $objectGetClass(this)) + ">"))
});
$c_s_Enumeration$Val.prototype.init___s_Enumeration__I__T = (function($$outer, i, name) {
  this.i$2 = i;
  this.name$2 = name;
  $c_s_Enumeration$Value.prototype.init___s_Enumeration.call(this, $$outer);
  var this$1 = $$outer.scala$Enumeration$$vmap$1;
  var assertion = (!this$1.contains__O__Z(i));
  if ((!assertion)) {
    throw new $c_jl_AssertionError().init___O((("assertion failed: " + "Duplicate id: ") + this.i$2))
  };
  $$outer.scala$Enumeration$$vmap$1.update__O__O__V(i, this);
  $$outer.scala$Enumeration$$vsetDefined$1 = false;
  $$outer.nextId$1 = ((1 + i) | 0);
  if (($$outer.nextId$1 > $$outer.scala$Enumeration$$topId$1)) {
    $$outer.scala$Enumeration$$topId$1 = $$outer.nextId$1
  };
  if ((i < $$outer.scala$Enumeration$$bottomId$1)) {
    $$outer.scala$Enumeration$$bottomId$1 = i
  };
  return this
});
var $d_s_Enumeration$Val = new $TypeData().initClass({
  s_Enumeration$Val: 0
}, false, "scala.Enumeration$Val", {
  s_Enumeration$Val: 1,
  s_Enumeration$Value: 1,
  O: 1,
  s_math_Ordered: 1,
  jl_Comparable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_Enumeration$Val.prototype.$classData = $d_s_Enumeration$Val;
/** @constructor */
function $c_s_None$() {
  $c_s_Option.call(this)
}
$c_s_None$.prototype = new $h_s_Option();
$c_s_None$.prototype.constructor = $c_s_None$;
/** @constructor */
function $h_s_None$() {
  /*<skip>*/
}
$h_s_None$.prototype = $c_s_None$.prototype;
$c_s_None$.prototype.init___ = (function() {
  return this
});
$c_s_None$.prototype.productPrefix__T = (function() {
  return "None"
});
$c_s_None$.prototype.productArity__I = (function() {
  return 0
});
$c_s_None$.prototype.isEmpty__Z = (function() {
  return true
});
$c_s_None$.prototype.get__O = (function() {
  this.get__sr_Nothing$()
});
$c_s_None$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_s_None$.prototype.toString__T = (function() {
  return "None"
});
$c_s_None$.prototype.get__sr_Nothing$ = (function() {
  throw new $c_ju_NoSuchElementException().init___T("None.get")
});
$c_s_None$.prototype.hashCode__I = (function() {
  return 2433880
});
$c_s_None$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_s_None$ = new $TypeData().initClass({
  s_None$: 0
}, false, "scala.None$", {
  s_None$: 1,
  s_Option: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_None$.prototype.$classData = $d_s_None$;
var $n_s_None$ = (void 0);
function $m_s_None$() {
  if ((!$n_s_None$)) {
    $n_s_None$ = new $c_s_None$().init___()
  };
  return $n_s_None$
}
/** @constructor */
function $c_s_PartialFunction$$anonfun$1() {
  $c_sr_AbstractPartialFunction.call(this)
}
$c_s_PartialFunction$$anonfun$1.prototype = new $h_sr_AbstractPartialFunction();
$c_s_PartialFunction$$anonfun$1.prototype.constructor = $c_s_PartialFunction$$anonfun$1;
/** @constructor */
function $h_s_PartialFunction$$anonfun$1() {
  /*<skip>*/
}
$h_s_PartialFunction$$anonfun$1.prototype = $c_s_PartialFunction$$anonfun$1.prototype;
$c_s_PartialFunction$$anonfun$1.prototype.init___ = (function() {
  return this
});
$c_s_PartialFunction$$anonfun$1.prototype.isDefinedAt__O__Z = (function(x1) {
  return true
});
$c_s_PartialFunction$$anonfun$1.prototype.applyOrElse__O__F1__O = (function(x1, $default) {
  return $m_s_PartialFunction$().scala$PartialFunction$$fallback$undpf$f
});
var $d_s_PartialFunction$$anonfun$1 = new $TypeData().initClass({
  s_PartialFunction$$anonfun$1: 0
}, false, "scala.PartialFunction$$anonfun$1", {
  s_PartialFunction$$anonfun$1: 1,
  sr_AbstractPartialFunction: 1,
  O: 1,
  F1: 1,
  s_PartialFunction: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_PartialFunction$$anonfun$1.prototype.$classData = $d_s_PartialFunction$$anonfun$1;
/** @constructor */
function $c_s_Some() {
  $c_s_Option.call(this);
  this.value$2 = null
}
$c_s_Some.prototype = new $h_s_Option();
$c_s_Some.prototype.constructor = $c_s_Some;
/** @constructor */
function $h_s_Some() {
  /*<skip>*/
}
$h_s_Some.prototype = $c_s_Some.prototype;
$c_s_Some.prototype.productPrefix__T = (function() {
  return "Some"
});
$c_s_Some.prototype.productArity__I = (function() {
  return 1
});
$c_s_Some.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_s_Some)) {
    var Some$1 = $as_s_Some(x$1);
    return $m_sr_BoxesRunTime$().equals__O__O__Z(this.value$2, Some$1.value$2)
  } else {
    return false
  }
});
$c_s_Some.prototype.isEmpty__Z = (function() {
  return false
});
$c_s_Some.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_s_Some.prototype.get__O = (function() {
  return this.value$2
});
$c_s_Some.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_s_Some.prototype.init___O = (function(value) {
  this.value$2 = value;
  return this
});
$c_s_Some.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_s_Some.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_s_Some(obj) {
  return (((obj instanceof $c_s_Some) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.Some"))
}
function $isArrayOf_s_Some(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_Some)))
}
function $asArrayOf_s_Some(obj, depth) {
  return (($isArrayOf_s_Some(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.Some;", depth))
}
var $d_s_Some = new $TypeData().initClass({
  s_Some: 0
}, false, "scala.Some", {
  s_Some: 1,
  s_Option: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_Some.prototype.$classData = $d_s_Some;
/** @constructor */
function $c_s_concurrent_duration_Duration$Infinite() {
  $c_s_concurrent_duration_Duration.call(this)
}
$c_s_concurrent_duration_Duration$Infinite.prototype = new $h_s_concurrent_duration_Duration();
$c_s_concurrent_duration_Duration$Infinite.prototype.constructor = $c_s_concurrent_duration_Duration$Infinite;
/** @constructor */
function $h_s_concurrent_duration_Duration$Infinite() {
  /*<skip>*/
}
$h_s_concurrent_duration_Duration$Infinite.prototype = $c_s_concurrent_duration_Duration$Infinite.prototype;
/** @constructor */
function $c_s_concurrent_duration_FiniteDuration() {
  $c_s_concurrent_duration_Duration.call(this);
  this.length$2 = $m_sjsr_RuntimeLong$().Zero__sjsr_RuntimeLong();
  this.unit$2 = null
}
$c_s_concurrent_duration_FiniteDuration.prototype = new $h_s_concurrent_duration_Duration();
$c_s_concurrent_duration_FiniteDuration.prototype.constructor = $c_s_concurrent_duration_FiniteDuration;
/** @constructor */
function $h_s_concurrent_duration_FiniteDuration() {
  /*<skip>*/
}
$h_s_concurrent_duration_FiniteDuration.prototype = $c_s_concurrent_duration_FiniteDuration.prototype;
$c_s_concurrent_duration_FiniteDuration.prototype.unitString__p2__T = (function() {
  var jsx$1 = $as_T($m_s_concurrent_duration_Duration$().timeUnitName$1.apply__O__O(this.unit$2));
  var t = this.length$2;
  var lo = t.lo$2;
  var hi = t.hi$2;
  return (jsx$1 + (((lo === 1) && (hi === 0)) ? "" : "s"))
});
$c_s_concurrent_duration_FiniteDuration.prototype.equals__O__Z = (function(other) {
  if ((other instanceof $c_s_concurrent_duration_FiniteDuration)) {
    var x2 = $as_s_concurrent_duration_FiniteDuration(other);
    var t = this.unit$2.toNanos__J__J(this.length$2);
    var lo = t.lo$2;
    var hi = t.hi$2;
    var b = x2.unit$2.toNanos__J__J(x2.length$2);
    return ((lo === b.lo$2) && (hi === b.hi$2))
  } else {
    return (this === other)
  }
});
$c_s_concurrent_duration_FiniteDuration.prototype.toString__T = (function() {
  return ((this.length$2 + " ") + this.unitString__p2__T())
});
$c_s_concurrent_duration_FiniteDuration.prototype.init___J__ju_concurrent_TimeUnit = (function(length, unit) {
  this.length$2 = length;
  this.unit$2 = unit;
  var x = $m_ju_concurrent_TimeUnit$().NANOSECONDS$1;
  if ((x === unit)) {
    var requirement = this.bounded__p2__J__Z(new $c_sjsr_RuntimeLong().init___I__I((-1), 2147483647))
  } else {
    var x$3 = $m_ju_concurrent_TimeUnit$().MICROSECONDS$1;
    if ((x$3 === unit)) {
      var requirement = this.bounded__p2__J__Z(new $c_sjsr_RuntimeLong().init___I__I((-1511828489), 2147483))
    } else {
      var x$5 = $m_ju_concurrent_TimeUnit$().MILLISECONDS$1;
      if ((x$5 === unit)) {
        var requirement = this.bounded__p2__J__Z(new $c_sjsr_RuntimeLong().init___I__I(2077252342, 2147))
      } else {
        var x$7 = $m_ju_concurrent_TimeUnit$().SECONDS$1;
        if ((x$7 === unit)) {
          var requirement = this.bounded__p2__J__Z(new $c_sjsr_RuntimeLong().init___I__I(633437444, 2))
        } else {
          var x$9 = $m_ju_concurrent_TimeUnit$().MINUTES$1;
          if ((x$9 === unit)) {
            var requirement = this.bounded__p2__J__Z(new $c_sjsr_RuntimeLong().init___I__I(153722867, 0))
          } else {
            var x$11 = $m_ju_concurrent_TimeUnit$().HOURS$1;
            if ((x$11 === unit)) {
              var requirement = this.bounded__p2__J__Z(new $c_sjsr_RuntimeLong().init___I__I(2562047, 0))
            } else {
              var x$13 = $m_ju_concurrent_TimeUnit$().DAYS$1;
              if ((x$13 === unit)) {
                var requirement = this.bounded__p2__J__Z(new $c_sjsr_RuntimeLong().init___I__I(106751, 0))
              } else {
                var t = $m_ju_concurrent_TimeUnit$().DAYS$1.convert__J__ju_concurrent_TimeUnit__J(length, unit);
                var lo = t.lo$2;
                var hi = t.hi$2;
                var requirement = (((hi === (-1)) ? (((-2147483648) ^ lo) >= 2147376897) : (hi > (-1))) && ((hi === 0) ? (((-2147483648) ^ lo) <= (-2147376897)) : (hi < 0)))
              }
            }
          }
        }
      }
    }
  };
  if ((!requirement)) {
    throw new $c_jl_IllegalArgumentException().init___T("requirement failed: Duration is limited to +-(2^63-1)ns (ca. 292 years)")
  };
  return this
});
$c_s_concurrent_duration_FiniteDuration.prototype.compare__O__I = (function(that) {
  return this.compare__s_concurrent_duration_Duration__I($as_s_concurrent_duration_Duration(that))
});
$c_s_concurrent_duration_FiniteDuration.prototype.compare__s_concurrent_duration_Duration__I = (function(other) {
  if ((other instanceof $c_s_concurrent_duration_FiniteDuration)) {
    var x2 = $as_s_concurrent_duration_FiniteDuration(other);
    var t = this.unit$2.toNanos__J__J(this.length$2);
    var lo = t.lo$2;
    var hi = t.hi$2;
    var this$2 = new $c_sr_RichLong().init___J(new $c_sjsr_RuntimeLong().init___I__I(lo, hi));
    var t$1 = x2.unit$2.toNanos__J__J(x2.length$2);
    var lo$1 = t$1.lo$2;
    var hi$1 = t$1.hi$2;
    var t$3 = this$2.self$1;
    var lo$3 = t$3.lo$2;
    var hi$3 = t$3.hi$2;
    var t$4 = $uJ(new $c_sjsr_RuntimeLong().init___I__I(lo$3, hi$3));
    var lo$4 = t$4.lo$2;
    var hi$4 = t$4.hi$2;
    var t$5 = $uJ(new $c_sjsr_RuntimeLong().init___I__I(lo$1, hi$1));
    var lo$5 = t$5.lo$2;
    var hi$5 = t$5.hi$2;
    return $m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$compare__I__I__I__I__I(lo$4, hi$4, lo$5, hi$5)
  } else {
    return ((-other.compare__s_concurrent_duration_Duration__I(this)) | 0)
  }
});
$c_s_concurrent_duration_FiniteDuration.prototype.bounded__p2__J__Z = (function(max) {
  var lo = max.lo$2;
  var hi = max.hi$2;
  var lo$1 = ((-lo) | 0);
  var hi$1 = ((lo !== 0) ? (~hi) : ((-hi) | 0));
  var b = this.length$2;
  var bhi = b.hi$2;
  if (((hi$1 === bhi) ? (((-2147483648) ^ lo$1) <= ((-2147483648) ^ b.lo$2)) : (hi$1 < bhi))) {
    var t = this.length$2;
    var lo$2 = t.lo$2;
    var hi$2 = t.hi$2;
    var bhi$1 = max.hi$2;
    return ((hi$2 === bhi$1) ? (((-2147483648) ^ lo$2) <= ((-2147483648) ^ max.lo$2)) : (hi$2 < bhi$1))
  } else {
    return false
  }
});
$c_s_concurrent_duration_FiniteDuration.prototype.hashCode__I = (function() {
  var t = this.unit$2.toNanos__J__J(this.length$2);
  var lo = t.lo$2;
  return lo
});
function $as_s_concurrent_duration_FiniteDuration(obj) {
  return (((obj instanceof $c_s_concurrent_duration_FiniteDuration) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.concurrent.duration.FiniteDuration"))
}
function $isArrayOf_s_concurrent_duration_FiniteDuration(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_concurrent_duration_FiniteDuration)))
}
function $asArrayOf_s_concurrent_duration_FiniteDuration(obj, depth) {
  return (($isArrayOf_s_concurrent_duration_FiniteDuration(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.concurrent.duration.FiniteDuration;", depth))
}
var $d_s_concurrent_duration_FiniteDuration = new $TypeData().initClass({
  s_concurrent_duration_FiniteDuration: 0
}, false, "scala.concurrent.duration.FiniteDuration", {
  s_concurrent_duration_FiniteDuration: 1,
  s_concurrent_duration_Duration: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_math_Ordered: 1,
  jl_Comparable: 1
});
$c_s_concurrent_duration_FiniteDuration.prototype.$classData = $d_s_concurrent_duration_FiniteDuration;
/** @constructor */
function $c_s_concurrent_impl_Promise$KeptPromise$Failed() {
  $c_O.call(this);
  this.result$1 = null
}
$c_s_concurrent_impl_Promise$KeptPromise$Failed.prototype = new $h_O();
$c_s_concurrent_impl_Promise$KeptPromise$Failed.prototype.constructor = $c_s_concurrent_impl_Promise$KeptPromise$Failed;
/** @constructor */
function $h_s_concurrent_impl_Promise$KeptPromise$Failed() {
  /*<skip>*/
}
$h_s_concurrent_impl_Promise$KeptPromise$Failed.prototype = $c_s_concurrent_impl_Promise$KeptPromise$Failed.prototype;
$c_s_concurrent_impl_Promise$KeptPromise$Failed.prototype.init___s_util_Failure = (function(result) {
  this.result$1 = result;
  return this
});
$c_s_concurrent_impl_Promise$KeptPromise$Failed.prototype.tryComplete__s_util_Try__Z = (function(value) {
  return false
});
$c_s_concurrent_impl_Promise$KeptPromise$Failed.prototype.foreach__F1__s_concurrent_ExecutionContext__V = (function(f, executor) {
  /*<skip>*/
});
$c_s_concurrent_impl_Promise$KeptPromise$Failed.prototype.toString__T = (function() {
  return $f_s_concurrent_impl_Promise__toString__T(this)
});
$c_s_concurrent_impl_Promise$KeptPromise$Failed.prototype.flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future = (function(f, executor) {
  return this
});
$c_s_concurrent_impl_Promise$KeptPromise$Failed.prototype.onComplete__F1__s_concurrent_ExecutionContext__V = (function(func, executor) {
  $f_s_concurrent_impl_Promise$KeptPromise$Kept__onComplete__F1__s_concurrent_ExecutionContext__V(this, func, executor)
});
$c_s_concurrent_impl_Promise$KeptPromise$Failed.prototype.zipWith__s_concurrent_Future__F2__s_concurrent_ExecutionContext__s_concurrent_Future = (function(that, f, executor) {
  return this
});
$c_s_concurrent_impl_Promise$KeptPromise$Failed.prototype.value__s_Option = (function() {
  return new $c_s_Some().init___O(this.result$1)
});
$c_s_concurrent_impl_Promise$KeptPromise$Failed.prototype.map__F1__s_concurrent_ExecutionContext__s_concurrent_Future = (function(f, executor) {
  return this
});
$c_s_concurrent_impl_Promise$KeptPromise$Failed.prototype.recover__s_PartialFunction__s_concurrent_ExecutionContext__s_concurrent_Future = (function(pf, executor) {
  return $f_s_concurrent_Future__recover__s_PartialFunction__s_concurrent_ExecutionContext__s_concurrent_Future(this, pf, executor)
});
$c_s_concurrent_impl_Promise$KeptPromise$Failed.prototype.recoverWith__s_PartialFunction__s_concurrent_ExecutionContext__s_concurrent_Future = (function(pf, executor) {
  return $f_s_concurrent_Future__recoverWith__s_PartialFunction__s_concurrent_ExecutionContext__s_concurrent_Future(this, pf, executor)
});
$c_s_concurrent_impl_Promise$KeptPromise$Failed.prototype.isCompleted__Z = (function() {
  return true
});
$c_s_concurrent_impl_Promise$KeptPromise$Failed.prototype.result__s_util_Try = (function() {
  return this.result$1
});
$c_s_concurrent_impl_Promise$KeptPromise$Failed.prototype.failed__s_concurrent_Future = (function() {
  var this$1 = $m_s_concurrent_impl_Promise$KeptPromise$().apply__s_util_Try__s_concurrent_Promise(new $c_s_util_Success().init___O(this.result$1.exception$2));
  return this$1
});
var $d_s_concurrent_impl_Promise$KeptPromise$Failed = new $TypeData().initClass({
  s_concurrent_impl_Promise$KeptPromise$Failed: 0
}, false, "scala.concurrent.impl.Promise$KeptPromise$Failed", {
  s_concurrent_impl_Promise$KeptPromise$Failed: 1,
  O: 1,
  s_concurrent_impl_Promise$KeptPromise$Kept: 1,
  s_concurrent_impl_Promise: 1,
  s_concurrent_Promise: 1,
  s_concurrent_Future: 1,
  s_concurrent_Awaitable: 1
});
$c_s_concurrent_impl_Promise$KeptPromise$Failed.prototype.$classData = $d_s_concurrent_impl_Promise$KeptPromise$Failed;
/** @constructor */
function $c_s_concurrent_impl_Promise$KeptPromise$Successful() {
  $c_O.call(this);
  this.result$1 = null
}
$c_s_concurrent_impl_Promise$KeptPromise$Successful.prototype = new $h_O();
$c_s_concurrent_impl_Promise$KeptPromise$Successful.prototype.constructor = $c_s_concurrent_impl_Promise$KeptPromise$Successful;
/** @constructor */
function $h_s_concurrent_impl_Promise$KeptPromise$Successful() {
  /*<skip>*/
}
$h_s_concurrent_impl_Promise$KeptPromise$Successful.prototype = $c_s_concurrent_impl_Promise$KeptPromise$Successful.prototype;
$c_s_concurrent_impl_Promise$KeptPromise$Successful.prototype.foreach__F1__s_concurrent_ExecutionContext__V = (function(f, executor) {
  $f_s_concurrent_Future__foreach__F1__s_concurrent_ExecutionContext__V(this, f, executor)
});
$c_s_concurrent_impl_Promise$KeptPromise$Successful.prototype.tryComplete__s_util_Try__Z = (function(value) {
  return false
});
$c_s_concurrent_impl_Promise$KeptPromise$Successful.prototype.toString__T = (function() {
  return $f_s_concurrent_impl_Promise__toString__T(this)
});
$c_s_concurrent_impl_Promise$KeptPromise$Successful.prototype.flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future = (function(f, executor) {
  return $f_s_concurrent_Future__flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(this, f, executor)
});
$c_s_concurrent_impl_Promise$KeptPromise$Successful.prototype.init___s_util_Success = (function(result) {
  this.result$1 = result;
  return this
});
$c_s_concurrent_impl_Promise$KeptPromise$Successful.prototype.onComplete__F1__s_concurrent_ExecutionContext__V = (function(func, executor) {
  $f_s_concurrent_impl_Promise$KeptPromise$Kept__onComplete__F1__s_concurrent_ExecutionContext__V(this, func, executor)
});
$c_s_concurrent_impl_Promise$KeptPromise$Successful.prototype.zipWith__s_concurrent_Future__F2__s_concurrent_ExecutionContext__s_concurrent_Future = (function(that, f, executor) {
  return $f_s_concurrent_Future__zipWith__s_concurrent_Future__F2__s_concurrent_ExecutionContext__s_concurrent_Future(this, that, f, executor)
});
$c_s_concurrent_impl_Promise$KeptPromise$Successful.prototype.map__F1__s_concurrent_ExecutionContext__s_concurrent_Future = (function(f, executor) {
  return $f_s_concurrent_Future__map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(this, f, executor)
});
$c_s_concurrent_impl_Promise$KeptPromise$Successful.prototype.value__s_Option = (function() {
  return new $c_s_Some().init___O(this.result$1)
});
$c_s_concurrent_impl_Promise$KeptPromise$Successful.prototype.recover__s_PartialFunction__s_concurrent_ExecutionContext__s_concurrent_Future = (function(pf, executor) {
  return this
});
$c_s_concurrent_impl_Promise$KeptPromise$Successful.prototype.isCompleted__Z = (function() {
  return true
});
$c_s_concurrent_impl_Promise$KeptPromise$Successful.prototype.recoverWith__s_PartialFunction__s_concurrent_ExecutionContext__s_concurrent_Future = (function(pf, executor) {
  return this
});
$c_s_concurrent_impl_Promise$KeptPromise$Successful.prototype.result__s_util_Try = (function() {
  return this.result$1
});
$c_s_concurrent_impl_Promise$KeptPromise$Successful.prototype.failed__s_concurrent_Future = (function() {
  var this$1 = $m_s_concurrent_impl_Promise$KeptPromise$().apply__s_util_Try__s_concurrent_Promise(new $c_s_util_Failure().init___jl_Throwable(new $c_ju_NoSuchElementException().init___T("Future.failed not completed with a throwable.")));
  return this$1
});
var $d_s_concurrent_impl_Promise$KeptPromise$Successful = new $TypeData().initClass({
  s_concurrent_impl_Promise$KeptPromise$Successful: 0
}, false, "scala.concurrent.impl.Promise$KeptPromise$Successful", {
  s_concurrent_impl_Promise$KeptPromise$Successful: 1,
  O: 1,
  s_concurrent_impl_Promise$KeptPromise$Kept: 1,
  s_concurrent_impl_Promise: 1,
  s_concurrent_Promise: 1,
  s_concurrent_Future: 1,
  s_concurrent_Awaitable: 1
});
$c_s_concurrent_impl_Promise$KeptPromise$Successful.prototype.$classData = $d_s_concurrent_impl_Promise$KeptPromise$Successful;
/** @constructor */
function $c_s_util_Failure() {
  $c_s_util_Try.call(this);
  this.exception$2 = null
}
$c_s_util_Failure.prototype = new $h_s_util_Try();
$c_s_util_Failure.prototype.constructor = $c_s_util_Failure;
/** @constructor */
function $h_s_util_Failure() {
  /*<skip>*/
}
$h_s_util_Failure.prototype = $c_s_util_Failure.prototype;
$c_s_util_Failure.prototype.productPrefix__T = (function() {
  return "Failure"
});
$c_s_util_Failure.prototype.productArity__I = (function() {
  return 1
});
$c_s_util_Failure.prototype.map__F1__s_util_Try = (function(f) {
  return this
});
$c_s_util_Failure.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_s_util_Failure)) {
    var Failure$1 = $as_s_util_Failure(x$1);
    var x = this.exception$2;
    var x$2 = Failure$1.exception$2;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_s_util_Failure.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.exception$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_s_util_Failure.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_s_util_Failure.prototype.foreach__F1__V = (function(f) {
  /*<skip>*/
});
$c_s_util_Failure.prototype.getOrElse__F0__O = (function($default) {
  return $default.apply__O()
});
$c_s_util_Failure.prototype.init___jl_Throwable = (function(exception) {
  this.exception$2 = exception;
  return this
});
$c_s_util_Failure.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_s_util_Failure.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_s_util_Failure.prototype.recover__s_PartialFunction__s_util_Try = (function(pf) {
  try {
    return (pf.isDefinedAt__O__Z(this.exception$2) ? new $c_s_util_Success().init___O(pf.apply__O__O(this.exception$2)) : this)
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      var o11 = $m_s_util_control_NonFatal$().unapply__jl_Throwable__s_Option(e$2);
      if ((!o11.isEmpty__Z())) {
        var e$3 = $as_jl_Throwable(o11.get__O());
        return new $c_s_util_Failure().init___jl_Throwable(e$3)
      };
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(e$2)
    } else {
      throw e
    }
  }
});
function $as_s_util_Failure(obj) {
  return (((obj instanceof $c_s_util_Failure) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.util.Failure"))
}
function $isArrayOf_s_util_Failure(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_util_Failure)))
}
function $asArrayOf_s_util_Failure(obj, depth) {
  return (($isArrayOf_s_util_Failure(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.util.Failure;", depth))
}
var $d_s_util_Failure = new $TypeData().initClass({
  s_util_Failure: 0
}, false, "scala.util.Failure", {
  s_util_Failure: 1,
  s_util_Try: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_util_Failure.prototype.$classData = $d_s_util_Failure;
/** @constructor */
function $c_s_util_Left() {
  $c_s_util_Either.call(this);
  this.value$2 = null
}
$c_s_util_Left.prototype = new $h_s_util_Either();
$c_s_util_Left.prototype.constructor = $c_s_util_Left;
/** @constructor */
function $h_s_util_Left() {
  /*<skip>*/
}
$h_s_util_Left.prototype = $c_s_util_Left.prototype;
$c_s_util_Left.prototype.productPrefix__T = (function() {
  return "Left"
});
$c_s_util_Left.prototype.productArity__I = (function() {
  return 1
});
$c_s_util_Left.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_s_util_Left)) {
    var Left$1 = $as_s_util_Left(x$1);
    return $m_sr_BoxesRunTime$().equals__O__O__Z(this.value$2, Left$1.value$2)
  } else {
    return false
  }
});
$c_s_util_Left.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_s_util_Left.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_s_util_Left.prototype.init___O = (function(value) {
  this.value$2 = value;
  return this
});
$c_s_util_Left.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_s_util_Left.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_s_util_Left.prototype.isRight__Z = (function() {
  return false
});
function $as_s_util_Left(obj) {
  return (((obj instanceof $c_s_util_Left) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.util.Left"))
}
function $isArrayOf_s_util_Left(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_util_Left)))
}
function $asArrayOf_s_util_Left(obj, depth) {
  return (($isArrayOf_s_util_Left(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.util.Left;", depth))
}
var $d_s_util_Left = new $TypeData().initClass({
  s_util_Left: 0
}, false, "scala.util.Left", {
  s_util_Left: 1,
  s_util_Either: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_util_Left.prototype.$classData = $d_s_util_Left;
/** @constructor */
function $c_s_util_Right() {
  $c_s_util_Either.call(this);
  this.value$2 = null
}
$c_s_util_Right.prototype = new $h_s_util_Either();
$c_s_util_Right.prototype.constructor = $c_s_util_Right;
/** @constructor */
function $h_s_util_Right() {
  /*<skip>*/
}
$h_s_util_Right.prototype = $c_s_util_Right.prototype;
$c_s_util_Right.prototype.productPrefix__T = (function() {
  return "Right"
});
$c_s_util_Right.prototype.productArity__I = (function() {
  return 1
});
$c_s_util_Right.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_s_util_Right)) {
    var Right$1 = $as_s_util_Right(x$1);
    return $m_sr_BoxesRunTime$().equals__O__O__Z(this.value$2, Right$1.value$2)
  } else {
    return false
  }
});
$c_s_util_Right.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_s_util_Right.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_s_util_Right.prototype.init___O = (function(value) {
  this.value$2 = value;
  return this
});
$c_s_util_Right.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_s_util_Right.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_s_util_Right.prototype.isRight__Z = (function() {
  return true
});
function $as_s_util_Right(obj) {
  return (((obj instanceof $c_s_util_Right) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.util.Right"))
}
function $isArrayOf_s_util_Right(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_util_Right)))
}
function $asArrayOf_s_util_Right(obj, depth) {
  return (($isArrayOf_s_util_Right(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.util.Right;", depth))
}
var $d_s_util_Right = new $TypeData().initClass({
  s_util_Right: 0
}, false, "scala.util.Right", {
  s_util_Right: 1,
  s_util_Either: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_util_Right.prototype.$classData = $d_s_util_Right;
/** @constructor */
function $c_s_util_Success() {
  $c_s_util_Try.call(this);
  this.value$2 = null
}
$c_s_util_Success.prototype = new $h_s_util_Try();
$c_s_util_Success.prototype.constructor = $c_s_util_Success;
/** @constructor */
function $h_s_util_Success() {
  /*<skip>*/
}
$h_s_util_Success.prototype = $c_s_util_Success.prototype;
$c_s_util_Success.prototype.productPrefix__T = (function() {
  return "Success"
});
$c_s_util_Success.prototype.productArity__I = (function() {
  return 1
});
$c_s_util_Success.prototype.map__F1__s_util_Try = (function(f) {
  try {
    return new $c_s_util_Success().init___O(f.apply__O__O(this.value$2))
  } catch (e) {
    var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
    if ((e$2 !== null)) {
      var o11 = $m_s_util_control_NonFatal$().unapply__jl_Throwable__s_Option(e$2);
      if ((!o11.isEmpty__Z())) {
        var e$3 = $as_jl_Throwable(o11.get__O());
        return new $c_s_util_Failure().init___jl_Throwable(e$3)
      };
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(e$2)
    } else {
      throw e
    }
  }
});
$c_s_util_Success.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_s_util_Success)) {
    var Success$1 = $as_s_util_Success(x$1);
    return $m_sr_BoxesRunTime$().equals__O__O__Z(this.value$2, Success$1.value$2)
  } else {
    return false
  }
});
$c_s_util_Success.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_s_util_Success.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_s_util_Success.prototype.foreach__F1__V = (function(f) {
  f.apply__O__O(this.value$2)
});
$c_s_util_Success.prototype.init___O = (function(value) {
  this.value$2 = value;
  return this
});
$c_s_util_Success.prototype.getOrElse__F0__O = (function($default) {
  return this.value$2
});
$c_s_util_Success.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_s_util_Success.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_s_util_Success.prototype.recover__s_PartialFunction__s_util_Try = (function(pf) {
  return this
});
function $as_s_util_Success(obj) {
  return (((obj instanceof $c_s_util_Success) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.util.Success"))
}
function $isArrayOf_s_util_Success(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_util_Success)))
}
function $asArrayOf_s_util_Success(obj, depth) {
  return (($isArrayOf_s_util_Success(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.util.Success;", depth))
}
var $d_s_util_Success = new $TypeData().initClass({
  s_util_Success: 0
}, false, "scala.util.Success", {
  s_util_Success: 1,
  s_util_Try: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_util_Success.prototype.$classData = $d_s_util_Success;
/** @constructor */
function $c_s_util_matching_Regex$MatchIterator() {
  $c_sc_AbstractIterator.call(this);
  this.source$2 = null;
  this.regex$2 = null;
  this.groupNames$2 = null;
  this.matcher$2 = null;
  this.nextSeen$2 = 0;
  this.scala$util$matching$Regex$MatchData$$nameToIndex$2 = null;
  this.bitmap$0$2 = false
}
$c_s_util_matching_Regex$MatchIterator.prototype = new $h_sc_AbstractIterator();
$c_s_util_matching_Regex$MatchIterator.prototype.constructor = $c_s_util_matching_Regex$MatchIterator;
/** @constructor */
function $h_s_util_matching_Regex$MatchIterator() {
  /*<skip>*/
}
$h_s_util_matching_Regex$MatchIterator.prototype = $c_s_util_matching_Regex$MatchIterator.prototype;
$c_s_util_matching_Regex$MatchIterator.prototype.next__O = (function() {
  return this.next__T()
});
$c_s_util_matching_Regex$MatchIterator.prototype.init___jl_CharSequence__s_util_matching_Regex__sc_Seq = (function(source, regex, groupNames) {
  this.source$2 = source;
  this.regex$2 = regex;
  this.groupNames$2 = groupNames;
  var this$1 = regex.pattern$1;
  this.matcher$2 = new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$1, source, 0, $charSequenceLength(source));
  this.nextSeen$2 = 0;
  return this
});
$c_s_util_matching_Regex$MatchIterator.prototype.start__I__I = (function(i) {
  this.ensure__p2__V();
  return this.matcher$2.start__I__I(i)
});
$c_s_util_matching_Regex$MatchIterator.prototype.toString__T = (function() {
  return "<iterator>"
});
$c_s_util_matching_Regex$MatchIterator.prototype.end__I = (function() {
  this.ensure__p2__V();
  return this.matcher$2.end__I()
});
$c_s_util_matching_Regex$MatchIterator.prototype.next__T = (function() {
  var x1 = this.nextSeen$2;
  switch (x1) {
    case 0: {
      if ((!this.hasNext__Z())) {
        throw new $c_ju_NoSuchElementException().init___()
      };
      this.next__T();
      break
    }
    case 1: {
      this.nextSeen$2 = 2;
      break
    }
    case 2: {
      this.nextSeen$2 = 0;
      this.next__T();
      break
    }
    case 3: {
      throw new $c_ju_NoSuchElementException().init___();
      break
    }
    default: {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  return this.matcher$2.group__T()
});
$c_s_util_matching_Regex$MatchIterator.prototype.ensure__p2__V = (function() {
  var x1 = this.nextSeen$2;
  switch (x1) {
    case 0: {
      if ((!this.hasNext__Z())) {
        throw new $c_jl_IllegalStateException().init___()
      };
      break
    }
    case 1: {
      break
    }
    case 2: {
      break
    }
    case 3: {
      throw new $c_jl_IllegalStateException().init___();
      break
    }
    default: {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_s_util_matching_Regex$MatchIterator.prototype.hasNext__Z = (function() {
  var x1 = this.nextSeen$2;
  switch (x1) {
    case 0: {
      this.nextSeen$2 = (this.matcher$2.find__Z() ? 1 : 3);
      break
    }
    case 1: {
      break
    }
    case 2: {
      this.nextSeen$2 = 0;
      this.hasNext__Z();
      break
    }
    case 3: {
      break
    }
    default: {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  return (this.nextSeen$2 === 1)
});
$c_s_util_matching_Regex$MatchIterator.prototype.source__jl_CharSequence = (function() {
  return this.source$2
});
$c_s_util_matching_Regex$MatchIterator.prototype.start__I = (function() {
  this.ensure__p2__V();
  return this.matcher$2.start__I()
});
$c_s_util_matching_Regex$MatchIterator.prototype.end__I__I = (function(i) {
  this.ensure__p2__V();
  return this.matcher$2.end__I__I(i)
});
var $d_s_util_matching_Regex$MatchIterator = new $TypeData().initClass({
  s_util_matching_Regex$MatchIterator: 0
}, false, "scala.util.matching.Regex$MatchIterator", {
  s_util_matching_Regex$MatchIterator: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  s_util_matching_Regex$MatchData: 1
});
$c_s_util_matching_Regex$MatchIterator.prototype.$classData = $d_s_util_matching_Regex$MatchIterator;
/** @constructor */
function $c_s_util_matching_Regex$MatchIterator$$anon$4() {
  $c_sc_AbstractIterator.call(this);
  this.scala$util$matching$Regex$Replacement$$sb$2 = null;
  this.$$outer$2 = null
}
$c_s_util_matching_Regex$MatchIterator$$anon$4.prototype = new $h_sc_AbstractIterator();
$c_s_util_matching_Regex$MatchIterator$$anon$4.prototype.constructor = $c_s_util_matching_Regex$MatchIterator$$anon$4;
/** @constructor */
function $h_s_util_matching_Regex$MatchIterator$$anon$4() {
  /*<skip>*/
}
$h_s_util_matching_Regex$MatchIterator$$anon$4.prototype = $c_s_util_matching_Regex$MatchIterator$$anon$4.prototype;
$c_s_util_matching_Regex$MatchIterator$$anon$4.prototype.next__O = (function() {
  return this.next__s_util_matching_Regex$Match()
});
$c_s_util_matching_Regex$MatchIterator$$anon$4.prototype.hasNext__Z = (function() {
  return this.$$outer$2.hasNext__Z()
});
$c_s_util_matching_Regex$MatchIterator$$anon$4.prototype.matcher__ju_regex_Matcher = (function() {
  return this.$$outer$2.matcher$2
});
$c_s_util_matching_Regex$MatchIterator$$anon$4.prototype.next__s_util_matching_Regex$Match = (function() {
  this.$$outer$2.next__T();
  return new $c_s_util_matching_Regex$Match().init___jl_CharSequence__ju_regex_Matcher__sc_Seq(this.$$outer$2.source$2, this.matcher__ju_regex_Matcher(), this.$$outer$2.groupNames$2).force__s_util_matching_Regex$Match()
});
$c_s_util_matching_Regex$MatchIterator$$anon$4.prototype.init___s_util_matching_Regex$MatchIterator = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.scala$util$matching$Regex$Replacement$$sb$2 = new $c_jl_StringBuffer().init___();
  return this
});
var $d_s_util_matching_Regex$MatchIterator$$anon$4 = new $TypeData().initClass({
  s_util_matching_Regex$MatchIterator$$anon$4: 0
}, false, "scala.util.matching.Regex$MatchIterator$$anon$4", {
  s_util_matching_Regex$MatchIterator$$anon$4: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  s_util_matching_Regex$Replacement: 1
});
$c_s_util_matching_Regex$MatchIterator$$anon$4.prototype.$classData = $d_s_util_matching_Regex$MatchIterator$$anon$4;
function $f_sc_GenSetLike__equals__O__Z($thiz, that) {
  if ($is_sc_GenSet(that)) {
    var x2 = $as_sc_GenSet(that);
    return (($thiz === x2) || (($thiz.size__I() === x2.size__I()) && $f_sc_GenSetLike__liftedTree1$1__psc_GenSetLike__sc_GenSet__Z($thiz, x2)))
  } else {
    return false
  }
}
function $f_sc_GenSetLike__liftedTree1$1__psc_GenSetLike__sc_GenSet__Z($thiz, x2$1) {
  try {
    return $thiz.subsetOf__sc_GenSet__Z(x2$1)
  } catch (e) {
    if ((e instanceof $c_jl_ClassCastException)) {
      $as_jl_ClassCastException(e);
      return false
    } else {
      throw e
    }
  }
}
function $is_sc_GenSetLike(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_GenSetLike)))
}
function $as_sc_GenSetLike(obj) {
  return (($is_sc_GenSetLike(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.GenSetLike"))
}
function $isArrayOf_sc_GenSetLike(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_GenSetLike)))
}
function $asArrayOf_sc_GenSetLike(obj, depth) {
  return (($isArrayOf_sc_GenSetLike(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.GenSetLike;", depth))
}
function $f_sc_TraversableLike__flatMap__F1__scg_CanBuildFrom__O($thiz, f, bf) {
  var b = bf.apply__O__scm_Builder($thiz.repr__O());
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$1, f$1) {
    return (function(x$2) {
      return $as_scm_Builder(b$1.$$plus$plus$eq__sc_TraversableOnce__scg_Growable($as_sc_GenTraversableOnce(f$1.apply__O__O(x$2)).seq__sc_TraversableOnce()))
    })
  })($thiz, b, f)));
  return b.result__O()
}
function $f_sc_TraversableLike__to__scg_CanBuildFrom__O($thiz, cbf) {
  var b = cbf.apply__scm_Builder();
  $f_scm_Builder__sizeHint__sc_TraversableLike__V(b, $thiz);
  b.$$plus$plus$eq__sc_TraversableOnce__scg_Growable($thiz.thisCollection__sc_Traversable());
  return b.result__O()
}
function $f_sc_TraversableLike__isPartLikelySynthetic$1__psc_TraversableLike__T__I__Z($thiz, fqn$1, partStart$1) {
  var firstChar = (65535 & $uI(fqn$1.charCodeAt(partStart$1)));
  return (((firstChar > 90) && (firstChar < 127)) || (firstChar < 65))
}
function $f_sc_TraversableLike__dropWhile__F1__O($thiz, p) {
  var b = $thiz.newBuilder__scm_Builder();
  var go = new $c_sr_BooleanRef().init___Z(false);
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, go$1, p$1, b$1) {
    return (function(x$2) {
      if (((!go$1.elem$1) && (!$uZ(p$1.apply__O__O(x$2))))) {
        go$1.elem$1 = true
      };
      return (go$1.elem$1 ? b$1.$$plus$eq__O__scm_Builder(x$2) : (void 0))
    })
  })($thiz, go, p, b)));
  return b.result__O()
}
function $f_sc_TraversableLike__init__O($thiz) {
  if ($thiz.isEmpty__Z()) {
    throw new $c_jl_UnsupportedOperationException().init___T("empty.init")
  };
  var elem = $thiz.head__O();
  var lst = new $c_sr_ObjectRef().init___O(elem);
  var follow = new $c_sr_BooleanRef().init___Z(false);
  var b = $thiz.newBuilder__scm_Builder();
  $f_scm_Builder__sizeHint__sc_TraversableLike__I__V(b, $thiz, (-1));
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, follow$1, b$1, lst$1) {
    return (function(x$2) {
      if (follow$1.elem$1) {
        b$1.$$plus$eq__O__scm_Builder(lst$1.elem$1)
      } else {
        follow$1.elem$1 = true
      };
      lst$1.elem$1 = x$2
    })
  })($thiz, follow, b, lst)));
  return b.result__O()
}
function $f_sc_TraversableLike__toString__T($thiz) {
  return $thiz.mkString__T__T__T__T(($thiz.stringPrefix__T() + "("), ", ", ")")
}
function $f_sc_TraversableLike__headOption__s_Option($thiz) {
  return ($thiz.isEmpty__Z() ? $m_s_None$() : new $c_s_Some().init___O($thiz.head__O()))
}
function $f_sc_TraversableLike__filterImpl__F1__Z__O($thiz, p, isFlipped) {
  if (($thiz instanceof $c_sci_List)) {
    var x2 = $as_sci_List($thiz);
    return $f_sc_TraversableLike__filterImplList__psc_TraversableLike__sci_List__F1__Z__sci_List($thiz, x2, p, isFlipped)
  } else {
    var b = $thiz.newBuilder__scm_Builder();
    $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, p$1, isFlipped$1, b$1) {
      return (function(x$2) {
        return (($uZ(p$1.apply__O__O(x$2)) !== isFlipped$1) ? b$1.$$plus$eq__O__scm_Builder(x$2) : (void 0))
      })
    })($thiz, p, isFlipped, b)));
    return b.result__O()
  }
}
function $f_sc_TraversableLike__span__F1__T2($thiz, p) {
  var l = $thiz.newBuilder__scm_Builder();
  var r = $thiz.newBuilder__scm_Builder();
  var toLeft = new $c_sr_BooleanRef().init___Z(true);
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, toLeft$1, p$1, l$1, r$1) {
    return (function(x$2) {
      toLeft$1.elem$1 = (toLeft$1.elem$1 && $uZ(p$1.apply__O__O(x$2)));
      return (toLeft$1.elem$1 ? l$1 : r$1).$$plus$eq__O__scm_Builder(x$2)
    })
  })($thiz, toLeft, p, l, r)));
  return new $c_T2().init___O__O(l.result__O(), r.result__O())
}
function $f_sc_TraversableLike__allIn$1__psc_TraversableLike__sci_List__sci_List__F1__Z__sci_List($thiz, start, remaining, p$2, isFlipped$2) {
  _allIn: while (true) {
    if (remaining.isEmpty__Z()) {
      return start
    } else {
      var x$2 = remaining.head__O();
      if (($uZ(p$2.apply__O__O(x$2)) !== isFlipped$2)) {
        remaining = $as_sci_List(remaining.tail__O());
        continue _allIn
      } else {
        var firstMiss = remaining;
        return $f_sc_TraversableLike__partialFill$1__psc_TraversableLike__sci_List__sci_List__F1__Z__sci_List($thiz, start, firstMiss, p$2, isFlipped$2)
      }
    }
  }
}
function $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O($thiz, that, bf) {
  var b = bf.apply__O__scm_Builder($thiz.repr__O());
  if ($is_sc_IndexedSeqLike(that)) {
    var delta = that.seq__sc_TraversableOnce().size__I();
    $f_scm_Builder__sizeHint__sc_TraversableLike__I__V(b, $thiz, delta)
  };
  b.$$plus$plus$eq__sc_TraversableOnce__scg_Growable($thiz.thisCollection__sc_Traversable());
  b.$$plus$plus$eq__sc_TraversableOnce__scg_Growable(that.seq__sc_TraversableOnce());
  return b.result__O()
}
function $f_sc_TraversableLike__noneIn$1__psc_TraversableLike__sci_List__F1__Z__sci_List($thiz, l, p$2, isFlipped$2) {
  _noneIn: while (true) {
    if (l.isEmpty__Z()) {
      return $m_sci_Nil$()
    } else {
      var h = l.head__O();
      var t = $as_sci_List(l.tail__O());
      if (($uZ(p$2.apply__O__O(h)) !== isFlipped$2)) {
        var start = l;
        var remaining = t;
        return $f_sc_TraversableLike__allIn$1__psc_TraversableLike__sci_List__sci_List__F1__Z__sci_List($thiz, start, remaining, p$2, isFlipped$2)
      } else {
        l = t;
        continue _noneIn
      }
    }
  }
}
function $f_sc_TraversableLike__partition__F1__T2($thiz, p) {
  var l = $thiz.newBuilder__scm_Builder();
  var r = $thiz.newBuilder__scm_Builder();
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, p$1, l$1, r$1) {
    return (function(x$2) {
      return ($uZ(p$1.apply__O__O(x$2)) ? l$1 : r$1).$$plus$eq__O__scm_Builder(x$2)
    })
  })($thiz, p, l, r)));
  return new $c_T2().init___O__O(l.result__O(), r.result__O())
}
function $f_sc_TraversableLike__last__O($thiz) {
  var elem = $thiz.head__O();
  var lst = new $c_sr_ObjectRef().init___O(elem);
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, lst$1) {
    return (function(x$2) {
      lst$1.elem$1 = x$2
    })
  })($thiz, lst)));
  return lst.elem$1
}
function $f_sc_TraversableLike__tail__O($thiz) {
  if ($thiz.isEmpty__Z()) {
    throw new $c_jl_UnsupportedOperationException().init___T("empty.tail")
  };
  return $thiz.drop__I__O(1)
}
function $f_sc_TraversableLike__filterImplList__psc_TraversableLike__sci_List__F1__Z__sci_List($thiz, self, p, isFlipped) {
  var l = self;
  var result = $f_sc_TraversableLike__noneIn$1__psc_TraversableLike__sci_List__F1__Z__sci_List($thiz, l, p, isFlipped);
  return result
}
function $f_sc_TraversableLike__groupBy__F1__sci_Map($thiz, f) {
  var m = new $c_scm_HashMap().init___();
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, f$1, m$1) {
    return (function(elem$2) {
      var key = f$1.apply__O__O(elem$2);
      var bldr = $as_scm_Builder(m$1.getOrElseUpdate__O__F0__O(key, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this$1) {
        return (function() {
          return $this$1.newBuilder__scm_Builder()
        })
      })($this))));
      return bldr.$$plus$eq__O__scm_Builder(elem$2)
    })
  })($thiz, f, m)));
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var p = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(check$ifrefutable$1$2) {
      var check$ifrefutable$1 = $as_T2(check$ifrefutable$1$2);
      return (check$ifrefutable$1 !== null)
    })
  })($thiz));
  new $c_sc_TraversableLike$WithFilter().init___sc_TraversableLike__F1(m, p).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3, b$1) {
    return (function(x$2$2) {
      var x$2 = $as_T2(x$2$2);
      if ((x$2 !== null)) {
        var k = x$2.$$und1__O();
        var v = $as_scm_Builder(x$2.$$und2__O());
        return b$1.$$plus$eq__O__scm_Builder(new $c_T2().init___O__O(k, v.result__O()))
      } else {
        throw new $c_s_MatchError().init___O(x$2)
      }
    })
  })($thiz, b)));
  return $as_sci_Map(b.elems$1)
}
function $f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O($thiz, f, bf) {
  var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder($thiz, bf);
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$1, f$1) {
    return (function(x$2) {
      return b$1.$$plus$eq__O__scm_Builder(f$1.apply__O__O(x$2))
    })
  })($thiz, b, f)));
  return b.result__O()
}
function $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder($thiz, bf$1) {
  var b = bf$1.apply__O__scm_Builder($thiz.repr__O());
  $f_scm_Builder__sizeHint__sc_TraversableLike__V(b, $thiz);
  return b
}
function $f_sc_TraversableLike__partialFill$1__psc_TraversableLike__sci_List__sci_List__F1__Z__sci_List($thiz, origStart, firstMiss, p$2, isFlipped$2) {
  var newHead = new $c_sci_$colon$colon().init___O__sci_List(origStart.head__O(), $m_sci_Nil$());
  var toProcess = $as_sci_List(origStart.tail__O());
  var currentLast = newHead;
  while ((toProcess !== firstMiss)) {
    var newElem = new $c_sci_$colon$colon().init___O__sci_List(toProcess.head__O(), $m_sci_Nil$());
    currentLast.tl$5 = newElem;
    currentLast = newElem;
    toProcess = $as_sci_List(toProcess.tail__O())
  };
  var next = $as_sci_List(firstMiss.tail__O());
  var nextToCopy = next;
  while ((!next.isEmpty__Z())) {
    var head = next.head__O();
    if (($uZ(p$2.apply__O__O(head)) !== isFlipped$2)) {
      next = $as_sci_List(next.tail__O())
    } else {
      while ((nextToCopy !== next)) {
        var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy.head__O(), $m_sci_Nil$());
        currentLast.tl$5 = newElem$2;
        currentLast = newElem$2;
        nextToCopy = $as_sci_List(nextToCopy.tail__O())
      };
      nextToCopy = $as_sci_List(next.tail__O());
      next = $as_sci_List(next.tail__O())
    }
  };
  if ((!nextToCopy.isEmpty__Z())) {
    currentLast.tl$5 = nextToCopy
  };
  return newHead
}
function $f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O($thiz, pf, bf) {
  var b = bf.apply__O__scm_Builder($thiz.repr__O());
  $thiz.foreach__F1__V(pf.runWith__F1__F1(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$1) {
    return (function(x$1$2) {
      return b$1.$$plus$eq__O__scm_Builder(x$1$2)
    })
  })($thiz, b))));
  return b.result__O()
}
function $f_sc_TraversableLike__stringPrefix__T($thiz) {
  var this$1 = $thiz.repr__O();
  var fqn = $objectGetClass(this$1).getName__T();
  var pos = (((-1) + $uI(fqn.length)) | 0);
  while (true) {
    if ((pos !== (-1))) {
      var index = pos;
      var jsx$1 = ((65535 & $uI(fqn.charCodeAt(index))) === 36)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      pos = (((-1) + pos) | 0)
    } else {
      break
    }
  };
  if ((pos === (-1))) {
    var jsx$2 = true
  } else {
    var index$1 = pos;
    var jsx$2 = ((65535 & $uI(fqn.charCodeAt(index$1))) === 46)
  };
  if (jsx$2) {
    return ""
  };
  var result = "";
  while (true) {
    var partEnd = ((1 + pos) | 0);
    while (true) {
      if ((pos !== (-1))) {
        var index$2 = pos;
        var jsx$4 = ((65535 & $uI(fqn.charCodeAt(index$2))) <= 57)
      } else {
        var jsx$4 = false
      };
      if (jsx$4) {
        var index$3 = pos;
        var jsx$3 = ((65535 & $uI(fqn.charCodeAt(index$3))) >= 48)
      } else {
        var jsx$3 = false
      };
      if (jsx$3) {
        pos = (((-1) + pos) | 0)
      } else {
        break
      }
    };
    var lastNonDigit = pos;
    while (true) {
      if ((pos !== (-1))) {
        var index$4 = pos;
        var jsx$6 = ((65535 & $uI(fqn.charCodeAt(index$4))) !== 36)
      } else {
        var jsx$6 = false
      };
      if (jsx$6) {
        var index$5 = pos;
        var jsx$5 = ((65535 & $uI(fqn.charCodeAt(index$5))) !== 46)
      } else {
        var jsx$5 = false
      };
      if (jsx$5) {
        pos = (((-1) + pos) | 0)
      } else {
        break
      }
    };
    var partStart = ((1 + pos) | 0);
    if (((pos === lastNonDigit) && (partEnd !== $uI(fqn.length)))) {
      return result
    };
    while (true) {
      if ((pos !== (-1))) {
        var index$6 = pos;
        var jsx$7 = ((65535 & $uI(fqn.charCodeAt(index$6))) === 36)
      } else {
        var jsx$7 = false
      };
      if (jsx$7) {
        pos = (((-1) + pos) | 0)
      } else {
        break
      }
    };
    if ((pos === (-1))) {
      var atEnd = true
    } else {
      var index$7 = pos;
      var atEnd = ((65535 & $uI(fqn.charCodeAt(index$7))) === 46)
    };
    if ((atEnd || (!$f_sc_TraversableLike__isPartLikelySynthetic$1__psc_TraversableLike__T__I__Z($thiz, fqn, partStart)))) {
      var part = $as_T(fqn.substring(partStart, partEnd));
      var thiz = result;
      if ((thiz === null)) {
        throw new $c_jl_NullPointerException().init___()
      };
      if ((thiz === "")) {
        result = part
      } else {
        result = ((("" + part) + new $c_jl_Character().init___C(46)) + result)
      };
      if (atEnd) {
        return result
      }
    }
  }
}
function $is_sc_TraversableLike(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_TraversableLike)))
}
function $as_sc_TraversableLike(obj) {
  return (($is_sc_TraversableLike(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.TraversableLike"))
}
function $isArrayOf_sc_TraversableLike(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_TraversableLike)))
}
function $asArrayOf_sc_TraversableLike(obj, depth) {
  return (($isArrayOf_sc_TraversableLike(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.TraversableLike;", depth))
}
/** @constructor */
function $c_scg_SeqFactory() {
  $c_scg_GenSeqFactory.call(this)
}
$c_scg_SeqFactory.prototype = new $h_scg_GenSeqFactory();
$c_scg_SeqFactory.prototype.constructor = $c_scg_SeqFactory;
/** @constructor */
function $h_scg_SeqFactory() {
  /*<skip>*/
}
$h_scg_SeqFactory.prototype = $c_scg_SeqFactory.prototype;
/** @constructor */
function $c_sci_HashMap$HashTrieMap$$anon$3() {
  $c_sci_TrieIterator.call(this)
}
$c_sci_HashMap$HashTrieMap$$anon$3.prototype = new $h_sci_TrieIterator();
$c_sci_HashMap$HashTrieMap$$anon$3.prototype.constructor = $c_sci_HashMap$HashTrieMap$$anon$3;
/** @constructor */
function $h_sci_HashMap$HashTrieMap$$anon$3() {
  /*<skip>*/
}
$h_sci_HashMap$HashTrieMap$$anon$3.prototype = $c_sci_HashMap$HashTrieMap$$anon$3.prototype;
$c_sci_HashMap$HashTrieMap$$anon$3.prototype.getElem__O__O = (function(x) {
  return $as_sci_HashMap$HashMap1(x).ensurePair__T2()
});
$c_sci_HashMap$HashTrieMap$$anon$3.prototype.init___sci_HashMap$HashTrieMap = (function($$outer) {
  $c_sci_TrieIterator.prototype.init___Asci_Iterable.call(this, $$outer.elems$6);
  return this
});
var $d_sci_HashMap$HashTrieMap$$anon$3 = new $TypeData().initClass({
  sci_HashMap$HashTrieMap$$anon$3: 0
}, false, "scala.collection.immutable.HashMap$HashTrieMap$$anon$3", {
  sci_HashMap$HashTrieMap$$anon$3: 1,
  sci_TrieIterator: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sci_HashMap$HashTrieMap$$anon$3.prototype.$classData = $d_sci_HashMap$HashTrieMap$$anon$3;
/** @constructor */
function $c_sci_HashSet$HashTrieSet$$anon$1() {
  $c_sci_TrieIterator.call(this)
}
$c_sci_HashSet$HashTrieSet$$anon$1.prototype = new $h_sci_TrieIterator();
$c_sci_HashSet$HashTrieSet$$anon$1.prototype.constructor = $c_sci_HashSet$HashTrieSet$$anon$1;
/** @constructor */
function $h_sci_HashSet$HashTrieSet$$anon$1() {
  /*<skip>*/
}
$h_sci_HashSet$HashTrieSet$$anon$1.prototype = $c_sci_HashSet$HashTrieSet$$anon$1.prototype;
$c_sci_HashSet$HashTrieSet$$anon$1.prototype.init___sci_HashSet$HashTrieSet = (function($$outer) {
  $c_sci_TrieIterator.prototype.init___Asci_Iterable.call(this, $$outer.elems$5);
  return this
});
$c_sci_HashSet$HashTrieSet$$anon$1.prototype.getElem__O__O = (function(cc) {
  return $as_sci_HashSet$HashSet1(cc).key$6
});
var $d_sci_HashSet$HashTrieSet$$anon$1 = new $TypeData().initClass({
  sci_HashSet$HashTrieSet$$anon$1: 0
}, false, "scala.collection.immutable.HashSet$HashTrieSet$$anon$1", {
  sci_HashSet$HashTrieSet$$anon$1: 1,
  sci_TrieIterator: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1
});
$c_sci_HashSet$HashTrieSet$$anon$1.prototype.$classData = $d_sci_HashSet$HashTrieSet$$anon$1;
/** @constructor */
function $c_sci_ListMap$() {
  $c_scg_ImmutableMapFactory.call(this)
}
$c_sci_ListMap$.prototype = new $h_scg_ImmutableMapFactory();
$c_sci_ListMap$.prototype.constructor = $c_sci_ListMap$;
/** @constructor */
function $h_sci_ListMap$() {
  /*<skip>*/
}
$h_sci_ListMap$.prototype = $c_sci_ListMap$.prototype;
$c_sci_ListMap$.prototype.init___ = (function() {
  return this
});
$c_sci_ListMap$.prototype.empty__sc_GenMap = (function() {
  return $m_sci_ListMap$EmptyListMap$()
});
var $d_sci_ListMap$ = new $TypeData().initClass({
  sci_ListMap$: 0
}, false, "scala.collection.immutable.ListMap$", {
  sci_ListMap$: 1,
  scg_ImmutableMapFactory: 1,
  scg_MapFactory: 1,
  scg_GenMapFactory: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_ListMap$.prototype.$classData = $d_sci_ListMap$;
var $n_sci_ListMap$ = (void 0);
function $m_sci_ListMap$() {
  if ((!$n_sci_ListMap$)) {
    $n_sci_ListMap$ = new $c_sci_ListMap$().init___()
  };
  return $n_sci_ListMap$
}
/** @constructor */
function $c_sci_Set$() {
  $c_scg_ImmutableSetFactory.call(this)
}
$c_sci_Set$.prototype = new $h_scg_ImmutableSetFactory();
$c_sci_Set$.prototype.constructor = $c_sci_Set$;
/** @constructor */
function $h_sci_Set$() {
  /*<skip>*/
}
$h_sci_Set$.prototype = $c_sci_Set$.prototype;
$c_sci_Set$.prototype.init___ = (function() {
  return this
});
$c_sci_Set$.prototype.emptyInstance__sci_Set = (function() {
  return $m_sci_Set$EmptySet$()
});
var $d_sci_Set$ = new $TypeData().initClass({
  sci_Set$: 0
}, false, "scala.collection.immutable.Set$", {
  sci_Set$: 1,
  scg_ImmutableSetFactory: 1,
  scg_SetFactory: 1,
  scg_GenSetFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_GenericSeqCompanion: 1
});
$c_sci_Set$.prototype.$classData = $d_sci_Set$;
var $n_sci_Set$ = (void 0);
function $m_sci_Set$() {
  if ((!$n_sci_Set$)) {
    $n_sci_Set$ = new $c_sci_Set$().init___()
  };
  return $n_sci_Set$
}
/** @constructor */
function $c_sci_Stream$StreamBuilder() {
  $c_scm_LazyBuilder.call(this)
}
$c_sci_Stream$StreamBuilder.prototype = new $h_scm_LazyBuilder();
$c_sci_Stream$StreamBuilder.prototype.constructor = $c_sci_Stream$StreamBuilder;
/** @constructor */
function $h_sci_Stream$StreamBuilder() {
  /*<skip>*/
}
$h_sci_Stream$StreamBuilder.prototype = $c_sci_Stream$StreamBuilder.prototype;
$c_sci_Stream$StreamBuilder.prototype.init___ = (function() {
  $c_scm_LazyBuilder.prototype.init___.call(this);
  return this
});
$c_sci_Stream$StreamBuilder.prototype.result__O = (function() {
  return this.result__sci_Stream()
});
$c_sci_Stream$StreamBuilder.prototype.result__sci_Stream = (function() {
  var this$1 = this.parts$1;
  return $as_sci_Stream(this$1.scala$collection$mutable$ListBuffer$$start$6.toStream__sci_Stream().flatMap__F1__scg_CanBuildFrom__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$5$2) {
      var x$5 = $as_sc_TraversableOnce(x$5$2);
      return x$5.toStream__sci_Stream()
    })
  })(this)), ($m_sci_Stream$(), new $c_sci_Stream$StreamCanBuildFrom().init___())))
});
function $as_sci_Stream$StreamBuilder(obj) {
  return (((obj instanceof $c_sci_Stream$StreamBuilder) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.Stream$StreamBuilder"))
}
function $isArrayOf_sci_Stream$StreamBuilder(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_Stream$StreamBuilder)))
}
function $asArrayOf_sci_Stream$StreamBuilder(obj, depth) {
  return (($isArrayOf_sci_Stream$StreamBuilder(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.Stream$StreamBuilder;", depth))
}
var $d_sci_Stream$StreamBuilder = new $TypeData().initClass({
  sci_Stream$StreamBuilder: 0
}, false, "scala.collection.immutable.Stream$StreamBuilder", {
  sci_Stream$StreamBuilder: 1,
  scm_LazyBuilder: 1,
  O: 1,
  scm_ReusableBuilder: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1
});
$c_sci_Stream$StreamBuilder.prototype.$classData = $d_sci_Stream$StreamBuilder;
/** @constructor */
function $c_sci_VectorBuilder() {
  $c_O.call(this);
  this.blockIndex$1 = 0;
  this.lo$1 = 0;
  this.depth$1 = 0;
  this.display0$1 = null;
  this.display1$1 = null;
  this.display2$1 = null;
  this.display3$1 = null;
  this.display4$1 = null;
  this.display5$1 = null
}
$c_sci_VectorBuilder.prototype = new $h_O();
$c_sci_VectorBuilder.prototype.constructor = $c_sci_VectorBuilder;
/** @constructor */
function $h_sci_VectorBuilder() {
  /*<skip>*/
}
$h_sci_VectorBuilder.prototype = $c_sci_VectorBuilder.prototype;
$c_sci_VectorBuilder.prototype.display3__AO = (function() {
  return this.display3$1
});
$c_sci_VectorBuilder.prototype.init___ = (function() {
  this.display0$1 = $newArrayObject($d_O.getArrayOf(), [32]);
  this.depth$1 = 1;
  this.blockIndex$1 = 0;
  this.lo$1 = 0;
  return this
});
$c_sci_VectorBuilder.prototype.depth__I = (function() {
  return this.depth$1
});
$c_sci_VectorBuilder.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__O__sci_VectorBuilder(elem)
});
$c_sci_VectorBuilder.prototype.display5$und$eq__AO__V = (function(x$1) {
  this.display5$1 = x$1
});
$c_sci_VectorBuilder.prototype.display0__AO = (function() {
  return this.display0$1
});
$c_sci_VectorBuilder.prototype.display2$und$eq__AO__V = (function(x$1) {
  this.display2$1 = x$1
});
$c_sci_VectorBuilder.prototype.display4__AO = (function() {
  return this.display4$1
});
$c_sci_VectorBuilder.prototype.$$plus$eq__O__sci_VectorBuilder = (function(elem) {
  if ((this.lo$1 >= this.display0$1.u.length)) {
    var newBlockIndex = ((32 + this.blockIndex$1) | 0);
    var xor = (this.blockIndex$1 ^ newBlockIndex);
    $f_sci_VectorPointer__gotoNextBlockStartWritable__I__I__V(this, newBlockIndex, xor);
    this.blockIndex$1 = newBlockIndex;
    this.lo$1 = 0
  };
  this.display0$1.set(this.lo$1, elem);
  this.lo$1 = ((1 + this.lo$1) | 0);
  return this
});
$c_sci_VectorBuilder.prototype.result__O = (function() {
  return this.result__sci_Vector()
});
$c_sci_VectorBuilder.prototype.sizeHintBounded__I__sc_TraversableLike__V = (function(size, boundingColl) {
  $f_scm_Builder__sizeHintBounded__I__sc_TraversableLike__V(this, size, boundingColl)
});
$c_sci_VectorBuilder.prototype.display1$und$eq__AO__V = (function(x$1) {
  this.display1$1 = x$1
});
$c_sci_VectorBuilder.prototype.display4$und$eq__AO__V = (function(x$1) {
  this.display4$1 = x$1
});
$c_sci_VectorBuilder.prototype.display1__AO = (function() {
  return this.display1$1
});
$c_sci_VectorBuilder.prototype.display5__AO = (function() {
  return this.display5$1
});
$c_sci_VectorBuilder.prototype.result__sci_Vector = (function() {
  var size = ((this.blockIndex$1 + this.lo$1) | 0);
  if ((size === 0)) {
    var this$1 = $m_sci_Vector$();
    return this$1.NIL$6
  };
  var s = new $c_sci_Vector().init___I__I__I(0, size, 0);
  var depth = this.depth$1;
  $f_sci_VectorPointer__initFrom__sci_VectorPointer__I__V(s, this, depth);
  if ((this.depth$1 > 1)) {
    var xor = (((-1) + size) | 0);
    $f_sci_VectorPointer__gotoPos__I__I__V(s, 0, xor)
  };
  return s
});
$c_sci_VectorBuilder.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__O__sci_VectorBuilder(elem)
});
$c_sci_VectorBuilder.prototype.sizeHint__I__V = (function(size) {
  /*<skip>*/
});
$c_sci_VectorBuilder.prototype.depth$und$eq__I__V = (function(x$1) {
  this.depth$1 = x$1
});
$c_sci_VectorBuilder.prototype.display2__AO = (function() {
  return this.display2$1
});
$c_sci_VectorBuilder.prototype.display0$und$eq__AO__V = (function(x$1) {
  this.display0$1 = x$1
});
$c_sci_VectorBuilder.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return $as_sci_VectorBuilder($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs))
});
$c_sci_VectorBuilder.prototype.display3$und$eq__AO__V = (function(x$1) {
  this.display3$1 = x$1
});
function $as_sci_VectorBuilder(obj) {
  return (((obj instanceof $c_sci_VectorBuilder) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.VectorBuilder"))
}
function $isArrayOf_sci_VectorBuilder(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_VectorBuilder)))
}
function $asArrayOf_sci_VectorBuilder(obj, depth) {
  return (($isArrayOf_sci_VectorBuilder(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.VectorBuilder;", depth))
}
var $d_sci_VectorBuilder = new $TypeData().initClass({
  sci_VectorBuilder: 0
}, false, "scala.collection.immutable.VectorBuilder", {
  sci_VectorBuilder: 1,
  O: 1,
  scm_ReusableBuilder: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  sci_VectorPointer: 1
});
$c_sci_VectorBuilder.prototype.$classData = $d_sci_VectorBuilder;
/** @constructor */
function $c_sci_VectorIterator() {
  $c_sc_AbstractIterator.call(this);
  this.endIndex$2 = 0;
  this.blockIndex$2 = 0;
  this.lo$2 = 0;
  this.endLo$2 = 0;
  this.$$undhasNext$2 = false;
  this.depth$2 = 0;
  this.display0$2 = null;
  this.display1$2 = null;
  this.display2$2 = null;
  this.display3$2 = null;
  this.display4$2 = null;
  this.display5$2 = null
}
$c_sci_VectorIterator.prototype = new $h_sc_AbstractIterator();
$c_sci_VectorIterator.prototype.constructor = $c_sci_VectorIterator;
/** @constructor */
function $h_sci_VectorIterator() {
  /*<skip>*/
}
$h_sci_VectorIterator.prototype = $c_sci_VectorIterator.prototype;
$c_sci_VectorIterator.prototype.next__O = (function() {
  if ((!this.$$undhasNext$2)) {
    throw new $c_ju_NoSuchElementException().init___T("reached iterator end")
  };
  var res = this.display0$2.get(this.lo$2);
  this.lo$2 = ((1 + this.lo$2) | 0);
  if ((this.lo$2 === this.endLo$2)) {
    if ((((this.blockIndex$2 + this.lo$2) | 0) < this.endIndex$2)) {
      var newBlockIndex = ((32 + this.blockIndex$2) | 0);
      var xor = (this.blockIndex$2 ^ newBlockIndex);
      $f_sci_VectorPointer__gotoNextBlockStart__I__I__V(this, newBlockIndex, xor);
      this.blockIndex$2 = newBlockIndex;
      var x = ((this.endIndex$2 - this.blockIndex$2) | 0);
      this.endLo$2 = ((x < 32) ? x : 32);
      this.lo$2 = 0
    } else {
      this.$$undhasNext$2 = false
    }
  };
  return res
});
$c_sci_VectorIterator.prototype.display3__AO = (function() {
  return this.display3$2
});
$c_sci_VectorIterator.prototype.depth__I = (function() {
  return this.depth$2
});
$c_sci_VectorIterator.prototype.display5$und$eq__AO__V = (function(x$1) {
  this.display5$2 = x$1
});
$c_sci_VectorIterator.prototype.init___I__I = (function(_startIndex, endIndex) {
  this.endIndex$2 = endIndex;
  this.blockIndex$2 = ((-32) & _startIndex);
  this.lo$2 = (31 & _startIndex);
  var x = ((endIndex - this.blockIndex$2) | 0);
  this.endLo$2 = ((x < 32) ? x : 32);
  this.$$undhasNext$2 = (((this.blockIndex$2 + this.lo$2) | 0) < endIndex);
  return this
});
$c_sci_VectorIterator.prototype.display0__AO = (function() {
  return this.display0$2
});
$c_sci_VectorIterator.prototype.display2$und$eq__AO__V = (function(x$1) {
  this.display2$2 = x$1
});
$c_sci_VectorIterator.prototype.display4__AO = (function() {
  return this.display4$2
});
$c_sci_VectorIterator.prototype.display1$und$eq__AO__V = (function(x$1) {
  this.display1$2 = x$1
});
$c_sci_VectorIterator.prototype.hasNext__Z = (function() {
  return this.$$undhasNext$2
});
$c_sci_VectorIterator.prototype.display4$und$eq__AO__V = (function(x$1) {
  this.display4$2 = x$1
});
$c_sci_VectorIterator.prototype.display1__AO = (function() {
  return this.display1$2
});
$c_sci_VectorIterator.prototype.display5__AO = (function() {
  return this.display5$2
});
$c_sci_VectorIterator.prototype.depth$und$eq__I__V = (function(x$1) {
  this.depth$2 = x$1
});
$c_sci_VectorIterator.prototype.display2__AO = (function() {
  return this.display2$2
});
$c_sci_VectorIterator.prototype.display0$und$eq__AO__V = (function(x$1) {
  this.display0$2 = x$1
});
$c_sci_VectorIterator.prototype.display3$und$eq__AO__V = (function(x$1) {
  this.display3$2 = x$1
});
var $d_sci_VectorIterator = new $TypeData().initClass({
  sci_VectorIterator: 0
}, false, "scala.collection.immutable.VectorIterator", {
  sci_VectorIterator: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sci_VectorPointer: 1
});
$c_sci_VectorIterator.prototype.$classData = $d_sci_VectorIterator;
/** @constructor */
function $c_scm_HashMap$() {
  $c_scg_MutableMapFactory.call(this)
}
$c_scm_HashMap$.prototype = new $h_scg_MutableMapFactory();
$c_scm_HashMap$.prototype.constructor = $c_scm_HashMap$;
/** @constructor */
function $h_scm_HashMap$() {
  /*<skip>*/
}
$h_scm_HashMap$.prototype = $c_scm_HashMap$.prototype;
$c_scm_HashMap$.prototype.init___ = (function() {
  return this
});
$c_scm_HashMap$.prototype.empty__sc_Map = (function() {
  return new $c_scm_HashMap().init___()
});
$c_scm_HashMap$.prototype.empty__sc_GenMap = (function() {
  return new $c_scm_HashMap().init___()
});
var $d_scm_HashMap$ = new $TypeData().initClass({
  scm_HashMap$: 0
}, false, "scala.collection.mutable.HashMap$", {
  scm_HashMap$: 1,
  scg_MutableMapFactory: 1,
  scg_MapFactory: 1,
  scg_GenMapFactory: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_HashMap$.prototype.$classData = $d_scm_HashMap$;
var $n_scm_HashMap$ = (void 0);
function $m_scm_HashMap$() {
  if ((!$n_scm_HashMap$)) {
    $n_scm_HashMap$ = new $c_scm_HashMap$().init___()
  };
  return $n_scm_HashMap$
}
/** @constructor */
function $c_scm_LinkedHashMap$() {
  $c_scg_MutableMapFactory.call(this)
}
$c_scm_LinkedHashMap$.prototype = new $h_scg_MutableMapFactory();
$c_scm_LinkedHashMap$.prototype.constructor = $c_scm_LinkedHashMap$;
/** @constructor */
function $h_scm_LinkedHashMap$() {
  /*<skip>*/
}
$h_scm_LinkedHashMap$.prototype = $c_scm_LinkedHashMap$.prototype;
$c_scm_LinkedHashMap$.prototype.init___ = (function() {
  return this
});
$c_scm_LinkedHashMap$.prototype.empty__sc_Map = (function() {
  return new $c_scm_LinkedHashMap().init___()
});
$c_scm_LinkedHashMap$.prototype.empty__sc_GenMap = (function() {
  return new $c_scm_LinkedHashMap().init___()
});
var $d_scm_LinkedHashMap$ = new $TypeData().initClass({
  scm_LinkedHashMap$: 0
}, false, "scala.collection.mutable.LinkedHashMap$", {
  scm_LinkedHashMap$: 1,
  scg_MutableMapFactory: 1,
  scg_MapFactory: 1,
  scg_GenMapFactory: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_LinkedHashMap$.prototype.$classData = $d_scm_LinkedHashMap$;
var $n_scm_LinkedHashMap$ = (void 0);
function $m_scm_LinkedHashMap$() {
  if ((!$n_scm_LinkedHashMap$)) {
    $n_scm_LinkedHashMap$ = new $c_scm_LinkedHashMap$().init___()
  };
  return $n_scm_LinkedHashMap$
}
/** @constructor */
function $c_scm_ListMap$() {
  $c_scg_MutableMapFactory.call(this)
}
$c_scm_ListMap$.prototype = new $h_scg_MutableMapFactory();
$c_scm_ListMap$.prototype.constructor = $c_scm_ListMap$;
/** @constructor */
function $h_scm_ListMap$() {
  /*<skip>*/
}
$h_scm_ListMap$.prototype = $c_scm_ListMap$.prototype;
$c_scm_ListMap$.prototype.init___ = (function() {
  return this
});
$c_scm_ListMap$.prototype.empty__sc_Map = (function() {
  return new $c_scm_ListMap().init___()
});
$c_scm_ListMap$.prototype.empty__sc_GenMap = (function() {
  return new $c_scm_ListMap().init___()
});
var $d_scm_ListMap$ = new $TypeData().initClass({
  scm_ListMap$: 0
}, false, "scala.collection.mutable.ListMap$", {
  scm_ListMap$: 1,
  scg_MutableMapFactory: 1,
  scg_MapFactory: 1,
  scg_GenMapFactory: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_ListMap$.prototype.$classData = $d_scm_ListMap$;
var $n_scm_ListMap$ = (void 0);
function $m_scm_ListMap$() {
  if ((!$n_scm_ListMap$)) {
    $n_scm_ListMap$ = new $c_scm_ListMap$().init___()
  };
  return $n_scm_ListMap$
}
/** @constructor */
function $c_scm_Set$() {
  $c_scg_MutableSetFactory.call(this)
}
$c_scm_Set$.prototype = new $h_scg_MutableSetFactory();
$c_scm_Set$.prototype.constructor = $c_scm_Set$;
/** @constructor */
function $h_scm_Set$() {
  /*<skip>*/
}
$h_scm_Set$.prototype = $c_scm_Set$.prototype;
$c_scm_Set$.prototype.init___ = (function() {
  return this
});
$c_scm_Set$.prototype.empty__sc_GenTraversable = (function() {
  return new $c_scm_HashSet().init___()
});
var $d_scm_Set$ = new $TypeData().initClass({
  scm_Set$: 0
}, false, "scala.collection.mutable.Set$", {
  scm_Set$: 1,
  scg_MutableSetFactory: 1,
  scg_SetFactory: 1,
  scg_GenSetFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_GenericSeqCompanion: 1
});
$c_scm_Set$.prototype.$classData = $d_scm_Set$;
var $n_scm_Set$ = (void 0);
function $m_scm_Set$() {
  if ((!$n_scm_Set$)) {
    $n_scm_Set$ = new $c_scm_Set$().init___()
  };
  return $n_scm_Set$
}
/** @constructor */
function $c_sjsr_UndefinedBehaviorError() {
  $c_jl_Error.call(this)
}
$c_sjsr_UndefinedBehaviorError.prototype = new $h_jl_Error();
$c_sjsr_UndefinedBehaviorError.prototype.constructor = $c_sjsr_UndefinedBehaviorError;
/** @constructor */
function $h_sjsr_UndefinedBehaviorError() {
  /*<skip>*/
}
$h_sjsr_UndefinedBehaviorError.prototype = $c_sjsr_UndefinedBehaviorError.prototype;
$c_sjsr_UndefinedBehaviorError.prototype.fillInStackTrace__jl_Throwable = (function() {
  return $c_jl_Throwable.prototype.fillInStackTrace__jl_Throwable.call(this)
});
$c_sjsr_UndefinedBehaviorError.prototype.init___jl_Throwable = (function(cause) {
  $c_sjsr_UndefinedBehaviorError.prototype.init___T__jl_Throwable.call(this, ("An undefined behavior was detected" + ((cause === null) ? "" : (": " + cause.getMessage__T()))), cause);
  return this
});
$c_sjsr_UndefinedBehaviorError.prototype.init___T__jl_Throwable = (function(message, cause) {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, message, cause, true, true);
  return this
});
var $d_sjsr_UndefinedBehaviorError = new $TypeData().initClass({
  sjsr_UndefinedBehaviorError: 0
}, false, "scala.scalajs.runtime.UndefinedBehaviorError", {
  sjsr_UndefinedBehaviorError: 1,
  jl_Error: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  s_util_control_ControlThrowable: 1,
  s_util_control_NoStackTrace: 1
});
$c_sjsr_UndefinedBehaviorError.prototype.$classData = $d_sjsr_UndefinedBehaviorError;
/** @constructor */
function $c_sr_NonLocalReturnControl$mcV$sp() {
  $c_sr_NonLocalReturnControl.call(this);
  this.value$mcV$sp$f = null
}
$c_sr_NonLocalReturnControl$mcV$sp.prototype = new $h_sr_NonLocalReturnControl();
$c_sr_NonLocalReturnControl$mcV$sp.prototype.constructor = $c_sr_NonLocalReturnControl$mcV$sp;
/** @constructor */
function $h_sr_NonLocalReturnControl$mcV$sp() {
  /*<skip>*/
}
$h_sr_NonLocalReturnControl$mcV$sp.prototype = $c_sr_NonLocalReturnControl$mcV$sp.prototype;
$c_sr_NonLocalReturnControl$mcV$sp.prototype.value__O = (function() {
  return (void 0)
});
$c_sr_NonLocalReturnControl$mcV$sp.prototype.value$mcV$sp__V = (function() {
  /*<skip>*/
});
$c_sr_NonLocalReturnControl$mcV$sp.prototype.init___O__sr_BoxedUnit = (function(key, value$mcV$sp) {
  this.value$mcV$sp$f = value$mcV$sp;
  $c_sr_NonLocalReturnControl.prototype.init___O__O.call(this, key, (void 0));
  return this
});
var $d_sr_NonLocalReturnControl$mcV$sp = new $TypeData().initClass({
  sr_NonLocalReturnControl$mcV$sp: 0
}, false, "scala.runtime.NonLocalReturnControl$mcV$sp", {
  sr_NonLocalReturnControl$mcV$sp: 1,
  sr_NonLocalReturnControl: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  s_util_control_ControlThrowable: 1,
  s_util_control_NoStackTrace: 1
});
$c_sr_NonLocalReturnControl$mcV$sp.prototype.$classData = $d_sr_NonLocalReturnControl$mcV$sp;
/** @constructor */
function $c_sr_NonLocalReturnControl$mcZ$sp() {
  $c_sr_NonLocalReturnControl.call(this);
  this.value$mcZ$sp$f = false
}
$c_sr_NonLocalReturnControl$mcZ$sp.prototype = new $h_sr_NonLocalReturnControl();
$c_sr_NonLocalReturnControl$mcZ$sp.prototype.constructor = $c_sr_NonLocalReturnControl$mcZ$sp;
/** @constructor */
function $h_sr_NonLocalReturnControl$mcZ$sp() {
  /*<skip>*/
}
$h_sr_NonLocalReturnControl$mcZ$sp.prototype = $c_sr_NonLocalReturnControl$mcZ$sp.prototype;
$c_sr_NonLocalReturnControl$mcZ$sp.prototype.value__O = (function() {
  return this.value$mcZ$sp$f
});
$c_sr_NonLocalReturnControl$mcZ$sp.prototype.init___O__Z = (function(key, value$mcZ$sp) {
  this.value$mcZ$sp$f = value$mcZ$sp;
  $c_sr_NonLocalReturnControl.prototype.init___O__O.call(this, key, null);
  return this
});
$c_sr_NonLocalReturnControl$mcZ$sp.prototype.value$mcZ$sp__Z = (function() {
  return this.value$mcZ$sp$f
});
var $d_sr_NonLocalReturnControl$mcZ$sp = new $TypeData().initClass({
  sr_NonLocalReturnControl$mcZ$sp: 0
}, false, "scala.runtime.NonLocalReturnControl$mcZ$sp", {
  sr_NonLocalReturnControl$mcZ$sp: 1,
  sr_NonLocalReturnControl: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  s_util_control_ControlThrowable: 1,
  s_util_control_NoStackTrace: 1
});
$c_sr_NonLocalReturnControl$mcZ$sp.prototype.$classData = $d_sr_NonLocalReturnControl$mcZ$sp;
/** @constructor */
function $c_Lamf_client_model_document_DialectInstance() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_document_DialectInstance.prototype = new $h_O();
$c_Lamf_client_model_document_DialectInstance.prototype.constructor = $c_Lamf_client_model_document_DialectInstance;
/** @constructor */
function $h_Lamf_client_model_document_DialectInstance() {
  /*<skip>*/
}
$h_Lamf_client_model_document_DialectInstance.prototype = $c_Lamf_client_model_document_DialectInstance.prototype;
$c_Lamf_client_model_document_DialectInstance.prototype.init___Lamf_plugins_document_vocabularies_model_document_DialectInstance = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_document_DialectInstance.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_document_DialectInstance.prototype.init___Lamf_plugins_document_vocabularies_model_document_DialectInstance.call(this, new $c_Lamf_plugins_document_vocabularies_model_document_DialectInstance().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$withRaw__T__O = (function(raw) {
  return $f_Lamf_client_model_document_BaseUnit__withRaw__T__Lamf_client_model_document_BaseUnit(this, raw)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$findById__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__findById__T__sjs_js_UndefOr(this, id)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$withReferences__sjs_js_Array__O = (function(references) {
  return $f_Lamf_client_model_document_BaseUnit__withReferences__sjs_js_Array__Lamf_client_model_document_BaseUnit(this, references)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$references__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__references__sjs_js_Array(this)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$withEncodes__Lamf_client_model_domain_DialectDomainElement__O = (function(encoded) {
  return this.withEncodes__Lamf_client_model_domain_DialectDomainElement__Lamf_client_model_document_DialectInstance(encoded)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$prop$modelVersion__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__modelVersion__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$definedBy__O = (function() {
  return this.definedBy__Lamf_client_model_StrField()
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$prop$location__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__location__T(this)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_DialectInstance.prototype.withEncodes__Lamf_client_model_domain_DialectDomainElement__Lamf_client_model_document_DialectInstance = (function(encoded) {
  var this$1 = this.$$undinternal$1;
  var encoded$1 = encoded.$$undinternal$1;
  var field = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
  $as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$1, field, encoded$1));
  return this
});
$c_Lamf_client_model_document_DialectInstance.prototype.encodes__Lamf_client_model_domain_DialectDomainElement = (function() {
  var this$1 = this.$$undinternal$1;
  return new $c_Lamf_client_model_domain_DialectDomainElement().init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_Lamf_core_model_domain_DomainElement(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().Encodes$1))))
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$withDeclares__sjs_js_Array__O = (function(declares) {
  return $f_Lamf_client_model_document_DeclaresModel__withDeclares__sjs_js_Array__Lamf_client_model_document_DeclaresModel(this, declares)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$undinternal__Lamf_core_model_document_EncodesModel = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$prop$encodes__O = (function() {
  return this.encodes__Lamf_client_model_domain_DialectDomainElement()
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__withId__T__Lamf_client_model_document_BaseUnit(this, id)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$cloneUnit__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__cloneUnit__Lamf_client_model_document_BaseUnit(this)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$graphDependencies__O = (function() {
  return this.graphDependencies__sjs_js_Array()
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$withEncodes__Lamf_client_model_domain_DomainElement__O = (function(encoded) {
  return $f_Lamf_client_model_document_EncodesModel__withEncodes__Lamf_client_model_domain_DomainElement__Lamf_client_model_document_EncodesModel(this, encoded)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$findByType__T__O = (function(typeId) {
  return $f_Lamf_client_model_document_BaseUnit__findByType__T__sjs_js_Array(this, typeId)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$withLocation__T__O = (function(location) {
  return $f_Lamf_client_model_document_BaseUnit__withLocation__T__Lamf_client_model_document_BaseUnit(this, location)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$prop$raw__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__raw__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_DialectInstance.prototype.definedBy__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().DefinedBy$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$undinternal__Lamf_core_model_document_DeclaresModel = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_DialectInstance.prototype.withGraphDependencies__sjs_js_Array__Lamf_client_model_document_DialectInstance = (function(ids) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  var ids$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, ids, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().GraphDependencies$1;
  $as_Lamf_plugins_document_vocabularies_model_document_DialectInstance($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, ids$1));
  return this
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$withGraphDependencies__sjs_js_Array__O = (function(ids) {
  return this.withGraphDependencies__sjs_js_Array__Lamf_client_model_document_DialectInstance(ids)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$withDefinedBy__T__O = (function(dialectId) {
  return this.withDefinedBy__T__Lamf_client_model_document_DialectInstance(dialectId)
});
$c_Lamf_client_model_document_DialectInstance.prototype.withDefinedBy__T__Lamf_client_model_document_DialectInstance = (function(dialectId) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().DefinedBy$1;
  $as_Lamf_plugins_document_vocabularies_model_document_DialectInstance($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, dialectId));
  return this
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O = (function(renderOptions) {
  return $f_Lamf_client_model_document_BaseUnit__toNativeRdfModel__Lamf_client_render_RenderOptions__Lamf_core_rdf_RdfModel(this, renderOptions)
});
$c_Lamf_client_model_document_DialectInstance.prototype.withExternals__sjs_js_Array__Lamf_client_model_document_DialectInstance = (function(externals) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().ExternalConverter__Lamf_client_convert_ExternalConverter$ExternalConverter$();
  var externals$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, externals, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$().Externals$1;
  $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, externals$1);
  return this
});
$c_Lamf_client_model_document_DialectInstance.prototype.graphDependencies__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().GraphDependencies$1));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions = (function() {
  return new $c_Lamf_client_render_RenderOptions().init___()
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$withUsage__T__O = (function(usage) {
  return $f_Lamf_client_model_document_BaseUnit__withUsage__T__Lamf_client_model_document_BaseUnit(this, usage)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$withReferenceAlias__T__T__T__O = (function(alias, fullUrl, relativeUrl) {
  return $f_Lamf_client_model_document_BaseUnit__withReferenceAlias__T__T__T__Lamf_client_model_document_BaseUnit(this, alias, fullUrl, relativeUrl)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$withExternals__sjs_js_Array__O = (function(externals) {
  return this.withExternals__sjs_js_Array__Lamf_client_model_document_DialectInstance(externals)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$prop$declares__O = (function() {
  return $f_Lamf_client_model_document_DeclaresModel__declares__sjs_js_Array(this)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$meth$withDeclaredElement__Lamf_client_model_domain_DomainElement__O = (function(declared) {
  return $f_Lamf_client_model_document_DeclaresModel__withDeclaredElement__Lamf_client_model_domain_DomainElement__Lamf_client_model_document_DeclaresModel(this, declared)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$prop$sourceVendor__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__sourceVendor__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$prop$usage__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__usage__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_DialectInstance.prototype.$$js$exported$prop$externals__O = (function() {
  return this.externals__sjs_js_Array()
});
$c_Lamf_client_model_document_DialectInstance.prototype.externals__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(this$1);
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().ExternalConverter__Lamf_client_convert_ExternalConverter$ExternalConverter$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_document_DialectInstance.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_document_DialectInstance.prototype.withReferenceAlias = (function(arg, arg$2, arg$3) {
  var prep = $as_T(arg);
  var prep$2 = $as_T(arg$2);
  var prep$3 = $as_T(arg$3);
  return this.$$js$exported$meth$withReferenceAlias__T__T__T__O(prep, prep$2, prep$3)
});
$c_Lamf_client_model_document_DialectInstance.prototype.cloneUnit = (function() {
  return this.$$js$exported$meth$cloneUnit__O()
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstance.prototype, "sourceVendor", {
  "get": (function() {
    return this.$$js$exported$prop$sourceVendor__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectInstance.prototype.findByType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findByType__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstance.prototype.findById = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findById__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstance.prototype.toNativeRdfModel = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions() : $as_Lamf_client_render_RenderOptions(rest[0]));
  return this.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O(prep)
});
$c_Lamf_client_model_document_DialectInstance.prototype.withUsage = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withUsage__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstance.prototype.withLocation = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLocation__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstance.prototype.withRaw = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withRaw__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstance.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstance.prototype.withReferences = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withReferences__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstance.prototype, "modelVersion", {
  "get": (function() {
    return this.$$js$exported$prop$modelVersion__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstance.prototype, "usage", {
  "get": (function() {
    return this.$$js$exported$prop$usage__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstance.prototype, "location", {
  "get": (function() {
    return this.$$js$exported$prop$location__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstance.prototype, "raw", {
  "get": (function() {
    return this.$$js$exported$prop$raw__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectInstance.prototype.references = (function() {
  return this.$$js$exported$meth$references__O()
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstance.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectInstance.prototype.withEncodes = (function(arg) {
  if ((arg instanceof $c_Lamf_client_model_domain_DialectDomainElement)) {
    var prep$2 = $as_Lamf_client_model_domain_DialectDomainElement(arg);
    return this.$$js$exported$meth$withEncodes__Lamf_client_model_domain_DialectDomainElement__O(prep$2)
  } else if ($is_Lamf_client_model_domain_DomainElement(arg)) {
    var prep = $as_Lamf_client_model_domain_DomainElement(arg);
    return this.$$js$exported$meth$withEncodes__Lamf_client_model_domain_DomainElement__O(prep)
  } else {
    throw "No matching overload"
  }
});
$c_Lamf_client_model_document_DialectInstance.prototype.withDeclares = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withDeclares__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_document_DialectInstance.prototype.withDeclaredElement = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withDeclaredElement__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstance.prototype, "declares", {
  "get": (function() {
    return this.$$js$exported$prop$declares__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectInstance.prototype.withExternals = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExternals__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_document_DialectInstance.prototype.withGraphDependencies = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withGraphDependencies__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_document_DialectInstance.prototype.withDefinedBy = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDefinedBy__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstance.prototype, "encodes", {
  "get": (function() {
    return this.$$js$exported$prop$encodes__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstance.prototype, "externals", {
  "get": (function() {
    return this.$$js$exported$prop$externals__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectInstance.prototype.graphDependencies = (function() {
  return this.$$js$exported$meth$graphDependencies__O()
});
$c_Lamf_client_model_document_DialectInstance.prototype.definedBy = (function() {
  return this.$$js$exported$meth$definedBy__O()
});
var $d_Lamf_client_model_document_DialectInstance = new $TypeData().initClass({
  Lamf_client_model_document_DialectInstance: 0
}, false, "amf.client.model.document.DialectInstance", {
  Lamf_client_model_document_DialectInstance: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_EncodesModel: 1,
  Lamf_client_model_document_DeclaresModel: 1
});
$c_Lamf_client_model_document_DialectInstance.prototype.$classData = $d_Lamf_client_model_document_DialectInstance;
/** @constructor */
function $c_Lamf_client_model_document_DialectInstancePatch() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_document_DialectInstancePatch.prototype = new $h_O();
$c_Lamf_client_model_document_DialectInstancePatch.prototype.constructor = $c_Lamf_client_model_document_DialectInstancePatch;
/** @constructor */
function $h_Lamf_client_model_document_DialectInstancePatch() {
  /*<skip>*/
}
$h_Lamf_client_model_document_DialectInstancePatch.prototype = $c_Lamf_client_model_document_DialectInstancePatch.prototype;
$c_Lamf_client_model_document_DialectInstancePatch.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_document_DialectInstancePatch.prototype.init___Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.call(this, new $c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$meth$withRaw__T__O = (function(raw) {
  return $f_Lamf_client_model_document_BaseUnit__withRaw__T__Lamf_client_model_document_BaseUnit(this, raw)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$meth$findById__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__findById__T__sjs_js_UndefOr(this, id)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$meth$withReferences__sjs_js_Array__O = (function(references) {
  return $f_Lamf_client_model_document_BaseUnit__withReferences__sjs_js_Array__Lamf_client_model_document_BaseUnit(this, references)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$meth$references__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__references__sjs_js_Array(this)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$prop$modelVersion__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__modelVersion__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$prop$location__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__location__T(this)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.encodes__Lamf_client_model_domain_DialectDomainElement = (function() {
  var this$1 = this.$$undinternal$1;
  return new $c_Lamf_client_model_domain_DialectDomainElement().init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($as_Lamf_core_model_domain_DomainElement(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().Encodes$1))))
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$meth$withDeclares__sjs_js_Array__O = (function(declares) {
  return $f_Lamf_client_model_document_DeclaresModel__withDeclares__sjs_js_Array__Lamf_client_model_document_DeclaresModel(this, declares)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$undinternal__Lamf_core_model_document_EncodesModel = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$prop$encodes__O = (function() {
  return this.encodes__Lamf_client_model_domain_DialectDomainElement()
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__withId__T__Lamf_client_model_document_BaseUnit(this, id)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$meth$cloneUnit__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__cloneUnit__Lamf_client_model_document_BaseUnit(this)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$meth$withEncodes__Lamf_client_model_domain_DomainElement__O = (function(encoded) {
  return $f_Lamf_client_model_document_EncodesModel__withEncodes__Lamf_client_model_domain_DomainElement__Lamf_client_model_document_EncodesModel(this, encoded)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$meth$findByType__T__O = (function(typeId) {
  return $f_Lamf_client_model_document_BaseUnit__findByType__T__sjs_js_Array(this, typeId)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$meth$withLocation__T__O = (function(location) {
  return $f_Lamf_client_model_document_BaseUnit__withLocation__T__Lamf_client_model_document_BaseUnit(this, location)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$prop$raw__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__raw__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.init___Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$undinternal__Lamf_core_model_document_DeclaresModel = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O = (function(renderOptions) {
  return $f_Lamf_client_model_document_BaseUnit__toNativeRdfModel__Lamf_client_render_RenderOptions__Lamf_core_rdf_RdfModel(this, renderOptions)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions = (function() {
  return new $c_Lamf_client_render_RenderOptions().init___()
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$meth$withUsage__T__O = (function(usage) {
  return $f_Lamf_client_model_document_BaseUnit__withUsage__T__Lamf_client_model_document_BaseUnit(this, usage)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$meth$withReferenceAlias__T__T__T__O = (function(alias, fullUrl, relativeUrl) {
  return $f_Lamf_client_model_document_BaseUnit__withReferenceAlias__T__T__T__Lamf_client_model_document_BaseUnit(this, alias, fullUrl, relativeUrl)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$prop$declares__O = (function() {
  return $f_Lamf_client_model_document_DeclaresModel__declares__sjs_js_Array(this)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$meth$withDeclaredElement__Lamf_client_model_domain_DomainElement__O = (function(declared) {
  return $f_Lamf_client_model_document_DeclaresModel__withDeclaredElement__Lamf_client_model_domain_DomainElement__Lamf_client_model_document_DeclaresModel(this, declared)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$prop$sourceVendor__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__sourceVendor__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$$js$exported$prop$usage__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__usage__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.withReferenceAlias = (function(arg, arg$2, arg$3) {
  var prep = $as_T(arg);
  var prep$2 = $as_T(arg$2);
  var prep$3 = $as_T(arg$3);
  return this.$$js$exported$meth$withReferenceAlias__T__T__T__O(prep, prep$2, prep$3)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.cloneUnit = (function() {
  return this.$$js$exported$meth$cloneUnit__O()
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstancePatch.prototype, "sourceVendor", {
  "get": (function() {
    return this.$$js$exported$prop$sourceVendor__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.findByType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findByType__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.findById = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findById__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.toNativeRdfModel = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions() : $as_Lamf_client_render_RenderOptions(rest[0]));
  return this.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O(prep)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.withUsage = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withUsage__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.withLocation = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLocation__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.withRaw = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withRaw__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.withReferences = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withReferences__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstancePatch.prototype, "modelVersion", {
  "get": (function() {
    return this.$$js$exported$prop$modelVersion__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstancePatch.prototype, "usage", {
  "get": (function() {
    return this.$$js$exported$prop$usage__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstancePatch.prototype, "location", {
  "get": (function() {
    return this.$$js$exported$prop$location__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstancePatch.prototype, "raw", {
  "get": (function() {
    return this.$$js$exported$prop$raw__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.references = (function() {
  return this.$$js$exported$meth$references__O()
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstancePatch.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.withEncodes = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withEncodes__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstancePatch.prototype, "encodes", {
  "get": (function() {
    return this.$$js$exported$prop$encodes__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.withDeclares = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withDeclares__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.withDeclaredElement = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withDeclaredElement__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_DialectInstancePatch.prototype, "declares", {
  "get": (function() {
    return this.$$js$exported$prop$declares__O()
  }),
  "configurable": true
});
var $d_Lamf_client_model_document_DialectInstancePatch = new $TypeData().initClass({
  Lamf_client_model_document_DialectInstancePatch: 0
}, false, "amf.client.model.document.DialectInstancePatch", {
  Lamf_client_model_document_DialectInstancePatch: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_EncodesModel: 1,
  Lamf_client_model_document_DeclaresModel: 1
});
$c_Lamf_client_model_document_DialectInstancePatch.prototype.$classData = $d_Lamf_client_model_document_DialectInstancePatch;
/** @constructor */
function $c_Lamf_client_model_document_Document() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_document_Document.prototype = new $h_O();
$c_Lamf_client_model_document_Document.prototype.constructor = $c_Lamf_client_model_document_Document;
/** @constructor */
function $h_Lamf_client_model_document_Document() {
  /*<skip>*/
}
$h_Lamf_client_model_document_Document.prototype = $c_Lamf_client_model_document_Document.prototype;
$c_Lamf_client_model_document_Document.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_document_Document.prototype.init___Lamf_core_model_document_Document.call(this, new $c_Lamf_core_model_document_Document().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_document_Document.prototype.$$undinternal__Lamf_core_model_document_Document = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$meth$withRaw__T__O = (function(raw) {
  return $f_Lamf_client_model_document_BaseUnit__withRaw__T__Lamf_client_model_document_BaseUnit(this, raw)
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$meth$findById__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__findById__T__sjs_js_UndefOr(this, id)
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$meth$withReferences__sjs_js_Array__O = (function(references) {
  return $f_Lamf_client_model_document_BaseUnit__withReferences__sjs_js_Array__Lamf_client_model_document_BaseUnit(this, references)
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$meth$references__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__references__sjs_js_Array(this)
});
$c_Lamf_client_model_document_Document.prototype.init___Lamf_client_model_domain_DomainElement = (function(encoding) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$5 = new $c_Lamf_core_model_document_Document().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_client_convert_CoreClientConverters$();
  $m_Lamf_client_convert_CoreClientConverters$().DomainElementMatcher__Lamf_client_convert_DomainElementConverter$DomainElementMatcher$();
  var encoded = encoding.$$undinternal__Lamf_core_model_domain_DomainElement();
  var field = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
  $c_Lamf_client_model_document_Document.prototype.init___Lamf_core_model_document_Document.call(this, $as_Lamf_core_model_document_Document($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$5, field, encoded))));
  return this
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$prop$modelVersion__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__modelVersion__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$prop$location__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__location__T(this)
});
$c_Lamf_client_model_document_Document.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return this.$$undinternal__Lamf_core_model_document_Document()
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$meth$withDeclares__sjs_js_Array__O = (function(declares) {
  return $f_Lamf_client_model_document_DeclaresModel__withDeclares__sjs_js_Array__Lamf_client_model_document_DeclaresModel(this, declares)
});
$c_Lamf_client_model_document_Document.prototype.$$undinternal__Lamf_core_model_document_EncodesModel = (function() {
  return this.$$undinternal__Lamf_core_model_document_Document()
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$prop$encodes__O = (function() {
  return $f_Lamf_client_model_document_EncodesModel__encodes__Lamf_client_model_domain_DomainElement(this)
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__withId__T__Lamf_client_model_document_BaseUnit(this, id)
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$meth$cloneUnit__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__cloneUnit__Lamf_client_model_document_BaseUnit(this)
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$meth$withEncodes__Lamf_client_model_domain_DomainElement__O = (function(encoded) {
  return $f_Lamf_client_model_document_EncodesModel__withEncodes__Lamf_client_model_domain_DomainElement__Lamf_client_model_document_EncodesModel(this, encoded)
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$meth$findByType__T__O = (function(typeId) {
  return $f_Lamf_client_model_document_BaseUnit__findByType__T__sjs_js_Array(this, typeId)
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$meth$withLocation__T__O = (function(location) {
  return $f_Lamf_client_model_document_BaseUnit__withLocation__T__Lamf_client_model_document_BaseUnit(this, location)
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$prop$raw__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__raw__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_Document.prototype.$$undinternal__Lamf_core_model_document_DeclaresModel = (function() {
  return this.$$undinternal__Lamf_core_model_document_Document()
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O = (function(renderOptions) {
  return $f_Lamf_client_model_document_BaseUnit__toNativeRdfModel__Lamf_client_render_RenderOptions__Lamf_core_rdf_RdfModel(this, renderOptions)
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_document_Document.prototype.init___Lamf_core_model_document_Document = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions = (function() {
  return new $c_Lamf_client_render_RenderOptions().init___()
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$meth$withUsage__T__O = (function(usage) {
  return $f_Lamf_client_model_document_BaseUnit__withUsage__T__Lamf_client_model_document_BaseUnit(this, usage)
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal__Lamf_core_model_document_BaseUnit().id__T()
});
$c_Lamf_client_model_document_Document.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal__Lamf_core_model_document_Document()
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$meth$withReferenceAlias__T__T__T__O = (function(alias, fullUrl, relativeUrl) {
  return $f_Lamf_client_model_document_BaseUnit__withReferenceAlias__T__T__T__Lamf_client_model_document_BaseUnit(this, alias, fullUrl, relativeUrl)
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$prop$declares__O = (function() {
  return $f_Lamf_client_model_document_DeclaresModel__declares__sjs_js_Array(this)
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$meth$withDeclaredElement__Lamf_client_model_domain_DomainElement__O = (function(declared) {
  return $f_Lamf_client_model_document_DeclaresModel__withDeclaredElement__Lamf_client_model_domain_DomainElement__Lamf_client_model_document_DeclaresModel(this, declared)
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$prop$sourceVendor__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__sourceVendor__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_Document.prototype.$$js$exported$prop$usage__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__usage__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_Document.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_document_Document.prototype.withReferenceAlias = (function(arg, arg$2, arg$3) {
  var prep = $as_T(arg);
  var prep$2 = $as_T(arg$2);
  var prep$3 = $as_T(arg$3);
  return this.$$js$exported$meth$withReferenceAlias__T__T__T__O(prep, prep$2, prep$3)
});
$c_Lamf_client_model_document_Document.prototype.cloneUnit = (function() {
  return this.$$js$exported$meth$cloneUnit__O()
});
Object.defineProperty($c_Lamf_client_model_document_Document.prototype, "sourceVendor", {
  "get": (function() {
    return this.$$js$exported$prop$sourceVendor__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_Document.prototype.findByType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findByType__T__O(prep)
});
$c_Lamf_client_model_document_Document.prototype.findById = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findById__T__O(prep)
});
$c_Lamf_client_model_document_Document.prototype.toNativeRdfModel = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions() : $as_Lamf_client_render_RenderOptions(rest[0]));
  return this.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O(prep)
});
$c_Lamf_client_model_document_Document.prototype.withUsage = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withUsage__T__O(prep)
});
$c_Lamf_client_model_document_Document.prototype.withLocation = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLocation__T__O(prep)
});
$c_Lamf_client_model_document_Document.prototype.withRaw = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withRaw__T__O(prep)
});
$c_Lamf_client_model_document_Document.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_document_Document.prototype.withReferences = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withReferences__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_Document.prototype, "modelVersion", {
  "get": (function() {
    return this.$$js$exported$prop$modelVersion__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Document.prototype, "usage", {
  "get": (function() {
    return this.$$js$exported$prop$usage__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Document.prototype, "location", {
  "get": (function() {
    return this.$$js$exported$prop$location__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Document.prototype, "raw", {
  "get": (function() {
    return this.$$js$exported$prop$raw__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_Document.prototype.references = (function() {
  return this.$$js$exported$meth$references__O()
});
Object.defineProperty($c_Lamf_client_model_document_Document.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_Document.prototype.withEncodes = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withEncodes__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_Document.prototype, "encodes", {
  "get": (function() {
    return this.$$js$exported$prop$encodes__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_Document.prototype.withDeclares = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withDeclares__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_document_Document.prototype.withDeclaredElement = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withDeclaredElement__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_Document.prototype, "declares", {
  "get": (function() {
    return this.$$js$exported$prop$declares__O()
  }),
  "configurable": true
});
var $d_Lamf_client_model_document_Document = new $TypeData().initClass({
  Lamf_client_model_document_Document: 0
}, false, "amf.client.model.document.Document", {
  Lamf_client_model_document_Document: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_EncodesModel: 1,
  Lamf_client_model_document_DeclaresModel: 1
});
$c_Lamf_client_model_document_Document.prototype.$classData = $d_Lamf_client_model_document_Document;
/** @constructor */
function $c_Lamf_client_model_domain_AbstractDeclaration() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_AbstractDeclaration.prototype = new $h_O();
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.constructor = $c_Lamf_client_model_domain_AbstractDeclaration;
/** @constructor */
function $h_Lamf_client_model_domain_AbstractDeclaration() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_AbstractDeclaration.prototype = $c_Lamf_client_model_domain_AbstractDeclaration.prototype;
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.withDataNode__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_AbstractDeclaration = (function(dataNode) {
  var this$1 = this.$$undinternal__Lamf_core_model_domain_templates_AbstractDeclaration();
  var dataNode$1 = dataNode.$$undinternal__Lamf_core_model_domain_DataNode();
  var field = $m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().DataNode$1;
  $as_Lamf_core_model_domain_templates_AbstractDeclaration($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$1, field, dataNode$1));
  return this
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal__Lamf_core_model_domain_templates_AbstractDeclaration();
  var from = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().Name$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return this.linkTarget__sjs_js_UndefOr()
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.dataNode__Lamf_client_model_domain_DataNode = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal__Lamf_core_model_domain_templates_AbstractDeclaration().dataNode__Lamf_core_model_domain_DataNode();
  var m = $m_Lamf_client_convert_CoreClientConverters$().DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$();
  return m.asClient__Lamf_core_model_domain_DataNode__Lamf_client_model_domain_DataNode(from)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$prop$dataNode__O = (function() {
  return this.dataNode__Lamf_client_model_domain_DataNode()
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.variables__sjs_js_Array = (function() {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal__Lamf_core_model_domain_templates_AbstractDeclaration().variables__sc_Seq();
  var m = $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal__Lamf_core_model_domain_templates_AbstractDeclaration()
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.description__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal__Lamf_core_model_domain_templates_AbstractDeclaration().description__Lamf_core_model_StrField();
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.linkTarget__sjs_js_UndefOr = (function() {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("AbstractDeclaration is abstract"))
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$meth$withDataNode__Lamf_client_model_domain_DataNode__O = (function(dataNode) {
  return this.withDataNode__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_AbstractDeclaration(dataNode)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_AbstractDeclaration()
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.withName__T__Lamf_client_model_domain_AbstractDeclaration = (function(name) {
  var this$3 = this.$$undinternal__Lamf_core_model_domain_templates_AbstractDeclaration();
  this.$$undinternal__Lamf_core_model_domain_templates_AbstractDeclaration();
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_AbstractDeclaration()
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.withVariables__sjs_js_Array__Lamf_client_model_domain_AbstractDeclaration = (function(variables) {
  var this$2 = this.$$undinternal__Lamf_core_model_domain_templates_AbstractDeclaration();
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var m = $m_Lamf_client_convert_CoreClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  var variables$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, variables, m).asInternal__sc_Seq();
  var field = $m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().Variables$1;
  $as_Lamf_core_model_domain_templates_AbstractDeclaration($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, variables$1));
  return this
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$meth$withDescription__T__O = (function(description) {
  return this.withDescription__T__Lamf_client_model_domain_AbstractDeclaration(description)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal__Lamf_core_model_domain_DomainElement().id__T()
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal__Lamf_core_model_domain_templates_AbstractDeclaration()
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$prop$variables__O = (function() {
  return this.variables__sjs_js_Array()
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$undinternal__Lamf_core_model_domain_templates_AbstractDeclaration = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$prop$description__O = (function() {
  return this.description__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.init___Lamf_core_model_domain_templates_AbstractDeclaration = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.withDescription__T__Lamf_client_model_domain_AbstractDeclaration = (function(description) {
  var this$1 = this.$$undinternal__Lamf_core_model_domain_templates_AbstractDeclaration();
  var field = $m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().Description$1;
  $as_Lamf_core_model_domain_templates_AbstractDeclaration($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, description));
  return this
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_AbstractDeclaration(name)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$meth$withVariables__sjs_js_Array__O = (function(variables) {
  return this.withVariables__sjs_js_Array__Lamf_client_model_domain_AbstractDeclaration(variables)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.linkCopy__Lamf_client_model_domain_AbstractDeclaration = (function() {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("AbstractDeclaration is abstract"))
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_AbstractDeclaration.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_AbstractDeclaration.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AbstractDeclaration.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AbstractDeclaration.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AbstractDeclaration.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_AbstractDeclaration.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AbstractDeclaration.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
Object.defineProperty($c_Lamf_client_model_domain_AbstractDeclaration.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.withVariables = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withVariables__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.withDataNode = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DataNode(arg);
  return this.$$js$exported$meth$withDataNode__Lamf_client_model_domain_DataNode__O(prep)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.withDescription = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDescription__T__O(prep)
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_AbstractDeclaration.prototype, "variables", {
  "get": (function() {
    return this.$$js$exported$prop$variables__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AbstractDeclaration.prototype, "dataNode", {
  "get": (function() {
    return this.$$js$exported$prop$dataNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AbstractDeclaration.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AbstractDeclaration.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_AbstractDeclaration(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_AbstractDeclaration) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.AbstractDeclaration"))
}
function $isArrayOf_Lamf_client_model_domain_AbstractDeclaration(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_AbstractDeclaration)))
}
function $asArrayOf_Lamf_client_model_domain_AbstractDeclaration(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_AbstractDeclaration(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.AbstractDeclaration;", depth))
}
var $d_Lamf_client_model_domain_AbstractDeclaration = new $TypeData().initClass({
  Lamf_client_model_domain_AbstractDeclaration: 0
}, false, "amf.client.model.domain.AbstractDeclaration", {
  Lamf_client_model_domain_AbstractDeclaration: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_NamedDomainElement: 1
});
$c_Lamf_client_model_domain_AbstractDeclaration.prototype.$classData = $d_Lamf_client_model_domain_AbstractDeclaration;
/** @constructor */
function $c_Lamf_client_model_domain_Message() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_Message.prototype = new $h_O();
$c_Lamf_client_model_domain_Message.prototype.constructor = $c_Lamf_client_model_domain_Message;
/** @constructor */
function $h_Lamf_client_model_domain_Message() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_Message.prototype = $c_Lamf_client_model_domain_Message.prototype;
$c_Lamf_client_model_domain_Message.prototype.correlationId__Lamf_client_model_domain_CorrelationId = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  var from = $as_Lamf_plugins_domain_webapi_models_CorrelationId(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().CorrelationId$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().CorrelationIdMatcher__Lamf_client_convert_CorrelationIdConverter$CorrelationIdMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_CorrelationId__Lamf_client_model_domain_CorrelationId(from)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$withTags__sjs_js_Array__O = (function(tags) {
  return this.withTags__sjs_js_Array__Lamf_client_model_domain_Message(tags)
});
$c_Lamf_client_model_domain_Message.prototype.withSummary__T__Lamf_client_model_domain_Message = (function(summary) {
  var this$1 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Summary$1;
  $as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, summary));
  return this
});
$c_Lamf_client_model_domain_Message.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  var from = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(this$1.nameField__Lamf_core_metamodel_Field()));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Message.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_Message.prototype.init___Lamf_plugins_domain_webapi_models_Message.call(this, new $c_Lamf_plugins_domain_webapi_models_Message().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$withPayload__O = (function() {
  return this.withPayload__Lamf_client_model_domain_Payload()
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_Message.prototype.documentation__Lamf_client_model_domain_CreativeWork = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  var from = $as_Lamf_plugins_domain_shapes_models_CreativeWork(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Documentation$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().CreativeWorkMatcher__Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_client_model_domain_CreativeWork(from)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$prop$correlationId__O = (function() {
  return this.correlationId__Lamf_client_model_domain_CorrelationId()
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$withTitle__T__O = (function(title) {
  return this.withTitle__T__Lamf_client_model_domain_Message(title)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$prop$displayName__O = (function() {
  return this.displayName__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Message.prototype.withPayload__Lamf_client_model_domain_Payload = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message().withPayload__s_Option__Lamf_plugins_domain_webapi_models_Payload((this.$$undinternal__Lamf_plugins_domain_webapi_models_Message(), $m_s_None$()));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PayloadMatcher__Lamf_client_convert_PayloadConverter$PayloadMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Payload__Lamf_client_model_domain_Payload(from)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$prop$examples__O = (function() {
  return this.examples__sjs_js_Array()
});
$c_Lamf_client_model_domain_Message.prototype.init___Lamf_plugins_domain_webapi_models_Message = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_Message.prototype.examples__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  var from = $as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ExampleMatcher__Lamf_client_convert_ExampleConverter$ExampleMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_Message.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal__Lamf_plugins_domain_webapi_models_Message()
});
$c_Lamf_client_model_domain_Message.prototype.withTags__sjs_js_Array__Lamf_client_model_domain_Message = (function(tags) {
  var this$2 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().TagMatcher__Lamf_client_convert_TagConverter$TagMatcher$();
  var tags$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, tags, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Tags$1;
  $as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, tags$1));
  return this
});
$c_Lamf_client_model_domain_Message.prototype.linkCopy__Lamf_client_model_domain_Message = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message().linkCopy__Lamf_plugins_domain_webapi_models_Message();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().MessageMatcher__Lamf_client_convert_MessageConverter$MessageMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Message__Lamf_client_model_domain_Message(from)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$prop$payloads__O = (function() {
  return this.payloads__sjs_js_Array()
});
$c_Lamf_client_model_domain_Message.prototype.withDocumentation__Lamf_client_model_domain_CreativeWork__Lamf_client_model_domain_Message = (function(documentation) {
  var this$2 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().CreativeWorkMatcher__Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$();
  var documentation$1 = documentation.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Documentation$1;
  $as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, documentation$1));
  return this
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$withExamples__sjs_js_Array__O = (function(examples) {
  return this.withExamples__sjs_js_Array__Lamf_client_model_domain_Message(examples)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$withCorrelationId__Lamf_client_model_domain_CorrelationId__O = (function(correlationId) {
  return this.withCorrelationId__Lamf_client_model_domain_CorrelationId__Lamf_client_model_domain_Message(correlationId)
});
$c_Lamf_client_model_domain_Message.prototype.title__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  var from = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Title$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Message.prototype.withCorrelationId__Lamf_client_model_domain_CorrelationId__Lamf_client_model_domain_Message = (function(correlationId) {
  var this$2 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().CorrelationIdMatcher__Lamf_client_convert_CorrelationIdConverter$CorrelationIdMatcher$();
  var correlationId$1 = correlationId.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().CorrelationId$1;
  $as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, correlationId$1));
  return this
});
$c_Lamf_client_model_domain_Message.prototype.tags__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  var from = $as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Tags$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().TagMatcher__Lamf_client_convert_TagConverter$TagMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_Message.prototype.payloads__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  var from = $as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PayloadMatcher__Lamf_client_convert_PayloadConverter$PayloadMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$prop$bindings__O = (function() {
  return this.bindings__Lamf_client_model_domain_MessageBindings()
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_Message.prototype.description__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  var from = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Description$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$withBindings__Lamf_client_model_domain_MessageBindings__O = (function(bindings) {
  return this.withBindings__Lamf_client_model_domain_MessageBindings__Lamf_client_model_domain_Message(bindings)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$prop$documentation__O = (function() {
  return this.documentation__Lamf_client_model_domain_CreativeWork()
});
$c_Lamf_client_model_domain_Message.prototype.withPayload__sjs_js_UndefOr__Lamf_client_model_domain_Payload = (function(mediaType) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var jsx$1 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var from = jsx$1.withPayload__s_Option__Lamf_plugins_domain_webapi_models_Payload(new $c_Lamf_client_convert_CollectionConverter$ClientOptionOps().init___Lamf_client_convert_CollectionConverter__O(this$1, mediaType).toScala__s_Option());
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PayloadMatcher__Lamf_client_convert_PayloadConverter$PayloadMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Payload__Lamf_client_model_domain_Payload(from)
});
$c_Lamf_client_model_domain_Message.prototype.withName__T__Lamf_client_model_domain_Message = (function(name) {
  var this$3 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$withDisplayName__T__O = (function(displayName) {
  return this.withDisplayName__T__Lamf_client_model_domain_Message(displayName)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$withDocumentation__Lamf_client_model_domain_CreativeWork__O = (function(documentation) {
  return this.withDocumentation__Lamf_client_model_domain_CreativeWork__Lamf_client_model_domain_Message(documentation)
});
$c_Lamf_client_model_domain_Message.prototype.bindings__Lamf_client_model_domain_MessageBindings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  var from = $as_Lamf_plugins_domain_webapi_models_bindings_MessageBindings(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Bindings$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().MessageBindingsMatcher__Lamf_client_convert_MessageBindingsConverter$MessageBindingsMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_MessageBindings__Lamf_client_model_domain_MessageBindings(from)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_Message()
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Message.prototype.withTitle__T__Lamf_client_model_domain_Message = (function(title) {
  var this$1 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Title$1;
  $as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, title));
  return this
});
$c_Lamf_client_model_domain_Message.prototype.withDescription__T__Lamf_client_model_domain_Message = (function(description) {
  var this$1 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Description$1;
  $as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, description));
  return this
});
$c_Lamf_client_model_domain_Message.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_Message()
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$prop$isAbstract__O = (function() {
  return this.isAbstract__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Message.prototype.summary__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  var from = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Summary$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$withDescription__T__O = (function(description) {
  return this.withDescription__T__Lamf_client_model_domain_Message(description)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$withPayload__sjs_js_UndefOr__O = (function(mediaType) {
  return this.withPayload__sjs_js_UndefOr__Lamf_client_model_domain_Payload(mediaType)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$prop$tags__O = (function() {
  return this.tags__sjs_js_Array()
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_Message.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_Message = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal__Lamf_core_model_domain_DomainElement().id__T()
});
$c_Lamf_client_model_domain_Message.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal__Lamf_plugins_domain_webapi_models_Message()
});
$c_Lamf_client_model_domain_Message.prototype.withExamples__sjs_js_Array__Lamf_client_model_domain_Message = (function(examples) {
  var this$2 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ExampleMatcher__Lamf_client_convert_ExampleConverter$ExampleMatcher$();
  var examples$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, examples, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1;
  $as_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, examples$1));
  return this
});
$c_Lamf_client_model_domain_Message.prototype.withBindings__Lamf_client_model_domain_MessageBindings__Lamf_client_model_domain_Message = (function(bindings) {
  var this$2 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().MessageBindingsMatcher__Lamf_client_convert_MessageBindingsConverter$MessageBindingsMatcher$();
  var bindings$1 = bindings.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Bindings$1;
  $as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, bindings$1));
  return this
});
$c_Lamf_client_model_domain_Message.prototype.withDisplayName__T__Lamf_client_model_domain_Message = (function(displayName) {
  var this$1 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().DisplayName$1;
  $as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, displayName));
  return this
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$prop$description__O = (function() {
  return this.description__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$prop$summary__O = (function() {
  return this.summary__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Message.prototype.isAbstract__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  var from = $as_Lamf_core_model_BoolField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().IsAbstract$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_Message.prototype.displayName__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  var from = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().DisplayName$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_Message(name)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$withSummary__T__O = (function(summary) {
  return this.withSummary__T__Lamf_client_model_domain_Message(summary)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$prop$title__O = (function() {
  return this.title__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Message.prototype.withPayloads__sjs_js_Array__Lamf_client_model_domain_Message = (function(payloads) {
  var this$2 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PayloadMatcher__Lamf_client_convert_PayloadConverter$PayloadMatcher$();
  var payloads$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, payloads, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1;
  $as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, payloads$1));
  return this
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$withAbstract__Z__O = (function(isAbstract) {
  return this.withAbstract__Z__Lamf_client_model_domain_Message(isAbstract)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$withPayloads__sjs_js_Array__O = (function(payloads) {
  return this.withPayloads__sjs_js_Array__Lamf_client_model_domain_Message(payloads)
});
$c_Lamf_client_model_domain_Message.prototype.withAbstract__Z__Lamf_client_model_domain_Message = (function(isAbstract) {
  var this$1 = this.$$undinternal__Lamf_plugins_domain_webapi_models_Message();
  $as_Lamf_core_model_BoolField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().IsAbstract$1));
  return this
});
$c_Lamf_client_model_domain_Message.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_Message.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_Message.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_Message.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Message.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Message.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_Message.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Message.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Message.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Message.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Message.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Message.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Message.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_Message.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_Message.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Message.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Message.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Message.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Message.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_Message.prototype.withPayload = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = rest[0];
      return this.$$js$exported$meth$withPayload__sjs_js_UndefOr__O(prep);
      break
    }
    case 0: {
      return this.$$js$exported$meth$withPayload__O();
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_model_domain_Message.prototype.withBindings = (function(arg) {
  var prep = $as_Lamf_client_model_domain_MessageBindings(arg);
  return this.$$js$exported$meth$withBindings__Lamf_client_model_domain_MessageBindings__O(prep)
});
$c_Lamf_client_model_domain_Message.prototype.withSummary = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withSummary__T__O(prep)
});
$c_Lamf_client_model_domain_Message.prototype.withTitle = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withTitle__T__O(prep)
});
$c_Lamf_client_model_domain_Message.prototype.withDisplayName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDisplayName__T__O(prep)
});
$c_Lamf_client_model_domain_Message.prototype.withCorrelationId = (function(arg) {
  var prep = $as_Lamf_client_model_domain_CorrelationId(arg);
  return this.$$js$exported$meth$withCorrelationId__Lamf_client_model_domain_CorrelationId__O(prep)
});
$c_Lamf_client_model_domain_Message.prototype.withPayloads = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withPayloads__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Message.prototype.withExamples = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExamples__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Message.prototype.withTags = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withTags__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Message.prototype.withDocumentation = (function(arg) {
  var prep = $as_Lamf_client_model_domain_CreativeWork(arg);
  return this.$$js$exported$meth$withDocumentation__Lamf_client_model_domain_CreativeWork__O(prep)
});
$c_Lamf_client_model_domain_Message.prototype.withAbstract = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withAbstract__Z__O(prep)
});
$c_Lamf_client_model_domain_Message.prototype.withDescription = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDescription__T__O(prep)
});
$c_Lamf_client_model_domain_Message.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Message.prototype, "bindings", {
  "get": (function() {
    return this.$$js$exported$prop$bindings__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Message.prototype, "summary", {
  "get": (function() {
    return this.$$js$exported$prop$summary__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Message.prototype, "title", {
  "get": (function() {
    return this.$$js$exported$prop$title__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Message.prototype, "displayName", {
  "get": (function() {
    return this.$$js$exported$prop$displayName__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Message.prototype, "correlationId", {
  "get": (function() {
    return this.$$js$exported$prop$correlationId__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Message.prototype, "payloads", {
  "get": (function() {
    return this.$$js$exported$prop$payloads__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Message.prototype, "examples", {
  "get": (function() {
    return this.$$js$exported$prop$examples__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Message.prototype, "tags", {
  "get": (function() {
    return this.$$js$exported$prop$tags__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Message.prototype, "documentation", {
  "get": (function() {
    return this.$$js$exported$prop$documentation__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Message.prototype, "isAbstract", {
  "get": (function() {
    return this.$$js$exported$prop$isAbstract__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Message.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Message.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_Message(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_Message) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Message"))
}
function $isArrayOf_Lamf_client_model_domain_Message(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Message)))
}
function $asArrayOf_Lamf_client_model_domain_Message(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Message(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Message;", depth))
}
var $d_Lamf_client_model_domain_Message = new $TypeData().initClass({
  Lamf_client_model_domain_Message: 0
}, false, "amf.client.model.domain.Message", {
  Lamf_client_model_domain_Message: 1,
  O: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1
});
$c_Lamf_client_model_domain_Message.prototype.$classData = $d_Lamf_client_model_domain_Message;
/** @constructor */
function $c_Lamf_client_parse_DefaultParserErrorHandler$$anon$1() {
  $c_O.call(this);
  this.parserRun$1 = 0;
  this.x3$1$1 = null
}
$c_Lamf_client_parse_DefaultParserErrorHandler$$anon$1.prototype = new $h_O();
$c_Lamf_client_parse_DefaultParserErrorHandler$$anon$1.prototype.constructor = $c_Lamf_client_parse_DefaultParserErrorHandler$$anon$1;
/** @constructor */
function $h_Lamf_client_parse_DefaultParserErrorHandler$$anon$1() {
  /*<skip>*/
}
$h_Lamf_client_parse_DefaultParserErrorHandler$$anon$1.prototype = $c_Lamf_client_parse_DefaultParserErrorHandler$$anon$1.prototype;
$c_Lamf_client_parse_DefaultParserErrorHandler$$anon$1.prototype.handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V = (function(location, e) {
  $f_Lamf_core_parser_errorhandler_ParserErrorHandler__handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V(this, location, e)
});
$c_Lamf_client_parse_DefaultParserErrorHandler$$anon$1.prototype.handle__Lorg_yaml_model_YError__O__O = (function(error, defaultValue) {
  return $f_Lamf_core_parser_errorhandler_ParserErrorHandler__handle__Lorg_yaml_model_YError__O__O(this, error, defaultValue)
});
$c_Lamf_client_parse_DefaultParserErrorHandler$$anon$1.prototype.init___Lamf_core_errorhandling_AmfResultErrorHandler = (function(x3$1) {
  this.x3$1$1 = x3$1;
  this.parserRun$1 = $m_Lamf_core_AMFCompilerRunCount$().NONE$1;
  return this
});
$c_Lamf_client_parse_DefaultParserErrorHandler$$anon$1.prototype.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V = (function(specification, node, property, message, lexical, location) {
  var id = specification.id$1;
  var level = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  $f_Lamf_core_errorhandling_AmfResultErrorHandler__reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(this, id, node, property, message, lexical, level, location)
});
$c_Lamf_client_parse_DefaultParserErrorHandler$$anon$1.prototype.parserRun__I = (function() {
  return this.parserRun$1
});
$c_Lamf_client_parse_DefaultParserErrorHandler$$anon$1.prototype.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V = (function(id, node, property, message, lexical, level, location) {
  $f_Lamf_core_errorhandling_AmfResultErrorHandler__reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(this, id, node, property, message, lexical, level, location)
});
$c_Lamf_client_parse_DefaultParserErrorHandler$$anon$1.prototype.handlerAmfResult__Lamf_core_validation_AMFValidationResult__Z = (function(result) {
  return this.x3$1$1.handlerAmfResult__Lamf_core_validation_AMFValidationResult__Z(result)
});
var $d_Lamf_client_parse_DefaultParserErrorHandler$$anon$1 = new $TypeData().initClass({
  Lamf_client_parse_DefaultParserErrorHandler$$anon$1: 0
}, false, "amf.client.parse.DefaultParserErrorHandler$$anon$1", {
  Lamf_client_parse_DefaultParserErrorHandler$$anon$1: 1,
  O: 1,
  Lamf_core_parser_errorhandler_AmfParserErrorHandler: 1,
  Lamf_core_errorhandling_AmfResultErrorHandler: 1,
  Lamf_core_errorhandling_ErrorHandler: 1,
  Lamf_core_parser_errorhandler_ParserErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  Lorg_yaml_model_ParseErrorHandler: 1
});
$c_Lamf_client_parse_DefaultParserErrorHandler$$anon$1.prototype.$classData = $d_Lamf_client_parse_DefaultParserErrorHandler$$anon$1;
/** @constructor */
function $c_Lamf_client_parse_DefaultParserErrorHandler$$anon$2() {
  $c_O.call(this);
  this.parserRun$1 = 0;
  this.x4$1$1 = null
}
$c_Lamf_client_parse_DefaultParserErrorHandler$$anon$2.prototype = new $h_O();
$c_Lamf_client_parse_DefaultParserErrorHandler$$anon$2.prototype.constructor = $c_Lamf_client_parse_DefaultParserErrorHandler$$anon$2;
/** @constructor */
function $h_Lamf_client_parse_DefaultParserErrorHandler$$anon$2() {
  /*<skip>*/
}
$h_Lamf_client_parse_DefaultParserErrorHandler$$anon$2.prototype = $c_Lamf_client_parse_DefaultParserErrorHandler$$anon$2.prototype;
$c_Lamf_client_parse_DefaultParserErrorHandler$$anon$2.prototype.handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V = (function(location, e) {
  $f_Lamf_core_parser_errorhandler_ParserErrorHandler__handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V(this, location, e)
});
$c_Lamf_client_parse_DefaultParserErrorHandler$$anon$2.prototype.handle__Lorg_yaml_model_YError__O__O = (function(error, defaultValue) {
  return $f_Lamf_core_parser_errorhandler_ParserErrorHandler__handle__Lorg_yaml_model_YError__O__O(this, error, defaultValue)
});
$c_Lamf_client_parse_DefaultParserErrorHandler$$anon$2.prototype.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V = (function(specification, node, property, message, lexical, location) {
  var id = specification.id$1;
  var level = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  $f_Lamf_core_errorhandling_AmfResultErrorHandler__reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(this, id, node, property, message, lexical, level, location)
});
$c_Lamf_client_parse_DefaultParserErrorHandler$$anon$2.prototype.parserRun__I = (function() {
  return this.parserRun$1
});
$c_Lamf_client_parse_DefaultParserErrorHandler$$anon$2.prototype.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V = (function(id, node, property, message, lexical, level, location) {
  $f_Lamf_core_errorhandling_AmfResultErrorHandler__reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(this, id, node, property, message, lexical, level, location)
});
$c_Lamf_client_parse_DefaultParserErrorHandler$$anon$2.prototype.handlerAmfResult__Lamf_core_validation_AMFValidationResult__Z = (function(result) {
  this.x4$1$1.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(result.validationId$1, result.targetNode$1, result.targetProperty$1, result.message$1, result.position$1, result.level$1, result.location$1);
  return true
});
$c_Lamf_client_parse_DefaultParserErrorHandler$$anon$2.prototype.init___Lamf_core_errorhandling_ErrorHandler = (function(x4$1) {
  this.x4$1$1 = x4$1;
  this.parserRun$1 = $m_Lamf_core_AMFCompilerRunCount$().NONE$1;
  return this
});
var $d_Lamf_client_parse_DefaultParserErrorHandler$$anon$2 = new $TypeData().initClass({
  Lamf_client_parse_DefaultParserErrorHandler$$anon$2: 0
}, false, "amf.client.parse.DefaultParserErrorHandler$$anon$2", {
  Lamf_client_parse_DefaultParserErrorHandler$$anon$2: 1,
  O: 1,
  Lamf_core_parser_errorhandler_AmfParserErrorHandler: 1,
  Lamf_core_errorhandling_AmfResultErrorHandler: 1,
  Lamf_core_errorhandling_ErrorHandler: 1,
  Lamf_core_parser_errorhandler_ParserErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  Lorg_yaml_model_ParseErrorHandler: 1
});
$c_Lamf_client_parse_DefaultParserErrorHandler$$anon$2.prototype.$classData = $d_Lamf_client_parse_DefaultParserErrorHandler$$anon$2;
/** @constructor */
function $c_Lamf_core_annotations_DataNodePropertiesAnnotations() {
  $c_O.call(this);
  this.properties$1 = null;
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_core_annotations_DataNodePropertiesAnnotations.prototype = new $h_O();
$c_Lamf_core_annotations_DataNodePropertiesAnnotations.prototype.constructor = $c_Lamf_core_annotations_DataNodePropertiesAnnotations;
/** @constructor */
function $h_Lamf_core_annotations_DataNodePropertiesAnnotations() {
  /*<skip>*/
}
$h_Lamf_core_annotations_DataNodePropertiesAnnotations.prototype = $c_Lamf_core_annotations_DataNodePropertiesAnnotations.prototype;
$c_Lamf_core_annotations_DataNodePropertiesAnnotations.prototype.productPrefix__T = (function() {
  return "DataNodePropertiesAnnotations"
});
$c_Lamf_core_annotations_DataNodePropertiesAnnotations.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_annotations_DataNodePropertiesAnnotations.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_annotations_DataNodePropertiesAnnotations)) {
    var DataNodePropertiesAnnotations$1 = $as_Lamf_core_annotations_DataNodePropertiesAnnotations(x$1);
    var x = this.properties$1;
    var x$2 = DataNodePropertiesAnnotations$1.properties$1;
    return ((x === null) ? (x$2 === null) : $f_sc_GenMapLike__equals__O__Z(x, x$2))
  } else {
    return false
  }
});
$c_Lamf_core_annotations_DataNodePropertiesAnnotations.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.properties$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_annotations_DataNodePropertiesAnnotations.prototype.init___sci_Map = (function(properties) {
  this.properties$1 = properties;
  this.name$1 = "data-node-properties";
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var key = $as_T(x0$1.$$und1__O());
        var l = $as_Lamf_core_annotations_LexicalInformation(x0$1.$$und2__O());
        return ((key + "->") + l.range__Lamf_core_parser_Range())
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this));
  var this$1 = $m_sci_Iterable$();
  var bf = this$1.ReusableCBFInstance$2;
  this.value$1 = $as_sc_TraversableOnce($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(properties, f, bf)).mkString__T__T("#");
  return this
});
$c_Lamf_core_annotations_DataNodePropertiesAnnotations.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_DataNodePropertiesAnnotations.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_annotations_DataNodePropertiesAnnotations.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_annotations_DataNodePropertiesAnnotations.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_DataNodePropertiesAnnotations.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_DataNodePropertiesAnnotations(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_DataNodePropertiesAnnotations) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.DataNodePropertiesAnnotations"))
}
function $isArrayOf_Lamf_core_annotations_DataNodePropertiesAnnotations(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_DataNodePropertiesAnnotations)))
}
function $asArrayOf_Lamf_core_annotations_DataNodePropertiesAnnotations(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_DataNodePropertiesAnnotations(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.DataNodePropertiesAnnotations;", depth))
}
var $d_Lamf_core_annotations_DataNodePropertiesAnnotations = new $TypeData().initClass({
  Lamf_core_annotations_DataNodePropertiesAnnotations: 0
}, false, "amf.core.annotations.DataNodePropertiesAnnotations", {
  Lamf_core_annotations_DataNodePropertiesAnnotations: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_DataNodePropertiesAnnotations.prototype.$classData = $d_Lamf_core_annotations_DataNodePropertiesAnnotations;
/** @constructor */
function $c_Lamf_core_annotations_DefaultNode() {
  $c_O.call(this);
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_core_annotations_DefaultNode.prototype = new $h_O();
$c_Lamf_core_annotations_DefaultNode.prototype.constructor = $c_Lamf_core_annotations_DefaultNode;
/** @constructor */
function $h_Lamf_core_annotations_DefaultNode() {
  /*<skip>*/
}
$h_Lamf_core_annotations_DefaultNode.prototype = $c_Lamf_core_annotations_DefaultNode.prototype;
$c_Lamf_core_annotations_DefaultNode.prototype.init___ = (function() {
  this.name$1 = "default-node";
  this.value$1 = "";
  return this
});
$c_Lamf_core_annotations_DefaultNode.prototype.productPrefix__T = (function() {
  return "DefaultNode"
});
$c_Lamf_core_annotations_DefaultNode.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_annotations_DefaultNode.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_core_annotations_DefaultNode) && ($as_Lamf_core_annotations_DefaultNode(x$1), true))
});
$c_Lamf_core_annotations_DefaultNode.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_annotations_DefaultNode.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_DefaultNode.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_annotations_DefaultNode.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_annotations_DefaultNode.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_DefaultNode.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_DefaultNode(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_DefaultNode) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.DefaultNode"))
}
function $isArrayOf_Lamf_core_annotations_DefaultNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_DefaultNode)))
}
function $asArrayOf_Lamf_core_annotations_DefaultNode(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_DefaultNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.DefaultNode;", depth))
}
var $d_Lamf_core_annotations_DefaultNode = new $TypeData().initClass({
  Lamf_core_annotations_DefaultNode: 0
}, false, "amf.core.annotations.DefaultNode", {
  Lamf_core_annotations_DefaultNode: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_DefaultNode.prototype.$classData = $d_Lamf_core_annotations_DefaultNode;
/** @constructor */
function $c_Lamf_core_annotations_InlineElement() {
  $c_O.call(this);
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_core_annotations_InlineElement.prototype = new $h_O();
$c_Lamf_core_annotations_InlineElement.prototype.constructor = $c_Lamf_core_annotations_InlineElement;
/** @constructor */
function $h_Lamf_core_annotations_InlineElement() {
  /*<skip>*/
}
$h_Lamf_core_annotations_InlineElement.prototype = $c_Lamf_core_annotations_InlineElement.prototype;
$c_Lamf_core_annotations_InlineElement.prototype.init___ = (function() {
  this.name$1 = "inline-element";
  this.value$1 = "";
  return this
});
$c_Lamf_core_annotations_InlineElement.prototype.productPrefix__T = (function() {
  return "InlineElement"
});
$c_Lamf_core_annotations_InlineElement.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_annotations_InlineElement.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_core_annotations_InlineElement) && ($as_Lamf_core_annotations_InlineElement(x$1), true))
});
$c_Lamf_core_annotations_InlineElement.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_annotations_InlineElement.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_InlineElement.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_annotations_InlineElement.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_annotations_InlineElement.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_InlineElement.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_InlineElement(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_InlineElement) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.InlineElement"))
}
function $isArrayOf_Lamf_core_annotations_InlineElement(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_InlineElement)))
}
function $asArrayOf_Lamf_core_annotations_InlineElement(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_InlineElement(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.InlineElement;", depth))
}
var $d_Lamf_core_annotations_InlineElement = new $TypeData().initClass({
  Lamf_core_annotations_InlineElement: 0
}, false, "amf.core.annotations.InlineElement", {
  Lamf_core_annotations_InlineElement: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_InlineElement.prototype.$classData = $d_Lamf_core_annotations_InlineElement;
/** @constructor */
function $c_Lamf_core_annotations_LocalElement() {
  $c_O.call(this);
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_core_annotations_LocalElement.prototype = new $h_O();
$c_Lamf_core_annotations_LocalElement.prototype.constructor = $c_Lamf_core_annotations_LocalElement;
/** @constructor */
function $h_Lamf_core_annotations_LocalElement() {
  /*<skip>*/
}
$h_Lamf_core_annotations_LocalElement.prototype = $c_Lamf_core_annotations_LocalElement.prototype;
$c_Lamf_core_annotations_LocalElement.prototype.init___ = (function() {
  this.name$1 = "local-element";
  this.value$1 = "";
  return this
});
$c_Lamf_core_annotations_LocalElement.prototype.productPrefix__T = (function() {
  return "LocalElement"
});
$c_Lamf_core_annotations_LocalElement.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_annotations_LocalElement.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_core_annotations_LocalElement) && ($as_Lamf_core_annotations_LocalElement(x$1), true))
});
$c_Lamf_core_annotations_LocalElement.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_annotations_LocalElement.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_LocalElement.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_annotations_LocalElement.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_annotations_LocalElement.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_LocalElement.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_LocalElement(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_LocalElement) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.LocalElement"))
}
function $isArrayOf_Lamf_core_annotations_LocalElement(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_LocalElement)))
}
function $asArrayOf_Lamf_core_annotations_LocalElement(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_LocalElement(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.LocalElement;", depth))
}
var $d_Lamf_core_annotations_LocalElement = new $TypeData().initClass({
  Lamf_core_annotations_LocalElement: 0
}, false, "amf.core.annotations.LocalElement", {
  Lamf_core_annotations_LocalElement: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_LocalElement.prototype.$classData = $d_Lamf_core_annotations_LocalElement;
/** @constructor */
function $c_Lamf_core_annotations_NilUnion() {
  $c_O.call(this);
  this.position$1 = null;
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_core_annotations_NilUnion.prototype = new $h_O();
$c_Lamf_core_annotations_NilUnion.prototype.constructor = $c_Lamf_core_annotations_NilUnion;
/** @constructor */
function $h_Lamf_core_annotations_NilUnion() {
  /*<skip>*/
}
$h_Lamf_core_annotations_NilUnion.prototype = $c_Lamf_core_annotations_NilUnion.prototype;
$c_Lamf_core_annotations_NilUnion.prototype.productPrefix__T = (function() {
  return "NilUnion"
});
$c_Lamf_core_annotations_NilUnion.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_annotations_NilUnion.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_annotations_NilUnion)) {
    var NilUnion$1 = $as_Lamf_core_annotations_NilUnion(x$1);
    return (this.position$1 === NilUnion$1.position$1)
  } else {
    return false
  }
});
$c_Lamf_core_annotations_NilUnion.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.position$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_annotations_NilUnion.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_NilUnion.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_annotations_NilUnion.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_annotations_NilUnion.prototype.init___T = (function(position) {
  this.position$1 = position;
  this.name$1 = "nil-union";
  this.value$1 = position;
  return this
});
$c_Lamf_core_annotations_NilUnion.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_NilUnion.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_NilUnion(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_NilUnion) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.NilUnion"))
}
function $isArrayOf_Lamf_core_annotations_NilUnion(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_NilUnion)))
}
function $asArrayOf_Lamf_core_annotations_NilUnion(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_NilUnion(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.NilUnion;", depth))
}
var $d_Lamf_core_annotations_NilUnion = new $TypeData().initClass({
  Lamf_core_annotations_NilUnion: 0
}, false, "amf.core.annotations.NilUnion", {
  Lamf_core_annotations_NilUnion: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_NilUnion.prototype.$classData = $d_Lamf_core_annotations_NilUnion;
/** @constructor */
function $c_Lamf_core_annotations_NullSecurity() {
  $c_O.call(this);
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_core_annotations_NullSecurity.prototype = new $h_O();
$c_Lamf_core_annotations_NullSecurity.prototype.constructor = $c_Lamf_core_annotations_NullSecurity;
/** @constructor */
function $h_Lamf_core_annotations_NullSecurity() {
  /*<skip>*/
}
$h_Lamf_core_annotations_NullSecurity.prototype = $c_Lamf_core_annotations_NullSecurity.prototype;
$c_Lamf_core_annotations_NullSecurity.prototype.init___ = (function() {
  this.name$1 = "null-security";
  this.value$1 = "";
  return this
});
$c_Lamf_core_annotations_NullSecurity.prototype.productPrefix__T = (function() {
  return "NullSecurity"
});
$c_Lamf_core_annotations_NullSecurity.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_annotations_NullSecurity.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_core_annotations_NullSecurity) && ($as_Lamf_core_annotations_NullSecurity(x$1), true))
});
$c_Lamf_core_annotations_NullSecurity.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_annotations_NullSecurity.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_NullSecurity.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_annotations_NullSecurity.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_annotations_NullSecurity.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_NullSecurity.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_NullSecurity(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_NullSecurity) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.NullSecurity"))
}
function $isArrayOf_Lamf_core_annotations_NullSecurity(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_NullSecurity)))
}
function $asArrayOf_Lamf_core_annotations_NullSecurity(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_NullSecurity(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.NullSecurity;", depth))
}
var $d_Lamf_core_annotations_NullSecurity = new $TypeData().initClass({
  Lamf_core_annotations_NullSecurity: 0
}, false, "amf.core.annotations.NullSecurity", {
  Lamf_core_annotations_NullSecurity: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_NullSecurity.prototype.$classData = $d_Lamf_core_annotations_NullSecurity;
/** @constructor */
function $c_Lamf_core_annotations_ResolvedInheritance() {
  $c_O.call(this)
}
$c_Lamf_core_annotations_ResolvedInheritance.prototype = new $h_O();
$c_Lamf_core_annotations_ResolvedInheritance.prototype.constructor = $c_Lamf_core_annotations_ResolvedInheritance;
/** @constructor */
function $h_Lamf_core_annotations_ResolvedInheritance() {
  /*<skip>*/
}
$h_Lamf_core_annotations_ResolvedInheritance.prototype = $c_Lamf_core_annotations_ResolvedInheritance.prototype;
$c_Lamf_core_annotations_ResolvedInheritance.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_annotations_ResolvedInheritance.prototype.productPrefix__T = (function() {
  return "ResolvedInheritance"
});
$c_Lamf_core_annotations_ResolvedInheritance.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_annotations_ResolvedInheritance.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_core_annotations_ResolvedInheritance) && ($as_Lamf_core_annotations_ResolvedInheritance(x$1), true))
});
$c_Lamf_core_annotations_ResolvedInheritance.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_annotations_ResolvedInheritance.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_ResolvedInheritance.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_ResolvedInheritance.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_ResolvedInheritance(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_ResolvedInheritance) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.ResolvedInheritance"))
}
function $isArrayOf_Lamf_core_annotations_ResolvedInheritance(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_ResolvedInheritance)))
}
function $asArrayOf_Lamf_core_annotations_ResolvedInheritance(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_ResolvedInheritance(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.ResolvedInheritance;", depth))
}
var $d_Lamf_core_annotations_ResolvedInheritance = new $TypeData().initClass({
  Lamf_core_annotations_ResolvedInheritance: 0
}, false, "amf.core.annotations.ResolvedInheritance", {
  Lamf_core_annotations_ResolvedInheritance: 1,
  O: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_ResolvedInheritance.prototype.$classData = $d_Lamf_core_annotations_ResolvedInheritance;
/** @constructor */
function $c_Lamf_core_annotations_SingleValueArray() {
  $c_O.call(this);
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_core_annotations_SingleValueArray.prototype = new $h_O();
$c_Lamf_core_annotations_SingleValueArray.prototype.constructor = $c_Lamf_core_annotations_SingleValueArray;
/** @constructor */
function $h_Lamf_core_annotations_SingleValueArray() {
  /*<skip>*/
}
$h_Lamf_core_annotations_SingleValueArray.prototype = $c_Lamf_core_annotations_SingleValueArray.prototype;
$c_Lamf_core_annotations_SingleValueArray.prototype.init___ = (function() {
  this.name$1 = "single-value-array";
  this.value$1 = "";
  return this
});
$c_Lamf_core_annotations_SingleValueArray.prototype.productPrefix__T = (function() {
  return "SingleValueArray"
});
$c_Lamf_core_annotations_SingleValueArray.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_annotations_SingleValueArray.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_core_annotations_SingleValueArray) && ($as_Lamf_core_annotations_SingleValueArray(x$1), true))
});
$c_Lamf_core_annotations_SingleValueArray.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_annotations_SingleValueArray.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_SingleValueArray.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_annotations_SingleValueArray.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_annotations_SingleValueArray.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_SingleValueArray.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_SingleValueArray(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_SingleValueArray) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.SingleValueArray"))
}
function $isArrayOf_Lamf_core_annotations_SingleValueArray(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_SingleValueArray)))
}
function $asArrayOf_Lamf_core_annotations_SingleValueArray(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_SingleValueArray(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.SingleValueArray;", depth))
}
var $d_Lamf_core_annotations_SingleValueArray = new $TypeData().initClass({
  Lamf_core_annotations_SingleValueArray: 0
}, false, "amf.core.annotations.SingleValueArray", {
  Lamf_core_annotations_SingleValueArray: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_SingleValueArray.prototype.$classData = $d_Lamf_core_annotations_SingleValueArray;
/** @constructor */
function $c_Lamf_core_annotations_SourceLocation() {
  $c_O.call(this);
  this.location$1 = null
}
$c_Lamf_core_annotations_SourceLocation.prototype = new $h_O();
$c_Lamf_core_annotations_SourceLocation.prototype.constructor = $c_Lamf_core_annotations_SourceLocation;
/** @constructor */
function $h_Lamf_core_annotations_SourceLocation() {
  /*<skip>*/
}
$h_Lamf_core_annotations_SourceLocation.prototype = $c_Lamf_core_annotations_SourceLocation.prototype;
$c_Lamf_core_annotations_SourceLocation.prototype.productPrefix__T = (function() {
  return "SourceLocation"
});
$c_Lamf_core_annotations_SourceLocation.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_annotations_SourceLocation.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_annotations_SourceLocation)) {
    var SourceLocation$1 = $as_Lamf_core_annotations_SourceLocation(x$1);
    return (this.location$1 === SourceLocation$1.location$1)
  } else {
    return false
  }
});
$c_Lamf_core_annotations_SourceLocation.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.location$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_annotations_SourceLocation.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_SourceLocation.prototype.init___T = (function(location) {
  this.location$1 = location;
  return this
});
$c_Lamf_core_annotations_SourceLocation.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_SourceLocation.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_SourceLocation(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_SourceLocation) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.SourceLocation"))
}
function $isArrayOf_Lamf_core_annotations_SourceLocation(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_SourceLocation)))
}
function $asArrayOf_Lamf_core_annotations_SourceLocation(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_SourceLocation(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.SourceLocation;", depth))
}
var $d_Lamf_core_annotations_SourceLocation = new $TypeData().initClass({
  Lamf_core_annotations_SourceLocation: 0
}, false, "amf.core.annotations.SourceLocation", {
  Lamf_core_annotations_SourceLocation: 1,
  O: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_SourceLocation.prototype.$classData = $d_Lamf_core_annotations_SourceLocation;
/** @constructor */
function $c_Lamf_core_annotations_SynthesizedField() {
  $c_O.call(this);
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_core_annotations_SynthesizedField.prototype = new $h_O();
$c_Lamf_core_annotations_SynthesizedField.prototype.constructor = $c_Lamf_core_annotations_SynthesizedField;
/** @constructor */
function $h_Lamf_core_annotations_SynthesizedField() {
  /*<skip>*/
}
$h_Lamf_core_annotations_SynthesizedField.prototype = $c_Lamf_core_annotations_SynthesizedField.prototype;
$c_Lamf_core_annotations_SynthesizedField.prototype.init___ = (function() {
  this.name$1 = "synthesized-field";
  this.value$1 = "true";
  return this
});
$c_Lamf_core_annotations_SynthesizedField.prototype.productPrefix__T = (function() {
  return "SynthesizedField"
});
$c_Lamf_core_annotations_SynthesizedField.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_annotations_SynthesizedField.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_core_annotations_SynthesizedField) && ($as_Lamf_core_annotations_SynthesizedField(x$1), true))
});
$c_Lamf_core_annotations_SynthesizedField.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_annotations_SynthesizedField.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_SynthesizedField.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_annotations_SynthesizedField.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_annotations_SynthesizedField.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_SynthesizedField.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_SynthesizedField(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_SynthesizedField) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.SynthesizedField"))
}
function $isArrayOf_Lamf_core_annotations_SynthesizedField(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_SynthesizedField)))
}
function $asArrayOf_Lamf_core_annotations_SynthesizedField(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_SynthesizedField(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.SynthesizedField;", depth))
}
var $d_Lamf_core_annotations_SynthesizedField = new $TypeData().initClass({
  Lamf_core_annotations_SynthesizedField: 0
}, false, "amf.core.annotations.SynthesizedField", {
  Lamf_core_annotations_SynthesizedField: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_SynthesizedField.prototype.$classData = $d_Lamf_core_annotations_SynthesizedField;
/** @constructor */
function $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.f$1 = null;
  this.ordering$1 = null;
  this.force$1 = false;
  this.valuesTag$1 = null
}
$c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter.prototype = new $h_O();
$c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter.prototype.constructor = $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter;
/** @constructor */
function $h_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter() {
  /*<skip>*/
}
$h_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter.prototype = $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter.prototype;
$c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter.prototype.productPrefix__T = (function() {
  return "ArrayEmitter"
});
$c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter)) {
    var ArrayEmitter$1 = $as_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter(x$1);
    if ((this.key$1 === ArrayEmitter$1.key$1)) {
      var x = this.f$1;
      var x$2 = ArrayEmitter$1.f$1;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$3 = this.ordering$1;
      var x$4 = ArrayEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if ((jsx$1 && (this.force$1 === ArrayEmitter$1.force$1))) {
      var x$5 = this.valuesTag$1;
      var x$6 = ArrayEmitter$1.valuesTag$1;
      return (x$5 === x$6)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.f$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.force$1;
      break
    }
    case 4: {
      return this.valuesTag$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter.prototype.emitSingle__p1__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.f$1;
  var this$2 = $as_Lamf_core_model_domain_AmfArray(this$1.value$1.value$1).scalars__sc_Seq().headOption__s_Option();
  if (this$2.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var x$5 = $as_Lamf_core_model_domain_AmfScalar(arg1);
    var this$3 = new $c_s_Some().init___O(x$5.toString__T())
  };
  var value = $as_T((this$3.isEmpty__Z() ? "" : this$3.get__O()));
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  $m_Lamf_core_emitter_BaseEmitters_package$().raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(v, value, this.valuesTag$1);
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter.prototype.emitValues__p1__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = this.f$1;
  $as_Lamf_core_model_domain_AmfArray(this$2.value$1.value$1).scalars__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, result$1) {
    return (function(v$2) {
      var v$1 = $as_Lamf_core_model_domain_AmfScalar(v$2);
      return result$1.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType(v$1, $this.valuesTag$1))
    })
  })(this, result)));
  var jsx$2 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  var jsx$1 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$2.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$3 = j;
    var index = i;
    xs.set(jsx$3, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var single = (this.f$1.value$1.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_SingleValueArray.getClassOf()) || this.f$1.value$1.value$1.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_SingleValueArray.getClassOf()));
  var value = this.f$1.value$1;
  if ((single && (!this.force$1))) {
    this.emitSingle__p1__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
  } else {
    this.emitValues__p1__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
  }
});
$c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.key$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.f$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ordering$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.force$1 ? 1231 : 1237));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.valuesTag$1));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 5)
});
$c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
$c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter.prototype.init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType = (function(key, f, ordering, force, valuesTag) {
  this.key$1 = key;
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.force$1 = force;
  this.valuesTag$1 = valuesTag;
  return this
});
function $as_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter(obj) {
  return (((obj instanceof $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.emitter.BaseEmitters.package$ArrayEmitter"))
}
function $isArrayOf_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_emitter_BaseEmitters_package$ArrayEmitter)))
}
function $asArrayOf_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter(obj, depth) {
  return (($isArrayOf_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.emitter.BaseEmitters.package$ArrayEmitter;", depth))
}
var $d_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter = new $TypeData().initClass({
  Lamf_core_emitter_BaseEmitters_package$ArrayEmitter: 0
}, false, "amf.core.emitter.BaseEmitters.package$ArrayEmitter", {
  Lamf_core_emitter_BaseEmitters_package$ArrayEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter.prototype.$classData = $d_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter;
/** @constructor */
function $c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter() {
  $c_O.call(this);
  this.position$1 = null
}
$c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter.prototype = new $h_O();
$c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter.prototype.constructor = $c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter;
/** @constructor */
function $h_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter() {
  /*<skip>*/
}
$h_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter.prototype = $c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter.prototype;
$c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter.prototype.productPrefix__T = (function() {
  return "EmptyMapEmitter"
});
$c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var map = $m_Lorg_yaml_model_YMap$().empty$1;
  $m_Lorg_yaml_model_YNode$();
  var node = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1);
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer(node)
});
$c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter)) {
    var EmptyMapEmitter$1 = $as_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter(x$1);
    var x = this.position$1;
    var x$2 = EmptyMapEmitter$1.position$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.position$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter.prototype.init___Lamf_core_parser_Position = (function(position) {
  this.position$1 = position;
  return this
});
$c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  return this.position$1
});
function $as_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter(obj) {
  return (((obj instanceof $c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.emitter.BaseEmitters.package$EmptyMapEmitter"))
}
function $isArrayOf_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter)))
}
function $asArrayOf_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter(obj, depth) {
  return (($isArrayOf_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.emitter.BaseEmitters.package$EmptyMapEmitter;", depth))
}
var $d_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter = new $TypeData().initClass({
  Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter: 0
}, false, "amf.core.emitter.BaseEmitters.package$EmptyMapEmitter", {
  Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter.prototype.$classData = $d_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter;
/** @constructor */
function $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.value$1 = null;
  this.tag$1 = null;
  this.position$1 = null
}
$c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter.prototype = new $h_O();
$c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter.prototype.constructor = $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter;
/** @constructor */
function $h_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter() {
  /*<skip>*/
}
$h_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter.prototype = $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter.prototype;
$c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter.prototype.productPrefix__T = (function() {
  return "EntryPartEmitter"
});
$c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter)) {
    var EntryPartEmitter$1 = $as_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter(x$1);
    if ((this.key__T() === EntryPartEmitter$1.key__T())) {
      var x = this.value$1;
      var x$2 = EntryPartEmitter$1.value$1;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$3 = this.tag$1;
      var x$4 = EntryPartEmitter$1.tag$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.position$1;
      var x$6 = EntryPartEmitter$1.position$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key__T();
      break
    }
    case 1: {
      return this.value$1;
      break
    }
    case 2: {
      return this.tag$1;
      break
    }
    case 3: {
      return this.position$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter.prototype.init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position = (function(key, value, tag, position) {
  this.key$1 = key;
  this.value$1 = value;
  this.tag$1 = tag;
  this.position$1 = position;
  return this
});
$c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key__T();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  this.value$1.emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
  var this$4 = v.builder$1;
  var array = [key];
  if ((this$4.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$4.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$4, newSize);
  var len$1 = this$4.size0$6;
  var src = this$4.array$6;
  var dest = this$4.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$4.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$4.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter.prototype.key__T = (function() {
  return this.key$1
});
$c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  return this.position$1
});
function $as_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter(obj) {
  return (((obj instanceof $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.emitter.BaseEmitters.package$EntryPartEmitter"))
}
function $isArrayOf_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter)))
}
function $asArrayOf_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter(obj, depth) {
  return (($isArrayOf_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.emitter.BaseEmitters.package$EntryPartEmitter;", depth))
}
var $d_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter = new $TypeData().initClass({
  Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter: 0
}, false, "amf.core.emitter.BaseEmitters.package$EntryPartEmitter", {
  Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter.prototype.$classData = $d_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter;
/** @constructor */
function $c_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter() {
  $c_O.call(this);
  this.alias$1 = null;
  this.annotations$1 = null
}
$c_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter.prototype = new $h_O();
$c_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter.prototype.constructor = $c_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter;
/** @constructor */
function $h_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter() {
  /*<skip>*/
}
$h_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter.prototype = $c_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter.prototype;
$c_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter.prototype.productPrefix__T = (function() {
  return "LinkScalaEmitter"
});
$c_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var node = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YScalar$().withLocation__T__Lorg_yaml_model_YType__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_YScalar(this.alias$1, $m_Lorg_yaml_model_YType$().Include$1, this.annotations$1.sourceLocation__Lorg_mulesoft_lexer_SourceLocation()), $m_Lorg_yaml_model_YType$().Include$1);
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer(node)
});
$c_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter)) {
    var LinkScalaEmitter$1 = $as_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter(x$1);
    if ((this.alias$1 === LinkScalaEmitter$1.alias$1)) {
      var x = this.annotations$1;
      var x$2 = LinkScalaEmitter$1.annotations$1;
      return (x === x$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.alias$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter.prototype.init___T__Lamf_core_parser_Annotations = (function(alias, annotations) {
  this.alias$1 = alias;
  this.annotations$1 = annotations;
  return this
});
$c_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter(obj) {
  return (((obj instanceof $c_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.emitter.BaseEmitters.package$LinkScalaEmitter"))
}
function $isArrayOf_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter)))
}
function $asArrayOf_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter(obj, depth) {
  return (($isArrayOf_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.emitter.BaseEmitters.package$LinkScalaEmitter;", depth))
}
var $d_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter = new $TypeData().initClass({
  Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter: 0
}, false, "amf.core.emitter.BaseEmitters.package$LinkScalaEmitter", {
  Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter.prototype.$classData = $d_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter;
/** @constructor */
function $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.value$1 = null;
  this.tag$1 = null;
  this.position$1 = null
}
$c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter.prototype = new $h_O();
$c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter.prototype.constructor = $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter;
/** @constructor */
function $h_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter() {
  /*<skip>*/
}
$h_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter.prototype = $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter.prototype;
$c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter.prototype.productPrefix__T = (function() {
  return "MapEntryEmitter"
});
$c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter)) {
    var MapEntryEmitter$1 = $as_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter(x$1);
    if (((this.key$1 === MapEntryEmitter$1.key$1) && (this.value$1 === MapEntryEmitter$1.value$1))) {
      var x = this.tag$1;
      var x$2 = MapEntryEmitter$1.tag$1;
      var jsx$1 = (x === x$2)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.position$1;
      var x$4 = MapEntryEmitter$1.position$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.value$1;
      break
    }
    case 2: {
      return this.tag$1;
      break
    }
    case 3: {
      return this.position$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  $m_Lamf_core_emitter_BaseEmitters_package$().raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(v, this.value$1, this.tag$1);
  var this$4 = v.builder$1;
  var array = [key];
  if ((this$4.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$4.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$4, newSize);
  var len$1 = this$4.size0$6;
  var src = this$4.array$6;
  var dest = this$4.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$4.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$4.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter.prototype.init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position = (function(key, value, tag, position) {
  this.key$1 = key;
  this.value$1 = value;
  this.tag$1 = tag;
  this.position$1 = position;
  return this
});
$c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  return this.position$1
});
function $as_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter(obj) {
  return (((obj instanceof $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.emitter.BaseEmitters.package$MapEntryEmitter"))
}
function $isArrayOf_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter)))
}
function $asArrayOf_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter(obj, depth) {
  return (($isArrayOf_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.emitter.BaseEmitters.package$MapEntryEmitter;", depth))
}
var $d_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter = new $TypeData().initClass({
  Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter: 0
}, false, "amf.core.emitter.BaseEmitters.package$MapEntryEmitter", {
  Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter.prototype.$classData = $d_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter;
/** @constructor */
function $c_Lamf_core_emitter_BaseEmitters_package$NullEmitter() {
  $c_O.call(this);
  this.annotations$1 = null
}
$c_Lamf_core_emitter_BaseEmitters_package$NullEmitter.prototype = new $h_O();
$c_Lamf_core_emitter_BaseEmitters_package$NullEmitter.prototype.constructor = $c_Lamf_core_emitter_BaseEmitters_package$NullEmitter;
/** @constructor */
function $h_Lamf_core_emitter_BaseEmitters_package$NullEmitter() {
  /*<skip>*/
}
$h_Lamf_core_emitter_BaseEmitters_package$NullEmitter.prototype = $c_Lamf_core_emitter_BaseEmitters_package$NullEmitter.prototype;
$c_Lamf_core_emitter_BaseEmitters_package$NullEmitter.prototype.productPrefix__T = (function() {
  return "NullEmitter"
});
$c_Lamf_core_emitter_BaseEmitters_package$NullEmitter.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_emitter_BaseEmitters_package$NullEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var node = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YScalar$().withLocation__T__Lorg_yaml_model_YType__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_YScalar("null", $m_Lorg_yaml_model_YType$().Null$1, this.annotations$1.sourceLocation__Lorg_mulesoft_lexer_SourceLocation()), $m_Lorg_yaml_model_YType$().Null$1);
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer(node)
});
$c_Lamf_core_emitter_BaseEmitters_package$NullEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_emitter_BaseEmitters_package$NullEmitter)) {
    var NullEmitter$1 = $as_Lamf_core_emitter_BaseEmitters_package$NullEmitter(x$1);
    var x = this.annotations$1;
    var x$2 = NullEmitter$1.annotations$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_core_emitter_BaseEmitters_package$NullEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_emitter_BaseEmitters_package$NullEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_emitter_BaseEmitters_package$NullEmitter.prototype.init___Lamf_core_parser_Annotations = (function(annotations) {
  this.annotations$1 = annotations;
  return this
});
$c_Lamf_core_emitter_BaseEmitters_package$NullEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_emitter_BaseEmitters_package$NullEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_emitter_BaseEmitters_package$NullEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_core_emitter_BaseEmitters_package$NullEmitter(obj) {
  return (((obj instanceof $c_Lamf_core_emitter_BaseEmitters_package$NullEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.emitter.BaseEmitters.package$NullEmitter"))
}
function $isArrayOf_Lamf_core_emitter_BaseEmitters_package$NullEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_emitter_BaseEmitters_package$NullEmitter)))
}
function $asArrayOf_Lamf_core_emitter_BaseEmitters_package$NullEmitter(obj, depth) {
  return (($isArrayOf_Lamf_core_emitter_BaseEmitters_package$NullEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.emitter.BaseEmitters.package$NullEmitter;", depth))
}
var $d_Lamf_core_emitter_BaseEmitters_package$NullEmitter = new $TypeData().initClass({
  Lamf_core_emitter_BaseEmitters_package$NullEmitter: 0
}, false, "amf.core.emitter.BaseEmitters.package$NullEmitter", {
  Lamf_core_emitter_BaseEmitters_package$NullEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_emitter_BaseEmitters_package$NullEmitter.prototype.$classData = $d_Lamf_core_emitter_BaseEmitters_package$NullEmitter;
/** @constructor */
function $c_Lamf_core_emitter_BaseEmitters_package$RawEmitter() {
  $c_O.call(this);
  this.content$1 = null;
  this.tag$1 = null;
  this.annotations$1 = null
}
$c_Lamf_core_emitter_BaseEmitters_package$RawEmitter.prototype = new $h_O();
$c_Lamf_core_emitter_BaseEmitters_package$RawEmitter.prototype.constructor = $c_Lamf_core_emitter_BaseEmitters_package$RawEmitter;
/** @constructor */
function $h_Lamf_core_emitter_BaseEmitters_package$RawEmitter() {
  /*<skip>*/
}
$h_Lamf_core_emitter_BaseEmitters_package$RawEmitter.prototype = $c_Lamf_core_emitter_BaseEmitters_package$RawEmitter.prototype;
$c_Lamf_core_emitter_BaseEmitters_package$RawEmitter.prototype.productPrefix__T = (function() {
  return "RawEmitter"
});
$c_Lamf_core_emitter_BaseEmitters_package$RawEmitter.prototype.init___T__Lorg_yaml_model_YType__Lamf_core_parser_Annotations = (function(content, tag, annotations) {
  this.content$1 = content;
  this.tag$1 = tag;
  this.annotations$1 = annotations;
  return this
});
$c_Lamf_core_emitter_BaseEmitters_package$RawEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  $m_Lamf_core_emitter_BaseEmitters_package$().raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(b, this.content$1, this.tag$1)
});
$c_Lamf_core_emitter_BaseEmitters_package$RawEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_core_emitter_BaseEmitters_package$RawEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_emitter_BaseEmitters_package$RawEmitter)) {
    var RawEmitter$1 = $as_Lamf_core_emitter_BaseEmitters_package$RawEmitter(x$1);
    if ((this.content$1 === RawEmitter$1.content$1)) {
      var x = this.tag$1;
      var x$2 = RawEmitter$1.tag$1;
      var jsx$1 = (x === x$2)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.annotations$1;
      var x$4 = RawEmitter$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_emitter_BaseEmitters_package$RawEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.content$1;
      break
    }
    case 1: {
      return this.tag$1;
      break
    }
    case 2: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_emitter_BaseEmitters_package$RawEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_emitter_BaseEmitters_package$RawEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_emitter_BaseEmitters_package$RawEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_emitter_BaseEmitters_package$RawEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_core_emitter_BaseEmitters_package$RawEmitter(obj) {
  return (((obj instanceof $c_Lamf_core_emitter_BaseEmitters_package$RawEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.emitter.BaseEmitters.package$RawEmitter"))
}
function $isArrayOf_Lamf_core_emitter_BaseEmitters_package$RawEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_emitter_BaseEmitters_package$RawEmitter)))
}
function $asArrayOf_Lamf_core_emitter_BaseEmitters_package$RawEmitter(obj, depth) {
  return (($isArrayOf_Lamf_core_emitter_BaseEmitters_package$RawEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.emitter.BaseEmitters.package$RawEmitter;", depth))
}
var $d_Lamf_core_emitter_BaseEmitters_package$RawEmitter = new $TypeData().initClass({
  Lamf_core_emitter_BaseEmitters_package$RawEmitter: 0
}, false, "amf.core.emitter.BaseEmitters.package$RawEmitter", {
  Lamf_core_emitter_BaseEmitters_package$RawEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_emitter_BaseEmitters_package$RawEmitter.prototype.$classData = $d_Lamf_core_emitter_BaseEmitters_package$RawEmitter;
/** @constructor */
function $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter() {
  $c_O.call(this);
  this.v$1 = null;
  this.tag$1 = null
}
$c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter.prototype = new $h_O();
$c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter.prototype.constructor = $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter;
/** @constructor */
function $h_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter() {
  /*<skip>*/
}
$h_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter.prototype = $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter.prototype;
$c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter.prototype.productPrefix__T = (function() {
  return "ScalarEmitter"
});
$c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var node = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YScalar$().apply__O__Lorg_yaml_model_YScalar(this.v$1.value$1), this.tag$1);
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer(node)
});
$c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter)) {
    var ScalarEmitter$1 = $as_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter(x$1);
    var x = this.v$1;
    var x$2 = ScalarEmitter$1.v$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.tag$1;
      var x$4 = ScalarEmitter$1.tag$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.v$1;
      break
    }
    case 1: {
      return this.tag$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter.prototype.init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType = (function(v, tag) {
  this.v$1 = v;
  this.tag$1 = tag;
  return this
});
$c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.v$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter(obj) {
  return (((obj instanceof $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.emitter.BaseEmitters.package$ScalarEmitter"))
}
function $isArrayOf_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_emitter_BaseEmitters_package$ScalarEmitter)))
}
function $asArrayOf_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter(obj, depth) {
  return (($isArrayOf_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.emitter.BaseEmitters.package$ScalarEmitter;", depth))
}
var $d_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter = new $TypeData().initClass({
  Lamf_core_emitter_BaseEmitters_package$ScalarEmitter: 0
}, false, "amf.core.emitter.BaseEmitters.package$ScalarEmitter", {
  Lamf_core_emitter_BaseEmitters_package$ScalarEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter.prototype.$classData = $d_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter;
/** @constructor */
function $c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter() {
  $c_O.call(this);
  this.value$1 = null;
  this.annotations$1 = null;
  this.tag$1 = null
}
$c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter.prototype = new $h_O();
$c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter.prototype.constructor = $c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter;
/** @constructor */
function $h_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter() {
  /*<skip>*/
}
$h_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter.prototype = $c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter.prototype;
$c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter.prototype.productPrefix__T = (function() {
  return "TextScalarEmitter"
});
$c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var node = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YScalar$().withLocation__T__Lorg_yaml_model_YType__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_YScalar(this.value$1, this.tag$1, this.annotations$1.sourceLocation__Lorg_mulesoft_lexer_SourceLocation()), this.tag$1);
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer(node)
});
$c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter)) {
    var TextScalarEmitter$1 = $as_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter(x$1);
    if ((this.value$1 === TextScalarEmitter$1.value$1)) {
      var x = this.annotations$1;
      var x$2 = TextScalarEmitter$1.annotations$1;
      var jsx$1 = (x === x$2)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.tag$1;
      var x$4 = TextScalarEmitter$1.tag$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    case 2: {
      return this.tag$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter.prototype.init___T__Lamf_core_parser_Annotations__Lorg_yaml_model_YType = (function(value, annotations, tag) {
  this.value$1 = value;
  this.annotations$1 = annotations;
  this.tag$1 = tag;
  return this
});
$c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter(obj) {
  return (((obj instanceof $c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.emitter.BaseEmitters.package$TextScalarEmitter"))
}
function $isArrayOf_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter)))
}
function $asArrayOf_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter(obj, depth) {
  return (($isArrayOf_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.emitter.BaseEmitters.package$TextScalarEmitter;", depth))
}
var $d_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter = new $TypeData().initClass({
  Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter: 0
}, false, "amf.core.emitter.BaseEmitters.package$TextScalarEmitter", {
  Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter.prototype.$classData = $d_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter;
/** @constructor */
function $c_Lamf_core_metamodel_Type$Array() {
  $c_Lamf_core_metamodel_Type$ArrayLike.call(this)
}
$c_Lamf_core_metamodel_Type$Array.prototype = new $h_Lamf_core_metamodel_Type$ArrayLike();
$c_Lamf_core_metamodel_Type$Array.prototype.constructor = $c_Lamf_core_metamodel_Type$Array;
/** @constructor */
function $h_Lamf_core_metamodel_Type$Array() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_Type$Array.prototype = $c_Lamf_core_metamodel_Type$Array.prototype;
$c_Lamf_core_metamodel_Type$Array.prototype.productPrefix__T = (function() {
  return "Array"
});
$c_Lamf_core_metamodel_Type$Array.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_metamodel_Type$Array.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_metamodel_Type$Array)) {
    var Array$1 = $as_Lamf_core_metamodel_Type$Array(x$1);
    var x = this.element$1;
    var x$2 = Array$1.element$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_core_metamodel_Type$Array.prototype.element__Lamf_core_metamodel_Type = (function() {
  return this.element$1
});
$c_Lamf_core_metamodel_Type$Array.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.element$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_metamodel_Type$Array.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_metamodel_Type$Array.prototype.init___Lamf_core_metamodel_Type = (function(element) {
  $c_Lamf_core_metamodel_Type$ArrayLike.prototype.init___Lamf_core_metamodel_Type.call(this, element);
  return this
});
$c_Lamf_core_metamodel_Type$Array.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_metamodel_Type$Array.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_metamodel_Type$Array(obj) {
  return (((obj instanceof $c_Lamf_core_metamodel_Type$Array) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.metamodel.Type$Array"))
}
function $isArrayOf_Lamf_core_metamodel_Type$Array(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_metamodel_Type$Array)))
}
function $asArrayOf_Lamf_core_metamodel_Type$Array(obj, depth) {
  return (($isArrayOf_Lamf_core_metamodel_Type$Array(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.metamodel.Type$Array;", depth))
}
var $d_Lamf_core_metamodel_Type$Array = new $TypeData().initClass({
  Lamf_core_metamodel_Type$Array: 0
}, false, "amf.core.metamodel.Type$Array", {
  Lamf_core_metamodel_Type$Array: 1,
  Lamf_core_metamodel_Type$ArrayLike: 1,
  O: 1,
  Lamf_core_metamodel_Type: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_metamodel_Type$Array.prototype.$classData = $d_Lamf_core_metamodel_Type$Array;
/** @constructor */
function $c_Lamf_core_metamodel_Type$Bool$() {
  $c_Lamf_core_metamodel_Type$Scalar.call(this)
}
$c_Lamf_core_metamodel_Type$Bool$.prototype = new $h_Lamf_core_metamodel_Type$Scalar();
$c_Lamf_core_metamodel_Type$Bool$.prototype.constructor = $c_Lamf_core_metamodel_Type$Bool$;
/** @constructor */
function $h_Lamf_core_metamodel_Type$Bool$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_Type$Bool$.prototype = $c_Lamf_core_metamodel_Type$Bool$.prototype;
$c_Lamf_core_metamodel_Type$Bool$.prototype.init___ = (function() {
  $c_Lamf_core_metamodel_Type$Scalar.prototype.init___T.call(this, "boolean");
  return this
});
var $d_Lamf_core_metamodel_Type$Bool$ = new $TypeData().initClass({
  Lamf_core_metamodel_Type$Bool$: 0
}, false, "amf.core.metamodel.Type$Bool$", {
  Lamf_core_metamodel_Type$Bool$: 1,
  Lamf_core_metamodel_Type$Scalar: 1,
  O: 1,
  Lamf_core_metamodel_Type: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_metamodel_Type$Bool$.prototype.$classData = $d_Lamf_core_metamodel_Type$Bool$;
var $n_Lamf_core_metamodel_Type$Bool$ = (void 0);
function $m_Lamf_core_metamodel_Type$Bool$() {
  if ((!$n_Lamf_core_metamodel_Type$Bool$)) {
    $n_Lamf_core_metamodel_Type$Bool$ = new $c_Lamf_core_metamodel_Type$Bool$().init___()
  };
  return $n_Lamf_core_metamodel_Type$Bool$
}
/** @constructor */
function $c_Lamf_core_metamodel_Type$Date$() {
  $c_Lamf_core_metamodel_Type$Scalar.call(this)
}
$c_Lamf_core_metamodel_Type$Date$.prototype = new $h_Lamf_core_metamodel_Type$Scalar();
$c_Lamf_core_metamodel_Type$Date$.prototype.constructor = $c_Lamf_core_metamodel_Type$Date$;
/** @constructor */
function $h_Lamf_core_metamodel_Type$Date$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_Type$Date$.prototype = $c_Lamf_core_metamodel_Type$Date$.prototype;
$c_Lamf_core_metamodel_Type$Date$.prototype.init___ = (function() {
  $c_Lamf_core_metamodel_Type$Scalar.prototype.init___T.call(this, "date");
  return this
});
var $d_Lamf_core_metamodel_Type$Date$ = new $TypeData().initClass({
  Lamf_core_metamodel_Type$Date$: 0
}, false, "amf.core.metamodel.Type$Date$", {
  Lamf_core_metamodel_Type$Date$: 1,
  Lamf_core_metamodel_Type$Scalar: 1,
  O: 1,
  Lamf_core_metamodel_Type: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_metamodel_Type$Date$.prototype.$classData = $d_Lamf_core_metamodel_Type$Date$;
var $n_Lamf_core_metamodel_Type$Date$ = (void 0);
function $m_Lamf_core_metamodel_Type$Date$() {
  if ((!$n_Lamf_core_metamodel_Type$Date$)) {
    $n_Lamf_core_metamodel_Type$Date$ = new $c_Lamf_core_metamodel_Type$Date$().init___()
  };
  return $n_Lamf_core_metamodel_Type$Date$
}
/** @constructor */
function $c_Lamf_core_metamodel_Type$DateTime$() {
  $c_Lamf_core_metamodel_Type$Scalar.call(this)
}
$c_Lamf_core_metamodel_Type$DateTime$.prototype = new $h_Lamf_core_metamodel_Type$Scalar();
$c_Lamf_core_metamodel_Type$DateTime$.prototype.constructor = $c_Lamf_core_metamodel_Type$DateTime$;
/** @constructor */
function $h_Lamf_core_metamodel_Type$DateTime$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_Type$DateTime$.prototype = $c_Lamf_core_metamodel_Type$DateTime$.prototype;
$c_Lamf_core_metamodel_Type$DateTime$.prototype.init___ = (function() {
  $c_Lamf_core_metamodel_Type$Scalar.prototype.init___T.call(this, "dateTime");
  return this
});
var $d_Lamf_core_metamodel_Type$DateTime$ = new $TypeData().initClass({
  Lamf_core_metamodel_Type$DateTime$: 0
}, false, "amf.core.metamodel.Type$DateTime$", {
  Lamf_core_metamodel_Type$DateTime$: 1,
  Lamf_core_metamodel_Type$Scalar: 1,
  O: 1,
  Lamf_core_metamodel_Type: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_metamodel_Type$DateTime$.prototype.$classData = $d_Lamf_core_metamodel_Type$DateTime$;
var $n_Lamf_core_metamodel_Type$DateTime$ = (void 0);
function $m_Lamf_core_metamodel_Type$DateTime$() {
  if ((!$n_Lamf_core_metamodel_Type$DateTime$)) {
    $n_Lamf_core_metamodel_Type$DateTime$ = new $c_Lamf_core_metamodel_Type$DateTime$().init___()
  };
  return $n_Lamf_core_metamodel_Type$DateTime$
}
/** @constructor */
function $c_Lamf_core_metamodel_Type$Double$() {
  $c_Lamf_core_metamodel_Type$Scalar.call(this)
}
$c_Lamf_core_metamodel_Type$Double$.prototype = new $h_Lamf_core_metamodel_Type$Scalar();
$c_Lamf_core_metamodel_Type$Double$.prototype.constructor = $c_Lamf_core_metamodel_Type$Double$;
/** @constructor */
function $h_Lamf_core_metamodel_Type$Double$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_Type$Double$.prototype = $c_Lamf_core_metamodel_Type$Double$.prototype;
$c_Lamf_core_metamodel_Type$Double$.prototype.init___ = (function() {
  $c_Lamf_core_metamodel_Type$Scalar.prototype.init___T.call(this, "double");
  return this
});
var $d_Lamf_core_metamodel_Type$Double$ = new $TypeData().initClass({
  Lamf_core_metamodel_Type$Double$: 0
}, false, "amf.core.metamodel.Type$Double$", {
  Lamf_core_metamodel_Type$Double$: 1,
  Lamf_core_metamodel_Type$Scalar: 1,
  O: 1,
  Lamf_core_metamodel_Type: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_metamodel_Type$Double$.prototype.$classData = $d_Lamf_core_metamodel_Type$Double$;
var $n_Lamf_core_metamodel_Type$Double$ = (void 0);
function $m_Lamf_core_metamodel_Type$Double$() {
  if ((!$n_Lamf_core_metamodel_Type$Double$)) {
    $n_Lamf_core_metamodel_Type$Double$ = new $c_Lamf_core_metamodel_Type$Double$().init___()
  };
  return $n_Lamf_core_metamodel_Type$Double$
}
/** @constructor */
function $c_Lamf_core_metamodel_Type$EncodedIri$() {
  $c_Lamf_core_metamodel_Type$Scalar.call(this)
}
$c_Lamf_core_metamodel_Type$EncodedIri$.prototype = new $h_Lamf_core_metamodel_Type$Scalar();
$c_Lamf_core_metamodel_Type$EncodedIri$.prototype.constructor = $c_Lamf_core_metamodel_Type$EncodedIri$;
/** @constructor */
function $h_Lamf_core_metamodel_Type$EncodedIri$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_Type$EncodedIri$.prototype = $c_Lamf_core_metamodel_Type$EncodedIri$.prototype;
$c_Lamf_core_metamodel_Type$EncodedIri$.prototype.init___ = (function() {
  $c_Lamf_core_metamodel_Type$Scalar.prototype.init___T.call(this, "encodedUrl");
  return this
});
var $d_Lamf_core_metamodel_Type$EncodedIri$ = new $TypeData().initClass({
  Lamf_core_metamodel_Type$EncodedIri$: 0
}, false, "amf.core.metamodel.Type$EncodedIri$", {
  Lamf_core_metamodel_Type$EncodedIri$: 1,
  Lamf_core_metamodel_Type$Scalar: 1,
  O: 1,
  Lamf_core_metamodel_Type: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_metamodel_Type$EncodedIri$.prototype.$classData = $d_Lamf_core_metamodel_Type$EncodedIri$;
var $n_Lamf_core_metamodel_Type$EncodedIri$ = (void 0);
function $m_Lamf_core_metamodel_Type$EncodedIri$() {
  if ((!$n_Lamf_core_metamodel_Type$EncodedIri$)) {
    $n_Lamf_core_metamodel_Type$EncodedIri$ = new $c_Lamf_core_metamodel_Type$EncodedIri$().init___()
  };
  return $n_Lamf_core_metamodel_Type$EncodedIri$
}
/** @constructor */
function $c_Lamf_core_metamodel_Type$Float$() {
  $c_Lamf_core_metamodel_Type$Scalar.call(this)
}
$c_Lamf_core_metamodel_Type$Float$.prototype = new $h_Lamf_core_metamodel_Type$Scalar();
$c_Lamf_core_metamodel_Type$Float$.prototype.constructor = $c_Lamf_core_metamodel_Type$Float$;
/** @constructor */
function $h_Lamf_core_metamodel_Type$Float$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_Type$Float$.prototype = $c_Lamf_core_metamodel_Type$Float$.prototype;
$c_Lamf_core_metamodel_Type$Float$.prototype.init___ = (function() {
  $c_Lamf_core_metamodel_Type$Scalar.prototype.init___T.call(this, "float");
  return this
});
var $d_Lamf_core_metamodel_Type$Float$ = new $TypeData().initClass({
  Lamf_core_metamodel_Type$Float$: 0
}, false, "amf.core.metamodel.Type$Float$", {
  Lamf_core_metamodel_Type$Float$: 1,
  Lamf_core_metamodel_Type$Scalar: 1,
  O: 1,
  Lamf_core_metamodel_Type: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_metamodel_Type$Float$.prototype.$classData = $d_Lamf_core_metamodel_Type$Float$;
var $n_Lamf_core_metamodel_Type$Float$ = (void 0);
function $m_Lamf_core_metamodel_Type$Float$() {
  if ((!$n_Lamf_core_metamodel_Type$Float$)) {
    $n_Lamf_core_metamodel_Type$Float$ = new $c_Lamf_core_metamodel_Type$Float$().init___()
  };
  return $n_Lamf_core_metamodel_Type$Float$
}
/** @constructor */
function $c_Lamf_core_metamodel_Type$Int$() {
  $c_Lamf_core_metamodel_Type$Scalar.call(this)
}
$c_Lamf_core_metamodel_Type$Int$.prototype = new $h_Lamf_core_metamodel_Type$Scalar();
$c_Lamf_core_metamodel_Type$Int$.prototype.constructor = $c_Lamf_core_metamodel_Type$Int$;
/** @constructor */
function $h_Lamf_core_metamodel_Type$Int$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_Type$Int$.prototype = $c_Lamf_core_metamodel_Type$Int$.prototype;
$c_Lamf_core_metamodel_Type$Int$.prototype.init___ = (function() {
  $c_Lamf_core_metamodel_Type$Scalar.prototype.init___T.call(this, "int");
  return this
});
var $d_Lamf_core_metamodel_Type$Int$ = new $TypeData().initClass({
  Lamf_core_metamodel_Type$Int$: 0
}, false, "amf.core.metamodel.Type$Int$", {
  Lamf_core_metamodel_Type$Int$: 1,
  Lamf_core_metamodel_Type$Scalar: 1,
  O: 1,
  Lamf_core_metamodel_Type: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_metamodel_Type$Int$.prototype.$classData = $d_Lamf_core_metamodel_Type$Int$;
var $n_Lamf_core_metamodel_Type$Int$ = (void 0);
function $m_Lamf_core_metamodel_Type$Int$() {
  if ((!$n_Lamf_core_metamodel_Type$Int$)) {
    $n_Lamf_core_metamodel_Type$Int$ = new $c_Lamf_core_metamodel_Type$Int$().init___()
  };
  return $n_Lamf_core_metamodel_Type$Int$
}
/** @constructor */
function $c_Lamf_core_metamodel_Type$Iri$() {
  $c_Lamf_core_metamodel_Type$Scalar.call(this)
}
$c_Lamf_core_metamodel_Type$Iri$.prototype = new $h_Lamf_core_metamodel_Type$Scalar();
$c_Lamf_core_metamodel_Type$Iri$.prototype.constructor = $c_Lamf_core_metamodel_Type$Iri$;
/** @constructor */
function $h_Lamf_core_metamodel_Type$Iri$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_Type$Iri$.prototype = $c_Lamf_core_metamodel_Type$Iri$.prototype;
$c_Lamf_core_metamodel_Type$Iri$.prototype.init___ = (function() {
  $c_Lamf_core_metamodel_Type$Scalar.prototype.init___T.call(this, "url");
  return this
});
var $d_Lamf_core_metamodel_Type$Iri$ = new $TypeData().initClass({
  Lamf_core_metamodel_Type$Iri$: 0
}, false, "amf.core.metamodel.Type$Iri$", {
  Lamf_core_metamodel_Type$Iri$: 1,
  Lamf_core_metamodel_Type$Scalar: 1,
  O: 1,
  Lamf_core_metamodel_Type: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_metamodel_Type$Iri$.prototype.$classData = $d_Lamf_core_metamodel_Type$Iri$;
var $n_Lamf_core_metamodel_Type$Iri$ = (void 0);
function $m_Lamf_core_metamodel_Type$Iri$() {
  if ((!$n_Lamf_core_metamodel_Type$Iri$)) {
    $n_Lamf_core_metamodel_Type$Iri$ = new $c_Lamf_core_metamodel_Type$Iri$().init___()
  };
  return $n_Lamf_core_metamodel_Type$Iri$
}
/** @constructor */
function $c_Lamf_core_metamodel_Type$LiteralUri$() {
  $c_Lamf_core_metamodel_Type$Scalar.call(this)
}
$c_Lamf_core_metamodel_Type$LiteralUri$.prototype = new $h_Lamf_core_metamodel_Type$Scalar();
$c_Lamf_core_metamodel_Type$LiteralUri$.prototype.constructor = $c_Lamf_core_metamodel_Type$LiteralUri$;
/** @constructor */
function $h_Lamf_core_metamodel_Type$LiteralUri$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_Type$LiteralUri$.prototype = $c_Lamf_core_metamodel_Type$LiteralUri$.prototype;
$c_Lamf_core_metamodel_Type$LiteralUri$.prototype.init___ = (function() {
  $c_Lamf_core_metamodel_Type$Scalar.prototype.init___T.call(this, "literalUri");
  return this
});
var $d_Lamf_core_metamodel_Type$LiteralUri$ = new $TypeData().initClass({
  Lamf_core_metamodel_Type$LiteralUri$: 0
}, false, "amf.core.metamodel.Type$LiteralUri$", {
  Lamf_core_metamodel_Type$LiteralUri$: 1,
  Lamf_core_metamodel_Type$Scalar: 1,
  O: 1,
  Lamf_core_metamodel_Type: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_metamodel_Type$LiteralUri$.prototype.$classData = $d_Lamf_core_metamodel_Type$LiteralUri$;
var $n_Lamf_core_metamodel_Type$LiteralUri$ = (void 0);
function $m_Lamf_core_metamodel_Type$LiteralUri$() {
  if ((!$n_Lamf_core_metamodel_Type$LiteralUri$)) {
    $n_Lamf_core_metamodel_Type$LiteralUri$ = new $c_Lamf_core_metamodel_Type$LiteralUri$().init___()
  };
  return $n_Lamf_core_metamodel_Type$LiteralUri$
}
/** @constructor */
function $c_Lamf_core_metamodel_Type$RegExp$() {
  $c_Lamf_core_metamodel_Type$Scalar.call(this)
}
$c_Lamf_core_metamodel_Type$RegExp$.prototype = new $h_Lamf_core_metamodel_Type$Scalar();
$c_Lamf_core_metamodel_Type$RegExp$.prototype.constructor = $c_Lamf_core_metamodel_Type$RegExp$;
/** @constructor */
function $h_Lamf_core_metamodel_Type$RegExp$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_Type$RegExp$.prototype = $c_Lamf_core_metamodel_Type$RegExp$.prototype;
$c_Lamf_core_metamodel_Type$RegExp$.prototype.init___ = (function() {
  $c_Lamf_core_metamodel_Type$Scalar.prototype.init___T.call(this, "regexp");
  return this
});
var $d_Lamf_core_metamodel_Type$RegExp$ = new $TypeData().initClass({
  Lamf_core_metamodel_Type$RegExp$: 0
}, false, "amf.core.metamodel.Type$RegExp$", {
  Lamf_core_metamodel_Type$RegExp$: 1,
  Lamf_core_metamodel_Type$Scalar: 1,
  O: 1,
  Lamf_core_metamodel_Type: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_metamodel_Type$RegExp$.prototype.$classData = $d_Lamf_core_metamodel_Type$RegExp$;
var $n_Lamf_core_metamodel_Type$RegExp$ = (void 0);
function $m_Lamf_core_metamodel_Type$RegExp$() {
  if ((!$n_Lamf_core_metamodel_Type$RegExp$)) {
    $n_Lamf_core_metamodel_Type$RegExp$ = new $c_Lamf_core_metamodel_Type$RegExp$().init___()
  };
  return $n_Lamf_core_metamodel_Type$RegExp$
}
/** @constructor */
function $c_Lamf_core_metamodel_Type$SortedArray() {
  $c_Lamf_core_metamodel_Type$ArrayLike.call(this)
}
$c_Lamf_core_metamodel_Type$SortedArray.prototype = new $h_Lamf_core_metamodel_Type$ArrayLike();
$c_Lamf_core_metamodel_Type$SortedArray.prototype.constructor = $c_Lamf_core_metamodel_Type$SortedArray;
/** @constructor */
function $h_Lamf_core_metamodel_Type$SortedArray() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_Type$SortedArray.prototype = $c_Lamf_core_metamodel_Type$SortedArray.prototype;
$c_Lamf_core_metamodel_Type$SortedArray.prototype.productPrefix__T = (function() {
  return "SortedArray"
});
$c_Lamf_core_metamodel_Type$SortedArray.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_metamodel_Type$SortedArray.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_metamodel_Type$SortedArray)) {
    var SortedArray$1 = $as_Lamf_core_metamodel_Type$SortedArray(x$1);
    var x = this.element$1;
    var x$2 = SortedArray$1.element$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_core_metamodel_Type$SortedArray.prototype.element__Lamf_core_metamodel_Type = (function() {
  return this.element$1
});
$c_Lamf_core_metamodel_Type$SortedArray.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.element$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_metamodel_Type$SortedArray.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_metamodel_Type$SortedArray.prototype.init___Lamf_core_metamodel_Type = (function(element) {
  $c_Lamf_core_metamodel_Type$ArrayLike.prototype.init___Lamf_core_metamodel_Type.call(this, element);
  return this
});
$c_Lamf_core_metamodel_Type$SortedArray.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_metamodel_Type$SortedArray.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_metamodel_Type$SortedArray(obj) {
  return (((obj instanceof $c_Lamf_core_metamodel_Type$SortedArray) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.metamodel.Type$SortedArray"))
}
function $isArrayOf_Lamf_core_metamodel_Type$SortedArray(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_metamodel_Type$SortedArray)))
}
function $asArrayOf_Lamf_core_metamodel_Type$SortedArray(obj, depth) {
  return (($isArrayOf_Lamf_core_metamodel_Type$SortedArray(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.metamodel.Type$SortedArray;", depth))
}
var $d_Lamf_core_metamodel_Type$SortedArray = new $TypeData().initClass({
  Lamf_core_metamodel_Type$SortedArray: 0
}, false, "amf.core.metamodel.Type$SortedArray", {
  Lamf_core_metamodel_Type$SortedArray: 1,
  Lamf_core_metamodel_Type$ArrayLike: 1,
  O: 1,
  Lamf_core_metamodel_Type: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_metamodel_Type$SortedArray.prototype.$classData = $d_Lamf_core_metamodel_Type$SortedArray;
/** @constructor */
function $c_Lamf_core_metamodel_Type$Str$() {
  $c_Lamf_core_metamodel_Type$Scalar.call(this)
}
$c_Lamf_core_metamodel_Type$Str$.prototype = new $h_Lamf_core_metamodel_Type$Scalar();
$c_Lamf_core_metamodel_Type$Str$.prototype.constructor = $c_Lamf_core_metamodel_Type$Str$;
/** @constructor */
function $h_Lamf_core_metamodel_Type$Str$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_Type$Str$.prototype = $c_Lamf_core_metamodel_Type$Str$.prototype;
$c_Lamf_core_metamodel_Type$Str$.prototype.init___ = (function() {
  $c_Lamf_core_metamodel_Type$Scalar.prototype.init___T.call(this, "string");
  return this
});
var $d_Lamf_core_metamodel_Type$Str$ = new $TypeData().initClass({
  Lamf_core_metamodel_Type$Str$: 0
}, false, "amf.core.metamodel.Type$Str$", {
  Lamf_core_metamodel_Type$Str$: 1,
  Lamf_core_metamodel_Type$Scalar: 1,
  O: 1,
  Lamf_core_metamodel_Type: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_metamodel_Type$Str$.prototype.$classData = $d_Lamf_core_metamodel_Type$Str$;
var $n_Lamf_core_metamodel_Type$Str$ = (void 0);
function $m_Lamf_core_metamodel_Type$Str$() {
  if ((!$n_Lamf_core_metamodel_Type$Str$)) {
    $n_Lamf_core_metamodel_Type$Str$ = new $c_Lamf_core_metamodel_Type$Str$().init___()
  };
  return $n_Lamf_core_metamodel_Type$Str$
}
/** @constructor */
function $c_Lamf_core_metamodel_Type$Time$() {
  $c_Lamf_core_metamodel_Type$Scalar.call(this)
}
$c_Lamf_core_metamodel_Type$Time$.prototype = new $h_Lamf_core_metamodel_Type$Scalar();
$c_Lamf_core_metamodel_Type$Time$.prototype.constructor = $c_Lamf_core_metamodel_Type$Time$;
/** @constructor */
function $h_Lamf_core_metamodel_Type$Time$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_Type$Time$.prototype = $c_Lamf_core_metamodel_Type$Time$.prototype;
$c_Lamf_core_metamodel_Type$Time$.prototype.init___ = (function() {
  $c_Lamf_core_metamodel_Type$Scalar.prototype.init___T.call(this, "time");
  return this
});
var $d_Lamf_core_metamodel_Type$Time$ = new $TypeData().initClass({
  Lamf_core_metamodel_Type$Time$: 0
}, false, "amf.core.metamodel.Type$Time$", {
  Lamf_core_metamodel_Type$Time$: 1,
  Lamf_core_metamodel_Type$Scalar: 1,
  O: 1,
  Lamf_core_metamodel_Type: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_metamodel_Type$Time$.prototype.$classData = $d_Lamf_core_metamodel_Type$Time$;
var $n_Lamf_core_metamodel_Type$Time$ = (void 0);
function $m_Lamf_core_metamodel_Type$Time$() {
  if ((!$n_Lamf_core_metamodel_Type$Time$)) {
    $n_Lamf_core_metamodel_Type$Time$ = new $c_Lamf_core_metamodel_Type$Time$().init___()
  };
  return $n_Lamf_core_metamodel_Type$Time$
}
function $f_Lamf_core_metamodel_document_ExtensionLikeModel__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.amf$core$metamodel$document$ExtensionLikeModel$$undsetter$und$Extends$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "extends"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "extends", "Target base unit being extended by this extension model", $m_sci_Nil$()), true));
  var x$1 = $thiz.Extends__Lamf_core_metamodel_Field();
  var this$4 = $m_Lamf_core_metamodel_document_DocumentModel$().fields$1;
  $thiz.amf$core$metamodel$document$ExtensionLikeModel$$undsetter$und$fields$und$eq__sci_List__V(new $c_sci_$colon$colon().init___O__sci_List(x$1, this$4))
}
function $is_Lamf_core_metamodel_document_ExtensionLikeModel(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_metamodel_document_ExtensionLikeModel)))
}
function $as_Lamf_core_metamodel_document_ExtensionLikeModel(obj) {
  return (($is_Lamf_core_metamodel_document_ExtensionLikeModel(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.metamodel.document.ExtensionLikeModel"))
}
function $isArrayOf_Lamf_core_metamodel_document_ExtensionLikeModel(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_metamodel_document_ExtensionLikeModel)))
}
function $asArrayOf_Lamf_core_metamodel_document_ExtensionLikeModel(obj, depth) {
  return (($isArrayOf_Lamf_core_metamodel_document_ExtensionLikeModel(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.metamodel.document.ExtensionLikeModel;", depth))
}
function $f_Lamf_core_metamodel_domain_ShapeModel__CustomShapePropertyDefinitions__Lamf_core_metamodel_Field($thiz) {
  var jsx$1 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$());
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  return new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "customShapePropertyDefinitions"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "custom shape property definitions", "Custom constraint definitions added over a data shape", $m_sci_Nil$()), true)
}
function $f_Lamf_core_metamodel_domain_ShapeModel__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  $thiz.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "name"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "name", "Name for a data shape", $m_sci_Nil$()), true));
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  $thiz.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DisplayName$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "name"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "display name", "Human readable name for the term", $m_sci_Nil$()), true));
  var jsx$3 = $m_Lamf_core_metamodel_domain_DataNodeModel$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  $thiz.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Default$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "defaultValue"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "default value", "Default value parsed for a data shape property", $m_sci_Nil$()), true));
  var jsx$4 = $m_Lamf_core_metamodel_Type$Str$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  $thiz.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DefaultValueString$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "defaultValueStr"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "default value String", "Textual representation of the parsed default value for the shape property", $m_sci_Nil$()), true));
  var jsx$5 = new $c_Lamf_core_metamodel_Type$SortedArray().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_domain_DataNodeModel$());
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  $thiz.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Values$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "in"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "in", "Enumeration of possible values for a data shape property", $m_sci_Nil$()), true));
  var jsx$6 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Iri$());
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  $thiz.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Closure$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$6, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "closure"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "inheritance closure", "Transitive closure of data shapes this particular shape inherits structure from", $m_sci_Nil$()), true));
  var jsx$7 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_domain_ShapeModel$());
  var this$19 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  $thiz.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Inherits$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$7, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$19, "inherits"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "inherits", "Relationship of inheritance between data shapes", $m_sci_Nil$()), true));
  var jsx$8 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_domain_ShapeModel$());
  var this$22 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  $thiz.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Or$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$8, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$22, "or"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "or", "Logical or composition of data shapes", $m_sci_Nil$()), true));
  var jsx$9 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_domain_ShapeModel$());
  var this$25 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  $thiz.amf$core$metamodel$domain$ShapeModel$$undsetter$und$And$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$9, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$25, "and"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "and", "Logical and composition of data shapes", $m_sci_Nil$()), true));
  var jsx$10 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_domain_ShapeModel$());
  var this$28 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  $thiz.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Xone$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$10, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$28, "xone"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "exclusive or", "Logical exclusive or composition of data shapes", $m_sci_Nil$()), true));
  var jsx$11 = $m_Lamf_core_metamodel_domain_ShapeModel$();
  var this$31 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  $thiz.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Not$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$11, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$31, "not"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "not", "Logical not composition of data shapes", $m_sci_Nil$()), true));
  var jsx$12 = $m_Lamf_core_metamodel_domain_ShapeModel$();
  var this$34 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  $thiz.amf$core$metamodel$domain$ShapeModel$$undsetter$und$If$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$12, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$34, "if"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "if", "Condition for applying composition of data shapes", $m_sci_Nil$()), true));
  var jsx$13 = $m_Lamf_core_metamodel_domain_ShapeModel$();
  var this$37 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  $thiz.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Then$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$13, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$37, "then"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "then", "Composition of data shape when if data shape is valid", $m_sci_Nil$()), true));
  var jsx$14 = $m_Lamf_core_metamodel_domain_ShapeModel$();
  var this$40 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  $thiz.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Else$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$14, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$40, "else"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "else", "Composition of data shape when if data shape is invalid", $m_sci_Nil$()), true));
  var jsx$15 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$43 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  $thiz.amf$core$metamodel$domain$ShapeModel$$undsetter$und$ReadOnly$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$15, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$43, "readOnly"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "read only", "Read only property constraint", $m_sci_Nil$()), true));
  var jsx$16 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$46 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  $thiz.amf$core$metamodel$domain$ShapeModel$$undsetter$und$WriteOnly$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$16, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$46, "writeOnly"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "write only", "Write only property constraint", $m_sci_Nil$()), true));
  var jsx$17 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$49 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  $thiz.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Deprecated$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$17, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$49, "deprecated"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "deprecated", "Deprecated annotation for a property constraint", $m_sci_Nil$()), true));
  $thiz.amf$core$metamodel$domain$ShapeModel$$undsetter$und$key$und$eq__Lamf_core_metamodel_Field__V($thiz.Name__Lamf_core_metamodel_Field())
}
function $f_Lamf_core_metamodel_domain_ShapeModel__CustomShapeProperties__Lamf_core_metamodel_Field($thiz) {
  var jsx$1 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$());
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  return new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "customShapeProperties"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "custom shape properties", "Custom constraint values for a data shape", $m_sci_Nil$()), true)
}
function $is_Lamf_core_metamodel_domain_ShapeModel(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_core_metamodel_domain_ShapeModel)))
}
function $as_Lamf_core_metamodel_domain_ShapeModel(obj) {
  return (($is_Lamf_core_metamodel_domain_ShapeModel(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.metamodel.domain.ShapeModel"))
}
function $isArrayOf_Lamf_core_metamodel_domain_ShapeModel(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_metamodel_domain_ShapeModel)))
}
function $asArrayOf_Lamf_core_metamodel_domain_ShapeModel(obj, depth) {
  return (($isArrayOf_Lamf_core_metamodel_domain_ShapeModel(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.metamodel.domain.ShapeModel;", depth))
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$() {
  $c_O.call(this);
  this.doc$1 = null;
  this.Name$1 = null;
  this.DefinedBy$1 = null;
  this.Extension$1 = null;
  this.Element$1 = null;
  this.key$1 = null;
  this.type$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$.prototype.constructor = $c_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$.prototype = $c_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$.prototype;
$c_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_extensions_DomainExtensionModel__$$init$__V(this);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Domain Extension", "Extension to the model being parsed from RAML annotation or OpenAPI extensions\nThey must be a DomainPropertySchema (only in RAML) defining them.\nThe DomainPropertySchema might have an associated Data Shape that must validate the extension nested graph.\nThey are parsed as RDF graphs using a default transformation from a set of nested records into RDF.", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$.prototype.fields__sci_List = (function() {
  return $f_Lamf_core_metamodel_domain_extensions_DomainExtensionModel__fields__sci_List(this)
});
$c_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_core_model_domain_extensions_DomainExtension().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_extensions_DomainExtensionModel$: 0
}, false, "amf.core.metamodel.domain.extensions.DomainExtensionModel$", {
  Lamf_core_metamodel_domain_extensions_DomainExtensionModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_extensions_DomainExtensionModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1
});
$c_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$.prototype.$classData = $d_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$;
var $n_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$ = (void 0);
function $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$() {
  if ((!$n_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$)) {
    $n_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$ = new $c_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().init___()
  };
  return $n_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$
}
function $f_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel__fields__sci_List($thiz) {
  $m_sci_List$();
  var array = [$thiz.Name__Lamf_core_metamodel_Field(), $thiz.Description__Lamf_core_metamodel_Field(), $thiz.DataNode__Lamf_core_metamodel_Field(), $thiz.Variables__Lamf_core_metamodel_Field()];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$4 = result;
  var jsx$3 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  var jsx$2 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$5.ReusableCBFInstance$2));
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$6 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2))
}
function $f_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_domain_DataNodeModel$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.amf$core$metamodel$domain$templates$AbstractDeclarationModel$$undsetter$und$DataNode$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "dataNode"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "data node", "Associated dynamic structure for the declaration", $m_sci_Nil$()), true));
  var jsx$2 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Str$());
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.amf$core$metamodel$domain$templates$AbstractDeclarationModel$$undsetter$und$Variables$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "variable"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "variable", "Variables to be replaced in the graph template introduced by an AbstractDeclaration", $m_sci_Nil$()), true));
  $thiz.amf$core$metamodel$domain$templates$AbstractDeclarationModel$$undsetter$und$key$und$eq__Lamf_core_metamodel_Field__V($thiz.Name__Lamf_core_metamodel_Field())
}
/** @constructor */
function $c_Lamf_core_model_domain_Shape() {
  $c_O.call(this);
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_core_model_domain_Shape.prototype = new $h_O();
$c_Lamf_core_model_domain_Shape.prototype.constructor = $c_Lamf_core_model_domain_Shape;
/** @constructor */
function $h_Lamf_core_model_domain_Shape() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_Shape.prototype = $c_Lamf_core_model_domain_Shape.prototype;
$c_Lamf_core_model_domain_Shape.prototype.copyFields__s_Option__Lamf_core_model_domain_Shape__s_Option__Lamf_core_traversal_ModelTraversalRegistry__V = (function(recursionErrorHandler, cloned, recursionBase, traversal) {
  var this$3 = this.fields__Lamf_core_parser_Fields();
  var fn = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, traversal$1, recursionErrorHandler$1, recursionBase$1, cloned$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var f = $as_Lamf_core_metamodel_Field(x0$1.$$und1__O());
        var v = $as_Lamf_core_parser_Value(x0$1.$$und2__O());
        var rc6 = false;
        var x2 = null;
        var x1$2 = v.value$1;
        matchEnd7: {
          var clonedValue;
          if ((x1$2 instanceof $c_Lamf_core_model_domain_Shape)) {
            rc6 = true;
            x2 = $as_Lamf_core_model_domain_Shape(x1$2);
            if (((x2.id$1 !== $this.id$1) && traversal$1.canTraverse__T__Z(x2.id$1))) {
              var x2$1 = x2;
              var previousPath = traversal$1.currentPath$1;
              var element = x2$1.cloneShape__s_Option__s_Option__Lamf_core_traversal_ModelTraversalRegistry__Z__Lamf_core_model_domain_Shape(recursionErrorHandler$1, recursionBase$1, traversal$1, x2$1.cloneShape$default$4__Z());
              traversal$1.currentPath$1 = previousPath;
              var clonedValue = element;
              break matchEnd7
            }
          };
          if ((rc6 && (x2.id$1 === $this.id$1))) {
            var clonedValue = x2;
            break matchEnd7
          };
          if ((x1$2 instanceof $c_Lamf_core_model_domain_AmfArray)) {
            var x4 = $as_Lamf_core_model_domain_AmfArray(x1$2);
            var jsx$2 = x4.values$1;
            var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, traversal$1$1, recursionErrorHandler$1$1, recursionBase$1$1) {
              return (function(x0$2$2) {
                var x0$2 = $as_Lamf_core_model_domain_AmfElement(x0$2$2);
                var rc5 = false;
                var x2$2 = null;
                if ((x0$2 instanceof $c_Lamf_core_model_domain_Shape)) {
                  rc5 = true;
                  x2$2 = $as_Lamf_core_model_domain_Shape(x0$2);
                  if (((x2$2.id$1 !== this$2.id$1) && traversal$1$1.canTraverse__T__Z(x2$2.id$1))) {
                    var x2$3 = x2$2;
                    var previousPath$1 = traversal$1$1.currentPath$1;
                    var element$1 = x2$3.cloneShape__s_Option__s_Option__Lamf_core_traversal_ModelTraversalRegistry__Z__Lamf_core_model_domain_Shape(recursionErrorHandler$1$1, recursionBase$1$1, traversal$1$1, x2$3.cloneShape$default$4__Z());
                    traversal$1$1.currentPath$1 = previousPath$1;
                    return element$1
                  }
                };
                if ((rc5 && (x2$2.id$1 === this$2.id$1))) {
                  return x2$2
                };
                return x0$2
              })
            })($this, traversal$1, recursionErrorHandler$1, recursionBase$1));
            var this$1 = $m_sc_Seq$();
            var clonedValue = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)), x4.annotations$1);
            break matchEnd7
          };
          var clonedValue = x1$2
        };
        cloned$1.fields__Lamf_core_parser_Fields().setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(f, clonedValue, v.annotations$1)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, traversal, recursionErrorHandler, recursionBase, cloned));
  this$3.fs$1.foreach__F1__V(fn)
});
$c_Lamf_core_model_domain_Shape.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_core_model_domain_Shape.prototype.withCustomShapePropertyDefinition__T__Lamf_core_model_domain_extensions_PropertyShape = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$5 = new $c_Lamf_core_model_domain_extensions_PropertyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  var result = $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$5, name, a));
  var field = $m_Lamf_core_metamodel_domain_ShapeModel$().CustomShapePropertyDefinitions__Lamf_core_metamodel_Field();
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, result);
  return result
});
$c_Lamf_core_model_domain_Shape.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_core_model_domain_Shape.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_core_model_domain_Shape.prototype.copyShape__Lamf_core_parser_Annotations__Lamf_core_model_domain_Shape = (function(a) {
  var copiedShape = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_Linkable__copyElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_Linkable(this, a));
  return copiedShape
});
$c_Lamf_core_model_domain_Shape.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_core_model_domain_Shape.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_core_model_domain_Shape.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_core_model_domain_Shape.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_core_model_domain_Shape.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_core_model_domain_Shape.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_core_model_domain_Shape.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_core_model_domain_Shape.prototype.cloneShape$default$3__Lamf_core_traversal_ModelTraversalRegistry = (function() {
  return new $c_Lamf_core_traversal_ModelTraversalRegistry().init___()
});
$c_Lamf_core_model_domain_Shape.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_core_model_domain_Shape.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_core_model_domain_Shape.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_core_model_domain_Shape.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_core_model_domain_Shape.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_core_model_domain_Shape.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_core_model_domain_Shape.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_core_model_domain_Shape.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_core_model_domain_Shape.prototype.ramlSyntaxKey__T = (function() {
  return "shape"
});
$c_Lamf_core_model_domain_Shape.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_core_model_domain_Shape.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_core_model_domain_Shape.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_core_model_domain_Shape.prototype.copyShape__Lamf_core_model_domain_Shape = (function() {
  var this$1 = this.annotations__Lamf_core_parser_Annotations();
  return this.copyShape__Lamf_core_parser_Annotations__Lamf_core_model_domain_Shape($m_Lamf_core_parser_Annotations$().apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(this$1))
});
$c_Lamf_core_model_domain_Shape.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_core_model_domain_Shape.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_core_metamodel_domain_ShapeModel$().Name$1
});
$c_Lamf_core_model_domain_Shape.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_core_model_domain_Shape.prototype.effectiveInherits__sc_Seq = (function() {
  var jsx$2 = $as_sc_Seq(this.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(base$2) {
      var base = $as_Lamf_core_model_domain_Shape(base$2);
      if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(base).isDefined__Z()) {
        var x1 = base.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(base.effectiveLinkTarget$default$1__sc_Seq());
        if ((x1 instanceof $c_Lamf_core_model_domain_Shape)) {
          var x2 = $as_Lamf_core_model_domain_Shape(x1);
          return x2
        } else {
          return base
        }
      } else {
        return base
      }
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  return $as_sc_Seq($as_sc_TraversableLike(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_domain_Shape(x$1$2);
      return (x$1.id$1 !== this$2.id$1)
    })
  })(this))))
});
$c_Lamf_core_model_domain_Shape.prototype.collectCustomShapePropertyDefinitions__Z__scm_Set__sc_Seq = (function(onlyInherited, traversed) {
  var accInit = $m_sci_Map$EmptyMap$();
  if (onlyInherited) {
    var jsx$1 = $m_sc_Seq$();
    var array = [accInit];
    var initialSequence = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  } else {
    var jsx$2 = $m_sc_Seq$();
    var array$1 = [$as_sci_Map($as_sc_Seq(this.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().CustomShapePropertyDefinitions__Lamf_core_metamodel_Field())).foldLeft__O__F2__O(accInit, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
      return (function(acc$2, propertyShape$2) {
        var acc = $as_sci_Map(acc$2);
        var propertyShape = $as_Lamf_core_model_domain_extensions_PropertyShape(propertyShape$2);
        var this$4 = $as_Lamf_core_model_StrField(propertyShape.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
        var this$5 = this$4.option$1;
        return acc.updated__O__O__sci_Map($as_T((this$5.isEmpty__Z() ? null : this$5.get__O())), propertyShape)
      })
    })(this))))];
    var initialSequence = $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)))
  };
  return ($as_sc_Seq(this.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).nonEmpty__Z() ? $as_sc_Seq(this.effectiveInherits__sc_Seq().foldLeft__O__F2__O(initialSequence, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$2$1, traversed$1) {
    return (function(acc$3$2, baseShape$2) {
      var acc$3 = $as_sc_Seq(acc$3$2);
      var baseShape = $as_Lamf_core_model_domain_Shape(baseShape$2);
      if ((!traversed$1.contains__O__Z(baseShape.id$1))) {
        var jsx$5 = baseShape.collectCustomShapePropertyDefinitions__Z__scm_Set__sc_Seq(false, $as_scm_Set(traversed$1.$$plus$eq__O__scm_SetLike(baseShape.id$1)));
        var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, acc$1) {
          return (function(facetsMap$2) {
            var facetsMap = $as_sci_Map(facetsMap$2);
            var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, facetsMap$1) {
              return (function(accFacetsMap$2) {
                var accFacetsMap = $as_sci_Map(accFacetsMap$2);
                return accFacetsMap.$$plus$plus__sc_GenTraversableOnce__sci_Map(facetsMap$1)
              })
            })($this$1, facetsMap));
            var this$8 = $m_sc_Seq$();
            return $as_sc_Seq(acc$1.map__F1__scg_CanBuildFrom__O(jsx$4, this$8.ReusableCBFInstance$2))
          })
        })(this$2$1, acc$3));
        var this$9 = $m_sc_Seq$();
        return $as_sc_Seq(jsx$5.flatMap__F1__scg_CanBuildFrom__O(jsx$3, this$9.ReusableCBFInstance$2))
      } else {
        return acc$3
      }
    })
  })(this, traversed)))) : initialSequence)
});
$c_Lamf_core_model_domain_Shape.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_core_model_domain_Shape.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_core_model_domain_Shape.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_core_model_domain_Shape.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_core_model_domain_Shape.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_core_model_domain_Shape.prototype.cloneShape$default$2__s_Option = (function() {
  return $m_s_None$()
});
function $as_Lamf_core_model_domain_Shape(obj) {
  return (((obj instanceof $c_Lamf_core_model_domain_Shape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.Shape"))
}
function $isArrayOf_Lamf_core_model_domain_Shape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_Shape)))
}
function $asArrayOf_Lamf_core_model_domain_Shape(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_Shape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.Shape;", depth))
}
/** @constructor */
function $c_Lamf_core_parser_DefaultScalarNode() {
  $c_O.call(this);
  this.node$1 = null;
  this.iv$1 = null
}
$c_Lamf_core_parser_DefaultScalarNode.prototype = new $h_O();
$c_Lamf_core_parser_DefaultScalarNode.prototype.constructor = $c_Lamf_core_parser_DefaultScalarNode;
/** @constructor */
function $h_Lamf_core_parser_DefaultScalarNode() {
  /*<skip>*/
}
$h_Lamf_core_parser_DefaultScalarNode.prototype = $c_Lamf_core_parser_DefaultScalarNode.prototype;
$c_Lamf_core_parser_DefaultScalarNode.prototype.productPrefix__T = (function() {
  return "DefaultScalarNode"
});
$c_Lamf_core_parser_DefaultScalarNode.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_parser_DefaultScalarNode.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_parser_DefaultScalarNode)) {
    var DefaultScalarNode$1 = $as_Lamf_core_parser_DefaultScalarNode(x$1);
    var this$1 = this.node$1;
    var b = DefaultScalarNode$1.node$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_core_parser_DefaultScalarNode.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.node$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_parser_DefaultScalarNode.prototype.negated__Lamf_core_model_domain_AmfElement = (function() {
  return this.negated__Lamf_core_model_domain_AmfScalar()
});
$c_Lamf_core_parser_DefaultScalarNode.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_parser_DefaultScalarNode.prototype.$double__Lamf_core_model_domain_AmfScalar = (function() {
  var arg1 = this.node$1;
  var conversion = $m_Lorg_yaml_convert_YRead$DoubleYRead$();
  var iv = this.iv$1;
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($uD($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(arg1, conversion, iv)), $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(this.node$1))
});
$c_Lamf_core_parser_DefaultScalarNode.prototype.init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler = (function(node, iv) {
  this.node$1 = node;
  this.iv$1 = iv;
  return this
});
$c_Lamf_core_parser_DefaultScalarNode.prototype.string__Lamf_core_model_domain_AmfScalar = (function() {
  var arg1 = this.node$1;
  var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
  var iv = this.iv$1;
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(arg1, conversion, iv)), $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(this.node$1))
});
$c_Lamf_core_parser_DefaultScalarNode.prototype.negated__Lamf_core_model_domain_AmfScalar = (function() {
  var arg1 = this.node$1;
  var conversion = $m_Lorg_yaml_convert_YRead$BooleanYRead$();
  var iv = this.iv$1;
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations((!$uZ($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(arg1, conversion, iv))), $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(this.node$1))
});
$c_Lamf_core_parser_DefaultScalarNode.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_parser_DefaultScalarNode.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_parser_DefaultScalarNode.prototype.text__Lamf_core_model_domain_AmfScalar = (function() {
  var arg1 = this.node$1;
  var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
  var iv = this.iv$1;
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(arg1, conversion, iv)).text$3, $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(this.node$1))
});
$c_Lamf_core_parser_DefaultScalarNode.prototype.$boolean__Lamf_core_model_domain_AmfScalar = (function() {
  var arg1 = this.node$1;
  var conversion = $m_Lorg_yaml_convert_YRead$BooleanYRead$();
  var iv = this.iv$1;
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($uZ($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(arg1, conversion, iv)), $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(this.node$1))
});
$c_Lamf_core_parser_DefaultScalarNode.prototype.integer__Lamf_core_model_domain_AmfScalar = (function() {
  var arg1 = this.node$1;
  var conversion = $m_Lorg_yaml_convert_YRead$IntYRead$();
  var iv = this.iv$1;
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($uI($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(arg1, conversion, iv)), $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(this.node$1))
});
function $as_Lamf_core_parser_DefaultScalarNode(obj) {
  return (((obj instanceof $c_Lamf_core_parser_DefaultScalarNode) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.DefaultScalarNode"))
}
function $isArrayOf_Lamf_core_parser_DefaultScalarNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_DefaultScalarNode)))
}
function $asArrayOf_Lamf_core_parser_DefaultScalarNode(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_DefaultScalarNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.DefaultScalarNode;", depth))
}
var $d_Lamf_core_parser_DefaultScalarNode = new $TypeData().initClass({
  Lamf_core_parser_DefaultScalarNode: 0
}, false, "amf.core.parser.DefaultScalarNode", {
  Lamf_core_parser_DefaultScalarNode: 1,
  O: 1,
  Lamf_core_parser_ScalarNode: 1,
  Lamf_core_parser_TypedNode: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_DefaultScalarNode.prototype.$classData = $d_Lamf_core_parser_DefaultScalarNode;
/** @constructor */
function $c_Lamf_core_parser_ParserContext() {
  $c_O.call(this);
  this.rootContextDocument$1 = null;
  this.refs$1 = null;
  this.futureDeclarations$1 = null;
  this.eh$1 = null;
  this.plugins$1 = null;
  this.globalSpace$1 = null;
  this.sonsReferences$1 = null;
  this.parserRun$1 = 0
}
$c_Lamf_core_parser_ParserContext.prototype = new $h_O();
$c_Lamf_core_parser_ParserContext.prototype.constructor = $c_Lamf_core_parser_ParserContext;
/** @constructor */
function $h_Lamf_core_parser_ParserContext() {
  /*<skip>*/
}
$h_Lamf_core_parser_ParserContext.prototype = $c_Lamf_core_parser_ParserContext.prototype;
$c_Lamf_core_parser_ParserContext.prototype.forLocation__T__Lamf_core_parser_ParserContext = (function(newLocation) {
  var refs = this.refs$1;
  var futureDeclarations = this.futureDeclarations$1;
  var eh = this.eh$1;
  var plugins = this.plugins$1;
  var copied = new $c_Lamf_core_parser_ParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext(newLocation, refs, futureDeclarations, eh, plugins);
  copied.globalSpace$1 = this.globalSpace$1;
  return copied
});
$c_Lamf_core_parser_ParserContext.prototype.handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V = (function(location, e) {
  this.eh$1.handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V(location, e)
});
$c_Lamf_core_parser_ParserContext.prototype.productPrefix__T = (function() {
  return "ParserContext"
});
$c_Lamf_core_parser_ParserContext.prototype.getSonsParsedReferences__p1__sc_Seq = (function() {
  var jsx$2 = this.sonsReferences$1.values__sc_Iterable();
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(u$2) {
      var u = $as_Lamf_core_model_document_BaseUnit(u$2);
      var this$1 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(u);
      return new $c_Lamf_core_parser_ParsedReference().init___Lamf_core_model_document_BaseUnit__Lamf_core_parser_Reference__s_Option(u, new $c_Lamf_core_parser_Reference().init___T__sc_Seq($as_T((this$1.isEmpty__Z() ? u.id__T() : this$1.get__O())), $m_sci_Nil$()), $m_s_None$())
    })
  })(this));
  var this$3 = $m_sc_Iterable$();
  return $as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2)).toSeq__sc_Seq()
});
$c_Lamf_core_parser_ParserContext.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_core_parser_ParserContext.prototype.copyWithSonsReferences__Lamf_core_parser_ParserContext = (function() {
  var jsx$2 = this.refs$1;
  var jsx$1 = this.getSonsParsedReferences__p1__sc_Seq();
  var this$1 = $m_sc_Seq$();
  var x$1 = $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  var x$2 = this.rootContextDocument$1;
  var x$3 = this.futureDeclarations$1;
  var x$4 = this.eh$1;
  var x$5 = this.plugins$1;
  var context = new $c_Lamf_core_parser_ParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext(x$2, x$1, x$3, x$4, x$5);
  context.globalSpace$1 = this.globalSpace$1;
  return context
});
$c_Lamf_core_parser_ParserContext.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_parser_ParserContext)) {
    var ParserContext$1 = $as_Lamf_core_parser_ParserContext(x$1);
    if ((this.rootContextDocument$1 === ParserContext$1.rootContextDocument$1)) {
      var x = this.refs$1;
      var x$2 = ParserContext$1.refs$1;
      var jsx$3 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$3 = this.futureDeclarations$1;
      var x$4 = ParserContext$1.futureDeclarations$1;
      var jsx$2 = (x$3 === x$4)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.eh$1;
      var x$6 = ParserContext$1.eh$1;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.plugins$1;
      var x$8 = ParserContext$1.plugins$1;
      return ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_parser_ParserContext.prototype.handle__Lorg_yaml_model_YError__O__O = (function(error, defaultValue) {
  return this.eh$1.handle__Lorg_yaml_model_YError__O__O(error, defaultValue)
});
$c_Lamf_core_parser_ParserContext.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.rootContextDocument$1;
      break
    }
    case 1: {
      return this.refs$1;
      break
    }
    case 2: {
      return this.futureDeclarations$1;
      break
    }
    case 3: {
      return this.eh$1;
      break
    }
    case 4: {
      return this.plugins$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_parser_ParserContext.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_parser_ParserContext.prototype.addSonRef__Lamf_core_model_document_BaseUnit__Lamf_core_parser_ParserContext = (function(ref) {
  var jsx$1 = this.sonsReferences$1;
  var this$1 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(ref);
  var x1 = jsx$1.get__O__s_Option((this$1.isEmpty__Z() ? ref.id__T() : this$1.get__O()));
  if ((!(x1 instanceof $c_s_Some))) {
    var jsx$2 = this.sonsReferences$1;
    var this$2 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(ref);
    jsx$2.put__O__O__s_Option((this$2.isEmpty__Z() ? ref.id__T() : this$2.get__O()), ref)
  };
  return this
});
$c_Lamf_core_parser_ParserContext.prototype.init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext = (function(rootContextDocument, refs, futureDeclarations, eh, plugins) {
  this.rootContextDocument$1 = rootContextDocument;
  this.refs$1 = refs;
  this.futureDeclarations$1 = futureDeclarations;
  this.eh$1 = eh;
  this.plugins$1 = plugins;
  this.globalSpace$1 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.sonsReferences$1 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.parserRun$1 = eh.parserRun__I();
  return this
});
$c_Lamf_core_parser_ParserContext.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_parser_ParserContext.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_parser_ParserContext(obj) {
  return (((obj instanceof $c_Lamf_core_parser_ParserContext) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.ParserContext"))
}
function $isArrayOf_Lamf_core_parser_ParserContext(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_ParserContext)))
}
function $asArrayOf_Lamf_core_parser_ParserContext(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_ParserContext(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.ParserContext;", depth))
}
var $d_Lamf_core_parser_ParserContext = new $TypeData().initClass({
  Lamf_core_parser_ParserContext: 0
}, false, "amf.core.parser.ParserContext", {
  Lamf_core_parser_ParserContext: 1,
  O: 1,
  Lorg_yaml_model_ParseErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_ParserContext.prototype.$classData = $d_Lamf_core_parser_ParserContext;
/** @constructor */
function $c_Lamf_core_parser_Position$ZERO$() {
  $c_Lamf_core_parser_Position.call(this)
}
$c_Lamf_core_parser_Position$ZERO$.prototype = new $h_Lamf_core_parser_Position();
$c_Lamf_core_parser_Position$ZERO$.prototype.constructor = $c_Lamf_core_parser_Position$ZERO$;
/** @constructor */
function $h_Lamf_core_parser_Position$ZERO$() {
  /*<skip>*/
}
$h_Lamf_core_parser_Position$ZERO$.prototype = $c_Lamf_core_parser_Position$ZERO$.prototype;
$c_Lamf_core_parser_Position$ZERO$.prototype.init___ = (function() {
  $c_Lamf_core_parser_Position.prototype.init___I__I.call(this, 0, 0);
  return this
});
$c_Lamf_core_parser_Position$ZERO$.prototype.compareTo__Lamf_core_parser_Position__I = (function(o) {
  return 1
});
$c_Lamf_core_parser_Position$ZERO$.prototype.compareTo__O__I = (function(x$1) {
  $as_Lamf_core_parser_Position(x$1);
  return 1
});
var $d_Lamf_core_parser_Position$ZERO$ = new $TypeData().initClass({
  Lamf_core_parser_Position$ZERO$: 0
}, false, "amf.core.parser.Position$ZERO$", {
  Lamf_core_parser_Position$ZERO$: 1,
  Lamf_core_parser_Position: 1,
  O: 1,
  jl_Comparable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_Position$ZERO$.prototype.$classData = $d_Lamf_core_parser_Position$ZERO$;
var $n_Lamf_core_parser_Position$ZERO$ = (void 0);
function $m_Lamf_core_parser_Position$ZERO$() {
  if ((!$n_Lamf_core_parser_Position$ZERO$)) {
    $n_Lamf_core_parser_Position$ZERO$ = new $c_Lamf_core_parser_Position$ZERO$().init___()
  };
  return $n_Lamf_core_parser_Position$ZERO$
}
/** @constructor */
function $c_Lamf_core_remote_FileNotFound() {
  $c_Lamf_core_remote_FileLoaderException.call(this);
  this.cause$3 = null
}
$c_Lamf_core_remote_FileNotFound.prototype = new $h_Lamf_core_remote_FileLoaderException();
$c_Lamf_core_remote_FileNotFound.prototype.constructor = $c_Lamf_core_remote_FileNotFound;
/** @constructor */
function $h_Lamf_core_remote_FileNotFound() {
  /*<skip>*/
}
$h_Lamf_core_remote_FileNotFound.prototype = $c_Lamf_core_remote_FileNotFound.prototype;
$c_Lamf_core_remote_FileNotFound.prototype.productPrefix__T = (function() {
  return "FileNotFound"
});
$c_Lamf_core_remote_FileNotFound.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_remote_FileNotFound.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_remote_FileNotFound)) {
    var FileNotFound$1 = $as_Lamf_core_remote_FileNotFound(x$1);
    var x = this.cause$3;
    var x$2 = FileNotFound$1.cause$3;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_core_remote_FileNotFound.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.cause$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_remote_FileNotFound.prototype.init___jl_Throwable = (function(cause) {
  this.cause$3 = cause;
  var msj = ("File Not Found: " + cause.getMessage__T());
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, msj, cause, true, true);
  return this
});
$c_Lamf_core_remote_FileNotFound.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_remote_FileNotFound.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_remote_FileNotFound(obj) {
  return (((obj instanceof $c_Lamf_core_remote_FileNotFound) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.remote.FileNotFound"))
}
function $isArrayOf_Lamf_core_remote_FileNotFound(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_remote_FileNotFound)))
}
function $asArrayOf_Lamf_core_remote_FileNotFound(obj, depth) {
  return (($isArrayOf_Lamf_core_remote_FileNotFound(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.remote.FileNotFound;", depth))
}
var $d_Lamf_core_remote_FileNotFound = new $TypeData().initClass({
  Lamf_core_remote_FileNotFound: 0
}, false, "amf.core.remote.FileNotFound", {
  Lamf_core_remote_FileNotFound: 1,
  Lamf_core_remote_FileLoaderException: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1
});
$c_Lamf_core_remote_FileNotFound.prototype.$classData = $d_Lamf_core_remote_FileNotFound;
/** @constructor */
function $c_Lamf_core_remote_NetworkError() {
  $c_Lamf_core_remote_FileLoaderException.call(this);
  this.cause$3 = null
}
$c_Lamf_core_remote_NetworkError.prototype = new $h_Lamf_core_remote_FileLoaderException();
$c_Lamf_core_remote_NetworkError.prototype.constructor = $c_Lamf_core_remote_NetworkError;
/** @constructor */
function $h_Lamf_core_remote_NetworkError() {
  /*<skip>*/
}
$h_Lamf_core_remote_NetworkError.prototype = $c_Lamf_core_remote_NetworkError.prototype;
$c_Lamf_core_remote_NetworkError.prototype.productPrefix__T = (function() {
  return "NetworkError"
});
$c_Lamf_core_remote_NetworkError.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_remote_NetworkError.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_remote_NetworkError)) {
    var NetworkError$1 = $as_Lamf_core_remote_NetworkError(x$1);
    var x = this.cause$3;
    var x$2 = NetworkError$1.cause$3;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_core_remote_NetworkError.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.cause$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_remote_NetworkError.prototype.init___jl_Throwable = (function(cause) {
  this.cause$3 = cause;
  var msj = ("Network Error: " + cause.getMessage__T());
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, msj, cause, true, true);
  return this
});
$c_Lamf_core_remote_NetworkError.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_remote_NetworkError.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_remote_NetworkError(obj) {
  return (((obj instanceof $c_Lamf_core_remote_NetworkError) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.remote.NetworkError"))
}
function $isArrayOf_Lamf_core_remote_NetworkError(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_remote_NetworkError)))
}
function $asArrayOf_Lamf_core_remote_NetworkError(obj, depth) {
  return (($isArrayOf_Lamf_core_remote_NetworkError(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.remote.NetworkError;", depth))
}
var $d_Lamf_core_remote_NetworkError = new $TypeData().initClass({
  Lamf_core_remote_NetworkError: 0
}, false, "amf.core.remote.NetworkError", {
  Lamf_core_remote_NetworkError: 1,
  Lamf_core_remote_FileLoaderException: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1
});
$c_Lamf_core_remote_NetworkError.prototype.$classData = $d_Lamf_core_remote_NetworkError;
/** @constructor */
function $c_Lamf_core_remote_UnexpectedStatusCode() {
  $c_jl_Exception.call(this);
  this.resource$3 = null;
  this.code$3 = 0
}
$c_Lamf_core_remote_UnexpectedStatusCode.prototype = new $h_jl_Exception();
$c_Lamf_core_remote_UnexpectedStatusCode.prototype.constructor = $c_Lamf_core_remote_UnexpectedStatusCode;
/** @constructor */
function $h_Lamf_core_remote_UnexpectedStatusCode() {
  /*<skip>*/
}
$h_Lamf_core_remote_UnexpectedStatusCode.prototype = $c_Lamf_core_remote_UnexpectedStatusCode.prototype;
$c_Lamf_core_remote_UnexpectedStatusCode.prototype.productPrefix__T = (function() {
  return "UnexpectedStatusCode"
});
$c_Lamf_core_remote_UnexpectedStatusCode.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_remote_UnexpectedStatusCode.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_remote_UnexpectedStatusCode)) {
    var UnexpectedStatusCode$1 = $as_Lamf_core_remote_UnexpectedStatusCode(x$1);
    return ((this.resource$3 === UnexpectedStatusCode$1.resource$3) && (this.code$3 === UnexpectedStatusCode$1.code$3))
  } else {
    return false
  }
});
$c_Lamf_core_remote_UnexpectedStatusCode.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.resource$3;
      break
    }
    case 1: {
      return this.code$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_remote_UnexpectedStatusCode.prototype.init___T__I = (function(resource, code) {
  this.resource$3 = resource;
  this.code$3 = code;
  var s = (((("Unexpected status code '" + code) + "' for resource '") + resource) + "'");
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, s, null, true, true);
  return this
});
$c_Lamf_core_remote_UnexpectedStatusCode.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.resource$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.code$3);
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 2)
});
$c_Lamf_core_remote_UnexpectedStatusCode.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_remote_UnexpectedStatusCode(obj) {
  return (((obj instanceof $c_Lamf_core_remote_UnexpectedStatusCode) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.remote.UnexpectedStatusCode"))
}
function $isArrayOf_Lamf_core_remote_UnexpectedStatusCode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_remote_UnexpectedStatusCode)))
}
function $asArrayOf_Lamf_core_remote_UnexpectedStatusCode(obj, depth) {
  return (($isArrayOf_Lamf_core_remote_UnexpectedStatusCode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.remote.UnexpectedStatusCode;", depth))
}
var $d_Lamf_core_remote_UnexpectedStatusCode = new $TypeData().initClass({
  Lamf_core_remote_UnexpectedStatusCode: 0
}, false, "amf.core.remote.UnexpectedStatusCode", {
  Lamf_core_remote_UnexpectedStatusCode: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1
});
$c_Lamf_core_remote_UnexpectedStatusCode.prototype.$classData = $d_Lamf_core_remote_UnexpectedStatusCode;
/** @constructor */
function $c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader() {
  $c_Lamf_client_resource_BaseHttpResourceLoader.call(this)
}
$c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader.prototype = new $h_Lamf_client_resource_BaseHttpResourceLoader();
$c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader.prototype.constructor = $c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader;
/** @constructor */
function $h_Lamf_core_remote_browser_JsBrowserHttpResourceLoader() {
  /*<skip>*/
}
$h_Lamf_core_remote_browser_JsBrowserHttpResourceLoader.prototype = $c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader.prototype;
$c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader.prototype.productPrefix__T = (function() {
  return "JsBrowserHttpResourceLoader"
});
$c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader) && ($as_Lamf_core_remote_browser_JsBrowserHttpResourceLoader(x$1), true))
});
$c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader.prototype.$$js$exported$meth$fetch__T__O = (function(resource) {
  return this.fetch__T__sjs_js_Promise(resource)
});
$c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader.prototype.fetch__T__sjs_js_Promise = (function(resource) {
  var jsx$1 = $m_sjs_js_JSConverters$JSRichFuture$();
  var this$3 = $m_Lorg_scalajs_dom_ext_Ajax$();
  var headers = $m_sci_Map$EmptyMap$();
  var f = this$3.apply__T__T__Lorg_scalajs_dom_ext_Ajax$InputData__I__sci_Map__Z__T__s_concurrent_Future("GET", resource, null, 0, headers, false, "").flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, resource$1) {
    return (function(xhr$2) {
      var x1 = $uI(xhr$2.status);
      switch (x1) {
        case 200: {
          return $m_s_concurrent_Future$().successful__O__s_concurrent_Future(new $c_Lamf_client_remote_Content().init___T__T($as_T(xhr$2.responseText), resource$1));
          break
        }
        default: {
          return $m_s_concurrent_Future$().failed__jl_Throwable__s_concurrent_Future(new $c_Lamf_core_remote_UnexpectedStatusCode().init___T__I(resource$1, x1))
        }
      }
    })
  })(this, resource)), $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext()).recover__s_PartialFunction__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader$$anonfun$fetch$2().init___Lamf_core_remote_browser_JsBrowserHttpResourceLoader(this), $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext());
  return jsx$1.toJSPromise$extension__s_concurrent_Future__s_concurrent_ExecutionContext__sjs_js_Promise(f, $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext())
});
$c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_remote_browser_JsBrowserHttpResourceLoader(obj) {
  return (((obj instanceof $c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.remote.browser.JsBrowserHttpResourceLoader"))
}
function $isArrayOf_Lamf_core_remote_browser_JsBrowserHttpResourceLoader(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_remote_browser_JsBrowserHttpResourceLoader)))
}
function $asArrayOf_Lamf_core_remote_browser_JsBrowserHttpResourceLoader(obj, depth) {
  return (($isArrayOf_Lamf_core_remote_browser_JsBrowserHttpResourceLoader(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.remote.browser.JsBrowserHttpResourceLoader;", depth))
}
var $d_Lamf_core_remote_browser_JsBrowserHttpResourceLoader = new $TypeData().initClass({
  Lamf_core_remote_browser_JsBrowserHttpResourceLoader: 0
}, false, "amf.core.remote.browser.JsBrowserHttpResourceLoader", {
  Lamf_core_remote_browser_JsBrowserHttpResourceLoader: 1,
  Lamf_client_resource_BaseHttpResourceLoader: 1,
  O: 1,
  Lamf_client_resource_ResourceLoader: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader.prototype.$classData = $d_Lamf_core_remote_browser_JsBrowserHttpResourceLoader;
/** @constructor */
function $c_Lamf_core_remote_server_JsServerFileResourceLoader() {
  $c_O.call(this)
}
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype = new $h_O();
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.constructor = $c_Lamf_core_remote_server_JsServerFileResourceLoader;
/** @constructor */
function $h_Lamf_core_remote_server_JsServerFileResourceLoader() {
  /*<skip>*/
}
$h_Lamf_core_remote_server_JsServerFileResourceLoader.prototype = $c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype;
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.productPrefix__T = (function() {
  return "JsServerFileResourceLoader"
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_core_remote_server_JsServerFileResourceLoader) && ($as_Lamf_core_remote_server_JsServerFileResourceLoader(x$1), true))
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.$$js$exported$meth$fetch__T__O = (function(resource) {
  return $f_Lamf_client_resource_BaseFileResourceLoader__fetch__T__sjs_js_Promise(this, resource)
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.ensureFileAuthority__T__T = (function(str) {
  return ((($uI(str.length) >= 0) && ($as_T(str.substring(0, $uI("file:".length))) === "file:")) ? str : ("file://" + str))
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.fetchFile__T__sjs_js_Promise = (function(resource) {
  var jsx$4 = $m_sjs_js_JSConverters$JSRichFuture$();
  var qual$1 = $m_Lorg_mulesoft_common_io_Fs$().asyncFile__T__Lorg_mulesoft_common_io_AsyncFile(resource);
  var ctx = $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext();
  var f = qual$1.read__T__s_concurrent_ExecutionContext__s_concurrent_Future("UTF-8", ctx).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, resource$1) {
    return (function(content$2) {
      var content = $as_jl_CharSequence(content$2);
      var jsx$3 = new $c_Lamf_core_lexer_CharSequenceStream().init___T__jl_CharSequence(resource$1, content);
      var jsx$2 = $this.ensureFileAuthority__T__T(resource$1);
      var this$1 = $m_Lamf_core_remote_FileMediaType$();
      var this$2 = $f_Lamf_core_remote_FileMediaType__extension__T__s_Option(this$1, resource$1);
      if (this$2.isEmpty__Z()) {
        var jsx$1 = $m_s_None$()
      } else {
        var arg1 = this$2.get__O();
        var extension = $as_T(arg1);
        var this$3 = $m_Lamf_core_remote_FileMediaType$();
        var jsx$1 = $f_Lamf_core_remote_FileMediaType__mimeFromExtension__T__s_Option(this$3, extension)
      };
      return new $c_Lamf_client_remote_Content().init___Lamf_core_lexer_CharStream__T__s_Option(jsx$3, jsx$2, jsx$1)
    })
  })(this, resource)), $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext()).recoverWith__s_PartialFunction__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_Lamf_core_remote_server_JsServerFileResourceLoader$$anonfun$fetchFile$3().init___Lamf_core_remote_server_JsServerFileResourceLoader__T(this, resource), $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext());
  return jsx$4.toJSPromise$extension__s_concurrent_Future__s_concurrent_ExecutionContext__sjs_js_Promise(f, $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext())
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.fetch__T__sjs_js_Promise = (function(resource) {
  return $f_Lamf_client_resource_BaseFileResourceLoader__fetch__T__sjs_js_Promise(this, resource)
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.$$js$exported$meth$fetchFile__T__O = (function(resource) {
  return this.fetchFile__T__sjs_js_Promise(resource)
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.$$js$exported$meth$ensureFileAuthority__T__O = (function(str) {
  return this.ensureFileAuthority__T__T(str)
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.$$js$exported$meth$accepts__T__O = (function(resource) {
  return $f_Lamf_client_resource_BaseFileResourceLoader__accepts__T__Z(this, resource)
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.accepts__T__Z = (function(resource) {
  return $f_Lamf_client_resource_BaseFileResourceLoader__accepts__T__Z(this, resource)
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.accepts = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$accepts__T__O(prep)
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.fetch = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$fetch__T__O(prep)
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.ensureFileAuthority = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$ensureFileAuthority__T__O(prep)
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.fetchFile = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$fetchFile__T__O(prep)
});
function $as_Lamf_core_remote_server_JsServerFileResourceLoader(obj) {
  return (((obj instanceof $c_Lamf_core_remote_server_JsServerFileResourceLoader) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.remote.server.JsServerFileResourceLoader"))
}
function $isArrayOf_Lamf_core_remote_server_JsServerFileResourceLoader(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_remote_server_JsServerFileResourceLoader)))
}
function $asArrayOf_Lamf_core_remote_server_JsServerFileResourceLoader(obj, depth) {
  return (($isArrayOf_Lamf_core_remote_server_JsServerFileResourceLoader(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.remote.server.JsServerFileResourceLoader;", depth))
}
var $d_Lamf_core_remote_server_JsServerFileResourceLoader = new $TypeData().initClass({
  Lamf_core_remote_server_JsServerFileResourceLoader: 0
}, false, "amf.core.remote.server.JsServerFileResourceLoader", {
  Lamf_core_remote_server_JsServerFileResourceLoader: 1,
  O: 1,
  Lamf_client_resource_BaseFileResourceLoader: 1,
  Lamf_client_resource_ResourceLoader: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.$classData = $d_Lamf_core_remote_server_JsServerFileResourceLoader;
/** @constructor */
function $c_Lamf_core_remote_server_JsServerHttpResourceLoader() {
  $c_Lamf_client_resource_BaseHttpResourceLoader.call(this)
}
$c_Lamf_core_remote_server_JsServerHttpResourceLoader.prototype = new $h_Lamf_client_resource_BaseHttpResourceLoader();
$c_Lamf_core_remote_server_JsServerHttpResourceLoader.prototype.constructor = $c_Lamf_core_remote_server_JsServerHttpResourceLoader;
/** @constructor */
function $h_Lamf_core_remote_server_JsServerHttpResourceLoader() {
  /*<skip>*/
}
$h_Lamf_core_remote_server_JsServerHttpResourceLoader.prototype = $c_Lamf_core_remote_server_JsServerHttpResourceLoader.prototype;
$c_Lamf_core_remote_server_JsServerHttpResourceLoader.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_remote_server_JsServerHttpResourceLoader.prototype.productPrefix__T = (function() {
  return "JsServerHttpResourceLoader"
});
$c_Lamf_core_remote_server_JsServerHttpResourceLoader.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_remote_server_JsServerHttpResourceLoader.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_core_remote_server_JsServerHttpResourceLoader) && ($as_Lamf_core_remote_server_JsServerHttpResourceLoader(x$1), true))
});
$c_Lamf_core_remote_server_JsServerHttpResourceLoader.prototype.amf$core$remote$server$JsServerHttpResourceLoader$$$anonfun$handleResponse$2__O__sr_ObjectRef__O = (function(res, str$1) {
  str$1.elem$1 = (("" + $as_T(str$1.elem$1)) + $objectToString(res))
});
$c_Lamf_core_remote_server_JsServerHttpResourceLoader.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_remote_server_JsServerHttpResourceLoader.prototype.$$js$exported$meth$fetch__T__O = (function(resource) {
  return this.fetch__T__sjs_js_Promise(resource)
});
$c_Lamf_core_remote_server_JsServerHttpResourceLoader.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_remote_server_JsServerHttpResourceLoader.prototype.fetch__T__sjs_js_Promise = (function(resource) {
  var promise = new $c_s_concurrent_impl_Promise$DefaultPromise().init___();
  if ((($uI(resource.length) >= 0) && ($as_T(resource.substring(0, $uI("https:".length))) === "https:"))) {
    try {
      var req = $i_https.get(resource, this.handleResponse__p2__T__s_concurrent_Promise__sjs_js_Function1(resource, promise));
      req.on("error", this.handleError__p2__s_concurrent_Promise__sjs_js_Function(promise))
    } catch (e) {
      var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
      if ((e$2 !== null)) {
        var cause = new $c_Lamf_core_remote_NetworkError().init___jl_Throwable(e$2);
        $f_s_concurrent_Promise__failure__jl_Throwable__s_concurrent_Promise(promise, cause)
      } else {
        throw e
      }
    }
  } else {
    try {
      var req$2 = $i_http.get(resource, this.handleResponse__p2__T__s_concurrent_Promise__sjs_js_Function1(resource, promise));
      req$2.on("error", this.handleError__p2__s_concurrent_Promise__sjs_js_Function(promise))
    } catch (e$4) {
      var e$5 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e$4);
      if ((e$5 !== null)) {
        var cause$1 = new $c_Lamf_core_remote_NetworkError().init___jl_Throwable(e$5);
        $f_s_concurrent_Promise__failure__jl_Throwable__s_concurrent_Promise(promise, cause$1)
      } else {
        throw e$4
      }
    }
  };
  var jsx$1 = $m_sjs_js_JSConverters$JSRichFuture$();
  var pf = new $c_Lamf_core_remote_server_JsServerHttpResourceLoader$$anonfun$fetch$1().init___Lamf_core_remote_server_JsServerHttpResourceLoader(this);
  var executor = $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext();
  var f = $f_s_concurrent_Future__recover__s_PartialFunction__s_concurrent_ExecutionContext__s_concurrent_Future(promise, pf, executor);
  return jsx$1.toJSPromise$extension__s_concurrent_Future__s_concurrent_ExecutionContext__sjs_js_Promise(f, $m_s_concurrent_ExecutionContext$Implicits$().global__s_concurrent_ExecutionContext())
});
$c_Lamf_core_remote_server_JsServerHttpResourceLoader.prototype.handleError__p2__s_concurrent_Promise__sjs_js_Function = (function(promise) {
  return (function($this, promise$1) {
    return (function(e$2) {
      var cause = new $c_Lamf_core_remote_NetworkError().init___jl_Throwable(new $c_jl_Exception().init___T($objectToString(e$2)));
      return $f_s_concurrent_Promise__failure__jl_Throwable__s_concurrent_Promise(promise$1, cause)
    })
  })(this, promise)
});
$c_Lamf_core_remote_server_JsServerHttpResourceLoader.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_remote_server_JsServerHttpResourceLoader.prototype.amf$core$remote$server$JsServerHttpResourceLoader$$$anonfun$handleResponse$1__sjs_js_Dynamic__s_concurrent_Promise__T__O = (function(response, promise$2, resource$1) {
  var str = new $c_sr_ObjectRef().init___O("");
  var code = $uI(response.statusCode);
  if ((code >= 300)) {
    var cause = new $c_Lamf_core_remote_UnexpectedStatusCode().init___T__I(resource$1, code);
    return $f_s_concurrent_Promise__failure__jl_Throwable__s_concurrent_Promise(promise$2, cause)
  } else {
    var dataCb = (function(arg$outer, str$1) {
      return (function(arg1$2) {
        return arg$outer.amf$core$remote$server$JsServerHttpResourceLoader$$$anonfun$handleResponse$2__O__sr_ObjectRef__O(arg1$2, str$1)
      })
    })(this, str);
    response.on("data", dataCb);
    var completedCb = (function($this, response$1, promise$2$1, str$2, resource$1$1) {
      return (function() {
        try {
          var dict = response$1.headers;
          if ($uZ($m_sjs_js_WrappedDictionary$Cache$().safeHasOwnProperty$1.call(dict, "content-type"))) {
            var jsx$1 = dict["content-type"]
          } else {
            var jsx$1;
            throw new $c_ju_NoSuchElementException().init___T("key not found: content-type")
          };
          var mediaType = new $c_s_Some().init___O(jsx$1)
        } catch (e) {
          var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
          if ((e$2 !== null)) {
            var mediaType = $m_s_None$()
          } else {
            var mediaType;
            throw e
          }
        };
        var value = new $c_Lamf_client_remote_Content().init___T__T__s_Option($as_T(str$2.elem$1), resource$1$1, mediaType);
        return $f_s_concurrent_Promise__success__O__s_concurrent_Promise(promise$2$1, value)
      })
    })(this, response, promise$2, str, resource$1);
    return response.on("end", completedCb)
  }
});
$c_Lamf_core_remote_server_JsServerHttpResourceLoader.prototype.handleResponse__p2__T__s_concurrent_Promise__sjs_js_Function1 = (function(resource, promise) {
  return (function(arg$outer, promise$2, resource$1) {
    return (function(arg1$2) {
      return arg$outer.amf$core$remote$server$JsServerHttpResourceLoader$$$anonfun$handleResponse$1__sjs_js_Dynamic__s_concurrent_Promise__T__O(arg1$2, promise$2, resource$1)
    })
  })(this, promise, resource)
});
$c_Lamf_core_remote_server_JsServerHttpResourceLoader.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_remote_server_JsServerHttpResourceLoader(obj) {
  return (((obj instanceof $c_Lamf_core_remote_server_JsServerHttpResourceLoader) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.remote.server.JsServerHttpResourceLoader"))
}
function $isArrayOf_Lamf_core_remote_server_JsServerHttpResourceLoader(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_remote_server_JsServerHttpResourceLoader)))
}
function $asArrayOf_Lamf_core_remote_server_JsServerHttpResourceLoader(obj, depth) {
  return (($isArrayOf_Lamf_core_remote_server_JsServerHttpResourceLoader(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.remote.server.JsServerHttpResourceLoader;", depth))
}
var $d_Lamf_core_remote_server_JsServerHttpResourceLoader = new $TypeData().initClass({
  Lamf_core_remote_server_JsServerHttpResourceLoader: 0
}, false, "amf.core.remote.server.JsServerHttpResourceLoader", {
  Lamf_core_remote_server_JsServerHttpResourceLoader: 1,
  Lamf_client_resource_BaseHttpResourceLoader: 1,
  O: 1,
  Lamf_client_resource_ResourceLoader: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_remote_server_JsServerHttpResourceLoader.prototype.$classData = $d_Lamf_core_remote_server_JsServerHttpResourceLoader;
/** @constructor */
function $c_Lamf_core_resolution_stages_selectors_AndSelector() {
  $c_Lamf_core_resolution_stages_selectors_Selector.call(this);
  this.s0$2 = null;
  this.s1$2 = null
}
$c_Lamf_core_resolution_stages_selectors_AndSelector.prototype = new $h_Lamf_core_resolution_stages_selectors_Selector();
$c_Lamf_core_resolution_stages_selectors_AndSelector.prototype.constructor = $c_Lamf_core_resolution_stages_selectors_AndSelector;
/** @constructor */
function $h_Lamf_core_resolution_stages_selectors_AndSelector() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_selectors_AndSelector.prototype = $c_Lamf_core_resolution_stages_selectors_AndSelector.prototype;
$c_Lamf_core_resolution_stages_selectors_AndSelector.prototype.apply__O__O = (function(v1) {
  return this.apply__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(v1))
});
$c_Lamf_core_resolution_stages_selectors_AndSelector.prototype.init___Lamf_core_resolution_stages_selectors_Selector__Lamf_core_resolution_stages_selectors_Selector = (function(s0, s1) {
  this.s0$2 = s0;
  this.s1$2 = s1;
  return this
});
$c_Lamf_core_resolution_stages_selectors_AndSelector.prototype.apply__Lamf_core_model_domain_DomainElement__Z = (function(element) {
  var this$1 = this.s0$2;
  if (this$1.apply__Lamf_core_model_domain_DomainElement__Z(element)) {
    var this$2 = this.s1$2;
    return this$2.apply__Lamf_core_model_domain_DomainElement__Z(element)
  } else {
    return false
  }
});
var $d_Lamf_core_resolution_stages_selectors_AndSelector = new $TypeData().initClass({
  Lamf_core_resolution_stages_selectors_AndSelector: 0
}, false, "amf.core.resolution.stages.selectors.AndSelector", {
  Lamf_core_resolution_stages_selectors_AndSelector: 1,
  Lamf_core_resolution_stages_selectors_Selector: 1,
  O: 1,
  F1: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_resolution_stages_selectors_AndSelector.prototype.$classData = $d_Lamf_core_resolution_stages_selectors_AndSelector;
/** @constructor */
function $c_Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$() {
  $c_Lamf_core_resolution_stages_selectors_Selector.call(this)
}
$c_Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$.prototype = new $h_Lamf_core_resolution_stages_selectors_Selector();
$c_Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$.prototype.constructor = $c_Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$;
/** @constructor */
function $h_Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$.prototype = $c_Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$.prototype;
$c_Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$.prototype.apply__O__O = (function(v1) {
  return this.apply__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(v1))
});
$c_Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$.prototype.apply__Lamf_core_model_domain_DomainElement__Z = (function(element) {
  if ($is_Lamf_core_model_domain_ExternalSourceElement(element)) {
    var x2 = $as_Lamf_core_model_domain_ExternalSourceElement(element);
    var this$1 = x2.fields__Lamf_core_parser_Fields();
    var f = $m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().ReferenceId$1;
    return this$1.fs$1.contains__O__Z(f)
  } else {
    return false
  }
});
var $d_Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$ = new $TypeData().initClass({
  Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$: 0
}, false, "amf.core.resolution.stages.selectors.ExternalSourceElementSelector$", {
  Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$: 1,
  Lamf_core_resolution_stages_selectors_Selector: 1,
  O: 1,
  F1: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$.prototype.$classData = $d_Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$;
var $n_Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$ = (void 0);
function $m_Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$() {
  if ((!$n_Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$)) {
    $n_Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$ = new $c_Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$().init___()
  };
  return $n_Lamf_core_resolution_stages_selectors_ExternalSourceElementSelector$
}
/** @constructor */
function $c_Lamf_core_resolution_stages_selectors_KnownElementIdSelector() {
  $c_Lamf_core_resolution_stages_selectors_Selector.call(this);
  this.visited$2 = null
}
$c_Lamf_core_resolution_stages_selectors_KnownElementIdSelector.prototype = new $h_Lamf_core_resolution_stages_selectors_Selector();
$c_Lamf_core_resolution_stages_selectors_KnownElementIdSelector.prototype.constructor = $c_Lamf_core_resolution_stages_selectors_KnownElementIdSelector;
/** @constructor */
function $h_Lamf_core_resolution_stages_selectors_KnownElementIdSelector() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_selectors_KnownElementIdSelector.prototype = $c_Lamf_core_resolution_stages_selectors_KnownElementIdSelector.prototype;
$c_Lamf_core_resolution_stages_selectors_KnownElementIdSelector.prototype.apply__O__O = (function(v1) {
  return this.apply__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(v1))
});
$c_Lamf_core_resolution_stages_selectors_KnownElementIdSelector.prototype.apply__Lamf_core_model_domain_DomainElement__Z = (function(element) {
  return (this.visited$2.contains__O__Z(element.id__T()) || (this.visited$2.$$plus$eq__O__scm_SetLike(element.id__T()), false))
});
$c_Lamf_core_resolution_stages_selectors_KnownElementIdSelector.prototype.init___scm_Set = (function(visited) {
  this.visited$2 = visited;
  return this
});
var $d_Lamf_core_resolution_stages_selectors_KnownElementIdSelector = new $TypeData().initClass({
  Lamf_core_resolution_stages_selectors_KnownElementIdSelector: 0
}, false, "amf.core.resolution.stages.selectors.KnownElementIdSelector", {
  Lamf_core_resolution_stages_selectors_KnownElementIdSelector: 1,
  Lamf_core_resolution_stages_selectors_Selector: 1,
  O: 1,
  F1: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_resolution_stages_selectors_KnownElementIdSelector.prototype.$classData = $d_Lamf_core_resolution_stages_selectors_KnownElementIdSelector;
/** @constructor */
function $c_Lamf_core_resolution_stages_selectors_LinkNodeSelector$() {
  $c_Lamf_core_resolution_stages_selectors_Selector.call(this)
}
$c_Lamf_core_resolution_stages_selectors_LinkNodeSelector$.prototype = new $h_Lamf_core_resolution_stages_selectors_Selector();
$c_Lamf_core_resolution_stages_selectors_LinkNodeSelector$.prototype.constructor = $c_Lamf_core_resolution_stages_selectors_LinkNodeSelector$;
/** @constructor */
function $h_Lamf_core_resolution_stages_selectors_LinkNodeSelector$() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_selectors_LinkNodeSelector$.prototype = $c_Lamf_core_resolution_stages_selectors_LinkNodeSelector$.prototype;
$c_Lamf_core_resolution_stages_selectors_LinkNodeSelector$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_resolution_stages_selectors_LinkNodeSelector$.prototype.apply__O__O = (function(v1) {
  return this.apply__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(v1))
});
$c_Lamf_core_resolution_stages_selectors_LinkNodeSelector$.prototype.apply__Lamf_core_model_domain_DomainElement__Z = (function(element) {
  return (element instanceof $c_Lamf_core_model_domain_LinkNode)
});
var $d_Lamf_core_resolution_stages_selectors_LinkNodeSelector$ = new $TypeData().initClass({
  Lamf_core_resolution_stages_selectors_LinkNodeSelector$: 0
}, false, "amf.core.resolution.stages.selectors.LinkNodeSelector$", {
  Lamf_core_resolution_stages_selectors_LinkNodeSelector$: 1,
  Lamf_core_resolution_stages_selectors_Selector: 1,
  O: 1,
  F1: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_resolution_stages_selectors_LinkNodeSelector$.prototype.$classData = $d_Lamf_core_resolution_stages_selectors_LinkNodeSelector$;
var $n_Lamf_core_resolution_stages_selectors_LinkNodeSelector$ = (void 0);
function $m_Lamf_core_resolution_stages_selectors_LinkNodeSelector$() {
  if ((!$n_Lamf_core_resolution_stages_selectors_LinkNodeSelector$)) {
    $n_Lamf_core_resolution_stages_selectors_LinkNodeSelector$ = new $c_Lamf_core_resolution_stages_selectors_LinkNodeSelector$().init___()
  };
  return $n_Lamf_core_resolution_stages_selectors_LinkNodeSelector$
}
/** @constructor */
function $c_Lamf_core_resolution_stages_selectors_LinkSelector$() {
  $c_Lamf_core_resolution_stages_selectors_Selector.call(this)
}
$c_Lamf_core_resolution_stages_selectors_LinkSelector$.prototype = new $h_Lamf_core_resolution_stages_selectors_Selector();
$c_Lamf_core_resolution_stages_selectors_LinkSelector$.prototype.constructor = $c_Lamf_core_resolution_stages_selectors_LinkSelector$;
/** @constructor */
function $h_Lamf_core_resolution_stages_selectors_LinkSelector$() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_selectors_LinkSelector$.prototype = $c_Lamf_core_resolution_stages_selectors_LinkSelector$.prototype;
$c_Lamf_core_resolution_stages_selectors_LinkSelector$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_resolution_stages_selectors_LinkSelector$.prototype.apply__O__O = (function(v1) {
  return this.apply__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(v1))
});
$c_Lamf_core_resolution_stages_selectors_LinkSelector$.prototype.apply__Lamf_core_model_domain_DomainElement__Z = (function(element) {
  if ($is_Lamf_core_model_domain_Linkable(element)) {
    var this$1 = $as_Lamf_core_model_domain_Linkable(element);
    return $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1).isDefined__Z()
  } else {
    return false
  }
});
var $d_Lamf_core_resolution_stages_selectors_LinkSelector$ = new $TypeData().initClass({
  Lamf_core_resolution_stages_selectors_LinkSelector$: 0
}, false, "amf.core.resolution.stages.selectors.LinkSelector$", {
  Lamf_core_resolution_stages_selectors_LinkSelector$: 1,
  Lamf_core_resolution_stages_selectors_Selector: 1,
  O: 1,
  F1: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_resolution_stages_selectors_LinkSelector$.prototype.$classData = $d_Lamf_core_resolution_stages_selectors_LinkSelector$;
var $n_Lamf_core_resolution_stages_selectors_LinkSelector$ = (void 0);
function $m_Lamf_core_resolution_stages_selectors_LinkSelector$() {
  if ((!$n_Lamf_core_resolution_stages_selectors_LinkSelector$)) {
    $n_Lamf_core_resolution_stages_selectors_LinkSelector$ = new $c_Lamf_core_resolution_stages_selectors_LinkSelector$().init___()
  };
  return $n_Lamf_core_resolution_stages_selectors_LinkSelector$
}
/** @constructor */
function $c_Lamf_core_resolution_stages_selectors_OrSelector() {
  $c_Lamf_core_resolution_stages_selectors_Selector.call(this);
  this.s0$2 = null;
  this.s1$2 = null
}
$c_Lamf_core_resolution_stages_selectors_OrSelector.prototype = new $h_Lamf_core_resolution_stages_selectors_Selector();
$c_Lamf_core_resolution_stages_selectors_OrSelector.prototype.constructor = $c_Lamf_core_resolution_stages_selectors_OrSelector;
/** @constructor */
function $h_Lamf_core_resolution_stages_selectors_OrSelector() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_selectors_OrSelector.prototype = $c_Lamf_core_resolution_stages_selectors_OrSelector.prototype;
$c_Lamf_core_resolution_stages_selectors_OrSelector.prototype.apply__O__O = (function(v1) {
  return this.apply__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(v1))
});
$c_Lamf_core_resolution_stages_selectors_OrSelector.prototype.init___Lamf_core_resolution_stages_selectors_Selector__Lamf_core_resolution_stages_selectors_Selector = (function(s0, s1) {
  this.s0$2 = s0;
  this.s1$2 = s1;
  return this
});
$c_Lamf_core_resolution_stages_selectors_OrSelector.prototype.apply__Lamf_core_model_domain_DomainElement__Z = (function(element) {
  var this$1 = this.s0$2;
  if (this$1.apply__Lamf_core_model_domain_DomainElement__Z(element)) {
    return true
  } else {
    var this$2 = this.s1$2;
    return this$2.apply__Lamf_core_model_domain_DomainElement__Z(element)
  }
});
var $d_Lamf_core_resolution_stages_selectors_OrSelector = new $TypeData().initClass({
  Lamf_core_resolution_stages_selectors_OrSelector: 0
}, false, "amf.core.resolution.stages.selectors.OrSelector", {
  Lamf_core_resolution_stages_selectors_OrSelector: 1,
  Lamf_core_resolution_stages_selectors_Selector: 1,
  O: 1,
  F1: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_resolution_stages_selectors_OrSelector.prototype.$classData = $d_Lamf_core_resolution_stages_selectors_OrSelector;
/** @constructor */
function $c_Lamf_core_traversal_BaseUnitFieldOrdering() {
  $c_O.call(this)
}
$c_Lamf_core_traversal_BaseUnitFieldOrdering.prototype = new $h_O();
$c_Lamf_core_traversal_BaseUnitFieldOrdering.prototype.constructor = $c_Lamf_core_traversal_BaseUnitFieldOrdering;
/** @constructor */
function $h_Lamf_core_traversal_BaseUnitFieldOrdering() {
  /*<skip>*/
}
$h_Lamf_core_traversal_BaseUnitFieldOrdering.prototype = $c_Lamf_core_traversal_BaseUnitFieldOrdering.prototype;
$c_Lamf_core_traversal_BaseUnitFieldOrdering.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_traversal_BaseUnitFieldOrdering.prototype.gteq__O__O__Z = (function(x, y) {
  return $f_s_math_Ordering__gteq__O__O__Z(this, x, y)
});
$c_Lamf_core_traversal_BaseUnitFieldOrdering.prototype.compare__O__O__I = (function(x, y) {
  return this.compare__Lamf_core_parser_FieldEntry__Lamf_core_parser_FieldEntry__I($as_Lamf_core_parser_FieldEntry(x), $as_Lamf_core_parser_FieldEntry(y))
});
$c_Lamf_core_traversal_BaseUnitFieldOrdering.prototype.compare__Lamf_core_parser_FieldEntry__Lamf_core_parser_FieldEntry__I = (function(x, y) {
  var _1 = x.field$1;
  var _2 = y.field$1;
  var x$2 = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
  if (((x$2 === null) ? (_1 === null) : x$2.equals__O__Z(_1))) {
    return (-1)
  } else {
    var x$4 = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
    if (((x$4 === null) ? (_2 === null) : x$4.equals__O__Z(_2))) {
      return 1
    } else {
      return 0
    }
  }
});
$c_Lamf_core_traversal_BaseUnitFieldOrdering.prototype.lteq__O__O__Z = (function(x, y) {
  return $f_s_math_Ordering__lteq__O__O__Z(this, x, y)
});
var $d_Lamf_core_traversal_BaseUnitFieldOrdering = new $TypeData().initClass({
  Lamf_core_traversal_BaseUnitFieldOrdering: 0
}, false, "amf.core.traversal.BaseUnitFieldOrdering", {
  Lamf_core_traversal_BaseUnitFieldOrdering: 1,
  O: 1,
  s_math_Ordering: 1,
  ju_Comparator: 1,
  s_math_PartialOrdering: 1,
  s_math_Equiv: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_traversal_BaseUnitFieldOrdering.prototype.$classData = $d_Lamf_core_traversal_BaseUnitFieldOrdering;
/** @constructor */
function $c_Lamf_core_traversal_DeclaresModelFieldOrdering() {
  $c_O.call(this)
}
$c_Lamf_core_traversal_DeclaresModelFieldOrdering.prototype = new $h_O();
$c_Lamf_core_traversal_DeclaresModelFieldOrdering.prototype.constructor = $c_Lamf_core_traversal_DeclaresModelFieldOrdering;
/** @constructor */
function $h_Lamf_core_traversal_DeclaresModelFieldOrdering() {
  /*<skip>*/
}
$h_Lamf_core_traversal_DeclaresModelFieldOrdering.prototype = $c_Lamf_core_traversal_DeclaresModelFieldOrdering.prototype;
$c_Lamf_core_traversal_DeclaresModelFieldOrdering.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_traversal_DeclaresModelFieldOrdering.prototype.gteq__O__O__Z = (function(x, y) {
  return $f_s_math_Ordering__gteq__O__O__Z(this, x, y)
});
$c_Lamf_core_traversal_DeclaresModelFieldOrdering.prototype.compare__O__O__I = (function(x, y) {
  return this.compare__Lamf_core_parser_FieldEntry__Lamf_core_parser_FieldEntry__I($as_Lamf_core_parser_FieldEntry(x), $as_Lamf_core_parser_FieldEntry(y))
});
$c_Lamf_core_traversal_DeclaresModelFieldOrdering.prototype.compare__Lamf_core_parser_FieldEntry__Lamf_core_parser_FieldEntry__I = (function(x, y) {
  var _1 = x.field$1;
  var _2 = y.field$1;
  var x$2 = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
  if (((x$2 === null) ? (_1 === null) : x$2.equals__O__Z(_1))) {
    return (-1)
  } else {
    var x$4 = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
    if (((x$4 === null) ? (_2 === null) : x$4.equals__O__Z(_2))) {
      return 1
    } else {
      var x$6 = $m_Lamf_core_metamodel_document_DocumentModel$().Declares$1;
      if (((x$6 === null) ? (_1 === null) : x$6.equals__O__Z(_1))) {
        return (-1)
      } else {
        var x$8 = $m_Lamf_core_metamodel_document_DocumentModel$().Declares$1;
        if (((x$8 === null) ? (_2 === null) : x$8.equals__O__Z(_2))) {
          return 1
        } else {
          return 0
        }
      }
    }
  }
});
$c_Lamf_core_traversal_DeclaresModelFieldOrdering.prototype.lteq__O__O__Z = (function(x, y) {
  return $f_s_math_Ordering__lteq__O__O__Z(this, x, y)
});
var $d_Lamf_core_traversal_DeclaresModelFieldOrdering = new $TypeData().initClass({
  Lamf_core_traversal_DeclaresModelFieldOrdering: 0
}, false, "amf.core.traversal.DeclaresModelFieldOrdering", {
  Lamf_core_traversal_DeclaresModelFieldOrdering: 1,
  O: 1,
  s_math_Ordering: 1,
  ju_Comparator: 1,
  s_math_PartialOrdering: 1,
  s_math_Equiv: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_traversal_DeclaresModelFieldOrdering.prototype.$classData = $d_Lamf_core_traversal_DeclaresModelFieldOrdering;
/** @constructor */
function $c_Lamf_core_validation_AMFValidationResult() {
  $c_O.call(this);
  this.message$1 = null;
  this.level$1 = null;
  this.targetNode$1 = null;
  this.targetProperty$1 = null;
  this.validationId$1 = null;
  this.position$1 = null;
  this.location$1 = null;
  this.source$1 = null;
  this.completeMessage$1 = null
}
$c_Lamf_core_validation_AMFValidationResult.prototype = new $h_O();
$c_Lamf_core_validation_AMFValidationResult.prototype.constructor = $c_Lamf_core_validation_AMFValidationResult;
/** @constructor */
function $h_Lamf_core_validation_AMFValidationResult() {
  /*<skip>*/
}
$h_Lamf_core_validation_AMFValidationResult.prototype = $c_Lamf_core_validation_AMFValidationResult.prototype;
$c_Lamf_core_validation_AMFValidationResult.prototype.productPrefix__T = (function() {
  return "AMFValidationResult"
});
$c_Lamf_core_validation_AMFValidationResult.prototype.productArity__I = (function() {
  return 8
});
$c_Lamf_core_validation_AMFValidationResult.prototype.equals__O__Z = (function(obj) {
  if ((obj instanceof $c_Lamf_core_validation_AMFValidationResult)) {
    var x2 = $as_Lamf_core_validation_AMFValidationResult(obj);
    var this$1 = x2.message$1;
    var that = this.message$1;
    if (((this$1 === that) && (x2.validationId$1 === this.validationId$1))) {
      var jsx$3 = $m_sr_BoxesRunTime$();
      var this$2 = x2.location$1;
      var jsx$2 = (this$2.isEmpty__Z() ? "" : this$2.get__O());
      var this$3 = this.location$1;
      var jsx$1 = jsx$3.equals__O__O__Z(jsx$2, (this$3.isEmpty__Z() ? "" : this$3.get__O()))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return this.samePosition__p1__s_Option__Z(x2.position$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_validation_AMFValidationResult.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.message$1;
      break
    }
    case 1: {
      return this.level$1;
      break
    }
    case 2: {
      return this.targetNode$1;
      break
    }
    case 3: {
      return this.targetProperty$1;
      break
    }
    case 4: {
      return this.validationId$1;
      break
    }
    case 5: {
      return this.position$1;
      break
    }
    case 6: {
      return this.location$1;
      break
    }
    case 7: {
      return this.source$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_validation_AMFValidationResult.prototype.toString__T = (function() {
  $m_s_package$();
  var str = new $c_scm_StringBuilder().init___();
  str.append__T__scm_StringBuilder((("\n- Source: " + this.validationId$1) + "\n"));
  str.append__T__scm_StringBuilder((("  Message: " + this.message$1) + "\n"));
  str.append__T__scm_StringBuilder((("  Level: " + this.level$1) + "\n"));
  str.append__T__scm_StringBuilder((("  Target: " + this.targetNode$1) + "\n"));
  var this$2 = this.targetProperty$1;
  str.append__T__scm_StringBuilder((("  Property: " + (this$2.isEmpty__Z() ? "" : this$2.get__O())) + "\n"));
  str.append__T__scm_StringBuilder((("  Position: " + this.position$1) + "\n"));
  var this$3 = this.location$1;
  str.append__T__scm_StringBuilder((("  Location: " + (this$3.isEmpty__Z() ? "" : this$3.get__O())) + "\n"));
  return str.underlying$5.java$lang$StringBuilder$$content$f
});
$c_Lamf_core_validation_AMFValidationResult.prototype.compareTo__O__I = (function(that) {
  return this.compare__Lamf_core_validation_AMFValidationResult__I($as_Lamf_core_validation_AMFValidationResult(that))
});
$c_Lamf_core_validation_AMFValidationResult.prototype.compare__O__I = (function(that) {
  return this.compare__Lamf_core_validation_AMFValidationResult__I($as_Lamf_core_validation_AMFValidationResult(that))
});
$c_Lamf_core_validation_AMFValidationResult.prototype.init___T__T__T__s_Option__T__s_Option__s_Option__O = (function(message, level, targetNode, targetProperty, validationId, position, location, source) {
  this.message$1 = message;
  this.level$1 = level;
  this.targetNode$1 = targetNode;
  this.targetProperty$1 = targetProperty;
  this.validationId$1 = validationId;
  this.position$1 = position;
  this.location$1 = location;
  this.source$1 = source;
  $m_s_package$();
  var str = new $c_scm_StringBuilder().init___();
  str.append__T__scm_StringBuilder((("\n- Source: " + validationId) + "\n"));
  str.append__T__scm_StringBuilder((("  Message: " + message) + "\n"));
  str.append__T__scm_StringBuilder((("  Property: " + (targetProperty.isEmpty__Z() ? "" : targetProperty.get__O())) + "\n"));
  this.completeMessage$1 = str.underlying$5.java$lang$StringBuilder$$content$f;
  return this
});
$c_Lamf_core_validation_AMFValidationResult.prototype.samePosition__p1__s_Option__Z = (function(otherPosition) {
  if ((otherPosition instanceof $c_s_Some)) {
    var x2 = $as_s_Some(otherPosition);
    var otherPos = $as_Lamf_core_annotations_LexicalInformation(x2.value$2);
    if (this.position$1.isDefined__Z()) {
      var pos = $as_Lamf_core_annotations_LexicalInformation(this.position$1.get__O());
      var this$1 = otherPos.range__Lamf_core_parser_Range().toString__T();
      var that = pos.range__Lamf_core_parser_Range().toString__T();
      return (this$1 === that)
    }
  };
  return this.position$1.isEmpty__Z()
});
$c_Lamf_core_validation_AMFValidationResult.prototype.hashCode__I = (function() {
  return $systemIdentityHashCode(this)
});
$c_Lamf_core_validation_AMFValidationResult.prototype.compare__Lamf_core_validation_AMFValidationResult__I = (function(that) {
  var thatPosition = ((that.position$1 !== null) ? that.position$1 : $m_s_None$());
  var thisPosition = ((this.position$1 !== null) ? this.position$1 : $m_s_None$());
  if (thisPosition.isEmpty__Z()) {
    var this$1 = $m_s_None$()
  } else {
    var arg1 = thisPosition.get__O();
    var x$1 = $as_Lamf_core_annotations_LexicalInformation(arg1);
    var this$1 = new $c_s_Some().init___O(x$1.range__Lamf_core_parser_Range().start$1)
  };
  var jsx$1 = $as_Lamf_core_parser_Position((this$1.isEmpty__Z() ? new $c_Lamf_core_parser_Position().init___I__I(0, 0) : this$1.get__O()));
  if (thatPosition.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1$1 = thatPosition.get__O();
    var x$2 = $as_Lamf_core_annotations_LexicalInformation(arg1$1);
    var this$2 = new $c_s_Some().init___O(x$2.range__Lamf_core_parser_Range().start$1)
  };
  var x1 = jsx$1.compareTo__Lamf_core_parser_Position__I($as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? new $c_Lamf_core_parser_Position().init___I__I(0, 0) : this$2.get__O())));
  switch (x1) {
    case 0: {
      if (thisPosition.isEmpty__Z()) {
        var this$3 = $m_s_None$()
      } else {
        var arg1$2 = thisPosition.get__O();
        var x$3 = $as_Lamf_core_annotations_LexicalInformation(arg1$2);
        var this$3 = new $c_s_Some().init___O(x$3.range__Lamf_core_parser_Range().end$1)
      };
      var jsx$2 = $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? new $c_Lamf_core_parser_Position().init___I__I(0, 0) : this$3.get__O()));
      if (thatPosition.isEmpty__Z()) {
        var this$4 = $m_s_None$()
      } else {
        var arg1$3 = thatPosition.get__O();
        var x$4 = $as_Lamf_core_annotations_LexicalInformation(arg1$3);
        var this$4 = new $c_s_Some().init___O(x$4.range__Lamf_core_parser_Range().end$1)
      };
      var x1$2 = jsx$2.compareTo__Lamf_core_parser_Position__I($as_Lamf_core_parser_Position((this$4.isEmpty__Z() ? new $c_Lamf_core_parser_Position().init___I__I(0, 0) : this$4.get__O())));
      switch (x1$2) {
        case 0: {
          var this$5 = this.targetProperty$1;
          var thiz = $as_T((this$5.isEmpty__Z() ? "" : this$5.get__O()));
          var this$6 = that.targetProperty$1;
          var anotherString = $as_T((this$6.isEmpty__Z() ? "" : this$6.get__O()));
          var x1$3 = ((thiz === anotherString) ? 0 : ($uZ((thiz < anotherString)) ? (-1) : 1));
          switch (x1$3) {
            case 0: {
              var this$8 = $m_s_Option$().apply__O__s_Option(this.targetNode$1);
              var thiz$1 = $as_T((this$8.isEmpty__Z() ? "" : this$8.get__O()));
              var this$9 = $m_s_Option$().apply__O__s_Option(that.targetNode$1);
              var anotherString$1 = $as_T((this$9.isEmpty__Z() ? "" : this$9.get__O()));
              var x1$4 = ((thiz$1 === anotherString$1) ? 0 : ($uZ((thiz$1 < anotherString$1)) ? (-1) : 1));
              switch (x1$4) {
                case 0: {
                  var this$11 = $m_s_Option$().apply__O__s_Option(this.validationId$1);
                  var thiz$2 = $as_T((this$11.isEmpty__Z() ? "" : this$11.get__O()));
                  var this$12 = $m_s_Option$().apply__O__s_Option(that.validationId$1);
                  var anotherString$2 = $as_T((this$12.isEmpty__Z() ? "" : this$12.get__O()));
                  var x1$5 = ((thiz$2 === anotherString$2) ? 0 : ($uZ((thiz$2 < anotherString$2)) ? (-1) : 1));
                  switch (x1$5) {
                    case 0: {
                      var this$14 = $m_s_Option$().apply__O__s_Option(this.message$1);
                      var thiz$3 = $as_T((this$14.isEmpty__Z() ? "" : this$14.get__O()));
                      var this$15 = $m_s_Option$().apply__O__s_Option(that.message$1);
                      var anotherString$3 = $as_T((this$15.isEmpty__Z() ? "" : this$15.get__O()));
                      var i = ((thiz$3 === anotherString$3) ? 0 : ($uZ((thiz$3 < anotherString$3)) ? (-1) : 1));
                      break
                    }
                    default: {
                      var i = x1$5
                    }
                  };
                  break
                }
                default: {
                  var i = x1$4
                }
              };
              break
            }
            default: {
              var i = x1$3
            }
          };
          break
        }
        default: {
          var i = x1$2
        }
      };
      break
    }
    default: {
      var i = x1
    }
  };
  return ((i > 0) ? 1 : ((i === 0) ? i : (-1)))
});
$c_Lamf_core_validation_AMFValidationResult.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_validation_AMFValidationResult(obj) {
  return (((obj instanceof $c_Lamf_core_validation_AMFValidationResult) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.validation.AMFValidationResult"))
}
function $isArrayOf_Lamf_core_validation_AMFValidationResult(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_validation_AMFValidationResult)))
}
function $asArrayOf_Lamf_core_validation_AMFValidationResult(obj, depth) {
  return (($isArrayOf_Lamf_core_validation_AMFValidationResult(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.validation.AMFValidationResult;", depth))
}
var $d_Lamf_core_validation_AMFValidationResult = new $TypeData().initClass({
  Lamf_core_validation_AMFValidationResult: 0
}, false, "amf.core.validation.AMFValidationResult", {
  Lamf_core_validation_AMFValidationResult: 1,
  O: 1,
  s_math_Ordered: 1,
  jl_Comparable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_validation_AMFValidationResult.prototype.$classData = $d_Lamf_core_validation_AMFValidationResult;
/** @constructor */
function $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser() {
  $c_Lamf_plugins_document_graph_parser_GraphContextHelper.call(this);
  this.nodes$2 = null;
  this.unresolvedReferences$2 = null;
  this.unresolvedExtReferencesMap$2 = null;
  this.referencesMap$2 = null;
  this.cache$2 = null;
  this.graphMap$2 = null;
  this.xsdString$2 = null;
  this.xsdInteger$2 = null;
  this.xsdFloat$2 = null;
  this.amlNumber$2 = null;
  this.xsdDouble$2 = null;
  this.xsdBoolean$2 = null;
  this.xsdDateTime$2 = null;
  this.xsdDate$2 = null;
  this.types$2 = null;
  this.AnnotationName$module$2 = null;
  this.$$outer$2 = null
}
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype = new $h_Lamf_plugins_document_graph_parser_GraphContextHelper();
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.constructor = $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser;
/** @constructor */
function $h_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype = $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype;
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.parse__Lorg_yaml_model_YDocument__T__Lamf_core_model_document_BaseUnit = (function(document, location) {
  var x1 = document.node$2.value__Lorg_yaml_model_YValue();
  if ((x1 instanceof $c_Lorg_yaml_model_YMap)) {
    var x2 = $as_Lorg_yaml_model_YMap(x1);
    var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(x2).key__T__s_Option("@context");
    if ((!this$2.isEmpty__Z())) {
      var arg1 = this$2.get__O();
      var e = $as_Lorg_yaml_model_YMapEntry(arg1);
      this.parseCompactUris__Lorg_yaml_model_YNode__Lamf_plugins_document_graph_parser_GraphParserContext__V(e.value$2, this.$$outer$2.ctx$1)
    };
    var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(x2).key__T__s_Option("@graph");
    if (this$4.isEmpty__Z()) {
      var x1$2 = $m_s_None$()
    } else {
      var arg1$1 = this$4.get__O();
      var e$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
      var x1$2 = this.parseGraph__p2__Lorg_yaml_model_YNode__s_Option(e$3.value$2)
    };
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var b = $as_Lamf_core_model_document_BaseUnit(x2$2.value$2);
      if ((b !== null)) {
        var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
        return $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(b, field, location))
      }
    };
    var this$5 = this.$$outer$2.ctx$1.eh$1;
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnableToParseDocument$1;
    var property = $m_s_None$();
    var lexical = $m_s_None$();
    var location$1 = $m_s_None$();
    this$5.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, "", property, "Error parsing root JSON-LD node", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location$1);
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    return new $c_Lamf_core_model_document_Document().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
  } else {
    var this$9 = this.$$outer$2.ctx$1.eh$1;
    var specification$1 = $m_Lamf_plugins_features_validation_CoreValidations$().UnableToParseDocument$1;
    var property$1 = $m_s_None$();
    var lexical$1 = $m_s_None$();
    var location$2 = $m_s_None$();
    this$9.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification$1.id$1, "", property$1, "Error parsing root JSON-LD node", lexical$1, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location$2);
    $m_Lamf_core_parser_Annotations$();
    var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
    return new $c_Lamf_core_model_document_Document().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1)
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.parseCustomProperties__p2__Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__V = (function(map, instance) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(this.compactUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T($m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field().value$1.iri__T(), this.$$outer$2.ctx$1));
  if (this$2.isEmpty__Z()) {
    var this$6 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var x$7 = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$3 = x$7.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var iv = this.$$outer$2.ctx$1;
    var jsx$2 = $as_sc_TraversableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$8$2) {
        var x$8 = $as_Lorg_yaml_model_YNode(x$8$2);
        var t = $m_Lamf_core_metamodel_Type$Iri$();
        var this$4 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__value__Lamf_core_metamodel_Type__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode($this, t, x$8);
        var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
        var iv$1 = $this.$$outer$2.ctx$1;
        return $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion$1, iv$1)).text$3
      })
    })(this));
    var this$5 = $m_sc_Seq$();
    var this$6 = new $c_s_Some().init___O($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2)))
  };
  var properties = $as_sc_Seq((this$6.isEmpty__Z() ? $m_sci_Nil$() : this$6.get__O()));
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, map$1) {
    return (function(uri$2) {
      var uri = $as_T(uri$2);
      var this$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option(this$3$1.compactUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T(uri, this$3$1.$$outer$2.ctx$1));
      if (this$8.isEmpty__Z()) {
        var xo = $m_s_None$()
      } else {
        var arg1$1 = this$8.get__O();
        var entry = $as_Lorg_yaml_model_YMapEntry(arg1$1);
        $m_Lamf_core_parser_Annotations$();
        var annotations = new $c_Lamf_core_parser_Annotations().init___();
        var extension = new $c_Lamf_core_model_domain_extensions_DomainExtension().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
        var entryValue = entry.value$2;
        var this$12 = this$3$1.contentOfNode__Lorg_yaml_model_YNode__s_Option(entryValue);
        if (this$12.isEmpty__Z()) {
          var conversion$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
          var iv$2 = this$3$1.$$outer$2.ctx$1;
          var jsx$4 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(entryValue, conversion$2, iv$2))
        } else {
          var jsx$4 = this$12.get__O()
        };
        var obj = $as_Lorg_yaml_model_YMap(jsx$4);
        var this$13 = this$3$1.parseScalarProperty__p2__Lorg_yaml_model_YMap__Lamf_core_metamodel_Field__s_Option(obj, $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1);
        if ((!this$13.isEmpty__Z())) {
          var arg1$2 = this$13.get__O();
          var name = $as_T(arg1$2);
          var field = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1;
          new $c_s_Some().init___O($as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(extension, field, name)))
        };
        var this$14 = this$3$1.parseScalarProperty__p2__Lorg_yaml_model_YMap__Lamf_core_metamodel_Field__s_Option(obj, $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Element$1);
        if ((!this$14.isEmpty__Z())) {
          var arg1$3 = this$14.get__O();
          var element = $as_T(arg1$3);
          var field$1 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Element$1;
          new $c_s_Some().init___O($as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(extension, field$1, element)))
        };
        $m_Lamf_core_parser_Annotations$();
        var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
        var definition = new $c_Lamf_core_model_domain_extensions_CustomDomainProperty().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
        definition.id$1 = uri;
        var field$2 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().DefinedBy$1;
        $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(extension, field$2, definition));
        var this$18 = this$3$1.parse__p2__Lorg_yaml_model_YMap__s_Option(obj);
        var pf = new $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseCustomProperties$5$1().init___Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser(this$3$1);
        if ((!this$18.isEmpty__Z())) {
          var this$19 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
          var v1 = this$18.get__O();
          var this$20 = this$19.apply__O__s_Option(v1)
        } else {
          var this$20 = $m_s_None$()
        };
        if ((!this$20.isEmpty__Z())) {
          var arg1$4 = this$20.get__O();
          var pn = $as_Lamf_core_model_domain_DataNode(arg1$4);
          var value = pn.id$1;
          $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(extension, value);
          var field$3 = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1;
          $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(extension, field$3, pn))
        };
        var id = extension.id$1;
        var ctx = this$3$1.$$outer$2.ctx$1;
        var sources = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__retrieveSources__T__Lorg_yaml_model_YMap__Lamf_plugins_document_graph_parser_GraphParserContext__Lamf_core_model_document_SourceMap(this$3$1, id, map$1, ctx);
        var jsx$5 = extension.annotations$1;
        var nodes = this$3$1.nodes$2;
        var key = extension.id$1;
        jsx$5.$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations($f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this$3$1, nodes, sources, key));
        var xo = new $c_s_Some().init___O(extension)
      };
      return xo.toList__sci_List()
    })
  })(this, map));
  var this$22 = $m_sc_Seq$();
  var extensions = $as_sc_Seq(properties.flatMap__F1__scg_CanBuildFrom__O(jsx$3, this$22.ReusableCBFInstance$2));
  if (extensions.nonEmpty__Z()) {
    var x1 = extensions.partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
      return (function(x$9$2) {
        var x$9 = $as_Lamf_core_model_domain_extensions_DomainExtension(x$9$2);
        return x$9.isScalarExtension__Z()
      })
    })(this)));
    if ((x1 !== null)) {
      var scalars = $as_sc_Seq(x1.$$und1__O());
      var objects = $as_sc_Seq(x1.$$und2__O());
      var field$4 = $m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field();
      $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(instance, field$4, objects));
      this.applyScalarDomainProperties__p2__Lamf_core_model_domain_DomainElement__sc_Seq__V(instance, scalars)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.productPrefix__T = (function() {
  return "Parser"
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.applyScalarDomainProperties__p2__Lamf_core_model_domain_DomainElement__sc_Seq__V = (function(instance, scalars) {
  scalars.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, instance$1) {
    return (function(e$2) {
      var e = $as_Lamf_core_model_domain_extensions_DomainExtension(e$2);
      var this$1 = instance$1.fields__Lamf_core_parser_Fields().fieldsMeta__sci_List();
      inlinereturn$2: {
        var these = this$1;
        while ((!these.isEmpty__Z())) {
          var arg1 = these.head__O();
          var f = $as_Lamf_core_metamodel_Field(arg1);
          var this$2 = $as_Lamf_core_model_StrField(e.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Element$1));
          var other = f.value$1.iri__T();
          if ($f_Lamf_core_model_ValueField__is__O__Z(this$2, other)) {
            var this$3 = new $c_s_Some().init___O(these.head__O());
            break inlinereturn$2
          };
          these = $as_sc_LinearSeqOptimized(these.tail__O())
        };
        var this$3 = $m_s_None$()
      };
      if ((!this$3.isEmpty__Z())) {
        var arg1$1 = this$3.get__O();
        var f$3 = $as_Lamf_core_metamodel_Field(arg1$1);
        var this$4 = instance$1.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option(f$3);
        if ((!this$4.isEmpty__Z())) {
          var arg1$2 = this$4.get__O();
          var x0$1 = $as_Lamf_core_parser_FieldEntry(arg1$2);
          if ((x0$1 !== null)) {
            var value = x0$1.value$1;
            value.value$1.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_DomainExtensionAnnotation().init___Lamf_core_model_domain_extensions_DomainExtension(e))
          } else {
            throw new $c_s_MatchError().init___O(x0$1)
          }
        }
      }
    })
  })(this, instance)))
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.getRootNodeFromGraphMap__p2__s_Option = (function() {
  var this$1 = this.graphMap$2;
  var this$2 = new $c_scm_HashMap$$anon$2().init___scm_HashMap(this$1);
  var this$3 = this$2.$$outer$3.valuesIterator__sc_Iterator();
  while (this$3.hasNext__Z()) {
    var a = this$3.next__O();
    var node = $as_Lorg_yaml_model_YMap(a);
    var this$5 = node.entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(entry$2) {
        var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
        var this$4 = entry.key$2;
        var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv = $this.$$outer$2.ctx$1;
        return ($this.expandUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T($as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)), $this.$$outer$2.ctx$1) === $m_Lamf_core_metamodel_document_BaseUnitModel$().Root$1.value$1.iri__T())
      })
    })(this)));
    if ((!this$5.isEmpty__Z())) {
      var arg1 = this$5.get__O();
      var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1);
      var this$6 = entry$3.value$2;
      var conversion$1 = $m_Lorg_yaml_convert_YRead$BooleanYRead$();
      var iv$1 = this.$$outer$2.ctx$1;
      var jsx$1 = $uZ($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion$1, iv$1))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return new $c_s_Some().init___O(a)
    }
  };
  return $m_s_None$()
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.$int__p2__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar = (function(node) {
  var x1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.$$outer$2.ctx$1;
    var x1$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$13$2) {
        var x$13 = $as_Lorg_yaml_model_YMapEntry(x$13$2);
        var this$1 = x$13.key$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv$1 = $this.$$outer$2.ctx$1;
        var x$1 = $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion$1, iv$1);
        return ((x$1 !== null) && $objectEquals(x$1, "@value"))
      })
    })(this)));
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var this$2 = entry.value$2;
      var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$2 = this.$$outer$2.ctx$1;
      var x$2 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$2, iv$2)).text$3;
      var this$4 = new $c_sci_StringOps().init___T(x$2);
      var this$6 = $m_jl_Integer$();
      var $$this = this$4.repr$1;
      var value = this$6.parseInt__T__I__I($$this, 10)
    } else {
      var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$3 = this.$$outer$2.ctx$1;
      var x$3 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$3, iv$3)).text$3;
      var this$8 = new $c_sci_StringOps().init___T(x$3);
      var this$10 = $m_jl_Integer$();
      var $$this$1 = this$8.repr$1;
      var value = this$10.parseInt__T__I__I($$this$1, 10)
    }
  } else {
    var conversion$4 = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv$4 = this.$$outer$2.ctx$1;
    var x$4 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$4, iv$4)).text$3;
    var this$12 = new $c_sci_StringOps().init___T(x$4);
    var this$14 = $m_jl_Integer$();
    var $$this$2 = this$12.repr$1;
    var value = this$14.parseInt__T__I__I($$this$2, 10)
  };
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, new $c_Lamf_core_parser_Annotations().init___())
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.contentOfNode__Lorg_yaml_model_YNode__s_Option = (function(n) {
  var evidence$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var this$1 = $f_Lorg_yaml_model_YNodeLike__asOption__Lorg_yaml_convert_YRead__s_Option(n, evidence$1);
  if (this$1.isEmpty__Z()) {
    var id = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$4 = $as_Lorg_yaml_model_YMap(arg1);
    var ctx = this.$$outer$2.ctx$1;
    var id = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__retrieveId__Lorg_yaml_model_YMap__Lamf_core_parser_ParserContext__s_Option(this, x$4, ctx)
  };
  if (id.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1$1 = id.get__O();
    var id$2 = $as_T(arg1$1);
    return this.nodeFromId__p2__T__s_Option(id$2)
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.checkLinkables__p2__Lamf_core_model_domain_AmfObject__V = (function(instance) {
  if (($is_Lamf_core_model_domain_DomainElement(instance) && $is_Lamf_core_model_domain_Linkable(instance))) {
    var x2 = $as_Lamf_core_model_domain_DomainElement(instance);
    var jsx$1 = this.referencesMap$2;
    var self = x2.id__T();
    jsx$1.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(self, x2));
    var this$3 = this.unresolvedReferences$2;
    var key = x2.id__T();
    var x1 = this$3.get__O__s_Option(key);
    if ((x1 instanceof $c_s_Some)) {
      var x2$1 = $as_s_Some(x1);
      var v = x2$1.value$2;
      var jsx$2 = v
    } else {
      var x = $m_s_None$();
      if ((!(x === x1))) {
        throw new $c_s_MatchError().init___O(x1)
      };
      var jsx$2 = $m_sci_Nil$()
    };
    $as_sc_IterableLike(jsx$2).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, x2$2, instance$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_model_domain_DomainElement(x0$1$2);
        if ($is_Lamf_core_model_domain_Linkable(x0$1)) {
          var this$4 = $as_Lamf_core_model_domain_Linkable(x0$1);
          return $f_Lamf_core_model_domain_Linkable__withLinkTarget__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(this$4, x2$2)
        } else if ((x0$1 instanceof $c_Lamf_core_model_domain_LinkNode)) {
          var x3 = $as_Lamf_core_model_domain_LinkNode(x0$1);
          return x3.withLinkedDomainElement__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_LinkNode(x2$2)
        } else {
          var this$5 = this$2$1.$$outer$2.ctx$1.eh$1;
          var specification = $m_Lamf_plugins_features_validation_CoreValidations$().NotLinkable$1;
          var node = instance$1.id__T();
          var annotations = instance$1.annotations__Lamf_core_parser_Annotations();
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$5, specification, node, "Only linkable elements can be linked", annotations);
          return (void 0)
        }
      })
    })(this, x2, instance)));
    this.unresolvedReferences$2.update__O__O__V(x2.id__T(), $m_sci_Nil$())
  } else if ($is_Lamf_core_model_domain_ExternalSourceElement(instance)) {
    var x3$1 = $as_Lamf_core_model_domain_ExternalSourceElement(instance);
    var jsx$3 = this.unresolvedExtReferencesMap$2;
    var this$6 = $as_Lamf_core_model_StrField(x3$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().ReferenceId$1));
    var this$7 = this$6.option$1;
    var self$1 = $as_T((this$7.isEmpty__Z() ? null : this$7.get__O()));
    jsx$3.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(self$1, x3$1))
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser) && ($as_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser(x$1).$$outer$2 === this.$$outer$2))) {
    var Parser$1 = $as_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser(x$1);
    var x = this.nodes$2;
    var x$2 = Parser$1.nodes$2;
    return ((x === null) ? (x$2 === null) : $f_sc_GenMapLike__equals__O__Z(x, x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.setLinkTarget__p2__Lamf_core_model_domain_DomainElement__T__O = (function(instance, targetId) {
  var x1 = this.referencesMap$2.get__O__s_Option(targetId);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var target = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    var this$1 = $as_Lamf_core_model_domain_Linkable(instance);
    return $f_Lamf_core_model_domain_Linkable__withLinkTarget__Lamf_core_model_domain_DomainElement__Lamf_core_model_domain_DomainElement(this$1, target)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$2 = this.unresolvedReferences$2;
      var x1$1 = this$2.get__O__s_Option(targetId);
      if ((x1$1 instanceof $c_s_Some)) {
        var x2$1 = $as_s_Some(x1$1);
        var v = x2$1.value$2;
        var jsx$1 = v
      } else {
        var x$1 = $m_s_None$();
        if ((!(x$1 === x1$1))) {
          throw new $c_s_MatchError().init___O(x1$1)
        };
        var jsx$1 = $m_sci_Nil$()
      };
      var unresolved = $as_sc_Seq(jsx$1);
      var jsx$4 = this.unresolvedReferences$2;
      var jsx$3 = $m_sc_Seq$();
      var array = [instance];
      var jsx$2 = jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
      var this$6 = $m_sc_Seq$();
      var y = unresolved.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$6.ReusableCBFInstance$2);
      return jsx$4.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(targetId, y))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.parseNodeFields__p2__Lorg_yaml_model_YMap__sc_Seq__Lamf_core_model_document_SourceMap__T__Lamf_core_model_domain_AmfObject__s_Some = (function(node, fields, sources, transformedId, instance) {
  instance.withId__T__Lamf_core_model_domain_AmfObject(transformedId);
  this.checkLinkables__p2__Lamf_core_model_domain_AmfObject__V(instance);
  this.traverseFields__p2__Lorg_yaml_model_YMap__sc_Seq__Lamf_core_model_domain_AmfObject__Lamf_core_model_document_SourceMap__V(node, fields, instance, sources);
  matchEnd6: {
    if (($is_Lamf_core_model_domain_DomainElement(instance) && $is_Lamf_core_model_domain_Linkable(instance))) {
      var x2 = $as_Lamf_core_model_domain_DomainElement(instance);
      this.parseLinkableProperties__p2__Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__V(node, x2);
      break matchEnd6
    };
    if ((instance instanceof $c_Lamf_core_model_domain_ExternalDomainElement)) {
      var x3 = $as_Lamf_core_model_domain_ExternalDomainElement(instance);
      if (this.unresolvedExtReferencesMap$2.contains__O__Z(x3.id$1)) {
        var this$1 = this.unresolvedExtReferencesMap$2.get__O__s_Option(x3.id$1);
        if ((!this$1.isEmpty__Z())) {
          var arg1 = this$1.get__O();
          var element = $as_Lamf_core_model_domain_ExternalSourceElement(arg1);
          var this$2 = $as_Lamf_core_model_StrField(x3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1)).option$1;
          if ((!this$2.isEmpty__Z())) {
            var arg1$1 = this$2.get__O();
            var x$3 = $as_T(arg1$1);
            var field = $m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1;
            $as_Lamf_core_model_domain_ExternalSourceElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(element, field, x$3))
          }
        };
        break matchEnd6
      }
    };
    if ((instance instanceof $c_Lamf_core_model_domain_ObjectNode)) {
      var x4 = $as_Lamf_core_model_domain_ObjectNode(instance);
      this.parseObjectNodeProperties__p2__Lamf_core_model_domain_ObjectNode__Lorg_yaml_model_YMap__sc_Seq__V(x4, node, fields);
      break matchEnd6
    }
  };
  if ($is_Lamf_core_model_domain_DomainElement(instance)) {
    var x2$2 = $as_Lamf_core_model_domain_DomainElement(instance);
    this.parseCustomProperties__p2__Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__V(node, x2$2)
  };
  this.nodes$2 = this.nodes$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(transformedId, instance));
  return new $c_s_Some().init___O(instance)
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.nodes$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.key$1__p2__Lorg_yaml_model_YMapEntry__T = (function(entry) {
  var this$1 = entry.key$2;
  var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
  var iv = this.$$outer$2.ctx$1;
  return $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv))
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.parseScalarProperty__p2__Lorg_yaml_model_YMap__Lamf_core_metamodel_Field__s_Option = (function(definition, field) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(definition).key__T__s_Option(this.compactUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T(field.value$1.iri__T(), this.$$outer$2.ctx$1));
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var t = field.type$1;
    var node = entry.value$2;
    var this$3 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__value__Lamf_core_metamodel_Type__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode(this, t, node);
    var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv = this.$$outer$2.ctx$1;
    return new $c_s_Some().init___O($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv)).text$3)
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.baseUnitOrError__p2__s_Option__s_Option = (function(parsed) {
  var rc7 = false;
  var x2 = null;
  if ((parsed instanceof $c_s_Some)) {
    rc7 = true;
    x2 = $as_s_Some(parsed);
    var b = $as_Lamf_core_model_domain_AmfObject(x2.value$2);
    if ($is_Lamf_core_model_document_BaseUnit(b)) {
      var x5 = $as_Lamf_core_model_document_BaseUnit(b);
      return new $c_s_Some().init___O(x5)
    }
  };
  if (rc7) {
    var this$1 = this.$$outer$2.ctx$1.eh$1;
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnableToParseDocument$1;
    var property = $m_s_None$();
    var lexical = $m_s_None$();
    var location = $m_s_None$();
    this$1.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, "", property, "Root node is not a Base Unit", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
    return $m_s_None$()
  };
  var this$2 = this.$$outer$2.ctx$1.eh$1;
  var specification$1 = $m_Lamf_plugins_features_validation_CoreValidations$().UnableToParseDocument$1;
  var property$1 = $m_s_None$();
  var lexical$1 = $m_s_None$();
  var location$1 = $m_s_None$();
  this$2.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification$1.id$1, "", property$1, "Unable to parse root node", lexical$1, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location$1);
  return $m_s_None$()
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.toMapEntry$1__p2__Lorg_yaml_model_YNode__s_Option = (function(node) {
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.$$outer$2.ctx$1;
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv));
  var ctx = this.$$outer$2.ctx$1;
  var x1 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__retrieveId__Lorg_yaml_model_YMap__Lamf_core_parser_ParserContext__s_Option(this, map, ctx);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var id = $as_T(x2.value$2);
    return new $c_s_Some().init___O(new $c_T2().init___O__O(id, map))
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.parseNode__p2__Lorg_yaml_model_YMap__T__Lamf_core_metamodel_Obj__s_Option = (function(map, id, model) {
  var ctx = this.$$outer$2.ctx$1;
  var sources = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__retrieveSources__T__Lorg_yaml_model_YMap__Lamf_plugins_document_graph_parser_GraphParserContext__Lamf_core_model_document_SourceMap(this, id, map, ctx);
  var transformedId = this.transformIdFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T(id, this.$$outer$2.ctx$1);
  var jsx$1 = this.buildType__p2__T__Lorg_yaml_model_YMap__Lamf_core_metamodel_Obj__F1(transformedId, map, model);
  var nodes = this.nodes$2;
  var x1 = $as_s_Option(jsx$1.apply__O__O($f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, nodes, sources, transformedId)));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var builder = $as_Lamf_core_model_domain_AmfObject(x2.value$2);
    var fields = $m_Lamf_plugins_document_graph_MetaModelHelper$().fieldsFrom__Lamf_core_metamodel_Obj__sc_Seq(model);
    return this.parseNodeFields__p2__Lorg_yaml_model_YMap__sc_Seq__Lamf_core_model_document_SourceMap__T__Lamf_core_model_domain_AmfObject__s_Some(map, fields, sources, transformedId, builder)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.parseLinkableProperties__p2__Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__V = (function(map, instance) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(this.compactUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T($m_Lamf_core_metamodel_domain_LinkableElementModel$().TargetId$1.value$1.iri__T(), this.$$outer$2.ctx$1));
  if (this$2.isEmpty__Z()) {
    var this$6 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$5 = entry.value$2;
    var reader = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var this$4 = $m_sc_IndexedSeq$();
    var bf = this$4.ReusableCBF$6;
    var conversion = new $c_Lorg_yaml_convert_YRead$$anon$1().init___scg_CanBuildFrom__Lorg_yaml_convert_YRead(bf, reader);
    var iv = this.$$outer$2.ctx$1;
    var map$1 = $as_Lorg_yaml_model_YMap($as_sc_IterableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv)).head__O());
    var ctx = this.$$outer$2.ctx$1;
    var this$6 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__retrieveId__Lorg_yaml_model_YMap__Lamf_core_parser_ParserContext__s_Option(this, map$1, ctx)
  };
  if ((!this$6.isEmpty__Z())) {
    var arg1$1 = this$6.get__O();
    var targetId = $as_T(arg1$1);
    var transformedId = this.transformIdFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T(targetId, this.$$outer$2.ctx$1);
    this.setLinkTarget__p2__Lamf_core_model_domain_DomainElement__T__O(instance, transformedId)
  };
  var this$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(this.compactUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1.value$1.iri__T(), this.$$outer$2.ctx$1));
  if (this$8.isEmpty__Z()) {
    var this$17 = $m_s_None$()
  } else {
    var arg1$2 = this$8.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var node = entry$3.value$2;
    var this$10 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$SeqNodeYRead$());
    if (this$10.isEmpty__Z()) {
      var this$12 = $m_s_None$()
    } else {
      var arg1$3 = this$10.get__O();
      var nodes = $as_sc_Seq(arg1$3);
      var node$1 = $as_Lorg_yaml_model_YNodeLike(nodes.head__O());
      var this$12 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node$1).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YMapYRead$())
    };
    if (this$12.isEmpty__Z()) {
      var this$14 = $m_s_None$()
    } else {
      var arg1$4 = this$12.get__O();
      var map$2 = $as_Lorg_yaml_model_YMap(arg1$4);
      var this$14 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2).key__T__s_Option("@value")
    };
    if (this$14.isEmpty__Z()) {
      var this$17 = $m_s_None$()
    } else {
      var arg1$5 = this$14.get__O();
      var x$5 = $as_Lorg_yaml_model_YMapEntry(arg1$5);
      var node$2 = x$5.value$2;
      var this$16 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node$2).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lamf_core_parser_package$YScalarYRead$());
      if (this$16.isEmpty__Z()) {
        var this$17 = $m_s_None$()
      } else {
        var arg1$6 = this$16.get__O();
        var x$6 = $as_Lorg_yaml_model_YScalar(arg1$6);
        var this$17 = new $c_s_Some().init___O(x$6.text$3)
      }
    }
  };
  if ((!this$17.isEmpty__Z())) {
    var arg1$7 = this$17.get__O();
    var s = $as_T(arg1$7);
    var this$18 = $as_Lamf_core_model_domain_Linkable(instance);
    var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1;
    $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$18, field, s))
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.populateGraphMap__p2__Lorg_yaml_model_YSequence__V = (function(graphNodes) {
  var jsx$2 = graphNodes.nodes$3;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(node$2) {
      var node = $as_Lorg_yaml_model_YNode(node$2);
      var xo = $this.toMapEntry$1__p2__Lorg_yaml_model_YNode__s_Option(node);
      return xo.toList__sci_List()
    })
  })(this));
  var this$2 = $m_sc_IndexedSeq$();
  $as_sc_IterableLike(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBF$6)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var id = $as_T(x0$1.$$und1__O());
        var map = $as_Lorg_yaml_model_YMap(x0$1.$$und2__O());
        var this$3 = this$2$1.graphMap$2;
        this$3.put__O__O__s_Option(id, map)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this)))
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.any__p2__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar = (function(node) {
  var x1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.$$outer$2.ctx$1;
    var x1$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$16$2) {
        var x$16 = $as_Lorg_yaml_model_YMapEntry(x$16$2);
        var this$1 = x$16.key$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv$1 = $this.$$outer$2.ctx$1;
        var x$1 = $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion$1, iv$1);
        return ((x$1 !== null) && $objectEquals(x$1, "@value"))
      })
    })(this)));
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var this$2 = entry.value$2;
      var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$2 = this.$$outer$2.ctx$1;
      var nodeValue = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$2, iv$2)).text$3
    } else {
      var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$3 = this.$$outer$2.ctx$1;
      var nodeValue = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$3, iv$3)).text$3
    };
    var conversion$4 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$4 = this.$$outer$2.ctx$1;
    var x1$3 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$4, iv$4)).entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(x$17$2) {
        var x$17 = $as_Lorg_yaml_model_YMapEntry(x$17$2);
        var this$3 = x$17.key$2;
        var conversion$5 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv$5 = this$2$1.$$outer$2.ctx$1;
        var x$2 = $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion$5, iv$5);
        return ((x$2 !== null) && $objectEquals(x$2, "@type"))
      })
    })(this)));
    if ((x1$3 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$3);
      var typeEntry = $as_Lorg_yaml_model_YMapEntry(x2$2.value$2);
      var this$4 = typeEntry.value$2;
      var conversion$6 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$6 = this.$$outer$2.ctx$1;
      var typeUri = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion$6, iv$6)).text$3;
      var expandedUri = this.expandUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T(typeUri, this.$$outer$2.ctx$1);
      if ((expandedUri !== null)) {
        if ((expandedUri === this.xsdBoolean$2)) {
          var this$6 = new $c_sci_StringOps().init___T(nodeValue);
          var $$this = this$6.repr$1;
          return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($f_sci_StringLike__parseBoolean__psci_StringLike__T__Z(this$6, $$this), new $c_Lamf_core_parser_Annotations().init___())
        }
      };
      if ((expandedUri !== null)) {
        if ((expandedUri === this.xsdInteger$2)) {
          var this$10 = new $c_sci_StringOps().init___T(nodeValue);
          var this$12 = $m_jl_Integer$();
          var $$this$1 = this$10.repr$1;
          return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(this$12.parseInt__T__I__I($$this$1, 10), new $c_Lamf_core_parser_Annotations().init___())
        }
      };
      if ((expandedUri !== null)) {
        if ((expandedUri === this.xsdFloat$2)) {
          var this$15 = new $c_sci_StringOps().init___T(nodeValue);
          var $$this$2 = this$15.repr$1;
          return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($fround($m_jl_Double$().parseDouble__T__D($$this$2)), new $c_Lamf_core_parser_Annotations().init___())
        }
      };
      if ((expandedUri !== null)) {
        if ((expandedUri === this.xsdDouble$2)) {
          var this$20 = new $c_sci_StringOps().init___T(nodeValue);
          var jsx$1 = $m_jl_Double$();
          var $$this$3 = this$20.repr$1;
          return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(jsx$1.parseDouble__T__D($$this$3), new $c_Lamf_core_parser_Annotations().init___())
        }
      };
      if ((expandedUri !== null)) {
        if ((expandedUri === this.xsdDateTime$2)) {
          var this$23 = $m_Lorg_mulesoft_common_time_SimpleDateTime$().parse__T__s_util_Either(nodeValue);
          return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(new $c_s_util_Either$RightProjection().init___s_util_Either(this$23).get__O(), new $c_Lamf_core_parser_Annotations().init___())
        }
      };
      if ((expandedUri !== null)) {
        if ((expandedUri === this.xsdDate$2)) {
          var this$25 = $m_Lorg_mulesoft_common_time_SimpleDateTime$().parse__T__s_util_Either(nodeValue);
          return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(new $c_s_util_Either$RightProjection().init___s_util_Either(this$25).get__O(), new $c_Lamf_core_parser_Annotations().init___())
        }
      };
      return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(nodeValue, new $c_Lamf_core_parser_Annotations().init___())
    } else {
      return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(nodeValue, new $c_Lamf_core_parser_Annotations().init___())
    }
  } else {
    var conversion$7 = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv$7 = this.$$outer$2.ctx$1;
    return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$7, iv$7)).text$3, new $c_Lamf_core_parser_Annotations().init___())
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.str__p2__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar = (function(node) {
  var x1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.$$outer$2.ctx$1;
    var x1$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$11$2) {
        var x$11 = $as_Lorg_yaml_model_YMapEntry(x$11$2);
        var this$1 = x$11.key$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv$1 = $this.$$outer$2.ctx$1;
        var x$1 = $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion$1, iv$1);
        return ((x$1 !== null) && $objectEquals(x$1, "@value"))
      })
    })(this)));
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var this$2 = entry.value$2;
      var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$2 = this.$$outer$2.ctx$1;
      var value = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$2, iv$2)).text$3
    } else {
      var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$3 = this.$$outer$2.ctx$1;
      var value = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$3, iv$3)).text$3
    }
  } else {
    var conversion$4 = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv$4 = this.$$outer$2.ctx$1;
    var value = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$4, iv$4)).text$3
  };
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, new $c_Lamf_core_parser_Annotations().init___())
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.AnnotationName__Lamf_plugins_document_graph_parser_GraphParserHelpers$AnnotationName$ = (function() {
  if ((this.AnnotationName$module$2 === null)) {
    this.AnnotationName$lzycompute$1__p2__V()
  };
  return this.AnnotationName$module$2
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.AnnotationName$lzycompute$1__p2__V = (function() {
  if ((this.AnnotationName$module$2 === null)) {
    this.AnnotationName$module$2 = new $c_Lamf_plugins_document_graph_parser_GraphParserHelpers$AnnotationName$().init___Lamf_plugins_document_graph_parser_GraphParserHelpers(this)
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.parseSelfEncodedBaseUnit__p2__Lorg_yaml_model_YMap__s_Option = (function(rootNode) {
  var ctx = this.$$outer$2.ctx$1;
  var this$1 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__retrieveId__Lorg_yaml_model_YMap__Lamf_core_parser_ParserContext__s_Option(this, rootNode, ctx);
  if (this$1.isEmpty__Z()) {
    var parsed = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var id = $as_T(arg1);
    var this$5 = $m_Lamf_core_metamodel_document_BaseUnitModel$().type$1;
    var this$2 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
    var elem = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$2, "DialectInstance");
    var this$4 = $m_sci_List$();
    var bf = this$4.ReusableCBFInstance$2;
    var this$6 = this.retrieveTypeIgnoring__p2__T__Lorg_yaml_model_YMap__sc_Seq__s_Option(id, rootNode, $as_sc_Seq($f_sc_SeqLike__$$colon$plus__O__scg_CanBuildFrom__O(this$5, elem, bf)));
    if (this$6.isEmpty__Z()) {
      var parsed = $m_s_None$()
    } else {
      var arg1$1 = this$6.get__O();
      var encodesModel = $as_Lamf_core_metamodel_Obj(arg1$1);
      var this$7 = this.retrieveTypeIgnoring__p2__T__Lorg_yaml_model_YMap__sc_Seq__s_Option(id, rootNode, encodesModel.type__sci_List());
      if (this$7.isEmpty__Z()) {
        var parsed = $m_s_None$()
      } else {
        var arg1$2 = this$7.get__O();
        var unitModel = $as_Lamf_core_metamodel_Obj(arg1$2);
        var this$8 = this.parseRootNodeWithModel__p2__Lorg_yaml_model_YMap__Lamf_core_metamodel_Obj__s_Option(rootNode, encodesModel);
        if (this$8.isEmpty__Z()) {
          var parsed = $m_s_None$()
        } else {
          var arg1$3 = this$8.get__O();
          $as_Lamf_core_model_domain_AmfObject(arg1$3);
          var this$9 = this.parseRootNodeWithModel__p2__Lorg_yaml_model_YMap__Lamf_core_metamodel_Obj__s_Option(rootNode, unitModel);
          if (this$9.isEmpty__Z()) {
            var parsed = $m_s_None$()
          } else {
            var arg1$4 = this$9.get__O();
            var baseUnit = $as_Lamf_core_model_domain_AmfObject(arg1$4);
            var parsed = new $c_s_Some().init___O(baseUnit)
          }
        }
      }
    }
  };
  return this.baseUnitOrError__p2__s_Option__s_Option(parsed)
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.parseObjectNodeProperties__p2__Lamf_core_model_domain_ObjectNode__Lorg_yaml_model_YMap__sc_Seq__V = (function(obj, map, fields) {
  var jsx$2 = $m_sc_Seq$();
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().Sources$1.value$1.iri__T();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var array = ["@id", "@type", "smaps", jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "name")];
  var ignoredFields = $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  map.entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, fields$1, ignoredFields$1, obj$1) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var this$5 = entry.key$2;
      var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
      var iv = $this.$$outer$2.ctx$1;
      var fieldUri = $this.expandUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T($as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv)), $this.$$outer$2.ctx$1);
      var fieldValue = entry.value$2;
      var isAlreadyParsed = fields$1.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, fieldUri$1) {
        return (function(x$10$2) {
          var x$10 = $as_Lamf_core_metamodel_Field(x$10$2);
          return (x$10.value$1.iri__T() === fieldUri$1)
        })
      })($this, fieldUri)));
      if (((!ignoredFields$1.contains__O__Z(fieldUri)) && (!isAlreadyParsed))) {
        var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv$1 = $this.$$outer$2.ctx$1;
        var this$6 = $this.parse__p2__Lorg_yaml_model_YMap__s_Option($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(fieldValue, conversion$1, iv$1)));
        var pf = new $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser$$anonfun$$nestedInanonfun$parseObjectNodeProperties$1$1().init___Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser__Lamf_core_model_domain_ObjectNode__T($this, obj$1, fieldUri);
        if ((!this$6.isEmpty__Z())) {
          var this$7 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
          var v1 = this$6.get__O();
          return this$7.apply__O__s_Option(v1)
        } else {
          return $m_s_None$()
        }
      } else {
        return (void 0)
      }
    })
  })(this, fields, ignoredFields, obj)))
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.isSelfEncoded__p2__Lorg_yaml_model_YNode__Z = (function(node) {
  var obj = $m_Lamf_core_metamodel_document_BaseUnitModel$();
  var ctx = this.$$outer$2.ctx$1;
  if ($f_Lamf_plugins_document_graph_parser_GraphParserHelpers__nodeIsOfType__Lorg_yaml_model_YNode__Lamf_core_metamodel_Obj__Lamf_plugins_document_graph_parser_GraphParserContext__Z(this, node, obj, ctx)) {
    var obj$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$();
    var ctx$1 = this.$$outer$2.ctx$1;
    return $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__nodeIsOfType__Lorg_yaml_model_YNode__Lamf_core_metamodel_Obj__Lamf_plugins_document_graph_parser_GraphParserContext__Z(this, node, obj$1, ctx$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.traverseFields__p2__Lorg_yaml_model_YMap__sc_Seq__Lamf_core_model_domain_AmfObject__Lamf_core_model_document_SourceMap__V = (function(map, fields, instance, sources) {
  fields.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, map$1, instance$1, sources$1) {
    return (function(f$2) {
      var f = $as_Lamf_core_metamodel_Field(f$2);
      var k = $this.compactUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T(f.value$1.iri__T(), $this.$$outer$2.ctx$1);
      var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option(k);
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
        var t = f.type$1;
        var node = entry.value$2;
        return $this.traverse__p2__Lamf_core_model_domain_AmfObject__Lamf_core_metamodel_Field__Lorg_yaml_model_YNode__Lamf_core_model_document_SourceMap__T__Lamf_core_model_domain_AmfObject(instance$1, f, $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__value__Lamf_core_metamodel_Type__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode($this, t, node), sources$1, k)
      } else {
        return (void 0)
      }
    })
  })(this, map, instance, sources)))
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.parseRootNodeWithModel__p2__Lorg_yaml_model_YMap__Lamf_core_metamodel_Obj__s_Option = (function(rootNode, model) {
  var ctx = this.$$outer$2.ctx$1;
  var this$1 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__retrieveId__Lorg_yaml_model_YMap__Lamf_core_parser_ParserContext__s_Option(this, rootNode, ctx);
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var id = $as_T(arg1);
    var jsx$1 = $m_s_Option$();
    var ctx$1 = this.$$outer$2.ctx$1;
    var this$2 = jsx$1.apply__O__s_Option($f_Lamf_plugins_document_graph_parser_GraphParserHelpers__retrieveSources__T__Lorg_yaml_model_YMap__Lamf_plugins_document_graph_parser_GraphParserContext__Lamf_core_model_document_SourceMap(this, id, rootNode, ctx$1));
    if (this$2.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1$1 = this$2.get__O();
      var sources = $as_Lamf_core_model_document_SourceMap(arg1$1);
      var this$3 = $m_s_Option$().apply__O__s_Option(this.transformIdFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T(id, this.$$outer$2.ctx$1));
      if (this$3.isEmpty__Z()) {
        return $m_s_None$()
      } else {
        var arg1$2 = this$3.get__O();
        var finalId = $as_T(arg1$2);
        var jsx$2 = this.buildType__p2__T__Lorg_yaml_model_YMap__Lamf_core_metamodel_Obj__F1(finalId, rootNode, model);
        var nodes = this.nodes$2;
        var this$4 = $as_s_Option(jsx$2.apply__O__O($f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, nodes, sources, finalId)));
        if (this$4.isEmpty__Z()) {
          return $m_s_None$()
        } else {
          var arg1$3 = this$4.get__O();
          var instance = $as_Lamf_core_model_domain_AmfObject(arg1$3);
          var this$5 = this.parseNodeFields__p2__Lorg_yaml_model_YMap__sc_Seq__Lamf_core_model_document_SourceMap__T__Lamf_core_model_domain_AmfObject__s_Some(rootNode, $m_Lamf_plugins_document_graph_MetaModelHelper$().fieldsFrom__Lamf_core_metamodel_Obj__sc_Seq(model), sources, finalId, instance);
          var arg1$4 = this$5.value$2;
          var parsed = $as_Lamf_core_model_domain_AmfObject(arg1$4);
          this.cache$2.update__O__O__V(id, parsed);
          return new $c_s_Some().init___O(parsed)
        }
      }
    }
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.parseSortedArray__p2__Lamf_core_metamodel_Type__Lorg_yaml_model_YMap__sc_Seq = (function(listElement, rawNode) {
  var x1 = this.contentOfNode__Lorg_yaml_model_YNode__s_Option(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(rawNode, $m_Lorg_yaml_model_YType$().Map$1)));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var node = $as_Lorg_yaml_model_YMap(x2.value$2);
    var members = $as_sc_IndexedSeq(node.entries$3.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(entry$2) {
        var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
        var property = $this.key$1__p2__Lorg_yaml_model_YMapEntry__T(entry);
        var this$3 = $m_Lamf_core_vocabulary_Namespace$().Rdfs$1;
        var sortedMemberPrefix = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "_").iri__T();
        var prefix = $this.compactUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T(sortedMemberPrefix, $this.$$outer$2.ctx$1);
        return (($uI(property.length) >= 0) && ($as_T(property.substring(0, $uI(prefix.length))) === prefix))
      })
    })(this))));
    var jsx$2 = $as_sc_TraversableLike(members.sortBy__F1__s_math_Ordering__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(entry$3$2) {
        var entry$3 = $as_Lorg_yaml_model_YMapEntry(entry$3$2);
        return this$2$1.key$1__p2__Lorg_yaml_model_YMapEntry__T(entry$3)
      })
    })(this)), $m_s_math_Ordering$String$()));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, listElement$1) {
      return (function(entry$4$2) {
        var entry$4 = $as_Lorg_yaml_model_YMapEntry(entry$4$2);
        if ($is_Lamf_core_metamodel_Obj(listElement$1)) {
          var this$10 = entry$4.value$2;
          var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
          var iv = this$3$1.$$outer$2.ctx$1;
          var xo = this$3$1.parse__p2__Lorg_yaml_model_YMap__s_Option($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$10, conversion, iv)));
          return xo.toList__sci_List()
        } else {
          try {
            var node$1 = entry$4.value$2;
            var xo$1 = new $c_s_Some().init___O(this$3$1.str__p2__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar($f_Lamf_plugins_document_graph_parser_GraphParserHelpers__value__Lamf_core_metamodel_Type__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode(this$3$1, listElement$1, node$1)));
            return xo$1.toList__sci_List()
          } catch (e) {
            var e$2 = $m_sjsr_package$().wrapJavaScriptException__O__jl_Throwable(e);
            if ((e$2 instanceof $c_jl_Exception)) {
              var xo$2 = $m_s_None$();
              return xo$2.toList__sci_List()
            } else {
              throw e
            }
          }
        }
      })
    })(this, listElement));
    var this$14 = $m_sc_IndexedSeq$();
    return $as_sc_Seq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$14.ReusableCBF$6))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      $m_sc_Seq$();
      $m_sci_Seq$();
      var this$17 = new $c_scm_ListBuffer().init___();
      return this$17.toList__sci_List()
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.init___Lamf_plugins_document_graph_parser_FlattenedGraphParser__sci_Map = (function($$outer, nodes) {
  this.nodes$2 = nodes;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.unresolvedReferences$2 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.unresolvedExtReferencesMap$2 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.referencesMap$2 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.cache$2 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.graphMap$2 = new $c_scm_HashMap().init___();
  this.xsdString$2 = $m_Lamf_core_model_DataType$().String$1;
  this.xsdInteger$2 = $m_Lamf_core_model_DataType$().Integer$1;
  this.xsdFloat$2 = $m_Lamf_core_model_DataType$().Float$1;
  this.amlNumber$2 = $m_Lamf_core_model_DataType$().Number$1;
  this.xsdDouble$2 = $m_Lamf_core_model_DataType$().Double$1;
  this.xsdBoolean$2 = $m_Lamf_core_model_DataType$().Boolean$1;
  this.xsdDateTime$2 = $m_Lamf_core_model_DataType$().DateTime$1;
  this.xsdDate$2 = $m_Lamf_core_model_DataType$().Date$1;
  var this$3 = $m_sci_Map$EmptyMap$();
  var xs = $m_Lamf_core_registries_AMFDomainRegistry$().metadataRegistry$1;
  this.types$2 = $f_sci_MapLike__$$plus$plus__sc_GenTraversableOnce__sci_Map(this$3, xs);
  return this
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.parseBaseUnit__p2__Lorg_yaml_model_YMap__s_Option = (function(rootNode) {
  var ctx = this.$$outer$2.ctx$1;
  var this$1 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__retrieveId__Lorg_yaml_model_YMap__Lamf_core_parser_ParserContext__s_Option(this, rootNode, ctx);
  if (this$1.isEmpty__Z()) {
    var parsed$1 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var id = $as_T(arg1);
    var this$2 = this.retrieveTypeIgnoring__p2__T__Lorg_yaml_model_YMap__sc_Seq__s_Option(id, rootNode, $m_sci_Nil$());
    if (this$2.isEmpty__Z()) {
      var parsed$1 = $m_s_None$()
    } else {
      var arg1$1 = this$2.get__O();
      var model = $as_Lamf_core_metamodel_Obj(arg1$1);
      var this$3 = this.parseNode__p2__Lorg_yaml_model_YMap__T__Lamf_core_metamodel_Obj__s_Option(rootNode, id, model);
      if (this$3.isEmpty__Z()) {
        var parsed$1 = $m_s_None$()
      } else {
        var arg1$2 = this$3.get__O();
        var parsed = $as_Lamf_core_model_domain_AmfObject(arg1$2);
        var parsed$1 = new $c_s_Some().init___O(parsed)
      }
    }
  };
  return this.baseUnitOrError__p2__s_Option__s_Option(parsed$1)
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.traverse__p2__Lamf_core_model_domain_AmfObject__Lamf_core_metamodel_Field__Lorg_yaml_model_YNode__Lamf_core_model_document_SourceMap__T__Lamf_core_model_domain_AmfObject = (function(instance, f, node, sources, key) {
  var x1 = f.type$1;
  if ($is_Lamf_core_metamodel_Obj(x1)) {
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.$$outer$2.ctx$1;
    var this$1 = this.parse__p2__Lorg_yaml_model_YMap__s_Option($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)));
    if ((!this$1.isEmpty__Z())) {
      var arg1 = this$1.get__O();
      var n = $as_Lamf_core_model_domain_AmfObject(arg1);
      var nodes = this.nodes$2;
      var annotations = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, nodes, sources, key);
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, n, annotations)
    };
    return instance
  } else {
    var x = $m_Lamf_core_metamodel_Type$Str$();
    if (x.equals__O__Z(x1)) {
      var jsx$1 = true
    } else {
      var x$3 = $m_Lamf_core_metamodel_Type$RegExp$();
      if (x$3.equals__O__Z(x1)) {
        var jsx$1 = true
      } else {
        var x$5 = $m_Lamf_core_metamodel_Type$Iri$();
        if (x$5.equals__O__Z(x1)) {
          var jsx$1 = true
        } else {
          var x$7 = $m_Lamf_core_metamodel_Type$LiteralUri$();
          var jsx$1 = x$7.equals__O__Z(x1)
        }
      }
    };
    if (jsx$1) {
      var value = this.str__p2__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(node);
      var nodes$1 = this.nodes$2;
      var annotations$1 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, nodes$1, sources, key);
      return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, value, annotations$1)
    } else {
      var x$9 = $m_Lamf_core_metamodel_Type$Bool$();
      if (x$9.equals__O__Z(x1)) {
        var value$1 = this.bool__p2__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(node);
        var nodes$2 = this.nodes$2;
        var annotations$2 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, nodes$2, sources, key);
        return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, value$1, annotations$2)
      } else {
        var x$11 = $m_Lamf_core_metamodel_Type$Int$();
        if (x$11.equals__O__Z(x1)) {
          var value$2 = this.$int__p2__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(node);
          var nodes$3 = this.nodes$2;
          var annotations$3 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, nodes$3, sources, key);
          return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, value$2, annotations$3)
        } else {
          var x$13 = $m_Lamf_core_metamodel_Type$Float$();
          if (x$13.equals__O__Z(x1)) {
            var value$3 = this.$float__p2__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(node);
            var nodes$4 = this.nodes$2;
            var annotations$4 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, nodes$4, sources, key);
            return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, value$3, annotations$4)
          } else {
            var x$15 = $m_Lamf_core_metamodel_Type$Double$();
            if (x$15.equals__O__Z(x1)) {
              var value$4 = this.$double__p2__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(node);
              var nodes$5 = this.nodes$2;
              var annotations$5 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, nodes$5, sources, key);
              return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, value$4, annotations$5)
            } else {
              var x$17 = $m_Lamf_core_metamodel_Type$DateTime$();
              if (x$17.equals__O__Z(x1)) {
                var value$5 = this.date__p2__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(node);
                var nodes$6 = this.nodes$2;
                var annotations$6 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, nodes$6, sources, key);
                return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, value$5, annotations$6)
              } else {
                var x$19 = $m_Lamf_core_metamodel_Type$Date$();
                if (x$19.equals__O__Z(x1)) {
                  var value$6 = this.date__p2__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(node);
                  var nodes$7 = this.nodes$2;
                  var annotations$7 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, nodes$7, sources, key);
                  return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, value$6, annotations$7)
                } else {
                  var x$21 = $m_Lamf_core_metamodel_Type$Any$();
                  if ((x$21 === x1)) {
                    var value$7 = this.any__p2__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar(node);
                    var nodes$8 = this.nodes$2;
                    var annotations$8 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, nodes$8, sources, key);
                    return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, value$7, annotations$8)
                  } else if ((x1 instanceof $c_Lamf_core_metamodel_Type$SortedArray)) {
                    var x14 = $as_Lamf_core_metamodel_Type$SortedArray(x1);
                    var jsx$2 = x14.element$1;
                    var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
                    var iv$1 = this.$$outer$2.ctx$1;
                    var parsed = this.parseSortedArray__p2__Lamf_core_metamodel_Type__Lorg_yaml_model_YMap__sc_Seq(jsx$2, $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$1, iv$1)));
                    var nodes$9 = this.nodes$2;
                    var annotations$9 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, nodes$9, sources, key);
                    return $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, parsed, annotations$9)
                  } else if ((x1 instanceof $c_Lamf_core_metamodel_Type$Array)) {
                    var x15 = $as_Lamf_core_metamodel_Type$Array(x1);
                    var conversion$2 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
                    var iv$2 = this.$$outer$2.ctx$1;
                    var items = $as_sc_Seq($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$2, iv$2));
                    var x1$2 = x15.element$1;
                    if ($is_Lamf_core_metamodel_Obj(x1$2)) {
                      var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
                        return (function(n$3$2) {
                          var n$3 = $as_Lorg_yaml_model_YNode(n$3$2);
                          var conversion$3 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
                          var iv$3 = this$2.$$outer$2.ctx$1;
                          var xo = this$2.parse__p2__Lorg_yaml_model_YMap__s_Option($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(n$3, conversion$3, iv$3)));
                          return xo.toList__sci_List()
                        })
                      })(this));
                      var this$4 = $m_sc_Seq$();
                      var values = $as_sc_Seq(items.flatMap__F1__scg_CanBuildFrom__O(jsx$3, this$4.ReusableCBFInstance$2))
                    } else {
                      var x$23 = $m_Lamf_core_metamodel_Type$Str$();
                      if (x$23.equals__O__Z(x1$2)) {
                        var jsx$4 = true
                      } else {
                        var x$25 = $m_Lamf_core_metamodel_Type$Iri$();
                        var jsx$4 = x$25.equals__O__Z(x1$2)
                      };
                      if ((!jsx$4)) {
                        throw new $c_s_MatchError().init___O(x1$2)
                      };
                      var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, x15$1) {
                        return (function(n$4$2) {
                          var n$4 = $as_Lorg_yaml_model_YNode(n$4$2);
                          var t = x15$1.element$1;
                          return this$3$1.str__p2__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar($f_Lamf_plugins_document_graph_parser_GraphParserHelpers__value__Lamf_core_metamodel_Type__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode(this$3$1, t, n$4))
                        })
                      })(this, x15));
                      var this$5 = $m_sc_Seq$();
                      var values = $as_sc_Seq(items.map__F1__scg_CanBuildFrom__O(jsx$5, this$5.ReusableCBFInstance$2))
                    };
                    var x1$3 = x15.element$1;
                    if ($is_Lamf_core_metamodel_domain_DomainElementModel(x1$3)) {
                      var x$28 = $m_Lamf_core_metamodel_document_DocumentModel$().Declares$1;
                      var jsx$6 = ((f === null) ? (x$28 === null) : f.equals__O__Z(x$28))
                    } else {
                      var jsx$6 = false
                    };
                    if (jsx$6) {
                      var nodes$10 = this.nodes$2;
                      var annotations$10 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, nodes$10, sources, key);
                      return $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, values, annotations$10)
                    } else if ($is_Lamf_core_metamodel_document_BaseUnitModel(x1$3)) {
                      var nodes$11 = this.nodes$2;
                      var annotations$11 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, nodes$11, sources, key);
                      return $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, values, annotations$11)
                    } else {
                      var nodes$12 = this.nodes$2;
                      var annotations$12 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__annotations__sci_Map__Lamf_core_model_document_SourceMap__T__Lamf_core_parser_Annotations(this, nodes$12, sources, key);
                      return $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(instance, f, values, annotations$12)
                    }
                  } else {
                    throw new $c_s_MatchError().init___O(x1)
                  }
                }
              }
            }
          }
        }
      }
    }
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.nodeFromId__p2__T__s_Option = (function(id) {
  var x1 = this.graphMap$2.get__O__s_Option(id);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var raw = $as_Lorg_yaml_model_YMap(x2.value$2);
    return new $c_s_Some().init___O(raw)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$1 = this.$$outer$2.ctx$1.eh$1;
      var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnableToParseDocument$1;
      var message = ("Cannot find node with " + id);
      var property = $m_s_None$();
      var lexical = $m_s_None$();
      var location = $m_s_None$();
      this$1.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, "", property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
      return $m_s_None$()
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.parse__p2__Lorg_yaml_model_YMap__s_Option = (function(map) {
  if (this.isReferenceNode__p2__Lorg_yaml_model_YMap__Z(map)) {
    return this.parseReferenceNode__p2__Lorg_yaml_model_YMap__s_Option(map)
  } else {
    var ctx = this.$$outer$2.ctx$1;
    var this$1 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__retrieveId__Lorg_yaml_model_YMap__Lamf_core_parser_ParserContext__s_Option(this, map, ctx);
    if (this$1.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1 = this$1.get__O();
      var id = $as_T(arg1);
      var this$2 = this.retrieveTypeIgnoring__p2__T__Lorg_yaml_model_YMap__sc_Seq__s_Option(id, map, $m_sci_Nil$());
      if (this$2.isEmpty__Z()) {
        return $m_s_None$()
      } else {
        var arg1$1 = this$2.get__O();
        var model = $as_Lamf_core_metamodel_Obj(arg1$1);
        var this$3 = this.parseNode__p2__Lorg_yaml_model_YMap__T__Lamf_core_metamodel_Obj__s_Option(map, id, model);
        if (this$3.isEmpty__Z()) {
          return $m_s_None$()
        } else {
          var arg1$2 = this$3.get__O();
          var parsedObject = $as_Lamf_core_model_domain_AmfObject(arg1$2);
          this.cache$2.update__O__O__V(id, parsedObject);
          return new $c_s_Some().init___O(parsedObject)
        }
      }
    }
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.retrieveTypeIgnoring__p2__T__Lorg_yaml_model_YMap__sc_Seq__s_Option = (function(id, map, ignored) {
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_vocabulary_ValueType(x$1$2);
      return x$1.iri__T()
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var ignoredIris = $as_sc_Seq(ignored.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  var ctx = this.$$outer$2.ctx$1;
  var typeIris = $as_sc_Seq($f_Lamf_plugins_document_graph_parser_GraphParserHelpers__ts__Lorg_yaml_model_YMap__T__Lamf_plugins_document_graph_parser_GraphParserContext__sc_Seq(this, map, id, ctx).diff__sc_GenSeq__O(ignoredIris));
  var x1 = typeIris.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$2$2) {
      var x$2 = $as_T(x$2$2);
      return this$2.findType__p2__T__s_Option(x$2).isDefined__Z()
    })
  })(this)));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var t = $as_T(x2.value$2);
    return this.findType__p2__T__s_Option(t)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$3 = this.$$outer$2.ctx$1.eh$1;
      var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnableToParseNode$1;
      var message = ("Error parsing JSON-LD node, unknown @types " + typeIris);
      var prop = $m_s_None$();
      var l = map.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$3, specification, id, prop, message, l);
      return $m_s_None$()
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.findType__p2__T__s_Option = (function(typeString) {
  var this$1 = this.types$2.get__O__s_Option(this.expandUriFromContext__T__Lamf_plugins_document_graph_parser_GraphParserContext__T(typeString, this.$$outer$2.ctx$1));
  return (this$1.isEmpty__Z() ? $m_Lamf_core_registries_AMFDomainRegistry$().findType__T__s_Option(typeString) : this$1)
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.bool__p2__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar = (function(node) {
  var x1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.$$outer$2.ctx$1;
    var x1$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$12$2) {
        var x$12 = $as_Lorg_yaml_model_YMapEntry(x$12$2);
        var this$1 = x$12.key$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv$1 = $this.$$outer$2.ctx$1;
        var x$1 = $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion$1, iv$1);
        return ((x$1 !== null) && $objectEquals(x$1, "@value"))
      })
    })(this)));
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var this$2 = entry.value$2;
      var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$2 = this.$$outer$2.ctx$1;
      var x$2 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$2, iv$2)).text$3;
      var this$4 = new $c_sci_StringOps().init___T(x$2);
      var $$this = this$4.repr$1;
      var value = $f_sci_StringLike__parseBoolean__psci_StringLike__T__Z(this$4, $$this)
    } else {
      var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$3 = this.$$outer$2.ctx$1;
      var x$3 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$3, iv$3)).text$3;
      var this$7 = new $c_sci_StringOps().init___T(x$3);
      var $$this$1 = this$7.repr$1;
      var value = $f_sci_StringLike__parseBoolean__psci_StringLike__T__Z(this$7, $$this$1)
    }
  } else {
    var conversion$4 = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv$4 = this.$$outer$2.ctx$1;
    var x$4 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$4, iv$4)).text$3;
    var this$10 = new $c_sci_StringOps().init___T(x$4);
    var $$this$2 = this$10.repr$1;
    var value = $f_sci_StringLike__parseBoolean__psci_StringLike__T__Z(this$10, $$this$2)
  };
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, new $c_Lamf_core_parser_Annotations().init___())
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.parseGraph__p2__Lorg_yaml_model_YNode__s_Option = (function(graph) {
  var conversion = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
  var iv = this.$$outer$2.ctx$1;
  this.populateGraphMap__p2__Lorg_yaml_model_YSequence__V($as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(graph, conversion, iv)));
  var rc6 = false;
  var x2 = null;
  var x1 = this.getRootNodeFromGraphMap__p2__s_Option();
  if ((x1 instanceof $c_s_Some)) {
    rc6 = true;
    x2 = $as_s_Some(x1);
    var rootNode = $as_Lorg_yaml_model_YMap(x2.value$2);
    if (this.isSelfEncoded__p2__Lorg_yaml_model_YNode__Z(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(rootNode, $m_Lorg_yaml_model_YType$().Map$1)))) {
      return this.parseSelfEncodedBaseUnit__p2__Lorg_yaml_model_YMap__s_Option(rootNode)
    }
  };
  if (rc6) {
    var rootNode$2 = $as_Lorg_yaml_model_YMap(x2.value$2);
    return this.parseBaseUnit__p2__Lorg_yaml_model_YMap__s_Option(rootNode$2)
  };
  var x = $m_s_None$();
  if ((x === x1)) {
    var this$3 = this.$$outer$2.ctx$1.eh$1;
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().UnableToParseDocument$1;
    var property = $m_s_None$();
    var lexical = $m_s_None$();
    var location = $m_s_None$();
    this$3.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, "", property, "Cannot find root node for flattened JSON-LD", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
    return $m_s_None$()
  };
  throw new $c_s_MatchError().init___O(x1)
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.buildType__p2__T__Lorg_yaml_model_YMap__Lamf_core_metamodel_Obj__F1 = (function(id, map, modelType) {
  var x1 = $m_Lamf_core_registries_AMFDomainRegistry$().metadataRegistry$1.get__O__s_Option($as_Lamf_core_vocabulary_ValueType(modelType.type__sci_List().head__O()).iri__T());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var modelType$2 = $as_Lamf_core_metamodel_Obj(x2.value$2);
    if ($is_Lamf_core_metamodel_ModelDefaultBuilder(modelType$2)) {
      return new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, x3) {
        return (function(annotations$2) {
          var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
          var instance = $as_Lamf_core_metamodel_ModelDefaultBuilder(x3).modelInstance__Lamf_core_model_domain_AmfObject();
          instance.annotations__Lamf_core_parser_Annotations().$$plus$plus$eq__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(annotations);
          return new $c_s_Some().init___O(instance)
        })
      })(this, modelType$2))
    }
  };
  var x1$2 = $m_Lamf_core_registries_AMFDomainRegistry$().buildType__Lamf_core_metamodel_Obj__s_Option(modelType);
  if ((x1$2 instanceof $c_s_Some)) {
    var x2$2 = $as_s_Some(x1$2);
    var builder = $as_F1(x2$2.value$2);
    return new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, builder$1) {
      return (function(a$2) {
        var a = $as_Lamf_core_parser_Annotations(a$2);
        return new $c_s_Some().init___O(builder$1.apply__O__O(a))
      })
    })(this, builder))
  } else {
    var this$1 = this.$$outer$2.ctx$1.eh$1;
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().NodeNotFound$1;
    var message = ("Cannot find builder for node type " + modelType);
    var prop = $m_s_None$();
    var l = map.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, id, prop, message, l);
    return new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3) {
      return (function(x$19$2) {
        $as_Lamf_core_parser_Annotations(x$19$2);
        return $m_s_None$()
      })
    })(this))
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.$float__p2__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar = (function(node) {
  var x1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.$$outer$2.ctx$1;
    var x1$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$18$2) {
        var x$18 = $as_Lorg_yaml_model_YMapEntry(x$18$2);
        var this$1 = x$18.key$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv$1 = $this.$$outer$2.ctx$1;
        var x$1 = $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion$1, iv$1);
        return ((x$1 !== null) && $objectEquals(x$1, "@value"))
      })
    })(this)));
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var this$2 = entry.value$2;
      var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$2 = this.$$outer$2.ctx$1;
      var x$2 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$2, iv$2)).text$3;
      var this$4 = new $c_sci_StringOps().init___T(x$2);
      var jsx$1 = $m_jl_Double$();
      var $$this = this$4.repr$1;
      var value = jsx$1.parseDouble__T__D($$this)
    } else {
      var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$3 = this.$$outer$2.ctx$1;
      var x$3 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$3, iv$3)).text$3;
      var this$7 = new $c_sci_StringOps().init___T(x$3);
      var jsx$2 = $m_jl_Double$();
      var $$this$1 = this$7.repr$1;
      var value = jsx$2.parseDouble__T__D($$this$1)
    }
  } else {
    var conversion$4 = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv$4 = this.$$outer$2.ctx$1;
    var x$4 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$4, iv$4)).text$3;
    var this$10 = new $c_sci_StringOps().init___T(x$4);
    var jsx$3 = $m_jl_Double$();
    var $$this$2 = this$10.repr$1;
    var value = jsx$3.parseDouble__T__D($$this$2)
  };
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, new $c_Lamf_core_parser_Annotations().init___())
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.$double__p2__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar = (function(node) {
  var x1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.$$outer$2.ctx$1;
    var x1$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$14$2) {
        var x$14 = $as_Lorg_yaml_model_YMapEntry(x$14$2);
        var this$1 = x$14.key$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv$1 = $this.$$outer$2.ctx$1;
        var x$1 = $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion$1, iv$1);
        return ((x$1 !== null) && $objectEquals(x$1, "@value"))
      })
    })(this)));
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var this$2 = entry.value$2;
      var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$2 = this.$$outer$2.ctx$1;
      var x$2 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$2, iv$2)).text$3;
      var this$4 = new $c_sci_StringOps().init___T(x$2);
      var jsx$1 = $m_jl_Double$();
      var $$this = this$4.repr$1;
      var value = jsx$1.parseDouble__T__D($$this)
    } else {
      var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$3 = this.$$outer$2.ctx$1;
      var x$3 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$3, iv$3)).text$3;
      var this$7 = new $c_sci_StringOps().init___T(x$3);
      var jsx$2 = $m_jl_Double$();
      var $$this$1 = this$7.repr$1;
      var value = jsx$2.parseDouble__T__D($$this$1)
    }
  } else {
    var conversion$4 = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv$4 = this.$$outer$2.ctx$1;
    var x$4 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$4, iv$4)).text$3;
    var this$10 = new $c_sci_StringOps().init___T(x$4);
    var jsx$3 = $m_jl_Double$();
    var $$this$2 = this$10.repr$1;
    var value = jsx$3.parseDouble__T__D($$this$2)
  };
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, new $c_Lamf_core_parser_Annotations().init___())
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.date__p2__Lorg_yaml_model_YNode__Lamf_core_model_domain_AmfScalar = (function(node) {
  var x1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.$$outer$2.ctx$1;
    var x1$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).entries$3.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$15$2) {
        var x$15 = $as_Lorg_yaml_model_YMapEntry(x$15$2);
        var this$1 = x$15.key$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv$1 = $this.$$outer$2.ctx$1;
        var x$1 = $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion$1, iv$1);
        return ((x$1 !== null) && $objectEquals(x$1, "@value"))
      })
    })(this)));
    if ((x1$2 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$2);
      var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var jsx$1 = $m_Lorg_mulesoft_common_time_SimpleDateTime$();
      var this$2 = entry.value$2;
      var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$2 = this.$$outer$2.ctx$1;
      var this$3 = jsx$1.parse__T__s_util_Either($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$2, iv$2)).text$3);
      var value = $as_Lorg_mulesoft_common_time_SimpleDateTime(new $c_s_util_Either$RightProjection().init___s_util_Either(this$3).get__O())
    } else {
      var jsx$2 = $m_Lorg_mulesoft_common_time_SimpleDateTime$();
      var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$3 = this.$$outer$2.ctx$1;
      var this$4 = jsx$2.parse__T__s_util_Either($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$3, iv$3)).text$3);
      var value = $as_Lorg_mulesoft_common_time_SimpleDateTime(new $c_s_util_Either$RightProjection().init___s_util_Either(this$4).get__O())
    }
  } else {
    var jsx$3 = $m_Lorg_mulesoft_common_time_SimpleDateTime$();
    var conversion$4 = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv$4 = this.$$outer$2.ctx$1;
    var this$5 = jsx$3.parse__T__s_util_Either($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$4, iv$4)).text$3);
    var value = $as_Lorg_mulesoft_common_time_SimpleDateTime(new $c_s_util_Either$RightProjection().init___s_util_Either(this$5).get__O())
  };
  return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, new $c_Lamf_core_parser_Annotations().init___())
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.parseReferenceNode__p2__Lorg_yaml_model_YMap__s_Option = (function(node) {
  var ctx = this.$$outer$2.ctx$1;
  var this$1 = $f_Lamf_plugins_document_graph_parser_GraphParserHelpers__retrieveId__Lorg_yaml_model_YMap__Lamf_core_parser_ParserContext__s_Option(this, node, ctx);
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var id = $as_T(arg1);
    var x1 = this.cache$2.get__O__s_Option(id);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var parsed = $as_Lamf_core_model_domain_AmfObject(x2.value$2);
      return new $c_s_Some().init___O(parsed)
    } else {
      var x = $m_s_None$();
      if ((!(x === x1))) {
        throw new $c_s_MatchError().init___O(x1)
      };
      var this$2 = this.nodeFromId__p2__T__s_Option(id);
      if (this$2.isEmpty__Z()) {
        return $m_s_None$()
      } else {
        var arg1$1 = this$2.get__O();
        var map = $as_Lorg_yaml_model_YMap(arg1$1);
        return this.parse__p2__Lorg_yaml_model_YMap__s_Option(map)
      }
    }
  }
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.isReferenceNode__p2__Lorg_yaml_model_YMap__Z = (function(m) {
  return ((m.entries$3.size__I() === 1) && new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(m).key__T__s_Option("@id").isDefined__Z())
});
function $as_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.graph.parser.FlattenedGraphParser$Parser"))
}
function $isArrayOf_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser)))
}
function $asArrayOf_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.graph.parser.FlattenedGraphParser$Parser;", depth))
}
var $d_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser = new $TypeData().initClass({
  Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser: 0
}, false, "amf.plugins.document.graph.parser.FlattenedGraphParser$Parser", {
  Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser: 1,
  Lamf_plugins_document_graph_parser_GraphContextHelper: 1,
  O: 1,
  Lamf_plugins_document_graph_parser_GraphParserHelpers: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser.prototype.$classData = $d_Lamf_plugins_document_graph_parser_FlattenedGraphParser$Parser;
function $f_Lamf_plugins_document_vocabularies_AMLPlugin__init__s_concurrent_ExecutionContext__s_concurrent_Future($thiz, executionContext) {
  return $m_s_concurrent_Future$().apply__F0__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
    return (function() {
      return $this
    })
  })($thiz)), executionContext)
}
function $f_Lamf_plugins_document_vocabularies_AMLPlugin__unparseAsYDocument__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__s_Option($thiz, unit, renderOptions, shapeRenderOptions) {
  if ((unit instanceof $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_document_Vocabulary(unit);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_VocabularyEmitter().init___Lamf_plugins_document_vocabularies_model_document_Vocabulary(x2).emitVocabulary__Lorg_yaml_model_YDocument())
  } else if ((unit instanceof $c_Lamf_plugins_document_vocabularies_model_document_Dialect)) {
    var x3 = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(unit);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_vocabularies_emitters_dialects_DialectEmitter().init___Lamf_plugins_document_vocabularies_model_document_Dialect(x3).emitDialect__Lorg_yaml_model_YDocument())
  } else if ((unit instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary)) {
    var x4 = $as_Lamf_plugins_document_vocabularies_model_document_DialectLibrary(unit);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_vocabularies_emitters_dialects_RamlDialectLibraryEmitter().init___Lamf_plugins_document_vocabularies_model_document_DialectLibrary(x4).emitDialectLibrary__Lorg_yaml_model_YDocument())
  } else if ($is_Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit(unit)) {
    var x5 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit(unit);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectInstancesEmitter().init___Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_RenderOptions(x5, $as_Lamf_plugins_document_vocabularies_model_document_Dialect($thiz.registry$2.dialectFor__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__s_Option(x5).get__O()), renderOptions).emitInstance__Lorg_yaml_model_YDocument())
  } else {
    return $m_s_None$()
  }
}
function $f_Lamf_plugins_document_vocabularies_AMLPlugin__parseAndRegisterDialect__pLamf_plugins_document_vocabularies_AMLPlugin__Lamf_core_Root__Lamf_core_parser_ParserContext__s_Some($thiz, document, parentContext) {
  var x1 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser().init___Lamf_core_Root__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(document, new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectContext().init___Lamf_core_parser_ParserContext__s_Option(parentContext, $m_s_None$())).parseDocument__Lamf_core_model_document_BaseUnit();
  if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_Dialect)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(x1);
    if (x2.hasValidHeader__Z()) {
      $thiz.registry$2.register__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_plugins_document_vocabularies_DialectsRegistry(x2);
      return new $c_s_Some().init___O(x2)
    }
  };
  return new $c_s_Some().init___O(x1)
}
function $f_Lamf_plugins_document_vocabularies_AMLPlugin__computeValidationProfile__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_validation_core_ValidationProfile($thiz, dialect) {
  var header = dialect.header__T();
  var x1 = $thiz.registry$2.validations$1.get__O__s_Option(header);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var profile = $as_Lamf_core_validation_core_ValidationProfile(x2.value$2);
    return profile
  } else {
    var resolvedDialect = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(new $c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectResolutionPipeline().init___Lamf_core_errorhandling_ErrorHandler($f_Lamf_core_model_document_BaseUnit__errorHandler__Lamf_core_errorhandling_ErrorHandler(dialect)).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(dialect));
    var profile$2 = new $c_Lamf_plugins_document_vocabularies_validation_AMFDialectValidations().init___Lamf_plugins_document_vocabularies_model_document_Dialect(resolvedDialect).profile__Lamf_core_validation_core_ValidationProfile();
    $thiz.registry$2.validations$1 = $thiz.registry$2.validations$1.$$plus__T2__sci_Map(new $c_T2().init___O__O(header, profile$2));
    return profile$2
  }
}
function $f_Lamf_plugins_document_vocabularies_AMLPlugin__canUnparse__Lamf_core_model_document_BaseUnit__Z($thiz, unit) {
  if ((unit instanceof $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary)) {
    return true
  } else if ((unit instanceof $c_Lamf_plugins_document_vocabularies_model_document_Dialect)) {
    return true
  } else if ((unit instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary)) {
    return true
  } else if ($is_Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit(unit)) {
    var x5 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit(unit);
    return $thiz.registry$2.knowsDialectInstance__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__Z(x5)
  } else {
    return false
  }
}
function $f_Lamf_plugins_document_vocabularies_AMLPlugin__parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option($thiz, document, parentContext, platform, options) {
  var header = $m_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$().dialectHeaderDirective__Lamf_core_Root__s_Option(document);
  var rc15 = false;
  var x2 = null;
  if ((header instanceof $c_s_Some)) {
    rc15 = true;
    x2 = $as_s_Some(header);
    var p3 = $as_T(x2.value$2);
    if (($m_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$().VocabularyHeader$1 === p3)) {
      return new $c_s_Some().init___O(new $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabulariesParser().init___Lamf_core_Root__Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext(document, new $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext().init___Lamf_core_parser_ParserContext__s_Option(parentContext, $m_s_None$())).parseDocument__Lamf_core_model_document_BaseUnit())
    }
  };
  if (rc15) {
    var p5 = $as_T(x2.value$2);
    if (($m_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$().DialectLibraryHeader$1 === p5)) {
      return new $c_s_Some().init___O(new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser().init___Lamf_core_Root__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(document, $f_Lamf_plugins_document_vocabularies_AMLPlugin__cleanDialectContext__Lamf_core_parser_ParserContext__Lamf_core_Root__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext($thiz, parentContext, document)).parseLibrary__Lamf_core_model_document_BaseUnit())
    }
  };
  if (rc15) {
    var p7 = $as_T(x2.value$2);
    if (($m_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$().DialectFragmentHeader$1 === p7)) {
      return new $c_s_Some().init___O(new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectsParser().init___Lamf_core_Root__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext(document, new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectContext().init___Lamf_core_parser_ParserContext__s_Option(parentContext, $m_s_None$())).parseFragment__Lamf_core_model_document_BaseUnit())
    }
  };
  if (rc15) {
    var p9 = $as_T(x2.value$2);
    if (($m_Lamf_plugins_document_vocabularies_plugin_headers_ExtensionHeader$().DialectHeader$1 === p9)) {
      var parentContext$1 = $f_Lamf_plugins_document_vocabularies_AMLPlugin__cleanDialectContext__Lamf_core_parser_ParserContext__Lamf_core_Root__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext($thiz, parentContext, document);
      return $f_Lamf_plugins_document_vocabularies_AMLPlugin__parseAndRegisterDialect__pLamf_plugins_document_vocabularies_AMLPlugin__Lamf_core_Root__Lamf_core_parser_ParserContext__s_Some($thiz, document, parentContext$1)
    }
  };
  return $f_Lamf_plugins_document_vocabularies_AMLPlugin__parseDialectInstance__pLamf_plugins_document_vocabularies_AMLPlugin__Lamf_core_Root__s_Option__Lamf_core_parser_ParserContext__s_Option($thiz, document, header, parentContext)
}
function $f_Lamf_plugins_document_vocabularies_AMLPlugin__modelEntities__sc_Seq($thiz) {
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$(), $m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$(), $m_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$(), $m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$(), $m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$(), $m_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$(), $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$(), $m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$(), $m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$(), $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$(), $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$(), $m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$(), $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$(), $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$(), $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$(), $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$(), $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$(), $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$(), $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$()];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
}
function $f_Lamf_plugins_document_vocabularies_AMLPlugin__documentSyntaxes__sc_Seq($thiz) {
  var jsx$1 = $m_sc_Seq$();
  var array = ["application/aml+json", "application/aml+yaml", "application/raml", "application/raml+json", "application/raml+yaml", "text/yaml", "text/x-yaml", "application/yaml", "application/x-yaml", "application/json"];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
}
function $f_Lamf_plugins_document_vocabularies_AMLPlugin__$$init$__V($thiz) {
  $thiz.registry$2 = new $c_Lamf_plugins_document_vocabularies_DialectsRegistry().init___();
  $thiz.ID$2 = $m_Lamf_core_remote_Aml$().name$1;
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_core_remote_Aml$().name$1];
  $thiz.vendors$2 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  $thiz.allowRecursiveReferences$2 = true
}
function $f_Lamf_plugins_document_vocabularies_AMLPlugin__aggregateValidations__Lamf_core_validation_EffectiveValidations__sc_Seq__Lamf_core_validation_EffectiveValidations($thiz, validations, dependenciesValidations) {
  return $as_Lamf_core_validation_EffectiveValidations(dependenciesValidations.foldLeft__O__F2__O(validations, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(x0$1$2, x1$1$2) {
      var x0$1 = $as_Lamf_core_validation_EffectiveValidations(x0$1$2);
      var x1$1 = $as_Lamf_core_validation_core_ValidationProfile(x1$1$2);
      return x0$1.someEffective__Lamf_core_validation_core_ValidationProfile__Lamf_core_validation_EffectiveValidations(x1$1)
    })
  })($thiz))))
}
function $f_Lamf_plugins_document_vocabularies_AMLPlugin__domainValidationProfiles__Lamf_core_remote_Platform__sci_Map($thiz, platform) {
  var this$1 = $thiz.registry$2;
  var this$2 = this$1.map$1;
  var this$3 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$2);
  var z = $m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$());
  var elem$1 = null;
  elem$1 = z;
  var this$5 = this$3.$$outer$3.valuesIterator__sc_Iterator();
  while (this$5.hasNext__Z()) {
    var arg1 = this$5.next__O();
    var arg1$1 = elem$1;
    var x0$1 = $as_sci_Map(arg1$1);
    var x1$1 = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(arg1);
    var thiz = x1$1.nameAndVersion__T();
    if ((!($uI(thiz.indexOf("Validation Profile")) !== (-1)))) {
      elem$1 = x0$1.updated__O__O__sci_Map(x1$1.nameAndVersion__T(), new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, dialect) {
        return (function() {
          return $f_Lamf_plugins_document_vocabularies_AMLPlugin__computeValidationProfile__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_validation_core_ValidationProfile($this, dialect)
        })
      })($thiz, x1$1)))
    } else {
      elem$1 = x0$1
    }
  };
  return $as_sci_Map(elem$1)
}
function $f_Lamf_plugins_document_vocabularies_AMLPlugin__validationRequest__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_validation_EffectiveValidations__Lamf_core_remote_Platform__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future($thiz, baseUnit, profile, validations, platform, env, resolved, executionEnv) {
  var executionContext = executionEnv.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  if ($is_Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit(baseUnit)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit(baseUnit);
    var resolvedModel = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit(new $c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstanceResolutionPipeline().init___Lamf_core_errorhandling_ErrorHandler($f_Lamf_core_model_document_BaseUnit__errorHandler__Lamf_core_errorhandling_ErrorHandler(baseUnit)).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(x2));
    var jsx$4 = $m_s_concurrent_Future$();
    var jsx$3 = x2.graphDependencies__sc_Seq();
    var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(instance$2) {
        var instance = $as_Lamf_core_model_StrField(instance$2);
        var this$5 = $this.registry$2;
        var this$1 = instance.option$1;
        var uri = $as_T((this$1.isEmpty__Z() ? null : this$1.get__O()));
        var environment = $m_Lamf_internal_environment_Environment$().apply__Lamf_internal_environment_Environment();
        var this$3 = $this.registry$2;
        var this$4 = this$3.platform$1;
        var exec = this$4.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
        return this$5.registerDialect__T__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future(uri, environment, exec.$$undinternal$1.context$1)
      })
    })($thiz));
    var this$6 = $m_sc_Seq$();
    var jsx$1 = $as_sc_TraversableOnce(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$6.ReusableCBFInstance$2));
    var this$7 = $m_sc_Seq$();
    var dependenciesValidations = jsx$4.sequence__sc_TraversableOnce__scg_CanBuildFrom__s_concurrent_ExecutionContext__s_concurrent_Future(jsx$1, this$7.ReusableCBFInstance$2, executionContext).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(dialects$2) {
        var dialects = $as_sc_Seq(dialects$2);
        var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
          return (function(dialect$2) {
            var dialect = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(dialect$2);
            return $f_Lamf_plugins_document_vocabularies_AMLPlugin__computeValidationProfile__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_validation_core_ValidationProfile($this$1, dialect)
          })
        })(this$2$1));
        var this$8 = $m_sc_Seq$();
        return $as_sc_Seq(dialects.map__F1__scg_CanBuildFrom__O(jsx$5, this$8.ReusableCBFInstance$2))
      })
    })($thiz)), executionContext);
    return dependenciesValidations.flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, resolvedModel$1, validations$1, executionContext$1, baseUnit$1, profile$1) {
      return (function(validationsFromDeps$2) {
        var validationsFromDeps = $as_sc_Seq(validationsFromDeps$2);
        var x$2 = $f_Lamf_plugins_document_vocabularies_AMLPlugin__aggregateValidations__Lamf_core_validation_EffectiveValidations__sc_Seq__Lamf_core_validation_EffectiveValidations(this$3$1, validations$1, validationsFromDeps);
        var x$3 = new $c_Lamf_core_services_ValidationOptions().init___().withFullValidation__Lamf_core_services_ValidationOptions();
        $m_Lamf_core_services_RuntimeValidator$();
        var x$4 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
        var this$10 = $m_Lamf_core_services_RuntimeValidator$();
        return this$10.validator__p1__Lamf_core_services_RuntimeValidator().shaclValidation__Lamf_core_model_document_BaseUnit__Lamf_core_validation_EffectiveValidations__sci_Map__Lamf_core_services_ValidationOptions__s_concurrent_ExecutionContext__s_concurrent_Future(resolvedModel$1, x$2, x$4, x$3, executionContext$1).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, baseUnit$1$1, validations$1$1, profile$1$1) {
          return (function(shaclReport$2) {
            var shaclReport = $as_Lamf_core_validation_core_ValidationReport(shaclReport$2);
            var this$14 = shaclReport.results__sci_List();
            var f = (function($this$3, baseUnit$1$2, validations$1$2) {
              return (function(r$2) {
                var r = $as_Lamf_core_validation_core_ValidationResult(r$2);
                var this$11 = $m_Lamf_RamlProfile$();
                var messageStyle = this$11.amf$ProfileName$$m$1;
                var xo = $f_Lamf_core_validation_ValidationResultProcessor__buildValidationResult__Lamf_core_model_document_BaseUnit__Lamf_core_validation_core_ValidationResult__Lamf_MessageStyle__Lamf_core_validation_EffectiveValidations__s_Option($this$3, baseUnit$1$2, r, messageStyle, validations$1$2);
                return xo.toList__sci_List()
              })
            })($this$2, baseUnit$1$1, validations$1$1);
            var this$13 = $m_sci_List$();
            var bf = this$13.ReusableCBFInstance$2;
            if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
              if ((this$14 === $m_sci_Nil$())) {
                var jsx$6 = $m_sci_Nil$()
              } else {
                var rest = this$14;
                var found = new $c_sr_BooleanRef().init___Z(false);
                var h = new $c_sr_ObjectRef().init___O(null);
                var t = new $c_sr_ObjectRef().init___O(null);
                while ((rest !== $m_sci_Nil$())) {
                  var arg1 = rest.head__O();
                  $as_sc_GenTraversableOnce(f(arg1)).seq__sc_TraversableOnce().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$4, found$1, h$1, t$1) {
                    return (function(b$2) {
                      if ((!found$1.elem$1)) {
                        h$1.elem$1 = new $c_sci_$colon$colon().init___O__sci_List(b$2, $m_sci_Nil$());
                        t$1.elem$1 = $as_sci_$colon$colon(h$1.elem$1);
                        found$1.elem$1 = true
                      } else {
                        var nx = new $c_sci_$colon$colon().init___O__sci_List(b$2, $m_sci_Nil$());
                        $as_sci_$colon$colon(t$1.elem$1).tl$5 = nx;
                        t$1.elem$1 = nx
                      }
                    })
                  })(this$14, found, h, t)));
                  rest = $as_sci_List(rest.tail__O())
                };
                var jsx$6 = ((!found.elem$1) ? $m_sci_Nil$() : $as_sci_$colon$colon(h.elem$1))
              }
            } else {
              $m_sci_List$();
              var b = new $c_scm_ListBuffer().init___();
              var these = this$14;
              while ((!these.isEmpty__Z())) {
                var arg1$1 = these.head__O();
                var xs = $as_sc_GenTraversableOnce(f(arg1$1)).seq__sc_TraversableOnce();
                b.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(xs);
                these = $as_sci_List(these.tail__O())
              };
              var jsx$6 = b.toList__sci_List()
            };
            var results = $as_sci_List(jsx$6);
            inlinereturn$65: {
              var these$1 = results;
              while ((!these$1.isEmpty__Z())) {
                var arg1$2 = these$1.head__O();
                var x$1 = $as_Lamf_core_validation_AMFValidationResult(arg1$2);
                if ((x$1.level$1 === $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1)) {
                  var jsx$7 = true;
                  break inlinereturn$65
                };
                these$1 = $as_sc_LinearSeqOptimized(these$1.tail__O())
              };
              var jsx$7 = false
            };
            return new $c_Lamf_core_validation_AMFValidationReport().init___Z__T__Lamf_ProfileName__sc_Seq((!jsx$7), baseUnit$1$1.id__T(), profile$1$1, results)
          })
        })(this$3$1, baseUnit$1, validations$1, profile$1)), executionContext$1)
      })
    })($thiz, resolvedModel, validations, executionContext, baseUnit, profile)), executionContext)
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot resolve base unit of type " + $objectGetClass(baseUnit))))
  }
}
function $f_Lamf_plugins_document_vocabularies_AMLPlugin__canParse__Lamf_core_Root__Z($thiz, document) {
  return ((document.parsed$1 instanceof $c_Lamf_core_parser_SyamlParsedDocument) && $m_Lamf_plugins_document_vocabularies_plugin_headers_DialectHeader$().apply__Lamf_core_Root__Lamf_plugins_document_vocabularies_DialectsRegistry__Z(document, $thiz.registry$2))
}
function $f_Lamf_plugins_document_vocabularies_AMLPlugin__parseDocumentWithDialect__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_plugins_document_vocabularies_model_document_Dialect__s_Option__s_Option($thiz, document, parentContext, dialect, header) {
  var this$9 = $thiz.registry$2;
  var f = (function($this, header$1, document$1, parentContext$1) {
    return (function(resolvedDialect$2) {
      var resolvedDialect = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(resolvedDialect$2);
      var rc6 = false;
      var x2 = null;
      if ((header$1 instanceof $c_s_Some)) {
        rc6 = true;
        x2 = $as_s_Some(header$1);
        var headerKey = $as_T(x2.value$2);
        if (resolvedDialect.isFragmentHeader__T__Z(headerKey)) {
          var endIndex = $uI(headerKey.indexOf("/"));
          var name = $as_T(headerKey.substring(1, endIndex));
          return new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceFragmentParser().init___Lamf_core_Root__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext(document$1, new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_parser_ParserContext__s_Option(resolvedDialect, parentContext$1, $m_s_None$())).parse__T__s_Option(name)
        }
      };
      if (rc6) {
        var headerKey$2 = $as_T(x2.value$2);
        if (resolvedDialect.isLibraryHeader__T__Z(headerKey$2)) {
          return new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceLibraryParser().init___Lamf_core_Root__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext(document$1, new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_parser_ParserContext__s_Option(resolvedDialect, parentContext$1, $m_s_None$())).parse__s_Option()
        }
      };
      if (rc6) {
        var headerKey$3 = $as_T(x2.value$2);
        if (resolvedDialect.isPatchHeader__T__Z(headerKey$3)) {
          return new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstancePatchParser().init___Lamf_core_Root__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext(document$1, new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_parser_ParserContext__s_Option(resolvedDialect, parentContext$1, $m_s_None$()).forPatch__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext()).parse__s_Option()
        }
      };
      return new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser().init___Lamf_core_Root__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext(document$1, new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext().init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_parser_ParserContext__s_Option(resolvedDialect, parentContext$1, $m_s_None$())).parseDocument__s_Option()
    })
  })($thiz, header, document, parentContext);
  if ((!this$9.resolved$1.contains__O__Z(dialect.header__T()))) {
    var arg1 = this$9.resolveDialect__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_plugins_document_vocabularies_model_document_Dialect(dialect);
    return $as_s_Option(f(arg1))
  } else {
    return $as_s_Option(f(dialect))
  }
}
function $f_Lamf_plugins_document_vocabularies_AMLPlugin__parseDialectInstance__pLamf_plugins_document_vocabularies_AMLPlugin__Lamf_core_Root__s_Option__Lamf_core_parser_ParserContext__s_Option($thiz, root, header, parentContext) {
  if (header.isEmpty__Z()) {
    var h$3 = $m_s_None$()
  } else {
    var arg1 = header.get__O();
    var h = $as_T(arg1);
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(h, "\\|", 0);
    var this$3 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    var h$3 = new $c_s_Some().init___O($as_T($f_sc_IndexedSeqOptimized__head__O(this$3)))
  };
  if (h$3.isEmpty__Z()) {
    var this$5 = $m_s_None$()
  } else {
    var arg1$1 = h$3.get__O();
    var header$2 = $as_T(arg1$1);
    var this$4 = $thiz.registry$2;
    var this$5 = this$4.map$1.get__O__s_Option(header$2)
  };
  if (this$5.isEmpty__Z()) {
    var registry = $thiz.registry$2;
    var dialect = $f_Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor__dialectInKey__Lamf_core_Root__Lamf_plugins_document_vocabularies_DialectsRegistry__s_Option($thiz, root, registry)
  } else {
    var dialect = this$5
  };
  if ((dialect instanceof $c_s_Some)) {
    var x2 = $as_s_Some(dialect);
    var d = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(x2.value$2);
    return $f_Lamf_plugins_document_vocabularies_AMLPlugin__parseDocumentWithDialect__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_plugins_document_vocabularies_model_document_Dialect__s_Option__s_Option($thiz, root, parentContext, d, h$3)
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Unknown Dialect for document: " + root.location$1)))
  }
}
function $f_Lamf_plugins_document_vocabularies_AMLPlugin__serializableAnnotations__sci_Map($thiz) {
  var y = $m_Lamf_plugins_document_vocabularies_annotations_AliasesLocation$();
  var jsx$3 = new $c_T2().init___O__O("aliases-location", y);
  var y$1 = $m_Lamf_plugins_document_vocabularies_annotations_CustomId$();
  var jsx$2 = new $c_T2().init___O__O("custom-id", y$1);
  var y$2 = $m_Lamf_plugins_document_vocabularies_annotations_RefInclude$();
  var jsx$1 = new $c_T2().init___O__O("ref-include", y$2);
  var y$3 = $m_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef$();
  var array = [jsx$3, jsx$2, jsx$1, new $c_T2().init___O__O("json-pointer-ref", y$3)];
  var this$12 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = $uI(array.length);
  while ((i < len)) {
    var index = i;
    var arg1 = array[index];
    this$12.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  return $as_sci_Map(this$12.elems$1)
}
function $f_Lamf_plugins_document_vocabularies_AMLPlugin__resolve__Lamf_core_model_document_BaseUnit__Lamf_core_errorhandling_ErrorHandler__T__Lamf_core_model_document_BaseUnit($thiz, unit, errorHandler, pipelineId) {
  if ((unit instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch(unit);
    return new $c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstancePatchResolutionPipeline().init___Lamf_core_errorhandling_ErrorHandler(errorHandler).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(x2)
  } else if ((unit instanceof $c_Lamf_plugins_document_vocabularies_model_document_Dialect)) {
    var x3 = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(unit);
    return new $c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectResolutionPipeline().init___Lamf_core_errorhandling_ErrorHandler(errorHandler).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(x3)
  } else if ((unit instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstance)) {
    var x4 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstance(unit);
    return new $c_Lamf_plugins_document_vocabularies_resolution_pipelines_DialectInstanceResolutionPipeline().init___Lamf_core_errorhandling_ErrorHandler(errorHandler).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(x4)
  } else {
    return unit
  }
}
function $f_Lamf_plugins_document_vocabularies_AMLPlugin__cleanDialectContext__Lamf_core_parser_ParserContext__Lamf_core_Root__Lamf_plugins_document_vocabularies_parser_dialects_DialectContext($thiz, wrapped, root) {
  var jsx$4 = root.location$1;
  var jsx$3 = root.references$1;
  var jsx$2 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
  var jsx$1 = wrapped.eh$1;
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$6 = new $c_scm_ListBuffer().init___();
  var cleanNested = new $c_Lamf_core_parser_ParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext(jsx$4, jsx$3, jsx$2, jsx$1, new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$6.toList__sci_List()));
  return new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectContext().init___Lamf_core_parser_ParserContext__s_Option(cleanNested, $m_s_None$())
}
function $is_Lamf_plugins_document_vocabularies_AMLPlugin(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.Lamf_plugins_document_vocabularies_AMLPlugin)))
}
function $as_Lamf_plugins_document_vocabularies_AMLPlugin(obj) {
  return (($is_Lamf_plugins_document_vocabularies_AMLPlugin(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.AMLPlugin"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_AMLPlugin(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_AMLPlugin)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_AMLPlugin(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_AMLPlugin(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.AMLPlugin;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation() {
  $c_O.call(this);
  this.position$1 = 0;
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation.prototype.constructor = $c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_annotations_AliasesLocation() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_annotations_AliasesLocation.prototype = $c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation.prototype;
$c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation.prototype.productPrefix__T = (function() {
  return "AliasesLocation"
});
$c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation)) {
    var AliasesLocation$1 = $as_Lamf_plugins_document_vocabularies_annotations_AliasesLocation(x$1);
    return (this.position$1 === AliasesLocation$1.position$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.position$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation.prototype.init___I = (function(position) {
  this.position$1 = position;
  this.name$1 = "aliases-location";
  this.value$1 = ("" + position);
  return this
});
$c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.position$1);
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 1)
});
$c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_vocabularies_annotations_AliasesLocation(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.annotations.AliasesLocation"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_annotations_AliasesLocation(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_annotations_AliasesLocation)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_annotations_AliasesLocation(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_annotations_AliasesLocation(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.annotations.AliasesLocation;", depth))
}
var $d_Lamf_plugins_document_vocabularies_annotations_AliasesLocation = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_annotations_AliasesLocation: 0
}, false, "amf.plugins.document.vocabularies.annotations.AliasesLocation", {
  Lamf_plugins_document_vocabularies_annotations_AliasesLocation: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_annotations_AliasesLocation.prototype.$classData = $d_Lamf_plugins_document_vocabularies_annotations_AliasesLocation;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_annotations_CustomId() {
  $c_O.call(this);
  this.uri$1 = null;
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_plugins_document_vocabularies_annotations_CustomId.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_annotations_CustomId.prototype.constructor = $c_Lamf_plugins_document_vocabularies_annotations_CustomId;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_annotations_CustomId() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_annotations_CustomId.prototype = $c_Lamf_plugins_document_vocabularies_annotations_CustomId.prototype;
$c_Lamf_plugins_document_vocabularies_annotations_CustomId.prototype.productPrefix__T = (function() {
  return "CustomId"
});
$c_Lamf_plugins_document_vocabularies_annotations_CustomId.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_vocabularies_annotations_CustomId.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_annotations_CustomId)) {
    var CustomId$1 = $as_Lamf_plugins_document_vocabularies_annotations_CustomId(x$1);
    return (this.uri$1 === CustomId$1.uri$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_annotations_CustomId.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.uri$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_annotations_CustomId.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_annotations_CustomId.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_vocabularies_annotations_CustomId.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_plugins_document_vocabularies_annotations_CustomId.prototype.init___T = (function(uri) {
  this.uri$1 = uri;
  this.name$1 = "custom-id";
  this.value$1 = uri;
  return this
});
$c_Lamf_plugins_document_vocabularies_annotations_CustomId.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_annotations_CustomId.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_vocabularies_annotations_CustomId(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_annotations_CustomId) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.annotations.CustomId"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_annotations_CustomId(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_annotations_CustomId)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_annotations_CustomId(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_annotations_CustomId(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.annotations.CustomId;", depth))
}
var $d_Lamf_plugins_document_vocabularies_annotations_CustomId = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_annotations_CustomId: 0
}, false, "amf.plugins.document.vocabularies.annotations.CustomId", {
  Lamf_plugins_document_vocabularies_annotations_CustomId: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_annotations_CustomId.prototype.$classData = $d_Lamf_plugins_document_vocabularies_annotations_CustomId;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef() {
  $c_O.call(this);
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef.prototype.constructor = $c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef.prototype = $c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef.prototype;
$c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef.prototype.init___ = (function() {
  this.name$1 = "json-pointer-ref";
  this.value$1 = "true";
  return this
});
$c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef.prototype.productPrefix__T = (function() {
  return "JsonPointerRef"
});
$c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef) && ($as_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef(x$1), true))
});
$c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.annotations.JsonPointerRef"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_annotations_JsonPointerRef)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.annotations.JsonPointerRef;", depth))
}
var $d_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_annotations_JsonPointerRef: 0
}, false, "amf.plugins.document.vocabularies.annotations.JsonPointerRef", {
  Lamf_plugins_document_vocabularies_annotations_JsonPointerRef: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef.prototype.$classData = $d_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_annotations_RefInclude() {
  $c_O.call(this);
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_plugins_document_vocabularies_annotations_RefInclude.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_annotations_RefInclude.prototype.constructor = $c_Lamf_plugins_document_vocabularies_annotations_RefInclude;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_annotations_RefInclude() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_annotations_RefInclude.prototype = $c_Lamf_plugins_document_vocabularies_annotations_RefInclude.prototype;
$c_Lamf_plugins_document_vocabularies_annotations_RefInclude.prototype.init___ = (function() {
  this.name$1 = "ref-include";
  this.value$1 = "true";
  return this
});
$c_Lamf_plugins_document_vocabularies_annotations_RefInclude.prototype.productPrefix__T = (function() {
  return "RefInclude"
});
$c_Lamf_plugins_document_vocabularies_annotations_RefInclude.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_vocabularies_annotations_RefInclude.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_annotations_RefInclude) && ($as_Lamf_plugins_document_vocabularies_annotations_RefInclude(x$1), true))
});
$c_Lamf_plugins_document_vocabularies_annotations_RefInclude.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_vocabularies_annotations_RefInclude.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_annotations_RefInclude.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_vocabularies_annotations_RefInclude.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_plugins_document_vocabularies_annotations_RefInclude.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_annotations_RefInclude.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_vocabularies_annotations_RefInclude(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_annotations_RefInclude) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.annotations.RefInclude"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_annotations_RefInclude(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_annotations_RefInclude)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_annotations_RefInclude(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_annotations_RefInclude(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.annotations.RefInclude;", depth))
}
var $d_Lamf_plugins_document_vocabularies_annotations_RefInclude = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_annotations_RefInclude: 0
}, false, "amf.plugins.document.vocabularies.annotations.RefInclude", {
  Lamf_plugins_document_vocabularies_annotations_RefInclude: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_annotations_RefInclude.prototype.$classData = $d_Lamf_plugins_document_vocabularies_annotations_RefInclude;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter() {
  $c_O.call(this);
  this.external$1 = null;
  this.ordering$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter.prototype.productPrefix__T = (function() {
  return "ExternalEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter)) {
    var ExternalEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter(x$1);
    var x = this.external$1;
    var x$2 = ExternalEmitter$1.external$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = ExternalEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.external$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.external$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().DisplayName$1));
  var this$3 = this$2.option$1;
  var jsx$1 = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
  var this$4 = this.external$1;
  var this$5 = $as_Lamf_core_model_StrField(this$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().Base$1));
  var this$6 = this$5.option$1;
  new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position(jsx$1, $as_T((this$6.isEmpty__Z() ? null : this$6.get__O())), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
});
$c_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter.prototype.init___Lamf_plugins_document_vocabularies_model_domain_External__Lamf_core_emitter_SpecOrdering = (function(external, ordering) {
  this.external$1 = external;
  this.ordering$1 = ordering;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.external$1.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_Lamf_core_annotations_LexicalInformation(arg1);
    var this$2 = new $c_s_Some().init___O(x$1.range__Lamf_core_parser_Range().start$1)
  };
  return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
});
function $as_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.common.ExternalEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.common.ExternalEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.common.ExternalEmitter", {
  Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_common_ExternalEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter() {
  $c_O.call(this);
  this.reference$1 = null;
  this.ordering$1 = null;
  this.aliases$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter.prototype.productPrefix__T = (function() {
  return "ReferenceEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter.prototype.init___Lamf_core_model_document_DeclaresModel__Lamf_core_emitter_SpecOrdering__sci_Map = (function(reference, ordering, aliases) {
  this.reference$1 = reference;
  this.ordering$1 = ordering;
  this.aliases$1 = aliases;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter)) {
    var ReferenceEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter(x$1);
    var x = this.reference$1;
    var x$2 = ReferenceEmitter$1.reference$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = ReferenceEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.aliases$1;
      var x$6 = ReferenceEmitter$1.aliases$1;
      return ((x$5 === null) ? (x$6 === null) : $f_sc_GenMapLike__equals__O__Z(x$5, x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.reference$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.aliases$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var x1 = this.reference$1;
  if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_document_Vocabulary(x1);
    var this$1 = $as_Lamf_core_model_StrField(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Base$1));
    var this$2 = this$1.option$1;
    var aliasKey = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()))
  } else {
    var aliasKey = this.reference$1.id__T()
  };
  var x1$2 = this.aliases$1.get__O__s_Option(aliasKey);
  matchEnd5: {
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var p3 = $as_T2(x2$2.value$2);
      if ((p3 !== null)) {
        var alias = $as_T(p3.$$und1__O());
        var location = $as_T(p3.$$und2__O());
        new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position(alias, location, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b);
        break matchEnd5
      }
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  return $m_Lamf_core_parser_Position$ZERO$()
});
function $as_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.dialects.ReferenceEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.dialects.ReferenceEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.ReferenceEmitter", {
  Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter() {
  $c_O.call(this);
  this.baseUnit$1 = null;
  this.ordering$1 = null;
  this.aliases$1 = null;
  this.modules$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter.prototype.productPrefix__T = (function() {
  return "ReferencesEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter)) {
    var ReferencesEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter(x$1);
    var x = this.baseUnit$1;
    var x$2 = ReferencesEmitter$1.baseUnit$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = ReferencesEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.aliases$1;
      var x$6 = ReferencesEmitter$1.aliases$1;
      return ((x$5 === null) ? (x$6 === null) : $f_sc_GenMapLike__equals__O__Z(x$5, x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.baseUnit$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.aliases$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  if (this.modules$1.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("uses");
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$5 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    var jsx$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var jsx$3 = this.ordering$1;
    var jsx$2 = this.modules$1;
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(r$2) {
        var r = $as_Lamf_core_model_document_BaseUnit(r$2);
        return new $c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferenceEmitter().init___Lamf_core_model_document_DeclaresModel__Lamf_core_emitter_SpecOrdering__sci_Map($as_Lamf_core_model_document_DeclaresModel(r), $this.ordering$1, $this.aliases$1)
      })
    })(this));
    var this$3 = $m_sc_Seq$();
    jsx$4.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$3.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))), b$1);
    jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
    var this$6 = v.builder$1;
    var array = [key];
    if ((this$6.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$6.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
    var len$1 = this$6.size0$6;
    var src = this$6.array$6;
    var dest = this$6.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$6.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$6 = j;
      var index = i;
      xs.set(jsx$6, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$6.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_core_emitter_SpecOrdering__sci_Map = (function(baseUnit, ordering, aliases) {
  this.baseUnit$1 = baseUnit;
  this.ordering$1 = ordering;
  this.aliases$1 = aliases;
  var jsx$2 = baseUnit.references__sc_Seq();
  var jsx$1 = new $c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter$$anonfun$6().init___Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter(this);
  var this$1 = $m_sc_Seq$();
  this.modules$1 = $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.baseUnit$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_plugins_document_vocabularies_annotations_AliasesLocation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var annot = $as_Lamf_plugins_document_vocabularies_annotations_AliasesLocation(arg1);
    var _1$mcI$sp = annot.position$1;
    var this$3 = new $c_s_Some().init___O(new $c_Lamf_core_parser_Position().init___I__I(_1$mcI$sp, 0))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.dialects.ReferencesEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.dialects.ReferencesEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.ReferencesEmitter", {
  Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_ReferencesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter() {
  $c_O.call(this);
  this.reference$1 = null;
  this.ordering$1 = null;
  this.aliases$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter.prototype.productPrefix__T = (function() {
  return "ReferenceEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter)) {
    var ReferenceEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter(x$1);
    var x = this.reference$1;
    var x$2 = ReferenceEmitter$1.reference$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = ReferenceEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.aliases$1;
      var x$6 = ReferenceEmitter$1.aliases$1;
      return ((x$5 === null) ? (x$6 === null) : $f_sc_GenMapLike__equals__O__Z(x$5, x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.reference$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.aliases$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var x1 = this.aliases$1.get__O__s_Option(this.reference$1.id__T());
  matchEnd5: {
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var p3 = $as_T2(x2.value$2);
      if ((p3 !== null)) {
        var alias = $as_T(p3.$$und1__O());
        var location = $as_T(p3.$$und2__O());
        new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position(alias, location, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b);
        break matchEnd5
      }
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_core_emitter_SpecOrdering__sci_Map = (function(reference, ordering, aliases) {
  this.reference$1 = reference;
  this.ordering$1 = ordering;
  this.aliases$1 = aliases;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  return $m_Lamf_core_parser_Position$ZERO$()
});
function $as_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.instances.ReferenceEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.instances.ReferenceEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.instances.ReferenceEmitter", {
  Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter() {
  $c_O.call(this);
  this.baseUnit$1 = null;
  this.ordering$1 = null;
  this.aliases$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter.prototype.productPrefix__T = (function() {
  return "ReferencesEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter)) {
    var ReferencesEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter(x$1);
    var x = this.baseUnit$1;
    var x$2 = ReferencesEmitter$1.baseUnit$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = ReferencesEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.aliases$1;
      var x$6 = ReferencesEmitter$1.aliases$1;
      return ((x$5 === null) ? (x$6 === null) : $f_sc_GenMapLike__equals__O__Z(x$5, x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.baseUnit$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.aliases$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var jsx$2 = this.baseUnit$1.references__sc_Seq();
  var jsx$1 = new $c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter$$anonfun$1().init___Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter(this);
  var this$1 = $m_sc_Seq$();
  var modules = $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  if (modules.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("uses");
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$6 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    var jsx$5 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var jsx$4 = this.ordering$1;
    var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(r$2) {
        var r = $as_Lamf_core_model_document_BaseUnit(r$2);
        return new $c_Lamf_plugins_document_vocabularies_emitters_instances_ReferenceEmitter().init___Lamf_core_model_document_BaseUnit__Lamf_core_emitter_SpecOrdering__sci_Map(r, $this.ordering$1, $this.aliases$1)
      })
    })(this));
    var this$4 = $m_sc_Seq$();
    jsx$5.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$4.sorted__sc_Seq__sc_Seq($as_sc_Seq(modules.map__F1__scg_CanBuildFrom__O(jsx$3, this$4.ReusableCBFInstance$2))), b$1);
    jsx$6.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
    var this$7 = v.builder$1;
    var array = [key];
    if ((this$7.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$7.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
    var len$1 = this$7.size0$6;
    var src = this$7.array$6;
    var dest = this$7.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$7.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$7 = j;
      var index = i;
      xs.set(jsx$7, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$7.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_core_emitter_SpecOrdering__sci_Map = (function(baseUnit, ordering, aliases) {
  this.baseUnit$1 = baseUnit;
  this.ordering$1 = ordering;
  this.aliases$1 = aliases;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.baseUnit$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_plugins_document_vocabularies_annotations_AliasesLocation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var annot = $as_Lamf_plugins_document_vocabularies_annotations_AliasesLocation(arg1);
    var _1$mcI$sp = annot.position$1;
    var this$3 = new $c_s_Some().init___O(new $c_Lamf_core_parser_Position().init___I__I(_1$mcI$sp, 0))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.instances.ReferencesEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.instances.ReferencesEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.instances.ReferencesEmitter", {
  Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter() {
  $c_O.call(this);
  this.vocabularyReference$1 = null;
  this.vocabulary$1 = null;
  this.ordering$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter.prototype.init___Lamf_plugins_document_vocabularies_model_domain_VocabularyReference__Lamf_plugins_document_vocabularies_model_document_Vocabulary__Lamf_core_emitter_SpecOrdering = (function(vocabularyReference, vocabulary, ordering) {
  this.vocabularyReference$1 = vocabularyReference;
  this.vocabulary$1 = vocabulary;
  this.ordering$1 = ordering;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter.prototype.productPrefix__T = (function() {
  return "ImportEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter)) {
    var ImportEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter(x$1);
    var x = this.vocabularyReference$1;
    var x$2 = ImportEmitter$1.vocabularyReference$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.vocabulary$1;
      var x$4 = ImportEmitter$1.vocabulary$1;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.ordering$1;
      var x$6 = ImportEmitter$1.ordering$1;
      return (x$5 === x$6)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.vocabularyReference$1;
      break
    }
    case 1: {
      return this.vocabulary$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.vocabulary$1;
  var this$2 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$1);
  var thiz = $as_T((this$2.isEmpty__Z() ? this.vocabulary$1.id$1 : this$2.get__O()));
  var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "/", 0);
  var this$5 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
  var vocabFile = $as_T($f_sc_IndexedSeqOptimized__last__O(this$5));
  var this$6 = this.vocabulary$1;
  var this$7 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$6);
  var thiz$1 = $as_T((this$7.isEmpty__Z() ? this.vocabulary$1.id$1 : this$7.get__O()));
  var vocabFilePrefix = $as_T(thiz$1.split(vocabFile).join(""));
  var this$10 = this.vocabulary$1;
  var x1 = $as_sc_Seq(this$10.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().References$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x$12$2) {
      var x$12 = $as_Lamf_core_model_document_BaseUnit(x$12$2);
      var jsx$1 = x$12.id__T();
      var this$11 = this$3$1.vocabularyReference$1;
      var this$12 = $as_Lamf_core_model_StrField(this$11.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$().Reference$1));
      var this$13 = this$12.option$1;
      return (jsx$1 === $as_T((this$13.isEmpty__Z() ? null : this$13.get__O())))
    })
  })(this)));
  matchEnd6: {
    var vocabularyReferenceFile;
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var reference = $as_Lamf_core_model_document_BaseUnit(x2.value$2);
      if ((reference !== null)) {
        var this$14 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(reference);
        var vocabularyReferenceFile = $as_T((this$14.isEmpty__Z() ? reference.id__T() : this$14.get__O()));
        break matchEnd6
      }
    };
    var x = $m_s_None$();
    if ((x === x1)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Cannot regenerate vocabulary link without reference"))
    };
    throw new $c_s_MatchError().init___O(x1)
  };
  var importLocation = (($uI(vocabularyReferenceFile.indexOf(vocabFilePrefix)) !== (-1)) ? $as_T(vocabularyReferenceFile.split(vocabFilePrefix).join("")) : $as_T(vocabularyReferenceFile.split("file://").join("")));
  var this$22 = this.vocabularyReference$1;
  var this$23 = $as_Lamf_core_model_StrField(this$22.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$().Alias$1));
  var this$24 = this$23.option$1;
  new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position($as_T((this$24.isEmpty__Z() ? null : this$24.get__O())), importLocation, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.vocabularyReference$1.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$13 = $as_Lamf_core_annotations_LexicalInformation(arg1);
    var this$2 = new $c_s_Some().init___O(x$13.range__Lamf_core_parser_Range().start$1)
  };
  return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
});
function $as_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.vocabularies.ImportEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.vocabularies.ImportEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.vocabularies.ImportEmitter", {
  Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_ImportEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.Externals$1 = null;
  this.Encodes$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null
}
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModel__$$init$__V(this);
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  var x$10 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "DialectFragment");
  var this$3 = $m_Lamf_core_metamodel_document_FragmentModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$10, this$3);
  var x$12 = this.Externals$1;
  var x$11 = this.Location$1;
  var this$4 = $m_Lamf_core_metamodel_document_FragmentModel$().fields$1;
  var this$5 = new $c_sci_$colon$colon().init___O__sci_List(x$11, this$4);
  this.fields$1 = new $c_sci_$colon$colon().init___O__sci_List(x$12, this$5);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "Dialect Fragment", "AML dialect mapping fragment that can be included in multiple AML dialects", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_vocabularies_model_document_DialectFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$.prototype.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Encodes$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$.prototype.amf$plugins$document$vocabularies$metamodel$document$ExternalContextModel$$undsetter$und$Externals$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Externals$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$: 0
}, false, "amf.plugins.document.vocabularies.metamodel.document.DialectFragmentModel$", {
  Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_FragmentModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModel: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$;
var $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$() {
  if ((!$n_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$)) {
    $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$ = new $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.Externals$1 = null;
  this.Declares$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null
}
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_ModuleModel__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModel__$$init$__V(this);
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  var x$7 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "DialectLibrary");
  var this$3 = $m_Lamf_core_metamodel_document_DocumentModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$7, this$3);
  var x$9 = this.Externals$1;
  var x$8 = this.Location$1;
  var this$4 = $m_Lamf_core_metamodel_document_ModuleModel$().fields$1;
  var this$5 = new $c_sci_$colon$colon().init___O__sci_List(x$8, this$4);
  this.fields$1 = new $c_sci_$colon$colon().init___O__sci_List(x$9, this$5);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "Dialect Library", "Library of AML mappings that can be reused in different AML dialects", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$.prototype.amf$core$metamodel$document$ModuleModel$$undsetter$und$Declares$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Declares$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$.prototype.amf$plugins$document$vocabularies$metamodel$document$ExternalContextModel$$undsetter$und$Externals$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Externals$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$: 0
}, false, "amf.plugins.document.vocabularies.metamodel.document.DialectLibraryModel$", {
  Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_ModuleModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModel: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$;
var $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$() {
  if ((!$n_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$)) {
    $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$ = new $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$() {
  $c_O.call(this);
  this.Name$1 = null;
  this.Base$1 = null;
  this.Imports$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.Externals$1 = null;
  this.Declares$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null
}
$c_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_ModuleModel__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Name$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "name"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "name", "Name for an entity", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.Base$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "base"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "base", "Base URI prefix for definitions in this vocabulary", $m_sci_Nil$()), true);
  var jsx$3 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$());
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Owl$1;
  this.Imports$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "imports"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Owl$1, "import", "import relationships between vocabularies", $m_sci_Nil$()), true);
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  var x$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "Vocabulary");
  var this$12 = $m_Lamf_core_vocabulary_Namespace$().Owl$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$12, "Ontology");
  var this$14 = $m_Lamf_core_metamodel_document_BaseUnitModel$().type$1;
  var this$15 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$14);
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$15);
  var x$8 = this.Name$1;
  var x$7 = this.Imports$1;
  var x$6 = this.Externals$1;
  var x$5 = this.Declares$1;
  var x$4 = this.Base$1;
  var x$3 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
  var this$16 = $m_Lamf_core_metamodel_document_BaseUnitModel$().fields$1;
  var this$17 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$16);
  var this$18 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$17);
  var this$19 = new $c_sci_$colon$colon().init___O__sci_List(x$5, this$18);
  var this$20 = new $c_sci_$colon$colon().init___O__sci_List(x$6, this$19);
  var this$21 = new $c_sci_$colon$colon().init___O__sci_List(x$7, this$20);
  this.fields$1 = new $c_sci_$colon$colon().init___O__sci_List(x$8, this$21);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "Vocabulary", "Basic primitives for the declaration of vocabularies.", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$.prototype.amf$core$metamodel$document$ModuleModel$$undsetter$und$Declares$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Declares$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$.prototype.amf$plugins$document$vocabularies$metamodel$document$ExternalContextModel$$undsetter$und$Externals$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Externals$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$: 0
}, false, "amf.plugins.document.vocabularies.metamodel.document.VocabularyModel$", {
  Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_ModuleModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModel: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$;
var $n_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$() {
  if ((!$n_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$)) {
    $n_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$ = new $c_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$() {
  $c_O.call(this);
  this.Name$1 = null;
  this.NodePropertyMapping$1 = null;
  this.LiteralRange$1 = null;
  this.ObjectRange$1 = null;
  this.MapKeyProperty$1 = null;
  this.MapValueProperty$1 = null;
  this.MapTermKeyProperty$1 = null;
  this.MapTermValueProperty$1 = null;
  this.Sorted$1 = null;
  this.MinCount$1 = null;
  this.Pattern$1 = null;
  this.Minimum$1 = null;
  this.Maximum$1 = null;
  this.AllowMultiple$1 = null;
  this.Enum$1 = null;
  this.Unique$1 = null;
  this.ExternallyLinkable$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.TypeDiscriminator$1 = null;
  this.TypeDiscriminatorName$1 = null;
  this.MergePolicy$1 = null;
  this.ALLOWED$undMERGE$undPOLICY$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_metamodel_domain_MergeableMappingModel__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_metamodel_domain_NodeWithDiscriminatorModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Name$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "name"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "name", "Name in the source AST for the mapped property", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.NodePropertyMapping$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "path"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "path", "URI in the mapped graph for this mapped property", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.LiteralRange$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "datatype"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "datatype", "Scalar constraint over the type of the mapped property", $m_sci_Nil$()), true);
  var jsx$4 = new $c_Lamf_core_metamodel_Type$SortedArray().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Iri$());
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.ObjectRange$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "node"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "range", "Object constraint over the type of the mapped property", $m_sci_Nil$()), true);
  var jsx$5 = $m_Lamf_core_metamodel_Type$Str$();
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.MapKeyProperty$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "mapProperty"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "map label property", "Marks the mapping as a 'map' mapping syntax. Directly related with mapTermKeyProperty", $m_sci_Nil$()), true);
  var jsx$6 = $m_Lamf_core_metamodel_Type$Str$();
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.MapValueProperty$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$6, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "mapValueProperty"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "map label value property", "Marks the mapping as a 'map value' mapping syntax. Directly related with mapTermValueProperty", $m_sci_Nil$()), true);
  var jsx$7 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$19 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.MapTermKeyProperty$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$7, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$19, "mapTermProperty"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "map term property uri", "Marks the mapping as a 'map' mapping syntax. ", $m_sci_Nil$()), true);
  var jsx$8 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$22 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.MapTermValueProperty$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$8, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$22, "mapTermValueProperty"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "map term value property", "Marks the mapping as a 'map value' mapping syntax", $m_sci_Nil$()), true);
  var jsx$9 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$25 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.Sorted$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$9, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$25, "sorted"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "sorted", "Marks the mapping as requiring order in the mapped collection of nodes", $m_sci_Nil$()), true);
  var jsx$10 = $m_Lamf_core_metamodel_Type$Int$();
  var this$28 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.MinCount$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$10, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$28, "minCount"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "min count", "Minimum count constraint over tha mapped property", $m_sci_Nil$()), true);
  var jsx$11 = $m_Lamf_core_metamodel_Type$Str$();
  var this$31 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.Pattern$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$11, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$31, "pattern"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "pattern", "Pattern constraint over the mapped property", $m_sci_Nil$()), true);
  var jsx$12 = $m_Lamf_core_metamodel_Type$Double$();
  var this$34 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.Minimum$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$12, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$34, "minInclusive"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "min inclusive", "Minimum inclusive constraint over the mapped property", $m_sci_Nil$()), true);
  var jsx$13 = $m_Lamf_core_metamodel_Type$Double$();
  var this$37 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.Maximum$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$13, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$37, "maxInclusive"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "max inclusive", "Maximum inclusive constraint over the mapped property", $m_sci_Nil$()), true);
  var jsx$14 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$40 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.AllowMultiple$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$14, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$40, "allowMultiple"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "allow multiple", "Allows multiple mapped nodes for the property mapping", $m_sci_Nil$()), true);
  var jsx$15 = new $c_Lamf_core_metamodel_Type$SortedArray().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Any$());
  var this$43 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.Enum$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$15, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$43, "in"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "in", "Enum constraint for the values of the property mapping", $m_sci_Nil$()), true);
  var jsx$16 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$46 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.Unique$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$16, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$46, "unique"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "unique", "Marks the values for the property mapping as a primary key for this type of node", $m_sci_Nil$()), true);
  var jsx$17 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$49 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.ExternallyLinkable$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$17, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$49, "externallyLinkable"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "linkable", "Marks this object property as supporting external links", $m_sci_Nil$()), true);
  var this$52 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  var x$21 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$52, "NodePropertyMapping");
  var this$54 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$21, this$54);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "Node Property Mapping", "Semantic mapping from an input AST in a dialect document to the output graph of information for a class of output node", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$.prototype.amf$plugins$document$vocabularies$metamodel$domain$NodeWithDiscriminatorModel$$undsetter$und$TypeDiscriminatorName$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TypeDiscriminatorName$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$.prototype.amf$plugins$document$vocabularies$metamodel$domain$NodeWithDiscriminatorModel$$undsetter$und$TypeDiscriminator$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TypeDiscriminator$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$.prototype.fields__sci_List = (function() {
  var x$20 = this.NodePropertyMapping$1;
  var x$19 = this.Name$1;
  var x$18 = this.LiteralRange$1;
  var x$17 = this.ObjectRange$1;
  var x$16 = this.MapKeyProperty$1;
  var x$15 = this.MapValueProperty$1;
  var x$14 = this.MapTermKeyProperty$1;
  var x$13 = this.MapTermValueProperty$1;
  var x$12 = this.MinCount$1;
  var x$11 = this.Pattern$1;
  var x$10 = this.Minimum$1;
  var x$9 = this.Maximum$1;
  var x$8 = this.AllowMultiple$1;
  var x$7 = this.Sorted$1;
  var x$6 = this.Enum$1;
  var x$5 = this.TypeDiscriminator$1;
  var x$4 = this.Unique$1;
  var x$3 = this.ExternallyLinkable$1;
  var x$2 = this.TypeDiscriminatorName$1;
  var x$1 = this.MergePolicy$1;
  var this$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$2 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$1);
  var this$3 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$2);
  var this$4 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$3);
  var this$5 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$4);
  var this$6 = new $c_sci_$colon$colon().init___O__sci_List(x$5, this$5);
  var this$7 = new $c_sci_$colon$colon().init___O__sci_List(x$6, this$6);
  var this$8 = new $c_sci_$colon$colon().init___O__sci_List(x$7, this$7);
  var this$9 = new $c_sci_$colon$colon().init___O__sci_List(x$8, this$8);
  var this$10 = new $c_sci_$colon$colon().init___O__sci_List(x$9, this$9);
  var this$11 = new $c_sci_$colon$colon().init___O__sci_List(x$10, this$10);
  var this$12 = new $c_sci_$colon$colon().init___O__sci_List(x$11, this$11);
  var this$13 = new $c_sci_$colon$colon().init___O__sci_List(x$12, this$12);
  var this$14 = new $c_sci_$colon$colon().init___O__sci_List(x$13, this$13);
  var this$15 = new $c_sci_$colon$colon().init___O__sci_List(x$14, this$14);
  var this$16 = new $c_sci_$colon$colon().init___O__sci_List(x$15, this$15);
  var this$17 = new $c_sci_$colon$colon().init___O__sci_List(x$16, this$16);
  var this$18 = new $c_sci_$colon$colon().init___O__sci_List(x$17, this$17);
  var this$19 = new $c_sci_$colon$colon().init___O__sci_List(x$18, this$18);
  var this$20 = new $c_sci_$colon$colon().init___O__sci_List(x$19, this$19);
  return new $c_sci_$colon$colon().init___O__sci_List(x$20, this$20)
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$.prototype.amf$plugins$document$vocabularies$metamodel$domain$MergeableMappingModel$$undsetter$und$MergePolicy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.MergePolicy$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$.prototype.amf$plugins$document$vocabularies$metamodel$domain$MergeableMappingModel$$undsetter$und$ALLOWED$undMERGE$undPOLICY$und$eq__sci_Set__V = (function(x$1) {
  this.ALLOWED$undMERGE$undPOLICY$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$: 0
}, false, "amf.plugins.document.vocabularies.metamodel.domain.PropertyMappingModel$", {
  Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_document_vocabularies_metamodel_domain_MergeableMappingModel: 1,
  Lamf_plugins_document_vocabularies_metamodel_domain_NodeWithDiscriminatorModel: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$;
var $n_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$() {
  if ((!$n_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$)) {
    $n_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$ = new $c_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceFragmentParser() {
  $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceFragmentParser.prototype = new $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceFragmentParser.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceFragmentParser;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceFragmentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceFragmentParser.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceFragmentParser.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceFragmentParser.prototype.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext = (function() {
  return this.ctx$1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceFragmentParser.prototype.parseEncodedFragment__p2__Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment__s_Option = (function(dialectInstanceFragment) {
  var jsx$1 = $m_s_Option$();
  var this$1 = this.ctx$1.dialect$2;
  var this$2 = jsx$1.apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1)));
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var documents = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(arg1);
    var x1 = $as_sc_Seq(documents.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Fragments$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(dm$2) {
        var dm = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(dm$2);
        var jsx$2 = $m_Lorg_mulesoft_common_core_package$Strings$();
        var this$3 = $this.root$1.parsed$1.comment__s_Option();
        var str = $as_T((this$3.isEmpty__Z() ? "" : this$3.get__O()));
        var thiz = jsx$2.stripSpaces$extension__T__T(str);
        var this$5 = $as_Lamf_core_model_StrField(dm.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DocumentName$1));
        var this$6 = this$5.option$1;
        var s = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
        return ($uI(thiz.indexOf(s)) !== (-1))
      })
    })(this)));
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var documentMapping = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(x2.value$2);
      var jsx$3 = this.ctx$1;
      var this$10 = $as_Lamf_core_model_StrField(documentMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().EncodedNode$1));
      var this$11 = this$10.option$1;
      var x1$2 = jsx$3.findNodeMapping__T__s_Option($as_T((this$11.isEmpty__Z() ? null : this$11.get__O())));
      if ((x1$2 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$2);
        var nodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x2$2.value$2);
        var path = (dialectInstanceFragment.id$1 + "#");
        var x$2 = (path + "/");
        $m_Lorg_yaml_model_YNode$();
        var map = this.map$1;
        $m_Lorg_yaml_model_YNode$();
        var x$3 = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1);
        var x$5 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
        var x$6 = $m_s_None$();
        var x$8 = $m_s_None$();
        return this.parseNode__T__T__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__sci_Map__Z__s_Option__s_Option__s_Option(path, x$2, x$3, nodeMapping, x$5, false, x$6, x$8)
      } else {
        return $m_s_None$()
      }
    } else {
      var x = $m_s_None$();
      if ((!(x === x1))) {
        throw new $c_s_MatchError().init___O(x1)
      };
      return $m_s_None$()
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceFragmentParser.prototype.parse__T__s_Option = (function(name) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.map$1);
  var this$3 = new $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var location = this.root$1.location$1;
  var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
  var this$4 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$3, field, location));
  var value = this.root$1.location$1;
  var this$5 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value));
  var dialectId = this.ctx$1.dialect$2.id$1;
  var field$1 = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().DefinedBy$1;
  var this$6 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$5, field$1, dialectId));
  var field$2 = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$().Fragment$1;
  var dialectInstanceFragment = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$6, field$2, name));
  new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser().init___Lamf_core_model_document_BaseUnit__Lorg_yaml_model_YMap__sc_Seq__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext(dialectInstanceFragment, this.map$1, this.root$1.references$1, this.ctx$1).parse__T__Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations(this.root$1.location$1);
  var this$7 = this.ctx$1.declarations$2.externals$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$7)) {
    var this$8 = this.ctx$1.declarations$2.externals$2;
    var this$9 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$8);
    var externals = this$9.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream();
    var field$3 = $m_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$().Externals$1;
    $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(dialectInstanceFragment, field$3, externals)
  };
  var x1 = this.parseEncodedFragment__p2__Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment__s_Option(dialectInstanceFragment);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var dialectDomainElement = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x2.value$2);
    var defaultId = this.encodedElementDefaultId__Lamf_core_model_document_EncodesModel__T(dialectInstanceFragment);
    $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(dialectDomainElement, defaultId);
    var this$10 = this.ctx$1;
    var pointer = (this.root$1.location$1 + "#/");
    this$10.globalSpace$1.update__O__O__V(pointer, dialectDomainElement);
    var field$4 = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
    return new $c_s_Some().init___O($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(dialectInstanceFragment, field$4, dialectDomainElement)))
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceFragmentParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext = (function(root, ctx) {
  $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext.call(this, root, ctx);
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceFragmentParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$1
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceFragmentParser = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceFragmentParser: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceFragmentParser", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceFragmentParser: 1,
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser: 1,
  O: 1,
  Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser: 1,
  Lamf_plugins_document_vocabularies_parser_instances_JsonPointerResolver: 1,
  Lamf_plugins_document_vocabularies_parser_instances_NodeMappableHelper: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_parser_BaseSpecParser: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceFragmentParser.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceFragmentParser;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceLibraryParser() {
  $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceLibraryParser.prototype = new $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceLibraryParser.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceLibraryParser;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceLibraryParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceLibraryParser.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceLibraryParser.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceLibraryParser.prototype.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext = (function() {
  return this.ctx$1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceLibraryParser.prototype.parse__s_Option = (function() {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.map$1);
  var this$3 = new $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var location = this.root$1.location$1;
  var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
  var this$4 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$3, field, location));
  var value = this.root$1.location$1;
  var this$5 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value));
  var dialectId = this.ctx$1.dialect$2.id$1;
  var field$1 = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().DefinedBy$1;
  var dialectInstance = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$5, field$1, dialectId));
  this.parseDeclarations__T__V("library");
  var jsx$1 = new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceReferencesParser().init___Lamf_core_model_document_BaseUnit__Lorg_yaml_model_YMap__sc_Seq__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext(dialectInstance, this.map$1, this.root$1.references$1, this.ctx$1);
  var this$6 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(dialectInstance);
  var references = jsx$1.parse__T__Lamf_plugins_document_vocabularies_parser_instances_ReferenceDeclarations($as_T((this$6.isEmpty__Z() ? dialectInstance.id$1 : this$6.get__O())));
  var this$7 = this.ctx$1.declarations$2.externals$2;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$7)) {
    var this$8 = this.ctx$1.declarations$2.externals$2;
    var this$9 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$8);
    var externals = this$9.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream();
    var field$2 = $m_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$().Externals$1;
    $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(dialectInstance, field$2, externals)
  };
  if (this.ctx$1.declarations$2.declarables__sc_Seq().nonEmpty__Z()) {
    var declarations = this.ctx$1.declarations$2.declarables__sc_Seq();
    var field$3 = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
    $as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(dialectInstance, field$3, declarations))
  };
  if (references.baseUnitReferences__sc_Seq().nonEmpty__Z()) {
    var references$1 = references.baseUnitReferences__sc_Seq();
    var field$4 = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
    $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(dialectInstance, field$4, references$1))
  };
  var this$10 = this.ctx$1.futureDeclarations$1;
  $f_Lamf_core_parser_FutureDeclarations__resolve__V(this$10);
  return new $c_s_Some().init___O(dialectInstance)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceLibraryParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext = (function(root, ctx) {
  $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext.call(this, root, ctx);
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceLibraryParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$1
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceLibraryParser = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceLibraryParser: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceLibraryParser", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceLibraryParser: 1,
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser: 1,
  O: 1,
  Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser: 1,
  Lamf_plugins_document_vocabularies_parser_instances_JsonPointerResolver: 1,
  Lamf_plugins_document_vocabularies_parser_instances_NodeMappableHelper: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_parser_BaseSpecParser: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceLibraryParser.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceLibraryParser;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstancePatchParser() {
  $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.call(this)
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstancePatchParser.prototype = new $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstancePatchParser.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstancePatchParser;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstancePatchParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstancePatchParser.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstancePatchParser.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstancePatchParser.prototype.ctx__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext = (function() {
  return this.ctx$1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstancePatchParser.prototype.parse__s_Option = (function() {
  var x1 = this.parseDocument__s_Option();
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var dialectInstance = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstance(x2.value$2);
    var patch = new $c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(dialectInstance.fields$1, dialectInstance.annotations$1);
    var value = dialectInstance.id$1;
    $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(patch, value);
    return new $c_s_Some().init___O(this.checkTarget__p2__Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch__Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch(patch))
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstancePatchParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext = (function(root, ctx) {
  $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext.call(this, root, ctx);
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstancePatchParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstancePatchParser.prototype.checkTarget__p2__Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch__Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch = (function(patch) {
  var rc5 = false;
  var x2 = null;
  var map = this.map$1;
  var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("$target");
  matchEnd6: {
    if ((x1 instanceof $c_s_Some)) {
      rc5 = true;
      x2 = $as_s_Some(x1);
      var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var this$2 = entry.value$2;
      var x = this$2.tag__Lorg_yaml_model_YTag().tagType$3;
      var x$2 = $m_Lorg_yaml_model_YType$().Str$1;
      if ((x === x$2)) {
        var jsx$1 = this.platform$1;
        var this$3 = entry.value$2;
        var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv = this.ctx$1;
        var target = jsx$1.resolvePath__T__T($as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv)));
        var field = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$().Extends$1;
        $as_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(patch, field, target));
        break matchEnd6
      }
    };
    if (rc5) {
      var entry$2 = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var this$4 = this.ctx$1.eh$1;
      var specification = $m_Lamf_validation_DialectValidations$().DialectError$1;
      var node = patch.id$1;
      var ast = entry$2.value$2;
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$4, specification, node, prop, "Patch $target must be a valid URL", l);
      break matchEnd6
    }
  };
  return patch
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstancePatchParser = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstancePatchParser: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstancePatchParser", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstancePatchParser: 1,
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceParser: 1,
  O: 1,
  Lamf_plugins_document_vocabularies_parser_common_AnnotationsParser: 1,
  Lamf_plugins_document_vocabularies_parser_instances_JsonPointerResolver: 1,
  Lamf_plugins_document_vocabularies_parser_instances_NodeMappableHelper: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_parser_BaseSpecParser: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstancePatchParser.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstancePatchParser;
function $f_Lamf_plugins_document_webapi_AsyncPlugin__detectAsyncUnit__pLamf_plugins_document_webapi_AsyncPlugin__Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__s_Option($thiz, root, ctx) {
  var this$1 = $m_Lamf_plugins_document_webapi_parser_AsyncHeader$().apply__Lamf_core_Root__s_Option(root);
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x0$1 = $as_Lamf_plugins_document_webapi_parser_AsyncHeader(arg1);
    var x = $m_Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$();
    if ((x === x0$1)) {
      var this$2 = new $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser().init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(root, ctx);
      $m_Lamf_core_parser_Annotations$();
      var annotations = new $c_Lamf_core_parser_Annotations().init___();
      return new $c_s_Some().init___O(this$2.parseDocument__p2__Lamf_core_model_document_Document__Lamf_core_model_document_Document(new $c_Lamf_core_model_document_Document().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)))
    } else {
      return $m_s_None$()
    }
  }
}
function $f_Lamf_plugins_document_webapi_AsyncPlugin__parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option($thiz, document, parentContext, platform, options) {
  var loc = document.location$1;
  var refs = document.references$1;
  var ds = $m_s_None$();
  var ctx = $thiz.context__T__sc_Seq__Lamf_core_client_ParsingOptions__Lamf_core_parser_ParserContext__s_Option__Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext(loc, refs, options, parentContext, ds);
  var parsed = $f_Lamf_plugins_document_webapi_AsyncPlugin__detectAsyncUnit__pLamf_plugins_document_webapi_AsyncPlugin__Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__s_Option($thiz, document, ctx);
  if (parsed.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = parsed.get__O();
    var unit = $as_Lamf_core_model_document_BaseUnit(arg1);
    return new $c_s_Some().init___O($f_Lamf_plugins_document_webapi_OasLikePlugin__promoteFragments__Lamf_core_model_document_BaseUnit__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_core_model_document_BaseUnit($thiz, unit, ctx))
  }
}
function $f_Lamf_plugins_document_webapi_AsyncPlugin__documentSyntaxes__sc_Seq($thiz) {
  var jsx$1 = $m_sc_Seq$();
  var array = ["application/json", "application/yaml", "application/x-yaml", "text/yaml", "text/vnd.yaml", "text/x-yaml", "application/asyncapi+json", "application/async+json", "application/asyncapi+yaml", "application/async+yaml", "application/asyncapi", "application/async"];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
}
function $f_Lamf_plugins_document_webapi_AsyncPlugin__$$init$__V($thiz) {
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_core_remote_AsyncApi20$().name$1, $m_Lamf_core_remote_AsyncApi$().name$1];
  $thiz.vendors$2 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
}
function $f_Lamf_plugins_document_webapi_OasPlugin__parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option($thiz, document, parentContext, platform, options) {
  var ctx = $thiz.context__T__sc_Seq__Lamf_core_client_ParsingOptions__Lamf_core_parser_ParserContext__s_Option__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(document.location$1, document.references$1, options, parentContext, $m_s_None$());
  var x1 = document.referenceKind$1;
  var x = $m_Lamf_core_parser_LibraryReference$();
  if ((x === x1)) {
    var parsed = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser().init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(document, ctx).parseModule__Lamf_core_model_document_Module())
  } else {
    var x$3 = $m_Lamf_core_parser_LinkReference$();
    if ((x$3 === x1)) {
      var parsed = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser().init___Lamf_core_Root__s_Option__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(document, $m_s_None$(), ctx).parseFragment__Lamf_core_model_document_BaseUnit())
    } else {
      var parsed = $f_Lamf_plugins_document_webapi_OasPlugin__detectOasUnit__pLamf_plugins_document_webapi_OasPlugin__Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext__s_Option($thiz, document, ctx)
    }
  };
  if (parsed.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = parsed.get__O();
    var unit = $as_Lamf_core_model_document_BaseUnit(arg1);
    return new $c_s_Some().init___O($f_Lamf_plugins_document_webapi_OasLikePlugin__promoteFragments__Lamf_core_model_document_BaseUnit__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_core_model_document_BaseUnit($thiz, unit, ctx))
  }
}
function $f_Lamf_plugins_document_webapi_OasPlugin__documentSyntaxes__sc_Seq($thiz) {
  var jsx$1 = $m_sc_Seq$();
  var array = ["application/json", "application/yaml", "application/x-yaml", "text/yaml", "text/vnd.yaml", "text/x-yaml", "application/openapi+json", "application/swagger+json", "application/openapi+yaml", "application/swagger+yaml", "application/openapi", "application/swagger"];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
}
function $f_Lamf_plugins_document_webapi_OasPlugin__$$init$__V($thiz) {
  var jsx$1 = $m_sc_Seq$();
  var array = [$thiz.vendor__Lamf_core_remote_Vendor().name__T(), $m_Lamf_core_remote_Oas$().name$1];
  $thiz.amf$plugins$document$webapi$OasPlugin$$undsetter$und$vendors$und$eq__sc_Seq__V($as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))))
}
function $f_Lamf_plugins_document_webapi_OasPlugin__detectOasUnit__pLamf_plugins_document_webapi_OasPlugin__Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext__s_Option($thiz, root, ctx) {
  var this$1 = $m_Lamf_plugins_document_webapi_parser_OasHeader$().apply__Lamf_core_Root__s_Option(root);
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x0$1 = $as_Lamf_plugins_document_webapi_parser_OasHeader(arg1);
    var x = $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Overlay$();
    if ((x === x0$1)) {
      var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser().init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(root, ctx).parseOverlay__Lamf_plugins_document_webapi_model_Overlay()
    } else {
      var x$3 = $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Extension$();
      if ((x$3 === x0$1)) {
        var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser().init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(root, ctx).parseExtension__Lamf_plugins_document_webapi_model_Extension()
      } else {
        var x$5 = $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$();
        if ((x$5 === x0$1)) {
          var this$2 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser().init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(root, ctx);
          $m_Lamf_core_parser_Annotations$();
          var annotations = new $c_Lamf_core_parser_Annotations().init___();
          var jsx$1 = this$2.parseDocument__p2__Lamf_core_model_document_Document__Lamf_core_model_document_Document(new $c_Lamf_core_model_document_Document().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations))
        } else {
          var x$7 = $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$();
          if ((x$7 === x0$1)) {
            var this$6 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser().init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(root, ctx);
            $m_Lamf_core_parser_Annotations$();
            var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
            var jsx$1 = this$6.parseDocument__p2__Lamf_core_model_document_Document__Lamf_core_model_document_Document(new $c_Lamf_core_model_document_Document().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1))
          } else {
            var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser().init___Lamf_core_Root__s_Option__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(root, new $c_s_Some().init___O(x0$1), ctx).parseFragment__Lamf_core_model_document_BaseUnit()
          }
        }
      }
    };
    return new $c_s_Some().init___O(jsx$1)
  }
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_LocalLinkPath() {
  $c_O.call(this);
  this.rawPath$1 = null;
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_plugins_document_webapi_annotations_LocalLinkPath.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_LocalLinkPath.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_LocalLinkPath;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_LocalLinkPath() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_LocalLinkPath.prototype = $c_Lamf_plugins_document_webapi_annotations_LocalLinkPath.prototype;
$c_Lamf_plugins_document_webapi_annotations_LocalLinkPath.prototype.productPrefix__T = (function() {
  return "LocalLinkPath"
});
$c_Lamf_plugins_document_webapi_annotations_LocalLinkPath.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_annotations_LocalLinkPath.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_LocalLinkPath)) {
    var LocalLinkPath$1 = $as_Lamf_plugins_document_webapi_annotations_LocalLinkPath(x$1);
    return (this.rawPath$1 === LocalLinkPath$1.rawPath$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_annotations_LocalLinkPath.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.rawPath$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_annotations_LocalLinkPath.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_LocalLinkPath.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_annotations_LocalLinkPath.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_plugins_document_webapi_annotations_LocalLinkPath.prototype.init___T = (function(rawPath) {
  this.rawPath$1 = rawPath;
  this.name$1 = "local-link-path";
  this.value$1 = rawPath;
  return this
});
$c_Lamf_plugins_document_webapi_annotations_LocalLinkPath.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_LocalLinkPath.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_annotations_LocalLinkPath(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_LocalLinkPath) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.LocalLinkPath"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_LocalLinkPath(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_LocalLinkPath)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_LocalLinkPath(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_LocalLinkPath(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.LocalLinkPath;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_LocalLinkPath = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_LocalLinkPath: 0
}, false, "amf.plugins.document.webapi.annotations.LocalLinkPath", {
  Lamf_plugins_document_webapi_annotations_LocalLinkPath: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_LocalLinkPath.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_LocalLinkPath;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$.prototype = new $h_Lamf_plugins_document_webapi_parser_RamlHeader();
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$.prototype = $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$.prototype;
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.init___T.call(this, "%RAML 1.0 AnnotationTypeDeclaration");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$: 0
}, false, "amf.plugins.document.webapi.parser.RamlFragmentHeader$Raml10AnnotationTypeDeclaration$", {
  Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$: 1,
  Lamf_plugins_document_webapi_parser_RamlHeader: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_plugins_document_webapi_parser_RamlFragment: 1
});
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$;
var $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$)) {
    $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$ = new $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$.prototype = new $h_Lamf_plugins_document_webapi_parser_RamlHeader();
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$.prototype = $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$.prototype;
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.init___T.call(this, "%RAML 1.0 DataType");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$: 0
}, false, "amf.plugins.document.webapi.parser.RamlFragmentHeader$Raml10DataType$", {
  Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$: 1,
  Lamf_plugins_document_webapi_parser_RamlHeader: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_plugins_document_webapi_parser_RamlFragment: 1
});
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$;
var $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$)) {
    $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$ = new $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$.prototype = new $h_Lamf_plugins_document_webapi_parser_RamlHeader();
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$.prototype = $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$.prototype;
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.init___T.call(this, "%RAML 1.0 DocumentationItem");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$: 0
}, false, "amf.plugins.document.webapi.parser.RamlFragmentHeader$Raml10DocumentationItem$", {
  Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$: 1,
  Lamf_plugins_document_webapi_parser_RamlHeader: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_plugins_document_webapi_parser_RamlFragment: 1
});
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$;
var $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$)) {
    $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$ = new $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$.prototype = new $h_Lamf_plugins_document_webapi_parser_RamlHeader();
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$.prototype = $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$.prototype;
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.init___T.call(this, "%RAML 1.0 NamedExample");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$: 0
}, false, "amf.plugins.document.webapi.parser.RamlFragmentHeader$Raml10NamedExample$", {
  Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$: 1,
  Lamf_plugins_document_webapi_parser_RamlHeader: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_plugins_document_webapi_parser_RamlFragment: 1
});
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$;
var $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$)) {
    $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$ = new $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$.prototype = new $h_Lamf_plugins_document_webapi_parser_RamlHeader();
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$.prototype = $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$.prototype;
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.init___T.call(this, "%RAML 1.0 ResourceType");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$: 0
}, false, "amf.plugins.document.webapi.parser.RamlFragmentHeader$Raml10ResourceType$", {
  Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$: 1,
  Lamf_plugins_document_webapi_parser_RamlHeader: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_plugins_document_webapi_parser_RamlFragment: 1
});
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$;
var $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$)) {
    $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$ = new $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$.prototype = new $h_Lamf_plugins_document_webapi_parser_RamlHeader();
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$.prototype = $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$.prototype;
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.init___T.call(this, "%RAML 1.0 SecurityScheme");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$: 0
}, false, "amf.plugins.document.webapi.parser.RamlFragmentHeader$Raml10SecurityScheme$", {
  Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$: 1,
  Lamf_plugins_document_webapi_parser_RamlHeader: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_plugins_document_webapi_parser_RamlFragment: 1
});
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$;
var $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$)) {
    $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$ = new $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.call(this)
}
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$.prototype = new $h_Lamf_plugins_document_webapi_parser_RamlHeader();
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$.prototype = $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$.prototype;
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_RamlHeader.prototype.init___T.call(this, "%RAML 1.0 Trait");
  return this
});
var $d_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$: 0
}, false, "amf.plugins.document.webapi.parser.RamlFragmentHeader$Raml10Trait$", {
  Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$: 1,
  Lamf_plugins_document_webapi_parser_RamlHeader: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_plugins_document_webapi_parser_RamlFragment: 1
});
$c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$;
var $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$ = (void 0);
function $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$() {
  if ((!$n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$)) {
    $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$ = new $c_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$().init___()
  };
  return $n_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.bindings$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter.prototype.productPrefix__T = (function() {
  return "AsyncApiBindingsDeclarationEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter)) {
    var AsyncApiBindingsDeclarationEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter(x$1);
    if ((this.key$1 === AsyncApiBindingsDeclarationEmitter$1.key$1)) {
      var x = this.bindings$1;
      var x$2 = AsyncApiBindingsDeclarationEmitter$1.bindings$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.ordering$1;
      var x$4 = AsyncApiBindingsDeclarationEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.bindings$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter.prototype.init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(key, bindings, ordering, spec) {
  this.key$1 = key;
  this.bindings$1 = bindings;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var jsx$2 = this.bindings$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(p$2) {
      var p = $as_Lamf_core_model_domain_AmfElement(p$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter().init___Lamf_core_model_domain_AmfElement__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(p, $this.ordering$1, $m_sci_Nil$(), $this.spec$1)
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var namedBindingsEmitters = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  namedBindingsEmitters.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, pb) {
    return (function(e$2) {
      var e = $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter(e$2);
      e.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(pb)
    })
  })(this, b$1)));
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$4 = j;
    var index = i;
    xs.set(jsx$4, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.bindings$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var b = $as_Lamf_core_model_domain_AmfElement(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = b.annotations__Lamf_core_parser_Annotations();
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiBindingsDeclarationEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiBindingsDeclarationEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiBindingsDeclarationEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsDeclarationEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter() {
  $c_O.call(this);
  this.idObj$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter.prototype.productPrefix__T = (function() {
  return "AsyncApiCorrelationIdContentEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var fs = this.idObj$1.fields$1;
  var this$2 = this.idObj$1;
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2).isDefined__Z()) {
    this.emitLink__p1__Lorg_yaml_model_YDocument$PartBuilder__V(b)
  } else {
    var jsx$1 = b.builder$1;
    var sourceName = b.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$().Description$1);
    if ((!this$4.isEmpty__Z())) {
      var arg1 = this$4.get__O();
      var f = $as_Lamf_core_parser_FieldEntry(arg1);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f, $m_s_None$())))
    };
    var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$().Location$1);
    if ((!this$6.isEmpty__Z())) {
      var arg1$1 = this$6.get__O();
      var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("location", f$3, $m_s_None$())))
    };
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
    jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter)) {
    var AsyncApiCorrelationIdContentEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter(x$1);
    var x = this.idObj$1;
    var x$2 = AsyncApiCorrelationIdContentEmitter$1.idObj$1;
    if ((x === x$2)) {
      var x$3 = this.ordering$1;
      var x$4 = AsyncApiCorrelationIdContentEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.idObj$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter.prototype.emitLink__p1__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$1 = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$();
  var this$1 = this.idObj$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1));
  var this$3 = this$2.option$1;
  var label = jsx$1.appendOas3ComponentsPrefix__T__T__T($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())), "correlationIds");
  this.spec$1.ref__Lorg_yaml_model_YDocument$PartBuilder__T__V(b, label)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter.prototype.init___Lamf_plugins_domain_webapi_models_CorrelationId__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(idObj, ordering, spec) {
  this.idObj$1 = idObj;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.idObj$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiCorrelationIdContentEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiCorrelationIdContentEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiCorrelationIdContentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter() {
  $c_O.call(this);
  this.ids$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter.prototype.productPrefix__T = (function() {
  return "AsyncCorrelationIdDeclarationsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter)) {
    var AsyncCorrelationIdDeclarationsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter(x$1);
    var x = this.ids$1;
    var x$2 = AsyncCorrelationIdDeclarationsEmitter$1.ids$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = AsyncCorrelationIdDeclarationsEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.ids$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("correlationIds");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$2 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  this.ids$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, entryBuilder) {
    return (function(idObj$2) {
      var idObj = $as_Lamf_plugins_domain_webapi_models_CorrelationId(idObj$2);
      var emitter = new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiCorrelationIdContentEmitter().init___Lamf_plugins_domain_webapi_models_CorrelationId__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(idObj, $this.ordering$1, $this.spec$1);
      $m_Lorg_yaml_model_YNode$();
      var this$3 = $as_Lamf_core_model_StrField(idObj.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$().Name$1));
      var this$4 = this$3.option$1;
      var str = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
      var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
      var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(entryBuilder.sourceName$2);
      emitter.emit__Lorg_yaml_model_YDocument$PartBuilder__V(v$1);
      var this$8 = v$1.builder$1;
      var array = [key$1];
      if ((this$8.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len = $uI(array.length);
      var newSize = ((this$8.size0$6 + len) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$8, newSize);
      var len$1 = this$8.size0$6;
      var src = this$8.array$6;
      var dest = this$8.array$6;
      $systemArraycopy(src, 0, dest, len, len$1);
      var xs = this$8.array$6;
      var len$2 = xs.u.length;
      var i = 0;
      var j = 0;
      var x = $uI(array.length);
      var x$1 = ((x < len$2) ? x : len$2);
      var that = xs.u.length;
      var end = ((x$1 < that) ? x$1 : that);
      while ((i < end)) {
        var jsx$1 = j;
        var index = i;
        xs.set(jsx$1, array[index]);
        i = ((1 + i) | 0);
        j = ((1 + j) | 0)
      };
      this$8.size0$6 = newSize;
      entryBuilder.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1))
    })
  })(this, b$1)));
  jsx$2.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$21 = v.builder$1;
  var array$1 = [key];
  if ((this$21.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len$3 = $uI(array$1.length);
  var newSize$1 = ((this$21.size0$6 + len$3) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$21, newSize$1);
  var len$4 = this$21.size0$6;
  var src$1 = this$21.array$6;
  var dest$1 = this$21.array$6;
  $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
  var xs$1 = this$21.array$6;
  var len$5 = xs$1.u.length;
  var i$1 = 0;
  var j$1 = 0;
  var x$2 = $uI(array$1.length);
  var x$3 = ((x$2 < len$5) ? x$2 : len$5);
  var that$1 = xs$1.u.length;
  var end$1 = ((x$3 < that$1) ? x$3 : that$1);
  while ((i$1 < end$1)) {
    var jsx$3 = j$1;
    var index$1 = i$1;
    xs$1.set(jsx$3, array$1[index$1]);
    i$1 = ((1 + i$1) | 0);
    j$1 = ((1 + j$1) | 0)
  };
  this$21.size0$6 = newSize$1;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(ids, ordering, spec) {
  this.ids$1 = ids;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.ids$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var p = $as_Lamf_plugins_domain_webapi_models_CorrelationId(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = p.annotations$1;
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncCorrelationIdDeclarationsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.emitters.AsyncCorrelationIdDeclarationsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncCorrelationIdDeclarationsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncCorrelationIdDeclarationsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter() {
  $c_O.call(this);
  this.messages$1 = null;
  this.isTrait$1 = false;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter.prototype.productPrefix__T = (function() {
  return "AsyncMessageDeclarationsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter)) {
    var AsyncMessageDeclarationsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter(x$1);
    var x = this.messages$1;
    var x$2 = AsyncMessageDeclarationsEmitter$1.messages$1;
    if ((((x === null) ? (x$2 === null) : x.equals__O__Z(x$2)) && (this.isTrait$1 === AsyncMessageDeclarationsEmitter$1.isTrait$1))) {
      var x$3 = this.ordering$1;
      var x$4 = AsyncMessageDeclarationsEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.messages$1;
      break
    }
    case 1: {
      return this.isTrait$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter.prototype.init___sc_Seq__Z__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(messages, isTrait, ordering, spec) {
  this.messages$1 = messages;
  this.isTrait$1 = isTrait;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var key = (this.isTrait$1 ? ($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("messageTraits")) : ($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("messages")));
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$2 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  this.messages$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, entryBuilder) {
    return (function(msg$2) {
      var msg = $as_Lamf_plugins_domain_webapi_models_Message(msg$2);
      var emitter = new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter().init___Lamf_plugins_domain_webapi_models_Message__Z__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(msg, $this.isTrait$1, $this.ordering$1, $this.spec$1);
      $m_Lorg_yaml_model_YNode$();
      var this$4 = $as_Lamf_core_model_StrField(msg.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(msg.nameField__Lamf_core_metamodel_Field()));
      var this$5 = this$4.option$1;
      var str = $as_T((this$5.isEmpty__Z() ? null : this$5.get__O()));
      var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
      var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(entryBuilder.sourceName$2);
      emitter.emit__Lorg_yaml_model_YDocument$PartBuilder__V(v$1);
      var this$9 = v$1.builder$1;
      var array = [key$1];
      if ((this$9.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len = $uI(array.length);
      var newSize = ((this$9.size0$6 + len) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$9, newSize);
      var len$1 = this$9.size0$6;
      var src = this$9.array$6;
      var dest = this$9.array$6;
      $systemArraycopy(src, 0, dest, len, len$1);
      var xs = this$9.array$6;
      var len$2 = xs.u.length;
      var i = 0;
      var j = 0;
      var x = $uI(array.length);
      var x$1 = ((x < len$2) ? x : len$2);
      var that = xs.u.length;
      var end = ((x$1 < that) ? x$1 : that);
      while ((i < end)) {
        var jsx$1 = j;
        var index = i;
        xs.set(jsx$1, array[index]);
        i = ((1 + i) | 0);
        j = ((1 + j) | 0)
      };
      this$9.size0$6 = newSize;
      entryBuilder.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1))
    })
  })(this, b$1)));
  jsx$2.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$22 = v.builder$1;
  var array$1 = [key];
  if ((this$22.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len$3 = $uI(array$1.length);
  var newSize$1 = ((this$22.size0$6 + len$3) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$22, newSize$1);
  var len$4 = this$22.size0$6;
  var src$1 = this$22.array$6;
  var dest$1 = this$22.array$6;
  $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
  var xs$1 = this$22.array$6;
  var len$5 = xs$1.u.length;
  var i$1 = 0;
  var j$1 = 0;
  var x$2 = $uI(array$1.length);
  var x$3 = ((x$2 < len$5) ? x$2 : len$5);
  var that$1 = xs$1.u.length;
  var end$1 = ((x$3 < that$1) ? x$3 : that$1);
  while ((i$1 < end$1)) {
    var jsx$3 = j$1;
    var index$1 = i$1;
    xs$1.set(jsx$3, array$1[index$1]);
    i$1 = ((1 + i$1) | 0);
    j$1 = ((1 + j$1) | 0)
  };
  this$22.size0$6 = newSize$1;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.messages$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.isTrait$1 ? 1231 : 1237));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ordering$1));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 3)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.messages$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var p = $as_Lamf_plugins_domain_webapi_models_Message(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = p.annotations__Lamf_core_parser_Annotations();
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncMessageDeclarationsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.emitters.AsyncMessageDeclarationsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncMessageDeclarationsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncMessageDeclarationsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter() {
  $c_O.call(this);
  this.operations$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter.prototype.productPrefix__T = (function() {
  return "AsyncOperationTraitsDeclarationEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter)) {
    var AsyncOperationTraitsDeclarationEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter(x$1);
    var x = this.operations$1;
    var x$2 = AsyncOperationTraitsDeclarationEmitter$1.operations$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = AsyncOperationTraitsDeclarationEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.operations$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("operationTraits");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$2 = this.operations$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(op$2) {
      var op = $as_Lamf_plugins_domain_webapi_models_Operation(op$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiOperationEmitter().init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_emitter_SpecOrdering__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(op, $this.ordering$1, true, $this.spec$1)
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  var entryEmitters = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(entryEmitters), b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$4 = j;
    var index = i;
    xs.set(jsx$4, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(operations, ordering, spec) {
  this.operations$1 = operations;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.operations$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var p = $as_Lamf_plugins_domain_webapi_models_Operation(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = p.annotations$1;
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncOperationTraitsDeclarationEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.emitters.AsyncOperationTraitsDeclarationEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncOperationTraitsDeclarationEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsDeclarationEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter() {
  $c_O.call(this);
  this.operations$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter.prototype.productPrefix__T = (function() {
  return "AsyncOperationTraitsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter)) {
    var AsyncOperationTraitsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter(x$1);
    var x = this.operations$1;
    var x$2 = AsyncOperationTraitsEmitter$1.operations$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = AsyncOperationTraitsEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.operations$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("traits");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$4 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  var jsx$2 = this.operations$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(op$2) {
      var op = $as_Lamf_plugins_domain_webapi_models_Operation(op$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter().init___Lamf_plugins_domain_webapi_models_Operation__Z__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(op, true, $this.ordering$1, $this.spec$1)
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  var partEmitters = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(partEmitters), b$1);
  var jsx$3 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$3.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$4.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$5 = j;
    var index = i;
    xs.set(jsx$5, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(operations, ordering, spec) {
  this.operations$1 = operations;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.operations$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var p = $as_Lamf_plugins_domain_webapi_models_Operation(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = p.annotations$1;
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncOperationTraitsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.emitters.AsyncOperationTraitsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncOperationTraitsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter() {
  $c_O.call(this);
  this.scheme$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter.prototype.productPrefix__T = (function() {
  return "AsyncSingleSchemeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(scheme, ordering, spec) {
  this.scheme$1 = scheme;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter)) {
    var AsyncSingleSchemeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter(x$1);
    var x = this.scheme$1;
    var x$2 = AsyncSingleSchemeEmitter$1.scheme$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = AsyncSingleSchemeEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.scheme$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var this$1 = this.scheme$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Name$1));
  var this$3 = this$2.option$1;
  var str = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var fs = this.scheme$1.fields$1;
  var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1);
  if ((!this$6.isEmpty__Z())) {
    var arg1 = this$6.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    var this$7 = this.scheme$1;
    var this$8 = $as_Lamf_core_model_StrField(this$7.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Name$1));
    var this$9 = this$8.option$1;
    var x$2 = $as_T((this$9.isEmpty__Z() ? null : this$9.get__O()));
    var this$10 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = f.value$1.annotations$1;
    var x$3 = this$10.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", x$2, x$4, x$3))
  };
  var this$12 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Description$1);
  if ((!this$12.isEmpty__Z())) {
    var arg1$1 = this$12.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f$3, $m_s_None$()))
  };
  var this$14 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1);
  if ((!this$14.isEmpty__Z())) {
    var arg1$2 = this$14.get__O();
    $as_Lamf_core_parser_FieldEntry(arg1$2);
    var this$15 = this.scheme$1;
    result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSecuritySettingsEmitter().init___Lamf_plugins_domain_webapi_models_security_Settings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext($as_Lamf_plugins_domain_webapi_models_security_Settings(this$15.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1)), this.ordering$1, this.spec$1).emitters__sc_Seq())
  };
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$18 = v.builder$1;
  var array = [key];
  if ((this$18.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$18.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$18, newSize);
  var len$1 = this$18.size0$6;
  var src = this$18.array$6;
  var dest = this$18.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$18.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$18.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.scheme$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncSingleSchemeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.emitters.AsyncSingleSchemeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncSingleSchemeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncSingleSchemeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter() {
  $c_O.call(this);
  this.messages$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter.prototype.productPrefix__T = (function() {
  return "AsyncTraitMessagesEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter)) {
    var AsyncTraitMessagesEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter(x$1);
    var x = this.messages$1;
    var x$2 = AsyncTraitMessagesEmitter$1.messages$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = AsyncTraitMessagesEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.messages$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("traits");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$2 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  this.messages$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, partBuilder) {
    return (function(msg$2) {
      var msg = $as_Lamf_plugins_domain_webapi_models_Message(msg$2);
      var emitter = new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageContentEmitter().init___Lamf_plugins_domain_webapi_models_Message__Z__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(msg, true, $this.ordering$1, $this.spec$1);
      emitter.emit__Lorg_yaml_model_YDocument$PartBuilder__V(partBuilder)
    })
  })(this, b$1)));
  var jsx$1 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$2.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$3 = j;
    var index = i;
    xs.set(jsx$3, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(messages, ordering, spec) {
  this.messages$1 = messages;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.messages$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var p = $as_Lamf_plugins_domain_webapi_models_Message(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = p.annotations__Lamf_core_parser_Annotations();
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncTraitMessagesEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.emitters.AsyncTraitMessagesEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncTraitMessagesEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncTraitMessagesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator() {
  $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator.call(this);
  this.parentId$2 = null;
  this.ctx$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator.prototype.productPrefix__T = (function() {
  return "AsyncConcreteMessagePopulator"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator.prototype.init___T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(parentId, ctx) {
  this.parentId$2 = parentId;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator.prototype.init___Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext.call(this, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator)) {
    var AsyncConcreteMessagePopulator$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator(x$1);
    return (this.parentId$2 === AsyncConcreteMessagePopulator$1.parentId$2)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.parentId$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator.prototype.parseTraits__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Message__V = (function(map, message) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("traits");
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$3 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
    var iv = this.ctx$2;
    var jsx$3 = $as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv)).nodes$3;
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(node$2) {
        var node = $as_Lorg_yaml_model_YNode(node$2);
        var jsx$2 = $m_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser$();
        var errorHandler = $this.ctx$2;
        return jsx$2.apply__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__s_Option__Z__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageParser(new $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, errorHandler), $this.parentId$2, $m_s_None$(), true, $this.ctx$2).parse__Lamf_plugins_domain_webapi_models_Message()
      })
    })(this));
    var this$5 = $m_sc_IndexedSeq$();
    var traits = $as_sc_IndexedSeq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBF$6));
    var field = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Extends__Lamf_core_metamodel_Field();
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(message, field, traits, annotations)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator.prototype.parseSchema__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Payload__V = (function(map, payload) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("payload");
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var schemaVersion = $m_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$().getSchemaVersion__Lamf_plugins_domain_webapi_models_Payload__Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion(payload, this.ctx$2.eh$1);
    var this$4 = $m_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncApiTypeParser(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, payload$1) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        $m_Lamf_core_parser_Annotations$();
        var a = new $c_Lamf_core_parser_Annotations().init___();
        var qual$1 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, "schema", a));
        var x$1 = payload$1.id$1;
        var x$2 = qual$1.adopted$default$2__sc_Seq();
        qual$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$1, x$2)
      })
    })(this, payload)), schemaVersion, this.ctx$2).parse__s_Option();
    if ((!this$4.isEmpty__Z())) {
      var arg1$1 = this$4.get__O();
      var s = $as_Lamf_core_model_domain_Shape(arg1$1);
      var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
      var value = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(s, payload.id$1, $m_s_None$());
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
      $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(payload, field, value, annotations))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncConcreteMessagePopulator"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.parser.AsyncConcreteMessagePopulator;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncConcreteMessagePopulator", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator: 1,
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncConcreteMessagePopulator;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator() {
  $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator.call(this);
  this.ctx$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator.prototype.productPrefix__T = (function() {
  return "AsyncMessageTraitPopulator"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator) && ($as_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator(x$1), true))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator.prototype.populate__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Message__Lamf_plugins_domain_webapi_models_Message = (function(map, message) {
  var nextMessage = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator.prototype.populate__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Message__Lamf_plugins_domain_webapi_models_Message.call(this, map, message);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().IsAbstract$1;
  $as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(nextMessage, field, true));
  this.ctx$2.closedShape__T__Lorg_yaml_model_YMap__T__V(nextMessage.id$1, map, "messageTrait");
  return nextMessage
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator.prototype.parseTraits__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Message__V = (function(map, message) {
  /*<skip>*/
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator.prototype.parseSchema__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Payload__V = (function(map, payload) {
  /*<skip>*/
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator.prototype.init___Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(ctx) {
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator.prototype.init___Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext.call(this, ctx);
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncMessageTraitPopulator"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.parser.AsyncMessageTraitPopulator;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncMessageTraitPopulator", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator: 1,
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessagePopulator: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncMessageTraitPopulator;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser.call(this);
  this.parent$2 = null;
  this.map$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser.prototype.productPrefix__T = (function() {
  return "AsyncServerParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function() {
  return $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(this.ctx$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser.prototype.parse__Lamf_plugins_domain_webapi_models_Server = (function() {
  var server = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser.prototype.parse__Lamf_plugins_domain_webapi_models_Server.call(this);
  var map = this.map$2;
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Protocol$1;
  var iv = $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(this.ctx$1);
  jsx$1.key__T__F1__V("protocol", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(server));
  var map$1 = this.map$2;
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().ProtocolVersion$1;
  var iv$1 = $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(this.ctx$1);
  jsx$2.key__T__F1__V("protocolVersion", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(server));
  var map$2 = this.map$2;
  var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2).key__T__s_Option("bindings");
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var node = entry.value$2;
    var errorHandler = $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(this.ctx$1);
    var bindings = $as_Lamf_plugins_domain_webapi_models_bindings_ServerBindings(new $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser().init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(new $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, errorHandler), server.id$1, $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(this.ctx$1)).parse__Lamf_core_model_domain_NamedDomainElement());
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Bindings$1;
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(server, field$2, bindings, annotations);
    new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(server, this.map$2, $m_sci_Nil$(), $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(this.ctx$1)).parseOrphanNode__T__V("bindings")
  };
  var map$3 = this.map$2;
  var this$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3);
  var this$9 = this$8.key__T__s_Option("security");
  if ((!this$9.isEmpty__Z())) {
    var arg1$1 = this$9.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var idCounter = new $c_Lamf_core_utils_package$IdCounter().init___();
    var this$10 = entry$3.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var iv$2 = $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(this.ctx$1);
    var jsx$6 = $as_sc_TraversableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$10, conversion, iv$2));
    var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, server$1, idCounter$1) {
      return (function(s$2) {
        var s = $as_Lorg_yaml_model_YNode(s$2);
        return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeSecurityRequirementParser().init___Lorg_yaml_model_YNode__F1__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(s, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, server$1$1) {
          return (function(name$2) {
            var name = $as_T(name$2);
            return server$1$1.withSecurity__T__Lamf_plugins_domain_webapi_models_security_SecurityRequirement(name)
          })
        })($this, server$1)), idCounter$1, $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext($this.ctx$1)).parse__s_Option()
      })
    })(this, server, idCounter));
    var this$11 = $m_sc_Seq$();
    var jsx$4 = $as_sc_TraversableLike(jsx$6.map__F1__scg_CanBuildFrom__O(jsx$5, this$11.ReusableCBFInstance$2));
    var jsx$3 = new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser(this);
    var this$12 = $m_sc_Seq$();
    var securedBy = $as_sc_Seq(jsx$4.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$3, this$12.ReusableCBFInstance$2));
    var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Security$1;
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(securedBy, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3.value$2));
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(server, field$3, value, annotations$1)
  };
  return server
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser)) {
    var AsyncServerParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser(x$1);
    if ((this.parent$2 === AsyncServerParser$1.parent$2)) {
      var this$1 = this.map$2;
      var b = AsyncServerParser$1.map$2;
      return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser.prototype.init___T__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(parent, map, ctx) {
  this.parent$2 = parent;
  this.map$2 = map;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser.prototype.init___T__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.call(this, parent, map, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.parent$2;
      break
    }
    case 1: {
      return this.map$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncServerParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.parser.AsyncServerParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncServerParser", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser.call(this);
  this.entry$2 = null;
  this.parent$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser();
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser.prototype.productPrefix__T = (function() {
  return "AsyncServerVariableParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function() {
  return $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(this.ctx$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser)) {
    var AsyncServerVariableParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser(x$1);
    var x = this.entry$2;
    var x$2 = AsyncServerVariableParser$1.entry$2;
    if ((x === x$2)) {
      return (this.parent$2 === AsyncServerVariableParser$1.parent$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$2;
      break
    }
    case 1: {
      return this.parent$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser.prototype.init___Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(entry, parent, ctx) {
  this.entry$2 = entry;
  this.parent$2 = parent;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser.prototype.init___Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.call(this, entry, parent, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser.prototype.parseMap__Lamf_plugins_domain_webapi_models_Parameter__Lorg_yaml_model_YMap__V = (function(variable, map) {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser.prototype.parseMap__Lamf_plugins_domain_webapi_models_Parameter__Lorg_yaml_model_YMap__V.call(this, variable, map);
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("examples");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var examplesEntry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = examplesEntry.value$2;
    var x1 = this$4.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Seq$1;
    if ((x === x1)) {
      var idCounter = new $c_Lamf_core_utils_package$IdCounter().init___();
      var this$5 = examplesEntry.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
      var iv = $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(this.ctx$1);
      var jsx$2 = $as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv)).nodes$3;
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, idCounter$1) {
        return (function(node$2) {
          var node = $as_Lorg_yaml_model_YNode(node$2);
          var qual$1 = $m_Lamf_plugins_domain_shapes_models_Example$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_Example(node);
          var x$1 = idCounter$1.genId__T__T("example");
          $m_Lamf_core_parser_Annotations$();
          var x$2 = new $c_Lamf_core_parser_Annotations().init___();
          var this$8 = $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, x$1, x$2));
          $m_Lorg_yaml_model_YNode$();
          var iv$1 = $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext($this.ctx$1);
          var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
          var value = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$1, iv$1));
          var field = $m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1;
          return $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$8, field, value))
        })
      })(this, idCounter));
      var this$9 = $m_sc_IndexedSeq$();
      var examples = $as_sc_IndexedSeq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$9.ReusableCBF$6));
      var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1;
      $as_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(variable, field$1, examples))
    } else {
      var this$10 = $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(this.ctx$1);
      var violationId = $m_Lamf_validations_ParserSideValidations$().ExamplesMustBeASeq$1;
      var node$1 = variable.id$1;
      var this$11 = this$10.eh$1;
      var location = this$10.rootContextDocument$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__T__V(this$11, violationId, node$1, "Examples facet must be an array of strings", location)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncServerVariableParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.parser.AsyncServerVariableParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.parser.AsyncServerVariableParser", {
  Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper() {
  $c_O.call(this);
  this.emitters$1 = null;
  this.ordering$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper.prototype.productPrefix__T = (function() {
  return "DeclarationsEmitterWrapper"
});
$c_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper)) {
    var DeclarationsEmitterWrapper$1 = $as_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper(x$1);
    var x = this.emitters$1;
    var x$2 = DeclarationsEmitterWrapper$1.emitters$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = DeclarationsEmitterWrapper$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.emitters$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  if (this.emitters$1.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("components");
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$1 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(this.emitters$1), b$1);
    jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
    var this$5 = v.builder$1;
    var array = [key];
    if ((this$5.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$5.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$5, newSize);
    var len$1 = this$5.size0$6;
    var src = this$5.array$6;
    var dest = this$5.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$5.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$2 = j;
      var index = i;
      xs.set(jsx$2, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$5.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering = (function(emitters, ordering) {
  this.emitters$1 = emitters;
  this.ordering$1 = ordering;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.emitters$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$2 = $as_Lamf_core_emitter_EntryEmitter(arg1);
    var this$2 = new $c_s_Some().init___O(x$2.position__Lamf_core_parser_Position())
  };
  return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.common.DeclarationsEmitterWrapper"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.common.DeclarationsEmitterWrapper;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.DeclarationsEmitterWrapper", {
  Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry() {
  $c_O.call(this);
  this.version$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry.prototype.productPrefix__T = (function() {
  return "JsonSchemaEntry"
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion = (function(version) {
  this.version$1 = version;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry)) {
    var JsonSchemaEntry$1 = $as_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry(x$1);
    var x = this.version$1;
    var x$2 = JsonSchemaEntry$1.version$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.version$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var x = this.version$1;
  var x$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$();
  if (((x !== null) && x.equals__O__Z(x$2))) {
    var draftVersionNumber = 7
  } else {
    var draftVersionNumber = 4
  };
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("$schema");
  $m_Lorg_yaml_model_YNode$();
  var str = (("http://json-schema.org/draft-0" + draftVersionNumber) + "/schema#");
  var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry.prototype.position__Lamf_core_parser_Position = (function() {
  return $m_Lamf_core_parser_Position$ZERO$()
});
function $as_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.common.JsonSchemaEntry"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.common.JsonSchemaEntry;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.JsonSchemaEntry", {
  Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaEntry;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode() {
  $c_O.call(this);
  this.obj$1 = null;
  this.scalar$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode.prototype.productPrefix__T = (function() {
  return "RamlScalarValuedNode"
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode)) {
    var RamlScalarValuedNode$1 = $as_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode(x$1);
    var this$1 = this.obj$1;
    var b = RamlScalarValuedNode$1.obj$1;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.scalar$1;
      var x$2 = RamlScalarValuedNode$1.scalar$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.obj$1;
      break
    }
    case 1: {
      return this.scalar$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode.prototype.negated__Lamf_core_model_domain_AmfElement = (function() {
  return this.negated__Lamf_core_model_domain_AmfScalar()
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode.prototype.$double__Lamf_core_model_domain_AmfScalar = (function() {
  var arg1 = this.scalar$1;
  return arg1.$double__Lamf_core_model_domain_AmfScalar()
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode.prototype.string__Lamf_core_model_domain_AmfScalar = (function() {
  var arg1 = this.scalar$1;
  return arg1.string__Lamf_core_model_domain_AmfScalar()
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode.prototype.negated__Lamf_core_model_domain_AmfScalar = (function() {
  var arg1 = this.scalar$1;
  return arg1.negated__Lamf_core_model_domain_AmfScalar()
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode.prototype.init___Lorg_yaml_model_YMap__Lamf_core_parser_ScalarNode__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(obj, scalar, iv) {
  this.obj$1 = obj;
  this.scalar$1 = scalar;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode.prototype.text__Lamf_core_model_domain_AmfScalar = (function() {
  var arg1 = this.scalar$1;
  return arg1.text__Lamf_core_model_domain_AmfScalar()
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode.prototype.$boolean__Lamf_core_model_domain_AmfScalar = (function() {
  var arg1 = this.scalar$1;
  return arg1.$boolean__Lamf_core_model_domain_AmfScalar()
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode.prototype.integer__Lamf_core_model_domain_AmfScalar = (function() {
  var arg1 = this.scalar$1;
  return arg1.integer__Lamf_core_model_domain_AmfScalar()
});
function $as_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.common.RamlScalarValuedNode"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.common.RamlScalarValuedNode;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.RamlScalarValuedNode", {
  Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode: 1,
  O: 1,
  Lamf_core_parser_ScalarNode: 1,
  Lamf_core_parser_TypedNode: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarValuedNode;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode() {
  $c_O.call(this);
  this.node$1 = null;
  this.iv$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode.prototype.productPrefix__T = (function() {
  return "RamlSingleArrayNode"
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode)) {
    var RamlSingleArrayNode$1 = $as_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode(x$1);
    var this$1 = this.node$1;
    var b = RamlSingleArrayNode$1.node$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.node$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode.prototype.negated__Lamf_core_model_domain_AmfElement = (function() {
  return this.negated__Lamf_core_model_domain_AmfArray()
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode.prototype.text__Lamf_core_model_domain_AmfArray = (function() {
  var node = this.node$1;
  var iv = this.iv$1;
  var this$2 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
  return this.as__p1__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfArray(this$2.text__Lamf_core_model_domain_AmfScalar())
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode.prototype.$boolean__Lamf_core_model_domain_AmfArray = (function() {
  var node = this.node$1;
  var iv = this.iv$1;
  var this$2 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
  return this.as__p1__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfArray(this$2.$boolean__Lamf_core_model_domain_AmfScalar())
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode.prototype.init___Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(node, iv) {
  this.node$1 = node;
  this.iv$1 = iv;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode.prototype.integer__Lamf_core_model_domain_AmfArray = (function() {
  var node = this.node$1;
  var iv = this.iv$1;
  var this$2 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
  return this.as__p1__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfArray(this$2.integer__Lamf_core_model_domain_AmfScalar())
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode.prototype.negated__Lamf_core_model_domain_AmfArray = (function() {
  var node = this.node$1;
  var iv = this.iv$1;
  var this$2 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
  return this.as__p1__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfArray(this$2.negated__Lamf_core_model_domain_AmfScalar())
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode.prototype.obj__F1__Lamf_core_model_domain_AmfArray = (function(fn) {
  return this.as__p1__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfArray($as_Lamf_core_model_domain_AmfElement(fn.apply__O__O(this.node$1)))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode.prototype.as__p1__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfArray = (function(element) {
  var jsx$1 = $m_sc_Seq$();
  var array = [element];
  return new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))), $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(this.node$1).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SingleValueArray().init___()))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.common.RamlSingleArrayNode"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.common.RamlSingleArrayNode;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.RamlSingleArrayNode", {
  Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode: 1,
  O: 1,
  Lamf_core_parser_ArrayNode: 1,
  Lamf_core_parser_TypedNode: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_RamlSingleArrayNode;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter() {
  $c_O.call(this);
  this.declaration$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter.prototype.productPrefix__T = (function() {
  return "AbstractDeclarationEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter)) {
    var AbstractDeclarationEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter(x$1);
    var x = this.declaration$1;
    var x$2 = AbstractDeclarationEmitter$1.declaration$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = AbstractDeclarationEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = AbstractDeclarationEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.declaration$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter.prototype.init___Lamf_core_model_domain_templates_AbstractDeclaration__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(declaration, ordering, references, spec) {
  this.declaration$1 = declaration;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.declaration$1;
  var x1 = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().Name$1)).option$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var n = $as_T(x2.value$2);
    var name = n
  } else {
    var this$4 = this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler();
    var specification = $m_Lamf_validations_RenderSideValidations$().RenderValidation$1;
    var node = this.declaration$1.id$1;
    var property = $m_s_None$();
    var message = ("Cannot declare abstract declaration without name " + this.declaration$1);
    var this$2 = this.declaration$1;
    var lexical = this$2.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var this$3 = this.declaration$1;
    var location = $f_Lamf_core_model_domain_AmfElement__location__s_Option(this$3);
    this$4.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
    var name = "default-name"
  };
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(name);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var this$6 = this.declaration$1;
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$6).isDefined__Z()) {
    var this$7 = this.declaration$1;
    var this$8 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$7);
    if ((!this$8.isEmpty__Z())) {
      var arg1 = this$8.get__O();
      var l = $as_Lamf_core_model_domain_DomainElement(arg1);
      var jsx$1 = this.spec$1.factory__Lamf_plugins_document_webapi_contexts_SpecEmitterFactory().tagToReferenceEmitter__F3();
      var this$9 = this.declaration$1;
      $as_Lamf_core_emitter_PartEmitter(jsx$1.apply__O__O__O__O(l, $as_Lamf_core_model_StrField(this$9.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1, this.references$1)).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v)
    }
  } else {
    var this$10 = $m_s_Option$().apply__O__s_Option(this.declaration$1.dataNode__Lamf_core_model_domain_DataNode());
    if (this$10.isEmpty__Z()) {
      var this$12 = $m_s_None$()
    } else {
      var arg1$1 = this$10.get__O();
      var x$2 = $as_Lamf_core_model_domain_DataNode(arg1$1);
      var this$12 = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler(x$2, this.ordering$1, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler()).emitters__sc_Seq())
    };
    var elem = $as_sc_Seq((this$12.isEmpty__Z() ? $m_sci_Nil$() : this$12.get__O()));
    var elem$1 = null;
    elem$1 = elem;
    var this$14 = this.declaration$1.description__Lamf_core_model_StrField().option$1;
    if ((!this$14.isEmpty__Z())) {
      var arg1$2 = this$14.get__O();
      var description = $as_T(arg1$2);
      var jsx$5 = $as_sc_Seq(elem$1);
      var jsx$4 = $m_sc_Seq$();
      var jsx$3 = $m_Lorg_yaml_model_YType$().Str$1;
      var this$15 = $m_Lamf_core_emitter_BaseEmitters_package$();
      var annotations = this.declaration$1.description__Lamf_core_model_StrField().annotations$1;
      var array = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("usage", description, jsx$3, this$15.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))];
      var jsx$2 = jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
      var this$18 = $m_sc_Seq$();
      elem$1 = $as_sc_Seq(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$18.ReusableCBFInstance$2))
    };
    var jsx$6 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    this.ordering$1.sorted__sc_Seq__sc_Seq($as_sc_Seq(elem$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$2) {
      return (function(x$3$2) {
        var x$3 = $as_Lamf_core_emitter_EntryEmitter(x$3$2);
        x$3.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$2)
      })
    })(this, b$1)));
    jsx$6.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  };
  var this$22 = v.builder$1;
  var array$1 = [key];
  if ((this$22.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array$1.length);
  var newSize = ((this$22.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$22, newSize);
  var len$1 = this$22.size0$6;
  var src = this$22.array$6;
  var dest = this$22.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$22.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array$1.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$7 = j;
    var index = i;
    xs.set(jsx$7, array$1[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$22.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.declaration$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.AbstractDeclarationEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.AbstractDeclarationEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.AbstractDeclarationEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.declarations$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter.prototype.productPrefix__T = (function() {
  return "AbstractDeclarationsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter)) {
    var AbstractDeclarationsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter(x$1);
    if ((this.key$1 === AbstractDeclarationsEmitter$1.key$1)) {
      var x = this.declarations$1;
      var x$2 = AbstractDeclarationsEmitter$1.declarations$1;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$3 = this.ordering$1;
      var x$4 = AbstractDeclarationsEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = AbstractDeclarationsEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.declarations$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$5 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var jsx$3 = this.ordering$1;
  var jsx$2 = this.declarations$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(d$2) {
      var d = $as_Lamf_core_model_domain_templates_AbstractDeclaration(d$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationEmitter().init___Lamf_core_model_domain_templates_AbstractDeclaration__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(d, $this.ordering$1, $this.references$1, $this.spec$1)
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  jsx$4.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$3.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))), b$1);
  jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$6 = j;
    var index = i;
    xs.set(jsx$6, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter.prototype.init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, declarations, ordering, references, spec) {
  this.key$1 = key;
  this.declarations$1 = declarations;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.declarations$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var a = $as_Lamf_core_model_domain_templates_AbstractDeclaration(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = a.annotations__Lamf_core_parser_Annotations();
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.AbstractDeclarationsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.AbstractDeclarationsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.AbstractDeclarationsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter() {
  $c_O.call(this);
  this.dataNode$1 = null;
  this.ordering$1 = null;
  this.resolvedLinks$1 = false;
  this.referencesCollector$1 = null;
  this.amf$plugins$document$webapi$parser$spec$declaration$DataNodeEmitter$$eh$f = null;
  this.xsdString$1 = null;
  this.xsdInteger$1 = null;
  this.xsdFloat$1 = null;
  this.amlNumber$1 = null;
  this.xsdDouble$1 = null;
  this.xsdBoolean$1 = null;
  this.xsdNil$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype.productPrefix__T = (function() {
  return "DataNodeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype.emitArray__Lamf_core_model_domain_ArrayNode__Lorg_yaml_model_YDocument$PartBuilder__V = (function(arrayNode, b) {
  var jsx$2 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  this.ordering$1.sorted__sc_Seq__sc_Seq(this.arrayEmitters__Lamf_core_model_domain_ArrayNode__sc_Seq(arrayNode)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$2) {
    return (function(x$9$2) {
      var x$9 = $as_Lamf_core_emitter_PartEmitter(x$9$2);
      x$9.emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$2)
    })
  })(this, b$1)));
  var jsx$1 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$2.$$plus$eq__O__scm_ArrayBuffer(node)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var x1 = this.dataNode$1;
  if ((x1 instanceof $c_Lamf_core_model_domain_ScalarNode)) {
    var x2 = $as_Lamf_core_model_domain_ScalarNode(x1);
    this.emitScalar__Lamf_core_model_domain_ScalarNode__Lorg_yaml_model_YDocument$PartBuilder__V(x2, b)
  } else if ((x1 instanceof $c_Lamf_core_model_domain_ArrayNode)) {
    var x3 = $as_Lamf_core_model_domain_ArrayNode(x1);
    this.emitArray__Lamf_core_model_domain_ArrayNode__Lorg_yaml_model_YDocument$PartBuilder__V(x3, b)
  } else if ((x1 instanceof $c_Lamf_core_model_domain_ObjectNode)) {
    var x4 = $as_Lamf_core_model_domain_ObjectNode(x1);
    this.emitObject__Lamf_core_model_domain_ObjectNode__Lorg_yaml_model_YDocument$PartBuilder__V(x4, b)
  } else if ((x1 instanceof $c_Lamf_core_model_domain_LinkNode)) {
    var x5 = $as_Lamf_core_model_domain_LinkNode(x1);
    this.emitLink__Lamf_core_model_domain_LinkNode__Lorg_yaml_model_YDocument$PartBuilder__V(x5, b)
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype.scalarEmitter__Lamf_core_model_domain_ScalarNode__Lamf_core_emitter_PartEmitter = (function(scalar) {
  var rc8 = false;
  var x2 = null;
  var x1 = $as_Lamf_core_model_StrField(scalar.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().DataType$1)).option$1;
  if ((x1 instanceof $c_s_Some)) {
    rc8 = true;
    x2 = $as_s_Some(x1);
    var t = $as_T(x2.value$2);
    if ((t === this.xsdString$1)) {
      var this$1 = $as_Lamf_core_model_StrField(scalar.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1));
      var this$2 = this$1.option$1;
      return new $c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter().init___T__Lamf_core_parser_Annotations__Lorg_yaml_model_YType($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())), scalar.annotations$2, $m_Lorg_yaml_model_YType$().Str$1)
    }
  };
  if (rc8) {
    var t$2 = $as_T(x2.value$2);
    if ((t$2 === this.xsdInteger$1)) {
      var this$4 = $as_Lamf_core_model_StrField(scalar.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1));
      var this$5 = this$4.option$1;
      return new $c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter().init___T__Lamf_core_parser_Annotations__Lorg_yaml_model_YType($as_T((this$5.isEmpty__Z() ? null : this$5.get__O())), scalar.annotations$2, $m_Lorg_yaml_model_YType$().Int$1)
    }
  };
  if (rc8) {
    var t$3 = $as_T(x2.value$2);
    if ((!(!((t$3 === this.xsdDouble$1) | (t$3 === this.amlNumber$1))))) {
      var this$6 = $as_Lamf_core_model_StrField(scalar.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1));
      var this$7 = this$6.option$1;
      return new $c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter().init___T__Lamf_core_parser_Annotations__Lorg_yaml_model_YType($as_T((this$7.isEmpty__Z() ? null : this$7.get__O())), scalar.annotations$2, $m_Lorg_yaml_model_YType$().Float$1)
    }
  };
  if (rc8) {
    var t$4 = $as_T(x2.value$2);
    if ((t$4 === this.xsdBoolean$1)) {
      var this$8 = $as_Lamf_core_model_StrField(scalar.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1));
      var this$9 = this$8.option$1;
      return new $c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter().init___T__Lamf_core_parser_Annotations__Lorg_yaml_model_YType($as_T((this$9.isEmpty__Z() ? null : this$9.get__O())), scalar.annotations$2, $m_Lorg_yaml_model_YType$().Bool$1)
    }
  };
  if (rc8) {
    var t$5 = $as_T(x2.value$2);
    if ((t$5 === this.xsdNil$1)) {
      return new $c_Lamf_core_emitter_BaseEmitters_package$NullEmitter().init___Lamf_core_parser_Annotations(scalar.annotations$2)
    }
  };
  var this$10 = $as_Lamf_core_model_StrField(scalar.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1));
  var this$11 = this$10.option$1;
  return new $c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter().init___T__Lamf_core_parser_Annotations__Lorg_yaml_model_YType($as_T((this$11.isEmpty__Z() ? null : this$11.get__O())), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()), $m_Lorg_yaml_model_YType$().Str$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter)) {
    var DataNodeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter(x$1);
    var x = this.dataNode$1;
    var x$2 = DataNodeEmitter$1.dataNode$1;
    if ((x === x$2)) {
      var x$3 = this.ordering$1;
      var x$4 = DataNodeEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if ((jsx$1 && (this.resolvedLinks$1 === DataNodeEmitter$1.resolvedLinks$1))) {
      var x$5 = this.referencesCollector$1;
      var x$6 = DataNodeEmitter$1.referencesCollector$1;
      return ((x$5 === null) ? (x$6 === null) : $f_sc_GenMapLike__equals__O__Z(x$5, x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype.linkEmitters__Lamf_core_model_domain_LinkNode__sc_Seq = (function(link) {
  var this$1 = link.linkedDomainElement$2;
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var elem = $as_Lamf_core_model_domain_DomainElement(arg1);
    var jsx$1 = this.referencesCollector$1;
    var this$2 = $as_Lamf_core_model_StrField(link.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkNodeModel$().Alias$1));
    var this$3 = this$2.option$1;
    jsx$1.update__O__O__V($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())), elem)
  };
  if (this.resolvedLinks$1) {
    var jsx$2 = $m_sc_Seq$();
    var this$4 = $as_Lamf_core_model_StrField(link.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkNodeModel$().Alias$1));
    var this$5 = this$4.option$1;
    var array = [new $c_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter().init___T__Lamf_core_parser_Annotations($as_T((this$5.isEmpty__Z() ? null : this$5.get__O())), link.annotations$2)];
    return $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  } else {
    var jsx$3 = $m_sc_Seq$();
    var this$8 = $as_Lamf_core_model_StrField(link.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkNodeModel$().Alias$1));
    var this$9 = this$8.option$1;
    var array$1 = [new $c_Lamf_core_emitter_BaseEmitters_package$LinkScalaEmitter().init___T__Lamf_core_parser_Annotations($as_T((this$9.isEmpty__Z() ? null : this$9.get__O())), link.annotations$2)];
    return $as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.dataNode$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.resolvedLinks$1;
      break
    }
    case 3: {
      return this.referencesCollector$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype.emitters__sc_Seq = (function() {
  var x1 = this.dataNode$1;
  if ((x1 instanceof $c_Lamf_core_model_domain_ScalarNode)) {
    var x2 = $as_Lamf_core_model_domain_ScalarNode(x1);
    var jsx$3 = $m_sc_Seq$();
    var array = [this.scalarEmitter__Lamf_core_model_domain_ScalarNode__Lamf_core_emitter_PartEmitter(x2)];
    var jsx$2 = $as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  } else if ((x1 instanceof $c_Lamf_core_model_domain_ArrayNode)) {
    var x3 = $as_Lamf_core_model_domain_ArrayNode(x1);
    var jsx$2 = this.arrayEmitters__Lamf_core_model_domain_ArrayNode__sc_Seq(x3)
  } else if ((x1 instanceof $c_Lamf_core_model_domain_ObjectNode)) {
    var x4 = $as_Lamf_core_model_domain_ObjectNode(x1);
    var jsx$2 = this.objectEmitters__Lamf_core_model_domain_ObjectNode__sc_Seq(x4)
  } else {
    if ((!(x1 instanceof $c_Lamf_core_model_domain_LinkNode))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var x5 = $as_Lamf_core_model_domain_LinkNode(x1);
    var jsx$2 = this.linkEmitters__Lamf_core_model_domain_LinkNode__sc_Seq(x5)
  };
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter(this);
  var this$3 = $m_sc_Seq$();
  var e = $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
  return $as_sc_Seq(e.flatten__F1__sc_GenTraversable(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(xo$2) {
      var xo = $as_s_Option(xo$2);
      return xo.toList__sci_List()
    })
  })(this))))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype.emitLink__Lamf_core_model_domain_LinkNode__Lorg_yaml_model_YDocument$PartBuilder__V = (function(link, b) {
  this.linkEmitters__Lamf_core_model_domain_LinkNode__sc_Seq(link).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$1) {
    return (function(x$10$2) {
      var x$10 = $as_Lamf_core_emitter_PartEmitter(x$10$2);
      x$10.emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$1)
    })
  })(this, b)))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype.objectEmitters__Lamf_core_model_domain_ObjectNode__sc_Seq = (function(objectNode) {
  var jsx$2 = objectNode.propertyFields__sc_Iterable();
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, objectNode$1) {
    return (function(f$2) {
      var f = $as_Lamf_core_metamodel_Field(f$2);
      var value = objectNode$1.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value(f);
      var str = f.value$1.name$1;
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter().init___T__Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_parser_Annotations__Lamf_core_errorhandling_ErrorHandler(new $c_Lamf_core_utils_package$AmfStrings().init___T(str).urlComponentDecoded__T(), $as_Lamf_core_model_domain_DataNode(value.value$1), $this.ordering$1, $this.resolvedLinks$1, $this.referencesCollector$1, value.annotations$1, $this.amf$plugins$document$webapi$parser$spec$declaration$DataNodeEmitter$$eh$f)
    })
  })(this, objectNode));
  var this$2 = $m_sc_Iterable$();
  return $as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2)).toSeq__sc_Seq()
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype.emitScalar__Lamf_core_model_domain_ScalarNode__Lorg_yaml_model_YDocument$PartBuilder__V = (function(scalar, b) {
  this.scalarEmitter__Lamf_core_model_domain_ScalarNode__Lamf_core_emitter_PartEmitter(scalar).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype.init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler = (function(dataNode, ordering, resolvedLinks, referencesCollector, eh) {
  this.dataNode$1 = dataNode;
  this.ordering$1 = ordering;
  this.resolvedLinks$1 = resolvedLinks;
  this.referencesCollector$1 = referencesCollector;
  this.amf$plugins$document$webapi$parser$spec$declaration$DataNodeEmitter$$eh$f = eh;
  this.xsdString$1 = $m_Lamf_core_vocabulary_Namespace$XsdTypes$().xsdString$1.iri__T();
  this.xsdInteger$1 = $m_Lamf_core_vocabulary_Namespace$XsdTypes$().xsdInteger$1.iri__T();
  this.xsdFloat$1 = $m_Lamf_core_vocabulary_Namespace$XsdTypes$().xsdFloat$1.iri__T();
  this.amlNumber$1 = $m_Lamf_core_vocabulary_Namespace$XsdTypes$().amlNumber$1.iri__T();
  this.xsdDouble$1 = $m_Lamf_core_vocabulary_Namespace$XsdTypes$().xsdDouble$1.iri__T();
  this.xsdBoolean$1 = $m_Lamf_core_vocabulary_Namespace$XsdTypes$().xsdBoolean$1.iri__T();
  this.xsdNil$1 = $m_Lamf_core_vocabulary_Namespace$XsdTypes$().xsdNil$1.iri__T();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.dataNode$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ordering$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.resolvedLinks$1 ? 1231 : 1237));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.referencesCollector$1));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 4)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype.arrayEmitters__Lamf_core_model_domain_ArrayNode__sc_Seq = (function(arrayNode) {
  var jsx$2 = $as_sc_Seq(arrayNode.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ArrayNodeModel$().Member$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$8$2) {
      var x$8 = $as_Lamf_core_model_domain_DataNode(x$8$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler(x$8, $this.ordering$1, $this.resolvedLinks$1, $this.referencesCollector$1, $this.amf$plugins$document$webapi$parser$spec$declaration$DataNodeEmitter$$eh$f)
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype.emitObject__Lamf_core_model_domain_ObjectNode__Lorg_yaml_model_YDocument$PartBuilder__V = (function(objectNode, b) {
  var jsx$1 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var ordered = this.ordering$1.sorted__sc_Seq__sc_Seq(this.objectEmitters__Lamf_core_model_domain_ObjectNode__sc_Seq(objectNode));
  ordered.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$2) {
    return (function(x$7$2) {
      var x$7 = $as_Lamf_core_emitter_EntryEmitter(x$7$2);
      x$7.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$2)
    })
  })(this, b$1)));
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.dataNode$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.DataNodeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.DataNodeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.DataNodeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.value$1 = null;
  this.ordering$1 = null;
  this.resolvedLinks$1 = false;
  this.referencesCollector$1 = null;
  this.propertyAnnotations$1 = null;
  this.eh$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter.prototype.productPrefix__T = (function() {
  return "DataPropertyEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter.prototype.productArity__I = (function() {
  return 6
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter)) {
    var DataPropertyEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter(x$1);
    if ((this.key$1 === DataPropertyEmitter$1.key$1)) {
      var x = this.value$1;
      var x$2 = DataPropertyEmitter$1.value$1;
      var jsx$3 = (x === x$2)
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$3 = this.ordering$1;
      var x$4 = DataPropertyEmitter$1.ordering$1;
      var jsx$2 = (x$3 === x$4)
    } else {
      var jsx$2 = false
    };
    if ((jsx$2 && (this.resolvedLinks$1 === DataPropertyEmitter$1.resolvedLinks$1))) {
      var x$5 = this.referencesCollector$1;
      var x$6 = DataPropertyEmitter$1.referencesCollector$1;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : $f_sc_GenMapLike__equals__O__Z(x$5, x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.propertyAnnotations$1;
      var x$8 = DataPropertyEmitter$1.propertyAnnotations$1;
      return (x$7 === x$8)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.value$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.resolvedLinks$1;
      break
    }
    case 4: {
      return this.referencesCollector$1;
      break
    }
    case 5: {
      return this.propertyAnnotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter.prototype.init___T__Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_parser_Annotations__Lamf_core_errorhandling_ErrorHandler = (function(key, value, ordering, resolvedLinks, referencesCollector, propertyAnnotations, eh) {
  this.key$1 = key;
  this.value$1 = value;
  this.ordering$1 = ordering;
  this.resolvedLinks$1 = resolvedLinks;
  this.referencesCollector$1 = referencesCollector;
  this.propertyAnnotations$1 = propertyAnnotations;
  this.eh$1 = eh;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.propertyAnnotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_SourceAST.getClassOf());
  if (this$1.isEmpty__Z()) {
    var xo = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$11 = $as_Lamf_core_annotations_SourceAST(arg1);
    var xo = new $c_s_Some().init___O(x$11.ast$1)
  };
  var this$3 = xo.toList__sci_List();
  var pf = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter$$anonfun$2().init___Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter(this);
  var this$4 = $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$3, pf);
  var keyAnnotations = $as_Lamf_core_parser_Annotations((this$4.isEmpty__Z() ? this.propertyAnnotations$1 : this$4.get__O()));
  var jsx$2 = $m_Lorg_yaml_model_YNode$();
  var jsx$1 = $m_Lorg_yaml_model_YScalar$();
  var str = this.key$1;
  var key = jsx$2.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(jsx$1.withLocation__T__Lorg_yaml_model_YType__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_YScalar(new $c_Lamf_core_utils_package$AmfStrings().init___T(str).urlComponentDecoded__T(), $m_Lorg_yaml_model_YType$().Str$1, keyAnnotations.sourceLocation__Lorg_mulesoft_lexer_SourceLocation()), $m_Lorg_yaml_model_YType$().Str$1);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler(this.value$1, this.ordering$1, this.resolvedLinks$1, this.referencesCollector$1, this.eh$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
  var this$8 = v.builder$1;
  var array = [key];
  if ((this$8.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$8.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$8, newSize);
  var len$1 = this$8.size0$6;
  var src = this$8.array$6;
  var dest = this$8.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$8.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$3 = j;
    var index = i;
    xs.set(jsx$3, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$8.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.key$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.value$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ordering$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.resolvedLinks$1 ? 1231 : 1237));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.referencesCollector$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.propertyAnnotations$1));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 6)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.value$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.DataPropertyEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.DataPropertyEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.DataPropertyEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_DataPropertyEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.resourceTypes$1 = null;
  this.ordering$1 = null;
  this.eh$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter.prototype.init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_core_errorhandling_ErrorHandler = (function(key, resourceTypes, ordering, eh) {
  this.key$1 = key;
  this.resourceTypes$1 = resourceTypes;
  this.ordering$1 = ordering;
  this.eh$1 = eh;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter.prototype.productPrefix__T = (function() {
  return "EndPointExtendsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter)) {
    var EndPointExtendsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter(x$1);
    if ((this.key$1 === EndPointExtendsEmitter$1.key$1)) {
      var x = this.resourceTypes$1;
      var x$2 = EndPointExtendsEmitter$1.resourceTypes$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.ordering$1;
      var x$4 = EndPointExtendsEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.resourceTypes$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter().init___Lamf_core_model_domain_templates_ParametrizedDeclaration__Lamf_core_emitter_SpecOrdering__Lamf_core_errorhandling_ErrorHandler($as_Lamf_core_model_domain_templates_ParametrizedDeclaration(this.resourceTypes$1.head__O()), this.ordering$1, this.eh$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
  var this$4 = v.builder$1;
  var array = [key];
  if ((this$4.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$4.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$4, newSize);
  var len$1 = this$4.size0$6;
  var src = this$4.array$6;
  var dest = this$4.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$4.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$4.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.resourceTypes$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var rt = $as_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = rt.annotations$2;
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.EndPointExtendsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.EndPointExtendsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.EndPointExtendsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_EndPointExtendsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter() {
  $c_O.call(this);
  this.document$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter.prototype.init___Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(document, ordering, spec) {
  this.document$1 = document;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter.prototype.productPrefix__T = (function() {
  return "OasCreativeWorkEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var this$1 = this.document$1;
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1).isDefined__Z()) {
    var jsx$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var this$2 = this.document$1;
    var this$3 = $as_Lamf_core_model_StrField(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1;
    if (this$3.isEmpty__Z()) {
      var this$4 = this.document$1;
      var jsx$1 = $as_Lamf_core_model_domain_AmfObject($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$4).get__O()).id__T()
    } else {
      var jsx$1 = this$3.get__O()
    };
    jsx$2.raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(b, $as_T(jsx$1), $m_Lorg_yaml_model_YType$().Str$1)
  } else {
    var jsx$3 = b.builder$1;
    var sourceName = b.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkItemsEmitter().init___Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.document$1, this.ordering$1, this.spec$1).emitters__sc_Seq(), b$1);
    jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter)) {
    var OasCreativeWorkEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter(x$1);
    var x = this.document$1;
    var x$2 = OasCreativeWorkEmitter$1.document$1;
    if ((x === x$2)) {
      var x$3 = this.ordering$1;
      var x$4 = OasCreativeWorkEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.document$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.document$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasCreativeWorkEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasCreativeWorkEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasCreativeWorkEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.documentation$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter.prototype.productPrefix__T = (function() {
  return "OasEntryCreativeWorkEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter)) {
    var OasEntryCreativeWorkEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter(x$1);
    if ((this.key$1 === OasEntryCreativeWorkEmitter$1.key$1)) {
      var x = this.documentation$1;
      var x$2 = OasEntryCreativeWorkEmitter$1.documentation$1;
      var jsx$1 = (x === x$2)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.ordering$1;
      var x$4 = OasEntryCreativeWorkEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.documentation$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCreativeWorkEmitter().init___Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.documentation$1, this.ordering$1, this.spec$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
  var this$5 = v.builder$1;
  var array = [key];
  if ((this$5.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$5.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$5, newSize);
  var len$1 = this$5.size0$6;
  var src = this$5.array$6;
  var dest = this$5.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$5.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$5.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter.prototype.init___T__Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, documentation, ordering, spec) {
  this.key$1 = key;
  this.documentation$1 = documentation;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.documentation$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasEntryCreativeWorkEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasEntryCreativeWorkEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasEntryCreativeWorkEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.call(this);
  this.shape$3 = null;
  this.map$3 = null;
  this.options$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser.prototype.productPrefix__T = (function() {
  return "AnyTypeShapeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser(x$1).$$outer$1 === this.$$outer$1))) {
    var AnyTypeShapeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser(x$1);
    var x = this.shape$3;
    var x$2 = AnyTypeShapeParser$1.shape$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var this$1 = this.map$3;
      var b = AnyTypeShapeParser$1.map$3;
      return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$3;
      break
    }
    case 1: {
      return this.map$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser.prototype.options__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions = (function() {
  return this.options$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser.prototype.map__Lorg_yaml_model_YMap = (function() {
  return this.map$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_AnyShape__Lorg_yaml_model_YMap = (function($$outer, shape, map) {
  this.shape$3 = shape;
  this.map$3 = map;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.call(this, $$outer);
  this.options$3 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions().init___Z__Z__Z(true, true, false);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser.prototype.shape__Lamf_core_model_domain_Shape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser.prototype.shape__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$AnyTypeShapeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$AnyTypeShapeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$AnyTypeShapeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.call(this);
  this.shape$3 = null;
  this.map$3 = null;
  this.ctx$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser.prototype.productPrefix__T = (function() {
  return "NodeShapeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_NodeShape__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function($$outer, shape, map, ctx) {
  this.shape$3 = shape;
  this.map$3 = map;
  this.ctx$3 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.call(this, $$outer);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser(x$1).$$outer$1 === this.$$outer$1))) {
    var NodeShapeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser(x$1);
    var x = this.shape$3;
    var x$2 = NodeShapeParser$1.shape$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var this$1 = this.map$3;
      var b = NodeShapeParser$1.map$3;
      return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$3;
      break
    }
    case 1: {
      return this.map$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser.prototype.map__Lorg_yaml_model_YMap = (function() {
  return this.map$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser.prototype.shape__Lamf_core_model_domain_Shape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser.prototype.shape__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_NodeShape = (function() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape.call(this);
  var map = this.map$3;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("type");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = this.shape$3;
    var annotation = new $c_Lamf_core_annotations_ExplicitField().init___();
    $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$4, annotation)
  };
  var map$1 = this.map$3;
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var this$6 = this.$$outer$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MinProperties$1;
  var iv = this.ctx$3;
  jsx$1.key__T__F1__V("minProperties", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$6, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$3));
  var map$2 = this.map$3;
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var this$8 = this.$$outer$1;
  var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MaxProperties$1;
  var iv$1 = this.ctx$3;
  jsx$2.key__T__F1__V("maxProperties", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$8, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$3));
  var this$9 = this.shape$3;
  var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$9, field$2, false);
  var map$3 = this.map$3;
  var this$11 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3).key__T__s_Option("additionalProperties");
  if ((!this$11.isEmpty__Z())) {
    var arg1$1 = this$11.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var this$12 = entry.value$2;
    var x1 = this$12.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Bool$1;
    if ((x === x1)) {
      var this$13 = this.$$outer$1;
      var field$3 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1;
      var iv$2 = this.ctx$3;
      var this$14 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$13, field$3, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$3).negated__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField();
      this$14.withAnnotation__Lamf_core_model_domain_Annotation__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_Lamf_core_annotations_ExplicitField().init___()).apply__Lorg_yaml_model_YMapEntry__V(entry)
    } else {
      var x$3 = $m_Lorg_yaml_model_YType$().Map$1;
      if ((x$3 === x1)) {
        var this$15 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(s$2) {
            var s = $as_Lamf_core_model_domain_Shape(s$2);
            s.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject($this.shape$3.id$1, s.adopted$default$2__sc_Seq())
          })
        })(this)), this.$$outer$1.version$2, this.ctx$3).parse__s_Option();
        if ((!this$15.isEmpty__Z())) {
          var arg1$2 = this$15.get__O();
          var s$3 = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1$2);
          var this$16 = this.shape$3;
          var field$4 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().AdditionalPropertiesSchema$1;
          var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
          $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$16, field$4, s$3, annotations))
        }
      } else {
        var this$17 = this.ctx$3.eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().InvalidAdditionalPropertiesType$1;
        var node = this.shape$3.id$1;
        var prop = $m_s_None$();
        var l = entry.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$17, specification, node, prop, "Invalid part type for additional properties node. Should be a boolean or a map", l)
      }
    }
  };
  var this$18 = this.$$outer$1;
  if ((this$18.version$2 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion)) {
    var map$4 = this.map$3;
    var this$20 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$4);
    var this$21 = this$20.key__T__s_Option("discriminator");
    if ((!this$21.isEmpty__Z())) {
      var arg1$3 = this$21.get__O();
      var x$24 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
      new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DiscriminatorParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_NodeShape__Lorg_yaml_model_YMapEntry(this.$$outer$1, this.shape$3, x$24).parse__V()
    }
  } else {
    var map$5 = this.map$3;
    var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$5);
    var this$23 = this.$$outer$1;
    var field$5 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Discriminator$1;
    var iv$3 = this.ctx$3;
    jsx$3.key__T__F1__V("discriminator", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$23, field$5, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$3));
    var map$6 = this.map$3;
    var jsx$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$6);
    var jsx$4 = new $c_Lamf_core_utils_package$AmfStrings().init___T("discriminatorValue").asOasExtension__T();
    var this$26 = this.$$outer$1;
    var field$6 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().DiscriminatorValue$1;
    var iv$4 = this.ctx$3;
    jsx$5.key__T__F1__V(jsx$4, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$26, field$6, iv$4).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$3))
  };
  var requiredFields = this.$$outer$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$parseRequiredFields__Lorg_yaml_model_YMap__Lamf_plugins_domain_shapes_models_NodeShape__sci_Map(this.map$3, this.shape$3);
  var properties = $as_scm_LinkedHashMap($m_scm_LinkedHashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var map$7 = this.map$3;
  var properEntry = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$7).key__T__s_Option("properties");
  if ((!properEntry.isEmpty__Z())) {
    var arg1$4 = properEntry.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$4);
    var jsx$6 = $m_s_Option$();
    var this$28 = entry$3.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$5 = this.ctx$3;
    var x1$1 = jsx$6.apply__O__s_Option($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$28, conversion, iv$5));
    if ((x1$1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1$1);
      var m = $as_Lorg_yaml_model_YMap(x2.value$2);
      var props = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lorg_yaml_model_YMap__F1__sci_Map__Z(this.$$outer$1, m, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
        return (function(name$2) {
          var name = $as_T(name$2);
          return $this$1.shape$3.withProperty__T__Lamf_core_model_domain_extensions_PropertyShape(name)
        })
      })(this)), requiredFields, (this.$$outer$1.PropertiesParser__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser$(), false)).parse__sc_Seq();
      var jsx$7 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
        return (function(p$2) {
          var p = $as_Lamf_core_model_domain_extensions_PropertyShape(p$2);
          var this$29 = $as_Lamf_core_model_StrField(p.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
          var this$30 = this$29.option$1;
          var self = $as_T((this$30.isEmpty__Z() ? null : this$30.get__O()));
          return new $c_T2().init___O__O(self, p)
        })
      })(this));
      var this$33 = $m_sc_Seq$();
      var xs = $as_sc_TraversableOnce(props.map__F1__scg_CanBuildFrom__O(jsx$7, this$33.ReusableCBFInstance$2));
      $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(properties, xs)
    }
  };
  var x$1 = this.$$outer$1.version$2;
  var x$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$();
  if (((x$1 !== null) && x$1.equals__O__Z(x$2))) {
    new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$InnerShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__T__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape(this.$$outer$1, "propertyNames", $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().PropertyNames$1, this.map$3, this.shape$3).parse__V()
  };
  var map$8 = this.map$3;
  var patternPropEntry = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$8).key__T__s_Option("patternProperties");
  if ((!patternPropEntry.isEmpty__Z())) {
    var arg1$5 = patternPropEntry.get__O();
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$5);
    var node$1 = entry$4.value$2;
    var x1$2 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node$1).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YMapYRead$());
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$1 = $as_s_Some(x1$2);
      var m$1 = $as_Lorg_yaml_model_YMap(x2$1.value$2);
      var jsx$9 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lorg_yaml_model_YMap__F1__sci_Map__Z(this.$$outer$1, m$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2) {
        return (function(name$2$1) {
          var name$1 = $as_T(name$2$1);
          return $this$2.shape$3.withProperty__T__Lamf_core_model_domain_extensions_PropertyShape(name$1)
        })
      })(this)), requiredFields, true).parse__sc_Seq();
      var jsx$8 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$2) {
        return (function(p$2$1) {
          var p$1 = $as_Lamf_core_model_domain_extensions_PropertyShape(p$2$1);
          var this$36 = $as_Lamf_core_model_StrField(p$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
          var this$37 = this$36.option$1;
          var self$1 = $as_T((this$37.isEmpty__Z() ? null : this$37.get__O()));
          return new $c_T2().init___O__O(self$1, p$1)
        })
      })(this));
      var this$40 = $m_sc_Seq$();
      var xs$1 = $as_sc_TraversableOnce(jsx$9.map__F1__scg_CanBuildFrom__O(jsx$8, this$40.ReusableCBFInstance$2));
      $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(properties, xs$1)
    }
  };
  if (properEntry.isEmpty__Z()) {
    var this$43 = $m_s_None$()
  } else {
    var arg1$6 = properEntry.get__O();
    var pe = $as_Lorg_yaml_model_YMapEntry(arg1$6);
    var self$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(pe.value$2);
    var y = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(pe);
    var this$43 = new $c_s_Some().init___O(new $c_T2().init___O__O(self$2, y))
  };
  if (this$43.isEmpty__Z()) {
    if (patternPropEntry.isEmpty__Z()) {
      var this$46 = $m_s_None$()
    } else {
      var arg1$7 = patternPropEntry.get__O();
      var pp = $as_Lorg_yaml_model_YMapEntry(arg1$7);
      var self$3 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(pp.value$2);
      var y$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(pp);
      var this$46 = new $c_s_Some().init___O(new $c_T2().init___O__O(self$3, y$1))
    }
  } else {
    var this$46 = this$43
  };
  if (this$46.isEmpty__Z()) {
    $m_Lamf_core_parser_Annotations$();
    var self$4 = new $c_Lamf_core_parser_Annotations().init___();
    $m_Lamf_core_parser_Annotations$();
    var y$2 = new $c_Lamf_core_parser_Annotations().init___();
    var jsx$10 = new $c_T2().init___O__O(self$4, y$2)
  } else {
    var jsx$10 = this$46.get__O()
  };
  var x1$3 = $as_T2(jsx$10);
  if ((x1$3 === null)) {
    throw new $c_s_MatchError().init___O(x1$3)
  };
  var entryAnnotations = $as_Lamf_core_parser_Annotations(x1$3.$$und1__O());
  var valueAnnotations = $as_Lamf_core_parser_Annotations(x1$3.$$und2__O());
  if ($f_sc_TraversableOnce__nonEmpty__Z(properties)) {
    var this$52 = this.shape$3;
    var field$7 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1;
    var this$51 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(properties);
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(this$51.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream(), entryAnnotations);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$52, field$7, value, valueAnnotations)
  };
  var this$53 = this.shape$3;
  $as_sc_Seq(this$53.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$9$1, properties$1) {
    return (function(p$2$2) {
      var p$3 = $as_Lamf_core_model_domain_extensions_PropertyShape(p$2$2);
      var this$54 = $as_Lamf_core_model_StrField(p$3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
      var this$55 = this$54.option$1;
      var self$5 = $as_T((this$55.isEmpty__Z() ? null : this$55.get__O()));
      properties$1.put__O__O__s_Option(self$5, p$3);
      return properties$1
    })
  })(this, properties)));
  var map$9 = this.map$3;
  var this$59 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$9);
  var this$60 = this$59.key__T__s_Option("dependencies");
  if ((!this$60.isEmpty__Z())) {
    var arg1$8 = this$60.get__O();
    var entry$5 = $as_Lorg_yaml_model_YMapEntry(arg1$8);
    var this$61 = entry$5.value$2;
    var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$6 = this.ctx$3;
    var dependencies = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser().init___Lorg_yaml_model_YMap__scm_LinkedHashMap__Lamf_plugins_document_webapi_contexts_WebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$61, conversion$1, iv$6)), properties, this.ctx$3).parse__sc_Seq();
    var this$62 = this.shape$3;
    var field$8 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Dependencies$1;
    var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(dependencies, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$5.value$2));
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$5);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$62, field$8, value$1, annotations$1)
  };
  var map$10 = this.map$3;
  var this$64 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$10);
  var this$65 = this$64.key__T__s_Option("x-amf-merge");
  if ((!this$65.isEmpty__Z())) {
    var arg1$9 = this$65.get__O();
    var entry$6 = $as_Lorg_yaml_model_YMapEntry(arg1$9);
    var jsx$11 = this.$$outer$1;
    var this$66 = entry$6.value$2;
    var conversion$2 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var iv$7 = this.ctx$3;
    var inherits = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AllOfParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__sc_Seq__F1(jsx$11, $as_sc_Seq($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$66, conversion$2, iv$7)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3) {
      return (function(s$2$1) {
        var s$1 = $as_Lamf_core_model_domain_Shape(s$2$1);
        s$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject($this$3.shape$3.id$1, s$1.adopted$default$2__sc_Seq())
      })
    })(this))).parse__sc_Seq();
    var this$67 = this.shape$3;
    var field$9 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Inherits$1;
    var value$2 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(inherits, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$6.value$2));
    var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$6);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$67, field$9, value$2, annotations$2)
  };
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$NodeShapeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$NodeShapeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$NodeShapeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.call(this);
  this.nodeOrEntry$3 = null;
  this.name$3 = null;
  this.node$3 = null;
  this.map$3 = null;
  this.shape$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser.prototype.productPrefix__T = (function() {
  return "UnionShapeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser(x$1).$$outer$1 === this.$$outer$1))) {
    var UnionShapeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser(x$1);
    var x = this.nodeOrEntry$3;
    var x$2 = UnionShapeParser$1.nodeOrEntry$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      return (this.name$3 === UnionShapeParser$1.name$3)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.nodeOrEntry$3;
      break
    }
    case 1: {
      return this.name$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_UnionShape = (function() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape.call(this);
  var map = this.map$3;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("x-amf-union");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var evidence$2 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var x1 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$4, evidence$2);
    if ((x1 instanceof $c_s_util_Right)) {
      var x2 = $as_s_util_Right(x1);
      var seq = $as_sc_Seq(x2.value$2);
      var this$5 = $m_sc_Seq$();
      var jsx$4 = $as_sc_TraversableLike(seq.zipWithIndex__scg_CanBuildFrom__O(this$5.ReusableCBFInstance$2));
      var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x0$1$2) {
          var x0$1 = $as_T2(x0$1$2);
          if ((x0$1 !== null)) {
            var unionNode = $as_Lorg_yaml_model_YNode(x0$1.$$und1__O());
            var index = x0$1.$$und2$mcI$sp__I();
            var entry$1 = $m_Lorg_yaml_model_YMapEntry$().apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry($m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(("item" + index)), unionNode);
            return $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(entry$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, index$1) {
              return (function(item$2) {
                var item = $as_Lamf_core_model_domain_Shape(item$2);
                item.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject((($this$1.shape$3.id$1 + "/items/") + index$1), item.adopted$default$2__sc_Seq())
              })
            })($this, index)), $this.$$outer$1.version$2, $this.$$outer$1.ctx$2).parse__s_Option()
          } else {
            throw new $c_s_MatchError().init___O(x0$1)
          }
        })
      })(this));
      var this$6 = $m_sc_Seq$();
      var jsx$2 = $as_sc_TraversableLike($as_sc_TraversableLike(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$6.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
        return (function(x$10$2) {
          var x$10 = $as_s_Option(x$10$2);
          return x$10.isDefined__Z()
        })
      })(this))));
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
        return (function(x$11$2) {
          var x$11 = $as_s_Option(x$11$2);
          return $as_Lamf_plugins_domain_shapes_models_AnyShape(x$11.get__O())
        })
      })(this));
      var this$7 = $m_sc_Seq$();
      var unionNodes = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
      var this$8 = this.shape$3;
      var field = $m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1;
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
      $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$8, field, unionNodes, annotations)
    } else {
      var this$9 = this.$$outer$1.ctx$2.eh$1;
      var specification = $m_Lamf_validation_DialectValidations$().InvalidUnionType$1;
      var node = this.shape$3.id$1;
      var ast = entry.value$2;
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$9, specification, node, prop, "Unions are built from multiple shape nodes", l)
    }
  };
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser.prototype.map__Lorg_yaml_model_YMap = (function() {
  return this.map$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser.prototype.nameAnnotations__p3__Lamf_core_parser_Annotations = (function() {
  var this$1 = this.nodeOrEntry$3;
  var this$2 = new $c_s_util_Either$LeftProjection().init___s_util_Either(this$1).toOption__s_Option();
  if (this$2.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$3 = new $c_s_Some().init___O($m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(e.key$2))
  };
  return $as_Lamf_core_parser_Annotations((this$3.isEmpty__Z() ? ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()) : this$3.get__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser.prototype.shape__Lamf_core_model_domain_Shape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__s_util_Either__T = (function($$outer, nodeOrEntry, name) {
  this.nodeOrEntry$3 = nodeOrEntry;
  this.name$3 = name;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.call(this, $$outer);
  if ((nodeOrEntry instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(nodeOrEntry);
    var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    var jsx$1 = entry.value$2
  } else if ((nodeOrEntry instanceof $c_s_util_Right)) {
    var x3 = $as_s_util_Right(nodeOrEntry);
    var n = $as_Lorg_yaml_model_YNode(x3.value$2);
    var jsx$1 = n
  } else {
    var jsx$1;
    throw new $c_s_MatchError().init___O(nodeOrEntry)
  };
  this.node$3 = jsx$1;
  var this$1 = this.node$3;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = $$outer.ctx$2;
  this.map$3 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var annotations = $m_Lamf_core_parser_Annotations$().valueNode__Lorg_yaml_model_YNode__Lamf_core_parser_Annotations(this.node$3);
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_UnionShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var a = this.nameAnnotations__p3__Lamf_core_parser_Annotations();
  var union = $as_Lamf_plugins_domain_shapes_models_UnionShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$4, name, a));
  $$outer.adopt$2.apply__O__O(union);
  this.shape$3 = union;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser.prototype.shape__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$UnionShapeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$UnionShapeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$UnionShapeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter() {
  $c_O.call(this);
  this.declaration$1 = null;
  this.ordering$1 = null;
  this.eh$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter.prototype.productPrefix__T = (function() {
  return "ParametrizedDeclarationEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  if (this.declaration$1.variables__sc_Seq().nonEmpty__Z()) {
    var jsx$5 = b.builder$1;
    var sourceName = b.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lorg_yaml_model_YNode$();
    var this$2 = this.declaration$1;
    var this$3 = $as_Lamf_core_model_StrField(this$2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$().Name$1));
    var this$4 = this$3.option$1;
    var str = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
    var jsx$3 = v.builder$1;
    var sourceName$1 = v.sourceName$2;
    var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
    var jsx$2 = this.declaration$1.variables__sc_Seq();
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(variable$2) {
        var variable = $as_Lamf_core_model_domain_templates_VariableValue(variable$2);
        return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter().init___Lamf_core_model_domain_templates_VariableValue__Lamf_core_emitter_SpecOrdering__Lamf_core_errorhandling_ErrorHandler(variable, $this.ordering$1, $this.eh$1)
      })
    })(this));
    var this$7 = $m_sc_Seq$();
    var result = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$2);
    jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1));
    var this$10 = v.builder$1;
    var array = [key];
    if ((this$10.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$10.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$10, newSize);
    var len$1 = this$10.size0$6;
    var src = this$10.array$6;
    var dest = this$10.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$10.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$4 = j;
      var index = i;
      xs.set(jsx$4, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$10.size0$6 = newSize;
    b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1));
    jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  } else {
    var jsx$6 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var this$21 = this.declaration$1;
    var this$22 = $as_Lamf_core_model_StrField(this$21.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$().Name$1));
    var this$23 = this$22.option$1;
    jsx$6.raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(b, $as_T((this$23.isEmpty__Z() ? null : this$23.get__O())), $m_Lorg_yaml_model_YType$().Str$1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter)) {
    var ParametrizedDeclarationEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter(x$1);
    var x = this.declaration$1;
    var x$2 = ParametrizedDeclarationEmitter$1.declaration$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = ParametrizedDeclarationEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.declaration$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter.prototype.init___Lamf_core_model_domain_templates_ParametrizedDeclaration__Lamf_core_emitter_SpecOrdering__Lamf_core_errorhandling_ErrorHandler = (function(declaration, ordering, eh) {
  this.declaration$1 = declaration;
  this.ordering$1 = ordering;
  this.eh$1 = eh;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.declaration$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.ParametrizedDeclarationEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.ParametrizedDeclarationEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.ParametrizedDeclarationEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RAMLSchemaVersion.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_RAMLSchemaVersion();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion.prototype.init___ = (function() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion.prototype.init___T.call(this, "raml1.0");
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion.prototype.productPrefix__T = (function() {
  return "RAML10SchemaVersion"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion(x$1), true))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RAML10SchemaVersion"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RAML10SchemaVersion;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RAML10SchemaVersion", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RAMLSchemaVersion: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter() {
  $c_O.call(this);
  this.documentation$1 = null;
  this.ordering$1 = null;
  this.withExtension$1 = false;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter.prototype.productPrefix__T = (function() {
  return "RamlCreativeWorkEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$1 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkItemsEmitter().init___Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Z__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.documentation$1, this.ordering$1, this.withExtension$1, this.spec$1).emitters__sc_Seq(), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter.prototype.init___Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Z__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(documentation, ordering, withExtension, spec) {
  this.documentation$1 = documentation;
  this.ordering$1 = ordering;
  this.withExtension$1 = withExtension;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter)) {
    var RamlCreativeWorkEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter(x$1);
    var x = this.documentation$1;
    var x$2 = RamlCreativeWorkEmitter$1.documentation$1;
    if ((x === x$2)) {
      var x$3 = this.ordering$1;
      var x$4 = RamlCreativeWorkEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.withExtension$1 === RamlCreativeWorkEmitter$1.withExtension$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.documentation$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.withExtension$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.documentation$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ordering$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.withExtension$1 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 3)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.documentation$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlCreativeWorkEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlCreativeWorkEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlCreativeWorkEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter() {
  $c_O.call(this);
  this.reference$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter.prototype.productPrefix__T = (function() {
  return "RamlLocalReferenceEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var this$1 = this.reference$1;
  var x1 = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var label = $as_T(x2.value$2);
    $m_Lamf_core_emitter_BaseEmitters_package$().raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(b, label, $m_Lorg_yaml_model_YType$().Str$1)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Missing link label"))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter)) {
    var RamlLocalReferenceEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter(x$1);
    var x = this.reference$1;
    var x$2 = RamlLocalReferenceEmitter$1.reference$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.reference$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter.prototype.init___Lamf_core_model_domain_Linkable = (function(reference) {
  this.reference$1 = reference;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.reference$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlLocalReferenceEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlLocalReferenceEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlLocalReferenceEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser.call(this);
  this.part$2 = null;
  this.adopt$2 = null;
  this.ctx$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser.prototype.parseReferenced__T__T__Lamf_core_parser_Annotations__F1__Lamf_plugins_domain_webapi_models_security_SecurityScheme = (function(name, parsedUrl, annotations, adopt) {
  var scheme = this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().findSecuritySchemeOrError__Lorg_yaml_model_YPart__T__Lamf_core_parser_SearchScope$Scope__Lamf_plugins_domain_webapi_models_security_SecurityScheme(this.part$2, parsedUrl, $m_Lamf_core_parser_SearchScope$All$());
  var copied = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(scheme, parsedUrl, annotations));
  adopt.apply__O__O(copied);
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  return $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(copied, name, a))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser.prototype.productPrefix__T = (function() {
  return "RamlSecuritySchemeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser)) {
    var RamlSecuritySchemeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser(x$1);
    var x = this.part$2;
    var x$2 = RamlSecuritySchemeParser$1.part$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.adopt$2;
      var x$4 = RamlSecuritySchemeParser$1.adopt$2;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.part$2;
      break
    }
    case 1: {
      return this.adopt$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser.prototype.init___Lorg_yaml_model_YPart__F1__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(part, adopt, ctx) {
  this.part$2 = part;
  this.adopt$2 = adopt;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser.prototype.init___Lorg_yaml_model_YPart__F1__Lamf_plugins_document_webapi_contexts_WebApiContext.call(this, part, adopt, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser.prototype.parse__Lamf_plugins_domain_webapi_models_security_SecurityScheme = (function() {
  var node = this.getNode__Lorg_yaml_model_YNode();
  var key = this.getName__T();
  var x1 = this.ctx$2.link__Lorg_yaml_model_YNode__s_util_Either(node);
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var link = $as_T(x2.value$2);
    return this.parseReferenced__T__T__Lamf_core_parser_Annotations__F1__Lamf_plugins_domain_webapi_models_security_SecurityScheme(key, link, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(node), this.adopt$2)
  } else if ((x1 instanceof $c_s_util_Right)) {
    var x3 = $as_s_util_Right(x1);
    var value = $as_Lorg_yaml_model_YNode(x3.value$2);
    var scheme = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(this.adopt$2.apply__O__O($m_Lamf_plugins_domain_webapi_models_security_SecurityScheme$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_security_SecurityScheme(this.part$2)));
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$2;
    var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(value, conversion, iv));
    this.ctx$2.closedShape__T__Lorg_yaml_model_YMap__T__V(scheme.id$1, map, "securitySchema");
    var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1;
    var iv$1 = this.ctx$2;
    jsx$1.key__T__F1__V("type", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(scheme).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
    var x1$2 = $as_Lamf_core_model_StrField(scheme.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1)).option$1;
    matchEnd8: {
      if ((x1$2 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$2);
        var p3 = $as_T(x2$2.value$2);
        if (((p3 === "oauth2") || ((p3 === "basic") || (p3 === "apiKey")))) {
          this.ctx$2.eh$1.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V($m_Lamf_validations_ParserSideValidations$().CrossSecurityWarningSpecification$1, scheme.id$1, new $c_s_Some().init___O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1.value$1.iri__T()), "OAS 2.0 security scheme type detected in RAML 1.0 spec", $as_Lamf_core_model_StrField(scheme.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1)).annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf()), new $c_s_Some().init___O(this.ctx$2.rootContextDocument$1));
          break matchEnd8
        }
      }
    };
    var this$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var this$4 = this$3.key__T__s_Option("type");
    if ((!this$4.isEmpty__Z())) {
      var arg1 = this$4.get__O();
      var value$2 = $as_Lorg_yaml_model_YMapEntry(arg1);
      var this$5 = value$2.value$2;
      var x = this$5.tag__Lorg_yaml_model_YTag().tagType$3;
      var x$2 = $m_Lorg_yaml_model_YType$().Null$1;
      if (((x === x$2) && $as_Lamf_core_model_StrField(scheme.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1)).option$1.contains__O__Z(""))) {
        var this$7 = this.ctx$2.eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().MissingSecuritySchemeErrorSpecification$1;
        var node$1 = scheme.id$1;
        var property = new $c_s_Some().init___O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1.value$1.iri__T());
        var jsx$2 = $m_Lamf_core_parser_Range$();
        var this$6 = map.location$1;
        var lexical = new $c_s_Some().init___O(new $c_Lamf_core_annotations_LexicalInformation().init___Lamf_core_parser_Range(jsx$2.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$6.lineFrom$1, this$6.columnFrom$1, this$6.lineTo$1, this$6.columnTo$1))));
        var location = new $c_s_Some().init___O(this.ctx$2.rootContextDocument$1);
        this$7.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node$1, property, "Security Scheme must have a mandatory value from 'OAuth 1.0', 'OAuth 2.0', 'Basic Authentication', 'Digest Authentication', 'Pass Through', x-<other>'", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
      }
    };
    scheme.normalizeType__V();
    var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().DisplayName$1;
    var iv$2 = this.ctx$2;
    jsx$3.key__T__F1__V("displayName", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(scheme).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
    var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Description$1;
    var iv$3 = this.ctx$2;
    jsx$4.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(scheme).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
    new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDescribedByParser().init___T__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext("describedBy", map, scheme, this.ctx$2).parse__V();
    var jsx$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1;
    var iv$4 = this.ctx$2;
    jsx$5.key__T__F1__V("settings", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$3, iv$4).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(scheme).using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, scheme$1) {
      return (function(node$2$2) {
        var node$2 = $as_Lorg_yaml_model_YNode(node$2$2);
        return $m_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecuritySettingsParser$().parse__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_domain_webapi_models_security_Settings(scheme$1, node$2, this$2$1.ctx$2)
      })
    })(this, scheme))));
    $m_sci_List$();
    var array = [$m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().securityScheme$1];
    var i = (((-1) + $uI(array.length)) | 0);
    var result = $m_sci_Nil$();
    while ((i >= 0)) {
      var this$14 = result;
      var index = i;
      var x$1 = array[index];
      result = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$14);
      i = (((-1) + i) | 0)
    };
    new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(scheme, map, result, this.ctx$2).parse__V();
    return scheme
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlSecuritySchemeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlSecuritySchemeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlSecuritySchemeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlSecuritySchemeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector() {
  $c_O.call(this);
  this.InheritsTypeDetecter$module$1 = null;
  this.ShapeClassTypeDefMatcher$module$1 = null;
  this.parent$1 = null;
  this.format$1 = null;
  this.defaultType$1 = null;
  this.recursive$1 = false;
  this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeDetector$$ctx$f = null;
  this.platform$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.productPrefix__T = (function() {
  return "RamlTypeDetector"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.inferType__p1__Lorg_yaml_model_YMap__s_Option = (function(map) {
  var this$1 = this.ShapeClassTypeDefMatcher__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$().fetchByRamlSyntax__Lorg_yaml_model_YMap__s_Option(map);
  return (this$1.isEmpty__Z() ? new $c_s_Some().init___O(this.defaultType$1.typeDef__Lamf_plugins_domain_shapes_models_TypeDef()) : this$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.ShapeClassTypeDefMatcher__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$ = (function() {
  if ((this.ShapeClassTypeDefMatcher$module$1 === null)) {
    this.ShapeClassTypeDefMatcher$lzycompute$1__p1__V()
  };
  return this.ShapeClassTypeDefMatcher$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.ShapeClassTypeDefMatcher$lzycompute$1__p1__V = (function() {
  if ((this.ShapeClassTypeDefMatcher$module$1 === null)) {
    this.ShapeClassTypeDefMatcher$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector)) {
    var RamlTypeDetector$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector(x$1);
    if ((this.parent$1 === RamlTypeDetector$1.parent$1)) {
      var x = this.format$1;
      var x$2 = RamlTypeDetector$1.format$1;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$3 = this.defaultType$1;
      var x$4 = RamlTypeDetector$1.defaultType$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.recursive$1 === RamlTypeDetector$1.recursive$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.parent$1;
      break
    }
    case 1: {
      return this.format$1;
      break
    }
    case 2: {
      return this.defaultType$1;
      break
    }
    case 3: {
      return this.recursive$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.detectProperties__p1__Lorg_yaml_model_YMap__s_Option = (function(map) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("properties");
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    $as_Lorg_yaml_model_YMapEntry(arg1);
    return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$())
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.detectFileTypes__p1__Lorg_yaml_model_YMap__s_Option = (function(map) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("fileTypes");
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    $as_Lorg_yaml_model_YMapEntry(arg1);
    return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$FileType$())
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.InheritsTypeDetecter$lzycompute$1__p1__V = (function() {
  if ((this.InheritsTypeDetecter$module$1 === null)) {
    this.InheritsTypeDetecter$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$InheritsTypeDetecter$().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.init___T__s_Option__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(parent, format, defaultType, recursive, ctx) {
  this.parent$1 = parent;
  this.format$1 = format;
  this.defaultType$1 = defaultType;
  this.recursive$1 = recursive;
  this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeDetector$$ctx$f = ctx;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.detectItems__p1__Lorg_yaml_model_YMap__s_Option = (function(map) {
  var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("items");
  if ((x1 instanceof $c_s_Some)) {
    return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$())
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return $m_s_None$()
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.parent$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.format$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.defaultType$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.recursive$1 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 4)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.detect__Lorg_yaml_model_YNode__s_Option = (function(node) {
  var x1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Seq$1;
  if ((x === x1)) {
    var conversion = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var iv = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeDetector$$ctx$f;
    var sequence = $as_sc_Seq($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv));
    var this$1 = this.InheritsTypeDetecter__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$InheritsTypeDetecter$().apply__sci_List__Lorg_yaml_model_YPart__s_Option(this.collectTypeDefs__p1__sc_Seq__sci_List(sequence), node);
    return (this$1.isEmpty__Z() ? new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$()) : this$1)
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x$3 === x1)) {
      var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv$1 = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeDetector$$ctx$f;
      var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$1, iv$1));
      var entries = $as_sc_IndexedSeq(map.entries$3.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
        return (function(e$2) {
          var e = $as_Lorg_yaml_model_YMapEntry(e$2);
          var this$3 = e.key$2;
          var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
          var iv$2 = this$2.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeDetector$$ctx$f;
          var thiz = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion$2, iv$2)).text$3;
          if ((thiz === null)) {
            throw new $c_jl_NullPointerException().init___()
          };
          return (!$m_ju_regex_Pattern$().matches__T__jl_CharSequence__Z(".*/.*", thiz))
        })
      })(this))));
      var jsx$1 = $m_Lorg_yaml_model_YMap$();
      var this$5 = entries.headOption__s_Option();
      if (this$5.isEmpty__Z()) {
        var this$6 = $m_s_None$()
      } else {
        var arg1 = this$5.get__O();
        var x$1 = $as_Lorg_yaml_model_YMapEntry(arg1);
        var this$6 = new $c_s_Some().init___O(x$1.location$1.sourceName$1)
      };
      var filterMap = jsx$1.apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(entries, $as_T((this$6.isEmpty__Z() ? "" : this$6.get__O())));
      var typeExplicit = this.detectTypeOrSchema__p1__Lorg_yaml_model_YMap__s_Option(filterMap);
      var this$7 = this.detectItems__p1__Lorg_yaml_model_YMap__s_Option(filterMap);
      var this$8 = (this$7.isEmpty__Z() ? this.detectFileTypes__p1__Lorg_yaml_model_YMap__s_Option(filterMap) : this$7);
      var this$9 = (this$8.isEmpty__Z() ? this.detectProperties__p1__Lorg_yaml_model_YMap__s_Option(filterMap) : this$8);
      var infer = (this$9.isEmpty__Z() ? this.detectAnyOf__p1__Lorg_yaml_model_YMap__s_Option(filterMap) : this$9);
      var rc9 = false;
      var x2 = null;
      if ((typeExplicit instanceof $c_s_Some)) {
        rc9 = true;
        x2 = $as_s_Some(typeExplicit);
        var p3 = $as_Lamf_plugins_domain_shapes_models_TypeDef(x2.value$2);
        var x$5 = $m_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$();
        if (((x$5 === p3) && infer.isDefined__Z())) {
          var this$10 = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeDetector$$ctx$f.eh$1;
          var specification = $m_Lamf_validations_ParserSideValidations$().JsonSchemaInheratinaceWarningSpecification$1;
          var node$1 = this.parent$1;
          var property = new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1.value$1.iri__T());
          var part = node.value__Lorg_yaml_model_YValue();
          var location = part.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$10, specification, node$1, property, "Inheritance from JSON Schema", location);
          return typeExplicit
        }
      };
      if (rc9) {
        return typeExplicit
      };
      var x$7 = $m_s_None$();
      if (((x$7 === typeExplicit) && infer.isDefined__Z())) {
        return infer
      };
      return this.inferType__p1__Lorg_yaml_model_YMap__s_Option(map)
    } else {
      var x$9 = $m_Lorg_yaml_model_YType$().Null$1;
      if ((x$9 === x1)) {
        return new $c_s_Some().init___O(this.defaultType$1.typeDef__Lamf_plugins_domain_shapes_models_TypeDef())
      } else {
        var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
        var iv$3 = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeDetector$$ctx$f;
        var scalar = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$3, iv$3));
        var x1$3 = scalar.text$3;
        if (((($uI(x1$3.length) >= 0) && ($as_T(x1$3.substring(0, $uI("<<".length))) === "<<")) && $m_sjsr_RuntimeString$().endsWith__T__T__Z(x1$3, ">>"))) {
          var x$11 = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeDetector$$ctx$f.contextType$3;
          var x$12 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2;
          if (((x$11 === null) ? (x$12 === null) : x$11.equals__O__Z(x$12))) {
            var this$16 = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeDetector$$ctx$f.eh$1;
            var specification$1 = $m_Lamf_validations_ParserSideValidations$().InvalidAbstractDeclarationParameterInType$1;
            var node$2 = this.parent$1;
            var message = (("Resource Type/Trait parameter " + x1$3) + " in type");
            var prop = $m_s_None$();
            var l = node.location$1;
            $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$16, specification$1, node$2, prop, message, l)
          };
          return $m_s_None$()
        };
        var o13 = $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$().unapply__T__s_Option(x1$3);
        if ((!o13.isEmpty__Z())) {
          return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$XMLSchemaType$())
        };
        var o15 = $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$().unapply__T__s_Option(x1$3);
        if ((!o15.isEmpty__Z())) {
          return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$JSONSchemaType$())
        };
        var o17 = $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$().unapply__T__s_Option(x1$3);
        if ((!o17.isEmpty__Z())) {
          var text = $as_T(o17.get__O());
          var x$1$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$8$1) {
            return (function(shape$2) {
              var shape = $as_Lamf_core_model_domain_Shape(shape$2);
              $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(shape, "/")
            })
          })(this));
          var conversion$4 = $m_Lamf_core_parser_package$YScalarYRead$();
          var iv$4 = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeDetector$$ctx$f;
          var x$2$2 = new $c_s_Some().init___O($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$4, iv$4));
          var ctx = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeDetector$$ctx$f;
          var this$18 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser().init___F1__I__s_Option__Z__T__Lamf_plugins_document_webapi_contexts_WebApiContext(x$1$3, 0, x$2$2, true, text, ctx).parse__s_Option();
          if (this$18.isEmpty__Z()) {
            var this$19 = $m_s_None$()
          } else {
            var arg1$1 = this$18.get__O();
            var s = $as_Lamf_core_model_domain_Shape(arg1$1);
            var this$19 = this.ShapeClassTypeDefMatcher__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$().apply__Lamf_core_model_domain_Shape__Lorg_yaml_model_YNode__Z__Lamf_core_parser_ParserContext__s_Option(s, node, this.recursive$1, this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeDetector$$ctx$f)
          };
          if (this$19.isEmpty__Z()) {
            return $m_s_None$()
          } else {
            var arg1$2 = this$19.get__O();
            var x0$1 = $as_Lamf_plugins_domain_shapes_models_TypeDef(arg1$2);
            var x$2 = $m_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$();
            if ((x$2 === x0$1)) {
              var jsx$2 = true
            } else {
              var x$3$1 = $m_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$();
              var jsx$2 = (x$3$1 === x0$1)
            };
            return new $c_s_Some().init___O(((jsx$2 && (!this.recursive$1)) ? $m_Lamf_plugins_domain_shapes_models_TypeDef$TypeExpressionType$() : x0$1))
          }
        };
        if ($m_sjsr_RuntimeString$().endsWith__T__T__Z(x1$3, "?")) {
          return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$NilUnionType$())
        };
        if ((x1$3 !== null)) {
          var x$13 = $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$().matchType__Lamf_plugins_document_webapi_parser_TypeName__Lamf_plugins_domain_shapes_models_TypeDef__Z__Lamf_plugins_domain_shapes_models_TypeDef(new $c_Lamf_plugins_document_webapi_parser_TypeName().init___T__s_Option(x1$3, $m_s_None$()), $m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$(), ($m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$(), false));
          var x$14 = $m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$();
          if (((x$13 !== null) && (x$13 === x$14))) {
            var rc7 = false;
            var x2$2 = null;
            var x1$4 = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeDetector$$ctx$f.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().findType__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option(scalar.text$3, $m_Lamf_core_parser_SearchScope$All$(), (this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeDetector$$ctx$f.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations(), $m_s_None$()));
            if ((x1$4 instanceof $c_s_Some)) {
              rc7 = true;
              x2$2 = $as_s_Some(x1$4);
              var ancestor = $as_Lamf_plugins_domain_shapes_models_AnyShape(x2$2.value$2);
              if (this.recursive$1) {
                return this.ShapeClassTypeDefMatcher__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$ShapeClassTypeDefMatcher$().apply__Lamf_core_model_domain_Shape__Lorg_yaml_model_YNode__Z__Lamf_core_parser_ParserContext__s_Option(ancestor, node, this.recursive$1, this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeDetector$$ctx$f)
              }
            };
            if ((rc7 && (!this.recursive$1))) {
              return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$())
            };
            var x$15 = $m_s_None$();
            if ((x$15 === x1$4)) {
              return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$())
            };
            throw new $c_s_MatchError().init___O(x1$4)
          }
        };
        var t = scalar.text$3;
        if (this.format$1.isDefined__Z()) {
          var this$22 = this.format$1;
          if (this$22.isEmpty__Z()) {
            return $m_s_None$()
          } else {
            var arg1$3 = this$22.get__O();
            var f = $as_T(arg1$3);
            return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$().matchType__Lamf_plugins_document_webapi_parser_TypeName__Lamf_plugins_domain_shapes_models_TypeDef__Z__Lamf_plugins_domain_shapes_models_TypeDef($m_Lamf_plugins_document_webapi_parser_TypeName$().apply__T__T__Lamf_plugins_document_webapi_parser_TypeName(t, f), ($m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$(), $m_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$()), ($m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$(), false)))
          }
        } else {
          return new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$().matchType__Lamf_plugins_document_webapi_parser_TypeName__Lamf_plugins_domain_shapes_models_TypeDef__Z__Lamf_plugins_domain_shapes_models_TypeDef(new $c_Lamf_plugins_document_webapi_parser_TypeName().init___T__s_Option(t, $m_s_None$()), ($m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$(), $m_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$()), ($m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$(), false)))
        }
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.InheritsTypeDetecter__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector$InheritsTypeDetecter$ = (function() {
  if ((this.InheritsTypeDetecter$module$1 === null)) {
    this.InheritsTypeDetecter$lzycompute$1__p1__V()
  };
  return this.InheritsTypeDetecter$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.typeOrSchema__Lorg_yaml_model_YMap__s_Option = (function(map) {
  var type = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("type");
  var schema = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("schema");
  if ((!type.isEmpty__Z())) {
    var arg1 = type.get__O();
    $as_Lorg_yaml_model_YMapEntry(arg1);
    if ((!schema.isEmpty__Z())) {
      var arg1$1 = schema.get__O();
      var s = $as_Lorg_yaml_model_YMapEntry(arg1$1);
      var this$3 = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeDetector$$ctx$f.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().ExclusiveSchemaType$1;
      var node = this.parent$1;
      var ast = s.key$2;
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$3, specification, node, prop, "'schema' and 'type' properties are mutually exclusive", l)
    }
  };
  if ((!schema.isEmpty__Z())) {
    var arg1$2 = schema.get__O();
    var s$1 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var this$4 = this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeDetector$$ctx$f.eh$1;
    var specification$1 = $m_Lamf_validations_ParserSideValidations$().SchemaDeprecated$1;
    var node$1 = this.parent$1;
    var ast$1 = s$1.key$2;
    var property = $m_s_None$();
    var location = ast$1.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$4, specification$1, node$1, property, "'schema' keyword it's deprecated for 1.0 version, should use 'type' instead", location)
  };
  return (type.isEmpty__Z() ? schema : type)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.collectTypeDefs__p1__sc_Seq__sci_List = (function(sequence) {
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(node$2) {
      var node = $as_Lorg_yaml_model_YNode(node$2);
      var x$1 = $this.parent$1;
      var x$3 = $m_s_None$();
      var x$4 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$();
      var xo = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector().init___T__s_Option__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(x$1, x$3, x$4, true, $this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeDetector$$ctx$f).detect__Lorg_yaml_model_YNode__s_Option(node);
      return xo.toList__sci_List()
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  return $as_sc_TraversableOnce(sequence.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2)).toList__sci_List()
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.detectTypeOrSchema__p1__Lorg_yaml_model_YMap__s_Option = (function(map) {
  var this$1 = map.entries$3;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$1)) {
    var this$2 = this.typeOrSchema__Lorg_yaml_model_YMap__s_Option(map);
    if (this$2.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1 = this$2.get__O();
      var e = $as_Lorg_yaml_model_YMapEntry(arg1);
      var x$1 = this.parent$1;
      var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("format");
      var this$7 = (this$4.isEmpty__Z() ? new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("format").asRamlAnnotation__T()) : this$4);
      if (this$7.isEmpty__Z()) {
        var x$2 = $m_s_None$()
      } else {
        var arg1$1 = this$7.get__O();
        var x$5 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
        var x$2 = new $c_s_Some().init___O(x$5.value$2.toString__T())
      };
      var x$4 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$();
      var result = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector().init___T__s_Option__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(x$1, x$2, x$4, true, this.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeDetector$$ctx$f).detect__Lorg_yaml_model_YNode__s_Option(e.value$2);
      var rc6 = false;
      var x2 = null;
      if ((result instanceof $c_s_Some)) {
        rc6 = true;
        x2 = $as_s_Some(result);
        var t = $as_Lamf_plugins_domain_shapes_models_TypeDef(x2.value$2);
        var x$6 = $m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$();
        if (((t !== null) && (t === x$6))) {
          var jsx$1 = true
        } else {
          var x$8 = $m_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$();
          if (((t !== null) && (t === x$8))) {
            var jsx$1 = (e.value$2.toString__T() !== "any")
          } else {
            var jsx$1 = false
          }
        };
        if (jsx$1) {
          return $m_s_None$()
        }
      };
      if (rc6) {
        var other = $as_Lamf_plugins_domain_shapes_models_TypeDef(x2.value$2);
        return new $c_s_Some().init___O(other)
      };
      var x$9 = $m_s_None$();
      if ((x$9 === result)) {
        return result
      };
      throw new $c_s_MatchError().init___O(result)
    }
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.detectAnyOf__p1__Lorg_yaml_model_YMap__s_Option = (function(map) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("anyOf");
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    $as_Lorg_yaml_model_YMapEntry(arg1);
    return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$())
  }
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeDetector"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlTypeDetector;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeDetector", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeDetector;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.shape$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter.prototype.productPrefix__T = (function() {
  return "RamlTypeEntryEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter)) {
    var RamlTypeEntryEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter(x$1);
    if ((this.key$1 === RamlTypeEntryEmitter$1.key$1)) {
      var x = this.shape$1;
      var x$2 = RamlTypeEntryEmitter$1.shape$1;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$3 = this.ordering$1;
      var x$4 = RamlTypeEntryEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = RamlTypeEntryEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.shape$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var x$1 = this.shape$1;
  var x$2 = this.ordering$1;
  var x$3 = this.references$1;
  var x$4 = $m_sci_Nil$();
  var emitters = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x$1, x$2, x$4, x$3, false, this.spec$1).entries__sc_Seq();
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(emitters), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$5 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$5 < that) ? x$5 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter.prototype.init___T__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(key, shape, ordering, references, spec) {
  this.key$1 = key;
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.shape$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeEntryEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlTypeEntryEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeEntryEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter() {
  $c_O.call(this);
  this.variable$1 = null;
  this.ordering$1 = null;
  this.eh$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter.prototype.productPrefix__T = (function() {
  return "VariableEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter)) {
    var VariableEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter(x$1);
    var x = this.variable$1;
    var x$2 = VariableEmitter$1.variable$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = VariableEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.variable$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var this$1 = this.variable$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_VariableValueModel$().Name$1));
  var this$3 = this$2.option$1;
  var str = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = $m_s_Option$();
  var this$5 = this.variable$1;
  var this$6 = jsx$1.apply__O__s_Option($as_Lamf_core_model_domain_DataNode(this$5.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_VariableValueModel$().Value$1)));
  if (this$6.isEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var map = $m_Lorg_yaml_model_YMap$().empty$1;
    $m_Lorg_yaml_model_YNode$();
    var node = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1);
    v.builder$1.$$plus$eq__O__scm_ArrayBuffer(node)
  } else {
    var arg1 = this$6.get__O();
    var v$1 = $as_Lamf_core_model_domain_DataNode(arg1);
    new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler(v$1, this.ordering$1, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.eh$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v)
  };
  var this$12 = v.builder$1;
  var array = [key];
  if ((this$12.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$12.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$12, newSize);
  var len$1 = this$12.size0$6;
  var src = this$12.array$6;
  var dest = this$12.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$12.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$12.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter.prototype.init___Lamf_core_model_domain_templates_VariableValue__Lamf_core_emitter_SpecOrdering__Lamf_core_errorhandling_ErrorHandler = (function(variable, ordering, eh) {
  this.variable$1 = variable;
  this.ordering$1 = ordering;
  this.eh$1 = eh;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.variable$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.VariableEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.VariableEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.VariableEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_VariableEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.value$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter.prototype.productPrefix__T = (function() {
  return "EnumValuesEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter)) {
    var EnumValuesEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter(x$1);
    if ((this.key$1 === EnumValuesEmitter$1.key$1)) {
      var x = this.value$1;
      var x$2 = EnumValuesEmitter$1.value$1;
      var jsx$1 = (x === x$2)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.ordering$1;
      var x$4 = EnumValuesEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.value$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var nodes = $as_Lamf_core_model_domain_AmfArray(this.value$1.value$1).values$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(d$2) {
      var d = $as_Lamf_core_model_domain_DataNode(d$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler(d, $this.ordering$1, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), $this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler())
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  var emitters = $as_sc_Seq(nodes.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(emitters), b$1);
  var jsx$2 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$2.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$8 = v.builder$1;
  var array = [key];
  if ((this$8.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$8.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$8, newSize);
  var len$1 = this$8.size0$6;
  var src = this$8.array$6;
  var dest = this$8.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$8.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$4 = j;
    var index = i;
    xs.set(jsx$4, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$8.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter.prototype.init___T__Lamf_core_parser_Value__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, value, ordering, spec) {
  this.key$1 = key;
  this.value$1 = value;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.EnumValuesEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.EnumValuesEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.EnumValuesEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.f$1 = null;
  this.ordering$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter.prototype.productPrefix__T = (function() {
  return "IriTemplateEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter)) {
    var IriTemplateEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter(x$1);
    if ((this.key$1 === IriTemplateEmitter$1.key$1)) {
      var x = this.f$1;
      var x$2 = IriTemplateEmitter$1.f$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.ordering$1;
      var x$4 = IriTemplateEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.f$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$2 = this.f$1.arrayValues__sc_Seq();
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(iriMapping$2) {
      var iriMapping = $as_Lamf_core_model_domain_AmfObject(iriMapping$2);
      var this$3 = iriMapping.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$().TemplateVariable$1);
      if (this$3.isEmpty__Z()) {
        var xo = $m_s_None$()
      } else {
        var arg1 = this$3.get__O();
        var variable = $as_Lamf_core_parser_FieldEntry(arg1);
        var this$4 = iriMapping.fields__Lamf_core_parser_Fields().entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$().LinkExpression$1);
        if (this$4.isEmpty__Z()) {
          var xo = $m_s_None$()
        } else {
          var arg1$1 = this$4.get__O();
          var link = $as_Lamf_core_parser_FieldEntry(arg1$1);
          var xo = new $c_s_Some().init___O(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option($as_Lamf_core_model_domain_AmfScalar(variable.value$1.value$1).toString__T(), link, $m_s_None$()))
        }
      };
      return xo.toList__sci_List()
    })
  })(this));
  var this$7 = $m_sc_Seq$();
  var emitters = $as_sc_Seq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(emitters), b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$10 = v.builder$1;
  var array = [key];
  if ((this$10.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$10.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$10, newSize);
  var len$1 = this$10.size0$6;
  var src = this$10.array$6;
  var dest = this$10.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$10.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$4 = j;
    var index = i;
    xs.set(jsx$4, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$10.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter.prototype.init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering = (function(key, f, ordering) {
  this.key$1 = key;
  this.f$1 = f;
  this.ordering$1 = ordering;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.IriTemplateEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.IriTemplateEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.IriTemplateEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.f$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter.prototype.productPrefix__T = (function() {
  return "XMLSerializerEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter)) {
    var XMLSerializerEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter(x$1);
    if ((this.key$1 === XMLSerializerEmitter$1.key$1)) {
      var x = this.f$1;
      var x$2 = XMLSerializerEmitter$1.f$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.ordering$1;
      var x$4 = XMLSerializerEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.f$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var value = this.f$1.value$1;
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var this$3 = this.f$1;
  var fs = $as_Lamf_core_model_domain_AmfObject(this$3.value$1.value$1).fields__Lamf_core_parser_Fields();
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Attribute$1);
  if (this$4.isEmpty__Z()) {
    var jsx$1 = true
  } else {
    var arg1 = this$4.get__O();
    var x$1 = $as_Lamf_core_parser_FieldEntry(arg1);
    var jsx$1 = x$1.value$1.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_ExplicitField.getClassOf())
  };
  if (jsx$1) {
    var this$5 = this$4
  } else {
    var this$5 = $m_s_None$()
  };
  if ((!this$5.isEmpty__Z())) {
    var arg1$1 = this$5.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("attribute", f, $m_s_None$())))
  };
  var this$7 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Wrapped$1);
  if (this$7.isEmpty__Z()) {
    var jsx$2 = true
  } else {
    var arg1$2 = this$7.get__O();
    var x$2 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    var jsx$2 = x$2.value$1.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_ExplicitField.getClassOf())
  };
  if (jsx$2) {
    var this$8 = this$7
  } else {
    var this$8 = $m_s_None$()
  };
  if ((!this$8.isEmpty__Z())) {
    var arg1$3 = this$8.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("wrapped", f$3, $m_s_None$())))
  };
  var this$10 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Name$1);
  if (this$10.isEmpty__Z()) {
    var jsx$3 = true
  } else {
    var arg1$4 = this$10.get__O();
    var x$3 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    var jsx$3 = x$3.value$1.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_ExplicitField.getClassOf())
  };
  if (jsx$3) {
    var this$11 = this$10
  } else {
    var this$11 = $m_s_None$()
  };
  if ((!this$11.isEmpty__Z())) {
    var arg1$5 = this$11.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$5);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("name", f$4, $m_s_None$())))
  };
  var this$13 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Namespace$1);
  if ((!this$13.isEmpty__Z())) {
    var arg1$6 = this$13.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$6);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("namespace", f$5, $m_s_None$())))
  };
  var this$15 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Prefix$1);
  if ((!this$15.isEmpty__Z())) {
    var arg1$7 = this$15.get__O();
    var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$7);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("prefix", f$6, $m_s_None$())))
  };
  var this$17 = this.f$1;
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext($as_Lamf_core_model_domain_DomainElement(this$17.value$1.value$1), this.ordering$1, this.spec$1).emitters__sc_Seq());
  var jsx$4 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$21 = v.builder$1;
  var array = [key];
  if ((this$21.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$21.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$21, newSize);
  var len$1 = this$21.size0$6;
  var src = this$21.array$6;
  var dest = this$21.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$21.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$4 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$4 < that) ? x$4 : that);
  while ((i < end)) {
    var jsx$5 = j;
    var index = i;
    xs.set(jsx$5, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$21.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter.prototype.init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, f, ordering, spec) {
  this.key$1 = key;
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.XMLSerializerEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.XMLSerializerEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.XMLSerializerEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_XMLSerializerEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.shape$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.mediaType$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter.prototype.productPrefix__T = (function() {
  return "AsyncSchemaEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter)) {
    var AsyncSchemaEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter(x$1);
    if ((this.key$1 === AsyncSchemaEmitter$1.key$1)) {
      var x = this.shape$1;
      var x$2 = AsyncSchemaEmitter$1.shape$1;
      var jsx$3 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$3 = this.ordering$1;
      var x$4 = AsyncSchemaEmitter$1.ordering$1;
      var jsx$2 = (x$3 === x$4)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.references$1;
      var x$6 = AsyncSchemaEmitter$1.references$1;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.mediaType$1;
      var x$8 = AsyncSchemaEmitter$1.mediaType$1;
      return ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.shape$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.references$1;
      break
    }
    case 4: {
      return this.mediaType$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var schemaVersion = $m_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncSchemaFormats$().getSchemaVersion__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion(this.mediaType$1, this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler());
  if ((schemaVersion instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RAML10SchemaVersion)) {
    this.emitAsRaml__p1__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
  } else {
    this.emitAsOas__p1__Lorg_yaml_model_YDocument$EntryBuilder__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__V(b, schemaVersion)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter.prototype.emitAsRaml__p1__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var x$1 = this.shape$1;
  var x$2 = this.ordering$1;
  var x$3 = this.references$1;
  var x$4 = $m_sci_Nil$();
  var spec = this.spec$1;
  var x$6 = new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(spec.eh__Lamf_core_errorhandling_ErrorHandler(), spec.refEmitter$1, new $c_Lamf_core_emitter_ShapeRenderOptions().init___());
  var emitters = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x$1, x$2, x$4, x$3, false, x$6).entries__sc_Seq();
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  emitters.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, eb) {
    return (function(x$2$2) {
      var x$2$1 = $as_Lamf_core_emitter_EntryEmitter(x$2$2);
      x$2$1.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(eb)
    })
  })(this, b$1)));
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$9 = v.builder$1;
  var array = [key];
  if ((this$9.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$9.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$9, newSize);
  var len$1 = this$9.size0$6;
  var src = this$9.array$6;
  var dest = this$9.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$9.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$5 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$5 < that) ? x$5 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$9.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter.prototype.init___T__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__s_Option__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(key, shape, ordering, references, mediaType, spec) {
  this.key$1 = key;
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.mediaType$1 = mediaType;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter.prototype.emitAsOas__p1__Lorg_yaml_model_YDocument$EntryBuilder__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__V = (function(b, schemaVersion) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var x$1 = this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler();
  var x$3 = $m_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$();
  var x$4 = new $c_Lamf_core_emitter_ShapeRenderOptions().init___();
  var newCtx = new $c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion(x$1, x$3, x$4, schemaVersion);
  var x$5 = this.shape$1;
  var x$6 = this.ordering$1;
  var x$7 = this.references$1;
  var x$8 = $m_sci_Nil$();
  var x$9 = $m_sci_Nil$();
  var x$10 = $m_sci_Nil$();
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x$5, x$6, x$8, x$7, x$9, x$10, newCtx).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
  var this$10 = v.builder$1;
  var array = [key];
  if ((this$10.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$10.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$10, newSize);
  var len$1 = this$10.size0$6;
  var src = this$10.array$6;
  var dest = this$10.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$10.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$2 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$2 < that) ? x$2 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$10.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.shape$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.async.AsyncSchemaEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.async.AsyncSchemaEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.async.AsyncSchemaEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_async_AsyncSchemaEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter() {
  $c_O.call(this);
  this.found$1 = null;
  this.fs$1 = null;
  this.ordering$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter.prototype.productPrefix__T = (function() {
  return "Oas3DiscriminatorEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter)) {
    var Oas3DiscriminatorEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter(x$1);
    var x = this.found$1;
    var x$2 = Oas3DiscriminatorEmitter$1.found$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.fs$1;
      var x$4 = Oas3DiscriminatorEmitter$1.fs$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.ordering$1;
      var x$6 = Oas3DiscriminatorEmitter$1.ordering$1;
      return (x$5 === x$6)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.found$1;
      break
    }
    case 1: {
      return this.fs$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("discriminator");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$3 = this.fs$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Discriminator$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("propertyName", f, $m_s_None$())))
  };
  var this$5 = this.fs$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().DiscriminatorMapping$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1$1 = this$5.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_IriTemplateEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering("mapping", f$3, this.ordering$1)))
  };
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$8 = v.builder$1;
  var array = [key];
  if ((this$8.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$8.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$8, newSize);
  var len$1 = this$8.size0$6;
  var src = this$8.array$6;
  var dest = this$8.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$8.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$8.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_parser_Fields__Lamf_core_emitter_SpecOrdering = (function(found, fs, ordering) {
  this.found$1 = found;
  this.fs$1 = fs;
  this.ordering$1 = ordering;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.found$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.Oas3DiscriminatorEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.Oas3DiscriminatorEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.Oas3DiscriminatorEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.pointer$1 = null;
  this.schemaPath$1 = null;
  this.spec$1 = null;
  this.emitters$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter.prototype.productPrefix__T = (function() {
  return "OasAndConstraintEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter)) {
    var OasAndConstraintEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter(x$1);
    var x = this.shape$1;
    var x$2 = OasAndConstraintEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasAndConstraintEmitter$1.ordering$1;
      var jsx$3 = (x$3 === x$4)
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$5 = this.references$1;
      var x$6 = OasAndConstraintEmitter$1.references$1;
      var jsx$2 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$7 = this.pointer$1;
      var x$8 = OasAndConstraintEmitter$1.pointer$1;
      var jsx$1 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$9 = this.schemaPath$1;
      var x$10 = OasAndConstraintEmitter$1.schemaPath$1;
      return ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    case 3: {
      return this.pointer$1;
      break
    }
    case 4: {
      return this.schemaPath$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("allOf");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$2 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  this.ordering$1.sorted__sc_Seq__sc_Seq(this.emitters$1).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$2) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter(x$2$2);
      x$2.emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$2)
    })
  })(this, b$1)));
  var jsx$1 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$2.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$3 = j;
    var index = i;
    xs.set(jsx$3, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var jsx$2 = this.emitters$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter(x$3$2);
      return x$3.position__Lamf_core_parser_Position()
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var this$3 = $as_sc_TraversableLike($as_sc_SeqLike(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).sortBy__F1__s_math_Ordering__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$4$2) {
      var x$4 = $as_Lamf_core_parser_Position(x$4$2);
      return x$4.line$1
    })
  })(this)), $m_s_math_Ordering$Int$())).headOption__s_Option();
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(shape, ordering, references, pointer, schemaPath, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.pointer$1 = pointer;
  this.schemaPath$1 = schemaPath;
  this.spec$1 = spec;
  var jsx$9 = $as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().And$1));
  var this$1 = $m_sc_Seq$();
  var jsx$8 = $as_sc_TraversableLike(jsx$9.zipWithIndex__scg_CanBuildFrom__O(this$1.ReusableCBFInstance$2));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var s = $as_Lamf_core_model_domain_Shape(x0$1.$$und1__O());
        var i = x0$1.$$und2$mcI$sp__I();
        if ((s !== null)) {
          var jsx$7 = $this.ordering$1;
          var jsx$6 = $m_sci_Nil$();
          var jsx$5 = $this.references$1;
          var jsx$4 = $this.pointer$1;
          var jsx$3 = $m_sc_Seq$();
          var array = ["allOf", ("" + i)];
          var jsx$2 = jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
          var this$4 = $m_sc_Seq$();
          return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(s, jsx$7, jsx$6, jsx$5, $as_sc_Seq(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$4.ReusableCBFInstance$2)), $this.schemaPath$1, $this.spec$1)
        }
      };
      throw new $c_s_MatchError().init___O(x0$1)
    })
  })(this));
  var this$5 = $m_sc_Seq$();
  this.emitters$1 = $as_sc_Seq(jsx$8.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2));
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasAndConstraintEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasAndConstraintEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasAndConstraintEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAndConstraintEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.pointer$1 = null;
  this.schemaPath$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter.prototype.productPrefix__T = (function() {
  return "OasAnyOfShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter)) {
    var OasAnyOfShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter(x$1);
    var x = this.shape$1;
    var x$2 = OasAnyOfShapeEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasAnyOfShapeEmitter$1.ordering$1;
      var jsx$3 = (x$3 === x$4)
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$5 = this.references$1;
      var x$6 = OasAnyOfShapeEmitter$1.references$1;
      var jsx$2 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$7 = this.pointer$1;
      var x$8 = OasAnyOfShapeEmitter$1.pointer$1;
      var jsx$1 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$9 = this.schemaPath$1;
      var x$10 = OasAnyOfShapeEmitter$1.schemaPath$1;
      return ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    case 3: {
      return this.pointer$1;
      break
    }
    case 4: {
      return this.schemaPath$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.spec$1.anyOfKey__T();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$11 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  var this$3 = this.shape$1;
  var jsx$9 = $as_sc_Seq(this$3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1));
  var this$4 = $m_sc_Seq$();
  var jsx$8 = $as_sc_TraversableLike(jsx$9.zipWithIndex__scg_CanBuildFrom__O(this$4.ReusableCBFInstance$2));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var s = $as_Lamf_core_model_domain_Shape(x0$1.$$und1__O());
        var i = x0$1.$$und2$mcI$sp__I();
        if ((s !== null)) {
          var jsx$7 = $this.ordering$1;
          var jsx$6 = $m_sci_Nil$();
          var jsx$5 = $this.references$1;
          var jsx$4 = $this.pointer$1;
          var jsx$3 = $m_sc_Seq$();
          var array = ["anyOf", ("" + i)];
          var jsx$2 = jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
          var this$7 = $m_sc_Seq$();
          return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(s, jsx$7, jsx$6, jsx$5, $as_sc_Seq(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$7.ReusableCBFInstance$2)), $this.schemaPath$1, $this.spec$1)
        }
      };
      throw new $c_s_MatchError().init___O(x0$1)
    })
  })(this));
  var this$8 = $m_sc_Seq$();
  var emitters = $as_sc_Seq(jsx$8.map__F1__scg_CanBuildFrom__O(jsx$1, this$8.ReusableCBFInstance$2));
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(emitters), b$1);
  var jsx$10 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$10.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$11.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$12 = v.builder$1;
  var array$1 = [key];
  if ((this$12.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array$1.length);
  var newSize = ((this$12.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$12, newSize);
  var len$1 = this$12.size0$6;
  var src = this$12.array$6;
  var dest = this$12.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$12.array$6;
  var len$2 = xs.u.length;
  var i$1 = 0;
  var j = 0;
  var x = $uI(array$1.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i$1 < end)) {
    var jsx$12 = j;
    var index = i$1;
    xs.set(jsx$12, array$1[index]);
    i$1 = ((1 + i$1) | 0);
    j = ((1 + j) | 0)
  };
  this$12.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(shape, ordering, references, pointer, schemaPath, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.pointer$1 = pointer;
  this.schemaPath$1 = schemaPath;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$1 = this.shape$1;
  var annotations = this$1.annotations$2;
  return this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasAnyOfShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasAnyOfShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasAnyOfShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.call(this);
  this.shape$3 = null;
  this.ordering$3 = null;
  this.references$3 = null;
  this.pointer$3 = null;
  this.schemaPath$3 = null;
  this.isHeader$3 = false;
  this.spec$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter.prototype.productPrefix__T = (function() {
  return "OasArrayShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter.prototype.productArity__I = (function() {
  return 6
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter)) {
    var OasArrayShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter(x$1);
    var x = this.shape$3;
    var x$2 = OasArrayShapeEmitter$1.shape$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$3;
      var x$4 = OasArrayShapeEmitter$1.ordering$3;
      var jsx$4 = (x$3 === x$4)
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      var x$5 = this.references$3;
      var x$6 = OasArrayShapeEmitter$1.references$3;
      var jsx$3 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$7 = this.pointer$3;
      var x$8 = OasArrayShapeEmitter$1.pointer$3;
      var jsx$2 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$9 = this.schemaPath$3;
      var x$10 = OasArrayShapeEmitter$1.schemaPath$3;
      var jsx$1 = ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.isHeader$3 === OasArrayShapeEmitter$1.isHeader$3)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$3;
      break
    }
    case 1: {
      return this.ordering$3;
      break
    }
    case 2: {
      return this.references$3;
      break
    }
    case 3: {
      return this.pointer$3;
      break
    }
    case 4: {
      return this.schemaPath$3;
      break
    }
    case 5: {
      return this.isHeader$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter.prototype.emitters__sc_Seq = (function() {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.prototype.emitters__sc_Seq.call(this)));
  var this$1 = this.shape$3;
  var fs = this$1.fields$2;
  result.$$plus$eq__O__scm_ListBuffer(this.spec$3.oasTypePropertyEmitter__T__Lamf_core_model_domain_Shape__Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter("array", this.shape$3));
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MaxItems$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("maxItems", f, $m_s_None$())))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MinItems$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("minItems", f$3, $m_s_None$())))
  };
  var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().UniqueItems$1);
  if ((!this$6.isEmpty__Z())) {
    var arg1$2 = this$6.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("uniqueItems", f$4, $m_s_None$())))
  };
  var x = this.spec$3.schemaVersion__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion();
  var x$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$();
  if (((x !== null) && x.equals__O__Z(x$2))) {
    var jsx$2 = $m_s_Option$();
    var this$8 = this.shape$3;
    var jsx$1 = jsx$2.apply__O__s_Option($as_Lamf_core_model_domain_Shape(this$8.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Contains$1))).isDefined__Z()
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var this$9 = this.shape$3;
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter().init___T__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext("contains", $as_Lamf_core_model_domain_Shape(this$9.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Contains$1)), this.ordering$3, this.references$3, this.pointer$3, this.schemaPath$3, this.spec$3))
  };
  var rc6 = false;
  var x2 = null;
  var x1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().CollectionFormat$1);
  matchEnd7: {
    if ((x1 instanceof $c_s_Some)) {
      rc6 = true;
      x2 = $as_s_Some(x1);
      var f$5 = $as_Lamf_core_parser_FieldEntry(x2.value$2);
      if (f$5.value$1.annotations$1.contains__jl_Class__Z($d_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems.getClassOf())) {
        result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter().init___Lamf_plugins_domain_shapes_models_ArrayShape__Lamf_core_emitter_SpecOrdering__sc_Seq__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.shape$3, this.ordering$3, this.references$3, new $c_s_Some().init___O(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("collectionFormat", f$5, $m_s_None$())), this.pointer$3, this.schemaPath$3, this.spec$3));
        break matchEnd7
      }
    };
    if (rc6) {
      var f$6 = $as_Lamf_core_parser_FieldEntry(x2.value$2);
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter().init___Lamf_plugins_domain_shapes_models_ArrayShape__Lamf_core_emitter_SpecOrdering__sc_Seq__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.shape$3, this.ordering$3, this.references$3, $m_s_None$(), this.pointer$3, this.schemaPath$3, this.spec$3)).$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("collectionFormat", f$6, $m_s_None$()));
      break matchEnd7
    };
    var x$3 = $m_s_None$();
    if ((x$3 === x1)) {
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter().init___Lamf_plugins_domain_shapes_models_ArrayShape__Lamf_core_emitter_SpecOrdering__sc_Seq__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.shape$3, this.ordering$3, this.references$3, $m_s_None$(), this.pointer$3, this.schemaPath$3, this.spec$3));
      break matchEnd7
    };
    throw new $c_s_MatchError().init___O(x1)
  };
  var this$12 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Inherits$1);
  if ((!this$12.isEmpty__Z())) {
    var arg1$3 = this$12.get__O();
    var f$7 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(f$7, this.ordering$3, this.references$3, this.spec$3)))
  };
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.shape$3, this.ordering$3, this.spec$3).emitters__sc_Seq());
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_ArrayShape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(shape, ordering, references, pointer, schemaPath, isHeader, spec) {
  this.shape$3 = shape;
  this.ordering$3 = ordering;
  this.references$3 = references;
  this.pointer$3 = pointer;
  this.schemaPath$3 = schemaPath;
  this.isHeader$3 = isHeader;
  this.spec$3 = spec;
  var x$5 = $m_sci_Nil$();
  var x$6 = $m_sci_Nil$();
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.call(this, shape, ordering, references, x$5, x$6, isHeader, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.shape$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ordering$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.references$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.pointer$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.schemaPath$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.isHeader$3 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 6)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasArrayShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasArrayShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasArrayShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasArrayShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.shape$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.pointer$1 = null;
  this.schemaPath$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter.prototype.productPrefix__T = (function() {
  return "OasEntryShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter.prototype.productArity__I = (function() {
  return 6
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter)) {
    var OasEntryShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter(x$1);
    if ((this.key$1 === OasEntryShapeEmitter$1.key$1)) {
      var x = this.shape$1;
      var x$2 = OasEntryShapeEmitter$1.shape$1;
      var jsx$4 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      var x$3 = this.ordering$1;
      var x$4 = OasEntryShapeEmitter$1.ordering$1;
      var jsx$3 = (x$3 === x$4)
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$5 = this.references$1;
      var x$6 = OasEntryShapeEmitter$1.references$1;
      var jsx$2 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$7 = this.pointer$1;
      var x$8 = OasEntryShapeEmitter$1.pointer$1;
      var jsx$1 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$9 = this.schemaPath$1;
      var x$10 = OasEntryShapeEmitter$1.schemaPath$1;
      return ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.shape$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.references$1;
      break
    }
    case 4: {
      return this.pointer$1;
      break
    }
    case 5: {
      return this.schemaPath$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var x$1 = this.shape$1;
  var x$2 = this.ordering$1;
  var x$3 = this.references$1;
  var jsx$2 = this.pointer$1;
  var jsx$1 = this.key$1;
  var this$3 = $m_sc_Seq$();
  var x$4 = $as_sc_Seq(jsx$2.$$colon$plus__O__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
  var x$5 = this.schemaPath$1;
  var x$6 = $m_sci_Nil$();
  var emitters = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x$1, x$2, x$6, x$3, x$4, x$5, false, this.spec$1).entries__sc_Seq();
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(emitters), b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$7 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$7 < that) ? x$7 : that);
  while ((i < end)) {
    var jsx$4 = j;
    var index = i;
    xs.set(jsx$4, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter.prototype.init___T__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(key, shape, ordering, references, pointer, schemaPath, spec) {
  this.key$1 = key;
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.pointer$1 = pointer;
  this.schemaPath$1 = schemaPath;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.shape$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasEntryShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasEntryShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasEntryShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.pointer$1 = null;
  this.customName$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter.prototype.productPrefix__T = (function() {
  return "OasNamedTypeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter)) {
    var OasNamedTypeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter(x$1);
    var x = this.shape$1;
    var x$2 = OasNamedTypeEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasNamedTypeEmitter$1.ordering$1;
      var jsx$3 = (x$3 === x$4)
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$5 = this.references$1;
      var x$6 = OasNamedTypeEmitter$1.references$1;
      var jsx$2 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$7 = this.pointer$1;
      var x$8 = OasNamedTypeEmitter$1.pointer$1;
      var jsx$1 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$9 = this.customName$1;
      var x$10 = OasNamedTypeEmitter$1.customName$1;
      return ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    case 3: {
      return this.pointer$1;
      break
    }
    case 4: {
      return this.customName$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.customName$1;
  if (this$1.isEmpty__Z()) {
    var this$2 = this.shape$1;
    var this$3 = $as_Lamf_core_model_StrField(this$2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
    var jsx$1 = $as_T((this$3.isEmpty__Z() ? "schema" : this$3.get__O()))
  } else {
    var jsx$1 = this$1.get__O()
  };
  var name = $as_T(jsx$1);
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(name);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var x$1$2 = this.shape$1;
  var x$2 = this.ordering$1;
  var x$3 = this.references$1;
  var jsx$2 = this.pointer$1;
  var this$5 = $m_sc_Seq$();
  var x$4 = $as_sc_Seq(jsx$2.$$colon$plus__O__scg_CanBuildFrom__O(name, this$5.ReusableCBFInstance$2));
  var x$5 = $m_sci_Nil$();
  var x$6 = $m_sci_Nil$();
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x$1$2, x$2, x$5, x$3, x$4, x$6, this.spec$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
  var this$10 = v.builder$1;
  var array = [key];
  if ((this$10.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$10.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$10, newSize);
  var len$1 = this$10.size0$6;
  var src = this$10.array$6;
  var dest = this$10.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$10.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$3 = j;
    var index = i;
    xs.set(jsx$3, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$10.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__s_Option__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(shape, ordering, references, pointer, customName, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.pointer$1 = pointer;
  this.customName$1 = customName;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.shape$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasNamedTypeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasNamedTypeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasNamedTypeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter() {
  $c_O.call(this);
  this.nil$1 = null;
  this.ordering$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter.prototype.productPrefix__T = (function() {
  return "OasNilShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_NilShape__Lamf_core_emitter_SpecOrdering = (function(nil, ordering) {
  this.nil$1 = nil;
  this.ordering$1 = ordering;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter)) {
    var OasNilShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter(x$1);
    var x = this.nil$1;
    var x$2 = OasNilShapeEmitter$1.nil$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasNilShapeEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.nil$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("type");
  $m_Lorg_yaml_model_YNode$();
  var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("null");
  b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$1 = this.nil$1;
  var annotations = this$1.annotations$2;
  return this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasNilShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasNilShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasNilShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNilShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.call(this);
  this.node$3 = null;
  this.ordering$3 = null;
  this.references$3 = null;
  this.pointer$3 = null;
  this.schemaPath$3 = null;
  this.isHeader$3 = false;
  this.spec$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter.prototype.productPrefix__T = (function() {
  return "OasNodeShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter.prototype.productArity__I = (function() {
  return 6
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter)) {
    var OasNodeShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter(x$1);
    var x = this.node$3;
    var x$2 = OasNodeShapeEmitter$1.node$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$3;
      var x$4 = OasNodeShapeEmitter$1.ordering$3;
      var jsx$4 = (x$3 === x$4)
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      var x$5 = this.references$3;
      var x$6 = OasNodeShapeEmitter$1.references$3;
      var jsx$3 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$7 = this.pointer$3;
      var x$8 = OasNodeShapeEmitter$1.pointer$3;
      var jsx$2 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$9 = this.schemaPath$3;
      var x$10 = OasNodeShapeEmitter$1.schemaPath$3;
      var jsx$1 = ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.isHeader$3 === OasNodeShapeEmitter$1.isHeader$3)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.node$3;
      break
    }
    case 1: {
      return this.ordering$3;
      break
    }
    case 2: {
      return this.references$3;
      break
    }
    case 3: {
      return this.pointer$3;
      break
    }
    case 4: {
      return this.schemaPath$3;
      break
    }
    case 5: {
      return this.isHeader$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter.prototype.emitters__sc_Seq = (function() {
  var isOas3 = (this.spec$3.schemaVersion__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion() instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.prototype.emitters__sc_Seq.call(this)));
  var this$1 = this.node$3;
  var fs = this$1.fields$2;
  result.$$plus$eq__O__scm_ListBuffer(this.spec$3.oasTypePropertyEmitter__T__Lamf_core_model_domain_Shape__Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter("object", this.node$3));
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MinProperties$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("minProperties", f, $m_s_None$())))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MaxProperties$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("maxProperties", f$3, $m_s_None$())))
  };
  var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1);
  if (this$6.isEmpty__Z()) {
    var jsx$1 = true
  } else {
    var arg1$2 = this$6.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    var jsx$1 = (f$4.value$1.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_ExplicitField.getClassOf()) || $as_Lamf_core_model_domain_AmfScalar(f$4.value$1.value$1).toBool__Z())
  };
  if (jsx$1) {
    var x1 = this$6
  } else {
    var x1 = $m_s_None$()
  };
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var f$5 = $as_Lamf_core_parser_FieldEntry(x2.value$2);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("additionalProperties", f$5.negated__Lamf_core_parser_FieldEntry(), $m_s_None$()))
  } else {
    var this$8 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().AdditionalPropertiesSchema$1);
    if ((!this$8.isEmpty__Z())) {
      var arg1$3 = this$8.get__O();
      var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$3);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter().init___T__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext("additionalProperties", $as_Lamf_core_model_domain_Shape(f$6.value$1.value$1), this.ordering$3, this.references$3, this.pointer$3, this.schemaPath$3, this.spec$3)))
    }
  };
  if (isOas3) {
    var this$9 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Discriminator$1);
    var this$10 = (this$9.isEmpty__Z() ? fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().DiscriminatorMapping$1) : this$9);
    if ((!this$10.isEmpty__Z())) {
      var arg1$4 = this$10.get__O();
      var f$7 = $as_Lamf_core_parser_FieldEntry(arg1$4);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_Oas3DiscriminatorEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_parser_Fields__Lamf_core_emitter_SpecOrdering(f$7, fs, this.ordering$3)))
    }
  } else {
    var this$11 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Discriminator$1);
    if ((!this$11.isEmpty__Z())) {
      var arg1$5 = this$11.get__O();
      var f$8 = $as_Lamf_core_parser_FieldEntry(arg1$5);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("discriminator", f$8, $m_s_None$())))
    }
  };
  var this$13 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().DiscriminatorValue$1);
  if ((!this$13.isEmpty__Z())) {
    var arg1$6 = this$13.get__O();
    var f$9 = $as_Lamf_core_parser_FieldEntry(arg1$6);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("discriminatorValue").asOasExtension__T(), f$9, $m_s_None$())))
  };
  var this$16 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1);
  if ((!this$16.isEmpty__Z())) {
    var arg1$7 = this$16.get__O();
    var f$10 = $as_Lamf_core_parser_FieldEntry(arg1$7);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter().init___Lamf_core_parser_FieldEntry__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(f$10, this.references$3, this.spec$3)))
  };
  var this$17 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1);
  if ((!this$17.isEmpty__Z())) {
    var arg1$8 = this$17.get__O();
    var f$11 = $as_Lamf_core_parser_FieldEntry(arg1$8);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(f$11, this.ordering$3, this.references$3, this.pointer$3, this.schemaPath$3, this.spec$3)))
  };
  var jsx$4 = $m_sci_ListMap$();
  var this$18 = this.node$3;
  var jsx$3 = $as_sc_Seq(this$18.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1));
  var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$11$1) {
    return (function(p$2) {
      var p = $as_Lamf_core_model_domain_extensions_PropertyShape(p$2);
      var self = p.id$1;
      return new $c_T2().init___O__O(self, p)
    })
  })(this));
  var this$21 = $m_sc_Seq$();
  var properties = $as_sci_ListMap(jsx$4.apply__sc_Seq__sc_GenMap($as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$21.ReusableCBFInstance$2))));
  var this$22 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Dependencies$1);
  if ((!this$22.isEmpty__Z())) {
    var arg1$9 = this$22.get__O();
    var f$12 = $as_Lamf_core_parser_FieldEntry(arg1$9);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sci_ListMap(f$12, this.ordering$3, properties)))
  };
  var this$23 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Inherits$1);
  if ((!this$23.isEmpty__Z())) {
    var arg1$10 = this$23.get__O();
    var f$13 = $as_Lamf_core_parser_FieldEntry(arg1$10);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(f$13, this.ordering$3, this.references$3, this.spec$3)))
  };
  var x = this.spec$3.schemaVersion__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion();
  var x$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$();
  if (((x !== null) && x.equals__O__Z(x$2))) {
    var jsx$6 = $m_s_Option$();
    var this$24 = this.node$3;
    var jsx$5 = jsx$6.apply__O__s_Option($as_Lamf_core_model_domain_Shape(this$24.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().PropertyNames$1))).isDefined__Z()
  } else {
    var jsx$5 = false
  };
  if (jsx$5) {
    var this$25 = this.node$3;
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter().init___T__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext("propertyNames", $as_Lamf_core_model_domain_Shape(this$25.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().PropertyNames$1)), this.ordering$3, this.references$3, this.pointer$3, this.schemaPath$3, this.spec$3))
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_NodeShape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(node, ordering, references, pointer, schemaPath, isHeader, spec) {
  this.node$3 = node;
  this.ordering$3 = ordering;
  this.references$3 = references;
  this.pointer$3 = pointer;
  this.schemaPath$3 = schemaPath;
  this.isHeader$3 = isHeader;
  this.spec$3 = spec;
  var x$5 = $m_sci_Nil$();
  var x$6 = $m_sci_Nil$();
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.call(this, node, ordering, references, x$5, x$6, isHeader, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.node$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ordering$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.references$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.pointer$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.schemaPath$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.isHeader$3 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 6)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasNodeShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasNodeShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasNodeShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNodeShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.pointer$1 = null;
  this.schemaPath$1 = null;
  this.spec$1 = null;
  this.emitters$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter.prototype.productPrefix__T = (function() {
  return "OasOrConstraintEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter)) {
    var OasOrConstraintEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter(x$1);
    var x = this.shape$1;
    var x$2 = OasOrConstraintEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasOrConstraintEmitter$1.ordering$1;
      var jsx$3 = (x$3 === x$4)
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$5 = this.references$1;
      var x$6 = OasOrConstraintEmitter$1.references$1;
      var jsx$2 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$7 = this.pointer$1;
      var x$8 = OasOrConstraintEmitter$1.pointer$1;
      var jsx$1 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$9 = this.schemaPath$1;
      var x$10 = OasOrConstraintEmitter$1.schemaPath$1;
      return ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    case 3: {
      return this.pointer$1;
      break
    }
    case 4: {
      return this.schemaPath$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("anyOf");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$2 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  this.ordering$1.sorted__sc_Seq__sc_Seq(this.emitters$1).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$2) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter(x$2$2);
      x$2.emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$2)
    })
  })(this, b$1)));
  var jsx$1 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$2.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$3 = j;
    var index = i;
    xs.set(jsx$3, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var jsx$2 = this.emitters$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter(x$3$2);
      return x$3.position__Lamf_core_parser_Position()
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var this$3 = $as_sc_TraversableLike($as_sc_SeqLike(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).sortBy__F1__s_math_Ordering__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$4$2) {
      var x$4 = $as_Lamf_core_parser_Position(x$4$2);
      return x$4.line$1
    })
  })(this)), $m_s_math_Ordering$Int$())).headOption__s_Option();
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(shape, ordering, references, pointer, schemaPath, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.pointer$1 = pointer;
  this.schemaPath$1 = schemaPath;
  this.spec$1 = spec;
  var jsx$9 = $as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Or$1));
  var this$1 = $m_sc_Seq$();
  var jsx$8 = $as_sc_TraversableLike(jsx$9.zipWithIndex__scg_CanBuildFrom__O(this$1.ReusableCBFInstance$2));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var s = $as_Lamf_core_model_domain_Shape(x0$1.$$und1__O());
        var i = x0$1.$$und2$mcI$sp__I();
        if ((s !== null)) {
          var jsx$7 = $this.ordering$1;
          var jsx$6 = $m_sci_Nil$();
          var jsx$5 = $this.references$1;
          var jsx$4 = $this.pointer$1;
          var jsx$3 = $m_sc_Seq$();
          var array = ["anyOf", ("" + i)];
          var jsx$2 = jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
          var this$4 = $m_sc_Seq$();
          return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(s, jsx$7, jsx$6, jsx$5, $as_sc_Seq(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$4.ReusableCBFInstance$2)), $this.schemaPath$1, $this.spec$1)
        }
      };
      throw new $c_s_MatchError().init___O(x0$1)
    })
  })(this));
  var this$5 = $m_sc_Seq$();
  this.emitters$1 = $as_sc_Seq(jsx$8.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2));
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasOrConstraintEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasOrConstraintEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasOrConstraintEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasOrConstraintEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter() {
  $c_O.call(this);
  this.f$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.pointer$1 = null;
  this.schemaPath$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter.prototype.productPrefix__T = (function() {
  return "OasPropertiesShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(f, ordering, references, pointer, schemaPath, spec) {
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.pointer$1 = pointer;
  this.schemaPath$1 = schemaPath;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter)) {
    var OasPropertiesShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter(x$1);
    var x = this.f$1;
    var x$2 = OasPropertiesShapeEmitter$1.f$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasPropertiesShapeEmitter$1.ordering$1;
      var jsx$3 = (x$3 === x$4)
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$5 = this.references$1;
      var x$6 = OasPropertiesShapeEmitter$1.references$1;
      var jsx$2 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$7 = this.pointer$1;
      var x$8 = OasPropertiesShapeEmitter$1.pointer$1;
      var jsx$1 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$9 = this.schemaPath$1;
      var x$10 = OasPropertiesShapeEmitter$1.schemaPath$1;
      return ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.f$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    case 3: {
      return this.pointer$1;
      break
    }
    case 4: {
      return this.schemaPath$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.f$1;
  var properties = $as_Lamf_core_model_domain_AmfArray(this$1.value$1.value$1).values$1.partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_domain_AmfElement(x$1$2);
      var this$2 = $as_Lamf_core_model_domain_extensions_PropertyShape(x$1);
      return $as_Lamf_core_model_StrField(this$2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().PatternName$1)).option$1.isDefined__Z()
    })
  })(this)));
  var x1 = $as_sc_Seq(properties.$$und2__O());
  var x = $m_sci_Nil$();
  if ((!x.equals__O__Z(x1))) {
    this.emitProperties__p1__sc_Seq__T__Lorg_yaml_model_YDocument$EntryBuilder__V(x1, "properties", b)
  };
  var x1$2 = $as_sc_Seq(properties.$$und1__O());
  var x$3 = $m_sci_Nil$();
  if ((!x$3.equals__O__Z(x1$2))) {
    this.emitProperties__p1__sc_Seq__T__Lorg_yaml_model_YDocument$EntryBuilder__V(x1$2, "patternProperties", b)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter.prototype.emitProperties__p1__sc_Seq__T__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(properties, propertiesKey, b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(propertiesKey);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$2 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, propertiesKey$1) {
    return (function(v$2) {
      var v$1 = $as_Lamf_core_model_domain_AmfElement(v$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter().init___Lamf_core_model_domain_extensions_PropertyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__T__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext($as_Lamf_core_model_domain_extensions_PropertyShape(v$1), $this.ordering$1, $this.references$1, propertiesKey$1, $this.pointer$1, $this.schemaPath$1, $this.spec$1)
    })
  })(this, propertiesKey));
  var this$3 = $m_sc_Seq$();
  var result = $as_sc_Seq(properties.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$2.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$3 = j;
    var index = i;
    xs.set(jsx$3, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasPropertiesShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasPropertiesShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasPropertiesShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertiesShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter() {
  $c_O.call(this);
  this.property$1 = null;
  this.ordering$1 = null;
  this.properties$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter.prototype.productPrefix__T = (function() {
  return "OasPropertyDependenciesEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter)) {
    var OasPropertyDependenciesEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter(x$1);
    var x = this.property$1;
    var x$2 = OasPropertyDependenciesEmitter$1.property$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasPropertyDependenciesEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.properties$1;
      var x$6 = OasPropertyDependenciesEmitter$1.properties$1;
      return ((x$5 === null) ? (x$6 === null) : $f_sc_GenMapLike__equals__O__Z(x$5, x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.property$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.properties$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter.prototype.init___Lamf_plugins_domain_shapes_models_PropertyDependencies__Lamf_core_emitter_SpecOrdering__sci_ListMap = (function(property, ordering, properties) {
  this.property$1 = property;
  this.ordering$1 = ordering;
  this.properties$1 = properties;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var jsx$1 = this.properties$1;
  var this$1 = this.property$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$().PropertySource$1));
  var this$3 = this$2.option$1;
  var this$4 = jsx$1.get__O__s_Option($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())));
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var p = $as_Lamf_core_model_domain_extensions_PropertyShape(arg1);
    $m_Lorg_yaml_model_YNode$();
    var this$5 = $as_Lamf_core_model_StrField(p.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
    var this$6 = this$5.option$1;
    var str = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$8 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
    var this$9 = this.property$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$().PropertyTarget$1);
    if (this$9.isEmpty__Z()) {
      var targets = $m_s_None$()
    } else {
      var arg1$1 = this$9.get__O();
      var f = $as_Lamf_core_parser_FieldEntry(arg1$1);
      var jsx$3 = $as_Lamf_core_model_domain_AmfArray(f.value$1.value$1).scalars__sc_Seq();
      var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(iri$2) {
          var iri = $as_Lamf_core_model_domain_AmfScalar(iri$2);
          var this$10 = $this.properties$1.get__O__s_Option($objectToString(iri.value$1));
          if (this$10.isEmpty__Z()) {
            var xo = $m_s_None$()
          } else {
            var arg1$2 = this$10.get__O();
            var p$1 = $as_Lamf_core_model_domain_extensions_PropertyShape(arg1$2);
            var this$11 = $as_Lamf_core_model_StrField(p$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
            var this$12 = this$11.option$1;
            var xo = new $c_s_Some().init___O(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($as_T((this$12.isEmpty__Z() ? null : this$12.get__O())), iri.annotations$1))
          };
          return xo.toList__sci_List()
        })
      })(this));
      var this$14 = $m_sc_Seq$();
      var targets = new $c_s_Some().init___O($as_sc_Seq(jsx$3.flatMap__F1__scg_CanBuildFrom__O(jsx$2, this$14.ReusableCBFInstance$2)))
    };
    if ((!targets.isEmpty__Z())) {
      var arg1$3 = targets.get__O();
      var target = $as_sc_Seq(arg1$3);
      var jsx$6 = $m_Lamf_core_emitter_BaseEmitters_package$();
      var jsx$5 = this.ordering$1;
      var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
        return (function(t$2) {
          var t = $as_Lamf_core_model_domain_AmfScalar(t$2);
          return new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType(t, $m_Lorg_yaml_model_YType$().Str$1)
        })
      })(this));
      var this$16 = $m_sc_Seq$();
      jsx$6.traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V(jsx$5.sorted__sc_Seq__sc_Seq($as_sc_Seq(target.map__F1__scg_CanBuildFrom__O(jsx$4, this$16.ReusableCBFInstance$2))), b$1)
    };
    var jsx$7 = $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YSequence$();
    var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
    var parts = b$1.builder$1;
    var node = jsx$7.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
    jsx$8.$$plus$eq__O__scm_ArrayBuffer(node);
    var this$20 = v.builder$1;
    var array = [key];
    if ((this$20.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$20.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$20, newSize);
    var len$1 = this$20.size0$6;
    var src = this$20.array$6;
    var dest = this$20.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$20.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$9 = j;
      var index = i;
      xs.set(jsx$9, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$20.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.property$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasPropertyDependenciesEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasPropertyDependenciesEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasPropertyDependenciesEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter() {
  $c_O.call(this);
  this.recursive$1 = null;
  this.ordering$1 = null;
  this.schemaPath$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter.prototype.productPrefix__T = (function() {
  return "OasRecursiveShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter.prototype.init___Lamf_core_model_domain_RecursiveShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(recursive, ordering, schemaPath, spec) {
  this.recursive$1 = recursive;
  this.ordering$1 = ordering;
  this.schemaPath$1 = schemaPath;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter)) {
    var OasRecursiveShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter(x$1);
    var x = this.recursive$1;
    var x$2 = OasRecursiveShapeEmitter$1.recursive$1;
    if ((x === x$2)) {
      var x$3 = this.ordering$1;
      var x$4 = OasRecursiveShapeEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.schemaPath$1;
      var x$6 = OasRecursiveShapeEmitter$1.schemaPath$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.recursive$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.schemaPath$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.recursive$1;
  var x1 = $as_Lamf_core_model_StrField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_RecursiveShapeModel$().FixPoint$1)).option$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var id = $as_T(x2.value$2);
    var this$2 = this.findInPath__p1__T__s_Option(id);
    if (this$2.isEmpty__Z()) {
      var this$3 = this.recursive$1;
      var x1$1 = this$3.internalFixpointTarget$2;
      if ((x1$1 instanceof $c_s_Some)) {
        var x2$1 = $as_s_Some(x1$1);
        var shape = $as_Lamf_core_model_domain_Shape(x2$1.value$2);
        var this$4 = this.findInPath__p1__T__s_Option(shape.id$1);
        if (this$4.isEmpty__Z()) {
          var this$5 = this.recursive$1;
          var this$6 = this$5.internalFixpointTarget$2;
          if (this$6.isEmpty__Z()) {
            var pointer = $m_s_None$()
          } else {
            var arg1 = this$6.get__O();
            var x$1 = $as_Lamf_core_model_domain_Shape(arg1);
            var this$7 = $as_Lamf_core_model_StrField(x$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
            if (this$7.isEmpty__Z()) {
              var pointer = $m_s_None$()
            } else {
              var arg1$1 = this$7.get__O();
              var x$2 = $as_T(arg1$1);
              var pointer = new $c_s_Some().init___O((("#" + this.spec$1.schemasDeclarationsPath__T()) + x$2))
            }
          }
        } else {
          var pointer = this$4
        }
      } else {
        var x = $m_s_None$();
        if ((!(x === x1$1))) {
          throw new $c_s_MatchError().init___O(x1$1)
        };
        var pointer = $m_s_None$()
      }
    } else {
      var pointer = this$2
    }
  } else {
    var pointer = $m_s_None$()
  };
  if ((!pointer.isEmpty__Z())) {
    var arg1$2 = pointer.get__O();
    var p = $as_T(arg1$2);
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("$ref");
    $m_Lorg_yaml_model_YNode$();
    var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(p);
    b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter.prototype.findInPath__p1__T__s_Option = (function(id) {
  var jsx$1 = $m_sc_Seq$();
  var array = [new $c_jl_Character().init___C(94)];
  var extraneousChars = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  var rc9 = false;
  var x2 = null;
  var x1 = $as_sc_IterableLike(this.schemaPath$1.reverse__O()).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, id$1) {
    return (function(x$3$2) {
      var x$3 = $as_T2(x$3$2);
      var x = x$3.$$und1__O();
      return ((x === null) ? (id$1 === null) : $objectEquals(x, id$1))
    })
  })(this, id)));
  if ((x1 instanceof $c_s_Some)) {
    rc9 = true;
    x2 = $as_s_Some(x1);
    var p3 = $as_T2(x2.value$2);
    if ((p3 !== null)) {
      var pointer = $as_T(p3.$$und2__O());
      if (((pointer === "#") && (!(this.spec$1 instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext)))) {
        return $m_s_None$()
      }
    }
  };
  if (rc9) {
    var p6 = $as_T2(x2.value$2);
    if ((p6 !== null)) {
      var pointer$2 = $as_T(p6.$$und2__O());
      if ((!extraneousChars.forall__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, pointer$2$1) {
        return (function(x$4$2) {
          if ((x$4$2 === null)) {
            var x$4 = 0
          } else {
            var this$6 = $as_jl_Character(x$4$2);
            var x$4 = this$6.value$1
          };
          var this$10 = new $c_sci_StringOps().init___T(pointer$2$1);
          var elem = new $c_jl_Character().init___C(x$4);
          return $f_sc_SeqLike__contains__O__Z(this$10, elem)
        })
      })(this, pointer$2))))) {
        return new $c_s_Some().init___O(pointer$2)
      }
    }
  };
  return $m_s_None$()
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  return $m_Lamf_core_parser_Position$ZERO$()
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasRecursiveShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasRecursiveShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasRecursiveShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter() {
  $c_O.call(this);
  this.f$1 = null;
  this.references$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter.prototype.productPrefix__T = (function() {
  return "OasRequiredPropertiesShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter)) {
    var OasRequiredPropertiesShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter(x$1);
    var x = this.f$1;
    var x$2 = OasRequiredPropertiesShapeEmitter$1.f$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.references$1;
      var x$4 = OasRequiredPropertiesShapeEmitter$1.references$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.f$1;
      break
    }
    case 1: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.f$1;
  var requiredProperties = $as_sc_Seq($as_Lamf_core_model_domain_AmfArray(this$1.value$1.value$1).values$1.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_domain_AmfElement(x0$1$2);
      if ((x0$1 instanceof $c_Lamf_core_model_domain_extensions_PropertyShape)) {
        var x2 = $as_Lamf_core_model_domain_extensions_PropertyShape(x0$1);
        var this$2 = $as_Lamf_core_model_StrField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().PatternName$1));
        if ($f_Lamf_core_model_StrField__isNullOrEmpty__Z(this$2)) {
          var this$3 = $as_Lamf_core_model_IntField(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1));
          return ($f_Lamf_core_model_IntField__value__I(this$3) > 0)
        }
      };
      return false
    })
  })(this))));
  if (requiredProperties.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("required");
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$2 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
    requiredProperties.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, b$2) {
      return (function(x0$2$2) {
        var x0$2 = $as_Lamf_core_model_domain_AmfElement(x0$2$2);
        if ((x0$2 instanceof $c_Lamf_core_model_domain_extensions_PropertyShape)) {
          var x2$1 = $as_Lamf_core_model_domain_extensions_PropertyShape(x0$2);
          var this$6 = $as_Lamf_core_model_StrField(x2$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
          var this$7 = this$6.option$1;
          new $c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter().init___T__Lamf_core_parser_Annotations__Lorg_yaml_model_YType($as_T((this$7.isEmpty__Z() ? null : this$7.get__O())), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()), $m_Lorg_yaml_model_YType$().Str$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$2)
        } else {
          throw new $c_s_MatchError().init___O(x0$2)
        }
      })
    })(this, b$1)));
    var jsx$1 = $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YSequence$();
    var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
    var parts = b$1.builder$1;
    var node = jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
    jsx$2.$$plus$eq__O__scm_ArrayBuffer(node);
    var this$13 = v.builder$1;
    var array = [key];
    if ((this$13.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$13.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$13, newSize);
    var len$1 = this$13.size0$6;
    var src = this$13.array$6;
    var dest = this$13.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$13.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$3 = j;
      var index = i;
      xs.set(jsx$3, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$13.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter.prototype.init___Lamf_core_parser_FieldEntry__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(f, references, spec) {
  this.f$1 = f;
  this.references$1 = references;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasRequiredPropertiesShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasRequiredPropertiesShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasRequiredPropertiesShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRequiredPropertiesShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter() {
  $c_O.call(this);
  this.f$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter.prototype.productPrefix__T = (function() {
  return "OasSchemaEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter)) {
    var OasSchemaEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter(x$1);
    var x = this.f$1;
    var x$2 = OasSchemaEmitter$1.f$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasSchemaEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = OasSchemaEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.f$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var shape = $as_Lamf_core_model_domain_Shape(this.f$1.value$1.value$1);
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("schema");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var x$2 = this.ordering$1;
  var x$3 = this.references$1;
  var x$4 = $m_sci_Nil$();
  var x$5 = $m_sci_Nil$();
  var x$6 = $m_sci_Nil$();
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(shape, x$2, x$4, x$3, x$5, x$6, this.spec$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(f, ordering, references, spec) {
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasSchemaEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasSchemaEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasSchemaEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter() {
  $c_O.call(this);
  this.f$1 = null;
  this.ordering$1 = null;
  this.propertiesMap$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter.prototype.productPrefix__T = (function() {
  return "OasShapeDependenciesEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter)) {
    var OasShapeDependenciesEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter(x$1);
    var x = this.f$1;
    var x$2 = OasShapeDependenciesEmitter$1.f$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasShapeDependenciesEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.propertiesMap$1;
      var x$6 = OasShapeDependenciesEmitter$1.propertiesMap$1;
      return ((x$5 === null) ? (x$6 === null) : $f_sc_GenMapLike__equals__O__Z(x$5, x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.f$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.propertiesMap$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("dependencies");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var this$3 = this.f$1;
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(this$3.value$1.value$1).values$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(v$2) {
      var v$1 = $as_Lamf_core_model_domain_AmfElement(v$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyDependenciesEmitter().init___Lamf_plugins_domain_shapes_models_PropertyDependencies__Lamf_core_emitter_SpecOrdering__sci_ListMap($as_Lamf_plugins_domain_shapes_models_PropertyDependencies(v$1), $this.ordering$1, $this.propertiesMap$1)
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  var result = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2));
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$4 = j;
    var index = i;
    xs.set(jsx$4, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sci_ListMap = (function(f, ordering, propertiesMap) {
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.propertiesMap$1 = propertiesMap;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasShapeDependenciesEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasShapeDependenciesEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasShapeDependenciesEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeDependenciesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter() {
  $c_O.call(this);
  this.f$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter.prototype.productPrefix__T = (function() {
  return "OasShapeInheritsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter)) {
    var OasShapeInheritsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter(x$1);
    var x = this.f$1;
    var x$2 = OasShapeInheritsEmitter$1.f$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasShapeInheritsEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = OasShapeInheritsEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.f$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(f, ordering, references, spec) {
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.f$1;
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(this$1.value$1.value$1).values$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_domain_AmfElement(x$1$2);
      return $as_Lamf_core_model_domain_Shape(x$1)
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  var inherits = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("x-amf-merge");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$8 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  inherits.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, b$2) {
    return (function(s$2) {
      var s = $as_Lamf_core_model_domain_Shape(s$2);
      if (s.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf())) {
        var jsx$4 = $this$1.spec$1;
        var jsx$3 = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$();
        var this$5 = $as_Lamf_core_model_StrField(s.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
        var this$6 = this$5.option$1;
        jsx$4.ref__Lorg_yaml_model_YDocument$PartBuilder__T__V(b$2, jsx$3.appendDefinitionsPrefix__T__s_Option__T($as_T((this$6.isEmpty__Z() ? null : this$6.get__O())), new $c_s_Some().init___O($this$1.spec$1.vendor__Lamf_core_remote_Vendor())))
      } else if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(s).isDefined__Z()) {
        var jsx$6 = $this$1.spec$1;
        var jsx$5 = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$();
        var this$7 = $as_Lamf_core_model_StrField(s.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
        var this$8 = this$7.option$1;
        jsx$6.ref__Lorg_yaml_model_YDocument$PartBuilder__T__V(b$2, jsx$5.appendDefinitionsPrefix__T__s_Option__T($as_T((this$8.isEmpty__Z() ? null : this$8.get__O())), new $c_s_Some().init___O($this$1.spec$1.vendor__Lamf_core_remote_Vendor())))
      } else {
        var x$2 = $this$1.ordering$1;
        var x$3 = $this$1.references$1;
        var x$4 = $m_sci_Nil$();
        var x$5 = $m_sci_Nil$();
        var x$6 = $m_sci_Nil$();
        new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(s, x$2, x$4, x$3, x$5, x$6, $this$1.spec$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$2)
      }
    })
  })(this, b$1)));
  var jsx$7 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$7.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$8.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$15 = v.builder$1;
  var array = [key];
  if ((this$15.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$15.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$15, newSize);
  var len$1 = this$15.size0$6;
  var src = this$15.array$6;
  var dest = this$15.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$15.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$7 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$7 < that) ? x$7 : that);
  while ((i < end)) {
    var jsx$9 = j;
    var index = i;
    xs.set(jsx$9, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$15.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasShapeInheritsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasShapeInheritsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasShapeInheritsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter() {
  $c_O.call(this);
  this.array$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.additionalEntry$1 = null;
  this.pointer$1 = null;
  this.schemaPath$1 = null;
  this.spec$1 = null;
  this.itemEmitters$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter.prototype.productPrefix__T = (function() {
  return "OasTupleItemsShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter.prototype.productArity__I = (function() {
  return 6
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter)) {
    var OasTupleItemsShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter(x$1);
    var x = this.array$1;
    var x$2 = OasTupleItemsShapeEmitter$1.array$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasTupleItemsShapeEmitter$1.ordering$1;
      var jsx$4 = (x$3 === x$4)
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      var x$5 = this.references$1;
      var x$6 = OasTupleItemsShapeEmitter$1.references$1;
      var jsx$3 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$7 = this.additionalEntry$1;
      var x$8 = OasTupleItemsShapeEmitter$1.additionalEntry$1;
      var jsx$2 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$9 = this.pointer$1;
      var x$10 = OasTupleItemsShapeEmitter$1.pointer$1;
      var jsx$1 = ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$11 = this.schemaPath$1;
      var x$12 = OasTupleItemsShapeEmitter$1.schemaPath$1;
      return ((x$11 === null) ? (x$12 === null) : x$11.equals__O__Z(x$12))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.array$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    case 3: {
      return this.additionalEntry$1;
      break
    }
    case 4: {
      return this.pointer$1;
      break
    }
    case 5: {
      return this.schemaPath$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var jsx$1 = $m_s_Option$();
  var this$1 = this.array$1;
  if (jsx$1.apply__O__s_Option(this$1.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().TupleItems$2)).isDefined__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("items");
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$6 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
    this.itemEmitters$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, le) {
      return (function(emitter$2) {
        var emitter = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter(emitter$2);
        var jsx$3 = emitter.emitters__sc_Seq();
        var jsx$2 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter($this);
        var this$4 = $m_sc_Seq$();
        var allEmitters = $as_sc_Seq(jsx$3.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$2, this$4.ReusableCBFInstance$2));
        var jsx$4 = le.builder$1;
        var sourceName$1 = le.sourceName$2;
        var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
        allEmitters.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, o) {
          return (function(x$2$2) {
            var x$2 = $as_Lamf_core_emitter_EntryEmitter(x$2$2);
            x$2.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(o)
          })
        })($this, b$2)));
        jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1))
      })
    })(this, b$1)));
    var jsx$5 = $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YSequence$();
    var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
    var parts = b$1.builder$1;
    var node = jsx$5.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
    jsx$6.$$plus$eq__O__scm_ArrayBuffer(node);
    var this$9 = v.builder$1;
    var array = [key];
    if ((this$9.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$9.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$9, newSize);
    var len$1 = this$9.size0$6;
    var src = this$9.array$6;
    var dest = this$9.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$9.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$7 = j;
      var index = i;
      xs.set(jsx$7, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$9.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_TupleShape__Lamf_core_emitter_SpecOrdering__sc_Seq__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(array, ordering, references, additionalEntry, pointer, schemaPath, spec) {
  this.array$1 = array;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.additionalEntry$1 = additionalEntry;
  this.pointer$1 = pointer;
  this.schemaPath$1 = schemaPath;
  this.spec$1 = spec;
  var jsx$9 = $as_sc_Seq(array.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().TupleItems$2));
  var this$1 = $m_sc_Seq$();
  var jsx$8 = $as_sc_TraversableLike(jsx$9.zipWithIndex__scg_CanBuildFrom__O(this$1.ReusableCBFInstance$2));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var shape = $as_Lamf_core_model_domain_Shape(x0$1.$$und1__O());
        var i = x0$1.$$und2$mcI$sp__I();
        var jsx$7 = $this.ordering$1;
        var jsx$6 = $m_sci_Nil$();
        var jsx$5 = $this.references$1;
        var jsx$4 = $this.pointer$1;
        var jsx$3 = $m_sc_Seq$();
        var array$1 = ["items", ("" + i)];
        var jsx$2 = jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
        var this$4 = $m_sc_Seq$();
        return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(shape, jsx$7, jsx$6, jsx$5, $as_sc_Seq(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$4.ReusableCBFInstance$2)), $this.schemaPath$1, false, $this.spec$1)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this));
  var this$5 = $m_sc_Seq$();
  this.itemEmitters$1 = $as_sc_Seq(jsx$8.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2));
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var jsx$1 = $m_s_Option$();
  var this$1 = this.array$1;
  var x1 = jsx$1.apply__O__s_Option(this$1.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var value = $as_Lamf_core_parser_Value(x2.value$2);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = value.annotations$1;
    return this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
  } else {
    return $m_Lamf_core_parser_Position$ZERO$()
  }
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasTupleItemsShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasTupleItemsShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasTupleItemsShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.call(this);
  this.shape$3 = null;
  this.ordering$3 = null;
  this.references$3 = null;
  this.pointer$3 = null;
  this.schemaPath$3 = null;
  this.isHeader$3 = false;
  this.spec$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter.prototype.productPrefix__T = (function() {
  return "OasTupleShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter.prototype.productArity__I = (function() {
  return 6
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_TupleShape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(shape, ordering, references, pointer, schemaPath, isHeader, spec) {
  this.shape$3 = shape;
  this.ordering$3 = ordering;
  this.references$3 = references;
  this.pointer$3 = pointer;
  this.schemaPath$3 = schemaPath;
  this.isHeader$3 = isHeader;
  this.spec$3 = spec;
  var x$5 = $m_sci_Nil$();
  var x$6 = $m_sci_Nil$();
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.call(this, shape, ordering, references, x$5, x$6, isHeader, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter)) {
    var OasTupleShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter(x$1);
    var x = this.shape$3;
    var x$2 = OasTupleShapeEmitter$1.shape$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$3;
      var x$4 = OasTupleShapeEmitter$1.ordering$3;
      var jsx$4 = (x$3 === x$4)
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      var x$5 = this.references$3;
      var x$6 = OasTupleShapeEmitter$1.references$3;
      var jsx$3 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$7 = this.pointer$3;
      var x$8 = OasTupleShapeEmitter$1.pointer$3;
      var jsx$2 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$9 = this.schemaPath$3;
      var x$10 = OasTupleShapeEmitter$1.schemaPath$3;
      var jsx$1 = ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.isHeader$3 === OasTupleShapeEmitter$1.isHeader$3)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$3;
      break
    }
    case 1: {
      return this.ordering$3;
      break
    }
    case 2: {
      return this.references$3;
      break
    }
    case 3: {
      return this.pointer$3;
      break
    }
    case 4: {
      return this.schemaPath$3;
      break
    }
    case 5: {
      return this.isHeader$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter.prototype.emitters__sc_Seq = (function() {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.prototype.emitters__sc_Seq.call(this)));
  var this$1 = this.shape$3;
  var fs = this$1.fields$2;
  result.$$plus$eq__O__scm_ListBuffer(this.spec$3.oasTypePropertyEmitter__T__Lamf_core_model_domain_Shape__Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter("array", this.shape$3));
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MaxItems$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("maxItems", f, $m_s_None$())))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MinItems$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("minItems", f$3, $m_s_None$())))
  };
  var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().UniqueItems$1);
  if ((!this$6.isEmpty__Z())) {
    var arg1$2 = this$6.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("uniqueItems", f$4, $m_s_None$())))
  };
  var x1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().ClosedItems$2);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var f$5 = $as_Lamf_core_parser_FieldEntry(x2.value$2);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("additionalItems", f$5.negated__Lamf_core_parser_FieldEntry(), $m_s_None$()))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$9 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().AdditionalItemsSchema$2);
      if ((!this$9.isEmpty__Z())) {
        var arg1$3 = this$9.get__O();
        var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$3);
        new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasEntryShapeEmitter().init___T__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext("additionalItems", $as_Lamf_core_model_domain_Shape(f$6.value$1.value$1), this.ordering$3, this.references$3, this.pointer$3, this.schemaPath$3, this.spec$3)))
      }
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  var rc6 = false;
  var x2$2 = null;
  var x1$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().CollectionFormat$1);
  matchEnd7: {
    if ((x1$2 instanceof $c_s_Some)) {
      rc6 = true;
      x2$2 = $as_s_Some(x1$2);
      var f$7 = $as_Lamf_core_parser_FieldEntry(x2$2.value$2);
      if (f$7.value$1.annotations$1.contains__jl_Class__Z($d_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems.getClassOf())) {
        result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter().init___Lamf_plugins_domain_shapes_models_TupleShape__Lamf_core_emitter_SpecOrdering__sc_Seq__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.shape$3, this.ordering$3, this.references$3, new $c_s_Some().init___O(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("collectionFormat", f$7, $m_s_None$())), this.pointer$3, this.schemaPath$3, this.spec$3));
        break matchEnd7
      }
    };
    if (rc6) {
      var f$8 = $as_Lamf_core_parser_FieldEntry(x2$2.value$2);
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter().init___Lamf_plugins_domain_shapes_models_TupleShape__Lamf_core_emitter_SpecOrdering__sc_Seq__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.shape$3, this.ordering$3, this.references$3, $m_s_None$(), this.pointer$3, this.schemaPath$3, this.spec$3)).$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("collectionFormat", f$8, $m_s_None$()));
      break matchEnd7
    };
    var x$3 = $m_s_None$();
    if ((x$3 === x1$2)) {
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleItemsShapeEmitter().init___Lamf_plugins_domain_shapes_models_TupleShape__Lamf_core_emitter_SpecOrdering__sc_Seq__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.shape$3, this.ordering$3, this.references$3, $m_s_None$(), this.pointer$3, this.schemaPath$3, this.spec$3));
      break matchEnd7
    };
    throw new $c_s_MatchError().init___O(x1$2)
  };
  var this$12 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Inherits$1);
  if ((!this$12.isEmpty__Z())) {
    var arg1$4 = this$12.get__O();
    var f$9 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeInheritsEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(f$9, this.ordering$3, this.references$3, this.spec$3)))
  };
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.shape$3, this.ordering$3, this.spec$3).emitters__sc_Seq());
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.shape$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ordering$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.references$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.pointer$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.schemaPath$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.isHeader$3 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 6)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasTupleShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasTupleShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasTupleShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTupleShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.call(this);
  this.shape$3 = null;
  this.ordering$3 = null;
  this.references$3 = null;
  this.pointer$3 = null;
  this.schemaPath$3 = null;
  this.isHeader$3 = false;
  this.spec$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter.prototype.productPrefix__T = (function() {
  return "OasUnionShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(shape, ordering, references, pointer, schemaPath, isHeader, spec) {
  this.shape$3 = shape;
  this.ordering$3 = ordering;
  this.references$3 = references;
  this.pointer$3 = pointer;
  this.schemaPath$3 = schemaPath;
  this.isHeader$3 = isHeader;
  this.spec$3 = spec;
  var x$5 = $m_sci_Nil$();
  var x$6 = $m_sci_Nil$();
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.call(this, shape, ordering, references, x$5, x$6, isHeader, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter.prototype.productArity__I = (function() {
  return 6
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter)) {
    var OasUnionShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter(x$1);
    var x = this.shape$3;
    var x$2 = OasUnionShapeEmitter$1.shape$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$3;
      var x$4 = OasUnionShapeEmitter$1.ordering$3;
      var jsx$4 = (x$3 === x$4)
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      var x$5 = this.references$3;
      var x$6 = OasUnionShapeEmitter$1.references$3;
      var jsx$3 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$7 = this.pointer$3;
      var x$8 = OasUnionShapeEmitter$1.pointer$3;
      var jsx$2 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$9 = this.schemaPath$3;
      var x$10 = OasUnionShapeEmitter$1.schemaPath$3;
      var jsx$1 = ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.isHeader$3 === OasUnionShapeEmitter$1.isHeader$3)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$3;
      break
    }
    case 1: {
      return this.ordering$3;
      break
    }
    case 2: {
      return this.references$3;
      break
    }
    case 3: {
      return this.pointer$3;
      break
    }
    case 4: {
      return this.schemaPath$3;
      break
    }
    case 5: {
      return this.isHeader$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter.prototype.emitters__sc_Seq = (function() {
  var jsx$3 = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.prototype.emitters__sc_Seq.call(this);
  var jsx$2 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyOfShapeEmitter().init___Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.shape$3, this.ordering$3, this.references$3, this.pointer$3, this.schemaPath$3, this.spec$3)];
  var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
  var this$3 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.shape$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ordering$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.references$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.pointer$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.schemaPath$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.isHeader$3 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 6)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasUnionShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasUnionShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasUnionShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasUnionShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.pointer$1 = null;
  this.schemaPath$1 = null;
  this.spec$1 = null;
  this.emitters$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter.prototype.productPrefix__T = (function() {
  return "OasXoneConstraintEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter)) {
    var OasXoneConstraintEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter(x$1);
    var x = this.shape$1;
    var x$2 = OasXoneConstraintEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasXoneConstraintEmitter$1.ordering$1;
      var jsx$3 = (x$3 === x$4)
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$5 = this.references$1;
      var x$6 = OasXoneConstraintEmitter$1.references$1;
      var jsx$2 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$7 = this.pointer$1;
      var x$8 = OasXoneConstraintEmitter$1.pointer$1;
      var jsx$1 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$9 = this.schemaPath$1;
      var x$10 = OasXoneConstraintEmitter$1.schemaPath$1;
      return ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    case 3: {
      return this.pointer$1;
      break
    }
    case 4: {
      return this.schemaPath$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("oneOf");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$2 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  this.ordering$1.sorted__sc_Seq__sc_Seq(this.emitters$1).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$2) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter(x$2$2);
      x$2.emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$2)
    })
  })(this, b$1)));
  var jsx$1 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$2.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$3 = j;
    var index = i;
    xs.set(jsx$3, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var jsx$2 = this.emitters$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter(x$3$2);
      return x$3.position__Lamf_core_parser_Position()
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var this$3 = $as_sc_TraversableLike($as_sc_SeqLike(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).sortBy__F1__s_math_Ordering__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$4$2) {
      var x$4 = $as_Lamf_core_parser_Position(x$4$2);
      return x$4.line$1
    })
  })(this)), $m_s_math_Ordering$Int$())).headOption__s_Option();
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(shape, ordering, references, pointer, schemaPath, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.pointer$1 = pointer;
  this.schemaPath$1 = schemaPath;
  this.spec$1 = spec;
  var jsx$9 = $as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Xone$1));
  var this$1 = $m_sc_Seq$();
  var jsx$8 = $as_sc_TraversableLike(jsx$9.zipWithIndex__scg_CanBuildFrom__O(this$1.ReusableCBFInstance$2));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var s = $as_Lamf_core_model_domain_Shape(x0$1.$$und1__O());
        var i = x0$1.$$und2$mcI$sp__I();
        if ((s !== null)) {
          var jsx$7 = $this.ordering$1;
          var jsx$6 = $m_sci_Nil$();
          var jsx$5 = $this.references$1;
          var jsx$4 = $this.pointer$1;
          var jsx$3 = $m_sc_Seq$();
          var array = ["oneOf", ("" + i)];
          var jsx$2 = jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
          var this$4 = $m_sc_Seq$();
          return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(s, jsx$7, jsx$6, jsx$5, $as_sc_Seq(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$4.ReusableCBFInstance$2)), $this.schemaPath$1, $this.spec$1)
        }
      };
      throw new $c_s_MatchError().init___O(x0$1)
    })
  })(this));
  var this$5 = $m_sc_Seq$();
  this.emitters$1 = $as_sc_Seq(jsx$8.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2));
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasXoneConstraintEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasXoneConstraintEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasXoneConstraintEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasXoneConstraintEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null;
  this.emitters$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter.prototype.productPrefix__T = (function() {
  return "RamlAndConstraintEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter)) {
    var RamlAndConstraintEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter(x$1);
    var x = this.shape$1;
    var x$2 = RamlAndConstraintEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlAndConstraintEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = RamlAndConstraintEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = new $c_Lamf_core_utils_package$AmfStrings().init___T("and").asRamlAnnotation__T();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$2 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  this.ordering$1.sorted__sc_Seq__sc_Seq(this.emitters$1).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$2) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter(x$2$2);
      x$2.emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$2)
    })
  })(this, b$1)));
  var jsx$1 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$2.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$3 = j;
    var index = i;
    xs.set(jsx$3, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(shape, ordering, references, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  var jsx$2 = $as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().And$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(s$2) {
      var s = $as_Lamf_core_model_domain_Shape(s$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(s, $this.ordering$1, $m_s_None$(), $m_sci_Nil$(), $this.references$1, $this.spec$1)
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  this.emitters$1 = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var jsx$2 = this.emitters$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter(x$3$2);
      return x$3.position__Lamf_core_parser_Position()
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var this$3 = $as_sc_TraversableLike($as_sc_SeqLike(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).sortBy__F1__s_math_Ordering__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$4$2) {
      var x$4 = $as_Lamf_core_parser_Position(x$4$2);
      return x$4.line$1
    })
  })(this)), $m_s_math_Ordering$Int$())).headOption__s_Option();
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlAndConstraintEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlAndConstraintEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlAndConstraintEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAndConstraintEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter.prototype.productPrefix__T = (function() {
  return "RamlAnyOfShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter)) {
    var RamlAnyOfShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter(x$1);
    var x = this.shape$1;
    var x$2 = RamlAnyOfShapeEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlAnyOfShapeEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = RamlAnyOfShapeEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var x1 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$().inlinedEmission__Lamf_plugins_domain_shapes_models_UnionShape__s_Option(this.shape$1);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var e = $as_T(x2.value$2);
    this.emitUnionInlined__T__Lorg_yaml_model_YDocument$EntryBuilder__V(e, b)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      this.emitUnionExpanded__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter.prototype.emitUnionInlined__T__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(types, b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("type");
  $m_Lorg_yaml_model_YNode$();
  var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(types);
  b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(shape, ordering, references, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter.prototype.emitUnionExpanded__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("anyOf");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$4 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  var this$3 = this.shape$1;
  var jsx$2 = $as_sc_Seq(this$3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(s$2) {
      var s = $as_Lamf_core_model_domain_Shape(s$2);
      var x$2 = $this.ordering$1;
      var x$3 = $m_s_None$();
      var x$4 = $this.references$1;
      var x$5 = $m_sci_Nil$();
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(s, x$2, x$3, x$5, x$4, $this.spec$1)
    })
  })(this));
  var this$5 = $m_sc_Seq$();
  var emitters = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2));
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(emitters), b$1);
  var jsx$3 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$3.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$4.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$9 = v.builder$1;
  var array = [key];
  if ((this$9.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$9.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$9, newSize);
  var len$1 = this$9.size0$6;
  var src = this$9.array$6;
  var dest = this$9.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$9.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$5 = j;
    var index = i;
    xs.set(jsx$5, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$9.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$1 = this.shape$1;
  var annotations = this$1.fields$2.get__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1).annotations__Lamf_core_parser_Annotations();
  return this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlAnyOfShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlAnyOfShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlAnyOfShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.references$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter.prototype.productPrefix__T = (function() {
  return "RamlExternalSourceEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var this$1 = this.references$1;
  var pf = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter$$anonfun$emit$1().init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter(this);
  var this$2 = $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$1, pf);
  if (this$2.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var ex = $as_Lamf_core_model_domain_ExternalDomainElement(arg1);
    var this$3 = $as_Lamf_core_model_StrField(ex.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1)).option$1
  };
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var x$1 = $as_T(arg1$1);
    $m_Lamf_core_emitter_BaseEmitters_package$().raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(b, x$1, $m_Lorg_yaml_model_YType$().Str$1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter)) {
    var RamlExternalSourceEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter(x$1);
    var x = this.shape$1;
    var x$2 = RamlExternalSourceEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.references$1;
      var x$4 = RamlExternalSourceEmitter$1.references$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter.prototype.init___Lamf_core_model_domain_Shape__sc_Seq = (function(shape, references) {
  this.shape$1 = shape;
  this.references$1 = references;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.shape$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlExternalSourceEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlExternalSourceEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlExternalSourceEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlExternalSourceEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter.prototype.productPrefix__T = (function() {
  return "RamlInlinedAnyOfShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var x1 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionEmitterHelper$().inlinedEmission__Lamf_plugins_domain_shapes_models_UnionShape__s_Option(this.shape$1);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var e = $as_T(x2.value$2);
    b.$$plus$eq__T__V(e)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      this.emitUnionExpanded__Lorg_yaml_model_YDocument$PartBuilder__V(b)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter)) {
    var RamlInlinedAnyOfShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter(x$1);
    var x = this.shape$1;
    var x$2 = RamlInlinedAnyOfShapeEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlInlinedAnyOfShapeEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = RamlInlinedAnyOfShapeEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter.prototype.emitUnionExpanded__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$6 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("anyOf");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
  var jsx$4 = v.builder$1;
  var sourceName$1 = v.sourceName$2;
  var b$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$1);
  var this$4 = this.shape$1;
  var jsx$2 = $as_sc_Seq(this$4.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(s$2) {
      var s = $as_Lamf_core_model_domain_Shape(s$2);
      var x$2 = $this.ordering$1;
      var x$3 = $m_s_None$();
      var x$4 = $this.references$1;
      var x$5 = $m_sci_Nil$();
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(s, x$2, x$3, x$5, x$4, $this.spec$1)
    })
  })(this));
  var this$6 = $m_sc_Seq$();
  var emitters = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2));
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(emitters), b$2);
  var jsx$3 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$1);
  var parts = b$2.builder$1;
  var node = jsx$3.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$4.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$10 = v.builder$1;
  var array = [key];
  if ((this$10.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$10.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$10, newSize);
  var len$1 = this$10.size0$6;
  var src = this$10.array$6;
  var dest = this$10.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$10.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$5 = j;
    var index = i;
    xs.set(jsx$5, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$10.size0$6 = newSize;
  b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1));
  jsx$6.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(shape, ordering, references, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$1 = this.shape$1;
  var annotations = this$1.fields$2.get__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1).annotations__Lamf_core_parser_Annotations();
  return this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlInlinedAnyOfShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlInlinedAnyOfShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlInlinedAnyOfShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter() {
  $c_O.call(this);
  this.array$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter.prototype.productPrefix__T = (function() {
  return "RamlItemsShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter)) {
    var RamlItemsShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter(x$1);
    var x = this.array$1;
    var x$2 = RamlItemsShapeEmitter$1.array$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlItemsShapeEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = RamlItemsShapeEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.array$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.array$1;
  var x1 = $as_Lamf_core_model_domain_Shape(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1));
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x1);
    if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x2).isDefined__Z()) {
      $m_Lorg_yaml_model_YNode$();
      var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("items");
      var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
      new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x2, this.ordering$1, $m_s_None$(), $m_sci_Nil$(), this.references$1, this.spec$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
      var this$5 = v.builder$1;
      var array = [key];
      if ((this$5.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len = $uI(array.length);
      var newSize = ((this$5.size0$6 + len) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$5, newSize);
      var len$1 = this$5.size0$6;
      var src = this$5.array$6;
      var dest = this$5.array$6;
      $systemArraycopy(src, 0, dest, len, len$1);
      var xs = this$5.array$6;
      var len$2 = xs.u.length;
      var i = 0;
      var j = 0;
      var x = $uI(array.length);
      var x$1 = ((x < len$2) ? x : len$2);
      var that = xs.u.length;
      var end = ((x$1 < that) ? x$1 : that);
      while ((i < end)) {
        var jsx$1 = j;
        var index = i;
        xs.set(jsx$1, array[index]);
        i = ((1 + i) | 0);
        j = ((1 + j) | 0)
      };
      this$5.size0$6 = newSize;
      b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
    } else {
      $m_Lorg_yaml_model_YNode$();
      var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("items");
      var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
      var jsx$2 = v$1.builder$1;
      var sourceName = v$1.sourceName$2;
      var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
      var x$2 = this.ordering$1;
      var x$3 = this.references$1;
      var x$4 = $m_sci_Nil$();
      new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x2, x$2, x$4, x$3, false, this.spec$1).entries__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$2) {
        return (function(x$3$2$2) {
          var x$3$2 = $as_Lamf_core_emitter_EntryEmitter(x$3$2$2);
          x$3$2.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$2)
        })
      })(this, b$1)));
      jsx$2.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
      var this$21 = v$1.builder$1;
      var array$1 = [key$1];
      if ((this$21.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$3 = $uI(array$1.length);
      var newSize$1 = ((this$21.size0$6 + len$3) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$21, newSize$1);
      var len$4 = this$21.size0$6;
      var src$1 = this$21.array$6;
      var dest$1 = this$21.array$6;
      $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
      var xs$1 = this$21.array$6;
      var len$5 = xs$1.u.length;
      var i$1 = 0;
      var j$1 = 0;
      var x$5 = $uI(array$1.length);
      var x$6 = ((x$5 < len$5) ? x$5 : len$5);
      var that$1 = xs$1.u.length;
      var end$1 = ((x$6 < that$1) ? x$6 : that$1);
      while ((i$1 < end$1)) {
        var jsx$3 = j$1;
        var index$1 = i$1;
        xs$1.set(jsx$3, array$1[index$1]);
        i$1 = ((1 + i$1) | 0);
        j$1 = ((1 + j$1) | 0)
      };
      this$21.size0$6 = newSize$1;
      b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1))
    }
  } else if ((x1 instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
    var x3 = $as_Lamf_core_model_domain_RecursiveShape(x1);
    $m_Lorg_yaml_model_YNode$();
    var key$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("items");
    var v$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$4 = v$2.builder$1;
    var sourceName$1 = v$2.sourceName$2;
    var b$3 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
    var x$7 = this.ordering$1;
    var x$8 = this.references$1;
    var x$9 = $m_sci_Nil$();
    new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x3, x$7, x$9, x$8, false, this.spec$1).entries__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, b$4) {
      return (function(x$5$2) {
        var x$5$1 = $as_Lamf_core_emitter_EntryEmitter(x$5$2);
        x$5$1.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$4)
      })
    })(this, b$3)));
    jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$3.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1));
    var this$37 = v$2.builder$1;
    var array$2 = [key$2];
    if ((this$37.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$6 = $uI(array$2.length);
    var newSize$2 = ((this$37.size0$6 + len$6) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$37, newSize$2);
    var len$7 = this$37.size0$6;
    var src$2 = this$37.array$6;
    var dest$2 = this$37.array$6;
    $systemArraycopy(src$2, 0, dest$2, len$6, len$7);
    var xs$2 = this$37.array$6;
    var len$8 = xs$2.u.length;
    var i$2 = 0;
    var j$2 = 0;
    var x$10 = $uI(array$2.length);
    var x$11 = ((x$10 < len$8) ? x$10 : len$8);
    var that$2 = xs$2.u.length;
    var end$2 = ((x$11 < that$2) ? x$11 : that$2);
    while ((i$2 < end$2)) {
      var jsx$5 = j$2;
      var index$2 = i$2;
      xs$2.set(jsx$5, array$2[index$2]);
      i$2 = ((1 + i$2) | 0);
      j$2 = ((1 + j$2) | 0)
    };
    this$37.size0$6 = newSize$2;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$2.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_ArrayShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(array, ordering, references, spec) {
  this.array$1 = array;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$1 = this.array$1;
  var annotations = this$1.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1).annotations$1;
  return this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlItemsShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlItemsShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlItemsShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.typesEmitter$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter.prototype.productPrefix__T = (function() {
  return "RamlNamedTypeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__F5__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(shape, ordering, references, typesEmitter, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.typesEmitter$1 = typesEmitter;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter)) {
    var RamlNamedTypeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter(x$1);
    var x = this.shape$1;
    var x$2 = RamlNamedTypeEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlNamedTypeEmitter$1.ordering$1;
      var jsx$2 = (x$3 === x$4)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.references$1;
      var x$6 = RamlNamedTypeEmitter$1.references$1;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.typesEmitter$1;
      var x$8 = RamlNamedTypeEmitter$1.typesEmitter$1;
      return (x$7 === x$8)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    case 3: {
      return this.typesEmitter$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.shape$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
  var name = $as_T((this$2.isEmpty__Z() ? "schema" : this$2.get__O()));
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(name);
  var this$4 = this.shape$1;
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$4).isDefined__Z()) {
    var f = (function(this$2$1) {
      return (function(b$2$2) {
        var b$2 = $as_Lorg_yaml_model_YDocument$PartBuilder(b$2$2);
        this$2$1.emitLink__p1__Lorg_yaml_model_YDocument$PartBuilder__V(b$2)
      })
    })(this);
    var vf_$_f$2 = f
  } else {
    var f$1 = (function(this$3$1) {
      return (function(b$3$2) {
        var b$3 = $as_Lorg_yaml_model_YDocument$PartBuilder(b$3$2);
        this$3$1.emitInline__p1__Lorg_yaml_model_YDocument$PartBuilder__V(b$3)
      })
    })(this);
    var vf_$_f$2 = f$1
  };
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  vf_$_f$2(v);
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter.prototype.emitLink__p1__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var this$1 = this.shape$1;
  var this$2 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var l = $as_Lamf_core_model_domain_DomainElement(arg1);
    var jsx$1 = this.spec$1.factory__Lamf_plugins_document_webapi_contexts_SpecEmitterFactory().tagToReferenceEmitter__F3();
    var this$3 = this.shape$1;
    $as_Lamf_core_emitter_PartEmitter(jsx$1.apply__O__O__O__O(l, $as_Lamf_core_model_StrField(this$3.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1, this.references$1)).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter.prototype.emitInline__p1__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var x1 = this.shape$1;
  if ((x1 !== null)) {
    $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter(this.typesEmitter$1.apply__O__O__O__O__O__O(x1, this.ordering$1, $m_s_None$(), $m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()), this.references$1)).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b)
  } else {
    var this$3 = this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler();
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
    var node = this.shape$1.id$1;
    var property = $m_s_None$();
    var this$1 = this.shape$1;
    var lexical = this$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var this$2 = this.shape$1;
    var location = $f_Lamf_core_model_domain_ExternalSourceElement__location__s_Option(this$2);
    this$3.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "Cannot emit inline shape that doesnt support type expressions", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.shape$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlNamedTypeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlNamedTypeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlNamedTypeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.emitter$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter.prototype.productPrefix__T = (function() {
  return "RamlNotConstraintEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter)) {
    var RamlNotConstraintEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter(x$1);
    var x = this.shape$1;
    var x$2 = RamlNotConstraintEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlNotConstraintEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = RamlNotConstraintEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = new $c_Lamf_core_utils_package$AmfStrings().init___T("not").asRamlAnnotation__T();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  this.emitter$1.emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
  var this$5 = v.builder$1;
  var array = [key];
  if ((this$5.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$5.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$5, newSize);
  var len$1 = this$5.size0$6;
  var src = this$5.array$6;
  var dest = this$5.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$5.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$5.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(shape, ordering, references, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.emitter$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext($as_Lamf_plugins_domain_shapes_models_AnyShape($as_Lamf_core_model_domain_Shape(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Not$1))), ordering, $m_s_None$(), $m_sci_Nil$(), references, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  return this.emitter$1.position__Lamf_core_parser_Position()
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlNotConstraintEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlNotConstraintEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlNotConstraintEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNotConstraintEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null;
  this.emitters$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter.prototype.productPrefix__T = (function() {
  return "RamlOrConstraintEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter)) {
    var RamlOrConstraintEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter(x$1);
    var x = this.shape$1;
    var x$2 = RamlOrConstraintEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlOrConstraintEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = RamlOrConstraintEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = new $c_Lamf_core_utils_package$AmfStrings().init___T("or").asRamlAnnotation__T();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$2 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  this.ordering$1.sorted__sc_Seq__sc_Seq(this.emitters$1).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$2) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter(x$2$2);
      x$2.emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$2)
    })
  })(this, b$1)));
  var jsx$1 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$2.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$3 = j;
    var index = i;
    xs.set(jsx$3, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(shape, ordering, references, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  var jsx$2 = $as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Or$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(s$2) {
      var s = $as_Lamf_core_model_domain_Shape(s$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(s, $this.ordering$1, $m_s_None$(), $m_sci_Nil$(), $this.references$1, $this.spec$1)
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  this.emitters$1 = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var jsx$2 = this.emitters$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter(x$3$2);
      return x$3.position__Lamf_core_parser_Position()
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var this$3 = $as_sc_TraversableLike($as_sc_SeqLike(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).sortBy__F1__s_math_Ordering__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$4$2) {
      var x$4 = $as_Lamf_core_parser_Position(x$4$2);
      return x$4.line$1
    })
  })(this)), $m_s_math_Ordering$Int$())).headOption__s_Option();
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlOrConstraintEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlOrConstraintEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlOrConstraintEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlOrConstraintEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter() {
  $c_O.call(this);
  this.f$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter.prototype.productPrefix__T = (function() {
  return "RamlPropertiesShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter)) {
    var RamlPropertiesShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter(x$1);
    var x = this.f$1;
    var x$2 = RamlPropertiesShapeEmitter$1.f$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlPropertiesShapeEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = RamlPropertiesShapeEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.f$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("properties");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var this$3 = this.f$1;
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(this$3.value$1.value$1).values$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(v$2) {
      var v$1 = $as_Lamf_core_model_domain_AmfElement(v$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter().init___Lamf_core_model_domain_extensions_PropertyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext($as_Lamf_core_model_domain_extensions_PropertyShape(v$1), $this.ordering$1, $this.references$1, $this.spec$1)
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  var result = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2));
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$4 = j;
    var index = i;
    xs.set(jsx$4, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(f, ordering, references, spec) {
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlPropertiesShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlPropertiesShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlPropertiesShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter() {
  $c_O.call(this);
  this.property$1 = null;
  this.ordering$1 = null;
  this.properties$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter.prototype.productPrefix__T = (function() {
  return "RamlPropertyDependenciesEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter)) {
    var RamlPropertyDependenciesEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter(x$1);
    var x = this.property$1;
    var x$2 = RamlPropertyDependenciesEmitter$1.property$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlPropertyDependenciesEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.properties$1;
      var x$6 = RamlPropertyDependenciesEmitter$1.properties$1;
      return ((x$5 === null) ? (x$6 === null) : $f_sc_GenMapLike__equals__O__Z(x$5, x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.property$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.properties$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var jsx$1 = this.properties$1;
  var this$1 = this.property$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$().PropertySource$1));
  var this$3 = this$2.option$1;
  var this$4 = jsx$1.get__O__s_Option($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())));
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var p = $as_Lamf_core_model_domain_extensions_PropertyShape(arg1);
    $m_Lorg_yaml_model_YNode$();
    var this$5 = $as_Lamf_core_model_StrField(p.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
    var this$6 = this$5.option$1;
    var str = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var this$8 = this.property$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$().PropertyTarget$1);
    if (this$8.isEmpty__Z()) {
      var targets = $m_s_None$()
    } else {
      var arg1$1 = this$8.get__O();
      var f = $as_Lamf_core_parser_FieldEntry(arg1$1);
      var jsx$3 = $as_Lamf_core_model_domain_AmfArray(f.value$1.value$1).scalars__sc_Seq();
      var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(iri$2) {
          var iri = $as_Lamf_core_model_domain_AmfScalar(iri$2);
          var this$9 = $this.properties$1.get__O__s_Option($objectToString(iri.value$1));
          if (this$9.isEmpty__Z()) {
            var xo = $m_s_None$()
          } else {
            var arg1$2 = this$9.get__O();
            var p$1 = $as_Lamf_core_model_domain_extensions_PropertyShape(arg1$2);
            var this$10 = $as_Lamf_core_model_StrField(p$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
            var this$11 = this$10.option$1;
            var xo = new $c_s_Some().init___O(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($as_T((this$11.isEmpty__Z() ? null : this$11.get__O())), iri.annotations$1))
          };
          return xo.toList__sci_List()
        })
      })(this));
      var this$13 = $m_sc_Seq$();
      var targets = new $c_s_Some().init___O($as_sc_Seq(jsx$3.flatMap__F1__scg_CanBuildFrom__O(jsx$2, this$13.ReusableCBFInstance$2)))
    };
    if ((!targets.isEmpty__Z())) {
      var arg1$3 = targets.get__O();
      var target = $as_sc_Seq(arg1$3);
      var jsx$8 = v.builder$1;
      var sourceName = v.sourceName$2;
      var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
      var jsx$6 = $m_Lamf_core_emitter_BaseEmitters_package$();
      var jsx$5 = this.ordering$1;
      var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
        return (function(t$2) {
          var t = $as_Lamf_core_model_domain_AmfScalar(t$2);
          return new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType(t, $m_Lorg_yaml_model_YType$().Str$1)
        })
      })(this));
      var this$16 = $m_sc_Seq$();
      jsx$6.traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V(jsx$5.sorted__sc_Seq__sc_Seq($as_sc_Seq(target.map__F1__scg_CanBuildFrom__O(jsx$4, this$16.ReusableCBFInstance$2))), b$1);
      var jsx$7 = $m_Lorg_yaml_model_YNode$();
      $m_Lorg_yaml_model_YSequence$();
      var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
      var parts = b$1.builder$1;
      var node = jsx$7.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
      jsx$8.$$plus$eq__O__scm_ArrayBuffer(node)
    };
    var this$20 = v.builder$1;
    var array = [key];
    if ((this$20.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$20.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$20, newSize);
    var len$1 = this$20.size0$6;
    var src = this$20.array$6;
    var dest = this$20.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$20.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$9 = j;
      var index = i;
      xs.set(jsx$9, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$20.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter.prototype.init___Lamf_plugins_domain_shapes_models_PropertyDependencies__Lamf_core_emitter_SpecOrdering__sci_ListMap__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(property, ordering, properties, spec) {
  this.property$1 = property;
  this.ordering$1 = ordering;
  this.properties$1 = properties;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.property$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlPropertyDependenciesEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlPropertyDependenciesEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlPropertyDependenciesEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter() {
  $c_O.call(this);
  this.property$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter.prototype.productPrefix__T = (function() {
  return "RamlPropertyShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter)) {
    var RamlPropertyShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter(x$1);
    var x = this.property$1;
    var x$2 = RamlPropertyShapeEmitter$1.property$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlPropertyShapeEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = RamlPropertyShapeEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.property$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter.prototype.init___Lamf_core_model_domain_extensions_PropertyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(property, ordering, references, spec) {
  this.property$1 = property;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var fs = this.property$1.fields$2;
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1);
  if (this$1.isEmpty__Z()) {
    var this$15 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    if ((($uI($as_Lamf_core_model_domain_AmfScalar(f.value$1.value$1).value$1) === 0) && (!f.value$1.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_ExplicitField.getClassOf())))) {
      var this$2 = this.property$1;
      var this$3 = $as_Lamf_core_model_StrField(this$2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
      var this$4 = this$3.option$1;
      var jsx$1 = ($as_T((this$4.isEmpty__Z() ? null : this$4.get__O())) + "?")
    } else {
      var this$5 = this.property$1;
      if ($as_Lamf_core_model_StrField(this$5.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().PatternName$1)).option$1.isDefined__Z()) {
        var this$6 = this.property$1;
        var this$7 = $as_Lamf_core_model_StrField(this$6.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
        var this$8 = this$7.option$1;
        var jsx$2 = ($as_T((this$8.isEmpty__Z() ? null : this$8.get__O())) !== "//")
      } else {
        var jsx$2 = false
      };
      if (jsx$2) {
        var this$9 = this.property$1;
        var this$10 = $as_Lamf_core_model_StrField(this$9.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
        var this$11 = this$10.option$1;
        var jsx$1 = (("/" + $as_T((this$11.isEmpty__Z() ? null : this$11.get__O()))) + "/")
      } else {
        var this$12 = this.property$1;
        var this$13 = $as_Lamf_core_model_StrField(this$12.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
        var this$14 = this$13.option$1;
        var jsx$1 = $as_T((this$14.isEmpty__Z() ? null : this$14.get__O()))
      }
    };
    var this$15 = new $c_s_Some().init___O(jsx$1)
  };
  if (this$15.isEmpty__Z()) {
    var this$16 = this.property$1;
    var this$17 = $as_Lamf_core_model_StrField(this$16.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
    var this$18 = this$17.option$1;
    var jsx$3 = $as_T((this$18.isEmpty__Z() ? null : this$18.get__O()))
  } else {
    var jsx$3 = this$15.get__O()
  };
  var name = $as_T(jsx$3);
  var key = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YScalar$().apply__O__Lorg_yaml_model_YScalar(name), $m_Lorg_yaml_model_YType$().Str$1);
  var this$19 = this.property$1;
  if ($as_Lamf_core_model_domain_Shape(this$19.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1)).annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_SynthesizedField.getClassOf())) {
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    $m_Lamf_core_emitter_BaseEmitters_package$().raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(v, "", $m_Lorg_yaml_model_YType$().Null$1);
    var this$22 = v.builder$1;
    var array = [key];
    if ((this$22.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$22.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$22, newSize);
    var len$1 = this$22.size0$6;
    var src = this$22.array$6;
    var dest = this$22.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$22.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$4 = j;
      var index = i;
      xs.set(jsx$4, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$22.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  } else {
    var this$33 = this.property$1;
    var xo = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter().init___Lamf_core_model_domain_Shape__s_Option($as_Lamf_core_model_domain_Shape(this$33.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1)), this.property$1.fields$2.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1)).emitter__s_Option();
    var this$35 = xo.toList__sci_List();
    var this$36 = this.property$1;
    var x1 = $as_Lamf_core_model_domain_Shape(this$36.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1));
    if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
      var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x1);
      var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
      var x$2 = this.ordering$1;
      var x$3 = $m_s_None$();
      var x$4 = this.references$1;
      var x$5 = $m_sci_Nil$();
      var x1$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x2, x$2, x$3, x$5, x$4, this.spec$1).emitter$1;
      if ((x1$1 instanceof $c_s_util_Left)) {
        var x2$1 = $as_s_util_Left(x1$1);
        var p = $as_Lamf_core_emitter_PartEmitter(x2$1.value$2);
        p.emit__Lorg_yaml_model_YDocument$PartBuilder__V(v$1)
      } else if ((x1$1 instanceof $c_s_util_Right)) {
        var x3 = $as_s_util_Right(x1$1);
        var entries = $as_sc_Seq(x3.value$2);
        var jsx$7 = v$1.builder$1;
        var sourceName = v$1.sourceName$2;
        var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
        var jsx$6 = $m_Lamf_core_emitter_BaseEmitters_package$();
        var jsx$5 = this.ordering$1;
        var this$39 = $m_sc_Seq$();
        jsx$6.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$5.sorted__sc_Seq__sc_Seq($as_sc_Seq(entries.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this$35, this$39.ReusableCBFInstance$2))), b$1);
        jsx$7.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
      } else {
        throw new $c_s_MatchError().init___O(x1$1)
      };
      var this$42 = v$1.builder$1;
      var array$1 = [key];
      if ((this$42.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$3 = $uI(array$1.length);
      var newSize$1 = ((this$42.size0$6 + len$3) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$42, newSize$1);
      var len$4 = this$42.size0$6;
      var src$1 = this$42.array$6;
      var dest$1 = this$42.array$6;
      $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
      var xs$1 = this$42.array$6;
      var len$5 = xs$1.u.length;
      var i$1 = 0;
      var j$1 = 0;
      var x$6 = $uI(array$1.length);
      var x$7 = ((x$6 < len$5) ? x$6 : len$5);
      var that$1 = xs$1.u.length;
      var end$1 = ((x$7 < that$1) ? x$7 : that$1);
      while ((i$1 < end$1)) {
        var jsx$8 = j$1;
        var index$1 = i$1;
        xs$1.set(jsx$8, array$1[index$1]);
        i$1 = ((1 + i$1) | 0);
        j$1 = ((1 + j$1) | 0)
      };
      this$42.size0$6 = newSize$1;
      b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1))
    } else {
      var v$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
      var jsx$9 = v$2.builder$1;
      var sourceName$1 = v$2.sourceName$2;
      var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
      $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this$35, b$2);
      jsx$9.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1));
      var this$56 = v$2.builder$1;
      var array$2 = [key];
      if ((this$56.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$6 = $uI(array$2.length);
      var newSize$2 = ((this$56.size0$6 + len$6) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$56, newSize$2);
      var len$7 = this$56.size0$6;
      var src$2 = this$56.array$6;
      var dest$2 = this$56.array$6;
      $systemArraycopy(src$2, 0, dest$2, len$6, len$7);
      var xs$2 = this$56.array$6;
      var len$8 = xs$2.u.length;
      var i$2 = 0;
      var j$2 = 0;
      var x$8 = $uI(array$2.length);
      var x$9 = ((x$8 < len$8) ? x$8 : len$8);
      var that$2 = xs$2.u.length;
      var end$2 = ((x$9 < that$2) ? x$9 : that$2);
      while ((i$2 < end$2)) {
        var jsx$10 = j$2;
        var index$2 = i$2;
        xs$2.set(jsx$10, array$2[index$2]);
        i$2 = ((1 + i$2) | 0);
        j$2 = ((1 + j$2) | 0)
      };
      this$56.size0$6 = newSize$2;
      b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$2.builder$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.property$1.annotations$2;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlPropertyShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlPropertyShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlPropertyShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter.prototype.productPrefix__T = (function() {
  return "RamlRecursiveShapeTypeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter.prototype.init___Lamf_core_model_domain_RecursiveShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(shape, ordering, references, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter)) {
    var RamlRecursiveShapeTypeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter(x$1);
    var x = this.shape$1;
    var x$2 = RamlRecursiveShapeTypeEmitter$1.shape$1;
    if ((x === x$2)) {
      var x$3 = this.ordering$1;
      var x$4 = RamlRecursiveShapeTypeEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = RamlRecursiveShapeTypeEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeEmitter().init___Lamf_core_model_domain_RecursiveShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(this.shape$1, this.ordering$1, this.references$1, this.spec$1).emitters__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_emitter_EntryEmitter(x$1$2);
      x$1.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$1)
    })
  })(this, b)))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.shape$1.annotations$2;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlRecursiveShapeTypeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlRecursiveShapeTypeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlRecursiveShapeTypeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter.prototype.productPrefix__T = (function() {
  return "RamlSchemaShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var this$1 = this.shape$1;
  if ($as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).nonEmpty__Z()) {
    var this$2 = this.shape$1;
    var fs = this$2.fields$2;
    var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var shape = this.shape$1;
    var ordering = this.ordering$1;
    var references = this.references$1;
    var spec = this.spec$1;
    result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter().init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(shape, ordering, references, spec).emitters__sc_Seq());
    var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$().Raw$1);
    if ((!this$4.isEmpty__Z())) {
      var arg1 = this$4.get__O();
      var f = $as_Lamf_core_parser_FieldEntry(arg1);
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("type", f, $m_s_None$()))
    };
    var jsx$1 = b.builder$1;
    var sourceName = b.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
    jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  } else {
    var this$7 = this.shape$1;
    var x1 = $as_Lamf_core_model_StrField(this$7.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1)).option$1;
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var r = $as_T(x2.value$2);
      $m_Lamf_core_emitter_BaseEmitters_package$().raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(b, r, $m_Lorg_yaml_model_YType$().Str$1)
    } else {
      var x = $m_s_None$();
      if ((x === x1)) {
        var node = $m_Lorg_yaml_model_YNode$().Null$1;
        b.builder$1.$$plus$eq__O__scm_ArrayBuffer(node)
      } else {
        throw new $c_s_MatchError().init___O(x1)
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter)) {
    var RamlSchemaShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter(x$1);
    var x = this.shape$1;
    var x$2 = RamlSchemaShapeEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlSchemaShapeEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = RamlSchemaShapeEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_SchemaShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(shape, ordering, references, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$1 = this.shape$1;
  var annotations = this$1.annotations$2;
  return this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlSchemaShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlSchemaShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlSchemaShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlSchemaShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter() {
  $c_O.call(this);
  this.f$1 = null;
  this.ordering$1 = null;
  this.props$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter.prototype.productPrefix__T = (function() {
  return "RamlShapeDependenciesEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter)) {
    var RamlShapeDependenciesEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter(x$1);
    var x = this.f$1;
    var x$2 = RamlShapeDependenciesEmitter$1.f$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlShapeDependenciesEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.props$1;
      var x$6 = RamlShapeDependenciesEmitter$1.props$1;
      return ((x$5 === null) ? (x$6 === null) : $f_sc_GenMapLike__equals__O__Z(x$5, x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.f$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.props$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = new $c_Lamf_core_utils_package$AmfStrings().init___T("dependencies").asRamlAnnotation__T();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var this$4 = this.f$1;
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(this$4.value$1.value$1).values$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(v$2) {
      var v$1 = $as_Lamf_core_model_domain_AmfElement(v$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyDependenciesEmitter().init___Lamf_plugins_domain_shapes_models_PropertyDependencies__Lamf_core_emitter_SpecOrdering__sci_ListMap__Lamf_plugins_document_webapi_contexts_SpecEmitterContext($as_Lamf_plugins_domain_shapes_models_PropertyDependencies(v$1), $this.ordering$1, $this.props$1, $this.spec$1)
    })
  })(this));
  var this$5 = $m_sc_Seq$();
  var result = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2));
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$8 = v.builder$1;
  var array = [key];
  if ((this$8.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$8.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$8, newSize);
  var len$1 = this$8.size0$6;
  var src = this$8.array$6;
  var dest = this$8.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$8.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$4 = j;
    var index = i;
    xs.set(jsx$4, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$8.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sci_ListMap__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(f, ordering, props, spec) {
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.props$1 = props;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlShapeDependenciesEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlShapeDependenciesEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlShapeDependenciesEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter() {
  $c_O.call(this);
  this.f$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter.prototype.emitShape__p1__Lamf_core_model_domain_Shape__Lorg_yaml_model_YDocument$PartBuilder__V = (function(value, b) {
  matchEnd6: {
    if ((value instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
      var x2 = $as_Lamf_plugins_domain_shapes_models_UnionShape(value);
      if ((!$f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x2).isDefined__Z())) {
        new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter().init___Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x2, this.ordering$1, this.references$1, this.spec$1).partEmitters__Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters().emitAll__Lorg_yaml_model_YDocument$PartBuilder__V(b);
        break matchEnd6
      }
    };
    if ($is_Lamf_plugins_domain_shapes_models_ShapeHelpers(value)) {
      if ((value.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf()) || $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(value).isDefined__Z())) {
        this.emitDeclared__p1__Lamf_core_model_domain_Shape__Lorg_yaml_model_YDocument$PartBuilder__V(value, b);
        break matchEnd6
      }
    };
    if ((value instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
      var x4 = $as_Lamf_plugins_domain_shapes_models_AnyShape(value);
      var jsx$2 = b.builder$1;
      var sourceName = b.sourceName$2;
      var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
      var jsx$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
      var x$2 = this.ordering$1;
      var x$3 = this.references$1;
      var x$4 = $m_sci_Nil$();
      jsx$1.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x4, x$2, x$4, x$3, false, this.spec$1).entries__sc_Seq(), b$1);
      jsx$2.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
      break matchEnd6
    };
    var this$3 = this.spec$1;
    var this$4 = this$3.eh$1;
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
    var node = value.id$1;
    var property = $m_s_None$();
    var lexical = value.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var location = value.location__s_Option();
    this$4.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "Cannot emit for type shapes without WebAPI Shape support", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter.prototype.productPrefix__T = (function() {
  return "RamlShapeInheritsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter)) {
    var RamlShapeInheritsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter(x$1);
    var x = this.f$1;
    var x$2 = RamlShapeInheritsEmitter$1.f$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlShapeInheritsEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = RamlShapeInheritsEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.f$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter.prototype.emitDeclared__p1__Lamf_core_model_domain_Shape__Lorg_yaml_model_YDocument$PartBuilder__V = (function(shape, b) {
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(shape).isDefined__Z()) {
    this.spec$1.localReference__Lamf_core_model_domain_Linkable__Lamf_core_emitter_PartEmitter(shape).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b)
  } else {
    var jsx$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var this$1 = $as_Lamf_core_model_StrField(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
    var this$2 = this$1.option$1;
    jsx$1.raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(b, $as_T((this$2.isEmpty__Z() ? null : this$2.get__O())), $m_Lorg_yaml_model_YType$().Str$1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.f$1;
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(this$1.value$1.value$1).values$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_domain_AmfElement(x$1$2);
      return $as_Lamf_core_model_domain_Shape(x$1)
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  var values = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  var multiple = (values.size__I() > 1);
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("type");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  if (multiple) {
    var jsx$4 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
    values.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, l) {
      return (function(x$2$2) {
        var x$2 = $as_Lamf_core_model_domain_Shape(x$2$2);
        $this$1.emitShape__p1__Lamf_core_model_domain_Shape__Lorg_yaml_model_YDocument$PartBuilder__V(x$2, l)
      })
    })(this, b$1)));
    var jsx$3 = $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YSequence$();
    var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
    var parts = b$1.builder$1;
    var node = jsx$3.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
    jsx$4.$$plus$eq__O__scm_ArrayBuffer(node)
  } else {
    values.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, b$2) {
      return (function(x$3$2) {
        var x$3 = $as_Lamf_core_model_domain_Shape(x$3$2);
        this$2$1.emitShape__p1__Lamf_core_model_domain_Shape__Lorg_yaml_model_YDocument$PartBuilder__V(x$3, b$2)
      })
    })(this, v)))
  };
  var this$8 = v.builder$1;
  var array = [key];
  if ((this$8.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$8.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$8, newSize);
  var len$1 = this$8.size0$6;
  var src = this$8.array$6;
  var dest = this$8.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$8.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$4 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$4 < that) ? x$4 : that);
  while ((i < end)) {
    var jsx$5 = j;
    var index = i;
    xs.set(jsx$5, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$8.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(f, ordering, references, spec) {
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlShapeInheritsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlShapeInheritsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlShapeInheritsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeInheritsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter() {
  $c_O.call(this);
  this.item$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter.prototype.productPrefix__T = (function() {
  return "RamlTupleItemEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var x$1 = this.item$1;
  var x$2 = this.ordering$1;
  var x$3 = this.references$1;
  var x$4 = $m_sci_Nil$();
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x$1, x$2, x$4, x$3, false, this.spec$1).entries__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$1) {
    return (function(e$2) {
      var e = $as_Lamf_core_emitter_EntryEmitter(e$2);
      var jsx$1 = b$1.builder$1;
      var sourceName = b$1.sourceName$2;
      var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
      e.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$2);
      jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
    })
  })(this, b)))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter)) {
    var RamlTupleItemEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter(x$1);
    var x = this.item$1;
    var x$2 = RamlTupleItemEmitter$1.item$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlTupleItemEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = RamlTupleItemEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.item$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(item, ordering, references, spec) {
  this.item$1 = item;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.item$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlTupleItemEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlTupleItemEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlTupleItemEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter() {
  $c_O.call(this);
  this.tuple$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter.prototype.productPrefix__T = (function() {
  return "RamlTupleItemsShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter)) {
    var RamlTupleItemsShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter(x$1);
    var x = this.tuple$1;
    var x$2 = RamlTupleItemsShapeEmitter$1.tuple$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlTupleItemsShapeEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = RamlTupleItemsShapeEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.tuple$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_TupleShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(tuple, ordering, references, spec) {
  this.tuple$1 = tuple;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = new $c_Lamf_core_utils_package$AmfStrings().init___T("tuple").asRamlAnnotation__T();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$2 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  var this$4 = this.tuple$1;
  $as_sc_Seq(this$4.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().TupleItems$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$2) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_model_domain_Shape(x$2$2);
      new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x$2, $this.ordering$1, $this.references$1, $this.spec$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$2)
    })
  })(this, b$1)));
  var jsx$1 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$2.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$8 = v.builder$1;
  var array = [key];
  if ((this$8.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$8.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$8, newSize);
  var len$1 = this$8.size0$6;
  var src = this$8.array$6;
  var dest = this$8.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$8.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$3 = j;
    var index = i;
    xs.set(jsx$3, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$8.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$1 = this.tuple$1;
  var annotations = this$1.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().TupleItems$2).annotations$1;
  return this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlTupleItemsShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlTupleItemsShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlTupleItemsShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypeExpressionEmitter() {
  /*<skip>*/
}
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypeExpressionEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypeExpressionEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlTypeExpressionEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypeExpressionEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypeExpressionEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypeExpressionEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypeExpressionEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlTypeExpressionEmitter;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null;
  this.emitters$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter.prototype.productPrefix__T = (function() {
  return "RamlXoneConstraintEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter)) {
    var RamlXoneConstraintEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter(x$1);
    var x = this.shape$1;
    var x$2 = RamlXoneConstraintEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlXoneConstraintEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = RamlXoneConstraintEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = new $c_Lamf_core_utils_package$AmfStrings().init___T("xone").asRamlAnnotation__T();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$2 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  this.ordering$1.sorted__sc_Seq__sc_Seq(this.emitters$1).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$2) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter(x$2$2);
      x$2.emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$2)
    })
  })(this, b$1)));
  var jsx$1 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$2.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$3 = j;
    var index = i;
    xs.set(jsx$3, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(shape, ordering, references, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  var jsx$2 = $as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Xone$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(s$2) {
      var s = $as_Lamf_core_model_domain_Shape(s$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(s, $this.ordering$1, $m_s_None$(), $m_sci_Nil$(), $this.references$1, $this.spec$1)
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  this.emitters$1 = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var jsx$2 = this.emitters$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter(x$3$2);
      return x$3.position__Lamf_core_parser_Position()
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var this$3 = $as_sc_TraversableLike($as_sc_SeqLike(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)).sortBy__F1__s_math_Ordering__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$4$2) {
      var x$4 = $as_Lamf_core_parser_Position(x$4$2);
      return x$4.line$1
    })
  })(this)), $m_s_math_Ordering$Int$())).headOption__s_Option();
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlXoneConstraintEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlXoneConstraintEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlXoneConstraintEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlXoneConstraintEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser.call(this);
  this.entry$2 = null;
  this.producer$2 = null;
  this.collector$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser.prototype.productPrefix__T = (function() {
  return "AsyncEndpointParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function() {
  return $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(this.ctx$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser)) {
    var AsyncEndpointParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser(x$1);
    var x = this.entry$2;
    var x$2 = AsyncEndpointParser$1.entry$2;
    if ((x === x$2)) {
      var x$3 = this.producer$2;
      var x$4 = AsyncEndpointParser$1.producer$2;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.collector$2;
      var x$6 = AsyncEndpointParser$1.collector$2;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$2;
      break
    }
    case 1: {
      return this.producer$2;
      break
    }
    case 2: {
      return this.collector$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser.prototype.parseEndpointMap__Lamf_plugins_domain_webapi_models_EndPoint__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_EndPoint = (function(endpoint, map) {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser.prototype.parseEndpointMap__Lamf_plugins_domain_webapi_models_EndPoint__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_EndPoint.call(this, endpoint, map);
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("bindings");
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var node = entry.value$2;
    var errorHandler = $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(this.ctx$1);
    var bindings = $as_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings(new $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser().init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(new $c_Lamf_plugins_document_webapi_parser_spec_common_YNodeYMapEntryLike().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, errorHandler), endpoint.id$1, $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(this.ctx$1)).parse__Lamf_core_model_domain_NamedDomainElement());
    var field = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Bindings$1;
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(endpoint, field, bindings, annotations);
    new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(endpoint, map, $m_sci_Nil$(), $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(this.ctx$1)).parseOrphanNode__T__V("bindings")
  };
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Description$1;
  var iv = $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(this.ctx$1);
  jsx$1.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(endpoint));
  var this$7 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$8 = this$7.key__T__s_Option("parameters");
  if ((!this$8.isEmpty__Z())) {
    var arg1$1 = this$8.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var jsx$2 = endpoint.id$1;
    var this$9 = entry$3.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$1 = $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(this.ctx$1);
    var parameters = new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncParametersParser().init___T__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(jsx$2, $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$9, conversion, iv$1)), $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(this.ctx$1)).parse__sc_Seq();
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1;
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3.value$2);
    $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(endpoint, field$2, parameters, annotations$1)
  };
  var this$11 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var entries = this$11.regex__T__sc_Iterable("subscribe|publish");
  if (entries.nonEmpty__Z()) {
    var operations = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    entries.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, endpoint$2, operations$1) {
      return (function(entry$2) {
        var entry$1 = $as_Lorg_yaml_model_YMapEntry(entry$2);
        var this$12 = $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext($this.ctx$1);
        var operationParser = this$12.factory$5.operationParser__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser(entry$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, endpoint$2$1) {
          return (function(method$2) {
            var method = $as_T(method$2);
            return endpoint$2$1.withOperation__T__Lamf_plugins_domain_webapi_models_Operation(method)
          })
        })($this, endpoint$2)));
        return operations$1.$$plus$eq__O__scm_ListBuffer(operationParser.parse__Lamf_plugins_domain_webapi_models_Operation())
      })
    })(this, endpoint, operations)));
    var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1;
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(operations, new $c_Lamf_core_parser_Annotations().init___());
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(endpoint, field$3, value)
  };
  return endpoint
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__sci_List__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(entry, producer, collector, ctx) {
  this.entry$2 = entry;
  this.producer$2 = producer;
  this.collector$2 = collector;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__sci_List__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.call(this, entry, producer, collector, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.AsyncEndpointParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.AsyncEndpointParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.AsyncEndpointParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter() {
  $c_O.call(this);
  this.example$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null;
  this.entries$1 = null;
  this.emitters$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter.prototype.productPrefix__T = (function() {
  return "ExampleValuesEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var x1 = this.emitters$1;
  matchEnd5: {
    if ((x1 instanceof $c_s_util_Left)) {
      var x2 = $as_s_util_Left(x1);
      var p = $as_Lamf_core_emitter_PartEmitter(x2.value$2);
      p.emit__Lorg_yaml_model_YDocument$PartBuilder__V(b);
      break matchEnd5
    };
    if ((x1 instanceof $c_s_util_Right)) {
      var x3 = $as_s_util_Right(x1);
      var values = $as_sc_Seq(x3.value$2);
      if (values.nonEmpty__Z()) {
        var jsx$1 = b.builder$1;
        var sourceName = b.sourceName$2;
        var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
        $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(values), b$1);
        jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
        break matchEnd5
      }
    };
    new $c_Lamf_core_emitter_BaseEmitters_package$NullEmitter().init___Lamf_core_parser_Annotations(this.example$1.annotations$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter)) {
    var ExampleValuesEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter(x$1);
    var x = this.example$1;
    var x$2 = ExampleValuesEmitter$1.example$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = ExampleValuesEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.example$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter.prototype.init___Lamf_plugins_domain_shapes_models_Example__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(example, ordering, spec) {
  this.example$1 = example;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var fs = example.fields$1;
  $m_sci_List$();
  var array = [$m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Strict$1, $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Description$1, $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().DisplayName$1, $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().CustomDomainProperties__Lamf_core_metamodel_Field()];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var this$5 = result;
  var f$1 = (function($this, fs$1) {
    return (function(f$2) {
      var f = $as_Lamf_core_metamodel_Field(f$2);
      var x1 = fs$1.entry__Lamf_core_metamodel_Field__s_Option(f);
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var entry = $as_Lamf_core_parser_FieldEntry(x2.value$2);
        return (!entry.value$1.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_SynthesizedField.getClassOf()))
      } else {
        var x$1 = $m_s_None$();
        if ((x$1 === x1)) {
          return false
        } else {
          throw new $c_s_MatchError().init___O(x1)
        }
      }
    })
  })(this, fs);
  if ((this$5 !== null)) {
    var l = this$5;
    var l$1 = l;
    x: {
      var result$1;
      _noneIn: while (true) {
        if (l$1.isEmpty__Z()) {
          var result$1 = $m_sci_Nil$();
          break
        } else {
          var h = l$1.head__O();
          var t = $as_sci_List(l$1.tail__O());
          if (($uZ(f$1(h)) === false)) {
            l$1 = t;
            continue _noneIn
          };
          var start = l$1;
          var remaining = t;
          var remaining$1 = remaining;
          _allIn: while (true) {
            if (remaining$1.isEmpty__Z()) {
              var result$1 = start;
              break x
            } else {
              var x$2 = remaining$1.head__O();
              if (($uZ(f$1(x$2)) !== false)) {
                remaining$1 = $as_sci_List(remaining$1.tail__O());
                continue _allIn
              };
              var firstMiss = remaining$1;
              var newHead = new $c_sci_$colon$colon().init___O__sci_List(start.head__O(), $m_sci_Nil$());
              var toProcess = $as_sci_List(start.tail__O());
              var currentLast = newHead;
              while ((toProcess !== firstMiss)) {
                var newElem = new $c_sci_$colon$colon().init___O__sci_List(toProcess.head__O(), $m_sci_Nil$());
                currentLast.tl$5 = newElem;
                currentLast = newElem;
                toProcess = $as_sci_List(toProcess.tail__O())
              };
              var next = $as_sci_List(firstMiss.tail__O());
              var nextToCopy = next;
              while ((!next.isEmpty__Z())) {
                var head = next.head__O();
                if (($uZ(f$1(head)) !== false)) {
                  next = $as_sci_List(next.tail__O())
                } else {
                  while ((nextToCopy !== next)) {
                    var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy.head__O(), $m_sci_Nil$());
                    currentLast.tl$5 = newElem$2;
                    currentLast = newElem$2;
                    nextToCopy = $as_sci_List(nextToCopy.tail__O())
                  };
                  nextToCopy = $as_sci_List(next.tail__O());
                  next = $as_sci_List(next.tail__O())
                }
              };
              if ((!nextToCopy.isEmpty__Z())) {
                currentLast.tl$5 = nextToCopy
              };
              var result$1 = newHead;
              break x
            }
          }
        }
      }
    };
    var explicitFielMeta = result$1
  } else {
    $m_sci_List$();
    var b = new $c_scm_ListBuffer().init___();
    var these = this$5;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      if (($uZ(f$1(arg1)) !== false)) {
        b.$$plus$eq__O__scm_ListBuffer(arg1)
      };
      these = $as_sci_List(these.tail__O())
    };
    var explicitFielMeta = b.toList__sci_List()
  };
  var this$7 = fs.fieldsMeta__sci_List();
  inlinereturn$39: {
    var these$1 = this$7;
    while ((!these$1.isEmpty__Z())) {
      var arg1$1 = these$1.head__O();
      var x$21 = $as_Lamf_core_metamodel_Field(arg1$1);
      if ($f_sc_LinearSeqOptimized__contains__O__Z(explicitFielMeta, x$21)) {
        var jsx$1 = true;
        break inlinereturn$39
      };
      these$1 = $as_sc_LinearSeqOptimized(these$1.tail__O())
    };
    var jsx$1 = false
  };
  if (jsx$1) {
    var isExpanded = true
  } else {
    var this$8 = $as_Lamf_core_model_StrField(example.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1)).option$1;
    if ((!this$8.isEmpty__Z())) {
      var arg1$2 = this$8.get__O();
      var x$22 = $as_T(arg1$2);
      var isExpanded = ($uI(x$22.indexOf("value")) !== (-1))
    } else {
      var isExpanded = false
    }
  };
  if (isExpanded) {
    var this$12 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().DisplayName$1);
    if ((!this$12.isEmpty__Z())) {
      var arg1$3 = this$12.get__O();
      var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$3);
      results.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("displayName", f$3, $m_s_None$(), this.spec$1))
    };
    var this$14 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Description$1);
    if ((!this$14.isEmpty__Z())) {
      var arg1$4 = this$14.get__O();
      var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$4);
      results.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("description", f$4, $m_s_None$(), this.spec$1))
    };
    if ((fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Strict$1).isDefined__Z() && (!$as_Lamf_core_parser_FieldEntry(fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Strict$1).get__O()).value$1.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_SynthesizedField.getClassOf())))) {
      var this$16 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Strict$1);
      if ((!this$16.isEmpty__Z())) {
        var arg1$5 = this$16.get__O();
        var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$5);
        results.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("strict", f$5, $m_s_None$(), this.spec$1))
      }
    };
    var this$18 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1);
    if (this$18.isEmpty__Z()) {
      var this$19 = this.example$1;
      var this$20 = $as_Lamf_core_model_StrField(this$19.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1)).option$1;
      if ((!this$20.isEmpty__Z())) {
        var arg1$6 = this$20.get__O();
        var s = $as_T(arg1$6);
        results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter().init___T(s))
      }
    } else {
      var arg1$7 = this$18.get__O();
      var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$7);
      var this$21 = this.example$1;
      var x$2$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler($as_Lamf_core_model_domain_DataNode(this$21.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1)), this.ordering$1, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler());
      var this$23 = $m_Lamf_core_emitter_BaseEmitters_package$();
      var annotations = f$6.value$1.annotations$1;
      var x$3 = this$23.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf());
      var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
      results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position("value", x$2$1, x$4, x$3))
    };
    results.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(example, ordering, spec).emitters__sc_Seq())
  } else {
    var this$25 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1);
    if (this$25.isEmpty__Z()) {
      var this$26 = this.example$1;
      var this$27 = $as_Lamf_core_model_StrField(this$26.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1)).option$1;
      if ((!this$27.isEmpty__Z())) {
        var arg1$8 = this$27.get__O();
        var s$1 = $as_T(arg1$8);
        results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter().init___T(s$1))
      }
    } else {
      var arg1$9 = this$25.get__O();
      $as_Lamf_core_parser_FieldEntry(arg1$9);
      var this$28 = this.example$1;
      results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler($as_Lamf_core_model_domain_DataNode(this$28.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1)), this.ordering$1, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler()))
    }
  };
  this.entries$1 = results;
  var x1$1 = this.entries$1;
  matchEnd5: {
    var jsx$2;
    $m_sc_Seq$();
    var o8 = new $c_s_Some().init___O(x1$1);
    if (((o8.value$2 !== null) && ($as_sc_SeqLike(o8.value$2).lengthCompare__I__I(1) === 0))) {
      var p = $as_Lamf_core_emitter_Emitter($as_sc_SeqLike(o8.value$2).apply__I__O(0));
      if ($is_Lamf_core_emitter_PartEmitter(p)) {
        var x3 = $as_Lamf_core_emitter_PartEmitter(p);
        $m_s_package$();
        var jsx$2 = new $c_s_util_Left().init___O(x3);
        break matchEnd5
      }
    };
    if (x1$1.forall__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$11$1) {
      return (function(x$24$2) {
        var x$24 = $as_Lamf_core_emitter_Emitter(x$24$2);
        return $is_Lamf_core_emitter_EntryEmitter(x$24)
      })
    })(this)))) {
      $m_s_package$();
      var jsx$3 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter(this);
      var this$32 = $m_sc_Seq$();
      var value = x1$1.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$3, this$32.ReusableCBFInstance$2);
      var jsx$2 = new $c_s_util_Right().init___O(value);
      break matchEnd5
    };
    var this$34 = spec.eh__Lamf_core_errorhandling_ErrorHandler();
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
    var node = example.id$1;
    var property = $m_s_None$();
    var message = ("IllegalTypeDeclarations found: " + x1$1);
    var lexical = example.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var location = $f_Lamf_core_model_domain_ExternalSourceElement__location__s_Option(example);
    this$34.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
    $m_s_package$();
    var value$1 = $m_sci_Nil$();
    var jsx$2 = new $c_s_util_Right().init___O(value$1)
  };
  this.emitters$1 = jsx$2;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.example$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.ExampleValuesEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.ExampleValuesEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.ExampleValuesEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter() {
  $c_O.call(this);
  this.example$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter.prototype.productPrefix__T = (function() {
  return "NamedExampleEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter)) {
    var NamedExampleEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter(x$1);
    var x = this.example$1;
    var x$2 = NamedExampleEmitter$1.example$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = NamedExampleEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.example$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.example$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Name$1));
  var this$3 = this$2.option$1;
  new $c_Lamf_plugins_document_webapi_parser_spec_domain_KeyedExampleEmitter().init___T__Lamf_plugins_domain_shapes_models_Example__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())), this.example$1, this.ordering$1, this.spec$1).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter.prototype.init___Lamf_plugins_domain_shapes_models_Example__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(example, ordering, spec) {
  this.example$1 = example;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.example$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.NamedExampleEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.NamedExampleEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.NamedExampleEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser() {
  $c_O.call(this);
  this.entryOrNode$1 = null;
  this.parentId$1 = null;
  this.nameNode$1 = null;
  this.nameGenerator$1 = null;
  this.ctx$1 = null;
  this.map$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.invalidBinding__p1__s_Option__T__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter__V = (function(bindingEntry, binding, parameter) {
  if (bindingEntry.isEmpty__Z()) {
    var this$1 = $m_s_None$()
  } else {
    var arg1 = bindingEntry.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$1 = new $c_s_Some().init___O($m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(e.value$2))
  };
  var entryValueAnnotations = $as_Lamf_core_parser_Annotations((this$1.isEmpty__Z() ? ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()) : this$1.get__O()));
  var this$4 = this.ctx$1.eh$1;
  var specification = $m_Lamf_validations_ParserSideValidations$().OasInvalidParameterBinding$1;
  var message = (("Invalid parameter binding '" + binding) + "'");
  if (bindingEntry.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1$1 = bindingEntry.get__O();
    var x$4 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var this$3 = new $c_s_Some().init___O(x$4.value$2)
  };
  var ast = $as_Lorg_yaml_model_YPart((this$3.isEmpty__Z() ? this.map$1 : this$3.get__O()));
  var prop = $m_s_None$();
  var l = ast.location$1;
  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$4, specification, "", prop, message, l);
  var x1 = parameter.domainElement$1;
  if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Parameter)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_Parameter(x1);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
    var this$5 = $as_Lamf_core_model_StrField(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
    var this$6 = this$5.option$1;
    var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($as_T((this$6.isEmpty__Z() ? null : this$6.get__O())), entryValueAnnotations);
    var annotations = entryValueAnnotations.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_domain_webapi_annotations_InvalidBinding().init___T(binding));
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(x2, field, value, annotations)
  } else if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Payload)) {
    var x3 = $as_Lamf_plugins_domain_webapi_models_Payload(x1);
    var annotation = new $c_Lamf_plugins_domain_webapi_annotations_InvalidBinding().init___T(binding);
    $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(x3, annotation)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.checkNotFileInBody__Lamf_core_model_domain_Shape__V = (function(schema) {
  var schemaToCheck = ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(schema).isDefined__Z() ? $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(schema) : schema);
  if ((schemaToCheck instanceof $c_Lamf_plugins_domain_shapes_models_FileShape)) {
    var this$1 = this.ctx$1.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().OasFormDataNotFileSpecification$1;
    var node = schema.id$1;
    var ast = this.map$1;
    var prop = $m_s_None$();
    var l = ast.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, node, prop, "File types in parameters must be declared in formData params", l)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.productPrefix__T = (function() {
  return "Oas2ParameterParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.commonPayload__p1__s_Option__Lamf_plugins_domain_webapi_models_Payload = (function(bindingRange) {
  var jsx$2 = $m_Lamf_plugins_domain_webapi_models_Payload$();
  var this$1 = this.entryOrNode$1.toOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$2 = this.entryOrNode$1;
    var jsx$1 = $as_Lorg_yaml_model_YMapEntry(new $c_s_util_Either$LeftProjection().init___s_util_Either(this$2).get__O())
  } else {
    var jsx$1 = this$1.get__O()
  };
  var payload = jsx$2.apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_Payload($as_Lorg_yaml_model_YPart(jsx$1));
  this.setName__Lamf_core_model_domain_NamedDomainElement__Lamf_core_model_domain_DomainElement(payload);
  if ($as_Lamf_core_model_StrField(payload.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Name$1)).option$1.isEmpty__Z()) {
    var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1;
    var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations("default", new $c_Lamf_core_parser_Annotations().init___());
    var annotations = ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_Inferred().init___());
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(payload, field, value, annotations)
  };
  var map = this.map$1;
  var this$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$7 = this$6.key__T__s_Option("required");
  if ((!this$7.isEmpty__Z())) {
    var arg1 = this$7.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$8 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$BooleanYRead$();
    var iv = this.ctx$1;
    var req = $uZ($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$8, conversion, iv));
    var jsx$4 = payload.annotations$1;
    var jsx$3 = $m_Lamf_core_parser_Range$();
    var this$9 = entry.location$1;
    jsx$4.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload().init___Z__Lamf_core_parser_Range(req, jsx$3.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$9.lineFrom$1, this$9.columnFrom$1, this$9.lineTo$1, this$9.columnTo$1))))
  };
  var map$1 = this.map$1;
  var jsx$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Description$1;
  var iv$1 = this.ctx$1;
  jsx$5.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(payload));
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(payload, this.map$1, $m_sci_Nil$(), this.ctx$1).parse__V();
  return payload
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser)) {
    var Oas2ParameterParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser(x$1);
    var x = this.entryOrNode$1;
    var x$2 = Oas2ParameterParser$1.entryOrNode$1;
    if ((((x === null) ? (x$2 === null) : x.equals__O__Z(x$2)) && (this.parentId$1 === Oas2ParameterParser$1.parentId$1))) {
      var x$3 = this.nameNode$1;
      var x$4 = Oas2ParameterParser$1.nameNode$1;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.nameGenerator$1;
      var x$6 = Oas2ParameterParser$1.nameGenerator$1;
      return (x$5 === x$6)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entryOrNode$1;
      break
    }
    case 1: {
      return this.parentId$1;
      break
    }
    case 2: {
      return this.nameNode$1;
      break
    }
    case 3: {
      return this.nameGenerator$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.validateEntryName__p1__Lamf_core_model_domain_NamedDomainElement__V = (function(element) {
  if ($as_Lamf_core_model_StrField(element.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(element.nameField__Lamf_core_metamodel_Field())).option$1.isEmpty__Z()) {
    var name = this.nameGenerator$1.genId__T__T("parameter");
    var a = ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_AutoGeneratedName().init___());
    $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(element, name, a)
  };
  element.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(this.parentId$1, element.adopted$default$2__sc_Seq());
  var map = this.map$1;
  if (new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("name").isEmpty__Z()) {
    var this$3 = this.ctx$1.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().ParameterNameRequired$1;
    var node = element.id__T();
    var ast = this.map$1;
    var prop = $m_s_None$();
    var l = ast.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$3, specification, node, prop, "'name' property is required in a parameter.", l)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.setDefaultSchema$1__p1__F1 = (function() {
  return new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(c$2) {
      var c = $as_Lamf_plugins_domain_webapi_models_SchemaContainer(c$2);
      $m_Lamf_core_parser_Annotations$();
      var annotation = new $c_Lamf_plugins_document_webapi_annotations_Inferred().init___();
      var annotations = new $c_Lamf_core_parser_Annotations().init___().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(annotation);
      var fields = new $c_Lamf_core_parser_Fields().init___();
      return c.setSchema__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(new $c_Lamf_plugins_domain_shapes_models_AnyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations))
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.buildFromBinding__p1__T__s_Option__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter = (function($in, bindingEntry) {
  if (($in === "body")) {
    var jsx$5 = $m_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$();
    if (bindingEntry.isEmpty__Z()) {
      var jsx$3 = $m_s_None$()
    } else {
      var arg1 = bindingEntry.get__O();
      var a = $as_Lorg_yaml_model_YMapEntry(arg1);
      var jsx$4 = $m_Lamf_core_parser_Range$();
      var this$1 = a.location$1;
      var jsx$3 = new $c_s_Some().init___O(jsx$4.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$1.lineFrom$1, this$1.columnFrom$1, this$1.lineTo$1, this$1.columnTo$1)))
    };
    var jsx$2 = this.parseBodyPayload__p1__s_Option__Lamf_plugins_domain_webapi_models_Payload(jsx$3);
    var this$2 = this.entryOrNode$1.toOption__s_Option();
    if (this$2.isEmpty__Z()) {
      var this$3 = this.entryOrNode$1;
      var jsx$1 = new $c_s_util_Either$LeftProjection().init___s_util_Either(this$3).toOption__s_Option()
    } else {
      var jsx$1 = this$2
    };
    return jsx$5.apply__Lamf_plugins_domain_webapi_models_Payload__s_Option__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(jsx$2, jsx$1)
  } else if (($in === "formData")) {
    var jsx$10 = $m_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$();
    if (bindingEntry.isEmpty__Z()) {
      var jsx$8 = $m_s_None$()
    } else {
      var arg1$1 = bindingEntry.get__O();
      var a$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
      var jsx$9 = $m_Lamf_core_parser_Range$();
      var this$4 = a$3.location$1;
      var jsx$8 = new $c_s_Some().init___O(jsx$9.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$4.lineFrom$1, this$4.columnFrom$1, this$4.lineTo$1, this$4.columnTo$1)))
    };
    var jsx$7 = this.parseFormDataPayload__p1__s_Option__Lamf_plugins_domain_webapi_models_Payload(jsx$8);
    var this$5 = this.entryOrNode$1.toOption__s_Option();
    if (this$5.isEmpty__Z()) {
      var this$6 = this.entryOrNode$1;
      var jsx$6 = new $c_s_util_Either$LeftProjection().init___s_util_Either(this$6).toOption__s_Option()
    } else {
      var jsx$6 = this$5
    };
    return jsx$10.apply__Lamf_plugins_domain_webapi_models_Payload__s_Option__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(jsx$7, jsx$6)
  } else if ((($in === "query") || (($in === "header") || ($in === "path")))) {
    var jsx$13 = $m_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$();
    var jsx$12 = this.parseCommonParam__T__Lamf_plugins_domain_webapi_models_Parameter($in);
    var this$7 = this.entryOrNode$1.toOption__s_Option();
    if (this$7.isEmpty__Z()) {
      var this$8 = this.entryOrNode$1;
      var jsx$11 = new $c_s_util_Either$LeftProjection().init___s_util_Either(this$8).toOption__s_Option()
    } else {
      var jsx$11 = this$7
    };
    return jsx$13.apply__Lamf_plugins_domain_webapi_models_Parameter__s_Option__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(jsx$12, jsx$11)
  } else {
    var oasParam = this.buildFromBinding__p1__T__s_Option__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(this.defaultBinding__T(), $m_s_None$());
    this.invalidBinding__p1__s_Option__T__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter__V(bindingEntry, $in, oasParam);
    return oasParam
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$2__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.parseBodyPayload__p1__s_Option__Lamf_plugins_domain_webapi_models_Payload = (function(bindingRange) {
  var payload = this.commonPayload__p1__s_Option__Lamf_plugins_domain_webapi_models_Payload(bindingRange);
  this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(payload.id$1, this.map$1, "bodyParameter");
  var map = this.map$1;
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var jsx$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T("mediaType").asOasExtension__T();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1;
  var iv = this.ctx$1;
  jsx$2.key__T__F1__V(jsx$1, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(payload));
  var this$3 = $as_Lamf_core_model_StrField(payload.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1));
  if ($f_Lamf_core_model_StrField__nonEmpty__Z(this$3)) {
    this.validateEntryName__p1__Lamf_core_model_domain_NamedDomainElement__V(payload)
  };
  var map$1 = this.map$1;
  var this$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var this$6 = this$5.key__T__s_Option("schema");
  if ((!this$6.isEmpty__Z())) {
    var arg1 = this$6.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$7 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, payload$3) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        var qual$1 = $as_Lamf_core_model_domain_Shape($this.setName__Lamf_core_model_domain_NamedDomainElement__Lamf_core_model_domain_DomainElement(shape));
        var x$1 = payload$3.id$1;
        var x$2 = qual$1.adopted$default$2__sc_Seq();
        qual$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$1, x$2)
      })
    })(this, payload)), $m_Lamf_plugins_document_webapi_parser_spec_package$().toOas__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.ctx$1)).parse__s_Option();
    if ((!this$7.isEmpty__Z())) {
      var arg1$1 = this$7.get__O();
      var schema = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1$1);
      this.checkNotFileInBody__Lamf_core_model_domain_Shape__V(schema);
      var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
      var value = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(schema, payload.id$1, $m_s_None$());
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(payload, field$1, value, annotations);
      if ((!bindingRange.isEmpty__Z())) {
        var arg1$2 = bindingRange.get__O();
        var range = $as_Lamf_core_parser_Range(arg1$2);
        schema.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo().init___Lamf_core_parser_Range(range))
      };
      new $c_s_Some().init___O(schema)
    }
  };
  return payload
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.parseParameterRef__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter = (function(ref, parentId) {
  var jsx$1 = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$();
  $m_Lorg_yaml_model_YNode$();
  var node = ref.value$2;
  var iv = this.ctx$1;
  var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
  var refUrl = jsx$1.stripParameterDefinitionsPrefix__T__Lamf_plugins_document_webapi_contexts_WebApiContext__T($as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)), this.ctx$1);
  var x1 = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations().findParameter__T__Lamf_core_parser_SearchScope$Scope__s_Option(refUrl, $m_Lamf_core_parser_SearchScope$All$());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var param = $as_Lamf_plugins_domain_webapi_models_Parameter(x2.value$2);
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.map$1);
    var parameter = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(param, refUrl, annotations));
    $m_Lamf_core_parser_Annotations$();
    var a = new $c_Lamf_core_parser_Annotations().init___();
    var qual$1 = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(parameter, refUrl, a));
    $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, parentId);
    return $m_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$().apply__Lamf_plugins_domain_webapi_models_Parameter__s_Option__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(parameter, new $c_s_Some().init___O(ref))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var x1$2 = this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations().findPayload__T__Lamf_core_parser_SearchScope$Scope__s_Option(refUrl, $m_Lamf_core_parser_SearchScope$All$());
      if ((x1$2 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$2);
        var payload = $as_Lamf_plugins_domain_webapi_models_Payload(x2$2.value$2);
        var jsx$2 = $m_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$();
        var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.map$1);
        return jsx$2.apply__Lamf_plugins_domain_webapi_models_Payload__s_Option__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter($as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(payload, refUrl, annotations$1)), new $c_s_Some().init___O(ref))
      } else {
        var x$4 = $m_s_None$();
        if ((x$4 === x1$2)) {
          var fullRef = this.ctx$1.resolvedPath__T__T__T(this.ctx$1.rootContextDocument$1, refUrl);
          var x1$3 = this.ctx$1.parseRemoteOasParameter__T__T__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext__s_Option(fullRef, parentId, $m_Lamf_plugins_document_webapi_parser_spec_package$().toOas__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.ctx$1));
          if ((x1$3 instanceof $c_s_Some)) {
            var x2$3 = $as_s_Some(x1$3);
            var oasParameter = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(x2$3.value$2);
            var this$3 = oasParameter.paramOption$1;
            if ((!this$3.isEmpty__Z())) {
              var arg1 = this$3.get__O();
              var param$2 = $as_Lamf_plugins_domain_webapi_models_Parameter(arg1);
              var this$4 = this.nameNode$1;
              if (this$4.isEmpty__Z()) {
                var this$7 = $m_s_None$()
              } else {
                var arg1$1 = this$4.get__O();
                var x$6 = $as_Lorg_yaml_model_YNode(arg1$1);
                var iv$1 = this.ctx$1;
                var this$6 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(x$6, iv$1);
                var this$7 = new $c_s_Some().init___O(this$6.text__Lamf_core_model_domain_AmfScalar())
              };
              if (this$7.isEmpty__Z()) {
                /*<skip>*/
              } else {
                var arg1$2 = this$7.get__O();
                var name = $as_Lamf_core_model_domain_AmfScalar(arg1$2);
                var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1;
                var qual$2 = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(param$2, field, name));
                $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
                new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$2, parentId)))
              }
            };
            return oasParameter
          } else {
            var this$8 = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter().init___T__Lorg_yaml_model_YPart(refUrl, ref);
            var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ref);
            var parameter$2 = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this$8, refUrl, annotations$2));
            this.setName__Lamf_core_model_domain_NamedDomainElement__Lamf_core_model_domain_DomainElement(parameter$2);
            $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
            $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(parameter$2, parentId);
            var this$9 = this.ctx$1.eh$1;
            var specification = $m_Lamf_validations_ParserSideValidations$().UnresolvedParameter$1;
            var node$1 = parameter$2.id$1;
            var message = ("Cannot find parameter or payload reference " + refUrl);
            var prop = $m_s_None$();
            var l = ref.location$1;
            $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$9, specification, node$1, prop, message, l);
            return $m_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$().apply__Lamf_plugins_domain_webapi_models_Parameter__s_Option__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(parameter$2, new $c_s_Some().init___O(ref))
          }
        } else {
          throw new $c_s_MatchError().init___O(x1$2)
        }
      }
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.setName__Lamf_core_model_domain_NamedDomainElement__Lamf_core_model_domain_DomainElement = (function(p) {
  var rc6 = false;
  var x2 = null;
  matchEnd7: {
    if ((p instanceof $c_Lamf_core_model_domain_Shape)) {
      rc6 = true;
      x2 = $as_Lamf_core_model_domain_Shape(p);
      if (this.nameNode$1.isDefined__Z()) {
        var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Name$1;
        var this$1 = this.nameNode$1;
        if (this$1.isEmpty__Z()) {
          var jsx$1 = $m_s_None$()
        } else {
          var arg1 = this$1.get__O();
          var x$1 = $as_Lorg_yaml_model_YNode(arg1);
          var iv = this.ctx$1;
          var this$3 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(x$1, iv);
          var jsx$1 = new $c_s_Some().init___O(this$3.text__Lamf_core_model_domain_AmfScalar())
        };
        var value = $as_Lamf_core_model_domain_AmfElement(jsx$1.get__O());
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(p, field, value);
        break matchEnd7
      }
    };
    if (rc6) {
      var map = this.map$1;
      var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
      var field$1 = $m_Lamf_core_metamodel_domain_ShapeModel$().Name$1;
      var iv$1 = this.ctx$1;
      jsx$2.key__T__F1__V("name", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(p).withAnnotation__Lamf_core_model_domain_Annotation__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_Lamf_plugins_document_webapi_annotations_Inferred().init___()));
      break matchEnd7
    };
    if ((p instanceof $c_Lamf_plugins_domain_webapi_models_Payload)) {
      var x4 = $as_Lamf_plugins_domain_webapi_models_Payload(p);
      var this$5 = this.nameNode$1;
      if (this$5.isDefined__Z()) {
        var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1;
        var this$6 = this.nameNode$1;
        if (this$6.isEmpty__Z()) {
          var jsx$3 = $m_s_None$()
        } else {
          var arg1$1 = this$6.get__O();
          var x$2 = $as_Lorg_yaml_model_YNode(arg1$1);
          var iv$2 = this.ctx$1;
          var this$8 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(x$2, iv$2);
          var jsx$3 = new $c_s_Some().init___O(this$8.text__Lamf_core_model_domain_AmfScalar())
        };
        var value$1 = $as_Lamf_core_model_domain_AmfElement(jsx$3.get__O());
        var map$1 = this.map$1;
        var this$10 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option("name");
        if (this$10.isEmpty__Z()) {
          var this$15 = $m_s_None$()
        } else {
          var arg1$2 = this$10.get__O();
          var e = $as_Lorg_yaml_model_YMapEntry(arg1$2);
          $m_Lamf_core_parser_Annotations$();
          var node = e.value$2;
          var iv$3 = this.ctx$1;
          var this$12 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv$3);
          var jsx$5 = $objectToString(this$12.text__Lamf_core_model_domain_AmfScalar().value$1);
          var jsx$4 = $m_Lamf_core_parser_Range$();
          var this$13 = e.location$1;
          var annotation = new $c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload().init___T__Lamf_core_parser_Range(jsx$5, jsx$4.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$13.lineFrom$1, this$13.columnFrom$1, this$13.lineTo$1, this$13.columnTo$1)));
          var this$15 = new $c_s_Some().init___O(new $c_Lamf_core_parser_Annotations().init___().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(annotation))
        };
        var annotations = $as_Lamf_core_parser_Annotations((this$15.isEmpty__Z() ? ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()) : this$15.get__O()));
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(x4, field$2, value$1, annotations)
      } else {
        var map$2 = this.map$1;
        var jsx$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
        var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1;
        var iv$4 = this.ctx$1;
        jsx$6.key__T__F1__V("name", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$3, iv$4).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(x4))
      };
      this.validateEntryName__p1__Lamf_core_model_domain_NamedDomainElement__V(x4);
      break matchEnd7
    };
    var this$18 = this.nameNode$1;
    if (this$18.isDefined__Z()) {
      var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1;
      var this$19 = this.nameNode$1;
      if (this$19.isEmpty__Z()) {
        var jsx$7 = $m_s_None$()
      } else {
        var arg1$3 = this$19.get__O();
        var x$3 = $as_Lorg_yaml_model_YNode(arg1$3);
        var iv$5 = this.ctx$1;
        var this$21 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(x$3, iv$5);
        var jsx$7 = new $c_s_Some().init___O(this$21.text__Lamf_core_model_domain_AmfScalar())
      };
      var value$2 = $as_Lamf_core_model_domain_AmfElement(jsx$7.get__O());
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(p, field$4, value$2)
    } else {
      var map$3 = this.map$1;
      var jsx$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3);
      var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1;
      var iv$6 = this.ctx$1;
      jsx$8.key__T__F1__V("name", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$5, iv$6).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(p))
    };
    this.validateEntryName__p1__Lamf_core_model_domain_NamedDomainElement__V(p)
  };
  return p
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.parse__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter = (function() {
  var map = this.map$1;
  var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("$ref");
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var ref = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    return this.parseParameterRef__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(ref, this.parentId$1)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var map$1 = this.map$1;
      var x1$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option("in");
      if ((x1$2 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$2);
        var entry = $as_Lorg_yaml_model_YMapEntry(x2$2.value$2);
        if ((entry !== null)) {
          var this$3 = entry.value$2;
          var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
          var iv = this.ctx$1;
          var $in = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv)).text$3;
          return this.buildFromBinding__p1__T__s_Option__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter($in, new $c_s_Some().init___O(entry))
        }
      };
      var parameter = $m_Lamf_plugins_domain_webapi_models_Parameter$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_Parameter(this.map$1);
      this.setName__Lamf_core_model_domain_NamedDomainElement__Lamf_core_model_domain_DomainElement(parameter);
      var parent = this.parentId$1;
      $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(parameter, parent);
      return $m_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$().apply__Lamf_plugins_domain_webapi_models_Parameter__s_Option__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(parameter, new $c_s_Some().init___O(this.map$1))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.defaultBinding__T = (function() {
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("schema");
  if (this$2.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$3 = new $c_s_Some().init___O("body")
  };
  return $as_T((this$3.isEmpty__Z() ? "query" : this$3.get__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.EmptyTarget$lzycompute$2__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.parseFormDataPayload__p1__s_Option__Lamf_plugins_domain_webapi_models_Payload = (function(bindingRange) {
  var payload = this.commonPayload__p1__s_Option__Lamf_plugins_domain_webapi_models_Payload(bindingRange);
  this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(payload.id$1, this.map$1, "parameter");
  var map = this.map$1;
  var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("type");
  var x = $m_s_None$();
  if ((x === x1)) {
    this.setDefaultSchema$1__p1__F1().apply__O__O(payload);
    var this$2 = this.ctx$1.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().MissingParameterType$1;
    var node = payload.id$1;
    var ast = this.map$1;
    var prop = $m_s_None$();
    var l = ast.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$2, specification, node, prop, "'type' is required in a parameter with binding 'formData'", l)
  } else if ((x1 instanceof $c_s_Some)) {
    var jsx$3 = this.entryOrNode$1;
    var jsx$2 = this.map$1;
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, payload$1) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        var qual$1 = $as_Lamf_core_model_domain_Shape($this.setName__Lamf_core_model_domain_NamedDomainElement__Lamf_core_model_domain_DomainElement(shape));
        var x$1 = payload$1.id$1;
        var x$2 = qual$1.adopted$default$2__sc_Seq();
        qual$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$1, x$2)
      })
    })(this, payload));
    var eh = this.ctx$1.eh$1;
    var this$4 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser().init___s_util_Either__T__Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(jsx$3, "schema", jsx$2, jsx$1, new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion().init___T__Lamf_core_errorhandling_ErrorHandler("parameter", eh), $m_Lamf_plugins_document_webapi_parser_spec_package$().toOas__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.ctx$1)).parse__s_Option();
    if (this$4.isEmpty__Z()) {
      var this$6 = $m_s_None$()
    } else {
      var arg1 = this$4.get__O();
      var schema = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1);
      var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
      var value = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(schema, payload.id$1, $m_s_None$());
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.map$1);
      var this$6 = new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(payload, field, value, annotations)))
    };
    if (this$6.isEmpty__Z()) {
      var this$7 = this.ctx$1.eh$1;
      var specification$1 = $m_Lamf_validations_ParserSideValidations$().UnresolvedParameter$1;
      var node$1 = payload.id$1;
      var ast$1 = this.map$1;
      var prop$1 = $m_s_None$();
      var l$1 = ast$1.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$7, specification$1, node$1, prop$1, "Cannot find valid schema for parameter", l$1)
    }
  } else {
    throw new $c_s_MatchError().init___O(x1)
  };
  payload.annotations$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_FormBodyParameter().init___());
  return payload
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.init___s_util_Either__T__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(entryOrNode, parentId, nameNode, nameGenerator, ctx) {
  this.entryOrNode$1 = entryOrNode;
  this.parentId$1 = parentId;
  this.nameNode$1 = nameNode;
  this.nameGenerator$1 = nameGenerator;
  this.ctx$1 = ctx;
  if ((entryOrNode instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(entryOrNode);
    var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    var this$1 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var jsx$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, ctx))
  } else if ((entryOrNode instanceof $c_s_util_Right)) {
    var x3 = $as_s_util_Right(entryOrNode);
    var node = $as_Lorg_yaml_model_YNode(x3.value$2);
    var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var jsx$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$1, ctx))
  } else {
    var jsx$1;
    throw new $c_s_MatchError().init___O(entryOrNode)
  };
  this.map$1 = jsx$1;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.parseFixedFields__Lamf_plugins_domain_webapi_models_Parameter = (function() {
  var jsx$2 = $m_Lamf_plugins_domain_webapi_models_Parameter$();
  var this$1 = this.entryOrNode$1.toOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$2 = this.entryOrNode$1;
    var jsx$1 = $as_Lorg_yaml_model_YMapEntry(new $c_s_util_Either$LeftProjection().init___s_util_Either(this$2).get__O())
  } else {
    var jsx$1 = this$1.get__O()
  };
  var parameter = jsx$2.apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_Parameter($as_Lorg_yaml_model_YPart(jsx$1));
  this.setName__Lamf_core_model_domain_NamedDomainElement__Lamf_core_model_domain_DomainElement(parameter);
  var parent = this.parentId$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(parameter, parent);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(parameter, field, false);
  var map = this.map$1;
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().ParameterName$1;
  var iv = this.ctx$1;
  jsx$3.key__T__F1__V("name", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(parameter));
  var map$1 = this.map$1;
  var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
  var iv$1 = this.ctx$1;
  jsx$4.key__T__F1__V("in", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(parameter));
  var map$2 = this.map$1;
  var jsx$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Description$1;
  var iv$2 = this.ctx$1;
  jsx$5.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$3, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(parameter));
  var map$3 = this.map$1;
  var jsx$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3);
  var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1;
  var iv$3 = this.ctx$1;
  var this$7 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$4, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(parameter);
  jsx$6.key__T__F1__V("required", this$7.withAnnotation__Lamf_core_model_domain_Annotation__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_Lamf_core_annotations_ExplicitField().init___()));
  this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(parameter.id$1, this.map$1, "parameter");
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(parameter, this.map$1, $m_sci_Nil$(), this.ctx$1).parse__V();
  return parameter
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.parseCommonParam__T__Lamf_plugins_domain_webapi_models_Parameter = (function(binding) {
  var parameter = this.parseFixedFields__Lamf_plugins_domain_webapi_models_Parameter();
  var map = this.map$1;
  var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("type");
  var x = $m_s_None$();
  if ((x === x1)) {
    this.setDefaultSchema$1__p1__F1().apply__O__O(parameter);
    var this$2 = this.ctx$1.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().MissingParameterType$1;
    var node = parameter.id$1;
    var message = (("'type' is required in a parameter with binding '" + binding) + "'");
    var ast = this.map$1;
    var prop = $m_s_None$();
    var l = ast.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$2, specification, node, prop, message, l)
  } else if ((x1 instanceof $c_s_Some)) {
    var jsx$3 = this.entryOrNode$1;
    var jsx$2 = this.map$1;
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parameter$3) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        $m_Lamf_core_parser_Annotations$();
        var a = new $c_Lamf_core_parser_Annotations().init___();
        var qual$1 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, "schema", a));
        var x$1 = parameter$3.id$1;
        var x$2 = qual$1.adopted$default$2__sc_Seq();
        qual$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$1, x$2)
      })
    })(this, parameter));
    var eh = this.ctx$1.eh$1;
    var this$5 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser().init___s_util_Either__T__Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(jsx$3, "schema", jsx$2, jsx$1, new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS20SchemaVersion().init___T__Lamf_core_errorhandling_ErrorHandler("parameter", eh), $m_Lamf_plugins_document_webapi_parser_spec_package$().toOas__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.ctx$1)).parse__s_Option();
    if (this$5.isEmpty__Z()) {
      var this$6 = $m_s_None$()
    } else {
      var arg1 = this$5.get__O();
      var schema = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1);
      var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1;
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.map$1);
      var this$6 = new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(parameter, field, schema, annotations)))
    };
    if (this$6.isEmpty__Z()) {
      var this$7 = this.ctx$1.eh$1;
      var specification$1 = $m_Lamf_validations_ParserSideValidations$().UnresolvedParameter$1;
      var node$1 = parameter.id$1;
      var ast$1 = this.map$1;
      var prop$1 = $m_s_None$();
      var l$1 = ast$1.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$7, specification$1, node$1, prop$1, "Cannot find valid schema for parameter", l$1)
    }
  } else {
    throw new $c_s_MatchError().init___O(x1)
  };
  return parameter
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Oas2ParameterParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Oas2ParameterParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Oas2ParameterParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasParameterParser: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser.call(this);
  this.map$2 = null;
  this.api$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser.prototype.productPrefix__T = (function() {
  return "Oas2ServersParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function() {
  return $as_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.ctx$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser)) {
    var Oas2ServersParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser(x$1);
    var this$1 = this.map$2;
    var b = Oas2ServersParser$1.map$2;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.api$2;
      var x$2 = Oas2ServersParser$1.api$2;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$2;
      break
    }
    case 1: {
      return this.api$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser.prototype.init___Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_WebApi__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(map, api, ctx) {
  this.map$2 = map;
  this.api$2 = api;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser.prototype.init___Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.call(this, map, api, $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Servers$1, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser.prototype.parse__V = (function() {
  if (this.baseUriExists__Lorg_yaml_model_YMap__Z(this.map$2)) {
    var elem$1 = null;
    elem$1 = "";
    var elem$1$1 = null;
    elem$1$1 = "";
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var map = this.map$2;
    var this$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("basePath");
    if ((!this$5.isEmpty__Z())) {
      var arg1 = this$5.get__O();
      var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
      var jsx$1 = $m_Lamf_core_parser_Range$();
      var this$6 = entry.location$1;
      var range = jsx$1.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$6.lineFrom$1, this$6.columnFrom$1, this$6.lineTo$1, this$6.columnTo$1));
      annotations.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_BasePathLexicalInformation().init___Lamf_core_parser_Range(range));
      var this$8 = entry.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
      var iv = $as_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.ctx$1);
      elem$1$1 = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$8, conversion, iv));
      var thiz = $as_T(elem$1$1);
      if ((!(($uI(thiz.length) >= 0) && ($as_T(thiz.substring(0, $uI("/".length))) === "/")))) {
        var this$14 = $as_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.ctx$1).eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().InvalidBasePath$1;
        var node = this.api$2.id$1;
        var ast = entry.value$2;
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$14, specification, node, prop, "'basePath' property must start with '/'", l);
        elem$1$1 = ("/" + $as_T(elem$1$1))
      }
    };
    var map$1 = this.map$2;
    var this$16 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option("host");
    if ((!this$16.isEmpty__Z())) {
      var arg1$1 = this$16.get__O();
      var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
      var jsx$2 = $m_Lamf_core_parser_Range$();
      var this$17 = entry$3.location$1;
      var range$1 = jsx$2.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$17.lineFrom$1, this$17.columnFrom$1, this$17.lineTo$1, this$17.columnTo$1));
      annotations.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_HostLexicalInformation().init___Lamf_core_parser_Range(range$1));
      var this$19 = entry$3.value$2;
      var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
      var iv$1 = $as_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.ctx$1);
      elem$1 = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$19, conversion$1, iv$1))
    };
    $m_Lamf_core_parser_Annotations$();
    var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
    var this$24 = new $c_Lamf_plugins_domain_webapi_models_Server().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Url$1;
    var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations((("" + $as_T(elem$1)) + $as_T(elem$1$1)), new $c_Lamf_core_parser_Annotations().init___());
    var server = $as_Lamf_plugins_domain_webapi_models_Server($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$24, field, value, annotations));
    var map$2 = this.map$2;
    var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
    var jsx$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T("serverDescription").asOasExtension__T();
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Description$1;
    var iv$2 = $as_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.ctx$1);
    jsx$4.key__T__F1__V(jsx$3, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(server));
    var map$3 = this.map$2;
    var this$29 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3);
    var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("baseUriParameters").asOasExtension__T();
    var this$30 = this$29.key__T__s_Option(keyword);
    if ((!this$30.isEmpty__Z())) {
      var arg1$2 = this$30.get__O();
      var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
      var this$31 = entry$4.value$2;
      var conversion$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv$3 = $as_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.ctx$1);
      var jsx$6 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersParser().init___Lorg_yaml_model_YMap__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$31, conversion$2, iv$3)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, server$2) {
        return (function(p$2) {
          var p = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2);
          var parent = server$2.id$1;
          $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
          $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(p, parent)
        })
      })(this, server)), false, $m_Lamf_plugins_document_webapi_parser_spec_package$().toRaml__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext($as_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.ctx$1))).parse__sc_Seq();
      var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
        return (function(x$6$2) {
          var x$6 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$6$2);
          var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
          return $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(x$6, field$2, "path"))
        })
      })(this));
      var this$32 = $m_sc_Seq$();
      var uriParameters = $as_sc_Seq(jsx$6.map__F1__scg_CanBuildFrom__O(jsx$5, this$32.ReusableCBFInstance$2));
      var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Variables$1;
      var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(uriParameters, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4.value$2));
      var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4);
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(server, field$3, value$1, annotations$2)
    };
    var this$36 = this.api$2;
    var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Servers$1;
    var jsx$7 = $m_sc_Seq$();
    var annotation = new $c_Lamf_core_annotations_SynthesizedField().init___();
    var array = [$as_Lamf_plugins_domain_webapi_models_Server($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(server, annotation))];
    var value$2 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$7.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$36, field$4, value$2)
  };
  this.parseServers__T__V(new $c_Lamf_core_utils_package$AmfStrings().init___T("servers").asOasExtension__T())
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser.prototype.baseUriExists__Lorg_yaml_model_YMap__Z = (function(map) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("host");
  return (this$2.isEmpty__Z() ? new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("basePath") : this$2).isDefined__Z()
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Oas2ServersParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Oas2ServersParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Oas2ServersParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter() {
  $c_O.call(this);
  this.example$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null;
  this.emitters$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter.prototype.productPrefix__T = (function() {
  return "Oas3ExampleValuesEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter)) {
    var Oas3ExampleValuesEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter(x$1);
    var x = this.example$1;
    var x$2 = Oas3ExampleValuesEmitter$1.example$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = Oas3ExampleValuesEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.example$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.example$1;
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1).isDefined__Z()) {
    var jsx$1 = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$();
    var this$2 = this.example$1;
    var this$3 = $as_Lamf_core_model_StrField(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1));
    var this$4 = this$3.option$1;
    var refUrl = jsx$1.appendOas3ComponentsPrefix__T__T__T($as_T((this$4.isEmpty__Z() ? null : this$4.get__O())), "examples");
    $m_Lorg_yaml_model_YNode$();
    var str = this.keyName__Lamf_plugins_domain_shapes_models_Example__T(this.example$1);
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$2 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lorg_yaml_model_YNode$();
    var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("$ref");
    $m_Lorg_yaml_model_YNode$();
    var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(refUrl);
    b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$1, value);
    jsx$2.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
    var this$11 = v.builder$1;
    var array = [key];
    if ((this$11.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$11.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$11, newSize);
    var len$1 = this$11.size0$6;
    var src = this$11.array$6;
    var dest = this$11.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$11.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$3 = j;
      var index = i;
      xs.set(jsx$3, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$11.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  } else {
    $m_Lorg_yaml_model_YNode$();
    var str$1 = this.keyName__Lamf_plugins_domain_shapes_models_Example__T(this.example$1);
    var key$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
    var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$4 = v$1.builder$1;
    var sourceName$1 = v$1.sourceName$2;
    var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(this.emitters$1), b$2);
    jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1));
    var this$26 = v$1.builder$1;
    var array$1 = [key$2];
    if ((this$26.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$3 = $uI(array$1.length);
    var newSize$1 = ((this$26.size0$6 + len$3) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$26, newSize$1);
    var len$4 = this$26.size0$6;
    var src$1 = this$26.array$6;
    var dest$1 = this$26.array$6;
    $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
    var xs$1 = this$26.array$6;
    var len$5 = xs$1.u.length;
    var i$1 = 0;
    var j$1 = 0;
    var x$2 = $uI(array$1.length);
    var x$3 = ((x$2 < len$5) ? x$2 : len$5);
    var that$1 = xs$1.u.length;
    var end$1 = ((x$3 < that$1) ? x$3 : that$1);
    while ((i$1 < end$1)) {
      var jsx$5 = j$1;
      var index$1 = i$1;
      xs$1.set(jsx$5, array$1[index$1]);
      i$1 = ((1 + i$1) | 0);
      j$1 = ((1 + j$1) | 0)
    };
    this$26.size0$6 = newSize$1;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter.prototype.init___Lamf_plugins_domain_shapes_models_Example__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(example, ordering, spec) {
  this.example$1 = example;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var fs = example.fields$1;
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Summary$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    results.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("summary", f, $m_s_None$(), this.spec$1))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Description$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    results.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("description", f$3, $m_s_None$(), this.spec$1))
  };
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().ExternalValue$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1$2 = this$5.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    results.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("externalValue", f$4, $m_s_None$(), this.spec$1))
  };
  var this$7 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1);
  if ((!this$7.isEmpty__Z())) {
    var arg1$3 = this$7.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    var this$8 = this.example$1;
    var x$2 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler($as_Lamf_core_model_domain_DataNode(this$8.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1)), this.ordering$1, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler());
    var this$10 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = f$5.value$1.annotations$1;
    var x$3 = this$10.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
    results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position("value", x$2, x$4, x$3))
  };
  results.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(example, ordering, spec).emitters__sc_Seq());
  this.emitters$1 = results;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter.prototype.keyName__Lamf_plugins_domain_shapes_models_Example__T = (function(example) {
  var this$1 = $as_Lamf_core_model_StrField(example.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Name$1)).option$1;
  return $as_T((this$1.isEmpty__Z() ? "default" : this$1.get__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.example$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Oas3ExampleValuesEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Oas3ExampleValuesEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Oas3ExampleValuesEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter() {
  $c_O.call(this);
  this.links$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter.prototype.productPrefix__T = (function() {
  return "Oas3LinkDeclarationEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter)) {
    var Oas3LinkDeclarationEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter(x$1);
    var x = this.links$1;
    var x$2 = Oas3LinkDeclarationEmitter$1.links$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = Oas3LinkDeclarationEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = Oas3LinkDeclarationEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.links$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("links");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  this.links$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, decBuilder) {
    return (function(link$2) {
      var link = $as_Lamf_plugins_domain_webapi_models_TemplatedLink(link$2);
      var result = $m_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$().emitters__Lamf_plugins_domain_webapi_models_TemplatedLink__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext__scm_ListBuffer(link, $this.ordering$1, $this.references$1, $this.spec$1);
      if (result.nonEmpty__Z()) {
        $m_Lorg_yaml_model_YNode$();
        var this$3 = $as_Lamf_core_model_StrField(link.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Name$1));
        var this$4 = this$3.option$1;
        var str = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
        var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
        var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(decBuilder.sourceName$2);
        var jsx$1 = v$1.builder$1;
        var sourceName$1 = v$1.sourceName$2;
        var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
        $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V($this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$2);
        jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1));
        var this$9 = v$1.builder$1;
        var array = [key$1];
        if ((this$9.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len = $uI(array.length);
        var newSize = ((this$9.size0$6 + len) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$9, newSize);
        var len$1 = this$9.size0$6;
        var src = this$9.array$6;
        var dest = this$9.array$6;
        $systemArraycopy(src, 0, dest, len, len$1);
        var xs = this$9.array$6;
        var len$2 = xs.u.length;
        var i = 0;
        var j = 0;
        var x = $uI(array.length);
        var x$1 = ((x < len$2) ? x : len$2);
        var that = xs.u.length;
        var end = ((x$1 < that) ? x$1 : that);
        while ((i < end)) {
          var jsx$2 = j;
          var index = i;
          xs.set(jsx$2, array[index]);
          i = ((1 + i) | 0);
          j = ((1 + j) | 0)
        };
        this$9.size0$6 = newSize;
        decBuilder.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1))
      }
    })
  })(this, b$1)));
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$22 = v.builder$1;
  var array$1 = [key];
  if ((this$22.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len$3 = $uI(array$1.length);
  var newSize$1 = ((this$22.size0$6 + len$3) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$22, newSize$1);
  var len$4 = this$22.size0$6;
  var src$1 = this$22.array$6;
  var dest$1 = this$22.array$6;
  $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
  var xs$1 = this$22.array$6;
  var len$5 = xs$1.u.length;
  var i$1 = 0;
  var j$1 = 0;
  var x$2 = $uI(array$1.length);
  var x$3 = ((x$2 < len$5) ? x$2 : len$5);
  var that$1 = xs$1.u.length;
  var end$1 = ((x$3 < that$1) ? x$3 : that$1);
  while ((i$1 < end$1)) {
    var jsx$4 = j$1;
    var index$1 = i$1;
    xs$1.set(jsx$4, array$1[index$1]);
    i$1 = ((1 + i$1) | 0);
    j$1 = ((1 + j$1) | 0)
  };
  this$22.size0$6 = newSize$1;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(links, ordering, references, spec) {
  this.links$1 = links;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.links$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var p = $as_Lamf_plugins_domain_webapi_models_TemplatedLink(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = p.annotations$1;
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Oas3LinkDeclarationEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Oas3LinkDeclarationEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Oas3LinkDeclarationEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkDeclarationEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter() {
  $c_O.call(this);
  this.mapping$1 = null;
  this.ordering$1 = null;
  this.references$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter.prototype.productPrefix__T = (function() {
  return "Oas3LinkParametersEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter)) {
    var Oas3LinkParametersEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter(x$1);
    var x = this.mapping$1;
    var x$2 = Oas3LinkParametersEmitter$1.mapping$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = Oas3LinkParametersEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = Oas3LinkParametersEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.mapping$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var jsx$2 = this.mapping$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(mapping$2) {
      var mapping = $as_Lamf_plugins_domain_webapi_models_IriTemplateMapping(mapping$2);
      var this$1 = $as_Lamf_core_model_StrField(mapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$().TemplateVariable$1));
      var this$2 = this$1.option$1;
      var x$1 = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
      var this$3 = $as_Lamf_core_model_StrField(mapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$().LinkExpression$1));
      var this$4 = this$3.option$1;
      var x$2 = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
      var this$5 = $m_Lamf_core_emitter_BaseEmitters_package$();
      var annotations = mapping.annotations$1;
      var x$3 = this$5.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf());
      var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
      return new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position(x$1, x$2, x$4, x$3)
    })
  })(this));
  var this$7 = $m_sc_Seq$();
  var entryEmitters = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("parameters");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(entryEmitters), b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$12 = v.builder$1;
  var array = [key];
  if ((this$12.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$12.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$12, newSize);
  var len$1 = this$12.size0$6;
  var src = this$12.array$6;
  var dest = this$12.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$12.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$5 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$5 < that) ? x$5 : that);
  while ((i < end)) {
    var jsx$4 = j;
    var index = i;
    xs.set(jsx$4, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$12.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(mapping, ordering, references, spec) {
  this.mapping$1 = mapping;
  this.ordering$1 = ordering;
  this.references$1 = references;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = $as_Lamf_plugins_domain_webapi_models_IriTemplateMapping(this.mapping$1.head__O()).annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Oas3LinkParametersEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Oas3LinkParametersEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Oas3LinkParametersEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3LinkParametersEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersEmitter.call(this);
  this.operation$3 = null;
  this.f$3 = null;
  this.ordering$3 = null;
  this.references$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter.prototype.productPrefix__T = (function() {
  return "Oas3OperationServersEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter)) {
    var Oas3OperationServersEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter(x$1);
    var x = this.operation$3;
    var x$2 = Oas3OperationServersEmitter$1.operation$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.f$3;
      var x$4 = Oas3OperationServersEmitter$1.f$3;
      var jsx$2 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.ordering$3;
      var x$6 = Oas3OperationServersEmitter$1.ordering$3;
      var jsx$1 = (x$5 === x$6)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.references$3;
      var x$8 = Oas3OperationServersEmitter$1.references$3;
      return ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.operation$3;
      break
    }
    case 1: {
      return this.f$3;
      break
    }
    case 2: {
      return this.ordering$3;
      break
    }
    case 3: {
      return this.references$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(operation, f, ordering, references, spec) {
  this.operation$3 = operation;
  this.f$3 = f;
  this.ordering$3 = ordering;
  this.references$3 = references;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersEmitter.prototype.init___Lamf_core_model_domain_DomainElement__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.call(this, operation, f, ordering, references, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter.prototype.emitters__sc_Seq = (function() {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = this.operation$3;
  this.asExtension__T__sc_Seq__scm_ListBuffer__V("servers", $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Servers$1)), result);
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Oas3OperationServersEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Oas3OperationServersEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Oas3OperationServersEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter: 1,
  O: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser.call(this);
  this.map$2 = null;
  this.elem$2 = null;
  this.field$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser.prototype.productPrefix__T = (function() {
  return "Oas3ServersParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser.prototype.init___Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(map, elem, field, ctx) {
  this.map$2 = map;
  this.elem$2 = elem;
  this.field$2 = field;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser.prototype.init___Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.call(this, map, elem, field, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function() {
  return $as_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.ctx$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser)) {
    var Oas3ServersParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser(x$1);
    var this$1 = this.map$2;
    var b = Oas3ServersParser$1.map$2;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.elem$2;
      var x$2 = Oas3ServersParser$1.elem$2;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.field$2;
      var x$4 = Oas3ServersParser$1.field$2;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$2;
      break
    }
    case 1: {
      return this.elem$2;
      break
    }
    case 2: {
      return this.field$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser.prototype.parse__V = (function() {
  var x = $as_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.ctx$1).syntax__Lamf_plugins_document_webapi_parser_spec_SpecSyntax();
  var x$2 = $m_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$();
  if (((x !== null) && (x === x$2))) {
    this.parseServers__T__V("servers")
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Oas3ServersParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Oas3ServersParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Oas3ServersParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter() {
  $c_O.call(this);
  this.callbacks$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter.prototype.productPrefix__T = (function() {
  return "OasCallbackEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(p) {
  var this$1 = this.callbacks$1.headOption__s_Option();
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var x$6 = $as_Lamf_plugins_domain_webapi_models_Callback(arg1);
    var jsx$1 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x$6).isDefined__Z()
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var this$2 = $as_Lamf_core_model_domain_Linkable(this.callbacks$1.head__O());
    var this$3 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2);
    if ((!this$3.isEmpty__Z())) {
      var arg1$1 = this$3.get__O();
      var l = $as_Lamf_core_model_domain_DomainElement(arg1$1);
      var this$4 = $as_Lamf_core_model_domain_Linkable(this.callbacks$1.head__O());
      new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter().init___Lamf_core_model_domain_DomainElement__s_Option__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(l, $as_Lamf_core_model_StrField(this$4.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1, this.references$1, this.spec$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(p)
    }
  } else {
    var jsx$7 = p.builder$1;
    var sourceName = p.sourceName$2;
    var b = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    var jsx$6 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var jsx$5 = this.callbacks$1;
    var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(callback$2) {
        var callback = $as_Lamf_plugins_domain_webapi_models_Callback(callback$2);
        var jsx$4 = $m_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$();
        var jsx$3 = $as_Lamf_plugins_domain_webapi_models_EndPoint(callback.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$().Endpoint$1));
        var this$6 = $as_Lamf_core_model_StrField(callback.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$().Expression$1));
        var this$7 = this$6.option$1;
        return jsx$4.endpointEmitterWithPath__Lamf_plugins_domain_webapi_models_EndPoint__T__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext__Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter(jsx$3, $as_T((this$7.isEmpty__Z() ? null : this$7.get__O())), $this.ordering$1, $this.references$1, $this.spec$1)
      })
    })(this));
    var this$8 = $m_sc_Seq$();
    jsx$6.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V($as_sc_Seq(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$2, this$8.ReusableCBFInstance$2)), b);
    jsx$7.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter)) {
    var OasCallbackEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter(x$1);
    var x = this.callbacks$1;
    var x$2 = OasCallbackEmitter$1.callbacks$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasCallbackEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = OasCallbackEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.callbacks$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(callbacks, ordering, references, spec) {
  this.callbacks$1 = callbacks;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$1 = this.callbacks$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$8 = $as_Lamf_plugins_domain_webapi_models_Callback(arg1);
    var this$2 = new $c_s_Some().init___O(x$8.annotations$1)
  };
  var annotations = $as_Lamf_core_parser_Annotations((this$2.isEmpty__Z() ? ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()) : this$2.get__O()));
  return this$4.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasCallbackEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasCallbackEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasCallbackEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter() {
  $c_O.call(this);
  this.callbacks$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.annotations$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_core_parser_Annotations__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(callbacks, ordering, references, annotations, spec) {
  this.callbacks$1 = callbacks;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.annotations$1 = annotations;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter.prototype.productPrefix__T = (function() {
  return "OasCallbacksEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$3 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var stringToCallbacks = this.callbacks$1.groupBy__F1__sci_Map(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$4$2) {
      var x$4 = $as_Lamf_plugins_domain_webapi_models_Callback(x$4$2);
      var this$3 = $as_Lamf_core_model_StrField(x$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$().Name$1));
      var this$4 = this$3.option$1;
      return $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()))
    })
  })(this)));
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var name = $as_T(x0$1.$$und1__O());
        var callbacks = $as_sc_Seq(x0$1.$$und2__O());
        var jsx$2 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbackEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(callbacks, this$2$1.ordering$1, this$2$1.references$1, this$2$1.spec$1);
        var jsx$1 = $m_Lorg_yaml_model_YType$().Str$1;
        var this$8 = $m_Lamf_core_emitter_BaseEmitters_package$();
        var this$5 = callbacks.headOption__s_Option();
        if (this$5.isEmpty__Z()) {
          var this$6 = $m_s_None$()
        } else {
          var arg1 = this$5.get__O();
          var x$5 = $as_Lamf_plugins_domain_webapi_models_Callback(arg1);
          var this$6 = new $c_s_Some().init___O(x$5.annotations$1)
        };
        var annotations$1 = $as_Lamf_core_parser_Annotations((this$6.isEmpty__Z() ? ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()) : this$6.get__O()));
        return new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position(name, jsx$2, jsx$1, this$8.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations$1, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this));
  var this$9 = $m_sci_Iterable$();
  var bf = this$9.ReusableCBFInstance$2;
  var emitters = $as_sc_TraversableOnce($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(stringToCallbacks, f, bf)).toSeq__sc_Seq();
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(emitters), b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter)) {
    var OasCallbacksEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter(x$1);
    var x = this.callbacks$1;
    var x$2 = OasCallbacksEmitter$1.callbacks$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasCallbacksEmitter$1.ordering$1;
      var jsx$2 = (x$3 === x$4)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.references$1;
      var x$6 = OasCallbacksEmitter$1.references$1;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.annotations$1;
      var x$8 = OasCallbacksEmitter$1.annotations$1;
      return (x$7 === x$8)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.callbacks$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    case 3: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasCallbacksEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasCallbacksEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasCallbacksEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter() {
  $c_O.call(this);
  this.payloads$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.annotations$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_core_parser_Annotations__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(payloads, ordering, references, annotations, spec) {
  this.payloads$1 = payloads;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.annotations$1 = annotations;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter.prototype.productPrefix__T = (function() {
  return "OasContentPayloadsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$6 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$5 = this.payloads$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(payload$2) {
      var payload = $as_Lamf_plugins_domain_webapi_models_Payload(payload$2);
      var this$3 = $as_Lamf_core_model_StrField(payload.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1));
      var this$4 = this$3.option$1;
      var jsx$4 = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
      var jsx$3 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter().init___Lamf_plugins_domain_webapi_models_Payload__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(payload, $this.ordering$1, $this.references$1, $this.spec$1);
      var jsx$2 = $m_Lorg_yaml_model_YType$().Str$1;
      var this$5 = $m_Lamf_core_emitter_BaseEmitters_package$();
      var annotations$1 = payload.annotations$1;
      return new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position(jsx$4, jsx$3, jsx$2, this$5.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations$1, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
    })
  })(this));
  var this$6 = $m_sc_Seq$();
  var emitters = $as_sc_Seq(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2));
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(emitters), b$1);
  jsx$6.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter)) {
    var OasContentPayloadsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter(x$1);
    var x = this.payloads$1;
    var x$2 = OasContentPayloadsEmitter$1.payloads$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasContentPayloadsEmitter$1.ordering$1;
      var jsx$2 = (x$3 === x$4)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.references$1;
      var x$6 = OasContentPayloadsEmitter$1.references$1;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.annotations$1;
      var x$8 = OasContentPayloadsEmitter$1.annotations$1;
      return (x$7 === x$8)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.payloads$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    case 3: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasContentPayloadsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasContentPayloadsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasContentPayloadsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter() {
  $c_O.call(this);
  this.parameters$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter.prototype.productPrefix__T = (function() {
  return "OasDeclaredHeadersEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter)) {
    var OasDeclaredHeadersEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter(x$1);
    var x = this.parameters$1;
    var x$2 = OasDeclaredHeadersEmitter$1.parameters$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasDeclaredHeadersEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = OasDeclaredHeadersEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.parameters$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("headers");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$2 = this.parameters$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$29$2) {
      var x$29 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$29$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter().init___Lamf_plugins_domain_webapi_models_Parameter__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(x$29, $this.ordering$1, $this.references$1, $this.spec$1)
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  var emitters = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(emitters), b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$4 = j;
    var index = i;
    xs.set(jsx$4, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(parameters, ordering, references, spec) {
  this.parameters$1 = parameters;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.parameters$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var param = $as_Lamf_plugins_domain_webapi_models_Parameter(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = param.annotations$1;
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasDeclaredHeadersEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasDeclaredHeadersEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasDeclaredHeadersEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasDeclaredHeadersEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter() {
  $c_O.call(this);
  this.encoding$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter.prototype.productPrefix__T = (function() {
  return "OasEncodingEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter)) {
    var OasEncodingEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter(x$1);
    var x = this.encoding$1;
    var x$2 = OasEncodingEmitter$1.encoding$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasEncodingEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = OasEncodingEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.encoding$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var fs = this.encoding$1.fields$1;
  $m_Lorg_yaml_model_YNode$();
  var this$2 = this.encoding$1;
  var this$3 = $as_Lamf_core_model_StrField(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().PropertyName$1));
  var this$4 = this$3.option$1;
  var str = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$7 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().ContentType$1);
  if ((!this$7.isEmpty__Z())) {
    var arg1 = this$7.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("contentType", f, $m_s_None$())))
  };
  var this$9 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().Headers$1);
  if ((!this$9.isEmpty__Z())) {
    var arg1$1 = this$9.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("headers", f$3, this.ordering$1, this.references$1, this.spec$1)))
  };
  var this$10 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().Style$1);
  if ((!this$10.isEmpty__Z())) {
    var arg1$2 = this$10.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("style", f$4, $m_s_None$())))
  };
  var this$12 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().Explode$1);
  if ((!this$12.isEmpty__Z())) {
    var arg1$3 = this$12.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("explode", f$5, $m_s_None$())))
  };
  var this$14 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().AllowReserved$1);
  if ((!this$14.isEmpty__Z())) {
    var arg1$4 = this$14.get__O();
    var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("allowReserved", f$6, $m_s_None$())))
  };
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$18 = v.builder$1;
  var array = [key];
  if ((this$18.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$18.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$18, newSize);
  var len$1 = this$18.size0$6;
  var src = this$18.array$6;
  var dest = this$18.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$18.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$18.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Encoding__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(encoding, ordering, references, spec) {
  this.encoding$1 = encoding;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.encoding$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasEncodingEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasEncodingEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasEncodingEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.f$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter.prototype.encodings__p1__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq = (function(f, ordering, references) {
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(f.value$1.value$1).values$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ordering$1, references$1) {
    return (function(e$2) {
      var e = $as_Lamf_core_model_domain_AmfElement(e$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingEmitter().init___Lamf_plugins_domain_webapi_models_Encoding__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext($as_Lamf_plugins_domain_webapi_models_Encoding(e), ordering$1, references$1, $this.spec$1)
    })
  })(this, ordering, references));
  var this$1 = $m_sc_Seq$();
  var result = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  return ordering.sorted__sc_Seq__sc_Seq(result)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter.prototype.productPrefix__T = (function() {
  return "OasEncodingsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter)) {
    var OasEncodingsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter(x$1);
    if ((this.key$1 === OasEncodingsEmitter$1.key$1)) {
      var x = this.f$1;
      var x$2 = OasEncodingsEmitter$1.f$1;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$3 = this.ordering$1;
      var x$4 = OasEncodingsEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = OasEncodingsEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.f$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var emitters = this.encodings__p1__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq(this.f$1, this.ordering$1, this.references$1);
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(emitters, b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter.prototype.init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, f, ordering, references, spec) {
  this.key$1 = key;
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasEncodingsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasEncodingsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasEncodingsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter() {
  $c_O.call(this);
  this.parameter$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Parameter__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(parameter, ordering, references, spec) {
  this.parameter$1 = parameter;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter.prototype.productPrefix__T = (function() {
  return "OasHeaderEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter)) {
    var OasHeaderEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter(x$1);
    var x = this.parameter$1;
    var x$2 = OasHeaderEmitter$1.parameter$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasHeaderEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = OasHeaderEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.parameter$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter.prototype.emitOas2Header__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$5 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var fs = this.parameter$1.fields$1;
  var jsx$2 = $m_s_Option$();
  var this$2 = this.parameter$1;
  if (jsx$2.apply__O__s_Option($as_Lamf_core_model_domain_Shape(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1))).isDefined__Z()) {
    var jsx$3 = $m_s_Option$();
    var this$3 = this.parameter$1;
    var this$4 = $as_Lamf_core_model_domain_Shape(this$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1));
    var jsx$1 = jsx$3.apply__O__s_Option($as_Lamf_core_model_StrField(this$4.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Description$1))).isEmpty__Z()
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Description$1);
    if ((!this$5.isEmpty__Z())) {
      var arg1 = this$5.get__O();
      var f = $as_Lamf_core_parser_FieldEntry(arg1);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("description", f, $m_s_None$(), this.spec$1)))
    }
  };
  var this$7 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1);
  if (this$7.isEmpty__Z()) {
    var jsx$4 = true
  } else {
    var arg1$1 = this$7.get__O();
    var x$26 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    var jsx$4 = x$26.value$1.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_ExplicitField.getClassOf())
  };
  if (jsx$4) {
    var this$8 = this$7
  } else {
    var this$8 = $m_s_None$()
  };
  if ((!this$8.isEmpty__Z())) {
    var arg1$2 = this$8.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("x-amf-required", f$3, $m_s_None$(), this.spec$1)))
  };
  var this$10 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1);
  if ((!this$10.isEmpty__Z())) {
    var arg1$3 = this$10.get__O();
    $as_Lamf_core_parser_FieldEntry(arg1$3);
    var this$11 = this.parameter$1;
    var x$1 = $as_Lamf_core_model_domain_Shape(this$11.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1));
    var x$2 = this.ordering$1;
    var x$4 = this.references$1;
    var x$5 = $m_sci_Nil$();
    var x$6 = $m_sci_Nil$();
    var x$7 = $m_sci_Nil$();
    new $c_s_Some().init___O(result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x$1, x$2, x$5, x$4, x$6, x$7, true, this.spec$1).entries__sc_Seq()))
  };
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter.prototype.emitParameterKey__Lamf_core_parser_Fields__Lorg_yaml_model_YDocument$PartBuilder__V = (function(fs, b) {
  var this$1 = $as_Lamf_core_parser_FieldEntry(fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1).get__O());
  new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType($as_Lamf_core_model_domain_AmfScalar(this$1.value$1.value$1), $m_Lorg_yaml_model_YType$().Str$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$2 = this.parameter$1;
  if (($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2).isDefined__Z() && (!(this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory() instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory)))) {
    this.emitLink__p1__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
  } else {
    this.emitParameter__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter.prototype.emitParameter__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var this$1 = this.parameter$1;
  var str = $as_T($as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1)).option$1.get__O());
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  if ((this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory() instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory)) {
    new $c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter().init___Lamf_plugins_domain_webapi_models_Parameter__Lamf_core_emitter_SpecOrdering__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.parameter$1, this.ordering$1, this.references$1, true, this.spec$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v)
  } else {
    this.emitOas2Header__Lorg_yaml_model_YDocument$PartBuilder__V(v)
  };
  var this$5 = v.builder$1;
  var array = [key];
  if ((this$5.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$5.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$5, newSize);
  var len$1 = this$5.size0$6;
  var src = this$5.array$6;
  var dest = this$5.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$5.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$5.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.parameter$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter.prototype.emitLink__p1__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.parameter$1;
  var fs = $as_Lamf_core_model_domain_AmfObject($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1).get__O()).fields__Lamf_core_parser_Fields();
  var k = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  this.emitParameterKey__Lamf_core_parser_Fields__Lorg_yaml_model_YDocument$PartBuilder__V(fs, k);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var this$2 = this.parameter$1;
  var this$3 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2);
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var l = $as_Lamf_core_model_domain_DomainElement(arg1);
    var jsx$1 = this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory().tagToReferenceEmitter__F3();
    var this$4 = this.parameter$1;
    $as_Lamf_core_emitter_PartEmitter(jsx$1.apply__O__O__O__O(l, $as_Lamf_core_model_StrField(this$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1, this.references$1)).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v)
  };
  var this$5 = k.builder$1;
  var jsx$2 = $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$5, 0));
  var this$6 = v.builder$1;
  b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(jsx$2, $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$6, 0)))
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasHeaderEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasHeaderEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasHeaderEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter() {
  $c_O.call(this);
  this.link$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter.prototype.productPrefix__T = (function() {
  return "OasLinkEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(p) {
  var this$1 = this.link$1;
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1).isDefined__Z()) {
    var this$2 = this.link$1;
    var this$3 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2);
    if ((!this$3.isEmpty__Z())) {
      var arg1 = this$3.get__O();
      var l = $as_Lamf_core_model_domain_DomainElement(arg1);
      var this$4 = this.link$1;
      new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter().init___Lamf_core_model_domain_DomainElement__s_Option__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(l, $as_Lamf_core_model_StrField(this$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1, this.references$1, this.spec$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(p)
    }
  } else {
    var result = $m_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter$().emitters__Lamf_plugins_domain_webapi_models_TemplatedLink__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext__scm_ListBuffer(this.link$1, this.ordering$1, this.references$1, this.spec$1);
    var jsx$1 = p.builder$1;
    var sourceName = p.sourceName$2;
    var b = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b);
    jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter)) {
    var OasLinkEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter(x$1);
    var x = this.link$1;
    var x$2 = OasLinkEmitter$1.link$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasLinkEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = OasLinkEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.link$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter.prototype.init___Lamf_plugins_domain_webapi_models_TemplatedLink__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(link, ordering, references, spec) {
  this.link$1 = link;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.link$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasLinkEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasLinkEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasLinkEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter() {
  $c_O.call(this);
  this.links$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.annotations$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_core_parser_Annotations__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(links, ordering, references, annotations, spec) {
  this.links$1 = links;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.annotations$1 = annotations;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter.prototype.productPrefix__T = (function() {
  return "OasLinksEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$6 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$5 = this.links$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(link$2) {
      var link = $as_Lamf_plugins_domain_webapi_models_TemplatedLink(link$2);
      var this$3 = $as_Lamf_core_model_StrField(link.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Name$1));
      var this$4 = this$3.option$1;
      var jsx$4 = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
      var jsx$3 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkEmitter().init___Lamf_plugins_domain_webapi_models_TemplatedLink__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(link, $this.ordering$1, $this.references$1, $this.spec$1);
      var jsx$2 = $m_Lorg_yaml_model_YType$().Str$1;
      var this$5 = $m_Lamf_core_emitter_BaseEmitters_package$();
      var annotations$1 = link.annotations$1;
      return new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position(jsx$4, jsx$3, jsx$2, this$5.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations$1, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
    })
  })(this));
  var this$6 = $m_sc_Seq$();
  var emitters = $as_sc_Seq(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2));
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(emitters), b$1);
  jsx$6.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter)) {
    var OasLinksEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter(x$1);
    var x = this.links$1;
    var x$2 = OasLinksEmitter$1.links$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasLinksEmitter$1.ordering$1;
      var jsx$2 = (x$3 === x$4)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.references$1;
      var x$6 = OasLinksEmitter$1.references$1;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.annotations$1;
      var x$8 = OasLinksEmitter$1.annotations$1;
      return (x$7 === x$8)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.links$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    case 3: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasLinksEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasLinksEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasLinksEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter() {
  $c_O.call(this);
  this.oasParameters$1 = null;
  this.references$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter__sc_Seq__sc_Seq = (function($$outer, oasParameters, references) {
  this.oasParameters$1 = oasParameters;
  this.references$1 = references;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter.prototype.productPrefix__T = (function() {
  return "OasParameterEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var OasParameterEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter(x$1);
    var x = this.oasParameters$1;
    var x$2 = OasParameterEmitter$1.oasParameters$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.references$1;
      var x$4 = OasParameterEmitter$1.references$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.oasParameters$1;
      break
    }
    case 1: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  if ((this.oasParameters$1.nonEmpty__Z() || this.$$outer$1.payloads$1.nonEmpty__Z())) {
    $m_Lorg_yaml_model_YNode$();
    var str = this.$$outer$1.key$1;
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$2 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V(this.$$outer$1.amf$plugins$document$webapi$parser$spec$domain$OasParametersEmitter$$parameters__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq(this.oasParameters$1, this.$$outer$1.ordering$1, this.references$1), b$1);
    var jsx$1 = $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YSequence$();
    var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
    var parts = b$1.builder$1;
    var node = jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
    jsx$2.$$plus$eq__O__scm_ArrayBuffer(node);
    var this$6 = v.builder$1;
    var array = [key];
    if ((this$6.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$6.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
    var len$1 = this$6.size0$6;
    var src = this$6.array$6;
    var dest = this$6.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$6.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$3 = j;
      var index = i;
      xs.set(jsx$3, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$6.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.oasParameters$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var p = $as_Lamf_plugins_domain_webapi_models_Parameter(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = p.annotations$1;
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  if (this$3.isEmpty__Z()) {
    var this$4 = this.$$outer$1.payloads$1.headOption__s_Option();
    if (this$4.isEmpty__Z()) {
      var this$6 = $m_s_None$()
    } else {
      var arg1$1 = this$4.get__O();
      var p$1 = $as_Lamf_plugins_domain_webapi_models_Payload(arg1$1);
      var this$5 = $m_Lamf_core_emitter_BaseEmitters_package$();
      var annotations$1 = p$1.annotations$1;
      var this$6 = new $c_s_Some().init___O(this$5.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations$1, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
    };
    var jsx$1 = $as_Lamf_core_parser_Position((this$6.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$6.get__O()))
  } else {
    var jsx$1 = this$3.get__O()
  };
  return $as_Lamf_core_parser_Position(jsx$1)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasParametersEmitter$OasParameterEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasParametersEmitter$OasParameterEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasParametersEmitter$OasParameterEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$OasParameterEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.ramlParameters$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter.prototype.productPrefix__T = (function() {
  return "XRamlParameterEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var XRamlParameterEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter(x$1);
    if ((this.key$1 === XRamlParameterEmitter$1.key$1)) {
      var x = this.ramlParameters$1;
      var x$2 = XRamlParameterEmitter$1.ramlParameters$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.ramlParameters$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  if (this.ramlParameters$1.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var str = this.key$1;
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$4 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    var jsx$3 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var jsx$2 = this.ramlParameters$1;
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(p$2) {
        var p = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2);
        return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter().init___Lamf_plugins_domain_webapi_models_Parameter__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(p, $this.$$outer$1.ordering$1, $m_sci_Nil$(), new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_XRaml10SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions($this.$$outer$1.spec$1.eh__Lamf_core_errorhandling_ErrorHandler(), $m_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$(), new $c_Lamf_core_emitter_ShapeRenderOptions().init___()))
      })
    })(this));
    var this$6 = $m_sc_Seq$();
    jsx$3.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2)), b$1);
    jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
    var this$9 = v.builder$1;
    var array = [key];
    if ((this$9.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$9.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$9, newSize);
    var len$1 = this$9.size0$6;
    var src = this$9.array$6;
    var dest = this$9.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$9.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$5 = j;
      var index = i;
      xs.set(jsx$5, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$9.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter__T__sc_Seq = (function($$outer, key, ramlParameters) {
  this.key$1 = key;
  this.ramlParameters$1 = ramlParameters;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.ramlParameters$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var p = $as_Lamf_plugins_domain_webapi_models_Parameter(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = p.annotations$1;
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasParametersEmitter$XRamlParameterEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasParametersEmitter$XRamlParameterEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasParametersEmitter$XRamlParameterEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter$XRamlParameterEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter() {
  $c_O.call(this);
  this.payload$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter.prototype.productPrefix__T = (function() {
  return "OasPayloadEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$2 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var fs = this.payload$1.fields$1;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  if ((this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory() instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory)) {
    var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Examples$1);
    if ((!this$3.isEmpty__Z())) {
      var arg1 = this$3.get__O();
      var f = $as_Lamf_core_parser_FieldEntry(arg1);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$().apply__T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter("examples", f, this.ordering$1, this.spec$1)))
    };
    var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Encoding$1);
    if ((!this$4.isEmpty__Z())) {
      var arg1$1 = this$4.get__O();
      var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEncodingsEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("encoding", f$3, this.ordering$1, this.references$1, this.spec$1)))
    }
  };
  if ((this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory() instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory)) {
    var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Name$1);
    if ((!this$5.isEmpty__Z())) {
      var arg1$2 = this$5.get__O();
      var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
      var x1 = f$4.value$1.annotations$1.find__jl_Class__s_Option($d_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload.getClassOf());
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var ann = $as_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload(x2.value$2);
        var x$2 = ann.paramName$1;
        var x$3 = ann.range$1.start$1;
        var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
        var jsx$1 = result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("name", x$2, x$4, x$3))
      } else {
        var jsx$1 = result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("name", f$4, $m_s_None$()))
      };
      new $c_s_Some().init___O(jsx$1)
    };
    var this$8 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1);
    if ((!this$8.isEmpty__Z())) {
      var arg1$3 = this$8.get__O();
      var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("mediaType", f$5, $m_s_None$())))
    }
  };
  var this$10 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1);
  if ((!this$10.isEmpty__Z())) {
    var arg1$4 = this$10.get__O();
    var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    new $c_s_Some().init___O(((!f$6.value$1.value$1.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_SynthesizedField.getClassOf())) ? result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(f$6, this.ordering$1, this.references$1, this.spec$1)) : (void 0)))
  };
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.payload$1, this.ordering$1, this.spec$1).emitters__sc_Seq());
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$2.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter)) {
    var OasPayloadEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter(x$1);
    var x = this.payload$1;
    var x$2 = OasPayloadEmitter$1.payload$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasPayloadEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = OasPayloadEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.payload$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Payload__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(payload, ordering, references, spec) {
  this.payload$1 = payload;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.payload$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasPayloadEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasPayloadEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasPayloadEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.payloads$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter.prototype.productPrefix__T = (function() {
  return "OasPayloadsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter)) {
    var OasPayloadsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter(x$1);
    if ((this.key$1 === OasPayloadsEmitter$1.key$1)) {
      var x = this.payloads$1;
      var x$2 = OasPayloadsEmitter$1.payloads$1;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$3 = this.ordering$1;
      var x$4 = OasPayloadsEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = OasPayloadsEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.payloads$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter.prototype.init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(key, payloads, ordering, references, spec) {
  this.key$1 = key;
  this.payloads$1 = payloads;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$6 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  var jsx$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var jsx$3 = this.ordering$1;
  var jsx$2 = this.payloads$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(p$2) {
      var p = $as_Lamf_plugins_domain_webapi_models_Payload(p$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadEmitter().init___Lamf_plugins_domain_webapi_models_Payload__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(p, $this.ordering$1, $this.references$1, $this.spec$1)
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  jsx$4.traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V(jsx$3.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))), b$1);
  var jsx$5 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$5.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$6.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$7 = j;
    var index = i;
    xs.set(jsx$7, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var filtered = $as_sc_Seq(this.payloads$1.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(p$2) {
      var p = $as_Lamf_plugins_domain_webapi_models_Payload(p$2);
      var this$1 = p.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      if ((!this$1.isEmpty__Z())) {
        var arg1 = this$1.get__O();
        var x$3 = $as_Lamf_core_annotations_LexicalInformation(arg1);
        return (!x$3.range__Lamf_core_parser_Range().start$1.isZero__Z())
      } else {
        return false
      }
    })
  })(this))));
  var result = $as_Lamf_core_parser_Position(filtered.foldLeft__O__F2__O($m_Lamf_core_parser_Position$ZERO$(), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$2) {
    return (function(pos$2, p$3$2) {
      var pos = $as_Lamf_core_parser_Position(pos$2);
      var p$3 = $as_Lamf_plugins_domain_webapi_models_Payload(p$3$2);
      var this$3 = p$3.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      if (this$3.isEmpty__Z()) {
        var this$4 = $m_s_None$()
      } else {
        var arg1$1 = this$3.get__O();
        var x$4 = $as_Lamf_core_annotations_LexicalInformation(arg1$1);
        var this$4 = new $c_s_Some().init___O(x$4.range__Lamf_core_parser_Range().start$1)
      };
      if (this$4.isEmpty__Z()) {
        var jsx$1 = true
      } else {
        var arg1$2 = this$4.get__O();
        var newPos = $as_Lamf_core_parser_Position(arg1$2);
        var jsx$1 = (pos.isZero__Z() || pos.lt__Lamf_core_parser_Position__Z(newPos))
      };
      if (jsx$1) {
        var this$5 = this$4
      } else {
        var this$5 = $m_s_None$()
      };
      return $as_Lamf_core_parser_Position((this$5.isEmpty__Z() ? pos : this$5.get__O()))
    })
  })(this))));
  return result
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasPayloadsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasPayloadsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasPayloadsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter() {
  $c_O.call(this);
  this.response$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.isDeclaration$1 = false;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter.prototype.productPrefix__T = (function() {
  return "OasResponseEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter)) {
    var OasResponseEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter(x$1);
    var x = this.response$1;
    var x$2 = OasResponseEmitter$1.response$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasResponseEmitter$1.ordering$1;
      var jsx$2 = (x$3 === x$4)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.references$1;
      var x$6 = OasResponseEmitter$1.references$1;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.isDeclaration$1 === OasResponseEmitter$1.isDeclaration$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.response$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    case 3: {
      return this.isDeclaration$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter.prototype.statusCodeOrName__p1__Lamf_core_parser_Fields__s_Option = (function(fs) {
  var statusCode = ((!this.isDeclaration$1) ? fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1) : $m_s_None$());
  var this$1 = (statusCode.isEmpty__Z() ? fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Name$1) : statusCode);
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$4 = $as_Lamf_core_parser_FieldEntry(arg1);
    return new $c_s_Some().init___O($as_Lamf_core_model_domain_AmfScalar(x$4.value$1.value$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var fs = this.response$1.fields$2;
  var k = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var this$2 = this.statusCodeOrName__p1__Lamf_core_parser_Fields__s_Option(fs);
  new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType($as_Lamf_core_model_domain_AmfScalar((this$2.isEmpty__Z() ? new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations("default", new $c_Lamf_core_parser_Annotations().init___()) : this$2.get__O())), $m_Lorg_yaml_model_YType$().Str$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(k);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var this$5 = this.response$1;
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$5).isDefined__Z()) {
    this.spec$1.localReference__Lamf_core_model_domain_Linkable__Lamf_core_emitter_PartEmitter(this.response$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v)
  } else {
    var jsx$3 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var this$7 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Description$1);
    if (this$7.isEmpty__Z()) {
      var jsx$1 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Description$1;
      var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations("", new $c_Lamf_core_parser_Annotations().init___());
      $m_Lamf_core_parser_Annotations$();
      var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
      var this$11 = new $c_s_Some().init___O(new $c_Lamf_core_parser_FieldEntry().init___Lamf_core_metamodel_Field__Lamf_core_parser_Value(jsx$1, new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value, annotations$1)))
    } else {
      var this$11 = this$7
    };
    if ((!this$11.isEmpty__Z())) {
      var arg1 = this$11.get__O();
      var f = $as_Lamf_core_parser_FieldEntry(arg1);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f, $m_s_None$())))
    };
    var this$13 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Headers$1);
    if ((!this$13.isEmpty__Z())) {
      var arg1$1 = this$13.get__O();
      var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("headers", f$3, this.ordering$1, this.references$1, this.spec$1)))
    };
    if ((this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory() instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory)) {
      var this$14 = this.response$1.fields$2;
      var this$17 = this$14.fs$1;
      var this$15 = $m_Lamf_core_parser_FieldEntry$();
      var f$1 = $f_F2__tupled__F1(this$15);
      var this$16 = $m_sci_Iterable$();
      var bf = this$16.ReusableCBFInstance$2;
      var this$18 = $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$17, f$1, bf)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
        return (function(x$2$2) {
          var x$2 = $as_Lamf_core_parser_FieldEntry(x$2$2);
          var x = x$2.field$1;
          var x$3 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Payloads$1;
          return ((x === null) ? (x$3 === null) : x.equals__O__Z(x$3))
        })
      })(this)));
      if ((!this$18.isEmpty__Z())) {
        var arg1$2 = this$18.get__O();
        var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
        var payloads = f$4.arrayValues__sc_Seq();
        var annotations$2 = f$4.value$1.annotations$1;
        result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position("content", new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_core_parser_Annotations__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(payloads, this.ordering$1, this.references$1, annotations$2, this.spec$1), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()))
      };
      var this$21 = this.response$1.fields$2;
      var this$24 = this$21.fs$1;
      var this$22 = $m_Lamf_core_parser_FieldEntry$();
      var f$2 = $f_F2__tupled__F1(this$22);
      var this$23 = $m_sci_Iterable$();
      var bf$1 = this$23.ReusableCBFInstance$2;
      var this$25 = $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$24, f$2, bf$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1) {
        return (function(x$3$2) {
          var x$3$1 = $as_Lamf_core_parser_FieldEntry(x$3$2);
          var x$1 = x$3$1.field$1;
          var x$2$1 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Links$1;
          return ((x$1 === null) ? (x$2$1 === null) : x$1.equals__O__Z(x$2$1))
        })
      })(this)));
      if ((!this$25.isEmpty__Z())) {
        var arg1$3 = this$25.get__O();
        var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
        var links = f$5.arrayValues__sc_Seq();
        var annotations$3 = f$5.value$1.annotations$1;
        result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position("links", new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinksEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_core_parser_Annotations__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(links, this.ordering$1, this.references$1, annotations$3, this.spec$1), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()))
      }
    };
    if ((this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory() instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory)) {
      var jsx$2 = $m_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$();
      var this$28 = this.response$1;
      var payloads$1 = jsx$2.apply__sc_Seq__Z__Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads($as_sc_Seq(this$28.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1)), false);
      var this$29 = payloads$1.default$1;
      if ((!this$29.isEmpty__Z())) {
        var arg1$4 = this$29.get__O();
        var payload = $as_Lamf_plugins_domain_webapi_models_Payload(arg1$4);
        var this$30 = payload.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1);
        if ((!this$30.isEmpty__Z())) {
          var arg1$5 = this$30.get__O();
          var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$5);
          new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("mediaType").asOasExtension__T(), f$6, $m_s_None$())))
        };
        var this$33 = payload.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1);
        if ((!this$33.isEmpty__Z())) {
          var arg1$6 = this$33.get__O();
          var f$3$1 = $as_Lamf_core_parser_FieldEntry(arg1$6);
          new $c_s_Some().init___O(((!f$3$1.value$1.value$1.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_SynthesizedField.getClassOf())) ? result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(f$3$1, this.ordering$1, this.references$1, this.spec$1)) : (void 0)))
        }
      };
      if (payloads$1.other$1.nonEmpty__Z()) {
        result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(new $c_Lamf_core_utils_package$AmfStrings().init___T("responsePayloads").asOasExtension__T(), payloads$1.other$1, this.ordering$1, this.references$1, this.spec$1))
      }
    };
    var this$35 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Examples$1);
    if ((!this$35.isEmpty__Z())) {
      var arg1$7 = this$35.get__O();
      var f$6$1 = $as_Lamf_core_parser_FieldEntry(arg1$7);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$().apply__T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter("examples", f$6$1, this.ordering$1, this.spec$1)))
    };
    result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.response$1, this.ordering$1, this.spec$1).emitters__sc_Seq());
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
    jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  };
  var this$36 = k.builder$1;
  var jsx$4 = $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$36, 0));
  var this$37 = v.builder$1;
  b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(jsx$4, $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$37, 0)))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Response__Lamf_core_emitter_SpecOrdering__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(response, ordering, references, isDeclaration, spec) {
  this.response$1 = response;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.isDeclaration$1 = isDeclaration;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.response$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ordering$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.references$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.isDeclaration$1 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 4)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.response$1.annotations$2;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasResponseEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasResponseEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasResponseEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter() {
  $c_O.call(this);
  this.example$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter.prototype.productPrefix__T = (function() {
  return "OasResponseExampleEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter)) {
    var OasResponseExampleEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter(x$1);
    var x = this.example$1;
    var x$2 = OasResponseExampleEmitter$1.example$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasResponseExampleEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.example$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.example$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1);
  if (this$1.isEmpty__Z()) {
    var this$2 = this.example$1;
    var this$3 = $as_Lamf_core_model_StrField(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1)).option$1;
    if ((!this$3.isEmpty__Z())) {
      var arg1 = this$3.get__O();
      var s = $as_T(arg1);
      $m_Lorg_yaml_model_YNode$();
      var str = this.keyName__Lamf_plugins_domain_shapes_models_Example__T(this.example$1);
      var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
      var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
      new $c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter().init___T(s).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
      var this$7 = v.builder$1;
      var array = [key];
      if ((this$7.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len = $uI(array.length);
      var newSize = ((this$7.size0$6 + len) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
      var len$1 = this$7.size0$6;
      var src = this$7.array$6;
      var dest = this$7.array$6;
      $systemArraycopy(src, 0, dest, len, len$1);
      var xs = this$7.array$6;
      var len$2 = xs.u.length;
      var i = 0;
      var j = 0;
      var x = $uI(array.length);
      var x$1 = ((x < len$2) ? x : len$2);
      var that = xs.u.length;
      var end = ((x$1 < that) ? x$1 : that);
      while ((i < end)) {
        var jsx$1 = j;
        var index = i;
        xs.set(jsx$1, array[index]);
        i = ((1 + i) | 0);
        j = ((1 + j) | 0)
      };
      this$7.size0$6 = newSize;
      b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
    }
  } else {
    var arg1$1 = this$1.get__O();
    $as_Lamf_core_parser_FieldEntry(arg1$1);
    $m_Lorg_yaml_model_YNode$();
    var str$1 = this.keyName__Lamf_plugins_domain_shapes_models_Example__T(this.example$1);
    var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
    var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var this$19 = this.example$1;
    new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler($as_Lamf_core_model_domain_DataNode(this$19.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1)), this.ordering$1, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler()).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v$1);
    var this$23 = v$1.builder$1;
    var array$1 = [key$1];
    if ((this$23.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$3 = $uI(array$1.length);
    var newSize$1 = ((this$23.size0$6 + len$3) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$23, newSize$1);
    var len$4 = this$23.size0$6;
    var src$1 = this$23.array$6;
    var dest$1 = this$23.array$6;
    $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
    var xs$1 = this$23.array$6;
    var len$5 = xs$1.u.length;
    var i$1 = 0;
    var j$1 = 0;
    var x$2 = $uI(array$1.length);
    var x$3 = ((x$2 < len$5) ? x$2 : len$5);
    var that$1 = xs$1.u.length;
    var end$1 = ((x$3 < that$1) ? x$3 : that$1);
    while ((i$1 < end$1)) {
      var jsx$2 = j$1;
      var index$1 = i$1;
      xs$1.set(jsx$2, array$1[index$1]);
      i$1 = ((1 + i$1) | 0);
      j$1 = ((1 + j$1) | 0)
    };
    this$23.size0$6 = newSize$1;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter.prototype.init___Lamf_plugins_domain_shapes_models_Example__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(example, ordering, spec) {
  this.example$1 = example;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter.prototype.keyName__Lamf_plugins_domain_shapes_models_Example__T = (function(example) {
  if ((this.spec$1.factory__Lamf_plugins_document_webapi_contexts_SpecEmitterFactory() instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory)) {
    var this$1 = $as_Lamf_core_model_StrField(example.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Name$1));
    var this$2 = this$1.option$1;
    return $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()))
  } else {
    var this$3 = $as_Lamf_core_model_StrField(example.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().MediaType$1));
    var this$4 = this$3.option$1;
    return $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.example$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasResponseExampleEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasResponseExampleEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasResponseExampleEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.examples$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter.prototype.productPrefix__T = (function() {
  return "OasResponseExamplesEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter.prototype.init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, examples, ordering, spec) {
  this.key$1 = key;
  this.examples$1 = examples;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter)) {
    var OasResponseExamplesEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter(x$1);
    if ((this.key$1 === OasResponseExamplesEmitter$1.key$1)) {
      var x = this.examples$1;
      var x$2 = OasResponseExamplesEmitter$1.examples$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.ordering$1;
      var x$4 = OasResponseExamplesEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.examples$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  if (this.examples$1.nonEmpty__Z()) {
    if ((this.spec$1.factory__Lamf_plugins_document_webapi_contexts_SpecEmitterFactory() instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory)) {
      $m_Lorg_yaml_model_YNode$();
      var str = this.key$1;
      var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
      var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
      var jsx$5 = v.builder$1;
      var sourceName = v.sourceName$2;
      var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
      var jsx$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
      var jsx$3 = this.ordering$1;
      var jsx$2 = this.examples$1;
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x$2$2) {
          var x$2 = $as_Lamf_plugins_domain_shapes_models_Example(x$2$2);
          return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ExampleValuesEmitter().init___Lamf_plugins_domain_shapes_models_Example__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x$2, $this.ordering$1, $this.spec$1)
        })
      })(this));
      var this$3 = $m_sc_Seq$();
      jsx$4.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$3.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))), b$1);
      jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
      var this$6 = v.builder$1;
      var array = [key];
      if ((this$6.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len = $uI(array.length);
      var newSize = ((this$6.size0$6 + len) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
      var len$1 = this$6.size0$6;
      var src = this$6.array$6;
      var dest = this$6.array$6;
      $systemArraycopy(src, 0, dest, len, len$1);
      var xs = this$6.array$6;
      var len$2 = xs.u.length;
      var i = 0;
      var j = 0;
      var x = $uI(array.length);
      var x$1 = ((x < len$2) ? x : len$2);
      var that = xs.u.length;
      var end = ((x$1 < that) ? x$1 : that);
      while ((i < end)) {
        var jsx$6 = j;
        var index = i;
        xs.set(jsx$6, array[index]);
        i = ((1 + i) | 0);
        j = ((1 + j) | 0)
      };
      this$6.size0$6 = newSize;
      b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
    } else {
      $m_Lorg_yaml_model_YNode$();
      var str$1 = this.key$1;
      var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
      var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
      var jsx$11 = v$1.builder$1;
      var sourceName$1 = v$1.sourceName$2;
      var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
      var jsx$10 = $m_Lamf_core_emitter_BaseEmitters_package$();
      var jsx$9 = this.ordering$1;
      var jsx$8 = this.examples$1;
      var jsx$7 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
        return (function(x$5$2) {
          var x$5 = $as_Lamf_plugins_domain_shapes_models_Example(x$5$2);
          return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExampleEmitter().init___Lamf_plugins_domain_shapes_models_Example__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x$5, $this$1.ordering$1, $this$1.spec$1)
        })
      })(this));
      var this$19 = $m_sc_Seq$();
      jsx$10.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$9.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$8.map__F1__scg_CanBuildFrom__O(jsx$7, this$19.ReusableCBFInstance$2))), b$2);
      jsx$11.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1));
      var this$22 = v$1.builder$1;
      var array$1 = [key$1];
      if ((this$22.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$3 = $uI(array$1.length);
      var newSize$1 = ((this$22.size0$6 + len$3) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$22, newSize$1);
      var len$4 = this$22.size0$6;
      var src$1 = this$22.array$6;
      var dest$1 = this$22.array$6;
      $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
      var xs$1 = this$22.array$6;
      var len$5 = xs$1.u.length;
      var i$1 = 0;
      var j$1 = 0;
      var x$3 = $uI(array$1.length);
      var x$4 = ((x$3 < len$5) ? x$3 : len$5);
      var that$1 = xs$1.u.length;
      var end$1 = ((x$4 < that$1) ? x$4 : that$1);
      while ((i$1 < end$1)) {
        var jsx$12 = j$1;
        var index$1 = i$1;
        xs$1.set(jsx$12, array$1[index$1]);
        i$1 = ((1 + i$1) | 0);
        j$1 = ((1 + j$1) | 0)
      };
      this$22.size0$6 = newSize$1;
      b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.examples$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var a = $as_Lamf_plugins_domain_shapes_models_Example(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = a.annotations$1;
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasResponseExamplesEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasResponseExamplesEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasResponseExamplesEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter() {
  $c_O.call(this);
  this.server$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter.prototype.productPrefix__T = (function() {
  return "OasServerEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var fs = this.server$1.fields$1;
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Url$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("url", f, $m_s_None$())))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Description$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f$3, $m_s_None$())))
  };
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Variables$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1$2 = this$5.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(f$4, this.ordering$1, this.spec$1)))
  };
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.server$1, this.ordering$1, this.spec$1).emitters__sc_Seq());
  var jsx$1 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter)) {
    var OasServerEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter(x$1);
    var x = this.server$1;
    var x$2 = OasServerEmitter$1.server$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasServerEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.server$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Server__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(server, ordering, spec) {
  this.server$1 = server;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.server$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasServerEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasServerEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasServerEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter() {
  $c_O.call(this);
  this.variable$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Parameter__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(variable, ordering, spec) {
  this.variable$1 = variable;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter.prototype.productPrefix__T = (function() {
  return "OasServerVariableEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter)) {
    var OasServerVariableEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter(x$1);
    var x = this.variable$1;
    var x$2 = OasServerVariableEmitter$1.variable$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasServerVariableEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.variable$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter.prototype.entries__p1__Lamf_plugins_domain_webapi_models_Parameter__sc_Seq = (function(variable) {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var shape = $as_Lamf_core_model_domain_Shape(variable.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1));
  var fs = shape.fields__Lamf_core_parser_Fields();
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ShapeModel$().Description$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f, $m_s_None$())))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ShapeModel$().Values$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_EnumValuesEmitter().init___T__Lamf_core_parser_Value__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("enum", f$3.value$1, this.ordering$1, this.spec$1)))
  };
  var x1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ShapeModel$().Default$1);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var f$4 = $as_Lamf_core_parser_FieldEntry(x2.value$2);
    var x$2 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_DataNodeEmitter().init___Lamf_core_model_domain_DataNode__Lamf_core_emitter_SpecOrdering__Z__scm_Map__Lamf_core_errorhandling_ErrorHandler($as_Lamf_core_model_domain_DataNode(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Default$1)), this.ordering$1, false, $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$())), this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler());
    var this$5 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = f$4.value$1.annotations$1;
    var x$3 = this$5.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position("default", x$2, x$4, x$3))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("default", "", $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var this$1 = this.variable$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
  var this$3 = this$2.option$1;
  var str = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.entries__p1__Lamf_plugins_domain_webapi_models_Parameter__sc_Seq(this.variable$1), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$8 = v.builder$1;
  var array = [key];
  if ((this$8.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$8.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$8, newSize);
  var len$1 = this$8.size0$6;
  var src = this$8.array$6;
  var dest = this$8.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$8.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$8.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.variable$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasServerVariableEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasServerVariableEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasServerVariableEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser.call(this);
  this.entry$2 = null;
  this.parent$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser.prototype.productPrefix__T = (function() {
  return "OasServerVariableParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function() {
  return $as_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.ctx$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser)) {
    var OasServerVariableParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser(x$1);
    var x = this.entry$2;
    var x$2 = OasServerVariableParser$1.entry$2;
    if ((x === x$2)) {
      return (this.parent$2 === OasServerVariableParser$1.parent$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$2;
      break
    }
    case 1: {
      return this.parent$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser.prototype.init___Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(entry, parent, ctx) {
  this.entry$2 = entry;
  this.parent$2 = parent;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser.prototype.init___Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.call(this, entry, parent, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser.prototype.requiredDefaultField__p2__Lamf_plugins_domain_webapi_models_Parameter__Lorg_yaml_model_YMap__V = (function(variable, map) {
  if (new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("default").isEmpty__Z()) {
    var this$2 = $as_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.ctx$1).eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().ServerVariableMissingDefault$1;
    var node = variable.id$1;
    var prop = $m_s_None$();
    var l = map.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$2, specification, node, prop, "Server variable must define a 'default' field", l)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser.prototype.parseMap__Lamf_plugins_domain_webapi_models_Parameter__Lorg_yaml_model_YMap__V = (function(variable, map) {
  this.requiredDefaultField__p2__Lamf_plugins_domain_webapi_models_Parameter__Lorg_yaml_model_YMap__V(variable, map);
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser.prototype.parseMap__Lamf_plugins_domain_webapi_models_Parameter__Lorg_yaml_model_YMap__V.call(this, variable, map)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasServerVariableParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasServerVariableParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasServerVariableParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter() {
  $c_O.call(this);
  this.f$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter.prototype.productPrefix__T = (function() {
  return "OasServerVariablesEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(f, ordering, spec) {
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter)) {
    var OasServerVariablesEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter(x$1);
    var x = this.f$1;
    var x$2 = OasServerVariablesEmitter$1.f$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasServerVariablesEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.f$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.f$1;
  var all = this$1.arrayValues__sc_Seq();
  var hasNonOas3Variables = all.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$5$2) {
      var x$5 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$5$2);
      return (!$m_Lamf_plugins_document_webapi_parser_spec_domain_Servers$().isVariable__Lamf_plugins_domain_webapi_models_Parameter__Z(x$5))
    })
  })(this)));
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("variables");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.variables__p1__sc_Seq__sc_Seq(all), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1));
  if (hasNonOas3Variables) {
    var jsx$6 = new $c_Lamf_core_utils_package$AmfStrings().init___T("parameters").asOasExtension__T();
    var jsx$5 = this.f$1;
    var jsx$4 = this.ordering$1;
    var jsx$3 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var spec = this.spec$1;
    new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(jsx$6, jsx$5, jsx$4, jsx$3, new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(spec.eh__Lamf_core_errorhandling_ErrorHandler(), spec.refEmitter$1, new $c_Lamf_core_emitter_ShapeRenderOptions().init___())).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter.prototype.variables__p1__sc_Seq__sc_Seq = (function(vars) {
  var jsx$2 = this.ordering$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(v$2) {
      var v = $as_Lamf_plugins_domain_webapi_models_Parameter(v$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableEmitter().init___Lamf_plugins_domain_webapi_models_Parameter__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(v, $this.ordering$1, $this.spec$1)
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  return jsx$2.sorted__sc_Seq__sc_Seq($as_sc_Seq(vars.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$1 = this.f$1;
  var annotations = this$1.value$1.value$1.annotations__Lamf_core_parser_Annotations();
  return this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasServerVariablesEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasServerVariablesEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasServerVariablesEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariablesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.f$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter.prototype.productPrefix__T = (function() {
  return "OasWithExtensionsSecurityRequirementsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter)) {
    var OasWithExtensionsSecurityRequirementsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter(x$1);
    if ((this.key$1 === OasWithExtensionsSecurityRequirementsEmitter$1.key$1)) {
      var x = this.f$1;
      var x$2 = OasWithExtensionsSecurityRequirementsEmitter$1.f$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.ordering$1;
      var x$4 = OasWithExtensionsSecurityRequirementsEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.f$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var value = this.f$1.value$1;
  var this$2 = this.f$1;
  var x1 = this.collect__sc_Seq__sc_Seq($as_Lamf_core_model_domain_AmfArray(this$2.value$1.value$1).values$1).partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(r$2) {
      var r = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(r$2);
      return $this.allSchemesAreValidInOas__sc_Seq__Lamf_core_remote_Vendor__Z($as_sc_Seq(r.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$().Schemes$1)), $this.spec$1.vendor__Lamf_core_remote_Vendor())
    })
  })(this)));
  if ((x1 === null)) {
    throw new $c_s_MatchError().init___O(x1)
  };
  var validOas = $as_sc_Seq(x1.$$und1__O());
  var invalidOas = $as_sc_Seq(x1.$$und2__O());
  if (validOas.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var str = this.key$1;
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$5 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
    var jsx$3 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var jsx$2 = this.ordering$1;
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
      return (function(scheme$2) {
        var scheme = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(scheme$2);
        return $this$1.emit__Lamf_plugins_domain_webapi_models_security_SecurityRequirement__Lamf_core_emitter_PartEmitter(scheme)
      })
    })(this));
    var this$5 = $m_sc_Seq$();
    jsx$3.traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V(jsx$2.sorted__sc_Seq__sc_Seq($as_sc_Seq(validOas.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))), b$1);
    var jsx$4 = $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YSequence$();
    var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
    var parts = b$1.builder$1;
    var node = jsx$4.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
    jsx$5.$$plus$eq__O__scm_ArrayBuffer(node);
    var this$9 = v.builder$1;
    var array = [key];
    if ((this$9.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$9.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$9, newSize);
    var len$1 = this$9.size0$6;
    var src = this$9.array$6;
    var dest = this$9.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$9.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$6 = j;
      var index = i;
      xs.set(jsx$6, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$9.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  };
  if (invalidOas.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var str$1 = this.key$1;
    var str$2 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str$1).asOasExtension__T();
    var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$2);
    var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$11 = v$1.builder$1;
    var sourceName$1 = v$1.sourceName$2;
    var b$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$1);
    var jsx$9 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var jsx$8 = this.ordering$1;
    var jsx$7 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2) {
      return (function(scheme$2$1) {
        var scheme$1 = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(scheme$2$1);
        return $this$2.emit__Lamf_plugins_domain_webapi_models_security_SecurityRequirement__Lamf_core_emitter_PartEmitter(scheme$1)
      })
    })(this));
    var this$23 = $m_sc_Seq$();
    jsx$9.traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V(jsx$8.sorted__sc_Seq__sc_Seq($as_sc_Seq(invalidOas.map__F1__scg_CanBuildFrom__O(jsx$7, this$23.ReusableCBFInstance$2))), b$2);
    var jsx$10 = $m_Lorg_yaml_model_YNode$();
    $m_Lorg_yaml_model_YSequence$();
    var loc$1 = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$1);
    var parts$1 = b$2.builder$1;
    var node$1 = jsx$10.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc$1, parts$1), $m_Lorg_yaml_model_YType$().Seq$1);
    jsx$11.$$plus$eq__O__scm_ArrayBuffer(node$1);
    var this$27 = v$1.builder$1;
    var array$1 = [key$1];
    if ((this$27.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$3 = $uI(array$1.length);
    var newSize$1 = ((this$27.size0$6 + len$3) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$27, newSize$1);
    var len$4 = this$27.size0$6;
    var src$1 = this$27.array$6;
    var dest$1 = this$27.array$6;
    $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
    var xs$1 = this$27.array$6;
    var len$5 = xs$1.u.length;
    var i$1 = 0;
    var j$1 = 0;
    var x$2 = $uI(array$1.length);
    var x$3 = ((x$2 < len$5) ? x$2 : len$5);
    var that$1 = xs$1.u.length;
    var end$1 = ((x$3 < that$1) ? x$3 : that$1);
    while ((i$1 < end$1)) {
      var jsx$12 = j$1;
      var index$1 = i$1;
      xs$1.set(jsx$12, array$1[index$1]);
      i$1 = ((1 + i$1) | 0);
      j$1 = ((1 + j$1) | 0)
    };
    this$27.size0$6 = newSize$1;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter.prototype.allSchemesAreValidInOas__sc_Seq__Lamf_core_remote_Vendor__Z = (function(schemes, vendor) {
  var nonLocalReturnKey1 = new $c_O().init___();
  try {
    return schemes.forall__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, nonLocalReturnKey1$1, vendor$1) {
      return (function(s$2) {
        var s = $as_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme(s$2);
        var x1 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(s.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Scheme$1));
        if ((x1 !== null)) {
          if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x1).isDefined__Z()) {
            throw new $c_sr_NonLocalReturnControl$mcZ$sp().init___O__Z(nonLocalReturnKey1$1, true)
          }
        };
        var this$1 = $m_s_Option$().apply__O__s_Option($as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(s.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Scheme$1)));
        if ((!this$1.isEmpty__Z())) {
          var arg1 = this$1.get__O();
          var s$2$1 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(arg1);
          var this$2 = $as_Lamf_core_model_StrField(s$2$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1)).option$1;
          var schemeType = $as_T((this$2.isEmpty__Z() ? "" : this$2.get__O()));
          return $m_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeSecuritySchemeTypeMappings$().validTypesFor__Lamf_core_remote_Vendor__sci_Set(vendor$1).contains__O__Z(schemeType)
        } else {
          return false
        }
      })
    })(this, nonLocalReturnKey1, vendor)))
  } catch (e) {
    if ((e instanceof $c_sr_NonLocalReturnControl)) {
      var ex = $as_sr_NonLocalReturnControl(e);
      if ((ex.key$2 === nonLocalReturnKey1)) {
        return ex.value$mcZ$sp__Z()
      } else {
        throw ex
      }
    } else {
      throw e
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter.prototype.collect__sc_Seq__sc_Seq = (function(elements) {
  var this$1 = this.f$1;
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(this$1.value$1.value$1).values$1;
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter$$anonfun$collect$2().init___Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter(this);
  var this$2 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter.prototype.emit__Lamf_plugins_domain_webapi_models_security_SecurityRequirement__Lamf_core_emitter_PartEmitter = (function(scheme) {
  return $as_Lamf_core_emitter_PartEmitter(this.spec$1.factory__Lamf_plugins_document_webapi_contexts_SpecEmitterFactory().securityRequirementEmitter__F2().apply__O__O__O(scheme, this.ordering$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter.prototype.init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, f, ordering, spec) {
  this.key$1 = key;
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasWithExtensionsSecurityRequirementsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasWithExtensionsSecurityRequirementsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasWithExtensionsSecurityRequirementsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter() {
  $c_O.call(this);
  this.parameter$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.asHeader$1 = false;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter.prototype.productPrefix__T = (function() {
  return "ParameterEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var this$2 = this.parameter$1;
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2).isDefined__Z()) {
    this.emitLink__p1__Lorg_yaml_model_YDocument$PartBuilder__V(b)
  } else {
    var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var fs = this.parameter$1.fields$1;
    if ((!this.asHeader$1)) {
      var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().ParameterName$1);
      var this$4 = (this$3.isEmpty__Z() ? fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1) : this$3);
      if ((!this$4.isEmpty__Z())) {
        var arg1 = this$4.get__O();
        var f = $as_Lamf_core_parser_FieldEntry(arg1);
        new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("name", f, $m_s_None$())))
      }
    };
    var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Description$1);
    if ((!this$6.isEmpty__Z())) {
      var arg1$1 = this$6.get__O();
      var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f$3, $m_s_None$())))
    };
    var this$8 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1);
    if (this$8.isEmpty__Z()) {
      var jsx$1 = true
    } else {
      var arg1$2 = this$8.get__O();
      var x$24 = $as_Lamf_core_parser_FieldEntry(arg1$2);
      if (this.isExplicit__p1__Lamf_core_parser_FieldEntry__Z(x$24)) {
        var jsx$1 = true
      } else {
        var this$9 = this.parameter$1;
        var this$10 = $as_Lamf_core_model_BoolField(this$9.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1));
        var jsx$1 = $f_Lamf_core_model_BoolField__value__Z(this$10)
      }
    };
    if (jsx$1) {
      var this$11 = this$8
    } else {
      var this$11 = $m_s_None$()
    };
    if ((!this$11.isEmpty__Z())) {
      var arg1$3 = this$11.get__O();
      var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$3);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("required", f$4, $m_s_None$())))
    };
    if ((!this.asHeader$1)) {
      var this$13 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1);
      if ((!this$13.isEmpty__Z())) {
        var arg1$4 = this$13.get__O();
        var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$4);
        new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$().apply__T__Lamf_core_metamodel_Field__O__Lamf_core_parser_Annotations__Lamf_core_emitter_BaseEmitters_package$ValueEmitter("in", $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1, this.binding__Lamf_core_parser_FieldEntry__T(f$5), f$5.value$1.annotations$1)))
      }
    };
    var this$14 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1);
    if ((!this$14.isEmpty__Z())) {
      var arg1$5 = this$14.get__O();
      var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$5);
      if ((this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory() instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory)) {
        var jsx$2 = true
      } else {
        var this$15 = this.parameter$1;
        var this$16 = $as_Lamf_core_model_StrField(this$15.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
        var jsx$2 = $f_Lamf_core_model_ValueField__is__O__Z(this$16, "body")
      };
      if (jsx$2) {
        result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(f$6, this.ordering$1, this.references$1, this.spec$1));
        result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.parameter$1, this.ordering$1, this.spec$1).emitters__sc_Seq())
      } else {
        var jsx$5 = $as_Lamf_core_model_domain_Shape(f$6.value$1.value$1);
        var jsx$4 = this.ordering$1;
        var jsx$3 = $m_sc_Seq$();
        var array = [$m_Lamf_core_metamodel_domain_ShapeModel$().Description$1, $m_Lamf_core_metamodel_domain_ShapeModel$().DisplayName$1];
        result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(jsx$5, jsx$4, $as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))), this.references$1, $m_sci_Nil$(), $m_sci_Nil$(), false, this.spec$1).entries__sc_Seq())
      }
    };
    var x = this.spec$1.vendor__Lamf_core_remote_Vendor();
    var x$2 = $m_Lamf_core_remote_Vendor$().OAS30$1;
    if ((x === x$2)) {
      result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(this.oas3Emitters__Lamf_core_parser_Fields__sc_Seq(fs))
    };
    var jsx$6 = b.builder$1;
    var sourceName = b.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
    jsx$6.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter)) {
    var ParameterEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter(x$1);
    var x = this.parameter$1;
    var x$2 = ParameterEmitter$1.parameter$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = ParameterEmitter$1.ordering$1;
      var jsx$2 = (x$3 === x$4)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.references$1;
      var x$6 = ParameterEmitter$1.references$1;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.asHeader$1 === ParameterEmitter$1.asHeader$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.parameter$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    case 3: {
      return this.asHeader$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter.prototype.binding__Lamf_core_parser_FieldEntry__T = (function(f) {
  var x1 = f.value$1.annotations$1.find__jl_Class__s_Option($d_Lamf_plugins_domain_webapi_annotations_InvalidBinding.getClassOf());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var invalid = $as_Lamf_plugins_domain_webapi_annotations_InvalidBinding(x2.value$2);
    return invalid.value$1
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$1 = f.value$1;
      return this$1.value$1.toString__T()
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter.prototype.oas3Emitters__Lamf_core_parser_Fields__sc_Seq = (function(fs) {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Deprecated$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("deprecated", f, $m_s_None$())))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().AllowEmptyValue$1);
  if (this$3.isEmpty__Z()) {
    var jsx$1 = true
  } else {
    var arg1$1 = this$3.get__O();
    var entry = $as_Lamf_core_parser_FieldEntry(arg1$1);
    var jsx$1 = this.isExplicit__p1__Lamf_core_parser_FieldEntry__Z(entry)
  };
  if (jsx$1) {
    var this$4 = this$3
  } else {
    var this$4 = $m_s_None$()
  };
  if ((!this$4.isEmpty__Z())) {
    var arg1$2 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("allowEmptyValue", f$3, $m_s_None$())))
  };
  var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Style$1);
  if (this$6.isEmpty__Z()) {
    var jsx$2 = true
  } else {
    var arg1$3 = this$6.get__O();
    var entry$3 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    var jsx$2 = this.isExplicit__p1__Lamf_core_parser_FieldEntry__Z(entry$3)
  };
  if (jsx$2) {
    var this$7 = this$6
  } else {
    var this$7 = $m_s_None$()
  };
  if ((!this$7.isEmpty__Z())) {
    var arg1$4 = this$7.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("style", f$4, $m_s_None$())))
  };
  var this$9 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Explode$1);
  if (this$9.isEmpty__Z()) {
    var jsx$3 = true
  } else {
    var arg1$5 = this$9.get__O();
    var entry$4 = $as_Lamf_core_parser_FieldEntry(arg1$5);
    var jsx$3 = this.isExplicit__p1__Lamf_core_parser_FieldEntry__Z(entry$4)
  };
  if (jsx$3) {
    var this$10 = this$9
  } else {
    var this$10 = $m_s_None$()
  };
  if ((!this$10.isEmpty__Z())) {
    var arg1$6 = this$10.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$6);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("explode", f$5, $m_s_None$())))
  };
  var this$12 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().AllowReserved$1);
  if (this$12.isEmpty__Z()) {
    var jsx$4 = true
  } else {
    var arg1$7 = this$12.get__O();
    var entry$5 = $as_Lamf_core_parser_FieldEntry(arg1$7);
    var jsx$4 = this.isExplicit__p1__Lamf_core_parser_FieldEntry__Z(entry$5)
  };
  if (jsx$4) {
    var this$13 = this$12
  } else {
    var this$13 = $m_s_None$()
  };
  if ((!this$13.isEmpty__Z())) {
    var arg1$8 = this$13.get__O();
    var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$8);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("allowReserved", f$6, $m_s_None$())))
  };
  var this$15 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Payloads$1);
  if ((!this$15.isEmpty__Z())) {
    var arg1$9 = this$15.get__O();
    var f$7 = $as_Lamf_core_parser_FieldEntry(arg1$9);
    var payloads = f$7.arrayValues__sc_Seq();
    var annotations = f$7.value$1.annotations$1;
    var x$2 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentPayloadsEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_core_parser_Annotations__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(payloads, this.ordering$1, this.references$1, annotations, this.spec$1);
    var this$16 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var x$3 = this$16.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position("content", x$2, x$4, x$3)))
  };
  var this$18 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Examples$1);
  if ((!this$18.isEmpty__Z())) {
    var arg1$10 = this$18.get__O();
    var f$8 = $as_Lamf_core_parser_FieldEntry(arg1$10);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$().apply__T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter("examples", f$8, this.ordering$1, this.spec$1)))
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter.prototype.emitLink__p1__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var this$1 = this.parameter$1;
  var x1 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1);
  matchEnd5: {
    var label;
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var e = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
      if ((e instanceof $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter)) {
        var this$2 = this.parameter$1;
        var this$3 = $as_Lamf_core_model_StrField(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1));
        var this$4 = this$3.option$1;
        var label = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
        break matchEnd5
      }
    };
    if (this.asHeader$1) {
      var jsx$1 = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$();
      var this$5 = this.parameter$1;
      var this$6 = $as_Lamf_core_model_StrField(this$5.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1));
      var this$7 = this$6.option$1;
      var label = jsx$1.appendOas3ComponentsPrefix__T__T__T($as_T((this$7.isEmpty__Z() ? null : this$7.get__O())), "headers")
    } else {
      var jsx$2 = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$();
      var this$8 = this.parameter$1;
      var this$9 = $as_Lamf_core_model_StrField(this$8.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1));
      var this$10 = this$9.option$1;
      var label = jsx$2.appendParameterDefinitionsPrefix__T__Z__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__T($as_T((this$10.isEmpty__Z() ? null : this$10.get__O())), false, this.spec$1)
    }
  };
  this.spec$1.ref__Lorg_yaml_model_YDocument$PartBuilder__T__V(b, label)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.parameter$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ordering$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.references$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.asHeader$1 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 4)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Parameter__Lamf_core_emitter_SpecOrdering__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(parameter, ordering, references, asHeader, spec) {
  this.parameter$1 = parameter;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.asHeader$1 = asHeader;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.parameter$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter.prototype.isExplicit__p1__Lamf_core_parser_FieldEntry__Z = (function(entry) {
  return entry.value$1.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_ExplicitField.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.ParameterEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.ParameterEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.ParameterEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter() {
  $c_O.call(this);
  this.payload$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype.bindingPos__p1__Lamf_core_model_domain_Shape__Lamf_core_parser_Position = (function(schema) {
  var this$1 = $m_s_Option$().apply__O__s_Option(schema);
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$33 = $as_Lamf_core_model_domain_Shape(arg1);
    var this$2 = x$33.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo.getClassOf())
  };
  if (this$2.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1$1 = this$2.get__O();
    var x$34 = $as_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo(arg1$1);
    var this$3 = new $c_s_Some().init___O(x$34.range$1.start$1)
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype.productPrefix__T = (function() {
  return "PayloadAsParameterEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype.fileShape__p1__Lamf_plugins_domain_shapes_models_FileShape__Lorg_yaml_model_YDocument$PartBuilder__V = (function(file, b) {
  var jsx$3 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var fs = file.fields$2;
  var x1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$().Name$1);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var f = $as_Lamf_core_parser_FieldEntry(x2.value$2);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("name", f, $m_s_None$()))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      this.emitPayloadName__p1__scm_ListBuffer__scm_ListBuffer(result)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$().Description$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var f$2 = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f$2, $m_s_None$())))
  };
  var x$3 = this.bindingPos__p1__Lamf_core_model_domain_Shape__Lamf_core_parser_Position(file);
  var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
  result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("in", "formData", x$4, x$3));
  var jsx$2 = this.ordering$1;
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_core_metamodel_domain_ShapeModel$().Description$1];
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(file, jsx$2, $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))), this.references$1, $m_sci_Nil$(), $m_sci_Nil$(), false, this.spec$1).entries__sc_Seq());
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.payload$1, this.ordering$1, this.spec$1).emitters__sc_Seq());
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var this$1 = this.payload$1;
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1).isDefined__Z()) {
    var jsx$2 = this.spec$1;
    var jsx$1 = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$();
    var this$2 = this.payload$1;
    var this$3 = $as_Lamf_core_model_StrField(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1));
    var this$4 = this$3.option$1;
    jsx$2.ref__Lorg_yaml_model_YDocument$PartBuilder__T__V(b, jsx$1.appendParameterDefinitionsPrefix__T__Z__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__T($as_T((this$4.isEmpty__Z() ? null : this$4.get__O())), false, this.spec$1))
  } else {
    var this$5 = this.payload$1;
    var x1 = $as_Lamf_core_model_domain_Shape(this$5.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1));
    matchEnd5: {
      if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_FileShape)) {
        var x2 = $as_Lamf_plugins_domain_shapes_models_FileShape(x1);
        this.fileShape__p1__Lamf_plugins_domain_shapes_models_FileShape__Lorg_yaml_model_YDocument$PartBuilder__V(x2, b);
        break matchEnd5
      };
      if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
        var x3 = $as_Lamf_plugins_domain_shapes_models_NodeShape(x1);
        if (this.payload$1.annotations$1.find__jl_Class__s_Option($d_Lamf_plugins_document_webapi_annotations_FormBodyParameter.getClassOf()).isDefined__Z()) {
          if ($as_sc_Seq(x3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1)).nonEmpty__Z()) {
            $as_sc_Seq(x3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$1) {
              return (function(x$31$2) {
                var x$31 = $as_Lamf_core_model_domain_extensions_PropertyShape(x$31$2);
                $this.formDataParameter__p1__Lamf_core_model_domain_extensions_PropertyShape__Lorg_yaml_model_YDocument$PartBuilder__V(x$31, b$1)
              })
            })(this, b)));
            (void 0)
          } else {
            this.emptyFormData__p1__Lamf_plugins_domain_webapi_models_Payload__Lorg_yaml_model_YDocument$PartBuilder__V(this.payload$1, b);
            (void 0)
          };
          break matchEnd5
        }
      };
      this.defaultPayload__p1__Lorg_yaml_model_YDocument$PartBuilder__V(b)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype.emitPayloadName__p1__scm_ListBuffer__scm_ListBuffer = (function(result) {
  var this$1 = this.payload$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Name$1);
  if (this$1.isEmpty__Z()) {
    var x1 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    var this$2 = f.value$1.annotations$1.find__jl_Class__s_Option($d_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload.getClassOf());
    if (this$2.isEmpty__Z()) {
      var this$4 = $m_s_None$()
    } else {
      var arg1$1 = this$2.get__O();
      var ann = $as_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload(arg1$1);
      var x$2 = ann.paramName$1;
      var x$3 = ann.range$1.start$1;
      var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
      var this$4 = new $c_s_Some().init___O(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("name", x$2, x$4, x$3))
    };
    if (this$4.isEmpty__Z()) {
      var this$5 = f.value$1;
      var x$6 = this$5.value$1.toString__T();
      var this$6 = $m_Lamf_core_emitter_BaseEmitters_package$();
      var annotations = f.value$1.annotations$1;
      var x$7 = this$6.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf());
      var x$8 = $m_Lorg_yaml_model_YType$().Str$1;
      var x1 = new $c_s_Some().init___O(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("name", x$6, x$8, x$7))
    } else {
      var x1 = this$4
    }
  };
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var e = $as_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter(x2.value$2);
    return result.$$plus$eq__O__scm_ListBuffer(e)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("name", "generated", $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter)) {
    var PayloadAsParameterEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter(x$1);
    var x = this.payload$1;
    var x$2 = PayloadAsParameterEmitter$1.payload$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = PayloadAsParameterEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = PayloadAsParameterEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.payload$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype.formDataParameter__p1__Lamf_core_model_domain_extensions_PropertyShape__Lorg_yaml_model_YDocument$PartBuilder__V = (function(property, b) {
  var jsx$3 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = property.fields$2.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1);
  if (this$2.isEmpty__Z()) {
    var jsx$1 = true
  } else {
    var arg1 = this$2.get__O();
    var x$32 = $as_Lamf_core_parser_FieldEntry(arg1);
    var jsx$1 = $as_Lamf_core_model_domain_AmfScalar(x$32.value$1.value$1).annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_ExplicitField.getClassOf())
  };
  if (jsx$1) {
    var this$3 = this$2
  } else {
    var this$3 = $m_s_None$()
  };
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1$1);
    var jsx$2 = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1;
    var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(($numberIntValue($as_Lamf_core_model_domain_AmfScalar(f.value$1.value$1).toNumber__jl_Number()) !== 0), new $c_Lamf_core_parser_Annotations().init___());
    var annotations = $as_Lamf_core_model_domain_AmfScalar(f.value$1.value$1).annotations$1;
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("required", new $c_Lamf_core_parser_FieldEntry().init___Lamf_core_metamodel_Field__Lamf_core_parser_Value(jsx$2, new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value, annotations)), new $c_s_Some().init___O($m_Lorg_yaml_model_YType$().Bool$1))))
  };
  var this$6 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(property.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1)));
  if ((!this$6.isEmpty__Z())) {
    var arg1$2 = this$6.get__O();
    var schema = $as_Lamf_core_model_domain_Shape(arg1$2);
    var fs = schema.fields__Lamf_core_parser_Fields();
    var x1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var f$1 = $as_Lamf_core_parser_FieldEntry(x2.value$2);
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("name", f$1, $m_s_None$()))
    } else {
      var x = $m_s_None$();
      if ((x === x1)) {
        this.emitPayloadName__p1__scm_ListBuffer__scm_ListBuffer(result)
      } else {
        throw new $c_s_MatchError().init___O(x1)
      }
    };
    var x$3 = this.bindingPos__p1__Lamf_core_model_domain_Shape__Lamf_core_parser_Position(schema);
    var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("in", "formData", x$4, x$3));
    var x$6 = this.ordering$1;
    var x$7 = this.references$1;
    var x$8 = $m_sci_Nil$();
    var x$9 = $m_sci_Nil$();
    var x$10 = $m_sci_Nil$();
    result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(schema, x$6, x$8, x$7, x$9, x$10, false, this.spec$1).entries__sc_Seq());
    result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.payload$1, this.ordering$1, this.spec$1).emitters__sc_Seq())
  };
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Payload__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(payload, ordering, references, spec) {
  this.payload$1 = payload;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype.emptyFormData__p1__Lamf_plugins_domain_webapi_models_Payload__Lorg_yaml_model_YDocument$PartBuilder__V = (function(payload, b) {
  var jsx$1 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  this.emitPayloadName__p1__scm_ListBuffer__scm_ListBuffer(result);
  var x$3 = this.bindingPos__p1__Lamf_core_model_domain_Shape__Lamf_core_parser_Position($as_Lamf_core_model_domain_Shape(payload.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1)));
  var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
  result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("in", "formData", x$4, x$3));
  var x1 = payload.annotations$1.find__jl_Class__s_Option($d_Lamf_plugins_document_webapi_annotations_RequiredParamPayload.getClassOf());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var a = $as_Lamf_plugins_document_webapi_annotations_RequiredParamPayload(x2.value$2);
    var this$3 = a.required$1;
    var x$6 = ("" + this$3);
    var x$7 = a.range$1.start$1;
    var x$8 = $m_Lorg_yaml_model_YType$().Str$1;
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("in", x$6, x$8, x$7))
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  var x$11 = this.bindingPos__p1__Lamf_core_model_domain_Shape__Lamf_core_parser_Position($as_Lamf_core_model_domain_Shape(payload.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1)));
  var x$12 = $m_Lorg_yaml_model_YType$().Str$1;
  result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", "object", x$12, x$11));
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype.emitPayloadDescription__p1__scm_ListBuffer__O = (function(result) {
  var this$1 = this.payload$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Description$1);
  if (this$1.isEmpty__Z()) {
    var x1 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    var this$2 = f.value$1;
    var x1 = new $c_s_Some().init___O(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("description", this$2.value$1.toString__T(), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()))
  };
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var e = $as_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter(x2.value$2);
    return result.$$plus$eq__O__scm_ListBuffer(e)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return (void 0)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.payload$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype.binding__T = (function() {
  var x1 = this.payload$1.annotations$1.find__jl_Class__s_Option($d_Lamf_plugins_domain_webapi_annotations_InvalidBinding.getClassOf());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var invalid = $as_Lamf_plugins_domain_webapi_annotations_InvalidBinding(x2.value$2);
    return invalid.value$1
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return "body"
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype.defaultPayload__p1__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$1 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = this.payload$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("mediaType").asOasExtension__T(), f, $m_s_None$())))
  };
  var x$2 = this.binding__T();
  var this$5 = this.payload$1;
  var x$3 = this.bindingPos__p1__Lamf_core_model_domain_Shape__Lamf_core_parser_Position($as_Lamf_core_model_domain_Shape(this$5.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1)));
  var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
  result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("in", x$2, x$4, x$3));
  this.emitPayloadName__p1__scm_ListBuffer__scm_ListBuffer(result);
  this.emitPayloadDescription__p1__scm_ListBuffer__O(result);
  var x1 = this.payload$1.annotations$1.find__jl_Class__s_Option($d_Lamf_plugins_document_webapi_annotations_RequiredParamPayload.getClassOf());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var a = $as_Lamf_plugins_document_webapi_annotations_RequiredParamPayload(x2.value$2);
    if (a.required$1) {
      var this$7 = a.required$1;
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("required", ("" + this$7), $m_Lorg_yaml_model_YType$().Bool$1, $m_Lamf_core_parser_Position$ZERO$()))
    }
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  var this$10 = this.payload$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1);
  if ((!this$10.isEmpty__Z())) {
    var arg1$1 = this$10.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasSchemaEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(f$3, this.ordering$1, this.references$1, this.spec$1)))
  };
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.payload$1, this.ordering$1, this.spec$1).emitters__sc_Seq());
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.PayloadAsParameterEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.PayloadAsParameterEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.PayloadAsParameterEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser.call(this);
  this.entry$2 = null;
  this.producer$2 = null;
  this.parent$2 = null;
  this.collector$2 = null;
  this.parseOptionalOperations$2 = false
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser.prototype.productPrefix__T = (function() {
  return "Raml08EndpointParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser)) {
    var Raml08EndpointParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser(x$1);
    var x = this.entry$2;
    var x$2 = Raml08EndpointParser$1.entry$2;
    if ((x === x$2)) {
      var x$3 = this.producer$2;
      var x$4 = Raml08EndpointParser$1.producer$2;
      var jsx$3 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$5 = this.parent$2;
      var x$6 = Raml08EndpointParser$1.parent$2;
      var jsx$2 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$7 = this.collector$2;
      var x$8 = Raml08EndpointParser$1.collector$2;
      var jsx$1 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.parseOptionalOperations$2 === Raml08EndpointParser$1.parseOptionalOperations$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser.prototype.uriParametersKey__T = (function() {
  return "uriParameters|baseUriParameters"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$2;
      break
    }
    case 1: {
      return this.producer$2;
      break
    }
    case 2: {
      return this.parent$2;
      break
    }
    case 3: {
      return this.collector$2;
      break
    }
    case 4: {
      return this.parseOptionalOperations$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__s_Option__scm_ListBuffer__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(entry, producer, parent, collector, parseOptionalOperations, ctx) {
  this.entry$2 = entry;
  this.producer$2 = producer;
  this.parent$2 = parent;
  this.collector$2 = collector;
  this.parseOptionalOperations$2 = parseOptionalOperations;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__s_Option__scm_ListBuffer__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, entry, producer, parent, collector, parseOptionalOperations, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.entry$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.producer$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.parent$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.collector$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.parseOptionalOperations$2 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 5)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml08EndpointParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml08EndpointParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml08EndpointParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndpointParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter() {
  $c_O.call(this);
  this.nodeShape$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter.prototype.productPrefix__T = (function() {
  return "Raml08FormPropertiesEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter)) {
    var Raml08FormPropertiesEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter(x$1);
    var x = this.nodeShape$1;
    var x$2 = Raml08FormPropertiesEmitter$1.nodeShape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = Raml08FormPropertiesEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.nodeShape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("formParameters");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$7 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var this$3 = this.nodeShape$1;
  $as_sc_Seq(this$3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ob) {
    return (function(p$2) {
      var p = $as_Lamf_core_model_domain_extensions_PropertyShape(p$2);
      var x1 = $as_Lamf_core_model_domain_Shape(p.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1));
      if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
        var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x1);
        $m_Lorg_yaml_model_YNode$();
        var this$4 = $as_Lamf_core_model_StrField(p.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
        var this$5 = this$4.option$1;
        var str = $as_T((this$5.isEmpty__Z() ? null : this$5.get__O()));
        var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
        var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(ob.sourceName$2);
        var x1$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x2, $this.ordering$1, $m_s_None$(), $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), $this.spec$1).emitter$1;
        if ((x1$1 instanceof $c_s_util_Left)) {
          var x2$1 = $as_s_util_Left(x1$1);
          var prop = $as_Lamf_core_emitter_PartEmitter(x2$1.value$2);
          prop.emit__Lorg_yaml_model_YDocument$PartBuilder__V(v$1)
        } else if ((x1$1 instanceof $c_s_util_Right)) {
          var x3 = $as_s_util_Right(x1$1);
          var entries = $as_sc_Seq(x3.value$2);
          var x1$2 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRequiredShapeEmitter().init___Lamf_core_model_domain_Shape__s_Option($as_Lamf_core_model_domain_Shape(p.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1)), p.fields$2.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1)).emitter__s_Option();
          if ((x1$2 instanceof $c_s_Some)) {
            var x2$2 = $as_s_Some(x1$2);
            var emitter = $as_Lamf_core_emitter_EntryEmitter(x2$2.value$2);
            var jsx$1 = $m_sc_Seq$();
            var array = [emitter];
            var additionalEmitters = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
          } else {
            var x = $m_s_None$();
            if ((!(x === x1$2))) {
              throw new $c_s_MatchError().init___O(x1$2)
            };
            var additionalEmitters = $m_sci_Nil$()
          };
          var jsx$4 = v$1.builder$1;
          var sourceName$1 = v$1.sourceName$2;
          var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
          var jsx$3 = $m_Lamf_core_emitter_BaseEmitters_package$();
          var jsx$2 = $this.ordering$1;
          var this$10 = $m_sc_Seq$();
          jsx$3.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$2.sorted__sc_Seq__sc_Seq($as_sc_Seq(entries.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(additionalEmitters, this$10.ReusableCBFInstance$2))), b$2);
          jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1))
        } else {
          throw new $c_s_MatchError().init___O(x1$1)
        };
        var this$13 = v$1.builder$1;
        var array$1 = [key$1];
        if ((this$13.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len = $uI(array$1.length);
        var newSize = ((this$13.size0$6 + len) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$13, newSize);
        var len$1 = this$13.size0$6;
        var src = this$13.array$6;
        var dest = this$13.array$6;
        $systemArraycopy(src, 0, dest, len, len$1);
        var xs = this$13.array$6;
        var len$2 = xs.u.length;
        var i = 0;
        var j = 0;
        var x$1 = $uI(array$1.length);
        var x$2 = ((x$1 < len$2) ? x$1 : len$2);
        var that = xs.u.length;
        var end = ((x$2 < that) ? x$2 : that);
        while ((i < end)) {
          var jsx$5 = j;
          var index = i;
          xs.set(jsx$5, array$1[index]);
          i = ((1 + i) | 0);
          j = ((1 + j) | 0)
        };
        this$13.size0$6 = newSize;
        ob.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1))
      } else {
        $m_Lorg_yaml_model_YNode$();
        var this$24 = $as_Lamf_core_model_StrField(p.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
        var this$25 = this$24.option$1;
        var str$1 = $as_T((this$25.isEmpty__Z() ? null : this$25.get__O()));
        var key$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
        var v$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(ob.sourceName$2);
        new $c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter().init___Lamf_core_model_domain_AmfElement__T(x1, (("Cannot emit property " + $objectGetClass(x1).toString__T()) + " in raml 08 form properties")).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v$2);
        var this$29 = v$2.builder$1;
        var array$2 = [key$2];
        if ((this$29.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len$3 = $uI(array$2.length);
        var newSize$1 = ((this$29.size0$6 + len$3) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$29, newSize$1);
        var len$4 = this$29.size0$6;
        var src$1 = this$29.array$6;
        var dest$1 = this$29.array$6;
        $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
        var xs$1 = this$29.array$6;
        var len$5 = xs$1.u.length;
        var i$1 = 0;
        var j$1 = 0;
        var x$3 = $uI(array$2.length);
        var x$4 = ((x$3 < len$5) ? x$3 : len$5);
        var that$1 = xs$1.u.length;
        var end$1 = ((x$4 < that$1) ? x$4 : that$1);
        while ((i$1 < end$1)) {
          var jsx$6 = j$1;
          var index$1 = i$1;
          xs$1.set(jsx$6, array$2[index$1]);
          i$1 = ((1 + i$1) | 0);
          j$1 = ((1 + j$1) | 0)
        };
        this$29.size0$6 = newSize$1;
        ob.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$2.builder$1))
      }
    })
  })(this, b$1)));
  jsx$7.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$42 = v.builder$1;
  var array$3 = [key];
  if ((this$42.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len$6 = $uI(array$3.length);
  var newSize$2 = ((this$42.size0$6 + len$6) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$42, newSize$2);
  var len$7 = this$42.size0$6;
  var src$2 = this$42.array$6;
  var dest$2 = this$42.array$6;
  $systemArraycopy(src$2, 0, dest$2, len$6, len$7);
  var xs$2 = this$42.array$6;
  var len$8 = xs$2.u.length;
  var i$2 = 0;
  var j$2 = 0;
  var x$5 = $uI(array$3.length);
  var x$6 = ((x$5 < len$8) ? x$5 : len$8);
  var that$2 = xs$2.u.length;
  var end$2 = ((x$6 < that$2) ? x$6 : that$2);
  while ((i$2 < end$2)) {
    var jsx$8 = j$2;
    var index$2 = i$2;
    xs$2.set(jsx$8, array$3[index$2]);
    i$2 = ((1 + i$2) | 0);
    j$2 = ((1 + j$2) | 0)
  };
  this$42.size0$6 = newSize$2;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter.prototype.init___Lamf_plugins_domain_shapes_models_NodeShape__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(nodeShape, ordering, spec) {
  this.nodeShape$1 = nodeShape;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$1 = this.nodeShape$1;
  var annotations = this$1.annotations$2;
  return this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml08FormPropertiesEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml08FormPropertiesEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml08FormPropertiesEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08FormPropertiesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser.call(this);
  this.map$2 = null;
  this.producer$2 = null;
  this.parseOptional$2 = false;
  this.ctx$2 = null;
  this.baseUriParametersKey$2 = null;
  this.defaultType$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser.prototype.productPrefix__T = (function() {
  return "Raml08RequestParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser.prototype.baseUriParametersKey__T = (function() {
  return this.baseUriParametersKey$2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser)) {
    var Raml08RequestParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser(x$1);
    var this$1 = this.map$2;
    var b = Raml08RequestParser$1.map$2;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.producer$2;
      var x$2 = Raml08RequestParser$1.producer$2;
      var jsx$1 = (x === x$2)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.parseOptional$2 === Raml08RequestParser$1.parseOptional$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$2;
      break
    }
    case 1: {
      return this.producer$2;
      break
    }
    case 2: {
      return this.parseOptional$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser.prototype.parse__Lamf_core_utils_Lazy__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$Target__V = (function(request, target) {
  /*<skip>*/
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser.prototype.parseParameter__Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_domain_webapi_models_Parameter = (function(entry, adopt, parseOptional) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser().init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(p$2) {
      var p = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2);
      var parent = $as_Lamf_core_model_domain_AmfObject($this.request$1.getOrCreate__O()).id__T();
      $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(p, parent)
    })
  })(this)), parseOptional, this.ctx$2).parse__Lamf_plugins_domain_webapi_models_Parameter()
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser.prototype.init___Lorg_yaml_model_YMap__F0__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(map, producer, parseOptional, ctx) {
  this.map$2 = map;
  this.producer$2 = producer;
  this.parseOptional$2 = parseOptional;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser.prototype.init___Lorg_yaml_model_YMap__F0__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, map, producer, parseOptional, ctx);
  this.baseUriParametersKey$2 = "baseUriParameters";
  this.defaultType$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.map$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.producer$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.parseOptional$2 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 3)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser.prototype.defaultType__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType = (function() {
  return this.defaultType$2
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml08RequestParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml08RequestParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml08RequestParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08RequestParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser.call(this);
  this.entry$2 = null;
  this.adopt$2 = null;
  this.parseOptional$2 = false;
  this.defaultType$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(entry, adopt, parseOptional, ctx) {
  this.entry$2 = entry;
  this.adopt$2 = adopt;
  this.parseOptional$2 = parseOptional;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, entry, adopt, parseOptional, ctx);
  this.defaultType$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser.prototype.productPrefix__T = (function() {
  return "Raml08ResponseParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser)) {
    var Raml08ResponseParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser(x$1);
    var x = this.entry$2;
    var x$2 = Raml08ResponseParser$1.entry$2;
    if ((x === x$2)) {
      var x$3 = this.adopt$2;
      var x$4 = Raml08ResponseParser$1.adopt$2;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.parseOptional$2 === Raml08ResponseParser$1.parseOptional$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$2;
      break
    }
    case 1: {
      return this.adopt$2;
      break
    }
    case 2: {
      return this.parseOptional$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser.prototype.supportsOptionalResponses__Z = (function() {
  return true
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.entry$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.adopt$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.parseOptional$2 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 3)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser.prototype.parseMap__Lamf_plugins_domain_webapi_models_Response__Lorg_yaml_model_YMap__V = (function(response, map) {
  /*<skip>*/
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser.prototype.defaultType__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType = (function() {
  return this.defaultType$2
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml08ResponseParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml08ResponseParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml08ResponseParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser.call(this);
  this.entry$2 = null;
  this.producer$2 = null;
  this.parent$2 = null;
  this.collector$2 = null;
  this.parseOptionalOperations$2 = false
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser.prototype.productPrefix__T = (function() {
  return "Raml10EndpointParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser)) {
    var Raml10EndpointParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser(x$1);
    var x = this.entry$2;
    var x$2 = Raml10EndpointParser$1.entry$2;
    if ((x === x$2)) {
      var x$3 = this.producer$2;
      var x$4 = Raml10EndpointParser$1.producer$2;
      var jsx$3 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$5 = this.parent$2;
      var x$6 = Raml10EndpointParser$1.parent$2;
      var jsx$2 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$7 = this.collector$2;
      var x$8 = Raml10EndpointParser$1.collector$2;
      var jsx$1 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.parseOptionalOperations$2 === Raml10EndpointParser$1.parseOptionalOperations$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser.prototype.uriParametersKey__T = (function() {
  return "uriParameters"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$2;
      break
    }
    case 1: {
      return this.producer$2;
      break
    }
    case 2: {
      return this.parent$2;
      break
    }
    case 3: {
      return this.collector$2;
      break
    }
    case 4: {
      return this.parseOptionalOperations$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__s_Option__scm_ListBuffer__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(entry, producer, parent, collector, parseOptionalOperations, ctx) {
  this.entry$2 = entry;
  this.producer$2 = producer;
  this.parent$2 = parent;
  this.collector$2 = collector;
  this.parseOptionalOperations$2 = parseOptionalOperations;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__s_Option__scm_ListBuffer__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, entry, producer, parent, collector, parseOptionalOperations, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.entry$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.producer$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.parent$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.collector$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.parseOptionalOperations$2 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 5)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml10EndpointParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml10EndpointParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml10EndpointParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndpointParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter() {
  $c_O.call(this);
  this.payload$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter.prototype.productPrefix__T = (function() {
  return "Raml10PayloadEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter)) {
    var Raml10PayloadEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter(x$1);
    var x = this.payload$1;
    var x$2 = Raml10PayloadEmitter$1.payload$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = Raml10PayloadEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = Raml10PayloadEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.payload$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var fs = this.payload$1.fields$1;
  var rc7 = false;
  var x2 = null;
  var jsx$1 = $m_s_Option$();
  var this$1 = this.payload$1;
  var x1 = jsx$1.apply__O__s_Option($as_Lamf_core_model_domain_Shape(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1)));
  matchEnd8: {
    if ((x1 instanceof $c_s_Some)) {
      rc7 = true;
      x2 = $as_s_Some(x1);
      var shape = $as_Lamf_core_model_domain_Shape(x2.value$2);
      if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
        var x4 = $as_Lamf_plugins_domain_shapes_models_AnyShape(shape);
        var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1);
        if ((!this$2.isEmpty__Z())) {
          var arg1 = this$2.get__O();
          var mediaType = $as_Lamf_core_parser_FieldEntry(arg1);
          var k = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
          new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType($as_Lamf_core_model_domain_AmfScalar(mediaType.value$1.value$1), $m_Lorg_yaml_model_YType$().Str$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(k);
          var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
          var x$2$2 = this.ordering$1;
          var x$3 = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.payload$1, this.ordering$1, this.spec$1));
          var x$4 = this.references$1;
          var x$5 = $m_sci_Nil$();
          new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x4, x$2$2, x$3, x$5, x$4, this.spec$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
          var this$5 = k.builder$1;
          var jsx$2 = $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$5, 0));
          var this$6 = v.builder$1;
          b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(jsx$2, $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$6, 0)))
        };
        break matchEnd8
      }
    };
    if (rc7) {
      var other = $as_Lamf_core_model_domain_Shape(x2.value$2);
      var this$7 = this.spec$1;
      var this$8 = this$7.eh$1;
      var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
      var node = other.id$1;
      var property = $m_s_None$();
      var lexical = other.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      var location = other.location__s_Option();
      this$8.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "Cannot emit a non WebAPI Shape", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
      break matchEnd8
    };
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$9 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1);
      if ((!this$9.isEmpty__Z())) {
        var arg1$1 = this$9.get__O();
        var mediaType$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
        var k$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
        new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType($as_Lamf_core_model_domain_AmfScalar(mediaType$3.value$1.value$1), $m_Lorg_yaml_model_YType$().Str$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(k$1);
        var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
        var x$7 = this.ordering$1;
        var x$8 = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.payload$1, this.ordering$1, this.spec$1));
        var x$9 = this.references$1;
        var x$10 = $m_sci_Nil$();
        new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(null, x$7, x$8, x$10, x$9, this.spec$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v$1);
        var this$12 = k$1.builder$1;
        var jsx$3 = $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$12, 0));
        var this$13 = v$1.builder$1;
        b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(jsx$3, $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$13, 0)))
      };
      break matchEnd8
    };
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Payload__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(payload, ordering, references, spec) {
  this.payload$1 = payload;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.payload$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml10PayloadEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml10PayloadEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml10PayloadEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser.call(this);
  this.map$2 = null;
  this.producer$2 = null;
  this.parseOptional$2 = false;
  this.ctx$2 = null;
  this.baseUriParametersKey$2 = null;
  this.defaultType$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser.prototype.productPrefix__T = (function() {
  return "Raml10RequestParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser.prototype.baseUriParametersKey__T = (function() {
  return this.baseUriParametersKey$2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser)) {
    var Raml10RequestParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser(x$1);
    var this$1 = this.map$2;
    var b = Raml10RequestParser$1.map$2;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.producer$2;
      var x$2 = Raml10RequestParser$1.producer$2;
      var jsx$1 = (x === x$2)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.parseOptional$2 === Raml10RequestParser$1.parseOptional$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$2;
      break
    }
    case 1: {
      return this.producer$2;
      break
    }
    case 2: {
      return this.parseOptional$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser.prototype.parse__Lamf_core_utils_Lazy__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$Target__V = (function(request, target) {
  var map = this.map$2;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("queryString");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var queryEntry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$6 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(queryEntry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, request$1) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        shape.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject($as_Lamf_core_model_domain_AmfObject(request$1.getOrCreate__O()).id__T(), shape.adopted$default$2__sc_Seq())
      })
    })(this, request)), new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo().init___Z__Z(false, false), $m_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$(), this.ctx$2).parse__s_Option();
    if ((!this$6.isEmpty__Z())) {
      var arg1$1 = this$6.get__O();
      var q = $as_Lamf_core_model_domain_Shape(arg1$1);
      var finalRequest = $as_Lamf_plugins_domain_webapi_models_Request(request.getOrCreate__O());
      var map$1 = this.map$2;
      if (new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option("queryParameters").isDefined__Z()) {
        var this$8 = this.ctx$2.eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().ExclusivePropertiesSpecification$1;
        var node = finalRequest.id$1;
        var ast = this.map$2;
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$8, specification, node, prop, "Properties 'queryString' and 'queryParameters' are exclusive and cannot be declared together", l)
      };
      var queryString = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(q, finalRequest.id$1, $m_s_None$());
      var field = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryString$1;
      new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_Request($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(finalRequest, field, queryString)))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser.prototype.parseParameter__Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_domain_webapi_models_Parameter = (function(entry, adopt, parseOptional) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser().init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(p$2) {
      var p = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2);
      var parent = $as_Lamf_core_model_domain_AmfObject($this.request$1.getOrCreate__O()).id__T();
      $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(p, parent)
    })
  })(this)), parseOptional, this.ctx$2).parse__Lamf_plugins_domain_webapi_models_Parameter()
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser.prototype.init___Lorg_yaml_model_YMap__F0__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(map, producer, parseOptional, ctx) {
  this.map$2 = map;
  this.producer$2 = producer;
  this.parseOptional$2 = parseOptional;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser.prototype.init___Lorg_yaml_model_YMap__F0__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, map, producer, parseOptional, ctx);
  this.baseUriParametersKey$2 = new $c_Lamf_core_utils_package$AmfStrings().init___T("baseUriParameters").asRamlAnnotation__T();
  this.defaultType$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.map$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.producer$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.parseOptional$2 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 3)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser.prototype.defaultType__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType = (function() {
  return this.defaultType$2
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml10RequestParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml10RequestParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml10RequestParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_RamlRequestParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10RequestParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser.call(this);
  this.entry$2 = null;
  this.adopt$2 = null;
  this.parseOptional$2 = false;
  this.ctx$2 = null;
  this.defaultType$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(entry, adopt, parseOptional, ctx) {
  this.entry$2 = entry;
  this.adopt$2 = adopt;
  this.parseOptional$2 = parseOptional;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, entry, adopt, parseOptional, ctx);
  this.defaultType$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser.prototype.productPrefix__T = (function() {
  return "Raml10ResponseParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser)) {
    var Raml10ResponseParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser(x$1);
    var x = this.entry$2;
    var x$2 = Raml10ResponseParser$1.entry$2;
    if ((x === x$2)) {
      var x$3 = this.adopt$2;
      var x$4 = Raml10ResponseParser$1.adopt$2;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.parseOptional$2 === Raml10ResponseParser$1.parseOptional$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$2;
      break
    }
    case 1: {
      return this.adopt$2;
      break
    }
    case 2: {
      return this.parseOptional$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser.prototype.supportsOptionalResponses__Z = (function() {
  return false
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.entry$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.adopt$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.parseOptional$2 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 3)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser.prototype.parseMap__Lamf_plugins_domain_webapi_models_Response__Lorg_yaml_model_YMap__V = (function(response, map) {
  $m_sci_List$();
  var array = [$m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().response$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(response, map, result, this.ctx$2).parse__V()
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser.prototype.defaultType__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType = (function() {
  return this.defaultType$2
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml10ResponseParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml10ResponseParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml10ResponseParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.f$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter.prototype.productPrefix__T = (function() {
  return "RamlParametersEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter)) {
    var RamlParametersEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter(x$1);
    if ((this.key$1 === RamlParametersEmitter$1.key$1)) {
      var x = this.f$1;
      var x$2 = RamlParametersEmitter$1.f$1;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$3 = this.ordering$1;
      var x$4 = RamlParametersEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = RamlParametersEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.f$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var params = this.parameters__p1__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq(this.f$1, this.ordering$1, this.references$1);
  if (params.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var str = this.key$1;
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$1 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(params, b$1);
    jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
    var this$6 = v.builder$1;
    var array = [key];
    if ((this$6.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$6.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
    var len$1 = this$6.size0$6;
    var src = this$6.array$6;
    var dest = this$6.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$6.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$2 = j;
      var index = i;
      xs.set(jsx$2, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$6.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter.prototype.parameters__p1__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq = (function(f, ordering, references) {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  $as_sc_IterableLike($as_Lamf_core_model_domain_AmfArray(f.value$1.value$1).values$1.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_core_model_domain_AmfElement(x$3$2);
      return (!x$3.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_SynthesizedField.getClassOf()))
    })
  })(this)))).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, result$1, ordering$1, references$1) {
    return (function(e$2) {
      var e = $as_Lamf_core_model_domain_AmfElement(e$2);
      return result$1.$$plus$eq__O__scm_ListBuffer(this$2.spec$1.factory__Lamf_plugins_document_webapi_contexts_SpecEmitterFactory().headerEmitter__F3().apply__O__O__O__O($as_Lamf_plugins_domain_webapi_models_Parameter(e), ordering$1, references$1))
    })
  })(this, result, ordering, references)));
  return ordering.sorted__sc_Seq__sc_Seq(result)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter.prototype.init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, f, ordering, references, spec) {
  this.key$1 = key;
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlParametersEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlParametersEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlParametersEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.f$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.defaultResponse$1 = false;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter.prototype.productPrefix__T = (function() {
  return "RamlResponsesEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter.prototype.init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(key, f, ordering, references, defaultResponse, spec) {
  this.key$1 = key;
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.defaultResponse$1 = defaultResponse;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter.prototype.responses__p1__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq = (function(f, ordering, references) {
  var jsx$2 = this.effectiveResponses__sc_Seq();
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ordering$1, references$1) {
    return (function(e$2) {
      var e = $as_Lamf_core_model_domain_AmfElement(e$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter($this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory().responseEmitter__F3().apply__O__O__O__O($as_Lamf_plugins_domain_webapi_models_Response(e), ordering$1, references$1))
    })
  })(this, ordering, references));
  var this$1 = $m_sc_Seq$();
  var result = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  return ordering.sorted__sc_Seq__sc_Seq(result)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter)) {
    var RamlResponsesEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter(x$1);
    if ((this.key$1 === RamlResponsesEmitter$1.key$1)) {
      var x = this.f$1;
      var x$2 = RamlResponsesEmitter$1.f$1;
      var jsx$3 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$3 = this.ordering$1;
      var x$4 = RamlResponsesEmitter$1.ordering$1;
      var jsx$2 = (x$3 === x$4)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.references$1;
      var x$6 = RamlResponsesEmitter$1.references$1;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.defaultResponse$1 === RamlResponsesEmitter$1.defaultResponse$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.f$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.references$1;
      break
    }
    case 4: {
      return this.defaultResponse$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  if (this.effectiveResponses__sc_Seq().nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var str = this.key$1;
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$1 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.responses__p1__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq(this.f$1, this.ordering$1, this.references$1), b$1);
    jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
    var this$6 = v.builder$1;
    var array = [key];
    if ((this$6.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$6.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
    var len$1 = this$6.size0$6;
    var src = this$6.array$6;
    var dest = this$6.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$6.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$2 = j;
      var index = i;
      xs.set(jsx$2, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$6.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter.prototype.effectiveResponses__sc_Seq = (function() {
  if (this.defaultResponse$1) {
    var this$1 = this.f$1;
    return $as_sc_Seq($as_Lamf_core_model_domain_AmfArray(this$1.value$1.value$1).values$1.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$3$2) {
        var x$3 = $as_Lamf_core_model_domain_AmfElement(x$3$2);
        var this$2 = $as_Lamf_plugins_domain_webapi_models_Response(x$3);
        var this$3 = $as_Lamf_core_model_StrField(this$2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1)).option$1;
        var x = (this$3.isEmpty__Z() ? "default" : this$3.get__O());
        return ((x !== null) && $objectEquals(x, "default"))
      })
    })(this))))
  } else {
    var this$4 = this.f$1;
    return $as_sc_Seq($as_Lamf_core_model_domain_AmfArray(this$4.value$1.value$1).values$1.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(x$4$2) {
        var x$4 = $as_Lamf_core_model_domain_AmfElement(x$4$2);
        var this$5 = $as_Lamf_plugins_domain_webapi_models_Response(x$4);
        var this$6 = $as_Lamf_core_model_StrField(this$5.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1)).option$1;
        var x$1 = (this$6.isEmpty__Z() ? "default" : this$6.get__O());
        return (!((x$1 !== null) && $objectEquals(x$1, "default")))
      })
    })(this))))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.key$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.f$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ordering$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.references$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.defaultResponse$1 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 5)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlResponsesEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlResponsesEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlResponsesEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponsesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters() {
  $c_O.call(this);
  this.key$1 = null;
  this.servers$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters.prototype.productPrefix__T = (function() {
  return "ServersEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters.prototype.init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, servers, ordering, spec) {
  this.key$1 = key;
  this.servers$1 = servers;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters)) {
    var ServersEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters(x$1);
    if ((this.key$1 === ServersEmitters$1.key$1)) {
      var x = this.servers$1;
      var x$2 = ServersEmitters$1.servers$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.ordering$1;
      var x$4 = ServersEmitters$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.servers$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$2 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V(this.orderedServers__p1__sc_Seq__sc_Seq(this.servers$1), b$1);
  var jsx$1 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$1.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$2.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$3 = j;
    var index = i;
    xs.set(jsx$3, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters.prototype.orderedServers__p1__sc_Seq__sc_Seq = (function(servers) {
  var jsx$2 = this.ordering$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(e$2) {
      var e = $as_Lamf_plugins_domain_webapi_models_Server(e$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerEmitter().init___Lamf_plugins_domain_webapi_models_Server__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(e, $this.ordering$1, $this.spec$1)
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  return jsx$2.sorted__sc_Seq__sc_Seq($as_sc_Seq(servers.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.servers$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$3 = $as_Lamf_plugins_domain_webapi_models_Server(arg1);
    var this$2 = new $c_s_Some().init___O(x$3.annotations$1)
  };
  if (this$2.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1$1 = this$2.get__O();
    var annotations = $as_Lamf_core_parser_Annotations(arg1$1);
    var this$3 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var this$4 = new $c_s_Some().init___O(this$3.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$4.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$4.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.ServersEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.ServersEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.ServersEmitters", {
  Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_ServersEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.example$1 = null;
  this.ordering$1 = null;
  this.valueEmitter$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter.prototype.productPrefix__T = (function() {
  return "SingleExampleEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter)) {
    var SingleExampleEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter(x$1);
    if ((this.key$1 === SingleExampleEmitter$1.key$1)) {
      var x = this.example$1;
      var x$2 = SingleExampleEmitter$1.example$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.ordering$1;
      var x$4 = SingleExampleEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.example$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var x1 = this.valueEmitter$1;
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var entry = $as_Lamf_core_emitter_EntryEmitter(x2.value$2);
    var jsx$1 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    entry.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$1);
    jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  } else if ((x1 instanceof $c_s_util_Right)) {
    var x3 = $as_s_util_Right(x1);
    var map = $as_Lamf_core_emitter_PartEmitter(x3.value$2);
    map.emit__Lorg_yaml_model_YDocument$PartBuilder__V(v)
  } else {
    throw new $c_s_MatchError().init___O(x1)
  };
  var this$5 = v.builder$1;
  var array = [key];
  if ((this$5.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$5.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$5, newSize);
  var len$1 = this$5.size0$6;
  var src = this$5.array$6;
  var dest = this$5.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$5.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$5.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.example$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter.prototype.init___T__Lamf_plugins_domain_shapes_models_Example__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, example, ordering, spec) {
  this.key$1 = key;
  this.example$1 = example;
  this.ordering$1 = ordering;
  var x1 = example.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Name$1);
  if ((x1 instanceof $c_s_Some)) {
    $m_s_package$();
    var value = new $c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter().init___Lamf_plugins_domain_shapes_models_Example__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(example, ordering, spec);
    var jsx$1 = new $c_s_util_Left().init___O(value)
  } else {
    $m_s_package$();
    var value$1 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter().init___Lamf_plugins_domain_shapes_models_Example__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(example, ordering, spec);
    var jsx$1 = new $c_s_util_Right().init___O(value$1)
  };
  this.valueEmitter$1 = jsx$1;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.SingleExampleEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.SingleExampleEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.SingleExampleEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_SingleExampleEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter() {
  $c_O.call(this);
  this.value$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter.prototype.productPrefix__T = (function() {
  return "StringToAstEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$2 = $m_Lamf_core_utils_package$MediaTypeMatcher$();
  var content = this.value$1;
  if (jsx$2.isXml$extension__T__Z(content)) {
    var jsx$1 = true
  } else {
    var jsx$3 = $m_Lamf_core_utils_package$MediaTypeMatcher$();
    var content$1 = this.value$1;
    var jsx$1 = jsx$3.isJson$extension__T__Z(content$1)
  };
  if (jsx$1) {
    var node = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(this.value$1)
  } else {
    var this$3 = $m_Lorg_yaml_parser_YamlParser$().apply__jl_CharSequence__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_YamlParser(this.value$1, $m_Lorg_yaml_model_ParseErrorHandler$().parseErrorHandler$1);
    var node = $f_Lorg_yaml_parser_YParser__document__Lorg_yaml_model_YDocument(this$3).node$2
  };
  this.emitNode__p1__Lorg_yaml_model_YNode__Lorg_yaml_model_YDocument$PartBuilder__V(node, b)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter)) {
    var StringToAstEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter(x$1);
    return (this.value$1 === StringToAstEmitter$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter.prototype.emitNode__p1__Lorg_yaml_model_YNode__Lorg_yaml_model_YDocument$PartBuilder__V = (function(node, b) {
  var x1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
    var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv));
    var jsx$2 = b.builder$1;
    var sourceName = b.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    map.entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, e) {
      return (function(entry$2) {
        var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
        $m_Lorg_yaml_model_YNode$();
        var this$2 = entry.key$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv$1 = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
        var str = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$1, iv$1));
        var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
        var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(e.sourceName$2);
        $this.emitNode__p1__Lorg_yaml_model_YNode__Lorg_yaml_model_YDocument$PartBuilder__V(entry.value$2, v);
        var this$6 = v.builder$1;
        var array = [key];
        if ((this$6.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len = $uI(array.length);
        var newSize = ((this$6.size0$6 + len) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
        var len$1 = this$6.size0$6;
        var src = this$6.array$6;
        var dest = this$6.array$6;
        $systemArraycopy(src, 0, dest, len, len$1);
        var xs = this$6.array$6;
        var len$2 = xs.u.length;
        var i = 0;
        var j = 0;
        var x$1 = $uI(array.length);
        var x$2 = ((x$1 < len$2) ? x$1 : len$2);
        var that = xs.u.length;
        var end = ((x$2 < that) ? x$2 : that);
        while ((i < end)) {
          var jsx$1 = j;
          var index = i;
          xs.set(jsx$1, array[index]);
          i = ((1 + i) | 0);
          j = ((1 + j) | 0)
        };
        this$6.size0$6 = newSize;
        e.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
      })
    })(this, b$1)));
    jsx$2.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Seq$1;
    if ((x$3 === x1)) {
      var conversion$2 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
      var iv$2 = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
      var seq = $as_sc_Seq($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$2, iv$2));
      var jsx$4 = b.builder$1;
      var sourceName$1 = b.sourceName$2;
      var b$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$1);
      seq.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, p) {
        return (function(x$25$2) {
          var x$25 = $as_Lorg_yaml_model_YNode(x$25$2);
          $this$1.emitNode__p1__Lorg_yaml_model_YNode__Lorg_yaml_model_YDocument$PartBuilder__V(x$25, p)
        })
      })(this, b$2)));
      var jsx$3 = $m_Lorg_yaml_model_YNode$();
      $m_Lorg_yaml_model_YSequence$();
      var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$1);
      var parts = b$2.builder$1;
      var node$1 = jsx$3.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
      jsx$4.$$plus$eq__O__scm_ArrayBuffer(node$1)
    } else {
      var conversion$3 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
      var iv$3 = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
      var scalar = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$3, iv$3));
      b.$$plus$eq__T__V(scalar.text$3)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter.prototype.init___T = (function(value) {
  this.value$1 = value;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  return $m_Lamf_core_parser_Position$ZERO$()
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.StringToAstEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.StringToAstEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.StringToAstEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_StringToAstEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.call(this);
  this.entryLike$2 = null;
  this.parent$2 = null;
  this.ctx$2 = null;
  this.bindingsField$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.bindingsField__Lamf_core_metamodel_Field = (function() {
  return this.bindingsField$2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.productPrefix__T = (function() {
  return "AsyncChannelBindingsParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.handleRef__T__Lamf_plugins_domain_webapi_models_bindings_ChannelBindings = (function(fullRef) {
  var label = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().stripOas3ComponentsPrefix__T__T__T(fullRef, "channelBindings");
  var this$1 = this.ctx$2.declarations$4.findChannelBindings__T__Lamf_core_parser_SearchScope$Scope__s_Option(label, $m_Lamf_core_parser_SearchScope$Named$());
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var channelBindings = $as_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings(arg1);
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var this$3 = new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings(this.nameAndAdopt__Lamf_core_model_domain_NamedDomainElement__s_Option__Lamf_core_model_domain_NamedDomainElement($as_Lamf_core_model_domain_NamedDomainElement($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(channelBindings, label, annotations)), this.entryLike$2.key__s_Option())))
  };
  return $as_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings((this$3.isEmpty__Z() ? $as_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings(this.remote__T__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_NamedDomainElement(fullRef, this.entryLike$2, this.parent$2, this.ctx$2)) : this$3.get__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.handleRef__T__Lamf_core_model_domain_NamedDomainElement = (function(fullRef) {
  return this.handleRef__T__Lamf_plugins_domain_webapi_models_bindings_ChannelBindings(fullRef)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.parseWs__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement = (function(entry, parent, ctx) {
  return this.parseWs__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_ChannelBinding(entry, parent, ctx)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.parseWs__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_ChannelBinding = (function(entry, parent, ctx) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var binding = $as_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, parent));
  var this$3 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, ctx));
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$().Method$1;
  jsx$1.key__T__F1__V("method", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  var this$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$7 = this$6.key__T__s_Option("query");
  if ((!this$7.isEmpty__Z())) {
    var arg1 = this$7.get__O();
    var entry$2 = $as_Lorg_yaml_model_YMapEntry(arg1);
    this.parseSchema__Lamf_core_metamodel_Field__Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V($m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$().Query$1, binding, entry$2, (binding.id$1 + "/query"), ctx)
  };
  var this$9 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$10 = this$9.key__T__s_Option("headers");
  if ((!this$10.isEmpty__Z())) {
    var arg1$1 = this$10.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    this.parseSchema__Lamf_core_metamodel_Field__Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V($m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$().Headers$1, binding, entry$3, (binding.id$1 + "/headers"), ctx)
  };
  this.parseBindingVersion__Lamf_plugins_domain_webapi_models_bindings_BindingVersion__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V(binding, $m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$().BindingVersion$1, map, ctx);
  ctx.closedShape__T__Lorg_yaml_model_YMap__T__V(binding.id$1, map, "wsChannelBinding");
  return binding
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser)) {
    var AsyncChannelBindingsParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser(x$1);
    var x = this.entryLike$2;
    var x$2 = AsyncChannelBindingsParser$1.entryLike$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      return (this.parent$2 === AsyncChannelBindingsParser$1.parent$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.errorBindings__T__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_core_model_domain_NamedDomainElement = (function(fullRef, entryLike) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorChannelBindings().init___T__Lorg_yaml_model_YPart(fullRef, entryLike.asMap__Lorg_yaml_model_YMap())
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entryLike$2;
      break
    }
    case 1: {
      return this.parent$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.parseAmqp__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement = (function(entry, parent, ctx) {
  return this.parseAmqp__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_ChannelBinding(entry, parent, ctx)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.parseAmqp__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_ChannelBinding = (function(entry, parent, ctx) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var binding = $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, parent));
  var this$3 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, ctx));
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$().Is$1;
  jsx$1.key__T__F1__V("is", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  var this$5 = $as_Lamf_core_model_StrField(binding.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$().Is$1));
  if ($f_Lamf_core_model_StrField__isNullOrEmpty__Z(this$5)) {
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$().Is$1;
    var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations("routingKey", new $c_Lamf_core_parser_Annotations().init___());
    $m_Lamf_core_parser_Annotations$();
    var annotation = new $c_Lamf_core_annotations_SynthesizedField().init___();
    var annotations$1 = new $c_Lamf_core_parser_Annotations().init___().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(annotation);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(binding, field$1, value, annotations$1)
  };
  var this$8 = $as_Lamf_core_model_StrField(binding.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$().Is$1));
  var this$9 = this$8.option$1;
  var x1 = $as_T((this$9.isEmpty__Z() ? null : this$9.get__O()));
  if ((x1 === "queue")) {
    this.parseQueue__p2__Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V(binding, map, ctx)
  } else if ((x1 === "routingKey")) {
    this.parseExchange__p2__Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V(binding, map, ctx)
  };
  this.parseBindingVersion__Lamf_plugins_domain_webapi_models_bindings_BindingVersion__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V(binding, $m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$().BindingVersion$1, map, ctx);
  return binding
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(entryLike, parent, ctx) {
  this.entryLike$2 = entryLike;
  this.parent$2 = parent;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext.call(this, entryLike, parent, ctx);
  this.bindingsField$2 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$().Bindings$1;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.parseQueue__p2__Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V = (function(binding, map, ctx) {
  ctx.closedShape__T__Lorg_yaml_model_YMap__T__V(binding.id$1, map, "amqpIsQueueChannelBinding");
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("queue");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
    var fields = new $c_Lamf_core_parser_Fields().init___();
    var qual$1 = new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
    var x$1 = binding.id$1;
    $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var queue = $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
    var this$6 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var queueMap = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion, ctx));
    var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(queueMap);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$().Name$1;
    jsx$1.key__T__F1__V("name", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(queue));
    var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(queueMap);
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$().Durable$1;
    jsx$2.key__T__F1__V("durable", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(queue));
    var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(queueMap);
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$().Exclusive$1;
    jsx$3.key__T__F1__V("exclusive", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(queue));
    var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(queueMap);
    var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$().AutoDelete$1;
    jsx$4.key__T__F1__V("autoDelete", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$3, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(queue));
    this.parseVHost__p2__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__O(queue, $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$().VHost$1, queueMap, ctx);
    ctx.closedShape__T__Lorg_yaml_model_YMap__T__V(queue.id$1, queueMap, "amqpQueueChannelBinding");
    var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$().Queue$1;
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(binding, field$4, queue, annotations$1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.parseExchange__p2__Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V = (function(binding, map, ctx) {
  ctx.closedShape__T__Lorg_yaml_model_YMap__T__V(binding.id$1, map, "amqpIsExchangeChannelBinding");
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("exchange");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
    var fields = new $c_Lamf_core_parser_Fields().init___();
    var qual$1 = new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
    var x$1 = binding.id$1;
    $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var exchange = $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
    var this$6 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var exchangeMap = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion, ctx));
    var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(exchangeMap);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$().Name$1;
    jsx$1.key__T__F1__V("name", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(exchange));
    var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(exchangeMap);
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$().Type$1;
    jsx$2.key__T__F1__V("type", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(exchange));
    var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(exchangeMap);
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$().Durable$1;
    jsx$3.key__T__F1__V("durable", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(exchange));
    var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(exchangeMap);
    var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$().AutoDelete$1;
    jsx$4.key__T__F1__V("autoDelete", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$3, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(exchange));
    this.parseVHost__p2__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__O(exchange, $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$().VHost$1, exchangeMap, ctx);
    ctx.closedShape__T__Lorg_yaml_model_YMap__T__V(exchange.id$1, exchangeMap, "amqpExchangeChannelBinding");
    var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$().Exchange$1;
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(binding, field$4, exchange, annotations$1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.parseVHost__p2__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__O = (function(element, field, map, ctx) {
  new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__F1__V("vhost", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(element));
  var this$2 = element.fields__Lamf_core_parser_Fields();
  if ((!this$2.fs$1.contains__O__Z(field))) {
    var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations("/", new $c_Lamf_core_parser_Annotations().init___());
    $m_Lamf_core_parser_Annotations$();
    var annotation = new $c_Lamf_core_annotations_SynthesizedField().init___();
    var annotations = new $c_Lamf_core_parser_Annotations().init___().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(annotation);
    return $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(element, field, value, annotations)
  } else {
    return (void 0)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.createParser__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser = (function(entryLike) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser().init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(entryLike, this.parent$2, this.ctx$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.createBindings__Lamf_core_model_domain_NamedDomainElement = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.binding.AsyncChannelBindingsParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.binding.AsyncChannelBindingsParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.binding.AsyncChannelBindingsParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncChannelBindingsParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.call(this);
  this.entryLike$2 = null;
  this.parent$2 = null;
  this.ctx$2 = null;
  this.bindingsField$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.bindingsField__Lamf_core_metamodel_Field = (function() {
  return this.bindingsField$2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.productPrefix__T = (function() {
  return "AsyncMessageBindingsParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.handleRef__T__Lamf_core_model_domain_NamedDomainElement = (function(fullRef) {
  return this.handleRef__T__Lamf_plugins_domain_webapi_models_bindings_MessageBindings(fullRef)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.parseMqtt__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_MessageBinding = (function(entry, parent, ctx) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var binding = $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, parent));
  var this$3 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, ctx));
  this.parseBindingVersion__Lamf_plugins_domain_webapi_models_bindings_BindingVersion__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V(binding, $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$().BindingVersion$1, map, ctx);
  ctx.closedShape__T__Lorg_yaml_model_YMap__T__V(binding.id$1, map, "mqttMessageBinding");
  return binding
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser)) {
    var AsyncMessageBindingsParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser(x$1);
    var x = this.entryLike$2;
    var x$2 = AsyncMessageBindingsParser$1.entryLike$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      return (this.parent$2 === AsyncMessageBindingsParser$1.parent$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.errorBindings__T__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_core_model_domain_NamedDomainElement = (function(fullRef, entryLike) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessageBindings().init___T__Lorg_yaml_model_YPart(fullRef, entryLike.asMap__Lorg_yaml_model_YMap())
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entryLike$2;
      break
    }
    case 1: {
      return this.parent$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.parseAmqp__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement = (function(entry, parent, ctx) {
  return this.parseAmqp__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_MessageBinding(entry, parent, ctx)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(entryLike, parent, ctx) {
  this.entryLike$2 = entryLike;
  this.parent$2 = parent;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext.call(this, entryLike, parent, ctx);
  this.bindingsField$2 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$().Bindings$1;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.parseAmqp__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_MessageBinding = (function(entry, parent, ctx) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var binding = $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, parent));
  var this$3 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, ctx));
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$().ContentEncoding$1;
  jsx$1.key__T__F1__V("contentEncoding", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$().MessageType$1;
  jsx$2.key__T__F1__V("messageType", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  this.parseBindingVersion__Lamf_plugins_domain_webapi_models_bindings_BindingVersion__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V(binding, $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$().BindingVersion$1, map, ctx);
  ctx.closedShape__T__Lorg_yaml_model_YMap__T__V(binding.id$1, map, "amqpMessageBinding");
  return binding
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.parseMqtt__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement = (function(entry, parent, ctx) {
  return this.parseMqtt__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_MessageBinding(entry, parent, ctx)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.parseHttp__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_MessageBinding = (function(entry, parent, ctx) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var binding = $as_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, parent));
  var this$3 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, ctx));
  var this$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$6 = this$5.key__T__s_Option("headers");
  if ((!this$6.isEmpty__Z())) {
    var arg1 = this$6.get__O();
    var x$1$2 = $as_Lorg_yaml_model_YMapEntry(arg1);
    this.parseSchema__Lamf_core_metamodel_Field__Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V($m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$().Headers$1, binding, x$1$2, binding.id$1, ctx)
  };
  this.parseBindingVersion__Lamf_plugins_domain_webapi_models_bindings_BindingVersion__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V(binding, $m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$().BindingVersion$1, map, ctx);
  ctx.closedShape__T__Lorg_yaml_model_YMap__T__V(binding.id$1, map, "httpMessageBinding");
  return binding
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.parseKafka__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_MessageBinding = (function(entry, parent, ctx) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var binding = $as_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, parent));
  var this$3 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, ctx));
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$().MessageKey$1;
  jsx$1.key__T__F1__V("key", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  this.parseBindingVersion__Lamf_plugins_domain_webapi_models_bindings_BindingVersion__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V(binding, $m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$().BindingVersion$1, map, ctx);
  ctx.closedShape__T__Lorg_yaml_model_YMap__T__V(binding.id$1, map, "kafkaMessageBinding");
  return binding
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.handleRef__T__Lamf_plugins_domain_webapi_models_bindings_MessageBindings = (function(fullRef) {
  var label = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().stripOas3ComponentsPrefix__T__T__T(fullRef, "messageBindings");
  var this$1 = this.ctx$2.declarations$4.findMessageBindings__T__Lamf_core_parser_SearchScope$Scope__s_Option(label, $m_Lamf_core_parser_SearchScope$Named$());
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var messageBindings = $as_Lamf_plugins_domain_webapi_models_bindings_MessageBindings(arg1);
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var this$3 = new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_bindings_MessageBindings(this.nameAndAdopt__Lamf_core_model_domain_NamedDomainElement__s_Option__Lamf_core_model_domain_NamedDomainElement($as_Lamf_core_model_domain_NamedDomainElement($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(messageBindings, label, annotations)), this.entryLike$2.key__s_Option())))
  };
  return $as_Lamf_plugins_domain_webapi_models_bindings_MessageBindings((this$3.isEmpty__Z() ? $as_Lamf_plugins_domain_webapi_models_bindings_MessageBindings(this.remote__T__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_NamedDomainElement(fullRef, this.entryLike$2, this.parent$2, this.ctx$2)) : this$3.get__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.createParser__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser = (function(entryLike) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser().init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(entryLike, this.parent$2, this.ctx$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.createBindings__Lamf_core_model_domain_NamedDomainElement = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.parseHttp__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement = (function(entry, parent, ctx) {
  return this.parseHttp__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_MessageBinding(entry, parent, ctx)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.parseKafka__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement = (function(entry, parent, ctx) {
  return this.parseKafka__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_MessageBinding(entry, parent, ctx)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.binding.AsyncMessageBindingsParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.binding.AsyncMessageBindingsParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.binding.AsyncMessageBindingsParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncMessageBindingsParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.call(this);
  this.entryLike$2 = null;
  this.parent$2 = null;
  this.ctx$2 = null;
  this.bindingsField$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.bindingsField__Lamf_core_metamodel_Field = (function() {
  return this.bindingsField$2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.productPrefix__T = (function() {
  return "AsyncOperationBindingsParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.handleRef__T__Lamf_core_model_domain_NamedDomainElement = (function(fullRef) {
  return this.handleRef__T__Lamf_plugins_domain_webapi_models_bindings_OperationBindings(fullRef)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser)) {
    var AsyncOperationBindingsParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser(x$1);
    var x = this.entryLike$2;
    var x$2 = AsyncOperationBindingsParser$1.entryLike$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      return (this.parent$2 === AsyncOperationBindingsParser$1.parent$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.errorBindings__T__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_core_model_domain_NamedDomainElement = (function(fullRef, entryLike) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationBindings().init___T__Lorg_yaml_model_YPart(fullRef, entryLike.asMap__Lorg_yaml_model_YMap())
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entryLike$2;
      break
    }
    case 1: {
      return this.parent$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.parseKafka__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_OperationBinding = (function(entry, parent, ctx) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var binding = $as_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, parent));
  var this$3 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, ctx));
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$().GroupId$1;
  jsx$1.key__T__F1__V("groupId", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$().ClientId$1;
  jsx$2.key__T__F1__V("clientId", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  this.parseBindingVersion__Lamf_plugins_domain_webapi_models_bindings_BindingVersion__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V(binding, $m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$().BindingVersion$1, map, ctx);
  ctx.closedShape__T__Lorg_yaml_model_YMap__T__V(binding.id$1, map, "kafkaOperationBinding");
  return binding
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.parseAmqp__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement = (function(entry, parent, ctx) {
  return this.parseAmqp__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_OperationBinding(entry, parent, ctx)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.parseAmqp__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_OperationBinding = (function(entry, parent, ctx) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var binding = $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, parent));
  var this$3 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, ctx));
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().Expiration$1;
  jsx$1.key__T__F1__V("expiration", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().UserId$1;
  jsx$2.key__T__F1__V("userId", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().CC$1;
  jsx$3.key__T__F1__V("cc", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().Priority$1;
  jsx$4.key__T__F1__V("priority", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$3, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  var jsx$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().DeliveryMode$1;
  jsx$5.key__T__F1__V("deliveryMode", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$4, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  var jsx$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().Mandatory$1;
  jsx$6.key__T__F1__V("mandatory", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$5, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  var jsx$7 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$6 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().BCC$1;
  jsx$7.key__T__F1__V("bcc", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$6, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  var jsx$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$7 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().ReplyTo$1;
  jsx$8.key__T__F1__V("replyTo", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$7, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  var jsx$9 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$8 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().Timestamp$1;
  jsx$9.key__T__F1__V("timestamp", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$8, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  var jsx$10 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$9 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().Ack$1;
  jsx$10.key__T__F1__V("ack", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$9, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  this.parseBindingVersion__Lamf_plugins_domain_webapi_models_bindings_BindingVersion__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V(binding, $m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$().BindingVersion$1, map, ctx);
  ctx.closedShape__T__Lorg_yaml_model_YMap__T__V(binding.id$1, map, "amqpOperationBinding");
  return binding
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.handleRef__T__Lamf_plugins_domain_webapi_models_bindings_OperationBindings = (function(fullRef) {
  var label = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().stripOas3ComponentsPrefix__T__T__T(fullRef, "operationBindings");
  var this$1 = this.ctx$2.declarations$4.findOperationBindings__T__Lamf_core_parser_SearchScope$Scope__s_Option(label, $m_Lamf_core_parser_SearchScope$Named$());
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var operationBindings = $as_Lamf_plugins_domain_webapi_models_bindings_OperationBindings(arg1);
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var this$3 = new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_bindings_OperationBindings(this.nameAndAdopt__Lamf_core_model_domain_NamedDomainElement__s_Option__Lamf_core_model_domain_NamedDomainElement($as_Lamf_core_model_domain_NamedDomainElement($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(operationBindings, label, annotations)), this.entryLike$2.key__s_Option())))
  };
  return $as_Lamf_plugins_domain_webapi_models_bindings_OperationBindings((this$3.isEmpty__Z() ? $as_Lamf_plugins_domain_webapi_models_bindings_OperationBindings(this.remote__T__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_NamedDomainElement(fullRef, this.entryLike$2, this.parent$2, this.ctx$2)) : this$3.get__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(entryLike, parent, ctx) {
  this.entryLike$2 = entryLike;
  this.parent$2 = parent;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext.call(this, entryLike, parent, ctx);
  this.bindingsField$2 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$().Bindings$1;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.parseMqtt__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement = (function(entry, parent, ctx) {
  return this.parseMqtt__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_OperationBinding(entry, parent, ctx)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.parseMqtt__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_OperationBinding = (function(entry, parent, ctx) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var binding = $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, parent));
  var this$3 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, ctx));
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$().Qos$1;
  jsx$1.key__T__F1__V("qos", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$().Retain$1;
  jsx$2.key__T__F1__V("retain", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  this.parseBindingVersion__Lamf_plugins_domain_webapi_models_bindings_BindingVersion__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V(binding, $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$().BindingVersion$1, map, ctx);
  ctx.closedShape__T__Lorg_yaml_model_YMap__T__V(binding.id$1, map, "mqttOperationBinding");
  return binding
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.createParser__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser = (function(entryOrMap) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser().init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(entryOrMap, this.parent$2, this.ctx$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.createBindings__Lamf_core_model_domain_NamedDomainElement = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.parseHttp__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement = (function(entry, parent, ctx) {
  return this.parseHttp__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_OperationBinding(entry, parent, ctx)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.parseKafka__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement = (function(entry, parent, ctx) {
  return this.parseKafka__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_OperationBinding(entry, parent, ctx)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.parseHttp__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_OperationBinding = (function(entry, parent, ctx) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var binding = $as_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, parent));
  var this$3 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, ctx));
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$().OperationType$1;
  jsx$1.key__T__F1__V("type", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  var this$5 = $as_Lamf_core_model_StrField(binding.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$().OperationType$1));
  if ($f_Lamf_core_model_ValueField__is__O__Z(this$5, "request")) {
    var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$().Method$1;
    jsx$2.key__T__F1__V("method", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding))
  };
  var this$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$9 = this$8.key__T__s_Option("query");
  if ((!this$9.isEmpty__Z())) {
    var arg1 = this$9.get__O();
    var entry$2 = $as_Lorg_yaml_model_YMapEntry(arg1);
    this.parseSchema__Lamf_core_metamodel_Field__Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V($m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$().Query$1, binding, entry$2, binding.id$1, ctx)
  };
  this.parseBindingVersion__Lamf_plugins_domain_webapi_models_bindings_BindingVersion__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V(binding, $m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$().BindingVersion$1, map, ctx);
  ctx.closedShape__T__Lorg_yaml_model_YMap__T__V(binding.id$1, map, "httpOperationBinding");
  return binding
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.binding.AsyncOperationBindingsParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.binding.AsyncOperationBindingsParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.binding.AsyncOperationBindingsParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncOperationBindingsParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.call(this);
  this.entryLike$2 = null;
  this.parent$2 = null;
  this.ctx$2 = null;
  this.bindingsField$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype.bindingsField__Lamf_core_metamodel_Field = (function() {
  return this.bindingsField$2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype.productPrefix__T = (function() {
  return "AsyncServerBindingsParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype.handleRef__T__Lamf_core_model_domain_NamedDomainElement = (function(fullRef) {
  return this.handleRef__T__Lamf_plugins_domain_webapi_models_bindings_ServerBindings(fullRef)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser)) {
    var AsyncServerBindingsParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser(x$1);
    var x = this.entryLike$2;
    var x$2 = AsyncServerBindingsParser$1.entryLike$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      return (this.parent$2 === AsyncServerBindingsParser$1.parent$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype.errorBindings__T__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_core_model_domain_NamedDomainElement = (function(fullRef, entryLike) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorServerBindings().init___T__Lorg_yaml_model_YPart(fullRef, entryLike.asMap__Lorg_yaml_model_YMap())
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entryLike$2;
      break
    }
    case 1: {
      return this.parent$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype.parseLastWill__p2__Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V = (function(binding, map, ctx) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("lastWill");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
    var fields = new $c_Lamf_core_parser_Fields().init___();
    var qual$1 = new $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
    var x$1 = binding.id$1;
    $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var lastWill = $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
    var this$6 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var lastWillMap = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion, ctx));
    var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(lastWillMap);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$().Topic$1;
    jsx$1.key__T__F1__V("topic", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(lastWill));
    var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(lastWillMap);
    var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$().Qos$1;
    jsx$2.key__T__F1__V("qos", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(lastWill));
    var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(lastWillMap);
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$().Retain$1;
    jsx$3.key__T__F1__V("retain", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(lastWill));
    ctx.closedShape__T__Lorg_yaml_model_YMap__T__V(lastWill.id$1, lastWillMap, "mqttServerLastWill");
    var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().LastWill$1;
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(binding, field$3, lastWill, annotations$1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(entryLike, parent, ctx) {
  this.entryLike$2 = entryLike;
  this.parent$2 = parent;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext.call(this, entryLike, parent, ctx);
  this.bindingsField$2 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$().Bindings$1;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype.parseMqtt__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_DomainElement = (function(entry, parent, ctx) {
  return this.parseMqtt__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_ServerBinding(entry, parent, ctx)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype.handleRef__T__Lamf_plugins_domain_webapi_models_bindings_ServerBindings = (function(fullRef) {
  var label = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().stripOas3ComponentsPrefix__T__T__T(fullRef, "serverBindings");
  var this$1 = this.ctx$2.declarations$4.findServerBindings__T__Lamf_core_parser_SearchScope$Scope__s_Option(label, $m_Lamf_core_parser_SearchScope$Named$());
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var serverBindings = $as_Lamf_plugins_domain_webapi_models_bindings_ServerBindings(arg1);
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var this$3 = new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_bindings_ServerBindings(this.nameAndAdopt__Lamf_core_model_domain_NamedDomainElement__s_Option__Lamf_core_model_domain_NamedDomainElement($as_Lamf_core_model_domain_NamedDomainElement($f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(serverBindings, label, annotations)), this.entryLike$2.key__s_Option())))
  };
  return $as_Lamf_plugins_domain_webapi_models_bindings_ServerBindings((this$3.isEmpty__Z() ? $as_Lamf_plugins_domain_webapi_models_bindings_ServerBindings(this.remote__T__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_core_model_domain_NamedDomainElement(fullRef, this.entryLike$2, this.parent$2, this.ctx$2)) : this$3.get__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype.parseMqtt__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_domain_webapi_models_bindings_ServerBinding = (function(entry, parent, ctx) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var binding = $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, parent));
  var this$3 = entry.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, ctx));
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().ClientId$1;
  jsx$1.key__T__F1__V("clientId", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().CleanSession$1;
  jsx$2.key__T__F1__V("cleanSession", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().KeepAlive$1;
  jsx$3.key__T__F1__V("keepAlive", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, ctx).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(binding));
  this.parseLastWill__p2__Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V(binding, map, ctx);
  this.parseBindingVersion__Lamf_plugins_domain_webapi_models_bindings_BindingVersion__Lamf_core_metamodel_Field__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__V(binding, $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().BindingVersion$1, map, ctx);
  ctx.closedShape__T__Lorg_yaml_model_YMap__T__V(binding.id$1, map, "mqttServerBinding");
  return binding
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype.createParser__Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser = (function(entryLike) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser().init___Lamf_plugins_document_webapi_parser_spec_common_YMapEntryLike__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(entryLike, this.parent$2, this.ctx$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype.createBindings__Lamf_core_model_domain_NamedDomainElement = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.binding.AsyncServerBindingsParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.binding.AsyncServerBindingsParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.binding.AsyncServerBindingsParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncBindingsParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_binding_AsyncServerBindingsParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter() {
  $c_O.call(this);
  this.endpoint$1 = null;
  this.pathName$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter.prototype.productPrefix__T = (function() {
  return "EndPointEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters__Lamf_plugins_domain_webapi_models_EndPoint__s_Option__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function($$outer, endpoint, pathName, ordering, references, spec) {
  this.endpoint$1 = endpoint;
  this.pathName$1 = pathName;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var EndPointEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter(x$1);
    var x = this.endpoint$1;
    var x$2 = EndPointEmitter$1.endpoint$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.pathName$1;
      var x$4 = EndPointEmitter$1.pathName$1;
      var jsx$2 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.ordering$1;
      var x$6 = EndPointEmitter$1.ordering$1;
      var jsx$1 = (x$5 === x$6)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.references$1;
      var x$8 = EndPointEmitter$1.references$1;
      return ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.endpoint$1;
      break
    }
    case 1: {
      return this.pathName$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter.prototype.operations__p1__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__sc_Seq__sc_Seq = (function(f, ordering, endpointPayloadEmitted, references) {
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(f.value$1.value$1).values$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ordering$1, endpointPayloadEmitted$1, references$1) {
    return (function(e$2) {
      var e = $as_Lamf_core_model_domain_AmfElement(e$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OperationEmitter().init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_emitter_SpecOrdering__Z__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext($as_Lamf_plugins_domain_webapi_models_Operation(e), ordering$1, endpointPayloadEmitted$1, references$1, $this.spec$1)
    })
  })(this, ordering, endpointPayloadEmitted, references));
  var this$1 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var fs = this.endpoint$1.fields$1;
  var k = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var this$2 = this.pathName$1;
  if (this$2.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var x$1 = $as_T(arg1);
    var this$4 = new $c_s_Some().init___O(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(x$1, new $c_Lamf_core_parser_Annotations().init___()))
  };
  if (this$4.isEmpty__Z()) {
    var this$5 = $as_Lamf_core_parser_FieldEntry(fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1).get__O());
    var jsx$1 = $as_Lamf_core_model_domain_AmfScalar(this$5.value$1.value$1)
  } else {
    var jsx$1 = this$4.get__O()
  };
  new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType($as_Lamf_core_model_domain_AmfScalar(jsx$1), $m_Lorg_yaml_model_YType$().Str$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(k);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$11 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$8 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Name$1);
  if ((!this$8.isEmpty__Z())) {
    var arg1$1 = this$8.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("displayName").asOasExtension__T(), f, $m_s_None$())))
  };
  var this$11 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Description$1);
  if ((!this$11.isEmpty__Z())) {
    var arg1$2 = this$11.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    var descriptionKey = ((this.spec$1 instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext) ? "description" : new $c_Lamf_core_utils_package$AmfStrings().init___T("description").asOasExtension__T());
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(descriptionKey, f$3, $m_s_None$())))
  };
  var this$14 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field());
  if ((!this$14.isEmpty__Z())) {
    var arg1$3 = this$14.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    new $c_s_Some().init___O(result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lamf_core_errorhandling_ErrorHandler(f$4, this.ordering$1, true, this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler()).emitters__sc_Seq()))
  };
  var jsx$4 = $m_Lamf_plugins_document_webapi_parser_spec_domain_Parameters$();
  var this$15 = this.endpoint$1;
  var this$16 = $as_Lamf_core_model_StrField(this$15.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1));
  var this$17 = this$16.option$1;
  var jsx$3 = $as_T((this$17.isEmpty__Z() ? null : this$17.get__O()));
  var this$18 = this.endpoint$1;
  var jsx$2 = $as_sc_Seq(this$18.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1));
  var this$19 = this.endpoint$1;
  var parameters = jsx$4.classified__T__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_parser_spec_domain_Parameters(jsx$3, jsx$2, $as_sc_Seq(this$19.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Payloads$1)));
  var x1 = this.spec$1;
  if ((x1 instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext)) {
    var this$20 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Summary$1);
    if ((!this$20.isEmpty__Z())) {
      var arg1$4 = this$20.get__O();
      var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$4);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("summary", f$5, $m_s_None$())))
    };
    var this$22 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Servers$1);
    if ((!this$22.isEmpty__Z())) {
      var arg1$5 = this$22.get__O();
      var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$5);
      var this$23 = $as_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory(this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory());
      var endpoint = this.endpoint$1;
      var ordering = this.ordering$1;
      var references = this.references$1;
      new $c_s_Some().init___O(result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3EndPointServersEmitter().init___Lamf_plugins_domain_webapi_models_EndPoint__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(endpoint, f$6, ordering, references, this$23.spec$3).emitters__sc_Seq()))
    }
  };
  if (parameters.nonEmpty__Z()) {
    var jsx$10 = parameters.query$1;
    var jsx$9 = parameters.path$1;
    var this$24 = $m_sc_Seq$();
    var jsx$8 = $as_sc_TraversableLike(jsx$10.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$9, this$24.ReusableCBFInstance$2));
    var jsx$7 = parameters.header$1;
    var this$25 = $m_sc_Seq$();
    var jsx$6 = $as_sc_TraversableLike(jsx$8.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$7, this$25.ReusableCBFInstance$2));
    var jsx$5 = parameters.cookie$1;
    var this$26 = $m_sc_Seq$();
    result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext("parameters", $as_sc_Seq(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$5, this$26.ReusableCBFInstance$2)), this.ordering$1, parameters.body$1, this.references$1, this.spec$1).oasEndpointEmitters__sc_Seq())
  };
  var this$27 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1);
  if ((!this$27.isEmpty__Z())) {
    var arg1$6 = this$27.get__O();
    var f$7 = $as_Lamf_core_parser_FieldEntry(arg1$6);
    new $c_s_Some().init___O(result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(this.operations__p1__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__sc_Seq__sc_Seq(f$7, this.ordering$1, parameters.body$1.nonEmpty__Z(), this.references$1)))
  };
  var this$28 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Security$1);
  if ((!this$28.isEmpty__Z())) {
    var arg1$7 = this$28.get__O();
    var f$8 = $as_Lamf_core_parser_FieldEntry(arg1$7);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(new $c_Lamf_core_utils_package$AmfStrings().init___T("security").asOasExtension__T(), f$8, this.ordering$1, this.spec$1)))
  };
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.endpoint$1, this.ordering$1, this.spec$1).emitters__sc_Seq());
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$11.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$30 = k.builder$1;
  var jsx$12 = $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$30, 0));
  var this$31 = v.builder$1;
  b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(jsx$12, $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$31, 0)))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.endpoint$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.AccessibleOasDocumentEmitters$EndPointEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.AccessibleOasDocumentEmitters$EndPointEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.AccessibleOasDocumentEmitters$EndPointEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter() {
  $c_O.call(this);
  this.requests$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter.prototype.productPrefix__T = (function() {
  return "Oas3RequestBodyDeclarationsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter)) {
    var Oas3RequestBodyDeclarationsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter(x$1);
    var x = this.requests$1;
    var x$2 = Oas3RequestBodyDeclarationsEmitter$1.requests$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = Oas3RequestBodyDeclarationsEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = Oas3RequestBodyDeclarationsEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.requests$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("requestBodies");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  this.requests$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, decBuilder) {
    return (function(request$2) {
      var request = $as_Lamf_plugins_domain_webapi_models_Request(request$2);
      var result = $m_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$().emitters__Lamf_plugins_domain_webapi_models_Request__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext__scm_ListBuffer(request, $this.ordering$1, $this.references$1, $this.spec$1);
      if (result.nonEmpty__Z()) {
        $m_Lorg_yaml_model_YNode$();
        var this$3 = $as_Lamf_core_model_StrField(request.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Name$1));
        var this$4 = this$3.option$1;
        var str = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
        var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
        var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(decBuilder.sourceName$2);
        var jsx$1 = v$1.builder$1;
        var sourceName$1 = v$1.sourceName$2;
        var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
        $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V($this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$2);
        jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1));
        var this$9 = v$1.builder$1;
        var array = [key$1];
        if ((this$9.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len = $uI(array.length);
        var newSize = ((this$9.size0$6 + len) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$9, newSize);
        var len$1 = this$9.size0$6;
        var src = this$9.array$6;
        var dest = this$9.array$6;
        $systemArraycopy(src, 0, dest, len, len$1);
        var xs = this$9.array$6;
        var len$2 = xs.u.length;
        var i = 0;
        var j = 0;
        var x = $uI(array.length);
        var x$1 = ((x < len$2) ? x : len$2);
        var that = xs.u.length;
        var end = ((x$1 < that) ? x$1 : that);
        while ((i < end)) {
          var jsx$2 = j;
          var index = i;
          xs.set(jsx$2, array[index]);
          i = ((1 + i) | 0);
          j = ((1 + j) | 0)
        };
        this$9.size0$6 = newSize;
        decBuilder.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1))
      }
    })
  })(this, b$1)));
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$22 = v.builder$1;
  var array$1 = [key];
  if ((this$22.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len$3 = $uI(array$1.length);
  var newSize$1 = ((this$22.size0$6 + len$3) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$22, newSize$1);
  var len$4 = this$22.size0$6;
  var src$1 = this$22.array$6;
  var dest$1 = this$22.array$6;
  $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
  var xs$1 = this$22.array$6;
  var len$5 = xs$1.u.length;
  var i$1 = 0;
  var j$1 = 0;
  var x$2 = $uI(array$1.length);
  var x$3 = ((x$2 < len$5) ? x$2 : len$5);
  var that$1 = xs$1.u.length;
  var end$1 = ((x$3 < that$1) ? x$3 : that$1);
  while ((i$1 < end$1)) {
    var jsx$4 = j$1;
    var index$1 = i$1;
    xs$1.set(jsx$4, array$1[index$1]);
    i$1 = ((1 + i$1) | 0);
    j$1 = ((1 + j$1) | 0)
  };
  this$22.size0$6 = newSize$1;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(requests, ordering, references, spec) {
  this.requests$1 = requests;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.requests$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var rq = $as_Lamf_plugins_domain_webapi_models_Request(arg1);
    var this$3 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var this$2 = $as_sc_Seq(rq.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1)).headOption__s_Option();
    var annotations = $as_Lamf_core_model_domain_AmfElement((this$2.isEmpty__Z() ? rq : this$2.get__O())).annotations__Lamf_core_parser_Annotations();
    var this$4 = new $c_s_Some().init___O(this$3.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$4.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$4.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.Oas3RequestBodyDeclarationsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.Oas3RequestBodyDeclarationsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.Oas3RequestBodyDeclarationsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyDeclarationsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter() {
  $c_O.call(this);
  this.request$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter.prototype.productPrefix__T = (function() {
  return "Oas3RequestBodyEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter)) {
    var Oas3RequestBodyEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter(x$1);
    var x = this.request$1;
    var x$2 = Oas3RequestBodyEmitter$1.request$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = Oas3RequestBodyEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = Oas3RequestBodyEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.request$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.request$1;
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1).isDefined__Z()) {
    var jsx$1 = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$();
    var this$2 = this.request$1;
    var this$3 = $as_Lamf_core_model_StrField(this$2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1));
    var this$4 = this$3.option$1;
    var refUrl = jsx$1.appendOas3ComponentsPrefix__T__T__T($as_T((this$4.isEmpty__Z() ? null : this$4.get__O())), "requestBodies");
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("requestBody");
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$2 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lorg_yaml_model_YNode$();
    var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("$ref");
    $m_Lorg_yaml_model_YNode$();
    var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(refUrl);
    b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$1, value);
    jsx$2.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
    var this$11 = v.builder$1;
    var array = [key];
    if ((this$11.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$11.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$11, newSize);
    var len$1 = this$11.size0$6;
    var src = this$11.array$6;
    var dest = this$11.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$11.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$3 = j;
      var index = i;
      xs.set(jsx$3, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$11.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  } else {
    var result = $m_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter$().emitters__Lamf_plugins_domain_webapi_models_Request__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext__scm_ListBuffer(this.request$1, this.ordering$1, this.references$1, this.spec$1);
    if (result.nonEmpty__Z()) {
      $m_Lorg_yaml_model_YNode$();
      var key$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("requestBody");
      var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
      var jsx$4 = v$1.builder$1;
      var sourceName$1 = v$1.sourceName$2;
      var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
      $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$2);
      jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1));
      var this$26 = v$1.builder$1;
      var array$1 = [key$2];
      if ((this$26.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$3 = $uI(array$1.length);
      var newSize$1 = ((this$26.size0$6 + len$3) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$26, newSize$1);
      var len$4 = this$26.size0$6;
      var src$1 = this$26.array$6;
      var dest$1 = this$26.array$6;
      $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
      var xs$1 = this$26.array$6;
      var len$5 = xs$1.u.length;
      var i$1 = 0;
      var j$1 = 0;
      var x$2 = $uI(array$1.length);
      var x$3 = ((x$2 < len$5) ? x$2 : len$5);
      var that$1 = xs$1.u.length;
      var end$1 = ((x$3 < that$1) ? x$3 : that$1);
      while ((i$1 < end$1)) {
        var jsx$5 = j$1;
        var index$1 = i$1;
        xs$1.set(jsx$5, array$1[index$1]);
        i$1 = ((1 + i$1) | 0);
        j$1 = ((1 + j$1) | 0)
      };
      this$26.size0$6 = newSize$1;
      b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Request__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(request, ordering, references, spec) {
  this.request$1 = request;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$3 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var this$1 = this.request$1;
  var this$2 = $as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1)).headOption__s_Option();
  var annotations = $as_Lamf_core_model_domain_AmfElement((this$2.isEmpty__Z() ? this.request$1 : this$2.get__O())).annotations__Lamf_core_parser_Annotations();
  return this$3.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.Oas3RequestBodyEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.Oas3RequestBodyEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.Oas3RequestBodyEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter() {
  $c_O.call(this);
  this.properties$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(properties, ordering, spec) {
  this.properties$1 = properties;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter.prototype.productPrefix__T = (function() {
  return "OasAnnotationsTypesEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter)) {
    var OasAnnotationsTypesEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter(x$1);
    var x = this.properties$1;
    var x$2 = OasAnnotationsTypesEmitter$1.properties$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasAnnotationsTypesEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.properties$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = new $c_Lamf_core_utils_package$AmfStrings().init___T("annotationTypes").asOasExtension__T();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$5 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var jsx$3 = this.ordering$1;
  var jsx$2 = this.properties$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$9$2) {
      var x$9 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(x$9$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter().init___Lamf_core_model_domain_extensions_CustomDomainProperty__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(x$9, $this.ordering$1, $this.spec$1)
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  jsx$4.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$3.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2))), b$1);
  jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$6 = j;
    var index = i;
    xs.set(jsx$6, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.properties$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var p = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = p.annotations$1;
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasAnnotationsTypesEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasAnnotationsTypesEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasAnnotationsTypesEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasAnnotationsTypesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter() {
  $c_O.call(this);
  this.oasParameters$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.key$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter.prototype.productPrefix__T = (function() {
  return "OasDeclaredParametersEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter)) {
    var OasDeclaredParametersEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter(x$1);
    var x = this.oasParameters$1;
    var x$2 = OasDeclaredParametersEmitter$1.oasParameters$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasDeclaredParametersEmitter$1.ordering$1;
      var jsx$2 = (x$3 === x$4)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.references$1;
      var x$6 = OasDeclaredParametersEmitter$1.references$1;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.key$1 === OasDeclaredParametersEmitter$1.key$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__T__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(oasParameters, ordering, references, key, spec) {
  this.oasParameters$1 = oasParameters;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.key$1 = key;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.oasParameters$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    case 3: {
      return this.key$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$5 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var jsx$3 = this.ordering$1;
  var jsx$2 = this.oasParameters$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$5$2) {
      var x$5 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(x$5$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter().init___Lamf_plugins_document_webapi_parser_spec_domain_OasParameter__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(x$5, $this.ordering$1, $this.references$1, $this.spec$1)
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  jsx$4.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$3.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))), b$1);
  jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$6 = j;
    var index = i;
    xs.set(jsx$6, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.oasParameters$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var o = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = o.domainElement$1.annotations__Lamf_core_parser_Annotations();
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasDeclaredParametersEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasDeclaredParametersEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasDeclaredParametersEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredParametersEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.responses$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter.prototype.productPrefix__T = (function() {
  return "OasDeclaredResponsesEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter)) {
    var OasDeclaredResponsesEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter(x$1);
    if ((this.key$1 === OasDeclaredResponsesEmitter$1.key$1)) {
      var x = this.responses$1;
      var x$2 = OasDeclaredResponsesEmitter$1.responses$1;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$3 = this.ordering$1;
      var x$4 = OasDeclaredResponsesEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = OasDeclaredResponsesEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.responses$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter.prototype.init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(key, responses, ordering, references, spec) {
  this.key$1 = key;
  this.responses$1 = responses;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$5 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var jsx$3 = this.ordering$1;
  var jsx$2 = this.responses$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$12$2) {
      var x$12 = $as_Lamf_plugins_domain_webapi_models_Response(x$12$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseEmitter().init___Lamf_plugins_domain_webapi_models_Response__Lamf_core_emitter_SpecOrdering__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(x$12, $this.ordering$1, $this.references$1, true, $this.spec$1)
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  jsx$4.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$3.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))), b$1);
  jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$6 = j;
    var index = i;
    xs.set(jsx$6, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.responses$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var a = $as_Lamf_plugins_domain_webapi_models_Response(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = a.annotations$2;
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasDeclaredResponsesEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasDeclaredResponsesEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasDeclaredResponsesEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasDeclaredResponsesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.f$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.orphanAnnotations$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter.prototype.productPrefix__T = (function() {
  return "EndpointsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var EndpointsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter(x$1);
    if ((this.key$1 === EndpointsEmitter$1.key$1)) {
      var x = this.f$1;
      var x$2 = EndpointsEmitter$1.f$1;
      var jsx$3 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$3 = this.ordering$1;
      var x$4 = EndpointsEmitter$1.ordering$1;
      var jsx$2 = (x$3 === x$4)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.references$1;
      var x$6 = EndpointsEmitter$1.references$1;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.orphanAnnotations$1;
      var x$8 = EndpointsEmitter$1.orphanAnnotations$1;
      return ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.f$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.references$1;
      break
    }
    case 4: {
      return this.orphanAnnotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter__T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq = (function($$outer, key, f, ordering, references, orphanAnnotations) {
  this.key$1 = key;
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.orphanAnnotations$1 = orphanAnnotations;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var jsx$2 = this.endpoints__p1__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq(this.f$1, this.ordering$1, this.references$1);
  var jsx$1 = this.pathsElementAnnotations__p1__sc_Seq();
  var this$1 = $m_sc_Seq$();
  var emitters = $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(emitters, b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$4 = j;
    var index = i;
    xs.set(jsx$4, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter.prototype.pathsElementAnnotations__p1__sc_Seq = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.orphanAnnotations$1, this.ordering$1, this.$$outer$1.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext()).emitters__sc_Seq()
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter.prototype.endpoints__p1__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq = (function(f, ordering, references) {
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(f.value$1.value$1).values$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ordering$1, references$1) {
    return (function(e$2) {
      var e = $as_Lamf_core_model_domain_AmfElement(e$2);
      return $this.$$outer$1.EndPointEmitter__Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter$().apply__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext__Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters$EndPointEmitter($as_Lamf_plugins_domain_webapi_models_EndPoint(e), ordering$1, references$1, $this.$$outer$1.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext())
    })
  })(this, ordering, references));
  var this$1 = $m_sc_Seq$();
  var result = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  return ordering.sorted__sc_Seq__sc_Seq(result)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasDocumentEmitter$EndpointsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasDocumentEmitter$EndpointsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasDocumentEmitter$EndpointsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter$EndpointsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter() {
  $c_O.call(this);
  this.oasHeader$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter.prototype.productPrefix__T = (function() {
  return "OasHeaderEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var OasHeaderEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter(x$1);
    var x = this.oasHeader$1;
    var x$2 = OasHeaderEmitter$1.oasHeader$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.oasHeader$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position(this.oasHeader$1.key$1, this.oasHeader$1.value$1, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter__Lamf_plugins_document_webapi_parser_OasHeader = (function($$outer, oasHeader) {
  this.oasHeader$1 = oasHeader;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  return $m_Lamf_core_parser_Position$ZERO$()
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$OasHeaderEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$OasHeaderEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentEmitter$OasHeaderEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter$OasHeaderEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter() {
  $c_O.call(this);
  this.oasParameter$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter.prototype.productPrefix__T = (function() {
  return "OasNamedParameterEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter)) {
    var OasNamedParameterEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter(x$1);
    var x = this.oasParameter$1;
    var x$2 = OasNamedParameterEmitter$1.oasParameter$1;
    if ((x === x$2)) {
      var x$3 = this.ordering$1;
      var x$4 = OasNamedParameterEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = OasNamedParameterEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.oasParameter$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = $as_Lamf_core_model_domain_NamedDomainElement(this.oasParameter$1.domainElement$1);
  var x1 = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(this$1.nameField__Lamf_core_metamodel_Field())).option$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var n = $as_T(x2.value$2);
    var name = n
  } else {
    var this$3 = this.spec$1.eh__Lamf_core_errorhandling_ErrorHandler();
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
    var node = this.oasParameter$1.domainElement$1.id__T();
    var property = $m_s_None$();
    var message = ("Cannot declare parameter without name " + this.oasParameter$1.domainElement$1);
    var this$2 = this.oasParameter$1.domainElement$1;
    var lexical = this$2.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var location = this.oasParameter$1.domainElement$1.location__s_Option();
    this$3.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
    var name = "default-name"
  };
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(name);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var x1$1 = this.oasParameter$1.domainElement$1;
  if ((x1$1 instanceof $c_Lamf_plugins_domain_webapi_models_Parameter)) {
    var x2$1 = $as_Lamf_plugins_domain_webapi_models_Parameter(x1$1);
    new $c_Lamf_plugins_document_webapi_parser_spec_domain_ParameterEmitter().init___Lamf_plugins_domain_webapi_models_Parameter__Lamf_core_emitter_SpecOrdering__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(x2$1, this.ordering$1, this.references$1, false, this.spec$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v)
  } else if ((x1$1 instanceof $c_Lamf_plugins_domain_webapi_models_Payload)) {
    var x3 = $as_Lamf_plugins_domain_webapi_models_Payload(x1$1);
    new $c_Lamf_plugins_document_webapi_parser_spec_domain_PayloadAsParameterEmitter().init___Lamf_plugins_domain_webapi_models_Payload__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(x3, this.ordering$1, this.references$1, this.spec$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v)
  };
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_domain_OasParameter__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(oasParameter, ordering, references, spec) {
  this.oasParameter$1 = oasParameter;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.oasParameter$1.domainElement$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasNamedParameterEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasNamedParameterEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasNamedParameterEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedParameterEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter() {
  $c_O.call(this);
  this.annotationType$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter.prototype.productPrefix__T = (function() {
  return "OasNamedPropertyTypeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter)) {
    var OasNamedPropertyTypeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter(x$1);
    var x = this.annotationType$1;
    var x$2 = OasNamedPropertyTypeEmitter$1.annotationType$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = OasNamedPropertyTypeEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.annotationType$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var this$1 = this.annotationType$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Name$1)).option$1;
  if (this$2.isEmpty__Z()) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot declare annotation type without name " + this.annotationType$1)))
  };
  var str = $as_T(this$2.get__O());
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var this$4 = this.annotationType$1;
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$4).isDefined__Z()) {
    var jsx$1 = this.annotationType$1;
    var this$5 = this.annotationType$1;
    new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter().init___Lamf_core_model_domain_DomainElement__s_Option__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(jsx$1, $as_Lamf_core_model_StrField(this$5.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1, $m_sci_Nil$(), this.spec$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v)
  } else {
    var x1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter(this.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory().annotationTypeEmitter__F2().apply__O__O__O(this.annotationType$1, this.ordering$1)).emitters__s_util_Either();
    if ((x1 instanceof $c_s_util_Left)) {
      var x2 = $as_s_util_Left(x1);
      var emitters = $as_sc_Seq(x2.value$2);
      var jsx$2 = v.builder$1;
      var sourceName = v.sourceName$2;
      var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
      $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(emitters), b$1);
      jsx$2.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
    } else if ((x1 instanceof $c_s_util_Right)) {
      var x3 = $as_s_util_Right(x1);
      var part = $as_Lamf_core_emitter_PartEmitter(x3.value$2);
      part.emit__Lorg_yaml_model_YDocument$PartBuilder__V(v)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  var this$9 = v.builder$1;
  var array = [key];
  if ((this$9.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$9.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$9, newSize);
  var len$1 = this$9.size0$6;
  var src = this$9.array$6;
  var dest = this$9.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$9.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$3 = j;
    var index = i;
    xs.set(jsx$3, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$9.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter.prototype.init___Lamf_core_model_domain_extensions_CustomDomainProperty__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(annotationType, ordering, spec) {
  this.annotationType$1 = annotationType;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.annotationType$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasNamedPropertyTypeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasNamedPropertyTypeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasNamedPropertyTypeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedPropertyTypeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.url$1 = null;
  this.pos$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter.prototype.productPrefix__T = (function() {
  return "OasNamedRefEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter)) {
    var OasNamedRefEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter(x$1);
    if (((this.key$1 === OasNamedRefEmitter$1.key$1) && (this.url$1 === OasNamedRefEmitter$1.url$1))) {
      var x = this.pos$1;
      var x$2 = OasNamedRefEmitter$1.pos$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.url$1;
      break
    }
    case 2: {
      return this.pos$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter.prototype.init___T__T__Lamf_core_parser_Position__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(key, url, pos, spec) {
  this.key$1 = key;
  this.url$1 = url;
  this.pos$1 = pos;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  this.spec$1.ref__Lorg_yaml_model_YDocument$PartBuilder__T__V(v, this.url$1);
  var this$4 = v.builder$1;
  var array = [key];
  if ((this$4.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$4.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$4, newSize);
  var len$1 = this$4.size0$6;
  var src = this$4.array$6;
  var dest = this$4.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$4.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$4.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  return this.pos$1
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasNamedRefEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasNamedRefEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasNamedRefEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasNamedRefEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter() {
  $c_O.call(this);
  this.reference$1 = null;
  this.aliases$1 = null;
  this.ordering$1 = null;
  this.aliasGenerator$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter.prototype.productPrefix__T = (function() {
  return "ReferenceEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var ReferenceEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter(x$1);
    var x = this.reference$1;
    var x$2 = ReferenceEmitter$1.reference$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.aliases$1;
      var x$4 = ReferenceEmitter$1.aliases$1;
      var jsx$2 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.ordering$1;
      var x$6 = ReferenceEmitter$1.ordering$1;
      var jsx$1 = (x$5 === x$6)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.aliasGenerator$1;
      var x$8 = ReferenceEmitter$1.aliasGenerator$1;
      return (x$7 === x$8)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.reference$1;
      break
    }
    case 1: {
      return this.aliases$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.aliasGenerator$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter.prototype.name__p1__T = (function() {
  var this$1 = this.reference$1;
  var this$2 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$1);
  return $as_T((this$2.isEmpty__Z() ? this.reference$1.id__T() : this$2.get__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.aliases$1;
  var aliasesMap = $as_Lamf_core_annotations_Aliases((this$1.isEmpty__Z() ? new $c_Lamf_core_annotations_Aliases().init___sci_Set($as_sci_Set($m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))) : this$1.get__O())).aliases$1;
  var this$3 = aliasesMap.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var p3 = $as_T2(x0$1.$$und2__O());
        if ((p3 !== null)) {
          var f = $as_T(p3.$$und1__O());
          return (f === this$2.reference$1.id__T())
        }
      };
      throw new $c_s_MatchError().init___O(x0$1)
    })
  })(this)));
  if (this$3.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1 = this$3.get__O();
    var x0$2 = $as_T2(arg1);
    matchEnd5$1: {
      var jsx$1;
      if ((x0$2 !== null)) {
        var a = $as_T(x0$2.$$und1__O());
        var p2 = $as_T2(x0$2.$$und2__O());
        if ((p2 !== null)) {
          var r = $as_T(p2.$$und2__O());
          var jsx$1 = new $c_T2().init___O__O(a, r);
          break matchEnd5$1
        }
      };
      throw new $c_s_MatchError().init___O(x0$2)
    };
    var this$4 = new $c_s_Some().init___O(jsx$1)
  };
  var effectiveAlias = $as_T2((this$4.isEmpty__Z() ? new $c_T2().init___O__O(this.aliasGenerator$1.apply__O(), this.name__p1__T()) : this$4.get__O()));
  new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position($as_T(effectiveAlias.$$und1__O()), $as_T(effectiveAlias.$$und2__O()), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter__Lamf_core_model_document_BaseUnit__s_Option__Lamf_core_emitter_SpecOrdering__F0 = (function($$outer, reference, aliases, ordering, aliasGenerator) {
  this.reference$1 = reference;
  this.aliases$1 = aliases;
  this.ordering$1 = ordering;
  this.aliasGenerator$1 = aliasGenerator;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  return $m_Lamf_core_parser_Position$ZERO$()
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasSpecEmitter$ReferenceEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasSpecEmitter$ReferenceEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasSpecEmitter$ReferenceEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter() {
  $c_O.call(this);
  this.baseUnit$1 = null;
  this.ordering$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter.prototype.productPrefix__T = (function() {
  return "ReferencesEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var ReferencesEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter(x$1);
    var x = this.baseUnit$1;
    var x$2 = ReferencesEmitter$1.baseUnit$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = ReferencesEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.baseUnit$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.baseUnit$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_Aliases.getClassOf());
  var aliases = $as_Lamf_core_annotations_Aliases((this$1.isEmpty__Z() ? new $c_Lamf_core_annotations_Aliases().init___sci_Set($as_sci_Set($m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))) : this$1.get__O()));
  var references = this.baseUnit$1.references__sc_Seq();
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter(this);
  var this$2 = $m_sc_Seq$();
  var modules = $as_sc_Seq(references.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  if (modules.nonEmpty__Z()) {
    var elem = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var modulesEmitted = new $c_sr_ObjectRef().init___O(elem);
    var idCounter = new $c_Lamf_core_utils_package$IdCounter().init___();
    var this$12 = aliases.aliases$1;
    var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, modules$1, modulesEmitted$1, idCounter$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_T2(x0$1$2);
        if ((x0$1 !== null)) {
          var alias = $as_T(x0$1.$$und1__O());
          var p2 = $as_T2(x0$1.$$und2__O());
          if ((p2 !== null)) {
            var fullUrl = $as_T(p2.$$und1__O());
            var localUrl = $as_T(p2.$$und2__O());
            var x1$2 = modules$1.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, fullUrl$1) {
              return (function(x$17$2) {
                var x$17 = $as_Lamf_core_model_document_Module(x$17$2);
                return (x$17.id$1 === fullUrl$1)
              })
            })(this$2$1, fullUrl)));
            if ((x1$2 instanceof $c_s_Some)) {
              var x2 = $as_s_Some(x1$2);
              var module = $as_Lamf_core_model_document_Module(x2.value$2);
              var jsx$2 = $as_sci_Map(modulesEmitted$1.elem$1);
              var self = module.id$1;
              modulesEmitted$1.elem$1 = jsx$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, module));
              var jsx$4 = this$2$1.$$outer$1;
              var y = new $c_T2().init___O__O(fullUrl, localUrl);
              var array = [new $c_T2().init___O__O(alias, y)];
              if (($uI(array.length) === 0)) {
                var jsx$3 = $m_sci_Set$EmptySet$()
              } else {
                var b$1 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
                var i = 0;
                var len = $uI(array.length);
                while ((i < len)) {
                  var index = i;
                  var arg1 = array[index];
                  b$1.$$plus$eq__O__scm_SetBuilder(arg1);
                  i = ((1 + i) | 0)
                };
                var jsx$3 = b$1.elems$1
              };
              return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter__Lamf_core_model_document_BaseUnit__s_Option__Lamf_core_emitter_SpecOrdering__F0(jsx$4, module, new $c_s_Some().init___O(new $c_Lamf_core_annotations_Aliases().init___sci_Set($as_sci_Set(jsx$3))), this$2$1.ordering$1, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$2$2, idCounter$1$1) {
                return (function() {
                  return idCounter$1$1.genId__T__T("uses")
                })
              })(this$2$1, idCounter$1))))
            } else {
              return $m_s_None$()
            }
          }
        };
        throw new $c_s_MatchError().init___O(x0$1)
      })
    })(this, modules, modulesEmitted, idCounter));
    var this$11 = $m_sci_Set$();
    var bf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$11);
    var aliasesEmitters = $as_sc_SetLike($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$12, f, bf)).toSeq__sc_Seq();
    var jsx$6 = $as_sc_TraversableLike(modules.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, modulesEmitted$2) {
      return (function(m$2) {
        var m = $as_Lamf_core_model_document_Module(m$2);
        return $as_sci_Map(modulesEmitted$2.elem$1).get__O__s_Option(m.id$1).isEmpty__Z()
      })
    })(this, modulesEmitted))));
    var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, idCounter$2) {
      return (function(module$2) {
        var module$1 = $as_Lamf_core_model_document_Module(module$2);
        return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferenceEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter__Lamf_core_model_document_BaseUnit__s_Option__Lamf_core_emitter_SpecOrdering__F0(this$4$1.$$outer$1, module$1, new $c_s_Some().init___O(new $c_Lamf_core_annotations_Aliases().init___sci_Set($as_sci_Set($m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())))), this$4$1.ordering$1, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this$1, idCounter$1$2) {
          return (function() {
            return idCounter$1$2.genId__T__T("uses")
          })
        })(this$4$1, idCounter$2))))
      })
    })(this, idCounter));
    var this$13 = $m_sc_Seq$();
    var missingModuleEmitters = $as_sc_Seq(jsx$6.map__F1__scg_CanBuildFrom__O(jsx$5, this$13.ReusableCBFInstance$2));
    var this$14 = $m_sc_Seq$();
    var jsx$8 = $as_sc_TraversableLike(aliasesEmitters.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(missingModuleEmitters, this$14.ReusableCBFInstance$2));
    var jsx$7 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter$$anonfun$2().init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter(this);
    var this$15 = $m_sc_Seq$();
    var finalEmitters = $as_sc_Seq(jsx$8.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$7, this$15.ReusableCBFInstance$2));
    $m_Lorg_yaml_model_YNode$();
    var str = new $c_Lamf_core_utils_package$AmfStrings().init___T("uses").asOasExtension__T();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$9 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(finalEmitters), b$2);
    jsx$9.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
    var this$21 = v.builder$1;
    var array$1 = [key];
    if ((this$21.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$1 = $uI(array$1.length);
    var newSize = ((this$21.size0$6 + len$1) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$21, newSize);
    var len$2 = this$21.size0$6;
    var src = this$21.array$6;
    var dest = this$21.array$6;
    $systemArraycopy(src, 0, dest, len$1, len$2);
    var xs = this$21.array$6;
    var len$3 = xs.u.length;
    var i$1 = 0;
    var j = 0;
    var x = $uI(array$1.length);
    var x$1 = ((x < len$3) ? x : len$3);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i$1 < end)) {
      var jsx$10 = j;
      var index$1 = i$1;
      xs.set(jsx$10, array$1[index$1]);
      i$1 = ((1 + i$1) | 0);
      j = ((1 + j) | 0)
    };
    this$21.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_SpecOrdering = (function($$outer, baseUnit, ordering) {
  this.baseUnit$1 = baseUnit;
  this.ordering$1 = ordering;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  return $m_Lamf_core_parser_Position$ZERO$()
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasSpecEmitter$ReferencesEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasSpecEmitter$ReferencesEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasSpecEmitter$ReferencesEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter$ReferencesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters() {
  $c_O.call(this);
  this.documents$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters.prototype.init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(documents, ordering, spec) {
  this.documents$1 = documents;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters.prototype.productPrefix__T = (function() {
  return "CreativeWorkEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters)) {
    var CreativeWorkEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters(x$1);
    var x = this.documents$1;
    var x$2 = CreativeWorkEmitters$1.documents$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = CreativeWorkEmitters$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.documents$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = new $c_Lamf_core_utils_package$AmfStrings().init___T("userDocumentation").asOasExtension__T();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$6 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  var jsx$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var jsx$3 = this.ordering$1;
  var jsx$2 = this.documents$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_plugins_domain_shapes_models_CreativeWork(x$2$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter().init___Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Z__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x$2, $this.ordering$1, false, $this.spec$1)
    })
  })(this));
  var this$4 = $m_sc_Seq$();
  jsx$4.traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V(jsx$3.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2))), b$1);
  var jsx$5 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$5.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$6.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$8 = v.builder$1;
  var array = [key];
  if ((this$8.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$8.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$8, newSize);
  var len$1 = this$8.size0$6;
  var src = this$8.array$6;
  var dest = this$8.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$8.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$7 = j;
    var index = i;
    xs.set(jsx$7, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$8.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.documents$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$4 = $as_Lamf_plugins_domain_shapes_models_CreativeWork(arg1);
    var this$2 = new $c_s_Some().init___O(x$4.annotations$1)
  };
  if (this$2.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1$1 = this$2.get__O();
    var annotations = $as_Lamf_core_parser_Annotations(arg1$1);
    var this$3 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var this$4 = new $c_s_Some().init___O(this$3.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$4.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$4.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.CreativeWorkEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.CreativeWorkEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.CreativeWorkEmitters", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_CreativeWorkEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter() {
  $c_O.call(this);
  this.fs$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter.prototype.productPrefix__T = (function() {
  return "InfoEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter)) {
    var InfoEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter(x$1);
    var x = this.fs$1;
    var x$2 = InfoEmitter$1.fs$1;
    if ((x === x$2)) {
      var x$3 = this.ordering$1;
      var x$4 = InfoEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fs$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter.prototype.init___Lamf_core_parser_Fields__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(fs, ordering, spec) {
  this.fs$1 = fs;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = this.fs$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Name$1);
  if (this$1.isEmpty__Z()) {
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("title", "API", $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()))
  } else {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("title", f, $m_s_None$()))
  };
  var this$5 = this.fs$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Description$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1$1 = this$5.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f$3, $m_s_None$())))
  };
  var this$7 = this.fs$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().TermsOfService$1);
  if ((!this$7.isEmpty__Z())) {
    var arg1$2 = this$7.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("termsOfService", f$4, $m_s_None$())))
  };
  var this$9 = this.fs$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Version$1);
  if (this$9.isEmpty__Z()) {
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("version", "1.0", $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()))
  } else {
    var arg1$3 = this$9.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("version", f$5, $m_s_None$()))
  };
  var this$13 = this.fs$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().License$1);
  if ((!this$13.isEmpty__Z())) {
    var arg1$4 = this$13.get__O();
    var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("license", f$6, this.ordering$1, this.spec$1)))
  };
  var this$14 = this.fs$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Provider$1);
  if ((!this$14.isEmpty__Z())) {
    var arg1$5 = this$14.get__O();
    var f$7 = $as_Lamf_core_parser_FieldEntry(arg1$5);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("contact", f$7, this.ordering$1, this.spec$1)))
  };
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("info");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$19 = v.builder$1;
  var array = [key];
  if ((this$19.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$19.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$19, newSize);
  var len$1 = this$19.size0$6;
  var src = this$19.array$6;
  var dest = this$19.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$19.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$19.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var elem = $m_Lamf_core_parser_Position$ZERO$();
  var elem$1 = null;
  elem$1 = elem;
  var this$2 = this.fs$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Version$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    var this$3 = f.value$1.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    if ((!this$3.isEmpty__Z())) {
      var arg1$1 = this$3.get__O();
      var x0$1 = $as_Lamf_core_annotations_LexicalInformation(arg1$1);
      if ((x0$1 !== null)) {
        var range = x0$1.range__Lamf_core_parser_Range();
        elem$1 = range.start$1
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    }
  };
  var this$4 = this.fs$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Name$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$2 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    var this$5 = f$3.value$1.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    if ((!this$5.isEmpty__Z())) {
      var arg1$3 = this$5.get__O();
      var x0$2 = $as_Lamf_core_annotations_LexicalInformation(arg1$3);
      if ((x0$2 !== null)) {
        var range$1 = x0$2.range__Lamf_core_parser_Range();
        if (($as_Lamf_core_parser_Position(elem$1).isZero__Z() || range$1.start$1.lt__Lamf_core_parser_Position__Z($as_Lamf_core_parser_Position(elem$1)))) {
          elem$1 = range$1.start$1
        }
      } else {
        throw new $c_s_MatchError().init___O(x0$2)
      }
    }
  };
  return $as_Lamf_core_parser_Position(elem$1)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.InfoEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.InfoEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.InfoEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_InfoEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.f$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter.prototype.productPrefix__T = (function() {
  return "LicenseEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter)) {
    var LicenseEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter(x$1);
    if ((this.key$1 === LicenseEmitter$1.key$1)) {
      var x = this.f$1;
      var x$2 = LicenseEmitter$1.f$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.ordering$1;
      var x$4 = LicenseEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.f$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var value = this.f$1.value$1;
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var this$4 = this.f$1;
  var fs = $as_Lamf_core_model_domain_AmfObject(this$4.value$1.value$1).fields__Lamf_core_parser_Fields();
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_LicenseModel$().Url$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1 = this$5.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("url", f, $m_s_None$())))
  };
  var this$7 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_LicenseModel$().Name$1);
  if ((!this$7.isEmpty__Z())) {
    var arg1$1 = this$7.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("name", f$3, $m_s_None$())))
  };
  var this$9 = this.f$1;
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext($as_Lamf_core_model_domain_DomainElement(this$9.value$1.value$1), this.ordering$1, this.spec$1).emitters__sc_Seq());
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$12 = v.builder$1;
  var array = [key];
  if ((this$12.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$12.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$12, newSize);
  var len$1 = this$12.size0$6;
  var src = this$12.array$6;
  var dest = this$12.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$12.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$12.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter.prototype.init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, f, ordering, spec) {
  this.key$1 = key;
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.LicenseEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.LicenseEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.LicenseEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_LicenseEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter() {
  $c_O.call(this);
  this.settings$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter.prototype.productPrefix__T = (function() {
  return "Oas3OAuth2FlowEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter)) {
    var Oas3OAuth2FlowEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter(x$1);
    var x = this.settings$1;
    var x$2 = Oas3OAuth2FlowEmitter$1.settings$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = Oas3OAuth2FlowEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.settings$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.settings$1;
  var fs = this$1.fields$1;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = this.settings$1;
  var orphanAnnotations = $as_sc_Seq($as_sc_Seq(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field())).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$3$2) {
      var x$3 = $as_Lamf_core_model_domain_extensions_DomainExtension(x$3$2);
      return $as_Lamf_core_model_domain_DataNode(x$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)).annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.getClassOf())
    })
  })(this))));
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(f, this.ordering$1, orphanAnnotations, this.spec$1))
  };
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.settings$1, this.ordering$1, this.spec$1).emitters__sc_Seq());
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_OAuth2Settings__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(settings, ordering, spec) {
  this.settings$1 = settings;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.settings$1;
  var this$2 = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1)).headOption__s_Option();
  if (this$2.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var flow = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow(arg1);
    var this$3 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = flow.annotations$1;
    var this$4 = new $c_s_Some().init___O(this$3.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$4.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$4.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.Oas3OAuth2FlowEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.Oas3OAuth2FlowEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.Oas3OAuth2FlowEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuth2FlowEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter() {
  $c_O.call(this);
  this.flow$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter.prototype.productPrefix__T = (function() {
  return "Oas3OAuthFlowEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter)) {
    var Oas3OAuthFlowEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter(x$1);
    var x = this.flow$1;
    var x$2 = Oas3OAuthFlowEmitter$1.flow$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = Oas3OAuthFlowEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.flow$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var fs = this.flow$1.fields$1;
  var jsx$1 = $m_Lorg_yaml_model_YNode$();
  var this$1 = this.flow$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Flow$1));
  var this$3 = this$2.option$1;
  var key = jsx$1.apply__T__Lorg_yaml_model_YNode($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())));
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$2 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var builders = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1 = this$5.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(builders.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("authorizationUrl", f, $m_s_None$())))
  };
  var this$7 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1);
  if ((!this$7.isEmpty__Z())) {
    var arg1$1 = this$7.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(builders.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("tokenUrl", f$3, $m_s_None$())))
  };
  var this$9 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().RefreshUri$1);
  if ((!this$9.isEmpty__Z())) {
    var arg1$2 = this$9.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(builders.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("refreshUrl", f$4, $m_s_None$())))
  };
  var this$11 = this.flow$1;
  var orphanAnnotations = $as_sc_Seq($as_sc_Seq(this$11.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field())).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
    return (function(x$6$2) {
      var x$6 = $as_Lamf_core_model_domain_extensions_DomainExtension(x$6$2);
      return $as_Lamf_core_model_domain_DataNode(x$6.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)).annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.getClassOf())
    })
  })(this))));
  var this$12 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Scopes$1);
  if ((!this$12.isEmpty__Z())) {
    var arg1$3 = this$12.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    builders.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("scopes", f$5, this.ordering$1, orphanAnnotations, this.spec$1))
  };
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(builders), b$1);
  jsx$2.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$15 = v.builder$1;
  var array = [key];
  if ((this$15.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$15.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$15, newSize);
  var len$1 = this$15.size0$6;
  var src = this$15.array$6;
  var dest = this$15.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$15.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$3 = j;
    var index = i;
    xs.set(jsx$3, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$15.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_OAuth2Flow__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(flow, ordering, spec) {
  this.flow$1 = flow;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.flow$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.Oas3OAuthFlowEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.Oas3OAuthFlowEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.Oas3OAuthFlowEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter() {
  $c_O.call(this);
  this.f$1 = null;
  this.ordering$1 = null;
  this.orphanAnnotations$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter.prototype.productPrefix__T = (function() {
  return "Oas3OAuthFlowsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(f, ordering, orphanAnnotations, spec) {
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.orphanAnnotations$1 = orphanAnnotations;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter)) {
    var Oas3OAuthFlowsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter(x$1);
    var x = this.f$1;
    var x$2 = Oas3OAuthFlowsEmitter$1.f$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = Oas3OAuthFlowsEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.orphanAnnotations$1;
      var x$6 = Oas3OAuthFlowsEmitter$1.orphanAnnotations$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.f$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.orphanAnnotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter.prototype.flowsElementAnnotations__p1__sc_Seq = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.orphanAnnotations$1, this.ordering$1, this.spec$1).emitters__sc_Seq()
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var flows = this.f$1.arrayValues__sc_Seq();
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(flow$2) {
      var flow = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow(flow$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowEmitter().init___Lamf_plugins_domain_webapi_models_security_OAuth2Flow__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(flow, $this.ordering$1, $this.spec$1)
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike(flows.map__F1__scg_CanBuildFrom__O(jsx$3, this$1.ReusableCBFInstance$2));
  var jsx$1 = this.flowsElementAnnotations__p1__sc_Seq();
  var this$2 = $m_sc_Seq$();
  var emitters = $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("flows");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$4 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(emitters), b$1);
  jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$5 = j;
    var index = i;
    xs.set(jsx$5, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.Oas3OAuthFlowsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.Oas3OAuthFlowsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.Oas3OAuthFlowsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3OAuthFlowsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.f$1 = null;
  this.ordering$1 = null;
  this.orphanAnnotations$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter.prototype.productPrefix__T = (function() {
  return "OasOAuth2ScopeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter.prototype.scopesElementAnnotations__p1__sc_Seq = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OrphanAnnotationsEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.orphanAnnotations$1, this.ordering$1, this.spec$1).emitters__sc_Seq()
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter)) {
    var OasOAuth2ScopeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter(x$1);
    if ((this.key$1 === OasOAuth2ScopeEmitter$1.key$1)) {
      var x = this.f$1;
      var x$2 = OasOAuth2ScopeEmitter$1.f$1;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$3 = this.ordering$1;
      var x$4 = OasOAuth2ScopeEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.orphanAnnotations$1;
      var x$6 = OasOAuth2ScopeEmitter$1.orphanAnnotations$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.f$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.orphanAnnotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var jsx$2 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasScopeValuesEmitters().init___Lamf_core_parser_FieldEntry(this.f$1).emitters__sc_Seq();
  var jsx$1 = this.scopesElementAnnotations__p1__sc_Seq();
  var this$1 = $m_sc_Seq$();
  var emitters = $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(emitters), b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$4 = j;
    var index = i;
    xs.set(jsx$4, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter.prototype.init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, f, ordering, orphanAnnotations, spec) {
  this.key$1 = key;
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.orphanAnnotations$1 = orphanAnnotations;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasOAuth2ScopeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.OasOAuth2ScopeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasOAuth2ScopeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOAuth2ScopeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter() {
  $c_O.call(this);
  this.settingsEntries$1 = null;
  this.settings$1 = null;
  this.ordering$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter.prototype.productPrefix__T = (function() {
  return "OasSettingsTypeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter.prototype.init___sc_Seq__Lamf_plugins_domain_webapi_models_security_Settings__Lamf_core_emitter_SpecOrdering = (function(settingsEntries, settings, ordering) {
  this.settingsEntries$1 = settingsEntries;
  this.settings$1 = settings;
  this.ordering$1 = ordering;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter)) {
    var OasSettingsTypeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter(x$1);
    var x = this.settingsEntries$1;
    var x$2 = OasSettingsTypeEmitter$1.settingsEntries$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.settings$1;
      var x$4 = OasSettingsTypeEmitter$1.settings$1;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.ordering$1;
      var x$6 = OasSettingsTypeEmitter$1.ordering$1;
      return (x$5 === x$6)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.settingsEntries$1;
      break
    }
    case 1: {
      return this.settings$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  this.settings$1.annotations__Lamf_core_parser_Annotations();
  $m_Lorg_yaml_model_YNode$();
  var str = new $c_Lamf_core_utils_package$AmfStrings().init___T("settings").asOasExtension__T();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(this.settingsEntries$1), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.settingsEntries$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$11 = $as_Lamf_core_emitter_EntryEmitter(arg1);
    var this$2 = new $c_s_Some().init___O(x$11.position__Lamf_core_parser_Position())
  };
  return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasSettingsTypeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.OasSettingsTypeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasSettingsTypeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSettingsTypeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.f$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter.prototype.productPrefix__T = (function() {
  return "OrganizationEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter)) {
    var OrganizationEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter(x$1);
    if ((this.key$1 === OrganizationEmitter$1.key$1)) {
      var x = this.f$1;
      var x$2 = OrganizationEmitter$1.f$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.ordering$1;
      var x$4 = OrganizationEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.f$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var value = this.f$1.value$1;
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var this$4 = this.f$1;
  var fs = $as_Lamf_core_model_domain_AmfObject(this$4.value$1.value$1).fields__Lamf_core_parser_Fields();
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$().Url$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1 = this$5.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("url", f, $m_s_None$())))
  };
  var this$7 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$().Name$1);
  if ((!this$7.isEmpty__Z())) {
    var arg1$1 = this$7.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("name", f$3, $m_s_None$())))
  };
  var this$9 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$().Email$1);
  if ((!this$9.isEmpty__Z())) {
    var arg1$2 = this$9.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("email", f$4, $m_s_None$())))
  };
  var this$11 = this.f$1;
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext($as_Lamf_core_model_domain_DomainElement(this$11.value$1.value$1), this.ordering$1, this.spec$1).emitters__sc_Seq());
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$14 = v.builder$1;
  var array = [key];
  if ((this$14.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$14.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$14, newSize);
  var len$1 = this$14.size0$6;
  var src = this$14.array$6;
  var dest = this$14.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$14.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$14.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter.prototype.init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, f, ordering, spec) {
  this.key$1 = key;
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.OrganizationEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.OrganizationEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.OrganizationEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OrganizationEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.tags$1 = null;
  this.ordering$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter.prototype.productPrefix__T = (function() {
  return "StringArrayTagsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter.prototype.init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, tags, ordering, spec) {
  this.key$1 = key;
  this.tags$1 = tags;
  this.ordering$1 = ordering;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter)) {
    var StringArrayTagsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter(x$1);
    if ((this.key$1 === StringArrayTagsEmitter$1.key$1)) {
      var x = this.tags$1;
      var x$2 = StringArrayTagsEmitter$1.tags$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.ordering$1;
      var x$4 = StringArrayTagsEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.tags$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var jsx$4 = this.tags$1;
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_plugins_domain_webapi_models_Tag(x$1$2);
      var xo = $as_Lamf_core_model_StrField(x$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TagModel$().Name$1)).option$1;
      return xo.toList__sci_List()
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike(jsx$4.flatMap__F1__scg_CanBuildFrom__O(jsx$3, this$2.ReusableCBFInstance$2));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(name$2) {
      var name = $as_T(name$2);
      return new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(name, new $c_Lamf_core_parser_Annotations().init___()), $m_Lorg_yaml_model_YType$().Str$1)
    })
  })(this));
  var this$5 = $m_sc_Seq$();
  var emitters = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2));
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$6 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(emitters), b$1);
  var jsx$5 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$5.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$6.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$11 = v.builder$1;
  var array = [key];
  if ((this$11.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$11.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$11, newSize);
  var len$1 = this$11.size0$6;
  var src = this$11.array$6;
  var dest = this$11.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$11.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$2 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$2 < that) ? x$2 : that);
  while ((i < end)) {
    var jsx$7 = j;
    var index = i;
    xs.set(jsx$7, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$11.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.tags$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var a = $as_Lamf_plugins_domain_webapi_models_Tag(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = a.annotations$1;
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.StringArrayTagsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.StringArrayTagsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.StringArrayTagsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter() {
  $c_O.call(this);
  this.TagEmitter$module$1 = null;
  this.key$1 = null;
  this.tags$1 = null;
  this.ordering$1 = null;
  this.amf$plugins$document$webapi$parser$spec$oas$emitters$TagsEmitter$$spec$f = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter.prototype.productPrefix__T = (function() {
  return "TagsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter.prototype.init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, tags, ordering, spec) {
  this.key$1 = key;
  this.tags$1 = tags;
  this.ordering$1 = ordering;
  this.amf$plugins$document$webapi$parser$spec$oas$emitters$TagsEmitter$$spec$f = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter)) {
    var TagsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter(x$1);
    if ((this.key$1 === TagsEmitter$1.key$1)) {
      var x = this.tags$1;
      var x$2 = TagsEmitter$1.tags$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.ordering$1;
      var x$4 = TagsEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.tags$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var jsx$2 = this.tags$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(t$2) {
      var t = $as_Lamf_plugins_domain_webapi_models_Tag(t$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter().init___Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter__Lamf_plugins_domain_webapi_models_Tag__Lamf_core_emitter_SpecOrdering($this, t, $this.ordering$1)
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var emitters = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$4 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(emitters), b$1);
  var jsx$3 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$3.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$4.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$5 = j;
    var index = i;
    xs.set(jsx$5, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.tags$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var a = $as_Lamf_plugins_domain_webapi_models_Tag(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = a.annotations$1;
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.TagsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.TagsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.TagsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter() {
  $c_O.call(this);
  this.tag$1 = null;
  this.ordering$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter.prototype.productPrefix__T = (function() {
  return "TagEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(p) {
  var jsx$1 = p.builder$1;
  var sourceName = p.sourceName$2;
  var b = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var fs = this.tag$1.fields$1;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_TagModel$().Name$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("name", f, $m_s_None$())))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_TagModel$().Description$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("description", f$3, $m_s_None$())))
  };
  var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_TagModel$().Documentation$1);
  if ((!this$6.isEmpty__Z())) {
    var arg1$2 = this$6.get__O();
    $as_Lamf_core_parser_FieldEntry(arg1$2);
    var this$7 = this.tag$1;
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasEntryCreativeWorkEmitter().init___T__Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("externalDocs", $as_Lamf_plugins_domain_shapes_models_CreativeWork(this$7.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TagModel$().Documentation$1)), this.ordering$1, this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$emitters$TagsEmitter$$spec$f)))
  };
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.tag$1, this.ordering$1, this.$$outer$1.amf$plugins$document$webapi$parser$spec$oas$emitters$TagsEmitter$$spec$f).emitters__sc_Seq());
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var TagEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter(x$1);
    var x = this.tag$1;
    var x$2 = TagEmitter$1.tag$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = TagEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.tag$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter__Lamf_plugins_domain_webapi_models_Tag__Lamf_core_emitter_SpecOrdering = (function($$outer, tag, ordering) {
  this.tag$1 = tag;
  this.ordering$1 = ordering;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.tag$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.TagsEmitter$TagEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.TagsEmitter$TagEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.TagsEmitter$TagEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter$TagEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter() {
  $c_O.call(this);
  this.element$1 = null;
  this.message$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter.prototype.productPrefix__T = (function() {
  return "CommentEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var node = $m_Lorg_yaml_model_YNode$().Empty$1;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer(node);
  b.comment__T__V(this.message$1);
  var this$1 = this.element$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_SourceAST.getClassOf());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$17 = $as_Lamf_core_annotations_SourceAST(arg1);
    var this$2 = new $c_s_Some().init___O(x$17.ast$1)
  };
  if ((!this$2.isEmpty__Z())) {
    var arg1$1 = this$2.get__O();
    var a = $as_Lorg_yaml_model_YPart(arg1$1);
    var this$3 = $m_Lorg_yaml_render_YamlRender$();
    b.comment__T__V(this$3.render__Lorg_yaml_model_YPart__Z__T(a, false))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter)) {
    var CommentEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter(x$1);
    var x = this.element$1;
    var x$2 = CommentEmitter$1.element$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      return (this.message$1 === CommentEmitter$1.message$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.element$1;
      break
    }
    case 1: {
      return this.message$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter.prototype.init___Lamf_core_model_domain_AmfElement__T = (function(element, message) {
  this.element$1 = element;
  this.message$1 = message;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  return $m_Lamf_core_parser_Position$ZERO$()
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.CommentEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.CommentEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.CommentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter() {
  $c_O.call(this);
  this.properties$1 = null;
  this.references$1 = null;
  this.ordering$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter.prototype.productPrefix__T = (function() {
  return "AnnotationsTypesEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var AnnotationsTypesEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter(x$1);
    var x = this.properties$1;
    var x$2 = AnnotationsTypesEmitter$1.properties$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.references$1;
      var x$4 = AnnotationsTypesEmitter$1.references$1;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.ordering$1;
      var x$6 = AnnotationsTypesEmitter$1.ordering$1;
      return (x$5 === x$6)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.properties$1;
      break
    }
    case 1: {
      return this.references$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("annotationTypes");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$5 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var jsx$3 = this.ordering$1;
  var jsx$2 = this.properties$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(p$2) {
      var p = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(p$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter().init___Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters__Lamf_core_model_domain_extensions_CustomDomainProperty__sc_Seq__Lamf_core_emitter_SpecOrdering($this.$$outer$1, p, $this.references$1, $this.ordering$1)
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  jsx$4.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$3.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))), b$1);
  jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$6 = j;
    var index = i;
    xs.set(jsx$6, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters__sc_Seq__sc_Seq__Lamf_core_emitter_SpecOrdering = (function($$outer, properties, references, ordering) {
  this.properties$1 = properties;
  this.references$1 = references;
  this.ordering$1 = ordering;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.properties$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var p = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = p.annotations$1;
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.Raml10RootLevelEmitters$AnnotationsTypesEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.Raml10RootLevelEmitters$AnnotationsTypesEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.Raml10RootLevelEmitters$AnnotationsTypesEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$AnnotationsTypesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter() {
  $c_O.call(this);
  this.annotation$1 = null;
  this.references$1 = null;
  this.ordering$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter.prototype.productPrefix__T = (function() {
  return "NamedPropertyTypeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters__Lamf_core_model_domain_extensions_CustomDomainProperty__sc_Seq__Lamf_core_emitter_SpecOrdering = (function($$outer, annotation, references, ordering) {
  this.annotation$1 = annotation;
  this.references$1 = references;
  this.ordering$1 = ordering;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var NamedPropertyTypeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter(x$1);
    var x = this.annotation$1;
    var x$2 = NamedPropertyTypeEmitter$1.annotation$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.references$1;
      var x$4 = NamedPropertyTypeEmitter$1.references$1;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.ordering$1;
      var x$6 = NamedPropertyTypeEmitter$1.ordering$1;
      return (x$5 === x$6)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.annotation$1;
      break
    }
    case 1: {
      return this.references$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.annotation$1;
  var x1 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Name$1)).option$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var n = $as_T(x2.value$2);
    var name = n
  } else {
    var this$2 = this.$$outer$1;
    var this$3 = this$2.spec$1;
    var this$6 = this$3.eh$1;
    var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
    var node = this.annotation$1.id$1;
    var property = $m_s_None$();
    var message = ("Annotation type without name " + this.annotation$1);
    var this$4 = this.annotation$1;
    var lexical = this$4.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
    var this$5 = this.annotation$1;
    var location = $f_Lamf_core_model_domain_AmfElement__location__s_Option(this$5);
    this$6.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
    var name = "default-name"
  };
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(name);
  var this$8 = this.annotation$1;
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$8).isDefined__Z()) {
    var f = (function($this) {
      return (function(b$2$2) {
        var b$2 = $as_Lorg_yaml_model_YDocument$PartBuilder(b$2$2);
        $this.emitLink__p1__Lorg_yaml_model_YDocument$PartBuilder__V(b$2)
      })
    })(this);
    var vf_$_f$2 = f
  } else {
    var f$1 = (function(this$2$1) {
      return (function(b$3$2) {
        var b$3 = $as_Lorg_yaml_model_YDocument$PartBuilder(b$3$2);
        this$2$1.emitInline__p1__Lorg_yaml_model_YDocument$PartBuilder__V(b$3)
      })
    })(this);
    var vf_$_f$2 = f$1
  };
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  vf_$_f$2(v);
  var this$11 = v.builder$1;
  var array = [key];
  if ((this$11.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$11.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$11, newSize);
  var len$1 = this$11.size0$6;
  var src = this$11.array$6;
  var dest = this$11.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$11.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$1 = j;
    var index = i;
    xs.set(jsx$1, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$11.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter.prototype.emitLink__p1__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var this$1 = this.annotation$1;
  var this$2 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var l = $as_Lamf_core_model_domain_DomainElement(arg1);
    var this$3 = this.$$outer$1;
    var this$4 = this$3.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory();
    var jsx$1 = $f_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory__tagToReferenceEmitter__F3(this$4);
    var this$5 = this.annotation$1;
    $as_Lamf_core_emitter_PartEmitter(jsx$1.apply__O__O__O__O(l, $as_Lamf_core_model_StrField(this$5.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1, this.references$1)).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter.prototype.emitInline__p1__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var this$1 = this.$$outer$1;
  var x1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationTypeEmitter(this$1.spec$1.factory__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory().annotationTypeEmitter__F2().apply__O__O__O(this.annotation$1, this.ordering$1)).emitters__s_util_Either();
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var emitters = $as_sc_Seq(x2.value$2);
    var jsx$1 = b.builder$1;
    var sourceName = b.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(emitters), b$1);
    jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  } else if ((x1 instanceof $c_s_util_Right)) {
    var x3 = $as_s_util_Right(x1);
    var part = $as_Lamf_core_emitter_PartEmitter(x3.value$2);
    part.emit__Lorg_yaml_model_YDocument$PartBuilder__V(b)
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.annotation$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.Raml10RootLevelEmitters$NamedPropertyTypeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.Raml10RootLevelEmitters$NamedPropertyTypeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.Raml10RootLevelEmitters$NamedPropertyTypeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_Raml10RootLevelEmitters$NamedPropertyTypeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.f$1 = null;
  this.ordering$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter__T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering = (function($$outer, key, f, ordering) {
  this.key$1 = key;
  this.f$1 = f;
  this.ordering$1 = ordering;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter.prototype.productPrefix__T = (function() {
  return "LicenseEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var LicenseEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter(x$1);
    if ((this.key$1 === LicenseEmitter$1.key$1)) {
      var x = this.f$1;
      var x$2 = LicenseEmitter$1.f$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.ordering$1;
      var x$4 = LicenseEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.f$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var value = this.f$1.value$1;
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var this$4 = this.f$1;
  var fs = $as_Lamf_core_model_domain_AmfObject(this$4.value$1.value$1).fields__Lamf_core_parser_Fields();
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_LicenseModel$().Url$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1 = this$5.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("url", f, $m_s_None$())))
  };
  var this$7 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_LicenseModel$().Name$1);
  if ((!this$7.isEmpty__Z())) {
    var arg1$1 = this$7.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("name", f$3, $m_s_None$())))
  };
  var this$9 = this.f$1;
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext($as_Lamf_core_model_domain_DomainElement(this$9.value$1.value$1), this.ordering$1, this.$$outer$1.spec$1).emitters__sc_Seq());
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$12 = v.builder$1;
  var array = [key];
  if ((this$12.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$12.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$12, newSize);
  var len$1 = this$12.size0$6;
  var src = this$12.array$6;
  var dest = this$12.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$12.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$12.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlDocumentEmitter$LicenseEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlDocumentEmitter$LicenseEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlDocumentEmitter$LicenseEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$LicenseEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.f$1 = null;
  this.ordering$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter__T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering = (function($$outer, key, f, ordering) {
  this.key$1 = key;
  this.f$1 = f;
  this.ordering$1 = ordering;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter.prototype.productPrefix__T = (function() {
  return "OrganizationEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter) && ($as_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter(x$1).$$outer$1 === this.$$outer$1))) {
    var OrganizationEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter(x$1);
    if ((this.key$1 === OrganizationEmitter$1.key$1)) {
      var x = this.f$1;
      var x$2 = OrganizationEmitter$1.f$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.ordering$1;
      var x$4 = OrganizationEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.f$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var value = this.f$1.value$1;
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var this$4 = this.f$1;
  var fs = $as_Lamf_core_model_domain_AmfObject(this$4.value$1.value$1).fields__Lamf_core_parser_Fields();
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$().Url$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1 = this$5.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("url", f, $m_s_None$())))
  };
  var this$7 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$().Name$1);
  if ((!this$7.isEmpty__Z())) {
    var arg1$1 = this$7.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("name", f$3, $m_s_None$())))
  };
  var this$9 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$().Email$1);
  if ((!this$9.isEmpty__Z())) {
    var arg1$2 = this$9.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("email", f$4, $m_s_None$())))
  };
  var this$11 = this.f$1;
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext($as_Lamf_core_model_domain_DomainElement(this$11.value$1.value$1), this.ordering$1, this.$$outer$1.spec$1).emitters__sc_Seq());
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(result), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$14 = v.builder$1;
  var array = [key];
  if ((this$14.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$14.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$14, newSize);
  var len$1 = this$14.size0$6;
  var src = this$14.array$6;
  var dest = this$14.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$14.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$14.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlDocumentEmitter$OrganizationEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlDocumentEmitter$OrganizationEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlDocumentEmitter$OrganizationEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$OrganizationEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter$$anonfun$defaultOrder$1$1() {
  $c_O.call(this);
  this.$$outer$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter$$anonfun$defaultOrder$1$1.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter$$anonfun$defaultOrder$1$1.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter$$anonfun$defaultOrder$1$1;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter$$anonfun$defaultOrder$1$1() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter$$anonfun$defaultOrder$1$1.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter$$anonfun$defaultOrder$1$1.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter$$anonfun$defaultOrder$1$1.prototype.init___Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter$$anonfun$defaultOrder$1$1.prototype.gteq__O__O__Z = (function(x, y) {
  return $f_s_math_Ordering__gteq__O__O__Z(this, x, y)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter$$anonfun$defaultOrder$1$1.prototype.compare__O__O__I = (function(x, y) {
  return this.compare__Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter__Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter__I($as_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter(x), $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter(y))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter$$anonfun$defaultOrder$1$1.prototype.compare__Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter__Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter__I = (function(x, y) {
  return this.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlDocumentEmitter$WebApiEmitter$$$anonfun$endpoints$1__Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter__Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter__I(x, y)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter$$anonfun$defaultOrder$1$1.prototype.lteq__O__O__Z = (function(x, y) {
  return $f_s_math_Ordering__lteq__O__O__Z(this, x, y)
});
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter$$anonfun$defaultOrder$1$1 = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter$$anonfun$defaultOrder$1$1: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlDocumentEmitter$WebApiEmitter$$anonfun$defaultOrder$1$1", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter$$anonfun$defaultOrder$1$1: 1,
  O: 1,
  s_math_Ordering: 1,
  ju_Comparator: 1,
  s_math_PartialOrdering: 1,
  s_math_Equiv: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter$$anonfun$defaultOrder$1$1.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter$WebApiEmitter$$anonfun$defaultOrder$1$1;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser.call(this);
  this.root$3 = null;
  this.ctx$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser.prototype.parseDocument__Lamf_core_model_document_Document__Lamf_core_model_document_Document = (function(document) {
  var parent = this.root$3.location$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(document, parent));
  var location = this.root$3.location$1;
  var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
  $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, location));
  var this$2 = $as_Lamf_core_parser_SyamlParsedDocument(this.root$3.parsed$1).document$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv));
  var references = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser().init___Lamf_core_model_document_BaseUnit__T__Lorg_yaml_model_YMap__sc_Seq__Lamf_plugins_document_webapi_contexts_WebApiContext(document, "uses", map, this.root$3.references$1, this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext()).parse__T__Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations(this.root$3.location$1);
  this.parseDeclarations__Lamf_core_Root__Lorg_yaml_model_YMap__V(this.root$3, map);
  var this$3 = this.parseWebApi__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_WebApi(map);
  var annotation = new $c_Lamf_core_annotations_SourceVendor().init___Lamf_core_remote_Vendor(this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().vendor__Lamf_core_remote_Vendor());
  var api = $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$3, annotation));
  var field$1 = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
  $as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(document, field$1, api));
  var declarables = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().declarables__sc_Seq();
  if (declarables.nonEmpty__Z()) {
    var field$2 = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
    $as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(document, field$2, declarables))
  };
  var this$4 = references.references$1;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$4)) {
    var references$1 = references.solvedReferences__sc_Seq();
    var field$3 = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
    $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(document, field$3, references$1))
  };
  var this$5 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().futureDeclarations$1;
  $f_Lamf_core_parser_FutureDeclarations__resolve__V(this$5);
  return document
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(root, ctx) {
  this.root$3 = root;
  this.ctx$3 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser.prototype.init___Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser.prototype.obtainTarget__p3__s_Enumeration$Value__sci_List = (function(contextType) {
  var x = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2;
  if (((x === null) ? (contextType === null) : x.equals__O__Z(contextType))) {
    $m_sci_List$();
    var array = [$m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().webapi$1];
    var i = (((-1) + $uI(array.length)) | 0);
    var result = $m_sci_Nil$();
    while ((i >= 0)) {
      var this$4 = result;
      var index = i;
      var x$1 = array[index];
      result = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$4);
      i = (((-1) + i) | 0)
    };
    return result
  } else {
    var x$3 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().OVERLAY$2;
    if (((x$3 === null) ? (contextType === null) : x$3.equals__O__Z(contextType))) {
      $m_sci_List$();
      var array$1 = [$m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().overlay$1];
      var i$1 = (((-1) + $uI(array$1.length)) | 0);
      var result$1 = $m_sci_Nil$();
      while ((i$1 >= 0)) {
        var this$8 = result$1;
        var index$1 = i$1;
        var x$2 = array$1[index$1];
        result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$8);
        i$1 = (((-1) + i$1) | 0)
      };
      return result$1
    } else {
      var x$5 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().EXTENSION$2;
      if (((x$5 === null) ? (contextType === null) : x$5.equals__O__Z(contextType))) {
        $m_sci_List$();
        var array$2 = [$m_Lamf_plugins_document_webapi_vocabulary_VocabularyMappings$().extension$1];
        var i$2 = (((-1) + $uI(array$2.length)) | 0);
        var result$2 = $m_sci_Nil$();
        while ((i$2 >= 0)) {
          var this$12 = result$2;
          var index$2 = i$2;
          var x$4 = array$2[index$2];
          result$2 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$12);
          i$2 = (((-1) + i$2) | 0)
        };
        return result$2
      } else {
        return $m_sci_Nil$()
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser.prototype.parseWebApi__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_WebApi = (function(map) {
  var qual$1 = $m_Lamf_plugins_domain_webapi_models_WebApi$().apply__Lorg_yaml_model_YNode__Lamf_plugins_domain_webapi_models_WebApi($as_Lamf_core_parser_SyamlParsedDocument(this.root$3.parsed$1).document$2.node$2);
  var x$1 = this.root$3.location$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var api = $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
  this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().closedShape__T__Lorg_yaml_model_YMap__T__V(api.id$1, map, "webApi");
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Name$1;
  var iv = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$1.key__T__F1__V("title", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(api).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Description$1;
  var iv$1 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$2.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(api).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$5 = this$4.key__T__s_Option("mediaType");
  if ((!this$5.isEmpty__Z())) {
    var arg1 = this$5.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().globalMediatype$3 = true;
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    var this$6 = entry.value$2;
    var x1 = this$6.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Seq$1;
    if ((x === x1)) {
      var node = entry.value$2;
      var iv$2 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
      var this$8 = new $c_Lamf_core_parser_DefaultArrayNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv$2);
      var value = $f_Lamf_core_parser_BaseArrayNode__text__Lamf_core_model_domain_AmfArray(this$8)
    } else {
      annotations.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SingleValueArray().init___());
      var jsx$3 = $m_sc_Seq$();
      var this$9 = $m_Lamf_plugins_document_webapi_parser_spec_common_RamlScalarNode$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_core_parser_ScalarNode(entry.value$2, this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext());
      var array = [this$9.text__Lamf_core_model_domain_AmfScalar()];
      var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))), new $c_Lamf_core_parser_Annotations().init___())
    };
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().ContentType$1;
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(api, field$2, value, annotations);
    var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Accepts$1;
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(api, field$3, value, annotations)
  };
  var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Version$1;
  var iv$3 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$4.key__T__F1__V("version", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$4, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(api).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var jsx$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var jsx$5 = new $c_Lamf_core_utils_package$AmfStrings().init___T("termsOfService").asRamlAnnotation__T();
  var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().TermsOfService$1;
  var iv$4 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$6.key__T__F1__V(jsx$5, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$5, iv$4).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(api));
  var jsx$7 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$6 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Schemes$1;
  var iv$5 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$7.key__T__F1__V("protocols", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$6, iv$5).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(api).allowingSingleValue__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var jsx$9 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var jsx$8 = new $c_Lamf_core_utils_package$AmfStrings().init___T("contact").asRamlAnnotation__T();
  var field$7 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Provider$1;
  var iv$6 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$9.key__T__F1__V(jsx$8, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$7, iv$6).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(api).using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(node$2) {
      var node$1 = $as_Lorg_yaml_model_YNode(node$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$().parse__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_domain_webapi_models_Organization(node$1, this$2$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext())
    })
  })(this))));
  var jsx$11 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var jsx$10 = new $c_Lamf_core_utils_package$AmfStrings().init___T("license").asRamlAnnotation__T();
  var field$8 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().License$1;
  var iv$7 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$11.key__T__F1__V(jsx$10, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$8, iv$7).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(api).using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(node$3$2) {
      var node$3 = $as_Lorg_yaml_model_YNode(node$3$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$().parse__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_domain_webapi_models_License(node$3, this$3$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext())
    })
  })(this))));
  var this$23 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("tags").asRamlAnnotation__T();
  var this$24 = this$23.key__T__s_Option(keyword);
  if ((!this$24.isEmpty__Z())) {
    var arg1$1 = this$24.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var this$27 = entry$3.value$2;
    var reader = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var this$26 = $m_sc_IndexedSeq$();
    var bf = this$26.ReusableCBF$6;
    var conversion = new $c_Lorg_yaml_convert_YRead$$anon$1().init___scg_CanBuildFrom__Lorg_yaml_convert_YRead(bf, reader);
    var iv$8 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
    var jsx$13 = $as_sc_TraversableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$27, conversion, iv$8));
    var jsx$12 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, api$1) {
      return (function(tag$2) {
        var tag = $as_Lorg_yaml_model_YMap(tag$2);
        return $m_Lamf_plugins_document_webapi_parser_spec_domain_TagsParser$().apply__Lorg_yaml_model_YNode__F1__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_domain_TagsParser(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(tag, $m_Lorg_yaml_model_YType$().Map$1)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, api$1$1) {
          return (function(tag$2$2) {
            var tag$2$1 = $as_Lamf_plugins_domain_webapi_models_Tag(tag$2$2);
            var parent = api$1$1.id$1;
            $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
            return $as_Lamf_plugins_domain_webapi_models_Tag($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(tag$2$1, parent))
          })
        })($this, api$1)), $this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext()).parse__Lamf_plugins_domain_webapi_models_Tag()
      })
    })(this, api));
    var this$30 = $m_sc_Seq$();
    var tags = $as_sc_Seq(jsx$13.map__F1__scg_CanBuildFrom__O(jsx$12, this$30.ReusableCBFInstance$2));
    var field$9 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Tags$1;
    var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(tags, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3.value$2));
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(api, field$9, value$1, annotations$1)
  };
  var this$32 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var entries = this$32.regex__T__sc_Iterable("^/.*");
  if (entries.nonEmpty__Z()) {
    var endpoints = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    entries.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, api$1$2, endpoints$1) {
      return (function(entry$2) {
        var entry$1 = $as_Lorg_yaml_model_YMapEntry(entry$2);
        $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndpointParser($this$2.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().endPointParser__F5().apply__O__O__O__O__O__O(entry$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, api$1$3) {
          return (function(path$2) {
            var path = $as_T(path$2);
            return api$1$3.withEndPoint__T__Lamf_plugins_domain_webapi_models_EndPoint(path)
          })
        })($this$2, api$1$2)), $m_s_None$(), endpoints$1, false)).parse__V()
      })
    })(this, api, endpoints)));
    var field$10 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1;
    var value$2 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(endpoints, new $c_Lamf_core_parser_Annotations().init___());
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(api, field$10, value$2);
    this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().mergeAllOperationContexts__V()
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlServersParser().init___Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_WebApi__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(map, api, this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext()).parse__V();
  var idCounter = new $c_Lamf_core_utils_package$IdCounter().init___();
  var eta$0$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1, api$2) {
    return (function(name$2) {
      var name = $as_T(name$2);
      return api$2.withSecurity__T__Lamf_plugins_domain_webapi_models_security_SecurityRequirement(name)
    })
  })(this, api));
  var RequirementParser = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$7$1, eta$0$1$1, idCounter$1) {
    return (function(node$4$2) {
      var node$4 = $as_Lorg_yaml_model_YNode(node$4$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementParser$().parse__F1__Lamf_core_utils_package$IdCounter__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_domain_webapi_models_security_SecurityRequirement(eta$0$1$1, idCounter$1, node$4, this$7$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext())
    })
  })(this, eta$0$1, idCounter));
  var jsx$14 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$11 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Security$1;
  var iv$9 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$14.key__T__F1__V("securedBy", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$11, iv$9).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(api).using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(RequirementParser).allowingSingleValue__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var this$36 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$37 = this$36.key__T__s_Option("documentation");
  if ((!this$37.isEmpty__Z())) {
    var arg1$2 = this$37.get__O();
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var field$12 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Documentations$1;
    var this$38 = entry$4.value$2;
    var conversion$1 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var iv$10 = this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
    var values = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UserDocumentationsParser().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser__sc_Seq__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__T(this, $as_sc_Seq($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$38, conversion$1, iv$10)), this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations(), api.id$1).parse__sc_Seq();
    var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4);
    $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(api, field$12, values, annotations$2)
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(api, map, this.obtainTarget__p3__s_Enumeration$Value__sci_List(this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().contextType$3), this.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext()).parse__V();
  return api
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter() {
  $c_O.call(this);
  this.reference$1 = null;
  this.aliases$1 = null;
  this.ordering$1 = null;
  this.aliasGenerator$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter.prototype.productPrefix__T = (function() {
  return "ReferenceEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter)) {
    var ReferenceEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter(x$1);
    var x = this.reference$1;
    var x$2 = ReferenceEmitter$1.reference$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.aliases$1;
      var x$4 = ReferenceEmitter$1.aliases$1;
      var jsx$2 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.ordering$1;
      var x$6 = ReferenceEmitter$1.ordering$1;
      var jsx$1 = (x$5 === x$6)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.aliasGenerator$1;
      var x$8 = ReferenceEmitter$1.aliasGenerator$1;
      return (x$7 === x$8)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.reference$1;
      break
    }
    case 1: {
      return this.aliases$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.aliasGenerator$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter.prototype.name__p1__T = (function() {
  var this$1 = this.reference$1;
  var this$2 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$1);
  return $as_T((this$2.isEmpty__Z() ? this.reference$1.id__T() : this$2.get__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.aliases$1;
  var aliasesMap = $as_Lamf_core_annotations_Aliases((this$1.isEmpty__Z() ? new $c_Lamf_core_annotations_Aliases().init___sci_Set($as_sci_Set($m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))) : this$1.get__O())).aliases$1;
  var this$3 = aliasesMap.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var p3 = $as_T2(x0$1.$$und2__O());
        if ((p3 !== null)) {
          var f = $as_T(p3.$$und1__O());
          return (f === this$2.reference$1.id__T())
        }
      };
      throw new $c_s_MatchError().init___O(x0$1)
    })
  })(this)));
  if (this$3.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1 = this$3.get__O();
    var x0$2 = $as_T2(arg1);
    matchEnd5$1: {
      var jsx$1;
      if ((x0$2 !== null)) {
        var a = $as_T(x0$2.$$und1__O());
        var p2 = $as_T2(x0$2.$$und2__O());
        if ((p2 !== null)) {
          var r = $as_T(p2.$$und2__O());
          var jsx$1 = new $c_T2().init___O__O(a, r);
          break matchEnd5$1
        }
      };
      throw new $c_s_MatchError().init___O(x0$2)
    };
    var this$4 = new $c_s_Some().init___O(jsx$1)
  };
  var effectiveAlias = $as_T2((this$4.isEmpty__Z() ? new $c_T2().init___O__O(this.aliasGenerator$1.apply__O(), this.name__p1__T()) : this$4.get__O()));
  new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position($as_T(effectiveAlias.$$und1__O()), $as_T(effectiveAlias.$$und2__O()), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter.prototype.init___Lamf_core_model_document_BaseUnit__s_Option__Lamf_core_emitter_SpecOrdering__F0 = (function(reference, aliases, ordering, aliasGenerator) {
  this.reference$1 = reference;
  this.aliases$1 = aliases;
  this.ordering$1 = ordering;
  this.aliasGenerator$1 = aliasGenerator;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  return $m_Lamf_core_parser_Position$ZERO$()
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.ReferenceEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.ReferenceEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.ReferenceEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter() {
  $c_O.call(this);
  this.baseUnit$1 = null;
  this.ordering$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter.prototype.productPrefix__T = (function() {
  return "ReferencesEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter)) {
    var ReferencesEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter(x$1);
    var x = this.baseUnit$1;
    var x$2 = ReferencesEmitter$1.baseUnit$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = ReferencesEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.baseUnit$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.baseUnit$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_Aliases.getClassOf());
  var aliases = $as_Lamf_core_annotations_Aliases((this$1.isEmpty__Z() ? new $c_Lamf_core_annotations_Aliases().init___sci_Set($as_sci_Set($m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))) : this$1.get__O()));
  var references = this.baseUnit$1.references__sc_Seq();
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter(this);
  var this$2 = $m_sc_Seq$();
  var modules = $as_sc_Seq(references.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  if (modules.nonEmpty__Z()) {
    var elem = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var modulesEmitted = new $c_sr_ObjectRef().init___O(elem);
    var idCounter = new $c_Lamf_core_utils_package$IdCounter().init___();
    var this$12 = aliases.aliases$1;
    var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, modules$1, modulesEmitted$1, idCounter$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_T2(x0$1$2);
        if ((x0$1 !== null)) {
          var alias = $as_T(x0$1.$$und1__O());
          var p2 = $as_T2(x0$1.$$und2__O());
          if ((p2 !== null)) {
            var fullUrl = $as_T(p2.$$und1__O());
            var localUrl = $as_T(p2.$$und2__O());
            var x1$2 = modules$1.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, fullUrl$1) {
              return (function(x$4$2) {
                var x$4 = $as_Lamf_core_model_document_Module(x$4$2);
                return (x$4.id$1 === fullUrl$1)
              })
            })(this$2$1, fullUrl)));
            if ((x1$2 instanceof $c_s_Some)) {
              var x2 = $as_s_Some(x1$2);
              var module = $as_Lamf_core_model_document_Module(x2.value$2);
              var jsx$2 = $as_sci_Map(modulesEmitted$1.elem$1);
              var self = module.id$1;
              modulesEmitted$1.elem$1 = jsx$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(self, module));
              var y = new $c_T2().init___O__O(fullUrl, localUrl);
              var array = [new $c_T2().init___O__O(alias, y)];
              if (($uI(array.length) === 0)) {
                var jsx$3 = $m_sci_Set$EmptySet$()
              } else {
                var b$1 = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
                var i = 0;
                var len = $uI(array.length);
                while ((i < len)) {
                  var index = i;
                  var arg1 = array[index];
                  b$1.$$plus$eq__O__scm_SetBuilder(arg1);
                  i = ((1 + i) | 0)
                };
                var jsx$3 = b$1.elems$1
              };
              return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter().init___Lamf_core_model_document_BaseUnit__s_Option__Lamf_core_emitter_SpecOrdering__F0(module, new $c_s_Some().init___O(new $c_Lamf_core_annotations_Aliases().init___sci_Set($as_sci_Set(jsx$3))), this$2$1.ordering$1, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$2$2, idCounter$1$1) {
                return (function() {
                  return idCounter$1$1.genId__T__T("uses")
                })
              })(this$2$1, idCounter$1))))
            } else {
              return $m_s_None$()
            }
          }
        };
        throw new $c_s_MatchError().init___O(x0$1)
      })
    })(this, modules, modulesEmitted, idCounter));
    var this$11 = $m_sci_Set$();
    var bf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$11);
    var aliasesEmitters = $as_sc_SetLike($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$12, f, bf)).toSeq__sc_Seq();
    var jsx$5 = $as_sc_TraversableLike(modules.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, modulesEmitted$2) {
      return (function(m$2) {
        var m = $as_Lamf_core_model_document_Module(m$2);
        return $as_sci_Map(modulesEmitted$2.elem$1).get__O__s_Option(m.id$1).isEmpty__Z()
      })
    })(this, modulesEmitted))));
    var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, idCounter$2) {
      return (function(module$2) {
        var module$1 = $as_Lamf_core_model_document_Module(module$2);
        return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferenceEmitter().init___Lamf_core_model_document_BaseUnit__s_Option__Lamf_core_emitter_SpecOrdering__F0(module$1, new $c_s_Some().init___O(new $c_Lamf_core_annotations_Aliases().init___sci_Set($as_sci_Set($m_s_Predef$().Set$2.apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())))), this$4$1.ordering$1, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this$1, idCounter$1$2) {
          return (function() {
            return idCounter$1$2.genId__T__T("uses")
          })
        })(this$4$1, idCounter$2))))
      })
    })(this, idCounter));
    var this$13 = $m_sc_Seq$();
    var missingModuleEmitters = $as_sc_Seq(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$4, this$13.ReusableCBFInstance$2));
    var this$14 = $m_sc_Seq$();
    var jsx$7 = $as_sc_TraversableLike(aliasesEmitters.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(missingModuleEmitters, this$14.ReusableCBFInstance$2));
    var jsx$6 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter$$anonfun$2().init___Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter(this);
    var this$15 = $m_sc_Seq$();
    var finalEmitters = $as_sc_Seq(jsx$7.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$6, this$15.ReusableCBFInstance$2));
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("uses");
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$8 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(finalEmitters), b$2);
    jsx$8.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
    var this$20 = v.builder$1;
    var array$1 = [key];
    if ((this$20.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$1 = $uI(array$1.length);
    var newSize = ((this$20.size0$6 + len$1) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$20, newSize);
    var len$2 = this$20.size0$6;
    var src = this$20.array$6;
    var dest = this$20.array$6;
    $systemArraycopy(src, 0, dest, len$1, len$2);
    var xs = this$20.array$6;
    var len$3 = xs.u.length;
    var i$1 = 0;
    var j = 0;
    var x = $uI(array$1.length);
    var x$1 = ((x < len$3) ? x : len$3);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i$1 < end)) {
      var jsx$9 = j;
      var index$1 = i$1;
      xs.set(jsx$9, array$1[index$1]);
      i$1 = ((1 + i$1) | 0);
      j = ((1 + j) | 0)
    };
    this$20.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_core_emitter_SpecOrdering = (function(baseUnit, ordering) {
  this.baseUnit$1 = baseUnit;
  this.ordering$1 = ordering;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  return $m_Lamf_core_parser_Position$ZERO$()
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.ReferencesEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.ReferencesEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.ReferencesEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_ReferencesEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter() {
  $c_O.call(this);
  this.f$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter.prototype.productPrefix__T = (function() {
  return "UserDocumentationsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter)) {
    var UserDocumentationsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter(x$1);
    var x = this.f$1;
    var x$2 = UserDocumentationsEmitter$1.f$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = UserDocumentationsEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.f$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("documentation");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$5 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  var this$3 = this.f$1;
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(this$3.value$1.value$1).values$1;
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter$$anonfun$$nestedInanonfun$emit$31$1().init___Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter(this);
  var this$4 = $m_sc_Seq$();
  $as_sc_IterableLike(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$2) {
    return (function(c$2) {
      var c = $as_Lamf_plugins_domain_shapes_models_CreativeWork(c$2);
      if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(c).isDefined__Z()) {
        var jsx$3 = $m_Lamf_core_emitter_BaseEmitters_package$();
        var this$5 = $as_Lamf_core_model_StrField(c.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1;
        jsx$3.raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(b$2, $as_T((this$5.isEmpty__Z() ? $as_Lamf_core_model_domain_AmfObject($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(c).get__O()).id__T() : this$5.get__O())), $m_Lorg_yaml_model_YType$().Str$1)
      } else {
        new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCreativeWorkEmitter().init___Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_core_emitter_SpecOrdering__Z__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(c, $this.ordering$1, true, $this.spec$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$2)
      }
    })
  })(this, b$1)));
  var jsx$4 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$4.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$5.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$10 = v.builder$1;
  var array = [key];
  if ((this$10.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$10.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$10, newSize);
  var len$1 = this$10.size0$6;
  var src = this$10.array$6;
  var dest = this$10.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$10.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$6 = j;
    var index = i;
    xs.set(jsx$6, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$10.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(f, ordering, spec) {
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.f$1;
  var this$2 = $as_Lamf_core_model_domain_AmfArray(this$1.value$1.value$1).values$1.headOption__s_Option();
  if (this$2.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var x$15 = $as_Lamf_core_model_domain_AmfElement(arg1);
    var this$3 = new $c_s_Some().init___O(x$15.annotations__Lamf_core_parser_Annotations())
  };
  if (this$3.isEmpty__Z()) {
    var this$5 = $m_s_None$()
  } else {
    var arg1$1 = this$3.get__O();
    var annotations = $as_Lamf_core_parser_Annotations(arg1$1);
    var this$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var this$5 = new $c_s_Some().init___O(this$4.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$5.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$5.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.UserDocumentationsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.UserDocumentationsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.UserDocumentationsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_UserDocumentationsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.f$1 = null;
  this.ordering$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter.prototype.productPrefix__T = (function() {
  return "RamlOAuth2ScopeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter)) {
    var RamlOAuth2ScopeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter(x$1);
    if ((this.key$1 === RamlOAuth2ScopeEmitter$1.key$1)) {
      var x = this.f$1;
      var x$2 = RamlOAuth2ScopeEmitter$1.f$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.ordering$1;
      var x$4 = RamlOAuth2ScopeEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.f$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.f$1;
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(this$1.value$1.value$1).values$1;
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter(this);
  var this$2 = $m_sc_Seq$();
  var namesEmitters = $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$4 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(namesEmitters), b$1);
  var jsx$3 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$3.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$4.$$plus$eq__O__scm_ArrayBuffer(node);
  var this$8 = v.builder$1;
  var array = [key];
  if ((this$8.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$8.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$8, newSize);
  var len$1 = this$8.size0$6;
  var src = this$8.array$6;
  var dest = this$8.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$8.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$5 = j;
    var index = i;
    xs.set(jsx$5, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$8.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter.prototype.init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering = (function(key, f, ordering) {
  this.key$1 = key;
  this.f$1 = f;
  this.ordering$1 = ordering;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.emitters.RamlOAuth2ScopeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.emitters.RamlOAuth2ScopeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.emitters.RamlOAuth2ScopeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlOAuth2ScopeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters() {
  $c_O.call(this);
  this.securitySchemes$1 = null;
  this.references$1 = null;
  this.ordering$1 = null;
  this.namedSecurityEmitter$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters.prototype.init___sc_Seq__sc_Seq__Lamf_core_emitter_SpecOrdering__F3__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(securitySchemes, references, ordering, namedSecurityEmitter, spec) {
  this.securitySchemes$1 = securitySchemes;
  this.references$1 = references;
  this.ordering$1 = ordering;
  this.namedSecurityEmitter$1 = namedSecurityEmitter;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters.prototype.productPrefix__T = (function() {
  return "RamlSecuritySchemesEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters)) {
    var RamlSecuritySchemesEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters(x$1);
    var x = this.securitySchemes$1;
    var x$2 = RamlSecuritySchemesEmitters$1.securitySchemes$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.references$1;
      var x$4 = RamlSecuritySchemesEmitters$1.references$1;
      var jsx$2 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.ordering$1;
      var x$6 = RamlSecuritySchemesEmitters$1.ordering$1;
      var jsx$1 = (x$5 === x$6)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.namedSecurityEmitter$1;
      var x$8 = RamlSecuritySchemesEmitters$1.namedSecurityEmitter$1;
      return (x$7 === x$8)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.securitySchemes$1;
      break
    }
    case 1: {
      return this.references$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.namedSecurityEmitter$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("securitySchemes");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$5 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var jsx$3 = this.ordering$1;
  var jsx$2 = this.securitySchemes$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(s$2) {
      var s = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(s$2);
      return $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter($this.namedSecurityEmitter$1.apply__O__O__O__O(s, $this.references$1, $this.ordering$1))
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  jsx$4.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$3.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2))), b$1);
  jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$6 = v.builder$1;
  var array = [key];
  if ((this$6.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$6.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
  var len$1 = this$6.size0$6;
  var src = this$6.array$6;
  var dest = this$6.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$6.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$6 = j;
    var index = i;
    xs.set(jsx$6, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$6.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.securitySchemes$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var a = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(arg1);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = a.annotations$1;
    var this$3 = new $c_s_Some().init___O(this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf()))
  };
  return $as_Lamf_core_parser_Position((this$3.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$3.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.emitters.RamlSecuritySchemesEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.emitters.RamlSecuritySchemesEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.emitters.RamlSecuritySchemesEmitters", {
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySchemesEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter() {
  $c_O.call(this);
  this.f$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter.prototype.productPrefix__T = (function() {
  return "RamlSecuritySettingsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(f, ordering, spec) {
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter)) {
    var RamlSecuritySettingsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter(x$1);
    var x = this.f$1;
    var x$2 = RamlSecuritySettingsEmitter$1.f$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlSecuritySettingsEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.f$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("settings");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$1 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(new $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.f$1, this.ordering$1, this.spec$1).emitters__sc_Seq()), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$5 = v.builder$1;
  var array = [key];
  if ((this$5.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$5.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$5, newSize);
  var len$1 = this$5.size0$6;
  var src = this$5.array$6;
  var dest = this$5.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$5.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$5.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.emitters.RamlSecuritySettingsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.emitters.RamlSecuritySettingsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.emitters.RamlSecuritySettingsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor() {
  $c_O.call(this);
  this.profileName$1 = null
}
$c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor.prototype = $c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor.prototype;
$c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor.prototype.productPrefix__T = (function() {
  return "JsReportValidationProcessor"
});
$c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor)) {
    var JsReportValidationProcessor$1 = $as_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor(x$1);
    var x = this.profileName$1;
    var x$2 = JsReportValidationProcessor$1.profileName$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.profileName$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor.prototype.processException__jl_Throwable__s_Option__O = (function(r, element) {
  return this.processException__jl_Throwable__s_Option__Lamf_core_validation_AMFValidationReport(r, element)
});
$c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor.prototype.processException__jl_Throwable__s_Option__Lamf_core_validation_AMFValidationReport = (function(r, element) {
  if ((r instanceof $c_sjs_js_JavaScriptException)) {
    var x2 = $as_sjs_js_JavaScriptException(r);
    var jsx$1 = $m_sc_Seq$();
    var message = ("Internal error during validation " + $objectToString(x2.exception$4));
    var level = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
    if (element.isEmpty__Z()) {
      var this$1 = $m_s_None$()
    } else {
      var arg1 = element.get__O();
      var x$6 = $as_Lamf_core_model_domain_DomainElement(arg1);
      var this$1 = new $c_s_Some().init___O(x$6.id__T())
    };
    var targetNode = $as_T((this$1.isEmpty__Z() ? "" : this$1.get__O()));
    if (element.isEmpty__Z()) {
      var targetProperty = $m_s_None$()
    } else {
      var arg1$1 = element.get__O();
      var x$7 = $as_Lamf_core_model_domain_DomainElement(arg1$1);
      var targetProperty = new $c_s_Some().init___O(x$7.id__T())
    };
    var validationId = $m_Lamf_validations_PayloadValidations$().ExampleValidationErrorSpecification$1.id$1;
    if (element.isEmpty__Z()) {
      var position = $m_s_None$()
    } else {
      var arg1$2 = element.get__O();
      var x$8 = $as_Lamf_core_model_domain_DomainElement(arg1$2);
      var position = x$8.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf())
    };
    if (element.isEmpty__Z()) {
      var location = $m_s_None$()
    } else {
      var arg1$3 = element.get__O();
      var x$9 = $as_Lamf_core_model_domain_DomainElement(arg1$3);
      var location = x$9.location__s_Option()
    };
    var array = [new $c_Lamf_core_validation_AMFValidationResult().init___T__T__T__s_Option__T__s_Option__s_Option__O(message, level, targetNode, targetProperty, validationId, position, location, x2)];
    var results = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  } else {
    var results = $f_Lamf_plugins_document_webapi_validation_remote_ReportValidationProcessor__processCommonException__jl_Throwable__s_Option__sc_Seq(this, r, element)
  };
  return $f_Lamf_plugins_document_webapi_validation_remote_ReportValidationProcessor__processResults__sc_Seq__Lamf_core_validation_AMFValidationReport(this, results)
});
$c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor.prototype.init___Lamf_ProfileName = (function(profileName) {
  this.profileName$1 = profileName;
  return this
});
$c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor.prototype.processResults__sc_Seq__O = (function(r) {
  return $f_Lamf_plugins_document_webapi_validation_remote_ReportValidationProcessor__processResults__sc_Seq__Lamf_core_validation_AMFValidationReport(this, r)
});
function $as_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.remote.JsReportValidationProcessor"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.remote.JsReportValidationProcessor;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor: 0
}, false, "amf.plugins.document.webapi.validation.remote.JsReportValidationProcessor", {
  Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_remote_ReportValidationProcessor: 1,
  Lamf_plugins_document_webapi_validation_remote_ValidationProcessor: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_remote_JsReportValidationProcessor;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep() {
  $c_O.call(this);
  this.validationContext$1 = null;
  this.executionContext$1 = null
}
$c_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep.prototype = $c_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep.prototype;
$c_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep.prototype.productPrefix__T = (function() {
  return "ExamplesValidationStep"
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep.prototype.buildValidationWithCustomLevelForProfile__p1__Lamf_core_validation_AMFValidationResult__s_Option = (function(result) {
  var id = result.validationId$1;
  var validations = this.validationContext$1.validations$1;
  var x$1 = $f_Lamf_core_validation_ValidationResultProcessor__findLevel__T__Lamf_core_validation_EffectiveValidations__T__T(this, id, validations, "");
  var x$2 = result.message$1;
  var x$3 = result.targetNode$1;
  var x$4 = result.targetProperty$1;
  var x$5 = result.validationId$1;
  var x$6 = result.position$1;
  var x$7 = result.location$1;
  var x$8 = result.source$1;
  return new $c_s_Some().init___O(new $c_Lamf_core_validation_AMFValidationResult().init___T__T__T__s_Option__T__s_Option__s_Option__O(x$2, x$1, x$3, x$4, x$5, x$6, x$7, x$8))
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep.prototype.init___Lamf_plugins_document_webapi_validation_runner_ValidationContext__s_concurrent_ExecutionContext = (function(validationContext, executionContext) {
  this.validationContext$1 = validationContext;
  this.executionContext$1 = executionContext;
  return this
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep.prototype.validate__s_concurrent_Future = (function() {
  return new $c_Lamf_plugins_document_webapi_validation_UnitPayloadsValidation().init___Lamf_core_model_document_BaseUnit__Lamf_core_remote_Platform(this.validationContext$1.baseUnit$1, this.validationContext$1.platform$1).validate__Lamf_internal_environment_Environment__s_concurrent_ExecutionContext__s_concurrent_Future(this.validationContext$1.env$1, this.executionContext$1).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(results$2) {
      var results = $as_sc_Seq(results$2);
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
        return (function(result$2) {
          var result = $as_Lamf_core_validation_AMFValidationResult(result$2);
          var xo = $this$1.buildValidationWithCustomLevelForProfile__p1__Lamf_core_validation_AMFValidationResult__s_Option(result);
          return xo.toList__sci_List()
        })
      })($this));
      var this$2 = $m_sc_Seq$();
      return $as_sc_Seq(results.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2))
    })
  })(this)), this.executionContext$1)
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep.prototype.endStep__Z = (function() {
  return true
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep)) {
    var ExamplesValidationStep$1 = $as_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep(x$1);
    var x = this.validationContext$1;
    var x$2 = ExamplesValidationStep$1.validationContext$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.validationContext$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runner.steps.ExamplesValidationStep"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runner.steps.ExamplesValidationStep;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep: 0
}, false, "amf.plugins.document.webapi.validation.runner.steps.ExamplesValidationStep", {
  Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runner_steps_ValidationStep: 1,
  Lamf_core_validation_ValidationResultProcessor: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runner_steps_ExamplesValidationStep;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep() {
  $c_O.call(this);
  this.validationContext$1 = null;
  this.executionContext$1 = null
}
$c_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep.prototype = $c_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep.prototype;
$c_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep.prototype.productPrefix__T = (function() {
  return "ModelValidationStep"
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep.prototype.init___Lamf_plugins_document_webapi_validation_runner_ValidationContext__s_concurrent_ExecutionContext = (function(validationContext, executionContext) {
  this.validationContext$1 = validationContext;
  this.executionContext$1 = executionContext;
  return this
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep.prototype.validate__s_concurrent_Future = (function() {
  var baseOptions = new $c_Lamf_plugins_document_webapi_validation_runner_FilterDataNodeOptions().init___().withMessageStyle__Lamf_MessageStyle__Lamf_core_services_ValidationOptions(this.validationContext$1.messageStyle$1);
  var x1 = this.validationContext$1.profile$1;
  var x = $m_Lamf_RamlProfile$();
  if (x.equals__O__Z(x1)) {
    var jsx$1 = true
  } else {
    var x$3 = $m_Lamf_Raml10Profile$();
    if (x$3.equals__O__Z(x1)) {
      var jsx$1 = true
    } else {
      var x$5 = $m_Lamf_Raml08Profile$();
      if (x$5.equals__O__Z(x1)) {
        var jsx$1 = true
      } else {
        var x$7 = $m_Lamf_OasProfile$();
        if (x$7.equals__O__Z(x1)) {
          var jsx$1 = true
        } else {
          var x$9 = $m_Lamf_Oas20Profile$();
          if (x$9.equals__O__Z(x1)) {
            var jsx$1 = true
          } else {
            var x$11 = $m_Lamf_Oas30Profile$();
            if (x$11.equals__O__Z(x1)) {
              var jsx$1 = true
            } else {
              var x$13 = $m_Lamf_AsyncProfile$();
              if (x$13.equals__O__Z(x1)) {
                var jsx$1 = true
              } else {
                var x$15 = $m_Lamf_Async20Profile$();
                if (x$15.equals__O__Z(x1)) {
                  var jsx$1 = true
                } else {
                  var x$17 = $m_Lamf_AmfProfile$();
                  var jsx$1 = x$17.equals__O__Z(x1)
                }
              }
            }
          }
        }
      }
    }
  };
  if (jsx$1) {
    var options = baseOptions.withPartialValidation__Lamf_core_services_ValidationOptions()
  } else {
    var options = baseOptions.withFullValidation__Lamf_core_services_ValidationOptions()
  };
  $m_Lamf_core_benchmark_ExecutionLog$().log__T__Lamf_core_benchmark_ExecutionLog$("WebApiValidations#validationRequestsForBaseUnit: validating now WebAPI");
  var this$1 = $m_Lamf_core_services_RuntimeValidator$();
  var model = this.validationContext$1.baseUnit$1;
  var validations = this.validationContext$1.validations$1;
  var customFunctions = $m_Lamf_validations_CustomShaclFunctions$().functions$1;
  var executionContext = this.executionContext$1;
  return this$1.validator__p1__Lamf_core_services_RuntimeValidator().shaclValidation__Lamf_core_model_document_BaseUnit__Lamf_core_validation_EffectiveValidations__sci_Map__Lamf_core_services_ValidationOptions__s_concurrent_ExecutionContext__s_concurrent_Future(model, validations, customFunctions, options, executionContext).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(report$2) {
      var report = $as_Lamf_core_validation_core_ValidationReport(report$2);
      var this$4 = report.results__sci_List();
      var f = (function($this$1) {
        return (function(r$2) {
          var r = $as_Lamf_core_validation_core_ValidationResult(r$2);
          var xo = $this$1.buildValidationResult__p1__Lamf_core_validation_core_ValidationResult__s_Option(r);
          return xo.toList__sci_List()
        })
      })($this);
      var this$3 = $m_sci_List$();
      var bf = this$3.ReusableCBFInstance$2;
      if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
        if ((this$4 === $m_sci_Nil$())) {
          var jsx$2 = $m_sci_Nil$()
        } else {
          var rest = this$4;
          var found = new $c_sr_BooleanRef().init___Z(false);
          var h = new $c_sr_ObjectRef().init___O(null);
          var t = new $c_sr_ObjectRef().init___O(null);
          while ((rest !== $m_sci_Nil$())) {
            var arg1 = rest.head__O();
            $as_sc_GenTraversableOnce(f(arg1)).seq__sc_TraversableOnce().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, found$1, h$1, t$1) {
              return (function(b$2) {
                if ((!found$1.elem$1)) {
                  h$1.elem$1 = new $c_sci_$colon$colon().init___O__sci_List(b$2, $m_sci_Nil$());
                  t$1.elem$1 = $as_sci_$colon$colon(h$1.elem$1);
                  found$1.elem$1 = true
                } else {
                  var nx = new $c_sci_$colon$colon().init___O__sci_List(b$2, $m_sci_Nil$());
                  $as_sci_$colon$colon(t$1.elem$1).tl$5 = nx;
                  t$1.elem$1 = nx
                }
              })
            })(this$4, found, h, t)));
            rest = $as_sci_List(rest.tail__O())
          };
          var jsx$2 = ((!found.elem$1) ? $m_sci_Nil$() : $as_sci_$colon$colon(h.elem$1))
        }
      } else {
        $m_sci_List$();
        var b = new $c_scm_ListBuffer().init___();
        var these = this$4;
        while ((!these.isEmpty__Z())) {
          var arg1$1 = these.head__O();
          var xs = $as_sc_GenTraversableOnce(f(arg1$1)).seq__sc_TraversableOnce();
          b.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(xs);
          these = $as_sci_List(these.tail__O())
        };
        var jsx$2 = b.toList__sci_List()
      };
      return $as_sc_Seq(jsx$2)
    })
  })(this)), this.executionContext$1)
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep.prototype.endStep__Z = (function() {
  return true
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep)) {
    var ModelValidationStep$1 = $as_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep(x$1);
    var x = this.validationContext$1;
    var x$2 = ModelValidationStep$1.validationContext$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.validationContext$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep.prototype.buildValidationResult__p1__Lamf_core_validation_core_ValidationResult__s_Option = (function(r) {
  var model = this.validationContext$1.baseUnit$1;
  var messageStyle = this.validationContext$1.messageStyle$1;
  var validations = this.validationContext$1.validations$1;
  return $f_Lamf_core_validation_ValidationResultProcessor__buildValidationResult__Lamf_core_model_document_BaseUnit__Lamf_core_validation_core_ValidationResult__Lamf_MessageStyle__Lamf_core_validation_EffectiveValidations__s_Option(this, model, r, messageStyle, validations)
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runner.steps.ModelValidationStep"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runner.steps.ModelValidationStep;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep: 0
}, false, "amf.plugins.document.webapi.validation.runner.steps.ModelValidationStep", {
  Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runner_steps_ValidationStep: 1,
  Lamf_core_validation_ValidationResultProcessor: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runner_steps_ModelValidationStep;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep() {
  $c_O.call(this);
  this.validationContext$1 = null
}
$c_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep.prototype = $c_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep.prototype;
$c_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep.prototype.productPrefix__T = (function() {
  return "ParserValidationStep"
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep.prototype.validate__s_concurrent_Future = (function() {
  var jsx$1 = $m_s_concurrent_Future$();
  var this$1 = this.validationContext$1.baseUnit$1;
  var this$2 = this$1.amf$core$model$document$BaseUnit$$run__s_Option();
  if (this$2.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var parserRun = $uI(arg1);
    var this$3 = new $c_s_Some().init___O($m_Lamf_core_errorhandling_StaticErrorCollector$().getRun__I__sc_Seq(parserRun))
  };
  return jsx$1.successful__O__s_concurrent_Future((this$3.isEmpty__Z() ? $m_sci_Nil$() : this$3.get__O()))
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep)) {
    var ParserValidationStep$1 = $as_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep(x$1);
    var x = this.validationContext$1;
    var x$2 = ParserValidationStep$1.validationContext$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep.prototype.endStep__Z = (function() {
  return true
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.validationContext$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep.prototype.init___Lamf_plugins_document_webapi_validation_runner_ValidationContext = (function(validationContext) {
  this.validationContext$1 = validationContext;
  return this
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runner.steps.ParserValidationStep"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runner.steps.ParserValidationStep;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep: 0
}, false, "amf.plugins.document.webapi.validation.runner.steps.ParserValidationStep", {
  Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runner_steps_ValidationStep: 1,
  Lamf_core_validation_ValidationResultProcessor: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runner_steps_ParserValidationStep;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser() {
  $c_O.call(this);
  this.value$1 = null;
  this.rx$1 = null;
  this.followedBy$1 = null;
  this.completeStack$1 = null;
  this.extraValue$1 = null;
  this.possibleApplications$1 = null;
  this.next$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype.productPrefix__T = (function() {
  return "AsyncAPIRuntimeExpressionParser"
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser)) {
    var AsyncAPIRuntimeExpressionParser$1 = $as_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser(x$1);
    return (this.value$1 === AsyncAPIRuntimeExpressionParser$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype.nodeIsValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__nodeIsValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype.next__s_Option = (function() {
  return (((((8 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.next$lzycompute__p1__s_Option() : this.next$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype.completelyValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__completelyValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype.rx__s_util_matching_Regex = (function() {
  return this.rx$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype.extraValue__T = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.extraValue$lzycompute__p1__T() : this.extraValue$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype.extraValue$lzycompute__p1__T = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.extraValue$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__extraValue__T(this);
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.extraValue$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype.init___T = (function(value) {
  this.value$1 = value;
  var this$2 = new $c_sci_StringOps().init___T("");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.rx$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken$()];
  this.followedBy$1 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype.followedBy__sc_Seq = (function() {
  return this.followedBy$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype.next$lzycompute__p1__s_Option = (function() {
  if (((((8 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.next$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__next__s_Option(this);
    this.bitmap$0$1 = (((8 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.next$1
});
function $as_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runtimeexpression.AsyncAPIRuntimeExpressionParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runtimeexpression.AsyncAPIRuntimeExpressionParser;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.AsyncAPIRuntimeExpressionParser", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeExpressionParser: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_AsyncAPIRuntimeExpressionParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken() {
  $c_O.call(this);
  this.value$1 = null;
  this.label$1 = null;
  this.rx$1 = null;
  this.followedBy$1 = null;
  this.extraValue$1 = null;
  this.possibleApplications$1 = null;
  this.next$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype.productPrefix__T = (function() {
  return "BodyNoFragmentCodeBaseExpressionToken"
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken)) {
    var BodyNoFragmentCodeBaseExpressionToken$1 = $as_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken(x$1);
    return (this.value$1 === BodyNoFragmentCodeBaseExpressionToken$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype.nodeIsValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__nodeIsValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype.next__s_Option = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.next$lzycompute__p1__s_Option() : this.next$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype.completelyValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__completelyValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype.rx__s_util_matching_Regex = (function() {
  return this.rx$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype.extraValue__T = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.extraValue$lzycompute__p1__T() : this.extraValue$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype.extraValue$lzycompute__p1__T = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.extraValue$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__extraValue__T(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.extraValue$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype.init___T = (function(value) {
  this.value$1 = value;
  this.label$1 = "body";
  var this$2 = new $c_sci_StringOps().init___T("(body)");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.rx$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  this.followedBy$1 = $m_sci_Nil$();
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype.followedBy__sc_Seq = (function() {
  return this.followedBy$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype.next$lzycompute__p1__s_Option = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.next$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__next__s_Option(this);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.next$1
});
function $as_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runtimeexpression.BodyNoFragmentCodeBaseExpressionToken"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runtimeexpression.BodyNoFragmentCodeBaseExpressionToken;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.BodyNoFragmentCodeBaseExpressionToken", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_LabeledExpressionToken: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyNoFragmentCodeBaseExpressionToken;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken() {
  $c_O.call(this);
  this.value$1 = null;
  this.label$1 = null;
  this.rx$1 = null;
  this.followedBy$1 = null;
  this.extraValue$1 = null;
  this.possibleApplications$1 = null;
  this.next$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype.productPrefix__T = (function() {
  return "BodyWithFragmentCodeBaseExpressionToken"
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken)) {
    var BodyWithFragmentCodeBaseExpressionToken$1 = $as_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken(x$1);
    return (this.value$1 === BodyWithFragmentCodeBaseExpressionToken$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype.nodeIsValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__nodeIsValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype.next__s_Option = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.next$lzycompute__p1__s_Option() : this.next$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype.completelyValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__completelyValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype.rx__s_util_matching_Regex = (function() {
  return this.rx$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype.extraValue__T = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.extraValue$lzycompute__p1__T() : this.extraValue$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype.extraValue$lzycompute__p1__T = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.extraValue$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__extraValue__T(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.extraValue$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype.init___T = (function(value) {
  this.value$1 = value;
  this.label$1 = "body#";
  var this$2 = new $c_sci_StringOps().init___T("(body#).*");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.rx$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$()];
  this.followedBy$1 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype.followedBy__sc_Seq = (function() {
  return this.followedBy$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype.next$lzycompute__p1__s_Option = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.next$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__next__s_Option(this);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.next$1
});
function $as_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runtimeexpression.BodyWithFragmentCodeBaseExpressionToken"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runtimeexpression.BodyWithFragmentCodeBaseExpressionToken;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.BodyWithFragmentCodeBaseExpressionToken", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_LabeledExpressionToken: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_BodyWithFragmentCodeBaseExpressionToken;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken() {
  $c_O.call(this);
  this.value$1 = null;
  this.rx$1 = null;
  this.label$1 = null;
  this.followedBy$1 = null;
  this.extraValue$1 = null;
  this.possibleApplications$1 = null;
  this.next$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype.productPrefix__T = (function() {
  return "HeaderCodeBaseExpressionToken"
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken)) {
    var HeaderCodeBaseExpressionToken$1 = $as_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken(x$1);
    return (this.value$1 === HeaderCodeBaseExpressionToken$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype.nodeIsValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__nodeIsValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype.next__s_Option = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.next$lzycompute__p1__s_Option() : this.next$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype.completelyValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__completelyValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype.rx__s_util_matching_Regex = (function() {
  return this.rx$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype.extraValue__T = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.extraValue$lzycompute__p1__T() : this.extraValue$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype.extraValue$lzycompute__p1__T = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.extraValue$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__extraValue__T(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.extraValue$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype.init___T = (function(value) {
  this.value$1 = value;
  var this$2 = new $c_sci_StringOps().init___T("(header\\.).*");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.rx$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  this.label$1 = "header.";
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_document_webapi_validation_runtimeexpression_TokenExpressionToken$()];
  this.followedBy$1 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype.followedBy__sc_Seq = (function() {
  return this.followedBy$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype.next$lzycompute__p1__s_Option = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.next$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__next__s_Option(this);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.next$1
});
function $as_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runtimeexpression.HeaderCodeBaseExpressionToken"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runtimeexpression.HeaderCodeBaseExpressionToken;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.HeaderCodeBaseExpressionToken", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_LabeledExpressionToken: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderCodeBaseExpressionToken;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken() {
  $c_O.call(this);
  this.value$1 = null;
  this.label$1 = null;
  this.rx$1 = null;
  this.followedBy$1 = null;
  this.extraValue$1 = null;
  this.possibleApplications$1 = null;
  this.next$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype.productPrefix__T = (function() {
  return "HeaderExpressionToken"
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken)) {
    var HeaderExpressionToken$1 = $as_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken(x$1);
    return (this.value$1 === HeaderExpressionToken$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype.nodeIsValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__nodeIsValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype.next__s_Option = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.next$lzycompute__p1__s_Option() : this.next$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype.completelyValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__completelyValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype.rx__s_util_matching_Regex = (function() {
  return this.rx$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype.extraValue__T = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.extraValue$lzycompute__p1__T() : this.extraValue$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype.extraValue$lzycompute__p1__T = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.extraValue$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__extraValue__T(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.extraValue$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype.init___T = (function(value) {
  this.value$1 = value;
  this.label$1 = "header#";
  var this$2 = new $c_sci_StringOps().init___T("(header#).*");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.rx$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$()];
  this.followedBy$1 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype.followedBy__sc_Seq = (function() {
  return this.followedBy$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype.next$lzycompute__p1__s_Option = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.next$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__next__s_Option(this);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.next$1
});
function $as_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runtimeexpression.HeaderExpressionToken"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runtimeexpression.HeaderExpressionToken;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.HeaderExpressionToken", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_LabeledExpressionToken: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken() {
  $c_O.call(this);
  this.value$1 = null;
  this.label$1 = null;
  this.rx$1 = null;
  this.followedBy$1 = null;
  this.extraValue$1 = null;
  this.possibleApplications$1 = null;
  this.next$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype.productPrefix__T = (function() {
  return "MessageBaseExpressionToken"
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken)) {
    var MessageBaseExpressionToken$1 = $as_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken(x$1);
    return (this.value$1 === MessageBaseExpressionToken$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype.nodeIsValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__nodeIsValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype.next__s_Option = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.next$lzycompute__p1__s_Option() : this.next$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype.completelyValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__completelyValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype.rx__s_util_matching_Regex = (function() {
  return this.rx$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype.extraValue__T = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.extraValue$lzycompute__p1__T() : this.extraValue$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype.extraValue$lzycompute__p1__T = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.extraValue$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__extraValue__T(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.extraValue$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype.init___T = (function(value) {
  this.value$1 = value;
  this.label$1 = "$message.";
  var this$2 = new $c_sci_StringOps().init___T("(\\$message\\.).*");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.rx$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_document_webapi_validation_runtimeexpression_HeaderExpressionToken$(), $m_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken$()];
  this.followedBy$1 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype.followedBy__sc_Seq = (function() {
  return this.followedBy$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype.next$lzycompute__p1__s_Option = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.next$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__next__s_Option(this);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.next$1
});
function $as_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runtimeexpression.MessageBaseExpressionToken"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runtimeexpression.MessageBaseExpressionToken;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.MessageBaseExpressionToken", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_LabeledExpressionToken: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_MessageBaseExpressionToken;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser() {
  $c_O.call(this);
  this.value$1 = null;
  this.rx$1 = null;
  this.followedBy$1 = null;
  this.completeStack$1 = null;
  this.extraValue$1 = null;
  this.possibleApplications$1 = null;
  this.next$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype.productPrefix__T = (function() {
  return "OAS3RuntimeExpressionParser"
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser)) {
    var OAS3RuntimeExpressionParser$1 = $as_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser(x$1);
    return (this.value$1 === OAS3RuntimeExpressionParser$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype.nodeIsValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__nodeIsValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype.next__s_Option = (function() {
  return (((((8 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.next$lzycompute__p1__s_Option() : this.next$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype.completelyValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__completelyValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype.rx__s_util_matching_Regex = (function() {
  return this.rx$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype.extraValue__T = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.extraValue$lzycompute__p1__T() : this.extraValue$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype.extraValue$lzycompute__p1__T = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.extraValue$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__extraValue__T(this);
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.extraValue$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype.init___T = (function(value) {
  this.value$1 = value;
  var this$2 = new $c_sci_StringOps().init___T("");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.rx$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken$(), $m_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken$(), $m_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken$(), $m_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken$(), $m_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken$()];
  this.followedBy$1 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype.followedBy__sc_Seq = (function() {
  return this.followedBy$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype.next$lzycompute__p1__s_Option = (function() {
  if (((((8 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.next$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__next__s_Option(this);
    this.bitmap$0$1 = (((8 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.next$1
});
function $as_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runtimeexpression.OAS3RuntimeExpressionParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runtimeexpression.OAS3RuntimeExpressionParser;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.OAS3RuntimeExpressionParser", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeExpressionParser: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_OAS3RuntimeExpressionParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken() {
  $c_O.call(this);
  this.value$1 = null;
  this.label$1 = null;
  this.rx$1 = null;
  this.followedBy$1 = null;
  this.extraValue$1 = null;
  this.possibleApplications$1 = null;
  this.next$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype.productPrefix__T = (function() {
  return "PayloadExpressionToken"
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken)) {
    var PayloadExpressionToken$1 = $as_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken(x$1);
    return (this.value$1 === PayloadExpressionToken$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype.nodeIsValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__nodeIsValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype.next__s_Option = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.next$lzycompute__p1__s_Option() : this.next$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype.completelyValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__completelyValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype.rx__s_util_matching_Regex = (function() {
  return this.rx$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype.extraValue__T = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.extraValue$lzycompute__p1__T() : this.extraValue$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype.extraValue$lzycompute__p1__T = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.extraValue$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__extraValue__T(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.extraValue$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype.init___T = (function(value) {
  this.value$1 = value;
  this.label$1 = "payload#";
  var this$2 = new $c_sci_StringOps().init___T("(payload#).*");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.rx$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  var jsx$1 = $m_sc_Seq$();
  var array = [$m_Lamf_plugins_document_webapi_validation_runtimeexpression_FragmentExpressionToken$()];
  this.followedBy$1 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype.followedBy__sc_Seq = (function() {
  return this.followedBy$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype.next$lzycompute__p1__s_Option = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.next$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__next__s_Option(this);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.next$1
});
function $as_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runtimeexpression.PayloadExpressionToken"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runtimeexpression.PayloadExpressionToken;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.PayloadExpressionToken", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_LabeledExpressionToken: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_PayloadExpressionToken;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression() {
  $c_O.call(this);
  this.expression$1 = null;
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression.prototype.constructor = $c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression.prototype = $c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression.prototype;
$c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression.prototype.productPrefix__T = (function() {
  return "ParsedFromTypeExpression"
});
$c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression)) {
    var ParsedFromTypeExpression$1 = $as_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression(x$1);
    return (this.expression$1 === ParsedFromTypeExpression$1.expression$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.expression$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression.prototype.init___T = (function(expression) {
  this.expression$1 = expression;
  this.name$1 = "type-expression";
  this.value$1 = expression;
  return this
});
$c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.annotations.ParsedFromTypeExpression"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.annotations.ParsedFromTypeExpression;", depth))
}
var $d_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression: 0
}, false, "amf.plugins.domain.shapes.annotations.ParsedFromTypeExpression", {
  Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression.prototype.$classData = $d_Lamf_plugins_domain_shapes_annotations_ParsedFromTypeExpression;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$() {
  $c_O.call(this);
  this.Url$1 = null;
  this.Title$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.Description$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$.prototype.constructor = $c_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$.prototype = $c_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$.prototype;
$c_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Url$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "url"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "url", "URL for the creative work", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Title$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "title"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "title", "Title of the item", $m_sci_Nil$()), true);
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "CreativeWork");
  var this$9 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$9);
  var x$4 = this.Url$1;
  var x$3 = this.Title$1;
  var x$2 = this.Description$1;
  var jsx$4 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var jsx$3 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().fields$1;
  var this$10 = $m_sci_List$();
  var this$11 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$10.ReusableCBFInstance$2));
  var this$12 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$11);
  var this$13 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$12);
  this.fields$1 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$13);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "Creative Work", "The most generic kind of creative work, including books, movies, photographs, software programs, etc.", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_shapes_models_CreativeWork().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$: 0
}, false, "amf.plugins.domain.shapes.metamodel.CreativeWorkModel$", {
  Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1
});
$c_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$.prototype.$classData = $d_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$;
var $n_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$ = (void 0);
function $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$() {
  if ((!$n_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$)) {
    $n_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$ = new $c_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$() {
  $c_Lamf_core_resolution_stages_selectors_Selector.call(this)
}
$c_Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$.prototype = new $h_Lamf_core_resolution_stages_selectors_Selector();
$c_Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$.prototype.constructor = $c_Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$.prototype = $c_Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$.prototype;
$c_Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$.prototype.init___ = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$.prototype.apply__O__O = (function(v1) {
  return this.apply__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(v1))
});
$c_Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$.prototype.hasParameters__p2__Lamf_plugins_domain_webapi_models_Request__Z = (function(req) {
  var jsx$6 = $as_sc_Seq(req.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryParameters$1));
  var jsx$5 = $as_sc_Seq(req.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().UriParameters$1));
  var this$1 = $m_sc_Seq$();
  var jsx$4 = $as_sc_TraversableLike(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$5, this$1.ReusableCBFInstance$2));
  var jsx$3 = $as_sc_Seq(req.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().CookieParameters$1));
  var this$2 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$2.ReusableCBFInstance$2));
  var jsx$1 = $as_sc_Seq(req.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Headers$1));
  var this$3 = $m_sc_Seq$();
  return $as_sc_TraversableOnce(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2)).nonEmpty__Z()
});
$c_Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$.prototype.apply__Lamf_core_model_domain_DomainElement__Z = (function(element) {
  if ((element instanceof $c_Lamf_plugins_domain_webapi_models_Request)) {
    var x2 = $as_Lamf_plugins_domain_webapi_models_Request(element);
    return this.hasParameters__p2__Lamf_plugins_domain_webapi_models_Request__Z(x2)
  } else {
    return false
  }
});
var $d_Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$: 0
}, false, "amf.plugins.domain.shapes.resolution.stages.ReqWithParametersSelector$", {
  Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$: 1,
  Lamf_core_resolution_stages_selectors_Selector: 1,
  O: 1,
  F1: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$.prototype.$classData = $d_Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$;
var $n_Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$ = (void 0);
function $m_Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$() {
  if ((!$n_Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$)) {
    $n_Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$ = new $c_Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_resolution_stages_ReqWithParametersSelector$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin() {
  $c_O.call(this);
  this.defaultSeverity$1 = null;
  this.payloadMediaType$1 = null;
  this.ID$1 = null
}
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin.prototype.constructor = $c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin.prototype = $c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin.prototype;
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin.prototype.init__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  return $m_s_concurrent_Future$().successful__O__s_concurrent_Future(this)
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin.prototype.productPrefix__T = (function() {
  return "AnyMatchPayloadPlugin"
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin.prototype.validator__Lamf_core_model_domain_Shape__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__Lamf_core_validation_PayloadValidator = (function(s, env, validationMode) {
  return new $c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMathPayloadValidator().init___Lamf_core_model_domain_Shape__T(s, this.defaultSeverity$1)
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin.prototype.canValidate__Lamf_core_model_domain_Shape__Lamf_internal_environment_Environment__Z = (function(shape, env) {
  return false
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin)) {
    var AnyMatchPayloadPlugin$1 = $as_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin(x$1);
    return (this.defaultSeverity$1 === AnyMatchPayloadPlugin$1.defaultSeverity$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.defaultSeverity$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin.prototype.ID__T = (function() {
  return this.ID$1
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin.prototype.dependencies__sc_Seq = (function() {
  return $m_sci_Nil$()
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin.prototype.init___T = (function(defaultSeverity) {
  this.defaultSeverity$1 = defaultSeverity;
  this.payloadMediaType$1 = $m_sci_Nil$();
  this.ID$1 = "Any match";
  return this
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin.prototype.payloadMediaType__sc_Seq = (function() {
  return this.payloadMediaType$1
});
function $as_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.validation.PayloadValidationPluginsHandler$AnyMatchPayloadPlugin"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.validation.PayloadValidationPluginsHandler$AnyMatchPayloadPlugin;", depth))
}
var $d_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin: 0
}, false, "amf.plugins.domain.shapes.validation.PayloadValidationPluginsHandler$AnyMatchPayloadPlugin", {
  Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin: 1,
  O: 1,
  Lamf_core_validation_AMFPayloadValidationPlugin: 1,
  Lamf_client_plugins_AMFPlugin: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin.prototype.$classData = $d_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$AnyMatchPayloadPlugin;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_annotations_InvalidBinding() {
  $c_O.call(this);
  this.value$1 = null;
  this.name$1 = null
}
$c_Lamf_plugins_domain_webapi_annotations_InvalidBinding.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_annotations_InvalidBinding.prototype.constructor = $c_Lamf_plugins_domain_webapi_annotations_InvalidBinding;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_annotations_InvalidBinding() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_annotations_InvalidBinding.prototype = $c_Lamf_plugins_domain_webapi_annotations_InvalidBinding.prototype;
$c_Lamf_plugins_domain_webapi_annotations_InvalidBinding.prototype.productPrefix__T = (function() {
  return "InvalidBinding"
});
$c_Lamf_plugins_domain_webapi_annotations_InvalidBinding.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_domain_webapi_annotations_InvalidBinding.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_annotations_InvalidBinding)) {
    var InvalidBinding$1 = $as_Lamf_plugins_domain_webapi_annotations_InvalidBinding(x$1);
    return (this.value$1 === InvalidBinding$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_annotations_InvalidBinding.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_annotations_InvalidBinding.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_annotations_InvalidBinding.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_plugins_domain_webapi_annotations_InvalidBinding.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_domain_webapi_annotations_InvalidBinding.prototype.init___T = (function(value) {
  this.value$1 = value;
  this.name$1 = "invalid-binding";
  return this
});
$c_Lamf_plugins_domain_webapi_annotations_InvalidBinding.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_annotations_InvalidBinding.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_domain_webapi_annotations_InvalidBinding(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_annotations_InvalidBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.annotations.InvalidBinding"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_annotations_InvalidBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_annotations_InvalidBinding)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_annotations_InvalidBinding(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_annotations_InvalidBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.annotations.InvalidBinding;", depth))
}
var $d_Lamf_plugins_domain_webapi_annotations_InvalidBinding = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_annotations_InvalidBinding: 0
}, false, "amf.plugins.domain.webapi.annotations.InvalidBinding", {
  Lamf_plugins_domain_webapi_annotations_InvalidBinding: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_annotations_InvalidBinding.prototype.$classData = $d_Lamf_plugins_domain_webapi_annotations_InvalidBinding;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension() {
  $c_O.call(this);
  this.location$1 = null;
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.prototype.constructor = $c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.prototype = $c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.prototype;
$c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.prototype.productPrefix__T = (function() {
  return "OrphanOasExtension"
});
$c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension)) {
    var OrphanOasExtension$1 = $as_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension(x$1);
    return (this.location$1 === OrphanOasExtension$1.location$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.location$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.prototype.init___T = (function(location) {
  this.location$1 = location;
  this.name$1 = "orphan-oas-extension";
  this.value$1 = location;
  return this
});
$c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.annotations.OrphanOasExtension"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_annotations_OrphanOasExtension)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.annotations.OrphanOasExtension;", depth))
}
var $d_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_annotations_OrphanOasExtension: 0
}, false, "amf.plugins.domain.webapi.annotations.OrphanOasExtension", {
  Lamf_plugins_domain_webapi_annotations_OrphanOasExtension: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.prototype.$classData = $d_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_CallbackModel$() {
  $c_O.call(this);
  this.Expression$1 = null;
  this.Endpoint$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.key$1 = null;
  this.doc$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_CallbackModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_CallbackModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_CallbackModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_CallbackModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_CallbackModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_CallbackModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_CallbackModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_CallbackModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Expression$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "expression"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "expression", "structural location of the information to fulfill the callback", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Endpoint$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "endpoint"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "endpoint", "Endpoint targeted by the callback", $m_sci_Nil$()), true);
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "Callback");
  var this$9 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$9);
  var x$4 = this.Name$1;
  var x$3 = this.Expression$1;
  var x$2 = this.Endpoint$1;
  var this$10 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$11 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$10);
  var this$12 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$11);
  this.fields$1 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$12);
  this.key$1 = this.Name$1;
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Callback", "Model defining the information for a HTTP callback/ webhook", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_CallbackModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_CallbackModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_CallbackModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_metamodel_CallbackModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_CallbackModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_CallbackModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_CallbackModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_Callback().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_CallbackModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_CallbackModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_CallbackModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_CallbackModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.CallbackModel$", {
  Lamf_plugins_domain_webapi_metamodel_CallbackModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_CallbackModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_CallbackModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_CallbackModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_CallbackModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_CallbackModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_CallbackModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_CallbackModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_ServerModel$() {
  $c_O.call(this);
  this.Url$1 = null;
  this.Variables$1 = null;
  this.Protocol$1 = null;
  this.ProtocolVersion$1 = null;
  this.Security$1 = null;
  this.Bindings$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Description$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_ServerModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_ServerModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_ServerModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_ServerModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_ServerModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_ServerModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_ServerModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_ServerModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Url$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "urlTemplate"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "urlTemplate", "URL (potentially a template) for the server", $m_sci_Nil$()), true);
  var jsx$2 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$());
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Variables$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "variable"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "variable", "Variables in the URL for the server", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_core_metamodel_Type$Str$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Protocol$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "protocol"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "protocol", "The protocol this URL supports for connection", $m_sci_Nil$()), true);
  var jsx$4 = $m_Lamf_core_metamodel_Type$Str$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.ProtocolVersion$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "protocolVersion"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "protocolVersion", "The version of the protocol used for connection", $m_sci_Nil$()), true);
  var jsx$5 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$());
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.Security$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "security"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "security", "Textual indication of the kind of security scheme used", $m_sci_Nil$()), true);
  var jsx$6 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$();
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Bindings$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$6, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "binding"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "binding", "Bindings for this server", $m_sci_Nil$()), true);
  var this$19 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$19, "Server");
  var this$21 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$21);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Server", "Information about the network accessible locations where the API is available", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_ServerModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ServerModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_ServerModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ServerModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Name$1, this.Url$1, this.Description$1, this.Variables$1, this.Protocol$1, this.ProtocolVersion$1, this.Security$1, this.Bindings$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_ServerModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ServerModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ServerModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_Server().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_ServerModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ServerModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_ServerModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_ServerModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.ServerModel$", {
  Lamf_plugins_domain_webapi_metamodel_ServerModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_ServerModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_ServerModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_ServerModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_ServerModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_ServerModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_ServerModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_ServerModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_TagModel$() {
  $c_O.call(this);
  this.Documentation$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Description$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_TagModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_TagModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_TagModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_TagModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_TagModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_TagModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_TagModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_TagModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  var jsx$1 = $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Documentation$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "documentation"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "documentation", "Documentation about the tag", $m_sci_Nil$()), true);
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "Tag");
  var this$6 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$6);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Tag", "Categorical information provided by some API spec format. Tags are extensions to the model supported directly in the input API spec format.", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_TagModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_TagModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_TagModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Name$1, this.Description$1, this.Documentation$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_TagModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_TagModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_TagModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_TagModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_Tag().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_TagModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_TagModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_TagModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_TagModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.TagModel$", {
  Lamf_plugins_domain_webapi_metamodel_TagModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_TagModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_TagModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_TagModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_TagModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_TagModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_TagModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_TagModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_TagModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$() {
  $c_O.call(this);
  this.Schemes$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.key$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  var jsx$1 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$());
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.Schemes$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "schemes"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "schemes", "", $m_sci_Nil$()), true);
  $m_sci_List$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "SecurityRequirement")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$9 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$9);
    i = (((-1) + i) | 0)
  };
  var jsx$3 = result;
  var jsx$2 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  var this$10 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$10.ReusableCBFInstance$2));
  $m_sci_List$();
  var array$1 = [this.Schemes$1];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$14 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$14);
    i$1 = (((-1) + i$1) | 0)
  };
  var jsx$5 = result$1;
  var jsx$4 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$15 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$15.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "Security Requirement", "Flow for an OAuth2 security scheme setting", $m_sci_Nil$());
  this.key$1 = this.Name$1;
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.security.SecurityRequirementModel$", {
  Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_EndPoint() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_EndPoint;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_EndPoint() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_EndPoint.prototype = $c_Lamf_plugins_domain_webapi_models_EndPoint.prototype;
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.withServer__T__Lamf_plugins_domain_webapi_models_Server = (function(url) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_Server().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Url$1;
  var result = $as_Lamf_plugins_domain_webapi_models_Server($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, url));
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Servers$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field$1, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.removeServers__V = (function() {
  this.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Servers$1)
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$()
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.withSecurity__T__Lamf_plugins_domain_webapi_models_security_SecurityRequirement = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$().Name$1;
  var result = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, name));
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Security$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field$1, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1));
  var this$2 = this$1.option$1;
  var str = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  var this$4 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$5 = this$4.platform$1;
  var url = this$4.str$1;
  return ("/end-points/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$5, url))
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.withParameter__T__Lamf_plugins_domain_webapi_models_Parameter = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_Parameter().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var this$5 = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().ParameterName$1;
  var result = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$5, field, name));
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field$1, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.withServers__sc_Seq__Lamf_plugins_domain_webapi_models_ServerContainer = (function(servers) {
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Servers$1;
  return $as_Lamf_plugins_domain_webapi_models_EndPoint($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this, field, servers))
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.traits__sc_Seq = (function() {
  var jsx$2 = $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field()));
  var jsx$1 = new $c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$traits$1().init___Lamf_plugins_domain_webapi_models_EndPoint(this);
  var this$1 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.resourceType__s_Option = (function() {
  var this$1 = $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field()));
  var pf = new $c_Lamf_plugins_domain_webapi_models_EndPoint$$anonfun$resourceType$1().init___Lamf_plugins_domain_webapi_models_EndPoint(this);
  return $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$1, pf)
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.withOperation__T__Lamf_plugins_domain_webapi_models_Operation = (function(method) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_Operation().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Method$1;
  var result = $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, method));
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field$1, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.relativePath__T = (function() {
  var this$1 = this.parent__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$8 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var p = $as_Lamf_plugins_domain_webapi_models_EndPoint(arg1);
    var this$2 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1));
    var this$3 = this$2.option$1;
    var x = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
    var this$7 = new $c_sci_StringOps().init___T(x);
    var this$5 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1));
    var this$6 = this$5.option$1;
    var prefix = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
    var this$8 = new $c_s_Some().init___O($f_sci_StringLike__stripPrefix__T__T(this$7, prefix))
  };
  if (this$8.isEmpty__Z()) {
    var this$9 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1));
    var this$10 = this$9.option$1;
    var jsx$1 = $as_T((this$10.isEmpty__Z() ? null : this$10.get__O()))
  } else {
    var jsx$1 = this$8.get__O()
  };
  return $as_T(jsx$1)
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Name$1
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.parent__s_Option = (function() {
  var this$1 = this.annotations$1.find__jl_Class__s_Option($d_Lamf_plugins_domain_webapi_annotations_ParentEndPoint.getClassOf());
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_Lamf_plugins_domain_webapi_annotations_ParentEndPoint(arg1);
    return x$1.parent$1
  }
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.servers__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Servers$1))
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.withPayload__s_Option__Lamf_plugins_domain_webapi_models_Payload = (function(mediaType) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var result = new $c_Lamf_plugins_domain_webapi_models_Payload().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  if ((!mediaType.isEmpty__Z())) {
    var arg1 = mediaType.get__O();
    var mediaType$2 = $as_T(arg1);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1;
    $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(result, field, mediaType$2))
  };
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Payloads$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field$1, result);
  return result
});
function $as_Lamf_plugins_domain_webapi_models_EndPoint(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_EndPoint) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.EndPoint"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_EndPoint(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_EndPoint)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_EndPoint(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_EndPoint(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.EndPoint;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_EndPoint = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_EndPoint: 0
}, false, "amf.plugins.domain.webapi.models.EndPoint", {
  Lamf_plugins_domain_webapi_models_EndPoint: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_plugins_domain_webapi_models_ExtensibleWebApiDomainElement: 1,
  Lamf_plugins_domain_webapi_models_ServerContainer: 1
});
$c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_EndPoint;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_Message() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_Message.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_Message.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_Message;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_Message() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_Message.prototype = $c_Lamf_plugins_domain_webapi_models_Message.prototype;
$c_Lamf_plugins_domain_webapi_models_Message.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_plugins_domain_webapi_models_Message()
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$()
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(this.nameField__Lamf_core_metamodel_Field())).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "message" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annot$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annot = $as_Lamf_core_parser_Annotations(annot$2);
      return new $c_Lamf_plugins_domain_webapi_models_Message().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annot)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.linkCopy__Lamf_plugins_domain_webapi_models_Message = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_Message().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Name$1
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.withPayload__s_Option__Lamf_plugins_domain_webapi_models_Payload = (function(mediaType) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var result = new $c_Lamf_plugins_domain_webapi_models_Payload().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  if ((!mediaType.isEmpty__Z())) {
    var arg1 = mediaType.get__O();
    var mediaType$2 = $as_T(arg1);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1;
    new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(result, field, mediaType$2)))
  };
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field$1, result);
  return result
});
function $as_Lamf_plugins_domain_webapi_models_Message(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_Message) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.Message"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_Message(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_Message)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_Message(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_Message(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.Message;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_Message = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_Message: 0
}, false, "amf.plugins.domain.webapi.models.Message", {
  Lamf_plugins_domain_webapi_models_Message: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement: 1,
  Lamf_core_model_domain_Linkable: 1
});
$c_Lamf_plugins_domain_webapi_models_Message.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_Message;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_security_SecurityScheme() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype = $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype;
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.withApiKeySettings__Lamf_plugins_domain_webapi_models_security_ApiKeySettings = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var settings = new $c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, settings);
  return settings
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return this.adopted__T__sc_Seq__Lamf_plugins_domain_webapi_models_security_SecurityScheme(parent, cycle)
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.withOAuth1Settings__Lamf_plugins_domain_webapi_models_security_OAuth1Settings = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var settings = new $c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, settings);
  return settings
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.adopted__T__sc_Seq__Lamf_plugins_domain_webapi_models_security_SecurityScheme = (function(parent, cycle) {
  if (($m_s_Option$().apply__O__s_Option(parent).isDefined__Z() && ($uI(parent.indexOf("#")) !== (-1)))) {
    var str = this.componentId__T();
    var this$5 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
    var this$6 = this$5.platform$1;
    var url = this$5.str$1;
    return $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(this.withId__T__Lamf_core_model_domain_AmfObject(((parent + "/") + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$6, url))))
  } else {
    var str$1 = this.componentId__T();
    var this$8 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str$1);
    var this$9 = this$8.platform$1;
    var url$1 = this$8.str$1;
    return $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(this.withId__T__Lamf_core_model_domain_AmfObject(((parent + "#") + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$9, url$1))))
  }
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.withHttpApiKeySettings__Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var settings = new $c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, settings);
  return settings
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.withHeader__T__Lamf_plugins_domain_webapi_models_Parameter = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_Parameter().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var result = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Headers$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$5 = new $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value))
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$()
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.withDefaultSettings__Lamf_plugins_domain_webapi_models_security_Settings = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var settings = new $c_Lamf_plugins_domain_webapi_models_security_Settings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, settings);
  return settings
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.normalizeType__V = (function() {
  var x1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1)).option$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var value = $as_T(x2.value$2);
    var normalized = ((value === "oauth2") ? "OAuth 2.0" : ((value === "basic") ? "Basic Authentication" : (((value === "apiKey") || (value === "x-apiKey")) ? "Api Key" : value)));
    var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1;
    var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(normalized, $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1)).annotations$1.reject__F1__Lamf_core_parser_Annotations(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$1$2) {
        var x$1 = $as_Lamf_core_model_domain_Annotation(x$1$2);
        return (x$1 instanceof $c_Lamf_core_annotations_SourceAST)
      })
    })(this))));
    var annotations = this.fields$1.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1).annotations$1;
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this, field, value$1, annotations)
  }
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "fragment" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url)
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.withOAuth2Settings__Lamf_plugins_domain_webapi_models_security_OAuth2Settings = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var settings = new $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, settings);
  return settings
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.withQueryParameter__T__Lamf_plugins_domain_webapi_models_Parameter = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_Parameter().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var result = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().QueryParameters$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.withHttpSettings__Lamf_plugins_domain_webapi_models_security_HttpSettings = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var settings = new $c_Lamf_plugins_domain_webapi_models_security_HttpSettings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, settings);
  return settings
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.withResponse__T__Lamf_plugins_domain_webapi_models_Response = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_Response().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var this$5 = $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2));
  var statusCode = ((name === "default") ? "200" : name);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1;
  var result = $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$5, field, statusCode));
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Responses$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field$1, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Name$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.withOpenIdConnectSettings__Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var settings = new $c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, settings);
  return settings
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.security.SecurityScheme"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_security_SecurityScheme(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_security_SecurityScheme)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_security_SecurityScheme(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_security_SecurityScheme(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.security.SecurityScheme;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_security_SecurityScheme = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_security_SecurityScheme: 0
}, false, "amf.plugins.domain.webapi.models.security.SecurityScheme", {
  Lamf_plugins_domain_webapi_models_security_SecurityScheme: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_plugins_domain_webapi_models_security_WithSettings: 1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_security_SecurityScheme;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_templates_ResourceType() {
  $c_Lamf_core_model_domain_templates_AbstractDeclaration.call(this);
  this.fields$2 = null;
  this.annotations$2 = null
}
$c_Lamf_plugins_domain_webapi_models_templates_ResourceType.prototype = new $h_Lamf_core_model_domain_templates_AbstractDeclaration();
$c_Lamf_plugins_domain_webapi_models_templates_ResourceType.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_templates_ResourceType;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_templates_ResourceType() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_templates_ResourceType.prototype = $c_Lamf_plugins_domain_webapi_models_templates_ResourceType.prototype;
$c_Lamf_plugins_domain_webapi_models_templates_ResourceType.prototype.asEndpoint__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_domain_webapi_models_EndPoint = (function(unit, profile, errorHandler) {
  var x1 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this);
  if ((x1 instanceof $c_s_Some)) {
    var links = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    return $as_Lamf_plugins_domain_webapi_models_templates_ResourceType($f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)).asEndpoint__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_domain_webapi_models_EndPoint(unit, profile, errorHandler)
  } else {
    var this$1 = $m_s_Option$().apply__O__s_Option(this.dataNode__Lamf_core_model_domain_DataNode());
    if (this$1.isEmpty__Z()) {
      var this$5 = $m_s_None$()
    } else {
      var arg1 = this$1.get__O();
      var x$1 = $as_Lamf_core_model_domain_DataNode(arg1);
      var x$4 = this.annotations$2;
      var this$2 = $as_Lamf_core_model_StrField(this.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().Name$1));
      var this$3 = this$2.option$1;
      var x$5 = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
      var x$6 = this.id$1;
      var x$7 = $m_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$().findUnitLocationOfElement__T__Lamf_core_model_document_BaseUnit__s_Option(this.id$1, unit);
      var x$10 = $m_s_None$();
      var this$5 = new $c_s_Some().init___O($m_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$().asEndpoint__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_model_domain_DataNode__Lamf_core_parser_Annotations__T__T__s_Option__Z__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_domain_webapi_models_EndPoint(unit, profile, x$1, x$4, x$5, x$6, x$7, false, x$10, errorHandler))
    };
    return $as_Lamf_plugins_domain_webapi_models_EndPoint((this$5.isEmpty__Z() ? null : this$5.get__O()))
  }
});
$c_Lamf_plugins_domain_webapi_models_templates_ResourceType.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$()
});
$c_Lamf_plugins_domain_webapi_models_templates_ResourceType.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$5 = new $c_Lamf_plugins_domain_webapi_models_templates_ResourceType().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_templates_ResourceType($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value))
});
$c_Lamf_plugins_domain_webapi_models_templates_ResourceType.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_plugins_domain_webapi_models_templates_ResourceType.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_templates_ResourceType().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_templates_ResourceType.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_plugins_domain_webapi_models_templates_ResourceType.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$2 = fields;
  this.annotations$2 = annotations;
  $c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_templates_ResourceType) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.templates.ResourceType"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_templates_ResourceType(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_templates_ResourceType)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_templates_ResourceType(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_templates_ResourceType(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.templates.ResourceType;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_templates_ResourceType = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_templates_ResourceType: 0
}, false, "amf.plugins.domain.webapi.models.templates.ResourceType", {
  Lamf_plugins_domain_webapi_models_templates_ResourceType: 1,
  Lamf_core_model_domain_templates_AbstractDeclaration: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_NamedDomainElement: 1
});
$c_Lamf_plugins_domain_webapi_models_templates_ResourceType.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_templates_ResourceType;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_templates_Trait() {
  $c_Lamf_core_model_domain_templates_AbstractDeclaration.call(this);
  this.fields$2 = null;
  this.annotations$2 = null
}
$c_Lamf_plugins_domain_webapi_models_templates_Trait.prototype = new $h_Lamf_core_model_domain_templates_AbstractDeclaration();
$c_Lamf_plugins_domain_webapi_models_templates_Trait.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_templates_Trait;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_templates_Trait() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_templates_Trait.prototype = $c_Lamf_plugins_domain_webapi_models_templates_Trait.prototype;
$c_Lamf_plugins_domain_webapi_models_templates_Trait.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$()
});
$c_Lamf_plugins_domain_webapi_models_templates_Trait.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$5 = new $c_Lamf_plugins_domain_webapi_models_templates_Trait().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_templates_Trait($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value))
});
$c_Lamf_plugins_domain_webapi_models_templates_Trait.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_plugins_domain_webapi_models_templates_Trait.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_templates_Trait().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_templates_Trait.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_plugins_domain_webapi_models_templates_Trait.prototype.asOperation__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_domain_webapi_models_Operation = (function(unit, profile, errorHandler) {
  var x1 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this);
  if ((x1 instanceof $c_s_Some)) {
    var links = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    return $as_Lamf_plugins_domain_webapi_models_templates_Trait($f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)).asOperation__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_domain_webapi_models_Operation(unit, profile, errorHandler)
  } else {
    var this$1 = $m_s_Option$().apply__O__s_Option(this.dataNode__Lamf_core_model_domain_DataNode());
    if (this$1.isEmpty__Z()) {
      var this$4 = $m_s_None$()
    } else {
      var arg1 = this$1.get__O();
      var x$1 = $as_Lamf_core_model_domain_DataNode(arg1);
      var this$2 = $as_Lamf_core_model_StrField(this.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().Name$1)).option$1;
      var x$4 = $as_T((this$2.isEmpty__Z() ? "" : this$2.get__O()));
      var x$5 = this.annotations$2;
      var x$6 = this.id$1;
      var x$7 = $m_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$().findUnitLocationOfElement__T__Lamf_core_model_document_BaseUnit__s_Option(this.id$1, unit);
      var x$10 = $m_s_None$();
      var this$4 = new $c_s_Some().init___O($m_Lamf_plugins_domain_webapi_resolution_ExtendsHelper$().asOperation__Lamf_ProfileName__Lamf_core_model_domain_DataNode__Lamf_core_model_document_BaseUnit__T__Lamf_core_parser_Annotations__T__s_Option__Z__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_domain_webapi_models_Operation(profile, x$1, unit, x$4, x$5, x$6, x$7, false, x$10, errorHandler))
    };
    return $as_Lamf_plugins_domain_webapi_models_Operation((this$4.isEmpty__Z() ? null : this$4.get__O()))
  }
});
$c_Lamf_plugins_domain_webapi_models_templates_Trait.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$2 = fields;
  this.annotations$2 = annotations;
  $c_Lamf_core_model_domain_templates_AbstractDeclaration.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_templates_Trait(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_templates_Trait) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.templates.Trait"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_templates_Trait(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_templates_Trait)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_templates_Trait(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_templates_Trait(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.templates.Trait;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_templates_Trait = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_templates_Trait: 0
}, false, "amf.plugins.domain.webapi.models.templates.Trait", {
  Lamf_plugins_domain_webapi_models_templates_Trait: 1,
  Lamf_core_model_domain_templates_AbstractDeclaration: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_NamedDomainElement: 1
});
$c_Lamf_plugins_domain_webapi_models_templates_Trait.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_templates_Trait;
/** @constructor */
function $c_Ljava_io_PrintStream() {
  $c_Ljava_io_FilterOutputStream.call(this);
  this.encoder$3 = null;
  this.autoFlush$3 = false;
  this.charset$3 = null;
  this.closing$3 = false;
  this.java$io$PrintStream$$closed$3 = false;
  this.errorFlag$3 = false;
  this.bitmap$0$3 = false
}
$c_Ljava_io_PrintStream.prototype = new $h_Ljava_io_FilterOutputStream();
$c_Ljava_io_PrintStream.prototype.constructor = $c_Ljava_io_PrintStream;
/** @constructor */
function $h_Ljava_io_PrintStream() {
  /*<skip>*/
}
$h_Ljava_io_PrintStream.prototype = $c_Ljava_io_PrintStream.prototype;
$c_Ljava_io_PrintStream.prototype.append__jl_CharSequence__jl_Appendable = (function(x$1) {
  return this.append__jl_CharSequence__Ljava_io_PrintStream(x$1)
});
$c_Ljava_io_PrintStream.prototype.init___Ljava_io_OutputStream__Z__Ljava_nio_charset_Charset = (function(_out, autoFlush, charset) {
  this.autoFlush$3 = autoFlush;
  this.charset$3 = charset;
  $c_Ljava_io_FilterOutputStream.prototype.init___Ljava_io_OutputStream.call(this, _out);
  this.closing$3 = false;
  this.java$io$PrintStream$$closed$3 = false;
  this.errorFlag$3 = false;
  return this
});
$c_Ljava_io_PrintStream.prototype.append__jl_CharSequence__Ljava_io_PrintStream = (function(csq) {
  this.print__T__V(((csq === null) ? "null" : $objectToString(csq)));
  return this
});
$c_Ljava_io_PrintStream.prototype.println__T__V = (function(s) {
  this.print__T__V(s);
  this.java$lang$JSConsoleBasedPrintStream$$printString__T__V("\n")
});
function $as_Ljava_io_PrintStream(obj) {
  return (((obj instanceof $c_Ljava_io_PrintStream) || (obj === null)) ? obj : $throwClassCastException(obj, "java.io.PrintStream"))
}
function $isArrayOf_Ljava_io_PrintStream(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Ljava_io_PrintStream)))
}
function $asArrayOf_Ljava_io_PrintStream(obj, depth) {
  return (($isArrayOf_Ljava_io_PrintStream(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Ljava.io.PrintStream;", depth))
}
/** @constructor */
function $c_Ljava_nio_HeapCharBuffer() {
  $c_Ljava_nio_CharBuffer.call(this);
  this.$$undreadOnly$3 = false
}
$c_Ljava_nio_HeapCharBuffer.prototype = new $h_Ljava_nio_CharBuffer();
$c_Ljava_nio_HeapCharBuffer.prototype.constructor = $c_Ljava_nio_HeapCharBuffer;
/** @constructor */
function $h_Ljava_nio_HeapCharBuffer() {
  /*<skip>*/
}
$h_Ljava_nio_HeapCharBuffer.prototype = $c_Ljava_nio_HeapCharBuffer.prototype;
$c_Ljava_nio_HeapCharBuffer.prototype.put__C__Ljava_nio_CharBuffer = (function(c) {
  if (this.$$undreadOnly$3) {
    throw new $c_Ljava_nio_ReadOnlyBufferException().init___()
  };
  var p = this.java$nio$Buffer$$$undposition$1;
  if ((p === this.$$undlimit$1)) {
    throw new $c_Ljava_nio_BufferOverflowException().init___()
  };
  this.java$nio$Buffer$$$undposition$1 = ((1 + p) | 0);
  this.$$undarray$2.set(((this.$$undarrayOffset$2 + p) | 0), c);
  return this
});
$c_Ljava_nio_HeapCharBuffer.prototype.subSequence__I__I__jl_CharSequence = (function(start, end) {
  return this.subSequence__I__I__Ljava_nio_CharBuffer(start, end)
});
$c_Ljava_nio_HeapCharBuffer.prototype.get__C = (function() {
  var p = this.java$nio$Buffer$$$undposition$1;
  if ((p === this.$$undlimit$1)) {
    throw new $c_Ljava_nio_BufferUnderflowException().init___()
  };
  this.java$nio$Buffer$$$undposition$1 = ((1 + p) | 0);
  var value = this.$$undarray$2.get(((this.$$undarrayOffset$2 + p) | 0));
  return value
});
$c_Ljava_nio_HeapCharBuffer.prototype.init___I__AC__I__I__I__Z = (function(_capacity, _array0, _arrayOffset0, _initialPosition, _initialLimit, _readOnly) {
  this.$$undreadOnly$3 = _readOnly;
  $c_Ljava_nio_CharBuffer.prototype.init___I__AC__I.call(this, _capacity, _array0, _arrayOffset0);
  $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call(this, _initialPosition);
  $c_Ljava_nio_Buffer.prototype.limit__I__Ljava_nio_Buffer.call(this, _initialLimit);
  return this
});
$c_Ljava_nio_HeapCharBuffer.prototype.subSequence__I__I__Ljava_nio_CharBuffer = (function(start, end) {
  if ((((start < 0) || (end < start)) || (end > ((this.$$undlimit$1 - this.java$nio$Buffer$$$undposition$1) | 0)))) {
    throw new $c_jl_IndexOutOfBoundsException().init___()
  };
  return new $c_Ljava_nio_HeapCharBuffer().init___I__AC__I__I__I__Z(this.$$undcapacity$1, this.$$undarray$2, this.$$undarrayOffset$2, ((this.java$nio$Buffer$$$undposition$1 + start) | 0), ((this.java$nio$Buffer$$$undposition$1 + end) | 0), this.$$undreadOnly$3)
});
$c_Ljava_nio_HeapCharBuffer.prototype.get__AC__I__I__Ljava_nio_CharBuffer = (function(dst, offset, length) {
  if ((((offset < 0) || (length < 0)) || (offset > ((dst.u.length - length) | 0)))) {
    throw new $c_jl_IndexOutOfBoundsException().init___()
  };
  var p = this.java$nio$Buffer$$$undposition$1;
  var newPos = ((p + length) | 0);
  if ((newPos > this.$$undlimit$1)) {
    throw new $c_Ljava_nio_BufferUnderflowException().init___()
  };
  this.java$nio$Buffer$$$undposition$1 = newPos;
  $systemArraycopy(this.$$undarray$2, ((this.$$undarrayOffset$2 + p) | 0), dst, offset, length);
  return this
});
$c_Ljava_nio_HeapCharBuffer.prototype.get__I__C = (function(index) {
  if (((index < 0) || (index >= this.$$undlimit$1))) {
    throw new $c_jl_IndexOutOfBoundsException().init___()
  };
  var value = this.$$undarray$2.get(((this.$$undarrayOffset$2 + index) | 0));
  return value
});
$c_Ljava_nio_HeapCharBuffer.prototype.store__I__C__V = (function(index, elem) {
  this.$$undarray$2.set(((this.$$undarrayOffset$2 + index) | 0), elem)
});
$c_Ljava_nio_HeapCharBuffer.prototype.load__I__C = (function(index) {
  var value = this.$$undarray$2.get(((this.$$undarrayOffset$2 + index) | 0));
  return value
});
$c_Ljava_nio_HeapCharBuffer.prototype.store__I__AC__I__I__V = (function(startIndex, src, offset, length) {
  $systemArraycopy(src, offset, this.$$undarray$2, ((this.$$undarrayOffset$2 + startIndex) | 0), length)
});
$c_Ljava_nio_HeapCharBuffer.prototype.isReadOnly__Z = (function() {
  return this.$$undreadOnly$3
});
var $d_Ljava_nio_HeapCharBuffer = new $TypeData().initClass({
  Ljava_nio_HeapCharBuffer: 0
}, false, "java.nio.HeapCharBuffer", {
  Ljava_nio_HeapCharBuffer: 1,
  Ljava_nio_CharBuffer: 1,
  Ljava_nio_Buffer: 1,
  O: 1,
  jl_Comparable: 1,
  jl_CharSequence: 1,
  jl_Appendable: 1,
  jl_Readable: 1
});
$c_Ljava_nio_HeapCharBuffer.prototype.$classData = $d_Ljava_nio_HeapCharBuffer;
/** @constructor */
function $c_Ljava_nio_StringCharBuffer() {
  $c_Ljava_nio_CharBuffer.call(this);
  this.java$nio$StringCharBuffer$$$undcsq$f = null;
  this.java$nio$StringCharBuffer$$$undcsqOffset$f = 0
}
$c_Ljava_nio_StringCharBuffer.prototype = new $h_Ljava_nio_CharBuffer();
$c_Ljava_nio_StringCharBuffer.prototype.constructor = $c_Ljava_nio_StringCharBuffer;
/** @constructor */
function $h_Ljava_nio_StringCharBuffer() {
  /*<skip>*/
}
$h_Ljava_nio_StringCharBuffer.prototype = $c_Ljava_nio_StringCharBuffer.prototype;
$c_Ljava_nio_StringCharBuffer.prototype.put__C__Ljava_nio_CharBuffer = (function(c) {
  throw new $c_Ljava_nio_ReadOnlyBufferException().init___()
});
$c_Ljava_nio_StringCharBuffer.prototype.subSequence__I__I__jl_CharSequence = (function(start, end) {
  return this.subSequence__I__I__Ljava_nio_CharBuffer(start, end)
});
$c_Ljava_nio_StringCharBuffer.prototype.get__C = (function() {
  var p = this.java$nio$Buffer$$$undposition$1;
  if ((p === this.$$undlimit$1)) {
    throw new $c_Ljava_nio_BufferUnderflowException().init___()
  };
  this.java$nio$Buffer$$$undposition$1 = ((1 + p) | 0);
  var c = $charSequenceCharAt(this.java$nio$StringCharBuffer$$$undcsq$f, ((this.java$nio$StringCharBuffer$$$undcsqOffset$f + p) | 0));
  return c
});
$c_Ljava_nio_StringCharBuffer.prototype.toString__T = (function() {
  var offset = this.java$nio$StringCharBuffer$$$undcsqOffset$f;
  return $objectToString($charSequenceSubSequence(this.java$nio$StringCharBuffer$$$undcsq$f, ((this.java$nio$Buffer$$$undposition$1 + offset) | 0), ((this.$$undlimit$1 + offset) | 0)))
});
$c_Ljava_nio_StringCharBuffer.prototype.init___I__jl_CharSequence__I__I__I = (function(_capacity, _csq, _csqOffset, _initialPosition, _initialLimit) {
  this.java$nio$StringCharBuffer$$$undcsq$f = _csq;
  this.java$nio$StringCharBuffer$$$undcsqOffset$f = _csqOffset;
  $c_Ljava_nio_CharBuffer.prototype.init___I__AC__I.call(this, _capacity, null, (-1));
  $c_Ljava_nio_Buffer.prototype.position__I__Ljava_nio_Buffer.call(this, _initialPosition);
  $c_Ljava_nio_Buffer.prototype.limit__I__Ljava_nio_Buffer.call(this, _initialLimit);
  return this
});
$c_Ljava_nio_StringCharBuffer.prototype.subSequence__I__I__Ljava_nio_CharBuffer = (function(start, end) {
  if ((((start < 0) || (end < start)) || (end > ((this.$$undlimit$1 - this.java$nio$Buffer$$$undposition$1) | 0)))) {
    throw new $c_jl_IndexOutOfBoundsException().init___()
  };
  return new $c_Ljava_nio_StringCharBuffer().init___I__jl_CharSequence__I__I__I(this.$$undcapacity$1, this.java$nio$StringCharBuffer$$$undcsq$f, this.java$nio$StringCharBuffer$$$undcsqOffset$f, ((this.java$nio$Buffer$$$undposition$1 + start) | 0), ((this.java$nio$Buffer$$$undposition$1 + end) | 0))
});
$c_Ljava_nio_StringCharBuffer.prototype.get__AC__I__I__Ljava_nio_CharBuffer = (function(dst, offset, length) {
  if ((((offset < 0) || (length < 0)) || (offset > ((dst.u.length - length) | 0)))) {
    throw new $c_jl_IndexOutOfBoundsException().init___()
  };
  var p = this.java$nio$Buffer$$$undposition$1;
  var newPos = ((p + length) | 0);
  if ((newPos > this.$$undlimit$1)) {
    throw new $c_Ljava_nio_BufferUnderflowException().init___()
  };
  this.java$nio$Buffer$$$undposition$1 = newPos;
  var selfPos = p;
  var endPos = ((selfPos + length) | 0);
  var arrayIndex = offset;
  while ((selfPos !== endPos)) {
    var jsx$1 = arrayIndex;
    var index = selfPos;
    var c = $charSequenceCharAt(this.java$nio$StringCharBuffer$$$undcsq$f, ((this.java$nio$StringCharBuffer$$$undcsqOffset$f + index) | 0));
    dst.set(jsx$1, c);
    selfPos = ((1 + selfPos) | 0);
    arrayIndex = ((1 + arrayIndex) | 0)
  };
  return this
});
$c_Ljava_nio_StringCharBuffer.prototype.get__I__C = (function(index) {
  if (((index < 0) || (index >= this.$$undlimit$1))) {
    throw new $c_jl_IndexOutOfBoundsException().init___()
  };
  var c = $charSequenceCharAt(this.java$nio$StringCharBuffer$$$undcsq$f, ((this.java$nio$StringCharBuffer$$$undcsqOffset$f + index) | 0));
  return c
});
$c_Ljava_nio_StringCharBuffer.prototype.store__I__C__V = (function(index, elem) {
  throw new $c_Ljava_nio_ReadOnlyBufferException().init___()
});
$c_Ljava_nio_StringCharBuffer.prototype.load__I__C = (function(index) {
  return $charSequenceCharAt(this.java$nio$StringCharBuffer$$$undcsq$f, ((this.java$nio$StringCharBuffer$$$undcsqOffset$f + index) | 0))
});
$c_Ljava_nio_StringCharBuffer.prototype.store__I__AC__I__I__V = (function(startIndex, src, offset, length) {
  throw new $c_Ljava_nio_ReadOnlyBufferException().init___()
});
$c_Ljava_nio_StringCharBuffer.prototype.isReadOnly__Z = (function() {
  return true
});
var $d_Ljava_nio_StringCharBuffer = new $TypeData().initClass({
  Ljava_nio_StringCharBuffer: 0
}, false, "java.nio.StringCharBuffer", {
  Ljava_nio_StringCharBuffer: 1,
  Ljava_nio_CharBuffer: 1,
  Ljava_nio_Buffer: 1,
  O: 1,
  jl_Comparable: 1,
  jl_CharSequence: 1,
  jl_Appendable: 1,
  jl_Readable: 1
});
$c_Ljava_nio_StringCharBuffer.prototype.$classData = $d_Ljava_nio_StringCharBuffer;
/** @constructor */
function $c_Lorg_mulesoft_common_io_LimitReachedException() {
  $c_jl_Exception.call(this)
}
$c_Lorg_mulesoft_common_io_LimitReachedException.prototype = new $h_jl_Exception();
$c_Lorg_mulesoft_common_io_LimitReachedException.prototype.constructor = $c_Lorg_mulesoft_common_io_LimitReachedException;
/** @constructor */
function $h_Lorg_mulesoft_common_io_LimitReachedException() {
  /*<skip>*/
}
$h_Lorg_mulesoft_common_io_LimitReachedException.prototype = $c_Lorg_mulesoft_common_io_LimitReachedException.prototype;
$c_Lorg_mulesoft_common_io_LimitReachedException.prototype.init___ = (function() {
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
$c_Lorg_mulesoft_common_io_LimitReachedException.prototype.productPrefix__T = (function() {
  return "LimitReachedException"
});
$c_Lorg_mulesoft_common_io_LimitReachedException.prototype.productArity__I = (function() {
  return 0
});
$c_Lorg_mulesoft_common_io_LimitReachedException.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lorg_mulesoft_common_io_LimitReachedException) && ($as_Lorg_mulesoft_common_io_LimitReachedException(x$1), true))
});
$c_Lorg_mulesoft_common_io_LimitReachedException.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lorg_mulesoft_common_io_LimitReachedException.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lorg_mulesoft_common_io_LimitReachedException.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lorg_mulesoft_common_io_LimitReachedException(obj) {
  return (((obj instanceof $c_Lorg_mulesoft_common_io_LimitReachedException) || (obj === null)) ? obj : $throwClassCastException(obj, "org.mulesoft.common.io.LimitReachedException"))
}
function $isArrayOf_Lorg_mulesoft_common_io_LimitReachedException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_mulesoft_common_io_LimitReachedException)))
}
function $asArrayOf_Lorg_mulesoft_common_io_LimitReachedException(obj, depth) {
  return (($isArrayOf_Lorg_mulesoft_common_io_LimitReachedException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.mulesoft.common.io.LimitReachedException;", depth))
}
var $d_Lorg_mulesoft_common_io_LimitReachedException = new $TypeData().initClass({
  Lorg_mulesoft_common_io_LimitReachedException: 0
}, false, "org.mulesoft.common.io.LimitReachedException", {
  Lorg_mulesoft_common_io_LimitReachedException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1
});
$c_Lorg_mulesoft_common_io_LimitReachedException.prototype.$classData = $d_Lorg_mulesoft_common_io_LimitReachedException;
/** @constructor */
function $c_Lorg_mulesoft_lexer_SourceLocation() {
  $c_O.call(this);
  this.sourceName$1 = null;
  this.offsetFrom$1 = 0;
  this.offsetTo$1 = 0;
  this.lineFrom$1 = 0;
  this.columnFrom$1 = 0;
  this.lineTo$1 = 0;
  this.columnTo$1 = 0
}
$c_Lorg_mulesoft_lexer_SourceLocation.prototype = new $h_O();
$c_Lorg_mulesoft_lexer_SourceLocation.prototype.constructor = $c_Lorg_mulesoft_lexer_SourceLocation;
/** @constructor */
function $h_Lorg_mulesoft_lexer_SourceLocation() {
  /*<skip>*/
}
$h_Lorg_mulesoft_lexer_SourceLocation.prototype = $c_Lorg_mulesoft_lexer_SourceLocation.prototype;
$c_Lorg_mulesoft_lexer_SourceLocation.prototype.productPrefix__T = (function() {
  return "SourceLocation"
});
$c_Lorg_mulesoft_lexer_SourceLocation.prototype.productArity__I = (function() {
  return 7
});
$c_Lorg_mulesoft_lexer_SourceLocation.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lorg_mulesoft_lexer_SourceLocation)) {
    var SourceLocation$1 = $as_Lorg_mulesoft_lexer_SourceLocation(x$1);
    return (((((((this.sourceName$1 === SourceLocation$1.sourceName$1) && (this.offsetFrom$1 === SourceLocation$1.offsetFrom$1)) && (this.offsetTo$1 === SourceLocation$1.offsetTo$1)) && (this.lineFrom$1 === SourceLocation$1.lineFrom$1)) && (this.columnFrom$1 === SourceLocation$1.columnFrom$1)) && (this.lineTo$1 === SourceLocation$1.lineTo$1)) && (this.columnTo$1 === SourceLocation$1.columnTo$1))
  } else {
    return false
  }
});
$c_Lorg_mulesoft_lexer_SourceLocation.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.sourceName$1;
      break
    }
    case 1: {
      return this.offsetFrom$1;
      break
    }
    case 2: {
      return this.offsetTo$1;
      break
    }
    case 3: {
      return this.lineFrom$1;
      break
    }
    case 4: {
      return this.columnFrom$1;
      break
    }
    case 5: {
      return this.lineTo$1;
      break
    }
    case 6: {
      return this.columnTo$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lorg_mulesoft_lexer_SourceLocation.prototype.isZero__Z = (function() {
  return ((((((this.lineFrom$1 === 0) && (this.columnFrom$1 === 0)) && (this.lineTo$1 === 0)) && (this.columnTo$1 === 0)) && (this.offsetFrom$1 === 0)) && (this.offsetTo$1 === 0))
});
$c_Lorg_mulesoft_lexer_SourceLocation.prototype.toString__T = (function() {
  var thiz = this.sourceName$1;
  if ((thiz === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  if ((thiz === "")) {
    var src = "Unknown"
  } else {
    var src = this.sourceName$1
  };
  var offset = (((!(!(((((this.offsetFrom$1 <= 0) && (this.offsetTo$1 <= 0)) && (this.lineFrom$1 !== 1)) && (this.lineTo$1 !== 1)) & (this.columnFrom$1 !== 0)))) && (this.columnTo$1 !== 0)) ? "" : (((("[" + this.offsetFrom$1) + ",") + this.offsetTo$1) + "]"));
  var range = (((this.lineFrom$1 <= 0) && (this.lineTo$1 <= 0)) ? "" : (((((((": " + this.lineFrom$1) + ",") + this.columnFrom$1) + "..") + this.lineTo$1) + ",") + this.columnTo$1));
  return ((src + offset) + range)
});
$c_Lorg_mulesoft_lexer_SourceLocation.prototype.compareTo__O__I = (function(that) {
  return this.compare__Lorg_mulesoft_lexer_SourceLocation__I($as_Lorg_mulesoft_lexer_SourceLocation(that))
});
$c_Lorg_mulesoft_lexer_SourceLocation.prototype.compare__O__I = (function(that) {
  return this.compare__Lorg_mulesoft_lexer_SourceLocation__I($as_Lorg_mulesoft_lexer_SourceLocation(that))
});
$c_Lorg_mulesoft_lexer_SourceLocation.prototype.init___T__I__I__I__I__I__I = (function(sourceName, offsetFrom, offsetTo, lineFrom, columnFrom, lineTo, columnTo) {
  this.sourceName$1 = sourceName;
  this.offsetFrom$1 = offsetFrom;
  this.offsetTo$1 = offsetTo;
  this.lineFrom$1 = lineFrom;
  this.columnFrom$1 = columnFrom;
  this.lineTo$1 = lineTo;
  this.columnTo$1 = columnTo;
  return this
});
$c_Lorg_mulesoft_lexer_SourceLocation.prototype.compare__Lorg_mulesoft_lexer_SourceLocation__I = (function(that) {
  if ((this.sourceName$1 !== that.sourceName$1)) {
    var thiz = this.sourceName$1;
    var anotherString = that.sourceName$1;
    return ((thiz === anotherString) ? 0 : ($uZ((thiz < anotherString)) ? (-1) : 1))
  } else if ((this.offsetFrom$1 !== that.offsetFrom$1)) {
    var x = this.offsetFrom$1;
    var y = that.offsetFrom$1;
    return ((x === y) ? 0 : ((x < y) ? (-1) : 1))
  } else if ((this.lineFrom$1 !== that.lineFrom$1)) {
    var x$1 = this.lineFrom$1;
    var y$1 = that.lineFrom$1;
    return ((x$1 === y$1) ? 0 : ((x$1 < y$1) ? (-1) : 1))
  } else {
    var x$2 = this.columnFrom$1;
    var y$2 = that.columnFrom$1;
    return ((x$2 === y$2) ? 0 : ((x$2 < y$2) ? (-1) : 1))
  }
});
$c_Lorg_mulesoft_lexer_SourceLocation.prototype.to__Lorg_mulesoft_lexer_SourceLocation__Lorg_mulesoft_lexer_SourceLocation = (function(that) {
  var x$2 = $m_Lorg_mulesoft_lexer_SourceLocation$().Unknown$1;
  if (this.equals__O__Z(x$2)) {
    return that
  } else {
    var x$4 = $m_Lorg_mulesoft_lexer_SourceLocation$().Unknown$1;
    if (((that === null) ? (x$4 === null) : that.equals__O__Z(x$4))) {
      return this
    } else {
      return $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_Position__Lorg_mulesoft_lexer_Position__Lorg_mulesoft_lexer_SourceLocation(this.sourceName$1, $m_Lorg_mulesoft_lexer_Position$().apply__I__I__I__Lorg_mulesoft_lexer_Position(this.lineFrom$1, this.columnFrom$1, this.offsetFrom$1), $m_Lorg_mulesoft_lexer_Position$().apply__I__I__I__Lorg_mulesoft_lexer_Position(that.lineTo$1, that.columnTo$1, that.offsetTo$1))
    }
  }
});
$c_Lorg_mulesoft_lexer_SourceLocation.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.sourceName$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.offsetFrom$1);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.offsetTo$1);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.lineFrom$1);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.columnFrom$1);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.lineTo$1);
  acc = $m_sr_Statics$().mix__I__I__I(acc, this.columnTo$1);
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 7)
});
$c_Lorg_mulesoft_lexer_SourceLocation.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lorg_mulesoft_lexer_SourceLocation(obj) {
  return (((obj instanceof $c_Lorg_mulesoft_lexer_SourceLocation) || (obj === null)) ? obj : $throwClassCastException(obj, "org.mulesoft.lexer.SourceLocation"))
}
function $isArrayOf_Lorg_mulesoft_lexer_SourceLocation(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_mulesoft_lexer_SourceLocation)))
}
function $asArrayOf_Lorg_mulesoft_lexer_SourceLocation(obj, depth) {
  return (($isArrayOf_Lorg_mulesoft_lexer_SourceLocation(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.mulesoft.lexer.SourceLocation;", depth))
}
var $d_Lorg_mulesoft_lexer_SourceLocation = new $TypeData().initClass({
  Lorg_mulesoft_lexer_SourceLocation: 0
}, false, "org.mulesoft.lexer.SourceLocation", {
  Lorg_mulesoft_lexer_SourceLocation: 1,
  O: 1,
  s_math_Ordered: 1,
  jl_Comparable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_mulesoft_lexer_SourceLocation.prototype.$classData = $d_Lorg_mulesoft_lexer_SourceLocation;
/** @constructor */
function $c_Lorg_scalajs_dom_ext_AjaxException() {
  $c_jl_Exception.call(this);
  this.xhr$3 = null
}
$c_Lorg_scalajs_dom_ext_AjaxException.prototype = new $h_jl_Exception();
$c_Lorg_scalajs_dom_ext_AjaxException.prototype.constructor = $c_Lorg_scalajs_dom_ext_AjaxException;
/** @constructor */
function $h_Lorg_scalajs_dom_ext_AjaxException() {
  /*<skip>*/
}
$h_Lorg_scalajs_dom_ext_AjaxException.prototype = $c_Lorg_scalajs_dom_ext_AjaxException.prototype;
$c_Lorg_scalajs_dom_ext_AjaxException.prototype.productPrefix__T = (function() {
  return "AjaxException"
});
$c_Lorg_scalajs_dom_ext_AjaxException.prototype.productArity__I = (function() {
  return 1
});
$c_Lorg_scalajs_dom_ext_AjaxException.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lorg_scalajs_dom_ext_AjaxException)) {
    var AjaxException$1 = $as_Lorg_scalajs_dom_ext_AjaxException(x$1);
    return $m_sr_BoxesRunTime$().equals__O__O__Z(this.xhr$3, AjaxException$1.xhr$3)
  } else {
    return false
  }
});
$c_Lorg_scalajs_dom_ext_AjaxException.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.xhr$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lorg_scalajs_dom_ext_AjaxException.prototype.init___Lorg_scalajs_dom_raw_XMLHttpRequest = (function(xhr) {
  this.xhr$3 = xhr;
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
$c_Lorg_scalajs_dom_ext_AjaxException.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lorg_scalajs_dom_ext_AjaxException.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lorg_scalajs_dom_ext_AjaxException(obj) {
  return (((obj instanceof $c_Lorg_scalajs_dom_ext_AjaxException) || (obj === null)) ? obj : $throwClassCastException(obj, "org.scalajs.dom.ext.AjaxException"))
}
function $isArrayOf_Lorg_scalajs_dom_ext_AjaxException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_scalajs_dom_ext_AjaxException)))
}
function $asArrayOf_Lorg_scalajs_dom_ext_AjaxException(obj, depth) {
  return (($isArrayOf_Lorg_scalajs_dom_ext_AjaxException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.scalajs.dom.ext.AjaxException;", depth))
}
var $d_Lorg_scalajs_dom_ext_AjaxException = new $TypeData().initClass({
  Lorg_scalajs_dom_ext_AjaxException: 0
}, false, "org.scalajs.dom.ext.AjaxException", {
  Lorg_scalajs_dom_ext_AjaxException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1
});
$c_Lorg_scalajs_dom_ext_AjaxException.prototype.$classData = $d_Lorg_scalajs_dom_ext_AjaxException;
/** @constructor */
function $c_ju_Arrays$$anon$3() {
  $c_O.call(this);
  this.cmp$1$1 = null
}
$c_ju_Arrays$$anon$3.prototype = new $h_O();
$c_ju_Arrays$$anon$3.prototype.constructor = $c_ju_Arrays$$anon$3;
/** @constructor */
function $h_ju_Arrays$$anon$3() {
  /*<skip>*/
}
$h_ju_Arrays$$anon$3.prototype = $c_ju_Arrays$$anon$3.prototype;
$c_ju_Arrays$$anon$3.prototype.init___ju_Comparator = (function(cmp$1) {
  this.cmp$1$1 = cmp$1;
  return this
});
$c_ju_Arrays$$anon$3.prototype.gteq__O__O__Z = (function(x, y) {
  return $f_s_math_Ordering__gteq__O__O__Z(this, x, y)
});
$c_ju_Arrays$$anon$3.prototype.compare__O__O__I = (function(x, y) {
  return this.cmp$1$1.compare__O__O__I(x, y)
});
$c_ju_Arrays$$anon$3.prototype.lteq__O__O__Z = (function(x, y) {
  return $f_s_math_Ordering__lteq__O__O__Z(this, x, y)
});
var $d_ju_Arrays$$anon$3 = new $TypeData().initClass({
  ju_Arrays$$anon$3: 0
}, false, "java.util.Arrays$$anon$3", {
  ju_Arrays$$anon$3: 1,
  O: 1,
  s_math_Ordering: 1,
  ju_Comparator: 1,
  s_math_PartialOrdering: 1,
  s_math_Equiv: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_ju_Arrays$$anon$3.prototype.$classData = $d_ju_Arrays$$anon$3;
/** @constructor */
function $c_ju_DuplicateFormatFlagsException() {
  $c_ju_IllegalFormatException.call(this);
  this.f$6 = null
}
$c_ju_DuplicateFormatFlagsException.prototype = new $h_ju_IllegalFormatException();
$c_ju_DuplicateFormatFlagsException.prototype.constructor = $c_ju_DuplicateFormatFlagsException;
/** @constructor */
function $h_ju_DuplicateFormatFlagsException() {
  /*<skip>*/
}
$h_ju_DuplicateFormatFlagsException.prototype = $c_ju_DuplicateFormatFlagsException.prototype;
$c_ju_DuplicateFormatFlagsException.prototype.getMessage__T = (function() {
  return (("Flags = '" + this.f$6) + "'")
});
$c_ju_DuplicateFormatFlagsException.prototype.init___T = (function(f) {
  this.f$6 = f;
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  if ((f === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  return this
});
var $d_ju_DuplicateFormatFlagsException = new $TypeData().initClass({
  ju_DuplicateFormatFlagsException: 0
}, false, "java.util.DuplicateFormatFlagsException", {
  ju_DuplicateFormatFlagsException: 1,
  ju_IllegalFormatException: 1,
  jl_IllegalArgumentException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_ju_DuplicateFormatFlagsException.prototype.$classData = $d_ju_DuplicateFormatFlagsException;
/** @constructor */
function $c_ju_FormatFlagsConversionMismatchException() {
  $c_ju_IllegalFormatException.call(this);
  this.f$6 = null;
  this.c$6 = 0
}
$c_ju_FormatFlagsConversionMismatchException.prototype = new $h_ju_IllegalFormatException();
$c_ju_FormatFlagsConversionMismatchException.prototype.constructor = $c_ju_FormatFlagsConversionMismatchException;
/** @constructor */
function $h_ju_FormatFlagsConversionMismatchException() {
  /*<skip>*/
}
$h_ju_FormatFlagsConversionMismatchException.prototype = $c_ju_FormatFlagsConversionMismatchException.prototype;
$c_ju_FormatFlagsConversionMismatchException.prototype.getMessage__T = (function() {
  var c = this.c$6;
  return ((("Conversion = " + new $c_jl_Character().init___C(c)) + ", Flags = ") + this.f$6)
});
$c_ju_FormatFlagsConversionMismatchException.prototype.init___T__C = (function(f, c) {
  this.f$6 = f;
  this.c$6 = c;
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  if ((f === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  return this
});
var $d_ju_FormatFlagsConversionMismatchException = new $TypeData().initClass({
  ju_FormatFlagsConversionMismatchException: 0
}, false, "java.util.FormatFlagsConversionMismatchException", {
  ju_FormatFlagsConversionMismatchException: 1,
  ju_IllegalFormatException: 1,
  jl_IllegalArgumentException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_ju_FormatFlagsConversionMismatchException.prototype.$classData = $d_ju_FormatFlagsConversionMismatchException;
/** @constructor */
function $c_ju_IllegalFormatCodePointException() {
  $c_ju_IllegalFormatException.call(this);
  this.c$6 = 0
}
$c_ju_IllegalFormatCodePointException.prototype = new $h_ju_IllegalFormatException();
$c_ju_IllegalFormatCodePointException.prototype.constructor = $c_ju_IllegalFormatCodePointException;
/** @constructor */
function $h_ju_IllegalFormatCodePointException() {
  /*<skip>*/
}
$h_ju_IllegalFormatCodePointException.prototype = $c_ju_IllegalFormatCodePointException.prototype;
$c_ju_IllegalFormatCodePointException.prototype.getMessage__T = (function() {
  var i = this.c$6;
  var x = $uD((i >>> 0));
  var jsx$1 = x.toString(16);
  return ("Code point = 0x" + $as_T(jsx$1))
});
$c_ju_IllegalFormatCodePointException.prototype.init___I = (function(c) {
  this.c$6 = c;
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
var $d_ju_IllegalFormatCodePointException = new $TypeData().initClass({
  ju_IllegalFormatCodePointException: 0
}, false, "java.util.IllegalFormatCodePointException", {
  ju_IllegalFormatCodePointException: 1,
  ju_IllegalFormatException: 1,
  jl_IllegalArgumentException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_ju_IllegalFormatCodePointException.prototype.$classData = $d_ju_IllegalFormatCodePointException;
/** @constructor */
function $c_ju_IllegalFormatConversionException() {
  $c_ju_IllegalFormatException.call(this);
  this.c$6 = 0;
  this.arg$6 = null
}
$c_ju_IllegalFormatConversionException.prototype = new $h_ju_IllegalFormatException();
$c_ju_IllegalFormatConversionException.prototype.constructor = $c_ju_IllegalFormatConversionException;
/** @constructor */
function $h_ju_IllegalFormatConversionException() {
  /*<skip>*/
}
$h_ju_IllegalFormatConversionException.prototype = $c_ju_IllegalFormatConversionException.prototype;
$c_ju_IllegalFormatConversionException.prototype.getMessage__T = (function() {
  var c = this.c$6;
  return (($as_T($g.String.fromCharCode(c)) + " != ") + this.arg$6.getName__T())
});
$c_ju_IllegalFormatConversionException.prototype.init___C__jl_Class = (function(c, arg) {
  this.c$6 = c;
  this.arg$6 = arg;
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  if ((arg === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  return this
});
var $d_ju_IllegalFormatConversionException = new $TypeData().initClass({
  ju_IllegalFormatConversionException: 0
}, false, "java.util.IllegalFormatConversionException", {
  ju_IllegalFormatConversionException: 1,
  ju_IllegalFormatException: 1,
  jl_IllegalArgumentException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_ju_IllegalFormatConversionException.prototype.$classData = $d_ju_IllegalFormatConversionException;
/** @constructor */
function $c_ju_IllegalFormatFlagsException() {
  $c_ju_IllegalFormatException.call(this);
  this.f$6 = null
}
$c_ju_IllegalFormatFlagsException.prototype = new $h_ju_IllegalFormatException();
$c_ju_IllegalFormatFlagsException.prototype.constructor = $c_ju_IllegalFormatFlagsException;
/** @constructor */
function $h_ju_IllegalFormatFlagsException() {
  /*<skip>*/
}
$h_ju_IllegalFormatFlagsException.prototype = $c_ju_IllegalFormatFlagsException.prototype;
$c_ju_IllegalFormatFlagsException.prototype.getMessage__T = (function() {
  return (("Flags = '" + this.f$6) + "'")
});
$c_ju_IllegalFormatFlagsException.prototype.init___T = (function(f) {
  this.f$6 = f;
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  if ((f === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  return this
});
var $d_ju_IllegalFormatFlagsException = new $TypeData().initClass({
  ju_IllegalFormatFlagsException: 0
}, false, "java.util.IllegalFormatFlagsException", {
  ju_IllegalFormatFlagsException: 1,
  ju_IllegalFormatException: 1,
  jl_IllegalArgumentException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_ju_IllegalFormatFlagsException.prototype.$classData = $d_ju_IllegalFormatFlagsException;
/** @constructor */
function $c_ju_IllegalFormatPrecisionException() {
  $c_ju_IllegalFormatException.call(this);
  this.p$6 = 0
}
$c_ju_IllegalFormatPrecisionException.prototype = new $h_ju_IllegalFormatException();
$c_ju_IllegalFormatPrecisionException.prototype.constructor = $c_ju_IllegalFormatPrecisionException;
/** @constructor */
function $h_ju_IllegalFormatPrecisionException() {
  /*<skip>*/
}
$h_ju_IllegalFormatPrecisionException.prototype = $c_ju_IllegalFormatPrecisionException.prototype;
$c_ju_IllegalFormatPrecisionException.prototype.getMessage__T = (function() {
  var i = this.p$6;
  return ("" + i)
});
$c_ju_IllegalFormatPrecisionException.prototype.init___I = (function(p) {
  this.p$6 = p;
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
var $d_ju_IllegalFormatPrecisionException = new $TypeData().initClass({
  ju_IllegalFormatPrecisionException: 0
}, false, "java.util.IllegalFormatPrecisionException", {
  ju_IllegalFormatPrecisionException: 1,
  ju_IllegalFormatException: 1,
  jl_IllegalArgumentException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_ju_IllegalFormatPrecisionException.prototype.$classData = $d_ju_IllegalFormatPrecisionException;
/** @constructor */
function $c_ju_IllegalFormatWidthException() {
  $c_ju_IllegalFormatException.call(this);
  this.w$6 = 0
}
$c_ju_IllegalFormatWidthException.prototype = new $h_ju_IllegalFormatException();
$c_ju_IllegalFormatWidthException.prototype.constructor = $c_ju_IllegalFormatWidthException;
/** @constructor */
function $h_ju_IllegalFormatWidthException() {
  /*<skip>*/
}
$h_ju_IllegalFormatWidthException.prototype = $c_ju_IllegalFormatWidthException.prototype;
$c_ju_IllegalFormatWidthException.prototype.getMessage__T = (function() {
  var i = this.w$6;
  return ("" + i)
});
$c_ju_IllegalFormatWidthException.prototype.init___I = (function(w) {
  this.w$6 = w;
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
var $d_ju_IllegalFormatWidthException = new $TypeData().initClass({
  ju_IllegalFormatWidthException: 0
}, false, "java.util.IllegalFormatWidthException", {
  ju_IllegalFormatWidthException: 1,
  ju_IllegalFormatException: 1,
  jl_IllegalArgumentException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_ju_IllegalFormatWidthException.prototype.$classData = $d_ju_IllegalFormatWidthException;
/** @constructor */
function $c_ju_MissingFormatArgumentException() {
  $c_ju_IllegalFormatException.call(this);
  this.s$6 = null
}
$c_ju_MissingFormatArgumentException.prototype = new $h_ju_IllegalFormatException();
$c_ju_MissingFormatArgumentException.prototype.constructor = $c_ju_MissingFormatArgumentException;
/** @constructor */
function $h_ju_MissingFormatArgumentException() {
  /*<skip>*/
}
$h_ju_MissingFormatArgumentException.prototype = $c_ju_MissingFormatArgumentException.prototype;
$c_ju_MissingFormatArgumentException.prototype.getMessage__T = (function() {
  return (("Format specifier '" + this.s$6) + "'")
});
$c_ju_MissingFormatArgumentException.prototype.init___T = (function(s) {
  this.s$6 = s;
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  if ((s === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  return this
});
var $d_ju_MissingFormatArgumentException = new $TypeData().initClass({
  ju_MissingFormatArgumentException: 0
}, false, "java.util.MissingFormatArgumentException", {
  ju_MissingFormatArgumentException: 1,
  ju_IllegalFormatException: 1,
  jl_IllegalArgumentException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_ju_MissingFormatArgumentException.prototype.$classData = $d_ju_MissingFormatArgumentException;
/** @constructor */
function $c_ju_MissingFormatWidthException() {
  $c_ju_IllegalFormatException.call(this);
  this.s$6 = null
}
$c_ju_MissingFormatWidthException.prototype = new $h_ju_IllegalFormatException();
$c_ju_MissingFormatWidthException.prototype.constructor = $c_ju_MissingFormatWidthException;
/** @constructor */
function $h_ju_MissingFormatWidthException() {
  /*<skip>*/
}
$h_ju_MissingFormatWidthException.prototype = $c_ju_MissingFormatWidthException.prototype;
$c_ju_MissingFormatWidthException.prototype.getMessage__T = (function() {
  return this.s$6
});
$c_ju_MissingFormatWidthException.prototype.init___T = (function(s) {
  this.s$6 = s;
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  if ((s === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  return this
});
var $d_ju_MissingFormatWidthException = new $TypeData().initClass({
  ju_MissingFormatWidthException: 0
}, false, "java.util.MissingFormatWidthException", {
  ju_MissingFormatWidthException: 1,
  ju_IllegalFormatException: 1,
  jl_IllegalArgumentException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_ju_MissingFormatWidthException.prototype.$classData = $d_ju_MissingFormatWidthException;
/** @constructor */
function $c_ju_UnknownFormatConversionException() {
  $c_ju_IllegalFormatException.call(this);
  this.s$6 = null
}
$c_ju_UnknownFormatConversionException.prototype = new $h_ju_IllegalFormatException();
$c_ju_UnknownFormatConversionException.prototype.constructor = $c_ju_UnknownFormatConversionException;
/** @constructor */
function $h_ju_UnknownFormatConversionException() {
  /*<skip>*/
}
$h_ju_UnknownFormatConversionException.prototype = $c_ju_UnknownFormatConversionException.prototype;
$c_ju_UnknownFormatConversionException.prototype.getMessage__T = (function() {
  return (("Conversion = '" + this.s$6) + "'")
});
$c_ju_UnknownFormatConversionException.prototype.init___T = (function(s) {
  this.s$6 = s;
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  if ((s === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  return this
});
var $d_ju_UnknownFormatConversionException = new $TypeData().initClass({
  ju_UnknownFormatConversionException: 0
}, false, "java.util.UnknownFormatConversionException", {
  ju_UnknownFormatConversionException: 1,
  ju_IllegalFormatException: 1,
  jl_IllegalArgumentException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1
});
$c_ju_UnknownFormatConversionException.prototype.$classData = $d_ju_UnknownFormatConversionException;
/** @constructor */
function $c_s_Tuple2$mcIC$sp() {
  $c_T2.call(this);
  this.$$und1$mcI$sp$f = 0;
  this.$$und2$mcC$sp$f = 0
}
$c_s_Tuple2$mcIC$sp.prototype = new $h_T2();
$c_s_Tuple2$mcIC$sp.prototype.constructor = $c_s_Tuple2$mcIC$sp;
/** @constructor */
function $h_s_Tuple2$mcIC$sp() {
  /*<skip>*/
}
$h_s_Tuple2$mcIC$sp.prototype = $c_s_Tuple2$mcIC$sp.prototype;
$c_s_Tuple2$mcIC$sp.prototype.$$und1$mcI$sp__I = (function() {
  return this.$$und1$mcI$sp$f
});
$c_s_Tuple2$mcIC$sp.prototype.$$und2$mcC$sp__C = (function() {
  return this.$$und2$mcC$sp$f
});
$c_s_Tuple2$mcIC$sp.prototype.init___I__C = (function(_1$mcI$sp, _2$mcC$sp) {
  this.$$und1$mcI$sp$f = _1$mcI$sp;
  this.$$und2$mcC$sp$f = _2$mcC$sp;
  $c_T2.prototype.init___O__O.call(this, null, null);
  return this
});
$c_s_Tuple2$mcIC$sp.prototype.$$und2__O = (function() {
  var c = this.$$und2$mcC$sp$f;
  return new $c_jl_Character().init___C(c)
});
$c_s_Tuple2$mcIC$sp.prototype.$$und1__O = (function() {
  return this.$$und1$mcI$sp$f
});
var $d_s_Tuple2$mcIC$sp = new $TypeData().initClass({
  s_Tuple2$mcIC$sp: 0
}, false, "scala.Tuple2$mcIC$sp", {
  s_Tuple2$mcIC$sp: 1,
  T2: 1,
  O: 1,
  s_Product2: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_Tuple2$mcIC$sp.prototype.$classData = $d_s_Tuple2$mcIC$sp;
/** @constructor */
function $c_s_concurrent_duration_Duration$$anon$1() {
  $c_s_concurrent_duration_Duration$Infinite.call(this)
}
$c_s_concurrent_duration_Duration$$anon$1.prototype = new $h_s_concurrent_duration_Duration$Infinite();
$c_s_concurrent_duration_Duration$$anon$1.prototype.constructor = $c_s_concurrent_duration_Duration$$anon$1;
/** @constructor */
function $h_s_concurrent_duration_Duration$$anon$1() {
  /*<skip>*/
}
$h_s_concurrent_duration_Duration$$anon$1.prototype = $c_s_concurrent_duration_Duration$$anon$1.prototype;
$c_s_concurrent_duration_Duration$$anon$1.prototype.init___ = (function() {
  return this
});
$c_s_concurrent_duration_Duration$$anon$1.prototype.equals__O__Z = (function(other) {
  return false
});
$c_s_concurrent_duration_Duration$$anon$1.prototype.toString__T = (function() {
  return "Duration.Undefined"
});
$c_s_concurrent_duration_Duration$$anon$1.prototype.compare__O__I = (function(that) {
  return this.compare__s_concurrent_duration_Duration__I($as_s_concurrent_duration_Duration(that))
});
$c_s_concurrent_duration_Duration$$anon$1.prototype.compare__s_concurrent_duration_Duration__I = (function(other) {
  return ((other === this) ? 0 : 1)
});
var $d_s_concurrent_duration_Duration$$anon$1 = new $TypeData().initClass({
  s_concurrent_duration_Duration$$anon$1: 0
}, false, "scala.concurrent.duration.Duration$$anon$1", {
  s_concurrent_duration_Duration$$anon$1: 1,
  s_concurrent_duration_Duration$Infinite: 1,
  s_concurrent_duration_Duration: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_math_Ordered: 1,
  jl_Comparable: 1
});
$c_s_concurrent_duration_Duration$$anon$1.prototype.$classData = $d_s_concurrent_duration_Duration$$anon$1;
/** @constructor */
function $c_s_concurrent_duration_Duration$$anon$2() {
  $c_s_concurrent_duration_Duration$Infinite.call(this)
}
$c_s_concurrent_duration_Duration$$anon$2.prototype = new $h_s_concurrent_duration_Duration$Infinite();
$c_s_concurrent_duration_Duration$$anon$2.prototype.constructor = $c_s_concurrent_duration_Duration$$anon$2;
/** @constructor */
function $h_s_concurrent_duration_Duration$$anon$2() {
  /*<skip>*/
}
$h_s_concurrent_duration_Duration$$anon$2.prototype = $c_s_concurrent_duration_Duration$$anon$2.prototype;
$c_s_concurrent_duration_Duration$$anon$2.prototype.init___ = (function() {
  return this
});
$c_s_concurrent_duration_Duration$$anon$2.prototype.toString__T = (function() {
  return "Duration.Inf"
});
$c_s_concurrent_duration_Duration$$anon$2.prototype.compare__O__I = (function(that) {
  return this.compare__s_concurrent_duration_Duration__I($as_s_concurrent_duration_Duration(that))
});
$c_s_concurrent_duration_Duration$$anon$2.prototype.compare__s_concurrent_duration_Duration__I = (function(other) {
  return ((other === $m_s_concurrent_duration_Duration$().Undefined$1) ? (-1) : ((other === this) ? 0 : 1))
});
var $d_s_concurrent_duration_Duration$$anon$2 = new $TypeData().initClass({
  s_concurrent_duration_Duration$$anon$2: 0
}, false, "scala.concurrent.duration.Duration$$anon$2", {
  s_concurrent_duration_Duration$$anon$2: 1,
  s_concurrent_duration_Duration$Infinite: 1,
  s_concurrent_duration_Duration: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_math_Ordered: 1,
  jl_Comparable: 1
});
$c_s_concurrent_duration_Duration$$anon$2.prototype.$classData = $d_s_concurrent_duration_Duration$$anon$2;
/** @constructor */
function $c_s_concurrent_duration_Duration$$anon$3() {
  $c_s_concurrent_duration_Duration$Infinite.call(this)
}
$c_s_concurrent_duration_Duration$$anon$3.prototype = new $h_s_concurrent_duration_Duration$Infinite();
$c_s_concurrent_duration_Duration$$anon$3.prototype.constructor = $c_s_concurrent_duration_Duration$$anon$3;
/** @constructor */
function $h_s_concurrent_duration_Duration$$anon$3() {
  /*<skip>*/
}
$h_s_concurrent_duration_Duration$$anon$3.prototype = $c_s_concurrent_duration_Duration$$anon$3.prototype;
$c_s_concurrent_duration_Duration$$anon$3.prototype.init___ = (function() {
  return this
});
$c_s_concurrent_duration_Duration$$anon$3.prototype.toString__T = (function() {
  return "Duration.MinusInf"
});
$c_s_concurrent_duration_Duration$$anon$3.prototype.compare__O__I = (function(that) {
  return this.compare__s_concurrent_duration_Duration__I($as_s_concurrent_duration_Duration(that))
});
$c_s_concurrent_duration_Duration$$anon$3.prototype.compare__s_concurrent_duration_Duration__I = (function(other) {
  return ((other === this) ? 0 : (-1))
});
var $d_s_concurrent_duration_Duration$$anon$3 = new $TypeData().initClass({
  s_concurrent_duration_Duration$$anon$3: 0
}, false, "scala.concurrent.duration.Duration$$anon$3", {
  s_concurrent_duration_Duration$$anon$3: 1,
  s_concurrent_duration_Duration$Infinite: 1,
  s_concurrent_duration_Duration: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_math_Ordered: 1,
  jl_Comparable: 1
});
$c_s_concurrent_duration_Duration$$anon$3.prototype.$classData = $d_s_concurrent_duration_Duration$$anon$3;
/** @constructor */
function $c_s_math_LowPriorityOrderingImplicits$$anon$3() {
  $c_O.call(this);
  this.evidence$1$1$1 = null
}
$c_s_math_LowPriorityOrderingImplicits$$anon$3.prototype = new $h_O();
$c_s_math_LowPriorityOrderingImplicits$$anon$3.prototype.constructor = $c_s_math_LowPriorityOrderingImplicits$$anon$3;
/** @constructor */
function $h_s_math_LowPriorityOrderingImplicits$$anon$3() {
  /*<skip>*/
}
$h_s_math_LowPriorityOrderingImplicits$$anon$3.prototype = $c_s_math_LowPriorityOrderingImplicits$$anon$3.prototype;
$c_s_math_LowPriorityOrderingImplicits$$anon$3.prototype.init___s_math_LowPriorityOrderingImplicits__F1 = (function($$outer, evidence$1$1) {
  this.evidence$1$1$1 = evidence$1$1;
  return this
});
$c_s_math_LowPriorityOrderingImplicits$$anon$3.prototype.gteq__O__O__Z = (function(x, y) {
  return $f_s_math_Ordering__gteq__O__O__Z(this, x, y)
});
$c_s_math_LowPriorityOrderingImplicits$$anon$3.prototype.compare__O__O__I = (function(x, y) {
  return $comparableCompareTo($as_jl_Comparable(this.evidence$1$1$1.apply__O__O(x)), y)
});
$c_s_math_LowPriorityOrderingImplicits$$anon$3.prototype.lteq__O__O__Z = (function(x, y) {
  return $f_s_math_Ordering__lteq__O__O__Z(this, x, y)
});
var $d_s_math_LowPriorityOrderingImplicits$$anon$3 = new $TypeData().initClass({
  s_math_LowPriorityOrderingImplicits$$anon$3: 0
}, false, "scala.math.LowPriorityOrderingImplicits$$anon$3", {
  s_math_LowPriorityOrderingImplicits$$anon$3: 1,
  O: 1,
  s_math_Ordering: 1,
  ju_Comparator: 1,
  s_math_PartialOrdering: 1,
  s_math_Equiv: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_math_LowPriorityOrderingImplicits$$anon$3.prototype.$classData = $d_s_math_LowPriorityOrderingImplicits$$anon$3;
/** @constructor */
function $c_s_math_Ordering$$anon$2() {
  $c_O.call(this);
  this.$$outer$1 = null;
  this.f$1$1 = null
}
$c_s_math_Ordering$$anon$2.prototype = new $h_O();
$c_s_math_Ordering$$anon$2.prototype.constructor = $c_s_math_Ordering$$anon$2;
/** @constructor */
function $h_s_math_Ordering$$anon$2() {
  /*<skip>*/
}
$h_s_math_Ordering$$anon$2.prototype = $c_s_math_Ordering$$anon$2.prototype;
$c_s_math_Ordering$$anon$2.prototype.gteq__O__O__Z = (function(x, y) {
  return $f_s_math_Ordering__gteq__O__O__Z(this, x, y)
});
$c_s_math_Ordering$$anon$2.prototype.compare__O__O__I = (function(x, y) {
  return this.$$outer$1.compare__O__O__I(this.f$1$1.apply__O__O(x), this.f$1$1.apply__O__O(y))
});
$c_s_math_Ordering$$anon$2.prototype.init___s_math_Ordering__F1 = (function($$outer, f$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  this.f$1$1 = f$1;
  return this
});
$c_s_math_Ordering$$anon$2.prototype.lteq__O__O__Z = (function(x, y) {
  return $f_s_math_Ordering__lteq__O__O__Z(this, x, y)
});
var $d_s_math_Ordering$$anon$2 = new $TypeData().initClass({
  s_math_Ordering$$anon$2: 0
}, false, "scala.math.Ordering$$anon$2", {
  s_math_Ordering$$anon$2: 1,
  O: 1,
  s_math_Ordering: 1,
  ju_Comparator: 1,
  s_math_PartialOrdering: 1,
  s_math_Equiv: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_math_Ordering$$anon$2.prototype.$classData = $d_s_math_Ordering$$anon$2;
/** @constructor */
function $c_s_math_Ordering$$anon$6() {
  $c_O.call(this);
  this.cmp$2$1 = null
}
$c_s_math_Ordering$$anon$6.prototype = new $h_O();
$c_s_math_Ordering$$anon$6.prototype.constructor = $c_s_math_Ordering$$anon$6;
/** @constructor */
function $h_s_math_Ordering$$anon$6() {
  /*<skip>*/
}
$h_s_math_Ordering$$anon$6.prototype = $c_s_math_Ordering$$anon$6.prototype;
$c_s_math_Ordering$$anon$6.prototype.init___F2 = (function(cmp$2) {
  this.cmp$2$1 = cmp$2;
  return this
});
$c_s_math_Ordering$$anon$6.prototype.gteq__O__O__Z = (function(x, y) {
  return (!$uZ(this.cmp$2$1.apply__O__O__O(x, y)))
});
$c_s_math_Ordering$$anon$6.prototype.compare__O__O__I = (function(x, y) {
  return ($uZ(this.cmp$2$1.apply__O__O__O(x, y)) ? (-1) : ($uZ(this.cmp$2$1.apply__O__O__O(y, x)) ? 1 : 0))
});
$c_s_math_Ordering$$anon$6.prototype.lteq__O__O__Z = (function(x, y) {
  return (!$uZ(this.cmp$2$1.apply__O__O__O(y, x)))
});
var $d_s_math_Ordering$$anon$6 = new $TypeData().initClass({
  s_math_Ordering$$anon$6: 0
}, false, "scala.math.Ordering$$anon$6", {
  s_math_Ordering$$anon$6: 1,
  O: 1,
  s_math_Ordering: 1,
  ju_Comparator: 1,
  s_math_PartialOrdering: 1,
  s_math_Equiv: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_math_Ordering$$anon$6.prototype.$classData = $d_s_math_Ordering$$anon$6;
/** @constructor */
function $c_s_reflect_ClassTag$GenericClassTag() {
  $c_O.call(this);
  this.runtimeClass$1 = null
}
$c_s_reflect_ClassTag$GenericClassTag.prototype = new $h_O();
$c_s_reflect_ClassTag$GenericClassTag.prototype.constructor = $c_s_reflect_ClassTag$GenericClassTag;
/** @constructor */
function $h_s_reflect_ClassTag$GenericClassTag() {
  /*<skip>*/
}
$h_s_reflect_ClassTag$GenericClassTag.prototype = $c_s_reflect_ClassTag$GenericClassTag.prototype;
$c_s_reflect_ClassTag$GenericClassTag.prototype.newArray__I__O = (function(len) {
  return $f_s_reflect_ClassTag__newArray__I__O(this, len)
});
$c_s_reflect_ClassTag$GenericClassTag.prototype.equals__O__Z = (function(x) {
  return $f_s_reflect_ClassTag__equals__O__Z(this, x)
});
$c_s_reflect_ClassTag$GenericClassTag.prototype.toString__T = (function() {
  var clazz = this.runtimeClass$1;
  return $f_s_reflect_ClassTag__prettyprint$1__ps_reflect_ClassTag__jl_Class__T(this, clazz)
});
$c_s_reflect_ClassTag$GenericClassTag.prototype.runtimeClass__jl_Class = (function() {
  return this.runtimeClass$1
});
$c_s_reflect_ClassTag$GenericClassTag.prototype.init___jl_Class = (function(runtimeClass) {
  this.runtimeClass$1 = runtimeClass;
  return this
});
$c_s_reflect_ClassTag$GenericClassTag.prototype.hashCode__I = (function() {
  return $m_sr_Statics$().anyHash__O__I(this.runtimeClass$1)
});
var $d_s_reflect_ClassTag$GenericClassTag = new $TypeData().initClass({
  s_reflect_ClassTag$GenericClassTag: 0
}, false, "scala.reflect.ClassTag$GenericClassTag", {
  s_reflect_ClassTag$GenericClassTag: 1,
  O: 1,
  s_reflect_ClassTag: 1,
  s_reflect_ClassManifestDeprecatedApis: 1,
  s_reflect_OptManifest: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_Equals: 1
});
$c_s_reflect_ClassTag$GenericClassTag.prototype.$classData = $d_s_reflect_ClassTag$GenericClassTag;
function $is_sc_GenIterable(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_GenIterable)))
}
function $as_sc_GenIterable(obj) {
  return (($is_sc_GenIterable(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.GenIterable"))
}
function $isArrayOf_sc_GenIterable(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_GenIterable)))
}
function $asArrayOf_sc_GenIterable(obj, depth) {
  return (($isArrayOf_sc_GenIterable(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.GenIterable;", depth))
}
/** @constructor */
function $c_sc_Seq$() {
  $c_scg_SeqFactory.call(this)
}
$c_sc_Seq$.prototype = new $h_scg_SeqFactory();
$c_sc_Seq$.prototype.constructor = $c_sc_Seq$;
/** @constructor */
function $h_sc_Seq$() {
  /*<skip>*/
}
$h_sc_Seq$.prototype = $c_sc_Seq$.prototype;
$c_sc_Seq$.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory.prototype.init___.call(this);
  return this
});
$c_sc_Seq$.prototype.newBuilder__scm_Builder = (function() {
  $m_sci_Seq$();
  return new $c_scm_ListBuffer().init___()
});
var $d_sc_Seq$ = new $TypeData().initClass({
  sc_Seq$: 0
}, false, "scala.collection.Seq$", {
  sc_Seq$: 1,
  scg_SeqFactory: 1,
  scg_GenSeqFactory: 1,
  scg_GenTraversableFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_TraversableFactory: 1,
  scg_GenericSeqCompanion: 1
});
$c_sc_Seq$.prototype.$classData = $d_sc_Seq$;
var $n_sc_Seq$ = (void 0);
function $m_sc_Seq$() {
  if ((!$n_sc_Seq$)) {
    $n_sc_Seq$ = new $c_sc_Seq$().init___()
  };
  return $n_sc_Seq$
}
/** @constructor */
function $c_scg_IndexedSeqFactory() {
  $c_scg_SeqFactory.call(this)
}
$c_scg_IndexedSeqFactory.prototype = new $h_scg_SeqFactory();
$c_scg_IndexedSeqFactory.prototype.constructor = $c_scg_IndexedSeqFactory;
/** @constructor */
function $h_scg_IndexedSeqFactory() {
  /*<skip>*/
}
$h_scg_IndexedSeqFactory.prototype = $c_scg_IndexedSeqFactory.prototype;
/** @constructor */
function $c_sci_HashMap$() {
  $c_scg_ImmutableMapFactory.call(this);
  this.defaultMerger$4 = null
}
$c_sci_HashMap$.prototype = new $h_scg_ImmutableMapFactory();
$c_sci_HashMap$.prototype.constructor = $c_sci_HashMap$;
/** @constructor */
function $h_sci_HashMap$() {
  /*<skip>*/
}
$h_sci_HashMap$.prototype = $c_sci_HashMap$.prototype;
$c_sci_HashMap$.prototype.init___ = (function() {
  $n_sci_HashMap$ = this;
  var mergef = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(a$2, b$2) {
      var a = $as_T2(a$2);
      $as_T2(b$2);
      return a
    })
  })(this));
  this.defaultMerger$4 = new $c_sci_HashMap$$anon$1().init___F2(mergef);
  return this
});
$c_sci_HashMap$.prototype.scala$collection$immutable$HashMap$$makeHashTrieMap__I__sci_HashMap__I__sci_HashMap__I__I__sci_HashMap$HashTrieMap = (function(hash0, elem0, hash1, elem1, level, size) {
  var index0 = (31 & ((hash0 >>> level) | 0));
  var index1 = (31 & ((hash1 >>> level) | 0));
  if ((index0 !== index1)) {
    var bitmap = ((1 << index0) | (1 << index1));
    var elems = $newArrayObject($d_sci_HashMap.getArrayOf(), [2]);
    if ((index0 < index1)) {
      elems.set(0, elem0);
      elems.set(1, elem1)
    } else {
      elems.set(0, elem1);
      elems.set(1, elem0)
    };
    return new $c_sci_HashMap$HashTrieMap().init___I__Asci_HashMap__I(bitmap, elems, size)
  } else {
    var elems$2 = $newArrayObject($d_sci_HashMap.getArrayOf(), [1]);
    var bitmap$2 = (1 << index0);
    elems$2.set(0, this.scala$collection$immutable$HashMap$$makeHashTrieMap__I__sci_HashMap__I__sci_HashMap__I__I__sci_HashMap$HashTrieMap(hash0, elem0, hash1, elem1, ((5 + level) | 0), size));
    return new $c_sci_HashMap$HashTrieMap().init___I__Asci_HashMap__I(bitmap$2, elems$2, size)
  }
});
$c_sci_HashMap$.prototype.scala$collection$immutable$HashMap$$keepBits__I__I__I = (function(bitmap, keep) {
  var result = 0;
  var current = bitmap;
  var kept = keep;
  while ((kept !== 0)) {
    var lsb = (current ^ (current & (((-1) + current) | 0)));
    if (((1 & kept) !== 0)) {
      result = (result | lsb)
    };
    current = (current & (~lsb));
    kept = ((kept >>> 1) | 0)
  };
  return result
});
$c_sci_HashMap$.prototype.empty__sc_GenMap = (function() {
  return $m_sci_HashMap$EmptyHashMap$()
});
var $d_sci_HashMap$ = new $TypeData().initClass({
  sci_HashMap$: 0
}, false, "scala.collection.immutable.HashMap$", {
  sci_HashMap$: 1,
  scg_ImmutableMapFactory: 1,
  scg_MapFactory: 1,
  scg_GenMapFactory: 1,
  O: 1,
  scg_BitOperations$Int: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_HashMap$.prototype.$classData = $d_sci_HashMap$;
var $n_sci_HashMap$ = (void 0);
function $m_sci_HashMap$() {
  if ((!$n_sci_HashMap$)) {
    $n_sci_HashMap$ = new $c_sci_HashMap$().init___()
  };
  return $n_sci_HashMap$
}
/** @constructor */
function $c_sci_Seq$() {
  $c_scg_SeqFactory.call(this)
}
$c_sci_Seq$.prototype = new $h_scg_SeqFactory();
$c_sci_Seq$.prototype.constructor = $c_sci_Seq$;
/** @constructor */
function $h_sci_Seq$() {
  /*<skip>*/
}
$h_sci_Seq$.prototype = $c_sci_Seq$.prototype;
$c_sci_Seq$.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory.prototype.init___.call(this);
  return this
});
$c_sci_Seq$.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_ListBuffer().init___()
});
var $d_sci_Seq$ = new $TypeData().initClass({
  sci_Seq$: 0
}, false, "scala.collection.immutable.Seq$", {
  sci_Seq$: 1,
  scg_SeqFactory: 1,
  scg_GenSeqFactory: 1,
  scg_GenTraversableFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_TraversableFactory: 1,
  scg_GenericSeqCompanion: 1
});
$c_sci_Seq$.prototype.$classData = $d_sci_Seq$;
var $n_sci_Seq$ = (void 0);
function $m_sci_Seq$() {
  if ((!$n_sci_Seq$)) {
    $n_sci_Seq$ = new $c_sci_Seq$().init___()
  };
  return $n_sci_Seq$
}
/** @constructor */
function $c_scm_ArrayBuilder() {
  $c_O.call(this)
}
$c_scm_ArrayBuilder.prototype = new $h_O();
$c_scm_ArrayBuilder.prototype.constructor = $c_scm_ArrayBuilder;
/** @constructor */
function $h_scm_ArrayBuilder() {
  /*<skip>*/
}
$h_scm_ArrayBuilder.prototype = $c_scm_ArrayBuilder.prototype;
$c_scm_ArrayBuilder.prototype.sizeHintBounded__I__sc_TraversableLike__V = (function(size, boundingColl) {
  $f_scm_Builder__sizeHintBounded__I__sc_TraversableLike__V(this, size, boundingColl)
});
$c_scm_ArrayBuilder.prototype.sizeHint__I__V = (function(size) {
  /*<skip>*/
});
$c_scm_ArrayBuilder.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs)
});
/** @constructor */
function $c_scm_IndexedSeq$() {
  $c_scg_SeqFactory.call(this)
}
$c_scm_IndexedSeq$.prototype = new $h_scg_SeqFactory();
$c_scm_IndexedSeq$.prototype.constructor = $c_scm_IndexedSeq$;
/** @constructor */
function $h_scm_IndexedSeq$() {
  /*<skip>*/
}
$h_scm_IndexedSeq$.prototype = $c_scm_IndexedSeq$.prototype;
$c_scm_IndexedSeq$.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory.prototype.init___.call(this);
  return this
});
$c_scm_IndexedSeq$.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_ArrayBuffer().init___()
});
var $d_scm_IndexedSeq$ = new $TypeData().initClass({
  scm_IndexedSeq$: 0
}, false, "scala.collection.mutable.IndexedSeq$", {
  scm_IndexedSeq$: 1,
  scg_SeqFactory: 1,
  scg_GenSeqFactory: 1,
  scg_GenTraversableFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_TraversableFactory: 1,
  scg_GenericSeqCompanion: 1
});
$c_scm_IndexedSeq$.prototype.$classData = $d_scm_IndexedSeq$;
var $n_scm_IndexedSeq$ = (void 0);
function $m_scm_IndexedSeq$() {
  if ((!$n_scm_IndexedSeq$)) {
    $n_scm_IndexedSeq$ = new $c_scm_IndexedSeq$().init___()
  };
  return $n_scm_IndexedSeq$
}
/** @constructor */
function $c_scm_Seq$() {
  $c_scg_SeqFactory.call(this)
}
$c_scm_Seq$.prototype = new $h_scg_SeqFactory();
$c_scm_Seq$.prototype.constructor = $c_scm_Seq$;
/** @constructor */
function $h_scm_Seq$() {
  /*<skip>*/
}
$h_scm_Seq$.prototype = $c_scm_Seq$.prototype;
$c_scm_Seq$.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory.prototype.init___.call(this);
  return this
});
$c_scm_Seq$.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_ArrayBuffer().init___()
});
var $d_scm_Seq$ = new $TypeData().initClass({
  scm_Seq$: 0
}, false, "scala.collection.mutable.Seq$", {
  scm_Seq$: 1,
  scg_SeqFactory: 1,
  scg_GenSeqFactory: 1,
  scg_GenTraversableFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_TraversableFactory: 1,
  scg_GenericSeqCompanion: 1
});
$c_scm_Seq$.prototype.$classData = $d_scm_Seq$;
var $n_scm_Seq$ = (void 0);
function $m_scm_Seq$() {
  if ((!$n_scm_Seq$)) {
    $n_scm_Seq$ = new $c_scm_Seq$().init___()
  };
  return $n_scm_Seq$
}
/** @constructor */
function $c_sjs_js_WrappedArray$() {
  $c_scg_SeqFactory.call(this)
}
$c_sjs_js_WrappedArray$.prototype = new $h_scg_SeqFactory();
$c_sjs_js_WrappedArray$.prototype.constructor = $c_sjs_js_WrappedArray$;
/** @constructor */
function $h_sjs_js_WrappedArray$() {
  /*<skip>*/
}
$h_sjs_js_WrappedArray$.prototype = $c_sjs_js_WrappedArray$.prototype;
$c_sjs_js_WrappedArray$.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory.prototype.init___.call(this);
  return this
});
$c_sjs_js_WrappedArray$.prototype.newBuilder__scm_Builder = (function() {
  return new $c_sjs_js_WrappedArray().init___()
});
var $d_sjs_js_WrappedArray$ = new $TypeData().initClass({
  sjs_js_WrappedArray$: 0
}, false, "scala.scalajs.js.WrappedArray$", {
  sjs_js_WrappedArray$: 1,
  scg_SeqFactory: 1,
  scg_GenSeqFactory: 1,
  scg_GenTraversableFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_TraversableFactory: 1,
  scg_GenericSeqCompanion: 1
});
$c_sjs_js_WrappedArray$.prototype.$classData = $d_sjs_js_WrappedArray$;
var $n_sjs_js_WrappedArray$ = (void 0);
function $m_sjs_js_WrappedArray$() {
  if ((!$n_sjs_js_WrappedArray$)) {
    $n_sjs_js_WrappedArray$ = new $c_sjs_js_WrappedArray$().init___()
  };
  return $n_sjs_js_WrappedArray$
}
/** @constructor */
function $c_Lamf_client_model_AnyField() {
  $c_O.call(this);
  this.amf$client$model$AnyField$$$undinternal$1 = null;
  this.$$undoption$1 = null;
  this.option$1 = null
}
$c_Lamf_client_model_AnyField.prototype = new $h_O();
$c_Lamf_client_model_AnyField.prototype.constructor = $c_Lamf_client_model_AnyField;
/** @constructor */
function $h_Lamf_client_model_AnyField() {
  /*<skip>*/
}
$h_Lamf_client_model_AnyField.prototype = $c_Lamf_client_model_AnyField.prototype;
$c_Lamf_client_model_AnyField.prototype.productPrefix__T = (function() {
  return "AnyField"
});
$c_Lamf_client_model_AnyField.prototype.$$js$exported$meth$is__O__O = (function(other) {
  return $f_Lamf_client_model_ValueField__is__O__Z(this, other)
});
$c_Lamf_client_model_AnyField.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_AnyField.prototype.init___Lamf_core_model_AnyField = (function(_internal) {
  this.amf$client$model$AnyField$$$undinternal$1 = _internal;
  this.$$undoption$1 = _internal.option$1;
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undoption$1;
  var m = $m_Lamf_client_convert_CoreClientConverters$().AnyMatcher__Lamf_client_convert_CoreBaseConverter$AnyMatcher$();
  this.option$1 = new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O();
  return this
});
$c_Lamf_client_model_AnyField.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_AnyField)) {
    var AnyField$1 = $as_Lamf_client_model_AnyField(x$1);
    var x = this.amf$client$model$AnyField$$$undinternal$1;
    var x$2 = AnyField$1.amf$client$model$AnyField$$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_AnyField.prototype.$$js$exported$meth$toString__O = (function() {
  return $f_Lamf_client_model_ValueField__toString__T(this)
});
$c_Lamf_client_model_AnyField.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.amf$client$model$AnyField$$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_AnyField.prototype.toString__T = (function() {
  return $f_Lamf_client_model_ValueField__toString__T(this)
});
$c_Lamf_client_model_AnyField.prototype.$$js$exported$prop$nonNull__O = (function() {
  return this.$$undoption$1.isDefined__Z()
});
$c_Lamf_client_model_AnyField.prototype.annotations__Lamf_client_model_Annotations = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.amf$client$model$AnyField$$$undinternal$1.annotations$1;
  $m_Lamf_client_convert_CoreClientConverters$().AnnotationsFieldMatcher__Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$();
  return new $c_Lamf_client_model_Annotations().init___Lamf_core_parser_Annotations(from)
});
$c_Lamf_client_model_AnyField.prototype.$$js$exported$meth$value__O = (function() {
  var this$1 = this.$$undoption$1;
  return (this$1.isEmpty__Z() ? null : this$1.get__O())
});
$c_Lamf_client_model_AnyField.prototype.$$js$exported$meth$annotations__O = (function() {
  return this.annotations__Lamf_client_model_Annotations()
});
$c_Lamf_client_model_AnyField.prototype.$$js$exported$meth$is__F1__O = (function(accepts) {
  return $f_Lamf_client_model_ValueField__is__F1__Z(this, accepts)
});
$c_Lamf_client_model_AnyField.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_AnyField.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_AnyField.prototype.$$js$exported$prop$option__O = (function() {
  return this.option$1
});
$c_Lamf_client_model_AnyField.prototype.$$js$exported$prop$isNull__O = (function() {
  return this.$$undoption$1.isEmpty__Z()
});
$c_Lamf_client_model_AnyField.prototype.$$js$exported$meth$remove__O = (function() {
  var this$1 = this.amf$client$model$AnyField$$$undinternal$1;
  this$1.$$outer$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields(this$1.field$1)
});
$c_Lamf_client_model_AnyField.prototype.$$undoption__s_Option = (function() {
  return this.$$undoption$1
});
$c_Lamf_client_model_AnyField.prototype.toString = (function() {
  return this.$$js$exported$meth$toString__O()
});
Object.defineProperty($c_Lamf_client_model_AnyField.prototype, "nonNull", {
  "get": (function() {
    return this.$$js$exported$prop$nonNull__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_AnyField.prototype, "isNull", {
  "get": (function() {
    return this.$$js$exported$prop$isNull__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_AnyField.prototype.is = (function(arg) {
  if ($is_F1(arg)) {
    var prep$2 = $as_F1(arg);
    return this.$$js$exported$meth$is__F1__O(prep$2)
  } else {
    var prep = arg;
    return this.$$js$exported$meth$is__O__O(prep)
  }
});
$c_Lamf_client_model_AnyField.prototype.remove = (function() {
  return this.$$js$exported$meth$remove__O()
});
$c_Lamf_client_model_AnyField.prototype.value = (function() {
  return this.$$js$exported$meth$value__O()
});
$c_Lamf_client_model_AnyField.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
Object.defineProperty($c_Lamf_client_model_AnyField.prototype, "option", {
  "get": (function() {
    return this.$$js$exported$prop$option__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_AnyField(obj) {
  return (((obj instanceof $c_Lamf_client_model_AnyField) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.AnyField"))
}
function $isArrayOf_Lamf_client_model_AnyField(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_AnyField)))
}
function $asArrayOf_Lamf_client_model_AnyField(obj, depth) {
  return (($isArrayOf_Lamf_client_model_AnyField(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.AnyField;", depth))
}
var $d_Lamf_client_model_AnyField = new $TypeData().initClass({
  Lamf_client_model_AnyField: 0
}, false, "amf.client.model.AnyField", {
  Lamf_client_model_AnyField: 1,
  O: 1,
  Lamf_client_model_BaseField: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_client_model_ValueField: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_AnyField.prototype.$classData = $d_Lamf_client_model_AnyField;
/** @constructor */
function $c_Lamf_client_model_StrField() {
  $c_O.call(this);
  this.amf$client$model$StrField$$$undinternal$1 = null;
  this.$$undoption$1 = null;
  this.option$1 = null
}
$c_Lamf_client_model_StrField.prototype = new $h_O();
$c_Lamf_client_model_StrField.prototype.constructor = $c_Lamf_client_model_StrField;
/** @constructor */
function $h_Lamf_client_model_StrField() {
  /*<skip>*/
}
$h_Lamf_client_model_StrField.prototype = $c_Lamf_client_model_StrField.prototype;
$c_Lamf_client_model_StrField.prototype.productPrefix__T = (function() {
  return "StrField"
});
$c_Lamf_client_model_StrField.prototype.$$js$exported$meth$is__O__O = (function(other) {
  return $f_Lamf_client_model_ValueField__is__O__Z(this, other)
});
$c_Lamf_client_model_StrField.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_StrField.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_StrField)) {
    var StrField$1 = $as_Lamf_client_model_StrField(x$1);
    var x = this.amf$client$model$StrField$$$undinternal$1;
    var x$2 = StrField$1.amf$client$model$StrField$$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_StrField.prototype.$$js$exported$meth$toString__O = (function() {
  return $f_Lamf_client_model_ValueField__toString__T(this)
});
$c_Lamf_client_model_StrField.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.amf$client$model$StrField$$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_StrField.prototype.isNullOrEmpty__Z = (function() {
  var this$1 = this.$$undoption$1;
  if (this$1.isEmpty__Z()) {
    return true
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_T(arg1);
    if ((x$1 === null)) {
      throw new $c_jl_NullPointerException().init___()
    };
    return (x$1 === "")
  }
});
$c_Lamf_client_model_StrField.prototype.toString__T = (function() {
  return $f_Lamf_client_model_ValueField__toString__T(this)
});
$c_Lamf_client_model_StrField.prototype.$$js$exported$prop$nonNull__O = (function() {
  return this.$$undoption$1.isDefined__Z()
});
$c_Lamf_client_model_StrField.prototype.annotations__Lamf_client_model_Annotations = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.amf$client$model$StrField$$$undinternal$1.annotations$1;
  $m_Lamf_client_convert_CoreClientConverters$().AnnotationsFieldMatcher__Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$();
  return new $c_Lamf_client_model_Annotations().init___Lamf_core_parser_Annotations(from)
});
$c_Lamf_client_model_StrField.prototype.$$js$exported$prop$nonEmpty__O = (function() {
  return this.nonEmpty__Z()
});
$c_Lamf_client_model_StrField.prototype.$$js$exported$meth$value__O = (function() {
  var this$1 = this.$$undoption$1;
  return $as_T((this$1.isEmpty__Z() ? null : this$1.get__O()))
});
$c_Lamf_client_model_StrField.prototype.$$js$exported$meth$annotations__O = (function() {
  return this.annotations__Lamf_client_model_Annotations()
});
$c_Lamf_client_model_StrField.prototype.$$js$exported$meth$is__F1__O = (function(accepts) {
  return $f_Lamf_client_model_ValueField__is__F1__Z(this, accepts)
});
$c_Lamf_client_model_StrField.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_StrField.prototype.init___Lamf_core_model_StrField = (function(_internal) {
  this.amf$client$model$StrField$$$undinternal$1 = _internal;
  this.$$undoption$1 = _internal.option$1;
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undoption$1;
  var m = $m_Lamf_client_convert_CoreClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  this.option$1 = new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O();
  return this
});
$c_Lamf_client_model_StrField.prototype.$$js$exported$prop$isNullOrEmpty__O = (function() {
  return this.isNullOrEmpty__Z()
});
$c_Lamf_client_model_StrField.prototype.$$js$exported$prop$option__O = (function() {
  return this.option$1
});
$c_Lamf_client_model_StrField.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_StrField.prototype.nonEmpty__Z = (function() {
  return (!this.isNullOrEmpty__Z())
});
$c_Lamf_client_model_StrField.prototype.$$js$exported$prop$isNull__O = (function() {
  return this.$$undoption$1.isEmpty__Z()
});
$c_Lamf_client_model_StrField.prototype.$$js$exported$meth$remove__O = (function() {
  var this$1 = this.amf$client$model$StrField$$$undinternal$1;
  this$1.$$outer$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields(this$1.field$1)
});
$c_Lamf_client_model_StrField.prototype.$$undoption__s_Option = (function() {
  return this.$$undoption$1
});
$c_Lamf_client_model_StrField.prototype.toString = (function() {
  return this.$$js$exported$meth$toString__O()
});
Object.defineProperty($c_Lamf_client_model_StrField.prototype, "nonNull", {
  "get": (function() {
    return this.$$js$exported$prop$nonNull__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_StrField.prototype, "isNull", {
  "get": (function() {
    return this.$$js$exported$prop$isNull__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_StrField.prototype.is = (function(arg) {
  if ($is_F1(arg)) {
    var prep$2 = $as_F1(arg);
    return this.$$js$exported$meth$is__F1__O(prep$2)
  } else {
    var prep = arg;
    return this.$$js$exported$meth$is__O__O(prep)
  }
});
$c_Lamf_client_model_StrField.prototype.remove = (function() {
  return this.$$js$exported$meth$remove__O()
});
Object.defineProperty($c_Lamf_client_model_StrField.prototype, "nonEmpty", {
  "get": (function() {
    return this.$$js$exported$prop$nonEmpty__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_StrField.prototype, "isNullOrEmpty", {
  "get": (function() {
    return this.$$js$exported$prop$isNullOrEmpty__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_StrField.prototype.value = (function() {
  return this.$$js$exported$meth$value__O()
});
$c_Lamf_client_model_StrField.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
Object.defineProperty($c_Lamf_client_model_StrField.prototype, "option", {
  "get": (function() {
    return this.$$js$exported$prop$option__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_StrField(obj) {
  return (((obj instanceof $c_Lamf_client_model_StrField) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.StrField"))
}
function $isArrayOf_Lamf_client_model_StrField(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_StrField)))
}
function $asArrayOf_Lamf_client_model_StrField(obj, depth) {
  return (($isArrayOf_Lamf_client_model_StrField(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.StrField;", depth))
}
var $d_Lamf_client_model_StrField = new $TypeData().initClass({
  Lamf_client_model_StrField: 0
}, false, "amf.client.model.StrField", {
  Lamf_client_model_StrField: 1,
  O: 1,
  Lamf_client_model_BaseField: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_client_model_ValueField: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_StrField.prototype.$classData = $d_Lamf_client_model_StrField;
/** @constructor */
function $c_Lamf_client_model_domain_AnyShape() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_AnyShape.prototype = new $h_O();
$c_Lamf_client_model_domain_AnyShape.prototype.constructor = $c_Lamf_client_model_domain_AnyShape;
/** @constructor */
function $h_Lamf_client_model_domain_AnyShape() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_AnyShape.prototype = $c_Lamf_client_model_domain_AnyShape.prototype;
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withOr__sjs_js_Array__O = (function(subShapes) {
  return $f_Lamf_client_model_domain_Shape__withOr__sjs_js_Array__Lamf_client_model_domain_Shape(this, subShapes)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$parameterValidator__T__Lamf_client_environment_Environment__O = (function(mediaType, env) {
  return this.parameterValidator__T__Lamf_client_environment_Environment__sjs_js_UndefOr(mediaType, env)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$xone__O = (function() {
  return $f_Lamf_client_model_domain_Shape__xone__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$buildRamlDatatype__Lamf_client_execution_BaseExecutionEnvironment__O = (function(exec) {
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  return $f_Lamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer__generateRamlDatatype__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_client_execution_BaseExecutionEnvironment__T(this$1, this$1, exec)
});
$c_Lamf_client_model_domain_AnyShape.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_AnyShape.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape.call(this, new $c_Lamf_plugins_domain_shapes_models_AnyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$deprecated__O = (function() {
  return $f_Lamf_client_model_domain_Shape__deprecated__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withWriteOnly__Z__O = (function(writeOnly) {
  return $f_Lamf_client_model_domain_Shape__withWriteOnly__Z__Lamf_client_model_domain_Shape(this, writeOnly)
});
$c_Lamf_client_model_domain_AnyShape.prototype.buildJsonSchema__Lamf_client_render_ShapeRenderOptions__Lamf_client_execution_BaseExecutionEnvironment__T = (function(options, exec) {
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var options$1 = $m_Lamf_core_emitter_ShapeRenderOptions$().apply__Lamf_client_render_ShapeRenderOptions__Lamf_core_emitter_ShapeRenderOptions(options);
  return $f_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer__generateJsonSchema__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_ShapeRenderOptions__Lamf_client_execution_BaseExecutionEnvironment__T(this$1, this$1, options$1, exec)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$buildJsonSchema__Lamf_client_execution_BaseExecutionEnvironment__O = (function(exec) {
  return this.buildJsonSchema__Lamf_client_execution_BaseExecutionEnvironment__T(exec)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$undinternal__Lamf_core_model_domain_Shape = (function() {
  return this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape()
});
$c_Lamf_client_model_domain_AnyShape.prototype.documentation__Lamf_client_model_domain_CreativeWork = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var from = $as_Lamf_plugins_domain_shapes_models_CreativeWork(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Documentation$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().CreativeWorkMatcher__Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_client_model_domain_CreativeWork(from)
});
$c_Lamf_client_model_domain_AnyShape.prototype.buildJsonSchema__Lamf_client_execution_BaseExecutionEnvironment__T = (function(exec) {
  this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var x$2 = new $c_Lamf_core_emitter_ShapeRenderOptions().init___();
  var this$3 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  return $f_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer__generateJsonSchema__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_ShapeRenderOptions__Lamf_client_execution_BaseExecutionEnvironment__T(this$3, this$3, x$2, exec)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$buildRamlDatatype__O = (function() {
  return this.buildRamlDatatype__T()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$displayName__O = (function() {
  return $f_Lamf_client_model_domain_Shape__displayName__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withCustomShapePropertyDefinition__T__O = (function(name) {
  return $f_Lamf_client_model_domain_Shape__withCustomShapePropertyDefinition__T__Lamf_client_model_domain_PropertyShape(this, name)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$name__O = (function() {
  return $f_Lamf_client_model_domain_Shape__name__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.comment__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var from = $as_Lamf_core_model_StrField(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Comment$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$examples__O = (function() {
  return this.examples__sjs_js_Array()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$validate__T__Lamf_client_environment_Environment__O = (function(payload, env) {
  return this.validate__T__Lamf_client_environment_Environment__sjs_js_Promise(payload, env)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$elseShape__O = (function() {
  return $f_Lamf_client_model_domain_Shape__elseShape__Lamf_client_model_domain_Shape(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$buildJsonSchema__Lamf_client_render_ShapeRenderOptions__O = (function(options) {
  return this.buildJsonSchema__Lamf_client_render_ShapeRenderOptions__T(options)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_AnyShape.prototype.examples__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var from = $as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ExampleMatcher__Lamf_client_convert_ExampleConverter$ExampleMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.trackedExample__T__sjs_js_UndefOr = (function(trackId) {
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape().trackedExample__T__s_Option(trackId);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ExampleMatcher__Lamf_client_convert_ExampleConverter$ExampleMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withXone__sjs_js_Array__O = (function(subShapes) {
  return $f_Lamf_client_model_domain_Shape__withXone__sjs_js_Array__Lamf_client_model_domain_Shape(this, subShapes)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withAnd__sjs_js_Array__O = (function(subShapes) {
  return $f_Lamf_client_model_domain_Shape__withAnd__sjs_js_Array__Lamf_client_model_domain_Shape(this, subShapes)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape()
});
$c_Lamf_client_model_domain_AnyShape.prototype.parameterValidator__T__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_UndefOr = (function(mediaType, exec) {
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape().parameterValidator__T__Lamf_client_execution_BaseExecutionEnvironment__s_Option(mediaType, exec);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PayloadValidatorMatcher__Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$validate__Lamf_client_model_document_PayloadFragment__Lamf_client_environment_Environment__O = (function(fragment, env) {
  return this.validate__Lamf_client_model_document_PayloadFragment__Lamf_client_environment_Environment__sjs_js_Promise(fragment, env)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withComment__T__Lamf_client_model_domain_AnyShape = (function(comment) {
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var field = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Comment$1;
  $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, comment));
  return this
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withCustomShapeProperties__sjs_js_Array__O = (function(customShapeProperties) {
  return $f_Lamf_client_model_domain_Shape__withCustomShapeProperties__sjs_js_Array__Lamf_client_model_domain_Shape(this, customShapeProperties)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$trackedExample__T__O = (function(trackId) {
  return this.trackedExample__T__sjs_js_UndefOr(trackId)
});
$c_Lamf_client_model_domain_AnyShape.prototype.parameterValidator__T__sjs_js_UndefOr = (function(mediaType) {
  var this$3 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$2 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var env = $m_Lamf_internal_environment_Environment$().apply__Lamf_internal_environment_Environment();
  var from = $m_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$().payloadValidator__Lamf_core_model_domain_Shape__T__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__s_Option(this$2, mediaType, env, $m_Lamf_client_plugins_ScalarRelaxedValidationMode$());
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PayloadValidatorMatcher__Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$3, from, m).asClient__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$or__O = (function() {
  return $f_Lamf_client_model_domain_Shape__or__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.validate__Lamf_client_model_document_PayloadFragment__sjs_js_Promise = (function(fragment) {
  var this$1 = this.platform$1;
  var this$2 = this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  var executionEnvironment = this$2.$$undinternal$1.context$1;
  var this$3 = $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape().validate__Lamf_core_model_document_PayloadFragment__s_concurrent_Future($as_Lamf_core_model_document_PayloadFragment(fragment.$$undinternal$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$();
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$3, from, m, executionEnvironment).asClient__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withExamples__sjs_js_Array__O = (function(examples) {
  return this.withExamples__sjs_js_Array__Lamf_client_model_domain_AnyShape(examples)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withXMLSerialization__Lamf_client_model_domain_XMLSerializer__Lamf_client_model_domain_AnyShape = (function(xmlSerialization) {
  var this$2 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().XMLSerializerMatcher__Lamf_client_convert_XMLSerializerConverter$XMLSerializerMatcher$();
  var xmlSerialization$1 = xmlSerialization.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().XMLSerialization$1;
  $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, xmlSerialization$1));
  return this
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withThen__Lamf_client_model_domain_Shape__O = (function(thenShape) {
  return $f_Lamf_client_model_domain_Shape__withThen__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Shape(this, thenShape)
});
$c_Lamf_client_model_domain_AnyShape.prototype.validate__T__sjs_js_Promise = (function(payload) {
  var this$1 = this.platform$1;
  var this$2 = this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  var executionEnvironment = this$2.$$undinternal$1.context$1;
  var this$3 = $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape().validate__T__s_concurrent_Future(payload);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$();
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$3, from, m, executionEnvironment).asClient__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withReadOnly__Z__O = (function(readOnly) {
  return $f_Lamf_client_model_domain_Shape__withReadOnly__Z__Lamf_client_model_domain_Shape(this, readOnly)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$parameterValidator__T__Lamf_client_execution_BaseExecutionEnvironment__O = (function(mediaType, exec) {
  return this.parameterValidator__T__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_UndefOr(mediaType, exec)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withComment__T__O = (function(comment) {
  return this.withComment__T__Lamf_client_model_domain_AnyShape(comment)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withElse__Lamf_client_model_domain_Shape__O = (function(elseShape) {
  return $f_Lamf_client_model_domain_Shape__withElse__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Shape(this, elseShape)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$validate__T__Lamf_client_execution_BaseExecutionEnvironment__O = (function(payload, exec) {
  return this.validate__T__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise(payload, exec)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$values__O = (function() {
  return $f_Lamf_client_model_domain_Shape__values__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withNode__Lamf_client_model_domain_Shape__O = (function(shape) {
  return $f_Lamf_client_model_domain_Shape__withNode__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Shape(this, shape)
});
$c_Lamf_client_model_domain_AnyShape.prototype.toJsonSchema__T = (function() {
  var this$3 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var this$2 = this$1.platform$2;
  var exec = this$2.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  return $f_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer__toJsonSchema__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_client_execution_BaseExecutionEnvironment__T(this$3, this$3, exec)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withCustomShapePropertyDefinitions__sjs_js_Array__O = (function(propertyDefinitions) {
  return $f_Lamf_client_model_domain_Shape__withCustomShapePropertyDefinitions__sjs_js_Array__Lamf_client_model_domain_Shape(this, propertyDefinitions)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$defaultValueStr__O = (function() {
  return $f_Lamf_client_model_domain_Shape__defaultValueStr__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.payloadValidator__T__sjs_js_UndefOr = (function(mediaType) {
  var this$3 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$2 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var env = $m_Lamf_internal_environment_Environment$().apply__Lamf_internal_environment_Environment();
  var from = $m_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$().payloadValidator__Lamf_core_model_domain_Shape__T__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__s_Option(this$2, mediaType, env, $m_Lamf_client_plugins_StrictValidationMode$());
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PayloadValidatorMatcher__Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$3, from, m).asClient__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.payloadValidator__T__Lamf_client_environment_Environment__sjs_js_UndefOr = (function(mediaType, env) {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var env$1 = env.$$undinternal$1;
  var from = $m_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$().payloadValidator__Lamf_core_model_domain_Shape__T__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__s_Option(this$1, mediaType, env$1, $m_Lamf_client_plugins_StrictValidationMode$());
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PayloadValidatorMatcher__Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withDefaultValue__Lamf_client_model_domain_DataNode__O = (function($default) {
  return $f_Lamf_client_model_domain_Shape__withDefaultValue__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_Shape(this, $default)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$validateParameter__T__Lamf_client_execution_BaseExecutionEnvironment__O = (function(payload, exec) {
  return this.validateParameter__T__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise(payload, exec)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$validate__T__O = (function(payload) {
  return this.validate__T__sjs_js_Promise(payload)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withDocumentation__Lamf_client_model_domain_CreativeWork__Lamf_client_model_domain_AnyShape = (function(documentation) {
  var this$2 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().CreativeWorkMatcher__Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$();
  var documentation$1 = documentation.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Documentation$1;
  $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, documentation$1));
  return this
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withIf__Lamf_client_model_domain_Shape__O = (function(ifShape) {
  return $f_Lamf_client_model_domain_Shape__withIf__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Shape(this, ifShape)
});
$c_Lamf_client_model_domain_AnyShape.prototype.validate__T__Lamf_client_environment_Environment__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise = (function(payload, env, exec) {
  var executionEnvironment = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var env$1 = env.$$undinternal$1;
  var from = $m_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$().validateWithGuessing__Lamf_core_model_domain_Shape__T__T__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(this$1, payload, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, env$1, $m_Lamf_client_plugins_StrictValidationMode$(), exec);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$();
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$2, from, m, executionEnvironment).asClient__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withExample__T__O = (function(mediaType) {
  return this.withExample__T__Lamf_client_model_domain_Example(mediaType)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$documentation__O = (function() {
  return this.documentation__Lamf_client_model_domain_CreativeWork()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$isDefaultEmpty__O = (function() {
  return this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape().isDefaultEmpty__Z()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$payloadValidator__T__O = (function(mediaType) {
  return this.payloadValidator__T__sjs_js_UndefOr(mediaType)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$inherits__O = (function() {
  return $f_Lamf_client_model_domain_Shape__inherits__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.validate__Lamf_client_model_document_PayloadFragment__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise = (function(fragment, exec) {
  var executionEnvironment = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape().validate__Lamf_core_model_document_PayloadFragment__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future($as_Lamf_core_model_document_PayloadFragment(fragment.$$undinternal$1), exec);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$();
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$1, from, m, executionEnvironment).asClient__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$validate__Lamf_client_model_document_PayloadFragment__Lamf_client_environment_Environment__Lamf_client_execution_BaseExecutionEnvironment__O = (function(fragment, env, exec) {
  return this.validate__Lamf_client_model_document_PayloadFragment__Lamf_client_environment_Environment__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise(fragment, env, exec)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withDisplayName__T__O = (function(name) {
  return $f_Lamf_client_model_domain_Shape__withDisplayName__T__Lamf_client_model_domain_Shape(this, name)
});
$c_Lamf_client_model_domain_AnyShape.prototype.validateParameter__T__sjs_js_Promise = (function(payload) {
  var this$1 = this.platform$1;
  var this$2 = this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  var executionEnvironment = this$2.$$undinternal$1.context$1;
  var this$7 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$6 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var env = $m_Lamf_internal_environment_Environment$().apply__Lamf_internal_environment_Environment();
  var this$4 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var this$5 = this$4.platform$2;
  var exec = this$5.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  var from = $m_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$().validateWithGuessing__Lamf_core_model_domain_Shape__T__T__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(this$6, payload, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, env, $m_Lamf_client_plugins_ScalarRelaxedValidationMode$(), exec);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$();
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$7, from, m, executionEnvironment).asClient__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withDocumentation__Lamf_client_model_domain_CreativeWork__O = (function(documentation) {
  return this.withDocumentation__Lamf_client_model_domain_CreativeWork__Lamf_client_model_domain_AnyShape(documentation)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$toRamlDatatype__Lamf_client_execution_BaseExecutionEnvironment__O = (function(exec) {
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  return $f_Lamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer__toRamlDatatype__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_client_execution_BaseExecutionEnvironment__T(this$1, this$1, exec)
});
$c_Lamf_client_model_domain_AnyShape.prototype.parameterValidator__T__Lamf_client_environment_Environment__sjs_js_UndefOr = (function(mediaType, env) {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var env$1 = env.$$undinternal$1;
  var from = $m_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$().payloadValidator__Lamf_core_model_domain_Shape__T__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__s_Option(this$1, mediaType, env$1, $m_Lamf_client_plugins_ScalarRelaxedValidationMode$());
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PayloadValidatorMatcher__Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$toRamlDatatype__O = (function() {
  return this.toRamlDatatype__T()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$thenShape__O = (function() {
  return $f_Lamf_client_model_domain_Shape__thenShape__Lamf_client_model_domain_Shape(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$and__O = (function() {
  return $f_Lamf_client_model_domain_Shape__and__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$readOnly__O = (function() {
  return $f_Lamf_client_model_domain_Shape__readOnly__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.validate__Lamf_client_model_document_PayloadFragment__Lamf_client_environment_Environment__sjs_js_Promise = (function(fragment, env) {
  var this$1 = this.platform$1;
  var this$2 = this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  var executionEnvironment = this$2.$$undinternal$1.context$1;
  var this$3 = $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape().validate__Lamf_core_model_document_PayloadFragment__Lamf_internal_environment_Environment__s_concurrent_Future($as_Lamf_core_model_document_PayloadFragment(fragment.$$undinternal$1), env.$$undinternal$1);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$();
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$3, from, m, executionEnvironment).asClient__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$validateParameter__T__Lamf_client_environment_Environment__Lamf_client_execution_BaseExecutionEnvironment__O = (function(payload, env, exec) {
  return this.validateParameter__T__Lamf_client_environment_Environment__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise(payload, env, exec)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_AnyShape()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$validateParameter__T__Lamf_client_environment_Environment__O = (function(payload, env) {
  return this.validateParameter__T__Lamf_client_environment_Environment__sjs_js_Promise(payload, env)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$toJsonSchema__O = (function() {
  return this.toJsonSchema__T()
});
$c_Lamf_client_model_domain_AnyShape.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_AnyShape()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$comment__O = (function() {
  return this.comment__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withXMLSerialization__Lamf_client_model_domain_XMLSerializer__O = (function(xmlSerialization) {
  return this.withXMLSerialization__Lamf_client_model_domain_XMLSerializer__Lamf_client_model_domain_AnyShape(xmlSerialization)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$xmlSerialization__O = (function() {
  return this.xmlSerialization__Lamf_client_model_domain_XMLSerializer()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withDescription__T__O = (function(description) {
  return $f_Lamf_client_model_domain_Shape__withDescription__T__Lamf_client_model_domain_Shape(this, description)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$customShapeProperties__O = (function() {
  return $f_Lamf_client_model_domain_Shape__customShapeProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$toJsonSchema__Lamf_client_execution_BaseExecutionEnvironment__O = (function(exec) {
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  return $f_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer__toJsonSchema__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_client_execution_BaseExecutionEnvironment__T(this$1, this$1, exec)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$customShapePropertyDefinitions__O = (function() {
  return $f_Lamf_client_model_domain_Shape__customShapePropertyDefinitions__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.validate__T__Lamf_client_environment_Environment__sjs_js_Promise = (function(payload, env) {
  var this$1 = this.platform$1;
  var this$2 = this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  var executionEnvironment = this$2.$$undinternal$1.context$1;
  var this$3 = $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape().validate__T__Lamf_internal_environment_Environment__s_concurrent_Future(payload, env.$$undinternal$1);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$();
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$3, from, m, executionEnvironment).asClient__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_AnyShape.prototype.validateParameter__T__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise = (function(payload, exec) {
  var executionEnvironment = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape().validateParameter__T__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(payload, exec);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$();
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$1, from, m, executionEnvironment).asClient__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$validateParameter__T__O = (function(payload) {
  return this.validateParameter__T__sjs_js_Promise(payload)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal__Lamf_core_model_domain_DomainElement().id__T()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape()
});
$c_Lamf_client_model_domain_AnyShape.prototype.toRamlDatatype__T = (function() {
  var this$3 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var this$2 = this$1.platform$2;
  var exec = this$2.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  return $f_Lamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer__toRamlDatatype__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_client_execution_BaseExecutionEnvironment__T(this$3, this$3, exec)
});
$c_Lamf_client_model_domain_AnyShape.prototype.buildRamlDatatype__T = (function() {
  var this$3 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var this$2 = this$1.platform$2;
  var exec = this$2.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  return $f_Lamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer__generateRamlDatatype__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_client_execution_BaseExecutionEnvironment__T(this$3, this$3, exec)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$description__O = (function() {
  return $f_Lamf_client_model_domain_Shape__description__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$writeOnly__O = (function() {
  return $f_Lamf_client_model_domain_Shape__writeOnly__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$buildJsonSchema__Lamf_client_render_ShapeRenderOptions__Lamf_client_execution_BaseExecutionEnvironment__O = (function(options, exec) {
  return this.buildJsonSchema__Lamf_client_render_ShapeRenderOptions__Lamf_client_execution_BaseExecutionEnvironment__T(options, exec)
});
$c_Lamf_client_model_domain_AnyShape.prototype.buildJsonSchema__T = (function() {
  var this$5 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var options = new $c_Lamf_core_emitter_ShapeRenderOptions().init___();
  var this$3 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var this$4 = this$3.platform$2;
  var exec = this$4.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  return $f_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer__generateJsonSchema__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_ShapeRenderOptions__Lamf_client_execution_BaseExecutionEnvironment__T(this$5, this$5, options, exec)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$validate__Lamf_client_model_document_PayloadFragment__O = (function(fragment) {
  return this.validate__Lamf_client_model_document_PayloadFragment__sjs_js_Promise(fragment)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withExamples__sjs_js_Array__Lamf_client_model_domain_AnyShape = (function(examples) {
  var this$2 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ExampleMatcher__Lamf_client_convert_ExampleConverter$ExampleMatcher$();
  var examples$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, examples, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1;
  $as_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, examples$1));
  return this
});
$c_Lamf_client_model_domain_AnyShape.prototype.validate__Lamf_client_model_document_PayloadFragment__Lamf_client_environment_Environment__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise = (function(fragment, env, exec) {
  var executionEnvironment = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape().validate__Lamf_core_model_document_PayloadFragment__Lamf_internal_environment_Environment__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future($as_Lamf_core_model_document_PayloadFragment(fragment.$$undinternal$1), env.$$undinternal$1, exec);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$();
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$1, from, m, executionEnvironment).asClient__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$validate__T__Lamf_client_environment_Environment__Lamf_client_execution_BaseExecutionEnvironment__O = (function(payload, env, exec) {
  return this.validate__T__Lamf_client_environment_Environment__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise(payload, env, exec)
});
$c_Lamf_client_model_domain_AnyShape.prototype.linkCopy__Lamf_client_model_domain_AnyShape = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape().linkCopy__Lamf_plugins_domain_shapes_models_AnyShape();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().AnyShapeMatcher__Lamf_client_convert_AnyShapeConverter$AnyShapeMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_client_model_domain_AnyShape(from)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return $f_Lamf_client_model_domain_Shape__withName__T__Lamf_client_model_domain_Shape(this, name)
});
$c_Lamf_client_model_domain_AnyShape.prototype.validateParameter__T__Lamf_client_environment_Environment__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise = (function(payload, env, exec) {
  var executionEnvironment = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var env$1 = env.$$undinternal$1;
  var from = $m_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$().validateWithGuessing__Lamf_core_model_domain_Shape__T__T__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(this$1, payload, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, env$1, $m_Lamf_client_plugins_ScalarRelaxedValidationMode$(), exec);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$();
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$2, from, m, executionEnvironment).asClient__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withInherits__sjs_js_Array__O = (function(inherits) {
  return $f_Lamf_client_model_domain_Shape__withInherits__sjs_js_Array__Lamf_client_model_domain_Shape(this, inherits)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$not__O = (function() {
  return $f_Lamf_client_model_domain_Shape__not__Lamf_client_model_domain_Shape(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.xmlSerialization__Lamf_client_model_domain_XMLSerializer = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var from = $as_Lamf_plugins_domain_shapes_models_XMLSerializer(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().XMLSerialization$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().XMLSerializerMatcher__Lamf_client_convert_XMLSerializerConverter$XMLSerializerMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_XMLSerializer__Lamf_client_model_domain_XMLSerializer(from)
});
$c_Lamf_client_model_domain_AnyShape.prototype.validate__T__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise = (function(payload, exec) {
  var executionEnvironment = exec.$$undinternal__Lamf_core_execution_ExecutionEnvironment().context$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape().validate__T__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(payload, exec);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$();
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$1, from, m, executionEnvironment).asClient__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.buildJsonSchema__Lamf_client_render_ShapeRenderOptions__T = (function(options) {
  var this$3 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var options$1 = $m_Lamf_core_emitter_ShapeRenderOptions$().apply__Lamf_client_render_ShapeRenderOptions__Lamf_core_emitter_ShapeRenderOptions(options);
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var this$2 = this$1.platform$2;
  var exec = this$2.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  return $f_Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer__generateJsonSchema__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_ShapeRenderOptions__Lamf_client_execution_BaseExecutionEnvironment__T(this$3, this$3, options$1, exec)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$payloadValidator__T__Lamf_client_environment_Environment__O = (function(mediaType, env) {
  return this.payloadValidator__T__Lamf_client_environment_Environment__sjs_js_UndefOr(mediaType, env)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withDefaultStr__T__O = (function(value) {
  return $f_Lamf_client_model_domain_Shape__withDefaultStr__T__Lamf_client_model_domain_Shape(this, value)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$parameterValidator__T__O = (function(mediaType) {
  return this.parameterValidator__T__sjs_js_UndefOr(mediaType)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withValues__sjs_js_Array__O = (function(values) {
  return $f_Lamf_client_model_domain_Shape__withValues__sjs_js_Array__Lamf_client_model_domain_Shape(this, values)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$validate__Lamf_client_model_document_PayloadFragment__Lamf_client_execution_BaseExecutionEnvironment__O = (function(fragment, exec) {
  return this.validate__Lamf_client_model_document_PayloadFragment__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_Promise(fragment, exec)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$buildJsonSchema__O = (function() {
  return this.buildJsonSchema__T()
});
$c_Lamf_client_model_domain_AnyShape.prototype.validateParameter__T__Lamf_client_environment_Environment__sjs_js_Promise = (function(payload, env) {
  var this$1 = this.platform$1;
  var this$2 = this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  var executionEnvironment = this$2.$$undinternal$1.context$1;
  var this$6 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$5 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var env$1 = env.$$undinternal$1;
  var this$3 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var this$4 = this$3.platform$2;
  var exec = this$4.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  var from = $m_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$().validateWithGuessing__Lamf_core_model_domain_Shape__T__T__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(this$5, payload, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, env$1, $m_Lamf_client_plugins_ScalarRelaxedValidationMode$(), exec);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$();
  return new $c_Lamf_client_convert_FutureConverter$InternalFutureOps().init___Lamf_client_convert_FutureConverter__s_concurrent_Future__Lamf_client_convert_InternalClientMatcher__s_concurrent_ExecutionContext(this$6, from, m, executionEnvironment).asClient__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.withExample__T__Lamf_client_model_domain_Example = (function(mediaType) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape();
  var name = new $c_s_Some().init___O(mediaType);
  var from = $f_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement__withExample__s_Option__Lamf_plugins_domain_shapes_models_Example(this$1, name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ExampleMatcher__Lamf_client_convert_ExampleConverter$ExampleMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_Example__Lamf_client_model_domain_Example(from)
});
$c_Lamf_client_model_domain_AnyShape.prototype.payloadValidator__T__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_UndefOr = (function(mediaType, exec) {
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape().payloadValidator__T__Lamf_client_execution_BaseExecutionEnvironment__s_Option(mediaType, exec);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PayloadValidatorMatcher__Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$defaultValue__O = (function() {
  return $f_Lamf_client_model_domain_Shape__defaultValue__Lamf_client_model_domain_DataNode(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$prop$ifShape__O = (function() {
  return $f_Lamf_client_model_domain_Shape__ifShape__Lamf_client_model_domain_Shape(this)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$payloadValidator__T__Lamf_client_execution_BaseExecutionEnvironment__O = (function(mediaType, exec) {
  return this.payloadValidator__T__Lamf_client_execution_BaseExecutionEnvironment__sjs_js_UndefOr(mediaType, exec)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$inlined__O = (function() {
  return this.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape().inlined__Z()
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withDeprecated__Z__O = (function(deprecated) {
  return $f_Lamf_client_model_domain_Shape__withDeprecated__Z__Lamf_client_model_domain_Shape(this, deprecated)
});
$c_Lamf_client_model_domain_AnyShape.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_AnyShape.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_AnyShape.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_AnyShape.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_AnyShape.prototype.withThen = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withThen__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withElse = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withElse__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withIf = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withIf__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withDeprecated = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withDeprecated__Z__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withWriteOnly = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withWriteOnly__Z__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withReadOnly = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withReadOnly__Z__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withCustomShapePropertyDefinition = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withCustomShapePropertyDefinition__T__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withCustomShapePropertyDefinitions = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomShapePropertyDefinitions__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withCustomShapeProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomShapeProperties__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withDefaultStr = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDefaultStr__T__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withNode = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withNode__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withXone = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withXone__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withAnd = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withAnd__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withOr = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withOr__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withInherits = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withInherits__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withValues = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withValues__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withDefaultValue = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DataNode(arg);
  return this.$$js$exported$meth$withDefaultValue__Lamf_client_model_domain_DataNode__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withDescription = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDescription__T__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withDisplayName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDisplayName__T__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "thenShape", {
  "get": (function() {
    return this.$$js$exported$prop$thenShape__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "elseShape", {
  "get": (function() {
    return this.$$js$exported$prop$elseShape__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "ifShape", {
  "get": (function() {
    return this.$$js$exported$prop$ifShape__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "deprecated", {
  "get": (function() {
    return this.$$js$exported$prop$deprecated__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "writeOnly", {
  "get": (function() {
    return this.$$js$exported$prop$writeOnly__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "readOnly", {
  "get": (function() {
    return this.$$js$exported$prop$readOnly__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "not", {
  "get": (function() {
    return this.$$js$exported$prop$not__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "xone", {
  "get": (function() {
    return this.$$js$exported$prop$xone__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "and", {
  "get": (function() {
    return this.$$js$exported$prop$and__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "or", {
  "get": (function() {
    return this.$$js$exported$prop$or__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "customShapePropertyDefinitions", {
  "get": (function() {
    return this.$$js$exported$prop$customShapePropertyDefinitions__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "customShapeProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customShapeProperties__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "inherits", {
  "get": (function() {
    return this.$$js$exported$prop$inherits__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "values", {
  "get": (function() {
    return this.$$js$exported$prop$values__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "defaultValueStr", {
  "get": (function() {
    return this.$$js$exported$prop$defaultValueStr__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "defaultValue", {
  "get": (function() {
    return this.$$js$exported$prop$defaultValue__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "displayName", {
  "get": (function() {
    return this.$$js$exported$prop$displayName__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_AnyShape.prototype.inlined = (function() {
  return this.$$js$exported$meth$inlined__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.trackedExample = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$trackedExample__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "isDefaultEmpty", {
  "get": (function() {
    return this.$$js$exported$prop$isDefaultEmpty__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_AnyShape.prototype.parameterValidator = (function(arg) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 1;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      var prep = $as_T(arg);
      return this.$$js$exported$meth$parameterValidator__T__O(prep);
      break
    }
    case 1: {
      if ((rest[0] instanceof $c_Lamf_client_execution_BaseExecutionEnvironment)) {
        var prep$4 = $as_T(arg);
        var prep$5 = $as_Lamf_client_execution_BaseExecutionEnvironment(rest[0]);
        return this.$$js$exported$meth$parameterValidator__T__Lamf_client_execution_BaseExecutionEnvironment__O(prep$4, prep$5)
      } else if ((rest[0] instanceof $c_Lamf_client_environment_Environment)) {
        var prep$2 = $as_T(arg);
        var prep$3 = $as_Lamf_client_environment_Environment(rest[0]);
        return this.$$js$exported$meth$parameterValidator__T__Lamf_client_environment_Environment__O(prep$2, prep$3)
      } else {
        throw "No matching overload"
      };
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_model_domain_AnyShape.prototype.payloadValidator = (function(arg) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 1;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      if ((rest[0] instanceof $c_Lamf_client_execution_BaseExecutionEnvironment)) {
        var prep$3 = $as_T(arg);
        var prep$4 = $as_Lamf_client_execution_BaseExecutionEnvironment(rest[0]);
        return this.$$js$exported$meth$payloadValidator__T__Lamf_client_execution_BaseExecutionEnvironment__O(prep$3, prep$4)
      } else if ((rest[0] instanceof $c_Lamf_client_environment_Environment)) {
        var prep = $as_T(arg);
        var prep$2 = $as_Lamf_client_environment_Environment(rest[0]);
        return this.$$js$exported$meth$payloadValidator__T__Lamf_client_environment_Environment__O(prep, prep$2)
      } else {
        throw "No matching overload"
      };
      break
    }
    case 0: {
      var prep$5 = $as_T(arg);
      return this.$$js$exported$meth$payloadValidator__T__O(prep$5);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_model_domain_AnyShape.prototype.validateParameter = (function(arg) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 1;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 2: {
      var prep = $as_T(arg);
      var prep$2 = $as_Lamf_client_environment_Environment(rest[0]);
      var prep$3 = $as_Lamf_client_execution_BaseExecutionEnvironment(rest[1]);
      return this.$$js$exported$meth$validateParameter__T__Lamf_client_environment_Environment__Lamf_client_execution_BaseExecutionEnvironment__O(prep, prep$2, prep$3);
      break
    }
    case 0: {
      var prep$4 = $as_T(arg);
      return this.$$js$exported$meth$validateParameter__T__O(prep$4);
      break
    }
    case 1: {
      if ((rest[0] instanceof $c_Lamf_client_environment_Environment)) {
        var prep$7 = $as_T(arg);
        var prep$8 = $as_Lamf_client_environment_Environment(rest[0]);
        return this.$$js$exported$meth$validateParameter__T__Lamf_client_environment_Environment__O(prep$7, prep$8)
      } else if ((rest[0] instanceof $c_Lamf_client_execution_BaseExecutionEnvironment)) {
        var prep$5 = $as_T(arg);
        var prep$6 = $as_Lamf_client_execution_BaseExecutionEnvironment(rest[0]);
        return this.$$js$exported$meth$validateParameter__T__Lamf_client_execution_BaseExecutionEnvironment__O(prep$5, prep$6)
      } else {
        throw "No matching overload"
      };
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_model_domain_AnyShape.prototype.validate = (function(arg) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 1;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 2: {
      if ($is_T(arg)) {
        var prep$4 = $as_T(arg);
        var prep$5 = $as_Lamf_client_environment_Environment(rest[0]);
        var prep$6 = $as_Lamf_client_execution_BaseExecutionEnvironment(rest[1]);
        return this.$$js$exported$meth$validate__T__Lamf_client_environment_Environment__Lamf_client_execution_BaseExecutionEnvironment__O(prep$4, prep$5, prep$6)
      } else if ((arg instanceof $c_Lamf_client_model_document_PayloadFragment)) {
        var prep = $as_Lamf_client_model_document_PayloadFragment(arg);
        var prep$2 = $as_Lamf_client_environment_Environment(rest[0]);
        var prep$3 = $as_Lamf_client_execution_BaseExecutionEnvironment(rest[1]);
        return this.$$js$exported$meth$validate__Lamf_client_model_document_PayloadFragment__Lamf_client_environment_Environment__Lamf_client_execution_BaseExecutionEnvironment__O(prep, prep$2, prep$3)
      } else {
        throw "No matching overload"
      };
      break
    }
    case 0: {
      if ($is_T(arg)) {
        var prep$8 = $as_T(arg);
        return this.$$js$exported$meth$validate__T__O(prep$8)
      } else if ((arg instanceof $c_Lamf_client_model_document_PayloadFragment)) {
        var prep$7 = $as_Lamf_client_model_document_PayloadFragment(arg);
        return this.$$js$exported$meth$validate__Lamf_client_model_document_PayloadFragment__O(prep$7)
      } else {
        throw "No matching overload"
      };
      break
    }
    case 1: {
      if ($is_T(arg)) {
        if ((rest[0] instanceof $c_Lamf_client_execution_BaseExecutionEnvironment)) {
          var prep$15 = $as_T(arg);
          var prep$16 = $as_Lamf_client_execution_BaseExecutionEnvironment(rest[0]);
          return this.$$js$exported$meth$validate__T__Lamf_client_execution_BaseExecutionEnvironment__O(prep$15, prep$16)
        } else if ((rest[0] instanceof $c_Lamf_client_environment_Environment)) {
          var prep$13 = $as_T(arg);
          var prep$14 = $as_Lamf_client_environment_Environment(rest[0]);
          return this.$$js$exported$meth$validate__T__Lamf_client_environment_Environment__O(prep$13, prep$14)
        } else {
          throw "No matching overload"
        }
      } else if ((arg instanceof $c_Lamf_client_model_document_PayloadFragment)) {
        if ((rest[0] instanceof $c_Lamf_client_execution_BaseExecutionEnvironment)) {
          var prep$11 = $as_Lamf_client_model_document_PayloadFragment(arg);
          var prep$12 = $as_Lamf_client_execution_BaseExecutionEnvironment(rest[0]);
          return this.$$js$exported$meth$validate__Lamf_client_model_document_PayloadFragment__Lamf_client_execution_BaseExecutionEnvironment__O(prep$11, prep$12)
        } else if ((rest[0] instanceof $c_Lamf_client_environment_Environment)) {
          var prep$9 = $as_Lamf_client_model_document_PayloadFragment(arg);
          var prep$10 = $as_Lamf_client_environment_Environment(rest[0]);
          return this.$$js$exported$meth$validate__Lamf_client_model_document_PayloadFragment__Lamf_client_environment_Environment__O(prep$9, prep$10)
        } else {
          throw "No matching overload"
        }
      } else {
        throw "No matching overload"
      };
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_model_domain_AnyShape.prototype.buildRamlDatatype = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      return this.$$js$exported$meth$buildRamlDatatype__O();
      break
    }
    case 1: {
      var prep = $as_Lamf_client_execution_BaseExecutionEnvironment(rest[0]);
      return this.$$js$exported$meth$buildRamlDatatype__Lamf_client_execution_BaseExecutionEnvironment__O(prep);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_model_domain_AnyShape.prototype.toRamlDatatype = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      return this.$$js$exported$meth$toRamlDatatype__O();
      break
    }
    case 1: {
      var prep = $as_Lamf_client_execution_BaseExecutionEnvironment(rest[0]);
      return this.$$js$exported$meth$toRamlDatatype__Lamf_client_execution_BaseExecutionEnvironment__O(prep);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_model_domain_AnyShape.prototype.buildJsonSchema = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      return this.$$js$exported$meth$buildJsonSchema__O();
      break
    }
    case 1: {
      if ((rest[0] instanceof $c_Lamf_client_execution_BaseExecutionEnvironment)) {
        var prep$2 = $as_Lamf_client_execution_BaseExecutionEnvironment(rest[0]);
        return this.$$js$exported$meth$buildJsonSchema__Lamf_client_execution_BaseExecutionEnvironment__O(prep$2)
      } else if ((rest[0] instanceof $c_Lamf_client_render_ShapeRenderOptions)) {
        var prep = $as_Lamf_client_render_ShapeRenderOptions(rest[0]);
        return this.$$js$exported$meth$buildJsonSchema__Lamf_client_render_ShapeRenderOptions__O(prep)
      } else {
        throw "No matching overload"
      };
      break
    }
    case 2: {
      var prep$3 = $as_Lamf_client_render_ShapeRenderOptions(rest[0]);
      var prep$4 = $as_Lamf_client_execution_BaseExecutionEnvironment(rest[1]);
      return this.$$js$exported$meth$buildJsonSchema__Lamf_client_render_ShapeRenderOptions__Lamf_client_execution_BaseExecutionEnvironment__O(prep$3, prep$4);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_model_domain_AnyShape.prototype.toJsonSchema = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_client_execution_BaseExecutionEnvironment(rest[0]);
      return this.$$js$exported$meth$toJsonSchema__Lamf_client_execution_BaseExecutionEnvironment__O(prep);
      break
    }
    case 0: {
      return this.$$js$exported$meth$toJsonSchema__O();
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_model_domain_AnyShape.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_AnyShape.prototype.withExample = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withExample__T__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withComment = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withComment__T__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withExamples = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExamples__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withXMLSerialization = (function(arg) {
  var prep = $as_Lamf_client_model_domain_XMLSerializer(arg);
  return this.$$js$exported$meth$withXMLSerialization__Lamf_client_model_domain_XMLSerializer__O(prep)
});
$c_Lamf_client_model_domain_AnyShape.prototype.withDocumentation = (function(arg) {
  var prep = $as_Lamf_client_model_domain_CreativeWork(arg);
  return this.$$js$exported$meth$withDocumentation__Lamf_client_model_domain_CreativeWork__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "comment", {
  "get": (function() {
    return this.$$js$exported$prop$comment__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "examples", {
  "get": (function() {
    return this.$$js$exported$prop$examples__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "xmlSerialization", {
  "get": (function() {
    return this.$$js$exported$prop$xmlSerialization__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_AnyShape.prototype, "documentation", {
  "get": (function() {
    return this.$$js$exported$prop$documentation__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_AnyShape(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_AnyShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.AnyShape"))
}
function $isArrayOf_Lamf_client_model_domain_AnyShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_AnyShape)))
}
function $asArrayOf_Lamf_client_model_domain_AnyShape(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_AnyShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.AnyShape;", depth))
}
var $d_Lamf_client_model_domain_AnyShape = new $TypeData().initClass({
  Lamf_client_model_domain_AnyShape: 0
}, false, "amf.client.model.domain.AnyShape", {
  Lamf_client_model_domain_AnyShape: 1,
  O: 1,
  Lamf_client_model_domain_Shape: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_NamedDomainElement: 1
});
$c_Lamf_client_model_domain_AnyShape.prototype.$classData = $d_Lamf_client_model_domain_AnyShape;
/** @constructor */
function $c_Lamf_client_parse_DefaultErrorHandler() {
  $c_O.call(this);
  this.amf$core$errorhandling$ErrorCollector$$errors$1 = null
}
$c_Lamf_client_parse_DefaultErrorHandler.prototype = new $h_O();
$c_Lamf_client_parse_DefaultErrorHandler.prototype.constructor = $c_Lamf_client_parse_DefaultErrorHandler;
/** @constructor */
function $h_Lamf_client_parse_DefaultErrorHandler() {
  /*<skip>*/
}
$h_Lamf_client_parse_DefaultErrorHandler.prototype = $c_Lamf_client_parse_DefaultErrorHandler.prototype;
$c_Lamf_client_parse_DefaultErrorHandler.prototype.productPrefix__T = (function() {
  return "DefaultErrorHandler"
});
$c_Lamf_client_parse_DefaultErrorHandler.prototype.init___ = (function() {
  $f_Lamf_core_errorhandling_ErrorCollector__$$init$__V(this);
  return this
});
$c_Lamf_client_parse_DefaultErrorHandler.prototype.amf$core$errorhandling$ErrorCollector$$errors__scm_ListBuffer = (function() {
  return this.amf$core$errorhandling$ErrorCollector$$errors$1
});
$c_Lamf_client_parse_DefaultErrorHandler.prototype.amf$core$errorhandling$ErrorCollector$$undsetter$und$amf$core$errorhandling$ErrorCollector$$errors$und$eq__scm_ListBuffer__V = (function(x$1) {
  this.amf$core$errorhandling$ErrorCollector$$errors$1 = x$1
});
$c_Lamf_client_parse_DefaultErrorHandler.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_client_parse_DefaultErrorHandler.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_client_parse_DefaultErrorHandler) && ($as_Lamf_client_parse_DefaultErrorHandler(x$1), true))
});
$c_Lamf_client_parse_DefaultErrorHandler.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_client_parse_DefaultErrorHandler.prototype.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V = (function(specification, node, property, message, lexical, location) {
  var id = specification.id$1;
  var level = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  $f_Lamf_core_errorhandling_AmfResultErrorHandler__reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(this, id, node, property, message, lexical, level, location)
});
$c_Lamf_client_parse_DefaultErrorHandler.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_parse_DefaultErrorHandler.prototype.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V = (function(id, node, property, message, lexical, level, location) {
  $f_Lamf_core_errorhandling_AmfResultErrorHandler__reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(this, id, node, property, message, lexical, level, location)
});
$c_Lamf_client_parse_DefaultErrorHandler.prototype.handlerAmfResult__Lamf_core_validation_AMFValidationResult__Z = (function(result) {
  return $f_Lamf_core_errorhandling_ErrorCollector__handlerAmfResult__Lamf_core_validation_AMFValidationResult__Z(this, result)
});
$c_Lamf_client_parse_DefaultErrorHandler.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_parse_DefaultErrorHandler.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_client_parse_DefaultErrorHandler(obj) {
  return (((obj instanceof $c_Lamf_client_parse_DefaultErrorHandler) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.parse.DefaultErrorHandler"))
}
function $isArrayOf_Lamf_client_parse_DefaultErrorHandler(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_parse_DefaultErrorHandler)))
}
function $asArrayOf_Lamf_client_parse_DefaultErrorHandler(obj, depth) {
  return (($isArrayOf_Lamf_client_parse_DefaultErrorHandler(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.parse.DefaultErrorHandler;", depth))
}
var $d_Lamf_client_parse_DefaultErrorHandler = new $TypeData().initClass({
  Lamf_client_parse_DefaultErrorHandler: 0
}, false, "amf.client.parse.DefaultErrorHandler", {
  Lamf_client_parse_DefaultErrorHandler: 1,
  O: 1,
  Lamf_core_errorhandling_ErrorCollector: 1,
  Lamf_core_errorhandling_AmfResultErrorHandler: 1,
  Lamf_core_errorhandling_ErrorHandler: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_parse_DefaultErrorHandler.prototype.$classData = $d_Lamf_client_parse_DefaultErrorHandler;
/** @constructor */
function $c_Lamf_client_parse_DefaultParserErrorHandler() {
  $c_O.call(this);
  this.parserRun$1 = 0;
  this.amf$core$errorhandling$ErrorCollector$$errors$1 = null
}
$c_Lamf_client_parse_DefaultParserErrorHandler.prototype = new $h_O();
$c_Lamf_client_parse_DefaultParserErrorHandler.prototype.constructor = $c_Lamf_client_parse_DefaultParserErrorHandler;
/** @constructor */
function $h_Lamf_client_parse_DefaultParserErrorHandler() {
  /*<skip>*/
}
$h_Lamf_client_parse_DefaultParserErrorHandler.prototype = $c_Lamf_client_parse_DefaultParserErrorHandler.prototype;
$c_Lamf_client_parse_DefaultParserErrorHandler.prototype.handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V = (function(location, e) {
  $f_Lamf_core_parser_errorhandler_ParserErrorHandler__handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V(this, location, e)
});
$c_Lamf_client_parse_DefaultParserErrorHandler.prototype.amf$core$errorhandling$ErrorCollector$$errors__scm_ListBuffer = (function() {
  return this.amf$core$errorhandling$ErrorCollector$$errors$1
});
$c_Lamf_client_parse_DefaultParserErrorHandler.prototype.amf$core$errorhandling$ErrorCollector$$undsetter$und$amf$core$errorhandling$ErrorCollector$$errors$und$eq__scm_ListBuffer__V = (function(x$1) {
  this.amf$core$errorhandling$ErrorCollector$$errors$1 = x$1
});
$c_Lamf_client_parse_DefaultParserErrorHandler.prototype.handle__Lorg_yaml_model_YError__O__O = (function(error, defaultValue) {
  return $f_Lamf_core_parser_errorhandler_ParserErrorHandler__handle__Lorg_yaml_model_YError__O__O(this, error, defaultValue)
});
$c_Lamf_client_parse_DefaultParserErrorHandler.prototype.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V = (function(specification, node, property, message, lexical, location) {
  var id = specification.id$1;
  var level = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  $f_Lamf_core_errorhandling_AmfResultErrorHandler__reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(this, id, node, property, message, lexical, level, location)
});
$c_Lamf_client_parse_DefaultParserErrorHandler.prototype.parserRun__I = (function() {
  return this.parserRun$1
});
$c_Lamf_client_parse_DefaultParserErrorHandler.prototype.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V = (function(id, node, property, message, lexical, level, location) {
  $f_Lamf_core_errorhandling_AmfResultErrorHandler__reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(this, id, node, property, message, lexical, level, location)
});
$c_Lamf_client_parse_DefaultParserErrorHandler.prototype.init___I = (function(parserRun) {
  this.parserRun$1 = parserRun;
  $f_Lamf_core_errorhandling_ErrorCollector__$$init$__V(this);
  return this
});
$c_Lamf_client_parse_DefaultParserErrorHandler.prototype.handlerAmfResult__Lamf_core_validation_AMFValidationResult__Z = (function(result) {
  if ($f_Lamf_core_errorhandling_ErrorCollector__handlerAmfResult__Lamf_core_validation_AMFValidationResult__Z(this, result)) {
    if ((this.parserRun$1 !== $m_Lamf_core_AMFCompilerRunCount$().NONE$1)) {
      $m_Lamf_core_errorhandling_StaticErrorCollector$().collect__Lamf_core_validation_AMFValidationResult__I__V(result, this.parserRun$1)
    };
    return true
  } else {
    return false
  }
});
var $d_Lamf_client_parse_DefaultParserErrorHandler = new $TypeData().initClass({
  Lamf_client_parse_DefaultParserErrorHandler: 0
}, false, "amf.client.parse.DefaultParserErrorHandler", {
  Lamf_client_parse_DefaultParserErrorHandler: 1,
  O: 1,
  Lamf_core_errorhandling_ErrorCollector: 1,
  Lamf_core_errorhandling_AmfResultErrorHandler: 1,
  Lamf_core_errorhandling_ErrorHandler: 1,
  Lamf_core_parser_errorhandler_AmfParserErrorHandler: 1,
  Lamf_core_parser_errorhandler_ParserErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  Lorg_yaml_model_ParseErrorHandler: 1
});
$c_Lamf_client_parse_DefaultParserErrorHandler.prototype.$classData = $d_Lamf_client_parse_DefaultParserErrorHandler;
/** @constructor */
function $c_Lamf_core_annotations_Aliases() {
  $c_O.call(this);
  this.aliases$1 = null;
  this.name$1 = null;
  this.value$1 = null;
  this.uris$1 = null
}
$c_Lamf_core_annotations_Aliases.prototype = new $h_O();
$c_Lamf_core_annotations_Aliases.prototype.constructor = $c_Lamf_core_annotations_Aliases;
/** @constructor */
function $h_Lamf_core_annotations_Aliases() {
  /*<skip>*/
}
$h_Lamf_core_annotations_Aliases.prototype = $c_Lamf_core_annotations_Aliases.prototype;
$c_Lamf_core_annotations_Aliases.prototype.productPrefix__T = (function() {
  return "Aliases"
});
$c_Lamf_core_annotations_Aliases.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_annotations_Aliases.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_annotations_Aliases)) {
    var Aliases$1 = $as_Lamf_core_annotations_Aliases(x$1);
    var x = this.aliases$1;
    var x$2 = Aliases$1.aliases$1;
    return ((x === null) ? (x$2 === null) : $f_sc_GenSetLike__equals__O__Z(x, x$2))
  } else {
    return false
  }
});
$c_Lamf_core_annotations_Aliases.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.aliases$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_annotations_Aliases.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_Aliases.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_annotations_Aliases.prototype.init___sci_Set = (function(aliases) {
  this.aliases$1 = aliases;
  this.name$1 = "aliases-array";
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var alias = $as_T(x0$1.$$und1__O());
        var p2 = $as_T2(x0$1.$$und2__O());
        if ((p2 !== null)) {
          var fullUrl = $as_T(p2.$$und1__O());
          var relativeUrl = $as_T(p2.$$und2__O());
          return ((((alias + "->") + fullUrl) + "::") + relativeUrl)
        }
      };
      throw new $c_s_MatchError().init___O(x0$1)
    })
  })(this));
  var this$1 = $m_sci_Set$();
  var bf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  this.value$1 = $as_sc_TraversableOnce($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(aliases, f, bf)).mkString__T__T(",");
  var f$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$1$2) {
      var x$1 = $as_T2(x$1$2);
      return $as_T($as_T2(x$1.$$und2__O()).$$und1__O())
    })
  })(this));
  var this$3 = $m_sci_Set$();
  var bf$1 = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$3);
  this.uris$1 = $as_sc_SetLike($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(aliases, f$1, bf$1)).toSeq__sc_Seq();
  return this
});
$c_Lamf_core_annotations_Aliases.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_annotations_Aliases.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_Aliases.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_annotations_Aliases.prototype.shorten__F1__Lamf_core_model_domain_Annotation = (function(fn) {
  var this$4 = this.aliases$1;
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, fn$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var alias = $as_T(x0$1.$$und1__O());
        var p2 = $as_T2(x0$1.$$und2__O());
        if ((p2 !== null)) {
          var fullUrl = $as_T(p2.$$und1__O());
          var relativeUrl = $as_T(p2.$$und2__O());
          var y = new $c_T2().init___O__O(fn$1.apply__O__O(fullUrl), relativeUrl);
          return new $c_T2().init___O__O(alias, y)
        }
      };
      throw new $c_s_MatchError().init___O(x0$1)
    })
  })(this, fn));
  var this$3 = $m_sci_Set$();
  var bf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$3);
  return new $c_Lamf_core_annotations_Aliases().init___sci_Set($as_sci_Set($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$4, f, bf)))
});
function $as_Lamf_core_annotations_Aliases(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_Aliases) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.Aliases"))
}
function $isArrayOf_Lamf_core_annotations_Aliases(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_Aliases)))
}
function $asArrayOf_Lamf_core_annotations_Aliases(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_Aliases(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.Aliases;", depth))
}
var $d_Lamf_core_annotations_Aliases = new $TypeData().initClass({
  Lamf_core_annotations_Aliases: 0
}, false, "amf.core.annotations.Aliases", {
  Lamf_core_annotations_Aliases: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_UriAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_Aliases.prototype.$classData = $d_Lamf_core_annotations_Aliases;
/** @constructor */
function $c_Lamf_core_annotations_AutoGeneratedName() {
  $c_O.call(this);
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_core_annotations_AutoGeneratedName.prototype = new $h_O();
$c_Lamf_core_annotations_AutoGeneratedName.prototype.constructor = $c_Lamf_core_annotations_AutoGeneratedName;
/** @constructor */
function $h_Lamf_core_annotations_AutoGeneratedName() {
  /*<skip>*/
}
$h_Lamf_core_annotations_AutoGeneratedName.prototype = $c_Lamf_core_annotations_AutoGeneratedName.prototype;
$c_Lamf_core_annotations_AutoGeneratedName.prototype.init___ = (function() {
  this.name$1 = "auto-generated-name";
  this.value$1 = "";
  return this
});
$c_Lamf_core_annotations_AutoGeneratedName.prototype.productPrefix__T = (function() {
  return "AutoGeneratedName"
});
$c_Lamf_core_annotations_AutoGeneratedName.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_annotations_AutoGeneratedName.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_core_annotations_AutoGeneratedName) && ($as_Lamf_core_annotations_AutoGeneratedName(x$1), true))
});
$c_Lamf_core_annotations_AutoGeneratedName.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_annotations_AutoGeneratedName.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_AutoGeneratedName.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_annotations_AutoGeneratedName.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_annotations_AutoGeneratedName.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_AutoGeneratedName.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_AutoGeneratedName(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_AutoGeneratedName) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.AutoGeneratedName"))
}
function $isArrayOf_Lamf_core_annotations_AutoGeneratedName(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_AutoGeneratedName)))
}
function $asArrayOf_Lamf_core_annotations_AutoGeneratedName(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_AutoGeneratedName(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.AutoGeneratedName;", depth))
}
var $d_Lamf_core_annotations_AutoGeneratedName = new $TypeData().initClass({
  Lamf_core_annotations_AutoGeneratedName: 0
}, false, "amf.core.annotations.AutoGeneratedName", {
  Lamf_core_annotations_AutoGeneratedName: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_AutoGeneratedName.prototype.$classData = $d_Lamf_core_annotations_AutoGeneratedName;
/** @constructor */
function $c_Lamf_core_annotations_DeclaredElement() {
  $c_O.call(this);
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_core_annotations_DeclaredElement.prototype = new $h_O();
$c_Lamf_core_annotations_DeclaredElement.prototype.constructor = $c_Lamf_core_annotations_DeclaredElement;
/** @constructor */
function $h_Lamf_core_annotations_DeclaredElement() {
  /*<skip>*/
}
$h_Lamf_core_annotations_DeclaredElement.prototype = $c_Lamf_core_annotations_DeclaredElement.prototype;
$c_Lamf_core_annotations_DeclaredElement.prototype.init___ = (function() {
  this.name$1 = "declared-element";
  this.value$1 = "";
  return this
});
$c_Lamf_core_annotations_DeclaredElement.prototype.productPrefix__T = (function() {
  return "DeclaredElement"
});
$c_Lamf_core_annotations_DeclaredElement.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_annotations_DeclaredElement.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_core_annotations_DeclaredElement) && ($as_Lamf_core_annotations_DeclaredElement(x$1), true))
});
$c_Lamf_core_annotations_DeclaredElement.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_annotations_DeclaredElement.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_DeclaredElement.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_annotations_DeclaredElement.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_annotations_DeclaredElement.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_DeclaredElement.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_DeclaredElement(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_DeclaredElement) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.DeclaredElement"))
}
function $isArrayOf_Lamf_core_annotations_DeclaredElement(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_DeclaredElement)))
}
function $asArrayOf_Lamf_core_annotations_DeclaredElement(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_DeclaredElement(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.DeclaredElement;", depth))
}
var $d_Lamf_core_annotations_DeclaredElement = new $TypeData().initClass({
  Lamf_core_annotations_DeclaredElement: 0
}, false, "amf.core.annotations.DeclaredElement", {
  Lamf_core_annotations_DeclaredElement: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_DeclaredElement.prototype.$classData = $d_Lamf_core_annotations_DeclaredElement;
/** @constructor */
function $c_Lamf_core_annotations_DeclaredHeader() {
  $c_O.call(this);
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_core_annotations_DeclaredHeader.prototype = new $h_O();
$c_Lamf_core_annotations_DeclaredHeader.prototype.constructor = $c_Lamf_core_annotations_DeclaredHeader;
/** @constructor */
function $h_Lamf_core_annotations_DeclaredHeader() {
  /*<skip>*/
}
$h_Lamf_core_annotations_DeclaredHeader.prototype = $c_Lamf_core_annotations_DeclaredHeader.prototype;
$c_Lamf_core_annotations_DeclaredHeader.prototype.init___ = (function() {
  this.name$1 = "declared-header";
  this.value$1 = "";
  return this
});
$c_Lamf_core_annotations_DeclaredHeader.prototype.productPrefix__T = (function() {
  return "DeclaredHeader"
});
$c_Lamf_core_annotations_DeclaredHeader.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_core_annotations_DeclaredHeader.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_core_annotations_DeclaredHeader) && ($as_Lamf_core_annotations_DeclaredHeader(x$1), true))
});
$c_Lamf_core_annotations_DeclaredHeader.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_core_annotations_DeclaredHeader.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_DeclaredHeader.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_annotations_DeclaredHeader.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_annotations_DeclaredHeader.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_DeclaredHeader.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_DeclaredHeader(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_DeclaredHeader) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.DeclaredHeader"))
}
function $isArrayOf_Lamf_core_annotations_DeclaredHeader(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_DeclaredHeader)))
}
function $asArrayOf_Lamf_core_annotations_DeclaredHeader(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_DeclaredHeader(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.DeclaredHeader;", depth))
}
var $d_Lamf_core_annotations_DeclaredHeader = new $TypeData().initClass({
  Lamf_core_annotations_DeclaredHeader: 0
}, false, "amf.core.annotations.DeclaredHeader", {
  Lamf_core_annotations_DeclaredHeader: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_DeclaredHeader.prototype.$classData = $d_Lamf_core_annotations_DeclaredHeader;
/** @constructor */
function $c_Lamf_core_annotations_ExternalFragmentRef() {
  $c_O.call(this);
  this.fragment$1 = null;
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_core_annotations_ExternalFragmentRef.prototype = new $h_O();
$c_Lamf_core_annotations_ExternalFragmentRef.prototype.constructor = $c_Lamf_core_annotations_ExternalFragmentRef;
/** @constructor */
function $h_Lamf_core_annotations_ExternalFragmentRef() {
  /*<skip>*/
}
$h_Lamf_core_annotations_ExternalFragmentRef.prototype = $c_Lamf_core_annotations_ExternalFragmentRef.prototype;
$c_Lamf_core_annotations_ExternalFragmentRef.prototype.productPrefix__T = (function() {
  return "ExternalFragmentRef"
});
$c_Lamf_core_annotations_ExternalFragmentRef.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_annotations_ExternalFragmentRef.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_annotations_ExternalFragmentRef)) {
    var ExternalFragmentRef$1 = $as_Lamf_core_annotations_ExternalFragmentRef(x$1);
    return (this.fragment$1 === ExternalFragmentRef$1.fragment$1)
  } else {
    return false
  }
});
$c_Lamf_core_annotations_ExternalFragmentRef.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fragment$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_annotations_ExternalFragmentRef.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_ExternalFragmentRef.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_annotations_ExternalFragmentRef.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_annotations_ExternalFragmentRef.prototype.init___T = (function(fragment) {
  this.fragment$1 = fragment;
  this.name$1 = "external-fragment-ref";
  this.value$1 = fragment;
  return this
});
$c_Lamf_core_annotations_ExternalFragmentRef.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_ExternalFragmentRef.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_ExternalFragmentRef(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_ExternalFragmentRef) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.ExternalFragmentRef"))
}
function $isArrayOf_Lamf_core_annotations_ExternalFragmentRef(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_ExternalFragmentRef)))
}
function $asArrayOf_Lamf_core_annotations_ExternalFragmentRef(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_ExternalFragmentRef(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.ExternalFragmentRef;", depth))
}
var $d_Lamf_core_annotations_ExternalFragmentRef = new $TypeData().initClass({
  Lamf_core_annotations_ExternalFragmentRef: 0
}, false, "amf.core.annotations.ExternalFragmentRef", {
  Lamf_core_annotations_ExternalFragmentRef: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_ExternalFragmentRef.prototype.$classData = $d_Lamf_core_annotations_ExternalFragmentRef;
/** @constructor */
function $c_Lamf_core_annotations_LexicalInformation() {
  $c_O.call(this);
  this.range$1 = null;
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_core_annotations_LexicalInformation.prototype = new $h_O();
$c_Lamf_core_annotations_LexicalInformation.prototype.constructor = $c_Lamf_core_annotations_LexicalInformation;
/** @constructor */
function $h_Lamf_core_annotations_LexicalInformation() {
  /*<skip>*/
}
$h_Lamf_core_annotations_LexicalInformation.prototype = $c_Lamf_core_annotations_LexicalInformation.prototype;
$c_Lamf_core_annotations_LexicalInformation.prototype.productPrefix__T = (function() {
  return "LexicalInformation"
});
$c_Lamf_core_annotations_LexicalInformation.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_annotations_LexicalInformation.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_annotations_LexicalInformation)) {
    var LexicalInformation$1 = $as_Lamf_core_annotations_LexicalInformation(x$1);
    var x = this.range__Lamf_core_parser_Range();
    var x$2 = LexicalInformation$1.range__Lamf_core_parser_Range();
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_core_annotations_LexicalInformation.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.range__Lamf_core_parser_Range();
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_annotations_LexicalInformation.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_LexicalInformation.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_annotations_LexicalInformation.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_annotations_LexicalInformation.prototype.init___Lamf_core_parser_Range = (function(range) {
  this.range$1 = range;
  this.name$1 = "lexical";
  this.value$1 = range.toString__T();
  return this
});
$c_Lamf_core_annotations_LexicalInformation.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_LexicalInformation.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_annotations_LexicalInformation.prototype.range__Lamf_core_parser_Range = (function() {
  return this.range$1
});
function $as_Lamf_core_annotations_LexicalInformation(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_LexicalInformation) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.LexicalInformation"))
}
function $isArrayOf_Lamf_core_annotations_LexicalInformation(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_LexicalInformation)))
}
function $asArrayOf_Lamf_core_annotations_LexicalInformation(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_LexicalInformation(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.LexicalInformation;", depth))
}
var $d_Lamf_core_annotations_LexicalInformation = new $TypeData().initClass({
  Lamf_core_annotations_LexicalInformation: 0
}, false, "amf.core.annotations.LexicalInformation", {
  Lamf_core_annotations_LexicalInformation: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_LexicalInformation.prototype.$classData = $d_Lamf_core_annotations_LexicalInformation;
/** @constructor */
function $c_Lamf_core_annotations_SourceVendor() {
  $c_O.call(this);
  this.vendor$1 = null;
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_core_annotations_SourceVendor.prototype = new $h_O();
$c_Lamf_core_annotations_SourceVendor.prototype.constructor = $c_Lamf_core_annotations_SourceVendor;
/** @constructor */
function $h_Lamf_core_annotations_SourceVendor() {
  /*<skip>*/
}
$h_Lamf_core_annotations_SourceVendor.prototype = $c_Lamf_core_annotations_SourceVendor.prototype;
$c_Lamf_core_annotations_SourceVendor.prototype.productPrefix__T = (function() {
  return "SourceVendor"
});
$c_Lamf_core_annotations_SourceVendor.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_annotations_SourceVendor.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_annotations_SourceVendor)) {
    var SourceVendor$1 = $as_Lamf_core_annotations_SourceVendor(x$1);
    var x = this.vendor$1;
    var x$2 = SourceVendor$1.vendor$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_core_annotations_SourceVendor.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.vendor$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_annotations_SourceVendor.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_SourceVendor.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_annotations_SourceVendor.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_annotations_SourceVendor.prototype.init___Lamf_core_remote_Vendor = (function(vendor) {
  this.vendor$1 = vendor;
  this.name$1 = "source-vendor";
  this.value$1 = vendor.name__T();
  return this
});
$c_Lamf_core_annotations_SourceVendor.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_SourceVendor.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_annotations_SourceVendor(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_SourceVendor) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.SourceVendor"))
}
function $isArrayOf_Lamf_core_annotations_SourceVendor(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_SourceVendor)))
}
function $asArrayOf_Lamf_core_annotations_SourceVendor(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_SourceVendor(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.SourceVendor;", depth))
}
var $d_Lamf_core_annotations_SourceVendor = new $TypeData().initClass({
  Lamf_core_annotations_SourceVendor: 0
}, false, "amf.core.annotations.SourceVendor", {
  Lamf_core_annotations_SourceVendor: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_SourceVendor.prototype.$classData = $d_Lamf_core_annotations_SourceVendor;
/** @constructor */
function $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.f$1 = null;
  this.dataType$1 = null;
  this.tag$1 = null
}
$c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter.prototype = new $h_O();
$c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter.prototype.constructor = $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter;
/** @constructor */
function $h_Lamf_core_emitter_BaseEmitters_package$ValueEmitter() {
  /*<skip>*/
}
$h_Lamf_core_emitter_BaseEmitters_package$ValueEmitter.prototype = $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter.prototype;
$c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter.prototype.productPrefix__T = (function() {
  return "ValueEmitter"
});
$c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter)) {
    var ValueEmitter$1 = $as_Lamf_core_emitter_BaseEmitters_package$ValueEmitter(x$1);
    if ((this.key$1 === ValueEmitter$1.key$1)) {
      var x = this.f$1;
      var x$2 = ValueEmitter$1.f$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.dataType$1;
      var x$4 = ValueEmitter$1.dataType$1;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter.prototype.simpleScalar__p1__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var rc9 = false;
  var x2 = null;
  var x1 = this.dataType$1;
  matchEnd10: {
    var value;
    if ((x1 instanceof $c_s_Some)) {
      rc9 = true;
      x2 = $as_s_Some(x1);
      var p3 = $as_Lorg_yaml_model_YType(x2.value$2);
      var x = $m_Lorg_yaml_model_YType$().Int$1;
      if ((x === p3)) {
        var this$1 = this.f$1;
        var x$1 = $objectToString($as_Lamf_core_model_domain_AmfScalar(this$1.value$1.value$1).value$1);
        var this$3 = new $c_sci_StringOps().init___T(x$1);
        var jsx$1 = $m_jl_Double$();
        var $$this = this$3.repr$1;
        var x$2 = jsx$1.parseDouble__T__D($$this);
        var this$9 = $doubleToInt($uD($g.Math.floor(x$2)));
        var value = ("" + this$9);
        break matchEnd10
      }
    };
    if (rc9) {
      var p5 = $as_Lorg_yaml_model_YType(x2.value$2);
      var x$3 = $m_Lorg_yaml_model_YType$().Float$1;
      if ((x$3 === p5)) {
        var this$11 = this.f$1;
        var x$4 = $objectToString($as_Lamf_core_model_domain_AmfScalar(this$11.value$1.value$1).value$1);
        var this$13 = new $c_sci_StringOps().init___T(x$4);
        var jsx$2 = $m_jl_Double$();
        var $$this$1 = this$13.repr$1;
        var this$15 = jsx$2.parseDouble__T__D($$this$1);
        var x1$2 = ("" + this$15);
        if ($m_sjsr_RuntimeString$().endsWith__T__T__Z(x1$2, ".0")) {
          var endIndex = $uI(x1$2.indexOf(".0"));
          var value = $as_T(x1$2.substring(0, endIndex));
          break matchEnd10
        } else {
          var value = x1$2;
          break matchEnd10
        }
      }
    };
    var this$21 = this.f$1;
    var value = $as_Lamf_core_model_domain_AmfScalar(this$21.value$1.value$1).value$1
  };
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var jsx$4 = $m_Lorg_yaml_model_YNode$();
  var jsx$3 = $m_Lorg_yaml_model_YScalar$().apply__O__Lorg_yaml_model_YScalar(value);
  var this$23 = this.dataType$1;
  var value$1 = jsx$4.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(jsx$3, $as_Lorg_yaml_model_YType((this$23.isEmpty__Z() ? this.tag$1 : this$23.get__O())));
  b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value$1)
});
$c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.f$1;
      break
    }
    case 2: {
      return this.dataType$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var value = this.f$1.value$1;
  this.simpleScalar__p1__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
});
$c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter.prototype.f__Lamf_core_parser_FieldEntry = (function() {
  return this.f$1
});
$c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter.prototype.init___T__Lamf_core_parser_FieldEntry__s_Option = (function(key, f, dataType) {
  this.key$1 = key;
  this.f$1 = f;
  this.dataType$1 = dataType;
  $f_Lamf_core_emitter_BaseEmitters_package$BaseValueEmitter__$$init$__V(this);
  return this
});
$c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  return $f_Lamf_core_emitter_BaseEmitters_package$BaseValueEmitter__position__Lamf_core_parser_Position(this)
});
$c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter.prototype.amf$core$emitter$BaseEmitters$BaseValueEmitter$$undsetter$und$tag$und$eq__Lorg_yaml_model_YType__V = (function(x$1) {
  this.tag$1 = x$1
});
function $as_Lamf_core_emitter_BaseEmitters_package$ValueEmitter(obj) {
  return (((obj instanceof $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.emitter.BaseEmitters.package$ValueEmitter"))
}
function $isArrayOf_Lamf_core_emitter_BaseEmitters_package$ValueEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_emitter_BaseEmitters_package$ValueEmitter)))
}
function $asArrayOf_Lamf_core_emitter_BaseEmitters_package$ValueEmitter(obj, depth) {
  return (($isArrayOf_Lamf_core_emitter_BaseEmitters_package$ValueEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.emitter.BaseEmitters.package$ValueEmitter;", depth))
}
var $d_Lamf_core_emitter_BaseEmitters_package$ValueEmitter = new $TypeData().initClass({
  Lamf_core_emitter_BaseEmitters_package$ValueEmitter: 0
}, false, "amf.core.emitter.BaseEmitters.package$ValueEmitter", {
  Lamf_core_emitter_BaseEmitters_package$ValueEmitter: 1,
  O: 1,
  Lamf_core_emitter_BaseEmitters_package$BaseValueEmitter: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter.prototype.$classData = $d_Lamf_core_emitter_BaseEmitters_package$ValueEmitter;
/** @constructor */
function $c_Lamf_core_emitter_SpecOrdering$Default$() {
  $c_O.call(this)
}
$c_Lamf_core_emitter_SpecOrdering$Default$.prototype = new $h_O();
$c_Lamf_core_emitter_SpecOrdering$Default$.prototype.constructor = $c_Lamf_core_emitter_SpecOrdering$Default$;
/** @constructor */
function $h_Lamf_core_emitter_SpecOrdering$Default$() {
  /*<skip>*/
}
$h_Lamf_core_emitter_SpecOrdering$Default$.prototype = $c_Lamf_core_emitter_SpecOrdering$Default$.prototype;
$c_Lamf_core_emitter_SpecOrdering$Default$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_emitter_SpecOrdering$Default$.prototype.sorted__sc_Seq__sc_Seq = (function(values) {
  return values
});
$c_Lamf_core_emitter_SpecOrdering$Default$.prototype.gteq__O__O__Z = (function(x, y) {
  return $f_s_math_Ordering__gteq__O__O__Z(this, x, y)
});
$c_Lamf_core_emitter_SpecOrdering$Default$.prototype.compare__O__O__I = (function(x, y) {
  $as_Lamf_core_emitter_Emitter(x);
  $as_Lamf_core_emitter_Emitter(y);
  return 1
});
$c_Lamf_core_emitter_SpecOrdering$Default$.prototype.lteq__O__O__Z = (function(x, y) {
  return $f_s_math_Ordering__lteq__O__O__Z(this, x, y)
});
var $d_Lamf_core_emitter_SpecOrdering$Default$ = new $TypeData().initClass({
  Lamf_core_emitter_SpecOrdering$Default$: 0
}, false, "amf.core.emitter.SpecOrdering$Default$", {
  Lamf_core_emitter_SpecOrdering$Default$: 1,
  O: 1,
  Lamf_core_emitter_SpecOrdering: 1,
  s_math_Ordering: 1,
  ju_Comparator: 1,
  s_math_PartialOrdering: 1,
  s_math_Equiv: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_emitter_SpecOrdering$Default$.prototype.$classData = $d_Lamf_core_emitter_SpecOrdering$Default$;
var $n_Lamf_core_emitter_SpecOrdering$Default$ = (void 0);
function $m_Lamf_core_emitter_SpecOrdering$Default$() {
  if ((!$n_Lamf_core_emitter_SpecOrdering$Default$)) {
    $n_Lamf_core_emitter_SpecOrdering$Default$ = new $c_Lamf_core_emitter_SpecOrdering$Default$().init___()
  };
  return $n_Lamf_core_emitter_SpecOrdering$Default$
}
/** @constructor */
function $c_Lamf_core_emitter_SpecOrdering$Lexical$() {
  $c_O.call(this)
}
$c_Lamf_core_emitter_SpecOrdering$Lexical$.prototype = new $h_O();
$c_Lamf_core_emitter_SpecOrdering$Lexical$.prototype.constructor = $c_Lamf_core_emitter_SpecOrdering$Lexical$;
/** @constructor */
function $h_Lamf_core_emitter_SpecOrdering$Lexical$() {
  /*<skip>*/
}
$h_Lamf_core_emitter_SpecOrdering$Lexical$.prototype = $c_Lamf_core_emitter_SpecOrdering$Lexical$.prototype;
$c_Lamf_core_emitter_SpecOrdering$Lexical$.prototype.init___ = (function() {
  return this
});
$c_Lamf_core_emitter_SpecOrdering$Lexical$.prototype.sorted__sc_Seq__sc_Seq = (function(values) {
  var x1 = values.partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_emitter_Emitter(x$1$2);
      return x$1.position__Lamf_core_parser_Position().isZero__Z()
    })
  })(this)));
  if ((x1 !== null)) {
    var without = $as_sc_Seq(x1.$$und1__O());
    var lexical = $as_sc_Seq(x1.$$und2__O());
    var jsx$1 = $as_sc_TraversableLike(lexical.sorted__s_math_Ordering__O(this));
    var this$1 = $m_sc_Seq$();
    return $as_sc_Seq(jsx$1.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(without, this$1.ReusableCBFInstance$2))
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_core_emitter_SpecOrdering$Lexical$.prototype.gteq__O__O__Z = (function(x, y) {
  return $f_s_math_Ordering__gteq__O__O__Z(this, x, y)
});
$c_Lamf_core_emitter_SpecOrdering$Lexical$.prototype.compare__O__O__I = (function(x, y) {
  var x$1 = $as_Lamf_core_emitter_Emitter(x);
  var y$1 = $as_Lamf_core_emitter_Emitter(y);
  return x$1.position__Lamf_core_parser_Position().compareTo__Lamf_core_parser_Position__I(y$1.position__Lamf_core_parser_Position())
});
$c_Lamf_core_emitter_SpecOrdering$Lexical$.prototype.lteq__O__O__Z = (function(x, y) {
  return $f_s_math_Ordering__lteq__O__O__Z(this, x, y)
});
var $d_Lamf_core_emitter_SpecOrdering$Lexical$ = new $TypeData().initClass({
  Lamf_core_emitter_SpecOrdering$Lexical$: 0
}, false, "amf.core.emitter.SpecOrdering$Lexical$", {
  Lamf_core_emitter_SpecOrdering$Lexical$: 1,
  O: 1,
  Lamf_core_emitter_SpecOrdering: 1,
  s_math_Ordering: 1,
  ju_Comparator: 1,
  s_math_PartialOrdering: 1,
  s_math_Equiv: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_emitter_SpecOrdering$Lexical$.prototype.$classData = $d_Lamf_core_emitter_SpecOrdering$Lexical$;
var $n_Lamf_core_emitter_SpecOrdering$Lexical$ = (void 0);
function $m_Lamf_core_emitter_SpecOrdering$Lexical$() {
  if ((!$n_Lamf_core_emitter_SpecOrdering$Lexical$)) {
    $n_Lamf_core_emitter_SpecOrdering$Lexical$ = new $c_Lamf_core_emitter_SpecOrdering$Lexical$().init___()
  };
  return $n_Lamf_core_emitter_SpecOrdering$Lexical$
}
/** @constructor */
function $c_Lamf_core_metamodel_document_DocumentModel$() {
  $c_O.call(this);
  this.doc$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.Declares$1 = null;
  this.Encodes$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null
}
$c_Lamf_core_metamodel_document_DocumentModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_document_DocumentModel$.prototype.constructor = $c_Lamf_core_metamodel_document_DocumentModel$;
/** @constructor */
function $h_Lamf_core_metamodel_document_DocumentModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_document_DocumentModel$.prototype = $c_Lamf_core_metamodel_document_DocumentModel$.prototype;
$c_Lamf_core_metamodel_document_DocumentModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_document_DocumentModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_ModuleModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_DocumentModel__$$init$__V(this);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "Document", "A Document is a parsing Unit that encodes a stand-alone DomainElement and can include references to other DomainElements that reference from the encoded DomainElement.\nSince it encodes a DomainElement, but also declares references, it behaves like a Fragment and a Module at the same time.\nThe main difference is that the Document encoded DomainElement is stand-alone and that the references declared are supposed to be private not for re-use from other Units", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_document_DocumentModel$.prototype.amf$core$metamodel$document$DocumentModel$$undsetter$und$fields$und$eq__sci_List__V = (function(x$1) {
  this.fields$1 = x$1
});
$c_Lamf_core_metamodel_document_DocumentModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_document_DocumentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_core_metamodel_document_DocumentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_core_metamodel_document_DocumentModel$.prototype.Declares__Lamf_core_metamodel_Field = (function() {
  return this.Declares$1
});
$c_Lamf_core_metamodel_document_DocumentModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_document_DocumentModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_core_metamodel_document_DocumentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_core_metamodel_document_DocumentModel$.prototype.amf$core$metamodel$document$ModuleModel$$undsetter$und$Declares$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Declares$1 = x$1
});
$c_Lamf_core_metamodel_document_DocumentModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_core_model_document_Document().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_core_metamodel_document_DocumentModel$.prototype.Encodes__Lamf_core_metamodel_Field = (function() {
  return this.Encodes$1
});
$c_Lamf_core_metamodel_document_DocumentModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_core_metamodel_document_DocumentModel$.prototype.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Encodes$1 = x$1
});
$c_Lamf_core_metamodel_document_DocumentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_core_metamodel_document_DocumentModel$.prototype.amf$core$metamodel$document$DocumentModel$$undsetter$und$type$und$eq__sci_List__V = (function(x$1) {
  this.type$1 = x$1
});
$c_Lamf_core_metamodel_document_DocumentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_core_metamodel_document_DocumentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_core_metamodel_document_DocumentModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_document_DocumentModel$: 0
}, false, "amf.core.metamodel.document.DocumentModel$", {
  Lamf_core_metamodel_document_DocumentModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_DocumentModel: 1,
  Lamf_core_metamodel_document_FragmentModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_document_ModuleModel: 1
});
$c_Lamf_core_metamodel_document_DocumentModel$.prototype.$classData = $d_Lamf_core_metamodel_document_DocumentModel$;
var $n_Lamf_core_metamodel_document_DocumentModel$ = (void 0);
function $m_Lamf_core_metamodel_document_DocumentModel$() {
  if ((!$n_Lamf_core_metamodel_document_DocumentModel$)) {
    $n_Lamf_core_metamodel_document_DocumentModel$ = new $c_Lamf_core_metamodel_document_DocumentModel$().init___()
  };
  return $n_Lamf_core_metamodel_document_DocumentModel$
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$() {
  $c_O.call(this);
  this.Name$1 = null;
  this.key$1 = null;
  this.Domain$1 = null;
  this.Schema$1 = null;
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Description$1 = null;
  this.DisplayName$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$.prototype.constructor = $c_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$.prototype = $c_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$.prototype;
$c_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DisplayNameField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Name$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "name"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "name", "Name for an entity", $m_sci_Nil$()), true);
  this.key$1 = this.Name$1;
  var jsx$2 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Iri$());
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Rdfs$1;
  this.Domain$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "domain"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Rdfs$1, "domain", "RDFS domain property", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_core_metamodel_domain_ShapeModel$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.Schema$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "schema"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "schema", "Schema for an entity", $m_sci_Nil$()), true);
  $m_sci_List$();
  var array = [this.Domain$1, this.Schema$1, this.Name$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$13 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$13);
    i = (((-1) + i) | 0)
  };
  var jsx$7 = result;
  var jsx$6 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().fields$1;
  var this$14 = $m_sci_List$();
  var jsx$5 = $as_sci_List(jsx$7.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$6, this$14.ReusableCBFInstance$2));
  var jsx$4 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$15 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$15.ReusableCBFInstance$2));
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var x$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "DomainProperty");
  var this$18 = $m_Lamf_core_vocabulary_Namespace$().Rdf$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$18, "Property");
  var this$20 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  var this$21 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$20);
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$21);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "Custom Domain Property", "Definition of an extension to the domain model defined directly by a user in the RAML/OpenAPI document.\nThis can be achieved by using an annotationType in RAML. In OpenAPI thy don't need to\n      be declared, they can just be used.\n      This should be mapped to new RDF properties declared directly in the main document or module.\n      Contrast this extension mechanism with the creation of a propertyTerm in a vocabulary, a more\nre-usable and generic way of achieving the same functionality.\nIt can be validated using a SHACL shape", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$.prototype.amf$core$metamodel$domain$common$DisplayNameField$$undsetter$und$DisplayName$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DisplayName$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_core_model_domain_extensions_CustomDomainProperty().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$: 0
}, false, "amf.core.metamodel.domain.extensions.CustomDomainPropertyModel$", {
  Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_DisplayNameField: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1
});
$c_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$.prototype.$classData = $d_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$;
var $n_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$ = (void 0);
function $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$() {
  if ((!$n_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$)) {
    $n_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$ = new $c_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().init___()
  };
  return $n_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.doc$1 = null;
  this.Target$1 = null;
  this.Variables$1 = null;
  this.key$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype.constructor = $c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype = $c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype;
$c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel__$$init$__V(this);
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "ParametrizedDeclaration");
  var this$3 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$3);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "Parametrized Declaration", "Generic graph template supporting variables that can be transformed into a domain element", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype.Target__Lamf_core_metamodel_Field = (function() {
  return this.Target$1
});
$c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype.Variables__Lamf_core_metamodel_Field = (function() {
  return this.Variables$1
});
$c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype.fields__sci_List = (function() {
  return $f_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel__fields__sci_List(this)
});
$c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype.amf$core$metamodel$domain$templates$ParametrizedDeclarationModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype.modelInstance__sr_Nothing$ = (function() {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("ParametrizedDeclaration is abstract and cannot be instantiated by default"))
});
$c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype.amf$core$metamodel$domain$templates$ParametrizedDeclarationModel$$undsetter$und$key$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.key$1 = x$1
});
$c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  this.modelInstance__sr_Nothing$()
});
$c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype.amf$core$metamodel$domain$templates$ParametrizedDeclarationModel$$undsetter$und$Variables$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Variables$1 = x$1
});
$c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype.Name__Lamf_core_metamodel_Field = (function() {
  return this.Name$1
});
var $d_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$: 0
}, false, "amf.core.metamodel.domain.templates.ParametrizedDeclarationModel$", {
  Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1
});
$c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$.prototype.$classData = $d_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$;
var $n_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$ = (void 0);
function $m_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$() {
  if ((!$n_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$)) {
    $n_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$ = new $c_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$().init___()
  };
  return $n_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$
}
/** @constructor */
function $c_Lamf_core_model_domain_ExternalDomainElement() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.parsed$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_core_model_domain_ExternalDomainElement.prototype = new $h_O();
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.constructor = $c_Lamf_core_model_domain_ExternalDomainElement;
/** @constructor */
function $h_Lamf_core_model_domain_ExternalDomainElement() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_ExternalDomainElement.prototype = $c_Lamf_core_model_domain_ExternalDomainElement.prototype;
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.productPrefix__T = (function() {
  return "ExternalDomainElement"
});
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_model_domain_ExternalDomainElement)) {
    var ExternalDomainElement$1 = $as_Lamf_core_model_domain_ExternalDomainElement(x$1);
    var x = this.fields$1;
    var x$2 = ExternalDomainElement$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = ExternalDomainElement$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_core_metamodel_domain_ExternalDomainElementModel$()
});
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.componentId__T = (function() {
  return "#/external"
});
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  this.parsed$1 = $m_s_None$();
  return this
});
function $as_Lamf_core_model_domain_ExternalDomainElement(obj) {
  return (((obj instanceof $c_Lamf_core_model_domain_ExternalDomainElement) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.ExternalDomainElement"))
}
function $isArrayOf_Lamf_core_model_domain_ExternalDomainElement(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_ExternalDomainElement)))
}
function $asArrayOf_Lamf_core_model_domain_ExternalDomainElement(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_ExternalDomainElement(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.ExternalDomainElement;", depth))
}
var $d_Lamf_core_model_domain_ExternalDomainElement = new $TypeData().initClass({
  Lamf_core_model_domain_ExternalDomainElement: 0
}, false, "amf.core.model.domain.ExternalDomainElement", {
  Lamf_core_model_domain_ExternalDomainElement: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_domain_ExternalDomainElement.prototype.$classData = $d_Lamf_core_model_domain_ExternalDomainElement;
/** @constructor */
function $c_Lamf_core_model_domain_RecursiveShape() {
  $c_Lamf_core_model_domain_Shape.call(this);
  this.fields$2 = null;
  this.annotations$2 = null;
  this.internalFixpointTarget$2 = null
}
$c_Lamf_core_model_domain_RecursiveShape.prototype = new $h_Lamf_core_model_domain_Shape();
$c_Lamf_core_model_domain_RecursiveShape.prototype.constructor = $c_Lamf_core_model_domain_RecursiveShape;
/** @constructor */
function $h_Lamf_core_model_domain_RecursiveShape() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_RecursiveShape.prototype = $c_Lamf_core_model_domain_RecursiveShape.prototype;
$c_Lamf_core_model_domain_RecursiveShape.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Recursive shape cannot be linked"))
});
$c_Lamf_core_model_domain_RecursiveShape.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_core_metamodel_domain_RecursiveShapeModel$()
});
$c_Lamf_core_model_domain_RecursiveShape.prototype.cloneShape$default$4__Z = (function() {
  return false
});
$c_Lamf_core_model_domain_RecursiveShape.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_core_model_domain_RecursiveShape.prototype.cloneShape$default$3__Lamf_core_traversal_ModelTraversalRegistry = (function() {
  return new $c_Lamf_core_traversal_ModelTraversalRegistry().init___()
});
$c_Lamf_core_model_domain_RecursiveShape.prototype.withFixpointTarget__Lamf_core_model_domain_Shape__Lamf_core_model_domain_RecursiveShape = (function(target) {
  this.internalFixpointTarget$2 = new $c_s_Some().init___O(target);
  return this
});
$c_Lamf_core_model_domain_RecursiveShape.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
  if (this$1.isEmpty__Z()) {
    var this$5 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var name = $as_T(arg1);
    var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(name);
    var this$4 = this$3.platform$1;
    var url = this$3.str$1;
    var this$5 = new $c_s_Some().init___O(("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url)))
  };
  return ($as_T((this$5.isEmpty__Z() ? "" : this$5.get__O())) + "/recursive")
});
$c_Lamf_core_model_domain_RecursiveShape.prototype.cloneShape__s_Option__s_Option__Lamf_core_traversal_ModelTraversalRegistry__Z__Lamf_core_model_domain_Shape = (function(recursionErrorHandler, recursionBase, traversal, cloneExamples) {
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var cloned = new $c_Lamf_core_model_domain_RecursiveShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  cloned.id$1 = this.id$1;
  this.copyFields__s_Option__Lamf_core_model_domain_Shape__s_Option__Lamf_core_traversal_ModelTraversalRegistry__V(recursionErrorHandler, cloned, $m_s_None$(), traversal);
  var this$4 = this.internalFixpointTarget$2;
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var target = $as_Lamf_core_model_domain_Shape(arg1);
    cloned.withFixpointTarget__Lamf_core_model_domain_Shape__Lamf_core_model_domain_RecursiveShape(target)
  };
  return cloned
});
$c_Lamf_core_model_domain_RecursiveShape.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_core_model_domain_RecursiveShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_core_model_domain_RecursiveShape.prototype.copyShape__Lamf_core_model_domain_RecursiveShape = (function() {
  var this$1 = $c_Lamf_core_model_domain_Shape.prototype.copyShape__Lamf_core_model_domain_Shape.call(this);
  var value = this.id$1;
  var copy = $as_Lamf_core_model_domain_RecursiveShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$1, value));
  var this$2 = this.internalFixpointTarget$2;
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var target = $as_Lamf_core_model_domain_Shape(arg1);
    copy.withFixpointTarget__Lamf_core_model_domain_Shape__Lamf_core_model_domain_RecursiveShape(target)
  };
  return copy
});
$c_Lamf_core_model_domain_RecursiveShape.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_core_model_domain_RecursiveShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$2 = fields;
  this.annotations$2 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  this.internalFixpointTarget$2 = $m_s_None$();
  return this
});
function $as_Lamf_core_model_domain_RecursiveShape(obj) {
  return (((obj instanceof $c_Lamf_core_model_domain_RecursiveShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.RecursiveShape"))
}
function $isArrayOf_Lamf_core_model_domain_RecursiveShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_RecursiveShape)))
}
function $asArrayOf_Lamf_core_model_domain_RecursiveShape(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_RecursiveShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.RecursiveShape;", depth))
}
var $d_Lamf_core_model_domain_RecursiveShape = new $TypeData().initClass({
  Lamf_core_model_domain_RecursiveShape: 0
}, false, "amf.core.model.domain.RecursiveShape", {
  Lamf_core_model_domain_RecursiveShape: 1,
  Lamf_core_model_domain_Shape: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelper: 1
});
$c_Lamf_core_model_domain_RecursiveShape.prototype.$classData = $d_Lamf_core_model_domain_RecursiveShape;
/** @constructor */
function $c_Lamf_core_model_domain_templates_VariableValue() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_core_model_domain_templates_VariableValue.prototype = new $h_O();
$c_Lamf_core_model_domain_templates_VariableValue.prototype.constructor = $c_Lamf_core_model_domain_templates_VariableValue;
/** @constructor */
function $h_Lamf_core_model_domain_templates_VariableValue() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_templates_VariableValue.prototype = $c_Lamf_core_model_domain_templates_VariableValue.prototype;
$c_Lamf_core_model_domain_templates_VariableValue.prototype.productPrefix__T = (function() {
  return "VariableValue"
});
$c_Lamf_core_model_domain_templates_VariableValue.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_core_model_domain_templates_VariableValue.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_model_domain_templates_VariableValue.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_core_model_domain_templates_VariableValue.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_model_domain_templates_VariableValue)) {
    var VariableValue$1 = $as_Lamf_core_model_domain_templates_VariableValue(x$1);
    var x = this.fields$1;
    var x$2 = VariableValue$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = VariableValue$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_model_domain_templates_VariableValue.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_model_domain_templates_VariableValue.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_core_model_domain_templates_VariableValue.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_core_metamodel_domain_templates_VariableValueModel$()
});
$c_Lamf_core_model_domain_templates_VariableValue.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_core_model_domain_templates_VariableValue.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_model_domain_templates_VariableValue.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_VariableValueModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-variable" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_core_model_domain_templates_VariableValue.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_core_model_domain_templates_VariableValue.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_core_model_domain_templates_VariableValue.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_core_model_domain_templates_VariableValue.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_core_model_domain_templates_VariableValue.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_core_model_domain_templates_VariableValue.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_model_domain_templates_VariableValue.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_core_model_domain_templates_VariableValue.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_model_domain_templates_VariableValue.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_core_model_domain_templates_VariableValue.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_core_model_domain_templates_VariableValue(obj) {
  return (((obj instanceof $c_Lamf_core_model_domain_templates_VariableValue) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.templates.VariableValue"))
}
function $isArrayOf_Lamf_core_model_domain_templates_VariableValue(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_templates_VariableValue)))
}
function $asArrayOf_Lamf_core_model_domain_templates_VariableValue(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_templates_VariableValue(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.templates.VariableValue;", depth))
}
var $d_Lamf_core_model_domain_templates_VariableValue = new $TypeData().initClass({
  Lamf_core_model_domain_templates_VariableValue: 0
}, false, "amf.core.model.domain.templates.VariableValue", {
  Lamf_core_model_domain_templates_VariableValue: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_domain_templates_VariableValue.prototype.$classData = $d_Lamf_core_model_domain_templates_VariableValue;
/** @constructor */
function $c_Lamf_core_parser_DefaultArrayNode() {
  $c_O.call(this);
  this.node$1 = null;
  this.iv$1 = null
}
$c_Lamf_core_parser_DefaultArrayNode.prototype = new $h_O();
$c_Lamf_core_parser_DefaultArrayNode.prototype.constructor = $c_Lamf_core_parser_DefaultArrayNode;
/** @constructor */
function $h_Lamf_core_parser_DefaultArrayNode() {
  /*<skip>*/
}
$h_Lamf_core_parser_DefaultArrayNode.prototype = $c_Lamf_core_parser_DefaultArrayNode.prototype;
$c_Lamf_core_parser_DefaultArrayNode.prototype.productPrefix__T = (function() {
  return "DefaultArrayNode"
});
$c_Lamf_core_parser_DefaultArrayNode.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_parser_DefaultArrayNode.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_parser_DefaultArrayNode)) {
    var DefaultArrayNode$1 = $as_Lamf_core_parser_DefaultArrayNode(x$1);
    var this$1 = this.node$1;
    var b = DefaultArrayNode$1.node$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_core_parser_DefaultArrayNode.prototype.nodes__T2 = (function() {
  var this$1 = this.node$1;
  var conversion = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
  var iv = this.iv$1;
  return new $c_T2().init___O__O($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv), this.node$1)
});
$c_Lamf_core_parser_DefaultArrayNode.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.node$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_parser_DefaultArrayNode.prototype.negated__Lamf_core_model_domain_AmfElement = (function() {
  return $f_Lamf_core_parser_BaseArrayNode__negated__Lamf_core_model_domain_AmfArray(this)
});
$c_Lamf_core_parser_DefaultArrayNode.prototype.text__Lamf_core_model_domain_AmfArray = (function() {
  return $f_Lamf_core_parser_BaseArrayNode__text__Lamf_core_model_domain_AmfArray(this)
});
$c_Lamf_core_parser_DefaultArrayNode.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_parser_DefaultArrayNode.prototype.$boolean__Lamf_core_model_domain_AmfArray = (function() {
  return $f_Lamf_core_parser_BaseArrayNode__$boolean__Lamf_core_model_domain_AmfArray(this)
});
$c_Lamf_core_parser_DefaultArrayNode.prototype.iv__Lorg_yaml_model_IllegalTypeHandler = (function() {
  return this.iv$1
});
$c_Lamf_core_parser_DefaultArrayNode.prototype.integer__Lamf_core_model_domain_AmfArray = (function() {
  return $f_Lamf_core_parser_BaseArrayNode__integer__Lamf_core_model_domain_AmfArray(this)
});
$c_Lamf_core_parser_DefaultArrayNode.prototype.init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler = (function(node, iv) {
  this.node$1 = node;
  this.iv$1 = iv;
  return this
});
$c_Lamf_core_parser_DefaultArrayNode.prototype.obj__F1__Lamf_core_model_domain_AmfArray = (function(fn) {
  return $f_Lamf_core_parser_BaseArrayNode__array__pLamf_core_parser_BaseArrayNode__F1__Lamf_core_model_domain_AmfArray(this, fn)
});
$c_Lamf_core_parser_DefaultArrayNode.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_parser_DefaultArrayNode.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_parser_DefaultArrayNode(obj) {
  return (((obj instanceof $c_Lamf_core_parser_DefaultArrayNode) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.DefaultArrayNode"))
}
function $isArrayOf_Lamf_core_parser_DefaultArrayNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_DefaultArrayNode)))
}
function $asArrayOf_Lamf_core_parser_DefaultArrayNode(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_DefaultArrayNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.DefaultArrayNode;", depth))
}
var $d_Lamf_core_parser_DefaultArrayNode = new $TypeData().initClass({
  Lamf_core_parser_DefaultArrayNode: 0
}, false, "amf.core.parser.DefaultArrayNode", {
  Lamf_core_parser_DefaultArrayNode: 1,
  O: 1,
  Lamf_core_parser_BaseArrayNode: 1,
  Lamf_core_parser_ArrayNode: 1,
  Lamf_core_parser_TypedNode: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_DefaultArrayNode.prototype.$classData = $d_Lamf_core_parser_DefaultArrayNode;
/** @constructor */
function $c_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$() {
  $c_O.call(this);
  this.parserRun$1 = 0
}
$c_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$.prototype = new $h_O();
$c_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$.prototype.constructor = $c_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$;
/** @constructor */
function $h_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$() {
  /*<skip>*/
}
$h_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$.prototype = $c_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$.prototype;
$c_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$.prototype.init___ = (function() {
  $n_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$ = this;
  this.parserRun$1 = $m_Lamf_core_AMFCompilerRunCount$().NONE$1;
  return this
});
$c_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$.prototype.handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V = (function(location, e) {
  $f_Lamf_core_parser_errorhandler_ParserErrorHandler__handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V(this, location, e)
});
$c_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$.prototype.handle__Lorg_yaml_model_YError__O__O = (function(error, defaultValue) {
  return $f_Lamf_core_parser_errorhandler_ParserErrorHandler__handle__Lorg_yaml_model_YError__O__O(this, error, defaultValue)
});
$c_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$.prototype.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V = (function(specification, node, property, message, lexical, location) {
  var id = specification.id$1;
  var level = $m_Lamf_core_validation_SeverityLevels$().WARNING$1;
  $f_Lamf_core_errorhandling_AmfResultErrorHandler__reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(this, id, node, property, message, lexical, level, location)
});
$c_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$.prototype.parserRun__I = (function() {
  return this.parserRun$1
});
$c_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$.prototype.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V = (function(id, node, property, message, lexical, level, location) {
  $f_Lamf_core_errorhandling_AmfResultErrorHandler__reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(this, id, node, property, message, lexical, level, location)
});
$c_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$.prototype.handlerAmfResult__Lamf_core_validation_AMFValidationResult__Z = (function(result) {
  return $f_Lamf_core_parser_errorhandler_UnhandledAmfParserErrorHandler__handlerAmfResult__Lamf_core_validation_AMFValidationResult__Z(this, result)
});
var $d_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$ = new $TypeData().initClass({
  Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$: 0
}, false, "amf.core.parser.errorhandler.UnhandledParserErrorHandler$", {
  Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$: 1,
  O: 1,
  Lamf_core_parser_errorhandler_UnhandledAmfParserErrorHandler: 1,
  Lamf_core_parser_errorhandler_AmfParserErrorHandler: 1,
  Lamf_core_errorhandling_AmfResultErrorHandler: 1,
  Lamf_core_errorhandling_ErrorHandler: 1,
  Lamf_core_parser_errorhandler_ParserErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  Lorg_yaml_model_ParseErrorHandler: 1
});
$c_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$.prototype.$classData = $d_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$;
var $n_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$ = (void 0);
function $m_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$() {
  if ((!$n_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$)) {
    $n_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$ = new $c_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$().init___()
  };
  return $n_Lamf_core_parser_errorhandler_UnhandledParserErrorHandler$
}
/** @constructor */
function $c_Lamf_core_rdf_RdfParserContext() {
  $c_Lamf_core_parser_ParserContext.call(this);
  this.unresolvedReferences$2 = null;
  this.unresolvedExtReferencesMap$2 = null;
  this.referencesMap$2 = null;
  this.collected$2 = null;
  this.nodes$2 = null
}
$c_Lamf_core_rdf_RdfParserContext.prototype = new $h_Lamf_core_parser_ParserContext();
$c_Lamf_core_rdf_RdfParserContext.prototype.constructor = $c_Lamf_core_rdf_RdfParserContext;
/** @constructor */
function $h_Lamf_core_rdf_RdfParserContext() {
  /*<skip>*/
}
$h_Lamf_core_rdf_RdfParserContext.prototype = $c_Lamf_core_rdf_RdfParserContext.prototype;
$c_Lamf_core_rdf_RdfParserContext.prototype.init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext = (function(rootContextDocument, refs, futureDeclarations, eh, plugins) {
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$3 = new $c_scm_ListBuffer().init___();
  $c_Lamf_core_parser_ParserContext.prototype.init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext.call(this, rootContextDocument, this$3.toList__sci_List(), futureDeclarations, eh, plugins);
  this.unresolvedReferences$2 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.unresolvedExtReferencesMap$2 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.referencesMap$2 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.collected$2 = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  this.nodes$2 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  return this
});
var $d_Lamf_core_rdf_RdfParserContext = new $TypeData().initClass({
  Lamf_core_rdf_RdfParserContext: 0
}, false, "amf.core.rdf.RdfParserContext", {
  Lamf_core_rdf_RdfParserContext: 1,
  Lamf_core_parser_ParserContext: 1,
  O: 1,
  Lorg_yaml_model_ParseErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_rdf_RdfParserContext.prototype.$classData = $d_Lamf_core_rdf_RdfParserContext;
/** @constructor */
function $c_Lamf_core_resolution_stages_selectors_MetaModelSelector() {
  $c_Lamf_core_resolution_stages_selectors_Selector.call(this);
  this.namespace$2 = null;
  this.id$2 = null
}
$c_Lamf_core_resolution_stages_selectors_MetaModelSelector.prototype = new $h_Lamf_core_resolution_stages_selectors_Selector();
$c_Lamf_core_resolution_stages_selectors_MetaModelSelector.prototype.constructor = $c_Lamf_core_resolution_stages_selectors_MetaModelSelector;
/** @constructor */
function $h_Lamf_core_resolution_stages_selectors_MetaModelSelector() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_selectors_MetaModelSelector.prototype = $c_Lamf_core_resolution_stages_selectors_MetaModelSelector.prototype;
$c_Lamf_core_resolution_stages_selectors_MetaModelSelector.prototype.init___Lamf_core_vocabulary_Namespace__T = (function(namespace, id) {
  this.namespace$2 = namespace;
  this.id$2 = id;
  return this
});
$c_Lamf_core_resolution_stages_selectors_MetaModelSelector.prototype.apply__O__O = (function(v1) {
  return this.apply__Lamf_core_model_domain_DomainElement__Z($as_Lamf_core_model_domain_DomainElement(v1))
});
$c_Lamf_core_resolution_stages_selectors_MetaModelSelector.prototype.apply__Lamf_core_model_domain_DomainElement__Z = (function(element) {
  var metaModelFound = $f_Lamf_core_metamodel_MetaModelTypeMapping__metaModel__O__Lamf_core_metamodel_Obj(this, element);
  var this$1 = this.namespace$2;
  var id = this.id$2;
  var targetIri = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, id).iri__T();
  var this$3 = metaModelFound.type__sci_List();
  var these = this$3;
  while ((!these.isEmpty__Z())) {
    var arg1 = these.head__O();
    var t = $as_Lamf_core_vocabulary_ValueType(arg1);
    if ((t.iri__T() === targetIri)) {
      return true
    };
    these = $as_sc_LinearSeqOptimized(these.tail__O())
  };
  return false
});
/** @constructor */
function $c_Lamf_plugins_document_graph_parser_GraphParserContext() {
  $c_Lamf_core_parser_ParserContext.call(this);
  this.compactUris$2 = null;
  this.baseId$2 = null
}
$c_Lamf_plugins_document_graph_parser_GraphParserContext.prototype = new $h_Lamf_core_parser_ParserContext();
$c_Lamf_plugins_document_graph_parser_GraphParserContext.prototype.constructor = $c_Lamf_plugins_document_graph_parser_GraphParserContext;
/** @constructor */
function $h_Lamf_plugins_document_graph_parser_GraphParserContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_graph_parser_GraphParserContext.prototype = $c_Lamf_plugins_document_graph_parser_GraphParserContext.prototype;
$c_Lamf_plugins_document_graph_parser_GraphParserContext.prototype.init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_AmfParserErrorHandler__scm_Map__s_Option = (function(rootContextDocument, refs, futureDeclarations, eh, compactUris, baseId) {
  this.compactUris$2 = compactUris;
  this.baseId$2 = baseId;
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$5 = new $c_scm_ListBuffer().init___();
  $c_Lamf_core_parser_ParserContext.prototype.init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext.call(this, rootContextDocument, refs, futureDeclarations, eh, new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$5.toList__sci_List()));
  return this
});
var $d_Lamf_plugins_document_graph_parser_GraphParserContext = new $TypeData().initClass({
  Lamf_plugins_document_graph_parser_GraphParserContext: 0
}, false, "amf.plugins.document.graph.parser.GraphParserContext", {
  Lamf_plugins_document_graph_parser_GraphParserContext: 1,
  Lamf_core_parser_ParserContext: 1,
  O: 1,
  Lorg_yaml_model_ParseErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_graph_parser_GraphParserContext.prototype.$classData = $d_Lamf_plugins_document_graph_parser_GraphParserContext;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter() {
  $c_O.call(this);
  this.declared$1 = null;
  this.publicNodeMapping$1 = null;
  this.nodeMappable$1 = null;
  this.instance$1 = null;
  this.dialect$1 = null;
  this.ordering$1 = null;
  this.declarationsPath$1 = null;
  this.aliases$1 = null;
  this.keyPropertyId$1 = null;
  this.renderOptions$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter.prototype.productPrefix__T = (function() {
  return "DeclarationsGroupEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter.prototype.productArity__I = (function() {
  return 10
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter)) {
    var DeclarationsGroupEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter(x$1);
    var x = this.declared$1;
    var x$2 = DeclarationsGroupEmitter$1.declared$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.publicNodeMapping$1;
      var x$4 = DeclarationsGroupEmitter$1.publicNodeMapping$1;
      var jsx$8 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$8 = false
    };
    if (jsx$8) {
      var x$5 = this.nodeMappable$1;
      var x$6 = DeclarationsGroupEmitter$1.nodeMappable$1;
      var jsx$7 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$7 = false
    };
    if (jsx$7) {
      var x$7 = this.instance$1;
      var x$8 = DeclarationsGroupEmitter$1.instance$1;
      var jsx$6 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$6 = false
    };
    if (jsx$6) {
      var x$9 = this.dialect$1;
      var x$10 = DeclarationsGroupEmitter$1.dialect$1;
      var jsx$5 = ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      var jsx$5 = false
    };
    if (jsx$5) {
      var x$11 = this.ordering$1;
      var x$12 = DeclarationsGroupEmitter$1.ordering$1;
      var jsx$4 = (x$11 === x$12)
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      var x$13 = this.declarationsPath$1;
      var x$14 = DeclarationsGroupEmitter$1.declarationsPath$1;
      var jsx$3 = ((x$13 === null) ? (x$14 === null) : x$13.equals__O__Z(x$14))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$15 = this.aliases$1;
      var x$16 = DeclarationsGroupEmitter$1.aliases$1;
      var jsx$2 = ((x$15 === null) ? (x$16 === null) : $f_sc_GenMapLike__equals__O__Z(x$15, x$16))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$17 = this.keyPropertyId$1;
      var x$18 = DeclarationsGroupEmitter$1.keyPropertyId$1;
      var jsx$1 = ((x$17 === null) ? (x$18 === null) : x$17.equals__O__Z(x$18))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$19 = this.renderOptions$1;
      var x$20 = DeclarationsGroupEmitter$1.renderOptions$1;
      return (x$19 === x$20)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.declared$1;
      break
    }
    case 1: {
      return this.publicNodeMapping$1;
      break
    }
    case 2: {
      return this.nodeMappable$1;
      break
    }
    case 3: {
      return this.instance$1;
      break
    }
    case 4: {
      return this.dialect$1;
      break
    }
    case 5: {
      return this.ordering$1;
      break
    }
    case 6: {
      return this.declarationsPath$1;
      break
    }
    case 7: {
      return this.aliases$1;
      break
    }
    case 8: {
      return this.keyPropertyId$1;
      break
    }
    case 9: {
      return this.renderOptions$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter.prototype.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect = (function() {
  return this.dialect$1
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.publicNodeMapping$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().MappedNode$1));
  var this$3 = this$2.option$1;
  var nodeMappingId = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
  var x1 = $f_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__findNodeMappingById__T__T2(this, nodeMappingId);
  matchEnd5: {
    var discriminator;
    if ((x1 !== null)) {
      var unionMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1.$$und2__O());
      if ((unionMapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping)) {
        var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(unionMapping);
        var discriminator = new $c_s_Some().init___O(new $c_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper().init___Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper(x3, this));
        break matchEnd5
      }
    };
    var discriminator = $m_s_None$()
  };
  if (this.declarationsPath$1.isEmpty__Z()) {
    var this$4 = this.publicNodeMapping$1;
    var this$5 = $as_Lamf_core_model_StrField(this$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().Name$1));
    var this$6 = this$5.option$1;
    var declarationKey = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(declarationKey);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$2 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    this.sortedDeclarations__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$2, discriminator$1) {
      return (function(decl$2) {
        var decl = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(decl$2);
        var identifier = $this.computeIdentifier__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T(decl);
        var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(identifier);
        var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$2.sourceName$2);
        if (discriminator$1.isEmpty__Z()) {
          var discriminatorProperty = $m_s_None$()
        } else {
          var arg1 = discriminator$1.get__O();
          var x$14 = $as_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper(arg1);
          var discriminatorProperty = x$14.compute__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__s_Option(decl)
        };
        var x$2 = $this.nodeMappable$1;
        var x$3 = $this.instance$1;
        var x$4 = $this.dialect$1;
        var x$5 = $this.ordering$1;
        var x$6 = $this.aliases$1;
        var x$8 = $this.renderOptions$1;
        var x$9 = $m_s_None$();
        var x$11 = $m_s_None$();
        var x$13 = $m_sci_Nil$();
        new $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter().init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sci_Map__s_Option__Z__s_Option__s_Option__Z__sc_Seq__Lamf_core_emitter_RenderOptions(decl, x$2, x$3, x$4, x$5, x$6, x$9, false, x$11, discriminatorProperty, false, x$13, x$8).emit__Lorg_yaml_model_YDocument$PartBuilder__V(v$1);
        var this$14 = v$1.builder$1;
        var array = [key$1];
        if ((this$14.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len = $uI(array.length);
        var newSize = ((this$14.size0$6 + len) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$14, newSize);
        var len$1 = this$14.size0$6;
        var src = this$14.array$6;
        var dest = this$14.array$6;
        $systemArraycopy(src, 0, dest, len, len$1);
        var xs = this$14.array$6;
        var len$2 = xs.u.length;
        var i = 0;
        var j = 0;
        var x = $uI(array.length);
        var x$1 = ((x < len$2) ? x : len$2);
        var that = xs.u.length;
        var end = ((x$1 < that) ? x$1 : that);
        while ((i < end)) {
          var jsx$1 = j;
          var index = i;
          xs.set(jsx$1, array[index]);
          i = ((1 + i) | 0);
          j = ((1 + j) | 0)
        };
        this$14.size0$6 = newSize;
        b$2.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1))
      })
    })(this, b$1, discriminator)));
    jsx$2.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
    var this$27 = v.builder$1;
    var array$1 = [key];
    if ((this$27.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$3 = $uI(array$1.length);
    var newSize$1 = ((this$27.size0$6 + len$3) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$27, newSize$1);
    var len$4 = this$27.size0$6;
    var src$1 = this$27.array$6;
    var dest$1 = this$27.array$6;
    $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
    var xs$1 = this$27.array$6;
    var len$5 = xs$1.u.length;
    var i$1 = 0;
    var j$1 = 0;
    var x$7 = $uI(array$1.length);
    var x$10 = ((x$7 < len$5) ? x$7 : len$5);
    var that$1 = xs$1.u.length;
    var end$1 = ((x$10 < that$1) ? x$10 : that$1);
    while ((i$1 < end$1)) {
      var jsx$3 = j$1;
      var index$1 = i$1;
      xs$1.set(jsx$3, array$1[index$1]);
      i$1 = ((1 + i$1) | 0);
      j$1 = ((1 + j$1) | 0)
    };
    this$27.size0$6 = newSize$1;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  } else {
    $m_Lorg_yaml_model_YNode$();
    var str = $as_T(this.declarationsPath$1.head__O());
    var key$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    var v$2 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$4 = v$2.builder$1;
    var sourceName$1 = v$2.sourceName$2;
    var b$3 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
    new $c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter().init___sc_Seq__Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sc_Seq__sci_Map__s_Option__Lamf_core_emitter_RenderOptions(this.declared$1, this.publicNodeMapping$1, this.nodeMappable$1, this.instance$1, this.dialect$1, this.ordering$1, $as_sc_Seq(this.declarationsPath$1.tail__O()), this.aliases$1, this.keyPropertyId$1, this.renderOptions$1).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$3);
    jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$3.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1));
    var this$42 = v$2.builder$1;
    var array$2 = [key$2];
    if ((this$42.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len$6 = $uI(array$2.length);
    var newSize$2 = ((this$42.size0$6 + len$6) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$42, newSize$2);
    var len$7 = this$42.size0$6;
    var src$2 = this$42.array$6;
    var dest$2 = this$42.array$6;
    $systemArraycopy(src$2, 0, dest$2, len$6, len$7);
    var xs$2 = this$42.array$6;
    var len$8 = xs$2.u.length;
    var i$2 = 0;
    var j$2 = 0;
    var x$12 = $uI(array$2.length);
    var x$15 = ((x$12 < len$8) ? x$12 : len$8);
    var that$2 = xs$2.u.length;
    var end$2 = ((x$15 < that$2) ? x$15 : that$2);
    while ((i$2 < end$2)) {
      var jsx$5 = j$2;
      var index$2 = i$2;
      xs$2.set(jsx$5, array$2[index$2]);
      i$2 = ((1 + i$2) | 0);
      j$2 = ((1 + j$2) | 0)
    };
    this$42.size0$6 = newSize$2;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$2.builder$1))
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter.prototype.computeIdentifier__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__T = (function(decl) {
  var x1 = $as_Lamf_core_model_StrField(decl.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$().DeclarationName$1)).option$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var name = $as_T(x2.value$2);
    return name
  } else {
    var thiz = decl.id$1;
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "#", 0);
    var this$3 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    var thiz$1 = $as_T($f_sc_IndexedSeqOptimized__last__O(this$3));
    var xs$1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz$1, "/", 0);
    var this$6 = new $c_scm_ArrayOps$ofRef().init___AO(xs$1);
    var str = $as_T($f_sc_IndexedSeqOptimized__last__O(this$6));
    var this$8 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
    var this$9 = this$8.platform$1;
    var url = this$8.str$1;
    return $f_Lamf_core_remote_JsPlatform__decodeURI__T__T(this$9, url)
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter.prototype.sortedDeclarations__sc_Seq = (function() {
  var jsx$2 = this.declared$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$17$2) {
      var x$17 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x$17$2);
      var this$1 = x$17.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      if (this$1.isEmpty__Z()) {
        var this$2 = $m_s_None$()
      } else {
        var arg1 = this$1.get__O();
        var lexInfo = $as_Lamf_core_annotations_LexicalInformation(arg1);
        var this$2 = new $c_s_Some().init___O(lexInfo.range__Lamf_core_parser_Range().start$1)
      };
      return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
    })
  })(this));
  var this$3 = $m_s_math_Ordering$();
  var evidence$1 = $m_s_Predef$().singleton$und$less$colon$less$2;
  return $as_sc_Seq(jsx$2.sortBy__F1__s_math_Ordering__O(jsx$1, new $c_s_math_LowPriorityOrderingImplicits$$anon$3().init___s_math_LowPriorityOrderingImplicits__F1(this$3, evidence$1)))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter.prototype.init___sc_Seq__Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sc_Seq__sci_Map__s_Option__Lamf_core_emitter_RenderOptions = (function(declared, publicNodeMapping, nodeMappable, instance, dialect, ordering, declarationsPath, aliases, keyPropertyId, renderOptions) {
  this.declared$1 = declared;
  this.publicNodeMapping$1 = publicNodeMapping;
  this.nodeMappable$1 = nodeMappable;
  this.instance$1 = instance;
  this.dialect$1 = dialect;
  this.ordering$1 = ordering;
  this.declarationsPath$1 = declarationsPath;
  this.aliases$1 = aliases;
  this.keyPropertyId$1 = keyPropertyId;
  this.renderOptions$1 = renderOptions;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var jsx$3 = this.declared$1;
  var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$16$2) {
      var x$16 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x$16$2);
      var this$1 = x$16.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      if (this$1.isEmpty__Z()) {
        var xo = $m_s_None$()
      } else {
        var arg1 = this$1.get__O();
        var lexInfo = $as_Lamf_core_annotations_LexicalInformation(arg1);
        var xo = new $c_s_Some().init___O(lexInfo.range__Lamf_core_parser_Range().start$1)
      };
      return xo.toList__sci_List()
    })
  })(this));
  var this$3 = $m_sc_Seq$();
  var jsx$1 = $as_sc_SeqLike(jsx$3.flatMap__F1__scg_CanBuildFrom__O(jsx$2, this$3.ReusableCBFInstance$2));
  var this$4 = $m_s_math_Ordering$();
  var evidence$1 = $m_s_Predef$().singleton$und$less$colon$less$2;
  var this$5 = $as_sc_TraversableLike(jsx$1.sorted__s_math_Ordering__O(new $c_s_math_LowPriorityOrderingImplicits$$anon$3().init___s_math_LowPriorityOrderingImplicits__F1(this$4, evidence$1))).headOption__s_Option();
  return $as_Lamf_core_parser_Position((this$5.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$5.get__O()))
});
function $as_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.instances.DeclarationsGroupEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.instances.DeclarationsGroupEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.instances.DeclarationsGroupEmitter", {
  Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter() {
  $c_O.call(this);
  this.node$1 = null;
  this.nodeMappable$1 = null;
  this.instance$1 = null;
  this.dialect$1 = null;
  this.ordering$1 = null;
  this.aliases$1 = null;
  this.keyPropertyId$1 = null;
  this.rootNode$1 = false;
  this.discriminatorMappable$1 = null;
  this.discriminator$1 = null;
  this.emitDialect$1 = false;
  this.topLevelEmitters$1 = null;
  this.renderOptions$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.productPrefix__T = (function() {
  return "DialectNodeEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sci_Map__s_Option__Z__s_Option__s_Option__Z__sc_Seq__Lamf_core_emitter_RenderOptions = (function(node, nodeMappable, instance, dialect, ordering, aliases, keyPropertyId, rootNode, discriminatorMappable, discriminator, emitDialect, topLevelEmitters, renderOptions) {
  this.node$1 = node;
  this.nodeMappable$1 = nodeMappable;
  this.instance$1 = instance;
  this.dialect$1 = dialect;
  this.ordering$1 = ordering;
  this.aliases$1 = aliases;
  this.keyPropertyId$1 = keyPropertyId;
  this.rootNode$1 = rootNode;
  this.discriminatorMappable$1 = discriminatorMappable;
  this.discriminator$1 = discriminator;
  this.emitDialect$1 = emitDialect;
  this.topLevelEmitters$1 = topLevelEmitters;
  this.renderOptions$1 = renderOptions;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.isLibrary__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__Z = (function(elem, instance) {
  return instance.references__sc_Seq().exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, elem$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_document_BaseUnit(x0$1$2);
      return ($is_Lamf_core_model_document_DeclaresModel(x0$1) && $as_Lamf_core_model_document_DeclaresModel(x0$1).declares__sc_Seq().exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, elem$2) {
        return (function(x$41$2) {
          var x$41 = $as_Lamf_core_model_domain_DomainElement(x$41$2);
          return (x$41.id__T() === $as_Lamf_core_model_domain_AmfObject($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(elem$2).get__O()).id__T())
        })
      })($this, elem$1))))
    })
  })(this, elem)))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.productArity__I = (function() {
  return 13
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var this$1 = this.node$1;
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1).isDefined__Z()) {
    if (this.isFragment__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__Z(this.node$1, this.instance$1)) {
      var node = this.node$1;
      new $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$2().init___Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(this, node).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b)
    } else if (this.isLibrary__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__Z(this.node$1, this.instance$1)) {
      this.emitLibrarRef__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__Lorg_yaml_model_YDocument$PartBuilder__V(this.node$1, this.instance$1, b)
    } else {
      this.emitRef__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YDocument$PartBuilder__V(this.node$1, b)
    }
  } else {
    var elem = this.topLevelEmitters$1;
    var emitters = new $c_sr_ObjectRef().init___O(elem);
    if (this.emitDialect$1) {
      var jsx$3 = $as_sc_Seq(emitters.elem$1);
      var jsx$2 = $m_sc_Seq$();
      var array = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("$dialect", this.nodeMappable$1.id__T(), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$())];
      var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
      var this$7 = $m_sc_Seq$();
      emitters.elem$1 = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2))
    };
    if (this.discriminator$1.isDefined__Z()) {
      var x1 = $as_T2(this.discriminator$1.get__O());
      if ((x1 === null)) {
        throw new $c_s_MatchError().init___O(x1)
      };
      var discriminatorName = $as_T(x1.$$und1__O());
      var discriminatorValue = $as_T(x1.$$und2__O());
      var jsx$6 = $as_sc_Seq(emitters.elem$1);
      var jsx$5 = $m_sc_Seq$();
      var array$1 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position(discriminatorName, discriminatorValue, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$())];
      var jsx$4 = jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
      var this$12 = $m_sc_Seq$();
      emitters.elem$1 = $as_sc_Seq(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$12.ReusableCBFInstance$2))
    };
    if (this.node$1.annotations$1.find__jl_Class__s_Option($d_Lamf_plugins_document_vocabularies_annotations_CustomId.getClassOf()).isDefined__Z()) {
      var jsx$7 = true
    } else {
      var this$13 = this.renderOptions$1;
      var jsx$7 = this$13.emitNodeIds$1
    };
    if (jsx$7) {
      var x1$2 = this.node$1.annotations$1.find__jl_Class__s_Option($d_Lamf_plugins_document_vocabularies_annotations_CustomId.getClassOf());
      matchEnd4: {
        var baseId;
        if ((x1$2 instanceof $c_s_Some)) {
          var x2 = $as_s_Some(x1$2);
          var customId = $as_Lamf_plugins_document_vocabularies_annotations_CustomId(x2.value$2);
          if ((customId.value$1 !== "true")) {
            var baseId = customId.value$1;
            break matchEnd4
          }
        };
        var baseId = this.node$1.id$1
      };
      var this$14 = this.dialect$1;
      var this$15 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$14);
      var s = $as_jl_CharSequence((this$15.isEmpty__Z() ? "" : this$15.get__O()));
      var str = $objectToString(s);
      if (($uI(baseId.indexOf(str)) !== (-1))) {
        var target = this.dialect$1.id$1;
        var customId$2 = $as_T(baseId.split(target).join(""))
      } else {
        var customId$2 = baseId
      };
      var jsx$10 = $as_sc_Seq(emitters.elem$1);
      var jsx$9 = $m_sc_Seq$();
      var array$2 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("$id", customId$2, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$())];
      var jsx$8 = jsx$9.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2));
      var this$25 = $m_sc_Seq$();
      emitters.elem$1 = $as_sc_Seq(jsx$10.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$8, this$25.ReusableCBFInstance$2))
    };
    this.uniqueFields__Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel__sc_Iterable(this.node$1.meta__Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel()).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, emitters$1) {
      return (function(field$2) {
        var field = $as_Lamf_core_metamodel_Field(field$2);
        var this$26 = this$2$1.findPropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_core_metamodel_Field__s_Option(this$2$1.node$1, field);
        if ((!this$26.isEmpty__Z())) {
          var arg1 = this$26.get__O();
          var propertyMapping = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(arg1);
          if (this$2$1.keyPropertyId$1.isEmpty__Z()) {
            var jsx$11 = true
          } else {
            var this$27 = $as_Lamf_core_model_StrField(propertyMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
            var this$28 = this$27.option$1;
            var jsx$11 = ($as_T((this$28.isEmpty__Z() ? null : this$28.get__O())) !== this$2$1.keyPropertyId$1.get__O())
          };
          if (jsx$11) {
            var this$29 = $as_Lamf_core_model_StrField(propertyMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
            var this$30 = this$29.option$1;
            var key = $as_T((this$30.isEmpty__Z() ? null : this$30.get__O()));
            var propertyClassification = propertyMapping.classification__Lamf_plugins_document_vocabularies_model_domain_PropertyClassification();
            var rc15 = false;
            var x2$1 = null;
            var this$31 = this$2$1.node$1.fields$1;
            var x1$1 = this$31.fs$1.get__O__s_Option(field);
            matchEnd16: {
              var nextEmitter;
              if ((x1$1 instanceof $c_s_Some)) {
                rc15 = true;
                x2$1 = $as_s_Some(x1$1);
                var entry = $as_Lamf_core_parser_Value(x2$1.value$2);
                if ((entry.value$1 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
                  var scalar = $as_Lamf_core_model_domain_AmfScalar(entry.value$1);
                  var nextEmitter = this$2$1.emitScalar__T__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfScalar__s_Option__sc_Seq(key, field, scalar, new $c_s_Some().init___O(entry.annotations$1));
                  break matchEnd16
                }
              };
              if (rc15) {
                var entry$2 = $as_Lamf_core_parser_Value(x2$1.value$2);
                if ((entry$2.value$1 instanceof $c_Lamf_core_model_domain_AmfArray)) {
                  var x$2 = $m_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$();
                  var jsx$12 = ((propertyClassification !== null) && (propertyClassification === x$2))
                } else {
                  var jsx$12 = false
                };
                if (jsx$12) {
                  var array$3 = $as_Lamf_core_model_domain_AmfArray(entry$2.value$1);
                  var nextEmitter = this$2$1.emitScalarArray__T__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfArray__s_Option__sc_Seq(key, field, array$3, new $c_s_Some().init___O(entry$2.annotations$1));
                  break matchEnd16
                }
              };
              if (rc15) {
                var entry$3 = $as_Lamf_core_parser_Value(x2$1.value$2);
                if ((entry$3.value$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
                  var x$4 = $m_Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$();
                  var jsx$13 = ((propertyClassification !== null) && (propertyClassification === x$4))
                } else {
                  var jsx$13 = false
                };
                if (jsx$13) {
                  var element = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(entry$3.value$1);
                  var nextEmitter = this$2$1.emitExternalObject__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__sc_Seq(key, element, propertyMapping);
                  break matchEnd16
                }
              };
              if (rc15) {
                var entry$4 = $as_Lamf_core_parser_Value(x2$1.value$2);
                if ((entry$4.value$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
                  var x$6 = $m_Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$();
                  var jsx$14 = ((propertyClassification !== null) && (propertyClassification === x$6))
                } else {
                  var jsx$14 = false
                };
                if (jsx$14) {
                  var element$2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(entry$4.value$1);
                  var nextEmitter = this$2$1.emitExternalLink__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__s_Option__sc_Seq(key, element$2, propertyMapping, $m_s_None$());
                  break matchEnd16
                }
              };
              if (rc15) {
                var entry$5 = $as_Lamf_core_parser_Value(x2$1.value$2);
                if ((entry$5.value$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
                  var x$8 = $m_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$();
                  var jsx$15 = ((propertyClassification !== null) && (propertyClassification === x$8))
                } else {
                  var jsx$15 = false
                };
                if ((jsx$15 && (!propertyMapping.isUnion__Z()))) {
                  var element$3 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(entry$5.value$1);
                  var result = this$2$1.emitObjectEntry__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__s_Option__sc_Seq(key, element$3, propertyMapping, new $c_s_Some().init___O(entry$5.annotations$1));
                  var nextEmitter = result;
                  break matchEnd16
                }
              };
              if (rc15) {
                var entry$6 = $as_Lamf_core_parser_Value(x2$1.value$2);
                if ((entry$6.value$1 instanceof $c_Lamf_core_model_domain_AmfArray)) {
                  var x$10 = $m_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$();
                  var jsx$16 = ((propertyClassification !== null) && (propertyClassification === x$10))
                } else {
                  var jsx$16 = false
                };
                if ((jsx$16 && (!propertyMapping.isUnion__Z()))) {
                  var array$2$1 = $as_Lamf_core_model_domain_AmfArray(entry$6.value$1);
                  var nextEmitter = this$2$1.emitObjectEntry__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__s_Option__sc_Seq(key, array$2$1, propertyMapping, new $c_s_Some().init___O(entry$6.annotations$1));
                  break matchEnd16
                }
              };
              if (rc15) {
                var entry$7 = $as_Lamf_core_parser_Value(x2$1.value$2);
                if ((entry$7.value$1 instanceof $c_Lamf_core_model_domain_AmfArray)) {
                  var x$12 = $m_Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$();
                  var jsx$17 = ((propertyClassification !== null) && (propertyClassification === x$12))
                } else {
                  var jsx$17 = false
                };
                if (jsx$17) {
                  var array$3$1 = $as_Lamf_core_model_domain_AmfArray(entry$7.value$1);
                  var nextEmitter = this$2$1.emitExternalLink__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__s_Option__sc_Seq(key, array$3$1, propertyMapping, new $c_s_Some().init___O(entry$7.annotations$1));
                  break matchEnd16
                }
              };
              if (rc15) {
                var entry$8 = $as_Lamf_core_parser_Value(x2$1.value$2);
                if ((entry$8.value$1 instanceof $c_Lamf_core_model_domain_AmfArray)) {
                  var x$14 = $m_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$();
                  var jsx$18 = ((propertyClassification !== null) && (propertyClassification === x$14))
                } else {
                  var jsx$18 = false
                };
                if (jsx$18) {
                  var array$4 = $as_Lamf_core_model_domain_AmfArray(entry$8.value$1);
                  var nextEmitter = this$2$1.emitObjectEntry__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__s_Option__sc_Seq(key, array$4, propertyMapping, new $c_s_Some().init___O(entry$8.annotations$1));
                  break matchEnd16
                }
              };
              if (rc15) {
                var entry$9 = $as_Lamf_core_parser_Value(x2$1.value$2);
                if ((entry$9.value$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
                  var x$16 = $m_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$();
                  var jsx$19 = ((propertyClassification !== null) && (propertyClassification === x$16))
                } else {
                  var jsx$19 = false
                };
                if ((jsx$19 && propertyMapping.isUnion__Z())) {
                  var element$4 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(entry$9.value$1);
                  var nextEmitter = this$2$1.emitObjectEntry__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__s_Option__sc_Seq(key, element$4, propertyMapping, $m_s_None$());
                  break matchEnd16
                }
              };
              if (rc15) {
                var entry$10 = $as_Lamf_core_parser_Value(x2$1.value$2);
                if ((entry$10.value$1 instanceof $c_Lamf_core_model_domain_AmfArray)) {
                  var x$18 = $m_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$();
                  var jsx$20 = ((propertyClassification !== null) && (propertyClassification === x$18))
                } else {
                  var jsx$20 = false
                };
                if ((jsx$20 && propertyMapping.isUnion__Z())) {
                  var array$5 = $as_Lamf_core_model_domain_AmfArray(entry$10.value$1);
                  var nextEmitter = this$2$1.emitObjectEntry__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__s_Option__sc_Seq(key, array$5, propertyMapping, new $c_s_Some().init___O(entry$10.annotations$1));
                  break matchEnd16
                }
              };
              if (rc15) {
                var entry$11 = $as_Lamf_core_parser_Value(x2$1.value$2);
                if ((entry$11.value$1 instanceof $c_Lamf_core_model_domain_AmfArray)) {
                  var x$20 = $m_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$();
                  var jsx$21 = ((propertyClassification !== null) && (propertyClassification === x$20))
                } else {
                  var jsx$21 = false
                };
                if (jsx$21) {
                  var array$6 = $as_Lamf_core_model_domain_AmfArray(entry$11.value$1);
                  var nextEmitter = this$2$1.emitObjectPairs__T__Lamf_core_model_domain_AmfArray__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__s_Option__sc_Seq(key, array$6, propertyMapping, new $c_s_Some().init___O(entry$11.annotations$1));
                  break matchEnd16
                }
              };
              var x$21 = $m_s_None$();
              if ((x$21 === x1$1)) {
                var nextEmitter = $m_sci_Nil$();
                break matchEnd16
              };
              throw new $c_s_MatchError().init___O(x1$1)
            };
            var jsx$22 = $as_sc_Seq(emitters$1.elem$1);
            var this$32 = $m_sc_Seq$();
            emitters$1.elem$1 = $as_sc_Seq(jsx$22.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(nextEmitter, this$32.ReusableCBFInstance$2))
          }
        }
      })
    })(this, emitters)));
    if (this.rootNode$1) {
      var jsx$24 = $as_sc_Seq(emitters.elem$1);
      var jsx$23 = this.declarationsEmitters__sc_Seq();
      var this$33 = $m_sc_Seq$();
      emitters.elem$1 = $as_sc_Seq(jsx$24.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$23, this$33.ReusableCBFInstance$2))
    };
    if (this.rootNode$1) {
      var jsx$27 = $as_sc_Seq(emitters.elem$1);
      var jsx$26 = $m_sc_Seq$();
      var array$7 = [new $c_Lamf_plugins_document_vocabularies_emitters_instances_ReferencesEmitter().init___Lamf_core_model_document_BaseUnit__Lamf_core_emitter_SpecOrdering__sci_Map(this.instance$1, this.ordering$1, this.aliases$1)];
      var jsx$25 = jsx$26.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$7));
      var this$36 = $m_sc_Seq$();
      emitters.elem$1 = $as_sc_Seq(jsx$27.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$25, this$36.ReusableCBFInstance$2))
    };
    var jsx$28 = b.builder$1;
    var sourceName = b.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    this.ordering$1.sorted__sc_Seq__sc_Seq($as_sc_Seq(emitters.elem$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$2) {
      return (function(x$19$2) {
        var x$19 = $as_Lamf_core_emitter_EntryEmitter(x$19$2);
        x$19.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$2)
      })
    })(this, b$1)));
    jsx$28.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter)) {
    var DialectNodeEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter(x$1);
    var x = this.node$1;
    var x$2 = DialectNodeEmitter$1.node$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.nodeMappable$1;
      var x$4 = DialectNodeEmitter$1.nodeMappable$1;
      var jsx$9 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$9 = false
    };
    if (jsx$9) {
      var x$5 = this.instance$1;
      var x$6 = DialectNodeEmitter$1.instance$1;
      var jsx$8 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$8 = false
    };
    if (jsx$8) {
      var x$7 = this.dialect$1;
      var x$8 = DialectNodeEmitter$1.dialect$1;
      var jsx$7 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$7 = false
    };
    if (jsx$7) {
      var x$9 = this.ordering$1;
      var x$10 = DialectNodeEmitter$1.ordering$1;
      var jsx$6 = (x$9 === x$10)
    } else {
      var jsx$6 = false
    };
    if (jsx$6) {
      var x$11 = this.aliases$1;
      var x$12 = DialectNodeEmitter$1.aliases$1;
      var jsx$5 = ((x$11 === null) ? (x$12 === null) : $f_sc_GenMapLike__equals__O__Z(x$11, x$12))
    } else {
      var jsx$5 = false
    };
    if (jsx$5) {
      var x$13 = this.keyPropertyId$1;
      var x$14 = DialectNodeEmitter$1.keyPropertyId$1;
      var jsx$4 = ((x$13 === null) ? (x$14 === null) : x$13.equals__O__Z(x$14))
    } else {
      var jsx$4 = false
    };
    if ((jsx$4 && (this.rootNode$1 === DialectNodeEmitter$1.rootNode$1))) {
      var x$15 = this.discriminatorMappable$1;
      var x$16 = DialectNodeEmitter$1.discriminatorMappable$1;
      var jsx$3 = ((x$15 === null) ? (x$16 === null) : x$15.equals__O__Z(x$16))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$17 = this.discriminator$1;
      var x$18 = DialectNodeEmitter$1.discriminator$1;
      var jsx$2 = ((x$17 === null) ? (x$18 === null) : x$17.equals__O__Z(x$18))
    } else {
      var jsx$2 = false
    };
    if ((jsx$2 && (this.emitDialect$1 === DialectNodeEmitter$1.emitDialect$1))) {
      var x$19 = this.topLevelEmitters$1;
      var x$20 = DialectNodeEmitter$1.topLevelEmitters$1;
      var jsx$1 = ((x$19 === null) ? (x$20 === null) : x$19.equals__O__Z(x$20))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$21 = this.renderOptions$1;
      var x$22 = DialectNodeEmitter$1.renderOptions$1;
      return (x$21 === x$22)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.node$1;
      break
    }
    case 1: {
      return this.nodeMappable$1;
      break
    }
    case 2: {
      return this.instance$1;
      break
    }
    case 3: {
      return this.dialect$1;
      break
    }
    case 4: {
      return this.ordering$1;
      break
    }
    case 5: {
      return this.aliases$1;
      break
    }
    case 6: {
      return this.keyPropertyId$1;
      break
    }
    case 7: {
      return this.rootNode$1;
      break
    }
    case 8: {
      return this.discriminatorMappable$1;
      break
    }
    case 9: {
      return this.discriminator$1;
      break
    }
    case 10: {
      return this.emitDialect$1;
      break
    }
    case 11: {
      return this.topLevelEmitters$1;
      break
    }
    case 12: {
      return this.renderOptions$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.emitLibrarRef__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(elem, instance, b) {
  if (elem.annotations$1.contains__jl_Class__Z($d_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef.getClassOf())) {
    var jsx$2 = b.builder$1;
    var sourceName = b.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("$ref");
    $m_Lorg_yaml_model_YNode$();
    var this$3 = this.node$1;
    var this$4 = $as_Lamf_core_model_StrField(this$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1;
    if (this$4.isEmpty__Z()) {
      var this$5 = this.node$1;
      var jsx$1 = $as_Lamf_core_model_domain_AmfObject($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$5).get__O()).id__T()
    } else {
      var jsx$1 = this$4.get__O()
    };
    var str = $as_T(jsx$1);
    var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value);
    jsx$2.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  } else {
    var lib = instance.references__sc_Seq().find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, elem$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_model_document_BaseUnit(x0$1$2);
        return ($is_Lamf_core_model_document_DeclaresModel(x0$1) && $as_Lamf_core_model_document_DeclaresModel(x0$1).declares__sc_Seq().exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, elem$3) {
          return (function(x$42$2) {
            var x$42 = $as_Lamf_core_model_domain_DomainElement(x$42$2);
            return (x$42.id__T() === $as_Lamf_core_model_domain_AmfObject($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(elem$3).get__O()).id__T())
          })
        })(this$2$1, elem$1))))
      })
    })(this, elem)));
    var alias = $as_T($as_T2(this.aliases$1.apply__O__O($as_Lamf_core_model_domain_AmfObject(lib.get__O()).id__T())).$$und1__O());
    new $c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter().init___T__Lamf_core_parser_Annotations__Lorg_yaml_model_YType(((alias + ".") + elem.localRefName__T()), elem.annotations$1, $m_Lorg_yaml_model_YType$().Str$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b)
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.findAllNodeMappings__T__sc_Seq = (function(mappableId) {
  var x1 = $f_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__findNodeMappingById__T__T2(this, mappableId);
  if ((x1 !== null)) {
    var nodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1.$$und2__O());
    if ((nodeMapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
      var x4 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(nodeMapping);
      var jsx$1 = $m_sc_Seq$();
      var array = [x4];
      return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
    }
  };
  if ((x1 !== null)) {
    var unionMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1.$$und2__O());
    if ((unionMapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping)) {
      var x5 = $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(unionMapping);
      var jsx$3 = $as_sc_Seq(x5.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1));
      var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(rangeId$2) {
          var rangeId = $as_Lamf_core_model_StrField(rangeId$2);
          var this$3 = rangeId.option$1;
          var nodeMappingId = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
          return $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable($f_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__findNodeMappingById__T__T2($this, nodeMappingId).$$und2__O())
        })
      })(this));
      var this$4 = $m_sc_Seq$();
      var mappables = $as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$4.ReusableCBFInstance$2));
      var jsx$4 = new $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$findAllNodeMappings$2().init___Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter(this);
      var this$5 = $m_sc_Seq$();
      return $as_sc_Seq(mappables.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$4, this$5.ReusableCBFInstance$2))
    }
  };
  return $m_sci_Nil$()
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.emitObjectEntry__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__s_Option__sc_Seq = (function(key, target, propertyMapping, annotations) {
  if ((target instanceof $c_Lamf_core_model_domain_AmfArray)) {
    var x2 = $as_Lamf_core_model_domain_AmfArray(target);
    var elements = x2.values$1
  } else {
    if ((!(target instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement))) {
      throw new $c_s_MatchError().init___O(target)
    };
    var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(target);
    var jsx$1 = $m_sc_Seq$();
    var array = [x3];
    var elements = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  };
  var isArray = (target instanceof $c_Lamf_core_model_domain_AmfArray);
  var discriminator = new $c_Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper().init___Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper(propertyMapping, this);
  var jsx$2 = $m_sc_Seq$();
  var array$1 = [new $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$4().init___Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__sc_Seq__Lamf_plugins_document_vocabularies_emitters_instances_DiscriminatorHelper__Z__T__s_Option__Lamf_core_model_domain_AmfElement(this, propertyMapping, elements, discriminator, isArray, key, annotations, target)];
  return $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.emitObjectPairs__T__Lamf_core_model_domain_AmfArray__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__s_Option__sc_Seq = (function(key, array, propertyMapping, annotations) {
  var this$1 = $as_Lamf_core_model_StrField(propertyMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermKeyProperty$1));
  var this$2 = this$1.option$1;
  var keyProperty = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  var this$3 = $as_Lamf_core_model_StrField(propertyMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermValueProperty$1));
  var this$4 = this$3.option$1;
  var valueProperty = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
  var jsx$1 = $m_sc_Seq$();
  var array$1 = [new $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$5().init___Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter__T__Lamf_core_model_domain_AmfArray__T__T__s_Option(this, key, array, keyProperty, valueProperty, annotations)];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect = (function() {
  return this.dialect$1
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.emitScalar__T__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfScalar__s_Option__sc_Seq = (function(key, field, scalar, annotations) {
  var x1 = scalar.value$1;
  if ((x1 instanceof $c_Lorg_mulesoft_common_time_SimpleDateTime)) {
    var x2 = $as_Lorg_mulesoft_common_time_SimpleDateTime(x1);
    var formatted = x2.toString__T()
  } else {
    var formatted = x1
  };
  var jsx$1 = $m_sc_Seq$();
  var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(formatted, new $c_Lamf_core_parser_Annotations().init___());
  var annotations$1 = $as_Lamf_core_parser_Annotations((annotations.isEmpty__Z() ? scalar.annotations$1 : annotations.get__O()));
  var array = [new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(key, new $c_Lamf_core_parser_FieldEntry().init___Lamf_core_metamodel_Field__Lamf_core_parser_Value(field, new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value, annotations$1)), $m_s_None$())];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.nodeMappingForObjectProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__s_Option = (function(propertyMapping, dialectDomainElement) {
  var jsx$2 = $as_sc_Seq(propertyMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(rangeNodeMapping$2) {
      var rangeNodeMapping = $as_Lamf_core_model_StrField(rangeNodeMapping$2);
      var this$1 = rangeNodeMapping.option$1;
      return $this.findAllNodeMappings__T__sc_Seq($as_T((this$1.isEmpty__Z() ? null : this$1.get__O())))
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  var nodeMappings = $as_sc_Seq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  return nodeMappings.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, dialectDomainElement$1) {
    return (function(nodeMapping$2) {
      var nodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(nodeMapping$2);
      var this$4 = dialectDomainElement$1.meta__Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel().type$1;
      var f = (function($this$1) {
        return (function(x$31$2) {
          var x$31 = $as_Lamf_core_vocabulary_ValueType(x$31$2);
          return x$31.iri__T()
        })
      })(this$2$1);
      var this$3 = $m_sci_List$();
      var bf = this$3.ReusableCBFInstance$2;
      if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
        if ((this$4 === $m_sci_Nil$())) {
          var jsx$3 = $m_sci_Nil$()
        } else {
          var arg1 = this$4.head__O();
          var h = new $c_sci_$colon$colon().init___O__sci_List(f(arg1), $m_sci_Nil$());
          var t = h;
          var rest = $as_sci_List(this$4.tail__O());
          while ((rest !== $m_sci_Nil$())) {
            var arg1$1 = rest.head__O();
            var nx = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$1), $m_sci_Nil$());
            t.tl$5 = nx;
            t = nx;
            rest = $as_sci_List(rest.tail__O())
          };
          var jsx$3 = h
        }
      } else {
        var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$4, bf);
        var these = this$4;
        while ((!these.isEmpty__Z())) {
          var arg1$2 = these.head__O();
          b.$$plus$eq__O__scm_Builder(f(arg1$2));
          these = $as_sci_List(these.tail__O())
        };
        var jsx$3 = b.result__O()
      };
      var this$5 = $as_sc_LinearSeqOptimized(jsx$3);
      var these$1 = this$5;
      while ((!these$1.isEmpty__Z())) {
        var arg1$3 = these$1.head__O();
        var i = $as_T(arg1$3);
        var this$6 = $as_Lamf_core_model_StrField(nodeMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().NodeTypeMapping$1));
        var this$7 = this$6.option$1;
        if (((i === $as_T((this$7.isEmpty__Z() ? null : this$7.get__O()))) || (i === nodeMapping.id$1))) {
          return true
        };
        these$1 = $as_sc_LinearSeqOptimized(these$1.tail__O())
      };
      return false
    })
  })(this, dialectDomainElement)))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.declares__p1__s_Option = (function() {
  var x1 = this.instance$1;
  return ($is_Lamf_core_model_document_DeclaresModel(x1) ? new $c_s_Some().init___O(x1) : $m_s_None$())
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.emitRef__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YDocument$PartBuilder__V = (function(node, b) {
  if (node.annotations$1.contains__jl_Class__Z($d_Lamf_plugins_document_vocabularies_annotations_JsonPointerRef.getClassOf())) {
    var jsx$1 = b.builder$1;
    var sourceName = b.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("$ref");
    $m_Lorg_yaml_model_YNode$();
    var this$3 = $as_Lamf_core_model_StrField(node.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1;
    var str = $as_T((this$3.isEmpty__Z() ? $as_Lamf_core_model_domain_AmfObject($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(node).get__O()).id__T() : this$3.get__O()));
    var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value);
    jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  } else {
    new $c_Lamf_core_emitter_BaseEmitters_package$TextScalarEmitter().init___T__Lamf_core_parser_Annotations__Lorg_yaml_model_YType(node.localRefName__T(), node.annotations$1, $m_Lorg_yaml_model_YType$().Str$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b)
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.isFragment__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__Z = (function(elem, instance) {
  var x1 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(elem);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var domainElement = $as_Lamf_core_model_domain_DomainElement(x2.value$2);
    return instance.references__sc_Seq().exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, domainElement$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_model_document_BaseUnit(x0$1$2);
        if ((x0$1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment)) {
          var x2$1 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment(x0$1);
          return ($as_Lamf_core_model_domain_DomainElement(x2$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().Encodes$1)).id__T() === domainElement$1.id__T())
        } else {
          return false
        }
      })
    })(this, domainElement)))
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot check fragment for an element without target for element " + elem.id$1)))
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.declarationsEmitters__sc_Seq = (function() {
  var jsx$1 = $m_s_Option$();
  var this$1 = this.dialect$1;
  var this$2 = jsx$1.apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1)));
  if (this$2.isEmpty__Z()) {
    var emitters = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var docs = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(arg1);
    var this$3 = $m_s_Option$().apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(docs.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Root$1)));
    if (this$3.isEmpty__Z()) {
      var emitters = $m_s_None$()
    } else {
      var arg1$1 = this$3.get__O();
      var root = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(arg1$1);
      var this$4 = this.declares__p1__s_Option();
      if (this$4.isEmpty__Z()) {
        var emitters = $m_s_None$()
      } else {
        var arg1$2 = this$4.get__O();
        var model = $as_Lamf_core_model_document_DeclaresModel(arg1$2);
        var this$5 = $as_Lamf_core_model_StrField(root.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().EncodedNode$1));
        var this$6 = this$5.option$1;
        var emitters = new $c_s_Some().init___O((($as_T((this$6.isEmpty__Z() ? null : this$6.get__O())) === this.node$1.id$1) ? $m_sci_Nil$() : $as_sc_Seq($as_sc_Seq(root.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DeclaredNodes$1)).foldLeft__O__F2__O($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this, model$1, docs$1) {
          return (function(x0$1$2, x1$1$2) {
            var x0$1 = $as_sc_Seq(x0$1$2);
            var x1$1 = $as_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping(x1$1$2);
            var this$7 = $as_Lamf_core_model_StrField(x1$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().MappedNode$1));
            var this$8 = this$7.option$1;
            var jsx$3 = $this.findAllNodeMappings__T__sc_Seq($as_T((this$8.isEmpty__Z() ? null : this$8.get__O())));
            var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
              return (function(x$43$2) {
                var x$43 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x$43$2);
                return x$43.id$1
              })
            })($this));
            var this$9 = $m_sc_Seq$();
            var publicMappings = $as_sc_TraversableOnce(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$9.ReusableCBFInstance$2)).toSet__sci_Set();
            var jsx$5 = model$1.declares__sc_Seq();
            var jsx$4 = new $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$2().init___Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter__sci_Set($this, publicMappings);
            var this$10 = $m_sc_Seq$();
            var declared = $as_sc_Seq(jsx$5.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$4, this$10.ReusableCBFInstance$2));
            if (declared.nonEmpty__Z()) {
              var this$11 = $as_Lamf_core_model_StrField(x1$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().MappedNode$1));
              var this$12 = this$11.option$1;
              var nodeMappingId = $as_T((this$12.isEmpty__Z() ? null : this$12.get__O()));
              var x1$2 = $f_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__findNodeMappingById__T__T2($this, nodeMappingId);
              if ((x1$2 !== null)) {
                var nodeMappable = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1$2.$$und2__O());
                if ((nodeMappable !== null)) {
                  var jsx$8 = $m_sc_Seq$();
                  var x$4 = $this.instance$1;
                  var x$5 = $this.dialect$1;
                  var x$6 = $this.ordering$1;
                  var jsx$7 = $m_s_Predef$();
                  var this$13 = $as_Lamf_core_model_StrField(docs$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().DeclarationsPath$1)).option$1;
                  var thiz = $as_T((this$13.isEmpty__Z() ? "/" : this$13.get__O()));
                  var x$7 = jsx$7.wrapRefArray__AO__scm_WrappedArray($m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "/", 0));
                  var x$8 = $this.aliases$1;
                  var x$9 = $this.renderOptions$1;
                  var x$10 = $m_s_None$();
                  var array = [new $c_Lamf_plugins_document_vocabularies_emitters_instances_DeclarationsGroupEmitter().init___sc_Seq__Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sc_Seq__sci_Map__s_Option__Lamf_core_emitter_RenderOptions(declared, x1$1, nodeMappable, x$4, x$5, x$6, x$7, x$8, x$10, x$9)];
                  var jsx$6 = jsx$8.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
                  var this$18 = $m_sc_Seq$();
                  return $as_sc_Seq(x0$1.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$6, this$18.ReusableCBFInstance$2))
                }
              };
              throw new $c_s_MatchError().init___O(x1$2)
            } else {
              return x0$1
            }
          })
        })(this, model, docs))))))
      }
    }
  };
  return $as_sc_Seq((emitters.isEmpty__Z() ? $m_sci_Nil$() : emitters.get__O()))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.emitScalarArray__T__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfArray__s_Option__sc_Seq = (function(key, field, array, annotations) {
  var jsx$1 = $m_sc_Seq$();
  var annotations$1 = $as_Lamf_core_parser_Annotations((annotations.isEmpty__Z() ? array.annotations$1 : annotations.get__O()));
  var array$1 = [new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType(key, new $c_Lamf_core_parser_FieldEntry().init___Lamf_core_metamodel_Field__Lamf_core_parser_Value(field, new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(array, annotations$1)), this.ordering$1, false, $m_Lorg_yaml_model_YType$().Str$1)];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.uniqueFields__Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel__sc_Iterable = (function(meta) {
  var allFields = meta.fields$1;
  var elem = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var elem$1 = null;
  elem$1 = elem;
  var these = allFields;
  while ((!these.isEmpty__Z())) {
    var arg1 = these.head__O();
    var f = $as_Lamf_core_metamodel_Field(arg1);
    var x1 = $as_sci_Map(elem$1).get__O__s_Option(f.value$1.iri__T());
    if ((!(x1 instanceof $c_s_Some))) {
      elem$1 = $as_sci_Map(elem$1).updated__O__O__sci_Map(f.value$1.iri__T(), f)
    };
    these = $as_sci_List(these.tail__O())
  };
  var this$2 = $as_sci_Map(elem$1);
  return new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$2)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.emitExternalObject__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__sc_Seq = (function(key, element, propertyMapping) {
  var nodeMappingId = element.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping().id$1;
  var x1 = $f_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__findNodeMappingById__T__T2(this, nodeMappingId);
  if ((x1 === null)) {
    throw new $c_s_MatchError().init___O(x1)
  };
  var externalDialect = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(x1.$$und1__O());
  var nextNodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1.$$und2__O());
  var jsx$1 = $m_sc_Seq$();
  var x$3 = this.instance$1;
  var x$5 = this.ordering$1;
  var x$6 = this.aliases$1;
  var x$8 = this.renderOptions$1;
  var x$9 = $m_s_None$();
  var x$11 = $m_s_None$();
  var x$12 = $m_s_None$();
  var x$13 = $m_sci_Nil$();
  var array = [new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position(key, new $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter().init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit__Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sci_Map__s_Option__Z__s_Option__s_Option__Z__sc_Seq__Lamf_core_emitter_RenderOptions(element, nextNodeMapping, x$3, externalDialect, x$5, x$6, x$9, false, x$11, x$12, true, x$13, x$8), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$())];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.emitCustomId__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YDocument$PartBuilder__V = (function(elem, b) {
  var rc6 = false;
  var x2 = null;
  var x1 = elem.annotations$1.find__jl_Class__s_Option($d_Lamf_plugins_document_vocabularies_annotations_CustomId.getClassOf());
  matchEnd7: {
    if ((x1 instanceof $c_s_Some)) {
      rc6 = true;
      x2 = $as_s_Some(x1);
      var customId = $as_Lamf_plugins_document_vocabularies_annotations_CustomId(x2.value$2);
      if ((customId.value$1 !== "true")) {
        var jsx$1 = b.builder$1;
        var sourceName = b.sourceName$2;
        var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
        $m_Lorg_yaml_model_YNode$();
        var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("$id");
        $m_Lorg_yaml_model_YNode$();
        var str = customId.value$1;
        var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
        b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value);
        jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
        break matchEnd7
      }
    };
    if (rc6) {
      var jsx$2 = b.builder$1;
      var sourceName$1 = b.sourceName$2;
      var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
      $m_Lorg_yaml_model_YNode$();
      var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("$id");
      $m_Lorg_yaml_model_YNode$();
      var str$1 = elem.id$1;
      var value$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
      b$2.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$1, value$1);
      jsx$2.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1));
      break matchEnd7
    };
    b.$$plus$eq__T__V(elem.id$1)
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.node$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.nodeMappable$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.instance$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.dialect$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ordering$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.aliases$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.keyPropertyId$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.rootNode$1 ? 1231 : 1237));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.discriminatorMappable$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.discriminator$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.emitDialect$1 ? 1231 : 1237));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.topLevelEmitters$1));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.renderOptions$1));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 13)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.emitExternalLink__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__s_Option__sc_Seq = (function(key, target, propertyMapping, annotations) {
  var jsx$1 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anon$3().init___Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter__T__Lamf_core_model_domain_AmfElement__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__s_Option(this, key, target, propertyMapping, annotations)];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.findPropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_core_metamodel_Field__s_Option = (function(node, field) {
  var iri = field.value$1.iri__T();
  var x1 = this.nodeMappable$1;
  if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x1);
    return $as_sc_Seq(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, iri$1) {
      return (function(x$44$2) {
        var x$44 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$44$2);
        var this$1 = $as_Lamf_core_model_StrField(x$44.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
        var this$2 = this$1.option$1;
        return ($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())) === iri$1)
      })
    })(this, iri)))
  } else if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping)) {
    var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(x1);
    var jsx$2 = $as_sc_Seq(x3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(x$45$2) {
        var x$45 = $as_Lamf_core_model_StrField(x$45$2);
        var this$3 = x$45.option$1;
        return $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()))
      })
    })(this));
    var this$4 = $m_sc_Seq$();
    var rangeIds = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2));
    var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
      return (function(id$2) {
        var id = $as_T(id$2);
        var x1$1 = $f_Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper__findNodeMappingById__T__T2(this$3$1, id);
        if ((x1$1 !== null)) {
          var nodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(x1$1.$$und2__O());
          if ((nodeMapping instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
            var x3$1 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(nodeMapping);
            return new $c_s_Some().init___O(x3$1)
          }
        };
        return $m_s_None$()
      })
    })(this));
    var this$5 = $m_sc_Seq$();
    var jsx$4 = $as_sc_TraversableLike(rangeIds.map__F1__scg_CanBuildFrom__O(jsx$5, this$5.ReusableCBFInstance$2));
    var jsx$3 = new $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter$$anonfun$3().init___Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter(this);
    var this$6 = $m_sc_Seq$();
    var nodeMappingsInRange = $as_sc_Seq(jsx$4.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$3, this$6.ReusableCBFInstance$2));
    var jsx$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
      return (function(x$46$2) {
        var x$46 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x$46$2);
        return $as_sc_Seq(x$46.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1))
      })
    })(this));
    var this$7 = $m_sc_Seq$();
    return $as_sc_IterableLike(nodeMappingsInRange.flatMap__F1__scg_CanBuildFrom__O(jsx$6, this$7.ReusableCBFInstance$2)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1, iri$2) {
      return (function(x$47$2) {
        var x$47 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$47$2);
        var this$8 = $as_Lamf_core_model_StrField(x$47.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
        var this$9 = this$8.option$1;
        return ($as_T((this$9.isEmpty__Z() ? null : this$9.get__O())) === iri$2)
      })
    })(this, iri)))
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.node$1.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$20 = $as_Lamf_core_annotations_LexicalInformation(arg1);
    var this$2 = new $c_s_Some().init___O(x$20.range__Lamf_core_parser_Range().start$1)
  };
  return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
});
function $as_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.instances.DialectNodeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.instances.DialectNodeEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.instances.DialectNodeEmitter", {
  Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_instances_DialectNodeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter() {
  $c_O.call(this);
  this.classTerm$1 = null;
  this.ordering$1 = null;
  this.aliasMapping$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter.prototype.productPrefix__T = (function() {
  return "ClassTermEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter)) {
    var ClassTermEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter(x$1);
    var x = this.classTerm$1;
    var x$2 = ClassTermEmitter$1.classTerm$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = ClassTermEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.aliasMapping$1;
      var x$6 = ClassTermEmitter$1.aliasMapping$1;
      return ((x$5 === null) ? (x$6 === null) : $f_sc_GenMapLike__equals__O__Z(x$5, x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.classTerm$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.aliasMapping$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter.prototype.init___Lamf_plugins_document_vocabularies_model_domain_ClassTerm__Lamf_core_emitter_SpecOrdering__sci_Map = (function(classTerm, ordering, aliasMapping) {
  this.classTerm$1 = classTerm;
  this.ordering$1 = ordering;
  this.aliasMapping$1 = aliasMapping;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var id = this.classTerm$1.id$1;
  var aliasMapping = this.aliasMapping$1;
  var classAlias = $f_Lamf_plugins_document_vocabularies_emitters_vocabularies_AliasMapper__aliasFor__T__sci_Map__T(this, id, aliasMapping);
  var elem = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var elem$1 = null;
  elem$1 = elem;
  var this$2 = this.classTerm$1;
  var this$3 = $as_Lamf_core_model_StrField(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().DisplayName$1)).option$1;
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var displayName = $as_T(arg1);
    var jsx$3 = $as_sc_Seq(elem$1);
    var jsx$2 = $m_sc_Seq$();
    var array = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("displayName", displayName, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$())];
    var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$8 = $m_sc_Seq$();
    elem$1 = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$8.ReusableCBFInstance$2))
  };
  var this$9 = this.classTerm$1;
  var this$10 = $as_Lamf_core_model_StrField(this$9.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().Description$1)).option$1;
  if ((!this$10.isEmpty__Z())) {
    var arg1$1 = this$10.get__O();
    var description = $as_T(arg1$1);
    var jsx$6 = $as_sc_Seq(elem$1);
    var jsx$5 = $m_sc_Seq$();
    var array$1 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("description", description, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$())];
    var jsx$4 = jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
    var this$15 = $m_sc_Seq$();
    elem$1 = $as_sc_Seq(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$15.ReusableCBFInstance$2))
  };
  var this$16 = this.classTerm$1;
  if ($as_sc_Seq(this$16.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().SubClassOf$1)).nonEmpty__Z()) {
    var jsx$9 = $as_sc_Seq(elem$1);
    var jsx$8 = $m_sc_Seq$();
    var array$2 = [new $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$1().init___Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter(this)];
    var jsx$7 = jsx$8.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2));
    var this$19 = $m_sc_Seq$();
    elem$1 = $as_sc_Seq(jsx$9.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$7, this$19.ReusableCBFInstance$2))
  };
  var this$20 = this.classTerm$1;
  if ($as_sc_Seq(this$20.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().Properties$1)).nonEmpty__Z()) {
    var jsx$12 = $as_sc_Seq(elem$1);
    var jsx$11 = $m_sc_Seq$();
    var array$3 = [new $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter$$anon$2().init___Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter(this)];
    var jsx$10 = jsx$11.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$3));
    var this$23 = $m_sc_Seq$();
    elem$1 = $as_sc_Seq(jsx$12.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$10, this$23.ReusableCBFInstance$2))
  };
  if ($as_sc_Seq(elem$1).isEmpty__Z()) {
    new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position(classAlias, "", $m_Lorg_yaml_model_YType$().Null$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
  } else {
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(classAlias);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$13 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq($as_sc_Seq(elem$1)), b$1);
    jsx$13.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
    var this$29 = v.builder$1;
    var array$4 = [key];
    if ((this$29.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array$4.length);
    var newSize = ((this$29.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$29, newSize);
    var len$1 = this$29.size0$6;
    var src = this$29.array$6;
    var dest = this$29.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$29.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array$4.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$14 = j;
      var index = i;
      xs.set(jsx$14, array$4[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$29.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.classTerm$1.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$6 = $as_Lamf_core_annotations_LexicalInformation(arg1);
    var this$2 = new $c_s_Some().init___O(x$6.range__Lamf_core_parser_Range().start$1)
  };
  return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
});
function $as_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.vocabularies.ClassTermEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.vocabularies.ClassTermEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.vocabularies.ClassTermEmitter", {
  Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  Lamf_plugins_document_vocabularies_emitters_vocabularies_AliasMapper: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_ClassTermEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter() {
  $c_O.call(this);
  this.propertyTerm$1 = null;
  this.ordering$1 = null;
  this.aliasMapping$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter.prototype.productPrefix__T = (function() {
  return "PropertyTermEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter)) {
    var PropertyTermEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter(x$1);
    var x = this.propertyTerm$1;
    var x$2 = PropertyTermEmitter$1.propertyTerm$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = PropertyTermEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.aliasMapping$1;
      var x$6 = PropertyTermEmitter$1.aliasMapping$1;
      return ((x$5 === null) ? (x$6 === null) : $f_sc_GenMapLike__equals__O__Z(x$5, x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.propertyTerm$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.aliasMapping$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var id = this.propertyTerm$1.id$1;
  var aliasMapping = this.aliasMapping$1;
  var propertyAlias = $f_Lamf_plugins_document_vocabularies_emitters_vocabularies_AliasMapper__aliasFor__T__sci_Map__T(this, id, aliasMapping);
  var elem = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var elem$1 = null;
  elem$1 = elem;
  var this$2 = this.propertyTerm$1;
  var this$3 = $as_Lamf_core_model_StrField(this$2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().DisplayName$1)).option$1;
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var displayName = $as_T(arg1);
    var jsx$3 = $as_sc_Seq(elem$1);
    var jsx$2 = $m_sc_Seq$();
    var array = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("displayName", displayName, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$())];
    var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$8 = $m_sc_Seq$();
    elem$1 = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$8.ReusableCBFInstance$2))
  };
  var this$9 = this.propertyTerm$1;
  var this$10 = $as_Lamf_core_model_StrField(this$9.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().Description$1)).option$1;
  if ((!this$10.isEmpty__Z())) {
    var arg1$1 = this$10.get__O();
    var description = $as_T(arg1$1);
    var jsx$6 = $as_sc_Seq(elem$1);
    var jsx$5 = $m_sc_Seq$();
    var array$1 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("description", description, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$())];
    var jsx$4 = jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
    var this$15 = $m_sc_Seq$();
    elem$1 = $as_sc_Seq(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$15.ReusableCBFInstance$2))
  };
  var this$16 = this.propertyTerm$1;
  if ($as_sc_Seq(this$16.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().SubPropertyOf$1)).nonEmpty__Z()) {
    var jsx$9 = $as_sc_Seq(elem$1);
    var jsx$8 = $m_sc_Seq$();
    var array$2 = [new $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$3().init___Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter(this)];
    var jsx$7 = jsx$8.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2));
    var this$19 = $m_sc_Seq$();
    elem$1 = $as_sc_Seq(jsx$9.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$7, this$19.ReusableCBFInstance$2))
  };
  var this$20 = this.propertyTerm$1;
  var this$21 = $as_Lamf_core_model_StrField(this$20.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$().Range$1));
  if (this$21.option$1.isDefined__Z()) {
    var jsx$12 = $as_sc_Seq(elem$1);
    var jsx$11 = $m_sc_Seq$();
    var array$3 = [new $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter$$anon$4().init___Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter(this)];
    var jsx$10 = jsx$11.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$3));
    var this$24 = $m_sc_Seq$();
    elem$1 = $as_sc_Seq(jsx$12.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$10, this$24.ReusableCBFInstance$2))
  };
  if ($as_sc_Seq(elem$1).isEmpty__Z()) {
    new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position(propertyAlias, "", $m_Lorg_yaml_model_YType$().Null$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
  } else {
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(propertyAlias);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$13 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq($as_sc_Seq(elem$1)), b$1);
    jsx$13.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
    var this$30 = v.builder$1;
    var array$4 = [key];
    if ((this$30.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array$4.length);
    var newSize = ((this$30.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$30, newSize);
    var len$1 = this$30.size0$6;
    var src = this$30.array$6;
    var dest = this$30.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$30.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array$4.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$14 = j;
      var index = i;
      xs.set(jsx$14, array$4[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$30.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter.prototype.init___Lamf_plugins_document_vocabularies_model_domain_PropertyTerm__Lamf_core_emitter_SpecOrdering__sci_Map = (function(propertyTerm, ordering, aliasMapping) {
  this.propertyTerm$1 = propertyTerm;
  this.ordering$1 = ordering;
  this.aliasMapping$1 = aliasMapping;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.propertyTerm$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$11 = $as_Lamf_core_annotations_LexicalInformation(arg1);
    var this$2 = new $c_s_Some().init___O(x$11.range__Lamf_core_parser_Range().start$1)
  };
  return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
});
function $as_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.vocabularies.PropertyTermEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.vocabularies.PropertyTermEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.vocabularies.PropertyTermEmitter", {
  Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  Lamf_plugins_document_vocabularies_emitters_vocabularies_AliasMapper: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_vocabularies_PropertyTermEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$() {
  $c_O.call(this);
  this.NodeTypeMapping$1 = null;
  this.PropertiesMapping$1 = null;
  this.IdTemplate$1 = null;
  this.ResolvedExtends$1 = null;
  this.type$1 = null;
  this.Name$1 = null;
  this.MergePolicy$1 = null;
  this.ALLOWED$undMERGE$undPOLICY$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.doc$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype.Extends$lzycompute__p1__Lamf_core_metamodel_Field = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.Extends$1 = $f_Lamf_core_metamodel_domain_DomainElementModel__Extends__Lamf_core_metamodel_Field(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.Extends$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_metamodel_domain_MergeableMappingModel__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappableModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.NodeTypeMapping$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "targetClass"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "target class", "Target class whose instances will need to match the constraint described for the node", $m_sci_Nil$()), true);
  var jsx$2 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$());
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.PropertiesMapping$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "property"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "property", "Data shape constraint for a property of the target node", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_core_metamodel_Type$Str$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.IdTemplate$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "uriTemplate"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "uriTemplate", "URI template that will be used to generate the URI of the parsed nodeds in the graph", $m_sci_Nil$()), true);
  var jsx$4 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Iri$());
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.ResolvedExtends$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "resolvedExtends"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true);
  var this$15 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  var x$8 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$15, "NodeMapping");
  var this$17 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$7 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$17, "Shape");
  var this$19 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  var this$20 = new $c_sci_$colon$colon().init___O__sci_List(x$7, this$19);
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$8, this$20);
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype.amf$plugins$document$vocabularies$metamodel$domain$NodeMappableModel$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  this.doc$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype.Extends__Lamf_core_metamodel_Field = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.Extends$lzycompute__p1__Lamf_core_metamodel_Field() : this.Extends$1)
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype.fields__sci_List = (function() {
  var x$6 = this.NodeTypeMapping$1;
  var x$5 = this.Name$1;
  var x$4 = this.PropertiesMapping$1;
  var x$3 = this.IdTemplate$1;
  var x$2 = this.MergePolicy$1;
  var x$1 = this.ResolvedExtends$1;
  var jsx$2 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().fields$1;
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$1 = $m_sci_List$();
  var this$2 = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  var this$3 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$2);
  var this$4 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$3);
  var this$5 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$4);
  var this$6 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$5);
  var this$7 = new $c_sci_$colon$colon().init___O__sci_List(x$5, this$6);
  return new $c_sci_$colon$colon().init___O__sci_List(x$6, this$7)
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype.amf$plugins$document$vocabularies$metamodel$domain$MergeableMappingModel$$undsetter$und$MergePolicy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.MergePolicy$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype.amf$plugins$document$vocabularies$metamodel$domain$MergeableMappingModel$$undsetter$und$ALLOWED$undMERGE$undPOLICY$und$eq__sci_Set__V = (function(x$1) {
  this.ALLOWED$undMERGE$undPOLICY$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$: 0
}, false, "amf.plugins.document.vocabularies.metamodel.domain.NodeMappingModel$", {
  Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_plugins_document_vocabularies_metamodel_domain_MergeableMappingModel: 1,
  Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappableModel: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$;
var $n_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$() {
  if ((!$n_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$)) {
    $n_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$ = new $c_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_ClassTerm() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.productPrefix__T = (function() {
  return "ClassTerm"
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return this.adopted__T__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_ClassTerm(parent, cycle)
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm)) {
    var ClassTerm$1 = $as_Lamf_plugins_document_vocabularies_model_domain_ClassTerm(x$1);
    var x = this.fields$1;
    var x$2 = ClassTerm$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = ClassTerm$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.withProperties__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_ClassTerm = (function(properties) {
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().Properties$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_T(x$1$2);
      return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(x$1, new $c_Lamf_core_parser_Annotations().init___())
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(properties.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2)), new $c_Lamf_core_parser_Annotations().init___());
  return $as_Lamf_plugins_document_vocabularies_model_domain_ClassTerm($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, value))
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$()
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.adopted__T__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_ClassTerm = (function(parent, cycle) {
  if ($m_s_Option$().apply__O__s_Option(this.id$1).isEmpty__Z()) {
    $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
  };
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.withSubClassOf__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_ClassTerm = (function(superClasses) {
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().SubClassOf$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_T(x$2$2);
      return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(x$2, new $c_Lamf_core_parser_Annotations().init___())
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(superClasses.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2)), new $c_Lamf_core_parser_Annotations().init___());
  return $as_Lamf_plugins_document_vocabularies_model_domain_ClassTerm($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, value))
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_document_vocabularies_model_domain_ClassTerm(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.domain.ClassTerm"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_domain_ClassTerm(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_domain_ClassTerm)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_domain_ClassTerm(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_domain_ClassTerm(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.domain.ClassTerm;", depth))
}
var $d_Lamf_plugins_document_vocabularies_model_domain_ClassTerm = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_ClassTerm: 0
}, false, "amf.plugins.document.vocabularies.model.domain.ClassTerm", {
  Lamf_plugins_document_vocabularies_model_domain_ClassTerm: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_ClassTerm;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.productPrefix__T = (function() {
  return "DocumentMapping"
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return this.adopted__T__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(parent, cycle)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping)) {
    var DocumentMapping$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(x$1);
    var x = this.fields$1;
    var x$2 = DocumentMapping$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = DocumentMapping$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$()
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.adopted__T__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_DocumentMapping = (function(parent, cycle) {
  if ($m_s_Option$().apply__O__s_Option(this.id$1).isEmpty__Z()) {
    $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
  };
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.domain.DocumentMapping"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_domain_DocumentMapping)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.domain.DocumentMapping;", depth))
}
var $d_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_DocumentMapping: 0
}, false, "amf.plugins.document.vocabularies.model.domain.DocumentMapping", {
  Lamf_plugins_document_vocabularies_model_domain_DocumentMapping: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.productPrefix__T = (function() {
  return "DocumentsModel"
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel)) {
    var DocumentsModel$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(x$1);
    var x = this.fields$1;
    var x$2 = DocumentsModel$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = DocumentsModel$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$()
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.componentId__T = (function() {
  return "/documents"
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.domain.DocumentsModel"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_domain_DocumentsModel)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.domain.DocumentsModel;", depth))
}
var $d_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_DocumentsModel: 0
}, false, "amf.plugins.document.vocabularies.model.domain.DocumentsModel", {
  Lamf_plugins_document_vocabularies_model_domain_DocumentsModel: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_External() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_External;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_External() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_External.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_External.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.productPrefix__T = (function() {
  return "External"
});
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_External)) {
    var External$1 = $as_Lamf_plugins_document_vocabularies_model_domain_External(x$1);
    var x = this.fields$1;
    var x$2 = External$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = External$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$()
});
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.componentId__T = (function() {
  var x1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().DisplayName$1)).option$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var alias = $as_T(x2.value$2);
    var this$2 = new $c_Lamf_core_utils_package$AmfStrings().init___T(alias);
    var this$3 = this$2.platform$1;
    var url = this$2.str$1;
    return ("/externals/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$3, url))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Cannot set ID of external without alias"))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_document_vocabularies_model_domain_External(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_domain_External) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.domain.External"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_domain_External(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_domain_External)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_domain_External(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_domain_External(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.domain.External;", depth))
}
var $d_Lamf_plugins_document_vocabularies_model_domain_External = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_External: 0
}, false, "amf.plugins.document.vocabularies.model.domain.External", {
  Lamf_plugins_document_vocabularies_model_domain_External: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_External.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_External;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.productPrefix__T = (function() {
  return "PublicNodeMapping"
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return this.adopted__T__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping(parent, cycle)
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping)) {
    var PublicNodeMapping$1 = $as_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping(x$1);
    var x = this.fields$1;
    var x$2 = PublicNodeMapping$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = PublicNodeMapping$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$()
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.adopted__T__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping = (function(parent, cycle) {
  if ($m_s_Option$().apply__O__s_Option(this.id$1).isEmpty__Z()) {
    $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
  };
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.domain.PublicNodeMapping"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.domain.PublicNodeMapping;", depth))
}
var $d_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping: 0
}, false, "amf.plugins.document.vocabularies.model.domain.PublicNodeMapping", {
  Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.productPrefix__T = (function() {
  return "VocabularyReference"
});
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference)) {
    var VocabularyReference$1 = $as_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference(x$1);
    var x = this.fields$1;
    var x$2 = VocabularyReference$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = VocabularyReference$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$()
});
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.componentId__T = (function() {
  var x1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$().Alias$1)).option$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var alias = $as_T(x2.value$2);
    var this$2 = new $c_Lamf_core_utils_package$AmfStrings().init___T(alias);
    var this$3 = this$2.platform$1;
    var url = this$2.str$1;
    return ("/vocabularyReference/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$3, url))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Cannot set ID of VocabularyReference without alias"))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.domain.VocabularyReference"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_domain_VocabularyReference)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.domain.VocabularyReference;", depth))
}
var $d_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_VocabularyReference: 0
}, false, "amf.plugins.document.vocabularies.model.domain.VocabularyReference", {
  Lamf_plugins_document_vocabularies_model_domain_VocabularyReference: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference;
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_BodyParameter() {
  $c_O.call(this);
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_plugins_document_webapi_annotations_BodyParameter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_BodyParameter.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_BodyParameter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_BodyParameter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_BodyParameter.prototype = $c_Lamf_plugins_document_webapi_annotations_BodyParameter.prototype;
$c_Lamf_plugins_document_webapi_annotations_BodyParameter.prototype.init___ = (function() {
  this.name$1 = "body-parameter";
  this.value$1 = "true";
  return this
});
$c_Lamf_plugins_document_webapi_annotations_BodyParameter.prototype.productPrefix__T = (function() {
  return "BodyParameter"
});
$c_Lamf_plugins_document_webapi_annotations_BodyParameter.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_annotations_BodyParameter.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_BodyParameter) && ($as_Lamf_plugins_document_webapi_annotations_BodyParameter(x$1), true))
});
$c_Lamf_plugins_document_webapi_annotations_BodyParameter.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_annotations_BodyParameter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_BodyParameter.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_annotations_BodyParameter.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_plugins_document_webapi_annotations_BodyParameter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_BodyParameter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_annotations_BodyParameter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_BodyParameter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.BodyParameter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_BodyParameter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_BodyParameter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_BodyParameter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_BodyParameter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.BodyParameter;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_BodyParameter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_BodyParameter: 0
}, false, "amf.plugins.document.webapi.annotations.BodyParameter", {
  Lamf_plugins_document_webapi_annotations_BodyParameter: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_BodyParameter.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_BodyParameter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_FormBodyParameter() {
  $c_O.call(this);
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_plugins_document_webapi_annotations_FormBodyParameter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_FormBodyParameter.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_FormBodyParameter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_FormBodyParameter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_FormBodyParameter.prototype = $c_Lamf_plugins_document_webapi_annotations_FormBodyParameter.prototype;
$c_Lamf_plugins_document_webapi_annotations_FormBodyParameter.prototype.init___ = (function() {
  this.name$1 = "form-body-parameter";
  this.value$1 = "true";
  return this
});
$c_Lamf_plugins_document_webapi_annotations_FormBodyParameter.prototype.productPrefix__T = (function() {
  return "FormBodyParameter"
});
$c_Lamf_plugins_document_webapi_annotations_FormBodyParameter.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_annotations_FormBodyParameter.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_FormBodyParameter) && ($as_Lamf_plugins_document_webapi_annotations_FormBodyParameter(x$1), true))
});
$c_Lamf_plugins_document_webapi_annotations_FormBodyParameter.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_annotations_FormBodyParameter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_FormBodyParameter.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_annotations_FormBodyParameter.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_plugins_document_webapi_annotations_FormBodyParameter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_FormBodyParameter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_annotations_FormBodyParameter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_FormBodyParameter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.FormBodyParameter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_FormBodyParameter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_FormBodyParameter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_FormBodyParameter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_FormBodyParameter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.FormBodyParameter;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_FormBodyParameter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_FormBodyParameter: 0
}, false, "amf.plugins.document.webapi.annotations.FormBodyParameter", {
  Lamf_plugins_document_webapi_annotations_FormBodyParameter: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_FormBodyParameter.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_FormBodyParameter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_JSONSchemaId() {
  $c_O.call(this);
  this.id$1 = null;
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaId.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaId.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_JSONSchemaId;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_JSONSchemaId() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_JSONSchemaId.prototype = $c_Lamf_plugins_document_webapi_annotations_JSONSchemaId.prototype;
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaId.prototype.productPrefix__T = (function() {
  return "JSONSchemaId"
});
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaId.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaId.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_JSONSchemaId)) {
    var JSONSchemaId$1 = $as_Lamf_plugins_document_webapi_annotations_JSONSchemaId(x$1);
    return (this.id$1 === JSONSchemaId$1.id$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaId.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.id$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaId.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaId.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaId.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaId.prototype.init___T = (function(id) {
  this.id$1 = id;
  this.name$1 = "json-schema-id";
  this.value$1 = id;
  return this
});
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaId.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaId.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_annotations_JSONSchemaId(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_JSONSchemaId) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.JSONSchemaId"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_JSONSchemaId(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_JSONSchemaId)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_JSONSchemaId(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_JSONSchemaId(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.JSONSchemaId;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_JSONSchemaId = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_JSONSchemaId: 0
}, false, "amf.plugins.document.webapi.annotations.JSONSchemaId", {
  Lamf_plugins_document_webapi_annotations_JSONSchemaId: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_JSONSchemaId.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_JSONSchemaId;
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload() {
  $c_O.call(this);
  this.paramName$1 = null;
  this.range$1 = null;
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload.prototype = $c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload.prototype;
$c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload.prototype.productPrefix__T = (function() {
  return "ParameterNameForPayload"
});
$c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload)) {
    var ParameterNameForPayload$1 = $as_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload(x$1);
    if ((this.paramName$1 === ParameterNameForPayload$1.paramName$1)) {
      var x = this.range$1;
      var x$2 = ParameterNameForPayload$1.range$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.paramName$1;
      break
    }
    case 1: {
      return this.range$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload.prototype.init___T__Lamf_core_parser_Range = (function(paramName, range) {
  this.paramName$1 = paramName;
  this.range$1 = range;
  this.name$1 = "parameter-name-for-payload";
  this.value$1 = ((paramName + "->") + range.toString__T());
  return this
});
$c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.ParameterNameForPayload"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_ParameterNameForPayload)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.ParameterNameForPayload;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_ParameterNameForPayload: 0
}, false, "amf.plugins.document.webapi.annotations.ParameterNameForPayload", {
  Lamf_plugins_document_webapi_annotations_ParameterNameForPayload: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_ParameterNameForPayload;
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_ParsedJSONExample() {
  $c_O.call(this);
  this.rawText$1 = null;
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONExample.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONExample.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_ParsedJSONExample;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_ParsedJSONExample() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_ParsedJSONExample.prototype = $c_Lamf_plugins_document_webapi_annotations_ParsedJSONExample.prototype;
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONExample.prototype.productPrefix__T = (function() {
  return "ParsedJSONExample"
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONExample.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONExample.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_ParsedJSONExample)) {
    var ParsedJSONExample$1 = $as_Lamf_plugins_document_webapi_annotations_ParsedJSONExample(x$1);
    return (this.rawText$1 === ParsedJSONExample$1.rawText$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONExample.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.rawText$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONExample.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONExample.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONExample.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONExample.prototype.init___T = (function(rawText) {
  this.rawText$1 = rawText;
  this.name$1 = "parsed-json-example";
  this.value$1 = rawText;
  return this
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONExample.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONExample.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_annotations_ParsedJSONExample(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_ParsedJSONExample) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.ParsedJSONExample"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_ParsedJSONExample(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_ParsedJSONExample)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_ParsedJSONExample(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_ParsedJSONExample(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.ParsedJSONExample;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_ParsedJSONExample = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_ParsedJSONExample: 0
}, false, "amf.plugins.document.webapi.annotations.ParsedJSONExample", {
  Lamf_plugins_document_webapi_annotations_ParsedJSONExample: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONExample.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_ParsedJSONExample;
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype() {
  $c_O.call(this);
  this.rawText$1 = null;
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype.prototype = $c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype.prototype;
$c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype.prototype.productPrefix__T = (function() {
  return "ParsedRamlDatatype"
});
$c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype)) {
    var ParsedRamlDatatype$1 = $as_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype(x$1);
    return (this.rawText$1 === ParsedRamlDatatype$1.rawText$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.rawText$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype.prototype.init___T = (function(rawText) {
  this.rawText$1 = rawText;
  this.name$1 = "parsed-raml-datatype";
  this.value$1 = rawText;
  return this
});
$c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.ParsedRamlDatatype"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.ParsedRamlDatatype;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype: 0
}, false, "amf.plugins.document.webapi.annotations.ParsedRamlDatatype", {
  Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_ParsedRamlDatatype;
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload() {
  $c_O.call(this);
  this.required$1 = false;
  this.range$1 = null;
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_RequiredParamPayload() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_RequiredParamPayload.prototype = $c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload.prototype;
$c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload.prototype.productPrefix__T = (function() {
  return "RequiredParamPayload"
});
$c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload)) {
    var RequiredParamPayload$1 = $as_Lamf_plugins_document_webapi_annotations_RequiredParamPayload(x$1);
    if ((this.required$1 === RequiredParamPayload$1.required$1)) {
      var x = this.range$1;
      var x$2 = RequiredParamPayload$1.range$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.required$1;
      break
    }
    case 1: {
      return this.range$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.required$1 ? 1231 : 1237));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.range$1));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 2)
});
$c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload.prototype.init___Z__Lamf_core_parser_Range = (function(required, range) {
  this.required$1 = required;
  this.range$1 = range;
  this.name$1 = "required-param-payload";
  this.value$1 = (("" + $m_s_Predef$any2stringadd$().$$plus$extension__O__T__T(required, "->")) + range.toString__T());
  return this
});
function $as_Lamf_plugins_document_webapi_annotations_RequiredParamPayload(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.RequiredParamPayload"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_RequiredParamPayload(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_RequiredParamPayload)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_RequiredParamPayload(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_RequiredParamPayload(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.RequiredParamPayload;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_RequiredParamPayload = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_RequiredParamPayload: 0
}, false, "amf.plugins.document.webapi.annotations.RequiredParamPayload", {
  Lamf_plugins_document_webapi_annotations_RequiredParamPayload: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_RequiredParamPayload.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_RequiredParamPayload;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory() {
  $c_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterFactory.call(this);
  this.spec$3 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory.prototype = new $h_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterFactory();
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory.prototype.productPrefix__T = (function() {
  return "Async20SpecEmitterFactory"
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory)) {
    var Async20SpecEmitterFactory$1 = $as_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory(x$1);
    var x = this.spec$3;
    var x$2 = Async20SpecEmitterFactory$1.spec$3;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory.prototype.tagToReferenceEmitter__F3 = (function() {
  $m_s_Predef$().$$qmark$qmark$qmark__sr_Nothing$()
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory.prototype.init___Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterContext = (function(spec) {
  this.spec$3 = spec;
  $c_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory.prototype.init___Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.call(this, spec);
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.spec$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory.prototype.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function() {
  return this.spec$3
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory.prototype.facetsInstanceEmitter__F2 = (function() {
  $m_s_Predef$().$$qmark$qmark$qmark__sr_Nothing$()
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory.prototype.customFacetsEmitter__F3 = (function() {
  $m_s_Predef$().$$qmark$qmark$qmark__sr_Nothing$()
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory.prototype.headerEmitter__F3 = (function() {
  $m_s_Predef$().$$qmark$qmark$qmark__sr_Nothing$()
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory.prototype.securityRequirementEmitter__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(requirement$2, ordering$2) {
      var requirement = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(requirement$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter().init___Lamf_plugins_domain_webapi_models_security_SecurityRequirement__Lamf_core_emitter_SpecOrdering(requirement, ordering)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.emitter.async.Async20SpecEmitterFactory"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.emitter.async.Async20SpecEmitterFactory;", depth))
}
var $d_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.async.Async20SpecEmitterFactory", {
  Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory: 1,
  Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterFactory: 1,
  Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_SpecEmitterFactory: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterFactory;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.f$1 = null;
  this.extensions$1 = null;
  this.mediaType$1 = null;
  this.spec$1 = null;
  this.tag$1 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter.prototype.productPrefix__T = (function() {
  return "RamlScalarValueEmitter"
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter)) {
    var RamlScalarValueEmitter$1 = $as_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter(x$1);
    if ((this.key$1 === RamlScalarValueEmitter$1.key$1)) {
      var x = this.f$1;
      var x$2 = RamlScalarValueEmitter$1.f$1;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$3 = this.extensions$1;
      var x$4 = RamlScalarValueEmitter$1.extensions$1;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.mediaType$1;
      var x$6 = RamlScalarValueEmitter$1.mediaType$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.f$1;
      break
    }
    case 2: {
      return this.extensions$1;
      break
    }
    case 3: {
      return this.mediaType$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter.prototype.annotatedScalar__p1__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.key$1;
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$4 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$3 = $m_Lorg_yaml_model_YNode$();
  var jsx$2 = $m_Lorg_yaml_model_YScalar$();
  var this$3 = this.f$1;
  var jsx$1 = jsx$2.apply__O__Lorg_yaml_model_YScalar($as_Lamf_core_model_domain_AmfScalar(this$3.value$1.value$1).value$1);
  var this$4 = this.mediaType$1;
  b$1.updateDynamic__T__Lorg_yaml_model_YNode__V("value", jsx$3.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(jsx$1, $as_Lorg_yaml_model_YType((this$4.isEmpty__Z() ? this.tag$1 : this$4.get__O()))));
  this.extensions$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, b$2) {
    return (function(e$2) {
      var e = $as_Lamf_core_model_domain_extensions_DomainExtension(e$2);
      $as_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter(this$2$1.spec$1.factory__Lamf_plugins_document_webapi_contexts_SpecEmitterFactory().annotationEmitter__F2().apply__O__O__O(e, $m_Lamf_core_emitter_SpecOrdering$Default$())).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$2)
    })
  })(this, b$1)));
  jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$7 = v.builder$1;
  var array = [key];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$5 = j;
    var index = i;
    xs.set(jsx$5, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var value = this.f$1.value$1;
  this.annotatedScalar__p1__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter.prototype.f__Lamf_core_parser_FieldEntry = (function() {
  return this.f$1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter.prototype.init___T__Lamf_core_parser_FieldEntry__sc_Seq__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, f, extensions, mediaType, spec) {
  this.key$1 = key;
  this.f$1 = f;
  this.extensions$1 = extensions;
  this.mediaType$1 = mediaType;
  this.spec$1 = spec;
  $f_Lamf_core_emitter_BaseEmitters_package$BaseValueEmitter__$$init$__V(this);
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  return $f_Lamf_core_emitter_BaseEmitters_package$BaseValueEmitter__position__Lamf_core_parser_Position(this)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter.prototype.amf$core$emitter$BaseEmitters$BaseValueEmitter$$undsetter$und$tag$und$eq__Lorg_yaml_model_YType__V = (function(x$1) {
  this.tag$1 = x$1
});
function $as_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.emitter.raml.RamlScalarValueEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.emitter.raml.RamlScalarValueEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.raml.RamlScalarValueEmitter", {
  Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter: 1,
  O: 1,
  Lamf_core_emitter_BaseEmitters_package$BaseValueEmitter: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarValueEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory() {
  $c_O.call(this);
  this.ctx$1 = null
}
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory.prototype.productPrefix__T = (function() {
  return "Async20VersionFactory"
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory) && ($as_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory(x$1), true))
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory.prototype.securitySchemeParser__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(part$2, adopt$2) {
      var part = $as_Lorg_yaml_model_YPart(part$2);
      var adopt = $as_F1(adopt$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser().init___Lorg_yaml_model_YPart__F1__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(part, adopt, $this.ctx$1)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory.prototype.endPointParser__Lorg_yaml_model_YMapEntry__F1__sci_List__Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser = (function(entry, producer, collector) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_AsyncEndpointParser().init___Lorg_yaml_model_YMapEntry__F1__sci_List__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(entry, producer, collector, this.ctx$1)
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory.prototype.operationParser__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser = (function(entry, producer) {
  return $m_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser$().apply__Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext__Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncOperationParser(entry, producer, false, this.ctx$1)
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory.prototype.securitySettingsParser__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser = (function(map, scheme) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySettingsParser().init___Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(map, scheme, this.ctx$1)
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory.prototype.serverVariableParser__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser = (function(entry, parent) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_async_parser_AsyncServerVariableParser().init___Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(entry, parent, this.ctx$1)
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory.prototype.init___Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(ctx) {
  this.ctx$1 = ctx;
  return this
});
function $as_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.parser.async.Async20VersionFactory"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.parser.async.Async20VersionFactory;", depth))
}
var $d_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory: 0
}, false, "amf.plugins.document.webapi.contexts.parser.async.Async20VersionFactory", {
  Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_parser_async_AsyncSpecVersionFactory: 1,
  Lamf_plugins_document_webapi_contexts_parser_OasLikeSpecVersionFactory: 1,
  Lamf_plugins_document_webapi_contexts_SpecVersionFactory: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory() {
  $c_Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory.call(this)
}
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype = new $h_Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory();
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype.productPrefix__T = (function() {
  return "Oas2VersionFactory"
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function() {
  return this.ctx$1
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory) && ($as_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory(x$1), true))
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype.serversParser__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_WebApi__Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser = (function(map, api) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ServersParser().init___Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_WebApi__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(map, api, this.ctx$1)
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype.endPointParser__Lorg_yaml_model_YMapEntry__F1__sci_List__Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser = (function(entry, producer, collector) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser().init___Lorg_yaml_model_YMapEntry__F1__sci_List__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(entry, producer, collector, this.ctx$1)
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype.operationParser__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser = (function(entry, producer) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser().init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(entry, producer, this.ctx$1)
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype.securitySettingsParser__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser = (function(map, scheme) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas2SecuritySettingsParser().init___Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(map, scheme, this.ctx$1)
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype.serversParser__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Operation__Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser = (function(map, operation) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser().init___Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(map, operation, $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Servers$1, this.ctx$1)
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype.serverVariableParser__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser = (function(entry, parent) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser().init___Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(entry, parent, this.ctx$1)
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype.init___Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(ctx) {
  $c_Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory.prototype.init___Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext.call(this, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype.serversParser__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser = (function(map, endpoint) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser().init___Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(map, endpoint, $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Servers$1, this.ctx$1)
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype.parameterParser__s_util_Either__T__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_parser_spec_domain_OasParameterParser = (function(entryOrNode, parentId, nameNode, nameGenerator) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser().init___s_util_Either__T__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_WebApiContext(entryOrNode, parentId, nameNode, nameGenerator, this.ctx$1)
});
function $as_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.parser.oas.Oas2VersionFactory"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.parser.oas.Oas2VersionFactory;", depth))
}
var $d_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory: 0
}, false, "amf.plugins.document.webapi.contexts.parser.oas.Oas2VersionFactory", {
  Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory: 1,
  Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_parser_OasLikeSpecVersionFactory: 1,
  Lamf_plugins_document_webapi_contexts_SpecVersionFactory: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory() {
  $c_Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory.call(this)
}
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype = new $h_Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory();
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype.productPrefix__T = (function() {
  return "Oas3VersionFactory"
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function() {
  return this.ctx$1
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory) && ($as_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory(x$1), true))
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype.serversParser__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_WebApi__Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser = (function(map, api) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser().init___Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(map, api, $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Servers$1, this.ctx$1)
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype.endPointParser__Lorg_yaml_model_YMapEntry__F1__sci_List__Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser = (function(entry, producer, collector) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser().init___Lorg_yaml_model_YMapEntry__F1__sci_List__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(entry, producer, collector, this.ctx$1)
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype.operationParser__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser = (function(entry, producer) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser().init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(entry, producer, this.ctx$1)
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype.securitySettingsParser__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySettingsParser = (function(map, scheme) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Oas3SecuritySettingsParser().init___Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(map, scheme, this.ctx$1)
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype.serversParser__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Operation__Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser = (function(map, operation) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser().init___Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(map, operation, $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Servers$1, this.ctx$1)
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype.serverVariableParser__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_parser_spec_domain_OasLikeServerVariableParser = (function(entry, parent) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasServerVariableParser().init___Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(entry, parent, this.ctx$1)
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype.init___Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(ctx) {
  $c_Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory.prototype.init___Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext.call(this, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype.serversParser__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser = (function(map, endpoint) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ServersParser().init___Lorg_yaml_model_YMap__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(map, endpoint, $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Servers$1, this.ctx$1)
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype.parameterParser__s_util_Either__T__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_parser_spec_domain_OasParameterParser = (function(entryOrNode, parentId, nameNode, nameGenerator) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser().init___s_util_Either__T__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_WebApiContext(entryOrNode, parentId, nameNode, nameGenerator, this.ctx$1)
});
function $as_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.parser.oas.Oas3VersionFactory"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.parser.oas.Oas3VersionFactory;", depth))
}
var $d_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory: 0
}, false, "amf.plugins.document.webapi.contexts.parser.oas.Oas3VersionFactory", {
  Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory: 1,
  Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_parser_OasLikeSpecVersionFactory: 1,
  Lamf_plugins_document_webapi_contexts_SpecVersionFactory: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCorrelationId() {
  $c_Lamf_plugins_domain_webapi_models_CorrelationId.call(this);
  this.idPart$2 = null;
  this.ast$2 = null;
  this.namespace$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCorrelationId.prototype = new $h_Lamf_plugins_domain_webapi_models_CorrelationId();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCorrelationId.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCorrelationId;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCorrelationId() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCorrelationId.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCorrelationId.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCorrelationId.prototype.originalMeta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCorrelationId.prototype.newErrorInstance__Lamf_core_annotations_ErrorDeclaration = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCorrelationId().init___T__Lorg_yaml_model_YPart(this.idPart$2, this.ast$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCorrelationId.prototype.namespace__T = (function() {
  return this.namespace$2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCorrelationId.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCorrelationId.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return new $c_Lamf_core_annotations_ErrorDeclaration$$anon$1().init___Lamf_core_annotations_ErrorDeclaration(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCorrelationId.prototype.init___T__Lorg_yaml_model_YPart = (function(idPart, ast) {
  this.idPart$2 = idPart;
  this.ast$2 = ast;
  $c_Lamf_plugins_domain_webapi_models_CorrelationId.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, new $c_Lamf_core_parser_Fields().init___(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast));
  this.namespace$2 = "http://amferror.com/#errorCorrelationId/";
  $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, idPart);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCorrelationId.prototype.amf$core$annotations$ErrorDeclaration$$super$withId__T__Lamf_core_annotations_ErrorDeclaration = (function(value) {
  return $as_Lamf_core_annotations_ErrorDeclaration($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value))
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCorrelationId = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCorrelationId: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorCorrelationId", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCorrelationId: 1,
  Lamf_plugins_domain_webapi_models_CorrelationId: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_annotations_ErrorDeclaration: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCorrelationId.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCorrelationId;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser() {
  $c_O.call(this);
  this.entry$1 = null;
  this.webApi$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser.prototype.productPrefix__T = (function() {
  return "IdentifierParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser)) {
    var IdentifierParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser(x$1);
    var x = this.entry$1;
    var x$2 = IdentifierParser$1.entry$1;
    if ((x === x$2)) {
      var x$3 = this.webApi$1;
      var x$4 = IdentifierParser$1.webApi$1;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.ctx$1;
      var x$6 = IdentifierParser$1.ctx$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$1;
      break
    }
    case 1: {
      return this.webApi$1;
      break
    }
    case 2: {
      return this.ctx$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser.prototype.init___Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_WebApi__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(entry, webApi, ctx) {
  this.entry$1 = entry;
  this.webApi$1 = webApi;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser.prototype.parse__V = (function() {
  var this$1 = this.entry$1.value$2;
  var x1 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Str$1;
  if ((x === x1)) {
    var this$2 = this.entry$1.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
    var iv = this.ctx$1;
    var id = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv));
    var this$4 = this.webApi$1;
    var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Identifier$1;
    var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(id, new $c_Lamf_core_parser_Annotations().init___());
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$1);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$4, field, value, annotations)
  } else {
    var this$5 = this.ctx$1.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().InvalidIdentifier$1;
    var node = this.webApi$1.id$1;
    var loc = this.entry$1.location$1;
    var prop = $m_s_None$();
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$5, specification, node, prop, "'id' must be a string", loc)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.IdentifierParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.IdentifierParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.IdentifierParser", {
  Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_WebApiBaseSpecParser: 1,
  Lamf_core_parser_BaseSpecParser: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_IdentifierParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter.call(this);
  this.bindings$2 = null;
  this.ordering$2 = null;
  this.extensions$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter.prototype.productPrefix__T = (function() {
  return "AsyncApiBindingsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter)) {
    var AsyncApiBindingsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter(x$1);
    var x = this.bindings$2;
    var x$2 = AsyncApiBindingsEmitter$1.bindings$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = AsyncApiBindingsEmitter$1.ordering$2;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.extensions$2;
      var x$6 = AsyncApiBindingsEmitter$1.extensions$2;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.bindings$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    case 2: {
      return this.extensions$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter.prototype.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function() {
  return this.spec$1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter.prototype.init___Lamf_core_model_domain_AmfElement__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(bindings, ordering, extensions, spec) {
  this.bindings$2 = bindings;
  this.ordering$2 = ordering;
  this.extensions$2 = extensions;
  $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter.prototype.init___Lamf_core_model_domain_AmfElement__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.call(this, bindings, ordering, extensions, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter.prototype.key__T = (function() {
  return "bindings"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiBindingsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiBindingsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiBindingsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter.call(this);
  this.bindings$2 = null;
  this.ordering$2 = null;
  this.extensions$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter.prototype.productPrefix__T = (function() {
  return "AsyncApiNamedBindingsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter)) {
    var AsyncApiNamedBindingsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter(x$1);
    var x = this.bindings$2;
    var x$2 = AsyncApiNamedBindingsEmitter$1.bindings$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = AsyncApiNamedBindingsEmitter$1.ordering$2;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.extensions$2;
      var x$6 = AsyncApiNamedBindingsEmitter$1.extensions$2;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.bindings$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    case 2: {
      return this.extensions$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter.prototype.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function() {
  return this.spec$1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter.prototype.init___Lamf_core_model_domain_AmfElement__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(bindings, ordering, extensions, spec) {
  this.bindings$2 = bindings;
  this.ordering$2 = ordering;
  this.extensions$2 = extensions;
  $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter.prototype.init___Lamf_core_model_domain_AmfElement__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.call(this, bindings, ordering, extensions, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter.prototype.key__T = (function() {
  var x1 = this.bindings$2;
  if ($is_Lamf_core_model_domain_NamedDomainElement(x1)) {
    var x2 = $as_Lamf_core_model_domain_NamedDomainElement(x1);
    var name = $as_Lamf_core_model_StrField(x2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(x2.nameField__Lamf_core_metamodel_Field())).option$1
  } else {
    var name = $m_s_None$()
  };
  return $as_T((name.isEmpty__Z() ? "default" : name.get__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiNamedBindingsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiNamedBindingsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncApiNamedBindingsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEntryEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiNamedBindingsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationPartEmitter.call(this);
  this.operation$2 = null;
  this.isTrait$2 = false;
  this.ordering$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationPartEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter.prototype.productPrefix__T = (function() {
  return "AsyncOperationPartEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var this$1 = this.operation$2;
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1).isDefined__Z()) {
    this.emitLink__Lorg_yaml_model_YDocument$PartBuilder__V(b)
  } else {
    var jsx$4 = b.builder$1;
    var sourceName = b.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    var fs = this.operation$2.fields$1;
    var tempResult = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var this$3 = this.operation$2;
    var bindingOrphanAnnotations = $as_sc_Seq($as_sc_Seq(this$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field())).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$1$2) {
        var x$1 = $as_Lamf_core_model_domain_extensions_DomainExtension(x$1$2);
        return $as_Lamf_core_model_domain_DataNode(x$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)).annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.getClassOf())
      })
    })(this))));
    var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Bindings$1);
    if ((!this$4.isEmpty__Z())) {
      var arg1 = this$4.get__O();
      var f = $as_Lamf_core_parser_FieldEntry(arg1);
      new $c_s_Some().init___O(tempResult.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiBindingsEmitter().init___Lamf_core_model_domain_AmfElement__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(f.value$1.value$1, this.ordering$2, bindingOrphanAnnotations, $as_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.spec$1))))
    };
    var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Tags$1);
    if ((!this$5.isEmpty__Z())) {
      var arg1$1 = this$5.get__O();
      var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
      new $c_s_Some().init___O(tempResult.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_TagsEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("tags", $as_Lamf_core_model_domain_AmfArray(f$3.value$1.value$1).values$1, this.ordering$2, $as_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.spec$1))))
    };
    if ((!this.isTrait$2)) {
      var this$6 = this.emitMessage__Lamf_core_parser_Fields__s_Option(fs);
      if ((!this$6.isEmpty__Z())) {
        var arg1$2 = this$6.get__O();
        var reqOrRes = $as_Lamf_core_emitter_EntryEmitter(arg1$2);
        new $c_s_Some().init___O(tempResult.$$plus$eq__O__scm_ListBuffer(reqOrRes))
      };
      var this$7 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Extends__Lamf_core_metamodel_Field());
      if ((!this$7.isEmpty__Z())) {
        var arg1$3 = this$7.get__O();
        var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$3);
        this.emitTraits__Lamf_core_parser_FieldEntry__scm_ListBuffer__V(f$4, tempResult)
      }
    };
    var jsx$3 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var jsx$2 = this.ordering$2;
    var jsx$1 = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationPartEmitter.prototype.commonEmitters__sc_Seq.call(this);
    var this$8 = $m_sc_Seq$();
    jsx$3.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$2.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$1.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(tempResult, this$8.ReusableCBFInstance$2))), b$1);
    jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter.prototype.emitLink__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var this$1 = this.operation$2;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1;
  var label = $as_T((this$2.isEmpty__Z() ? "default" : this$2.get__O()));
  var fullRef = $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().appendOas3ComponentsPrefix__T__T__T(label, "operationTraits");
  var jsx$1 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("$ref");
  $m_Lorg_yaml_model_YNode$();
  var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(fullRef);
  b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter)) {
    var AsyncOperationPartEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter(x$1);
    var x = this.operation$2;
    var x$2 = AsyncOperationPartEmitter$1.operation$2;
    if ((((x === null) ? (x$2 === null) : x.equals__O__Z(x$2)) && (this.isTrait$2 === AsyncOperationPartEmitter$1.isTrait$2))) {
      var x$3 = this.ordering$2;
      var x$4 = AsyncOperationPartEmitter$1.ordering$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.operation$2;
      break
    }
    case 1: {
      return this.isTrait$2;
      break
    }
    case 2: {
      return this.ordering$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter.prototype.emitMessage__Lamf_core_parser_Fields__s_Option = (function(fs) {
  var jsx$1 = $m_Lamf_plugins_document_webapi_parser_spec_async_AsyncHelper$();
  var this$1 = this.operation$2;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Method$1));
  var this$3 = this$2.option$1;
  var x1 = jsx$1.messageType__T__s_Option($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var s = $as_Lamf_plugins_document_webapi_parser_spec_async_MessageType(x2.value$2);
    var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option(s.field__Lamf_core_metamodel_Field());
    if (this$4.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1 = this$4.get__O();
      var x$3 = $as_Lamf_core_parser_FieldEntry(arg1);
      return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncApiMessageEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x$3, this.ordering$2, $as_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.spec$1)))
    }
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter.prototype.spec__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function() {
  return $as_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.spec$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter.prototype.emitOperationId__Lamf_core_parser_Fields__scm_ListBuffer__V = (function(fs, result) {
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().OperationId$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("operationId", f, $m_s_None$()))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Operation__Z__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(operation, isTrait, ordering, spec) {
  this.operation$2 = operation;
  this.isTrait$2 = isTrait;
  this.ordering$2 = ordering;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationPartEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, operation, ordering, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter.prototype.emitTraits__Lamf_core_parser_FieldEntry__scm_ListBuffer__V = (function(f, tempResult) {
  tempResult.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationTraitsEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(f.arrayValues__sc_Seq(), this.ordering$2, $as_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.spec$1)))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.operation$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.isTrait$2 ? 1231 : 1237));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ordering$2));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 3)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncOperationPartEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.emitters.AsyncOperationPartEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.emitters.AsyncOperationPartEmitter", {
  Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationPartEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_emitters_AsyncOperationPartEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode() {
  $c_O.call(this);
  this.obj$1 = null;
  this.iv$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode.prototype = $c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode.prototype.productPrefix__T = (function() {
  return "MapEntriesArrayNode"
});
$c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode)) {
    var MapEntriesArrayNode$1 = $as_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode(x$1);
    var this$1 = this.obj$1;
    var b = MapEntriesArrayNode$1.obj$1;
    return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode.prototype.nodes__T2 = (function() {
  var jsx$4 = this.obj$1.entries$3;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(e$2) {
      var e = $as_Lorg_yaml_model_YMapEntry(e$2);
      $m_Lorg_yaml_model_YNode$();
      var jsx$3 = $m_Lorg_yaml_model_YMap$();
      $m_s_package$();
      var array = [e];
      if (($uI(array.length) === 0)) {
        $m_sci_IndexedSeq$();
        $m_sci_Vector$();
        var this$6 = new $c_sci_VectorBuilder().init___();
        var jsx$2 = this$6.result__sci_Vector()
      } else {
        $m_sci_IndexedSeq$();
        $m_sci_Vector$();
        var b = new $c_sci_VectorBuilder().init___();
        var i = 0;
        var len = $uI(array.length);
        while ((i < len)) {
          var index = i;
          var arg1 = array[index];
          b.$$plus$eq__O__sci_VectorBuilder(arg1);
          i = ((1 + i) | 0)
        };
        var jsx$2 = b.result__sci_Vector()
      };
      var this$9 = $this.obj$1;
      var map = jsx$3.apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(jsx$2, this$9.location$1.sourceName$1);
      return $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1)
    })
  })(this));
  var this$11 = $m_sc_IndexedSeq$();
  var maps = $as_sc_IndexedSeq(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$1, this$11.ReusableCBF$6));
  $m_Lorg_yaml_model_YNode$();
  var map$1 = this.obj$1;
  $m_Lorg_yaml_model_YNode$();
  return new $c_T2().init___O__O(maps, $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map$1, $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.obj$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode.prototype.negated__Lamf_core_model_domain_AmfElement = (function() {
  return $f_Lamf_core_parser_BaseArrayNode__negated__Lamf_core_model_domain_AmfArray(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode.prototype.text__Lamf_core_model_domain_AmfArray = (function() {
  return $f_Lamf_core_parser_BaseArrayNode__text__Lamf_core_model_domain_AmfArray(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode.prototype.$boolean__Lamf_core_model_domain_AmfArray = (function() {
  return $f_Lamf_core_parser_BaseArrayNode__$boolean__Lamf_core_model_domain_AmfArray(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode.prototype.iv__Lorg_yaml_model_IllegalTypeHandler = (function() {
  return this.iv$1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode.prototype.integer__Lamf_core_model_domain_AmfArray = (function() {
  return $f_Lamf_core_parser_BaseArrayNode__integer__Lamf_core_model_domain_AmfArray(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode.prototype.obj__F1__Lamf_core_model_domain_AmfArray = (function(fn) {
  return $f_Lamf_core_parser_BaseArrayNode__array__pLamf_core_parser_BaseArrayNode__F1__Lamf_core_model_domain_AmfArray(this, fn)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode.prototype.init___Lorg_yaml_model_YMap__Lorg_yaml_model_IllegalTypeHandler = (function(obj, iv) {
  this.obj$1 = obj;
  this.iv$1 = iv;
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.common.MapEntriesArrayNode"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.common.MapEntriesArrayNode;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode: 0
}, false, "amf.plugins.document.webapi.parser.spec.common.MapEntriesArrayNode", {
  Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode: 1,
  O: 1,
  Lamf_core_parser_BaseArrayNode: 1,
  Lamf_core_parser_ArrayNode: 1,
  Lamf_core_parser_TypedNode: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_common_MapEntriesArrayNode;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySchemeParser.call(this);
  this.part$3 = null;
  this.adopt$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySchemeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser.prototype.productPrefix__T = (function() {
  return "Async2SecuritySchemeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser)) {
    var Async2SecuritySchemeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser(x$1);
    var x = this.part$3;
    var x$2 = Async2SecuritySchemeParser$1.part$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.adopt$3;
      var x$4 = Async2SecuritySchemeParser$1.adopt$3;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.part$3;
      break
    }
    case 1: {
      return this.adopt$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser.prototype.init___Lorg_yaml_model_YPart__F1__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(part, adopt, ctx) {
  this.part$3 = part;
  this.adopt$3 = adopt;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySchemeParser.prototype.init___Lorg_yaml_model_YPart__F1__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.call(this, part, adopt, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.Async2SecuritySchemeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.Async2SecuritySchemeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.Async2SecuritySchemeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySchemeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_Async2SecuritySchemeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters.call(this);
  this.types$2 = null;
  this.references$2 = null;
  this.ordering$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters.prototype.productPrefix__T = (function() {
  return "CompactOasTypesEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters)) {
    var CompactOasTypesEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters(x$1);
    var x = this.types$2;
    var x$2 = CompactOasTypesEmitters$1.types$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.references$2;
      var x$4 = CompactOasTypesEmitters$1.references$2;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.ordering$2;
      var x$6 = CompactOasTypesEmitters$1.ordering$2;
      return (x$5 === x$6)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.types$2;
      break
    }
    case 1: {
      return this.references$2;
      break
    }
    case 2: {
      return this.ordering$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters.prototype.emitTypes__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  if (this.types$2.nonEmpty__Z()) {
    var jsx$1 = true
  } else {
    var this$1 = this.spec$2.definitionsQueue$3;
    var this$2 = this$1.pendingEmission$1;
    var jsx$1 = $f_sc_TraversableOnce__nonEmpty__Z(this$2)
  };
  if (jsx$1) {
    $m_Lorg_yaml_model_YNode$();
    var str = this.key$1;
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$6 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    var definitionsQueue = this.spec$2.definitionsQueue$3;
    this.types$2.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, definitionsQueue$1) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        return definitionsQueue$1.enqueue__Lamf_core_model_domain_Shape__T(shape)
      })
    })(this, definitionsQueue)));
    while (true) {
      var this$5 = definitionsQueue.pendingEmission$1;
      if ($f_sc_TraversableOnce__nonEmpty__Z(this$5)) {
        var labeledShape = $as_Lamf_plugins_document_webapi_contexts_emitter_oas_LabeledShape(definitionsQueue.pendingEmission$1.dequeue__O());
        this.spec$2.forceEmission$3 = new $c_s_Some().init___O(labeledShape.shape$1.id$1);
        var jsx$5 = labeledShape.shape$1;
        var jsx$4 = this.ordering$2;
        var jsx$3 = this.references$2;
        var jsx$2 = $m_sc_Seq$();
        var array = ["definitions"];
        new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__s_Option__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(jsx$5, jsx$4, jsx$3, $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))), new $c_s_Some().init___O(labeledShape.label$1), this.spec$2).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$1)
      } else {
        break
      }
    };
    jsx$6.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
    var this$10 = v.builder$1;
    var array$1 = [key];
    if ((this$10.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array$1.length);
    var newSize = ((this$10.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$10, newSize);
    var len$1 = this$10.size0$6;
    var src = this$10.array$6;
    var dest = this$10.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$10.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array$1.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$7 = j;
      var index = i;
      xs.set(jsx$7, array$1[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$10.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters.prototype.init___sc_Seq__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(types, references, ordering, spec) {
  this.types$2 = types;
  this.references$2 = references;
  this.ordering$2 = ordering;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters.prototype.init___sc_Seq__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, types, references, ordering, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.CompactOasTypesEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.CompactOasTypesEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.CompactOasTypesEmitters", {
  Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_CompactOasTypesEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter.call(this);
  this.domainExtension$2 = null;
  this.ordering$2 = null;
  this.name$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter.prototype.productPrefix__T = (function() {
  return "OasAnnotationEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter)) {
    var OasAnnotationEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter(x$1);
    var x = this.domainExtension$2;
    var x$2 = OasAnnotationEmitter$1.domainExtension$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = OasAnnotationEmitter$1.ordering$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.domainExtension$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter.prototype.name__T = (function() {
  return this.name$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter.prototype.init___Lamf_core_model_domain_extensions_DomainExtension__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(domainExtension, ordering, spec) {
  this.domainExtension$2 = domainExtension;
  this.ordering$2 = ordering;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter.prototype.init___Lamf_core_model_domain_extensions_DomainExtension__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, domainExtension, ordering, spec);
  var this$1 = $as_Lamf_core_model_StrField(domainExtension.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1));
  var this$2 = this$1.option$1;
  this.name$2 = ("x-" + $as_T((this$2.isEmpty__Z() ? null : this$2.get__O())));
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasAnnotationEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasAnnotationEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasAnnotationEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasAnnotationEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter.call(this);
  this.f$2 = null;
  this.ordering$2 = null;
  this.references$2 = null;
  this.spec$2 = null;
  this.key$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter.prototype.productPrefix__T = (function() {
  return "OasCustomFacetsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter)) {
    var OasCustomFacetsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter(x$1);
    var x = this.f$2;
    var x$2 = OasCustomFacetsEmitter$1.f$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = OasCustomFacetsEmitter$1.ordering$2;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$2;
      var x$6 = OasCustomFacetsEmitter$1.references$2;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.f$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    case 2: {
      return this.references$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(f, ordering, references, spec) {
  this.f$2 = f;
  this.ordering$2 = ordering;
  this.references$2 = references;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, f, ordering, references, spec);
  this.key$2 = new $c_Lamf_core_utils_package$AmfStrings().init___T("facets").asOasExtension__T();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter.prototype.shapeEmitter__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(p$2, o$2, s$2) {
      var p = $as_Lamf_core_model_domain_extensions_PropertyShape(p$2);
      var o = $as_Lamf_core_emitter_SpecOrdering(o$2);
      var s = $as_sc_Seq(s$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter().init___Lamf_core_model_domain_extensions_PropertyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__T__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(p, o, s, "properties", $m_sci_Nil$(), $m_sci_Nil$(), $this.spec$2)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter.prototype.key__T = (function() {
  return this.key$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasCustomFacetsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasCustomFacetsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasCustomFacetsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasCustomFacetsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters.call(this);
  this.types$2 = null;
  this.references$2 = null;
  this.ordering$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters.prototype.productPrefix__T = (function() {
  return "OasDeclaredTypesEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters)) {
    var OasDeclaredTypesEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters(x$1);
    var x = this.types$2;
    var x$2 = OasDeclaredTypesEmitters$1.types$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.references$2;
      var x$4 = OasDeclaredTypesEmitters$1.references$2;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.ordering$2;
      var x$6 = OasDeclaredTypesEmitters$1.ordering$2;
      return (x$5 === x$6)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.types$2;
      break
    }
    case 1: {
      return this.references$2;
      break
    }
    case 2: {
      return this.ordering$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters.prototype.init___sc_Seq__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(types, references, ordering, spec) {
  this.types$2 = types;
  this.references$2 = references;
  this.ordering$2 = ordering;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters.prototype.init___sc_Seq__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, types, references, ordering, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters.prototype.emitTypes__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  if (this.types$2.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var str = this.key$1;
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$8 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    var jsx$7 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var jsx$6 = this.ordering$2;
    var jsx$5 = this.types$2;
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$3$2) {
        var x$3 = $as_Lamf_core_model_domain_Shape(x$3$2);
        var jsx$4 = $this.ordering$2;
        var jsx$3 = $this.references$2;
        var jsx$2 = $m_sc_Seq$();
        var array = [$this.key$1];
        return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasNamedTypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__s_Option__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(x$3, jsx$4, jsx$3, $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))), $m_s_None$(), $this.spec$2)
      })
    })(this));
    var this$6 = $m_sc_Seq$();
    jsx$7.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$6.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2))), b$1);
    jsx$8.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
    var this$9 = v.builder$1;
    var array$1 = [key];
    if ((this$9.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array$1.length);
    var newSize = ((this$9.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$9, newSize);
    var len$1 = this$9.size0$6;
    var src = this$9.array$6;
    var dest = this$9.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$9.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array$1.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$9 = j;
      var index = i;
      xs.set(jsx$9, array$1[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$9.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasDeclaredTypesEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasDeclaredTypesEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasDeclaredTypesEmitters", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasDeclaredTypesEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter.call(this);
  this.shapeExtension$2 = null;
  this.ordering$2 = null;
  this.name$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter.prototype.productPrefix__T = (function() {
  return "OasFacetsInstanceEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter)) {
    var OasFacetsInstanceEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter(x$1);
    var x = this.shapeExtension$2;
    var x$2 = OasFacetsInstanceEmitter$1.shapeExtension$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = OasFacetsInstanceEmitter$1.ordering$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shapeExtension$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter.prototype.name__T = (function() {
  return this.name$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter.prototype.init___Lamf_core_model_domain_extensions_ShapeExtension__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(shapeExtension, ordering, spec) {
  this.shapeExtension$2 = shapeExtension;
  this.ordering$2 = ordering;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter.prototype.init___Lamf_core_model_domain_extensions_ShapeExtension__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, shapeExtension, ordering, spec);
  var this$1 = $as_Lamf_core_model_domain_extensions_PropertyShape(shapeExtension.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$().DefinedBy$1));
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
  var this$3 = this$2.option$1;
  var str = ("facet-" + $as_T((this$3.isEmpty__Z() ? null : this$3.get__O())));
  this.name$2 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str).asOasExtension__T();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasFacetsInstanceEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasFacetsInstanceEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasFacetsInstanceEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasFacetsInstanceEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySchemeParser.call(this);
  this.part$3 = null;
  this.adopt$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySchemeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser.prototype.init___Lorg_yaml_model_YPart__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(part, adopt, ctx) {
  this.part$3 = part;
  this.adopt$3 = adopt;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySchemeParser.prototype.init___Lorg_yaml_model_YPart__F1__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.call(this, part, adopt, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser.prototype.productPrefix__T = (function() {
  return "OasSecuritySchemeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser)) {
    var OasSecuritySchemeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser(x$1);
    var x = this.part$3;
    var x$2 = OasSecuritySchemeParser$1.part$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.adopt$3;
      var x$4 = OasSecuritySchemeParser$1.adopt$3;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.part$3;
      break
    }
    case 1: {
      return this.adopt$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasSecuritySchemeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasSecuritySchemeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasSecuritySchemeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasLikeSecuritySchemeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasSecuritySchemeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.call(this);
  this.shape$3 = null;
  this.map$3 = null;
  this.adopt$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser.prototype.productPrefix__T = (function() {
  return "ArrayShapeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser(x$1).$$outer$1 === this.$$outer$1))) {
    var ArrayShapeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser(x$1);
    var x = this.shape$3;
    var x$2 = ArrayShapeParser$1.shape$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var this$1 = this.map$3;
      var b = ArrayShapeParser$1.map$3;
      var jsx$1 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.adopt$3;
      var x$4 = ArrayShapeParser$1.adopt$3;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$3;
      break
    }
    case 1: {
      return this.map$3;
      break
    }
    case 2: {
      return this.adopt$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  this.$$outer$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$checkJsonIdentity__Lamf_plugins_domain_shapes_models_AnyShape__Lorg_yaml_model_YMap__F1__Lamf_core_parser_FutureDeclarations__V(this.shape$3, this.map$3, this.adopt$3, this.$$outer$1.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations().futureDeclarations__Lamf_core_parser_FutureDeclarations());
  $f_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementShapeParser__parse__Lamf_plugins_domain_shapes_models_AnyShape(this);
  var map = this.map$3;
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$2 = this.$$outer$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().CollectionFormat$1;
  var iv = this.$$outer$1.ctx$2;
  jsx$1.key__T__F1__V("collectionFormat", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$2, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$3));
  var map$1 = this.map$3;
  var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option("items");
  if (this$4.isEmpty__Z()) {
    var this$6 = $m_s_None$()
  } else {
    var arg1 = this$4.get__O();
    var x$20 = $as_Lorg_yaml_model_YMapEntry(arg1);
    var node = x$20.value$2;
    var this$6 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YMapYRead$())
  };
  if ((!this$6.isEmpty__Z())) {
    var arg1$1 = this$6.get__O();
    var x$21 = $as_Lorg_yaml_model_YMap(arg1$1);
    var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(x$21);
    var this$8 = this.$$outer$1;
    var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().CollectionFormat$1;
    var iv$1 = this.$$outer$1.ctx$2;
    jsx$2.key__T__F1__V("collectionFormat", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$8, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$3).withAnnotation__Lamf_core_model_domain_Annotation__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_Lamf_plugins_document_webapi_annotations_CollectionFormatFromItems().init___()))
  };
  var map$2 = this.map$3;
  var this$10 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2).key__T__s_Option("items");
  if (this$10.isEmpty__Z()) {
    var finalShape = $m_s_None$()
  } else {
    var arg1$2 = this$10.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var this$11 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(items$2) {
        var items = $as_Lamf_core_model_domain_Shape(items$2);
        items.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(($this.shape$3.id$1 + "/items"), items.adopted$default$2__sc_Seq())
      })
    })(this)), this.$$outer$1.version$2, this.$$outer$1.ctx$2).parse__s_Option();
    if (this$11.isEmpty__Z()) {
      var finalShape = $m_s_None$()
    } else {
      var arg1$3 = this$11.get__O();
      var item = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1$3);
      if ((item instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
        var x2 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(item);
        var jsx$3 = this.shape$3.withItems__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_ArrayShape(x2).toMatrixShape__Lamf_plugins_domain_shapes_models_MatrixShape()
      } else if ((item instanceof $c_Lamf_plugins_domain_shapes_models_MatrixShape)) {
        var x3 = $as_Lamf_plugins_domain_shapes_models_MatrixShape(item);
        var jsx$3 = this.shape$3.withItems__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_ArrayShape(x3).toMatrixShape__Lamf_plugins_domain_shapes_models_MatrixShape()
      } else {
        if ((item === null)) {
          throw new $c_s_MatchError().init___O(item)
        };
        var jsx$3 = this.shape$3.withItems__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_ArrayShape(item)
      };
      var finalShape = new $c_s_Some().init___O(jsx$3)
    }
  };
  if ((finalShape instanceof $c_s_Some)) {
    var x2$1 = $as_s_Some(finalShape);
    var parsed = $as_Lamf_plugins_domain_shapes_models_DataArrangementShape(x2$1.value$2);
    if ((parsed !== null)) {
      var value = this.shape$3.id$1;
      return $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(parsed, value))
    }
  };
  var x = $m_s_None$();
  if ((x === finalShape)) {
    var jsx$4 = this.shape$3;
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var fields = new $c_Lamf_core_parser_Fields().init___();
    return jsx$4.withItems__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_ArrayShape(new $c_Lamf_plugins_domain_shapes_models_AnyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations))
  };
  throw new $c_s_MatchError().init___O(finalShape)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser.prototype.map__Lorg_yaml_model_YMap = (function() {
  return this.map$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_ArrayShape__Lorg_yaml_model_YMap__F1 = (function($$outer, shape, map, adopt) {
  this.shape$3 = shape;
  this.map$3 = map;
  this.adopt$3 = adopt;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.call(this, $$outer);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser.prototype.shape__Lamf_core_model_domain_Shape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser.prototype.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$DataArrangementShapeParser$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser = (function() {
  return this.$$outer$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser.prototype.shape__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$ArrayShapeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$ArrayShapeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$ArrayShapeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementShapeParser: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ArrayShapeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.call(this);
  this.typeDef$3 = null;
  this.shape$3 = null;
  this.map$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser.prototype.productPrefix__T = (function() {
  return "FileShapeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser(x$1).$$outer$1 === this.$$outer$1))) {
    var FileShapeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser(x$1);
    var x = this.typeDef$3;
    var x$2 = FileShapeParser$1.typeDef$3;
    if ((x === x$2)) {
      var x$3 = this.shape$3;
      var x$4 = FileShapeParser$1.shape$3;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var this$1 = this.map$3;
      var b = FileShapeParser$1.map$3;
      return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.typeDef$3;
      break
    }
    case 1: {
      return this.shape$3;
      break
    }
    case 2: {
      return this.map$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_domain_shapes_models_FileShape__Lorg_yaml_model_YMap = (function($$outer, typeDef, shape, map) {
  this.typeDef$3 = typeDef;
  this.shape$3 = shape;
  this.map$3 = map;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.call(this, $$outer);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser.prototype.map__Lorg_yaml_model_YMap = (function() {
  return this.map$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser.prototype.shape__Lamf_core_model_domain_Shape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser.prototype.shape__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_FileShape = (function() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape.call(this);
  var map = this.map$3;
  var shape = this.shape$3;
  var typeDef = this.typeDef$3;
  $f_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$CommonScalarParsingLogic__parseScalar__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_domain_shapes_models_TypeDef(this, map, shape, typeDef);
  var map$1 = this.map$3;
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var jsx$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T("fileTypes").asOasExtension__T();
  var this$3 = this.$$outer$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$().FileTypes$1;
  var iv = this.$$outer$1.ctx$2;
  jsx$2.key__T__F1__V(jsx$1, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$3, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$3));
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser.prototype.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser = (function() {
  return this.$$outer$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$FileShapeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$FileShapeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$FileShapeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$CommonScalarParsingLogic: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.call(this);
  this.dataNodeParser$3 = null;
  this.enumParser$3 = null;
  this.typeDef$3 = null;
  this.shape$3 = null;
  this.map$3 = null;
  this.bitmap$0$3 = 0
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype.productPrefix__T = (function() {
  return "ScalarShapeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser(x$1).$$outer$1 === this.$$outer$1))) {
    var ScalarShapeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser(x$1);
    var x = this.typeDef$3;
    var x$2 = ScalarShapeParser$1.typeDef$3;
    if ((x === x$2)) {
      var x$3 = this.shape$3;
      var x$4 = ScalarShapeParser$1.shape$3;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var this$1 = this.map$3;
      var b = ScalarShapeParser$1.map$3;
      return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype.dataNodeParser__F1 = (function() {
  return (((((1 & this.bitmap$0$3) << 24) >> 24) === 0) ? this.dataNodeParser$lzycompute__p3__F1() : this.dataNodeParser$3)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.typeDef$3;
      break
    }
    case 1: {
      return this.shape$3;
      break
    }
    case 2: {
      return this.map$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype.enumParser$lzycompute__p3__F1 = (function() {
  if (((((2 & this.bitmap$0$3) << 24) >> 24) === 0)) {
    this.enumParser$3 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$().apply__T__T__Lamf_plugins_document_webapi_contexts_WebApiContext__F1(this.shape$3.id$1, $m_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$().SCALAR$undENUM$1, this.$$outer$1.ctx$2);
    this.bitmap$0$3 = (((2 | this.bitmap$0$3) << 24) >> 24)
  };
  return this.enumParser$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype.map__Lorg_yaml_model_YMap = (function() {
  return this.map$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_ScalarShape = (function() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape.call(this);
  var map = this.map$3;
  var shape = this.shape$3;
  var typeDef = this.typeDef$3;
  var validatedTypeDef = $f_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$CommonScalarParsingLogic__parseScalar__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_domain_shapes_models_TypeDef(this, map, shape, typeDef);
  var map$1 = this.map$3;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option("type");
  if (this$2.isEmpty__Z()) {
    var this$5 = this.shape$3;
    var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
    var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$().xsd__Lamf_plugins_domain_shapes_models_TypeDef__T(validatedTypeDef), new $c_Lamf_core_parser_Annotations().init___());
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$5, field, value, annotations))
  } else {
    var arg1 = this$2.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$7 = this.shape$3;
    var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
    var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$().xsd__Lamf_plugins_domain_shapes_models_TypeDef__T(validatedTypeDef), new $c_Lamf_core_parser_Annotations().init___());
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$7, field$1, value$1, annotations$1))
  };
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype.dataNodeParser$lzycompute__p3__F1 = (function() {
  if (((((1 & this.bitmap$0$3) << 24) >> 24) === 0)) {
    var x$1 = new $c_s_Some().init___O(this.shape$3.id$1);
    var x$2 = new $c_Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables().init___();
    var x$3 = new $c_Lamf_core_utils_package$IdCounter().init___();
    var eta$0$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_ScalarNodeParser().init___Lamf_plugins_document_webapi_parser_spec_common_AbstractVariables__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_WebApiContext(x$2, x$1, x$3, this.$$outer$1.ctx$2);
    this.dataNodeParser$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, eta$0$1$1) {
      return (function(node$2) {
        var node = $as_Lorg_yaml_model_YNode(node$2);
        return eta$0$1$1.parse__Lorg_yaml_model_YNode__Lamf_core_model_domain_DataNode(node)
      })
    })(this, eta$0$1));
    this.bitmap$0$3 = (((1 | this.bitmap$0$3) << 24) >> 24)
  };
  return this.dataNodeParser$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_domain_shapes_models_ScalarShape__Lorg_yaml_model_YMap = (function($$outer, typeDef, shape, map) {
  this.typeDef$3 = typeDef;
  this.shape$3 = shape;
  this.map$3 = map;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.call(this, $$outer);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype.shape__Lamf_core_model_domain_Shape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype.shape__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser = (function() {
  return this.$$outer$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype.enumParser__F1 = (function() {
  return (((((2 & this.bitmap$0$3) << 24) >> 24) === 0) ? this.enumParser$lzycompute__p3__F1() : this.enumParser$3)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$ScalarShapeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$ScalarShapeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$ScalarShapeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$CommonScalarParsingLogic: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.call(this);
  this.shape$3 = null;
  this.map$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser.prototype.productPrefix__T = (function() {
  return "SchemaShapeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_SchemaShape__Lorg_yaml_model_YMap = (function($$outer, shape, map) {
  this.shape$3 = shape;
  this.map$3 = map;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.call(this, $$outer);
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape.call(this);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser(x$1).$$outer$1 === this.$$outer$1))) {
    var SchemaShapeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser(x$1);
    var x = this.shape$3;
    var x$2 = SchemaShapeParser$1.shape$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var this$1 = this.map$3;
      var b = SchemaShapeParser$1.map$3;
      return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$3;
      break
    }
    case 1: {
      return this.map$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  var map = this.map$3;
  var this$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("schema").asOasExtension__T();
  var this$4 = this$3.key__T__s_Option(keyword);
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$5 = entry.value$2;
    var evidence$2 = $m_Lorg_yaml_convert_YRead$StringYRead$();
    var x1 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$5, evidence$2);
    if ((x1 instanceof $c_s_util_Right)) {
      var x2 = $as_s_util_Right(x1);
      var str = $as_T(x2.value$2);
      var this$6 = this.shape$3;
      var field = $m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$().Raw$1;
      $as_Lamf_plugins_domain_shapes_models_SchemaShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$6, field, str))
    } else {
      var this$7 = this.$$outer$1.ctx$2.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidSchemaType$1;
      var node = this.shape$3.id$1;
      var ast = entry.value$2;
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$7, specification, node, prop, "Cannot parse non string schema shape", l);
      var this$8 = this.shape$3;
      var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$().Raw$1;
      $as_Lamf_plugins_domain_shapes_models_SchemaShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$8, field$1, ""))
    }
  };
  var map$1 = this.map$3;
  var this$11 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var keyword$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T("mediaType").asOasExtension__T();
  var this$12 = this$11.key__T__s_Option(keyword$1);
  if ((!this$12.isEmpty__Z())) {
    var arg1$1 = this$12.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var this$13 = entry$3.value$2;
    var evidence$2$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
    var x1$1 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$13, evidence$2$1);
    if ((x1$1 instanceof $c_s_util_Right)) {
      var x2$1 = $as_s_util_Right(x1$1);
      var str$1 = $as_T(x2$1.value$2);
      var this$14 = this.shape$3;
      var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$().MediaType$1;
      $as_Lamf_plugins_domain_shapes_models_SchemaShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$14, field$2, str$1))
    } else {
      var this$15 = this.$$outer$1.ctx$2.eh$1;
      var specification$1 = $m_Lamf_validations_ParserSideValidations$().InvalidMediaTypeType$1;
      var node$1 = this.shape$3.id$1;
      var ast$1 = entry$3.value$2;
      var prop$1 = $m_s_None$();
      var l$1 = ast$1.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$15, specification$1, node$1, prop$1, "Cannot parse non string schema shape", l$1);
      var this$16 = this.shape$3;
      var field$3 = $m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$().MediaType$1;
      $as_Lamf_plugins_domain_shapes_models_SchemaShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$16, field$3, "*/*"))
    }
  };
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser.prototype.map__Lorg_yaml_model_YMap = (function() {
  return this.map$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser.prototype.shape__Lamf_core_model_domain_Shape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser.prototype.shape__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser.prototype.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser = (function() {
  return this.$$outer$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$SchemaShapeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$SchemaShapeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$SchemaShapeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$CommonScalarParsingLogic: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.call(this);
  this.shape$3 = null;
  this.map$3 = null;
  this.adopt$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_TupleShape__Lorg_yaml_model_YMap__F1 = (function($$outer, shape, map, adopt) {
  this.shape$3 = shape;
  this.map$3 = map;
  this.adopt$3 = adopt;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.call(this, $$outer);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser.prototype.productPrefix__T = (function() {
  return "TupleShapeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser(x$1).$$outer$1 === this.$$outer$1))) {
    var TupleShapeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser(x$1);
    var x = this.shape$3;
    var x$2 = TupleShapeParser$1.shape$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var this$1 = this.map$3;
      var b = TupleShapeParser$1.map$3;
      var jsx$1 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.adopt$3;
      var x$4 = TupleShapeParser$1.adopt$3;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$3;
      break
    }
    case 1: {
      return this.map$3;
      break
    }
    case 2: {
      return this.adopt$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  this.adopt$3.apply__O__O(this.shape$3);
  $f_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementShapeParser__parse__Lamf_plugins_domain_shapes_models_AnyShape(this);
  var map = this.map$3;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("additionalItems");
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$3 = entry.value$2;
    var x1 = this$3.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Bool$1;
    if ((x === x1)) {
      var this$4 = this.$$outer$1;
      var field = $m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().ClosedItems$2;
      var iv = this.$$outer$1.ctx$2;
      new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$4, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$3).negated__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField().apply__Lorg_yaml_model_YMapEntry__V(entry);
      var x$3 = this.$$outer$1.version$2;
      var x$4 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$();
      if (((x$3 !== null) && x$3.equals__O__Z(x$4))) {
        this.additionalItemViolation__p3__Lorg_yaml_model_YMapEntry__T__V(entry, "Invalid part type for additional items node. Expected a map")
      }
    } else {
      var x$5 = $m_Lorg_yaml_model_YType$().Map$1;
      if ((x$5 === x1)) {
        var this$5 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(s$2) {
            var s = $as_Lamf_core_model_domain_Shape(s$2);
            s.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject($this.shape$3.id$1, s.adopted$default$2__sc_Seq())
          })
        })(this)), this.$$outer$1.version$2, this.$$outer$1.ctx$2).parse__s_Option();
        if ((!this$5.isEmpty__Z())) {
          var arg1$1 = this$5.get__O();
          var s$3 = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1$1);
          var this$6 = this.shape$3;
          var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().AdditionalItemsSchema$2;
          var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
          $as_Lamf_plugins_domain_shapes_models_TupleShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$6, field$1, s$3, annotations))
        }
      } else {
        var x$7 = this.$$outer$1.version$2;
        var x$8 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$();
        this.additionalItemViolation__p3__Lorg_yaml_model_YMapEntry__T__V(entry, (((x$7 !== null) && x$7.equals__O__Z(x$8)) ? "Invalid part type for additional items node. Expected a map" : "Invalid part type for additional items node. Should be a boolean or a map"))
      }
    }
  };
  var map$1 = this.map$3;
  var this$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var this$9 = this$8.key__T__s_Option("items");
  if ((!this$9.isEmpty__Z())) {
    var arg1$2 = this$9.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var this$10 = entry$3.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
    var iv$1 = this.$$outer$1.ctx$2;
    var jsx$5 = $as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$10, conversion, iv$1)).nodes$3;
    var jsx$4 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser$$anonfun$2().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser(this);
    var this$11 = $m_sc_IndexedSeq$();
    var jsx$3 = $as_sc_IterableLike(jsx$5.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$4, this$11.ReusableCBF$6));
    var this$12 = $m_sc_IndexedSeq$();
    var jsx$2 = $as_sc_TraversableLike(jsx$3.zipWithIndex__scg_CanBuildFrom__O(this$12.ReusableCBF$6));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_T2(x0$1$2);
        if ((x0$1 !== null)) {
          var elem = $as_Lorg_yaml_model_YNode(x0$1.$$und1__O());
          var index = x0$1.$$und2$mcI$sp__I();
          return $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YNode__T__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(elem, ("member" + index), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, index$1) {
            return (function(item$2) {
              var item = $as_Lamf_core_model_domain_Shape(item$2);
              item.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject((($this$2.shape$3.id$1 + "/items/") + index$1), item.adopted$default$2__sc_Seq())
            })
          })($this$1, index)), $this$1.$$outer$1.version$2, $this$1.$$outer$1.ctx$2).parse__s_Option()
        } else {
          throw new $c_s_MatchError().init___O(x0$1)
        }
      })
    })(this));
    var this$13 = $m_sc_IndexedSeq$();
    var items = $as_sc_IndexedSeq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$13.ReusableCBF$6));
    var this$15 = this.shape$3;
    var jsx$7 = $as_sc_TraversableLike(items.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(x$18$2) {
        var x$18 = $as_s_Option(x$18$2);
        return x$18.isDefined__Z()
      })
    })(this))));
    var jsx$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
      return (function(x$19$2) {
        var x$19 = $as_s_Option(x$19$2);
        return $as_Lamf_plugins_domain_shapes_models_AnyShape(x$19.get__O())
      })
    })(this));
    var this$14 = $m_sc_IndexedSeq$();
    var items$1 = $as_sc_Seq(jsx$7.map__F1__scg_CanBuildFrom__O(jsx$6, this$14.ReusableCBF$6));
    var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().TupleItems$2;
    $as_Lamf_plugins_domain_shapes_models_TupleShape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$15, field$2, items$1))
  };
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser.prototype.additionalItemViolation__p3__Lorg_yaml_model_YMapEntry__T__V = (function(entry, msg) {
  var this$1 = this.$$outer$1.ctx$2.eh$1;
  var specification = $m_Lamf_validations_ParserSideValidations$().InvalidAdditionalItemsType$1;
  var node = this.shape$3.id$1;
  var prop = $m_s_None$();
  var l = entry.location$1;
  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, node, prop, msg, l)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser.prototype.map__Lorg_yaml_model_YMap = (function() {
  return this.map$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser.prototype.shape__Lamf_core_model_domain_Shape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser.prototype.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$DataArrangementShapeParser$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser = (function() {
  return this.$$outer$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser.prototype.shape__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$TupleShapeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$TupleShapeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser$TupleShapeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ShapeParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementShapeParser: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$TupleShapeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter.call(this);
  this.domainExtension$2 = null;
  this.ordering$2 = null;
  this.name$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter.prototype.productPrefix__T = (function() {
  return "RamlAnnotationEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter)) {
    var RamlAnnotationEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter(x$1);
    var x = this.domainExtension$2;
    var x$2 = RamlAnnotationEmitter$1.domainExtension$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = RamlAnnotationEmitter$1.ordering$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.domainExtension$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter.prototype.name__T = (function() {
  return this.name$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter.prototype.init___Lamf_core_model_domain_extensions_DomainExtension__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(domainExtension, ordering, spec) {
  this.domainExtension$2 = domainExtension;
  this.ordering$2 = ordering;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter.prototype.init___Lamf_core_model_domain_extensions_DomainExtension__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, domainExtension, ordering, spec);
  var this$1 = $as_Lamf_core_model_StrField(domainExtension.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1));
  var this$2 = this$1.option$1;
  this.name$2 = (("(" + $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()))) + ")");
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlAnnotationEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlAnnotationEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlAnnotationEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlAnnotationEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter.call(this);
  this.f$2 = null;
  this.ordering$2 = null;
  this.references$2 = null;
  this.spec$2 = null;
  this.key$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter.prototype.productPrefix__T = (function() {
  return "RamlCustomFacetsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter)) {
    var RamlCustomFacetsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter(x$1);
    var x = this.f$2;
    var x$2 = RamlCustomFacetsEmitter$1.f$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = RamlCustomFacetsEmitter$1.ordering$2;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$2;
      var x$6 = RamlCustomFacetsEmitter$1.references$2;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.f$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    case 2: {
      return this.references$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter.prototype.shapeEmitter__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(property$2, ordering$2, references$2) {
      var property = $as_Lamf_core_model_domain_extensions_PropertyShape(property$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      var references = $as_sc_Seq(references$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertyShapeEmitter().init___Lamf_core_model_domain_extensions_PropertyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(property, ordering, references, $this.spec$2)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(f, ordering, references, spec) {
  this.f$2 = f;
  this.ordering$2 = ordering;
  this.references$2 = references;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter.prototype.init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, f, ordering, references, spec);
  this.key$2 = "facets";
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter.prototype.key__T = (function() {
  return this.key$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlCustomFacetsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlCustomFacetsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlCustomFacetsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_CustomFacetsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlCustomFacetsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters.call(this);
  this.types$2 = null;
  this.references$2 = null;
  this.ordering$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters.prototype.init___sc_Seq__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(types, references, ordering, spec) {
  this.types$2 = types;
  this.references$2 = references;
  this.ordering$2 = ordering;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters.prototype.init___sc_Seq__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, types, references, ordering, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters.prototype.productPrefix__T = (function() {
  return "RamlDeclaredTypesEmitters"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters)) {
    var RamlDeclaredTypesEmitters$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters(x$1);
    var x = this.types$2;
    var x$2 = RamlDeclaredTypesEmitters$1.types$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.references$2;
      var x$4 = RamlDeclaredTypesEmitters$1.references$2;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.ordering$2;
      var x$6 = RamlDeclaredTypesEmitters$1.ordering$2;
      return (x$5 === x$6)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.types$2;
      break
    }
    case 1: {
      return this.references$2;
      break
    }
    case 2: {
      return this.ordering$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters.prototype.emitTypes__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var str = this.spec$2.factory__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory().typesKey__T();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$5 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var jsx$3 = this.ordering$2;
  var jsx$2 = this.types$2;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_domain_Shape(x0$1$2);
      if ((x0$1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
        var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x0$1);
        var xo = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter().init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__F5__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x2, $this.ordering$2, $this.references$2, $this.spec$2.factory__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlEmitterVersionFactory().typesEmitter__F5(), $this.spec$2));
        return xo.toList__sci_List()
      } else if ((x0$1 instanceof $c_Lamf_core_model_domain_RecursiveShape)) {
        var x3 = $as_Lamf_core_model_domain_RecursiveShape(x0$1);
        var xo$1 = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlRecursiveShapeTypeEmitter().init___Lamf_core_model_domain_RecursiveShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x3, $this.ordering$2, $this.references$2, $this.spec$2));
        return xo$1.toList__sci_List()
      } else {
        var this$5 = $this.spec$2;
        var this$6 = this$5.eh$1;
        var specification = $m_Lamf_validations_RenderSideValidations$().RenderValidation$1;
        var node = x0$1.id$1;
        var property = $m_s_None$();
        var lexical = x0$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
        var location = x0$1.location__s_Option();
        this$6.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "Cannot emit non WebApi shape", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
        var xo$2 = $m_s_None$();
        return xo$2.toList__sci_List()
      }
    })
  })(this));
  var this$8 = $m_sc_Seq$();
  jsx$4.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$3.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$8.ReusableCBFInstance$2))), b$1);
  jsx$5.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$11 = v.builder$1;
  var array = [key];
  if ((this$11.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$11.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$11, newSize);
  var len$1 = this$11.size0$6;
  var src = this$11.array$6;
  var dest = this$11.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$11.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$6 = j;
    var index = i;
    xs.set(jsx$6, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$11.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlDeclaredTypesEmitters"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlDeclaredTypesEmitters;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlDeclaredTypesEmitters", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_DeclaredTypesEmitters: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlDeclaredTypesEmitters;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter.call(this);
  this.shapeExtension$2 = null;
  this.ordering$2 = null;
  this.name$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter.prototype.productPrefix__T = (function() {
  return "RamlFacetsInstanceEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter)) {
    var RamlFacetsInstanceEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter(x$1);
    var x = this.shapeExtension$2;
    var x$2 = RamlFacetsInstanceEmitter$1.shapeExtension$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = RamlFacetsInstanceEmitter$1.ordering$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shapeExtension$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter.prototype.name__T = (function() {
  return this.name$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter.prototype.init___Lamf_core_model_domain_extensions_ShapeExtension__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(shapeExtension, ordering, spec) {
  this.shapeExtension$2 = shapeExtension;
  this.ordering$2 = ordering;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter.prototype.init___Lamf_core_model_domain_extensions_ShapeExtension__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, shapeExtension, ordering, spec);
  var this$1 = $as_Lamf_core_model_domain_extensions_PropertyShape(shapeExtension.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$().DefinedBy$1));
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
  var this$3 = this$2.option$1;
  this.name$2 = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlFacetsInstanceEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlFacetsInstanceEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlFacetsInstanceEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_FacetsInstanceEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlFacetsInstanceEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEntryEmitter() {
  $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter.call(this)
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEntryEmitter.prototype = new $h_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEntryEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEntryEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEntryEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEntryEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEntryEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEntryEmitter.prototype.init___T__Lamf_core_model_domain_Linkable = (function(key, reference) {
  $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter.prototype.init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position.call(this, key, new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEmitter().init___Lamf_core_model_domain_Linkable(reference), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$());
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEntryEmitter.prototype.key__T = (function() {
  return this.key$1
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEntryEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEntryEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlLocalReferenceEntryEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEntryEmitter: 1,
  Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEntryEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlLocalReferenceEntryEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter() {
  $c_O.call(this);
  this.target$1 = null;
  this.label$1 = null;
  this.references$1 = null;
  this.spec$1 = null;
  this.referenceLabel$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter.prototype.init___Lamf_core_model_domain_DomainElement__s_Option__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(target, label, references, spec) {
  this.target$1 = target;
  this.label$1 = label;
  this.references$1 = references;
  this.spec$1 = spec;
  $f_Lamf_plugins_document_webapi_contexts_TagToReferenceEmitter__$$init$__V(this);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter.prototype.target__Lamf_core_model_domain_DomainElement = (function() {
  return this.target$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter.prototype.productPrefix__T = (function() {
  return "RamlTagToReferenceEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var x1 = this.references$1.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_document_BaseUnit(x0$1$2);
      if ((x0$1 instanceof $c_Lamf_core_model_document_Module)) {
        var x2 = $as_Lamf_core_model_document_Module(x0$1);
        return $as_sc_Seq(x2.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_ModuleModel$().Declares$1)).contains__O__Z($this.target$1)
      } else if ($is_Lamf_core_model_document_Fragment(x0$1)) {
        var x3 = $as_Lamf_core_model_document_Fragment(x0$1);
        var x = x3.encodes__Lamf_core_model_domain_DomainElement();
        var x$2 = $this.target$1;
        return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this)));
  matchEnd6: {
    if ((x1 instanceof $c_s_Some)) {
      var x2$1 = $as_s_Some(x1);
      if ($is_Lamf_core_model_document_Fragment(x2$1.value$2)) {
        this.spec$1.ref__Lorg_yaml_model_YDocument$PartBuilder__T__V(b, this.referenceLabel$1);
        break matchEnd6
      }
    };
    $m_Lamf_core_emitter_BaseEmitters_package$().raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(b, this.referenceLabel$1, $m_Lorg_yaml_model_YType$().Str$1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter)) {
    var RamlTagToReferenceEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter(x$1);
    var x = this.target$1;
    var x$2 = RamlTagToReferenceEmitter$1.target$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.label$1;
      var x$4 = RamlTagToReferenceEmitter$1.label$1;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = RamlTagToReferenceEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.target$1;
      break
    }
    case 1: {
      return this.label$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter.prototype.amf$plugins$document$webapi$contexts$TagToReferenceEmitter$$undsetter$und$referenceLabel$und$eq__T__V = (function(x$1) {
  this.referenceLabel$1 = x$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter.prototype.label__s_Option = (function() {
  return this.label$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.target$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlTagToReferenceEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlTagToReferenceEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTagToReferenceEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  Lamf_plugins_document_webapi_contexts_TagToReferenceEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTagToReferenceEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.f$1 = null;
  this.ordering$1 = null;
  this.eh$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter.prototype.emit__Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait__Lamf_core_emitter_PartEmitter = (function(element) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_ParametrizedDeclarationEmitter().init___Lamf_core_model_domain_templates_ParametrizedDeclaration__Lamf_core_emitter_SpecOrdering__Lamf_core_errorhandling_ErrorHandler(element, this.ordering$1, this.eh$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter.prototype.productPrefix__T = (function() {
  return "TraitExtendsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter)) {
    var TraitExtendsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter(x$1);
    if ((this.key$1 === TraitExtendsEmitter$1.key$1)) {
      var x = this.f$1;
      var x$2 = TraitExtendsEmitter$1.f$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.ordering$1;
      var x$4 = TraitExtendsEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.f$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $f_Lamf_plugins_document_webapi_parser_spec_domain_SingleValueArrayEmitter__emit__Lorg_yaml_model_YDocument$EntryBuilder__V(this, b)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter.prototype.init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_core_errorhandling_ErrorHandler = (function(key, f, ordering, eh) {
  this.key$1 = key;
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.eh$1 = eh;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter.prototype.emit__Lamf_core_model_domain_AmfElement__Lamf_core_emitter_PartEmitter = (function(element) {
  return this.emit__Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait__Lamf_core_emitter_PartEmitter($as_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait(element))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter.prototype.f__Lamf_core_parser_FieldEntry = (function() {
  return this.f$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter.prototype.collect__sc_Seq__sc_Seq = (function(elements) {
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter$$anonfun$collect$1().init___Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter(this);
  var this$1 = $m_sc_Seq$();
  return $as_sc_Seq(elements.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter.prototype.ordering__Lamf_core_emitter_SpecOrdering = (function() {
  return this.ordering$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter.prototype.key__T = (function() {
  return this.key$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  return $f_Lamf_plugins_document_webapi_parser_spec_domain_SingleValueArrayEmitter__position__Lamf_core_parser_Position(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.TraitExtendsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.TraitExtendsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.TraitExtendsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_SingleValueArrayEmitter: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_TraitExtendsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector.call(this);
  this.array$2 = null;
  this.ordering$2 = null;
  this.references$2 = null;
  this.additionalEntry$2 = null;
  this.pointer$2 = null;
  this.schemaPath$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter.prototype.productPrefix__T = (function() {
  return "OasItemsShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter.prototype.productArity__I = (function() {
  return 6
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter)) {
    var OasItemsShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter(x$1);
    var x = this.array$2;
    var x$2 = OasItemsShapeEmitter$1.array$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = OasItemsShapeEmitter$1.ordering$2;
      var jsx$4 = (x$3 === x$4)
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      var x$5 = this.references$2;
      var x$6 = OasItemsShapeEmitter$1.references$2;
      var jsx$3 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$7 = this.additionalEntry$2;
      var x$8 = OasItemsShapeEmitter$1.additionalEntry$2;
      var jsx$2 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$9 = this.pointer$2;
      var x$10 = OasItemsShapeEmitter$1.pointer$2;
      var jsx$1 = ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$11 = this.schemaPath$2;
      var x$12 = OasItemsShapeEmitter$1.schemaPath$2;
      return ((x$11 === null) ? (x$12 === null) : x$11.equals__O__Z(x$12))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.array$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    case 2: {
      return this.references$2;
      break
    }
    case 3: {
      return this.additionalEntry$2;
      break
    }
    case 4: {
      return this.pointer$2;
      break
    }
    case 5: {
      return this.schemaPath$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter.prototype.emitPart__Lorg_yaml_model_YDocument$PartBuilder__V = (function(part) {
  var jsx$1 = this.pointer$2;
  var this$1 = $m_sc_Seq$();
  var x1 = this.emitter__sc_Seq__sc_Seq__s_util_Either($as_sc_Seq(jsx$1.$$colon$plus__O__scg_CanBuildFrom__O("items", this$1.ReusableCBFInstance$2)), this.schemaPath$2);
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var p = $as_Lamf_core_emitter_PartEmitter(x2.value$2);
    p.emit__Lorg_yaml_model_YDocument$PartBuilder__V(part)
  } else if ((x1 instanceof $c_s_util_Right)) {
    var x3 = $as_s_util_Right(x1);
    var entries = $as_sc_Seq(x3.value$2);
    var jsx$4 = part.builder$1;
    var sourceName = part.sourceName$2;
    var b = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    var jsx$3 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var xo = this.additionalEntry$2;
    var jsx$2 = xo.toList__sci_List();
    var this$4 = $m_sc_Seq$();
    jsx$3.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V($as_sc_Seq(entries.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$4.ReusableCBFInstance$2)), b);
    jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var jsx$1 = $m_s_Option$();
  var this$1 = this.array$2;
  if (jsx$1.apply__O__s_Option(this$1.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1)).isDefined__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("items");
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    this.emitPart__Lorg_yaml_model_YDocument$PartBuilder__V(v);
    var this$5 = v.builder$1;
    var array = [key];
    if ((this$5.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$5.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$5, newSize);
    var len$1 = this$5.size0$6;
    var src = this$5.array$6;
    var dest = this$5.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$5.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$2 = j;
      var index = i;
      xs.set(jsx$2, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$5.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_ArrayShape__Lamf_core_emitter_SpecOrdering__sc_Seq__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(array, ordering, references, additionalEntry, pointer, schemaPath, spec) {
  this.array$2 = array;
  this.ordering$2 = ordering;
  this.references$2 = references;
  this.additionalEntry$2 = additionalEntry;
  this.pointer$2 = pointer;
  this.schemaPath$2 = schemaPath;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.call(this, $as_Lamf_core_model_domain_Shape(array.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1)), ordering, $m_sci_Nil$(), references, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var jsx$1 = $m_s_Option$();
  var this$1 = this.array$2;
  var x1 = jsx$1.apply__O__s_Option(this$1.fields$2.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var value = $as_Lamf_core_parser_Value(x2.value$2);
    var this$2 = $m_Lamf_core_emitter_BaseEmitters_package$();
    var annotations = value.annotations$1;
    return this$2.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
  } else {
    return $m_Lamf_core_parser_Position$ZERO$()
  }
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasItemsShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasItemsShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasItemsShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasItemsShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector.call(this);
  this.property$2 = null;
  this.ordering$2 = null;
  this.references$2 = null;
  this.propertiesKey$2 = null;
  this.pointer$2 = null;
  this.schemaPath$2 = null;
  this.propertyName$2 = null;
  this.propertyKey$2 = null;
  this.computedEmitters$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter.prototype.productPrefix__T = (function() {
  return "OasPropertyShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter.prototype.productArity__I = (function() {
  return 6
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter)) {
    var OasPropertyShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter(x$1);
    var x = this.property$2;
    var x$2 = OasPropertyShapeEmitter$1.property$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = OasPropertyShapeEmitter$1.ordering$2;
      var jsx$3 = (x$3 === x$4)
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$5 = this.references$2;
      var x$6 = OasPropertyShapeEmitter$1.references$2;
      var jsx$2 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$2 = false
    };
    if ((jsx$2 && (this.propertiesKey$2 === OasPropertyShapeEmitter$1.propertiesKey$2))) {
      var x$7 = this.pointer$2;
      var x$8 = OasPropertyShapeEmitter$1.pointer$2;
      var jsx$1 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$9 = this.schemaPath$2;
      var x$10 = OasPropertyShapeEmitter$1.schemaPath$2;
      return ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.property$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    case 2: {
      return this.references$2;
      break
    }
    case 3: {
      return this.propertiesKey$2;
      break
    }
    case 4: {
      return this.pointer$2;
      break
    }
    case 5: {
      return this.schemaPath$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.property$2;
  var x1 = $as_Lamf_core_model_domain_Shape(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1));
  if (((x1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape) || (x1 instanceof $c_Lamf_core_model_domain_RecursiveShape))) {
    var key = this.propertyKey$2;
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var x1$1 = this.computedEmitters$2;
    if ((x1$1 instanceof $c_s_util_Left)) {
      var x2 = $as_s_util_Left(x1$1);
      var p = $as_Lamf_core_emitter_PartEmitter(x2.value$2);
      p.emit__Lorg_yaml_model_YDocument$PartBuilder__V(v)
    } else if ((x1$1 instanceof $c_s_util_Right)) {
      var x3 = $as_s_util_Right(x1$1);
      var entries = $as_sc_Seq(x3.value$2);
      var jsx$1 = v.builder$1;
      var sourceName = v.sourceName$2;
      var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
      $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$2.sorted__sc_Seq__sc_Seq(entries), b$1);
      jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
    } else {
      throw new $c_s_MatchError().init___O(x1$1)
    };
    var this$5 = v.builder$1;
    var array = [key];
    if ((this$5.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$5.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$5, newSize);
    var len$1 = this$5.size0$6;
    var src = this$5.array$6;
    var dest = this$5.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$5.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$2 = j;
      var index = i;
      xs.set(jsx$2, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$5.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter.prototype.init___Lamf_core_model_domain_extensions_PropertyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__T__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(property, ordering, references, propertiesKey, pointer, schemaPath, spec) {
  this.property$2 = property;
  this.ordering$2 = ordering;
  this.references$2 = references;
  this.propertiesKey$2 = propertiesKey;
  this.pointer$2 = pointer;
  this.schemaPath$2 = schemaPath;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.call(this, $as_Lamf_core_model_domain_Shape(property.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1)), ordering, $m_sci_Nil$(), references, spec);
  var this$1 = $as_Lamf_core_model_StrField(property.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().PatternName$1)).option$1;
  if (this$1.isEmpty__Z()) {
    var this$2 = this.property$2;
    var this$3 = $as_Lamf_core_model_StrField(this$2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
    var this$4 = this$3.option$1;
    var jsx$1 = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()))
  } else {
    var jsx$1 = this$1.get__O()
  };
  this.propertyName$2 = $as_T(jsx$1);
  this.propertyKey$2 = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YScalar$().apply__O__Lorg_yaml_model_YScalar(this.propertyName$2), $m_Lorg_yaml_model_YType$().Str$1);
  var jsx$3 = $m_sc_Seq$();
  var array = [propertiesKey, this.propertyName$2];
  var jsx$2 = jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
  var this$7 = $m_sc_Seq$();
  this.computedEmitters$2 = this.emitter__sc_Seq__sc_Seq__s_util_Either($as_sc_Seq(pointer.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$7.ReusableCBFInstance$2)), schemaPath);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.property$2.annotations$2;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasPropertyShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasPropertyShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasPropertyShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasPropertyShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector.call(this);
  this.shape$2 = null;
  this.ordering$2 = null;
  this.ignored$2 = null;
  this.references$2 = null;
  this.pointer$2 = null;
  this.schemaPath$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter.prototype.productPrefix__T = (function() {
  return "OasTypePartEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var x1 = this.emitter__sc_Seq__sc_Seq__s_util_Either(this.pointer$2, this.schemaPath$2);
  if ((x1 instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(x1);
    var p = $as_Lamf_core_emitter_PartEmitter(x2.value$2);
    p.emit__Lorg_yaml_model_YDocument$PartBuilder__V(b)
  } else if ((x1 instanceof $c_s_util_Right)) {
    var x3 = $as_s_util_Right(x1);
    var entries = $as_sc_Seq(x3.value$2);
    var jsx$1 = b.builder$1;
    var sourceName = b.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(entries, b$1);
    jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter.prototype.productArity__I = (function() {
  return 6
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter)) {
    var OasTypePartEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter(x$1);
    var x = this.shape$2;
    var x$2 = OasTypePartEmitter$1.shape$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = OasTypePartEmitter$1.ordering$2;
      var jsx$4 = (x$3 === x$4)
    } else {
      var jsx$4 = false
    };
    if (jsx$4) {
      var x$5 = this.ignored$2;
      var x$6 = OasTypePartEmitter$1.ignored$2;
      var jsx$3 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$7 = this.references$2;
      var x$8 = OasTypePartEmitter$1.references$2;
      var jsx$2 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$9 = this.pointer$2;
      var x$10 = OasTypePartEmitter$1.pointer$2;
      var jsx$1 = ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$11 = this.schemaPath$2;
      var x$12 = OasTypePartEmitter$1.schemaPath$2;
      return ((x$11 === null) ? (x$12 === null) : x$11.equals__O__Z(x$12))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    case 2: {
      return this.ignored$2;
      break
    }
    case 3: {
      return this.references$2;
      break
    }
    case 4: {
      return this.pointer$2;
      break
    }
    case 5: {
      return this.schemaPath$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.getEmitters__sc_Seq().headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$2 = $as_Lamf_core_emitter_Emitter(arg1);
    var this$2 = new $c_s_Some().init___O(x$2.position__Lamf_core_parser_Position())
  };
  return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(shape, ordering, ignored, references, pointer, schemaPath, spec) {
  this.shape$2 = shape;
  this.ordering$2 = ordering;
  this.ignored$2 = ignored;
  this.references$2 = references;
  this.pointer$2 = pointer;
  this.schemaPath$2 = schemaPath;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.call(this, shape, ordering, ignored, references, spec);
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasTypePartEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasTypePartEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasTypePartEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartCollector: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypePartEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter.call(this);
  this.shape$2 = null;
  this.ordering$2 = null;
  this.annotations$2 = null;
  this.ignored$2 = null;
  this.references$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter.prototype.productPrefix__T = (function() {
  return "Raml08TypePartEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter)) {
    var Raml08TypePartEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter(x$1);
    var x = this.shape$2;
    var x$2 = Raml08TypePartEmitter$1.shape$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = Raml08TypePartEmitter$1.ordering$2;
      var jsx$3 = (x$3 === x$4)
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$5 = this.annotations$2;
      var x$6 = Raml08TypePartEmitter$1.annotations$2;
      var jsx$2 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$7 = this.ignored$2;
      var x$8 = Raml08TypePartEmitter$1.ignored$2;
      var jsx$1 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$9 = this.references$2;
      var x$10 = Raml08TypePartEmitter$1.references$2;
      return ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    case 2: {
      return this.annotations$2;
      break
    }
    case 3: {
      return this.ignored$2;
      break
    }
    case 4: {
      return this.references$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter.prototype.emitters__sc_Seq = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(this.shape$2, this.ordering$2, this.spec$2).emitters__sc_Seq()
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(shape, ordering, annotations, ignored, references, spec) {
  this.shape$2 = shape;
  this.ordering$2 = ordering;
  this.annotations$2 = annotations;
  this.ignored$2 = ignored;
  this.references$2 = references;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, shape, ordering, annotations, ignored, references, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.Raml08TypePartEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.Raml08TypePartEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.Raml08TypePartEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter.call(this);
  this.shape$2 = null;
  this.ordering$2 = null;
  this.annotations$2 = null;
  this.ignored$2 = null;
  this.references$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter.prototype.productPrefix__T = (function() {
  return "Raml10TypePartEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter)) {
    var Raml10TypePartEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter(x$1);
    var x = this.shape$2;
    var x$2 = Raml10TypePartEmitter$1.shape$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = Raml10TypePartEmitter$1.ordering$2;
      var jsx$3 = (x$3 === x$4)
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$5 = this.annotations$2;
      var x$6 = Raml10TypePartEmitter$1.annotations$2;
      var jsx$2 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$7 = this.ignored$2;
      var x$8 = Raml10TypePartEmitter$1.ignored$2;
      var jsx$1 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$9 = this.references$2;
      var x$10 = Raml10TypePartEmitter$1.references$2;
      return ((x$9 === null) ? (x$10 === null) : x$9.equals__O__Z(x$10))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    case 2: {
      return this.annotations$2;
      break
    }
    case 3: {
      return this.ignored$2;
      break
    }
    case 4: {
      return this.references$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter.prototype.emitters__sc_Seq = (function() {
  var this$1 = this.annotations$2;
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter(arg1);
    var this$2 = new $c_s_Some().init___O(x$1.emitters__sc_Seq())
  };
  var annotationEmitters = $as_sc_Seq((this$2.isEmpty__Z() ? $m_sci_Nil$() : this$2.get__O()));
  var jsx$2 = this.ordering$2;
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(this.shape$2, this.ordering$2, this.ignored$2, this.references$2, annotationEmitters.nonEmpty__Z(), this.spec$2).emitters__sc_Seq();
  var this$3 = $m_sc_Seq$();
  return jsx$2.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$1.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(annotationEmitters, this$3.ReusableCBFInstance$2)))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(shape, ordering, annotations, ignored, references, spec) {
  this.shape$2 = shape;
  this.ordering$2 = ordering;
  this.annotations$2 = annotations;
  this.ignored$2 = ignored;
  this.references$2 = references;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter.prototype.init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, shape, ordering, annotations, ignored, references, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.Raml10TypePartEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.Raml10TypePartEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.Raml10TypePartEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.call(this);
  this.array$3 = null;
  this.ordering$3 = null;
  this.references$3 = null;
  this.spec$3 = null;
  this.typeName$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter.prototype.productPrefix__T = (function() {
  return "RamlArrayShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter.prototype.typeName__s_Option = (function() {
  return this.typeName$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter)) {
    var RamlArrayShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter(x$1);
    var x = this.array$3;
    var x$2 = RamlArrayShapeEmitter$1.array$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$3;
      var x$4 = RamlArrayShapeEmitter$1.ordering$3;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$3;
      var x$6 = RamlArrayShapeEmitter$1.references$3;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.array$3;
      break
    }
    case 1: {
      return this.ordering$3;
      break
    }
    case 2: {
      return this.references$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter.prototype.emitters__sc_Seq = (function() {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype.emitters__sc_Seq.call(this)));
  var this$1 = this.array$3;
  var fs = this$1.fields$2;
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    $as_Lamf_core_parser_FieldEntry(arg1);
    this.typeEmitted$1 = true;
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlItemsShapeEmitter().init___Lamf_plugins_domain_shapes_models_ArrayShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(this.array$3, this.ordering$3, this.references$3, this.spec$3))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MaxItems$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("maxItems", f, $m_s_None$(), this.spec$3)))
  };
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MinItems$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1$2 = this$5.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("minItems", f$3, $m_s_None$(), this.spec$3)))
  };
  var this$7 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().UniqueItems$1);
  if ((!this$7.isEmpty__Z())) {
    var arg1$3 = this$7.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("uniqueItems", f$4, $m_s_None$(), this.spec$3)))
  };
  var this$9 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().CollectionFormat$1);
  if ((!this$9.isEmpty__Z())) {
    var arg1$4 = this$9.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("collectionFormat").asRamlAnnotation__T(), f$5, $m_s_None$())))
  };
  if ((!this.typeEmitted$1)) {
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", "array", $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()))
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_ArrayShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(array, ordering, references, spec) {
  this.array$3 = array;
  this.ordering$3 = ordering;
  this.references$3 = references;
  this.spec$3 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this, array, ordering, references, spec);
  var this$1 = array.annotations$2.find__jl_Class__s_Option($d_Lamf_core_annotations_ExplicitField.getClassOf());
  if (this$1.isEmpty__Z()) {
    var jsx$1 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    $as_Lamf_core_annotations_ExplicitField(arg1);
    var jsx$1 = new $c_s_Some().init___O("array")
  };
  this.typeName$3 = jsx$1;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlArrayShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlArrayShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlArrayShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlArrayShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.call(this);
  this.MixedEmitters$module$3 = null;
  this.shape$3 = null;
  this.ordering$3 = null;
  this.references$3 = null;
  this.spec$3 = null;
  this.typeName$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter.prototype.productPrefix__T = (function() {
  return "RamlInlinedUnionShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter.prototype.typeName__s_Option = (function() {
  return this.typeName$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter.prototype.partEmitters__Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters = (function() {
  var this$1 = this.shape$3;
  if ($as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1)).isEmpty__Z()) {
    var this$2 = this.shape$3;
    var jsx$1 = $as_sc_Seq(this$2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).nonEmpty__Z()
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var unionEmitters = $m_sci_Nil$()
  } else {
    var jsx$2 = $m_sc_Seq$();
    var array = [new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedAnyOfShapeEmitter().init___Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(this.shape$3, this.ordering$3, this.references$3, this.spec$3)];
    var unionEmitters = $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  };
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter$MixedEmitters().init___Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter__sc_Seq__sc_Seq(this, $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype.emitters__sc_Seq.call(this), unionEmitters)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter)) {
    var RamlInlinedUnionShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter(x$1);
    var x = this.shape$3;
    var x$2 = RamlInlinedUnionShapeEmitter$1.shape$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$3;
      var x$4 = RamlInlinedUnionShapeEmitter$1.ordering$3;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$3;
      var x$6 = RamlInlinedUnionShapeEmitter$1.references$3;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$3;
      break
    }
    case 1: {
      return this.ordering$3;
      break
    }
    case 2: {
      return this.references$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(shape, ordering, references, spec) {
  this.shape$3 = shape;
  this.ordering$3 = ordering;
  this.references$3 = references;
  this.spec$3 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this, shape, ordering, references, spec);
  this.typeName$3 = new $c_s_Some().init___O("union");
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlInlinedUnionShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlInlinedUnionShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlInlinedUnionShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlInlinedUnionShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter() {
  $c_O.call(this);
  this.shape$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.typeKey$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter.prototype.productPrefix__T = (function() {
  return "RamlJsonShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var x1 = this.shape$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.getClassOf());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var json = $as_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema(x2.value$2);
    var this$1 = this.shape$1;
    if ($as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).nonEmpty__Z()) {
      var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      var shape = this.shape$1;
      var ordering = this.ordering$1;
      var references = this.references$1;
      var spec = this.spec$1;
      $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter__emitExamples__Lamf_plugins_domain_shapes_models_AnyShape__scm_ListBuffer__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__V(this, shape, results, ordering, references, spec);
      results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position(this.typeKey$1, json.rawText$1, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()));
      var jsx$1 = b.builder$1;
      var sourceName = b.sourceName$2;
      var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
      $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(results), b$1);
      jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
    } else {
      $m_Lamf_core_emitter_BaseEmitters_package$().raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(b, json.rawText$1, $m_Lorg_yaml_model_YType$().Str$1)
    }
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__T__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(shape, ordering, references, typeKey, spec) {
  this.shape$1 = shape;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.typeKey$1 = typeKey;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter)) {
    var RamlJsonShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter(x$1);
    var x = this.shape$1;
    var x$2 = RamlJsonShapeEmitter$1.shape$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RamlJsonShapeEmitter$1.ordering$1;
      var jsx$2 = (x$3 === x$4)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.references$1;
      var x$6 = RamlJsonShapeEmitter$1.references$1;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.typeKey$1 === RamlJsonShapeEmitter$1.typeKey$1)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.references$1;
      break
    }
    case 3: {
      return this.typeKey$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.shape$1.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlJsonShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlJsonShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlJsonShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlJsonShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.call(this);
  this.shape$3 = null;
  this.ordering$3 = null;
  this.references$3 = null;
  this.typeName$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter.prototype.productPrefix__T = (function() {
  return "RamlNilShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter.prototype.typeName__s_Option = (function() {
  return this.typeName$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter)) {
    var RamlNilShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter(x$1);
    var x = this.shape$3;
    var x$2 = RamlNilShapeEmitter$1.shape$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$3;
      var x$4 = RamlNilShapeEmitter$1.ordering$3;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$3;
      var x$6 = RamlNilShapeEmitter$1.references$3;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$3;
      break
    }
    case 1: {
      return this.ordering$3;
      break
    }
    case 2: {
      return this.references$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter.prototype.emitters__sc_Seq = (function() {
  var result = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype.emitters__sc_Seq.call(this);
  if ((!this.typeEmitted$1)) {
    var entry = new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", "nil", $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$());
    var jsx$3 = result;
    var jsx$2 = $m_sc_Seq$();
    var array = [entry];
    var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$5 = $m_sc_Seq$();
    result = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_NilShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(shape, ordering, references, spec) {
  this.shape$3 = shape;
  this.ordering$3 = ordering;
  this.references$3 = references;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this, shape, ordering, references, spec);
  this.typeName$3 = new $c_s_Some().init___O("nil");
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlNilShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlNilShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlNilShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNilShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.call(this);
  this.node$3 = null;
  this.ordering$3 = null;
  this.references$3 = null;
  this.spec$3 = null;
  this.typeName$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter.prototype.productPrefix__T = (function() {
  return "RamlNodeShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter.prototype.typeName__s_Option = (function() {
  return this.typeName$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter)) {
    var RamlNodeShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter(x$1);
    var x = this.node$3;
    var x$2 = RamlNodeShapeEmitter$1.node$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$3;
      var x$4 = RamlNodeShapeEmitter$1.ordering$3;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$3;
      var x$6 = RamlNodeShapeEmitter$1.references$3;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.node$3;
      break
    }
    case 1: {
      return this.ordering$3;
      break
    }
    case 2: {
      return this.references$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter.prototype.emitters__sc_Seq = (function() {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype.emitters__sc_Seq.call(this)));
  var this$1 = this.node$3;
  var fs = this$1.fields$2;
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MinProperties$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("minProperties", f, $m_s_None$(), this.spec$3)))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MaxProperties$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("maxProperties", f$3, $m_s_None$(), this.spec$3)))
  };
  var this$6 = this.node$3;
  var hasPatternProperties = $as_sc_Seq(this$6.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1)).exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_domain_extensions_PropertyShape(x$1$2);
      var this$7 = $as_Lamf_core_model_StrField(x$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().PatternName$1));
      return $f_Lamf_core_model_StrField__nonEmpty__Z(this$7)
    })
  })(this)));
  var this$8 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1);
  if ((!this$8.isEmpty__Z())) {
    var arg1$2 = this$8.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    var this$9 = this.node$3;
    var this$10 = $as_Lamf_core_model_BoolField(this$9.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1));
    var closed = $f_Lamf_core_model_BoolField__value__Z(this$10);
    if (((!hasPatternProperties) && (closed || f$4.value$1.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_ExplicitField.getClassOf())))) {
      var this$11 = (!closed);
      var jsx$1 = $m_Lorg_yaml_model_YType$().Bool$1;
      var this$13 = $m_Lamf_core_emitter_BaseEmitters_package$();
      var annotations = f$4.value$1.annotations$1;
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("additionalProperties", ("" + this$11), jsx$1, this$13.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())))
    }
  };
  var this$14 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().AdditionalPropertiesSchema$1);
  if ((!this$14.isEmpty__Z())) {
    var arg1$3 = this$14.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    var shape = $as_Lamf_core_model_domain_Shape(f$5.value$1.value$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeEntryEmitter().init___T__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(new $c_Lamf_core_utils_package$AmfStrings().init___T("additionalProperties").asRamlAnnotation__T(), shape, this.ordering$3, this.references$3, this.spec$3)))
  };
  var this$16 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Discriminator$1);
  if ((!this$16.isEmpty__Z())) {
    var arg1$4 = this$16.get__O();
    var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("discriminator", f$6, $m_s_None$(), this.spec$3)))
  };
  var this$18 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().DiscriminatorValue$1);
  if ((!this$18.isEmpty__Z())) {
    var arg1$5 = this$18.get__O();
    var f$7 = $as_Lamf_core_parser_FieldEntry(arg1$5);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("discriminatorValue", f$7, $m_s_None$(), this.spec$3)))
  };
  var this$20 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1);
  if ((!this$20.isEmpty__Z())) {
    var arg1$6 = this$20.get__O();
    var f$8 = $as_Lamf_core_parser_FieldEntry(arg1$6);
    this.typeEmitted$1 = true;
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlPropertiesShapeEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(f$8, this.ordering$3, this.references$3, this.spec$3)))
  };
  var jsx$4 = $m_sci_ListMap$();
  var this$21 = this.node$3;
  var jsx$3 = $as_sc_Seq(this$21.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1));
  var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$9$1) {
    return (function(p$2) {
      var p = $as_Lamf_core_model_domain_extensions_PropertyShape(p$2);
      var self = p.id$1;
      return new $c_T2().init___O__O(self, p)
    })
  })(this));
  var this$24 = $m_sc_Seq$();
  var propertiesMap = $as_sci_ListMap(jsx$4.apply__sc_Seq__sc_GenMap($as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$24.ReusableCBFInstance$2))));
  var this$25 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Dependencies$1);
  if ((!this$25.isEmpty__Z())) {
    var arg1$7 = this$25.get__O();
    var f$9 = $as_Lamf_core_parser_FieldEntry(arg1$7);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeDependenciesEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sci_ListMap__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(f$9, this.ordering$3, propertiesMap, this.spec$3)))
  };
  if ((!this.typeEmitted$1)) {
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", "object", $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()))
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_NodeShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(node, ordering, references, spec) {
  this.node$3 = node;
  this.ordering$3 = ordering;
  this.references$3 = references;
  this.spec$3 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this, node, ordering, references, spec);
  var this$1 = node.annotations$2.find__jl_Class__s_Option($d_Lamf_core_annotations_ExplicitField.getClassOf());
  if (this$1.isEmpty__Z()) {
    var jsx$1 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    $as_Lamf_core_annotations_ExplicitField(arg1);
    var jsx$1 = new $c_s_Some().init___O("object")
  };
  this.typeName$3 = jsx$1;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlNodeShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlNodeShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlNodeShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNodeShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.call(this);
  this.tuple$3 = null;
  this.ordering$3 = null;
  this.references$3 = null;
  this.spec$3 = null;
  this.typeName$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter.prototype.productPrefix__T = (function() {
  return "RamlTupleShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter.prototype.typeName__s_Option = (function() {
  return this.typeName$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter)) {
    var RamlTupleShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter(x$1);
    var x = this.tuple$3;
    var x$2 = RamlTupleShapeEmitter$1.tuple$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$3;
      var x$4 = RamlTupleShapeEmitter$1.ordering$3;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$3;
      var x$6 = RamlTupleShapeEmitter$1.references$3;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.tuple$3;
      break
    }
    case 1: {
      return this.ordering$3;
      break
    }
    case 2: {
      return this.references$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_TupleShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(tuple, ordering, references, spec) {
  this.tuple$3 = tuple;
  this.ordering$3 = ordering;
  this.references$3 = references;
  this.spec$3 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this, tuple, ordering, references, spec);
  var this$1 = tuple.annotations$2.find__jl_Class__s_Option($d_Lamf_core_annotations_ExplicitField.getClassOf());
  if (this$1.isEmpty__Z()) {
    var jsx$1 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    $as_Lamf_core_annotations_ExplicitField(arg1);
    var jsx$1 = new $c_s_Some().init___O("array")
  };
  this.typeName$3 = jsx$1;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter.prototype.emitters__sc_Seq = (function() {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype.emitters__sc_Seq.call(this)));
  var this$1 = this.tuple$3;
  var fs = this$1.fields$2;
  result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleItemsShapeEmitter().init___Lamf_plugins_domain_shapes_models_TupleShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(this.tuple$3, this.ordering$3, this.references$3, this.spec$3));
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MaxItems$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("maxItems", f, $m_s_None$(), this.spec$3)))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MinItems$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("minItems", f$3, $m_s_None$(), this.spec$3)))
  };
  var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().UniqueItems$1);
  if ((!this$6.isEmpty__Z())) {
    var arg1$2 = this$6.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("uniqueItems", f$4, $m_s_None$(), this.spec$3)))
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlTupleShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlTupleShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlTupleShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTupleShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.call(this);
  this.shape$3 = null;
  this.ordering$3 = null;
  this.references$3 = null;
  this.spec$3 = null;
  this.typeName$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter.prototype.productPrefix__T = (function() {
  return "RamlUnionShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter.prototype.typeName__s_Option = (function() {
  return this.typeName$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter)) {
    var RamlUnionShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter(x$1);
    var x = this.shape$3;
    var x$2 = RamlUnionShapeEmitter$1.shape$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$3;
      var x$4 = RamlUnionShapeEmitter$1.ordering$3;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$3;
      var x$6 = RamlUnionShapeEmitter$1.references$3;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$3;
      break
    }
    case 1: {
      return this.ordering$3;
      break
    }
    case 2: {
      return this.references$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter.prototype.emitters__sc_Seq = (function() {
  var this$1 = this.shape$3;
  if ($as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1)).isEmpty__Z()) {
    var this$2 = this.shape$3;
    var jsx$1 = $as_sc_Seq(this$2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).nonEmpty__Z()
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var unionEmitters = $m_sci_Nil$()
  } else {
    var jsx$2 = $m_sc_Seq$();
    var array = [new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyOfShapeEmitter().init___Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(this.shape$3, this.ordering$3, this.references$3, this.spec$3)];
    var unionEmitters = $as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
  };
  var jsx$3 = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype.emitters__sc_Seq.call(this);
  var this$5 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(unionEmitters, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_UnionShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(shape, ordering, references, spec) {
  this.shape$3 = shape;
  this.ordering$3 = ordering;
  this.references$3 = references;
  this.spec$3 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this, shape, ordering, references, spec);
  this.typeName$3 = new $c_s_Some().init___O("union");
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlUnionShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlUnionShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlUnionShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlUnionShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasRecursiveShapeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter.call(this);
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasRecursiveShapeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasRecursiveShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasRecursiveShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasRecursiveShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasRecursiveShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasRecursiveShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasRecursiveShapeEmitter.prototype.init___Lamf_core_model_domain_RecursiveShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(recursive, ordering, schemaPath, spec) {
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter.prototype.init___Lamf_core_model_domain_RecursiveShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.call(this, recursive, ordering, schemaPath, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasRecursiveShapeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.recursive$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_RecursiveShapeModel$().FixPoint$1)).option$1;
  if (this$2.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var fixpoint = $as_T(arg1);
    var this$3 = this.spec$2.definitionsQueue$3;
    var this$4 = this$3.queuedIdsWithLabel$1.get__O__s_Option(fixpoint)
  };
  if (this$4.isEmpty__Z()) {
    var this$5 = this.recursive$1;
    var this$6 = this$5.internalFixpointTarget$2;
    if (this$6.isEmpty__Z()) {
      var label = $m_s_None$()
    } else {
      var arg1$1 = this$6.get__O();
      var shape = $as_Lamf_core_model_domain_Shape(arg1$1);
      var label = new $c_s_Some().init___O(this.spec$2.definitionsQueue$3.enqueue__Lamf_core_model_domain_Shape__T(shape))
    }
  } else {
    var label = this$4
  };
  if ((label instanceof $c_s_Some)) {
    var x2 = $as_s_Some(label);
    var name = $as_T(x2.value$2);
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("$ref");
    $m_Lorg_yaml_model_YNode$();
    var str = (("#" + this.spec$2.schemasDeclarationsPath__T()) + name);
    var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
    b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value)
  } else {
    var x = $m_s_None$();
    if ((x === label)) {
      $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V.call(this, b)
    } else {
      throw new $c_s_MatchError().init___O(label)
    }
  }
});
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasRecursiveShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasRecursiveShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.schema.json.CompactOasRecursiveShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasRecursiveShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasRecursiveShapeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasRecursiveShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_schema_json_CompactOasRecursiveShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter.call(this);
  this.key$2 = null;
  this.examples$2 = null;
  this.ordering$2 = null;
  this.references$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter.prototype.productPrefix__T = (function() {
  return "ExampleArrayEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$2 = this.examples$2;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$17$2) {
      var x$17 = $as_Lamf_plugins_domain_shapes_models_Example(x$17$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleValuesEmitter().init___Lamf_plugins_domain_shapes_models_Example__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x$17, $this.ordering$2, $this.spec$2)
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var emitters = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  var jsx$4 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V(this.ordering$2.sorted__sc_Seq__sc_Seq(emitters), b$1);
  var jsx$3 = $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YSequence$();
  var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName);
  var parts = b$1.builder$1;
  var node = jsx$3.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
  jsx$4.$$plus$eq__O__scm_ArrayBuffer(node)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter)) {
    var ExampleArrayEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter(x$1);
    if ((this.key$2 === ExampleArrayEmitter$1.key$2)) {
      var x = this.examples$2;
      var x$2 = ExampleArrayEmitter$1.examples$2;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$3 = this.ordering$2;
      var x$4 = ExampleArrayEmitter$1.ordering$2;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$2;
      var x$6 = ExampleArrayEmitter$1.references$2;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$2;
      break
    }
    case 1: {
      return this.examples$2;
      break
    }
    case 2: {
      return this.ordering$2;
      break
    }
    case 3: {
      return this.references$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter.prototype.init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, examples, ordering, references, spec) {
  this.key$2 = key;
  this.examples$2 = examples;
  this.ordering$2 = ordering;
  this.references$2 = references;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter.prototype.init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, key, examples, ordering, references, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.ExampleArrayEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.ExampleArrayEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.ExampleArrayEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_ExampleArrayEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter.call(this);
  this.key$2 = null;
  this.examples$2 = null;
  this.ordering$2 = null;
  this.references$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter.prototype.productPrefix__T = (function() {
  return "NamedMultipleExampleEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$2 = this.examples$2;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$14$2) {
      var x$14 = $as_Lamf_plugins_domain_shapes_models_Example(x$14$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_NamedExampleEmitter().init___Lamf_plugins_domain_shapes_models_Example__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x$14, $this.ordering$2, $this.spec$2)
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var emitters = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  var jsx$3 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$2.sorted__sc_Seq__sc_Seq(emitters), b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter)) {
    var NamedMultipleExampleEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter(x$1);
    if ((this.key$2 === NamedMultipleExampleEmitter$1.key$2)) {
      var x = this.examples$2;
      var x$2 = NamedMultipleExampleEmitter$1.examples$2;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$3 = this.ordering$2;
      var x$4 = NamedMultipleExampleEmitter$1.ordering$2;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$2;
      var x$6 = NamedMultipleExampleEmitter$1.references$2;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$2;
      break
    }
    case 1: {
      return this.examples$2;
      break
    }
    case 2: {
      return this.ordering$2;
      break
    }
    case 3: {
      return this.references$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter.prototype.init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, examples, ordering, references, spec) {
  this.key$2 = key;
  this.examples$2 = examples;
  this.ordering$2 = ordering;
  this.references$2 = references;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter.prototype.init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, key, examples, ordering, references, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.NamedMultipleExampleEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.NamedMultipleExampleEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.NamedMultipleExampleEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_NamedMultipleExampleEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser.call(this);
  this.entry$3 = null;
  this.producer$3 = null;
  this.collector$3 = null;
  this.ctx$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser.prototype.productPrefix__T = (function() {
  return "Oas20EndpointParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function() {
  return this.ctx$3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function() {
  return this.ctx$3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser)) {
    var Oas20EndpointParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser(x$1);
    var x = this.entry$3;
    var x$2 = Oas20EndpointParser$1.entry$3;
    if ((x === x$2)) {
      var x$3 = this.producer$3;
      var x$4 = Oas20EndpointParser$1.producer$3;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.collector$3;
      var x$6 = Oas20EndpointParser$1.collector$3;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__sci_List__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(entry, producer, collector, ctx) {
  this.entry$3 = entry;
  this.producer$3 = producer;
  this.collector$3 = collector;
  this.ctx$3 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__sci_List__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.call(this, entry, producer, collector, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$3;
      break
    }
    case 1: {
      return this.producer$3;
      break
    }
    case 2: {
      return this.collector$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser.prototype.parseEndpointMap__Lamf_plugins_domain_webapi_models_EndPoint__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_EndPoint = (function(endpoint, map) {
  return $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser.prototype.parseEndpointMap__Lamf_plugins_domain_webapi_models_EndPoint__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_EndPoint.call(this, endpoint, map)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Oas20EndpointParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Oas20EndpointParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Oas20EndpointParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas20EndpointParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasOperationParser.call(this);
  this.entry$3 = null;
  this.producer$3 = null;
  this.ctx$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_OasOperationParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser.prototype.productPrefix__T = (function() {
  return "Oas20OperationParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function() {
  return this.ctx$3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function() {
  return this.ctx$3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser)) {
    var Oas20OperationParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser(x$1);
    var x = this.entry$3;
    var x$2 = Oas20OperationParser$1.entry$3;
    if ((x === x$2)) {
      var x$3 = this.producer$3;
      var x$4 = Oas20OperationParser$1.producer$3;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$3;
      break
    }
    case 1: {
      return this.producer$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(entry, producer, ctx) {
  this.entry$3 = entry;
  this.producer$3 = producer;
  this.ctx$3 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasOperationParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext.call(this, entry, producer, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser.prototype.parse__Lamf_plugins_domain_webapi_models_Operation = (function() {
  var operation = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasOperationParser.prototype.parse__Lamf_plugins_domain_webapi_models_Operation.call(this);
  var this$1 = this.entry$3.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$3;
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var this$2 = new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20RequestParser().init___Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(map, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, operation$1) {
    return (function(r$2) {
      var r = $as_Lamf_plugins_domain_webapi_models_Request(r$2);
      var parent = operation$1.id$1;
      $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(r, parent)
    })
  })(this, operation)), this.ctx$3).parse__s_Option();
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var r$3 = $as_Lamf_plugins_domain_webapi_models_Request(arg1);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Request$1;
    var jsx$1 = $m_sc_Seq$();
    var array = [r$3];
    var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))), new $c_Lamf_core_parser_Annotations().init___());
    var annotations = ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SynthesizedField().init___());
    new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(operation, field, value, annotations)))
  };
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Schemes$1;
  var iv$1 = this.ctx$3;
  jsx$2.key__T__F1__V("schemes", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(operation));
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Accepts$1;
  var iv$2 = this.ctx$3;
  jsx$3.key__T__F1__V("consumes", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(operation));
  var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().ContentType$1;
  var iv$3 = this.ctx$3;
  jsx$4.key__T__F1__V("produces", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$3, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(operation));
  return operation
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Oas20OperationParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Oas20OperationParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Oas20OperationParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasOperationParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas20OperationParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser.call(this);
  this.entry$3 = null;
  this.producer$3 = null;
  this.collector$3 = null;
  this.ctx$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser.prototype.stripPathParams$1__p3__T__T = (function(s) {
  if ($m_sjsr_RuntimeString$().endsWith__T__T__Z(s, "/")) {
    var this$2 = new $c_sci_StringOps().init___T(s);
    var trimmed = $as_T($f_sc_IndexedSeqOptimized__init__O(this$2))
  } else {
    var trimmed = s
  };
  return $m_sjsr_RuntimeString$().replaceAll__T__T__T__T(trimmed, "\\{.*?\\}", "")
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser.prototype.productPrefix__T = (function() {
  return "Oas30EndpointParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function() {
  return this.ctx$3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function() {
  return this.ctx$3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser)) {
    var Oas30EndpointParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser(x$1);
    var x = this.entry$3;
    var x$2 = Oas30EndpointParser$1.entry$3;
    if ((x === x$2)) {
      var x$3 = this.producer$3;
      var x$4 = Oas30EndpointParser$1.producer$3;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.collector$3;
      var x$6 = Oas30EndpointParser$1.collector$3;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__sci_List__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(entry, producer, collector, ctx) {
  this.entry$3 = entry;
  this.producer$3 = producer;
  this.collector$3 = collector;
  this.ctx$3 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__sci_List__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.call(this, entry, producer, collector, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$3;
      break
    }
    case 1: {
      return this.producer$3;
      break
    }
    case 2: {
      return this.collector$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser.prototype.identicalPaths__T__T__Z = (function(first, second) {
  return (this.stripPathParams$1__p3__T__T(first) === this.stripPathParams$1__p3__T__T(second))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser.prototype.parseEndpointMap__Lamf_plugins_domain_webapi_models_EndPoint__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_EndPoint = (function(endpoint, map) {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser.prototype.parseEndpointMap__Lamf_plugins_domain_webapi_models_EndPoint__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_EndPoint.call(this, endpoint, map);
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Summary$1;
  var iv = this.ctx$3;
  jsx$1.key__T__F1__V("summary", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(endpoint));
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Description$1;
  var iv$1 = this.ctx$3;
  jsx$2.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(endpoint));
  return endpoint
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Oas30EndpointParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Oas30EndpointParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Oas30EndpointParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasEndpointParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasLikeEndpointParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas30EndpointParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasOperationParser.call(this);
  this.entry$3 = null;
  this.producer$3 = null;
  this.ctx$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_OasOperationParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser.prototype.productPrefix__T = (function() {
  return "Oas30OperationParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function() {
  return this.ctx$3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function() {
  return this.ctx$3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser)) {
    var Oas30OperationParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser(x$1);
    var x = this.entry$3;
    var x$2 = Oas30OperationParser$1.entry$3;
    if ((x === x$2)) {
      var x$3 = this.producer$3;
      var x$4 = Oas30OperationParser$1.producer$3;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$3;
      break
    }
    case 1: {
      return this.producer$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(entry, producer, ctx) {
  this.entry$3 = entry;
  this.producer$3 = producer;
  this.ctx$3 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_OasOperationParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext.call(this, entry, producer, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser.prototype.parse__Lamf_plugins_domain_webapi_models_Operation = (function() {
  var operation = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasOperationParser.prototype.parse__Lamf_plugins_domain_webapi_models_Operation.call(this);
  var this$1 = this.entry$3.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$3;
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var this$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$4 = this$3.key__T__s_Option("requestBody");
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$5 = entry.value$2;
    var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$1 = this.ctx$3;
    operation.withRequest__Lamf_plugins_domain_webapi_models_Request__Lamf_plugins_domain_webapi_models_Operation(new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser().init___Lorg_yaml_model_YMap__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion$1, iv$1)), operation.id$1, entry, this.ctx$3).parse__Lamf_plugins_domain_webapi_models_Request())
  };
  var this$6 = $m_s_Option$().apply__O__s_Option(operation.request__Lamf_plugins_domain_webapi_models_Request());
  if (this$6.isEmpty__Z()) {
    var this$7 = $m_s_None$()
  } else {
    var arg1$1 = this$6.get__O();
    var x$2 = $as_Lamf_plugins_domain_webapi_models_Request(arg1$1);
    var this$7 = new $c_s_Some().init___O(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, x$2$1) {
      return (function() {
        return x$2$1
      })
    })(this, x$2)))
  };
  new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ParametersParser().init___Lorg_yaml_model_YMap__F0__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(map, $as_F0((this$7.isEmpty__Z() ? new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this$1, operation$5) {
    return (function() {
      return operation$5.withRequest__Lamf_plugins_domain_webapi_models_Request()
    })
  })(this, operation)) : this$7.get__O())), this.ctx$3).parseParameters__V();
  var this$9 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$10 = this$9.key__T__s_Option("callbacks");
  if ((!this$10.isEmpty__Z())) {
    var arg1$2 = this$10.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var this$11 = entry$3.value$2;
    var conversion$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$2 = this.ctx$3;
    var jsx$2 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$11, conversion$2, iv$2)).entries$3;
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, operation$5$1) {
      return (function(callbackEntry$2) {
        var callbackEntry = $as_Lorg_yaml_model_YMapEntry(callbackEntry$2);
        var this$12 = callbackEntry.key$2;
        var conversion$3 = $m_Lamf_core_parser_package$YScalarYRead$();
        var iv$3 = $this$2.ctx$3;
        var name = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$12, conversion$3, iv$3)).text$3;
        var this$13 = callbackEntry.value$2;
        var conversion$4 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv$4 = $this$2.ctx$3;
        return new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser().init___Lorg_yaml_model_YMap__F1__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$13, conversion$4, iv$4)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, name$1, operation$5$2) {
          return (function(x$3$2) {
            var x$3 = $as_Lamf_plugins_domain_webapi_models_Callback(x$3$2);
            $m_Lamf_core_parser_Annotations$();
            var a = new $c_Lamf_core_parser_Annotations().init___();
            var qual$1 = $as_Lamf_plugins_domain_webapi_models_Callback($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(x$3, name$1, a));
            var x$1 = operation$5$2.id$1;
            $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
            $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1)
          })
        })($this$2, name, operation$5$1)), name, callbackEntry, $this$2.ctx$3).parse__sci_List()
      })
    })(this, operation));
    var this$15 = $m_sc_IndexedSeq$();
    var callbacks = $as_sc_IndexedSeq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$15.ReusableCBF$6));
    var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Callbacks$1;
    $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(operation, field, callbacks))
  };
  var this$16 = operation.fields$1;
  var f = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Request$1;
  if (this$16.fs$1.contains__O__Z(f)) {
    operation.request__Lamf_plugins_domain_webapi_models_Request().annotations$2.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_VirtualObject().init___())
  };
  this.ctx$3.factory__Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory().serversParser__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Operation__Lamf_plugins_document_webapi_parser_spec_domain_OasServersParser(map, operation).parse__V();
  return operation
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Oas30OperationParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Oas30OperationParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Oas30OperationParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasOperationParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasLikeOperationParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas30OperationParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.call(this);
  this.ctx$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser.prototype.buildParameter__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter = (function() {
  var result = this.parseFixedFields__Lamf_plugins_domain_webapi_models_Parameter();
  this.parseSchema__p2__Lamf_plugins_domain_webapi_models_Parameter__V(result);
  this.parseExamples__p2__Lamf_plugins_domain_webapi_models_Parameter__V(result);
  this.parseContent__p2__Lamf_plugins_domain_webapi_models_Parameter__V(result);
  this.parseQueryFields__p2__Lamf_plugins_domain_webapi_models_Parameter__V(result);
  $m_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$().parseStyleField__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Parameter__Lamf_plugins_document_webapi_contexts_WebApiContext__V(this.map$1, result, this.ctx$2);
  $m_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$().parseExplodeField__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Parameter__V(this.map$1, result);
  var map = this.map$1;
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Deprecated$1;
  var iv = this.ctx$2;
  jsx$1.key__T__F1__V("deprecated", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(result));
  $m_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser$().validateSchemaOrContent__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_Parameter__Lamf_plugins_document_webapi_contexts_WebApiContext__V(this.map$1, result, this.ctx$2);
  return $m_Lamf_plugins_document_webapi_parser_spec_domain_OasParameter$().apply__Lamf_plugins_domain_webapi_models_Parameter__s_Option__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(result, $m_s_None$())
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser.prototype.parseQueryFields__p2__Lamf_plugins_domain_webapi_models_Parameter__V = (function(result) {
  var this$1 = $as_Lamf_core_model_StrField(result.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1)).option$1;
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var b = $as_T(arg1);
    if ((b === "query")) {
      var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().AllowReserved$1;
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(result, field, false);
      var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().AllowEmptyValue$1;
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(result, field$1, false);
      var map = this.map$1;
      var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
      var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().AllowReserved$1;
      var iv = this.ctx$2;
      var this$3 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(result);
      jsx$1.key__T__F1__V("allowReserved", this$3.withAnnotation__Lamf_core_model_domain_Annotation__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_Lamf_core_annotations_ExplicitField().init___()));
      var map$1 = this.map$1;
      var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
      var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().AllowEmptyValue$1;
      var iv$1 = this.ctx$2;
      var this$5 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$3, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(result);
      jsx$2.key__T__F1__V("allowEmptyValue", this$5.withAnnotation__Lamf_core_model_domain_Annotation__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_Lamf_core_annotations_ExplicitField().init___()))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser.prototype.parseContent__p2__Lamf_plugins_domain_webapi_models_Parameter__V = (function(param) {
  var payloadProducer = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, param$1) {
    return (function(mediaType$2) {
      var mediaType = $as_s_Option(mediaType$2);
      $m_Lamf_core_parser_Annotations$();
      var annotations = new $c_Lamf_core_parser_Annotations().init___();
      var res = new $c_Lamf_plugins_domain_webapi_models_Payload().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
      if ((!mediaType.isEmpty__Z())) {
        var arg1 = mediaType.get__O();
        var mediaType$2$1 = $as_T(arg1);
        var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1;
        new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(res, field, mediaType$2$1)))
      };
      var parent = param$1.id$1;
      $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
      return $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(res, parent))
    })
  })(this, param));
  var map = this.map$1;
  var this$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$6 = this$5.key__T__s_Option("content");
  if ((!this$6.isEmpty__Z())) {
    var arg1$1 = this$6.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var payloads = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasContentsParser().init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(entry, payloadProducer, $m_Lamf_plugins_document_webapi_parser_spec_package$().toOas__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.ctx$2)).parse__sci_List();
    if ($f_sc_TraversableOnce__nonEmpty__Z(payloads)) {
      var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Payloads$1;
      var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(payloads, new $c_Lamf_core_parser_Annotations().init___());
      var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(param, field$1, value, annotations$1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser.prototype.parse__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter = (function() {
  var map = this.map$1;
  var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("$ref");
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var ref = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    return this.parseParameterRef__Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter(ref, this.parentId$1)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return this.buildParameter__Lamf_plugins_document_webapi_parser_spec_domain_OasParameter()
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser.prototype.parseExamples__p2__Lamf_plugins_domain_webapi_models_Parameter__V = (function(param) {
  new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasExamplesParser().init___Lorg_yaml_model_YMap__Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement__Lamf_plugins_document_webapi_contexts_WebApiContext(this.map$1, param, this.ctx$2).parse__V()
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser.prototype.parseSchema__p2__Lamf_plugins_domain_webapi_models_Parameter__V = (function(param) {
  var map = this.map$1;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("schema");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var jsx$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$();
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, param$2) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        var qual$1 = $as_Lamf_core_model_domain_Shape($this.setName__Lamf_core_model_domain_NamedDomainElement__Lamf_core_model_domain_DomainElement(shape));
        var x$1 = param$2.id$1;
        var x$2 = qual$1.adopted$default$2__sc_Seq();
        qual$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$1, x$2)
      })
    })(this, param));
    var eh = this.ctx$2.eh$1;
    var this$5 = jsx$2.apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(entry, jsx$1, new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion().init___T__Lamf_core_errorhandling_ErrorHandler("schema", eh), $m_Lamf_plugins_document_webapi_parser_spec_package$().toOas__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.ctx$2)).parse__s_Option();
    if ((!this$5.isEmpty__Z())) {
      var arg1$1 = this$5.get__O();
      var schema = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1$1);
      this.ctx$2.autoGeneratedAnnotation__Lamf_core_model_domain_Shape__V(schema);
      var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1;
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
      new $c_s_Some().init___O($as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(param, field, schema, annotations)))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser.prototype.init___s_util_Either__T__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_WebApiContext = (function(entryOrNode, parentId, nameNode, nameGenerator, ctx) {
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser.prototype.init___s_util_Either__T__s_Option__Lamf_core_utils_package$IdCounter__Lamf_plugins_document_webapi_contexts_WebApiContext.call(this, entryOrNode, parentId, nameNode, nameGenerator, ctx);
  return this
});
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Oas3ParameterParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_Oas2ParameterParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_OasParameterParser: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Oas3ParameterParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser() {
  $c_O.call(this);
  this.entry$1 = null;
  this.api$1 = null;
  this.ctx$1 = null;
  this.SingleTarget$module$1 = null;
  this.EmptyTarget$module$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser.prototype.productPrefix__T = (function() {
  return "OasLikeInformationParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser)) {
    var OasLikeInformationParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser(x$1);
    var x = this.entry$1;
    var x$2 = OasLikeInformationParser$1.entry$1;
    if ((x === x$2)) {
      var x$3 = this.api$1;
      var x$4 = OasLikeInformationParser$1.api$1;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.ctx$1;
      var x$6 = OasLikeInformationParser$1.ctx$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$1;
      break
    }
    case 1: {
      return this.api$1;
      break
    }
    case 2: {
      return this.ctx$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser.prototype.EmptyTarget__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$ = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$lzycompute$1__p1__V()
  };
  return this.EmptyTarget$module$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser.prototype.parse__V = (function() {
  var this$1 = this.entry$1.value$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$1;
  var info = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  this.ctx$1.closedShape__T__Lorg_yaml_model_YMap__T__V(this.api$1.id$1, info, "info");
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(info);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Name$1;
  var iv$1 = this.ctx$1;
  jsx$1.key__T__F1__V("title", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.api$1));
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(info);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Description$1;
  var iv$2 = this.ctx$1;
  jsx$2.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.api$1));
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(info);
  var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().TermsOfService$1;
  var iv$3 = this.ctx$1;
  jsx$3.key__T__F1__V("termsOfService", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.api$1));
  var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(info);
  var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Version$1;
  var iv$4 = this.ctx$1;
  jsx$4.key__T__F1__V("version", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$3, iv$4).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.api$1));
  var jsx$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(info);
  var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Provider$1;
  var iv$5 = this.ctx$1;
  jsx$5.key__T__F1__V("contact", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$4, iv$5).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.api$1).using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(node$2) {
      var node = $as_Lorg_yaml_model_YNode(node$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_domain_OrganizationParser$().parse__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_domain_webapi_models_Organization(node, $this.ctx$1)
    })
  })(this))));
  var jsx$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(info);
  var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().License$1;
  var iv$6 = this.ctx$1;
  jsx$6.key__T__F1__V("license", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$5, iv$6).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.api$1).using__F1__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(node$3$2) {
      var node$3 = $as_Lorg_yaml_model_YNode(node$3$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_domain_LicenseParser$().parse__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_domain_webapi_models_License(node$3, this$2$1.ctx$1)
    })
  })(this))))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser.prototype.init___Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_webapi_models_WebApi__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function(entry, api, ctx) {
  this.entry$1 = entry;
  this.api$1 = api;
  this.ctx$1 = ctx;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser.prototype.EmptyTarget$lzycompute$1__p1__V = (function() {
  if ((this.EmptyTarget$module$1 === null)) {
    this.EmptyTarget$module$1 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$EmptyTarget$().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.OasLikeInformationParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.OasLikeInformationParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.OasLikeInformationParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_WebApiBaseSpecParser: 1,
  Lamf_core_parser_BaseSpecParser: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_OasLikeInformationParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter.call(this);
  this.endpoint$2 = null;
  this.ordering$2 = null;
  this.children$2 = null;
  this.references$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter.prototype.productPrefix__T = (function() {
  return "Raml08EndPointEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter)) {
    var Raml08EndPointEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter(x$1);
    var x = this.endpoint$2;
    var x$2 = Raml08EndPointEmitter$1.endpoint$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = Raml08EndPointEmitter$1.ordering$2;
      var jsx$2 = (x$3 === x$4)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.children$2;
      var x$6 = Raml08EndPointEmitter$1.children$2;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.references$2;
      var x$8 = Raml08EndPointEmitter$1.references$2;
      return ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter.prototype.init___Lamf_plugins_domain_webapi_models_EndPoint__Lamf_core_emitter_SpecOrdering__scm_ListBuffer__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(endpoint, ordering, children, references, ctx) {
  this.endpoint$2 = endpoint;
  this.ordering$2 = ordering;
  this.children$2 = children;
  this.references$2 = references;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter.prototype.init___Lamf_core_emitter_SpecOrdering__scm_ListBuffer__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this, ordering, children, references, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.endpoint$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    case 2: {
      return this.children$2;
      break
    }
    case 3: {
      return this.references$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter.prototype.emitters__Lamf_core_parser_Fields__scm_ListBuffer = (function(fs) {
  var result = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter.prototype.emitters__Lamf_core_parser_Fields__scm_ListBuffer.call(this, fs);
  var jsx$1 = $m_Lamf_core_utils_package$TemplateUri$();
  var this$1 = this.endpoint$2;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1));
  var this$3 = this$2.option$1;
  var variables = jsx$1.variables__T__sc_Seq($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())));
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1 = this$4.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    if ($as_Lamf_core_model_domain_AmfArray(f.value$1.value$1).values$1.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(f$2$2) {
        var f$2 = $as_Lamf_core_model_domain_AmfElement(f$2$2);
        return (!f$2.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_SynthesizedField.getClassOf()))
      })
    })(this)))) {
      var elem = $m_sci_Nil$();
      var uriParameters = new $c_sr_ObjectRef().init___O(elem);
      var elem$1 = $m_sci_Nil$();
      var pathParameters = new $c_sr_ObjectRef().init___O(elem$1);
      $as_Lamf_core_model_domain_AmfArray(f.value$1.value$1).values$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, variables$1, pathParameters$1, uriParameters$1) {
        return (function(x0$1$2) {
          var x0$1 = $as_Lamf_core_model_domain_AmfElement(x0$1$2);
          if ((x0$1 instanceof $c_Lamf_plugins_domain_webapi_models_Parameter)) {
            var x2 = $as_Lamf_plugins_domain_webapi_models_Parameter(x0$1);
            var this$7 = $as_Lamf_core_model_StrField(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
            var this$8 = this$7.option$1;
            if (variables$1.contains__O__Z($as_T((this$8.isEmpty__Z() ? null : this$8.get__O())))) {
              var jsx$3 = true
            } else {
              var this$9 = $as_Lamf_core_model_StrField(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().ParameterName$1));
              var this$10 = this$9.option$1;
              var jsx$3 = variables$1.contains__O__Z($as_T((this$10.isEmpty__Z() ? null : this$10.get__O())))
            };
            if (jsx$3) {
              var jsx$6 = $as_sc_Seq(pathParameters$1.elem$1);
              var jsx$5 = $m_sc_Seq$();
              var array = [x2];
              var jsx$4 = jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
              var this$13 = $m_sc_Seq$();
              pathParameters$1.elem$1 = $as_sc_Seq(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$13.ReusableCBFInstance$2))
            } else {
              var jsx$9 = $as_sc_Seq(uriParameters$1.elem$1);
              var jsx$8 = $m_sc_Seq$();
              var array$1 = [x2];
              var jsx$7 = jsx$8.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
              var this$16 = $m_sc_Seq$();
              uriParameters$1.elem$1 = $as_sc_Seq(jsx$9.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$7, this$16.ReusableCBFInstance$2))
            }
          } else {
            throw new $c_s_MatchError().init___O(x0$1)
          }
        })
      })(this, variables, pathParameters, uriParameters)));
      var jsx$10 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1;
      var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(pathParameters.elem$1), new $c_Lamf_core_parser_Annotations().init___());
      var annotations = f.value$1.annotations$1;
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("uriParameters", new $c_Lamf_core_parser_FieldEntry().init___Lamf_core_metamodel_Field__Lamf_core_parser_Value(jsx$10, new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value, annotations)), this.ordering$2, this.references$2, this.spec$1));
      var jsx$11 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1;
      var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(uriParameters.elem$1), new $c_Lamf_core_parser_Annotations().init___());
      var annotations$1 = f.value$1.annotations$1;
      var jsx$2 = result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("baseUriParameters", new $c_Lamf_core_parser_FieldEntry().init___Lamf_core_metamodel_Field__Lamf_core_parser_Value(jsx$11, new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value$1, annotations$1)), this.ordering$2, this.references$2, this.spec$1))
    } else {
      var jsx$2 = (void 0)
    };
    new $c_s_Some().init___O(jsx$2)
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter.prototype.endpoint__Lamf_plugins_domain_webapi_models_EndPoint = (function() {
  return this.endpoint$2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml08EndPointEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml08EndPointEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml08EndPointEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08EndPointEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter.call(this);
  this.operation$2 = null;
  this.ordering$2 = null;
  this.references$2 = null;
  this.baseUriParameterKey$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter.prototype.productPrefix__T = (function() {
  return "Raml08OperationEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter)) {
    var Raml08OperationEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter(x$1);
    var x = this.operation$2;
    var x$2 = Raml08OperationEmitter$1.operation$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = Raml08OperationEmitter$1.ordering$2;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$2;
      var x$6 = Raml08OperationEmitter$1.references$2;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.operation$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    case 2: {
      return this.references$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(operation, ordering, references, spec) {
  this.operation$2 = operation;
  this.ordering$2 = ordering;
  this.references$2 = references;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this, operation, ordering, references, spec);
  this.baseUriParameterKey$2 = "baseUriParameters";
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter.prototype.baseUriParameterKey__T = (function() {
  return this.baseUriParameterKey$2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml08OperationEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml08OperationEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml08OperationEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08OperationEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterEmitter.call(this);
  this.parameter$2 = null;
  this.ordering$2 = null;
  this.references$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter.prototype.productPrefix__T = (function() {
  return "Raml08ParameterEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter)) {
    var Raml08ParameterEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter(x$1);
    var x = this.parameter$2;
    var x$2 = Raml08ParameterEmitter$1.parameter$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = Raml08ParameterEmitter$1.ordering$2;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$2;
      var x$6 = Raml08ParameterEmitter$1.references$2;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.parameter$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    case 2: {
      return this.references$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter.prototype.emitParameterKey__Lamf_core_parser_Fields__Lorg_yaml_model_YDocument$PartBuilder__V = (function(fields, builder) {
  var this$1 = $as_Lamf_core_parser_FieldEntry(fields.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1).get__O());
  new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType($as_Lamf_core_model_domain_AmfScalar(this$1.value$1.value$1), $m_Lorg_yaml_model_YType$().Str$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(builder)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Parameter__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(parameter, ordering, references, spec) {
  this.parameter$2 = parameter;
  this.ordering$2 = ordering;
  this.references$2 = references;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Parameter__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, parameter, ordering, references, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter.prototype.emitParameter__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(builder) {
  var this$1 = this.parameter$2;
  var x1 = $as_Lamf_core_model_domain_Shape(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1));
  if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
    var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x1);
    var f$1 = (function(this$2, x2$1) {
      return (function(x$11$2) {
        var x$11 = $as_Lorg_yaml_model_YDocument$PartBuilder(x$11$2);
        var jsx$2 = x$11.builder$1;
        var sourceName = x$11.sourceName$2;
        var b = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
        var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        var x1$1 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter$().apply__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext__Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml08TypePartEmitter(x2$1, this$2.ordering$2, this$2.references$2, this$2.spec$2).emitter$1;
        matchEnd7: {
          if ((x1$1 instanceof $c_s_util_Left)) {
            var x2$2 = $as_s_util_Left(x1$1);
            var p = $as_Lamf_core_emitter_PartEmitter(x2$2.value$2);
            if ((p !== null)) {
              result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter$$anon$1().init___Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter__Lamf_core_emitter_PartEmitter(this$2, p));
              break matchEnd7
            }
          };
          if ((x1$1 instanceof $c_s_util_Right)) {
            var x3 = $as_s_util_Right(x1$1);
            var e = $as_sc_Seq(x3.value$2);
            if ((e !== null)) {
              result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(e);
              break matchEnd7
            }
          };
          throw new $c_s_MatchError().init___O(x1$1)
        };
        var this$4 = this$2.parameter$2.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1);
        if (this$4.isEmpty__Z()) {
          var jsx$1 = true
        } else {
          var arg1 = this$4.get__O();
          var x$12 = $as_Lamf_core_parser_FieldEntry(arg1);
          var jsx$1 = x$12.value$1.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_ExplicitField.getClassOf())
        };
        if (jsx$1) {
          var this$5 = this$4
        } else {
          var this$5 = $m_s_None$()
        };
        if ((!this$5.isEmpty__Z())) {
          var arg1$1 = this$5.get__O();
          var f = $as_Lamf_core_parser_FieldEntry(arg1$1);
          new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("required", f, $m_s_None$(), this$2.spec$2)))
        };
        $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this$2.ordering$2.sorted__sc_Seq__sc_Seq(result), b);
        jsx$2.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
      })
    })(this, x2);
    var vf_$_f$2 = f$1
  } else {
    var eta$0$1 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_CommentEmitter().init___Lamf_core_model_domain_AmfElement__T(x1, (("Cannot emit " + $objectGetClass(x1).toString__T()) + " type of shape in raml 08"));
    var f$2 = (function(this$3$1, eta$0$1$1) {
      return (function(b$2) {
        var b$1 = $as_Lorg_yaml_model_YDocument$PartBuilder(b$2);
        eta$0$1$1.emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$1)
      })
    })(this, eta$0$1);
    var vf_$_f$2 = f$2
  };
  var k = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(builder.sourceName$2);
  this.emitParameterKey__Lamf_core_parser_Fields__Lorg_yaml_model_YDocument$PartBuilder__V(this.parameter$2.fields$1, k);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(builder.sourceName$2);
  vf_$_f$2(v);
  var this$7 = k.builder$1;
  var jsx$3 = $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$7, 0));
  var this$8 = v.builder$1;
  builder.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(jsx$3, $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$8, 0)))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml08ParameterEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml08ParameterEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml08ParameterEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser.call(this);
  this.entry$2 = null;
  this.adopted$2 = null;
  this.parseOptional$2 = false
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(entry, adopted, parseOptional, ctx) {
  this.entry$2 = entry;
  this.adopted$2 = adopted;
  this.parseOptional$2 = parseOptional;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, entry, adopted, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser.prototype.parse__Lamf_plugins_domain_webapi_models_Parameter = (function() {
  var node = this.entry$2.key$2;
  var iv = this.ctx$1;
  var name = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
  var this$2 = $m_Lamf_plugins_domain_webapi_models_Parameter$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_Parameter(this.entry$2);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1;
  var value = name.text__Lamf_core_model_domain_AmfScalar();
  var this$3 = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, value));
  var name$1 = name.text__Lamf_core_model_domain_AmfScalar().toString__T();
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().ParameterName$1;
  var parameter = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$3, field$1, name$1));
  this.adopted$2.apply__O__O(parameter);
  var this$4 = this.entry$2.value$2;
  var x1 = this$4.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Null$1;
  if ((x === x1)) {
    var this$8 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(this.entry$2, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parameter$1) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        $m_Lamf_core_parser_Annotations$();
        var a = new $c_Lamf_core_parser_Annotations().init___();
        var qual$1 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, "schema", a));
        var x$1 = parameter$1.id$1;
        var x$2 = qual$1.adopted$default$2__sc_Seq();
        qual$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$1, x$2)
      })
    })(this, parameter)), new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo().init___Z__Z(false, false), $m_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$(), this.ctx$1).parse__s_Option();
    if ((!this$8.isEmpty__Z())) {
      var arg1 = this$8.get__O();
      var schema = $as_Lamf_core_model_domain_Shape(arg1);
      $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(schema, parameter.id$1, $m_s_None$()).annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SynthesizedField().init___());
      var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1;
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$2);
      $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(parameter, field$2, schema, annotations))
    }
  } else {
    var this$11 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser(this.entry$2, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, name$2, parameter$2) {
      return (function(s$2) {
        var s = $as_Lamf_core_model_domain_Shape(s$2);
        var name$3 = name$2.text__Lamf_core_model_domain_AmfScalar().toString__T();
        $m_Lamf_core_parser_Annotations$();
        var a$1 = new $c_Lamf_core_parser_Annotations().init___();
        var qual$2 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(s, name$3, a$1));
        var x$3 = parameter$2.id$1;
        var x$4 = qual$2.adopted$default$2__sc_Seq();
        qual$2.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$3, x$4)
      })
    })(this, name, parameter)), false, $m_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$(), this.ctx$1).parse__s_Option();
    if ((!this$11.isEmpty__Z())) {
      var arg1$1 = this$11.get__O();
      var s$3 = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1$1);
      var schema$1 = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(s$3, parameter.id$1, $m_s_None$());
      var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1;
      $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(parameter, field$3, schema$1))
    }
  };
  var node$1 = this.entry$2.value$2;
  var x1$2 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node$1).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YMapYRead$());
  if ((x1$2 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1$2);
    var map = $as_Lorg_yaml_model_YMap(x2.value$2);
    var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1;
    var iv$1 = this.ctx$1;
    var this$15 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$4, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(parameter);
    jsx$1.key__T__F1__V("required", this$15.withAnnotation__Lamf_core_model_domain_Annotation__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_Lamf_core_annotations_ExplicitField().init___()));
    var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Description$1;
    var iv$2 = this.ctx$1;
    jsx$2.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$5, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(parameter).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField())
  };
  if (parameter.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1).isEmpty__Z()) {
    var field$6 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1;
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(parameter, field$6, false)
  };
  var stringName = name.text__Lamf_core_model_domain_AmfScalar().toString__T();
  if ((this.parseOptional$2 && $m_sjsr_RuntimeString$().endsWith__T__T__Z(stringName, "?"))) {
    var field$7 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Optional$1;
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(parameter, field$7, true);
    var this$18 = new $c_sci_StringOps().init___T(stringName);
    var n = $f_sci_StringLike__stripSuffix__T__T(this$18, "?");
    var field$8 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1;
    var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(n, name.text__Lamf_core_model_domain_AmfScalar().annotations$1);
    var this$19 = $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(parameter, field$8, value$1);
    var field$9 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().ParameterName$1;
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$19, field$9, n)
  };
  return parameter
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser.prototype.productPrefix__T = (function() {
  return "Raml08ParameterParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser)) {
    var Raml08ParameterParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser(x$1);
    var x = this.entry$2;
    var x$2 = Raml08ParameterParser$1.entry$2;
    if ((x === x$2)) {
      var x$3 = this.adopted$2;
      var x$4 = Raml08ParameterParser$1.adopted$2;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.parseOptional$2 === Raml08ParameterParser$1.parseOptional$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$2;
      break
    }
    case 1: {
      return this.adopted$2;
      break
    }
    case 2: {
      return this.parseOptional$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.entry$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.adopted$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.parseOptional$2 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 3)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml08ParameterParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml08ParameterParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml08ParameterParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ParameterParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.f$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter.prototype.productPrefix__T = (function() {
  return "Raml08PayloadsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter)) {
    var Raml08PayloadsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter(x$1);
    if ((this.key$1 === Raml08PayloadsEmitter$1.key$1)) {
      var x = this.f$1;
      var x$2 = Raml08PayloadsEmitter$1.f$1;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$3 = this.ordering$1;
      var x$4 = Raml08PayloadsEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = Raml08PayloadsEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.f$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var k = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  new $c_Lamf_core_emitter_BaseEmitters_package$RawEmitter().init___T__Lorg_yaml_model_YType__Lamf_core_parser_Annotations(this.key$1, $m_Lorg_yaml_model_YType$().Str$1, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___())).emit__Lorg_yaml_model_YDocument$PartBuilder__V(k);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var this$4 = this.f$1;
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(this$4.value$1.value$1).values$1;
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter(this);
  var this$5 = $m_sc_Seq$();
  var payloads = $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2));
  if (payloads.isEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var map = $m_Lorg_yaml_model_YMap$().empty$1;
    $m_Lorg_yaml_model_YNode$();
    var node = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map, $m_Lorg_yaml_model_YType$().Map$1);
    v.builder$1.$$plus$eq__O__scm_ArrayBuffer(node)
  } else {
    var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(p$2) {
        var p = $as_Lamf_plugins_domain_webapi_models_Payload(p$2);
        return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadEmitter().init___Lamf_plugins_domain_webapi_models_Payload__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(p, $this.ordering$1, $this.spec$1).emitters__sc_Seq()
      })
    })(this));
    var this$8 = $m_sc_Seq$();
    var emitters = $as_sc_Seq(payloads.flatMap__F1__scg_CanBuildFrom__O(jsx$3, this$8.ReusableCBFInstance$2));
    matchEnd5: {
      $m_sc_Seq$();
      var o8 = new $c_s_Some().init___O(emitters);
      if (((o8.value$2 !== null) && ($as_sc_SeqLike(o8.value$2).lengthCompare__I__I(1) === 0))) {
        var pe = $as_Lamf_core_emitter_Emitter($as_sc_SeqLike(o8.value$2).apply__I__O(0));
        if ($is_Lamf_core_emitter_PartEmitter(pe)) {
          var x3 = $as_Lamf_core_emitter_PartEmitter(pe);
          x3.emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
          break matchEnd5
        }
      };
      if (emitters.forall__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
        return (function(x$6$2) {
          var x$6 = $as_Lamf_core_emitter_Emitter(x$6$2);
          return $is_Lamf_core_emitter_EntryEmitter(x$6)
        })
      })(this)))) {
        var jsx$7 = v.builder$1;
        var sourceName = v.sourceName$2;
        var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
        var jsx$6 = $m_Lamf_core_emitter_BaseEmitters_package$();
        var jsx$5 = this.ordering$1;
        var jsx$4 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter$$anonfun$$nestedInanonfun$emit$11$1().init___Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter(this);
        var this$11 = $m_sc_Seq$();
        jsx$6.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$5.sorted__sc_Seq__sc_Seq($as_sc_Seq(emitters.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$4, this$11.ReusableCBFInstance$2))), b$1);
        jsx$7.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
        break matchEnd5
      };
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("IllegalTypeDeclarations found: " + emitters)))
    }
  };
  var this$12 = k.builder$1;
  var jsx$8 = $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$12, 0));
  var this$13 = v.builder$1;
  b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(jsx$8, $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$13, 0)))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter.prototype.init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(key, f, ordering, references, spec) {
  this.key$1 = key;
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml08PayloadsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml08PayloadsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml08PayloadsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadsEmitter: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08PayloadsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter.call(this);
  this.response$2 = null;
  this.ordering$2 = null;
  this.references$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter.prototype.productPrefix__T = (function() {
  return "Raml08ResponseEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter)) {
    var Raml08ResponseEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter(x$1);
    var x = this.response$2;
    var x$2 = Raml08ResponseEmitter$1.response$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = Raml08ResponseEmitter$1.ordering$2;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$2;
      var x$6 = Raml08ResponseEmitter$1.references$2;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.response$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    case 2: {
      return this.references$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Response__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(response, ordering, references, spec) {
  this.response$2 = response;
  this.ordering$2 = ordering;
  this.references$2 = references;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Response__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this, response, ordering, references, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml08ResponseEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml08ResponseEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml08ResponseEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml08ResponseEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter.call(this);
  this.endpoint$2 = null;
  this.ordering$2 = null;
  this.children$2 = null;
  this.references$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter.prototype.productPrefix__T = (function() {
  return "Raml10EndPointEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter)) {
    var Raml10EndPointEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter(x$1);
    var x = this.endpoint$2;
    var x$2 = Raml10EndPointEmitter$1.endpoint$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = Raml10EndPointEmitter$1.ordering$2;
      var jsx$2 = (x$3 === x$4)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.children$2;
      var x$6 = Raml10EndPointEmitter$1.children$2;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.references$2;
      var x$8 = Raml10EndPointEmitter$1.references$2;
      return ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter.prototype.init___Lamf_plugins_domain_webapi_models_EndPoint__Lamf_core_emitter_SpecOrdering__scm_ListBuffer__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(endpoint, ordering, children, references, spec) {
  this.endpoint$2 = endpoint;
  this.ordering$2 = ordering;
  this.children$2 = children;
  this.references$2 = references;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter.prototype.init___Lamf_core_emitter_SpecOrdering__scm_ListBuffer__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this, ordering, children, references, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.endpoint$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    case 2: {
      return this.children$2;
      break
    }
    case 3: {
      return this.references$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter.prototype.emitters__Lamf_core_parser_Fields__scm_ListBuffer = (function(fs) {
  var result = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter.prototype.emitters__Lamf_core_parser_Fields__scm_ListBuffer.call(this, fs);
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Payloads$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(new $c_Lamf_core_utils_package$AmfStrings().init___T("payloads").asRamlAnnotation__T(), f, this.ordering$2, this.references$2, this.spec$1)))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    if ($as_Lamf_core_model_domain_AmfArray(f$3.value$1.value$1).values$1.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(f$2$2) {
        var f$2 = $as_Lamf_core_model_domain_AmfElement(f$2$2);
        return (!f$2.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_SynthesizedField.getClassOf()))
      })
    })(this)))) {
      var x1 = $as_Lamf_core_model_domain_AmfArray(f$3.value$1.value$1).values$1.partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
        return (function(p$2) {
          var p = $as_Lamf_plugins_domain_webapi_models_Parameter(p$2);
          var this$4 = $as_Lamf_core_model_StrField(p.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
          return $f_Lamf_core_model_ValueField__is__O__Z(this$4, "path")
        })
      })(this)));
      if ((x1 === null)) {
        throw new $c_s_MatchError().init___O(x1)
      };
      var path = $as_sc_Seq(x1.$$und1__O());
      var other = $as_sc_Seq(x1.$$und2__O());
      var x$1$2 = new $c_Lamf_core_utils_package$AmfStrings().init___T("parameters").asRamlAnnotation__T();
      var x$3 = this.ordering$2;
      var x$4 = this.references$2;
      var x$5 = $m_sci_Nil$();
      var spec = this.spec$1;
      var x$6 = new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(spec.eh$1, spec.refEmitter$1, new $c_Lamf_core_emitter_ShapeRenderOptions().init___());
      result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(x$1$2, other, x$3, x$5, x$4, x$6).ramlEndpointEmitters__sc_Seq());
      if (path.nonEmpty__Z()) {
        var jsx$2 = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1;
        var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(path, f$3.value$1.value$1.annotations__Lamf_core_parser_Annotations());
        var annotations = f$3.value$1.annotations$1;
        var entry = new $c_Lamf_core_parser_FieldEntry().init___Lamf_core_metamodel_Field__Lamf_core_parser_Value(jsx$2, new $c_Lamf_core_parser_Value().init___Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations(value, annotations));
        var jsx$1 = result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametersEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("uriParameters", entry, this.ordering$2, this.references$2, this.spec$1))
      } else {
        var jsx$1 = (void 0)
      }
    } else {
      var jsx$1 = (void 0)
    };
    new $c_s_Some().init___O(jsx$1)
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter.prototype.endpoint__Lamf_plugins_domain_webapi_models_EndPoint = (function() {
  return this.endpoint$2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml10EndPointEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml10EndPointEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml10EndPointEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_RamlEndPointEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10EndPointEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter.call(this);
  this.operation$2 = null;
  this.ordering$2 = null;
  this.references$2 = null;
  this.spec$2 = null;
  this.baseUriParameterKey$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter.prototype.productPrefix__T = (function() {
  return "Raml10OperationEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter)) {
    var Raml10OperationEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter(x$1);
    var x = this.operation$2;
    var x$2 = Raml10OperationEmitter$1.operation$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = Raml10OperationEmitter$1.ordering$2;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$2;
      var x$6 = Raml10OperationEmitter$1.references$2;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.operation$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    case 2: {
      return this.references$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter.prototype.entries__Lamf_core_parser_Fields__sc_Seq = (function(fs) {
  var emitters = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter.prototype.entries__Lamf_core_parser_Fields__sc_Seq.call(this, fs);
  var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = $m_s_Option$().apply__O__s_Option(this.operation$2.request__Lamf_plugins_domain_webapi_models_Request());
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var req = $as_Lamf_plugins_domain_webapi_models_Request(arg1);
    var this$2 = req.fields$2.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryString$1);
    if ((!this$2.isEmpty__Z())) {
      var arg1$1 = this$2.get__O();
      var f = $as_Lamf_core_parser_FieldEntry(arg1$1);
      var rc6 = false;
      var x2 = null;
      var x1 = $m_s_Option$().apply__O__s_Option(f.value$1.value$1);
      matchEnd7: {
        if ((x1 instanceof $c_s_Some)) {
          rc6 = true;
          x2 = $as_s_Some(x1);
          var shape = $as_Lamf_core_model_domain_AmfElement(x2.value$2);
          if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
            var x4 = $as_Lamf_plugins_domain_shapes_models_AnyShape(shape);
            results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter().init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__F5__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x4, this.ordering$2, this.references$2, new $c_sjsr_AnonFunction5().init___sjs_js_Function5((function($this) {
              return (function(shape$2$2, ordering$2, annotations$2, ignored$2, references$2) {
                var shape$2 = $as_Lamf_core_model_domain_Shape(shape$2$2);
                var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
                var annotations = $as_s_Option(annotations$2);
                var ignored = $as_sc_Seq(ignored$2);
                var references = $as_sc_Seq(references$2);
                return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(shape$2, ordering, annotations, ignored, references, $this.spec$2)
              })
            })(this)), this.spec$2));
            break matchEnd7
          }
        };
        if (rc6) {
          var other = $as_Lamf_core_model_domain_AmfElement(x2.value$2);
          var this$3 = this.spec$2;
          var this$4 = this$3.eh$1;
          var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
          var node = req.id$1;
          var property = $m_s_None$();
          var lexical = other.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
          var location = other.location__s_Option();
          this$4.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "Cannot emit non WebApi Shape", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
          break matchEnd7
        }
      }
    }
  };
  var this$5 = new $c_scm_ListBuffer().init___().$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(results);
  var xs = emitters.seq__sc_TraversableOnce();
  var this$6 = this$5.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(xs);
  var xs$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.operation$2, this.ordering$2, this.spec$2).emitters__sc_Seq();
  var this$7 = new $c_scm_ListBuffer().init___().$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(this$6);
  var xs$2 = xs$1.seq__sc_TraversableOnce();
  return this$7.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(xs$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(operation, ordering, references, spec) {
  this.operation$2 = operation;
  this.ordering$2 = ordering;
  this.references$2 = references;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this, operation, ordering, references, spec);
  this.baseUriParameterKey$2 = new $c_Lamf_core_utils_package$AmfStrings().init___T("baseUriParameters").asRamlAnnotation__T();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter.prototype.baseUriParameterKey__T = (function() {
  return this.baseUriParameterKey$2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml10OperationEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml10OperationEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml10OperationEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_RamlOperationEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10OperationEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterEmitter.call(this);
  this.parameter$2 = null;
  this.ordering$2 = null;
  this.references$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter.prototype.productPrefix__T = (function() {
  return "Raml10ParameterEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter)) {
    var Raml10ParameterEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter(x$1);
    var x = this.parameter$2;
    var x$2 = Raml10ParameterEmitter$1.parameter$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = Raml10ParameterEmitter$1.ordering$2;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$2;
      var x$6 = Raml10ParameterEmitter$1.references$2;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.parameter$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    case 2: {
      return this.references$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter.prototype.emitParameterKey__Lamf_core_parser_Fields__Lorg_yaml_model_YDocument$PartBuilder__V = (function(fs, b) {
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var x$9 = $as_Lamf_core_parser_FieldEntry(arg1);
    var explicit = x$9.value$1.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_ExplicitField.getClassOf())
  } else {
    var explicit = false
  };
  if ((!explicit)) {
    var this$2 = this.parameter$2;
    var this$3 = $as_Lamf_core_model_BoolField(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1));
    var jsx$1 = (!$f_Lamf_core_model_BoolField__value__Z(this$3))
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var this$4 = this.parameter$2;
    var this$5 = $as_Lamf_core_model_StrField(this$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
    var this$6 = this$5.option$1;
    new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(($as_T((this$6.isEmpty__Z() ? null : this$6.get__O())) + "?"), new $c_Lamf_core_parser_Annotations().init___()), $m_Lorg_yaml_model_YType$().Str$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b)
  } else {
    var this$9 = $as_Lamf_core_parser_FieldEntry(fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1).get__O());
    new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType($as_Lamf_core_model_domain_AmfScalar(this$9.value$1.value$1), $m_Lorg_yaml_model_YType$().Str$1).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Parameter__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(parameter, ordering, references, spec) {
  this.parameter$2 = parameter;
  this.ordering$2 = ordering;
  this.references$2 = references;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Parameter__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, parameter, ordering, references, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter.prototype.emitParameter__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var fs = this.parameter$2.fields$1;
  var jsx$2 = $m_s_Option$();
  var this$1 = this.parameter$2;
  if (jsx$2.apply__O__s_Option($as_Lamf_core_model_domain_Shape(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1))).isDefined__Z()) {
    var this$2 = this.parameter$2;
    var jsx$1 = $as_Lamf_core_model_domain_Shape(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1)).annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_SynthesizedField.getClassOf())
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var k = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    this.emitParameterKey__Lamf_core_parser_Fields__Lorg_yaml_model_YDocument$PartBuilder__V(fs, k);
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    $m_Lamf_core_emitter_BaseEmitters_package$().raw__Lorg_yaml_model_YDocument$PartBuilder__T__Lorg_yaml_model_YType__V(v, "", $m_Lorg_yaml_model_YType$().Null$1);
    var this$3 = k.builder$1;
    var jsx$3 = $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$3, 0));
    var this$4 = v.builder$1;
    b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(jsx$3, $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$4, 0)))
  } else {
    var k$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    this.emitParameterKey__Lamf_core_parser_Fields__Lorg_yaml_model_YDocument$PartBuilder__V(fs, k$1);
    var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$10 = v$1.builder$1;
    var sourceName = v$1.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
    var this$6 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Description$1);
    if ((!this$6.isEmpty__Z())) {
      var arg1 = this$6.get__O();
      var f = $as_Lamf_core_parser_FieldEntry(arg1);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("description", f, $m_s_None$(), this.spec$2)))
    };
    var this$8 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1);
    if (this$8.isEmpty__Z()) {
      var jsx$4 = true
    } else {
      var arg1$1 = this$8.get__O();
      var x$8 = $as_Lamf_core_parser_FieldEntry(arg1$1);
      var jsx$4 = x$8.value$1.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_ExplicitField.getClassOf())
    };
    if (jsx$4) {
      var this$9 = this$8
    } else {
      var this$9 = $m_s_None$()
    };
    if ((!this$9.isEmpty__Z())) {
      var arg1$2 = this$9.get__O();
      var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$2);
      new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("required", f$3, $m_s_None$(), this.spec$2)))
    };
    var rc9 = false;
    var x2 = null;
    var jsx$5 = $m_s_Option$();
    var this$11 = this.parameter$2;
    var x1 = jsx$5.apply__O__s_Option($as_Lamf_core_model_domain_Shape(this$11.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1)));
    matchEnd10: {
      if ((x1 instanceof $c_s_Some)) {
        rc9 = true;
        x2 = $as_s_Some(x1);
        var shape = $as_Lamf_core_model_domain_Shape(x2.value$2);
        if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
          var x5 = $as_Lamf_plugins_domain_shapes_models_AnyShape(shape);
          if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(x5).isDefined__Z()) {
            var jsx$7 = this.ordering$2;
            var jsx$6 = $m_sc_Seq$();
            var array = [$m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Description$1];
            var this$14 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x5, jsx$7, $as_sc_Seq(jsx$6.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))), this.references$2, false, this.spec$2).emitters__sc_Seq().headOption__s_Option();
            if ((!this$14.isEmpty__Z())) {
              var arg1$3 = this$14.get__O();
              var h = $as_Lamf_core_emitter_Emitter(arg1$3);
              result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", $as_Lamf_core_emitter_PartEmitter(h), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()))
            };
            break matchEnd10
          }
        }
      };
      if (rc9) {
        var shape$2 = $as_Lamf_core_model_domain_Shape(x2.value$2);
        if ((shape$2 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
          var x6 = $as_Lamf_plugins_domain_shapes_models_AnyShape(shape$2);
          var jsx$9 = this.ordering$2;
          var jsx$8 = $m_sc_Seq$();
          var array$1 = [$m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Description$1];
          result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x6, jsx$9, $as_sc_Seq(jsx$8.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1))), this.references$2, false, this.spec$2).entries__sc_Seq());
          break matchEnd10
        }
      };
      if (rc9) {
        var other = $as_Lamf_core_model_domain_Shape(x2.value$2);
        var this$19 = this.spec$2;
        var this$20 = this$19.eh$1;
        var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
        var node = other.id$1;
        var property = $m_s_None$();
        var lexical = other.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
        var location = other.location__s_Option();
        this$20.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "Cannot emit parameter for a non WebAPI shape", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
        break matchEnd10
      };
      var x = $m_s_None$();
      if ((x === x1)) {
        result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.parameter$2, this.ordering$2, this.spec$2).emitters__sc_Seq());
        break matchEnd10
      };
      throw new $c_s_MatchError().init___O(x1)
    };
    var x1$2 = $m_s_Option$().apply__O__s_Option(this.parameter$2.fields$1.getValue__Lamf_core_metamodel_Field__Lamf_core_parser_Value($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var v$2 = $as_Lamf_core_parser_Value(x2$2.value$2);
      var x1$3 = v$2.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_ExplicitField.getClassOf());
      if ((x1$3 instanceof $c_s_Some)) {
        var this$21 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1);
        if ((!this$21.isEmpty__Z())) {
          var arg1$4 = this$21.get__O();
          var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$4);
          new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("binding").asRamlAnnotation__T(), f$4, $m_s_None$())))
        }
      } else {
        var x$3 = $m_s_None$();
        if ((!(x$3 === x1$3))) {
          throw new $c_s_MatchError().init___O(x1$3)
        }
      }
    };
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$2.sorted__sc_Seq__sc_Seq(result), b$1);
    jsx$10.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
    var this$24 = k$1.builder$1;
    var jsx$11 = $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$24, 0));
    var this$25 = v$1.builder$1;
    b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(jsx$11, $as_Lorg_yaml_model_YNode($f_scm_ResizableArray__apply__I__O(this$25, 0)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml10ParameterEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml10ParameterEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml10ParameterEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser.call(this);
  this.entry$2 = null;
  this.adopted$2 = null;
  this.parseOptional$2 = false
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(entry, adopted, parseOptional, ctx) {
  this.entry$2 = entry;
  this.adopted$2 = adopted;
  this.parseOptional$2 = parseOptional;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser.prototype.init___Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, entry, adopted, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser.prototype.parse__Lamf_plugins_domain_webapi_models_Parameter = (function() {
  var node = this.entry$2.key$2;
  var iv = this.ctx$1;
  var name = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
  var this$2 = $m_Lamf_plugins_domain_webapi_models_Parameter$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_Parameter(this.entry$2);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1;
  var value = name.text__Lamf_core_model_domain_AmfScalar();
  var this$3 = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, value));
  var name$1 = name.text__Lamf_core_model_domain_AmfScalar().toString__T();
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().ParameterName$1;
  var parameter = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$3, field$1, name$1));
  this.adopted$2.apply__O__O(parameter);
  var this$4 = this.entry$2.value$2;
  var evidence$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var x1 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$4, evidence$2);
  if ((x1 instanceof $c_s_util_Right)) {
    var x2 = $as_s_util_Right(x1);
    var map = $as_Lorg_yaml_model_YMap(x2.value$2);
    var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1;
    var iv$1 = this.ctx$1;
    var this$6 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(parameter);
    jsx$1.key__T__F1__V("required", this$6.withAnnotation__Lamf_core_model_domain_Annotation__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_Lamf_core_annotations_ExplicitField().init___()).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
    var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var field$3 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Description$1;
    var iv$2 = this.ctx$1;
    jsx$2.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$3, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(parameter).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
    var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var jsx$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T("binding").asRamlAnnotation__T();
    var field$4 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
    var iv$3 = this.ctx$1;
    var this$10 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$4, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(parameter);
    jsx$4.key__T__F1__V(jsx$3, this$10.withAnnotation__Lamf_core_model_domain_Annotation__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_Lamf_core_annotations_ExplicitField().init___()));
    var this$13 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(this.entry$2, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parameter$1) {
      return (function(shape$2) {
        var shape = $as_Lamf_core_model_domain_Shape(shape$2);
        $m_Lamf_core_parser_Annotations$();
        var a = new $c_Lamf_core_parser_Annotations().init___();
        var qual$1 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, "schema", a));
        var x$1 = parameter$1.id$1;
        var x$2 = qual$1.adopted$default$2__sc_Seq();
        qual$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$1, x$2)
      })
    })(this, parameter)), new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo().init___Z__Z(false, true), $m_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$(), this.ctx$1).parse__s_Option();
    if ((!this$13.isEmpty__Z())) {
      var arg1 = this$13.get__O();
      var s = $as_Lamf_core_model_domain_Shape(arg1);
      var field$5 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1;
      var value$1 = $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(s, parameter.id$1, $m_s_None$());
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$2);
      $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(parameter, field$5, value$1, annotations))
    };
    new $c_Lamf_plugins_document_webapi_parser_spec_common_AnnotationParser().init___Lamf_core_model_domain_DomainElement__Lorg_yaml_model_YMap__sci_List__Lamf_plugins_document_webapi_contexts_WebApiContext(parameter, map, $m_sci_Nil$(), this.ctx$1).parse__V();
    var p = parameter
  } else {
    var x1$2 = this.ctx$1.link__Lorg_yaml_model_YNode__s_util_Either(this.entry$2.value$2);
    var scope = ((x1$2 instanceof $c_s_util_Left) ? $m_Lamf_core_parser_SearchScope$Fragments$() : $m_Lamf_core_parser_SearchScope$Named$());
    var this$16 = this.entry$2.value$2;
    var x1$3 = this$16.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Null$1;
    if ((x === x1$3)) {
      var this$20 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(this.entry$2, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, parameter$2) {
        return (function(shape$3$2) {
          var shape$3 = $as_Lamf_core_model_domain_Shape(shape$3$2);
          $m_Lamf_core_parser_Annotations$();
          var a$1 = new $c_Lamf_core_parser_Annotations().init___();
          var qual$2 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape$3, "schema", a$1));
          var x$5 = parameter$2.id$1;
          var x$6 = qual$2.adopted$default$2__sc_Seq();
          qual$2.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$5, x$6)
        })
      })(this, parameter)), new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo().init___Z__Z(false, false), $m_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$(), this.ctx$1).parse__s_Option();
      if ((!this$20.isEmpty__Z())) {
        var arg1$1 = this$20.get__O();
        var schema = $as_Lamf_core_model_domain_Shape(arg1$1);
        $m_Lamf_plugins_domain_shapes_models_ExampleTracking$().tracking__Lamf_core_model_domain_Shape__T__s_Option__Lamf_core_model_domain_Shape(schema, parameter.id$1, $m_s_None$()).annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_SynthesizedField().init___());
        var field$6 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1;
        var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$2);
        $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(parameter, field$6, schema, annotations$1))
      };
      var p = parameter
    } else {
      var rc7 = false;
      var x2$2 = null;
      var this$22 = this.entry$2.value$2;
      var evidence$2$1 = $m_Lamf_core_parser_package$YScalarYRead$();
      var x1$4 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$22, evidence$2$1);
      matchEnd8: {
        var p;
        if ((x1$4 instanceof $c_s_util_Right)) {
          rc7 = true;
          x2$2 = $as_s_util_Right(x1$4);
          var ref = $as_Lorg_yaml_model_YScalar(x2$2.value$2);
          if (this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().findParameter__T__Lamf_core_parser_SearchScope$Scope__s_Option(ref.text$3, scope).isDefined__Z()) {
            var this$23 = $as_Lamf_plugins_domain_webapi_models_Parameter($as_Lamf_core_model_domain_Linkable(this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().findParameter__T__Lamf_core_parser_SearchScope$Scope__s_Option(ref.text$3, scope).get__O()).link__T__Lamf_core_parser_Annotations__O(ref.text$3, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$2)));
            var field$7 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1;
            var value$2 = name.text__Lamf_core_model_domain_AmfScalar();
            var p = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$23, field$7, value$2));
            break matchEnd8
          }
        };
        if (rc7) {
          var ref$2 = $as_Lorg_yaml_model_YScalar(x2$2.value$2);
          if (this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().findType__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option(ref$2.text$3, scope, (this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations(), $m_s_None$())).isDefined__Z()) {
            var shape$4 = $as_Lamf_core_model_domain_Shape($as_Lamf_core_model_domain_Linkable(this.ctx$1.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().findType__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option(ref$2.text$3, scope, new $c_s_Some().init___O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1, parameter$3) {
              return (function(s$3$2) {
                var s$3 = $as_T(s$3$2);
                var this$25 = this$5$1.ctx$1.eh$1;
                var specification = $m_Lamf_validations_ParserSideValidations$().InvalidFragmentType$1;
                var node$1 = parameter$3.id$1;
                var ast = this$5$1.entry$2.value$2;
                var prop = $m_s_None$();
                var l = ast.location$1;
                $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$25, specification, node$1, prop, s$3, l)
              })
            })(this, parameter)))).get__O()).link__T__Lamf_core_parser_Annotations__O(ref$2.text$3, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$2)));
            $m_Lamf_core_parser_Annotations$();
            var a$2 = new $c_Lamf_core_parser_Annotations().init___();
            var qual$3 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape$4, "schema", a$2));
            var x$7 = parameter.id$1;
            var x$8 = qual$3.adopted$default$2__sc_Seq();
            var schema$1 = $as_Lamf_core_model_domain_Shape(qual$3.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$7, x$8));
            var field$8 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1;
            var p = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(parameter, field$8, schema$1));
            break matchEnd8
          }
        };
        if (rc7) {
          var ref$3 = $as_Lorg_yaml_model_YScalar(x2$2.value$2);
          var str = ref$3.text$3;
          if ($f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax__wellKnownType__T__Z__Z(this, str, true)) {
            var ramlType = ref$3.text$3;
            var shape$5 = $f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax__parseWellKnownTypeRef__T__Lamf_core_model_domain_Shape(this, ramlType);
            $m_Lamf_core_parser_Annotations$();
            var a$3 = new $c_Lamf_core_parser_Annotations().init___();
            var qual$4 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape$5, "schema", a$3));
            var x$9 = parameter.id$1;
            var x$10 = qual$4.adopted$default$2__sc_Seq();
            var schema$3 = $as_Lamf_core_model_domain_Shape(qual$4.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$9, x$10));
            var field$9 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1;
            var p = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(parameter, field$9, schema$3));
            break matchEnd8
          }
        };
        if (rc7) {
          var ref$4 = $as_Lorg_yaml_model_YScalar(x2$2.value$2);
          var str$1 = ref$4.text$3;
          if ($f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax__isTypeExpression__T__Z(this, str$1)) {
            var x$13 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1, parameter$4) {
              return (function(shape$6$2) {
                var shape$6 = $as_Lamf_core_model_domain_Shape(shape$6$2);
                $m_Lamf_core_parser_Annotations$();
                var a$4 = new $c_Lamf_core_parser_Annotations().init___();
                var qual$5 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape$6, "schema", a$4));
                var x$11 = parameter$4.id$1;
                var x$12 = qual$5.adopted$default$2__sc_Seq();
                qual$5.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(x$11, x$12)
              })
            })(this, parameter));
            var x$14 = ref$4.text$3;
            var x$15 = $m_s_None$();
            var ctx = this.ctx$1;
            var x1$5 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser().init___F1__I__s_Option__Z__T__Lamf_plugins_document_webapi_contexts_WebApiContext(x$13, 0, x$15, false, x$14, ctx).parse__s_Option();
            if ((x1$5 instanceof $c_s_Some)) {
              var x2$3 = $as_s_Some(x1$5);
              var schema$4 = $as_Lamf_core_model_domain_Shape(x2$3.value$2);
              var field$10 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1;
              var p = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(parameter, field$10, schema$4));
              break matchEnd8
            } else {
              var this$31 = this.ctx$1.eh$1;
              var specification$1 = $m_Lamf_plugins_features_validation_CoreValidations$().UnresolvedReference$1;
              var node$2 = parameter.id$1;
              var message = (("Cannot parse type expression for unresolved parameter '" + $as_Lamf_core_model_StrField(parameter.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1))) + "'");
              var ast$1 = this.entry$2.value$2;
              var prop$1 = $m_s_None$();
              var l$1 = ast$1.location$1;
              $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$31, specification$1, node$2, prop$1, message, l$1);
              var p = parameter;
              break matchEnd8
            }
          }
        };
        var this$32 = this.ctx$1.eh$1;
        var specification$2 = $m_Lamf_plugins_features_validation_CoreValidations$().UnresolvedReference$1;
        var node$3 = parameter.id$1;
        var ast$2 = this.entry$2.value$2;
        var prop$2 = $m_s_None$();
        var l$2 = ast$2.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$32, specification$2, node$3, prop$2, "Cannot declare unresolved parameter", l$2);
        var p = parameter
      }
    }
  };
  if (p.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1).isEmpty__Z()) {
    var stringName = name.text__Lamf_core_model_domain_AmfScalar().toString__T();
    var required = (!$m_sjsr_RuntimeString$().endsWith__T__T__Z(stringName, "?"));
    if (required) {
      var paramName = stringName
    } else {
      var this$34 = new $c_sci_StringOps().init___T(stringName);
      var paramName = $f_sci_StringLike__stripSuffix__T__T(this$34, "?")
    };
    var field$11 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1;
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(p, field$11, required);
    var field$12 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1;
    var value$3 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(paramName, name.text__Lamf_core_model_domain_AmfScalar().annotations$1);
    var this$35 = $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(p, field$12, value$3);
    var field$13 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().ParameterName$1;
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$35, field$13, paramName)
  };
  return p
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser.prototype.productPrefix__T = (function() {
  return "Raml10ParameterParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser)) {
    var Raml10ParameterParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser(x$1);
    var x = this.entry$2;
    var x$2 = Raml10ParameterParser$1.entry$2;
    if ((x === x$2)) {
      var x$3 = this.adopted$2;
      var x$4 = Raml10ParameterParser$1.adopted$2;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.parseOptional$2 === Raml10ParameterParser$1.parseOptional$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$2;
      break
    }
    case 1: {
      return this.adopted$2;
      break
    }
    case 2: {
      return this.parseOptional$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.entry$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.adopted$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.parseOptional$2 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 3)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml10ParameterParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml10ParameterParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml10ParameterParser", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_RamlParameterParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ParameterParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.f$1 = null;
  this.ordering$1 = null;
  this.references$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter.prototype.productPrefix__T = (function() {
  return "Raml10PayloadsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter)) {
    var Raml10PayloadsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter(x$1);
    if ((this.key$1 === Raml10PayloadsEmitter$1.key$1)) {
      var x = this.f$1;
      var x$2 = Raml10PayloadsEmitter$1.f$1;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$3 = this.ordering$1;
      var x$4 = Raml10PayloadsEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$1;
      var x$6 = Raml10PayloadsEmitter$1.references$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.f$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.references$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var x1 = this.payloads__p1__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq(this.f$1, this.ordering$1, this.references$1);
  matchEnd5: {
    $m_sc_Seq$();
    var o8 = new $c_s_Some().init___O(x1);
    if (((o8.value$2 !== null) && ($as_sc_SeqLike(o8.value$2).lengthCompare__I__I(1) === 0))) {
      var p = $as_Lamf_core_emitter_Emitter($as_sc_SeqLike(o8.value$2).apply__I__O(0));
      if ($is_Lamf_core_emitter_PartEmitter(p)) {
        var x3 = $as_Lamf_core_emitter_PartEmitter(p);
        $m_Lorg_yaml_model_YNode$();
        var str = this.key$1;
        var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
        var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
        x3.emit__Lorg_yaml_model_YDocument$PartBuilder__V(v);
        var this$6 = v.builder$1;
        var array = [key];
        if ((this$6.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len = $uI(array.length);
        var newSize = ((this$6.size0$6 + len) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$6, newSize);
        var len$1 = this$6.size0$6;
        var src = this$6.array$6;
        var dest = this$6.array$6;
        $systemArraycopy(src, 0, dest, len, len$1);
        var xs = this$6.array$6;
        var len$2 = xs.u.length;
        var i = 0;
        var j = 0;
        var x = $uI(array.length);
        var x$1 = ((x < len$2) ? x : len$2);
        var that = xs.u.length;
        var end = ((x$1 < that) ? x$1 : that);
        while ((i < end)) {
          var jsx$1 = j;
          var index = i;
          xs.set(jsx$1, array[index]);
          i = ((1 + i) | 0);
          j = ((1 + j) | 0)
        };
        this$6.size0$6 = newSize;
        b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1));
        break matchEnd5
      }
    };
    if (x1.forall__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(x$12$2) {
        var x$12 = $as_Lamf_core_emitter_Emitter(x$12$2);
        return $is_Lamf_core_emitter_EntryEmitter(x$12)
      })
    })(this)))) {
      $m_Lorg_yaml_model_YNode$();
      var str$1 = this.key$1;
      var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
      var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
      var jsx$4 = v$1.builder$1;
      var sourceName = v$1.sourceName$2;
      var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
      var jsx$3 = $m_Lamf_core_emitter_BaseEmitters_package$();
      var jsx$2 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter$$anonfun$$nestedInanonfun$emit$26$1().init___Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter(this);
      var this$19 = $m_sc_Seq$();
      jsx$3.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V($as_sc_Seq(x1.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$2, this$19.ReusableCBFInstance$2)), b$1);
      jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
      var this$22 = v$1.builder$1;
      var array$1 = [key$1];
      if ((this$22.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len$3 = $uI(array$1.length);
      var newSize$1 = ((this$22.size0$6 + len$3) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$22, newSize$1);
      var len$4 = this$22.size0$6;
      var src$1 = this$22.array$6;
      var dest$1 = this$22.array$6;
      $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
      var xs$1 = this$22.array$6;
      var len$5 = xs$1.u.length;
      var i$1 = 0;
      var j$1 = 0;
      var x$2 = $uI(array$1.length);
      var x$3 = ((x$2 < len$5) ? x$2 : len$5);
      var that$1 = xs$1.u.length;
      var end$1 = ((x$3 < that$1) ? x$3 : that$1);
      while ((i$1 < end$1)) {
        var jsx$5 = j$1;
        var index$1 = i$1;
        xs$1.set(jsx$5, array$1[index$1]);
        i$1 = ((1 + i$1) | 0);
        j$1 = ((1 + j$1) | 0)
      };
      this$22.size0$6 = newSize$1;
      b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1));
      break matchEnd5
    };
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("IllegalTypeDeclarations found: " + x1)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter.prototype.init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(key, f, ordering, references, spec) {
  this.key$1 = key;
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.references$1 = references;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter.prototype.payloads__p1__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq = (function(f, ordering, references) {
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(f.value$1.value$1).values$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, ordering$1, references$1) {
    return (function(e$2) {
      var e = $as_Lamf_core_model_domain_AmfElement(e$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10Payloads().init___Lamf_plugins_domain_webapi_models_Payload__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext($as_Lamf_plugins_domain_webapi_models_Payload(e), ordering$1, references$1, $this.spec$1).emitters__sc_Seq()
    })
  })(this, ordering, references));
  var this$1 = $m_sc_Seq$();
  return ordering.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.f$1.value$1.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml10PayloadsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml10PayloadsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml10PayloadsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_RamlPayloadsEmitter: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10PayloadsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter.call(this);
  this.response$2 = null;
  this.ordering$2 = null;
  this.references$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter.prototype.productPrefix__T = (function() {
  return "Raml10ResponseEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter)) {
    var Raml10ResponseEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter(x$1);
    var x = this.response$2;
    var x$2 = Raml10ResponseEmitter$1.response$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = Raml10ResponseEmitter$1.ordering$2;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$2;
      var x$6 = Raml10ResponseEmitter$1.references$2;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.response$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    case 2: {
      return this.references$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Response__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(response, ordering, references, spec) {
  this.response$2 = response;
  this.ordering$2 = ordering;
  this.references$2 = references;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Response__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this, response, ordering, references, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter.prototype.emitters__Lamf_core_parser_Fields__scm_ListBuffer = (function(fs) {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Examples$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter$().apply__T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_plugins_document_webapi_parser_spec_domain_OasResponseExamplesEmitter(new $c_Lamf_core_utils_package$AmfStrings().init___T("examples").asRamlAnnotation__T(), f, this.ordering$2, this.spec$2)))
  };
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.response$2, this.ordering$2, this.spec$2).emitters__sc_Seq());
  var this$3 = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter.prototype.emitters__Lamf_core_parser_Fields__scm_ListBuffer.call(this, fs);
  var this$4 = new $c_scm_ListBuffer().init___().$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(this$3);
  return this$4.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(result)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.Raml10ResponseEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.Raml10ResponseEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.Raml10ResponseEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_RamlResponseEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_Raml10ResponseEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedSecuritySchemeEmitter.call(this);
  this.parametrizedScheme$2 = null;
  this.ordering$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedSecuritySchemeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter.prototype.productPrefix__T = (function() {
  return "RamlParametrizedSecuritySchemeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var fs = this.parametrizedScheme$2.fields$1;
  var rc6 = false;
  var x3 = null;
  var x1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Settings$1);
  matchEnd7: {
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var f = $as_Lamf_core_parser_FieldEntry(x2.value$2);
      var jsx$3 = b.builder$1;
      var sourceName = b.sourceName$2;
      var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
      $m_Lorg_yaml_model_YNode$();
      var this$2 = this.parametrizedScheme$2;
      var this$3 = $as_Lamf_core_model_StrField(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Name$1));
      var this$4 = this$3.option$1;
      var str = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
      var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
      var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
      var jsx$1 = v.builder$1;
      var sourceName$1 = v.sourceName$2;
      var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
      $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$2.sorted__sc_Seq__sc_Seq(new $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlSecuritySettingsValuesEmitters().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(f, this.ordering$2, this.spec$2).emitters__sc_Seq()), b$2);
      jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1));
      var this$9 = v.builder$1;
      var array = [key];
      if ((this$9.size0$6 < 0)) {
        throw new $c_jl_IndexOutOfBoundsException().init___T("0")
      };
      var len = $uI(array.length);
      var newSize = ((this$9.size0$6 + len) | 0);
      $f_scm_ResizableArray__ensureSize__I__V(this$9, newSize);
      var len$1 = this$9.size0$6;
      var src = this$9.array$6;
      var dest = this$9.array$6;
      $systemArraycopy(src, 0, dest, len, len$1);
      var xs = this$9.array$6;
      var len$2 = xs.u.length;
      var i = 0;
      var j = 0;
      var x = $uI(array.length);
      var x$1 = ((x < len$2) ? x : len$2);
      var that = xs.u.length;
      var end = ((x$1 < that) ? x$1 : that);
      while ((i < end)) {
        var jsx$2 = j;
        var index = i;
        xs.set(jsx$2, array[index]);
        i = ((1 + i) | 0);
        j = ((1 + j) | 0)
      };
      this$9.size0$6 = newSize;
      b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1));
      jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
      break matchEnd7
    };
    var x$2 = $m_s_None$();
    if ((x$2 === x1)) {
      rc6 = true;
      x3 = x1;
      if (this.parametrizedScheme$2.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_NullSecurity.getClassOf())) {
        var node = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YScalar$().Null$1, $m_Lorg_yaml_model_YType$().Null$1);
        b.builder$1.$$plus$eq__O__scm_ArrayBuffer(node);
        break matchEnd7
      }
    };
    if (rc6) {
      var this$20 = this.parametrizedScheme$2;
      var this$21 = $as_Lamf_core_model_StrField(this$20.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Name$1));
      var this$22 = this$21.option$1;
      b.$$plus$eq__T__V($as_T((this$22.isEmpty__Z() ? null : this$22.get__O())));
      break matchEnd7
    };
    throw new $c_s_MatchError().init___O(x1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(parametrizedScheme, ordering, spec) {
  this.parametrizedScheme$2 = parametrizedScheme;
  this.ordering$2 = ordering;
  this.spec$2 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter)) {
    var RamlParametrizedSecuritySchemeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter(x$1);
    var x = this.parametrizedScheme$2;
    var x$2 = RamlParametrizedSecuritySchemeEmitter$1.parametrizedScheme$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = RamlParametrizedSecuritySchemeEmitter$1.ordering$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.parametrizedScheme$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.parametrizedScheme$2.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlParametrizedSecuritySchemeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlParametrizedSecuritySchemeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlParametrizedSecuritySchemeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_ParametrizedSecuritySchemeEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_AbstractSecurityRequirementEmitter.call(this);
  this.requirement$2 = null;
  this.ordering$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_AbstractSecurityRequirementEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityRequirement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(requirement, ordering, spec) {
  this.requirement$2 = requirement;
  this.ordering$2 = ordering;
  this.spec$2 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter.prototype.productPrefix__T = (function() {
  return "RamlSecurityRequirementEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var this$1 = this.requirement$2;
  $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$().Schemes$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$1) {
    return (function(scheme$2) {
      var scheme = $as_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme(scheme$2);
      new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlParametrizedSecuritySchemeEmitter().init___Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(scheme, $this.ordering$2, $this.spec$2).emit__Lorg_yaml_model_YDocument$PartBuilder__V(b$1)
    })
  })(this, b)))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter)) {
    var RamlSecurityRequirementEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter(x$1);
    var x = this.requirement$2;
    var x$2 = RamlSecurityRequirementEmitter$1.requirement$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = RamlSecurityRequirementEmitter$1.ordering$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.requirement$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.requirement$2.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.RamlSecurityRequirementEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.RamlSecurityRequirementEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.RamlSecurityRequirementEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_AbstractSecurityRequirementEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_RamlSecurityRequirementEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter.call(this);
  this.key$2 = null;
  this.examples$2 = null;
  this.ordering$2 = null;
  this.references$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter.prototype.productPrefix__T = (function() {
  return "SafeNamedMultipleExampleEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var idCounter = new $c_Lamf_core_utils_package$IdCounter().init___();
  var jsx$2 = this.examples$2;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, idCounter$1) {
    return (function(e$2) {
      var e = $as_Lamf_plugins_domain_shapes_models_Example(e$2);
      var x1 = $as_Lamf_core_model_StrField(e.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Name$1)).option$1;
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var name = $as_T(x2.value$2);
        var key = name
      } else {
        var x = $m_s_None$();
        if ((!(x === x1))) {
          throw new $c_s_MatchError().init___O(x1)
        };
        var key = idCounter$1.genId__T__T("example")
      };
      return new $c_Lamf_plugins_document_webapi_parser_spec_domain_KeyedExampleEmitter().init___T__Lamf_plugins_domain_shapes_models_Example__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(key, e, $this.ordering$2, $this.spec$2)
    })
  })(this, idCounter));
  var this$1 = $m_sc_Seq$();
  var emitters = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  var jsx$3 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$2.sorted__sc_Seq__sc_Seq(emitters), b$1);
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter)) {
    var SafeNamedMultipleExampleEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter(x$1);
    if ((this.key$2 === SafeNamedMultipleExampleEmitter$1.key$2)) {
      var x = this.examples$2;
      var x$2 = SafeNamedMultipleExampleEmitter$1.examples$2;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$3 = this.ordering$2;
      var x$4 = SafeNamedMultipleExampleEmitter$1.ordering$2;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$2;
      var x$6 = SafeNamedMultipleExampleEmitter$1.references$2;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$2;
      break
    }
    case 1: {
      return this.examples$2;
      break
    }
    case 2: {
      return this.ordering$2;
      break
    }
    case 3: {
      return this.references$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter.prototype.init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, examples, ordering, references, spec) {
  this.key$2 = key;
  this.examples$2 = examples;
  this.ordering$2 = ordering;
  this.references$2 = references;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter.prototype.init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, key, examples, ordering, references, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.SafeNamedMultipleExampleEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.SafeNamedMultipleExampleEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.SafeNamedMultipleExampleEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_MultipleExampleEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_SafeNamedMultipleExampleEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter() {
  $c_O.call(this);
  this.key$1 = null;
  this.f$1 = null;
  this.ordering$1 = null;
  this.spec$1 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter.prototype.productPrefix__T = (function() {
  return "SecurityRequirementsEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter)) {
    var SecurityRequirementsEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter(x$1);
    if ((this.key$1 === SecurityRequirementsEmitter$1.key$1)) {
      var x = this.f$1;
      var x$2 = SecurityRequirementsEmitter$1.f$1;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.ordering$1;
      var x$4 = SecurityRequirementsEmitter$1.ordering$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$1;
      break
    }
    case 1: {
      return this.f$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $f_Lamf_plugins_document_webapi_parser_spec_domain_SingleValueArrayEmitter__emit__Lorg_yaml_model_YDocument$EntryBuilder__V(this, b)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter.prototype.emit__Lamf_core_model_domain_AmfElement__Lamf_core_emitter_PartEmitter = (function(element) {
  return this.emit__Lamf_plugins_domain_webapi_models_security_SecurityRequirement__Lamf_core_emitter_PartEmitter($as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(element))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter.prototype.f__Lamf_core_parser_FieldEntry = (function() {
  return this.f$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter.prototype.collect__sc_Seq__sc_Seq = (function(elements) {
  var this$1 = this.f$1;
  var jsx$2 = $as_Lamf_core_model_domain_AmfArray(this$1.value$1.value$1).values$1;
  var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter$$anonfun$collect$1().init___Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter(this);
  var this$2 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter.prototype.ordering__Lamf_core_emitter_SpecOrdering = (function() {
  return this.ordering$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter.prototype.emit__Lamf_plugins_domain_webapi_models_security_SecurityRequirement__Lamf_core_emitter_PartEmitter = (function(scheme) {
  return $as_Lamf_core_emitter_PartEmitter(this.spec$1.factory__Lamf_plugins_document_webapi_contexts_SpecEmitterFactory().securityRequirementEmitter__F2().apply__O__O__O(scheme, this.ordering$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter.prototype.init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function(key, f, ordering, spec) {
  this.key$1 = key;
  this.f$1 = f;
  this.ordering$1 = ordering;
  this.spec$1 = spec;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter.prototype.key__T = (function() {
  return this.key$1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  return $f_Lamf_plugins_document_webapi_parser_spec_domain_SingleValueArrayEmitter__position__Lamf_core_parser_Position(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.domain.SecurityRequirementsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.domain.SecurityRequirementsEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.domain.SecurityRequirementsEmitter", {
  Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_SingleValueArrayEmitter: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_domain_SecurityRequirementsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleEmitter.call(this);
  this.module$3 = null;
  this.spec$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter.prototype.productPrefix__T = (function() {
  return "Oas20ModuleEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter)) {
    var Oas20ModuleEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter(x$1);
    var x = this.module$3;
    var x$2 = Oas20ModuleEmitter$1.module$3;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter.prototype.docVersion__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(builder) {
  builder.updateDynamic__T__Lorg_yaml_model_YNode__V("swagger", ($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("2.0")))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.module$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter.prototype.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function() {
  return this.spec$3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter.prototype.init___Lamf_core_model_document_Module__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(module, spec) {
  this.module$3 = module;
  this.spec$3 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleEmitter.prototype.init___Lamf_core_model_document_Module__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.call(this, module, spec);
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.Oas20ModuleEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.Oas20ModuleEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.Oas20ModuleEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasModuleEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_BaseSpecEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleEmitter.call(this);
  this.module$3 = null;
  this.spec$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter.prototype.productPrefix__T = (function() {
  return "Oas30ModuleEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter)) {
    var Oas30ModuleEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter(x$1);
    var x = this.module$3;
    var x$2 = Oas30ModuleEmitter$1.module$3;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter.prototype.docVersion__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(builder) {
  builder.updateDynamic__T__Lorg_yaml_model_YNode__V("openapi", ($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("3.0.0")))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.module$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter.prototype.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function() {
  return this.spec$3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter.prototype.init___Lamf_core_model_document_Module__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(module, spec) {
  this.module$3 = module;
  this.spec$3 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleEmitter.prototype.init___Lamf_core_model_document_Module__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.call(this, module, spec);
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.Oas30ModuleEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.Oas30ModuleEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.Oas30ModuleEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasModuleEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_BaseSpecEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter.call(this);
  this.securityScheme$2 = null;
  this.mappedType$2 = null;
  this.ordering$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter.prototype.productPrefix__T = (function() {
  return "Oas3NamedSecuritySchemeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter)) {
    var Oas3NamedSecuritySchemeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter(x$1);
    var x = this.securityScheme$2;
    var x$2 = Oas3NamedSecuritySchemeEmitter$1.securityScheme$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.mappedType$2;
      var x$4 = Oas3NamedSecuritySchemeEmitter$1.mappedType$2;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.ordering$2;
      var x$6 = Oas3NamedSecuritySchemeEmitter$1.ordering$2;
      return (x$5 === x$6)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.securityScheme$2;
      break
    }
    case 1: {
      return this.mappedType$2;
      break
    }
    case 2: {
      return this.ordering$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(securityScheme, mappedType, ordering, spec) {
  this.securityScheme$2 = securityScheme;
  this.mappedType$2 = mappedType;
  this.ordering$2 = ordering;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.call(this, securityScheme, mappedType, ordering, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter.prototype.emitInline__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$1 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$2.sorted__sc_Seq__sc_Seq(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemeEmitter().init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_plugins_document_webapi_parser_spec_oas_SecuritySchemeType__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.securityScheme$2, this.mappedType$2, this.ordering$2, this.spec$2).emitters__sc_Seq()), b$1);
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.Oas3NamedSecuritySchemeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.Oas3NamedSecuritySchemeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.Oas3NamedSecuritySchemeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasNamedSecuritySchemeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3NamedSecuritySchemeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationPartEmitter.call(this);
  this.operation$2 = null;
  this.ordering$2 = null;
  this.endpointPayloadEmitted$2 = false;
  this.references$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationPartEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter.prototype.productPrefix__T = (function() {
  return "OasOperationPartEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(p) {
  var jsx$4 = p.builder$1;
  var sourceName = p.sourceName$2;
  var b = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var fs = this.operation$2.fields$1;
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Tags$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_StringArrayTagsEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("tags", $as_Lamf_core_model_domain_AmfArray(f.value$1.value$1).values$1, this.ordering$2, $as_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.spec$1))))
  };
  var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Deprecated$1);
  if ((!this$3.isEmpty__Z())) {
    var arg1$1 = this$3.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("deprecated", f$3, $m_s_None$())))
  };
  var this$5 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Schemes$1);
  if ((!this$5.isEmpty__Z())) {
    var arg1$2 = this$5.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType("schemes", f$4, this.ordering$2, false, $m_Lorg_yaml_model_YType$().Str$1)))
  };
  var this$7 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Accepts$1);
  if ((!this$7.isEmpty__Z())) {
    var arg1$3 = this$7.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType("consumes", f$5, this.ordering$2, false, $m_Lorg_yaml_model_YType$().Str$1)))
  };
  var this$9 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().ContentType$1);
  if ((!this$9.isEmpty__Z())) {
    var arg1$4 = this$9.get__O();
    var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType("produces", f$6, this.ordering$2, false, $m_Lorg_yaml_model_YType$().Str$1)))
  };
  var this$11 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field());
  if ((!this$11.isEmpty__Z())) {
    var arg1$5 = this$11.get__O();
    var f$7 = $as_Lamf_core_parser_FieldEntry(arg1$5);
    new $c_s_Some().init___O(result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_ExtendsEmitter().init___Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lamf_core_errorhandling_ErrorHandler(f$7, this.ordering$2, true, $as_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.spec$1).eh__Lamf_core_errorhandling_ErrorHandler()).emitters__sc_Seq()))
  };
  var this$12 = $m_s_Option$().apply__O__s_Option(this.operation$2.request__Lamf_plugins_domain_webapi_models_Request());
  if ((!this$12.isEmpty__Z())) {
    var arg1$6 = this$12.get__O();
    var req = $as_Lamf_plugins_domain_webapi_models_Request(arg1$6);
    result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(this.requestEmitters__Lamf_plugins_domain_webapi_models_Request__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq(req, this.ordering$2, this.references$2))
  };
  var this$13 = this.operation$2;
  var orphanAnnotations = $as_sc_Seq($as_sc_Seq(this$13.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().CustomDomainProperties__Lamf_core_metamodel_Field())).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$8$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_domain_extensions_DomainExtension(x$1$2);
      return $as_Lamf_core_model_domain_DataNode(x$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1)).annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_plugins_domain_webapi_annotations_OrphanOasExtension.getClassOf())
    })
  })(this))));
  var this$14 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1);
  if (this$14.isEmpty__Z()) {
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position("responses", new $c_Lamf_core_emitter_BaseEmitters_package$EmptyMapEmitter().init___Lamf_core_parser_Position($m_Lamf_core_parser_Position$ZERO$()), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()))
  } else {
    var arg1$7 = this$14.get__O();
    var f$8 = $as_Lamf_core_parser_FieldEntry(arg1$7);
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_ResponsesEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext("responses", f$8, this.ordering$2, this.references$2, orphanAnnotations, $as_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.spec$1)))
  };
  var this$18 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Security$1);
  if ((!this$18.isEmpty__Z())) {
    var arg1$8 = this$18.get__O();
    var f$9 = $as_Lamf_core_parser_FieldEntry(arg1$8);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasWithExtensionsSecurityRequirementsEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext("security", f$9, this.ordering$2, $as_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.spec$1))))
  };
  if (($as_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.spec$1).factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory() instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory)) {
    var this$19 = this.operation$2.fields$1;
    var this$22 = this$19.fs$1;
    var this$20 = $m_Lamf_core_parser_FieldEntry$();
    var f$1 = $f_F2__tupled__F1(this$20);
    var this$21 = $m_sci_Iterable$();
    var bf = this$21.ReusableCBFInstance$2;
    var this$23 = $as_sc_Iterable($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$22, f$1, bf)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$12$1) {
      return (function(x$2$2) {
        var x$2 = $as_Lamf_core_parser_FieldEntry(x$2$2);
        var x = x$2.field$1;
        var x$3 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Callbacks$1;
        return ((x === null) ? (x$3 === null) : x.equals__O__Z(x$3))
      })
    })(this)));
    if ((!this$23.isEmpty__Z())) {
      var arg1$9 = this$23.get__O();
      var f$10 = $as_Lamf_core_parser_FieldEntry(arg1$9);
      var callbacks = f$10.arrayValues__sc_Seq();
      var annotations = f$10.value$1.annotations$1;
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$EntryPartEmitter().init___T__Lamf_core_emitter_PartEmitter__Lorg_yaml_model_YType__Lamf_core_parser_Position("callbacks", new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasCallbacksEmitter().init___sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_core_parser_Annotations__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(callbacks, this.ordering$2, this.references$2, annotations, $as_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.spec$1)), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()))
    };
    var this$26 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Servers$1);
    if ((!this$26.isEmpty__Z())) {
      var arg1$10 = this$26.get__O();
      var f$11 = $as_Lamf_core_parser_FieldEntry(arg1$10);
      var this$27 = $as_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.spec$1).factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory();
      var operation = this.operation$2;
      var ordering = this.ordering$2;
      var references = this.references$2;
      new $c_s_Some().init___O(result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(this$27.serversEmitter__Lamf_plugins_domain_webapi_models_Operation__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter(operation, f$11, ordering, references).emitters__sc_Seq()))
    }
  };
  var jsx$3 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var jsx$2 = this.ordering$2;
  var jsx$1 = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationPartEmitter.prototype.commonEmitters__sc_Seq.call(this);
  var this$28 = $m_sc_Seq$();
  jsx$3.traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(jsx$2.sorted__sc_Seq__sc_Seq($as_sc_Seq(jsx$1.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(result, this$28.ReusableCBFInstance$2))), b);
  jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter)) {
    var OasOperationPartEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter(x$1);
    var x = this.operation$2;
    var x$2 = OasOperationPartEmitter$1.operation$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = OasOperationPartEmitter$1.ordering$2;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if ((jsx$1 && (this.endpointPayloadEmitted$2 === OasOperationPartEmitter$1.endpointPayloadEmitted$2))) {
      var x$5 = this.references$2;
      var x$6 = OasOperationPartEmitter$1.references$2;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.operation$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    case 2: {
      return this.endpointPayloadEmitted$2;
      break
    }
    case 3: {
      return this.references$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter.prototype.spec__Lamf_plugins_document_webapi_contexts_SpecEmitterContext = (function() {
  return $as_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.spec$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_emitter_SpecOrdering__Z__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(operation, ordering, endpointPayloadEmitted, references, spec) {
  this.operation$2 = operation;
  this.ordering$2 = ordering;
  this.endpointPayloadEmitted$2 = endpointPayloadEmitted;
  this.references$2 = references;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationPartEmitter.prototype.init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, operation, ordering, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter.prototype.ramlTypesEmitter__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter = (function(s, o, a, fs, us) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(s, o, a, fs, us, new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions($as_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.spec$1).eh__Lamf_core_errorhandling_ErrorHandler(), $m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$(), new $c_Lamf_core_emitter_ShapeRenderOptions().init___()))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter.prototype.requestEmitters__Lamf_plugins_domain_webapi_models_Request__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq = (function(request, ordering, references) {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  if (($as_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.spec$1).factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory() instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory)) {
    var jsx$6 = $as_sc_Seq(request.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryParameters$1));
    var jsx$5 = $as_sc_Seq(request.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().UriParameters$1));
    var this$1 = $m_sc_Seq$();
    var jsx$4 = $as_sc_TraversableLike(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$5, this$1.ReusableCBFInstance$2));
    var jsx$3 = $as_sc_Seq(request.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Headers$1));
    var this$2 = $m_sc_Seq$();
    var jsx$2 = $as_sc_TraversableLike(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$2.ReusableCBFInstance$2));
    var jsx$1 = $as_sc_Seq(request.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().CookieParameters$1));
    var this$3 = $m_sc_Seq$();
    var parameters = $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
    if (parameters.nonEmpty__Z()) {
      result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext("parameters", parameters, ordering, $m_sci_Nil$(), references, $as_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.spec$1)).emitters__sc_Seq())
    };
    var jsx$7 = $m_sc_Seq$();
    var array = [new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3RequestBodyEmitter().init___Lamf_plugins_domain_webapi_models_Request__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(request, ordering, references, $as_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.spec$1))];
    result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer($as_sc_TraversableOnce(jsx$7.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))))
  } else {
    var fs = request.fields$2;
    var jsx$11 = $as_sc_Seq(request.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryParameters$1));
    var jsx$10 = $as_sc_Seq(request.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().UriParameters$1));
    var this$6 = $m_sc_Seq$();
    var jsx$9 = $as_sc_TraversableLike(jsx$11.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$10, this$6.ReusableCBFInstance$2));
    var jsx$8 = $as_sc_Seq(request.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Headers$1));
    var this$7 = $m_sc_Seq$();
    var parameters$2 = $as_sc_Seq(jsx$9.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$8, this$7.ReusableCBFInstance$2));
    var x1 = $as_sc_Seq(request.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Payloads$1)).partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(p$2) {
        var p = $as_Lamf_plugins_domain_webapi_models_Payload(p$2);
        return (!p.annotations$1.contains__jl_Class__Z($d_Lamf_plugins_document_webapi_annotations_FormBodyParameter.getClassOf()))
      })
    })(this)));
    if ((x1 === null)) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var body = $as_sc_Seq(x1.$$und1__O());
    var formData = $as_sc_Seq(x1.$$und2__O());
    var payloads = $m_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads$().apply__sc_Seq__Z__Lamf_plugins_document_webapi_parser_spec_domain_OasPayloads(body, false);
    if (((parameters$2.nonEmpty__Z() || payloads.default$1.isDefined__Z()) || formData.nonEmpty__Z())) {
      var xo = payloads.default$1;
      var this$9 = xo.toList__sci_List();
      var this$10 = $m_sc_Seq$();
      result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasParametersEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext("parameters", parameters$2, ordering, $as_sc_Seq(this$9.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(formData, this$10.ReusableCBFInstance$2)), references, $as_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.spec$1)).emitters__sc_Seq())
    };
    if (payloads.other$1.nonEmpty__Z()) {
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasPayloadsEmitter().init___T__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(new $c_Lamf_core_utils_package$AmfStrings().init___T("requestPayloads").asOasExtension__T(), payloads.other$1, ordering, references, $as_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.spec$1)))
    };
    var this$12 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryString$1);
    if ((!this$12.isEmpty__Z())) {
      var arg1 = this$12.get__O();
      var f = $as_Lamf_core_parser_FieldEntry(arg1);
      var rc7 = false;
      var x2 = null;
      var x1$1 = $m_s_Option$().apply__O__s_Option(f.value$1.value$1);
      matchEnd8: {
        if ((x1$1 instanceof $c_s_Some)) {
          rc7 = true;
          x2 = $as_s_Some(x1$1);
          var shape = $as_Lamf_core_model_domain_AmfElement(x2.value$2);
          if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
            var x4 = $as_Lamf_plugins_domain_shapes_models_AnyShape(shape);
            result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter().init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__F5__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x4, ordering, $m_sci_Nil$(), new $c_sjsr_AnonFunction5().init___sjs_js_Function5((function($this$1) {
              return (function(s$2, o$2, a$2, fs$2, us$2) {
                var s = $as_Lamf_plugins_domain_shapes_models_AnyShape(s$2);
                var o = $as_Lamf_core_emitter_SpecOrdering(o$2);
                var a = $as_s_Option(a$2);
                var fs$1 = $as_sc_Seq(fs$2);
                var us = $as_sc_Seq(us$2);
                return $this$1.ramlTypesEmitter__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlTypePartEmitter(s, o, a, fs$1, us)
              })
            })(this)), $as_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.spec$1)));
            break matchEnd8
          }
        };
        if (rc7) {
          var other = $as_Lamf_core_model_domain_AmfElement(x2.value$2);
          var this$13 = $as_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.spec$1).eh__Lamf_core_errorhandling_ErrorHandler();
          var specification = $m_Lamf_plugins_features_validation_CoreValidations$().ResolutionValidation$1;
          var node = request.id$1;
          var property = $m_s_None$();
          var lexical = other.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
          var location = other.location__s_Option();
          this$13.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, "Cannot emit a non WebApi Shape", lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
          break matchEnd8
        };
        var x = $m_s_None$();
        if ((x === x1$1)) {
          break matchEnd8
        };
        throw new $c_s_MatchError().init___O(x1$1)
      }
    }
  };
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(request, ordering, $as_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(this.spec$1)).emitters__sc_Seq());
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.operation$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ordering$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.endpointPayloadEmitted$2 ? 1231 : 1237));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.references$2));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 4)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasOperationPartEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.OasOperationPartEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasOperationPartEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasLikeOperationPartEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasOperationPartEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_domain_AbstractSecurityRequirementEmitter.call(this);
  this.requirement$2 = null;
  this.ordering$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_domain_AbstractSecurityRequirementEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityRequirement__Lamf_core_emitter_SpecOrdering = (function(requirement, ordering) {
  this.requirement$2 = requirement;
  this.ordering$2 = ordering;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter.prototype.productPrefix__T = (function() {
  return "OasSecurityRequirementEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var jsx$12 = b.builder$1;
  var sourceName = b.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var this$2 = this.requirement$2;
  $as_sc_Seq(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$().Schemes$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, eb) {
    return (function(parametrizedScheme$2) {
      var parametrizedScheme = $as_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme(parametrizedScheme$2);
      var fs = parametrizedScheme.fields$1;
      var x1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Settings$1);
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var f = $as_Lamf_core_parser_FieldEntry(x2.value$2);
        var x1$2 = f.value$1.value$1;
        if ((x1$2 instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings)) {
          var x2$2 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(x1$2);
          var this$8 = $as_sc_Seq(x2$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1)).headOption__s_Option().toList__sci_List();
          var f$1 = (function($this$1) {
            return (function(flow$2) {
              var flow = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow(flow$2);
              var jsx$2 = $as_sc_Seq(flow.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Scopes$1));
              var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2) {
                return (function(s$2) {
                  var s = $as_Lamf_plugins_domain_webapi_models_security_Scope(s$2);
                  var this$3 = $as_Lamf_core_model_StrField(s.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Name$1));
                  var this$4 = this$3.option$1;
                  return new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($as_T((this$4.isEmpty__Z() ? null : this$4.get__O())), s.annotations$1), $m_Lorg_yaml_model_YType$().Str$1)
                })
              })($this$1));
              var this$6 = $m_sc_Seq$();
              return $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2))
            })
          })($this);
          var this$7 = $m_sci_List$();
          var bf = this$7.ReusableCBFInstance$2;
          if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
            if ((this$8 === $m_sci_Nil$())) {
              var jsx$3 = $m_sci_Nil$()
            } else {
              var rest = this$8;
              var found = new $c_sr_BooleanRef().init___Z(false);
              var h = new $c_sr_ObjectRef().init___O(null);
              var t = new $c_sr_ObjectRef().init___O(null);
              while ((rest !== $m_sci_Nil$())) {
                var arg1 = rest.head__O();
                $as_sc_GenTraversableOnce(f$1(arg1)).seq__sc_TraversableOnce().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, found$1, h$1, t$1) {
                  return (function(b$2) {
                    if ((!found$1.elem$1)) {
                      h$1.elem$1 = new $c_sci_$colon$colon().init___O__sci_List(b$2, $m_sci_Nil$());
                      t$1.elem$1 = $as_sci_$colon$colon(h$1.elem$1);
                      found$1.elem$1 = true
                    } else {
                      var nx = new $c_sci_$colon$colon().init___O__sci_List(b$2, $m_sci_Nil$());
                      $as_sci_$colon$colon(t$1.elem$1).tl$5 = nx;
                      t$1.elem$1 = nx
                    }
                  })
                })(this$8, found, h, t)));
                rest = $as_sci_List(rest.tail__O())
              };
              var jsx$3 = ((!found.elem$1) ? $m_sci_Nil$() : $as_sci_$colon$colon(h.elem$1))
            }
          } else {
            $m_sci_List$();
            var b$3 = new $c_scm_ListBuffer().init___();
            var these = this$8;
            while ((!these.isEmpty__Z())) {
              var arg1$1 = these.head__O();
              var xs = $as_sc_GenTraversableOnce(f$1(arg1$1)).seq__sc_TraversableOnce();
              b$3.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(xs);
              these = $as_sci_List(these.tail__O())
            };
            var jsx$3 = b$3.toList__sci_List()
          };
          var scopes = $as_sc_Seq(jsx$3)
        } else if ((x1$2 instanceof $c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings)) {
          var x3 = $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(x1$2);
          var jsx$5 = $as_sc_Seq(x3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$().Scopes$1));
          var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
            return (function(s$2$1) {
              var s$1 = $as_Lamf_plugins_domain_webapi_models_security_Scope(s$2$1);
              var this$13 = $as_Lamf_core_model_StrField(s$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Name$1));
              var this$14 = this$13.option$1;
              return new $c_Lamf_core_emitter_BaseEmitters_package$ScalarEmitter().init___Lamf_core_model_domain_AmfScalar__Lorg_yaml_model_YType(new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($as_T((this$14.isEmpty__Z() ? null : this$14.get__O())), s$1.annotations$1), $m_Lorg_yaml_model_YType$().Str$1)
            })
          })($this));
          var this$16 = $m_sc_Seq$();
          var scopes = $as_sc_Seq(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$4, this$16.ReusableCBFInstance$2))
        } else {
          var scopes = $m_sci_Nil$()
        };
        $m_Lorg_yaml_model_YNode$();
        var this$17 = $as_Lamf_core_model_StrField(parametrizedScheme.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Name$1));
        var this$18 = this$17.option$1;
        var str = $as_T((this$18.isEmpty__Z() ? null : this$18.get__O()));
        var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
        var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(eb.sourceName$2);
        var jsx$7 = v.builder$1;
        var sourceName$1 = v.sourceName$2;
        var b$4 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$1);
        $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$PartBuilder__V($this.ordering$2.sorted__sc_Seq__sc_Seq(scopes), b$4);
        var jsx$6 = $m_Lorg_yaml_model_YNode$();
        $m_Lorg_yaml_model_YSequence$();
        var loc = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$1);
        var parts = b$4.builder$1;
        var node = jsx$6.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc, parts), $m_Lorg_yaml_model_YType$().Seq$1);
        jsx$7.$$plus$eq__O__scm_ArrayBuffer(node);
        var this$24 = v.builder$1;
        var array = [key];
        if ((this$24.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len = $uI(array.length);
        var newSize = ((this$24.size0$6 + len) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$24, newSize);
        var len$1 = this$24.size0$6;
        var src = this$24.array$6;
        var dest = this$24.array$6;
        $systemArraycopy(src, 0, dest, len, len$1);
        var xs$1 = this$24.array$6;
        var len$2 = xs$1.u.length;
        var i = 0;
        var j = 0;
        var x = $uI(array.length);
        var x$1 = ((x < len$2) ? x : len$2);
        var that = xs$1.u.length;
        var end = ((x$1 < that) ? x$1 : that);
        while ((i < end)) {
          var jsx$8 = j;
          var index = i;
          xs$1.set(jsx$8, array[index]);
          i = ((1 + i) | 0);
          j = ((1 + j) | 0)
        };
        this$24.size0$6 = newSize;
        eb.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
      } else {
        var x$2 = $m_s_None$();
        if ((x$2 === x1)) {
          $m_Lorg_yaml_model_YNode$();
          var this$35 = $as_Lamf_core_model_StrField(parametrizedScheme.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Name$1));
          var this$36 = this$35.option$1;
          var str$1 = $as_T((this$36.isEmpty__Z() ? null : this$36.get__O()));
          var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
          var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(eb.sourceName$2);
          var jsx$10 = v$1.builder$1;
          var sourceName$2 = v$1.sourceName$2;
          var b$5 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(sourceName$2);
          var jsx$9 = $m_Lorg_yaml_model_YNode$();
          $m_Lorg_yaml_model_YSequence$();
          var loc$1 = $m_Lorg_mulesoft_lexer_SourceLocation$().apply__T__Lorg_mulesoft_lexer_SourceLocation(sourceName$2);
          var parts$1 = b$5.builder$1;
          var node$1 = jsx$9.apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(new $c_Lorg_yaml_model_YSequence().init___Lorg_mulesoft_lexer_SourceLocation__sc_IndexedSeq(loc$1, parts$1), $m_Lorg_yaml_model_YType$().Seq$1);
          jsx$10.$$plus$eq__O__scm_ArrayBuffer(node$1);
          var this$42 = v$1.builder$1;
          var array$1 = [key$1];
          if ((this$42.size0$6 < 0)) {
            throw new $c_jl_IndexOutOfBoundsException().init___T("0")
          };
          var len$3 = $uI(array$1.length);
          var newSize$1 = ((this$42.size0$6 + len$3) | 0);
          $f_scm_ResizableArray__ensureSize__I__V(this$42, newSize$1);
          var len$4 = this$42.size0$6;
          var src$1 = this$42.array$6;
          var dest$1 = this$42.array$6;
          $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
          var xs$2 = this$42.array$6;
          var len$5 = xs$2.u.length;
          var i$1 = 0;
          var j$1 = 0;
          var x$3 = $uI(array$1.length);
          var x$4 = ((x$3 < len$5) ? x$3 : len$5);
          var that$1 = xs$2.u.length;
          var end$1 = ((x$4 < that$1) ? x$4 : that$1);
          while ((i$1 < end$1)) {
            var jsx$11 = j$1;
            var index$1 = i$1;
            xs$2.set(jsx$11, array$1[index$1]);
            i$1 = ((1 + i$1) | 0);
            j$1 = ((1 + j$1) | 0)
          };
          this$42.size0$6 = newSize$1;
          eb.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1))
        } else {
          throw new $c_s_MatchError().init___O(x1)
        }
      }
    })
  })(this, b$1)));
  jsx$12.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter)) {
    var OasSecurityRequirementEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter(x$1);
    var x = this.requirement$2;
    var x$2 = OasSecurityRequirementEmitter$1.requirement$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$2;
      var x$4 = OasSecurityRequirementEmitter$1.ordering$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.requirement$2;
      break
    }
    case 1: {
      return this.ordering$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.requirement$2.annotations$1;
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasSecurityRequirementEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.emitters.OasSecurityRequirementEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.emitters.OasSecurityRequirementEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_domain_AbstractSecurityRequirementEmitter: 1,
  O: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecurityRequirementEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter.call(this);
  this.securityScheme$2 = null;
  this.references$2 = null;
  this.ordering$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter.prototype.productPrefix__T = (function() {
  return "Raml08NamedSecuritySchemeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter)) {
    var Raml08NamedSecuritySchemeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter(x$1);
    var x = this.securityScheme$2;
    var x$2 = Raml08NamedSecuritySchemeEmitter$1.securityScheme$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.references$2;
      var x$4 = Raml08NamedSecuritySchemeEmitter$1.references$2;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.ordering$2;
      var x$6 = Raml08NamedSecuritySchemeEmitter$1.ordering$2;
      return (x$5 === x$6)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.securityScheme$2;
      break
    }
    case 1: {
      return this.references$2;
      break
    }
    case 2: {
      return this.ordering$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter.prototype.securitySchemeEmitter__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(securityScheme$2, references$2, ordering$2) {
      var securityScheme = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(securityScheme$2);
      var references = $as_sc_Seq(references$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08SecuritySchemeEmitter().init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(securityScheme, references, ordering, $this.spec$2)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(securityScheme, references, ordering, spec) {
  this.securityScheme$2 = securityScheme;
  this.references$2 = references;
  this.ordering$2 = ordering;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this, securityScheme, references, ordering, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.emitters.Raml08NamedSecuritySchemeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.emitters.Raml08NamedSecuritySchemeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.emitters.Raml08NamedSecuritySchemeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml08NamedSecuritySchemeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_DescribedByEmitter.call(this);
  this.key$2 = null;
  this.securityScheme$2 = null;
  this.ordering$2 = null;
  this.references$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_DescribedByEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter.prototype.productPrefix__T = (function() {
  return "Raml10DescribedByEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter)) {
    var Raml10DescribedByEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter(x$1);
    if ((this.key$2 === Raml10DescribedByEmitter$1.key$2)) {
      var x = this.securityScheme$2;
      var x$2 = Raml10DescribedByEmitter$1.securityScheme$2;
      var jsx$2 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$3 = this.ordering$2;
      var x$4 = Raml10DescribedByEmitter$1.ordering$2;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$2;
      var x$6 = Raml10DescribedByEmitter$1.references$2;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$2;
      break
    }
    case 1: {
      return this.securityScheme$2;
      break
    }
    case 2: {
      return this.ordering$2;
      break
    }
    case 3: {
      return this.references$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter.prototype.entries__Lamf_core_parser_Fields__sc_Seq = (function(fs) {
  var results = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().QueryString$1);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    var x1 = f.value$1.value$1;
    if ((x1 instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
      var x2 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x1);
      results.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlNamedTypeEmitter().init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__F5__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(x2, this.ordering$2, this.references$2, new $c_sjsr_AnonFunction5().init___sjs_js_Function5((function($this) {
        return (function(shape$2, ordering$2, annotations$2, ignored$2, references$2) {
          var shape = $as_Lamf_core_model_domain_Shape(shape$2);
          var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
          var annotations = $as_s_Option(annotations$2);
          var ignored = $as_sc_Seq(ignored$2);
          var references = $as_sc_Seq(references$2);
          return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_Raml10TypePartEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__s_Option__sc_Seq__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(shape, ordering, annotations, ignored, references, $this.spec$2)
        })
      })(this)), this.spec$2))
    }
  };
  results.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AnnotationsEmitter().init___Lamf_core_model_domain_DomainElement__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_SpecEmitterContext(this.securityScheme$2, this.ordering$2, this.spec$2).emitters__sc_Seq());
  var jsx$1 = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_DescribedByEmitter.prototype.entries__Lamf_core_parser_Fields__sc_Seq.call(this, fs);
  var this$2 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$1.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(results, this$2.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter.prototype.init___T__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(key, securityScheme, ordering, references, spec) {
  this.key$2 = key;
  this.securityScheme$2 = securityScheme;
  this.ordering$2 = ordering;
  this.references$2 = references;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_DescribedByEmitter.prototype.init___T__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this, key, securityScheme, ordering, references, spec);
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.emitters.Raml10DescribedByEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.emitters.Raml10DescribedByEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.emitters.Raml10DescribedByEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_DescribedByEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10DescribedByEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter.call(this);
  this.securityScheme$2 = null;
  this.references$2 = null;
  this.ordering$2 = null;
  this.spec$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter.prototype.productPrefix__T = (function() {
  return "Raml10NamedSecuritySchemeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter)) {
    var Raml10NamedSecuritySchemeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter(x$1);
    var x = this.securityScheme$2;
    var x$2 = Raml10NamedSecuritySchemeEmitter$1.securityScheme$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.references$2;
      var x$4 = Raml10NamedSecuritySchemeEmitter$1.references$2;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.ordering$2;
      var x$6 = Raml10NamedSecuritySchemeEmitter$1.ordering$2;
      return (x$5 === x$6)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.securityScheme$2;
      break
    }
    case 1: {
      return this.references$2;
      break
    }
    case 2: {
      return this.ordering$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter.prototype.securitySchemeEmitter__F3 = (function() {
  return new $c_sjsr_AnonFunction3().init___sjs_js_Function3((function($this) {
    return (function(securityScheme$2, references$2, ordering$2) {
      var securityScheme = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(securityScheme$2);
      var references = $as_sc_Seq(references$2);
      var ordering = $as_Lamf_core_emitter_SpecOrdering(ordering$2);
      return new $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10SecuritySchemeEmitter().init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(securityScheme, references, ordering, $this.spec$2)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(securityScheme, references, ordering, spec) {
  this.securityScheme$2 = securityScheme;
  this.references$2 = references;
  this.ordering$2 = ordering;
  this.spec$2 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityScheme__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this, securityScheme, references, ordering, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.emitters.Raml10NamedSecuritySchemeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.emitters.Raml10NamedSecuritySchemeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.emitters.Raml10NamedSecuritySchemeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_emitters_RamlNamedSecuritySchemeEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_emitters_Raml10NamedSecuritySchemeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken() {
  $c_O.call(this);
  this.value$1 = null;
  this.label$1 = null;
  this.rx$1 = null;
  this.followedBy$1 = null;
  this.extraValue$1 = null;
  this.possibleApplications$1 = null;
  this.next$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype.productPrefix__T = (function() {
  return "MethodBaseExpressionToken"
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken)) {
    var MethodBaseExpressionToken$1 = $as_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken(x$1);
    return (this.value$1 === MethodBaseExpressionToken$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype.nodeIsValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__nodeIsValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype.next__s_Option = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.next$lzycompute__p1__s_Option() : this.next$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype.completelyValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__completelyValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype.rx__s_util_matching_Regex = (function() {
  return this.rx$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype.extraValue__T = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.extraValue$lzycompute__p1__T() : this.extraValue$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype.extraValue$lzycompute__p1__T = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.extraValue$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__extraValue__T(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.extraValue$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype.init___T = (function(value) {
  this.value$1 = value;
  this.followedBy$1 = $m_sci_Nil$();
  this.label$1 = "$method";
  var this$2 = new $c_sci_StringOps().init___T("(\\$method)");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.rx$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype.followedBy__sc_Seq = (function() {
  return this.followedBy$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype.next$lzycompute__p1__s_Option = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.next$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__next__s_Option(this);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.next$1
});
function $as_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runtimeexpression.MethodBaseExpressionToken"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runtimeexpression.MethodBaseExpressionToken;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.MethodBaseExpressionToken", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_BaseLabeledExpressionToken: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_LabeledExpressionToken: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_MethodBaseExpressionToken;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression() {
  $c_O.call(this);
  this.value$1 = null;
  this.label$1 = null;
  this.rx$1 = null;
  this.followedBy$1 = null;
  this.extraValue$1 = null;
  this.possibleApplications$1 = null;
  this.next$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype.productPrefix__T = (function() {
  return "PathExpression"
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression)) {
    var PathExpression$1 = $as_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression(x$1);
    return (this.value$1 === PathExpression$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype.nodeIsValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__nodeIsValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype.next__s_Option = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.next$lzycompute__p1__s_Option() : this.next$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype.amf$plugins$document$webapi$validation$runtimeexpression$WithNameExpression$$undsetter$und$followedBy$und$eq__sc_Seq__V = (function(x$1) {
  this.followedBy$1 = x$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype.completelyValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__completelyValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype.rx__s_util_matching_Regex = (function() {
  return this.rx$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype.extraValue__T = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.extraValue$lzycompute__p1__T() : this.extraValue$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype.extraValue$lzycompute__p1__T = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.extraValue$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__extraValue__T(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.extraValue$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype.init___T = (function(value) {
  this.value$1 = value;
  $f_Lamf_plugins_document_webapi_validation_runtimeexpression_WithNameExpression__$$init$__V(this);
  this.label$1 = "path.";
  var this$2 = new $c_sci_StringOps().init___T("(path\\.).*");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.rx$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype.followedBy__sc_Seq = (function() {
  return this.followedBy$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype.next$lzycompute__p1__s_Option = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.next$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__next__s_Option(this);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.next$1
});
function $as_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runtimeexpression.PathExpression"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runtimeexpression.PathExpression;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.PathExpression", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_WithNameExpression: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_LabeledExpressionToken: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_PathExpression;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression() {
  $c_O.call(this);
  this.value$1 = null;
  this.label$1 = null;
  this.rx$1 = null;
  this.followedBy$1 = null;
  this.extraValue$1 = null;
  this.possibleApplications$1 = null;
  this.next$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype.productPrefix__T = (function() {
  return "QueryExpression"
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression)) {
    var QueryExpression$1 = $as_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression(x$1);
    return (this.value$1 === QueryExpression$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype.nodeIsValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__nodeIsValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype.next__s_Option = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.next$lzycompute__p1__s_Option() : this.next$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype.amf$plugins$document$webapi$validation$runtimeexpression$WithNameExpression$$undsetter$und$followedBy$und$eq__sc_Seq__V = (function(x$1) {
  this.followedBy$1 = x$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype.completelyValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__completelyValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype.rx__s_util_matching_Regex = (function() {
  return this.rx$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype.extraValue__T = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.extraValue$lzycompute__p1__T() : this.extraValue$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype.extraValue$lzycompute__p1__T = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.extraValue$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__extraValue__T(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.extraValue$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype.init___T = (function(value) {
  this.value$1 = value;
  $f_Lamf_plugins_document_webapi_validation_runtimeexpression_WithNameExpression__$$init$__V(this);
  this.label$1 = "query.";
  var this$2 = new $c_sci_StringOps().init___T("(query\\.).*");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.rx$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype.followedBy__sc_Seq = (function() {
  return this.followedBy$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype.next$lzycompute__p1__s_Option = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.next$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__next__s_Option(this);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.next$1
});
function $as_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runtimeexpression.QueryExpression"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runtimeexpression.QueryExpression;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.QueryExpression", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_WithNameExpression: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_LabeledExpressionToken: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_QueryExpression;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken() {
  $c_O.call(this);
  this.value$1 = null;
  this.label$1 = null;
  this.rx$1 = null;
  this.followedBy$1 = null;
  this.extraValue$1 = null;
  this.possibleApplications$1 = null;
  this.next$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype.productPrefix__T = (function() {
  return "RequestCodeBaseExpressionToken"
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken)) {
    var RequestCodeBaseExpressionToken$1 = $as_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken(x$1);
    return (this.value$1 === RequestCodeBaseExpressionToken$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype.nodeIsValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__nodeIsValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype.next__s_Option = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.next$lzycompute__p1__s_Option() : this.next$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype.completelyValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__completelyValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype.rx__s_util_matching_Regex = (function() {
  return this.rx$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype.amf$plugins$document$webapi$validation$runtimeexpression$WithSourceBaseExpression$$undsetter$und$followedBy$und$eq__sc_Seq__V = (function(x$1) {
  this.followedBy$1 = x$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype.extraValue__T = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.extraValue$lzycompute__p1__T() : this.extraValue$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype.extraValue$lzycompute__p1__T = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.extraValue$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__extraValue__T(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.extraValue$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype.init___T = (function(value) {
  this.value$1 = value;
  $f_Lamf_plugins_document_webapi_validation_runtimeexpression_WithSourceBaseExpression__$$init$__V(this);
  this.label$1 = "$request.";
  var this$2 = new $c_sci_StringOps().init___T("(\\$request\\.).*");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.rx$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype.followedBy__sc_Seq = (function() {
  return this.followedBy$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype.next$lzycompute__p1__s_Option = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.next$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__next__s_Option(this);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.next$1
});
function $as_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runtimeexpression.RequestCodeBaseExpressionToken"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runtimeexpression.RequestCodeBaseExpressionToken;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.RequestCodeBaseExpressionToken", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_WithSourceBaseExpression: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_LabeledExpressionToken: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_RequestCodeBaseExpressionToken;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken() {
  $c_O.call(this);
  this.value$1 = null;
  this.rx$1 = null;
  this.label$1 = null;
  this.followedBy$1 = null;
  this.extraValue$1 = null;
  this.possibleApplications$1 = null;
  this.next$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype.productPrefix__T = (function() {
  return "ResponseCodeBaseExpressionToken"
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken)) {
    var ResponseCodeBaseExpressionToken$1 = $as_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken(x$1);
    return (this.value$1 === ResponseCodeBaseExpressionToken$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype.nodeIsValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__nodeIsValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype.next__s_Option = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.next$lzycompute__p1__s_Option() : this.next$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype.completelyValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__completelyValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype.rx__s_util_matching_Regex = (function() {
  return this.rx$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype.amf$plugins$document$webapi$validation$runtimeexpression$WithSourceBaseExpression$$undsetter$und$followedBy$und$eq__sc_Seq__V = (function(x$1) {
  this.followedBy$1 = x$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype.extraValue__T = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.extraValue$lzycompute__p1__T() : this.extraValue$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype.extraValue$lzycompute__p1__T = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.extraValue$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__extraValue__T(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.extraValue$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype.init___T = (function(value) {
  this.value$1 = value;
  $f_Lamf_plugins_document_webapi_validation_runtimeexpression_WithSourceBaseExpression__$$init$__V(this);
  var this$2 = new $c_sci_StringOps().init___T("(\\$response\\.).*");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.rx$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  this.label$1 = "$response.";
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype.followedBy__sc_Seq = (function() {
  return this.followedBy$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype.next$lzycompute__p1__s_Option = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.next$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__next__s_Option(this);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.next$1
});
function $as_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runtimeexpression.ResponseCodeBaseExpressionToken"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runtimeexpression.ResponseCodeBaseExpressionToken;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.ResponseCodeBaseExpressionToken", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_WithSourceBaseExpression: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_LabeledExpressionToken: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_ResponseCodeBaseExpressionToken;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken() {
  $c_O.call(this);
  this.value$1 = null;
  this.label$1 = null;
  this.rx$1 = null;
  this.followedBy$1 = null;
  this.extraValue$1 = null;
  this.possibleApplications$1 = null;
  this.next$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype.productPrefix__T = (function() {
  return "StatusCodeBaseExpressionToken"
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken)) {
    var StatusCodeBaseExpressionToken$1 = $as_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken(x$1);
    return (this.value$1 === StatusCodeBaseExpressionToken$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype.nodeIsValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__nodeIsValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype.next__s_Option = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.next$lzycompute__p1__s_Option() : this.next$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype.completelyValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__completelyValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype.rx__s_util_matching_Regex = (function() {
  return this.rx$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype.extraValue__T = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.extraValue$lzycompute__p1__T() : this.extraValue$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype.extraValue$lzycompute__p1__T = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.extraValue$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__extraValue__T(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.extraValue$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype.init___T = (function(value) {
  this.value$1 = value;
  this.followedBy$1 = $m_sci_Nil$();
  this.label$1 = "$statusCode";
  var this$2 = new $c_sci_StringOps().init___T("(\\$statusCode)");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.rx$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype.followedBy__sc_Seq = (function() {
  return this.followedBy$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype.next$lzycompute__p1__s_Option = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.next$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__next__s_Option(this);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.next$1
});
function $as_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runtimeexpression.StatusCodeBaseExpressionToken"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runtimeexpression.StatusCodeBaseExpressionToken;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.StatusCodeBaseExpressionToken", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_BaseLabeledExpressionToken: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_LabeledExpressionToken: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_StatusCodeBaseExpressionToken;
/** @constructor */
function $c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken() {
  $c_O.call(this);
  this.value$1 = null;
  this.label$1 = null;
  this.rx$1 = null;
  this.followedBy$1 = null;
  this.extraValue$1 = null;
  this.possibleApplications$1 = null;
  this.next$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype.constructor = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken;
/** @constructor */
function $h_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype = $c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype;
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype.productPrefix__T = (function() {
  return "URLBaseExpressionToken"
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken)) {
    var URLBaseExpressionToken$1 = $as_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken(x$1);
    return (this.value$1 === URLBaseExpressionToken$1.value$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype.nodeIsValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__nodeIsValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.value$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype.next__s_Option = (function() {
  return (((((4 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.next$lzycompute__p1__s_Option() : this.next$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype.completelyValid__Z = (function() {
  return $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__completelyValid__Z(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype.rx__s_util_matching_Regex = (function() {
  return this.rx$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype.extraValue__T = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.extraValue$lzycompute__p1__T() : this.extraValue$1)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype.extraValue$lzycompute__p1__T = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.extraValue$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__extraValue__T(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.extraValue$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype.init___T = (function(value) {
  this.value$1 = value;
  this.followedBy$1 = $m_sci_Nil$();
  this.label$1 = "$url";
  var this$2 = new $c_sci_StringOps().init___T("(\\$url)");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  this.rx$1 = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  return this
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype.followedBy__sc_Seq = (function() {
  return this.followedBy$1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype.next$lzycompute__p1__s_Option = (function() {
  if (((((4 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.next$1 = $f_Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken__next__s_Option(this);
    this.bitmap$0$1 = (((4 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.next$1
});
function $as_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.validation.runtimeexpression.URLBaseExpressionToken"))
}
function $isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken)))
}
function $asArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.validation.runtimeexpression.URLBaseExpressionToken;", depth))
}
var $d_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken = new $TypeData().initClass({
  Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken: 0
}, false, "amf.plugins.document.webapi.validation.runtimeexpression.URLBaseExpressionToken", {
  Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken: 1,
  O: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_BaseLabeledExpressionToken: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_LabeledExpressionToken: 1,
  Lamf_plugins_document_webapi_validation_runtimeexpression_RuntimeParsingToken: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken.prototype.$classData = $d_Lamf_plugins_document_webapi_validation_runtimeexpression_URLBaseExpressionToken;
function $f_Lamf_plugins_domain_shapes_metamodel_ExampleModel__$$init$__V($thiz) {
  var jsx$4 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var jsx$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "displayName");
  var jsx$2 = $m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1;
  var jsx$1 = $m_sc_Seq$();
  var this$3 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "name").iri__T()];
  $thiz.DisplayName$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, jsx$3, new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq(jsx$2, "display name", "Human readable name for the term", $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))), true);
  var jsx$8 = $m_Lamf_core_metamodel_Type$Str$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var jsx$7 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "guiSummary");
  var jsx$6 = $m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1;
  var jsx$5 = $m_sc_Seq$();
  var this$9 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var array$1 = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$9, "description").iri__T()];
  $thiz.Summary$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$8, jsx$7, new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq(jsx$6, "gui summary", "Human readable description of the example", $as_sc_Seq(jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)))), true);
  var jsx$9 = $m_Lamf_core_metamodel_Type$Str$();
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  $thiz.Description$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$9, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "description"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "description", "", $m_sci_Nil$()), true);
  var jsx$10 = $m_Lamf_core_metamodel_Type$Str$();
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.ExternalValue$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$10, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "externalValue"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "external value", "Raw text containing an unparsable example", $m_sci_Nil$()), true);
  var jsx$11 = $m_Lamf_core_metamodel_domain_DataNodeModel$();
  var this$19 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.StructuredValue$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$11, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$19, "structuredValue"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "structured value", "Data structure containing the value of the example", $m_sci_Nil$()), true);
  var jsx$12 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$22 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  $thiz.Strict$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$12, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$22, "strict"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "strict", "Indicates if this example should be validated against an associated schema", $m_sci_Nil$()), true);
  var jsx$13 = $m_Lamf_core_metamodel_Type$Str$();
  var this$25 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  $thiz.MediaType$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$13, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$25, "mediaType"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "media type", "Media type associated to the example", $m_sci_Nil$()), true);
  $thiz.key$1 = $thiz.Name$1;
  $m_sci_List$();
  var array$2 = [$thiz.Name$1, $thiz.DisplayName$1, $thiz.Summary$1, $thiz.Description$1, $thiz.ExternalValue$1, $thiz.Strict$1, $thiz.MediaType$1, $thiz.StructuredValue$1];
  var i = (((-1) + $uI(array$2.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$31 = result;
    var index = i;
    var x = array$2[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$31);
    i = (((-1) + i) | 0)
  };
  var jsx$19 = result;
  var jsx$18 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$32 = $m_sci_List$();
  var jsx$17 = $as_sci_List(jsx$19.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$18, this$32.ReusableCBFInstance$2));
  var jsx$16 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().fields$1;
  var this$33 = $m_sci_List$();
  var jsx$15 = $as_sci_List(jsx$17.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$16, this$33.ReusableCBFInstance$2));
  var jsx$14 = $m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().fields$1;
  var this$34 = $m_sci_List$();
  $thiz.fields$1 = $as_sci_List(jsx$15.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$14, this$34.ReusableCBFInstance$2));
  var this$35 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$35, "Example");
  var this$37 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  $thiz.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$37);
  $thiz.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Example", "Example value for a schema inside an API", $m_sci_Nil$())
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_PropertyDependencies() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_PropertyDependencies;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_PropertyDependencies() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype = $c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype;
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.productPrefix__T = (function() {
  return "PropertyDependencies"
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_shapes_models_PropertyDependencies)) {
    var PropertyDependencies$1 = $as_Lamf_plugins_domain_shapes_models_PropertyDependencies(x$1);
    var x = this.fields$1;
    var x$2 = PropertyDependencies$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = PropertyDependencies$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$()
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$().PropertySource$1)).option$1;
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x = $as_T(arg1);
    var this$2 = new $c_s_Some().init___O(x)
  };
  var thiz = $as_T((this$2.isEmpty__Z() ? "unknown" : this$2.get__O()));
  var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "/", 0);
  var this$5 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
  var propertySourceName = $as_T($f_sc_IndexedSeqOptimized__last__O(this$5));
  return ("/dependency/" + propertySourceName)
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_domain_shapes_models_PropertyDependencies(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_models_PropertyDependencies) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.models.PropertyDependencies"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_models_PropertyDependencies(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_models_PropertyDependencies)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_models_PropertyDependencies(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_models_PropertyDependencies(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.models.PropertyDependencies;", depth))
}
var $d_Lamf_plugins_domain_shapes_models_PropertyDependencies = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_PropertyDependencies: 0
}, false, "amf.plugins.domain.shapes.models.PropertyDependencies", {
  Lamf_plugins_domain_shapes_models_PropertyDependencies: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_PropertyDependencies.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_PropertyDependencies;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_XMLSerializer() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_XMLSerializer;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_XMLSerializer() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype = $c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype;
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.productPrefix__T = (function() {
  return "XMLSerializer"
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_shapes_models_XMLSerializer)) {
    var XMLSerializer$1 = $as_Lamf_plugins_domain_shapes_models_XMLSerializer(x$1);
    var x = this.fields$1;
    var x$2 = XMLSerializer$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = XMLSerializer$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$()
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.componentId__T = (function() {
  return "/xml"
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_domain_shapes_models_XMLSerializer(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_models_XMLSerializer) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.models.XMLSerializer"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_models_XMLSerializer(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_models_XMLSerializer)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_models_XMLSerializer(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_models_XMLSerializer(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.models.XMLSerializer;", depth))
}
var $d_Lamf_plugins_domain_shapes_models_XMLSerializer = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_XMLSerializer: 0
}, false, "amf.plugins.domain.shapes.models.XMLSerializer", {
  Lamf_plugins_domain_shapes_models_XMLSerializer: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_XMLSerializer.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_XMLSerializer;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo() {
  $c_O.call(this);
  this.range$1 = null;
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo.prototype.constructor = $c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo.prototype = $c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo.prototype;
$c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo.prototype.productPrefix__T = (function() {
  return "ParameterBindingInBodyLexicalInfo"
});
$c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo)) {
    var ParameterBindingInBodyLexicalInfo$1 = $as_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo(x$1);
    var x = this.range$1;
    var x$2 = ParameterBindingInBodyLexicalInfo$1.range$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.range$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo.prototype.init___Lamf_core_parser_Range = (function(range) {
  this.range$1 = range;
  this.name$1 = "parameter-binding-in-body-lexical-info";
  this.value$1 = range.toString__T();
  return this
});
$c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.annotations.ParameterBindingInBodyLexicalInfo"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.annotations.ParameterBindingInBodyLexicalInfo;", depth))
}
var $d_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo: 0
}, false, "amf.plugins.domain.webapi.annotations.ParameterBindingInBodyLexicalInfo", {
  Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo.prototype.$classData = $d_Lamf_plugins_domain_webapi_annotations_ParameterBindingInBodyLexicalInfo;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint() {
  $c_O.call(this);
  this.reference$1 = null;
  this.name$1 = null;
  this.value$1 = null;
  this.parent$1 = null
}
$c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint.prototype.constructor = $c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_annotations_ParentEndPoint() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_annotations_ParentEndPoint.prototype = $c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint.prototype;
$c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint.prototype.productPrefix__T = (function() {
  return "ParentEndPoint"
});
$c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint)) {
    var ParentEndPoint$1 = $as_Lamf_plugins_domain_webapi_annotations_ParentEndPoint(x$1);
    return (this.reference$1 === ParentEndPoint$1.reference$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.reference$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint.prototype.init___T = (function(reference) {
  this.reference$1 = reference;
  this.name$1 = "parent-end-point";
  this.value$1 = reference;
  this.parent$1 = $m_s_None$();
  return this
});
$c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint.prototype.resolve__sci_Map__V = (function(objects) {
  if (this.parent$1.isEmpty__Z()) {
    var x1 = objects.get__O__s_Option(this.reference$1);
    matchEnd5: {
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var e = $as_Lamf_core_model_domain_AmfElement(x2.value$2);
        if ((e instanceof $c_Lamf_plugins_domain_webapi_models_EndPoint)) {
          var x3 = $as_Lamf_plugins_domain_webapi_models_EndPoint(e);
          this.parent$1 = new $c_s_Some().init___O(x3);
          break matchEnd5
        }
      }
    }
  }
});
$c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_domain_webapi_annotations_ParentEndPoint(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.annotations.ParentEndPoint"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_annotations_ParentEndPoint(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_annotations_ParentEndPoint)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_annotations_ParentEndPoint(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_annotations_ParentEndPoint(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.annotations.ParentEndPoint;", depth))
}
var $d_Lamf_plugins_domain_webapi_annotations_ParentEndPoint = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_annotations_ParentEndPoint: 0
}, false, "amf.plugins.domain.webapi.annotations.ParentEndPoint", {
  Lamf_plugins_domain_webapi_annotations_ParentEndPoint: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_ResolvableAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_annotations_ParentEndPoint.prototype.$classData = $d_Lamf_plugins_domain_webapi_annotations_ParentEndPoint;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo() {
  $c_O.call(this);
  this.range$1 = null;
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo.prototype.constructor = $c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo.prototype = $c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo.prototype;
$c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo.prototype.productPrefix__T = (function() {
  return "TypePropertyLexicalInfo"
});
$c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo)) {
    var TypePropertyLexicalInfo$1 = $as_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo(x$1);
    var x = this.range$1;
    var x$2 = TypePropertyLexicalInfo$1.range$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.range$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo.prototype.init___Lamf_core_parser_Range = (function(range) {
  this.range$1 = range;
  this.name$1 = "type-property-lexical-info";
  this.value$1 = range.toString__T();
  return this
});
$c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.annotations.TypePropertyLexicalInfo"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.annotations.TypePropertyLexicalInfo;", depth))
}
var $d_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo: 0
}, false, "amf.plugins.domain.webapi.annotations.TypePropertyLexicalInfo", {
  Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo.prototype.$classData = $d_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$() {
  $c_O.call(this);
  this.Location$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Description$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Location$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "location"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "location", "Structural location of a piece of information", $m_sci_Nil$()), true);
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "CorrelationId");
  var this$6 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$6);
  var x$4 = this.Name$1;
  var x$3 = this.Description$1;
  var x$2 = this.Location$1;
  var jsx$3 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().fields$1;
  var jsx$2 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$7 = $m_sci_List$();
  var this$8 = $as_sci_List(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$7.ReusableCBFInstance$2));
  var this$9 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$8);
  var this$10 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$9);
  this.fields$1 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$10);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "CorrelationId", "Model defining an identifier that can used for message tracing and correlation", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_CorrelationId().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.CorrelationIdModel$", {
  Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_EndPointModel$() {
  $c_O.call(this);
  this.Path$1 = null;
  this.Summary$1 = null;
  this.Operations$1 = null;
  this.Parameters$1 = null;
  this.Payloads$1 = null;
  this.Servers$1 = null;
  this.Security$1 = null;
  this.Bindings$1 = null;
  this.key$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.Description$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_EndPointModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_EndPointModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_EndPointModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_EndPointModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_EndPointModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_EndPointModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_EndPointModel$.prototype.Extends$lzycompute__p1__Lamf_core_metamodel_Field = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.Extends$1 = $f_Lamf_core_metamodel_domain_DomainElementModel__Extends__Lamf_core_metamodel_Field(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.Extends$1
});
$c_Lamf_plugins_domain_webapi_metamodel_EndPointModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_EndPointModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Path$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "path"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "path", "Path template for an endpoint", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Summary$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "summary"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "summary", "Human readable short description of the endpoint", $m_sci_Nil$()), true);
  var jsx$3 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$());
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Operations$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "supportedOperation"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "supported operation", "Operations supported by an endpoint", $m_sci_Nil$()), true);
  var jsx$4 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$());
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Parameters$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "parameter"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "parameter", "Additional data required or returned by an operation", $m_sci_Nil$()), true);
  var jsx$5 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$());
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Payloads$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "payload"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "payload", "Main payload data required or returned by an operation", $m_sci_Nil$()), true);
  var jsx$6 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$());
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Servers$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$6, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "server"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "servers", "Specific information about the server where the endpoint is accessible", $m_sci_Nil$()), true);
  var jsx$7 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$());
  var this$19 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.Security$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$7, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$19, "security"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "security", "Textual indication of the kind of security scheme used", $m_sci_Nil$()), true);
  var jsx$8 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$();
  var this$22 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Bindings$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$8, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$22, "binding"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "binding", "Bindings for this endpoint", $m_sci_Nil$()), true);
  this.key$1 = this.Path$1;
  var this$25 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$25, "EndPoint");
  var this$27 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$27);
  $m_sci_List$();
  var array = [this.Path$1, this.Name$1, this.Summary$1, this.Description$1, this.Operations$1, this.Parameters$1, this.Payloads$1, this.Servers$1, this.Security$1, this.Bindings$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$31 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$31);
    i = (((-1) + i) | 0)
  };
  var jsx$10 = result;
  var jsx$9 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$32 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$10.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$9, this$32.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "EndPoint", "EndPoint in the API holding a number of executable operations", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_EndPointModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_EndPointModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_EndPointModel$.prototype.Extends__Lamf_core_metamodel_Field = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.Extends$lzycompute__p1__Lamf_core_metamodel_Field() : this.Extends$1)
});
$c_Lamf_plugins_domain_webapi_metamodel_EndPointModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_EndPointModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_metamodel_EndPointModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_EndPointModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_EndPointModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_EndPointModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_EndPoint().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_EndPointModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_EndPointModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_EndPointModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_EndPointModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.EndPointModel$", {
  Lamf_plugins_domain_webapi_metamodel_EndPointModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_EndPointModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_EndPointModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_EndPointModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_EndPointModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_EndPointModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_EndPointModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$() {
  $c_O.call(this);
  this.Template$1 = null;
  this.OperationId$1 = null;
  this.OperationRef$1 = null;
  this.Mapping$1 = null;
  this.RequestBody$1 = null;
  this.Server$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.Description$1 = null;
  this.Name$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Template$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "template"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "template", "URL template for a templated link", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.OperationId$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "operationId"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "operation ID", "Identifier of the target operation", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_core_metamodel_Type$Str$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.OperationRef$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "operationRef"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "operation Ref", "Reference of the target operation", $m_sci_Nil$()), true);
  var jsx$4 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$());
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Mapping$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "mapping"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "mapping", "Variable mapping for the URL template", $m_sci_Nil$()), true);
  var jsx$5 = $m_Lamf_core_metamodel_Type$Str$();
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.RequestBody$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "requestBody"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "request body", "", $m_sci_Nil$()), true);
  var jsx$6 = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$();
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Server$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$6, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "server"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "server", "", $m_sci_Nil$()), true);
  var this$19 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$19, "TemplatedLink");
  var this$21 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$21);
  var x$8 = this.Name$1;
  var x$7 = this.Template$1;
  var x$6 = this.OperationId$1;
  var x$5 = this.Mapping$1;
  var x$4 = this.RequestBody$1;
  var x$3 = this.Description$1;
  var x$2 = this.Server$1;
  var jsx$8 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var jsx$7 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().fields$1;
  var this$22 = $m_sci_List$();
  var this$23 = $as_sci_List(jsx$8.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$7, this$22.ReusableCBFInstance$2));
  var this$24 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$23);
  var this$25 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$24);
  var this$26 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$25);
  var this$27 = new $c_sci_$colon$colon().init___O__sci_List(x$5, this$26);
  var this$28 = new $c_sci_$colon$colon().init___O__sci_List(x$6, this$27);
  var this$29 = new $c_sci_$colon$colon().init___O__sci_List(x$7, this$28);
  this.fields$1 = new $c_sci_$colon$colon().init___O__sci_List(x$8, this$29);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Templated Link", "Templated link containing URL template and variables mapping", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_TemplatedLink().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.TemplatedLinkModel$", {
  Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_WebApiModel$() {
  $c_O.call(this);
  this.Servers$1 = null;
  this.Accepts$1 = null;
  this.ContentType$1 = null;
  this.Identifier$1 = null;
  this.Schemes$1 = null;
  this.Version$1 = null;
  this.TermsOfService$1 = null;
  this.Provider$1 = null;
  this.License$1 = null;
  this.Documentations$1 = null;
  this.EndPoints$1 = null;
  this.Security$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Tags$1 = null;
  this.Description$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_WebApiModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_WebApiModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_WebApiModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_WebApiModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_WebApiModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_WebApiModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_WebApiModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_WebApiModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_TagsModel__$$init$__V(this);
  var jsx$1 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$());
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Servers$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "server"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "server", "server information", $m_sci_Nil$()), true);
  var jsx$2 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Str$());
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Accepts$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "accepts"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "accepts", "Media-types accepted in a API request", $m_sci_Nil$()), true);
  var jsx$3 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Str$());
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.ContentType$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "contentType"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "content type", "Media types returned by a API response", $m_sci_Nil$()), true);
  var jsx$4 = $m_Lamf_core_metamodel_Type$Str$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Identifier$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "identifier"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "identifier", "The identifier property represents any kind of identifier, such as ISBNs, GTIN codes, UUIDs, etc.", $m_sci_Nil$()), true);
  var jsx$5 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Str$());
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Schemes$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "scheme"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "scheme", "URI scheme for the API protocol", $m_sci_Nil$()), true);
  var jsx$6 = $m_Lamf_core_metamodel_Type$Str$();
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Version$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$6, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "version"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "version", "Version of the API", $m_sci_Nil$()), true);
  var jsx$7 = $m_Lamf_core_metamodel_Type$Str$();
  var this$19 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.TermsOfService$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$7, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$19, "termsOfService"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "terms of service", "Terms and conditions when using the API", $m_sci_Nil$()), true);
  var jsx$8 = $m_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$();
  var this$22 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Provider$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$8, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$22, "provider"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "provider", "Organization providing some kind of asset or service", $m_sci_Nil$()), true);
  var jsx$9 = $m_Lamf_plugins_domain_webapi_metamodel_LicenseModel$();
  var this$25 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.License$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$9, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$25, "license"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "license", "License for the API", $m_sci_Nil$()), true);
  var jsx$10 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$());
  var this$28 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Documentations$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$10, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$28, "documentation"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "documentation", "Documentation associated to the API", $m_sci_Nil$()), true);
  var jsx$11 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$());
  var this$31 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.EndPoints$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$11, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$31, "endpoint"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "endpoint", "End points defined in the API", $m_sci_Nil$()), true);
  var jsx$12 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$());
  var this$34 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.Security$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$12, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$34, "security"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "security", "Textual indication of the kind of security scheme used", $m_sci_Nil$()), true);
  var this$37 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$37, "WebAPI");
  var this$39 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$39, "RootDomainElement");
  var this$41 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  var this$42 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$41);
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$42);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Web API", "Top level element describing a HTTP API", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_WebApiModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_WebApiModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_WebApiModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_WebApiModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Name$1, this.Description$1, this.Identifier$1, this.Servers$1, this.Accepts$1, this.ContentType$1, this.Schemes$1, this.Version$1, this.TermsOfService$1, this.Provider$1, this.License$1, this.Documentations$1, this.EndPoints$1, this.Security$1, this.Tags$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_WebApiModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_WebApiModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_WebApiModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_WebApi().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_WebApiModel$.prototype.amf$plugins$domain$webapi$metamodel$TagsModel$$undsetter$und$Tags$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Tags$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_WebApiModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_WebApiModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_WebApiModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_WebApiModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.WebApiModel$", {
  Lamf_plugins_domain_webapi_metamodel_WebApiModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1,
  Lamf_plugins_domain_webapi_metamodel_TagsModel: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_WebApiModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_WebApiModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_WebApiModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_WebApiModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_WebApiModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_WebApiModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.key$1 = null;
  this.doc$1 = null;
  this.Type$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingType__$$init$__V(this);
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "ChannelBinding");
  var this$3 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$3);
  this.key$1 = this.Type$1;
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "ChannelBinding", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingType$$undsetter$und$Type$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Type$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Type$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$.prototype.modelInstance__sr_Nothing$ = (function() {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("ChannelBinding is an abstract class"))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  this.modelInstance__sr_Nothing$()
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.ChannelBindingModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingType: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.key$1 = null;
  this.doc$1 = null;
  this.Type$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingType__$$init$__V(this);
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "MessageBinding");
  var this$3 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$3);
  this.key$1 = this.Type$1;
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "MessageBinding", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingType$$undsetter$und$Type$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Type$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Type$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$.prototype.modelInstance__sr_Nothing$ = (function() {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("MessageBinding is an abstract class"))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  this.modelInstance__sr_Nothing$()
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.MessageBindingModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingType: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.key$1 = null;
  this.doc$1 = null;
  this.Type$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingType__$$init$__V(this);
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "OperationBinding");
  var this$3 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$3);
  this.key$1 = this.Type$1;
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "OperationBinding", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingType$$undsetter$und$Type$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Type$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Type$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$.prototype.modelInstance__sr_Nothing$ = (function() {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("OperationBinding is an abstract class"))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  this.modelInstance__sr_Nothing$()
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.OperationBindingModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingType: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.key$1 = null;
  this.doc$1 = null;
  this.Type$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingType__$$init$__V(this);
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "ServerBinding");
  var this$3 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$3);
  this.key$1 = this.Type$1;
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "ServerBinding", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingType$$undsetter$und$Type$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Type$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Type$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$.prototype.modelInstance__sr_Nothing$ = (function() {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("ServerBinding is an abstract class"))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  this.modelInstance__sr_Nothing$()
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.ServerBindingModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingType: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.doc$1 = null;
  this.Target$1 = null;
  this.Variables$1 = null;
  this.key$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel__$$init$__V(this);
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "ParametrizedResourceType");
  var this$3 = $m_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$3);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Parametrized Resource Type", "RAML resource type that can accept parameters", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$.prototype.Target__Lamf_core_metamodel_Field = (function() {
  return this.Target$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$.prototype.Variables__Lamf_core_metamodel_Field = (function() {
  return this.Variables$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$.prototype.fields__sci_List = (function() {
  return $f_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel__fields__sci_List(this)
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$.prototype.amf$core$metamodel$domain$templates$ParametrizedDeclarationModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$.prototype.amf$core$metamodel$domain$templates$ParametrizedDeclarationModel$$undsetter$und$key$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.key$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$.prototype.amf$core$metamodel$domain$templates$ParametrizedDeclarationModel$$undsetter$und$Variables$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Variables$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$.prototype.Name__Lamf_core_metamodel_Field = (function() {
  return this.Name$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.templates.ParametrizedResourceTypeModel$", {
  Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.doc$1 = null;
  this.Target$1 = null;
  this.Variables$1 = null;
  this.key$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel__$$init$__V(this);
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "ParametrizedTrait");
  var this$3 = $m_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$3);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Parametrized Trait", "RAML trait with declared parameters", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$.prototype.Target__Lamf_core_metamodel_Field = (function() {
  return this.Target$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$.prototype.Variables__Lamf_core_metamodel_Field = (function() {
  return this.Variables$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$.prototype.fields__sci_List = (function() {
  return $f_Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel__fields__sci_List(this)
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$.prototype.amf$core$metamodel$domain$templates$ParametrizedDeclarationModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$.prototype.amf$core$metamodel$domain$templates$ParametrizedDeclarationModel$$undsetter$und$key$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.key$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$.prototype.amf$core$metamodel$domain$templates$ParametrizedDeclarationModel$$undsetter$und$Variables$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Variables$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$.prototype.Name__Lamf_core_metamodel_Field = (function() {
  return this.Name$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.templates.ParametrizedTraitModel$", {
  Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_templates_ParametrizedDeclarationModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_Encoding() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_Encoding;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_Encoding() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_Encoding.prototype = $c_Lamf_plugins_domain_webapi_models_Encoding.prototype;
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.productPrefix__T = (function() {
  return "Encoding"
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_Encoding)) {
    var Encoding$1 = $as_Lamf_plugins_domain_webapi_models_Encoding(x$1);
    var x = this.fields$1;
    var x$2 = Encoding$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = Encoding$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.withHeader__T__Lamf_plugins_domain_webapi_models_Parameter = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_Parameter().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var result = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().Headers$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$()
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().PropertyName$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-encoding" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_domain_webapi_models_Encoding(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_Encoding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.Encoding"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_Encoding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_Encoding)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_Encoding(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_Encoding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.Encoding;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_Encoding = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_Encoding: 0
}, false, "amf.plugins.domain.webapi.models.Encoding", {
  Lamf_plugins_domain_webapi_models_Encoding: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_Encoding.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_Encoding;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_IriTemplateMapping() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_IriTemplateMapping;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_IriTemplateMapping() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype = $c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype;
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.productPrefix__T = (function() {
  return "IriTemplateMapping"
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_IriTemplateMapping)) {
    var IriTemplateMapping$1 = $as_Lamf_plugins_domain_webapi_models_IriTemplateMapping(x$1);
    var x = this.fields$1;
    var x$2 = IriTemplateMapping$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = IriTemplateMapping$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$()
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$().TemplateVariable$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "unknownVar" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/mapping/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_domain_webapi_models_IriTemplateMapping(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_IriTemplateMapping) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.IriTemplateMapping"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_IriTemplateMapping(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_IriTemplateMapping)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_IriTemplateMapping(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_IriTemplateMapping(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.IriTemplateMapping;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_IriTemplateMapping = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_IriTemplateMapping: 0
}, false, "amf.plugins.domain.webapi.models.IriTemplateMapping", {
  Lamf_plugins_domain_webapi_models_IriTemplateMapping: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_IriTemplateMapping.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_IriTemplateMapping;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_Parameter() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_Parameter;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_Parameter() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_Parameter.prototype = $c_Lamf_plugins_domain_webapi_models_Parameter.prototype;
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.withPayload__T__Lamf_plugins_domain_webapi_models_Payload = (function(mediaType) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_Payload().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1;
  var result = $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, mediaType));
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Payloads$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field$1, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.linkCopy__Lamf_plugins_domain_webapi_models_Parameter = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_Parameter().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  var copy = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value));
  var this$5 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1)).option$1;
  if ((!this$5.isEmpty__Z())) {
    var arg1 = this$5.get__O();
    var binding = $as_T(arg1);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
    $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(copy, field, binding))
  };
  return copy
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_plugins_domain_webapi_models_Parameter()
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$()
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-parameter" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/parameter/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.withObjectSchema__T__Lamf_plugins_domain_shapes_models_NodeShape = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_shapes_models_NodeShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var node = $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, node);
  return node
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.withScalarSchema__T__Lamf_plugins_domain_shapes_models_ScalarShape = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_shapes_models_ScalarShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var scalar = $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, scalar);
  return scalar
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.schema__Lamf_core_model_domain_Shape = (function() {
  return $as_Lamf_core_model_domain_Shape(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1))
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_Parameter().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.setSchema__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape = (function(shape) {
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, shape);
  return shape
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.cloneParameter__T__Lamf_plugins_domain_webapi_models_Parameter = (function(parent) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(this.annotations$1);
  var parameter = new $c_Lamf_plugins_domain_webapi_models_Parameter().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var this$3 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
  var this$4 = this$3.option$1;
  var name = $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()));
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(parameter, name, a));
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var cloned = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, parent));
  var this$6 = this.fields$1;
  var fn = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, cloned$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var f = $as_Lamf_core_metamodel_Field(x0$1.$$und1__O());
        var v = $as_Lamf_core_parser_Value(x0$1.$$und2__O());
        var x1$2 = v.value$1;
        if ((x1$2 instanceof $c_Lamf_core_model_domain_Shape)) {
          var x2 = $as_Lamf_core_model_domain_Shape(x1$2);
          var clonedValue = x2.cloneShape__s_Option__s_Option__Lamf_core_traversal_ModelTraversalRegistry__Z__Lamf_core_model_domain_Shape($m_s_None$(), x2.cloneShape$default$2__s_Option(), x2.cloneShape$default$3__Lamf_core_traversal_ModelTraversalRegistry(), x2.cloneShape$default$4__Z())
        } else {
          var clonedValue = x1$2
        };
        var annotations$1 = v.annotations$1;
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(cloned$1, f, clonedValue, annotations$1)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })(this, cloned));
  this$6.fs$1.foreach__F1__V(fn);
  return cloned
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_Parameter(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_Parameter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.Parameter"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_Parameter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_Parameter)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_Parameter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_Parameter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.Parameter;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_Parameter = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_Parameter: 0
}, false, "amf.plugins.domain.webapi.models.Parameter", {
  Lamf_plugins_domain_webapi_models_Parameter: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_plugins_domain_webapi_models_SchemaContainer: 1,
  Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement: 1
});
$c_Lamf_plugins_domain_webapi_models_Parameter.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_Parameter;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_Request() {
  $c_Lamf_plugins_domain_webapi_models_Message.call(this);
  this.fields$2 = null;
  this.annotations$2 = null
}
$c_Lamf_plugins_domain_webapi_models_Request.prototype = new $h_Lamf_plugins_domain_webapi_models_Message();
$c_Lamf_plugins_domain_webapi_models_Request.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_Request;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_Request() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_Request.prototype = $c_Lamf_plugins_domain_webapi_models_Request.prototype;
$c_Lamf_plugins_domain_webapi_models_Request.prototype.withCookieParameter__T__Lamf_plugins_domain_webapi_models_Parameter = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_Parameter().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var result = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().CookieParameters$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_Request.prototype.withHeader__T__Lamf_plugins_domain_webapi_models_Parameter = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_Parameter().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var result = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Headers$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_Request.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_Request().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_Request($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_webapi_models_Request.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$()
});
$c_Lamf_plugins_domain_webapi_models_Request.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_plugins_domain_webapi_models_Request.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "request" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_webapi_models_Request.prototype.withQueryParameter__T__Lamf_plugins_domain_webapi_models_Parameter = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_Parameter().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var result = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryParameters$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_Request.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annot$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annot = $as_Lamf_core_parser_Annotations(annot$2);
      return new $c_Lamf_plugins_domain_webapi_models_Request().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annot)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_Request.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_plugins_domain_webapi_models_Request.prototype.linkCopy__Lamf_plugins_domain_webapi_models_Message = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_Request().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_Request($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_webapi_models_Request.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$2 = fields;
  this.annotations$2 = annotations;
  $c_Lamf_plugins_domain_webapi_models_Message.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  return this
});
$c_Lamf_plugins_domain_webapi_models_Request.prototype.withUriParameter__T__Lamf_plugins_domain_webapi_models_Parameter = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_Parameter().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var result = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().UriParameters$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, result);
  return result
});
function $as_Lamf_plugins_domain_webapi_models_Request(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_Request) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.Request"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_Request(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_Request)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_Request(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_Request(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.Request;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_Request = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_Request: 0
}, false, "amf.plugins.domain.webapi.models.Request", {
  Lamf_plugins_domain_webapi_models_Request: 1,
  Lamf_plugins_domain_webapi_models_Message: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement: 1,
  Lamf_core_model_domain_Linkable: 1
});
$c_Lamf_plugins_domain_webapi_models_Request.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_Request;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_Response() {
  $c_Lamf_plugins_domain_webapi_models_Message.call(this);
  this.fields$2 = null;
  this.annotations$2 = null
}
$c_Lamf_plugins_domain_webapi_models_Response.prototype = new $h_Lamf_plugins_domain_webapi_models_Message();
$c_Lamf_plugins_domain_webapi_models_Response.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_Response;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_Response() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_Response.prototype = $c_Lamf_plugins_domain_webapi_models_Response.prototype;
$c_Lamf_plugins_domain_webapi_models_Response.prototype.withHeader__T__Lamf_plugins_domain_webapi_models_Parameter = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_Parameter().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var result = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Headers$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_Response.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$()
});
$c_Lamf_plugins_domain_webapi_models_Response.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_Response().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_webapi_models_Response.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_plugins_domain_webapi_models_Response.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-response" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_webapi_models_Response.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_Response().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_Response.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_plugins_domain_webapi_models_Response.prototype.linkCopy__Lamf_plugins_domain_webapi_models_Message = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_Response().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_webapi_models_Response.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Name$1
});
$c_Lamf_plugins_domain_webapi_models_Response.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$2 = fields;
  this.annotations$2 = annotations;
  $c_Lamf_plugins_domain_webapi_models_Message.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_Response(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_Response) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.Response"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_Response(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_Response)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_Response(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_Response(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.Response;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_Response = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_Response: 0
}, false, "amf.plugins.domain.webapi.models.Response", {
  Lamf_plugins_domain_webapi_models_Response: 1,
  Lamf_plugins_domain_webapi_models_Message: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement: 1,
  Lamf_core_model_domain_Linkable: 1
});
$c_Lamf_plugins_domain_webapi_models_Response.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_Response;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_Server() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_Server.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_Server.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_Server;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_Server() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_Server.prototype = $c_Lamf_plugins_domain_webapi_models_Server.prototype;
$c_Lamf_plugins_domain_webapi_models_Server.prototype.productPrefix__T = (function() {
  return "Server"
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_Server)) {
    var Server$1 = $as_Lamf_plugins_domain_webapi_models_Server(x$1);
    var x = this.fields$1;
    var x$2 = Server$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = Server$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$()
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.withSecurity__T__Lamf_plugins_domain_webapi_models_security_SecurityRequirement = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$().Name$1;
  var result = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, name));
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Security$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field$1, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Url$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? null : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.withVariable__T__Lamf_plugins_domain_webapi_models_Parameter = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_Parameter().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var result = $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Variables$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_domain_webapi_models_Server(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_Server) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.Server"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_Server(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_Server)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_Server(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_Server(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.Server;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_Server = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_Server: 0
}, false, "amf.plugins.domain.webapi.models.Server", {
  Lamf_plugins_domain_webapi_models_Server: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_Server.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_Server;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype = $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype;
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$()
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.componentId__T = (function() {
  return "/amqp091-channel"
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.key__Lamf_core_model_StrField = (function() {
  return $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$().key$1))
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.bindingVersionField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$().BindingVersion$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.amqp.Amqp091ChannelBinding"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.amqp.Amqp091ChannelBinding;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding: 0
}, false, "amf.plugins.domain.webapi.models.bindings.amqp.Amqp091ChannelBinding", {
  Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding: 1,
  O: 1,
  Lamf_plugins_domain_webapi_models_bindings_ChannelBinding: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_plugins_domain_webapi_models_bindings_BindingVersion: 1,
  Lamf_plugins_domain_webapi_models_Key: 1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype = $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype;
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$()
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.componentId__T = (function() {
  return "/amqp091-message"
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.key__Lamf_core_model_StrField = (function() {
  return $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$().key$1))
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.bindingVersionField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$().BindingVersion$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.amqp.Amqp091MessageBinding"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.amqp.Amqp091MessageBinding;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding: 0
}, false, "amf.plugins.domain.webapi.models.bindings.amqp.Amqp091MessageBinding", {
  Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding: 1,
  O: 1,
  Lamf_plugins_domain_webapi_models_bindings_MessageBinding: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_plugins_domain_webapi_models_bindings_BindingVersion: 1,
  Lamf_plugins_domain_webapi_models_Key: 1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype = $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype;
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$()
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.componentId__T = (function() {
  return "/amqp091-operation"
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.key__Lamf_core_model_StrField = (function() {
  return $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().key$1))
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.bindingVersionField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().BindingVersion$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.amqp.Amqp091OperationBinding"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.amqp.Amqp091OperationBinding;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding: 0
}, false, "amf.plugins.domain.webapi.models.bindings.amqp.Amqp091OperationBinding", {
  Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding: 1,
  O: 1,
  Lamf_plugins_domain_webapi_models_bindings_OperationBinding: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_plugins_domain_webapi_models_bindings_BindingVersion: 1,
  Lamf_plugins_domain_webapi_models_Key: 1
});
$c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype = $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype;
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$()
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.componentId__T = (function() {
  return "/http-message"
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.key__Lamf_core_model_StrField = (function() {
  return $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$().key$1))
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.bindingVersionField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$().BindingVersion$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.http.HttpMessageBinding"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.http.HttpMessageBinding;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding: 0
}, false, "amf.plugins.domain.webapi.models.bindings.http.HttpMessageBinding", {
  Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding: 1,
  O: 1,
  Lamf_plugins_domain_webapi_models_bindings_MessageBinding: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_plugins_domain_webapi_models_bindings_BindingVersion: 1,
  Lamf_plugins_domain_webapi_models_Key: 1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype = $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype;
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$()
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.componentId__T = (function() {
  return "/http-operation"
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.key__Lamf_core_model_StrField = (function() {
  return $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$().key$1))
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.bindingVersionField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$().BindingVersion$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.http.HttpOperationBinding"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.http.HttpOperationBinding;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding: 0
}, false, "amf.plugins.domain.webapi.models.bindings.http.HttpOperationBinding", {
  Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding: 1,
  O: 1,
  Lamf_plugins_domain_webapi_models_bindings_OperationBinding: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_plugins_domain_webapi_models_bindings_BindingVersion: 1,
  Lamf_plugins_domain_webapi_models_Key: 1
});
$c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype = $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype;
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$()
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.componentId__T = (function() {
  return "/kafka-message"
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.key__Lamf_core_model_StrField = (function() {
  return $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$().key$1))
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.bindingVersionField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$().BindingVersion$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.kafka.KafkaMessageBinding"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.kafka.KafkaMessageBinding;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding: 0
}, false, "amf.plugins.domain.webapi.models.bindings.kafka.KafkaMessageBinding", {
  Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding: 1,
  O: 1,
  Lamf_plugins_domain_webapi_models_bindings_MessageBinding: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_plugins_domain_webapi_models_bindings_BindingVersion: 1,
  Lamf_plugins_domain_webapi_models_Key: 1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.key$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype = $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype;
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$()
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.componentId__T = (function() {
  return "/kafka-operation"
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.key__Lamf_core_model_StrField = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.bindingVersionField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$().BindingVersion$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  this.key$1 = $as_Lamf_core_model_StrField(fields.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$().key$1));
  return this
});
function $as_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.kafka.KafkaOperationBinding"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.kafka.KafkaOperationBinding;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding: 0
}, false, "amf.plugins.domain.webapi.models.bindings.kafka.KafkaOperationBinding", {
  Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding: 1,
  O: 1,
  Lamf_plugins_domain_webapi_models_bindings_OperationBinding: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_plugins_domain_webapi_models_bindings_BindingVersion: 1,
  Lamf_plugins_domain_webapi_models_Key: 1
});
$c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.key$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype = $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype;
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$()
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.componentId__T = (function() {
  return "/mqtt-message"
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.key__Lamf_core_model_StrField = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.bindingVersionField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$().BindingVersion$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  this.key$1 = $as_Lamf_core_model_StrField(fields.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$().key$1));
  return this
});
function $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.mqtt.MqttMessageBinding"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.mqtt.MqttMessageBinding;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding: 0
}, false, "amf.plugins.domain.webapi.models.bindings.mqtt.MqttMessageBinding", {
  Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding: 1,
  O: 1,
  Lamf_plugins_domain_webapi_models_bindings_MessageBinding: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_plugins_domain_webapi_models_bindings_BindingVersion: 1,
  Lamf_plugins_domain_webapi_models_Key: 1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype = $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype;
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$()
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.componentId__T = (function() {
  return "/mqtt-operation"
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.key__Lamf_core_model_StrField = (function() {
  return $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$().key$1))
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.bindingVersionField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$().BindingVersion$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.mqtt.MqttOperationBinding"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.mqtt.MqttOperationBinding;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding: 0
}, false, "amf.plugins.domain.webapi.models.bindings.mqtt.MqttOperationBinding", {
  Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding: 1,
  O: 1,
  Lamf_plugins_domain_webapi_models_bindings_OperationBinding: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_plugins_domain_webapi_models_bindings_BindingVersion: 1,
  Lamf_plugins_domain_webapi_models_Key: 1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype = $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype;
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$()
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.componentId__T = (function() {
  return "/mqtt-server"
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.key__Lamf_core_model_StrField = (function() {
  return $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().key$1))
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.bindingVersionField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().BindingVersion$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.mqtt.MqttServerBinding"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.mqtt.MqttServerBinding;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding: 0
}, false, "amf.plugins.domain.webapi.models.bindings.mqtt.MqttServerBinding", {
  Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding: 1,
  O: 1,
  Lamf_plugins_domain_webapi_models_bindings_ServerBinding: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_plugins_domain_webapi_models_bindings_BindingVersion: 1,
  Lamf_plugins_domain_webapi_models_Key: 1
});
$c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype = $c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype;
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$()
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.componentId__T = (function() {
  return "/web-socket-channel"
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.key__Lamf_core_model_StrField = (function() {
  return $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$().key$1))
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.bindingVersionField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$().BindingVersion$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.websockets.WebSocketsChannelBinding"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.websockets.WebSocketsChannelBinding;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding: 0
}, false, "amf.plugins.domain.webapi.models.bindings.websockets.WebSocketsChannelBinding", {
  Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding: 1,
  O: 1,
  Lamf_plugins_domain_webapi_models_bindings_ChannelBinding: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_plugins_domain_webapi_models_bindings_BindingVersion: 1,
  Lamf_plugins_domain_webapi_models_Key: 1
});
$c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_security_OAuth2Flow() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype = $c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype;
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.productPrefix__T = (function() {
  return "OAuth2Flow"
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow)) {
    var OAuth2Flow$1 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow(x$1);
    var x = this.fields$1;
    var x$2 = OAuth2Flow$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = OAuth2Flow$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$()
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Flow$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-flow" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.security.OAuth2Flow"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_security_OAuth2Flow(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_security_OAuth2Flow)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_security_OAuth2Flow(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_security_OAuth2Flow(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.security.OAuth2Flow;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_security_OAuth2Flow = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_security_OAuth2Flow: 0
}, false, "amf.plugins.domain.webapi.models.security.OAuth2Flow", {
  Lamf_plugins_domain_webapi_models_security_OAuth2Flow: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_security_OAuth2Flow;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_security_Scope() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_security_Scope;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_security_Scope() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_security_Scope.prototype = $c_Lamf_plugins_domain_webapi_models_security_Scope.prototype;
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.productPrefix__T = (function() {
  return "Scope"
});
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_security_Scope)) {
    var Scope$1 = $as_Lamf_plugins_domain_webapi_models_security_Scope(x$1);
    var x = this.fields$1;
    var x$2 = Scope$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = Scope$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$()
});
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-scope" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_domain_webapi_models_security_Scope(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_security_Scope) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.security.Scope"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_security_Scope(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_security_Scope)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_security_Scope(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_security_Scope(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.security.Scope;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_security_Scope = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_security_Scope: 0
}, false, "amf.plugins.domain.webapi.models.security.Scope", {
  Lamf_plugins_domain_webapi_models_security_Scope: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_security_Scope.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_security_Scope;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_security_SecurityRequirement() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype = $c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype;
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.productPrefix__T = (function() {
  return "SecurityRequirement"
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement)) {
    var SecurityRequirement$1 = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(x$1);
    var x = this.fields$1;
    var x$2 = SecurityRequirement$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = SecurityRequirement$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$()
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-requirement" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.withScheme__T__Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Name$1;
  var scheme = $as_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, name));
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$().Schemes$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field$1, scheme);
  return scheme
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.withScheme__Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var scheme = new $c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$().Schemes$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, scheme);
  return scheme
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.security.SecurityRequirement"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_security_SecurityRequirement)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_security_SecurityRequirement(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.security.SecurityRequirement;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_security_SecurityRequirement = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_security_SecurityRequirement: 0
}, false, "amf.plugins.domain.webapi.models.security.SecurityRequirement", {
  Lamf_plugins_domain_webapi_models_security_SecurityRequirement: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_security_SecurityRequirement;
/** @constructor */
function $c_Lorg_mulesoft_common_parse_ParseException() {
  $c_jl_RuntimeException.call(this);
  this.parseError$4 = null
}
$c_Lorg_mulesoft_common_parse_ParseException.prototype = new $h_jl_RuntimeException();
$c_Lorg_mulesoft_common_parse_ParseException.prototype.constructor = $c_Lorg_mulesoft_common_parse_ParseException;
/** @constructor */
function $h_Lorg_mulesoft_common_parse_ParseException() {
  /*<skip>*/
}
$h_Lorg_mulesoft_common_parse_ParseException.prototype = $c_Lorg_mulesoft_common_parse_ParseException.prototype;
$c_Lorg_mulesoft_common_parse_ParseException.prototype.productPrefix__T = (function() {
  return "ParseException"
});
$c_Lorg_mulesoft_common_parse_ParseException.prototype.init___Lorg_mulesoft_common_parse_ParseError = (function(parseError) {
  this.parseError$4 = parseError;
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
$c_Lorg_mulesoft_common_parse_ParseException.prototype.productArity__I = (function() {
  return 1
});
$c_Lorg_mulesoft_common_parse_ParseException.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lorg_mulesoft_common_parse_ParseException)) {
    var ParseException$1 = $as_Lorg_mulesoft_common_parse_ParseException(x$1);
    var x = this.parseError$4;
    var x$2 = ParseException$1.parseError$4;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lorg_mulesoft_common_parse_ParseException.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.parseError$4;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lorg_mulesoft_common_parse_ParseException.prototype.getMessage__T = (function() {
  return this.parseError$4.message__T()
});
$c_Lorg_mulesoft_common_parse_ParseException.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lorg_mulesoft_common_parse_ParseException.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lorg_mulesoft_common_parse_ParseException(obj) {
  return (((obj instanceof $c_Lorg_mulesoft_common_parse_ParseException) || (obj === null)) ? obj : $throwClassCastException(obj, "org.mulesoft.common.parse.ParseException"))
}
function $isArrayOf_Lorg_mulesoft_common_parse_ParseException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_mulesoft_common_parse_ParseException)))
}
function $asArrayOf_Lorg_mulesoft_common_parse_ParseException(obj, depth) {
  return (($isArrayOf_Lorg_mulesoft_common_parse_ParseException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.mulesoft.common.parse.ParseException;", depth))
}
var $d_Lorg_mulesoft_common_parse_ParseException = new $TypeData().initClass({
  Lorg_mulesoft_common_parse_ParseException: 0
}, false, "org.mulesoft.common.parse.ParseException", {
  Lorg_mulesoft_common_parse_ParseException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1
});
$c_Lorg_mulesoft_common_parse_ParseException.prototype.$classData = $d_Lorg_mulesoft_common_parse_ParseException;
/** @constructor */
function $c_jl_JSConsoleBasedPrintStream() {
  $c_Ljava_io_PrintStream.call(this);
  this.isErr$4 = false;
  this.flushed$4 = false;
  this.buffer$4 = null
}
$c_jl_JSConsoleBasedPrintStream.prototype = new $h_Ljava_io_PrintStream();
$c_jl_JSConsoleBasedPrintStream.prototype.constructor = $c_jl_JSConsoleBasedPrintStream;
/** @constructor */
function $h_jl_JSConsoleBasedPrintStream() {
  /*<skip>*/
}
$h_jl_JSConsoleBasedPrintStream.prototype = $c_jl_JSConsoleBasedPrintStream.prototype;
$c_jl_JSConsoleBasedPrintStream.prototype.print__T__V = (function(s) {
  this.java$lang$JSConsoleBasedPrintStream$$printString__T__V(((s === null) ? "null" : s))
});
$c_jl_JSConsoleBasedPrintStream.prototype.java$lang$JSConsoleBasedPrintStream$$printString__T__V = (function(s) {
  var rest = s;
  while ((rest !== "")) {
    var thiz = rest;
    var nlPos = $uI(thiz.indexOf("\n"));
    if ((nlPos < 0)) {
      this.buffer$4 = (("" + this.buffer$4) + rest);
      this.flushed$4 = false;
      rest = ""
    } else {
      var jsx$1 = this.buffer$4;
      var thiz$1 = rest;
      this.doWriteLine__p4__T__V((("" + jsx$1) + $as_T(thiz$1.substring(0, nlPos))));
      this.buffer$4 = "";
      this.flushed$4 = true;
      var thiz$2 = rest;
      var beginIndex = ((1 + nlPos) | 0);
      rest = $as_T(thiz$2.substring(beginIndex))
    }
  }
});
$c_jl_JSConsoleBasedPrintStream.prototype.doWriteLine__p4__T__V = (function(line) {
  var x = $g.console;
  if ($uZ((!(!x)))) {
    if (this.isErr$4) {
      var x$1 = $g.console.error;
      var jsx$1 = $uZ((!(!x$1)))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      $g.console.error(line)
    } else {
      $g.console.log(line)
    }
  }
});
$c_jl_JSConsoleBasedPrintStream.prototype.init___Z = (function(isErr) {
  this.isErr$4 = isErr;
  var out = new $c_jl_JSConsoleBasedPrintStream$DummyOutputStream().init___();
  $c_Ljava_io_PrintStream.prototype.init___Ljava_io_OutputStream__Z__Ljava_nio_charset_Charset.call(this, out, false, null);
  this.flushed$4 = true;
  this.buffer$4 = "";
  return this
});
$c_jl_JSConsoleBasedPrintStream.prototype.close__V = (function() {
  /*<skip>*/
});
var $d_jl_JSConsoleBasedPrintStream = new $TypeData().initClass({
  jl_JSConsoleBasedPrintStream: 0
}, false, "java.lang.JSConsoleBasedPrintStream", {
  jl_JSConsoleBasedPrintStream: 1,
  Ljava_io_PrintStream: 1,
  Ljava_io_FilterOutputStream: 1,
  Ljava_io_OutputStream: 1,
  O: 1,
  Ljava_io_Closeable: 1,
  jl_AutoCloseable: 1,
  Ljava_io_Flushable: 1,
  jl_Appendable: 1
});
$c_jl_JSConsoleBasedPrintStream.prototype.$classData = $d_jl_JSConsoleBasedPrintStream;
/** @constructor */
function $c_s_Tuple2$mcDD$sp() {
  $c_T2.call(this);
  this.$$und1$mcD$sp$f = 0.0;
  this.$$und2$mcD$sp$f = 0.0
}
$c_s_Tuple2$mcDD$sp.prototype = new $h_T2();
$c_s_Tuple2$mcDD$sp.prototype.constructor = $c_s_Tuple2$mcDD$sp;
/** @constructor */
function $h_s_Tuple2$mcDD$sp() {
  /*<skip>*/
}
$h_s_Tuple2$mcDD$sp.prototype = $c_s_Tuple2$mcDD$sp.prototype;
$c_s_Tuple2$mcDD$sp.prototype.$$und1$mcD$sp__D = (function() {
  return this.$$und1$mcD$sp$f
});
$c_s_Tuple2$mcDD$sp.prototype.$$und2__O = (function() {
  return this.$$und2$mcD$sp$f
});
$c_s_Tuple2$mcDD$sp.prototype.$$und2$mcD$sp__D = (function() {
  return this.$$und2$mcD$sp$f
});
$c_s_Tuple2$mcDD$sp.prototype.init___D__D = (function(_1$mcD$sp, _2$mcD$sp) {
  this.$$und1$mcD$sp$f = _1$mcD$sp;
  this.$$und2$mcD$sp$f = _2$mcD$sp;
  $c_T2.prototype.init___O__O.call(this, null, null);
  return this
});
$c_s_Tuple2$mcDD$sp.prototype.$$und1__O = (function() {
  return this.$$und1$mcD$sp$f
});
var $d_s_Tuple2$mcDD$sp = new $TypeData().initClass({
  s_Tuple2$mcDD$sp: 0
}, false, "scala.Tuple2$mcDD$sp", {
  s_Tuple2$mcDD$sp: 1,
  T2: 1,
  O: 1,
  s_Product2: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_Product2$mcDD$sp: 1
});
$c_s_Tuple2$mcDD$sp.prototype.$classData = $d_s_Tuple2$mcDD$sp;
/** @constructor */
function $c_s_concurrent_impl_Promise$DefaultPromise() {
  $c_ju_concurrent_atomic_AtomicReference.call(this)
}
$c_s_concurrent_impl_Promise$DefaultPromise.prototype = new $h_ju_concurrent_atomic_AtomicReference();
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.constructor = $c_s_concurrent_impl_Promise$DefaultPromise;
/** @constructor */
function $h_s_concurrent_impl_Promise$DefaultPromise() {
  /*<skip>*/
}
$h_s_concurrent_impl_Promise$DefaultPromise.prototype = $c_s_concurrent_impl_Promise$DefaultPromise.prototype;
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.compressedRoot__p2__s_concurrent_impl_Promise$DefaultPromise__s_concurrent_impl_Promise$DefaultPromise = (function(linked) {
  _compressedRoot: while (true) {
    var target = linked.root__p2__s_concurrent_impl_Promise$DefaultPromise();
    if ((linked === target)) {
      return target
    } else if (this.compareAndSet__O__O__Z(linked, target)) {
      return target
    } else {
      var x1 = this.value$1;
      if ((x1 instanceof $c_s_concurrent_impl_Promise$DefaultPromise)) {
        var x2 = $as_s_concurrent_impl_Promise$DefaultPromise(x1);
        linked = x2;
        continue _compressedRoot
      } else {
        return this
      }
    }
  }
});
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.init___ = (function() {
  $c_ju_concurrent_atomic_AtomicReference.prototype.init___O.call(this, $m_sci_Nil$());
  return this
});
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.isCompleted0__p2__Z = (function() {
  var _$this = this;
  _isCompleted0: while (true) {
    var x1 = _$this.value$1;
    if ((x1 instanceof $c_s_util_Try)) {
      return true
    } else if ((x1 instanceof $c_s_concurrent_impl_Promise$DefaultPromise)) {
      var x3 = $as_s_concurrent_impl_Promise$DefaultPromise(x1);
      _$this = _$this.compressedRoot__p2__s_concurrent_impl_Promise$DefaultPromise__s_concurrent_impl_Promise$DefaultPromise(x3);
      continue _isCompleted0
    } else {
      return false
    }
  }
});
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.dispatchOrAddCallback__p2__s_concurrent_impl_CallbackRunnable__V = (function(runnable) {
  var _$this = this;
  _dispatchOrAddCallback: while (true) {
    var x1 = _$this.value$1;
    if ((x1 instanceof $c_s_util_Try)) {
      var x2 = $as_s_util_Try(x1);
      runnable.executeWithValue__s_util_Try__V(x2)
    } else {
      if ((x1 instanceof $c_s_concurrent_impl_Promise$DefaultPromise)) {
        var x3 = $as_s_concurrent_impl_Promise$DefaultPromise(x1);
        _$this = _$this.compressedRoot__p2__s_concurrent_impl_Promise$DefaultPromise__s_concurrent_impl_Promise$DefaultPromise(x3);
        continue _dispatchOrAddCallback
      };
      if ((!(x1 instanceof $c_sci_List))) {
        throw new $c_s_MatchError().init___O(x1)
      };
      var x4 = $as_sci_List(x1);
      if ((!_$this.compareAndSet__O__O__Z(x4, new $c_sci_$colon$colon().init___O__sci_List(runnable, x4)))) {
        continue _dispatchOrAddCallback
      }
    };
    break
  }
});
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.foreach__F1__s_concurrent_ExecutionContext__V = (function(f, executor) {
  $f_s_concurrent_Future__foreach__F1__s_concurrent_ExecutionContext__V(this, f, executor)
});
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.tryComplete__s_util_Try__Z = (function(value) {
  var resolved = $m_s_concurrent_impl_Promise$().scala$concurrent$impl$Promise$$resolveTry__s_util_Try__s_util_Try(value);
  var x1 = this.tryCompleteAndGetListeners__p2__s_util_Try__sci_List(resolved);
  if ((x1 !== null)) {
    if (x1.isEmpty__Z()) {
      return true
    } else {
      var these = x1;
      while ((!these.isEmpty__Z())) {
        var arg1 = these.head__O();
        var r = $as_s_concurrent_impl_CallbackRunnable(arg1);
        r.executeWithValue__s_util_Try__V(resolved);
        these = $as_sci_List(these.tail__O())
      };
      return true
    }
  } else {
    return false
  }
});
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.link__p2__s_concurrent_impl_Promise$DefaultPromise__V = (function(target) {
  var _$this = this;
  _link: while (true) {
    if ((_$this !== target)) {
      var x1 = _$this.value$1;
      matchEnd6: {
        if ((x1 instanceof $c_s_util_Try)) {
          var x2 = $as_s_util_Try(x1);
          if ((!target.tryComplete__s_util_Try__Z(x2))) {
            throw new $c_jl_IllegalStateException().init___T("Cannot link completed promises together")
          };
          break matchEnd6
        };
        if ((x1 instanceof $c_s_concurrent_impl_Promise$DefaultPromise)) {
          var x3 = $as_s_concurrent_impl_Promise$DefaultPromise(x1);
          _$this = _$this.compressedRoot__p2__s_concurrent_impl_Promise$DefaultPromise__s_concurrent_impl_Promise$DefaultPromise(x3);
          continue _link
        };
        if ((x1 instanceof $c_sci_List)) {
          var x4 = $as_sci_List(x1);
          if (_$this.compareAndSet__O__O__Z(x4, target)) {
            if ($f_sc_TraversableOnce__nonEmpty__Z(x4)) {
              var these = x4;
              while ((!these.isEmpty__Z())) {
                var arg1 = these.head__O();
                var x$2 = $as_s_concurrent_impl_CallbackRunnable(arg1);
                target.dispatchOrAddCallback__p2__s_concurrent_impl_CallbackRunnable__V(x$2);
                these = $as_sci_List(these.tail__O())
              };
              break matchEnd6
            } else {
              break matchEnd6
            }
          }
        };
        continue _link
      }
    };
    break
  }
});
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.toString__T = (function() {
  return $f_s_concurrent_impl_Promise__toString__T(this)
});
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.root__p2__s_concurrent_impl_Promise$DefaultPromise = (function() {
  var _$this = this;
  _root: while (true) {
    var x1 = _$this.value$1;
    if ((x1 instanceof $c_s_concurrent_impl_Promise$DefaultPromise)) {
      var x2 = $as_s_concurrent_impl_Promise$DefaultPromise(x1);
      _$this = x2;
      continue _root
    } else {
      return _$this
    }
  }
});
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future = (function(f, executor) {
  return $f_s_concurrent_Future__flatMap__F1__s_concurrent_ExecutionContext__s_concurrent_Future(this, f, executor)
});
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.compressedRoot__p2__s_concurrent_impl_Promise$DefaultPromise = (function() {
  var x1 = this.value$1;
  if ((x1 instanceof $c_s_concurrent_impl_Promise$DefaultPromise)) {
    var x2 = $as_s_concurrent_impl_Promise$DefaultPromise(x1);
    return this.compressedRoot__p2__s_concurrent_impl_Promise$DefaultPromise__s_concurrent_impl_Promise$DefaultPromise(x2)
  } else {
    return this
  }
});
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.onComplete__F1__s_concurrent_ExecutionContext__V = (function(func, executor) {
  this.dispatchOrAddCallback__p2__s_concurrent_impl_CallbackRunnable__V(new $c_s_concurrent_impl_CallbackRunnable().init___s_concurrent_ExecutionContext__F1(executor, func))
});
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.tryCompleteAndGetListeners__p2__s_util_Try__sci_List = (function(v) {
  var _$this = this;
  _tryCompleteAndGetListeners: while (true) {
    var x1 = _$this.value$1;
    if ((x1 instanceof $c_sci_List)) {
      var x2 = $as_sci_List(x1);
      if (_$this.compareAndSet__O__O__Z(x2, v)) {
        return x2
      } else {
        continue _tryCompleteAndGetListeners
      }
    } else if ((x1 instanceof $c_s_concurrent_impl_Promise$DefaultPromise)) {
      var x3 = $as_s_concurrent_impl_Promise$DefaultPromise(x1);
      _$this = _$this.compressedRoot__p2__s_concurrent_impl_Promise$DefaultPromise__s_concurrent_impl_Promise$DefaultPromise(x3);
      continue _tryCompleteAndGetListeners
    } else {
      return null
    }
  }
});
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.zipWith__s_concurrent_Future__F2__s_concurrent_ExecutionContext__s_concurrent_Future = (function(that, f, executor) {
  return $f_s_concurrent_Future__zipWith__s_concurrent_Future__F2__s_concurrent_ExecutionContext__s_concurrent_Future(this, that, f, executor)
});
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.map__F1__s_concurrent_ExecutionContext__s_concurrent_Future = (function(f, executor) {
  return $f_s_concurrent_Future__map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(this, f, executor)
});
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.value__s_Option = (function() {
  return this.value0__p2__s_Option()
});
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.recover__s_PartialFunction__s_concurrent_ExecutionContext__s_concurrent_Future = (function(pf, executor) {
  return $f_s_concurrent_Future__recover__s_PartialFunction__s_concurrent_ExecutionContext__s_concurrent_Future(this, pf, executor)
});
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.value0__p2__s_Option = (function() {
  var _$this = this;
  _value0: while (true) {
    var x1 = _$this.value$1;
    if ((x1 instanceof $c_s_util_Try)) {
      var x2 = $as_s_util_Try(x1);
      return new $c_s_Some().init___O(x2)
    } else if ((x1 instanceof $c_s_concurrent_impl_Promise$DefaultPromise)) {
      var x3 = $as_s_concurrent_impl_Promise$DefaultPromise(x1);
      _$this = _$this.compressedRoot__p2__s_concurrent_impl_Promise$DefaultPromise__s_concurrent_impl_Promise$DefaultPromise(x3);
      continue _value0
    } else {
      return $m_s_None$()
    }
  }
});
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.recoverWith__s_PartialFunction__s_concurrent_ExecutionContext__s_concurrent_Future = (function(pf, executor) {
  return $f_s_concurrent_Future__recoverWith__s_PartialFunction__s_concurrent_ExecutionContext__s_concurrent_Future(this, pf, executor)
});
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.isCompleted__Z = (function() {
  return this.isCompleted0__p2__Z()
});
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.failed__s_concurrent_Future = (function() {
  return $f_s_concurrent_Future__failed__s_concurrent_Future(this)
});
function $as_s_concurrent_impl_Promise$DefaultPromise(obj) {
  return (((obj instanceof $c_s_concurrent_impl_Promise$DefaultPromise) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.concurrent.impl.Promise$DefaultPromise"))
}
function $isArrayOf_s_concurrent_impl_Promise$DefaultPromise(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_concurrent_impl_Promise$DefaultPromise)))
}
function $asArrayOf_s_concurrent_impl_Promise$DefaultPromise(obj, depth) {
  return (($isArrayOf_s_concurrent_impl_Promise$DefaultPromise(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.concurrent.impl.Promise$DefaultPromise;", depth))
}
var $d_s_concurrent_impl_Promise$DefaultPromise = new $TypeData().initClass({
  s_concurrent_impl_Promise$DefaultPromise: 0
}, false, "scala.concurrent.impl.Promise$DefaultPromise", {
  s_concurrent_impl_Promise$DefaultPromise: 1,
  ju_concurrent_atomic_AtomicReference: 1,
  O: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_concurrent_impl_Promise: 1,
  s_concurrent_Promise: 1,
  s_concurrent_Future: 1,
  s_concurrent_Awaitable: 1
});
$c_s_concurrent_impl_Promise$DefaultPromise.prototype.$classData = $d_s_concurrent_impl_Promise$DefaultPromise;
/** @constructor */
function $c_s_math_Ordering$Int$() {
  $c_O.call(this)
}
$c_s_math_Ordering$Int$.prototype = new $h_O();
$c_s_math_Ordering$Int$.prototype.constructor = $c_s_math_Ordering$Int$;
/** @constructor */
function $h_s_math_Ordering$Int$() {
  /*<skip>*/
}
$h_s_math_Ordering$Int$.prototype = $c_s_math_Ordering$Int$.prototype;
$c_s_math_Ordering$Int$.prototype.init___ = (function() {
  return this
});
$c_s_math_Ordering$Int$.prototype.gteq__O__O__Z = (function(x, y) {
  return $f_s_math_Ordering__gteq__O__O__Z(this, x, y)
});
$c_s_math_Ordering$Int$.prototype.compare__O__O__I = (function(x, y) {
  var x$1 = $uI(x);
  var y$1 = $uI(y);
  return ((x$1 === y$1) ? 0 : ((x$1 < y$1) ? (-1) : 1))
});
$c_s_math_Ordering$Int$.prototype.lteq__O__O__Z = (function(x, y) {
  return $f_s_math_Ordering__lteq__O__O__Z(this, x, y)
});
var $d_s_math_Ordering$Int$ = new $TypeData().initClass({
  s_math_Ordering$Int$: 0
}, false, "scala.math.Ordering$Int$", {
  s_math_Ordering$Int$: 1,
  O: 1,
  s_math_Ordering$IntOrdering: 1,
  s_math_Ordering: 1,
  ju_Comparator: 1,
  s_math_PartialOrdering: 1,
  s_math_Equiv: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_math_Ordering$Int$.prototype.$classData = $d_s_math_Ordering$Int$;
var $n_s_math_Ordering$Int$ = (void 0);
function $m_s_math_Ordering$Int$() {
  if ((!$n_s_math_Ordering$Int$)) {
    $n_s_math_Ordering$Int$ = new $c_s_math_Ordering$Int$().init___()
  };
  return $n_s_math_Ordering$Int$
}
/** @constructor */
function $c_s_math_Ordering$String$() {
  $c_O.call(this)
}
$c_s_math_Ordering$String$.prototype = new $h_O();
$c_s_math_Ordering$String$.prototype.constructor = $c_s_math_Ordering$String$;
/** @constructor */
function $h_s_math_Ordering$String$() {
  /*<skip>*/
}
$h_s_math_Ordering$String$.prototype = $c_s_math_Ordering$String$.prototype;
$c_s_math_Ordering$String$.prototype.init___ = (function() {
  return this
});
$c_s_math_Ordering$String$.prototype.gteq__O__O__Z = (function(x, y) {
  return $f_s_math_Ordering__gteq__O__O__Z(this, x, y)
});
$c_s_math_Ordering$String$.prototype.compare__O__O__I = (function(x, y) {
  var x$1 = $as_T(x);
  var y$1 = $as_T(y);
  return ((x$1 === y$1) ? 0 : ($uZ((x$1 < y$1)) ? (-1) : 1))
});
$c_s_math_Ordering$String$.prototype.lteq__O__O__Z = (function(x, y) {
  return $f_s_math_Ordering__lteq__O__O__Z(this, x, y)
});
var $d_s_math_Ordering$String$ = new $TypeData().initClass({
  s_math_Ordering$String$: 0
}, false, "scala.math.Ordering$String$", {
  s_math_Ordering$String$: 1,
  O: 1,
  s_math_Ordering$StringOrdering: 1,
  s_math_Ordering: 1,
  ju_Comparator: 1,
  s_math_PartialOrdering: 1,
  s_math_Equiv: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_s_math_Ordering$String$.prototype.$classData = $d_s_math_Ordering$String$;
var $n_s_math_Ordering$String$ = (void 0);
function $m_s_math_Ordering$String$() {
  if ((!$n_s_math_Ordering$String$)) {
    $n_s_math_Ordering$String$ = new $c_s_math_Ordering$String$().init___()
  };
  return $n_s_math_Ordering$String$
}
/** @constructor */
function $c_s_reflect_AnyValManifest() {
  $c_O.call(this);
  this.toString$1 = null
}
$c_s_reflect_AnyValManifest.prototype = new $h_O();
$c_s_reflect_AnyValManifest.prototype.constructor = $c_s_reflect_AnyValManifest;
/** @constructor */
function $h_s_reflect_AnyValManifest() {
  /*<skip>*/
}
$h_s_reflect_AnyValManifest.prototype = $c_s_reflect_AnyValManifest.prototype;
$c_s_reflect_AnyValManifest.prototype.equals__O__Z = (function(that) {
  return (this === that)
});
$c_s_reflect_AnyValManifest.prototype.toString__T = (function() {
  return this.toString$1
});
$c_s_reflect_AnyValManifest.prototype.hashCode__I = (function() {
  return $systemIdentityHashCode(this)
});
/** @constructor */
function $c_s_reflect_ManifestFactory$ClassTypeManifest() {
  $c_O.call(this);
  this.prefix$1 = null;
  this.runtimeClass1$1 = null;
  this.typeArguments$1 = null
}
$c_s_reflect_ManifestFactory$ClassTypeManifest.prototype = new $h_O();
$c_s_reflect_ManifestFactory$ClassTypeManifest.prototype.constructor = $c_s_reflect_ManifestFactory$ClassTypeManifest;
/** @constructor */
function $h_s_reflect_ManifestFactory$ClassTypeManifest() {
  /*<skip>*/
}
$h_s_reflect_ManifestFactory$ClassTypeManifest.prototype = $c_s_reflect_ManifestFactory$ClassTypeManifest.prototype;
/** @constructor */
function $c_sc_IndexedSeq$() {
  $c_scg_IndexedSeqFactory.call(this);
  this.ReusableCBF$6 = null
}
$c_sc_IndexedSeq$.prototype = new $h_scg_IndexedSeqFactory();
$c_sc_IndexedSeq$.prototype.constructor = $c_sc_IndexedSeq$;
/** @constructor */
function $h_sc_IndexedSeq$() {
  /*<skip>*/
}
$h_sc_IndexedSeq$.prototype = $c_sc_IndexedSeq$.prototype;
$c_sc_IndexedSeq$.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory.prototype.init___.call(this);
  $n_sc_IndexedSeq$ = this;
  this.ReusableCBF$6 = new $c_sc_IndexedSeq$$anon$1().init___();
  return this
});
$c_sc_IndexedSeq$.prototype.newBuilder__scm_Builder = (function() {
  $m_sci_IndexedSeq$();
  $m_sci_Vector$();
  return new $c_sci_VectorBuilder().init___()
});
var $d_sc_IndexedSeq$ = new $TypeData().initClass({
  sc_IndexedSeq$: 0
}, false, "scala.collection.IndexedSeq$", {
  sc_IndexedSeq$: 1,
  scg_IndexedSeqFactory: 1,
  scg_SeqFactory: 1,
  scg_GenSeqFactory: 1,
  scg_GenTraversableFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_TraversableFactory: 1,
  scg_GenericSeqCompanion: 1
});
$c_sc_IndexedSeq$.prototype.$classData = $d_sc_IndexedSeq$;
var $n_sc_IndexedSeq$ = (void 0);
function $m_sc_IndexedSeq$() {
  if ((!$n_sc_IndexedSeq$)) {
    $n_sc_IndexedSeq$ = new $c_sc_IndexedSeq$().init___()
  };
  return $n_sc_IndexedSeq$
}
/** @constructor */
function $c_sc_IndexedSeqLike$Elements() {
  $c_sc_AbstractIterator.call(this);
  this.end$2 = 0;
  this.index$2 = 0;
  this.$$outer$2 = null
}
$c_sc_IndexedSeqLike$Elements.prototype = new $h_sc_AbstractIterator();
$c_sc_IndexedSeqLike$Elements.prototype.constructor = $c_sc_IndexedSeqLike$Elements;
/** @constructor */
function $h_sc_IndexedSeqLike$Elements() {
  /*<skip>*/
}
$h_sc_IndexedSeqLike$Elements.prototype = $c_sc_IndexedSeqLike$Elements.prototype;
$c_sc_IndexedSeqLike$Elements.prototype.next__O = (function() {
  if ((this.index$2 >= this.end$2)) {
    $m_sc_Iterator$().empty$1.next__O()
  };
  var x = this.$$outer$2.apply__I__O(this.index$2);
  this.index$2 = ((1 + this.index$2) | 0);
  return x
});
$c_sc_IndexedSeqLike$Elements.prototype.take__I__sc_Iterator = (function(n) {
  return ((n <= 0) ? $m_sc_Iterator$().empty$1 : ((n <= this.available__p2__I()) ? new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this.$$outer$2, this.index$2, ((this.index$2 + n) | 0)) : new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this.$$outer$2, this.index$2, this.end$2)))
});
$c_sc_IndexedSeqLike$Elements.prototype.init___sc_IndexedSeqLike__I__I = (function($$outer, start, end) {
  this.end$2 = end;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.index$2 = start;
  return this
});
$c_sc_IndexedSeqLike$Elements.prototype.hasNext__Z = (function() {
  return (this.index$2 < this.end$2)
});
$c_sc_IndexedSeqLike$Elements.prototype.available__p2__I = (function() {
  var x = ((this.end$2 - this.index$2) | 0);
  return ((x > 0) ? x : 0)
});
$c_sc_IndexedSeqLike$Elements.prototype.drop__I__sc_Iterator = (function(n) {
  return ((n <= 0) ? new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this.$$outer$2, this.index$2, this.end$2) : ((((this.index$2 + n) | 0) >= this.end$2) ? new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this.$$outer$2, this.end$2, this.end$2) : new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this.$$outer$2, ((this.index$2 + n) | 0), this.end$2)))
});
var $d_sc_IndexedSeqLike$Elements = new $TypeData().initClass({
  sc_IndexedSeqLike$Elements: 0
}, false, "scala.collection.IndexedSeqLike$Elements", {
  sc_IndexedSeqLike$Elements: 1,
  sc_AbstractIterator: 1,
  O: 1,
  sc_Iterator: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_BufferedIterator: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sc_IndexedSeqLike$Elements.prototype.$classData = $d_sc_IndexedSeqLike$Elements;
/** @constructor */
function $c_sci_HashSet$() {
  $c_scg_ImmutableSetFactory.call(this)
}
$c_sci_HashSet$.prototype = new $h_scg_ImmutableSetFactory();
$c_sci_HashSet$.prototype.constructor = $c_sci_HashSet$;
/** @constructor */
function $h_sci_HashSet$() {
  /*<skip>*/
}
$h_sci_HashSet$.prototype = $c_sci_HashSet$.prototype;
$c_sci_HashSet$.prototype.init___ = (function() {
  return this
});
$c_sci_HashSet$.prototype.scala$collection$immutable$HashSet$$keepBits__I__I__I = (function(bitmap, keep) {
  var result = 0;
  var current = bitmap;
  var kept = keep;
  while ((kept !== 0)) {
    var lsb = (current ^ (current & (((-1) + current) | 0)));
    if (((1 & kept) !== 0)) {
      result = (result | lsb)
    };
    current = (current & (~lsb));
    kept = ((kept >>> 1) | 0)
  };
  return result
});
$c_sci_HashSet$.prototype.scala$collection$immutable$HashSet$$makeHashTrieSet__I__sci_HashSet__I__sci_HashSet__I__sci_HashSet$HashTrieSet = (function(hash0, elem0, hash1, elem1, level) {
  var index0 = (31 & ((hash0 >>> level) | 0));
  var index1 = (31 & ((hash1 >>> level) | 0));
  if ((index0 !== index1)) {
    var bitmap = ((1 << index0) | (1 << index1));
    var elems = $newArrayObject($d_sci_HashSet.getArrayOf(), [2]);
    if ((index0 < index1)) {
      elems.set(0, elem0);
      elems.set(1, elem1)
    } else {
      elems.set(0, elem1);
      elems.set(1, elem0)
    };
    return new $c_sci_HashSet$HashTrieSet().init___I__Asci_HashSet__I(bitmap, elems, ((elem0.size__I() + elem1.size__I()) | 0))
  } else {
    var elems$2 = $newArrayObject($d_sci_HashSet.getArrayOf(), [1]);
    var bitmap$2 = (1 << index0);
    var child = this.scala$collection$immutable$HashSet$$makeHashTrieSet__I__sci_HashSet__I__sci_HashSet__I__sci_HashSet$HashTrieSet(hash0, elem0, hash1, elem1, ((5 + level) | 0));
    elems$2.set(0, child);
    return new $c_sci_HashSet$HashTrieSet().init___I__Asci_HashSet__I(bitmap$2, elems$2, child.size0$5)
  }
});
$c_sci_HashSet$.prototype.emptyInstance__sci_Set = (function() {
  return $m_sci_HashSet$EmptyHashSet$()
});
var $d_sci_HashSet$ = new $TypeData().initClass({
  sci_HashSet$: 0
}, false, "scala.collection.immutable.HashSet$", {
  sci_HashSet$: 1,
  scg_ImmutableSetFactory: 1,
  scg_SetFactory: 1,
  scg_GenSetFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_GenericSeqCompanion: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_HashSet$.prototype.$classData = $d_sci_HashSet$;
var $n_sci_HashSet$ = (void 0);
function $m_sci_HashSet$() {
  if ((!$n_sci_HashSet$)) {
    $n_sci_HashSet$ = new $c_sci_HashSet$().init___()
  };
  return $n_sci_HashSet$
}
/** @constructor */
function $c_sci_IndexedSeq$() {
  $c_scg_IndexedSeqFactory.call(this)
}
$c_sci_IndexedSeq$.prototype = new $h_scg_IndexedSeqFactory();
$c_sci_IndexedSeq$.prototype.constructor = $c_sci_IndexedSeq$;
/** @constructor */
function $h_sci_IndexedSeq$() {
  /*<skip>*/
}
$h_sci_IndexedSeq$.prototype = $c_sci_IndexedSeq$.prototype;
$c_sci_IndexedSeq$.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory.prototype.init___.call(this);
  return this
});
$c_sci_IndexedSeq$.prototype.newBuilder__scm_Builder = (function() {
  $m_sci_Vector$();
  return new $c_sci_VectorBuilder().init___()
});
var $d_sci_IndexedSeq$ = new $TypeData().initClass({
  sci_IndexedSeq$: 0
}, false, "scala.collection.immutable.IndexedSeq$", {
  sci_IndexedSeq$: 1,
  scg_IndexedSeqFactory: 1,
  scg_SeqFactory: 1,
  scg_GenSeqFactory: 1,
  scg_GenTraversableFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_TraversableFactory: 1,
  scg_GenericSeqCompanion: 1
});
$c_sci_IndexedSeq$.prototype.$classData = $d_sci_IndexedSeq$;
var $n_sci_IndexedSeq$ = (void 0);
function $m_sci_IndexedSeq$() {
  if ((!$n_sci_IndexedSeq$)) {
    $n_sci_IndexedSeq$ = new $c_sci_IndexedSeq$().init___()
  };
  return $n_sci_IndexedSeq$
}
/** @constructor */
function $c_sci_ListSet$() {
  $c_scg_ImmutableSetFactory.call(this)
}
$c_sci_ListSet$.prototype = new $h_scg_ImmutableSetFactory();
$c_sci_ListSet$.prototype.constructor = $c_sci_ListSet$;
/** @constructor */
function $h_sci_ListSet$() {
  /*<skip>*/
}
$h_sci_ListSet$.prototype = $c_sci_ListSet$.prototype;
$c_sci_ListSet$.prototype.init___ = (function() {
  return this
});
$c_sci_ListSet$.prototype.emptyInstance__sci_Set = (function() {
  return $m_sci_ListSet$EmptyListSet$()
});
var $d_sci_ListSet$ = new $TypeData().initClass({
  sci_ListSet$: 0
}, false, "scala.collection.immutable.ListSet$", {
  sci_ListSet$: 1,
  scg_ImmutableSetFactory: 1,
  scg_SetFactory: 1,
  scg_GenSetFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_GenericSeqCompanion: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_ListSet$.prototype.$classData = $d_sci_ListSet$;
var $n_sci_ListSet$ = (void 0);
function $m_sci_ListSet$() {
  if ((!$n_sci_ListSet$)) {
    $n_sci_ListSet$ = new $c_sci_ListSet$().init___()
  };
  return $n_sci_ListSet$
}
/** @constructor */
function $c_scm_ArrayBuilder$generic() {
  $c_scm_ArrayBuilder.call(this);
  this.elementClass$2 = null;
  this.isCharArrayBuilder$2 = false;
  this.elems$2 = null
}
$c_scm_ArrayBuilder$generic.prototype = new $h_scm_ArrayBuilder();
$c_scm_ArrayBuilder$generic.prototype.constructor = $c_scm_ArrayBuilder$generic;
/** @constructor */
function $h_scm_ArrayBuilder$generic() {
  /*<skip>*/
}
$h_scm_ArrayBuilder$generic.prototype = $c_scm_ArrayBuilder$generic.prototype;
$c_scm_ArrayBuilder$generic.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__O__scm_ArrayBuilder$generic(elem)
});
$c_scm_ArrayBuilder$generic.prototype.toString__T = (function() {
  return "ArrayBuilder.generic"
});
$c_scm_ArrayBuilder$generic.prototype.$$plus$eq__O__scm_ArrayBuilder$generic = (function(elem) {
  if (this.isCharArrayBuilder$2) {
    if ((elem === null)) {
      var unboxedElem = 0
    } else {
      var this$2 = $as_jl_Character(elem);
      var unboxedElem = this$2.value$1
    }
  } else {
    var unboxedElem = ((elem === null) ? this.elementClass$2.data$1.zero : elem)
  };
  this.elems$2.push(unboxedElem);
  return this
});
$c_scm_ArrayBuilder$generic.prototype.result__O = (function() {
  var x$2 = this.elementClass$2;
  if ((x$2 === $d_V.getClassOf())) {
    var elemRuntimeClass = $d_sr_BoxedUnit.getClassOf()
  } else {
    var x$4 = this.elementClass$2;
    if ((x$4 === $d_sr_Null$.getClassOf())) {
      var jsx$1 = true
    } else {
      var x$6 = this.elementClass$2;
      var jsx$1 = (x$6 === $d_sr_Nothing$.getClassOf())
    };
    if (jsx$1) {
      var elemRuntimeClass = $d_O.getClassOf()
    } else {
      var elemRuntimeClass = this.elementClass$2
    }
  };
  return $makeNativeArrayWrapper(elemRuntimeClass.data$1.getArrayOf(), this.elems$2)
});
$c_scm_ArrayBuilder$generic.prototype.init___jl_Class = (function(elementClass) {
  this.elementClass$2 = elementClass;
  this.isCharArrayBuilder$2 = (elementClass === $d_C.getClassOf());
  this.elems$2 = [];
  return this
});
$c_scm_ArrayBuilder$generic.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__O__scm_ArrayBuilder$generic(elem)
});
var $d_scm_ArrayBuilder$generic = new $TypeData().initClass({
  scm_ArrayBuilder$generic: 0
}, false, "scala.collection.mutable.ArrayBuilder$generic", {
  scm_ArrayBuilder$generic: 1,
  scm_ArrayBuilder: 1,
  O: 1,
  scm_ReusableBuilder: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_ArrayBuilder$generic.prototype.$classData = $d_scm_ArrayBuilder$generic;
/** @constructor */
function $c_scm_ArrayBuilder$ofBoolean() {
  $c_scm_ArrayBuilder.call(this);
  this.elems$2 = null;
  this.capacity$2 = 0;
  this.size$2 = 0
}
$c_scm_ArrayBuilder$ofBoolean.prototype = new $h_scm_ArrayBuilder();
$c_scm_ArrayBuilder$ofBoolean.prototype.constructor = $c_scm_ArrayBuilder$ofBoolean;
/** @constructor */
function $h_scm_ArrayBuilder$ofBoolean() {
  /*<skip>*/
}
$h_scm_ArrayBuilder$ofBoolean.prototype = $c_scm_ArrayBuilder$ofBoolean.prototype;
$c_scm_ArrayBuilder$ofBoolean.prototype.init___ = (function() {
  this.capacity$2 = 0;
  this.size$2 = 0;
  return this
});
$c_scm_ArrayBuilder$ofBoolean.prototype.mkArray__p2__I__AZ = (function(size) {
  var newelems = $newArrayObject($d_Z.getArrayOf(), [size]);
  if ((this.size$2 > 0)) {
    $m_s_Array$().copy__O__I__O__I__I__V(this.elems$2, 0, newelems, 0, this.size$2)
  };
  return newelems
});
$c_scm_ArrayBuilder$ofBoolean.prototype.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuilder$ofBoolean = (function(xs) {
  if ((xs instanceof $c_scm_WrappedArray$ofBoolean)) {
    var x2 = $as_scm_WrappedArray$ofBoolean(xs);
    this.ensureSize__p2__I__V(((this.size$2 + x2.length__I()) | 0));
    $m_s_Array$().copy__O__I__O__I__I__V(x2.array$6, 0, this.elems$2, this.size$2, x2.length__I());
    this.size$2 = ((this.size$2 + x2.length__I()) | 0);
    return this
  } else {
    return $as_scm_ArrayBuilder$ofBoolean($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs))
  }
});
$c_scm_ArrayBuilder$ofBoolean.prototype.equals__O__Z = (function(other) {
  if ((other instanceof $c_scm_ArrayBuilder$ofBoolean)) {
    var x2 = $as_scm_ArrayBuilder$ofBoolean(other);
    return ((this.size$2 === x2.size$2) && (this.elems$2 === x2.elems$2))
  } else {
    return false
  }
});
$c_scm_ArrayBuilder$ofBoolean.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__Z__scm_ArrayBuilder$ofBoolean($uZ(elem))
});
$c_scm_ArrayBuilder$ofBoolean.prototype.toString__T = (function() {
  return "ArrayBuilder.ofBoolean"
});
$c_scm_ArrayBuilder$ofBoolean.prototype.result__O = (function() {
  return this.result__AZ()
});
$c_scm_ArrayBuilder$ofBoolean.prototype.resize__p2__I__V = (function(size) {
  this.elems$2 = this.mkArray__p2__I__AZ(size);
  this.capacity$2 = size
});
$c_scm_ArrayBuilder$ofBoolean.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__Z__scm_ArrayBuilder$ofBoolean($uZ(elem))
});
$c_scm_ArrayBuilder$ofBoolean.prototype.result__AZ = (function() {
  if (((this.capacity$2 !== 0) && (this.capacity$2 === this.size$2))) {
    this.capacity$2 = 0;
    return this.elems$2
  } else {
    return this.mkArray__p2__I__AZ(this.size$2)
  }
});
$c_scm_ArrayBuilder$ofBoolean.prototype.sizeHint__I__V = (function(size) {
  if ((this.capacity$2 < size)) {
    this.resize__p2__I__V(size)
  }
});
$c_scm_ArrayBuilder$ofBoolean.prototype.ensureSize__p2__I__V = (function(size) {
  if (((this.capacity$2 < size) || (this.capacity$2 === 0))) {
    var newsize = ((this.capacity$2 === 0) ? 16 : (this.capacity$2 << 1));
    while ((newsize < size)) {
      newsize = (newsize << 1)
    };
    this.resize__p2__I__V(newsize)
  }
});
$c_scm_ArrayBuilder$ofBoolean.prototype.$$plus$eq__Z__scm_ArrayBuilder$ofBoolean = (function(elem) {
  this.ensureSize__p2__I__V(((1 + this.size$2) | 0));
  this.elems$2.set(this.size$2, elem);
  this.size$2 = ((1 + this.size$2) | 0);
  return this
});
$c_scm_ArrayBuilder$ofBoolean.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return this.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuilder$ofBoolean(xs)
});
function $as_scm_ArrayBuilder$ofBoolean(obj) {
  return (((obj instanceof $c_scm_ArrayBuilder$ofBoolean) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayBuilder$ofBoolean"))
}
function $isArrayOf_scm_ArrayBuilder$ofBoolean(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayBuilder$ofBoolean)))
}
function $asArrayOf_scm_ArrayBuilder$ofBoolean(obj, depth) {
  return (($isArrayOf_scm_ArrayBuilder$ofBoolean(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayBuilder$ofBoolean;", depth))
}
var $d_scm_ArrayBuilder$ofBoolean = new $TypeData().initClass({
  scm_ArrayBuilder$ofBoolean: 0
}, false, "scala.collection.mutable.ArrayBuilder$ofBoolean", {
  scm_ArrayBuilder$ofBoolean: 1,
  scm_ArrayBuilder: 1,
  O: 1,
  scm_ReusableBuilder: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_ArrayBuilder$ofBoolean.prototype.$classData = $d_scm_ArrayBuilder$ofBoolean;
/** @constructor */
function $c_scm_ArrayBuilder$ofByte() {
  $c_scm_ArrayBuilder.call(this);
  this.elems$2 = null;
  this.capacity$2 = 0;
  this.size$2 = 0
}
$c_scm_ArrayBuilder$ofByte.prototype = new $h_scm_ArrayBuilder();
$c_scm_ArrayBuilder$ofByte.prototype.constructor = $c_scm_ArrayBuilder$ofByte;
/** @constructor */
function $h_scm_ArrayBuilder$ofByte() {
  /*<skip>*/
}
$h_scm_ArrayBuilder$ofByte.prototype = $c_scm_ArrayBuilder$ofByte.prototype;
$c_scm_ArrayBuilder$ofByte.prototype.init___ = (function() {
  this.capacity$2 = 0;
  this.size$2 = 0;
  return this
});
$c_scm_ArrayBuilder$ofByte.prototype.equals__O__Z = (function(other) {
  if ((other instanceof $c_scm_ArrayBuilder$ofByte)) {
    var x2 = $as_scm_ArrayBuilder$ofByte(other);
    return ((this.size$2 === x2.size$2) && (this.elems$2 === x2.elems$2))
  } else {
    return false
  }
});
$c_scm_ArrayBuilder$ofByte.prototype.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuilder$ofByte = (function(xs) {
  if ((xs instanceof $c_scm_WrappedArray$ofByte)) {
    var x2 = $as_scm_WrappedArray$ofByte(xs);
    this.ensureSize__p2__I__V(((this.size$2 + x2.length__I()) | 0));
    $m_s_Array$().copy__O__I__O__I__I__V(x2.array$6, 0, this.elems$2, this.size$2, x2.length__I());
    this.size$2 = ((this.size$2 + x2.length__I()) | 0);
    return this
  } else {
    return $as_scm_ArrayBuilder$ofByte($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs))
  }
});
$c_scm_ArrayBuilder$ofByte.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__B__scm_ArrayBuilder$ofByte($uB(elem))
});
$c_scm_ArrayBuilder$ofByte.prototype.mkArray__p2__I__AB = (function(size) {
  var newelems = $newArrayObject($d_B.getArrayOf(), [size]);
  if ((this.size$2 > 0)) {
    $m_s_Array$().copy__O__I__O__I__I__V(this.elems$2, 0, newelems, 0, this.size$2)
  };
  return newelems
});
$c_scm_ArrayBuilder$ofByte.prototype.toString__T = (function() {
  return "ArrayBuilder.ofByte"
});
$c_scm_ArrayBuilder$ofByte.prototype.result__O = (function() {
  return this.result__AB()
});
$c_scm_ArrayBuilder$ofByte.prototype.resize__p2__I__V = (function(size) {
  this.elems$2 = this.mkArray__p2__I__AB(size);
  this.capacity$2 = size
});
$c_scm_ArrayBuilder$ofByte.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__B__scm_ArrayBuilder$ofByte($uB(elem))
});
$c_scm_ArrayBuilder$ofByte.prototype.$$plus$eq__B__scm_ArrayBuilder$ofByte = (function(elem) {
  this.ensureSize__p2__I__V(((1 + this.size$2) | 0));
  this.elems$2.set(this.size$2, elem);
  this.size$2 = ((1 + this.size$2) | 0);
  return this
});
$c_scm_ArrayBuilder$ofByte.prototype.sizeHint__I__V = (function(size) {
  if ((this.capacity$2 < size)) {
    this.resize__p2__I__V(size)
  }
});
$c_scm_ArrayBuilder$ofByte.prototype.result__AB = (function() {
  if (((this.capacity$2 !== 0) && (this.capacity$2 === this.size$2))) {
    this.capacity$2 = 0;
    return this.elems$2
  } else {
    return this.mkArray__p2__I__AB(this.size$2)
  }
});
$c_scm_ArrayBuilder$ofByte.prototype.ensureSize__p2__I__V = (function(size) {
  if (((this.capacity$2 < size) || (this.capacity$2 === 0))) {
    var newsize = ((this.capacity$2 === 0) ? 16 : (this.capacity$2 << 1));
    while ((newsize < size)) {
      newsize = (newsize << 1)
    };
    this.resize__p2__I__V(newsize)
  }
});
$c_scm_ArrayBuilder$ofByte.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return this.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuilder$ofByte(xs)
});
function $as_scm_ArrayBuilder$ofByte(obj) {
  return (((obj instanceof $c_scm_ArrayBuilder$ofByte) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayBuilder$ofByte"))
}
function $isArrayOf_scm_ArrayBuilder$ofByte(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayBuilder$ofByte)))
}
function $asArrayOf_scm_ArrayBuilder$ofByte(obj, depth) {
  return (($isArrayOf_scm_ArrayBuilder$ofByte(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayBuilder$ofByte;", depth))
}
var $d_scm_ArrayBuilder$ofByte = new $TypeData().initClass({
  scm_ArrayBuilder$ofByte: 0
}, false, "scala.collection.mutable.ArrayBuilder$ofByte", {
  scm_ArrayBuilder$ofByte: 1,
  scm_ArrayBuilder: 1,
  O: 1,
  scm_ReusableBuilder: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_ArrayBuilder$ofByte.prototype.$classData = $d_scm_ArrayBuilder$ofByte;
/** @constructor */
function $c_scm_ArrayBuilder$ofChar() {
  $c_scm_ArrayBuilder.call(this);
  this.elems$2 = null;
  this.capacity$2 = 0;
  this.size$2 = 0
}
$c_scm_ArrayBuilder$ofChar.prototype = new $h_scm_ArrayBuilder();
$c_scm_ArrayBuilder$ofChar.prototype.constructor = $c_scm_ArrayBuilder$ofChar;
/** @constructor */
function $h_scm_ArrayBuilder$ofChar() {
  /*<skip>*/
}
$h_scm_ArrayBuilder$ofChar.prototype = $c_scm_ArrayBuilder$ofChar.prototype;
$c_scm_ArrayBuilder$ofChar.prototype.init___ = (function() {
  this.capacity$2 = 0;
  this.size$2 = 0;
  return this
});
$c_scm_ArrayBuilder$ofChar.prototype.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuilder$ofChar = (function(xs) {
  if ((xs instanceof $c_scm_WrappedArray$ofChar)) {
    var x2 = $as_scm_WrappedArray$ofChar(xs);
    this.ensureSize__p2__I__V(((this.size$2 + x2.length__I()) | 0));
    $m_s_Array$().copy__O__I__O__I__I__V(x2.array$6, 0, this.elems$2, this.size$2, x2.length__I());
    this.size$2 = ((this.size$2 + x2.length__I()) | 0);
    return this
  } else {
    return $as_scm_ArrayBuilder$ofChar($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs))
  }
});
$c_scm_ArrayBuilder$ofChar.prototype.equals__O__Z = (function(other) {
  if ((other instanceof $c_scm_ArrayBuilder$ofChar)) {
    var x2 = $as_scm_ArrayBuilder$ofChar(other);
    return ((this.size$2 === x2.size$2) && (this.elems$2 === x2.elems$2))
  } else {
    return false
  }
});
$c_scm_ArrayBuilder$ofChar.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  if ((elem === null)) {
    var jsx$1 = 0
  } else {
    var this$2 = $as_jl_Character(elem);
    var jsx$1 = this$2.value$1
  };
  return this.$$plus$eq__C__scm_ArrayBuilder$ofChar(jsx$1)
});
$c_scm_ArrayBuilder$ofChar.prototype.toString__T = (function() {
  return "ArrayBuilder.ofChar"
});
$c_scm_ArrayBuilder$ofChar.prototype.result__O = (function() {
  return this.result__AC()
});
$c_scm_ArrayBuilder$ofChar.prototype.resize__p2__I__V = (function(size) {
  this.elems$2 = this.mkArray__p2__I__AC(size);
  this.capacity$2 = size
});
$c_scm_ArrayBuilder$ofChar.prototype.result__AC = (function() {
  if (((this.capacity$2 !== 0) && (this.capacity$2 === this.size$2))) {
    this.capacity$2 = 0;
    return this.elems$2
  } else {
    return this.mkArray__p2__I__AC(this.size$2)
  }
});
$c_scm_ArrayBuilder$ofChar.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  if ((elem === null)) {
    var jsx$1 = 0
  } else {
    var this$2 = $as_jl_Character(elem);
    var jsx$1 = this$2.value$1
  };
  return this.$$plus$eq__C__scm_ArrayBuilder$ofChar(jsx$1)
});
$c_scm_ArrayBuilder$ofChar.prototype.sizeHint__I__V = (function(size) {
  if ((this.capacity$2 < size)) {
    this.resize__p2__I__V(size)
  }
});
$c_scm_ArrayBuilder$ofChar.prototype.mkArray__p2__I__AC = (function(size) {
  var newelems = $newArrayObject($d_C.getArrayOf(), [size]);
  if ((this.size$2 > 0)) {
    $m_s_Array$().copy__O__I__O__I__I__V(this.elems$2, 0, newelems, 0, this.size$2)
  };
  return newelems
});
$c_scm_ArrayBuilder$ofChar.prototype.ensureSize__p2__I__V = (function(size) {
  if (((this.capacity$2 < size) || (this.capacity$2 === 0))) {
    var newsize = ((this.capacity$2 === 0) ? 16 : (this.capacity$2 << 1));
    while ((newsize < size)) {
      newsize = (newsize << 1)
    };
    this.resize__p2__I__V(newsize)
  }
});
$c_scm_ArrayBuilder$ofChar.prototype.$$plus$eq__C__scm_ArrayBuilder$ofChar = (function(elem) {
  this.ensureSize__p2__I__V(((1 + this.size$2) | 0));
  this.elems$2.set(this.size$2, elem);
  this.size$2 = ((1 + this.size$2) | 0);
  return this
});
$c_scm_ArrayBuilder$ofChar.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return this.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuilder$ofChar(xs)
});
function $as_scm_ArrayBuilder$ofChar(obj) {
  return (((obj instanceof $c_scm_ArrayBuilder$ofChar) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayBuilder$ofChar"))
}
function $isArrayOf_scm_ArrayBuilder$ofChar(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayBuilder$ofChar)))
}
function $asArrayOf_scm_ArrayBuilder$ofChar(obj, depth) {
  return (($isArrayOf_scm_ArrayBuilder$ofChar(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayBuilder$ofChar;", depth))
}
var $d_scm_ArrayBuilder$ofChar = new $TypeData().initClass({
  scm_ArrayBuilder$ofChar: 0
}, false, "scala.collection.mutable.ArrayBuilder$ofChar", {
  scm_ArrayBuilder$ofChar: 1,
  scm_ArrayBuilder: 1,
  O: 1,
  scm_ReusableBuilder: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_ArrayBuilder$ofChar.prototype.$classData = $d_scm_ArrayBuilder$ofChar;
/** @constructor */
function $c_scm_ArrayBuilder$ofDouble() {
  $c_scm_ArrayBuilder.call(this);
  this.elems$2 = null;
  this.capacity$2 = 0;
  this.size$2 = 0
}
$c_scm_ArrayBuilder$ofDouble.prototype = new $h_scm_ArrayBuilder();
$c_scm_ArrayBuilder$ofDouble.prototype.constructor = $c_scm_ArrayBuilder$ofDouble;
/** @constructor */
function $h_scm_ArrayBuilder$ofDouble() {
  /*<skip>*/
}
$h_scm_ArrayBuilder$ofDouble.prototype = $c_scm_ArrayBuilder$ofDouble.prototype;
$c_scm_ArrayBuilder$ofDouble.prototype.init___ = (function() {
  this.capacity$2 = 0;
  this.size$2 = 0;
  return this
});
$c_scm_ArrayBuilder$ofDouble.prototype.equals__O__Z = (function(other) {
  if ((other instanceof $c_scm_ArrayBuilder$ofDouble)) {
    var x2 = $as_scm_ArrayBuilder$ofDouble(other);
    return ((this.size$2 === x2.size$2) && (this.elems$2 === x2.elems$2))
  } else {
    return false
  }
});
$c_scm_ArrayBuilder$ofDouble.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__D__scm_ArrayBuilder$ofDouble($uD(elem))
});
$c_scm_ArrayBuilder$ofDouble.prototype.toString__T = (function() {
  return "ArrayBuilder.ofDouble"
});
$c_scm_ArrayBuilder$ofDouble.prototype.result__AD = (function() {
  if (((this.capacity$2 !== 0) && (this.capacity$2 === this.size$2))) {
    this.capacity$2 = 0;
    return this.elems$2
  } else {
    return this.mkArray__p2__I__AD(this.size$2)
  }
});
$c_scm_ArrayBuilder$ofDouble.prototype.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuilder$ofDouble = (function(xs) {
  if ((xs instanceof $c_scm_WrappedArray$ofDouble)) {
    var x2 = $as_scm_WrappedArray$ofDouble(xs);
    this.ensureSize__p2__I__V(((this.size$2 + x2.length__I()) | 0));
    $m_s_Array$().copy__O__I__O__I__I__V(x2.array$6, 0, this.elems$2, this.size$2, x2.length__I());
    this.size$2 = ((this.size$2 + x2.length__I()) | 0);
    return this
  } else {
    return $as_scm_ArrayBuilder$ofDouble($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs))
  }
});
$c_scm_ArrayBuilder$ofDouble.prototype.result__O = (function() {
  return this.result__AD()
});
$c_scm_ArrayBuilder$ofDouble.prototype.mkArray__p2__I__AD = (function(size) {
  var newelems = $newArrayObject($d_D.getArrayOf(), [size]);
  if ((this.size$2 > 0)) {
    $m_s_Array$().copy__O__I__O__I__I__V(this.elems$2, 0, newelems, 0, this.size$2)
  };
  return newelems
});
$c_scm_ArrayBuilder$ofDouble.prototype.resize__p2__I__V = (function(size) {
  this.elems$2 = this.mkArray__p2__I__AD(size);
  this.capacity$2 = size
});
$c_scm_ArrayBuilder$ofDouble.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__D__scm_ArrayBuilder$ofDouble($uD(elem))
});
$c_scm_ArrayBuilder$ofDouble.prototype.sizeHint__I__V = (function(size) {
  if ((this.capacity$2 < size)) {
    this.resize__p2__I__V(size)
  }
});
$c_scm_ArrayBuilder$ofDouble.prototype.$$plus$eq__D__scm_ArrayBuilder$ofDouble = (function(elem) {
  this.ensureSize__p2__I__V(((1 + this.size$2) | 0));
  this.elems$2.set(this.size$2, elem);
  this.size$2 = ((1 + this.size$2) | 0);
  return this
});
$c_scm_ArrayBuilder$ofDouble.prototype.ensureSize__p2__I__V = (function(size) {
  if (((this.capacity$2 < size) || (this.capacity$2 === 0))) {
    var newsize = ((this.capacity$2 === 0) ? 16 : (this.capacity$2 << 1));
    while ((newsize < size)) {
      newsize = (newsize << 1)
    };
    this.resize__p2__I__V(newsize)
  }
});
$c_scm_ArrayBuilder$ofDouble.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return this.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuilder$ofDouble(xs)
});
function $as_scm_ArrayBuilder$ofDouble(obj) {
  return (((obj instanceof $c_scm_ArrayBuilder$ofDouble) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayBuilder$ofDouble"))
}
function $isArrayOf_scm_ArrayBuilder$ofDouble(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayBuilder$ofDouble)))
}
function $asArrayOf_scm_ArrayBuilder$ofDouble(obj, depth) {
  return (($isArrayOf_scm_ArrayBuilder$ofDouble(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayBuilder$ofDouble;", depth))
}
var $d_scm_ArrayBuilder$ofDouble = new $TypeData().initClass({
  scm_ArrayBuilder$ofDouble: 0
}, false, "scala.collection.mutable.ArrayBuilder$ofDouble", {
  scm_ArrayBuilder$ofDouble: 1,
  scm_ArrayBuilder: 1,
  O: 1,
  scm_ReusableBuilder: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_ArrayBuilder$ofDouble.prototype.$classData = $d_scm_ArrayBuilder$ofDouble;
/** @constructor */
function $c_scm_ArrayBuilder$ofFloat() {
  $c_scm_ArrayBuilder.call(this);
  this.elems$2 = null;
  this.capacity$2 = 0;
  this.size$2 = 0
}
$c_scm_ArrayBuilder$ofFloat.prototype = new $h_scm_ArrayBuilder();
$c_scm_ArrayBuilder$ofFloat.prototype.constructor = $c_scm_ArrayBuilder$ofFloat;
/** @constructor */
function $h_scm_ArrayBuilder$ofFloat() {
  /*<skip>*/
}
$h_scm_ArrayBuilder$ofFloat.prototype = $c_scm_ArrayBuilder$ofFloat.prototype;
$c_scm_ArrayBuilder$ofFloat.prototype.init___ = (function() {
  this.capacity$2 = 0;
  this.size$2 = 0;
  return this
});
$c_scm_ArrayBuilder$ofFloat.prototype.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuilder$ofFloat = (function(xs) {
  if ((xs instanceof $c_scm_WrappedArray$ofFloat)) {
    var x2 = $as_scm_WrappedArray$ofFloat(xs);
    this.ensureSize__p2__I__V(((this.size$2 + x2.length__I()) | 0));
    $m_s_Array$().copy__O__I__O__I__I__V(x2.array$6, 0, this.elems$2, this.size$2, x2.length__I());
    this.size$2 = ((this.size$2 + x2.length__I()) | 0);
    return this
  } else {
    return $as_scm_ArrayBuilder$ofFloat($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs))
  }
});
$c_scm_ArrayBuilder$ofFloat.prototype.equals__O__Z = (function(other) {
  if ((other instanceof $c_scm_ArrayBuilder$ofFloat)) {
    var x2 = $as_scm_ArrayBuilder$ofFloat(other);
    return ((this.size$2 === x2.size$2) && (this.elems$2 === x2.elems$2))
  } else {
    return false
  }
});
$c_scm_ArrayBuilder$ofFloat.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__F__scm_ArrayBuilder$ofFloat($uF(elem))
});
$c_scm_ArrayBuilder$ofFloat.prototype.toString__T = (function() {
  return "ArrayBuilder.ofFloat"
});
$c_scm_ArrayBuilder$ofFloat.prototype.result__O = (function() {
  return this.result__AF()
});
$c_scm_ArrayBuilder$ofFloat.prototype.resize__p2__I__V = (function(size) {
  this.elems$2 = this.mkArray__p2__I__AF(size);
  this.capacity$2 = size
});
$c_scm_ArrayBuilder$ofFloat.prototype.$$plus$eq__F__scm_ArrayBuilder$ofFloat = (function(elem) {
  this.ensureSize__p2__I__V(((1 + this.size$2) | 0));
  this.elems$2.set(this.size$2, elem);
  this.size$2 = ((1 + this.size$2) | 0);
  return this
});
$c_scm_ArrayBuilder$ofFloat.prototype.result__AF = (function() {
  if (((this.capacity$2 !== 0) && (this.capacity$2 === this.size$2))) {
    this.capacity$2 = 0;
    return this.elems$2
  } else {
    return this.mkArray__p2__I__AF(this.size$2)
  }
});
$c_scm_ArrayBuilder$ofFloat.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__F__scm_ArrayBuilder$ofFloat($uF(elem))
});
$c_scm_ArrayBuilder$ofFloat.prototype.sizeHint__I__V = (function(size) {
  if ((this.capacity$2 < size)) {
    this.resize__p2__I__V(size)
  }
});
$c_scm_ArrayBuilder$ofFloat.prototype.mkArray__p2__I__AF = (function(size) {
  var newelems = $newArrayObject($d_F.getArrayOf(), [size]);
  if ((this.size$2 > 0)) {
    $m_s_Array$().copy__O__I__O__I__I__V(this.elems$2, 0, newelems, 0, this.size$2)
  };
  return newelems
});
$c_scm_ArrayBuilder$ofFloat.prototype.ensureSize__p2__I__V = (function(size) {
  if (((this.capacity$2 < size) || (this.capacity$2 === 0))) {
    var newsize = ((this.capacity$2 === 0) ? 16 : (this.capacity$2 << 1));
    while ((newsize < size)) {
      newsize = (newsize << 1)
    };
    this.resize__p2__I__V(newsize)
  }
});
$c_scm_ArrayBuilder$ofFloat.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return this.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuilder$ofFloat(xs)
});
function $as_scm_ArrayBuilder$ofFloat(obj) {
  return (((obj instanceof $c_scm_ArrayBuilder$ofFloat) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayBuilder$ofFloat"))
}
function $isArrayOf_scm_ArrayBuilder$ofFloat(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayBuilder$ofFloat)))
}
function $asArrayOf_scm_ArrayBuilder$ofFloat(obj, depth) {
  return (($isArrayOf_scm_ArrayBuilder$ofFloat(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayBuilder$ofFloat;", depth))
}
var $d_scm_ArrayBuilder$ofFloat = new $TypeData().initClass({
  scm_ArrayBuilder$ofFloat: 0
}, false, "scala.collection.mutable.ArrayBuilder$ofFloat", {
  scm_ArrayBuilder$ofFloat: 1,
  scm_ArrayBuilder: 1,
  O: 1,
  scm_ReusableBuilder: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_ArrayBuilder$ofFloat.prototype.$classData = $d_scm_ArrayBuilder$ofFloat;
/** @constructor */
function $c_scm_ArrayBuilder$ofInt() {
  $c_scm_ArrayBuilder.call(this);
  this.elems$2 = null;
  this.capacity$2 = 0;
  this.size$2 = 0
}
$c_scm_ArrayBuilder$ofInt.prototype = new $h_scm_ArrayBuilder();
$c_scm_ArrayBuilder$ofInt.prototype.constructor = $c_scm_ArrayBuilder$ofInt;
/** @constructor */
function $h_scm_ArrayBuilder$ofInt() {
  /*<skip>*/
}
$h_scm_ArrayBuilder$ofInt.prototype = $c_scm_ArrayBuilder$ofInt.prototype;
$c_scm_ArrayBuilder$ofInt.prototype.init___ = (function() {
  this.capacity$2 = 0;
  this.size$2 = 0;
  return this
});
$c_scm_ArrayBuilder$ofInt.prototype.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuilder$ofInt = (function(xs) {
  if ((xs instanceof $c_scm_WrappedArray$ofInt)) {
    var x2 = $as_scm_WrappedArray$ofInt(xs);
    this.ensureSize__p2__I__V(((this.size$2 + x2.length__I()) | 0));
    $m_s_Array$().copy__O__I__O__I__I__V(x2.array$6, 0, this.elems$2, this.size$2, x2.length__I());
    this.size$2 = ((this.size$2 + x2.length__I()) | 0);
    return this
  } else {
    return $as_scm_ArrayBuilder$ofInt($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs))
  }
});
$c_scm_ArrayBuilder$ofInt.prototype.equals__O__Z = (function(other) {
  if ((other instanceof $c_scm_ArrayBuilder$ofInt)) {
    var x2 = $as_scm_ArrayBuilder$ofInt(other);
    return ((this.size$2 === x2.size$2) && (this.elems$2 === x2.elems$2))
  } else {
    return false
  }
});
$c_scm_ArrayBuilder$ofInt.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__I__scm_ArrayBuilder$ofInt($uI(elem))
});
$c_scm_ArrayBuilder$ofInt.prototype.toString__T = (function() {
  return "ArrayBuilder.ofInt"
});
$c_scm_ArrayBuilder$ofInt.prototype.result__O = (function() {
  return this.result__AI()
});
$c_scm_ArrayBuilder$ofInt.prototype.resize__p2__I__V = (function(size) {
  this.elems$2 = this.mkArray__p2__I__AI(size);
  this.capacity$2 = size
});
$c_scm_ArrayBuilder$ofInt.prototype.result__AI = (function() {
  if (((this.capacity$2 !== 0) && (this.capacity$2 === this.size$2))) {
    this.capacity$2 = 0;
    return this.elems$2
  } else {
    return this.mkArray__p2__I__AI(this.size$2)
  }
});
$c_scm_ArrayBuilder$ofInt.prototype.$$plus$eq__I__scm_ArrayBuilder$ofInt = (function(elem) {
  this.ensureSize__p2__I__V(((1 + this.size$2) | 0));
  this.elems$2.set(this.size$2, elem);
  this.size$2 = ((1 + this.size$2) | 0);
  return this
});
$c_scm_ArrayBuilder$ofInt.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__I__scm_ArrayBuilder$ofInt($uI(elem))
});
$c_scm_ArrayBuilder$ofInt.prototype.mkArray__p2__I__AI = (function(size) {
  var newelems = $newArrayObject($d_I.getArrayOf(), [size]);
  if ((this.size$2 > 0)) {
    $m_s_Array$().copy__O__I__O__I__I__V(this.elems$2, 0, newelems, 0, this.size$2)
  };
  return newelems
});
$c_scm_ArrayBuilder$ofInt.prototype.sizeHint__I__V = (function(size) {
  if ((this.capacity$2 < size)) {
    this.resize__p2__I__V(size)
  }
});
$c_scm_ArrayBuilder$ofInt.prototype.ensureSize__p2__I__V = (function(size) {
  if (((this.capacity$2 < size) || (this.capacity$2 === 0))) {
    var newsize = ((this.capacity$2 === 0) ? 16 : (this.capacity$2 << 1));
    while ((newsize < size)) {
      newsize = (newsize << 1)
    };
    this.resize__p2__I__V(newsize)
  }
});
$c_scm_ArrayBuilder$ofInt.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return this.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuilder$ofInt(xs)
});
function $as_scm_ArrayBuilder$ofInt(obj) {
  return (((obj instanceof $c_scm_ArrayBuilder$ofInt) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayBuilder$ofInt"))
}
function $isArrayOf_scm_ArrayBuilder$ofInt(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayBuilder$ofInt)))
}
function $asArrayOf_scm_ArrayBuilder$ofInt(obj, depth) {
  return (($isArrayOf_scm_ArrayBuilder$ofInt(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayBuilder$ofInt;", depth))
}
var $d_scm_ArrayBuilder$ofInt = new $TypeData().initClass({
  scm_ArrayBuilder$ofInt: 0
}, false, "scala.collection.mutable.ArrayBuilder$ofInt", {
  scm_ArrayBuilder$ofInt: 1,
  scm_ArrayBuilder: 1,
  O: 1,
  scm_ReusableBuilder: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_ArrayBuilder$ofInt.prototype.$classData = $d_scm_ArrayBuilder$ofInt;
/** @constructor */
function $c_scm_ArrayBuilder$ofLong() {
  $c_scm_ArrayBuilder.call(this);
  this.elems$2 = null;
  this.capacity$2 = 0;
  this.size$2 = 0
}
$c_scm_ArrayBuilder$ofLong.prototype = new $h_scm_ArrayBuilder();
$c_scm_ArrayBuilder$ofLong.prototype.constructor = $c_scm_ArrayBuilder$ofLong;
/** @constructor */
function $h_scm_ArrayBuilder$ofLong() {
  /*<skip>*/
}
$h_scm_ArrayBuilder$ofLong.prototype = $c_scm_ArrayBuilder$ofLong.prototype;
$c_scm_ArrayBuilder$ofLong.prototype.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuilder$ofLong = (function(xs) {
  if ((xs instanceof $c_scm_WrappedArray$ofLong)) {
    var x2 = $as_scm_WrappedArray$ofLong(xs);
    this.ensureSize__p2__I__V(((this.size$2 + x2.length__I()) | 0));
    $m_s_Array$().copy__O__I__O__I__I__V(x2.array$6, 0, this.elems$2, this.size$2, x2.length__I());
    this.size$2 = ((this.size$2 + x2.length__I()) | 0);
    return this
  } else {
    return $as_scm_ArrayBuilder$ofLong($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs))
  }
});
$c_scm_ArrayBuilder$ofLong.prototype.init___ = (function() {
  this.capacity$2 = 0;
  this.size$2 = 0;
  return this
});
$c_scm_ArrayBuilder$ofLong.prototype.$$plus$eq__J__scm_ArrayBuilder$ofLong = (function(elem) {
  this.ensureSize__p2__I__V(((1 + this.size$2) | 0));
  this.elems$2.set(this.size$2, elem);
  this.size$2 = ((1 + this.size$2) | 0);
  return this
});
$c_scm_ArrayBuilder$ofLong.prototype.equals__O__Z = (function(other) {
  if ((other instanceof $c_scm_ArrayBuilder$ofLong)) {
    var x2 = $as_scm_ArrayBuilder$ofLong(other);
    return ((this.size$2 === x2.size$2) && (this.elems$2 === x2.elems$2))
  } else {
    return false
  }
});
$c_scm_ArrayBuilder$ofLong.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__J__scm_ArrayBuilder$ofLong($uJ(elem))
});
$c_scm_ArrayBuilder$ofLong.prototype.result__AJ = (function() {
  if (((this.capacity$2 !== 0) && (this.capacity$2 === this.size$2))) {
    this.capacity$2 = 0;
    return this.elems$2
  } else {
    return this.mkArray__p2__I__AJ(this.size$2)
  }
});
$c_scm_ArrayBuilder$ofLong.prototype.toString__T = (function() {
  return "ArrayBuilder.ofLong"
});
$c_scm_ArrayBuilder$ofLong.prototype.result__O = (function() {
  return this.result__AJ()
});
$c_scm_ArrayBuilder$ofLong.prototype.resize__p2__I__V = (function(size) {
  this.elems$2 = this.mkArray__p2__I__AJ(size);
  this.capacity$2 = size
});
$c_scm_ArrayBuilder$ofLong.prototype.mkArray__p2__I__AJ = (function(size) {
  var newelems = $newArrayObject($d_J.getArrayOf(), [size]);
  if ((this.size$2 > 0)) {
    $m_s_Array$().copy__O__I__O__I__I__V(this.elems$2, 0, newelems, 0, this.size$2)
  };
  return newelems
});
$c_scm_ArrayBuilder$ofLong.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__J__scm_ArrayBuilder$ofLong($uJ(elem))
});
$c_scm_ArrayBuilder$ofLong.prototype.sizeHint__I__V = (function(size) {
  if ((this.capacity$2 < size)) {
    this.resize__p2__I__V(size)
  }
});
$c_scm_ArrayBuilder$ofLong.prototype.ensureSize__p2__I__V = (function(size) {
  if (((this.capacity$2 < size) || (this.capacity$2 === 0))) {
    var newsize = ((this.capacity$2 === 0) ? 16 : (this.capacity$2 << 1));
    while ((newsize < size)) {
      newsize = (newsize << 1)
    };
    this.resize__p2__I__V(newsize)
  }
});
$c_scm_ArrayBuilder$ofLong.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return this.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuilder$ofLong(xs)
});
function $as_scm_ArrayBuilder$ofLong(obj) {
  return (((obj instanceof $c_scm_ArrayBuilder$ofLong) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayBuilder$ofLong"))
}
function $isArrayOf_scm_ArrayBuilder$ofLong(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayBuilder$ofLong)))
}
function $asArrayOf_scm_ArrayBuilder$ofLong(obj, depth) {
  return (($isArrayOf_scm_ArrayBuilder$ofLong(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayBuilder$ofLong;", depth))
}
var $d_scm_ArrayBuilder$ofLong = new $TypeData().initClass({
  scm_ArrayBuilder$ofLong: 0
}, false, "scala.collection.mutable.ArrayBuilder$ofLong", {
  scm_ArrayBuilder$ofLong: 1,
  scm_ArrayBuilder: 1,
  O: 1,
  scm_ReusableBuilder: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_ArrayBuilder$ofLong.prototype.$classData = $d_scm_ArrayBuilder$ofLong;
/** @constructor */
function $c_scm_ArrayBuilder$ofRef() {
  $c_scm_ArrayBuilder.call(this);
  this.evidence$2$2 = null;
  this.elems$2 = null;
  this.capacity$2 = 0;
  this.size$2 = 0
}
$c_scm_ArrayBuilder$ofRef.prototype = new $h_scm_ArrayBuilder();
$c_scm_ArrayBuilder$ofRef.prototype.constructor = $c_scm_ArrayBuilder$ofRef;
/** @constructor */
function $h_scm_ArrayBuilder$ofRef() {
  /*<skip>*/
}
$h_scm_ArrayBuilder$ofRef.prototype = $c_scm_ArrayBuilder$ofRef.prototype;
$c_scm_ArrayBuilder$ofRef.prototype.init___s_reflect_ClassTag = (function(evidence$2) {
  this.evidence$2$2 = evidence$2;
  this.capacity$2 = 0;
  this.size$2 = 0;
  return this
});
$c_scm_ArrayBuilder$ofRef.prototype.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuilder$ofRef = (function(xs) {
  if ((xs instanceof $c_scm_WrappedArray$ofRef)) {
    var x2 = $as_scm_WrappedArray$ofRef(xs);
    this.ensureSize__p2__I__V(((this.size$2 + x2.length__I()) | 0));
    $m_s_Array$().copy__O__I__O__I__I__V(x2.array$6, 0, this.elems$2, this.size$2, x2.length__I());
    this.size$2 = ((this.size$2 + x2.length__I()) | 0);
    return this
  } else {
    return $as_scm_ArrayBuilder$ofRef($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs))
  }
});
$c_scm_ArrayBuilder$ofRef.prototype.equals__O__Z = (function(other) {
  if ((other instanceof $c_scm_ArrayBuilder$ofRef)) {
    var x2 = $as_scm_ArrayBuilder$ofRef(other);
    return ((this.size$2 === x2.size$2) && (this.elems$2 === x2.elems$2))
  } else {
    return false
  }
});
$c_scm_ArrayBuilder$ofRef.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__O__scm_ArrayBuilder$ofRef(elem)
});
$c_scm_ArrayBuilder$ofRef.prototype.toString__T = (function() {
  return "ArrayBuilder.ofRef"
});
$c_scm_ArrayBuilder$ofRef.prototype.result__O = (function() {
  return this.result__AO()
});
$c_scm_ArrayBuilder$ofRef.prototype.resize__p2__I__V = (function(size) {
  this.elems$2 = this.mkArray__p2__I__AO(size);
  this.capacity$2 = size
});
$c_scm_ArrayBuilder$ofRef.prototype.$$plus$eq__O__scm_ArrayBuilder$ofRef = (function(elem) {
  this.ensureSize__p2__I__V(((1 + this.size$2) | 0));
  this.elems$2.set(this.size$2, elem);
  this.size$2 = ((1 + this.size$2) | 0);
  return this
});
$c_scm_ArrayBuilder$ofRef.prototype.result__AO = (function() {
  if (((this.capacity$2 !== 0) && (this.capacity$2 === this.size$2))) {
    this.capacity$2 = 0;
    return this.elems$2
  } else {
    return this.mkArray__p2__I__AO(this.size$2)
  }
});
$c_scm_ArrayBuilder$ofRef.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__O__scm_ArrayBuilder$ofRef(elem)
});
$c_scm_ArrayBuilder$ofRef.prototype.sizeHint__I__V = (function(size) {
  if ((this.capacity$2 < size)) {
    this.resize__p2__I__V(size)
  }
});
$c_scm_ArrayBuilder$ofRef.prototype.ensureSize__p2__I__V = (function(size) {
  if (((this.capacity$2 < size) || (this.capacity$2 === 0))) {
    var newsize = ((this.capacity$2 === 0) ? 16 : (this.capacity$2 << 1));
    while ((newsize < size)) {
      newsize = (newsize << 1)
    };
    this.resize__p2__I__V(newsize)
  }
});
$c_scm_ArrayBuilder$ofRef.prototype.mkArray__p2__I__AO = (function(size) {
  var newelems = $asArrayOf_O(this.evidence$2$2.newArray__I__O(size), 1);
  if ((this.size$2 > 0)) {
    $m_s_Array$().copy__O__I__O__I__I__V(this.elems$2, 0, newelems, 0, this.size$2)
  };
  return newelems
});
$c_scm_ArrayBuilder$ofRef.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return this.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuilder$ofRef(xs)
});
function $as_scm_ArrayBuilder$ofRef(obj) {
  return (((obj instanceof $c_scm_ArrayBuilder$ofRef) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayBuilder$ofRef"))
}
function $isArrayOf_scm_ArrayBuilder$ofRef(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayBuilder$ofRef)))
}
function $asArrayOf_scm_ArrayBuilder$ofRef(obj, depth) {
  return (($isArrayOf_scm_ArrayBuilder$ofRef(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayBuilder$ofRef;", depth))
}
var $d_scm_ArrayBuilder$ofRef = new $TypeData().initClass({
  scm_ArrayBuilder$ofRef: 0
}, false, "scala.collection.mutable.ArrayBuilder$ofRef", {
  scm_ArrayBuilder$ofRef: 1,
  scm_ArrayBuilder: 1,
  O: 1,
  scm_ReusableBuilder: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_ArrayBuilder$ofRef.prototype.$classData = $d_scm_ArrayBuilder$ofRef;
/** @constructor */
function $c_scm_ArrayBuilder$ofShort() {
  $c_scm_ArrayBuilder.call(this);
  this.elems$2 = null;
  this.capacity$2 = 0;
  this.size$2 = 0
}
$c_scm_ArrayBuilder$ofShort.prototype = new $h_scm_ArrayBuilder();
$c_scm_ArrayBuilder$ofShort.prototype.constructor = $c_scm_ArrayBuilder$ofShort;
/** @constructor */
function $h_scm_ArrayBuilder$ofShort() {
  /*<skip>*/
}
$h_scm_ArrayBuilder$ofShort.prototype = $c_scm_ArrayBuilder$ofShort.prototype;
$c_scm_ArrayBuilder$ofShort.prototype.init___ = (function() {
  this.capacity$2 = 0;
  this.size$2 = 0;
  return this
});
$c_scm_ArrayBuilder$ofShort.prototype.equals__O__Z = (function(other) {
  if ((other instanceof $c_scm_ArrayBuilder$ofShort)) {
    var x2 = $as_scm_ArrayBuilder$ofShort(other);
    return ((this.size$2 === x2.size$2) && (this.elems$2 === x2.elems$2))
  } else {
    return false
  }
});
$c_scm_ArrayBuilder$ofShort.prototype.$$plus$eq__S__scm_ArrayBuilder$ofShort = (function(elem) {
  this.ensureSize__p2__I__V(((1 + this.size$2) | 0));
  this.elems$2.set(this.size$2, elem);
  this.size$2 = ((1 + this.size$2) | 0);
  return this
});
$c_scm_ArrayBuilder$ofShort.prototype.result__AS = (function() {
  if (((this.capacity$2 !== 0) && (this.capacity$2 === this.size$2))) {
    this.capacity$2 = 0;
    return this.elems$2
  } else {
    return this.mkArray__p2__I__AS(this.size$2)
  }
});
$c_scm_ArrayBuilder$ofShort.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__S__scm_ArrayBuilder$ofShort($uS(elem))
});
$c_scm_ArrayBuilder$ofShort.prototype.toString__T = (function() {
  return "ArrayBuilder.ofShort"
});
$c_scm_ArrayBuilder$ofShort.prototype.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuilder$ofShort = (function(xs) {
  if ((xs instanceof $c_scm_WrappedArray$ofShort)) {
    var x2 = $as_scm_WrappedArray$ofShort(xs);
    this.ensureSize__p2__I__V(((this.size$2 + x2.length__I()) | 0));
    $m_s_Array$().copy__O__I__O__I__I__V(x2.array$6, 0, this.elems$2, this.size$2, x2.length__I());
    this.size$2 = ((this.size$2 + x2.length__I()) | 0);
    return this
  } else {
    return $as_scm_ArrayBuilder$ofShort($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs))
  }
});
$c_scm_ArrayBuilder$ofShort.prototype.result__O = (function() {
  return this.result__AS()
});
$c_scm_ArrayBuilder$ofShort.prototype.resize__p2__I__V = (function(size) {
  this.elems$2 = this.mkArray__p2__I__AS(size);
  this.capacity$2 = size
});
$c_scm_ArrayBuilder$ofShort.prototype.mkArray__p2__I__AS = (function(size) {
  var newelems = $newArrayObject($d_S.getArrayOf(), [size]);
  if ((this.size$2 > 0)) {
    $m_s_Array$().copy__O__I__O__I__I__V(this.elems$2, 0, newelems, 0, this.size$2)
  };
  return newelems
});
$c_scm_ArrayBuilder$ofShort.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__S__scm_ArrayBuilder$ofShort($uS(elem))
});
$c_scm_ArrayBuilder$ofShort.prototype.sizeHint__I__V = (function(size) {
  if ((this.capacity$2 < size)) {
    this.resize__p2__I__V(size)
  }
});
$c_scm_ArrayBuilder$ofShort.prototype.ensureSize__p2__I__V = (function(size) {
  if (((this.capacity$2 < size) || (this.capacity$2 === 0))) {
    var newsize = ((this.capacity$2 === 0) ? 16 : (this.capacity$2 << 1));
    while ((newsize < size)) {
      newsize = (newsize << 1)
    };
    this.resize__p2__I__V(newsize)
  }
});
$c_scm_ArrayBuilder$ofShort.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return this.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuilder$ofShort(xs)
});
function $as_scm_ArrayBuilder$ofShort(obj) {
  return (((obj instanceof $c_scm_ArrayBuilder$ofShort) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayBuilder$ofShort"))
}
function $isArrayOf_scm_ArrayBuilder$ofShort(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayBuilder$ofShort)))
}
function $asArrayOf_scm_ArrayBuilder$ofShort(obj, depth) {
  return (($isArrayOf_scm_ArrayBuilder$ofShort(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayBuilder$ofShort;", depth))
}
var $d_scm_ArrayBuilder$ofShort = new $TypeData().initClass({
  scm_ArrayBuilder$ofShort: 0
}, false, "scala.collection.mutable.ArrayBuilder$ofShort", {
  scm_ArrayBuilder$ofShort: 1,
  scm_ArrayBuilder: 1,
  O: 1,
  scm_ReusableBuilder: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_ArrayBuilder$ofShort.prototype.$classData = $d_scm_ArrayBuilder$ofShort;
/** @constructor */
function $c_scm_ArrayBuilder$ofUnit() {
  $c_scm_ArrayBuilder.call(this);
  this.size$2 = 0
}
$c_scm_ArrayBuilder$ofUnit.prototype = new $h_scm_ArrayBuilder();
$c_scm_ArrayBuilder$ofUnit.prototype.constructor = $c_scm_ArrayBuilder$ofUnit;
/** @constructor */
function $h_scm_ArrayBuilder$ofUnit() {
  /*<skip>*/
}
$h_scm_ArrayBuilder$ofUnit.prototype = $c_scm_ArrayBuilder$ofUnit.prototype;
$c_scm_ArrayBuilder$ofUnit.prototype.init___ = (function() {
  this.size$2 = 0;
  return this
});
$c_scm_ArrayBuilder$ofUnit.prototype.equals__O__Z = (function(other) {
  if ((other instanceof $c_scm_ArrayBuilder$ofUnit)) {
    var x2 = $as_scm_ArrayBuilder$ofUnit(other);
    return (this.size$2 === x2.size$2)
  } else {
    return false
  }
});
$c_scm_ArrayBuilder$ofUnit.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__sr_BoxedUnit__scm_ArrayBuilder$ofUnit($asUnit(elem))
});
$c_scm_ArrayBuilder$ofUnit.prototype.toString__T = (function() {
  return "ArrayBuilder.ofUnit"
});
$c_scm_ArrayBuilder$ofUnit.prototype.$$plus$eq__sr_BoxedUnit__scm_ArrayBuilder$ofUnit = (function(elem) {
  this.size$2 = ((1 + this.size$2) | 0);
  return this
});
$c_scm_ArrayBuilder$ofUnit.prototype.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuilder$ofUnit = (function(xs) {
  this.size$2 = ((this.size$2 + xs.size__I()) | 0);
  return this
});
$c_scm_ArrayBuilder$ofUnit.prototype.result__O = (function() {
  return this.result__Asr_BoxedUnit()
});
$c_scm_ArrayBuilder$ofUnit.prototype.result__Asr_BoxedUnit = (function() {
  var ans = $newArrayObject($d_sr_BoxedUnit.getArrayOf(), [this.size$2]);
  var i = 0;
  while ((i < this.size$2)) {
    ans.set(i, (void 0));
    i = ((1 + i) | 0)
  };
  return ans
});
$c_scm_ArrayBuilder$ofUnit.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__sr_BoxedUnit__scm_ArrayBuilder$ofUnit($asUnit(elem))
});
$c_scm_ArrayBuilder$ofUnit.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return this.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuilder$ofUnit(xs)
});
function $as_scm_ArrayBuilder$ofUnit(obj) {
  return (((obj instanceof $c_scm_ArrayBuilder$ofUnit) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayBuilder$ofUnit"))
}
function $isArrayOf_scm_ArrayBuilder$ofUnit(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayBuilder$ofUnit)))
}
function $asArrayOf_scm_ArrayBuilder$ofUnit(obj, depth) {
  return (($isArrayOf_scm_ArrayBuilder$ofUnit(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayBuilder$ofUnit;", depth))
}
var $d_scm_ArrayBuilder$ofUnit = new $TypeData().initClass({
  scm_ArrayBuilder$ofUnit: 0
}, false, "scala.collection.mutable.ArrayBuilder$ofUnit", {
  scm_ArrayBuilder$ofUnit: 1,
  scm_ArrayBuilder: 1,
  O: 1,
  scm_ReusableBuilder: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_ArrayBuilder$ofUnit.prototype.$classData = $d_scm_ArrayBuilder$ofUnit;
/** @constructor */
function $c_scm_HashSet$() {
  $c_scg_MutableSetFactory.call(this)
}
$c_scm_HashSet$.prototype = new $h_scg_MutableSetFactory();
$c_scm_HashSet$.prototype.constructor = $c_scm_HashSet$;
/** @constructor */
function $h_scm_HashSet$() {
  /*<skip>*/
}
$h_scm_HashSet$.prototype = $c_scm_HashSet$.prototype;
$c_scm_HashSet$.prototype.init___ = (function() {
  return this
});
$c_scm_HashSet$.prototype.empty__sc_GenTraversable = (function() {
  return new $c_scm_HashSet().init___()
});
var $d_scm_HashSet$ = new $TypeData().initClass({
  scm_HashSet$: 0
}, false, "scala.collection.mutable.HashSet$", {
  scm_HashSet$: 1,
  scg_MutableSetFactory: 1,
  scg_SetFactory: 1,
  scg_GenSetFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_GenericSeqCompanion: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_HashSet$.prototype.$classData = $d_scm_HashSet$;
var $n_scm_HashSet$ = (void 0);
function $m_scm_HashSet$() {
  if ((!$n_scm_HashSet$)) {
    $n_scm_HashSet$ = new $c_scm_HashSet$().init___()
  };
  return $n_scm_HashSet$
}
/** @constructor */
function $c_scm_LinkedHashSet$() {
  $c_scg_MutableSetFactory.call(this)
}
$c_scm_LinkedHashSet$.prototype = new $h_scg_MutableSetFactory();
$c_scm_LinkedHashSet$.prototype.constructor = $c_scm_LinkedHashSet$;
/** @constructor */
function $h_scm_LinkedHashSet$() {
  /*<skip>*/
}
$h_scm_LinkedHashSet$.prototype = $c_scm_LinkedHashSet$.prototype;
$c_scm_LinkedHashSet$.prototype.init___ = (function() {
  return this
});
$c_scm_LinkedHashSet$.prototype.empty__sc_GenTraversable = (function() {
  return new $c_scm_LinkedHashSet().init___()
});
var $d_scm_LinkedHashSet$ = new $TypeData().initClass({
  scm_LinkedHashSet$: 0
}, false, "scala.collection.mutable.LinkedHashSet$", {
  scm_LinkedHashSet$: 1,
  scg_MutableSetFactory: 1,
  scg_SetFactory: 1,
  scg_GenSetFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_GenericSeqCompanion: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_LinkedHashSet$.prototype.$classData = $d_scm_LinkedHashSet$;
var $n_scm_LinkedHashSet$ = (void 0);
function $m_scm_LinkedHashSet$() {
  if ((!$n_scm_LinkedHashSet$)) {
    $n_scm_LinkedHashSet$ = new $c_scm_LinkedHashSet$().init___()
  };
  return $n_scm_LinkedHashSet$
}
/** @constructor */
function $c_sjs_js_JavaScriptException() {
  $c_jl_RuntimeException.call(this);
  this.exception$4 = null
}
$c_sjs_js_JavaScriptException.prototype = new $h_jl_RuntimeException();
$c_sjs_js_JavaScriptException.prototype.constructor = $c_sjs_js_JavaScriptException;
/** @constructor */
function $h_sjs_js_JavaScriptException() {
  /*<skip>*/
}
$h_sjs_js_JavaScriptException.prototype = $c_sjs_js_JavaScriptException.prototype;
$c_sjs_js_JavaScriptException.prototype.productPrefix__T = (function() {
  return "JavaScriptException"
});
$c_sjs_js_JavaScriptException.prototype.productArity__I = (function() {
  return 1
});
$c_sjs_js_JavaScriptException.prototype.fillInStackTrace__jl_Throwable = (function() {
  var e = this.exception$4;
  this.stackdata = e;
  return this
});
$c_sjs_js_JavaScriptException.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_sjs_js_JavaScriptException)) {
    var JavaScriptException$1 = $as_sjs_js_JavaScriptException(x$1);
    return $m_sr_BoxesRunTime$().equals__O__O__Z(this.exception$4, JavaScriptException$1.exception$4)
  } else {
    return false
  }
});
$c_sjs_js_JavaScriptException.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.exception$4;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_sjs_js_JavaScriptException.prototype.getMessage__T = (function() {
  return $objectToString(this.exception$4)
});
$c_sjs_js_JavaScriptException.prototype.init___O = (function(exception) {
  this.exception$4 = exception;
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, null, null, true, true);
  return this
});
$c_sjs_js_JavaScriptException.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_sjs_js_JavaScriptException.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_sjs_js_JavaScriptException(obj) {
  return (((obj instanceof $c_sjs_js_JavaScriptException) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.scalajs.js.JavaScriptException"))
}
function $isArrayOf_sjs_js_JavaScriptException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sjs_js_JavaScriptException)))
}
function $asArrayOf_sjs_js_JavaScriptException(obj, depth) {
  return (($isArrayOf_sjs_js_JavaScriptException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.scalajs.js.JavaScriptException;", depth))
}
var $d_sjs_js_JavaScriptException = new $TypeData().initClass({
  sjs_js_JavaScriptException: 0
}, false, "scala.scalajs.js.JavaScriptException", {
  sjs_js_JavaScriptException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1
});
$c_sjs_js_JavaScriptException.prototype.$classData = $d_sjs_js_JavaScriptException;
/** @constructor */
function $c_Lamf_client_model_BoolField() {
  $c_O.call(this);
  this.amf$client$model$BoolField$$$undinternal$1 = null;
  this.$$undoption$1 = null;
  this.option$1 = null
}
$c_Lamf_client_model_BoolField.prototype = new $h_O();
$c_Lamf_client_model_BoolField.prototype.constructor = $c_Lamf_client_model_BoolField;
/** @constructor */
function $h_Lamf_client_model_BoolField() {
  /*<skip>*/
}
$h_Lamf_client_model_BoolField.prototype = $c_Lamf_client_model_BoolField.prototype;
$c_Lamf_client_model_BoolField.prototype.productPrefix__T = (function() {
  return "BoolField"
});
$c_Lamf_client_model_BoolField.prototype.$$js$exported$meth$is__O__O = (function(other) {
  return $f_Lamf_client_model_ValueField__is__O__Z(this, other)
});
$c_Lamf_client_model_BoolField.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_BoolField.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_BoolField)) {
    var BoolField$1 = $as_Lamf_client_model_BoolField(x$1);
    var x = this.amf$client$model$BoolField$$$undinternal$1;
    var x$2 = BoolField$1.amf$client$model$BoolField$$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_BoolField.prototype.$$js$exported$meth$toString__O = (function() {
  return $f_Lamf_client_model_ValueField__toString__T(this)
});
$c_Lamf_client_model_BoolField.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.amf$client$model$BoolField$$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_BoolField.prototype.toString__T = (function() {
  return $f_Lamf_client_model_ValueField__toString__T(this)
});
$c_Lamf_client_model_BoolField.prototype.value__Z = (function() {
  var x1 = this.$$undoption$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var v = $uZ(x2.value$2);
    return v
  } else {
    return false
  }
});
$c_Lamf_client_model_BoolField.prototype.$$js$exported$prop$nonNull__O = (function() {
  return this.$$undoption$1.isDefined__Z()
});
$c_Lamf_client_model_BoolField.prototype.annotations__Lamf_client_model_Annotations = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.amf$client$model$BoolField$$$undinternal$1.annotations$1;
  $m_Lamf_client_convert_CoreClientConverters$().AnnotationsFieldMatcher__Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$();
  return new $c_Lamf_client_model_Annotations().init___Lamf_core_parser_Annotations(from)
});
$c_Lamf_client_model_BoolField.prototype.$$js$exported$meth$value__O = (function() {
  return this.value__Z()
});
$c_Lamf_client_model_BoolField.prototype.init___Lamf_core_model_BoolField = (function(_internal) {
  this.amf$client$model$BoolField$$$undinternal$1 = _internal;
  this.$$undoption$1 = _internal.option$1;
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undoption$1;
  var m = $m_Lamf_client_convert_CoreClientConverters$().BooleanMatcher__Lamf_client_convert_CoreBaseConverter$BooleanMatcher$();
  this.option$1 = new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O();
  return this
});
$c_Lamf_client_model_BoolField.prototype.$$js$exported$meth$annotations__O = (function() {
  return this.annotations__Lamf_client_model_Annotations()
});
$c_Lamf_client_model_BoolField.prototype.$$js$exported$meth$is__F1__O = (function(accepts) {
  return $f_Lamf_client_model_ValueField__is__F1__Z(this, accepts)
});
$c_Lamf_client_model_BoolField.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_BoolField.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_BoolField.prototype.$$js$exported$prop$option__O = (function() {
  return this.option$1
});
$c_Lamf_client_model_BoolField.prototype.$$js$exported$prop$isNull__O = (function() {
  return this.$$undoption$1.isEmpty__Z()
});
$c_Lamf_client_model_BoolField.prototype.$$js$exported$meth$remove__O = (function() {
  var this$1 = this.amf$client$model$BoolField$$$undinternal$1;
  this$1.$$outer$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields(this$1.field$1)
});
$c_Lamf_client_model_BoolField.prototype.$$undoption__s_Option = (function() {
  return this.$$undoption$1
});
$c_Lamf_client_model_BoolField.prototype.toString = (function() {
  return this.$$js$exported$meth$toString__O()
});
Object.defineProperty($c_Lamf_client_model_BoolField.prototype, "nonNull", {
  "get": (function() {
    return this.$$js$exported$prop$nonNull__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_BoolField.prototype, "isNull", {
  "get": (function() {
    return this.$$js$exported$prop$isNull__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_BoolField.prototype.is = (function(arg) {
  if ($is_F1(arg)) {
    var prep$2 = $as_F1(arg);
    return this.$$js$exported$meth$is__F1__O(prep$2)
  } else {
    var prep = arg;
    return this.$$js$exported$meth$is__O__O(prep)
  }
});
$c_Lamf_client_model_BoolField.prototype.remove = (function() {
  return this.$$js$exported$meth$remove__O()
});
$c_Lamf_client_model_BoolField.prototype.value = (function() {
  return this.$$js$exported$meth$value__O()
});
$c_Lamf_client_model_BoolField.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
Object.defineProperty($c_Lamf_client_model_BoolField.prototype, "option", {
  "get": (function() {
    return this.$$js$exported$prop$option__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_BoolField(obj) {
  return (((obj instanceof $c_Lamf_client_model_BoolField) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.BoolField"))
}
function $isArrayOf_Lamf_client_model_BoolField(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_BoolField)))
}
function $asArrayOf_Lamf_client_model_BoolField(obj, depth) {
  return (($isArrayOf_Lamf_client_model_BoolField(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.BoolField;", depth))
}
var $d_Lamf_client_model_BoolField = new $TypeData().initClass({
  Lamf_client_model_BoolField: 0
}, false, "amf.client.model.BoolField", {
  Lamf_client_model_BoolField: 1,
  O: 1,
  Lamf_client_model_BaseAnyValField: 1,
  Lamf_client_model_BaseField: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_client_model_ValueField: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_BoolField.prototype.$classData = $d_Lamf_client_model_BoolField;
/** @constructor */
function $c_Lamf_client_model_DoubleField() {
  $c_O.call(this);
  this.amf$client$model$DoubleField$$$undinternal$1 = null;
  this.$$undoption$1 = null;
  this.option$1 = null
}
$c_Lamf_client_model_DoubleField.prototype = new $h_O();
$c_Lamf_client_model_DoubleField.prototype.constructor = $c_Lamf_client_model_DoubleField;
/** @constructor */
function $h_Lamf_client_model_DoubleField() {
  /*<skip>*/
}
$h_Lamf_client_model_DoubleField.prototype = $c_Lamf_client_model_DoubleField.prototype;
$c_Lamf_client_model_DoubleField.prototype.productPrefix__T = (function() {
  return "DoubleField"
});
$c_Lamf_client_model_DoubleField.prototype.$$js$exported$meth$is__O__O = (function(other) {
  return $f_Lamf_client_model_ValueField__is__O__Z(this, other)
});
$c_Lamf_client_model_DoubleField.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_DoubleField.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_DoubleField)) {
    var DoubleField$1 = $as_Lamf_client_model_DoubleField(x$1);
    var x = this.amf$client$model$DoubleField$$$undinternal$1;
    var x$2 = DoubleField$1.amf$client$model$DoubleField$$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_DoubleField.prototype.$$js$exported$meth$toString__O = (function() {
  return $f_Lamf_client_model_ValueField__toString__T(this)
});
$c_Lamf_client_model_DoubleField.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.amf$client$model$DoubleField$$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_DoubleField.prototype.toString__T = (function() {
  return $f_Lamf_client_model_ValueField__toString__T(this)
});
$c_Lamf_client_model_DoubleField.prototype.$$js$exported$prop$nonNull__O = (function() {
  return this.$$undoption$1.isDefined__Z()
});
$c_Lamf_client_model_DoubleField.prototype.annotations__Lamf_client_model_Annotations = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.amf$client$model$DoubleField$$$undinternal$1.annotations$1;
  $m_Lamf_client_convert_CoreClientConverters$().AnnotationsFieldMatcher__Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$();
  return new $c_Lamf_client_model_Annotations().init___Lamf_core_parser_Annotations(from)
});
$c_Lamf_client_model_DoubleField.prototype.$$js$exported$meth$value__O = (function() {
  return this.value__D()
});
$c_Lamf_client_model_DoubleField.prototype.init___Lamf_core_model_DoubleField = (function(_internal) {
  this.amf$client$model$DoubleField$$$undinternal$1 = _internal;
  this.$$undoption$1 = _internal.option$1;
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undoption$1;
  var m = $m_Lamf_client_convert_CoreClientConverters$().DoubleMatcher__Lamf_client_convert_CoreBaseConverter$DoubleMatcher$();
  this.option$1 = new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O();
  return this
});
$c_Lamf_client_model_DoubleField.prototype.$$js$exported$meth$annotations__O = (function() {
  return this.annotations__Lamf_client_model_Annotations()
});
$c_Lamf_client_model_DoubleField.prototype.$$js$exported$meth$is__F1__O = (function(accepts) {
  return $f_Lamf_client_model_ValueField__is__F1__Z(this, accepts)
});
$c_Lamf_client_model_DoubleField.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_DoubleField.prototype.value__D = (function() {
  var x1 = this.$$undoption$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var v = $uD(x2.value$2);
    return v
  } else {
    return 0.0
  }
});
$c_Lamf_client_model_DoubleField.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_DoubleField.prototype.$$js$exported$prop$option__O = (function() {
  return this.option$1
});
$c_Lamf_client_model_DoubleField.prototype.$$js$exported$prop$isNull__O = (function() {
  return this.$$undoption$1.isEmpty__Z()
});
$c_Lamf_client_model_DoubleField.prototype.$$js$exported$meth$remove__O = (function() {
  var this$1 = this.amf$client$model$DoubleField$$$undinternal$1;
  this$1.$$outer$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields(this$1.field$1)
});
$c_Lamf_client_model_DoubleField.prototype.$$undoption__s_Option = (function() {
  return this.$$undoption$1
});
$c_Lamf_client_model_DoubleField.prototype.toString = (function() {
  return this.$$js$exported$meth$toString__O()
});
Object.defineProperty($c_Lamf_client_model_DoubleField.prototype, "nonNull", {
  "get": (function() {
    return this.$$js$exported$prop$nonNull__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_DoubleField.prototype, "isNull", {
  "get": (function() {
    return this.$$js$exported$prop$isNull__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_DoubleField.prototype.is = (function(arg) {
  if ($is_F1(arg)) {
    var prep$2 = $as_F1(arg);
    return this.$$js$exported$meth$is__F1__O(prep$2)
  } else {
    var prep = arg;
    return this.$$js$exported$meth$is__O__O(prep)
  }
});
$c_Lamf_client_model_DoubleField.prototype.remove = (function() {
  return this.$$js$exported$meth$remove__O()
});
$c_Lamf_client_model_DoubleField.prototype.value = (function() {
  return this.$$js$exported$meth$value__O()
});
$c_Lamf_client_model_DoubleField.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
Object.defineProperty($c_Lamf_client_model_DoubleField.prototype, "option", {
  "get": (function() {
    return this.$$js$exported$prop$option__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_DoubleField(obj) {
  return (((obj instanceof $c_Lamf_client_model_DoubleField) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.DoubleField"))
}
function $isArrayOf_Lamf_client_model_DoubleField(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_DoubleField)))
}
function $asArrayOf_Lamf_client_model_DoubleField(obj, depth) {
  return (($isArrayOf_Lamf_client_model_DoubleField(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.DoubleField;", depth))
}
var $d_Lamf_client_model_DoubleField = new $TypeData().initClass({
  Lamf_client_model_DoubleField: 0
}, false, "amf.client.model.DoubleField", {
  Lamf_client_model_DoubleField: 1,
  O: 1,
  Lamf_client_model_BaseAnyValField: 1,
  Lamf_client_model_BaseField: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_client_model_ValueField: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_DoubleField.prototype.$classData = $d_Lamf_client_model_DoubleField;
/** @constructor */
function $c_Lamf_client_model_IntField() {
  $c_O.call(this);
  this.amf$client$model$IntField$$$undinternal$1 = null;
  this.$$undoption$1 = null;
  this.option$1 = null
}
$c_Lamf_client_model_IntField.prototype = new $h_O();
$c_Lamf_client_model_IntField.prototype.constructor = $c_Lamf_client_model_IntField;
/** @constructor */
function $h_Lamf_client_model_IntField() {
  /*<skip>*/
}
$h_Lamf_client_model_IntField.prototype = $c_Lamf_client_model_IntField.prototype;
$c_Lamf_client_model_IntField.prototype.productPrefix__T = (function() {
  return "IntField"
});
$c_Lamf_client_model_IntField.prototype.$$js$exported$meth$is__O__O = (function(other) {
  return $f_Lamf_client_model_ValueField__is__O__Z(this, other)
});
$c_Lamf_client_model_IntField.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_IntField.prototype.value__I = (function() {
  var x1 = this.$$undoption$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var v = $uI(x2.value$2);
    return v
  } else {
    return 0
  }
});
$c_Lamf_client_model_IntField.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_IntField)) {
    var IntField$1 = $as_Lamf_client_model_IntField(x$1);
    var x = this.amf$client$model$IntField$$$undinternal$1;
    var x$2 = IntField$1.amf$client$model$IntField$$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_IntField.prototype.$$js$exported$meth$toString__O = (function() {
  return $f_Lamf_client_model_ValueField__toString__T(this)
});
$c_Lamf_client_model_IntField.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.amf$client$model$IntField$$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_IntField.prototype.toString__T = (function() {
  return $f_Lamf_client_model_ValueField__toString__T(this)
});
$c_Lamf_client_model_IntField.prototype.init___Lamf_core_model_IntField = (function(_internal) {
  this.amf$client$model$IntField$$$undinternal$1 = _internal;
  this.$$undoption$1 = _internal.option$1;
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undoption$1;
  var m = $m_Lamf_client_convert_CoreClientConverters$().IntMatcher__Lamf_client_convert_CoreBaseConverter$IntMatcher$();
  this.option$1 = new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O();
  return this
});
$c_Lamf_client_model_IntField.prototype.$$js$exported$prop$nonNull__O = (function() {
  return this.$$undoption$1.isDefined__Z()
});
$c_Lamf_client_model_IntField.prototype.annotations__Lamf_client_model_Annotations = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.amf$client$model$IntField$$$undinternal$1.annotations$1;
  $m_Lamf_client_convert_CoreClientConverters$().AnnotationsFieldMatcher__Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$();
  return new $c_Lamf_client_model_Annotations().init___Lamf_core_parser_Annotations(from)
});
$c_Lamf_client_model_IntField.prototype.$$js$exported$meth$value__O = (function() {
  return this.value__I()
});
$c_Lamf_client_model_IntField.prototype.$$js$exported$meth$annotations__O = (function() {
  return this.annotations__Lamf_client_model_Annotations()
});
$c_Lamf_client_model_IntField.prototype.$$js$exported$meth$is__F1__O = (function(accepts) {
  return $f_Lamf_client_model_ValueField__is__F1__Z(this, accepts)
});
$c_Lamf_client_model_IntField.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_IntField.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_IntField.prototype.$$js$exported$prop$option__O = (function() {
  return this.option$1
});
$c_Lamf_client_model_IntField.prototype.$$js$exported$prop$isNull__O = (function() {
  return this.$$undoption$1.isEmpty__Z()
});
$c_Lamf_client_model_IntField.prototype.$$js$exported$meth$remove__O = (function() {
  var this$1 = this.amf$client$model$IntField$$$undinternal$1;
  this$1.$$outer$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields(this$1.field$1)
});
$c_Lamf_client_model_IntField.prototype.$$undoption__s_Option = (function() {
  return this.$$undoption$1
});
$c_Lamf_client_model_IntField.prototype.toString = (function() {
  return this.$$js$exported$meth$toString__O()
});
Object.defineProperty($c_Lamf_client_model_IntField.prototype, "nonNull", {
  "get": (function() {
    return this.$$js$exported$prop$nonNull__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_IntField.prototype, "isNull", {
  "get": (function() {
    return this.$$js$exported$prop$isNull__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_IntField.prototype.is = (function(arg) {
  if ($is_F1(arg)) {
    var prep$2 = $as_F1(arg);
    return this.$$js$exported$meth$is__F1__O(prep$2)
  } else {
    var prep = arg;
    return this.$$js$exported$meth$is__O__O(prep)
  }
});
$c_Lamf_client_model_IntField.prototype.remove = (function() {
  return this.$$js$exported$meth$remove__O()
});
$c_Lamf_client_model_IntField.prototype.value = (function() {
  return this.$$js$exported$meth$value__O()
});
$c_Lamf_client_model_IntField.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
Object.defineProperty($c_Lamf_client_model_IntField.prototype, "option", {
  "get": (function() {
    return this.$$js$exported$prop$option__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_IntField(obj) {
  return (((obj instanceof $c_Lamf_client_model_IntField) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.IntField"))
}
function $isArrayOf_Lamf_client_model_IntField(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_IntField)))
}
function $asArrayOf_Lamf_client_model_IntField(obj, depth) {
  return (($isArrayOf_Lamf_client_model_IntField(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.IntField;", depth))
}
var $d_Lamf_client_model_IntField = new $TypeData().initClass({
  Lamf_client_model_IntField: 0
}, false, "amf.client.model.IntField", {
  Lamf_client_model_IntField: 1,
  O: 1,
  Lamf_client_model_BaseAnyValField: 1,
  Lamf_client_model_BaseField: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_client_model_ValueField: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_IntField.prototype.$classData = $d_Lamf_client_model_IntField;
/** @constructor */
function $c_Lamf_client_model_domain_ClassTerm() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_ClassTerm.prototype = new $h_O();
$c_Lamf_client_model_domain_ClassTerm.prototype.constructor = $c_Lamf_client_model_domain_ClassTerm;
/** @constructor */
function $h_Lamf_client_model_domain_ClassTerm() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_ClassTerm.prototype = $c_Lamf_client_model_domain_ClassTerm.prototype;
$c_Lamf_client_model_domain_ClassTerm.prototype.productPrefix__T = (function() {
  return "ClassTerm"
});
$c_Lamf_client_model_domain_ClassTerm.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_ClassTerm.prototype.init___Lamf_plugins_document_vocabularies_model_domain_ClassTerm.call(this, new $c_Lamf_plugins_document_vocabularies_model_domain_ClassTerm().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$js$exported$meth$withSubClassOf__sjs_js_Array__O = (function(superClasses) {
  return this.withSubClassOf__sjs_js_Array__Lamf_client_model_domain_ClassTerm(superClasses)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().Name$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$js$exported$prop$displayName__O = (function() {
  return this.displayName__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.properties__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().Properties$1));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ClassTerm.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_ClassTerm)) {
    var ClassTerm$1 = $as_Lamf_client_model_domain_ClassTerm(x$1);
    var x = this.$$undinternal$1;
    var x$2 = ClassTerm$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_ClassTerm.prototype.withSubClassOf__sjs_js_Array__Lamf_client_model_domain_ClassTerm = (function(superClasses) {
  var jsx$1 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  jsx$1.withSubClassOf__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_ClassTerm(new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, superClasses, m).asInternal__sc_Seq());
  return this
});
$c_Lamf_client_model_domain_ClassTerm.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$js$exported$prop$subClassOf__O = (function() {
  return this.subClassOf__sjs_js_Array()
});
$c_Lamf_client_model_domain_ClassTerm.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.withName__T__Lamf_client_model_domain_ClassTerm = (function(name) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().Name$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_ClassTerm($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name));
  return this
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.withProperties__sjs_js_Array__Lamf_client_model_domain_ClassTerm = (function(properties) {
  var jsx$1 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  jsx$1.withProperties__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_ClassTerm(new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, properties, m).asInternal__sc_Seq());
  return this
});
$c_Lamf_client_model_domain_ClassTerm.prototype.withDescription__T__Lamf_client_model_domain_ClassTerm = (function(description) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().Description$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_ClassTerm($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, description));
  return this
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.description__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().Description$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$js$exported$meth$withDisplayName__T__O = (function(displayName) {
  return this.withDisplayName__T__Lamf_client_model_domain_ClassTerm(displayName)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.subClassOf__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().SubClassOf$1));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$js$exported$prop$properties__O = (function() {
  return this.properties__sjs_js_Array()
});
$c_Lamf_client_model_domain_ClassTerm.prototype.init___Lamf_plugins_document_vocabularies_model_domain_ClassTerm = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$js$exported$meth$withDescription__T__O = (function(description) {
  return this.withDescription__T__Lamf_client_model_domain_ClassTerm(description)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.withDisplayName__T__Lamf_client_model_domain_ClassTerm = (function(displayName) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().DisplayName$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_ClassTerm($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, displayName));
  return this
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$js$exported$meth$withProperties__sjs_js_Array__O = (function(properties) {
  return this.withProperties__sjs_js_Array__Lamf_client_model_domain_ClassTerm(properties)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$js$exported$prop$description__O = (function() {
  return this.description__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_ClassTerm.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_ClassTerm.prototype.displayName__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ClassTermModel$().DisplayName$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_ClassTerm(name)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_ClassTerm.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_ClassTerm.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ClassTerm.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ClassTerm.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ClassTerm.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ClassTerm.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ClassTerm.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ClassTerm.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ClassTerm.prototype.withSubClassOf = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withSubClassOf__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.withProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withProperties__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.withDescription = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDescription__T__O(prep)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.withDisplayName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDisplayName__T__O(prep)
});
$c_Lamf_client_model_domain_ClassTerm.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ClassTerm.prototype, "subClassOf", {
  "get": (function() {
    return this.$$js$exported$prop$subClassOf__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ClassTerm.prototype, "properties", {
  "get": (function() {
    return this.$$js$exported$prop$properties__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ClassTerm.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ClassTerm.prototype, "displayName", {
  "get": (function() {
    return this.$$js$exported$prop$displayName__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ClassTerm.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_ClassTerm(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_ClassTerm) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.ClassTerm"))
}
function $isArrayOf_Lamf_client_model_domain_ClassTerm(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_ClassTerm)))
}
function $asArrayOf_Lamf_client_model_domain_ClassTerm(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_ClassTerm(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.ClassTerm;", depth))
}
var $d_Lamf_client_model_domain_ClassTerm = new $TypeData().initClass({
  Lamf_client_model_domain_ClassTerm: 0
}, false, "amf.client.model.domain.ClassTerm", {
  Lamf_client_model_domain_ClassTerm: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_ClassTerm.prototype.$classData = $d_Lamf_client_model_domain_ClassTerm;
/** @constructor */
function $c_Lamf_client_model_domain_CreativeWork() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_CreativeWork.prototype = new $h_O();
$c_Lamf_client_model_domain_CreativeWork.prototype.constructor = $c_Lamf_client_model_domain_CreativeWork;
/** @constructor */
function $h_Lamf_client_model_domain_CreativeWork() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_CreativeWork.prototype = $c_Lamf_client_model_domain_CreativeWork.prototype;
$c_Lamf_client_model_domain_CreativeWork.prototype.withUrl__T__Lamf_client_model_domain_CreativeWork = (function(url) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Url$1;
  $as_Lamf_plugins_domain_shapes_models_CreativeWork($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, url));
  return this
});
$c_Lamf_client_model_domain_CreativeWork.prototype.productPrefix__T = (function() {
  return "CreativeWork"
});
$c_Lamf_client_model_domain_CreativeWork.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_CreativeWork.prototype.init___Lamf_plugins_domain_shapes_models_CreativeWork.call(this, new $c_Lamf_plugins_domain_shapes_models_CreativeWork().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_CreativeWork.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_CreativeWork.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.$$js$exported$meth$withTitle__T__O = (function(title) {
  return this.withTitle__T__Lamf_client_model_domain_CreativeWork(title)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.$$js$exported$prop$url__O = (function() {
  return this.url__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_CreativeWork.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_CreativeWork)) {
    var CreativeWork$1 = $as_Lamf_client_model_domain_CreativeWork(x$1);
    var x = this.$$undinternal$1;
    var x$2 = CreativeWork$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_CreativeWork.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_CreativeWork.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_CreativeWork.prototype.url__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Url$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.$$js$exported$meth$withUrl__T__O = (function(url) {
  return this.withUrl__T__Lamf_client_model_domain_CreativeWork(url)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.title__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Title$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.init___Lamf_plugins_domain_shapes_models_CreativeWork = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_CreativeWork.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.description__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Description$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.withTitle__T__Lamf_client_model_domain_CreativeWork = (function(title) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Title$1;
  $as_Lamf_plugins_domain_shapes_models_CreativeWork($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, title));
  return this
});
$c_Lamf_client_model_domain_CreativeWork.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.$$js$exported$meth$withDescription__T__O = (function(description) {
  return this.withDescription__T__Lamf_client_model_domain_CreativeWork(description)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_CreativeWork.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_CreativeWork.prototype.$$js$exported$prop$description__O = (function() {
  return this.description__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_CreativeWork.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_CreativeWork.prototype.withDescription__T__Lamf_client_model_domain_CreativeWork = (function(description) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Description$1;
  $as_Lamf_plugins_domain_shapes_models_CreativeWork($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, description));
  return this
});
$c_Lamf_client_model_domain_CreativeWork.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.$$js$exported$prop$title__O = (function() {
  return this.title__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_CreativeWork.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_CreativeWork.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_CreativeWork.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_CreativeWork.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_CreativeWork.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_CreativeWork.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_CreativeWork.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_CreativeWork.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_CreativeWork.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_CreativeWork.prototype.withDescription = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDescription__T__O(prep)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.withTitle = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withTitle__T__O(prep)
});
$c_Lamf_client_model_domain_CreativeWork.prototype.withUrl = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withUrl__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_CreativeWork.prototype, "title", {
  "get": (function() {
    return this.$$js$exported$prop$title__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_CreativeWork.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_CreativeWork.prototype, "url", {
  "get": (function() {
    return this.$$js$exported$prop$url__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_CreativeWork(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_CreativeWork) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.CreativeWork"))
}
function $isArrayOf_Lamf_client_model_domain_CreativeWork(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_CreativeWork)))
}
function $asArrayOf_Lamf_client_model_domain_CreativeWork(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_CreativeWork(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.CreativeWork;", depth))
}
var $d_Lamf_client_model_domain_CreativeWork = new $TypeData().initClass({
  Lamf_client_model_domain_CreativeWork: 0
}, false, "amf.client.model.domain.CreativeWork", {
  Lamf_client_model_domain_CreativeWork: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_CreativeWork.prototype.$classData = $d_Lamf_client_model_domain_CreativeWork;
/** @constructor */
function $c_Lamf_client_model_domain_DataArrangeShape() {
  $c_Lamf_client_model_domain_AnyShape.call(this)
}
$c_Lamf_client_model_domain_DataArrangeShape.prototype = new $h_Lamf_client_model_domain_AnyShape();
$c_Lamf_client_model_domain_DataArrangeShape.prototype.constructor = $c_Lamf_client_model_domain_DataArrangeShape;
/** @constructor */
function $h_Lamf_client_model_domain_DataArrangeShape() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_DataArrangeShape.prototype = $c_Lamf_client_model_domain_DataArrangeShape.prototype;
$c_Lamf_client_model_domain_DataArrangeShape.prototype.minItems__Lamf_client_model_IntField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_DataArrangementShape();
  var from = $as_Lamf_core_model_IntField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MinItems$1));
  $m_Lamf_client_convert_WebApiClientConverters$().IntFieldMatcher__Lamf_client_convert_FieldConverter$IntFieldMatcher$();
  return new $c_Lamf_client_model_IntField().init___Lamf_core_model_IntField(from)
});
$c_Lamf_client_model_domain_DataArrangeShape.prototype.$$js$exported$meth$withUniqueItems__Z__O = (function(uniqueItems) {
  return this.withUniqueItems__Z__Lamf_client_model_domain_DataArrangeShape(uniqueItems)
});
$c_Lamf_client_model_domain_DataArrangeShape.prototype.$$js$exported$prop$minItems__O = (function() {
  return this.minItems__Lamf_client_model_IntField()
});
$c_Lamf_client_model_domain_DataArrangeShape.prototype.withMinItems__I__Lamf_client_model_domain_DataArrangeShape = (function(minItems) {
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_DataArrangementShape();
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MinItems$1;
  $as_Lamf_plugins_domain_shapes_models_DataArrangementShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject(this$1, field, minItems));
  return this
});
$c_Lamf_client_model_domain_DataArrangeShape.prototype.withMaxItems__I__Lamf_client_model_domain_DataArrangeShape = (function(maxItems) {
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_DataArrangementShape();
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MaxItems$1;
  $as_Lamf_plugins_domain_shapes_models_DataArrangementShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject(this$1, field, maxItems));
  return this
});
$c_Lamf_client_model_domain_DataArrangeShape.prototype.maxItems__Lamf_client_model_IntField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_DataArrangementShape();
  var from = $as_Lamf_core_model_IntField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MaxItems$1));
  $m_Lamf_client_convert_WebApiClientConverters$().IntFieldMatcher__Lamf_client_convert_FieldConverter$IntFieldMatcher$();
  return new $c_Lamf_client_model_IntField().init___Lamf_core_model_IntField(from)
});
$c_Lamf_client_model_domain_DataArrangeShape.prototype.$$js$exported$meth$withMinItems__I__O = (function(minItems) {
  return this.withMinItems__I__Lamf_client_model_domain_DataArrangeShape(minItems)
});
$c_Lamf_client_model_domain_DataArrangeShape.prototype.$$js$exported$meth$withMaxItems__I__O = (function(maxItems) {
  return this.withMaxItems__I__Lamf_client_model_domain_DataArrangeShape(maxItems)
});
$c_Lamf_client_model_domain_DataArrangeShape.prototype.uniqueItems__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_DataArrangementShape();
  var from = $as_Lamf_core_model_BoolField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().UniqueItems$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_DataArrangeShape.prototype.withUniqueItems__Z__Lamf_client_model_domain_DataArrangeShape = (function(uniqueItems) {
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_DataArrangementShape();
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().UniqueItems$1;
  $as_Lamf_plugins_domain_shapes_models_DataArrangementShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, uniqueItems));
  return this
});
$c_Lamf_client_model_domain_DataArrangeShape.prototype.$$js$exported$prop$maxItems__O = (function() {
  return this.maxItems__Lamf_client_model_IntField()
});
$c_Lamf_client_model_domain_DataArrangeShape.prototype.$$js$exported$prop$uniqueItems__O = (function() {
  return this.uniqueItems__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_DataArrangeShape.prototype.withUniqueItems = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withUniqueItems__Z__O(prep)
});
$c_Lamf_client_model_domain_DataArrangeShape.prototype.withMaxItems = (function(arg) {
  var prep = $uI(arg);
  return this.$$js$exported$meth$withMaxItems__I__O(prep)
});
$c_Lamf_client_model_domain_DataArrangeShape.prototype.withMinItems = (function(arg) {
  var prep = $uI(arg);
  return this.$$js$exported$meth$withMinItems__I__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_DataArrangeShape.prototype, "uniqueItems", {
  "get": (function() {
    return this.$$js$exported$prop$uniqueItems__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DataArrangeShape.prototype, "maxItems", {
  "get": (function() {
    return this.$$js$exported$prop$maxItems__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DataArrangeShape.prototype, "minItems", {
  "get": (function() {
    return this.$$js$exported$prop$minItems__O()
  }),
  "configurable": true
});
/** @constructor */
function $c_Lamf_client_model_domain_DialectDomainElement() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_DialectDomainElement.prototype = new $h_O();
$c_Lamf_client_model_domain_DialectDomainElement.prototype.constructor = $c_Lamf_client_model_domain_DialectDomainElement;
/** @constructor */
function $h_Lamf_client_model_domain_DialectDomainElement() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_DialectDomainElement.prototype = $c_Lamf_client_model_domain_DialectDomainElement.prototype;
$c_Lamf_client_model_domain_DialectDomainElement.prototype.productPrefix__T = (function() {
  return "DialectDomainElement"
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_DialectDomainElement.prototype.init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.call(this, new $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.definedBy__Lamf_client_model_domain_NodeMapping = (function() {
  return new $c_Lamf_client_model_domain_NodeMapping().init___Lamf_plugins_document_vocabularies_model_domain_NodeMapping(this.$$undinternal$1.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping())
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$isAbstract__O = (function() {
  var this$1 = this.$$undinternal$1;
  return $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$().Abstract$1))
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.getPropertyUris__sjs_js_Array = (function() {
  var this$3 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$2 = this.$$undinternal$1.meta__Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel().fields$1;
  var f = (function($this) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_metamodel_Field(x$2$2);
      return x$2.value$1.iri__T()
    })
  })(this);
  var this$1 = $m_sci_List$();
  var bf = this$1.ReusableCBFInstance$2;
  if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
    if ((this$2 === $m_sci_Nil$())) {
      var jsx$1 = $m_sci_Nil$()
    } else {
      var arg1 = this$2.head__O();
      var h = new $c_sci_$colon$colon().init___O__sci_List(f(arg1), $m_sci_Nil$());
      var t = h;
      var rest = $as_sci_List(this$2.tail__O());
      while ((rest !== $m_sci_Nil$())) {
        var arg1$1 = rest.head__O();
        var nx = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$1), $m_sci_Nil$());
        t.tl$5 = nx;
        t = nx;
        rest = $as_sci_List(rest.tail__O())
      };
      var jsx$1 = h
    }
  } else {
    var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$2, bf);
    var these = this$2;
    while ((!these.isEmpty__Z())) {
      var arg1$2 = these.head__O();
      b.$$plus$eq__O__scm_Builder(f(arg1$2));
      these = $as_sci_List(these.tail__O())
    };
    var jsx$1 = b.result__O()
  };
  var from = $as_sc_Seq(jsx$1);
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$3, from, m).asClient__O()
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.setObjectProperty__T__Lamf_client_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(propertyId, value) {
  var x1 = this.$$undinternal$1.findPropertyMappingByTermPropertyId__T__s_Option($m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType(propertyId).iri__T());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var mapping = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x2.value$2);
    return this.$$undinternal$1.setObjectField__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(mapping, value.$$undinternal$1, $m_Lorg_yaml_model_YNode$().Empty$1)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot find node mapping for propertyId " + propertyId)))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.setLiteralProperty__T__I__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(propertyId, value) {
  var x1 = this.$$undinternal$1.findPropertyMappingByTermPropertyId__T__s_Option($m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType(propertyId).iri__T());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var mapping = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x2.value$2);
    return this.$$undinternal$1.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__I__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(mapping, value, $m_Lorg_yaml_model_YMapEntry$().apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry($m_Lorg_yaml_model_YNode$().Empty$1, $m_Lorg_yaml_model_YNode$().Empty$1))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot find node mapping for propertyId " + propertyId)))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$getTypeUris__O = (function() {
  return this.getTypeUris__sjs_js_Array()
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.getScalarValueByPropertyUri__T__sjs_js_Array = (function(propertyId) {
  var expanded = $m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType(propertyId).iri__T();
  var this$1 = this.$$undinternal$1.findPropertyMappingByTermPropertyId__T__s_Option(expanded);
  if (this$1.isEmpty__Z()) {
    var x1 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$5 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(arg1);
    var x1 = new $c_s_Some().init___O(x$5.toField__Lamf_core_metamodel_Field())
  };
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var mapping = $as_Lamf_core_metamodel_Field(x2.value$2);
    var this$2 = this.$$undinternal$1.fields$1;
    var x1$2 = this$2.fs$1.get__O__s_Option(mapping);
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var value = $as_Lamf_core_parser_Value(x2$2.value$2);
      var x1$3 = value.value$1;
      if ((x1$3 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
        var x2$3 = $as_Lamf_core_model_domain_AmfScalar(x1$3);
        var jsx$1 = $m_sc_Seq$();
        var array = [x2$3.value$1];
        var res = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
      } else if ((x1$3 instanceof $c_Lamf_core_model_domain_AmfArray)) {
        var x3 = $as_Lamf_core_model_domain_AmfArray(x1$3);
        var jsx$3 = x3.scalars__sc_Seq();
        var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
          return (function(x$6$2) {
            var x$6 = $as_Lamf_core_model_domain_AmfScalar(x$6$2);
            return x$6.value$1
          })
        })(this));
        var this$5 = $m_sc_Seq$();
        var res = $as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$2, this$5.ReusableCBFInstance$2))
      } else {
        if ((!$is_Lamf_core_model_domain_AmfObject(x1$3))) {
          throw new $c_s_MatchError().init___O(x1$3)
        };
        var res = $m_sci_Nil$()
      }
    } else {
      var x = $m_s_None$();
      if ((!(x === x1$2))) {
        throw new $c_s_MatchError().init___O(x1$2)
      };
      var this$6 = this.$$undinternal$1.fields$1;
      var this$7 = this$6.fs$1.get__O__s_Option(mapping);
      if (this$7.isEmpty__Z()) {
        var this$10 = $m_s_None$()
      } else {
        var arg1$1 = this$7.get__O();
        var x$7 = $as_Lamf_core_parser_Value(arg1$1);
        var jsx$4 = $m_sc_Seq$();
        var array$1 = [x$7];
        var this$10 = new $c_s_Some().init___O($as_sc_Seq(jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1))))
      };
      var res = $as_sc_Seq((this$10.isEmpty__Z() ? $m_sci_Nil$() : this$10.get__O()))
    }
  } else {
    var res = $m_sci_Nil$()
  };
  var this$11 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().AnyMatcher__Lamf_client_convert_CoreBaseConverter$AnyMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$11, res, m).asClient__O()
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_DialectDomainElement)) {
    var DialectDomainElement$1 = $as_Lamf_client_model_domain_DialectDomainElement(x$1);
    var x = this.$$undinternal$1;
    var x$2 = DialectDomainElement$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$withInstanceTypes__sjs_js_Array__O = (function(types) {
  return this.withInstanceTypes__sjs_js_Array__Lamf_client_model_domain_DialectDomainElement(types)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$definedBy__O = (function() {
  return this.definedBy__Lamf_client_model_domain_NodeMapping()
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$setObjectProperty__T__Lamf_client_model_domain_DialectDomainElement__O = (function(propertyId, value) {
  return this.setObjectProperty__T__Lamf_client_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(propertyId, value)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$setLiteralProperty__T__I__O = (function(propertyId, value) {
  return this.setLiteralProperty__T__I__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(propertyId, value)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.withInstanceTypes__sjs_js_Array__Lamf_client_model_domain_DialectDomainElement = (function(types) {
  var jsx$1 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  jsx$1.withInstanceTypes__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, types, m).asInternal__sc_Seq());
  return this
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.setLiteralProperty__T__D__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(propertyId, value) {
  var x1 = this.$$undinternal$1.findPropertyMappingByTermPropertyId__T__s_Option($m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType(propertyId).iri__T());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var mapping = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x2.value$2);
    return this.$$undinternal$1.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__D__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(mapping, value, $m_Lorg_yaml_model_YMapEntry$().apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry($m_Lorg_yaml_model_YNode$().Empty$1, $m_Lorg_yaml_model_YNode$().Empty$1))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot find node mapping for propertyId " + propertyId)))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$withDefinedby__Lamf_client_model_domain_NodeMapping__O = (function(nodeMapping) {
  return this.withDefinedby__Lamf_client_model_domain_NodeMapping__Lamf_client_model_domain_DialectDomainElement(nodeMapping)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.setObjectCollectionProperty__T__sjs_js_Array__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(propertyId, value) {
  var x1 = this.$$undinternal$1.findPropertyMappingByTermPropertyId__T__s_Option($m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType(propertyId).iri__T());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var mapping = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x2.value$2);
    var jsx$1 = this.$$undinternal$1;
    var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
    var m = $m_Lamf_client_convert_VocabulariesClientConverter$().DialectDomainElementConvertej__Lamf_client_convert_DialectDomainElementConverter$DialectDomainElementConvertej$();
    return jsx$1.setObjectField__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__sc_Seq__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(mapping, new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, value, m).asInternal__sc_Seq(), $m_Lorg_yaml_model_YNode$().Empty$1)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot find node mapping for propertyId " + propertyId)))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$localRefName__O = (function() {
  return this.$$undinternal$1.localRefName__T()
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.setLiteralProperty__T__Z__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(propertyId, value) {
  var x1 = this.$$undinternal$1.findPropertyMappingByTermPropertyId__T__s_Option($m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType(propertyId).iri__T());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var mapping = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x2.value$2);
    return this.$$undinternal$1.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Z__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(mapping, value, $m_Lorg_yaml_model_YMapEntry$().apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry($m_Lorg_yaml_model_YNode$().Empty$1, $m_Lorg_yaml_model_YNode$().Empty$1))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot find node mapping for propertyId " + propertyId)))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$setLiteralProperty__T__sjs_js_Array__O = (function(propertyId, value) {
  return this.setLiteralProperty__T__sjs_js_Array__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(propertyId, value)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$setLiteralProperty__T__Z__O = (function(propertyId, value) {
  return this.setLiteralProperty__T__Z__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(propertyId, value)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$includeName__O = (function() {
  return this.$$undinternal$1.includeName__T()
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$getObjectPropertyUri__T__O = (function(propertyId) {
  return this.getObjectPropertyUri__T__sjs_js_Array(propertyId)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$getPropertyUris__O = (function() {
  return this.getPropertyUris__sjs_js_Array()
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.withAbstract__Z__Lamf_client_model_domain_DialectDomainElement = (function(isAbstract) {
  this.$$undinternal$1.withAbstract__Z__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(isAbstract);
  return this
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$setLiteralProperty__T__T__O = (function(propertyId, value) {
  return this.setLiteralProperty__T__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(propertyId, value)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$setLiteralProperty__T__D__O = (function(propertyId, value) {
  return this.setLiteralProperty__T__D__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(propertyId, value)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.getObjectPropertyUri__T__sjs_js_Array = (function(propertyId) {
  var expanded = $m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType(propertyId).iri__T();
  var this$1 = this.$$undinternal$1.findPropertyMappingByTermPropertyId__T__s_Option(expanded);
  if (this$1.isEmpty__Z()) {
    var x1 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$8 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(arg1);
    var x1 = new $c_s_Some().init___O(x$8.toField__Lamf_core_metamodel_Field())
  };
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var f = $as_Lamf_core_metamodel_Field(x2.value$2);
    var rc14 = false;
    var x2$2 = null;
    var this$2 = this.$$undinternal$1.fields$1;
    var x1$2 = this$2.fs$1.get__O__s_Option(f);
    matchEnd15: {
      var res;
      if ((x1$2 instanceof $c_s_Some)) {
        rc14 = true;
        x2$2 = $as_s_Some(x1$2);
        var p3 = $as_Lamf_core_parser_Value(x2$2.value$2);
        var o18 = $m_Lamf_core_parser_Value$().unapply__Lamf_core_parser_Value__s_Option(p3);
        if ((!o18.isEmpty__Z())) {
          var arr = $as_Lamf_core_model_domain_AmfElement($as_T2(o18.get__O()).$$und1__O());
          if ((arr instanceof $c_Lamf_core_model_domain_AmfArray)) {
            var x10 = $as_Lamf_core_model_domain_AmfArray(arr);
            var jsx$2 = x10.values$1;
            var jsx$1 = new $c_Lamf_client_model_domain_DialectDomainElement$$anonfun$1().init___Lamf_client_model_domain_DialectDomainElement(this);
            var this$3 = $m_sc_Seq$();
            var res = $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$3.ReusableCBFInstance$2));
            break matchEnd15
          }
        }
      };
      if (rc14) {
        var p7 = $as_Lamf_core_parser_Value(x2$2.value$2);
        var o20 = $m_Lamf_core_parser_Value$().unapply__Lamf_core_parser_Value__s_Option(p7);
        if ((!o20.isEmpty__Z())) {
          var value = $as_Lamf_core_model_domain_AmfElement($as_T2(o20.get__O()).$$und1__O());
          if ((value instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
            var x11 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(value);
            var jsx$3 = $m_sc_Seq$();
            $m_Lamf_client_convert_VocabulariesClientConverter$();
            var from = new $c_Lamf_client_model_domain_DialectDomainElement().init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x11);
            $m_Lamf_client_convert_VocabulariesClientConverter$().DialectDomainElementConvertej__Lamf_client_convert_DialectDomainElementConverter$DialectDomainElementConvertej$();
            var array = [from.$$undinternal$1];
            var res = $as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
            break matchEnd15
          }
        }
      };
      var x = $m_s_None$();
      if ((x === x1$2)) {
        var res = $m_sci_Nil$();
        break matchEnd15
      };
      throw new $c_s_MatchError().init___O(x1$2)
    }
  } else {
    var res = $m_sci_Nil$()
  };
  var this$7 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var m$1 = $m_Lamf_client_convert_VocabulariesClientConverter$().DialectDomainElementConvertej__Lamf_client_convert_DialectDomainElementConverter$DialectDomainElementConvertej$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$7, res, m$1).asClient__O()
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$setLiteralProperty__T__F__O = (function(propertyId, value) {
  return this.setLiteralProperty__T__F__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(propertyId, value)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.setLiteralProperty__T__sjs_js_Array__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(propertyId, value) {
  var x1 = this.$$undinternal$1.findPropertyMappingByTermPropertyId__T__s_Option($m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType(propertyId).iri__T());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var mapping = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x2.value$2);
    var jsx$1 = this.$$undinternal$1;
    var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
    var m = $m_Lamf_client_convert_VocabulariesClientConverter$().AnyMatcher__Lamf_client_convert_CoreBaseConverter$AnyMatcher$();
    return jsx$1.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__sc_Seq__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(mapping, new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, value, m).asInternal__sc_Seq(), $m_Lorg_yaml_model_YMapEntry$().apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry($m_Lorg_yaml_model_YNode$().Empty$1, $m_Lorg_yaml_model_YNode$().Empty$1))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot find node mapping for propertyId " + propertyId)))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.getScalarByPropertyUri__T__sjs_js_Array = (function(propertyId) {
  var expanded = $m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType(propertyId).iri__T();
  var this$1 = this.$$undinternal$1.findPropertyMappingByTermPropertyId__T__s_Option(expanded);
  if (this$1.isEmpty__Z()) {
    var x1 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$3 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(arg1);
    var x1 = new $c_s_Some().init___O(x$3.toField__Lamf_core_metamodel_Field())
  };
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var mapping = $as_Lamf_core_metamodel_Field(x2.value$2);
    var rc7 = false;
    var x2$2 = null;
    var this$2 = this.$$undinternal$1.fields$1;
    var x1$2 = this$2.fs$1.get__O__s_Option(mapping);
    matchEnd8: {
      var res$2;
      if ((x1$2 instanceof $c_s_Some)) {
        rc7 = true;
        x2$2 = $as_s_Some(x1$2);
        var res = $as_Lamf_core_parser_Value(x2$2.value$2);
        if ($is_sc_Seq(res)) {
          var res$2 = $as_sc_Seq(res);
          break matchEnd8
        }
      };
      if (rc7) {
        var value = $as_Lamf_core_parser_Value(x2$2.value$2);
        var jsx$1 = $m_sc_Seq$();
        var array = [value];
        var res$2 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
        break matchEnd8
      };
      var x = $m_s_None$();
      if ((x === x1$2)) {
        var this$5 = this.$$undinternal$1.fields$1;
        var this$6 = this$5.fs$1.get__O__s_Option(mapping);
        if (this$6.isEmpty__Z()) {
          var this$9 = $m_s_None$()
        } else {
          var arg1$1 = this$6.get__O();
          var x$4 = $as_Lamf_core_parser_Value(arg1$1);
          var jsx$2 = $m_sc_Seq$();
          var array$1 = [x$4];
          var this$9 = new $c_s_Some().init___O($as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1))))
        };
        var res$2 = $as_sc_Seq((this$9.isEmpty__Z() ? $m_sci_Nil$() : this$9.get__O()));
        break matchEnd8
      };
      throw new $c_s_MatchError().init___O(x1$2)
    }
  } else {
    var res$2 = $m_sci_Nil$()
  };
  var this$10 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().AnyMatcher__Lamf_client_convert_CoreBaseConverter$AnyMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$10, res$2, m).asClient__O()
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.setLiteralProperty__T__F__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(propertyId, value) {
  var x1 = this.$$undinternal$1.findPropertyMappingByTermPropertyId__T__s_Option($m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType(propertyId).iri__T());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var mapping = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x2.value$2);
    return this.$$undinternal$1.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__F__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(mapping, value, $m_Lorg_yaml_model_YMapEntry$().apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry($m_Lorg_yaml_model_YNode$().Empty$1, $m_Lorg_yaml_model_YNode$().Empty$1))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot find node mapping for propertyId " + propertyId)))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.getTypeUris__sjs_js_Array = (function() {
  var this$3 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$2 = this.$$undinternal$1.meta__Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel().type$1;
  var f = (function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_vocabulary_ValueType(x$1$2);
      return x$1.iri__T()
    })
  })(this);
  var this$1 = $m_sci_List$();
  var bf = this$1.ReusableCBFInstance$2;
  if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
    if ((this$2 === $m_sci_Nil$())) {
      var jsx$1 = $m_sci_Nil$()
    } else {
      var arg1 = this$2.head__O();
      var h = new $c_sci_$colon$colon().init___O__sci_List(f(arg1), $m_sci_Nil$());
      var t = h;
      var rest = $as_sci_List(this$2.tail__O());
      while ((rest !== $m_sci_Nil$())) {
        var arg1$1 = rest.head__O();
        var nx = new $c_sci_$colon$colon().init___O__sci_List(f(arg1$1), $m_sci_Nil$());
        t.tl$5 = nx;
        t = nx;
        rest = $as_sci_List(rest.tail__O())
      };
      var jsx$1 = h
    }
  } else {
    var b = $f_sc_TraversableLike__builder$1__psc_TraversableLike__scg_CanBuildFrom__scm_Builder(this$2, bf);
    var these = this$2;
    while ((!these.isEmpty__Z())) {
      var arg1$2 = these.head__O();
      b.$$plus$eq__O__scm_Builder(f(arg1$2));
      these = $as_sci_List(these.tail__O())
    };
    var jsx$1 = b.result__O()
  };
  var from = $as_sc_Seq(jsx$1);
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$3, from, m).asClient__O()
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.withDefinedby__Lamf_client_model_domain_NodeMapping__Lamf_client_model_domain_DialectDomainElement = (function(nodeMapping) {
  this.$$undinternal$1.withDefinedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(nodeMapping.$$undinternal$1);
  return this
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$getScalarByPropertyUri__T__O = (function(propertyId) {
  return this.getScalarByPropertyUri__T__sjs_js_Array(propertyId)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$setObjectCollectionProperty__T__sjs_js_Array__O = (function(propertyId, value) {
  return this.setObjectCollectionProperty__T__sjs_js_Array__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(propertyId, value)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$withAbstract__Z__O = (function(isAbstract) {
  return this.withAbstract__Z__Lamf_client_model_domain_DialectDomainElement(isAbstract)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$$js$exported$meth$getScalarValueByPropertyUri__T__O = (function(propertyId) {
  return this.getScalarValueByPropertyUri__T__sjs_js_Array(propertyId)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.setLiteralProperty__T__T__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(propertyId, value) {
  var x1 = this.$$undinternal$1.findPropertyMappingByTermPropertyId__T__s_Option($m_Lamf_core_vocabulary_Namespace$().expand__T__Lamf_core_vocabulary_ValueType(propertyId).iri__T());
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var mapping = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x2.value$2);
    return this.$$undinternal$1.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(mapping, value, $m_Lorg_yaml_model_YMapEntry$().apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry($m_Lorg_yaml_model_YNode$().Empty$1, $m_Lorg_yaml_model_YNode$().Empty$1))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot find node mapping for propertyId " + propertyId)))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_DialectDomainElement.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_DialectDomainElement.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DialectDomainElement.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DialectDomainElement.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DialectDomainElement.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.setLiteralProperty = (function(arg, arg$2) {
  if (((typeof arg$2) === "boolean")) {
    var prep$11 = $as_T(arg);
    var prep$12 = $uZ(arg$2);
    return this.$$js$exported$meth$setLiteralProperty__T__Z__O(prep$11, prep$12)
  } else if ($isInt(arg$2)) {
    var prep$9 = $as_T(arg);
    var prep$10 = $uI(arg$2);
    return this.$$js$exported$meth$setLiteralProperty__T__I__O(prep$9, prep$10)
  } else if ($isFloat(arg$2)) {
    var prep$7 = $as_T(arg);
    var prep$8 = $uF(arg$2);
    return this.$$js$exported$meth$setLiteralProperty__T__F__O(prep$7, prep$8)
  } else if (((typeof arg$2) === "number")) {
    var prep$5 = $as_T(arg);
    var prep$6 = $uD(arg$2);
    return this.$$js$exported$meth$setLiteralProperty__T__D__O(prep$5, prep$6)
  } else if ($is_T(arg$2)) {
    var prep$3 = $as_T(arg);
    var prep$4 = $as_T(arg$2);
    return this.$$js$exported$meth$setLiteralProperty__T__T__O(prep$3, prep$4)
  } else {
    var prep = $as_T(arg);
    var prep$2 = arg$2;
    return this.$$js$exported$meth$setLiteralProperty__T__sjs_js_Array__O(prep, prep$2)
  }
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.getObjectPropertyUri = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$getObjectPropertyUri__T__O(prep)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.getScalarValueByPropertyUri = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$getScalarValueByPropertyUri__T__O(prep)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.getScalarByPropertyUri = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$getScalarByPropertyUri__T__O(prep)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.getPropertyUris = (function() {
  return this.$$js$exported$meth$getPropertyUris__O()
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.getTypeUris = (function() {
  return this.$$js$exported$meth$getTypeUris__O()
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.setObjectCollectionProperty = (function(arg, arg$2) {
  var prep = $as_T(arg);
  var prep$2 = arg$2;
  return this.$$js$exported$meth$setObjectCollectionProperty__T__sjs_js_Array__O(prep, prep$2)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.setObjectProperty = (function(arg, arg$2) {
  var prep = $as_T(arg);
  var prep$2 = $as_Lamf_client_model_domain_DialectDomainElement(arg$2);
  return this.$$js$exported$meth$setObjectProperty__T__Lamf_client_model_domain_DialectDomainElement__O(prep, prep$2)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.includeName = (function() {
  return this.$$js$exported$meth$includeName__O()
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.localRefName = (function() {
  return this.$$js$exported$meth$localRefName__O()
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.definedBy = (function() {
  return this.$$js$exported$meth$definedBy__O()
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.withDefinedby = (function(arg) {
  var prep = $as_Lamf_client_model_domain_NodeMapping(arg);
  return this.$$js$exported$meth$withDefinedby__Lamf_client_model_domain_NodeMapping__O(prep)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.withInstanceTypes = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withInstanceTypes__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.withAbstract = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withAbstract__Z__O(prep)
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.isAbstract = (function() {
  return this.$$js$exported$meth$isAbstract__O()
});
function $as_Lamf_client_model_domain_DialectDomainElement(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_DialectDomainElement) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.DialectDomainElement"))
}
function $isArrayOf_Lamf_client_model_domain_DialectDomainElement(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_DialectDomainElement)))
}
function $asArrayOf_Lamf_client_model_domain_DialectDomainElement(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_DialectDomainElement(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.DialectDomainElement;", depth))
}
var $d_Lamf_client_model_domain_DialectDomainElement = new $TypeData().initClass({
  Lamf_client_model_domain_DialectDomainElement: 0
}, false, "amf.client.model.domain.DialectDomainElement", {
  Lamf_client_model_domain_DialectDomainElement: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_DialectDomainElement.prototype.$classData = $d_Lamf_client_model_domain_DialectDomainElement;
/** @constructor */
function $c_Lamf_client_model_domain_DocumentMapping() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_DocumentMapping.prototype = new $h_O();
$c_Lamf_client_model_domain_DocumentMapping.prototype.constructor = $c_Lamf_client_model_domain_DocumentMapping;
/** @constructor */
function $h_Lamf_client_model_domain_DocumentMapping() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_DocumentMapping.prototype = $c_Lamf_client_model_domain_DocumentMapping.prototype;
$c_Lamf_client_model_domain_DocumentMapping.prototype.$$js$exported$meth$encoded__O = (function() {
  return this.encoded__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.$$js$exported$meth$documentName__O = (function() {
  return this.documentName__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.productPrefix__T = (function() {
  return "DocumentMapping"
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_DocumentMapping.prototype.init___Lamf_plugins_document_vocabularies_model_domain_DocumentMapping.call(this, new $c_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_DocumentMapping)) {
    var DocumentMapping$1 = $as_Lamf_client_model_domain_DocumentMapping(x$1);
    var x = this.$$undinternal$1;
    var x$2 = DocumentMapping$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.withDocumentName__T__Lamf_client_model_domain_DocumentMapping = (function(name) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DocumentName$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name));
  return this
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.init___Lamf_plugins_document_vocabularies_model_domain_DocumentMapping = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.declaredNodes__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DeclaredNodes$1));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().PublicNodeMappingConverter__Lamf_client_convert_PublicNodeMappingConverter$PublicNodeMappingConverter$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.$$js$exported$meth$withDocumentName__T__O = (function(name) {
  return this.withDocumentName__T__Lamf_client_model_domain_DocumentMapping(name)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.$$js$exported$meth$withDeclaredNodes__sjs_js_Array__O = (function(declarations) {
  return this.withDeclaredNodes__sjs_js_Array__Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(declarations)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.$$js$exported$meth$withEncoded__T__O = (function(encodedNode) {
  return this.withEncoded__T__Lamf_client_model_domain_DocumentMapping(encodedNode)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.withEncoded__T__Lamf_client_model_domain_DocumentMapping = (function(encodedNode) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().EncodedNode$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, encodedNode));
  return this
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.$$js$exported$meth$declaredNodes__O = (function() {
  return this.declaredNodes__sjs_js_Array()
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.withDeclaredNodes__sjs_js_Array__Lamf_plugins_document_vocabularies_model_domain_DocumentMapping = (function(declarations) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().PublicNodeMappingConverter__Lamf_client_convert_PublicNodeMappingConverter$PublicNodeMappingConverter$();
  var fragments = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, declarations, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DeclaredNodes$1;
  return $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, fragments))
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.documentName__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DocumentName$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.encoded__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().EncodedNode$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_DocumentMapping.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_DocumentMapping.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DocumentMapping.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DocumentMapping.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DocumentMapping.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.withDeclaredNodes = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withDeclaredNodes__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.declaredNodes = (function() {
  return this.$$js$exported$meth$declaredNodes__O()
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.withEncoded = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withEncoded__T__O(prep)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.encoded = (function() {
  return this.$$js$exported$meth$encoded__O()
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.withDocumentName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDocumentName__T__O(prep)
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.documentName = (function() {
  return this.$$js$exported$meth$documentName__O()
});
function $as_Lamf_client_model_domain_DocumentMapping(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_DocumentMapping) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.DocumentMapping"))
}
function $isArrayOf_Lamf_client_model_domain_DocumentMapping(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_DocumentMapping)))
}
function $asArrayOf_Lamf_client_model_domain_DocumentMapping(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_DocumentMapping(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.DocumentMapping;", depth))
}
var $d_Lamf_client_model_domain_DocumentMapping = new $TypeData().initClass({
  Lamf_client_model_domain_DocumentMapping: 0
}, false, "amf.client.model.domain.DocumentMapping", {
  Lamf_client_model_domain_DocumentMapping: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_DocumentMapping.prototype.$classData = $d_Lamf_client_model_domain_DocumentMapping;
/** @constructor */
function $c_Lamf_client_model_domain_DocumentsModel() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_DocumentsModel.prototype = new $h_O();
$c_Lamf_client_model_domain_DocumentsModel.prototype.constructor = $c_Lamf_client_model_domain_DocumentsModel;
/** @constructor */
function $h_Lamf_client_model_domain_DocumentsModel() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_DocumentsModel.prototype = $c_Lamf_client_model_domain_DocumentsModel.prototype;
$c_Lamf_client_model_domain_DocumentsModel.prototype.productPrefix__T = (function() {
  return "DocumentsModel"
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_DocumentsModel.prototype.init___Lamf_plugins_document_vocabularies_model_domain_DocumentsModel.call(this, new $c_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$meth$withDeclarationsPath__T__O = (function(declarationsPath) {
  return this.withDeclarationsPath__T__Lamf_client_model_domain_DocumentsModel(declarationsPath)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.withDeclarationsPath__T__Lamf_client_model_domain_DocumentsModel = (function(declarationsPath) {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().DeclarationsPath$1;
  var from = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, declarationsPath));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().DocumentModelConverter__Lamf_client_convert_DocumentsModelConverter$DocumentModelConverter$();
  return m.asClient__Lamf_plugins_document_vocabularies_model_domain_DocumentsModel__Lamf_client_model_domain_DocumentsModel(from)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.library__Lamf_client_model_domain_DocumentMapping = (function() {
  var this$1 = this.$$undinternal$1;
  return new $c_Lamf_client_model_domain_DocumentMapping().init___Lamf_plugins_document_vocabularies_model_domain_DocumentMapping($as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Library$1)))
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_DocumentsModel)) {
    var DocumentsModel$1 = $as_Lamf_client_model_domain_DocumentsModel(x$1);
    var x = this.$$undinternal$1;
    var x$2 = DocumentsModel$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.declarationsPath__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().DeclarationsPath$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.fragments__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Fragments$1));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().DocumentMappingConverter__Lamf_client_convert_DocumentMappingConverter$DocumentMappingConverter$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$meth$withFragments__sjs_js_Array__O = (function(fragments) {
  return this.withFragments__sjs_js_Array__Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(fragments)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.withSelfEncoded__Z__Lamf_client_model_domain_DocumentsModel = (function(selfEncoded) {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().SelfEncoded$1;
  var from = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, selfEncoded));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().DocumentModelConverter__Lamf_client_convert_DocumentsModelConverter$DocumentModelConverter$();
  return m.asClient__Lamf_plugins_document_vocabularies_model_domain_DocumentsModel__Lamf_client_model_domain_DocumentsModel(from)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$meth$withSelfEncoded__Z__O = (function(selfEncoded) {
  return this.withSelfEncoded__Z__Lamf_client_model_domain_DocumentsModel(selfEncoded)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.root__Lamf_client_model_domain_DocumentMapping = (function() {
  var this$1 = this.$$undinternal$1;
  return new $c_Lamf_client_model_domain_DocumentMapping().init___Lamf_plugins_document_vocabularies_model_domain_DocumentMapping($as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Root$1)))
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$meth$library__O = (function() {
  return this.library__Lamf_client_model_domain_DocumentMapping()
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$meth$root__O = (function() {
  return this.root__Lamf_client_model_domain_DocumentMapping()
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$meth$keyProperty__O = (function() {
  return this.keyProperty__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$meth$selfEncoded__O = (function() {
  return this.selfEncoded__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.keyProperty__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().KeyProperty$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$meth$withLibrary__Lamf_client_model_domain_DocumentMapping__O = (function(library) {
  var this$1 = this.$$undinternal$1;
  var library$1 = library.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Library$1;
  return $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$1, field, library$1))
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.selfEncoded__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().SelfEncoded$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$meth$fragments__O = (function() {
  return this.fragments__sjs_js_Array()
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.withFragments__sjs_js_Array__Lamf_plugins_document_vocabularies_model_domain_DocumentsModel = (function(fragments) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().DocumentMappingConverter__Lamf_client_convert_DocumentMappingConverter$DocumentMappingConverter$();
  var fragments$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, fragments, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Fragments$1;
  return $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, fragments$1))
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.withKeyProperty__Z__Lamf_client_model_domain_DocumentsModel = (function(keyProperty) {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().KeyProperty$1;
  var from = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, keyProperty));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().DocumentModelConverter__Lamf_client_convert_DocumentsModelConverter$DocumentModelConverter$();
  return m.asClient__Lamf_plugins_document_vocabularies_model_domain_DocumentsModel__Lamf_client_model_domain_DocumentsModel(from)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$meth$withRoot__Lamf_client_model_domain_DocumentMapping__O = (function(documentMapping) {
  var this$1 = this.$$undinternal$1;
  var documentMapping$1 = documentMapping.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Root$1;
  return $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$1, field, documentMapping$1))
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$meth$withKeyProperty__Z__O = (function(keyProperty) {
  return this.withKeyProperty__Z__Lamf_client_model_domain_DocumentsModel(keyProperty)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$$js$exported$meth$declarationsPath__O = (function() {
  return this.declarationsPath__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.init___Lamf_plugins_document_vocabularies_model_domain_DocumentsModel = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_DocumentsModel.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_DocumentsModel.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DocumentsModel.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DocumentsModel.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DocumentsModel.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.withKeyProperty = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withKeyProperty__Z__O(prep)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.keyProperty = (function() {
  return this.$$js$exported$meth$keyProperty__O()
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.withDeclarationsPath = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDeclarationsPath__T__O(prep)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.declarationsPath = (function() {
  return this.$$js$exported$meth$declarationsPath__O()
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.withSelfEncoded = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withSelfEncoded__Z__O(prep)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.selfEncoded = (function() {
  return this.$$js$exported$meth$selfEncoded__O()
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.withLibrary = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DocumentMapping(arg);
  return this.$$js$exported$meth$withLibrary__Lamf_client_model_domain_DocumentMapping__O(prep)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.library = (function() {
  return this.$$js$exported$meth$library__O()
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.withFragments = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withFragments__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.fragments = (function() {
  return this.$$js$exported$meth$fragments__O()
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.withRoot = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DocumentMapping(arg);
  return this.$$js$exported$meth$withRoot__Lamf_client_model_domain_DocumentMapping__O(prep)
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.root = (function() {
  return this.$$js$exported$meth$root__O()
});
function $as_Lamf_client_model_domain_DocumentsModel(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_DocumentsModel) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.DocumentsModel"))
}
function $isArrayOf_Lamf_client_model_domain_DocumentsModel(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_DocumentsModel)))
}
function $asArrayOf_Lamf_client_model_domain_DocumentsModel(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_DocumentsModel(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.DocumentsModel;", depth))
}
var $d_Lamf_client_model_domain_DocumentsModel = new $TypeData().initClass({
  Lamf_client_model_domain_DocumentsModel: 0
}, false, "amf.client.model.domain.DocumentsModel", {
  Lamf_client_model_domain_DocumentsModel: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_DocumentsModel.prototype.$classData = $d_Lamf_client_model_domain_DocumentsModel;
/** @constructor */
function $c_Lamf_client_model_domain_DomainExtension() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_DomainExtension.prototype = new $h_O();
$c_Lamf_client_model_domain_DomainExtension.prototype.constructor = $c_Lamf_client_model_domain_DomainExtension;
/** @constructor */
function $h_Lamf_client_model_domain_DomainExtension() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_DomainExtension.prototype = $c_Lamf_client_model_domain_DomainExtension.prototype;
$c_Lamf_client_model_domain_DomainExtension.prototype.init___Lamf_core_model_domain_extensions_DomainExtension = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_DomainExtension.prototype.productPrefix__T = (function() {
  return "DomainExtension"
});
$c_Lamf_client_model_domain_DomainExtension.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_DomainExtension.prototype.init___Lamf_core_model_domain_extensions_DomainExtension.call(this, new $c_Lamf_core_model_domain_extensions_DomainExtension().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_DomainExtension.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_DomainExtension.prototype.definedBy__Lamf_client_model_domain_CustomDomainProperty = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().DefinedBy$1));
  $m_Lamf_client_convert_CoreClientConverters$().CustomDomainPropertyMatcher__Lamf_client_convert_CustomDomainPropertyConverter$CustomDomainPropertyMatcher$();
  return new $c_Lamf_client_model_domain_CustomDomainProperty().init___Lamf_core_model_domain_extensions_CustomDomainProperty(from)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_DomainExtension.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_DomainExtension)) {
    var DomainExtension$1 = $as_Lamf_client_model_domain_DomainExtension(x$1);
    var x = this.$$undinternal$1;
    var x$2 = DomainExtension$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_DomainExtension.prototype.$$js$exported$prop$extension__O = (function() {
  return this.extension__Lamf_client_model_domain_DataNode()
});
$c_Lamf_client_model_domain_DomainExtension.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_DomainExtension.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_DomainExtension.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.withName__T__Lamf_client_model_domain_DomainExtension = (function(name) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Name$1;
  $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name));
  return this
});
$c_Lamf_client_model_domain_DomainExtension.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.withDefinedBy__Lamf_client_model_domain_CustomDomainProperty__Lamf_client_model_domain_DomainExtension = (function(property) {
  var this$1 = this.$$undinternal$1;
  var customProperty = property.$$undinternal$1;
  var field = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().DefinedBy$1;
  $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$1, field, customProperty));
  return this
});
$c_Lamf_client_model_domain_DomainExtension.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.$$js$exported$prop$definedBy__O = (function() {
  return this.definedBy__Lamf_client_model_domain_CustomDomainProperty()
});
$c_Lamf_client_model_domain_DomainExtension.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_DomainExtension.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_DomainExtension.prototype.withExtension__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_DomainExtension = (function(node) {
  var this$1 = this.$$undinternal$1;
  var extension = node.$$undinternal__Lamf_core_model_domain_DataNode();
  var field = $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1;
  $as_Lamf_core_model_domain_extensions_DomainExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$1, field, extension));
  return this
});
$c_Lamf_client_model_domain_DomainExtension.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_DomainExtension.prototype.extension__Lamf_client_model_domain_DataNode = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_domain_DataNode(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1));
  var m = $m_Lamf_client_convert_CoreClientConverters$().DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$();
  return m.asClient__Lamf_core_model_domain_DataNode__Lamf_client_model_domain_DataNode(from)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.$$js$exported$meth$withExtension__Lamf_client_model_domain_DataNode__O = (function(node) {
  return this.withExtension__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_DomainExtension(node)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_DomainExtension(name)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.$$js$exported$meth$withDefinedBy__Lamf_client_model_domain_CustomDomainProperty__O = (function(property) {
  return this.withDefinedBy__Lamf_client_model_domain_CustomDomainProperty__Lamf_client_model_domain_DomainExtension(property)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_DomainExtension.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_DomainExtension.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_DomainExtension.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_DomainExtension.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_DomainExtension.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DomainExtension.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DomainExtension.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DomainExtension.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_DomainExtension.prototype.withExtension = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DataNode(arg);
  return this.$$js$exported$meth$withExtension__Lamf_client_model_domain_DataNode__O(prep)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.withDefinedBy = (function(arg) {
  var prep = $as_Lamf_client_model_domain_CustomDomainProperty(arg);
  return this.$$js$exported$meth$withDefinedBy__Lamf_client_model_domain_CustomDomainProperty__O(prep)
});
$c_Lamf_client_model_domain_DomainExtension.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_DomainExtension.prototype, "extension", {
  "get": (function() {
    return this.$$js$exported$prop$extension__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DomainExtension.prototype, "definedBy", {
  "get": (function() {
    return this.$$js$exported$prop$definedBy__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DomainExtension.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_DomainExtension(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_DomainExtension) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.DomainExtension"))
}
function $isArrayOf_Lamf_client_model_domain_DomainExtension(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_DomainExtension)))
}
function $asArrayOf_Lamf_client_model_domain_DomainExtension(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_DomainExtension(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.DomainExtension;", depth))
}
var $d_Lamf_client_model_domain_DomainExtension = new $TypeData().initClass({
  Lamf_client_model_domain_DomainExtension: 0
}, false, "amf.client.model.domain.DomainExtension", {
  Lamf_client_model_domain_DomainExtension: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_DomainExtension.prototype.$classData = $d_Lamf_client_model_domain_DomainExtension;
/** @constructor */
function $c_Lamf_client_model_domain_Encoding() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_Encoding.prototype = new $h_O();
$c_Lamf_client_model_domain_Encoding.prototype.constructor = $c_Lamf_client_model_domain_Encoding;
/** @constructor */
function $h_Lamf_client_model_domain_Encoding() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_Encoding.prototype = $c_Lamf_client_model_domain_Encoding.prototype;
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$meth$withHeader__T__O = (function(name) {
  return this.withHeader__T__Lamf_client_model_domain_Parameter(name)
});
$c_Lamf_client_model_domain_Encoding.prototype.productPrefix__T = (function() {
  return "Encoding"
});
$c_Lamf_client_model_domain_Encoding.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_Encoding.prototype.init___Lamf_plugins_domain_webapi_models_Encoding.call(this, new $c_Lamf_plugins_domain_webapi_models_Encoding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_Encoding.prototype.withExplode__Z__Lamf_client_model_domain_Encoding = (function(explode) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().Explode$1;
  $as_Lamf_plugins_domain_webapi_models_Encoding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, explode));
  return this
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$meth$withHeaders__sjs_js_Array__O = (function(headers) {
  return this.withHeaders__sjs_js_Array__Lamf_client_model_domain_Encoding(headers)
});
$c_Lamf_client_model_domain_Encoding.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_Encoding.prototype.explode__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().Explode$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$prop$allowReserved__O = (function() {
  return this.allowReserved__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_Encoding.prototype.withPropertyName__T__Lamf_client_model_domain_Encoding = (function(propertyName) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().PropertyName$1;
  $as_Lamf_plugins_domain_webapi_models_Encoding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, propertyName));
  return this
});
$c_Lamf_client_model_domain_Encoding.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Encoding.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_Encoding)) {
    var Encoding$1 = $as_Lamf_client_model_domain_Encoding(x$1);
    var x = this.$$undinternal$1;
    var x$2 = Encoding$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$prop$contentType__O = (function() {
  return this.contentType__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Encoding.prototype.withHeader__T__Lamf_client_model_domain_Parameter = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withHeader__T__Lamf_plugins_domain_webapi_models_Parameter(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Parameter__Lamf_client_model_domain_Parameter(from)
});
$c_Lamf_client_model_domain_Encoding.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$meth$withContentType__T__O = (function(contentType) {
  return this.withContentType__T__Lamf_client_model_domain_Encoding(contentType)
});
$c_Lamf_client_model_domain_Encoding.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_Encoding.prototype.style__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().Style$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$meth$withStyle__T__O = (function(style) {
  return this.withStyle__T__Lamf_client_model_domain_Encoding(style)
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$meth$withExplode__Z__O = (function(explode) {
  return this.withExplode__Z__Lamf_client_model_domain_Encoding(explode)
});
$c_Lamf_client_model_domain_Encoding.prototype.contentType__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().ContentType$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$prop$explode__O = (function() {
  return this.explode__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_Encoding.prototype.withAllowReserved__Z__Lamf_client_model_domain_Encoding = (function(allowReserved) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().AllowReserved$1;
  $as_Lamf_plugins_domain_webapi_models_Encoding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, allowReserved));
  return this
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Encoding.prototype.headers__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().Headers$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$prop$propertyName__O = (function() {
  return this.propertyName__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Encoding.prototype.withContentType__T__Lamf_client_model_domain_Encoding = (function(contentType) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().ContentType$1;
  $as_Lamf_plugins_domain_webapi_models_Encoding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, contentType));
  return this
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$meth$withPropertyName__T__O = (function(propertyName) {
  return this.withPropertyName__T__Lamf_client_model_domain_Encoding(propertyName)
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$prop$headers__O = (function() {
  return this.headers__sjs_js_Array()
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$meth$withAllowReserved__Z__O = (function(allowReserved) {
  return this.withAllowReserved__Z__Lamf_client_model_domain_Encoding(allowReserved)
});
$c_Lamf_client_model_domain_Encoding.prototype.init___Lamf_plugins_domain_webapi_models_Encoding = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_Encoding.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Encoding.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_Encoding.prototype.propertyName__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().PropertyName$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Encoding.prototype.withHeaders__sjs_js_Array__Lamf_client_model_domain_Encoding = (function(headers) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  var headers$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, headers, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().Headers$1;
  $as_Lamf_plugins_domain_webapi_models_Encoding($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, headers$1));
  return this
});
$c_Lamf_client_model_domain_Encoding.prototype.$$js$exported$prop$style__O = (function() {
  return this.style__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Encoding.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_Encoding.prototype.withStyle__T__Lamf_client_model_domain_Encoding = (function(style) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().Style$1;
  $as_Lamf_plugins_domain_webapi_models_Encoding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, style));
  return this
});
$c_Lamf_client_model_domain_Encoding.prototype.allowReserved__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().AllowReserved$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_Encoding.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_Encoding.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_Encoding.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Encoding.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Encoding.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_Encoding.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Encoding.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Encoding.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Encoding.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Encoding.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Encoding.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Encoding.prototype.withHeader = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withHeader__T__O(prep)
});
$c_Lamf_client_model_domain_Encoding.prototype.withAllowReserved = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withAllowReserved__Z__O(prep)
});
$c_Lamf_client_model_domain_Encoding.prototype.withExplode = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withExplode__Z__O(prep)
});
$c_Lamf_client_model_domain_Encoding.prototype.withStyle = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withStyle__T__O(prep)
});
$c_Lamf_client_model_domain_Encoding.prototype.withHeaders = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withHeaders__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Encoding.prototype.withContentType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withContentType__T__O(prep)
});
$c_Lamf_client_model_domain_Encoding.prototype.withPropertyName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withPropertyName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Encoding.prototype, "allowReserved", {
  "get": (function() {
    return this.$$js$exported$prop$allowReserved__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Encoding.prototype, "explode", {
  "get": (function() {
    return this.$$js$exported$prop$explode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Encoding.prototype, "style", {
  "get": (function() {
    return this.$$js$exported$prop$style__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Encoding.prototype, "headers", {
  "get": (function() {
    return this.$$js$exported$prop$headers__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Encoding.prototype, "contentType", {
  "get": (function() {
    return this.$$js$exported$prop$contentType__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Encoding.prototype, "propertyName", {
  "get": (function() {
    return this.$$js$exported$prop$propertyName__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_Encoding(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_Encoding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Encoding"))
}
function $isArrayOf_Lamf_client_model_domain_Encoding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Encoding)))
}
function $asArrayOf_Lamf_client_model_domain_Encoding(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Encoding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Encoding;", depth))
}
var $d_Lamf_client_model_domain_Encoding = new $TypeData().initClass({
  Lamf_client_model_domain_Encoding: 0
}, false, "amf.client.model.domain.Encoding", {
  Lamf_client_model_domain_Encoding: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_Encoding.prototype.$classData = $d_Lamf_client_model_domain_Encoding;
/** @constructor */
function $c_Lamf_client_model_domain_External() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_External.prototype = new $h_O();
$c_Lamf_client_model_domain_External.prototype.constructor = $c_Lamf_client_model_domain_External;
/** @constructor */
function $h_Lamf_client_model_domain_External() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_External.prototype = $c_Lamf_client_model_domain_External.prototype;
$c_Lamf_client_model_domain_External.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_External.prototype.init___Lamf_plugins_document_vocabularies_model_domain_External.call(this, new $c_Lamf_plugins_document_vocabularies_model_domain_External().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_External.prototype.productPrefix__T = (function() {
  return "External"
});
$c_Lamf_client_model_domain_External.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_External.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_External.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_External.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_External.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_External.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_External)) {
    var External$1 = $as_Lamf_client_model_domain_External(x$1);
    var x = this.$$undinternal$1;
    var x$2 = External$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_External.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_External.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_External.prototype.$$js$exported$meth$withBase__T__O = (function(base) {
  return this.withBase__T__Lamf_client_model_domain_External(base)
});
$c_Lamf_client_model_domain_External.prototype.$$js$exported$prop$base__O = (function() {
  return this.base__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_External.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_External.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_External.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_External.prototype.$$js$exported$meth$withAlias__T__O = (function(alias) {
  return this.withAlias__T__Lamf_client_model_domain_External(alias)
});
$c_Lamf_client_model_domain_External.prototype.alias__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().DisplayName$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_External.prototype.$$js$exported$prop$alias__O = (function() {
  return this.alias__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_External.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_External.prototype.base__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().Base$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_External.prototype.withBase__T__Lamf_client_model_domain_External = (function(base) {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().Base$1;
  var from = $as_Lamf_plugins_document_vocabularies_model_domain_External($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, base));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().ExternalConverter__Lamf_client_convert_ExternalConverter$ExternalConverter$();
  return m.asClient__Lamf_plugins_document_vocabularies_model_domain_External__Lamf_client_model_domain_External(from)
});
$c_Lamf_client_model_domain_External.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_External.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_External.prototype.withAlias__T__Lamf_client_model_domain_External = (function(alias) {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().DisplayName$1;
  var from = $as_Lamf_plugins_document_vocabularies_model_domain_External($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, alias));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().ExternalConverter__Lamf_client_convert_ExternalConverter$ExternalConverter$();
  return m.asClient__Lamf_plugins_document_vocabularies_model_domain_External__Lamf_client_model_domain_External(from)
});
$c_Lamf_client_model_domain_External.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_External.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_External.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_External.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_External.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_External.prototype.init___Lamf_plugins_document_vocabularies_model_domain_External = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_External.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_External.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_External.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_External.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_External.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_External.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_External.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_External.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_External.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_External.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_External.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_External.prototype.withBase = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withBase__T__O(prep)
});
$c_Lamf_client_model_domain_External.prototype.withAlias = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withAlias__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_External.prototype, "base", {
  "get": (function() {
    return this.$$js$exported$prop$base__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_External.prototype, "alias", {
  "get": (function() {
    return this.$$js$exported$prop$alias__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_External(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_External) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.External"))
}
function $isArrayOf_Lamf_client_model_domain_External(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_External)))
}
function $asArrayOf_Lamf_client_model_domain_External(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_External(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.External;", depth))
}
var $d_Lamf_client_model_domain_External = new $TypeData().initClass({
  Lamf_client_model_domain_External: 0
}, false, "amf.client.model.domain.External", {
  Lamf_client_model_domain_External: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_External.prototype.$classData = $d_Lamf_client_model_domain_External;
/** @constructor */
function $c_Lamf_client_model_domain_ExternalDomainElement() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_ExternalDomainElement.prototype = new $h_O();
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.constructor = $c_Lamf_client_model_domain_ExternalDomainElement;
/** @constructor */
function $h_Lamf_client_model_domain_ExternalDomainElement() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_ExternalDomainElement.prototype = $c_Lamf_client_model_domain_ExternalDomainElement.prototype;
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.init___Lamf_core_model_domain_ExternalDomainElement = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_ExternalDomainElement.prototype.init___Lamf_core_model_domain_ExternalDomainElement.call(this, new $c_Lamf_core_model_domain_ExternalDomainElement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.productPrefix__T = (function() {
  return "ExternalDomainElement"
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.$$js$exported$meth$withRaw__T__O = (function(raw) {
  return this.withRaw__T__Lamf_client_model_domain_ExternalDomainElement(raw)
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.mediaType__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().MediaType$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_ExternalDomainElement)) {
    var ExternalDomainElement$1 = $as_Lamf_client_model_domain_ExternalDomainElement(x$1);
    var x = this.$$undinternal$1;
    var x$2 = ExternalDomainElement$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.withMediaType__T__Lamf_client_model_domain_ExternalDomainElement = (function(mediaType) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().MediaType$1;
  $as_Lamf_core_model_domain_ExternalDomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, mediaType));
  return this
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.raw__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.$$js$exported$prop$raw__O = (function() {
  return this.raw__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.$$js$exported$meth$withMediaType__T__O = (function(mediaType) {
  return this.withMediaType__T__Lamf_client_model_domain_ExternalDomainElement(mediaType)
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.$$js$exported$prop$mediaType__O = (function() {
  return this.mediaType__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.withRaw__T__Lamf_client_model_domain_ExternalDomainElement = (function(raw) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1;
  $as_Lamf_core_model_domain_ExternalDomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, raw));
  return this
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ExternalDomainElement.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ExternalDomainElement.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ExternalDomainElement.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ExternalDomainElement.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ExternalDomainElement.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.withMediaType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withMediaType__T__O(prep)
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.withRaw = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withRaw__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ExternalDomainElement.prototype, "mediaType", {
  "get": (function() {
    return this.$$js$exported$prop$mediaType__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ExternalDomainElement.prototype, "raw", {
  "get": (function() {
    return this.$$js$exported$prop$raw__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_ExternalDomainElement(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_ExternalDomainElement) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.ExternalDomainElement"))
}
function $isArrayOf_Lamf_client_model_domain_ExternalDomainElement(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_ExternalDomainElement)))
}
function $asArrayOf_Lamf_client_model_domain_ExternalDomainElement(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_ExternalDomainElement(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.ExternalDomainElement;", depth))
}
var $d_Lamf_client_model_domain_ExternalDomainElement = new $TypeData().initClass({
  Lamf_client_model_domain_ExternalDomainElement: 0
}, false, "amf.client.model.domain.ExternalDomainElement", {
  Lamf_client_model_domain_ExternalDomainElement: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_ExternalDomainElement.prototype.$classData = $d_Lamf_client_model_domain_ExternalDomainElement;
/** @constructor */
function $c_Lamf_client_model_domain_IriTemplateMapping() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_IriTemplateMapping.prototype = new $h_O();
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.constructor = $c_Lamf_client_model_domain_IriTemplateMapping;
/** @constructor */
function $h_Lamf_client_model_domain_IriTemplateMapping() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_IriTemplateMapping.prototype = $c_Lamf_client_model_domain_IriTemplateMapping.prototype;
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.$$js$exported$meth$withTemplateVariable__T__O = (function(variable) {
  return this.withTemplateVariable__T__Lamf_client_model_domain_IriTemplateMapping(variable)
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_IriTemplateMapping.prototype.init___Lamf_plugins_domain_webapi_models_IriTemplateMapping.call(this, new $c_Lamf_plugins_domain_webapi_models_IriTemplateMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.productPrefix__T = (function() {
  return "IriTemplateMapping"
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.withTemplateVariable__T__Lamf_client_model_domain_IriTemplateMapping = (function(variable) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$().TemplateVariable$1;
  $as_Lamf_plugins_domain_webapi_models_IriTemplateMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, variable));
  return this
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.$$js$exported$prop$templateVariable__O = (function() {
  return this.templateVariable__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_IriTemplateMapping)) {
    var IriTemplateMapping$1 = $as_Lamf_client_model_domain_IriTemplateMapping(x$1);
    var x = this.$$undinternal$1;
    var x$2 = IriTemplateMapping$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.templateVariable__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$().TemplateVariable$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.withLinkExpression__T__Lamf_client_model_domain_IriTemplateMapping = (function(expression) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$().LinkExpression$1;
  $as_Lamf_plugins_domain_webapi_models_IriTemplateMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, expression));
  return this
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.$$js$exported$prop$linkExpression__O = (function() {
  return this.linkExpression__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.init___Lamf_plugins_domain_webapi_models_IriTemplateMapping = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.$$js$exported$meth$withLinkExpression__T__O = (function(expression) {
  return this.withLinkExpression__T__Lamf_client_model_domain_IriTemplateMapping(expression)
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.linkExpression__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$().LinkExpression$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_IriTemplateMapping.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_IriTemplateMapping.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_IriTemplateMapping.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_IriTemplateMapping.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_IriTemplateMapping.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.withLinkExpression = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkExpression__T__O(prep)
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.withTemplateVariable = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withTemplateVariable__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_IriTemplateMapping.prototype, "linkExpression", {
  "get": (function() {
    return this.$$js$exported$prop$linkExpression__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_IriTemplateMapping.prototype, "templateVariable", {
  "get": (function() {
    return this.$$js$exported$prop$templateVariable__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_IriTemplateMapping(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_IriTemplateMapping) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.IriTemplateMapping"))
}
function $isArrayOf_Lamf_client_model_domain_IriTemplateMapping(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_IriTemplateMapping)))
}
function $asArrayOf_Lamf_client_model_domain_IriTemplateMapping(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_IriTemplateMapping(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.IriTemplateMapping;", depth))
}
var $d_Lamf_client_model_domain_IriTemplateMapping = new $TypeData().initClass({
  Lamf_client_model_domain_IriTemplateMapping: 0
}, false, "amf.client.model.domain.IriTemplateMapping", {
  Lamf_client_model_domain_IriTemplateMapping: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_IriTemplateMapping.prototype.$classData = $d_Lamf_client_model_domain_IriTemplateMapping;
/** @constructor */
function $c_Lamf_client_model_domain_MqttServerLastWill() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_MqttServerLastWill.prototype = new $h_O();
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.constructor = $c_Lamf_client_model_domain_MqttServerLastWill;
/** @constructor */
function $h_Lamf_client_model_domain_MqttServerLastWill() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_MqttServerLastWill.prototype = $c_Lamf_client_model_domain_MqttServerLastWill.prototype;
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.productPrefix__T = (function() {
  return "MqttServerLastWill"
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_MqttServerLastWill.prototype.init___Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill.call(this, new $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.withQos__I__Lamf_client_model_domain_MqttServerLastWill = (function(qos) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$().Qos$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject(this$1, field, qos));
  return this
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.$$js$exported$prop$retain__O = (function() {
  return this.retain__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_MqttServerLastWill)) {
    var MqttServerLastWill$1 = $as_Lamf_client_model_domain_MqttServerLastWill(x$1);
    var x = this.$$undinternal$1;
    var x$2 = MqttServerLastWill$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.withRetain__Z__Lamf_client_model_domain_MqttServerLastWill = (function(retain) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$().Retain$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, retain));
  return this
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.retain__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$().Retain$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.$$js$exported$meth$withRetain__Z__O = (function(retain) {
  return this.withRetain__Z__Lamf_client_model_domain_MqttServerLastWill(retain)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.qos__Lamf_client_model_IntField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_IntField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$().Qos$1));
  $m_Lamf_client_convert_WebApiClientConverters$().IntFieldMatcher__Lamf_client_convert_FieldConverter$IntFieldMatcher$();
  return new $c_Lamf_client_model_IntField().init___Lamf_core_model_IntField(from)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.init___Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.$$js$exported$prop$topic__O = (function() {
  return this.topic__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.topic__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$().Topic$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.$$js$exported$meth$withQos__I__O = (function(qos) {
  return this.withQos__I__Lamf_client_model_domain_MqttServerLastWill(qos)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.$$js$exported$meth$withTopic__T__O = (function(topic) {
  return this.withTopic__T__Lamf_client_model_domain_MqttServerLastWill(topic)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.withTopic__T__Lamf_client_model_domain_MqttServerLastWill = (function(topic) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$().Topic$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, topic));
  return this
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.$$js$exported$prop$qos__O = (function() {
  return this.qos__Lamf_client_model_IntField()
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_MqttServerLastWill.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_MqttServerLastWill.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttServerLastWill.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttServerLastWill.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttServerLastWill.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.withRetain = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withRetain__Z__O(prep)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.withQos = (function(arg) {
  var prep = $uI(arg);
  return this.$$js$exported$meth$withQos__I__O(prep)
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.withTopic = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withTopic__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_MqttServerLastWill.prototype, "retain", {
  "get": (function() {
    return this.$$js$exported$prop$retain__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttServerLastWill.prototype, "qos", {
  "get": (function() {
    return this.$$js$exported$prop$qos__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttServerLastWill.prototype, "topic", {
  "get": (function() {
    return this.$$js$exported$prop$topic__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_MqttServerLastWill(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_MqttServerLastWill) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.MqttServerLastWill"))
}
function $isArrayOf_Lamf_client_model_domain_MqttServerLastWill(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_MqttServerLastWill)))
}
function $asArrayOf_Lamf_client_model_domain_MqttServerLastWill(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_MqttServerLastWill(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.MqttServerLastWill;", depth))
}
var $d_Lamf_client_model_domain_MqttServerLastWill = new $TypeData().initClass({
  Lamf_client_model_domain_MqttServerLastWill: 0
}, false, "amf.client.model.domain.MqttServerLastWill", {
  Lamf_client_model_domain_MqttServerLastWill: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_MqttServerLastWill.prototype.$classData = $d_Lamf_client_model_domain_MqttServerLastWill;
/** @constructor */
function $c_Lamf_client_model_domain_OAuth2Flow() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_OAuth2Flow.prototype = new $h_O();
$c_Lamf_client_model_domain_OAuth2Flow.prototype.constructor = $c_Lamf_client_model_domain_OAuth2Flow;
/** @constructor */
function $h_Lamf_client_model_domain_OAuth2Flow() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_OAuth2Flow.prototype = $c_Lamf_client_model_domain_OAuth2Flow.prototype;
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$js$exported$prop$flow__O = (function() {
  return this.flow__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.productPrefix__T = (function() {
  return "OAuth2Flow"
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_OAuth2Flow.prototype.init___Lamf_plugins_domain_webapi_models_security_OAuth2Flow.call(this, new $c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.authorizationUri__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.withRefreshUri__T__Lamf_client_model_domain_OAuth2Flow = (function(refreshUri) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().RefreshUri$1;
  $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, refreshUri));
  return this
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$js$exported$meth$withAuthorizationUri__T__O = (function(authorizationUri) {
  return this.withAuthorizationUri__T__Lamf_client_model_domain_OAuth2Flow(authorizationUri)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_OAuth2Flow)) {
    var OAuth2Flow$1 = $as_Lamf_client_model_domain_OAuth2Flow(x$1);
    var x = this.$$undinternal$1;
    var x$2 = OAuth2Flow$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.withAccessTokenUri__T__Lamf_client_model_domain_OAuth2Flow = (function(accessTokenUri) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1;
  $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, accessTokenUri));
  return this
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.withAuthorizationUri__T__Lamf_client_model_domain_OAuth2Flow = (function(authorizationUri) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AuthorizationUri$1;
  $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, authorizationUri));
  return this
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$js$exported$meth$withRefreshUri__T__O = (function(refreshUri) {
  return this.withRefreshUri__T__Lamf_client_model_domain_OAuth2Flow(refreshUri)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$js$exported$prop$accessTokenUri__O = (function() {
  return this.accessTokenUri__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.scopes__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Scopes$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ScopeMatcher__Lamf_client_convert_ScopeConverter$ScopeMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$js$exported$meth$withScopes__sjs_js_Array__O = (function(scopes) {
  return this.withScopes__sjs_js_Array__Lamf_client_model_domain_OAuth2Flow(scopes)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.init___Lamf_plugins_domain_webapi_models_security_OAuth2Flow = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$js$exported$meth$withFlow__T__O = (function(flow) {
  return this.withFlow__T__Lamf_client_model_domain_OAuth2Flow(flow)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.refreshUri__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().RefreshUri$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$js$exported$prop$refreshUri__O = (function() {
  return this.refreshUri__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.withScopes__sjs_js_Array__Lamf_client_model_domain_OAuth2Flow = (function(scopes) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ScopeMatcher__Lamf_client_convert_ScopeConverter$ScopeMatcher$();
  var scopes$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, scopes, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Scopes$1;
  $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, scopes$1));
  return this
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$js$exported$meth$withAccessTokenUri__T__O = (function(accessTokenUri) {
  return this.withAccessTokenUri__T__Lamf_client_model_domain_OAuth2Flow(accessTokenUri)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.accessTokenUri__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().AccessTokenUri$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$js$exported$prop$authorizationUri__O = (function() {
  return this.authorizationUri__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.withFlow__T__Lamf_client_model_domain_OAuth2Flow = (function(flow) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Flow$1;
  $as_Lamf_plugins_domain_webapi_models_security_OAuth2Flow($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, flow));
  return this
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.flow__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2FlowModel$().Flow$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$$js$exported$prop$scopes__O = (function() {
  return this.scopes__sjs_js_Array()
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_OAuth2Flow.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_OAuth2Flow.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_OAuth2Flow.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_OAuth2Flow.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_OAuth2Flow.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.withFlow = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withFlow__T__O(prep)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.withScopes = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withScopes__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.withRefreshUri = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withRefreshUri__T__O(prep)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.withAccessTokenUri = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withAccessTokenUri__T__O(prep)
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.withAuthorizationUri = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withAuthorizationUri__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_OAuth2Flow.prototype, "flow", {
  "get": (function() {
    return this.$$js$exported$prop$flow__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_OAuth2Flow.prototype, "scopes", {
  "get": (function() {
    return this.$$js$exported$prop$scopes__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_OAuth2Flow.prototype, "refreshUri", {
  "get": (function() {
    return this.$$js$exported$prop$refreshUri__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_OAuth2Flow.prototype, "accessTokenUri", {
  "get": (function() {
    return this.$$js$exported$prop$accessTokenUri__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_OAuth2Flow.prototype, "authorizationUri", {
  "get": (function() {
    return this.$$js$exported$prop$authorizationUri__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_OAuth2Flow(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_OAuth2Flow) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.OAuth2Flow"))
}
function $isArrayOf_Lamf_client_model_domain_OAuth2Flow(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_OAuth2Flow)))
}
function $asArrayOf_Lamf_client_model_domain_OAuth2Flow(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_OAuth2Flow(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.OAuth2Flow;", depth))
}
var $d_Lamf_client_model_domain_OAuth2Flow = new $TypeData().initClass({
  Lamf_client_model_domain_OAuth2Flow: 0
}, false, "amf.client.model.domain.OAuth2Flow", {
  Lamf_client_model_domain_OAuth2Flow: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_OAuth2Flow.prototype.$classData = $d_Lamf_client_model_domain_OAuth2Flow;
/** @constructor */
function $c_Lamf_client_model_domain_ParametrizedSecurityScheme() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype = new $h_O();
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.constructor = $c_Lamf_client_model_domain_ParametrizedSecurityScheme;
/** @constructor */
function $h_Lamf_client_model_domain_ParametrizedSecurityScheme() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype = $c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype;
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.settings__Lamf_client_model_domain_Settings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_plugins_domain_webapi_models_security_Settings(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Settings$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().SettingsMatcher__Lamf_client_convert_SettingsConverter$SettingsMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_security_Settings__Lamf_client_model_domain_Settings(from)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$meth$withOAuth1Settings__O = (function() {
  return this.withOAuth1Settings__Lamf_client_model_domain_OAuth1Settings()
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.productPrefix__T = (function() {
  return "ParametrizedSecurityScheme"
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.init___Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.call(this, new $c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_ParametrizedSecurityScheme)) {
    var ParametrizedSecurityScheme$1 = $as_Lamf_client_model_domain_ParametrizedSecurityScheme(x$1);
    var x = this.$$undinternal$1;
    var x$2 = ParametrizedSecurityScheme$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withOAuth1Settings__Lamf_client_model_domain_OAuth1Settings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withOAuth1Settings__Lamf_plugins_domain_webapi_models_security_OAuth1Settings();
  $m_Lamf_client_convert_WebApiClientConverters$().OAuth1SettingsMatcher__Lamf_client_convert_SettingsConverter$OAuth1SettingsMatcher$();
  return new $c_Lamf_client_model_domain_OAuth1Settings().init___Lamf_plugins_domain_webapi_models_security_OAuth1Settings(from)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$prop$scheme__O = (function() {
  return this.scheme__Lamf_client_model_domain_SecurityScheme()
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withHttpSettings__Lamf_client_model_domain_HttpSettings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withHttpSettings__Lamf_plugins_domain_webapi_models_security_HttpSettings();
  $m_Lamf_client_convert_WebApiClientConverters$().HttpSettingsMatcher__Lamf_client_convert_SettingsConverter$HttpSettingsMatcher$();
  return new $c_Lamf_client_model_domain_HttpSettings().init___Lamf_plugins_domain_webapi_models_security_HttpSettings(from)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.description__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Description$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withName__T__Lamf_client_model_domain_ParametrizedSecurityScheme = (function(name) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Name$1;
  $as_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name));
  return this
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withApiKeySettings__Lamf_client_model_domain_ApiKeySettings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withApiKeySettings__Lamf_plugins_domain_webapi_models_security_ApiKeySettings();
  $m_Lamf_client_convert_WebApiClientConverters$().ApiKeySettingsMatcher__Lamf_client_convert_SettingsConverter$ApiKeySettingsMatcher$();
  return new $c_Lamf_client_model_domain_ApiKeySettings().init___Lamf_plugins_domain_webapi_models_security_ApiKeySettings(from)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withDescription__T__Lamf_client_model_domain_ParametrizedSecurityScheme = (function(description) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Description$1;
  $as_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, description));
  return this
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$meth$withOAuth2Settings__O = (function() {
  return this.withOAuth2Settings__Lamf_client_model_domain_OAuth2Settings()
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withScheme__Lamf_client_model_domain_SecurityScheme__Lamf_client_model_domain_ParametrizedSecurityScheme = (function(scheme) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().SecuritySchemeMatcher__Lamf_client_convert_SecuritySchemeConverter$SecuritySchemeMatcher$();
  var scheme$1 = scheme.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Scheme$1;
  $as_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, scheme$1));
  return this
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.init___Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$meth$withOpenIdConnectSettings__O = (function() {
  return this.withOpenIdConnectSettings__Lamf_client_model_domain_OpenIdConnectSettings()
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$meth$withScheme__Lamf_client_model_domain_SecurityScheme__O = (function(scheme) {
  return this.withScheme__Lamf_client_model_domain_SecurityScheme__Lamf_client_model_domain_ParametrizedSecurityScheme(scheme)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$meth$withDescription__T__O = (function(description) {
  return this.withDescription__T__Lamf_client_model_domain_ParametrizedSecurityScheme(description)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withOpenIdConnectSettings__Lamf_client_model_domain_OpenIdConnectSettings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withOpenIdConnectSettings__Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings();
  $m_Lamf_client_convert_WebApiClientConverters$().OpenIdConnectSettingsMatcher__Lamf_client_convert_SettingsConverter$OpenIdConnectSettingsMatcher$();
  return new $c_Lamf_client_model_domain_OpenIdConnectSettings().init___Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(from)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$meth$withApiKeySettings__O = (function() {
  return this.withApiKeySettings__Lamf_client_model_domain_ApiKeySettings()
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$prop$description__O = (function() {
  return this.description__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withSettings__Lamf_client_model_domain_Settings__Lamf_client_model_domain_ParametrizedSecurityScheme = (function(settings) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().SettingsMatcher__Lamf_client_convert_SettingsConverter$SettingsMatcher$();
  var settings$1 = settings.$$undinternal__Lamf_plugins_domain_webapi_models_security_Settings();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Settings$1;
  $as_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, settings$1));
  return this
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_ParametrizedSecurityScheme(name)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withOAuth2Settings__Lamf_client_model_domain_OAuth2Settings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withOAuth2Settings__Lamf_plugins_domain_webapi_models_security_OAuth2Settings();
  $m_Lamf_client_convert_WebApiClientConverters$().OAuth2SettingsMatcher__Lamf_client_convert_SettingsConverter$OAuth2SettingsMatcher$();
  return new $c_Lamf_client_model_domain_OAuth2Settings().init___Lamf_plugins_domain_webapi_models_security_OAuth2Settings(from)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.scheme__Lamf_client_model_domain_SecurityScheme = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Scheme$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().SecuritySchemeMatcher__Lamf_client_convert_SecuritySchemeConverter$SecuritySchemeMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_client_model_domain_SecurityScheme(from)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$meth$withSettings__Lamf_client_model_domain_Settings__O = (function(settings) {
  return this.withSettings__Lamf_client_model_domain_Settings__Lamf_client_model_domain_ParametrizedSecurityScheme(settings)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withDefaultSettings__Lamf_client_model_domain_Settings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withDefaultSettings__Lamf_plugins_domain_webapi_models_security_Settings();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().SettingsMatcher__Lamf_client_convert_SettingsConverter$SettingsMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_security_Settings__Lamf_client_model_domain_Settings(from)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$meth$withDefaultSettings__O = (function() {
  return this.withDefaultSettings__Lamf_client_model_domain_Settings()
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$prop$settings__O = (function() {
  return this.settings__Lamf_client_model_domain_Settings()
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$$js$exported$meth$withHttpSettings__O = (function() {
  return this.withHttpSettings__Lamf_client_model_domain_HttpSettings()
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withOpenIdConnectSettings = (function() {
  return this.$$js$exported$meth$withOpenIdConnectSettings__O()
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withHttpSettings = (function() {
  return this.$$js$exported$meth$withHttpSettings__O()
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withApiKeySettings = (function() {
  return this.$$js$exported$meth$withApiKeySettings__O()
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withOAuth2Settings = (function() {
  return this.$$js$exported$meth$withOAuth2Settings__O()
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withOAuth1Settings = (function() {
  return this.$$js$exported$meth$withOAuth1Settings__O()
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withDefaultSettings = (function() {
  return this.$$js$exported$meth$withDefaultSettings__O()
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withSettings = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Settings(arg);
  return this.$$js$exported$meth$withSettings__Lamf_client_model_domain_Settings__O(prep)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withScheme = (function(arg) {
  var prep = $as_Lamf_client_model_domain_SecurityScheme(arg);
  return this.$$js$exported$meth$withScheme__Lamf_client_model_domain_SecurityScheme__O(prep)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withDescription = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDescription__T__O(prep)
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype, "settings", {
  "get": (function() {
    return this.$$js$exported$prop$settings__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype, "scheme", {
  "get": (function() {
    return this.$$js$exported$prop$scheme__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_ParametrizedSecurityScheme(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_ParametrizedSecurityScheme) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.ParametrizedSecurityScheme"))
}
function $isArrayOf_Lamf_client_model_domain_ParametrizedSecurityScheme(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_ParametrizedSecurityScheme)))
}
function $asArrayOf_Lamf_client_model_domain_ParametrizedSecurityScheme(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_ParametrizedSecurityScheme(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.ParametrizedSecurityScheme;", depth))
}
var $d_Lamf_client_model_domain_ParametrizedSecurityScheme = new $TypeData().initClass({
  Lamf_client_model_domain_ParametrizedSecurityScheme: 0
}, false, "amf.client.model.domain.ParametrizedSecurityScheme", {
  Lamf_client_model_domain_ParametrizedSecurityScheme: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.$classData = $d_Lamf_client_model_domain_ParametrizedSecurityScheme;
/** @constructor */
function $c_Lamf_client_model_domain_PropertyDependencies() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_PropertyDependencies.prototype = new $h_O();
$c_Lamf_client_model_domain_PropertyDependencies.prototype.constructor = $c_Lamf_client_model_domain_PropertyDependencies;
/** @constructor */
function $h_Lamf_client_model_domain_PropertyDependencies() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_PropertyDependencies.prototype = $c_Lamf_client_model_domain_PropertyDependencies.prototype;
$c_Lamf_client_model_domain_PropertyDependencies.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_PropertyDependencies.prototype.init___Lamf_plugins_domain_shapes_models_PropertyDependencies.call(this, new $c_Lamf_plugins_domain_shapes_models_PropertyDependencies().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.init___Lamf_plugins_domain_shapes_models_PropertyDependencies = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.productPrefix__T = (function() {
  return "PropertyDependencies"
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.withPropertyTarget__sjs_js_Array__Lamf_client_model_domain_PropertyDependencies = (function(propertyTarget) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  var propertyTarget$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, propertyTarget, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$().PropertyTarget$1;
  $as_Lamf_plugins_domain_shapes_models_PropertyDependencies($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, propertyTarget$1));
  return this
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.$$js$exported$prop$target__O = (function() {
  return this.target__sjs_js_Array()
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_PropertyDependencies)) {
    var PropertyDependencies$1 = $as_Lamf_client_model_domain_PropertyDependencies(x$1);
    var x = this.$$undinternal$1;
    var x$2 = PropertyDependencies$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.source__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$().PropertySource$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.$$js$exported$prop$source__O = (function() {
  return this.source__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.$$js$exported$meth$withPropertySource__T__O = (function(propertySource) {
  return this.withPropertySource__T__Lamf_client_model_domain_PropertyDependencies(propertySource)
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.target__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$().PropertyTarget$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.withPropertySource__T__Lamf_client_model_domain_PropertyDependencies = (function(propertySource) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$().PropertySource$1;
  $as_Lamf_plugins_domain_shapes_models_PropertyDependencies($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, propertySource));
  return this
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.$$js$exported$meth$withPropertyTarget__sjs_js_Array__O = (function(propertyTarget) {
  return this.withPropertyTarget__sjs_js_Array__Lamf_client_model_domain_PropertyDependencies(propertyTarget)
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyDependencies.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyDependencies.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyDependencies.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyDependencies.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyDependencies.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.withPropertyTarget = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withPropertyTarget__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.withPropertySource = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withPropertySource__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyDependencies.prototype, "target", {
  "get": (function() {
    return this.$$js$exported$prop$target__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyDependencies.prototype, "source", {
  "get": (function() {
    return this.$$js$exported$prop$source__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_PropertyDependencies(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_PropertyDependencies) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.PropertyDependencies"))
}
function $isArrayOf_Lamf_client_model_domain_PropertyDependencies(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_PropertyDependencies)))
}
function $asArrayOf_Lamf_client_model_domain_PropertyDependencies(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_PropertyDependencies(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.PropertyDependencies;", depth))
}
var $d_Lamf_client_model_domain_PropertyDependencies = new $TypeData().initClass({
  Lamf_client_model_domain_PropertyDependencies: 0
}, false, "amf.client.model.domain.PropertyDependencies", {
  Lamf_client_model_domain_PropertyDependencies: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_PropertyDependencies.prototype.$classData = $d_Lamf_client_model_domain_PropertyDependencies;
/** @constructor */
function $c_Lamf_client_model_domain_PropertyMapping() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_PropertyMapping.prototype = new $h_O();
$c_Lamf_client_model_domain_PropertyMapping.prototype.constructor = $c_Lamf_client_model_domain_PropertyMapping;
/** @constructor */
function $h_Lamf_client_model_domain_PropertyMapping() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_PropertyMapping.prototype = $c_Lamf_client_model_domain_PropertyMapping.prototype;
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$nodePropertyMapping__O = (function() {
  return this.nodePropertyMapping__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$mapValueProperty__O = (function() {
  return this.mapValueProperty__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$pattern__O = (function() {
  return this.pattern__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withMapKeyProperty__T__Lamf_client_model_domain_PropertyMapping = (function(key) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapKeyProperty$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, key));
  return this
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withTypeDiscriminatorName__T__Lamf_client_model_domain_PropertyMapping = (function(name) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().TypeDiscriminatorName$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name);
  return this
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.productPrefix__T = (function() {
  return "PropertyMapping"
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_PropertyMapping.prototype.init___Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.call(this, new $c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.init___Lamf_plugins_document_vocabularies_model_domain_PropertyMapping = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.minCount__Lamf_client_model_IntField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_IntField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MinCount$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().IntFieldMatcher__Lamf_client_convert_FieldConverter$IntFieldMatcher$();
  return new $c_Lamf_client_model_IntField().init___Lamf_core_model_IntField(from)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$enum__O = (function() {
  return this.$enum__sjs_js_Array()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$minimum__O = (function() {
  return this.minimum__Lamf_client_model_DoubleField()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$withPattern__T__O = (function(pattern) {
  return this.withPattern__T__Lamf_client_model_domain_PropertyMapping(pattern)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_PropertyMapping)) {
    var PropertyMapping$1 = $as_Lamf_client_model_domain_PropertyMapping(x$1);
    var x = this.$$undinternal$1;
    var x$2 = PropertyMapping$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withSorted__Z__Lamf_client_model_domain_PropertyMapping = (function(sorted) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Sorted$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, sorted));
  return this
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withMaximum__D__Lamf_client_model_domain_PropertyMapping = (function(max) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Maximum$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__D__Lamf_core_model_domain_AmfObject(this$1, field, max));
  return this
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$classification__O = (function() {
  return this.classification__T()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$minCount__O = (function() {
  return this.minCount__Lamf_client_model_IntField()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.typeDiscriminator__sjs_js_Dictionary = (function() {
  var jsx$1 = $m_s_Option$();
  var this$1 = this.$$undinternal$1;
  var x1 = jsx$1.apply__O__s_Option($f_Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__typeDiscriminator__sci_Map(this$1));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var m = $as_sci_Map(x2.value$2);
    var this$2 = $m_Lamf_client_convert_VocabulariesClientConverter$();
    var z = $m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$());
    var op = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
      return (function(x0$1$2, x1$1$2) {
        var x0$1 = $as_scm_Map(x0$1$2);
        var x1$1 = $as_T2(x1$1$2);
        var x1$2 = new $c_T2().init___O__O(x0$1, x1$1);
        var acc = $as_scm_Map(x1$2.$$und1$f);
        var p2 = $as_T2(x1$2.$$und2$f);
        if ((p2 !== null)) {
          var k = $as_T(p2.$$und1__O());
          var v = $as_T(p2.$$und2__O());
          acc.put__O__O__s_Option(k, v);
          return acc
        };
        throw new $c_s_MatchError().init___O(x1$2)
      })
    })(this));
    var from = $as_scm_Map($f_sc_TraversableOnce__foldLeft__O__F2__O(m, z, op));
    var m$1 = $m_Lamf_client_convert_VocabulariesClientConverter$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
    return new $c_Lamf_client_convert_CollectionConverter$InternalMapOps().init___Lamf_client_convert_CollectionConverter__scm_Map__Lamf_client_convert_InternalClientMatcher(this$2, from, m$1).asClient__O()
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$3 = $m_Lamf_client_convert_VocabulariesClientConverter$();
      var from$1 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
      var m$2 = $m_Lamf_client_convert_VocabulariesClientConverter$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
      return new $c_Lamf_client_convert_CollectionConverter$InternalMapOps().init___Lamf_client_convert_CollectionConverter__scm_Map__Lamf_client_convert_InternalClientMatcher(this$3, from$1, m$2).asClient__O()
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$withMapValueProperty__T__O = (function(value) {
  return this.withMapValueProperty__T__Lamf_client_model_domain_PropertyMapping(value)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$enum__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Enum$1));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().AnyFieldMatcher__Lamf_client_convert_FieldConverter$AnyFieldMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$withSorted__Z__O = (function(sorted) {
  return this.withSorted__Z__Lamf_client_model_domain_PropertyMapping(sorted)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.pattern__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Pattern$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$withLiteralRange__T__O = (function(range) {
  return this.withLiteralRange__T__Lamf_client_model_domain_PropertyMapping(range)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$externallyLikable__O = (function() {
  return this.externallyLikable__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$typeDiscriminator__O = (function() {
  return this.typeDiscriminator__sjs_js_Dictionary()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withMapValueProperty__T__Lamf_client_model_domain_PropertyMapping = (function(value) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapValueProperty$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, value));
  return this
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$allowMultiple__O = (function() {
  return this.allowMultiple__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$withMapKeyProperty__T__O = (function(key) {
  return this.withMapKeyProperty__T__Lamf_client_model_domain_PropertyMapping(key)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$withTypeDiscriminatorName__T__O = (function(name) {
  return this.withTypeDiscriminatorName__T__Lamf_client_model_domain_PropertyMapping(name)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.nodePropertyMapping__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$objectRange__O = (function() {
  return this.objectRange__sjs_js_Array()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.objectRange__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.typeDiscriminatorName__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().TypeDiscriminatorName$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$withObjectRange__sjs_js_Array__O = (function(range) {
  return this.withObjectRange__sjs_js_Array__Lamf_client_model_domain_PropertyMapping(range)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$withTypeDiscriminator__sjs_js_Dictionary__O = (function(typesMapping) {
  this.withTypeDiscriminator__sjs_js_Dictionary__sr_Nothing$(typesMapping)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$sorted__O = (function() {
  return this.sorted__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.maximum__Lamf_client_model_DoubleField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_DoubleField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Maximum$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().DoubleFieldMatcher__Lamf_client_convert_FieldConverter$DoubleFieldMatcher$();
  return new $c_Lamf_client_model_DoubleField().init___Lamf_core_model_DoubleField(from)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.classification__T = (function() {
  var x1 = this.$$undinternal$1.classification__Lamf_plugins_document_vocabularies_model_domain_PropertyClassification();
  var x = $m_Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$();
  if ((x === x1)) {
    return "extension_property"
  } else {
    var x$3 = $m_Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$();
    if ((x$3 === x1)) {
      return "literal_property"
    } else {
      var x$5 = $m_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$();
      if ((x$5 === x1)) {
        return "object_property"
      } else {
        var x$7 = $m_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$();
        if ((x$7 === x1)) {
          return "object_property_collection"
        } else {
          var x$9 = $m_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$();
          if ((x$9 === x1)) {
            return "object_map_property"
          } else {
            var x$11 = $m_Lamf_plugins_document_vocabularies_model_domain_ObjectMapInheritanceProperty$();
            if ((x$11 === x1)) {
              return "object_map_inheritance"
            } else {
              var x$13 = $m_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$();
              if ((x$13 === x1)) {
                return "object_pair_property"
              } else {
                var x$15 = $m_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$();
                if ((x$15 === x1)) {
                  return "literal_property_collection"
                } else {
                  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Unknown property classification " + x1)))
                }
              }
            }
          }
        }
      }
    }
  }
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$maximum__O = (function() {
  return this.maximum__Lamf_client_model_DoubleField()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withAllowMultiple__Z__Lamf_client_model_domain_PropertyMapping = (function(allow) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().AllowMultiple$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, allow));
  return this
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$withNodePropertyMapping__T__O = (function(propertyId) {
  return this.withNodePropertyMapping__T__Lamf_client_model_domain_PropertyMapping(propertyId)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$withEnum__sjs_js_Array__O = (function(values) {
  return this.withEnum__sjs_js_Array__Lamf_client_model_domain_PropertyMapping(values)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.literalRange__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withName__T__Lamf_client_model_domain_PropertyMapping = (function(name) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name));
  return this
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$withMaximum__D__O = (function(max) {
  return this.withMaximum__D__Lamf_client_model_domain_PropertyMapping(max)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$withExternallyLinkable__Z__O = (function(linkable) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().ExternallyLinkable$1;
  return $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, linkable))
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$withMinimum__D__O = (function(min) {
  return this.withMinimum__D__Lamf_client_model_domain_PropertyMapping(min)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withPattern__T__Lamf_client_model_domain_PropertyMapping = (function(pattern) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Pattern$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, pattern));
  return this
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$withAllowMultiple__Z__O = (function(allow) {
  return this.withAllowMultiple__Z__Lamf_client_model_domain_PropertyMapping(allow)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withMinCount__I__Lamf_client_model_domain_PropertyMapping = (function(minCount) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MinCount$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject(this$1, field, minCount));
  return this
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withTypeDiscriminator__sjs_js_Dictionary__sr_Nothing$ = (function(typesMapping) {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Not implemented yet"))
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withMinimum__D__Lamf_client_model_domain_PropertyMapping = (function(min) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Minimum$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__D__Lamf_core_model_domain_AmfObject(this$1, field, min));
  return this
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.minimum__Lamf_client_model_DoubleField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_DoubleField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Minimum$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().DoubleFieldMatcher__Lamf_client_convert_FieldConverter$DoubleFieldMatcher$();
  return new $c_Lamf_client_model_DoubleField().init___Lamf_core_model_DoubleField(from)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$withMinCount__I__O = (function(minCount) {
  return this.withMinCount__I__Lamf_client_model_domain_PropertyMapping(minCount)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.allowMultiple__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().AllowMultiple$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.mapValueProperty__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapKeyProperty$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.externallyLikable__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().ExternallyLinkable$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$typeDiscriminatorName__O = (function() {
  return this.typeDiscriminatorName__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.mapKeyProperty__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapKeyProperty$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_PropertyMapping(name)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withObjectRange__sjs_js_Array__Lamf_client_model_domain_PropertyMapping = (function(range) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  var range$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, range, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, range$1);
  return this
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withLiteralRange__T__Lamf_client_model_domain_PropertyMapping = (function(range) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, range));
  return this
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withEnum__sjs_js_Array__Lamf_client_model_domain_PropertyMapping = (function(values) {
  var jsx$1 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().AnyMatcher__Lamf_client_convert_CoreBaseConverter$AnyMatcher$();
  jsx$1.withEnum__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, values, m).asInternal__sc_Seq());
  return this
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.sorted__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Sorted$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$literalRange__O = (function() {
  return this.literalRange__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$$js$exported$meth$mapKeyProperty__O = (function() {
  return this.mapKeyProperty__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withNodePropertyMapping__T__Lamf_client_model_domain_PropertyMapping = (function(propertyId) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, propertyId));
  return this
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyMapping.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyMapping.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyMapping.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyMapping.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyMapping.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.classification = (function() {
  return this.$$js$exported$meth$classification__O()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.externallyLikable = (function() {
  return this.$$js$exported$meth$externallyLikable__O()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withExternallyLinkable = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withExternallyLinkable__Z__O(prep)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withTypeDiscriminatorName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withTypeDiscriminatorName__T__O(prep)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.typeDiscriminatorName = (function() {
  return this.$$js$exported$meth$typeDiscriminatorName__O()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withTypeDiscriminator = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withTypeDiscriminator__sjs_js_Dictionary__O(prep)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.typeDiscriminator = (function() {
  return this.$$js$exported$meth$typeDiscriminator__O()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withSorted = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withSorted__Z__O(prep)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.sorted = (function() {
  return this.$$js$exported$meth$sorted__O()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withEnum = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withEnum__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype["enum"] = (function() {
  return this.$$js$exported$meth$enum__O()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withAllowMultiple = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withAllowMultiple__Z__O(prep)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.allowMultiple = (function() {
  return this.$$js$exported$meth$allowMultiple__O()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withMaximum = (function(arg) {
  var prep = $uD(arg);
  return this.$$js$exported$meth$withMaximum__D__O(prep)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.maximum = (function() {
  return this.$$js$exported$meth$maximum__O()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withMinimum = (function(arg) {
  var prep = $uD(arg);
  return this.$$js$exported$meth$withMinimum__D__O(prep)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.minimum = (function() {
  return this.$$js$exported$meth$minimum__O()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withPattern = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withPattern__T__O(prep)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.pattern = (function() {
  return this.$$js$exported$meth$pattern__O()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withMinCount = (function(arg) {
  var prep = $uI(arg);
  return this.$$js$exported$meth$withMinCount__I__O(prep)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.minCount = (function() {
  return this.$$js$exported$meth$minCount__O()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withMapValueProperty = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withMapValueProperty__T__O(prep)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.mapValueProperty = (function() {
  return this.$$js$exported$meth$mapValueProperty__O()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withMapKeyProperty = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withMapKeyProperty__T__O(prep)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.mapKeyProperty = (function() {
  return this.$$js$exported$meth$mapKeyProperty__O()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.objectRange = (function() {
  return this.$$js$exported$meth$objectRange__O()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withObjectRange = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withObjectRange__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.literalRange = (function() {
  return this.$$js$exported$meth$literalRange__O()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withLiteralRange = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLiteralRange__T__O(prep)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.nodePropertyMapping = (function() {
  return this.$$js$exported$meth$nodePropertyMapping__O()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withNodePropertyMapping = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withNodePropertyMapping__T__O(prep)
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.name = (function() {
  return this.$$js$exported$meth$name__O()
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
function $as_Lamf_client_model_domain_PropertyMapping(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_PropertyMapping) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.PropertyMapping"))
}
function $isArrayOf_Lamf_client_model_domain_PropertyMapping(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_PropertyMapping)))
}
function $asArrayOf_Lamf_client_model_domain_PropertyMapping(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_PropertyMapping(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.PropertyMapping;", depth))
}
var $d_Lamf_client_model_domain_PropertyMapping = new $TypeData().initClass({
  Lamf_client_model_domain_PropertyMapping: 0
}, false, "amf.client.model.domain.PropertyMapping", {
  Lamf_client_model_domain_PropertyMapping: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_PropertyMapping.prototype.$classData = $d_Lamf_client_model_domain_PropertyMapping;
/** @constructor */
function $c_Lamf_client_model_domain_PublicNodeMapping() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_PublicNodeMapping.prototype = new $h_O();
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.constructor = $c_Lamf_client_model_domain_PublicNodeMapping;
/** @constructor */
function $h_Lamf_client_model_domain_PublicNodeMapping() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_PublicNodeMapping.prototype = $c_Lamf_client_model_domain_PublicNodeMapping.prototype;
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.$$js$exported$meth$mappedNode__O = (function() {
  return this.mappedNode__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.withMappedNode__T__Lamf_client_model_domain_PublicNodeMapping = (function(mappedNode) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().MappedNode$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, mappedNode));
  return this
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_PublicNodeMapping.prototype.init___Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping.call(this, new $c_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.productPrefix__T = (function() {
  return "PublicNodeMapping"
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().Name$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.$$js$exported$meth$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_PublicNodeMapping)) {
    var PublicNodeMapping$1 = $as_Lamf_client_model_domain_PublicNodeMapping(x$1);
    var x = this.$$undinternal$1;
    var x$2 = PublicNodeMapping$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.init___Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.mappedNode__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().MappedNode$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.$$js$exported$meth$withMappedNode__T__O = (function(mappedNode) {
  return this.withMappedNode__T__Lamf_client_model_domain_PublicNodeMapping(mappedNode)
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.withName__T__Lamf_client_model_domain_PublicNodeMapping = (function(name) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().Name$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name));
  return this
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_PublicNodeMapping(name)
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_PublicNodeMapping.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_PublicNodeMapping.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PublicNodeMapping.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PublicNodeMapping.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PublicNodeMapping.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.withMappedNode = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withMappedNode__T__O(prep)
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.mappedNode = (function() {
  return this.$$js$exported$meth$mappedNode__O()
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.name = (function() {
  return this.$$js$exported$meth$name__O()
});
function $as_Lamf_client_model_domain_PublicNodeMapping(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_PublicNodeMapping) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.PublicNodeMapping"))
}
function $isArrayOf_Lamf_client_model_domain_PublicNodeMapping(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_PublicNodeMapping)))
}
function $asArrayOf_Lamf_client_model_domain_PublicNodeMapping(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_PublicNodeMapping(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.PublicNodeMapping;", depth))
}
var $d_Lamf_client_model_domain_PublicNodeMapping = new $TypeData().initClass({
  Lamf_client_model_domain_PublicNodeMapping: 0
}, false, "amf.client.model.domain.PublicNodeMapping", {
  Lamf_client_model_domain_PublicNodeMapping: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_PublicNodeMapping.prototype.$classData = $d_Lamf_client_model_domain_PublicNodeMapping;
/** @constructor */
function $c_Lamf_client_model_domain_Scope() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_Scope.prototype = new $h_O();
$c_Lamf_client_model_domain_Scope.prototype.constructor = $c_Lamf_client_model_domain_Scope;
/** @constructor */
function $h_Lamf_client_model_domain_Scope() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_Scope.prototype = $c_Lamf_client_model_domain_Scope.prototype;
$c_Lamf_client_model_domain_Scope.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_Scope.prototype.init___Lamf_plugins_domain_webapi_models_security_Scope.call(this, new $c_Lamf_plugins_domain_webapi_models_security_Scope().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_Scope.prototype.productPrefix__T = (function() {
  return "Scope"
});
$c_Lamf_client_model_domain_Scope.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Scope.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_Scope.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_Scope.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Scope.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_Scope.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_Scope.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Scope.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_Scope)) {
    var Scope$1 = $as_Lamf_client_model_domain_Scope(x$1);
    var x = this.$$undinternal$1;
    var x$2 = Scope$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_Scope.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_Scope.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_Scope.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_Scope.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_Scope.prototype.description__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Description$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Scope.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_Scope.prototype.withDescription__T__Lamf_client_model_domain_Scope = (function(description) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Description$1;
  $as_Lamf_plugins_domain_webapi_models_security_Scope($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, description));
  return this
});
$c_Lamf_client_model_domain_Scope.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Scope.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Scope.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_Scope.prototype.$$js$exported$meth$withDescription__T__O = (function(description) {
  return this.withDescription__T__Lamf_client_model_domain_Scope(description)
});
$c_Lamf_client_model_domain_Scope.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_Scope.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_Scope.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Scope.prototype.$$js$exported$prop$description__O = (function() {
  return this.description__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Scope.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_Scope.prototype.init___Lamf_plugins_domain_webapi_models_security_Scope = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_Scope.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_Scope.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_Scope(name)
});
$c_Lamf_client_model_domain_Scope.prototype.withName__T__Lamf_client_model_domain_Scope = (function(name) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ScopeModel$().Name$1;
  $as_Lamf_plugins_domain_webapi_models_security_Scope($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name));
  return this
});
$c_Lamf_client_model_domain_Scope.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_Scope.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_Scope.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Scope.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Scope.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_Scope.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Scope.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Scope.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Scope.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Scope.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Scope.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Scope.prototype.withDescription = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDescription__T__O(prep)
});
$c_Lamf_client_model_domain_Scope.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Scope.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Scope.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_Scope(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_Scope) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Scope"))
}
function $isArrayOf_Lamf_client_model_domain_Scope(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Scope)))
}
function $asArrayOf_Lamf_client_model_domain_Scope(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Scope(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Scope;", depth))
}
var $d_Lamf_client_model_domain_Scope = new $TypeData().initClass({
  Lamf_client_model_domain_Scope: 0
}, false, "amf.client.model.domain.Scope", {
  Lamf_client_model_domain_Scope: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_Scope.prototype.$classData = $d_Lamf_client_model_domain_Scope;
/** @constructor */
function $c_Lamf_client_model_domain_SecurityRequirement() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_SecurityRequirement.prototype = new $h_O();
$c_Lamf_client_model_domain_SecurityRequirement.prototype.constructor = $c_Lamf_client_model_domain_SecurityRequirement;
/** @constructor */
function $h_Lamf_client_model_domain_SecurityRequirement() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_SecurityRequirement.prototype = $c_Lamf_client_model_domain_SecurityRequirement.prototype;
$c_Lamf_client_model_domain_SecurityRequirement.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_SecurityRequirement.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityRequirement.call(this, new $c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.productPrefix__T = (function() {
  return "SecurityRequirement"
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.$$js$exported$meth$withSchemes__sjs_js_Array__O = (function(schemes) {
  return this.withSchemes__sjs_js_Array__Lamf_client_model_domain_SecurityRequirement(schemes)
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_SecurityRequirement)) {
    var SecurityRequirement$1 = $as_Lamf_client_model_domain_SecurityRequirement(x$1);
    var x = this.$$undinternal$1;
    var x$2 = SecurityRequirement$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.withSchemes__sjs_js_Array__Lamf_client_model_domain_SecurityRequirement = (function(schemes) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParametrizedSecuritySchemeMatcher__Lamf_client_convert_ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$();
  var schemes$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, schemes, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$().Schemes$1;
  $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, schemes$1));
  return this
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityRequirement = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.withScheme__Lamf_client_model_domain_ParametrizedSecurityScheme = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withScheme__Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParametrizedSecuritySchemeMatcher__Lamf_client_convert_ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme__Lamf_client_model_domain_ParametrizedSecurityScheme(from)
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.withName__T__Lamf_client_model_domain_SecurityRequirement = (function(name) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$().Name$1;
  $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name));
  return this
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.$$js$exported$prop$schemes__O = (function() {
  return this.schemes__sjs_js_Array()
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.schemes__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$().Schemes$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParametrizedSecuritySchemeMatcher__Lamf_client_convert_ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_SecurityRequirement(name)
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.$$js$exported$meth$withScheme__O = (function() {
  return this.withScheme__Lamf_client_model_domain_ParametrizedSecurityScheme()
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityRequirement.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityRequirement.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityRequirement.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityRequirement.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityRequirement.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.withScheme = (function() {
  return this.$$js$exported$meth$withScheme__O()
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.withSchemes = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withSchemes__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityRequirement.prototype, "schemes", {
  "get": (function() {
    return this.$$js$exported$prop$schemes__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityRequirement.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_SecurityRequirement(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_SecurityRequirement) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.SecurityRequirement"))
}
function $isArrayOf_Lamf_client_model_domain_SecurityRequirement(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_SecurityRequirement)))
}
function $asArrayOf_Lamf_client_model_domain_SecurityRequirement(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_SecurityRequirement(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.SecurityRequirement;", depth))
}
var $d_Lamf_client_model_domain_SecurityRequirement = new $TypeData().initClass({
  Lamf_client_model_domain_SecurityRequirement: 0
}, false, "amf.client.model.domain.SecurityRequirement", {
  Lamf_client_model_domain_SecurityRequirement: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_SecurityRequirement.prototype.$classData = $d_Lamf_client_model_domain_SecurityRequirement;
/** @constructor */
function $c_Lamf_client_model_domain_Server() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_Server.prototype = new $h_O();
$c_Lamf_client_model_domain_Server.prototype.constructor = $c_Lamf_client_model_domain_Server;
/** @constructor */
function $h_Lamf_client_model_domain_Server() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_Server.prototype = $c_Lamf_client_model_domain_Server.prototype;
$c_Lamf_client_model_domain_Server.prototype.productPrefix__T = (function() {
  return "Server"
});
$c_Lamf_client_model_domain_Server.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_Server.prototype.init___Lamf_plugins_domain_webapi_models_Server.call(this, new $c_Lamf_plugins_domain_webapi_models_Server().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_Server.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_Server.prototype.withVariables__sjs_js_Array__Lamf_client_model_domain_Server = (function(variables) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  var variables$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, variables, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Variables$1;
  $as_Lamf_plugins_domain_webapi_models_Server($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, variables$1));
  return this
});
$c_Lamf_client_model_domain_Server.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$prop$url__O = (function() {
  return this.url__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Server.prototype.variables__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Variables$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$prop$protocol__O = (function() {
  return this.protocol__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_Server.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Server.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_Server)) {
    var Server$1 = $as_Lamf_client_model_domain_Server(x$1);
    var x = this.$$undinternal$1;
    var x$2 = Server$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_Server.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_Server.prototype.url__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Url$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$meth$withUrl__T__O = (function(url) {
  return this.withUrl__T__Lamf_client_model_domain_Server(url)
});
$c_Lamf_client_model_domain_Server.prototype.protocol__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Protocol$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Server.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_Server.prototype.withProtocol__T__Lamf_client_model_domain_Server = (function(protocol) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Protocol$1;
  $as_Lamf_plugins_domain_webapi_models_Server($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, protocol));
  return this
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$prop$bindings__O = (function() {
  return this.bindings__Lamf_client_model_domain_ServerBindings()
});
$c_Lamf_client_model_domain_Server.prototype.init___Lamf_plugins_domain_webapi_models_Server = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_Server.prototype.description__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Description$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Server.prototype.withSecurity__sjs_js_Array__Lamf_client_model_domain_Server = (function(security) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().SecurityRequirementMatcher__Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$();
  var security$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, security, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Security$1;
  $as_Lamf_plugins_domain_webapi_models_Server($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, security$1));
  return this
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_Server.prototype.protocolVersion__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().ProtocolVersion$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Server.prototype.bindings__Lamf_client_model_domain_ServerBindings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_plugins_domain_webapi_models_bindings_ServerBindings(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Bindings$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ServerBindingsMatcher__Lamf_client_convert_ServerBindingsConverter$ServerBindingsMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_ServerBindings__Lamf_client_model_domain_ServerBindings(from)
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$meth$withProtocolVersion__T__O = (function(protocolVersion) {
  return this.withProtocolVersion__T__Lamf_client_model_domain_Server(protocolVersion)
});
$c_Lamf_client_model_domain_Server.prototype.withUrl__T__Lamf_client_model_domain_Server = (function(url) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Url$1;
  $as_Lamf_plugins_domain_webapi_models_Server($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, url));
  return this
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Server.prototype.withProtocolVersion__T__Lamf_client_model_domain_Server = (function(protocolVersion) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().ProtocolVersion$1;
  $as_Lamf_plugins_domain_webapi_models_Server($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, protocolVersion));
  return this
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$meth$withProtocol__T__O = (function(protocol) {
  return this.withProtocol__T__Lamf_client_model_domain_Server(protocol)
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$meth$withSecurity__sjs_js_Array__O = (function(security) {
  return this.withSecurity__sjs_js_Array__Lamf_client_model_domain_Server(security)
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_Server.prototype.withVariable__T__Lamf_client_model_domain_Parameter = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withVariable__T__Lamf_plugins_domain_webapi_models_Parameter(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Parameter__Lamf_client_model_domain_Parameter(from)
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$meth$withDescription__T__O = (function(description) {
  return this.withDescription__T__Lamf_client_model_domain_Server(description)
});
$c_Lamf_client_model_domain_Server.prototype.withDescription__T__Lamf_client_model_domain_Server = (function(description) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Description$1;
  $as_Lamf_plugins_domain_webapi_models_Server($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, description));
  return this
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_Server.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$prop$variables__O = (function() {
  return this.variables__sjs_js_Array()
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$prop$security__O = (function() {
  return this.security__sjs_js_Array()
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$prop$description__O = (function() {
  return this.description__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Server.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$meth$withVariable__T__O = (function(name) {
  return this.withVariable__T__Lamf_client_model_domain_Parameter(name)
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$meth$withBindings__Lamf_client_model_domain_ServerBindings__O = (function(bindings) {
  return this.withBindings__Lamf_client_model_domain_ServerBindings__Lamf_client_model_domain_Server(bindings)
});
$c_Lamf_client_model_domain_Server.prototype.withBindings__Lamf_client_model_domain_ServerBindings__Lamf_client_model_domain_Server = (function(bindings) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().ServerBindingsMatcher__Lamf_client_convert_ServerBindingsConverter$ServerBindingsMatcher$();
  var bindings$1 = bindings.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Bindings$1;
  $as_Lamf_plugins_domain_webapi_models_Server($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, bindings$1));
  return this
});
$c_Lamf_client_model_domain_Server.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$prop$protocolVersion__O = (function() {
  return this.protocolVersion__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Server.prototype.$$js$exported$meth$withVariables__sjs_js_Array__O = (function(variables) {
  return this.withVariables__sjs_js_Array__Lamf_client_model_domain_Server(variables)
});
$c_Lamf_client_model_domain_Server.prototype.security__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Security$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().SecurityRequirementMatcher__Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Server.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_Server.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_Server.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Server.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Server.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_Server.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Server.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Server.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Server.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Server.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Server.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Server.prototype.withVariable = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withVariable__T__O(prep)
});
$c_Lamf_client_model_domain_Server.prototype.withBindings = (function(arg) {
  var prep = $as_Lamf_client_model_domain_ServerBindings(arg);
  return this.$$js$exported$meth$withBindings__Lamf_client_model_domain_ServerBindings__O(prep)
});
$c_Lamf_client_model_domain_Server.prototype.withSecurity = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withSecurity__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Server.prototype.withProtocolVersion = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withProtocolVersion__T__O(prep)
});
$c_Lamf_client_model_domain_Server.prototype.withProtocol = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withProtocol__T__O(prep)
});
$c_Lamf_client_model_domain_Server.prototype.withVariables = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withVariables__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Server.prototype.withDescription = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDescription__T__O(prep)
});
$c_Lamf_client_model_domain_Server.prototype.withUrl = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withUrl__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Server.prototype, "bindings", {
  "get": (function() {
    return this.$$js$exported$prop$bindings__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Server.prototype, "security", {
  "get": (function() {
    return this.$$js$exported$prop$security__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Server.prototype, "protocolVersion", {
  "get": (function() {
    return this.$$js$exported$prop$protocolVersion__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Server.prototype, "protocol", {
  "get": (function() {
    return this.$$js$exported$prop$protocol__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Server.prototype, "variables", {
  "get": (function() {
    return this.$$js$exported$prop$variables__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Server.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Server.prototype, "url", {
  "get": (function() {
    return this.$$js$exported$prop$url__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Server.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_Server(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_Server) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Server"))
}
function $isArrayOf_Lamf_client_model_domain_Server(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Server)))
}
function $asArrayOf_Lamf_client_model_domain_Server(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Server(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Server;", depth))
}
var $d_Lamf_client_model_domain_Server = new $TypeData().initClass({
  Lamf_client_model_domain_Server: 0
}, false, "amf.client.model.domain.Server", {
  Lamf_client_model_domain_Server: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_Server.prototype.$classData = $d_Lamf_client_model_domain_Server;
/** @constructor */
function $c_Lamf_client_model_domain_ShapeExtension() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_ShapeExtension.prototype = new $h_O();
$c_Lamf_client_model_domain_ShapeExtension.prototype.constructor = $c_Lamf_client_model_domain_ShapeExtension;
/** @constructor */
function $h_Lamf_client_model_domain_ShapeExtension() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_ShapeExtension.prototype = $c_Lamf_client_model_domain_ShapeExtension.prototype;
$c_Lamf_client_model_domain_ShapeExtension.prototype.$$js$exported$meth$withDefinedBy__Lamf_client_model_domain_PropertyShape__O = (function(definedBy) {
  return this.withDefinedBy__Lamf_client_model_domain_PropertyShape__Lamf_client_model_domain_ShapeExtension(definedBy)
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_ShapeExtension.prototype.init___Lamf_core_model_domain_extensions_ShapeExtension.call(this, new $c_Lamf_core_model_domain_extensions_ShapeExtension().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.productPrefix__T = (function() {
  return "ShapeExtension"
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.init___Lamf_core_model_domain_extensions_ShapeExtension = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.$$js$exported$prop$extension__O = (function() {
  return this.extension__Lamf_client_model_domain_DataNode()
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_ShapeExtension)) {
    var ShapeExtension$1 = $as_Lamf_client_model_domain_ShapeExtension(x$1);
    var x = this.$$undinternal$1;
    var x$2 = ShapeExtension$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.withExtension__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_ShapeExtension = (function(extension) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_CoreClientConverters$();
  $m_Lamf_client_convert_CoreClientConverters$().DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$();
  var extension$1 = extension.$$undinternal__Lamf_core_model_domain_DataNode();
  var field = $m_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$().Extension$1;
  $as_Lamf_core_model_domain_extensions_ShapeExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, extension$1));
  return this
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.definedBy__Lamf_client_model_domain_PropertyShape = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_domain_extensions_PropertyShape(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$().DefinedBy$1));
  var m = $m_Lamf_client_convert_CoreClientConverters$().PropertyShapeMatcher__Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_extensions_PropertyShape__Lamf_client_model_domain_PropertyShape(from)
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.$$js$exported$prop$definedBy__O = (function() {
  return this.definedBy__Lamf_client_model_domain_PropertyShape()
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.$$js$exported$meth$withExtension__Lamf_client_model_domain_DataNode__O = (function(extension) {
  return this.withExtension__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_ShapeExtension(extension)
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.extension__Lamf_client_model_domain_DataNode = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_domain_DataNode(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Extension$1));
  var m = $m_Lamf_client_convert_CoreClientConverters$().DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$();
  return m.asClient__Lamf_core_model_domain_DataNode__Lamf_client_model_domain_DataNode(from)
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.withDefinedBy__Lamf_client_model_domain_PropertyShape__Lamf_client_model_domain_ShapeExtension = (function(definedBy) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_CoreClientConverters$();
  $m_Lamf_client_convert_CoreClientConverters$().PropertyShapeMatcher__Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$();
  var customProperty = definedBy.$$undinternal$1;
  var field = $m_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$().DefinedBy$1;
  $as_Lamf_core_model_domain_extensions_ShapeExtension($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, customProperty));
  return this
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ShapeExtension.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ShapeExtension.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ShapeExtension.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ShapeExtension.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ShapeExtension.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.withExtension = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DataNode(arg);
  return this.$$js$exported$meth$withExtension__Lamf_client_model_domain_DataNode__O(prep)
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.withDefinedBy = (function(arg) {
  var prep = $as_Lamf_client_model_domain_PropertyShape(arg);
  return this.$$js$exported$meth$withDefinedBy__Lamf_client_model_domain_PropertyShape__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ShapeExtension.prototype, "extension", {
  "get": (function() {
    return this.$$js$exported$prop$extension__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ShapeExtension.prototype, "definedBy", {
  "get": (function() {
    return this.$$js$exported$prop$definedBy__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_ShapeExtension(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_ShapeExtension) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.ShapeExtension"))
}
function $isArrayOf_Lamf_client_model_domain_ShapeExtension(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_ShapeExtension)))
}
function $asArrayOf_Lamf_client_model_domain_ShapeExtension(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_ShapeExtension(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.ShapeExtension;", depth))
}
var $d_Lamf_client_model_domain_ShapeExtension = new $TypeData().initClass({
  Lamf_client_model_domain_ShapeExtension: 0
}, false, "amf.client.model.domain.ShapeExtension", {
  Lamf_client_model_domain_ShapeExtension: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_ShapeExtension.prototype.$classData = $d_Lamf_client_model_domain_ShapeExtension;
/** @constructor */
function $c_Lamf_client_model_domain_VariableValue() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_VariableValue.prototype = new $h_O();
$c_Lamf_client_model_domain_VariableValue.prototype.constructor = $c_Lamf_client_model_domain_VariableValue;
/** @constructor */
function $h_Lamf_client_model_domain_VariableValue() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_VariableValue.prototype = $c_Lamf_client_model_domain_VariableValue.prototype;
$c_Lamf_client_model_domain_VariableValue.prototype.productPrefix__T = (function() {
  return "VariableValue"
});
$c_Lamf_client_model_domain_VariableValue.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_VariableValueModel$().Name$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_VariableValue.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_VariableValue.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_VariableValue.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_VariableValue.prototype.withName__T__Lamf_client_model_domain_VariableValue = (function(name) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_core_metamodel_domain_templates_VariableValueModel$().Name$1;
  $as_Lamf_core_model_domain_templates_VariableValue($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name));
  return this
});
$c_Lamf_client_model_domain_VariableValue.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_VariableValue.prototype.withValue__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_VariableValue = (function(value) {
  var this$1 = this.$$undinternal$1;
  var value$1 = value.$$undinternal__Lamf_core_model_domain_DataNode();
  var field = $m_Lamf_core_metamodel_domain_templates_VariableValueModel$().Value$1;
  $as_Lamf_core_model_domain_templates_VariableValue($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$1, field, value$1));
  return this
});
$c_Lamf_client_model_domain_VariableValue.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_VariableValue.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_VariableValue.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_VariableValue)) {
    var VariableValue$1 = $as_Lamf_client_model_domain_VariableValue(x$1);
    var x = this.$$undinternal$1;
    var x$2 = VariableValue$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_VariableValue.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_VariableValue.prototype.$$js$exported$meth$withValue__Lamf_client_model_domain_DataNode__O = (function(value) {
  return this.withValue__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_VariableValue(value)
});
$c_Lamf_client_model_domain_VariableValue.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_VariableValue.prototype.init___Lamf_core_model_domain_templates_VariableValue = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_VariableValue.prototype.value__Lamf_client_model_domain_DataNode = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_domain_DataNode(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_templates_VariableValueModel$().Value$1));
  var m = $m_Lamf_client_convert_CoreClientConverters$().DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$();
  return m.asClient__Lamf_core_model_domain_DataNode__Lamf_client_model_domain_DataNode(from)
});
$c_Lamf_client_model_domain_VariableValue.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_VariableValue.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_VariableValue.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_VariableValue.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_VariableValue.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_VariableValue.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_VariableValue.prototype.$$js$exported$prop$value__O = (function() {
  return this.value__Lamf_client_model_domain_DataNode()
});
$c_Lamf_client_model_domain_VariableValue.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_VariableValue.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_VariableValue.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_VariableValue.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_VariableValue.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_VariableValue.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_VariableValue(name)
});
$c_Lamf_client_model_domain_VariableValue.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_VariableValue.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_VariableValue.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_VariableValue.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_VariableValue.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_VariableValue.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_VariableValue.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_VariableValue.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_VariableValue.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_VariableValue.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_VariableValue.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_VariableValue.prototype.withValue = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DataNode(arg);
  return this.$$js$exported$meth$withValue__Lamf_client_model_domain_DataNode__O(prep)
});
$c_Lamf_client_model_domain_VariableValue.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_VariableValue.prototype, "value", {
  "get": (function() {
    return this.$$js$exported$prop$value__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_VariableValue.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_VariableValue(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_VariableValue) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.VariableValue"))
}
function $isArrayOf_Lamf_client_model_domain_VariableValue(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_VariableValue)))
}
function $asArrayOf_Lamf_client_model_domain_VariableValue(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_VariableValue(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.VariableValue;", depth))
}
var $d_Lamf_client_model_domain_VariableValue = new $TypeData().initClass({
  Lamf_client_model_domain_VariableValue: 0
}, false, "amf.client.model.domain.VariableValue", {
  Lamf_client_model_domain_VariableValue: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_VariableValue.prototype.$classData = $d_Lamf_client_model_domain_VariableValue;
/** @constructor */
function $c_Lamf_client_model_domain_VocabularyReference() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_VocabularyReference.prototype = new $h_O();
$c_Lamf_client_model_domain_VocabularyReference.prototype.constructor = $c_Lamf_client_model_domain_VocabularyReference;
/** @constructor */
function $h_Lamf_client_model_domain_VocabularyReference() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_VocabularyReference.prototype = $c_Lamf_client_model_domain_VocabularyReference.prototype;
$c_Lamf_client_model_domain_VocabularyReference.prototype.withReference__T__Lamf_client_model_domain_VocabularyReference = (function(reference) {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$().Reference$1;
  var from = $as_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, reference));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().VocabularyReferenceConverter__Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$();
  return m.asClient__Lamf_plugins_document_vocabularies_model_domain_VocabularyReference__Lamf_client_model_domain_VocabularyReference(from)
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_VocabularyReference.prototype.init___Lamf_plugins_document_vocabularies_model_domain_VocabularyReference.call(this, new $c_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.productPrefix__T = (function() {
  return "VocabularyReference"
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_VocabularyReference)) {
    var VocabularyReference$1 = $as_Lamf_client_model_domain_VocabularyReference(x$1);
    var x = this.$$undinternal$1;
    var x$2 = VocabularyReference$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.reference__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$().Reference$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.$$js$exported$prop$reference__O = (function() {
  return this.reference__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.$$js$exported$meth$withAlias__T__O = (function(alias) {
  return this.withAlias__T__Lamf_client_model_domain_VocabularyReference(alias)
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.alias__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$().Alias$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.init___Lamf_plugins_document_vocabularies_model_domain_VocabularyReference = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.$$js$exported$prop$alias__O = (function() {
  return this.alias__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.withAlias__T__Lamf_client_model_domain_VocabularyReference = (function(alias) {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_VocabularyReferenceModel$().Alias$1;
  var from = $as_Lamf_plugins_document_vocabularies_model_domain_VocabularyReference($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, alias));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().VocabularyReferenceConverter__Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$();
  return m.asClient__Lamf_plugins_document_vocabularies_model_domain_VocabularyReference__Lamf_client_model_domain_VocabularyReference(from)
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.$$js$exported$meth$withReference__T__O = (function(reference) {
  return this.withReference__T__Lamf_client_model_domain_VocabularyReference(reference)
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_VocabularyReference.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_VocabularyReference.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_VocabularyReference.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_VocabularyReference.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_VocabularyReference.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.withReference = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withReference__T__O(prep)
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.withAlias = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withAlias__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_VocabularyReference.prototype, "reference", {
  "get": (function() {
    return this.$$js$exported$prop$reference__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_VocabularyReference.prototype, "alias", {
  "get": (function() {
    return this.$$js$exported$prop$alias__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_VocabularyReference(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_VocabularyReference) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.VocabularyReference"))
}
function $isArrayOf_Lamf_client_model_domain_VocabularyReference(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_VocabularyReference)))
}
function $asArrayOf_Lamf_client_model_domain_VocabularyReference(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_VocabularyReference(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.VocabularyReference;", depth))
}
var $d_Lamf_client_model_domain_VocabularyReference = new $TypeData().initClass({
  Lamf_client_model_domain_VocabularyReference: 0
}, false, "amf.client.model.domain.VocabularyReference", {
  Lamf_client_model_domain_VocabularyReference: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_VocabularyReference.prototype.$classData = $d_Lamf_client_model_domain_VocabularyReference;
/** @constructor */
function $c_Lamf_client_model_domain_XMLSerializer() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_XMLSerializer.prototype = new $h_O();
$c_Lamf_client_model_domain_XMLSerializer.prototype.constructor = $c_Lamf_client_model_domain_XMLSerializer;
/** @constructor */
function $h_Lamf_client_model_domain_XMLSerializer() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_XMLSerializer.prototype = $c_Lamf_client_model_domain_XMLSerializer.prototype;
$c_Lamf_client_model_domain_XMLSerializer.prototype.namespace__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Namespace$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.withNamespace__T__Lamf_client_model_domain_XMLSerializer = (function(namespace) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Namespace$1;
  $as_Lamf_plugins_domain_shapes_models_XMLSerializer($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, namespace));
  return this
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.productPrefix__T = (function() {
  return "XMLSerializer"
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_XMLSerializer.prototype.init___Lamf_plugins_domain_shapes_models_XMLSerializer.call(this, new $c_Lamf_plugins_domain_shapes_models_XMLSerializer().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.wrapped__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Wrapped$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$js$exported$meth$withPrefix__T__O = (function(prefix) {
  return this.withPrefix__T__Lamf_client_model_domain_XMLSerializer(prefix)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.withWrapped__Z__Lamf_client_model_domain_XMLSerializer = (function(wrapped) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Wrapped$1;
  $as_Lamf_plugins_domain_shapes_models_XMLSerializer($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, wrapped));
  return this
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$js$exported$meth$withNamespace__T__O = (function(namespace) {
  return this.withNamespace__T__Lamf_client_model_domain_XMLSerializer(namespace)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$js$exported$prop$namespace__O = (function() {
  return this.namespace__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_XMLSerializer)) {
    var XMLSerializer$1 = $as_Lamf_client_model_domain_XMLSerializer(x$1);
    var x = this.$$undinternal$1;
    var x$2 = XMLSerializer$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$js$exported$prop$prefix__O = (function() {
  return this.prefix__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$js$exported$prop$wrapped__O = (function() {
  return this.wrapped__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.withAttribute__Z__Lamf_client_model_domain_XMLSerializer = (function(attribute) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Attribute$1;
  $as_Lamf_plugins_domain_shapes_models_XMLSerializer($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, attribute));
  return this
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.init___Lamf_plugins_domain_shapes_models_XMLSerializer = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.attribute__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Attribute$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.withPrefix__T__Lamf_client_model_domain_XMLSerializer = (function(prefix) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Prefix$1;
  $as_Lamf_plugins_domain_shapes_models_XMLSerializer($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, prefix));
  return this
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.withName__T__Lamf_client_model_domain_XMLSerializer = (function(name) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Name$1;
  $as_Lamf_plugins_domain_shapes_models_XMLSerializer($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name));
  return this
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.prefix__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$().Prefix$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$js$exported$prop$attribute__O = (function() {
  return this.attribute__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$js$exported$meth$withWrapped__Z__O = (function(wrapped) {
  return this.withWrapped__Z__Lamf_client_model_domain_XMLSerializer(wrapped)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$js$exported$meth$withAttribute__Z__O = (function(attribute) {
  return this.withAttribute__Z__Lamf_client_model_domain_XMLSerializer(attribute)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_XMLSerializer(name)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_XMLSerializer.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_XMLSerializer.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_XMLSerializer.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_XMLSerializer.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_XMLSerializer.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.withPrefix = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withPrefix__T__O(prep)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.withNamespace = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withNamespace__T__O(prep)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.withWrapped = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withWrapped__Z__O(prep)
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.withAttribute = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withAttribute__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_XMLSerializer.prototype, "prefix", {
  "get": (function() {
    return this.$$js$exported$prop$prefix__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_XMLSerializer.prototype, "namespace", {
  "get": (function() {
    return this.$$js$exported$prop$namespace__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_XMLSerializer.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_XMLSerializer.prototype, "wrapped", {
  "get": (function() {
    return this.$$js$exported$prop$wrapped__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_XMLSerializer.prototype, "attribute", {
  "get": (function() {
    return this.$$js$exported$prop$attribute__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_XMLSerializer(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_XMLSerializer) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.XMLSerializer"))
}
function $isArrayOf_Lamf_client_model_domain_XMLSerializer(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_XMLSerializer)))
}
function $asArrayOf_Lamf_client_model_domain_XMLSerializer(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_XMLSerializer(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.XMLSerializer;", depth))
}
var $d_Lamf_client_model_domain_XMLSerializer = new $TypeData().initClass({
  Lamf_client_model_domain_XMLSerializer: 0
}, false, "amf.client.model.domain.XMLSerializer", {
  Lamf_client_model_domain_XMLSerializer: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_XMLSerializer.prototype.$classData = $d_Lamf_client_model_domain_XMLSerializer;
/** @constructor */
function $c_Lamf_core_annotations_BasePathLexicalInformation() {
  $c_Lamf_core_annotations_LexicalInformation.call(this);
  this.name$2 = null
}
$c_Lamf_core_annotations_BasePathLexicalInformation.prototype = new $h_Lamf_core_annotations_LexicalInformation();
$c_Lamf_core_annotations_BasePathLexicalInformation.prototype.constructor = $c_Lamf_core_annotations_BasePathLexicalInformation;
/** @constructor */
function $h_Lamf_core_annotations_BasePathLexicalInformation() {
  /*<skip>*/
}
$h_Lamf_core_annotations_BasePathLexicalInformation.prototype = $c_Lamf_core_annotations_BasePathLexicalInformation.prototype;
$c_Lamf_core_annotations_BasePathLexicalInformation.prototype.name__T = (function() {
  return this.name$2
});
$c_Lamf_core_annotations_BasePathLexicalInformation.prototype.init___Lamf_core_parser_Range = (function(range) {
  $c_Lamf_core_annotations_LexicalInformation.prototype.init___Lamf_core_parser_Range.call(this, range);
  this.name$2 = "base-path-lexical";
  return this
});
$c_Lamf_core_annotations_BasePathLexicalInformation.prototype.range__Lamf_core_parser_Range = (function() {
  return this.range$1
});
var $d_Lamf_core_annotations_BasePathLexicalInformation = new $TypeData().initClass({
  Lamf_core_annotations_BasePathLexicalInformation: 0
}, false, "amf.core.annotations.BasePathLexicalInformation", {
  Lamf_core_annotations_BasePathLexicalInformation: 1,
  Lamf_core_annotations_LexicalInformation: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_BasePathLexicalInformation.prototype.$classData = $d_Lamf_core_annotations_BasePathLexicalInformation;
/** @constructor */
function $c_Lamf_core_annotations_HostLexicalInformation() {
  $c_Lamf_core_annotations_LexicalInformation.call(this);
  this.name$2 = null
}
$c_Lamf_core_annotations_HostLexicalInformation.prototype = new $h_Lamf_core_annotations_LexicalInformation();
$c_Lamf_core_annotations_HostLexicalInformation.prototype.constructor = $c_Lamf_core_annotations_HostLexicalInformation;
/** @constructor */
function $h_Lamf_core_annotations_HostLexicalInformation() {
  /*<skip>*/
}
$h_Lamf_core_annotations_HostLexicalInformation.prototype = $c_Lamf_core_annotations_HostLexicalInformation.prototype;
$c_Lamf_core_annotations_HostLexicalInformation.prototype.name__T = (function() {
  return this.name$2
});
$c_Lamf_core_annotations_HostLexicalInformation.prototype.init___Lamf_core_parser_Range = (function(range) {
  $c_Lamf_core_annotations_LexicalInformation.prototype.init___Lamf_core_parser_Range.call(this, range);
  this.name$2 = "host-lexical";
  return this
});
$c_Lamf_core_annotations_HostLexicalInformation.prototype.range__Lamf_core_parser_Range = (function() {
  return this.range$1
});
var $d_Lamf_core_annotations_HostLexicalInformation = new $TypeData().initClass({
  Lamf_core_annotations_HostLexicalInformation: 0
}, false, "amf.core.annotations.HostLexicalInformation", {
  Lamf_core_annotations_HostLexicalInformation: 1,
  Lamf_core_annotations_LexicalInformation: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_HostLexicalInformation.prototype.$classData = $d_Lamf_core_annotations_HostLexicalInformation;
/** @constructor */
function $c_Lamf_core_annotations_InheritanceProvenance() {
  $c_O.call(this);
  this.baseId$1 = null;
  this.name$1 = null;
  this.value$1 = null;
  this.uris$1 = null
}
$c_Lamf_core_annotations_InheritanceProvenance.prototype = new $h_O();
$c_Lamf_core_annotations_InheritanceProvenance.prototype.constructor = $c_Lamf_core_annotations_InheritanceProvenance;
/** @constructor */
function $h_Lamf_core_annotations_InheritanceProvenance() {
  /*<skip>*/
}
$h_Lamf_core_annotations_InheritanceProvenance.prototype = $c_Lamf_core_annotations_InheritanceProvenance.prototype;
$c_Lamf_core_annotations_InheritanceProvenance.prototype.productPrefix__T = (function() {
  return "InheritanceProvenance"
});
$c_Lamf_core_annotations_InheritanceProvenance.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_annotations_InheritanceProvenance.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_annotations_InheritanceProvenance)) {
    var InheritanceProvenance$1 = $as_Lamf_core_annotations_InheritanceProvenance(x$1);
    return (this.baseId$1 === InheritanceProvenance$1.baseId$1)
  } else {
    return false
  }
});
$c_Lamf_core_annotations_InheritanceProvenance.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.baseId$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_annotations_InheritanceProvenance.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_InheritanceProvenance.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_annotations_InheritanceProvenance.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_annotations_InheritanceProvenance.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_InheritanceProvenance.prototype.init___T = (function(baseId) {
  this.baseId$1 = baseId;
  this.name$1 = "inheritance-provenance";
  this.value$1 = baseId;
  var jsx$1 = $m_sc_Seq$();
  var array = [baseId];
  this.uris$1 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
$c_Lamf_core_annotations_InheritanceProvenance.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_annotations_InheritanceProvenance.prototype.shorten__F1__Lamf_core_model_domain_Annotation = (function(fn) {
  return new $c_Lamf_core_annotations_InheritanceProvenance().init___T($as_T(fn.apply__O__O(this.baseId$1)))
});
function $as_Lamf_core_annotations_InheritanceProvenance(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_InheritanceProvenance) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.InheritanceProvenance"))
}
function $isArrayOf_Lamf_core_annotations_InheritanceProvenance(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_InheritanceProvenance)))
}
function $asArrayOf_Lamf_core_annotations_InheritanceProvenance(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_InheritanceProvenance(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.InheritanceProvenance;", depth))
}
var $d_Lamf_core_annotations_InheritanceProvenance = new $TypeData().initClass({
  Lamf_core_annotations_InheritanceProvenance: 0
}, false, "amf.core.annotations.InheritanceProvenance", {
  Lamf_core_annotations_InheritanceProvenance: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  Lamf_core_model_domain_UriAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_InheritanceProvenance.prototype.$classData = $d_Lamf_core_annotations_InheritanceProvenance;
/** @constructor */
function $c_Lamf_core_annotations_InheritedShapes() {
  $c_O.call(this);
  this.baseIds$1 = null;
  this.name$1 = null;
  this.value$1 = null;
  this.uris$1 = null
}
$c_Lamf_core_annotations_InheritedShapes.prototype = new $h_O();
$c_Lamf_core_annotations_InheritedShapes.prototype.constructor = $c_Lamf_core_annotations_InheritedShapes;
/** @constructor */
function $h_Lamf_core_annotations_InheritedShapes() {
  /*<skip>*/
}
$h_Lamf_core_annotations_InheritedShapes.prototype = $c_Lamf_core_annotations_InheritedShapes.prototype;
$c_Lamf_core_annotations_InheritedShapes.prototype.productPrefix__T = (function() {
  return "InheritedShapes"
});
$c_Lamf_core_annotations_InheritedShapes.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_annotations_InheritedShapes.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_annotations_InheritedShapes)) {
    var InheritedShapes$1 = $as_Lamf_core_annotations_InheritedShapes(x$1);
    var x = this.baseIds$1;
    var x$2 = InheritedShapes$1.baseIds$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_core_annotations_InheritedShapes.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.baseIds$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_annotations_InheritedShapes.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_InheritedShapes.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_annotations_InheritedShapes.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_annotations_InheritedShapes.prototype.init___sc_Seq = (function(baseIds) {
  this.baseIds$1 = baseIds;
  this.name$1 = "inherited-shapes";
  this.value$1 = baseIds.mkString__T__T(",");
  this.uris$1 = baseIds;
  return this
});
$c_Lamf_core_annotations_InheritedShapes.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_InheritedShapes.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_annotations_InheritedShapes.prototype.shorten__F1__Lamf_core_model_domain_Annotation = (function(fn) {
  var jsx$1 = this.baseIds$1;
  var this$1 = $m_sc_Seq$();
  return new $c_Lamf_core_annotations_InheritedShapes().init___sc_Seq($as_sc_Seq(jsx$1.map__F1__scg_CanBuildFrom__O(fn, this$1.ReusableCBFInstance$2)))
});
function $as_Lamf_core_annotations_InheritedShapes(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_InheritedShapes) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.InheritedShapes"))
}
function $isArrayOf_Lamf_core_annotations_InheritedShapes(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_InheritedShapes)))
}
function $asArrayOf_Lamf_core_annotations_InheritedShapes(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_InheritedShapes(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.InheritedShapes;", depth))
}
var $d_Lamf_core_annotations_InheritedShapes = new $TypeData().initClass({
  Lamf_core_annotations_InheritedShapes: 0
}, false, "amf.core.annotations.InheritedShapes", {
  Lamf_core_annotations_InheritedShapes: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  Lamf_core_model_domain_UriAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_InheritedShapes.prototype.$classData = $d_Lamf_core_annotations_InheritedShapes;
/** @constructor */
function $c_Lamf_core_annotations_ResolvedLinkAnnotation() {
  $c_O.call(this);
  this.linkId$1 = null;
  this.name$1 = null;
  this.value$1 = null;
  this.uris$1 = null
}
$c_Lamf_core_annotations_ResolvedLinkAnnotation.prototype = new $h_O();
$c_Lamf_core_annotations_ResolvedLinkAnnotation.prototype.constructor = $c_Lamf_core_annotations_ResolvedLinkAnnotation;
/** @constructor */
function $h_Lamf_core_annotations_ResolvedLinkAnnotation() {
  /*<skip>*/
}
$h_Lamf_core_annotations_ResolvedLinkAnnotation.prototype = $c_Lamf_core_annotations_ResolvedLinkAnnotation.prototype;
$c_Lamf_core_annotations_ResolvedLinkAnnotation.prototype.productPrefix__T = (function() {
  return "ResolvedLinkAnnotation"
});
$c_Lamf_core_annotations_ResolvedLinkAnnotation.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_annotations_ResolvedLinkAnnotation.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_annotations_ResolvedLinkAnnotation)) {
    var ResolvedLinkAnnotation$1 = $as_Lamf_core_annotations_ResolvedLinkAnnotation(x$1);
    return (this.linkId$1 === ResolvedLinkAnnotation$1.linkId$1)
  } else {
    return false
  }
});
$c_Lamf_core_annotations_ResolvedLinkAnnotation.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.linkId$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_annotations_ResolvedLinkAnnotation.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_ResolvedLinkAnnotation.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_annotations_ResolvedLinkAnnotation.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_annotations_ResolvedLinkAnnotation.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_ResolvedLinkAnnotation.prototype.init___T = (function(linkId) {
  this.linkId$1 = linkId;
  this.name$1 = "resolved-link";
  this.value$1 = linkId;
  var jsx$1 = $m_sc_Seq$();
  var array = [linkId];
  this.uris$1 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
$c_Lamf_core_annotations_ResolvedLinkAnnotation.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_annotations_ResolvedLinkAnnotation.prototype.shorten__F1__Lamf_core_model_domain_Annotation = (function(fn) {
  return new $c_Lamf_core_annotations_ResolvedLinkAnnotation().init___T($as_T(fn.apply__O__O(this.linkId$1)))
});
function $as_Lamf_core_annotations_ResolvedLinkAnnotation(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_ResolvedLinkAnnotation) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.ResolvedLinkAnnotation"))
}
function $isArrayOf_Lamf_core_annotations_ResolvedLinkAnnotation(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_ResolvedLinkAnnotation)))
}
function $asArrayOf_Lamf_core_annotations_ResolvedLinkAnnotation(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_ResolvedLinkAnnotation(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.ResolvedLinkAnnotation;", depth))
}
var $d_Lamf_core_annotations_ResolvedLinkAnnotation = new $TypeData().initClass({
  Lamf_core_annotations_ResolvedLinkAnnotation: 0
}, false, "amf.core.annotations.ResolvedLinkAnnotation", {
  Lamf_core_annotations_ResolvedLinkAnnotation: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  Lamf_core_model_domain_UriAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_ResolvedLinkAnnotation.prototype.$classData = $d_Lamf_core_annotations_ResolvedLinkAnnotation;
/** @constructor */
function $c_Lamf_core_annotations_ResolvedLinkTargetAnnotation() {
  $c_O.call(this);
  this.linkTargetId$1 = null;
  this.name$1 = null;
  this.value$1 = null;
  this.uris$1 = null
}
$c_Lamf_core_annotations_ResolvedLinkTargetAnnotation.prototype = new $h_O();
$c_Lamf_core_annotations_ResolvedLinkTargetAnnotation.prototype.constructor = $c_Lamf_core_annotations_ResolvedLinkTargetAnnotation;
/** @constructor */
function $h_Lamf_core_annotations_ResolvedLinkTargetAnnotation() {
  /*<skip>*/
}
$h_Lamf_core_annotations_ResolvedLinkTargetAnnotation.prototype = $c_Lamf_core_annotations_ResolvedLinkTargetAnnotation.prototype;
$c_Lamf_core_annotations_ResolvedLinkTargetAnnotation.prototype.productPrefix__T = (function() {
  return "ResolvedLinkTargetAnnotation"
});
$c_Lamf_core_annotations_ResolvedLinkTargetAnnotation.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_annotations_ResolvedLinkTargetAnnotation.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_annotations_ResolvedLinkTargetAnnotation)) {
    var ResolvedLinkTargetAnnotation$1 = $as_Lamf_core_annotations_ResolvedLinkTargetAnnotation(x$1);
    return (this.linkTargetId$1 === ResolvedLinkTargetAnnotation$1.linkTargetId$1)
  } else {
    return false
  }
});
$c_Lamf_core_annotations_ResolvedLinkTargetAnnotation.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.linkTargetId$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_annotations_ResolvedLinkTargetAnnotation.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_ResolvedLinkTargetAnnotation.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_annotations_ResolvedLinkTargetAnnotation.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_annotations_ResolvedLinkTargetAnnotation.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_ResolvedLinkTargetAnnotation.prototype.init___T = (function(linkTargetId) {
  this.linkTargetId$1 = linkTargetId;
  this.name$1 = "resolved-link-target";
  this.value$1 = linkTargetId;
  var jsx$1 = $m_sc_Seq$();
  var array = [linkTargetId];
  this.uris$1 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
$c_Lamf_core_annotations_ResolvedLinkTargetAnnotation.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_annotations_ResolvedLinkTargetAnnotation.prototype.shorten__F1__Lamf_core_model_domain_Annotation = (function(fn) {
  return new $c_Lamf_core_annotations_ResolvedLinkTargetAnnotation().init___T($as_T(fn.apply__O__O(this.linkTargetId$1)))
});
function $as_Lamf_core_annotations_ResolvedLinkTargetAnnotation(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_ResolvedLinkTargetAnnotation) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.ResolvedLinkTargetAnnotation"))
}
function $isArrayOf_Lamf_core_annotations_ResolvedLinkTargetAnnotation(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_ResolvedLinkTargetAnnotation)))
}
function $asArrayOf_Lamf_core_annotations_ResolvedLinkTargetAnnotation(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_ResolvedLinkTargetAnnotation(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.ResolvedLinkTargetAnnotation;", depth))
}
var $d_Lamf_core_annotations_ResolvedLinkTargetAnnotation = new $TypeData().initClass({
  Lamf_core_annotations_ResolvedLinkTargetAnnotation: 0
}, false, "amf.core.annotations.ResolvedLinkTargetAnnotation", {
  Lamf_core_annotations_ResolvedLinkTargetAnnotation: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  Lamf_core_model_domain_UriAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_ResolvedLinkTargetAnnotation.prototype.$classData = $d_Lamf_core_annotations_ResolvedLinkTargetAnnotation;
/** @constructor */
function $c_Lamf_core_metamodel_document_ExtensionLikeModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.fields$1 = null;
  this.Declares$1 = null;
  this.Encodes$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null
}
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.constructor = $c_Lamf_core_metamodel_document_ExtensionLikeModel$;
/** @constructor */
function $h_Lamf_core_metamodel_document_ExtensionLikeModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype = $c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype;
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_document_ExtensionLikeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_ModuleModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_DocumentModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_ExtensionLikeModel__$$init$__V(this);
  $m_sci_List$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "DocumentExtension")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_document_BaseUnitModel$().type$1;
  var this$7 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "Document Extension", "A Document that extends a target document, overwriting part of the information or overlaying additional information.", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.amf$core$metamodel$document$DocumentModel$$undsetter$und$fields$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.Extends__Lamf_core_metamodel_Field = (function() {
  return this.Extends$1
});
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.amf$core$metamodel$document$ExtensionLikeModel$$undsetter$und$Extends$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Extends$1 = x$1
});
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.Declares__Lamf_core_metamodel_Field = (function() {
  return this.Declares$1
});
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.amf$core$metamodel$document$ModuleModel$$undsetter$und$Declares$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Declares$1 = x$1
});
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_core_model_document_Module().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.Encodes__Lamf_core_metamodel_Field = (function() {
  return this.Encodes$1
});
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.amf$core$metamodel$document$ExtensionLikeModel$$undsetter$und$fields$und$eq__sci_List__V = (function(x$1) {
  this.fields$1 = x$1
});
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Encodes$1 = x$1
});
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.amf$core$metamodel$document$DocumentModel$$undsetter$und$type$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_core_metamodel_document_ExtensionLikeModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_document_ExtensionLikeModel$: 0
}, false, "amf.core.metamodel.document.ExtensionLikeModel$", {
  Lamf_core_metamodel_document_ExtensionLikeModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_ExtensionLikeModel: 1,
  Lamf_core_metamodel_document_DocumentModel: 1,
  Lamf_core_metamodel_document_FragmentModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_document_ModuleModel: 1
});
$c_Lamf_core_metamodel_document_ExtensionLikeModel$.prototype.$classData = $d_Lamf_core_metamodel_document_ExtensionLikeModel$;
var $n_Lamf_core_metamodel_document_ExtensionLikeModel$ = (void 0);
function $m_Lamf_core_metamodel_document_ExtensionLikeModel$() {
  if ((!$n_Lamf_core_metamodel_document_ExtensionLikeModel$)) {
    $n_Lamf_core_metamodel_document_ExtensionLikeModel$ = new $c_Lamf_core_metamodel_document_ExtensionLikeModel$().init___()
  };
  return $n_Lamf_core_metamodel_document_ExtensionLikeModel$
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_RecursiveShapeModel$() {
  $c_O.call(this);
  this.FixPoint$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Name$1 = null;
  this.DisplayName$1 = null;
  this.Default$1 = null;
  this.DefaultValueString$1 = null;
  this.Values$1 = null;
  this.Closure$1 = null;
  this.Inherits$1 = null;
  this.Or$1 = null;
  this.And$1 = null;
  this.Xone$1 = null;
  this.Not$1 = null;
  this.If$1 = null;
  this.Then$1 = null;
  this.Else$1 = null;
  this.ReadOnly$1 = null;
  this.WriteOnly$1 = null;
  this.Deprecated$1 = null;
  this.key$1 = null;
  this.CustomShapePropertyDefinitions$1 = null;
  this.CustomShapeProperties$1 = null;
  this.Description$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.constructor = $c_Lamf_core_metamodel_domain_RecursiveShapeModel$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_RecursiveShapeModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype = $c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype;
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_RecursiveShapeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ShapeModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.FixPoint$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "fixPoint"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "fixpoint", "Link to the base of the recursion for a recursive shape", $m_sci_Nil$()), true);
  $m_sci_List$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "RecursiveShape")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$9 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$9);
    i = (((-1) + i) | 0)
  };
  var jsx$3 = result;
  var jsx$2 = $m_Lamf_core_metamodel_domain_ShapeModel$().type$1;
  var this$10 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$10.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "Recursive Shape", "Recursion on a Shape structure, used when expanding a shape and finding the canonical representation of that shape.", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$ReadOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReadOnly$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Deprecated$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Deprecated$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DefaultValueString$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DefaultValueString$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.FixPoint$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$4 = result;
  var jsx$3 = $m_Lamf_core_metamodel_domain_ShapeModel$().fields$1;
  var this$5 = $m_sci_List$();
  var jsx$2 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$5.ReusableCBFInstance$2));
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$6 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2))
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DisplayName$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DisplayName$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$WriteOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.WriteOnly$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$key$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.key$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Else$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Else$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$And$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.And$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Inherits$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Inherits$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_core_model_domain_RecursiveShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Not$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Not$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$If$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.If$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Closure$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Closure$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Xone$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Xone$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Or$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Or$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Values$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Values$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Then$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Then$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Default$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Default$1 = x$1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.Name__Lamf_core_metamodel_Field = (function() {
  return this.Name$1
});
var $d_Lamf_core_metamodel_domain_RecursiveShapeModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_RecursiveShapeModel$: 0
}, false, "amf.core.metamodel.domain.RecursiveShapeModel$", {
  Lamf_core_metamodel_domain_RecursiveShapeModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_ShapeModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1
});
$c_Lamf_core_metamodel_domain_RecursiveShapeModel$.prototype.$classData = $d_Lamf_core_metamodel_domain_RecursiveShapeModel$;
var $n_Lamf_core_metamodel_domain_RecursiveShapeModel$ = (void 0);
function $m_Lamf_core_metamodel_domain_RecursiveShapeModel$() {
  if ((!$n_Lamf_core_metamodel_domain_RecursiveShapeModel$)) {
    $n_Lamf_core_metamodel_domain_RecursiveShapeModel$ = new $c_Lamf_core_metamodel_domain_RecursiveShapeModel$().init___()
  };
  return $n_Lamf_core_metamodel_domain_RecursiveShapeModel$
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_ShapeModel$() {
  $c_O.call(this);
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Name$1 = null;
  this.DisplayName$1 = null;
  this.Default$1 = null;
  this.DefaultValueString$1 = null;
  this.Values$1 = null;
  this.Closure$1 = null;
  this.Inherits$1 = null;
  this.Or$1 = null;
  this.And$1 = null;
  this.Xone$1 = null;
  this.Not$1 = null;
  this.If$1 = null;
  this.Then$1 = null;
  this.Else$1 = null;
  this.ReadOnly$1 = null;
  this.WriteOnly$1 = null;
  this.Deprecated$1 = null;
  this.key$1 = null;
  this.CustomShapePropertyDefinitions$1 = null;
  this.CustomShapeProperties$1 = null;
  this.Description$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.constructor = $c_Lamf_core_metamodel_domain_ShapeModel$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_ShapeModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_ShapeModel$.prototype = $c_Lamf_core_metamodel_domain_ShapeModel$.prototype;
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.CustomShapeProperties$lzycompute__p1__Lamf_core_metamodel_Field = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.CustomShapeProperties$1 = $f_Lamf_core_metamodel_domain_ShapeModel__CustomShapeProperties__Lamf_core_metamodel_Field(this);
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.CustomShapeProperties$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_ShapeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ShapeModel__$$init$__V(this);
  var jsx$2 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().fields$1;
  $m_sci_List$();
  var array = [this.Name$1, this.DisplayName$1, this.Description$1, this.Default$1, this.Values$1, this.Inherits$1, this.DefaultValueString$1, this.Not$1, this.And$1, this.Or$1, this.Xone$1, this.Closure$1, this.If$1, this.Then$1, this.Else$1, this.ReadOnly$1, this.WriteOnly$1, this.Deprecated$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$1 = result;
  var this$5 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2));
  $m_sci_List$();
  var this$6 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var jsx$4 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$6, "Shape");
  var this$8 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var array$1 = [jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$8, "Shape")];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$13 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$13);
    i$1 = (((-1) + i$1) | 0)
  };
  var jsx$5 = result$1;
  var jsx$3 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  var this$14 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$14.ReusableCBFInstance$2));
  var jsx$7 = $m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1;
  var jsx$6 = $m_sc_Seq$();
  var this$15 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var array$2 = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$15, "Shape").iri__T()];
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq(jsx$7, "Shape", "Base class for all shapes. Shapes are Domain Entities that define constraints over parts of a data graph.\nThey can be used to define and enforce schemas for the data graph information through SHACL.\nShapes can be recursive and inherit from other shapes.", $as_sc_Seq(jsx$6.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2))));
  return this
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$ReadOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReadOnly$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Deprecated$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Deprecated$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DefaultValueString$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DefaultValueString$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.CustomShapePropertyDefinitions__Lamf_core_metamodel_Field = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.CustomShapePropertyDefinitions$lzycompute__p1__Lamf_core_metamodel_Field() : this.CustomShapePropertyDefinitions$1)
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.CustomShapePropertyDefinitions$lzycompute__p1__Lamf_core_metamodel_Field = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.CustomShapePropertyDefinitions$1 = $f_Lamf_core_metamodel_domain_ShapeModel__CustomShapePropertyDefinitions__Lamf_core_metamodel_Field(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.CustomShapePropertyDefinitions$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$WriteOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.WriteOnly$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DisplayName$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DisplayName$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.modelInstance__sr_Nothing$ = (function() {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Shape is abstract and it cannot be instantiated by default"))
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$key$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.key$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Else$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Else$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Inherits$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Inherits$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$And$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.And$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.CustomShapeProperties__Lamf_core_metamodel_Field = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.CustomShapeProperties$lzycompute__p1__Lamf_core_metamodel_Field() : this.CustomShapeProperties$1)
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  this.modelInstance__sr_Nothing$()
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Not$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Not$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$If$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.If$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Closure$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Closure$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Xone$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Xone$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Values$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Values$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Or$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Or$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Then$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Then$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Default$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Default$1 = x$1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.Name__Lamf_core_metamodel_Field = (function() {
  return this.Name$1
});
var $d_Lamf_core_metamodel_domain_ShapeModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_ShapeModel$: 0
}, false, "amf.core.metamodel.domain.ShapeModel$", {
  Lamf_core_metamodel_domain_ShapeModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_ShapeModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1
});
$c_Lamf_core_metamodel_domain_ShapeModel$.prototype.$classData = $d_Lamf_core_metamodel_domain_ShapeModel$;
var $n_Lamf_core_metamodel_domain_ShapeModel$ = (void 0);
function $m_Lamf_core_metamodel_domain_ShapeModel$() {
  if ((!$n_Lamf_core_metamodel_domain_ShapeModel$)) {
    $n_Lamf_core_metamodel_domain_ShapeModel$ = new $c_Lamf_core_metamodel_domain_ShapeModel$().init___()
  };
  return $n_Lamf_core_metamodel_domain_ShapeModel$
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$() {
  $c_O.call(this);
  this.Path$1 = null;
  this.Range$1 = null;
  this.MinCount$1 = null;
  this.MaxCount$1 = null;
  this.PatternName$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Name$1 = null;
  this.DisplayName$1 = null;
  this.Default$1 = null;
  this.DefaultValueString$1 = null;
  this.Values$1 = null;
  this.Closure$1 = null;
  this.Inherits$1 = null;
  this.Or$1 = null;
  this.And$1 = null;
  this.Xone$1 = null;
  this.Not$1 = null;
  this.If$1 = null;
  this.Then$1 = null;
  this.Else$1 = null;
  this.ReadOnly$1 = null;
  this.WriteOnly$1 = null;
  this.Deprecated$1 = null;
  this.key$1 = null;
  this.CustomShapePropertyDefinitions$1 = null;
  this.CustomShapeProperties$1 = null;
  this.Description$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.constructor = $c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype = $c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype;
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ShapeModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.Path$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "path"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "path", "Path to the constrained property", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_domain_ShapeModel$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.Range$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "range"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "range", "Range property constraint", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_core_metamodel_Type$Int$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.MinCount$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "minCount"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "min. count", "Minimum count property constraint", $m_sci_Nil$()), true);
  var jsx$4 = $m_Lamf_core_metamodel_Type$Int$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.MaxCount$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "maxCount"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "max. count", "Maximum count property constraint", $m_sci_Nil$()), true);
  var jsx$5 = $m_Lamf_core_metamodel_Type$Str$();
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.PatternName$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "patternName"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "pattern name", "Patterned property constraint", $m_sci_Nil$()), true);
  $m_sci_List$();
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "PropertyShape")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$21 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$21);
    i = (((-1) + i) | 0)
  };
  var jsx$7 = result;
  var jsx$6 = $m_Lamf_core_metamodel_domain_ShapeModel$().type$1;
  var this$22 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$7.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$6, this$22.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "Property Shape", "Constraint over a property in a data shape.", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$ReadOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReadOnly$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Deprecated$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Deprecated$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DefaultValueString$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DefaultValueString$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Path$1, this.Range$1, this.MinCount$1, this.MaxCount$1, this.PatternName$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$4 = result;
  var jsx$3 = $m_Lamf_core_metamodel_domain_ShapeModel$().fields$1;
  var this$5 = $m_sci_List$();
  var jsx$2 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$5.ReusableCBFInstance$2));
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$6 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2))
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DisplayName$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DisplayName$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$WriteOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.WriteOnly$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$key$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.key$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Else$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Else$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$And$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.And$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Inherits$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Inherits$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_core_model_domain_extensions_PropertyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Not$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Not$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$If$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.If$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Closure$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Closure$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Xone$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Xone$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Or$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Or$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Values$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Values$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Then$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Then$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Default$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Default$1 = x$1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.Name__Lamf_core_metamodel_Field = (function() {
  return this.Name$1
});
var $d_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_extensions_PropertyShapeModel$: 0
}, false, "amf.core.metamodel.domain.extensions.PropertyShapeModel$", {
  Lamf_core_metamodel_domain_extensions_PropertyShapeModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_ShapeModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1
});
$c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$.prototype.$classData = $d_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$;
var $n_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$ = (void 0);
function $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$() {
  if ((!$n_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$)) {
    $n_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$ = new $c_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().init___()
  };
  return $n_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$
}
/** @constructor */
function $c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.doc$1 = null;
  this.DataNode$1 = null;
  this.Variables$1 = null;
  this.key$1 = null;
  this.Description$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype = new $h_O();
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype.constructor = $c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$;
/** @constructor */
function $h_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$() {
  /*<skip>*/
}
$h_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype = $c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype;
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype.init___ = (function() {
  $n_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel__$$init$__V(this);
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "AbstractDeclaration");
  var this$3 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$3);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().AmlDoc$1, "Abstract Declaration", "Graph template that can be used to declare a re-usable graph structure that can be applied to different domain elements\nin order to re-use common semantics. Similar to a Lisp macro or a C++ template.\nIt can be extended by any domain element adding bindings for the variables in the declaration.", $m_sci_Nil$());
  return this
});
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype.Description__Lamf_core_metamodel_Field = (function() {
  return this.Description$1
});
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype.Variables__Lamf_core_metamodel_Field = (function() {
  return this.Variables$1
});
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype.amf$core$metamodel$domain$templates$AbstractDeclarationModel$$undsetter$und$key$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.key$1 = x$1
});
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype.fields__sci_List = (function() {
  return $f_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel__fields__sci_List(this)
});
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype.amf$core$metamodel$domain$templates$AbstractDeclarationModel$$undsetter$und$DataNode$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DataNode$1 = x$1
});
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype.modelInstance__sr_Nothing$ = (function() {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("AbstractDeclarationModel is abstract and cannot be instantiated"))
});
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  this.modelInstance__sr_Nothing$()
});
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype.DataNode__Lamf_core_metamodel_Field = (function() {
  return this.DataNode$1
});
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype.amf$core$metamodel$domain$templates$AbstractDeclarationModel$$undsetter$und$Variables$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Variables$1 = x$1
});
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype.Name__Lamf_core_metamodel_Field = (function() {
  return this.Name$1
});
var $d_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$ = new $TypeData().initClass({
  Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$: 0
}, false, "amf.core.metamodel.domain.templates.AbstractDeclarationModel$", {
  Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_templates_AbstractDeclarationModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1
});
$c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$.prototype.$classData = $d_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$;
var $n_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$ = (void 0);
function $m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$() {
  if ((!$n_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$)) {
    $n_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$ = new $c_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().init___()
  };
  return $n_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$
}
/** @constructor */
function $c_Lamf_core_model_domain_extensions_DomainExtension() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype = new $h_O();
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.constructor = $c_Lamf_core_model_domain_extensions_DomainExtension;
/** @constructor */
function $h_Lamf_core_model_domain_extensions_DomainExtension() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_extensions_DomainExtension.prototype = $c_Lamf_core_model_domain_extensions_DomainExtension.prototype;
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.productPrefix__T = (function() {
  return "DomainExtension"
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return this.adopted__T__sc_Seq__Lamf_core_model_domain_extensions_DomainExtension(parent, cycle)
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_model_domain_extensions_DomainExtension)) {
    var DomainExtension$1 = $as_Lamf_core_model_domain_extensions_DomainExtension(x$1);
    var x = this.fields$1;
    var x$2 = DomainExtension$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = DomainExtension$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$()
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.componentId__T = (function() {
  return "/extension"
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.isScalarExtension__Z = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().Element$1));
  return (!$f_Lamf_core_model_StrField__isNullOrEmpty__Z(this$1))
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_extensions_DomainExtension = (function(parent, cycle) {
  if ($m_s_Option$().apply__O__s_Option(this.id$1).isEmpty__Z()) {
    var jsx$1 = true
  } else {
    var thiz = this.id$1;
    var jsx$1 = (($uI(thiz.length) >= 0) && ($as_T(thiz.substring(0, $uI("null/".length))) === "null/"))
  };
  if (jsx$1) {
    $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
  };
  return this
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.obtainSchema__Lamf_core_model_domain_Shape = (function() {
  var this$1 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_DomainExtensionModel$().DefinedBy$1));
  return $as_Lamf_core_model_domain_Shape(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Schema$1))
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_core_model_domain_extensions_DomainExtension(obj) {
  return (((obj instanceof $c_Lamf_core_model_domain_extensions_DomainExtension) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.extensions.DomainExtension"))
}
function $isArrayOf_Lamf_core_model_domain_extensions_DomainExtension(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_extensions_DomainExtension)))
}
function $asArrayOf_Lamf_core_model_domain_extensions_DomainExtension(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_extensions_DomainExtension(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.extensions.DomainExtension;", depth))
}
var $d_Lamf_core_model_domain_extensions_DomainExtension = new $TypeData().initClass({
  Lamf_core_model_domain_extensions_DomainExtension: 0
}, false, "amf.core.model.domain.extensions.DomainExtension", {
  Lamf_core_model_domain_extensions_DomainExtension: 1,
  O: 1,
  Lamf_core_model_domain_extensions_Extension: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_domain_extensions_DomainExtension.prototype.$classData = $d_Lamf_core_model_domain_extensions_DomainExtension;
/** @constructor */
function $c_Lamf_core_model_domain_extensions_ShapeExtension() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype = new $h_O();
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.constructor = $c_Lamf_core_model_domain_extensions_ShapeExtension;
/** @constructor */
function $h_Lamf_core_model_domain_extensions_ShapeExtension() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_extensions_ShapeExtension.prototype = $c_Lamf_core_model_domain_extensions_ShapeExtension.prototype;
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.productPrefix__T = (function() {
  return "ShapeExtension"
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_model_domain_extensions_ShapeExtension)) {
    var ShapeExtension$1 = $as_Lamf_core_model_domain_extensions_ShapeExtension(x$1);
    var x = this.fields$1;
    var x$2 = ShapeExtension$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = ShapeExtension$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$()
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.componentId__T = (function() {
  var this$1 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_extensions_PropertyShape(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$().DefinedBy$1)));
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_Lamf_core_model_domain_extensions_PropertyShape(arg1);
    var this$2 = $as_Lamf_core_model_StrField(x$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1
  };
  var str = $as_T((this$2.isEmpty__Z() ? "default-extension" : this$2.get__O()));
  var this$4 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$5 = this$4.platform$1;
  var url = this$4.str$1;
  return ("/shape-extension/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$5, url))
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.obtainSchema__Lamf_core_model_domain_Shape = (function() {
  var this$1 = $as_Lamf_core_model_domain_extensions_PropertyShape(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_ShapeExtensionModel$().DefinedBy$1));
  return $as_Lamf_core_model_domain_Shape(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1))
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  this.id$1 = "http://a.ml/vocabularies#document/shape_extension";
  return this
});
function $as_Lamf_core_model_domain_extensions_ShapeExtension(obj) {
  return (((obj instanceof $c_Lamf_core_model_domain_extensions_ShapeExtension) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.extensions.ShapeExtension"))
}
function $isArrayOf_Lamf_core_model_domain_extensions_ShapeExtension(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_extensions_ShapeExtension)))
}
function $asArrayOf_Lamf_core_model_domain_extensions_ShapeExtension(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_extensions_ShapeExtension(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.extensions.ShapeExtension;", depth))
}
var $d_Lamf_core_model_domain_extensions_ShapeExtension = new $TypeData().initClass({
  Lamf_core_model_domain_extensions_ShapeExtension: 0
}, false, "amf.core.model.domain.extensions.ShapeExtension", {
  Lamf_core_model_domain_extensions_ShapeExtension: 1,
  O: 1,
  Lamf_core_model_domain_extensions_Extension: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_domain_extensions_ShapeExtension.prototype.$classData = $d_Lamf_core_model_domain_extensions_ShapeExtension;
/** @constructor */
function $c_Lamf_core_resolution_stages_selectors_NodeShapeSelector$() {
  $c_Lamf_core_resolution_stages_selectors_MetaModelSelector.call(this)
}
$c_Lamf_core_resolution_stages_selectors_NodeShapeSelector$.prototype = new $h_Lamf_core_resolution_stages_selectors_MetaModelSelector();
$c_Lamf_core_resolution_stages_selectors_NodeShapeSelector$.prototype.constructor = $c_Lamf_core_resolution_stages_selectors_NodeShapeSelector$;
/** @constructor */
function $h_Lamf_core_resolution_stages_selectors_NodeShapeSelector$() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_selectors_NodeShapeSelector$.prototype = $c_Lamf_core_resolution_stages_selectors_NodeShapeSelector$.prototype;
$c_Lamf_core_resolution_stages_selectors_NodeShapeSelector$.prototype.init___ = (function() {
  $c_Lamf_core_resolution_stages_selectors_MetaModelSelector.prototype.init___Lamf_core_vocabulary_Namespace__T.call(this, $m_Lamf_core_vocabulary_Namespace$().Shacl$1, "NodeShape");
  return this
});
var $d_Lamf_core_resolution_stages_selectors_NodeShapeSelector$ = new $TypeData().initClass({
  Lamf_core_resolution_stages_selectors_NodeShapeSelector$: 0
}, false, "amf.core.resolution.stages.selectors.NodeShapeSelector$", {
  Lamf_core_resolution_stages_selectors_NodeShapeSelector$: 1,
  Lamf_core_resolution_stages_selectors_MetaModelSelector: 1,
  Lamf_core_resolution_stages_selectors_Selector: 1,
  O: 1,
  F1: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1
});
$c_Lamf_core_resolution_stages_selectors_NodeShapeSelector$.prototype.$classData = $d_Lamf_core_resolution_stages_selectors_NodeShapeSelector$;
var $n_Lamf_core_resolution_stages_selectors_NodeShapeSelector$ = (void 0);
function $m_Lamf_core_resolution_stages_selectors_NodeShapeSelector$() {
  if ((!$n_Lamf_core_resolution_stages_selectors_NodeShapeSelector$)) {
    $n_Lamf_core_resolution_stages_selectors_NodeShapeSelector$ = new $c_Lamf_core_resolution_stages_selectors_NodeShapeSelector$().init___()
  };
  return $n_Lamf_core_resolution_stages_selectors_NodeShapeSelector$
}
/** @constructor */
function $c_Lamf_core_resolution_stages_selectors_ShapeSelector$() {
  $c_Lamf_core_resolution_stages_selectors_MetaModelSelector.call(this)
}
$c_Lamf_core_resolution_stages_selectors_ShapeSelector$.prototype = new $h_Lamf_core_resolution_stages_selectors_MetaModelSelector();
$c_Lamf_core_resolution_stages_selectors_ShapeSelector$.prototype.constructor = $c_Lamf_core_resolution_stages_selectors_ShapeSelector$;
/** @constructor */
function $h_Lamf_core_resolution_stages_selectors_ShapeSelector$() {
  /*<skip>*/
}
$h_Lamf_core_resolution_stages_selectors_ShapeSelector$.prototype = $c_Lamf_core_resolution_stages_selectors_ShapeSelector$.prototype;
$c_Lamf_core_resolution_stages_selectors_ShapeSelector$.prototype.init___ = (function() {
  $c_Lamf_core_resolution_stages_selectors_MetaModelSelector.prototype.init___Lamf_core_vocabulary_Namespace__T.call(this, $m_Lamf_core_vocabulary_Namespace$().Shapes$1, "Shape");
  return this
});
var $d_Lamf_core_resolution_stages_selectors_ShapeSelector$ = new $TypeData().initClass({
  Lamf_core_resolution_stages_selectors_ShapeSelector$: 0
}, false, "amf.core.resolution.stages.selectors.ShapeSelector$", {
  Lamf_core_resolution_stages_selectors_ShapeSelector$: 1,
  Lamf_core_resolution_stages_selectors_MetaModelSelector: 1,
  Lamf_core_resolution_stages_selectors_Selector: 1,
  O: 1,
  F1: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1
});
$c_Lamf_core_resolution_stages_selectors_ShapeSelector$.prototype.$classData = $d_Lamf_core_resolution_stages_selectors_ShapeSelector$;
var $n_Lamf_core_resolution_stages_selectors_ShapeSelector$ = (void 0);
function $m_Lamf_core_resolution_stages_selectors_ShapeSelector$() {
  if ((!$n_Lamf_core_resolution_stages_selectors_ShapeSelector$)) {
    $n_Lamf_core_resolution_stages_selectors_ShapeSelector$ = new $c_Lamf_core_resolution_stages_selectors_ShapeSelector$().init___()
  };
  return $n_Lamf_core_resolution_stages_selectors_ShapeSelector$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter() {
  $c_O.call(this);
  this.dialect$1 = null;
  this.ordering$1 = null;
  this.aliases$1 = null;
  this.documents$1 = null;
  this.emitters$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter.prototype.productPrefix__T = (function() {
  return "DocumentsModelEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter)) {
    var DocumentsModelEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter(x$1);
    var x = this.dialect$1;
    var x$2 = DocumentsModelEmitter$1.dialect$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = DocumentsModelEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.aliases$1;
      var x$6 = DocumentsModelEmitter$1.aliases$1;
      return ((x$5 === null) ? (x$6 === null) : $f_sc_GenMapLike__equals__O__Z(x$5, x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.dialect$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.aliases$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter.prototype.aliases__sci_Map = (function() {
  return this.aliases$1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("documents");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$15 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var jsx$1 = $m_s_Option$();
  var this$3 = this.documents$1;
  if (jsx$1.apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(this$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Root$1))).isDefined__Z()) {
    var jsx$4 = this.emitters$1;
    var jsx$3 = $m_sc_Seq$();
    var array = [new $c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter().init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sci_Map(this.dialect$1, this.ordering$1, this.aliases$1)];
    var jsx$2 = jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$6 = $m_sc_Seq$();
    this.emitters$1 = $as_sc_Seq(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$6.ReusableCBFInstance$2))
  };
  var this$7 = this.documents$1;
  if ($as_sc_Seq(this$7.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Fragments$1)).nonEmpty__Z()) {
    var jsx$7 = this.emitters$1;
    var jsx$6 = $m_sc_Seq$();
    var array$1 = [new $c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter().init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sci_Map(this.dialect$1, this.ordering$1, this.aliases$1)];
    var jsx$5 = jsx$6.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
    var this$10 = $m_sc_Seq$();
    this.emitters$1 = $as_sc_Seq(jsx$7.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$5, this$10.ReusableCBFInstance$2))
  };
  var jsx$8 = $m_s_Option$();
  var this$11 = this.documents$1;
  if (jsx$8.apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(this$11.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Library$1))).isDefined__Z()) {
    var jsx$11 = this.emitters$1;
    var jsx$10 = $m_sc_Seq$();
    var array$2 = [new $c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter().init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sci_Map(this.dialect$1, this.ordering$1, this.aliases$1)];
    var jsx$9 = jsx$10.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2));
    var this$14 = $m_sc_Seq$();
    this.emitters$1 = $as_sc_Seq(jsx$11.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$9, this$14.ReusableCBFInstance$2))
  };
  var jsx$14 = this.emitters$1;
  var jsx$13 = $m_sc_Seq$();
  var array$3 = [new $c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter().init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sci_Map(this.dialect$1, this.ordering$1, $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())))];
  var jsx$12 = jsx$13.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$3));
  var this$18 = $m_sc_Seq$();
  this.emitters$1 = $as_sc_Seq(jsx$14.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$12, this$18.ReusableCBFInstance$2));
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(this.emitters$1), b$1);
  jsx$15.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$21 = v.builder$1;
  var array$4 = [key];
  if ((this$21.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array$4.length);
  var newSize = ((this$21.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$21, newSize);
  var len$1 = this$21.size0$6;
  var src = this$21.array$6;
  var dest = this$21.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$21.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array$4.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$16 = j;
    var index = i;
    xs.set(jsx$16, array$4[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$21.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter.prototype.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect = (function() {
  return this.dialect$1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter.prototype.init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sci_Map = (function(dialect, ordering, aliases) {
  this.dialect$1 = dialect;
  this.ordering$1 = ordering;
  this.aliases$1 = aliases;
  this.documents$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(dialect.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1));
  this.emitters$1 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var jsx$1 = $m_s_Option$();
  var this$1 = this.documents$1;
  var this$2 = jsx$1.apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Root$1)));
  if (this$2.isEmpty__Z()) {
    var this$6 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(arg1);
    var this$3 = this.documents$1;
    var this$4 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(this$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Root$1)).fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().EncodedNode$1);
    if (this$4.isEmpty__Z()) {
      var this$6 = $m_s_None$()
    } else {
      var arg1$1 = this$4.get__O();
      var enc = $as_Lamf_core_parser_FieldEntry(arg1$1);
      var this$5 = enc.value$1.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      if (this$5.isEmpty__Z()) {
        var this$6 = $m_s_None$()
      } else {
        var arg1$2 = this$5.get__O();
        var x$19 = $as_Lamf_core_annotations_LexicalInformation(arg1$2);
        var this$6 = new $c_s_Some().init___O(x$19.range__Lamf_core_parser_Range().start$1)
      }
    }
  };
  if (this$6.isEmpty__Z()) {
    var this$9 = $m_s_None$()
  } else {
    var arg1$3 = this$6.get__O();
    var pos = $as_Lamf_core_parser_Position(arg1$3);
    var jsx$2 = $m_sc_Seq$();
    var array = [pos];
    var this$9 = new $c_s_Some().init___O($as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))))
  };
  var rootEncodedPosition = $as_sc_Seq((this$9.isEmpty__Z() ? $m_sci_Nil$() : this$9.get__O()));
  var jsx$3 = $m_s_Option$();
  var this$10 = this.documents$1;
  var this$11 = jsx$3.apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(this$10.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Root$1)));
  if (this$11.isEmpty__Z()) {
    var this$12 = $m_s_None$()
  } else {
    var arg1$4 = this$11.get__O();
    var x$20 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(arg1$4);
    var this$12 = new $c_s_Some().init___O($as_sc_Seq(x$20.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DeclaredNodes$1)))
  };
  var rootDeclared = $as_sc_Seq((this$12.isEmpty__Z() ? $m_sci_Nil$() : this$12.get__O()));
  var jsx$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1) {
    return (function(x$21$2) {
      var x$21 = $as_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping(x$21$2);
      var xo = x$21.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      return xo.toList__sci_List()
    })
  })(this));
  var this$14 = $m_sc_Seq$();
  var jsx$5 = $as_sc_TraversableLike(rootDeclared.flatMap__F1__scg_CanBuildFrom__O(jsx$6, this$14.ReusableCBFInstance$2));
  var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$7$1) {
    return (function(x$22$2) {
      var x$22 = $as_Lamf_core_annotations_LexicalInformation(x$22$2);
      return x$22.range__Lamf_core_parser_Range().start$1
    })
  })(this));
  var this$15 = $m_sc_Seq$();
  var rootDeclaredPositions = $as_sc_Seq(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$4, this$15.ReusableCBFInstance$2));
  var jsx$7 = $m_s_Option$();
  var this$16 = this.documents$1;
  var this$17 = jsx$7.apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(this$16.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Library$1)));
  if (this$17.isEmpty__Z()) {
    var this$18 = $m_s_None$()
  } else {
    var arg1$5 = this$17.get__O();
    var x$23 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(arg1$5);
    var this$18 = new $c_s_Some().init___O($as_sc_Seq(x$23.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DeclaredNodes$1)))
  };
  var libraryDeclarations = $as_sc_Seq((this$18.isEmpty__Z() ? $m_sci_Nil$() : this$18.get__O()));
  var jsx$10 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$10$1) {
    return (function(x$24$2) {
      var x$24 = $as_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping(x$24$2);
      var this$19 = x$24.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      if (this$19.isEmpty__Z()) {
        return $m_s_None$()
      } else {
        var arg1$6 = this$19.get__O();
        var x$25 = $as_Lamf_core_annotations_LexicalInformation(arg1$6);
        return new $c_s_Some().init___O(x$25.range__Lamf_core_parser_Range().start$1)
      }
    })
  })(this));
  var this$20 = $m_sc_Seq$();
  var jsx$9 = $as_sc_TraversableLike(libraryDeclarations.map__F1__scg_CanBuildFrom__O(jsx$10, this$20.ReusableCBFInstance$2));
  var jsx$8 = new $c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter$$anonfun$3().init___Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter(this);
  var this$21 = $m_sc_Seq$();
  var libraryDeclarationPositions = $as_sc_Seq(jsx$9.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$8, this$21.ReusableCBFInstance$2));
  var this$22 = this.documents$1;
  var jsx$12 = $as_sc_Seq(this$22.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Fragments$1));
  var jsx$11 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$11$1) {
    return (function(fragment$2) {
      var fragment = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(fragment$2);
      var this$23 = fragment.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      if (this$23.isEmpty__Z()) {
        var xo$1 = $m_s_None$()
      } else {
        var arg1$7 = this$23.get__O();
        var x$26 = $as_Lamf_core_annotations_LexicalInformation(arg1$7);
        var xo$1 = new $c_s_Some().init___O(x$26.range__Lamf_core_parser_Range().start$1)
      };
      return xo$1.toList__sci_List()
    })
  })(this));
  var this$25 = $m_sc_Seq$();
  var fragmentPositions = $as_sc_Seq(jsx$12.flatMap__F1__scg_CanBuildFrom__O(jsx$11, this$25.ReusableCBFInstance$2));
  var this$26 = $m_sc_Seq$();
  var jsx$15 = $as_sc_TraversableLike(rootEncodedPosition.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(rootDeclaredPositions, this$26.ReusableCBFInstance$2));
  var this$27 = $m_sc_Seq$();
  var jsx$14 = $as_sc_TraversableLike(jsx$15.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(fragmentPositions, this$27.ReusableCBFInstance$2));
  var this$28 = $m_sc_Seq$();
  var jsx$13 = $as_sc_SeqLike(jsx$14.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(libraryDeclarationPositions, this$28.ReusableCBFInstance$2));
  var this$29 = $m_s_math_Ordering$();
  var evidence$1 = $m_s_Predef$().singleton$und$less$colon$less$2;
  var this$30 = $as_sc_TraversableLike(jsx$13.sorted__s_math_Ordering__O(new $c_s_math_LowPriorityOrderingImplicits$$anon$3().init___s_math_LowPriorityOrderingImplicits__F1(this$29, evidence$1))).headOption__s_Option();
  return $as_Lamf_core_parser_Position((this$30.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$30.get__O()))
});
function $as_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.dialects.DocumentsModelEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.dialects.DocumentsModelEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.DocumentsModelEmitter", {
  Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  Lamf_plugins_document_vocabularies_emitters_dialects_AliasesConsumer: 1,
  Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter() {
  $c_O.call(this);
  this.dialect$1 = null;
  this.ordering$1 = null;
  this.aliases$1 = null;
  this.mapping$1 = null;
  this.emitters$1 = null;
  this.sortedNodes$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter.prototype.productPrefix__T = (function() {
  return "DocumentsModelOptionsEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter.prototype.hasOptions__p1__Z = (function() {
  var jsx$3 = $m_sc_Seq$();
  var this$1 = this.mapping$1;
  var jsx$2 = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().SelfEncoded$1)).option$1;
  var this$2 = this.mapping$1;
  var jsx$1 = $as_Lamf_core_model_StrField(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().DeclarationsPath$1)).option$1;
  var this$3 = this.mapping$1;
  var array = [jsx$2, jsx$1, $as_Lamf_core_model_BoolField(this$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().KeyProperty$1)).option$1];
  return $as_sc_TraversableOnce(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)).flatten__F1__sc_GenTraversable(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(xo$2) {
      var xo = $as_s_Option(xo$2);
      return xo.toList__sci_List()
    })
  })(this)))).nonEmpty__Z()
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter)) {
    var DocumentsModelOptionsEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter(x$1);
    var x = this.dialect$1;
    var x$2 = DocumentsModelOptionsEmitter$1.dialect$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = DocumentsModelOptionsEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.aliases$1;
      var x$6 = DocumentsModelOptionsEmitter$1.aliases$1;
      return ((x$5 === null) ? (x$6 === null) : $f_sc_GenMapLike__equals__O__Z(x$5, x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.dialect$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.aliases$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter.prototype.aliases__sci_Map = (function() {
  return this.aliases$1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  if (this.sortedNodes$1.nonEmpty__Z()) {
    $m_Lorg_yaml_model_YNode$();
    var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("options");
    var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
    var jsx$1 = v.builder$1;
    var sourceName = v.sourceName$2;
    var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
    $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.sortedNodes$1, b$1);
    jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
    var this$5 = v.builder$1;
    var array = [key];
    if ((this$5.size0$6 < 0)) {
      throw new $c_jl_IndexOutOfBoundsException().init___T("0")
    };
    var len = $uI(array.length);
    var newSize = ((this$5.size0$6 + len) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this$5, newSize);
    var len$1 = this$5.size0$6;
    var src = this$5.array$6;
    var dest = this$5.array$6;
    $systemArraycopy(src, 0, dest, len, len$1);
    var xs = this$5.array$6;
    var len$2 = xs.u.length;
    var i = 0;
    var j = 0;
    var x = $uI(array.length);
    var x$1 = ((x < len$2) ? x : len$2);
    var that = xs.u.length;
    var end = ((x$1 < that) ? x$1 : that);
    while ((i < end)) {
      var jsx$2 = j;
      var index = i;
      xs.set(jsx$2, array[index]);
      i = ((1 + i) | 0);
      j = ((1 + j) | 0)
    };
    this$5.size0$6 = newSize;
    b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter.prototype.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect = (function() {
  return this.dialect$1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter.prototype.init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sci_Map = (function(dialect, ordering, aliases) {
  this.dialect$1 = dialect;
  this.ordering$1 = ordering;
  this.aliases$1 = aliases;
  this.mapping$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(dialect.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1));
  this.emitters$1 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  if (this.hasOptions__p1__Z()) {
    var this$2 = this.mapping$1;
    var y = $as_Lamf_core_model_BoolField(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().SelfEncoded$1)).option$1;
    var jsx$4 = new $c_T2().init___O__O("selfEncoded", y);
    var this$5 = this.mapping$1;
    var y$1 = $as_Lamf_core_model_StrField(this$5.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().DeclarationsPath$1)).option$1;
    var jsx$3 = new $c_T2().init___O__O("declarationsPath", y$1);
    var this$8 = this.mapping$1;
    var y$2 = $as_Lamf_core_model_BoolField(this$8.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().KeyProperty$1)).option$1;
    var jsx$2 = new $c_T2().init___O__O("keyProperty", y$2);
    var this$11 = this.mapping$1;
    var y$3 = $as_Lamf_core_model_StrField(this$11.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().ReferenceStyle$1)).option$1;
    var array = [jsx$4, jsx$3, jsx$2, new $c_T2().init___O__O("referenceStyle", y$3)];
    var this$16 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
    var i = 0;
    var len = $uI(array.length);
    while ((i < len)) {
      var index = i;
      var arg1 = array[index];
      this$16.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
      i = ((1 + i) | 0)
    };
    var options = $as_sci_Map(this$16.elems$1);
    var y$4 = $m_Lorg_yaml_model_YType$().Bool$1;
    var jsx$7 = new $c_T2().init___O__O("selfEncoded", y$4);
    var y$5 = $m_Lorg_yaml_model_YType$().Bool$1;
    var jsx$6 = new $c_T2().init___O__O("keyProperty", y$5);
    var y$6 = $m_Lorg_yaml_model_YType$().Str$1;
    var jsx$5 = new $c_T2().init___O__O("declarationsPath", y$6);
    var y$7 = $m_Lorg_yaml_model_YType$().Str$1;
    var array$1 = [jsx$7, jsx$6, jsx$5, new $c_T2().init___O__O("referenceStyle", y$7)];
    var this$28 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
    var i$1 = 0;
    var len$1 = $uI(array$1.length);
    while ((i$1 < len$1)) {
      var index$1 = i$1;
      var arg1$1 = array$1[index$1];
      this$28.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1$1));
      i$1 = ((1 + i$1) | 0)
    };
    var types = $as_sci_Map(this$28.elems$1);
    var this$30 = this.mapping$1;
    var y$8 = $as_Lamf_core_model_BoolField(this$30.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().SelfEncoded$1)).annotations$1;
    var jsx$10 = new $c_T2().init___O__O("selfEncoded", y$8);
    var this$33 = this.mapping$1;
    var y$9 = $as_Lamf_core_model_StrField(this$33.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().DeclarationsPath$1)).annotations$1;
    var jsx$9 = new $c_T2().init___O__O("declarationsPath", y$9);
    var this$36 = this.mapping$1;
    var y$10 = $as_Lamf_core_model_BoolField(this$36.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().KeyProperty$1)).annotations$1;
    var jsx$8 = new $c_T2().init___O__O("keyProperty", y$10);
    var this$39 = this.mapping$1;
    var y$11 = $as_Lamf_core_model_StrField(this$39.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().ReferenceStyle$1)).annotations$1;
    var array$2 = [jsx$10, jsx$9, jsx$8, new $c_T2().init___O__O("referenceStyle", y$11)];
    var this$44 = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
    var i$2 = 0;
    var len$2 = $uI(array$2.length);
    while ((i$2 < len$2)) {
      var index$2 = i$2;
      var arg1$2 = array$2[index$2];
      this$44.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1$2));
      i$2 = ((1 + i$2) | 0)
    };
    var annotations = $as_sci_Map(this$44.elems$1);
    var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, types$1, annotations$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_T2(x0$1$2);
        if ((x0$1 !== null)) {
          var optionName = $as_T(x0$1.$$und1__O());
          var maybeValue = $as_s_Option(x0$1.$$und2__O());
          if (maybeValue.isEmpty__Z()) {
            return $m_s_None$()
          } else {
            var arg1$3 = maybeValue.get__O();
            var nodetype = $as_Lorg_yaml_model_YType(types$1.apply__O__O(optionName));
            var this$45 = $m_Lamf_core_emitter_BaseEmitters_package$();
            var annotations$2 = $as_Lamf_core_parser_Annotations(annotations$1.apply__O__O(optionName));
            var position = this$45.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations$2, $d_Lamf_core_annotations_LexicalInformation.getClassOf());
            return new $c_s_Some().init___O(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position(optionName, $objectToString(arg1$3), nodetype, position))
          }
        } else {
          throw new $c_s_MatchError().init___O(x0$1)
        }
      })
    })(this, types, annotations));
    var this$46 = $m_sci_Iterable$();
    var bf = this$46.ReusableCBFInstance$2;
    var jsx$12 = $as_sc_TraversableLike($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(options, f, bf));
    var jsx$11 = new $c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter$$anonfun$2().init___Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter(this);
    var this$47 = $m_sci_Iterable$();
    var optionNodes = $as_sc_TraversableOnce(jsx$12.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$11, this$47.ReusableCBFInstance$2)).toSeq__sc_Seq();
    var sorted = ordering.sorted__sc_Seq__sc_Seq(optionNodes);
    var jsx$1 = sorted
  } else {
    var jsx$1 = $m_sci_Nil$()
  };
  this.sortedNodes$1 = jsx$1;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.sortedNodes$1.headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$9 = $as_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter(arg1);
    var this$2 = new $c_s_Some().init___O(x$9.position$1)
  };
  return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
});
function $as_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.dialects.DocumentsModelOptionsEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.dialects.DocumentsModelOptionsEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.DocumentsModelOptionsEmitter", {
  Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  Lamf_plugins_document_vocabularies_emitters_dialects_AliasesConsumer: 1,
  Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_DocumentsModelOptionsEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter() {
  $c_O.call(this);
  this.dialect$1 = null;
  this.fragment$1 = null;
  this.ordering$1 = null;
  this.aliases$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter.prototype.productPrefix__T = (function() {
  return "FragmentMappingEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter)) {
    var FragmentMappingEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter(x$1);
    var x = this.dialect$1;
    var x$2 = FragmentMappingEmitter$1.dialect$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.fragment$1;
      var x$4 = FragmentMappingEmitter$1.fragment$1;
      var jsx$2 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.ordering$1;
      var x$6 = FragmentMappingEmitter$1.ordering$1;
      var jsx$1 = (x$5 === x$6)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.aliases$1;
      var x$8 = FragmentMappingEmitter$1.aliases$1;
      return ((x$7 === null) ? (x$8 === null) : $f_sc_GenMapLike__equals__O__Z(x$7, x$8))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.dialect$1;
      break
    }
    case 1: {
      return this.fragment$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.aliases$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter.prototype.aliases__sci_Map = (function() {
  return this.aliases$1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter.prototype.init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_plugins_document_vocabularies_model_domain_DocumentMapping__Lamf_core_emitter_SpecOrdering__sci_Map = (function(dialect, fragment, ordering, aliases) {
  this.dialect$1 = dialect;
  this.fragment$1 = fragment;
  this.ordering$1 = ordering;
  this.aliases$1 = aliases;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.fragment$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().EncodedNode$1));
  var this$3 = this$2.option$1;
  var id = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
  var x1 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_AliasesConsumer__aliasFor__T__s_Option(this, id);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var alias = $as_T(x2.value$2);
    var this$4 = this.fragment$1;
    var this$5 = $as_Lamf_core_model_StrField(this$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DocumentName$1));
    var this$6 = this$5.option$1;
    new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position($as_T((this$6.isEmpty__Z() ? null : this$6.get__O())), alias, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
  } else {
    var this$9 = this.fragment$1;
    var this$10 = $as_Lamf_core_model_StrField(this$9.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DocumentName$1));
    var this$11 = this$10.option$1;
    var jsx$1 = $as_T((this$11.isEmpty__Z() ? null : this$11.get__O()));
    var this$12 = this.fragment$1;
    var this$13 = $as_Lamf_core_model_StrField(this$12.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().EncodedNode$1));
    var this$14 = this$13.option$1;
    new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position(jsx$1, $as_T((this$14.isEmpty__Z() ? null : this$14.get__O())), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b)
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter.prototype.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect = (function() {
  return this.dialect$1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.fragment$1.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$13 = $as_Lamf_core_annotations_LexicalInformation(arg1);
    var this$2 = new $c_s_Some().init___O(x$13.range__Lamf_core_parser_Range().start$1)
  };
  return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
});
function $as_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.dialects.FragmentMappingEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.dialects.FragmentMappingEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.FragmentMappingEmitter", {
  Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  Lamf_plugins_document_vocabularies_emitters_dialects_AliasesConsumer: 1,
  Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter() {
  $c_O.call(this);
  this.dialect$1 = null;
  this.ordering$1 = null;
  this.aliases$1 = null;
  this.emitters$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter.prototype.productPrefix__T = (function() {
  return "FragmentsDocumentModelEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter)) {
    var FragmentsDocumentModelEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter(x$1);
    var x = this.dialect$1;
    var x$2 = FragmentsDocumentModelEmitter$1.dialect$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = FragmentsDocumentModelEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.aliases$1;
      var x$6 = FragmentsDocumentModelEmitter$1.aliases$1;
      return ((x$5 === null) ? (x$6 === null) : $f_sc_GenMapLike__equals__O__Z(x$5, x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.dialect$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.aliases$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter.prototype.aliases__sci_Map = (function() {
  return this.aliases$1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("fragments");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$3 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lorg_yaml_model_YNode$();
  var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("encodes");
  var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
  var jsx$1 = v$1.builder$1;
  var sourceName$1 = v$1.sourceName$2;
  var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
  this.ordering$1.sorted__sc_Seq__sc_Seq(this.emitters$1).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$3) {
    return (function(x$16$2) {
      var x$16 = $as_Lamf_core_emitter_EntryEmitter(x$16$2);
      x$16.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$3)
    })
  })(this, b$2)));
  jsx$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1));
  var this$7 = v$1.builder$1;
  var array = [key$1];
  if ((this$7.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array.length);
  var newSize = ((this$7.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$7, newSize);
  var len$1 = this$7.size0$6;
  var src = this$7.array$6;
  var dest = this$7.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$7.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$2 = j;
    var index = i;
    xs.set(jsx$2, array[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$7.size0$6 = newSize;
  b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1));
  jsx$3.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$20 = v.builder$1;
  var array$1 = [key];
  if ((this$20.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len$3 = $uI(array$1.length);
  var newSize$1 = ((this$20.size0$6 + len$3) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$20, newSize$1);
  var len$4 = this$20.size0$6;
  var src$1 = this$20.array$6;
  var dest$1 = this$20.array$6;
  $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
  var xs$1 = this$20.array$6;
  var len$5 = xs$1.u.length;
  var i$1 = 0;
  var j$1 = 0;
  var x$2 = $uI(array$1.length);
  var x$3 = ((x$2 < len$5) ? x$2 : len$5);
  var that$1 = xs$1.u.length;
  var end$1 = ((x$3 < that$1) ? x$3 : that$1);
  while ((i$1 < end$1)) {
    var jsx$4 = j$1;
    var index$1 = i$1;
    xs$1.set(jsx$4, array$1[index$1]);
    i$1 = ((1 + i$1) | 0);
    j$1 = ((1 + j$1) | 0)
  };
  this$20.size0$6 = newSize$1;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter.prototype.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect = (function() {
  return this.dialect$1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter.prototype.init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sci_Map = (function(dialect, ordering, aliases) {
  this.dialect$1 = dialect;
  this.ordering$1 = ordering;
  this.aliases$1 = aliases;
  var this$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(dialect.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1));
  var jsx$2 = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Fragments$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(fragmentMapping$2) {
      var fragmentMapping = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(fragmentMapping$2);
      return new $c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentMappingEmitter().init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_plugins_document_vocabularies_model_domain_DocumentMapping__Lamf_core_emitter_SpecOrdering__sci_Map($this.dialect$1, fragmentMapping, $this.ordering$1, $this.aliases$1)
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  this.emitters$1 = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.ordering$1.sorted__sc_Seq__sc_Seq(this.emitters$1).headOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var e = $as_Lamf_core_emitter_EntryEmitter(arg1);
    var this$2 = new $c_s_Some().init___O(e.position__Lamf_core_parser_Position())
  };
  return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
});
function $as_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.dialects.FragmentsDocumentModelEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.dialects.FragmentsDocumentModelEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.FragmentsDocumentModelEmitter", {
  Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  Lamf_plugins_document_vocabularies_emitters_dialects_AliasesConsumer: 1,
  Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_FragmentsDocumentModelEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter() {
  $c_O.call(this);
  this.dialect$1 = null;
  this.ordering$1 = null;
  this.aliases$1 = null;
  this.mapping$1 = null;
  this.emitters$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter.prototype.productPrefix__T = (function() {
  return "LibraryDocumentModelEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter)) {
    var LibraryDocumentModelEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter(x$1);
    var x = this.dialect$1;
    var x$2 = LibraryDocumentModelEmitter$1.dialect$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = LibraryDocumentModelEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.aliases$1;
      var x$6 = LibraryDocumentModelEmitter$1.aliases$1;
      return ((x$5 === null) ? (x$6 === null) : $f_sc_GenMapLike__equals__O__Z(x$5, x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.dialect$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.aliases$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter.prototype.aliases__sci_Map = (function() {
  return this.aliases$1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.mapping$1;
  var jsx$3 = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DeclaredNodes$1));
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(declaration$2) {
      var declaration = $as_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping(declaration$2);
      var this$2 = $as_Lamf_core_model_StrField(declaration.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().MappedNode$1));
      var this$3 = this$2.option$1;
      var id = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
      var x1 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_AliasesConsumer__aliasFor__T__s_Option($this, id);
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var declaredId = $as_T(x2.value$2);
        var this$4 = $as_Lamf_core_model_StrField(declaration.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().Name$1));
        var this$5 = this$4.option$1;
        return new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position($as_T((this$5.isEmpty__Z() ? null : this$5.get__O())), declaredId, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$())
      } else {
        var this$8 = $as_Lamf_core_model_StrField(declaration.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().Name$1));
        var this$9 = this$8.option$1;
        var jsx$2 = $as_T((this$9.isEmpty__Z() ? null : this$9.get__O()));
        var this$10 = $as_Lamf_core_model_StrField(declaration.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().MappedNode$1));
        var this$11 = this$10.option$1;
        return new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position(jsx$2, $as_T((this$11.isEmpty__Z() ? null : this$11.get__O())), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$())
      }
    })
  })(this));
  var this$14 = $m_sc_Seq$();
  var declaredNodes = $as_sc_Seq(jsx$3.map__F1__scg_CanBuildFrom__O(jsx$1, this$14.ReusableCBFInstance$2));
  var sortedNodes = this.ordering$1.sorted__sc_Seq__sc_Seq(declaredNodes);
  var jsx$6 = this.emitters$1;
  var jsx$5 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anon$2().init___Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter__sc_Seq(this, sortedNodes)];
  var jsx$4 = jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
  var this$17 = $m_sc_Seq$();
  this.emitters$1 = $as_sc_Seq(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$17.ReusableCBFInstance$2));
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("library");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$7 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(this.emitters$1), b$1);
  jsx$7.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$22 = v.builder$1;
  var array$1 = [key];
  if ((this$22.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array$1.length);
  var newSize = ((this$22.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$22, newSize);
  var len$1 = this$22.size0$6;
  var src = this$22.array$6;
  var dest = this$22.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$22.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array$1.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$8 = j;
    var index = i;
    xs.set(jsx$8, array$1[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$22.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter.prototype.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect = (function() {
  return this.dialect$1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter.prototype.init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sci_Map = (function(dialect, ordering, aliases) {
  this.dialect$1 = dialect;
  this.ordering$1 = ordering;
  this.aliases$1 = aliases;
  var this$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(dialect.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1));
  this.mapping$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Library$1));
  this.emitters$1 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.dialect$1;
  var this$2 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1));
  var this$3 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Library$1));
  var jsx$4 = $as_sc_Seq(this$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DeclaredNodes$1));
  var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(lib$2) {
      var lib = $as_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping(lib$2);
      var this$4 = lib.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
      if (this$4.isEmpty__Z()) {
        return $m_s_None$()
      } else {
        var arg1 = this$4.get__O();
        var x$7 = $as_Lamf_core_annotations_LexicalInformation(arg1);
        return new $c_s_Some().init___O(x$7.range__Lamf_core_parser_Range().start$1)
      }
    })
  })(this));
  var this$5 = $m_sc_Seq$();
  var jsx$2 = $as_sc_TraversableLike(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$5.ReusableCBFInstance$2));
  var jsx$1 = new $c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter$$anonfun$1().init___Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter(this);
  var this$6 = $m_sc_Seq$();
  var allPos = $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2));
  var this$7 = $m_s_math_Ordering$();
  var evidence$1 = $m_s_Predef$().singleton$und$less$colon$less$2;
  var this$8 = $as_sc_TraversableLike(allPos.sorted__s_math_Ordering__O(new $c_s_math_LowPriorityOrderingImplicits$$anon$3().init___s_math_LowPriorityOrderingImplicits__F1(this$7, evidence$1))).headOption__s_Option();
  return $as_Lamf_core_parser_Position((this$8.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$8.get__O()))
});
function $as_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.dialects.LibraryDocumentModelEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.dialects.LibraryDocumentModelEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.LibraryDocumentModelEmitter", {
  Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  Lamf_plugins_document_vocabularies_emitters_dialects_AliasesConsumer: 1,
  Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_LibraryDocumentModelEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter() {
  $c_O.call(this);
  this.dialect$1 = null;
  this.ordering$1 = null;
  this.aliases$1 = null;
  this.mapping$1 = null;
  this.emitters$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter.prototype.productPrefix__T = (function() {
  return "RootDocumentModelEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter)) {
    var RootDocumentModelEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter(x$1);
    var x = this.dialect$1;
    var x$2 = RootDocumentModelEmitter$1.dialect$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$1;
      var x$4 = RootDocumentModelEmitter$1.ordering$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.aliases$1;
      var x$6 = RootDocumentModelEmitter$1.aliases$1;
      return ((x$5 === null) ? (x$6 === null) : $f_sc_GenMapLike__equals__O__Z(x$5, x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.dialect$1;
      break
    }
    case 1: {
      return this.ordering$1;
      break
    }
    case 2: {
      return this.aliases$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter.prototype.aliases__sci_Map = (function() {
  return this.aliases$1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.mapping$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().EncodedNode$1)).option$1;
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var encodedId = $as_T(arg1);
    var x1 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_AliasesConsumer__aliasFor__T__s_Option(this, encodedId);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var alias = $as_T(x2.value$2);
      var jsx$3 = this.emitters$1;
      var jsx$2 = $m_sc_Seq$();
      var array = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("encodes", alias, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$())];
      var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
      var this$7 = $m_sc_Seq$();
      this.emitters$1 = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2))
    } else {
      var x = $m_s_None$();
      if ((x === x1)) {
        var jsx$6 = this.emitters$1;
        var jsx$5 = $m_sc_Seq$();
        var array$1 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("encodes", encodedId, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$())];
        var jsx$4 = jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
        var this$12 = $m_sc_Seq$();
        this.emitters$1 = $as_sc_Seq(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$12.ReusableCBFInstance$2))
      } else {
        throw new $c_s_MatchError().init___O(x1)
      }
    }
  };
  var this$13 = this.mapping$1;
  var decls = $as_sc_Seq(this$13.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DeclaredNodes$1));
  if (decls.nonEmpty__Z()) {
    var jsx$7 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(declaration$2) {
        var declaration = $as_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping(declaration$2);
        var this$14 = $as_Lamf_core_model_StrField(declaration.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().MappedNode$1));
        var this$15 = this$14.option$1;
        var id = $as_T((this$15.isEmpty__Z() ? null : this$15.get__O()));
        var x1$1 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_AliasesConsumer__aliasFor__T__s_Option(this$2$1, id);
        if ((x1$1 instanceof $c_s_Some)) {
          var x2$1 = $as_s_Some(x1$1);
          var declaredId = $as_T(x2$1.value$2);
          var this$16 = $as_Lamf_core_model_StrField(declaration.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().Name$1));
          var this$17 = this$16.option$1;
          return new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position($as_T((this$17.isEmpty__Z() ? null : this$17.get__O())), declaredId, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$())
        } else {
          var this$20 = $as_Lamf_core_model_StrField(declaration.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().Name$1));
          var this$21 = this$20.option$1;
          var jsx$8 = $as_T((this$21.isEmpty__Z() ? null : this$21.get__O()));
          var this$22 = $as_Lamf_core_model_StrField(declaration.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().MappedNode$1));
          var this$23 = this$22.option$1;
          return new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position(jsx$8, $as_T((this$23.isEmpty__Z() ? null : this$23.get__O())), $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$())
        }
      })
    })(this));
    var this$26 = $m_sc_Seq$();
    var declaredNodes = $as_sc_Seq(decls.map__F1__scg_CanBuildFrom__O(jsx$7, this$26.ReusableCBFInstance$2));
    var sortedNodes = this.ordering$1.sorted__sc_Seq__sc_Seq(declaredNodes);
    var jsx$11 = this.emitters$1;
    var jsx$10 = $m_sc_Seq$();
    var array$2 = [new $c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter$$anon$3().init___Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter__sc_Seq(this, sortedNodes)];
    var jsx$9 = jsx$10.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2));
    var this$29 = $m_sc_Seq$();
    this.emitters$1 = $as_sc_Seq(jsx$11.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$9, this$29.ReusableCBFInstance$2))
  };
  $m_Lorg_yaml_model_YNode$();
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("root");
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$12 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(this.emitters$1), b$1);
  jsx$12.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$34 = v.builder$1;
  var array$3 = [key];
  if ((this$34.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array$3.length);
  var newSize = ((this$34.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$34, newSize);
  var len$1 = this$34.size0$6;
  var src = this$34.array$6;
  var dest = this$34.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$34.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x$1 = $uI(array$3.length);
  var x$2 = ((x$1 < len$2) ? x$1 : len$2);
  var that = xs.u.length;
  var end = ((x$2 < that) ? x$2 : that);
  while ((i < end)) {
    var jsx$13 = j;
    var index = i;
    xs.set(jsx$13, array$3[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$34.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter.prototype.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect = (function() {
  return this.dialect$1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter.prototype.init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_emitter_SpecOrdering__sci_Map = (function(dialect, ordering, aliases) {
  this.dialect$1 = dialect;
  this.ordering$1 = ordering;
  this.aliases$1 = aliases;
  var this$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(dialect.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1));
  this.mapping$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Root$1));
  this.emitters$1 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.dialect$1;
  var this$2 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1));
  var this$3 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(this$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Root$1)).annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  if (this$3.isEmpty__Z()) {
    var this$4 = $m_s_None$()
  } else {
    var arg1 = this$3.get__O();
    var x$12 = $as_Lamf_core_annotations_LexicalInformation(arg1);
    var this$4 = new $c_s_Some().init___O(x$12.range__Lamf_core_parser_Range().start$1)
  };
  return $as_Lamf_core_parser_Position((this$4.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$4.get__O()))
});
function $as_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.dialects.RootDocumentModelEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.dialects.RootDocumentModelEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.RootDocumentModelEmitter", {
  Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  Lamf_plugins_document_vocabularies_emitters_dialects_AliasesConsumer: 1,
  Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_RootDocumentModelEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$() {
  $c_O.call(this);
  this.DefinedBy$1 = null;
  this.Fragment$1 = null;
  this.GraphDependencies$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.Externals$1 = null;
  this.Declares$1 = null;
  this.Encodes$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null;
  this.doc$1 = null
}
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_ModuleModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_DocumentModel__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.DefinedBy$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "definedBy"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$6 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.Fragment$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$6, "fragment"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true);
  var jsx$3 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Iri$());
  var this$11 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  this.GraphDependencies$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$11, "graphDependencies"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true);
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  var x$9 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "DialectInstanceFragment");
  var this$18 = $m_Lamf_core_metamodel_document_FragmentModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$9, this$18);
  var x$13 = this.DefinedBy$1;
  var x$12 = this.Fragment$1;
  var x$11 = this.GraphDependencies$1;
  var x$10 = this.Externals$1;
  var this$19 = $m_Lamf_core_metamodel_document_FragmentModel$().fields$1;
  var this$20 = new $c_sci_$colon$colon().init___O__sci_List(x$10, this$19);
  var this$21 = new $c_sci_$colon$colon().init___O__sci_List(x$11, this$20);
  var this$22 = new $c_sci_$colon$colon().init___O__sci_List(x$12, this$21);
  this.fields$1 = new $c_sci_$colon$colon().init___O__sci_List(x$13, this$22);
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype.amf$core$metamodel$document$DocumentModel$$undsetter$und$fields$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  this.doc$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype.Declares__Lamf_core_metamodel_Field = (function() {
  return this.Declares$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype.amf$core$metamodel$document$ModuleModel$$undsetter$und$Declares$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Declares$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype.Encodes__Lamf_core_metamodel_Field = (function() {
  return this.Encodes$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Encodes$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype.amf$core$metamodel$document$DocumentModel$$undsetter$und$type$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype.amf$plugins$document$vocabularies$metamodel$document$ExternalContextModel$$undsetter$und$Externals$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Externals$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$: 0
}, false, "amf.plugins.document.vocabularies.metamodel.document.DialectInstanceFragmentModel$", {
  Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_DocumentModel: 1,
  Lamf_core_metamodel_document_FragmentModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_document_ModuleModel: 1,
  Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModel: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$;
var $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$() {
  if ((!$n_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$)) {
    $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$ = new $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$() {
  $c_O.call(this);
  this.DefinedBy$1 = null;
  this.GraphDependencies$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.Externals$1 = null;
  this.Declares$1 = null;
  this.Encodes$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null;
  this.doc$1 = null
}
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_ModuleModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_DocumentModel__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.DefinedBy$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "definedBy"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true);
  var jsx$2 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Iri$());
  var this$6 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  this.GraphDependencies$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$6, "graphDependencies"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true);
  var this$11 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  var x$5 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$11, "DialectInstanceLibrary");
  var this$13 = $m_Lamf_core_metamodel_document_ModuleModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$5, this$13);
  var x$8 = this.DefinedBy$1;
  var x$7 = this.GraphDependencies$1;
  var x$6 = this.Externals$1;
  var this$14 = $m_Lamf_core_metamodel_document_ModuleModel$().fields$1;
  var this$15 = new $c_sci_$colon$colon().init___O__sci_List(x$6, this$14);
  var this$16 = new $c_sci_$colon$colon().init___O__sci_List(x$7, this$15);
  this.fields$1 = new $c_sci_$colon$colon().init___O__sci_List(x$8, this$16);
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype.amf$core$metamodel$document$DocumentModel$$undsetter$und$fields$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  this.doc$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype.Declares__Lamf_core_metamodel_Field = (function() {
  return this.Declares$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype.amf$core$metamodel$document$ModuleModel$$undsetter$und$Declares$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Declares$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype.Encodes__Lamf_core_metamodel_Field = (function() {
  return this.Encodes$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Encodes$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype.amf$core$metamodel$document$DocumentModel$$undsetter$und$type$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype.amf$plugins$document$vocabularies$metamodel$document$ExternalContextModel$$undsetter$und$Externals$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Externals$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$: 0
}, false, "amf.plugins.document.vocabularies.metamodel.document.DialectInstanceLibraryModel$", {
  Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_DocumentModel: 1,
  Lamf_core_metamodel_document_FragmentModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_document_ModuleModel: 1,
  Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModel: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$;
var $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$() {
  if ((!$n_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$)) {
    $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$ = new $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$() {
  $c_O.call(this);
  this.DefinedBy$1 = null;
  this.GraphDependencies$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.Externals$1 = null;
  this.Declares$1 = null;
  this.Encodes$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null;
  this.doc$1 = null
}
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_ModuleModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_DocumentModel__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.DefinedBy$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "definedBy"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true);
  var jsx$2 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Iri$());
  var this$6 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  this.GraphDependencies$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$6, "graphDependencies"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true);
  var this$11 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$11, "DialectInstance");
  var this$13 = $m_Lamf_core_metamodel_document_DocumentModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$13);
  var x$4 = this.DefinedBy$1;
  var x$3 = this.GraphDependencies$1;
  var x$2 = this.Externals$1;
  var this$14 = $m_Lamf_core_metamodel_document_DocumentModel$().fields$1;
  var this$15 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$14);
  var this$16 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$15);
  this.fields$1 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$16);
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype.amf$core$metamodel$document$DocumentModel$$undsetter$und$fields$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  this.doc$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype.Declares__Lamf_core_metamodel_Field = (function() {
  return this.Declares$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype.amf$core$metamodel$document$ModuleModel$$undsetter$und$Declares$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Declares$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_vocabularies_model_document_DialectInstance().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype.Encodes__Lamf_core_metamodel_Field = (function() {
  return this.Encodes$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Encodes$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype.amf$core$metamodel$document$DocumentModel$$undsetter$und$type$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype.amf$plugins$document$vocabularies$metamodel$document$ExternalContextModel$$undsetter$und$Externals$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Externals$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$: 0
}, false, "amf.plugins.document.vocabularies.metamodel.document.DialectInstanceModel$", {
  Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_DocumentModel: 1,
  Lamf_core_metamodel_document_FragmentModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_document_ModuleModel: 1,
  Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModel: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$;
var $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$() {
  if ((!$n_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$)) {
    $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$ = new $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$() {
  $c_O.call(this);
  this.Name$1 = null;
  this.Version$1 = null;
  this.Documents$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.Externals$1 = null;
  this.Declares$1 = null;
  this.Encodes$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null
}
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_ModuleModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_DocumentModel__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Name$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "name"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "name", "Name of the dialect", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Version$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "version"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "version", "Version of the dialect", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.Documents$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "documents"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "documents", "Document mapping for the the dialect", $m_sci_Nil$()), true);
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "Dialect");
  var this$12 = $m_Lamf_core_metamodel_document_DocumentModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$12);
  var x$6 = this.Name$1;
  var x$5 = this.Version$1;
  var x$4 = this.Externals$1;
  var x$3 = this.Documents$1;
  var x$2 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
  var this$13 = $m_Lamf_core_metamodel_document_DocumentModel$().fields$1;
  var this$14 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$13);
  var this$15 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$14);
  var this$16 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$15);
  var this$17 = new $c_sci_$colon$colon().init___O__sci_List(x$5, this$16);
  this.fields$1 = new $c_sci_$colon$colon().init___O__sci_List(x$6, this$17);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Meta$1, "Dialect", "Definition of an AML dialect, mapping AST nodes from dialect documents into an output semantic graph", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype.amf$core$metamodel$document$DocumentModel$$undsetter$und$fields$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype.Declares__Lamf_core_metamodel_Field = (function() {
  return this.Declares$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype.amf$core$metamodel$document$ModuleModel$$undsetter$und$Declares$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Declares$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_vocabularies_model_document_Dialect().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype.Encodes__Lamf_core_metamodel_Field = (function() {
  return this.Encodes$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Encodes$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype.amf$core$metamodel$document$DocumentModel$$undsetter$und$type$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype.amf$plugins$document$vocabularies$metamodel$document$ExternalContextModel$$undsetter$und$Externals$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Externals$1 = x$1
});
var $d_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$: 0
}, false, "amf.plugins.document.vocabularies.metamodel.document.DialectModel$", {
  Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_DocumentModel: 1,
  Lamf_core_metamodel_document_FragmentModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_document_ModuleModel: 1,
  Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModel: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$;
var $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$() {
  if ((!$n_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$)) {
    $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$ = new $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$() {
  $c_O.call(this);
  this.ObjectRange$1 = null;
  this.fields$1 = null;
  this.type$1 = null;
  this.Name$1 = null;
  this.TypeDiscriminator$1 = null;
  this.TypeDiscriminatorName$1 = null;
  this.MergePolicy$1 = null;
  this.ALLOWED$undMERGE$undPOLICY$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.doc$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_metamodel_domain_MergeableMappingModel__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_metamodel_domain_NodeWithDiscriminatorModel__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappableModel__$$init$__V(this);
  var jsx$1 = new $c_Lamf_core_metamodel_Type$SortedArray().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Iri$());
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.ObjectRange$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "node"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "range", "Object constraint over the type of the mapped property", $m_sci_Nil$()), true);
  var x$4 = this.Name$1;
  var x$3 = this.TypeDiscriminator$1;
  var x$2 = this.TypeDiscriminatorName$1;
  var x$1 = this.ObjectRange$1;
  var jsx$3 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().fields$1;
  var jsx$2 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$4 = $m_sci_List$();
  var this$5 = $as_sci_List(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$4.ReusableCBFInstance$2));
  var this$6 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$5);
  var this$7 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$6);
  var this$8 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$7);
  this.fields$1 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$8);
  var this$9 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  var x$6 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$9, "UnionNodeMapping");
  var this$11 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var x$5 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$11, "Shape");
  var this$13 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  var this$14 = new $c_sci_$colon$colon().init___O__sci_List(x$5, this$13);
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$6, this$14);
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype.amf$plugins$document$vocabularies$metamodel$domain$NodeMappableModel$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  this.doc$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype.amf$plugins$document$vocabularies$metamodel$domain$NodeWithDiscriminatorModel$$undsetter$und$TypeDiscriminatorName$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TypeDiscriminatorName$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype.amf$plugins$document$vocabularies$metamodel$domain$NodeWithDiscriminatorModel$$undsetter$und$TypeDiscriminator$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TypeDiscriminator$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype.amf$plugins$document$vocabularies$metamodel$domain$MergeableMappingModel$$undsetter$und$MergePolicy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.MergePolicy$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype.amf$plugins$document$vocabularies$metamodel$domain$MergeableMappingModel$$undsetter$und$ALLOWED$undMERGE$undPOLICY$und$eq__sci_Set__V = (function(x$1) {
  this.ALLOWED$undMERGE$undPOLICY$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$: 0
}, false, "amf.plugins.document.vocabularies.metamodel.domain.UnionNodeMappingModel$", {
  Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_plugins_document_vocabularies_metamodel_domain_MergeableMappingModel: 1,
  Lamf_plugins_document_vocabularies_metamodel_domain_NodeWithDiscriminatorModel: 1,
  Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappableModel: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$;
var $n_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$() {
  if ((!$n_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$)) {
    $n_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$ = new $c_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm() {
  $c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm.call(this);
  this.fields$2 = null;
  this.annotations$2 = null
}
$c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm.prototype = new $h_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm();
$c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm.prototype.productPrefix__T = (function() {
  return "DatatypePropertyTerm"
});
$c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm)) {
    var DatatypePropertyTerm$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm(x$1);
    var x = this.fields$2;
    var x$2 = DatatypePropertyTerm$1.fields$2;
    if ((x === x$2)) {
      var x$3 = this.annotations$2;
      var x$4 = DatatypePropertyTerm$1.annotations$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$2;
      break
    }
    case 1: {
      return this.annotations$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_vocabularies_metamodel_domain_DatatypePropertyTermModel$()
});
$c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$2 = fields;
  this.annotations$2 = annotations;
  return this
});
function $as_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.domain.DatatypePropertyTerm"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.domain.DatatypePropertyTerm;", depth))
}
var $d_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm: 0
}, false, "amf.plugins.document.vocabularies.model.domain.DatatypePropertyTerm", {
  Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm: 1,
  Lamf_plugins_document_vocabularies_model_domain_PropertyTerm: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.instanceTypes$1 = null;
  this.instanceDefinedBy$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.setObjectField__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(property, value, node) {
  if (value.isUnresolved$1) {
    var resolve = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, property$1, value$1, node$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_model_domain_Linkable(x0$1$2);
        if ((x0$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
          var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x0$1);
          var f = property$1.toField__Lamf_core_metamodel_Field();
          var jsx$2 = value$1.refName$1;
          var jsx$1 = value$1.annotations$1;
          var this$1 = $as_Lamf_core_model_BoolField(value$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1)).option$1;
          var value$2 = $as_Lamf_core_model_domain_AmfObject($this.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(jsx$2, jsx$1, x2, $uZ((this$1.isEmpty__Z() ? false : this$1.get__O())))).withId__T__Lamf_core_model_domain_AmfObject(value$1.id$1);
          var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(node$1);
          $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject($this, f, value$2, annotations)
        } else {
          throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot resolve reference with not dialect domain element value " + x0$1.id__T())))
        }
      })
    })(this, property, value, node));
    $f_Lamf_core_model_domain_Linkable__toFutureRef__F1__V(value, resolve)
  } else {
    var f$1 = property.toField__Lamf_core_metamodel_Field();
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(node);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this, f$1, value, annotations$1)
  };
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.productPrefix__T = (function() {
  return "DialectDomainElement"
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.withInstanceTypes__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(types) {
  this.instanceTypes$1 = types;
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return this.adopted__T__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(parent, cycle)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.setObjectField__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__sc_Seq__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(property, value, node) {
  var f = property.toField__Lamf_core_metamodel_Field();
  var x = $m_sci_Nil$();
  if (x.equals__O__Z(value)) {
    var this$1 = this.fields$1;
    var jsx$1 = (!this$1.fs$1.contains__O__Z(f))
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($m_sci_Nil$(), new $c_Lamf_core_parser_Annotations().init___());
    var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(node);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this, f, value$1, annotations)
  } else {
    var x1$2 = value.partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x0$1$2);
        if ((x0$1 !== null)) {
          if (x0$1.isUnresolved$1) {
            return true
          }
        };
        return false
      })
    })(this)));
    if ((x1$2 === null)) {
      throw new $c_s_MatchError().init___O(x1$2)
    };
    var unresolved = $as_sc_Seq(x1$2.$$und1__O());
    var normal = $as_sc_Seq(x1$2.$$und2__O());
    var value$2 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(normal, new $c_Lamf_core_parser_Annotations().init___());
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(node);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this, f, value$2, annotations$1);
    unresolved.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, f$1, node$1) {
      return (function(x0$2$2) {
        var x0$2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x0$2$2);
        matchEnd4$1: {
          if ((x0$2 !== null)) {
            if (x0$2.isUnresolved$1) {
              var resolve = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, f$2, node$2) {
                return (function(x0$3$2) {
                  var x0$3 = $as_Lamf_core_model_domain_Linkable(x0$3$2);
                  if ((x0$3 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
                    var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x0$3);
                    $this$1.setObjInCollection__p1__Lamf_core_metamodel_Field__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(f$2, node$2, x2)
                  }
                })
              })(this$2$1, f$1, node$1));
              $f_Lamf_core_model_domain_Linkable__toFutureRef__F1__V(x0$2, resolve);
              break matchEnd4$1
            }
          }
        }
      })
    })(this, f, node)))
  };
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
    var DialectDomainElement$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(x$1);
    var x = this.fields$1;
    var x$2 = DialectDomainElement$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = DialectDomainElement$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__sc_Seq__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(property, value, entry) {
  var field = property.toField__Lamf_core_metamodel_Field();
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$9$2) {
      return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(x$9$2, new $c_Lamf_core_parser_Annotations().init___())
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(value.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2)), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this, field, value$1, annotations);
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value)).withDefinedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(this.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping()).withInstanceTypes__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(this.instanceTypes$1)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.objectCollectionProperty__Lamf_core_metamodel_Field__sc_Seq = (function(f) {
  var this$1 = this.fields$1;
  var this$2 = this$1.fs$1.get__O__s_Option(f);
  var pf = new $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectCollectionProperty$1().init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(this);
  if ((!this$2.isEmpty__Z())) {
    var this$3 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$2.get__O();
    var this$4 = this$3.apply__O__s_Option(v1)
  } else {
    var this$4 = $m_s_None$()
  };
  return $as_sc_Seq((this$4.isEmpty__Z() ? $m_sci_Nil$() : this$4.get__O()))
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.includeName__T = (function() {
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this).isDefined__Z()) {
    var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1)).option$1;
    if (this$1.isEmpty__Z()) {
      var this$2 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this);
      if (this$2.isEmpty__Z()) {
        var this$6 = $m_s_None$()
      } else {
        var arg1 = this$2.get__O();
        var x$3 = $as_Lamf_core_model_domain_DomainElement(arg1);
        var thiz = x$3.id__T();
        var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "#", 0);
        var this$5 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
        var this$6 = new $c_s_Some().init___O($as_T($f_sc_IndexedSeqOptimized__head__O(this$5)))
      };
      if (this$6.isEmpty__Z()) {
        throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot produce include reference without linked element at elem " + this.id$1)))
      };
      var jsx$1 = $as_T(this$6.get__O())
    } else {
      var jsx$1 = this$1.get__O()
    };
    return $as_T(jsx$1)
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot produce include reference without linked element at elem " + this.id$1)))
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return this.meta__Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel()
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__I__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(property, value, entry) {
  var field = property.toField__Lamf_core_metamodel_Field();
  var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this, field, value$1, annotations);
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Z__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(property, value, entry) {
  var field = property.toField__Lamf_core_metamodel_Field();
  var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this, field, value$1, annotations);
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.localRefName__T = (function() {
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this).isDefined__Z()) {
    var this$1 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this);
    if (this$1.isEmpty__Z()) {
      var this$8 = $m_s_None$()
    } else {
      var arg1 = this$1.get__O();
      var x$2 = $as_Lamf_core_model_domain_DomainElement(arg1);
      var thiz = x$2.id__T();
      var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "#", 0);
      var this$4 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
      var thiz$1 = $as_T($f_sc_IndexedSeqOptimized__last__O(this$4));
      var xs$1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz$1, "/", 0);
      var this$7 = new $c_scm_ArrayOps$ofRef().init___AO(xs$1);
      var this$8 = new $c_s_Some().init___O($as_T($f_sc_IndexedSeqOptimized__last__O(this$7)))
    };
    if (this$8.isEmpty__Z()) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T(("Cannot produce local reference without linked element at elem " + this.id$1)))
    };
    return $as_T(this$8.get__O())
  } else {
    var thiz$2 = this.id$1;
    var xs$2 = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz$2, "#", 0);
    var this$11 = new $c_scm_ArrayOps$ofRef().init___AO(xs$2);
    var thiz$3 = $as_T($f_sc_IndexedSeqOptimized__last__O(this$11));
    var xs$3 = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz$3, "/", 0);
    var this$14 = new $c_scm_ArrayOps$ofRef().init___AO(xs$3);
    return $as_T($f_sc_IndexedSeqOptimized__last__O(this$14))
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  var unresolvedNodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(unresolved);
  var linked = $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(unresolvedNodeMapping, label, annotations);
  if ((supportsRecursion && $is_Lamf_core_model_domain_Linkable(linked))) {
    var this$1 = $as_Lamf_core_model_domain_Linkable(linked);
    var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1;
    $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, supportsRecursion))
  };
  return $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(linked)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(property, value, entry) {
  var field = property.toField__Lamf_core_metamodel_Field();
  var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this, field, value$1, annotations);
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.literalProperties__Lamf_core_metamodel_Field__sc_Seq = (function(f) {
  var this$1 = this.fields$1;
  var this$2 = this$1.fs$1.get__O__s_Option(f);
  var pf = new $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperties$1().init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(this);
  if ((!this$2.isEmpty__Z())) {
    var this$3 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$2.get__O();
    var this$4 = this$3.apply__O__s_Option(v1)
  } else {
    var this$4 = $m_s_None$()
  };
  return $as_sc_Seq((this$4.isEmpty__Z() ? $m_sci_Nil$() : this$4.get__O()))
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__D__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(property, value, entry) {
  var field = property.toField__Lamf_core_metamodel_Field();
  var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this, field, value$1, annotations);
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.objectProperty__Lamf_core_metamodel_Field__s_Option = (function(f) {
  var this$1 = this.fields$1;
  var this$2 = this$1.fs$1.get__O__s_Option(f);
  var pf = new $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$objectProperty$1().init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(this);
  if ((!this$2.isEmpty__Z())) {
    var this$3 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$2.get__O();
    return this$3.apply__O__s_Option(v1)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.meta__Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel = (function() {
  if (this.instanceTypes$1.isEmpty__Z()) {
    $m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$();
    return new $c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel().init___sc_Seq__sc_Seq__s_Option(($m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$(), $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))), ($m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$(), $m_sci_Nil$()), ($m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$(), $m_s_None$()))
  } else {
    var jsx$3 = $as_sc_Seq(this.instanceTypes$1.distinct__O());
    var this$5 = this.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping();
    var jsx$2 = $as_sc_Seq(this$5.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$10$2) {
        var x$10 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$10$2);
        return x$10.toField__Lamf_core_metamodel_Field()
      })
    })(this));
    var this$6 = $m_sc_Seq$();
    return new $c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel().init___sc_Seq__sc_Seq__s_Option(jsx$3, $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2)), new $c_s_Some().init___O(this.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping()))
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lorg_mulesoft_common_time_SimpleDateTime__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(property, value, entry) {
  var field = property.toField__Lamf_core_metamodel_Field();
  var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this, field, value$1, annotations);
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.findPropertyMappingByTermPropertyId__T__s_Option = (function(termPropertyId) {
  var this$1 = this.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping();
  return $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, termPropertyId$1) {
    return (function(x$5$2) {
      var x$5 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$5$2);
      var this$2 = $as_Lamf_core_model_StrField(x$5.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
      var this$3 = this$2.option$1;
      return ($as_T((this$3.isEmpty__Z() ? null : this$3.get__O())) === termPropertyId$1)
    })
  })(this, termPropertyId)))
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(property, entry) {
  var field = property.toField__Lamf_core_metamodel_Field();
  var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(entry.value$2, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this, field, value, annotations);
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.adopted__T__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(newId, cycle) {
  return ($m_s_Option$().apply__O__s_Option(this.id$1).isEmpty__Z() ? $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, newId)) : this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.setObjInCollection__p1__Lamf_core_metamodel_Field__Lorg_yaml_model_YNode__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(f, node, newObj) {
  var objs = $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O(f));
  var this$1 = $m_sc_Seq$();
  var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(objs.$$colon$plus__O__scg_CanBuildFrom__O(newObj, this$1.ReusableCBFInstance$2)), new $c_Lamf_core_parser_Annotations().init___());
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(node);
  return $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this, f, value, annotations))
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.withAbstract__Z__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(isAbstract) {
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$().Abstract$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this, field, isAbstract);
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.literalProperty__Lamf_core_metamodel_Field__s_Option = (function(f) {
  var this$1 = this.fields$1;
  var this$2 = this$1.fs$1.get__O__s_Option(f);
  var pf = new $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement$$anonfun$literalProperty$1().init___Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(this);
  if ((!this$2.isEmpty__Z())) {
    var this$3 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$2.get__O();
    return this$3.apply__O__s_Option(v1)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.setProperty__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__F__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(property, value, entry) {
  var field = property.toField__Lamf_core_metamodel_Field();
  var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(value, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2));
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this, field, value$1, annotations);
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.withDefinedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = (function(nodeMapping) {
  this.instanceDefinedBy$1 = new $c_s_Some().init___O(nodeMapping);
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.definedBy__Lamf_plugins_document_vocabularies_model_domain_NodeMapping = (function() {
  var x1 = this.instanceDefinedBy$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var mapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x2.value$2);
    return mapping
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("NodeMapping for the instance not defined"))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  this.instanceTypes$1 = $m_sci_Nil$();
  this.instanceDefinedBy$1 = $m_s_None$();
  return this
});
function $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.domain.DialectDomainElement"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.domain.DialectDomainElement;", depth))
}
var $d_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement: 0
}, false, "amf.plugins.document.vocabularies.model.domain.DialectDomainElement", {
  Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.Name$1 = null;
  this.MergePolicy$1 = null;
  this.ALLOWED$undMERGE$undPOLICY$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_NodeMapping() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.amf$plugins$document$vocabularies$metamodel$domain$NodeMappableModel$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.MergePolicy__Lamf_core_metamodel_Field = (function() {
  return this.MergePolicy$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$5 = new $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value))
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$()
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.primaryKey__sc_Seq = (function() {
  return $as_sc_Seq($as_sc_SeqLike($as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$1$2);
      var this$1 = $as_Lamf_core_model_BoolField(x$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Unique$1)).option$1;
      return $uZ((this$1.isEmpty__Z() ? false : this$1.get__O()))
    })
  })(this)))).sortBy__F1__s_math_Ordering__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$2$2);
      var this$3 = $as_Lamf_core_model_StrField(x$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
      var this$4 = this$3.option$1;
      return $as_T((this$4.isEmpty__Z() ? null : this$4.get__O()))
    })
  })(this)), $m_s_math_Ordering$String$()))
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O(this.Name$1));
  var this$2 = this$1.option$1;
  var str = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  var this$4 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$5 = this$4.platform$1;
  var url = this$4.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$5, url))
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  var unresolvedNodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(unresolved);
  var linked = $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations);
  if ((supportsRecursion && $is_Lamf_core_model_domain_Linkable(linked))) {
    var this$1 = $as_Lamf_core_model_domain_Linkable(linked);
    var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1;
    $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, supportsRecursion))
  };
  var this$4 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(linked).withId__T__Lamf_core_model_domain_AmfObject(unresolvedNodeMapping.id$1));
  var this$2 = $as_Lamf_core_model_StrField(unresolvedNodeMapping.fields$1.field__Lamf_core_metamodel_Field__O(unresolvedNodeMapping.Name$1));
  var this$3 = this$2.option$1;
  var name = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
  var field$1 = this$4.Name$1;
  return $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field$1, name)))
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.amf$plugins$document$vocabularies$metamodel$domain$MergeableMappingModel$$undsetter$und$MergePolicy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.MergePolicy$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.ALLOWED$undMERGE$undPOLICY__sci_Set = (function() {
  return this.ALLOWED$undMERGE$undPOLICY$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.amf$plugins$document$vocabularies$metamodel$domain$MergeableMappingModel$$undsetter$und$ALLOWED$undMERGE$undPOLICY$und$eq__sci_Set__V = (function(x$1) {
  this.ALLOWED$undMERGE$undPOLICY$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.withName__T__Lamf_plugins_document_vocabularies_model_domain_NodeMappable = (function(name) {
  var field = this.Name$1;
  return $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this, field, name)))
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_metamodel_domain_MergeableMappingModel__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappableModel__$$init$__V(this);
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.Name__Lamf_core_metamodel_Field = (function() {
  return this.Name$1
});
function $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.domain.NodeMapping"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_domain_NodeMapping)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.domain.NodeMapping;", depth))
}
var $d_Lamf_plugins_document_vocabularies_model_domain_NodeMapping = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_NodeMapping: 0
}, false, "amf.plugins.document.vocabularies.model.domain.NodeMapping", {
  Lamf_plugins_document_vocabularies_model_domain_NodeMapping: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_plugins_document_vocabularies_model_domain_MergeableMapping: 1,
  Lamf_plugins_document_vocabularies_metamodel_domain_MergeableMappingModel: 1,
  Lamf_plugins_document_vocabularies_model_domain_NodeMappable: 1,
  Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappableModel: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_NodeMapping;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm() {
  $c_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm.call(this);
  this.fields$2 = null;
  this.annotations$2 = null
}
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm.prototype = new $h_Lamf_plugins_document_vocabularies_model_domain_PropertyTerm();
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm.prototype.productPrefix__T = (function() {
  return "ObjectPropertyTerm"
});
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm)) {
    var ObjectPropertyTerm$1 = $as_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm(x$1);
    var x = this.fields$2;
    var x$2 = ObjectPropertyTerm$1.fields$2;
    if ((x === x$2)) {
      var x$3 = this.annotations$2;
      var x$4 = ObjectPropertyTerm$1.annotations$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$2;
      break
    }
    case 1: {
      return this.annotations$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_vocabularies_metamodel_domain_ObjectPropertyTermModel$()
});
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$2 = fields;
  this.annotations$2 = annotations;
  return this
});
function $as_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.domain.ObjectPropertyTerm"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.domain.ObjectPropertyTerm;", depth))
}
var $d_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm: 0
}, false, "amf.plugins.document.vocabularies.model.domain.ObjectPropertyTerm", {
  Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm: 1,
  Lamf_plugins_document_vocabularies_model_domain_PropertyTerm: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext() {
  $c_Lamf_core_parser_ParserContext.call(this);
  this.dialect$2 = null;
  this.wrapped$2 = null;
  this.ds$2 = null;
  this.isPatch$2 = false;
  this.nestedDialects$2 = null;
  this.libraryDeclarationsNodeMappings$2 = null;
  this.rootDeclarationsNodeMappings$2 = null;
  this.rootProps$2 = null;
  this.declarations$2 = null
}
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext.prototype = new $h_Lamf_core_parser_ParserContext();
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext.prototype = $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext.prototype;
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext.prototype.isIncludeMap__p2__Lorg_yaml_model_YNode__Z = (function(node) {
  if ((node.value__Lorg_yaml_model_YValue() instanceof $c_Lorg_yaml_model_YMap)) {
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
    var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv));
    return new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("$include").isDefined__Z()
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext.prototype.findJsonPointer__T__s_Option = (function(pointer) {
  var x1 = this.globalSpace$1.get__O__s_Option(pointer);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var e = x2.value$2;
    if ((e instanceof $c_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement)) {
      var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_DialectDomainElement(e);
      return new $c_s_Some().init___O(x3)
    }
  };
  return $m_s_None$()
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext.prototype.isInclude__p2__Lorg_yaml_model_YNode__Z = (function(node) {
  var x = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x$2 = $m_Lorg_yaml_model_YType$().Include$1;
  return (x === x$2)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext.prototype.init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_core_parser_ParserContext__s_Option = (function(dialect, wrapped, ds) {
  this.dialect$2 = dialect;
  this.wrapped$2 = wrapped;
  this.ds$2 = ds;
  var jsx$4 = wrapped.rootContextDocument$1;
  var jsx$3 = wrapped.refs$1;
  var jsx$2 = wrapped.futureDeclarations$1;
  var jsx$1 = wrapped.eh$1;
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$5 = new $c_scm_ListBuffer().init___();
  $c_Lamf_core_parser_ParserContext.prototype.init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext.call(this, jsx$4, jsx$3, jsx$2, jsx$1, new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$5.toList__sci_List()));
  this.isPatch$2 = false;
  this.nestedDialects$2 = $m_sci_Nil$();
  this.libraryDeclarationsNodeMappings$2 = this.parseDeclaredNodeMappings__T__sci_Map("library");
  this.rootDeclarationsNodeMappings$2 = this.parseDeclaredNodeMappings__T__sci_Map("root");
  this.rootProps$2 = this.computeRootProps__sci_Set();
  this.globalSpace$1 = wrapped.globalSpace$1;
  if (ds.isEmpty__Z()) {
    var x$1 = this.eh$1;
    var x$2 = this.futureDeclarations$1;
    var x$3 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var jsx$5 = new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations().init___sci_Map__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations(x$3, x$1, x$2)
  } else {
    var jsx$5 = ds.get__O()
  };
  this.declarations$2 = $as_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceDeclarations(jsx$5);
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext.prototype.link__Lorg_yaml_model_YNode__s_util_Either = (function(node) {
  if (this.isInclude__p2__Lorg_yaml_model_YNode__Z(node)) {
    $m_s_package$();
    var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
    var value = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).text$3;
    return new $c_s_util_Left().init___O(value)
  } else if (this.isIncludeMap__p2__Lorg_yaml_model_YNode__Z(node)) {
    $m_s_package$();
    var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$1 = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
    var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$1, iv$1));
    var this$3 = $as_Lorg_yaml_model_YMapEntry(new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("$include").get__O()).value$2;
    var conversion$2 = $m_Lorg_yaml_convert_YRead$StringYRead$();
    var iv$2 = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
    var value$1 = $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion$2, iv$2);
    return new $c_s_util_Left().init___O(value$1)
  } else {
    $m_s_package$();
    return new $c_s_util_Right().init___O(node)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext.prototype.forPatch__Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext = (function() {
  this.isPatch$2 = true;
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext.prototype.findNodeMapping__T__s_Option = (function(mappingId) {
  var this$1 = this.dialect$2;
  var this$2 = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Declares$1));
  var pf = new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$findNodeMapping$1().init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext__T(this, mappingId);
  return $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$2, pf)
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext.prototype.computeRootProps__sci_Set = (function() {
  var jsx$1 = $m_s_Option$();
  var this$1 = this.dialect$2;
  var this$2 = jsx$1.apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1)));
  if (this$2.isEmpty__Z()) {
    var x1 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var x$1 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(arg1);
    var x1 = $as_Lamf_core_model_StrField(x$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().DeclarationsPath$1)).option$1
  };
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var declarationsPath = $as_T(x2.value$2);
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(declarationsPath, "/", 0);
    var this$5 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    var array = [$as_T($f_sc_IndexedSeqOptimized__head__O(this$5))];
    if (($uI(array.length) === 0)) {
      var jsx$2 = $m_sci_Set$EmptySet$()
    } else {
      var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
      var i = 0;
      var len = $uI(array.length);
      while ((i < len)) {
        var index = i;
        var arg1$1 = array[index];
        b.$$plus$eq__O__scm_SetBuilder(arg1$1);
        i = ((1 + i) | 0)
      };
      var jsx$2 = b.elems$1
    };
    var declarationProps = $as_sci_Set(jsx$2)
  } else {
    var jsx$8 = $m_s_Option$();
    var this$9 = this.dialect$2;
    var this$10 = jsx$8.apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(this$9.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1)));
    if (this$10.isEmpty__Z()) {
      var this$11 = $m_s_None$()
    } else {
      var arg1$2 = this$10.get__O();
      var d = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(arg1$2);
      var this$11 = $m_s_Option$().apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(d.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Root$1)))
    };
    if (this$11.isEmpty__Z()) {
      var this$15 = $m_s_None$()
    } else {
      var arg1$3 = this$11.get__O();
      var x$2 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(arg1$3);
      var jsx$10 = $as_sc_Seq(x$2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DeclaredNodes$1));
      var jsx$9 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x$3$2) {
          var x$3 = $as_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping(x$3$2);
          var this$12 = $as_Lamf_core_model_StrField(x$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().Name$1));
          var this$13 = this$12.option$1;
          return $as_T((this$13.isEmpty__Z() ? null : this$13.get__O()))
        })
      })(this));
      var this$14 = $m_sc_Seq$();
      var this$15 = new $c_s_Some().init___O($as_sc_Seq(jsx$10.map__F1__scg_CanBuildFrom__O(jsx$9, this$14.ReusableCBFInstance$2)))
    };
    var jsx$7 = $as_sc_TraversableLike((this$15.isEmpty__Z() ? $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())) : this$15.get__O()));
    var jsx$4 = $m_s_Option$();
    var this$16 = this.dialect$2;
    var this$17 = jsx$4.apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(this$16.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1)));
    if (this$17.isEmpty__Z()) {
      var this$18 = $m_s_None$()
    } else {
      var arg1$4 = this$17.get__O();
      var d$3 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(arg1$4);
      var this$18 = $m_s_Option$().apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(d$3.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Library$1)))
    };
    if (this$18.isEmpty__Z()) {
      var this$22 = $m_s_None$()
    } else {
      var arg1$5 = this$18.get__O();
      var x$4 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(arg1$5);
      var jsx$6 = $as_sc_Seq(x$4.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DeclaredNodes$1));
      var jsx$5 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
        return (function(x$5$2) {
          var x$5 = $as_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping(x$5$2);
          var this$19 = $as_Lamf_core_model_StrField(x$5.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().Name$1));
          var this$20 = this$19.option$1;
          return $as_T((this$20.isEmpty__Z() ? null : this$20.get__O()))
        })
      })(this));
      var this$21 = $m_sc_Seq$();
      var this$22 = new $c_s_Some().init___O($as_sc_Seq(jsx$6.map__F1__scg_CanBuildFrom__O(jsx$5, this$21.ReusableCBFInstance$2)))
    };
    var jsx$3 = $as_sc_GenTraversableOnce((this$22.isEmpty__Z() ? $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())) : this$22.get__O()));
    var this$23 = $m_sc_Seq$();
    var declarationProps = $as_sc_TraversableOnce(jsx$7.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$23.ReusableCBFInstance$2)).toSet__sci_Set()
  };
  var jsx$11 = $m_sc_Seq$();
  var array$1 = ["uses", "external"];
  return $as_sci_Set(declarationProps.$$plus$plus__sc_GenTraversableOnce__sc_Set($as_sc_TraversableOnce(jsx$11.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1))).toSet__sci_Set()))
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext.prototype.parseDeclaredNodeMappings__T__sci_Map = (function(documentType) {
  var jsx$1 = $m_s_Option$();
  var this$1 = this.dialect$2;
  var this$2 = jsx$1.apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1)));
  if (this$2.isEmpty__Z()) {
    var this$10 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var documents = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(arg1);
    var documentMappings = ((documentType === "root") ? $m_s_Option$().apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(documents.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Root$1))) : $m_s_Option$().apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(documents.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Library$1))));
    if (documentMappings.isEmpty__Z()) {
      var this$10 = $m_s_None$()
    } else {
      var arg1$1 = documentMappings.get__O();
      var mapping = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(arg1$1);
      var jsx$5 = $as_sc_Seq(mapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DeclaredNodes$1));
      var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(declaration$2) {
          var declaration = $as_Lamf_plugins_document_vocabularies_model_domain_PublicNodeMapping(declaration$2);
          var this$3 = $as_Lamf_core_model_StrField(declaration.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().MappedNode$1));
          var this$4 = this$3.option$1;
          var this$5 = $this.findNodeMapping__T__s_Option($as_T((this$4.isEmpty__Z() ? null : this$4.get__O())));
          if (this$5.isEmpty__Z()) {
            return $m_s_None$()
          } else {
            var arg1$2 = this$5.get__O();
            var nodeMapping = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(arg1$2);
            var this$6 = $as_Lamf_core_model_StrField(declaration.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PublicNodeMappingModel$().Name$1));
            var this$7 = this$6.option$1;
            return new $c_s_Some().init___O(new $c_T2().init___O__O($as_T((this$7.isEmpty__Z() ? null : this$7.get__O())), nodeMapping))
          }
        })
      })(this));
      var this$8 = $m_sc_Seq$();
      var jsx$3 = $as_sc_TraversableLike(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$4, this$8.ReusableCBFInstance$2));
      var jsx$2 = new $c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext$$anonfun$$nestedInanonfun$parseDeclaredNodeMappings$2$1().init___Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext(this);
      var this$9 = $m_sc_Seq$();
      var this$10 = new $c_s_Some().init___O($as_sc_Seq(jsx$3.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$2, this$9.ReusableCBFInstance$2)))
    }
  };
  var declarations = $as_sc_Seq((this$10.isEmpty__Z() ? $m_sci_Nil$() : this$10.get__O()));
  return $as_sci_Map(declarations.foldLeft__O__F2__O($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()), new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function(this$3$1) {
    return (function(x0$1$2, x1$1$2) {
      var x0$1 = $as_sci_Map(x0$1$2);
      var x1$1 = $as_T2(x1$1$2);
      var x1 = new $c_T2().init___O__O(x0$1, x1$1);
      var acc = $as_sci_Map(x1.$$und1$f);
      var p2 = $as_T2(x1.$$und2$f);
      if ((p2 !== null)) {
        var name = $as_T(p2.$$und1__O());
        var mapping$1 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable(p2.$$und2__O());
        return acc.$$plus__T2__sci_Map(new $c_T2().init___O__O(name, mapping$1))
      };
      throw new $c_s_MatchError().init___O(x1)
    })
  })(this))))
});
var $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext: 0
}, false, "amf.plugins.document.vocabularies.parser.instances.DialectInstanceContext", {
  Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext: 1,
  Lamf_core_parser_ParserContext: 1,
  O: 1,
  Lorg_yaml_model_ParseErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter: 1
});
$c_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_instances_DialectInstanceContext;
/** @constructor */
function $c_Lamf_plugins_document_webapi_Raml08Plugin$() {
  $c_Lamf_client_plugins_AMFDocumentPlugin.call(this);
  this.validationProfile$2 = null;
  this.vendors$2 = null;
  this.ID$2 = null;
  this.allowRecursiveReferences$2 = false;
  this.aggregatedReport$2 = null;
  this.defaultValidationProfiles$2 = null;
  this.platform$2 = null
}
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype = new $h_Lamf_client_plugins_AMFDocumentPlugin();
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.constructor = $c_Lamf_plugins_document_webapi_Raml08Plugin$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_Raml08Plugin$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_Raml08Plugin$.prototype = $c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype;
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.init__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  return $m_s_concurrent_Future$().successful__O__s_concurrent_Future(this)
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.init___ = (function() {
  $c_Lamf_client_plugins_AMFDocumentPlugin.prototype.init___.call(this);
  $n_Lamf_plugins_document_webapi_Raml08Plugin$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$2 = this$1.platform$1;
  $f_Lamf_plugins_document_webapi_validation_WebApiValidations__$$init$__V(this);
  $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__$$init$__V(this);
  $f_Lamf_plugins_document_webapi_RamlPlugin__$$init$__V(this);
  this.validationProfile$2 = $m_Lamf_Raml08Profile$();
  return this
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.amf$plugins$document$webapi$RamlPlugin$$undsetter$und$vendors$und$eq__sc_Seq__V = (function(x$1) {
  this.vendors$2 = x$1
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.unparseAsYDocument__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__s_Option = (function(unit, renderOptions, shapeRenderOptions) {
  if ((unit instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(unit);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter().init___Lamf_core_model_document_BaseUnit__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x2, new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_core_emitter_ShapeRenderOptions(renderOptions.eh$1, new $c_Lamf_core_emitter_ShapeRenderOptions().init___())).emitDocument__Lorg_yaml_model_YDocument())
  } else if ($is_Lamf_core_model_document_Fragment(unit)) {
    var x3 = $as_Lamf_core_model_document_Fragment(unit);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter().init___Lamf_core_model_document_Fragment__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x3, new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml08SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_core_emitter_ShapeRenderOptions(renderOptions.eh$1, new $c_Lamf_core_emitter_ShapeRenderOptions().init___())).emitFragment__Lorg_yaml_model_YDocument())
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.context$default$4__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.canUnparse__Lamf_core_model_document_BaseUnit__Z = (function(unit) {
  if ((!(unit instanceof $c_Lamf_plugins_document_webapi_model_Overlay))) {
    if ((!(unit instanceof $c_Lamf_plugins_document_webapi_model_Extension))) {
      if ((unit instanceof $c_Lamf_core_model_document_Document)) {
        var x4 = $as_Lamf_core_model_document_Document(unit);
        return (x4.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)
      } else {
        return ((!(unit instanceof $c_Lamf_core_model_document_Module)) && ((unit instanceof $c_Lamf_plugins_document_webapi_model_DocumentationItemFragment) || ((unit instanceof $c_Lamf_plugins_document_webapi_model_DataTypeFragment) || ((unit instanceof $c_Lamf_plugins_document_webapi_model_NamedExampleFragment) || ((unit instanceof $c_Lamf_plugins_document_webapi_model_ResourceTypeFragment) || ((unit instanceof $c_Lamf_plugins_document_webapi_model_TraitFragment) || ((unit instanceof $c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment) || ((unit instanceof $c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment) || (unit instanceof $c_Lamf_core_model_document_ExternalFragment)))))))))
      }
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option = (function(root, parentContext, platform, options) {
  return $f_Lamf_plugins_document_webapi_RamlPlugin__parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option(this, root, parentContext, platform, options)
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.vendor__Lamf_core_remote_Vendor = (function() {
  return $m_Lamf_core_remote_Raml08$()
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.modelEntities__sc_Seq = (function() {
  return $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__modelEntities__sc_Seq(this)
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.amf$plugins$document$webapi$validation$WebApiValidations$$undsetter$und$defaultValidationProfiles$und$eq__sci_Map__V = (function(x$1) {
  this.defaultValidationProfiles$2 = x$1
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.documentSyntaxes__sc_Seq = (function() {
  return $f_Lamf_plugins_document_webapi_RamlPlugin__documentSyntaxes__sc_Seq(this)
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.referenceHandler__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_ReferenceHandler = (function(eh) {
  return new $c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler().init___T__Lamf_plugins_document_webapi_BaseWebApiPlugin(this.ID$2, this)
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.vendors__sc_Seq = (function() {
  return this.vendors$2
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.ID__T = (function() {
  return this.ID$2
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.amf$plugins$document$webapi$BaseWebApiPlugin$$undsetter$und$allowRecursiveReferences$und$eq__Z__V = (function(x$1) {
  this.allowRecursiveReferences$2 = x$1
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.domainValidationProfiles__Lamf_core_remote_Platform__sci_Map = (function(platform) {
  var this$1 = this.defaultValidationProfiles$2;
  var p = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_T(x$1$2);
      return (x$1 === $m_Lamf_plugins_document_webapi_Raml08Plugin$().validationProfile$2.p$1)
    })
  })(this));
  return new $c_sci_MapLike$$anon$1().init___sci_MapLike__F1(this$1, p)
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.validationProfile__Lamf_ProfileName = (function() {
  return this.validationProfile$2
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.aggregatedReport$und$eq__sci_List__V = (function(x$1) {
  this.aggregatedReport$2 = x$1
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.dependencies__sc_Seq = (function() {
  return $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__dependencies__sc_Seq(this)
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.context__Lamf_core_parser_ParserContext__Lamf_core_Root__Lamf_core_client_ParsingOptions__s_Option__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(wrapped, root, options, ds) {
  var x$1 = root.location$1;
  var jsx$2 = root.references$1;
  var jsx$1 = wrapped.refs$1;
  var this$1 = $m_sc_Seq$();
  var x$2 = $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  if (ds.isEmpty__Z()) {
    var x$4 = $m_s_None$()
  } else {
    var arg1 = ds.get__O();
    var d = $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(arg1);
    var x$4 = new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$().apply__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations(d))
  };
  var x$6 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2;
  return new $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions(x$1, x$2, wrapped, x$4, x$6, options)
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.validationRequest__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_validation_EffectiveValidations__Lamf_core_remote_Platform__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future = (function(baseUnit, profile, validations, platform, env, resolved, executionEnv) {
  return $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__validationRequest__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_validation_EffectiveValidations__Lamf_core_remote_Platform__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(this, baseUnit, profile, validations, platform, env, resolved, executionEnv)
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.canParse__Lamf_core_Root__Z = (function(root) {
  var this$1 = $m_Lamf_plugins_document_webapi_parser_RamlHeader$().apply__Lamf_core_Root__s_Option(root);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var x0$1 = $as_Lamf_plugins_document_webapi_parser_RamlHeader(arg1);
    var x = $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml08$();
    if (x.equals__O__Z(x0$1)) {
      return true
    } else {
      return $is_Lamf_plugins_document_webapi_parser_RamlFragment(x0$1)
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.serializableAnnotations__sci_Map = (function() {
  return $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__serializableAnnotations__sci_Map(this)
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.allowRecursiveReferences__Z = (function() {
  return this.allowRecursiveReferences$2
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.amf$plugins$document$webapi$BaseWebApiPlugin$$undsetter$und$ID$und$eq__T__V = (function(x$1) {
  this.ID$2 = x$1
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_errorhandling_ErrorHandler__T__Lamf_core_model_document_BaseUnit = (function(unit, errorHandler, pipelineId) {
  return (($m_Lamf_core_resolution_pipelines_ResolutionPipeline$().DEFAULT$undPIPELINE$1 === pipelineId) ? new $c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08ResolutionPipeline().init___Lamf_core_errorhandling_ErrorHandler(errorHandler).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit) : (($m_Lamf_core_resolution_pipelines_ResolutionPipeline$().EDITING$undPIPELINE$1 === pipelineId) ? new $c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08EditingPipeline().init___Lamf_core_errorhandling_ErrorHandler__Z(errorHandler, true).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit) : (($m_Lamf_core_resolution_pipelines_ResolutionPipeline$().CACHE$undPIPELINE$1 === pipelineId) ? new $c_Lamf_plugins_document_webapi_resolution_pipelines_Raml08EditingPipeline().init___Lamf_core_errorhandling_ErrorHandler__Z(errorHandler, false).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit) : $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__resolve__Lamf_core_model_document_BaseUnit__Lamf_core_errorhandling_ErrorHandler__T__Lamf_core_model_document_BaseUnit(this, unit, errorHandler, pipelineId))))
});
var $d_Lamf_plugins_document_webapi_Raml08Plugin$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_Raml08Plugin$: 0
}, false, "amf.plugins.document.webapi.Raml08Plugin$", {
  Lamf_plugins_document_webapi_Raml08Plugin$: 1,
  Lamf_client_plugins_AMFDocumentPlugin: 1,
  O: 1,
  Lamf_client_plugins_AMFPlugin: 1,
  Lamf_plugins_document_webapi_RamlPlugin: 1,
  Lamf_plugins_document_webapi_BaseWebApiPlugin: 1,
  Lamf_client_plugins_AMFValidationPlugin: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_validation_WebApiValidations: 1,
  Lamf_core_validation_ValidationResultProcessor: 1
});
$c_Lamf_plugins_document_webapi_Raml08Plugin$.prototype.$classData = $d_Lamf_plugins_document_webapi_Raml08Plugin$;
var $n_Lamf_plugins_document_webapi_Raml08Plugin$ = (void 0);
function $m_Lamf_plugins_document_webapi_Raml08Plugin$() {
  if ((!$n_Lamf_plugins_document_webapi_Raml08Plugin$)) {
    $n_Lamf_plugins_document_webapi_Raml08Plugin$ = new $c_Lamf_plugins_document_webapi_Raml08Plugin$().init___()
  };
  return $n_Lamf_plugins_document_webapi_Raml08Plugin$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_Raml10Plugin$() {
  $c_Lamf_client_plugins_AMFDocumentPlugin.call(this);
  this.validationProfile$2 = null;
  this.vendors$2 = null;
  this.ID$2 = null;
  this.allowRecursiveReferences$2 = false;
  this.aggregatedReport$2 = null;
  this.defaultValidationProfiles$2 = null;
  this.platform$2 = null
}
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype = new $h_Lamf_client_plugins_AMFDocumentPlugin();
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.constructor = $c_Lamf_plugins_document_webapi_Raml10Plugin$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_Raml10Plugin$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_Raml10Plugin$.prototype = $c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype;
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.init__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  return $m_s_concurrent_Future$().successful__O__s_concurrent_Future(this)
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.init___ = (function() {
  $c_Lamf_client_plugins_AMFDocumentPlugin.prototype.init___.call(this);
  $n_Lamf_plugins_document_webapi_Raml10Plugin$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$2 = this$1.platform$1;
  $f_Lamf_plugins_document_webapi_validation_WebApiValidations__$$init$__V(this);
  $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__$$init$__V(this);
  $f_Lamf_plugins_document_webapi_RamlPlugin__$$init$__V(this);
  this.validationProfile$2 = $m_Lamf_RamlProfile$();
  return this
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.amf$plugins$document$webapi$RamlPlugin$$undsetter$und$vendors$und$eq__sc_Seq__V = (function(x$1) {
  this.vendors$2 = x$1
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.unparseAsYDocument__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__s_Option = (function(unit, renderOptions, shapeRenderOptions) {
  if ((unit instanceof $c_Lamf_core_model_document_Module)) {
    var x2 = $as_Lamf_core_model_document_Module(unit);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleEmitter().init___Lamf_core_model_document_Module__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x2, new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(renderOptions.eh$1, $m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$(), new $c_Lamf_core_emitter_ShapeRenderOptions().init___())).emitModule__Lorg_yaml_model_YDocument())
  } else if ((unit instanceof $c_Lamf_core_model_document_Document)) {
    var x3 = $as_Lamf_core_model_document_Document(unit);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentEmitter().init___Lamf_core_model_document_BaseUnit__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x3, new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(renderOptions.eh$1, $m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$(), new $c_Lamf_core_emitter_ShapeRenderOptions().init___())).emitDocument__Lorg_yaml_model_YDocument())
  } else if ((unit instanceof $c_Lamf_core_model_document_ExternalFragment)) {
    var x4 = $as_Lamf_core_model_document_ExternalFragment(unit);
    var jsx$1 = $m_Lorg_yaml_model_YNode$();
    var this$7 = $as_Lamf_core_model_domain_ExternalDomainElement($as_Lamf_core_model_domain_DomainElement(x4.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)));
    var this$8 = $as_Lamf_core_model_StrField(this$7.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1));
    var this$9 = this$8.option$1;
    var x$1 = jsx$1.apply__T__Lorg_yaml_model_YNode($as_T((this$9.isEmpty__Z() ? null : this$9.get__O())));
    return new $c_s_Some().init___O($m_Lorg_yaml_model_YDocument$().apply__Lorg_yaml_model_YNode__T__Lorg_yaml_model_YDocument(x$1, ""))
  } else if ($is_Lamf_core_model_document_Fragment(unit)) {
    var x5 = $as_Lamf_core_model_document_Fragment(unit);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentEmitter().init___Lamf_core_model_document_Fragment__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext(x5, new $c_Lamf_plugins_document_webapi_contexts_emitter_raml_Raml10SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(renderOptions.eh$1, $m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlRefEmitter$(), new $c_Lamf_core_emitter_ShapeRenderOptions().init___())).emitFragment__Lorg_yaml_model_YDocument())
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.context$default$4__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.canUnparse__Lamf_core_model_document_BaseUnit__Z = (function(unit) {
  if ((unit instanceof $c_Lamf_plugins_document_webapi_model_Overlay)) {
    return true
  } else if ((unit instanceof $c_Lamf_plugins_document_webapi_model_Extension)) {
    return true
  } else if ((unit instanceof $c_Lamf_core_model_document_Document)) {
    var x4 = $as_Lamf_core_model_document_Document(unit);
    return (x4.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)
  } else {
    return ((unit instanceof $c_Lamf_core_model_document_Module) || ((unit instanceof $c_Lamf_plugins_document_webapi_model_DocumentationItemFragment) || ((unit instanceof $c_Lamf_plugins_document_webapi_model_DataTypeFragment) || ((unit instanceof $c_Lamf_plugins_document_webapi_model_NamedExampleFragment) || ((unit instanceof $c_Lamf_plugins_document_webapi_model_ResourceTypeFragment) || ((unit instanceof $c_Lamf_plugins_document_webapi_model_TraitFragment) || ((unit instanceof $c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment) || ((unit instanceof $c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment) || (unit instanceof $c_Lamf_core_model_document_ExternalFragment)))))))))
  }
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option = (function(root, parentContext, platform, options) {
  return $f_Lamf_plugins_document_webapi_RamlPlugin__parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option(this, root, parentContext, platform, options)
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.vendor__Lamf_core_remote_Vendor = (function() {
  return $m_Lamf_core_remote_Raml10$()
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.modelEntities__sc_Seq = (function() {
  return $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__modelEntities__sc_Seq(this)
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.amf$plugins$document$webapi$validation$WebApiValidations$$undsetter$und$defaultValidationProfiles$und$eq__sci_Map__V = (function(x$1) {
  this.defaultValidationProfiles$2 = x$1
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.documentSyntaxes__sc_Seq = (function() {
  return $f_Lamf_plugins_document_webapi_RamlPlugin__documentSyntaxes__sc_Seq(this)
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.referenceHandler__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_ReferenceHandler = (function(eh) {
  return new $c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler().init___T__Lamf_plugins_document_webapi_BaseWebApiPlugin(this.ID$2, this)
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.vendors__sc_Seq = (function() {
  return this.vendors$2
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.ID__T = (function() {
  return this.ID$2
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.amf$plugins$document$webapi$BaseWebApiPlugin$$undsetter$und$allowRecursiveReferences$und$eq__Z__V = (function(x$1) {
  this.allowRecursiveReferences$2 = x$1
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.domainValidationProfiles__Lamf_core_remote_Platform__sci_Map = (function(platform) {
  var this$1 = this.defaultValidationProfiles$2;
  var p = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(k$2) {
      var k = $as_T(k$2);
      return (((k === $m_Lamf_Raml10Profile$().p$1) || (k === $m_Lamf_RamlProfile$().p$1)) || (k === $m_Lamf_AmfProfile$().p$1))
    })
  })(this));
  return new $c_sci_MapLike$$anon$1().init___sci_MapLike__F1(this$1, p)
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.validationProfile__Lamf_ProfileName = (function() {
  return this.validationProfile$2
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.aggregatedReport$und$eq__sci_List__V = (function(x$1) {
  this.aggregatedReport$2 = x$1
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.dependencies__sc_Seq = (function() {
  return $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__dependencies__sc_Seq(this)
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.context__Lamf_core_parser_ParserContext__Lamf_core_Root__Lamf_core_client_ParsingOptions__s_Option__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(wrapped, root, options, ds) {
  var x$1 = root.location$1;
  var jsx$2 = root.references$1;
  var jsx$1 = wrapped.refs$1;
  var this$1 = $m_sc_Seq$();
  var x$2 = $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  if (ds.isEmpty__Z()) {
    var x$4 = $m_s_None$()
  } else {
    var arg1 = ds.get__O();
    var d = $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(arg1);
    var x$4 = new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations$().apply__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations(d))
  };
  var x$6 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2;
  return new $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions(x$1, x$2, wrapped, x$4, x$6, options)
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.validationRequest__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_validation_EffectiveValidations__Lamf_core_remote_Platform__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future = (function(baseUnit, profile, validations, platform, env, resolved, executionEnv) {
  return $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__validationRequest__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_validation_EffectiveValidations__Lamf_core_remote_Platform__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(this, baseUnit, profile, validations, platform, env, resolved, executionEnv)
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.canParse__Lamf_core_Root__Z = (function(root) {
  var this$1 = $m_Lamf_plugins_document_webapi_parser_RamlHeader$().apply__Lamf_core_Root__s_Option(root);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var x0$1 = $as_Lamf_plugins_document_webapi_parser_RamlHeader(arg1);
    var x = $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10$();
    if (x.equals__O__Z(x0$1)) {
      var jsx$1 = true
    } else {
      var x$3 = $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Overlay$();
      if (x$3.equals__O__Z(x0$1)) {
        var jsx$1 = true
      } else {
        var x$5 = $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Extension$();
        if (x$5.equals__O__Z(x0$1)) {
          var jsx$1 = true
        } else {
          var x$7 = $m_Lamf_plugins_document_webapi_parser_RamlHeader$Raml10Library$();
          var jsx$1 = x$7.equals__O__Z(x0$1)
        }
      }
    };
    if (jsx$1) {
      return true
    } else {
      var x$9 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$();
      if (x$9.equals__O__Z(x0$1)) {
        return true
      } else {
        var x$11 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$();
        if (x$11.equals__O__Z(x0$1)) {
          return true
        } else {
          var x$13 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$();
          if (x$13.equals__O__Z(x0$1)) {
            return true
          } else {
            var x$15 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$();
            if (x$15.equals__O__Z(x0$1)) {
              return true
            } else {
              var x$17 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$();
              if (x$17.equals__O__Z(x0$1)) {
                return true
              } else {
                var x$19 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$();
                if (x$19.equals__O__Z(x0$1)) {
                  return true
                } else {
                  var x$21 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$();
                  return x$21.equals__O__Z(x0$1)
                }
              }
            }
          }
        }
      }
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.serializableAnnotations__sci_Map = (function() {
  return $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__serializableAnnotations__sci_Map(this)
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.allowRecursiveReferences__Z = (function() {
  return this.allowRecursiveReferences$2
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.amf$plugins$document$webapi$BaseWebApiPlugin$$undsetter$und$ID$und$eq__T__V = (function(x$1) {
  this.ID$2 = x$1
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_errorhandling_ErrorHandler__T__Lamf_core_model_document_BaseUnit = (function(unit, errorHandler, pipelineId) {
  return (($m_Lamf_core_resolution_pipelines_ResolutionPipeline$().DEFAULT$undPIPELINE$1 === pipelineId) ? new $c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10ResolutionPipeline().init___Lamf_core_errorhandling_ErrorHandler(errorHandler).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit) : (($m_Lamf_core_resolution_pipelines_ResolutionPipeline$().EDITING$undPIPELINE$1 === pipelineId) ? new $c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10EditingPipeline().init___Lamf_core_errorhandling_ErrorHandler__Z(errorHandler, true).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit) : (($m_Lamf_core_resolution_pipelines_ResolutionPipeline$().COMPATIBILITY$undPIPELINE$1 === pipelineId) ? new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_CompatibilityPipeline().init___Lamf_core_errorhandling_ErrorHandler__Lamf_ProfileName(errorHandler, $m_Lamf_RamlProfile$()).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit) : (($m_Lamf_core_resolution_pipelines_ResolutionPipeline$().CACHE$undPIPELINE$1 === pipelineId) ? new $c_Lamf_plugins_document_webapi_resolution_pipelines_Raml10EditingPipeline().init___Lamf_core_errorhandling_ErrorHandler__Z(errorHandler, false).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit) : $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__resolve__Lamf_core_model_document_BaseUnit__Lamf_core_errorhandling_ErrorHandler__T__Lamf_core_model_document_BaseUnit(this, unit, errorHandler, pipelineId)))))
});
var $d_Lamf_plugins_document_webapi_Raml10Plugin$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_Raml10Plugin$: 0
}, false, "amf.plugins.document.webapi.Raml10Plugin$", {
  Lamf_plugins_document_webapi_Raml10Plugin$: 1,
  Lamf_client_plugins_AMFDocumentPlugin: 1,
  O: 1,
  Lamf_client_plugins_AMFPlugin: 1,
  Lamf_plugins_document_webapi_RamlPlugin: 1,
  Lamf_plugins_document_webapi_BaseWebApiPlugin: 1,
  Lamf_client_plugins_AMFValidationPlugin: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_validation_WebApiValidations: 1,
  Lamf_core_validation_ValidationResultProcessor: 1
});
$c_Lamf_plugins_document_webapi_Raml10Plugin$.prototype.$classData = $d_Lamf_plugins_document_webapi_Raml10Plugin$;
var $n_Lamf_plugins_document_webapi_Raml10Plugin$ = (void 0);
function $m_Lamf_plugins_document_webapi_Raml10Plugin$() {
  if ((!$n_Lamf_plugins_document_webapi_Raml10Plugin$)) {
    $n_Lamf_plugins_document_webapi_Raml10Plugin$ = new $c_Lamf_plugins_document_webapi_Raml10Plugin$().init___()
  };
  return $n_Lamf_plugins_document_webapi_Raml10Plugin$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance() {
  $c_O.call(this);
  this.baseId$1 = null;
  this.baseLocation$1 = null;
  this.name$1 = null;
  this.value$1 = null;
  this.uris$1 = null
}
$c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_ExtensionProvenance() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_ExtensionProvenance.prototype = $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance.prototype;
$c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance.prototype.productPrefix__T = (function() {
  return "ExtensionProvenance"
});
$c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance)) {
    var ExtensionProvenance$1 = $as_Lamf_plugins_document_webapi_annotations_ExtensionProvenance(x$1);
    if ((this.baseId$1 === ExtensionProvenance$1.baseId$1)) {
      var x = this.baseLocation$1;
      var x$2 = ExtensionProvenance$1.baseLocation$1;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.baseId$1;
      break
    }
    case 1: {
      return this.baseLocation$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance.prototype.init___T__s_Option = (function(baseId, baseLocation) {
  this.baseId$1 = baseId;
  this.baseLocation$1 = baseLocation;
  this.name$1 = "extension-provenance";
  if (baseLocation.isEmpty__Z()) {
    var this$1 = $m_s_None$()
  } else {
    var arg1 = baseLocation.get__O();
    var x$1 = $as_T(arg1);
    var this$1 = new $c_s_Some().init___O((",location->" + x$1))
  };
  this.value$1 = (("id->" + baseId) + (this$1.isEmpty__Z() ? "" : this$1.get__O()));
  var jsx$1 = $m_sc_Seq$();
  var array = [baseId];
  this.uris$1 = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return this
});
$c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance.prototype.shorten__F1__Lamf_core_model_domain_Annotation = (function(fn) {
  return new $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance().init___T__s_Option($as_T(fn.apply__O__O(this.baseId$1)), this.baseLocation$1)
});
function $as_Lamf_plugins_document_webapi_annotations_ExtensionProvenance(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.ExtensionProvenance"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_ExtensionProvenance(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_ExtensionProvenance)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_ExtensionProvenance(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_ExtensionProvenance(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.ExtensionProvenance;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_ExtensionProvenance = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_ExtensionProvenance: 0
}, false, "amf.plugins.document.webapi.annotations.ExtensionProvenance", {
  Lamf_plugins_document_webapi_annotations_ExtensionProvenance: 1,
  O: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_UriAnnotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_ExtensionProvenance.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_ExtensionProvenance;
/** @constructor */
function $c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema() {
  $c_O.call(this);
  this.rawText$1 = null;
  this.name$1 = null;
  this.value$1 = null
}
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.prototype.constructor = $c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema;
/** @constructor */
function $h_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.prototype = $c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.prototype;
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.prototype.productPrefix__T = (function() {
  return "ParsedJSONSchema"
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema)) {
    var ParsedJSONSchema$1 = $as_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema(x$1);
    return (this.rawText$1 === ParsedJSONSchema$1.rawText$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.rawText$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.prototype.init___T = (function(rawText) {
  this.rawText$1 = rawText;
  this.name$1 = "parsed-json-schema";
  this.value$1 = rawText;
  return this
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.annotations.ParsedJSONSchema"))
}
function $isArrayOf_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_annotations_ParsedJSONSchema)))
}
function $asArrayOf_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.annotations.ParsedJSONSchema;", depth))
}
var $d_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema = new $TypeData().initClass({
  Lamf_plugins_document_webapi_annotations_ParsedJSONSchema: 0
}, false, "amf.plugins.document.webapi.annotations.ParsedJSONSchema", {
  Lamf_plugins_document_webapi_annotations_ParsedJSONSchema: 1,
  O: 1,
  Lamf_core_model_domain_EternalSerializedAnnotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema.prototype.$classData = $d_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory() {
  $c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory.call(this);
  this.spec$3 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory.prototype = new $h_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory();
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory.prototype.productPrefix__T = (function() {
  return "Oas3SpecEmitterFactory"
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory)) {
    var Oas3SpecEmitterFactory$1 = $as_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory(x$1);
    var x = this.spec$3;
    var x$2 = Oas3SpecEmitterFactory$1.spec$3;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.spec$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory.prototype.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function() {
  return this.spec$3
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory.prototype.init___Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(spec) {
  this.spec$3 = spec;
  $c_Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory.prototype.init___Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.call(this, spec);
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory.prototype.serversEmitter__Lamf_plugins_domain_webapi_models_Operation__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter = (function(operation, f, ordering, references) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3OperationServersEmitter().init___Lamf_plugins_domain_webapi_models_Operation__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(operation, f, ordering, references, this.spec$3)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory.prototype.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function() {
  return this.spec$3
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory.prototype.securitySchemesEmitters__sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_parser_spec_oas_emitters_OasSecuritySchemesEmitters = (function(securitySchemes, ordering) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_oas_emitters_Oas3SecuritySchemesEmitters().init___sc_Seq__Lamf_core_emitter_SpecOrdering__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(securitySchemes, ordering, this.spec$3)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory.prototype.serversEmitter__Lamf_plugins_domain_webapi_models_WebApi__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_parser_spec_domain_OasServersEmitter = (function(api, f, ordering, references) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3WebApiServersEmitter().init___Lamf_plugins_domain_webapi_models_WebApi__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(api, f, ordering, references, this.spec$3)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.emitter.oas.Oas3SpecEmitterFactory"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.emitter.oas.Oas3SpecEmitterFactory;", depth))
}
var $d_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.oas.Oas3SpecEmitterFactory", {
  Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory: 1,
  Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory: 1,
  Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_SpecEmitterFactory: 1,
  Lamf_plugins_document_webapi_contexts_emitter_oas_OasCompactEmitterFactory: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterFactory;
/** @constructor */
function $c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.fields$1 = null;
  this.Declares$1 = null;
  this.Encodes$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null
}
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.constructor = $c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_metamodel_ExtensionModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype = $c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype;
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_metamodel_ExtensionModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_ModuleModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_DocumentModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_ExtensionLikeModel__$$init$__V(this);
  $m_sci_List$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "Extension")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_document_DocumentModel$().type$1;
  var this$7 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Extension", "API spec information designed to be applied and compelement the information of a base specification. RAML extensions and overlays are examples of extensions.", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.amf$core$metamodel$document$DocumentModel$$undsetter$und$fields$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.Extends__Lamf_core_metamodel_Field = (function() {
  return this.Extends$1
});
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.amf$core$metamodel$document$ExtensionLikeModel$$undsetter$und$Extends$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Extends$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.Declares__Lamf_core_metamodel_Field = (function() {
  return this.Declares$1
});
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.amf$core$metamodel$document$ModuleModel$$undsetter$und$Declares$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Declares$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_webapi_model_Extension().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.Encodes__Lamf_core_metamodel_Field = (function() {
  return this.Encodes$1
});
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.amf$core$metamodel$document$ExtensionLikeModel$$undsetter$und$fields$und$eq__sci_List__V = (function(x$1) {
  this.fields$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Encodes$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.amf$core$metamodel$document$DocumentModel$$undsetter$und$type$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_plugins_document_webapi_metamodel_ExtensionModel$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_metamodel_ExtensionModel$: 0
}, false, "amf.plugins.document.webapi.metamodel.ExtensionModel$", {
  Lamf_plugins_document_webapi_metamodel_ExtensionModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_ExtensionLikeModel: 1,
  Lamf_core_metamodel_document_DocumentModel: 1,
  Lamf_core_metamodel_document_FragmentModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_document_ModuleModel: 1
});
$c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$.prototype.$classData = $d_Lamf_plugins_document_webapi_metamodel_ExtensionModel$;
var $n_Lamf_plugins_document_webapi_metamodel_ExtensionModel$ = (void 0);
function $m_Lamf_plugins_document_webapi_metamodel_ExtensionModel$() {
  if ((!$n_Lamf_plugins_document_webapi_metamodel_ExtensionModel$)) {
    $n_Lamf_plugins_document_webapi_metamodel_ExtensionModel$ = new $c_Lamf_plugins_document_webapi_metamodel_ExtensionModel$().init___()
  };
  return $n_Lamf_plugins_document_webapi_metamodel_ExtensionModel$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_metamodel_OverlayModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.doc$1 = null;
  this.Extends$1 = null;
  this.fields$1 = null;
  this.Declares$1 = null;
  this.Encodes$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null
}
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.constructor = $c_Lamf_plugins_document_webapi_metamodel_OverlayModel$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_metamodel_OverlayModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype = $c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype;
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_webapi_metamodel_OverlayModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_ModuleModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_DocumentModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_ExtensionLikeModel__$$init$__V(this);
  $m_sci_List$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "Overlay")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_document_DocumentModel$().type$1;
  var this$7 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Overlay Model", "Model defining a RAML overlay", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.amf$core$metamodel$document$DocumentModel$$undsetter$und$fields$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.Extends__Lamf_core_metamodel_Field = (function() {
  return this.Extends$1
});
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.amf$core$metamodel$document$ExtensionLikeModel$$undsetter$und$Extends$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Extends$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.Declares__Lamf_core_metamodel_Field = (function() {
  return this.Declares$1
});
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.amf$core$metamodel$document$ModuleModel$$undsetter$und$Declares$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Declares$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_webapi_model_Overlay().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.Encodes__Lamf_core_metamodel_Field = (function() {
  return this.Encodes$1
});
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.amf$core$metamodel$document$ExtensionLikeModel$$undsetter$und$fields$und$eq__sci_List__V = (function(x$1) {
  this.fields$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Encodes$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.amf$core$metamodel$document$DocumentModel$$undsetter$und$type$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
var $d_Lamf_plugins_document_webapi_metamodel_OverlayModel$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_metamodel_OverlayModel$: 0
}, false, "amf.plugins.document.webapi.metamodel.OverlayModel$", {
  Lamf_plugins_document_webapi_metamodel_OverlayModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_ExtensionLikeModel: 1,
  Lamf_core_metamodel_document_DocumentModel: 1,
  Lamf_core_metamodel_document_FragmentModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_document_ModuleModel: 1
});
$c_Lamf_plugins_document_webapi_metamodel_OverlayModel$.prototype.$classData = $d_Lamf_plugins_document_webapi_metamodel_OverlayModel$;
var $n_Lamf_plugins_document_webapi_metamodel_OverlayModel$ = (void 0);
function $m_Lamf_plugins_document_webapi_metamodel_OverlayModel$() {
  if ((!$n_Lamf_plugins_document_webapi_metamodel_OverlayModel$)) {
    $n_Lamf_plugins_document_webapi_metamodel_OverlayModel$ = new $c_Lamf_plugins_document_webapi_metamodel_OverlayModel$().init___()
  };
  return $n_Lamf_plugins_document_webapi_metamodel_OverlayModel$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessage() {
  $c_Lamf_plugins_domain_webapi_models_Message.call(this);
  this.idPart$2 = null;
  this.ast$2 = null;
  this.isAbstract$2 = false;
  this.namespace$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessage.prototype = new $h_Lamf_plugins_domain_webapi_models_Message();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessage.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessage;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessage() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessage.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessage.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessage.prototype.originalMeta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessage.prototype.newErrorInstance__Lamf_core_annotations_ErrorDeclaration = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessage().init___T__Lorg_yaml_model_YPart__Z(this.idPart$2, this.ast$2, this.isAbstract$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessage.prototype.namespace__T = (function() {
  return this.namespace$2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessage.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessage.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return new $c_Lamf_core_annotations_ErrorDeclaration$$anon$1().init___Lamf_core_annotations_ErrorDeclaration(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessage.prototype.init___T__Lorg_yaml_model_YPart__Z = (function(idPart, ast, isAbstract) {
  this.idPart$2 = idPart;
  this.ast$2 = ast;
  this.isAbstract$2 = isAbstract;
  $c_Lamf_plugins_domain_webapi_models_Message.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, new $c_Lamf_core_parser_Fields().init___(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast));
  this.namespace$2 = "http://amferror.com/#errorMessage/";
  $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, idPart);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().IsAbstract$1;
  $as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this, field, isAbstract));
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessage.prototype.amf$core$annotations$ErrorDeclaration$$super$withId__T__Lamf_core_annotations_ErrorDeclaration = (function(value) {
  return $as_Lamf_core_annotations_ErrorDeclaration($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value))
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessage = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessage: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorMessage", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessage: 1,
  Lamf_plugins_domain_webapi_models_Message: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_annotations_ErrorDeclaration: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessage.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessage;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser.call(this);
  this.ScalarShapeParser$module$2 = null;
  this.UnionShapeParser$module$2 = null;
  this.OrConstraintParser$module$2 = null;
  this.AndConstraintParser$module$2 = null;
  this.XoneConstraintParser$module$2 = null;
  this.InnerShapeParser$module$2 = null;
  this.DataArrangementParser$module$2 = null;
  this.TupleShapeParser$module$2 = null;
  this.ArrayShapeParser$module$2 = null;
  this.AnyTypeShapeParser$module$2 = null;
  this.NodeShapeParser$module$2 = null;
  this.DiscriminatorParser$module$2 = null;
  this.AllOfParser$module$2 = null;
  this.PropertiesParser$module$2 = null;
  this.PropertyShapeParser$module$2 = null;
  this.Property$module$2 = null;
  this.FileShapeParser$module$2 = null;
  this.SchemaShapeParser$module$2 = null;
  this.entryOrNode$2 = null;
  this.name$2 = null;
  this.map$2 = null;
  this.adopt$2 = null;
  this.version$2 = null;
  this.ctx$2 = null;
  this.ast$2 = null;
  this.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.parseAnyType__p2__T__Lorg_yaml_model_YMap__F1__Lamf_plugins_domain_shapes_models_AnyShape = (function(name, map, adopt) {
  var this$1 = $m_Lamf_plugins_domain_shapes_models_AnyShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_AnyShape(this.ast$2);
  var a = this.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
  var shape = $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$1, name, a));
  adopt.apply__O__O(shape);
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_AnyShape__Lorg_yaml_model_YMap(this, shape, map).parse__Lamf_plugins_domain_shapes_models_AnyShape()
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.PropertiesParser$lzycompute$1__p2__V = (function() {
  if ((this.PropertiesParser$module$2 === null)) {
    this.PropertiesParser$module$2 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser$().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.detectItemProperties__p2__s_Option = (function() {
  var map = this.map$2;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("items");
  if (this$2.isEmpty__Z()) {
    var map$1 = this.map$2;
    var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option("minItems")
  } else {
    var this$4 = this$2
  };
  if (this$4.isEmpty__Z()) {
    var map$2 = this.map$2;
    var this$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2).key__T__s_Option("maxItems")
  } else {
    var this$6 = this$4
  };
  if (this$6.isEmpty__Z()) {
    var map$3 = this.map$2;
    var this$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3).key__T__s_Option("uniqueItems")
  } else {
    var this$8 = this$6
  };
  if (this$8.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$8.get__O();
    $as_Lorg_yaml_model_YMapEntry(arg1);
    return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$())
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.productPrefix__T = (function() {
  return "OasTypeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.detectDependency__p2__s_Option = (function() {
  var map = this.map$2;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("$ref");
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    $as_Lorg_yaml_model_YMapEntry(arg1);
    return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$LinkType$())
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser)) {
    var OasTypeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(x$1);
    var x = this.entryOrNode$2;
    var x$2 = OasTypeParser$1.entryOrNode$2;
    if ((((x === null) ? (x$2 === null) : x.equals__O__Z(x$2)) && (this.name$2 === OasTypeParser$1.name$2))) {
      var this$1 = this.map$2;
      var b = OasTypeParser$1.map$2;
      var jsx$2 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$3 = this.adopt$2;
      var x$4 = OasTypeParser$1.adopt$2;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.version$2;
      var x$6 = OasTypeParser$1.version$2;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.parseArrayType__p2__T__Lorg_yaml_model_YMap__F1__Lamf_plugins_domain_shapes_models_AnyShape = (function(name, map, adopt) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$DataArrangementParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__T__Lorg_yaml_model_YPart__Lorg_yaml_model_YMap__F1(this, name, this.ast$2, map, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, adopt$1) {
    return (function(shape$2) {
      var shape = $as_Lamf_core_model_domain_Shape(shape$2);
      adopt$1.apply__O__O(shape)
    })
  })(this, adopt))).parse__Lamf_plugins_domain_shapes_models_AnyShape()
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entryOrNode$2;
      break
    }
    case 1: {
      return this.name$2;
      break
    }
    case 2: {
      return this.map$2;
      break
    }
    case 3: {
      return this.adopt$2;
      break
    }
    case 4: {
      return this.version$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.parseDisjointUnionType__p2__Lamf_plugins_domain_shapes_models_UnionShape = (function() {
  var jsx$2 = $m_Lorg_yaml_model_YMap$();
  var jsx$1 = $as_sc_IndexedSeq(this.map$2.entries$3.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$8$2) {
      var x$8 = $as_Lorg_yaml_model_YMapEntry(x$8$2);
      var this$1 = x$8.key$2;
      var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
      var iv = $this.ctx$2;
      var x = $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv);
      return (!((x !== null) && $objectEquals(x, "type")))
    })
  })(this))));
  var this$2 = this.map$2;
  var filtered = jsx$2.apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(jsx$1, this$2.location$1.sourceName$1);
  $m_s_package$();
  $m_Lorg_yaml_model_YNode$();
  $m_Lorg_yaml_model_YNode$();
  var value = $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(filtered, $m_Lorg_yaml_model_YType$().Map$1);
  var parser = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__s_util_Either__T(this, new $c_s_util_Right().init___O(value), this.name$2);
  this.adopt$2.apply__O__O(parser.shape$3);
  var union = parser.parse__Lamf_plugins_domain_shapes_models_UnionShape();
  var finals = $as_sc_IndexedSeq(filtered.entries$3.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var this$6 = entry.key$2;
      var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
      var iv$1 = this$2$1.ctx$2;
      var prop = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion$1, iv$1));
      return (((((((((((((prop !== "example") && (prop !== new $c_Lamf_core_utils_package$AmfStrings().init___T("examples").asOasExtension__T())) && (prop !== "title")) && (prop !== "description")) && (prop !== "default")) && (prop !== "enum")) && (prop !== "externalDocs")) && (prop !== "xml")) && (prop !== new $c_Lamf_core_utils_package$AmfStrings().init___T("facets").asOasExtension__T())) && (prop !== "anyOf")) && (prop !== "allOf")) && (prop !== "oneOf")) && (prop !== "not"))
    })
  })(this))));
  var jsx$3 = $m_Lorg_yaml_model_YMap$();
  var this$9 = finals.headOption__s_Option();
  if (this$9.isEmpty__Z()) {
    var this$10 = $m_s_None$()
  } else {
    var arg1 = this$9.get__O();
    var x$9 = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$10 = new $c_s_Some().init___O(x$9.location$1.sourceName$1)
  };
  var exclusiveProps = jsx$3.apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(finals, $as_T((this$10.isEmpty__Z() ? "" : this$10.get__O())));
  var i = new $c_sr_IntRef().init___I(0);
  var map = this.map$2;
  var this$13 = $as_Lorg_yaml_model_YMapEntry(new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("type").get__O()).value$2;
  var conversion$2 = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
  var iv$2 = this.ctx$2;
  var jsx$9 = $as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$13, conversion$2, iv$2)).nodes$3;
  var jsx$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$5$1, i$1, exclusiveProps$1, union$1) {
    return (function(node$2) {
      var node = $as_Lorg_yaml_model_YNode(node$2);
      i$1.elem$1 = ((1 + i$1.elem$1) | 0);
      var x$1 = node.tag__Lorg_yaml_model_YTag().tagType$3;
      var x$2 = $m_Lorg_yaml_model_YType$().Str$1;
      if ((x$1 === x$2)) {
        var conversion$3 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv$3 = this$5$1.ctx$2;
        var x1 = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$3, iv$3));
        if ((x1 === "object")) {
          var name = (("" + this$5$1.name$2) + i$1.elem$1);
          var f = (function($this$1, union$1$1) {
            return (function(s$2) {
              var s = $as_Lamf_core_model_domain_Shape(s$2);
              var value$1 = (union$1$1.id$1 + "/object");
              $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(s, value$1)
            })
          })(this$5$1, union$1);
          if (new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(exclusiveProps$1).key__T__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("schema").asOasExtension__T()).isDefined__Z()) {
            var this$16 = $m_Lamf_plugins_domain_shapes_models_SchemaShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_SchemaShape(this$5$1.ast$2);
            var a = this$5$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
            var shape = $as_Lamf_plugins_domain_shapes_models_SchemaShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$16, name, a));
            f(shape);
            var jsx$7 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_SchemaShape__Lorg_yaml_model_YMap(this$5$1, shape, exclusiveProps$1).parse__Lamf_plugins_domain_shapes_models_AnyShape()
          } else {
            var this$17 = $m_Lamf_plugins_domain_shapes_models_NodeShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_NodeShape(this$5$1.ast$2);
            var a$1 = this$5$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
            var shape$2 = $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$17, name, a$1));
            var futureDeclarations = this$5$1.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations().futureDeclarations__Lamf_core_parser_FutureDeclarations();
            f(shape$2);
            if (((!(this$5$1.version$2 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion)) && (!(this$5$1.version$2 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion)))) {
              var this$19 = exclusiveProps$1.map$3.get__O__s_Option(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("id")));
              if ((!this$19.isEmpty__Z())) {
                var arg1$1 = this$19.get__O();
                var f$1 = $as_Lorg_yaml_model_YNode(arg1$1);
                var evidence$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
                var this$20 = $f_Lorg_yaml_model_YNodeLike__asOption__Lorg_yaml_convert_YRead__s_Option(f$1, evidence$1);
                if ((!this$20.isEmpty__Z())) {
                  var arg1$2 = this$20.get__O();
                  var id = $as_T(arg1$2);
                  $f_Lamf_core_parser_FutureDeclarations__resolveRef__T__Lamf_core_model_domain_Linkable__V(futureDeclarations, id, shape$2);
                  this$5$1.ctx$2.registerJsonSchema__T__Lamf_plugins_domain_shapes_models_AnyShape__V(id, shape$2)
                }
              }
            };
            var jsx$7 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_NodeShape__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(this$5$1, shape$2, exclusiveProps$1, this$5$1.ctx$2).parse__Lamf_plugins_domain_shapes_models_NodeShape()
          };
          return new $c_s_Some().init___O(jsx$7)
        } else if ((x1 === "array")) {
          return new $c_s_Some().init___O(this$5$1.parseArrayType__p2__T__Lorg_yaml_model_YMap__F1__Lamf_plugins_domain_shapes_models_AnyShape((("" + this$5$1.name$2) + i$1.elem$1), exclusiveProps$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$2, union$1$2) {
            return (function(s$3$2) {
              var s$3 = $as_Lamf_core_model_domain_Shape(s$3$2);
              var value$2 = (union$1$2.id$1 + "/array");
              $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(s$3, value$2)
            })
          })(this$5$1, union$1))))
        } else if ((x1 === "number")) {
          var typeDef = $m_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$();
          var name$1 = (("" + this$5$1.name$2) + i$1.elem$1);
          var f$2 = (function(this$3$1, union$1$3) {
            return (function(s$4$2) {
              var s$4 = $as_Lamf_core_model_domain_Shape(s$4$2);
              var value$3 = (union$1$3.id$1 + "/number");
              $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(s$4, value$3)
            })
          })(this$5$1, union$1);
          var x$3 = $m_Lamf_plugins_domain_shapes_models_TypeDef$NilType$();
          if ((x$3 === typeDef)) {
            var this$21 = $m_Lamf_plugins_domain_shapes_models_NilShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_NilShape(this$5$1.ast$2);
            var a$2 = this$5$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
            var shape$1 = $as_Lamf_plugins_domain_shapes_models_NilShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$21, name$1, a$2));
            f$2(shape$1);
            var parsed = shape$1
          } else {
            var x$3$1 = $m_Lamf_plugins_domain_shapes_models_TypeDef$FileType$();
            if ((x$3$1 === typeDef)) {
              var this$22 = $m_Lamf_plugins_domain_shapes_models_FileShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_FileShape(this$5$1.ast$2);
              var a$3 = this$5$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
              var shape$2$1 = $as_Lamf_plugins_domain_shapes_models_FileShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$22, name$1, a$3));
              f$2(shape$2$1);
              var parsed = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_domain_shapes_models_FileShape__Lorg_yaml_model_YMap(this$5$1, typeDef, shape$2$1, exclusiveProps$1).parse__Lamf_plugins_domain_shapes_models_FileShape()
            } else {
              var this$23 = $m_Lamf_plugins_domain_shapes_models_ScalarShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_ScalarShape(this$5$1.ast$2);
              var a$4 = this$5$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
              var shape$3 = $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$23, name$1, a$4));
              f$2(shape$3);
              var parsed = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_domain_shapes_models_ScalarShape__Lorg_yaml_model_YMap(this$5$1, typeDef, shape$3, exclusiveProps$1).parse__Lamf_plugins_domain_shapes_models_ScalarShape()
            }
          };
          return new $c_s_Some().init___O(parsed)
        } else if ((x1 === "integer")) {
          var typeDef$1 = $m_Lamf_plugins_domain_shapes_models_TypeDef$IntType$();
          var name$2 = (("" + this$5$1.name$2) + i$1.elem$1);
          var f$3 = (function(this$4$1, union$1$4) {
            return (function(s$5$2) {
              var s$5 = $as_Lamf_core_model_domain_Shape(s$5$2);
              var value$4 = (union$1$4.id$1 + "/integer");
              $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(s$5, value$4)
            })
          })(this$5$1, union$1);
          var x$4 = $m_Lamf_plugins_domain_shapes_models_TypeDef$NilType$();
          if ((x$4 === typeDef$1)) {
            var this$24 = $m_Lamf_plugins_domain_shapes_models_NilShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_NilShape(this$5$1.ast$2);
            var a$5 = this$5$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
            var shape$4 = $as_Lamf_plugins_domain_shapes_models_NilShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$24, name$2, a$5));
            f$3(shape$4);
            var parsed$1 = shape$4
          } else {
            var x$3$2 = $m_Lamf_plugins_domain_shapes_models_TypeDef$FileType$();
            if ((x$3$2 === typeDef$1)) {
              var this$25 = $m_Lamf_plugins_domain_shapes_models_FileShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_FileShape(this$5$1.ast$2);
              var a$6 = this$5$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
              var shape$2$2 = $as_Lamf_plugins_domain_shapes_models_FileShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$25, name$2, a$6));
              f$3(shape$2$2);
              var parsed$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_domain_shapes_models_FileShape__Lorg_yaml_model_YMap(this$5$1, typeDef$1, shape$2$2, exclusiveProps$1).parse__Lamf_plugins_domain_shapes_models_FileShape()
            } else {
              var this$26 = $m_Lamf_plugins_domain_shapes_models_ScalarShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_ScalarShape(this$5$1.ast$2);
              var a$7 = this$5$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
              var shape$3$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$26, name$2, a$7));
              f$3(shape$3$1);
              var parsed$1 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_domain_shapes_models_ScalarShape__Lorg_yaml_model_YMap(this$5$1, typeDef$1, shape$3$1, exclusiveProps$1).parse__Lamf_plugins_domain_shapes_models_ScalarShape()
            }
          };
          return new $c_s_Some().init___O(parsed$1)
        } else if ((x1 === "string")) {
          var typeDef$2 = $m_Lamf_plugins_domain_shapes_models_TypeDef$StrType$();
          var name$3 = (("" + this$5$1.name$2) + i$1.elem$1);
          var f$4 = (function(this$5$2, union$1$5) {
            return (function(s$6$2) {
              var s$6 = $as_Lamf_core_model_domain_Shape(s$6$2);
              var value$5 = (union$1$5.id$1 + "/string");
              $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(s$6, value$5)
            })
          })(this$5$1, union$1);
          var x$5 = $m_Lamf_plugins_domain_shapes_models_TypeDef$NilType$();
          if ((x$5 === typeDef$2)) {
            var this$27 = $m_Lamf_plugins_domain_shapes_models_NilShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_NilShape(this$5$1.ast$2);
            var a$8 = this$5$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
            var shape$5 = $as_Lamf_plugins_domain_shapes_models_NilShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$27, name$3, a$8));
            f$4(shape$5);
            var parsed$2 = shape$5
          } else {
            var x$3$3 = $m_Lamf_plugins_domain_shapes_models_TypeDef$FileType$();
            if ((x$3$3 === typeDef$2)) {
              var this$28 = $m_Lamf_plugins_domain_shapes_models_FileShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_FileShape(this$5$1.ast$2);
              var a$9 = this$5$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
              var shape$2$3 = $as_Lamf_plugins_domain_shapes_models_FileShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$28, name$3, a$9));
              f$4(shape$2$3);
              var parsed$2 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_domain_shapes_models_FileShape__Lorg_yaml_model_YMap(this$5$1, typeDef$2, shape$2$3, exclusiveProps$1).parse__Lamf_plugins_domain_shapes_models_FileShape()
            } else {
              var this$29 = $m_Lamf_plugins_domain_shapes_models_ScalarShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_ScalarShape(this$5$1.ast$2);
              var a$10 = this$5$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
              var shape$3$2 = $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$29, name$3, a$10));
              f$4(shape$3$2);
              var parsed$2 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_domain_shapes_models_ScalarShape__Lorg_yaml_model_YMap(this$5$1, typeDef$2, shape$3$2, exclusiveProps$1).parse__Lamf_plugins_domain_shapes_models_ScalarShape()
            }
          };
          return new $c_s_Some().init___O(parsed$2)
        } else if ((x1 === "boolean")) {
          var typeDef$3 = $m_Lamf_plugins_domain_shapes_models_TypeDef$BoolType$();
          var name$4 = (("" + this$5$1.name$2) + i$1.elem$1);
          var f$5 = (function(this$6$1, union$1$6) {
            return (function(s$7$2) {
              var s$7 = $as_Lamf_core_model_domain_Shape(s$7$2);
              var value$6 = (union$1$6.id$1 + "/boolean");
              $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(s$7, value$6)
            })
          })(this$5$1, union$1);
          var x$6 = $m_Lamf_plugins_domain_shapes_models_TypeDef$NilType$();
          if ((x$6 === typeDef$3)) {
            var this$30 = $m_Lamf_plugins_domain_shapes_models_NilShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_NilShape(this$5$1.ast$2);
            var a$11 = this$5$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
            var shape$6 = $as_Lamf_plugins_domain_shapes_models_NilShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$30, name$4, a$11));
            f$5(shape$6);
            var parsed$3 = shape$6
          } else {
            var x$3$4 = $m_Lamf_plugins_domain_shapes_models_TypeDef$FileType$();
            if ((x$3$4 === typeDef$3)) {
              var this$31 = $m_Lamf_plugins_domain_shapes_models_FileShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_FileShape(this$5$1.ast$2);
              var a$12 = this$5$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
              var shape$2$4 = $as_Lamf_plugins_domain_shapes_models_FileShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$31, name$4, a$12));
              f$5(shape$2$4);
              var parsed$3 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_domain_shapes_models_FileShape__Lorg_yaml_model_YMap(this$5$1, typeDef$3, shape$2$4, exclusiveProps$1).parse__Lamf_plugins_domain_shapes_models_FileShape()
            } else {
              var this$32 = $m_Lamf_plugins_domain_shapes_models_ScalarShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_ScalarShape(this$5$1.ast$2);
              var a$13 = this$5$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
              var shape$3$3 = $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$32, name$4, a$13));
              f$5(shape$3$3);
              var parsed$3 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_domain_shapes_models_ScalarShape__Lorg_yaml_model_YMap(this$5$1, typeDef$3, shape$3$3, exclusiveProps$1).parse__Lamf_plugins_domain_shapes_models_ScalarShape()
            }
          };
          return new $c_s_Some().init___O(parsed$3)
        } else if ((x1 === "null")) {
          var typeDef$4 = $m_Lamf_plugins_domain_shapes_models_TypeDef$NilType$();
          var name$5 = (("" + this$5$1.name$2) + i$1.elem$1);
          var f$6 = (function(this$7$1, union$1$7) {
            return (function(s$8$2) {
              var s$8 = $as_Lamf_core_model_domain_Shape(s$8$2);
              var value$7 = (union$1$7.id$1 + "/nil");
              $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(s$8, value$7)
            })
          })(this$5$1, union$1);
          var x$7 = $m_Lamf_plugins_domain_shapes_models_TypeDef$NilType$();
          if ((x$7 === typeDef$4)) {
            var this$33 = $m_Lamf_plugins_domain_shapes_models_NilShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_NilShape(this$5$1.ast$2);
            var a$14 = this$5$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
            var shape$7 = $as_Lamf_plugins_domain_shapes_models_NilShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$33, name$5, a$14));
            f$6(shape$7);
            var parsed$4 = shape$7
          } else {
            var x$3$5 = $m_Lamf_plugins_domain_shapes_models_TypeDef$FileType$();
            if ((x$3$5 === typeDef$4)) {
              var this$34 = $m_Lamf_plugins_domain_shapes_models_FileShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_FileShape(this$5$1.ast$2);
              var a$15 = this$5$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
              var shape$2$5 = $as_Lamf_plugins_domain_shapes_models_FileShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$34, name$5, a$15));
              f$6(shape$2$5);
              var parsed$4 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_domain_shapes_models_FileShape__Lorg_yaml_model_YMap(this$5$1, typeDef$4, shape$2$5, exclusiveProps$1).parse__Lamf_plugins_domain_shapes_models_FileShape()
            } else {
              var this$35 = $m_Lamf_plugins_domain_shapes_models_ScalarShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_ScalarShape(this$5$1.ast$2);
              var a$16 = this$5$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
              var shape$3$4 = $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$35, name$5, a$16));
              f$6(shape$3$4);
              var parsed$4 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_domain_shapes_models_ScalarShape__Lorg_yaml_model_YMap(this$5$1, typeDef$4, shape$3$4, exclusiveProps$1).parse__Lamf_plugins_domain_shapes_models_ScalarShape()
            }
          };
          return new $c_s_Some().init___O(parsed$4)
        } else if ((x1 === "any")) {
          var name$6 = (("" + this$5$1.name$2) + i$1.elem$1);
          var this$36 = $m_Lamf_plugins_domain_shapes_models_AnyShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_AnyShape(this$5$1.ast$2);
          var a$17 = this$5$1.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
          var shape$8 = $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$36, name$6, a$17));
          var value$8 = (union$1.id$1 + "/any");
          $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(shape$8, value$8);
          return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$AnyTypeShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_AnyShape__Lorg_yaml_model_YMap(this$5$1, shape$8, exclusiveProps$1).parse__Lamf_plugins_domain_shapes_models_AnyShape())
        } else {
          var this$38 = this$5$1.ctx$2.eh$1;
          var specification = $m_Lamf_validations_ParserSideValidations$().InvalidDisjointUnionType$1;
          var node$1 = union$1.id$1;
          var message = ("Invalid type for disjointUnion " + x1);
          var map$1 = this$5$1.map$2;
          var ast = $as_Lorg_yaml_model_YMapEntry(new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option("type").get__O()).value$2;
          var prop$1 = $m_s_None$();
          var l = ast.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$38, specification, node$1, prop$1, message, l);
          return $m_s_None$()
        }
      } else {
        var x$3$6 = node.tag__Lorg_yaml_model_YTag().tagType$3;
        var x$4$1 = $m_Lorg_yaml_model_YType$().Map$1;
        if ((x$3$6 === x$4$1)) {
          var jsx$8 = $m_Lorg_yaml_model_YMapEntry$();
          $m_Lorg_yaml_model_YNode$();
          var str = ("union_member_" + i$1.elem$1);
          var entry$1 = jsx$8.apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry($m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str), node);
          return $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(entry$1, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$9$1, union$1$8) {
            return (function(shape$2$6) {
              var shape$9 = $as_Lamf_core_model_domain_Shape(shape$2$6);
              shape$9.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(union$1$8.id$1, shape$9.adopted$default$2__sc_Seq())
            })
          })(this$5$1, union$1)), this$5$1.version$2, this$5$1.ctx$2).parse__s_Option()
        } else {
          var this$41 = this$5$1.ctx$2.eh$1;
          var specification$1 = $m_Lamf_validations_ParserSideValidations$().InvalidDisjointUnionType$1;
          var node$3 = union$1.id$1;
          var message$1 = ("Invalid type for disjointUnion " + node.tag__Lorg_yaml_model_YTag().tagType$3);
          var map$2 = this$5$1.map$2;
          var ast$1 = $as_Lorg_yaml_model_YMapEntry(new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2).key__T__s_Option("type").get__O()).value$2;
          var prop$2 = $m_s_None$();
          var l$1 = ast$1.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$41, specification$1, node$3, prop$2, message$1, l$1);
          return $m_s_None$()
        }
      }
    })
  })(this, i, exclusiveProps, union));
  var this$42 = $m_sc_IndexedSeq$();
  var jsx$5 = $as_sc_TraversableLike(jsx$9.map__F1__scg_CanBuildFrom__O(jsx$6, this$42.ReusableCBF$6));
  var jsx$4 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(this);
  var this$43 = $m_sc_IndexedSeq$();
  var parsedTypes = $as_sc_Seq(jsx$5.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$4, this$43.ReusableCBF$6));
  if (parsedTypes.nonEmpty__Z()) {
    var field = $m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1;
    $f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(union, field, parsedTypes)
  };
  return union
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.parse__s_Option = (function() {
  if (this.detectDisjointUnion__p2__Z()) {
    this.validateUnionType__V();
    return new $c_s_Some().init___O(this.parseDisjointUnionType__p2__Lamf_plugins_domain_shapes_models_UnionShape())
  } else {
    var x1 = this.detect__p2__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_domain_shapes_models_TypeDef(this.version$2);
    var x = $m_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$();
    if ((x === x1)) {
      var parsedShape = new $c_s_Some().init___O(this.parseUnionType__p2__Lamf_plugins_domain_shapes_models_UnionShape())
    } else {
      var x$3 = $m_Lamf_plugins_domain_shapes_models_TypeDef$LinkType$();
      if ((x$3 === x1)) {
        var parsedShape = this.parseLinkType__p2__s_Option()
      } else {
        var x$5 = $m_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$();
        if ((x$5 === x1)) {
          var parsedShape = new $c_s_Some().init___O(this.parseObjectType__p2__T__Lorg_yaml_model_YMap__F1__Lamf_plugins_domain_shapes_models_AnyShape(this.name$2, this.map$2, this.adopt$2))
        } else {
          var x$7 = $m_Lamf_plugins_domain_shapes_models_TypeDef$ArrayType$();
          if ((x$7 === x1)) {
            var parsedShape = new $c_s_Some().init___O(this.parseArrayType__p2__T__Lorg_yaml_model_YMap__F1__Lamf_plugins_domain_shapes_models_AnyShape(this.name$2, this.map$2, this.adopt$2))
          } else {
            var x$9 = $m_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$();
            if ((x$9 === x1)) {
              var parsedShape = new $c_s_Some().init___O(this.parseAnyType__p2__T__Lorg_yaml_model_YMap__F1__Lamf_plugins_domain_shapes_models_AnyShape(this.name$2, this.map$2, this.adopt$2))
            } else {
              var parsedShape = ($f_Lamf_plugins_domain_shapes_models_TypeDef__isScalar__Z(x1) ? new $c_s_Some().init___O(this.parseScalarType__p2__Lamf_plugins_domain_shapes_models_TypeDef__T__Lorg_yaml_model_YMap__F1__Lamf_plugins_domain_shapes_models_AnyShape(x1, this.name$2, this.map$2, this.adopt$2)) : $m_s_None$())
            }
          }
        }
      }
    };
    if ((parsedShape instanceof $c_s_Some)) {
      var x2 = $as_s_Some(parsedShape);
      var shape = $as_Lamf_plugins_domain_shapes_models_AnyShape(x2.value$2);
      if ((shape !== null)) {
        if ((this.version$2 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion)) {
          this.ctx$2.closedShape__T__Lorg_yaml_model_YMap__T__V(shape.id$1, this.map$2, $as_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion(this.version$2).position__T())
        };
        return ((this.version$2 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion) ? new $c_s_Some().init___O(this.checkNilUnion__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_domain_shapes_models_AnyShape(shape)) : new $c_s_Some().init___O(shape))
      }
    };
    var x$11 = $m_s_None$();
    if ((x$11 === parsedShape)) {
      return $m_s_None$()
    };
    throw new $c_s_MatchError().init___O(parsedShape)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.detectUnion__p2__s_Option = (function() {
  var map = this.map$2;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("x-amf-union");
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    $as_Lorg_yaml_model_YMapEntry(arg1);
    return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$UnionType$())
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$parseRequiredFields__Lorg_yaml_model_YMap__Lamf_plugins_domain_shapes_models_NodeShape__sci_Map = (function(map, shape) {
  var defaultValue = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("required");
  if (this$2.isEmpty__Z()) {
    var this$5 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var field = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$3 = field.value$2;
    var _1 = this$3.tag__Lorg_yaml_model_YTag().tagType$3;
    var _2 = this.version$2;
    var x = $m_Lorg_yaml_model_YType$().Seq$1;
    if ((x === _1)) {
      var x$3 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$();
      var jsx$2 = (x$3 === _2)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var this$4 = this.ctx$2.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidRequiredArrayForSchemaVersion$1;
      var node = shape.id$1;
      var ast = field.value$2;
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$4, specification, node, prop, "Required arrays of properties not supported in JSON Schema below version draft-4", l);
      var jsx$1 = defaultValue
    } else {
      var x$5 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$();
      if ((x$5 === _2)) {
        var jsx$1 = defaultValue
      } else {
        var x$7 = $m_Lorg_yaml_model_YType$().Seq$1;
        if ((x$7 === _1)) {
          var x$9 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$();
          var jsx$3 = (x$9 === _2)
        } else {
          var jsx$3 = false
        };
        if (jsx$3) {
          var jsx$1 = this.parse$1__p2__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_shapes_models_NodeShape__sci_Map(field, shape)
        } else {
          var x$11 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$();
          if ((x$11 === _2)) {
            var jsx$1 = defaultValue
          } else {
            var jsx$1 = this.parse$1__p2__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_shapes_models_NodeShape__sci_Map(field, shape)
          }
        }
      }
    };
    var this$5 = new $c_s_Some().init___O(jsx$1)
  };
  return $as_sci_Map((this$5.isEmpty__Z() ? defaultValue : this$5.get__O()))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.parse$1__p2__Lorg_yaml_model_YMapEntry__Lamf_plugins_domain_shapes_models_NodeShape__sci_Map = (function(field, shape$3) {
  var defaultValue = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var this$1 = field.value$2;
  var evidence$1 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
  var requiredSeq = $f_Lorg_yaml_model_YNodeLike__asOption__Lorg_yaml_convert_YRead__s_Option(this$1, evidence$1);
  if ((requiredSeq instanceof $c_s_Some)) {
    var x2 = $as_s_Some(requiredSeq);
    var required = $as_sc_Seq(x2.value$2);
    var requiredGroup = required.groupBy__F1__sci_Map(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x$26$2) {
        var x$26 = $as_Lorg_yaml_model_YNode(x$26$2);
        var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv = $this.ctx$2;
        return $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(x$26, conversion, iv))
      })
    })(this)));
    this.validateRequiredFields__p2__sci_Map__Lamf_plugins_domain_shapes_models_NodeShape__V(requiredGroup, shape$3);
    var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
      return (function(x0$1$2) {
        var x0$1 = $as_T2(x0$1$2);
        if ((x0$1 !== null)) {
          var key = $as_T(x0$1.$$und1__O());
          var nodes = $as_sc_Seq(x0$1.$$und2__O());
          var y = nodes.head__O();
          return new $c_T2().init___O__O(key, y)
        } else {
          throw new $c_s_MatchError().init___O(x0$1)
        }
      })
    })(this));
    var this$5 = $m_sci_Map$();
    var bf = new $c_scg_GenMapFactory$MapCanBuildFrom().init___scg_GenMapFactory(this$5);
    return $as_sci_Map($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(requiredGroup, f, bf))
  } else {
    var x = $m_s_None$();
    if ((x === requiredSeq)) {
      var this$6 = this.ctx$2.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidRequiredValue$1;
      var node = shape$3.id$1;
      var loc = field.location$1;
      var prop = $m_s_None$();
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$6, specification, node, prop, "'required' field has to be an array", loc);
      return defaultValue
    } else {
      throw new $c_s_MatchError().init___O(requiredSeq)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.detectDisjointUnion__p2__Z = (function() {
  var map = this.map$2;
  if (new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("type").isDefined__Z()) {
    var map$1 = this.map$2;
    var this$3 = $as_Lorg_yaml_model_YMapEntry(new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option("type").get__O()).value$2;
    var evidence$1 = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
    return $f_Lorg_yaml_model_YNodeLike__asOption__Lorg_yaml_convert_YRead__s_Option(this$3, evidence$1).isDefined__Z()
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.detectObjectProperties__p2__s_Option = (function() {
  var map = this.map$2;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("properties");
  if (this$2.isEmpty__Z()) {
    var map$1 = this.map$2;
    var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option("x-amf-merge")
  } else {
    var this$4 = this$2
  };
  if (this$4.isEmpty__Z()) {
    var map$2 = this.map$2;
    var this$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2).key__T__s_Option("minProperties")
  } else {
    var this$6 = this$4
  };
  if (this$6.isEmpty__Z()) {
    var map$3 = this.map$2;
    var this$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3).key__T__s_Option("maxProperties")
  } else {
    var this$8 = this$6
  };
  if (this$8.isEmpty__Z()) {
    var map$4 = this.map$2;
    var this$10 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$4).key__T__s_Option("dependencies")
  } else {
    var this$10 = this$8
  };
  if (this$10.isEmpty__Z()) {
    var map$5 = this.map$2;
    var this$12 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$5).key__T__s_Option("patternProperties")
  } else {
    var this$12 = this$10
  };
  if (this$12.isEmpty__Z()) {
    var map$6 = this.map$2;
    var this$14 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$6).key__T__s_Option("additionalProperties")
  } else {
    var this$14 = this$12
  };
  if (this$14.isEmpty__Z()) {
    var map$7 = this.map$2;
    var this$16 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$7).key__T__s_Option("discriminator")
  } else {
    var this$16 = this$14
  };
  if (this$16.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$16.get__O();
    $as_Lorg_yaml_model_YMapEntry(arg1);
    return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$ObjectType$())
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.detectStringProperties__p2__s_Option = (function() {
  var map = this.map$2;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("minLength");
  if (this$2.isEmpty__Z()) {
    var map$1 = this.map$2;
    var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option("maxLength")
  } else {
    var this$4 = this$2
  };
  if (this$4.isEmpty__Z()) {
    var map$2 = this.map$2;
    var this$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2).key__T__s_Option("pattern")
  } else {
    var this$6 = this$4
  };
  if (this$6.isEmpty__Z()) {
    var map$3 = this.map$2;
    var this$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3).key__T__s_Option("format")
  } else {
    var this$8 = this$6
  };
  if (this$8.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$8.get__O();
    $as_Lorg_yaml_model_YMapEntry(arg1);
    return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$StrType$())
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.detectType__p2__s_Option = (function() {
  var map = this.map$2;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("type");
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$3 = e.value$2;
    var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
    var iv = this.ctx$2;
    var t = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv)).text$3;
    var map$1 = this.map$2;
    var this$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option("format");
    if (this$5.isEmpty__Z()) {
      var this$8 = $m_s_None$()
    } else {
      var arg1$1 = this$5.get__O();
      var e$2 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
      var node = e$2.value$2;
      var this$7 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lamf_core_parser_package$YScalarYRead$());
      if (this$7.isEmpty__Z()) {
        var this$8 = $m_s_None$()
      } else {
        var arg1$2 = this$7.get__O();
        var x$7 = $as_Lorg_yaml_model_YScalar(arg1$2);
        var this$8 = new $c_s_Some().init___O(x$7.text$3)
      }
    };
    var f = $as_T((this$8.isEmpty__Z() ? "" : this$8.get__O()));
    var result = $m_Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$().matchType__T__T__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_domain_shapes_models_TypeDef(t, f, $m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$());
    var x$2 = $m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$();
    if (((result !== null) && (result === x$2))) {
      var this$9 = this.ctx$2.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidJsonSchemaType$1;
      var message = ("Invalid type " + t);
      var ast = e.value$2;
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$9, specification, "", prop, message, l);
      return $m_s_None$()
    } else {
      return new $c_s_Some().init___O(result)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.validateRequiredFields__p2__sci_Map__Lamf_plugins_domain_shapes_models_NodeShape__V = (function(required, shape) {
  required.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, shape$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      matchEnd3: {
        if ((x0$1 !== null)) {
          var name = $as_T(x0$1.$$und1__O());
          var nodes = $as_sc_Seq(x0$1.$$und2__O());
          if ((nodes.size__I() > 1)) {
            var this$1 = $this.ctx$2.eh$1;
            var specification = $m_Lamf_validations_ParserSideValidations$().DuplicateRequiredItem$1;
            var node = shape$1.id$1;
            var message = (("'" + name) + "' is duplicated in 'required' property");
            var ast = $as_Lorg_yaml_model_YPart(nodes.last__O());
            var prop = $m_s_None$();
            var l = ast.location$1;
            $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$1, specification, node, prop, message, l);
            break matchEnd3
          }
        }
      }
    })
  })(this, shape)))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.parseUnionType__p2__Lamf_plugins_domain_shapes_models_UnionShape = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$UnionShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__s_util_Either__T(this, this.entryOrNode$2, this.name$2).parse__Lamf_plugins_domain_shapes_models_UnionShape()
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.validateUnionType__V = (function() {
  if ((this.version$2 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion)) {
    var this$2 = this.ctx$2.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().InvalidJsonSchemaType$1;
    var map = this.map$2;
    var ast = $as_Lorg_yaml_model_YPart(new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("type").get__O());
    var prop = $m_s_None$();
    var l = ast.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$2, specification, "", prop, "Value of field 'type' must be a string, multiple types are not supported", l)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.parseLinkType__p2__s_Option = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasRefParser().init___Lorg_yaml_model_YMap__T__Lamf_core_parser_Annotations__Lorg_yaml_model_YPart__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(this.map$2, this.name$2, this.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2, this.ast$2, this.adopt$2, this.version$2, this.ctx$2).parse__s_Option()
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.init___s_util_Either__T__Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function(entryOrNode, name, map, adopt, version, ctx) {
  this.entryOrNode$2 = entryOrNode;
  this.name$2 = name;
  this.map$2 = map;
  this.adopt$2 = adopt;
  this.version$2 = version;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser.prototype.init___Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.call(this, ctx);
  if ((entryOrNode instanceof $c_s_util_Left)) {
    var x2 = $as_s_util_Left(entryOrNode);
    var l = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    var jsx$1 = l
  } else if ((entryOrNode instanceof $c_s_util_Right)) {
    var x3 = $as_s_util_Right(entryOrNode);
    var r = $as_Lorg_yaml_model_YNode(x3.value$2);
    var jsx$1 = r
  } else {
    var jsx$1;
    throw new $c_s_MatchError().init___O(entryOrNode)
  };
  this.ast$2 = jsx$1;
  var this$1 = new $c_s_util_Either$LeftProjection().init___s_util_Either(entryOrNode).toOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$2 = new $c_s_Some().init___O($m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(e.key$2))
  };
  this.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2 = $as_Lamf_core_parser_Annotations((this$2.isEmpty__Z() ? ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()) : this$2.get__O()));
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.checkNilUnion__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_domain_shapes_models_AnyShape = (function(parsed) {
  var map = this.map$2;
  var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("nullable");
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var nullableEntry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
    var node = nullableEntry.value$2;
    var this$3 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$BooleanYRead$());
    if ($uZ((this$3.isEmpty__Z() ? false : this$3.get__O()))) {
      $m_Lamf_core_parser_Annotations$();
      var annotations = new $c_Lamf_core_parser_Annotations().init___();
      var this$7 = new $c_Lamf_plugins_domain_shapes_models_UnionShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
      var name = this.name$2;
      var a = this.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
      var union = $as_Lamf_plugins_domain_shapes_models_UnionShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$7, name, a).withId__T__Lamf_core_model_domain_AmfObject((parsed.id$1 + "/nilUnion")));
      var jsx$2 = parsed.annotations__Lamf_core_parser_Annotations();
      var jsx$1 = $m_Lamf_core_parser_Range$();
      var this$8 = nullableEntry.key$2;
      var this$9 = this$8.location$1;
      jsx$2.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_NilUnion().init___T(jsx$1.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$9.lineFrom$1, this$9.columnFrom$1, this$9.lineTo$1, this$9.columnTo$1)).toString__T()));
      var jsx$3 = $m_sc_Seq$();
      $m_Lamf_core_parser_Annotations$();
      var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
      var this$13 = new $c_Lamf_plugins_domain_shapes_models_NilShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
      var value = (union.id$1 + "_nil");
      var array = [parsed, $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$13, value))];
      var elements = $as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
      var field = $m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1;
      $as_Lamf_plugins_domain_shapes_models_UnionShape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(union, field, elements));
      return union
    }
  };
  return parsed
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.detectNumberProperties__p2__s_Option = (function() {
  var map = this.map$2;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("multipleOf");
  if (this$2.isEmpty__Z()) {
    var map$1 = this.map$2;
    var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option("minimum")
  } else {
    var this$4 = this$2
  };
  if (this$4.isEmpty__Z()) {
    var map$2 = this.map$2;
    var this$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2).key__T__s_Option("maximum")
  } else {
    var this$6 = this$4
  };
  if (this$6.isEmpty__Z()) {
    var map$3 = this.map$2;
    var this$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3).key__T__s_Option("exclusiveMinimum")
  } else {
    var this$8 = this$6
  };
  if (this$8.isEmpty__Z()) {
    var map$4 = this.map$2;
    var this$10 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$4).key__T__s_Option("exclusiveMaximum")
  } else {
    var this$10 = this$8
  };
  if (this$10.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$10.get__O();
    $as_Lorg_yaml_model_YMapEntry(arg1);
    return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_models_TypeDef$NumberType$())
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.PropertiesParser__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$PropertiesParser$ = (function() {
  if ((this.PropertiesParser$module$2 === null)) {
    this.PropertiesParser$lzycompute$1__p2__V()
  };
  return this.PropertiesParser$module$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.parseObjectType__p2__T__Lorg_yaml_model_YMap__F1__Lamf_plugins_domain_shapes_models_AnyShape = (function(name, map, adopt) {
  if (new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("schema").asOasExtension__T()).isDefined__Z()) {
    var this$3 = $m_Lamf_plugins_domain_shapes_models_SchemaShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_SchemaShape(this.ast$2);
    var a = this.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
    var shape = $as_Lamf_plugins_domain_shapes_models_SchemaShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a));
    adopt.apply__O__O(shape);
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$SchemaShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_SchemaShape__Lorg_yaml_model_YMap(this, shape, map).parse__Lamf_plugins_domain_shapes_models_AnyShape()
  } else {
    var this$4 = $m_Lamf_plugins_domain_shapes_models_NodeShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_NodeShape(this.ast$2);
    var a$1 = this.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
    var shape$2 = $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$4, name, a$1));
    this.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$checkJsonIdentity__Lamf_plugins_domain_shapes_models_AnyShape__Lorg_yaml_model_YMap__F1__Lamf_core_parser_FutureDeclarations__V(shape$2, map, adopt, this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations().futureDeclarations__Lamf_core_parser_FutureDeclarations());
    return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$NodeShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_NodeShape__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(this, shape$2, map, this.ctx$2).parse__Lamf_plugins_domain_shapes_models_NodeShape()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$checkJsonIdentity__Lamf_plugins_domain_shapes_models_AnyShape__Lorg_yaml_model_YMap__F1__Lamf_core_parser_FutureDeclarations__V = (function(shape, map, adopt, futureDeclarations) {
  adopt.apply__O__O(shape);
  if (((!(this.version$2 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion)) && (!(this.version$2 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OAS30SchemaVersion)))) {
    var this$2 = map.map$3.get__O__s_Option(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("id")));
    if ((!this$2.isEmpty__Z())) {
      var arg1 = this$2.get__O();
      var f = $as_Lorg_yaml_model_YNode(arg1);
      var evidence$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
      var this$3 = $f_Lorg_yaml_model_YNodeLike__asOption__Lorg_yaml_convert_YRead__s_Option(f, evidence$1);
      if ((!this$3.isEmpty__Z())) {
        var arg1$1 = this$3.get__O();
        var id = $as_T(arg1$1);
        $f_Lamf_core_parser_FutureDeclarations__resolveRef__T__Lamf_core_model_domain_Linkable__V(futureDeclarations, id, shape);
        this.ctx$2.registerJsonSchema__T__Lamf_plugins_domain_shapes_models_AnyShape__V(id, shape)
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.parseScalarType__p2__Lamf_plugins_domain_shapes_models_TypeDef__T__Lorg_yaml_model_YMap__F1__Lamf_plugins_domain_shapes_models_AnyShape = (function(typeDef, name, map, adopt) {
  var x = $m_Lamf_plugins_domain_shapes_models_TypeDef$NilType$();
  if ((x === typeDef)) {
    var this$1 = $m_Lamf_plugins_domain_shapes_models_NilShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_NilShape(this.ast$2);
    var a = this.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
    var shape = $as_Lamf_plugins_domain_shapes_models_NilShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$1, name, a));
    adopt.apply__O__O(shape);
    var parsed = shape
  } else {
    var x$3 = $m_Lamf_plugins_domain_shapes_models_TypeDef$FileType$();
    if ((x$3 === typeDef)) {
      var this$2 = $m_Lamf_plugins_domain_shapes_models_FileShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_FileShape(this.ast$2);
      var a$1 = this.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
      var shape$2 = $as_Lamf_plugins_domain_shapes_models_FileShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$2, name, a$1));
      adopt.apply__O__O(shape$2);
      var parsed = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$FileShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_domain_shapes_models_FileShape__Lorg_yaml_model_YMap(this, typeDef, shape$2, map).parse__Lamf_plugins_domain_shapes_models_FileShape()
    } else {
      var this$3 = $m_Lamf_plugins_domain_shapes_models_ScalarShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_ScalarShape(this.ast$2);
      var a$2 = this.amf$plugins$document$webapi$parser$spec$declaration$OasTypeParser$$nameAnnotations$2;
      var shape$3 = $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a$2));
      adopt.apply__O__O(shape$3);
      var parsed = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$ScalarShapeParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_domain_shapes_models_ScalarShape__Lorg_yaml_model_YMap(this, typeDef, shape$3, map).parse__Lamf_plugins_domain_shapes_models_ScalarShape()
    }
  };
  return parsed
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.detect__p2__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_domain_shapes_models_TypeDef = (function(version) {
  matchEnd4: {
    var defaultType;
    if ((version instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion)) {
      var x2 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OASSchemaVersion(version);
      if ((x2.position__T() === "parameter")) {
        var defaultType = $m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$();
        break matchEnd4
      }
    };
    var defaultType = $m_Lamf_plugins_domain_shapes_models_TypeDef$AnyType$()
  };
  var this$1 = this.detectDependency__p2__s_Option();
  var this$2 = (this$1.isEmpty__Z() ? this.detectType__p2__s_Option() : this$1);
  var this$3 = (this$2.isEmpty__Z() ? this.detectObjectProperties__p2__s_Option() : this$2);
  var this$4 = (this$3.isEmpty__Z() ? this.detectUnion__p2__s_Option() : this$3);
  var this$5 = (this$4.isEmpty__Z() ? this.detectItemProperties__p2__s_Option() : this$4);
  var this$6 = (this$5.isEmpty__Z() ? this.detectNumberProperties__p2__s_Option() : this$5);
  var this$7 = (this$6.isEmpty__Z() ? this.detectStringProperties__p2__s_Option() : this$6);
  return $as_Lamf_plugins_domain_shapes_models_TypeDef((this$7.isEmpty__Z() ? defaultType : this$7.get__O()))
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasTypeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTypeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_WebApiBaseSpecParser: 1,
  Lamf_core_parser_BaseSpecParser: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.call(this);
  this.shape$3 = null;
  this.map$3 = null;
  this.options$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser.prototype.productPrefix__T = (function() {
  return "AnyTypeShapeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser(x$1).$$outer$1 === this.$$outer$1))) {
    var AnyTypeShapeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser(x$1);
    var x = this.shape$3;
    var x$2 = AnyTypeShapeParser$1.shape$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var this$1 = this.map$3;
      var b = AnyTypeShapeParser$1.map$3;
      return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$3;
      break
    }
    case 1: {
      return this.map$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser.prototype.options__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions = (function() {
  return this.options$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser.prototype.map__Lorg_yaml_model_YMap = (function() {
  return this.map$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lamf_plugins_domain_shapes_models_AnyShape__Lorg_yaml_model_YMap = (function($$outer, shape, map) {
  this.shape$3 = shape;
  this.map$3 = map;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.call(this, $$outer);
  this.options$3 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions().init___Z__Z__Z(true, true, false).checkScalar__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions(shape);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser.prototype.shape__Lamf_core_model_domain_Shape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser.prototype.shape__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$AnyTypeShapeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$AnyTypeShapeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$AnyTypeShapeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_ExampleParser: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyTypeShapeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.call(this);
  this.shape$3 = null;
  this.map$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser.prototype.productPrefix__T = (function() {
  return "NilShapeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser(x$1).$$outer$1 === this.$$outer$1))) {
    var NilShapeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser(x$1);
    var x = this.shape$3;
    var x$2 = NilShapeParser$1.shape$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var this$1 = this.map$3;
      var b = NilShapeParser$1.map$3;
      return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$3;
      break
    }
    case 1: {
      return this.map$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lamf_plugins_domain_shapes_models_NilShape__Lorg_yaml_model_YMap = (function($$outer, shape, map) {
  this.shape$3 = shape;
  this.map$3 = map;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.call(this, $$outer);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser.prototype.map__Lorg_yaml_model_YMap = (function() {
  return this.map$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser.prototype.shape__Lamf_core_model_domain_Shape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser.prototype.shape__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$NilShapeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$NilShapeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$NilShapeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_ExampleParser: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NilShapeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.call(this);
  this.shape$3 = null;
  this.map$3 = null;
  this.adopt$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser.prototype.productPrefix__T = (function() {
  return "TupleShapeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser(x$1).$$outer$1 === this.$$outer$1))) {
    var TupleShapeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser(x$1);
    var x = this.shape$3;
    var x$2 = TupleShapeParser$1.shape$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var this$1 = this.map$3;
      var b = TupleShapeParser$1.map$3;
      var jsx$1 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.adopt$3;
      var x$4 = TupleShapeParser$1.adopt$3;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$3;
      break
    }
    case 1: {
      return this.map$3;
      break
    }
    case 2: {
      return this.adopt$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser.prototype.map__Lorg_yaml_model_YMap = (function() {
  return this.map$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_TupleShape = (function() {
  this.adopt$3.apply__O__O(this.shape$3);
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape.call(this);
  this.parseInheritance__V();
  var map = this.map$3;
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$2 = this.$$outer$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MinItems$1;
  var iv = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$1.key__T__F1__V("minItems", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$2, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$3).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var map$1 = this.map$3;
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var this$4 = this.$$outer$1;
  var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().MaxItems$1;
  var iv$1 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$2.key__T__F1__V("maxItems", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$4, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$3).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var map$2 = this.map$3;
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var this$6 = this.$$outer$1;
  var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().UniqueItems$1;
  var iv$2 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$3.key__T__F1__V("uniqueItems", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$6, field$2, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$3).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var map$3 = this.map$3;
  var itemsField = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3).key__T__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("tuple").asRamlAnnotation__T());
  var x = $m_s_None$();
  if ((!(x === itemsField))) {
    if ((itemsField instanceof $c_s_Some)) {
      var x2 = $as_s_Some(itemsField);
      var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var this$9 = entry.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
      var iv$3 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
      var jsx$9 = $as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$9, conversion, iv$3)).nodes$3;
      var jsx$8 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser$$anonfun$1().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser(this);
      var this$10 = $m_sc_IndexedSeq$();
      var jsx$7 = $as_sc_IterableLike(jsx$9.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$8, this$10.ReusableCBF$6));
      var this$11 = $m_sc_IndexedSeq$();
      var jsx$6 = $as_sc_TraversableLike(jsx$7.zipWithIndex__scg_CanBuildFrom__O(this$11.ReusableCBF$6));
      var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x0$1$2) {
          var x0$1 = $as_T2(x0$1$2);
          if ((x0$1 !== null)) {
            var elem = $as_Lorg_yaml_model_YNode(x0$1.$$und1__O());
            var index = x0$1.$$und2$mcI$sp__I();
            var jsx$5 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$();
            $m_Lorg_yaml_model_YNode$();
            var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
            var iv$4 = $this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
            var map$4 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(elem, conversion$1, iv$4));
            $m_Lorg_yaml_model_YNode$();
            return jsx$5.apply__Lorg_yaml_model_YNode__T__F1__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode(map$4, $m_Lorg_yaml_model_YType$().Map$1), ("member" + index), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, index$1) {
              return (function(item$2) {
                var item = $as_Lamf_core_model_domain_Shape(item$2);
                item.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject((($this$1.shape$3.id$1 + "/items/") + index$1), item.adopted$default$2__sc_Seq())
              })
            })($this, index)), $m_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$(), $this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext()).parse__s_Option()
          } else {
            throw new $c_s_MatchError().init___O(x0$1)
          }
        })
      })(this));
      var this$14 = $m_sc_IndexedSeq$();
      var items = $as_sc_IndexedSeq(jsx$6.map__F1__scg_CanBuildFrom__O(jsx$4, this$14.ReusableCBF$6));
      var this$16 = this.shape$3;
      var jsx$11 = $as_sc_TraversableLike(items.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
        return (function(x$20$2) {
          var x$20 = $as_s_Option(x$20$2);
          return x$20.isDefined__Z()
        })
      })(this))));
      var jsx$10 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
        return (function(x$21$2) {
          var x$21 = $as_s_Option(x$21$2);
          return $as_Lamf_core_model_domain_Shape(x$21.get__O())
        })
      })(this));
      var this$15 = $m_sc_IndexedSeq$();
      var items$1 = $as_sc_Seq(jsx$11.map__F1__scg_CanBuildFrom__O(jsx$10, this$15.ReusableCBF$6));
      var field$3 = $m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().TupleItems$2;
      $as_Lamf_plugins_domain_shapes_models_TupleShape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$16, field$3, items$1))
    } else {
      throw new $c_s_MatchError().init___O(itemsField)
    }
  };
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser.prototype.shape__Lamf_core_model_domain_Shape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser.prototype.shape__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lamf_plugins_domain_shapes_models_TupleShape__Lorg_yaml_model_YMap__F1 = (function($$outer, shape, map, adopt) {
  this.shape$3 = shape;
  this.map$3 = map;
  this.adopt$3 = adopt;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.call(this, $$outer);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$TupleShapeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$TupleShapeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$TupleShapeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_ExampleParser: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$TupleShapeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.call(this);
  this.map$3 = null;
  this.shape$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser.prototype.productPrefix__T = (function() {
  return "UnionShapeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser(x$1).$$outer$1 === this.$$outer$1))) {
    var UnionShapeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser(x$1);
    var this$1 = this.map$3;
    var b = UnionShapeParser$1.map$3;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.shape$3;
      var x$2 = UnionShapeParser$1.shape$3;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.map$3;
      break
    }
    case 1: {
      return this.shape$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser.prototype.map__Lorg_yaml_model_YMap = (function() {
  return this.map$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_UnionShape = (function() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape.call(this);
  var map = this.map$3;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("anyOf");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var evidence$2 = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var x1 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(this$4, evidence$2);
    if ((x1 instanceof $c_s_util_Right)) {
      var x2 = $as_s_util_Right(x1);
      var seq = $as_sc_Seq(x2.value$2);
      var this$5 = $m_sc_Seq$();
      var jsx$4 = $as_sc_TraversableLike(seq.zipWithIndex__scg_CanBuildFrom__O(this$5.ReusableCBFInstance$2));
      var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(x0$1$2) {
          var x0$1 = $as_T2(x0$1$2);
          if ((x0$1 !== null)) {
            var unionNode = $as_Lorg_yaml_model_YNode(x0$1.$$und1__O());
            var index = x0$1.$$und2$mcI$sp__I();
            return $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser($this.$$outer$1.typeParser__F5().apply__O__O__O__O__O__O(($m_s_package$(), new $c_s_util_Right().init___O(unionNode)), ("item" + index), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, index$1) {
              return (function(item$2) {
                var item = $as_Lamf_core_model_domain_Shape(item$2);
                item.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject((($this$1.shape$3.id$1 + "/items/") + index$1), item.adopted$default$2__sc_Seq())
              })
            })($this, index)), $this.$$outer$1.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$typeInfo$f.isAnnotation$1, $m_Lamf_plugins_document_webapi_parser_spec_declaration_AnyDefaultType$())).parse__s_Option()
          } else {
            throw new $c_s_MatchError().init___O(x0$1)
          }
        })
      })(this));
      var this$7 = $m_sc_Seq$();
      var jsx$2 = $as_sc_TraversableLike($as_sc_TraversableLike(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$3, this$7.ReusableCBFInstance$2)).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
        return (function(x$12$2) {
          var x$12 = $as_s_Option(x$12$2);
          return x$12.isDefined__Z()
        })
      })(this))));
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
        return (function(x$13$2) {
          var x$13 = $as_s_Option(x$13$2);
          return $as_Lamf_core_model_domain_Shape(x$13.get__O())
        })
      })(this));
      var this$8 = $m_sc_Seq$();
      var unionNodes = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$8.ReusableCBFInstance$2));
      var this$9 = this.shape$3;
      var field = $m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1;
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
      $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$9, field, unionNodes, annotations)
    } else {
      var this$10 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1;
      var specification = $m_Lamf_validation_DialectValidations$().InvalidUnionType$1;
      var node = this.shape$3.id$1;
      var prop = $m_s_None$();
      var l = entry.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$10, specification, node, prop, "Unions are built from multiple shape nodes", l)
    }
  };
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YMap__Lamf_plugins_domain_shapes_models_UnionShape = (function($$outer, map, shape) {
  this.map$3 = map;
  this.shape$3 = shape;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.call(this, $$outer);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser.prototype.shape__Lamf_core_model_domain_Shape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser.prototype.shape__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$UnionShapeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$UnionShapeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$UnionShapeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_ExampleParser: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$UnionShapeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.call(this);
  this.scalar$3 = null;
  this.ordering$3 = null;
  this.references$3 = null;
  this.isHeader$3 = false;
  this.spec$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter.prototype.productPrefix__T = (function() {
  return "OasFileShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_FileShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(scalar, ordering, references, isHeader, spec) {
  this.scalar$3 = scalar;
  this.ordering$3 = ordering;
  this.references$3 = references;
  this.isHeader$3 = isHeader;
  this.spec$3 = spec;
  var x$5 = $m_sci_Nil$();
  var x$6 = $m_sci_Nil$();
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.call(this, scalar, ordering, references, x$5, x$6, isHeader, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter.prototype.typeDef__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter)) {
    var OasFileShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter(x$1);
    var x = this.scalar$3;
    var x$2 = OasFileShapeEmitter$1.scalar$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$3;
      var x$4 = OasFileShapeEmitter$1.ordering$3;
      var jsx$2 = (x$3 === x$4)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.references$3;
      var x$6 = OasFileShapeEmitter$1.references$3;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.isHeader$3 === OasFileShapeEmitter$1.isHeader$3)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.scalar$3;
      break
    }
    case 1: {
      return this.ordering$3;
      break
    }
    case 2: {
      return this.references$3;
      break
    }
    case 3: {
      return this.isHeader$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter.prototype.emitters__sc_Seq = (function() {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.prototype.emitters__sc_Seq.call(this)));
  var this$1 = this.scalar$3;
  var fs = this$1.fields$2;
  result.$$plus$eq__O__scm_ListBuffer(this.spec$3.oasTypePropertyEmitter__T__Lamf_core_model_domain_Shape__Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter("file", this.scalar$3));
  $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__emitCommonFields__Lamf_core_parser_Fields__scm_ListBuffer__V(this, fs, result);
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$().FileTypes$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType(new $c_Lamf_core_utils_package$AmfStrings().init___T("fileTypes").asOasExtension__T(), f, this.ordering$3, false, $m_Lorg_yaml_model_YType$().Str$1)))
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter.prototype.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function() {
  return this.spec$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.scalar$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ordering$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.references$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.isHeader$3 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 4)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasFileShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasFileShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasFileShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFormatTranslator: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasFileShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.call(this);
  this.scalar$3 = null;
  this.ordering$3 = null;
  this.references$3 = null;
  this.isHeader$3 = false;
  this.spec$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter.prototype.productPrefix__T = (function() {
  return "OasScalarShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter.prototype.typeDef__s_Option = (function() {
  var this$1 = this.scalar$3;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1)).option$1;
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var iri = $as_T(arg1);
    return new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$().typeDef__T__Lamf_plugins_domain_shapes_models_TypeDef(iri))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter)) {
    var OasScalarShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter(x$1);
    var x = this.scalar$3;
    var x$2 = OasScalarShapeEmitter$1.scalar$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$3;
      var x$4 = OasScalarShapeEmitter$1.ordering$3;
      var jsx$2 = (x$3 === x$4)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.references$3;
      var x$6 = OasScalarShapeEmitter$1.references$3;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.isHeader$3 === OasScalarShapeEmitter$1.isHeader$3)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.scalar$3;
      break
    }
    case 1: {
      return this.ordering$3;
      break
    }
    case 2: {
      return this.references$3;
      break
    }
    case 3: {
      return this.isHeader$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter.prototype.emitters__sc_Seq = (function() {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.prototype.emitters__sc_Seq.call(this)));
  var this$1 = this.scalar$3;
  var fs = this$1.fields$2;
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    var typeDefStr = this.spec$3.typeDefMatcher__Lamf_plugins_document_webapi_parser_OasTypeDefStringValueMatcher().matchType__Lamf_plugins_domain_shapes_models_TypeDef__T($as_Lamf_plugins_domain_shapes_models_TypeDef(this.typeDef__s_Option().get__O()));
    var this$3 = this.scalar$3;
    var x1 = this$3.annotations$2.find__jl_Class__s_Option($d_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo.getClassOf());
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var lexicalInfo = $as_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo(x2.value$2);
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", typeDefStr, $m_Lorg_yaml_model_YType$().Str$1, lexicalInfo.range$1.start$1))
    } else {
      var this$4 = $m_Lamf_core_emitter_BaseEmitters_package$();
      var annotations = f.value$1.annotations$1;
      var x$3 = this$4.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf());
      var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
      result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", typeDefStr, x$4, x$3))
    }
  };
  var x1$1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Format$1);
  if ((!(x1$1 instanceof $c_s_Some))) {
    var x = $m_s_None$();
    if ((x === x1$1)) {
      var this$7 = this.spec$3.typeDefMatcher__Lamf_plugins_document_webapi_parser_OasTypeDefStringValueMatcher();
      var this$6 = this.typeDef__s_Option();
      var typeDef = $as_Lamf_plugins_domain_shapes_models_TypeDef((this$6.isEmpty__Z() ? $m_Lamf_plugins_domain_shapes_models_TypeDef$UndefinedType$() : this$6.get__O()));
      var x1$2 = $f_Lamf_plugins_document_webapi_parser_OasTypeDefStringValueMatcher__matchFormat__Lamf_plugins_domain_shapes_models_TypeDef__s_Option(this$7, typeDef);
      if ((x1$2 instanceof $c_s_Some)) {
        var x2$1 = $as_s_Some(x1$2);
        var format = $as_T(x2$1.value$2);
        result.$$plus$eq__O__scm_ListBuffer($m_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$().apply__T__Lamf_core_metamodel_Field__O__Lamf_core_parser_Annotations__Lamf_core_emitter_BaseEmitters_package$ValueEmitter("format", $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Format$1, $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFormatTranslator__checkRamlFormats__T__T(this, format), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___())))
      } else {
        var x$3$1 = $m_s_None$();
        if ((!(x$3$1 === x1$2))) {
          throw new $c_s_MatchError().init___O(x1$2)
        }
      }
    } else {
      throw new $c_s_MatchError().init___O(x1$1)
    }
  };
  $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter__emitCommonFields__Lamf_core_parser_Fields__scm_ListBuffer__V(this, fs, result);
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter.prototype.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function() {
  return this.spec$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(scalar, ordering, references, isHeader, spec) {
  this.scalar$3 = scalar;
  this.ordering$3 = ordering;
  this.references$3 = references;
  this.isHeader$3 = isHeader;
  this.spec$3 = spec;
  var x$5 = $m_sci_Nil$();
  var x$6 = $m_sci_Nil$();
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext.call(this, scalar, ordering, references, x$5, x$6, isHeader, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.scalar$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.ordering$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.references$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.isHeader$3 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 4)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasScalarShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasScalarShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.oas.OasScalarShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasAnyShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasShapeEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasCommonOASFieldsEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFormatTranslator: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasScalarShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.call(this);
  this.scalar$3 = null;
  this.ordering$3 = null;
  this.references$3 = null;
  this.spec$3 = null;
  this.typeName$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter.prototype.productPrefix__T = (function() {
  return "RamlFileShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter.prototype.typeName__s_Option = (function() {
  return this.typeName$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter)) {
    var RamlFileShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter(x$1);
    var x = this.scalar$3;
    var x$2 = RamlFileShapeEmitter$1.scalar$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$3;
      var x$4 = RamlFileShapeEmitter$1.ordering$3;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$3;
      var x$6 = RamlFileShapeEmitter$1.references$3;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.scalar$3;
      break
    }
    case 1: {
      return this.ordering$3;
      break
    }
    case 2: {
      return this.references$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter.prototype.emitters__sc_Seq = (function() {
  var result = $as_scm_ListBuffer($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype.emitters__sc_Seq.call(this)));
  var this$1 = this.scalar$3;
  var fs = this$1.fields$2;
  var spec = this.spec$3;
  $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlCommonOASFieldsEmitter__emitOASFields__Lamf_core_parser_Fields__scm_ListBuffer__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__V(this, fs, result, spec);
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$().FileTypes$1);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var f = $as_Lamf_core_parser_FieldEntry(arg1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType("fileTypes", f, this.ordering$3, false, $m_Lorg_yaml_model_YType$().Str$1)))
  };
  var this$4 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Pattern$1);
  if ((!this$4.isEmpty__Z())) {
    var arg1$1 = this$4.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("pattern").asRamlAnnotation__T(), $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlCommonOASFieldsEmitter__processRamlPattern__Lamf_core_parser_FieldEntry__Lamf_core_parser_FieldEntry(this, f$3), $m_s_None$())))
  };
  var this$7 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Minimum$1);
  if ((!this$7.isEmpty__Z())) {
    var arg1$2 = this$7.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("minimum").asRamlAnnotation__T(), f$4, $m_s_None$())))
  };
  var this$10 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Maximum$1);
  if ((!this$10.isEmpty__Z())) {
    var arg1$3 = this$10.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("maximum").asRamlAnnotation__T(), f$5, $m_s_None$())))
  };
  var this$13 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MultipleOf$1);
  if ((!this$13.isEmpty__Z())) {
    var arg1$4 = this$13.get__O();
    var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("multipleOf").asRamlAnnotation__T(), f$6, $m_s_None$())))
  };
  if (result.isEmpty__Z()) {
    var jsx$1 = true
  } else if ((result.len$6 === 1)) {
    var this$16 = this.scalar$3;
    var this$17 = this$16.fields$2.$$qmark__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Examples$1);
    var jsx$1 = this$17.isDefined__Z()
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", "file", $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()))
  };
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_FileShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(scalar, ordering, references, spec) {
  this.scalar$3 = scalar;
  this.ordering$3 = ordering;
  this.references$3 = references;
  this.spec$3 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this, scalar, ordering, references, spec);
  this.typeName$3 = new $c_s_Some().init___O("file");
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlFileShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlFileShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlFileShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlCommonOASFieldsEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlFileShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.call(this);
  this.scalar$3 = null;
  this.ordering$3 = null;
  this.references$3 = null;
  this.spec$3 = null;
  this.rawTypeDef$3 = null;
  this.x$1$3 = null;
  this.typeDef$3 = null;
  this.format$3 = null;
  this.valuesTag$3 = null;
  this.typeName$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter.prototype.productPrefix__T = (function() {
  return "RamlScalarShapeEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter.prototype.typeName__s_Option = (function() {
  return this.typeName$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter)) {
    var RamlScalarShapeEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter(x$1);
    var x = this.scalar$3;
    var x$2 = RamlScalarShapeEmitter$1.scalar$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.ordering$3;
      var x$4 = RamlScalarShapeEmitter$1.ordering$3;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.references$3;
      var x$6 = RamlScalarShapeEmitter$1.references$3;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.scalar$3;
      break
    }
    case 1: {
      return this.ordering$3;
      break
    }
    case 2: {
      return this.references$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter.prototype.emitFormat__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_core_parser_Fields__s_Option__s_Option = (function(rawTypeDef, fs, format) {
  var formatKey = ((!(!($f_Lamf_plugins_domain_shapes_models_TypeDef__isNumber__Z(rawTypeDef) | $f_Lamf_plugins_domain_shapes_models_TypeDef__isDate__Z(rawTypeDef)))) ? "format" : new $c_Lamf_core_utils_package$AmfStrings().init___T("format").asRamlAnnotation__T());
  var translationFormats = $as_sci_Set($m_Lamf_plugins_document_webapi_parser_OasTypeDefMatcher$().knownFormats$1.diff__sc_GenSet__sc_Set($m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$().knownFormats$1));
  var this$2 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Format$1);
  if (this$2.isEmpty__Z()) {
    var explicitFormatOption = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var x0$1 = $as_Lamf_core_parser_FieldEntry(arg1);
    if ((x0$1.value$1.value$1 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
      var entryFormat = $objectToString($as_Lamf_core_model_domain_AmfScalar(x0$1.value$1.value$1).value$1);
      var this$3 = new $c_s_Some().init___O(entryFormat);
      var arg1$1 = this$3.value$2;
      var fmt = $as_T(arg1$1);
      if ((!translationFormats.contains__O__Z(fmt))) {
        var explicitFormatOption = this$3
      } else {
        var explicitFormatOption = $m_s_None$()
      }
    } else {
      var explicitFormatOption = $m_s_None$()
    }
  };
  var finalFormatOption = (explicitFormatOption.isEmpty__Z() ? format : explicitFormatOption);
  var x1 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Format$1);
  matchEnd4: {
    var annotations;
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var entry = $as_Lamf_core_parser_FieldEntry(x2.value$2);
      if ((entry.value$1.value$1 instanceof $c_Lamf_core_model_domain_AmfScalar)) {
        var annotations = entry.value$1.annotations$1;
        break matchEnd4
      }
    };
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___()
  };
  var isExplicit = explicitFormatOption.isDefined__Z();
  if (finalFormatOption.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1$2 = finalFormatOption.get__O();
    var x0$2 = $as_T(arg1$2);
    return new $c_s_Some().init___O((((x0$2 === "float") && isExplicit) ? $m_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$().apply__T__Lamf_core_metamodel_Field__O__Lamf_core_parser_Annotations__Lamf_core_emitter_BaseEmitters_package$ValueEmitter(formatKey, $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Format$1, "float", annotations) : (((x0$2 === "int32") && isExplicit) ? $m_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$().apply__T__Lamf_core_metamodel_Field__O__Lamf_core_parser_Annotations__Lamf_core_emitter_BaseEmitters_package$ValueEmitter(formatKey, $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Format$1, "int32", annotations) : $m_Lamf_core_emitter_BaseEmitters_package$RawValueEmitter$().apply__T__Lamf_core_metamodel_Field__O__Lamf_core_parser_Annotations__Lamf_core_emitter_BaseEmitters_package$ValueEmitter(formatKey, $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Format$1, x0$2, annotations))))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter.prototype.emitters__sc_Seq = (function() {
  var this$1 = this.scalar$3;
  var fs = this$1.fields$2;
  var this$2 = this.scalar$3;
  if ($as_sc_Seq(this$2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).isEmpty__Z()) {
    var this$3 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1);
    if (this$3.isEmpty__Z()) {
      var typeEmitterOption = $m_s_None$()
    } else {
      var arg1 = this$3.get__O();
      var f = $as_Lamf_core_parser_FieldEntry(arg1);
      if ((!f.value$1.annotations$1.contains__jl_Class__Z($d_Lamf_plugins_document_webapi_annotations_Inferred.getClassOf()))) {
        var this$4 = this.scalar$3;
        this$4.fields$2.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1);
        var x$2 = this.typeDef$3;
        var this$5 = $m_Lamf_core_emitter_BaseEmitters_package$();
        var annotations = f.value$1.annotations$1;
        var x$3 = this$5.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf());
        var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
        var typeEmitterOption = new $c_s_Some().init___O(new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("type", x$2, x$4, x$3))
      } else {
        var typeEmitterOption = $m_s_None$()
      }
    }
  } else {
    var typeEmitterOption = $m_s_None$()
  };
  var this$8 = $as_scm_BufferLike($m_scm_ListBuffer$().apply__sc_Seq__sc_GenTraversable($c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype.emitters__sc_Seq.call(this)));
  var xs = typeEmitterOption.toList__sci_List();
  var result = $as_scm_ListBuffer($as_scm_Buffer(this$8.clone__scm_Buffer().$$plus$plus$eq__sc_TraversableOnce__scg_Growable(xs)));
  var spec = this.spec$3;
  $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlCommonOASFieldsEmitter__emitOASFields__Lamf_core_parser_Fields__scm_ListBuffer__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__V(this, fs, result, spec);
  var this$9 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Pattern$1);
  if ((!this$9.isEmpty__Z())) {
    var arg1$1 = this$9.get__O();
    var f$3 = $as_Lamf_core_parser_FieldEntry(arg1$1);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("pattern", $f_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlCommonOASFieldsEmitter__processRamlPattern__Lamf_core_parser_FieldEntry__Lamf_core_parser_FieldEntry(this, f$3), $m_s_None$(), this.spec$3)))
  };
  var this$11 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Minimum$1);
  if ((!this$11.isEmpty__Z())) {
    var arg1$2 = this$11.get__O();
    var f$4 = $as_Lamf_core_parser_FieldEntry(arg1$2);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("minimum", f$4, new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$().convert__Lamf_plugins_domain_shapes_models_TypeDef__Lorg_yaml_model_YType(this.rawTypeDef$3)))))
  };
  var this$12 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Maximum$1);
  if ((!this$12.isEmpty__Z())) {
    var arg1$3 = this$12.get__O();
    var f$5 = $as_Lamf_core_parser_FieldEntry(arg1$3);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer(new $c_Lamf_core_emitter_BaseEmitters_package$ValueEmitter().init___T__Lamf_core_parser_FieldEntry__s_Option("maximum", f$5, new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$().convert__Lamf_plugins_domain_shapes_models_TypeDef__Lorg_yaml_model_YType(this.rawTypeDef$3)))))
  };
  var this$13 = fs.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MultipleOf$1);
  if ((!this$13.isEmpty__Z())) {
    var arg1$4 = this$13.get__O();
    var f$6 = $as_Lamf_core_parser_FieldEntry(arg1$4);
    new $c_s_Some().init___O(result.$$plus$eq__O__scm_ListBuffer($m_Lamf_plugins_document_webapi_contexts_emitter_raml_RamlScalarEmitter$().apply__T__Lamf_core_parser_FieldEntry__s_Option__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__Lamf_core_emitter_EntryEmitter("multipleOf", f$6, new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_NumberTypeToYTypeConverter$().convert__Lamf_plugins_domain_shapes_models_TypeDef__Lorg_yaml_model_YType(this.rawTypeDef$3)), this.spec$3)))
  };
  var xo = this.emitFormat__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_core_parser_Fields__s_Option__s_Option(this.rawTypeDef$3, fs, this.format$3);
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(xo.toList__sci_List());
  return result
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext = (function(scalar, ordering, references, spec) {
  this.scalar$3 = scalar;
  this.ordering$3 = ordering;
  this.references$3 = references;
  this.spec$3 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape__Lamf_core_emitter_SpecOrdering__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_raml_RamlSpecEmitterContext.call(this, scalar, ordering, references, spec);
  var jsx$1 = $m_Lamf_plugins_domain_shapes_parser_TypeDefXsdMapping$();
  var this$1 = $as_Lamf_core_model_StrField(scalar.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1));
  var this$2 = this$1.option$1;
  this.rawTypeDef$3 = jsx$1.typeDef__T__Lamf_plugins_domain_shapes_models_TypeDef($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())));
  var x1 = $m_Lamf_plugins_document_webapi_parser_RamlTypeDefStringValueMatcher$().matchType__Lamf_plugins_domain_shapes_models_TypeDef__s_Option__Lamf_plugins_document_webapi_parser_TypeName(this.rawTypeDef$3, $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__format__Lamf_core_model_StrField(scalar).option$1);
  if ((x1 !== null)) {
    var typeDef = x1.typeDef$1;
    var format = x1.format$1;
    var jsx$2 = new $c_T2().init___O__O(typeDef, format)
  } else {
    var jsx$2;
    throw new $c_s_MatchError().init___O(x1)
  };
  this.x$1$3 = jsx$2;
  this.typeDef$3 = $as_T(this.x$1$3.$$und1__O());
  this.format$3 = $as_s_Option(this.x$1$3.$$und2__O());
  this.valuesTag$3 = $m_Lamf_plugins_domain_shapes_parser_TypeDefYTypeMapping$().apply__Lamf_plugins_domain_shapes_models_TypeDef__Lorg_yaml_model_YType(this.rawTypeDef$3);
  this.typeName$3 = $m_s_None$();
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlScalarShapeEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlScalarShapeEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.emitters.raml.RamlScalarShapeEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlAnyShapeEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlShapeEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_ExamplesEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlCommonOASFieldsEmitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_raml_RamlScalarShapeEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter.call(this);
  this.document$3 = null;
  this.spec$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter.prototype.productPrefix__T = (function() {
  return "Oas2DocumentEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter)) {
    var Oas2DocumentEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter(x$1);
    var x = this.document$3;
    var x$2 = Oas2DocumentEmitter$1.document$3;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.document$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter.prototype.versionEntry__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  b.updateDynamic__T__Lorg_yaml_model_YNode__V("swagger", $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YScalar$().apply__O__Lorg_yaml_model_YScalar("2.0"), $m_Lorg_yaml_model_YType$().Str$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter.prototype.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function() {
  return this.spec$3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(document, spec) {
  this.document$3 = document;
  this.spec$3 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.call(this, document, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.Oas2DocumentEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.Oas2DocumentEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.Oas2DocumentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_BaseSpecEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter.call(this);
  this.document$3 = null;
  this.spec$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter.prototype.productPrefix__T = (function() {
  return "Oas3DocumentEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter)) {
    var Oas3DocumentEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter(x$1);
    var x = this.document$3;
    var x$2 = Oas3DocumentEmitter$1.document$3;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.document$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter.prototype.wrapDeclarations__sc_Seq__Lamf_core_emitter_SpecOrdering__sc_Seq = (function(emitters, ordering) {
  var jsx$1 = $m_sc_Seq$();
  var array = [new $c_Lamf_plugins_document_webapi_parser_spec_common_DeclarationsEmitterWrapper().init___sc_Seq__Lamf_core_emitter_SpecOrdering(emitters, ordering)];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter.prototype.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function() {
  return this.spec$3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter.prototype.versionEntry__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  b.updateDynamic__T__Lorg_yaml_model_YNode__V("openapi", $m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YScalar$().apply__O__Lorg_yaml_model_YScalar("3.0.0"), $m_Lorg_yaml_model_YType$().Str$1))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function(document, spec) {
  this.document$3 = document;
  this.spec$3 = spec;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter.prototype.init___Lamf_core_model_document_BaseUnit__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.call(this, document, spec);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.Oas3DocumentEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.Oas3DocumentEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.Oas3DocumentEmitter", {
  Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_BaseSpecEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_AccessibleOasDocumentEmitters: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser.call(this);
  this.root$2 = null;
  this.ctx$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(root, ctx) {
  this.root$2 = root;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser.prototype.init___Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.call(this, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser.prototype.productPrefix__T = (function() {
  return "OasModuleParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser)) {
    var OasModuleParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser(x$1);
    var x = this.root$2;
    var x$2 = OasModuleParser$1.root$2;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.root$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser.prototype.parseModule__Lamf_core_model_document_Module = (function() {
  var sourceVendor = new $c_Lamf_core_annotations_SourceVendor().init___Lamf_core_remote_Vendor(this.ctx$2.vendor__Lamf_core_remote_Vendor());
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations($as_Lamf_core_parser_SyamlParsedDocument(this.root$2.parsed$1).document$2);
  var this$3 = new $c_Lamf_core_model_document_Module().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var location = this.root$2.location$1;
  var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
  var qual$1 = $as_Lamf_core_model_document_Module($as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$3, field, location)));
  var x$1 = this.root$2.location$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$4 = $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1);
  var module = $as_Lamf_core_model_document_Module($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$4, sourceVendor));
  var field$1 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
  var value = this.root$2.location$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(module, field$1, value);
  var node = $as_Lamf_core_parser_SyamlParsedDocument(this.root$2.parsed$1).document$2;
  var this$6 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YMapYRead$());
  if ((!this$6.isEmpty__Z())) {
    var arg1 = this$6.get__O();
    var rootMap = $as_Lorg_yaml_model_YMap(arg1);
    var references = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser().init___Lamf_core_model_document_BaseUnit__T__Lorg_yaml_model_YMap__sc_Seq__Lamf_plugins_document_webapi_contexts_WebApiContext(module, new $c_Lamf_core_utils_package$AmfStrings().init___T("uses").asOasExtension__T(), rootMap, this.root$2.references$1, this.ctx$2).parse__T__Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations(this.root$2.location$1);
    new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser().init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.root$2, this.ctx$2).parseDeclarations__Lamf_core_Root__Lorg_yaml_model_YMap__V(this.root$2, rootMap);
    new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser().init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser__Lorg_yaml_model_YMap__Lamf_core_model_document_BaseUnit(this, rootMap, module).parse__V();
    var declarable = this.ctx$2.declarations$4.declarables__sc_Seq();
    if (declarable.nonEmpty__Z()) {
      var field$2 = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
      $as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(module, field$2, declarable))
    };
    var this$8 = references.references$1;
    if ($f_sc_TraversableOnce__nonEmpty__Z(this$8)) {
      var references$1 = references.solvedReferences__sc_Seq();
      var field$3 = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
      $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(module, field$3, references$1))
    }
  };
  return module
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasModuleParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasModuleParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasModuleParser", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_WebApiBaseSpecParser: 1,
  Lamf_core_parser_BaseSpecParser: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasModuleParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.call(this);
  this.DocumentationItemFragmentParser$module$2 = null;
  this.DataTypeFragmentParser$module$2 = null;
  this.ResourceTypeFragmentParser$module$2 = null;
  this.TraitFragmentParser$module$2 = null;
  this.AnnotationFragmentParser$module$2 = null;
  this.SecuritySchemeFragmentParser$module$2 = null;
  this.NamedExampleFragmentParser$module$2 = null;
  this.root$2 = null;
  this.fragmentType$2 = null;
  this.ctx$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser.prototype.productPrefix__T = (function() {
  return "RamlFragmentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser.prototype.parseFragment__s_Option = (function() {
  var this$1 = $as_Lamf_core_parser_SyamlParsedDocument(this.root$2.parsed$1).document$2;
  var evidence$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var x1 = this$1.obj__Lorg_yaml_model_YObj().to__Lorg_yaml_convert_YRead__s_util_Either(evidence$1);
  if ((x1 instanceof $c_s_util_Right)) {
    var x2 = $as_s_util_Right(x1);
    var map = $as_Lorg_yaml_model_YMap(x2.value$2);
    var rootMap = map
  } else {
    var x = this.fragmentType$2;
    var x$2 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$();
    if ((!((x !== null) && x.equals__O__Z(x$2)))) {
      var this$2 = this.ctx$2.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidFragmentType$1;
      var node = this.root$2.location$1;
      var ast = $as_Lamf_core_parser_SyamlParsedDocument(this.root$2.parsed$1).document$2;
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$2, specification, node, prop, "Cannot parse empty map", l)
    };
    var rootMap = $m_Lorg_yaml_model_YMap$().empty$1
  };
  var x1$2 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParserAnnotations$().apply__T__Lorg_yaml_model_YMap__Lamf_core_Root__Lamf_plugins_document_webapi_contexts_WebApiContext__T2("uses", rootMap, this.root$2, this.ctx$2);
  if ((x1$2 === null)) {
    throw new $c_s_MatchError().init___O(x1$2)
  };
  var references = $as_Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations(x1$2.$$und1__O());
  var aliases = $as_s_Option(x1$2.$$und2__O());
  var encodedMap = $m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap($as_sc_IndexedSeq(rootMap.entries$3.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(e$2) {
      var e = $as_Lorg_yaml_model_YMapEntry(e$2);
      var this$3 = e.key$2;
      var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv = $this.ctx$2;
      if (($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv)).text$3 !== "usage")) {
        var this$4 = e.key$2;
        var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
        var iv$1 = $this.ctx$2;
        return ($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion$1, iv$1)).text$3 !== "uses")
      } else {
        return false
      }
    })
  })(this)))), this.root$2.location$1);
  var x1$3 = this.fragmentType$2;
  var x$3 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DocumentationItem$();
  if (x$3.equals__O__Z(x1$3)) {
    var optionFragment = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DocumentationItemFragmentParser().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser__Lorg_yaml_model_YMap(this, encodedMap).parse__Lamf_plugins_document_webapi_model_DocumentationItemFragment())
  } else {
    var x$5 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10DataType$();
    if (x$5.equals__O__Z(x1$3)) {
      var optionFragment = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$DataTypeFragmentParser().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser__Lorg_yaml_model_YMap(this, encodedMap).parse__Lamf_plugins_document_webapi_model_DataTypeFragment())
    } else {
      var x$7 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10ResourceType$();
      if (x$7.equals__O__Z(x1$3)) {
        var optionFragment = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$ResourceTypeFragmentParser().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser__Lorg_yaml_model_YMap(this, encodedMap).parse__Lamf_plugins_document_webapi_model_ResourceTypeFragment())
      } else {
        var x$9 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10Trait$();
        if (x$9.equals__O__Z(x1$3)) {
          var optionFragment = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$TraitFragmentParser().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser__Lorg_yaml_model_YMap(this, encodedMap).parse__Lamf_plugins_document_webapi_model_TraitFragment())
        } else {
          var x$11 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10AnnotationTypeDeclaration$();
          if (x$11.equals__O__Z(x1$3)) {
            var optionFragment = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$AnnotationFragmentParser().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser__Lorg_yaml_model_YMap(this, encodedMap).parse__Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment())
          } else {
            var x$13 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10SecurityScheme$();
            if (x$13.equals__O__Z(x1$3)) {
              var optionFragment = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$SecuritySchemeFragmentParser().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser__Lorg_yaml_model_YMap(this, encodedMap).parse__Lamf_plugins_document_webapi_model_SecuritySchemeFragment())
            } else {
              var x$15 = $m_Lamf_plugins_document_webapi_parser_RamlFragmentHeader$Raml10NamedExample$();
              if (x$15.equals__O__Z(x1$3)) {
                var this$5 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser$NamedExampleFragmentParser().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser__Lorg_yaml_model_YMap(this, encodedMap);
                var optionFragment = new $c_s_Some().init___O(this$5.$$outer$1.amf$plugins$document$webapi$parser$spec$raml$RamlFragmentParser$$buildExternalFragment__Lamf_core_model_document_ExternalFragment())
              } else {
                var optionFragment = $m_s_None$()
              }
            }
          }
        }
      }
    }
  };
  if ((optionFragment instanceof $c_s_Some)) {
    var x2$2 = $as_s_Some(optionFragment);
    var fragment = $as_Lamf_core_model_document_Fragment(x2$2.value$2);
    var this$7 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(rootMap);
    var this$8 = this$7.key__T__s_Option("usage");
    if ((!this$8.isEmpty__Z())) {
      var arg1 = this$8.get__O();
      var usage = $as_Lorg_yaml_model_YMapEntry(arg1);
      var field = $m_Lamf_core_metamodel_document_FragmentModel$().Usage$1;
      var this$9 = usage.value$2;
      var conversion$2 = $m_Lorg_yaml_convert_YRead$StringYRead$();
      var iv$2 = this.ctx$2;
      var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$9, conversion$2, iv$2), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(usage.value$2));
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(usage.value$2);
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(fragment, field, value, annotations)
    };
    var location = this.root$2.location$1;
    var field$1 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
    $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(fragment, field$1, location));
    new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser__Lorg_yaml_model_YMap__Lamf_core_model_document_BaseUnit(this, rootMap, fragment).parse__V();
    var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations($as_Lamf_core_parser_SyamlParsedDocument(this.root$2.parsed$1).document$2);
    $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(fragment, other);
    if (aliases.isDefined__Z()) {
      fragment.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations($as_Lamf_core_model_domain_Annotation(aliases.get__O()))
    };
    var this$10 = fragment.encodes__Lamf_core_model_domain_DomainElement();
    var annotation = new $c_Lamf_core_annotations_SourceVendor().init___Lamf_core_remote_Vendor($m_Lamf_core_remote_Raml10$());
    $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$10, annotation);
    var this$11 = references.references$1;
    if ($f_sc_TraversableOnce__nonEmpty__Z(this$11)) {
      var references$1 = references.solvedReferences__sc_Seq();
      var field$2 = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
      $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(fragment, field$2, references$1))
    };
    return new $c_s_Some().init___O(fragment)
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser)) {
    var RamlFragmentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser(x$1);
    var x = this.root$2;
    var x$2 = RamlFragmentParser$1.root$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.fragmentType$2;
      var x$4 = RamlFragmentParser$1.fragmentType$2;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.root$2;
      break
    }
    case 1: {
      return this.fragmentType$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser.prototype.amf$plugins$document$webapi$parser$spec$raml$RamlFragmentParser$$buildExternalFragment__Lamf_core_model_document_ExternalFragment = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_core_model_document_ExternalFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var location = this.root$2.location$1;
  var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
  var this$5 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, location));
  var value = this.root$2.location$1;
  var this$11 = $as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  $m_Lamf_core_parser_Annotations$();
  var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
  var this$9 = new $c_Lamf_core_model_domain_ExternalDomainElement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
  var text = this.root$2.raw$1;
  var field$1 = $m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1;
  var this$10 = $as_Lamf_core_model_domain_ExternalDomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$9, field$1, text));
  var mediaType = this.root$2.mediatype$1;
  var field$2 = $m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().MediaType$1;
  var encoded = $as_Lamf_core_model_domain_ExternalDomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$10, field$2, mediaType));
  var field$3 = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
  return $as_Lamf_core_model_document_ExternalFragment($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$11, field$3, encoded)))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_webapi_parser_RamlFragment__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(root, fragmentType, ctx) {
  this.root$2 = root;
  this.fragmentType$2 = fragmentType;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.prototype.init___Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$2
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlFragmentParser", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_WebApiBaseSpecParser: 1,
  Lamf_core_parser_BaseSpecParser: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlFragmentParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CallbackSelector$() {
  $c_Lamf_core_resolution_stages_selectors_MetaModelSelector.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CallbackSelector$.prototype = new $h_Lamf_core_resolution_stages_selectors_MetaModelSelector();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CallbackSelector$.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CallbackSelector$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CallbackSelector$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CallbackSelector$.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CallbackSelector$.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CallbackSelector$.prototype.init___ = (function() {
  $c_Lamf_core_resolution_stages_selectors_MetaModelSelector.prototype.init___Lamf_core_vocabulary_Namespace__T.call(this, $m_Lamf_core_vocabulary_Namespace$().ApiContract$1, "Callback");
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CallbackSelector$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CallbackSelector$: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.CallbackSelector$", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CallbackSelector$: 1,
  Lamf_core_resolution_stages_selectors_MetaModelSelector: 1,
  Lamf_core_resolution_stages_selectors_Selector: 1,
  O: 1,
  F1: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CallbackSelector$.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CallbackSelector$;
var $n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CallbackSelector$ = (void 0);
function $m_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CallbackSelector$() {
  if ((!$n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CallbackSelector$)) {
    $n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CallbackSelector$ = new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CallbackSelector$().init___()
  };
  return $n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_CallbackSelector$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ExampleSelector$() {
  $c_Lamf_core_resolution_stages_selectors_MetaModelSelector.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ExampleSelector$.prototype = new $h_Lamf_core_resolution_stages_selectors_MetaModelSelector();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ExampleSelector$.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ExampleSelector$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ExampleSelector$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ExampleSelector$.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ExampleSelector$.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ExampleSelector$.prototype.init___ = (function() {
  $c_Lamf_core_resolution_stages_selectors_MetaModelSelector.prototype.init___Lamf_core_vocabulary_Namespace__T.call(this, $m_Lamf_core_vocabulary_Namespace$().ApiContract$1, "Example");
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ExampleSelector$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ExampleSelector$: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.ExampleSelector$", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ExampleSelector$: 1,
  Lamf_core_resolution_stages_selectors_MetaModelSelector: 1,
  Lamf_core_resolution_stages_selectors_Selector: 1,
  O: 1,
  F1: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ExampleSelector$.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ExampleSelector$;
var $n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ExampleSelector$ = (void 0);
function $m_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ExampleSelector$() {
  if ((!$n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ExampleSelector$)) {
    $n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ExampleSelector$ = new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ExampleSelector$().init___()
  };
  return $n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ExampleSelector$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ParameterSelector$() {
  $c_Lamf_core_resolution_stages_selectors_MetaModelSelector.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ParameterSelector$.prototype = new $h_Lamf_core_resolution_stages_selectors_MetaModelSelector();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ParameterSelector$.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ParameterSelector$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ParameterSelector$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ParameterSelector$.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ParameterSelector$.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ParameterSelector$.prototype.init___ = (function() {
  $c_Lamf_core_resolution_stages_selectors_MetaModelSelector.prototype.init___Lamf_core_vocabulary_Namespace__T.call(this, $m_Lamf_core_vocabulary_Namespace$().ApiContract$1, "Parameter");
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ParameterSelector$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ParameterSelector$: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.ParameterSelector$", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ParameterSelector$: 1,
  Lamf_core_resolution_stages_selectors_MetaModelSelector: 1,
  Lamf_core_resolution_stages_selectors_Selector: 1,
  O: 1,
  F1: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ParameterSelector$.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ParameterSelector$;
var $n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ParameterSelector$ = (void 0);
function $m_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ParameterSelector$() {
  if ((!$n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ParameterSelector$)) {
    $n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ParameterSelector$ = new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ParameterSelector$().init___()
  };
  return $n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ParameterSelector$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PayloadSelector$() {
  $c_Lamf_core_resolution_stages_selectors_MetaModelSelector.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PayloadSelector$.prototype = new $h_Lamf_core_resolution_stages_selectors_MetaModelSelector();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PayloadSelector$.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PayloadSelector$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PayloadSelector$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PayloadSelector$.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PayloadSelector$.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PayloadSelector$.prototype.init___ = (function() {
  $c_Lamf_core_resolution_stages_selectors_MetaModelSelector.prototype.init___Lamf_core_vocabulary_Namespace__T.call(this, $m_Lamf_core_vocabulary_Namespace$().ApiContract$1, "Payload");
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PayloadSelector$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PayloadSelector$: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.PayloadSelector$", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PayloadSelector$: 1,
  Lamf_core_resolution_stages_selectors_MetaModelSelector: 1,
  Lamf_core_resolution_stages_selectors_Selector: 1,
  O: 1,
  F1: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PayloadSelector$.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PayloadSelector$;
var $n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PayloadSelector$ = (void 0);
function $m_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PayloadSelector$() {
  if ((!$n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PayloadSelector$)) {
    $n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PayloadSelector$ = new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PayloadSelector$().init___()
  };
  return $n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_PayloadSelector$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResponseSelector$() {
  $c_Lamf_core_resolution_stages_selectors_MetaModelSelector.call(this)
}
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResponseSelector$.prototype = new $h_Lamf_core_resolution_stages_selectors_MetaModelSelector();
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResponseSelector$.prototype.constructor = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResponseSelector$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResponseSelector$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResponseSelector$.prototype = $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResponseSelector$.prototype;
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResponseSelector$.prototype.init___ = (function() {
  $c_Lamf_core_resolution_stages_selectors_MetaModelSelector.prototype.init___Lamf_core_vocabulary_Namespace__T.call(this, $m_Lamf_core_vocabulary_Namespace$().ApiContract$1, "Response");
  return this
});
var $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResponseSelector$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResponseSelector$: 0
}, false, "amf.plugins.document.webapi.resolution.pipelines.compatibility.raml.ResponseSelector$", {
  Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResponseSelector$: 1,
  Lamf_core_resolution_stages_selectors_MetaModelSelector: 1,
  Lamf_core_resolution_stages_selectors_Selector: 1,
  O: 1,
  F1: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1
});
$c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResponseSelector$.prototype.$classData = $d_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResponseSelector$;
var $n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResponseSelector$ = (void 0);
function $m_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResponseSelector$() {
  if ((!$n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResponseSelector$)) {
    $n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResponseSelector$ = new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResponseSelector$().init___()
  };
  return $n_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_raml_ResponseSelector$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$() {
  $c_O.call(this);
  this.Is$1 = null;
  this.Exchange$1 = null;
  this.Queue$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.key$1 = null;
  this.BindingVersion$1 = null;
  this.Type$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingType__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Is$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "is"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "is", "Defines what type of channel is it", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Exchange$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "exchange"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "exchange", "Defines the exchange properties", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Queue$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "queue"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "queue", "Defines the queue properties", $m_sci_Nil$()), true);
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "Amqp091ChannelBinding");
  var this$12 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$12);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "Amqp091ChannelBinding", "", $m_sci_Nil$());
  this.key$1 = this.Type$1;
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingType$$undsetter$und$Type$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Type$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Is$1, this.Exchange$1, this.Queue$1, this.BindingVersion$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$().fields__sci_List();
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingVersion$$undsetter$und$BindingVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.BindingVersion$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.Amqp091ChannelBindingModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingType: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$() {
  $c_O.call(this);
  this.ContentEncoding$1 = null;
  this.MessageType$1 = null;
  this.type$1 = null;
  this.key$1 = null;
  this.doc$1 = null;
  this.BindingVersion$1 = null;
  this.Type$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingType__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.ContentEncoding$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "contentEncoding"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "contentEncoding", "MIME encoding for the message content", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.MessageType$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "messageType"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "messageType", "Application-specific message type", $m_sci_Nil$()), true);
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$5 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "Amqp091MessageBinding");
  var this$9 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$5, this$9);
  this.key$1 = this.Type$1;
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "Amqp091MessageBinding", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingType$$undsetter$und$Type$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Type$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.ContentEncoding$1, this.MessageType$1, this.BindingVersion$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$().fields__sci_List();
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingVersion$$undsetter$und$BindingVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.BindingVersion$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.Amqp091MessageBindingModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingType: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$() {
  $c_O.call(this);
  this.Expiration$1 = null;
  this.UserId$1 = null;
  this.CC$1 = null;
  this.Priority$1 = null;
  this.DeliveryMode$1 = null;
  this.Mandatory$1 = null;
  this.BCC$1 = null;
  this.ReplyTo$1 = null;
  this.Timestamp$1 = null;
  this.Ack$1 = null;
  this.type$1 = null;
  this.key$1 = null;
  this.doc$1 = null;
  this.BindingVersion$1 = null;
  this.Type$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingType__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Int$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Expiration$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "expiration"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "expiration", "TTL (Time-To-Live) for the message", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.UserId$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "userId"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "userId", "Identifies the user who has sent the message", $m_sci_Nil$()), true);
  var jsx$3 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Str$());
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.CC$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "cc"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "cc", "The routing keys the message should be routed to at the time of publishing", $m_sci_Nil$()), true);
  var jsx$4 = $m_Lamf_core_metamodel_Type$Int$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Priority$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "priority"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "priority", "A priority for the message", $m_sci_Nil$()), true);
  var jsx$5 = $m_Lamf_core_metamodel_Type$Int$();
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.DeliveryMode$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "deliveryMode"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "deliveryMode", "Delivery mode of the message", $m_sci_Nil$()), true);
  var jsx$6 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Mandatory$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$6, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "mandatory"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "mandatory", "Whether the message is mandatory or not", $m_sci_Nil$()), true);
  var jsx$7 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Str$());
  var this$19 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.BCC$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$7, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$19, "bcc"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "bcc", "Like cc but consumers will not receive this information", $m_sci_Nil$()), true);
  var jsx$8 = $m_Lamf_core_metamodel_Type$Str$();
  var this$22 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.ReplyTo$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$8, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$22, "replyTo"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "replyTo", "Name of the queue where the consumer should send the response", $m_sci_Nil$()), true);
  var jsx$9 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$25 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Timestamp$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$9, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$25, "timestamp"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "timestamp", "Whether the message should include a timestamp or not", $m_sci_Nil$()), true);
  var jsx$10 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$28 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Ack$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$10, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$28, "ack"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "ack", "Whether the consumer should ack the message or not", $m_sci_Nil$()), true);
  var this$31 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$4 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$31, "Amqp091OperationBinding");
  var this$33 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$33);
  this.key$1 = this.Type$1;
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "Amqp091OperationBinding", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingType$$undsetter$und$Type$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Type$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Expiration$1, this.UserId$1, this.CC$1, this.Priority$1, this.DeliveryMode$1, this.Mandatory$1, this.BCC$1, this.ReplyTo$1, this.Timestamp$1, this.Ack$1, this.BindingVersion$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$().fields__sci_List();
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingVersion$$undsetter$und$BindingVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.BindingVersion$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.Amqp091OperationBindingModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingType: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$() {
  $c_O.call(this);
  this.MessageKey$1 = null;
  this.type$1 = null;
  this.key$1 = null;
  this.doc$1 = null;
  this.BindingVersion$1 = null;
  this.Type$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingType__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.MessageKey$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "messageKey"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "key", "The message key", $m_sci_Nil$()), true);
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "KafkaMessageBinding");
  var this$6 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$6);
  this.key$1 = this.Type$1;
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "KafkaMessageBinding", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingType$$undsetter$und$Type$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Type$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.MessageKey$1, this.BindingVersion$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$().fields__sci_List();
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingVersion$$undsetter$und$BindingVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.BindingVersion$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.KafkaMessageBindingModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingType: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$() {
  $c_O.call(this);
  this.GroupId$1 = null;
  this.ClientId$1 = null;
  this.key$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.BindingVersion$1 = null;
  this.Type$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingType__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.GroupId$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "groupId"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "groupId", "Id of the consumer group", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.ClientId$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "clientId"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "clientId", "Id of the consumer inside a consumer group", $m_sci_Nil$()), true);
  this.key$1 = this.Type$1;
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "KafkaOperationBinding");
  var this$9 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$9);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "KafkaOperationBinding", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingType$$undsetter$und$Type$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Type$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.GroupId$1, this.ClientId$1, this.BindingVersion$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$().fields__sci_List();
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingVersion$$undsetter$und$BindingVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.BindingVersion$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.KafkaOperationBindingModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingType: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$() {
  $c_O.call(this);
  this.key$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.BindingVersion$1 = null;
  this.Type$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingType__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion__$$init$__V(this);
  this.key$1 = this.Type$1;
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$4 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "MqttMessageBinding");
  var this$3 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$3);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "MqttMessageBinding", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingType$$undsetter$und$Type$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Type$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.BindingVersion$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$().fields__sci_List();
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingVersion$$undsetter$und$BindingVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.BindingVersion$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.MqttMessageBindingModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingType: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$() {
  $c_O.call(this);
  this.Qos$1 = null;
  this.Retain$1 = null;
  this.key$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.BindingVersion$1 = null;
  this.Type$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingType__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Int$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Qos$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "qos"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "qos", "Defines how hard the broker/client will try to ensure that a message is received", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Retain$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "retain"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "retain", "Whether the broker should retain the message or not", $m_sci_Nil$()), true);
  this.key$1 = this.Type$1;
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "MqttOperationBinding");
  var this$9 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$9);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "MqttOperationBinding", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingType$$undsetter$und$Type$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Type$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Qos$1, this.Retain$1, this.BindingVersion$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$().fields__sci_List();
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingVersion$$undsetter$und$BindingVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.BindingVersion$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.MqttOperationBindingModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingType: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$() {
  $c_O.call(this);
  this.ClientId$1 = null;
  this.CleanSession$1 = null;
  this.LastWill$1 = null;
  this.KeepAlive$1 = null;
  this.type$1 = null;
  this.key$1 = null;
  this.doc$1 = null;
  this.BindingVersion$1 = null;
  this.Type$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingType__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.ClientId$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "clientId"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "clientId", "The client identifier", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.CleanSession$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "cleanSession"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "cleanSession", "Whether to create a persistent connection or not", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerLastWillModel$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.LastWill$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "lastWill"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "lastWill", "Last Will and Testament configuration", $m_sci_Nil$()), true);
  var jsx$4 = $m_Lamf_core_metamodel_Type$Int$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.KeepAlive$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "keepAlive"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "keepAlive", "Interval in seconds of the longest period of time the broker and the client can endure without sending a message", $m_sci_Nil$()), true);
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "MqttServerBinding");
  var this$15 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$15);
  this.key$1 = this.Type$1;
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "MqttServerBinding", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingType$$undsetter$und$Type$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Type$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.ClientId$1, this.CleanSession$1, this.LastWill$1, this.KeepAlive$1, this.BindingVersion$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel$().fields__sci_List();
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingVersion$$undsetter$und$BindingVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.BindingVersion$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.MqttServerBindingModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingType: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$() {
  $c_O.call(this);
  this.Name$1 = null;
  this.Type$1 = null;
  this.Responses$1 = null;
  this.Settings$1 = null;
  this.key$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.Headers$1 = null;
  this.QueryParameters$1 = null;
  this.QueryString$1 = null;
  this.UriParameters$1 = null;
  this.DisplayName$1 = null;
  this.Description$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DisplayNameField__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_ParametersFieldModel__$$init$__V(this);
  var jsx$4 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var jsx$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "name");
  var jsx$2 = $m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1;
  var jsx$1 = $m_sc_Seq$();
  var this$3 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "name").iri__T()];
  this.Name$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, jsx$3, new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq(jsx$2, "name", "Name for the security scheme", $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))), true);
  var jsx$5 = $m_Lamf_core_metamodel_Type$Str$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.Type$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "type"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "type", "Type of security scheme", $m_sci_Nil$()), true);
  var jsx$6 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$());
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Responses$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$6, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "response"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "response", "Response associated to this security scheme", $m_sci_Nil$()), true);
  var jsx$7 = $m_Lamf_plugins_domain_webapi_metamodel_security_SettingsModel$();
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.Settings$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$7, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "settings"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "settings", "Security scheme settings", $m_sci_Nil$()), true);
  this.key$1 = this.Name$1;
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "SecurityScheme");
  var this$18 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$18);
  $m_sci_List$();
  var array$1 = [this.Name$1, this.Type$1, this.DisplayName$1, this.Description$1, this.Headers$1, this.QueryParameters$1, this.Responses$1, this.Settings$1, this.QueryString$1];
  var i = (((-1) + $uI(array$1.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$22 = result;
    var index = i;
    var x = array$1[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$22);
    i = (((-1) + i) | 0)
  };
  var jsx$11 = result;
  var jsx$10 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().fields$1;
  var this$23 = $m_sci_List$();
  var jsx$9 = $as_sci_List(jsx$11.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$10, this$23.ReusableCBFInstance$2));
  var jsx$8 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$24 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$9.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$8, this$24.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "Security Scheme", "Authentication and access control mechanism defined in an API", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$.prototype.amf$plugins$domain$webapi$metamodel$ParametersFieldModel$$undsetter$und$UriParameters$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.UriParameters$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$.prototype.amf$core$metamodel$domain$common$DisplayNameField$$undsetter$und$DisplayName$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DisplayName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$.prototype.amf$plugins$domain$webapi$metamodel$ParametersFieldModel$$undsetter$und$Headers$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Headers$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$.prototype.amf$plugins$domain$webapi$metamodel$ParametersFieldModel$$undsetter$und$QueryParameters$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.QueryParameters$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$.prototype.amf$plugins$domain$webapi$metamodel$ParametersFieldModel$$undsetter$und$QueryString$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.QueryString$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.security.SecuritySchemeModel$", {
  Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1,
  Lamf_core_metamodel_domain_common_DisplayNameField: 1,
  Lamf_plugins_domain_webapi_metamodel_ParametersFieldModel: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.doc$1 = null;
  this.DataNode$1 = null;
  this.Variables$1 = null;
  this.key$1 = null;
  this.Description$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel__$$init$__V(this);
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "ResourceType");
  var this$3 = $m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$3);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Resource Type", "Type of document base unit encoding a RAML resource type", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype.Description__Lamf_core_metamodel_Field = (function() {
  return this.Description$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype.Variables__Lamf_core_metamodel_Field = (function() {
  return this.Variables$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype.amf$core$metamodel$domain$templates$AbstractDeclarationModel$$undsetter$und$key$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.key$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype.fields__sci_List = (function() {
  return $f_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel__fields__sci_List(this)
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype.amf$core$metamodel$domain$templates$AbstractDeclarationModel$$undsetter$und$DataNode$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DataNode$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_templates_ResourceType().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype.DataNode__Lamf_core_metamodel_Field = (function() {
  return this.DataNode$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype.amf$core$metamodel$domain$templates$AbstractDeclarationModel$$undsetter$und$Variables$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Variables$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype.Name__Lamf_core_metamodel_Field = (function() {
  return this.Name$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.templates.ResourceTypeModel$", {
  Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_templates_AbstractDeclarationModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.doc$1 = null;
  this.DataNode$1 = null;
  this.Variables$1 = null;
  this.key$1 = null;
  this.Description$1 = null;
  this.Name$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel__$$init$__V(this);
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "Trait");
  var this$3 = $m_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$3);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Trait", "Type of document base unit encoding a RAML trait", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype.Description__Lamf_core_metamodel_Field = (function() {
  return this.Description$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype.Variables__Lamf_core_metamodel_Field = (function() {
  return this.Variables$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype.amf$core$metamodel$domain$templates$AbstractDeclarationModel$$undsetter$und$key$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.key$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype.fields__sci_List = (function() {
  return $f_Lamf_core_metamodel_domain_templates_AbstractDeclarationModel__fields__sci_List(this)
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype.amf$core$metamodel$domain$templates$AbstractDeclarationModel$$undsetter$und$DataNode$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DataNode$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_templates_Trait().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype.DataNode__Lamf_core_metamodel_Field = (function() {
  return this.DataNode$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype.amf$core$metamodel$domain$templates$AbstractDeclarationModel$$undsetter$und$Variables$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Variables$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype.Name__Lamf_core_metamodel_Field = (function() {
  return this.Name$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.templates.TraitModel$", {
  Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_templates_AbstractDeclarationModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_License() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_License.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_License.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_License;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_License() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_License.prototype = $c_Lamf_plugins_domain_webapi_models_License.prototype;
$c_Lamf_plugins_domain_webapi_models_License.prototype.productPrefix__T = (function() {
  return "License"
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_License)) {
    var License$1 = $as_Lamf_plugins_domain_webapi_models_License(x$1);
    var x = this.fields$1;
    var x$2 = License$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = License$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_LicenseModel$()
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.componentId__T = (function() {
  return "/license"
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_LicenseModel$().Name$1
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_domain_webapi_models_License(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_License) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.License"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_License(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_License)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_License(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_License(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.License;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_License = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_License: 0
}, false, "amf.plugins.domain.webapi.models.License", {
  Lamf_plugins_domain_webapi_models_License: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_License.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_License;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_Organization() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_Organization.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_Organization;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_Organization() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_Organization.prototype = $c_Lamf_plugins_domain_webapi_models_Organization.prototype;
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.productPrefix__T = (function() {
  return "Organization"
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_Organization)) {
    var Organization$1 = $as_Lamf_plugins_domain_webapi_models_Organization(x$1);
    var x = this.fields$1;
    var x$2 = Organization$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = Organization$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$()
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.componentId__T = (function() {
  return "/organization"
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$().Name$1
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_domain_webapi_models_Organization(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_Organization) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.Organization"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_Organization(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_Organization)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_Organization(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_Organization(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.Organization;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_Organization = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_Organization: 0
}, false, "amf.plugins.domain.webapi.models.Organization", {
  Lamf_plugins_domain_webapi_models_Organization: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_Organization.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_Organization;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings() {
  $c_Lamf_plugins_domain_webapi_models_security_Settings.call(this)
}
$c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings.prototype = new $h_Lamf_plugins_domain_webapi_models_security_Settings();
$c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_security_ApiKeySettings() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_security_ApiKeySettings.prototype = $c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings.prototype;
$c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings.prototype.productPrefix__T = (function() {
  return "ApiKeySettings"
});
$c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings)) {
    var ApiKeySettings$1 = $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(x$1);
    var x = this.fields$1;
    var x$2 = ApiKeySettings$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = ApiKeySettings$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$()
});
$c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings.prototype.componentId__T = (function() {
  return "/settings/api-key"
});
$c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  $c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.security.ApiKeySettings"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_security_ApiKeySettings)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.security.ApiKeySettings;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_security_ApiKeySettings = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_security_ApiKeySettings: 0
}, false, "amf.plugins.domain.webapi.models.security.ApiKeySettings", {
  Lamf_plugins_domain_webapi_models_security_ApiKeySettings: 1,
  Lamf_plugins_domain_webapi_models_security_Settings: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_security_ApiKeySettings;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings() {
  $c_Lamf_plugins_domain_webapi_models_security_Settings.call(this)
}
$c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings.prototype = new $h_Lamf_plugins_domain_webapi_models_security_Settings();
$c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings.prototype = $c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings.prototype;
$c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings.prototype.productPrefix__T = (function() {
  return "HttpApiKeySettings"
});
$c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings)) {
    var HttpApiKeySettings$1 = $as_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(x$1);
    var x = this.fields$1;
    var x$2 = HttpApiKeySettings$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = HttpApiKeySettings$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_security_HttpApiKeySettingsModel$()
});
$c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings.prototype.componentId__T = (function() {
  return "/settings/http-api-key"
});
$c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  $c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.security.HttpApiKeySettings"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.security.HttpApiKeySettings;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings: 0
}, false, "amf.plugins.domain.webapi.models.security.HttpApiKeySettings", {
  Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings: 1,
  Lamf_plugins_domain_webapi_models_security_Settings: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_security_HttpSettings() {
  $c_Lamf_plugins_domain_webapi_models_security_Settings.call(this)
}
$c_Lamf_plugins_domain_webapi_models_security_HttpSettings.prototype = new $h_Lamf_plugins_domain_webapi_models_security_Settings();
$c_Lamf_plugins_domain_webapi_models_security_HttpSettings.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_security_HttpSettings;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_security_HttpSettings() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_security_HttpSettings.prototype = $c_Lamf_plugins_domain_webapi_models_security_HttpSettings.prototype;
$c_Lamf_plugins_domain_webapi_models_security_HttpSettings.prototype.productPrefix__T = (function() {
  return "HttpSettings"
});
$c_Lamf_plugins_domain_webapi_models_security_HttpSettings.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_security_HttpSettings.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_security_HttpSettings)) {
    var HttpSettings$1 = $as_Lamf_plugins_domain_webapi_models_security_HttpSettings(x$1);
    var x = this.fields$1;
    var x$2 = HttpSettings$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = HttpSettings$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_security_HttpSettings.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_security_HttpSettings.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$()
});
$c_Lamf_plugins_domain_webapi_models_security_HttpSettings.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_security_HttpSettings.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_security_HttpSettings.prototype.componentId__T = (function() {
  return "/settings/http"
});
$c_Lamf_plugins_domain_webapi_models_security_HttpSettings.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_security_HttpSettings.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_security_HttpSettings.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_security_HttpSettings.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  $c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_security_HttpSettings(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_security_HttpSettings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.security.HttpSettings"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_security_HttpSettings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_security_HttpSettings)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_security_HttpSettings(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_security_HttpSettings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.security.HttpSettings;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_security_HttpSettings = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_security_HttpSettings: 0
}, false, "amf.plugins.domain.webapi.models.security.HttpSettings", {
  Lamf_plugins_domain_webapi_models_security_HttpSettings: 1,
  Lamf_plugins_domain_webapi_models_security_Settings: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_security_HttpSettings.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_security_HttpSettings;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings() {
  $c_Lamf_plugins_domain_webapi_models_security_Settings.call(this)
}
$c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings.prototype = new $h_Lamf_plugins_domain_webapi_models_security_Settings();
$c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_security_OAuth1Settings() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_security_OAuth1Settings.prototype = $c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings.prototype;
$c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings.prototype.productPrefix__T = (function() {
  return "OAuth1Settings"
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings)) {
    var OAuth1Settings$1 = $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(x$1);
    var x = this.fields$1;
    var x$2 = OAuth1Settings$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = OAuth1Settings$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$()
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings.prototype.componentId__T = (function() {
  return "/settings/oauth1"
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  $c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.security.OAuth1Settings"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_security_OAuth1Settings)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.security.OAuth1Settings;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_security_OAuth1Settings = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_security_OAuth1Settings: 0
}, false, "amf.plugins.domain.webapi.models.security.OAuth1Settings", {
  Lamf_plugins_domain_webapi_models_security_OAuth1Settings: 1,
  Lamf_plugins_domain_webapi_models_security_Settings: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_security_OAuth1Settings;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings() {
  $c_Lamf_plugins_domain_webapi_models_security_Settings.call(this)
}
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings.prototype = new $h_Lamf_plugins_domain_webapi_models_security_Settings();
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_security_OAuth2Settings() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_security_OAuth2Settings.prototype = $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings.prototype;
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings.prototype.productPrefix__T = (function() {
  return "OAuth2Settings"
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings)) {
    var OAuth2Settings$1 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(x$1);
    var x = this.fields$1;
    var x$2 = OAuth2Settings$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = OAuth2Settings$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$()
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings.prototype.componentId__T = (function() {
  return "/settings/oauth2"
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings.prototype.withFlow__Lamf_plugins_domain_webapi_models_security_OAuth2Flow = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var flow = new $c_Lamf_plugins_domain_webapi_models_security_OAuth2Flow().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, flow);
  return flow
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  $c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.security.OAuth2Settings"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_security_OAuth2Settings)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.security.OAuth2Settings;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_security_OAuth2Settings = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_security_OAuth2Settings: 0
}, false, "amf.plugins.domain.webapi.models.security.OAuth2Settings", {
  Lamf_plugins_domain_webapi_models_security_OAuth2Settings: 1,
  Lamf_plugins_domain_webapi_models_security_Settings: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_security_OAuth2Settings;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings() {
  $c_Lamf_plugins_domain_webapi_models_security_Settings.call(this)
}
$c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings.prototype = new $h_Lamf_plugins_domain_webapi_models_security_Settings();
$c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings.prototype = $c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings.prototype;
$c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings.prototype.productPrefix__T = (function() {
  return "OpenIdConnectSettings"
});
$c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings)) {
    var OpenIdConnectSettings$1 = $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(x$1);
    var x = this.fields$1;
    var x$2 = OpenIdConnectSettings$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = OpenIdConnectSettings$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$()
});
$c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings.prototype.componentId__T = (function() {
  return "/settings/open-id-connect"
});
$c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  $c_Lamf_plugins_domain_webapi_models_security_Settings.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.security.OpenIdConnectSettings"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.security.OpenIdConnectSettings;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings: 0
}, false, "amf.plugins.domain.webapi.models.security.OpenIdConnectSettings", {
  Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings: 1,
  Lamf_plugins_domain_webapi_models_security_Settings: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype = $c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype;
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.productPrefix__T = (function() {
  return "ParametrizedSecurityScheme"
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.withApiKeySettings__Lamf_plugins_domain_webapi_models_security_ApiKeySettings = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var settings = new $c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Settings$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, settings);
  return settings
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.withOAuth1Settings__Lamf_plugins_domain_webapi_models_security_OAuth1Settings = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var settings = new $c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Settings$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, settings);
  return settings
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme)) {
    var ParametrizedSecurityScheme$1 = $as_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme(x$1);
    var x = this.fields$1;
    var x$2 = ParametrizedSecurityScheme$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = ParametrizedSecurityScheme$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.withHttpApiKeySettings__Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var settings = new $c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Settings$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, settings);
  return settings
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$()
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.withDefaultSettings__Lamf_plugins_domain_webapi_models_security_Settings = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var settings = new $c_Lamf_plugins_domain_webapi_models_security_Settings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Settings$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, settings);
  return settings
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-parametrized" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.withOAuth2Settings__Lamf_plugins_domain_webapi_models_security_OAuth2Settings = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var settings = new $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Settings$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, settings);
  return settings
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.withHttpSettings__Lamf_plugins_domain_webapi_models_security_HttpSettings = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var settings = new $c_Lamf_plugins_domain_webapi_models_security_HttpSettings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Settings$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, settings);
  return settings
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.withOpenIdConnectSettings__Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var settings = new $c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ParametrizedSecuritySchemeModel$().Settings$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, settings);
  return settings
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.security.ParametrizedSecurityScheme"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.security.ParametrizedSecurityScheme;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme: 0
}, false, "amf.plugins.domain.webapi.models.security.ParametrizedSecurityScheme", {
  Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_plugins_domain_webapi_models_security_WithSettings: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_security_ParametrizedSecurityScheme;
/** @constructor */
function $c_Lorg_yaml_model_DuplicateKeyException() {
  $c_Lorg_yaml_model_SyamlException.call(this);
  this.key$5 = null;
  this.cause$5 = null
}
$c_Lorg_yaml_model_DuplicateKeyException.prototype = new $h_Lorg_yaml_model_SyamlException();
$c_Lorg_yaml_model_DuplicateKeyException.prototype.constructor = $c_Lorg_yaml_model_DuplicateKeyException;
/** @constructor */
function $h_Lorg_yaml_model_DuplicateKeyException() {
  /*<skip>*/
}
$h_Lorg_yaml_model_DuplicateKeyException.prototype = $c_Lorg_yaml_model_DuplicateKeyException.prototype;
$c_Lorg_yaml_model_DuplicateKeyException.prototype.productPrefix__T = (function() {
  return "DuplicateKeyException"
});
$c_Lorg_yaml_model_DuplicateKeyException.prototype.productArity__I = (function() {
  return 2
});
$c_Lorg_yaml_model_DuplicateKeyException.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lorg_yaml_model_DuplicateKeyException)) {
    var DuplicateKeyException$1 = $as_Lorg_yaml_model_DuplicateKeyException(x$1);
    if ((this.key$5 === DuplicateKeyException$1.key$5)) {
      var x = this.cause$5;
      var x$2 = DuplicateKeyException$1.cause$5;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_model_DuplicateKeyException.prototype.init___T__jl_Exception = (function(key, cause) {
  this.key$5 = key;
  this.cause$5 = cause;
  var message = (("Duplicate key : '" + key) + "'");
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, message, cause, true, true);
  return this
});
$c_Lorg_yaml_model_DuplicateKeyException.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$5;
      break
    }
    case 1: {
      return this.cause$5;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lorg_yaml_model_DuplicateKeyException.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lorg_yaml_model_DuplicateKeyException.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lorg_yaml_model_DuplicateKeyException(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_DuplicateKeyException) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.DuplicateKeyException"))
}
function $isArrayOf_Lorg_yaml_model_DuplicateKeyException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_DuplicateKeyException)))
}
function $asArrayOf_Lorg_yaml_model_DuplicateKeyException(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_DuplicateKeyException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.DuplicateKeyException;", depth))
}
var $d_Lorg_yaml_model_DuplicateKeyException = new $TypeData().initClass({
  Lorg_yaml_model_DuplicateKeyException: 0
}, false, "org.yaml.model.DuplicateKeyException", {
  Lorg_yaml_model_DuplicateKeyException: 1,
  Lorg_yaml_model_SyamlException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1
});
$c_Lorg_yaml_model_DuplicateKeyException.prototype.$classData = $d_Lorg_yaml_model_DuplicateKeyException;
/** @constructor */
function $c_Lorg_yaml_model_LexerException() {
  $c_Lorg_yaml_model_SyamlException.call(this);
  this.text$5 = null;
  this.cause$5 = null
}
$c_Lorg_yaml_model_LexerException.prototype = new $h_Lorg_yaml_model_SyamlException();
$c_Lorg_yaml_model_LexerException.prototype.constructor = $c_Lorg_yaml_model_LexerException;
/** @constructor */
function $h_Lorg_yaml_model_LexerException() {
  /*<skip>*/
}
$h_Lorg_yaml_model_LexerException.prototype = $c_Lorg_yaml_model_LexerException.prototype;
$c_Lorg_yaml_model_LexerException.prototype.productPrefix__T = (function() {
  return "LexerException"
});
$c_Lorg_yaml_model_LexerException.prototype.productArity__I = (function() {
  return 2
});
$c_Lorg_yaml_model_LexerException.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lorg_yaml_model_LexerException)) {
    var LexerException$1 = $as_Lorg_yaml_model_LexerException(x$1);
    if ((this.text$5 === LexerException$1.text$5)) {
      var x = this.cause$5;
      var x$2 = LexerException$1.cause$5;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_model_LexerException.prototype.init___T__jl_Exception = (function(text, cause) {
  this.text$5 = text;
  this.cause$5 = cause;
  var message = (("Syntax error in the following text: '" + text) + "'");
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, message, cause, true, true);
  return this
});
$c_Lorg_yaml_model_LexerException.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.text$5;
      break
    }
    case 1: {
      return this.cause$5;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lorg_yaml_model_LexerException.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lorg_yaml_model_LexerException.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lorg_yaml_model_LexerException(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_LexerException) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.LexerException"))
}
function $isArrayOf_Lorg_yaml_model_LexerException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_LexerException)))
}
function $asArrayOf_Lorg_yaml_model_LexerException(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_LexerException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.LexerException;", depth))
}
var $d_Lorg_yaml_model_LexerException = new $TypeData().initClass({
  Lorg_yaml_model_LexerException: 0
}, false, "org.yaml.model.LexerException", {
  Lorg_yaml_model_LexerException: 1,
  Lorg_yaml_model_SyamlException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1
});
$c_Lorg_yaml_model_LexerException.prototype.$classData = $d_Lorg_yaml_model_LexerException;
/** @constructor */
function $c_Lorg_yaml_model_ParseException() {
  $c_Lorg_yaml_model_SyamlException.call(this);
  this.tag$5 = null;
  this.text$5 = null;
  this.cause$5 = null
}
$c_Lorg_yaml_model_ParseException.prototype = new $h_Lorg_yaml_model_SyamlException();
$c_Lorg_yaml_model_ParseException.prototype.constructor = $c_Lorg_yaml_model_ParseException;
/** @constructor */
function $h_Lorg_yaml_model_ParseException() {
  /*<skip>*/
}
$h_Lorg_yaml_model_ParseException.prototype = $c_Lorg_yaml_model_ParseException.prototype;
$c_Lorg_yaml_model_ParseException.prototype.productPrefix__T = (function() {
  return "ParseException"
});
$c_Lorg_yaml_model_ParseException.prototype.productArity__I = (function() {
  return 3
});
$c_Lorg_yaml_model_ParseException.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lorg_yaml_model_ParseException)) {
    var ParseException$1 = $as_Lorg_yaml_model_ParseException(x$1);
    var x = this.tag$5;
    var x$2 = ParseException$1.tag$5;
    if (((x === x$2) && (this.text$5 === ParseException$1.text$5))) {
      var x$3 = this.cause$5;
      var x$4 = ParseException$1.cause$5;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_model_ParseException.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.tag$5;
      break
    }
    case 1: {
      return this.text$5;
      break
    }
    case 2: {
      return this.cause$5;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lorg_yaml_model_ParseException.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lorg_yaml_model_ParseException.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lorg_yaml_model_ParseException.prototype.init___Lorg_yaml_model_YType__T__jl_Exception = (function(tag, text, cause) {
  this.tag$5 = tag;
  this.text$5 = text;
  this.cause$5 = cause;
  var message = (((("Cannot parse '" + text) + "' with tag '") + tag) + "'");
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, message, cause, true, true);
  return this
});
function $as_Lorg_yaml_model_ParseException(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_ParseException) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.ParseException"))
}
function $isArrayOf_Lorg_yaml_model_ParseException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_ParseException)))
}
function $asArrayOf_Lorg_yaml_model_ParseException(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_ParseException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.ParseException;", depth))
}
var $d_Lorg_yaml_model_ParseException = new $TypeData().initClass({
  Lorg_yaml_model_ParseException: 0
}, false, "org.yaml.model.ParseException", {
  Lorg_yaml_model_ParseException: 1,
  Lorg_yaml_model_SyamlException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1
});
$c_Lorg_yaml_model_ParseException.prototype.$classData = $d_Lorg_yaml_model_ParseException;
/** @constructor */
function $c_Lorg_yaml_model_ParserException() {
  $c_Lorg_yaml_model_SyamlException.call(this);
  this.text$5 = null;
  this.cause$5 = null
}
$c_Lorg_yaml_model_ParserException.prototype = new $h_Lorg_yaml_model_SyamlException();
$c_Lorg_yaml_model_ParserException.prototype.constructor = $c_Lorg_yaml_model_ParserException;
/** @constructor */
function $h_Lorg_yaml_model_ParserException() {
  /*<skip>*/
}
$h_Lorg_yaml_model_ParserException.prototype = $c_Lorg_yaml_model_ParserException.prototype;
$c_Lorg_yaml_model_ParserException.prototype.productPrefix__T = (function() {
  return "ParserException"
});
$c_Lorg_yaml_model_ParserException.prototype.productArity__I = (function() {
  return 2
});
$c_Lorg_yaml_model_ParserException.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lorg_yaml_model_ParserException)) {
    var ParserException$1 = $as_Lorg_yaml_model_ParserException(x$1);
    if ((this.text$5 === ParserException$1.text$5)) {
      var x = this.cause$5;
      var x$2 = ParserException$1.cause$5;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_model_ParserException.prototype.init___T__jl_Exception = (function(text, cause) {
  this.text$5 = text;
  this.cause$5 = cause;
  var message = ("Syntax error : " + text);
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, message, cause, true, true);
  return this
});
$c_Lorg_yaml_model_ParserException.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.text$5;
      break
    }
    case 1: {
      return this.cause$5;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lorg_yaml_model_ParserException.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lorg_yaml_model_ParserException.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lorg_yaml_model_ParserException(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_ParserException) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.ParserException"))
}
function $isArrayOf_Lorg_yaml_model_ParserException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_ParserException)))
}
function $asArrayOf_Lorg_yaml_model_ParserException(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_ParserException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.ParserException;", depth))
}
var $d_Lorg_yaml_model_ParserException = new $TypeData().initClass({
  Lorg_yaml_model_ParserException: 0
}, false, "org.yaml.model.ParserException", {
  Lorg_yaml_model_ParserException: 1,
  Lorg_yaml_model_SyamlException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1
});
$c_Lorg_yaml_model_ParserException.prototype.$classData = $d_Lorg_yaml_model_ParserException;
/** @constructor */
function $c_Lorg_yaml_model_UndefinedAnchorException() {
  $c_Lorg_yaml_model_SyamlException.call(this);
  this.anchor$5 = null;
  this.cause$5 = null
}
$c_Lorg_yaml_model_UndefinedAnchorException.prototype = new $h_Lorg_yaml_model_SyamlException();
$c_Lorg_yaml_model_UndefinedAnchorException.prototype.constructor = $c_Lorg_yaml_model_UndefinedAnchorException;
/** @constructor */
function $h_Lorg_yaml_model_UndefinedAnchorException() {
  /*<skip>*/
}
$h_Lorg_yaml_model_UndefinedAnchorException.prototype = $c_Lorg_yaml_model_UndefinedAnchorException.prototype;
$c_Lorg_yaml_model_UndefinedAnchorException.prototype.productPrefix__T = (function() {
  return "UndefinedAnchorException"
});
$c_Lorg_yaml_model_UndefinedAnchorException.prototype.productArity__I = (function() {
  return 2
});
$c_Lorg_yaml_model_UndefinedAnchorException.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lorg_yaml_model_UndefinedAnchorException)) {
    var UndefinedAnchorException$1 = $as_Lorg_yaml_model_UndefinedAnchorException(x$1);
    if ((this.anchor$5 === UndefinedAnchorException$1.anchor$5)) {
      var x = this.cause$5;
      var x$2 = UndefinedAnchorException$1.cause$5;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_model_UndefinedAnchorException.prototype.init___T__jl_Exception = (function(anchor, cause) {
  this.anchor$5 = anchor;
  this.cause$5 = cause;
  var message = (("Undefined anchor : '" + anchor) + "'");
  $c_jl_Throwable.prototype.init___T__jl_Throwable__Z__Z.call(this, message, cause, true, true);
  return this
});
$c_Lorg_yaml_model_UndefinedAnchorException.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.anchor$5;
      break
    }
    case 1: {
      return this.cause$5;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lorg_yaml_model_UndefinedAnchorException.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lorg_yaml_model_UndefinedAnchorException.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lorg_yaml_model_UndefinedAnchorException(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_UndefinedAnchorException) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.UndefinedAnchorException"))
}
function $isArrayOf_Lorg_yaml_model_UndefinedAnchorException(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_UndefinedAnchorException)))
}
function $asArrayOf_Lorg_yaml_model_UndefinedAnchorException(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_UndefinedAnchorException(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.UndefinedAnchorException;", depth))
}
var $d_Lorg_yaml_model_UndefinedAnchorException = new $TypeData().initClass({
  Lorg_yaml_model_UndefinedAnchorException: 0
}, false, "org.yaml.model.UndefinedAnchorException", {
  Lorg_yaml_model_UndefinedAnchorException: 1,
  Lorg_yaml_model_SyamlException: 1,
  jl_RuntimeException: 1,
  jl_Exception: 1,
  jl_Throwable: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1
});
$c_Lorg_yaml_model_UndefinedAnchorException.prototype.$classData = $d_Lorg_yaml_model_UndefinedAnchorException;
/** @constructor */
function $c_Lorg_yaml_model_YFail() {
  $c_Lorg_yaml_model_YObj.call(this);
  this.error$2 = null;
  this.tagType$2 = null
}
$c_Lorg_yaml_model_YFail.prototype = new $h_Lorg_yaml_model_YObj();
$c_Lorg_yaml_model_YFail.prototype.constructor = $c_Lorg_yaml_model_YFail;
/** @constructor */
function $h_Lorg_yaml_model_YFail() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YFail.prototype = $c_Lorg_yaml_model_YFail.prototype;
$c_Lorg_yaml_model_YFail.prototype.productPrefix__T = (function() {
  return "YFail"
});
$c_Lorg_yaml_model_YFail.prototype.productArity__I = (function() {
  return 1
});
$c_Lorg_yaml_model_YFail.prototype.equals__O__Z = (function(obj) {
  return false
});
$c_Lorg_yaml_model_YFail.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.error$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lorg_yaml_model_YFail.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lorg_yaml_model_YFail.prototype.to__Lorg_yaml_convert_YRead__s_util_Either = (function(evidence$1) {
  $m_s_package$();
  var value = this.error$2;
  return new $c_s_util_Left().init___O(value)
});
$c_Lorg_yaml_model_YFail.prototype.init___Lorg_yaml_model_YError = (function(error) {
  this.error$2 = error;
  this.tagType$2 = $m_Lorg_yaml_model_YType$().Unknown$1;
  return this
});
$c_Lorg_yaml_model_YFail.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lorg_yaml_model_YFail.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lorg_yaml_model_YFail.prototype.thisNode__Lorg_yaml_model_YNode = (function() {
  throw new $c_jl_IllegalStateException().init___()
});
function $as_Lorg_yaml_model_YFail(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YFail) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YFail"))
}
function $isArrayOf_Lorg_yaml_model_YFail(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YFail)))
}
function $asArrayOf_Lorg_yaml_model_YFail(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YFail(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YFail;", depth))
}
var $d_Lorg_yaml_model_YFail = new $TypeData().initClass({
  Lorg_yaml_model_YFail: 0
}, false, "org.yaml.model.YFail", {
  Lorg_yaml_model_YFail: 1,
  Lorg_yaml_model_YObj: 1,
  O: 1,
  Lorg_yaml_model_YNodeLike: 1,
  Lorg_yaml_model_YValueLike: 1,
  s_Dynamic: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_model_YFail.prototype.$classData = $d_Lorg_yaml_model_YFail;
/** @constructor */
function $c_Lorg_yaml_model_YSuccess() {
  $c_Lorg_yaml_model_YObj.call(this);
  this.node$2 = null;
  this.tagType$2 = null
}
$c_Lorg_yaml_model_YSuccess.prototype = new $h_Lorg_yaml_model_YObj();
$c_Lorg_yaml_model_YSuccess.prototype.constructor = $c_Lorg_yaml_model_YSuccess;
/** @constructor */
function $h_Lorg_yaml_model_YSuccess() {
  /*<skip>*/
}
$h_Lorg_yaml_model_YSuccess.prototype = $c_Lorg_yaml_model_YSuccess.prototype;
$c_Lorg_yaml_model_YSuccess.prototype.productPrefix__T = (function() {
  return "YSuccess"
});
$c_Lorg_yaml_model_YSuccess.prototype.productArity__I = (function() {
  return 1
});
$c_Lorg_yaml_model_YSuccess.prototype.equals__O__Z = (function(obj) {
  if ((!(obj instanceof $c_Lorg_yaml_model_YFail))) {
    if ($is_Lorg_yaml_model_YNodeLike(obj)) {
      var x3 = $as_Lorg_yaml_model_YNodeLike(obj);
      var this$1 = this.node$2;
      var b = x3.thisNode__Lorg_yaml_model_YNode();
      return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else if ((obj instanceof $c_Lorg_yaml_model_YValue)) {
      var x4 = $as_Lorg_yaml_model_YValue(obj);
      return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(x4, this)
    } else {
      throw new $c_s_MatchError().init___O(obj)
    }
  } else {
    return false
  }
});
$c_Lorg_yaml_model_YSuccess.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.node$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lorg_yaml_model_YSuccess.prototype.toString__T = (function() {
  return this.node$2.toString__T()
});
$c_Lorg_yaml_model_YSuccess.prototype.init___Lorg_yaml_model_YNode = (function(node) {
  this.node$2 = node;
  this.tagType$2 = node.tag__Lorg_yaml_model_YTag().tagType$3;
  return this
});
$c_Lorg_yaml_model_YSuccess.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lorg_yaml_model_YSuccess.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lorg_yaml_model_YSuccess.prototype.thisNode__Lorg_yaml_model_YNode = (function() {
  return this.node$2
});
function $as_Lorg_yaml_model_YSuccess(obj) {
  return (((obj instanceof $c_Lorg_yaml_model_YSuccess) || (obj === null)) ? obj : $throwClassCastException(obj, "org.yaml.model.YSuccess"))
}
function $isArrayOf_Lorg_yaml_model_YSuccess(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lorg_yaml_model_YSuccess)))
}
function $asArrayOf_Lorg_yaml_model_YSuccess(obj, depth) {
  return (($isArrayOf_Lorg_yaml_model_YSuccess(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lorg.yaml.model.YSuccess;", depth))
}
var $d_Lorg_yaml_model_YSuccess = new $TypeData().initClass({
  Lorg_yaml_model_YSuccess: 0
}, false, "org.yaml.model.YSuccess", {
  Lorg_yaml_model_YSuccess: 1,
  Lorg_yaml_model_YObj: 1,
  O: 1,
  Lorg_yaml_model_YNodeLike: 1,
  Lorg_yaml_model_YValueLike: 1,
  s_Dynamic: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lorg_yaml_model_YSuccess.prototype.$classData = $d_Lorg_yaml_model_YSuccess;
/** @constructor */
function $c_s_math_BigDecimal() {
  $c_s_math_ScalaNumber.call(this);
  this.bigDecimal$3 = null;
  this.mc$3 = null;
  this.computedHashCode$3 = 0
}
$c_s_math_BigDecimal.prototype = new $h_s_math_ScalaNumber();
$c_s_math_BigDecimal.prototype.constructor = $c_s_math_BigDecimal;
/** @constructor */
function $h_s_math_BigDecimal() {
  /*<skip>*/
}
$h_s_math_BigDecimal.prototype = $c_s_math_BigDecimal.prototype;
$c_s_math_BigDecimal.prototype.isValidInt__Z = (function() {
  try {
    this.bigDecimal$3.intValueExact__I();
    return true
  } catch (e) {
    if ((e instanceof $c_jl_ArithmeticException)) {
      return false
    } else {
      throw e
    }
  }
});
$c_s_math_BigDecimal.prototype.toBigInt__s_math_BigInt = (function() {
  return new $c_s_math_BigInt().init___Ljava_math_BigInteger(this.bigDecimal$3.toBigInteger__Ljava_math_BigInteger())
});
$c_s_math_BigDecimal.prototype.longValue__J = (function() {
  return this.bigDecimal$3.longValue__J()
});
$c_s_math_BigDecimal.prototype.init___Ljava_math_BigDecimal__Ljava_math_MathContext = (function(bigDecimal, mc) {
  this.bigDecimal$3 = bigDecimal;
  this.mc$3 = mc;
  if ((bigDecimal === null)) {
    throw new $c_jl_IllegalArgumentException().init___T("null value for BigDecimal")
  };
  if ((mc === null)) {
    throw new $c_jl_IllegalArgumentException().init___T("null MathContext for BigDecimal")
  };
  this.computedHashCode$3 = 1565550863;
  return this
});
$c_s_math_BigDecimal.prototype.isValidShort__Z = (function() {
  try {
    this.bigDecimal$3.shortValueExact__S();
    return true
  } catch (e) {
    if ((e instanceof $c_jl_ArithmeticException)) {
      return false
    } else {
      throw e
    }
  }
});
$c_s_math_BigDecimal.prototype.byteValue__B = (function() {
  return ((this.bigDecimal$3.intValue__I() << 24) >> 24)
});
$c_s_math_BigDecimal.prototype.equals__O__Z = (function(that) {
  if ((that instanceof $c_s_math_BigDecimal)) {
    var x2 = $as_s_math_BigDecimal(that);
    return this.equals__s_math_BigDecimal__Z(x2)
  } else if ((that instanceof $c_s_math_BigInt)) {
    var x3 = $as_s_math_BigInt(that);
    var this$1 = x3.bigInteger$3;
    var jsx$2 = $m_Ljava_math_BitLevel$().bitLength__Ljava_math_BigInteger__I(this$1);
    var jsx$1 = this.bigDecimal$3.precision__I();
    var this$2 = this.bigDecimal$3;
    if ((jsx$2 > (3.3219280948873626 * (((-2) + ((jsx$1 - this$2.java$math$BigDecimal$$$undscale$2) | 0)) | 0)))) {
      var this$3 = this.toBigIntExact__s_Option();
      if ((!this$3.isEmpty__Z())) {
        var arg1 = this$3.get__O();
        var x$1 = $as_s_math_BigInt(arg1);
        return x3.equals__s_math_BigInt__Z(x$1)
      } else {
        return false
      }
    } else {
      return false
    }
  } else if (((typeof that) === "number")) {
    var x4 = $uD(that);
    if ((!((x4 === Infinity) || (x4 === (-Infinity))))) {
      var d = this.bigDecimal$3.doubleValue__D();
      if (((!((d === Infinity) || (d === (-Infinity)))) && (d === x4))) {
        var this$10 = $m_s_math_BigDecimal$();
        return this.equals__s_math_BigDecimal__Z(this$10.decimal__D__Ljava_math_MathContext__s_math_BigDecimal(d, this$10.defaultMathContext$1))
      } else {
        return false
      }
    } else {
      return false
    }
  } else if ($isFloat(that)) {
    var x5 = $uF(that);
    if ((!((x5 === Infinity) || (x5 === (-Infinity))))) {
      var f = this.bigDecimal$3.floatValue__F();
      if (((!((f === Infinity) || (f === (-Infinity)))) && (f === x5))) {
        var this$17 = $m_s_math_BigDecimal$();
        return this.equals__s_math_BigDecimal__Z(this$17.decimal__D__Ljava_math_MathContext__s_math_BigDecimal(f, this$17.defaultMathContext$1))
      } else {
        return false
      }
    } else {
      return false
    }
  } else {
    return (this.isValidLong__Z() && $f_s_math_ScalaNumericAnyConversions__unifiedPrimitiveEquals__O__Z(this, that))
  }
});
$c_s_math_BigDecimal.prototype.isWhole__Z = (function() {
  var this$1 = this.bigDecimal$3;
  if ((this$1.java$math$BigDecimal$$$undscale$2 <= 0)) {
    return true
  } else {
    var this$2 = this.bigDecimal$3.stripTrailingZeros__Ljava_math_BigDecimal();
    return (this$2.java$math$BigDecimal$$$undscale$2 <= 0)
  }
});
$c_s_math_BigDecimal.prototype.computeHashCode__p3__V = (function() {
  if (this.isWhole__Z()) {
    var jsx$3 = this.bigDecimal$3.precision__I();
    var this$1 = this.bigDecimal$3;
    var jsx$2 = (((jsx$3 - this$1.java$math$BigDecimal$$$undscale$2) | 0) < 4934)
  } else {
    var jsx$2 = false
  };
  if (jsx$2) {
    var jsx$1 = this.toBigInt__s_math_BigInt().hashCode__I()
  } else if (this.isDecimalDouble__Z()) {
    var jsx$1 = $m_sr_Statics$().doubleHash__D__I(this.bigDecimal$3.doubleValue__D())
  } else {
    var temp = this.bigDecimal$3.stripTrailingZeros__Ljava_math_BigDecimal();
    var jsx$1 = $m_s_util_hashing_MurmurHash3$().mixLast__I__I__I(temp.scaleByPowerOfTen__I__Ljava_math_BigDecimal(temp.java$math$BigDecimal$$$undscale$2).toBigInteger__Ljava_math_BigInteger().hashCode__I(), temp.java$math$BigDecimal$$$undscale$2)
  };
  this.computedHashCode$3 = jsx$1
});
$c_s_math_BigDecimal.prototype.isValidChar__Z = (function() {
  return ((this.isValidInt__Z() && (this.bigDecimal$3.intValueExact__I() >= 0)) && (this.bigDecimal$3.intValueExact__I() <= 65535))
});
$c_s_math_BigDecimal.prototype.toString__T = (function() {
  return this.bigDecimal$3.toString__T()
});
$c_s_math_BigDecimal.prototype.compareTo__O__I = (function(that) {
  var that$1 = $as_s_math_BigDecimal(that);
  return this.bigDecimal$3.compareTo__Ljava_math_BigDecimal__I(that$1.bigDecimal$3)
});
$c_s_math_BigDecimal.prototype.isValidByte__Z = (function() {
  try {
    this.bigDecimal$3.byteValueExact__B();
    return true
  } catch (e) {
    if ((e instanceof $c_jl_ArithmeticException)) {
      return false
    } else {
      throw e
    }
  }
});
$c_s_math_BigDecimal.prototype.compare__O__I = (function(that) {
  var that$1 = $as_s_math_BigDecimal(that);
  return this.bigDecimal$3.compareTo__Ljava_math_BigDecimal__I(that$1.bigDecimal$3)
});
$c_s_math_BigDecimal.prototype.underlying__O = (function() {
  return this.bigDecimal$3
});
$c_s_math_BigDecimal.prototype.isDecimalDouble__Z = (function() {
  var d = this.bigDecimal$3.doubleValue__D();
  if ((!((d === Infinity) || (d === (-Infinity))))) {
    var this$4 = $m_s_math_BigDecimal$();
    return this.equals__s_math_BigDecimal__Z(this$4.decimal__D__Ljava_math_MathContext__s_math_BigDecimal(d, this$4.defaultMathContext$1))
  } else {
    return false
  }
});
$c_s_math_BigDecimal.prototype.toBigIntExact__s_Option = (function() {
  if (this.isWhole__Z()) {
    try {
      return new $c_s_Some().init___O(new $c_s_math_BigInt().init___Ljava_math_BigInteger(this.bigDecimal$3.toBigIntegerExact__Ljava_math_BigInteger()))
    } catch (e) {
      if ((e instanceof $c_jl_ArithmeticException)) {
        return $m_s_None$()
      } else {
        throw e
      }
    }
  } else {
    return $m_s_None$()
  }
});
$c_s_math_BigDecimal.prototype.shortValue__S = (function() {
  return ((this.bigDecimal$3.intValue__I() << 16) >> 16)
});
$c_s_math_BigDecimal.prototype.doubleValue__D = (function() {
  return this.bigDecimal$3.doubleValue__D()
});
$c_s_math_BigDecimal.prototype.hashCode__I = (function() {
  if ((this.computedHashCode$3 === 1565550863)) {
    this.computeHashCode__p3__V()
  };
  return this.computedHashCode$3
});
$c_s_math_BigDecimal.prototype.intValue__I = (function() {
  return this.bigDecimal$3.intValue__I()
});
$c_s_math_BigDecimal.prototype.isValidLong__Z = (function() {
  try {
    var this$1 = this.bigDecimal$3;
    this$1.valueExact__p2__I__J(64);
    return true
  } catch (e) {
    if ((e instanceof $c_jl_ArithmeticException)) {
      return false
    } else {
      throw e
    }
  }
});
$c_s_math_BigDecimal.prototype.floatValue__F = (function() {
  return this.bigDecimal$3.floatValue__F()
});
$c_s_math_BigDecimal.prototype.equals__s_math_BigDecimal__Z = (function(that) {
  return (this.bigDecimal$3.compareTo__Ljava_math_BigDecimal__I(that.bigDecimal$3) === 0)
});
function $as_s_math_BigDecimal(obj) {
  return (((obj instanceof $c_s_math_BigDecimal) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.math.BigDecimal"))
}
function $isArrayOf_s_math_BigDecimal(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_math_BigDecimal)))
}
function $asArrayOf_s_math_BigDecimal(obj, depth) {
  return (($isArrayOf_s_math_BigDecimal(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.math.BigDecimal;", depth))
}
var $d_s_math_BigDecimal = new $TypeData().initClass({
  s_math_BigDecimal: 0
}, false, "scala.math.BigDecimal", {
  s_math_BigDecimal: 1,
  s_math_ScalaNumber: 1,
  jl_Number: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  s_math_ScalaNumericConversions: 1,
  s_math_ScalaNumericAnyConversions: 1,
  s_Serializable: 1,
  s_math_Ordered: 1,
  jl_Comparable: 1
});
$c_s_math_BigDecimal.prototype.$classData = $d_s_math_BigDecimal;
/** @constructor */
function $c_s_math_BigInt() {
  $c_s_math_ScalaNumber.call(this);
  this.bigInteger$3 = null
}
$c_s_math_BigInt.prototype = new $h_s_math_ScalaNumber();
$c_s_math_BigInt.prototype.constructor = $c_s_math_BigInt;
/** @constructor */
function $h_s_math_BigInt() {
  /*<skip>*/
}
$h_s_math_BigInt.prototype = $c_s_math_BigInt.prototype;
$c_s_math_BigInt.prototype.isValidInt__Z = (function() {
  var this$1 = $m_s_math_BigInt$();
  var that = this$1.apply__I__s_math_BigInt((-2147483648));
  if ($f_s_math_Ordered__$$greater$eq__O__Z(this, that)) {
    var this$2 = $m_s_math_BigInt$();
    var that$1 = this$2.apply__I__s_math_BigInt(2147483647);
    return $f_s_math_Ordered__$$less$eq__O__Z(this, that$1)
  } else {
    return false
  }
});
$c_s_math_BigInt.prototype.longValue__J = (function() {
  return this.bigInteger$3.longValue__J()
});
$c_s_math_BigInt.prototype.isValidShort__Z = (function() {
  var this$1 = $m_s_math_BigInt$();
  var that = this$1.apply__I__s_math_BigInt((-32768));
  if ($f_s_math_Ordered__$$greater$eq__O__Z(this, that)) {
    var this$2 = $m_s_math_BigInt$();
    var that$1 = this$2.apply__I__s_math_BigInt(32767);
    return $f_s_math_Ordered__$$less$eq__O__Z(this, that$1)
  } else {
    return false
  }
});
$c_s_math_BigInt.prototype.byteValue__B = (function() {
  return ((this.bigInteger$3.intValue__I() << 24) >> 24)
});
$c_s_math_BigInt.prototype.equals__O__Z = (function(that) {
  if ((that instanceof $c_s_math_BigInt)) {
    var x2 = $as_s_math_BigInt(that);
    return this.equals__s_math_BigInt__Z(x2)
  } else if ((that instanceof $c_s_math_BigDecimal)) {
    var x3 = $as_s_math_BigDecimal(that);
    return x3.equals__O__Z(this)
  } else if (((typeof that) === "number")) {
    var x4 = $uD(that);
    if (this.isValidDouble__Z()) {
      var this$1 = this.bigInteger$3;
      return ($m_jl_Double$().parseDouble__T__D($m_Ljava_math_Conversion$().toDecimalScaledString__Ljava_math_BigInteger__T(this$1)) === x4)
    } else {
      return false
    }
  } else if ($isFloat(that)) {
    var x5 = $uF(that);
    if (this.isValidFloat__Z()) {
      var this$2 = this.bigInteger$3;
      var s = $m_Ljava_math_Conversion$().toDecimalScaledString__Ljava_math_BigInteger__T(this$2);
      return ($fround($m_jl_Double$().parseDouble__T__D(s)) === x5)
    } else {
      return false
    }
  } else {
    return (this.isValidLong__Z() && $f_s_math_ScalaNumericAnyConversions__unifiedPrimitiveEquals__O__Z(this, that))
  }
});
$c_s_math_BigInt.prototype.equals__s_math_BigInt__Z = (function(that) {
  return (this.bigInteger$3.compareTo__Ljava_math_BigInteger__I(that.bigInteger$3) === 0)
});
$c_s_math_BigInt.prototype.bitLengthOverflow__p3__Z = (function() {
  var shifted = this.bigInteger$3.shiftRight__I__Ljava_math_BigInteger(2147483647);
  return ((shifted.sign$2 !== 0) && (!shifted.equals__O__Z($m_s_math_BigInt$().scala$math$BigInt$$minusOne$1)))
});
$c_s_math_BigInt.prototype.isValidDouble__Z = (function() {
  var this$1 = this.bigInteger$3;
  var bitLen = $m_Ljava_math_BitLevel$().bitLength__Ljava_math_BigInteger__I(this$1);
  if ((bitLen <= 53)) {
    var jsx$1 = true
  } else {
    var lowest = this.bigInteger$3.getLowestSetBit__I();
    var jsx$1 = (((bitLen <= 1024) && (lowest >= (((-53) + bitLen) | 0))) && (lowest < 1024))
  };
  if (jsx$1) {
    return (!this.bitLengthOverflow__p3__Z())
  } else {
    return false
  }
});
$c_s_math_BigInt.prototype.isValidChar__Z = (function() {
  var this$1 = $m_s_math_BigInt$();
  var that = this$1.apply__I__s_math_BigInt(0);
  if ($f_s_math_Ordered__$$greater$eq__O__Z(this, that)) {
    var this$2 = $m_s_math_BigInt$();
    var that$1 = this$2.apply__I__s_math_BigInt(65535);
    return $f_s_math_Ordered__$$less$eq__O__Z(this, that$1)
  } else {
    return false
  }
});
$c_s_math_BigInt.prototype.toString__T = (function() {
  var this$1 = this.bigInteger$3;
  return $m_Ljava_math_Conversion$().toDecimalScaledString__Ljava_math_BigInteger__T(this$1)
});
$c_s_math_BigInt.prototype.compareTo__O__I = (function(that) {
  var that$1 = $as_s_math_BigInt(that);
  return this.bigInteger$3.compareTo__Ljava_math_BigInteger__I(that$1.bigInteger$3)
});
$c_s_math_BigInt.prototype.isValidByte__Z = (function() {
  var this$1 = $m_s_math_BigInt$();
  var that = this$1.apply__I__s_math_BigInt((-128));
  if ($f_s_math_Ordered__$$greater$eq__O__Z(this, that)) {
    var this$2 = $m_s_math_BigInt$();
    var that$1 = this$2.apply__I__s_math_BigInt(127);
    return $f_s_math_Ordered__$$less$eq__O__Z(this, that$1)
  } else {
    return false
  }
});
$c_s_math_BigInt.prototype.compare__O__I = (function(that) {
  var that$1 = $as_s_math_BigInt(that);
  return this.bigInteger$3.compareTo__Ljava_math_BigInteger__I(that$1.bigInteger$3)
});
$c_s_math_BigInt.prototype.underlying__O = (function() {
  return this.bigInteger$3
});
$c_s_math_BigInt.prototype.isValidFloat__Z = (function() {
  var this$1 = this.bigInteger$3;
  var bitLen = $m_Ljava_math_BitLevel$().bitLength__Ljava_math_BigInteger__I(this$1);
  if ((bitLen <= 24)) {
    var jsx$1 = true
  } else {
    var lowest = this.bigInteger$3.getLowestSetBit__I();
    var jsx$1 = (((bitLen <= 128) && (lowest >= (((-24) + bitLen) | 0))) && (lowest < 128))
  };
  if (jsx$1) {
    return (!this.bitLengthOverflow__p3__Z())
  } else {
    return false
  }
});
$c_s_math_BigInt.prototype.shortValue__S = (function() {
  return ((this.bigInteger$3.intValue__I() << 16) >> 16)
});
$c_s_math_BigInt.prototype.doubleValue__D = (function() {
  var this$1 = this.bigInteger$3;
  return $m_jl_Double$().parseDouble__T__D($m_Ljava_math_Conversion$().toDecimalScaledString__Ljava_math_BigInteger__T(this$1))
});
$c_s_math_BigInt.prototype.hashCode__I = (function() {
  return (this.isValidLong__Z() ? $f_s_math_ScalaNumericAnyConversions__unifiedPrimitiveHashcode__I(this) : $m_sr_Statics$().anyHash__O__I(this.bigInteger$3))
});
$c_s_math_BigInt.prototype.intValue__I = (function() {
  return this.bigInteger$3.intValue__I()
});
$c_s_math_BigInt.prototype.init___Ljava_math_BigInteger = (function(bigInteger) {
  this.bigInteger$3 = bigInteger;
  return this
});
$c_s_math_BigInt.prototype.isValidLong__Z = (function() {
  var this$1 = $m_s_math_BigInt$();
  var that = this$1.apply__J__s_math_BigInt(new $c_sjsr_RuntimeLong().init___I__I(0, (-2147483648)));
  if ($f_s_math_Ordered__$$greater$eq__O__Z(this, that)) {
    var this$2 = $m_s_math_BigInt$();
    var that$1 = this$2.apply__J__s_math_BigInt(new $c_sjsr_RuntimeLong().init___I__I((-1), 2147483647));
    return $f_s_math_Ordered__$$less$eq__O__Z(this, that$1)
  } else {
    return false
  }
});
$c_s_math_BigInt.prototype.floatValue__F = (function() {
  var this$1 = this.bigInteger$3;
  var s = $m_Ljava_math_Conversion$().toDecimalScaledString__Ljava_math_BigInteger__T(this$1);
  return $fround($m_jl_Double$().parseDouble__T__D(s))
});
function $as_s_math_BigInt(obj) {
  return (((obj instanceof $c_s_math_BigInt) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.math.BigInt"))
}
function $isArrayOf_s_math_BigInt(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.s_math_BigInt)))
}
function $asArrayOf_s_math_BigInt(obj, depth) {
  return (($isArrayOf_s_math_BigInt(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.math.BigInt;", depth))
}
var $d_s_math_BigInt = new $TypeData().initClass({
  s_math_BigInt: 0
}, false, "scala.math.BigInt", {
  s_math_BigInt: 1,
  s_math_ScalaNumber: 1,
  jl_Number: 1,
  O: 1,
  Ljava_io_Serializable: 1,
  s_math_ScalaNumericConversions: 1,
  s_math_ScalaNumericAnyConversions: 1,
  s_Serializable: 1,
  s_math_Ordered: 1,
  jl_Comparable: 1
});
$c_s_math_BigInt.prototype.$classData = $d_s_math_BigInt;
/** @constructor */
function $c_s_reflect_ManifestFactory$BooleanManifest$() {
  $c_s_reflect_AnyValManifest.call(this)
}
$c_s_reflect_ManifestFactory$BooleanManifest$.prototype = new $h_s_reflect_AnyValManifest();
$c_s_reflect_ManifestFactory$BooleanManifest$.prototype.constructor = $c_s_reflect_ManifestFactory$BooleanManifest$;
/** @constructor */
function $h_s_reflect_ManifestFactory$BooleanManifest$() {
  /*<skip>*/
}
$h_s_reflect_ManifestFactory$BooleanManifest$.prototype = $c_s_reflect_ManifestFactory$BooleanManifest$.prototype;
$c_s_reflect_ManifestFactory$BooleanManifest$.prototype.init___ = (function() {
  this.toString$1 = "Boolean";
  return this
});
$c_s_reflect_ManifestFactory$BooleanManifest$.prototype.newArray__I__O = (function(len) {
  return $newArrayObject($d_Z.getArrayOf(), [len])
});
$c_s_reflect_ManifestFactory$BooleanManifest$.prototype.runtimeClass__jl_Class = (function() {
  return $d_Z.getClassOf()
});
var $d_s_reflect_ManifestFactory$BooleanManifest$ = new $TypeData().initClass({
  s_reflect_ManifestFactory$BooleanManifest$: 0
}, false, "scala.reflect.ManifestFactory$BooleanManifest$", {
  s_reflect_ManifestFactory$BooleanManifest$: 1,
  s_reflect_AnyValManifest: 1,
  O: 1,
  s_reflect_Manifest: 1,
  s_reflect_ClassTag: 1,
  s_reflect_ClassManifestDeprecatedApis: 1,
  s_reflect_OptManifest: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_Equals: 1
});
$c_s_reflect_ManifestFactory$BooleanManifest$.prototype.$classData = $d_s_reflect_ManifestFactory$BooleanManifest$;
var $n_s_reflect_ManifestFactory$BooleanManifest$ = (void 0);
function $m_s_reflect_ManifestFactory$BooleanManifest$() {
  if ((!$n_s_reflect_ManifestFactory$BooleanManifest$)) {
    $n_s_reflect_ManifestFactory$BooleanManifest$ = new $c_s_reflect_ManifestFactory$BooleanManifest$().init___()
  };
  return $n_s_reflect_ManifestFactory$BooleanManifest$
}
/** @constructor */
function $c_s_reflect_ManifestFactory$ByteManifest$() {
  $c_s_reflect_AnyValManifest.call(this)
}
$c_s_reflect_ManifestFactory$ByteManifest$.prototype = new $h_s_reflect_AnyValManifest();
$c_s_reflect_ManifestFactory$ByteManifest$.prototype.constructor = $c_s_reflect_ManifestFactory$ByteManifest$;
/** @constructor */
function $h_s_reflect_ManifestFactory$ByteManifest$() {
  /*<skip>*/
}
$h_s_reflect_ManifestFactory$ByteManifest$.prototype = $c_s_reflect_ManifestFactory$ByteManifest$.prototype;
$c_s_reflect_ManifestFactory$ByteManifest$.prototype.init___ = (function() {
  this.toString$1 = "Byte";
  return this
});
$c_s_reflect_ManifestFactory$ByteManifest$.prototype.newArray__I__O = (function(len) {
  return $newArrayObject($d_B.getArrayOf(), [len])
});
$c_s_reflect_ManifestFactory$ByteManifest$.prototype.runtimeClass__jl_Class = (function() {
  return $d_B.getClassOf()
});
var $d_s_reflect_ManifestFactory$ByteManifest$ = new $TypeData().initClass({
  s_reflect_ManifestFactory$ByteManifest$: 0
}, false, "scala.reflect.ManifestFactory$ByteManifest$", {
  s_reflect_ManifestFactory$ByteManifest$: 1,
  s_reflect_AnyValManifest: 1,
  O: 1,
  s_reflect_Manifest: 1,
  s_reflect_ClassTag: 1,
  s_reflect_ClassManifestDeprecatedApis: 1,
  s_reflect_OptManifest: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_Equals: 1
});
$c_s_reflect_ManifestFactory$ByteManifest$.prototype.$classData = $d_s_reflect_ManifestFactory$ByteManifest$;
var $n_s_reflect_ManifestFactory$ByteManifest$ = (void 0);
function $m_s_reflect_ManifestFactory$ByteManifest$() {
  if ((!$n_s_reflect_ManifestFactory$ByteManifest$)) {
    $n_s_reflect_ManifestFactory$ByteManifest$ = new $c_s_reflect_ManifestFactory$ByteManifest$().init___()
  };
  return $n_s_reflect_ManifestFactory$ByteManifest$
}
/** @constructor */
function $c_s_reflect_ManifestFactory$CharManifest$() {
  $c_s_reflect_AnyValManifest.call(this)
}
$c_s_reflect_ManifestFactory$CharManifest$.prototype = new $h_s_reflect_AnyValManifest();
$c_s_reflect_ManifestFactory$CharManifest$.prototype.constructor = $c_s_reflect_ManifestFactory$CharManifest$;
/** @constructor */
function $h_s_reflect_ManifestFactory$CharManifest$() {
  /*<skip>*/
}
$h_s_reflect_ManifestFactory$CharManifest$.prototype = $c_s_reflect_ManifestFactory$CharManifest$.prototype;
$c_s_reflect_ManifestFactory$CharManifest$.prototype.init___ = (function() {
  this.toString$1 = "Char";
  return this
});
$c_s_reflect_ManifestFactory$CharManifest$.prototype.newArray__I__O = (function(len) {
  return $newArrayObject($d_C.getArrayOf(), [len])
});
$c_s_reflect_ManifestFactory$CharManifest$.prototype.runtimeClass__jl_Class = (function() {
  return $d_C.getClassOf()
});
var $d_s_reflect_ManifestFactory$CharManifest$ = new $TypeData().initClass({
  s_reflect_ManifestFactory$CharManifest$: 0
}, false, "scala.reflect.ManifestFactory$CharManifest$", {
  s_reflect_ManifestFactory$CharManifest$: 1,
  s_reflect_AnyValManifest: 1,
  O: 1,
  s_reflect_Manifest: 1,
  s_reflect_ClassTag: 1,
  s_reflect_ClassManifestDeprecatedApis: 1,
  s_reflect_OptManifest: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_Equals: 1
});
$c_s_reflect_ManifestFactory$CharManifest$.prototype.$classData = $d_s_reflect_ManifestFactory$CharManifest$;
var $n_s_reflect_ManifestFactory$CharManifest$ = (void 0);
function $m_s_reflect_ManifestFactory$CharManifest$() {
  if ((!$n_s_reflect_ManifestFactory$CharManifest$)) {
    $n_s_reflect_ManifestFactory$CharManifest$ = new $c_s_reflect_ManifestFactory$CharManifest$().init___()
  };
  return $n_s_reflect_ManifestFactory$CharManifest$
}
/** @constructor */
function $c_s_reflect_ManifestFactory$DoubleManifest$() {
  $c_s_reflect_AnyValManifest.call(this)
}
$c_s_reflect_ManifestFactory$DoubleManifest$.prototype = new $h_s_reflect_AnyValManifest();
$c_s_reflect_ManifestFactory$DoubleManifest$.prototype.constructor = $c_s_reflect_ManifestFactory$DoubleManifest$;
/** @constructor */
function $h_s_reflect_ManifestFactory$DoubleManifest$() {
  /*<skip>*/
}
$h_s_reflect_ManifestFactory$DoubleManifest$.prototype = $c_s_reflect_ManifestFactory$DoubleManifest$.prototype;
$c_s_reflect_ManifestFactory$DoubleManifest$.prototype.init___ = (function() {
  this.toString$1 = "Double";
  return this
});
$c_s_reflect_ManifestFactory$DoubleManifest$.prototype.newArray__I__O = (function(len) {
  return $newArrayObject($d_D.getArrayOf(), [len])
});
$c_s_reflect_ManifestFactory$DoubleManifest$.prototype.runtimeClass__jl_Class = (function() {
  return $d_D.getClassOf()
});
var $d_s_reflect_ManifestFactory$DoubleManifest$ = new $TypeData().initClass({
  s_reflect_ManifestFactory$DoubleManifest$: 0
}, false, "scala.reflect.ManifestFactory$DoubleManifest$", {
  s_reflect_ManifestFactory$DoubleManifest$: 1,
  s_reflect_AnyValManifest: 1,
  O: 1,
  s_reflect_Manifest: 1,
  s_reflect_ClassTag: 1,
  s_reflect_ClassManifestDeprecatedApis: 1,
  s_reflect_OptManifest: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_Equals: 1
});
$c_s_reflect_ManifestFactory$DoubleManifest$.prototype.$classData = $d_s_reflect_ManifestFactory$DoubleManifest$;
var $n_s_reflect_ManifestFactory$DoubleManifest$ = (void 0);
function $m_s_reflect_ManifestFactory$DoubleManifest$() {
  if ((!$n_s_reflect_ManifestFactory$DoubleManifest$)) {
    $n_s_reflect_ManifestFactory$DoubleManifest$ = new $c_s_reflect_ManifestFactory$DoubleManifest$().init___()
  };
  return $n_s_reflect_ManifestFactory$DoubleManifest$
}
/** @constructor */
function $c_s_reflect_ManifestFactory$FloatManifest$() {
  $c_s_reflect_AnyValManifest.call(this)
}
$c_s_reflect_ManifestFactory$FloatManifest$.prototype = new $h_s_reflect_AnyValManifest();
$c_s_reflect_ManifestFactory$FloatManifest$.prototype.constructor = $c_s_reflect_ManifestFactory$FloatManifest$;
/** @constructor */
function $h_s_reflect_ManifestFactory$FloatManifest$() {
  /*<skip>*/
}
$h_s_reflect_ManifestFactory$FloatManifest$.prototype = $c_s_reflect_ManifestFactory$FloatManifest$.prototype;
$c_s_reflect_ManifestFactory$FloatManifest$.prototype.init___ = (function() {
  this.toString$1 = "Float";
  return this
});
$c_s_reflect_ManifestFactory$FloatManifest$.prototype.newArray__I__O = (function(len) {
  return $newArrayObject($d_F.getArrayOf(), [len])
});
$c_s_reflect_ManifestFactory$FloatManifest$.prototype.runtimeClass__jl_Class = (function() {
  return $d_F.getClassOf()
});
var $d_s_reflect_ManifestFactory$FloatManifest$ = new $TypeData().initClass({
  s_reflect_ManifestFactory$FloatManifest$: 0
}, false, "scala.reflect.ManifestFactory$FloatManifest$", {
  s_reflect_ManifestFactory$FloatManifest$: 1,
  s_reflect_AnyValManifest: 1,
  O: 1,
  s_reflect_Manifest: 1,
  s_reflect_ClassTag: 1,
  s_reflect_ClassManifestDeprecatedApis: 1,
  s_reflect_OptManifest: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_Equals: 1
});
$c_s_reflect_ManifestFactory$FloatManifest$.prototype.$classData = $d_s_reflect_ManifestFactory$FloatManifest$;
var $n_s_reflect_ManifestFactory$FloatManifest$ = (void 0);
function $m_s_reflect_ManifestFactory$FloatManifest$() {
  if ((!$n_s_reflect_ManifestFactory$FloatManifest$)) {
    $n_s_reflect_ManifestFactory$FloatManifest$ = new $c_s_reflect_ManifestFactory$FloatManifest$().init___()
  };
  return $n_s_reflect_ManifestFactory$FloatManifest$
}
/** @constructor */
function $c_s_reflect_ManifestFactory$IntManifest$() {
  $c_s_reflect_AnyValManifest.call(this)
}
$c_s_reflect_ManifestFactory$IntManifest$.prototype = new $h_s_reflect_AnyValManifest();
$c_s_reflect_ManifestFactory$IntManifest$.prototype.constructor = $c_s_reflect_ManifestFactory$IntManifest$;
/** @constructor */
function $h_s_reflect_ManifestFactory$IntManifest$() {
  /*<skip>*/
}
$h_s_reflect_ManifestFactory$IntManifest$.prototype = $c_s_reflect_ManifestFactory$IntManifest$.prototype;
$c_s_reflect_ManifestFactory$IntManifest$.prototype.init___ = (function() {
  this.toString$1 = "Int";
  return this
});
$c_s_reflect_ManifestFactory$IntManifest$.prototype.newArray__I__O = (function(len) {
  return $newArrayObject($d_I.getArrayOf(), [len])
});
$c_s_reflect_ManifestFactory$IntManifest$.prototype.runtimeClass__jl_Class = (function() {
  return $d_I.getClassOf()
});
var $d_s_reflect_ManifestFactory$IntManifest$ = new $TypeData().initClass({
  s_reflect_ManifestFactory$IntManifest$: 0
}, false, "scala.reflect.ManifestFactory$IntManifest$", {
  s_reflect_ManifestFactory$IntManifest$: 1,
  s_reflect_AnyValManifest: 1,
  O: 1,
  s_reflect_Manifest: 1,
  s_reflect_ClassTag: 1,
  s_reflect_ClassManifestDeprecatedApis: 1,
  s_reflect_OptManifest: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_Equals: 1
});
$c_s_reflect_ManifestFactory$IntManifest$.prototype.$classData = $d_s_reflect_ManifestFactory$IntManifest$;
var $n_s_reflect_ManifestFactory$IntManifest$ = (void 0);
function $m_s_reflect_ManifestFactory$IntManifest$() {
  if ((!$n_s_reflect_ManifestFactory$IntManifest$)) {
    $n_s_reflect_ManifestFactory$IntManifest$ = new $c_s_reflect_ManifestFactory$IntManifest$().init___()
  };
  return $n_s_reflect_ManifestFactory$IntManifest$
}
/** @constructor */
function $c_s_reflect_ManifestFactory$LongManifest$() {
  $c_s_reflect_AnyValManifest.call(this)
}
$c_s_reflect_ManifestFactory$LongManifest$.prototype = new $h_s_reflect_AnyValManifest();
$c_s_reflect_ManifestFactory$LongManifest$.prototype.constructor = $c_s_reflect_ManifestFactory$LongManifest$;
/** @constructor */
function $h_s_reflect_ManifestFactory$LongManifest$() {
  /*<skip>*/
}
$h_s_reflect_ManifestFactory$LongManifest$.prototype = $c_s_reflect_ManifestFactory$LongManifest$.prototype;
$c_s_reflect_ManifestFactory$LongManifest$.prototype.init___ = (function() {
  this.toString$1 = "Long";
  return this
});
$c_s_reflect_ManifestFactory$LongManifest$.prototype.newArray__I__O = (function(len) {
  return $newArrayObject($d_J.getArrayOf(), [len])
});
$c_s_reflect_ManifestFactory$LongManifest$.prototype.runtimeClass__jl_Class = (function() {
  return $d_J.getClassOf()
});
var $d_s_reflect_ManifestFactory$LongManifest$ = new $TypeData().initClass({
  s_reflect_ManifestFactory$LongManifest$: 0
}, false, "scala.reflect.ManifestFactory$LongManifest$", {
  s_reflect_ManifestFactory$LongManifest$: 1,
  s_reflect_AnyValManifest: 1,
  O: 1,
  s_reflect_Manifest: 1,
  s_reflect_ClassTag: 1,
  s_reflect_ClassManifestDeprecatedApis: 1,
  s_reflect_OptManifest: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_Equals: 1
});
$c_s_reflect_ManifestFactory$LongManifest$.prototype.$classData = $d_s_reflect_ManifestFactory$LongManifest$;
var $n_s_reflect_ManifestFactory$LongManifest$ = (void 0);
function $m_s_reflect_ManifestFactory$LongManifest$() {
  if ((!$n_s_reflect_ManifestFactory$LongManifest$)) {
    $n_s_reflect_ManifestFactory$LongManifest$ = new $c_s_reflect_ManifestFactory$LongManifest$().init___()
  };
  return $n_s_reflect_ManifestFactory$LongManifest$
}
/** @constructor */
function $c_s_reflect_ManifestFactory$PhantomManifest() {
  $c_s_reflect_ManifestFactory$ClassTypeManifest.call(this);
  this.toString$2 = null
}
$c_s_reflect_ManifestFactory$PhantomManifest.prototype = new $h_s_reflect_ManifestFactory$ClassTypeManifest();
$c_s_reflect_ManifestFactory$PhantomManifest.prototype.constructor = $c_s_reflect_ManifestFactory$PhantomManifest;
/** @constructor */
function $h_s_reflect_ManifestFactory$PhantomManifest() {
  /*<skip>*/
}
$h_s_reflect_ManifestFactory$PhantomManifest.prototype = $c_s_reflect_ManifestFactory$PhantomManifest.prototype;
$c_s_reflect_ManifestFactory$PhantomManifest.prototype.equals__O__Z = (function(that) {
  return (this === that)
});
$c_s_reflect_ManifestFactory$PhantomManifest.prototype.toString__T = (function() {
  return this.toString$2
});
$c_s_reflect_ManifestFactory$PhantomManifest.prototype.hashCode__I = (function() {
  return $systemIdentityHashCode(this)
});
/** @constructor */
function $c_s_reflect_ManifestFactory$ShortManifest$() {
  $c_s_reflect_AnyValManifest.call(this)
}
$c_s_reflect_ManifestFactory$ShortManifest$.prototype = new $h_s_reflect_AnyValManifest();
$c_s_reflect_ManifestFactory$ShortManifest$.prototype.constructor = $c_s_reflect_ManifestFactory$ShortManifest$;
/** @constructor */
function $h_s_reflect_ManifestFactory$ShortManifest$() {
  /*<skip>*/
}
$h_s_reflect_ManifestFactory$ShortManifest$.prototype = $c_s_reflect_ManifestFactory$ShortManifest$.prototype;
$c_s_reflect_ManifestFactory$ShortManifest$.prototype.init___ = (function() {
  this.toString$1 = "Short";
  return this
});
$c_s_reflect_ManifestFactory$ShortManifest$.prototype.newArray__I__O = (function(len) {
  return $newArrayObject($d_S.getArrayOf(), [len])
});
$c_s_reflect_ManifestFactory$ShortManifest$.prototype.runtimeClass__jl_Class = (function() {
  return $d_S.getClassOf()
});
var $d_s_reflect_ManifestFactory$ShortManifest$ = new $TypeData().initClass({
  s_reflect_ManifestFactory$ShortManifest$: 0
}, false, "scala.reflect.ManifestFactory$ShortManifest$", {
  s_reflect_ManifestFactory$ShortManifest$: 1,
  s_reflect_AnyValManifest: 1,
  O: 1,
  s_reflect_Manifest: 1,
  s_reflect_ClassTag: 1,
  s_reflect_ClassManifestDeprecatedApis: 1,
  s_reflect_OptManifest: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_Equals: 1
});
$c_s_reflect_ManifestFactory$ShortManifest$.prototype.$classData = $d_s_reflect_ManifestFactory$ShortManifest$;
var $n_s_reflect_ManifestFactory$ShortManifest$ = (void 0);
function $m_s_reflect_ManifestFactory$ShortManifest$() {
  if ((!$n_s_reflect_ManifestFactory$ShortManifest$)) {
    $n_s_reflect_ManifestFactory$ShortManifest$ = new $c_s_reflect_ManifestFactory$ShortManifest$().init___()
  };
  return $n_s_reflect_ManifestFactory$ShortManifest$
}
/** @constructor */
function $c_s_reflect_ManifestFactory$UnitManifest$() {
  $c_s_reflect_AnyValManifest.call(this)
}
$c_s_reflect_ManifestFactory$UnitManifest$.prototype = new $h_s_reflect_AnyValManifest();
$c_s_reflect_ManifestFactory$UnitManifest$.prototype.constructor = $c_s_reflect_ManifestFactory$UnitManifest$;
/** @constructor */
function $h_s_reflect_ManifestFactory$UnitManifest$() {
  /*<skip>*/
}
$h_s_reflect_ManifestFactory$UnitManifest$.prototype = $c_s_reflect_ManifestFactory$UnitManifest$.prototype;
$c_s_reflect_ManifestFactory$UnitManifest$.prototype.init___ = (function() {
  this.toString$1 = "Unit";
  return this
});
$c_s_reflect_ManifestFactory$UnitManifest$.prototype.newArray__I__O = (function(len) {
  return $newArrayObject($d_sr_BoxedUnit.getArrayOf(), [len])
});
$c_s_reflect_ManifestFactory$UnitManifest$.prototype.runtimeClass__jl_Class = (function() {
  return $d_V.getClassOf()
});
var $d_s_reflect_ManifestFactory$UnitManifest$ = new $TypeData().initClass({
  s_reflect_ManifestFactory$UnitManifest$: 0
}, false, "scala.reflect.ManifestFactory$UnitManifest$", {
  s_reflect_ManifestFactory$UnitManifest$: 1,
  s_reflect_AnyValManifest: 1,
  O: 1,
  s_reflect_Manifest: 1,
  s_reflect_ClassTag: 1,
  s_reflect_ClassManifestDeprecatedApis: 1,
  s_reflect_OptManifest: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_Equals: 1
});
$c_s_reflect_ManifestFactory$UnitManifest$.prototype.$classData = $d_s_reflect_ManifestFactory$UnitManifest$;
var $n_s_reflect_ManifestFactory$UnitManifest$ = (void 0);
function $m_s_reflect_ManifestFactory$UnitManifest$() {
  if ((!$n_s_reflect_ManifestFactory$UnitManifest$)) {
    $n_s_reflect_ManifestFactory$UnitManifest$ = new $c_s_reflect_ManifestFactory$UnitManifest$().init___()
  };
  return $n_s_reflect_ManifestFactory$UnitManifest$
}
function $f_sc_IterableLike__sameElements__sc_GenIterable__Z($thiz, that) {
  if ((that instanceof $c_sci_Vector)) {
    var x2 = $as_sci_Vector(that);
    if (($thiz instanceof $c_sci_Vector)) {
      var thisVector = $as_sci_Vector($thiz);
      if ((thisVector === x2)) {
        return true
      } else {
        var equal = (thisVector.length__I() === x2.length__I());
        if (equal) {
          var length = x2.length__I();
          var index = 0;
          while (((index < length) && equal)) {
            equal = $m_sr_BoxesRunTime$().equals__O__O__Z(thisVector.apply__I__O(index), x2.apply__I__O(index));
            index = ((1 + index) | 0)
          }
        };
        return equal
      }
    }
  };
  var these = $thiz.iterator__sc_Iterator();
  var those = that.iterator__sc_Iterator();
  while ((these.hasNext__Z() && those.hasNext__Z())) {
    if ((!$m_sr_BoxesRunTime$().equals__O__O__Z(these.next__O(), those.next__O()))) {
      return false
    }
  };
  return ((!these.hasNext__Z()) && (!those.hasNext__Z()))
}
function $f_sc_IterableLike__isEmpty__Z($thiz) {
  return (!$thiz.iterator__sc_Iterator().hasNext__Z())
}
function $f_sc_IterableLike__takeWhile__F1__O($thiz, p) {
  var b = $thiz.newBuilder__scm_Builder();
  var it = $thiz.iterator__sc_Iterator();
  while (it.hasNext__Z()) {
    var x = it.next__O();
    if ((!$uZ(p.apply__O__O(x)))) {
      return b.result__O()
    };
    b.$$plus$eq__O__scm_Builder(x)
  };
  return b.result__O()
}
function $f_sc_IterableLike__zipWithIndex__scg_CanBuildFrom__O($thiz, bf) {
  var b = bf.apply__O__scm_Builder($thiz.repr__O());
  var i = new $c_sr_IntRef().init___I(0);
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$1, i$1) {
    return (function(x$2) {
      b$1.$$plus$eq__O__scm_Builder(new $c_T2().init___O__O(x$2, i$1.elem$1));
      i$1.elem$1 = ((1 + i$1.elem$1) | 0)
    })
  })($thiz, b, i)));
  return b.result__O()
}
function $f_sc_IterableLike__take__I__O($thiz, n) {
  var b = $thiz.newBuilder__scm_Builder();
  if ((n <= 0)) {
    return b.result__O()
  } else {
    b.sizeHintBounded__I__sc_TraversableLike__V(n, $thiz);
    var i = 0;
    var it = $thiz.iterator__sc_Iterator();
    while (((i < n) && it.hasNext__Z())) {
      b.$$plus$eq__O__scm_Builder(it.next__O());
      i = ((1 + i) | 0)
    };
    return b.result__O()
  }
}
function $f_sc_IterableLike__drop__I__O($thiz, n) {
  var b = $thiz.newBuilder__scm_Builder();
  var lo = ((n < 0) ? 0 : n);
  var delta = ((-lo) | 0);
  $f_scm_Builder__sizeHint__sc_TraversableLike__I__V(b, $thiz, delta);
  var i = 0;
  var it = $thiz.iterator__sc_Iterator();
  while (((i < n) && it.hasNext__Z())) {
    it.next__O();
    i = ((1 + i) | 0)
  };
  return $as_scm_Builder(b.$$plus$plus$eq__sc_TraversableOnce__scg_Growable(it)).result__O()
}
function $f_sc_IterableLike__copyToArray__O__I__I__V($thiz, xs, start, len) {
  var i = start;
  var x = ((start + len) | 0);
  var that = $m_sr_ScalaRunTime$().array$undlength__O__I(xs);
  var end = ((x < that) ? x : that);
  var it = $thiz.iterator__sc_Iterator();
  while (((i < end) && it.hasNext__Z())) {
    $m_sr_ScalaRunTime$().array$undupdate__O__I__O__V(xs, i, it.next__O());
    i = ((1 + i) | 0)
  }
}
function $f_sc_IterableLike__dropRight__I__O($thiz, n) {
  var b = $thiz.newBuilder__scm_Builder();
  if ((n >= 0)) {
    var delta = ((-n) | 0);
    $f_scm_Builder__sizeHint__sc_TraversableLike__I__V(b, $thiz, delta)
  };
  var lead = $thiz.iterator__sc_Iterator().drop__I__sc_Iterator(n);
  var it = $thiz.iterator__sc_Iterator();
  while (lead.hasNext__Z()) {
    b.$$plus$eq__O__scm_Builder(it.next__O());
    lead.next__O()
  };
  return b.result__O()
}
function $f_sc_IterableLike__zip__sc_GenIterable__scg_CanBuildFrom__O($thiz, that, bf) {
  var b = bf.apply__O__scm_Builder($thiz.repr__O());
  var these = $thiz.iterator__sc_Iterator();
  var those = that.iterator__sc_Iterator();
  while ((these.hasNext__Z() && those.hasNext__Z())) {
    b.$$plus$eq__O__scm_Builder(new $c_T2().init___O__O(these.next__O(), those.next__O()))
  };
  return b.result__O()
}
function $is_sc_IterableLike(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_IterableLike)))
}
function $as_sc_IterableLike(obj) {
  return (($is_sc_IterableLike(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.IterableLike"))
}
function $isArrayOf_sc_IterableLike(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_IterableLike)))
}
function $asArrayOf_sc_IterableLike(obj, depth) {
  return (($isArrayOf_sc_IterableLike(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.IterableLike;", depth))
}
function $is_sc_Traversable(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_Traversable)))
}
function $as_sc_Traversable(obj) {
  return (($is_sc_Traversable(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.Traversable"))
}
function $isArrayOf_sc_Traversable(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_Traversable)))
}
function $asArrayOf_sc_Traversable(obj, depth) {
  return (($isArrayOf_sc_Traversable(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.Traversable;", depth))
}
/** @constructor */
function $c_sci_List$() {
  $c_scg_SeqFactory.call(this);
  this.partialNotApplied$5 = null
}
$c_sci_List$.prototype = new $h_scg_SeqFactory();
$c_sci_List$.prototype.constructor = $c_sci_List$;
/** @constructor */
function $h_sci_List$() {
  /*<skip>*/
}
$h_sci_List$.prototype = $c_sci_List$.prototype;
$c_sci_List$.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory.prototype.init___.call(this);
  $n_sci_List$ = this;
  this.partialNotApplied$5 = new $c_sci_List$$anon$1().init___();
  return this
});
$c_sci_List$.prototype.empty__sc_GenTraversable = (function() {
  return $m_sci_Nil$()
});
$c_sci_List$.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_ListBuffer().init___()
});
var $d_sci_List$ = new $TypeData().initClass({
  sci_List$: 0
}, false, "scala.collection.immutable.List$", {
  sci_List$: 1,
  scg_SeqFactory: 1,
  scg_GenSeqFactory: 1,
  scg_GenTraversableFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_TraversableFactory: 1,
  scg_GenericSeqCompanion: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_List$.prototype.$classData = $d_sci_List$;
var $n_sci_List$ = (void 0);
function $m_sci_List$() {
  if ((!$n_sci_List$)) {
    $n_sci_List$ = new $c_sci_List$().init___()
  };
  return $n_sci_List$
}
/** @constructor */
function $c_sci_Stream$() {
  $c_scg_SeqFactory.call(this)
}
$c_sci_Stream$.prototype = new $h_scg_SeqFactory();
$c_sci_Stream$.prototype.constructor = $c_sci_Stream$;
/** @constructor */
function $h_sci_Stream$() {
  /*<skip>*/
}
$h_sci_Stream$.prototype = $c_sci_Stream$.prototype;
$c_sci_Stream$.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory.prototype.init___.call(this);
  return this
});
$c_sci_Stream$.prototype.from__I__I__sci_Stream = (function(start, step) {
  var tl = new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, start$1, step$1) {
    return (function() {
      return $m_sci_Stream$().from__I__I__sci_Stream(((start$1 + step$1) | 0), step$1)
    })
  })(this, start, step));
  return new $c_sci_Stream$Cons().init___O__F0(start, tl)
});
$c_sci_Stream$.prototype.filteredTail__sci_Stream__F1__Z__sci_Stream$Cons = (function(stream, p, isFlipped) {
  var hd = stream.head__O();
  var tl = new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, stream$1, p$1, isFlipped$1) {
    return (function() {
      return $as_sci_Stream(stream$1.tail__O()).filterImpl__F1__Z__sci_Stream(p$1, isFlipped$1)
    })
  })(this, stream, p, isFlipped));
  return new $c_sci_Stream$Cons().init___O__F0(hd, tl)
});
$c_sci_Stream$.prototype.empty__sc_GenTraversable = (function() {
  return $m_sci_Stream$Empty$()
});
$c_sci_Stream$.prototype.collectedTail__O__sci_Stream__s_PartialFunction__scg_CanBuildFrom__sci_Stream$Cons = (function(head, stream, pf, bf) {
  var tl = new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, stream$1, pf$1, bf$1) {
    return (function() {
      return $as_sci_Stream($as_sci_Stream(stream$1.tail__O()).collect__s_PartialFunction__scg_CanBuildFrom__O(pf$1, bf$1))
    })
  })(this, stream, pf, bf));
  return new $c_sci_Stream$Cons().init___O__F0(head, tl)
});
$c_sci_Stream$.prototype.newBuilder__scm_Builder = (function() {
  return new $c_sci_Stream$StreamBuilder().init___()
});
var $d_sci_Stream$ = new $TypeData().initClass({
  sci_Stream$: 0
}, false, "scala.collection.immutable.Stream$", {
  sci_Stream$: 1,
  scg_SeqFactory: 1,
  scg_GenSeqFactory: 1,
  scg_GenTraversableFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_TraversableFactory: 1,
  scg_GenericSeqCompanion: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_Stream$.prototype.$classData = $d_sci_Stream$;
var $n_sci_Stream$ = (void 0);
function $m_sci_Stream$() {
  if ((!$n_sci_Stream$)) {
    $n_sci_Stream$ = new $c_sci_Stream$().init___()
  };
  return $n_sci_Stream$
}
/** @constructor */
function $c_scm_ArrayBuffer$() {
  $c_scg_SeqFactory.call(this)
}
$c_scm_ArrayBuffer$.prototype = new $h_scg_SeqFactory();
$c_scm_ArrayBuffer$.prototype.constructor = $c_scm_ArrayBuffer$;
/** @constructor */
function $h_scm_ArrayBuffer$() {
  /*<skip>*/
}
$h_scm_ArrayBuffer$.prototype = $c_scm_ArrayBuffer$.prototype;
$c_scm_ArrayBuffer$.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory.prototype.init___.call(this);
  return this
});
$c_scm_ArrayBuffer$.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_ArrayBuffer().init___()
});
var $d_scm_ArrayBuffer$ = new $TypeData().initClass({
  scm_ArrayBuffer$: 0
}, false, "scala.collection.mutable.ArrayBuffer$", {
  scm_ArrayBuffer$: 1,
  scg_SeqFactory: 1,
  scg_GenSeqFactory: 1,
  scg_GenTraversableFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_TraversableFactory: 1,
  scg_GenericSeqCompanion: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_ArrayBuffer$.prototype.$classData = $d_scm_ArrayBuffer$;
var $n_scm_ArrayBuffer$ = (void 0);
function $m_scm_ArrayBuffer$() {
  if ((!$n_scm_ArrayBuffer$)) {
    $n_scm_ArrayBuffer$ = new $c_scm_ArrayBuffer$().init___()
  };
  return $n_scm_ArrayBuffer$
}
/** @constructor */
function $c_scm_ArraySeq$() {
  $c_scg_SeqFactory.call(this)
}
$c_scm_ArraySeq$.prototype = new $h_scg_SeqFactory();
$c_scm_ArraySeq$.prototype.constructor = $c_scm_ArraySeq$;
/** @constructor */
function $h_scm_ArraySeq$() {
  /*<skip>*/
}
$h_scm_ArraySeq$.prototype = $c_scm_ArraySeq$.prototype;
$c_scm_ArraySeq$.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory.prototype.init___.call(this);
  return this
});
$c_scm_ArraySeq$.prototype.newBuilder__scm_Builder = (function() {
  var this$1 = new $c_scm_ArrayBuffer().init___();
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(buf$2) {
      var buf = $as_scm_ArrayBuffer(buf$2);
      var result = new $c_scm_ArraySeq().init___I(buf.size0$6);
      var xs = result.array$5;
      $f_sc_TraversableOnce__copyToArray__O__I__V(buf, xs, 0);
      return result
    })
  })(this));
  return new $c_scm_Builder$$anon$1().init___scm_Builder__F1(this$1, f)
});
var $d_scm_ArraySeq$ = new $TypeData().initClass({
  scm_ArraySeq$: 0
}, false, "scala.collection.mutable.ArraySeq$", {
  scm_ArraySeq$: 1,
  scg_SeqFactory: 1,
  scg_GenSeqFactory: 1,
  scg_GenTraversableFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_TraversableFactory: 1,
  scg_GenericSeqCompanion: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_ArraySeq$.prototype.$classData = $d_scm_ArraySeq$;
var $n_scm_ArraySeq$ = (void 0);
function $m_scm_ArraySeq$() {
  if ((!$n_scm_ArraySeq$)) {
    $n_scm_ArraySeq$ = new $c_scm_ArraySeq$().init___()
  };
  return $n_scm_ArraySeq$
}
/** @constructor */
function $c_scm_LinkedList$() {
  $c_scg_SeqFactory.call(this)
}
$c_scm_LinkedList$.prototype = new $h_scg_SeqFactory();
$c_scm_LinkedList$.prototype.constructor = $c_scm_LinkedList$;
/** @constructor */
function $h_scm_LinkedList$() {
  /*<skip>*/
}
$h_scm_LinkedList$.prototype = $c_scm_LinkedList$.prototype;
$c_scm_LinkedList$.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory.prototype.init___.call(this);
  return this
});
$c_scm_LinkedList$.prototype.empty__sc_GenTraversable = (function() {
  return new $c_scm_LinkedList().init___()
});
$c_scm_LinkedList$.prototype.newBuilder__scm_Builder = (function() {
  var this$1 = new $c_scm_MutableList().init___();
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(l$2) {
      var l = $as_scm_MutableList(l$2);
      return l.first0$5
    })
  })(this));
  return new $c_scm_Builder$$anon$1().init___scm_Builder__F1(this$1, f)
});
var $d_scm_LinkedList$ = new $TypeData().initClass({
  scm_LinkedList$: 0
}, false, "scala.collection.mutable.LinkedList$", {
  scm_LinkedList$: 1,
  scg_SeqFactory: 1,
  scg_GenSeqFactory: 1,
  scg_GenTraversableFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_TraversableFactory: 1,
  scg_GenericSeqCompanion: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_LinkedList$.prototype.$classData = $d_scm_LinkedList$;
var $n_scm_LinkedList$ = (void 0);
function $m_scm_LinkedList$() {
  if ((!$n_scm_LinkedList$)) {
    $n_scm_LinkedList$ = new $c_scm_LinkedList$().init___()
  };
  return $n_scm_LinkedList$
}
/** @constructor */
function $c_scm_ListBuffer$() {
  $c_scg_SeqFactory.call(this)
}
$c_scm_ListBuffer$.prototype = new $h_scg_SeqFactory();
$c_scm_ListBuffer$.prototype.constructor = $c_scm_ListBuffer$;
/** @constructor */
function $h_scm_ListBuffer$() {
  /*<skip>*/
}
$h_scm_ListBuffer$.prototype = $c_scm_ListBuffer$.prototype;
$c_scm_ListBuffer$.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory.prototype.init___.call(this);
  return this
});
$c_scm_ListBuffer$.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_ListBuffer().init___())
});
var $d_scm_ListBuffer$ = new $TypeData().initClass({
  scm_ListBuffer$: 0
}, false, "scala.collection.mutable.ListBuffer$", {
  scm_ListBuffer$: 1,
  scg_SeqFactory: 1,
  scg_GenSeqFactory: 1,
  scg_GenTraversableFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_TraversableFactory: 1,
  scg_GenericSeqCompanion: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_ListBuffer$.prototype.$classData = $d_scm_ListBuffer$;
var $n_scm_ListBuffer$ = (void 0);
function $m_scm_ListBuffer$() {
  if ((!$n_scm_ListBuffer$)) {
    $n_scm_ListBuffer$ = new $c_scm_ListBuffer$().init___()
  };
  return $n_scm_ListBuffer$
}
/** @constructor */
function $c_scm_MutableList$() {
  $c_scg_SeqFactory.call(this)
}
$c_scm_MutableList$.prototype = new $h_scg_SeqFactory();
$c_scm_MutableList$.prototype.constructor = $c_scm_MutableList$;
/** @constructor */
function $h_scm_MutableList$() {
  /*<skip>*/
}
$h_scm_MutableList$.prototype = $c_scm_MutableList$.prototype;
$c_scm_MutableList$.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory.prototype.init___.call(this);
  return this
});
$c_scm_MutableList$.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_MutableList().init___()
});
var $d_scm_MutableList$ = new $TypeData().initClass({
  scm_MutableList$: 0
}, false, "scala.collection.mutable.MutableList$", {
  scm_MutableList$: 1,
  scg_SeqFactory: 1,
  scg_GenSeqFactory: 1,
  scg_GenTraversableFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_TraversableFactory: 1,
  scg_GenericSeqCompanion: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_MutableList$.prototype.$classData = $d_scm_MutableList$;
var $n_scm_MutableList$ = (void 0);
function $m_scm_MutableList$() {
  if ((!$n_scm_MutableList$)) {
    $n_scm_MutableList$ = new $c_scm_MutableList$().init___()
  };
  return $n_scm_MutableList$
}
/** @constructor */
function $c_scm_Queue$() {
  $c_scg_SeqFactory.call(this)
}
$c_scm_Queue$.prototype = new $h_scg_SeqFactory();
$c_scm_Queue$.prototype.constructor = $c_scm_Queue$;
/** @constructor */
function $h_scm_Queue$() {
  /*<skip>*/
}
$h_scm_Queue$.prototype = $c_scm_Queue$.prototype;
$c_scm_Queue$.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory.prototype.init___.call(this);
  return this
});
$c_scm_Queue$.prototype.newBuilder__scm_Builder = (function() {
  var this$1 = new $c_scm_MutableList().init___();
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_scm_MutableList(x$1$2);
      return new $c_scm_Queue().init___scm_LinkedList__scm_LinkedList__I(x$1.first0$5, x$1.last0$5, x$1.len$5)
    })
  })(this));
  return new $c_scm_Builder$$anon$1().init___scm_Builder__F1(this$1, f)
});
var $d_scm_Queue$ = new $TypeData().initClass({
  scm_Queue$: 0
}, false, "scala.collection.mutable.Queue$", {
  scm_Queue$: 1,
  scg_SeqFactory: 1,
  scg_GenSeqFactory: 1,
  scg_GenTraversableFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_TraversableFactory: 1,
  scg_GenericSeqCompanion: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_Queue$.prototype.$classData = $d_scm_Queue$;
var $n_scm_Queue$ = (void 0);
function $m_scm_Queue$() {
  if ((!$n_scm_Queue$)) {
    $n_scm_Queue$ = new $c_scm_Queue$().init___()
  };
  return $n_scm_Queue$
}
/** @constructor */
function $c_Lamf_client_model_document_Module() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_document_Module.prototype = new $h_O();
$c_Lamf_client_model_document_Module.prototype.constructor = $c_Lamf_client_model_document_Module;
/** @constructor */
function $h_Lamf_client_model_document_Module() {
  /*<skip>*/
}
$h_Lamf_client_model_document_Module.prototype = $c_Lamf_client_model_document_Module.prototype;
$c_Lamf_client_model_document_Module.prototype.productPrefix__T = (function() {
  return "Module"
});
$c_Lamf_client_model_document_Module.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_document_Module.prototype.init___Lamf_core_model_document_Module.call(this, new $c_Lamf_core_model_document_Module().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$meth$withRaw__T__O = (function(raw) {
  return $f_Lamf_client_model_document_BaseUnit__withRaw__T__Lamf_client_model_document_BaseUnit(this, raw)
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$meth$findById__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__findById__T__sjs_js_UndefOr(this, id)
});
$c_Lamf_client_model_document_Module.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$meth$withReferences__sjs_js_Array__O = (function(references) {
  return $f_Lamf_client_model_document_BaseUnit__withReferences__sjs_js_Array__Lamf_client_model_document_BaseUnit(this, references)
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$meth$references__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__references__sjs_js_Array(this)
});
$c_Lamf_client_model_document_Module.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_document_Module)) {
    var Module$1 = $as_Lamf_client_model_document_Module(x$1);
    var x = this.$$undinternal$1;
    var x$2 = Module$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_document_Module.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$prop$modelVersion__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__modelVersion__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$prop$location__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__location__T(this)
});
$c_Lamf_client_model_document_Module.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_document_Module.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$meth$withDeclares__sjs_js_Array__O = (function(declares) {
  return $f_Lamf_client_model_document_DeclaresModel__withDeclares__sjs_js_Array__Lamf_client_model_document_DeclaresModel(this, declares)
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__withId__T__Lamf_client_model_document_BaseUnit(this, id)
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$meth$cloneUnit__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__cloneUnit__Lamf_client_model_document_BaseUnit(this)
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$meth$findByType__T__O = (function(typeId) {
  return $f_Lamf_client_model_document_BaseUnit__findByType__T__sjs_js_Array(this, typeId)
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$meth$withLocation__T__O = (function(location) {
  return $f_Lamf_client_model_document_BaseUnit__withLocation__T__Lamf_client_model_document_BaseUnit(this, location)
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$prop$raw__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__raw__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_Module.prototype.$$undinternal__Lamf_core_model_document_DeclaresModel = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O = (function(renderOptions) {
  return $f_Lamf_client_model_document_BaseUnit__toNativeRdfModel__Lamf_client_render_RenderOptions__Lamf_core_rdf_RdfModel(this, renderOptions)
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_document_Module.prototype.init___Lamf_core_model_document_Module = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions = (function() {
  return new $c_Lamf_client_render_RenderOptions().init___()
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$meth$withUsage__T__O = (function(usage) {
  return $f_Lamf_client_model_document_BaseUnit__withUsage__T__Lamf_client_model_document_BaseUnit(this, usage)
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_document_Module.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$meth$withReferenceAlias__T__T__T__O = (function(alias, fullUrl, relativeUrl) {
  return $f_Lamf_client_model_document_BaseUnit__withReferenceAlias__T__T__T__Lamf_client_model_document_BaseUnit(this, alias, fullUrl, relativeUrl)
});
$c_Lamf_client_model_document_Module.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$prop$declares__O = (function() {
  return $f_Lamf_client_model_document_DeclaresModel__declares__sjs_js_Array(this)
});
$c_Lamf_client_model_document_Module.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$meth$withDeclaredElement__Lamf_client_model_domain_DomainElement__O = (function(declared) {
  return $f_Lamf_client_model_document_DeclaresModel__withDeclaredElement__Lamf_client_model_domain_DomainElement__Lamf_client_model_document_DeclaresModel(this, declared)
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$prop$sourceVendor__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__sourceVendor__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_Module.prototype.$$js$exported$prop$usage__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__usage__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_Module.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_document_Module.prototype.withReferenceAlias = (function(arg, arg$2, arg$3) {
  var prep = $as_T(arg);
  var prep$2 = $as_T(arg$2);
  var prep$3 = $as_T(arg$3);
  return this.$$js$exported$meth$withReferenceAlias__T__T__T__O(prep, prep$2, prep$3)
});
$c_Lamf_client_model_document_Module.prototype.cloneUnit = (function() {
  return this.$$js$exported$meth$cloneUnit__O()
});
Object.defineProperty($c_Lamf_client_model_document_Module.prototype, "sourceVendor", {
  "get": (function() {
    return this.$$js$exported$prop$sourceVendor__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_Module.prototype.findByType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findByType__T__O(prep)
});
$c_Lamf_client_model_document_Module.prototype.findById = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findById__T__O(prep)
});
$c_Lamf_client_model_document_Module.prototype.toNativeRdfModel = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions() : $as_Lamf_client_render_RenderOptions(rest[0]));
  return this.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O(prep)
});
$c_Lamf_client_model_document_Module.prototype.withUsage = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withUsage__T__O(prep)
});
$c_Lamf_client_model_document_Module.prototype.withLocation = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLocation__T__O(prep)
});
$c_Lamf_client_model_document_Module.prototype.withRaw = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withRaw__T__O(prep)
});
$c_Lamf_client_model_document_Module.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_document_Module.prototype.withReferences = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withReferences__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_Module.prototype, "modelVersion", {
  "get": (function() {
    return this.$$js$exported$prop$modelVersion__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Module.prototype, "usage", {
  "get": (function() {
    return this.$$js$exported$prop$usage__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Module.prototype, "location", {
  "get": (function() {
    return this.$$js$exported$prop$location__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Module.prototype, "raw", {
  "get": (function() {
    return this.$$js$exported$prop$raw__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_Module.prototype.references = (function() {
  return this.$$js$exported$meth$references__O()
});
Object.defineProperty($c_Lamf_client_model_document_Module.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_Module.prototype.withDeclares = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withDeclares__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_document_Module.prototype.withDeclaredElement = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withDeclaredElement__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_Module.prototype, "declares", {
  "get": (function() {
    return this.$$js$exported$prop$declares__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_document_Module(obj) {
  return (((obj instanceof $c_Lamf_client_model_document_Module) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.document.Module"))
}
function $isArrayOf_Lamf_client_model_document_Module(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_document_Module)))
}
function $asArrayOf_Lamf_client_model_document_Module(obj, depth) {
  return (($isArrayOf_Lamf_client_model_document_Module(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.document.Module;", depth))
}
var $d_Lamf_client_model_document_Module = new $TypeData().initClass({
  Lamf_client_model_document_Module: 0
}, false, "amf.client.model.document.Module", {
  Lamf_client_model_document_Module: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_DeclaresModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_document_Module.prototype.$classData = $d_Lamf_client_model_document_Module;
/** @constructor */
function $c_Lamf_client_model_domain_Amqp091ChannelExchange() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype = new $h_O();
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.constructor = $c_Lamf_client_model_domain_Amqp091ChannelExchange;
/** @constructor */
function $h_Lamf_client_model_domain_Amqp091ChannelExchange() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_Amqp091ChannelExchange.prototype = $c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype;
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.withVHost__T__Lamf_client_model_domain_Amqp091ChannelExchange = (function(vHost) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$().VHost$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, vHost));
  return this
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.productPrefix__T = (function() {
  return "Amqp091ChannelExchange"
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange.call(this, new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$js$exported$meth$withVHost__T__O = (function(vHost) {
  return this.withVHost__T__Lamf_client_model_domain_Amqp091ChannelExchange(vHost)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.withAutoDelete__Z__Lamf_client_model_domain_Amqp091ChannelExchange = (function(autoDelete) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$().AutoDelete$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, autoDelete));
  return this
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$js$exported$prop$durable__O = (function() {
  return this.durable__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$js$exported$prop$autoDelete__O = (function() {
  return this.autoDelete__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_Amqp091ChannelExchange)) {
    var Amqp091ChannelExchange$1 = $as_Lamf_client_model_domain_Amqp091ChannelExchange(x$1);
    var x = this.$$undinternal$1;
    var x$2 = Amqp091ChannelExchange$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$js$exported$meth$withAutoDelete__Z__O = (function(autoDelete) {
  return this.withAutoDelete__Z__Lamf_client_model_domain_Amqp091ChannelExchange(autoDelete)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.withName__T__Lamf_client_model_domain_Amqp091ChannelExchange = (function(name) {
  var this$3 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.type__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$().Type$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$js$exported$meth$withType__T__O = (function(type) {
  return this.withType__T__Lamf_client_model_domain_Amqp091ChannelExchange(type)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$js$exported$prop$type__O = (function() {
  return this.type__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$js$exported$prop$vHost__O = (function() {
  return this.vHost__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$js$exported$meth$withDurable__Z__O = (function(durable) {
  return this.withDurable__Z__Lamf_client_model_domain_Amqp091ChannelExchange(durable)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.withDurable__Z__Lamf_client_model_domain_Amqp091ChannelExchange = (function(durable) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$().Durable$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, durable));
  return this
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.withType__T__Lamf_client_model_domain_Amqp091ChannelExchange = (function(type) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$().Type$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, type));
  return this
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.vHost__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$().VHost$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.autoDelete__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$().AutoDelete$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.durable__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelExchangeModel$().Durable$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_Amqp091ChannelExchange(name)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.withVHost = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withVHost__T__O(prep)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.withAutoDelete = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withAutoDelete__Z__O(prep)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.withDurable = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withDurable__Z__O(prep)
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.withType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withType__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype, "vHost", {
  "get": (function() {
    return this.$$js$exported$prop$vHost__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype, "autoDelete", {
  "get": (function() {
    return this.$$js$exported$prop$autoDelete__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype, "durable", {
  "get": (function() {
    return this.$$js$exported$prop$durable__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype, "type", {
  "get": (function() {
    return this.$$js$exported$prop$type__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_Amqp091ChannelExchange(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_Amqp091ChannelExchange) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Amqp091ChannelExchange"))
}
function $isArrayOf_Lamf_client_model_domain_Amqp091ChannelExchange(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Amqp091ChannelExchange)))
}
function $asArrayOf_Lamf_client_model_domain_Amqp091ChannelExchange(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Amqp091ChannelExchange(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Amqp091ChannelExchange;", depth))
}
var $d_Lamf_client_model_domain_Amqp091ChannelExchange = new $TypeData().initClass({
  Lamf_client_model_domain_Amqp091ChannelExchange: 0
}, false, "amf.client.model.domain.Amqp091ChannelExchange", {
  Lamf_client_model_domain_Amqp091ChannelExchange: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.$classData = $d_Lamf_client_model_domain_Amqp091ChannelExchange;
/** @constructor */
function $c_Lamf_client_model_domain_Amqp091Queue() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_Amqp091Queue.prototype = new $h_O();
$c_Lamf_client_model_domain_Amqp091Queue.prototype.constructor = $c_Lamf_client_model_domain_Amqp091Queue;
/** @constructor */
function $h_Lamf_client_model_domain_Amqp091Queue() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_Amqp091Queue.prototype = $c_Lamf_client_model_domain_Amqp091Queue.prototype;
$c_Lamf_client_model_domain_Amqp091Queue.prototype.withAutoDelete__Z__Lamf_client_model_domain_Amqp091Queue = (function(autoDelete) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$().AutoDelete$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, autoDelete));
  return this
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.exclusive__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$().Exclusive$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.productPrefix__T = (function() {
  return "Amqp091Queue"
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$js$exported$prop$exclusive__O = (function() {
  return this.exclusive__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_Amqp091Queue.prototype.init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue.call(this, new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$js$exported$meth$withVHost__T__O = (function(vHost) {
  return this.withVHost__T__Lamf_client_model_domain_Amqp091Queue(vHost)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$js$exported$prop$durable__O = (function() {
  return this.durable__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$js$exported$prop$autoDelete__O = (function() {
  return this.autoDelete__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_Amqp091Queue)) {
    var Amqp091Queue$1 = $as_Lamf_client_model_domain_Amqp091Queue(x$1);
    var x = this.$$undinternal$1;
    var x$2 = Amqp091Queue$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.withDurable__Z__Lamf_client_model_domain_Amqp091Queue = (function(durable) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$().Durable$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, durable));
  return this
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$js$exported$meth$withAutoDelete__Z__O = (function(autoDelete) {
  return this.withAutoDelete__Z__Lamf_client_model_domain_Amqp091Queue(autoDelete)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.withExclusive__Z__Lamf_client_model_domain_Amqp091Queue = (function(exclusive) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$().Exclusive$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, exclusive));
  return this
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$js$exported$meth$withExclusive__Z__O = (function(exclusive) {
  return this.withExclusive__Z__Lamf_client_model_domain_Amqp091Queue(exclusive)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$js$exported$prop$vHost__O = (function() {
  return this.vHost__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$js$exported$meth$withDurable__Z__O = (function(durable) {
  return this.withDurable__Z__Lamf_client_model_domain_Amqp091Queue(durable)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.withName__T__Lamf_client_model_domain_Amqp091Queue = (function(name) {
  var this$3 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.vHost__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$().VHost$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.autoDelete__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$().AutoDelete$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.durable__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$().Durable$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_Amqp091Queue(name)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.withVHost__T__Lamf_client_model_domain_Amqp091Queue = (function(vHost) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091QueueModel$().VHost$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, vHost));
  return this
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091Queue.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091Queue.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091Queue.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091Queue.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091Queue.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091Queue.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.withVHost = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withVHost__T__O(prep)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.withAutoDelete = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withAutoDelete__Z__O(prep)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.withExclusive = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withExclusive__Z__O(prep)
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.withDurable = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withDurable__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091Queue.prototype, "vHost", {
  "get": (function() {
    return this.$$js$exported$prop$vHost__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091Queue.prototype, "autoDelete", {
  "get": (function() {
    return this.$$js$exported$prop$autoDelete__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091Queue.prototype, "exclusive", {
  "get": (function() {
    return this.$$js$exported$prop$exclusive__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091Queue.prototype, "durable", {
  "get": (function() {
    return this.$$js$exported$prop$durable__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_Amqp091Queue(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_Amqp091Queue) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Amqp091Queue"))
}
function $isArrayOf_Lamf_client_model_domain_Amqp091Queue(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Amqp091Queue)))
}
function $asArrayOf_Lamf_client_model_domain_Amqp091Queue(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Amqp091Queue(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Amqp091Queue;", depth))
}
var $d_Lamf_client_model_domain_Amqp091Queue = new $TypeData().initClass({
  Lamf_client_model_domain_Amqp091Queue: 0
}, false, "amf.client.model.domain.Amqp091Queue", {
  Lamf_client_model_domain_Amqp091Queue: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_Amqp091Queue.prototype.$classData = $d_Lamf_client_model_domain_Amqp091Queue;
/** @constructor */
function $c_Lamf_client_model_domain_ApiKeySettings() {
  $c_Lamf_client_model_domain_Settings.call(this)
}
$c_Lamf_client_model_domain_ApiKeySettings.prototype = new $h_Lamf_client_model_domain_Settings();
$c_Lamf_client_model_domain_ApiKeySettings.prototype.constructor = $c_Lamf_client_model_domain_ApiKeySettings;
/** @constructor */
function $h_Lamf_client_model_domain_ApiKeySettings() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_ApiKeySettings.prototype = $c_Lamf_client_model_domain_ApiKeySettings.prototype;
$c_Lamf_client_model_domain_ApiKeySettings.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_ApiKeySettings.prototype.init___Lamf_plugins_domain_webapi_models_security_ApiKeySettings.call(this, new $c_Lamf_plugins_domain_webapi_models_security_ApiKeySettings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(this.$$undinternal$1);
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.productPrefix__T = (function() {
  return "ApiKeySettings"
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.$in__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(this.$$undinternal$1);
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().In$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_ApiKeySettings)) {
    var ApiKeySettings$1 = $as_Lamf_client_model_domain_ApiKeySettings(x$1);
    var x = $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(ApiKeySettings$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.withName__T__Lamf_client_model_domain_ApiKeySettings = (function(name) {
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().Name$1;
  $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name));
  return this
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.$$js$exported$meth$withIn__T__O = (function($in) {
  return this.withIn__T__Lamf_client_model_domain_ApiKeySettings($in)
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.$$js$exported$prop$in__O = (function() {
  return this.$in__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.withIn__T__Lamf_client_model_domain_ApiKeySettings = (function($in) {
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().In$1;
  $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, $in));
  return this
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_security_Settings = (function() {
  return $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_domain_webapi_models_security_ApiKeySettings(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_ApiKeySettings(name)
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.init___Lamf_plugins_domain_webapi_models_security_ApiKeySettings = (function(_internal) {
  $c_Lamf_client_model_domain_Settings.prototype.init___Lamf_plugins_domain_webapi_models_security_Settings.call(this, _internal);
  return this
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.withIn = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withIn__T__O(prep)
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ApiKeySettings.prototype, "in", {
  "get": (function() {
    return this.$$js$exported$prop$in__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ApiKeySettings.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_ApiKeySettings(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_ApiKeySettings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.ApiKeySettings"))
}
function $isArrayOf_Lamf_client_model_domain_ApiKeySettings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_ApiKeySettings)))
}
function $asArrayOf_Lamf_client_model_domain_ApiKeySettings(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_ApiKeySettings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.ApiKeySettings;", depth))
}
var $d_Lamf_client_model_domain_ApiKeySettings = new $TypeData().initClass({
  Lamf_client_model_domain_ApiKeySettings: 0
}, false, "amf.client.model.domain.ApiKeySettings", {
  Lamf_client_model_domain_ApiKeySettings: 1,
  Lamf_client_model_domain_Settings: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_ApiKeySettings.prototype.$classData = $d_Lamf_client_model_domain_ApiKeySettings;
/** @constructor */
function $c_Lamf_client_model_domain_ArrayNode() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_ArrayNode.prototype = new $h_O();
$c_Lamf_client_model_domain_ArrayNode.prototype.constructor = $c_Lamf_client_model_domain_ArrayNode;
/** @constructor */
function $h_Lamf_client_model_domain_ArrayNode() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_ArrayNode.prototype = $c_Lamf_client_model_domain_ArrayNode.prototype;
$c_Lamf_client_model_domain_ArrayNode.prototype.init___ = (function() {
  $m_Lamf_core_model_domain_ArrayNode$();
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_ArrayNode.prototype.init___Lamf_core_model_domain_ArrayNode.call(this, new $c_Lamf_core_model_domain_ArrayNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_ArrayNode.prototype.productPrefix__T = (function() {
  return "ArrayNode"
});
$c_Lamf_client_model_domain_ArrayNode.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_ArrayNode.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_ArrayNode.prototype.$$js$exported$prop$name__O = (function() {
  return $f_Lamf_client_model_domain_DataNode__name__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_ArrayNode.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_ArrayNode.prototype.$$js$exported$meth$addMember__Lamf_client_model_domain_DataNode__O = (function(member) {
  return this.addMember__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_ArrayNode(member)
});
$c_Lamf_client_model_domain_ArrayNode.prototype.addMember__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_ArrayNode = (function(member) {
  this.$$undinternal$1.addMember__Lamf_core_model_domain_DataNode__sc_Seq(member.$$undinternal__Lamf_core_model_domain_DataNode());
  return this
});
$c_Lamf_client_model_domain_ArrayNode.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_ArrayNode.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ArrayNode.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_ArrayNode)) {
    var ArrayNode$1 = $as_Lamf_client_model_domain_ArrayNode(x$1);
    var x = this.$$undinternal$1;
    var x$2 = ArrayNode$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_ArrayNode.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_ArrayNode.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_ArrayNode.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_ArrayNode.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_ArrayNode.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_ArrayNode.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ArrayNode.prototype.members__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ArrayNodeModel$().Member$1));
  var m = $m_Lamf_client_convert_CoreClientConverters$().DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_ArrayNode.prototype.$$undinternal__Lamf_core_model_domain_DataNode = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ArrayNode.prototype.$$js$exported$prop$members__O = (function() {
  return this.members__sjs_js_Array()
});
$c_Lamf_client_model_domain_ArrayNode.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ArrayNode.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_ArrayNode.prototype.init___Lamf_core_model_domain_ArrayNode = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_ArrayNode.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_ArrayNode.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_ArrayNode.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ArrayNode.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_ArrayNode.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_ArrayNode.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return $f_Lamf_client_model_domain_DataNode__withName__T__Lamf_client_model_domain_DataNode(this, name)
});
$c_Lamf_client_model_domain_ArrayNode.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_ArrayNode.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_ArrayNode.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ArrayNode.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ArrayNode.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_ArrayNode.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_ArrayNode.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ArrayNode.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ArrayNode.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ArrayNode.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ArrayNode.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ArrayNode.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ArrayNode.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ArrayNode.prototype.addMember = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DataNode(arg);
  return this.$$js$exported$meth$addMember__Lamf_client_model_domain_DataNode__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ArrayNode.prototype, "members", {
  "get": (function() {
    return this.$$js$exported$prop$members__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_ArrayNode(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_ArrayNode) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.ArrayNode"))
}
function $isArrayOf_Lamf_client_model_domain_ArrayNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_ArrayNode)))
}
function $asArrayOf_Lamf_client_model_domain_ArrayNode(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_ArrayNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.ArrayNode;", depth))
}
var $d_Lamf_client_model_domain_ArrayNode = new $TypeData().initClass({
  Lamf_client_model_domain_ArrayNode: 0
}, false, "amf.client.model.domain.ArrayNode", {
  Lamf_client_model_domain_ArrayNode: 1,
  O: 1,
  Lamf_client_model_domain_DataNode: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_ArrayNode.prototype.$classData = $d_Lamf_client_model_domain_ArrayNode;
/** @constructor */
function $c_Lamf_client_model_domain_Callback() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_Callback.prototype = new $h_O();
$c_Lamf_client_model_domain_Callback.prototype.constructor = $c_Lamf_client_model_domain_Callback;
/** @constructor */
function $h_Lamf_client_model_domain_Callback() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_Callback.prototype = $c_Lamf_client_model_domain_Callback.prototype;
$c_Lamf_client_model_domain_Callback.prototype.productPrefix__T = (function() {
  return "Callback"
});
$c_Lamf_client_model_domain_Callback.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_Callback.prototype.init___Lamf_plugins_domain_webapi_models_Callback.call(this, new $c_Lamf_plugins_domain_webapi_models_Callback().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_Callback.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Callback.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_Callback.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_Callback.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_Callback.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Callback.prototype.$$js$exported$meth$withExpression__T__O = (function(expression) {
  return this.withExpression__T__Lamf_client_model_domain_Callback(expression)
});
$c_Lamf_client_model_domain_Callback.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_Callback.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_Callback)) {
    var Callback$1 = $as_Lamf_client_model_domain_Callback(x$1);
    var x = this.$$undinternal$1;
    var x$2 = Callback$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_Callback.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Callback.prototype.withName__T__Lamf_client_model_domain_Callback = (function(name) {
  var this$3 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_Callback.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_Callback.prototype.withEndpoint__T__Lamf_client_model_domain_EndPoint = (function(path) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withEndpoint__T__Lamf_plugins_domain_webapi_models_EndPoint(path);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().EndPointMatcher__Lamf_client_convert_EndPointConverter$EndPointMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_client_model_domain_EndPoint(from)
});
$c_Lamf_client_model_domain_Callback.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_Callback.prototype.endpoint__Lamf_client_model_domain_EndPoint = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_plugins_domain_webapi_models_EndPoint(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$().Endpoint$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().EndPointMatcher__Lamf_client_convert_EndPointConverter$EndPointMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_client_model_domain_EndPoint(from)
});
$c_Lamf_client_model_domain_Callback.prototype.expression__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$().Expression$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Callback.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_Callback.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_Callback.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_Callback.prototype.withEndpoint__Lamf_client_model_domain_EndPoint__Lamf_client_model_domain_Callback = (function(endpoint) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().EndPointMatcher__Lamf_client_convert_EndPointConverter$EndPointMatcher$();
  var endpoint$1 = endpoint.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$().Endpoint$1;
  $as_Lamf_plugins_domain_webapi_models_Callback($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, endpoint$1));
  return this
});
$c_Lamf_client_model_domain_Callback.prototype.init___Lamf_plugins_domain_webapi_models_Callback = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_Callback.prototype.$$js$exported$prop$endpoint__O = (function() {
  return this.endpoint__Lamf_client_model_domain_EndPoint()
});
$c_Lamf_client_model_domain_Callback.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Callback.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Callback.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_Callback.prototype.$$js$exported$meth$withEndpoint__Lamf_client_model_domain_EndPoint__O = (function(endpoint) {
  return this.withEndpoint__Lamf_client_model_domain_EndPoint__Lamf_client_model_domain_Callback(endpoint)
});
$c_Lamf_client_model_domain_Callback.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_Callback.prototype.$$js$exported$meth$withEndpoint__T__O = (function(path) {
  return this.withEndpoint__T__Lamf_client_model_domain_EndPoint(path)
});
$c_Lamf_client_model_domain_Callback.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_Callback.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Callback.prototype.withExpression__T__Lamf_client_model_domain_Callback = (function(expression) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$().Expression$1;
  $as_Lamf_plugins_domain_webapi_models_Callback($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, expression));
  return this
});
$c_Lamf_client_model_domain_Callback.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_Callback.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_Callback.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_Callback(name)
});
$c_Lamf_client_model_domain_Callback.prototype.$$js$exported$prop$expression__O = (function() {
  return this.expression__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Callback.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_Callback.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_Callback.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Callback.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Callback.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_Callback.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Callback.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Callback.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Callback.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Callback.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Callback.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Callback.prototype.withEndpoint = (function(arg) {
  if ($is_T(arg)) {
    var prep$2 = $as_T(arg);
    return this.$$js$exported$meth$withEndpoint__T__O(prep$2)
  } else if ((arg instanceof $c_Lamf_client_model_domain_EndPoint)) {
    var prep = $as_Lamf_client_model_domain_EndPoint(arg);
    return this.$$js$exported$meth$withEndpoint__Lamf_client_model_domain_EndPoint__O(prep)
  } else {
    throw "No matching overload"
  }
});
$c_Lamf_client_model_domain_Callback.prototype.withExpression = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withExpression__T__O(prep)
});
$c_Lamf_client_model_domain_Callback.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Callback.prototype, "endpoint", {
  "get": (function() {
    return this.$$js$exported$prop$endpoint__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Callback.prototype, "expression", {
  "get": (function() {
    return this.$$js$exported$prop$expression__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Callback.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_Callback(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_Callback) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Callback"))
}
function $isArrayOf_Lamf_client_model_domain_Callback(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Callback)))
}
function $asArrayOf_Lamf_client_model_domain_Callback(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Callback(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Callback;", depth))
}
var $d_Lamf_client_model_domain_Callback = new $TypeData().initClass({
  Lamf_client_model_domain_Callback: 0
}, false, "amf.client.model.domain.Callback", {
  Lamf_client_model_domain_Callback: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_Callback.prototype.$classData = $d_Lamf_client_model_domain_Callback;
/** @constructor */
function $c_Lamf_client_model_domain_CustomDomainProperty() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_CustomDomainProperty.prototype = new $h_O();
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.constructor = $c_Lamf_client_model_domain_CustomDomainProperty;
/** @constructor */
function $h_Lamf_client_model_domain_CustomDomainProperty() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_CustomDomainProperty.prototype = $c_Lamf_client_model_domain_CustomDomainProperty.prototype;
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.productPrefix__T = (function() {
  return "CustomDomainProperty"
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_CustomDomainProperty.prototype.init___Lamf_core_model_domain_extensions_CustomDomainProperty.call(this, new $c_Lamf_core_model_domain_extensions_CustomDomainProperty().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$meth$withSchema__Lamf_client_model_domain_Shape__O = (function(schema) {
  return this.withSchema__Lamf_client_model_domain_Shape__Lamf_client_model_domain_CustomDomainProperty(schema)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Name$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$prop$displayName__O = (function() {
  return this.displayName__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_CustomDomainProperty)) {
    var CustomDomainProperty$1 = $as_Lamf_client_model_domain_CustomDomainProperty(x$1);
    var x = this.$$undinternal$1;
    var x$2 = CustomDomainProperty$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$prop$schema__O = (function() {
  return this.schema__Lamf_client_model_domain_Shape()
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.withDescription__T__Lamf_client_model_domain_CustomDomainProperty = (function(description) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Description$1;
  $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, description));
  return this
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.description__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Description$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$meth$withDisplayName__T__O = (function(displayName) {
  return this.withDisplayName__T__Lamf_client_model_domain_CustomDomainProperty(displayName)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.withDisplayName__T__Lamf_client_model_domain_CustomDomainProperty = (function(displayName) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().DisplayName$1;
  $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, displayName));
  return this
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_CustomDomainProperty()
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.linkCopy__Lamf_client_model_domain_CustomDomainProperty = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$5 = new $c_Lamf_core_model_domain_extensions_CustomDomainProperty().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  $m_Lamf_client_convert_CoreClientConverters$().CustomDomainPropertyMatcher__Lamf_client_convert_CustomDomainPropertyConverter$CustomDomainPropertyMatcher$();
  return new $c_Lamf_client_model_domain_CustomDomainProperty().init___Lamf_core_model_domain_extensions_CustomDomainProperty(from)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.schema__Lamf_client_model_domain_Shape = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_domain_Shape(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Schema$1));
  var m = $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(from)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.withName__T__Lamf_client_model_domain_CustomDomainProperty = (function(name) {
  var this$3 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_CustomDomainProperty()
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.withDomain__sjs_js_Array__Lamf_client_model_domain_CustomDomainProperty = (function(domain) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var m = $m_Lamf_client_convert_CoreClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  var domain$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, domain, m).asInternal__sc_Seq();
  var field = $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Domain$1;
  $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, domain$1));
  return this
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.withSchema__Lamf_client_model_domain_Shape__Lamf_client_model_domain_CustomDomainProperty = (function(schema) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_CoreClientConverters$();
  $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var schema$1 = schema.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Schema$1;
  $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, schema$1));
  return this
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$meth$withDescription__T__O = (function(description) {
  return this.withDescription__T__Lamf_client_model_domain_CustomDomainProperty(description)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.init___Lamf_core_model_domain_extensions_CustomDomainProperty = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$prop$description__O = (function() {
  return this.description__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.displayName__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().DisplayName$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.domain__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Domain$1));
  var m = $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_CustomDomainProperty(name)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$meth$withDomain__sjs_js_Array__O = (function(domain) {
  return this.withDomain__sjs_js_Array__Lamf_client_model_domain_CustomDomainProperty(domain)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$prop$domain__O = (function() {
  return this.domain__sjs_js_Array()
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_CustomDomainProperty.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_CustomDomainProperty.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_CustomDomainProperty.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_CustomDomainProperty.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_CustomDomainProperty.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_CustomDomainProperty.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_CustomDomainProperty.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_CustomDomainProperty.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.withSchema = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withSchema__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.withDomain = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withDomain__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.withDescription = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDescription__T__O(prep)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.withDisplayName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDisplayName__T__O(prep)
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_CustomDomainProperty.prototype, "schema", {
  "get": (function() {
    return this.$$js$exported$prop$schema__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_CustomDomainProperty.prototype, "domain", {
  "get": (function() {
    return this.$$js$exported$prop$domain__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_CustomDomainProperty.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_CustomDomainProperty.prototype, "displayName", {
  "get": (function() {
    return this.$$js$exported$prop$displayName__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_CustomDomainProperty.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_CustomDomainProperty(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_CustomDomainProperty) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.CustomDomainProperty"))
}
function $isArrayOf_Lamf_client_model_domain_CustomDomainProperty(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_CustomDomainProperty)))
}
function $asArrayOf_Lamf_client_model_domain_CustomDomainProperty(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_CustomDomainProperty(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.CustomDomainProperty;", depth))
}
var $d_Lamf_client_model_domain_CustomDomainProperty = new $TypeData().initClass({
  Lamf_client_model_domain_CustomDomainProperty: 0
}, false, "amf.client.model.domain.CustomDomainProperty", {
  Lamf_client_model_domain_CustomDomainProperty: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_CustomDomainProperty.prototype.$classData = $d_Lamf_client_model_domain_CustomDomainProperty;
/** @constructor */
function $c_Lamf_client_model_domain_DatatypePropertyTerm() {
  $c_Lamf_client_model_domain_PropertyTerm.call(this)
}
$c_Lamf_client_model_domain_DatatypePropertyTerm.prototype = new $h_Lamf_client_model_domain_PropertyTerm();
$c_Lamf_client_model_domain_DatatypePropertyTerm.prototype.constructor = $c_Lamf_client_model_domain_DatatypePropertyTerm;
/** @constructor */
function $h_Lamf_client_model_domain_DatatypePropertyTerm() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_DatatypePropertyTerm.prototype = $c_Lamf_client_model_domain_DatatypePropertyTerm.prototype;
$c_Lamf_client_model_domain_DatatypePropertyTerm.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_DatatypePropertyTerm.prototype.init___Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm.call(this, new $c_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_DatatypePropertyTerm.prototype.productPrefix__T = (function() {
  return "DatatypePropertyTerm"
});
$c_Lamf_client_model_domain_DatatypePropertyTerm.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_DatatypePropertyTerm.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_DatatypePropertyTerm)) {
    var DatatypePropertyTerm$1 = $as_Lamf_client_model_domain_DatatypePropertyTerm(x$1);
    var x = $as_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm(DatatypePropertyTerm$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_DatatypePropertyTerm.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_DatatypePropertyTerm.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_DatatypePropertyTerm.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_DatatypePropertyTerm.prototype.$$undinternal__Lamf_plugins_document_vocabularies_model_domain_PropertyTerm = (function() {
  return $as_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_DatatypePropertyTerm.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_DatatypePropertyTerm.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_DatatypePropertyTerm.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_DatatypePropertyTerm.prototype.init___Lamf_plugins_document_vocabularies_model_domain_DatatypePropertyTerm = (function(_internal) {
  $c_Lamf_client_model_domain_PropertyTerm.prototype.init___Lamf_plugins_document_vocabularies_model_domain_PropertyTerm.call(this, _internal);
  return this
});
function $as_Lamf_client_model_domain_DatatypePropertyTerm(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_DatatypePropertyTerm) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.DatatypePropertyTerm"))
}
function $isArrayOf_Lamf_client_model_domain_DatatypePropertyTerm(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_DatatypePropertyTerm)))
}
function $asArrayOf_Lamf_client_model_domain_DatatypePropertyTerm(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_DatatypePropertyTerm(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.DatatypePropertyTerm;", depth))
}
var $d_Lamf_client_model_domain_DatatypePropertyTerm = new $TypeData().initClass({
  Lamf_client_model_domain_DatatypePropertyTerm: 0
}, false, "amf.client.model.domain.DatatypePropertyTerm", {
  Lamf_client_model_domain_DatatypePropertyTerm: 1,
  Lamf_client_model_domain_PropertyTerm: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_DatatypePropertyTerm.prototype.$classData = $d_Lamf_client_model_domain_DatatypePropertyTerm;
/** @constructor */
function $c_Lamf_client_model_domain_EndPoint() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_EndPoint.prototype = new $h_O();
$c_Lamf_client_model_domain_EndPoint.prototype.constructor = $c_Lamf_client_model_domain_EndPoint;
/** @constructor */
function $h_Lamf_client_model_domain_EndPoint() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_EndPoint.prototype = $c_Lamf_client_model_domain_EndPoint.prototype;
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$meth$withBindings__Lamf_client_model_domain_ChannelBindings__O = (function(bindings) {
  return this.withBindings__Lamf_client_model_domain_ChannelBindings__Lamf_client_model_domain_EndPoint(bindings)
});
$c_Lamf_client_model_domain_EndPoint.prototype.productPrefix__T = (function() {
  return "EndPoint"
});
$c_Lamf_client_model_domain_EndPoint.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_EndPoint.prototype.init___Lamf_plugins_domain_webapi_models_EndPoint.call(this, new $c_Lamf_plugins_domain_webapi_models_EndPoint().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_EndPoint.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_EndPoint.prototype.withServers__sjs_js_Array__Lamf_client_model_domain_EndPoint = (function(servers) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ServerMatcher__Lamf_client_convert_ServerConverter$ServerMatcher$();
  var servers$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, servers, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Servers$1;
  $as_Lamf_plugins_domain_webapi_models_EndPoint($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, servers$1));
  return this
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$meth$withParameters__sjs_js_Array__O = (function(parameters) {
  return this.withParameters__sjs_js_Array__Lamf_client_model_domain_EndPoint(parameters)
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$meth$withPath__T__O = (function(path) {
  return this.withPath__T__Lamf_client_model_domain_EndPoint(path)
});
$c_Lamf_client_model_domain_EndPoint.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$prop$operations__O = (function() {
  return this.operations__sjs_js_Array()
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$prop$parameters__O = (function() {
  return this.parameters__sjs_js_Array()
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_EndPoint.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_EndPoint)) {
    var EndPoint$1 = $as_Lamf_client_model_domain_EndPoint(x$1);
    var x = this.$$undinternal$1;
    var x$2 = EndPoint$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_EndPoint.prototype.path__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_EndPoint.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$prop$payloads__O = (function() {
  return this.payloads__sjs_js_Array()
});
$c_Lamf_client_model_domain_EndPoint.prototype.withSummary__T__Lamf_client_model_domain_EndPoint = (function(summary) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Summary$1;
  $as_Lamf_plugins_domain_webapi_models_EndPoint($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, summary));
  return this
});
$c_Lamf_client_model_domain_EndPoint.prototype.withOperation__T__Lamf_client_model_domain_Operation = (function(method) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withOperation__T__Lamf_plugins_domain_webapi_models_Operation(method);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().OperationMatcher__Lamf_client_convert_OperationConverter$OperationMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Operation__Lamf_client_model_domain_Operation(from)
});
$c_Lamf_client_model_domain_EndPoint.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_EndPoint.prototype.withSecurity__sjs_js_Array__Lamf_client_model_domain_EndPoint = (function(security) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().SecurityRequirementMatcher__Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$();
  var security$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, security, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Security$1;
  $as_Lamf_plugins_domain_webapi_models_EndPoint($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, security$1));
  return this
});
$c_Lamf_client_model_domain_EndPoint.prototype.withOperations__sjs_js_Array__Lamf_client_model_domain_EndPoint = (function(operations) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().OperationMatcher__Lamf_client_convert_OperationConverter$OperationMatcher$();
  var operations$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, operations, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1;
  $as_Lamf_plugins_domain_webapi_models_EndPoint($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, operations$1));
  return this
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_EndPoint.prototype.payloads__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Payloads$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PayloadMatcher__Lamf_client_convert_PayloadConverter$PayloadMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_EndPoint.prototype.withPath__T__Lamf_client_model_domain_EndPoint = (function(path) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1;
  $as_Lamf_plugins_domain_webapi_models_EndPoint($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, path));
  return this
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$prop$bindings__O = (function() {
  return this.bindings__Lamf_client_model_domain_ChannelBindings()
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$prop$servers__O = (function() {
  return this.servers__sjs_js_Array()
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_EndPoint.prototype.description__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Description$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_EndPoint.prototype.parameters__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$meth$withOperations__sjs_js_Array__O = (function(operations) {
  return this.withOperations__sjs_js_Array__Lamf_client_model_domain_EndPoint(operations)
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$meth$withOperation__T__O = (function(method) {
  return this.withOperation__T__Lamf_client_model_domain_Operation(method)
});
$c_Lamf_client_model_domain_EndPoint.prototype.servers__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Servers$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ServerMatcher__Lamf_client_convert_ServerConverter$ServerMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_EndPoint.prototype.withServer__T__Lamf_client_model_domain_Server = (function(url) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withServer__T__Lamf_plugins_domain_webapi_models_Server(url);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ServerMatcher__Lamf_client_convert_ServerConverter$ServerMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Server__Lamf_client_model_domain_Server(from)
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$prop$parent__O = (function() {
  return this.parent__sjs_js_UndefOr()
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$meth$withServer__T__O = (function(url) {
  return this.withServer__T__Lamf_client_model_domain_Server(url)
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$meth$withSecurity__sjs_js_Array__O = (function(security) {
  return this.withSecurity__sjs_js_Array__Lamf_client_model_domain_EndPoint(security)
});
$c_Lamf_client_model_domain_EndPoint.prototype.withName__T__Lamf_client_model_domain_EndPoint = (function(name) {
  var this$3 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_EndPoint.prototype.withDescription__T__Lamf_client_model_domain_EndPoint = (function(description) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Description$1;
  $as_Lamf_plugins_domain_webapi_models_EndPoint($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, description));
  return this
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_EndPoint.prototype.summary__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Summary$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_EndPoint.prototype.withPayload__T__Lamf_client_model_domain_Payload = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withPayload__s_Option__Lamf_plugins_domain_webapi_models_Payload(new $c_s_Some().init___O(name));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PayloadMatcher__Lamf_client_convert_PayloadConverter$PayloadMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Payload__Lamf_client_model_domain_Payload(from)
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$meth$withDescription__T__O = (function(description) {
  return this.withDescription__T__Lamf_client_model_domain_EndPoint(description)
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$meth$withPayload__T__O = (function(name) {
  return this.withPayload__T__Lamf_client_model_domain_Payload(name)
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_EndPoint.prototype.operations__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Operations$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().OperationMatcher__Lamf_client_convert_OperationConverter$OperationMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$prop$relativePath__O = (function() {
  return this.$$undinternal$1.relativePath__T()
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$prop$security__O = (function() {
  return this.security__sjs_js_Array()
});
$c_Lamf_client_model_domain_EndPoint.prototype.bindings__Lamf_client_model_domain_ChannelBindings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Bindings$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ChannelBindingsMatcher__Lamf_client_convert_ChannelBindingsConverter$ChannelBindingsMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_ChannelBindings__Lamf_client_model_domain_ChannelBindings(from)
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$prop$description__O = (function() {
  return this.description__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_EndPoint.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_EndPoint.prototype.withParameters__sjs_js_Array__Lamf_client_model_domain_EndPoint = (function(parameters) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  var parameters$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, parameters, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Parameters$1;
  $as_Lamf_plugins_domain_webapi_models_EndPoint($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, parameters$1));
  return this
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$prop$summary__O = (function() {
  return this.summary__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$prop$path__O = (function() {
  return this.path__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$meth$withParameter__T__O = (function(name) {
  return this.withParameter__T__Lamf_client_model_domain_Parameter(name)
});
$c_Lamf_client_model_domain_EndPoint.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_EndPoint.prototype.parent__sjs_js_UndefOr = (function() {
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.parent__s_Option();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().EndPointMatcher__Lamf_client_convert_EndPointConverter$EndPointMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$meth$withSummary__T__O = (function(summary) {
  return this.withSummary__T__Lamf_client_model_domain_EndPoint(summary)
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_EndPoint(name)
});
$c_Lamf_client_model_domain_EndPoint.prototype.init___Lamf_plugins_domain_webapi_models_EndPoint = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$meth$withServers__sjs_js_Array__O = (function(servers) {
  return this.withServers__sjs_js_Array__Lamf_client_model_domain_EndPoint(servers)
});
$c_Lamf_client_model_domain_EndPoint.prototype.withParameter__T__Lamf_client_model_domain_Parameter = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withParameter__T__Lamf_plugins_domain_webapi_models_Parameter(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Parameter__Lamf_client_model_domain_Parameter(from)
});
$c_Lamf_client_model_domain_EndPoint.prototype.$$js$exported$meth$withPayloads__sjs_js_Array__O = (function(payloads) {
  return this.withPayloads__sjs_js_Array__Lamf_client_model_domain_EndPoint(payloads)
});
$c_Lamf_client_model_domain_EndPoint.prototype.security__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Security$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().SecurityRequirementMatcher__Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_EndPoint.prototype.withPayloads__sjs_js_Array__Lamf_client_model_domain_EndPoint = (function(payloads) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PayloadMatcher__Lamf_client_convert_PayloadConverter$PayloadMatcher$();
  var payloads$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, payloads, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Payloads$1;
  $as_Lamf_plugins_domain_webapi_models_EndPoint($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, payloads$1));
  return this
});
$c_Lamf_client_model_domain_EndPoint.prototype.withBindings__Lamf_client_model_domain_ChannelBindings__Lamf_client_model_domain_EndPoint = (function(bindings) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().ChannelBindingsMatcher__Lamf_client_convert_ChannelBindingsConverter$ChannelBindingsMatcher$();
  var bindings$1 = bindings.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Bindings$1;
  $as_Lamf_plugins_domain_webapi_models_EndPoint($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, bindings$1));
  return this
});
$c_Lamf_client_model_domain_EndPoint.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_EndPoint.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_EndPoint.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_EndPoint.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_EndPoint.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_EndPoint.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_EndPoint.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_EndPoint.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_EndPoint.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_EndPoint.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_EndPoint.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_EndPoint.prototype.withBindings = (function(arg) {
  var prep = $as_Lamf_client_model_domain_ChannelBindings(arg);
  return this.$$js$exported$meth$withBindings__Lamf_client_model_domain_ChannelBindings__O(prep)
});
$c_Lamf_client_model_domain_EndPoint.prototype.withServer = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withServer__T__O(prep)
});
$c_Lamf_client_model_domain_EndPoint.prototype.withPayload = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withPayload__T__O(prep)
});
$c_Lamf_client_model_domain_EndPoint.prototype.withParameter = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withParameter__T__O(prep)
});
$c_Lamf_client_model_domain_EndPoint.prototype.withOperation = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withOperation__T__O(prep)
});
$c_Lamf_client_model_domain_EndPoint.prototype.withSecurity = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withSecurity__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_EndPoint.prototype.withServers = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withServers__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_EndPoint.prototype.withPayloads = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withPayloads__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_EndPoint.prototype.withParameters = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withParameters__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_EndPoint.prototype.withOperations = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withOperations__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_EndPoint.prototype.withPath = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withPath__T__O(prep)
});
$c_Lamf_client_model_domain_EndPoint.prototype.withSummary = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withSummary__T__O(prep)
});
$c_Lamf_client_model_domain_EndPoint.prototype.withDescription = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDescription__T__O(prep)
});
$c_Lamf_client_model_domain_EndPoint.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_EndPoint.prototype, "relativePath", {
  "get": (function() {
    return this.$$js$exported$prop$relativePath__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_EndPoint.prototype, "parent", {
  "get": (function() {
    return this.$$js$exported$prop$parent__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_EndPoint.prototype, "bindings", {
  "get": (function() {
    return this.$$js$exported$prop$bindings__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_EndPoint.prototype, "security", {
  "get": (function() {
    return this.$$js$exported$prop$security__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_EndPoint.prototype, "servers", {
  "get": (function() {
    return this.$$js$exported$prop$servers__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_EndPoint.prototype, "payloads", {
  "get": (function() {
    return this.$$js$exported$prop$payloads__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_EndPoint.prototype, "parameters", {
  "get": (function() {
    return this.$$js$exported$prop$parameters__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_EndPoint.prototype, "operations", {
  "get": (function() {
    return this.$$js$exported$prop$operations__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_EndPoint.prototype, "path", {
  "get": (function() {
    return this.$$js$exported$prop$path__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_EndPoint.prototype, "summary", {
  "get": (function() {
    return this.$$js$exported$prop$summary__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_EndPoint.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_EndPoint.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_EndPoint(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_EndPoint) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.EndPoint"))
}
function $isArrayOf_Lamf_client_model_domain_EndPoint(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_EndPoint)))
}
function $asArrayOf_Lamf_client_model_domain_EndPoint(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_EndPoint(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.EndPoint;", depth))
}
var $d_Lamf_client_model_domain_EndPoint = new $TypeData().initClass({
  Lamf_client_model_domain_EndPoint: 0
}, false, "amf.client.model.domain.EndPoint", {
  Lamf_client_model_domain_EndPoint: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_EndPoint.prototype.$classData = $d_Lamf_client_model_domain_EndPoint;
/** @constructor */
function $c_Lamf_client_model_domain_HttpApiKeySettings() {
  $c_Lamf_client_model_domain_Settings.call(this)
}
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype = new $h_Lamf_client_model_domain_Settings();
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.constructor = $c_Lamf_client_model_domain_HttpApiKeySettings;
/** @constructor */
function $h_Lamf_client_model_domain_HttpApiKeySettings() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_HttpApiKeySettings.prototype = $c_Lamf_client_model_domain_HttpApiKeySettings.prototype;
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_HttpApiKeySettings.prototype.init___Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings.call(this, new $c_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(this.$$undinternal$1);
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.productPrefix__T = (function() {
  return "HttpApiKeySettings"
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.$in__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(this.$$undinternal$1);
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().In$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.init___Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings = (function(_internal) {
  $c_Lamf_client_model_domain_Settings.prototype.init___Lamf_plugins_domain_webapi_models_security_Settings.call(this, _internal);
  return this
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_HttpApiKeySettings)) {
    var HttpApiKeySettings$1 = $as_Lamf_client_model_domain_HttpApiKeySettings(x$1);
    var x = $as_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(HttpApiKeySettings$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.$$js$exported$meth$withIn__T__O = (function($in) {
  return this.withIn__T__Lamf_client_model_domain_HttpApiKeySettings($in)
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.$$js$exported$prop$in__O = (function() {
  return this.$in__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.withIn__T__Lamf_client_model_domain_HttpApiKeySettings = (function($in) {
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().In$1;
  $as_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, $in));
  return this
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_security_Settings = (function() {
  return $as_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.withName__T__Lamf_client_model_domain_HttpApiKeySettings = (function(name) {
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_ApiKeySettingsModel$().Name$1;
  $as_Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name));
  return this
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_HttpApiKeySettings(name)
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.withIn = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withIn__T__O(prep)
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_HttpApiKeySettings.prototype, "in", {
  "get": (function() {
    return this.$$js$exported$prop$in__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_HttpApiKeySettings.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_HttpApiKeySettings(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_HttpApiKeySettings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.HttpApiKeySettings"))
}
function $isArrayOf_Lamf_client_model_domain_HttpApiKeySettings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_HttpApiKeySettings)))
}
function $asArrayOf_Lamf_client_model_domain_HttpApiKeySettings(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_HttpApiKeySettings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.HttpApiKeySettings;", depth))
}
var $d_Lamf_client_model_domain_HttpApiKeySettings = new $TypeData().initClass({
  Lamf_client_model_domain_HttpApiKeySettings: 0
}, false, "amf.client.model.domain.HttpApiKeySettings", {
  Lamf_client_model_domain_HttpApiKeySettings: 1,
  Lamf_client_model_domain_Settings: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_HttpApiKeySettings.prototype.$classData = $d_Lamf_client_model_domain_HttpApiKeySettings;
/** @constructor */
function $c_Lamf_client_model_domain_HttpSettings() {
  $c_Lamf_client_model_domain_Settings.call(this)
}
$c_Lamf_client_model_domain_HttpSettings.prototype = new $h_Lamf_client_model_domain_Settings();
$c_Lamf_client_model_domain_HttpSettings.prototype.constructor = $c_Lamf_client_model_domain_HttpSettings;
/** @constructor */
function $h_Lamf_client_model_domain_HttpSettings() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_HttpSettings.prototype = $c_Lamf_client_model_domain_HttpSettings.prototype;
$c_Lamf_client_model_domain_HttpSettings.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_HttpSettings.prototype.init___Lamf_plugins_domain_webapi_models_security_HttpSettings.call(this, new $c_Lamf_plugins_domain_webapi_models_security_HttpSettings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_HttpSettings.prototype.productPrefix__T = (function() {
  return "HttpSettings"
});
$c_Lamf_client_model_domain_HttpSettings.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_HttpSettings.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_domain_webapi_models_security_HttpSettings(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_HttpSettings.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_HttpSettings)) {
    var HttpSettings$1 = $as_Lamf_client_model_domain_HttpSettings(x$1);
    var x = $as_Lamf_plugins_domain_webapi_models_security_HttpSettings(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_domain_webapi_models_security_HttpSettings(HttpSettings$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_HttpSettings.prototype.withScheme__T__Lamf_client_model_domain_HttpSettings = (function(scheme) {
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_HttpSettings(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$().Scheme$1;
  $as_Lamf_plugins_domain_webapi_models_security_HttpSettings($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, scheme));
  return this
});
$c_Lamf_client_model_domain_HttpSettings.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_domain_webapi_models_security_HttpSettings(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_HttpSettings.prototype.init___Lamf_plugins_domain_webapi_models_security_HttpSettings = (function(_internal) {
  $c_Lamf_client_model_domain_Settings.prototype.init___Lamf_plugins_domain_webapi_models_security_Settings.call(this, _internal);
  return this
});
$c_Lamf_client_model_domain_HttpSettings.prototype.bearerFormat__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_HttpSettings(this.$$undinternal$1);
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$().BearerFormat$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_HttpSettings.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_HttpSettings.prototype.$$js$exported$prop$scheme__O = (function() {
  return this.scheme__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_HttpSettings.prototype.$$js$exported$meth$withBearerFormat__T__O = (function(bearerFormat) {
  return this.withBearerFormat__T__Lamf_client_model_domain_HttpSettings(bearerFormat)
});
$c_Lamf_client_model_domain_HttpSettings.prototype.scheme__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_HttpSettings(this.$$undinternal$1);
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$().Scheme$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_HttpSettings.prototype.withBearerFormat__T__Lamf_client_model_domain_HttpSettings = (function(bearerFormat) {
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_HttpSettings(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_HttpSettingsModel$().BearerFormat$1;
  $as_Lamf_plugins_domain_webapi_models_security_HttpSettings($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, bearerFormat));
  return this
});
$c_Lamf_client_model_domain_HttpSettings.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_security_Settings = (function() {
  return $as_Lamf_plugins_domain_webapi_models_security_HttpSettings(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_HttpSettings.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_domain_webapi_models_security_HttpSettings(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_HttpSettings.prototype.$$js$exported$prop$bearerFormat__O = (function() {
  return this.bearerFormat__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_HttpSettings.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_HttpSettings.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_HttpSettings.prototype.$$js$exported$meth$withScheme__T__O = (function(scheme) {
  return this.withScheme__T__Lamf_client_model_domain_HttpSettings(scheme)
});
$c_Lamf_client_model_domain_HttpSettings.prototype.withBearerFormat = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withBearerFormat__T__O(prep)
});
$c_Lamf_client_model_domain_HttpSettings.prototype.withScheme = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withScheme__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_HttpSettings.prototype, "bearerFormat", {
  "get": (function() {
    return this.$$js$exported$prop$bearerFormat__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_HttpSettings.prototype, "scheme", {
  "get": (function() {
    return this.$$js$exported$prop$scheme__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_HttpSettings(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_HttpSettings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.HttpSettings"))
}
function $isArrayOf_Lamf_client_model_domain_HttpSettings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_HttpSettings)))
}
function $asArrayOf_Lamf_client_model_domain_HttpSettings(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_HttpSettings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.HttpSettings;", depth))
}
var $d_Lamf_client_model_domain_HttpSettings = new $TypeData().initClass({
  Lamf_client_model_domain_HttpSettings: 0
}, false, "amf.client.model.domain.HttpSettings", {
  Lamf_client_model_domain_HttpSettings: 1,
  Lamf_client_model_domain_Settings: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_HttpSettings.prototype.$classData = $d_Lamf_client_model_domain_HttpSettings;
/** @constructor */
function $c_Lamf_client_model_domain_License() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_License.prototype = new $h_O();
$c_Lamf_client_model_domain_License.prototype.constructor = $c_Lamf_client_model_domain_License;
/** @constructor */
function $h_Lamf_client_model_domain_License() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_License.prototype = $c_Lamf_client_model_domain_License.prototype;
$c_Lamf_client_model_domain_License.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_License.prototype.init___Lamf_plugins_domain_webapi_models_License.call(this, new $c_Lamf_plugins_domain_webapi_models_License().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_License.prototype.productPrefix__T = (function() {
  return "License"
});
$c_Lamf_client_model_domain_License.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_LicenseModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_License.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_License.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_License.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_License.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_License.prototype.$$js$exported$prop$url__O = (function() {
  return this.url__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_License.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_License.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_License.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_License)) {
    var License$1 = $as_Lamf_client_model_domain_License(x$1);
    var x = this.$$undinternal$1;
    var x$2 = License$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_License.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_License.prototype.url__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_LicenseModel$().Url$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_License.prototype.$$js$exported$meth$withUrl__T__O = (function(url) {
  return this.withUrl__T__Lamf_client_model_domain_License(url)
});
$c_Lamf_client_model_domain_License.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_License.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_License.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_License.prototype.init___Lamf_plugins_domain_webapi_models_License = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_License.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_License.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_License.prototype.withUrl__T__Lamf_client_model_domain_License = (function(url) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_LicenseModel$().Url$1;
  $as_Lamf_plugins_domain_webapi_models_License($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, url));
  return this
});
$c_Lamf_client_model_domain_License.prototype.withName__T__Lamf_client_model_domain_License = (function(name) {
  var this$3 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_License.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_License.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_License.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_License.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_License.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_License.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_License.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_License.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_License(name)
});
$c_Lamf_client_model_domain_License.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_License.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_License.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_License.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_License.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_License.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_License.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_License.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_License.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_License.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_License.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_License.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
$c_Lamf_client_model_domain_License.prototype.withUrl = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withUrl__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_License.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_License.prototype, "url", {
  "get": (function() {
    return this.$$js$exported$prop$url__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_License(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_License) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.License"))
}
function $isArrayOf_Lamf_client_model_domain_License(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_License)))
}
function $asArrayOf_Lamf_client_model_domain_License(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_License(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.License;", depth))
}
var $d_Lamf_client_model_domain_License = new $TypeData().initClass({
  Lamf_client_model_domain_License: 0
}, false, "amf.client.model.domain.License", {
  Lamf_client_model_domain_License: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_License.prototype.$classData = $d_Lamf_client_model_domain_License;
/** @constructor */
function $c_Lamf_client_model_domain_NodeMapping() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_NodeMapping.prototype = new $h_O();
$c_Lamf_client_model_domain_NodeMapping.prototype.constructor = $c_Lamf_client_model_domain_NodeMapping;
/** @constructor */
function $h_Lamf_client_model_domain_NodeMapping() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_NodeMapping.prototype = $c_Lamf_client_model_domain_NodeMapping.prototype;
$c_Lamf_client_model_domain_NodeMapping.prototype.idTemplate__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().IdTemplate$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.withNodeTypeMapping__T__Lamf_client_model_domain_NodeMapping = (function(nodeType) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().NodeTypeMapping$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, nodeType));
  return this
});
$c_Lamf_client_model_domain_NodeMapping.prototype.withName__T__Lamf_client_model_domain_NodeMapping = (function(name) {
  var this$1 = this.$$undinternal$1;
  var field = this$1.Name$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name)));
  return this
});
$c_Lamf_client_model_domain_NodeMapping.prototype.productPrefix__T = (function() {
  return "NodeMapping"
});
$c_Lamf_client_model_domain_NodeMapping.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_NodeMapping.prototype.init___Lamf_plugins_document_vocabularies_model_domain_NodeMapping.call(this, new $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_NodeMapping.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O(this$1.Name$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_NodeMapping.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_NodeMapping)) {
    var NodeMapping$1 = $as_Lamf_client_model_domain_NodeMapping(x$1);
    var x = this.$$undinternal$1;
    var x$2 = NodeMapping$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_NodeMapping.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_NodeMapping.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.mergePolicy__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $f_Lamf_plugins_document_vocabularies_model_domain_MergeableMapping__mergePolicy__Lamf_core_model_StrField(this$1);
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.init___Lamf_plugins_document_vocabularies_model_domain_NodeMapping = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$meth$withNodeTypeMapping__T__O = (function(nodeType) {
  return this.withNodeTypeMapping__T__Lamf_client_model_domain_NodeMapping(nodeType)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.linkCopy__Lamf_client_model_domain_NodeMapping = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$6 = new $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$6, value));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().NodeMappingConverter__Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$();
  return m.asClient__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__Lamf_client_model_domain_NodeMapping(from)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$prop$nodetypeMapping__O = (function() {
  return this.nodetypeMapping__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$meth$withMergePolicy__T__O = (function(mergePolicy) {
  return this.withMergePolicy__T__Lamf_client_model_domain_NodeMapping(mergePolicy)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$prop$idTemplate__O = (function() {
  return this.idTemplate__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_NodeMapping.prototype.withIdTemplate__T__Lamf_client_model_domain_NodeMapping = (function(idTemplate) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().IdTemplate$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, idTemplate));
  return this
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_NodeMapping()
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_NodeMapping()
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$meth$withPropertiesMapping__sjs_js_Array__O = (function(props) {
  return this.withPropertiesMapping__sjs_js_Array__Lamf_client_model_domain_NodeMapping(props)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$meth$propertiesMapping__O = (function() {
  return this.propertiesMapping__sjs_js_Array()
});
$c_Lamf_client_model_domain_NodeMapping.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$prop$mergePolicy__O = (function() {
  return this.mergePolicy__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$meth$withIdTemplate__T__O = (function(idTemplate) {
  return this.withIdTemplate__T__Lamf_client_model_domain_NodeMapping(idTemplate)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_NodeMapping(name)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.nodetypeMapping__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().NodeTypeMapping$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.propertiesMapping__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().PropertyMappingConverter__Lamf_client_convert_PropertyMappingConverter$PropertyMappingConverter$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_NodeMapping.prototype.withPropertiesMapping__sjs_js_Array__Lamf_client_model_domain_NodeMapping = (function(props) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().PropertyMappingConverter__Lamf_client_convert_PropertyMappingConverter$PropertyMappingConverter$();
  var props$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, props, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, props$1));
  return this
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.withMergePolicy__T__Lamf_client_model_domain_NodeMapping = (function(mergePolicy) {
  var this$1 = this.$$undinternal$1;
  $f_Lamf_plugins_document_vocabularies_model_domain_MergeableMapping__withMergePolicy__T__Lamf_plugins_document_vocabularies_model_domain_MergeableMapping(this$1, mergePolicy);
  return this
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_NodeMapping.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_NodeMapping.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_NodeMapping.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_NodeMapping.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_NodeMapping.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_NodeMapping.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_NodeMapping.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_NodeMapping.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_NodeMapping.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_NodeMapping.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_NodeMapping.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_NodeMapping.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_NodeMapping.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_NodeMapping.prototype.withMergePolicy = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withMergePolicy__T__O(prep)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.withIdTemplate = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withIdTemplate__T__O(prep)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.withPropertiesMapping = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withPropertiesMapping__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.withNodeTypeMapping = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withNodeTypeMapping__T__O(prep)
});
$c_Lamf_client_model_domain_NodeMapping.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_NodeMapping.prototype, "mergePolicy", {
  "get": (function() {
    return this.$$js$exported$prop$mergePolicy__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_NodeMapping.prototype, "idTemplate", {
  "get": (function() {
    return this.$$js$exported$prop$idTemplate__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_NodeMapping.prototype.propertiesMapping = (function() {
  return this.$$js$exported$meth$propertiesMapping__O()
});
Object.defineProperty($c_Lamf_client_model_domain_NodeMapping.prototype, "nodetypeMapping", {
  "get": (function() {
    return this.$$js$exported$prop$nodetypeMapping__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_NodeMapping.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_NodeMapping(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_NodeMapping) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.NodeMapping"))
}
function $isArrayOf_Lamf_client_model_domain_NodeMapping(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_NodeMapping)))
}
function $asArrayOf_Lamf_client_model_domain_NodeMapping(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_NodeMapping(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.NodeMapping;", depth))
}
var $d_Lamf_client_model_domain_NodeMapping = new $TypeData().initClass({
  Lamf_client_model_domain_NodeMapping: 0
}, false, "amf.client.model.domain.NodeMapping", {
  Lamf_client_model_domain_NodeMapping: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_NodeMapping.prototype.$classData = $d_Lamf_client_model_domain_NodeMapping;
/** @constructor */
function $c_Lamf_client_model_domain_OAuth1Settings() {
  $c_Lamf_client_model_domain_Settings.call(this)
}
$c_Lamf_client_model_domain_OAuth1Settings.prototype = new $h_Lamf_client_model_domain_Settings();
$c_Lamf_client_model_domain_OAuth1Settings.prototype.constructor = $c_Lamf_client_model_domain_OAuth1Settings;
/** @constructor */
function $h_Lamf_client_model_domain_OAuth1Settings() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_OAuth1Settings.prototype = $c_Lamf_client_model_domain_OAuth1Settings.prototype;
$c_Lamf_client_model_domain_OAuth1Settings.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_OAuth1Settings.prototype.init___Lamf_plugins_domain_webapi_models_security_OAuth1Settings.call(this, new $c_Lamf_plugins_domain_webapi_models_security_OAuth1Settings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.productPrefix__T = (function() {
  return "OAuth1Settings"
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.$$js$exported$prop$tokenCredentialsUri__O = (function() {
  return this.tokenCredentialsUri__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.authorizationUri__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(this.$$undinternal$1);
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$().AuthorizationUri$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.$$js$exported$meth$withAuthorizationUri__T__O = (function(authorizationUri) {
  return this.withAuthorizationUri__T__Lamf_client_model_domain_OAuth1Settings(authorizationUri)
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.$$js$exported$prop$requestTokenUri__O = (function() {
  return this.requestTokenUri__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_OAuth1Settings)) {
    var OAuth1Settings$1 = $as_Lamf_client_model_domain_OAuth1Settings(x$1);
    var x = $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(OAuth1Settings$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.withTokenCredentialsUri__T__Lamf_client_model_domain_OAuth1Settings = (function(tokenCredentialsUri) {
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$().TokenCredentialsUri$1;
  $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, tokenCredentialsUri));
  return this
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.$$js$exported$meth$withTokenCredentialsUri__T__O = (function(tokenCredentialsUri) {
  return this.withTokenCredentialsUri__T__Lamf_client_model_domain_OAuth1Settings(tokenCredentialsUri)
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.withSignatures__sjs_js_Array__Lamf_client_model_domain_OAuth1Settings = (function(signatures) {
  var this$2 = $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(this.$$undinternal$1);
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  var signatures$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, signatures, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$().Signatures$1;
  $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, signatures$1));
  return this
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.init___Lamf_plugins_domain_webapi_models_security_OAuth1Settings = (function(_internal) {
  $c_Lamf_client_model_domain_Settings.prototype.init___Lamf_plugins_domain_webapi_models_security_Settings.call(this, _internal);
  return this
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.withAuthorizationUri__T__Lamf_client_model_domain_OAuth1Settings = (function(authorizationUri) {
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$().AuthorizationUri$1;
  $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, authorizationUri));
  return this
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.requestTokenUri__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(this.$$undinternal$1);
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$().RequestTokenUri$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.tokenCredentialsUri__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(this.$$undinternal$1);
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$().TokenCredentialsUri$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_security_Settings = (function() {
  return $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.$$js$exported$prop$authorizationUri__O = (function() {
  return this.authorizationUri__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.$$js$exported$meth$withRequestTokenUri__T__O = (function(requestTokenUri) {
  return this.withRequestTokenUri__T__Lamf_client_model_domain_OAuth1Settings(requestTokenUri)
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.withRequestTokenUri__T__Lamf_client_model_domain_OAuth1Settings = (function(requestTokenUri) {
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$().RequestTokenUri$1;
  $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, requestTokenUri));
  return this
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.$$js$exported$prop$signatures__O = (function() {
  return this.signatures__sjs_js_Array()
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.$$js$exported$meth$withSignatures__sjs_js_Array__O = (function(signatures) {
  return this.withSignatures__sjs_js_Array__Lamf_client_model_domain_OAuth1Settings(signatures)
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.signatures__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_OAuth1Settings(this.$$undinternal$1);
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth1SettingsModel$().Signatures$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.withSignatures = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withSignatures__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.withTokenCredentialsUri = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withTokenCredentialsUri__T__O(prep)
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.withAuthorizationUri = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withAuthorizationUri__T__O(prep)
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.withRequestTokenUri = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withRequestTokenUri__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_OAuth1Settings.prototype, "signatures", {
  "get": (function() {
    return this.$$js$exported$prop$signatures__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_OAuth1Settings.prototype, "tokenCredentialsUri", {
  "get": (function() {
    return this.$$js$exported$prop$tokenCredentialsUri__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_OAuth1Settings.prototype, "authorizationUri", {
  "get": (function() {
    return this.$$js$exported$prop$authorizationUri__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_OAuth1Settings.prototype, "requestTokenUri", {
  "get": (function() {
    return this.$$js$exported$prop$requestTokenUri__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_OAuth1Settings(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_OAuth1Settings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.OAuth1Settings"))
}
function $isArrayOf_Lamf_client_model_domain_OAuth1Settings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_OAuth1Settings)))
}
function $asArrayOf_Lamf_client_model_domain_OAuth1Settings(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_OAuth1Settings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.OAuth1Settings;", depth))
}
var $d_Lamf_client_model_domain_OAuth1Settings = new $TypeData().initClass({
  Lamf_client_model_domain_OAuth1Settings: 0
}, false, "amf.client.model.domain.OAuth1Settings", {
  Lamf_client_model_domain_OAuth1Settings: 1,
  Lamf_client_model_domain_Settings: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_OAuth1Settings.prototype.$classData = $d_Lamf_client_model_domain_OAuth1Settings;
/** @constructor */
function $c_Lamf_client_model_domain_OAuth2Settings() {
  $c_Lamf_client_model_domain_Settings.call(this)
}
$c_Lamf_client_model_domain_OAuth2Settings.prototype = new $h_Lamf_client_model_domain_Settings();
$c_Lamf_client_model_domain_OAuth2Settings.prototype.constructor = $c_Lamf_client_model_domain_OAuth2Settings;
/** @constructor */
function $h_Lamf_client_model_domain_OAuth2Settings() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_OAuth2Settings.prototype = $c_Lamf_client_model_domain_OAuth2Settings.prototype;
$c_Lamf_client_model_domain_OAuth2Settings.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_OAuth2Settings.prototype.init___Lamf_plugins_domain_webapi_models_security_OAuth2Settings.call(this, new $c_Lamf_plugins_domain_webapi_models_security_OAuth2Settings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.productPrefix__T = (function() {
  return "OAuth2Settings"
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_OAuth2Settings)) {
    var OAuth2Settings$1 = $as_Lamf_client_model_domain_OAuth2Settings(x$1);
    var x = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(OAuth2Settings$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.init___Lamf_plugins_domain_webapi_models_security_OAuth2Settings = (function(_internal) {
  $c_Lamf_client_model_domain_Settings.prototype.init___Lamf_plugins_domain_webapi_models_security_Settings.call(this, _internal);
  return this
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.$$js$exported$prop$flows__O = (function() {
  return this.flows__sjs_js_Array()
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.$$js$exported$meth$withAuthorizationGrants__sjs_js_Array__O = (function(grants) {
  return this.withAuthorizationGrants__sjs_js_Array__Lamf_client_model_domain_OAuth2Settings(grants)
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.authorizationGrants__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(this.$$undinternal$1);
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().AuthorizationGrants$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.withFlows__sjs_js_Array__Lamf_client_model_domain_OAuth2Settings = (function(flows) {
  var this$2 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(this.$$undinternal$1);
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().OAuth2FlowMatcher__Lamf_client_convert_OAuth2FlowConverter$OAuth2FlowMatcher$();
  var flows$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, flows, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1;
  $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, flows$1));
  return this
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.$$js$exported$meth$withFlows__sjs_js_Array__O = (function(flows) {
  return this.withFlows__sjs_js_Array__Lamf_client_model_domain_OAuth2Settings(flows)
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.$$js$exported$prop$authorizationGrants__O = (function() {
  return this.authorizationGrants__sjs_js_Array()
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.withAuthorizationGrants__sjs_js_Array__Lamf_client_model_domain_OAuth2Settings = (function(grants) {
  var this$2 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(this.$$undinternal$1);
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  var authorizationGrants = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, grants, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().AuthorizationGrants$1;
  $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, authorizationGrants));
  return this
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_security_Settings = (function() {
  return $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.flows__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_OAuth2Settings(this.$$undinternal$1);
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OAuth2SettingsModel$().Flows$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().OAuth2FlowMatcher__Lamf_client_convert_OAuth2FlowConverter$OAuth2FlowMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.withAuthorizationGrants = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withAuthorizationGrants__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.withFlows = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withFlows__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_OAuth2Settings.prototype, "authorizationGrants", {
  "get": (function() {
    return this.$$js$exported$prop$authorizationGrants__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_OAuth2Settings.prototype, "flows", {
  "get": (function() {
    return this.$$js$exported$prop$flows__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_OAuth2Settings(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_OAuth2Settings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.OAuth2Settings"))
}
function $isArrayOf_Lamf_client_model_domain_OAuth2Settings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_OAuth2Settings)))
}
function $asArrayOf_Lamf_client_model_domain_OAuth2Settings(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_OAuth2Settings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.OAuth2Settings;", depth))
}
var $d_Lamf_client_model_domain_OAuth2Settings = new $TypeData().initClass({
  Lamf_client_model_domain_OAuth2Settings: 0
}, false, "amf.client.model.domain.OAuth2Settings", {
  Lamf_client_model_domain_OAuth2Settings: 1,
  Lamf_client_model_domain_Settings: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_OAuth2Settings.prototype.$classData = $d_Lamf_client_model_domain_OAuth2Settings;
/** @constructor */
function $c_Lamf_client_model_domain_ObjectNode() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_ObjectNode.prototype = new $h_O();
$c_Lamf_client_model_domain_ObjectNode.prototype.constructor = $c_Lamf_client_model_domain_ObjectNode;
/** @constructor */
function $h_Lamf_client_model_domain_ObjectNode() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_ObjectNode.prototype = $c_Lamf_client_model_domain_ObjectNode.prototype;
$c_Lamf_client_model_domain_ObjectNode.prototype.productPrefix__T = (function() {
  return "ObjectNode"
});
$c_Lamf_client_model_domain_ObjectNode.prototype.init___ = (function() {
  $m_Lamf_core_model_domain_ObjectNode$();
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_ObjectNode.prototype.init___Lamf_core_model_domain_ObjectNode.call(this, new $c_Lamf_core_model_domain_ObjectNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_ObjectNode.prototype.$$js$exported$meth$getProperty__T__O = (function(property) {
  return this.getProperty__T__sjs_js_UndefOr(property)
});
$c_Lamf_client_model_domain_ObjectNode.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_ObjectNode.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_ObjectNode.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_ObjectNode.prototype.$$js$exported$prop$name__O = (function() {
  return $f_Lamf_client_model_domain_DataNode__name__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_ObjectNode.prototype.init___Lamf_core_model_domain_ObjectNode = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_ObjectNode.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_ObjectNode.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_ObjectNode)) {
    var ObjectNode$1 = $as_Lamf_client_model_domain_ObjectNode(x$1);
    var x = this.$$undinternal$1;
    var x$2 = ObjectNode$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_ObjectNode.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ObjectNode.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_ObjectNode.prototype.addProperty__T__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_ObjectNode = (function(property, node) {
  this.$$undinternal$1.addProperty__T__Lamf_core_model_domain_DataNode__Lamf_core_parser_Annotations__Lamf_core_model_domain_ObjectNode(property, node.$$undinternal__Lamf_core_model_domain_DataNode(), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
  return this
});
$c_Lamf_client_model_domain_ObjectNode.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_ObjectNode.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_ObjectNode.prototype.properties__sjs_js_Dictionary = (function() {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal$1.allPropertiesWithName__sci_Map();
  var m = $m_Lamf_client_convert_CoreClientConverters$().DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalImmutableMapOps().init___Lamf_client_convert_CollectionConverter__sci_Map__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
});
$c_Lamf_client_model_domain_ObjectNode.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_ObjectNode.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_ObjectNode.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ObjectNode.prototype.$$js$exported$prop$properties__O = (function() {
  return this.properties__sjs_js_Dictionary()
});
$c_Lamf_client_model_domain_ObjectNode.prototype.$$undinternal__Lamf_core_model_domain_DataNode = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ObjectNode.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ObjectNode.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_ObjectNode.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_ObjectNode.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_ObjectNode.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ObjectNode.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_ObjectNode.prototype.$$js$exported$meth$addProperty__T__Lamf_client_model_domain_DataNode__O = (function(property, node) {
  return this.addProperty__T__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_ObjectNode(property, node)
});
$c_Lamf_client_model_domain_ObjectNode.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_ObjectNode.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return $f_Lamf_client_model_domain_DataNode__withName__T__Lamf_client_model_domain_DataNode(this, name)
});
$c_Lamf_client_model_domain_ObjectNode.prototype.getProperty__T__sjs_js_UndefOr = (function(property) {
  var this$1 = $m_Lamf_client_convert_CoreClientConverters$();
  var from = this.$$undinternal$1.getFromKey__T__s_Option(property);
  var m = $m_Lamf_client_convert_CoreClientConverters$().DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
});
$c_Lamf_client_model_domain_ObjectNode.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_ObjectNode.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_ObjectNode.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ObjectNode.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ObjectNode.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_ObjectNode.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_ObjectNode.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ObjectNode.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ObjectNode.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ObjectNode.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ObjectNode.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ObjectNode.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ObjectNode.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ObjectNode.prototype.addProperty = (function(arg, arg$2) {
  var prep = $as_T(arg);
  var prep$2 = $as_Lamf_client_model_domain_DataNode(arg$2);
  return this.$$js$exported$meth$addProperty__T__Lamf_client_model_domain_DataNode__O(prep, prep$2)
});
$c_Lamf_client_model_domain_ObjectNode.prototype.getProperty = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$getProperty__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ObjectNode.prototype, "properties", {
  "get": (function() {
    return this.$$js$exported$prop$properties__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_ObjectNode(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_ObjectNode) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.ObjectNode"))
}
function $isArrayOf_Lamf_client_model_domain_ObjectNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_ObjectNode)))
}
function $asArrayOf_Lamf_client_model_domain_ObjectNode(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_ObjectNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.ObjectNode;", depth))
}
var $d_Lamf_client_model_domain_ObjectNode = new $TypeData().initClass({
  Lamf_client_model_domain_ObjectNode: 0
}, false, "amf.client.model.domain.ObjectNode", {
  Lamf_client_model_domain_ObjectNode: 1,
  O: 1,
  Lamf_client_model_domain_DataNode: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_ObjectNode.prototype.$classData = $d_Lamf_client_model_domain_ObjectNode;
/** @constructor */
function $c_Lamf_client_model_domain_ObjectPropertyTerm() {
  $c_Lamf_client_model_domain_PropertyTerm.call(this)
}
$c_Lamf_client_model_domain_ObjectPropertyTerm.prototype = new $h_Lamf_client_model_domain_PropertyTerm();
$c_Lamf_client_model_domain_ObjectPropertyTerm.prototype.constructor = $c_Lamf_client_model_domain_ObjectPropertyTerm;
/** @constructor */
function $h_Lamf_client_model_domain_ObjectPropertyTerm() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_ObjectPropertyTerm.prototype = $c_Lamf_client_model_domain_ObjectPropertyTerm.prototype;
$c_Lamf_client_model_domain_ObjectPropertyTerm.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_ObjectPropertyTerm.prototype.init___Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm.call(this, new $c_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_ObjectPropertyTerm.prototype.productPrefix__T = (function() {
  return "ObjectPropertyTerm"
});
$c_Lamf_client_model_domain_ObjectPropertyTerm.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_ObjectPropertyTerm.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_ObjectPropertyTerm)) {
    var ObjectPropertyTerm$1 = $as_Lamf_client_model_domain_ObjectPropertyTerm(x$1);
    var x = $as_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm(ObjectPropertyTerm$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_ObjectPropertyTerm.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_ObjectPropertyTerm.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_ObjectPropertyTerm.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_ObjectPropertyTerm.prototype.$$undinternal__Lamf_plugins_document_vocabularies_model_domain_PropertyTerm = (function() {
  return $as_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_ObjectPropertyTerm.prototype.init___Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm = (function(_internal) {
  $c_Lamf_client_model_domain_PropertyTerm.prototype.init___Lamf_plugins_document_vocabularies_model_domain_PropertyTerm.call(this, _internal);
  return this
});
$c_Lamf_client_model_domain_ObjectPropertyTerm.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyTerm(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_ObjectPropertyTerm.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_ObjectPropertyTerm.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_client_model_domain_ObjectPropertyTerm(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_ObjectPropertyTerm) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.ObjectPropertyTerm"))
}
function $isArrayOf_Lamf_client_model_domain_ObjectPropertyTerm(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_ObjectPropertyTerm)))
}
function $asArrayOf_Lamf_client_model_domain_ObjectPropertyTerm(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_ObjectPropertyTerm(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.ObjectPropertyTerm;", depth))
}
var $d_Lamf_client_model_domain_ObjectPropertyTerm = new $TypeData().initClass({
  Lamf_client_model_domain_ObjectPropertyTerm: 0
}, false, "amf.client.model.domain.ObjectPropertyTerm", {
  Lamf_client_model_domain_ObjectPropertyTerm: 1,
  Lamf_client_model_domain_PropertyTerm: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_ObjectPropertyTerm.prototype.$classData = $d_Lamf_client_model_domain_ObjectPropertyTerm;
/** @constructor */
function $c_Lamf_client_model_domain_OpenIdConnectSettings() {
  $c_Lamf_client_model_domain_Settings.call(this)
}
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype = new $h_Lamf_client_model_domain_Settings();
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.constructor = $c_Lamf_client_model_domain_OpenIdConnectSettings;
/** @constructor */
function $h_Lamf_client_model_domain_OpenIdConnectSettings() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_OpenIdConnectSettings.prototype = $c_Lamf_client_model_domain_OpenIdConnectSettings.prototype;
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.init___Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings.call(this, new $c_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.productPrefix__T = (function() {
  return "OpenIdConnectSettings"
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.init___Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings = (function(_internal) {
  $c_Lamf_client_model_domain_Settings.prototype.init___Lamf_plugins_domain_webapi_models_security_Settings.call(this, _internal);
  return this
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.$$js$exported$prop$url__O = (function() {
  return this.url__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_OpenIdConnectSettings)) {
    var OpenIdConnectSettings$1 = $as_Lamf_client_model_domain_OpenIdConnectSettings(x$1);
    var x = $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(OpenIdConnectSettings$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.$$js$exported$meth$withUrl__T__O = (function(url) {
  return this.withUrl__T__Lamf_client_model_domain_OpenIdConnectSettings(url)
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.url__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(this.$$undinternal$1);
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$().Url$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.$$js$exported$meth$withScopes__sjs_js_Array__O = (function(scopes) {
  return this.withScopes__sjs_js_Array__Lamf_client_model_domain_OpenIdConnectSettings(scopes)
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.scopes__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(this.$$undinternal$1);
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$().Scopes$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ScopeMatcher__Lamf_client_convert_ScopeConverter$ScopeMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.withUrl__T__Lamf_client_model_domain_OpenIdConnectSettings = (function(url) {
  var this$1 = $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$().Url$1;
  $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, url));
  return this
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_security_Settings = (function() {
  return $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.$$js$exported$prop$scopes__O = (function() {
  return this.scopes__sjs_js_Array()
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.withScopes__sjs_js_Array__Lamf_client_model_domain_OpenIdConnectSettings = (function(scopes) {
  var this$2 = $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(this.$$undinternal$1);
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ScopeMatcher__Lamf_client_convert_ScopeConverter$ScopeMatcher$();
  var scopes$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, scopes, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_OpenIdConnectSettingsModel$().Scopes$1;
  $as_Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, scopes$1));
  return this
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.withScopes = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withScopes__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.withUrl = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withUrl__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_OpenIdConnectSettings.prototype, "scopes", {
  "get": (function() {
    return this.$$js$exported$prop$scopes__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_OpenIdConnectSettings.prototype, "url", {
  "get": (function() {
    return this.$$js$exported$prop$url__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_OpenIdConnectSettings(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_OpenIdConnectSettings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.OpenIdConnectSettings"))
}
function $isArrayOf_Lamf_client_model_domain_OpenIdConnectSettings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_OpenIdConnectSettings)))
}
function $asArrayOf_Lamf_client_model_domain_OpenIdConnectSettings(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_OpenIdConnectSettings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.OpenIdConnectSettings;", depth))
}
var $d_Lamf_client_model_domain_OpenIdConnectSettings = new $TypeData().initClass({
  Lamf_client_model_domain_OpenIdConnectSettings: 0
}, false, "amf.client.model.domain.OpenIdConnectSettings", {
  Lamf_client_model_domain_OpenIdConnectSettings: 1,
  Lamf_client_model_domain_Settings: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.$classData = $d_Lamf_client_model_domain_OpenIdConnectSettings;
/** @constructor */
function $c_Lamf_client_model_domain_Organization() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_Organization.prototype = new $h_O();
$c_Lamf_client_model_domain_Organization.prototype.constructor = $c_Lamf_client_model_domain_Organization;
/** @constructor */
function $h_Lamf_client_model_domain_Organization() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_Organization.prototype = $c_Lamf_client_model_domain_Organization.prototype;
$c_Lamf_client_model_domain_Organization.prototype.productPrefix__T = (function() {
  return "Organization"
});
$c_Lamf_client_model_domain_Organization.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Organization.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_Organization.prototype.init___Lamf_plugins_domain_webapi_models_Organization.call(this, new $c_Lamf_plugins_domain_webapi_models_Organization().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_Organization.prototype.$$js$exported$meth$withEmail__T__O = (function(email) {
  return this.withEmail__T__Lamf_client_model_domain_Organization(email)
});
$c_Lamf_client_model_domain_Organization.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_Organization.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_Organization.prototype.withName__T__Lamf_client_model_domain_Organization = (function(name) {
  var this$3 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_Organization.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_Organization.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Organization.prototype.$$js$exported$prop$url__O = (function() {
  return this.url__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Organization.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_Organization.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_Organization)) {
    var Organization$1 = $as_Lamf_client_model_domain_Organization(x$1);
    var x = this.$$undinternal$1;
    var x$2 = Organization$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_Organization.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Organization.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_Organization.prototype.url__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$().Url$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Organization.prototype.$$js$exported$meth$withUrl__T__O = (function(url) {
  return this.withUrl__T__Lamf_client_model_domain_Organization(url)
});
$c_Lamf_client_model_domain_Organization.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_Organization.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_Organization.prototype.init___Lamf_plugins_domain_webapi_models_Organization = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_Organization.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_Organization.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_Organization.prototype.$$js$exported$prop$email__O = (function() {
  return this.email__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Organization.prototype.withUrl__T__Lamf_client_model_domain_Organization = (function(url) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$().Url$1;
  $as_Lamf_plugins_domain_webapi_models_Organization($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, url));
  return this
});
$c_Lamf_client_model_domain_Organization.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Organization.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Organization.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_Organization.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_Organization.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_Organization.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Organization.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_Organization.prototype.email__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$().Email$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Organization.prototype.withEmail__T__Lamf_client_model_domain_Organization = (function(email) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OrganizationModel$().Email$1;
  $as_Lamf_plugins_domain_webapi_models_Organization($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, email));
  return this
});
$c_Lamf_client_model_domain_Organization.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_Organization.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_Organization(name)
});
$c_Lamf_client_model_domain_Organization.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_Organization.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_Organization.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Organization.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Organization.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_Organization.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Organization.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Organization.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Organization.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Organization.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Organization.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Organization.prototype.withEmail = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withEmail__T__O(prep)
});
$c_Lamf_client_model_domain_Organization.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
$c_Lamf_client_model_domain_Organization.prototype.withUrl = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withUrl__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Organization.prototype, "email", {
  "get": (function() {
    return this.$$js$exported$prop$email__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Organization.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Organization.prototype, "url", {
  "get": (function() {
    return this.$$js$exported$prop$url__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_Organization(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_Organization) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Organization"))
}
function $isArrayOf_Lamf_client_model_domain_Organization(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Organization)))
}
function $asArrayOf_Lamf_client_model_domain_Organization(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Organization(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Organization;", depth))
}
var $d_Lamf_client_model_domain_Organization = new $TypeData().initClass({
  Lamf_client_model_domain_Organization: 0
}, false, "amf.client.model.domain.Organization", {
  Lamf_client_model_domain_Organization: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_Organization.prototype.$classData = $d_Lamf_client_model_domain_Organization;
/** @constructor */
function $c_Lamf_client_model_domain_Parameter() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_Parameter.prototype = new $h_O();
$c_Lamf_client_model_domain_Parameter.prototype.constructor = $c_Lamf_client_model_domain_Parameter;
/** @constructor */
function $h_Lamf_client_model_domain_Parameter() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_Parameter.prototype = $c_Lamf_client_model_domain_Parameter.prototype;
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$prop$allowEmptyValue__O = (function() {
  return this.allowEmptyValue__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$withScalarSchema__T__O = (function(name) {
  return this.withScalarSchema__T__Lamf_client_model_domain_ScalarShape(name)
});
$c_Lamf_client_model_domain_Parameter.prototype.productPrefix__T = (function() {
  return "Parameter"
});
$c_Lamf_client_model_domain_Parameter.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$withSchema__Lamf_client_model_domain_Shape__O = (function(schema) {
  return this.withSchema__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Parameter(schema)
});
$c_Lamf_client_model_domain_Parameter.prototype.init___Lamf_plugins_domain_webapi_models_Parameter = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_Parameter.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_Parameter.prototype.init___Lamf_plugins_domain_webapi_models_Parameter.call(this, new $c_Lamf_plugins_domain_webapi_models_Parameter().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$prop$deprecated__O = (function() {
  return this.deprecated__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$withObjectSchema__T__O = (function(name) {
  return this.withObjectSchema__T__Lamf_client_model_domain_NodeShape(name)
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_Parameter.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_Parameter.prototype.withScalarSchema__T__Lamf_client_model_domain_ScalarShape = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withScalarSchema__T__Lamf_plugins_domain_shapes_models_ScalarShape(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ScalarShapeMatcher__Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_client_model_domain_ScalarShape(from)
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Parameter.prototype.withAllowReserved__Z__Lamf_client_model_domain_Parameter = (function(allowReserved) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().AllowReserved$1;
  $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, allowReserved));
  return this
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$prop$examples__O = (function() {
  return this.examples__sjs_js_Array()
});
$c_Lamf_client_model_domain_Parameter.prototype.explode__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Explode$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_Parameter.prototype.deprecated__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Deprecated$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_Parameter.prototype.examples__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ExampleMatcher__Lamf_client_convert_ExampleConverter$ExampleMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$prop$allowReserved__O = (function() {
  return this.allowReserved__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_Parameter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_Parameter)) {
    var Parameter$1 = $as_Lamf_client_model_domain_Parameter(x$1);
    var x = this.$$undinternal$1;
    var x$2 = Parameter$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_Parameter.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Parameter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$prop$payloads__O = (function() {
  return this.payloads__sjs_js_Array()
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$withExamples__sjs_js_Array__O = (function(examples) {
  return this.withExamples__sjs_js_Array__Lamf_client_model_domain_Parameter(examples)
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$prop$schema__O = (function() {
  return this.schema__Lamf_client_model_domain_Shape()
});
$c_Lamf_client_model_domain_Parameter.prototype.allowEmptyValue__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().AllowEmptyValue$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_Parameter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$withAllowEmptyValue__Z__O = (function(allowEmptyValue) {
  return this.withAllowEmptyValue__Z__Lamf_client_model_domain_Parameter(allowEmptyValue)
});
$c_Lamf_client_model_domain_Parameter.prototype.parameterName__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().ParameterName$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Parameter.prototype.required__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_Parameter.prototype.style__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Style$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Parameter.prototype.withStyle__T__Lamf_client_model_domain_Parameter = (function(style) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Style$1;
  $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, style));
  return this
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$withStyle__T__O = (function(style) {
  return this.withStyle__T__Lamf_client_model_domain_Parameter(style)
});
$c_Lamf_client_model_domain_Parameter.prototype.payloads__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Payloads$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PayloadMatcher__Lamf_client_convert_PayloadConverter$PayloadMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$withExplode__Z__O = (function(explode) {
  return this.withExplode__Z__Lamf_client_model_domain_Parameter(explode)
});
$c_Lamf_client_model_domain_Parameter.prototype.description__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Description$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$withExample__T__O = (function(name) {
  return this.withExample__T__Lamf_client_model_domain_Example(name)
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_Parameter.prototype.withBinding__T__Lamf_client_model_domain_Parameter = (function(binding) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1;
  $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, binding));
  return this
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$prop$parameterName__O = (function() {
  return this.parameterName__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Parameter.prototype.withAllowEmptyValue__Z__Lamf_client_model_domain_Parameter = (function(allowEmptyValue) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().AllowEmptyValue$1;
  $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, allowEmptyValue));
  return this
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$prop$explode__O = (function() {
  return this.explode__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_Parameter.prototype.binding__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Binding$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Parameter.prototype.withDescription__T__Lamf_client_model_domain_Parameter = (function(description) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Description$1;
  $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, description));
  return this
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Parameter.prototype.withRequired__Z__Lamf_client_model_domain_Parameter = (function(required) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Required$1;
  $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, required));
  return this
});
$c_Lamf_client_model_domain_Parameter.prototype.schema__Lamf_client_model_domain_Shape = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_domain_Shape(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(from)
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$prop$required__O = (function() {
  return this.required__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$withRequired__Z__O = (function(required) {
  return this.withRequired__Z__Lamf_client_model_domain_Parameter(required)
});
$c_Lamf_client_model_domain_Parameter.prototype.withExplode__Z__Lamf_client_model_domain_Parameter = (function(explode) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Explode$1;
  $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, explode));
  return this
});
$c_Lamf_client_model_domain_Parameter.prototype.withDeprecated__Z__Lamf_client_model_domain_Parameter = (function(deprecated) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Deprecated$1;
  $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, deprecated));
  return this
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Parameter.prototype.withParameterName__T__Lamf_client_model_domain_Parameter = (function(name) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().ParameterName$1;
  $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name));
  return this
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_Parameter.prototype.withPayload__T__Lamf_client_model_domain_Payload = (function(mediaType) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withPayload__T__Lamf_plugins_domain_webapi_models_Payload(mediaType);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PayloadMatcher__Lamf_client_convert_PayloadConverter$PayloadMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Payload__Lamf_client_model_domain_Payload(from)
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$withDescription__T__O = (function(description) {
  return this.withDescription__T__Lamf_client_model_domain_Parameter(description)
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$withAllowReserved__Z__O = (function(allowReserved) {
  return this.withAllowReserved__Z__Lamf_client_model_domain_Parameter(allowReserved)
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$withPayload__T__O = (function(mediaType) {
  return this.withPayload__T__Lamf_client_model_domain_Payload(mediaType)
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_Parameter.prototype.withName__T__Lamf_client_model_domain_Parameter = (function(name) {
  var this$3 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_Parameter.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$prop$binding__O = (function() {
  return this.binding__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$withParameterName__T__O = (function(name) {
  return this.withParameterName__T__Lamf_client_model_domain_Parameter(name)
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$prop$description__O = (function() {
  return this.description__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Parameter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_Parameter.prototype.withPayloads__sjs_js_Array__Lamf_client_model_domain_Parameter = (function(payloads) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PayloadMatcher__Lamf_client_convert_PayloadConverter$PayloadMatcher$();
  var payloads$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, payloads, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Payloads$1;
  $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, payloads$1));
  return this
});
$c_Lamf_client_model_domain_Parameter.prototype.withExamples__sjs_js_Array__Lamf_client_model_domain_Parameter = (function(examples) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ExampleMatcher__Lamf_client_convert_ExampleConverter$ExampleMatcher$();
  var examples$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, examples, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1;
  $as_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, examples$1));
  return this
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$prop$style__O = (function() {
  return this.style__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Parameter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_Parameter(name)
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$withBinding__T__O = (function(binding) {
  return this.withBinding__T__Lamf_client_model_domain_Parameter(binding)
});
$c_Lamf_client_model_domain_Parameter.prototype.withSchema__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Parameter = (function(schema) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var schema$1 = schema.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1;
  $as_Lamf_plugins_domain_webapi_models_Parameter($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, schema$1));
  return this
});
$c_Lamf_client_model_domain_Parameter.prototype.withObjectSchema__T__Lamf_client_model_domain_NodeShape = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withObjectSchema__T__Lamf_plugins_domain_shapes_models_NodeShape(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().NodeShapeMatcher__Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_NodeShape__Lamf_client_model_domain_NodeShape(from)
});
$c_Lamf_client_model_domain_Parameter.prototype.withExample__T__Lamf_client_model_domain_Example = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var name$1 = new $c_s_Some().init___O(name);
  var from = $f_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement__withExample__s_Option__Lamf_plugins_domain_shapes_models_Example(this$1, name$1);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ExampleMatcher__Lamf_client_convert_ExampleConverter$ExampleMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_Example__Lamf_client_model_domain_Example(from)
});
$c_Lamf_client_model_domain_Parameter.prototype.allowReserved__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().AllowReserved$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$withPayloads__sjs_js_Array__O = (function(payloads) {
  return this.withPayloads__sjs_js_Array__Lamf_client_model_domain_Parameter(payloads)
});
$c_Lamf_client_model_domain_Parameter.prototype.$$js$exported$meth$withDeprecated__Z__O = (function(deprecated) {
  return this.withDeprecated__Z__Lamf_client_model_domain_Parameter(deprecated)
});
$c_Lamf_client_model_domain_Parameter.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_Parameter.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_Parameter.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Parameter.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Parameter.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_Parameter.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Parameter.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Parameter.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Parameter.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Parameter.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Parameter.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Parameter.prototype.withExample = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withExample__T__O(prep)
});
$c_Lamf_client_model_domain_Parameter.prototype.withPayload = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withPayload__T__O(prep)
});
$c_Lamf_client_model_domain_Parameter.prototype.withScalarSchema = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withScalarSchema__T__O(prep)
});
$c_Lamf_client_model_domain_Parameter.prototype.withObjectSchema = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withObjectSchema__T__O(prep)
});
$c_Lamf_client_model_domain_Parameter.prototype.withSchema = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withSchema__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_Parameter.prototype.withExamples = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExamples__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Parameter.prototype.withPayloads = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withPayloads__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Parameter.prototype.withBinding = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withBinding__T__O(prep)
});
$c_Lamf_client_model_domain_Parameter.prototype.withAllowReserved = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withAllowReserved__Z__O(prep)
});
$c_Lamf_client_model_domain_Parameter.prototype.withExplode = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withExplode__Z__O(prep)
});
$c_Lamf_client_model_domain_Parameter.prototype.withStyle = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withStyle__T__O(prep)
});
$c_Lamf_client_model_domain_Parameter.prototype.withAllowEmptyValue = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withAllowEmptyValue__Z__O(prep)
});
$c_Lamf_client_model_domain_Parameter.prototype.withDeprecated = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withDeprecated__Z__O(prep)
});
$c_Lamf_client_model_domain_Parameter.prototype.withRequired = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withRequired__Z__O(prep)
});
$c_Lamf_client_model_domain_Parameter.prototype.withDescription = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDescription__T__O(prep)
});
$c_Lamf_client_model_domain_Parameter.prototype.withParameterName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withParameterName__T__O(prep)
});
$c_Lamf_client_model_domain_Parameter.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Parameter.prototype, "examples", {
  "get": (function() {
    return this.$$js$exported$prop$examples__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Parameter.prototype, "payloads", {
  "get": (function() {
    return this.$$js$exported$prop$payloads__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Parameter.prototype, "schema", {
  "get": (function() {
    return this.$$js$exported$prop$schema__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Parameter.prototype, "binding", {
  "get": (function() {
    return this.$$js$exported$prop$binding__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Parameter.prototype, "allowReserved", {
  "get": (function() {
    return this.$$js$exported$prop$allowReserved__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Parameter.prototype, "explode", {
  "get": (function() {
    return this.$$js$exported$prop$explode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Parameter.prototype, "style", {
  "get": (function() {
    return this.$$js$exported$prop$style__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Parameter.prototype, "allowEmptyValue", {
  "get": (function() {
    return this.$$js$exported$prop$allowEmptyValue__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Parameter.prototype, "deprecated", {
  "get": (function() {
    return this.$$js$exported$prop$deprecated__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Parameter.prototype, "required", {
  "get": (function() {
    return this.$$js$exported$prop$required__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Parameter.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Parameter.prototype, "parameterName", {
  "get": (function() {
    return this.$$js$exported$prop$parameterName__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Parameter.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_Parameter(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_Parameter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Parameter"))
}
function $isArrayOf_Lamf_client_model_domain_Parameter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Parameter)))
}
function $asArrayOf_Lamf_client_model_domain_Parameter(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Parameter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Parameter;", depth))
}
var $d_Lamf_client_model_domain_Parameter = new $TypeData().initClass({
  Lamf_client_model_domain_Parameter: 0
}, false, "amf.client.model.domain.Parameter", {
  Lamf_client_model_domain_Parameter: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_Parameter.prototype.$classData = $d_Lamf_client_model_domain_Parameter;
/** @constructor */
function $c_Lamf_client_model_domain_Payload() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_Payload.prototype = new $h_O();
$c_Lamf_client_model_domain_Payload.prototype.constructor = $c_Lamf_client_model_domain_Payload;
/** @constructor */
function $h_Lamf_client_model_domain_Payload() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_Payload.prototype = $c_Lamf_client_model_domain_Payload.prototype;
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$meth$withScalarSchema__T__O = (function(name) {
  return this.withScalarSchema__T__Lamf_client_model_domain_ScalarShape(name)
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$prop$encodings__O = (function() {
  return this.encodings__sjs_js_Array()
});
$c_Lamf_client_model_domain_Payload.prototype.productPrefix__T = (function() {
  return "Payload"
});
$c_Lamf_client_model_domain_Payload.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_Payload.prototype.init___Lamf_plugins_domain_webapi_models_Payload.call(this, new $c_Lamf_plugins_domain_webapi_models_Payload().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$meth$withSchema__Lamf_client_model_domain_Shape__O = (function(schema) {
  return this.withSchema__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Payload(schema)
});
$c_Lamf_client_model_domain_Payload.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$meth$withObjectSchema__T__O = (function(name) {
  return this.withObjectSchema__T__Lamf_client_model_domain_NodeShape(name)
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_Payload.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Payload.prototype.mediaType__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Payload.prototype.withScalarSchema__T__Lamf_client_model_domain_ScalarShape = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withScalarSchema__T__Lamf_plugins_domain_shapes_models_ScalarShape(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ScalarShapeMatcher__Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_client_model_domain_ScalarShape(from)
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$prop$examples__O = (function() {
  return this.examples__sjs_js_Array()
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_Payload.prototype.examples__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ExampleMatcher__Lamf_client_convert_ExampleConverter$ExampleMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Payload.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Payload.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_Payload)) {
    var Payload$1 = $as_Lamf_client_model_domain_Payload(x$1);
    var x = this.$$undinternal$1;
    var x$2 = Payload$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_Payload.prototype.withExamples__sjs_js_Array__Lamf_client_model_domain_Payload = (function(examples) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ExampleMatcher__Lamf_client_convert_ExampleConverter$ExampleMatcher$();
  var examples$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, examples, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1;
  $as_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, examples$1));
  return this
});
$c_Lamf_client_model_domain_Payload.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$meth$withExamples__sjs_js_Array__O = (function(examples) {
  return this.withExamples__sjs_js_Array__Lamf_client_model_domain_Payload(examples)
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$prop$schema__O = (function() {
  return this.schema__Lamf_client_model_domain_Shape()
});
$c_Lamf_client_model_domain_Payload.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$meth$withExample__T__O = (function(name) {
  return this.withExample__T__Lamf_client_model_domain_Example(name)
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_Payload.prototype.encodings__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Encoding$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().EncodingMatcher__Lamf_client_convert_EncodingConverter$EncodingMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Payload.prototype.schemaMediaType__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().SchemaMediaType$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$meth$withEncoding__T__O = (function(name) {
  return this.withEncoding__T__Lamf_client_model_domain_Encoding(name)
});
$c_Lamf_client_model_domain_Payload.prototype.withEncodings__sjs_js_Array__Lamf_client_model_domain_Payload = (function(encoding) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().EncodingMatcher__Lamf_client_convert_EncodingConverter$EncodingMatcher$();
  var encoding$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, encoding, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Encoding$1;
  $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, encoding$1));
  return this
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$meth$withSchemaMediaType__T__O = (function(mediaType) {
  return this.withSchemaMediaType__T__Lamf_client_model_domain_Payload(mediaType)
});
$c_Lamf_client_model_domain_Payload.prototype.withSchemaMediaType__T__Lamf_client_model_domain_Payload = (function(mediaType) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().SchemaMediaType$1;
  $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, mediaType));
  return this
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$prop$schemaMediaType__O = (function() {
  return this.schemaMediaType__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Payload.prototype.encoding__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Encoding$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().EncodingMatcher__Lamf_client_convert_EncodingConverter$EncodingMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Payload.prototype.schema__Lamf_client_model_domain_Shape = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_domain_Shape(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(from)
});
$c_Lamf_client_model_domain_Payload.prototype.init___Lamf_plugins_domain_webapi_models_Payload = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$meth$withEncodings__sjs_js_Array__O = (function(encoding) {
  return this.withEncodings__sjs_js_Array__Lamf_client_model_domain_Payload(encoding)
});
$c_Lamf_client_model_domain_Payload.prototype.withEncoding__T__Lamf_client_model_domain_Encoding = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withEncoding__T__Lamf_plugins_domain_webapi_models_Encoding(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().EncodingMatcher__Lamf_client_convert_EncodingConverter$EncodingMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Encoding__Lamf_client_model_domain_Encoding(from)
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$meth$withMediaType__T__O = (function(mediaType) {
  return this.withMediaType__T__Lamf_client_model_domain_Payload(mediaType)
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$meth$withEncoding__sjs_js_Array__O = (function(encoding) {
  return this.withEncoding__sjs_js_Array__Lamf_client_model_domain_Payload(encoding)
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$prop$mediaType__O = (function() {
  return this.mediaType__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_Payload.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Payload.prototype.withMediaType__T__Lamf_client_model_domain_Payload = (function(mediaType) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1;
  $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, mediaType));
  return this
});
$c_Lamf_client_model_domain_Payload.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_Payload.prototype.withSchema__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Payload = (function(schema) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var schema$1 = schema.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
  $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, schema$1));
  return this
});
$c_Lamf_client_model_domain_Payload.prototype.withName__T__Lamf_client_model_domain_Payload = (function(name) {
  var this$3 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_Payload.prototype.withEncoding__sjs_js_Array__Lamf_client_model_domain_Payload = (function(encoding) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().EncodingMatcher__Lamf_client_convert_EncodingConverter$EncodingMatcher$();
  var encoding$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, encoding, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Encoding$1;
  $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, encoding$1));
  return this
});
$c_Lamf_client_model_domain_Payload.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_Payload(name)
});
$c_Lamf_client_model_domain_Payload.prototype.$$js$exported$prop$encoding__O = (function() {
  return this.encoding__sjs_js_Array()
});
$c_Lamf_client_model_domain_Payload.prototype.withObjectSchema__T__Lamf_client_model_domain_NodeShape = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withObjectSchema__T__Lamf_plugins_domain_shapes_models_NodeShape(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().NodeShapeMatcher__Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_NodeShape__Lamf_client_model_domain_NodeShape(from)
});
$c_Lamf_client_model_domain_Payload.prototype.withExample__T__Lamf_client_model_domain_Example = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var name$1 = new $c_s_Some().init___O(name);
  var from = $f_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement__withExample__s_Option__Lamf_plugins_domain_shapes_models_Example(this$1, name$1);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ExampleMatcher__Lamf_client_convert_ExampleConverter$ExampleMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_Example__Lamf_client_model_domain_Example(from)
});
$c_Lamf_client_model_domain_Payload.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_Payload.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_Payload.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Payload.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Payload.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_Payload.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Payload.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Payload.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Payload.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Payload.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Payload.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Payload.prototype.withEncoding = (function(arg) {
  if ($is_T(arg)) {
    var prep$2 = $as_T(arg);
    return this.$$js$exported$meth$withEncoding__T__O(prep$2)
  } else {
    var prep = arg;
    return this.$$js$exported$meth$withEncoding__sjs_js_Array__O(prep)
  }
});
Object.defineProperty($c_Lamf_client_model_domain_Payload.prototype, "encoding", {
  "get": (function() {
    return this.$$js$exported$prop$encoding__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Payload.prototype.withExample = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withExample__T__O(prep)
});
$c_Lamf_client_model_domain_Payload.prototype.withScalarSchema = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withScalarSchema__T__O(prep)
});
$c_Lamf_client_model_domain_Payload.prototype.withObjectSchema = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withObjectSchema__T__O(prep)
});
$c_Lamf_client_model_domain_Payload.prototype.withEncodings = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withEncodings__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Payload.prototype.withExamples = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExamples__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Payload.prototype.withSchema = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withSchema__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_Payload.prototype.withSchemaMediaType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withSchemaMediaType__T__O(prep)
});
$c_Lamf_client_model_domain_Payload.prototype.withMediaType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withMediaType__T__O(prep)
});
$c_Lamf_client_model_domain_Payload.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Payload.prototype, "encodings", {
  "get": (function() {
    return this.$$js$exported$prop$encodings__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Payload.prototype, "examples", {
  "get": (function() {
    return this.$$js$exported$prop$examples__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Payload.prototype, "schema", {
  "get": (function() {
    return this.$$js$exported$prop$schema__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Payload.prototype, "schemaMediaType", {
  "get": (function() {
    return this.$$js$exported$prop$schemaMediaType__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Payload.prototype, "mediaType", {
  "get": (function() {
    return this.$$js$exported$prop$mediaType__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Payload.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_Payload(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_Payload) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Payload"))
}
function $isArrayOf_Lamf_client_model_domain_Payload(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Payload)))
}
function $asArrayOf_Lamf_client_model_domain_Payload(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Payload(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Payload;", depth))
}
var $d_Lamf_client_model_domain_Payload = new $TypeData().initClass({
  Lamf_client_model_domain_Payload: 0
}, false, "amf.client.model.domain.Payload", {
  Lamf_client_model_domain_Payload: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_Payload.prototype.$classData = $d_Lamf_client_model_domain_Payload;
/** @constructor */
function $c_Lamf_client_model_domain_ScalarNode() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_ScalarNode.prototype = new $h_O();
$c_Lamf_client_model_domain_ScalarNode.prototype.constructor = $c_Lamf_client_model_domain_ScalarNode;
/** @constructor */
function $h_Lamf_client_model_domain_ScalarNode() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_ScalarNode.prototype = $c_Lamf_client_model_domain_ScalarNode.prototype;
$c_Lamf_client_model_domain_ScalarNode.prototype.init___T__T = (function(value, dataType) {
  var this$1 = $m_Lamf_core_model_domain_ScalarNode$();
  var dataType$1 = $m_s_Option$().apply__O__s_Option(dataType);
  $c_Lamf_client_model_domain_ScalarNode.prototype.init___Lamf_core_model_domain_ScalarNode.call(this, this$1.apply__T__s_Option__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode(value, dataType$1, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___())));
  return this
});
$c_Lamf_client_model_domain_ScalarNode.prototype.productPrefix__T = (function() {
  return "ScalarNode"
});
$c_Lamf_client_model_domain_ScalarNode.prototype.init___ = (function() {
  var this$1 = $m_Lamf_core_model_domain_ScalarNode$();
  var dataType = $m_s_None$();
  $c_Lamf_client_model_domain_ScalarNode.prototype.init___Lamf_core_model_domain_ScalarNode.call(this, this$1.apply__T__s_Option__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode("", dataType, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___())));
  return this
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$$js$exported$meth$withDataType__T__O = (function(dataType) {
  return this.withDataType__T__Lamf_client_model_domain_ScalarNode(dataType)
});
$c_Lamf_client_model_domain_ScalarNode.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$$js$exported$prop$name__O = (function() {
  return $f_Lamf_client_model_domain_DataNode__name__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_ScalarNode.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_ScalarNode)) {
    var ScalarNode$1 = $as_Lamf_client_model_domain_ScalarNode(x$1);
    var x = this.$$undinternal$1;
    var x$2 = ScalarNode$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ScalarNode.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$$js$exported$meth$toString__O = (function() {
  return this.toString__T()
});
$c_Lamf_client_model_domain_ScalarNode.prototype.toString__T = (function() {
  var this$1 = $f_Lamf_client_model_domain_DataNode__name__Lamf_client_model_StrField(this);
  var this$2 = this$1.$$undoption$1;
  return (((($as_T((this$2.isEmpty__Z() ? null : this$2.get__O())) + ":") + this.dataType__Lamf_client_model_StrField()) + "=") + this.value__Lamf_client_model_StrField())
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$$js$exported$prop$dataType__O = (function() {
  return this.dataType__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_ScalarNode.prototype.withValue__T__Lamf_client_model_domain_ScalarNode = (function(value) {
  var this$1 = this.$$undinternal$1;
  this$1.withValue__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_ScalarNode(value, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
  return this
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_ScalarNode.prototype.value__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().Value$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_ScalarNode.prototype.init___Lamf_core_model_domain_ScalarNode = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$$js$exported$meth$withValue__T__O = (function(value) {
  return this.withValue__T__Lamf_client_model_domain_ScalarNode(value)
});
$c_Lamf_client_model_domain_ScalarNode.prototype.withDataType__T__Lamf_client_model_domain_ScalarNode = (function(dataType) {
  this.$$undinternal$1.withDataType__T__Lamf_core_model_domain_ScalarNode(dataType);
  return this
});
$c_Lamf_client_model_domain_ScalarNode.prototype.dataType__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ScalarNodeModel$().DataType$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$$undinternal__Lamf_core_model_domain_DataNode = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$$js$exported$prop$value__O = (function() {
  return this.value__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ScalarNode.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_ScalarNode.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return $f_Lamf_client_model_domain_DataNode__withName__T__Lamf_client_model_domain_DataNode(this, name)
});
$c_Lamf_client_model_domain_ScalarNode.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_ScalarNode.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_ScalarNode.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ScalarNode.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ScalarNode.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_ScalarNode.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_ScalarNode.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ScalarNode.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ScalarNode.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ScalarNode.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ScalarNode.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ScalarNode.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ScalarNode.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ScalarNode.prototype.withDataType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDataType__T__O(prep)
});
$c_Lamf_client_model_domain_ScalarNode.prototype.withValue = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withValue__T__O(prep)
});
$c_Lamf_client_model_domain_ScalarNode.prototype.toString = (function() {
  return this.$$js$exported$meth$toString__O()
});
Object.defineProperty($c_Lamf_client_model_domain_ScalarNode.prototype, "dataType", {
  "get": (function() {
    return this.$$js$exported$prop$dataType__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ScalarNode.prototype, "value", {
  "get": (function() {
    return this.$$js$exported$prop$value__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_ScalarNode(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_ScalarNode) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.ScalarNode"))
}
function $isArrayOf_Lamf_client_model_domain_ScalarNode(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_ScalarNode)))
}
function $asArrayOf_Lamf_client_model_domain_ScalarNode(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_ScalarNode(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.ScalarNode;", depth))
}
var $d_Lamf_client_model_domain_ScalarNode = new $TypeData().initClass({
  Lamf_client_model_domain_ScalarNode: 0
}, false, "amf.client.model.domain.ScalarNode", {
  Lamf_client_model_domain_ScalarNode: 1,
  O: 1,
  Lamf_client_model_domain_DataNode: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_ScalarNode.prototype.$classData = $d_Lamf_client_model_domain_ScalarNode;
/** @constructor */
function $c_Lamf_client_model_domain_SecurityScheme() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_SecurityScheme.prototype = new $h_O();
$c_Lamf_client_model_domain_SecurityScheme.prototype.constructor = $c_Lamf_client_model_domain_SecurityScheme;
/** @constructor */
function $h_Lamf_client_model_domain_SecurityScheme() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_SecurityScheme.prototype = $c_Lamf_client_model_domain_SecurityScheme.prototype;
$c_Lamf_client_model_domain_SecurityScheme.prototype.withResponse__T__Lamf_client_model_domain_Response = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withResponse__T__Lamf_plugins_domain_webapi_models_Response(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ResponseMatcher__Lamf_client_convert_MessageConverter$ResponseMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Response__Lamf_client_model_domain_Response(from)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.settings__Lamf_client_model_domain_Settings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_plugins_domain_webapi_models_security_Settings(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().SettingsMatcher__Lamf_client_convert_SettingsConverter$SettingsMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_security_Settings__Lamf_client_model_domain_Settings(from)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withHeader__T__O = (function(name) {
  return this.withHeader__T__Lamf_client_model_domain_Parameter(name)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withOAuth1Settings__O = (function() {
  return this.withOAuth1Settings__Lamf_client_model_domain_OAuth1Settings()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withDisplayName__T__Lamf_client_model_domain_SecurityScheme = (function(displayName) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().DisplayName$1;
  $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, displayName));
  return this
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.productPrefix__T = (function() {
  return "SecurityScheme"
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_SecurityScheme.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityScheme.call(this, new $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.init___Lamf_plugins_domain_webapi_models_security_SecurityScheme = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withHeaders__sjs_js_Array__O = (function(headers) {
  return this.withHeaders__sjs_js_Array__Lamf_client_model_domain_SecurityScheme(headers)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$prop$displayName__O = (function() {
  return this.displayName__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withSettings__Lamf_client_model_domain_Settings__Lamf_client_model_domain_SecurityScheme = (function(settings) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().SettingsMatcher__Lamf_client_convert_SettingsConverter$SettingsMatcher$();
  var settings$1 = settings.$$undinternal__Lamf_plugins_domain_webapi_models_security_Settings();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Settings$1;
  $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, settings$1));
  return this
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_SecurityScheme)) {
    var SecurityScheme$1 = $as_Lamf_client_model_domain_SecurityScheme(x$1);
    var x = this.$$undinternal$1;
    var x$2 = SecurityScheme$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withQueryParameter__T__Lamf_client_model_domain_Parameter = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withQueryParameter__T__Lamf_plugins_domain_webapi_models_Parameter(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Parameter__Lamf_client_model_domain_Parameter(from)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withHeader__T__Lamf_client_model_domain_Parameter = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withHeader__T__Lamf_plugins_domain_webapi_models_Parameter(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Parameter__Lamf_client_model_domain_Parameter(from)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withOAuth1Settings__Lamf_client_model_domain_OAuth1Settings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withOAuth1Settings__Lamf_plugins_domain_webapi_models_security_OAuth1Settings();
  $m_Lamf_client_convert_WebApiClientConverters$().OAuth1SettingsMatcher__Lamf_client_convert_SettingsConverter$OAuth1SettingsMatcher$();
  return new $c_Lamf_client_model_domain_OAuth1Settings().init___Lamf_plugins_domain_webapi_models_security_OAuth1Settings(from)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withQueryParameter__T__O = (function(name) {
  return this.withQueryParameter__T__Lamf_client_model_domain_Parameter(name)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withHeaders__sjs_js_Array__Lamf_client_model_domain_SecurityScheme = (function(headers) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  var headers$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, headers, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Headers$1;
  $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, headers$1));
  return this
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withHttpSettings__Lamf_client_model_domain_HttpSettings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withHttpSettings__Lamf_plugins_domain_webapi_models_security_HttpSettings();
  $m_Lamf_client_convert_WebApiClientConverters$().HttpSettingsMatcher__Lamf_client_convert_SettingsConverter$HttpSettingsMatcher$();
  return new $c_Lamf_client_model_domain_HttpSettings().init___Lamf_plugins_domain_webapi_models_security_HttpSettings(from)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.description__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Description$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withResponses__sjs_js_Array__Lamf_client_model_domain_SecurityScheme = (function(responses) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ResponseMatcher__Lamf_client_convert_MessageConverter$ResponseMatcher$();
  var responses$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, responses, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Responses$1;
  $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, responses$1));
  return this
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withResponses__sjs_js_Array__O = (function(responses) {
  return this.withResponses__sjs_js_Array__Lamf_client_model_domain_SecurityScheme(responses)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withDisplayName__T__O = (function(displayName) {
  return this.withDisplayName__T__Lamf_client_model_domain_SecurityScheme(displayName)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withName__T__Lamf_client_model_domain_SecurityScheme = (function(name) {
  var this$3 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withQueryString__Lamf_client_model_domain_Shape__Lamf_client_model_domain_SecurityScheme = (function(queryString) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var queryString$1 = queryString.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().QueryString$1;
  $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, queryString$1));
  return this
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.type__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withApiKeySettings__Lamf_client_model_domain_ApiKeySettings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withApiKeySettings__Lamf_plugins_domain_webapi_models_security_ApiKeySettings();
  $m_Lamf_client_convert_WebApiClientConverters$().ApiKeySettingsMatcher__Lamf_client_convert_SettingsConverter$ApiKeySettingsMatcher$();
  return new $c_Lamf_client_model_domain_ApiKeySettings().init___Lamf_plugins_domain_webapi_models_security_ApiKeySettings(from)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$prop$queryParameters__O = (function() {
  return this.queryParameters__sjs_js_Array()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_SecurityScheme()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withHttpApiKeySettings__O = (function() {
  return this.withHttpApiKeySettings__Lamf_client_model_domain_HttpApiKeySettings()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withOAuth2Settings__O = (function() {
  return this.withOAuth2Settings__Lamf_client_model_domain_OAuth2Settings()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.headers__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Headers$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withType__T__O = (function(type) {
  return this.withType__T__Lamf_client_model_domain_SecurityScheme(type)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withOpenIdConnectSettings__O = (function() {
  return this.withOpenIdConnectSettings__Lamf_client_model_domain_OpenIdConnectSettings()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withType__T__Lamf_client_model_domain_SecurityScheme = (function(type) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Type$1;
  $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, type));
  return this
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$prop$headers__O = (function() {
  return this.headers__sjs_js_Array()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_SecurityScheme()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$prop$type__O = (function() {
  return this.type__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$prop$responses__O = (function() {
  return this.responses__sjs_js_Array()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.queryParameters__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().QueryParameters$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withDescription__T__O = (function(description) {
  return this.withDescription__T__Lamf_client_model_domain_SecurityScheme(description)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withOpenIdConnectSettings__Lamf_client_model_domain_OpenIdConnectSettings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withOpenIdConnectSettings__Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings();
  $m_Lamf_client_convert_WebApiClientConverters$().OpenIdConnectSettingsMatcher__Lamf_client_convert_SettingsConverter$OpenIdConnectSettingsMatcher$();
  return new $c_Lamf_client_model_domain_OpenIdConnectSettings().init___Lamf_plugins_domain_webapi_models_security_OpenIdConnectSettings(from)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.queryString__Lamf_client_model_domain_Shape = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_domain_Shape(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().QueryString$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(from)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withQueryString__Lamf_client_model_domain_Shape__O = (function(queryString) {
  return this.withQueryString__Lamf_client_model_domain_Shape__Lamf_client_model_domain_SecurityScheme(queryString)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withApiKeySettings__O = (function() {
  return this.withApiKeySettings__Lamf_client_model_domain_ApiKeySettings()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withDescription__T__Lamf_client_model_domain_SecurityScheme = (function(description) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Description$1;
  $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, description));
  return this
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$prop$description__O = (function() {
  return this.description__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.displayName__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().DisplayName$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.linkCopy__Lamf_client_model_domain_SecurityScheme = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$6 = new $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$6, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().SecuritySchemeMatcher__Lamf_client_convert_SecuritySchemeConverter$SecuritySchemeMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_security_SecurityScheme__Lamf_client_model_domain_SecurityScheme(from)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withResponse__T__O = (function(name) {
  return this.withResponse__T__Lamf_client_model_domain_Response(name)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withHttpApiKeySettings__Lamf_client_model_domain_HttpApiKeySettings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withHttpApiKeySettings__Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings();
  $m_Lamf_client_convert_WebApiClientConverters$().HttpApiKeySettingsMatcher__Lamf_client_convert_SettingsConverter$HttpApiKeySettingsMatcher$();
  return new $c_Lamf_client_model_domain_HttpApiKeySettings().init___Lamf_plugins_domain_webapi_models_security_HttpApiKeySettings(from)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_SecurityScheme(name)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withOAuth2Settings__Lamf_client_model_domain_OAuth2Settings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withOAuth2Settings__Lamf_plugins_domain_webapi_models_security_OAuth2Settings();
  $m_Lamf_client_convert_WebApiClientConverters$().OAuth2SettingsMatcher__Lamf_client_convert_SettingsConverter$OAuth2SettingsMatcher$();
  return new $c_Lamf_client_model_domain_OAuth2Settings().init___Lamf_plugins_domain_webapi_models_security_OAuth2Settings(from)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$prop$queryString__O = (function() {
  return this.queryString__Lamf_client_model_domain_Shape()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.responses__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().Responses$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ResponseMatcher__Lamf_client_convert_MessageConverter$ResponseMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withSettings__Lamf_client_model_domain_Settings__O = (function(settings) {
  return this.withSettings__Lamf_client_model_domain_Settings__Lamf_client_model_domain_SecurityScheme(settings)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withQueryParameters__sjs_js_Array__O = (function(queryParameters) {
  return this.withQueryParameters__sjs_js_Array__Lamf_client_model_domain_SecurityScheme(queryParameters)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withDefaultSettings__Lamf_client_model_domain_Settings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withDefaultSettings__Lamf_plugins_domain_webapi_models_security_Settings();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().SettingsMatcher__Lamf_client_convert_SettingsConverter$SettingsMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_security_Settings__Lamf_client_model_domain_Settings(from)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withDefaultSettings__O = (function() {
  return this.withDefaultSettings__Lamf_client_model_domain_Settings()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$prop$settings__O = (function() {
  return this.settings__Lamf_client_model_domain_Settings()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withQueryParameters__sjs_js_Array__Lamf_client_model_domain_SecurityScheme = (function(queryParameters) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  var queryParameters$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, queryParameters, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$().QueryParameters$1;
  $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, queryParameters$1));
  return this
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withHttpSettings__O = (function() {
  return this.withHttpSettings__Lamf_client_model_domain_HttpSettings()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityScheme.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityScheme.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityScheme.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityScheme.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityScheme.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityScheme.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityScheme.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityScheme.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withOpenIdConnectSettings = (function() {
  return this.$$js$exported$meth$withOpenIdConnectSettings__O()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withHttpSettings = (function() {
  return this.$$js$exported$meth$withHttpSettings__O()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withHttpApiKeySettings = (function() {
  return this.$$js$exported$meth$withHttpApiKeySettings__O()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withApiKeySettings = (function() {
  return this.$$js$exported$meth$withApiKeySettings__O()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withOAuth2Settings = (function() {
  return this.$$js$exported$meth$withOAuth2Settings__O()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withOAuth1Settings = (function() {
  return this.$$js$exported$meth$withOAuth1Settings__O()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withDefaultSettings = (function() {
  return this.$$js$exported$meth$withDefaultSettings__O()
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withResponse = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withResponse__T__O(prep)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withQueryParameter = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withQueryParameter__T__O(prep)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withHeader = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withHeader__T__O(prep)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withQueryString = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withQueryString__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withSettings = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Settings(arg);
  return this.$$js$exported$meth$withSettings__Lamf_client_model_domain_Settings__O(prep)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withResponses = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withResponses__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withQueryParameters = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withQueryParameters__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withHeaders = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withHeaders__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withDescription = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDescription__T__O(prep)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withDisplayName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDisplayName__T__O(prep)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withType__T__O(prep)
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityScheme.prototype, "queryString", {
  "get": (function() {
    return this.$$js$exported$prop$queryString__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityScheme.prototype, "settings", {
  "get": (function() {
    return this.$$js$exported$prop$settings__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityScheme.prototype, "responses", {
  "get": (function() {
    return this.$$js$exported$prop$responses__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityScheme.prototype, "queryParameters", {
  "get": (function() {
    return this.$$js$exported$prop$queryParameters__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityScheme.prototype, "headers", {
  "get": (function() {
    return this.$$js$exported$prop$headers__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityScheme.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityScheme.prototype, "displayName", {
  "get": (function() {
    return this.$$js$exported$prop$displayName__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityScheme.prototype, "type", {
  "get": (function() {
    return this.$$js$exported$prop$type__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_SecurityScheme.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_SecurityScheme(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_SecurityScheme) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.SecurityScheme"))
}
function $isArrayOf_Lamf_client_model_domain_SecurityScheme(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_SecurityScheme)))
}
function $asArrayOf_Lamf_client_model_domain_SecurityScheme(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_SecurityScheme(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.SecurityScheme;", depth))
}
var $d_Lamf_client_model_domain_SecurityScheme = new $TypeData().initClass({
  Lamf_client_model_domain_SecurityScheme: 0
}, false, "amf.client.model.domain.SecurityScheme", {
  Lamf_client_model_domain_SecurityScheme: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_SecurityScheme.prototype.$classData = $d_Lamf_client_model_domain_SecurityScheme;
/** @constructor */
function $c_Lamf_client_model_domain_Tag() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_Tag.prototype = new $h_O();
$c_Lamf_client_model_domain_Tag.prototype.constructor = $c_Lamf_client_model_domain_Tag;
/** @constructor */
function $h_Lamf_client_model_domain_Tag() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_Tag.prototype = $c_Lamf_client_model_domain_Tag.prototype;
$c_Lamf_client_model_domain_Tag.prototype.init___Lamf_plugins_domain_webapi_models_Tag = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_Tag.prototype.productPrefix__T = (function() {
  return "Tag"
});
$c_Lamf_client_model_domain_Tag.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TagModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Tag.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_Tag.prototype.init___Lamf_plugins_domain_webapi_models_Tag.call(this, new $c_Lamf_plugins_domain_webapi_models_Tag().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_Tag.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_Tag.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_Tag.prototype.documentation__Lamf_client_model_domain_CreativeWork = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_plugins_domain_shapes_models_CreativeWork(this$1.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TagModel$().Documentation$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().CreativeWorkMatcher__Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_client_model_domain_CreativeWork(from)
});
$c_Lamf_client_model_domain_Tag.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_Tag.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Tag.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_Tag.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_Tag)) {
    var Tag$1 = $as_Lamf_client_model_domain_Tag(x$1);
    var x = this.$$undinternal$1;
    var x$2 = Tag$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_Tag.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Tag.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_Tag.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_Tag.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_Tag.prototype.withVariables__Lamf_client_model_domain_CreativeWork__Lamf_client_model_domain_Tag = (function(documentation) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().CreativeWorkMatcher__Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$();
  var documentation$1 = documentation.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_TagModel$().Documentation$1;
  $as_Lamf_plugins_domain_webapi_models_Tag($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, documentation$1));
  return this
});
$c_Lamf_client_model_domain_Tag.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_Tag.prototype.description__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TagModel$().Description$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Tag.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_Tag.prototype.$$js$exported$prop$documentation__O = (function() {
  return this.documentation__Lamf_client_model_domain_CreativeWork()
});
$c_Lamf_client_model_domain_Tag.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Tag.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Tag.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_Tag.prototype.$$js$exported$meth$withDescription__T__O = (function(description) {
  return this.withDescription__T__Lamf_client_model_domain_Tag(description)
});
$c_Lamf_client_model_domain_Tag.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_Tag.prototype.withName__T__Lamf_client_model_domain_Tag = (function(name) {
  var this$3 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_Tag.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_Tag.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Tag.prototype.$$js$exported$prop$description__O = (function() {
  return this.description__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Tag.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_Tag.prototype.withDescription__T__Lamf_client_model_domain_Tag = (function(description) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_TagModel$().Description$1;
  $as_Lamf_plugins_domain_webapi_models_Tag($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, description));
  return this
});
$c_Lamf_client_model_domain_Tag.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_Tag.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_Tag(name)
});
$c_Lamf_client_model_domain_Tag.prototype.$$js$exported$meth$withVariables__Lamf_client_model_domain_CreativeWork__O = (function(documentation) {
  return this.withVariables__Lamf_client_model_domain_CreativeWork__Lamf_client_model_domain_Tag(documentation)
});
$c_Lamf_client_model_domain_Tag.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_Tag.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_Tag.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Tag.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Tag.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_Tag.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Tag.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Tag.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Tag.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Tag.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Tag.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Tag.prototype.withVariables = (function(arg) {
  var prep = $as_Lamf_client_model_domain_CreativeWork(arg);
  return this.$$js$exported$meth$withVariables__Lamf_client_model_domain_CreativeWork__O(prep)
});
$c_Lamf_client_model_domain_Tag.prototype.withDescription = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDescription__T__O(prep)
});
$c_Lamf_client_model_domain_Tag.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Tag.prototype, "documentation", {
  "get": (function() {
    return this.$$js$exported$prop$documentation__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Tag.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Tag.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_Tag(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_Tag) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Tag"))
}
function $isArrayOf_Lamf_client_model_domain_Tag(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Tag)))
}
function $asArrayOf_Lamf_client_model_domain_Tag(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Tag(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Tag;", depth))
}
var $d_Lamf_client_model_domain_Tag = new $TypeData().initClass({
  Lamf_client_model_domain_Tag: 0
}, false, "amf.client.model.domain.Tag", {
  Lamf_client_model_domain_Tag: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_Tag.prototype.$classData = $d_Lamf_client_model_domain_Tag;
/** @constructor */
function $c_Lamf_client_model_domain_TemplatedLink() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_TemplatedLink.prototype = new $h_O();
$c_Lamf_client_model_domain_TemplatedLink.prototype.constructor = $c_Lamf_client_model_domain_TemplatedLink;
/** @constructor */
function $h_Lamf_client_model_domain_TemplatedLink() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_TemplatedLink.prototype = $c_Lamf_client_model_domain_TemplatedLink.prototype;
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$prop$operationId__O = (function() {
  return this.operationId__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.mapping__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Mapping$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().IriTemplateMappingConverter__Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.server__Lamf_client_model_domain_Server = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_plugins_domain_webapi_models_Server(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Server$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ServerMatcher__Lamf_client_convert_ServerConverter$ServerMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Server__Lamf_client_model_domain_Server(from)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.withOperationRef__T__Lamf_client_model_domain_TemplatedLink = (function(operationRef) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().OperationRef$1;
  $as_Lamf_plugins_domain_webapi_models_TemplatedLink($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, operationRef));
  return this
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$meth$withServer__Lamf_client_model_domain_Server__O = (function(server) {
  return this.withServer__Lamf_client_model_domain_Server__Lamf_client_model_domain_TemplatedLink(server)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.productPrefix__T = (function() {
  return "TemplatedLink"
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_TemplatedLink.prototype.init___Lamf_plugins_domain_webapi_models_TemplatedLink.call(this, new $c_Lamf_plugins_domain_webapi_models_TemplatedLink().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.withServer__Lamf_client_model_domain_Server__Lamf_client_model_domain_TemplatedLink = (function(server) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().ServerMatcher__Lamf_client_convert_ServerConverter$ServerMatcher$();
  var server$1 = server.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Server$1;
  $as_Lamf_plugins_domain_webapi_models_TemplatedLink($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, server$1));
  return this
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_TemplatedLink)) {
    var TemplatedLink$1 = $as_Lamf_client_model_domain_TemplatedLink(x$1);
    var x = this.$$undinternal$1;
    var x$2 = TemplatedLink$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$prop$server__O = (function() {
  return this.server__Lamf_client_model_domain_Server()
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.withTemplate__T__Lamf_client_model_domain_TemplatedLink = (function(template) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Template$1;
  $as_Lamf_plugins_domain_webapi_models_TemplatedLink($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, template));
  return this
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$meth$withRequestBody__T__O = (function(requestBody) {
  return this.withRequestBody__T__Lamf_client_model_domain_TemplatedLink(requestBody)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.operationId__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().OperationId$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.init___Lamf_plugins_domain_webapi_models_TemplatedLink = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.description__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Description$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$prop$operationRef__O = (function() {
  return this.operationRef__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.withOperationId__T__Lamf_client_model_domain_TemplatedLink = (function(operationId) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().OperationId$1;
  $as_Lamf_plugins_domain_webapi_models_TemplatedLink($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, operationId));
  return this
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.withMapping__sjs_js_Array__Lamf_client_model_domain_TemplatedLink = (function(mapping) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().IriTemplateMappingConverter__Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$();
  var mapping$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, mapping, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Mapping$1;
  $as_Lamf_plugins_domain_webapi_models_TemplatedLink($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, mapping$1));
  return this
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.withName__T__Lamf_client_model_domain_TemplatedLink = (function(name) {
  var this$3 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$meth$withTemplate__T__O = (function(template) {
  return this.withTemplate__T__Lamf_client_model_domain_TemplatedLink(template)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$meth$withDescription__T__O = (function(description) {
  return this.withDescription__T__Lamf_client_model_domain_TemplatedLink(description)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$meth$withOperationRef__T__O = (function(operationRef) {
  return this.withOperationRef__T__Lamf_client_model_domain_TemplatedLink(operationRef)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$meth$withMapping__sjs_js_Array__O = (function(mapping) {
  return this.withMapping__sjs_js_Array__Lamf_client_model_domain_TemplatedLink(mapping)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.withRequestBody__T__Lamf_client_model_domain_TemplatedLink = (function(requestBody) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().RequestBody$1;
  $as_Lamf_plugins_domain_webapi_models_TemplatedLink($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, requestBody));
  return this
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$prop$description__O = (function() {
  return this.description__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$prop$requestBody__O = (function() {
  return this.requestBody__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.operationRef__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().OperationRef$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$prop$mapping__O = (function() {
  return this.mapping__sjs_js_Array()
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_TemplatedLink(name)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$prop$template__O = (function() {
  return this.template__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.template__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Template$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.withDescription__T__Lamf_client_model_domain_TemplatedLink = (function(description) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Description$1;
  $as_Lamf_plugins_domain_webapi_models_TemplatedLink($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, description));
  return this
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$$js$exported$meth$withOperationId__T__O = (function(operationId) {
  return this.withOperationId__T__Lamf_client_model_domain_TemplatedLink(operationId)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.requestBody__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().RequestBody$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_TemplatedLink.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_TemplatedLink.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_TemplatedLink.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_TemplatedLink.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_TemplatedLink.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.withServer = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Server(arg);
  return this.$$js$exported$meth$withServer__Lamf_client_model_domain_Server__O(prep)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.withRequestBody = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withRequestBody__T__O(prep)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.withMapping = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withMapping__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.withOperationRef = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withOperationRef__T__O(prep)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.withOperationId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withOperationId__T__O(prep)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.withTemplate = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withTemplate__T__O(prep)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.withDescription = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDescription__T__O(prep)
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_TemplatedLink.prototype, "server", {
  "get": (function() {
    return this.$$js$exported$prop$server__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_TemplatedLink.prototype, "requestBody", {
  "get": (function() {
    return this.$$js$exported$prop$requestBody__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_TemplatedLink.prototype, "mapping", {
  "get": (function() {
    return this.$$js$exported$prop$mapping__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_TemplatedLink.prototype, "operationRef", {
  "get": (function() {
    return this.$$js$exported$prop$operationRef__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_TemplatedLink.prototype, "operationId", {
  "get": (function() {
    return this.$$js$exported$prop$operationId__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_TemplatedLink.prototype, "template", {
  "get": (function() {
    return this.$$js$exported$prop$template__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_TemplatedLink.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_TemplatedLink.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_TemplatedLink(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_TemplatedLink) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.TemplatedLink"))
}
function $isArrayOf_Lamf_client_model_domain_TemplatedLink(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_TemplatedLink)))
}
function $asArrayOf_Lamf_client_model_domain_TemplatedLink(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_TemplatedLink(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.TemplatedLink;", depth))
}
var $d_Lamf_client_model_domain_TemplatedLink = new $TypeData().initClass({
  Lamf_client_model_domain_TemplatedLink: 0
}, false, "amf.client.model.domain.TemplatedLink", {
  Lamf_client_model_domain_TemplatedLink: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_TemplatedLink.prototype.$classData = $d_Lamf_client_model_domain_TemplatedLink;
/** @constructor */
function $c_Lamf_client_model_domain_UnionNodeMapping() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_UnionNodeMapping.prototype = new $h_O();
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.constructor = $c_Lamf_client_model_domain_UnionNodeMapping;
/** @constructor */
function $h_Lamf_client_model_domain_UnionNodeMapping() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_UnionNodeMapping.prototype = $c_Lamf_client_model_domain_UnionNodeMapping.prototype;
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.productPrefix__T = (function() {
  return "UnionNodeMapping"
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_UnionNodeMapping.prototype.init___Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.call(this, new $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O(this$1.Name$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.linkCopy__Lamf_client_model_domain_UnionNodeMapping = (function() {
  var this$1 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$5 = new $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this$1.id$1;
  return new $c_Lamf_client_model_domain_UnionNodeMapping().init___Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping($as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value)))
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_UnionNodeMapping)) {
    var UnionNodeMapping$1 = $as_Lamf_client_model_domain_UnionNodeMapping(x$1);
    var x = this.$$undinternal$1;
    var x$2 = UnionNodeMapping$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.withTypeDiscriminatorName__T__Lamf_client_model_domain_UnionNodeMapping = (function(name) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().TypeDiscriminatorName$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name);
  return this
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.typeDiscriminator__sjs_js_Dictionary = (function() {
  var this$2 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $f_Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__typeDiscriminator__sci_Map(this$1);
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalImmutableMapOps().init___Lamf_client_convert_CollectionConverter__sci_Map__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.init___Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$meth$typeDiscriminator__O = (function() {
  return this.typeDiscriminator__sjs_js_Dictionary()
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.withTypeDiscriminator__sjs_js_Dictionary__Lamf_client_model_domain_UnionNodeMapping = (function(typesMapping) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  var typesMapping$1 = new $c_Lamf_client_convert_CollectionConverter$ClientMapOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, typesMapping, m).asInternal__sci_Map();
  $f_Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__withTypeDiscriminator__sci_Map__O(this$2, typesMapping$1);
  return this
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$meth$withTypeDiscriminatorName__T__O = (function(name) {
  return this.withTypeDiscriminatorName__T__Lamf_client_model_domain_UnionNodeMapping(name)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$meth$objectRange__O = (function() {
  return this.objectRange__sjs_js_Array()
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.objectRange__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1));
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_UnionNodeMapping()
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.typeDiscriminatorName__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().TypeDiscriminatorName$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$meth$withObjectRange__sjs_js_Array__O = (function(range) {
  return this.withObjectRange__sjs_js_Array__Lamf_client_model_domain_UnionNodeMapping(range)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$meth$withTypeDiscriminator__sjs_js_Dictionary__O = (function(typesMapping) {
  return this.withTypeDiscriminator__sjs_js_Dictionary__Lamf_client_model_domain_UnionNodeMapping(typesMapping)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.withName__T__Lamf_client_model_domain_UnionNodeMapping = (function(name) {
  var this$1 = this.$$undinternal$1;
  var field = this$1.Name$1;
  $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping($as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name)));
  return this
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_UnionNodeMapping()
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.withObjectRange__sjs_js_Array__Lamf_client_model_domain_UnionNodeMapping = (function(range) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  var range$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, range, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, range$1);
  return this
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$meth$typeDiscriminatorName__O = (function() {
  return this.typeDiscriminatorName__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_UnionNodeMapping(name)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_UnionNodeMapping.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_UnionNodeMapping.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_UnionNodeMapping.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_UnionNodeMapping.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_UnionNodeMapping.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_UnionNodeMapping.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_UnionNodeMapping.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_UnionNodeMapping.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.withTypeDiscriminator = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withTypeDiscriminator__sjs_js_Dictionary__O(prep)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.withTypeDiscriminatorName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withTypeDiscriminatorName__T__O(prep)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.withObjectRange = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withObjectRange__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.objectRange = (function() {
  return this.$$js$exported$meth$objectRange__O()
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.typeDiscriminator = (function() {
  return this.$$js$exported$meth$typeDiscriminator__O()
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.typeDiscriminatorName = (function() {
  return this.$$js$exported$meth$typeDiscriminatorName__O()
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_UnionNodeMapping.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_UnionNodeMapping(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_UnionNodeMapping) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.UnionNodeMapping"))
}
function $isArrayOf_Lamf_client_model_domain_UnionNodeMapping(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_UnionNodeMapping)))
}
function $asArrayOf_Lamf_client_model_domain_UnionNodeMapping(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_UnionNodeMapping(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.UnionNodeMapping;", depth))
}
var $d_Lamf_client_model_domain_UnionNodeMapping = new $TypeData().initClass({
  Lamf_client_model_domain_UnionNodeMapping: 0
}, false, "amf.client.model.domain.UnionNodeMapping", {
  Lamf_client_model_domain_UnionNodeMapping: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_UnionNodeMapping.prototype.$classData = $d_Lamf_client_model_domain_UnionNodeMapping;
/** @constructor */
function $c_Lamf_client_model_domain_WebApi() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_WebApi.prototype = new $h_O();
$c_Lamf_client_model_domain_WebApi.prototype.constructor = $c_Lamf_client_model_domain_WebApi;
/** @constructor */
function $h_Lamf_client_model_domain_WebApi() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_WebApi.prototype = $c_Lamf_client_model_domain_WebApi.prototype;
$c_Lamf_client_model_domain_WebApi.prototype.withProvider__Lamf_client_model_domain_Organization__Lamf_client_model_domain_WebApi = (function(provider) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().OrganizationMatcher__Lamf_client_convert_OrganizationConverter$OrganizationMatcher$();
  var provider$1 = provider.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Provider$1;
  $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, provider$1));
  return this
});
$c_Lamf_client_model_domain_WebApi.prototype.withIdentifier__T__Lamf_client_model_domain_WebApi = (function(identifier) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Identifier$1;
  $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, identifier));
  return this
});
$c_Lamf_client_model_domain_WebApi.prototype.withDefaultServer__T__Lamf_client_model_domain_Server = (function(url) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withDefaultServer__T__Lamf_plugins_domain_webapi_models_Server(url);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ServerMatcher__Lamf_client_convert_ServerConverter$ServerMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Server__Lamf_client_model_domain_Server(from)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withLicense__Lamf_client_model_domain_License__O = (function(license) {
  return this.withLicense__Lamf_client_model_domain_License__Lamf_client_model_domain_WebApi(license)
});
$c_Lamf_client_model_domain_WebApi.prototype.productPrefix__T = (function() {
  return "WebApi"
});
$c_Lamf_client_model_domain_WebApi.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_WebApi.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_WebApi.prototype.init___Lamf_plugins_domain_webapi_models_WebApi.call(this, new $c_Lamf_plugins_domain_webapi_models_WebApi().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_WebApi.prototype.withVersion__T__Lamf_client_model_domain_WebApi = (function(version) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Version$1;
  $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, version));
  return this
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$prop$accepts__O = (function() {
  return this.accepts__sjs_js_Array()
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_WebApi.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withSchemes__sjs_js_Array__O = (function(schemes) {
  return this.withSchemes__sjs_js_Array__Lamf_client_model_domain_WebApi(schemes)
});
$c_Lamf_client_model_domain_WebApi.prototype.withSecurity__sjs_js_Array__Lamf_client_model_domain_WebApi = (function(security) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().SecurityRequirementMatcher__Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$();
  var security$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, security, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Security$1;
  $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, security$1));
  return this
});
$c_Lamf_client_model_domain_WebApi.prototype.contentType__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().ContentType$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_WebApi.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_WebApi)) {
    var WebApi$1 = $as_Lamf_client_model_domain_WebApi(x$1);
    var x = this.$$undinternal$1;
    var x$2 = WebApi$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$prop$contentType__O = (function() {
  return this.contentType__sjs_js_Array()
});
$c_Lamf_client_model_domain_WebApi.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withDefaultServer__T__O = (function(url) {
  return this.withDefaultServer__T__Lamf_client_model_domain_Server(url)
});
$c_Lamf_client_model_domain_WebApi.prototype.termsOfService__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().TermsOfService$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withEndPoints__sjs_js_Array__O = (function(endPoints) {
  return this.withEndPoints__sjs_js_Array__Lamf_client_model_domain_WebApi(endPoints)
});
$c_Lamf_client_model_domain_WebApi.prototype.init___Lamf_plugins_domain_webapi_models_WebApi = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_WebApi.prototype.withLicense__Lamf_client_model_domain_License__Lamf_client_model_domain_WebApi = (function(license) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().LicenseMatcher__Lamf_client_convert_LicenseConverter$LicenseMatcher$();
  var license$1 = license.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().License$1;
  $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, license$1));
  return this
});
$c_Lamf_client_model_domain_WebApi.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_WebApi.prototype.accepts__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Accepts$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_WebApi.prototype.withDocumentationUrl__T__Lamf_client_model_domain_CreativeWork = (function(url) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withDocumentationUrl__T__Lamf_plugins_domain_shapes_models_CreativeWork(url);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().CreativeWorkMatcher__Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_client_model_domain_CreativeWork(from)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withProvider__Lamf_client_model_domain_Organization__O = (function(provider) {
  return this.withProvider__Lamf_client_model_domain_Organization__Lamf_client_model_domain_WebApi(provider)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$prop$servers__O = (function() {
  return this.servers__sjs_js_Array()
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_WebApi.prototype.description__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Description$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_WebApi.prototype.withServers__sjs_js_Array__Lamf_client_model_domain_WebApi = (function(servers) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ServerMatcher__Lamf_client_convert_ServerConverter$ServerMatcher$();
  var servers$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, servers, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Servers$1;
  $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, servers$1));
  return this
});
$c_Lamf_client_model_domain_WebApi.prototype.identifier__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Identifier$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_WebApi.prototype.withEndPoint__T__Lamf_client_model_domain_EndPoint = (function(path) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withEndPoint__T__Lamf_plugins_domain_webapi_models_EndPoint(path);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().EndPointMatcher__Lamf_client_convert_EndPointConverter$EndPointMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_client_model_domain_EndPoint(from)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$prop$version__O = (function() {
  return this.version__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$prop$termsOfService__O = (function() {
  return this.termsOfService__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_WebApi.prototype.withDescription__T__Lamf_client_model_domain_WebApi = (function(description) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Description$1;
  $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, description));
  return this
});
$c_Lamf_client_model_domain_WebApi.prototype.servers__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Servers$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ServerMatcher__Lamf_client_convert_ServerConverter$ServerMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withContentType__sjs_js_Array__O = (function(contentType) {
  return this.withContentType__sjs_js_Array__Lamf_client_model_domain_WebApi(contentType)
});
$c_Lamf_client_model_domain_WebApi.prototype.withServer__T__Lamf_client_model_domain_Server = (function(url) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withServer__T__Lamf_plugins_domain_webapi_models_Server(url);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ServerMatcher__Lamf_client_convert_ServerConverter$ServerMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Server__Lamf_client_model_domain_Server(from)
});
$c_Lamf_client_model_domain_WebApi.prototype.withAccepts__sjs_js_Array__Lamf_client_model_domain_WebApi = (function(accepts) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  var accepts$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, accepts, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Accepts$1;
  $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, accepts$1));
  return this
});
$c_Lamf_client_model_domain_WebApi.prototype.withSchemes__sjs_js_Array__Lamf_client_model_domain_WebApi = (function(schemes) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  var schemes$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, schemes, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Schemes$1;
  $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, schemes$1));
  return this
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withServer__T__O = (function(url) {
  return this.withServer__T__Lamf_client_model_domain_Server(url)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withSecurity__sjs_js_Array__O = (function(security) {
  return this.withSecurity__sjs_js_Array__Lamf_client_model_domain_WebApi(security)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$prop$license__O = (function() {
  return this.license__Lamf_client_model_domain_License()
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$prop$schemes__O = (function() {
  return this.schemes__sjs_js_Array()
});
$c_Lamf_client_model_domain_WebApi.prototype.schemes__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Schemes$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withDescription__T__O = (function(description) {
  return this.withDescription__T__Lamf_client_model_domain_WebApi(description)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withDocumentation__sjs_js_Array__O = (function(documentations) {
  return this.withDocumentation__sjs_js_Array__Lamf_client_model_domain_WebApi(documentations)
});
$c_Lamf_client_model_domain_WebApi.prototype.endPoints__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().EndPointMatcher__Lamf_client_convert_EndPointConverter$EndPointMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withVersion__T__O = (function(version) {
  return this.withVersion__T__Lamf_client_model_domain_WebApi(version)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_WebApi.prototype.withContentType__sjs_js_Array__Lamf_client_model_domain_WebApi = (function(contentType) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  var contentType$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, contentType, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().ContentType$1;
  $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, contentType$1));
  return this
});
$c_Lamf_client_model_domain_WebApi.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_WebApi.prototype.version__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Version$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$prop$security__O = (function() {
  return this.security__sjs_js_Array()
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$prop$description__O = (function() {
  return this.description__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withDocumentationTitle__T__O = (function(title) {
  return this.withDocumentationTitle__T__Lamf_client_model_domain_CreativeWork(title)
});
$c_Lamf_client_model_domain_WebApi.prototype.withDocumentation__sjs_js_Array__Lamf_client_model_domain_WebApi = (function(documentations) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().CreativeWorkMatcher__Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$();
  var documentations$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, documentations, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Documentations$1;
  $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, documentations$1));
  return this
});
$c_Lamf_client_model_domain_WebApi.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_WebApi.prototype.license__Lamf_client_model_domain_License = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_plugins_domain_webapi_models_License(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().License$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().LicenseMatcher__Lamf_client_convert_LicenseConverter$LicenseMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_License__Lamf_client_model_domain_License(from)
});
$c_Lamf_client_model_domain_WebApi.prototype.provider__Lamf_client_model_domain_Organization = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_plugins_domain_webapi_models_Organization(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Provider$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().OrganizationMatcher__Lamf_client_convert_OrganizationConverter$OrganizationMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Organization__Lamf_client_model_domain_Organization(from)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withTermsOfService__T__O = (function(terms) {
  return this.withTermsOfService__T__Lamf_client_model_domain_WebApi(terms)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withEndPoint__T__O = (function(path) {
  return this.withEndPoint__T__Lamf_client_model_domain_EndPoint(path)
});
$c_Lamf_client_model_domain_WebApi.prototype.withDocumentationTitle__T__Lamf_client_model_domain_CreativeWork = (function(title) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withDocumentationTitle__T__Lamf_plugins_domain_shapes_models_CreativeWork(title);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().CreativeWorkMatcher__Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_client_model_domain_CreativeWork(from)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withAccepts__sjs_js_Array__O = (function(accepts) {
  return this.withAccepts__sjs_js_Array__Lamf_client_model_domain_WebApi(accepts)
});
$c_Lamf_client_model_domain_WebApi.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_WebApi.prototype.withTermsOfService__T__Lamf_client_model_domain_WebApi = (function(terms) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().TermsOfService$1;
  $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, terms));
  return this
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_WebApi(name)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$prop$sourceVendor__O = (function() {
  return this.$$undinternal$1.sourceVendor__s_Option()
});
$c_Lamf_client_model_domain_WebApi.prototype.withEndPoints__sjs_js_Array__Lamf_client_model_domain_WebApi = (function(endPoints) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().EndPointMatcher__Lamf_client_convert_EndPointConverter$EndPointMatcher$();
  var endPoints$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, endPoints, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1;
  $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, endPoints$1));
  return this
});
$c_Lamf_client_model_domain_WebApi.prototype.withName__T__Lamf_client_model_domain_WebApi = (function(name) {
  var this$3 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$prop$endPoints__O = (function() {
  return this.endPoints__sjs_js_Array()
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withIdentifier__T__O = (function(identifier) {
  return this.withIdentifier__T__Lamf_client_model_domain_WebApi(identifier)
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$prop$provider__O = (function() {
  return this.provider__Lamf_client_model_domain_Organization()
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withServers__sjs_js_Array__O = (function(servers) {
  return this.withServers__sjs_js_Array__Lamf_client_model_domain_WebApi(servers)
});
$c_Lamf_client_model_domain_WebApi.prototype.security__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Security$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().SecurityRequirementMatcher__Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$prop$documentations__O = (function() {
  return this.documentations__sjs_js_Array()
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$prop$identifier__O = (function() {
  return this.identifier__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_WebApi.prototype.$$js$exported$meth$withDocumentationUrl__T__O = (function(url) {
  return this.withDocumentationUrl__T__Lamf_client_model_domain_CreativeWork(url)
});
$c_Lamf_client_model_domain_WebApi.prototype.documentations__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Documentations$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().CreativeWorkMatcher__Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_WebApi.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_WebApi.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_WebApi.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_WebApi.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_WebApi.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_WebApi.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_WebApi.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_WebApi.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebApi.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebApi.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebApi.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebApi.prototype, "sourceVendor", {
  "get": (function() {
    return this.$$js$exported$prop$sourceVendor__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_WebApi.prototype.withDefaultServer = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDefaultServer__T__O(prep)
});
$c_Lamf_client_model_domain_WebApi.prototype.withServer = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withServer__T__O(prep)
});
$c_Lamf_client_model_domain_WebApi.prototype.withEndPoint = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withEndPoint__T__O(prep)
});
$c_Lamf_client_model_domain_WebApi.prototype.withDocumentationUrl = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDocumentationUrl__T__O(prep)
});
$c_Lamf_client_model_domain_WebApi.prototype.withDocumentationTitle = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDocumentationTitle__T__O(prep)
});
$c_Lamf_client_model_domain_WebApi.prototype.withSecurity = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withSecurity__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_WebApi.prototype.withServers = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withServers__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_WebApi.prototype.withDocumentation = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withDocumentation__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_WebApi.prototype.withLicense = (function(arg) {
  var prep = $as_Lamf_client_model_domain_License(arg);
  return this.$$js$exported$meth$withLicense__Lamf_client_model_domain_License__O(prep)
});
$c_Lamf_client_model_domain_WebApi.prototype.withProvider = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Organization(arg);
  return this.$$js$exported$meth$withProvider__Lamf_client_model_domain_Organization__O(prep)
});
$c_Lamf_client_model_domain_WebApi.prototype.withTermsOfService = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withTermsOfService__T__O(prep)
});
$c_Lamf_client_model_domain_WebApi.prototype.withVersion = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withVersion__T__O(prep)
});
$c_Lamf_client_model_domain_WebApi.prototype.withContentType = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withContentType__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_WebApi.prototype.withAccepts = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withAccepts__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_WebApi.prototype.withEndPoints = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withEndPoints__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_WebApi.prototype.withSchemes = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withSchemes__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_WebApi.prototype.withIdentifier = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withIdentifier__T__O(prep)
});
$c_Lamf_client_model_domain_WebApi.prototype.withDescription = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDescription__T__O(prep)
});
$c_Lamf_client_model_domain_WebApi.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_WebApi.prototype, "security", {
  "get": (function() {
    return this.$$js$exported$prop$security__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebApi.prototype, "servers", {
  "get": (function() {
    return this.$$js$exported$prop$servers__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebApi.prototype, "documentations", {
  "get": (function() {
    return this.$$js$exported$prop$documentations__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebApi.prototype, "license", {
  "get": (function() {
    return this.$$js$exported$prop$license__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebApi.prototype, "provider", {
  "get": (function() {
    return this.$$js$exported$prop$provider__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebApi.prototype, "termsOfService", {
  "get": (function() {
    return this.$$js$exported$prop$termsOfService__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebApi.prototype, "version", {
  "get": (function() {
    return this.$$js$exported$prop$version__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebApi.prototype, "contentType", {
  "get": (function() {
    return this.$$js$exported$prop$contentType__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebApi.prototype, "accepts", {
  "get": (function() {
    return this.$$js$exported$prop$accepts__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebApi.prototype, "endPoints", {
  "get": (function() {
    return this.$$js$exported$prop$endPoints__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebApi.prototype, "schemes", {
  "get": (function() {
    return this.$$js$exported$prop$schemes__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebApi.prototype, "identifier", {
  "get": (function() {
    return this.$$js$exported$prop$identifier__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebApi.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebApi.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_WebApi(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_WebApi) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.WebApi"))
}
function $isArrayOf_Lamf_client_model_domain_WebApi(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_WebApi)))
}
function $asArrayOf_Lamf_client_model_domain_WebApi(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_WebApi(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.WebApi;", depth))
}
var $d_Lamf_client_model_domain_WebApi = new $TypeData().initClass({
  Lamf_client_model_domain_WebApi: 0
}, false, "amf.client.model.domain.WebApi", {
  Lamf_client_model_domain_WebApi: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_WebApi.prototype.$classData = $d_Lamf_client_model_domain_WebApi;
/** @constructor */
function $c_Lamf_core_annotations_TrackedElement() {
  $c_O.call(this);
  this.parents$1 = null;
  this.name$1 = null;
  this.value$1 = null;
  this.uris$1 = null
}
$c_Lamf_core_annotations_TrackedElement.prototype = new $h_O();
$c_Lamf_core_annotations_TrackedElement.prototype.constructor = $c_Lamf_core_annotations_TrackedElement;
/** @constructor */
function $h_Lamf_core_annotations_TrackedElement() {
  /*<skip>*/
}
$h_Lamf_core_annotations_TrackedElement.prototype = $c_Lamf_core_annotations_TrackedElement.prototype;
$c_Lamf_core_annotations_TrackedElement.prototype.productPrefix__T = (function() {
  return "TrackedElement"
});
$c_Lamf_core_annotations_TrackedElement.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_annotations_TrackedElement.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_annotations_TrackedElement)) {
    var TrackedElement$1 = $as_Lamf_core_annotations_TrackedElement(x$1);
    var x = this.parents$1;
    var x$2 = TrackedElement$1.parents$1;
    return ((x === null) ? (x$2 === null) : $f_sc_GenSetLike__equals__O__Z(x, x$2))
  } else {
    return false
  }
});
$c_Lamf_core_annotations_TrackedElement.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.parents$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_annotations_TrackedElement.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_annotations_TrackedElement.prototype.name__T = (function() {
  return this.name$1
});
$c_Lamf_core_annotations_TrackedElement.prototype.value__T = (function() {
  return this.value$1
});
$c_Lamf_core_annotations_TrackedElement.prototype.init___sci_Set = (function(parents) {
  this.parents$1 = parents;
  this.name$1 = "tracked-element";
  this.value$1 = $f_sc_TraversableOnce__mkString__T__T__T__T(parents, "", ",", "");
  this.uris$1 = $f_sc_SetLike__toSeq__sc_Seq(parents);
  return this
});
$c_Lamf_core_annotations_TrackedElement.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_annotations_TrackedElement.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_annotations_TrackedElement.prototype.shorten__F1__Lamf_core_model_domain_Annotation = (function(fn) {
  var this$2 = this.parents$1;
  var this$1 = $m_sci_Set$();
  var bf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return new $c_Lamf_core_annotations_TrackedElement().init___sci_Set($as_sci_Set($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this$2, fn, bf)))
});
function $as_Lamf_core_annotations_TrackedElement(obj) {
  return (((obj instanceof $c_Lamf_core_annotations_TrackedElement) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.annotations.TrackedElement"))
}
function $isArrayOf_Lamf_core_annotations_TrackedElement(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_annotations_TrackedElement)))
}
function $asArrayOf_Lamf_core_annotations_TrackedElement(obj, depth) {
  return (($isArrayOf_Lamf_core_annotations_TrackedElement(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.annotations.TrackedElement;", depth))
}
var $d_Lamf_core_annotations_TrackedElement = new $TypeData().initClass({
  Lamf_core_annotations_TrackedElement: 0
}, false, "amf.core.annotations.TrackedElement", {
  Lamf_core_annotations_TrackedElement: 1,
  O: 1,
  Lamf_core_model_domain_EternalSerializedAnnotation: 1,
  Lamf_core_model_domain_PerpetualAnnotation: 1,
  Lamf_core_model_domain_Annotation: 1,
  Lamf_core_model_domain_SerializableAnnotation: 1,
  Lamf_core_model_domain_UriAnnotation: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_annotations_TrackedElement.prototype.$classData = $d_Lamf_core_annotations_TrackedElement;
/** @constructor */
function $c_Lamf_core_model_domain_extensions_CustomDomainProperty() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype = new $h_O();
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.constructor = $c_Lamf_core_model_domain_extensions_CustomDomainProperty;
/** @constructor */
function $h_Lamf_core_model_domain_extensions_CustomDomainProperty() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype = $c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype;
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.productPrefix__T = (function() {
  return "CustomDomainProperty"
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return this.adopted__T__sc_Seq__Lamf_core_model_domain_extensions_CustomDomainProperty(parent, cycle)
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_model_domain_extensions_CustomDomainProperty)) {
    var CustomDomainProperty$1 = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(x$1);
    var x = this.fields$1;
    var x$2 = CustomDomainProperty$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = CustomDomainProperty$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_core_model_domain_extensions_CustomDomainProperty().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$()
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Name$1)).option$1;
  if (this$1.isEmpty__Z()) {
    var this$5 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$1 = $as_T(arg1);
    var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(x$1);
    var this$4 = this$3.platform$1;
    var url = this$3.str$1;
    var this$5 = new $c_s_Some().init___O($f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
  };
  return $as_T((this$5.isEmpty__Z() ? "" : this$5.get__O()))
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_extensions_CustomDomainProperty = (function(parent, cycle) {
  if ($m_s_Option$().apply__O__s_Option(this.id$1).isEmpty__Z()) {
    if (($uI(parent.indexOf("#")) !== (-1))) {
      var str = this.componentId__T();
      var this$5 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
      var this$6 = this$5.platform$1;
      var url = this$5.str$1;
      var value = ((parent + "/") + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$6, url));
      return $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value))
    } else {
      var str$1 = this.componentId__T();
      var this$8 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str$1);
      var this$9 = this$8.platform$1;
      var url$1 = this$8.str$1;
      var value$1 = ((parent + "#") + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$9, url$1));
      return $as_Lamf_core_model_domain_extensions_CustomDomainProperty($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value$1))
    }
  } else {
    return this
  }
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_core_model_domain_extensions_CustomDomainProperty().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_core_metamodel_domain_extensions_CustomDomainPropertyModel$().Name$1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_core_model_domain_extensions_CustomDomainProperty(obj) {
  return (((obj instanceof $c_Lamf_core_model_domain_extensions_CustomDomainProperty) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.extensions.CustomDomainProperty"))
}
function $isArrayOf_Lamf_core_model_domain_extensions_CustomDomainProperty(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_extensions_CustomDomainProperty)))
}
function $asArrayOf_Lamf_core_model_domain_extensions_CustomDomainProperty(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_extensions_CustomDomainProperty(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.extensions.CustomDomainProperty;", depth))
}
var $d_Lamf_core_model_domain_extensions_CustomDomainProperty = new $TypeData().initClass({
  Lamf_core_model_domain_extensions_CustomDomainProperty: 0
}, false, "amf.core.model.domain.extensions.CustomDomainProperty", {
  Lamf_core_model_domain_extensions_CustomDomainProperty: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_domain_extensions_CustomDomainProperty.prototype.$classData = $d_Lamf_core_model_domain_extensions_CustomDomainProperty;
/** @constructor */
function $c_Lamf_core_parser_Fields$AnyFieldImpl() {
  $c_O.call(this);
  this.option$1 = null;
  this.annotations$1 = null;
  this.field$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_core_parser_Fields$AnyFieldImpl.prototype = new $h_O();
$c_Lamf_core_parser_Fields$AnyFieldImpl.prototype.constructor = $c_Lamf_core_parser_Fields$AnyFieldImpl;
/** @constructor */
function $h_Lamf_core_parser_Fields$AnyFieldImpl() {
  /*<skip>*/
}
$h_Lamf_core_parser_Fields$AnyFieldImpl.prototype = $c_Lamf_core_parser_Fields$AnyFieldImpl.prototype;
$c_Lamf_core_parser_Fields$AnyFieldImpl.prototype.productPrefix__T = (function() {
  return "AnyFieldImpl"
});
$c_Lamf_core_parser_Fields$AnyFieldImpl.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_core_parser_Fields$AnyFieldImpl.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_core_parser_Fields$AnyFieldImpl) && ($as_Lamf_core_parser_Fields$AnyFieldImpl(x$1).$$outer$1 === this.$$outer$1))) {
    var AnyFieldImpl$1 = $as_Lamf_core_parser_Fields$AnyFieldImpl(x$1);
    var x = this.option$1;
    var x$2 = AnyFieldImpl$1.option$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.annotations$1;
      var x$4 = AnyFieldImpl$1.annotations$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.field$1;
      var x$6 = AnyFieldImpl$1.field$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_parser_Fields$AnyFieldImpl.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.option$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    case 2: {
      return this.field$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_parser_Fields$AnyFieldImpl.prototype.toString__T = (function() {
  return $f_Lamf_core_model_ValueField__toString__T(this)
});
$c_Lamf_core_parser_Fields$AnyFieldImpl.prototype.init___Lamf_core_parser_Fields__Lamf_core_model_domain_AmfScalar__Lamf_core_metamodel_Field = (function($$outer, s, f) {
  $c_Lamf_core_parser_Fields$AnyFieldImpl.prototype.init___Lamf_core_parser_Fields__s_Option__Lamf_core_parser_Annotations__Lamf_core_metamodel_Field.call(this, $$outer, $m_s_Option$().apply__O__s_Option(s.value$1), s.annotations$1, f);
  return this
});
$c_Lamf_core_parser_Fields$AnyFieldImpl.prototype.option__s_Option = (function() {
  return this.option$1
});
$c_Lamf_core_parser_Fields$AnyFieldImpl.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_parser_Fields$AnyFieldImpl.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_parser_Fields$AnyFieldImpl.prototype.init___Lamf_core_parser_Fields__s_Option__Lamf_core_parser_Annotations__Lamf_core_metamodel_Field = (function($$outer, option, annotations, field) {
  this.option$1 = option;
  this.annotations$1 = annotations;
  this.field$1 = field;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
function $as_Lamf_core_parser_Fields$AnyFieldImpl(obj) {
  return (((obj instanceof $c_Lamf_core_parser_Fields$AnyFieldImpl) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.Fields$AnyFieldImpl"))
}
function $isArrayOf_Lamf_core_parser_Fields$AnyFieldImpl(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_Fields$AnyFieldImpl)))
}
function $asArrayOf_Lamf_core_parser_Fields$AnyFieldImpl(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_Fields$AnyFieldImpl(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.Fields$AnyFieldImpl;", depth))
}
var $d_Lamf_core_parser_Fields$AnyFieldImpl = new $TypeData().initClass({
  Lamf_core_parser_Fields$AnyFieldImpl: 0
}, false, "amf.core.parser.Fields$AnyFieldImpl", {
  Lamf_core_parser_Fields$AnyFieldImpl: 1,
  O: 1,
  Lamf_core_model_AnyField: 1,
  Lamf_core_model_BaseField: 1,
  Lamf_core_model_Annotable: 1,
  Lamf_core_model_ValueField: 1,
  Lamf_core_parser_Fields$FieldRemover: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_Fields$AnyFieldImpl.prototype.$classData = $d_Lamf_core_parser_Fields$AnyFieldImpl;
/** @constructor */
function $c_Lamf_core_parser_Fields$StrFieldImpl() {
  $c_O.call(this);
  this.option$1 = null;
  this.annotations$1 = null;
  this.field$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_core_parser_Fields$StrFieldImpl.prototype = new $h_O();
$c_Lamf_core_parser_Fields$StrFieldImpl.prototype.constructor = $c_Lamf_core_parser_Fields$StrFieldImpl;
/** @constructor */
function $h_Lamf_core_parser_Fields$StrFieldImpl() {
  /*<skip>*/
}
$h_Lamf_core_parser_Fields$StrFieldImpl.prototype = $c_Lamf_core_parser_Fields$StrFieldImpl.prototype;
$c_Lamf_core_parser_Fields$StrFieldImpl.prototype.productPrefix__T = (function() {
  return "StrFieldImpl"
});
$c_Lamf_core_parser_Fields$StrFieldImpl.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_core_parser_Fields$StrFieldImpl.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_core_parser_Fields$StrFieldImpl) && ($as_Lamf_core_parser_Fields$StrFieldImpl(x$1).$$outer$1 === this.$$outer$1))) {
    var StrFieldImpl$1 = $as_Lamf_core_parser_Fields$StrFieldImpl(x$1);
    var x = this.option$1;
    var x$2 = StrFieldImpl$1.option$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.annotations$1;
      var x$4 = StrFieldImpl$1.annotations$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.field$1;
      var x$6 = StrFieldImpl$1.field$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_parser_Fields$StrFieldImpl.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.option$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    case 2: {
      return this.field$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_parser_Fields$StrFieldImpl.prototype.toString__T = (function() {
  return $f_Lamf_core_model_ValueField__toString__T(this)
});
$c_Lamf_core_parser_Fields$StrFieldImpl.prototype.init___Lamf_core_parser_Fields__Lamf_core_model_domain_AmfScalar__Lamf_core_metamodel_Field = (function($$outer, s, f) {
  var this$1 = $m_s_Option$().apply__O__s_Option(s.value$1);
  if (this$1.isEmpty__Z()) {
    var jsx$1 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var jsx$1 = new $c_s_Some().init___O($as_T(arg1))
  };
  $c_Lamf_core_parser_Fields$StrFieldImpl.prototype.init___Lamf_core_parser_Fields__s_Option__Lamf_core_parser_Annotations__Lamf_core_metamodel_Field.call(this, $$outer, jsx$1, s.annotations$1, f);
  return this
});
$c_Lamf_core_parser_Fields$StrFieldImpl.prototype.option__s_Option = (function() {
  return this.option$1
});
$c_Lamf_core_parser_Fields$StrFieldImpl.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_parser_Fields$StrFieldImpl.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_parser_Fields$StrFieldImpl.prototype.init___Lamf_core_parser_Fields__s_Option__Lamf_core_parser_Annotations__Lamf_core_metamodel_Field = (function($$outer, option, annotations, field) {
  this.option$1 = option;
  this.annotations$1 = annotations;
  this.field$1 = field;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
function $as_Lamf_core_parser_Fields$StrFieldImpl(obj) {
  return (((obj instanceof $c_Lamf_core_parser_Fields$StrFieldImpl) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.Fields$StrFieldImpl"))
}
function $isArrayOf_Lamf_core_parser_Fields$StrFieldImpl(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_Fields$StrFieldImpl)))
}
function $asArrayOf_Lamf_core_parser_Fields$StrFieldImpl(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_Fields$StrFieldImpl(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.Fields$StrFieldImpl;", depth))
}
var $d_Lamf_core_parser_Fields$StrFieldImpl = new $TypeData().initClass({
  Lamf_core_parser_Fields$StrFieldImpl: 0
}, false, "amf.core.parser.Fields$StrFieldImpl", {
  Lamf_core_parser_Fields$StrFieldImpl: 1,
  O: 1,
  Lamf_core_model_StrField: 1,
  Lamf_core_model_BaseField: 1,
  Lamf_core_model_Annotable: 1,
  Lamf_core_model_ValueField: 1,
  Lamf_core_parser_Fields$FieldRemover: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_Fields$StrFieldImpl.prototype.$classData = $d_Lamf_core_parser_Fields$StrFieldImpl;
/** @constructor */
function $c_Lamf_core_parser_errorhandler_WarningOnlyHandler() {
  $c_Lamf_core_parser_errorhandler_RuntimeWrapperErrorHandler.call(this);
  this.parent$2 = null;
  this.warningRegister$2 = false;
  this.parserRun$2 = 0
}
$c_Lamf_core_parser_errorhandler_WarningOnlyHandler.prototype = new $h_Lamf_core_parser_errorhandler_RuntimeWrapperErrorHandler();
$c_Lamf_core_parser_errorhandler_WarningOnlyHandler.prototype.constructor = $c_Lamf_core_parser_errorhandler_WarningOnlyHandler;
/** @constructor */
function $h_Lamf_core_parser_errorhandler_WarningOnlyHandler() {
  /*<skip>*/
}
$h_Lamf_core_parser_errorhandler_WarningOnlyHandler.prototype = $c_Lamf_core_parser_errorhandler_WarningOnlyHandler.prototype;
$c_Lamf_core_parser_errorhandler_WarningOnlyHandler.prototype.handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V = (function(location, e) {
  var specification = $m_Lamf_plugins_features_validation_CoreValidations$().SyamlWarning$1;
  var message = e.s$1;
  var property = $m_s_None$();
  $f_Lamf_core_errorhandling_ErrorHandler__warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this, specification, "", property, message, location);
  this.warningRegister$2 = true
});
$c_Lamf_core_parser_errorhandler_WarningOnlyHandler.prototype.productPrefix__T = (function() {
  return "WarningOnlyHandler"
});
$c_Lamf_core_parser_errorhandler_WarningOnlyHandler.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_core_parser_errorhandler_WarningOnlyHandler.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_parser_errorhandler_WarningOnlyHandler)) {
    var WarningOnlyHandler$1 = $as_Lamf_core_parser_errorhandler_WarningOnlyHandler(x$1);
    var x = this.parent$2;
    var x$2 = WarningOnlyHandler$1.parent$2;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_core_parser_errorhandler_WarningOnlyHandler.prototype.init___Lamf_core_parser_errorhandler_ParserErrorHandler = (function(parent) {
  this.parent$2 = parent;
  $c_Lamf_core_parser_errorhandler_RuntimeWrapperErrorHandler.prototype.init___Lamf_core_parser_errorhandler_ParserErrorHandler.call(this, parent);
  this.warningRegister$2 = false;
  this.parserRun$2 = parent.parserRun__I();
  return this
});
$c_Lamf_core_parser_errorhandler_WarningOnlyHandler.prototype.handle__Lorg_yaml_model_YError__O__O = (function(error, defaultValue) {
  var specification = $m_Lamf_plugins_features_validation_CoreValidations$().SyamlWarning$1;
  var message = error.error__T();
  var ast = $f_Lamf_core_parser_errorhandler_ParserErrorHandler__part__Lorg_yaml_model_YError__Lorg_yaml_model_YPart(this, error);
  var property = $m_s_None$();
  var location = ast.location$1;
  $f_Lamf_core_errorhandling_ErrorHandler__warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this, specification, "", property, message, location);
  this.warningRegister$2 = true;
  return defaultValue
});
$c_Lamf_core_parser_errorhandler_WarningOnlyHandler.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.parent$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_parser_errorhandler_WarningOnlyHandler.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_parser_errorhandler_WarningOnlyHandler.prototype.parserRun__I = (function() {
  return this.parserRun$2
});
$c_Lamf_core_parser_errorhandler_WarningOnlyHandler.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_parser_errorhandler_WarningOnlyHandler.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_core_parser_errorhandler_WarningOnlyHandler(obj) {
  return (((obj instanceof $c_Lamf_core_parser_errorhandler_WarningOnlyHandler) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.errorhandler.WarningOnlyHandler"))
}
function $isArrayOf_Lamf_core_parser_errorhandler_WarningOnlyHandler(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_errorhandler_WarningOnlyHandler)))
}
function $asArrayOf_Lamf_core_parser_errorhandler_WarningOnlyHandler(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_errorhandler_WarningOnlyHandler(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.errorhandler.WarningOnlyHandler;", depth))
}
var $d_Lamf_core_parser_errorhandler_WarningOnlyHandler = new $TypeData().initClass({
  Lamf_core_parser_errorhandler_WarningOnlyHandler: 0
}, false, "amf.core.parser.errorhandler.WarningOnlyHandler", {
  Lamf_core_parser_errorhandler_WarningOnlyHandler: 1,
  Lamf_core_parser_errorhandler_RuntimeWrapperErrorHandler: 1,
  O: 1,
  Lamf_core_parser_errorhandler_ParserErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  Lorg_yaml_model_ParseErrorHandler: 1,
  Lamf_core_errorhandling_ErrorHandler: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_errorhandler_WarningOnlyHandler.prototype.$classData = $d_Lamf_core_parser_errorhandler_WarningOnlyHandler;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_AMLPlugin$() {
  $c_Lamf_client_plugins_AMFDocumentPlugin.call(this);
  this.registry$2 = null;
  this.ID$2 = null;
  this.vendors$2 = null;
  this.allowRecursiveReferences$2 = false;
  this.platform$2 = null
}
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype = new $h_Lamf_client_plugins_AMFDocumentPlugin();
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_AMLPlugin$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_AMLPlugin$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype = $c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype;
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype.init__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  return $f_Lamf_plugins_document_vocabularies_AMLPlugin__init__s_concurrent_ExecutionContext__s_concurrent_Future(this, executionContext)
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype.init___ = (function() {
  $c_Lamf_client_plugins_AMFDocumentPlugin.prototype.init___.call(this);
  $n_Lamf_plugins_document_vocabularies_AMLPlugin$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$2 = this$1.platform$1;
  $f_Lamf_plugins_document_vocabularies_AMLPlugin__$$init$__V(this);
  return this
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype.modelEntitiesResolver__s_Option = (function() {
  return new $c_s_Some().init___O(this.registry$2)
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype.unparseAsYDocument__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__s_Option = (function(unit, renderOptions, shapeRenderOptions) {
  return $f_Lamf_plugins_document_vocabularies_AMLPlugin__unparseAsYDocument__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__s_Option(this, unit, renderOptions, shapeRenderOptions)
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype.canUnparse__Lamf_core_model_document_BaseUnit__Z = (function(unit) {
  return $f_Lamf_plugins_document_vocabularies_AMLPlugin__canUnparse__Lamf_core_model_document_BaseUnit__Z(this, unit)
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype.parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option = (function(document, parentContext, platform, options) {
  return $f_Lamf_plugins_document_vocabularies_AMLPlugin__parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option(this, document, parentContext, platform, options)
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype.modelEntities__sc_Seq = (function() {
  return $f_Lamf_plugins_document_vocabularies_AMLPlugin__modelEntities__sc_Seq(this)
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype.documentSyntaxes__sc_Seq = (function() {
  return $f_Lamf_plugins_document_vocabularies_AMLPlugin__documentSyntaxes__sc_Seq(this)
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype.referenceHandler__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_ReferenceHandler = (function(eh) {
  return new $c_Lamf_plugins_document_vocabularies_parser_common_SyntaxExtensionsReferenceHandler().init___Lamf_plugins_document_vocabularies_DialectsRegistry__Lamf_core_errorhandling_ErrorHandler(this.registry$2, eh)
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype.vendors__sc_Seq = (function() {
  return this.vendors$2
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype.ID__T = (function() {
  return this.ID$2
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype.domainValidationProfiles__Lamf_core_remote_Platform__sci_Map = (function(platform) {
  return $f_Lamf_plugins_document_vocabularies_AMLPlugin__domainValidationProfiles__Lamf_core_remote_Platform__sci_Map(this, platform)
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype.dependencies__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype.validationRequest__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_validation_EffectiveValidations__Lamf_core_remote_Platform__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future = (function(baseUnit, profile, validations, platform, env, resolved, executionEnv) {
  return $f_Lamf_plugins_document_vocabularies_AMLPlugin__validationRequest__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_validation_EffectiveValidations__Lamf_core_remote_Platform__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(this, baseUnit, profile, validations, platform, env, resolved, executionEnv)
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype.apply__Lamf_plugins_document_vocabularies_AMLPlugin = (function() {
  var this$1 = $m_Lamf_core_registries_AMFPluginsRegistry$();
  var ID = this.ID$2;
  var this$2 = this$1.documentPluginIDRegistry$1.get__O__s_Option(ID);
  var pf = new $c_Lamf_plugins_document_vocabularies_AMLPlugin$$anonfun$apply$1().init___();
  if ((!this$2.isEmpty__Z())) {
    var this$3 = new $c_s_PartialFunction$Lifted().init___s_PartialFunction(pf);
    var v1 = this$2.get__O();
    var this$4 = this$3.apply__O__s_Option(v1)
  } else {
    var this$4 = $m_s_None$()
  };
  return $as_Lamf_plugins_document_vocabularies_AMLPlugin((this$4.isEmpty__Z() ? $m_Lamf_plugins_document_vocabularies_AMLPlugin$() : this$4.get__O()))
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype.canParse__Lamf_core_Root__Z = (function(document) {
  return $f_Lamf_plugins_document_vocabularies_AMLPlugin__canParse__Lamf_core_Root__Z(this, document)
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype.serializableAnnotations__sci_Map = (function() {
  return $f_Lamf_plugins_document_vocabularies_AMLPlugin__serializableAnnotations__sci_Map(this)
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype.allowRecursiveReferences__Z = (function() {
  return this.allowRecursiveReferences$2
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_errorhandling_ErrorHandler__T__Lamf_core_model_document_BaseUnit = (function(unit, errorHandler, pipelineId) {
  return $f_Lamf_plugins_document_vocabularies_AMLPlugin__resolve__Lamf_core_model_document_BaseUnit__Lamf_core_errorhandling_ErrorHandler__T__Lamf_core_model_document_BaseUnit(this, unit, errorHandler, pipelineId)
});
var $d_Lamf_plugins_document_vocabularies_AMLPlugin$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_AMLPlugin$: 0
}, false, "amf.plugins.document.vocabularies.AMLPlugin$", {
  Lamf_plugins_document_vocabularies_AMLPlugin$: 1,
  Lamf_client_plugins_AMFDocumentPlugin: 1,
  O: 1,
  Lamf_client_plugins_AMFPlugin: 1,
  Lamf_plugins_document_vocabularies_AMLPlugin: 1,
  Lamf_plugins_document_vocabularies_plugin_headers_RamlHeaderExtractor: 1,
  Lamf_plugins_document_vocabularies_plugin_headers_JsonHeaderExtractor: 1,
  Lamf_client_plugins_AMFValidationPlugin: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_validation_ValidationResultProcessor: 1,
  Lamf_plugins_document_vocabularies_plugin_headers_KeyPropertyHeaderExtractor: 1
});
$c_Lamf_plugins_document_vocabularies_AMLPlugin$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_AMLPlugin$;
var $n_Lamf_plugins_document_vocabularies_AMLPlugin$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_AMLPlugin$() {
  if ((!$n_Lamf_plugins_document_vocabularies_AMLPlugin$)) {
    $n_Lamf_plugins_document_vocabularies_AMLPlugin$ = new $c_Lamf_plugins_document_vocabularies_AMLPlugin$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_AMLPlugin$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$() {
  $c_O.call(this);
  this.DefinedBy$1 = null;
  this.GraphDependencies$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.Extends$1 = null;
  this.Externals$1 = null;
  this.Declares$1 = null;
  this.Encodes$1 = null;
  this.Root$1 = null;
  this.Location$1 = null;
  this.References$1 = null;
  this.Usage$1 = null;
  this.DescribedBy$1 = null;
  this.ModelVersion$1 = null;
  this.doc$1 = null
}
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.constructor = $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype = $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype;
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_document_BaseUnitModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_FragmentModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_ModuleModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_DocumentModel__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModel__$$init$__V(this);
  $f_Lamf_core_metamodel_document_ExtensionLikeModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  this.DefinedBy$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "definedBy"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true);
  var jsx$2 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Iri$());
  var this$6 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  this.GraphDependencies$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$6, "graphDependencies"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true);
  var this$11 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
  var x$15 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$11, "DialectInstancePatch");
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  var x$14 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "DocumentExtension");
  var this$15 = $m_Lamf_core_metamodel_document_BaseUnitModel$().type$1;
  var this$16 = new $c_sci_$colon$colon().init___O__sci_List(x$14, this$15);
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$15, this$16);
  var x$19 = this.DefinedBy$1;
  var x$18 = this.GraphDependencies$1;
  var x$17 = this.Externals$1;
  var x$16 = this.Extends$1;
  var this$17 = $m_Lamf_core_metamodel_document_FragmentModel$().fields$1;
  var this$18 = new $c_sci_$colon$colon().init___O__sci_List(x$16, this$17);
  var this$19 = new $c_sci_$colon$colon().init___O__sci_List(x$17, this$18);
  var this$20 = new $c_sci_$colon$colon().init___O__sci_List(x$18, this$19);
  this.fields$1 = new $c_sci_$colon$colon().init___O__sci_List(x$19, this$20);
  return this
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.amf$core$metamodel$document$DocumentModel$$undsetter$und$fields$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$References$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.References$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$DescribedBy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DescribedBy$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  this.doc$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.Extends__Lamf_core_metamodel_Field = (function() {
  return this.Extends$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.amf$core$metamodel$document$ExtensionLikeModel$$undsetter$und$Extends$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Extends$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.Declares__Lamf_core_metamodel_Field = (function() {
  return this.Declares$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$ModelVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ModelVersion$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.amf$core$metamodel$document$ModuleModel$$undsetter$und$Declares$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Declares$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.Encodes__Lamf_core_metamodel_Field = (function() {
  return this.Encodes$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.amf$core$metamodel$document$ExtensionLikeModel$$undsetter$und$fields$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.amf$core$metamodel$document$FragmentModel$$undsetter$und$Encodes$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Encodes$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Usage$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Usage$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.amf$core$metamodel$document$DocumentModel$$undsetter$und$type$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.amf$core$metamodel$document$BaseUnitModel$$undsetter$und$Root$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Root$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.amf$plugins$document$vocabularies$metamodel$document$ExternalContextModel$$undsetter$und$Externals$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Externals$1 = x$1
});
var $d_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$ = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$: 0
}, false, "amf.plugins.document.vocabularies.metamodel.document.DialectInstancePatchModel$", {
  Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$: 1,
  O: 1,
  Lamf_core_metamodel_document_DocumentModel: 1,
  Lamf_core_metamodel_document_FragmentModel: 1,
  Lamf_core_metamodel_document_BaseUnitModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_document_ModuleModel: 1,
  Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModel: 1,
  Lamf_core_metamodel_document_ExtensionLikeModel: 1
});
$c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$.prototype.$classData = $d_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$;
var $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$ = (void 0);
function $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$() {
  if ((!$n_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$)) {
    $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$ = new $c_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$().init___()
  };
  return $n_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectContext() {
  $c_Lamf_core_parser_ParserContext.call(this);
  this.wrapped$2 = null;
  this.ds$2 = null;
  this.recursiveDeclarations$2 = null;
  this.declarations$2 = null;
  this.dialect$2 = null;
  this.library$2 = null;
  this.nodeMapping$2 = null;
  this.fragment$2 = null;
  this.propertyMapping$2 = null;
  this.documentsMapping$2 = null;
  this.documentsMappingOptions$2 = null
}
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectContext.prototype = new $h_Lamf_core_parser_ParserContext();
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectContext.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectContext;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_dialects_DialectContext.prototype = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectContext.prototype;
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectContext.prototype.findInRecursiveShapes__T__s_Option = (function(key) {
  var qname = $m_Lamf_core_utils_package$QName$().apply__T__Lamf_core_utils_package$QName(key);
  if (qname.isQualified$1) {
    var x1 = this.recursiveDeclarations$2.get__O__s_Option(qname.qualification$1);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var recursiveUnit = $as_Lamf_core_model_document_RecursiveUnit(x2.value$2);
      var x = recursiveUnit.id$1;
      var this$2 = new $c_sci_StringOps().init___T(x);
      var unitId = $f_sci_StringLike__stripSuffix__T__T(this$2, "/recursive");
      return new $c_s_Some().init___O(((unitId + "#/declarations/") + qname.name$1))
    } else {
      return $m_s_None$()
    }
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectContext.prototype.init___Lamf_core_parser_ParserContext__s_Option = (function(wrapped, ds) {
  this.wrapped$2 = wrapped;
  this.ds$2 = ds;
  var jsx$4 = wrapped.rootContextDocument$1;
  var jsx$3 = wrapped.refs$1;
  var jsx$2 = wrapped.futureDeclarations$1;
  var jsx$1 = wrapped.eh$1;
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$5 = new $c_scm_ListBuffer().init___();
  $c_Lamf_core_parser_ParserContext.prototype.init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext.call(this, jsx$4, jsx$3, jsx$2, jsx$1, new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$5.toList__sci_List()));
  $f_Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax__$$init$__V(this);
  this.recursiveDeclarations$2 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  if (ds.isEmpty__Z()) {
    var x$1 = this.eh$1;
    var x$2 = this.futureDeclarations$1;
    var x$3 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var jsx$5 = new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations().init___sci_Map__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations(x$3, x$1, x$2)
  } else {
    var jsx$5 = ds.get__O()
  };
  this.declarations$2 = $as_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations(jsx$5);
  return this
});
var $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectContext = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_dialects_DialectContext: 0
}, false, "amf.plugins.document.vocabularies.parser.dialects.DialectContext", {
  Lamf_plugins_document_vocabularies_parser_dialects_DialectContext: 1,
  Lamf_core_parser_ParserContext: 1,
  O: 1,
  Lorg_yaml_model_ParseErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_plugins_document_vocabularies_parser_dialects_DialectSyntax: 1,
  Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter: 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectContext.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectContext;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext() {
  $c_Lamf_core_parser_ParserContext.call(this);
  this.wrapped$2 = null;
  this.ds$2 = null;
  this.imported$2 = null;
  this.pendingLocal$2 = null;
  this.declarations$2 = null;
  this.vocabulary$2 = null;
  this.classTerm$2 = null;
  this.propertyTerm$2 = null
}
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext.prototype = new $h_Lamf_core_parser_ParserContext();
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext.prototype = $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext.prototype;
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext.prototype.resolveClassTermAlias__T__T__Lorg_yaml_model_YPart__Z__s_Option = (function(base, classTermAlias, where, strictLocal) {
  if (($uI(classTermAlias.indexOf(".")) !== (-1))) {
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(classTermAlias, "\\.", 0);
    var this$6 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    var prefix = $as_T($f_sc_IndexedSeqOptimized__head__O(this$6));
    var xs$1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(classTermAlias, "\\.", 0);
    var this$9 = new $c_scm_ArrayOps$ofRef().init___AO(xs$1);
    var value = $as_T($f_sc_IndexedSeqOptimized__last__O(this$9));
    var x1 = this.declarations$2.externals$2.get__O__s_Option(prefix);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var external = $as_Lamf_plugins_document_vocabularies_model_domain_External(x2.value$2);
      var this$10 = $as_Lamf_core_model_StrField(external.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().Base$1));
      var this$11 = this$10.option$1;
      return new $c_s_Some().init___O((("" + $as_T((this$11.isEmpty__Z() ? null : this$11.get__O()))) + value))
    } else {
      var x = $m_s_None$();
      if ((x === x1)) {
        var x1$2 = this.declarations$2.libraries$1.get__O__s_Option(prefix);
        if ((x1$2 instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(x1$2);
          var vocab = $as_Lamf_core_parser_Declarations(x2$2.value$2);
          if ((vocab instanceof $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations)) {
            var x3 = $as_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations(vocab);
            return x3.getClassTermId__T__s_Option(value)
          }
        };
        return $m_s_None$()
      } else {
        throw new $c_s_MatchError().init___O(x1)
      }
    }
  } else {
    var local = (("" + base) + classTermAlias);
    var x1$3 = this.declarations$2.getClassTermId__T__s_Option(classTermAlias);
    if ((!(x1$3 instanceof $c_s_Some))) {
      var x$3 = $m_s_None$();
      if ((x$3 === x1$3)) {
        if (strictLocal) {
          var jsx$3 = this.pendingLocal$2;
          var jsx$2 = $m_sc_Seq$();
          var array = [new $c_T4().init___O__O__O__O(local, classTermAlias, where, false)];
          var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
          var this$14 = $m_sc_Seq$();
          this.pendingLocal$2 = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$14.ReusableCBFInstance$2))
        }
      } else {
        throw new $c_s_MatchError().init___O(x1$3)
      }
    };
    return new $c_s_Some().init___O(local)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext.prototype.register__T__Lamf_plugins_document_vocabularies_model_domain_ClassTerm__V = (function(alias, classTerm) {
  if ((!this.isDuplicated__p2__T__Z(classTerm.id$1))) {
    this.pendingLocal$2 = $as_sc_Seq(this.pendingLocal$2.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, classTerm$1) {
      return (function(x$2$2) {
        var x$2 = $as_T4(x$2$2);
        var x = x$2.$$und1$1;
        var x$3 = classTerm$1.id$1;
        return (!((x === null) ? (x$3 === null) : $objectEquals(x, x$3)))
      })
    })(this, classTerm))));
    this.declarations$2.classTerms$2 = this.declarations$2.classTerms$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(alias, classTerm))
  }
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext.prototype.terms__sc_Seq = (function() {
  var this$1 = this.declarations$2.classTerms$2;
  var this$2 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$1);
  var jsx$2 = this$2.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream();
  var this$3 = this.declarations$2.propertyTerms$2;
  var this$4 = new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this$3);
  var jsx$1 = this$4.$$outer$3.valuesIterator__sc_Iterator().toStream__sci_Stream();
  var this$5 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext.prototype.registerVocabulary__T__Lamf_plugins_document_vocabularies_model_document_Vocabulary__V = (function(alias, vocabulary) {
  this.imported$2 = this.imported$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(alias, vocabulary))
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext.prototype.register__T__Lamf_plugins_document_vocabularies_model_domain_PropertyTerm__V = (function(alias, propertyTerm) {
  if ((!this.isDuplicated__p2__T__Z(propertyTerm.id$1))) {
    this.pendingLocal$2 = $as_sc_Seq(this.pendingLocal$2.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, propertyTerm$1) {
      return (function(x$3$2) {
        var x$3 = $as_T4(x$3$2);
        var x = x$3.$$und1$1;
        var x$2 = propertyTerm$1.id$1;
        return (!((x === null) ? (x$2 === null) : $objectEquals(x, x$2)))
      })
    })(this, propertyTerm))));
    this.declarations$2.propertyTerms$2 = this.declarations$2.propertyTerms$2.$$plus__T2__sci_Map(new $c_T2().init___O__O(alias, propertyTerm))
  }
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext.prototype.resolvePropertyTermAlias__T__T__Lorg_yaml_model_YPart__Z__s_Option = (function(base, propertyTermAlias, where, strictLocal) {
  if (($uI(propertyTermAlias.indexOf(".")) !== (-1))) {
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(propertyTermAlias, "\\.", 0);
    var this$6 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    var prefix = $as_T($f_sc_IndexedSeqOptimized__head__O(this$6));
    var xs$1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(propertyTermAlias, "\\.", 0);
    var this$9 = new $c_scm_ArrayOps$ofRef().init___AO(xs$1);
    var value = $as_T($f_sc_IndexedSeqOptimized__last__O(this$9));
    var x1 = this.declarations$2.externals$2.get__O__s_Option(prefix);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var external = $as_Lamf_plugins_document_vocabularies_model_domain_External(x2.value$2);
      var this$10 = $as_Lamf_core_model_StrField(external.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_ExternalModel$().Base$1));
      var this$11 = this$10.option$1;
      return new $c_s_Some().init___O((("" + $as_T((this$11.isEmpty__Z() ? null : this$11.get__O()))) + value))
    } else {
      var x = $m_s_None$();
      if ((x === x1)) {
        var x1$2 = this.declarations$2.libraries$1.get__O__s_Option(prefix);
        if ((x1$2 instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(x1$2);
          var vocab = $as_Lamf_core_parser_Declarations(x2$2.value$2);
          if ((vocab instanceof $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations)) {
            var x3 = $as_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations(vocab);
            return x3.getPropertyTermId__T__s_Option(value)
          }
        };
        return $m_s_None$()
      } else {
        throw new $c_s_MatchError().init___O(x1)
      }
    }
  } else {
    var local = (("" + base) + propertyTermAlias);
    var x1$3 = this.declarations$2.getPropertyTermId__T__s_Option(propertyTermAlias);
    if ((!(x1$3 instanceof $c_s_Some))) {
      var x$3 = $m_s_None$();
      if ((x$3 === x1$3)) {
        if (strictLocal) {
          var jsx$3 = this.pendingLocal$2;
          var jsx$2 = $m_sc_Seq$();
          var array = [new $c_T4().init___O__O__O__O(local, propertyTermAlias, where, true)];
          var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
          var this$14 = $m_sc_Seq$();
          this.pendingLocal$2 = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$14.ReusableCBFInstance$2))
        }
      } else {
        throw new $c_s_MatchError().init___O(x1$3)
      }
    };
    return new $c_s_Some().init___O(local)
  }
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext.prototype.init___Lamf_core_parser_ParserContext__s_Option = (function(wrapped, ds) {
  this.wrapped$2 = wrapped;
  this.ds$2 = ds;
  var jsx$4 = wrapped.rootContextDocument$1;
  var jsx$3 = wrapped.refs$1;
  var jsx$2 = wrapped.futureDeclarations$1;
  var jsx$1 = wrapped.eh$1;
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$5 = new $c_scm_ListBuffer().init___();
  $c_Lamf_core_parser_ParserContext.prototype.init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext.call(this, jsx$4, jsx$3, jsx$2, jsx$1, new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$5.toList__sci_List()));
  $f_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularySyntax__$$init$__V(this);
  this.imported$2 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  this.pendingLocal$2 = $m_sci_Nil$();
  if (ds.isEmpty__Z()) {
    var x$1 = this.eh$1;
    var x$2 = this.futureDeclarations$1;
    var x$3 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$4 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$5 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$6 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$7 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var jsx$5 = new $c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations().init___sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations(x$3, x$4, x$5, x$6, x$7, x$1, x$2)
  } else {
    var jsx$5 = ds.get__O()
  };
  this.declarations$2 = $as_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyDeclarations(jsx$5);
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext.prototype.isDuplicated__p2__T__Z = (function(iri) {
  var isDuplicate = this.terms__sc_Seq().exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, iri$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_model_domain_DomainElement(x$1$2);
      return (x$1.id__T() === iri$1)
    })
  })(this, iri)));
  if (isDuplicate) {
    var this$1 = this.eh$1;
    var specification = $m_Lamf_validation_DialectValidations$().DuplicateTerm$1;
    var message = (("'" + iri) + "' term cannot be both a class term and property term");
    var property = $m_s_None$();
    var lexical = $m_s_None$();
    var location = $m_s_None$();
    this$1.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, iri, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location)
  };
  return isDuplicate
});
var $d_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext: 0
}, false, "amf.plugins.document.vocabularies.parser.vocabularies.VocabularyContext", {
  Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext: 1,
  Lamf_core_parser_ParserContext: 1,
  O: 1,
  Lorg_yaml_model_ParseErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularySyntax: 1,
  Lamf_plugins_document_vocabularies_parser_common_SyntaxErrorReporter: 1
});
$c_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_vocabularies_VocabularyContext;
/** @constructor */
function $c_Lamf_plugins_document_webapi_Async20Plugin$() {
  $c_Lamf_client_plugins_AMFDocumentPlugin.call(this);
  this.validationProfile$2 = null;
  this.vendors$2 = null;
  this.ID$2 = null;
  this.allowRecursiveReferences$2 = false;
  this.aggregatedReport$2 = null;
  this.defaultValidationProfiles$2 = null;
  this.platform$2 = null
}
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype = new $h_Lamf_client_plugins_AMFDocumentPlugin();
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.constructor = $c_Lamf_plugins_document_webapi_Async20Plugin$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_Async20Plugin$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_Async20Plugin$.prototype = $c_Lamf_plugins_document_webapi_Async20Plugin$.prototype;
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.init__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  return $m_s_concurrent_Future$().successful__O__s_concurrent_Future(this)
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.init___ = (function() {
  $c_Lamf_client_plugins_AMFDocumentPlugin.prototype.init___.call(this);
  $n_Lamf_plugins_document_webapi_Async20Plugin$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$2 = this$1.platform$1;
  $f_Lamf_plugins_document_webapi_validation_WebApiValidations__$$init$__V(this);
  $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__$$init$__V(this);
  $f_Lamf_plugins_document_webapi_AsyncPlugin__$$init$__V(this);
  this.validationProfile$2 = $m_Lamf_Async20Profile$();
  return this
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.unparseAsYDocument__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__s_Option = (function(unit, renderOptions, shapeRenderOptions) {
  if ((unit instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(unit);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentEmitter().init___Lamf_core_model_document_BaseUnit__Lamf_plugins_document_webapi_contexts_emitter_async_AsyncSpecEmitterContext(x2, new $c_Lamf_plugins_document_webapi_contexts_emitter_async_Async20SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion(renderOptions.eh$1, $m_Lamf_plugins_document_webapi_contexts_emitter_async_AsyncRefEmitter$(), new $c_Lamf_core_emitter_ShapeRenderOptions().init___(), $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft7SchemaVersion$())).emitDocument__Lorg_yaml_model_YDocument())
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.context__T__sc_Seq__Lamf_core_client_ParsingOptions__Lamf_core_parser_ParserContext__s_Option__Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext = (function(loc, refs, options, wrapped, ds) {
  var x$6 = $as_scm_Set($m_scm_HashSet$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  return new $c_Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__scm_Set__Lamf_core_client_ParsingOptions(loc, refs, wrapped, ds, x$6, options)
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.canUnparse__Lamf_core_model_document_BaseUnit__Z = (function(unit) {
  if ((unit instanceof $c_Lamf_core_model_document_Document)) {
    var x2 = $as_Lamf_core_model_document_Document(unit);
    return (x2.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)
  } else if ((unit instanceof $c_Lamf_core_model_document_Module)) {
    var x3 = $as_Lamf_core_model_document_Module(unit);
    return $as_sc_Seq(x3.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_ModuleModel$().Declares$1)).exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_model_domain_DomainElement(x0$1$2);
        return false
      })
    })(this)))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option = (function(document, parentContext, platform, options) {
  return $f_Lamf_plugins_document_webapi_AsyncPlugin__parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option(this, document, parentContext, platform, options)
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.vendor__Lamf_core_remote_Vendor = (function() {
  return $m_Lamf_core_remote_AsyncApi20$()
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.modelEntities__sc_Seq = (function() {
  return $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__modelEntities__sc_Seq(this)
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.amf$plugins$document$webapi$validation$WebApiValidations$$undsetter$und$defaultValidationProfiles$und$eq__sci_Map__V = (function(x$1) {
  this.defaultValidationProfiles$2 = x$1
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.documentSyntaxes__sc_Seq = (function() {
  return $f_Lamf_plugins_document_webapi_AsyncPlugin__documentSyntaxes__sc_Seq(this)
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.referenceHandler__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_ReferenceHandler = (function(eh) {
  return new $c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler().init___T__Lamf_plugins_document_webapi_BaseWebApiPlugin(this.ID$2, this)
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.vendors__sc_Seq = (function() {
  return this.vendors$2
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.ID__T = (function() {
  return this.ID$2
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.amf$plugins$document$webapi$BaseWebApiPlugin$$undsetter$und$allowRecursiveReferences$und$eq__Z__V = (function(x$1) {
  this.allowRecursiveReferences$2 = x$1
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.domainValidationProfiles__Lamf_core_remote_Platform__sci_Map = (function(platform) {
  var this$1 = this.defaultValidationProfiles$2;
  var p = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(k$2) {
      var k = $as_T(k$2);
      return ((k === $m_Lamf_Async20Profile$().p$1) || (k === $m_Lamf_AsyncProfile$().p$1))
    })
  })(this));
  return new $c_sci_MapLike$$anon$1().init___sci_MapLike__F1(this$1, p)
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.validationProfile__Lamf_ProfileName = (function() {
  return this.validationProfile$2
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.aggregatedReport$und$eq__sci_List__V = (function(x$1) {
  this.aggregatedReport$2 = x$1
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.dependencies__sc_Seq = (function() {
  return $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__dependencies__sc_Seq(this)
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.validationRequest__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_validation_EffectiveValidations__Lamf_core_remote_Platform__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future = (function(baseUnit, profile, validations, platform, env, resolved, executionEnv) {
  return $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__validationRequest__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_validation_EffectiveValidations__Lamf_core_remote_Platform__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(this, baseUnit, profile, validations, platform, env, resolved, executionEnv)
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.canParse__Lamf_core_Root__Z = (function(root) {
  return $m_Lamf_plugins_document_webapi_parser_AsyncHeader$().apply__Lamf_core_Root__s_Option(root).contains__O__Z($m_Lamf_plugins_document_webapi_parser_AsyncHeader$Async20Header$())
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.serializableAnnotations__sci_Map = (function() {
  return $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__serializableAnnotations__sci_Map(this)
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.allowRecursiveReferences__Z = (function() {
  return this.allowRecursiveReferences$2
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.amf$plugins$document$webapi$BaseWebApiPlugin$$undsetter$und$ID$und$eq__T__V = (function(x$1) {
  this.ID$2 = x$1
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_errorhandling_ErrorHandler__T__Lamf_core_model_document_BaseUnit = (function(unit, errorHandler, pipelineId) {
  return (($m_Lamf_core_resolution_pipelines_ResolutionPipeline$().DEFAULT$undPIPELINE$1 === pipelineId) ? new $c_Lamf_plugins_document_webapi_resolution_pipelines_Async20ResolutionPipeline().init___Lamf_core_errorhandling_ErrorHandler(errorHandler).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit) : (($m_Lamf_core_resolution_pipelines_ResolutionPipeline$().EDITING$undPIPELINE$1 === pipelineId) ? new $c_Lamf_plugins_document_webapi_resolution_pipelines_Async20EditingPipeline().init___Lamf_core_errorhandling_ErrorHandler__Z(errorHandler, true).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit) : (($m_Lamf_core_resolution_pipelines_ResolutionPipeline$().CACHE$undPIPELINE$1 === pipelineId) ? new $c_Lamf_plugins_document_webapi_resolution_pipelines_Async20EditingPipeline().init___Lamf_core_errorhandling_ErrorHandler__Z(errorHandler, false).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit) : $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__resolve__Lamf_core_model_document_BaseUnit__Lamf_core_errorhandling_ErrorHandler__T__Lamf_core_model_document_BaseUnit(this, unit, errorHandler, pipelineId))))
});
var $d_Lamf_plugins_document_webapi_Async20Plugin$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_Async20Plugin$: 0
}, false, "amf.plugins.document.webapi.Async20Plugin$", {
  Lamf_plugins_document_webapi_Async20Plugin$: 1,
  Lamf_client_plugins_AMFDocumentPlugin: 1,
  O: 1,
  Lamf_client_plugins_AMFPlugin: 1,
  Lamf_plugins_document_webapi_AsyncPlugin: 1,
  Lamf_plugins_document_webapi_OasLikePlugin: 1,
  Lamf_plugins_document_webapi_BaseWebApiPlugin: 1,
  Lamf_client_plugins_AMFValidationPlugin: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_validation_WebApiValidations: 1,
  Lamf_core_validation_ValidationResultProcessor: 1
});
$c_Lamf_plugins_document_webapi_Async20Plugin$.prototype.$classData = $d_Lamf_plugins_document_webapi_Async20Plugin$;
var $n_Lamf_plugins_document_webapi_Async20Plugin$ = (void 0);
function $m_Lamf_plugins_document_webapi_Async20Plugin$() {
  if ((!$n_Lamf_plugins_document_webapi_Async20Plugin$)) {
    $n_Lamf_plugins_document_webapi_Async20Plugin$ = new $c_Lamf_plugins_document_webapi_Async20Plugin$().init___()
  };
  return $n_Lamf_plugins_document_webapi_Async20Plugin$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_Oas20Plugin$() {
  $c_Lamf_client_plugins_AMFDocumentPlugin.call(this);
  this.validationProfile$2 = null;
  this.vendors$2 = null;
  this.ID$2 = null;
  this.allowRecursiveReferences$2 = false;
  this.aggregatedReport$2 = null;
  this.defaultValidationProfiles$2 = null;
  this.platform$2 = null
}
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype = new $h_Lamf_client_plugins_AMFDocumentPlugin();
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.constructor = $c_Lamf_plugins_document_webapi_Oas20Plugin$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_Oas20Plugin$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_Oas20Plugin$.prototype = $c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype;
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.amf$plugins$document$webapi$OasPlugin$$undsetter$und$vendors$und$eq__sc_Seq__V = (function(x$1) {
  this.vendors$2 = x$1
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.context__T__sc_Seq__Lamf_core_client_ParsingOptions__Lamf_core_parser_ParserContext__s_Option__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(loc, refs, options, wrapped, ds) {
  return new $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__Lamf_core_client_ParsingOptions(loc, refs, wrapped, ds, options)
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.init__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  return $m_s_concurrent_Future$().successful__O__s_concurrent_Future(this)
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.init___ = (function() {
  $c_Lamf_client_plugins_AMFDocumentPlugin.prototype.init___.call(this);
  $n_Lamf_plugins_document_webapi_Oas20Plugin$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$2 = this$1.platform$1;
  $f_Lamf_plugins_document_webapi_validation_WebApiValidations__$$init$__V(this);
  $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__$$init$__V(this);
  $f_Lamf_plugins_document_webapi_OasPlugin__$$init$__V(this);
  this.validationProfile$2 = $m_Lamf_Oas20Profile$();
  return this
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.unparseAsYDocument__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__s_Option = (function(unit, renderOptions, shapeRenderOptions) {
  if ((unit instanceof $c_Lamf_core_model_document_Module)) {
    var x2 = $as_Lamf_core_model_document_Module(unit);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas20ModuleEmitter().init___Lamf_core_model_document_Module__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(x2, new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(renderOptions.eh$1, $m_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$(), new $c_Lamf_core_emitter_ShapeRenderOptions().init___())).emitModule__Lorg_yaml_model_YDocument())
  } else if ((unit instanceof $c_Lamf_core_model_document_Document)) {
    var x3 = $as_Lamf_core_model_document_Document(unit);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentEmitter().init___Lamf_core_model_document_BaseUnit__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(x3, new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(renderOptions.eh$1, $m_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$(), new $c_Lamf_core_emitter_ShapeRenderOptions().init___())).emitDocument__Lorg_yaml_model_YDocument())
  } else if ((unit instanceof $c_Lamf_core_model_document_ExternalFragment)) {
    var x4 = $as_Lamf_core_model_document_ExternalFragment(unit);
    var jsx$1 = $m_Lorg_yaml_model_YNode$();
    var this$7 = $as_Lamf_core_model_domain_ExternalDomainElement($as_Lamf_core_model_domain_DomainElement(x4.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)));
    var this$8 = $as_Lamf_core_model_StrField(this$7.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1));
    var this$9 = this$8.option$1;
    var x$1 = jsx$1.apply__T__Lorg_yaml_model_YNode($as_T((this$9.isEmpty__Z() ? null : this$9.get__O())));
    return new $c_s_Some().init___O($m_Lorg_yaml_model_YDocument$().apply__Lorg_yaml_model_YNode__T__Lorg_yaml_model_YDocument(x$1, ""))
  } else if ($is_Lamf_core_model_document_Fragment(unit)) {
    var x5 = $as_Lamf_core_model_document_Fragment(unit);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter().init___Lamf_core_model_document_Fragment__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(x5, new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(renderOptions.eh$1, $m_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$(), new $c_Lamf_core_emitter_ShapeRenderOptions().init___())).emitFragment__Lorg_yaml_model_YDocument())
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.canUnparse__Lamf_core_model_document_BaseUnit__Z = (function(unit) {
  if ((unit instanceof $c_Lamf_plugins_document_webapi_model_Overlay)) {
    return true
  } else if ((unit instanceof $c_Lamf_plugins_document_webapi_model_Extension)) {
    return true
  } else if ((unit instanceof $c_Lamf_core_model_document_Document)) {
    var x4 = $as_Lamf_core_model_document_Document(unit);
    return (x4.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)
  } else if ((unit instanceof $c_Lamf_core_model_document_Module)) {
    var x5 = $as_Lamf_core_model_document_Module(unit);
    return $as_sc_Seq(x5.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_ModuleModel$().Declares$1)).exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_model_domain_DomainElement(x0$1$2);
        return (x0$1 !== null)
      })
    })(this)))
  } else {
    return $is_Lamf_core_model_document_Fragment(unit)
  }
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option = (function(document, parentContext, platform, options) {
  return $f_Lamf_plugins_document_webapi_OasPlugin__parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option(this, document, parentContext, platform, options)
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.vendor__Lamf_core_remote_Vendor = (function() {
  return $m_Lamf_core_remote_Oas20$()
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.modelEntities__sc_Seq = (function() {
  return $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__modelEntities__sc_Seq(this)
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.amf$plugins$document$webapi$validation$WebApiValidations$$undsetter$und$defaultValidationProfiles$und$eq__sci_Map__V = (function(x$1) {
  this.defaultValidationProfiles$2 = x$1
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.documentSyntaxes__sc_Seq = (function() {
  return $f_Lamf_plugins_document_webapi_OasPlugin__documentSyntaxes__sc_Seq(this)
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.referenceHandler__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_ReferenceHandler = (function(eh) {
  return new $c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler().init___T__Lamf_plugins_document_webapi_BaseWebApiPlugin(this.ID$2, this)
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.vendors__sc_Seq = (function() {
  return this.vendors$2
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.ID__T = (function() {
  return this.ID$2
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.amf$plugins$document$webapi$BaseWebApiPlugin$$undsetter$und$allowRecursiveReferences$und$eq__Z__V = (function(x$1) {
  this.allowRecursiveReferences$2 = x$1
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.domainValidationProfiles__Lamf_core_remote_Platform__sci_Map = (function(platform) {
  var this$1 = this.defaultValidationProfiles$2;
  var p = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(k$2) {
      var k = $as_T(k$2);
      return ((k === $m_Lamf_Oas20Profile$().p$1) || (k === $m_Lamf_OasProfile$().p$1))
    })
  })(this));
  return new $c_sci_MapLike$$anon$1().init___sci_MapLike__F1(this$1, p)
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.validationProfile__Lamf_ProfileName = (function() {
  return this.validationProfile$2
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.aggregatedReport$und$eq__sci_List__V = (function(x$1) {
  this.aggregatedReport$2 = x$1
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.dependencies__sc_Seq = (function() {
  return $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__dependencies__sc_Seq(this)
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.validationRequest__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_validation_EffectiveValidations__Lamf_core_remote_Platform__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future = (function(baseUnit, profile, validations, platform, env, resolved, executionEnv) {
  return $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__validationRequest__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_validation_EffectiveValidations__Lamf_core_remote_Platform__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(this, baseUnit, profile, validations, platform, env, resolved, executionEnv)
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.canParse__Lamf_core_Root__Z = (function(root) {
  var this$1 = $m_Lamf_plugins_document_webapi_parser_OasHeader$().apply__Lamf_core_Root__s_Option(root);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var x$1 = $as_Lamf_plugins_document_webapi_parser_OasHeader(arg1);
    var x$2 = $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$();
    return (!((x$1 !== null) && (x$1 === x$2)))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.serializableAnnotations__sci_Map = (function() {
  return $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__serializableAnnotations__sci_Map(this)
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.allowRecursiveReferences__Z = (function() {
  return this.allowRecursiveReferences$2
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.amf$plugins$document$webapi$BaseWebApiPlugin$$undsetter$und$ID$und$eq__T__V = (function(x$1) {
  this.ID$2 = x$1
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_errorhandling_ErrorHandler__T__Lamf_core_model_document_BaseUnit = (function(unit, errorHandler, pipelineId) {
  return (($m_Lamf_core_resolution_pipelines_ResolutionPipeline$().DEFAULT$undPIPELINE$1 === pipelineId) ? new $c_Lamf_plugins_document_webapi_resolution_pipelines_OasResolutionPipeline().init___Lamf_core_errorhandling_ErrorHandler(errorHandler).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit) : (($m_Lamf_core_resolution_pipelines_ResolutionPipeline$().EDITING$undPIPELINE$1 === pipelineId) ? new $c_Lamf_plugins_document_webapi_resolution_pipelines_OasEditingPipeline().init___Lamf_core_errorhandling_ErrorHandler__Z(errorHandler, true).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit) : (($m_Lamf_core_resolution_pipelines_ResolutionPipeline$().COMPATIBILITY$undPIPELINE$1 === pipelineId) ? new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_CompatibilityPipeline().init___Lamf_core_errorhandling_ErrorHandler__Lamf_ProfileName(errorHandler, $m_Lamf_OasProfile$()).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit) : (($m_Lamf_core_resolution_pipelines_ResolutionPipeline$().CACHE$undPIPELINE$1 === pipelineId) ? new $c_Lamf_plugins_document_webapi_resolution_pipelines_OasEditingPipeline().init___Lamf_core_errorhandling_ErrorHandler__Z(errorHandler, false).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit) : $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__resolve__Lamf_core_model_document_BaseUnit__Lamf_core_errorhandling_ErrorHandler__T__Lamf_core_model_document_BaseUnit(this, unit, errorHandler, pipelineId)))))
});
var $d_Lamf_plugins_document_webapi_Oas20Plugin$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_Oas20Plugin$: 0
}, false, "amf.plugins.document.webapi.Oas20Plugin$", {
  Lamf_plugins_document_webapi_Oas20Plugin$: 1,
  Lamf_client_plugins_AMFDocumentPlugin: 1,
  O: 1,
  Lamf_client_plugins_AMFPlugin: 1,
  Lamf_plugins_document_webapi_OasPlugin: 1,
  Lamf_plugins_document_webapi_OasLikePlugin: 1,
  Lamf_plugins_document_webapi_BaseWebApiPlugin: 1,
  Lamf_client_plugins_AMFValidationPlugin: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_validation_WebApiValidations: 1,
  Lamf_core_validation_ValidationResultProcessor: 1
});
$c_Lamf_plugins_document_webapi_Oas20Plugin$.prototype.$classData = $d_Lamf_plugins_document_webapi_Oas20Plugin$;
var $n_Lamf_plugins_document_webapi_Oas20Plugin$ = (void 0);
function $m_Lamf_plugins_document_webapi_Oas20Plugin$() {
  if ((!$n_Lamf_plugins_document_webapi_Oas20Plugin$)) {
    $n_Lamf_plugins_document_webapi_Oas20Plugin$ = new $c_Lamf_plugins_document_webapi_Oas20Plugin$().init___()
  };
  return $n_Lamf_plugins_document_webapi_Oas20Plugin$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_Oas30Plugin$() {
  $c_Lamf_client_plugins_AMFDocumentPlugin.call(this);
  this.validationProfile$2 = null;
  this.vendors$2 = null;
  this.ID$2 = null;
  this.allowRecursiveReferences$2 = false;
  this.aggregatedReport$2 = null;
  this.defaultValidationProfiles$2 = null;
  this.platform$2 = null
}
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype = new $h_Lamf_client_plugins_AMFDocumentPlugin();
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.constructor = $c_Lamf_plugins_document_webapi_Oas30Plugin$;
/** @constructor */
function $h_Lamf_plugins_document_webapi_Oas30Plugin$() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_Oas30Plugin$.prototype = $c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype;
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.amf$plugins$document$webapi$OasPlugin$$undsetter$und$vendors$und$eq__sc_Seq__V = (function(x$1) {
  this.vendors$2 = x$1
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.context__T__sc_Seq__Lamf_core_client_ParsingOptions__Lamf_core_parser_ParserContext__s_Option__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(loc, refs, options, wrapped, ds) {
  return new $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__Lamf_core_client_ParsingOptions(loc, refs, wrapped, ds, options)
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.init__s_concurrent_ExecutionContext__s_concurrent_Future = (function(executionContext) {
  return $m_s_concurrent_Future$().successful__O__s_concurrent_Future(this)
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.init___ = (function() {
  $c_Lamf_client_plugins_AMFDocumentPlugin.prototype.init___.call(this);
  $n_Lamf_plugins_document_webapi_Oas30Plugin$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$2 = this$1.platform$1;
  $f_Lamf_plugins_document_webapi_validation_WebApiValidations__$$init$__V(this);
  $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__$$init$__V(this);
  $f_Lamf_plugins_document_webapi_OasPlugin__$$init$__V(this);
  this.validationProfile$2 = $m_Lamf_Oas30Profile$();
  return this
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.unparseAsYDocument__Lamf_core_model_document_BaseUnit__Lamf_core_emitter_RenderOptions__Lamf_core_emitter_ShapeRenderOptions__s_Option = (function(unit, renderOptions, shapeRenderOptions) {
  if ((unit instanceof $c_Lamf_core_model_document_Module)) {
    var x2 = $as_Lamf_core_model_document_Module(unit);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30ModuleEmitter().init___Lamf_core_model_document_Module__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(x2, new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(renderOptions.eh$1, $m_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$(), new $c_Lamf_core_emitter_ShapeRenderOptions().init___())).emitModule__Lorg_yaml_model_YDocument())
  } else if ((unit instanceof $c_Lamf_core_model_document_Document)) {
    var x3 = $as_Lamf_core_model_document_Document(unit);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentEmitter().init___Lamf_core_model_document_BaseUnit__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(x3, new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(renderOptions.eh$1, $m_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$(), new $c_Lamf_core_emitter_ShapeRenderOptions().init___())).emitDocument__Lorg_yaml_model_YDocument())
  } else if ((unit instanceof $c_Lamf_core_model_document_ExternalFragment)) {
    var x4 = $as_Lamf_core_model_document_ExternalFragment(unit);
    var jsx$1 = $m_Lorg_yaml_model_YNode$();
    var this$7 = $as_Lamf_core_model_domain_ExternalDomainElement($as_Lamf_core_model_domain_DomainElement(x4.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)));
    var this$8 = $as_Lamf_core_model_StrField(this$7.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1));
    var this$9 = this$8.option$1;
    var x$1 = jsx$1.apply__T__Lorg_yaml_model_YNode($as_T((this$9.isEmpty__Z() ? null : this$9.get__O())));
    return new $c_s_Some().init___O($m_Lorg_yaml_model_YDocument$().apply__Lorg_yaml_model_YNode__T__Lorg_yaml_model_YDocument(x$1, ""))
  } else if ($is_Lamf_core_model_document_Fragment(unit)) {
    var x5 = $as_Lamf_core_model_document_Fragment(unit);
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentEmitter().init___Lamf_core_model_document_Fragment__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext(x5, new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas3SpecEmitterContext().init___Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_document_webapi_contexts_RefEmitter__Lamf_core_emitter_ShapeRenderOptions(renderOptions.eh$1, $m_Lamf_plugins_document_webapi_contexts_emitter_oas_OasRefEmitter$(), new $c_Lamf_core_emitter_ShapeRenderOptions().init___())).emitFragment__Lorg_yaml_model_YDocument())
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.canUnparse__Lamf_core_model_document_BaseUnit__Z = (function(unit) {
  if ((unit instanceof $c_Lamf_plugins_document_webapi_model_Overlay)) {
    return true
  } else if ((unit instanceof $c_Lamf_plugins_document_webapi_model_Extension)) {
    return true
  } else if ((unit instanceof $c_Lamf_core_model_document_Document)) {
    var x4 = $as_Lamf_core_model_document_Document(unit);
    return (x4.encodes__Lamf_core_model_domain_DomainElement() instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)
  } else if ((unit instanceof $c_Lamf_core_model_document_Module)) {
    var x5 = $as_Lamf_core_model_document_Module(unit);
    return $as_sc_Seq(x5.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_ModuleModel$().Declares$1)).exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(x0$1$2) {
        var x0$1 = $as_Lamf_core_model_domain_DomainElement(x0$1$2);
        return (x0$1 !== null)
      })
    })(this)))
  } else {
    return $is_Lamf_core_model_document_Fragment(unit)
  }
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option = (function(document, parentContext, platform, options) {
  return $f_Lamf_plugins_document_webapi_OasPlugin__parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option(this, document, parentContext, platform, options)
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.vendor__Lamf_core_remote_Vendor = (function() {
  return $m_Lamf_core_remote_Oas30$()
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.modelEntities__sc_Seq = (function() {
  return $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__modelEntities__sc_Seq(this)
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.amf$plugins$document$webapi$validation$WebApiValidations$$undsetter$und$defaultValidationProfiles$und$eq__sci_Map__V = (function(x$1) {
  this.defaultValidationProfiles$2 = x$1
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.documentSyntaxes__sc_Seq = (function() {
  var jsx$1 = $m_sc_Seq$();
  var array = ["application/json", "application/yaml", "application/x-yaml", "text/yaml", "text/vnd.yaml", "text/x-yaml", "application/openapi+json", "application/swagger+json", "application/openapi+yaml", "application/swagger+yaml", "application/openapi", "application/swagger"];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.referenceHandler__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_ReferenceHandler = (function(eh) {
  return new $c_Lamf_plugins_document_webapi_references_WebApiReferenceHandler().init___T__Lamf_plugins_document_webapi_BaseWebApiPlugin(this.ID$2, this)
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.vendors__sc_Seq = (function() {
  return this.vendors$2
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.ID__T = (function() {
  return this.ID$2
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.amf$plugins$document$webapi$BaseWebApiPlugin$$undsetter$und$allowRecursiveReferences$und$eq__Z__V = (function(x$1) {
  this.allowRecursiveReferences$2 = x$1
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.domainValidationProfiles__Lamf_core_remote_Platform__sci_Map = (function(platform) {
  var this$1 = this.defaultValidationProfiles$2;
  var p = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$2$2) {
      var x$2 = $as_T(x$2$2);
      return (x$2 === $m_Lamf_plugins_document_webapi_Oas30Plugin$().validationProfile$2.p$1)
    })
  })(this));
  return new $c_sci_MapLike$$anon$1().init___sci_MapLike__F1(this$1, p)
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.validationProfile__Lamf_ProfileName = (function() {
  return this.validationProfile$2
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.aggregatedReport$und$eq__sci_List__V = (function(x$1) {
  this.aggregatedReport$2 = x$1
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.dependencies__sc_Seq = (function() {
  return $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__dependencies__sc_Seq(this)
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.validationRequest__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_validation_EffectiveValidations__Lamf_core_remote_Platform__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future = (function(baseUnit, profile, validations, platform, env, resolved, executionEnv) {
  return $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__validationRequest__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_validation_EffectiveValidations__Lamf_core_remote_Platform__Lamf_internal_environment_Environment__Z__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(this, baseUnit, profile, validations, platform, env, resolved, executionEnv)
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.canParse__Lamf_core_Root__Z = (function(root) {
  return $m_Lamf_plugins_document_webapi_parser_OasHeader$().apply__Lamf_core_Root__s_Option(root).contains__O__Z($m_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$())
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.serializableAnnotations__sci_Map = (function() {
  return $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__serializableAnnotations__sci_Map(this)
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.allowRecursiveReferences__Z = (function() {
  return this.allowRecursiveReferences$2
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.amf$plugins$document$webapi$BaseWebApiPlugin$$undsetter$und$ID$und$eq__T__V = (function(x$1) {
  this.ID$2 = x$1
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.resolve__Lamf_core_model_document_BaseUnit__Lamf_core_errorhandling_ErrorHandler__T__Lamf_core_model_document_BaseUnit = (function(unit, errorHandler, pipelineId) {
  return (($m_Lamf_core_resolution_pipelines_ResolutionPipeline$().DEFAULT$undPIPELINE$1 === pipelineId) ? new $c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30ResolutionPipeline().init___Lamf_core_errorhandling_ErrorHandler(errorHandler).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit) : (($m_Lamf_core_resolution_pipelines_ResolutionPipeline$().EDITING$undPIPELINE$1 === pipelineId) ? new $c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30EditingPipeline().init___Lamf_core_errorhandling_ErrorHandler__Z(errorHandler, true).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit) : (($m_Lamf_core_resolution_pipelines_ResolutionPipeline$().COMPATIBILITY$undPIPELINE$1 === pipelineId) ? new $c_Lamf_plugins_document_webapi_resolution_pipelines_compatibility_CompatibilityPipeline().init___Lamf_core_errorhandling_ErrorHandler__Lamf_ProfileName(errorHandler, $m_Lamf_Oas30Profile$()).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit) : (($m_Lamf_core_resolution_pipelines_ResolutionPipeline$().CACHE$undPIPELINE$1 === pipelineId) ? new $c_Lamf_plugins_document_webapi_resolution_pipelines_Oas30EditingPipeline().init___Lamf_core_errorhandling_ErrorHandler__Z(errorHandler, false).resolve__Lamf_core_model_document_BaseUnit__Lamf_core_model_document_BaseUnit(unit) : $f_Lamf_plugins_document_webapi_BaseWebApiPlugin__resolve__Lamf_core_model_document_BaseUnit__Lamf_core_errorhandling_ErrorHandler__T__Lamf_core_model_document_BaseUnit(this, unit, errorHandler, pipelineId)))))
});
var $d_Lamf_plugins_document_webapi_Oas30Plugin$ = new $TypeData().initClass({
  Lamf_plugins_document_webapi_Oas30Plugin$: 0
}, false, "amf.plugins.document.webapi.Oas30Plugin$", {
  Lamf_plugins_document_webapi_Oas30Plugin$: 1,
  Lamf_client_plugins_AMFDocumentPlugin: 1,
  O: 1,
  Lamf_client_plugins_AMFPlugin: 1,
  Lamf_plugins_document_webapi_OasPlugin: 1,
  Lamf_plugins_document_webapi_OasLikePlugin: 1,
  Lamf_plugins_document_webapi_BaseWebApiPlugin: 1,
  Lamf_client_plugins_AMFValidationPlugin: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_validation_WebApiValidations: 1,
  Lamf_core_validation_ValidationResultProcessor: 1
});
$c_Lamf_plugins_document_webapi_Oas30Plugin$.prototype.$classData = $d_Lamf_plugins_document_webapi_Oas30Plugin$;
var $n_Lamf_plugins_document_webapi_Oas30Plugin$ = (void 0);
function $m_Lamf_plugins_document_webapi_Oas30Plugin$() {
  if ((!$n_Lamf_plugins_document_webapi_Oas30Plugin$)) {
    $n_Lamf_plugins_document_webapi_Oas30Plugin$ = new $c_Lamf_plugins_document_webapi_Oas30Plugin$().init___()
  };
  return $n_Lamf_plugins_document_webapi_Oas30Plugin$
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_WebApiContext() {
  $c_Lamf_core_parser_ParserContext.call(this);
  this.options$2 = null;
  this.declarations$2 = null;
  this.localJSONSchemaContext$2 = null;
  this.jsonSchemaIndex$2 = null;
  this.jsonSchemaRefGuide$2 = null;
  this.platform$2 = null
}
$c_Lamf_plugins_document_webapi_contexts_WebApiContext.prototype = new $h_Lamf_core_parser_ParserContext();
$c_Lamf_plugins_document_webapi_contexts_WebApiContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_WebApiContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_WebApiContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_WebApiContext.prototype = $c_Lamf_plugins_document_webapi_contexts_WebApiContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_WebApiContext.prototype.setJsonSchemaAST__Lorg_yaml_model_YNode__V = (function(value) {
  this.localJSONSchemaContext$2 = new $c_s_Some().init___O(value);
  this.jsonSchemaIndex$2 = new $c_s_Some().init___O($m_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex$().apply__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex(value, this))
});
$c_Lamf_plugins_document_webapi_contexts_WebApiContext.prototype.registerJsonSchema__T__Lamf_plugins_domain_shapes_models_AnyShape__V = (function(url, shape) {
  this.globalSpace$1.update__O__O__V(this.normalizedJsonPointer__T__T(url), shape)
});
$c_Lamf_plugins_document_webapi_contexts_WebApiContext.prototype.normalizeJsonPath__p2__T__T = (function(path) {
  if ((((path === "#") || (path === "")) || (path === "/"))) {
    return "/"
  } else {
    var s = ((($uI(path.length) >= 0) && ($as_T(path.substring(0, $uI("#/".length))) === "#/")) ? $as_T(path.split("#/").join("")) : path);
    if ((($uI(s.length) >= 0) && ($as_T(s.substring(0, $uI("/".length))) === "/"))) {
      var this$14 = new $c_sci_StringOps().init___T(s);
      return $f_sci_StringLike__stripPrefix__T__T(this$14, "/")
    } else {
      return s
    }
  }
});
$c_Lamf_plugins_document_webapi_contexts_WebApiContext.prototype.resolvedPath__T__T__T = (function(base, str) {
  if ((str === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  if ((str === "")) {
    var this$2 = this.platform$2;
    return $f_Lamf_core_remote_JsPlatform__normalizePath__T__T(this$2, base)
  } else if ((($uI(str.length) >= 0) && ($as_T(str.substring(0, $uI("/".length))) === "/"))) {
    return str
  } else if (($uI(str.indexOf(":")) !== (-1))) {
    return str
  } else if ((($uI(str.length) >= 0) && ($as_T(str.substring(0, $uI("#".length))) === "#"))) {
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(base, "#", 0);
    var this$18 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    return (("" + $as_T($f_sc_IndexedSeqOptimized__head__O(this$18))) + str)
  } else {
    var this$22 = this.platform$2;
    var str$1 = this.basePath__T__T(base);
    var this$20 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str$1);
    var this$21 = this$20.platform$1;
    var url = this$20.str$1;
    var url$1 = (("" + $f_Lamf_core_remote_JsPlatform__decodeURI__T__T(this$21, url)) + str);
    return $f_Lamf_core_remote_JsPlatform__normalizePath__T__T(this$22, url$1)
  }
});
$c_Lamf_plugins_document_webapi_contexts_WebApiContext.prototype.parseRemoteOasParameter__T__T__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext__s_Option = (function(fileUrl, parentId, ctx) {
  var referenceUrl = this.getReferenceUrl__p2__T__s_Option(fileUrl);
  var this$1 = this.obtainFragment__p2__T__s_Option(fileUrl);
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var fragment = $as_Lamf_core_model_document_Fragment(arg1);
    return $m_Lamf_plugins_document_webapi_JsonSchemaPlugin$().parseParameterFragment__Lamf_core_model_document_Fragment__s_Option__T__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext__s_Option(fragment, referenceUrl, parentId, ctx)
  }
});
$c_Lamf_plugins_document_webapi_contexts_WebApiContext.prototype.findLocalJSONPath__T__s_Option = (function(path) {
  var x1 = this.jsonSchemaIndex$2;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var jsi = $as_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaAstIndex(x2.value$2);
    var ref = this.normalizeJsonPath__p2__T__T(path);
    var this$1 = jsi.index$1.get__O__s_Option(ref);
    if (this$1.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1 = this$1.get__O();
      var x$2 = $as_Lorg_yaml_model_YNode(arg1);
      return new $c_s_Some().init___O(new $c_T2().init___O__O(path, x$2))
    }
  } else {
    return $m_s_None$()
  }
});
$c_Lamf_plugins_document_webapi_contexts_WebApiContext.prototype.init___T__sc_Seq__Lamf_core_client_ParsingOptions__Lamf_core_parser_ParserContext__s_Option = (function(loc, refs, options, wrapped, declarationsOption) {
  this.options$2 = options;
  var jsx$2 = wrapped.futureDeclarations$1;
  var jsx$1 = wrapped.eh$1;
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$5 = new $c_scm_ListBuffer().init___();
  $c_Lamf_core_parser_ParserContext.prototype.init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext.call(this, loc, refs, jsx$2, jsx$1, new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$5.toList__sci_List()));
  var this$6 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$2 = this$6.platform$1;
  if (declarationsOption.isEmpty__Z()) {
    var x$1 = $m_s_None$();
    var x$2 = this.eh$1;
    var x$3 = this.futureDeclarations$1;
    var x$4 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$5 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$6 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$7 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$8 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$9 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$10 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$11 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$12 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$13 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$14 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$15 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$16 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$17 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$18 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$19 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$20 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$21 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$22 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$23 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$24 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$25 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$26 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$27 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var jsx$3 = new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations().init___s_Option__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__sci_Map__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations__sci_Map(x$1, x$4, x$5, x$6, x$7, x$8, x$9, x$10, x$11, x$12, x$13, x$14, x$15, x$16, x$17, x$18, x$19, x$20, x$21, x$22, x$23, x$24, x$25, x$26, x$2, x$3, x$27)
  } else {
    var jsx$3 = declarationsOption.get__O()
  };
  this.declarations$2 = $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(jsx$3);
  if ((wrapped instanceof $c_Lamf_plugins_document_webapi_contexts_WebApiContext)) {
    var x2 = $as_Lamf_plugins_document_webapi_contexts_WebApiContext(wrapped);
    var jsx$4 = x2.localJSONSchemaContext$2
  } else {
    var jsx$4 = $m_s_None$()
  };
  this.localJSONSchemaContext$2 = jsx$4;
  if ((wrapped instanceof $c_Lamf_plugins_document_webapi_contexts_WebApiContext)) {
    var x2$2 = $as_Lamf_plugins_document_webapi_contexts_WebApiContext(wrapped);
    var jsx$5 = x2$2.jsonSchemaIndex$2
  } else {
    var jsx$5 = $m_s_None$()
  };
  this.jsonSchemaIndex$2 = jsx$5;
  this.jsonSchemaRefGuide$2 = new $c_Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide().init___T__sc_Seq__Lamf_plugins_document_webapi_contexts_WebApiContext(loc, this.refs$1, this);
  this.globalSpace$1 = wrapped.globalSpace$1;
  return this
});
$c_Lamf_plugins_document_webapi_contexts_WebApiContext.prototype.findJsonSchema__T__s_Option = (function(url) {
  var x1 = this.globalSpace$1.get__O__s_Option(this.normalizedJsonPointer__T__T(url));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var shape = x2.value$2;
    if ((shape instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
      var x3 = $as_Lamf_plugins_domain_shapes_models_AnyShape(shape);
      return new $c_s_Some().init___O(x3)
    }
  };
  return $m_s_None$()
});
$c_Lamf_plugins_document_webapi_contexts_WebApiContext.prototype.obtainFragment__p2__T__s_Option = (function(fileUrl) {
  var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(fileUrl, "#", 0);
  var this$3 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
  var baseFileUrl = $as_T($f_sc_IndexedSeqOptimized__head__O(this$3));
  var this$6 = $as_sc_TraversableOnce($as_sc_TraversableLike(this.refs$1.filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(r$2) {
      var r = $as_Lamf_core_parser_ParsedReference(r$2);
      var this$4 = r.unit$1;
      return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$4).isDefined__Z()
    })
  })(this)))).filter__F1__O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, baseFileUrl$1) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_parser_ParsedReference(x$1$2);
      var this$5 = x$1.unit$1;
      var x = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$5).get__O();
      return ((x === null) ? (baseFileUrl$1 === null) : $objectEquals(x, baseFileUrl$1))
    })
  })(this, baseFileUrl))));
  var pf = new $c_Lamf_plugins_document_webapi_contexts_WebApiContext$$anonfun$obtainFragment$3().init___Lamf_plugins_document_webapi_contexts_WebApiContext(this);
  return $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$6, pf)
});
$c_Lamf_plugins_document_webapi_contexts_WebApiContext.prototype.validateRefFormatWithError__T__Z = (function(ref) {
  return true
});
$c_Lamf_plugins_document_webapi_contexts_WebApiContext.prototype.computeJsonSchemaVersion__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion = (function(rootAst) {
  var x1 = rootAst.value__Lorg_yaml_model_YValue();
  if ((x1 instanceof $c_Lorg_yaml_model_YMap)) {
    var x2 = $as_Lorg_yaml_model_YMap(x1);
    var x1$2 = x2.map$3.get__O__s_Option(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("$schema")));
    if ((x1$2 instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(x1$2);
      var node = $as_Lorg_yaml_model_YNode(x2$2.value$2);
      var x1$3 = node.value__Lorg_yaml_model_YValue();
      if ((x1$3 instanceof $c_Lorg_yaml_model_YScalar)) {
        var x2$3 = $as_Lorg_yaml_model_YScalar(x1$3);
        var x1$4 = x2$3.text$3;
        return (($uI(x1$4.indexOf("http://json-schema.org/draft-01/schema")) !== (-1)) ? $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$() : (($uI(x1$4.indexOf("http://json-schema.org/draft-02/schema")) !== (-1)) ? $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$() : (($uI(x1$4.indexOf("http://json-schema.org/draft-03/schema")) !== (-1)) ? $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft3SchemaVersion$() : $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$())))
      } else {
        var this$11 = this.eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().InvalidJsonSchemaVersion$1;
        var prop = $m_s_None$();
        var l = node.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$11, specification, "", prop, "JSON Schema version value must be a string", l);
        return $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaDraft4SchemaVersion$()
      }
    } else {
      return $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$()
    }
  } else {
    return $m_Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaUnspecifiedVersion$()
  }
});
$c_Lamf_plugins_document_webapi_contexts_WebApiContext.prototype.getReferenceUrl__p2__T__s_Option = (function(fileUrl) {
  var x1 = $m_sjsr_RuntimeString$().split__T__T__I__AT(fileUrl, "#", 0);
  if ((x1 !== null)) {
    if ((x1.u.length > 1)) {
      var this$5 = new $c_scm_ArrayOps$ofRef().init___AO(x1);
      return new $c_s_Some().init___O($f_sc_IndexedSeqOptimized__last__O(this$5))
    }
  };
  return $m_s_None$()
});
$c_Lamf_plugins_document_webapi_contexts_WebApiContext.prototype.basePath__T__T = (function(path) {
  if (($uI(path.indexOf("#")) !== (-1))) {
    var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(path, "#", 0);
    var this$6 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
    var withoutHash = $as_T($f_sc_IndexedSeqOptimized__head__O(this$6))
  } else {
    var withoutHash = path
  };
  var this$10 = new $c_sci_StringOps().init___T(withoutHash);
  var n = $uI(withoutHash.lastIndexOf("/"));
  return ($as_T($f_sc_IndexedSeqOptimized__splitAt__I__T2(this$10, n).$$und1__O()) + "/")
});
$c_Lamf_plugins_document_webapi_contexts_WebApiContext.prototype.closedShape__T__Lorg_yaml_model_YMap__T__V = (function(node, ast, shape) {
  var x1 = this.syntax__Lamf_plugins_document_webapi_parser_spec_SpecSyntax().nodes__sci_Map().get__O__s_Option(shape);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var properties = $as_sci_Set(x2.value$2);
    ast.entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, shape$1, properties$1, node$1) {
      return (function(entry$2) {
        var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
        var this$1 = entry.key$2;
        var evidence$1 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
        var this$2 = $f_Lorg_yaml_model_YNodeLike__asOption__Lorg_yaml_convert_YRead__s_Option(this$1, evidence$1);
        if (this$2.isEmpty__Z()) {
          var this$3 = $m_s_None$()
        } else {
          var arg1 = this$2.get__O();
          var x$3 = $as_Lorg_yaml_model_YScalar(arg1);
          var this$3 = new $c_s_Some().init___O(x$3.text$3)
        };
        var key = $as_T((this$3.isEmpty__Z() ? entry.key$2.toString__T() : this$3.get__O()));
        if ((!$this.ignore__T__T__Z(shape$1, key))) {
          if ((!properties$1.contains__O__Z(key))) {
            var this$4 = $this.eh$1;
            var specification = $m_Lamf_validation_DialectValidations$().ClosedShapeSpecification$1;
            var message = (((((("Property '" + key) + "' not supported in a ") + $this.vendor__Lamf_core_remote_Vendor()) + " ") + shape$1) + " node");
            var prop = $m_s_None$();
            var l = entry.location$1;
            $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$4, specification, node$1, prop, message, l)
          }
        }
      })
    })(this, shape, properties, node)))
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$5 = this.eh$1;
      var specification$1 = $m_Lamf_validation_DialectValidations$().ClosedShapeSpecification$1;
      var message$1 = ((("Cannot validate unknown node type " + shape) + " for ") + this.vendor__Lamf_core_remote_Vendor());
      var prop$1 = $m_s_None$();
      var l$1 = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$5, specification$1, node, prop$1, message$1, l$1)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_contexts_WebApiContext.prototype.normalizedJsonPointer__T__T = (function(url) {
  if ($m_sjsr_RuntimeString$().endsWith__T__T__Z(url, "/")) {
    var this$2 = new $c_sci_StringOps().init___T(url);
    return $as_T($f_sc_IndexedSeqOptimized__dropRight__I__O(this$2, 1))
  } else {
    return url
  }
});
function $as_Lamf_plugins_document_webapi_contexts_WebApiContext(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_WebApiContext) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.WebApiContext"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_WebApiContext(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_WebApiContext)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_WebApiContext(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_WebApiContext(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.WebApiContext;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory() {
  $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory.call(this)
}
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory.prototype = new $h_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory();
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory.prototype.productPrefix__T = (function() {
  return "InlinedJsonSchemaEmitterFactory"
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory) && ($as_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory(x$1), true))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory.prototype.spec__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function() {
  return $as_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext(this.spec$3)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory.prototype.spec__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext = (function() {
  return $as_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext(this.spec$3)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory.prototype.init___Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext = (function(spec) {
  $c_Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory.prototype.init___Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext.call(this, spec);
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory.prototype.typeEmitters__Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__sc_Seq = (function(shape, ordering, ignored, references, pointer, schemaPath) {
  return new $c_Lamf_plugins_document_webapi_parser_spec_declaration_emitters_oas_OasTypeEmitter().init___Lamf_core_model_domain_Shape__Lamf_core_emitter_SpecOrdering__sc_Seq__sc_Seq__sc_Seq__sc_Seq__Z__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(shape, ordering, ignored, references, pointer, schemaPath, false, $as_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext(this.spec$3)).emitters__sc_Seq()
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.emitter.oas.InlinedJsonSchemaEmitterFactory"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.emitter.oas.InlinedJsonSchemaEmitterFactory;", depth))
}
var $d_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.oas.InlinedJsonSchemaEmitterFactory", {
  Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory: 1,
  Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterFactory: 1,
  Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory: 1,
  Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_SpecEmitterFactory: 1,
  Lamf_plugins_document_webapi_contexts_emitter_oas_OasCompactEmitterFactory: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter.call(this);
  this.target$2 = null;
  this.label$2 = null;
  this.reference$2 = null;
  this.referenceLabel$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter.prototype.target__Lamf_core_model_domain_DomainElement = (function() {
  return this.target$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter.prototype.productPrefix__T = (function() {
  return "OasTagToReferenceEmitter"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter.prototype.emit__Lorg_yaml_model_YDocument$PartBuilder__V = (function(b) {
  var x1 = this.follow__p2__Lamf_core_model_domain_DomainElement__sc_Seq__Lamf_core_model_domain_DomainElement(this.target$2, $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
  matchEnd9: {
    if ((x1 instanceof $c_Lamf_core_model_domain_Shape)) {
      var x2 = $as_Lamf_core_model_domain_Shape(x1);
      if (x2.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf())) {
        $as_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.spec$1).ref__Lorg_yaml_model_YDocument$PartBuilder__T__V(b, $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().appendDefinitionsPrefix__T__s_Option__T(this.referenceLabel$2, new $c_s_Some().init___O($as_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.spec$1).vendor__Lamf_core_remote_Vendor())));
        break matchEnd9
      }
    };
    if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Parameter)) {
      var x3 = $as_Lamf_plugins_domain_webapi_models_Parameter(x1);
      if (x3.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf())) {
        $as_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.spec$1).ref__Lorg_yaml_model_YDocument$PartBuilder__T__V(b, $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().appendParameterDefinitionsPrefix__T__Z__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__T(this.referenceLabel$2, false, $as_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.spec$1)));
        break matchEnd9
      }
    };
    if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Payload)) {
      var x4 = $as_Lamf_plugins_domain_webapi_models_Payload(x1);
      if (x4.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf())) {
        $as_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.spec$1).ref__Lorg_yaml_model_YDocument$PartBuilder__T__V(b, $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().appendParameterDefinitionsPrefix__T__Z__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__T(this.referenceLabel$2, false, $as_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.spec$1)));
        break matchEnd9
      }
    };
    if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Response)) {
      var x5 = $as_Lamf_plugins_domain_webapi_models_Response(x1);
      if (x5.annotations$2.contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf())) {
        $as_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.spec$1).ref__Lorg_yaml_model_YDocument$PartBuilder__T__V(b, $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().appendResponsesDefinitionsPrefix__T__Lamf_plugins_document_webapi_contexts_SpecEmitterContext__T(this.referenceLabel$2, $as_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.spec$1)));
        break matchEnd9
      }
    };
    if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_Callback)) {
      var x6 = $as_Lamf_plugins_domain_webapi_models_Callback(x1);
      if (x6.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf())) {
        $as_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.spec$1).ref__Lorg_yaml_model_YDocument$PartBuilder__T__V(b, $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().appendOas3ComponentsPrefix__T__T__T(this.referenceLabel$2, "callbacks"));
        break matchEnd9
      }
    };
    if ((x1 instanceof $c_Lamf_plugins_domain_webapi_models_TemplatedLink)) {
      var x7 = $as_Lamf_plugins_domain_webapi_models_TemplatedLink(x1);
      if (x7.annotations$1.contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf())) {
        $as_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.spec$1).ref__Lorg_yaml_model_YDocument$PartBuilder__T__V(b, $m_Lamf_plugins_document_webapi_parser_spec_package$OasDefinitions$().appendOas3ComponentsPrefix__T__T__T(this.referenceLabel$2, "links"));
        break matchEnd9
      }
    };
    $as_Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext(this.spec$1).ref__Lorg_yaml_model_YDocument$PartBuilder__T__V(b, this.referenceLabel$2)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter)) {
    var OasTagToReferenceEmitter$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter(x$1);
    var x = this.target$2;
    var x$2 = OasTagToReferenceEmitter$1.target$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.label$2;
      var x$4 = OasTagToReferenceEmitter$1.label$2;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.reference$2;
      var x$6 = OasTagToReferenceEmitter$1.reference$2;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.target$2;
      break
    }
    case 1: {
      return this.label$2;
      break
    }
    case 2: {
      return this.reference$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter.prototype.amf$plugins$document$webapi$contexts$TagToReferenceEmitter$$undsetter$und$referenceLabel$und$eq__T__V = (function(x$1) {
  this.referenceLabel$2 = x$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter.prototype.follow__p2__Lamf_core_model_domain_DomainElement__sc_Seq__Lamf_core_model_domain_DomainElement = (function(element, seenLinks) {
  _follow: while (true) {
    var x1 = element;
    if ($is_Lamf_core_model_domain_Linkable(x1)) {
      var this$1 = $as_Lamf_core_model_domain_Linkable(x1);
      if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1).isDefined__Z()) {
        var rc7 = false;
        var x2$2 = null;
        var this$2 = $as_Lamf_core_model_domain_Linkable(x1);
        var x1$2 = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2);
        if ((x1$2 instanceof $c_s_Some)) {
          rc7 = true;
          x2$2 = $as_s_Some(x1$2);
          var t = $as_Lamf_core_model_domain_DomainElement(x2$2.value$2);
          if ($is_Lamf_core_model_domain_Linkable(t)) {
            var this$3 = $as_Lamf_core_model_domain_Linkable(t);
            if ((!(!($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$3).isDefined__Z() & (!t.annotations__Lamf_core_parser_Annotations().contains__jl_Class__Z($d_Lamf_core_annotations_DeclaredElement.getClassOf())))))) {
              var this$4 = $as_Lamf_core_model_domain_Linkable(t);
              var temp$element = $as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$4).get__O());
              var jsx$2 = seenLinks;
              var jsx$1 = element.id__T();
              var this$5 = $m_sc_Seq$();
              var temp$seenLinks = $as_sc_Seq(jsx$2.$$colon$plus__O__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2));
              element = temp$element;
              seenLinks = temp$seenLinks;
              continue _follow
            }
          }
        };
        if (rc7) {
          var t$2 = $as_Lamf_core_model_domain_DomainElement(x2$2.value$2);
          return t$2
        };
        var x$2 = $m_s_None$();
        if ((x$2 === x1$2)) {
          return x1
        };
        throw new $c_s_MatchError().init___O(x1$2)
      }
    };
    return x1
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter.prototype.label__s_Option = (function() {
  return this.label$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter.prototype.init___Lamf_core_model_domain_DomainElement__s_Option__sc_Seq__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext = (function(target, label, reference, spec) {
  this.target$2 = target;
  this.label$2 = label;
  this.reference$2 = reference;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter.prototype.init___Lamf_plugins_document_webapi_contexts_SpecEmitterContext.call(this, spec);
  $f_Lamf_plugins_document_webapi_contexts_TagToReferenceEmitter__$$init$__V(this);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = $m_Lamf_core_emitter_BaseEmitters_package$();
  var annotations = this.target$2.annotations__Lamf_core_parser_Annotations();
  return this$1.pos__Lamf_core_parser_Annotations__jl_Class__Lamf_core_parser_Position(annotations, $d_Lamf_core_annotations_LexicalInformation.getClassOf())
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.OasTagToReferenceEmitter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.OasTagToReferenceEmitter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.OasTagToReferenceEmitter", {
  Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecEmitter: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_BaseSpecEmitter: 1,
  Lamf_plugins_document_webapi_contexts_TagToReferenceEmitter: 1,
  Lamf_core_emitter_PartEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_OasTagToReferenceEmitter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.call(this);
  this.Raml08ReferenceParser$module$3 = null;
  this.Raml08TextParser$module$3 = null;
  this.Raml08SchemaParser$module$3 = null;
  this.entryOrNode$3 = null;
  this.key$3 = null;
  this.adopt$3 = null;
  this.typeInfo$3 = null;
  this.defaultType$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function() {
  return this.ctx$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser.prototype.productPrefix__T = (function() {
  return "Raml08TypeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser.prototype.parseUnion__p3__Lamf_plugins_domain_shapes_models_ScalarShape__s_Option = (function(shape) {
  var jsx$2 = $m_s_Option$();
  var this$1 = $m_Lamf_plugins_domain_shapes_models_UnionShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_UnionShape(this.node$2);
  var name = this.name$2;
  var a = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.key$3);
  var qual$1 = $as_Lamf_plugins_domain_shapes_models_UnionShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$1, name, a));
  var x$1 = shape.id$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var jsx$1 = $as_Lamf_plugins_domain_shapes_models_UnionShape($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1));
  var this$2 = this.node$2;
  var conversion = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
  var iv = this.ctx$2;
  return jsx$2.apply__O__s_Option(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08UnionTypeParser().init___Lamf_plugins_domain_shapes_models_UnionShape__sc_Seq__Lorg_yaml_model_YPart__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(jsx$1, $as_sc_Seq($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv)), this.node$2, this.ctx$2).parse__Lamf_plugins_domain_shapes_models_UnionShape())
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser)) {
    var Raml08TypeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser(x$1);
    var x = this.entryOrNode$3;
    var x$2 = Raml08TypeParser$1.entryOrNode$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var this$1 = this.key$3;
      var b = Raml08TypeParser$1.key$3;
      var jsx$3 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$3 = this.adopt$3;
      var x$4 = Raml08TypeParser$1.adopt$3;
      var jsx$2 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.typeInfo$3;
      var x$6 = Raml08TypeParser$1.typeInfo$3;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.defaultType$3;
      var x$8 = Raml08TypeParser$1.defaultType$3;
      return (x$7 === x$8)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entryOrNode$3;
      break
    }
    case 1: {
      return this.key$3;
      break
    }
    case 2: {
      return this.adopt$3;
      break
    }
    case 3: {
      return this.typeInfo$3;
      break
    }
    case 4: {
      return this.defaultType$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser.prototype.parseSchemaOrTypeDeclarationAndExamples__p3__s_Option = (function() {
  var this$1 = this.node$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = this.ctx$2;
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  var this$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("schema");
  if (this$3.isEmpty__Z()) {
    return $m_s_Option$().apply__O__s_Option(new $c_Lamf_plugins_document_webapi_parser_spec_declaration_SimpleTypeParser().init___T__F1__Lorg_yaml_model_YMap__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this.name$2, this.adopt$3, map, this.defaultType$3.typeDef__Lamf_plugins_domain_shapes_models_TypeDef(), this.ctx$2).parse__Lamf_plugins_domain_shapes_models_AnyShape())
  } else {
    var arg1 = this$3.get__O();
    $as_Lorg_yaml_model_YMapEntry(arg1);
    var maybeShape = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08SchemaParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser__Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this, map, this.adopt$3, this.ctx$2).parse__s_Option();
    if (maybeShape.isEmpty__Z()) {
      return $m_s_None$()
    } else {
      var arg1$1 = maybeShape.get__O();
      var s = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1$1);
      var this$5 = s.meta__Lamf_plugins_domain_shapes_metamodel_AnyShapeModel().modelInstance__Lamf_plugins_domain_shapes_models_AnyShape();
      $m_Lamf_core_parser_Annotations$();
      var a = new $c_Lamf_core_parser_Annotations().init___();
      var inherits = $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$5, "inherits", a));
      this.adopt$3.apply__O__O(inherits);
      var this$6 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_RamlSingleExampleParser().init___T__Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext("example", map, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, inherits$1) {
        return (function(name$2) {
          var name = $as_s_Option(name$2);
          return $f_Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement__withExample__s_Option__Lamf_plugins_domain_shapes_models_Example(inherits$1, name)
        })
      })(this, inherits)), new $c_Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions().init___Z__Z__Z(true, true, false).checkScalar__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions(s), this.ctx$2).parse__s_Option();
      if (this$6.isEmpty__Z()) {
        var jsx$1 = s
      } else {
        var arg1$2 = this$6.get__O();
        var e = $as_Lamf_plugins_domain_shapes_models_Example(arg1$2);
        var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1;
        var jsx$2 = $m_sc_Seq$();
        var array = [s];
        var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))), new $c_Lamf_core_parser_Annotations().init___());
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(inherits, field, value);
        var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Examples$1;
        var jsx$3 = $m_sc_Seq$();
        var array$1 = [e];
        var values = $as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1)));
        var jsx$1 = $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(inherits, field$1, values))
      };
      return new $c_s_Some().init___O(jsx$1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser.prototype.parse__s_Option = (function() {
  var this$1 = $m_Lamf_plugins_domain_shapes_models_ScalarShape$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_ScalarShape(this.node$2);
  var name = this.name$2;
  var a = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.key$3);
  var shape = $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$1, name, a));
  this.adopt$3.apply__O__O(shape);
  var this$2 = this.node$2;
  var x1 = this$2.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x === x1)) {
    var optionalParsedShape = this.parseSchemaOrTypeDeclarationAndExamples__p3__s_Option()
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Seq$1;
    if ((x$3 === x1)) {
      var optionalParsedShape = this.parseUnion__p3__Lamf_plugins_domain_shapes_models_ScalarShape__s_Option(shape)
    } else {
      var optionalParsedShape = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$Raml08TextParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser__Lorg_yaml_model_YNode__F1__T__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this, this.node$2, this.adopt$3, this.name$2, this.defaultType$3, this.ctx$2).parse__s_Option()
    }
  };
  if (optionalParsedShape.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = optionalParsedShape.get__O();
    var result = $as_Lamf_plugins_domain_shapes_models_AnyShape(arg1);
    return new $c_s_Some().init___O(this.correctTypeAnnotations__p3__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_domain_shapes_models_AnyShape(result))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser.prototype.typeParser__F5 = (function() {
  return new $c_sjsr_AnonFunction5().init___sjs_js_Function5((function($this) {
    return (function(entryOrNode$2, name$2, adopt$2, isAnnotation$2, defaultType$2) {
      var entryOrNode = $as_s_util_Either(entryOrNode$2);
      var name = $as_T(name$2);
      var adopt = $as_F1(adopt$2);
      var isAnnotation = $uZ(isAnnotation$2);
      var defaultType = $as_Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType(defaultType$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$().apply__s_util_Either__T__F1__Z__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser(entryOrNode, name, adopt, isAnnotation, defaultType, $this.ctx$2)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser.prototype.correctTypeAnnotations__p3__Lamf_plugins_domain_shapes_models_AnyShape__Lamf_plugins_domain_shapes_models_AnyShape = (function(result) {
  var this$1 = $as_Lamf_core_model_StrField(result.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    $as_T(arg1);
    var name = this.name$2;
    var a = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.key$3);
    $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(result, name, a))
  };
  result.annotations__Lamf_core_parser_Annotations().reject__F1__Lamf_core_parser_Annotations(this.isLexical__p3__F1());
  var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.ast$2);
  return $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(result, other))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser.prototype.init___s_util_Either__Lorg_yaml_model_YNode__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(entryOrNode, key, adopt, typeInfo, defaultType, ctx) {
  this.entryOrNode$3 = entryOrNode;
  this.key$3 = key;
  this.adopt$3 = adopt;
  this.typeInfo$3 = typeInfo;
  this.defaultType$3 = defaultType;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.prototype.init___s_util_Either__Lorg_yaml_model_YNode__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, entryOrNode, key, adopt, typeInfo, defaultType, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser.prototype.isLexical__p3__F1 = (function() {
  return new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(a$2) {
      var a = $as_Lamf_core_model_domain_Annotation(a$2);
      return ((((a instanceof $c_Lamf_core_annotations_SourceAST) || (a instanceof $c_Lamf_core_annotations_SourceNode)) || (a instanceof $c_Lamf_core_annotations_SourceLocation)) || (a instanceof $c_Lamf_core_annotations_LexicalInformation))
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.Raml08TypeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.Raml08TypeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.Raml08TypeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_WebApiBaseSpecParser: 1,
  Lamf_core_parser_BaseSpecParser: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.call(this);
  this.entryOrNode$3 = null;
  this.key$3 = null;
  this.adopt$3 = null;
  this.typeInfo$3 = null;
  this.defaultType$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function() {
  return this.ctx$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser.prototype.productPrefix__T = (function() {
  return "Raml10TypeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser.prototype.productArity__I = (function() {
  return 5
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser)) {
    var Raml10TypeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(x$1);
    var x = this.entryOrNode$3;
    var x$2 = Raml10TypeParser$1.entryOrNode$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var this$1 = this.key$3;
      var b = Raml10TypeParser$1.key$3;
      var jsx$3 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var x$3 = this.adopt$3;
      var x$4 = Raml10TypeParser$1.adopt$3;
      var jsx$2 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.typeInfo$3;
      var x$6 = Raml10TypeParser$1.typeInfo$3;
      var jsx$1 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.defaultType$3;
      var x$8 = Raml10TypeParser$1.defaultType$3;
      return (x$7 === x$8)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entryOrNode$3;
      break
    }
    case 1: {
      return this.key$3;
      break
    }
    case 2: {
      return this.adopt$3;
      break
    }
    case 3: {
      return this.typeInfo$3;
      break
    }
    case 4: {
      return this.defaultType$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser.prototype.typeParser__F5 = (function() {
  return new $c_sjsr_AnonFunction5().init___sjs_js_Function5((function($this) {
    return (function(entryOrNode$2, name$2, adopt$2, isAnnotation$2, defaultType$2) {
      var entryOrNode = $as_s_util_Either(entryOrNode$2);
      var name = $as_T(name$2);
      var adopt = $as_F1(adopt$2);
      var isAnnotation = $uZ(isAnnotation$2);
      var defaultType = $as_Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType(defaultType$2);
      return $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$().apply__s_util_Either__T__F1__Z__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(entryOrNode, name, adopt, isAnnotation, defaultType, $this.ctx$2)
    })
  })(this))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser.prototype.init___s_util_Either__Lorg_yaml_model_YNode__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(entryOrNode, key, adopt, typeInfo, defaultType, ctx) {
  this.entryOrNode$3 = entryOrNode;
  this.key$3 = key;
  this.adopt$3 = adopt;
  this.typeInfo$3 = typeInfo;
  this.defaultType$3 = defaultType;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.prototype.init___s_util_Either__Lorg_yaml_model_YNode__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, entryOrNode, key, adopt, typeInfo, defaultType, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.Raml10TypeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.Raml10TypeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.Raml10TypeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_WebApiBaseSpecParser: 1,
  Lamf_core_parser_BaseSpecParser: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.call(this);
  this.shape$3 = null;
  this.map$3 = null;
  this.adopt$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser.prototype.productPrefix__T = (function() {
  return "ArrayShapeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lamf_plugins_domain_shapes_models_ArrayShape__Lorg_yaml_model_YMap__F1 = (function($$outer, shape, map, adopt) {
  this.shape$3 = shape;
  this.map$3 = map;
  this.adopt$3 = adopt;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.call(this, $$outer);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser(x$1).$$outer$1 === this.$$outer$1))) {
    var ArrayShapeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser(x$1);
    var x = this.shape$3;
    var x$2 = ArrayShapeParser$1.shape$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var this$1 = this.map$3;
      var b = ArrayShapeParser$1.map$3;
      var jsx$1 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.adopt$3;
      var x$4 = ArrayShapeParser$1.adopt$3;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser.prototype.parseInheritance__V = (function() {
  var map = this.map$3;
  if (new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("items").isDefined__Z()) {
    $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser.prototype.parseInheritance__V.call(this)
  } else {
    var this$2 = this.$$outer$1.typeOrSchema__Lorg_yaml_model_YMap__s_Option(this.map$3);
    if (this$2.isEmpty__Z()) {
      var this$6 = $m_s_None$()
    } else {
      var arg1 = this$2.get__O();
      var typeEntry = $as_Lorg_yaml_model_YMapEntry(arg1);
      var isTypeExpression = this.$$outer$1.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$isPlainArrayTypeExpression__Lorg_yaml_model_YMapEntry__Z(typeEntry);
      if (isTypeExpression) {
        var typeExpression = $m_sjsr_RuntimeString$().replaceFirst__T__T__T__T(typeEntry.value$2.toString__T(), "\\[\\]", "");
        var x$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(items$2) {
            var items = $as_Lamf_core_model_domain_Shape(items$2);
            items.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject($this.shape$3.id$1, items.adopted$default$2__sc_Seq())
          })
        })(this));
        var x$3 = $m_s_None$();
        var ctx = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
        var this$5 = new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser().init___F1__I__s_Option__Z__T__Lamf_plugins_document_webapi_contexts_WebApiContext(x$1, 0, x$3, false, typeExpression, ctx).parse__s_Option();
        if ((!this$5.isEmpty__Z())) {
          var arg1$1 = this$5.get__O();
          var value = $as_Lamf_core_model_domain_Shape(arg1$1);
          this.shape$3.withItems__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_ArrayShape(value)
        }
      } else {
        $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser.prototype.parseInheritance__V.call(this)
      };
      var this$6 = new $c_s_Some().init___O((void 0))
    };
    if (this$6.isEmpty__Z()) {
      $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser.prototype.parseInheritance__V.call(this)
    } else {
      this$6.get__O()
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$3;
      break
    }
    case 1: {
      return this.map$3;
      break
    }
    case 2: {
      return this.adopt$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  this.adopt$3.apply__O__O(this.shape$3);
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape.call(this);
  var map = this.map$3;
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$2 = this.$$outer$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().UniqueItems$1;
  var iv = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$1.key__T__F1__V("uniqueItems", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$2, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$3).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var map$1 = this.map$3;
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var jsx$2 = new $c_Lamf_core_utils_package$AmfStrings().init___T("collectionFormat").asRamlAnnotation__T();
  var this$5 = this.$$outer$1;
  var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().CollectionFormat$1;
  var iv$1 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$3.key__T__F1__V(jsx$2, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$5, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$3));
  this.parseItems__p3__V();
  var rc13 = false;
  var x2 = null;
  var jsx$4 = $m_s_Option$();
  var this$6 = this.shape$3;
  var x1 = jsx$4.apply__O__s_Option($as_Lamf_core_model_domain_Shape(this$6.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1)));
  matchEnd14: {
    var finalShape;
    if ((x1 instanceof $c_s_Some)) {
      rc13 = true;
      x2 = $as_s_Some(x1);
      if ((x2.value$2 instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
        var finalShape = new $c_s_Some().init___O(this.shape$3.toMatrixShape__Lamf_plugins_domain_shapes_models_MatrixShape());
        break matchEnd14
      }
    };
    if ((rc13 && (x2.value$2 instanceof $c_Lamf_plugins_domain_shapes_models_MatrixShape))) {
      var finalShape = new $c_s_Some().init___O(this.shape$3.toMatrixShape__Lamf_plugins_domain_shapes_models_MatrixShape());
      break matchEnd14
    };
    if ((rc13 && (x2.value$2 !== null))) {
      var finalShape = new $c_s_Some().init___O(this.shape$3);
      break matchEnd14
    };
    var x = $m_s_None$();
    if ((x === x1)) {
      var this$7 = this.arrayShapeTypeFromInherits__p3__s_Option();
      var finalShape = (this$7.isEmpty__Z() ? new $c_s_Some().init___O(this.shape$3) : this$7);
      break matchEnd14
    };
    throw new $c_s_MatchError().init___O(x1)
  };
  if ((finalShape instanceof $c_s_Some)) {
    var x2$2 = $as_s_Some(finalShape);
    var parsed = $as_Lamf_core_model_domain_Shape(x2$2.value$2);
    if ((parsed instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape)) {
      var x3 = $as_Lamf_plugins_domain_shapes_models_AnyShape(parsed);
      this.adopt$3.apply__O__O(x3);
      return x3
    }
  };
  var this$8 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1;
  var specification = $m_Lamf_validations_ParserSideValidations$().UnableToParseArray$1;
  var node = this.shape$3.id$1;
  var ast = this.map$3;
  var prop = $m_s_None$();
  var l = ast.location$1;
  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$8, specification, node, prop, "Cannot parse data arrangement shape", l);
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser.prototype.arrayShapeTypeFromInherits__p3__s_Option = (function() {
  var this$1 = this.shape$3;
  var this$2 = $as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).headOption__s_Option();
  if (this$2.isEmpty__Z()) {
    var maybeShape = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var x0$1 = $as_Lamf_core_model_domain_Shape(arg1);
    if ((x0$1 instanceof $c_Lamf_plugins_domain_shapes_models_MatrixShape)) {
      var x2 = $as_Lamf_plugins_domain_shapes_models_MatrixShape(x0$1);
      var jsx$1 = $as_Lamf_core_model_domain_Shape(x2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1))
    } else if ((x0$1 instanceof $c_Lamf_plugins_domain_shapes_models_TupleShape)) {
      var x3 = $as_Lamf_plugins_domain_shapes_models_TupleShape(x0$1);
      var jsx$1 = $as_Lamf_core_model_domain_Shape($as_sc_Seq(x3.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().TupleItems$2)).head__O())
    } else if ((x0$1 instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
      var x4 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(x0$1);
      var jsx$1 = $as_Lamf_core_model_domain_Shape(x4.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1))
    } else {
      if ((x0$1 === null)) {
        throw new $c_s_MatchError().init___O(x0$1)
      };
      var jsx$1 = x0$1
    };
    var maybeShape = new $c_s_Some().init___O(jsx$1)
  };
  var rc15 = false;
  var x2$1 = null;
  if ((maybeShape instanceof $c_s_Some)) {
    rc15 = true;
    x2$1 = $as_s_Some(maybeShape);
    if ((x2$1.value$2 instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
      return new $c_s_Some().init___O(this.shape$3.toMatrixShape__Lamf_plugins_domain_shapes_models_MatrixShape())
    }
  };
  if ((rc15 && (x2$1.value$2 instanceof $c_Lamf_plugins_domain_shapes_models_MatrixShape))) {
    return new $c_s_Some().init___O(this.shape$3.toMatrixShape__Lamf_plugins_domain_shapes_models_MatrixShape())
  };
  if ((rc15 && (x2$1.value$2 instanceof $c_Lamf_plugins_domain_shapes_models_TupleShape))) {
    return new $c_s_Some().init___O(this.shape$3.toMatrixShape__Lamf_plugins_domain_shapes_models_MatrixShape())
  };
  if ((rc15 && (x2$1.value$2 !== null))) {
    return new $c_s_Some().init___O(this.shape$3)
  };
  return $m_s_None$()
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser.prototype.map__Lorg_yaml_model_YMap = (function() {
  return this.map$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser.prototype.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$SchemaUsageRestrictions$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser = (function() {
  return this.$$outer$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser.prototype.shape__Lamf_core_model_domain_Shape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser.prototype.shape__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser.prototype.parseItems__p3__V = (function() {
  var map = this.map$3;
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("items");
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var itemsEntry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var x$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(items$2) {
        var items = $as_Lamf_core_model_domain_Shape(items$2);
        items.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject($this.shape$3.id$1, items.adopted$default$2__sc_Seq())
      })
    })(this));
    var x$3 = this.$$outer$1.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$defaultType$f;
    var x$4 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo().init___Z__Z(false, false);
    var this$4 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(itemsEntry, x$2, x$4, x$3, this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext()).parse__s_Option();
    if (this$4.isEmpty__Z()) {
      /*<skip>*/
    } else {
      var arg1$1 = this$4.get__O();
      var item = $as_Lamf_core_model_domain_Shape(arg1$1);
      var jsx$1 = $m_sc_Seq$();
      var array = [item];
      var elements = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
      var this$7 = this.shape$3;
      var location = $f_Lamf_core_model_domain_ExternalSourceElement__location__s_Option(this$7);
      var jsx$2 = $m_Lamf_core_parser_Range$();
      var this$8 = itemsEntry.location$1;
      var entryRange = jsx$2.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$8.lineFrom$1, this$8.columnFrom$1, this$8.lineTo$1, this$8.columnTo$1));
      $f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$SchemaUsageRestrictions__checkSchemaInProperty__sc_Seq__s_Option__Lamf_core_parser_Range__V(this, elements, location, entryRange);
      new $c_s_Some().init___O(this.shape$3.withItems__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_ArrayShape(item))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$ArrayShapeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$ArrayShapeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$ArrayShapeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_ExampleParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$SchemaUsageRestrictions: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ArrayShapeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.call(this);
  this.node$3 = null;
  this.file$3 = null;
  this.adopt$3 = null;
  this.map$3 = null;
  this.shape$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser.prototype.productPrefix__T = (function() {
  return "FileShapeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser(x$1).$$outer$1 === this.$$outer$1))) {
    var FileShapeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser(x$1);
    var this$1 = this.node$3;
    var b = FileShapeParser$1.node$3;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var x = this.file$3;
      var x$2 = FileShapeParser$1.file$3;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$3 = this.adopt$3;
      var x$4 = FileShapeParser$1.adopt$3;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.node$3;
      break
    }
    case 1: {
      return this.file$3;
      break
    }
    case 2: {
      return this.adopt$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YNode__Lamf_plugins_domain_shapes_models_FileShape__F1 = (function($$outer, node, file, adopt) {
  this.node$3 = node;
  this.file$3 = file;
  this.adopt$3 = adopt;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.call(this, $$outer);
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = $$outer.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  this.map$3 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv));
  this.shape$3 = (adopt.apply__O__O(file), file);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser.prototype.map__Lorg_yaml_model_YMap = (function() {
  return this.map$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser.prototype.shape__Lamf_core_model_domain_Shape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_FileShape = (function() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape.call(this);
  var map = this.map$3;
  var shape = this.shape$3;
  $f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$CommonScalarParsingLogic__parseOASFields__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape__V(this, map, shape);
  var rc6 = false;
  var x2 = null;
  var map$1 = this.map$3;
  var x1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option("fileTypes");
  matchEnd7: {
    if ((x1 instanceof $c_s_Some)) {
      rc6 = true;
      x2 = $as_s_Some(x1);
      var entry = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var this$2 = entry.value$2;
      var x = this$2.tag__Lorg_yaml_model_YTag().tagType$3;
      var x$2 = $m_Lorg_yaml_model_YType$().Seq$1;
      if ((x === x$2)) {
        var this$6 = this.shape$3;
        var field = $m_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$().FileTypes$1;
        var this$3 = entry.value$2;
        var conversion = $m_Lorg_yaml_convert_YRead$YSeqYRead$();
        var iv = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
        var jsx$2 = $as_Lorg_yaml_model_YSequence($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv)).nodes$3;
        var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(n$2) {
            var n = $as_Lorg_yaml_model_YNode(n$2);
            var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
            var iv$1 = $this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
            return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(n, conversion$1, iv$1)).text$3, new $c_Lamf_core_parser_Annotations().init___())
          })
        })(this));
        var this$5 = $m_sc_IndexedSeq$();
        var values = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBF$6));
        var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry.value$2);
        $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$6, field, values, annotations);
        break matchEnd7
      }
    };
    if (rc6) {
      var entry$2 = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var this$7 = entry$2.value$2;
      var x$3 = this$7.tag__Lorg_yaml_model_YTag().tagType$3;
      var x$4 = $m_Lorg_yaml_model_YType$().Str$1;
      if ((x$3 === x$4)) {
        var this$12 = this.shape$3;
        var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$().FileTypes$1;
        var jsx$3 = $m_sc_Seq$();
        var this$8 = entry$2.value$2;
        var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
        var iv$2 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
        var array = [new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$8, conversion$2, iv$2)).text$3, new $c_Lamf_core_parser_Annotations().init___())];
        var values$1 = $as_sc_Seq(jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
        var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$2.value$2);
        $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$12, field$1, values$1, annotations$1);
        break matchEnd7
      }
    };
    if (rc6) {
      var entry$3 = $as_Lorg_yaml_model_YMapEntry(x2.value$2);
      var this$14 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1;
      var spec = $m_Lamf_validations_ParserSideValidations$().UnexpectedFileTypesSyntax$1;
      var node = this.shape$3.id$1;
      var prop = new $c_s_Some().init___O($m_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$().FileTypes$1.value$1.iri__T());
      var this$13 = entry$3.value$2;
      var msg = ("Unexpected syntax for the fileTypes property: " + this$13.tag__Lorg_yaml_model_YTag().tagType$3);
      var ast = entry$3.value$2;
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$14, spec, node, prop, msg, l);
      break matchEnd7
    }
  };
  var map$2 = this.map$3;
  var this$17 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("minimum").asRamlAnnotation__T();
  var this$18 = this$17.key__T__s_Option(keyword);
  if ((!this$18.isEmpty__Z())) {
    var arg1 = this$18.get__O();
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1);
    var node$1 = entry$4.value$2;
    var iv$3 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
    var value = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$1, iv$3);
    var this$20 = this.shape$3;
    var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Minimum$1;
    var value$1 = value.text__Lamf_core_model_domain_AmfScalar();
    var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$20, field$2, value$1, annotations$2)
  };
  var map$3 = this.map$3;
  var this$23 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3);
  var keyword$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T("maximum").asRamlAnnotation__T();
  var this$24 = this$23.key__T__s_Option(keyword$1);
  if ((!this$24.isEmpty__Z())) {
    var arg1$1 = this$24.get__O();
    var entry$5 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var node$2 = entry$5.value$2;
    var iv$4 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
    var value$2 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$2, iv$4);
    var this$26 = this.shape$3;
    var field$3 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Maximum$1;
    var value$3 = value$2.text__Lamf_core_model_domain_AmfScalar();
    var annotations$3 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$5);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$26, field$3, value$3, annotations$3)
  };
  var map$4 = this.map$3;
  var jsx$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$4);
  var jsx$4 = new $c_Lamf_core_utils_package$AmfStrings().init___T("format").asRamlAnnotation__T();
  var this$29 = this.$$outer$1;
  var field$4 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Format$1;
  var iv$5 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$5.key__T__F1__V(jsx$4, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$29, field$4, iv$5).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$3));
  var map$5 = this.map$3;
  var this$31 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$5);
  var this$32 = this$31.key__T__s_Option("multipleOf");
  if ((!this$32.isEmpty__Z())) {
    var arg1$2 = this$32.get__O();
    var entry$6 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var node$3 = entry$6.value$2;
    var iv$6 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
    var value$4 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$3, iv$6);
    var this$34 = this.shape$3;
    var field$5 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MultipleOf$1;
    var value$5 = value$4.text__Lamf_core_model_domain_AmfScalar();
    var annotations$4 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$6);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$34, field$5, value$5, annotations$4)
  };
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser.prototype.shape__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser.prototype.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser = (function() {
  return this.$$outer$1
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$FileShapeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$FileShapeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$FileShapeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_ExampleParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$CommonScalarParsingLogic: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$FileShapeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.call(this);
  this.shape$3 = null;
  this.map$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lamf_plugins_domain_shapes_models_NodeShape__Lorg_yaml_model_YMap = (function($$outer, shape, map) {
  this.shape$3 = shape;
  this.map$3 = map;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.call(this, $$outer);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser.prototype.productPrefix__T = (function() {
  return "NodeShapeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser(x$1).$$outer$1 === this.$$outer$1))) {
    var NodeShapeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser(x$1);
    var x = this.shape$3;
    var x$2 = NodeShapeParser$1.shape$3;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var this$1 = this.map$3;
      var b = NodeShapeParser$1.map$3;
      return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.shape$3;
      break
    }
    case 1: {
      return this.map$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape.call(this);
  this.checkExtendedUnionDiscriminator__V();
  var map = this.map$3;
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$2 = this.$$outer$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MinProperties$1;
  var iv = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$1.key__T__F1__V("minProperties", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$2, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$3).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var map$1 = this.map$3;
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var this$4 = this.$$outer$1;
  var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MaxProperties$1;
  var iv$1 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$2.key__T__F1__V("maxProperties", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$4, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$3).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var this$5 = this.shape$3;
  if ($as_sc_Seq(this$5.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).isEmpty__Z()) {
    var this$6 = this.shape$3;
    var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1;
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$6, field$2, false)
  } else {
    var map$2 = this.map$3;
    if (new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2).key__T__s_Option("additionalProperties").isEmpty__Z()) {
      var closedInInhertiance = this.shape$3.effectiveInherits__sc_Seq().exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(s$2) {
          var s = $as_Lamf_core_model_domain_Shape(s$2);
          if ((s instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
            var this$8 = $as_Lamf_plugins_domain_shapes_models_NodeShape(s);
            var jsx$3 = $as_Lamf_core_model_BoolField(this$8.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1)).option$1.isDefined__Z()
          } else {
            var jsx$3 = false
          };
          if (jsx$3) {
            var this$9 = $as_Lamf_plugins_domain_shapes_models_NodeShape(s);
            var this$10 = $as_Lamf_core_model_BoolField(this$9.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1));
            return $f_Lamf_core_model_BoolField__value__Z(this$10)
          } else {
            return false
          }
        })
      })(this)));
      var this$11 = this.shape$3;
      var field$3 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1;
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$11, field$3, closedInInhertiance)
    }
  };
  var map$3 = this.map$3;
  var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3);
  var this$13 = this.$$outer$1;
  var field$4 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1;
  var iv$2 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  var this$14 = new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$13, field$4, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$3).negated__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField();
  jsx$4.key__T__F1__V("additionalProperties", this$14.withAnnotation__Lamf_core_model_domain_Annotation__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(new $c_Lamf_core_annotations_ExplicitField().init___()));
  var map$4 = this.map$3;
  var this$17 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$4).key__T__s_Option(new $c_Lamf_core_utils_package$AmfStrings().init___T("additionalProperties").asRamlAnnotation__T());
  if ((!this$17.isEmpty__Z())) {
    var arg1 = this$17.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$18 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser(this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().typeParser__F4().apply__O__O__O__O__O(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1) {
      return (function(s$2$1) {
        var s$1 = $as_Lamf_core_model_domain_Shape(s$2$1);
        s$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject($this$1.shape$3.id$1, s$1.adopted$default$2__sc_Seq())
      })
    })(this)), true, this.$$outer$1.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$defaultType$f)).parse__s_Option();
    if ((!this$18.isEmpty__Z())) {
      var arg1$1 = this$18.get__O();
      var parsed = $as_Lamf_core_model_domain_Shape(arg1$1);
      var this$19 = this.shape$3;
      var field$5 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().AdditionalPropertiesSchema$1;
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
      $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$19, field$5, parsed, annotations))
    }
  };
  var map$5 = this.map$3;
  var jsx$5 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$5);
  var this$21 = this.$$outer$1;
  var field$6 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Discriminator$1;
  var iv$3 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$5.key__T__F1__V("discriminator", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$21, field$6, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$3).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var map$6 = this.map$3;
  var jsx$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$6);
  var this$23 = this.$$outer$1;
  var field$7 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().DiscriminatorValue$1;
  var iv$4 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
  jsx$6.key__T__F1__V("discriminatorValue", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this$23, field$7, iv$4).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(this.shape$3).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
  var map$7 = this.map$3;
  var this$25 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$7);
  var this$26 = this$25.key__T__s_Option("properties");
  if ((!this$26.isEmpty__Z())) {
    var arg1$2 = this$26.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var this$27 = entry$3.value$2;
    var x1 = this$27.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x === x1)) {
      var this$28 = entry$3.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv$5 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
      var m = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$28, conversion, iv$5));
      var properties = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$PropertiesParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YMap__F1(this.$$outer$1, m, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2) {
        return (function(name$2) {
          var name = $as_T(name$2);
          return $this$2.shape$3.withProperty__T__Lamf_core_model_domain_extensions_PropertyShape(name)
        })
      })(this))).parse__sc_Seq();
      var hasPatternProperties = properties.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
        return (function(x$23$2) {
          var x$23 = $as_Lamf_core_model_domain_extensions_PropertyShape(x$23$2);
          var this$29 = $as_Lamf_core_model_StrField(x$23.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().PatternName$1));
          return $f_Lamf_core_model_StrField__nonEmpty__Z(this$29)
        })
      })(this)));
      if (hasPatternProperties) {
        var this$30 = this.shape$3;
        var this$31 = $as_Lamf_core_model_BoolField(this$30.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1));
        var jsx$7 = $f_Lamf_core_model_BoolField__value__Z(this$31)
      } else {
        var jsx$7 = false
      };
      if (jsx$7) {
        var this$32 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().PatternPropertiesOnClosedNodeSpecification$1;
        var node = this.shape$3.id$1;
        var ast = this.$$outer$1.node$2;
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$32, specification, node, prop, "Node without additional properties support cannot have pattern properties", l)
      };
      properties.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1, entry$1) {
        return (function(prop$2) {
          var prop$1 = $as_Lamf_core_model_domain_extensions_PropertyShape(prop$2);
          var jsx$8 = $m_sc_Seq$();
          var array = [$as_Lamf_core_model_domain_Shape(prop$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1))];
          var elements = $as_sc_Seq(jsx$8.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
          var location = $f_Lamf_core_model_domain_AmfElement__location__s_Option(prop$1);
          var jsx$9 = $m_Lamf_core_parser_Range$();
          var this$35 = entry$1.location$1;
          var entryRange = jsx$9.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$35.lineFrom$1, this$35.columnFrom$1, this$35.lineTo$1, this$35.columnTo$1));
          $f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$SchemaUsageRestrictions__checkSchemaInProperty__sc_Seq__s_Option__Lamf_core_parser_Range__V(this$3$1, elements, location, entryRange)
        })
      })(this, entry$3)));
      var this$36 = this.shape$3;
      var this$37 = $as_Lamf_core_model_StrField(this$36.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Discriminator$1)).option$1;
      if ((!this$37.isEmpty__Z())) {
        var arg1$3 = this$37.get__O();
        var discriminator = $as_T(arg1$3);
        var containsDiscriminatorProp = properties.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$3, discriminator$1) {
          return (function(x$24$2) {
            var x$24 = $as_Lamf_core_model_domain_extensions_PropertyShape(x$24$2);
            var this$38 = $as_Lamf_core_model_StrField(x$24.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
            var this$39 = this$38.option$1;
            return ($as_T((this$39.isEmpty__Z() ? null : this$39.get__O())) === discriminator$1)
          })
        })(this, discriminator)));
        if ((!containsDiscriminatorProp)) {
          var this$40 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
          var violationId = $m_Lamf_validations_ParserSideValidations$().MissingDiscriminatorProperty$1;
          var node$1 = this.shape$3.id$1;
          var message = (("Property '" + discriminator) + "' marked as discriminator is missing in properties facet");
          var this$41 = this$40.eh$1;
          var location$1 = this$40.rootContextDocument$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__T__V(this$41, violationId, node$1, message, location$1)
        }
      };
      var this$42 = this.shape$3;
      var field$8 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1;
      var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(properties, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3.value$2));
      var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$42, field$8, value, annotations$1)
    } else {
      var x$3 = $m_Lorg_yaml_model_YType$().Null$1;
      if ((!(x$3 === x1))) {
        var this$43 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1;
        var specification$1 = $m_Lamf_validations_ParserSideValidations$().InvalidValueInPropertiesFacet$1;
        var node$2 = this.shape$3.id$1;
        var prop$3 = $m_s_None$();
        var l$1 = entry$3.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$43, specification$1, node$2, prop$3, "Properties facet must be a map of key and values", l$1)
      }
    }
  };
  var properties$1 = $as_scm_LinkedHashMap($m_scm_LinkedHashMap$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  var this$44 = this.shape$3;
  $as_sc_Seq(this$44.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, properties$2) {
    return (function(p$2) {
      var p = $as_Lamf_core_model_domain_extensions_PropertyShape(p$2);
      var this$45 = $as_Lamf_core_model_StrField(p.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
      var this$46 = this$45.option$1;
      var self = $as_T((this$46.isEmpty__Z() ? null : this$46.get__O()));
      properties$2.put__O__O__s_Option(self, p);
      return properties$2
    })
  })(this, properties$1)));
  var map$8 = this.map$3;
  var this$51 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$8);
  var keyword = new $c_Lamf_core_utils_package$AmfStrings().init___T("dependencies").asRamlAnnotation__T();
  var this$52 = this$51.key__T__s_Option(keyword);
  if ((!this$52.isEmpty__Z())) {
    var arg1$4 = this$52.get__O();
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$4);
    var this$53 = entry$4.value$2;
    var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$6 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
    var dependencies = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_ShapeDependenciesParser().init___Lorg_yaml_model_YMap__scm_LinkedHashMap__Lamf_plugins_document_webapi_contexts_WebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$53, conversion$1, iv$6)), properties$1, this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext()).parse__sc_Seq();
    var this$54 = this.shape$3;
    var field$9 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Dependencies$1;
    var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(dependencies, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4.value$2));
    var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4);
    $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$54, field$9, value$1, annotations$2)
  };
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser.prototype.map__Lorg_yaml_model_YMap = (function() {
  return this.map$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser.prototype.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$SchemaUsageRestrictions$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser = (function() {
  return this.$$outer$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser.prototype.shape__Lamf_core_model_domain_Shape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser.prototype.shape__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser.prototype.checkExtendedUnionDiscriminator__V = (function() {
  var this$1 = this.shape$3;
  if (($as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).length__I() === 1)) {
    var this$2 = this.shape$3;
    var jsx$1 = ($as_sc_Seq(this$2.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1)).head__O() instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var map = this.map$3;
    var this$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("discriminator");
    if ((!this$4.isEmpty__Z())) {
      var arg1 = this$4.get__O();
      var x$25 = $as_Lorg_yaml_model_YMapEntry(arg1);
      var this$5 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().DiscriminatorOnExtendedUnionSpecification$1;
      var node = this.shape$3.id$1;
      var prop = $m_s_None$();
      var l = x$25.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$5, specification, node, prop, "Property discriminator forbidden in a node extending a unionShape", l)
    };
    var map$1 = this.map$3;
    var this$7 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1).key__T__s_Option("discriminatorValue");
    if ((!this$7.isEmpty__Z())) {
      var arg1$1 = this$7.get__O();
      var x$26 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
      var this$8 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1;
      var specification$1 = $m_Lamf_validations_ParserSideValidations$().DiscriminatorOnExtendedUnionSpecification$1;
      var node$1 = this.shape$3.id$1;
      var prop$1 = $m_s_None$();
      var l$1 = x$26.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$8, specification$1, node$1, prop$1, "Property discriminatorValue forbidden in a node extending a unionShape", l$1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$NodeShapeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$NodeShapeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$NodeShapeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_ExampleParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$SchemaUsageRestrictions: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$NodeShapeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.call(this);
  this.dataNodeParser$3 = null;
  this.enumParser$3 = null;
  this.typeDef$3 = null;
  this.shape$3 = null;
  this.map$3 = null;
  this.bitmap$0$3 = 0
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype.productPrefix__T = (function() {
  return "ScalarShapeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype.ensurePrecision__s_Option__T__Lorg_yaml_model_YNode__Z = (function(dataType, value, ast) {
  if ((!dataType.isEmpty__Z())) {
    var arg1 = dataType.get__O();
    var x$11 = $as_T(arg1);
    var jsx$1 = $m_sjsr_RuntimeString$().endsWith__T__T__Z(x$11, "#integer")
  } else {
    var jsx$1 = false
  };
  if ((!(jsx$1 && ($uI(value.indexOf(".")) !== (-1))))) {
    return true
  } else {
    var this$4 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().InvalidDecimalPoint$1;
    var node = this.shape$3.id$1;
    var message = ("Invalid decimal point for an integer: " + value);
    var prop = $m_s_None$();
    var l = ast.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$4, specification, node, prop, message, l);
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser(x$1).$$outer$1 === this.$$outer$1))) {
    var ScalarShapeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser(x$1);
    var x = this.typeDef$3;
    var x$2 = ScalarShapeParser$1.typeDef$3;
    if ((x === x$2)) {
      var x$3 = this.shape$3;
      var x$4 = ScalarShapeParser$1.shape$3;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var this$1 = this.map$3;
      var b = ScalarShapeParser$1.map$3;
      return $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.typeDef$3;
      break
    }
    case 1: {
      return this.shape$3;
      break
    }
    case 2: {
      return this.map$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype.enumParser$lzycompute__p3__F1 = (function() {
  if (((((2 & this.bitmap$0$3) << 24) >> 24) === 0)) {
    this.enumParser$3 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_CommonEnumParser$().apply__T__T__Lamf_plugins_document_webapi_contexts_WebApiContext__F1(this.shape$3.id$1, $m_Lamf_plugins_document_webapi_parser_spec_declaration_EnumParsing$().SCALAR$undENUM$1, this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext());
    this.bitmap$0$3 = (((2 | this.bitmap$0$3) << 24) >> 24)
  };
  return this.enumParser$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype.map__Lorg_yaml_model_YMap = (function() {
  return this.map$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_ScalarShape = (function() {
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype.parse__Lamf_plugins_domain_shapes_models_AnyShape.call(this);
  var map = this.map$3;
  var shape = this.shape$3;
  $f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$CommonScalarParsingLogic__parseOASFields__Lorg_yaml_model_YMap__Lamf_core_model_domain_Shape__V(this, map, shape);
  var validatedTypeDef = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_ScalarFormatType().init___Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_document_webapi_contexts_WebApiContext(this.shape$3, this.typeDef$3, this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext()).parse__Lorg_yaml_model_YMap__Lamf_plugins_domain_shapes_models_TypeDef(this.map$3);
  this.ensureFormatInDateTime__p3__Lamf_plugins_domain_shapes_models_TypeDef__V(validatedTypeDef);
  var this$1 = this.$$outer$1.typeOrSchema__Lorg_yaml_model_YMap__s_Option(this.map$3);
  if (this$1.isEmpty__Z()) {
    var this$4 = this.shape$3;
    var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
    var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$().xsd__Lamf_plugins_domain_shapes_models_TypeDef__T(validatedTypeDef), new $c_Lamf_core_parser_Annotations().init___());
    var annotations = ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()).$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_Inferred().init___());
    $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$4, field, value, annotations))
  } else {
    var arg1 = this$1.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$6 = this.shape$3;
    var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
    var value$1 = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations($m_Lamf_plugins_domain_shapes_parser_XsdTypeDefMapping$().xsd__Lamf_plugins_domain_shapes_models_TypeDef__T(validatedTypeDef), new $c_Lamf_core_parser_Annotations().init___());
    var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
    $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$6, field$1, value$1, annotations$1))
  };
  var map$1 = this.map$3;
  var this$8 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$1);
  var this$9 = this$8.key__T__s_Option("minimum");
  if ((!this$9.isEmpty__Z())) {
    var arg1$1 = this$9.get__O();
    var entry$3 = $as_Lorg_yaml_model_YMapEntry(arg1$1);
    var node = entry$3.value$2;
    var iv = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
    var value$2 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node, iv);
    var this$11 = this.shape$3;
    if (this.ensurePrecision__s_Option__T__Lorg_yaml_model_YNode__Z($as_Lamf_core_model_StrField(this$11.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1)).option$1, entry$3.value$2.toString__T(), entry$3.value$2)) {
      var this$12 = this.shape$3;
      var field$2 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Minimum$1;
      var value$3 = value$2.text__Lamf_core_model_domain_AmfScalar();
      var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$3);
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$12, field$2, value$3, annotations$2)
    }
  };
  var map$2 = this.map$3;
  var this$14 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$2);
  var this$15 = this$14.key__T__s_Option("maximum");
  if ((!this$15.isEmpty__Z())) {
    var arg1$2 = this$15.get__O();
    var entry$4 = $as_Lorg_yaml_model_YMapEntry(arg1$2);
    var node$1 = entry$4.value$2;
    var iv$1 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
    var value$4 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$1, iv$1);
    var this$17 = this.shape$3;
    if (this.ensurePrecision__s_Option__T__Lorg_yaml_model_YNode__Z($as_Lamf_core_model_StrField(this$17.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1)).option$1, entry$4.value$2.toString__T(), entry$4.value$2)) {
      var this$18 = this.shape$3;
      var field$3 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Maximum$1;
      var value$5 = value$4.text__Lamf_core_model_domain_AmfScalar();
      var annotations$3 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$4);
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$18, field$3, value$5, annotations$3)
    }
  };
  var map$3 = this.map$3;
  var this$20 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map$3);
  var this$21 = this$20.key__T__s_Option("multipleOf");
  if ((!this$21.isEmpty__Z())) {
    var arg1$3 = this$21.get__O();
    var entry$5 = $as_Lorg_yaml_model_YMapEntry(arg1$3);
    var node$2 = entry$5.value$2;
    var iv$2 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
    var value$6 = new $c_Lamf_core_parser_DefaultScalarNode().init___Lorg_yaml_model_YNode__Lorg_yaml_model_IllegalTypeHandler(node$2, iv$2);
    var this$23 = this.shape$3;
    if (this.ensurePrecision__s_Option__T__Lorg_yaml_model_YNode__Z($as_Lamf_core_model_StrField(this$23.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1)).option$1, entry$5.value$2.toString__T(), entry$5.value$2)) {
      var this$24 = this.shape$3;
      var field$4 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MultipleOf$1;
      var value$7 = value$6.text__Lamf_core_model_domain_AmfScalar();
      var annotations$4 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry$5);
      $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$24, field$4, value$7, annotations$4)
    }
  };
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype.shape__Lamf_core_model_domain_Shape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype.ensureFormatInDateTime__p3__Lamf_plugins_domain_shapes_models_TypeDef__V = (function(typeDef) {
  var x = $m_Lamf_plugins_domain_shapes_models_TypeDef$DateTimeType$();
  if ((x === typeDef)) {
    var this$1 = this.shape$3;
    var this$2 = $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__format__Lamf_core_model_StrField(this$1).option$1;
    if ((!this$2.isEmpty__Z())) {
      var arg1 = this$2.get__O();
      var format = $as_T(arg1);
      if (((format !== "rfc3339") && (format !== "rfc2616"))) {
        var this$3 = this.$$outer$1.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext().eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().InvalidDatetimeFormat$1;
        var node = this.shape$3.id$1;
        var ast = this.$$outer$1.ast$2;
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$3, specification, node, prop, "Invalid format value for datetime, must be 'rfc3339' or 'rfc2616'", l)
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype.shape__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this.shape$3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype.enumParser__F1 = (function() {
  return (((((2 & this.bitmap$0$3) << 24) >> 24) === 0) ? this.enumParser$lzycompute__p3__F1() : this.enumParser$3)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$CommonScalarParsingLogic$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser = (function() {
  return this.$$outer$1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lamf_plugins_domain_shapes_models_TypeDef__Lamf_plugins_domain_shapes_models_ScalarShape__Lorg_yaml_model_YMap = (function($$outer, typeDef, shape, map) {
  this.typeDef$3 = typeDef;
  this.shape$3 = shape;
  this.map$3 = map;
  $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser.call(this, $$outer);
  return this
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$ScalarShapeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$ScalarShapeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$ScalarShapeParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$AnyShapeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ShapeParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_ExampleParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$CommonScalarParsingLogic: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$ScalarShapeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser.call(this);
  this.DocumentationItemFragmentParser$module$2 = null;
  this.DataTypeFragmentParser$module$2 = null;
  this.AnnotationFragmentParser$module$2 = null;
  this.ResourceTypeFragmentParser$module$2 = null;
  this.TraitFragmentParser$module$2 = null;
  this.SecuritySchemeFragmentParser$module$2 = null;
  this.NamedExampleFragmentParser$module$2 = null;
  this.root$2 = null;
  this.fragment$2 = null;
  this.ctx$2 = null;
  this.platform$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser();
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser.prototype.productPrefix__T = (function() {
  return "OasFragmentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser)) {
    var OasFragmentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser(x$1);
    var x = this.root$2;
    var x$2 = OasFragmentParser$1.root$2;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.fragment$2;
      var x$4 = OasFragmentParser$1.fragment$2;
      return ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.root$2;
      break
    }
    case 1: {
      return this.fragment$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser.prototype.detectType__s_Option = (function() {
  var this$1 = this.fragment$2;
  return (this$1.isEmpty__Z() ? $m_Lamf_plugins_document_webapi_parser_OasHeader$().apply__Lamf_core_Root__s_Option(this.root$2) : this$1)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser.prototype.init___Lamf_core_Root__s_Option__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(root, fragment, ctx) {
  this.root$2 = root;
  this.fragment$2 = fragment;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser.prototype.init___Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.call(this, ctx);
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$2 = this$1.platform$1;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser.prototype.parseFragment__Lamf_core_model_document_BaseUnit = (function() {
  var this$1 = $as_Lamf_core_parser_SyamlParsedDocument(this.root$2.parsed$1).document$2;
  var evidence$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var x1 = this$1.obj__Lorg_yaml_model_YObj().to__Lorg_yaml_convert_YRead__s_util_Either(evidence$1);
  if ((x1 instanceof $c_s_util_Right)) {
    var x2 = $as_s_util_Right(x1);
    var m = $as_Lorg_yaml_model_YMap(x2.value$2);
    var map = m
  } else {
    var this$2 = this.ctx$2.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().InvalidFragmentType$1;
    var node = this.root$2.location$1;
    var ast = $as_Lamf_core_parser_SyamlParsedDocument(this.root$2.parsed$1).document$2;
    var prop = $m_s_None$();
    var l = ast.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$2, specification, node, prop, "Cannot parse empty map", l);
    var map = $m_Lorg_yaml_model_YMap$().empty$1
  };
  var this$3 = this.detectType__s_Option();
  if (this$3.isEmpty__Z()) {
    var this$5 = $m_s_None$()
  } else {
    var arg1 = this$3.get__O();
    var x0$1 = $as_Lamf_plugins_document_webapi_parser_OasHeader(arg1);
    var x = $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DocumentationItem$();
    if ((x === x0$1)) {
      var this$5 = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DocumentationItemFragmentParser().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser__Lorg_yaml_model_YMap(this, map).parse__Lamf_plugins_document_webapi_model_DocumentationItemFragment())
    } else {
      var x$3 = $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20DataType$();
      if ((x$3 === x0$1)) {
        var this$5 = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$DataTypeFragmentParser().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser__Lorg_yaml_model_YMap(this, map).parse__Lamf_plugins_document_webapi_model_DataTypeFragment())
      } else {
        var x$5 = $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20ResourceType$();
        if ((x$5 === x0$1)) {
          var this$5 = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$ResourceTypeFragmentParser().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser__Lorg_yaml_model_YMap(this, map).parse__Lamf_plugins_document_webapi_model_ResourceTypeFragment())
        } else {
          var x$7 = $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Trait$();
          if ((x$7 === x0$1)) {
            var this$5 = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$TraitFragmentParser().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser__Lorg_yaml_model_YMap(this, map).parse__Lamf_plugins_document_webapi_model_TraitFragment())
          } else {
            var x$9 = $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20AnnotationTypeDeclaration$();
            if ((x$9 === x0$1)) {
              var this$5 = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$AnnotationFragmentParser().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser__Lorg_yaml_model_YMap(this, map).parse__Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment())
            } else {
              var x$11 = $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20SecurityScheme$();
              if ((x$11 === x0$1)) {
                var this$5 = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$SecuritySchemeFragmentParser().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser__Lorg_yaml_model_YMap(this, map).parse__Lamf_plugins_document_webapi_model_SecuritySchemeFragment())
              } else {
                var x$13 = $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20NamedExample$();
                if ((x$13 === x0$1)) {
                  var this$5 = new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser$NamedExampleFragmentParser().init___Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser__Lorg_yaml_model_YMap(this, map).parse__Lamf_plugins_document_webapi_model_NamedExampleFragment())
                } else {
                  var x$15 = $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas20Header$();
                  if ((x$15 === x0$1)) {
                    var jsx$1 = true
                  } else {
                    var x$17 = $m_Lamf_plugins_document_webapi_parser_OasHeader$Oas30Header$();
                    var jsx$1 = (x$17 === x0$1)
                  };
                  if (jsx$1) {
                    var this$5 = new $c_Lamf_plugins_document_webapi_ExternalJsonYamlRefsPlugin().init___().parse__Lamf_core_Root__Lamf_core_parser_ParserContext__Lamf_core_remote_Platform__Lamf_core_client_ParsingOptions__s_Option(this.root$2, this.ctx$2, this.platform$2, new $c_Lamf_core_client_ParsingOptions().init___())
                  } else {
                    var this$5 = $m_s_None$()
                  }
                }
              }
            }
          }
        }
      }
    }
  };
  if (this$5.isEmpty__Z()) {
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var this$9 = new $c_Lamf_core_model_document_ExternalFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
    var location = this.root$2.location$1;
    var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
    var this$10 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$9, field, location));
    var value = this.root$2.location$1;
    var this$15 = $as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$10, value));
    $m_Lamf_core_parser_Annotations$();
    var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
    var this$14 = new $c_Lamf_core_model_domain_ExternalDomainElement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
    var text = this.root$2.raw$1;
    var field$1 = $m_Lamf_core_metamodel_domain_ExternalDomainElementModel$().Raw$1;
    var encoded = $as_Lamf_core_model_domain_ExternalDomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$14, field$1, text));
    var field$2 = $m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1;
    var fragment = $as_Lamf_core_model_document_ExternalFragment($as_Lamf_core_model_document_EncodesModel($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$15, field$2, encoded)));
    var this$16 = this.ctx$2.eh$1;
    var specification$1 = $m_Lamf_validations_ParserSideValidations$().InvalidFragmentType$1;
    var node$1 = fragment.id$1;
    var prop$1 = $m_s_None$();
    var l$1 = map.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$16, specification$1, node$1, prop$1, "Unsupported oas type", l$1);
    var jsx$2 = fragment
  } else {
    var jsx$2 = this$5.get__O()
  };
  var fragment$1 = $as_Lamf_core_model_document_BaseUnit(jsx$2);
  var references = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser().init___Lamf_core_model_document_BaseUnit__T__Lorg_yaml_model_YMap__sc_Seq__Lamf_plugins_document_webapi_contexts_WebApiContext(fragment$1, new $c_Lamf_core_utils_package$AmfStrings().init___T("uses").asOasExtension__T(), map, this.root$2.references$1, this.ctx$2).parse__T__Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations(this.root$2.location$1);
  var location$1 = this.root$2.location$1;
  var field$3 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
  var this$18 = $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(fragment$1, field$3, location$1));
  var other = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations($as_Lamf_core_parser_SyamlParsedDocument(this.root$2.parsed$1).document$2);
  $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfElement(this$18, other);
  new $c_Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser$UsageParser().init___Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser__Lorg_yaml_model_YMap__Lamf_core_model_document_BaseUnit(this, map, fragment$1).parse__V();
  var this$19 = references.references$1;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$19)) {
    var references$1 = references.solvedReferences__sc_Seq();
    var field$4 = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
    $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(fragment$1, field$4, references$1))
  };
  return fragment$1
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.OasFragmentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.OasFragmentParser", {
  Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_WebApiBaseSpecParser: 1,
  Lamf_core_parser_BaseSpecParser: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_OasFragmentParser;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$() {
  $c_O.call(this);
  this.DisplayName$1 = null;
  this.Summary$1 = null;
  this.Description$1 = null;
  this.ExternalValue$1 = null;
  this.StructuredValue$1 = null;
  this.Strict$1 = null;
  this.MediaType$1 = null;
  this.key$1 = null;
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Name$1 = null;
  this.Raw$1 = null;
  this.ReferenceId$1 = null;
  this.Location$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype.constructor = $c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_metamodel_ExampleModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype = $c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype;
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_shapes_metamodel_ExampleModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ExternalSourceElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_ExampleModel__$$init$__V(this);
  return this
});
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Raw$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Raw$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype.CustomDomainProperties__Lamf_core_metamodel_Field = (function() {
  return (((((2 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.CustomDomainProperties$lzycompute__p1__Lamf_core_metamodel_Field() : this.CustomDomainProperties$1)
});
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_shapes_models_Example().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$ReferenceId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReferenceId$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype.CustomDomainProperties$lzycompute__p1__Lamf_core_metamodel_Field = (function() {
  if (((((2 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.CustomDomainProperties$1 = $f_Lamf_core_metamodel_domain_DomainElementModel__CustomDomainProperties__Lamf_core_metamodel_Field(this);
    this.bitmap$0$1 = (((2 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.CustomDomainProperties$1
});
var $d_Lamf_plugins_domain_shapes_metamodel_ExampleModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_metamodel_ExampleModel$: 0
}, false, "amf.plugins.domain.shapes.metamodel.ExampleModel$", {
  Lamf_plugins_domain_shapes_metamodel_ExampleModel$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_metamodel_ExampleModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_ExternalSourceElementModel: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1
});
$c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$.prototype.$classData = $d_Lamf_plugins_domain_shapes_metamodel_ExampleModel$;
var $n_Lamf_plugins_domain_shapes_metamodel_ExampleModel$ = (void 0);
function $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$() {
  if ((!$n_Lamf_plugins_domain_shapes_metamodel_ExampleModel$)) {
    $n_Lamf_plugins_domain_shapes_metamodel_ExampleModel$ = new $c_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_metamodel_ExampleModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_Example() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.platform$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_shapes_models_Example.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_Example.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_Example;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_Example() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_Example.prototype = $c_Lamf_plugins_domain_shapes_models_Example.prototype;
$c_Lamf_plugins_domain_shapes_models_Example.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$5 = new $c_Lamf_plugins_domain_shapes_models_Example().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value))
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$()
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-example" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/example/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_ExternalSourceElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_shapes_models_Example().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Name$1
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.key__Lamf_core_model_StrField = (function() {
  return $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().key$1))
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
function $as_Lamf_plugins_domain_shapes_models_Example(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_models_Example) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.models.Example"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_models_Example(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_models_Example)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_models_Example(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_models_Example(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.models.Example;", depth))
}
var $d_Lamf_plugins_domain_shapes_models_Example = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_Example: 0
}, false, "amf.plugins.domain.shapes.models.Example", {
  Lamf_plugins_domain_shapes_models_Example: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_ExternalSourceElement: 1,
  Lamf_plugins_document_webapi_parser_spec_common_PayloadSerializer: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_domain_webapi_models_Key: 1
});
$c_Lamf_plugins_domain_shapes_models_Example.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_Example;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.key$1 = null;
  this.doc$1 = null;
  this.Headers$1 = null;
  this.BindingVersion$1 = null;
  this.Type$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingType__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders__$$init$__V(this);
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "HttpMessageBinding");
  var this$3 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$3);
  this.key$1 = this.Type$1;
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "HttpMessageBinding", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingType$$undsetter$und$Type$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Type$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Headers$1, this.BindingVersion$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel$().fields__sci_List();
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingVersion$$undsetter$und$BindingVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.BindingVersion$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingHeaders$$undsetter$und$Headers$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Headers$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.HttpMessageBindingModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingType: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$() {
  $c_O.call(this);
  this.OperationType$1 = null;
  this.Method$1 = null;
  this.type$1 = null;
  this.key$1 = null;
  this.doc$1 = null;
  this.Query$1 = null;
  this.BindingVersion$1 = null;
  this.Type$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingType__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.OperationType$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "operationType"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "type", "Type of operation", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Method$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "method"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "method", "Operation binding method", $m_sci_Nil$()), true);
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "HttpOperationBinding");
  var this$9 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$9);
  this.key$1 = this.Type$1;
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "HttpOperationBinding", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingQuery$$undsetter$und$Query$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Query$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingType$$undsetter$und$Type$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Type$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.OperationType$1, this.Method$1, this.Query$1, this.BindingVersion$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel$().fields__sci_List();
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingVersion$$undsetter$und$BindingVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.BindingVersion$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.HttpOperationBindingModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingType: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_Callback() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_Callback.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_Callback;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_Callback() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_Callback.prototype = $c_Lamf_plugins_domain_webapi_models_Callback.prototype;
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.productPrefix__T = (function() {
  return "Callback"
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_Callback)) {
    var Callback$1 = $as_Lamf_plugins_domain_webapi_models_Callback(x$1);
    var x = this.fields$1;
    var x$2 = Callback$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = Callback$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_Callback().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  var callback = $as_Lamf_plugins_domain_webapi_models_Callback($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value));
  var this$5 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$().Name$1)).option$1;
  if ((!this$5.isEmpty__Z())) {
    var arg1 = this$5.get__O();
    var x$1 = $as_T(arg1);
    $m_Lamf_core_parser_Annotations$();
    var a = new $c_Lamf_core_parser_Annotations().init___();
    $as_Lamf_plugins_domain_webapi_models_Callback($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(callback, x$1, a))
  };
  var this$7 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$().Expression$1)).option$1;
  if ((!this$7.isEmpty__Z())) {
    var arg1$1 = this$7.get__O();
    var expression = $as_T(arg1$1);
    var field = $m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$().Expression$1;
    $as_Lamf_plugins_domain_webapi_models_Callback($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(callback, field, expression))
  };
  return callback
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$()
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-callback" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  var jsx$1 = $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url);
  var this$5 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$().Expression$1)).option$1;
  var str$1 = $as_T((this$5.isEmpty__Z() ? "default-expression" : this$5.get__O()));
  var this$7 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str$1);
  var this$8 = this$7.platform$1;
  var url$1 = this$7.str$1;
  return ((("/" + jsx$1) + "/") + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$8, url$1))
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annot$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annot = $as_Lamf_core_parser_Annotations(annot$2);
      return new $c_Lamf_plugins_domain_webapi_models_Callback().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annot)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$().Name$1
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.withEndpoint__T__Lamf_plugins_domain_webapi_models_EndPoint = (function(path) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_EndPoint().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1;
  var result = $as_Lamf_plugins_domain_webapi_models_EndPoint($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, path));
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$().Endpoint$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field$1, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_Callback(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_Callback) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.Callback"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_Callback(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_Callback)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_Callback(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_Callback(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.Callback;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_Callback = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_Callback: 0
}, false, "amf.plugins.domain.webapi.models.Callback", {
  Lamf_plugins_domain_webapi_models_Callback: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_Callback.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_Callback;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_Tag() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_Tag.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_Tag;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_Tag() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_Tag.prototype = $c_Lamf_plugins_domain_webapi_models_Tag.prototype;
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.productPrefix__T = (function() {
  return "Tag"
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.documentations__sc_Seq = (function() {
  var jsx$1 = $m_sc_Seq$();
  var array = [$as_Lamf_plugins_domain_shapes_models_CreativeWork(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TagModel$().Documentation$1))];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_Tag)) {
    var Tag$1 = $as_Lamf_plugins_domain_webapi_models_Tag(x$1);
    var x = this.fields$1;
    var x$2 = Tag$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = Tag$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_TagModel$()
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TagModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-type" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/tag/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_TagModel$().Name$1
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
function $as_Lamf_plugins_domain_webapi_models_Tag(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_Tag) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.Tag"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_Tag(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_Tag)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_Tag(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_Tag(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.Tag;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_Tag = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_Tag: 0
}, false, "amf.plugins.domain.webapi.models.Tag", {
  Lamf_plugins_domain_webapi_models_Tag: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_plugins_domain_webapi_models_DocumentedElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_Tag.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_Tag;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_TemplatedLink() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_TemplatedLink;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_TemplatedLink() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype = $c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype;
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.productPrefix__T = (function() {
  return "TemplatedLink"
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_TemplatedLink)) {
    var TemplatedLink$1 = $as_Lamf_plugins_domain_webapi_models_TemplatedLink(x$1);
    var x = this.fields$1;
    var x$2 = TemplatedLink$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = TemplatedLink$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_TemplatedLink().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_core_model_domain_Linkable($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$()
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "UnknownTemplatedLink" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/templatedLink/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_TemplatedLink().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$().Name$1
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_TemplatedLink(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_TemplatedLink) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.TemplatedLink"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_TemplatedLink(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_TemplatedLink)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_TemplatedLink(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_TemplatedLink(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.TemplatedLink;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_TemplatedLink = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_TemplatedLink: 0
}, false, "amf.plugins.domain.webapi.models.TemplatedLink", {
  Lamf_plugins_domain_webapi_models_TemplatedLink: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_TemplatedLink;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype = $c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype;
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.productPrefix__T = (function() {
  return "ChannelBindings"
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings)) {
    var ChannelBindings$1 = $as_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings(x$1);
    var x = this.fields$1;
    var x$2 = ChannelBindings$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = ChannelBindings$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_plugins_domain_webapi_models_bindings_ChannelBindings()
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$()
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "channel-bindings" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.linkCopy__Lamf_plugins_domain_webapi_models_bindings_ChannelBindings = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  var bindings = $as_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value));
  var this$5 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$().Name$1)).option$1;
  if ((!this$5.isEmpty__Z())) {
    var arg1 = this$5.get__O();
    var x$1 = $as_T(arg1);
    $m_Lamf_core_parser_Annotations$();
    var a = new $c_Lamf_core_parser_Annotations().init___();
    $as_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(bindings, x$1, a))
  };
  return bindings
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annot$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annot = $as_Lamf_core_parser_Annotations(annot$2);
      return new $c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annot)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$().Name$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.ChannelBindings"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_ChannelBindings)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.ChannelBindings;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_bindings_ChannelBindings: 0
}, false, "amf.plugins.domain.webapi.models.bindings.ChannelBindings", {
  Lamf_plugins_domain_webapi_models_bindings_ChannelBindings: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype = $c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype;
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$()
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$().Type$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "dynamic-binding" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.key__Lamf_core_model_StrField = (function() {
  return $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$().key$1))
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.DynamicBinding"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_DynamicBinding)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.DynamicBinding;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_bindings_DynamicBinding: 0
}, false, "amf.plugins.domain.webapi.models.bindings.DynamicBinding", {
  Lamf_plugins_domain_webapi_models_bindings_DynamicBinding: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_plugins_domain_webapi_models_bindings_ServerBinding: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_plugins_domain_webapi_models_bindings_ChannelBinding: 1,
  Lamf_plugins_domain_webapi_models_bindings_OperationBinding: 1,
  Lamf_plugins_domain_webapi_models_bindings_MessageBinding: 1,
  Lamf_plugins_domain_webapi_models_Key: 1
});
$c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype = $c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype;
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$()
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$().Type$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "empty-binding" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.key__Lamf_core_model_StrField = (function() {
  return $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$().key$1))
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.EmptyBinding"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_EmptyBinding)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.EmptyBinding;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_bindings_EmptyBinding: 0
}, false, "amf.plugins.domain.webapi.models.bindings.EmptyBinding", {
  Lamf_plugins_domain_webapi_models_bindings_EmptyBinding: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_plugins_domain_webapi_models_bindings_ServerBinding: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_plugins_domain_webapi_models_bindings_ChannelBinding: 1,
  Lamf_plugins_domain_webapi_models_bindings_OperationBinding: 1,
  Lamf_plugins_domain_webapi_models_bindings_MessageBinding: 1,
  Lamf_plugins_domain_webapi_models_Key: 1
});
$c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_bindings_MessageBindings() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype = $c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype;
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.productPrefix__T = (function() {
  return "MessageBindings"
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.linkCopy__Lamf_plugins_domain_webapi_models_bindings_MessageBindings = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  var bindings = $as_Lamf_plugins_domain_webapi_models_bindings_MessageBindings($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value));
  var this$5 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$().Name$1)).option$1;
  if ((!this$5.isEmpty__Z())) {
    var arg1 = this$5.get__O();
    var x$1 = $as_T(arg1);
    $m_Lamf_core_parser_Annotations$();
    var a = new $c_Lamf_core_parser_Annotations().init___();
    $as_Lamf_plugins_domain_webapi_models_bindings_MessageBindings($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(bindings, x$1, a))
  };
  return bindings
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings)) {
    var MessageBindings$1 = $as_Lamf_plugins_domain_webapi_models_bindings_MessageBindings(x$1);
    var x = this.fields$1;
    var x$2 = MessageBindings$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = MessageBindings$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_plugins_domain_webapi_models_bindings_MessageBindings()
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$()
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "message-bindings" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annot$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annot = $as_Lamf_core_parser_Annotations(annot$2);
      return new $c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annot)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$().Name$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_bindings_MessageBindings(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.MessageBindings"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_MessageBindings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_MessageBindings)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_MessageBindings(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_MessageBindings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.MessageBindings;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_bindings_MessageBindings = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_bindings_MessageBindings: 0
}, false, "amf.plugins.domain.webapi.models.bindings.MessageBindings", {
  Lamf_plugins_domain_webapi_models_bindings_MessageBindings: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_bindings_MessageBindings;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_bindings_OperationBindings() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype = $c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype;
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.productPrefix__T = (function() {
  return "OperationBindings"
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings)) {
    var OperationBindings$1 = $as_Lamf_plugins_domain_webapi_models_bindings_OperationBindings(x$1);
    var x = this.fields$1;
    var x$2 = OperationBindings$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = OperationBindings$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_plugins_domain_webapi_models_bindings_OperationBindings()
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$()
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "operation-bindings" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annot$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annot = $as_Lamf_core_parser_Annotations(annot$2);
      return new $c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annot)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.linkCopy__Lamf_plugins_domain_webapi_models_bindings_OperationBindings = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  var bindings = $as_Lamf_plugins_domain_webapi_models_bindings_OperationBindings($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value));
  var this$5 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$().Name$1)).option$1;
  if ((!this$5.isEmpty__Z())) {
    var arg1 = this$5.get__O();
    var x$1 = $as_T(arg1);
    $m_Lamf_core_parser_Annotations$();
    var a = new $c_Lamf_core_parser_Annotations().init___();
    $as_Lamf_plugins_domain_webapi_models_bindings_OperationBindings($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(bindings, x$1, a))
  };
  return bindings
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$().Name$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_bindings_OperationBindings(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.OperationBindings"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_OperationBindings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_OperationBindings)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_OperationBindings(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_OperationBindings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.OperationBindings;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_bindings_OperationBindings = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_bindings_OperationBindings: 0
}, false, "amf.plugins.domain.webapi.models.bindings.OperationBindings", {
  Lamf_plugins_domain_webapi_models_bindings_OperationBindings: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_bindings_OperationBindings;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_bindings_ServerBindings() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype = $c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype;
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.productPrefix__T = (function() {
  return "ServerBindings"
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings)) {
    var ServerBindings$1 = $as_Lamf_plugins_domain_webapi_models_bindings_ServerBindings(x$1);
    var x = this.fields$1;
    var x$2 = ServerBindings$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = ServerBindings$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_plugins_domain_webapi_models_bindings_ServerBindings()
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$()
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.linkCopy__Lamf_plugins_domain_webapi_models_bindings_ServerBindings = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  var bindings = $as_Lamf_plugins_domain_webapi_models_bindings_ServerBindings($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value));
  var this$5 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$().Name$1)).option$1;
  if ((!this$5.isEmpty__Z())) {
    var arg1 = this$5.get__O();
    var x$1 = $as_T(arg1);
    $m_Lamf_core_parser_Annotations$();
    var a = new $c_Lamf_core_parser_Annotations().init___();
    $as_Lamf_plugins_domain_webapi_models_bindings_ServerBindings($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(bindings, x$1, a))
  };
  return bindings
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "server-bindings" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annot$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annot = $as_Lamf_core_parser_Annotations(annot$2);
      return new $c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annot)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$().Name$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_bindings_ServerBindings(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.bindings.ServerBindings"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_bindings_ServerBindings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_bindings_ServerBindings)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_bindings_ServerBindings(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_bindings_ServerBindings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.bindings.ServerBindings;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_bindings_ServerBindings = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_bindings_ServerBindings: 0
}, false, "amf.plugins.domain.webapi.models.bindings.ServerBindings", {
  Lamf_plugins_domain_webapi_models_bindings_ServerBindings: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_bindings_ServerBindings;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType() {
  $c_Lamf_core_model_domain_templates_ParametrizedDeclaration.call(this);
  this.fields$2 = null;
  this.annotations$2 = null
}
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType.prototype = new $h_Lamf_core_model_domain_templates_ParametrizedDeclaration();
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType.prototype = $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType.prototype;
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType.prototype.productPrefix__T = (function() {
  return "ParametrizedResourceType"
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType)) {
    var ParametrizedResourceType$1 = $as_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType(x$1);
    var x = this.fields$2;
    var x$2 = ParametrizedResourceType$1.fields$2;
    if ((x === x$2)) {
      var x$3 = this.annotations$2;
      var x$4 = ParametrizedResourceType$1.annotations$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$2;
      break
    }
    case 1: {
      return this.annotations$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedResourceTypeModel$()
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$2 = fields;
  this.annotations$2 = annotations;
  $c_Lamf_core_model_domain_templates_ParametrizedDeclaration.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.templates.ParametrizedResourceType"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.templates.ParametrizedResourceType;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType: 0
}, false, "amf.plugins.domain.webapi.models.templates.ParametrizedResourceType", {
  Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType: 1,
  Lamf_core_model_domain_templates_ParametrizedDeclaration: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait() {
  $c_Lamf_core_model_domain_templates_ParametrizedDeclaration.call(this);
  this.fields$2 = null;
  this.annotations$2 = null
}
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait.prototype = new $h_Lamf_core_model_domain_templates_ParametrizedDeclaration();
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait.prototype = $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait.prototype;
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait.prototype.productPrefix__T = (function() {
  return "ParametrizedTrait"
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait)) {
    var ParametrizedTrait$1 = $as_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait(x$1);
    var x = this.fields$2;
    var x$2 = ParametrizedTrait$1.fields$2;
    if ((x === x$2)) {
      var x$3 = this.annotations$2;
      var x$4 = ParametrizedTrait$1.annotations$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$2;
      break
    }
    case 1: {
      return this.annotations$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_templates_ParametrizedTraitModel$()
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$2 = fields;
  this.annotations$2 = annotations;
  $c_Lamf_core_model_domain_templates_ParametrizedDeclaration.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.templates.ParametrizedTrait"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.templates.ParametrizedTrait;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait: 0
}, false, "amf.plugins.domain.webapi.models.templates.ParametrizedTrait", {
  Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait: 1,
  Lamf_core_model_domain_templates_ParametrizedDeclaration: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait;
/** @constructor */
function $c_s_reflect_ManifestFactory$AnyManifest$() {
  $c_s_reflect_ManifestFactory$PhantomManifest.call(this)
}
$c_s_reflect_ManifestFactory$AnyManifest$.prototype = new $h_s_reflect_ManifestFactory$PhantomManifest();
$c_s_reflect_ManifestFactory$AnyManifest$.prototype.constructor = $c_s_reflect_ManifestFactory$AnyManifest$;
/** @constructor */
function $h_s_reflect_ManifestFactory$AnyManifest$() {
  /*<skip>*/
}
$h_s_reflect_ManifestFactory$AnyManifest$.prototype = $c_s_reflect_ManifestFactory$AnyManifest$.prototype;
$c_s_reflect_ManifestFactory$AnyManifest$.prototype.init___ = (function() {
  this.toString$2 = "Any";
  var prefix = $m_s_None$();
  var typeArguments = $m_sci_Nil$();
  this.prefix$1 = prefix;
  this.runtimeClass1$1 = $d_O.getClassOf();
  this.typeArguments$1 = typeArguments;
  return this
});
$c_s_reflect_ManifestFactory$AnyManifest$.prototype.newArray__I__O = (function(len) {
  return $newArrayObject($d_O.getArrayOf(), [len])
});
$c_s_reflect_ManifestFactory$AnyManifest$.prototype.runtimeClass__jl_Class = (function() {
  return $d_O.getClassOf()
});
var $d_s_reflect_ManifestFactory$AnyManifest$ = new $TypeData().initClass({
  s_reflect_ManifestFactory$AnyManifest$: 0
}, false, "scala.reflect.ManifestFactory$AnyManifest$", {
  s_reflect_ManifestFactory$AnyManifest$: 1,
  s_reflect_ManifestFactory$PhantomManifest: 1,
  s_reflect_ManifestFactory$ClassTypeManifest: 1,
  O: 1,
  s_reflect_Manifest: 1,
  s_reflect_ClassTag: 1,
  s_reflect_ClassManifestDeprecatedApis: 1,
  s_reflect_OptManifest: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_Equals: 1
});
$c_s_reflect_ManifestFactory$AnyManifest$.prototype.$classData = $d_s_reflect_ManifestFactory$AnyManifest$;
var $n_s_reflect_ManifestFactory$AnyManifest$ = (void 0);
function $m_s_reflect_ManifestFactory$AnyManifest$() {
  if ((!$n_s_reflect_ManifestFactory$AnyManifest$)) {
    $n_s_reflect_ManifestFactory$AnyManifest$ = new $c_s_reflect_ManifestFactory$AnyManifest$().init___()
  };
  return $n_s_reflect_ManifestFactory$AnyManifest$
}
/** @constructor */
function $c_s_reflect_ManifestFactory$AnyValManifest$() {
  $c_s_reflect_ManifestFactory$PhantomManifest.call(this)
}
$c_s_reflect_ManifestFactory$AnyValManifest$.prototype = new $h_s_reflect_ManifestFactory$PhantomManifest();
$c_s_reflect_ManifestFactory$AnyValManifest$.prototype.constructor = $c_s_reflect_ManifestFactory$AnyValManifest$;
/** @constructor */
function $h_s_reflect_ManifestFactory$AnyValManifest$() {
  /*<skip>*/
}
$h_s_reflect_ManifestFactory$AnyValManifest$.prototype = $c_s_reflect_ManifestFactory$AnyValManifest$.prototype;
$c_s_reflect_ManifestFactory$AnyValManifest$.prototype.init___ = (function() {
  this.toString$2 = "AnyVal";
  var prefix = $m_s_None$();
  var typeArguments = $m_sci_Nil$();
  this.prefix$1 = prefix;
  this.runtimeClass1$1 = $d_O.getClassOf();
  this.typeArguments$1 = typeArguments;
  return this
});
$c_s_reflect_ManifestFactory$AnyValManifest$.prototype.newArray__I__O = (function(len) {
  return $newArrayObject($d_O.getArrayOf(), [len])
});
$c_s_reflect_ManifestFactory$AnyValManifest$.prototype.runtimeClass__jl_Class = (function() {
  return $d_O.getClassOf()
});
var $d_s_reflect_ManifestFactory$AnyValManifest$ = new $TypeData().initClass({
  s_reflect_ManifestFactory$AnyValManifest$: 0
}, false, "scala.reflect.ManifestFactory$AnyValManifest$", {
  s_reflect_ManifestFactory$AnyValManifest$: 1,
  s_reflect_ManifestFactory$PhantomManifest: 1,
  s_reflect_ManifestFactory$ClassTypeManifest: 1,
  O: 1,
  s_reflect_Manifest: 1,
  s_reflect_ClassTag: 1,
  s_reflect_ClassManifestDeprecatedApis: 1,
  s_reflect_OptManifest: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_Equals: 1
});
$c_s_reflect_ManifestFactory$AnyValManifest$.prototype.$classData = $d_s_reflect_ManifestFactory$AnyValManifest$;
var $n_s_reflect_ManifestFactory$AnyValManifest$ = (void 0);
function $m_s_reflect_ManifestFactory$AnyValManifest$() {
  if ((!$n_s_reflect_ManifestFactory$AnyValManifest$)) {
    $n_s_reflect_ManifestFactory$AnyValManifest$ = new $c_s_reflect_ManifestFactory$AnyValManifest$().init___()
  };
  return $n_s_reflect_ManifestFactory$AnyValManifest$
}
/** @constructor */
function $c_s_reflect_ManifestFactory$NothingManifest$() {
  $c_s_reflect_ManifestFactory$PhantomManifest.call(this)
}
$c_s_reflect_ManifestFactory$NothingManifest$.prototype = new $h_s_reflect_ManifestFactory$PhantomManifest();
$c_s_reflect_ManifestFactory$NothingManifest$.prototype.constructor = $c_s_reflect_ManifestFactory$NothingManifest$;
/** @constructor */
function $h_s_reflect_ManifestFactory$NothingManifest$() {
  /*<skip>*/
}
$h_s_reflect_ManifestFactory$NothingManifest$.prototype = $c_s_reflect_ManifestFactory$NothingManifest$.prototype;
$c_s_reflect_ManifestFactory$NothingManifest$.prototype.init___ = (function() {
  this.toString$2 = "Nothing";
  var prefix = $m_s_None$();
  var typeArguments = $m_sci_Nil$();
  this.prefix$1 = prefix;
  this.runtimeClass1$1 = $d_sr_Nothing$.getClassOf();
  this.typeArguments$1 = typeArguments;
  return this
});
$c_s_reflect_ManifestFactory$NothingManifest$.prototype.newArray__I__O = (function(len) {
  return $newArrayObject($d_O.getArrayOf(), [len])
});
$c_s_reflect_ManifestFactory$NothingManifest$.prototype.runtimeClass__jl_Class = (function() {
  return $d_sr_Nothing$.getClassOf()
});
var $d_s_reflect_ManifestFactory$NothingManifest$ = new $TypeData().initClass({
  s_reflect_ManifestFactory$NothingManifest$: 0
}, false, "scala.reflect.ManifestFactory$NothingManifest$", {
  s_reflect_ManifestFactory$NothingManifest$: 1,
  s_reflect_ManifestFactory$PhantomManifest: 1,
  s_reflect_ManifestFactory$ClassTypeManifest: 1,
  O: 1,
  s_reflect_Manifest: 1,
  s_reflect_ClassTag: 1,
  s_reflect_ClassManifestDeprecatedApis: 1,
  s_reflect_OptManifest: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_Equals: 1
});
$c_s_reflect_ManifestFactory$NothingManifest$.prototype.$classData = $d_s_reflect_ManifestFactory$NothingManifest$;
var $n_s_reflect_ManifestFactory$NothingManifest$ = (void 0);
function $m_s_reflect_ManifestFactory$NothingManifest$() {
  if ((!$n_s_reflect_ManifestFactory$NothingManifest$)) {
    $n_s_reflect_ManifestFactory$NothingManifest$ = new $c_s_reflect_ManifestFactory$NothingManifest$().init___()
  };
  return $n_s_reflect_ManifestFactory$NothingManifest$
}
/** @constructor */
function $c_s_reflect_ManifestFactory$NullManifest$() {
  $c_s_reflect_ManifestFactory$PhantomManifest.call(this)
}
$c_s_reflect_ManifestFactory$NullManifest$.prototype = new $h_s_reflect_ManifestFactory$PhantomManifest();
$c_s_reflect_ManifestFactory$NullManifest$.prototype.constructor = $c_s_reflect_ManifestFactory$NullManifest$;
/** @constructor */
function $h_s_reflect_ManifestFactory$NullManifest$() {
  /*<skip>*/
}
$h_s_reflect_ManifestFactory$NullManifest$.prototype = $c_s_reflect_ManifestFactory$NullManifest$.prototype;
$c_s_reflect_ManifestFactory$NullManifest$.prototype.init___ = (function() {
  this.toString$2 = "Null";
  var prefix = $m_s_None$();
  var typeArguments = $m_sci_Nil$();
  this.prefix$1 = prefix;
  this.runtimeClass1$1 = $d_sr_Null$.getClassOf();
  this.typeArguments$1 = typeArguments;
  return this
});
$c_s_reflect_ManifestFactory$NullManifest$.prototype.newArray__I__O = (function(len) {
  return $newArrayObject($d_O.getArrayOf(), [len])
});
$c_s_reflect_ManifestFactory$NullManifest$.prototype.runtimeClass__jl_Class = (function() {
  return $d_sr_Null$.getClassOf()
});
var $d_s_reflect_ManifestFactory$NullManifest$ = new $TypeData().initClass({
  s_reflect_ManifestFactory$NullManifest$: 0
}, false, "scala.reflect.ManifestFactory$NullManifest$", {
  s_reflect_ManifestFactory$NullManifest$: 1,
  s_reflect_ManifestFactory$PhantomManifest: 1,
  s_reflect_ManifestFactory$ClassTypeManifest: 1,
  O: 1,
  s_reflect_Manifest: 1,
  s_reflect_ClassTag: 1,
  s_reflect_ClassManifestDeprecatedApis: 1,
  s_reflect_OptManifest: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_Equals: 1
});
$c_s_reflect_ManifestFactory$NullManifest$.prototype.$classData = $d_s_reflect_ManifestFactory$NullManifest$;
var $n_s_reflect_ManifestFactory$NullManifest$ = (void 0);
function $m_s_reflect_ManifestFactory$NullManifest$() {
  if ((!$n_s_reflect_ManifestFactory$NullManifest$)) {
    $n_s_reflect_ManifestFactory$NullManifest$ = new $c_s_reflect_ManifestFactory$NullManifest$().init___()
  };
  return $n_s_reflect_ManifestFactory$NullManifest$
}
/** @constructor */
function $c_s_reflect_ManifestFactory$ObjectManifest$() {
  $c_s_reflect_ManifestFactory$PhantomManifest.call(this)
}
$c_s_reflect_ManifestFactory$ObjectManifest$.prototype = new $h_s_reflect_ManifestFactory$PhantomManifest();
$c_s_reflect_ManifestFactory$ObjectManifest$.prototype.constructor = $c_s_reflect_ManifestFactory$ObjectManifest$;
/** @constructor */
function $h_s_reflect_ManifestFactory$ObjectManifest$() {
  /*<skip>*/
}
$h_s_reflect_ManifestFactory$ObjectManifest$.prototype = $c_s_reflect_ManifestFactory$ObjectManifest$.prototype;
$c_s_reflect_ManifestFactory$ObjectManifest$.prototype.init___ = (function() {
  this.toString$2 = "Object";
  var prefix = $m_s_None$();
  var typeArguments = $m_sci_Nil$();
  this.prefix$1 = prefix;
  this.runtimeClass1$1 = $d_O.getClassOf();
  this.typeArguments$1 = typeArguments;
  return this
});
$c_s_reflect_ManifestFactory$ObjectManifest$.prototype.newArray__I__O = (function(len) {
  return $newArrayObject($d_O.getArrayOf(), [len])
});
$c_s_reflect_ManifestFactory$ObjectManifest$.prototype.runtimeClass__jl_Class = (function() {
  return $d_O.getClassOf()
});
var $d_s_reflect_ManifestFactory$ObjectManifest$ = new $TypeData().initClass({
  s_reflect_ManifestFactory$ObjectManifest$: 0
}, false, "scala.reflect.ManifestFactory$ObjectManifest$", {
  s_reflect_ManifestFactory$ObjectManifest$: 1,
  s_reflect_ManifestFactory$PhantomManifest: 1,
  s_reflect_ManifestFactory$ClassTypeManifest: 1,
  O: 1,
  s_reflect_Manifest: 1,
  s_reflect_ClassTag: 1,
  s_reflect_ClassManifestDeprecatedApis: 1,
  s_reflect_OptManifest: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  s_Equals: 1
});
$c_s_reflect_ManifestFactory$ObjectManifest$.prototype.$classData = $d_s_reflect_ManifestFactory$ObjectManifest$;
var $n_s_reflect_ManifestFactory$ObjectManifest$ = (void 0);
function $m_s_reflect_ManifestFactory$ObjectManifest$() {
  if ((!$n_s_reflect_ManifestFactory$ObjectManifest$)) {
    $n_s_reflect_ManifestFactory$ObjectManifest$ = new $c_s_reflect_ManifestFactory$ObjectManifest$().init___()
  };
  return $n_s_reflect_ManifestFactory$ObjectManifest$
}
function $is_sc_GenMap(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_GenMap)))
}
function $as_sc_GenMap(obj) {
  return (($is_sc_GenMap(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.GenMap"))
}
function $isArrayOf_sc_GenMap(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_GenMap)))
}
function $asArrayOf_sc_GenMap(obj, depth) {
  return (($isArrayOf_sc_GenMap(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.GenMap;", depth))
}
function $is_sc_GenSeq(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_GenSeq)))
}
function $as_sc_GenSeq(obj) {
  return (($is_sc_GenSeq(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.GenSeq"))
}
function $isArrayOf_sc_GenSeq(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_GenSeq)))
}
function $asArrayOf_sc_GenSeq(obj, depth) {
  return (($isArrayOf_sc_GenSeq(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.GenSeq;", depth))
}
function $is_scg_TraversableForwarder(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.scg_TraversableForwarder)))
}
function $as_scg_TraversableForwarder(obj) {
  return (($is_scg_TraversableForwarder(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.generic.TraversableForwarder"))
}
function $isArrayOf_scg_TraversableForwarder(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scg_TraversableForwarder)))
}
function $asArrayOf_scg_TraversableForwarder(obj, depth) {
  return (($isArrayOf_scg_TraversableForwarder(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.generic.TraversableForwarder;", depth))
}
/** @constructor */
function $c_sci_Vector$() {
  $c_scg_IndexedSeqFactory.call(this);
  this.NIL$6 = null
}
$c_sci_Vector$.prototype = new $h_scg_IndexedSeqFactory();
$c_sci_Vector$.prototype.constructor = $c_sci_Vector$;
/** @constructor */
function $h_sci_Vector$() {
  /*<skip>*/
}
$h_sci_Vector$.prototype = $c_sci_Vector$.prototype;
$c_sci_Vector$.prototype.init___ = (function() {
  $c_scg_GenTraversableFactory.prototype.init___.call(this);
  $n_sci_Vector$ = this;
  this.NIL$6 = new $c_sci_Vector().init___I__I__I(0, 0, 0);
  return this
});
$c_sci_Vector$.prototype.empty__sc_GenTraversable = (function() {
  return this.NIL$6
});
$c_sci_Vector$.prototype.newBuilder__scm_Builder = (function() {
  return new $c_sci_VectorBuilder().init___()
});
var $d_sci_Vector$ = new $TypeData().initClass({
  sci_Vector$: 0
}, false, "scala.collection.immutable.Vector$", {
  sci_Vector$: 1,
  scg_IndexedSeqFactory: 1,
  scg_SeqFactory: 1,
  scg_GenSeqFactory: 1,
  scg_GenTraversableFactory: 1,
  scg_GenericCompanion: 1,
  O: 1,
  scg_TraversableFactory: 1,
  scg_GenericSeqCompanion: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_Vector$.prototype.$classData = $d_sci_Vector$;
var $n_sci_Vector$ = (void 0);
function $m_sci_Vector$() {
  if ((!$n_sci_Vector$)) {
    $n_sci_Vector$ = new $c_sci_Vector$().init___()
  };
  return $n_sci_Vector$
}
/** @constructor */
function $c_Lamf_client_model_document_AnnotationTypeDeclaration() {
  $c_Lamf_client_model_document_Fragment.call(this)
}
$c_Lamf_client_model_document_AnnotationTypeDeclaration.prototype = new $h_Lamf_client_model_document_Fragment();
$c_Lamf_client_model_document_AnnotationTypeDeclaration.prototype.constructor = $c_Lamf_client_model_document_AnnotationTypeDeclaration;
/** @constructor */
function $h_Lamf_client_model_document_AnnotationTypeDeclaration() {
  /*<skip>*/
}
$h_Lamf_client_model_document_AnnotationTypeDeclaration.prototype = $c_Lamf_client_model_document_AnnotationTypeDeclaration.prototype;
$c_Lamf_client_model_document_AnnotationTypeDeclaration.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_document_AnnotationTypeDeclaration.prototype.init___Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.call(this, new $c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_document_AnnotationTypeDeclaration.prototype.productPrefix__T = (function() {
  return "AnnotationTypeDeclaration"
});
$c_Lamf_client_model_document_AnnotationTypeDeclaration.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_document_AnnotationTypeDeclaration.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_document_AnnotationTypeDeclaration)) {
    var AnnotationTypeDeclaration$1 = $as_Lamf_client_model_document_AnnotationTypeDeclaration(x$1);
    var x = $as_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment(AnnotationTypeDeclaration$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_document_AnnotationTypeDeclaration.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_document_AnnotationTypeDeclaration.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_document_AnnotationTypeDeclaration.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return $as_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_AnnotationTypeDeclaration.prototype.$$undinternal__Lamf_core_model_document_EncodesModel = (function() {
  return $as_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_AnnotationTypeDeclaration.prototype.init___Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment = (function(_internal) {
  $c_Lamf_client_model_document_Fragment.prototype.init___Lamf_core_model_document_Fragment.call(this, _internal);
  return this
});
$c_Lamf_client_model_document_AnnotationTypeDeclaration.prototype.$$undinternal__Lamf_core_model_document_Fragment = (function() {
  return $as_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_AnnotationTypeDeclaration.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_AnnotationTypeDeclaration.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_document_AnnotationTypeDeclaration.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_client_model_document_AnnotationTypeDeclaration(obj) {
  return (((obj instanceof $c_Lamf_client_model_document_AnnotationTypeDeclaration) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.document.AnnotationTypeDeclaration"))
}
function $isArrayOf_Lamf_client_model_document_AnnotationTypeDeclaration(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_document_AnnotationTypeDeclaration)))
}
function $asArrayOf_Lamf_client_model_document_AnnotationTypeDeclaration(obj, depth) {
  return (($isArrayOf_Lamf_client_model_document_AnnotationTypeDeclaration(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.document.AnnotationTypeDeclaration;", depth))
}
var $d_Lamf_client_model_document_AnnotationTypeDeclaration = new $TypeData().initClass({
  Lamf_client_model_document_AnnotationTypeDeclaration: 0
}, false, "amf.client.model.document.AnnotationTypeDeclaration", {
  Lamf_client_model_document_AnnotationTypeDeclaration: 1,
  Lamf_client_model_document_Fragment: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_EncodesModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_document_AnnotationTypeDeclaration.prototype.$classData = $d_Lamf_client_model_document_AnnotationTypeDeclaration;
/** @constructor */
function $c_Lamf_client_model_document_DataType() {
  $c_Lamf_client_model_document_Fragment.call(this)
}
$c_Lamf_client_model_document_DataType.prototype = new $h_Lamf_client_model_document_Fragment();
$c_Lamf_client_model_document_DataType.prototype.constructor = $c_Lamf_client_model_document_DataType;
/** @constructor */
function $h_Lamf_client_model_document_DataType() {
  /*<skip>*/
}
$h_Lamf_client_model_document_DataType.prototype = $c_Lamf_client_model_document_DataType.prototype;
$c_Lamf_client_model_document_DataType.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_document_DataType.prototype.init___Lamf_plugins_document_webapi_model_DataTypeFragment.call(this, new $c_Lamf_plugins_document_webapi_model_DataTypeFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_document_DataType.prototype.productPrefix__T = (function() {
  return "DataType"
});
$c_Lamf_client_model_document_DataType.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_document_DataType.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_document_DataType)) {
    var DataType$1 = $as_Lamf_client_model_document_DataType(x$1);
    var x = $as_Lamf_plugins_document_webapi_model_DataTypeFragment(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_document_webapi_model_DataTypeFragment(DataType$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_document_DataType.prototype.init___Lamf_plugins_document_webapi_model_DataTypeFragment = (function(_internal) {
  $c_Lamf_client_model_document_Fragment.prototype.init___Lamf_core_model_document_Fragment.call(this, _internal);
  return this
});
$c_Lamf_client_model_document_DataType.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_document_webapi_model_DataTypeFragment(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_document_DataType.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_document_DataType.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return $as_Lamf_plugins_document_webapi_model_DataTypeFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_DataType.prototype.$$undinternal__Lamf_core_model_document_EncodesModel = (function() {
  return $as_Lamf_plugins_document_webapi_model_DataTypeFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_DataType.prototype.$$undinternal__Lamf_core_model_document_Fragment = (function() {
  return $as_Lamf_plugins_document_webapi_model_DataTypeFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_DataType.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_document_webapi_model_DataTypeFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_DataType.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_document_DataType.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_client_model_document_DataType(obj) {
  return (((obj instanceof $c_Lamf_client_model_document_DataType) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.document.DataType"))
}
function $isArrayOf_Lamf_client_model_document_DataType(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_document_DataType)))
}
function $asArrayOf_Lamf_client_model_document_DataType(obj, depth) {
  return (($isArrayOf_Lamf_client_model_document_DataType(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.document.DataType;", depth))
}
var $d_Lamf_client_model_document_DataType = new $TypeData().initClass({
  Lamf_client_model_document_DataType: 0
}, false, "amf.client.model.document.DataType", {
  Lamf_client_model_document_DataType: 1,
  Lamf_client_model_document_Fragment: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_EncodesModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_document_DataType.prototype.$classData = $d_Lamf_client_model_document_DataType;
/** @constructor */
function $c_Lamf_client_model_document_Dialect() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_document_Dialect.prototype = new $h_O();
$c_Lamf_client_model_document_Dialect.prototype.constructor = $c_Lamf_client_model_document_Dialect;
/** @constructor */
function $h_Lamf_client_model_document_Dialect() {
  /*<skip>*/
}
$h_Lamf_client_model_document_Dialect.prototype = $c_Lamf_client_model_document_Dialect.prototype;
$c_Lamf_client_model_document_Dialect.prototype.productPrefix__T = (function() {
  return "Dialect"
});
$c_Lamf_client_model_document_Dialect.prototype.documents__Lamf_client_model_domain_DocumentsModel = (function() {
  var this$1 = this.$$undinternal$1;
  return new $c_Lamf_client_model_domain_DocumentsModel().init___Lamf_plugins_document_vocabularies_model_domain_DocumentsModel($as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1)))
});
$c_Lamf_client_model_document_Dialect.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_document_Dialect.prototype.init___Lamf_plugins_document_vocabularies_model_document_Dialect.call(this, new $c_Lamf_plugins_document_vocabularies_model_document_Dialect().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_document_Dialect.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Name$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_document_Dialect.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$withRaw__T__O = (function(raw) {
  return $f_Lamf_client_model_document_BaseUnit__withRaw__T__Lamf_client_model_document_BaseUnit(this, raw)
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$findById__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__findById__T__sjs_js_UndefOr(this, id)
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$withReferences__sjs_js_Array__O = (function(references) {
  return $f_Lamf_client_model_document_BaseUnit__withReferences__sjs_js_Array__Lamf_client_model_document_BaseUnit(this, references)
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$prop$nameAndVersion__O = (function() {
  return this.$$undinternal$1.nameAndVersion__T()
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$references__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__references__sjs_js_Array(this)
});
$c_Lamf_client_model_document_Dialect.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_document_Dialect)) {
    var Dialect$1 = $as_Lamf_client_model_document_Dialect(x$1);
    var x = this.$$undinternal$1;
    var x$2 = Dialect$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$isFragmentHeader__T__O = (function(header) {
  return this.$$undinternal$1.isFragmentHeader__T__Z(header)
});
$c_Lamf_client_model_document_Dialect.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$withDocuments__Lamf_client_model_domain_DocumentsModel__O = (function(documentsMapping) {
  return this.withDocuments__Lamf_client_model_domain_DocumentsModel__Lamf_client_model_document_Dialect(documentsMapping)
});
$c_Lamf_client_model_document_Dialect.prototype.allHeaders__sjs_js_Array = (function() {
  var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var from = this.$$undinternal$1.allHeaders__sc_Seq();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$prop$modelVersion__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__modelVersion__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$prop$location__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__location__T(this)
});
$c_Lamf_client_model_document_Dialect.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_document_Dialect.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$prop$allHeaders__O = (function() {
  return this.allHeaders__sjs_js_Array()
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$withDeclares__sjs_js_Array__O = (function(declares) {
  return $f_Lamf_client_model_document_DeclaresModel__withDeclares__sjs_js_Array__Lamf_client_model_document_DeclaresModel(this, declares)
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$prop$fragmentHeaders__O = (function() {
  return this.fragmentHeaders__sjs_js_Array()
});
$c_Lamf_client_model_document_Dialect.prototype.$$undinternal__Lamf_core_model_document_EncodesModel = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$prop$encodes__O = (function() {
  return $f_Lamf_client_model_document_EncodesModel__encodes__Lamf_client_model_domain_DomainElement(this)
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_document_BaseUnit__withId__T__Lamf_client_model_document_BaseUnit(this, id)
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$cloneUnit__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__cloneUnit__Lamf_client_model_document_BaseUnit(this)
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$prop$version__O = (function() {
  return this.version__Lamf_client_model_StrField()
});
$c_Lamf_client_model_document_Dialect.prototype.fragmentHeaders__sjs_js_Array = (function() {
  var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var from = this.$$undinternal$1.fragmentHeaders__sc_Seq();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$withEncodes__Lamf_client_model_domain_DomainElement__O = (function(encoded) {
  return $f_Lamf_client_model_document_EncodesModel__withEncodes__Lamf_client_model_domain_DomainElement__Lamf_client_model_document_EncodesModel(this, encoded)
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$findByType__T__O = (function(typeId) {
  return $f_Lamf_client_model_document_BaseUnit__findByType__T__sjs_js_Array(this, typeId)
});
$c_Lamf_client_model_document_Dialect.prototype.libraryHeader__sjs_js_UndefOr = (function() {
  var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var from = this.$$undinternal$1.libraryHeader__s_Option();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$1, from, m).asClient__O()
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$isLibraryHeader__T__O = (function(header) {
  return this.$$undinternal$1.isLibraryHeader__T__Z(header)
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$withLocation__T__O = (function(location) {
  return $f_Lamf_client_model_document_BaseUnit__withLocation__T__Lamf_client_model_document_BaseUnit(this, location)
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$prop$raw__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__raw__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$documents__O = (function() {
  return this.documents__Lamf_client_model_domain_DocumentsModel()
});
$c_Lamf_client_model_document_Dialect.prototype.withVersion__T__Lamf_client_model_document_Dialect = (function(version) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Version$1;
  $as_Lamf_plugins_document_vocabularies_model_document_Dialect($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, version));
  return this
});
$c_Lamf_client_model_document_Dialect.prototype.$$undinternal__Lamf_core_model_document_DeclaresModel = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_Dialect.prototype.withName__T__Lamf_client_model_document_Dialect = (function(name) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Name$1;
  $as_Lamf_plugins_document_vocabularies_model_document_Dialect($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, name));
  return this
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O = (function(renderOptions) {
  return $f_Lamf_client_model_document_BaseUnit__toNativeRdfModel__Lamf_client_render_RenderOptions__Lamf_core_rdf_RdfModel(this, renderOptions)
});
$c_Lamf_client_model_document_Dialect.prototype.withExternals__sjs_js_Array__Lamf_client_model_document_Dialect = (function(externals) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().ExternalConverter__Lamf_client_convert_ExternalConverter$ExternalConverter$();
  var externals$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, externals, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_document_ExternalContextModelFields$().Externals$1;
  $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, externals$1);
  return this
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$withVersion__T__O = (function(version) {
  return this.withVersion__T__Lamf_client_model_document_Dialect(version)
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions = (function() {
  return new $c_Lamf_client_render_RenderOptions().init___()
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$withUsage__T__O = (function(usage) {
  return $f_Lamf_client_model_document_BaseUnit__withUsage__T__Lamf_client_model_document_BaseUnit(this, usage)
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_document_Dialect.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_document_Dialect.prototype.version__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Version$1));
  $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$withReferenceAlias__T__T__T__O = (function(alias, fullUrl, relativeUrl) {
  return $f_Lamf_client_model_document_BaseUnit__withReferenceAlias__T__T__T__Lamf_client_model_document_BaseUnit(this, alias, fullUrl, relativeUrl)
});
$c_Lamf_client_model_document_Dialect.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$withExternals__sjs_js_Array__O = (function(externals) {
  return this.withExternals__sjs_js_Array__Lamf_client_model_document_Dialect(externals)
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$prop$declares__O = (function() {
  return $f_Lamf_client_model_document_DeclaresModel__declares__sjs_js_Array(this)
});
$c_Lamf_client_model_document_Dialect.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$prop$libraryHeader__O = (function() {
  return this.libraryHeader__sjs_js_UndefOr()
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_document_Dialect(name)
});
$c_Lamf_client_model_document_Dialect.prototype.withDocuments__Lamf_client_model_domain_DocumentsModel__Lamf_client_model_document_Dialect = (function(documentsMapping) {
  var this$1 = this.$$undinternal$1;
  var documentsMapping$1 = documentsMapping.$$undinternal$1;
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1;
  $as_Lamf_plugins_document_vocabularies_model_document_Dialect($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$1, field, documentsMapping$1));
  return this
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$meth$withDeclaredElement__Lamf_client_model_domain_DomainElement__O = (function(declared) {
  return $f_Lamf_client_model_document_DeclaresModel__withDeclaredElement__Lamf_client_model_domain_DomainElement__Lamf_client_model_document_DeclaresModel(this, declared)
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$prop$sourceVendor__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__sourceVendor__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$prop$usage__O = (function() {
  return $f_Lamf_client_model_document_BaseUnit__usage__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$prop$header__O = (function() {
  return this.$$undinternal$1.header__T()
});
$c_Lamf_client_model_document_Dialect.prototype.$$js$exported$prop$externals__O = (function() {
  return this.externals__sjs_js_Array()
});
$c_Lamf_client_model_document_Dialect.prototype.externals__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_VocabulariesClientConverter$();
  var this$1 = this.$$undinternal$1;
  var from = $f_Lamf_plugins_document_vocabularies_model_document_ExternalContext__externals__sc_Seq(this$1);
  var m = $m_Lamf_client_convert_VocabulariesClientConverter$().ExternalConverter__Lamf_client_convert_ExternalConverter$ExternalConverter$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_document_Dialect.prototype.init___Lamf_plugins_document_vocabularies_model_document_Dialect = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_document_Dialect.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_document_Dialect.prototype.withReferenceAlias = (function(arg, arg$2, arg$3) {
  var prep = $as_T(arg);
  var prep$2 = $as_T(arg$2);
  var prep$3 = $as_T(arg$3);
  return this.$$js$exported$meth$withReferenceAlias__T__T__T__O(prep, prep$2, prep$3)
});
$c_Lamf_client_model_document_Dialect.prototype.cloneUnit = (function() {
  return this.$$js$exported$meth$cloneUnit__O()
});
Object.defineProperty($c_Lamf_client_model_document_Dialect.prototype, "sourceVendor", {
  "get": (function() {
    return this.$$js$exported$prop$sourceVendor__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_Dialect.prototype.findByType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findByType__T__O(prep)
});
$c_Lamf_client_model_document_Dialect.prototype.findById = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$findById__T__O(prep)
});
$c_Lamf_client_model_document_Dialect.prototype.toNativeRdfModel = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$toNativeRdfModel$default$1__Lamf_client_render_RenderOptions() : $as_Lamf_client_render_RenderOptions(rest[0]));
  return this.$$js$exported$meth$toNativeRdfModel__Lamf_client_render_RenderOptions__O(prep)
});
$c_Lamf_client_model_document_Dialect.prototype.withUsage = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withUsage__T__O(prep)
});
$c_Lamf_client_model_document_Dialect.prototype.withLocation = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLocation__T__O(prep)
});
$c_Lamf_client_model_document_Dialect.prototype.withRaw = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withRaw__T__O(prep)
});
$c_Lamf_client_model_document_Dialect.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_document_Dialect.prototype.withReferences = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withReferences__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_Dialect.prototype, "modelVersion", {
  "get": (function() {
    return this.$$js$exported$prop$modelVersion__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Dialect.prototype, "usage", {
  "get": (function() {
    return this.$$js$exported$prop$usage__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Dialect.prototype, "location", {
  "get": (function() {
    return this.$$js$exported$prop$location__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Dialect.prototype, "raw", {
  "get": (function() {
    return this.$$js$exported$prop$raw__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_Dialect.prototype.references = (function() {
  return this.$$js$exported$meth$references__O()
});
Object.defineProperty($c_Lamf_client_model_document_Dialect.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_Dialect.prototype.withEncodes = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withEncodes__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_Dialect.prototype, "encodes", {
  "get": (function() {
    return this.$$js$exported$prop$encodes__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_Dialect.prototype.withDeclares = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withDeclares__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_document_Dialect.prototype.withDeclaredElement = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withDeclaredElement__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_Dialect.prototype, "declares", {
  "get": (function() {
    return this.$$js$exported$prop$declares__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_Dialect.prototype.withDocuments = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DocumentsModel(arg);
  return this.$$js$exported$meth$withDocuments__Lamf_client_model_domain_DocumentsModel__O(prep)
});
$c_Lamf_client_model_document_Dialect.prototype.withExternals = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExternals__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_document_Dialect.prototype.withVersion = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withVersion__T__O(prep)
});
$c_Lamf_client_model_document_Dialect.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
$c_Lamf_client_model_document_Dialect.prototype.documents = (function() {
  return this.$$js$exported$meth$documents__O()
});
Object.defineProperty($c_Lamf_client_model_document_Dialect.prototype, "externals", {
  "get": (function() {
    return this.$$js$exported$prop$externals__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Dialect.prototype, "allHeaders", {
  "get": (function() {
    return this.$$js$exported$prop$allHeaders__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Dialect.prototype, "fragmentHeaders", {
  "get": (function() {
    return this.$$js$exported$prop$fragmentHeaders__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Dialect.prototype, "libraryHeader", {
  "get": (function() {
    return this.$$js$exported$prop$libraryHeader__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_document_Dialect.prototype.isFragmentHeader = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$isFragmentHeader__T__O(prep)
});
$c_Lamf_client_model_document_Dialect.prototype.isLibraryHeader = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$isLibraryHeader__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_document_Dialect.prototype, "header", {
  "get": (function() {
    return this.$$js$exported$prop$header__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Dialect.prototype, "nameAndVersion", {
  "get": (function() {
    return this.$$js$exported$prop$nameAndVersion__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Dialect.prototype, "version", {
  "get": (function() {
    return this.$$js$exported$prop$version__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_Dialect.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_document_Dialect(obj) {
  return (((obj instanceof $c_Lamf_client_model_document_Dialect) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.document.Dialect"))
}
function $isArrayOf_Lamf_client_model_document_Dialect(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_document_Dialect)))
}
function $asArrayOf_Lamf_client_model_document_Dialect(obj, depth) {
  return (($isArrayOf_Lamf_client_model_document_Dialect(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.document.Dialect;", depth))
}
var $d_Lamf_client_model_document_Dialect = new $TypeData().initClass({
  Lamf_client_model_document_Dialect: 0
}, false, "amf.client.model.document.Dialect", {
  Lamf_client_model_document_Dialect: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_EncodesModel: 1,
  Lamf_client_model_document_DeclaresModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_document_Dialect.prototype.$classData = $d_Lamf_client_model_document_Dialect;
/** @constructor */
function $c_Lamf_client_model_document_DocumentationItem() {
  $c_Lamf_client_model_document_Fragment.call(this)
}
$c_Lamf_client_model_document_DocumentationItem.prototype = new $h_Lamf_client_model_document_Fragment();
$c_Lamf_client_model_document_DocumentationItem.prototype.constructor = $c_Lamf_client_model_document_DocumentationItem;
/** @constructor */
function $h_Lamf_client_model_document_DocumentationItem() {
  /*<skip>*/
}
$h_Lamf_client_model_document_DocumentationItem.prototype = $c_Lamf_client_model_document_DocumentationItem.prototype;
$c_Lamf_client_model_document_DocumentationItem.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_document_DocumentationItem.prototype.init___Lamf_plugins_document_webapi_model_DocumentationItemFragment.call(this, new $c_Lamf_plugins_document_webapi_model_DocumentationItemFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_document_DocumentationItem.prototype.productPrefix__T = (function() {
  return "DocumentationItem"
});
$c_Lamf_client_model_document_DocumentationItem.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_document_DocumentationItem.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_document_DocumentationItem)) {
    var DocumentationItem$1 = $as_Lamf_client_model_document_DocumentationItem(x$1);
    var x = $as_Lamf_plugins_document_webapi_model_DocumentationItemFragment(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_document_webapi_model_DocumentationItemFragment(DocumentationItem$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_document_DocumentationItem.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_document_webapi_model_DocumentationItemFragment(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_document_DocumentationItem.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_document_DocumentationItem.prototype.init___Lamf_plugins_document_webapi_model_DocumentationItemFragment = (function(_internal) {
  $c_Lamf_client_model_document_Fragment.prototype.init___Lamf_core_model_document_Fragment.call(this, _internal);
  return this
});
$c_Lamf_client_model_document_DocumentationItem.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return $as_Lamf_plugins_document_webapi_model_DocumentationItemFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_DocumentationItem.prototype.$$undinternal__Lamf_core_model_document_EncodesModel = (function() {
  return $as_Lamf_plugins_document_webapi_model_DocumentationItemFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_DocumentationItem.prototype.$$undinternal__Lamf_core_model_document_Fragment = (function() {
  return $as_Lamf_plugins_document_webapi_model_DocumentationItemFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_DocumentationItem.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_document_webapi_model_DocumentationItemFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_DocumentationItem.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_document_DocumentationItem.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_client_model_document_DocumentationItem(obj) {
  return (((obj instanceof $c_Lamf_client_model_document_DocumentationItem) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.document.DocumentationItem"))
}
function $isArrayOf_Lamf_client_model_document_DocumentationItem(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_document_DocumentationItem)))
}
function $asArrayOf_Lamf_client_model_document_DocumentationItem(obj, depth) {
  return (($isArrayOf_Lamf_client_model_document_DocumentationItem(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.document.DocumentationItem;", depth))
}
var $d_Lamf_client_model_document_DocumentationItem = new $TypeData().initClass({
  Lamf_client_model_document_DocumentationItem: 0
}, false, "amf.client.model.document.DocumentationItem", {
  Lamf_client_model_document_DocumentationItem: 1,
  Lamf_client_model_document_Fragment: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_EncodesModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_document_DocumentationItem.prototype.$classData = $d_Lamf_client_model_document_DocumentationItem;
/** @constructor */
function $c_Lamf_client_model_document_ExternalFragment() {
  $c_Lamf_client_model_document_Fragment.call(this)
}
$c_Lamf_client_model_document_ExternalFragment.prototype = new $h_Lamf_client_model_document_Fragment();
$c_Lamf_client_model_document_ExternalFragment.prototype.constructor = $c_Lamf_client_model_document_ExternalFragment;
/** @constructor */
function $h_Lamf_client_model_document_ExternalFragment() {
  /*<skip>*/
}
$h_Lamf_client_model_document_ExternalFragment.prototype = $c_Lamf_client_model_document_ExternalFragment.prototype;
$c_Lamf_client_model_document_ExternalFragment.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_document_ExternalFragment.prototype.init___Lamf_core_model_document_ExternalFragment.call(this, new $c_Lamf_core_model_document_ExternalFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_document_ExternalFragment.prototype.productPrefix__T = (function() {
  return "ExternalFragment"
});
$c_Lamf_client_model_document_ExternalFragment.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_document_ExternalFragment.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_document_ExternalFragment)) {
    var ExternalFragment$1 = $as_Lamf_client_model_document_ExternalFragment(x$1);
    var x = $as_Lamf_core_model_document_ExternalFragment(this.$$undinternal$1);
    var x$2 = $as_Lamf_core_model_document_ExternalFragment(ExternalFragment$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_document_ExternalFragment.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_core_model_document_ExternalFragment(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_document_ExternalFragment.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_document_ExternalFragment.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return $as_Lamf_core_model_document_ExternalFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_ExternalFragment.prototype.$$undinternal__Lamf_core_model_document_EncodesModel = (function() {
  return $as_Lamf_core_model_document_ExternalFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_ExternalFragment.prototype.init___Lamf_core_model_document_ExternalFragment = (function(_internal) {
  $c_Lamf_client_model_document_Fragment.prototype.init___Lamf_core_model_document_Fragment.call(this, _internal);
  return this
});
$c_Lamf_client_model_document_ExternalFragment.prototype.$$undinternal__Lamf_core_model_document_Fragment = (function() {
  return $as_Lamf_core_model_document_ExternalFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_ExternalFragment.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_core_model_document_ExternalFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_ExternalFragment.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_document_ExternalFragment.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_client_model_document_ExternalFragment(obj) {
  return (((obj instanceof $c_Lamf_client_model_document_ExternalFragment) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.document.ExternalFragment"))
}
function $isArrayOf_Lamf_client_model_document_ExternalFragment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_document_ExternalFragment)))
}
function $asArrayOf_Lamf_client_model_document_ExternalFragment(obj, depth) {
  return (($isArrayOf_Lamf_client_model_document_ExternalFragment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.document.ExternalFragment;", depth))
}
var $d_Lamf_client_model_document_ExternalFragment = new $TypeData().initClass({
  Lamf_client_model_document_ExternalFragment: 0
}, false, "amf.client.model.document.ExternalFragment", {
  Lamf_client_model_document_ExternalFragment: 1,
  Lamf_client_model_document_Fragment: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_EncodesModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_document_ExternalFragment.prototype.$classData = $d_Lamf_client_model_document_ExternalFragment;
/** @constructor */
function $c_Lamf_client_model_document_NamedExample() {
  $c_Lamf_client_model_document_Fragment.call(this)
}
$c_Lamf_client_model_document_NamedExample.prototype = new $h_Lamf_client_model_document_Fragment();
$c_Lamf_client_model_document_NamedExample.prototype.constructor = $c_Lamf_client_model_document_NamedExample;
/** @constructor */
function $h_Lamf_client_model_document_NamedExample() {
  /*<skip>*/
}
$h_Lamf_client_model_document_NamedExample.prototype = $c_Lamf_client_model_document_NamedExample.prototype;
$c_Lamf_client_model_document_NamedExample.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_document_NamedExample.prototype.init___Lamf_plugins_document_webapi_model_NamedExampleFragment.call(this, new $c_Lamf_plugins_document_webapi_model_NamedExampleFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_document_NamedExample.prototype.productPrefix__T = (function() {
  return "NamedExample"
});
$c_Lamf_client_model_document_NamedExample.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_document_NamedExample.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_document_NamedExample)) {
    var NamedExample$1 = $as_Lamf_client_model_document_NamedExample(x$1);
    var x = $as_Lamf_plugins_document_webapi_model_NamedExampleFragment(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_document_webapi_model_NamedExampleFragment(NamedExample$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_document_NamedExample.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_document_webapi_model_NamedExampleFragment(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_document_NamedExample.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_document_NamedExample.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return $as_Lamf_plugins_document_webapi_model_NamedExampleFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_NamedExample.prototype.$$undinternal__Lamf_core_model_document_EncodesModel = (function() {
  return $as_Lamf_plugins_document_webapi_model_NamedExampleFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_NamedExample.prototype.$$undinternal__Lamf_core_model_document_Fragment = (function() {
  return $as_Lamf_plugins_document_webapi_model_NamedExampleFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_NamedExample.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_document_webapi_model_NamedExampleFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_NamedExample.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_document_NamedExample.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_document_NamedExample.prototype.init___Lamf_plugins_document_webapi_model_NamedExampleFragment = (function(_internal) {
  $c_Lamf_client_model_document_Fragment.prototype.init___Lamf_core_model_document_Fragment.call(this, _internal);
  return this
});
function $as_Lamf_client_model_document_NamedExample(obj) {
  return (((obj instanceof $c_Lamf_client_model_document_NamedExample) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.document.NamedExample"))
}
function $isArrayOf_Lamf_client_model_document_NamedExample(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_document_NamedExample)))
}
function $asArrayOf_Lamf_client_model_document_NamedExample(obj, depth) {
  return (($isArrayOf_Lamf_client_model_document_NamedExample(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.document.NamedExample;", depth))
}
var $d_Lamf_client_model_document_NamedExample = new $TypeData().initClass({
  Lamf_client_model_document_NamedExample: 0
}, false, "amf.client.model.document.NamedExample", {
  Lamf_client_model_document_NamedExample: 1,
  Lamf_client_model_document_Fragment: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_EncodesModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_document_NamedExample.prototype.$classData = $d_Lamf_client_model_document_NamedExample;
/** @constructor */
function $c_Lamf_client_model_document_PayloadFragment() {
  $c_Lamf_client_model_document_Fragment.call(this)
}
$c_Lamf_client_model_document_PayloadFragment.prototype = new $h_Lamf_client_model_document_Fragment();
$c_Lamf_client_model_document_PayloadFragment.prototype.constructor = $c_Lamf_client_model_document_PayloadFragment;
/** @constructor */
function $h_Lamf_client_model_document_PayloadFragment() {
  /*<skip>*/
}
$h_Lamf_client_model_document_PayloadFragment.prototype = $c_Lamf_client_model_document_PayloadFragment.prototype;
$c_Lamf_client_model_document_PayloadFragment.prototype.productPrefix__T = (function() {
  return "PayloadFragment"
});
$c_Lamf_client_model_document_PayloadFragment.prototype.dataNode__Lamf_client_model_domain_DataNode = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = $as_Lamf_core_model_document_PayloadFragment(this.$$undinternal$1);
  var from = $as_Lamf_core_model_domain_DataNode(this$1.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().Encodes$1));
  var m = $m_Lamf_client_convert_CoreClientConverters$().DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$();
  return m.asClient__Lamf_core_model_domain_DataNode__Lamf_client_model_domain_DataNode(from)
});
$c_Lamf_client_model_document_PayloadFragment.prototype.$$js$exported$prop$dataNode__O = (function() {
  return this.dataNode__Lamf_client_model_domain_DataNode()
});
$c_Lamf_client_model_document_PayloadFragment.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_document_PayloadFragment.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_document_PayloadFragment)) {
    var PayloadFragment$1 = $as_Lamf_client_model_document_PayloadFragment(x$1);
    var x = $as_Lamf_core_model_document_PayloadFragment(this.$$undinternal$1);
    var x$2 = $as_Lamf_core_model_document_PayloadFragment(PayloadFragment$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_document_PayloadFragment.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_core_model_document_PayloadFragment(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_document_PayloadFragment.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_document_PayloadFragment.prototype.init___Lamf_client_model_domain_ArrayNode__T = (function(arr, mediaType) {
  $c_Lamf_client_model_document_PayloadFragment.prototype.init___Lamf_core_model_document_PayloadFragment.call(this, $m_Lamf_core_model_document_PayloadFragment$().apply__Lamf_core_model_domain_DataNode__T__Lamf_core_model_document_PayloadFragment(arr.$$undinternal$1, mediaType));
  return this
});
$c_Lamf_client_model_document_PayloadFragment.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return $as_Lamf_core_model_document_PayloadFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_PayloadFragment.prototype.init___Lamf_client_model_domain_ObjectNode__T = (function(obj, mediaType) {
  $c_Lamf_client_model_document_PayloadFragment.prototype.init___Lamf_core_model_document_PayloadFragment.call(this, $m_Lamf_core_model_document_PayloadFragment$().apply__Lamf_core_model_domain_DataNode__T__Lamf_core_model_document_PayloadFragment(obj.$$undinternal$1, mediaType));
  return this
});
$c_Lamf_client_model_document_PayloadFragment.prototype.$$undinternal__Lamf_core_model_document_EncodesModel = (function() {
  return $as_Lamf_core_model_document_PayloadFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_PayloadFragment.prototype.init___Lamf_core_model_document_PayloadFragment = (function(_internal) {
  $c_Lamf_client_model_document_Fragment.prototype.init___Lamf_core_model_document_Fragment.call(this, _internal);
  return this
});
$c_Lamf_client_model_document_PayloadFragment.prototype.$$undinternal__Lamf_core_model_document_Fragment = (function() {
  return $as_Lamf_core_model_document_PayloadFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_PayloadFragment.prototype.$$js$exported$prop$mediaType__O = (function() {
  var this$1 = $as_Lamf_core_model_document_PayloadFragment(this.$$undinternal$1);
  return $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().MediaType$1))
});
$c_Lamf_client_model_document_PayloadFragment.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_core_model_document_PayloadFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_PayloadFragment.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_document_PayloadFragment.prototype.init___Lamf_client_model_domain_ScalarNode__T = (function(scalar, mediaType) {
  $c_Lamf_client_model_document_PayloadFragment.prototype.init___Lamf_core_model_document_PayloadFragment.call(this, $m_Lamf_core_model_document_PayloadFragment$().apply__Lamf_core_model_domain_DataNode__T__Lamf_core_model_document_PayloadFragment(scalar.$$undinternal$1, mediaType));
  return this
});
$c_Lamf_client_model_document_PayloadFragment.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
Object.defineProperty($c_Lamf_client_model_document_PayloadFragment.prototype, "dataNode", {
  "get": (function() {
    return this.$$js$exported$prop$dataNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_document_PayloadFragment.prototype, "mediaType", {
  "get": (function() {
    return this.$$js$exported$prop$mediaType__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_document_PayloadFragment(obj) {
  return (((obj instanceof $c_Lamf_client_model_document_PayloadFragment) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.document.PayloadFragment"))
}
function $isArrayOf_Lamf_client_model_document_PayloadFragment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_document_PayloadFragment)))
}
function $asArrayOf_Lamf_client_model_document_PayloadFragment(obj, depth) {
  return (($isArrayOf_Lamf_client_model_document_PayloadFragment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.document.PayloadFragment;", depth))
}
var $d_Lamf_client_model_document_PayloadFragment = new $TypeData().initClass({
  Lamf_client_model_document_PayloadFragment: 0
}, false, "amf.client.model.document.PayloadFragment", {
  Lamf_client_model_document_PayloadFragment: 1,
  Lamf_client_model_document_Fragment: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_EncodesModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_document_PayloadFragment.prototype.$classData = $d_Lamf_client_model_document_PayloadFragment;
/** @constructor */
function $c_Lamf_client_model_document_ResourceTypeFragment() {
  $c_Lamf_client_model_document_Fragment.call(this)
}
$c_Lamf_client_model_document_ResourceTypeFragment.prototype = new $h_Lamf_client_model_document_Fragment();
$c_Lamf_client_model_document_ResourceTypeFragment.prototype.constructor = $c_Lamf_client_model_document_ResourceTypeFragment;
/** @constructor */
function $h_Lamf_client_model_document_ResourceTypeFragment() {
  /*<skip>*/
}
$h_Lamf_client_model_document_ResourceTypeFragment.prototype = $c_Lamf_client_model_document_ResourceTypeFragment.prototype;
$c_Lamf_client_model_document_ResourceTypeFragment.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_document_ResourceTypeFragment.prototype.init___Lamf_plugins_document_webapi_model_ResourceTypeFragment.call(this, new $c_Lamf_plugins_document_webapi_model_ResourceTypeFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_document_ResourceTypeFragment.prototype.productPrefix__T = (function() {
  return "ResourceTypeFragment"
});
$c_Lamf_client_model_document_ResourceTypeFragment.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_document_ResourceTypeFragment.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_document_ResourceTypeFragment)) {
    var ResourceTypeFragment$1 = $as_Lamf_client_model_document_ResourceTypeFragment(x$1);
    var x = $as_Lamf_plugins_document_webapi_model_ResourceTypeFragment(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_document_webapi_model_ResourceTypeFragment(ResourceTypeFragment$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_document_ResourceTypeFragment.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_document_webapi_model_ResourceTypeFragment(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_document_ResourceTypeFragment.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_document_ResourceTypeFragment.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return $as_Lamf_plugins_document_webapi_model_ResourceTypeFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_ResourceTypeFragment.prototype.$$undinternal__Lamf_core_model_document_EncodesModel = (function() {
  return $as_Lamf_plugins_document_webapi_model_ResourceTypeFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_ResourceTypeFragment.prototype.$$undinternal__Lamf_core_model_document_Fragment = (function() {
  return $as_Lamf_plugins_document_webapi_model_ResourceTypeFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_ResourceTypeFragment.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_document_webapi_model_ResourceTypeFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_ResourceTypeFragment.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_document_ResourceTypeFragment.prototype.init___Lamf_plugins_document_webapi_model_ResourceTypeFragment = (function(_internal) {
  $c_Lamf_client_model_document_Fragment.prototype.init___Lamf_core_model_document_Fragment.call(this, _internal);
  return this
});
$c_Lamf_client_model_document_ResourceTypeFragment.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_client_model_document_ResourceTypeFragment(obj) {
  return (((obj instanceof $c_Lamf_client_model_document_ResourceTypeFragment) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.document.ResourceTypeFragment"))
}
function $isArrayOf_Lamf_client_model_document_ResourceTypeFragment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_document_ResourceTypeFragment)))
}
function $asArrayOf_Lamf_client_model_document_ResourceTypeFragment(obj, depth) {
  return (($isArrayOf_Lamf_client_model_document_ResourceTypeFragment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.document.ResourceTypeFragment;", depth))
}
var $d_Lamf_client_model_document_ResourceTypeFragment = new $TypeData().initClass({
  Lamf_client_model_document_ResourceTypeFragment: 0
}, false, "amf.client.model.document.ResourceTypeFragment", {
  Lamf_client_model_document_ResourceTypeFragment: 1,
  Lamf_client_model_document_Fragment: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_EncodesModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_document_ResourceTypeFragment.prototype.$classData = $d_Lamf_client_model_document_ResourceTypeFragment;
/** @constructor */
function $c_Lamf_client_model_document_SecuritySchemeFragment() {
  $c_Lamf_client_model_document_Fragment.call(this)
}
$c_Lamf_client_model_document_SecuritySchemeFragment.prototype = new $h_Lamf_client_model_document_Fragment();
$c_Lamf_client_model_document_SecuritySchemeFragment.prototype.constructor = $c_Lamf_client_model_document_SecuritySchemeFragment;
/** @constructor */
function $h_Lamf_client_model_document_SecuritySchemeFragment() {
  /*<skip>*/
}
$h_Lamf_client_model_document_SecuritySchemeFragment.prototype = $c_Lamf_client_model_document_SecuritySchemeFragment.prototype;
$c_Lamf_client_model_document_SecuritySchemeFragment.prototype.init___Lamf_plugins_document_webapi_model_SecuritySchemeFragment = (function(_internal) {
  $c_Lamf_client_model_document_Fragment.prototype.init___Lamf_core_model_document_Fragment.call(this, _internal);
  return this
});
$c_Lamf_client_model_document_SecuritySchemeFragment.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_document_SecuritySchemeFragment.prototype.init___Lamf_plugins_document_webapi_model_SecuritySchemeFragment.call(this, new $c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_document_SecuritySchemeFragment.prototype.productPrefix__T = (function() {
  return "SecuritySchemeFragment"
});
$c_Lamf_client_model_document_SecuritySchemeFragment.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_document_SecuritySchemeFragment.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_document_SecuritySchemeFragment)) {
    var SecuritySchemeFragment$1 = $as_Lamf_client_model_document_SecuritySchemeFragment(x$1);
    var x = $as_Lamf_plugins_document_webapi_model_SecuritySchemeFragment(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_document_webapi_model_SecuritySchemeFragment(SecuritySchemeFragment$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_document_SecuritySchemeFragment.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_document_webapi_model_SecuritySchemeFragment(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_document_SecuritySchemeFragment.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_document_SecuritySchemeFragment.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return $as_Lamf_plugins_document_webapi_model_SecuritySchemeFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_SecuritySchemeFragment.prototype.$$undinternal__Lamf_core_model_document_EncodesModel = (function() {
  return $as_Lamf_plugins_document_webapi_model_SecuritySchemeFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_SecuritySchemeFragment.prototype.$$undinternal__Lamf_core_model_document_Fragment = (function() {
  return $as_Lamf_plugins_document_webapi_model_SecuritySchemeFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_SecuritySchemeFragment.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_document_webapi_model_SecuritySchemeFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_SecuritySchemeFragment.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_document_SecuritySchemeFragment.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_client_model_document_SecuritySchemeFragment(obj) {
  return (((obj instanceof $c_Lamf_client_model_document_SecuritySchemeFragment) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.document.SecuritySchemeFragment"))
}
function $isArrayOf_Lamf_client_model_document_SecuritySchemeFragment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_document_SecuritySchemeFragment)))
}
function $asArrayOf_Lamf_client_model_document_SecuritySchemeFragment(obj, depth) {
  return (($isArrayOf_Lamf_client_model_document_SecuritySchemeFragment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.document.SecuritySchemeFragment;", depth))
}
var $d_Lamf_client_model_document_SecuritySchemeFragment = new $TypeData().initClass({
  Lamf_client_model_document_SecuritySchemeFragment: 0
}, false, "amf.client.model.document.SecuritySchemeFragment", {
  Lamf_client_model_document_SecuritySchemeFragment: 1,
  Lamf_client_model_document_Fragment: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_EncodesModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_document_SecuritySchemeFragment.prototype.$classData = $d_Lamf_client_model_document_SecuritySchemeFragment;
/** @constructor */
function $c_Lamf_client_model_document_TraitFragment() {
  $c_Lamf_client_model_document_Fragment.call(this)
}
$c_Lamf_client_model_document_TraitFragment.prototype = new $h_Lamf_client_model_document_Fragment();
$c_Lamf_client_model_document_TraitFragment.prototype.constructor = $c_Lamf_client_model_document_TraitFragment;
/** @constructor */
function $h_Lamf_client_model_document_TraitFragment() {
  /*<skip>*/
}
$h_Lamf_client_model_document_TraitFragment.prototype = $c_Lamf_client_model_document_TraitFragment.prototype;
$c_Lamf_client_model_document_TraitFragment.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_document_TraitFragment.prototype.init___Lamf_plugins_document_webapi_model_TraitFragment.call(this, new $c_Lamf_plugins_document_webapi_model_TraitFragment().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_document_TraitFragment.prototype.productPrefix__T = (function() {
  return "TraitFragment"
});
$c_Lamf_client_model_document_TraitFragment.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_document_TraitFragment.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_document_TraitFragment)) {
    var TraitFragment$1 = $as_Lamf_client_model_document_TraitFragment(x$1);
    var x = $as_Lamf_plugins_document_webapi_model_TraitFragment(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_document_webapi_model_TraitFragment(TraitFragment$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_document_TraitFragment.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_document_webapi_model_TraitFragment(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_document_TraitFragment.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_document_TraitFragment.prototype.init___Lamf_plugins_document_webapi_model_TraitFragment = (function(_internal) {
  $c_Lamf_client_model_document_Fragment.prototype.init___Lamf_core_model_document_Fragment.call(this, _internal);
  return this
});
$c_Lamf_client_model_document_TraitFragment.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return $as_Lamf_plugins_document_webapi_model_TraitFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_TraitFragment.prototype.$$undinternal__Lamf_core_model_document_EncodesModel = (function() {
  return $as_Lamf_plugins_document_webapi_model_TraitFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_TraitFragment.prototype.$$undinternal__Lamf_core_model_document_Fragment = (function() {
  return $as_Lamf_plugins_document_webapi_model_TraitFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_TraitFragment.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_document_webapi_model_TraitFragment(this.$$undinternal$1)
});
$c_Lamf_client_model_document_TraitFragment.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_document_TraitFragment.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_client_model_document_TraitFragment(obj) {
  return (((obj instanceof $c_Lamf_client_model_document_TraitFragment) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.document.TraitFragment"))
}
function $isArrayOf_Lamf_client_model_document_TraitFragment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_document_TraitFragment)))
}
function $asArrayOf_Lamf_client_model_document_TraitFragment(obj, depth) {
  return (($isArrayOf_Lamf_client_model_document_TraitFragment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.document.TraitFragment;", depth))
}
var $d_Lamf_client_model_document_TraitFragment = new $TypeData().initClass({
  Lamf_client_model_document_TraitFragment: 0
}, false, "amf.client.model.document.TraitFragment", {
  Lamf_client_model_document_TraitFragment: 1,
  Lamf_client_model_document_Fragment: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_EncodesModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_document_TraitFragment.prototype.$classData = $d_Lamf_client_model_document_TraitFragment;
/** @constructor */
function $c_Lamf_client_model_domain_ChannelBindings() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_ChannelBindings.prototype = new $h_O();
$c_Lamf_client_model_domain_ChannelBindings.prototype.constructor = $c_Lamf_client_model_domain_ChannelBindings;
/** @constructor */
function $h_Lamf_client_model_domain_ChannelBindings() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_ChannelBindings.prototype = $c_Lamf_client_model_domain_ChannelBindings.prototype;
$c_Lamf_client_model_domain_ChannelBindings.prototype.productPrefix__T = (function() {
  return "ChannelBindings"
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_ChannelBindings.prototype.init___Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.call(this, new $c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.linkCopy__Lamf_client_model_domain_ChannelBindings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.linkCopy__Lamf_plugins_domain_webapi_models_bindings_ChannelBindings();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ChannelBindingsMatcher__Lamf_client_convert_ChannelBindingsConverter$ChannelBindingsMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_ChannelBindings__Lamf_client_model_domain_ChannelBindings(from)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_ChannelBindings)) {
    var ChannelBindings$1 = $as_Lamf_client_model_domain_ChannelBindings(x$1);
    var x = this.$$undinternal$1;
    var x$2 = ChannelBindings$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.bindings__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$().Bindings$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ChannelBindingMatcher__Lamf_client_convert_ChannelBindingConverter$ChannelBindingMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$prop$bindings__O = (function() {
  return this.bindings__sjs_js_Array()
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.withName__T__Lamf_client_model_domain_ChannelBindings = (function(name) {
  var this$3 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_ChannelBindings()
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_ChannelBindings()
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.init___Lamf_plugins_domain_webapi_models_bindings_ChannelBindings = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$meth$withBindings__sjs_js_Array__O = (function(bindings) {
  return this.withBindings__sjs_js_Array__Lamf_client_model_domain_ChannelBindings(bindings)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_ChannelBindings(name)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.withBindings__sjs_js_Array__Lamf_client_model_domain_ChannelBindings = (function(bindings) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ChannelBindingMatcher__Lamf_client_convert_ChannelBindingConverter$ChannelBindingMatcher$();
  var bindings$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, bindings, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$().Bindings$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, bindings$1));
  return this
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ChannelBindings.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ChannelBindings.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ChannelBindings.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ChannelBindings.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ChannelBindings.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ChannelBindings.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ChannelBindings.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ChannelBindings.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.withBindings = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withBindings__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ChannelBindings.prototype, "bindings", {
  "get": (function() {
    return this.$$js$exported$prop$bindings__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ChannelBindings.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_ChannelBindings(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_ChannelBindings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.ChannelBindings"))
}
function $isArrayOf_Lamf_client_model_domain_ChannelBindings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_ChannelBindings)))
}
function $asArrayOf_Lamf_client_model_domain_ChannelBindings(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_ChannelBindings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.ChannelBindings;", depth))
}
var $d_Lamf_client_model_domain_ChannelBindings = new $TypeData().initClass({
  Lamf_client_model_domain_ChannelBindings: 0
}, false, "amf.client.model.domain.ChannelBindings", {
  Lamf_client_model_domain_ChannelBindings: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  Lamf_client_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_ChannelBindings.prototype.$classData = $d_Lamf_client_model_domain_ChannelBindings;
/** @constructor */
function $c_Lamf_client_model_domain_CorrelationId() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_CorrelationId.prototype = new $h_O();
$c_Lamf_client_model_domain_CorrelationId.prototype.constructor = $c_Lamf_client_model_domain_CorrelationId;
/** @constructor */
function $h_Lamf_client_model_domain_CorrelationId() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_CorrelationId.prototype = $c_Lamf_client_model_domain_CorrelationId.prototype;
$c_Lamf_client_model_domain_CorrelationId.prototype.productPrefix__T = (function() {
  return "CorrelationId"
});
$c_Lamf_client_model_domain_CorrelationId.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_CorrelationId.prototype.init___Lamf_plugins_domain_webapi_models_CorrelationId.call(this, new $c_Lamf_plugins_domain_webapi_models_CorrelationId().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_CorrelationId.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_CorrelationId.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_CorrelationId)) {
    var CorrelationId$1 = $as_Lamf_client_model_domain_CorrelationId(x$1);
    var x = this.$$undinternal$1;
    var x$2 = CorrelationId$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_CorrelationId.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_CorrelationId.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.withIdLocation__T__Lamf_client_model_domain_CorrelationId = (function(idLocation) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$().Location$1;
  $as_Lamf_plugins_domain_webapi_models_CorrelationId($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, idLocation));
  return this
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.description__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$().Description$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.init___Lamf_plugins_domain_webapi_models_CorrelationId = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_CorrelationId()
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_CorrelationId()
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.withName__T__Lamf_client_model_domain_CorrelationId = (function(name) {
  var this$3 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$meth$withDescription__T__O = (function(description) {
  return this.withDescription__T__Lamf_client_model_domain_CorrelationId(description)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.linkCopy__Lamf_client_model_domain_CorrelationId = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$5 = new $c_Lamf_plugins_domain_webapi_models_CorrelationId().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_webapi_models_CorrelationId($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().CorrelationIdMatcher__Lamf_client_convert_CorrelationIdConverter$CorrelationIdMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_CorrelationId__Lamf_client_model_domain_CorrelationId(from)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$prop$description__O = (function() {
  return this.description__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_CorrelationId.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$meth$withIdLocation__T__O = (function(idLocation) {
  return this.withIdLocation__T__Lamf_client_model_domain_CorrelationId(idLocation)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$prop$idLocation__O = (function() {
  return this.idLocation__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_CorrelationId(name)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.idLocation__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$().Location$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.withDescription__T__Lamf_client_model_domain_CorrelationId = (function(description) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$().Description$1;
  $as_Lamf_plugins_domain_webapi_models_CorrelationId($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, description));
  return this
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_CorrelationId.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_CorrelationId.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_CorrelationId.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_CorrelationId.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_CorrelationId.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_CorrelationId.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_CorrelationId.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_CorrelationId.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_CorrelationId.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_CorrelationId.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_CorrelationId.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_CorrelationId.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_CorrelationId.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_CorrelationId.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_CorrelationId.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_CorrelationId.prototype.withIdLocation = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withIdLocation__T__O(prep)
});
$c_Lamf_client_model_domain_CorrelationId.prototype.withDescription = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDescription__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_CorrelationId.prototype, "idLocation", {
  "get": (function() {
    return this.$$js$exported$prop$idLocation__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_CorrelationId.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_CorrelationId(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_CorrelationId) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.CorrelationId"))
}
function $isArrayOf_Lamf_client_model_domain_CorrelationId(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_CorrelationId)))
}
function $asArrayOf_Lamf_client_model_domain_CorrelationId(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_CorrelationId(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.CorrelationId;", depth))
}
var $d_Lamf_client_model_domain_CorrelationId = new $TypeData().initClass({
  Lamf_client_model_domain_CorrelationId: 0
}, false, "amf.client.model.domain.CorrelationId", {
  Lamf_client_model_domain_CorrelationId: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_CorrelationId.prototype.$classData = $d_Lamf_client_model_domain_CorrelationId;
/** @constructor */
function $c_Lamf_client_model_domain_Example() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_Example.prototype = new $h_O();
$c_Lamf_client_model_domain_Example.prototype.constructor = $c_Lamf_client_model_domain_Example;
/** @constructor */
function $h_Lamf_client_model_domain_Example() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_Example.prototype = $c_Lamf_client_model_domain_Example.prototype;
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$meth$withStructuredValue__Lamf_client_model_domain_DataNode__O = (function(value) {
  return this.withStructuredValue__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_Example(value)
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$prop$structuredValue__O = (function() {
  return this.structuredValue__Lamf_client_model_domain_DataNode()
});
$c_Lamf_client_model_domain_Example.prototype.productPrefix__T = (function() {
  return "Example"
});
$c_Lamf_client_model_domain_Example.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_Example.prototype.init___Lamf_plugins_domain_shapes_models_Example.call(this, new $c_Lamf_plugins_domain_shapes_models_Example().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_Example.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_Example.prototype.structuredValue__Lamf_client_model_domain_DataNode = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_domain_DataNode(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$();
  return m.asClient__Lamf_core_model_domain_DataNode__Lamf_client_model_domain_DataNode(from)
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_Example.prototype.withDisplayName__T__Lamf_client_model_domain_Example = (function(displayName) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().DisplayName$1;
  $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, displayName));
  return this
});
$c_Lamf_client_model_domain_Example.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$prop$displayName__O = (function() {
  return this.displayName__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Example.prototype.mediaType__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().MediaType$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Example.prototype.withStrict__Z__Lamf_client_model_domain_Example = (function(strict) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Strict$1;
  $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, strict));
  return this
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_Example.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Example.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_Example)) {
    var Example$1 = $as_Lamf_client_model_domain_Example(x$1);
    var x = this.$$undinternal$1;
    var x$2 = Example$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$prop$toYaml__O = (function() {
  var this$1 = this.$$undinternal$1;
  var this$2 = this$1.platform$1;
  var exec = this$2.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  return $f_Lamf_plugins_document_webapi_parser_spec_common_PayloadSerializer__toYaml__Lamf_plugins_domain_shapes_models_Example__Lamf_client_execution_BaseExecutionEnvironment__T(this$1, this$1, exec)
});
$c_Lamf_client_model_domain_Example.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$prop$location__O = (function() {
  return this.location__sjs_js_UndefOr()
});
$c_Lamf_client_model_domain_Example.prototype.strict__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Strict$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_Example.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_Example.prototype.description__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Description$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_Example.prototype.value__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$meth$withValue__T__O = (function(value) {
  return this.withValue__T__Lamf_client_model_domain_Example(value)
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$meth$withDisplayName__T__O = (function(displayName) {
  return this.withDisplayName__T__Lamf_client_model_domain_Example(displayName)
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$prop$toJson__O = (function() {
  var this$1 = this.$$undinternal$1;
  var this$2 = this$1.platform$1;
  var exec = this$2.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  return $f_Lamf_plugins_document_webapi_parser_spec_common_PayloadSerializer__toJson__Lamf_plugins_domain_shapes_models_Example__Lamf_client_execution_BaseExecutionEnvironment__T(this$1, this$1, exec)
});
$c_Lamf_client_model_domain_Example.prototype.linkCopy__Lamf_client_model_domain_Example = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$6 = new $c_Lamf_plugins_domain_shapes_models_Example().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$6, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ExampleMatcher__Lamf_client_convert_ExampleConverter$ExampleMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_Example__Lamf_client_model_domain_Example(from)
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_Example()
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Example.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_Example()
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$meth$withMediaType__T__O = (function(mediaType) {
  return this.withMediaType__T__Lamf_client_model_domain_Example(mediaType)
});
$c_Lamf_client_model_domain_Example.prototype.withMediaType__T__Lamf_client_model_domain_Example = (function(mediaType) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().MediaType$1;
  $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, mediaType));
  return this
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$meth$withDescription__T__O = (function(description) {
  return this.withDescription__T__Lamf_client_model_domain_Example(description)
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$prop$value__O = (function() {
  return this.value__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_Example.prototype.withName__T__Lamf_client_model_domain_Example = (function(name) {
  var this$3 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$prop$mediaType__O = (function() {
  return this.mediaType__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_Example.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Example.prototype.withStructuredValue__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_Example = (function(value) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$();
  var value$1 = value.$$undinternal__Lamf_core_model_domain_DataNode();
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().StructuredValue$1;
  $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, value$1));
  return this
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$prop$description__O = (function() {
  return this.description__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Example.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_Example.prototype.init___Lamf_plugins_domain_shapes_models_Example = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$meth$withStrict__Z__O = (function(strict) {
  return this.withStrict__Z__Lamf_client_model_domain_Example(strict)
});
$c_Lamf_client_model_domain_Example.prototype.displayName__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().DisplayName$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$prop$strict__O = (function() {
  return this.strict__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_Example.prototype.location__sjs_js_UndefOr = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $f_Lamf_core_model_domain_ExternalSourceElement__location__s_Option(this$1);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Example.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_Example(name)
});
$c_Lamf_client_model_domain_Example.prototype.withValue__T__Lamf_client_model_domain_Example = (function(value) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1;
  $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, value));
  return this
});
$c_Lamf_client_model_domain_Example.prototype.withDescription__T__Lamf_client_model_domain_Example = (function(description) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$().Description$1;
  $as_Lamf_plugins_domain_shapes_models_Example($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, description));
  return this
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_Example.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_Example.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_Example.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_Example.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Example.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Example.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_Example.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Example.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Example.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Example.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Example.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Example.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Example.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_Example.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_Example.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Example.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Example.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Example.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Example.prototype, "toYaml", {
  "get": (function() {
    return this.$$js$exported$prop$toYaml__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Example.prototype, "toJson", {
  "get": (function() {
    return this.$$js$exported$prop$toJson__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Example.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_Example.prototype.withMediaType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withMediaType__T__O(prep)
});
$c_Lamf_client_model_domain_Example.prototype.withStrict = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withStrict__Z__O(prep)
});
$c_Lamf_client_model_domain_Example.prototype.withStructuredValue = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DataNode(arg);
  return this.$$js$exported$meth$withStructuredValue__Lamf_client_model_domain_DataNode__O(prep)
});
$c_Lamf_client_model_domain_Example.prototype.withValue = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withValue__T__O(prep)
});
$c_Lamf_client_model_domain_Example.prototype.withDescription = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDescription__T__O(prep)
});
$c_Lamf_client_model_domain_Example.prototype.withDisplayName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDisplayName__T__O(prep)
});
$c_Lamf_client_model_domain_Example.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Example.prototype, "location", {
  "get": (function() {
    return this.$$js$exported$prop$location__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Example.prototype, "mediaType", {
  "get": (function() {
    return this.$$js$exported$prop$mediaType__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Example.prototype, "strict", {
  "get": (function() {
    return this.$$js$exported$prop$strict__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Example.prototype, "structuredValue", {
  "get": (function() {
    return this.$$js$exported$prop$structuredValue__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Example.prototype, "value", {
  "get": (function() {
    return this.$$js$exported$prop$value__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Example.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Example.prototype, "displayName", {
  "get": (function() {
    return this.$$js$exported$prop$displayName__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Example.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_Example(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_Example) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Example"))
}
function $isArrayOf_Lamf_client_model_domain_Example(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Example)))
}
function $asArrayOf_Lamf_client_model_domain_Example(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Example(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Example;", depth))
}
var $d_Lamf_client_model_domain_Example = new $TypeData().initClass({
  Lamf_client_model_domain_Example: 0
}, false, "amf.client.model.domain.Example", {
  Lamf_client_model_domain_Example: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_Example.prototype.$classData = $d_Lamf_client_model_domain_Example;
/** @constructor */
function $c_Lamf_client_model_domain_MessageBindings() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_MessageBindings.prototype = new $h_O();
$c_Lamf_client_model_domain_MessageBindings.prototype.constructor = $c_Lamf_client_model_domain_MessageBindings;
/** @constructor */
function $h_Lamf_client_model_domain_MessageBindings() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_MessageBindings.prototype = $c_Lamf_client_model_domain_MessageBindings.prototype;
$c_Lamf_client_model_domain_MessageBindings.prototype.productPrefix__T = (function() {
  return "MessageBindings"
});
$c_Lamf_client_model_domain_MessageBindings.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_MessageBindings.prototype.init___Lamf_plugins_domain_webapi_models_bindings_MessageBindings.call(this, new $c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_MessageBindings.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_MessageBindings.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_MessageBindings)) {
    var MessageBindings$1 = $as_Lamf_client_model_domain_MessageBindings(x$1);
    var x = this.$$undinternal$1;
    var x$2 = MessageBindings$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_MessageBindings.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_MessageBindings.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.bindings__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$().Bindings$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().MessageBindingMatcher__Lamf_client_convert_MessageBindingConverter$MessageBindingMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_MessageBindings.prototype.withName__T__Lamf_client_model_domain_MessageBindings = (function(name) {
  var this$3 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$prop$bindings__O = (function() {
  return this.bindings__sjs_js_Array()
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.init___Lamf_plugins_domain_webapi_models_bindings_MessageBindings = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_MessageBindings()
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_MessageBindings()
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.withBindings__sjs_js_Array__Lamf_client_model_domain_MessageBindings = (function(bindings) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().MessageBindingMatcher__Lamf_client_convert_MessageBindingConverter$MessageBindingMatcher$();
  var bindings$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, bindings, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$().Bindings$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_MessageBindings($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, bindings$1));
  return this
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_MessageBindings.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$meth$withBindings__sjs_js_Array__O = (function(bindings) {
  return this.withBindings__sjs_js_Array__Lamf_client_model_domain_MessageBindings(bindings)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_MessageBindings(name)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.linkCopy__Lamf_client_model_domain_MessageBindings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.linkCopy__Lamf_plugins_domain_webapi_models_bindings_MessageBindings();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().MessageBindingsMatcher__Lamf_client_convert_MessageBindingsConverter$MessageBindingsMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_MessageBindings__Lamf_client_model_domain_MessageBindings(from)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_MessageBindings.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_MessageBindings.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_MessageBindings.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_MessageBindings.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_MessageBindings.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MessageBindings.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MessageBindings.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MessageBindings.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_MessageBindings.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_MessageBindings.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MessageBindings.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MessageBindings.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_MessageBindings.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_MessageBindings.prototype.withBindings = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withBindings__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_MessageBindings.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_MessageBindings.prototype, "bindings", {
  "get": (function() {
    return this.$$js$exported$prop$bindings__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MessageBindings.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_MessageBindings(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_MessageBindings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.MessageBindings"))
}
function $isArrayOf_Lamf_client_model_domain_MessageBindings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_MessageBindings)))
}
function $asArrayOf_Lamf_client_model_domain_MessageBindings(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_MessageBindings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.MessageBindings;", depth))
}
var $d_Lamf_client_model_domain_MessageBindings = new $TypeData().initClass({
  Lamf_client_model_domain_MessageBindings: 0
}, false, "amf.client.model.domain.MessageBindings", {
  Lamf_client_model_domain_MessageBindings: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  Lamf_client_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_MessageBindings.prototype.$classData = $d_Lamf_client_model_domain_MessageBindings;
/** @constructor */
function $c_Lamf_client_model_domain_Operation() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_Operation.prototype = new $h_O();
$c_Lamf_client_model_domain_Operation.prototype.constructor = $c_Lamf_client_model_domain_Operation;
/** @constructor */
function $h_Lamf_client_model_domain_Operation() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_Operation.prototype = $c_Lamf_client_model_domain_Operation.prototype;
$c_Lamf_client_model_domain_Operation.prototype.withDeprecated__Z__Lamf_client_model_domain_Operation = (function(deprecated) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Deprecated$1;
  $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, deprecated));
  return this
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withTags__sjs_js_Array__O = (function(tags) {
  return this.withTags__sjs_js_Array__Lamf_client_model_domain_Operation(tags)
});
$c_Lamf_client_model_domain_Operation.prototype.withResponse__T__Lamf_client_model_domain_Response = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withResponse__T__Lamf_plugins_domain_webapi_models_Response(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ResponseMatcher__Lamf_client_convert_MessageConverter$ResponseMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Response__Lamf_client_model_domain_Response(from)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$operationId__O = (function() {
  return this.operationId__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Operation.prototype.bindings__Lamf_client_model_domain_OperationBindings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_plugins_domain_webapi_models_bindings_OperationBindings(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Bindings$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().OperationBindingsMatcher__Lamf_client_convert_OperationBindingsConverter$OperationBindingsMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_OperationBindings__Lamf_client_model_domain_OperationBindings(from)
});
$c_Lamf_client_model_domain_Operation.prototype.productPrefix__T = (function() {
  return "Operation"
});
$c_Lamf_client_model_domain_Operation.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Operation.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_Operation.prototype.init___Lamf_plugins_domain_webapi_models_Operation.call(this, new $c_Lamf_plugins_domain_webapi_models_Operation().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$deprecated__O = (function() {
  return this.deprecated__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$accepts__O = (function() {
  return this.accepts__sjs_js_Array()
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_Operation.prototype.withMethod__T__Lamf_client_model_domain_Operation = (function(method) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Method$1;
  $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, method));
  return this
});
$c_Lamf_client_model_domain_Operation.prototype.withName__T__Lamf_client_model_domain_Operation = (function(name) {
  var this$3 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_Operation.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withBindings__Lamf_client_model_domain_OperationBindings__O = (function(bindings) {
  return this.withBindings__Lamf_client_model_domain_OperationBindings__Lamf_client_model_domain_Operation(bindings)
});
$c_Lamf_client_model_domain_Operation.prototype.documentation__Lamf_client_model_domain_CreativeWork = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_plugins_domain_shapes_models_CreativeWork(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Documentation$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().CreativeWorkMatcher__Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_CreativeWork__Lamf_client_model_domain_CreativeWork(from)
});
$c_Lamf_client_model_domain_Operation.prototype.withSummary__T__Lamf_client_model_domain_Operation = (function(summary) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Summary$1;
  $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, summary));
  return this
});
$c_Lamf_client_model_domain_Operation.prototype.withCallback__T__Lamf_client_model_domain_Callback = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withCallback__T__Lamf_plugins_domain_webapi_models_Callback(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().CallbackMatcher__Lamf_client_convert_CallbackConverter$CallbackMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Callback__Lamf_client_model_domain_Callback(from)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withSchemes__sjs_js_Array__O = (function(schemes) {
  return this.withSchemes__sjs_js_Array__Lamf_client_model_domain_Operation(schemes)
});
$c_Lamf_client_model_domain_Operation.prototype.withRequest__Lamf_client_model_domain_Request__Lamf_client_model_domain_Operation = (function(request) {
  this.$$undinternal$1.withRequest__Lamf_plugins_domain_webapi_models_Request__Lamf_plugins_domain_webapi_models_Operation(($m_Lamf_client_convert_WebApiClientConverters$(), $m_Lamf_client_convert_WebApiClientConverters$().RequestMatcher__Lamf_client_convert_MessageConverter$RequestMatcher$(), $as_Lamf_plugins_domain_webapi_models_Request(request.$$undinternal$1)));
  return this
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$requests__O = (function() {
  return this.requests__sjs_js_Array()
});
$c_Lamf_client_model_domain_Operation.prototype.withDescription__T__Lamf_client_model_domain_Operation = (function(description) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Description$1;
  $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, description));
  return this
});
$c_Lamf_client_model_domain_Operation.prototype.withAbstract__Z__Lamf_client_model_domain_Operation = (function(abs) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().IsAbstract$1;
  $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, abs));
  return this
});
$c_Lamf_client_model_domain_Operation.prototype.contentType__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().ContentType$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Operation.prototype.deprecated__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Deprecated$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_Operation.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Operation.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_Operation)) {
    var Operation$1 = $as_Lamf_client_model_domain_Operation(x$1);
    var x = this.$$undinternal$1;
    var x$2 = Operation$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$contentType__O = (function() {
  return this.contentType__sjs_js_Array()
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withCallback__T__O = (function(name) {
  return this.withCallback__T__Lamf_client_model_domain_Callback(name)
});
$c_Lamf_client_model_domain_Operation.prototype.withDocumentation__Lamf_client_model_domain_CreativeWork__Lamf_client_model_domain_Operation = (function(documentation) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().CreativeWorkMatcher__Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$();
  var documentation$1 = documentation.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Documentation$1;
  $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, documentation$1));
  return this
});
$c_Lamf_client_model_domain_Operation.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_Operation.prototype.request__Lamf_client_model_domain_Request = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.request__Lamf_plugins_domain_webapi_models_Request();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().RequestMatcher__Lamf_client_convert_MessageConverter$RequestMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Request__Lamf_client_model_domain_Request(from)
});
$c_Lamf_client_model_domain_Operation.prototype.withOperationId__T__Lamf_client_model_domain_Operation = (function(operationId) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().OperationId$1;
  $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, operationId));
  return this
});
$c_Lamf_client_model_domain_Operation.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_Operation.prototype.callbacks__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Callbacks$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().CallbackMatcher__Lamf_client_convert_CallbackConverter$CallbackMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Operation.prototype.accepts__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Accepts$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Operation.prototype.requests__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Request$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().RequestMatcher__Lamf_client_convert_MessageConverter$RequestMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Operation.prototype.tags__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Tags$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().TagMatcher__Lamf_client_convert_TagConverter$TagMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withRequest__O = (function() {
  return this.withRequest__Lamf_client_model_domain_Request()
});
$c_Lamf_client_model_domain_Operation.prototype.operationId__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().OperationId$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_Operation.prototype.withAccepts__sjs_js_Array__Lamf_client_model_domain_Operation = (function(accepts) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  var accepts$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, accepts, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Accepts$1;
  var values = accepts$1.toList__sci_List();
  $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, values));
  return this
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$bindings__O = (function() {
  return this.bindings__Lamf_client_model_domain_OperationBindings()
});
$c_Lamf_client_model_domain_Operation.prototype.withServers__sjs_js_Array__Lamf_client_model_domain_Operation = (function(servers) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ServerMatcher__Lamf_client_convert_ServerConverter$ServerMatcher$();
  var servers$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, servers, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Servers$1;
  $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, servers$1));
  return this
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$servers__O = (function() {
  return this.servers__sjs_js_Array()
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_Operation.prototype.description__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Description$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Operation.prototype.init___Lamf_plugins_domain_webapi_models_Operation = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$documentation__O = (function() {
  return this.documentation__Lamf_client_model_domain_CreativeWork()
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withResponses__sjs_js_Array__O = (function(responses) {
  return this.withResponses__sjs_js_Array__Lamf_client_model_domain_Operation(responses)
});
$c_Lamf_client_model_domain_Operation.prototype.withSchemes__sjs_js_Array__Lamf_client_model_domain_Operation = (function(schemes) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  var schemes$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, schemes, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Schemes$1;
  var values = schemes$1.toList__sci_List();
  $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, values));
  return this
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withMethod__T__O = (function(method) {
  return this.withMethod__T__Lamf_client_model_domain_Operation(method)
});
$c_Lamf_client_model_domain_Operation.prototype.withSecurity__sjs_js_Array__Lamf_client_model_domain_Operation = (function(security) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().SecurityRequirementMatcher__Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$();
  var security$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, security, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Security$1;
  $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, security$1));
  return this
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withDocumentation__Lamf_client_model_domain_CreativeWork__O = (function(documentation) {
  return this.withDocumentation__Lamf_client_model_domain_CreativeWork__Lamf_client_model_domain_Operation(documentation)
});
$c_Lamf_client_model_domain_Operation.prototype.servers__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Servers$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ServerMatcher__Lamf_client_convert_ServerConverter$ServerMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withContentType__sjs_js_Array__O = (function(contentType) {
  return this.withContentType__sjs_js_Array__Lamf_client_model_domain_Operation(contentType)
});
$c_Lamf_client_model_domain_Operation.prototype.withServer__T__Lamf_client_model_domain_Server = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withServer__T__Lamf_plugins_domain_webapi_models_Server(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ServerMatcher__Lamf_client_convert_ServerConverter$ServerMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Server__Lamf_client_model_domain_Server(from)
});
$c_Lamf_client_model_domain_Operation.prototype.linkCopy__Lamf_client_model_domain_Operation = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$5 = new $c_Lamf_plugins_domain_webapi_models_Operation().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().OperationMatcher__Lamf_client_convert_OperationConverter$OperationMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Operation__Lamf_client_model_domain_Operation(from)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_Operation()
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withCallbacks__sjs_js_Array__O = (function(callbacks) {
  return this.withCallbacks__sjs_js_Array__Lamf_client_model_domain_Operation(callbacks)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withServer__T__O = (function(name) {
  return this.withServer__T__Lamf_client_model_domain_Server(name)
});
$c_Lamf_client_model_domain_Operation.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_Operation()
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withSecurity__sjs_js_Array__O = (function(security) {
  return this.withSecurity__sjs_js_Array__Lamf_client_model_domain_Operation(security)
});
$c_Lamf_client_model_domain_Operation.prototype.withBindings__Lamf_client_model_domain_OperationBindings__Lamf_client_model_domain_Operation = (function(bindings) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().OperationBindingsMatcher__Lamf_client_convert_OperationBindingsConverter$OperationBindingsMatcher$();
  var bindings$1 = bindings.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Bindings$1;
  $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, bindings$1));
  return this
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$isAbstract__O = (function() {
  return this.isAbstract__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Operation.prototype.withCallbacks__sjs_js_Array__Lamf_client_model_domain_Operation = (function(callbacks) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().CallbackMatcher__Lamf_client_convert_CallbackConverter$CallbackMatcher$();
  var callbacks$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, callbacks, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Callbacks$1;
  $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, callbacks$1));
  return this
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$responses__O = (function() {
  return this.responses__sjs_js_Array()
});
$c_Lamf_client_model_domain_Operation.prototype.summary__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Summary$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$schemes__O = (function() {
  return this.schemes__sjs_js_Array()
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withRequest__Lamf_client_model_domain_Request__O = (function(request) {
  return this.withRequest__Lamf_client_model_domain_Request__Lamf_client_model_domain_Operation(request)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withDescription__T__O = (function(description) {
  return this.withDescription__T__Lamf_client_model_domain_Operation(description)
});
$c_Lamf_client_model_domain_Operation.prototype.schemes__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Schemes$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$tags__O = (function() {
  return this.tags__sjs_js_Array()
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_Operation.prototype.method__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Method$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_Operation.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Operation.prototype.withContentType__sjs_js_Array__Lamf_client_model_domain_Operation = (function(contentType) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  var contentType$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, contentType, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().ContentType$1;
  var values = contentType$1.toList__sci_List();
  $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, values));
  return this
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$security__O = (function() {
  return this.security__sjs_js_Array()
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$description__O = (function() {
  return this.description__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Operation.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_Operation.prototype.withTags__sjs_js_Array__Lamf_client_model_domain_Operation = (function(tags) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().TagMatcher__Lamf_client_convert_TagConverter$TagMatcher$();
  var tags$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, tags, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Tags$1;
  $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, tags$1));
  return this
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$summary__O = (function() {
  return this.summary__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Operation.prototype.isAbstract__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().IsAbstract$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withAccepts__sjs_js_Array__O = (function(accepts) {
  return this.withAccepts__sjs_js_Array__Lamf_client_model_domain_Operation(accepts)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withResponse__T__O = (function(name) {
  return this.withResponse__T__Lamf_client_model_domain_Response(name)
});
$c_Lamf_client_model_domain_Operation.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_Operation(name)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withSummary__T__O = (function(summary) {
  return this.withSummary__T__Lamf_client_model_domain_Operation(summary)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$request__O = (function() {
  return this.request__Lamf_client_model_domain_Request()
});
$c_Lamf_client_model_domain_Operation.prototype.responses__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ResponseMatcher__Lamf_client_convert_MessageConverter$ResponseMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$method__O = (function() {
  return this.method__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withServers__sjs_js_Array__O = (function(servers) {
  return this.withServers__sjs_js_Array__Lamf_client_model_domain_Operation(servers)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withAbstract__Z__O = (function(abs) {
  return this.withAbstract__Z__Lamf_client_model_domain_Operation(abs)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withOperationId__T__O = (function(operationId) {
  return this.withOperationId__T__Lamf_client_model_domain_Operation(operationId)
});
$c_Lamf_client_model_domain_Operation.prototype.withResponses__sjs_js_Array__Lamf_client_model_domain_Operation = (function(responses) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ResponseMatcher__Lamf_client_convert_MessageConverter$ResponseMatcher$();
  var responses$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, responses, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1;
  $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, responses$1));
  return this
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$callbacks__O = (function() {
  return this.callbacks__sjs_js_Array()
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_Operation.prototype.security__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Security$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().SecurityRequirementMatcher__Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Operation.prototype.withRequest__Lamf_client_model_domain_Request = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.withRequest__Lamf_plugins_domain_webapi_models_Request();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().RequestMatcher__Lamf_client_convert_MessageConverter$RequestMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Request__Lamf_client_model_domain_Request(from)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withDeprecated__Z__O = (function(deprecated) {
  return this.withDeprecated__Z__Lamf_client_model_domain_Operation(deprecated)
});
$c_Lamf_client_model_domain_Operation.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_Operation.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_Operation.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_Operation.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Operation.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Operation.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Operation.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_Operation.prototype.withOperationId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withOperationId__T__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withBindings = (function(arg) {
  var prep = $as_Lamf_client_model_domain_OperationBindings(arg);
  return this.$$js$exported$meth$withBindings__Lamf_client_model_domain_OperationBindings__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withServer = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withServer__T__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withCallback = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withCallback__T__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withRequest = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      return this.$$js$exported$meth$withRequest__O();
      break
    }
    case 1: {
      var prep = $as_Lamf_client_model_domain_Request(rest[0]);
      return this.$$js$exported$meth$withRequest__Lamf_client_model_domain_Request__O(prep);
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_model_domain_Operation.prototype.withResponse = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withResponse__T__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withAbstract = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withAbstract__Z__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withTags = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withTags__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withServers = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withServers__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withCallbacks = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCallbacks__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withSecurity = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withSecurity__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withResponses = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withResponses__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withContentType = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withContentType__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withAccepts = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withAccepts__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withSchemes = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withSchemes__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withDocumentation = (function(arg) {
  var prep = $as_Lamf_client_model_domain_CreativeWork(arg);
  return this.$$js$exported$meth$withDocumentation__Lamf_client_model_domain_CreativeWork__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withSummary = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withSummary__T__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withDeprecated = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withDeprecated__Z__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withDescription = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDescription__T__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
$c_Lamf_client_model_domain_Operation.prototype.withMethod = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withMethod__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "operationId", {
  "get": (function() {
    return this.$$js$exported$prop$operationId__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "bindings", {
  "get": (function() {
    return this.$$js$exported$prop$bindings__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "isAbstract", {
  "get": (function() {
    return this.$$js$exported$prop$isAbstract__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "servers", {
  "get": (function() {
    return this.$$js$exported$prop$servers__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "callbacks", {
  "get": (function() {
    return this.$$js$exported$prop$callbacks__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "tags", {
  "get": (function() {
    return this.$$js$exported$prop$tags__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "security", {
  "get": (function() {
    return this.$$js$exported$prop$security__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "responses", {
  "get": (function() {
    return this.$$js$exported$prop$responses__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "requests", {
  "get": (function() {
    return this.$$js$exported$prop$requests__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "request", {
  "get": (function() {
    return this.$$js$exported$prop$request__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "contentType", {
  "get": (function() {
    return this.$$js$exported$prop$contentType__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "accepts", {
  "get": (function() {
    return this.$$js$exported$prop$accepts__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "schemes", {
  "get": (function() {
    return this.$$js$exported$prop$schemes__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "documentation", {
  "get": (function() {
    return this.$$js$exported$prop$documentation__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "summary", {
  "get": (function() {
    return this.$$js$exported$prop$summary__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "deprecated", {
  "get": (function() {
    return this.$$js$exported$prop$deprecated__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Operation.prototype, "method", {
  "get": (function() {
    return this.$$js$exported$prop$method__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_Operation(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_Operation) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Operation"))
}
function $isArrayOf_Lamf_client_model_domain_Operation(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Operation)))
}
function $asArrayOf_Lamf_client_model_domain_Operation(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Operation(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Operation;", depth))
}
var $d_Lamf_client_model_domain_Operation = new $TypeData().initClass({
  Lamf_client_model_domain_Operation: 0
}, false, "amf.client.model.domain.Operation", {
  Lamf_client_model_domain_Operation: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  Lamf_client_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_Operation.prototype.$classData = $d_Lamf_client_model_domain_Operation;
/** @constructor */
function $c_Lamf_client_model_domain_OperationBindings() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_OperationBindings.prototype = new $h_O();
$c_Lamf_client_model_domain_OperationBindings.prototype.constructor = $c_Lamf_client_model_domain_OperationBindings;
/** @constructor */
function $h_Lamf_client_model_domain_OperationBindings() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_OperationBindings.prototype = $c_Lamf_client_model_domain_OperationBindings.prototype;
$c_Lamf_client_model_domain_OperationBindings.prototype.productPrefix__T = (function() {
  return "OperationBindings"
});
$c_Lamf_client_model_domain_OperationBindings.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_OperationBindings.prototype.init___Lamf_plugins_domain_webapi_models_bindings_OperationBindings.call(this, new $c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_OperationBindings.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_OperationBindings.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_OperationBindings)) {
    var OperationBindings$1 = $as_Lamf_client_model_domain_OperationBindings(x$1);
    var x = this.$$undinternal$1;
    var x$2 = OperationBindings$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_OperationBindings.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_OperationBindings.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.bindings__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$().Bindings$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().OperationBindingMatcher__Lamf_client_convert_OperationBindingConverter$OperationBindingMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.withName__T__Lamf_client_model_domain_OperationBindings = (function(name) {
  var this$3 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$prop$bindings__O = (function() {
  return this.bindings__sjs_js_Array()
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.linkCopy__Lamf_client_model_domain_OperationBindings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.linkCopy__Lamf_plugins_domain_webapi_models_bindings_OperationBindings();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().OperationBindingsMatcher__Lamf_client_convert_OperationBindingsConverter$OperationBindingsMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_OperationBindings__Lamf_client_model_domain_OperationBindings(from)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_OperationBindings()
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.init___Lamf_plugins_domain_webapi_models_bindings_OperationBindings = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_OperationBindings.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_OperationBindings()
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_OperationBindings.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$meth$withBindings__sjs_js_Array__O = (function(bindings) {
  return this.withBindings__sjs_js_Array__Lamf_client_model_domain_OperationBindings(bindings)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.withBindings__sjs_js_Array__Lamf_client_model_domain_OperationBindings = (function(bindings) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().OperationBindingMatcher__Lamf_client_convert_OperationBindingConverter$OperationBindingMatcher$();
  var bindings$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, bindings, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$().Bindings$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_OperationBindings($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, bindings$1));
  return this
});
$c_Lamf_client_model_domain_OperationBindings.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_OperationBindings(name)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_OperationBindings.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_OperationBindings.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_OperationBindings.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_OperationBindings.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_OperationBindings.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_OperationBindings.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_OperationBindings.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_OperationBindings.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_OperationBindings.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_OperationBindings.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_OperationBindings.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_OperationBindings.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_OperationBindings.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_OperationBindings.prototype.withBindings = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withBindings__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_OperationBindings.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_OperationBindings.prototype, "bindings", {
  "get": (function() {
    return this.$$js$exported$prop$bindings__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_OperationBindings.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_OperationBindings(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_OperationBindings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.OperationBindings"))
}
function $isArrayOf_Lamf_client_model_domain_OperationBindings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_OperationBindings)))
}
function $asArrayOf_Lamf_client_model_domain_OperationBindings(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_OperationBindings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.OperationBindings;", depth))
}
var $d_Lamf_client_model_domain_OperationBindings = new $TypeData().initClass({
  Lamf_client_model_domain_OperationBindings: 0
}, false, "amf.client.model.domain.OperationBindings", {
  Lamf_client_model_domain_OperationBindings: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  Lamf_client_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_OperationBindings.prototype.$classData = $d_Lamf_client_model_domain_OperationBindings;
/** @constructor */
function $c_Lamf_client_model_domain_ParametrizedResourceType() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype = new $h_O();
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.constructor = $c_Lamf_client_model_domain_ParametrizedResourceType;
/** @constructor */
function $h_Lamf_client_model_domain_ParametrizedResourceType() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_ParametrizedResourceType.prototype = $c_Lamf_client_model_domain_ParametrizedResourceType.prototype;
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.productPrefix__T = (function() {
  return "ParametrizedResourceType"
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_ParametrizedResourceType.prototype.init___Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType.call(this, new $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.$$js$exported$prop$target__O = (function() {
  return $f_Lamf_client_model_domain_ParametrizedDeclaration__target__Lamf_client_model_domain_AbstractDeclaration(this)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.$$js$exported$prop$name__O = (function() {
  return $f_Lamf_client_model_domain_ParametrizedDeclaration__name__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_ParametrizedResourceType)) {
    var ParametrizedResourceType$1 = $as_Lamf_client_model_domain_ParametrizedResourceType(x$1);
    var x = this.$$undinternal$1;
    var x$2 = ParametrizedResourceType$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.$$js$exported$meth$withTarget__Lamf_client_model_domain_AbstractDeclaration__O = (function(target) {
  return $f_Lamf_client_model_domain_ParametrizedDeclaration__withTarget__Lamf_client_model_domain_AbstractDeclaration__Lamf_client_model_domain_ParametrizedDeclaration(this, target)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.$$undinternal__Lamf_core_model_domain_templates_ParametrizedDeclaration = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.init___Lamf_plugins_domain_webapi_models_templates_ParametrizedResourceType = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.$$js$exported$prop$variables__O = (function() {
  return $f_Lamf_client_model_domain_ParametrizedDeclaration__variables__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return $f_Lamf_client_model_domain_ParametrizedDeclaration__withName__T__Lamf_client_model_domain_ParametrizedDeclaration(this, name)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.$$js$exported$meth$withVariables__sjs_js_Array__O = (function(variables) {
  return $f_Lamf_client_model_domain_ParametrizedDeclaration__withVariables__sjs_js_Array__Lamf_client_model_domain_ParametrizedDeclaration(this, variables)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedResourceType.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedResourceType.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedResourceType.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedResourceType.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedResourceType.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.withVariables = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withVariables__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.withTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_AbstractDeclaration(arg);
  return this.$$js$exported$meth$withTarget__Lamf_client_model_domain_AbstractDeclaration__O(prep)
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedResourceType.prototype, "variables", {
  "get": (function() {
    return this.$$js$exported$prop$variables__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedResourceType.prototype, "target", {
  "get": (function() {
    return this.$$js$exported$prop$target__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedResourceType.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_ParametrizedResourceType(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_ParametrizedResourceType) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.ParametrizedResourceType"))
}
function $isArrayOf_Lamf_client_model_domain_ParametrizedResourceType(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_ParametrizedResourceType)))
}
function $asArrayOf_Lamf_client_model_domain_ParametrizedResourceType(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_ParametrizedResourceType(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.ParametrizedResourceType;", depth))
}
var $d_Lamf_client_model_domain_ParametrizedResourceType = new $TypeData().initClass({
  Lamf_client_model_domain_ParametrizedResourceType: 0
}, false, "amf.client.model.domain.ParametrizedResourceType", {
  Lamf_client_model_domain_ParametrizedResourceType: 1,
  O: 1,
  Lamf_client_model_domain_ParametrizedDeclaration: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_ParametrizedResourceType.prototype.$classData = $d_Lamf_client_model_domain_ParametrizedResourceType;
/** @constructor */
function $c_Lamf_client_model_domain_ParametrizedTrait() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_ParametrizedTrait.prototype = new $h_O();
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.constructor = $c_Lamf_client_model_domain_ParametrizedTrait;
/** @constructor */
function $h_Lamf_client_model_domain_ParametrizedTrait() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_ParametrizedTrait.prototype = $c_Lamf_client_model_domain_ParametrizedTrait.prototype;
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.productPrefix__T = (function() {
  return "ParametrizedTrait"
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_ParametrizedTrait.prototype.init___Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait.call(this, new $c_Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.$$js$exported$prop$target__O = (function() {
  return $f_Lamf_client_model_domain_ParametrizedDeclaration__target__Lamf_client_model_domain_AbstractDeclaration(this)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.$$js$exported$prop$name__O = (function() {
  return $f_Lamf_client_model_domain_ParametrizedDeclaration__name__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_ParametrizedTrait)) {
    var ParametrizedTrait$1 = $as_Lamf_client_model_domain_ParametrizedTrait(x$1);
    var x = this.$$undinternal$1;
    var x$2 = ParametrizedTrait$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.$$js$exported$meth$withTarget__Lamf_client_model_domain_AbstractDeclaration__O = (function(target) {
  return $f_Lamf_client_model_domain_ParametrizedDeclaration__withTarget__Lamf_client_model_domain_AbstractDeclaration__Lamf_client_model_domain_ParametrizedDeclaration(this, target)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.$$undinternal__Lamf_core_model_domain_templates_ParametrizedDeclaration = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.init___Lamf_plugins_domain_webapi_models_templates_ParametrizedTrait = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.$$js$exported$prop$variables__O = (function() {
  return $f_Lamf_client_model_domain_ParametrizedDeclaration__variables__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return $f_Lamf_client_model_domain_ParametrizedDeclaration__withName__T__Lamf_client_model_domain_ParametrizedDeclaration(this, name)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.$$js$exported$meth$withVariables__sjs_js_Array__O = (function(variables) {
  return $f_Lamf_client_model_domain_ParametrizedDeclaration__withVariables__sjs_js_Array__Lamf_client_model_domain_ParametrizedDeclaration(this, variables)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedTrait.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedTrait.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedTrait.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedTrait.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedTrait.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.withVariables = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withVariables__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.withTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_AbstractDeclaration(arg);
  return this.$$js$exported$meth$withTarget__Lamf_client_model_domain_AbstractDeclaration__O(prep)
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedTrait.prototype, "variables", {
  "get": (function() {
    return this.$$js$exported$prop$variables__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedTrait.prototype, "target", {
  "get": (function() {
    return this.$$js$exported$prop$target__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ParametrizedTrait.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_ParametrizedTrait(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_ParametrizedTrait) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.ParametrizedTrait"))
}
function $isArrayOf_Lamf_client_model_domain_ParametrizedTrait(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_ParametrizedTrait)))
}
function $asArrayOf_Lamf_client_model_domain_ParametrizedTrait(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_ParametrizedTrait(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.ParametrizedTrait;", depth))
}
var $d_Lamf_client_model_domain_ParametrizedTrait = new $TypeData().initClass({
  Lamf_client_model_domain_ParametrizedTrait: 0
}, false, "amf.client.model.domain.ParametrizedTrait", {
  Lamf_client_model_domain_ParametrizedTrait: 1,
  O: 1,
  Lamf_client_model_domain_ParametrizedDeclaration: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_ParametrizedTrait.prototype.$classData = $d_Lamf_client_model_domain_ParametrizedTrait;
/** @constructor */
function $c_Lamf_client_model_domain_ServerBindings() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_ServerBindings.prototype = new $h_O();
$c_Lamf_client_model_domain_ServerBindings.prototype.constructor = $c_Lamf_client_model_domain_ServerBindings;
/** @constructor */
function $h_Lamf_client_model_domain_ServerBindings() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_ServerBindings.prototype = $c_Lamf_client_model_domain_ServerBindings.prototype;
$c_Lamf_client_model_domain_ServerBindings.prototype.productPrefix__T = (function() {
  return "ServerBindings"
});
$c_Lamf_client_model_domain_ServerBindings.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_ServerBindings.prototype.init___Lamf_plugins_domain_webapi_models_bindings_ServerBindings.call(this, new $c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_ServerBindings.prototype.name__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$().Name$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_ServerBindings.prototype.init___Lamf_plugins_domain_webapi_models_bindings_ServerBindings = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$prop$name__O = (function() {
  return this.name__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ServerBindings.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_ServerBindings)) {
    var ServerBindings$1 = $as_Lamf_client_model_domain_ServerBindings(x$1);
    var x = this.$$undinternal$1;
    var x$2 = ServerBindings$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_ServerBindings.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_ServerBindings.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.bindings__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$().Bindings$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ServerBindingMatcher__Lamf_client_convert_ServerBindingConverter$ServerBindingMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$prop$bindings__O = (function() {
  return this.bindings__sjs_js_Array()
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.withName__T__Lamf_client_model_domain_ServerBindings = (function(name) {
  var this$3 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var a = new $c_Lamf_core_parser_Annotations().init___();
  $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$3, name, a);
  return this
});
$c_Lamf_client_model_domain_ServerBindings.prototype.withBindings__sjs_js_Array__Lamf_client_model_domain_ServerBindings = (function(bindings) {
  var this$2 = this.$$undinternal$1;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ServerBindingMatcher__Lamf_client_convert_ServerBindingConverter$ServerBindingMatcher$();
  var bindings$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, bindings, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$().Bindings$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_ServerBindings($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, bindings$1));
  return this
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_ServerBindings()
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_ServerBindings()
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_ServerBindings.prototype.linkCopy__Lamf_client_model_domain_ServerBindings = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = this.$$undinternal$1.linkCopy__Lamf_plugins_domain_webapi_models_bindings_ServerBindings();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ServerBindingsMatcher__Lamf_client_convert_ServerBindingsConverter$ServerBindingsMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_ServerBindings__Lamf_client_model_domain_ServerBindings(from)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$meth$withBindings__sjs_js_Array__O = (function(bindings) {
  return this.withBindings__sjs_js_Array__Lamf_client_model_domain_ServerBindings(bindings)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return this.withName__T__Lamf_client_model_domain_ServerBindings(name)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_ServerBindings.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_ServerBindings.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ServerBindings.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ServerBindings.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ServerBindings.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ServerBindings.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ServerBindings.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ServerBindings.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ServerBindings.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ServerBindings.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ServerBindings.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ServerBindings.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_ServerBindings.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_ServerBindings.prototype.withBindings = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withBindings__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_ServerBindings.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ServerBindings.prototype, "bindings", {
  "get": (function() {
    return this.$$js$exported$prop$bindings__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ServerBindings.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_ServerBindings(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_ServerBindings) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.ServerBindings"))
}
function $isArrayOf_Lamf_client_model_domain_ServerBindings(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_ServerBindings)))
}
function $asArrayOf_Lamf_client_model_domain_ServerBindings(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_ServerBindings(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.ServerBindings;", depth))
}
var $d_Lamf_client_model_domain_ServerBindings = new $TypeData().initClass({
  Lamf_client_model_domain_ServerBindings: 0
}, false, "amf.client.model.domain.ServerBindings", {
  Lamf_client_model_domain_ServerBindings: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  Lamf_client_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_ServerBindings.prototype.$classData = $d_Lamf_client_model_domain_ServerBindings;
/** @constructor */
function $c_Lamf_core_model_document_Module() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.amf$core$model$document$BaseUnit$$run$1 = null;
  this.raw$1 = null;
  this.platform$1 = null;
  this.id$1 = null
}
$c_Lamf_core_model_document_Module.prototype = new $h_O();
$c_Lamf_core_model_document_Module.prototype.constructor = $c_Lamf_core_model_document_Module;
/** @constructor */
function $h_Lamf_core_model_document_Module() {
  /*<skip>*/
}
$h_Lamf_core_model_document_Module.prototype = $c_Lamf_core_model_document_Module.prototype;
$c_Lamf_core_model_document_Module.prototype.productPrefix__T = (function() {
  return "Module"
});
$c_Lamf_core_model_document_Module.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_core_model_document_Module.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_model_document_Module.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_core_model_document_Module.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_model_document_Module)) {
    var Module$1 = $as_Lamf_core_model_document_Module(x$1);
    var x = this.fields$1;
    var x$2 = Module$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = Module$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_model_document_Module.prototype.raw$und$eq__s_Option__V = (function(x$1) {
  this.raw$1 = x$1
});
$c_Lamf_core_model_document_Module.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_model_document_Module.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_core_model_document_Module.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_core_model_document_Module.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_core_metamodel_document_ModuleModel$()
});
$c_Lamf_core_model_document_Module.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_model_document_Module.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_core_model_document_Module.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_core_model_document_Module.prototype.references__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_ModuleModel$().References$1))
});
$c_Lamf_core_model_document_Module.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_core_model_document_Module.prototype.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit = (function(selector, transformation, errorHandler) {
  return $f_Lamf_core_model_document_BaseUnit__transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(this, selector, transformation, errorHandler)
});
$c_Lamf_core_model_document_Module.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this)
});
$c_Lamf_core_model_document_Module.prototype.amf$core$model$document$BaseUnit$$run__s_Option = (function() {
  return this.amf$core$model$document$BaseUnit$$run$1
});
$c_Lamf_core_model_document_Module.prototype.declares__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_ModuleModel$().Declares$1))
});
$c_Lamf_core_model_document_Module.prototype.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V = (function(x$1) {
  this.amf$core$model$document$BaseUnit$$run$1 = x$1
});
$c_Lamf_core_model_document_Module.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_core_model_document_Module.prototype.raw__s_Option = (function() {
  return this.raw$1
});
$c_Lamf_core_model_document_Module.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_model_document_Module.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_model_document_Module.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_core_model_document_Module.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_core_model_document_Module.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  $f_Lamf_core_model_document_BaseUnit__$$init$__V(this);
  return this
});
function $as_Lamf_core_model_document_Module(obj) {
  return (((obj instanceof $c_Lamf_core_model_document_Module) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.document.Module"))
}
function $isArrayOf_Lamf_core_model_document_Module(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_document_Module)))
}
function $asArrayOf_Lamf_core_model_document_Module(obj, depth) {
  return (($isArrayOf_Lamf_core_model_document_Module(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.document.Module;", depth))
}
var $d_Lamf_core_model_document_Module = new $TypeData().initClass({
  Lamf_core_model_document_Module: 0
}, false, "amf.core.model.document.Module", {
  Lamf_core_model_document_Module: 1,
  O: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_model_document_DeclaresModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_document_Module.prototype.$classData = $d_Lamf_core_model_document_Module;
/** @constructor */
function $c_Lamf_core_parser_Fields$BoolFieldImpl() {
  $c_O.call(this);
  this.option$1 = null;
  this.annotations$1 = null;
  this.field$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_core_parser_Fields$BoolFieldImpl.prototype = new $h_O();
$c_Lamf_core_parser_Fields$BoolFieldImpl.prototype.constructor = $c_Lamf_core_parser_Fields$BoolFieldImpl;
/** @constructor */
function $h_Lamf_core_parser_Fields$BoolFieldImpl() {
  /*<skip>*/
}
$h_Lamf_core_parser_Fields$BoolFieldImpl.prototype = $c_Lamf_core_parser_Fields$BoolFieldImpl.prototype;
$c_Lamf_core_parser_Fields$BoolFieldImpl.prototype.productPrefix__T = (function() {
  return "BoolFieldImpl"
});
$c_Lamf_core_parser_Fields$BoolFieldImpl.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_core_parser_Fields$BoolFieldImpl.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_core_parser_Fields$BoolFieldImpl) && ($as_Lamf_core_parser_Fields$BoolFieldImpl(x$1).$$outer$1 === this.$$outer$1))) {
    var BoolFieldImpl$1 = $as_Lamf_core_parser_Fields$BoolFieldImpl(x$1);
    var x = this.option$1;
    var x$2 = BoolFieldImpl$1.option$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.annotations$1;
      var x$4 = BoolFieldImpl$1.annotations$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.field$1;
      var x$6 = BoolFieldImpl$1.field$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_parser_Fields$BoolFieldImpl.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.option$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    case 2: {
      return this.field$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_parser_Fields$BoolFieldImpl.prototype.toString__T = (function() {
  return $f_Lamf_core_model_ValueField__toString__T(this)
});
$c_Lamf_core_parser_Fields$BoolFieldImpl.prototype.init___Lamf_core_parser_Fields__Lamf_core_model_domain_AmfScalar__Lamf_core_metamodel_Field = (function($$outer, s, f) {
  var this$1 = $m_s_Option$().apply__O__s_Option(s.value$1);
  if (this$1.isEmpty__Z()) {
    var jsx$1 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var jsx$1 = new $c_s_Some().init___O($uZ(arg1))
  };
  $c_Lamf_core_parser_Fields$BoolFieldImpl.prototype.init___Lamf_core_parser_Fields__s_Option__Lamf_core_parser_Annotations__Lamf_core_metamodel_Field.call(this, $$outer, jsx$1, s.annotations$1, f);
  return this
});
$c_Lamf_core_parser_Fields$BoolFieldImpl.prototype.option__s_Option = (function() {
  return this.option$1
});
$c_Lamf_core_parser_Fields$BoolFieldImpl.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_parser_Fields$BoolFieldImpl.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_parser_Fields$BoolFieldImpl.prototype.init___Lamf_core_parser_Fields__s_Option__Lamf_core_parser_Annotations__Lamf_core_metamodel_Field = (function($$outer, option, annotations, field) {
  this.option$1 = option;
  this.annotations$1 = annotations;
  this.field$1 = field;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
function $as_Lamf_core_parser_Fields$BoolFieldImpl(obj) {
  return (((obj instanceof $c_Lamf_core_parser_Fields$BoolFieldImpl) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.Fields$BoolFieldImpl"))
}
function $isArrayOf_Lamf_core_parser_Fields$BoolFieldImpl(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_Fields$BoolFieldImpl)))
}
function $asArrayOf_Lamf_core_parser_Fields$BoolFieldImpl(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_Fields$BoolFieldImpl(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.Fields$BoolFieldImpl;", depth))
}
var $d_Lamf_core_parser_Fields$BoolFieldImpl = new $TypeData().initClass({
  Lamf_core_parser_Fields$BoolFieldImpl: 0
}, false, "amf.core.parser.Fields$BoolFieldImpl", {
  Lamf_core_parser_Fields$BoolFieldImpl: 1,
  O: 1,
  Lamf_core_model_BoolField: 1,
  Lamf_core_model_BaseAnyValField: 1,
  Lamf_core_model_BaseField: 1,
  Lamf_core_model_Annotable: 1,
  Lamf_core_model_ValueField: 1,
  Lamf_core_parser_Fields$FieldRemover: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_Fields$BoolFieldImpl.prototype.$classData = $d_Lamf_core_parser_Fields$BoolFieldImpl;
/** @constructor */
function $c_Lamf_core_parser_Fields$DoubleFieldImpl() {
  $c_O.call(this);
  this.option$1 = null;
  this.annotations$1 = null;
  this.field$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_core_parser_Fields$DoubleFieldImpl.prototype = new $h_O();
$c_Lamf_core_parser_Fields$DoubleFieldImpl.prototype.constructor = $c_Lamf_core_parser_Fields$DoubleFieldImpl;
/** @constructor */
function $h_Lamf_core_parser_Fields$DoubleFieldImpl() {
  /*<skip>*/
}
$h_Lamf_core_parser_Fields$DoubleFieldImpl.prototype = $c_Lamf_core_parser_Fields$DoubleFieldImpl.prototype;
$c_Lamf_core_parser_Fields$DoubleFieldImpl.prototype.productPrefix__T = (function() {
  return "DoubleFieldImpl"
});
$c_Lamf_core_parser_Fields$DoubleFieldImpl.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_core_parser_Fields$DoubleFieldImpl.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_core_parser_Fields$DoubleFieldImpl) && ($as_Lamf_core_parser_Fields$DoubleFieldImpl(x$1).$$outer$1 === this.$$outer$1))) {
    var DoubleFieldImpl$1 = $as_Lamf_core_parser_Fields$DoubleFieldImpl(x$1);
    var x = this.option$1;
    var x$2 = DoubleFieldImpl$1.option$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.annotations$1;
      var x$4 = DoubleFieldImpl$1.annotations$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.field$1;
      var x$6 = DoubleFieldImpl$1.field$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_parser_Fields$DoubleFieldImpl.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.option$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    case 2: {
      return this.field$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_parser_Fields$DoubleFieldImpl.prototype.toString__T = (function() {
  return $f_Lamf_core_model_ValueField__toString__T(this)
});
$c_Lamf_core_parser_Fields$DoubleFieldImpl.prototype.init___Lamf_core_parser_Fields__Lamf_core_model_domain_AmfScalar__Lamf_core_metamodel_Field = (function($$outer, s, f) {
  var this$1 = s.toNumberOption__s_Option();
  if (this$1.isEmpty__Z()) {
    var jsx$1 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$10 = $as_jl_Number(arg1);
    var jsx$1 = new $c_s_Some().init___O($uD(x$10))
  };
  $c_Lamf_core_parser_Fields$DoubleFieldImpl.prototype.init___Lamf_core_parser_Fields__s_Option__Lamf_core_parser_Annotations__Lamf_core_metamodel_Field.call(this, $$outer, jsx$1, s.annotations$1, f);
  return this
});
$c_Lamf_core_parser_Fields$DoubleFieldImpl.prototype.option__s_Option = (function() {
  return this.option$1
});
$c_Lamf_core_parser_Fields$DoubleFieldImpl.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_parser_Fields$DoubleFieldImpl.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_parser_Fields$DoubleFieldImpl.prototype.init___Lamf_core_parser_Fields__s_Option__Lamf_core_parser_Annotations__Lamf_core_metamodel_Field = (function($$outer, option, annotations, field) {
  this.option$1 = option;
  this.annotations$1 = annotations;
  this.field$1 = field;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
function $as_Lamf_core_parser_Fields$DoubleFieldImpl(obj) {
  return (((obj instanceof $c_Lamf_core_parser_Fields$DoubleFieldImpl) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.Fields$DoubleFieldImpl"))
}
function $isArrayOf_Lamf_core_parser_Fields$DoubleFieldImpl(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_Fields$DoubleFieldImpl)))
}
function $asArrayOf_Lamf_core_parser_Fields$DoubleFieldImpl(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_Fields$DoubleFieldImpl(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.Fields$DoubleFieldImpl;", depth))
}
var $d_Lamf_core_parser_Fields$DoubleFieldImpl = new $TypeData().initClass({
  Lamf_core_parser_Fields$DoubleFieldImpl: 0
}, false, "amf.core.parser.Fields$DoubleFieldImpl", {
  Lamf_core_parser_Fields$DoubleFieldImpl: 1,
  O: 1,
  Lamf_core_model_DoubleField: 1,
  Lamf_core_model_BaseAnyValField: 1,
  Lamf_core_model_BaseField: 1,
  Lamf_core_model_Annotable: 1,
  Lamf_core_model_ValueField: 1,
  Lamf_core_parser_Fields$FieldRemover: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_Fields$DoubleFieldImpl.prototype.$classData = $d_Lamf_core_parser_Fields$DoubleFieldImpl;
/** @constructor */
function $c_Lamf_core_parser_Fields$IntFieldImpl() {
  $c_O.call(this);
  this.option$1 = null;
  this.annotations$1 = null;
  this.field$1 = null;
  this.$$outer$1 = null
}
$c_Lamf_core_parser_Fields$IntFieldImpl.prototype = new $h_O();
$c_Lamf_core_parser_Fields$IntFieldImpl.prototype.constructor = $c_Lamf_core_parser_Fields$IntFieldImpl;
/** @constructor */
function $h_Lamf_core_parser_Fields$IntFieldImpl() {
  /*<skip>*/
}
$h_Lamf_core_parser_Fields$IntFieldImpl.prototype = $c_Lamf_core_parser_Fields$IntFieldImpl.prototype;
$c_Lamf_core_parser_Fields$IntFieldImpl.prototype.productPrefix__T = (function() {
  return "IntFieldImpl"
});
$c_Lamf_core_parser_Fields$IntFieldImpl.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_core_parser_Fields$IntFieldImpl.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_core_parser_Fields$IntFieldImpl) && ($as_Lamf_core_parser_Fields$IntFieldImpl(x$1).$$outer$1 === this.$$outer$1))) {
    var IntFieldImpl$1 = $as_Lamf_core_parser_Fields$IntFieldImpl(x$1);
    var x = this.option$1;
    var x$2 = IntFieldImpl$1.option$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.annotations$1;
      var x$4 = IntFieldImpl$1.annotations$1;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.field$1;
      var x$6 = IntFieldImpl$1.field$1;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_parser_Fields$IntFieldImpl.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.option$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    case 2: {
      return this.field$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_parser_Fields$IntFieldImpl.prototype.toString__T = (function() {
  return $f_Lamf_core_model_ValueField__toString__T(this)
});
$c_Lamf_core_parser_Fields$IntFieldImpl.prototype.init___Lamf_core_parser_Fields__Lamf_core_model_domain_AmfScalar__Lamf_core_metamodel_Field = (function($$outer, s, f) {
  var this$1 = $m_s_Option$().apply__O__s_Option(s.value$1);
  if (this$1.isEmpty__Z()) {
    var jsx$1 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var jsx$1 = new $c_s_Some().init___O($uI(arg1))
  };
  $c_Lamf_core_parser_Fields$IntFieldImpl.prototype.init___Lamf_core_parser_Fields__s_Option__Lamf_core_parser_Annotations__Lamf_core_metamodel_Field.call(this, $$outer, jsx$1, s.annotations$1, f);
  return this
});
$c_Lamf_core_parser_Fields$IntFieldImpl.prototype.option__s_Option = (function() {
  return this.option$1
});
$c_Lamf_core_parser_Fields$IntFieldImpl.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_parser_Fields$IntFieldImpl.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_parser_Fields$IntFieldImpl.prototype.init___Lamf_core_parser_Fields__s_Option__Lamf_core_parser_Annotations__Lamf_core_metamodel_Field = (function($$outer, option, annotations, field) {
  this.option$1 = option;
  this.annotations$1 = annotations;
  this.field$1 = field;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
function $as_Lamf_core_parser_Fields$IntFieldImpl(obj) {
  return (((obj instanceof $c_Lamf_core_parser_Fields$IntFieldImpl) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.parser.Fields$IntFieldImpl"))
}
function $isArrayOf_Lamf_core_parser_Fields$IntFieldImpl(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_parser_Fields$IntFieldImpl)))
}
function $asArrayOf_Lamf_core_parser_Fields$IntFieldImpl(obj, depth) {
  return (($isArrayOf_Lamf_core_parser_Fields$IntFieldImpl(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.parser.Fields$IntFieldImpl;", depth))
}
var $d_Lamf_core_parser_Fields$IntFieldImpl = new $TypeData().initClass({
  Lamf_core_parser_Fields$IntFieldImpl: 0
}, false, "amf.core.parser.Fields$IntFieldImpl", {
  Lamf_core_parser_Fields$IntFieldImpl: 1,
  O: 1,
  Lamf_core_model_IntField: 1,
  Lamf_core_model_BaseAnyValField: 1,
  Lamf_core_model_BaseField: 1,
  Lamf_core_model_Annotable: 1,
  Lamf_core_model_ValueField: 1,
  Lamf_core_parser_Fields$FieldRemover: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_parser_Fields$IntFieldImpl.prototype.$classData = $d_Lamf_core_parser_Fields$IntFieldImpl;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter() {
  $c_O.call(this);
  this.dialect$1 = null;
  this.nodeMappable$1 = null;
  this.ordering$1 = null;
  this.aliases$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter.prototype.productPrefix__T = (function() {
  return "NodeMappingEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter.prototype.isFragment__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_vocabularies_model_document_Dialect__Z = (function(elem, dialect) {
  return $as_sc_Seq(dialect.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().References$1)).exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, elem$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_document_BaseUnit(x0$1$2);
      if ((x0$1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectFragment)) {
        var x2 = $as_Lamf_plugins_document_vocabularies_model_document_DialectFragment(x0$1);
        return ($as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x2.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Encodes$1)).id$1 === elem$1.id__T())
      } else {
        return false
      }
    })
  })(this, elem)))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter.prototype.emitUnioNode__Lorg_yaml_model_YDocument$EntryBuilder__Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping__V = (function(b, unionNodeMapping) {
  $m_Lorg_yaml_model_YNode$();
  var this$1 = $as_Lamf_core_model_StrField(unionNodeMapping.fields$1.field__Lamf_core_metamodel_Field__O(unionNodeMapping.Name$1));
  var this$2 = this$1.option$1;
  var str = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$9 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var emitters = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var nodes = $as_sc_Seq(unionNodeMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1));
  if (nodes.nonEmpty__Z()) {
    var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1;
    var pos = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, unionNodeMapping, field);
    var jsx$3 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(nodeId$2) {
        var nodeId = $as_Lamf_core_model_StrField(nodeId$2);
        var this$5 = nodeId.option$1;
        var id = $as_T((this$5.isEmpty__Z() ? null : this$5.get__O()));
        var x1 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_AliasesConsumer__aliasFor__T__s_Option($this, id);
        if ((x1 instanceof $c_s_Some)) {
          var x2 = $as_s_Some(x1);
          var nodeMappingAlias = $as_T(x2.value$2);
          return new $c_s_Some().init___O(nodeMappingAlias)
        } else {
          return $m_s_None$()
        }
      })
    })(this));
    var this$6 = $m_sc_Seq$();
    var jsx$2 = $as_sc_TraversableLike(nodes.map__F1__scg_CanBuildFrom__O(jsx$3, this$6.ReusableCBFInstance$2));
    var jsx$1 = new $c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anonfun$5().init___Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter(this);
    var this$7 = $m_sc_Seq$();
    var targets = $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
    var jsx$6 = emitters;
    var jsx$5 = $m_sc_Seq$();
    var array = [new $c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter$$anon$5().init___Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter__sc_Seq__Lamf_core_parser_Position(this, targets, pos)];
    var jsx$4 = jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$10 = $m_sc_Seq$();
    emitters = $as_sc_Seq(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$10.ReusableCBFInstance$2));
    var jsx$8 = emitters;
    var jsx$7 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter__emitDiscriminator__Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__sc_Seq(this, unionNodeMapping);
    var this$11 = $m_sc_Seq$();
    emitters = $as_sc_Seq(jsx$8.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$7, this$11.ReusableCBFInstance$2));
    this.ordering$1.sorted__sc_Seq__sc_Seq(emitters).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, b$2) {
      return (function(x$35$2) {
        var x$35 = $as_Lamf_core_emitter_EntryEmitter(x$35$2);
        x$35.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$2)
      })
    })(this, b$1)))
  };
  jsx$9.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$14 = v.builder$1;
  var array$1 = [key];
  if ((this$14.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array$1.length);
  var newSize = ((this$14.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$14, newSize);
  var len$1 = this$14.size0$6;
  var src = this$14.array$6;
  var dest = this$14.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs = this$14.array$6;
  var len$2 = xs.u.length;
  var i = 0;
  var j = 0;
  var x = $uI(array$1.length);
  var x$1 = ((x < len$2) ? x : len$2);
  var that = xs.u.length;
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    var jsx$10 = j;
    var index = i;
    xs.set(jsx$10, array$1[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$14.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter.prototype.emitSingleNode__Lorg_yaml_model_YDocument$EntryBuilder__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__V = (function(b, nodeMapping) {
  $m_Lorg_yaml_model_YNode$();
  var this$1 = $as_Lamf_core_model_StrField(nodeMapping.fields$1.field__Lamf_core_metamodel_Field__O(nodeMapping.Name$1));
  var this$2 = this$1.option$1;
  var str = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$4 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var this$5 = $as_Lamf_core_model_StrField(nodeMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().NodeTypeMapping$1));
  var this$6 = this$5.option$1;
  var id = $as_T((this$6.isEmpty__Z() ? null : this$6.get__O()));
  var x1 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_AliasesConsumer__aliasFor__T__s_Option(this, id);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var classTermAlias = $as_T(x2.value$2);
    new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("classTerm", classTermAlias, $m_Lorg_yaml_model_YType$().Str$1, $m_Lamf_core_parser_Position$ZERO$()).emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$1)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      $as_Lamf_core_model_StrField(nodeMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().NodeTypeMapping$1))
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  var x1$2 = $as_sc_Seq(nodeMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().PropertiesMapping$1));
  matchEnd4: {
    if ((x1$2 !== null)) {
      if (x1$2.nonEmpty__Z()) {
        $m_Lorg_yaml_model_YNode$();
        var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("mapping");
        var v$1 = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b$1.sourceName$2);
        var jsx$2 = v$1.builder$1;
        var sourceName$1 = v$1.sourceName$2;
        var b$2 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName$1);
        var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
          return (function(pm$2) {
            var pm = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(pm$2);
            return new $c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter().init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_core_emitter_SpecOrdering__sci_Map($this.dialect$1, pm, $this.ordering$1, $this.aliases$1)
          })
        })(this));
        var this$11 = $m_sc_Seq$();
        var propertiesEmitters = $as_sc_Seq(x1$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$11.ReusableCBFInstance$2));
        $m_Lamf_core_emitter_BaseEmitters_package$().traverse__sc_Seq__Lorg_yaml_model_YDocument$EntryBuilder__V(this.ordering$1.sorted__sc_Seq__sc_Seq(propertiesEmitters), b$2);
        jsx$2.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$2.builder$1, sourceName$1), $m_Lorg_yaml_model_YType$().Map$1));
        var this$14 = v$1.builder$1;
        var array = [key$1];
        if ((this$14.size0$6 < 0)) {
          throw new $c_jl_IndexOutOfBoundsException().init___T("0")
        };
        var len = $uI(array.length);
        var newSize = ((this$14.size0$6 + len) | 0);
        $f_scm_ResizableArray__ensureSize__I__V(this$14, newSize);
        var len$1 = this$14.size0$6;
        var src = this$14.array$6;
        var dest = this$14.array$6;
        $systemArraycopy(src, 0, dest, len, len$1);
        var xs = this$14.array$6;
        var len$2 = xs.u.length;
        var i = 0;
        var j = 0;
        var x$1 = $uI(array.length);
        var x$2 = ((x$1 < len$2) ? x$1 : len$2);
        var that = xs.u.length;
        var end = ((x$2 < that) ? x$2 : that);
        while ((i < end)) {
          var jsx$3 = j;
          var index = i;
          xs.set(jsx$3, array[index]);
          i = ((1 + i) | 0);
          j = ((1 + j) | 0)
        };
        this$14.size0$6 = newSize;
        b$1.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v$1.builder$1));
        break matchEnd4
      }
    }
  };
  var x1$3 = $as_sc_Seq(nodeMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field())).headOption__s_Option();
  matchEnd5$2: {
    if ((x1$3 instanceof $c_s_Some)) {
      var x2$3 = $as_s_Some(x1$3);
      var link = $as_Lamf_core_model_domain_DomainElement(x2$3.value$2);
      if ($is_Lamf_core_model_domain_Linkable(link)) {
        $m_Lorg_yaml_model_YNode$();
        var key$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("extends");
        $m_Lorg_yaml_model_YNode$();
        var this$26 = $as_Lamf_core_model_domain_Linkable(link);
        var this$27 = $as_Lamf_core_model_StrField(this$26.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1));
        var this$28 = this$27.option$1;
        var str$1 = $as_T((this$28.isEmpty__Z() ? null : this$28.get__O()));
        var value = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
        b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$2, value);
        break matchEnd5$2
      }
    }
  };
  var this$30 = $as_Lamf_core_model_StrField(nodeMapping.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$().IdTemplate$1)).option$1;
  if ((!this$30.isEmpty__Z())) {
    var arg1 = this$30.get__O();
    var idTemplate = $as_T(arg1);
    $m_Lorg_yaml_model_YNode$();
    var key$3 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("idTemplate");
    $m_Lorg_yaml_model_YNode$();
    var value$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(idTemplate);
    b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$3, value$1)
  };
  var this$33 = $f_Lamf_plugins_document_vocabularies_model_domain_MergeableMapping__mergePolicy__Lamf_core_model_StrField(nodeMapping).option$1;
  if ((!this$33.isEmpty__Z())) {
    var arg1$1 = this$33.get__O();
    var policy = $as_T(arg1$1);
    $m_Lorg_yaml_model_YNode$();
    var key$4 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("patch");
    $m_Lorg_yaml_model_YNode$();
    var value$2 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(policy);
    b$1.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$4, value$2)
  };
  jsx$4.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$38 = v.builder$1;
  var array$1 = [key];
  if ((this$38.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len$3 = $uI(array$1.length);
  var newSize$1 = ((this$38.size0$6 + len$3) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$38, newSize$1);
  var len$4 = this$38.size0$6;
  var src$1 = this$38.array$6;
  var dest$1 = this$38.array$6;
  $systemArraycopy(src$1, 0, dest$1, len$3, len$4);
  var xs$1 = this$38.array$6;
  var len$5 = xs$1.u.length;
  var i$1 = 0;
  var j$1 = 0;
  var x$3 = $uI(array$1.length);
  var x$4 = ((x$3 < len$5) ? x$3 : len$5);
  var that$1 = xs$1.u.length;
  var end$1 = ((x$4 < that$1) ? x$4 : that$1);
  while ((i$1 < end$1)) {
    var jsx$5 = j$1;
    var index$1 = i$1;
    xs$1.set(jsx$5, array$1[index$1]);
    i$1 = ((1 + i$1) | 0);
    j$1 = ((1 + j$1) | 0)
  };
  this$38.size0$6 = newSize$1;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter)) {
    var NodeMappingEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter(x$1);
    var x = this.dialect$1;
    var x$2 = NodeMappingEmitter$1.dialect$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.nodeMappable$1;
      var x$4 = NodeMappingEmitter$1.nodeMappable$1;
      var jsx$2 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.ordering$1;
      var x$6 = NodeMappingEmitter$1.ordering$1;
      var jsx$1 = (x$5 === x$6)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.aliases$1;
      var x$8 = NodeMappingEmitter$1.aliases$1;
      return ((x$7 === null) ? (x$8 === null) : $f_sc_GenMapLike__equals__O__Z(x$7, x$8))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.dialect$1;
      break
    }
    case 1: {
      return this.nodeMappable$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.aliases$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter.prototype.aliases__sci_Map = (function() {
  return this.aliases$1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter.prototype.init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_plugins_document_vocabularies_model_domain_NodeMappable__Lamf_core_emitter_SpecOrdering__sci_Map = (function(dialect, nodeMappable, ordering, aliases) {
  this.dialect$1 = dialect;
  this.nodeMappable$1 = nodeMappable;
  this.ordering$1 = ordering;
  this.aliases$1 = aliases;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter.prototype.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect = (function() {
  return this.dialect$1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  var this$1 = this.nodeMappable$1;
  if ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1).isDefined__Z()) {
    var this$2 = this.nodeMappable$1;
    if (this.isFragment__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_vocabularies_model_document_Dialect__Z($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$2).get__O()), this.dialect$1)) {
      $m_Lorg_yaml_model_YNode$();
      var this$3 = this.nodeMappable$1;
      var this$4 = $as_Lamf_core_model_StrField(this$3.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(this$3.Name__Lamf_core_metamodel_Field()));
      var this$5 = this$4.option$1;
      var str = $as_T((this$5.isEmpty__Z() ? null : this$5.get__O()));
      var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
      var jsx$1 = $m_Lorg_yaml_model_YNode$();
      var this$7 = this.nodeMappable$1;
      var this$8 = $as_Lamf_core_model_StrField(this$7.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1));
      var this$9 = this$8.option$1;
      var value = jsx$1.include__T__T__Lorg_yaml_model_YNode$MutRef($as_T((this$9.isEmpty__Z() ? null : this$9.get__O())), ($m_Lorg_yaml_model_YNode$(), ""));
      b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key, value)
    } else {
      $m_Lorg_yaml_model_YNode$();
      var this$10 = this.nodeMappable$1;
      var this$11 = $as_Lamf_core_model_StrField(this$10.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(this$10.Name__Lamf_core_metamodel_Field()));
      var this$12 = this$11.option$1;
      var str$1 = $as_T((this$12.isEmpty__Z() ? null : this$12.get__O()));
      var key$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$1);
      $m_Lorg_yaml_model_YNode$();
      var this$14 = this.nodeMappable$1;
      var this$15 = $as_Lamf_core_model_StrField(this$14.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_LinkableElementModel$().Label$1));
      var this$16 = this$15.option$1;
      var str$2 = $as_T((this$16.isEmpty__Z() ? null : this$16.get__O()));
      var value$1 = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str$2);
      b.addEntry__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__V(key$1, value$1)
    }
  } else {
    var x1 = this.nodeMappable$1;
    if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping)) {
      var x2 = $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(x1);
      this.emitSingleNode__Lorg_yaml_model_YDocument$EntryBuilder__Lamf_plugins_document_vocabularies_model_domain_NodeMapping__V(b, x2)
    } else if ((x1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping)) {
      var x3 = $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(x1);
      this.emitUnioNode__Lorg_yaml_model_YDocument$EntryBuilder__Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping__V(b, x3)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.nodeMappable$1.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$36 = $as_Lamf_core_annotations_LexicalInformation(arg1);
    var this$2 = new $c_s_Some().init___O(x$36.range__Lamf_core_parser_Range().start$1)
  };
  return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
});
function $as_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.dialects.NodeMappingEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.dialects.NodeMappingEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.NodeMappingEmitter", {
  Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter: 1,
  Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor: 1,
  Lamf_plugins_document_vocabularies_emitters_dialects_AliasesConsumer: 1,
  Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_NodeMappingEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter() {
  $c_O.call(this);
  this.dialect$1 = null;
  this.propertyMapping$1 = null;
  this.ordering$1 = null;
  this.aliases$1 = null
}
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter.prototype.constructor = $c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter.prototype = $c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter.prototype;
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter.prototype.productPrefix__T = (function() {
  return "PropertyMappingEmitter"
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter)) {
    var PropertyMappingEmitter$1 = $as_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter(x$1);
    var x = this.dialect$1;
    var x$2 = PropertyMappingEmitter$1.dialect$1;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.propertyMapping$1;
      var x$4 = PropertyMappingEmitter$1.propertyMapping$1;
      var jsx$2 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$5 = this.ordering$1;
      var x$6 = PropertyMappingEmitter$1.ordering$1;
      var jsx$1 = (x$5 === x$6)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$7 = this.aliases$1;
      var x$8 = PropertyMappingEmitter$1.aliases$1;
      return ((x$7 === null) ? (x$8 === null) : $f_sc_GenMapLike__equals__O__Z(x$7, x$8))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.dialect$1;
      break
    }
    case 1: {
      return this.propertyMapping$1;
      break
    }
    case 2: {
      return this.ordering$1;
      break
    }
    case 3: {
      return this.aliases$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter.prototype.aliases__sci_Map = (function() {
  return this.aliases$1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter.prototype.dialect__Lamf_plugins_document_vocabularies_model_document_Dialect = (function() {
  return this.dialect$1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter.prototype.emit__Lorg_yaml_model_YDocument$EntryBuilder__V = (function(b) {
  $m_Lorg_yaml_model_YNode$();
  var this$1 = this.propertyMapping$1;
  var this$2 = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
  var this$3 = this$2.option$1;
  var str = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
  var key = $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode(str);
  var v = new $c_Lorg_yaml_model_YDocument$PartBuilder().init___T(b.sourceName$2);
  var jsx$82 = v.builder$1;
  var sourceName = v.sourceName$2;
  var b$1 = new $c_Lorg_yaml_model_YDocument$EntryBuilder().init___T(sourceName);
  var elem = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var elem$1 = null;
  elem$1 = elem;
  var this$7 = this.propertyMapping$1;
  var this$8 = $as_Lamf_core_model_StrField(this$7.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1));
  var this$9 = this$8.option$1;
  var id = $as_T((this$9.isEmpty__Z() ? null : this$9.get__O()));
  var x1 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_AliasesConsumer__aliasFor__T__s_Option(this, id);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var propertyTermAlias = $as_T(x2.value$2);
    var element = this.propertyMapping$1;
    var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1;
    var pos = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, element, field);
    var jsx$3 = $as_sc_Seq(elem$1);
    var jsx$2 = $m_sc_Seq$();
    var array = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("propertyTerm", propertyTermAlias, $m_Lorg_yaml_model_YType$().Str$1, pos)];
    var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
    var this$12 = $m_sc_Seq$();
    elem$1 = $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$12.ReusableCBFInstance$2))
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    }
  };
  var this$13 = this.propertyMapping$1;
  var this$14 = $as_Lamf_core_model_StrField(this$13.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1)).option$1;
  if ((!this$14.isEmpty__Z())) {
    var arg1 = this$14.get__O();
    var x0$1 = $as_T(arg1);
    var this$15 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
    if ((x0$1 === new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$15, "guid").iri__T())) {
      var element$1 = this.propertyMapping$1;
      var field$1 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1;
      var pos$1 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, element$1, field$1);
      var jsx$6 = $as_sc_Seq(elem$1);
      var jsx$5 = $m_sc_Seq$();
      var array$1 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("range", "guid", $m_Lorg_yaml_model_YType$().Str$1, pos$1)];
      var jsx$4 = jsx$5.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
      var this$19 = $m_sc_Seq$();
      elem$1 = $as_sc_Seq(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$19.ReusableCBFInstance$2))
    } else if ($m_sjsr_RuntimeString$().endsWith__T__T__Z(x0$1, "anyURI")) {
      var element$2 = this.propertyMapping$1;
      var field$2 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1;
      var pos$2 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, element$2, field$2);
      var jsx$9 = $as_sc_Seq(elem$1);
      var jsx$8 = $m_sc_Seq$();
      var array$2 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("range", "uri", $m_Lorg_yaml_model_YType$().Str$1, pos$2)];
      var jsx$7 = jsx$8.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2));
      var this$22 = $m_sc_Seq$();
      elem$1 = $as_sc_Seq(jsx$9.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$7, this$22.ReusableCBFInstance$2))
    } else if ($m_sjsr_RuntimeString$().endsWith__T__T__Z(x0$1, "link")) {
      var element$3 = this.propertyMapping$1;
      var field$3 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1;
      var pos$3 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, element$3, field$3);
      var jsx$12 = $as_sc_Seq(elem$1);
      var jsx$11 = $m_sc_Seq$();
      var array$3 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("range", "link", $m_Lorg_yaml_model_YType$().Str$1, pos$3)];
      var jsx$10 = jsx$11.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$3));
      var this$25 = $m_sc_Seq$();
      elem$1 = $as_sc_Seq(jsx$12.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$10, this$25.ReusableCBFInstance$2))
    } else if ($m_sjsr_RuntimeString$().endsWith__T__T__Z(x0$1, "anyType")) {
      var element$4 = this.propertyMapping$1;
      var field$4 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1;
      var pos$4 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, element$4, field$4);
      var jsx$15 = $as_sc_Seq(elem$1);
      var jsx$14 = $m_sc_Seq$();
      var array$4 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("range", "any", $m_Lorg_yaml_model_YType$().Str$1, pos$4)];
      var jsx$13 = jsx$14.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$4));
      var this$28 = $m_sc_Seq$();
      elem$1 = $as_sc_Seq(jsx$15.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$13, this$28.ReusableCBFInstance$2))
    } else if ($m_sjsr_RuntimeString$().endsWith__T__T__Z(x0$1, "number")) {
      var element$5 = this.propertyMapping$1;
      var field$5 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1;
      var pos$5 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, element$5, field$5);
      var jsx$18 = $as_sc_Seq(elem$1);
      var jsx$17 = $m_sc_Seq$();
      var array$5 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("range", "number", $m_Lorg_yaml_model_YType$().Str$1, pos$5)];
      var jsx$16 = jsx$17.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$5));
      var this$31 = $m_sc_Seq$();
      elem$1 = $as_sc_Seq(jsx$18.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$16, this$31.ReusableCBFInstance$2))
    } else {
      var element$6 = this.propertyMapping$1;
      var field$6 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1;
      var pos$6 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, element$6, field$6);
      var jsx$21 = $as_sc_Seq(elem$1);
      var jsx$20 = $m_sc_Seq$();
      var regex = $m_Lamf_core_vocabulary_Namespace$().Xsd$1.base$1;
      var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(x0$1, regex, 0);
      var this$34 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
      var array$6 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("range", $as_T($f_sc_IndexedSeqOptimized__last__O(this$34)), $m_Lorg_yaml_model_YType$().Str$1, pos$6)];
      var jsx$19 = jsx$20.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$6));
      var this$37 = $m_sc_Seq$();
      elem$1 = $as_sc_Seq(jsx$21.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$19, this$37.ReusableCBFInstance$2))
    }
  };
  var this$38 = this.propertyMapping$1;
  var this$39 = $f_Lamf_plugins_document_vocabularies_model_domain_MergeableMapping__mergePolicy__Lamf_core_model_StrField(this$38).option$1;
  if ((!this$39.isEmpty__Z())) {
    var arg1$1 = this$39.get__O();
    var policy = $as_T(arg1$1);
    var element$7 = this.propertyMapping$1;
    var field$7 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MergePolicy$1;
    var pos$7 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, element$7, field$7);
    var jsx$24 = $as_sc_Seq(elem$1);
    var jsx$23 = $m_sc_Seq$();
    var array$7 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("patch", policy, $m_Lorg_yaml_model_YType$().Str$1, pos$7)];
    var jsx$22 = jsx$23.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$7));
    var this$42 = $m_sc_Seq$();
    elem$1 = $as_sc_Seq(jsx$24.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$22, this$42.ReusableCBFInstance$2))
  };
  var this$43 = this.propertyMapping$1;
  var nodes = $as_sc_Seq(this$43.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1));
  if (nodes.nonEmpty__Z()) {
    var element$8 = this.propertyMapping$1;
    var field$8 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().ObjectRange$1;
    var pos$2$1 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, element$8, field$8);
    var jsx$27 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
      return (function(nodeId$2) {
        var nodeId = $as_Lamf_core_model_StrField(nodeId$2);
        var this$44 = nodeId.option$1;
        var jsx$28 = $as_T((this$44.isEmpty__Z() ? null : this$44.get__O()));
        var this$45 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
        if ((jsx$28 === new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$45, "anyNode").iri__T())) {
          return new $c_s_Some().init___O("anyNode")
        } else {
          var this$47 = nodeId.option$1;
          var id$1 = $as_T((this$47.isEmpty__Z() ? null : this$47.get__O()));
          var x1$1 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_AliasesConsumer__aliasFor__T__s_Option(this$3$1, id$1);
          if ((x1$1 instanceof $c_s_Some)) {
            var x2$1 = $as_s_Some(x1$1);
            var nodeMappingAlias = $as_T(x2$1.value$2);
            return new $c_s_Some().init___O(nodeMappingAlias)
          } else {
            return $m_s_None$()
          }
        }
      })
    })(this));
    var this$48 = $m_sc_Seq$();
    var jsx$26 = $as_sc_TraversableLike(nodes.map__F1__scg_CanBuildFrom__O(jsx$27, this$48.ReusableCBFInstance$2));
    var jsx$25 = new $c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anonfun$4().init___Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter(this);
    var this$49 = $m_sc_Seq$();
    var targets = $as_sc_Seq(jsx$26.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$25, this$49.ReusableCBFInstance$2));
    if ((targets.size__I() === 1)) {
      var jsx$31 = $as_sc_Seq(elem$1);
      var jsx$30 = $m_sc_Seq$();
      var array$8 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("range", $as_T(targets.head__O()), $m_Lorg_yaml_model_YType$().Str$1, pos$2$1)];
      var jsx$29 = jsx$30.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$8));
      var this$52 = $m_sc_Seq$();
      elem$1 = $as_sc_Seq(jsx$31.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$29, this$52.ReusableCBFInstance$2))
    } else if ((targets.size__I() > 1)) {
      var jsx$34 = $as_sc_Seq(elem$1);
      var jsx$33 = $m_sc_Seq$();
      var array$9 = [new $c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter$$anon$4().init___Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter__sc_Seq__Lamf_core_parser_Position(this, targets, pos$2$1)];
      var jsx$32 = jsx$33.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$9));
      var this$55 = $m_sc_Seq$();
      elem$1 = $as_sc_Seq(jsx$34.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$32, this$55.ReusableCBFInstance$2))
    }
  };
  var this$56 = this.propertyMapping$1;
  var this$57 = $as_Lamf_core_model_StrField(this$56.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapKeyProperty$1)).option$1;
  if (this$57.isEmpty__Z()) {
    var this$58 = this.propertyMapping$1;
    var this$59 = $as_Lamf_core_model_StrField(this$58.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermKeyProperty$1)).option$1;
    if ((!this$59.isEmpty__Z())) {
      var arg1$2 = this$59.get__O();
      var term = $as_T(arg1$2);
      var element$9 = this.propertyMapping$1;
      var field$9 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermKeyProperty$1;
      var pos$8 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, element$9, field$9);
      var x1$2 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_AliasesConsumer__aliasFor__T__s_Option(this, term);
      if ((x1$2 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$2);
        var propertyId = $as_T(x2$2.value$2);
        var jsx$37 = $as_sc_Seq(elem$1);
        var jsx$36 = $m_sc_Seq$();
        var array$10 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("mapTermKey", propertyId, $m_Lorg_yaml_model_YType$().Str$1, pos$8)];
        var jsx$35 = jsx$36.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$10));
        var this$62 = $m_sc_Seq$();
        elem$1 = $as_sc_Seq(jsx$37.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$35, this$62.ReusableCBFInstance$2))
      }
    }
  } else {
    var arg1$3 = this$57.get__O();
    var value = $as_T(arg1$3);
    var element$10 = this.propertyMapping$1;
    var field$10 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapKeyProperty$1;
    var pos$9 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, element$10, field$10);
    var jsx$40 = $as_sc_Seq(elem$1);
    var jsx$39 = $m_sc_Seq$();
    var array$11 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("mapKey", value, $m_Lorg_yaml_model_YType$().Str$1, pos$9)];
    var jsx$38 = jsx$39.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$11));
    var this$65 = $m_sc_Seq$();
    elem$1 = $as_sc_Seq(jsx$40.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$38, this$65.ReusableCBFInstance$2))
  };
  var this$66 = this.propertyMapping$1;
  var this$67 = $as_Lamf_core_model_StrField(this$66.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapValueProperty$1)).option$1;
  if (this$67.isEmpty__Z()) {
    var this$68 = this.propertyMapping$1;
    var this$69 = $as_Lamf_core_model_StrField(this$68.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermValueProperty$1)).option$1;
    if ((!this$69.isEmpty__Z())) {
      var arg1$4 = this$69.get__O();
      var term$1 = $as_T(arg1$4);
      var element$11 = this.propertyMapping$1;
      var field$11 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermValueProperty$1;
      var pos$10 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, element$11, field$11);
      var x1$3 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_AliasesConsumer__aliasFor__T__s_Option(this, term$1);
      if ((x1$3 instanceof $c_s_Some)) {
        var x2$3 = $as_s_Some(x1$3);
        var propertyId$1 = $as_T(x2$3.value$2);
        var jsx$43 = $as_sc_Seq(elem$1);
        var jsx$42 = $m_sc_Seq$();
        var array$12 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("mapTermValue", propertyId$1, $m_Lorg_yaml_model_YType$().Str$1, pos$10)];
        var jsx$41 = jsx$42.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$12));
        var this$72 = $m_sc_Seq$();
        elem$1 = $as_sc_Seq(jsx$43.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$41, this$72.ReusableCBFInstance$2))
      }
    }
  } else {
    var arg1$5 = this$67.get__O();
    var value$3 = $as_T(arg1$5);
    var element$12 = this.propertyMapping$1;
    var field$12 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapValueProperty$1;
    var pos$11 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, element$12, field$12);
    var jsx$46 = $as_sc_Seq(elem$1);
    var jsx$45 = $m_sc_Seq$();
    var array$13 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("mapValue", value$3, $m_Lorg_yaml_model_YType$().Str$1, pos$11)];
    var jsx$44 = jsx$45.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$13));
    var this$75 = $m_sc_Seq$();
    elem$1 = $as_sc_Seq(jsx$46.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$44, this$75.ReusableCBFInstance$2))
  };
  var this$76 = this.propertyMapping$1;
  var this$77 = $as_Lamf_core_model_BoolField(this$76.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Unique$1)).option$1;
  if ((!this$77.isEmpty__Z())) {
    var arg1$6 = this$77.get__O();
    var value$4 = $uZ(arg1$6);
    var element$13 = this.propertyMapping$1;
    var field$13 = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Unique$1;
    var pos$12 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, element$13, field$13);
    var jsx$49 = $as_sc_Seq(elem$1);
    var jsx$48 = $m_sc_Seq$();
    var array$14 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("unique", ("" + value$4), $m_Lorg_yaml_model_YType$().Bool$1, pos$12)];
    var jsx$47 = jsx$48.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$14));
    var this$81 = $m_sc_Seq$();
    elem$1 = $as_sc_Seq(jsx$49.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$47, this$81.ReusableCBFInstance$2))
  };
  var this$82 = this.propertyMapping$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MinCount$1);
  if ((!this$82.isEmpty__Z())) {
    var arg1$7 = this$82.get__O();
    var entry = $as_Lamf_core_parser_FieldEntry(arg1$7);
    var value$1 = $as_Lamf_core_model_domain_AmfScalar(entry.value$1.value$1).value$1;
    var element$14 = this.propertyMapping$1;
    var field$14 = entry.field$1;
    var pos$13 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, element$14, field$14);
    if ($m_sr_BoxesRunTime$().equals__O__O__Z(0, value$1)) {
      var jsx$52 = $as_sc_Seq(elem$1);
      var jsx$51 = $m_sc_Seq$();
      var array$15 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("mandatory", "false", $m_Lorg_yaml_model_YType$().Bool$1, pos$13)];
      var jsx$50 = jsx$51.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$15));
      var this$85 = $m_sc_Seq$();
      elem$1 = $as_sc_Seq(jsx$52.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$50, this$85.ReusableCBFInstance$2))
    } else if ($m_sr_BoxesRunTime$().equals__O__O__Z(1, value$1)) {
      var jsx$55 = $as_sc_Seq(elem$1);
      var jsx$54 = $m_sc_Seq$();
      var array$16 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("mandatory", "true", $m_Lorg_yaml_model_YType$().Bool$1, pos$13)];
      var jsx$53 = jsx$54.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$16));
      var this$88 = $m_sc_Seq$();
      elem$1 = $as_sc_Seq(jsx$55.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$53, this$88.ReusableCBFInstance$2))
    } else {
      throw new $c_s_MatchError().init___O(value$1)
    }
  };
  var this$89 = this.propertyMapping$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Pattern$1);
  if ((!this$89.isEmpty__Z())) {
    var arg1$8 = this$89.get__O();
    var entry$3 = $as_Lamf_core_parser_FieldEntry(arg1$8);
    var value$2 = $objectToString($as_Lamf_core_model_domain_AmfScalar(entry$3.value$1.value$1).value$1);
    var element$15 = this.propertyMapping$1;
    var field$15 = entry$3.field$1;
    var pos$14 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, element$15, field$15);
    var jsx$58 = $as_sc_Seq(elem$1);
    var jsx$57 = $m_sc_Seq$();
    var array$17 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("pattern", value$2, $m_Lorg_yaml_model_YType$().Str$1, pos$14)];
    var jsx$56 = jsx$57.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$17));
    var this$92 = $m_sc_Seq$();
    elem$1 = $as_sc_Seq(jsx$58.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$56, this$92.ReusableCBFInstance$2))
  };
  var this$93 = this.propertyMapping$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Minimum$1);
  if ((!this$93.isEmpty__Z())) {
    var arg1$9 = this$93.get__O();
    var entry$4 = $as_Lamf_core_parser_FieldEntry(arg1$9);
    var value$5 = $as_Lamf_core_model_domain_AmfScalar(entry$4.value$1.value$1).value$1;
    var element$16 = this.propertyMapping$1;
    var field$16 = entry$4.field$1;
    var pos$15 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, element$16, field$16);
    var jsx$61 = $as_sc_Seq(elem$1);
    var jsx$60 = $m_sc_Seq$();
    var array$18 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("minimum", $objectToString(value$5), $m_Lorg_yaml_model_YType$().Int$1, pos$15)];
    var jsx$59 = jsx$60.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$18));
    var this$96 = $m_sc_Seq$();
    elem$1 = $as_sc_Seq(jsx$61.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$59, this$96.ReusableCBFInstance$2))
  };
  var this$97 = this.propertyMapping$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Maximum$1);
  if ((!this$97.isEmpty__Z())) {
    var arg1$10 = this$97.get__O();
    var entry$5 = $as_Lamf_core_parser_FieldEntry(arg1$10);
    var value$6 = $as_Lamf_core_model_domain_AmfScalar(entry$5.value$1.value$1).value$1;
    var element$17 = this.propertyMapping$1;
    var field$17 = entry$5.field$1;
    var pos$16 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, element$17, field$17);
    var jsx$64 = $as_sc_Seq(elem$1);
    var jsx$63 = $m_sc_Seq$();
    var array$19 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("maximum", $objectToString(value$6), $m_Lorg_yaml_model_YType$().Int$1, pos$16)];
    var jsx$62 = jsx$63.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$19));
    var this$100 = $m_sc_Seq$();
    elem$1 = $as_sc_Seq(jsx$64.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$62, this$100.ReusableCBFInstance$2))
  };
  var this$101 = this.propertyMapping$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().AllowMultiple$1);
  if ((!this$101.isEmpty__Z())) {
    var arg1$11 = this$101.get__O();
    var entry$6 = $as_Lamf_core_parser_FieldEntry(arg1$11);
    var value$7 = $as_Lamf_core_model_domain_AmfScalar(entry$6.value$1.value$1).value$1;
    var element$18 = this.propertyMapping$1;
    var field$18 = entry$6.field$1;
    var pos$17 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, element$18, field$18);
    var jsx$67 = $as_sc_Seq(elem$1);
    var jsx$66 = $m_sc_Seq$();
    var array$20 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("allowMultiple", $objectToString(value$7), $m_Lorg_yaml_model_YType$().Bool$1, pos$17)];
    var jsx$65 = jsx$66.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$20));
    var this$104 = $m_sc_Seq$();
    elem$1 = $as_sc_Seq(jsx$67.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$65, this$104.ReusableCBFInstance$2))
  };
  var this$105 = this.propertyMapping$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Sorted$1);
  if ((!this$105.isEmpty__Z())) {
    var arg1$12 = this$105.get__O();
    var entry$7 = $as_Lamf_core_parser_FieldEntry(arg1$12);
    var value$8 = $as_Lamf_core_model_domain_AmfScalar(entry$7.value$1.value$1).value$1;
    var element$19 = this.propertyMapping$1;
    var field$19 = entry$7.field$1;
    var pos$18 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, element$19, field$19);
    var jsx$70 = $as_sc_Seq(elem$1);
    var jsx$69 = $m_sc_Seq$();
    var array$21 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("sorted", $objectToString(value$8), $m_Lorg_yaml_model_YType$().Bool$1, pos$18)];
    var jsx$68 = jsx$69.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$21));
    var this$108 = $m_sc_Seq$();
    elem$1 = $as_sc_Seq(jsx$70.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$68, this$108.ReusableCBFInstance$2))
  };
  var this$109 = this.propertyMapping$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Enum$1);
  if ((!this$109.isEmpty__Z())) {
    var arg1$13 = this$109.get__O();
    var entry$8 = $as_Lamf_core_parser_FieldEntry(arg1$13);
    var jsx$73 = $as_sc_Seq(elem$1);
    var jsx$72 = $m_sc_Seq$();
    var array$22 = [new $c_Lamf_core_emitter_BaseEmitters_package$ArrayEmitter().init___T__Lamf_core_parser_FieldEntry__Lamf_core_emitter_SpecOrdering__Z__Lorg_yaml_model_YType("enum", entry$8, this.ordering$1, false, $m_Lorg_yaml_model_YType$().Str$1)];
    var jsx$71 = jsx$72.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$22));
    var this$113 = $m_sc_Seq$();
    elem$1 = $as_sc_Seq(jsx$73.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$71, this$113.ReusableCBFInstance$2))
  };
  var this$114 = this.propertyMapping$1.fields$1.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().ExternallyLinkable$1);
  if ((!this$114.isEmpty__Z())) {
    var arg1$14 = this$114.get__O();
    var entry$9 = $as_Lamf_core_parser_FieldEntry(arg1$14);
    var value$9 = $as_Lamf_core_model_domain_AmfScalar(entry$9.value$1.value$1).value$1;
    var element$20 = this.propertyMapping$1;
    var field$20 = entry$9.field$1;
    var pos$19 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor__fieldPos__Lamf_core_model_domain_DomainElement__Lamf_core_metamodel_Field__Lamf_core_parser_Position(this, element$20, field$20);
    if ($m_sr_BoxesRunTime$().equals__O__O__Z(true, value$9)) {
      var jsx$76 = $as_sc_Seq(elem$1);
      var jsx$75 = $m_sc_Seq$();
      var array$23 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("isLink", "true", $m_Lorg_yaml_model_YType$().Bool$1, pos$19)];
      var jsx$74 = jsx$75.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$23));
      var this$117 = $m_sc_Seq$();
      elem$1 = $as_sc_Seq(jsx$76.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$74, this$117.ReusableCBFInstance$2))
    } else if ($m_sr_BoxesRunTime$().equals__O__O__Z(false, value$9)) {
      var jsx$79 = $as_sc_Seq(elem$1);
      var jsx$78 = $m_sc_Seq$();
      var array$24 = [new $c_Lamf_core_emitter_BaseEmitters_package$MapEntryEmitter().init___T__T__Lorg_yaml_model_YType__Lamf_core_parser_Position("isLink", "false", $m_Lorg_yaml_model_YType$().Bool$1, pos$19)];
      var jsx$77 = jsx$78.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$24));
      var this$120 = $m_sc_Seq$();
      elem$1 = $as_sc_Seq(jsx$79.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$77, this$120.ReusableCBFInstance$2))
    } else {
      throw new $c_s_MatchError().init___O(value$9)
    }
  };
  var jsx$81 = $as_sc_Seq(elem$1);
  var nodeWithDiscriminator = this.propertyMapping$1;
  var jsx$80 = $f_Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter__emitDiscriminator__Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__sc_Seq(this, nodeWithDiscriminator);
  var this$121 = $m_sc_Seq$();
  elem$1 = $as_sc_Seq(jsx$81.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$80, this$121.ReusableCBFInstance$2));
  this.ordering$1.sorted__sc_Seq__sc_Seq($as_sc_Seq(elem$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$17$1, b$2) {
    return (function(x$29$2) {
      var x$29 = $as_Lamf_core_emitter_EntryEmitter(x$29$2);
      x$29.emit__Lorg_yaml_model_YDocument$EntryBuilder__V(b$2)
    })
  })(this, b$1)));
  jsx$82.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YNode$().apply__Lorg_yaml_model_YValue__Lorg_yaml_model_YType__Lorg_yaml_model_YNode($m_Lorg_yaml_model_YMap$().apply__sc_IndexedSeq__T__Lorg_yaml_model_YMap(b$1.builder$1, sourceName), $m_Lorg_yaml_model_YType$().Map$1));
  var this$124 = v.builder$1;
  var array$25 = [key];
  if ((this$124.size0$6 < 0)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T("0")
  };
  var len = $uI(array$25.length);
  var newSize = ((this$124.size0$6 + len) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this$124, newSize);
  var len$1 = this$124.size0$6;
  var src = this$124.array$6;
  var dest = this$124.array$6;
  $systemArraycopy(src, 0, dest, len, len$1);
  var xs$1 = this$124.array$6;
  var len$2 = xs$1.u.length;
  var i = 0;
  var j = 0;
  var x$1 = $uI(array$25.length);
  var x$2 = ((x$1 < len$2) ? x$1 : len$2);
  var that = xs$1.u.length;
  var end = ((x$2 < that) ? x$2 : that);
  while ((i < end)) {
    var jsx$83 = j;
    var index = i;
    xs$1.set(jsx$83, array$25[index]);
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  };
  this$124.size0$6 = newSize;
  b.builder$1.$$plus$eq__O__scm_ArrayBuffer($m_Lorg_yaml_model_YMapEntry$().apply__sc_IndexedSeq__Lorg_yaml_model_YMapEntry(v.builder$1))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter.prototype.init___Lamf_plugins_document_vocabularies_model_document_Dialect__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping__Lamf_core_emitter_SpecOrdering__sci_Map = (function(dialect, propertyMapping, ordering, aliases) {
  this.dialect$1 = dialect;
  this.propertyMapping$1 = propertyMapping;
  this.ordering$1 = ordering;
  this.aliases$1 = aliases;
  return this
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter.prototype.position__Lamf_core_parser_Position = (function() {
  var this$1 = this.propertyMapping$1.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_LexicalInformation.getClassOf());
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$30 = $as_Lamf_core_annotations_LexicalInformation(arg1);
    var this$2 = new $c_s_Some().init___O(x$30.range__Lamf_core_parser_Range().start$1)
  };
  return $as_Lamf_core_parser_Position((this$2.isEmpty__Z() ? $m_Lamf_core_parser_Position$ZERO$() : this$2.get__O()))
});
function $as_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.emitters.dialects.PropertyMappingEmitter"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.emitters.dialects.PropertyMappingEmitter;", depth))
}
var $d_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter: 0
}, false, "amf.plugins.document.vocabularies.emitters.dialects.PropertyMappingEmitter", {
  Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter: 1,
  O: 1,
  Lamf_core_emitter_EntryEmitter: 1,
  Lamf_core_emitter_Emitter: 1,
  Lamf_plugins_document_vocabularies_emitters_dialects_DiscriminatorEmitter: 1,
  Lamf_plugins_document_vocabularies_emitters_dialects_PosExtractor: 1,
  Lamf_plugins_document_vocabularies_emitters_dialects_AliasesConsumer: 1,
  Lamf_plugins_document_vocabularies_emitters_instances_DialectEmitterHelper: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter.prototype.$classData = $d_Lamf_plugins_document_vocabularies_emitters_dialects_PropertyMappingEmitter;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.MergePolicy$1 = null;
  this.ALLOWED$undMERGE$undPOLICY$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.isUnion__Z = (function() {
  return (this.nodesInRange__sc_Seq().size__I() > 1)
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.productPrefix__T = (function() {
  return "PropertyMapping"
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping)) {
    var PropertyMapping$1 = $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(x$1);
    var x = this.fields$1;
    var x$2 = PropertyMapping$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = PropertyMapping$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.MergePolicy__Lamf_core_metamodel_Field = (function() {
  return this.MergePolicy$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$()
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.withEnum__sc_Seq__Lamf_plugins_document_vocabularies_model_domain_PropertyMapping = (function(values) {
  var field = $m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Enum$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      return new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(x$1$2, new $c_Lamf_core_parser_Annotations().init___())
    })
  })(this));
  var this$2 = $m_sc_Seq$();
  var values$1 = $as_sc_Seq(values.map__F1__scg_CanBuildFrom__O(jsx$1, this$2.ReusableCBFInstance$2));
  return $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this, field, values$1))
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.amf$plugins$document$vocabularies$metamodel$domain$MergeableMappingModel$$undsetter$und$MergePolicy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.MergePolicy$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.toField__Lamf_core_metamodel_Field = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().NodePropertyMapping$1)).option$1;
  if (this$1.isEmpty__Z()) {
    var this$4 = $m_Lamf_core_vocabulary_Namespace$().Data$1;
    var this$2 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Name$1));
    var this$3 = this$2.option$1;
    var id = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
    var jsx$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, id).iri__T()
  } else {
    var jsx$1 = this$1.get__O()
  };
  var iri = $as_T(jsx$1);
  var propertyIdValue = $m_Lamf_core_vocabulary_ValueType$().apply__T__Lamf_core_vocabulary_ValueType(iri);
  var isObjectRange = ($as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1)).nonEmpty__Z() || $m_s_Option$().apply__O__s_Option($f_Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__typeDiscriminator__sci_Map(this)).isDefined__Z());
  if (isObjectRange) {
    var this$6 = $as_Lamf_core_model_BoolField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().AllowMultiple$1));
    if ($f_Lamf_core_model_BoolField__value__Z(this$6)) {
      var this$7 = $as_Lamf_core_model_BoolField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().Sorted$1));
      var jsx$2 = $f_Lamf_core_model_BoolField__value__Z(this$7)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      return new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(new $c_Lamf_core_metamodel_Type$SortedArray().init___Lamf_core_metamodel_Type(($m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$(), new $c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel().init___sc_Seq__sc_Seq__s_Option(($m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$(), $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))), ($m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$(), $m_sci_Nil$()), ($m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$(), $m_s_None$())))), propertyIdValue, new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true)
    } else {
      var this$15 = $as_Lamf_core_model_BoolField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().AllowMultiple$1));
      if ($f_Lamf_core_model_BoolField__value__Z(this$15)) {
        var jsx$3 = true
      } else {
        var this$16 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermKeyProperty$1));
        var jsx$3 = this$16.option$1.isDefined__Z()
      };
      if (jsx$3) {
        return new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type(($m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$(), new $c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel().init___sc_Seq__sc_Seq__s_Option(($m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$(), $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))), ($m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$(), $m_sci_Nil$()), ($m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$(), $m_s_None$())))), propertyIdValue, new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true)
      } else {
        return new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(($m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$(), new $c_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel().init___sc_Seq__sc_Seq__s_Option(($m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$(), $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))), ($m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$(), $m_sci_Nil$()), ($m_Lamf_plugins_document_vocabularies_metamodel_domain_DialectDomainElementModel$(), $m_s_None$()))), propertyIdValue, new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true)
      }
    }
  } else {
    var rc15 = false;
    var x2 = null;
    var x1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1)).option$1;
    matchEnd16: {
      var fieldType;
      if ((x1 instanceof $c_s_Some)) {
        rc15 = true;
        x2 = $as_s_Some(x1);
        var literal = $as_T(x2.value$2);
        var this$31 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
        if ((literal === new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$31, "link").iri__T())) {
          var fieldType = $m_Lamf_core_metamodel_Type$Iri$();
          break matchEnd16
        }
      };
      if (rc15) {
        var literal$2 = $as_T(x2.value$2);
        if ((literal$2 === $m_Lamf_core_model_DataType$().AnyUri$1)) {
          var fieldType = $m_Lamf_core_metamodel_Type$LiteralUri$();
          break matchEnd16
        }
      };
      if (rc15) {
        var literal$3 = $as_T(x2.value$2);
        if ($m_sjsr_RuntimeString$().endsWith__T__T__Z(literal$3, "anyType")) {
          var fieldType = $m_Lamf_core_metamodel_Type$Any$();
          break matchEnd16
        }
      };
      if (rc15) {
        var literal$4 = $as_T(x2.value$2);
        if ($m_sjsr_RuntimeString$().endsWith__T__T__Z(literal$4, "number")) {
          var fieldType = $m_Lamf_core_metamodel_Type$Float$();
          break matchEnd16
        }
      };
      if (rc15) {
        var literal$5 = $as_T(x2.value$2);
        if ((literal$5 === $m_Lamf_core_model_DataType$().Integer$1)) {
          var fieldType = $m_Lamf_core_metamodel_Type$Int$();
          break matchEnd16
        }
      };
      if (rc15) {
        var literal$6 = $as_T(x2.value$2);
        if ((literal$6 === $m_Lamf_core_model_DataType$().Float$1)) {
          var fieldType = $m_Lamf_core_metamodel_Type$Float$();
          break matchEnd16
        }
      };
      if (rc15) {
        var literal$7 = $as_T(x2.value$2);
        if ((literal$7 === $m_Lamf_core_model_DataType$().Double$1)) {
          var fieldType = $m_Lamf_core_metamodel_Type$Double$();
          break matchEnd16
        }
      };
      if (rc15) {
        var literal$8 = $as_T(x2.value$2);
        if ((literal$8 === $m_Lamf_core_model_DataType$().Boolean$1)) {
          var fieldType = $m_Lamf_core_metamodel_Type$Bool$();
          break matchEnd16
        }
      };
      if (rc15) {
        var literal$9 = $as_T(x2.value$2);
        if ((literal$9 === $m_Lamf_core_model_DataType$().Decimal$1)) {
          var fieldType = $m_Lamf_core_metamodel_Type$Int$();
          break matchEnd16
        }
      };
      if (rc15) {
        var literal$10 = $as_T(x2.value$2);
        if ((literal$10 === $m_Lamf_core_model_DataType$().Time$1)) {
          var fieldType = $m_Lamf_core_metamodel_Type$Time$();
          break matchEnd16
        }
      };
      if (rc15) {
        var literal$11 = $as_T(x2.value$2);
        if ((literal$11 === $m_Lamf_core_model_DataType$().Date$1)) {
          var fieldType = $m_Lamf_core_metamodel_Type$Date$();
          break matchEnd16
        }
      };
      if (rc15) {
        var literal$12 = $as_T(x2.value$2);
        if ((literal$12 === $m_Lamf_core_model_DataType$().DateTime$1)) {
          var fieldType = $m_Lamf_core_metamodel_Type$Date$();
          break matchEnd16
        }
      };
      var fieldType = $m_Lamf_core_metamodel_Type$Str$()
    };
    var this$33 = $as_Lamf_core_model_BoolField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().AllowMultiple$1));
    if ($f_Lamf_core_model_BoolField__value__Z(this$33)) {
      return new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type(fieldType), propertyIdValue, new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true)
    } else {
      return new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(fieldType, propertyIdValue, new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Parser$1, "", "", $m_sci_Nil$()), true)
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.ALLOWED$undMERGE$undPOLICY__sci_Set = (function() {
  return this.ALLOWED$undMERGE$undPOLICY$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.nodesInRange__sc_Seq = (function() {
  var range = $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1));
  if (range.isEmpty__Z()) {
    var this$1 = $m_s_Option$().apply__O__s_Option($f_Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator__typeDiscriminator__sci_Map(this));
    return $as_sc_MapLike((this$1.isEmpty__Z() ? $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$())) : this$1.get__O())).values__sc_Iterable().toSeq__sc_Seq()
  } else {
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
      return (function(x$2$2) {
        var x$2 = $as_Lamf_core_model_StrField(x$2$2);
        var this$3 = x$2.option$1;
        return $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()))
      })
    })(this));
    var this$4 = $m_sc_Seq$();
    return $as_sc_Seq(range.map__F1__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2))
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.amf$plugins$document$vocabularies$metamodel$domain$MergeableMappingModel$$undsetter$und$ALLOWED$undMERGE$undPOLICY$und$eq__sci_Set__V = (function(x$1) {
  this.ALLOWED$undMERGE$undPOLICY$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.classification__Lamf_plugins_document_vocabularies_model_domain_PropertyClassification = (function() {
  var isAnyNode = $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1)).exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(obj$2) {
      var obj = $as_Lamf_core_model_StrField(obj$2);
      var this$1 = obj.option$1;
      var jsx$1 = $as_T((this$1.isEmpty__Z() ? null : this$1.get__O()));
      var this$2 = $m_Lamf_core_vocabulary_Namespace$().Meta$1;
      return (jsx$1 === new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$2, "anyNode").iri__T())
    })
  })(this)));
  var this$4 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().LiteralRange$1));
  var isLiteral = this$4.option$1.isDefined__Z();
  var isObject = $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$().ObjectRange$1)).nonEmpty__Z();
  var this$5 = $as_Lamf_core_model_BoolField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().AllowMultiple$1)).option$1;
  var multiple = $uZ((this$5.isEmpty__Z() ? false : this$5.get__O()));
  var this$6 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermKeyProperty$1));
  var isMap = this$6.option$1.isDefined__Z();
  var this$7 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().MapTermValueProperty$1));
  var isMapValue = this$7.option$1.isDefined__Z();
  var this$8 = $as_Lamf_core_model_BoolField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_PropertyMappingModel$().ExternallyLinkable$1)).option$1;
  var isExternalLink = $uZ((this$8.isEmpty__Z() ? false : this$8.get__O()));
  return (isExternalLink ? $m_Lamf_plugins_document_vocabularies_model_domain_ExternalLinkProperty$() : (isAnyNode ? $m_Lamf_plugins_document_vocabularies_model_domain_ExtensionPointProperty$() : ((isLiteral && (!multiple)) ? $m_Lamf_plugins_document_vocabularies_model_domain_LiteralProperty$() : (isLiteral ? $m_Lamf_plugins_document_vocabularies_model_domain_LiteralPropertyCollection$() : (((isObject && isMap) && isMapValue) ? $m_Lamf_plugins_document_vocabularies_model_domain_ObjectPairProperty$() : ((isObject && isMap) ? $m_Lamf_plugins_document_vocabularies_model_domain_ObjectMapProperty$() : ((isObject && (!multiple)) ? $m_Lamf_plugins_document_vocabularies_model_domain_ObjectProperty$() : $m_Lamf_plugins_document_vocabularies_model_domain_ObjectPropertyCollection$())))))))
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_plugins_document_vocabularies_metamodel_domain_MergeableMappingModel__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.domain.PropertyMapping"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_domain_PropertyMapping)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.domain.PropertyMapping;", depth))
}
var $d_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_PropertyMapping: 0
}, false, "amf.plugins.document.vocabularies.model.domain.PropertyMapping", {
  Lamf_plugins_document_vocabularies_model_domain_PropertyMapping: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_plugins_document_vocabularies_model_domain_MergeableMapping: 1,
  Lamf_plugins_document_vocabularies_metamodel_domain_MergeableMappingModel: 1,
  Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_PropertyMapping;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext() {
  $c_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext.call(this);
  this.factory$6 = null
}
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext();
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext.prototype = $c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext.prototype.schemaVersion__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion = (function() {
  return this.schemaVersion$5
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext.prototype.productPrefix__T = (function() {
  return "InlinedJsonSchemaEmitterContext"
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_core_emitter_ShapeRenderOptions__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion = (function(eh, options, schemaVersion) {
  $c_Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext.prototype.init___Lamf_core_errorhandling_ErrorHandler__Lamf_core_emitter_ShapeRenderOptions__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion.call(this, eh, options, schemaVersion);
  this.factory$6 = new $c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterFactory().init___Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext(this);
  return this
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext.prototype.factory__Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterFactory = (function() {
  return this.factory$6
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext)) {
    var InlinedJsonSchemaEmitterContext$1 = $as_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext(x$1);
    var x = this.eh$5;
    var x$2 = InlinedJsonSchemaEmitterContext$1.eh$5;
    if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
      var x$3 = this.options$5;
      var x$4 = InlinedJsonSchemaEmitterContext$1.options$5;
      var jsx$1 = (x$3 === x$4)
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.schemaVersion$5;
      var x$6 = InlinedJsonSchemaEmitterContext$1.schemaVersion$5;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.eh$5;
      break
    }
    case 1: {
      return this.options$5;
      break
    }
    case 2: {
      return this.schemaVersion$5;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext.prototype.options__Lamf_core_emitter_ShapeRenderOptions = (function() {
  return this.options$5
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext.prototype.eh__Lamf_core_errorhandling_ErrorHandler = (function() {
  return this.eh$5
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext.prototype.factory__Lamf_plugins_document_webapi_contexts_SpecEmitterFactory = (function() {
  return this.factory$6
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext.prototype.factory__Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterFactory = (function() {
  return this.factory$6
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.emitter.oas.InlinedJsonSchemaEmitterContext"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.emitter.oas.InlinedJsonSchemaEmitterContext;", depth))
}
var $d_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext: 0
}, false, "amf.plugins.document.webapi.contexts.emitter.oas.InlinedJsonSchemaEmitterContext", {
  Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_emitter_oas_JsonSchemaEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_emitter_oas_Oas2SpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_emitter_oas_OasSpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_emitter_OasLikeSpecEmitterContext: 1,
  Lamf_plugins_document_webapi_contexts_SpecEmitterContext: 1,
  O: 1,
  Lamf_plugins_document_webapi_contexts_emitter_oas_CompactEmissionContext: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_emitter_oas_InlinedJsonSchemaEmitterContext;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext() {
  $c_Lamf_plugins_document_webapi_contexts_WebApiContext.call(this);
  this.wrapped$3 = null;
  this.ds$3 = null;
  this.operationIds$3 = null;
  this.declarations$3 = null;
  this.linkTypes$3 = false;
  this.shapesThatDontPermitRef$3 = null
}
$c_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_WebApiContext();
$c_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.prototype.autoGeneratedAnnotation__Lamf_core_model_domain_Shape__V = (function(s) {
  $m_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$().oasAutoGeneratedAnnotation__Lamf_core_model_domain_Shape__V(s)
});
$c_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.prototype.moveToReference__T__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function(loc) {
  this.jsonSchemaRefGuide$2 = this.jsonSchemaRefGuide$2.changeJsonSchemaSearchDestination__T__Lamf_plugins_document_webapi_contexts_JsonSchemaRefGuide(loc);
  return this
});
$c_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.prototype.parseRemoteJSONPath__T__s_Option = (function(ref) {
  var this$1 = this.jsonSchemaRefGuide$2;
  if ((!this$1.context$1.validateRefFormatWithError__T__Z(ref))) {
    return $m_s_None$()
  };
  var fileUrl = this$1.context$1.resolvedPath__T__T__T(this$1.currentLoc$1, ref);
  var referenceUrl = this$1.getReferenceUrl__p1__T__s_Option(fileUrl);
  var this$2 = this$1.obtainFragmentFromFullRef__p1__T__s_Option(fileUrl);
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var fragment = $as_Lamf_core_model_document_Fragment(arg1);
    var newCtx = this.makeCopyWithJsonPointerContext__p3__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext().moveToReference__T__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext($as_T($f_Lamf_core_model_document_BaseUnit__location__s_Option(fragment).get__O()));
    return $m_Lamf_plugins_document_webapi_JsonSchemaPlugin$().parseFragment__Lamf_core_model_document_Fragment__s_Option__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__s_Option(fragment, referenceUrl, newCtx)
  }
});
$c_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.prototype.ignore__T__T__Z = (function(shape, property) {
  if ((($uI(property.length) >= 0) && ($as_T(property.substring(0, $uI("x-".length))) === "x-"))) {
    var jsx$1 = true
  } else if ((property === "$ref")) {
    var this$6 = this.shapesThatDontPermitRef$3;
    var jsx$1 = (!$f_sc_LinearSeqOptimized__contains__O__Z(this$6, shape))
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return true
  } else {
    return ((($uI(property.length) >= 0) && ($as_T(property.substring(0, $uI("/".length))) === "/")) && (shape === "paths"))
  }
});
$c_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.prototype.isMainFileContext__Z = (function() {
  return (this.rootContextDocument$1 === this.jsonSchemaRefGuide$2.currentLoc$1)
});
$c_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.prototype.linkTypes__Z = (function() {
  return this.linkTypes$3
});
$c_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.prototype.navigateToRemoteYNode__T__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__s_Option = (function(ref, ctx) {
  var nodeOption = this.jsonSchemaRefGuide$2.obtainRemoteYNode__T__s_Option(ref);
  var rootNode = this.jsonSchemaRefGuide$2.getRootYNode__T__s_Option(ref);
  if (nodeOption.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = nodeOption.get__O();
    var node = $as_Lorg_yaml_model_YNode(arg1);
    var newCtx = ctx.makeCopyWithJsonPointerContext__p3__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext().moveToReference__T__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(node.location$1.sourceName$1);
    if ((!rootNode.isEmpty__Z())) {
      var arg1$1 = rootNode.get__O();
      var value = $as_Lorg_yaml_model_YNode(arg1$1);
      newCtx.setJsonSchemaAST__Lorg_yaml_model_YNode__V(value)
    };
    return new $c_s_Some().init___O(new $c_Lamf_plugins_document_webapi_contexts_parser_RemoteNodeNavigation().init___Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext(node, newCtx))
  }
});
$c_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.prototype.link__Lorg_yaml_model_YNode__s_util_Either = (function(node) {
  var evidence$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var x1 = $f_Lorg_yaml_model_YNodeLike__to__Lorg_yaml_convert_YRead__s_util_Either(node, evidence$2);
  if ((x1 instanceof $c_s_util_Right)) {
    var x2 = $as_s_util_Right(x1);
    var map = $as_Lorg_yaml_model_YMap(x2.value$2);
    var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("$ref");
    if (this$2.isEmpty__Z()) {
      var this$4 = $m_s_None$()
    } else {
      var arg1 = this$2.get__O();
      var v = $as_Lorg_yaml_model_YMapEntry(arg1);
      var this$3 = v.value$2;
      var evidence$1 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
      var this$4 = $f_Lorg_yaml_model_YNodeLike__asOption__Lorg_yaml_convert_YRead__s_Option(this$3, evidence$1)
    };
    if (this$4.isEmpty__Z()) {
      var ref = $m_s_None$()
    } else {
      var arg1$1 = this$4.get__O();
      var x$1 = $as_Lorg_yaml_model_YScalar(arg1$1);
      var ref = new $c_s_Some().init___O(x$1.text$3)
    };
    if ((ref instanceof $c_s_Some)) {
      var x2$2 = $as_s_Some(ref);
      var url = $as_T(x2$2.value$2);
      $m_s_package$();
      return new $c_s_util_Left().init___O(url)
    } else {
      var x = $m_s_None$();
      if ((x === ref)) {
        $m_s_package$();
        return new $c_s_util_Right().init___O(node)
      } else {
        throw new $c_s_MatchError().init___O(ref)
      }
    }
  } else {
    $m_s_package$();
    return new $c_s_util_Right().init___O(node)
  }
});
$c_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.prototype.init___T__sc_Seq__Lamf_core_client_ParsingOptions__Lamf_core_parser_ParserContext__s_Option__scm_Set = (function(loc, refs, options, wrapped, ds, operationIds) {
  this.wrapped$3 = wrapped;
  this.ds$3 = ds;
  this.operationIds$3 = operationIds;
  $c_Lamf_plugins_document_webapi_contexts_WebApiContext.prototype.init___T__sc_Seq__Lamf_core_client_ParsingOptions__Lamf_core_parser_ParserContext__s_Option.call(this, loc, refs, options, wrapped, ds);
  if (ds.isEmpty__Z()) {
    var jsx$3 = this.refs$1;
    var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(r$2) {
        var r = $as_Lamf_core_parser_ParsedReference(r$2);
        if ((r.unit$1 instanceof $c_Lamf_core_model_document_ExternalFragment)) {
          var this$1 = $as_Lamf_core_model_document_ExternalFragment(r.unit$1);
          var this$2 = $as_Lamf_core_model_domain_ExternalDomainElement($as_Lamf_core_model_domain_DomainElement(this$1.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))).parsed$1;
          if (this$2.isEmpty__Z()) {
            var xo = $m_s_None$()
          } else {
            var arg1 = this$2.get__O();
            var node = $as_Lorg_yaml_model_YNode(arg1);
            var self = r.origin$1.url$1;
            var xo = new $c_s_Some().init___O(new $c_T2().init___O__O(self, node))
          };
          return xo.toList__sci_List()
        } else {
          var xo$1 = $m_s_None$();
          return xo$1.toList__sci_List()
        }
      })
    })(this));
    var this$7 = $m_sc_Seq$();
    var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations().init___sci_Map__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations($as_sc_TraversableOnce(jsx$3.flatMap__F1__scg_CanBuildFrom__O(jsx$2, this$7.ReusableCBFInstance$2)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2), $m_s_None$(), this.eh$1, this.futureDeclarations$1)
  } else {
    var jsx$1 = ds.get__O()
  };
  this.declarations$3 = $as_Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations(jsx$1);
  this.linkTypes$3 = (!(wrapped instanceof $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext));
  $m_sci_List$();
  var array = ["paths"];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$11 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$11);
    i = (((-1) + i) | 0)
  };
  this.shapesThatDontPermitRef$3 = result;
  return this
});
$c_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.prototype.makeCopyWithJsonPointerContext__p3__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function() {
  var copy = this.makeCopy__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
  copy.jsonSchemaRefGuide$2 = this.jsonSchemaRefGuide$2;
  return copy
});
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.call(this);
  this.root$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser();
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser.prototype.productPrefix__T = (function() {
  return "AsyncApi20DocumentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser)) {
    var AsyncApi20DocumentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser(x$1);
    var x = this.root$3;
    var x$2 = AsyncApi20DocumentParser$1.root$3;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.root$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function(root, ctx) {
  this.root$3 = root;
  $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext.call(this, root, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$2
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext = (function() {
  return this.ctx$2
});
function $as_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.async.AsyncApi20DocumentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.async.AsyncApi20DocumentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.async.AsyncApi20DocumentParser", {
  Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser: 1,
  Lamf_plugins_document_webapi_parser_spec_async_AsyncApiDocumentParser: 1,
  Lamf_plugins_document_webapi_parser_spec_async_AsyncApiSpecParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_WebApiBaseSpecParser: 1,
  Lamf_core_parser_BaseSpecParser: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasLikeDeclarationsHelper: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_async_AsyncApi20DocumentParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.call(this);
  this.entry$2 = null;
  this.shape$2 = null;
  this.fatherMap$2 = null;
  this.ctx$2 = null;
  this.$$outer$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser.prototype.init___Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser__Lorg_yaml_model_YMapEntry__Lamf_core_model_domain_Shape__s_Option__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function($$outer, entry, shape, fatherMap, ctx) {
  this.entry$2 = entry;
  this.shape$2 = shape;
  this.fatherMap$2 = fatherMap;
  this.ctx$2 = ctx;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.prototype.init___Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser.prototype.productPrefix__T = (function() {
  return "InheritanceParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser.prototype.productArity__I = (function() {
  return 3
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser) && ($as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser(x$1).$$outer$2 === this.$$outer$2))) {
    var InheritanceParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser(x$1);
    var x = this.entry$2;
    var x$2 = InheritanceParser$1.entry$2;
    if ((x === x$2)) {
      var x$3 = this.shape$2;
      var x$4 = InheritanceParser$1.shape$2;
      var jsx$1 = ((x$3 === null) ? (x$4 === null) : x$3.equals__O__Z(x$4))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var x$5 = this.fatherMap$2;
      var x$6 = InheritanceParser$1.fatherMap$2;
      return ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.entry$2;
      break
    }
    case 1: {
      return this.shape$2;
      break
    }
    case 2: {
      return this.fatherMap$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser.prototype.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$SchemaUsageRestrictions$$$outer__Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser = (function() {
  return this.$$outer$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser.prototype.parse__V = (function() {
  var this$1 = this.entry$2.value$2;
  var x1 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
  var x = $m_Lorg_yaml_model_YType$().Seq$1;
  if ((x === x1)) {
    var this$2 = this.entry$2.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$SeqNodeYRead$();
    var iv = this.ctx$2;
    var superTypes = $as_sc_Seq($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv));
    var isMultipleInheritance = (superTypes.size__I() > 1);
    var this$3 = $m_sc_Seq$();
    var jsx$2 = $as_sc_TraversableLike(superTypes.zipWithIndex__scg_CanBuildFrom__O(this$3.ReusableCBFInstance$2));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, isMultipleInheritance$1) {
      return (function(x0$1$2) {
        var x0$1 = $as_T2(x0$1$2);
        if ((x0$1 !== null)) {
          var node = $as_Lorg_yaml_model_YNode(x0$1.$$und1__O());
          var i = x0$1.$$und2$mcI$sp__I();
          var id = (isMultipleInheritance$1 ? (("" + $this.shape$2.id$1) + i) : $this.shape$2.id$1);
          var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
          var iv$1 = $this.ctx$2;
          var x1$2 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$1, iv$1)).text$3;
          var o7 = $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$().unapply__T__s_Option(x1$2);
          if ((!o7.isEmpty__Z())) {
            var s = $as_T(o7.get__O());
            var adopt = $this.$$outer$2.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$adopt$f;
            var part = new $c_s_Some().init___O(node);
            var ctx = $this.ctx$2;
            var qual$1 = $as_Lamf_core_model_domain_Shape(new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlTypeExpressionParser().init___F1__I__s_Option__Z__T__Lamf_plugins_document_webapi_contexts_WebApiContext(adopt, 0, part, false, s, ctx).parse__s_Option().get__O());
            var x$2 = qual$1.adopted$default$2__sc_Seq();
            return $as_Lamf_core_model_domain_Shape(qual$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(id, x$2))
          };
          if ($f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax__wellKnownType__T__Z__Z($this, x1$2, false)) {
            var this$5 = $f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax__parseWellKnownTypeRef__T__Lamf_core_model_domain_Shape($this, x1$2);
            var a = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations($this.entry$2.key$2);
            var qual$2 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$5, x1$2, a));
            var x$4 = qual$2.adopted$default$2__sc_Seq();
            return $as_Lamf_core_model_domain_Shape(qual$2.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(id, x$4))
          };
          var x1$3 = $this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().findType__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option(x1$2, $m_Lamf_core_parser_SearchScope$All$(), ($this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations(), $m_s_None$()));
          if ((x1$3 instanceof $c_s_Some)) {
            var x2 = $as_s_Some(x1$3);
            var ancestor = $as_Lamf_plugins_domain_shapes_models_AnyShape(x2.value$2);
            return ancestor
          } else {
            return $this.unresolved__p2__Lorg_yaml_model_YNode__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_UnresolvedShape(node, $this.shape$2)
          }
        } else {
          throw new $c_s_MatchError().init___O(x0$1)
        }
      })
    })(this, isMultipleInheritance));
    var this$7 = $m_sc_Seq$();
    var inherits = $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
    var base = this.shape$2;
    var jsx$3 = $m_Lamf_core_parser_Range$();
    var this$8 = this.$$outer$2.node$2;
    var this$9 = this$8.location$1;
    var entryRange = jsx$3.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$9.lineFrom$1, this$9.columnFrom$1, this$9.lineTo$1, this$9.columnTo$1));
    $f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$SchemaUsageRestrictions__checkSchemaInheritance__Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_parser_Range__V(this, base, inherits, entryRange);
    this.shape$2.fields__Lamf_core_parser_Fields().setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations(inherits, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$2.value$2)), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$2))
  } else {
    var x$3 = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x$3 === x1)) {
      var this$12 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(this.entry$2, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
        return (function(s$2) {
          var s$1 = $as_Lamf_core_model_domain_Shape(s$2);
          s$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(this$2$1.shape$2.id$1, s$1.adopted$default$2__sc_Seq())
        })
      })(this)), new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo().init___Z__Z(false, false), $m_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$(), this.ctx$2).parse__s_Option();
      if ((!this$12.isEmpty__Z())) {
        var arg1 = this$12.get__O();
        var s$3 = $as_Lamf_core_model_domain_Shape(arg1);
        var base$1 = this.shape$2;
        var jsx$4 = $m_sc_Seq$();
        var array = [s$3];
        var elements = $as_sc_Seq(jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
        var jsx$5 = $m_Lamf_core_parser_Range$();
        var this$15 = this.entry$2;
        var this$16 = this$15.location$1;
        var entryRange$1 = jsx$5.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$16.lineFrom$1, this$16.columnFrom$1, this$16.lineTo$1, this$16.columnTo$1));
        $f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$SchemaUsageRestrictions__checkSchemaInheritance__Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_parser_Range__V(this, base$1, elements, entryRange$1);
        var this$19 = this.shape$2;
        var field = $m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1;
        var jsx$6 = $m_sc_Seq$();
        var array$1 = [s$3];
        var value = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$6.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1))), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$2.value$2));
        var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$2);
        $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$19, field, value, annotations))
      }
    } else {
      var jsx$7 = $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$TypeExpression$();
      var this$20 = this.entry$2.value$2;
      var conversion$2 = $m_Lamf_core_parser_package$YScalarYRead$();
      var iv$2 = this.ctx$2;
      if (jsx$7.unapply__T__s_Option($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$20, conversion$2, iv$2)).text$3).isDefined__Z()) {
        var this$23 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml10TypeParser(this.entry$2, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
          return (function(s$4$2) {
            var s$4 = $as_Lamf_core_model_domain_Shape(s$4$2);
            s$4.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(this$4$1.shape$2.id$1, s$4.adopted$default$2__sc_Seq())
          })
        })(this)), new $c_Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo().init___Z__Z(false, false), $m_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$(), this.ctx$2).parse__s_Option();
        if ((!this$23.isEmpty__Z())) {
          var arg1$1 = this$23.get__O();
          var s$5 = $as_Lamf_core_model_domain_Shape(arg1$1);
          var base$2 = this.shape$2;
          var jsx$8 = $m_sc_Seq$();
          var array$2 = [s$5];
          var elements$1 = $as_sc_Seq(jsx$8.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$2)));
          var jsx$9 = $m_Lamf_core_parser_Range$();
          var this$26 = this.entry$2;
          var this$27 = this$26.location$1;
          var entryRange$2 = jsx$9.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$27.lineFrom$1, this$27.columnFrom$1, this$27.lineTo$1, this$27.columnTo$1));
          $f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$SchemaUsageRestrictions__checkSchemaInheritance__Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_parser_Range__V(this, base$2, elements$1, entryRange$2);
          var this$30 = this.shape$2;
          var field$1 = $m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1;
          var jsx$10 = $m_sc_Seq$();
          var array$3 = [s$5];
          var value$1 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$10.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$3))), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$2.value$2));
          var annotations$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$2);
          $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$30, field$1, value$1, annotations$1))
        }
      } else {
        var x$5 = $m_Lorg_yaml_model_YType$().Str$1;
        if ((x$5 === x1)) {
          var jsx$12 = $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$XMLSchema$();
          $m_Lorg_yaml_model_YNode$();
          var node$1 = this.entry$2.value$2;
          var iv$3 = this.ctx$2;
          var conversion$3 = $m_Lorg_yaml_convert_YRead$StringYRead$();
          var jsx$11 = jsx$12.unapply__T__s_Option($as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node$1, conversion$3, iv$3))).isDefined__Z()
        } else {
          var jsx$11 = false
        };
        if (jsx$11) {
          var this$33 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression().init___Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("schema")), this.entry$2.value$2, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$6$1) {
            return (function(xmlSchemaShape$2) {
              var xmlSchemaShape = $as_Lamf_core_model_domain_Shape(xmlSchemaShape$2);
              var value$2 = (this$6$1.shape$2.id$1 + "/xmlSchema");
              $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(xmlSchemaShape, value$2)
            })
          })(this)), false, this.ctx$2);
          var parsed = $f_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__parse__Lamf_plugins_domain_shapes_models_AnyShape(this$33);
          var base$3 = this.shape$2;
          var jsx$13 = $m_sc_Seq$();
          var array$4 = [parsed];
          var elements$2 = $as_sc_Seq(jsx$13.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$4)));
          var jsx$14 = $m_Lamf_core_parser_Range$();
          var this$36 = this.entry$2;
          var this$37 = this$36.location$1;
          var entryRange$3 = jsx$14.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$37.lineFrom$1, this$37.columnFrom$1, this$37.lineTo$1, this$37.columnTo$1));
          $f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$SchemaUsageRestrictions__checkSchemaInheritance__Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_parser_Range__V(this, base$3, elements$2, entryRange$3);
          var this$40 = this.shape$2;
          var field$2 = $m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1;
          var jsx$15 = $m_sc_Seq$();
          var array$5 = [parsed];
          var value$3 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$15.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$5))), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$2.value$2));
          var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$2);
          $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$40, field$2, value$3, annotations$2)
        } else {
          var this$41 = this.entry$2.value$2;
          var conversion$4 = $m_Lamf_core_parser_package$YScalarYRead$();
          var iv$4 = this.ctx$2;
          var str = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$41, conversion$4, iv$4)).text$3;
          if ((!$f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax__wellKnownType__T__Z__Z(this, str, false))) {
            var this$42 = this.entry$2.value$2;
            var conversion$5 = $m_Lamf_core_parser_package$YScalarYRead$();
            var iv$5 = this.ctx$2;
            var text = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$42, conversion$5, iv$5)).text$3;
            var x1$2$1 = this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().findType__T__Lamf_core_parser_SearchScope$Scope__s_Option__s_Option(text, $m_Lamf_core_parser_SearchScope$All$(), (this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations(), $m_s_None$()));
            if ((x1$2$1 instanceof $c_s_Some)) {
              var x2$1 = $as_s_Some(x1$2$1);
              var ancestor$1 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x2$1.value$2);
              var base$4 = this.shape$2;
              var jsx$16 = $m_sc_Seq$();
              var array$6 = [ancestor$1];
              var elements$3 = $as_sc_Seq(jsx$16.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$6)));
              var jsx$17 = $m_Lamf_core_parser_Range$();
              var this$46 = this.entry$2;
              var this$47 = this$46.location$1;
              var entryRange$4 = jsx$17.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$47.lineFrom$1, this$47.columnFrom$1, this$47.lineTo$1, this$47.columnTo$1));
              $f_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$SchemaUsageRestrictions__checkSchemaInheritance__Lamf_core_model_domain_Shape__sc_Seq__Lamf_core_parser_Range__V(this, base$4, elements$3, entryRange$4);
              var jsx$20 = this.shape$2.fields__Lamf_core_parser_Fields();
              var jsx$19 = $m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1;
              var jsx$18 = $m_sc_Seq$();
              var this$49 = $as_Lamf_plugins_domain_shapes_models_AnyShape(ancestor$1.link__T__Lamf_core_parser_Annotations__O(text, $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$2.value$2)));
              var this$48 = $as_Lamf_core_model_StrField(ancestor$1.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
              var name = $as_T((this$48.isEmpty__Z() ? "schema" : this$48.get__O()));
              var a$1 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$2.key$2);
              var this$50 = $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(this$49, name, a$1);
              var annotation = new $c_Lamf_core_annotations_AutoGeneratedName().init___();
              var array$7 = [$as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$50, annotation))];
              jsx$20.setWithoutId__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields(jsx$19, new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$18.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$7))), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$2.value$2)), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$2))
            } else {
              matchEnd5: {
                var baseClass;
                var o8 = $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$JSONSchema$().unapply__T__s_Option(text);
                if ((!o8.isEmpty__Z())) {
                  var this$53 = this.ctx$2.eh$1;
                  var specification = $m_Lamf_validations_ParserSideValidations$().JsonSchemaInheratinaceWarningSpecification$1;
                  var node$2 = this.shape$2.id$1;
                  var property = new $c_s_Some().init___O($m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1.value$1.iri__T());
                  var part$1 = this.entry$2.value$2;
                  var location = part$1.location$1;
                  $f_Lamf_core_errorhandling_ErrorHandler__warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$53, specification, node$2, property, "Inheritance from JSON Schema", location);
                  var this$55 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression().init___Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(($m_Lorg_yaml_model_YNode$(), $m_Lorg_yaml_model_YNode$().apply__T__Lorg_yaml_model_YNode("schema")), this.entry$2.value$2, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$8$1) {
                    return (function(jsonSchemaShape$2) {
                      var jsonSchemaShape = $as_Lamf_core_model_domain_Shape(jsonSchemaShape$2);
                      var value$4 = (this$8$1.shape$2.id$1 + "/jsonSchema");
                      $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(jsonSchemaShape, value$4)
                    })
                  })(this)), false, this.ctx$2);
                  var baseClass = $f_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser__parse__Lamf_plugins_domain_shapes_models_AnyShape(this$55);
                  break matchEnd5
                };
                var baseClass = this.unresolved__p2__Lorg_yaml_model_YNode__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_UnresolvedShape(this.entry$2.value$2, this.shape$2)
              };
              if ((text === null)) {
                throw new $c_jl_NullPointerException().init___()
              };
              if ((!$m_ju_regex_Pattern$().matches__T__jl_CharSequence__Z("<<.*>>", text))) {
                var this$59 = this.shape$2;
                var field$3 = $m_Lamf_core_metamodel_domain_ShapeModel$().Inherits$1;
                var jsx$21 = $m_sc_Seq$();
                var array$8 = [baseClass];
                var value$5 = new $c_Lamf_core_model_domain_AmfArray().init___sc_Seq__Lamf_core_parser_Annotations($as_sc_Seq(jsx$21.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$8))), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$2.value$2));
                var annotations$3 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(this.entry$2);
                $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(this$59, field$3, value$5, annotations$3)
              }
            }
          } else {
            var this$60 = this.shape$2;
            var annotation$1 = new $c_Lamf_core_annotations_ExplicitField().init___();
            $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$60, annotation$1)
          }
        }
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser.prototype.unresolved__p2__Lorg_yaml_model_YNode__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_UnresolvedShape = (function(node, shape) {
  var conversion = $m_Lamf_core_parser_package$YScalarYRead$();
  var iv = this.ctx$2;
  var reference = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).text$3;
  var jsx$3 = new $c_Lamf_core_parser_Fields().init___();
  var jsx$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(node);
  var this$2 = this.fatherMap$2;
  if (this$2.isEmpty__Z()) {
    var jsx$1 = $m_s_None$()
  } else {
    var arg1 = this$2.get__O();
    var m = $as_Lorg_yaml_model_YMap(arg1);
    var jsx$1 = new $c_s_Some().init___O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, shape$7, m$1) {
      return (function(resolvedKey$2) {
        var resolvedKey = $as_s_Option(resolvedKey$2);
        return new $c_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser().init___Lamf_core_model_domain_Shape__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__s_Option(shape$7, m$1, $this.ctx$2, $this.$$outer$2.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$typeInfo$f, resolvedKey)
      })
    })(this, shape, m)))
  };
  var unresolvedShape = new $c_Lamf_plugins_domain_shapes_models_UnresolvedShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations__T__s_Option__s_Option__Z(jsx$3, jsx$2, reference, jsx$1, new $c_s_Some().init___O(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, shape$1) {
    return (function(k$2) {
      var k = $as_T(k$2);
      var this$3 = shape$1.fields__Lamf_core_parser_Fields();
      var f = $m_Lamf_core_metamodel_domain_LinkableElementModel$().TargetId$1;
      if (this$3.fs$1.contains__O__Z(f)) {
        var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().TargetId$1;
        $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(shape$1, field, k)
      }
    })
  })(this, shape))), true);
  var c = this.ctx$2;
  $f_Lamf_core_parser_UnresolvedReference__withContext__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(unresolvedShape, c);
  if ((!new $c_Lamf_core_utils_package$AmfStrings().init___T(reference).validReferencePath__Z())) {
    var this$5 = this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().libraries$1;
    var this$6 = new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(this$5);
    var this$7 = this$6.$$outer$4.keysIterator__sc_Iterator();
    var res = false;
    while (((!res) && this$7.hasNext__Z())) {
      var arg1$1 = this$7.next__O();
      var x$22 = $as_T(arg1$1);
      var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(reference, "\\.", 0);
      var this$10 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
      res = (x$22 === $f_sc_IndexedSeqOptimized__head__O(this$10))
    };
    var jsx$4 = res
  } else {
    var jsx$4 = false
  };
  if (jsx$4) {
    var this$11 = this.ctx$2.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().ChainedReferenceSpecification$1;
    var node$1 = unresolvedShape.id$1;
    var message = ("Chained reference '" + reference);
    var prop = $m_s_None$();
    var l = node.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$11, specification, node$1, prop, message, l)
  } else {
    var ctx = this.ctx$2;
    $f_Lamf_core_model_domain_Linkable__unresolved__T__Lorg_yaml_model_YPart__T__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(unresolvedShape, reference, node, "error", ctx)
  };
  this.$$outer$2.amf$plugins$document$webapi$parser$spec$declaration$RamlTypeParser$$adopt$f.apply__O__O(unresolvedShape);
  return unresolvedShape
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$InheritanceParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$InheritanceParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.RamlTypeParser$InheritanceParser", {
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_WebApiBaseSpecParser: 1,
  Lamf_core_parser_BaseSpecParser: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$SchemaUsageRestrictions: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeParser$InheritanceParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.call(this);
  this.root$3 = null;
  this.definitionsKey$3 = null;
  this.securityKey$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser();
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(root, ctx) {
  this.root$3 = root;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext.call(this, root, ctx);
  this.definitionsKey$3 = "definitions";
  this.securityKey$3 = "securityDefinitions";
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser.prototype.securityKey__T = (function() {
  return this.securityKey$3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser.prototype.productPrefix__T = (function() {
  return "Oas2DocumentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function() {
  return this.ctx$2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser)) {
    var Oas2DocumentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser(x$1);
    var x = this.root$3;
    var x$2 = Oas2DocumentParser$1.root$3;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.root$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser.prototype.definitionsKey__T = (function() {
  return this.definitionsKey$3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser.prototype.parseWebApi__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_WebApi = (function(map) {
  var api = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.parseWebApi__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_WebApi.call(this, map);
  var jsx$1 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Accepts$1;
  var iv = this.ctx$2;
  jsx$1.key__T__F1__V("consumes", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(api));
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().ContentType$1;
  var iv$1 = this.ctx$2;
  jsx$2.key__T__F1__V("produces", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(api));
  var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Schemes$1;
  var iv$2 = this.ctx$2;
  jsx$3.key__T__F1__V("schemes", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(api));
  return api
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.Oas2DocumentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.Oas2DocumentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.Oas2DocumentParser", {
  Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_WebApiBaseSpecParser: 1,
  Lamf_core_parser_BaseSpecParser: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasLikeDeclarationsHelper: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas2DocumentParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.call(this);
  this.root$3 = null;
  this.definitionsKey$3 = null;
  this.securityKey$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser();
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.securityKey__T = (function() {
  return this.securityKey$3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(root, ctx) {
  this.root$3 = root;
  $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext.call(this, root, ctx);
  this.definitionsKey$3 = "schemas";
  this.securityKey$3 = "securitySchemes";
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.productPrefix__T = (function() {
  return "Oas3DocumentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function() {
  return this.ctx$2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser)) {
    var Oas3DocumentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser(x$1);
    var x = this.root$3;
    var x$2 = Oas3DocumentParser$1.root$3;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.root$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.definitionsKey__T = (function() {
  return this.definitionsKey$3
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.violation$1__p3__Lamf_core_model_domain_NamedDomainElement__T__V = (function(elem, msg) {
  var this$1 = this.ctx$2.eh$1;
  var specification = $m_Lamf_validations_ParserSideValidations$().InvalidFieldNameInComponents$1;
  var node = elem.id__T();
  var annotations = elem.annotations__Lamf_core_parser_Annotations();
  $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$1, specification, node, msg, annotations)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.validateNames__V = (function() {
  var declarations = this.ctx$2.declarations$4.declarables__sc_Seq();
  var this$2 = new $c_sci_StringOps().init___T("^[a-zA-Z0-9\\.\\-_]+$");
  var groupNames = $m_sci_Nil$();
  var $$this = this$2.repr$1;
  var keyRegex = new $c_s_util_matching_Regex().init___T__sc_Seq($$this, groupNames);
  declarations.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, keyRegex$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_domain_DomainElement(x0$1$2);
      if ($is_Lamf_core_model_domain_NamedDomainElement(x0$1)) {
        var x2 = $as_Lamf_core_model_domain_NamedDomainElement(x0$1);
        var x1$2 = $as_Lamf_core_model_StrField(x2.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O(x2.nameField__Lamf_core_metamodel_Field())).option$1;
        if ((x1$2 instanceof $c_s_Some)) {
          var x2$2 = $as_s_Some(x1$2);
          var name = $as_T(x2$2.value$2);
          var this$4 = keyRegex$1.pattern$1;
          if ((!new $c_ju_regex_Matcher().init___ju_regex_Pattern__jl_CharSequence__I__I(this$4, name, 0, $uI(name.length)).matches__Z())) {
            $this.violation$1__p3__Lamf_core_model_domain_NamedDomainElement__T__V(x2, (((("Name " + name) + " does not match regular expression ") + keyRegex$1.pattern$1.$$undpattern$1) + " for component declarations"))
          }
        } else {
          var x = $m_s_None$();
          if ((!(x === x1$2))) {
            throw new $c_s_MatchError().init___O(x1$2)
          };
          $this.violation$1__p3__Lamf_core_model_domain_NamedDomainElement__T__V(x2, "No name is defined for given component declaration")
        }
      }
    })
  })(this, keyRegex)))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.parseRequestBodyDeclarations__Lorg_yaml_model_YMap__T__V = (function(map, parent) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("requestBodies");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = e.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$2;
    $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$2) {
      return (function(entry$2) {
        var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
        var this$5 = entry.value$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv$1 = $this.ctx$2;
        var requestBody = new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30RequestParser().init___Lorg_yaml_model_YMap__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion$1, iv$1)), parent$2, entry, $this.ctx$2).parse__Lamf_plugins_domain_webapi_models_Request();
        var jsx$1 = $this.ctx$2.declarations$4;
        var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
        return jsx$1.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(requestBody, annotation)))
      })
    })(this, parent)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.parseExamplesDeclaration__Lorg_yaml_model_YMap__T__V = (function(map, parent) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("examples");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    new $c_Lamf_plugins_document_webapi_parser_spec_domain_Oas3NamedExamplesParser().init___Lorg_yaml_model_YMapEntry__T__Lamf_plugins_document_webapi_contexts_WebApiContext(e, parent, this.ctx$2).parse__sc_Seq().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(ex$2) {
        var ex = $as_Lamf_plugins_domain_shapes_models_Example(ex$2);
        var jsx$1 = $this.ctx$2.declarations$4;
        var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
        return jsx$1.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(ex, annotation)))
      })
    })(this)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.parseCallbackDeclarations__Lorg_yaml_model_YMap__T__V = (function(map, parent) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("callbacks");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$2;
    $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$5) {
      return (function(callbackEntry$2) {
        var callbackEntry = $as_Lorg_yaml_model_YMapEntry(callbackEntry$2);
        var this$5 = callbackEntry.key$2;
        var conversion$1 = $m_Lamf_core_parser_package$YScalarYRead$();
        var iv$1 = $this.ctx$2;
        var name = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion$1, iv$1)).text$3;
        var this$6 = callbackEntry.value$2;
        var conversion$2 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv$2 = $this.ctx$2;
        var callbacks = new $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas30CallbackParser().init___Lorg_yaml_model_YMap__F1__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion$2, iv$2)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, name$1, parent$5$1) {
          return (function(x$2$2) {
            var x$2 = $as_Lamf_plugins_domain_webapi_models_Callback(x$2$2);
            $m_Lamf_core_parser_Annotations$();
            var a = new $c_Lamf_core_parser_Annotations().init___();
            var qual$1 = $as_Lamf_plugins_domain_webapi_models_Callback($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(x$2, name$1, a));
            $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
            $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, parent$5$1)
          })
        })($this, name, parent$5)), name, callbackEntry, $this.ctx$2).parse__sci_List();
        var these = callbacks;
        while ((!these.isEmpty__Z())) {
          var arg1$1 = these.head__O();
          var callback = $as_Lamf_plugins_domain_webapi_models_Callback(arg1$1);
          var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
          $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(callback, annotation);
          $this.ctx$2.declarations$4.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(callback);
          these = $as_sci_List(these.tail__O())
        }
      })
    })(this, parent)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.parseDeclarations__Lamf_core_Root__Lorg_yaml_model_YMap__V = (function(root, map) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("components");
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var components = $as_Lorg_yaml_model_YMapEntry(arg1);
    var parent = (root.location$1 + "#/declarations");
    var this$3 = components.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$2;
    var map$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion, iv));
    this.parseExamplesDeclaration__Lorg_yaml_model_YMap__T__V(map$1, (parent + "/examples"));
    this.parseLinkDeclarations__Lorg_yaml_model_YMap__T__V(map$1, (parent + "/links"));
    var parent$1 = (parent + "/securitySchemes");
    $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.parseSecuritySchemeDeclarations__Lorg_yaml_model_YMap__T__V.call(this, map$1, parent$1);
    var typesPrefix = (parent + "/types");
    var ctx = this.ctx$2;
    $f_Lamf_plugins_document_webapi_parser_spec_oas_OasLikeDeclarationsHelper__parseTypeDeclarations__Lorg_yaml_model_YMap__T__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__V(this, map$1, typesPrefix, ctx);
    this.parseHeaderDeclarations__Lorg_yaml_model_YMap__T__V(map$1, (parent + "/headers"));
    var parentPath = (parent + "/parameters");
    $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.parseParameterDeclarations__Lorg_yaml_model_YMap__T__V.call(this, map$1, parentPath);
    var parentPath$1 = (parent + "/responses");
    $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.parseResponsesDeclarations__T__Lorg_yaml_model_YMap__T__V.call(this, "responses", map$1, parentPath$1);
    this.parseRequestBodyDeclarations__Lorg_yaml_model_YMap__T__V(map$1, (parent + "/requestBodies"));
    this.parseCallbackDeclarations__Lorg_yaml_model_YMap__T__V(map$1, (parent + "/callbacks"));
    $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.parseAnnotationTypeDeclarations__Lorg_yaml_model_YMap__T__V.call(this, map$1, parent);
    new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser().init___T__F1__Lorg_yaml_model_YMap__T__Lamf_plugins_document_webapi_contexts_WebApiContext(new $c_Lamf_core_utils_package$AmfStrings().init___T("resourceTypes").asOasExtension__T(), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(entry$2) {
        var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
        return $m_Lamf_plugins_domain_webapi_models_templates_ResourceType$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_templates_ResourceType(entry)
      })
    })(this)), map$1, (parent + "/resourceTypes"), this.ctx$2).parse__V();
    new $c_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationsParser().init___T__F1__Lorg_yaml_model_YMap__T__Lamf_plugins_document_webapi_contexts_WebApiContext(new $c_Lamf_core_utils_package$AmfStrings().init___T("traits").asOasExtension__T(), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(entry$3$2) {
        var entry$3 = $as_Lorg_yaml_model_YMapEntry(entry$3$2);
        return $m_Lamf_plugins_domain_webapi_models_templates_Trait$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_templates_Trait(entry$3)
      })
    })(this)), map$1, (parent + "/traits"), this.ctx$2).parse__V();
    this.ctx$2.closedShape__T__Lorg_yaml_model_YMap__T__V(parent, map$1, "components");
    this.validateNames__V()
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$2
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.parseHeaderDeclarations__Lorg_yaml_model_YMap__T__V = (function(map, parent) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("headers");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$2;
    var headers = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasHeaderParametersParser().init___Lorg_yaml_model_YMap__F1__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)), new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$3) {
      return (function(x$1$2) {
        var x$1 = $as_Lamf_plugins_domain_webapi_models_Parameter(x$1$2);
        $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
        $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(x$1, parent$3)
      })
    })(this, parent)), this.ctx$2).parse__sc_Seq();
    headers.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(header$2) {
        var header = $as_Lamf_plugins_domain_webapi_models_Parameter(header$2);
        var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
        var this$5 = $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(header, annotation);
        var annotation$1 = new $c_Lamf_core_annotations_DeclaredHeader().init___();
        $f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$5, annotation$1);
        this$2$1.ctx$2.declarations$4.registerHeader__Lamf_plugins_domain_webapi_models_Parameter__V(header)
      })
    })(this)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.parseWebApi__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_WebApi = (function(map) {
  $m_Lamf_plugins_document_webapi_parser_spec_common_YamlTagValidator$().validate__Lamf_core_Root__Lamf_plugins_document_webapi_contexts_WebApiContext__V(this.root$3, this.ctx$2);
  var api = $c_Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser.prototype.parseWebApi__Lorg_yaml_model_YMap__Lamf_plugins_domain_webapi_models_WebApi.call(this, map);
  var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var jsx$1 = new $c_Lamf_core_utils_package$AmfStrings().init___T("consumes").asOasExtension__T();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Accepts$1;
  var iv = this.ctx$2;
  jsx$2.key__T__F1__V(jsx$1, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(api));
  var jsx$4 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var jsx$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T("produces").asOasExtension__T();
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().ContentType$1;
  var iv$1 = this.ctx$2;
  jsx$4.key__T__F1__V(jsx$3, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(api));
  var jsx$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var jsx$5 = new $c_Lamf_core_utils_package$AmfStrings().init___T("schemes").asOasExtension__T();
  var field$2 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Schemes$1;
  var iv$2 = this.ctx$2;
  jsx$6.key__T__F1__V(jsx$5, new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(api));
  return api
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.parseLinkDeclarations__Lorg_yaml_model_YMap__T__V = (function(map, parent) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("links");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = entry.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$2;
    $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).entries$3.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$4) {
      return (function(entry$2$2) {
        var entry$2 = $as_Lorg_yaml_model_YMapEntry(entry$2$2);
        var jsx$1 = $this.ctx$2.declarations$4;
        var this$5 = new $c_Lamf_plugins_document_webapi_parser_spec_domain_OasLinkParser().init___T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(parent$4, entry$2, $this.ctx$2).parse__Lamf_plugins_domain_webapi_models_TemplatedLink();
        var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
        return jsx$1.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$5, annotation)))
      })
    })(this, parent)))
  }
});
function $as_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.oas.Oas3DocumentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.oas.Oas3DocumentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.oas.Oas3DocumentParser", {
  Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasDocumentParser: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasSpecParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_WebApiBaseSpecParser: 1,
  Lamf_core_parser_BaseSpecParser: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  Lamf_plugins_document_webapi_parser_spec_oas_OasLikeDeclarationsHelper: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_oas_Oas3DocumentParser;
function $f_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_plugins_domain_shapes_metamodel_XMLSerializerModel$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  $thiz.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$XMLSerialization$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "xmlSerialization"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "XML serialization", "information about how to serialize", $m_sci_Nil$()), true));
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  $thiz.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$Comment$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "comment"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "comment", "A comment on an item. The comment's content is expressed via the text", $m_sci_Nil$()), true));
  $m_sci_List$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "AnyShape")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$12 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$12);
    i = (((-1) + i) | 0)
  };
  var jsx$4 = result;
  var jsx$3 = $m_Lamf_core_metamodel_domain_ShapeModel$().type$1;
  var this$13 = $m_sci_List$();
  $thiz.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$type$und$eq__sci_List__V($as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$13.ReusableCBFInstance$2)))
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$() {
  $c_O.call(this);
  this.ParameterName$1 = null;
  this.Required$1 = null;
  this.Deprecated$1 = null;
  this.AllowEmptyValue$1 = null;
  this.Style$1 = null;
  this.Explode$1 = null;
  this.AllowReserved$1 = null;
  this.Binding$1 = null;
  this.Schema$1 = null;
  this.Payloads$1 = null;
  this.key$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.Description$1 = null;
  this.Examples$1 = null;
  this.Optional$1 = null;
  this.Name$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_ParameterModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_ParameterModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_templates_OptionalField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  var jsx$4 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var jsx$3 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "paramName");
  var jsx$2 = $m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1;
  var jsx$1 = $m_sc_Seq$();
  var this$3 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "name").iri__T()];
  this.ParameterName$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, jsx$3, new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq(jsx$2, "param name", "Name of a parameter", $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))), true);
  var jsx$5 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Required$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "required"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "required", "Marks the parameter as required", $m_sci_Nil$()), true);
  var jsx$6 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Document$1;
  this.Deprecated$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$6, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "deprecated"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "deprecated", "Marks the parameter as deprecated", $m_sci_Nil$()), true);
  var jsx$7 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.AllowEmptyValue$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$7, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "allowEmptyValue"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "allow empty value", "Parameter can be passed without value", $m_sci_Nil$()), true);
  var jsx$8 = $m_Lamf_core_metamodel_Type$Str$();
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Style$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$8, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "style"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "style", "Encoding style for the parameter information", $m_sci_Nil$()), true);
  var jsx$9 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$19 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Explode$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$9, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$19, "explode"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "explode", "", $m_sci_Nil$()), true);
  var jsx$10 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$22 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.AllowReserved$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$10, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$22, "allowReserved"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "allow reserved", "", $m_sci_Nil$()), true);
  var jsx$11 = $m_Lamf_core_metamodel_Type$Str$();
  var this$25 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Binding$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$11, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$25, "binding"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "binding", "Part of the Request model where the parameter can be encoded (header, path, query param, etc.)", $m_sci_Nil$()), true);
  var jsx$12 = $m_Lamf_core_metamodel_domain_ShapeModel$();
  var this$28 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.Schema$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$12, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$28, "schema"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "schema", "Schema the parameter value must validate", $m_sci_Nil$()), true);
  var jsx$13 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$());
  var this$31 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Payloads$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$13, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$31, "payload"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "payload", "", $m_sci_Nil$()), true);
  this.key$1 = this.Name$1;
  var this$34 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$34, "Parameter");
  var this$36 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$36);
  $m_sci_List$();
  var array$1 = [this.Name$1, this.ParameterName$1, this.Description$1, this.Required$1, this.Deprecated$1, this.AllowEmptyValue$1, this.Style$1, this.Explode$1, this.AllowReserved$1, this.Binding$1, this.Schema$1, this.Payloads$1, this.Examples$1];
  var i = (((-1) + $uI(array$1.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$40 = result;
    var index = i;
    var x = array$1[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$40);
    i = (((-1) + i) | 0)
  };
  var jsx$17 = result;
  var jsx$16 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().fields$1;
  var this$41 = $m_sci_List$();
  var jsx$15 = $as_sci_List(jsx$17.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$16, this$41.ReusableCBFInstance$2));
  var jsx$14 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$42 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$15.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$14, this$42.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Parameter", "Piece of data required or returned by an Operation", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype.amf$core$metamodel$domain$templates$OptionalField$$undsetter$und$Optional$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Optional$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype.amf$plugins$domain$shapes$metamodel$common$ExamplesField$$undsetter$und$Examples$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Examples$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_Parameter().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype.Optional__Lamf_core_metamodel_Field = (function() {
  return this.Optional$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_ParameterModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_ParameterModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.ParameterModel$", {
  Lamf_plugins_domain_webapi_metamodel_ParameterModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1,
  Lamf_core_metamodel_domain_templates_OptionalField: 1,
  Lamf_plugins_domain_shapes_metamodel_common_ExamplesField: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_ParameterModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_ParameterModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_ParameterModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_ParameterModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_ParameterModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$() {
  $c_O.call(this);
  this.MediaType$1 = null;
  this.SchemaMediaType$1 = null;
  this.Schema$1 = null;
  this.Encoding$1 = null;
  this.key$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.Examples$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Description$1 = null;
  this.Name$1 = null;
  this.Optional$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_PayloadModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_PayloadModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_templates_OptionalField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.MediaType$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "mediaType"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "media type", "Media types supported in the payload", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.SchemaMediaType$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "schemaMediaType"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "schemaMediaType", "Defines the format of the payload schema", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_core_metamodel_domain_ShapeModel$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.Schema$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "schema"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "schema", "Schema associated to this payload", $m_sci_Nil$()), true);
  var jsx$4 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$());
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Encoding$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "encoding"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "encoding", "An array of properties and its encoding information. The key, being the property name, must exist in the schema as a property", $m_sci_Nil$()), true);
  this.key$1 = this.MediaType$1;
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "Payload");
  var this$15 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$15);
  var x$7 = this.Name$1;
  var x$6 = this.MediaType$1;
  var x$5 = this.SchemaMediaType$1;
  var x$4 = this.Schema$1;
  var x$3 = this.Examples$1;
  var x$2 = this.Encoding$1;
  var jsx$6 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var jsx$5 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().fields$1;
  var this$16 = $m_sci_List$();
  var this$17 = $as_sci_List(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$5, this$16.ReusableCBFInstance$2));
  var this$18 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$17);
  var this$19 = new $c_sci_$colon$colon().init___O__sci_List(x$3, this$18);
  var this$20 = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$19);
  var this$21 = new $c_sci_$colon$colon().init___O__sci_List(x$5, this$20);
  var this$22 = new $c_sci_$colon$colon().init___O__sci_List(x$6, this$21);
  this.fields$1 = new $c_sci_$colon$colon().init___O__sci_List(x$7, this$22);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Payload", "Encoded payload using certain media-type", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype.amf$core$metamodel$domain$templates$OptionalField$$undsetter$und$Optional$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Optional$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype.amf$plugins$domain$shapes$metamodel$common$ExamplesField$$undsetter$und$Examples$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Examples$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_Payload().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype.Optional__Lamf_core_metamodel_Field = (function() {
  return this.Optional$1
});
$c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_PayloadModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_PayloadModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.PayloadModel$", {
  Lamf_plugins_domain_webapi_metamodel_PayloadModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_templates_OptionalField: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_plugins_domain_shapes_metamodel_common_ExamplesField: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_PayloadModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_PayloadModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_PayloadModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_PayloadModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_PayloadModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$() {
  $c_O.call(this);
  this.Definition$1 = null;
  this.type$1 = null;
  this.key$1 = null;
  this.doc$1 = null;
  this.Type$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingType__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_domain_DataNodeModel$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Definition$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "definition"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "definition", "definition of the unknown dynamic binding", $m_sci_Nil$()), true);
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "DynamicBinding");
  var this$6 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$6);
  this.key$1 = this.Type$1;
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "DynamicBinding", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingType$$undsetter$und$Type$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Type$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Definition$1, this.Type$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.DynamicBindingModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingType: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.key$1 = null;
  this.doc$1 = null;
  this.Type$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingType__$$init$__V(this);
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "EmptyBinding");
  var this$3 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$3);
  this.key$1 = this.Type$1;
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "EmptyBinding", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingType$$undsetter$und$Type$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Type$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Type$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  return result
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.EmptyBindingModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingType: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingModel: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingModel: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_EmptyBindingModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$() {
  $c_O.call(this);
  this.Method$1 = null;
  this.key$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Query$1 = null;
  this.Headers$1 = null;
  this.BindingVersion$1 = null;
  this.Type$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingType__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Method$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "method"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "method", "The HTTP method to use when establishing the connection", $m_sci_Nil$()), true);
  this.key$1 = this.Type$1;
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "WebSocketsChannelBinding");
  var this$6 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$6);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "WebSocketsChannelBinding", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingQuery$$undsetter$und$Query$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Query$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingType$$undsetter$und$Type$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Type$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Method$1, this.Query$1, this.Headers$1, this.BindingVersion$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel$().fields__sci_List();
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingVersion$$undsetter$und$BindingVersion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.BindingVersion$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$.prototype.amf$plugins$domain$webapi$metamodel$bindings$BindingHeaders$$undsetter$und$Headers$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Headers$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.bindings.WebSocketsChannelBindingModel$", {
  Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingType: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingVersion: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingHeaders: 1,
  Lamf_plugins_domain_webapi_metamodel_bindings_BindingQuery: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_WebApi() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_WebApi;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_WebApi() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_WebApi.prototype = $c_Lamf_plugins_domain_webapi_models_WebApi.prototype;
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.productPrefix__T = (function() {
  return "WebApi"
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.withServer__T__Lamf_plugins_domain_webapi_models_Server = (function(url) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_Server().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Url$1;
  var result = $as_Lamf_plugins_domain_webapi_models_Server($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, url));
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Servers$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field$1, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.withDocumentationUrl__T__Lamf_plugins_domain_shapes_models_CreativeWork = (function(url) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_CreativeWork().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Url$1;
  var result = $as_Lamf_plugins_domain_shapes_models_CreativeWork($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, url));
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Documentations$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field$1, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.removeServers__V = (function() {
  this.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Servers$1)
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.documentations__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Documentations$1))
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_WebApi)) {
    var WebApi$1 = $as_Lamf_plugins_domain_webapi_models_WebApi(x$1);
    var x = this.fields$1;
    var x$2 = WebApi$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = WebApi$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$()
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.withSecurity__T__Lamf_plugins_domain_webapi_models_security_SecurityRequirement = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$().Name$1;
  var result = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, name));
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Security$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field$1, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.componentId__T = (function() {
  return "#/web-api"
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.withServers__sc_Seq__Lamf_plugins_domain_webapi_models_ServerContainer = (function(servers) {
  var field = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Servers$1;
  return $as_Lamf_plugins_domain_webapi_models_WebApi($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this, field, servers))
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.withEndPoint__T__Lamf_plugins_domain_webapi_models_EndPoint = (function(path) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_EndPoint().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$().Path$1;
  var result = $as_Lamf_plugins_domain_webapi_models_EndPoint($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, path));
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().EndPoints$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field$1, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.withDefaultServer__T__Lamf_plugins_domain_webapi_models_Server = (function(url) {
  var this$1 = this.withServer__T__Lamf_plugins_domain_webapi_models_Server(url);
  var annotation = new $c_Lamf_core_annotations_SynthesizedField().init___();
  return $as_Lamf_plugins_domain_webapi_models_Server($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$1, annotation))
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Name$1
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.withDocumentationTitle__T__Lamf_plugins_domain_shapes_models_CreativeWork = (function(title) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_CreativeWork().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_CreativeWorkModel$().Title$1;
  var result = $as_Lamf_plugins_domain_shapes_models_CreativeWork($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, title));
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Documentations$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field$1, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  return this
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.servers__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_WebApiModel$().Servers$1))
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.sourceVendor__s_Option = (function() {
  var this$1 = this.annotations$1.find__jl_Class__s_Option($d_Lamf_core_annotations_SourceVendor.getClassOf());
  if (this$1.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var a = $as_Lamf_core_annotations_SourceVendor(arg1);
    return new $c_s_Some().init___O(a.vendor$1)
  }
});
function $as_Lamf_plugins_domain_webapi_models_WebApi(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_WebApi) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.WebApi"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_WebApi(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_WebApi)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_WebApi(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_WebApi(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.WebApi;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_WebApi = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_WebApi: 0
}, false, "amf.plugins.domain.webapi.models.WebApi", {
  Lamf_plugins_domain_webapi_models_WebApi: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_plugins_domain_webapi_models_ServerContainer: 1,
  Lamf_plugins_domain_webapi_models_DocumentedElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_WebApi.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_WebApi;
/** @constructor */
function $c_sc_AbstractTraversable() {
  $c_O.call(this)
}
$c_sc_AbstractTraversable.prototype = new $h_O();
$c_sc_AbstractTraversable.prototype.constructor = $c_sc_AbstractTraversable;
/** @constructor */
function $h_sc_AbstractTraversable() {
  /*<skip>*/
}
$h_sc_AbstractTraversable.prototype = $c_sc_AbstractTraversable.prototype;
$c_sc_AbstractTraversable.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_sc_AbstractTraversable.prototype.flatten__F1__sc_GenTraversable = (function(asTraversable) {
  return $f_scg_GenericTraversableTemplate__flatten__F1__sc_GenTraversable(this, asTraversable)
});
$c_sc_AbstractTraversable.prototype.toList__sci_List = (function() {
  var this$1 = $m_sci_List$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_sci_List($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sc_AbstractTraversable.prototype.flatMap__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__flatMap__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_sc_AbstractTraversable.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_TraversableLike__dropWhile__F1__O(this, p)
});
$c_sc_AbstractTraversable.prototype.mkString__T__T = (function(sep) {
  return this.mkString__T__T__T__T("", sep, "")
});
$c_sc_AbstractTraversable.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_sc_AbstractTraversable.prototype.withFilter__F1__scg_FilterMonadic = (function(p) {
  return new $c_sc_TraversableLike$WithFilter().init___sc_TraversableLike__F1(this, p)
});
$c_sc_AbstractTraversable.prototype.toString__T = (function() {
  return $f_sc_TraversableLike__toString__T(this)
});
$c_sc_AbstractTraversable.prototype.foldLeft__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_sc_AbstractTraversable.prototype.headOption__s_Option = (function() {
  return $f_sc_TraversableLike__headOption__s_Option(this)
});
$c_sc_AbstractTraversable.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sc_AbstractTraversable.prototype.filter__F1__O = (function(p) {
  return this.filterImpl__F1__Z__O(p, false)
});
$c_sc_AbstractTraversable.prototype.toBuffer__scm_Buffer = (function() {
  var this$1 = $m_scm_ArrayBuffer$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_scm_Buffer($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sc_AbstractTraversable.prototype.filterImpl__F1__Z__O = (function(p, isFlipped) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, isFlipped)
});
$c_sc_AbstractTraversable.prototype.size__I = (function() {
  return $f_sc_TraversableOnce__size__I(this)
});
$c_sc_AbstractTraversable.prototype.span__F1__T2 = (function(p) {
  return $f_sc_TraversableLike__span__F1__T2(this, p)
});
$c_sc_AbstractTraversable.prototype.mkString__T = (function() {
  return this.mkString__T__T("")
});
$c_sc_AbstractTraversable.prototype.filterNot__F1__O = (function(p) {
  return this.filterImpl__F1__Z__O(p, true)
});
$c_sc_AbstractTraversable.prototype.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_sc_AbstractTraversable.prototype.sizeHintIfCheap__I = (function() {
  return (-1)
});
$c_sc_AbstractTraversable.prototype.partition__F1__T2 = (function(p) {
  return $f_sc_TraversableLike__partition__F1__T2(this, p)
});
$c_sc_AbstractTraversable.prototype.last__O = (function() {
  return $f_sc_TraversableLike__last__O(this)
});
$c_sc_AbstractTraversable.prototype.tail__O = (function() {
  return $f_sc_TraversableLike__tail__O(this)
});
$c_sc_AbstractTraversable.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_sc_AbstractTraversable.prototype.toTraversable__sc_Traversable = (function() {
  return this.thisCollection__sc_Traversable()
});
$c_sc_AbstractTraversable.prototype.toSeq__sc_Seq = (function() {
  return this.toStream__sci_Stream()
});
$c_sc_AbstractTraversable.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sc_AbstractTraversable.prototype.$$div$colon__O__F2__O = (function(z, op) {
  return this.foldLeft__O__F2__O(z, op)
});
$c_sc_AbstractTraversable.prototype.repr__O = (function() {
  return this
});
$c_sc_AbstractTraversable.prototype.toSeq__sc_GenSeq = (function() {
  return this.toSeq__sc_Seq()
});
$c_sc_AbstractTraversable.prototype.isTraversableAgain__Z = (function() {
  return true
});
$c_sc_AbstractTraversable.prototype.groupBy__F1__sci_Map = (function(f) {
  return $f_sc_TraversableLike__groupBy__F1__sci_Map(this, f)
});
$c_sc_AbstractTraversable.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  this.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$1, ev$1) {
    return (function(x$2) {
      return b$1.$$plus$eq__O__scm_Builder(x$2)
    })
  })(this, b, ev)));
  return $as_sci_Map(b.elems$1)
});
$c_sc_AbstractTraversable.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_sc_AbstractTraversable.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_sc_TraversableOnce__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_sc_AbstractTraversable.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_sc_AbstractTraversable.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_TraversableOnce__reduceLeft__F2__O(this, op)
});
$c_sc_AbstractTraversable.prototype.collect__s_PartialFunction__scg_CanBuildFrom__O = (function(pf, bf) {
  return $f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this, pf, bf)
});
$c_sc_AbstractTraversable.prototype.newBuilder__scm_Builder = (function() {
  return this.companion__scg_GenericCompanion().newBuilder__scm_Builder()
});
$c_sc_AbstractTraversable.prototype.stringPrefix__T = (function() {
  return $f_sc_TraversableLike__stringPrefix__T(this)
});
function $f_sc_SeqLike__lengthCompare__I__I($thiz, len) {
  if ((len < 0)) {
    return 1
  } else {
    var i = 0;
    var it = $thiz.iterator__sc_Iterator();
    while (it.hasNext__Z()) {
      if ((i === len)) {
        return (it.hasNext__Z() ? 1 : 0)
      };
      it.next__O();
      i = ((1 + i) | 0)
    };
    return ((i - len) | 0)
  }
}
function $f_sc_SeqLike__isEmpty__Z($thiz) {
  return ($thiz.lengthCompare__I__I(0) === 0)
}
function $f_sc_SeqLike__$$colon$plus__O__scg_CanBuildFrom__O($thiz, elem, bf) {
  var b = bf.apply__O__scm_Builder($thiz.repr__O());
  b.$$plus$plus$eq__sc_TraversableOnce__scg_Growable($thiz.thisCollection__sc_Seq());
  b.$$plus$eq__O__scm_Builder(elem);
  return b.result__O()
}
function $f_sc_SeqLike__sorted__s_math_Ordering__O($thiz, ord) {
  var len = $thiz.length__I();
  var b = $thiz.newBuilder__scm_Builder();
  if ((len === 1)) {
    b.$$plus$plus$eq__sc_TraversableOnce__scg_Growable($thiz)
  } else if ((len > 1)) {
    b.sizeHint__I__V(len);
    var arr = $newArrayObject($d_O.getArrayOf(), [len]);
    var i = new $c_sr_IntRef().init___I(0);
    $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, arr$1, i$1) {
      return (function(x$2) {
        arr$1.set(i$1.elem$1, x$2);
        i$1.elem$1 = ((1 + i$1.elem$1) | 0)
      })
    })($thiz, arr, i)));
    $m_ju_Arrays$().sort__AO__ju_Comparator__V(arr, ord);
    i.elem$1 = 0;
    while ((i.elem$1 < arr.u.length)) {
      b.$$plus$eq__O__scm_Builder(arr.get(i.elem$1));
      i.elem$1 = ((1 + i.elem$1) | 0)
    }
  };
  return b.result__O()
}
function $f_sc_SeqLike__indexWhere__F1__I__I($thiz, p, from) {
  var i = ((from > 0) ? from : 0);
  var it = $thiz.iterator__sc_Iterator().drop__I__sc_Iterator(from);
  while (it.hasNext__Z()) {
    if ($uZ(p.apply__O__O(it.next__O()))) {
      return i
    } else {
      i = ((1 + i) | 0)
    }
  };
  return (-1)
}
function $f_sc_SeqLike__intersect__sc_GenSeq__O($thiz, that) {
  var sq = that.seq__sc_Seq();
  var occ = $f_sc_SeqLike__occCounts__psc_SeqLike__sc_Seq__scm_Map($thiz, sq);
  var b = $thiz.newBuilder__scm_Builder();
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, occ$1, b$1) {
    return (function(x$2) {
      var ox = $uI(occ$1.apply__O__O(x$2));
      if ((ox > 0)) {
        b$1.$$plus$eq__O__scm_Builder(x$2);
        occ$1.update__O__O__V(x$2, (((-1) + ox) | 0))
      }
    })
  })($thiz, occ, b)));
  return b.result__O()
}
function $f_sc_SeqLike__reverse__O($thiz) {
  var elem = $m_sci_Nil$();
  var xs = new $c_sr_ObjectRef().init___O(elem);
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, xs$1) {
    return (function(x$2) {
      var this$2 = $as_sci_List(xs$1.elem$1);
      xs$1.elem$1 = new $c_sci_$colon$colon().init___O__sci_List(x$2, this$2)
    })
  })($thiz, xs)));
  var b = $thiz.newBuilder__scm_Builder();
  $f_scm_Builder__sizeHint__sc_TraversableLike__V(b, $thiz);
  var this$3 = $as_sci_List(xs.elem$1);
  var these = this$3;
  while ((!these.isEmpty__Z())) {
    var arg1 = these.head__O();
    b.$$plus$eq__O__scm_Builder(arg1);
    these = $as_sci_List(these.tail__O())
  };
  return b.result__O()
}
function $f_sc_SeqLike__distinct__O($thiz) {
  var isImmutable = $is_sci_Seq($thiz);
  if ((isImmutable && ($thiz.lengthCompare__I__I(1) <= 0))) {
    return $thiz.repr__O()
  } else {
    var b = $thiz.newBuilder__scm_Builder();
    var seen = new $c_scm_HashSet().init___();
    var it = $thiz.iterator__sc_Iterator();
    var different = false;
    while (it.hasNext__Z()) {
      var next = it.next__O();
      if ($f_scm_FlatHashTable__addElem__O__Z(seen, next)) {
        b.$$plus$eq__O__scm_Builder(next)
      } else {
        different = true
      }
    };
    return ((different || (!isImmutable)) ? b.result__O() : $thiz.repr__O())
  }
}
function $f_sc_SeqLike__$$plus$colon__O__scg_CanBuildFrom__O($thiz, elem, bf) {
  var b = bf.apply__O__scm_Builder($thiz.repr__O());
  b.$$plus$eq__O__scm_Builder(elem);
  b.$$plus$plus$eq__sc_TraversableOnce__scg_Growable($thiz.thisCollection__sc_Seq());
  return b.result__O()
}
function $f_sc_SeqLike__diff__sc_GenSeq__O($thiz, that) {
  var sq = that.seq__sc_Seq();
  var occ = $f_sc_SeqLike__occCounts__psc_SeqLike__sc_Seq__scm_Map($thiz, sq);
  var b = $thiz.newBuilder__scm_Builder();
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, occ$1, b$1) {
    return (function(x$2) {
      var ox = $uI(occ$1.apply__O__O(x$2));
      return ((ox === 0) ? b$1.$$plus$eq__O__scm_Builder(x$2) : (occ$1.update__O__O__V(x$2, (((-1) + ox) | 0)), (void 0)))
    })
  })($thiz, occ, b)));
  return b.result__O()
}
function $f_sc_SeqLike__occCounts__psc_SeqLike__sc_Seq__scm_Map($thiz, sq) {
  var occ = new $c_sc_SeqLike$$anon$1().init___sc_SeqLike($thiz);
  sq.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, occ$1) {
    return (function(y$2) {
      var value = ((1 + $uI(occ$1.apply__O__O(y$2))) | 0);
      occ$1.put__O__O__s_Option(y$2, value)
    })
  })($thiz, occ)));
  return occ
}
function $f_sc_SeqLike__contains__O__Z($thiz, elem) {
  return $thiz.exists__F1__Z(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, elem$1) {
    return (function(x$12$2) {
      return $m_sr_BoxesRunTime$().equals__O__O__Z(x$12$2, elem$1)
    })
  })($thiz, elem)))
}
function $f_sc_SeqLike__sortBy__F1__s_math_Ordering__O($thiz, f, ord) {
  return $thiz.sorted__s_math_Ordering__O(new $c_s_math_Ordering$$anon$2().init___s_math_Ordering__F1(ord, f))
}
function $f_sc_SeqLike__segmentLength__F1__I__I($thiz, p, from) {
  var i = 0;
  var it = $thiz.iterator__sc_Iterator().drop__I__sc_Iterator(from);
  while ((it.hasNext__Z() && $uZ(p.apply__O__O(it.next__O())))) {
    i = ((1 + i) | 0)
  };
  return i
}
function $f_sc_SeqLike__sortWith__F2__O($thiz, lt) {
  return $thiz.sorted__s_math_Ordering__O(new $c_s_math_Ordering$$anon$6().init___F2(lt))
}
function $is_sc_SeqLike(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_SeqLike)))
}
function $as_sc_SeqLike(obj) {
  return (($is_sc_SeqLike(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.SeqLike"))
}
function $isArrayOf_sc_SeqLike(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_SeqLike)))
}
function $asArrayOf_sc_SeqLike(obj, depth) {
  return (($isArrayOf_sc_SeqLike(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.SeqLike;", depth))
}
function $f_sc_TraversableViewLike__init__sc_TraversableView($thiz) {
  var xs = $thiz.newSliced__scg_SliceInterval__sc_TraversableViewLike$Transformed($m_scg_SliceInterval$().apply__I__I__scg_SliceInterval(0, (((-1) + $thiz.length__I()) | 0)));
  return xs
}
function $f_sc_TraversableViewLike__takeWhile__F1__sc_TraversableView($thiz, p) {
  var xs = $thiz.newTakenWhile__F1__sc_TraversableViewLike$Transformed(p);
  return xs
}
function $f_sc_TraversableViewLike__withFilter__F1__sc_TraversableView($thiz, p) {
  var xs = $thiz.newFiltered__F1__sc_TraversableViewLike$Transformed(p);
  return xs
}
function $f_sc_TraversableViewLike__span__F1__T2($thiz, p) {
  var xs = $thiz.newTakenWhile__F1__sc_TraversableViewLike$Transformed(p);
  var xs$1 = $thiz.newDroppedWhile__F1__sc_TraversableViewLike$Transformed(p);
  return new $c_T2().init___O__O(xs, xs$1)
}
function $f_sc_TraversableViewLike__dropWhile__F1__sc_TraversableView($thiz, p) {
  var xs = $thiz.newDroppedWhile__F1__sc_TraversableViewLike$Transformed(p);
  return xs
}
function $f_sc_TraversableViewLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O($thiz, xs, bf) {
  return $thiz.newAppended__sc_GenTraversable__sc_TraversableViewLike$Transformed(xs.seq__sc_TraversableOnce().toTraversable__sc_Traversable())
}
function $f_sc_TraversableViewLike__partition__F1__T2($thiz, p) {
  var xs = $thiz.newFiltered__F1__sc_TraversableViewLike$Transformed(p);
  var xs$1 = $thiz.newFiltered__F1__sc_TraversableViewLike$Transformed(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, p$1) {
    return (function(x$1$2) {
      return (!$uZ(p$1.apply__O__O(x$1$2)))
    })
  })($thiz, p)));
  return new $c_T2().init___O__O(xs, xs$1)
}
function $f_sc_TraversableViewLike__viewToString__T($thiz) {
  return ((("" + $thiz.stringPrefix__T()) + $thiz.viewIdString__T()) + "(...)")
}
function $f_sc_TraversableViewLike__filter__F1__sc_TraversableView($thiz, p) {
  var xs = $thiz.newFiltered__F1__sc_TraversableViewLike$Transformed(p);
  return xs
}
function $f_sc_TraversableViewLike__groupBy__F1__sci_Map($thiz, f) {
  var this$1 = $f_sc_ViewMkString__thisSeq__sc_Seq($thiz).groupBy__F1__sci_Map(f);
  var f$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(xs$2) {
      var xs = $as_sc_Seq(xs$2);
      var xs$3 = $this.newForced__F0__sc_TraversableViewLike$Transformed(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this$1, xs$1) {
        return (function() {
          return xs$1
        })
      })($this, xs)));
      return xs$3
    })
  })($thiz));
  return new $c_sci_MapLike$$anon$2().init___sci_MapLike__F1(this$1, f$1)
}
function $f_sc_TraversableViewLike__filterNot__F1__sc_TraversableView($thiz, p) {
  var xs = $thiz.newFiltered__F1__sc_TraversableViewLike$Transformed(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, p$1) {
    return (function(a$2) {
      return (!$uZ(p$1.apply__O__O(a$2)))
    })
  })($thiz, p)));
  return xs
}
function $f_sc_TraversableViewLike__collect__s_PartialFunction__scg_CanBuildFrom__O($thiz, pf, bf) {
  var this$1 = $thiz.filter__F1__sc_TraversableView(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, pf$1) {
    return (function(x$2) {
      return pf$1.isDefinedAt__O__Z(x$2)
    })
  })($thiz, pf)));
  return this$1.newMapped__F1__sc_TraversableViewLike$Transformed(pf)
}
function $f_sc_TraversableViewLike__newBuilder__scm_Builder($thiz) {
  throw new $c_jl_UnsupportedOperationException().init___T($m_s_Predef$any2stringadd$().$$plus$extension__O__T__T($thiz, ".newBuilder"))
}
function $f_sc_TraversableViewLike__tail__sc_TraversableView($thiz) {
  if ($thiz.isEmpty__Z()) {
    return $thiz.scala$collection$TraversableViewLike$$super$tail__sc_TraversableView()
  } else {
    var xs = $f_sc_SeqViewLike__newDropped__I__sc_SeqViewLike$Transformed($thiz, 1);
    return xs
  }
}
function $is_sc_TraversableViewLike(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_TraversableViewLike)))
}
function $as_sc_TraversableViewLike(obj) {
  return (($is_sc_TraversableViewLike(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.TraversableViewLike"))
}
function $isArrayOf_sc_TraversableViewLike(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_TraversableViewLike)))
}
function $asArrayOf_sc_TraversableViewLike(obj, depth) {
  return (($isArrayOf_sc_TraversableViewLike(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.TraversableViewLike;", depth))
}
/** @constructor */
function $c_sr_RichLong() {
  $c_O.call(this);
  this.self$1 = $m_sjsr_RuntimeLong$().Zero__sjsr_RuntimeLong()
}
$c_sr_RichLong.prototype = new $h_O();
$c_sr_RichLong.prototype.constructor = $c_sr_RichLong;
/** @constructor */
function $h_sr_RichLong() {
  /*<skip>*/
}
$h_sr_RichLong.prototype = $c_sr_RichLong.prototype;
$c_sr_RichLong.prototype.isValidInt__Z = (function() {
  return $m_sr_RichLong$().isValidInt$extension__J__Z(this.self$1)
});
$c_sr_RichLong.prototype.longValue__J = (function() {
  var t = this.self$1;
  var lo = t.lo$2;
  var hi = t.hi$2;
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi)
});
$c_sr_RichLong.prototype.isValidShort__Z = (function() {
  return $m_sr_RichLong$().isValidShort$extension__J__Z(this.self$1)
});
$c_sr_RichLong.prototype.byteValue__B = (function() {
  return $m_sr_RichLong$().byteValue$extension__J__B(this.self$1)
});
$c_sr_RichLong.prototype.init___J = (function(self) {
  this.self$1 = self;
  return this
});
$c_sr_RichLong.prototype.equals__O__Z = (function(x$1) {
  return $m_sr_RichLong$().equals$extension__J__O__Z(this.self$1, x$1)
});
$c_sr_RichLong.prototype.isValidChar__Z = (function() {
  return $m_sr_RichLong$().isValidChar$extension__J__Z(this.self$1)
});
$c_sr_RichLong.prototype.toString__T = (function() {
  return $f_s_Proxy__toString__T(this)
});
$c_sr_RichLong.prototype.compareTo__O__I = (function(that) {
  var t$1 = this.self$1;
  var lo$1 = t$1.lo$2;
  var hi$1 = t$1.hi$2;
  var t$2 = $uJ(new $c_sjsr_RuntimeLong().init___I__I(lo$1, hi$1));
  var lo$2 = t$2.lo$2;
  var hi$2 = t$2.hi$2;
  var t$3 = $uJ(that);
  var lo$3 = t$3.lo$2;
  var hi$3 = t$3.hi$2;
  return $m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$compare__I__I__I__I__I(lo$2, hi$2, lo$3, hi$3)
});
$c_sr_RichLong.prototype.isValidByte__Z = (function() {
  return $m_sr_RichLong$().isValidByte$extension__J__Z(this.self$1)
});
$c_sr_RichLong.prototype.compare__O__I = (function(y) {
  var t$1 = this.self$1;
  var lo$1 = t$1.lo$2;
  var hi$1 = t$1.hi$2;
  var t$2 = $uJ(new $c_sjsr_RuntimeLong().init___I__I(lo$1, hi$1));
  var lo$2 = t$2.lo$2;
  var hi$2 = t$2.hi$2;
  var t$3 = $uJ(y);
  var lo$3 = t$3.lo$2;
  var hi$3 = t$3.hi$2;
  return $m_sjsr_RuntimeLong$().scala$scalajs$runtime$RuntimeLong$$compare__I__I__I__I__I(lo$2, hi$2, lo$3, hi$3)
});
$c_sr_RichLong.prototype.self__O = (function() {
  return this.self$1
});
$c_sr_RichLong.prototype.shortValue__S = (function() {
  return $m_sr_RichLong$().shortValue$extension__J__S(this.self$1)
});
$c_sr_RichLong.prototype.doubleValue__D = (function() {
  return $m_sr_RichLong$().doubleValue$extension__J__D(this.self$1)
});
$c_sr_RichLong.prototype.hashCode__I = (function() {
  var t = this.self$1;
  var lo = t.lo$2;
  var hi = t.hi$2;
  return (lo ^ hi)
});
$c_sr_RichLong.prototype.intValue__I = (function() {
  return $m_sr_RichLong$().intValue$extension__J__I(this.self$1)
});
$c_sr_RichLong.prototype.floatValue__F = (function() {
  return $m_sr_RichLong$().floatValue$extension__J__F(this.self$1)
});
function $as_sr_RichLong(obj) {
  return (((obj instanceof $c_sr_RichLong) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.runtime.RichLong"))
}
function $isArrayOf_sr_RichLong(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sr_RichLong)))
}
function $asArrayOf_sr_RichLong(obj, depth) {
  return (($isArrayOf_sr_RichLong(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.runtime.RichLong;", depth))
}
var $d_sr_RichLong = new $TypeData().initClass({
  sr_RichLong: 0
}, false, "scala.runtime.RichLong", {
  sr_RichLong: 1,
  O: 1,
  sr_IntegralProxy: 1,
  sr_ScalaWholeNumberProxy: 1,
  sr_ScalaNumberProxy: 1,
  s_math_ScalaNumericAnyConversions: 1,
  s_Proxy$Typed: 1,
  s_Proxy: 1,
  sr_OrderedProxy: 1,
  s_math_Ordered: 1,
  jl_Comparable: 1,
  sr_RangedProxy: 1
});
$c_sr_RichLong.prototype.$classData = $d_sr_RichLong;
/** @constructor */
function $c_Lamf_client_model_document_Extension() {
  $c_Lamf_client_model_document_Document.call(this)
}
$c_Lamf_client_model_document_Extension.prototype = new $h_Lamf_client_model_document_Document();
$c_Lamf_client_model_document_Extension.prototype.constructor = $c_Lamf_client_model_document_Extension;
/** @constructor */
function $h_Lamf_client_model_document_Extension() {
  /*<skip>*/
}
$h_Lamf_client_model_document_Extension.prototype = $c_Lamf_client_model_document_Extension.prototype;
$c_Lamf_client_model_document_Extension.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_document_Extension.prototype.init___Lamf_plugins_document_webapi_model_Extension.call(this, new $c_Lamf_plugins_document_webapi_model_Extension().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_document_Extension.prototype.productPrefix__T = (function() {
  return "Extension"
});
$c_Lamf_client_model_document_Extension.prototype.$$undinternal__Lamf_core_model_document_Document = (function() {
  return $as_Lamf_plugins_document_webapi_model_Extension(this.$$undinternal$1)
});
$c_Lamf_client_model_document_Extension.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_document_Extension.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_document_Extension)) {
    var Extension$1 = $as_Lamf_client_model_document_Extension(x$1);
    var x = $as_Lamf_plugins_document_webapi_model_Extension(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_document_webapi_model_Extension(Extension$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_document_Extension.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_document_webapi_model_Extension(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_document_Extension.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_document_Extension.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return $as_Lamf_plugins_document_webapi_model_Extension(this.$$undinternal$1)
});
$c_Lamf_client_model_document_Extension.prototype.$$undinternal__Lamf_core_model_document_EncodesModel = (function() {
  return $as_Lamf_plugins_document_webapi_model_Extension(this.$$undinternal$1)
});
$c_Lamf_client_model_document_Extension.prototype.$$undinternal__Lamf_core_model_document_DeclaresModel = (function() {
  return $as_Lamf_plugins_document_webapi_model_Extension(this.$$undinternal$1)
});
$c_Lamf_client_model_document_Extension.prototype.init___Lamf_plugins_document_webapi_model_Extension = (function(_internal) {
  $c_Lamf_client_model_document_Document.prototype.init___Lamf_core_model_document_Document.call(this, _internal);
  return this
});
$c_Lamf_client_model_document_Extension.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_document_webapi_model_Extension(this.$$undinternal$1)
});
$c_Lamf_client_model_document_Extension.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_document_Extension.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_client_model_document_Extension(obj) {
  return (((obj instanceof $c_Lamf_client_model_document_Extension) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.document.Extension"))
}
function $isArrayOf_Lamf_client_model_document_Extension(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_document_Extension)))
}
function $asArrayOf_Lamf_client_model_document_Extension(obj, depth) {
  return (($isArrayOf_Lamf_client_model_document_Extension(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.document.Extension;", depth))
}
var $d_Lamf_client_model_document_Extension = new $TypeData().initClass({
  Lamf_client_model_document_Extension: 0
}, false, "amf.client.model.document.Extension", {
  Lamf_client_model_document_Extension: 1,
  Lamf_client_model_document_Document: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_EncodesModel: 1,
  Lamf_client_model_document_DeclaresModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_document_Extension.prototype.$classData = $d_Lamf_client_model_document_Extension;
/** @constructor */
function $c_Lamf_client_model_document_Overlay() {
  $c_Lamf_client_model_document_Document.call(this)
}
$c_Lamf_client_model_document_Overlay.prototype = new $h_Lamf_client_model_document_Document();
$c_Lamf_client_model_document_Overlay.prototype.constructor = $c_Lamf_client_model_document_Overlay;
/** @constructor */
function $h_Lamf_client_model_document_Overlay() {
  /*<skip>*/
}
$h_Lamf_client_model_document_Overlay.prototype = $c_Lamf_client_model_document_Overlay.prototype;
$c_Lamf_client_model_document_Overlay.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_document_Overlay.prototype.init___Lamf_plugins_document_webapi_model_Overlay.call(this, new $c_Lamf_plugins_document_webapi_model_Overlay().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_document_Overlay.prototype.productPrefix__T = (function() {
  return "Overlay"
});
$c_Lamf_client_model_document_Overlay.prototype.$$undinternal__Lamf_core_model_document_Document = (function() {
  return $as_Lamf_plugins_document_webapi_model_Overlay(this.$$undinternal$1)
});
$c_Lamf_client_model_document_Overlay.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_document_Overlay.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_document_Overlay)) {
    var Overlay$1 = $as_Lamf_client_model_document_Overlay(x$1);
    var x = $as_Lamf_plugins_document_webapi_model_Overlay(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_document_webapi_model_Overlay(Overlay$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_document_Overlay.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_document_webapi_model_Overlay(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_document_Overlay.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_document_Overlay.prototype.$$undinternal__Lamf_core_model_document_BaseUnit = (function() {
  return $as_Lamf_plugins_document_webapi_model_Overlay(this.$$undinternal$1)
});
$c_Lamf_client_model_document_Overlay.prototype.$$undinternal__Lamf_core_model_document_EncodesModel = (function() {
  return $as_Lamf_plugins_document_webapi_model_Overlay(this.$$undinternal$1)
});
$c_Lamf_client_model_document_Overlay.prototype.$$undinternal__Lamf_core_model_document_DeclaresModel = (function() {
  return $as_Lamf_plugins_document_webapi_model_Overlay(this.$$undinternal$1)
});
$c_Lamf_client_model_document_Overlay.prototype.init___Lamf_plugins_document_webapi_model_Overlay = (function(_internal) {
  $c_Lamf_client_model_document_Document.prototype.init___Lamf_core_model_document_Document.call(this, _internal);
  return this
});
$c_Lamf_client_model_document_Overlay.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_document_webapi_model_Overlay(this.$$undinternal$1)
});
$c_Lamf_client_model_document_Overlay.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_document_Overlay.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_client_model_document_Overlay(obj) {
  return (((obj instanceof $c_Lamf_client_model_document_Overlay) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.document.Overlay"))
}
function $isArrayOf_Lamf_client_model_document_Overlay(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_document_Overlay)))
}
function $asArrayOf_Lamf_client_model_document_Overlay(obj, depth) {
  return (($isArrayOf_Lamf_client_model_document_Overlay(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.document.Overlay;", depth))
}
var $d_Lamf_client_model_document_Overlay = new $TypeData().initClass({
  Lamf_client_model_document_Overlay: 0
}, false, "amf.client.model.document.Overlay", {
  Lamf_client_model_document_Overlay: 1,
  Lamf_client_model_document_Document: 1,
  O: 1,
  Lamf_client_model_document_BaseUnit: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_document_EncodesModel: 1,
  Lamf_client_model_document_DeclaresModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_document_Overlay.prototype.$classData = $d_Lamf_client_model_document_Overlay;
/** @constructor */
function $c_Lamf_client_model_domain_Amqp091ChannelBinding() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype = new $h_O();
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.constructor = $c_Lamf_client_model_domain_Amqp091ChannelBinding;
/** @constructor */
function $h_Lamf_client_model_domain_Amqp091ChannelBinding() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_Amqp091ChannelBinding.prototype = $c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype;
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$meth$withIs__T__O = (function(is) {
  return this.withIs__T__Lamf_client_model_domain_Amqp091ChannelBinding(is)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$prop$is__O = (function() {
  return this.is__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.productPrefix__T = (function() {
  return "Amqp091ChannelBinding"
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding.call(this, new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.queue__Lamf_client_model_domain_Amqp091Queue = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$().Queue$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().Amqp091QueueMatcher__Lamf_client_convert_Amqp091QueueConverter$Amqp091QueueMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091Queue__Lamf_client_model_domain_Amqp091Queue(from)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_Amqp091ChannelBinding)) {
    var Amqp091ChannelBinding$1 = $as_Lamf_client_model_domain_Amqp091ChannelBinding(x$1);
    var x = this.$$undinternal$1;
    var x$2 = Amqp091ChannelBinding$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.exchange__Lamf_client_model_domain_Amqp091ChannelExchange = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$().Exchange$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().Amqp091ChannelExchangeMatcher__Lamf_client_convert_Amqp091ChannelExchangeConverter$Amqp091ChannelExchangeMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelExchange__Lamf_client_model_domain_Amqp091ChannelExchange(from)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$meth$withExchange__Lamf_client_model_domain_Amqp091ChannelExchange__O = (function(exchange) {
  return this.withExchange__Lamf_client_model_domain_Amqp091ChannelExchange__Lamf_client_model_domain_Amqp091ChannelBinding(exchange)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.withExchange__Lamf_client_model_domain_Amqp091ChannelExchange__Lamf_client_model_domain_Amqp091ChannelBinding = (function(exchange) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().Amqp091ChannelExchangeMatcher__Lamf_client_convert_Amqp091ChannelExchangeConverter$Amqp091ChannelExchangeMatcher$();
  var exchange$1 = exchange.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$().Exchange$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, exchange$1));
  return this
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.withQueue__Lamf_client_model_domain_Amqp091Queue__Lamf_client_model_domain_Amqp091ChannelBinding = (function(queue) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().Amqp091QueueMatcher__Lamf_client_convert_Amqp091QueueConverter$Amqp091QueueMatcher$();
  var queue$1 = queue.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$().Queue$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, queue$1));
  return this
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$meth$withBindingVersion__T__O = (function(bindingVersion) {
  return this.withBindingVersion__T__Lamf_client_model_domain_Amqp091ChannelBinding(bindingVersion)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$meth$withQueue__Lamf_client_model_domain_Amqp091Queue__O = (function(queue) {
  return this.withQueue__Lamf_client_model_domain_Amqp091Queue__Lamf_client_model_domain_Amqp091ChannelBinding(queue)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_Amqp091ChannelBinding()
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.withIs__T__Lamf_client_model_domain_Amqp091ChannelBinding = (function(is) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$().Is$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, is));
  return this
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_ChannelBinding = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_Amqp091ChannelBinding()
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.is__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$().Is$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.linkCopy__Lamf_client_model_domain_Amqp091ChannelBinding = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$5 = new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().Amqp091ChannelBindingMatcher__Lamf_client_convert_Amqp091ChannelBindingConverter$Amqp091ChannelBindingMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091ChannelBinding__Lamf_client_model_domain_Amqp091ChannelBinding(from)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$prop$queue__O = (function() {
  return this.queue__Lamf_client_model_domain_Amqp091Queue()
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.withBindingVersion__T__Lamf_client_model_domain_Amqp091ChannelBinding = (function(bindingVersion) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091ChannelBindingModel$().BindingVersion$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_BindingVersion($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, bindingVersion));
  return this
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$prop$exchange__O = (function() {
  return this.exchange__Lamf_client_model_domain_Amqp091ChannelExchange()
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.withQueue = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Amqp091Queue(arg);
  return this.$$js$exported$meth$withQueue__Lamf_client_model_domain_Amqp091Queue__O(prep)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.withExchange = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Amqp091ChannelExchange(arg);
  return this.$$js$exported$meth$withExchange__Lamf_client_model_domain_Amqp091ChannelExchange__O(prep)
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.withIs = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withIs__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype, "queue", {
  "get": (function() {
    return this.$$js$exported$prop$queue__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype, "exchange", {
  "get": (function() {
    return this.$$js$exported$prop$exchange__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype, "is", {
  "get": (function() {
    return this.$$js$exported$prop$is__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.withBindingVersion = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withBindingVersion__T__O(prep)
});
function $as_Lamf_client_model_domain_Amqp091ChannelBinding(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_Amqp091ChannelBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Amqp091ChannelBinding"))
}
function $isArrayOf_Lamf_client_model_domain_Amqp091ChannelBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Amqp091ChannelBinding)))
}
function $asArrayOf_Lamf_client_model_domain_Amqp091ChannelBinding(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Amqp091ChannelBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Amqp091ChannelBinding;", depth))
}
var $d_Lamf_client_model_domain_Amqp091ChannelBinding = new $TypeData().initClass({
  Lamf_client_model_domain_Amqp091ChannelBinding: 0
}, false, "amf.client.model.domain.Amqp091ChannelBinding", {
  Lamf_client_model_domain_Amqp091ChannelBinding: 1,
  O: 1,
  Lamf_client_model_domain_ChannelBinding: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_BindingVersion: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.$classData = $d_Lamf_client_model_domain_Amqp091ChannelBinding;
/** @constructor */
function $c_Lamf_client_model_domain_Amqp091MessageBinding() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype = new $h_O();
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.constructor = $c_Lamf_client_model_domain_Amqp091MessageBinding;
/** @constructor */
function $h_Lamf_client_model_domain_Amqp091MessageBinding() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_Amqp091MessageBinding.prototype = $c_Lamf_client_model_domain_Amqp091MessageBinding.prototype;
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.contentEncoding__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$().ContentEncoding$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.productPrefix__T = (function() {
  return "Amqp091MessageBinding"
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding.call(this, new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$prop$messageType__O = (function() {
  return this.messageType__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.messageType__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$().MessageType$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_Amqp091MessageBinding)) {
    var Amqp091MessageBinding$1 = $as_Lamf_client_model_domain_Amqp091MessageBinding(x$1);
    var x = this.$$undinternal$1;
    var x$2 = Amqp091MessageBinding$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$prop$contentEncoding__O = (function() {
  return this.contentEncoding__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$meth$withBindingVersion__T__O = (function(bindingVersion) {
  return this.withBindingVersion__T__Lamf_client_model_domain_Amqp091MessageBinding(bindingVersion)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$meth$withMessageType__T__O = (function(messageType) {
  return this.withMessageType__T__Lamf_client_model_domain_Amqp091MessageBinding(messageType)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$meth$withContentEncoding__T__O = (function(contentEncoding) {
  return this.withContentEncoding__T__Lamf_client_model_domain_Amqp091MessageBinding(contentEncoding)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.withMessageType__T__Lamf_client_model_domain_Amqp091MessageBinding = (function(messageType) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$().MessageType$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, messageType));
  return this
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_Amqp091MessageBinding()
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_Amqp091MessageBinding()
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_MessageBinding = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.linkCopy__Lamf_client_model_domain_Amqp091MessageBinding = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$5 = new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().Amqp091MessageBindingMatcher__Lamf_client_convert_Amqp091MessageBindingConverter$Amqp091MessageBindingMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding__Lamf_client_model_domain_Amqp091MessageBinding(from)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.withContentEncoding__T__Lamf_client_model_domain_Amqp091MessageBinding = (function(contentEncoding) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$().ContentEncoding$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091MessageBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, contentEncoding));
  return this
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.withBindingVersion__T__Lamf_client_model_domain_Amqp091MessageBinding = (function(bindingVersion) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091MessageBindingModel$().BindingVersion$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_BindingVersion($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, bindingVersion));
  return this
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091MessageBinding.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091MessageBinding.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091MessageBinding.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091MessageBinding.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091MessageBinding.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091MessageBinding.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091MessageBinding.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091MessageBinding.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.withMessageType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withMessageType__T__O(prep)
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.withContentEncoding = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withContentEncoding__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091MessageBinding.prototype, "messageType", {
  "get": (function() {
    return this.$$js$exported$prop$messageType__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091MessageBinding.prototype, "contentEncoding", {
  "get": (function() {
    return this.$$js$exported$prop$contentEncoding__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.withBindingVersion = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withBindingVersion__T__O(prep)
});
function $as_Lamf_client_model_domain_Amqp091MessageBinding(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_Amqp091MessageBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Amqp091MessageBinding"))
}
function $isArrayOf_Lamf_client_model_domain_Amqp091MessageBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Amqp091MessageBinding)))
}
function $asArrayOf_Lamf_client_model_domain_Amqp091MessageBinding(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Amqp091MessageBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Amqp091MessageBinding;", depth))
}
var $d_Lamf_client_model_domain_Amqp091MessageBinding = new $TypeData().initClass({
  Lamf_client_model_domain_Amqp091MessageBinding: 0
}, false, "amf.client.model.domain.Amqp091MessageBinding", {
  Lamf_client_model_domain_Amqp091MessageBinding: 1,
  O: 1,
  Lamf_client_model_domain_MessageBinding: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_BindingVersion: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.$classData = $d_Lamf_client_model_domain_Amqp091MessageBinding;
/** @constructor */
function $c_Lamf_client_model_domain_Amqp091OperationBinding() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype = new $h_O();
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.constructor = $c_Lamf_client_model_domain_Amqp091OperationBinding;
/** @constructor */
function $h_Lamf_client_model_domain_Amqp091OperationBinding() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_Amqp091OperationBinding.prototype = $c_Lamf_client_model_domain_Amqp091OperationBinding.prototype;
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$prop$userId__O = (function() {
  return this.userId__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withDeliveryMode__I__Lamf_client_model_domain_Amqp091OperationBinding = (function(deliveryMode) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().DeliveryMode$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject(this$1, field, deliveryMode));
  return this
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.productPrefix__T = (function() {
  return "Amqp091OperationBinding"
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding.call(this, new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$prop$bcc__O = (function() {
  return this.bcc__sjs_js_Array()
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$withCc__sc_Seq__O = (function(cC) {
  return this.withCc__sc_Seq__Lamf_client_model_domain_Amqp091OperationBinding(cC)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_Amqp091OperationBinding)) {
    var Amqp091OperationBinding$1 = $as_Lamf_client_model_domain_Amqp091OperationBinding(x$1);
    var x = this.$$undinternal$1;
    var x$2 = Amqp091OperationBinding$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$withTimestamp__Z__O = (function(timestamp) {
  return this.withTimestamp__Z__Lamf_client_model_domain_Amqp091OperationBinding(timestamp)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$prop$timestamp__O = (function() {
  var this$1 = this.$$undinternal$1;
  return $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().Timestamp$1))
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withExpiration__I__Lamf_client_model_domain_Amqp091OperationBinding = (function(expiration) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().Expiration$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject(this$1, field, expiration));
  return this
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withPriority__I__Lamf_client_model_domain_Amqp091OperationBinding = (function(priority) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().Priority$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject(this$1, field, priority));
  return this
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_OperationBinding = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withReplyTo__T__Lamf_client_model_domain_Amqp091OperationBinding = (function(replyTo) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().ReplyTo$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, replyTo));
  return this
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$prop$mandatory__O = (function() {
  var this$1 = this.$$undinternal$1;
  return $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().Mandatory$1))
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$withMandatory__Z__O = (function(mandatory) {
  return this.withMandatory__Z__Lamf_client_model_domain_Amqp091OperationBinding(mandatory)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$withAck__Z__O = (function(ack) {
  return this.withAck__Z__Lamf_client_model_domain_Amqp091OperationBinding(ack)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.linkCopy__Lamf_client_model_domain_Amqp091OperationBinding = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$5 = new $c_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().Amqp091OperationBindingMatcher__Lamf_client_convert_Amqp091OperationBindingConverter$Amqp091OperationBindingMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding__Lamf_client_model_domain_Amqp091OperationBinding(from)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$withBcc__sc_Seq__O = (function(bCC) {
  return this.withBcc__sc_Seq__Lamf_client_model_domain_Amqp091OperationBinding(bCC)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withBcc__sc_Seq__Lamf_client_model_domain_Amqp091OperationBinding = (function(bCC) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().BCC$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$1, field, bCC));
  return this
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$withBindingVersion__T__O = (function(bindingVersion) {
  return this.withBindingVersion__T__Lamf_client_model_domain_Amqp091OperationBinding(bindingVersion)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$prop$priority__O = (function() {
  var this$1 = this.$$undinternal$1;
  return $as_Lamf_core_model_IntField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().Priority$1))
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$withReplyTo__T__O = (function(replyTo) {
  return this.withReplyTo__T__Lamf_client_model_domain_Amqp091OperationBinding(replyTo)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$withExpiration__I__O = (function(expiration) {
  return this.withExpiration__I__Lamf_client_model_domain_Amqp091OperationBinding(expiration)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.bcc__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().BCC$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$prop$cc__O = (function() {
  return this.cc__sjs_js_Array()
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_Amqp091OperationBinding()
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.replyTo__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().ReplyTo$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$prop$expiration__O = (function() {
  var this$1 = this.$$undinternal$1;
  return $as_Lamf_core_model_IntField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().Expiration$1))
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withTimestamp__Z__Lamf_client_model_domain_Amqp091OperationBinding = (function(timestamp) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().Timestamp$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, timestamp));
  return this
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withCc__sc_Seq__Lamf_client_model_domain_Amqp091OperationBinding = (function(cC) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().CC$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$1, field, cC));
  return this
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$withUserId__T__O = (function(userId) {
  return this.withUserId__T__Lamf_client_model_domain_Amqp091OperationBinding(userId)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_Amqp091OperationBinding()
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$prop$deliveryMode__O = (function() {
  var this$1 = this.$$undinternal$1;
  return $as_Lamf_core_model_IntField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().DeliveryMode$1))
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withMandatory__Z__Lamf_client_model_domain_Amqp091OperationBinding = (function(mandatory) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().Mandatory$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, mandatory));
  return this
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.cc__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_sc_Seq(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().CC$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$prop$replyTo__O = (function() {
  return this.replyTo__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withBindingVersion__T__Lamf_client_model_domain_Amqp091OperationBinding = (function(bindingVersion) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().BindingVersion$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_BindingVersion($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, bindingVersion));
  return this
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$withPriority__I__O = (function(priority) {
  return this.withPriority__I__Lamf_client_model_domain_Amqp091OperationBinding(priority)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.userId__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().UserId$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withAck__Z__Lamf_client_model_domain_Amqp091OperationBinding = (function(ack) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().Ack$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, ack));
  return this
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withUserId__T__Lamf_client_model_domain_Amqp091OperationBinding = (function(userId) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().UserId$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_amqp_Amqp091OperationBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, userId));
  return this
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$withDeliveryMode__I__O = (function(deliveryMode) {
  return this.withDeliveryMode__I__Lamf_client_model_domain_Amqp091OperationBinding(deliveryMode)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$prop$ack__O = (function() {
  var this$1 = this.$$undinternal$1;
  return $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_Amqp091OperationBindingModel$().Ack$1))
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091OperationBinding.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091OperationBinding.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091OperationBinding.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091OperationBinding.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091OperationBinding.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091OperationBinding.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091OperationBinding.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091OperationBinding.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withAck = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withAck__Z__O(prep)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withTimestamp = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withTimestamp__Z__O(prep)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withReplyTo = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withReplyTo__T__O(prep)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withBcc = (function(arg) {
  var prep = $as_sc_Seq(arg);
  return this.$$js$exported$meth$withBcc__sc_Seq__O(prep)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withMandatory = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withMandatory__Z__O(prep)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withDeliveryMode = (function(arg) {
  var prep = $uI(arg);
  return this.$$js$exported$meth$withDeliveryMode__I__O(prep)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withPriority = (function(arg) {
  var prep = $uI(arg);
  return this.$$js$exported$meth$withPriority__I__O(prep)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withCc = (function(arg) {
  var prep = $as_sc_Seq(arg);
  return this.$$js$exported$meth$withCc__sc_Seq__O(prep)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withUserId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withUserId__T__O(prep)
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withExpiration = (function(arg) {
  var prep = $uI(arg);
  return this.$$js$exported$meth$withExpiration__I__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091OperationBinding.prototype, "ack", {
  "get": (function() {
    return this.$$js$exported$prop$ack__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091OperationBinding.prototype, "timestamp", {
  "get": (function() {
    return this.$$js$exported$prop$timestamp__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091OperationBinding.prototype, "replyTo", {
  "get": (function() {
    return this.$$js$exported$prop$replyTo__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091OperationBinding.prototype, "bcc", {
  "get": (function() {
    return this.$$js$exported$prop$bcc__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091OperationBinding.prototype, "mandatory", {
  "get": (function() {
    return this.$$js$exported$prop$mandatory__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091OperationBinding.prototype, "deliveryMode", {
  "get": (function() {
    return this.$$js$exported$prop$deliveryMode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091OperationBinding.prototype, "priority", {
  "get": (function() {
    return this.$$js$exported$prop$priority__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091OperationBinding.prototype, "cc", {
  "get": (function() {
    return this.$$js$exported$prop$cc__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091OperationBinding.prototype, "userId", {
  "get": (function() {
    return this.$$js$exported$prop$userId__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Amqp091OperationBinding.prototype, "expiration", {
  "get": (function() {
    return this.$$js$exported$prop$expiration__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.withBindingVersion = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withBindingVersion__T__O(prep)
});
function $as_Lamf_client_model_domain_Amqp091OperationBinding(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_Amqp091OperationBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Amqp091OperationBinding"))
}
function $isArrayOf_Lamf_client_model_domain_Amqp091OperationBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Amqp091OperationBinding)))
}
function $asArrayOf_Lamf_client_model_domain_Amqp091OperationBinding(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Amqp091OperationBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Amqp091OperationBinding;", depth))
}
var $d_Lamf_client_model_domain_Amqp091OperationBinding = new $TypeData().initClass({
  Lamf_client_model_domain_Amqp091OperationBinding: 0
}, false, "amf.client.model.domain.Amqp091OperationBinding", {
  Lamf_client_model_domain_Amqp091OperationBinding: 1,
  O: 1,
  Lamf_client_model_domain_OperationBinding: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_BindingVersion: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.$classData = $d_Lamf_client_model_domain_Amqp091OperationBinding;
/** @constructor */
function $c_Lamf_client_model_domain_HttpMessageBinding() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_HttpMessageBinding.prototype = new $h_O();
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.constructor = $c_Lamf_client_model_domain_HttpMessageBinding;
/** @constructor */
function $h_Lamf_client_model_domain_HttpMessageBinding() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_HttpMessageBinding.prototype = $c_Lamf_client_model_domain_HttpMessageBinding.prototype;
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.productPrefix__T = (function() {
  return "HttpMessageBinding"
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_HttpMessageBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding.call(this, new $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_HttpMessageBinding)) {
    var HttpMessageBinding$1 = $as_Lamf_client_model_domain_HttpMessageBinding(x$1);
    var x = this.$$undinternal$1;
    var x$2 = HttpMessageBinding$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$meth$withBindingVersion__T__O = (function(bindingVersion) {
  return this.withBindingVersion__T__Lamf_client_model_domain_HttpMessageBinding(bindingVersion)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_HttpMessageBinding()
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$prop$headers__O = (function() {
  return this.headers__Lamf_client_model_domain_Shape()
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_HttpMessageBinding()
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.linkCopy__Lamf_client_model_domain_HttpMessageBinding = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$5 = new $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().HttpMessageBindingMatcher__Lamf_client_convert_HttpMessageBindingConverter$HttpMessageBindingMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding__Lamf_client_model_domain_HttpMessageBinding(from)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.withHeaders__Lamf_client_model_domain_Shape__Lamf_client_model_domain_HttpMessageBinding = (function(headers) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var headers$1 = headers.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$().Headers$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_http_HttpMessageBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, headers$1));
  return this
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_MessageBinding = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.withBindingVersion__T__Lamf_client_model_domain_HttpMessageBinding = (function(bindingVersion) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$().BindingVersion$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_BindingVersion($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, bindingVersion));
  return this
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.headers__Lamf_client_model_domain_Shape = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_domain_Shape(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpMessageBindingModel$().Headers$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(from)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$meth$withHeaders__Lamf_client_model_domain_Shape__O = (function(headers) {
  return this.withHeaders__Lamf_client_model_domain_Shape__Lamf_client_model_domain_HttpMessageBinding(headers)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_HttpMessageBinding.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_HttpMessageBinding.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_HttpMessageBinding.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_HttpMessageBinding.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_HttpMessageBinding.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_HttpMessageBinding.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_HttpMessageBinding.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_HttpMessageBinding.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.withHeaders = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withHeaders__Lamf_client_model_domain_Shape__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_HttpMessageBinding.prototype, "headers", {
  "get": (function() {
    return this.$$js$exported$prop$headers__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.withBindingVersion = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withBindingVersion__T__O(prep)
});
function $as_Lamf_client_model_domain_HttpMessageBinding(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_HttpMessageBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.HttpMessageBinding"))
}
function $isArrayOf_Lamf_client_model_domain_HttpMessageBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_HttpMessageBinding)))
}
function $asArrayOf_Lamf_client_model_domain_HttpMessageBinding(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_HttpMessageBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.HttpMessageBinding;", depth))
}
var $d_Lamf_client_model_domain_HttpMessageBinding = new $TypeData().initClass({
  Lamf_client_model_domain_HttpMessageBinding: 0
}, false, "amf.client.model.domain.HttpMessageBinding", {
  Lamf_client_model_domain_HttpMessageBinding: 1,
  O: 1,
  Lamf_client_model_domain_MessageBinding: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_BindingVersion: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_HttpMessageBinding.prototype.$classData = $d_Lamf_client_model_domain_HttpMessageBinding;
/** @constructor */
function $c_Lamf_client_model_domain_HttpOperationBinding() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_HttpOperationBinding.prototype = new $h_O();
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.constructor = $c_Lamf_client_model_domain_HttpOperationBinding;
/** @constructor */
function $h_Lamf_client_model_domain_HttpOperationBinding() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_HttpOperationBinding.prototype = $c_Lamf_client_model_domain_HttpOperationBinding.prototype;
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.productPrefix__T = (function() {
  return "HttpOperationBinding"
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_HttpOperationBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding.call(this, new $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.query__Lamf_client_model_domain_Shape = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_domain_Shape(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$().Query$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(from)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$prop$operationType__O = (function() {
  return this.operationType__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_HttpOperationBinding)) {
    var HttpOperationBinding$1 = $as_Lamf_client_model_domain_HttpOperationBinding(x$1);
    var x = this.$$undinternal$1;
    var x$2 = HttpOperationBinding$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_OperationBinding = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$meth$withBindingVersion__T__O = (function(bindingVersion) {
  return this.withBindingVersion__T__Lamf_client_model_domain_HttpOperationBinding(bindingVersion)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$meth$withQuery__Lamf_client_model_domain_Shape__O = (function(query) {
  return this.withQuery__Lamf_client_model_domain_Shape__Lamf_client_model_domain_HttpOperationBinding(query)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$meth$withMethod__T__O = (function(method) {
  return this.withMethod__T__Lamf_client_model_domain_HttpOperationBinding(method)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.operationType__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$().OperationType$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_HttpOperationBinding()
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_HttpOperationBinding()
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.withQuery__Lamf_client_model_domain_Shape__Lamf_client_model_domain_HttpOperationBinding = (function(query) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var query$1 = query.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$().Query$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, query$1));
  return this
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.method__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$().Method$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$meth$withOperationType__T__O = (function(type) {
  return this.withOperationType__T__Lamf_client_model_domain_HttpOperationBinding(type)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.withBindingVersion__T__Lamf_client_model_domain_HttpOperationBinding = (function(bindingVersion) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$().BindingVersion$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_BindingVersion($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, bindingVersion));
  return this
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$prop$query__O = (function() {
  return this.query__Lamf_client_model_domain_Shape()
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.withOperationType__T__Lamf_client_model_domain_HttpOperationBinding = (function(type) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$().OperationType$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, type));
  return this
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.withMethod__T__Lamf_client_model_domain_HttpOperationBinding = (function(method) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_HttpOperationBindingModel$().Method$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, method));
  return this
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.linkCopy__Lamf_client_model_domain_HttpOperationBinding = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$5 = new $c_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().HttpOperationBindingMatcher__Lamf_client_convert_HttpOperationBindingConverter$HttpOperationBindingMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_http_HttpOperationBinding__Lamf_client_model_domain_HttpOperationBinding(from)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$prop$method__O = (function() {
  return this.method__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_HttpOperationBinding.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_HttpOperationBinding.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_HttpOperationBinding.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_HttpOperationBinding.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_HttpOperationBinding.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_HttpOperationBinding.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_HttpOperationBinding.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_HttpOperationBinding.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.withBindingVersion = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withBindingVersion__T__O(prep)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.withQuery = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withQuery__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.withMethod = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withMethod__T__O(prep)
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.withOperationType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withOperationType__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_HttpOperationBinding.prototype, "query", {
  "get": (function() {
    return this.$$js$exported$prop$query__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_HttpOperationBinding.prototype, "method", {
  "get": (function() {
    return this.$$js$exported$prop$method__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_HttpOperationBinding.prototype, "operationType", {
  "get": (function() {
    return this.$$js$exported$prop$operationType__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_HttpOperationBinding(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_HttpOperationBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.HttpOperationBinding"))
}
function $isArrayOf_Lamf_client_model_domain_HttpOperationBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_HttpOperationBinding)))
}
function $asArrayOf_Lamf_client_model_domain_HttpOperationBinding(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_HttpOperationBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.HttpOperationBinding;", depth))
}
var $d_Lamf_client_model_domain_HttpOperationBinding = new $TypeData().initClass({
  Lamf_client_model_domain_HttpOperationBinding: 0
}, false, "amf.client.model.domain.HttpOperationBinding", {
  Lamf_client_model_domain_HttpOperationBinding: 1,
  O: 1,
  Lamf_client_model_domain_OperationBinding: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_BindingVersion: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_HttpOperationBinding.prototype.$classData = $d_Lamf_client_model_domain_HttpOperationBinding;
/** @constructor */
function $c_Lamf_client_model_domain_KafkaMessageBinding() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype = new $h_O();
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.constructor = $c_Lamf_client_model_domain_KafkaMessageBinding;
/** @constructor */
function $h_Lamf_client_model_domain_KafkaMessageBinding() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_KafkaMessageBinding.prototype = $c_Lamf_client_model_domain_KafkaMessageBinding.prototype;
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.productPrefix__T = (function() {
  return "KafkaMessageBinding"
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_KafkaMessageBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding.call(this, new $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$meth$withKey__T__O = (function(key) {
  return this.withKey__T__Lamf_client_model_domain_KafkaMessageBinding(key)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_KafkaMessageBinding)) {
    var KafkaMessageBinding$1 = $as_Lamf_client_model_domain_KafkaMessageBinding(x$1);
    var x = this.$$undinternal$1;
    var x$2 = KafkaMessageBinding$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.withKey__T__Lamf_client_model_domain_KafkaMessageBinding = (function(key) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$().MessageKey$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, key));
  return this
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$prop$messageKey__O = (function() {
  var this$1 = this.$$undinternal$1;
  return $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$().MessageKey$1))
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$meth$withBindingVersion__T__O = (function(bindingVersion) {
  return this.withBindingVersion__T__Lamf_client_model_domain_KafkaMessageBinding(bindingVersion)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_KafkaMessageBinding()
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.linkCopy__Lamf_client_model_domain_KafkaMessageBinding = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var from = new $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().KafkaMessageBindingMatcher__Lamf_client_convert_KafkaMessageBindingConverter$KafkaMessageBindingMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaMessageBinding__Lamf_client_model_domain_KafkaMessageBinding(from)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_KafkaMessageBinding()
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_MessageBinding = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.withBindingVersion__T__Lamf_client_model_domain_KafkaMessageBinding = (function(bindingVersion) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaMessageBindingModel$().BindingVersion$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_BindingVersion($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, bindingVersion));
  return this
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_KafkaMessageBinding.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_KafkaMessageBinding.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_KafkaMessageBinding.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_KafkaMessageBinding.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_KafkaMessageBinding.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_KafkaMessageBinding.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_KafkaMessageBinding.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_KafkaMessageBinding.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.withBindingVersion = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withBindingVersion__T__O(prep)
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.withKey = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withKey__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_KafkaMessageBinding.prototype, "messageKey", {
  "get": (function() {
    return this.$$js$exported$prop$messageKey__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_KafkaMessageBinding(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_KafkaMessageBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.KafkaMessageBinding"))
}
function $isArrayOf_Lamf_client_model_domain_KafkaMessageBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_KafkaMessageBinding)))
}
function $asArrayOf_Lamf_client_model_domain_KafkaMessageBinding(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_KafkaMessageBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.KafkaMessageBinding;", depth))
}
var $d_Lamf_client_model_domain_KafkaMessageBinding = new $TypeData().initClass({
  Lamf_client_model_domain_KafkaMessageBinding: 0
}, false, "amf.client.model.domain.KafkaMessageBinding", {
  Lamf_client_model_domain_KafkaMessageBinding: 1,
  O: 1,
  Lamf_client_model_domain_MessageBinding: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_BindingVersion: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_KafkaMessageBinding.prototype.$classData = $d_Lamf_client_model_domain_KafkaMessageBinding;
/** @constructor */
function $c_Lamf_client_model_domain_KafkaOperationBinding() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype = new $h_O();
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.constructor = $c_Lamf_client_model_domain_KafkaOperationBinding;
/** @constructor */
function $h_Lamf_client_model_domain_KafkaOperationBinding() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_KafkaOperationBinding.prototype = $c_Lamf_client_model_domain_KafkaOperationBinding.prototype;
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.clientId__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$().ClientId$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.productPrefix__T = (function() {
  return "KafkaOperationBinding"
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_KafkaOperationBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding.call(this, new $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$meth$withClientId__T__O = (function(clientId) {
  return this.withClientId__T__Lamf_client_model_domain_KafkaOperationBinding(clientId)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_KafkaOperationBinding)) {
    var KafkaOperationBinding$1 = $as_Lamf_client_model_domain_KafkaOperationBinding(x$1);
    var x = this.$$undinternal$1;
    var x$2 = KafkaOperationBinding$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_OperationBinding = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$meth$withGroupId__T__O = (function(groupId) {
  return this.withGroupId__T__Lamf_client_model_domain_KafkaOperationBinding(groupId)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$prop$groupId__O = (function() {
  return this.groupId__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$meth$withBindingVersion__T__O = (function(bindingVersion) {
  return this.withBindingVersion__T__Lamf_client_model_domain_KafkaOperationBinding(bindingVersion)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.linkCopy__Lamf_client_model_domain_KafkaOperationBinding = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$5 = new $c_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().KafkaOperationBindingMatcher__Lamf_client_convert_KafkaOperationBindingConverter$KafkaOperationBindingMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding__Lamf_client_model_domain_KafkaOperationBinding(from)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.withGroupId__T__Lamf_client_model_domain_KafkaOperationBinding = (function(groupId) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$().GroupId$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, groupId));
  return this
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.withBindingVersion__T__Lamf_client_model_domain_KafkaOperationBinding = (function(bindingVersion) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$().BindingVersion$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_BindingVersion($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, bindingVersion));
  return this
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_KafkaOperationBinding()
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_KafkaOperationBinding()
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.withClientId__T__Lamf_client_model_domain_KafkaOperationBinding = (function(clientId) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$().ClientId$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_kafka_KafkaOperationBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, clientId));
  return this
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$prop$clientId__O = (function() {
  return this.clientId__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.groupId__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_KafkaOperationBindingModel$().GroupId$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_KafkaOperationBinding.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_KafkaOperationBinding.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_KafkaOperationBinding.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_KafkaOperationBinding.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_KafkaOperationBinding.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_KafkaOperationBinding.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_KafkaOperationBinding.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_KafkaOperationBinding.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.withClientId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withClientId__T__O(prep)
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.withGroupId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withGroupId__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_KafkaOperationBinding.prototype, "clientId", {
  "get": (function() {
    return this.$$js$exported$prop$clientId__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_KafkaOperationBinding.prototype, "groupId", {
  "get": (function() {
    return this.$$js$exported$prop$groupId__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.withBindingVersion = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withBindingVersion__T__O(prep)
});
function $as_Lamf_client_model_domain_KafkaOperationBinding(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_KafkaOperationBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.KafkaOperationBinding"))
}
function $isArrayOf_Lamf_client_model_domain_KafkaOperationBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_KafkaOperationBinding)))
}
function $asArrayOf_Lamf_client_model_domain_KafkaOperationBinding(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_KafkaOperationBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.KafkaOperationBinding;", depth))
}
var $d_Lamf_client_model_domain_KafkaOperationBinding = new $TypeData().initClass({
  Lamf_client_model_domain_KafkaOperationBinding: 0
}, false, "amf.client.model.domain.KafkaOperationBinding", {
  Lamf_client_model_domain_KafkaOperationBinding: 1,
  O: 1,
  Lamf_client_model_domain_OperationBinding: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_BindingVersion: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_KafkaOperationBinding.prototype.$classData = $d_Lamf_client_model_domain_KafkaOperationBinding;
/** @constructor */
function $c_Lamf_client_model_domain_MqttMessageBinding() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_MqttMessageBinding.prototype = new $h_O();
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.constructor = $c_Lamf_client_model_domain_MqttMessageBinding;
/** @constructor */
function $h_Lamf_client_model_domain_MqttMessageBinding() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_MqttMessageBinding.prototype = $c_Lamf_client_model_domain_MqttMessageBinding.prototype;
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.productPrefix__T = (function() {
  return "MqttMessageBinding"
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_MqttMessageBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding.call(this, new $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_MqttMessageBinding)) {
    var MqttMessageBinding$1 = $as_Lamf_client_model_domain_MqttMessageBinding(x$1);
    var x = this.$$undinternal$1;
    var x$2 = MqttMessageBinding$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$js$exported$meth$withBindingVersion__T__O = (function(bindingVersion) {
  return this.withBindingVersion__T__Lamf_client_model_domain_MqttMessageBinding(bindingVersion)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.linkCopy__Lamf_client_model_domain_MqttMessageBinding = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$5 = new $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().MqttMessageBindingMatcher__Lamf_client_convert_MqttMessageBindingConverter$MqttMessageBindingMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding__Lamf_client_model_domain_MqttMessageBinding(from)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_MqttMessageBinding()
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.withBindingVersion__T__Lamf_client_model_domain_MqttMessageBinding = (function(bindingVersion) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttMessageBindingModel$().BindingVersion$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_BindingVersion($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, bindingVersion));
  return this
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_MqttMessageBinding()
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_MessageBinding = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttMessageBinding = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_MqttMessageBinding.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_MqttMessageBinding.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttMessageBinding.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttMessageBinding.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttMessageBinding.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_MqttMessageBinding.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttMessageBinding.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttMessageBinding.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.withBindingVersion = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withBindingVersion__T__O(prep)
});
function $as_Lamf_client_model_domain_MqttMessageBinding(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_MqttMessageBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.MqttMessageBinding"))
}
function $isArrayOf_Lamf_client_model_domain_MqttMessageBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_MqttMessageBinding)))
}
function $asArrayOf_Lamf_client_model_domain_MqttMessageBinding(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_MqttMessageBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.MqttMessageBinding;", depth))
}
var $d_Lamf_client_model_domain_MqttMessageBinding = new $TypeData().initClass({
  Lamf_client_model_domain_MqttMessageBinding: 0
}, false, "amf.client.model.domain.MqttMessageBinding", {
  Lamf_client_model_domain_MqttMessageBinding: 1,
  O: 1,
  Lamf_client_model_domain_MessageBinding: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_BindingVersion: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_MqttMessageBinding.prototype.$classData = $d_Lamf_client_model_domain_MqttMessageBinding;
/** @constructor */
function $c_Lamf_client_model_domain_MqttOperationBinding() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_MqttOperationBinding.prototype = new $h_O();
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.constructor = $c_Lamf_client_model_domain_MqttOperationBinding;
/** @constructor */
function $h_Lamf_client_model_domain_MqttOperationBinding() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_MqttOperationBinding.prototype = $c_Lamf_client_model_domain_MqttOperationBinding.prototype;
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.productPrefix__T = (function() {
  return "MqttOperationBinding"
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_MqttOperationBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding.call(this, new $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$prop$retain__O = (function() {
  var this$1 = this.$$undinternal$1;
  return $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$().Retain$1))
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_MqttOperationBinding)) {
    var MqttOperationBinding$1 = $as_Lamf_client_model_domain_MqttOperationBinding(x$1);
    var x = this.$$undinternal$1;
    var x$2 = MqttOperationBinding$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_OperationBinding = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.withBindingVersion__T__Lamf_client_model_domain_MqttOperationBinding = (function(bindingVersion) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$().BindingVersion$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_BindingVersion($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, bindingVersion));
  return this
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$meth$withBindingVersion__T__O = (function(bindingVersion) {
  return this.withBindingVersion__T__Lamf_client_model_domain_MqttOperationBinding(bindingVersion)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.linkCopy__Lamf_client_model_domain_MqttOperationBinding = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$5 = new $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().MqttOperationBindingMatcher__Lamf_client_convert_MqttOperationBindingConverter$MqttOperationBindingMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding__Lamf_client_model_domain_MqttOperationBinding(from)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$meth$withRetain__Z__O = (function(retain) {
  return this.withRetain__Z__Lamf_client_model_domain_MqttOperationBinding(retain)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_MqttOperationBinding()
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_MqttOperationBinding()
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.withQos__I__Lamf_client_model_domain_MqttOperationBinding = (function(qos) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$().Qos$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject(this$1, field, qos));
  return this
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.withRetain__Z__Lamf_client_model_domain_MqttOperationBinding = (function(retain) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$().Retain$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, retain));
  return this
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$meth$withQos__I__O = (function(qos) {
  return this.withQos__I__Lamf_client_model_domain_MqttOperationBinding(qos)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttOperationBinding = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$prop$qos__O = (function() {
  var this$1 = this.$$undinternal$1;
  return $as_Lamf_core_model_IntField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttOperationBindingModel$().Qos$1))
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_MqttOperationBinding.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_MqttOperationBinding.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttOperationBinding.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttOperationBinding.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttOperationBinding.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_MqttOperationBinding.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttOperationBinding.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttOperationBinding.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.withBindingVersion = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withBindingVersion__T__O(prep)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.withRetain = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withRetain__Z__O(prep)
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.withQos = (function(arg) {
  var prep = $uI(arg);
  return this.$$js$exported$meth$withQos__I__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_MqttOperationBinding.prototype, "retain", {
  "get": (function() {
    return this.$$js$exported$prop$retain__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttOperationBinding.prototype, "qos", {
  "get": (function() {
    return this.$$js$exported$prop$qos__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_MqttOperationBinding(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_MqttOperationBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.MqttOperationBinding"))
}
function $isArrayOf_Lamf_client_model_domain_MqttOperationBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_MqttOperationBinding)))
}
function $asArrayOf_Lamf_client_model_domain_MqttOperationBinding(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_MqttOperationBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.MqttOperationBinding;", depth))
}
var $d_Lamf_client_model_domain_MqttOperationBinding = new $TypeData().initClass({
  Lamf_client_model_domain_MqttOperationBinding: 0
}, false, "amf.client.model.domain.MqttOperationBinding", {
  Lamf_client_model_domain_MqttOperationBinding: 1,
  O: 1,
  Lamf_client_model_domain_OperationBinding: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_BindingVersion: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_MqttOperationBinding.prototype.$classData = $d_Lamf_client_model_domain_MqttOperationBinding;
/** @constructor */
function $c_Lamf_client_model_domain_MqttServerBinding() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_MqttServerBinding.prototype = new $h_O();
$c_Lamf_client_model_domain_MqttServerBinding.prototype.constructor = $c_Lamf_client_model_domain_MqttServerBinding;
/** @constructor */
function $h_Lamf_client_model_domain_MqttServerBinding() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_MqttServerBinding.prototype = $c_Lamf_client_model_domain_MqttServerBinding.prototype;
$c_Lamf_client_model_domain_MqttServerBinding.prototype.clientId__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().ClientId$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.linkCopy__Lamf_client_model_domain_MqttServerBinding = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$5 = new $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().MqttServerBindingMatcher__Lamf_client_convert_MqttServerBindingConverter$MqttServerBindingMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding__Lamf_client_model_domain_MqttServerBinding(from)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.productPrefix__T = (function() {
  return "MqttServerBinding"
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_MqttServerBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding.call(this, new $c_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$prop$cleanSession__O = (function() {
  return this.cleanSession__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.keepAlive__Lamf_client_model_IntField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_IntField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().KeepAlive$1));
  $m_Lamf_client_convert_WebApiClientConverters$().IntFieldMatcher__Lamf_client_convert_FieldConverter$IntFieldMatcher$();
  return new $c_Lamf_client_model_IntField().init___Lamf_core_model_IntField(from)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.withBindingVersion__T__Lamf_client_model_domain_MqttServerBinding = (function(bindingVersion) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().BindingVersion$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_BindingVersion($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, bindingVersion));
  return this
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$meth$withClientId__T__O = (function(clientId) {
  return this.withClientId__T__Lamf_client_model_domain_MqttServerBinding(clientId)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.lastWill__Lamf_client_model_domain_MqttServerLastWill = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().LastWill$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().MqttServerLastWillMatcher__Lamf_client_convert_MqttServerLastWillConverter$MqttServerLastWillMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerLastWill__Lamf_client_model_domain_MqttServerLastWill(from)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$prop$lastWill__O = (function() {
  return this.lastWill__Lamf_client_model_domain_MqttServerLastWill()
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_MqttServerBinding)) {
    var MqttServerBinding$1 = $as_Lamf_client_model_domain_MqttServerBinding(x$1);
    var x = this.$$undinternal$1;
    var x$2 = MqttServerBinding$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.withClientId__T__Lamf_client_model_domain_MqttServerBinding = (function(clientId) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().ClientId$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, clientId));
  return this
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$meth$withBindingVersion__T__O = (function(bindingVersion) {
  return this.withBindingVersion__T__Lamf_client_model_domain_MqttServerBinding(bindingVersion)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_ServerBinding = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.withKeepAlive__I__Lamf_client_model_domain_MqttServerBinding = (function(keepAlive) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().KeepAlive$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject(this$1, field, keepAlive));
  return this
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.withLastWill__Lamf_client_model_domain_MqttServerLastWill__Lamf_client_model_domain_MqttServerBinding = (function(lastWill) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().MqttServerLastWillMatcher__Lamf_client_convert_MqttServerLastWillConverter$MqttServerLastWillMatcher$();
  var lastWill$1 = lastWill.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().LastWill$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, lastWill$1));
  return this
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_MqttServerBinding()
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.withCleanSession__Z__Lamf_client_model_domain_MqttServerBinding = (function(cleanSession) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().CleanSession$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_mqtt_MqttServerBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, cleanSession));
  return this
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_MqttServerBinding()
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.cleanSession__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_MqttServerBindingModel$().CleanSession$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$meth$withLastWill__Lamf_client_model_domain_MqttServerLastWill__O = (function(lastWill) {
  return this.withLastWill__Lamf_client_model_domain_MqttServerLastWill__Lamf_client_model_domain_MqttServerBinding(lastWill)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$meth$withKeepAlive__I__O = (function(keepAlive) {
  return this.withKeepAlive__I__Lamf_client_model_domain_MqttServerBinding(keepAlive)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$meth$withCleanSession__Z__O = (function(cleanSession) {
  return this.withCleanSession__Z__Lamf_client_model_domain_MqttServerBinding(cleanSession)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$prop$clientId__O = (function() {
  return this.clientId__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$prop$keepAlive__O = (function() {
  return this.keepAlive__Lamf_client_model_IntField()
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_MqttServerBinding.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_MqttServerBinding.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttServerBinding.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttServerBinding.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttServerBinding.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_MqttServerBinding.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttServerBinding.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttServerBinding.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.withKeepAlive = (function(arg) {
  var prep = $uI(arg);
  return this.$$js$exported$meth$withKeepAlive__I__O(prep)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.withLastWill = (function(arg) {
  var prep = $as_Lamf_client_model_domain_MqttServerLastWill(arg);
  return this.$$js$exported$meth$withLastWill__Lamf_client_model_domain_MqttServerLastWill__O(prep)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.withCleanSession = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withCleanSession__Z__O(prep)
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.withClientId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withClientId__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_MqttServerBinding.prototype, "keepAlive", {
  "get": (function() {
    return this.$$js$exported$prop$keepAlive__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttServerBinding.prototype, "lastWill", {
  "get": (function() {
    return this.$$js$exported$prop$lastWill__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttServerBinding.prototype, "cleanSession", {
  "get": (function() {
    return this.$$js$exported$prop$cleanSession__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_MqttServerBinding.prototype, "clientId", {
  "get": (function() {
    return this.$$js$exported$prop$clientId__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.withBindingVersion = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withBindingVersion__T__O(prep)
});
function $as_Lamf_client_model_domain_MqttServerBinding(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_MqttServerBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.MqttServerBinding"))
}
function $isArrayOf_Lamf_client_model_domain_MqttServerBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_MqttServerBinding)))
}
function $asArrayOf_Lamf_client_model_domain_MqttServerBinding(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_MqttServerBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.MqttServerBinding;", depth))
}
var $d_Lamf_client_model_domain_MqttServerBinding = new $TypeData().initClass({
  Lamf_client_model_domain_MqttServerBinding: 0
}, false, "amf.client.model.domain.MqttServerBinding", {
  Lamf_client_model_domain_MqttServerBinding: 1,
  O: 1,
  Lamf_client_model_domain_ServerBinding: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_BindingVersion: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_MqttServerBinding.prototype.$classData = $d_Lamf_client_model_domain_MqttServerBinding;
/** @constructor */
function $c_Lamf_client_model_domain_PropertyShape() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_PropertyShape.prototype = new $h_O();
$c_Lamf_client_model_domain_PropertyShape.prototype.constructor = $c_Lamf_client_model_domain_PropertyShape;
/** @constructor */
function $h_Lamf_client_model_domain_PropertyShape() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_PropertyShape.prototype = $c_Lamf_client_model_domain_PropertyShape.prototype;
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withOr__sjs_js_Array__O = (function(subShapes) {
  return $f_Lamf_client_model_domain_Shape__withOr__sjs_js_Array__Lamf_client_model_domain_Shape(this, subShapes)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withPatternName__T__O = (function(pattern) {
  return this.withPatternName__T__Lamf_client_model_domain_PropertyShape(pattern)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$xone__O = (function() {
  return $f_Lamf_client_model_domain_Shape__xone__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.productPrefix__T = (function() {
  return "PropertyShape"
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withMinCount__I__Lamf_client_model_domain_PropertyShape = (function(min) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1;
  $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject(this$1, field, min));
  return this
});
$c_Lamf_client_model_domain_PropertyShape.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_PropertyShape.prototype.init___Lamf_core_model_domain_extensions_PropertyShape.call(this, new $c_Lamf_core_model_domain_extensions_PropertyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$deprecated__O = (function() {
  return $f_Lamf_client_model_domain_Shape__deprecated__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withMaxCount__I__O = (function(max) {
  return this.withMaxCount__I__Lamf_client_model_domain_PropertyShape(max)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withWriteOnly__Z__O = (function(writeOnly) {
  return $f_Lamf_client_model_domain_Shape__withWriteOnly__Z__Lamf_client_model_domain_Shape(this, writeOnly)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$undinternal__Lamf_core_model_domain_Shape = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withPath__T__O = (function(path) {
  return this.withPath__T__Lamf_client_model_domain_PropertyShape(path)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$displayName__O = (function() {
  return $f_Lamf_client_model_domain_Shape__displayName__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.minCount__Lamf_client_model_IntField = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_IntField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MinCount$1));
  $m_Lamf_client_convert_CoreClientConverters$().IntFieldMatcher__Lamf_client_convert_FieldConverter$IntFieldMatcher$();
  return new $c_Lamf_client_model_IntField().init___Lamf_core_model_IntField(from)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withCustomShapePropertyDefinition__T__O = (function(name) {
  return $f_Lamf_client_model_domain_Shape__withCustomShapePropertyDefinition__T__Lamf_client_model_domain_PropertyShape(this, name)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$name__O = (function() {
  return $f_Lamf_client_model_domain_Shape__name__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$elseShape__O = (function() {
  return $f_Lamf_client_model_domain_Shape__elseShape__Lamf_client_model_domain_Shape(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withXone__sjs_js_Array__O = (function(subShapes) {
  return $f_Lamf_client_model_domain_Shape__withXone__sjs_js_Array__Lamf_client_model_domain_Shape(this, subShapes)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withAnd__sjs_js_Array__O = (function(subShapes) {
  return $f_Lamf_client_model_domain_Shape__withAnd__sjs_js_Array__Lamf_client_model_domain_Shape(this, subShapes)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_PropertyShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_PropertyShape)) {
    var PropertyShape$1 = $as_Lamf_client_model_domain_PropertyShape(x$1);
    var x = this.$$undinternal$1;
    var x$2 = PropertyShape$1.$$undinternal$1;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_PropertyShape.prototype.path__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Path$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withCustomShapeProperties__sjs_js_Array__O = (function(customShapeProperties) {
  return $f_Lamf_client_model_domain_Shape__withCustomShapeProperties__sjs_js_Array__Lamf_client_model_domain_Shape(this, customShapeProperties)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$or__O = (function() {
  return $f_Lamf_client_model_domain_Shape__or__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withThen__Lamf_client_model_domain_Shape__O = (function(thenShape) {
  return $f_Lamf_client_model_domain_Shape__withThen__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Shape(this, thenShape)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withReadOnly__Z__O = (function(readOnly) {
  return $f_Lamf_client_model_domain_Shape__withReadOnly__Z__Lamf_client_model_domain_Shape(this, readOnly)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withElse__Lamf_client_model_domain_Shape__O = (function(elseShape) {
  return $f_Lamf_client_model_domain_Shape__withElse__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Shape(this, elseShape)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$values__O = (function() {
  return $f_Lamf_client_model_domain_Shape__values__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withNode__Lamf_client_model_domain_Shape__O = (function(shape) {
  return $f_Lamf_client_model_domain_Shape__withNode__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Shape(this, shape)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withCustomShapePropertyDefinitions__sjs_js_Array__O = (function(propertyDefinitions) {
  return $f_Lamf_client_model_domain_Shape__withCustomShapePropertyDefinitions__sjs_js_Array__Lamf_client_model_domain_Shape(this, propertyDefinitions)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$defaultValueStr__O = (function() {
  return $f_Lamf_client_model_domain_Shape__defaultValueStr__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withDefaultValue__Lamf_client_model_domain_DataNode__O = (function($default) {
  return $f_Lamf_client_model_domain_Shape__withDefaultValue__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_Shape(this, $default)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.patternName__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().PatternName$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withIf__Lamf_client_model_domain_Shape__O = (function(ifShape) {
  return $f_Lamf_client_model_domain_Shape__withIf__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Shape(this, ifShape)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$range__O = (function() {
  return this.range__Lamf_client_model_domain_Shape()
});
$c_Lamf_client_model_domain_PropertyShape.prototype.range__Lamf_client_model_domain_Shape = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_domain_Shape(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1));
  var m = $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(from)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$inherits__O = (function() {
  return $f_Lamf_client_model_domain_Shape__inherits__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withPatternName__T__Lamf_client_model_domain_PropertyShape = (function(pattern) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().PatternName$1;
  $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, pattern));
  return this
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withDisplayName__T__O = (function(name) {
  return $f_Lamf_client_model_domain_Shape__withDisplayName__T__Lamf_client_model_domain_Shape(this, name)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$thenShape__O = (function() {
  return $f_Lamf_client_model_domain_Shape__thenShape__Lamf_client_model_domain_Shape(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$and__O = (function() {
  return $f_Lamf_client_model_domain_Shape__and__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$readOnly__O = (function() {
  return $f_Lamf_client_model_domain_Shape__readOnly__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$maxCount__O = (function() {
  return this.maxCount__Lamf_client_model_IntField()
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_PropertyShape()
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withRange__Lamf_client_model_domain_Shape__Lamf_client_model_domain_PropertyShape = (function(range) {
  var this$1 = this.$$undinternal$1;
  var range$1 = range.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1;
  $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$1, field, range$1));
  return this
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.maxCount__Lamf_client_model_IntField = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_IntField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MaxCount$1));
  $m_Lamf_client_convert_CoreClientConverters$().IntFieldMatcher__Lamf_client_convert_FieldConverter$IntFieldMatcher$();
  return new $c_Lamf_client_model_IntField().init___Lamf_core_model_IntField(from)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_PropertyShape()
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$patternName__O = (function() {
  return this.patternName__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withDescription__T__O = (function(description) {
  return $f_Lamf_client_model_domain_Shape__withDescription__T__Lamf_client_model_domain_Shape(this, description)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$customShapeProperties__O = (function() {
  return $f_Lamf_client_model_domain_Shape__customShapeProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$customShapePropertyDefinitions__O = (function() {
  return $f_Lamf_client_model_domain_Shape__customShapePropertyDefinitions__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withMaxCount__I__Lamf_client_model_domain_PropertyShape = (function(max) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().MaxCount$1;
  $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject(this$1, field, max));
  return this
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$description__O = (function() {
  return $f_Lamf_client_model_domain_Shape__description__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$writeOnly__O = (function() {
  return $f_Lamf_client_model_domain_Shape__writeOnly__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$path__O = (function() {
  return this.path__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withMinCount__I__O = (function(min) {
  return this.withMinCount__I__Lamf_client_model_domain_PropertyShape(min)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$minCount__O = (function() {
  return this.minCount__Lamf_client_model_IntField()
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return $f_Lamf_client_model_domain_Shape__withName__T__Lamf_client_model_domain_Shape(this, name)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.linkCopy__Lamf_client_model_domain_PropertyShape = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$5 = new $c_Lamf_core_model_domain_extensions_PropertyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_CoreClientConverters$().PropertyShapeMatcher__Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_extensions_PropertyShape__Lamf_client_model_domain_PropertyShape(from)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withPath__T__Lamf_client_model_domain_PropertyShape = (function(path) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Path$1;
  $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, path));
  return this
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withRange__Lamf_client_model_domain_Shape__O = (function(range) {
  return this.withRange__Lamf_client_model_domain_Shape__Lamf_client_model_domain_PropertyShape(range)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withInherits__sjs_js_Array__O = (function(inherits) {
  return $f_Lamf_client_model_domain_Shape__withInherits__sjs_js_Array__Lamf_client_model_domain_Shape(this, inherits)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$not__O = (function() {
  return $f_Lamf_client_model_domain_Shape__not__Lamf_client_model_domain_Shape(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.init___Lamf_core_model_domain_extensions_PropertyShape = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withValues__sjs_js_Array__O = (function(values) {
  return $f_Lamf_client_model_domain_Shape__withValues__sjs_js_Array__Lamf_client_model_domain_Shape(this, values)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withDefaultStr__T__O = (function(value) {
  return $f_Lamf_client_model_domain_Shape__withDefaultStr__T__Lamf_client_model_domain_Shape(this, value)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$defaultValue__O = (function() {
  return $f_Lamf_client_model_domain_Shape__defaultValue__Lamf_client_model_domain_DataNode(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$prop$ifShape__O = (function() {
  return $f_Lamf_client_model_domain_Shape__ifShape__Lamf_client_model_domain_Shape(this)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withDeprecated__Z__O = (function(deprecated) {
  return $f_Lamf_client_model_domain_Shape__withDeprecated__Z__Lamf_client_model_domain_Shape(this, deprecated)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_PropertyShape.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_PropertyShape.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withThen = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withThen__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withElse = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withElse__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withIf = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withIf__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withDeprecated = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withDeprecated__Z__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withWriteOnly = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withWriteOnly__Z__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withReadOnly = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withReadOnly__Z__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withCustomShapePropertyDefinition = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withCustomShapePropertyDefinition__T__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withCustomShapePropertyDefinitions = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomShapePropertyDefinitions__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withCustomShapeProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomShapeProperties__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withDefaultStr = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDefaultStr__T__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withNode = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withNode__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withXone = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withXone__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withAnd = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withAnd__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withOr = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withOr__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withInherits = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withInherits__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withValues = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withValues__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withDefaultValue = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DataNode(arg);
  return this.$$js$exported$meth$withDefaultValue__Lamf_client_model_domain_DataNode__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withDescription = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDescription__T__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withDisplayName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDisplayName__T__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "thenShape", {
  "get": (function() {
    return this.$$js$exported$prop$thenShape__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "elseShape", {
  "get": (function() {
    return this.$$js$exported$prop$elseShape__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "ifShape", {
  "get": (function() {
    return this.$$js$exported$prop$ifShape__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "deprecated", {
  "get": (function() {
    return this.$$js$exported$prop$deprecated__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "writeOnly", {
  "get": (function() {
    return this.$$js$exported$prop$writeOnly__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "readOnly", {
  "get": (function() {
    return this.$$js$exported$prop$readOnly__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "not", {
  "get": (function() {
    return this.$$js$exported$prop$not__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "xone", {
  "get": (function() {
    return this.$$js$exported$prop$xone__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "and", {
  "get": (function() {
    return this.$$js$exported$prop$and__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "or", {
  "get": (function() {
    return this.$$js$exported$prop$or__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "customShapePropertyDefinitions", {
  "get": (function() {
    return this.$$js$exported$prop$customShapePropertyDefinitions__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "customShapeProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customShapeProperties__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "inherits", {
  "get": (function() {
    return this.$$js$exported$prop$inherits__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "values", {
  "get": (function() {
    return this.$$js$exported$prop$values__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "defaultValueStr", {
  "get": (function() {
    return this.$$js$exported$prop$defaultValueStr__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "defaultValue", {
  "get": (function() {
    return this.$$js$exported$prop$defaultValue__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "displayName", {
  "get": (function() {
    return this.$$js$exported$prop$displayName__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_PropertyShape.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withPatternName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withPatternName__T__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withMaxCount = (function(arg) {
  var prep = $uI(arg);
  return this.$$js$exported$meth$withMaxCount__I__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withMinCount = (function(arg) {
  var prep = $uI(arg);
  return this.$$js$exported$meth$withMinCount__I__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withRange = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withRange__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_PropertyShape.prototype.withPath = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withPath__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "patternName", {
  "get": (function() {
    return this.$$js$exported$prop$patternName__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "maxCount", {
  "get": (function() {
    return this.$$js$exported$prop$maxCount__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "minCount", {
  "get": (function() {
    return this.$$js$exported$prop$minCount__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "range", {
  "get": (function() {
    return this.$$js$exported$prop$range__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_PropertyShape.prototype, "path", {
  "get": (function() {
    return this.$$js$exported$prop$path__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_PropertyShape(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_PropertyShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.PropertyShape"))
}
function $isArrayOf_Lamf_client_model_domain_PropertyShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_PropertyShape)))
}
function $asArrayOf_Lamf_client_model_domain_PropertyShape(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_PropertyShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.PropertyShape;", depth))
}
var $d_Lamf_client_model_domain_PropertyShape = new $TypeData().initClass({
  Lamf_client_model_domain_PropertyShape: 0
}, false, "amf.client.model.domain.PropertyShape", {
  Lamf_client_model_domain_PropertyShape: 1,
  O: 1,
  Lamf_client_model_domain_Shape: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_PropertyShape.prototype.$classData = $d_Lamf_client_model_domain_PropertyShape;
/** @constructor */
function $c_Lamf_client_model_domain_RecursiveShape() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_RecursiveShape.prototype = new $h_O();
$c_Lamf_client_model_domain_RecursiveShape.prototype.constructor = $c_Lamf_client_model_domain_RecursiveShape;
/** @constructor */
function $h_Lamf_client_model_domain_RecursiveShape() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_RecursiveShape.prototype = $c_Lamf_client_model_domain_RecursiveShape.prototype;
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withOr__sjs_js_Array__O = (function(subShapes) {
  return $f_Lamf_client_model_domain_Shape__withOr__sjs_js_Array__Lamf_client_model_domain_Shape(this, subShapes)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withFixPoint__T__Lamf_client_model_domain_RecursiveShape = (function(shapeId) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_core_metamodel_domain_RecursiveShapeModel$().FixPoint$1;
  $as_Lamf_core_model_domain_RecursiveShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, shapeId));
  return this
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$xone__O = (function() {
  return $f_Lamf_client_model_domain_Shape__xone__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.productPrefix__T = (function() {
  return "RecursiveShape"
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$deprecated__O = (function() {
  return $f_Lamf_client_model_domain_Shape__deprecated__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withWriteOnly__Z__O = (function(writeOnly) {
  return $f_Lamf_client_model_domain_Shape__withWriteOnly__Z__Lamf_client_model_domain_Shape(this, writeOnly)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$undinternal__Lamf_core_model_domain_Shape = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$displayName__O = (function() {
  return $f_Lamf_client_model_domain_Shape__displayName__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withCustomShapePropertyDefinition__T__O = (function(name) {
  return $f_Lamf_client_model_domain_Shape__withCustomShapePropertyDefinition__T__Lamf_client_model_domain_PropertyShape(this, name)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$name__O = (function() {
  return $f_Lamf_client_model_domain_Shape__name__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$elseShape__O = (function() {
  return $f_Lamf_client_model_domain_Shape__elseShape__Lamf_client_model_domain_Shape(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withXone__sjs_js_Array__O = (function(subShapes) {
  return $f_Lamf_client_model_domain_Shape__withXone__sjs_js_Array__Lamf_client_model_domain_Shape(this, subShapes)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withAnd__sjs_js_Array__O = (function(subShapes) {
  return $f_Lamf_client_model_domain_Shape__withAnd__sjs_js_Array__Lamf_client_model_domain_Shape(this, subShapes)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_RecursiveShape)) {
    var RecursiveShape$1 = $as_Lamf_client_model_domain_RecursiveShape(x$1);
    var x = this.$$undinternal$1;
    var x$2 = RecursiveShape$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$fixpoint__O = (function() {
  return this.fixpoint__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withCustomShapeProperties__sjs_js_Array__O = (function(customShapeProperties) {
  return $f_Lamf_client_model_domain_Shape__withCustomShapeProperties__sjs_js_Array__Lamf_client_model_domain_Shape(this, customShapeProperties)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$or__O = (function() {
  return $f_Lamf_client_model_domain_Shape__or__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.init___Lamf_core_model_domain_RecursiveShape = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withThen__Lamf_client_model_domain_Shape__O = (function(thenShape) {
  return $f_Lamf_client_model_domain_Shape__withThen__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Shape(this, thenShape)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withReadOnly__Z__O = (function(readOnly) {
  return $f_Lamf_client_model_domain_Shape__withReadOnly__Z__Lamf_client_model_domain_Shape(this, readOnly)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withElse__Lamf_client_model_domain_Shape__O = (function(elseShape) {
  return $f_Lamf_client_model_domain_Shape__withElse__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Shape(this, elseShape)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$values__O = (function() {
  return $f_Lamf_client_model_domain_Shape__values__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withNode__Lamf_client_model_domain_Shape__O = (function(shape) {
  return $f_Lamf_client_model_domain_Shape__withNode__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Shape(this, shape)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withCustomShapePropertyDefinitions__sjs_js_Array__O = (function(propertyDefinitions) {
  return $f_Lamf_client_model_domain_Shape__withCustomShapePropertyDefinitions__sjs_js_Array__Lamf_client_model_domain_Shape(this, propertyDefinitions)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$defaultValueStr__O = (function() {
  return $f_Lamf_client_model_domain_Shape__defaultValueStr__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withDefaultValue__Lamf_client_model_domain_DataNode__O = (function($default) {
  return $f_Lamf_client_model_domain_Shape__withDefaultValue__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_Shape(this, $default)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withIf__Lamf_client_model_domain_Shape__O = (function(ifShape) {
  return $f_Lamf_client_model_domain_Shape__withIf__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Shape(this, ifShape)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$inherits__O = (function() {
  return $f_Lamf_client_model_domain_Shape__inherits__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withDisplayName__T__O = (function(name) {
  return $f_Lamf_client_model_domain_Shape__withDisplayName__T__Lamf_client_model_domain_Shape(this, name)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withFixPoint__T__O = (function(shapeId) {
  return this.withFixPoint__T__Lamf_client_model_domain_RecursiveShape(shapeId)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$thenShape__O = (function() {
  return $f_Lamf_client_model_domain_Shape__thenShape__Lamf_client_model_domain_Shape(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$and__O = (function() {
  return $f_Lamf_client_model_domain_Shape__and__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$readOnly__O = (function() {
  return $f_Lamf_client_model_domain_Shape__readOnly__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_Linkable()
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Recursive shape cannot be linked"))
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withDescription__T__O = (function(description) {
  return $f_Lamf_client_model_domain_Shape__withDescription__T__Lamf_client_model_domain_Shape(this, description)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$customShapeProperties__O = (function() {
  return $f_Lamf_client_model_domain_Shape__customShapeProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$customShapePropertyDefinitions__O = (function() {
  return $f_Lamf_client_model_domain_Shape__customShapePropertyDefinitions__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$description__O = (function() {
  return $f_Lamf_client_model_domain_Shape__description__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$writeOnly__O = (function() {
  return $f_Lamf_client_model_domain_Shape__writeOnly__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withName__T__O = (function(name) {
  return $f_Lamf_client_model_domain_Shape__withName__T__Lamf_client_model_domain_Shape(this, name)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withInherits__sjs_js_Array__O = (function(inherits) {
  return $f_Lamf_client_model_domain_Shape__withInherits__sjs_js_Array__Lamf_client_model_domain_Shape(this, inherits)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$not__O = (function() {
  return $f_Lamf_client_model_domain_Shape__not__Lamf_client_model_domain_Shape(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withValues__sjs_js_Array__O = (function(values) {
  return $f_Lamf_client_model_domain_Shape__withValues__sjs_js_Array__Lamf_client_model_domain_Shape(this, values)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withDefaultStr__T__O = (function(value) {
  return $f_Lamf_client_model_domain_Shape__withDefaultStr__T__Lamf_client_model_domain_Shape(this, value)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.fixpoint__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_CoreClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_RecursiveShapeModel$().FixPoint$1));
  $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$defaultValue__O = (function() {
  return $f_Lamf_client_model_domain_Shape__defaultValue__Lamf_client_model_domain_DataNode(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$prop$ifShape__O = (function() {
  return $f_Lamf_client_model_domain_Shape__ifShape__Lamf_client_model_domain_Shape(this)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withDeprecated__Z__O = (function(deprecated) {
  return $f_Lamf_client_model_domain_Shape__withDeprecated__Z__Lamf_client_model_domain_Shape(this, deprecated)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withThen = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withThen__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withElse = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withElse__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withIf = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withIf__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withDeprecated = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withDeprecated__Z__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withWriteOnly = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withWriteOnly__Z__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withReadOnly = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withReadOnly__Z__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withCustomShapePropertyDefinition = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withCustomShapePropertyDefinition__T__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withCustomShapePropertyDefinitions = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomShapePropertyDefinitions__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withCustomShapeProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomShapeProperties__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withDefaultStr = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDefaultStr__T__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withNode = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withNode__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withXone = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withXone__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withAnd = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withAnd__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withOr = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withOr__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withInherits = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withInherits__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withValues = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withValues__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withDefaultValue = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DataNode(arg);
  return this.$$js$exported$meth$withDefaultValue__Lamf_client_model_domain_DataNode__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withDescription = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDescription__T__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withDisplayName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDisplayName__T__O(prep)
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withName = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withName__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "thenShape", {
  "get": (function() {
    return this.$$js$exported$prop$thenShape__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "elseShape", {
  "get": (function() {
    return this.$$js$exported$prop$elseShape__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "ifShape", {
  "get": (function() {
    return this.$$js$exported$prop$ifShape__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "deprecated", {
  "get": (function() {
    return this.$$js$exported$prop$deprecated__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "writeOnly", {
  "get": (function() {
    return this.$$js$exported$prop$writeOnly__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "readOnly", {
  "get": (function() {
    return this.$$js$exported$prop$readOnly__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "not", {
  "get": (function() {
    return this.$$js$exported$prop$not__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "xone", {
  "get": (function() {
    return this.$$js$exported$prop$xone__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "and", {
  "get": (function() {
    return this.$$js$exported$prop$and__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "or", {
  "get": (function() {
    return this.$$js$exported$prop$or__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "customShapePropertyDefinitions", {
  "get": (function() {
    return this.$$js$exported$prop$customShapePropertyDefinitions__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "customShapeProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customShapeProperties__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "inherits", {
  "get": (function() {
    return this.$$js$exported$prop$inherits__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "values", {
  "get": (function() {
    return this.$$js$exported$prop$values__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "defaultValueStr", {
  "get": (function() {
    return this.$$js$exported$prop$defaultValueStr__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "defaultValue", {
  "get": (function() {
    return this.$$js$exported$prop$defaultValue__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "description", {
  "get": (function() {
    return this.$$js$exported$prop$description__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "displayName", {
  "get": (function() {
    return this.$$js$exported$prop$displayName__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "name", {
  "get": (function() {
    return this.$$js$exported$prop$name__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.withFixPoint = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withFixPoint__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_RecursiveShape.prototype, "fixpoint", {
  "get": (function() {
    return this.$$js$exported$prop$fixpoint__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_RecursiveShape(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_RecursiveShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.RecursiveShape"))
}
function $isArrayOf_Lamf_client_model_domain_RecursiveShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_RecursiveShape)))
}
function $asArrayOf_Lamf_client_model_domain_RecursiveShape(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_RecursiveShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.RecursiveShape;", depth))
}
var $d_Lamf_client_model_domain_RecursiveShape = new $TypeData().initClass({
  Lamf_client_model_domain_RecursiveShape: 0
}, false, "amf.client.model.domain.RecursiveShape", {
  Lamf_client_model_domain_RecursiveShape: 1,
  O: 1,
  Lamf_client_model_domain_Shape: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_RecursiveShape.prototype.$classData = $d_Lamf_client_model_domain_RecursiveShape;
/** @constructor */
function $c_Lamf_client_model_domain_Request() {
  $c_Lamf_client_model_domain_Message.call(this)
}
$c_Lamf_client_model_domain_Request.prototype = new $h_Lamf_client_model_domain_Message();
$c_Lamf_client_model_domain_Request.prototype.constructor = $c_Lamf_client_model_domain_Request;
/** @constructor */
function $h_Lamf_client_model_domain_Request() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_Request.prototype = $c_Lamf_client_model_domain_Request.prototype;
$c_Lamf_client_model_domain_Request.prototype.$$js$exported$prop$cookieParameters__O = (function() {
  return this.cookieParameters__sjs_js_Array()
});
$c_Lamf_client_model_domain_Request.prototype.withUriParameters__sjs_js_Array__Lamf_client_model_domain_Request = (function(uriParameters) {
  var this$2 = $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1);
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  var uriParameters$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, uriParameters, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().UriParameters$1;
  $as_Lamf_plugins_domain_webapi_models_Request($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, uriParameters$1));
  return this
});
$c_Lamf_client_model_domain_Request.prototype.$$js$exported$meth$withHeader__T__O = (function(name) {
  return this.withHeader__T__Lamf_client_model_domain_Parameter(name)
});
$c_Lamf_client_model_domain_Request.prototype.withQueryParameters__sjs_js_Array__Lamf_client_model_domain_Request = (function(parameters) {
  var this$2 = $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1);
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  var parameters$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, parameters, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryParameters$1;
  $as_Lamf_plugins_domain_webapi_models_Request($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, parameters$1));
  return this
});
$c_Lamf_client_model_domain_Request.prototype.productPrefix__T = (function() {
  return "Request"
});
$c_Lamf_client_model_domain_Request.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_Request.prototype.init___Lamf_plugins_domain_webapi_models_Request.call(this, new $c_Lamf_plugins_domain_webapi_models_Request().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_Request.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_Request.prototype.$$js$exported$meth$withHeaders__sjs_js_Array__O = (function(headers) {
  return this.withHeaders__sjs_js_Array__Lamf_client_model_domain_Request(headers)
});
$c_Lamf_client_model_domain_Request.prototype.withCookieParameters__sjs_js_Array__Lamf_client_model_domain_Request = (function(cookieParameters) {
  var this$2 = $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1);
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  var cookieParameters$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, cookieParameters, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().CookieParameters$1;
  $as_Lamf_plugins_domain_webapi_models_Request($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, cookieParameters$1));
  return this
});
$c_Lamf_client_model_domain_Request.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_Request.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_Request)) {
    var Request$1 = $as_Lamf_client_model_domain_Request(x$1);
    var x = $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_domain_webapi_models_Request(Request$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_Request.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_Request.prototype.withHeader__T__Lamf_client_model_domain_Parameter = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1).withHeader__T__Lamf_plugins_domain_webapi_models_Parameter(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Parameter__Lamf_client_model_domain_Parameter(from)
});
$c_Lamf_client_model_domain_Request.prototype.withQueryParameter__T__Lamf_client_model_domain_Parameter = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1).withQueryParameter__T__Lamf_plugins_domain_webapi_models_Parameter(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Parameter__Lamf_client_model_domain_Parameter(from)
});
$c_Lamf_client_model_domain_Request.prototype.linkCopy__Lamf_client_model_domain_Message = (function() {
  return this.linkCopy__Lamf_client_model_domain_Request()
});
$c_Lamf_client_model_domain_Request.prototype.withQueryString__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Request = (function(queryString) {
  var this$2 = $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1);
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var queryString$1 = queryString.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryString$1;
  $as_Lamf_plugins_domain_webapi_models_Request($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, queryString$1));
  return this
});
$c_Lamf_client_model_domain_Request.prototype.$$js$exported$meth$withQueryParameter__T__O = (function(name) {
  return this.withQueryParameter__T__Lamf_client_model_domain_Parameter(name)
});
$c_Lamf_client_model_domain_Request.prototype.cookieParameters__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1);
  var from = $as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().CookieParameters$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Request.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_Request.prototype.required__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1);
  var from = $as_Lamf_core_model_BoolField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Required$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_Request.prototype.init___Lamf_plugins_domain_webapi_models_Request = (function(_internal) {
  $c_Lamf_client_model_domain_Message.prototype.init___Lamf_plugins_domain_webapi_models_Message.call(this, _internal);
  return this
});
$c_Lamf_client_model_domain_Request.prototype.linkCopy__Lamf_client_model_domain_Request = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1);
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$5 = new $c_Lamf_plugins_domain_webapi_models_Request().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_webapi_models_Request($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().RequestMatcher__Lamf_client_convert_MessageConverter$RequestMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Request__Lamf_client_model_domain_Request(from)
});
$c_Lamf_client_model_domain_Request.prototype.$$js$exported$prop$uriParameters__O = (function() {
  return this.uriParameters__sjs_js_Array()
});
$c_Lamf_client_model_domain_Request.prototype.$$js$exported$meth$withCookieParameters__sjs_js_Array__O = (function(cookieParameters) {
  return this.withCookieParameters__sjs_js_Array__Lamf_client_model_domain_Request(cookieParameters)
});
$c_Lamf_client_model_domain_Request.prototype.$$js$exported$meth$withUriParameters__sjs_js_Array__O = (function(uriParameters) {
  return this.withUriParameters__sjs_js_Array__Lamf_client_model_domain_Request(uriParameters)
});
$c_Lamf_client_model_domain_Request.prototype.$$js$exported$prop$queryParameters__O = (function() {
  return this.queryParameters__sjs_js_Array()
});
$c_Lamf_client_model_domain_Request.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_Request()
});
$c_Lamf_client_model_domain_Request.prototype.headers__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1);
  var from = $as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Headers$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Request.prototype.$$js$exported$prop$required__O = (function() {
  return this.required__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_Request.prototype.$$js$exported$meth$withRequired__Z__O = (function(required) {
  return this.withRequired__Z__Lamf_client_model_domain_Request(required)
});
$c_Lamf_client_model_domain_Request.prototype.$$js$exported$prop$headers__O = (function() {
  return this.headers__sjs_js_Array()
});
$c_Lamf_client_model_domain_Request.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_Request()
});
$c_Lamf_client_model_domain_Request.prototype.withRequired__Z__Lamf_client_model_domain_Request = (function(required) {
  var this$1 = $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().Required$1;
  $as_Lamf_plugins_domain_webapi_models_Request($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, required));
  return this
});
$c_Lamf_client_model_domain_Request.prototype.withPayload__T__Lamf_client_model_domain_Payload = (function(mediaType) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1).withPayload__s_Option__Lamf_plugins_domain_webapi_models_Payload(new $c_s_Some().init___O(mediaType));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PayloadMatcher__Lamf_client_convert_PayloadConverter$PayloadMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Payload__Lamf_client_model_domain_Payload(from)
});
$c_Lamf_client_model_domain_Request.prototype.queryParameters__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1);
  var from = $as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryParameters$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Request.prototype.withUriParameter__T__Lamf_client_model_domain_Parameter = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1).withUriParameter__T__Lamf_plugins_domain_webapi_models_Parameter(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Parameter__Lamf_client_model_domain_Parameter(from)
});
$c_Lamf_client_model_domain_Request.prototype.$$js$exported$meth$withCookieParameter__T__O = (function(name) {
  return this.withCookieParameter__T__Lamf_client_model_domain_Parameter(name)
});
$c_Lamf_client_model_domain_Request.prototype.$$js$exported$meth$withPayload__T__O = (function(mediaType) {
  return this.withPayload__T__Lamf_client_model_domain_Payload(mediaType)
});
$c_Lamf_client_model_domain_Request.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_Message = (function() {
  return $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_Request.prototype.queryString__Lamf_client_model_domain_Shape = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1);
  var from = $as_Lamf_core_model_domain_Shape(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().QueryString$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(from)
});
$c_Lamf_client_model_domain_Request.prototype.$$js$exported$meth$withUriParameter__T__O = (function(name) {
  return this.withUriParameter__T__Lamf_client_model_domain_Parameter(name)
});
$c_Lamf_client_model_domain_Request.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_Request.prototype.$$js$exported$meth$withQueryString__Lamf_client_model_domain_Shape__O = (function(queryString) {
  return this.withQueryString__Lamf_client_model_domain_Shape__Lamf_client_model_domain_Request(queryString)
});
$c_Lamf_client_model_domain_Request.prototype.withCookieParameter__T__Lamf_client_model_domain_Parameter = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1).withCookieParameter__T__Lamf_plugins_domain_webapi_models_Parameter(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Parameter__Lamf_client_model_domain_Parameter(from)
});
$c_Lamf_client_model_domain_Request.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_Request.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_Request.prototype.$$js$exported$prop$queryString__O = (function() {
  return this.queryString__Lamf_client_model_domain_Shape()
});
$c_Lamf_client_model_domain_Request.prototype.withHeaders__sjs_js_Array__Lamf_client_model_domain_Request = (function(headers) {
  var this$2 = $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1);
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  var headers$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, headers, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Headers$1;
  $as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, headers$1));
  return this
});
$c_Lamf_client_model_domain_Request.prototype.uriParameters__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_Request(this.$$undinternal$1);
  var from = $as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$().UriParameters$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Request.prototype.$$js$exported$meth$withQueryParameters__sjs_js_Array__O = (function(parameters) {
  return this.withQueryParameters__sjs_js_Array__Lamf_client_model_domain_Request(parameters)
});
$c_Lamf_client_model_domain_Request.prototype.withCookieParameter = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withCookieParameter__T__O(prep)
});
$c_Lamf_client_model_domain_Request.prototype.withUriParameter = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withUriParameter__T__O(prep)
});
$c_Lamf_client_model_domain_Request.prototype.withPayload = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      if ($is_T(rest[0])) {
        var prep$2 = $as_T(rest[0]);
        return this.$$js$exported$meth$withPayload__T__O(prep$2)
      } else {
        var prep = rest[0];
        return this.$$js$exported$meth$withPayload__sjs_js_UndefOr__O(prep)
      };
      break
    }
    case 0: {
      return this.$$js$exported$meth$withPayload__O();
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_model_domain_Request.prototype.withHeader = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withHeader__T__O(prep)
});
$c_Lamf_client_model_domain_Request.prototype.withQueryParameter = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withQueryParameter__T__O(prep)
});
$c_Lamf_client_model_domain_Request.prototype.withCookieParameters = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCookieParameters__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Request.prototype.withUriParameters = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withUriParameters__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Request.prototype.withQueryString = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withQueryString__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_Request.prototype.withHeaders = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withHeaders__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Request.prototype.withQueryParameters = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withQueryParameters__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Request.prototype.withRequired = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withRequired__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Request.prototype, "cookieParameters", {
  "get": (function() {
    return this.$$js$exported$prop$cookieParameters__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Request.prototype, "uriParameters", {
  "get": (function() {
    return this.$$js$exported$prop$uriParameters__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Request.prototype, "queryString", {
  "get": (function() {
    return this.$$js$exported$prop$queryString__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Request.prototype, "headers", {
  "get": (function() {
    return this.$$js$exported$prop$headers__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Request.prototype, "queryParameters", {
  "get": (function() {
    return this.$$js$exported$prop$queryParameters__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Request.prototype, "required", {
  "get": (function() {
    return this.$$js$exported$prop$required__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_Request(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_Request) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Request"))
}
function $isArrayOf_Lamf_client_model_domain_Request(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Request)))
}
function $asArrayOf_Lamf_client_model_domain_Request(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Request(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Request;", depth))
}
var $d_Lamf_client_model_domain_Request = new $TypeData().initClass({
  Lamf_client_model_domain_Request: 0
}, false, "amf.client.model.domain.Request", {
  Lamf_client_model_domain_Request: 1,
  Lamf_client_model_domain_Message: 1,
  O: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_Request.prototype.$classData = $d_Lamf_client_model_domain_Request;
/** @constructor */
function $c_Lamf_client_model_domain_ResourceType() {
  $c_Lamf_client_model_domain_AbstractDeclaration.call(this)
}
$c_Lamf_client_model_domain_ResourceType.prototype = new $h_Lamf_client_model_domain_AbstractDeclaration();
$c_Lamf_client_model_domain_ResourceType.prototype.constructor = $c_Lamf_client_model_domain_ResourceType;
/** @constructor */
function $h_Lamf_client_model_domain_ResourceType() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_ResourceType.prototype = $c_Lamf_client_model_domain_ResourceType.prototype;
$c_Lamf_client_model_domain_ResourceType.prototype.productPrefix__T = (function() {
  return "ResourceType"
});
$c_Lamf_client_model_domain_ResourceType.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_ResourceType.prototype.init___Lamf_plugins_domain_webapi_models_templates_ResourceType.call(this, new $c_Lamf_plugins_domain_webapi_models_templates_ResourceType().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_ResourceType.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return this.linkTarget__sjs_js_UndefOr()
});
$c_Lamf_client_model_domain_ResourceType.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_ResourceType.prototype.init___Lamf_plugins_domain_webapi_models_templates_ResourceType = (function(_internal) {
  $c_Lamf_client_model_domain_AbstractDeclaration.prototype.init___Lamf_core_model_domain_templates_AbstractDeclaration.call(this, _internal);
  return this
});
$c_Lamf_client_model_domain_ResourceType.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_ResourceType)) {
    var ResourceType$1 = $as_Lamf_client_model_domain_ResourceType(x$1);
    var x = $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(ResourceType$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_ResourceType.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_ResourceType.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_ResourceType.prototype.$$js$exported$meth$asEndpoint$default$2__Lamf_ProfileName = (function() {
  return $m_Lamf_RamlProfile$()
});
$c_Lamf_client_model_domain_ResourceType.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_ResourceType.prototype.asEndpoint__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_client_model_domain_EndPoint = (function(unit, profile) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(this.$$undinternal$1).asEndpoint__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_domain_webapi_models_EndPoint(unit.$$undinternal__Lamf_core_model_document_BaseUnit(), profile, ($as_Lamf_plugins_domain_webapi_models_templates_ResourceType(this.$$undinternal$1), $m_Lamf_core_errorhandling_UnhandledErrorHandler$()));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().EndPointMatcher__Lamf_client_convert_EndPointConverter$EndPointMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_EndPoint__Lamf_client_model_domain_EndPoint(from)
});
$c_Lamf_client_model_domain_ResourceType.prototype.linkTarget__sjs_js_UndefOr = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(this.$$undinternal$1);
  var from = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().DomainElementMatcher__Lamf_client_convert_DomainElementConverter$DomainElementMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_ResourceType.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_ResourceType()
});
$c_Lamf_client_model_domain_ResourceType.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_ResourceType()
});
$c_Lamf_client_model_domain_ResourceType.prototype.linkCopy__Lamf_client_model_domain_ResourceType = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(this.$$undinternal$1);
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$6 = new $c_Lamf_plugins_domain_webapi_models_templates_ResourceType().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_webapi_models_templates_ResourceType($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$6, value));
  $m_Lamf_client_convert_WebApiClientConverters$().ResourceTypeMatcher__Lamf_client_convert_ResourceTypeConverter$ResourceTypeMatcher$();
  return new $c_Lamf_client_model_domain_ResourceType().init___Lamf_plugins_domain_webapi_models_templates_ResourceType(from)
});
$c_Lamf_client_model_domain_ResourceType.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_ResourceType.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_ResourceType.prototype.$$undinternal__Lamf_core_model_domain_templates_AbstractDeclaration = (function() {
  return $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_ResourceType.prototype.$$js$exported$meth$asEndpoint__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__O = (function(unit, profile) {
  return this.asEndpoint__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_client_model_domain_EndPoint(unit, profile)
});
$c_Lamf_client_model_domain_ResourceType.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_ResourceType.prototype.linkCopy__Lamf_client_model_domain_AbstractDeclaration = (function() {
  return this.linkCopy__Lamf_client_model_domain_ResourceType()
});
$c_Lamf_client_model_domain_ResourceType.prototype.asEndpoint = (function(arg) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 1;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = $as_Lamf_client_model_document_BaseUnit(arg);
  var prep$2 = ((rest[0] === (void 0)) ? this.$$js$exported$meth$asEndpoint$default$2__Lamf_ProfileName() : $as_Lamf_ProfileName(rest[0]));
  return this.$$js$exported$meth$asEndpoint__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__O(prep, prep$2)
});
function $as_Lamf_client_model_domain_ResourceType(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_ResourceType) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.ResourceType"))
}
function $isArrayOf_Lamf_client_model_domain_ResourceType(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_ResourceType)))
}
function $asArrayOf_Lamf_client_model_domain_ResourceType(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_ResourceType(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.ResourceType;", depth))
}
var $d_Lamf_client_model_domain_ResourceType = new $TypeData().initClass({
  Lamf_client_model_domain_ResourceType: 0
}, false, "amf.client.model.domain.ResourceType", {
  Lamf_client_model_domain_ResourceType: 1,
  Lamf_client_model_domain_AbstractDeclaration: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_ResourceType.prototype.$classData = $d_Lamf_client_model_domain_ResourceType;
/** @constructor */
function $c_Lamf_client_model_domain_Response() {
  $c_Lamf_client_model_domain_Message.call(this)
}
$c_Lamf_client_model_domain_Response.prototype = new $h_Lamf_client_model_domain_Message();
$c_Lamf_client_model_domain_Response.prototype.constructor = $c_Lamf_client_model_domain_Response;
/** @constructor */
function $h_Lamf_client_model_domain_Response() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_Response.prototype = $c_Lamf_client_model_domain_Response.prototype;
$c_Lamf_client_model_domain_Response.prototype.$$js$exported$meth$withHeader__T__O = (function(name) {
  return this.withHeader__T__Lamf_client_model_domain_Parameter(name)
});
$c_Lamf_client_model_domain_Response.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_Response.prototype.init___Lamf_plugins_domain_webapi_models_Response.call(this, new $c_Lamf_plugins_domain_webapi_models_Response().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_Response.prototype.productPrefix__T = (function() {
  return "Response"
});
$c_Lamf_client_model_domain_Response.prototype.init___Lamf_plugins_domain_webapi_models_Response = (function(_internal) {
  $c_Lamf_client_model_domain_Message.prototype.init___Lamf_plugins_domain_webapi_models_Message.call(this, _internal);
  return this
});
$c_Lamf_client_model_domain_Response.prototype.links__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_Response(this.$$undinternal$1);
  var from = $as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Links$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().TemplatedLinkConverter__Lamf_client_convert_TemplatedLinkConverter$TemplatedLinkConverter$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Response.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_Response.prototype.$$js$exported$meth$withHeaders__sjs_js_Array__O = (function(headers) {
  return this.withHeaders__sjs_js_Array__Lamf_client_model_domain_Response(headers)
});
$c_Lamf_client_model_domain_Response.prototype.linkCopy__Lamf_client_model_domain_Response = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_Response(this.$$undinternal$1);
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$5 = new $c_Lamf_plugins_domain_webapi_models_Response().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ResponseMatcher__Lamf_client_convert_MessageConverter$ResponseMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Response__Lamf_client_model_domain_Response(from)
});
$c_Lamf_client_model_domain_Response.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_domain_webapi_models_Response(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_Response.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_Response)) {
    var Response$1 = $as_Lamf_client_model_domain_Response(x$1);
    var x = $as_Lamf_plugins_domain_webapi_models_Response(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_domain_webapi_models_Response(Response$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_Response.prototype.linkCopy__Lamf_client_model_domain_Message = (function() {
  return this.linkCopy__Lamf_client_model_domain_Response()
});
$c_Lamf_client_model_domain_Response.prototype.withHeader__T__Lamf_client_model_domain_Parameter = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = $as_Lamf_plugins_domain_webapi_models_Response(this.$$undinternal$1).withHeader__T__Lamf_plugins_domain_webapi_models_Parameter(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Parameter__Lamf_client_model_domain_Parameter(from)
});
$c_Lamf_client_model_domain_Response.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_domain_webapi_models_Response(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_Response.prototype.withHeaders__sjs_js_Array__Lamf_client_model_domain_Response = (function(headers) {
  var this$2 = $as_Lamf_plugins_domain_webapi_models_Response(this.$$undinternal$1);
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  var headers$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, headers, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Headers$1;
  $as_Lamf_plugins_domain_webapi_models_Message($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, headers$1));
  return this
});
$c_Lamf_client_model_domain_Response.prototype.withLinks__sjs_js_Array__Lamf_client_model_domain_Response = (function(links) {
  var this$2 = $as_Lamf_plugins_domain_webapi_models_Response(this.$$undinternal$1);
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().TemplatedLinkConverter__Lamf_client_convert_TemplatedLinkConverter$TemplatedLinkConverter$();
  var links$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, links, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().Links$1;
  $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, links$1));
  return this
});
$c_Lamf_client_model_domain_Response.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_Response.prototype.$$js$exported$prop$links__O = (function() {
  return this.links__sjs_js_Array()
});
$c_Lamf_client_model_domain_Response.prototype.$$js$exported$meth$withLinks__sjs_js_Array__O = (function(links) {
  return this.withLinks__sjs_js_Array__Lamf_client_model_domain_Response(links)
});
$c_Lamf_client_model_domain_Response.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_Response()
});
$c_Lamf_client_model_domain_Response.prototype.headers__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_Response(this.$$undinternal$1);
  var from = $as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().Headers$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Response.prototype.$$js$exported$meth$withStatusCode__T__O = (function(statusCode) {
  return this.withStatusCode__T__Lamf_client_model_domain_Response(statusCode)
});
$c_Lamf_client_model_domain_Response.prototype.$$js$exported$prop$headers__O = (function() {
  return this.headers__sjs_js_Array()
});
$c_Lamf_client_model_domain_Response.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_Response()
});
$c_Lamf_client_model_domain_Response.prototype.withPayload__T__Lamf_client_model_domain_Payload = (function(mediaType) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = $as_Lamf_plugins_domain_webapi_models_Response(this.$$undinternal$1).withPayload__s_Option__Lamf_plugins_domain_webapi_models_Payload(new $c_s_Some().init___O(mediaType));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PayloadMatcher__Lamf_client_convert_PayloadConverter$PayloadMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_Payload__Lamf_client_model_domain_Payload(from)
});
$c_Lamf_client_model_domain_Response.prototype.$$js$exported$meth$withPayload__T__O = (function(mediaType) {
  return this.withPayload__T__Lamf_client_model_domain_Payload(mediaType)
});
$c_Lamf_client_model_domain_Response.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_Message = (function() {
  return $as_Lamf_plugins_domain_webapi_models_Response(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_Response.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_domain_webapi_models_Response(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_Response.prototype.withStatusCode__T__Lamf_client_model_domain_Response = (function(statusCode) {
  var this$1 = $as_Lamf_plugins_domain_webapi_models_Response(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1;
  $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, statusCode));
  return this
});
$c_Lamf_client_model_domain_Response.prototype.$$js$exported$prop$statusCode__O = (function() {
  return this.statusCode__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_Response.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_Response.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_Response.prototype.statusCode__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_Response(this.$$undinternal$1);
  var from = $as_Lamf_core_model_StrField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_Response.prototype.withPayload = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      if ($is_T(rest[0])) {
        var prep$2 = $as_T(rest[0]);
        return this.$$js$exported$meth$withPayload__T__O(prep$2)
      } else {
        var prep = rest[0];
        return this.$$js$exported$meth$withPayload__sjs_js_UndefOr__O(prep)
      };
      break
    }
    case 0: {
      return this.$$js$exported$meth$withPayload__O();
      break
    }
    default: {
      throw "No matching overload"
    }
  }
});
$c_Lamf_client_model_domain_Response.prototype.withHeader = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withHeader__T__O(prep)
});
$c_Lamf_client_model_domain_Response.prototype.withLinks = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withLinks__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Response.prototype.withHeaders = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withHeaders__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_Response.prototype.withStatusCode = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withStatusCode__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_Response.prototype, "links", {
  "get": (function() {
    return this.$$js$exported$prop$links__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Response.prototype, "headers", {
  "get": (function() {
    return this.$$js$exported$prop$headers__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_Response.prototype, "statusCode", {
  "get": (function() {
    return this.$$js$exported$prop$statusCode__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_Response(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_Response) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Response"))
}
function $isArrayOf_Lamf_client_model_domain_Response(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Response)))
}
function $asArrayOf_Lamf_client_model_domain_Response(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Response(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Response;", depth))
}
var $d_Lamf_client_model_domain_Response = new $TypeData().initClass({
  Lamf_client_model_domain_Response: 0
}, false, "amf.client.model.domain.Response", {
  Lamf_client_model_domain_Response: 1,
  Lamf_client_model_domain_Message: 1,
  O: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_Response.prototype.$classData = $d_Lamf_client_model_domain_Response;
/** @constructor */
function $c_Lamf_client_model_domain_Trait() {
  $c_Lamf_client_model_domain_AbstractDeclaration.call(this)
}
$c_Lamf_client_model_domain_Trait.prototype = new $h_Lamf_client_model_domain_AbstractDeclaration();
$c_Lamf_client_model_domain_Trait.prototype.constructor = $c_Lamf_client_model_domain_Trait;
/** @constructor */
function $h_Lamf_client_model_domain_Trait() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_Trait.prototype = $c_Lamf_client_model_domain_Trait.prototype;
$c_Lamf_client_model_domain_Trait.prototype.asOperation__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_client_model_domain_Operation = (function(unit, profile) {
  return new $c_Lamf_client_model_domain_Operation().init___Lamf_plugins_domain_webapi_models_Operation($as_Lamf_plugins_domain_webapi_models_templates_Trait(this.$$undinternal$1).asOperation__Lamf_core_model_document_BaseUnit__Lamf_ProfileName__Lamf_core_errorhandling_ErrorHandler__Lamf_plugins_domain_webapi_models_Operation(unit.$$undinternal__Lamf_core_model_document_BaseUnit(), profile, ($as_Lamf_plugins_domain_webapi_models_templates_Trait(this.$$undinternal$1), $m_Lamf_core_errorhandling_UnhandledErrorHandler$())))
});
$c_Lamf_client_model_domain_Trait.prototype.productPrefix__T = (function() {
  return "Trait"
});
$c_Lamf_client_model_domain_Trait.prototype.$$js$exported$meth$asOperation$default$2__Lamf_ProfileName = (function() {
  return $m_Lamf_RamlProfile$()
});
$c_Lamf_client_model_domain_Trait.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_Trait.prototype.init___Lamf_plugins_domain_webapi_models_templates_Trait.call(this, new $c_Lamf_plugins_domain_webapi_models_templates_Trait().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_Trait.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return this.linkTarget__sjs_js_UndefOr()
});
$c_Lamf_client_model_domain_Trait.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_Trait.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_Trait)) {
    var Trait$1 = $as_Lamf_client_model_domain_Trait(x$1);
    var x = $as_Lamf_plugins_domain_webapi_models_templates_Trait(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_domain_webapi_models_templates_Trait(Trait$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_Trait.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_domain_webapi_models_templates_Trait(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_Trait.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_domain_webapi_models_templates_Trait(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_Trait.prototype.linkCopy__Lamf_client_model_domain_Trait = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_templates_Trait(this.$$undinternal$1);
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$6 = new $c_Lamf_plugins_domain_webapi_models_templates_Trait().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_webapi_models_templates_Trait($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$6, value));
  $m_Lamf_client_convert_WebApiClientConverters$().TraitMatcher__Lamf_client_convert_TraitConverter$TraitMatcher$();
  return new $c_Lamf_client_model_domain_Trait().init___Lamf_plugins_domain_webapi_models_templates_Trait(from)
});
$c_Lamf_client_model_domain_Trait.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_Trait.prototype.linkTarget__sjs_js_UndefOr = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_webapi_models_templates_Trait(this.$$undinternal$1);
  var from = $f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(this$1);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().DomainElementMatcher__Lamf_client_convert_DomainElementConverter$DomainElementMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_Trait.prototype.init___Lamf_plugins_domain_webapi_models_templates_Trait = (function(_internal) {
  $c_Lamf_client_model_domain_AbstractDeclaration.prototype.init___Lamf_core_model_domain_templates_AbstractDeclaration.call(this, _internal);
  return this
});
$c_Lamf_client_model_domain_Trait.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_Trait()
});
$c_Lamf_client_model_domain_Trait.prototype.$$js$exported$meth$asOperation__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__O = (function(unit, profile) {
  return this.asOperation__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__Lamf_client_model_domain_Operation(unit, profile)
});
$c_Lamf_client_model_domain_Trait.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_Trait()
});
$c_Lamf_client_model_domain_Trait.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_domain_webapi_models_templates_Trait(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_Trait.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_Trait.prototype.$$undinternal__Lamf_core_model_domain_templates_AbstractDeclaration = (function() {
  return $as_Lamf_plugins_domain_webapi_models_templates_Trait(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_Trait.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_Trait.prototype.linkCopy__Lamf_client_model_domain_AbstractDeclaration = (function() {
  return this.linkCopy__Lamf_client_model_domain_Trait()
});
$c_Lamf_client_model_domain_Trait.prototype.asOperation = (function(arg) {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 1;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = $as_Lamf_client_model_document_BaseUnit(arg);
  var prep$2 = ((rest[0] === (void 0)) ? this.$$js$exported$meth$asOperation$default$2__Lamf_ProfileName() : $as_Lamf_ProfileName(rest[0]));
  return this.$$js$exported$meth$asOperation__Lamf_client_model_document_BaseUnit__Lamf_ProfileName__O(prep, prep$2)
});
function $as_Lamf_client_model_domain_Trait(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_Trait) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.Trait"))
}
function $isArrayOf_Lamf_client_model_domain_Trait(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_Trait)))
}
function $asArrayOf_Lamf_client_model_domain_Trait(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_Trait(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.Trait;", depth))
}
var $d_Lamf_client_model_domain_Trait = new $TypeData().initClass({
  Lamf_client_model_domain_Trait: 0
}, false, "amf.client.model.domain.Trait", {
  Lamf_client_model_domain_Trait: 1,
  Lamf_client_model_domain_AbstractDeclaration: 1,
  O: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_Trait.prototype.$classData = $d_Lamf_client_model_domain_Trait;
/** @constructor */
function $c_Lamf_client_model_domain_WebSocketsChannelBinding() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype = new $h_O();
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.constructor = $c_Lamf_client_model_domain_WebSocketsChannelBinding;
/** @constructor */
function $h_Lamf_client_model_domain_WebSocketsChannelBinding() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_WebSocketsChannelBinding.prototype = $c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype;
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.productPrefix__T = (function() {
  return "WebSocketsChannelBinding"
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding.call(this, new $c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.query__Lamf_client_model_domain_Shape = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_domain_Shape(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$().Query$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(from)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.withHeaders__Lamf_client_model_domain_Shape__Lamf_client_model_domain_WebSocketsChannelBinding = (function(headers) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var headers$1 = headers.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$().Headers$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, headers$1));
  return this
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_WebSocketsChannelBinding)) {
    var WebSocketsChannelBinding$1 = $as_Lamf_client_model_domain_WebSocketsChannelBinding(x$1);
    var x = this.$$undinternal$1;
    var x$2 = WebSocketsChannelBinding$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.withBindingVersion__T__Lamf_client_model_domain_WebSocketsChannelBinding = (function(bindingVersion) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$().BindingVersion$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_BindingVersion($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, bindingVersion));
  return this
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.withType__T__Lamf_client_model_domain_WebSocketsChannelBinding = (function(type) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$().Type$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, type));
  return this
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$meth$withQuery__Lamf_client_model_domain_Shape__O = (function(query) {
  return this.withQuery__Lamf_client_model_domain_Shape__Lamf_client_model_domain_WebSocketsChannelBinding(query)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$meth$withBindingVersion__T__O = (function(bindingVersion) {
  return this.withBindingVersion__T__Lamf_client_model_domain_WebSocketsChannelBinding(bindingVersion)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.withQuery__Lamf_client_model_domain_Shape__Lamf_client_model_domain_WebSocketsChannelBinding = (function(query) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var query$1 = query.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$().Query$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, query$1));
  return this
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$meth$withMethod__T__O = (function(method) {
  return this.withMethod__T__Lamf_client_model_domain_WebSocketsChannelBinding(method)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.linkCopy__Lamf_client_model_domain_WebSocketsChannelBinding = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$5 = new $c_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().WebSocketsChannelBindingMatcher__Lamf_client_convert_WebSocketsChannelBindingConverter$WebSocketsChannelBindingMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding__Lamf_client_model_domain_WebSocketsChannelBinding(from)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.type__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$().Type$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_WebSocketsChannelBinding()
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$meth$withType__T__O = (function(type) {
  return this.withType__T__Lamf_client_model_domain_WebSocketsChannelBinding(type)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_ChannelBinding = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$prop$headers__O = (function() {
  return this.headers__Lamf_client_model_domain_Shape()
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_WebSocketsChannelBinding()
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$prop$type__O = (function() {
  return this.type__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.method__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$().Method$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$prop$query__O = (function() {
  return this.query__Lamf_client_model_domain_Shape()
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.headers__Lamf_client_model_domain_Shape = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_domain_Shape(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$().Headers$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(from)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$prop$method__O = (function() {
  return this.method__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.withMethod__T__Lamf_client_model_domain_WebSocketsChannelBinding = (function(method) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_WebSocketsChannelBindingModel$().Method$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_websockets_WebSocketsChannelBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, method));
  return this
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$meth$withHeaders__Lamf_client_model_domain_Shape__O = (function(headers) {
  return this.withHeaders__Lamf_client_model_domain_Shape__Lamf_client_model_domain_WebSocketsChannelBinding(headers)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.withType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withType__T__O(prep)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.withHeaders = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withHeaders__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.withQuery = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withQuery__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.withMethod = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withMethod__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype, "type", {
  "get": (function() {
    return this.$$js$exported$prop$type__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype, "headers", {
  "get": (function() {
    return this.$$js$exported$prop$headers__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype, "query", {
  "get": (function() {
    return this.$$js$exported$prop$query__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype, "method", {
  "get": (function() {
    return this.$$js$exported$prop$method__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.withBindingVersion = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withBindingVersion__T__O(prep)
});
function $as_Lamf_client_model_domain_WebSocketsChannelBinding(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_WebSocketsChannelBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.WebSocketsChannelBinding"))
}
function $isArrayOf_Lamf_client_model_domain_WebSocketsChannelBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_WebSocketsChannelBinding)))
}
function $asArrayOf_Lamf_client_model_domain_WebSocketsChannelBinding(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_WebSocketsChannelBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.WebSocketsChannelBinding;", depth))
}
var $d_Lamf_client_model_domain_WebSocketsChannelBinding = new $TypeData().initClass({
  Lamf_client_model_domain_WebSocketsChannelBinding: 0
}, false, "amf.client.model.domain.WebSocketsChannelBinding", {
  Lamf_client_model_domain_WebSocketsChannelBinding: 1,
  O: 1,
  Lamf_client_model_domain_ChannelBinding: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_BindingVersion: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.$classData = $d_Lamf_client_model_domain_WebSocketsChannelBinding;
/** @constructor */
function $c_Lamf_core_model_document_Document() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.amf$core$model$document$BaseUnit$$run$1 = null;
  this.raw$1 = null;
  this.platform$1 = null;
  this.id$1 = null
}
$c_Lamf_core_model_document_Document.prototype = new $h_O();
$c_Lamf_core_model_document_Document.prototype.constructor = $c_Lamf_core_model_document_Document;
/** @constructor */
function $h_Lamf_core_model_document_Document() {
  /*<skip>*/
}
$h_Lamf_core_model_document_Document.prototype = $c_Lamf_core_model_document_Document.prototype;
$c_Lamf_core_model_document_Document.prototype.productPrefix__T = (function() {
  return "Document"
});
$c_Lamf_core_model_document_Document.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_core_model_document_Document.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_model_document_Document.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_core_model_document_Document.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_model_document_Document)) {
    var Document$1 = $as_Lamf_core_model_document_Document(x$1);
    var x = this.fields__Lamf_core_parser_Fields();
    var x$2 = Document$1.fields__Lamf_core_parser_Fields();
    if ((x === x$2)) {
      var x$3 = this.annotations__Lamf_core_parser_Annotations();
      var x$4 = Document$1.annotations__Lamf_core_parser_Annotations();
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_model_document_Document.prototype.raw$und$eq__s_Option__V = (function(x$1) {
  this.raw$1 = x$1
});
$c_Lamf_core_model_document_Document.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields__Lamf_core_parser_Fields();
      break
    }
    case 1: {
      return this.annotations__Lamf_core_parser_Annotations();
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_model_document_Document.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_core_model_document_Document.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_core_model_document_Document.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_core_metamodel_document_DocumentModel$()
});
$c_Lamf_core_model_document_Document.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_model_document_Document.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_core_model_document_Document.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_core_model_document_Document.prototype.references__sc_Seq = (function() {
  return $as_sc_Seq(this.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().References$1))
});
$c_Lamf_core_model_document_Document.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_core_model_document_Document.prototype.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit = (function(selector, transformation, errorHandler) {
  return $f_Lamf_core_model_document_BaseUnit__transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(this, selector, transformation, errorHandler)
});
$c_Lamf_core_model_document_Document.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this)
});
$c_Lamf_core_model_document_Document.prototype.amf$core$model$document$BaseUnit$$run__s_Option = (function() {
  return this.amf$core$model$document$BaseUnit$$run$1
});
$c_Lamf_core_model_document_Document.prototype.declares__sc_Seq = (function() {
  return $as_sc_Seq(this.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().Declares$1))
});
$c_Lamf_core_model_document_Document.prototype.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V = (function(x$1) {
  this.amf$core$model$document$BaseUnit$$run$1 = x$1
});
$c_Lamf_core_model_document_Document.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_core_model_document_Document.prototype.raw__s_Option = (function() {
  return this.raw$1
});
$c_Lamf_core_model_document_Document.prototype.encodes__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_core_model_domain_DomainElement(this.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().Encodes$1))
});
$c_Lamf_core_model_document_Document.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_model_document_Document.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_model_document_Document.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_core_model_document_Document.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_core_model_document_Document.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  $f_Lamf_core_model_document_BaseUnit__$$init$__V(this);
  return this
});
function $as_Lamf_core_model_document_Document(obj) {
  return (((obj instanceof $c_Lamf_core_model_document_Document) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.document.Document"))
}
function $isArrayOf_Lamf_core_model_document_Document(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_document_Document)))
}
function $asArrayOf_Lamf_core_model_document_Document(obj, depth) {
  return (($isArrayOf_Lamf_core_model_document_Document(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.document.Document;", depth))
}
var $d_Lamf_core_model_document_Document = new $TypeData().initClass({
  Lamf_core_model_document_Document: 0
}, false, "amf.core.model.document.Document", {
  Lamf_core_model_document_Document: 1,
  O: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_model_document_EncodesModel: 1,
  Lamf_core_model_document_DeclaresModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_document_Document.prototype.$classData = $d_Lamf_core_model_document_Document;
/** @constructor */
function $c_Lamf_core_model_document_ExternalFragment() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.amf$core$model$document$BaseUnit$$run$1 = null;
  this.raw$1 = null;
  this.platform$1 = null;
  this.id$1 = null
}
$c_Lamf_core_model_document_ExternalFragment.prototype = new $h_O();
$c_Lamf_core_model_document_ExternalFragment.prototype.constructor = $c_Lamf_core_model_document_ExternalFragment;
/** @constructor */
function $h_Lamf_core_model_document_ExternalFragment() {
  /*<skip>*/
}
$h_Lamf_core_model_document_ExternalFragment.prototype = $c_Lamf_core_model_document_ExternalFragment.prototype;
$c_Lamf_core_model_document_ExternalFragment.prototype.productPrefix__T = (function() {
  return "ExternalFragment"
});
$c_Lamf_core_model_document_ExternalFragment.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_core_model_document_ExternalFragment.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_model_document_ExternalFragment.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_core_model_document_ExternalFragment.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_model_document_ExternalFragment)) {
    var ExternalFragment$1 = $as_Lamf_core_model_document_ExternalFragment(x$1);
    var x = this.fields$1;
    var x$2 = ExternalFragment$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = ExternalFragment$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_model_document_ExternalFragment.prototype.raw$und$eq__s_Option__V = (function(x$1) {
  this.raw$1 = x$1
});
$c_Lamf_core_model_document_ExternalFragment.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_model_document_ExternalFragment.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_core_model_document_ExternalFragment.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_core_model_document_ExternalFragment.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_core_metamodel_document_ExternalFragmentModel$()
});
$c_Lamf_core_model_document_ExternalFragment.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_model_document_ExternalFragment.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_core_model_document_ExternalFragment.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_core_model_document_ExternalFragment.prototype.references__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().References$1))
});
$c_Lamf_core_model_document_ExternalFragment.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_core_model_document_ExternalFragment.prototype.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit = (function(selector, transformation, errorHandler) {
  return $f_Lamf_core_model_document_BaseUnit__transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(this, selector, transformation, errorHandler)
});
$c_Lamf_core_model_document_ExternalFragment.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this)
});
$c_Lamf_core_model_document_ExternalFragment.prototype.amf$core$model$document$BaseUnit$$run__s_Option = (function() {
  return this.amf$core$model$document$BaseUnit$$run$1
});
$c_Lamf_core_model_document_ExternalFragment.prototype.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V = (function(x$1) {
  this.amf$core$model$document$BaseUnit$$run$1 = x$1
});
$c_Lamf_core_model_document_ExternalFragment.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_core_model_document_ExternalFragment.prototype.raw__s_Option = (function() {
  return this.raw$1
});
$c_Lamf_core_model_document_ExternalFragment.prototype.encodes__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_core_model_domain_ExternalDomainElement($as_Lamf_core_model_domain_DomainElement(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)))
});
$c_Lamf_core_model_document_ExternalFragment.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_model_document_ExternalFragment.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_model_document_ExternalFragment.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_core_model_document_ExternalFragment.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_core_model_document_ExternalFragment.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  $f_Lamf_core_model_document_BaseUnit__$$init$__V(this);
  return this
});
function $as_Lamf_core_model_document_ExternalFragment(obj) {
  return (((obj instanceof $c_Lamf_core_model_document_ExternalFragment) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.document.ExternalFragment"))
}
function $isArrayOf_Lamf_core_model_document_ExternalFragment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_document_ExternalFragment)))
}
function $asArrayOf_Lamf_core_model_document_ExternalFragment(obj, depth) {
  return (($isArrayOf_Lamf_core_model_document_ExternalFragment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.document.ExternalFragment;", depth))
}
var $d_Lamf_core_model_document_ExternalFragment = new $TypeData().initClass({
  Lamf_core_model_document_ExternalFragment: 0
}, false, "amf.core.model.document.ExternalFragment", {
  Lamf_core_model_document_ExternalFragment: 1,
  O: 1,
  Lamf_core_model_document_Fragment: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_model_document_EncodesModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_document_ExternalFragment.prototype.$classData = $d_Lamf_core_model_document_ExternalFragment;
/** @constructor */
function $c_Lamf_core_model_document_PayloadFragment() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.amf$core$model$document$BaseUnit$$run$1 = null;
  this.raw$1 = null;
  this.platform$1 = null;
  this.id$1 = null
}
$c_Lamf_core_model_document_PayloadFragment.prototype = new $h_O();
$c_Lamf_core_model_document_PayloadFragment.prototype.constructor = $c_Lamf_core_model_document_PayloadFragment;
/** @constructor */
function $h_Lamf_core_model_document_PayloadFragment() {
  /*<skip>*/
}
$h_Lamf_core_model_document_PayloadFragment.prototype = $c_Lamf_core_model_document_PayloadFragment.prototype;
$c_Lamf_core_model_document_PayloadFragment.prototype.productPrefix__T = (function() {
  return "PayloadFragment"
});
$c_Lamf_core_model_document_PayloadFragment.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_core_model_document_PayloadFragment.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_model_document_PayloadFragment.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_core_model_document_PayloadFragment.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_model_document_PayloadFragment)) {
    var PayloadFragment$1 = $as_Lamf_core_model_document_PayloadFragment(x$1);
    var x = this.fields$1;
    var x$2 = PayloadFragment$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = PayloadFragment$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_model_document_PayloadFragment.prototype.raw$und$eq__s_Option__V = (function(x$1) {
  this.raw$1 = x$1
});
$c_Lamf_core_model_document_PayloadFragment.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_model_document_PayloadFragment.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_core_model_document_PayloadFragment.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_core_model_document_PayloadFragment.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_core_metamodel_document_PayloadFragmentModel$()
});
$c_Lamf_core_model_document_PayloadFragment.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_model_document_PayloadFragment.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_core_model_document_PayloadFragment.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_core_model_document_PayloadFragment.prototype.references__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().References$1))
});
$c_Lamf_core_model_document_PayloadFragment.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_core_model_document_PayloadFragment.prototype.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit = (function(selector, transformation, errorHandler) {
  return $f_Lamf_core_model_document_BaseUnit__transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(this, selector, transformation, errorHandler)
});
$c_Lamf_core_model_document_PayloadFragment.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this)
});
$c_Lamf_core_model_document_PayloadFragment.prototype.amf$core$model$document$BaseUnit$$run__s_Option = (function() {
  return this.amf$core$model$document$BaseUnit$$run$1
});
$c_Lamf_core_model_document_PayloadFragment.prototype.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V = (function(x$1) {
  this.amf$core$model$document$BaseUnit$$run$1 = x$1
});
$c_Lamf_core_model_document_PayloadFragment.prototype.withMediaType__T__Lamf_core_model_document_PayloadFragment = (function(mediaType) {
  var field = $m_Lamf_core_metamodel_document_PayloadFragmentModel$().MediaType$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this, field, mediaType);
  return this
});
$c_Lamf_core_model_document_PayloadFragment.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_core_model_document_PayloadFragment.prototype.raw__s_Option = (function() {
  return this.raw$1
});
$c_Lamf_core_model_document_PayloadFragment.prototype.encodes__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_core_model_domain_DataNode(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_PayloadFragmentModel$().Encodes$1))
});
$c_Lamf_core_model_document_PayloadFragment.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_model_document_PayloadFragment.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_model_document_PayloadFragment.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_core_model_document_PayloadFragment.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_core_model_document_PayloadFragment.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  $f_Lamf_core_model_document_BaseUnit__$$init$__V(this);
  return this
});
function $as_Lamf_core_model_document_PayloadFragment(obj) {
  return (((obj instanceof $c_Lamf_core_model_document_PayloadFragment) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.document.PayloadFragment"))
}
function $isArrayOf_Lamf_core_model_document_PayloadFragment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_document_PayloadFragment)))
}
function $asArrayOf_Lamf_core_model_document_PayloadFragment(obj, depth) {
  return (($isArrayOf_Lamf_core_model_document_PayloadFragment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.document.PayloadFragment;", depth))
}
var $d_Lamf_core_model_document_PayloadFragment = new $TypeData().initClass({
  Lamf_core_model_document_PayloadFragment: 0
}, false, "amf.core.model.document.PayloadFragment", {
  Lamf_core_model_document_PayloadFragment: 1,
  O: 1,
  Lamf_core_model_document_Fragment: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_model_document_EncodesModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_document_PayloadFragment.prototype.$classData = $d_Lamf_core_model_document_PayloadFragment;
/** @constructor */
function $c_Lamf_core_model_document_RecursiveUnit() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.amf$core$model$document$BaseUnit$$run$1 = null;
  this.raw$1 = null;
  this.platform$1 = null;
  this.id$1 = null
}
$c_Lamf_core_model_document_RecursiveUnit.prototype = new $h_O();
$c_Lamf_core_model_document_RecursiveUnit.prototype.constructor = $c_Lamf_core_model_document_RecursiveUnit;
/** @constructor */
function $h_Lamf_core_model_document_RecursiveUnit() {
  /*<skip>*/
}
$h_Lamf_core_model_document_RecursiveUnit.prototype = $c_Lamf_core_model_document_RecursiveUnit.prototype;
$c_Lamf_core_model_document_RecursiveUnit.prototype.productPrefix__T = (function() {
  return "RecursiveUnit"
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_model_document_RecursiveUnit)) {
    var RecursiveUnit$1 = $as_Lamf_core_model_document_RecursiveUnit(x$1);
    var x = this.fields$1;
    var x$2 = RecursiveUnit$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = RecursiveUnit$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.raw$und$eq__s_Option__V = (function(x$1) {
  this.raw$1 = x$1
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return new $c_Lamf_core_model_document_RecursiveUnit$$anon$1().init___Lamf_core_model_document_RecursiveUnit(this)
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.componentId__T = (function() {
  return "/recursive"
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.references__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().References$1))
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit = (function(selector, transformation, errorHandler) {
  return $f_Lamf_core_model_document_BaseUnit__transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(this, selector, transformation, errorHandler)
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this)
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.amf$core$model$document$BaseUnit$$run__s_Option = (function() {
  return this.amf$core$model$document$BaseUnit$$run$1
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V = (function(x$1) {
  this.amf$core$model$document$BaseUnit$$run$1 = x$1
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.raw__s_Option = (function() {
  return this.raw$1
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.encodes__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_core_model_domain_DomainElement(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  $f_Lamf_core_model_document_BaseUnit__$$init$__V(this);
  return this
});
function $as_Lamf_core_model_document_RecursiveUnit(obj) {
  return (((obj instanceof $c_Lamf_core_model_document_RecursiveUnit) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.document.RecursiveUnit"))
}
function $isArrayOf_Lamf_core_model_document_RecursiveUnit(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_document_RecursiveUnit)))
}
function $asArrayOf_Lamf_core_model_document_RecursiveUnit(obj, depth) {
  return (($isArrayOf_Lamf_core_model_document_RecursiveUnit(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.document.RecursiveUnit;", depth))
}
var $d_Lamf_core_model_document_RecursiveUnit = new $TypeData().initClass({
  Lamf_core_model_document_RecursiveUnit: 0
}, false, "amf.core.model.document.RecursiveUnit", {
  Lamf_core_model_document_RecursiveUnit: 1,
  O: 1,
  Lamf_core_model_document_Fragment: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_model_document_EncodesModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_document_RecursiveUnit.prototype.$classData = $d_Lamf_core_model_document_RecursiveUnit;
/** @constructor */
function $c_Lamf_core_model_domain_extensions_PropertyShape() {
  $c_Lamf_core_model_domain_Shape.call(this);
  this.fields$2 = null;
  this.annotations$2 = null
}
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype = new $h_Lamf_core_model_domain_Shape();
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.constructor = $c_Lamf_core_model_domain_extensions_PropertyShape;
/** @constructor */
function $h_Lamf_core_model_domain_extensions_PropertyShape() {
  /*<skip>*/
}
$h_Lamf_core_model_domain_extensions_PropertyShape.prototype = $c_Lamf_core_model_domain_extensions_PropertyShape.prototype;
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.productPrefix__T = (function() {
  return "PropertyShape"
});
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return this.adopted__T__sc_Seq__Lamf_core_model_domain_extensions_PropertyShape(parent, cycle)
});
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_core_model_domain_extensions_PropertyShape)) {
    var PropertyShape$1 = $as_Lamf_core_model_domain_extensions_PropertyShape(x$1);
    var x = this.fields$2;
    var x$2 = PropertyShape$1.fields$2;
    if ((x === x$2)) {
      var x$3 = this.annotations$2;
      var x$4 = PropertyShape$1.annotations$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_extensions_PropertyShape = (function(parent, cycle) {
  $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent);
  if ($m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(this.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1))).isDefined__Z()) {
    var jsx$3 = $as_Lamf_core_model_domain_Shape(this.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$().Range$1));
    var jsx$2 = this.id$1;
    var jsx$1 = this.id$1;
    var this$1 = $m_sc_Seq$();
    jsx$3.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(jsx$2, $as_sc_Seq(cycle.$$colon$plus__O__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2)))
  };
  return this
});
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$2;
      break
    }
    case 1: {
      return this.annotations$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_core_model_domain_extensions_PropertyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$()
});
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.cloneShape$default$4__Z = (function() {
  return false
});
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-property" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/property/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.cloneShape__s_Option__s_Option__Lamf_core_traversal_ModelTraversalRegistry__Z__Lamf_core_model_domain_Shape = (function(recursionErrorHandler, recursionBase, traversed, cloneExample) {
  return this.cloneShape__s_Option__s_Option__Lamf_core_traversal_ModelTraversalRegistry__Z__Lamf_core_model_domain_extensions_PropertyShape(recursionErrorHandler, recursionBase, traversed, cloneExample)
});
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_core_model_domain_extensions_PropertyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.cloneShape__s_Option__s_Option__Lamf_core_traversal_ModelTraversalRegistry__Z__Lamf_core_model_domain_extensions_PropertyShape = (function(recursionErrorHandler, withRecursionBase, traversal, cloneExamples) {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lamf_core_parser_Annotations__Lamf_core_parser_Annotations(this.annotations$2);
  var cloned = new $c_Lamf_core_model_domain_extensions_PropertyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  cloned.id$1 = this.id$1;
  this.copyFields__s_Option__Lamf_core_model_domain_Shape__s_Option__Lamf_core_traversal_ModelTraversalRegistry__V(recursionErrorHandler, cloned, withRecursionBase, traversal);
  return cloned
});
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$2 = fields;
  this.annotations$2 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_core_model_domain_extensions_PropertyShape(obj) {
  return (((obj instanceof $c_Lamf_core_model_domain_extensions_PropertyShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.domain.extensions.PropertyShape"))
}
function $isArrayOf_Lamf_core_model_domain_extensions_PropertyShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_domain_extensions_PropertyShape)))
}
function $asArrayOf_Lamf_core_model_domain_extensions_PropertyShape(obj, depth) {
  return (($isArrayOf_Lamf_core_model_domain_extensions_PropertyShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.domain.extensions.PropertyShape;", depth))
}
var $d_Lamf_core_model_domain_extensions_PropertyShape = new $TypeData().initClass({
  Lamf_core_model_domain_extensions_PropertyShape: 0
}, false, "amf.core.model.domain.extensions.PropertyShape", {
  Lamf_core_model_domain_extensions_PropertyShape: 1,
  Lamf_core_model_domain_Shape: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelper: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_model_domain_extensions_PropertyShape.prototype.$classData = $d_Lamf_core_model_domain_extensions_PropertyShape;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_document_DialectFragment() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.amf$core$model$document$BaseUnit$$run$1 = null;
  this.raw$1 = null;
  this.platform$1 = null;
  this.id$1 = null
}
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_document_DialectFragment;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_document_DialectFragment() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype = $c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype;
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.productPrefix__T = (function() {
  return "DialectFragment"
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectFragment)) {
    var DialectFragment$1 = $as_Lamf_plugins_document_vocabularies_model_document_DialectFragment(x$1);
    var x = this.fields$1;
    var x$2 = DialectFragment$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = DialectFragment$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.raw$und$eq__s_Option__V = (function(x$1) {
  this.raw$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectFragmentModel$()
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.references__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().References$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit = (function(selector, transformation, errorHandler) {
  return $f_Lamf_core_model_document_BaseUnit__transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(this, selector, transformation, errorHandler)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.amf$core$model$document$BaseUnit$$run__s_Option = (function() {
  return this.amf$core$model$document$BaseUnit$$run$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V = (function(x$1) {
  this.amf$core$model$document$BaseUnit$$run$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.raw__s_Option = (function() {
  return this.raw$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.encodes__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_document_vocabularies_model_domain_NodeMapping(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Encodes$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  $f_Lamf_core_model_document_BaseUnit__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_document_vocabularies_model_document_DialectFragment(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectFragment) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.document.DialectFragment"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_document_DialectFragment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_document_DialectFragment)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_document_DialectFragment(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_document_DialectFragment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.document.DialectFragment;", depth))
}
var $d_Lamf_plugins_document_vocabularies_model_document_DialectFragment = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_document_DialectFragment: 0
}, false, "amf.plugins.document.vocabularies.model.document.DialectFragment", {
  Lamf_plugins_document_vocabularies_model_document_DialectFragment: 1,
  O: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_model_document_EncodesModel: 1,
  Lamf_plugins_document_vocabularies_model_document_ExternalContext: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectFragment.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_document_DialectFragment;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.amf$core$model$document$BaseUnit$$run$1 = null;
  this.raw$1 = null;
  this.platform$1 = null;
  this.id$1 = null
}
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_document_Vocabulary() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype = $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype;
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.productPrefix__T = (function() {
  return "Vocabulary"
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary)) {
    var Vocabulary$1 = $as_Lamf_plugins_document_vocabularies_model_document_Vocabulary(x$1);
    var x = this.fields$1;
    var x$2 = Vocabulary$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = Vocabulary$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.raw$und$eq__s_Option__V = (function(x$1) {
  this.raw$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$()
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.references__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().References$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit = (function(selector, transformation, errorHandler) {
  return $f_Lamf_core_model_document_BaseUnit__transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(this, selector, transformation, errorHandler)
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.amf$core$model$document$BaseUnit$$run__s_Option = (function() {
  return this.amf$core$model$document$BaseUnit$$run$1
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.declares__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_VocabularyModel$().Declares$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V = (function(x$1) {
  this.amf$core$model$document$BaseUnit$$run$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.raw__s_Option = (function() {
  return this.raw$1
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  $f_Lamf_core_model_document_BaseUnit__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_document_vocabularies_model_document_Vocabulary(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_document_Vocabulary) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.document.Vocabulary"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_document_Vocabulary(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_document_Vocabulary)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_document_Vocabulary(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_document_Vocabulary(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.document.Vocabulary;", depth))
}
var $d_Lamf_plugins_document_vocabularies_model_document_Vocabulary = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_document_Vocabulary: 0
}, false, "amf.plugins.document.vocabularies.model.document.Vocabulary", {
  Lamf_plugins_document_vocabularies_model_document_Vocabulary: 1,
  O: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_model_document_DeclaresModel: 1,
  Lamf_plugins_document_vocabularies_model_document_ExternalContext: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_document_Vocabulary.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_document_Vocabulary;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext() {
  $c_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.call(this);
  this.wrapped$4 = null;
  this.ds$4 = null;
  this.operationIds$4 = null;
  this.declarations$4 = null
}
$c_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
$c_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext.prototype.validateRefFormatWithError__T__Z = (function(ref) {
  if ((!(($uI(ref.indexOf("#")) !== (-1)) && ($uI(ref.indexOf("#/")) === (-1))))) {
    return true
  } else {
    var this$7 = this.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().MalformedJsonReference$1;
    var node = this.rootContextDocument$1;
    var message = (("AsyncApi JSONReference '" + ref) + "' should use '#/', not '#' only");
    var property = $m_s_None$();
    var lexical = $m_s_None$();
    var location = $m_s_None$();
    this$7.reportConstraint__T__T__s_Option__T__s_Option__T__s_Option__V(specification.id$1, node, property, message, lexical, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, location);
    return false
  }
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext.prototype.declarations__Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations = (function() {
  return this.declarations$4
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext.prototype.init___T__sc_Seq__Lamf_core_client_ParsingOptions__Lamf_core_parser_ParserContext__s_Option__scm_Set = (function(loc, refs, options, wrapped, ds, operationIds) {
  this.wrapped$4 = wrapped;
  this.ds$4 = ds;
  this.operationIds$4 = operationIds;
  $c_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.prototype.init___T__sc_Seq__Lamf_core_client_ParsingOptions__Lamf_core_parser_ParserContext__s_Option__scm_Set.call(this, loc, refs, options, wrapped, ds, operationIds);
  if (ds.isEmpty__Z()) {
    var jsx$3 = this.refs$1;
    var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(r$2) {
        var r = $as_Lamf_core_parser_ParsedReference(r$2);
        if ((r.unit$1 instanceof $c_Lamf_core_model_document_ExternalFragment)) {
          var this$1 = $as_Lamf_core_model_document_ExternalFragment(r.unit$1);
          var this$2 = $as_Lamf_core_model_domain_ExternalDomainElement($as_Lamf_core_model_domain_DomainElement(this$1.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))).parsed$1;
          if (this$2.isEmpty__Z()) {
            var xo = $m_s_None$()
          } else {
            var arg1 = this$2.get__O();
            var node = $as_Lorg_yaml_model_YNode(arg1);
            var self = r.origin$1.url$1;
            var xo = new $c_s_Some().init___O(new $c_T2().init___O__O(self, node))
          };
          return xo.toList__sci_List()
        } else {
          var xo$1 = $m_s_None$();
          return xo$1.toList__sci_List()
        }
      })
    })(this));
    var this$7 = $m_sc_Seq$();
    var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations().init___sci_Map__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations($as_sc_TraversableOnce(jsx$3.flatMap__F1__scg_CanBuildFrom__O(jsx$2, this$7.ReusableCBFInstance$2)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2), $m_s_None$(), this.eh$1, this.futureDeclarations$1)
  } else {
    var jsx$1 = ds.get__O()
  };
  this.declarations$4 = $as_Lamf_plugins_document_webapi_parser_spec_AsyncWebApiDeclarations(jsx$1);
  return this
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext.prototype.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function() {
  return this.declarations$4
});
function $as_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.parser.async.AsyncWebApiContext"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.parser.async.AsyncWebApiContext;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext() {
  $c_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.call(this);
  this.wrapped$4 = null;
  this.ds$4 = null;
  this.operationIds$4 = null;
  this.declarations$4 = null
}
$c_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext();
$c_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext.prototype.declarations__Lamf_plugins_document_webapi_parser_spec_OasLikeWebApiDeclarations = (function() {
  return this.declarations$4
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext.prototype.init___T__sc_Seq__Lamf_core_client_ParsingOptions__Lamf_core_parser_ParserContext__s_Option__scm_Set = (function(loc, refs, options, wrapped, ds, operationIds) {
  this.wrapped$4 = wrapped;
  this.ds$4 = ds;
  this.operationIds$4 = operationIds;
  $c_Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext.prototype.init___T__sc_Seq__Lamf_core_client_ParsingOptions__Lamf_core_parser_ParserContext__s_Option__scm_Set.call(this, loc, refs, options, wrapped, ds, $as_scm_Set($m_scm_HashSet$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
  if (ds.isEmpty__Z()) {
    var jsx$3 = this.refs$1;
    var jsx$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(r$2) {
        var r = $as_Lamf_core_parser_ParsedReference(r$2);
        if ((r.unit$1 instanceof $c_Lamf_core_model_document_ExternalFragment)) {
          var this$2 = $as_Lamf_core_model_document_ExternalFragment(r.unit$1);
          var this$3 = $as_Lamf_core_model_domain_ExternalDomainElement($as_Lamf_core_model_domain_DomainElement(this$2.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))).parsed$1;
          if (this$3.isEmpty__Z()) {
            var xo = $m_s_None$()
          } else {
            var arg1 = this$3.get__O();
            var node = $as_Lorg_yaml_model_YNode(arg1);
            var self = r.origin$1.url$1;
            var xo = new $c_s_Some().init___O(new $c_T2().init___O__O(self, node))
          };
          return xo.toList__sci_List()
        } else {
          var xo$1 = $m_s_None$();
          return xo$1.toList__sci_List()
        }
      })
    })(this));
    var this$8 = $m_sc_Seq$();
    var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations().init___sci_Map__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations($as_sc_TraversableOnce(jsx$3.flatMap__F1__scg_CanBuildFrom__O(jsx$2, this$8.ReusableCBFInstance$2)).toMap__s_Predef$$less$colon$less__sci_Map($m_s_Predef$().singleton$und$less$colon$less$2), $m_s_None$(), this.eh$1, this.futureDeclarations$1)
  } else {
    var jsx$1 = ds.get__O()
  };
  this.declarations$4 = $as_Lamf_plugins_document_webapi_parser_spec_OasWebApiDeclarations(jsx$1);
  return this
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext.prototype.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function() {
  return this.declarations$4
});
function $as_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.parser.oas.OasWebApiContext"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.parser.oas.OasWebApiContext;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext() {
  $c_Lamf_plugins_document_webapi_contexts_WebApiContext.call(this);
  this.wrapped$3 = null;
  this.ds$3 = null;
  this.contextType$3 = null;
  this.globalMediatype$3 = false;
  this.operationContexts$3 = null;
  this.declarations$3 = null
}
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_WebApiContext();
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype.init___T__sc_Seq__Lamf_core_client_ParsingOptions__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value = (function(loc, refs, options, wrapped, ds, contextType) {
  this.wrapped$3 = wrapped;
  this.ds$3 = ds;
  this.contextType$3 = contextType;
  $c_Lamf_plugins_document_webapi_contexts_WebApiContext.prototype.init___T__sc_Seq__Lamf_core_client_ParsingOptions__Lamf_core_parser_ParserContext__s_Option.call(this, loc, refs, options, wrapped, ds);
  this.globalMediatype$3 = false;
  this.operationContexts$3 = $as_scm_Map($m_scm_Map$().apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
  if (ds.isEmpty__Z()) {
    var x$1 = $m_s_None$();
    var x$2 = this.futureDeclarations$1;
    var x$3 = this.eh$1;
    var x$4 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var x$5 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
    var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().init___sci_Map__sci_Map__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations(x$4, x$5, x$1, x$3, x$2)
  } else {
    var jsx$1 = ds.get__O()
  };
  this.declarations$3 = $as_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations(jsx$1);
  return this
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype.isAllowedNestedEndpoint$1__p3__T__T__Z = (function(property$1, shape$1) {
  var this$1 = $m_sci_Nil$();
  var this$2 = new $c_sci_$colon$colon().init___O__sci_List("endPoint", this$1);
  var shapesIgnoringNestedEndpoints = new $c_sci_$colon$colon().init___O__sci_List("webApi", this$2);
  return ((($uI(property$1.length) >= 0) && ($as_T(property$1.substring(0, $uI("/".length))) === "/")) && $f_sc_LinearSeqOptimized__contains__O__Z(shapesIgnoringNestedEndpoints, shape$1))
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype.isInclude__p3__Lorg_yaml_model_YNode__Z = (function(node) {
  var x = node.tag__Lorg_yaml_model_YTag().tagType$3;
  var x$2 = $m_Lorg_yaml_model_YType$().Include$1;
  return (x === x$2)
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype.supportsAnnotations__Z = (function() {
  return true
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations = (function() {
  return this.declarations$3
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype.autoGeneratedAnnotation__Lamf_core_model_domain_Shape__V = (function(s) {
  $m_Lamf_plugins_document_webapi_parser_spec_domain_ParsingHelpers$().ramlAutoGeneratedAnnotation__Lamf_core_model_domain_Shape__V(s)
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype.findDeclarations__sc_Seq__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations = (function(path, declarations) {
  if (path.isEmpty__Z()) {
    return declarations
  } else {
    var nextLibrary = $as_T(path.head__O());
    var x1 = declarations.libraries$1.get__O__s_Option(nextLibrary);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var library = $as_Lamf_core_parser_Declarations(x2.value$2);
      if ((library instanceof $c_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations)) {
        var x3 = $as_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations(library);
        return this.findDeclarations__sc_Seq__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations($as_sc_Seq(path.tail__O()), x3)
      }
    };
    var violationId = $m_Lamf_plugins_features_validation_CoreValidations$().DeclarationNotFound$1;
    var message = ("Cannot find declarations in context '" + path.mkString__T__T("."));
    var this$1 = this.eh$1;
    var location = this.rootContextDocument$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__T__V(this$1, violationId, "", message, location);
    return declarations
  }
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype.isAllowedParameter$1__p3__T__T__Z = (function(property$1, shape$1) {
  var this$1 = $m_sci_Nil$();
  var this$2 = new $c_sci_$colon$colon().init___O__sci_List("trait", this$1);
  var shapesWithParameters = new $c_sci_$colon$colon().init___O__sci_List("resourceType", this$2);
  if ((property$1 === null)) {
    throw new $c_jl_NullPointerException().init___()
  };
  if ($m_ju_regex_Pattern$().matches__T__jl_CharSequence__Z("<<.+>>", property$1)) {
    return $f_sc_LinearSeqOptimized__contains__O__Z(shapesWithParameters, shape$1)
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype.closedRamlTypeShape__Lamf_core_model_domain_Shape__Lorg_yaml_model_YMap__T__Lamf_plugins_document_webapi_parser_spec_declaration_TypeInfo__V = (function(shape, ast, shapeType, typeInfo) {
  var node = shape.id$1;
  var facets = shape.collectCustomShapePropertyDefinitions__Z__scm_Set__sc_Seq(true, $as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
  var shapeLabel = $m_Lamf_plugins_document_webapi_parser_RamlShapeTypeBeautifier$().beautify__T__T(shapeType);
  var x1 = this.syntax__Lamf_plugins_document_webapi_parser_spec_SpecSyntax().nodes__sci_Map().get__O__s_Option(shapeType);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var props = $as_sci_Set(x2.value$2);
    var initialProperties = new $c_sr_ObjectRef().init___O(props);
    if (typeInfo.isAnnotation$1) {
      initialProperties.elem$1 = $as_sci_Set($as_sci_Set(initialProperties.elem$1).$$plus$plus__sc_GenTraversableOnce__sc_Set($as_sc_GenTraversableOnce(this.syntax__Lamf_plugins_document_webapi_parser_spec_SpecSyntax().nodes__sci_Map().apply__O__O("annotation"))))
    };
    if (typeInfo.isPropertyOrParameter$1) {
      initialProperties.elem$1 = $as_sci_Set($as_sci_Set(initialProperties.elem$1).$$plus$plus__sc_GenTraversableOnce__sc_Set($as_sc_GenTraversableOnce(this.syntax__Lamf_plugins_document_webapi_parser_spec_SpecSyntax().nodes__sci_Map().apply__O__O("property"))))
    };
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, initialProperties$1, ast$1, shapeType$1) {
      return (function(propertiesMap$2) {
        var propertiesMap = $as_sci_Map(propertiesMap$2);
        var totalProperties = $as_sci_Set($as_sci_Set(initialProperties$1.elem$1).$$plus$plus__sc_GenTraversableOnce__sc_Set(new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(propertiesMap)));
        $m_sc_Seq$();
        $m_sci_Seq$();
        var this$4 = new $c_scm_ListBuffer().init___();
        var acc = this$4.toList__sci_List();
        return $as_sc_Seq(ast$1.entries$3.foldLeft__O__F2__O(acc, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this$1, shapeType$1$1, totalProperties$1) {
          return (function(results$2, entry$2) {
            var results = $as_sc_Seq(results$2);
            var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
            var this$5 = entry.key$2;
            var conversion = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
            var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
            var key = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$5, conversion, iv)).text$3;
            if ($this$1.ignore__T__T__Z(shapeType$1$1, key)) {
              return results
            } else if ((!totalProperties$1.contains__O__Z(key))) {
              var jsx$3 = $m_sc_Seq$();
              var array = [entry];
              var jsx$2 = jsx$3.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array));
              var this$8 = $m_sc_Seq$();
              return $as_sc_Seq(results.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$8.ReusableCBFInstance$2))
            } else {
              return results
            }
          })
        })($this, shapeType$1, totalProperties))))
      })
    })(this, initialProperties, ast, shapeType));
    var this$9 = $m_sc_Seq$();
    var allResults = $as_sc_Seq(facets.map__F1__scg_CanBuildFrom__O(jsx$1, this$9.ReusableCBFInstance$2));
    var x1$2 = allResults.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1) {
      return (function(x$6$2) {
        var x$6 = $as_sc_Seq(x$6$2);
        return x$6.nonEmpty__Z()
      })
    })(this)));
    matchEnd6: {
      var x = $m_s_None$();
      if ((x === x1$2)) {
        break matchEnd6
      };
      if ((x1$2 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$2);
        var errors = $as_sc_Seq(x2$2.value$2);
        if ((errors !== null)) {
          var subject = ((errors.size__I() > 1) ? "Properties" : "Property");
          var this$13 = this.eh$1;
          var specification = $m_Lamf_validation_DialectValidations$().ClosedShapeSpecification$1;
          var jsx$6 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$3$1) {
            return (function(x$7$2) {
              var x$7 = $as_Lorg_yaml_model_YMapEntry(x$7$2);
              var this$10 = x$7.key$2;
              var conversion$1 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
              var iv$1 = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
              return $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$10, conversion$1, iv$1)).text$3
            })
          })(this));
          var this$11 = $m_sc_Seq$();
          var jsx$5 = $as_sc_TraversableLike(errors.map__F1__scg_CanBuildFrom__O(jsx$6, this$11.ReusableCBFInstance$2));
          var jsx$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1) {
            return (function(e$2) {
              var e = $as_T(e$2);
              return (("'" + e) + "'")
            })
          })(this));
          var this$12 = $m_sc_Seq$();
          var message = (((((((subject + " ") + $as_sc_TraversableOnce(jsx$5.map__F1__scg_CanBuildFrom__O(jsx$4, this$12.ReusableCBFInstance$2)).mkString__T__T(",")) + " not supported in a ") + this.vendor__Lamf_core_remote_Vendor()) + " ") + shapeLabel) + " node");
          var ast$2 = $as_Lorg_yaml_model_YPart(errors.head__O());
          var prop = $m_s_None$();
          var l = ast$2.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$13, specification, node, prop, message, l);
          break matchEnd6
        }
      };
      throw new $c_s_MatchError().init___O(x1$2)
    }
  } else {
    var x$4 = $m_s_None$();
    if ((x$4 === x1)) {
      var this$14 = this.eh$1;
      var specification$1 = $m_Lamf_validation_DialectValidations$().ClosedShapeSpecification$1;
      var message$1 = ((("Cannot validate unknown node type " + shapeType) + " for ") + this.vendor__Lamf_core_remote_Vendor());
      var annotations = shape.annotations__Lamf_core_parser_Annotations();
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__T__Lamf_core_parser_Annotations__V(this$14, specification$1, node, message$1, annotations)
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype.mergeContext__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__V = (function(subContext) {
  this.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().absorb__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__V(subContext.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations());
  subContext.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().futureDeclarations__Lamf_core_parser_FutureDeclarations().promises$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(fd$2) {
      var fd = $as_T2(fd$2);
      return $as_scm_Map($this.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().futureDeclarations__Lamf_core_parser_FutureDeclarations().promises$1.$$plus$eq__T2__scm_MapLike(fd))
    })
  })(this)));
  subContext.futureDeclarations$1.promises$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(fd$3$2) {
      var fd$3 = $as_T2(fd$3$2);
      return $as_scm_Map(this$2.futureDeclarations$1.promises$1.$$plus$eq__T2__scm_MapLike(fd$3))
    })
  })(this)))
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype.ignore__T__T__Z = (function(shape, property) {
  return (((this.isAnnotation$1__p3__T__Z(property) || this.isAllowedNestedEndpoint$1__p3__T__T__Z(property, shape)) || this.isAllowedParameter$1__p3__T__T__Z(property, shape)) || this.reportedByOtherConstraint$1__p3__T__T__Z(property, shape))
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype.mergeAllOperationContexts__V = (function() {
  this.operationContexts$3.values__sc_Iterable().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(subContext$2) {
      var subContext = $as_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(subContext$2);
      $this.mergeContext__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__V(subContext)
    })
  })(this)));
  this.operationContexts$3.keys__sc_Iterable().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(key$2) {
      var key = $as_T(key$2);
      return this$2.operationContexts$3.remove__O__s_Option(key)
    })
  })(this)))
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype.isAnnotation$1__p3__T__Z = (function(property$1) {
  return ((this.supportsAnnotations__Z() && (($uI(property$1.length) >= 0) && ($as_T(property$1.substring(0, $uI("(".length))) === "("))) && $m_sjsr_RuntimeString$().endsWith__T__T__Z(property$1, ")"))
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype.link__Lorg_yaml_model_YNode__s_util_Either = (function(node) {
  if (this.isInclude__p3__Lorg_yaml_model_YNode__Z(node)) {
    $m_s_package$();
    var conversion = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
    var iv = $m_Lorg_yaml_model_IllegalTypeHandler$().illegalValueHandler$1;
    var value = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion, iv)).text$3;
    return new $c_s_util_Left().init___O(value)
  } else {
    $m_s_package$();
    return new $c_s_util_Right().init___O(node)
  }
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype.reportedByOtherConstraint$1__p3__T__T__Z = (function(property$1, shape$1) {
  var this$1 = $m_sci_Nil$();
  var nestedEndpointsConstraintShapes = new $c_sci_$colon$colon().init___O__sci_List("resourceType", this$1);
  return ((($uI(property$1.length) >= 0) && ($as_T(property$1.substring(0, $uI("/".length))) === "/")) && $f_sc_LinearSeqOptimized__contains__O__Z(nestedEndpointsConstraintShapes, shape$1))
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype.mergeOperationContext__T__V = (function(operation) {
  var contextOption = this.operationContexts$3.get__O__s_Option(operation);
  if ((!contextOption.isEmpty__Z())) {
    var arg1 = contextOption.get__O();
    var subContext = $as_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(arg1);
    this.mergeContext__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__V(subContext)
  };
  this.operationContexts$3.remove__O__s_Option(operation)
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function() {
  return this.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations()
});
function $as_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.parser.raml.RamlWebApiContext"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.parser.raml.RamlWebApiContext;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.amf$core$model$document$BaseUnit$$run$1 = null;
  this.raw$1 = null;
  this.platform$1 = null;
  this.id$1 = null
}
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.constructor = $c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment;
/** @constructor */
function $h_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype = $c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype;
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.productPrefix__T = (function() {
  return "AnnotationTypeDeclarationFragment"
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment)) {
    var AnnotationTypeDeclarationFragment$1 = $as_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment(x$1);
    var x = this.fields$1;
    var x$2 = AnnotationTypeDeclarationFragment$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = AnnotationTypeDeclarationFragment$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.raw$und$eq__s_Option__V = (function(x$1) {
  this.raw$1 = x$1
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$AnnotationTypeDeclarationFragmentModel$()
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.references__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().References$1))
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit = (function(selector, transformation, errorHandler) {
  return $f_Lamf_core_model_document_BaseUnit__transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(this, selector, transformation, errorHandler)
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this)
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.amf$core$model$document$BaseUnit$$run__s_Option = (function() {
  return this.amf$core$model$document$BaseUnit$$run$1
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V = (function(x$1) {
  this.amf$core$model$document$BaseUnit$$run$1 = x$1
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.raw__s_Option = (function() {
  return this.raw$1
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.encodes__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_core_model_domain_extensions_CustomDomainProperty($as_Lamf_core_model_domain_DomainElement(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)))
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  $f_Lamf_core_model_document_BaseUnit__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.model.AnnotationTypeDeclarationFragment"))
}
function $isArrayOf_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment)))
}
function $asArrayOf_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.model.AnnotationTypeDeclarationFragment;", depth))
}
var $d_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment = new $TypeData().initClass({
  Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment: 0
}, false, "amf.plugins.document.webapi.model.AnnotationTypeDeclarationFragment", {
  Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment: 1,
  O: 1,
  Lamf_core_model_document_Fragment: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_model_document_EncodesModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment.prototype.$classData = $d_Lamf_plugins_document_webapi_model_AnnotationTypeDeclarationFragment;
/** @constructor */
function $c_Lamf_plugins_document_webapi_model_DataTypeFragment() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.amf$core$model$document$BaseUnit$$run$1 = null;
  this.raw$1 = null;
  this.platform$1 = null;
  this.id$1 = null
}
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.constructor = $c_Lamf_plugins_document_webapi_model_DataTypeFragment;
/** @constructor */
function $h_Lamf_plugins_document_webapi_model_DataTypeFragment() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype = $c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype;
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.productPrefix__T = (function() {
  return "DataTypeFragment"
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_model_DataTypeFragment)) {
    var DataTypeFragment$1 = $as_Lamf_plugins_document_webapi_model_DataTypeFragment(x$1);
    var x = this.fields$1;
    var x$2 = DataTypeFragment$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = DataTypeFragment$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.raw$und$eq__s_Option__V = (function(x$1) {
  this.raw$1 = x$1
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DataTypeFragmentModel$()
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.references__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().References$1))
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit = (function(selector, transformation, errorHandler) {
  return $f_Lamf_core_model_document_BaseUnit__transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(this, selector, transformation, errorHandler)
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this)
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.amf$core$model$document$BaseUnit$$run__s_Option = (function() {
  return this.amf$core$model$document$BaseUnit$$run$1
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V = (function(x$1) {
  this.amf$core$model$document$BaseUnit$$run$1 = x$1
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.raw__s_Option = (function() {
  return this.raw$1
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.encodes__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_core_model_domain_Shape($as_Lamf_core_model_domain_DomainElement(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)))
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  $f_Lamf_core_model_document_BaseUnit__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_document_webapi_model_DataTypeFragment(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_model_DataTypeFragment) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.model.DataTypeFragment"))
}
function $isArrayOf_Lamf_plugins_document_webapi_model_DataTypeFragment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_model_DataTypeFragment)))
}
function $asArrayOf_Lamf_plugins_document_webapi_model_DataTypeFragment(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_model_DataTypeFragment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.model.DataTypeFragment;", depth))
}
var $d_Lamf_plugins_document_webapi_model_DataTypeFragment = new $TypeData().initClass({
  Lamf_plugins_document_webapi_model_DataTypeFragment: 0
}, false, "amf.plugins.document.webapi.model.DataTypeFragment", {
  Lamf_plugins_document_webapi_model_DataTypeFragment: 1,
  O: 1,
  Lamf_core_model_document_Fragment: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_model_document_EncodesModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_model_DataTypeFragment.prototype.$classData = $d_Lamf_plugins_document_webapi_model_DataTypeFragment;
/** @constructor */
function $c_Lamf_plugins_document_webapi_model_DocumentationItemFragment() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.amf$core$model$document$BaseUnit$$run$1 = null;
  this.raw$1 = null;
  this.platform$1 = null;
  this.id$1 = null
}
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.constructor = $c_Lamf_plugins_document_webapi_model_DocumentationItemFragment;
/** @constructor */
function $h_Lamf_plugins_document_webapi_model_DocumentationItemFragment() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype = $c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype;
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.productPrefix__T = (function() {
  return "DocumentationItemFragment"
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_model_DocumentationItemFragment)) {
    var DocumentationItemFragment$1 = $as_Lamf_plugins_document_webapi_model_DocumentationItemFragment(x$1);
    var x = this.fields$1;
    var x$2 = DocumentationItemFragment$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = DocumentationItemFragment$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.raw$und$eq__s_Option__V = (function(x$1) {
  this.raw$1 = x$1
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$DocumentationItemFragmentModel$()
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.references__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().References$1))
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit = (function(selector, transformation, errorHandler) {
  return $f_Lamf_core_model_document_BaseUnit__transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(this, selector, transformation, errorHandler)
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this)
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.amf$core$model$document$BaseUnit$$run__s_Option = (function() {
  return this.amf$core$model$document$BaseUnit$$run$1
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V = (function(x$1) {
  this.amf$core$model$document$BaseUnit$$run$1 = x$1
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.raw__s_Option = (function() {
  return this.raw$1
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.encodes__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_domain_shapes_models_CreativeWork($as_Lamf_core_model_domain_DomainElement(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)))
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  $f_Lamf_core_model_document_BaseUnit__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_document_webapi_model_DocumentationItemFragment(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_model_DocumentationItemFragment) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.model.DocumentationItemFragment"))
}
function $isArrayOf_Lamf_plugins_document_webapi_model_DocumentationItemFragment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_model_DocumentationItemFragment)))
}
function $asArrayOf_Lamf_plugins_document_webapi_model_DocumentationItemFragment(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_model_DocumentationItemFragment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.model.DocumentationItemFragment;", depth))
}
var $d_Lamf_plugins_document_webapi_model_DocumentationItemFragment = new $TypeData().initClass({
  Lamf_plugins_document_webapi_model_DocumentationItemFragment: 0
}, false, "amf.plugins.document.webapi.model.DocumentationItemFragment", {
  Lamf_plugins_document_webapi_model_DocumentationItemFragment: 1,
  O: 1,
  Lamf_core_model_document_Fragment: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_model_document_EncodesModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_model_DocumentationItemFragment.prototype.$classData = $d_Lamf_plugins_document_webapi_model_DocumentationItemFragment;
/** @constructor */
function $c_Lamf_plugins_document_webapi_model_NamedExampleFragment() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.amf$core$model$document$BaseUnit$$run$1 = null;
  this.raw$1 = null;
  this.platform$1 = null;
  this.id$1 = null
}
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.constructor = $c_Lamf_plugins_document_webapi_model_NamedExampleFragment;
/** @constructor */
function $h_Lamf_plugins_document_webapi_model_NamedExampleFragment() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype = $c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype;
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.productPrefix__T = (function() {
  return "NamedExampleFragment"
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_model_NamedExampleFragment)) {
    var NamedExampleFragment$1 = $as_Lamf_plugins_document_webapi_model_NamedExampleFragment(x$1);
    var x = this.fields$1;
    var x$2 = NamedExampleFragment$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = NamedExampleFragment$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.raw$und$eq__s_Option__V = (function(x$1) {
  this.raw$1 = x$1
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$NamedExampleFragmentModel$()
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.references__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().References$1))
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit = (function(selector, transformation, errorHandler) {
  return $f_Lamf_core_model_document_BaseUnit__transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(this, selector, transformation, errorHandler)
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this)
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.amf$core$model$document$BaseUnit$$run__s_Option = (function() {
  return this.amf$core$model$document$BaseUnit$$run$1
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V = (function(x$1) {
  this.amf$core$model$document$BaseUnit$$run$1 = x$1
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.raw__s_Option = (function() {
  return this.raw$1
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.encodes__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_domain_shapes_models_Example($as_Lamf_core_model_domain_DomainElement(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)))
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  $f_Lamf_core_model_document_BaseUnit__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_document_webapi_model_NamedExampleFragment(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_model_NamedExampleFragment) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.model.NamedExampleFragment"))
}
function $isArrayOf_Lamf_plugins_document_webapi_model_NamedExampleFragment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_model_NamedExampleFragment)))
}
function $asArrayOf_Lamf_plugins_document_webapi_model_NamedExampleFragment(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_model_NamedExampleFragment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.model.NamedExampleFragment;", depth))
}
var $d_Lamf_plugins_document_webapi_model_NamedExampleFragment = new $TypeData().initClass({
  Lamf_plugins_document_webapi_model_NamedExampleFragment: 0
}, false, "amf.plugins.document.webapi.model.NamedExampleFragment", {
  Lamf_plugins_document_webapi_model_NamedExampleFragment: 1,
  O: 1,
  Lamf_core_model_document_Fragment: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_model_document_EncodesModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_model_NamedExampleFragment.prototype.$classData = $d_Lamf_plugins_document_webapi_model_NamedExampleFragment;
/** @constructor */
function $c_Lamf_plugins_document_webapi_model_ResourceTypeFragment() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.amf$core$model$document$BaseUnit$$run$1 = null;
  this.raw$1 = null;
  this.platform$1 = null;
  this.id$1 = null
}
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.constructor = $c_Lamf_plugins_document_webapi_model_ResourceTypeFragment;
/** @constructor */
function $h_Lamf_plugins_document_webapi_model_ResourceTypeFragment() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype = $c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype;
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.productPrefix__T = (function() {
  return "ResourceTypeFragment"
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_model_ResourceTypeFragment)) {
    var ResourceTypeFragment$1 = $as_Lamf_plugins_document_webapi_model_ResourceTypeFragment(x$1);
    var x = this.fields$1;
    var x$2 = ResourceTypeFragment$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = ResourceTypeFragment$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.raw$und$eq__s_Option__V = (function(x$1) {
  this.raw$1 = x$1
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$ResourceTypeFragmentModel$()
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.references__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().References$1))
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit = (function(selector, transformation, errorHandler) {
  return $f_Lamf_core_model_document_BaseUnit__transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(this, selector, transformation, errorHandler)
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this)
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.amf$core$model$document$BaseUnit$$run__s_Option = (function() {
  return this.amf$core$model$document$BaseUnit$$run$1
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V = (function(x$1) {
  this.amf$core$model$document$BaseUnit$$run$1 = x$1
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.raw__s_Option = (function() {
  return this.raw$1
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.encodes__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_core_model_domain_DomainElement(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  $f_Lamf_core_model_document_BaseUnit__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_document_webapi_model_ResourceTypeFragment(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_model_ResourceTypeFragment) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.model.ResourceTypeFragment"))
}
function $isArrayOf_Lamf_plugins_document_webapi_model_ResourceTypeFragment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_model_ResourceTypeFragment)))
}
function $asArrayOf_Lamf_plugins_document_webapi_model_ResourceTypeFragment(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_model_ResourceTypeFragment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.model.ResourceTypeFragment;", depth))
}
var $d_Lamf_plugins_document_webapi_model_ResourceTypeFragment = new $TypeData().initClass({
  Lamf_plugins_document_webapi_model_ResourceTypeFragment: 0
}, false, "amf.plugins.document.webapi.model.ResourceTypeFragment", {
  Lamf_plugins_document_webapi_model_ResourceTypeFragment: 1,
  O: 1,
  Lamf_core_model_document_Fragment: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_model_document_EncodesModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_model_ResourceTypeFragment.prototype.$classData = $d_Lamf_plugins_document_webapi_model_ResourceTypeFragment;
/** @constructor */
function $c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.amf$core$model$document$BaseUnit$$run$1 = null;
  this.raw$1 = null;
  this.platform$1 = null;
  this.id$1 = null
}
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.constructor = $c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment;
/** @constructor */
function $h_Lamf_plugins_document_webapi_model_SecuritySchemeFragment() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype = $c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype;
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.productPrefix__T = (function() {
  return "SecuritySchemeFragment"
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment)) {
    var SecuritySchemeFragment$1 = $as_Lamf_plugins_document_webapi_model_SecuritySchemeFragment(x$1);
    var x = this.fields$1;
    var x$2 = SecuritySchemeFragment$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = SecuritySchemeFragment$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.raw$und$eq__s_Option__V = (function(x$1) {
  this.raw$1 = x$1
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$SecuritySchemeFragmentModel$()
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.references__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().References$1))
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit = (function(selector, transformation, errorHandler) {
  return $f_Lamf_core_model_document_BaseUnit__transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(this, selector, transformation, errorHandler)
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this)
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.amf$core$model$document$BaseUnit$$run__s_Option = (function() {
  return this.amf$core$model$document$BaseUnit$$run$1
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V = (function(x$1) {
  this.amf$core$model$document$BaseUnit$$run$1 = x$1
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.raw__s_Option = (function() {
  return this.raw$1
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.encodes__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme($as_Lamf_core_model_domain_DomainElement(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1)))
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  $f_Lamf_core_model_document_BaseUnit__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_document_webapi_model_SecuritySchemeFragment(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.model.SecuritySchemeFragment"))
}
function $isArrayOf_Lamf_plugins_document_webapi_model_SecuritySchemeFragment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_model_SecuritySchemeFragment)))
}
function $asArrayOf_Lamf_plugins_document_webapi_model_SecuritySchemeFragment(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_model_SecuritySchemeFragment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.model.SecuritySchemeFragment;", depth))
}
var $d_Lamf_plugins_document_webapi_model_SecuritySchemeFragment = new $TypeData().initClass({
  Lamf_plugins_document_webapi_model_SecuritySchemeFragment: 0
}, false, "amf.plugins.document.webapi.model.SecuritySchemeFragment", {
  Lamf_plugins_document_webapi_model_SecuritySchemeFragment: 1,
  O: 1,
  Lamf_core_model_document_Fragment: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_model_document_EncodesModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_model_SecuritySchemeFragment.prototype.$classData = $d_Lamf_plugins_document_webapi_model_SecuritySchemeFragment;
/** @constructor */
function $c_Lamf_plugins_document_webapi_model_TraitFragment() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.amf$core$model$document$BaseUnit$$run$1 = null;
  this.raw$1 = null;
  this.platform$1 = null;
  this.id$1 = null
}
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype = new $h_O();
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.constructor = $c_Lamf_plugins_document_webapi_model_TraitFragment;
/** @constructor */
function $h_Lamf_plugins_document_webapi_model_TraitFragment() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_model_TraitFragment.prototype = $c_Lamf_plugins_document_webapi_model_TraitFragment.prototype;
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.productPrefix__T = (function() {
  return "TraitFragment"
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_model_TraitFragment)) {
    var TraitFragment$1 = $as_Lamf_plugins_document_webapi_model_TraitFragment(x$1);
    var x = this.fields$1;
    var x$2 = TraitFragment$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = TraitFragment$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.raw$und$eq__s_Option__V = (function(x$1) {
  this.raw$1 = x$1
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_webapi_metamodel_FragmentsTypesModels$TraitFragmentModel$()
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.references__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().References$1))
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit = (function(selector, transformation, errorHandler) {
  return $f_Lamf_core_model_document_BaseUnit__transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(this, selector, transformation, errorHandler)
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this)
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.amf$core$model$document$BaseUnit$$run__s_Option = (function() {
  return this.amf$core$model$document$BaseUnit$$run$1
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V = (function(x$1) {
  this.amf$core$model$document$BaseUnit$$run$1 = x$1
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.raw__s_Option = (function() {
  return this.raw$1
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.encodes__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_core_model_domain_DomainElement(this.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_FragmentModel$().Encodes$1))
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  $f_Lamf_core_model_document_BaseUnit__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_document_webapi_model_TraitFragment(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_model_TraitFragment) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.model.TraitFragment"))
}
function $isArrayOf_Lamf_plugins_document_webapi_model_TraitFragment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_model_TraitFragment)))
}
function $asArrayOf_Lamf_plugins_document_webapi_model_TraitFragment(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_model_TraitFragment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.model.TraitFragment;", depth))
}
var $d_Lamf_plugins_document_webapi_model_TraitFragment = new $TypeData().initClass({
  Lamf_plugins_document_webapi_model_TraitFragment: 0
}, false, "amf.plugins.document.webapi.model.TraitFragment", {
  Lamf_plugins_document_webapi_model_TraitFragment: 1,
  O: 1,
  Lamf_core_model_document_Fragment: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_model_document_EncodesModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_model_TraitFragment.prototype.$classData = $d_Lamf_plugins_document_webapi_model_TraitFragment;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCallback() {
  $c_Lamf_plugins_domain_webapi_models_Callback.call(this);
  this.idPart$2 = null;
  this.ast$2 = null;
  this.namespace$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCallback.prototype = new $h_Lamf_plugins_domain_webapi_models_Callback();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCallback.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCallback;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCallback() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCallback.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCallback.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCallback.prototype.originalMeta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCallback.prototype.newErrorInstance__Lamf_core_annotations_ErrorDeclaration = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCallback().init___T__Lorg_yaml_model_YPart(this.idPart$2, this.ast$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCallback.prototype.namespace__T = (function() {
  return this.namespace$2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCallback.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCallback.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return new $c_Lamf_core_annotations_ErrorDeclaration$$anon$1().init___Lamf_core_annotations_ErrorDeclaration(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCallback.prototype.init___T__Lorg_yaml_model_YPart = (function(idPart, ast) {
  this.idPart$2 = idPart;
  this.ast$2 = ast;
  $c_Lamf_plugins_domain_webapi_models_Callback.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, new $c_Lamf_core_parser_Fields().init___(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast));
  this.namespace$2 = "http://amferror.com/#errorCallback/";
  $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, idPart);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCallback.prototype.amf$core$annotations$ErrorDeclaration$$super$withId__T__Lamf_core_annotations_ErrorDeclaration = (function(value) {
  return $as_Lamf_core_annotations_ErrorDeclaration($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value))
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCallback = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCallback: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorCallback", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCallback: 1,
  Lamf_plugins_domain_webapi_models_Callback: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_core_annotations_ErrorDeclaration: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCallback.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorCallback;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorChannelBindings() {
  $c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.call(this);
  this.idPart$2 = null;
  this.ast$2 = null;
  this.namespace$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorChannelBindings.prototype = new $h_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorChannelBindings.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorChannelBindings;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorChannelBindings() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorChannelBindings.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorChannelBindings.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorChannelBindings.prototype.originalMeta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_ChannelBindingsModel$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorChannelBindings.prototype.newErrorInstance__Lamf_core_annotations_ErrorDeclaration = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorChannelBindings().init___T__Lorg_yaml_model_YPart(this.idPart$2, this.ast$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorChannelBindings.prototype.namespace__T = (function() {
  return this.namespace$2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorChannelBindings.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorChannelBindings.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return new $c_Lamf_core_annotations_ErrorDeclaration$$anon$1().init___Lamf_core_annotations_ErrorDeclaration(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorChannelBindings.prototype.init___T__Lorg_yaml_model_YPart = (function(idPart, ast) {
  this.idPart$2 = idPart;
  this.ast$2 = ast;
  $c_Lamf_plugins_domain_webapi_models_bindings_ChannelBindings.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, new $c_Lamf_core_parser_Fields().init___(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast));
  this.namespace$2 = "http://amferror.com/#channelBindings/";
  $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, idPart);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorChannelBindings.prototype.amf$core$annotations$ErrorDeclaration$$super$withId__T__Lamf_core_annotations_ErrorDeclaration = (function(value) {
  return $as_Lamf_core_annotations_ErrorDeclaration($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value))
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorChannelBindings = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorChannelBindings: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorChannelBindings", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorChannelBindings: 1,
  Lamf_plugins_domain_webapi_models_bindings_ChannelBindings: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_core_annotations_ErrorDeclaration: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorChannelBindings.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorChannelBindings;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorLink() {
  $c_Lamf_plugins_domain_webapi_models_TemplatedLink.call(this);
  this.idPart$2 = null;
  this.ast$2 = null;
  this.namespace$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorLink.prototype = new $h_Lamf_plugins_domain_webapi_models_TemplatedLink();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorLink.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorLink;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorLink() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorLink.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorLink.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorLink.prototype.originalMeta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorLink.prototype.newErrorInstance__Lamf_core_annotations_ErrorDeclaration = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorLink().init___T__Lorg_yaml_model_YPart(this.idPart$2, this.ast$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorLink.prototype.namespace__T = (function() {
  return this.namespace$2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorLink.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorLink.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return new $c_Lamf_core_annotations_ErrorDeclaration$$anon$1().init___Lamf_core_annotations_ErrorDeclaration(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorLink.prototype.init___T__Lorg_yaml_model_YPart = (function(idPart, ast) {
  this.idPart$2 = idPart;
  this.ast$2 = ast;
  $c_Lamf_plugins_domain_webapi_models_TemplatedLink.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, new $c_Lamf_core_parser_Fields().init___(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast));
  this.namespace$2 = "http://amferror.com/#errorTemplateLink/";
  $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, idPart);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorLink.prototype.amf$core$annotations$ErrorDeclaration$$super$withId__T__Lamf_core_annotations_ErrorDeclaration = (function(value) {
  return $as_Lamf_core_annotations_ErrorDeclaration($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value))
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorLink = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorLink: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorLink", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorLink: 1,
  Lamf_plugins_domain_webapi_models_TemplatedLink: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_core_annotations_ErrorDeclaration: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorLink.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorLink;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessageBindings() {
  $c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.call(this);
  this.idPart$2 = null;
  this.ast$2 = null;
  this.namespace$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessageBindings.prototype = new $h_Lamf_plugins_domain_webapi_models_bindings_MessageBindings();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessageBindings.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessageBindings;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessageBindings() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessageBindings.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessageBindings.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessageBindings.prototype.originalMeta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessageBindings.prototype.newErrorInstance__Lamf_core_annotations_ErrorDeclaration = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessageBindings().init___T__Lorg_yaml_model_YPart(this.idPart$2, this.ast$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessageBindings.prototype.namespace__T = (function() {
  return this.namespace$2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessageBindings.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessageBindings.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return new $c_Lamf_core_annotations_ErrorDeclaration$$anon$1().init___Lamf_core_annotations_ErrorDeclaration(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessageBindings.prototype.init___T__Lorg_yaml_model_YPart = (function(idPart, ast) {
  this.idPart$2 = idPart;
  this.ast$2 = ast;
  $c_Lamf_plugins_domain_webapi_models_bindings_MessageBindings.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, new $c_Lamf_core_parser_Fields().init___(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast));
  this.namespace$2 = "http://amferror.com/#messageBindings/";
  $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, idPart);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessageBindings.prototype.amf$core$annotations$ErrorDeclaration$$super$withId__T__Lamf_core_annotations_ErrorDeclaration = (function(value) {
  return $as_Lamf_core_annotations_ErrorDeclaration($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value))
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessageBindings = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessageBindings: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorMessageBindings", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessageBindings: 1,
  Lamf_plugins_domain_webapi_models_bindings_MessageBindings: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_core_annotations_ErrorDeclaration: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessageBindings.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorMessageBindings;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationBindings() {
  $c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.call(this);
  this.idPart$2 = null;
  this.ast$2 = null;
  this.namespace$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationBindings.prototype = new $h_Lamf_plugins_domain_webapi_models_bindings_OperationBindings();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationBindings.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationBindings;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationBindings() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationBindings.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationBindings.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationBindings.prototype.originalMeta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationBindings.prototype.newErrorInstance__Lamf_core_annotations_ErrorDeclaration = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationBindings().init___T__Lorg_yaml_model_YPart(this.idPart$2, this.ast$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationBindings.prototype.namespace__T = (function() {
  return this.namespace$2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationBindings.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationBindings.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return new $c_Lamf_core_annotations_ErrorDeclaration$$anon$1().init___Lamf_core_annotations_ErrorDeclaration(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationBindings.prototype.init___T__Lorg_yaml_model_YPart = (function(idPart, ast) {
  this.idPart$2 = idPart;
  this.ast$2 = ast;
  $c_Lamf_plugins_domain_webapi_models_bindings_OperationBindings.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, new $c_Lamf_core_parser_Fields().init___(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast));
  this.namespace$2 = "http://amferror.com/#operationBindings/";
  $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, idPart);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationBindings.prototype.amf$core$annotations$ErrorDeclaration$$super$withId__T__Lamf_core_annotations_ErrorDeclaration = (function(value) {
  return $as_Lamf_core_annotations_ErrorDeclaration($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value))
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationBindings = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationBindings: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorOperationBindings", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationBindings: 1,
  Lamf_plugins_domain_webapi_models_bindings_OperationBindings: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_core_annotations_ErrorDeclaration: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationBindings.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationBindings;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorServerBindings() {
  $c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.call(this);
  this.idPart$2 = null;
  this.ast$2 = null;
  this.namespace$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorServerBindings.prototype = new $h_Lamf_plugins_domain_webapi_models_bindings_ServerBindings();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorServerBindings.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorServerBindings;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorServerBindings() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorServerBindings.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorServerBindings.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorServerBindings.prototype.originalMeta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_bindings_ServerBindingsModel$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorServerBindings.prototype.newErrorInstance__Lamf_core_annotations_ErrorDeclaration = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorServerBindings().init___T__Lorg_yaml_model_YPart(this.idPart$2, this.ast$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorServerBindings.prototype.namespace__T = (function() {
  return this.namespace$2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorServerBindings.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorServerBindings.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return new $c_Lamf_core_annotations_ErrorDeclaration$$anon$1().init___Lamf_core_annotations_ErrorDeclaration(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorServerBindings.prototype.init___T__Lorg_yaml_model_YPart = (function(idPart, ast) {
  this.idPart$2 = idPart;
  this.ast$2 = ast;
  $c_Lamf_plugins_domain_webapi_models_bindings_ServerBindings.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, new $c_Lamf_core_parser_Fields().init___(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast));
  this.namespace$2 = "http://amferror.com/#serverBindings/";
  $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, idPart);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorServerBindings.prototype.amf$core$annotations$ErrorDeclaration$$super$withId__T__Lamf_core_annotations_ErrorDeclaration = (function(value) {
  return $as_Lamf_core_annotations_ErrorDeclaration($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value))
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorServerBindings = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorServerBindings: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorServerBindings", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorServerBindings: 1,
  Lamf_plugins_domain_webapi_models_bindings_ServerBindings: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_core_annotations_ErrorDeclaration: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorServerBindings.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorServerBindings;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression() {
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.call(this);
  this.RamlExternalOasLibParser$module$2 = null;
  this.key$2 = null;
  this.value$2 = null;
  this.adopt$2 = null;
  this.parseExample$2 = false;
  this.ctx$2 = null;
  this.externalType$2 = null;
  this.ValueAndOrigin$module$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.parseValue__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin__Lamf_plugins_domain_shapes_models_AnyShape = (function(origin) {
  var x1 = origin.oriUrl$1;
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var url = $as_T(x2.value$2);
    var parsed = this.parseValueWithUrl__p2__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin__T__Lamf_plugins_domain_shapes_models_AnyShape(origin, url)
  } else {
    var x = $m_s_None$();
    if ((!(x === x1))) {
      throw new $c_s_MatchError().init___O(x1)
    };
    var shape = this.parseJsonShape__p2__T__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__F1__Lorg_yaml_model_YNode__s_Option__Lamf_plugins_domain_shapes_models_AnyShape(origin.text$1, this.key$2, origin.valueAST$1, this.adopt$2, this.value$2, $m_s_None$());
    shape.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema().init___T(origin.text$1));
    var parsed = shape
  };
  if (this.parseExample$2) {
    var this$1 = this.value$2;
    var x$3 = this$1.tag__Lorg_yaml_model_YTag().tagType$3;
    var x$4 = $m_Lorg_yaml_model_YType$().Map$1;
    var jsx$1 = (x$3 === x$4)
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    var this$2 = this.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$2;
    var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv));
    var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var field = $m_Lamf_core_metamodel_domain_ShapeModel$().DisplayName$1;
    var iv$1 = this.ctx$2;
    jsx$2.key__T__F1__V("displayName", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field, iv$1).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(parsed).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
    var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var field$1 = $m_Lamf_core_metamodel_domain_ShapeModel$().Description$1;
    var iv$2 = this.ctx$2;
    jsx$3.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$1, iv$2).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(parsed).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
    var this$6 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var this$7 = this$6.key__T__s_Option("default");
    if ((!this$7.isEmpty__Z())) {
      var arg1 = this$7.get__O();
      var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
      var dataNodeResult = new $c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser().init___Lorg_yaml_model_YNode__T__Z__Z__Z__Lamf_plugins_document_webapi_contexts_WebApiContext(entry.value$2, parsed.id$1, false, false, false, this.ctx$2).parse__Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult();
      $f_Lamf_plugins_domain_shapes_models_ShapeHelper__setDefaultStrValue__Lorg_yaml_model_YMapEntry__V(parsed, entry);
      var this$8 = dataNodeResult.dataNode$1;
      if ((!this$8.isEmpty__Z())) {
        var arg1$1 = this$8.get__O();
        var dataNode = $as_Lamf_core_model_domain_DataNode(arg1$1);
        var field$2 = $m_Lamf_core_metamodel_domain_ShapeModel$().Default$1;
        var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
        $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(parsed, field$2, dataNode, annotations))
      }
    };
    var this$9 = this.value$2;
    var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$3 = this.ctx$2;
    var map$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$9, conversion$1, iv$3));
    var options = $m_Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$();
    var ctx = this.ctx$2;
    $f_Lamf_plugins_document_webapi_parser_spec_declaration_ExampleParser__parseExamples__Lamf_plugins_domain_shapes_models_AnyShape__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext__V(this, parsed, map$1, options, ctx)
  };
  parsed.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_SchemaIsJsonSchema().init___());
  return parsed
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.parseOasLib__p2__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin__T__s_Option__s_Option__Lamf_plugins_domain_shapes_models_AnyShape = (function(origin, basePath, localPath, normalizedLocalPath) {
  new $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression$RamlExternalOasLibParser().init___Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__T__Lorg_yaml_model_YNode__T(this, this.ctx$2, origin.text$1, origin.valueAST$1, basePath).parse__V();
  var x1 = this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().findInExternalsLibs__T__T__s_Option(basePath, $as_T(normalizedLocalPath.get__O()));
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var s = $as_Lamf_plugins_domain_shapes_models_AnyShape(x2.value$2);
    var this$1 = $c_Lamf_core_model_domain_Shape.prototype.copyShape__Lamf_core_model_domain_Shape.call(s);
    var value = s.id$1;
    var qual$1 = $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$1, value));
    var this$2 = this.key$2;
    var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
    var iv = this.ctx$2;
    var x$1 = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion, iv));
    $m_Lamf_core_parser_Annotations$();
    var x$2 = new $c_Lamf_core_parser_Annotations().init___();
    var shape = $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, x$1, x$2))
  } else {
    $m_Lamf_core_parser_Annotations$();
    var annotations = new $c_Lamf_core_parser_Annotations().init___();
    var fields = new $c_Lamf_core_parser_Fields().init___();
    var empty = new $c_Lamf_plugins_domain_shapes_models_AnyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
    this.adopt$2.apply__O__O(empty);
    var this$8 = this.ctx$2.eh$1;
    var specification = $m_Lamf_validations_ParserSideValidations$().JsonSchemaFragmentNotFound$1;
    var node = empty.id$1;
    var message = ((("could not find json schema fragment " + localPath.get__O()) + " in file ") + basePath);
    var ast = origin.valueAST$1;
    var prop = $m_s_None$();
    var l = ast.location$1;
    $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$8, specification, node, prop, message, l);
    var shape = empty
  };
  var this$9 = this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().fragments$1.get__O__s_Option(basePath);
  if ((!this$9.isEmpty__Z())) {
    var arg1 = this$9.get__O();
    var e = $as_Lamf_core_parser_FragmentRef(arg1);
    var id = (("" + e.encoded$1.id__T()) + localPath.get__O());
    var field = $m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().ReferenceId$1;
    $as_Lamf_plugins_domain_shapes_models_AnyShape($as_Lamf_core_model_domain_ExternalSourceElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(shape, field, id)))
  };
  shape.annotations__Lamf_core_parser_Annotations().$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ExternalFragmentRef().init___T($as_T(localPath.get__O())));
  return shape
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.productPrefix__T = (function() {
  return "RamlJsonSchemaExpression"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.normalizePath__p2__T__T = (function(rawPath) {
  var hashTagIdx = $uI(rawPath.indexOf("#"));
  var parentIdx = ((3 + $uI(rawPath.lastIndexOf("../"))) | 0);
  var currentIdx = ((2 + $uI(rawPath.lastIndexOf("./"))) | 0);
  var x = ((parentIdx > currentIdx) ? parentIdx : currentIdx);
  var start = ((x > 0) ? x : 0);
  var finish = ((hashTagIdx === (-1)) ? $uI(rawPath.length) : hashTagIdx);
  return $as_T(rawPath.substring(start, finish))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.externalType__T = (function() {
  return this.externalType$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression)) {
    var RamlJsonSchemaExpression$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression(x$1);
    var this$1 = this.key$2;
    var b = RamlJsonSchemaExpression$1.key$2;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var this$2 = this.value$2;
      var b$1 = RamlJsonSchemaExpression$1.value$2;
      var jsx$2 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$2, b$1)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x = this.adopt$2;
      var x$2 = RamlJsonSchemaExpression$1.adopt$2;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.parseExample$2 === RamlJsonSchemaExpression$1.parseExample$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$2;
      break
    }
    case 1: {
      return this.value$2;
      break
    }
    case 2: {
      return this.adopt$2;
      break
    }
    case 3: {
      return this.parseExample$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.getContext__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(valueAST, schemaEntry) {
  this.ctx$2.setJsonSchemaAST__Lorg_yaml_model_YNode__V(schemaEntry.value$2);
  return this.toSchemaContext__Lamf_plugins_document_webapi_contexts_WebApiContext__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this.ctx$2, valueAST)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.parseJsonShape__p2__T__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__F1__Lorg_yaml_model_YNode__s_Option__Lamf_plugins_domain_shapes_models_AnyShape = (function(text, key, valueAST, adopt, value, extLocation) {
  var eta$0$1 = this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().fragments$1;
  if (extLocation.isEmpty__Z()) {
    var this$1 = $m_s_None$()
  } else {
    var arg1 = extLocation.get__O();
    var key$2 = $as_T(arg1);
    var this$1 = eta$0$1.get__O__s_Option(key$2)
  };
  if (this$1.isEmpty__Z()) {
    var url = $m_s_None$()
  } else {
    var arg1$1 = this$1.get__O();
    var x$4 = $as_Lamf_core_parser_FragmentRef(arg1$1);
    var url = x$4.location$1
  };
  var parser = this.getParser__p2__T__Lorg_yaml_model_YNode__s_Option__Lorg_yaml_parser_JsonParser(text, valueAST, url);
  var schemaEntry = $m_Lorg_yaml_model_YMapEntry$().apply__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry(key, $f_Lorg_yaml_parser_YParser__document__Lorg_yaml_model_YDocument(parser).node$2);
  var jsonSchemaContext = this.getContext__p2__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(valueAST, schemaEntry);
  var fullRef = jsonSchemaContext.resolvedPath__T__T__T(jsonSchemaContext.rootContextDocument$1, "");
  var qual$1 = $m_Lamf_plugins_domain_shapes_models_UnresolvedShape$().apply__T__Lorg_yaml_model_YPart__Lamf_plugins_domain_shapes_models_UnresolvedShape(fullRef, schemaEntry);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = $as_Lamf_core_model_domain_Linkable($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, fullRef, x$2).withId__T__Lamf_core_model_domain_AmfObject(fullRef));
  var field = $m_Lamf_core_metamodel_domain_LinkableElementModel$().SupportsRecursion$1;
  var tmpShape = $as_Lamf_plugins_domain_shapes_models_UnresolvedShape($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$4, field, true)));
  $f_Lamf_core_model_domain_Linkable__unresolved__T__Lorg_yaml_model_YPart__T__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(tmpShape, fullRef, schemaEntry, "warning", jsonSchemaContext);
  $f_Lamf_core_parser_UnresolvedReference__withContext__Lamf_core_parser_ParserContext__Lamf_core_model_domain_DomainElement(tmpShape, jsonSchemaContext);
  adopt.apply__O__O(tmpShape);
  jsonSchemaContext.registerJsonSchema__T__Lamf_plugins_domain_shapes_models_AnyShape__V(fullRef, tmpShape);
  var s = this.actualParsing__p2__F1__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext__T__Lamf_plugins_domain_shapes_models_UnresolvedShape__Lamf_plugins_domain_shapes_models_AnyShape(adopt, value, schemaEntry, jsonSchemaContext, fullRef, tmpShape);
  this.cleanGlobalSpace__p2__V();
  this.savePromotedFragmentsFromNestedContext__p2__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext__V(jsonSchemaContext);
  return s
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.init___Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(key, value, adopt, parseExample, ctx) {
  this.key$2 = key;
  this.value$2 = value;
  this.adopt$2 = adopt;
  this.parseExample$2 = parseExample;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.prototype.init___Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, ctx);
  this.externalType$2 = "JSON";
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.parseValueWithUrl__p2__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin__T__Lamf_plugins_domain_shapes_models_AnyShape = (function(origin, url) {
  var x1 = $m_Lamf_core_parser_ReferenceFragmentPartition$().apply__T__T2(url);
  if ((x1 === null)) {
    throw new $c_s_MatchError().init___O(x1)
  };
  var basePath = $as_T(x1.$$und1__O());
  var localPath = $as_s_Option(x1.$$und2__O());
  if (localPath.isEmpty__Z()) {
    var normalizedLocalPath = $m_s_None$()
  } else {
    var arg1 = localPath.get__O();
    var x$2 = $as_T(arg1);
    var this$2 = new $c_sci_StringOps().init___T(x$2);
    var normalizedLocalPath = new $c_s_Some().init___O($f_sci_StringLike__stripPrefix__T__T(this$2, "/definitions/"))
  };
  if (normalizedLocalPath.isEmpty__Z()) {
    var this$3 = $m_s_None$()
  } else {
    var arg1$1 = normalizedLocalPath.get__O();
    var x$3 = $as_T(arg1$1);
    var this$3 = this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().findInExternalsLibs__T__T__s_Option(basePath, x$3)
  };
  if (this$3.isEmpty__Z()) {
    var this$4 = this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations();
    var x1$2 = this$4.externalShapes$3.get__O__s_Option(basePath)
  } else {
    var x1$2 = this$3
  };
  if ((x1$2 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1$2);
    var s = $as_Lamf_plugins_domain_shapes_models_AnyShape(x2.value$2);
    var this$5 = $c_Lamf_core_model_domain_Shape.prototype.copyShape__Lamf_core_model_domain_Shape.call(s);
    var value = s.id$1;
    var qual$1 = $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
    var this$6 = this.key$2;
    var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
    var iv = this.ctx$2;
    var x$1$2 = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion, iv));
    $m_Lamf_core_parser_Annotations$();
    var x$2$3 = new $c_Lamf_core_parser_Annotations().init___();
    var shape = $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, x$1$2, x$2$3));
    var this$8 = this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().fragments$1.get__O__s_Option(basePath);
    if ((!this$8.isEmpty__Z())) {
      var arg1$2 = this$8.get__O();
      var e = $as_Lamf_core_parser_FragmentRef(arg1$2);
      var id = (("" + e.encoded$1.id__T()) + (localPath.isEmpty__Z() ? "" : localPath.get__O()));
      var field = $m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().ReferenceId$1;
      $as_Lamf_plugins_domain_shapes_models_AnyShape($as_Lamf_core_model_domain_ExternalSourceElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(shape, field, id)))
    };
    if ($as_sc_Seq(shape.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).nonEmpty__Z()) {
      shape.id$1 = null;
      this.adopt$2.apply__O__O(shape);
      shape.fields__Lamf_core_parser_Fields().remove__T__Lamf_core_parser_Fields($m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Examples$1.value$1.iri__T())
    };
    return shape
  } else {
    return (normalizedLocalPath.isDefined__Z() ? this.parseOasLib__p2__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin__T__s_Option__s_Option__Lamf_plugins_domain_shapes_models_AnyShape(origin, basePath, localPath, normalizedLocalPath) : this.parseFragment__p2__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin__T__Lamf_plugins_domain_shapes_models_AnyShape(origin, basePath))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.ValueAndOrigin__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$ = (function() {
  if ((this.ValueAndOrigin$module$2 === null)) {
    this.ValueAndOrigin$lzycompute$1__p2__V()
  };
  return this.ValueAndOrigin$module$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.savePromotedFragmentsFromNestedContext__p2__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext__V = (function(jsonSchemaContext) {
  if (jsonSchemaContext.declarations$4.promotedFragments$1.nonEmpty__Z()) {
    var jsx$3 = this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations();
    var jsx$2 = this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().promotedFragments$1;
    var jsx$1 = jsonSchemaContext.declarations$4.promotedFragments$1;
    var this$1 = $m_sc_Seq$();
    jsx$3.promotedFragments$1 = $as_sc_Seq(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))
  };
  this.ctx$2.localJSONSchemaContext$2 = $m_s_None$()
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.parseFragment__p2__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin__T__Lamf_plugins_domain_shapes_models_AnyShape = (function(origin, basePath) {
  var shape = this.parseJsonShape__p2__T__Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__F1__Lorg_yaml_model_YNode__s_Option__Lamf_plugins_domain_shapes_models_AnyShape(origin.text$1, this.key$2, origin.valueAST$1, this.adopt$2, this.value$2, origin.oriUrl$1);
  var this$1 = this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().fragments$1.get__O__s_Option(basePath);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var e = $as_Lamf_core_parser_FragmentRef(arg1);
    var id = e.encoded$1.id__T();
    var field = $m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().ReferenceId$1;
    $as_Lamf_plugins_domain_shapes_models_AnyShape($as_Lamf_core_model_domain_ExternalSourceElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(shape, field, id)))
  };
  var this$2 = this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations();
  this$2.externalShapes$3 = this$2.externalShapes$3.$$plus__T2__sci_Map(new $c_T2().init___O__O(basePath, shape));
  var jsx$1 = shape.annotations__Lamf_core_parser_Annotations();
  var thiz = origin.text$1;
  jsx$1.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_plugins_document_webapi_annotations_ParsedJSONSchema().init___T($as_T(thiz.trim())));
  return shape
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.cleanGlobalSpace__p2__V = (function() {
  this.ctx$2.globalSpace$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(e$2) {
      var e = $as_T2(e$2);
      var thiz = $as_T(e.$$und1__O());
      var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "#", 0);
      var this$3 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
      var this$4 = $f_sc_TraversableLike__headOption__s_Option(this$3);
      var refPath = $as_T((this$4.isEmpty__Z() ? "" : this$4.get__O()));
      var this$5 = $as_Lorg_yaml_model_YPart($this.ctx$2.localJSONSchemaContext$2.get__O());
      if ((refPath === this$5.location$1.sourceName$1)) {
        return $this.ctx$2.globalSpace$1.remove__O__s_Option(e.$$und1__O())
      } else {
        return (void 0)
      }
    })
  })(this)))
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.ValueAndOrigin$lzycompute$1__p2__V = (function() {
  if ((this.ValueAndOrigin$module$2 === null)) {
    this.ValueAndOrigin$module$2 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$().init___Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.actualParsing__p2__F1__Lorg_yaml_model_YNode__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext__T__Lamf_plugins_domain_shapes_models_UnresolvedShape__Lamf_plugins_domain_shapes_models_AnyShape = (function(adopt, value, schemaEntry, jsonSchemaContext, fullRef, tmpShape) {
  var x1 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_OasTypeParser(schemaEntry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, adopt$1) {
    return (function(shape$2) {
      var shape = $as_Lamf_core_model_domain_Shape(shape$2);
      adopt$1.apply__O__O(shape)
    })
  })(this, adopt)), this.ctx$2.computeJsonSchemaVersion__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_parser_spec_declaration_JSONSchemaVersion(schemaEntry.value$2), jsonSchemaContext).parse__s_Option();
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var sh = $as_Lamf_plugins_domain_shapes_models_AnyShape(x2.value$2);
    var this$1 = this.ctx$2.futureDeclarations$1;
    $f_Lamf_core_parser_FutureDeclarations__resolveRef__T__Lamf_core_model_domain_Linkable__V(this$1, fullRef, sh);
    this.ctx$2.registerJsonSchema__T__Lamf_plugins_domain_shapes_models_AnyShape__V(fullRef, sh);
    tmpShape.resolve__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape(sh);
    return ($f_Lamf_core_model_domain_Linkable__linkTarget__s_Option(sh).isDefined__Z() ? $as_Lamf_plugins_domain_shapes_models_AnyShape(sh.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(sh.effectiveLinkTarget$default$1__sc_Seq())) : sh)
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      $m_Lamf_core_parser_Annotations$();
      var annotations = new $c_Lamf_core_parser_Annotations().init___();
      var shape$3 = new $c_Lamf_plugins_domain_shapes_models_SchemaShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
      adopt.apply__O__O(shape$3);
      var this$5 = this.ctx$2.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().UnableToParseJsonSchema$1;
      var node = shape$3.id$1;
      var prop = $m_s_None$();
      var l = value.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$5, specification, node, prop, "Cannot parse JSON Schema", l);
      return shape$3
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.key$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.value$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.adopt$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.parseExample$2 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 4)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.getParser__p2__T__Lorg_yaml_model_YNode__s_Option__Lorg_yaml_parser_JsonParser = (function(text, valueAST, url) {
  if (url.isDefined__Z()) {
    return $m_Lorg_yaml_parser_JsonParser$().withSource__jl_CharSequence__T__Lorg_mulesoft_lexer_Position__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_JsonParser(text, $as_T(url.get__O()), $m_Lorg_mulesoft_lexer_Position$().Zero$1, this.ctx$2.eh$1)
  } else {
    var jsx$4 = $m_Lorg_yaml_parser_JsonParser$();
    var this$2 = valueAST.value__Lorg_yaml_model_YValue();
    var jsx$3 = this$2.location$1.sourceName$1;
    var jsx$2 = $m_Lorg_mulesoft_lexer_Position$();
    var this$3 = valueAST.location$1;
    var jsx$1 = $m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$3.lineFrom$1, this$3.columnFrom$1, this$3.lineTo$1, this$3.columnTo$1).lineFrom$1;
    var this$4 = valueAST.location$1;
    return jsx$4.withSource__jl_CharSequence__T__Lorg_mulesoft_lexer_Position__Lorg_yaml_model_ParseErrorHandler__Lorg_yaml_parser_JsonParser(text, jsx$3, jsx$2.apply__I__I__I__Lorg_mulesoft_lexer_Position(jsx$1, $m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$4.lineFrom$1, this$4.columnFrom$1, this$4.lineTo$1, this$4.columnTo$1).columnFrom$1, ($m_Lorg_mulesoft_lexer_Position$(), 0)), this.ctx$2.eh$1)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.value__Lorg_yaml_model_YNode = (function() {
  return this.value$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.toSchemaContext__Lamf_plugins_document_webapi_contexts_WebApiContext__Lorg_yaml_model_YNode__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext = (function(ctx, ast) {
  if ((ast instanceof $c_Lorg_yaml_model_YNode$MutRef)) {
    var x2 = $as_Lorg_yaml_model_YNode$MutRef(ast);
    var x = x2.origTag$4.tagType$3;
    var x$2 = $m_Lorg_yaml_model_YType$().Include$1;
    if ((x === x$2)) {
      var rawPath = $as_Lorg_yaml_model_YScalar(x2.origValue$4).text$3;
      var normalizedFilePath = this.normalizePath__p2__T__T(rawPath);
      var x1$2 = ctx.refs$1.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, normalizedFilePath$1) {
        return (function(r$2) {
          var r = $as_Lamf_core_parser_ParsedReference(r$2);
          var this$1 = r.unit$1;
          var this$2 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(this$1);
          if ((!this$2.isEmpty__Z())) {
            var arg1 = this$2.get__O();
            var x$5 = $as_T(arg1);
            return $m_sjsr_RuntimeString$().endsWith__T__T__Z(x$5, normalizedFilePath$1)
          } else {
            return false
          }
        })
      })(this, normalizedFilePath)));
      if ((x1$2 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$2);
        var ref = $as_Lamf_core_parser_ParsedReference(x2$2.value$2);
        var jsx$4 = $m_Lamf_plugins_document_webapi_parser_spec_package$();
        var this$3 = ref.unit$1;
        var jsx$3 = $as_T($f_Lamf_core_model_document_BaseUnit__location__s_Option(this$3).get__O());
        var jsx$2 = ref.unit$1.references__sc_Seq();
        var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, ref$1) {
          return (function(r$3$2) {
            var r$3 = $as_Lamf_core_model_document_BaseUnit(r$3$2);
            var this$4 = ref$1.unit$1;
            return new $c_Lamf_core_parser_ParsedReference().init___Lamf_core_model_document_BaseUnit__Lamf_core_parser_Reference__s_Option(r$3, new $c_Lamf_core_parser_Reference().init___T__sc_Seq($as_T($f_Lamf_core_model_document_BaseUnit__location__s_Option(this$4).get__O()), $m_sci_Nil$()), $m_s_None$())
          })
        })(this, ref));
        var this$5 = $m_sc_Seq$();
        return jsx$4.toJsonSchema__T__sc_Seq__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(jsx$3, $as_sc_Seq(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2)), ctx)
      } else {
        var jsx$5 = $m_s_Option$();
        var this$6 = ast.value__Lorg_yaml_model_YValue();
        if (jsx$5.apply__O__s_Option(this$6.location$1.sourceName$1).isDefined__Z()) {
          var jsx$6 = $m_Lamf_plugins_document_webapi_parser_spec_package$();
          var this$7 = ast.value__Lorg_yaml_model_YValue();
          return jsx$6.toJsonSchema__T__sc_Seq__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this$7.location$1.sourceName$1, ctx.refs$1, ctx)
        } else {
          return $m_Lamf_plugins_document_webapi_parser_spec_package$().toJsonSchema__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext(ctx)
        }
      }
    } else {
      return $m_Lamf_plugins_document_webapi_parser_spec_package$().toJsonSchema__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext(ctx)
    }
  } else {
    return $m_Lamf_plugins_document_webapi_parser_spec_package$().toJsonSchema__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext(ctx)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.adopt__F1 = (function() {
  return this.adopt$2
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.external.raml.RamlJsonSchemaExpression"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.external.raml.RamlJsonSchemaExpression;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.external.raml.RamlJsonSchemaExpression", {
  Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_WebApiBaseSpecParser: 1,
  Lamf_core_parser_BaseSpecParser: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_ExampleParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlJsonSchemaExpression;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression() {
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.call(this);
  this.key$2 = null;
  this.value$2 = null;
  this.adopt$2 = null;
  this.parseExample$2 = false;
  this.ctx$2 = null;
  this.externalType$2 = null;
  this.ValueAndOrigin$module$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser();
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression.prototype = $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression.prototype.parseValue__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin__Lamf_plugins_domain_shapes_models_AnyShape = (function(origin) {
  return this.parseValue__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin__Lamf_plugins_domain_shapes_models_SchemaShape(origin)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression.prototype.parseValue__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin__Lamf_plugins_domain_shapes_models_SchemaShape = (function(origin) {
  var this$1 = origin.oriUrl$1;
  if (this$1.isEmpty__Z()) {
    var x1 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var url = $as_T(arg1);
    var x1 = new $c_s_Some().init___O($m_Lamf_core_parser_ReferenceFragmentPartition$().apply__T__T2(url))
  };
  matchEnd6: {
    var x1$2_$_$$und1$1;
    var x1$2_$_$$und2$1;
    var x1$2_$_$$und3$1;
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var p3 = $as_T2(x2.value$2);
      if ((p3 !== null)) {
        var path = $as_T(p3.$$und1__O());
        var uri = $as_s_Option(p3.$$und2__O());
        var maybeRef = this.ctx$2.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().fragments$1.get__O__s_Option(path);
        if (maybeRef.isEmpty__Z()) {
          var _1 = $m_s_None$()
        } else {
          var arg1$1 = maybeRef.get__O();
          var x$1 = $as_Lamf_core_parser_FragmentRef(arg1$1);
          var jsx$1 = x$1.encoded$1.id__T();
          if (uri.isEmpty__Z()) {
            var this$7 = $m_s_None$()
          } else {
            var arg1$2 = uri.get__O();
            var u = $as_T(arg1$2);
            var this$7 = new $c_s_Some().init___O(((($uI(u.length) >= 0) && ($as_T(u.substring(0, $uI("/".length))) === "/")) ? u : ("/" + u)))
          };
          var _1 = new $c_s_Some().init___O((("" + jsx$1) + (this$7.isEmpty__Z() ? "" : this$7.get__O())))
        };
        if (maybeRef.isEmpty__Z()) {
          var _2 = $m_s_None$()
        } else {
          var arg1$3 = maybeRef.get__O();
          var x$2 = $as_Lamf_core_parser_FragmentRef(arg1$3);
          var _2 = x$2.location$1
        };
        var x1$2_$_$$und1$1 = _1;
        var x1$2_$_$$und2$1 = _2;
        var x1$2_$_$$und3$1 = uri;
        break matchEnd6
      }
    };
    var x = $m_s_None$();
    if ((x === x1)) {
      var _1$1 = $m_s_None$();
      var _2$1 = $m_s_None$();
      var _3 = $m_s_None$();
      var x1$2_$_$$und1$1 = _1$1;
      var x1$2_$_$$und2$1 = _2$1;
      var x1$2_$_$$und3$1 = _3;
      break matchEnd6
    };
    throw new $c_s_MatchError().init___O(x1)
  };
  var maybeReferenceId = $as_s_Option(x1$2_$_$$und1$1);
  var maybeLocation = $as_s_Option(x1$2_$_$$und2$1);
  var maybeFragmentLabel = $as_s_Option(x1$2_$_$$und3$1);
  var this$8 = this.value$2;
  var x1$3 = this$8.tag__Lorg_yaml_model_YTag().tagType$3;
  var x$4 = $m_Lorg_yaml_model_YType$().Map$1;
  if ((x$4 === x1$3)) {
    var this$9 = this.value$2;
    var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv = this.ctx$2;
    var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$9, conversion, iv));
    var x1$4 = this.nestedTypeOrSchema__Lorg_yaml_model_YMap__s_Option(map);
    matchEnd5: {
      var parsedSchema;
      if ((x1$4 instanceof $c_s_Some)) {
        var x2$2 = $as_s_Some(x1$4);
        var typeEntry = $as_Lorg_yaml_model_YMapEntry(x2$2.value$2);
        if ((typeEntry !== null)) {
          var node = typeEntry.value$2;
          if (new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YScalarYRead$()).isDefined__Z()) {
            $m_Lamf_core_parser_Annotations$();
            var annotations = new $c_Lamf_core_parser_Annotations().init___();
            var this$15 = new $c_Lamf_plugins_domain_shapes_models_SchemaShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
            var this$14 = typeEntry.value$2;
            var conversion$1 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
            var iv$1 = this.ctx$2;
            var text = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$14, conversion$1, iv$1)).text$3;
            var field = $m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$().Raw$1;
            var this$16 = $as_Lamf_plugins_domain_shapes_models_SchemaShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$15, field, text));
            var field$1 = $m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$().MediaType$1;
            var shape = $as_Lamf_plugins_domain_shapes_models_SchemaShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$16, field$1, "application/xml"));
            var this$17 = this.key$2;
            var conversion$2 = $m_Lorg_yaml_convert_YRead$StringYRead$();
            var iv$2 = this.ctx$2;
            var name = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$17, conversion$2, iv$2));
            $m_Lamf_core_parser_Annotations$();
            var a = new $c_Lamf_core_parser_Annotations().init___();
            $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, name, a);
            this.adopt$2.apply__O__O(shape);
            var parsedSchema = shape;
            break matchEnd5
          }
        }
      };
      $m_Lamf_core_parser_Annotations$();
      var annotations$1 = new $c_Lamf_core_parser_Annotations().init___();
      var shape$2 = new $c_Lamf_plugins_domain_shapes_models_SchemaShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$1);
      this.adopt$2.apply__O__O(shape$2);
      var this$22 = this.ctx$2.eh$1;
      var specification = $m_Lamf_validations_ParserSideValidations$().InvalidXmlSchemaType$1;
      var node$1 = shape$2.id$1;
      var ast = this.value$2;
      var prop = $m_s_None$();
      var l = ast.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$22, specification, node$1, prop, "Cannot parse XML Schema expression out of a non string value", l);
      var parsedSchema = shape$2
    };
    var jsx$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var field$2 = $m_Lamf_core_metamodel_domain_ShapeModel$().DisplayName$1;
    var iv$3 = this.ctx$2;
    jsx$2.key__T__F1__V("displayName", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$2, iv$3).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(parsedSchema).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
    var jsx$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var field$3 = $m_Lamf_core_metamodel_domain_ShapeModel$().Description$1;
    var iv$4 = this.ctx$2;
    jsx$3.key__T__F1__V("description", new $c_Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$FieldOps().init___Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps__Lamf_core_metamodel_Field__Lamf_plugins_document_webapi_contexts_WebApiContext(this, field$3, iv$4).$in__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField(parsedSchema).allowingAnnotations__Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps$ObjectField());
    var this$26 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
    var this$27 = this$26.key__T__s_Option("default");
    if ((!this$27.isEmpty__Z())) {
      var arg1$4 = this$27.get__O();
      var entry = $as_Lorg_yaml_model_YMapEntry(arg1$4);
      var dataNodeResult = new $c_Lamf_plugins_document_webapi_parser_spec_domain_NodeDataNodeParser().init___Lorg_yaml_model_YNode__T__Z__Z__Z__Lamf_plugins_document_webapi_contexts_WebApiContext(entry.value$2, parsedSchema.id$1, false, false, false, this.ctx$2).parse__Lamf_plugins_document_webapi_parser_spec_domain_DataNodeParserResult();
      $f_Lamf_plugins_domain_shapes_models_ShapeHelper__setDefaultStrValue__Lorg_yaml_model_YMapEntry__V(parsedSchema, entry);
      var this$28 = dataNodeResult.dataNode$1;
      if ((!this$28.isEmpty__Z())) {
        var arg1$5 = this$28.get__O();
        var dataNode = $as_Lamf_core_model_domain_DataNode(arg1$5);
        var field$4 = $m_Lamf_core_metamodel_domain_ShapeModel$().Default$1;
        var annotations$2 = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(entry);
        $as_Lamf_plugins_domain_shapes_models_SchemaShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(parsedSchema, field$4, dataNode, annotations$2))
      }
    };
    var this$29 = this.value$2;
    var conversion$3 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
    var iv$5 = this.ctx$2;
    var map$1 = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$29, conversion$3, iv$5));
    var options = $m_Lamf_plugins_document_webapi_parser_spec_domain_DefaultExampleOptions$();
    var ctx = this.ctx$2;
    $f_Lamf_plugins_document_webapi_parser_spec_declaration_ExampleParser__parseExamples__Lamf_plugins_domain_shapes_models_AnyShape__Lorg_yaml_model_YMap__Lamf_plugins_document_webapi_parser_spec_domain_ExampleOptions__Lamf_plugins_document_webapi_contexts_WebApiContext__V(this, parsedSchema, map$1, options, ctx);
    var parsed = parsedSchema
  } else {
    var x$6 = $m_Lorg_yaml_model_YType$().Seq$1;
    if ((x$6 === x1$3)) {
      $m_Lamf_core_parser_Annotations$();
      var annotations$3 = new $c_Lamf_core_parser_Annotations().init___();
      var shape$3 = new $c_Lamf_plugins_domain_shapes_models_SchemaShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$3);
      this.adopt$2.apply__O__O(shape$3);
      var this$33 = this.ctx$2.eh$1;
      var specification$1 = $m_Lamf_validations_ParserSideValidations$().InvalidXmlSchemaType$1;
      var node$2 = shape$3.id$1;
      var ast$1 = this.value$2;
      var prop$1 = $m_s_None$();
      var l$1 = ast$1.location$1;
      $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$33, specification$1, node$2, prop$1, "Cannot parse XML Schema expression out of a non string value", l$1);
      var parsed = shape$3
    } else {
      var this$34 = this.value$2;
      var conversion$4 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
      var iv$6 = this.ctx$2;
      var raw = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$34, conversion$4, iv$6)).text$3;
      $m_Lamf_core_parser_Annotations$();
      var annotations$4 = new $c_Lamf_core_parser_Annotations().init___();
      var this$38 = new $c_Lamf_plugins_domain_shapes_models_SchemaShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations$4);
      var field$5 = $m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$().Raw$1;
      var this$39 = $as_Lamf_plugins_domain_shapes_models_SchemaShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$38, field$5, raw));
      var field$6 = $m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$().MediaType$1;
      var shape$4 = $as_Lamf_plugins_domain_shapes_models_SchemaShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$39, field$6, "application/xml"));
      var this$40 = this.key$2;
      var conversion$5 = $m_Lorg_yaml_convert_YRead$StringYRead$();
      var iv$7 = this.ctx$2;
      var name$1 = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$40, conversion$5, iv$7));
      $m_Lamf_core_parser_Annotations$();
      var a$1 = new $c_Lamf_core_parser_Annotations().init___();
      $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape$4, name$1, a$1);
      this.adopt$2.apply__O__O(shape$4);
      var parsed = shape$4
    }
  };
  if ((maybeReferenceId instanceof $c_s_Some)) {
    var x2$3 = $as_s_Some(maybeReferenceId);
    var r = $as_T(x2$3.value$2);
    var field$7 = $m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().ReferenceId$1;
    $as_Lamf_core_model_domain_ExternalSourceElement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(parsed, field$7, r))
  } else {
    var jsx$5 = parsed.annotations$2;
    var jsx$4 = $m_Lamf_core_parser_Range$();
    var this$42 = this.value$2;
    var this$43 = this$42.location$1;
    jsx$5.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_LexicalInformation().init___Lamf_core_parser_Range(jsx$4.apply__Lorg_mulesoft_lexer_InputRange__Lamf_core_parser_Range($m_Lorg_mulesoft_lexer_InputRange$().apply__I__I__I__I__Lorg_mulesoft_lexer_InputRange(this$43.lineFrom$1, this$43.columnFrom$1, this$43.lineTo$1, this$43.columnTo$1))))
  };
  var field$8 = $m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$().Location$1;
  if (maybeLocation.isEmpty__Z()) {
    var this$44 = this.ctx$2;
    var jsx$6 = this$44.rootContextDocument$1
  } else {
    var jsx$6 = maybeLocation.get__O()
  };
  var value = $as_T(jsx$6);
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(parsed, field$8, value);
  if ((!maybeFragmentLabel.isEmpty__Z())) {
    var arg1$6 = maybeFragmentLabel.get__O();
    var x$4$2 = $as_T(arg1$6);
    parsed.annotations$2.$$plus$eq__Lamf_core_model_domain_Annotation__Lamf_core_parser_Annotations(new $c_Lamf_core_annotations_ExternalFragmentRef().init___T(x$4$2))
  };
  return parsed
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression.prototype.productPrefix__T = (function() {
  return "RamlXmlSchemaExpression"
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression.prototype.externalType__T = (function() {
  return this.externalType$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression.prototype.productArity__I = (function() {
  return 4
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression)) {
    var RamlXmlSchemaExpression$1 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression(x$1);
    var this$1 = this.key$2;
    var b = RamlXmlSchemaExpression$1.key$2;
    if ($f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$1, b)) {
      var this$2 = this.value$2;
      var b$1 = RamlXmlSchemaExpression$1.value$2;
      var jsx$2 = $f_Lorg_yaml_model_YValueLike__$$eq$eq__Lorg_yaml_model_YValueLike__Z(this$2, b$1)
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x = this.adopt$2;
      var x$2 = RamlXmlSchemaExpression$1.adopt$2;
      var jsx$1 = ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.parseExample$2 === RamlXmlSchemaExpression$1.parseExample$2)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.key$2;
      break
    }
    case 1: {
      return this.value$2;
      break
    }
    case 2: {
      return this.adopt$2;
      break
    }
    case 3: {
      return this.parseExample$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression.prototype.init___Lorg_yaml_model_YNode__Lorg_yaml_model_YNode__F1__Z__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(key, value, adopt, parseExample, ctx) {
  this.key$2 = key;
  this.value$2 = value;
  this.adopt$2 = adopt;
  this.parseExample$2 = parseExample;
  this.ctx$2 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser.prototype.init___Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, ctx);
  this.externalType$2 = "XML";
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression.prototype.ValueAndOrigin__Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$ = (function() {
  if ((this.ValueAndOrigin$module$2 === null)) {
    this.ValueAndOrigin$lzycompute$1__p2__V()
  };
  return this.ValueAndOrigin$module$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression.prototype.ValueAndOrigin$lzycompute$1__p2__V = (function() {
  if ((this.ValueAndOrigin$module$2 === null)) {
    this.ValueAndOrigin$module$2 = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser$ValueAndOrigin$().init___Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser(this)
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.key$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.value$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.adopt$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.parseExample$2 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 4)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression.prototype.value__Lorg_yaml_model_YNode = (function() {
  return this.value$2
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression.prototype.adopt__F1 = (function() {
  return this.adopt$2
});
function $as_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.declaration.external.raml.RamlXmlSchemaExpression"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.declaration.external.raml.RamlXmlSchemaExpression;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression: 0
}, false, "amf.plugins.document.webapi.parser.spec.declaration.external.raml.RamlXmlSchemaExpression", {
  Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_WebApiBaseSpecParser: 1,
  Lamf_core_parser_BaseSpecParser: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlExternalTypesParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_ExampleParser: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_declaration_external_raml_RamlXmlSchemaExpression;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser.call(this);
  this.root$3 = null;
  this.ctx$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser();
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function() {
  return this.ctx$3
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser.prototype.productPrefix__T = (function() {
  return "RamlModuleParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser)) {
    var RamlModuleParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser(x$1);
    var x = this.root$3;
    var x$2 = RamlModuleParser$1.root$3;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.root$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser.prototype.parseModule__Lamf_core_model_document_Module = (function() {
  var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations($as_Lamf_core_parser_SyamlParsedDocument(this.root$3.parsed$1).document$2);
  var this$3 = new $c_Lamf_core_model_document_Module().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var location = this.root$3.location$1;
  var field = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
  var qual$1 = $as_Lamf_core_model_document_Module($as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$3, field, location)));
  var x$1 = this.root$3.location$1;
  $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
  var this$4 = $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(qual$1, x$1);
  var annotation = new $c_Lamf_core_annotations_SourceVendor().init___Lamf_core_remote_Vendor(this.ctx$3.vendor__Lamf_core_remote_Vendor());
  var module = $as_Lamf_core_model_document_Module($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$4, annotation));
  var location$1 = this.root$3.location$1;
  var field$1 = $m_Lamf_core_metamodel_document_BaseUnitModel$().Location$1;
  $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(module, field$1, location$1));
  var node = $as_Lamf_core_parser_SyamlParsedDocument(this.root$3.parsed$1).document$2;
  var this$6 = new $c_Lamf_core_parser_package$YNodeLikeOps().init___Lorg_yaml_model_YNodeLike(node).toOption__Lorg_yaml_convert_YRead__s_Option($m_Lorg_yaml_convert_YRead$YMapYRead$());
  if ((!this$6.isEmpty__Z())) {
    var arg1 = this$6.get__O();
    var rootMap = $as_Lorg_yaml_model_YMap(arg1);
    this.ctx$3.closedShape__T__Lorg_yaml_model_YMap__T__V(module.id$1, rootMap, "module");
    var references = new $c_Lamf_plugins_document_webapi_parser_spec_declaration_ReferencesParser().init___Lamf_core_model_document_BaseUnit__T__Lorg_yaml_model_YMap__sc_Seq__Lamf_plugins_document_webapi_contexts_WebApiContext(module, "uses", rootMap, this.root$3.references$1, this.ctx$3).parse__T__Lamf_plugins_document_webapi_parser_spec_declaration_ReferenceDeclarations(this.root$3.location$1);
    this.parseDeclarations__Lamf_core_Root__Lorg_yaml_model_YMap__V(this.root$3, rootMap);
    new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser__Lorg_yaml_model_YMap__Lamf_core_model_document_BaseUnit(this, rootMap, module).parse__V();
    var declarables = this.ctx$3.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().declarables__sc_Seq();
    if (declarables.nonEmpty__Z()) {
      var field$2 = $m_Lamf_core_metamodel_document_ModuleModel$().Declares$1;
      $as_Lamf_core_model_document_DeclaresModel($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(module, field$2, declarables))
    };
    var this$7 = references.references$1;
    if ($f_sc_TraversableOnce__nonEmpty__Z(this$7)) {
      var references$1 = references.solvedReferences__sc_Seq();
      var field$3 = $m_Lamf_core_metamodel_document_DocumentModel$().References$1;
      $as_Lamf_core_model_document_BaseUnit($f_Lamf_core_model_domain_AmfObject__setArrayWithoutId__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(module, field$3, references$1))
    }
  };
  var this$8 = this.ctx$3.futureDeclarations$1;
  $f_Lamf_core_parser_FutureDeclarations__resolve__V(this$8);
  return module
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(root, ctx) {
  this.root$3 = root;
  this.ctx$3 = ctx;
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser.prototype.init___Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$3
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser.prototype.parseSecuritySchemeDeclarations__Lorg_yaml_model_YMap__T__V = (function(map, parent) {
  $f_Lamf_plugins_document_webapi_parser_spec_raml_Raml10BaseSpecParser__parseSecuritySchemeDeclarations__Lorg_yaml_model_YMap__T__V(this, map, parent)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.RamlModuleParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.RamlModuleParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.RamlModuleParser", {
  Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_WebApiBaseSpecParser: 1,
  Lamf_core_parser_BaseSpecParser: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_Raml10BaseSpecParser: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_RamlModuleParser;
function $f_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel__$$init$__V($thiz) {
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  $thiz.MediaType$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "mediaType"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "media type", "Media type associated to a shape", $m_sci_Nil$()), true);
  $m_sci_List$();
  var array = [$thiz.MediaType$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$7 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$7);
    i = (((-1) + i) | 0)
  };
  $thiz.specificFields$1 = result;
  var jsx$5 = $thiz.specificFields$1;
  var jsx$4 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().fields$1;
  var this$8 = $m_sci_List$();
  var jsx$3 = $as_sci_List(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$8.ReusableCBFInstance$2));
  var jsx$2 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$9 = $m_sci_List$();
  $thiz.fields$1 = $as_sci_List(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$9.ReusableCBFInstance$2));
  $m_sci_List$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var array$1 = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "SchemaShape")];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$15 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$15);
    i$1 = (((-1) + i$1) | 0)
  };
  var jsx$7 = result$1;
  var jsx$6 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().type$1;
  var this$16 = $m_sci_List$();
  $thiz.type$1 = $as_sci_List(jsx$7.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$6, this$16.ReusableCBFInstance$2));
  $thiz.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "Schema Shape", "Raw schema that cannot be parsed using AMF shapes model", $m_sci_Nil$())
}
function $f_Lamf_plugins_domain_webapi_metamodel_MessageModel__$$init$__V($thiz) {
  var jsx$1 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$());
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  $thiz.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$Payloads$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "payload"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "payload", "Payload for a Request/Response", $m_sci_Nil$()), true));
  var jsx$2 = $m_Lamf_plugins_domain_webapi_metamodel_CorrelationIdModel$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  $thiz.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$CorrelationId$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "correlationId"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "correlationId", "an identifier that can be used for message tracing and correlation", $m_sci_Nil$()), true));
  var jsx$3 = $m_Lamf_core_metamodel_Type$Str$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  $thiz.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$DisplayName$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "displayName"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "displayName", "Human readable name for the term", $m_sci_Nil$()), true));
  var jsx$4 = $m_Lamf_core_metamodel_Type$Str$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  $thiz.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$Title$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "title"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "title", "Title of the item", $m_sci_Nil$()), true));
  var jsx$5 = $m_Lamf_core_metamodel_Type$Str$();
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  $thiz.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$Summary$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "summary"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "summary", "Human readable short description of the request/response", $m_sci_Nil$()), true));
  var jsx$6 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_MessageBindingsModel$();
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  $thiz.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$Bindings$und$eq__Lamf_core_metamodel_Field__V(new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$6, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "binding"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "binding", "Bindings for this request/response", $m_sci_Nil$()), true))
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_Payload() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_Payload.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_Payload;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_Payload() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_Payload.prototype = $c_Lamf_plugins_domain_webapi_models_Payload.prototype;
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.productPrefix__T = (function() {
  return "Payload"
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.withEncoding__T__Lamf_plugins_domain_webapi_models_Encoding = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_Encoding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_EncodingModel$().PropertyName$1;
  var result = $as_Lamf_plugins_domain_webapi_models_Encoding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, name));
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Encoding$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field$1, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_Payload)) {
    var Payload$1 = $as_Lamf_plugins_domain_webapi_models_Payload(x$1);
    var x = this.fields$1;
    var x$2 = Payload$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = Payload$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_Payload().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_Payload($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$()
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().MediaType$1)).option$1;
  if (this$1.isEmpty__Z()) {
    var this$2 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Name$1)).option$1;
    var jsx$1 = $as_T((this$2.isEmpty__Z() ? "default" : this$2.get__O()))
  } else {
    var jsx$1 = this$1.get__O()
  };
  var str = $as_T(jsx$1);
  var this$4 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$5 = this$4.platform$1;
  var url = this$4.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$5, url))
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.withObjectSchema__T__Lamf_plugins_domain_shapes_models_NodeShape = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_shapes_models_NodeShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var node = $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, node);
  return node
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.schema__Lamf_core_model_domain_Shape = (function() {
  return $as_Lamf_core_model_domain_Shape(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1))
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.withScalarSchema__T__Lamf_plugins_domain_shapes_models_ScalarShape = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_shapes_models_ScalarShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var scalar = $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Schema$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, scalar);
  return scalar
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_Payload().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.setSchema__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape = (function(shape) {
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$().Schema$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, shape);
  return shape
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_PayloadModel$().Name$1
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_webapi_models_Payload(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_Payload) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.Payload"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_Payload(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_Payload)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_Payload(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_Payload(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.Payload;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_Payload = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_Payload: 0
}, false, "amf.plugins.domain.webapi.models.Payload", {
  Lamf_plugins_domain_webapi_models_Payload: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_plugins_domain_webapi_models_SchemaContainer: 1,
  Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_Payload.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_Payload;
function $is_sc_GenSet(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_GenSet)))
}
function $as_sc_GenSet(obj) {
  return (($is_sc_GenSet(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.GenSet"))
}
function $isArrayOf_sc_GenSet(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_GenSet)))
}
function $asArrayOf_sc_GenSet(obj, depth) {
  return (($isArrayOf_sc_GenSet(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.GenSet;", depth))
}
function $f_sc_IndexedSeqLike__toBuffer__scm_Buffer($thiz) {
  var result = new $c_scm_ArrayBuffer().init___I($thiz.size__I());
  var xs = $thiz.seq__sc_TraversableOnce();
  result.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuffer(xs);
  return result
}
function $is_sc_IndexedSeqLike(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_IndexedSeqLike)))
}
function $as_sc_IndexedSeqLike(obj) {
  return (($is_sc_IndexedSeqLike(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.IndexedSeqLike"))
}
function $isArrayOf_sc_IndexedSeqLike(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_IndexedSeqLike)))
}
function $asArrayOf_sc_IndexedSeqLike(obj, depth) {
  return (($isArrayOf_sc_IndexedSeqLike(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.IndexedSeqLike;", depth))
}
function $is_sc_LinearSeqLike(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_LinearSeqLike)))
}
function $as_sc_LinearSeqLike(obj) {
  return (($is_sc_LinearSeqLike(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.LinearSeqLike"))
}
function $isArrayOf_sc_LinearSeqLike(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_LinearSeqLike)))
}
function $asArrayOf_sc_LinearSeqLike(obj, depth) {
  return (($isArrayOf_sc_LinearSeqLike(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.LinearSeqLike;", depth))
}
function $is_sc_TraversableView(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_TraversableView)))
}
function $as_sc_TraversableView(obj) {
  return (($is_sc_TraversableView(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.TraversableView"))
}
function $isArrayOf_sc_TraversableView(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_TraversableView)))
}
function $asArrayOf_sc_TraversableView(obj, depth) {
  return (($isArrayOf_sc_TraversableView(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.TraversableView;", depth))
}
/** @constructor */
function $c_Lamf_client_model_domain_FileShape() {
  $c_Lamf_client_model_domain_AnyShape.call(this)
}
$c_Lamf_client_model_domain_FileShape.prototype = new $h_Lamf_client_model_domain_AnyShape();
$c_Lamf_client_model_domain_FileShape.prototype.constructor = $c_Lamf_client_model_domain_FileShape;
/** @constructor */
function $h_Lamf_client_model_domain_FileShape() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_FileShape.prototype = $c_Lamf_client_model_domain_FileShape.prototype;
$c_Lamf_client_model_domain_FileShape.prototype.$$js$exported$prop$pattern__O = (function() {
  return this.pattern__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_FileShape.prototype.fileTypes__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
  var from = $as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$().FileTypes$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_FileShape.prototype.productPrefix__T = (function() {
  return "FileShape"
});
$c_Lamf_client_model_domain_FileShape.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_FileShape.prototype.init___Lamf_plugins_domain_shapes_models_FileShape.call(this, new $c_Lamf_plugins_domain_shapes_models_FileShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_FileShape.prototype.$$js$exported$meth$withFormat__T__O = (function(format) {
  return this.withFormat__T__Lamf_client_model_domain_FileShape(format)
});
$c_Lamf_client_model_domain_FileShape.prototype.$$undinternal__Lamf_core_model_domain_Shape = (function() {
  return $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_FileShape.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_FileShape.prototype.$$js$exported$prop$multipleOf__O = (function() {
  return this.multipleOf__Lamf_client_model_DoubleField()
});
$c_Lamf_client_model_domain_FileShape.prototype.maxLength__Lamf_client_model_IntField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
  var from = $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__maxLength__Lamf_core_model_IntField(this$1);
  $m_Lamf_client_convert_WebApiClientConverters$().IntFieldMatcher__Lamf_client_convert_FieldConverter$IntFieldMatcher$();
  return new $c_Lamf_client_model_IntField().init___Lamf_core_model_IntField(from)
});
$c_Lamf_client_model_domain_FileShape.prototype.$$js$exported$meth$withPattern__T__O = (function(pattern) {
  return this.withPattern__T__Lamf_client_model_domain_FileShape(pattern)
});
$c_Lamf_client_model_domain_FileShape.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_FileShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_FileShape)) {
    var FileShape$1 = $as_Lamf_client_model_domain_FileShape(x$1);
    var x = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_domain_shapes_models_FileShape(FileShape$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_FileShape.prototype.withPattern__T__Lamf_client_model_domain_FileShape = (function(pattern) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Pattern$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, pattern));
  return this
});
$c_Lamf_client_model_domain_FileShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_FileShape.prototype.$$js$exported$prop$exclusiveMinimum__O = (function() {
  return this.exclusiveMinimum__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_FileShape.prototype.withMinimum__D__Lamf_client_model_domain_FileShape = (function(min) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Minimum$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__D__Lamf_core_model_domain_AmfObject(this$1, field, min));
  return this
});
$c_Lamf_client_model_domain_FileShape.prototype.exclusiveMaximum__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
  var from = $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__exclusiveMaximum__Lamf_core_model_BoolField(this$1);
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_FileShape.prototype.withExclusiveMinimum__Z__Lamf_client_model_domain_FileShape = (function(min) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().ExclusiveMinimum$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, min));
  return this
});
$c_Lamf_client_model_domain_FileShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_FileShape.prototype.withFormat__T__Lamf_client_model_domain_FileShape = (function(format) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Format$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, format));
  return this
});
$c_Lamf_client_model_domain_FileShape.prototype.withMinLength__I__Lamf_client_model_domain_FileShape = (function(min) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MinLength$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject(this$1, field, min));
  return this
});
$c_Lamf_client_model_domain_FileShape.prototype.withMaxLength__I__Lamf_client_model_domain_FileShape = (function(max) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MaxLength$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject(this$1, field, max));
  return this
});
$c_Lamf_client_model_domain_FileShape.prototype.multipleOf__Lamf_client_model_DoubleField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
  var from = $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__multipleOf__Lamf_core_model_DoubleField(this$1);
  $m_Lamf_client_convert_WebApiClientConverters$().DoubleFieldMatcher__Lamf_client_convert_FieldConverter$DoubleFieldMatcher$();
  return new $c_Lamf_client_model_DoubleField().init___Lamf_core_model_DoubleField(from)
});
$c_Lamf_client_model_domain_FileShape.prototype.pattern__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
  var from = $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__pattern__Lamf_core_model_StrField(this$1);
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_FileShape.prototype.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_FileShape.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_FileShape()
});
$c_Lamf_client_model_domain_FileShape.prototype.$$js$exported$prop$maximum__O = (function() {
  return this.maximum__Lamf_client_model_DoubleField()
});
$c_Lamf_client_model_domain_FileShape.prototype.maximum__Lamf_client_model_DoubleField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
  var from = $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__maximum__Lamf_core_model_DoubleField(this$1);
  $m_Lamf_client_convert_WebApiClientConverters$().DoubleFieldMatcher__Lamf_client_convert_FieldConverter$DoubleFieldMatcher$();
  return new $c_Lamf_client_model_DoubleField().init___Lamf_core_model_DoubleField(from)
});
$c_Lamf_client_model_domain_FileShape.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_FileShape()
});
$c_Lamf_client_model_domain_FileShape.prototype.$$js$exported$meth$withMaximum__D__O = (function(max) {
  return this.withMaximum__D__Lamf_client_model_domain_FileShape(max)
});
$c_Lamf_client_model_domain_FileShape.prototype.exclusiveMinimum__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
  var from = $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__exclusiveMinimum__Lamf_core_model_BoolField(this$1);
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_FileShape.prototype.$$js$exported$meth$withFileTypes__sjs_js_Array__O = (function(fileTypes) {
  return this.withFileTypes__sjs_js_Array__Lamf_client_model_domain_FileShape(fileTypes)
});
$c_Lamf_client_model_domain_FileShape.prototype.$$js$exported$meth$withMinimum__D__O = (function(min) {
  return this.withMinimum__D__Lamf_client_model_domain_FileShape(min)
});
$c_Lamf_client_model_domain_FileShape.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_FileShape.prototype.$$js$exported$prop$fileTypes__O = (function() {
  return this.fileTypes__sjs_js_Array()
});
$c_Lamf_client_model_domain_FileShape.prototype.$$js$exported$prop$maxLength__O = (function() {
  return this.maxLength__Lamf_client_model_IntField()
});
$c_Lamf_client_model_domain_FileShape.prototype.linkCopy__Lamf_client_model_domain_FileShape = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$5 = new $c_Lamf_plugins_domain_shapes_models_FileShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_shapes_models_FileShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().FileShapeMatcher__Lamf_client_convert_FileShapeConverter$FileShapeMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_FileShape__Lamf_client_model_domain_FileShape(from)
});
$c_Lamf_client_model_domain_FileShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_FileShape.prototype.minimum__Lamf_client_model_DoubleField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
  var from = $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__minimum__Lamf_core_model_DoubleField(this$1);
  $m_Lamf_client_convert_WebApiClientConverters$().DoubleFieldMatcher__Lamf_client_convert_FieldConverter$DoubleFieldMatcher$();
  return new $c_Lamf_client_model_DoubleField().init___Lamf_core_model_DoubleField(from)
});
$c_Lamf_client_model_domain_FileShape.prototype.format__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
  var from = $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__format__Lamf_core_model_StrField(this$1);
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_FileShape.prototype.$$js$exported$meth$withExclusiveMinimum__Z__O = (function(min) {
  return this.withExclusiveMinimum__Z__Lamf_client_model_domain_FileShape(min)
});
$c_Lamf_client_model_domain_FileShape.prototype.withMaximum__D__Lamf_client_model_domain_FileShape = (function(max) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Maximum$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__D__Lamf_core_model_domain_AmfObject(this$1, field, max));
  return this
});
$c_Lamf_client_model_domain_FileShape.prototype.$$js$exported$prop$minLength__O = (function() {
  return this.minLength__Lamf_client_model_IntField()
});
$c_Lamf_client_model_domain_FileShape.prototype.$$js$exported$prop$exclusiveMaximum__O = (function() {
  return this.exclusiveMaximum__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_FileShape.prototype.$$js$exported$meth$withMinLength__I__O = (function(min) {
  return this.withMinLength__I__Lamf_client_model_domain_FileShape(min)
});
$c_Lamf_client_model_domain_FileShape.prototype.withFileTypes__sjs_js_Array__Lamf_client_model_domain_FileShape = (function(fileTypes) {
  var this$2 = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  var fileTypes$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, fileTypes, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$().FileTypes$1;
  $as_Lamf_plugins_domain_shapes_models_FileShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, fileTypes$1));
  return this
});
$c_Lamf_client_model_domain_FileShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_FileShape.prototype.withExclusiveMaximum__Z__Lamf_client_model_domain_FileShape = (function(max) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().ExclusiveMaximum$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, max));
  return this
});
$c_Lamf_client_model_domain_FileShape.prototype.linkCopy__Lamf_client_model_domain_AnyShape = (function() {
  return this.linkCopy__Lamf_client_model_domain_FileShape()
});
$c_Lamf_client_model_domain_FileShape.prototype.init___Lamf_plugins_domain_shapes_models_FileShape = (function(_internal) {
  $c_Lamf_client_model_domain_AnyShape.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape.call(this, _internal);
  return this
});
$c_Lamf_client_model_domain_FileShape.prototype.$$js$exported$prop$format__O = (function() {
  return this.format__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_FileShape.prototype.$$js$exported$meth$withMaxLength__I__O = (function(max) {
  return this.withMaxLength__I__Lamf_client_model_domain_FileShape(max)
});
$c_Lamf_client_model_domain_FileShape.prototype.$$js$exported$meth$withExclusiveMaximum__Z__O = (function(max) {
  return this.withExclusiveMaximum__Z__Lamf_client_model_domain_FileShape(max)
});
$c_Lamf_client_model_domain_FileShape.prototype.$$js$exported$prop$minimum__O = (function() {
  return this.minimum__Lamf_client_model_DoubleField()
});
$c_Lamf_client_model_domain_FileShape.prototype.withMultipleOf__D__Lamf_client_model_domain_FileShape = (function(multiple) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MultipleOf$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__D__Lamf_core_model_domain_AmfObject(this$1, field, multiple));
  return this
});
$c_Lamf_client_model_domain_FileShape.prototype.$$js$exported$meth$withMultipleOf__D__O = (function(multiple) {
  return this.withMultipleOf__D__Lamf_client_model_domain_FileShape(multiple)
});
$c_Lamf_client_model_domain_FileShape.prototype.minLength__Lamf_client_model_IntField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_FileShape(this.$$undinternal$1);
  var from = $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__minLength__Lamf_core_model_IntField(this$1);
  $m_Lamf_client_convert_WebApiClientConverters$().IntFieldMatcher__Lamf_client_convert_FieldConverter$IntFieldMatcher$();
  return new $c_Lamf_client_model_IntField().init___Lamf_core_model_IntField(from)
});
$c_Lamf_client_model_domain_FileShape.prototype.withMultipleOf = (function(arg) {
  var prep = $uD(arg);
  return this.$$js$exported$meth$withMultipleOf__D__O(prep)
});
$c_Lamf_client_model_domain_FileShape.prototype.withFormat = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withFormat__T__O(prep)
});
$c_Lamf_client_model_domain_FileShape.prototype.withExclusiveMaximum = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withExclusiveMaximum__Z__O(prep)
});
$c_Lamf_client_model_domain_FileShape.prototype.withExclusiveMinimum = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withExclusiveMinimum__Z__O(prep)
});
$c_Lamf_client_model_domain_FileShape.prototype.withMaximum = (function(arg) {
  var prep = $uD(arg);
  return this.$$js$exported$meth$withMaximum__D__O(prep)
});
$c_Lamf_client_model_domain_FileShape.prototype.withMinimum = (function(arg) {
  var prep = $uD(arg);
  return this.$$js$exported$meth$withMinimum__D__O(prep)
});
$c_Lamf_client_model_domain_FileShape.prototype.withMaxLength = (function(arg) {
  var prep = $uI(arg);
  return this.$$js$exported$meth$withMaxLength__I__O(prep)
});
$c_Lamf_client_model_domain_FileShape.prototype.withMinLength = (function(arg) {
  var prep = $uI(arg);
  return this.$$js$exported$meth$withMinLength__I__O(prep)
});
$c_Lamf_client_model_domain_FileShape.prototype.withPattern = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withPattern__T__O(prep)
});
$c_Lamf_client_model_domain_FileShape.prototype.withFileTypes = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withFileTypes__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_FileShape.prototype, "multipleOf", {
  "get": (function() {
    return this.$$js$exported$prop$multipleOf__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_FileShape.prototype, "format", {
  "get": (function() {
    return this.$$js$exported$prop$format__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_FileShape.prototype, "exclusiveMaximum", {
  "get": (function() {
    return this.$$js$exported$prop$exclusiveMaximum__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_FileShape.prototype, "exclusiveMinimum", {
  "get": (function() {
    return this.$$js$exported$prop$exclusiveMinimum__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_FileShape.prototype, "maximum", {
  "get": (function() {
    return this.$$js$exported$prop$maximum__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_FileShape.prototype, "minimum", {
  "get": (function() {
    return this.$$js$exported$prop$minimum__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_FileShape.prototype, "maxLength", {
  "get": (function() {
    return this.$$js$exported$prop$maxLength__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_FileShape.prototype, "minLength", {
  "get": (function() {
    return this.$$js$exported$prop$minLength__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_FileShape.prototype, "pattern", {
  "get": (function() {
    return this.$$js$exported$prop$pattern__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_FileShape.prototype, "fileTypes", {
  "get": (function() {
    return this.$$js$exported$prop$fileTypes__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_FileShape(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_FileShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.FileShape"))
}
function $isArrayOf_Lamf_client_model_domain_FileShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_FileShape)))
}
function $asArrayOf_Lamf_client_model_domain_FileShape(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_FileShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.FileShape;", depth))
}
var $d_Lamf_client_model_domain_FileShape = new $TypeData().initClass({
  Lamf_client_model_domain_FileShape: 0
}, false, "amf.client.model.domain.FileShape", {
  Lamf_client_model_domain_FileShape: 1,
  Lamf_client_model_domain_AnyShape: 1,
  O: 1,
  Lamf_client_model_domain_Shape: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_FileShape.prototype.$classData = $d_Lamf_client_model_domain_FileShape;
/** @constructor */
function $c_Lamf_client_model_domain_NilShape() {
  $c_Lamf_client_model_domain_AnyShape.call(this)
}
$c_Lamf_client_model_domain_NilShape.prototype = new $h_Lamf_client_model_domain_AnyShape();
$c_Lamf_client_model_domain_NilShape.prototype.constructor = $c_Lamf_client_model_domain_NilShape;
/** @constructor */
function $h_Lamf_client_model_domain_NilShape() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_NilShape.prototype = $c_Lamf_client_model_domain_NilShape.prototype;
$c_Lamf_client_model_domain_NilShape.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_NilShape.prototype.init___Lamf_plugins_domain_shapes_models_NilShape.call(this, new $c_Lamf_plugins_domain_shapes_models_NilShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_NilShape.prototype.productPrefix__T = (function() {
  return "NilShape"
});
$c_Lamf_client_model_domain_NilShape.prototype.$$undinternal__Lamf_core_model_domain_Shape = (function() {
  return $as_Lamf_plugins_domain_shapes_models_NilShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_NilShape.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_NilShape.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_domain_shapes_models_NilShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_NilShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_NilShape)) {
    var NilShape$1 = $as_Lamf_client_model_domain_NilShape(x$1);
    var x = $as_Lamf_plugins_domain_shapes_models_NilShape(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_domain_shapes_models_NilShape(NilShape$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_NilShape.prototype.init___Lamf_plugins_domain_shapes_models_NilShape = (function(_internal) {
  $c_Lamf_client_model_domain_AnyShape.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape.call(this, _internal);
  return this
});
$c_Lamf_client_model_domain_NilShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_domain_shapes_models_NilShape(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_NilShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_NilShape.prototype.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return $as_Lamf_plugins_domain_shapes_models_NilShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_NilShape.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_NilShape()
});
$c_Lamf_client_model_domain_NilShape.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_NilShape()
});
$c_Lamf_client_model_domain_NilShape.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_domain_shapes_models_NilShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_NilShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_NilShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_NilShape.prototype.linkCopy__Lamf_client_model_domain_AnyShape = (function() {
  return this.linkCopy__Lamf_client_model_domain_NilShape()
});
$c_Lamf_client_model_domain_NilShape.prototype.linkCopy__Lamf_client_model_domain_NilShape = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_NilShape(this.$$undinternal$1);
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$5 = new $c_Lamf_plugins_domain_shapes_models_NilShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_shapes_models_NilShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().NilShapeMatcher__Lamf_client_convert_NilShapeConverter$NilShapeMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_NilShape__Lamf_client_model_domain_NilShape(from)
});
function $as_Lamf_client_model_domain_NilShape(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_NilShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.NilShape"))
}
function $isArrayOf_Lamf_client_model_domain_NilShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_NilShape)))
}
function $asArrayOf_Lamf_client_model_domain_NilShape(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_NilShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.NilShape;", depth))
}
var $d_Lamf_client_model_domain_NilShape = new $TypeData().initClass({
  Lamf_client_model_domain_NilShape: 0
}, false, "amf.client.model.domain.NilShape", {
  Lamf_client_model_domain_NilShape: 1,
  Lamf_client_model_domain_AnyShape: 1,
  O: 1,
  Lamf_client_model_domain_Shape: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_NilShape.prototype.$classData = $d_Lamf_client_model_domain_NilShape;
/** @constructor */
function $c_Lamf_client_model_domain_NodeShape() {
  $c_Lamf_client_model_domain_AnyShape.call(this)
}
$c_Lamf_client_model_domain_NodeShape.prototype = new $h_Lamf_client_model_domain_AnyShape();
$c_Lamf_client_model_domain_NodeShape.prototype.constructor = $c_Lamf_client_model_domain_NodeShape;
/** @constructor */
function $h_Lamf_client_model_domain_NodeShape() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_NodeShape.prototype = $c_Lamf_client_model_domain_NodeShape.prototype;
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$meth$withDiscriminatorMapping__sjs_js_Array__O = (function(mappings) {
  return this.withDiscriminatorMapping__sjs_js_Array__Lamf_client_model_domain_NodeShape(mappings)
});
$c_Lamf_client_model_domain_NodeShape.prototype.withClosed__Z__Lamf_client_model_domain_NodeShape = (function(closed) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1;
  $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, closed));
  return this
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$prop$discriminatorValue__O = (function() {
  return this.discriminatorValue__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_NodeShape.prototype.minProperties__Lamf_client_model_IntField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
  var from = $as_Lamf_core_model_IntField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MinProperties$1));
  $m_Lamf_client_convert_WebApiClientConverters$().IntFieldMatcher__Lamf_client_convert_FieldConverter$IntFieldMatcher$();
  return new $c_Lamf_client_model_IntField().init___Lamf_core_model_IntField(from)
});
$c_Lamf_client_model_domain_NodeShape.prototype.productPrefix__T = (function() {
  return "NodeShape"
});
$c_Lamf_client_model_domain_NodeShape.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_NodeShape.prototype.init___Lamf_plugins_domain_shapes_models_NodeShape.call(this, new $c_Lamf_plugins_domain_shapes_models_NodeShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_NodeShape.prototype.propertyNames__Lamf_client_model_domain_Shape = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
  var from = $as_Lamf_core_model_domain_Shape(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().PropertyNames$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(from)
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$undinternal__Lamf_core_model_domain_Shape = (function() {
  return $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$prop$discriminator__O = (function() {
  return this.discriminator__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_NodeShape.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$meth$withInheritsObject__T__O = (function(name) {
  return this.withInheritsObject__T__Lamf_client_model_domain_NodeShape(name)
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$prop$discriminatorMapping__O = (function() {
  return this.discriminatorMapping__sjs_js_Array()
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$meth$withDiscriminator__T__O = (function(discriminator) {
  return this.withDiscriminator__T__Lamf_client_model_domain_NodeShape(discriminator)
});
$c_Lamf_client_model_domain_NodeShape.prototype.properties__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
  var from = $as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PropertyShapeMatcher__Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_NodeShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_NodeShape)) {
    var NodeShape$1 = $as_Lamf_client_model_domain_NodeShape(x$1);
    var x = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_domain_shapes_models_NodeShape(NodeShape$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$prop$minProperties__O = (function() {
  return this.minProperties__Lamf_client_model_IntField()
});
$c_Lamf_client_model_domain_NodeShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_NodeShape.prototype.withProperty__T__Lamf_client_model_domain_PropertyShape = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1).withProperty__T__Lamf_core_model_domain_extensions_PropertyShape(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PropertyShapeMatcher__Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_extensions_PropertyShape__Lamf_client_model_domain_PropertyShape(from)
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$prop$additionalPropertiesSchema__O = (function() {
  return this.additionalPropertiesSchema__Lamf_client_model_domain_Shape()
});
$c_Lamf_client_model_domain_NodeShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_NodeShape.prototype.withInheritsScalar__T__Lamf_client_model_domain_ScalarShape = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1).withInheritsScalar__T__Lamf_plugins_domain_shapes_models_ScalarShape(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ScalarShapeMatcher__Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_client_model_domain_ScalarShape(from)
});
$c_Lamf_client_model_domain_NodeShape.prototype.dependencies__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
  var from = $as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Dependencies$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PropertyDependenciesMatcher__Lamf_client_convert_PropertyDependenciesConverter$PropertyDependenciesMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$prop$dependencies__O = (function() {
  return this.dependencies__sjs_js_Array()
});
$c_Lamf_client_model_domain_NodeShape.prototype.closed__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
  var from = $as_Lamf_core_model_BoolField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Closed$1));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_NodeShape.prototype.additionalPropertiesSchema__Lamf_client_model_domain_Shape = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
  var from = $as_Lamf_core_model_domain_Shape(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().AdditionalPropertiesSchema$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(from)
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$meth$withDependency__O = (function() {
  return this.withDependency__Lamf_client_model_domain_PropertyDependencies()
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$meth$withMinProperties__I__O = (function(min) {
  return this.withMinProperties__I__Lamf_client_model_domain_NodeShape(min)
});
$c_Lamf_client_model_domain_NodeShape.prototype.discriminatorMapping__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
  var from = $as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().DiscriminatorMapping$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().IriTemplateMappingConverter__Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_NodeShape.prototype.withProperties__sjs_js_Array__Lamf_client_model_domain_NodeShape = (function(properties) {
  var this$2 = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PropertyShapeMatcher__Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$();
  var properties$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, properties, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1;
  $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, properties$1));
  return this
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$meth$withInheritsScalar__T__O = (function(name) {
  return this.withInheritsScalar__T__Lamf_client_model_domain_ScalarShape(name)
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$meth$withDependencies__sjs_js_Array__O = (function(dependencies) {
  return this.withDependencies__sjs_js_Array__Lamf_client_model_domain_NodeShape(dependencies)
});
$c_Lamf_client_model_domain_NodeShape.prototype.withPropertyNames__Lamf_client_model_domain_Shape__Lamf_client_model_domain_NodeShape = (function(propertyNames) {
  var this$2 = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var shape = propertyNames.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().PropertyNames$1;
  $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, shape));
  return this
});
$c_Lamf_client_model_domain_NodeShape.prototype.withMaxProperties__I__Lamf_client_model_domain_NodeShape = (function(max) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MaxProperties$1;
  $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject(this$1, field, max));
  return this
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$meth$withAdditionalPropertiesSchema__Lamf_client_model_domain_Shape__O = (function(additionalPropertiesSchema) {
  return this.withAdditionalPropertiesSchema__Lamf_client_model_domain_Shape__Lamf_client_model_domain_NodeShape(additionalPropertiesSchema)
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_NodeShape()
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$prop$properties__O = (function() {
  return this.properties__sjs_js_Array()
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$prop$propertyNames__O = (function() {
  return this.propertyNames__Lamf_client_model_domain_Shape()
});
$c_Lamf_client_model_domain_NodeShape.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_NodeShape()
});
$c_Lamf_client_model_domain_NodeShape.prototype.discriminatorValue__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
  var from = $as_Lamf_core_model_StrField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().DiscriminatorValue$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_NodeShape.prototype.withAdditionalPropertiesSchema__Lamf_client_model_domain_Shape__Lamf_client_model_domain_NodeShape = (function(additionalPropertiesSchema) {
  var this$2 = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var shape = additionalPropertiesSchema.$$undinternal__Lamf_core_model_domain_Shape();
  var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().AdditionalPropertiesSchema$1;
  $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, shape));
  return this
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$meth$withDiscriminatorValue__T__O = (function(value) {
  return this.withDiscriminatorValue__T__Lamf_client_model_domain_NodeShape(value)
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$prop$closed__O = (function() {
  return this.closed__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_NodeShape.prototype.withDependency__Lamf_client_model_domain_PropertyDependencies = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1).withDependency__Lamf_plugins_domain_shapes_models_PropertyDependencies();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PropertyDependenciesMatcher__Lamf_client_convert_PropertyDependenciesConverter$PropertyDependenciesMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_PropertyDependencies__Lamf_client_model_domain_PropertyDependencies(from)
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_NodeShape.prototype.withInheritsObject__T__Lamf_client_model_domain_NodeShape = (function(name) {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var from = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1).withInheritsObject__T__Lamf_plugins_domain_shapes_models_NodeShape(name);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().NodeShapeMatcher__Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_NodeShape__Lamf_client_model_domain_NodeShape(from)
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$meth$withProperties__sjs_js_Array__O = (function(properties) {
  return this.withProperties__sjs_js_Array__Lamf_client_model_domain_NodeShape(properties)
});
$c_Lamf_client_model_domain_NodeShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_NodeShape.prototype.linkCopy__Lamf_client_model_domain_NodeShape = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$5 = new $c_Lamf_plugins_domain_shapes_models_NodeShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().NodeShapeMatcher__Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_NodeShape__Lamf_client_model_domain_NodeShape(from)
});
$c_Lamf_client_model_domain_NodeShape.prototype.withMinProperties__I__Lamf_client_model_domain_NodeShape = (function(min) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MinProperties$1;
  $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject(this$1, field, min));
  return this
});
$c_Lamf_client_model_domain_NodeShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_NodeShape.prototype.linkCopy__Lamf_client_model_domain_AnyShape = (function() {
  return this.linkCopy__Lamf_client_model_domain_NodeShape()
});
$c_Lamf_client_model_domain_NodeShape.prototype.withDiscriminatorMapping__sjs_js_Array__Lamf_client_model_domain_NodeShape = (function(mappings) {
  var this$2 = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().IriTemplateMappingConverter__Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$();
  var mappings$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, mappings, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().DiscriminatorMapping$1;
  $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, mappings$1));
  return this
});
$c_Lamf_client_model_domain_NodeShape.prototype.discriminator__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
  var from = $as_Lamf_core_model_StrField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Discriminator$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$meth$withProperty__T__O = (function(name) {
  return this.withProperty__T__Lamf_client_model_domain_PropertyShape(name)
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$meth$withPropertyNames__Lamf_client_model_domain_Shape__O = (function(propertyNames) {
  return this.withPropertyNames__Lamf_client_model_domain_Shape__Lamf_client_model_domain_NodeShape(propertyNames)
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$meth$withMaxProperties__I__O = (function(max) {
  return this.withMaxProperties__I__Lamf_client_model_domain_NodeShape(max)
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$meth$withClosed__Z__O = (function(closed) {
  return this.withClosed__Z__Lamf_client_model_domain_NodeShape(closed)
});
$c_Lamf_client_model_domain_NodeShape.prototype.$$js$exported$prop$maxProperties__O = (function() {
  return this.maxProperties__Lamf_client_model_IntField()
});
$c_Lamf_client_model_domain_NodeShape.prototype.maxProperties__Lamf_client_model_IntField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
  var from = $as_Lamf_core_model_IntField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().MaxProperties$1));
  $m_Lamf_client_convert_WebApiClientConverters$().IntFieldMatcher__Lamf_client_convert_FieldConverter$IntFieldMatcher$();
  return new $c_Lamf_client_model_IntField().init___Lamf_core_model_IntField(from)
});
$c_Lamf_client_model_domain_NodeShape.prototype.withDependencies__sjs_js_Array__Lamf_client_model_domain_NodeShape = (function(dependencies) {
  var this$2 = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().PropertyDependenciesMatcher__Lamf_client_convert_PropertyDependenciesConverter$PropertyDependenciesMatcher$();
  var dependencies$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, dependencies, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Dependencies$1;
  $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, dependencies$1));
  return this
});
$c_Lamf_client_model_domain_NodeShape.prototype.withDiscriminator__T__Lamf_client_model_domain_NodeShape = (function(discriminator) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Discriminator$1;
  $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, discriminator));
  return this
});
$c_Lamf_client_model_domain_NodeShape.prototype.init___Lamf_plugins_domain_shapes_models_NodeShape = (function(_internal) {
  $c_Lamf_client_model_domain_AnyShape.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape.call(this, _internal);
  return this
});
$c_Lamf_client_model_domain_NodeShape.prototype.withDiscriminatorValue__T__Lamf_client_model_domain_NodeShape = (function(value) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_NodeShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().DiscriminatorValue$1;
  $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, value));
  return this
});
$c_Lamf_client_model_domain_NodeShape.prototype.withInheritsScalar = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withInheritsScalar__T__O(prep)
});
$c_Lamf_client_model_domain_NodeShape.prototype.withInheritsObject = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withInheritsObject__T__O(prep)
});
$c_Lamf_client_model_domain_NodeShape.prototype.withDependency = (function() {
  return this.$$js$exported$meth$withDependency__O()
});
$c_Lamf_client_model_domain_NodeShape.prototype.withProperty = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withProperty__T__O(prep)
});
$c_Lamf_client_model_domain_NodeShape.prototype.withPropertyNames = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withPropertyNames__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_NodeShape.prototype.withDependencies = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withDependencies__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_NodeShape.prototype.withAdditionalPropertiesSchema = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withAdditionalPropertiesSchema__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_NodeShape.prototype.withProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withProperties__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_NodeShape.prototype.withDiscriminatorMapping = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withDiscriminatorMapping__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_NodeShape.prototype.withDiscriminatorValue = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDiscriminatorValue__T__O(prep)
});
$c_Lamf_client_model_domain_NodeShape.prototype.withDiscriminator = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDiscriminator__T__O(prep)
});
$c_Lamf_client_model_domain_NodeShape.prototype.withClosed = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withClosed__Z__O(prep)
});
$c_Lamf_client_model_domain_NodeShape.prototype.withMaxProperties = (function(arg) {
  var prep = $uI(arg);
  return this.$$js$exported$meth$withMaxProperties__I__O(prep)
});
$c_Lamf_client_model_domain_NodeShape.prototype.withMinProperties = (function(arg) {
  var prep = $uI(arg);
  return this.$$js$exported$meth$withMinProperties__I__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_NodeShape.prototype, "propertyNames", {
  "get": (function() {
    return this.$$js$exported$prop$propertyNames__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_NodeShape.prototype, "dependencies", {
  "get": (function() {
    return this.$$js$exported$prop$dependencies__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_NodeShape.prototype, "additionalPropertiesSchema", {
  "get": (function() {
    return this.$$js$exported$prop$additionalPropertiesSchema__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_NodeShape.prototype, "properties", {
  "get": (function() {
    return this.$$js$exported$prop$properties__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_NodeShape.prototype, "discriminatorMapping", {
  "get": (function() {
    return this.$$js$exported$prop$discriminatorMapping__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_NodeShape.prototype, "discriminatorValue", {
  "get": (function() {
    return this.$$js$exported$prop$discriminatorValue__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_NodeShape.prototype, "discriminator", {
  "get": (function() {
    return this.$$js$exported$prop$discriminator__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_NodeShape.prototype, "closed", {
  "get": (function() {
    return this.$$js$exported$prop$closed__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_NodeShape.prototype, "maxProperties", {
  "get": (function() {
    return this.$$js$exported$prop$maxProperties__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_NodeShape.prototype, "minProperties", {
  "get": (function() {
    return this.$$js$exported$prop$minProperties__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_NodeShape(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_NodeShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.NodeShape"))
}
function $isArrayOf_Lamf_client_model_domain_NodeShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_NodeShape)))
}
function $asArrayOf_Lamf_client_model_domain_NodeShape(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_NodeShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.NodeShape;", depth))
}
var $d_Lamf_client_model_domain_NodeShape = new $TypeData().initClass({
  Lamf_client_model_domain_NodeShape: 0
}, false, "amf.client.model.domain.NodeShape", {
  Lamf_client_model_domain_NodeShape: 1,
  Lamf_client_model_domain_AnyShape: 1,
  O: 1,
  Lamf_client_model_domain_Shape: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_NodeShape.prototype.$classData = $d_Lamf_client_model_domain_NodeShape;
/** @constructor */
function $c_Lamf_client_model_domain_ScalarShape() {
  $c_Lamf_client_model_domain_AnyShape.call(this)
}
$c_Lamf_client_model_domain_ScalarShape.prototype = new $h_Lamf_client_model_domain_AnyShape();
$c_Lamf_client_model_domain_ScalarShape.prototype.constructor = $c_Lamf_client_model_domain_ScalarShape;
/** @constructor */
function $h_Lamf_client_model_domain_ScalarShape() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_ScalarShape.prototype = $c_Lamf_client_model_domain_ScalarShape.prototype;
$c_Lamf_client_model_domain_ScalarShape.prototype.$$js$exported$prop$pattern__O = (function() {
  return this.pattern__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_ScalarShape.prototype.productPrefix__T = (function() {
  return "ScalarShape"
});
$c_Lamf_client_model_domain_ScalarShape.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_ScalarShape.prototype.init___Lamf_plugins_domain_shapes_models_ScalarShape.call(this, new $c_Lamf_plugins_domain_shapes_models_ScalarShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$js$exported$meth$withFormat__T__O = (function(format) {
  return this.withFormat__T__Lamf_client_model_domain_ScalarShape(format)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.withMinimum__D__Lamf_client_model_domain_ScalarShape = (function(min) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Minimum$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__D__Lamf_core_model_domain_AmfObject(this$1, field, min));
  return this
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$js$exported$meth$withDataType__T__O = (function(dataType) {
  return this.withDataType__T__Lamf_client_model_domain_ScalarShape(dataType)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$undinternal__Lamf_core_model_domain_Shape = (function() {
  return $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$js$exported$prop$multipleOf__O = (function() {
  return this.multipleOf__Lamf_client_model_DoubleField()
});
$c_Lamf_client_model_domain_ScalarShape.prototype.maxLength__Lamf_client_model_IntField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
  var from = $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__maxLength__Lamf_core_model_IntField(this$1);
  $m_Lamf_client_convert_WebApiClientConverters$().IntFieldMatcher__Lamf_client_convert_FieldConverter$IntFieldMatcher$();
  return new $c_Lamf_client_model_IntField().init___Lamf_core_model_IntField(from)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.withPattern__T__Lamf_client_model_domain_ScalarShape = (function(pattern) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Pattern$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, pattern));
  return this
});
$c_Lamf_client_model_domain_ScalarShape.prototype.withMultipleOf__D__Lamf_client_model_domain_ScalarShape = (function(multiple) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MultipleOf$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__D__Lamf_core_model_domain_AmfObject(this$1, field, multiple));
  return this
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$js$exported$meth$withPattern__T__O = (function(pattern) {
  return this.withPattern__T__Lamf_client_model_domain_ScalarShape(pattern)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.withMaximum__D__Lamf_client_model_domain_ScalarShape = (function(max) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Maximum$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__D__Lamf_core_model_domain_AmfObject(this$1, field, max));
  return this
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_ScalarShape)) {
    var ScalarShape$1 = $as_Lamf_client_model_domain_ScalarShape(x$1);
    var x = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(ScalarShape$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_ScalarShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$js$exported$prop$exclusiveMinimum__O = (function() {
  return this.exclusiveMinimum__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_ScalarShape.prototype.exclusiveMaximum__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
  var from = $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__exclusiveMaximum__Lamf_core_model_BoolField(this$1);
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.withExclusiveMaximum__Z__Lamf_client_model_domain_ScalarShape = (function(max) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().ExclusiveMaximum$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, max));
  return this
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$js$exported$prop$dataType__O = (function() {
  return this.dataType__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_ScalarShape.prototype.multipleOf__Lamf_client_model_DoubleField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
  var from = $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__multipleOf__Lamf_core_model_DoubleField(this$1);
  $m_Lamf_client_convert_WebApiClientConverters$().DoubleFieldMatcher__Lamf_client_convert_FieldConverter$DoubleFieldMatcher$();
  return new $c_Lamf_client_model_DoubleField().init___Lamf_core_model_DoubleField(from)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.pattern__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
  var from = $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__pattern__Lamf_core_model_StrField(this$1);
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.withMaxLength__I__Lamf_client_model_domain_ScalarShape = (function(max) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MaxLength$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject(this$1, field, max));
  return this
});
$c_Lamf_client_model_domain_ScalarShape.prototype.withExclusiveMinimum__Z__Lamf_client_model_domain_ScalarShape = (function(min) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().ExclusiveMinimum$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, min));
  return this
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.dataType__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
  var from = $as_Lamf_core_model_StrField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_ScalarShape()
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$js$exported$prop$maximum__O = (function() {
  return this.maximum__Lamf_client_model_DoubleField()
});
$c_Lamf_client_model_domain_ScalarShape.prototype.init___Lamf_plugins_domain_shapes_models_ScalarShape = (function(_internal) {
  $c_Lamf_client_model_domain_AnyShape.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape.call(this, _internal);
  return this
});
$c_Lamf_client_model_domain_ScalarShape.prototype.maximum__Lamf_client_model_DoubleField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
  var from = $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__maximum__Lamf_core_model_DoubleField(this$1);
  $m_Lamf_client_convert_WebApiClientConverters$().DoubleFieldMatcher__Lamf_client_convert_FieldConverter$DoubleFieldMatcher$();
  return new $c_Lamf_client_model_DoubleField().init___Lamf_core_model_DoubleField(from)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_ScalarShape()
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$js$exported$meth$withMaximum__D__O = (function(max) {
  return this.withMaximum__D__Lamf_client_model_domain_ScalarShape(max)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.withFormat__T__Lamf_client_model_domain_ScalarShape = (function(format) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().Format$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, format));
  return this
});
$c_Lamf_client_model_domain_ScalarShape.prototype.exclusiveMinimum__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
  var from = $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__exclusiveMinimum__Lamf_core_model_BoolField(this$1);
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$js$exported$meth$withMinimum__D__O = (function(min) {
  return this.withMinimum__D__Lamf_client_model_domain_ScalarShape(min)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$js$exported$prop$maxLength__O = (function() {
  return this.maxLength__Lamf_client_model_IntField()
});
$c_Lamf_client_model_domain_ScalarShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_ScalarShape.prototype.minimum__Lamf_client_model_DoubleField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
  var from = $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__minimum__Lamf_core_model_DoubleField(this$1);
  $m_Lamf_client_convert_WebApiClientConverters$().DoubleFieldMatcher__Lamf_client_convert_FieldConverter$DoubleFieldMatcher$();
  return new $c_Lamf_client_model_DoubleField().init___Lamf_core_model_DoubleField(from)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.format__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
  var from = $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__format__Lamf_core_model_StrField(this$1);
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$js$exported$meth$withExclusiveMinimum__Z__O = (function(min) {
  return this.withExclusiveMinimum__Z__Lamf_client_model_domain_ScalarShape(min)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.withMinLength__I__Lamf_client_model_domain_ScalarShape = (function(min) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().MinLength$1;
  $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__I__Lamf_core_model_domain_AmfObject(this$1, field, min));
  return this
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$js$exported$prop$minLength__O = (function() {
  return this.minLength__Lamf_client_model_IntField()
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$js$exported$prop$exclusiveMaximum__O = (function() {
  return this.exclusiveMaximum__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$js$exported$meth$withMinLength__I__O = (function(min) {
  return this.withMinLength__I__Lamf_client_model_domain_ScalarShape(min)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.linkCopy__Lamf_client_model_domain_AnyShape = (function() {
  return this.linkCopy__Lamf_client_model_domain_ScalarShape()
});
$c_Lamf_client_model_domain_ScalarShape.prototype.withDataType__T__Lamf_client_model_domain_ScalarShape = (function(dataType) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1;
  $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, dataType));
  return this
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$js$exported$prop$format__O = (function() {
  return this.format__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$js$exported$meth$withMaxLength__I__O = (function(max) {
  return this.withMaxLength__I__Lamf_client_model_domain_ScalarShape(max)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$js$exported$meth$withExclusiveMaximum__Z__O = (function(max) {
  return this.withExclusiveMaximum__Z__Lamf_client_model_domain_ScalarShape(max)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$js$exported$prop$minimum__O = (function() {
  return this.minimum__Lamf_client_model_DoubleField()
});
$c_Lamf_client_model_domain_ScalarShape.prototype.linkCopy__Lamf_client_model_domain_ScalarShape = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$5 = new $c_Lamf_plugins_domain_shapes_models_ScalarShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ScalarShapeMatcher__Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_ScalarShape__Lamf_client_model_domain_ScalarShape(from)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$$js$exported$meth$withMultipleOf__D__O = (function(multiple) {
  return this.withMultipleOf__D__Lamf_client_model_domain_ScalarShape(multiple)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.minLength__Lamf_client_model_IntField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(this.$$undinternal$1);
  var from = $f_Lamf_plugins_domain_shapes_models_CommonShapeFields__minLength__Lamf_core_model_IntField(this$1);
  $m_Lamf_client_convert_WebApiClientConverters$().IntFieldMatcher__Lamf_client_convert_FieldConverter$IntFieldMatcher$();
  return new $c_Lamf_client_model_IntField().init___Lamf_core_model_IntField(from)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.withMultipleOf = (function(arg) {
  var prep = $uD(arg);
  return this.$$js$exported$meth$withMultipleOf__D__O(prep)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.withFormat = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withFormat__T__O(prep)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.withExclusiveMaximum = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withExclusiveMaximum__Z__O(prep)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.withExclusiveMinimum = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withExclusiveMinimum__Z__O(prep)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.withMaximum = (function(arg) {
  var prep = $uD(arg);
  return this.$$js$exported$meth$withMaximum__D__O(prep)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.withMinimum = (function(arg) {
  var prep = $uD(arg);
  return this.$$js$exported$meth$withMinimum__D__O(prep)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.withMaxLength = (function(arg) {
  var prep = $uI(arg);
  return this.$$js$exported$meth$withMaxLength__I__O(prep)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.withMinLength = (function(arg) {
  var prep = $uI(arg);
  return this.$$js$exported$meth$withMinLength__I__O(prep)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.withPattern = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withPattern__T__O(prep)
});
$c_Lamf_client_model_domain_ScalarShape.prototype.withDataType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withDataType__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ScalarShape.prototype, "multipleOf", {
  "get": (function() {
    return this.$$js$exported$prop$multipleOf__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ScalarShape.prototype, "format", {
  "get": (function() {
    return this.$$js$exported$prop$format__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ScalarShape.prototype, "exclusiveMaximum", {
  "get": (function() {
    return this.$$js$exported$prop$exclusiveMaximum__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ScalarShape.prototype, "exclusiveMinimum", {
  "get": (function() {
    return this.$$js$exported$prop$exclusiveMinimum__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ScalarShape.prototype, "maximum", {
  "get": (function() {
    return this.$$js$exported$prop$maximum__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ScalarShape.prototype, "minimum", {
  "get": (function() {
    return this.$$js$exported$prop$minimum__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ScalarShape.prototype, "maxLength", {
  "get": (function() {
    return this.$$js$exported$prop$maxLength__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ScalarShape.prototype, "minLength", {
  "get": (function() {
    return this.$$js$exported$prop$minLength__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ScalarShape.prototype, "pattern", {
  "get": (function() {
    return this.$$js$exported$prop$pattern__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ScalarShape.prototype, "dataType", {
  "get": (function() {
    return this.$$js$exported$prop$dataType__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_ScalarShape(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_ScalarShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.ScalarShape"))
}
function $isArrayOf_Lamf_client_model_domain_ScalarShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_ScalarShape)))
}
function $asArrayOf_Lamf_client_model_domain_ScalarShape(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_ScalarShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.ScalarShape;", depth))
}
var $d_Lamf_client_model_domain_ScalarShape = new $TypeData().initClass({
  Lamf_client_model_domain_ScalarShape: 0
}, false, "amf.client.model.domain.ScalarShape", {
  Lamf_client_model_domain_ScalarShape: 1,
  Lamf_client_model_domain_AnyShape: 1,
  O: 1,
  Lamf_client_model_domain_Shape: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_ScalarShape.prototype.$classData = $d_Lamf_client_model_domain_ScalarShape;
/** @constructor */
function $c_Lamf_client_model_domain_SchemaShape() {
  $c_Lamf_client_model_domain_AnyShape.call(this)
}
$c_Lamf_client_model_domain_SchemaShape.prototype = new $h_Lamf_client_model_domain_AnyShape();
$c_Lamf_client_model_domain_SchemaShape.prototype.constructor = $c_Lamf_client_model_domain_SchemaShape;
/** @constructor */
function $h_Lamf_client_model_domain_SchemaShape() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_SchemaShape.prototype = $c_Lamf_client_model_domain_SchemaShape.prototype;
$c_Lamf_client_model_domain_SchemaShape.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_SchemaShape.prototype.init___Lamf_plugins_domain_shapes_models_SchemaShape.call(this, new $c_Lamf_plugins_domain_shapes_models_SchemaShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_SchemaShape.prototype.productPrefix__T = (function() {
  return "SchemaShape"
});
$c_Lamf_client_model_domain_SchemaShape.prototype.$$undinternal__Lamf_core_model_domain_Shape = (function() {
  return $as_Lamf_plugins_domain_shapes_models_SchemaShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_SchemaShape.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_SchemaShape.prototype.$$js$exported$meth$withRaw__T__O = (function(text) {
  return this.withRaw__T__Lamf_client_model_domain_SchemaShape(text)
});
$c_Lamf_client_model_domain_SchemaShape.prototype.mediaType__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_SchemaShape(this.$$undinternal$1);
  var from = $as_Lamf_core_model_StrField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$().MediaType$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_SchemaShape.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_domain_shapes_models_SchemaShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_SchemaShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_SchemaShape)) {
    var SchemaShape$1 = $as_Lamf_client_model_domain_SchemaShape(x$1);
    var x = $as_Lamf_plugins_domain_shapes_models_SchemaShape(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_domain_shapes_models_SchemaShape(SchemaShape$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_SchemaShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_domain_shapes_models_SchemaShape(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_SchemaShape.prototype.$$js$exported$prop$location__O = (function() {
  return this.location__sjs_js_UndefOr()
});
$c_Lamf_client_model_domain_SchemaShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_SchemaShape.prototype.raw__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_SchemaShape(this.$$undinternal$1);
  var from = $as_Lamf_core_model_StrField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().Raw$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_SchemaShape.prototype.linkCopy__Lamf_client_model_domain_SchemaShape = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_SchemaShape(this.$$undinternal$1);
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$5 = new $c_Lamf_plugins_domain_shapes_models_SchemaShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_shapes_models_SchemaShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().SchemaShapeMatcher__Lamf_client_convert_SchemaShapeConverter$SchemaShapeMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_SchemaShape__Lamf_client_model_domain_SchemaShape(from)
});
$c_Lamf_client_model_domain_SchemaShape.prototype.withMediatype__T__Lamf_client_model_domain_SchemaShape = (function(mediaType) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_SchemaShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$().MediaType$1;
  $as_Lamf_plugins_domain_shapes_models_SchemaShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, mediaType));
  return this
});
$c_Lamf_client_model_domain_SchemaShape.prototype.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return $as_Lamf_plugins_domain_shapes_models_SchemaShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_SchemaShape.prototype.withRaw__T__Lamf_client_model_domain_SchemaShape = (function(text) {
  var this$1 = $as_Lamf_plugins_domain_shapes_models_SchemaShape(this.$$undinternal$1);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$().Raw$1;
  $as_Lamf_plugins_domain_shapes_models_SchemaShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, text));
  return this
});
$c_Lamf_client_model_domain_SchemaShape.prototype.$$js$exported$prop$raw__O = (function() {
  return this.raw__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_SchemaShape.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_SchemaShape()
});
$c_Lamf_client_model_domain_SchemaShape.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_SchemaShape()
});
$c_Lamf_client_model_domain_SchemaShape.prototype.$$js$exported$prop$mediaType__O = (function() {
  return this.mediaType__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_SchemaShape.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_domain_shapes_models_SchemaShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_SchemaShape.prototype.$$js$exported$meth$withMediatype__T__O = (function(mediaType) {
  return this.withMediatype__T__Lamf_client_model_domain_SchemaShape(mediaType)
});
$c_Lamf_client_model_domain_SchemaShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_SchemaShape.prototype.location__sjs_js_UndefOr = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_SchemaShape(this.$$undinternal$1);
  var from = $f_Lamf_core_model_domain_ExternalSourceElement__location__s_Option(this$1);
  var m = $m_Lamf_client_convert_WebApiClientConverters$().StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalOptionOps().init___Lamf_client_convert_CollectionConverter__s_Option__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_SchemaShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_SchemaShape.prototype.linkCopy__Lamf_client_model_domain_AnyShape = (function() {
  return this.linkCopy__Lamf_client_model_domain_SchemaShape()
});
$c_Lamf_client_model_domain_SchemaShape.prototype.init___Lamf_plugins_domain_shapes_models_SchemaShape = (function(_internal) {
  $c_Lamf_client_model_domain_AnyShape.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape.call(this, _internal);
  return this
});
$c_Lamf_client_model_domain_SchemaShape.prototype.withRaw = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withRaw__T__O(prep)
});
$c_Lamf_client_model_domain_SchemaShape.prototype.withMediatype = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withMediatype__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_SchemaShape.prototype, "location", {
  "get": (function() {
    return this.$$js$exported$prop$location__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_SchemaShape.prototype, "raw", {
  "get": (function() {
    return this.$$js$exported$prop$raw__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_SchemaShape.prototype, "mediaType", {
  "get": (function() {
    return this.$$js$exported$prop$mediaType__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_SchemaShape(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_SchemaShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.SchemaShape"))
}
function $isArrayOf_Lamf_client_model_domain_SchemaShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_SchemaShape)))
}
function $asArrayOf_Lamf_client_model_domain_SchemaShape(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_SchemaShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.SchemaShape;", depth))
}
var $d_Lamf_client_model_domain_SchemaShape = new $TypeData().initClass({
  Lamf_client_model_domain_SchemaShape: 0
}, false, "amf.client.model.domain.SchemaShape", {
  Lamf_client_model_domain_SchemaShape: 1,
  Lamf_client_model_domain_AnyShape: 1,
  O: 1,
  Lamf_client_model_domain_Shape: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_SchemaShape.prototype.$classData = $d_Lamf_client_model_domain_SchemaShape;
/** @constructor */
function $c_Lamf_client_model_domain_UnionShape() {
  $c_Lamf_client_model_domain_AnyShape.call(this)
}
$c_Lamf_client_model_domain_UnionShape.prototype = new $h_Lamf_client_model_domain_AnyShape();
$c_Lamf_client_model_domain_UnionShape.prototype.constructor = $c_Lamf_client_model_domain_UnionShape;
/** @constructor */
function $h_Lamf_client_model_domain_UnionShape() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_UnionShape.prototype = $c_Lamf_client_model_domain_UnionShape.prototype;
$c_Lamf_client_model_domain_UnionShape.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_UnionShape.prototype.init___Lamf_plugins_domain_shapes_models_UnionShape.call(this, new $c_Lamf_plugins_domain_shapes_models_UnionShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_UnionShape.prototype.productPrefix__T = (function() {
  return "UnionShape"
});
$c_Lamf_client_model_domain_UnionShape.prototype.$$undinternal__Lamf_core_model_domain_Shape = (function() {
  return $as_Lamf_plugins_domain_shapes_models_UnionShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_UnionShape.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_UnionShape.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_plugins_domain_shapes_models_UnionShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_UnionShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_UnionShape)) {
    var UnionShape$1 = $as_Lamf_client_model_domain_UnionShape(x$1);
    var x = $as_Lamf_plugins_domain_shapes_models_UnionShape(this.$$undinternal$1);
    var x$2 = $as_Lamf_plugins_domain_shapes_models_UnionShape(UnionShape$1.$$undinternal$1);
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_UnionShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return $as_Lamf_plugins_domain_shapes_models_UnionShape(this.$$undinternal$1);
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_UnionShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_UnionShape.prototype.init___Lamf_plugins_domain_shapes_models_UnionShape = (function(_internal) {
  $c_Lamf_client_model_domain_AnyShape.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape.call(this, _internal);
  return this
});
$c_Lamf_client_model_domain_UnionShape.prototype.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return $as_Lamf_plugins_domain_shapes_models_UnionShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_UnionShape.prototype.anyOf__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = $as_Lamf_plugins_domain_shapes_models_UnionShape(this.$$undinternal$1);
  var from = $as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_UnionShape.prototype.$$js$exported$meth$withAnyOf__sjs_js_Array__O = (function(anyOf) {
  return this.withAnyOf__sjs_js_Array__Lamf_client_model_domain_UnionShape(anyOf)
});
$c_Lamf_client_model_domain_UnionShape.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return $as_Lamf_plugins_domain_shapes_models_UnionShape(this.$$undinternal$1)
});
$c_Lamf_client_model_domain_UnionShape.prototype.$$js$exported$prop$anyOf__O = (function() {
  return this.anyOf__sjs_js_Array()
});
$c_Lamf_client_model_domain_UnionShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_UnionShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_UnionShape.prototype.withAnyOf__sjs_js_Array__Lamf_client_model_domain_UnionShape = (function(anyOf) {
  var this$2 = $as_Lamf_plugins_domain_shapes_models_UnionShape(this.$$undinternal$1);
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var elements = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, anyOf, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().AnyOf$1;
  $as_Lamf_plugins_domain_shapes_models_UnionShape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, elements));
  return this
});
$c_Lamf_client_model_domain_UnionShape.prototype.withAnyOf = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withAnyOf__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_UnionShape.prototype, "anyOf", {
  "get": (function() {
    return this.$$js$exported$prop$anyOf__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_UnionShape(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_UnionShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.UnionShape"))
}
function $isArrayOf_Lamf_client_model_domain_UnionShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_UnionShape)))
}
function $asArrayOf_Lamf_client_model_domain_UnionShape(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_UnionShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.UnionShape;", depth))
}
var $d_Lamf_client_model_domain_UnionShape = new $TypeData().initClass({
  Lamf_client_model_domain_UnionShape: 0
}, false, "amf.client.model.domain.UnionShape", {
  Lamf_client_model_domain_UnionShape: 1,
  Lamf_client_model_domain_AnyShape: 1,
  O: 1,
  Lamf_client_model_domain_Shape: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_UnionShape.prototype.$classData = $d_Lamf_client_model_domain_UnionShape;
/** @constructor */
function $c_Lamf_client_parse_IgnoringErrorHandler() {
  $c_Lamf_client_parse_DefaultParserErrorHandler.call(this)
}
$c_Lamf_client_parse_IgnoringErrorHandler.prototype = new $h_Lamf_client_parse_DefaultParserErrorHandler();
$c_Lamf_client_parse_IgnoringErrorHandler.prototype.constructor = $c_Lamf_client_parse_IgnoringErrorHandler;
/** @constructor */
function $h_Lamf_client_parse_IgnoringErrorHandler() {
  /*<skip>*/
}
$h_Lamf_client_parse_IgnoringErrorHandler.prototype = $c_Lamf_client_parse_IgnoringErrorHandler.prototype;
$c_Lamf_client_parse_IgnoringErrorHandler.prototype.handle__Lorg_mulesoft_lexer_SourceLocation__Lorg_yaml_model_SyamlException__V = (function(loc, e) {
  /*<skip>*/
});
$c_Lamf_client_parse_IgnoringErrorHandler.prototype.productPrefix__T = (function() {
  return "IgnoringErrorHandler"
});
$c_Lamf_client_parse_IgnoringErrorHandler.prototype.init___ = (function() {
  $c_Lamf_client_parse_DefaultParserErrorHandler.prototype.init___I.call(this, $m_Lamf_core_AMFCompilerRunCount$().nextRun__I());
  return this
});
$c_Lamf_client_parse_IgnoringErrorHandler.prototype.productArity__I = (function() {
  return 0
});
$c_Lamf_client_parse_IgnoringErrorHandler.prototype.equals__O__Z = (function(x$1) {
  return ((x$1 instanceof $c_Lamf_client_parse_IgnoringErrorHandler) && ($as_Lamf_client_parse_IgnoringErrorHandler(x$1), true))
});
$c_Lamf_client_parse_IgnoringErrorHandler.prototype.handle__Lorg_yaml_model_YError__O__O = (function(error, defaultValue) {
  return defaultValue
});
$c_Lamf_client_parse_IgnoringErrorHandler.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_Lamf_client_parse_IgnoringErrorHandler.prototype.warning__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__s_Option__s_Option__V = (function(id, node, property, message, lexical, location) {
  /*<skip>*/
});
$c_Lamf_client_parse_IgnoringErrorHandler.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_parse_IgnoringErrorHandler.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_parse_IgnoringErrorHandler.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_client_parse_IgnoringErrorHandler(obj) {
  return (((obj instanceof $c_Lamf_client_parse_IgnoringErrorHandler) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.parse.IgnoringErrorHandler"))
}
function $isArrayOf_Lamf_client_parse_IgnoringErrorHandler(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_parse_IgnoringErrorHandler)))
}
function $asArrayOf_Lamf_client_parse_IgnoringErrorHandler(obj, depth) {
  return (($isArrayOf_Lamf_client_parse_IgnoringErrorHandler(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.parse.IgnoringErrorHandler;", depth))
}
var $d_Lamf_client_parse_IgnoringErrorHandler = new $TypeData().initClass({
  Lamf_client_parse_IgnoringErrorHandler: 0
}, false, "amf.client.parse.IgnoringErrorHandler", {
  Lamf_client_parse_IgnoringErrorHandler: 1,
  Lamf_client_parse_DefaultParserErrorHandler: 1,
  O: 1,
  Lamf_core_errorhandling_ErrorCollector: 1,
  Lamf_core_errorhandling_AmfResultErrorHandler: 1,
  Lamf_core_errorhandling_ErrorHandler: 1,
  Lamf_core_parser_errorhandler_AmfParserErrorHandler: 1,
  Lamf_core_parser_errorhandler_ParserErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  Lorg_yaml_model_ParseErrorHandler: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_parse_IgnoringErrorHandler.prototype.$classData = $d_Lamf_client_parse_IgnoringErrorHandler;
/** @constructor */
function $c_Lamf_core_model_document_ExtensionLike() {
  $c_Lamf_core_model_document_Document.call(this)
}
$c_Lamf_core_model_document_ExtensionLike.prototype = new $h_Lamf_core_model_document_Document();
$c_Lamf_core_model_document_ExtensionLike.prototype.constructor = $c_Lamf_core_model_document_ExtensionLike;
/** @constructor */
function $h_Lamf_core_model_document_ExtensionLike() {
  /*<skip>*/
}
$h_Lamf_core_model_document_ExtensionLike.prototype = $c_Lamf_core_model_document_ExtensionLike.prototype;
$c_Lamf_core_model_document_ExtensionLike.prototype.encodes__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_core_model_domain_DomainElement(this.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().Encodes$1))
});
function $as_Lamf_core_model_document_ExtensionLike(obj) {
  return (((obj instanceof $c_Lamf_core_model_document_ExtensionLike) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.core.model.document.ExtensionLike"))
}
function $isArrayOf_Lamf_core_model_document_ExtensionLike(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_core_model_document_ExtensionLike)))
}
function $asArrayOf_Lamf_core_model_document_ExtensionLike(obj, depth) {
  return (($isArrayOf_Lamf_core_model_document_ExtensionLike(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.core.model.document.ExtensionLike;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.amf$core$model$document$BaseUnit$$run$1 = null;
  this.raw$1 = null;
  this.platform$1 = null;
  this.id$1 = null
}
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_document_DialectLibrary() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype = $c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype;
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.productPrefix__T = (function() {
  return "DialectLibrary"
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary)) {
    var DialectLibrary$1 = $as_Lamf_plugins_document_vocabularies_model_document_DialectLibrary(x$1);
    var x = this.fields$1;
    var x$2 = DialectLibrary$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = DialectLibrary$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.raw$und$eq__s_Option__V = (function(x$1) {
  this.raw$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectLibraryModel$()
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.references__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().References$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit = (function(selector, transformation, errorHandler) {
  return $f_Lamf_core_model_document_BaseUnit__transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(this, selector, transformation, errorHandler)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.amf$core$model$document$BaseUnit$$run__s_Option = (function() {
  return this.amf$core$model$document$BaseUnit$$run$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.declares__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Declares$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V = (function(x$1) {
  this.amf$core$model$document$BaseUnit$$run$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.raw__s_Option = (function() {
  return this.raw$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  $f_Lamf_core_model_document_BaseUnit__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_document_vocabularies_model_document_DialectLibrary(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.document.DialectLibrary"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_document_DialectLibrary(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_document_DialectLibrary)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_document_DialectLibrary(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_document_DialectLibrary(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.document.DialectLibrary;", depth))
}
var $d_Lamf_plugins_document_vocabularies_model_document_DialectLibrary = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_document_DialectLibrary: 0
}, false, "amf.plugins.document.vocabularies.model.document.DialectLibrary", {
  Lamf_plugins_document_vocabularies_model_document_DialectLibrary: 1,
  O: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_vocabularies_model_document_ExternalContext: 1,
  Lamf_core_model_document_DeclaresModel: 1,
  Lamf_plugins_document_vocabularies_model_document_MappingDeclarer: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectLibrary.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_document_DialectLibrary;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext() {
  $c_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext.call(this);
  this.wrapped$5 = null;
  this.ds$5 = null;
  this.operationIds$5 = null;
  this.factory$5 = null;
  this.vendor$5 = null;
  this.syntax$5 = null
}
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext();
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext.prototype.makeCopy__Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext = (function() {
  return new $c_Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__scm_Set__Lamf_core_client_ParsingOptions(this.rootContextDocument$1, this.refs$1, this, new $c_s_Some().init___O(this.declarations$4), this.operationIds$5, this.options$2)
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext.prototype.factory__Lamf_plugins_document_webapi_contexts_parser_OasLikeSpecVersionFactory = (function() {
  return this.factory$5
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext.prototype.vendor__Lamf_core_remote_Vendor = (function() {
  return this.vendor$5
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext.prototype.syntax__Lamf_plugins_document_webapi_parser_spec_SpecSyntax = (function() {
  return this.syntax$5
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext.prototype.init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__scm_Set__Lamf_core_client_ParsingOptions = (function(loc, refs, wrapped, ds, operationIds, options) {
  this.wrapped$5 = wrapped;
  this.ds$5 = ds;
  this.operationIds$5 = operationIds;
  $c_Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext.prototype.init___T__sc_Seq__Lamf_core_client_ParsingOptions__Lamf_core_parser_ParserContext__s_Option__scm_Set.call(this, loc, refs, options, wrapped, ds, operationIds);
  this.factory$5 = new $c_Lamf_plugins_document_webapi_contexts_parser_async_Async20VersionFactory().init___Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext(this);
  this.vendor$5 = $m_Lamf_core_remote_AsyncApi20$();
  this.syntax$5 = $m_Lamf_plugins_document_webapi_parser_spec_async_Async20Syntax$();
  return this
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext.prototype.makeCopy__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function() {
  return this.makeCopy__Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext()
});
var $d_Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext: 0
}, false, "amf.plugins.document.webapi.contexts.parser.async.Async20WebApiContext", {
  Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_parser_async_AsyncWebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_WebApiContext: 1,
  Lamf_core_parser_ParserContext: 1,
  O: 1,
  Lorg_yaml_model_ParseErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_plugins_document_webapi_contexts_SpecAwareContext: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_parser_async_Async20WebApiContext;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext() {
  $c_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext.call(this);
  this.wrapped$5 = null;
  this.ds$5 = null;
  this.factory$5 = null;
  this.syntax$5 = null;
  this.vendor$5 = null;
  this.linkTypes$5 = false
}
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext.prototype.makeCopy__Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext = (function() {
  return new $c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__Lamf_core_client_ParsingOptions(this.rootContextDocument$1, this.refs$1, this, new $c_s_Some().init___O(this.declarations$4), this.options$2)
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext.prototype.factory__Lamf_plugins_document_webapi_contexts_parser_OasLikeSpecVersionFactory = (function() {
  return this.factory$5
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext.prototype.vendor__Lamf_core_remote_Vendor = (function() {
  return this.vendor$5
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext.prototype.factory__Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory = (function() {
  return this.factory$5
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext.prototype.syntax__Lamf_plugins_document_webapi_parser_spec_SpecSyntax = (function() {
  return this.syntax$5
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext.prototype.init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__Lamf_core_client_ParsingOptions = (function(loc, refs, wrapped, ds, options) {
  this.wrapped$5 = wrapped;
  this.ds$5 = ds;
  $c_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext.prototype.init___T__sc_Seq__Lamf_core_client_ParsingOptions__Lamf_core_parser_ParserContext__s_Option__scm_Set.call(this, loc, refs, options, wrapped, ds, $as_scm_Set($m_scm_HashSet$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
  this.factory$5 = new $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory().init___Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this);
  this.syntax$5 = $m_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$();
  this.vendor$5 = $m_Lamf_core_remote_JsonSchema$();
  this.linkTypes$5 = ((!(wrapped instanceof $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext)) && (wrapped instanceof $c_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext));
  return this
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext.prototype.linkTypes__Z = (function() {
  return this.linkTypes$5
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext.prototype.makeCopy__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function() {
  return this.makeCopy__Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext()
});
var $d_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext: 0
}, false, "amf.plugins.document.webapi.contexts.parser.oas.JsonSchemaWebApiContext", {
  Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_WebApiContext: 1,
  Lamf_core_parser_ParserContext: 1,
  O: 1,
  Lorg_yaml_model_ParseErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_plugins_document_webapi_contexts_SpecAwareContext: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_parser_oas_JsonSchemaWebApiContext;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext() {
  $c_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext.call(this);
  this.factory$5 = null;
  this.vendor$5 = null;
  this.syntax$5 = null
}
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext.prototype.makeCopy__Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext = (function() {
  return new $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__Lamf_core_client_ParsingOptions(this.rootContextDocument$1, this.refs$1, this, new $c_s_Some().init___O(this.declarations$4), this.options$2)
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext.prototype.factory__Lamf_plugins_document_webapi_contexts_parser_OasLikeSpecVersionFactory = (function() {
  return this.factory$5
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext.prototype.factory__Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory = (function() {
  return this.factory$5
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext.prototype.vendor__Lamf_core_remote_Vendor = (function() {
  return this.vendor$5
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext.prototype.syntax__Lamf_plugins_document_webapi_parser_spec_SpecSyntax = (function() {
  return this.syntax$5
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext.prototype.init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__Lamf_core_client_ParsingOptions = (function(loc, refs, wrapped, ds, options) {
  $c_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext.prototype.init___T__sc_Seq__Lamf_core_client_ParsingOptions__Lamf_core_parser_ParserContext__s_Option__scm_Set.call(this, loc, refs, options, wrapped, ds, $as_scm_Set($m_scm_HashSet$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
  this.factory$5 = new $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2VersionFactory().init___Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this);
  this.vendor$5 = $m_Lamf_core_remote_Oas20$();
  this.syntax$5 = $m_Lamf_plugins_document_webapi_parser_spec_oas_Oas2Syntax$();
  return this
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext.prototype.makeCopy__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function() {
  return this.makeCopy__Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext()
});
function $as_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.parser.oas.Oas2WebApiContext"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.parser.oas.Oas2WebApiContext;", depth))
}
var $d_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext: 0
}, false, "amf.plugins.document.webapi.contexts.parser.oas.Oas2WebApiContext", {
  Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_WebApiContext: 1,
  Lamf_core_parser_ParserContext: 1,
  O: 1,
  Lorg_yaml_model_ParseErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_plugins_document_webapi_contexts_SpecAwareContext: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_parser_oas_Oas2WebApiContext;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext() {
  $c_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext.call(this);
  this.wrapped$5 = null;
  this.ds$5 = null;
  this.factory$5 = null;
  this.vendor$5 = null;
  this.syntax$5 = null
}
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext();
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext.prototype.factory__Lamf_plugins_document_webapi_contexts_parser_OasLikeSpecVersionFactory = (function() {
  return this.factory$5
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext.prototype.factory__Lamf_plugins_document_webapi_contexts_parser_oas_OasSpecVersionFactory = (function() {
  return this.factory$5
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext.prototype.vendor__Lamf_core_remote_Vendor = (function() {
  return this.vendor$5
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext.prototype.syntax__Lamf_plugins_document_webapi_parser_spec_SpecSyntax = (function() {
  return this.syntax$5
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext.prototype.init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__Lamf_core_client_ParsingOptions = (function(loc, refs, wrapped, ds, options) {
  this.wrapped$5 = wrapped;
  this.ds$5 = ds;
  $c_Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext.prototype.init___T__sc_Seq__Lamf_core_client_ParsingOptions__Lamf_core_parser_ParserContext__s_Option__scm_Set.call(this, loc, refs, options, wrapped, ds, $as_scm_Set($m_scm_HashSet$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
  this.factory$5 = new $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3VersionFactory().init___Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext(this);
  this.vendor$5 = $m_Lamf_core_remote_Oas30$();
  this.syntax$5 = $m_Lamf_plugins_document_webapi_parser_spec_oas_Oas3Syntax$();
  return this
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext.prototype.makeCopy__Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext = (function() {
  return this.makeCopy__Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext()
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext.prototype.makeCopy__Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext = (function() {
  return new $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__Lamf_core_client_ParsingOptions(this.rootContextDocument$1, this.refs$1, this, new $c_s_Some().init___O(this.declarations$4), this.options$2)
});
function $as_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.parser.oas.Oas3WebApiContext"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.parser.oas.Oas3WebApiContext;", depth))
}
var $d_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext: 0
}, false, "amf.plugins.document.webapi.contexts.parser.oas.Oas3WebApiContext", {
  Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_parser_oas_OasWebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_parser_OasLikeWebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_WebApiContext: 1,
  Lamf_core_parser_ParserContext: 1,
  O: 1,
  Lorg_yaml_model_ParseErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_plugins_document_webapi_contexts_SpecAwareContext: 1,
  Lamf_core_unsafe_PlatformSecrets: 1
});
$c_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_parser_oas_Oas3WebApiContext;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext() {
  $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this);
  this.ds$4 = null;
  this.factory$4 = null;
  this.syntax$4 = null;
  this.vendor$4 = null
}
$c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
$c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext.prototype.vendor__Lamf_core_remote_Vendor = (function() {
  return this.vendor$4
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext.prototype.init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions = (function(loc, refs, wrapped, ds, contextType, options) {
  this.ds$4 = ds;
  $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype.init___T__sc_Seq__Lamf_core_client_ParsingOptions__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value.call(this, loc, refs, options, wrapped, ds, contextType);
  this.factory$4 = new $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory().init___Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this);
  this.syntax$4 = new $c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext$$anon$1().init___Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext(this);
  this.vendor$4 = $m_Lamf_core_remote_Payload$();
  return this
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext.prototype.syntax__Lamf_plugins_document_webapi_parser_spec_SpecSyntax = (function() {
  return this.syntax$4
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext.prototype.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory = (function() {
  return this.factory$4
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext.prototype.clone__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(declarations) {
  var x$1 = this.rootContextDocument$1;
  var x$2 = this.refs$1;
  var x$3 = this.wrapped$3;
  var x$4 = new $c_s_Some().init___O(declarations);
  var x$5 = this.options$2;
  var x$6 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2;
  return new $c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions(x$1, x$2, x$3, x$4, x$6, x$5)
});
var $d_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext: 0
}, false, "amf.plugins.document.webapi.contexts.parser.raml.PayloadContext", {
  Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext: 1,
  Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_WebApiContext: 1,
  Lamf_core_parser_ParserContext: 1,
  O: 1,
  Lorg_yaml_model_ParseErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_plugins_document_webapi_contexts_SpecAwareContext: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecAwareContext: 1
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_parser_raml_PayloadContext;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext() {
  $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this);
  this.ds$4 = null;
  this.factory$4 = null;
  this.vendor$4 = null;
  this.syntax$4 = null
}
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext.prototype.supportsAnnotations__Z = (function() {
  return false
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext.prototype.vendor__Lamf_core_remote_Vendor = (function() {
  return this.vendor$4
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext.prototype.init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions = (function(loc, refs, wrapped, ds, contextType, options) {
  this.ds$4 = ds;
  $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype.init___T__sc_Seq__Lamf_core_client_ParsingOptions__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value.call(this, loc, refs, options, wrapped, ds, contextType);
  this.factory$4 = new $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08VersionFactory().init___Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this);
  this.vendor$4 = $m_Lamf_core_remote_Raml08$();
  this.syntax$4 = $m_Lamf_plugins_document_webapi_parser_spec_raml_Raml08Syntax$();
  return this
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext.prototype.syntax__Lamf_plugins_document_webapi_parser_spec_SpecSyntax = (function() {
  return this.syntax$4
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext.prototype.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory = (function() {
  return this.factory$4
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext.prototype.clone__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(declarations) {
  var x$1 = this.rootContextDocument$1;
  var x$2 = this.refs$1;
  var x$3 = this.wrapped$3;
  var x$4 = new $c_s_Some().init___O(declarations);
  var x$5 = this.options$2;
  var x$6 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2;
  return new $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions(x$1, x$2, x$3, x$4, x$6, x$5)
});
function $as_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.parser.raml.Raml08WebApiContext"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.parser.raml.Raml08WebApiContext;", depth))
}
var $d_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext: 0
}, false, "amf.plugins.document.webapi.contexts.parser.raml.Raml08WebApiContext", {
  Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_WebApiContext: 1,
  Lamf_core_parser_ParserContext: 1,
  O: 1,
  Lorg_yaml_model_ParseErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_plugins_document_webapi_contexts_SpecAwareContext: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecAwareContext: 1
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext() {
  $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this);
  this.ds$4 = null;
  this.factory$4 = null;
  this.vendor$4 = null;
  this.syntax$4 = null
}
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext();
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext.prototype.wrapped__Lamf_core_parser_ParserContext = (function() {
  return this.wrapped$3
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext.prototype.vendor__Lamf_core_remote_Vendor = (function() {
  return this.vendor$4
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext.prototype.init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions = (function(loc, refs, wrapped, ds, contextType, options) {
  this.ds$4 = ds;
  $c_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.prototype.init___T__sc_Seq__Lamf_core_client_ParsingOptions__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value.call(this, loc, refs, options, wrapped, ds, contextType);
  this.factory$4 = new $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10VersionFactory().init___Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext(this);
  this.vendor$4 = $m_Lamf_core_remote_Raml10$();
  this.syntax$4 = $m_Lamf_plugins_document_webapi_parser_spec_raml_Raml10Syntax$();
  return this
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext.prototype.syntax__Lamf_plugins_document_webapi_parser_spec_SpecSyntax = (function() {
  return this.syntax$4
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext.prototype.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory = (function() {
  return this.factory$4
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext.prototype.clone__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(declarations) {
  var x$1 = this.rootContextDocument$1;
  var x$2 = this.refs$1;
  var x$3 = this.wrapped__Lamf_core_parser_ParserContext();
  var x$4 = new $c_s_Some().init___O(declarations);
  var x$5 = this.options$2;
  var x$6 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2;
  return new $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions(x$1, x$2, x$3, x$4, x$6, x$5)
});
var $d_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext: 0
}, false, "amf.plugins.document.webapi.contexts.parser.raml.Raml10WebApiContext", {
  Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_WebApiContext: 1,
  Lamf_core_parser_ParserContext: 1,
  O: 1,
  Lorg_yaml_model_ParseErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_plugins_document_webapi_contexts_SpecAwareContext: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecAwareContext: 1
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint() {
  $c_Lamf_plugins_domain_webapi_models_EndPoint.call(this);
  this.idPart$2 = null;
  this.ast$2 = null;
  this.namespace$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint.prototype = new $h_Lamf_plugins_domain_webapi_models_EndPoint();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint.prototype.productPrefix__T = (function() {
  return "ErrorEndPoint"
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint.prototype.namespace__T = (function() {
  return this.namespace$2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint.prototype.originalMeta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_EndPointModel$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint.prototype.newErrorInstance__Lamf_core_annotations_ErrorDeclaration = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint().init___T__Lorg_yaml_model_YPart(this.idPart$2, this.ast$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint)) {
    var ErrorEndPoint$1 = $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint(x$1);
    if ((this.idPart$2 === ErrorEndPoint$1.idPart$2)) {
      var x = this.ast$2;
      var x$2 = ErrorEndPoint$1.ast$2;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.idPart$2;
      break
    }
    case 1: {
      return this.ast$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return new $c_Lamf_core_annotations_ErrorDeclaration$$anon$1().init___Lamf_core_annotations_ErrorDeclaration(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint.prototype.init___T__Lorg_yaml_model_YPart = (function(idPart, ast) {
  this.idPart$2 = idPart;
  this.ast$2 = ast;
  $c_Lamf_plugins_domain_webapi_models_EndPoint.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, new $c_Lamf_core_parser_Fields().init___(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast));
  this.namespace$2 = "http://amferror.com/#errorEndPoint/";
  $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, idPart);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint.prototype.amf$core$annotations$ErrorDeclaration$$super$withId__T__Lamf_core_annotations_ErrorDeclaration = (function(value) {
  return $as_Lamf_core_annotations_ErrorDeclaration($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorEndPoint"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorEndPoint;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorEndPoint", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint: 1,
  Lamf_plugins_domain_webapi_models_EndPoint: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_plugins_domain_webapi_models_ExtensibleWebApiDomainElement: 1,
  Lamf_plugins_domain_webapi_models_ServerContainer: 1,
  Lamf_core_annotations_ErrorDeclaration: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorEndPoint;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType() {
  $c_Lamf_plugins_domain_webapi_models_templates_ResourceType.call(this);
  this.idPart$3 = null;
  this.ast$3 = null;
  this.namespace$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType.prototype = new $h_Lamf_plugins_domain_webapi_models_templates_ResourceType();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType.prototype.productPrefix__T = (function() {
  return "ErrorResourceType"
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType.prototype.namespace__T = (function() {
  return this.namespace$3
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType.prototype.originalMeta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_templates_ResourceTypeModel$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType.prototype.newErrorInstance__Lamf_core_annotations_ErrorDeclaration = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType().init___T__Lorg_yaml_model_YPart(this.idPart$3, this.ast$3)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType)) {
    var ErrorResourceType$1 = $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType(x$1);
    if ((this.idPart$3 === ErrorResourceType$1.idPart$3)) {
      var x = this.ast$3;
      var x$2 = ErrorResourceType$1.ast$3;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.idPart$3;
      break
    }
    case 1: {
      return this.ast$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return new $c_Lamf_core_annotations_ErrorDeclaration$$anon$1().init___Lamf_core_annotations_ErrorDeclaration(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType.prototype.dataNode__Lamf_core_model_domain_DataNode = (function() {
  $m_Lamf_core_model_domain_ObjectNode$();
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_core_model_domain_ObjectNode().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType.prototype.init___T__Lorg_yaml_model_YPart = (function(idPart, ast) {
  this.idPart$3 = idPart;
  this.ast$3 = ast;
  $c_Lamf_plugins_domain_webapi_models_templates_ResourceType.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, new $c_Lamf_core_parser_Fields().init___(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast));
  this.namespace$3 = "http://amferror.com/#errorResourceType/";
  $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, idPart);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType.prototype.amf$core$annotations$ErrorDeclaration$$super$withId__T__Lamf_core_annotations_ErrorDeclaration = (function(value) {
  return $as_Lamf_core_annotations_ErrorDeclaration($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorResourceType"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorResourceType;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorResourceType", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType: 1,
  Lamf_plugins_domain_webapi_models_templates_ResourceType: 1,
  Lamf_core_model_domain_templates_AbstractDeclaration: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_annotations_ErrorDeclaration: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResourceType;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme() {
  $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.call(this);
  this.idPart$2 = null;
  this.ast$2 = null;
  this.namespace$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme.prototype = new $h_Lamf_plugins_domain_webapi_models_security_SecurityScheme();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme.prototype.productPrefix__T = (function() {
  return "ErrorSecurityScheme"
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme.prototype.namespace__T = (function() {
  return this.namespace$2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme.prototype.originalMeta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_security_SecuritySchemeModel$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme.prototype.newErrorInstance__Lamf_core_annotations_ErrorDeclaration = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme().init___T__Lorg_yaml_model_YPart(this.idPart$2, this.ast$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme)) {
    var ErrorSecurityScheme$1 = $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme(x$1);
    if ((this.idPart$2 === ErrorSecurityScheme$1.idPart$2)) {
      var x = this.ast$2;
      var x$2 = ErrorSecurityScheme$1.ast$2;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.idPart$2;
      break
    }
    case 1: {
      return this.ast$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return new $c_Lamf_core_annotations_ErrorDeclaration$$anon$1().init___Lamf_core_annotations_ErrorDeclaration(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme.prototype.init___T__Lorg_yaml_model_YPart = (function(idPart, ast) {
  this.idPart$2 = idPart;
  this.ast$2 = ast;
  $c_Lamf_plugins_domain_webapi_models_security_SecurityScheme.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, new $c_Lamf_core_parser_Fields().init___(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast));
  this.namespace$2 = "http://amferror.com/#errorSecurityScheme/";
  $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, idPart);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme.prototype.amf$core$annotations$ErrorDeclaration$$super$withId__T__Lamf_core_annotations_ErrorDeclaration = (function(value) {
  return $as_Lamf_core_annotations_ErrorDeclaration($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorSecurityScheme"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorSecurityScheme;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorSecurityScheme", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme: 1,
  Lamf_plugins_domain_webapi_models_security_SecurityScheme: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_plugins_domain_webapi_models_security_WithSettings: 1,
  Lamf_core_annotations_ErrorDeclaration: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorSecurityScheme;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait() {
  $c_Lamf_plugins_domain_webapi_models_templates_Trait.call(this);
  this.idPart$3 = null;
  this.ast$3 = null;
  this.namespace$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait.prototype = new $h_Lamf_plugins_domain_webapi_models_templates_Trait();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait.prototype.productPrefix__T = (function() {
  return "ErrorTrait"
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait.prototype.namespace__T = (function() {
  return this.namespace$3
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait.prototype.originalMeta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_templates_TraitModel$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait.prototype.newErrorInstance__Lamf_core_annotations_ErrorDeclaration = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait().init___T__Lorg_yaml_model_YPart(this.idPart$3, this.ast$3)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait)) {
    var ErrorTrait$1 = $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait(x$1);
    if ((this.idPart$3 === ErrorTrait$1.idPart$3)) {
      var x = this.ast$3;
      var x$2 = ErrorTrait$1.ast$3;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.idPart$3;
      break
    }
    case 1: {
      return this.ast$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return new $c_Lamf_core_annotations_ErrorDeclaration$$anon$1().init___Lamf_core_annotations_ErrorDeclaration(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait.prototype.init___T__Lorg_yaml_model_YPart = (function(idPart, ast) {
  this.idPart$3 = idPart;
  this.ast$3 = ast;
  $c_Lamf_plugins_domain_webapi_models_templates_Trait.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, new $c_Lamf_core_parser_Fields().init___(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast));
  this.namespace$3 = "http://amferror.com/#errorTrait/";
  $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, idPart);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait.prototype.amf$core$annotations$ErrorDeclaration$$super$withId__T__Lamf_core_annotations_ErrorDeclaration = (function(value) {
  return $as_Lamf_core_annotations_ErrorDeclaration($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorTrait"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorTrait;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorTrait", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait: 1,
  Lamf_plugins_domain_webapi_models_templates_Trait: 1,
  Lamf_core_model_domain_templates_AbstractDeclaration: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_annotations_ErrorDeclaration: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorTrait;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser.call(this);
  this.root$4 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser();
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function() {
  return $as_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext(this.ctx$3)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser.prototype.productPrefix__T = (function() {
  return "ExtensionLikeParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser)) {
    var ExtensionLikeParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser(x$1);
    var x = this.root$4;
    var x$2 = ExtensionLikeParser$1.root$4;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.root$4;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext = (function(root, ctx) {
  this.root$4 = root;
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, root, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser.prototype.parseExtension__Lamf_plugins_document_webapi_model_Extension = (function() {
  $as_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext(this.ctx$3).contextType$3 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().EXTENSION$2;
  var x1 = this.getParent__p4__s_Option();
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var parent = $as_Lamf_core_model_document_BaseUnit(x2.value$2);
    this.collectAncestorsDeclarationsAndReferences__p4__Lamf_core_model_document_BaseUnit__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__V(parent, $as_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext(this.ctx$3).parentDeclarations$5)
  };
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var extension = $as_Lamf_plugins_document_webapi_model_Extension(this.parseDocument__Lamf_core_model_document_Document__Lamf_core_model_document_Document(new $c_Lamf_plugins_document_webapi_model_Extension().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)));
  this.parseExtension__p4__Lamf_core_model_document_Document__Lamf_core_metamodel_Field__V(extension, $m_Lamf_core_metamodel_document_ExtensionLikeModel$().Extends$1);
  return extension
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser.prototype.collectAncestorsDeclarationsAndReferences__p4__Lamf_core_model_document_BaseUnit__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__V = (function(reference, collector) {
  var this$1 = $as_Lamf_core_model_document_Document(reference);
  $as_sc_Seq(this$1.fields__Lamf_core_parser_Fields().apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_DocumentModel$().Declares$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, collector$1) {
    return (function(x$2$2) {
      var x$2 = $as_Lamf_core_model_domain_DomainElement(x$2$2);
      return collector$1.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$2)
    })
  })(this, collector)));
  var x1 = reference.references__sc_Seq().partition__F1__T2(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x0$1$2) {
      var x0$1 = $as_Lamf_core_model_document_BaseUnit(x0$1$2);
      return ((x0$1 instanceof $c_Lamf_core_model_document_ExtensionLike) || (x0$1 instanceof $c_Lamf_core_model_document_Document))
    })
  })(this)));
  if ((x1 === null)) {
    throw new $c_s_MatchError().init___O(x1)
  };
  var exLikeOrDocument = $as_sc_Seq(x1.$$und1__O());
  var otherReferences = $as_sc_Seq(x1.$$und2__O());
  var this$3 = reference.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_core_annotations_Aliases.getClassOf());
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var x$4 = $as_Lamf_core_annotations_Aliases(arg1);
    x$4.aliases$1.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, otherReferences$1, collector$1$1) {
      return (function(alias$2) {
        var alias = $as_T2(alias$2);
        var fullUrl = $as_T($as_T2(alias.$$und2__O()).$$und1__O());
        var x1$1 = otherReferences$1.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$2, fullUrl$1) {
          return (function(x$5$2) {
            var x$5 = $as_Lamf_core_model_document_BaseUnit(x$5$2);
            var this$4 = $f_Lamf_core_model_document_BaseUnit__location__s_Option(x$5);
            if ((!this$4.isEmpty__Z())) {
              var arg1$1 = this$4.get__O();
              var x$6 = $as_T(arg1$1);
              return (x$6 === fullUrl$1)
            } else {
              return false
            }
          })
        })($this$1, fullUrl)));
        matchEnd5: {
          if ((x1$1 instanceof $c_s_Some)) {
            var x2 = $as_s_Some(x1$1);
            var library = $as_Lamf_core_model_document_BaseUnit(x2.value$2);
            if ((library instanceof $c_Lamf_core_model_document_Module)) {
              var x3 = $as_Lamf_core_model_document_Module(library);
              var libraryDeclarations = collector$1$1.getOrCreateLibrary__T__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations($as_T(alias.$$und1__O()));
              $as_sc_Seq(x3.fields$1.apply__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_document_ModuleModel$().Declares$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, libraryDeclarations$1) {
                return (function(x$7$2) {
                  var x$7 = $as_Lamf_core_model_domain_DomainElement(x$7$2);
                  return libraryDeclarations$1.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations(x$7)
                })
              })($this$1, libraryDeclarations)));
              break matchEnd5
            }
          }
        }
      })
    })(this, otherReferences, collector)))
  };
  exLikeOrDocument.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$4$1, collector$2) {
    return (function(x$8$2) {
      var x$8 = $as_Lamf_core_model_document_BaseUnit(x$8$2);
      this$4$1.collectAncestorsDeclarationsAndReferences__p4__Lamf_core_model_document_BaseUnit__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__V(x$8, collector$2)
    })
  })(this, collector)))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser.prototype.getParent__p4__s_Option = (function() {
  var jsx$2 = this.root$4.references$1;
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x$1$2) {
      var x$1 = $as_Lamf_core_parser_ParsedReference(x$1$2);
      return x$1.unit$1
    })
  })(this));
  var this$1 = $m_sc_Seq$();
  var this$2 = $as_sc_TraversableOnce(jsx$2.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  var pf = new $c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser$$anonfun$getParent$2().init___Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser(this);
  return $f_sc_TraversableOnce__collectFirst__s_PartialFunction__s_Option(this$2, pf)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser.prototype.parseOverlay__Lamf_plugins_document_webapi_model_Overlay = (function() {
  $as_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext(this.ctx$3).contextType$3 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().OVERLAY$2;
  var x1 = this.getParent__p4__s_Option();
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var parent = $as_Lamf_core_model_document_BaseUnit(x2.value$2);
    this.collectAncestorsDeclarationsAndReferences__p4__Lamf_core_model_document_BaseUnit__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__V(parent, $as_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext(this.ctx$3).parentDeclarations$5)
  };
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var overlay = $as_Lamf_plugins_document_webapi_model_Overlay(this.parseDocument__Lamf_core_model_document_Document__Lamf_core_model_document_Document(new $c_Lamf_plugins_document_webapi_model_Overlay().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)));
  this.parseExtension__p4__Lamf_core_model_document_Document__Lamf_core_metamodel_Field__V(overlay, $m_Lamf_core_metamodel_document_ExtensionLikeModel$().Extends$1);
  return overlay
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return $as_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext(this.ctx$3)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser.prototype.parseSecuritySchemeDeclarations__Lorg_yaml_model_YMap__T__V = (function(map, parent) {
  $f_Lamf_plugins_document_webapi_parser_spec_raml_Raml10BaseSpecParser__parseSecuritySchemeDeclarations__Lorg_yaml_model_YMap__T__V(this, map, parent)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser.prototype.parseExtension__p4__Lamf_core_model_document_Document__Lamf_core_metamodel_Field__V = (function(document, field) {
  var this$1 = $as_Lamf_core_parser_SyamlParsedDocument(this.root$4.parsed$1).document$2;
  var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
  var iv = $as_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext(this.ctx$3);
  var map = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
  new $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser$UsageParser().init___Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser__Lorg_yaml_model_YMap__Lamf_core_model_document_BaseUnit(this, map, document).parse__V();
  var this$3 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("extends");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$5 = this.root$4.references$1.find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, e$1) {
      return (function(x$9$2) {
        var x$9 = $as_Lamf_core_parser_ParsedReference(x$9$2);
        var jsx$1 = x$9.origin$1.url$1;
        var this$4 = e$1.value$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$StringYRead$();
        var iv$1 = $as_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext($this.ctx$3);
        return (jsx$1 === $f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion$1, iv$1))
      })
    })(this, e)));
    if ((!this$5.isEmpty__Z())) {
      var arg1$1 = this$5.get__O();
      var extend = $as_Lamf_core_parser_ParsedReference(arg1$1);
      var value = new $c_Lamf_core_model_domain_AmfScalar().init___O__Lamf_core_parser_Annotations(extend.unit$1.id__T(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(e.value$2));
      var annotations = $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(e);
      $as_Lamf_core_model_document_Document($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_model_domain_AmfObject(document, field, value, annotations))
    }
  }
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.ExtensionLikeParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.ExtensionLikeParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.ExtensionLikeParser", {
  Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_WebApiBaseSpecParser: 1,
  Lamf_core_parser_BaseSpecParser: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_Raml10BaseSpecParser: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_ExtensionLikeParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser.call(this);
  this.root$4 = null;
  this.platform$4 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser();
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function() {
  return this.ctx$3
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser.prototype.productPrefix__T = (function() {
  return "Raml08DocumentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser.prototype.parseSchemaDeclarations__p4__Lorg_yaml_model_YMap__T__V = (function(map, parent) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option("schemas");
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$3 = e.value$2;
    var x1 = this$3.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Map$1;
    if ((x === x1)) {
      var this$4 = e.value$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var iv = this.ctx$3;
      this.parseSchemaEntries__p4__sc_Seq__T__V($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$4, conversion, iv)).entries$3, parent)
    } else {
      var x$3 = $m_Lorg_yaml_model_YType$().Null$1;
      if ((!(x$3 === x1))) {
        var x$5 = $m_Lorg_yaml_model_YType$().Seq$1;
        if ((x$5 === x1)) {
          var this$7 = e.value$2;
          var reader = $m_Lorg_yaml_convert_YRead$YMapYRead$();
          var this$6 = $m_sc_IndexedSeq$();
          var bf = this$6.ReusableCBF$6;
          var conversion$1 = new $c_Lorg_yaml_convert_YRead$$anon$1().init___scg_CanBuildFrom__Lorg_yaml_convert_YRead(bf, reader);
          var iv$1 = this.ctx$3;
          var jsx$2 = $as_sc_TraversableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$7, conversion$1, iv$1));
          var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
            return (function(x$1$2) {
              var x$1 = $as_Lorg_yaml_model_YMap(x$1$2);
              return x$1.entries$3
            })
          })(this));
          var this$8 = $m_sc_Seq$();
          this.parseSchemaEntries__p4__sc_Seq__T__V($as_sc_Seq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$8.ReusableCBFInstance$2)), parent)
        } else {
          var this$9 = this.ctx$3.eh$1;
          var specification = $m_Lamf_validations_ParserSideValidations$().InvalidTypesType$1;
          var message = (("Invalid type " + x1) + " for 'types' node.");
          var ast = e.value$2;
          var prop = $m_s_None$();
          var l = ast.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$9, specification, parent, prop, message, l)
        }
      }
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser)) {
    var Raml08DocumentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser(x$1);
    var x = this.root$4;
    var x$2 = Raml08DocumentParser$1.root$4;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.root$4;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser.prototype.parseEntries__p4__sc_Seq__T__V = (function(entries, parent) {
  entries.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$1) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var jsx$1 = $this.ctx$3.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations();
      var this$3 = $as_Lamf_plugins_document_webapi_parser_spec_declaration_SecuritySchemeParser($this.ctx$3.factory__Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecVersionFactory().securitySchemeParser__F2().apply__O__O__O(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, entry$1, parent$4) {
        return (function(scheme$2) {
          var scheme = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme(scheme$2);
          var this$1 = entry$1.key$2;
          var conversion = $m_Lorg_yaml_convert_YRead$StringYRead$();
          var iv = $this$1.ctx$3;
          var name = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv));
          $m_Lamf_core_parser_Annotations$();
          var a = new $c_Lamf_core_parser_Annotations().init___();
          var qual$1 = $as_Lamf_plugins_domain_webapi_models_security_SecurityScheme($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(scheme, name, a));
          var x$2 = $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()));
          return qual$1.adopted__T__sc_Seq__Lamf_plugins_domain_webapi_models_security_SecurityScheme(parent$4, x$2)
        })
      })($this, entry, parent$1)))).parse__Lamf_plugins_domain_webapi_models_security_SecurityScheme();
      var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
      return jsx$1.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(this$3, annotation)))
    })
  })(this, parent)))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser.prototype.parseAbstractDeclarations__p4__T__F1__Lorg_yaml_model_YMap__T__V = (function(key, producer, map, parent) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map).key__T__s_Option(key);
  if ((!this$2.isEmpty__Z())) {
    var arg1 = this$2.get__O();
    var entry = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$3 = entry.value$2;
    var x1 = this$3.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Seq$1;
    if ((x === x1)) {
      var this$6 = entry.value$2;
      var reader = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var this$5 = $m_sc_IndexedSeq$();
      var bf = this$5.ReusableCBF$6;
      var conversion = new $c_Lorg_yaml_convert_YRead$$anon$1().init___scg_CanBuildFrom__Lorg_yaml_convert_YRead(bf, reader);
      var iv = this.ctx$3;
      var jsx$2 = $as_sc_TraversableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$6, conversion, iv));
      var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
        return (function(m$2) {
          var m = $as_Lorg_yaml_model_YMap(m$2);
          return m.entries$3
        })
      })(this));
      var this$7 = $m_sc_Seq$();
      var entries = $as_sc_Seq(jsx$2.flatMap__F1__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2))
    } else {
      var x$3 = $m_Lorg_yaml_model_YType$().Map$1;
      if ((x$3 === x1)) {
        var this$8 = entry.value$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv$1 = this.ctx$3;
        var entries = $as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$8, conversion$1, iv$1)).entries$3
      } else {
        var this$9 = this.ctx$3.eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().InvalidAbstractDeclarationType$1;
        var message = (("Invalid node " + x1) + " in abstract declaration");
        var ast = entry.value$2;
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$9, specification, parent, prop, message, l);
        var entries = $m_sci_Nil$()
      }
    };
    entries.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, producer$1, parent$2) {
      return (function(entry$2$2) {
        var entry$2 = $as_Lorg_yaml_model_YMapEntry(entry$2$2);
        return this$2$1.ctx$3.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations().$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations($m_Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser$().apply__Lamf_core_model_domain_templates_AbstractDeclaration__T__Lorg_yaml_model_YMapEntry__Lamf_plugins_document_webapi_contexts_WebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_AbstractDeclarationParser($as_Lamf_core_model_domain_templates_AbstractDeclaration(producer$1.apply__O__O(entry$2)), parent$2, entry$2, this$2$1.ctx$3).parse__Lamf_core_model_domain_templates_AbstractDeclaration())
      })
    })(this, producer, parent)))
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser.prototype.parseSchemaEntries__p4__sc_Seq__T__V = (function(entries, parent) {
  entries.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$1) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var jsx$1 = $m_Lamf_plugins_document_webapi_parser_RamlTypeDefMatcher$();
      var this$1 = entry.key$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
      var iv = $this.ctx$3;
      if (jsx$1.match08Type__T__s_Option($as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3).isDefined__Z()) {
        var this$3 = $this.ctx$3.eh$1;
        var specification = $m_Lamf_validations_ParserSideValidations$().InvalidTypeDefinition$1;
        var this$2 = entry.key$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
        var iv$1 = $this.ctx$3;
        var message = (("'" + $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$2, conversion$1, iv$1)).text$3) + "' cannot be used to name a custom type");
        var ast = entry.key$2;
        var prop = $m_s_None$();
        var l = ast.location$1;
        $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$3, specification, parent$1, prop, message, l)
      };
      var x1 = $m_Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser$().apply__Lorg_yaml_model_YMapEntry__F1__Z__Lamf_plugins_document_webapi_parser_spec_declaration_DefaultType__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext__Lamf_plugins_document_webapi_parser_spec_declaration_Raml08TypeParser(entry, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, entry$1, parent$6) {
        return (function(shape$2) {
          var shape = $as_Lamf_core_model_domain_Shape(shape$2);
          $m_Lorg_yaml_model_YNode$();
          var node = entry$1.key$2;
          var iv$2 = $this$1.ctx$3;
          var conversion$2 = $m_Lorg_yaml_convert_YRead$StringYRead$();
          var name = $as_T($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(node, conversion$2, iv$2));
          $m_Lamf_core_parser_Annotations$();
          var a = new $c_Lamf_core_parser_Annotations().init___();
          var qual$1 = $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(shape, name, a));
          var x$2 = qual$1.adopted$default$2__sc_Seq();
          qual$1.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(parent$6, x$2)
        })
      })($this, entry, parent$1)), false, $m_Lamf_plugins_document_webapi_parser_spec_declaration_StringDefaultType$(), $this.ctx$3).parse__s_Option();
      if ((x1 instanceof $c_s_Some)) {
        var x2 = $as_s_Some(x1);
        var shape$3 = $as_Lamf_plugins_domain_shapes_models_AnyShape(x2.value$2);
        var jsx$2 = $this.ctx$3.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations();
        var annotation = new $c_Lamf_core_annotations_DeclaredElement().init___();
        jsx$2.$$plus$eq__Lamf_core_model_domain_DomainElement__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations($as_Lamf_core_model_domain_DomainElement($f_Lamf_core_model_domain_AmfElement__add__Lamf_core_model_domain_Annotation__Lamf_core_model_domain_AmfElement(shape$3, annotation)));
        var this$8 = $this.platform$4;
        var jsx$3 = $this.ctx$3.basePath__T__T($this.ctx$3.rootContextDocument$1);
        var this$6 = $as_Lamf_core_model_StrField(shape$3.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
        var this$7 = this$6.option$1;
        var url = (("" + jsx$3) + $as_T((this$7.isEmpty__Z() ? null : this$7.get__O())));
        var localRaml08RefInJson = $f_Lamf_core_remote_JsPlatform__normalizePath__T__T(this$8, url);
        var this$9 = $this.ctx$3.futureDeclarations$1;
        $f_Lamf_core_parser_FutureDeclarations__resolveRef__T__Lamf_core_model_domain_Linkable__V(this$9, localRaml08RefInJson, shape$3)
      } else {
        var x = $m_s_None$();
        if ((x === x1)) {
          var this$10 = $this.ctx$3.eh$1;
          var specification$1 = $m_Lamf_validations_ParserSideValidations$().InvalidTypeDefinition$1;
          var message$1 = (("Error parsing shape '" + entry) + "'");
          var prop$1 = $m_s_None$();
          var l$1 = entry.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$10, specification$1, parent$1, prop$1, message$1, l$1)
        } else {
          throw new $c_s_MatchError().init___O(x1)
        }
      }
    })
  })(this, parent)))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(root, ctx) {
  this.root$4 = root;
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, root, ctx);
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$4 = this$1.platform$1;
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser.prototype.parseDeclarations__Lamf_core_Root__Lorg_yaml_model_YMap__V = (function(root, map) {
  var parent = (root.location$1 + "#/declarations");
  this.parseSchemaDeclarations__p4__Lorg_yaml_model_YMap__T__V(map, (parent + "/schemas"));
  this.parseAbstractDeclarations__p4__T__F1__Lorg_yaml_model_YMap__T__V("resourceTypes", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$1) {
    return (function(entry$2) {
      var entry = $as_Lorg_yaml_model_YMapEntry(entry$2);
      var qual$1 = $m_Lamf_plugins_domain_webapi_models_templates_ResourceType$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_templates_ResourceType(entry);
      var this$1 = entry.key$2;
      var conversion = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
      var iv = $this.ctx$3;
      var x$1 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$1, conversion, iv)).text$3;
      $m_Lamf_core_parser_Annotations$();
      var x$2 = new $c_Lamf_core_parser_Annotations().init___();
      var jsx$1 = $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, x$1, x$2);
      var this$3 = entry.key$2;
      var conversion$1 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
      var iv$1 = $this.ctx$3;
      var str = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$3, conversion$1, iv$1)).text$3;
      var this$5 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
      var this$6 = this$5.platform$1;
      var url = this$5.str$1;
      return $as_Lamf_plugins_domain_webapi_models_templates_ResourceType(jsx$1.withId__T__Lamf_core_model_domain_AmfObject(((parent$1 + "/resourceTypes/") + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$6, url))))
    })
  })(this, parent)), map, (parent + "/resourceTypes"));
  this.parseAbstractDeclarations__p4__T__F1__Lorg_yaml_model_YMap__T__V("traits", new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, parent$2) {
    return (function(entry$3$2) {
      var entry$3 = $as_Lorg_yaml_model_YMapEntry(entry$3$2);
      var qual$2 = $m_Lamf_plugins_domain_webapi_models_templates_Trait$().apply__Lorg_yaml_model_YPart__Lamf_plugins_domain_webapi_models_templates_Trait(entry$3);
      var this$7 = entry$3.key$2;
      var conversion$2 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
      var iv$2 = this$2$1.ctx$3;
      var x$3 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$7, conversion$2, iv$2)).text$3;
      $m_Lamf_core_parser_Annotations$();
      var x$4 = new $c_Lamf_core_parser_Annotations().init___();
      var jsx$2 = $f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$2, x$3, x$4);
      var this$9 = entry$3.key$2;
      var conversion$3 = $m_Lorg_yaml_convert_YRead$YScalarYRead$();
      var iv$3 = this$2$1.ctx$3;
      var str$1 = $as_Lorg_yaml_model_YScalar($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$9, conversion$3, iv$3)).text$3;
      var this$11 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str$1);
      var this$12 = this$11.platform$1;
      var url$1 = this$11.str$1;
      return $as_Lamf_plugins_domain_webapi_models_templates_Trait(jsx$2.withId__T__Lamf_core_model_domain_AmfObject(((parent$2 + "/traits/") + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$12, url$1))))
    })
  })(this, parent)), map, (parent + "/traits"));
  this.parseSecuritySchemeDeclarations__Lorg_yaml_model_YMap__T__V(map, (parent + "/securitySchemes"))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$3
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser.prototype.parseSecuritySchemeDeclarations__Lorg_yaml_model_YMap__T__V = (function(map, parent) {
  var this$2 = new $c_Lamf_core_parser_package$YMapOps().init___Lorg_yaml_model_YMap(map);
  var this$3 = this$2.key__T__s_Option("securitySchemes");
  if ((!this$3.isEmpty__Z())) {
    var arg1 = this$3.get__O();
    var e = $as_Lorg_yaml_model_YMapEntry(arg1);
    var this$4 = e.value$2;
    var x1 = this$4.tag__Lorg_yaml_model_YTag().tagType$3;
    var x = $m_Lorg_yaml_model_YType$().Seq$1;
    if ((x === x1)) {
      var this$7 = e.value$2;
      var reader = $m_Lorg_yaml_convert_YRead$YMapYRead$();
      var this$6 = $m_sc_IndexedSeq$();
      var bf = this$6.ReusableCBF$6;
      var conversion = new $c_Lorg_yaml_convert_YRead$$anon$1().init___scg_CanBuildFrom__Lorg_yaml_convert_YRead(bf, reader);
      var iv = this.ctx$3;
      $as_sc_IterableLike($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$7, conversion, iv)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, parent$3) {
        return (function(map$2) {
          var map$1 = $as_Lorg_yaml_model_YMap(map$2);
          $this.parseEntries__p4__sc_Seq__T__V(map$1.entries$3, parent$3)
        })
      })(this, parent)))
    } else {
      var x$3 = $m_Lorg_yaml_model_YType$().Map$1;
      if ((x$3 === x1)) {
        var this$8 = e.value$2;
        var conversion$1 = $m_Lorg_yaml_convert_YRead$YMapYRead$();
        var iv$1 = this.ctx$3;
        this.parseEntries__p4__sc_Seq__T__V($as_Lorg_yaml_model_YMap($f_Lorg_yaml_model_YNodeLike__as__Lorg_yaml_convert_YRead__Lorg_yaml_model_IllegalTypeHandler__O(this$8, conversion$1, iv$1)).entries$3, parent)
      } else {
        var x$5 = $m_Lorg_yaml_model_YType$().Null$1;
        if ((!(x$5 === x1))) {
          var this$9 = this.ctx$3.eh$1;
          var specification = $m_Lamf_validations_ParserSideValidations$().InvalidSecuredByType$1;
          var message = (("Invalid type " + x1) + " for 'securitySchemes' node.");
          var ast = e.value$2;
          var prop = $m_s_None$();
          var l = ast.location$1;
          $f_Lamf_core_errorhandling_ErrorHandler__violation__Lamf_core_validation_core_ValidationSpecification__T__s_Option__T__Lorg_mulesoft_lexer_SourceLocation__V(this$9, specification, parent, prop, message, l)
        }
      }
    }
  }
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.Raml08DocumentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.Raml08DocumentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.Raml08DocumentParser", {
  Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_WebApiBaseSpecParser: 1,
  Lamf_core_parser_BaseSpecParser: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_Raml08DocumentParser;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser() {
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser.call(this);
  this.root$4 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser.prototype = new $h_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser();
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser.prototype = $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser.prototype.ctx__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function() {
  return this.ctx$3
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser.prototype.productPrefix__T = (function() {
  return "Raml10DocumentParser"
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser)) {
    var Raml10DocumentParser$1 = $as_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser(x$1);
    var x = this.root$4;
    var x$2 = Raml10DocumentParser$1.root$4;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.root$4;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(root, ctx) {
  this.root$4 = root;
  $c_Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser.prototype.init___Lamf_core_Root__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext.call(this, root, ctx);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser.prototype.ctx__Lamf_core_parser_ParserContext = (function() {
  return this.ctx$3
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser.prototype.parseSecuritySchemeDeclarations__Lorg_yaml_model_YMap__T__V = (function(map, parent) {
  $f_Lamf_plugins_document_webapi_parser_spec_raml_Raml10BaseSpecParser__parseSecuritySchemeDeclarations__Lorg_yaml_model_YMap__T__V(this, map, parent)
});
function $as_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.raml.Raml10DocumentParser"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.raml.Raml10DocumentParser;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser: 0
}, false, "amf.plugins.document.webapi.parser.spec.raml.Raml10DocumentParser", {
  Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlDocumentParser: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlBaseDocumentParser: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_RamlSpecParser: 1,
  O: 1,
  Lamf_plugins_document_webapi_parser_spec_common_WebApiBaseSpecParser: 1,
  Lamf_core_parser_BaseSpecParser: 1,
  Lamf_plugins_document_webapi_parser_spec_common_SpecParserOps: 1,
  Lamf_plugins_document_webapi_parser_spec_declaration_RamlTypeSyntax: 1,
  Lamf_plugins_document_webapi_parser_spec_raml_Raml10BaseSpecParser: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_raml_Raml10DocumentParser;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$() {
  $c_O.call(this);
  this.doc$1 = null;
  this.fields$1 = null;
  this.XMLSerialization$1 = null;
  this.Comment$1 = null;
  this.type$1 = null;
  this.Documentation$1 = null;
  this.Examples$1 = null;
  this.Raw$1 = null;
  this.ReferenceId$1 = null;
  this.Location$1 = null;
  this.Name$1 = null;
  this.DisplayName$1 = null;
  this.Default$1 = null;
  this.DefaultValueString$1 = null;
  this.Values$1 = null;
  this.Closure$1 = null;
  this.Inherits$1 = null;
  this.Or$1 = null;
  this.And$1 = null;
  this.Xone$1 = null;
  this.Not$1 = null;
  this.If$1 = null;
  this.Then$1 = null;
  this.Else$1 = null;
  this.ReadOnly$1 = null;
  this.WriteOnly$1 = null;
  this.Deprecated$1 = null;
  this.key$1 = null;
  this.CustomShapePropertyDefinitions$1 = null;
  this.CustomShapeProperties$1 = null;
  this.Description$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.constructor = $c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype = $c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype;
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$XMLSerialization$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.XMLSerialization$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$Comment$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Comment$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ShapeModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ExternalSourceElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel__$$init$__V(this);
  var jsx$2 = $m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1;
  var jsx$1 = $m_sc_Seq$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "Shape").iri__T()];
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq(jsx$2, "Any Shape", "Base class for all shapes stored in the graph model", $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array))));
  var jsx$6 = $m_Lamf_core_metamodel_domain_ShapeModel$().fields$1;
  $m_sci_List$();
  var array$1 = [this.Documentation$1, this.XMLSerialization$1, this.Comment$1, this.Examples$1];
  var i = (((-1) + $uI(array$1.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$8 = result;
    var index = i;
    var x = array$1[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$8);
    i = (((-1) + i) | 0)
  };
  var jsx$5 = result;
  var this$9 = $m_sci_List$();
  var jsx$4 = $as_sci_List(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$5, this$9.ReusableCBFInstance$2));
  var jsx$3 = $m_Lamf_core_metamodel_domain_ExternalSourceElementModel$().fields$1;
  var this$10 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$10.ReusableCBFInstance$2));
  return this
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Raw$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Raw$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$ReadOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReadOnly$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$common$DocumentationField$$undsetter$und$Documentation$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Documentation$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Deprecated$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Deprecated$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DefaultValueString$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DefaultValueString$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$type$und$eq__sci_List__V = (function(x$1) {
  this.type$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$WriteOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.WriteOnly$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DisplayName$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DisplayName$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$common$ExamplesField$$undsetter$und$Examples$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Examples$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$key$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.key$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Else$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Else$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Inherits$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Inherits$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$And$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.And$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_shapes_models_AnyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Not$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Not$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$If$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.If$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Closure$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Closure$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$ReferenceId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReferenceId$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Xone$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Xone$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.modelInstance__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  return new $c_Lamf_plugins_domain_shapes_models_AnyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Values$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Values$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Or$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Or$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Then$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Then$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.Name__Lamf_core_metamodel_Field = (function() {
  return this.Name$1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Default$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Default$1 = x$1
});
var $d_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$: 0
}, false, "amf.plugins.domain.shapes.metamodel.AnyShapeModel$", {
  Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_metamodel_AnyShapeModel: 1,
  Lamf_core_metamodel_domain_ShapeModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1,
  Lamf_core_metamodel_domain_ExternalSourceElementModel: 1,
  Lamf_plugins_domain_shapes_metamodel_common_ExamplesField: 1,
  Lamf_plugins_domain_shapes_metamodel_common_DocumentationField: 1
});
$c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$.prototype.$classData = $d_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$;
var $n_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$ = (void 0);
function $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$() {
  if ((!$n_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$)) {
    $n_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$ = new $c_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape() {
  $c_O.call(this);
  this.Items$1 = null;
  this.Contains$1 = null;
  this.MinItems$1 = null;
  this.MaxItems$1 = null;
  this.UniqueItems$1 = null;
  this.CollectionFormat$1 = null;
  this.specificFields$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.XMLSerialization$1 = null;
  this.Comment$1 = null;
  this.type$1 = null;
  this.Documentation$1 = null;
  this.Examples$1 = null;
  this.Raw$1 = null;
  this.ReferenceId$1 = null;
  this.Location$1 = null;
  this.Name$1 = null;
  this.DisplayName$1 = null;
  this.Default$1 = null;
  this.DefaultValueString$1 = null;
  this.Values$1 = null;
  this.Closure$1 = null;
  this.Inherits$1 = null;
  this.Or$1 = null;
  this.And$1 = null;
  this.Xone$1 = null;
  this.Not$1 = null;
  this.If$1 = null;
  this.Then$1 = null;
  this.Else$1 = null;
  this.ReadOnly$1 = null;
  this.WriteOnly$1 = null;
  this.Deprecated$1 = null;
  this.key$1 = null;
  this.CustomShapePropertyDefinitions$1 = null;
  this.CustomShapeProperties$1 = null;
  this.Description$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.constructor = $c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype = $c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype;
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$Comment$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Comment$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$XMLSerialization$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.XMLSerialization$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.init___ = (function() {
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ShapeModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ExternalSourceElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_domain_ShapeModel$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.Items$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "items"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "items", "Shapes inside the data arrangement", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_domain_ShapeModel$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.Contains$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "contains"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "contains", "One of the shapes in the data arrangement", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_core_metamodel_Type$Int$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.MinItems$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "minCount"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "min count", "Minimum items count constraint", $m_sci_Nil$()), true);
  var jsx$4 = $m_Lamf_core_metamodel_Type$Int$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.MaxItems$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "maxCount"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "max count", "Maximum items count constraint", $m_sci_Nil$()), true);
  var jsx$5 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.UniqueItems$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "uniqueItems"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "uinque items", "Unique items constraint", $m_sci_Nil$()), true);
  var jsx$6 = $m_Lamf_core_metamodel_Type$Str$();
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.CollectionFormat$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$6, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "collectionFormat"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "collection format", "Input collection format information", $m_sci_Nil$()), true);
  $m_sci_List$();
  var array = [this.Items$1, this.Contains$1, this.MinItems$1, this.MaxItems$1, this.UniqueItems$1, this.CollectionFormat$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$22 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$22);
    i = (((-1) + i) | 0)
  };
  this.specificFields$1 = result;
  var jsx$10 = this.specificFields$1;
  var jsx$9 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().fields$1;
  var this$23 = $m_sci_List$();
  var jsx$8 = $as_sci_List(jsx$10.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$9, this$23.ReusableCBFInstance$2));
  var jsx$7 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$24 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$8.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$7, this$24.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "Data Arrangement Shape", "Base shape class for any data shape that contains a nested collection of data shapes", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Raw$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Raw$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$ReadOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReadOnly$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Deprecated$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Deprecated$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$plugins$domain$shapes$metamodel$common$DocumentationField$$undsetter$und$Documentation$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Documentation$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DefaultValueString$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DefaultValueString$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$type$und$eq__sci_List__V = (function(x$1) {
  this.type$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$WriteOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.WriteOnly$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DisplayName$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DisplayName$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$plugins$domain$shapes$metamodel$common$ExamplesField$$undsetter$und$Examples$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Examples$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$key$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.key$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Else$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Else$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Inherits$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Inherits$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$And$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.And$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Not$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Not$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$If$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.If$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Closure$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Closure$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$ReferenceId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReferenceId$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Xone$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Xone$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Values$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Values$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Or$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Or$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Then$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Then$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Default$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Default$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.Name__Lamf_core_metamodel_Field = (function() {
  return this.Name$1
});
/** @constructor */
function $c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$() {
  $c_O.call(this);
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.XMLSerialization$1 = null;
  this.Comment$1 = null;
  this.Documentation$1 = null;
  this.Examples$1 = null;
  this.Raw$1 = null;
  this.ReferenceId$1 = null;
  this.Location$1 = null;
  this.Name$1 = null;
  this.DisplayName$1 = null;
  this.Default$1 = null;
  this.DefaultValueString$1 = null;
  this.Values$1 = null;
  this.Closure$1 = null;
  this.Inherits$1 = null;
  this.Or$1 = null;
  this.And$1 = null;
  this.Xone$1 = null;
  this.Not$1 = null;
  this.If$1 = null;
  this.Then$1 = null;
  this.Else$1 = null;
  this.ReadOnly$1 = null;
  this.WriteOnly$1 = null;
  this.Deprecated$1 = null;
  this.key$1 = null;
  this.CustomShapePropertyDefinitions$1 = null;
  this.CustomShapeProperties$1 = null;
  this.Description$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.constructor = $c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype = $c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype;
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$Comment$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Comment$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$XMLSerialization$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.XMLSerialization$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ShapeModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ExternalSourceElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel__$$init$__V(this);
  $m_sci_List$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "NilShape")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_core_metamodel_domain_ShapeModel$().type$1;
  var this$7 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
  this.fields$1 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().fields$1;
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "Nil Shape", "Data shape representing the null/nil value in the input schema", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Raw$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Raw$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$ReadOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReadOnly$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Deprecated$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Deprecated$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$common$DocumentationField$$undsetter$und$Documentation$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Documentation$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DefaultValueString$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DefaultValueString$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$type$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$WriteOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.WriteOnly$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DisplayName$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DisplayName$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$common$ExamplesField$$undsetter$und$Examples$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Examples$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$key$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.key$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Else$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Else$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Inherits$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Inherits$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$And$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.And$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_shapes_models_NilShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Not$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Not$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$If$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.If$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Closure$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Closure$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$ReferenceId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReferenceId$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Xone$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Xone$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.modelInstance__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_shapes_models_NilShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Values$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Values$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Or$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Or$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Then$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Then$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Default$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Default$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.Name__Lamf_core_metamodel_Field = (function() {
  return this.Name$1
});
var $d_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_metamodel_NilShapeModel$: 0
}, false, "amf.plugins.domain.shapes.metamodel.NilShapeModel$", {
  Lamf_plugins_domain_shapes_metamodel_NilShapeModel$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_metamodel_AnyShapeModel: 1,
  Lamf_core_metamodel_domain_ShapeModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1,
  Lamf_core_metamodel_domain_ExternalSourceElementModel: 1,
  Lamf_plugins_domain_shapes_metamodel_common_ExamplesField: 1,
  Lamf_plugins_domain_shapes_metamodel_common_DocumentationField: 1
});
$c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$.prototype.$classData = $d_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$;
var $n_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$ = (void 0);
function $m_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$() {
  if ((!$n_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$)) {
    $n_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$ = new $c_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$() {
  $c_O.call(this);
  this.MinProperties$1 = null;
  this.MaxProperties$1 = null;
  this.Closed$1 = null;
  this.AdditionalPropertiesSchema$1 = null;
  this.Discriminator$1 = null;
  this.DiscriminatorValue$1 = null;
  this.DiscriminatorMapping$1 = null;
  this.Properties$1 = null;
  this.PropertyNames$1 = null;
  this.Dependencies$1 = null;
  this.specificFields$1 = null;
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.XMLSerialization$1 = null;
  this.Comment$1 = null;
  this.Documentation$1 = null;
  this.Examples$1 = null;
  this.Raw$1 = null;
  this.ReferenceId$1 = null;
  this.Location$1 = null;
  this.Name$1 = null;
  this.DisplayName$1 = null;
  this.Default$1 = null;
  this.DefaultValueString$1 = null;
  this.Values$1 = null;
  this.Closure$1 = null;
  this.Inherits$1 = null;
  this.Or$1 = null;
  this.And$1 = null;
  this.Xone$1 = null;
  this.Not$1 = null;
  this.If$1 = null;
  this.Then$1 = null;
  this.Else$1 = null;
  this.ReadOnly$1 = null;
  this.WriteOnly$1 = null;
  this.Deprecated$1 = null;
  this.key$1 = null;
  this.CustomShapePropertyDefinitions$1 = null;
  this.CustomShapeProperties$1 = null;
  this.Description$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.constructor = $c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype = $c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype;
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$XMLSerialization$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.XMLSerialization$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$Comment$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Comment$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ShapeModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ExternalSourceElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Int$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.MinProperties$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "minProperties"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "min properties", "Minimum number of properties in the input node constraint", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Int$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.MaxProperties$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "maxProperties"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "max properties", "Maximum number of properties in the input node constraint", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.Closed$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "closed"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "closed", "Additional properties in the input node accepted constraint", $m_sci_Nil$()), true);
  var jsx$4 = $m_Lamf_core_metamodel_domain_ShapeModel$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.AdditionalPropertiesSchema$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$4, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "additionalPropertiesSchema"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "additional properties schema", "Additional properties schema", $m_sci_Nil$()), true);
  var jsx$5 = $m_Lamf_core_metamodel_Type$Str$();
  var this$13 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.Discriminator$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$13, "discriminator"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "discriminator", "Discriminator property", $m_sci_Nil$()), true);
  var jsx$6 = $m_Lamf_core_metamodel_Type$Str$();
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.DiscriminatorValue$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$6, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "discriminatorValue"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "discriminator value", "Values for the discriminator property", $m_sci_Nil$()), true);
  var jsx$7 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_IriTemplateMappingModel$());
  var this$19 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.DiscriminatorMapping$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$7, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$19, "discriminatorMapping"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "discriminator mapping", "Mappping of acceptable values for the ndoe discriminator", $m_sci_Nil$()), true);
  var jsx$8 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_domain_extensions_PropertyShapeModel$());
  var this$22 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.Properties$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$8, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$22, "property"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "property", "Properties associated to this node", $m_sci_Nil$()), true);
  var jsx$9 = $m_Lamf_core_metamodel_domain_ShapeModel$();
  var this$25 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.PropertyNames$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$9, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$25, "propertyNames"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "property names", "Property names schema", $m_sci_Nil$()), true);
  var jsx$10 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_shapes_metamodel_PropertyDependenciesModel$());
  var this$28 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.Dependencies$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$10, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$28, "dependencies"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "dependencies", "Dependent properties constraint", $m_sci_Nil$()), true);
  $m_sci_List$();
  var array = [this.MinProperties$1, this.MaxProperties$1, this.Closed$1, this.AdditionalPropertiesSchema$1, this.Discriminator$1, this.DiscriminatorValue$1, this.DiscriminatorMapping$1, this.Properties$1, this.PropertyNames$1, this.Dependencies$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$34 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$34);
    i = (((-1) + i) | 0)
  };
  this.specificFields$1 = result;
  var jsx$14 = this.specificFields$1;
  var jsx$13 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().fields$1;
  var this$35 = $m_sci_List$();
  var jsx$12 = $as_sci_List(jsx$14.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$13, this$35.ReusableCBFInstance$2));
  var jsx$11 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$36 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$12.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$11, this$36.ReusableCBFInstance$2));
  $m_sci_List$();
  var this$37 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  var array$1 = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$37, "NodeShape")];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$42 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$42);
    i$1 = (((-1) + i$1) | 0)
  };
  var jsx$16 = result$1;
  var jsx$15 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().type$1;
  var this$43 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$16.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$15, this$43.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "Node Shape", "Shape that validates a record of fields, like a JS object", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Raw$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Raw$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$ReadOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReadOnly$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$common$DocumentationField$$undsetter$und$Documentation$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Documentation$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Deprecated$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Deprecated$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DefaultValueString$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DefaultValueString$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$type$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$WriteOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.WriteOnly$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DisplayName$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DisplayName$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$common$ExamplesField$$undsetter$und$Examples$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Examples$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$key$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.key$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Else$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Else$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$And$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.And$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Inherits$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Inherits$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_shapes_models_NodeShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Not$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Not$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$If$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.If$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Closure$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Closure$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$ReferenceId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReferenceId$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Xone$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Xone$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.modelInstance__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_shapes_models_NodeShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Or$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Or$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Values$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Values$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Then$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Then$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Default$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Default$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.Name__Lamf_core_metamodel_Field = (function() {
  return this.Name$1
});
var $d_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$: 0
}, false, "amf.plugins.domain.shapes.metamodel.NodeShapeModel$", {
  Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_metamodel_AnyShapeModel: 1,
  Lamf_core_metamodel_domain_ShapeModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1,
  Lamf_core_metamodel_domain_ExternalSourceElementModel: 1,
  Lamf_plugins_domain_shapes_metamodel_common_ExamplesField: 1,
  Lamf_plugins_domain_shapes_metamodel_common_DocumentationField: 1
});
$c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$.prototype.$classData = $d_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$;
var $n_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$ = (void 0);
function $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$() {
  if ((!$n_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$)) {
    $n_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$ = new $c_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$() {
  $c_O.call(this);
  this.AnyOf$1 = null;
  this.specificFields$1 = null;
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.XMLSerialization$1 = null;
  this.Comment$1 = null;
  this.Documentation$1 = null;
  this.Examples$1 = null;
  this.Raw$1 = null;
  this.ReferenceId$1 = null;
  this.Location$1 = null;
  this.Name$1 = null;
  this.DisplayName$1 = null;
  this.Default$1 = null;
  this.DefaultValueString$1 = null;
  this.Values$1 = null;
  this.Closure$1 = null;
  this.Inherits$1 = null;
  this.Or$1 = null;
  this.And$1 = null;
  this.Xone$1 = null;
  this.Not$1 = null;
  this.If$1 = null;
  this.Then$1 = null;
  this.Else$1 = null;
  this.ReadOnly$1 = null;
  this.WriteOnly$1 = null;
  this.Deprecated$1 = null;
  this.key$1 = null;
  this.CustomShapePropertyDefinitions$1 = null;
  this.CustomShapeProperties$1 = null;
  this.Description$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.constructor = $c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype = $c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype;
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$Comment$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Comment$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$XMLSerialization$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.XMLSerialization$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ShapeModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ExternalSourceElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel__$$init$__V(this);
  var jsx$1 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_domain_ShapeModel$());
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.AnyOf$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "anyOf"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "any of", "Data shapes in the union", $m_sci_Nil$()), true);
  $m_sci_List$();
  var array = [this.AnyOf$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$7 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$7);
    i = (((-1) + i) | 0)
  };
  this.specificFields$1 = result;
  var jsx$5 = this.specificFields$1;
  var jsx$4 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().fields$1;
  var this$8 = $m_sci_List$();
  var jsx$3 = $as_sci_List(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$8.ReusableCBFInstance$2));
  var jsx$2 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$9 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$9.ReusableCBFInstance$2));
  $m_sci_List$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var array$1 = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "UnionShape")];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$15 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$15);
    i$1 = (((-1) + i$1) | 0)
  };
  var jsx$7 = result$1;
  var jsx$6 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().type$1;
  var this$16 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$7.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$6, this$16.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "Union Shape", "Shape representing the union of many alternative data shapes", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Raw$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Raw$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$ReadOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReadOnly$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Deprecated$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Deprecated$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$common$DocumentationField$$undsetter$und$Documentation$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Documentation$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DefaultValueString$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DefaultValueString$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$type$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$WriteOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.WriteOnly$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DisplayName$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DisplayName$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$common$ExamplesField$$undsetter$und$Examples$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Examples$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$key$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.key$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Else$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Else$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Inherits$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Inherits$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$And$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.And$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_shapes_models_UnionShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Not$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Not$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$If$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.If$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Closure$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Closure$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$ReferenceId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReferenceId$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Xone$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Xone$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.modelInstance__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_shapes_models_UnionShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Values$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Values$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Or$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Or$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Then$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Then$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Default$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Default$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.Name__Lamf_core_metamodel_Field = (function() {
  return this.Name$1
});
var $d_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$: 0
}, false, "amf.plugins.domain.shapes.metamodel.UnionShapeModel$", {
  Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_metamodel_AnyShapeModel: 1,
  Lamf_core_metamodel_domain_ShapeModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1,
  Lamf_core_metamodel_domain_ExternalSourceElementModel: 1,
  Lamf_plugins_domain_shapes_metamodel_common_ExamplesField: 1,
  Lamf_plugins_domain_shapes_metamodel_common_DocumentationField: 1
});
$c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$.prototype.$classData = $d_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$;
var $n_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$ = (void 0);
function $m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$() {
  if ((!$n_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$)) {
    $n_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$ = new $c_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1() {
  $c_O.call(this);
  this.doc$1 = null;
  this.XMLSerialization$1 = null;
  this.Comment$1 = null;
  this.type$1 = null;
  this.Documentation$1 = null;
  this.Examples$1 = null;
  this.Raw$1 = null;
  this.ReferenceId$1 = null;
  this.Location$1 = null;
  this.Name$1 = null;
  this.DisplayName$1 = null;
  this.Default$1 = null;
  this.DefaultValueString$1 = null;
  this.Values$1 = null;
  this.Closure$1 = null;
  this.Inherits$1 = null;
  this.Or$1 = null;
  this.And$1 = null;
  this.Xone$1 = null;
  this.Not$1 = null;
  this.If$1 = null;
  this.Then$1 = null;
  this.Else$1 = null;
  this.ReadOnly$1 = null;
  this.WriteOnly$1 = null;
  this.Deprecated$1 = null;
  this.key$1 = null;
  this.CustomShapePropertyDefinitions$1 = null;
  this.CustomShapeProperties$1 = null;
  this.Description$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0;
  this.$$outer$1 = null
}
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype = $c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype;
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$Comment$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Comment$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$XMLSerialization$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.XMLSerialization$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$ReadOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReadOnly$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Raw$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Raw$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.modelInstance__Lamf_plugins_domain_shapes_models_UnresolvedShape = (function() {
  return new $c_Lamf_plugins_domain_shapes_models_UnresolvedShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations__T__s_Option__s_Option__Z(new $c_Lamf_core_parser_Fields().init___(), ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()), this.$$outer$1.reference$3, $m_s_None$(), $m_s_None$(), true)
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Deprecated$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Deprecated$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$plugins$domain$shapes$metamodel$common$DocumentationField$$undsetter$und$Documentation$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Documentation$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DefaultValueString$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DefaultValueString$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$type$und$eq__sci_List__V = (function(x$1) {
  this.type$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.fields__sci_List = (function() {
  return $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().fields$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$WriteOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.WriteOnly$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DisplayName$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DisplayName$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$plugins$domain$shapes$metamodel$common$ExamplesField$$undsetter$und$Examples$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Examples$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$key$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.key$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Else$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Else$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Inherits$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Inherits$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$And$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.And$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  return this.modelInstance__Lamf_plugins_domain_shapes_models_UnresolvedShape()
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Not$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Not$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$If$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.If$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.init___Lamf_plugins_domain_shapes_models_UnresolvedShape = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ShapeModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ExternalSourceElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel__$$init$__V(this);
  this.doc$1 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().doc$1;
  return this
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Closure$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Closure$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$ReferenceId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReferenceId$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Xone$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Xone$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.modelInstance__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this.modelInstance__Lamf_plugins_domain_shapes_models_UnresolvedShape()
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Values$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Values$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Or$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Or$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Then$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Then$1 = x$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.Name__Lamf_core_metamodel_Field = (function() {
  return this.Name$1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Default$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Default$1 = x$1
});
var $d_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1 = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1: 0
}, false, "amf.plugins.domain.shapes.models.UnresolvedShape$$anon$1", {
  Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1: 1,
  O: 1,
  Lamf_plugins_domain_shapes_metamodel_AnyShapeModel: 1,
  Lamf_core_metamodel_domain_ShapeModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1,
  Lamf_core_metamodel_domain_ExternalSourceElementModel: 1,
  Lamf_plugins_domain_shapes_metamodel_common_ExamplesField: 1,
  Lamf_plugins_domain_shapes_metamodel_common_DocumentationField: 1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_OperationModel$() {
  $c_O.call(this);
  this.Method$1 = null;
  this.OperationId$1 = null;
  this.Deprecated$1 = null;
  this.Summary$1 = null;
  this.Schemes$1 = null;
  this.Accepts$1 = null;
  this.ContentType$1 = null;
  this.Request$1 = null;
  this.Responses$1 = null;
  this.Security$1 = null;
  this.Callbacks$1 = null;
  this.Servers$1 = null;
  this.Bindings$1 = null;
  this.key$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.IsAbstract$1 = null;
  this.Tags$1 = null;
  this.Documentation$1 = null;
  this.Description$1 = null;
  this.Name$1 = null;
  this.Optional$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_OperationModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_OperationModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.Extends$lzycompute__p1__Lamf_core_metamodel_Field = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.Extends$1 = $f_Lamf_core_metamodel_domain_DomainElementModel__Extends__Lamf_core_metamodel_Field(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.Extends$1
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_OperationModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_templates_OptionalField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_TagsModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_AbstractModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Method$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "method"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "method", "HTTP method required to invoke the operation", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_Type$Str$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.OperationId$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "operationId"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "operation ID", "Identifier of the target operation", $m_sci_Nil$()), true);
  var jsx$3 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.Deprecated$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "deprecated"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "deprecated", "Marks the operation as deprecated", $m_sci_Nil$()), true);
  var jsx$7 = $m_Lamf_core_metamodel_Type$Str$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var jsx$6 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "guiSummary");
  var jsx$5 = $m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1;
  var jsx$4 = $m_sc_Seq$();
  var this$12 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$12, "description").iri__T()];
  this.Summary$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$7, jsx$6, new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq(jsx$5, "gui summary", "Human readable description of the operation", $as_sc_Seq(jsx$4.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))), true);
  var jsx$8 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Str$());
  var this$16 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Schemes$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$8, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$16, "scheme"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "scheme", "URI scheme for the API protocol", $m_sci_Nil$()), true);
  var jsx$9 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Str$());
  var this$19 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Accepts$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$9, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$19, "accepts"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "accepts", "Media-types accepted in a API request", $m_sci_Nil$()), true);
  var jsx$10 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Str$());
  var this$22 = $m_Lamf_core_vocabulary_Namespace$().Core$1;
  this.ContentType$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$10, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$22, "mediaType"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Core$1, "media type", "Media types returned by a API response", $m_sci_Nil$()), true);
  var jsx$11 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_RequestModel$());
  var this$25 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Request$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$11, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$25, "expects"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "expects", "Request information required by the operation", $m_sci_Nil$()), true);
  var jsx$12 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$());
  var this$28 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Responses$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$12, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$28, "returns"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "returns", "Response data returned by the operation", $m_sci_Nil$()), true);
  var jsx$13 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$());
  var this$31 = $m_Lamf_core_vocabulary_Namespace$().Security$1;
  this.Security$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$13, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$31, "security"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Security$1, "security", "security schemes applied to an element in the API spec", $m_sci_Nil$()), true);
  var jsx$14 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_CallbackModel$());
  var this$34 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Callbacks$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$14, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$34, "callback"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "callback", "associated callbacks", $m_sci_Nil$()), true);
  var jsx$15 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_ServerModel$());
  var this$37 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Servers$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$15, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$37, "server"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "server", "server information", $m_sci_Nil$()), true);
  var jsx$16 = $m_Lamf_plugins_domain_webapi_metamodel_bindings_OperationBindingsModel$();
  var this$40 = $m_Lamf_core_vocabulary_Namespace$().ApiBinding$1;
  this.Bindings$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$16, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$40, "binding"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiBinding$1, "binding", "Bindings for this operation", $m_sci_Nil$()), true);
  this.key$1 = this.Method$1;
  var this$43 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$43, "Operation");
  var this$45 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$45);
  $m_sci_List$();
  var array$1 = [this.Method$1, this.Name$1, this.Description$1, this.Deprecated$1, this.Summary$1, this.Documentation$1, this.Schemes$1, this.Accepts$1, this.ContentType$1, this.Request$1, this.Responses$1, this.Security$1, this.Tags$1, this.Callbacks$1, this.Servers$1, this.Bindings$1, this.IsAbstract$1, this.OperationId$1];
  var i = (((-1) + $uI(array$1.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$49 = result;
    var index = i;
    var x = array$1[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$49);
    i = (((-1) + i) | 0)
  };
  var jsx$20 = result;
  var jsx$19 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().fields$1;
  var this$50 = $m_sci_List$();
  var jsx$18 = $as_sci_List(jsx$20.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$19, this$50.ReusableCBFInstance$2));
  var jsx$17 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$51 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$18.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$17, this$51.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Operation", "Action that can be executed using a particular HTTP invocation", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.amf$plugins$domain$shapes$metamodel$common$DocumentationField$$undsetter$und$Documentation$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Documentation$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.amf$plugins$domain$webapi$metamodel$AbstractModel$$undsetter$und$IsAbstract$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsAbstract$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.amf$core$metamodel$domain$templates$OptionalField$$undsetter$und$Optional$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Optional$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.Extends__Lamf_core_metamodel_Field = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.Extends$lzycompute__p1__Lamf_core_metamodel_Field() : this.Extends$1)
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_Operation().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.Optional__Lamf_core_metamodel_Field = (function() {
  return this.Optional$1
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.amf$plugins$domain$webapi$metamodel$TagsModel$$undsetter$und$Tags$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Tags$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_OperationModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_OperationModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.OperationModel$", {
  Lamf_plugins_domain_webapi_metamodel_OperationModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_templates_OptionalField: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1,
  Lamf_plugins_domain_shapes_metamodel_common_DocumentationField: 1,
  Lamf_plugins_domain_webapi_metamodel_TagsModel: 1,
  Lamf_plugins_domain_webapi_metamodel_AbstractModel: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_OperationModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_OperationModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_OperationModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_OperationModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_OperationModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_OperationModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_OperationModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_models_Operation() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_domain_webapi_models_Operation.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.constructor = $c_Lamf_plugins_domain_webapi_models_Operation;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_models_Operation() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_models_Operation.prototype = $c_Lamf_plugins_domain_webapi_models_Operation.prototype;
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.request__Lamf_plugins_domain_webapi_models_Request = (function() {
  var this$1 = $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Request$1)).headOption__s_Option();
  return $as_Lamf_plugins_domain_webapi_models_Request((this$1.isEmpty__Z() ? null : this$1.get__O()))
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.productPrefix__T = (function() {
  return "Operation"
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.withServer__T__Lamf_plugins_domain_webapi_models_Server = (function(url) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_Server().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ServerModel$().Url$1;
  var result = $as_Lamf_plugins_domain_webapi_models_Server($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, url));
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Servers$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field$1, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.removeServers__V = (function() {
  this.fields$1.removeField__Lamf_core_metamodel_Field__Lamf_core_parser_Fields($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Servers$1)
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.documentations__sc_Seq = (function() {
  var jsx$1 = $m_sc_Seq$();
  var array = [$as_Lamf_plugins_domain_shapes_models_CreativeWork(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Documentation$1))];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_webapi_models_Operation)) {
    var Operation$1 = $as_Lamf_plugins_domain_webapi_models_Operation(x$1);
    var x = this.fields$1;
    var x$2 = Operation$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = Operation$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_Operation().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$()
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.withSecurity__T__Lamf_plugins_domain_webapi_models_security_SecurityRequirement = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_webapi_models_security_SecurityRequirement().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_security_SecurityRequirementModel$().Name$1;
  var result = $as_Lamf_plugins_domain_webapi_models_security_SecurityRequirement($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$4, field, name));
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Security$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field$1, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Method$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-operation" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.withServers__sc_Seq__Lamf_plugins_domain_webapi_models_ServerContainer = (function(servers) {
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Servers$1;
  return $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this, field, servers))
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.withRequest__Lamf_plugins_domain_webapi_models_Request__Lamf_plugins_domain_webapi_models_Operation = (function(request) {
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Request$1;
  var jsx$1 = $m_sc_Seq$();
  var array = [request];
  var values = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  return $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this, field, values))
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_webapi_models_Operation().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.withCallback__T__Lamf_plugins_domain_webapi_models_Callback = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_Callback().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var result = $as_Lamf_plugins_domain_webapi_models_Callback($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Callbacks$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.traits__sc_Seq = (function() {
  var jsx$2 = $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_DomainElementModel$().Extends__Lamf_core_metamodel_Field()));
  var jsx$1 = new $c_Lamf_plugins_domain_webapi_models_Operation$$anonfun$traits$1().init___Lamf_plugins_domain_webapi_models_Operation(this);
  var this$1 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$2.collect__s_PartialFunction__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.withRequest__Lamf_plugins_domain_webapi_models_Request = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var request = new $c_Lamf_plugins_domain_webapi_models_Request().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Request$1;
  var jsx$1 = $m_sc_Seq$();
  var array = [request];
  var values = $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  $f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this, field, values);
  return request
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.withResponse__T__Lamf_plugins_domain_webapi_models_Response = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_webapi_models_Response().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var this$5 = $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2));
  var statusCode = ((name === "default") ? "200" : name);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1;
  var result = $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$5, field, statusCode));
  var field$1 = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Responses$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field$1, result);
  return result
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.nameField__Lamf_core_metamodel_Field = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Name$1
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  return this
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.servers__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().Servers$1))
});
function $as_Lamf_plugins_domain_webapi_models_Operation(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_webapi_models_Operation) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.webapi.models.Operation"))
}
function $isArrayOf_Lamf_plugins_domain_webapi_models_Operation(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_webapi_models_Operation)))
}
function $asArrayOf_Lamf_plugins_domain_webapi_models_Operation(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_webapi_models_Operation(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.webapi.models.Operation;", depth))
}
var $d_Lamf_plugins_domain_webapi_models_Operation = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_models_Operation: 0
}, false, "amf.plugins.domain.webapi.models.Operation", {
  Lamf_plugins_domain_webapi_models_Operation: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_plugins_domain_webapi_models_ExtensibleWebApiDomainElement: 1,
  Lamf_plugins_domain_webapi_models_ServerContainer: 1,
  Lamf_plugins_domain_webapi_models_DocumentedElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_webapi_models_Operation.prototype.$classData = $d_Lamf_plugins_domain_webapi_models_Operation;
function $f_sc_IndexedSeqOptimized__head__O($thiz) {
  return ($f_sc_IndexedSeqOptimized__isEmpty__Z($thiz) ? $thiz.iterator__sc_Iterator().next__O() : $thiz.apply__I__O(0))
}
function $f_sc_IndexedSeqOptimized__lengthCompare__I__I($thiz, len) {
  return (($thiz.length__I() - len) | 0)
}
function $f_sc_IndexedSeqOptimized__sameElements__sc_GenIterable__Z($thiz, that) {
  if ($is_sc_IndexedSeq(that)) {
    var x2 = $as_sc_IndexedSeq(that);
    var len = $thiz.length__I();
    if ((len === x2.length__I())) {
      var i = 0;
      while (((i < len) && $m_sr_BoxesRunTime$().equals__O__O__Z($thiz.apply__I__O(i), x2.apply__I__O(i)))) {
        i = ((1 + i) | 0)
      };
      return (i === len)
    } else {
      return false
    }
  } else {
    return $f_sc_IterableLike__sameElements__sc_GenIterable__Z($thiz, that)
  }
}
function $f_sc_IndexedSeqOptimized__exists__F1__Z($thiz, p) {
  return ($f_sc_IndexedSeqOptimized__prefixLengthImpl__psc_IndexedSeqOptimized__F1__Z__I($thiz, p, false) !== $thiz.length__I())
}
function $f_sc_IndexedSeqOptimized__toList__sci_List($thiz) {
  var i = (((-1) + $thiz.length__I()) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$1 = result;
    var x = $thiz.apply__I__O(i);
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$1);
    i = (((-1) + i) | 0)
  };
  return result
}
function $f_sc_IndexedSeqOptimized__isEmpty__Z($thiz) {
  return ($thiz.length__I() === 0)
}
function $f_sc_IndexedSeqOptimized__prefixLengthImpl__psc_IndexedSeqOptimized__F1__Z__I($thiz, p, expectTrue) {
  var i = 0;
  while (((i < $thiz.length__I()) && ($uZ(p.apply__O__O($thiz.apply__I__O(i))) === expectTrue))) {
    i = ((1 + i) | 0)
  };
  return i
}
function $f_sc_IndexedSeqOptimized__dropWhile__F1__O($thiz, p) {
  return $thiz.drop__I__O($f_sc_IndexedSeqOptimized__segmentLength__F1__I__I($thiz, p, 0))
}
function $f_sc_IndexedSeqOptimized__forall__F1__Z($thiz, p) {
  return ($f_sc_IndexedSeqOptimized__prefixLengthImpl__psc_IndexedSeqOptimized__F1__Z__I($thiz, p, true) === $thiz.length__I())
}
function $f_sc_IndexedSeqOptimized__init__O($thiz) {
  return (($thiz.length__I() > 0) ? $thiz.slice__I__I__O(0, (((-1) + $thiz.length__I()) | 0)) : $thiz.scala$collection$IndexedSeqOptimized$$super$init__O())
}
function $f_sc_IndexedSeqOptimized__foreach__F1__V($thiz, f) {
  var i = 0;
  var len = $thiz.length__I();
  while ((i < len)) {
    f.apply__O__O($thiz.apply__I__O(i));
    i = ((1 + i) | 0)
  }
}
function $f_sc_IndexedSeqOptimized__indexWhere__F1__I__I($thiz, p, from) {
  var start = ((from > 0) ? from : 0);
  var len = $thiz.length__I();
  var i = start;
  while (true) {
    if ((i < len)) {
      var arg1 = $thiz.apply__I__O(i);
      var jsx$1 = (!$uZ(p.apply__O__O(arg1)))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      i = ((1 + i) | 0)
    } else {
      break
    }
  };
  var n = ((start + ((i - start) | 0)) | 0);
  return $f_sc_IndexedSeqOptimized__negLength__psc_IndexedSeqOptimized__I__I($thiz, n)
}
function $f_sc_IndexedSeqOptimized__takeWhile__F1__O($thiz, p) {
  return $thiz.take__I__O($f_sc_IndexedSeqOptimized__segmentLength__F1__I__I($thiz, p, 0))
}
function $f_sc_IndexedSeqOptimized__slice__I__I__O($thiz, from, until) {
  var lo = ((from > 0) ? from : 0);
  var x = ((until > 0) ? until : 0);
  var y = $thiz.length__I();
  var hi = ((x < y) ? x : y);
  var x$1 = ((hi - lo) | 0);
  var elems = ((x$1 > 0) ? x$1 : 0);
  var b = $thiz.newBuilder__scm_Builder();
  b.sizeHint__I__V(elems);
  var i = lo;
  while ((i < hi)) {
    b.$$plus$eq__O__scm_Builder($thiz.apply__I__O(i));
    i = ((1 + i) | 0)
  };
  return b.result__O()
}
function $f_sc_IndexedSeqOptimized__reverse__O($thiz) {
  var b = $thiz.newBuilder__scm_Builder();
  b.sizeHint__I__V($thiz.length__I());
  var i = $thiz.length__I();
  while ((i > 0)) {
    i = (((-1) + i) | 0);
    b.$$plus$eq__O__scm_Builder($thiz.apply__I__O(i))
  };
  return b.result__O()
}
function $f_sc_IndexedSeqOptimized__find__F1__s_Option($thiz, p) {
  var len = $thiz.length__I();
  var i = 0;
  while (true) {
    if ((i < len)) {
      var arg1 = $thiz.apply__I__O(i);
      var jsx$1 = (!$uZ(p.apply__O__O(arg1)))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      i = ((1 + i) | 0)
    } else {
      break
    }
  };
  var i$1 = i;
  return ((i$1 < $thiz.length__I()) ? new $c_s_Some().init___O($thiz.apply__I__O(i$1)) : $m_s_None$())
}
function $f_sc_IndexedSeqOptimized__span__F1__T2($thiz, p) {
  return $thiz.splitAt__I__T2($f_sc_IndexedSeqOptimized__segmentLength__F1__I__I($thiz, p, 0))
}
function $f_sc_IndexedSeqOptimized__zipWithIndex__scg_CanBuildFrom__O($thiz, bf) {
  var b = bf.apply__O__scm_Builder($thiz.repr__O());
  var len = $thiz.length__I();
  b.sizeHint__I__V(len);
  var i = 0;
  while ((i < len)) {
    b.$$plus$eq__O__scm_Builder(new $c_T2().init___O__O($thiz.apply__I__O(i), i));
    i = ((1 + i) | 0)
  };
  return b.result__O()
}
function $f_sc_IndexedSeqOptimized__splitAt__I__T2($thiz, n) {
  return new $c_T2().init___O__O($thiz.take__I__O(n), $thiz.drop__I__O(n))
}
function $f_sc_IndexedSeqOptimized__last__O($thiz) {
  return (($thiz.length__I() > 0) ? $thiz.apply__I__O((((-1) + $thiz.length__I()) | 0)) : $thiz.scala$collection$IndexedSeqOptimized$$super$last__O())
}
function $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O($thiz, start, end, z, op) {
  _foldl: while (true) {
    if ((start === end)) {
      return z
    } else {
      var temp$start = ((1 + start) | 0);
      var temp$z = op.apply__O__O__O(z, $thiz.apply__I__O(start));
      start = temp$start;
      z = temp$z;
      continue _foldl
    }
  }
}
function $f_sc_IndexedSeqOptimized__tail__O($thiz) {
  return ($f_sc_IndexedSeqOptimized__isEmpty__Z($thiz) ? $thiz.scala$collection$IndexedSeqOptimized$$super$tail__O() : $thiz.slice__I__I__O(1, $thiz.length__I()))
}
function $f_sc_IndexedSeqOptimized__copyToArray__O__I__I__V($thiz, xs, start, len) {
  var i = 0;
  var j = start;
  var x = $thiz.length__I();
  var x$1 = ((x < len) ? x : len);
  var that = (($m_sr_ScalaRunTime$().array$undlength__O__I(xs) - start) | 0);
  var end = ((x$1 < that) ? x$1 : that);
  while ((i < end)) {
    $m_sr_ScalaRunTime$().array$undupdate__O__I__O__V(xs, j, $thiz.apply__I__O(i));
    i = ((1 + i) | 0);
    j = ((1 + j) | 0)
  }
}
function $f_sc_IndexedSeqOptimized__negLength__psc_IndexedSeqOptimized__I__I($thiz, n) {
  return ((n >= $thiz.length__I()) ? (-1) : n)
}
function $f_sc_IndexedSeqOptimized__segmentLength__F1__I__I($thiz, p, from) {
  var len = $thiz.length__I();
  var i = from;
  while (((i < len) && $uZ(p.apply__O__O($thiz.apply__I__O(i))))) {
    i = ((1 + i) | 0)
  };
  return ((i - from) | 0)
}
function $f_sc_IndexedSeqOptimized__dropRight__I__O($thiz, n) {
  return $thiz.slice__I__I__O(0, (($thiz.length__I() - ((n > 0) ? n : 0)) | 0))
}
function $f_sc_IndexedSeqOptimized__reduceLeft__F2__O($thiz, op) {
  if (($thiz.length__I() > 0)) {
    var start = 1;
    var end = $thiz.length__I();
    var z = $thiz.apply__I__O(0);
    return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O($thiz, start, end, z, op)
  } else {
    return $f_sc_TraversableOnce__reduceLeft__F2__O($thiz, op)
  }
}
function $f_sc_IndexedSeqOptimized__zip__sc_GenIterable__scg_CanBuildFrom__O($thiz, that, bf) {
  if ($is_sc_IndexedSeq(that)) {
    var x2 = $as_sc_IndexedSeq(that);
    var b = bf.apply__O__scm_Builder($thiz.repr__O());
    var i = 0;
    var x = $thiz.length__I();
    var that$1 = x2.length__I();
    var len = ((x < that$1) ? x : that$1);
    b.sizeHint__I__V(len);
    while ((i < len)) {
      b.$$plus$eq__O__scm_Builder(new $c_T2().init___O__O($thiz.apply__I__O(i), x2.apply__I__O(i)));
      i = ((1 + i) | 0)
    };
    return b.result__O()
  } else {
    return $thiz.scala$collection$IndexedSeqOptimized$$super$zip__sc_GenIterable__scg_CanBuildFrom__O(that, bf)
  }
}
function $f_sc_LinearSeqOptimized__lengthCompare__I__I($thiz, len) {
  if ((len < 0)) {
    return 1
  } else {
    var i = 0;
    var xs = $thiz;
    return $f_sc_LinearSeqOptimized__loop$1__psc_LinearSeqOptimized__I__sc_LinearSeqOptimized__I__I($thiz, i, xs, len)
  }
}
function $f_sc_LinearSeqOptimized__apply__I__O($thiz, n) {
  var rest = $thiz.drop__I__sc_LinearSeqOptimized(n);
  if (((n < 0) || rest.isEmpty__Z())) {
    throw new $c_jl_IndexOutOfBoundsException().init___T(("" + n))
  };
  return rest.head__O()
}
function $f_sc_LinearSeqOptimized__dropRight__I__sc_LinearSeqOptimized($thiz, n) {
  var b = $thiz.newBuilder__scm_Builder();
  var these = $thiz;
  var lead = $thiz.drop__I__sc_LinearSeqOptimized(n);
  while ((!lead.isEmpty__Z())) {
    b.$$plus$eq__O__scm_Builder(these.head__O());
    these = $as_sc_LinearSeqOptimized(these.tail__O());
    lead = $as_sc_LinearSeqOptimized(lead.tail__O())
  };
  return $as_sc_LinearSeqOptimized(b.result__O())
}
function $f_sc_LinearSeqOptimized__sameElements__sc_GenIterable__Z($thiz, that) {
  if ($is_sc_LinearSeq(that)) {
    var x2 = $as_sc_LinearSeq(that);
    if (($thiz === x2)) {
      return true
    } else {
      var these = $thiz;
      var those = x2;
      while ((((!these.isEmpty__Z()) && (!those.isEmpty__Z())) && $m_sr_BoxesRunTime$().equals__O__O__Z(these.head__O(), those.head__O()))) {
        these = $as_sc_LinearSeqOptimized(these.tail__O());
        those = $as_sc_LinearSeq(those.tail__O())
      };
      return (these.isEmpty__Z() && those.isEmpty__Z())
    }
  } else {
    return $f_sc_IterableLike__sameElements__sc_GenIterable__Z($thiz, that)
  }
}
function $f_sc_LinearSeqOptimized__exists__F1__Z($thiz, p) {
  var these = $thiz;
  while ((!these.isEmpty__Z())) {
    if ($uZ(p.apply__O__O(these.head__O()))) {
      return true
    };
    these = $as_sc_LinearSeqOptimized(these.tail__O())
  };
  return false
}
function $f_sc_LinearSeqOptimized__drop__I__sc_LinearSeqOptimized($thiz, n) {
  var these = $thiz;
  var count = n;
  while (((!these.isEmpty__Z()) && (count > 0))) {
    these = $as_sc_LinearSeqOptimized(these.tail__O());
    count = (((-1) + count) | 0)
  };
  return these
}
function $f_sc_LinearSeqOptimized__takeWhile__F1__sc_LinearSeqOptimized($thiz, p) {
  var b = $thiz.newBuilder__scm_Builder();
  var these = $thiz;
  while (((!these.isEmpty__Z()) && $uZ(p.apply__O__O(these.head__O())))) {
    b.$$plus$eq__O__scm_Builder(these.head__O());
    these = $as_sc_LinearSeqOptimized(these.tail__O())
  };
  return $as_sc_LinearSeqOptimized(b.result__O())
}
function $f_sc_LinearSeqOptimized__forall__F1__Z($thiz, p) {
  var these = $thiz;
  while ((!these.isEmpty__Z())) {
    if ((!$uZ(p.apply__O__O(these.head__O())))) {
      return false
    };
    these = $as_sc_LinearSeqOptimized(these.tail__O())
  };
  return true
}
function $f_sc_LinearSeqOptimized__foreach__F1__V($thiz, f) {
  var these = $thiz;
  while ((!these.isEmpty__Z())) {
    f.apply__O__O(these.head__O());
    these = $as_sc_LinearSeqOptimized(these.tail__O())
  }
}
function $f_sc_LinearSeqOptimized__foldLeft__O__F2__O($thiz, z, op) {
  var acc = z;
  var these = $thiz;
  while ((!these.isEmpty__Z())) {
    acc = op.apply__O__O__O(acc, these.head__O());
    these = $as_sc_LinearSeqOptimized(these.tail__O())
  };
  return acc
}
function $f_sc_LinearSeqOptimized__indexWhere__F1__I__I($thiz, p, from) {
  var i = ((from > 0) ? from : 0);
  var these = $thiz.drop__I__sc_LinearSeqOptimized(from);
  while (true) {
    var this$3 = these;
    if ($f_sc_TraversableOnce__nonEmpty__Z(this$3)) {
      if ($uZ(p.apply__O__O(these.head__O()))) {
        return i
      };
      i = ((1 + i) | 0);
      these = $as_sc_LinearSeqOptimized(these.tail__O())
    } else {
      break
    }
  };
  return (-1)
}
function $f_sc_LinearSeqOptimized__span__F1__T2($thiz, p) {
  var these = $thiz;
  var b = $thiz.newBuilder__scm_Builder();
  while (((!these.isEmpty__Z()) && $uZ(p.apply__O__O(these.head__O())))) {
    b.$$plus$eq__O__scm_Builder(these.head__O());
    these = $as_sc_LinearSeqOptimized(these.tail__O())
  };
  return new $c_T2().init___O__O(b.result__O(), these)
}
function $f_sc_LinearSeqOptimized__find__F1__s_Option($thiz, p) {
  var these = $thiz;
  while ((!these.isEmpty__Z())) {
    if ($uZ(p.apply__O__O(these.head__O()))) {
      return new $c_s_Some().init___O(these.head__O())
    };
    these = $as_sc_LinearSeqOptimized(these.tail__O())
  };
  return $m_s_None$()
}
function $f_sc_LinearSeqOptimized__length__I($thiz) {
  var these = $thiz;
  var len = 0;
  while ((!these.isEmpty__Z())) {
    len = ((1 + len) | 0);
    these = $as_sc_LinearSeqOptimized(these.tail__O())
  };
  return len
}
function $f_sc_LinearSeqOptimized__last__O($thiz) {
  if ($thiz.isEmpty__Z()) {
    throw new $c_ju_NoSuchElementException().init___()
  };
  var these = $thiz;
  var nx = $as_sc_LinearSeqOptimized(these.tail__O());
  while ((!nx.isEmpty__Z())) {
    these = nx;
    nx = $as_sc_LinearSeqOptimized(nx.tail__O())
  };
  return these.head__O()
}
function $f_sc_LinearSeqOptimized__contains__O__Z($thiz, elem) {
  var these = $thiz;
  while ((!these.isEmpty__Z())) {
    if ($m_sr_BoxesRunTime$().equals__O__O__Z(these.head__O(), elem)) {
      return true
    };
    these = $as_sc_LinearSeqOptimized(these.tail__O())
  };
  return false
}
function $f_sc_LinearSeqOptimized__isDefinedAt__I__Z($thiz, x) {
  return ((x >= 0) && ($f_sc_LinearSeqOptimized__lengthCompare__I__I($thiz, x) > 0))
}
function $f_sc_LinearSeqOptimized__take__I__sc_LinearSeqOptimized($thiz, n) {
  var b = $thiz.newBuilder__scm_Builder();
  var i = 0;
  var these = $thiz;
  while (((!these.isEmpty__Z()) && (i < n))) {
    i = ((1 + i) | 0);
    b.$$plus$eq__O__scm_Builder(these.head__O());
    these = $as_sc_LinearSeqOptimized(these.tail__O())
  };
  return $as_sc_LinearSeqOptimized(b.result__O())
}
function $f_sc_LinearSeqOptimized__loop$1__psc_LinearSeqOptimized__I__sc_LinearSeqOptimized__I__I($thiz, i, xs, len$1) {
  _loop: while (true) {
    if ((i === len$1)) {
      return (xs.isEmpty__Z() ? 0 : 1)
    } else if (xs.isEmpty__Z()) {
      return (-1)
    } else {
      var temp$i = ((1 + i) | 0);
      var temp$xs = $as_sc_LinearSeqOptimized(xs.tail__O());
      i = temp$i;
      xs = temp$xs;
      continue _loop
    }
  }
}
function $f_sc_LinearSeqOptimized__reduceLeft__F2__O($thiz, op) {
  if ($thiz.isEmpty__Z()) {
    throw new $c_jl_UnsupportedOperationException().init___T("empty.reduceLeft")
  } else {
    return $as_sc_LinearSeqOptimized($thiz.tail__O()).foldLeft__O__F2__O($thiz.head__O(), op)
  }
}
function $is_sc_LinearSeqOptimized(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_LinearSeqOptimized)))
}
function $as_sc_LinearSeqOptimized(obj) {
  return (($is_sc_LinearSeqOptimized(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.LinearSeqOptimized"))
}
function $isArrayOf_sc_LinearSeqOptimized(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_LinearSeqOptimized)))
}
function $asArrayOf_sc_LinearSeqOptimized(obj, depth) {
  return (($isArrayOf_sc_LinearSeqOptimized(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.LinearSeqOptimized;", depth))
}
function $f_sc_SetLike__isEmpty__Z($thiz) {
  return ($thiz.size__I() === 0)
}
function $f_sc_SetLike__toBuffer__scm_Buffer($thiz) {
  var result = new $c_scm_ArrayBuffer().init___I($thiz.size__I());
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, result$1) {
    return (function(x$2$2) {
      return result$1.$$plus$eq__O__scm_ArrayBuffer(x$2$2)
    })
  })($thiz, result)));
  return result
}
function $f_sc_SetLike__toSeq__sc_Seq($thiz) {
  if ($thiz.isEmpty__Z()) {
    var this$1 = $m_s_package$().Vector$1;
    return this$1.NIL$6
  } else {
    $m_s_package$();
    var vb = new $c_sci_VectorBuilder().init___();
    $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, vb$1) {
      return (function(x$1$2) {
        return vb$1.$$plus$eq__O__scm_Builder(x$1$2)
      })
    })($thiz, vb)));
    return vb.result__sci_Vector()
  }
}
function $f_sc_SetLike__$$plus$plus__sc_GenTraversableOnce__sc_Set($thiz, elems) {
  var x$3 = $as_sc_Set($thiz);
  return $as_sc_Set(elems.seq__sc_TraversableOnce().$$div$colon__O__F2__O(x$3, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(x$4$2, x$5$2) {
      var x$4 = $as_sc_Set(x$4$2);
      return x$4.$$plus__O__sc_Set(x$5$2)
    })
  })($thiz))))
}
function $is_sc_SetLike(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_SetLike)))
}
function $as_sc_SetLike(obj) {
  return (($is_sc_SetLike(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.SetLike"))
}
function $isArrayOf_sc_SetLike(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_SetLike)))
}
function $asArrayOf_sc_SetLike(obj, depth) {
  return (($isArrayOf_sc_SetLike(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.SetLike;", depth))
}
function $f_sc_TraversableViewLike$Transformed__viewIdString__T($thiz) {
  return (("" + $thiz.scala$collection$TraversableViewLike$Transformed$$$outer__sc_TraversableViewLike().viewIdString__T()) + $thiz.viewIdentifier__T())
}
function $f_sc_TraversableViewLike$Transformed__headOption__s_Option($thiz) {
  var nonLocalReturnKey1 = new $c_O().init___();
  try {
    $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, nonLocalReturnKey1$1) {
      return (function(x$2) {
        throw new $c_sr_NonLocalReturnControl().init___O__O(nonLocalReturnKey1$1, new $c_s_Some().init___O(x$2))
      })
    })($thiz, nonLocalReturnKey1)));
    return $m_s_None$()
  } catch (e) {
    if ((e instanceof $c_sr_NonLocalReturnControl)) {
      var ex = $as_sr_NonLocalReturnControl(e);
      if ((ex.key$2 === nonLocalReturnKey1)) {
        return $as_s_Option(ex.value__O())
      } else {
        throw ex
      }
    } else {
      throw e
    }
  }
}
function $f_sc_TraversableViewLike$Transformed__last__O($thiz) {
  var empty = new $c_sr_BooleanRef().init___Z(true);
  var result = new $c_sr_ObjectRef().init___O(null);
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, empty$1, result$1) {
    return (function(x$2) {
      empty$1.elem$1 = false;
      result$1.elem$1 = x$2
    })
  })($thiz, empty, result)));
  if (empty.elem$1) {
    throw new $c_ju_NoSuchElementException().init___T("last of empty traversable")
  } else {
    return result.elem$1
  }
}
/** @constructor */
function $c_Lamf_client_model_domain_ArrayShape() {
  $c_Lamf_client_model_domain_DataArrangeShape.call(this);
  this.$$undinternal$3 = null
}
$c_Lamf_client_model_domain_ArrayShape.prototype = new $h_Lamf_client_model_domain_DataArrangeShape();
$c_Lamf_client_model_domain_ArrayShape.prototype.constructor = $c_Lamf_client_model_domain_ArrayShape;
/** @constructor */
function $h_Lamf_client_model_domain_ArrayShape() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_ArrayShape.prototype = $c_Lamf_client_model_domain_ArrayShape.prototype;
$c_Lamf_client_model_domain_ArrayShape.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_ArrayShape.prototype.init___Lamf_plugins_domain_shapes_models_ArrayShape.call(this, new $c_Lamf_plugins_domain_shapes_models_ArrayShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_ArrayShape.prototype.productPrefix__T = (function() {
  return "ArrayShape"
});
$c_Lamf_client_model_domain_ArrayShape.prototype.$$js$exported$prop$contains__O = (function() {
  return this.contains__Lamf_client_model_domain_Shape()
});
$c_Lamf_client_model_domain_ArrayShape.prototype.$$undinternal__Lamf_core_model_domain_Shape = (function() {
  return this.$$undinternal__Lamf_plugins_domain_shapes_models_ArrayShape()
});
$c_Lamf_client_model_domain_ArrayShape.prototype.init___Lamf_plugins_domain_shapes_models_ArrayShape = (function(_internal) {
  this.$$undinternal$3 = _internal;
  $c_Lamf_client_model_domain_AnyShape.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape.call(this, _internal);
  return this
});
$c_Lamf_client_model_domain_ArrayShape.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_ArrayShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_ArrayShape)) {
    var ArrayShape$1 = $as_Lamf_client_model_domain_ArrayShape(x$1);
    var x = this.$$undinternal$3;
    var x$2 = ArrayShape$1.$$undinternal$3;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_ArrayShape.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal__Lamf_plugins_domain_shapes_models_ArrayShape()
});
$c_Lamf_client_model_domain_ArrayShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_ArrayShape.prototype.contains__Lamf_client_model_domain_Shape = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_ArrayShape();
  var from = $as_Lamf_core_model_domain_Shape(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Contains$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(from)
});
$c_Lamf_client_model_domain_ArrayShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_ArrayShape.prototype.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this.$$undinternal__Lamf_plugins_domain_shapes_models_ArrayShape()
});
$c_Lamf_client_model_domain_ArrayShape.prototype.items__Lamf_client_model_domain_Shape = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_ArrayShape();
  var from = $as_Lamf_core_model_domain_Shape(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(from)
});
$c_Lamf_client_model_domain_ArrayShape.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_ArrayShape()
});
$c_Lamf_client_model_domain_ArrayShape.prototype.$$undinternal__Lamf_plugins_domain_shapes_models_ArrayShape = (function() {
  return this.$$undinternal$3
});
$c_Lamf_client_model_domain_ArrayShape.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_ArrayShape()
});
$c_Lamf_client_model_domain_ArrayShape.prototype.$$js$exported$prop$items__O = (function() {
  return this.items__Lamf_client_model_domain_Shape()
});
$c_Lamf_client_model_domain_ArrayShape.prototype.$$undinternal__Lamf_plugins_domain_shapes_models_DataArrangementShape = (function() {
  return this.$$undinternal__Lamf_plugins_domain_shapes_models_ArrayShape()
});
$c_Lamf_client_model_domain_ArrayShape.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal__Lamf_plugins_domain_shapes_models_ArrayShape()
});
$c_Lamf_client_model_domain_ArrayShape.prototype.linkCopy__Lamf_client_model_domain_ArrayShape = (function() {
  var this$1 = this.$$undinternal__Lamf_plugins_domain_shapes_models_ArrayShape();
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$5 = new $c_Lamf_plugins_domain_shapes_models_ArrayShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this$1.id$1;
  return new $c_Lamf_client_model_domain_ArrayShape().init___Lamf_plugins_domain_shapes_models_ArrayShape($as_Lamf_plugins_domain_shapes_models_ArrayShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value)))
});
$c_Lamf_client_model_domain_ArrayShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_ArrayShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_ArrayShape.prototype.withContains__Lamf_client_model_domain_Shape__Lamf_client_model_domain_ArrayShape = (function(contains) {
  this.$$undinternal__Lamf_plugins_domain_shapes_models_ArrayShape().withContains__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_ArrayShape(($m_Lamf_client_convert_WebApiClientConverters$(), $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$(), contains.$$undinternal__Lamf_core_model_domain_Shape()));
  return this
});
$c_Lamf_client_model_domain_ArrayShape.prototype.linkCopy__Lamf_client_model_domain_AnyShape = (function() {
  return this.linkCopy__Lamf_client_model_domain_ArrayShape()
});
$c_Lamf_client_model_domain_ArrayShape.prototype.$$js$exported$meth$withContains__Lamf_client_model_domain_Shape__O = (function(contains) {
  return this.withContains__Lamf_client_model_domain_Shape__Lamf_client_model_domain_ArrayShape(contains)
});
$c_Lamf_client_model_domain_ArrayShape.prototype.withItems__Lamf_client_model_domain_Shape__Lamf_client_model_domain_ArrayShape = (function(items) {
  this.$$undinternal__Lamf_plugins_domain_shapes_models_ArrayShape().withItems__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_ArrayShape(($m_Lamf_client_convert_WebApiClientConverters$(), $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$(), items.$$undinternal__Lamf_core_model_domain_Shape()));
  return this
});
$c_Lamf_client_model_domain_ArrayShape.prototype.$$js$exported$meth$withItems__Lamf_client_model_domain_Shape__O = (function(items) {
  return this.withItems__Lamf_client_model_domain_Shape__Lamf_client_model_domain_ArrayShape(items)
});
$c_Lamf_client_model_domain_ArrayShape.prototype.withContains = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withContains__Lamf_client_model_domain_Shape__O(prep)
});
$c_Lamf_client_model_domain_ArrayShape.prototype.withItems = (function(arg) {
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  return this.$$js$exported$meth$withItems__Lamf_client_model_domain_Shape__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_ArrayShape.prototype, "contains", {
  "get": (function() {
    return this.$$js$exported$prop$contains__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_ArrayShape.prototype, "items", {
  "get": (function() {
    return this.$$js$exported$prop$items__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_ArrayShape(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_ArrayShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.ArrayShape"))
}
function $isArrayOf_Lamf_client_model_domain_ArrayShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_ArrayShape)))
}
function $asArrayOf_Lamf_client_model_domain_ArrayShape(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_ArrayShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.ArrayShape;", depth))
}
var $d_Lamf_client_model_domain_ArrayShape = new $TypeData().initClass({
  Lamf_client_model_domain_ArrayShape: 0
}, false, "amf.client.model.domain.ArrayShape", {
  Lamf_client_model_domain_ArrayShape: 1,
  Lamf_client_model_domain_DataArrangeShape: 1,
  Lamf_client_model_domain_AnyShape: 1,
  O: 1,
  Lamf_client_model_domain_Shape: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_ArrayShape.prototype.$classData = $d_Lamf_client_model_domain_ArrayShape;
/** @constructor */
function $c_Lamf_client_model_domain_DynamicBinding() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_DynamicBinding.prototype = new $h_O();
$c_Lamf_client_model_domain_DynamicBinding.prototype.constructor = $c_Lamf_client_model_domain_DynamicBinding;
/** @constructor */
function $h_Lamf_client_model_domain_DynamicBinding() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_DynamicBinding.prototype = $c_Lamf_client_model_domain_DynamicBinding.prototype;
$c_Lamf_client_model_domain_DynamicBinding.prototype.productPrefix__T = (function() {
  return "DynamicBinding"
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_DynamicBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_DynamicBinding.call(this, new $c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_DynamicBinding)) {
    var DynamicBinding$1 = $as_Lamf_client_model_domain_DynamicBinding(x$1);
    var x = this.$$undinternal$1;
    var x$2 = DynamicBinding$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.linkCopy__Lamf_client_model_domain_DynamicBinding = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$5 = new $c_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().DynamicBindingMatcher__Lamf_client_convert_DynamicBindingConverter$DynamicBindingMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_DynamicBinding__Lamf_client_model_domain_DynamicBinding(from)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_OperationBinding = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$meth$withDefinition__Lamf_client_model_domain_DataNode__O = (function(definition) {
  return this.withDefinition__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_DynamicBinding(definition)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_DynamicBinding = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_ServerBinding = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.type__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$().Type$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_DynamicBinding()
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$meth$withType__T__O = (function(type) {
  return this.withType__T__Lamf_client_model_domain_DynamicBinding(type)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_ChannelBinding = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_DynamicBinding()
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$prop$type__O = (function() {
  return this.type__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.withDefinition__Lamf_client_model_domain_DataNode__Lamf_client_model_domain_DynamicBinding = (function(definition) {
  var this$2 = this.$$undinternal$1;
  $m_Lamf_client_convert_WebApiClientConverters$();
  $m_Lamf_client_convert_WebApiClientConverters$().DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$();
  var definition$1 = definition.$$undinternal__Lamf_core_model_domain_DataNode();
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$().Definition$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this$2, field, definition$1));
  return this
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_MessageBinding = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.definition__Lamf_client_model_domain_DataNode = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_domain_DataNode(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$().Definition$1));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$();
  return m.asClient__Lamf_core_model_domain_DataNode__Lamf_client_model_domain_DataNode(from)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.withType__T__Lamf_client_model_domain_DynamicBinding = (function(type) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$().Type$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_DynamicBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, type));
  return this
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$prop$definition__O = (function() {
  return this.definition__Lamf_client_model_domain_DataNode()
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_DynamicBinding.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_DynamicBinding.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DynamicBinding.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DynamicBinding.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DynamicBinding.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_DynamicBinding.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DynamicBinding.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DynamicBinding.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.withType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withType__T__O(prep)
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.withDefinition = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DataNode(arg);
  return this.$$js$exported$meth$withDefinition__Lamf_client_model_domain_DataNode__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_DynamicBinding.prototype, "type", {
  "get": (function() {
    return this.$$js$exported$prop$type__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_DynamicBinding.prototype, "definition", {
  "get": (function() {
    return this.$$js$exported$prop$definition__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_DynamicBinding(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_DynamicBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.DynamicBinding"))
}
function $isArrayOf_Lamf_client_model_domain_DynamicBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_DynamicBinding)))
}
function $asArrayOf_Lamf_client_model_domain_DynamicBinding(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_DynamicBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.DynamicBinding;", depth))
}
var $d_Lamf_client_model_domain_DynamicBinding = new $TypeData().initClass({
  Lamf_client_model_domain_DynamicBinding: 0
}, false, "amf.client.model.domain.DynamicBinding", {
  Lamf_client_model_domain_DynamicBinding: 1,
  O: 1,
  Lamf_client_model_domain_ServerBinding: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_OperationBinding: 1,
  Lamf_client_model_domain_ChannelBinding: 1,
  Lamf_client_model_domain_MessageBinding: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_DynamicBinding.prototype.$classData = $d_Lamf_client_model_domain_DynamicBinding;
/** @constructor */
function $c_Lamf_client_model_domain_EmptyBinding() {
  $c_O.call(this);
  this.$$undinternal$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_model_domain_EmptyBinding.prototype = new $h_O();
$c_Lamf_client_model_domain_EmptyBinding.prototype.constructor = $c_Lamf_client_model_domain_EmptyBinding;
/** @constructor */
function $h_Lamf_client_model_domain_EmptyBinding() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_EmptyBinding.prototype = $c_Lamf_client_model_domain_EmptyBinding.prototype;
$c_Lamf_client_model_domain_EmptyBinding.prototype.productPrefix__T = (function() {
  return "EmptyBinding"
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  $c_Lamf_client_model_domain_EmptyBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_EmptyBinding.call(this, new $c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations));
  return this
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$js$exported$prop$linkTarget__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkTarget__sjs_js_UndefOr(this)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$js$exported$meth$withIsExternalLink__Z__O = (function(isExternalLink) {
  return $f_Lamf_client_model_domain_DomainElement__withIsExternalLink__Z__Lamf_client_model_domain_DomainElement(this, isExternalLink)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$js$exported$meth$withLinkLabel__T__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__withLinkLabel__T__Lamf_client_model_domain_DomainElement(this, label)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$js$exported$meth$graph__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__graph__Lamf_client_model_domain_Graph(this)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$js$exported$meth$withExtendsNode__sjs_js_Array__O = (function(extension) {
  return $f_Lamf_client_model_domain_DomainElement__withExtendsNode__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extension)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_EmptyBinding)) {
    var EmptyBinding$1 = $as_Lamf_client_model_domain_EmptyBinding(x$1);
    var x = this.$$undinternal$1;
    var x$2 = EmptyBinding$1.$$undinternal$1;
    return (x === x$2)
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$js$exported$meth$link$default$1__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.linkCopy__Lamf_client_model_domain_EmptyBinding = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$5 = new $c_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().EmptyBindingMatcher__Lamf_client_convert_EmptyBindingConverter$EmptyBindingMatcher$();
  return m.asClient__Lamf_plugins_domain_webapi_models_bindings_EmptyBinding__Lamf_client_model_domain_EmptyBinding(from)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_OperationBinding = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$js$exported$prop$isLink__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__isLink__Z(this)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$js$exported$prop$position__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__position__Lamf_core_parser_Range(this)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$js$exported$meth$withId__T__O = (function(id) {
  return $f_Lamf_client_model_domain_DomainElement__withId__T__Lamf_client_model_domain_DomainElement(this, id)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$js$exported$prop$isExternalLink__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__isExternalLink__Lamf_client_model_BoolField(this)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_ServerBinding = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.type__Lamf_client_model_StrField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$1;
  var from = $as_Lamf_core_model_StrField(this$1.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$().Type$1));
  $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$();
  return new $c_Lamf_client_model_StrField().init___Lamf_core_model_StrField(from)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_EmptyBinding()
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$js$exported$prop$customDomainProperties__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__customDomainProperties__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$js$exported$meth$withType__T__O = (function(type) {
  return this.withType__T__Lamf_client_model_domain_EmptyBinding(type)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_ChannelBinding = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_EmptyBinding()
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$js$exported$meth$link__s_Option__O = (function(label) {
  return $f_Lamf_client_model_domain_Linkable__link__s_Option__O(this, label)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$js$exported$prop$extendsNode__O = (function() {
  return $f_Lamf_client_model_domain_DomainElement__extendsNode__sjs_js_Array(this)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$js$exported$prop$type__O = (function() {
  return this.type__Lamf_client_model_StrField()
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$js$exported$meth$annotations__O = (function() {
  return $f_Lamf_client_model_AmfObjectWrapper__annotations__Lamf_client_model_Annotations(this)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.withType__T__Lamf_client_model_domain_EmptyBinding = (function(type) {
  var this$1 = this.$$undinternal$1;
  var field = $m_Lamf_plugins_domain_webapi_metamodel_bindings_DynamicBindingModel$().Type$1;
  $as_Lamf_plugins_domain_webapi_models_bindings_EmptyBinding($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$1, field, type));
  return this
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O = (function(extensions) {
  return $f_Lamf_client_model_domain_DomainElement__withCustomDomainProperties__sjs_js_Array__Lamf_client_model_domain_DomainElement(this, extensions)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.init___Lamf_plugins_domain_webapi_models_bindings_EmptyBinding = (function(_internal) {
  this.$$undinternal$1 = _internal;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$undinternal__Lamf_plugins_domain_webapi_models_bindings_MessageBinding = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$js$exported$prop$id__O = (function() {
  return this.$$undinternal$1.id$1
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$1
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$js$exported$prop$linkLabel__O = (function() {
  return $f_Lamf_client_model_domain_Linkable__linkLabel__Lamf_client_model_StrField(this)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O = (function(target) {
  return $f_Lamf_client_model_domain_Linkable__withLinkTarget__Lamf_client_model_domain_DomainElement__Lamf_client_model_domain_DomainElement(this, target)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.annotations = (function() {
  return this.$$js$exported$meth$annotations__O()
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.graph = (function() {
  return this.$$js$exported$meth$graph__O()
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.withIsExternalLink = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withIsExternalLink__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_EmptyBinding.prototype, "isExternalLink", {
  "get": (function() {
    return this.$$js$exported$prop$isExternalLink__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.withId = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withId__T__O(prep)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.withExtendsNode = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withExtendsNode__sjs_js_Array__O(prep)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.withCustomDomainProperties = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withCustomDomainProperties__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_EmptyBinding.prototype, "position", {
  "get": (function() {
    return this.$$js$exported$prop$position__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_EmptyBinding.prototype, "id", {
  "get": (function() {
    return this.$$js$exported$prop$id__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_EmptyBinding.prototype, "extendsNode", {
  "get": (function() {
    return this.$$js$exported$prop$extendsNode__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_EmptyBinding.prototype, "customDomainProperties", {
  "get": (function() {
    return this.$$js$exported$prop$customDomainProperties__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.link = (function() {
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  var prep = ((rest[0] === (void 0)) ? this.$$js$exported$meth$link$default$1__s_Option() : $as_s_Option(rest[0]));
  return this.$$js$exported$meth$link__s_Option__O(prep)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.withLinkLabel = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withLinkLabel__T__O(prep)
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.withLinkTarget = (function(arg) {
  var prep = $as_Lamf_client_model_domain_DomainElement(arg);
  return this.$$js$exported$meth$withLinkTarget__Lamf_client_model_domain_DomainElement__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_EmptyBinding.prototype, "linkLabel", {
  "get": (function() {
    return this.$$js$exported$prop$linkLabel__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_EmptyBinding.prototype, "isLink", {
  "get": (function() {
    return this.$$js$exported$prop$isLink__O()
  }),
  "configurable": true
});
Object.defineProperty($c_Lamf_client_model_domain_EmptyBinding.prototype, "linkTarget", {
  "get": (function() {
    return this.$$js$exported$prop$linkTarget__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.linkCopy = (function() {
  return this.$$js$exported$meth$linkCopy__O()
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.withType = (function(arg) {
  var prep = $as_T(arg);
  return this.$$js$exported$meth$withType__T__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_EmptyBinding.prototype, "type", {
  "get": (function() {
    return this.$$js$exported$prop$type__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_EmptyBinding(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_EmptyBinding) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.EmptyBinding"))
}
function $isArrayOf_Lamf_client_model_domain_EmptyBinding(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_EmptyBinding)))
}
function $asArrayOf_Lamf_client_model_domain_EmptyBinding(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_EmptyBinding(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.EmptyBinding;", depth))
}
var $d_Lamf_client_model_domain_EmptyBinding = new $TypeData().initClass({
  Lamf_client_model_domain_EmptyBinding: 0
}, false, "amf.client.model.domain.EmptyBinding", {
  Lamf_client_model_domain_EmptyBinding: 1,
  O: 1,
  Lamf_client_model_domain_ServerBinding: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_OperationBinding: 1,
  Lamf_client_model_domain_ChannelBinding: 1,
  Lamf_client_model_domain_MessageBinding: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_EmptyBinding.prototype.$classData = $d_Lamf_client_model_domain_EmptyBinding;
/** @constructor */
function $c_Lamf_client_model_domain_TupleShape() {
  $c_Lamf_client_model_domain_DataArrangeShape.call(this);
  this.$$undinternal$3 = null
}
$c_Lamf_client_model_domain_TupleShape.prototype = new $h_Lamf_client_model_domain_DataArrangeShape();
$c_Lamf_client_model_domain_TupleShape.prototype.constructor = $c_Lamf_client_model_domain_TupleShape;
/** @constructor */
function $h_Lamf_client_model_domain_TupleShape() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_TupleShape.prototype = $c_Lamf_client_model_domain_TupleShape.prototype;
$c_Lamf_client_model_domain_TupleShape.prototype.withClosedItems__Z__Lamf_client_model_domain_TupleShape = (function(closedItems) {
  var this$1 = this.$$undinternal$3;
  var field = $m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().ClosedItems$2;
  $as_Lamf_plugins_domain_shapes_models_TupleShape($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this$1, field, closedItems));
  return this
});
$c_Lamf_client_model_domain_TupleShape.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  $c_Lamf_client_model_domain_TupleShape.prototype.init___Lamf_plugins_domain_shapes_models_TupleShape.call(this, new $c_Lamf_plugins_domain_shapes_models_TupleShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations));
  return this
});
$c_Lamf_client_model_domain_TupleShape.prototype.productPrefix__T = (function() {
  return "TupleShape"
});
$c_Lamf_client_model_domain_TupleShape.prototype.$$undinternal__Lamf_core_model_domain_Shape = (function() {
  return this.$$undinternal$3
});
$c_Lamf_client_model_domain_TupleShape.prototype.productArity__I = (function() {
  return 1
});
$c_Lamf_client_model_domain_TupleShape.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$3
});
$c_Lamf_client_model_domain_TupleShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_client_model_domain_TupleShape)) {
    var TupleShape$1 = $as_Lamf_client_model_domain_TupleShape(x$1);
    var x = this.$$undinternal$3;
    var x$2 = TupleShape$1.$$undinternal$3;
    return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
  } else {
    return false
  }
});
$c_Lamf_client_model_domain_TupleShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.$$undinternal$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_client_model_domain_TupleShape.prototype.additionalItemsSchema__Lamf_client_model_domain_Shape = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$3;
  var from = $as_Lamf_core_model_domain_Shape(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().AdditionalItemsSchema$2));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return m.asClient__Lamf_core_model_domain_Shape__Lamf_client_model_domain_Shape(from)
});
$c_Lamf_client_model_domain_TupleShape.prototype.linkCopy__Lamf_client_model_domain_TupleShape = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$3;
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$5 = new $c_Lamf_plugins_domain_shapes_models_TupleShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this$1.id$1;
  var from = $as_Lamf_plugins_domain_shapes_models_TupleShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().TupleShapeMatcher__Lamf_client_convert_TupleShapeConverter$TupleShapeMatcher$();
  return m.asClient__Lamf_plugins_domain_shapes_models_TupleShape__Lamf_client_model_domain_TupleShape(from)
});
$c_Lamf_client_model_domain_TupleShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_client_model_domain_TupleShape.prototype.closedItems__Lamf_client_model_BoolField = (function() {
  $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$3;
  var from = $as_Lamf_core_model_BoolField(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().ClosedItems$2));
  $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$();
  return new $c_Lamf_client_model_BoolField().init___Lamf_core_model_BoolField(from)
});
$c_Lamf_client_model_domain_TupleShape.prototype.$$js$exported$prop$additionalItemsSchema__O = (function() {
  return this.additionalItemsSchema__Lamf_client_model_domain_Shape()
});
$c_Lamf_client_model_domain_TupleShape.prototype.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this.$$undinternal$3
});
$c_Lamf_client_model_domain_TupleShape.prototype.$$js$exported$meth$linkCopy__O = (function() {
  return this.linkCopy__Lamf_client_model_domain_TupleShape()
});
$c_Lamf_client_model_domain_TupleShape.prototype.items__sjs_js_Array = (function() {
  var this$2 = $m_Lamf_client_convert_WebApiClientConverters$();
  var this$1 = this.$$undinternal$3;
  var from = $as_sc_Seq(this$1.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().TupleItems$2));
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  return new $c_Lamf_client_convert_CollectionConverter$InternalSeqOps().init___Lamf_client_convert_CollectionConverter__sc_Seq__Lamf_client_convert_InternalClientMatcher(this$2, from, m).asClient__O()
});
$c_Lamf_client_model_domain_TupleShape.prototype.init___Lamf_plugins_domain_shapes_models_TupleShape = (function(_internal) {
  this.$$undinternal$3 = _internal;
  $c_Lamf_client_model_domain_AnyShape.prototype.init___Lamf_plugins_domain_shapes_models_AnyShape.call(this, _internal);
  return this
});
$c_Lamf_client_model_domain_TupleShape.prototype.linkCopy__Lamf_client_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_client_model_domain_TupleShape()
});
$c_Lamf_client_model_domain_TupleShape.prototype.$$js$exported$prop$items__O = (function() {
  return this.items__sjs_js_Array()
});
$c_Lamf_client_model_domain_TupleShape.prototype.$$undinternal__Lamf_plugins_domain_shapes_models_DataArrangementShape = (function() {
  return this.$$undinternal$3
});
$c_Lamf_client_model_domain_TupleShape.prototype.$$js$exported$meth$withItems__sjs_js_Array__O = (function(items) {
  return this.withItems__sjs_js_Array__Lamf_client_model_domain_TupleShape(items)
});
$c_Lamf_client_model_domain_TupleShape.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$3
});
$c_Lamf_client_model_domain_TupleShape.prototype.$$js$exported$prop$closedItems__O = (function() {
  return this.closedItems__Lamf_client_model_BoolField()
});
$c_Lamf_client_model_domain_TupleShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_client_model_domain_TupleShape.prototype.withItems__sjs_js_Array__Lamf_client_model_domain_TupleShape = (function(items) {
  var this$2 = this.$$undinternal$3;
  var this$1 = $m_Lamf_client_convert_WebApiClientConverters$();
  var m = $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$();
  var items$1 = new $c_Lamf_client_convert_CollectionConverter$ClientListOps().init___Lamf_client_convert_CollectionConverter__O__Lamf_client_convert_ClientInternalMatcher(this$1, items, m).asInternal__sc_Seq();
  var field = $m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().TupleItems$2;
  $as_Lamf_plugins_domain_shapes_models_TupleShape($f_Lamf_core_model_domain_AmfObject__setArray__Lamf_core_metamodel_Field__sc_Seq__Lamf_core_model_domain_AmfObject(this$2, field, items$1));
  return this
});
$c_Lamf_client_model_domain_TupleShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_client_model_domain_TupleShape.prototype.linkCopy__Lamf_client_model_domain_AnyShape = (function() {
  return this.linkCopy__Lamf_client_model_domain_TupleShape()
});
$c_Lamf_client_model_domain_TupleShape.prototype.$$js$exported$meth$withClosedItems__Z__O = (function(closedItems) {
  return this.withClosedItems__Z__Lamf_client_model_domain_TupleShape(closedItems)
});
Object.defineProperty($c_Lamf_client_model_domain_TupleShape.prototype, "additionalItemsSchema", {
  "get": (function() {
    return this.$$js$exported$prop$additionalItemsSchema__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_TupleShape.prototype.withClosedItems = (function(arg) {
  var prep = $uZ(arg);
  return this.$$js$exported$meth$withClosedItems__Z__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_TupleShape.prototype, "closedItems", {
  "get": (function() {
    return this.$$js$exported$prop$closedItems__O()
  }),
  "configurable": true
});
$c_Lamf_client_model_domain_TupleShape.prototype.withItems = (function(arg) {
  var prep = arg;
  return this.$$js$exported$meth$withItems__sjs_js_Array__O(prep)
});
Object.defineProperty($c_Lamf_client_model_domain_TupleShape.prototype, "items", {
  "get": (function() {
    return this.$$js$exported$prop$items__O()
  }),
  "configurable": true
});
function $as_Lamf_client_model_domain_TupleShape(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_TupleShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.TupleShape"))
}
function $isArrayOf_Lamf_client_model_domain_TupleShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_TupleShape)))
}
function $asArrayOf_Lamf_client_model_domain_TupleShape(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_TupleShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.TupleShape;", depth))
}
var $d_Lamf_client_model_domain_TupleShape = new $TypeData().initClass({
  Lamf_client_model_domain_TupleShape: 0
}, false, "amf.client.model.domain.TupleShape", {
  Lamf_client_model_domain_TupleShape: 1,
  Lamf_client_model_domain_DataArrangeShape: 1,
  Lamf_client_model_domain_AnyShape: 1,
  O: 1,
  Lamf_client_model_domain_Shape: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_TupleShape.prototype.$classData = $d_Lamf_client_model_domain_TupleShape;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_document_Dialect() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.amf$core$model$document$BaseUnit$$run$1 = null;
  this.raw$1 = null;
  this.platform$1 = null;
  this.id$1 = null
}
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_document_Dialect;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_document_Dialect() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype = $c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype;
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.productPrefix__T = (function() {
  return "Dialect"
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.allHeaders__sc_Seq = (function() {
  var jsx$8 = $m_sc_Seq$();
  var array = [this.header__T()];
  var jsx$7 = $as_sc_TraversableLike(jsx$8.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)));
  var xo = this.libraryHeader__s_Option();
  var jsx$6 = xo.toList__sci_List();
  var this$4 = $m_sc_Seq$();
  var jsx$5 = $as_sc_TraversableLike(jsx$7.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$6, this$4.ReusableCBFInstance$2));
  var jsx$4 = this.fragmentHeaders__sc_Seq();
  var this$5 = $m_sc_Seq$();
  var jsx$3 = $as_sc_TraversableLike(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$5.ReusableCBFInstance$2));
  var jsx$2 = $m_sc_Seq$();
  var array$1 = [this.patchHeader__T()];
  var jsx$1 = jsx$2.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array$1));
  var this$8 = $m_sc_Seq$();
  return $as_sc_Seq(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$8.ReusableCBFInstance$2))
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.hasValidHeader__Z = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Name$1));
  if ((!$f_Lamf_core_model_StrField__isNullOrEmpty__Z(this$1))) {
    var this$2 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Version$1));
    return (!$f_Lamf_core_model_StrField__isNullOrEmpty__Z(this$2))
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_Dialect)) {
    var Dialect$1 = $as_Lamf_plugins_document_vocabularies_model_document_Dialect(x$1);
    var x = this.fields$1;
    var x$2 = Dialect$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = Dialect$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.raw$und$eq__s_Option__V = (function(x$1) {
  this.raw$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$()
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.references__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().References$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.isPatchHeader__T__Z = (function(h) {
  return (this.patchHeader__T() === $m_Lorg_mulesoft_common_core_package$Strings$().stripSpaces$extension__T__T(h))
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.isFragmentHeader__T__Z = (function(h) {
  return this.fragmentHeaders__sc_Seq().contains__O__Z($m_Lorg_mulesoft_common_core_package$Strings$().stripSpaces$extension__T__T(h))
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit = (function(selector, transformation, errorHandler) {
  return $f_Lamf_core_model_document_BaseUnit__transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(this, selector, transformation, errorHandler)
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.amf$core$model$document$BaseUnit$$run__s_Option = (function() {
  return this.amf$core$model$document$BaseUnit$$run$1
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V = (function(x$1) {
  this.amf$core$model$document$BaseUnit$$run$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.declares__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Declares$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.isLibraryHeader__T__Z = (function(h) {
  return this.libraryHeader__s_Option().contains__O__Z($m_Lorg_mulesoft_common_core_package$Strings$().stripSpaces$extension__T__T(h))
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.nameAndVersion__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Name$1));
  var this$2 = this$1.option$1;
  var jsx$1 = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  var this$3 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Version$1));
  var this$4 = this$3.option$1;
  return ((jsx$1 + " ") + $as_T((this$4.isEmpty__Z() ? null : this$4.get__O())))
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.patchHeader__T = (function() {
  var x = this.header__T();
  var this$2 = new $c_sci_StringOps().init___T(x);
  return ("%Patch/" + $f_sci_StringLike__stripPrefix__T__T(this$2, "%"))
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.fragmentHeaders__sc_Seq = (function() {
  var this$1 = $m_s_Option$().apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1)));
  if (this$1.isEmpty__Z()) {
    var this$8 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var x$5 = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(arg1);
    var jsx$4 = $as_sc_Seq(x$5.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Fragments$1));
    var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(f$2) {
        var f = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(f$2);
        var jsx$3 = $m_Lorg_mulesoft_common_core_package$Strings$();
        var this$2 = $as_Lamf_core_model_StrField(f.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentMappingModel$().DocumentName$1));
        var this$3 = this$2.option$1;
        var str = $as_T((this$3.isEmpty__Z() ? null : this$3.get__O()));
        var jsx$2 = jsx$3.stripSpaces$extension__T__T(str);
        var x = $this.header__T();
        var this$6 = new $c_sci_StringOps().init___T(x);
        return ((("%" + jsx$2) + "/") + $f_sci_StringLike__stripPrefix__T__T(this$6, "%"))
      })
    })(this));
    var this$7 = $m_sc_Seq$();
    var this$8 = new $c_s_Some().init___O($as_sc_Seq(jsx$4.map__F1__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2)))
  };
  if (this$8.isEmpty__Z()) {
    $m_sc_Seq$();
    $m_sci_Seq$();
    var this$11 = new $c_scm_ListBuffer().init___();
    var jsx$5 = this$11.toList__sci_List()
  } else {
    var jsx$5 = this$8.get__O()
  };
  return $as_sc_Seq(jsx$5)
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.raw__s_Option = (function() {
  return this.raw$1
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.header__T = (function() {
  var jsx$1 = $m_Lorg_mulesoft_common_core_package$Strings$();
  var str = ("%" + this.nameAndVersion__T());
  return jsx$1.stripSpaces$extension__T__T(str)
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.encodes__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_core_model_domain_DomainElement(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Encodes$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.libraryHeader__s_Option = (function() {
  var this$1 = $m_s_Option$().apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectModel$().Documents$1)));
  if (this$1.isEmpty__Z()) {
    var this$2 = $m_s_None$()
  } else {
    var arg1 = this$1.get__O();
    var d = $as_Lamf_plugins_document_vocabularies_model_domain_DocumentsModel(arg1);
    var this$2 = new $c_s_Some().init___O($m_s_Option$().apply__O__s_Option($as_Lamf_plugins_document_vocabularies_model_domain_DocumentMapping(d.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_domain_DocumentsModelModel$().Library$1))))
  };
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1$1 = this$2.get__O();
    $as_s_Option(arg1$1);
    var x = this.header__T();
    var this$4 = new $c_sci_StringOps().init___T(x);
    return new $c_s_Some().init___O(("%Library/" + $f_sci_StringLike__stripPrefix__T__T(this$4, "%")))
  }
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  $f_Lamf_core_model_document_BaseUnit__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_document_vocabularies_model_document_Dialect(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_document_Dialect) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.document.Dialect"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_document_Dialect(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_document_Dialect)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_document_Dialect(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_document_Dialect(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.document.Dialect;", depth))
}
var $d_Lamf_plugins_document_vocabularies_model_document_Dialect = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_document_Dialect: 0
}, false, "amf.plugins.document.vocabularies.model.document.Dialect", {
  Lamf_plugins_document_vocabularies_model_document_Dialect: 1,
  O: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_vocabularies_model_document_ExternalContext: 1,
  Lamf_core_model_document_DeclaresModel: 1,
  Lamf_core_model_document_EncodesModel: 1,
  Lamf_plugins_document_vocabularies_model_document_MappingDeclarer: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_document_Dialect.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_document_Dialect;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.composedDialects$1 = null;
  this.amf$core$model$document$BaseUnit$$run$1 = null;
  this.raw$1 = null;
  this.platform$1 = null;
  this.id$1 = null
}
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype = $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype;
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.productPrefix__T = (function() {
  return "DialectInstanceFragment"
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment)) {
    var DialectInstanceFragment$1 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment(x$1);
    var x = this.fields$1;
    var x$2 = DialectInstanceFragment$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = DialectInstanceFragment$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.raw$und$eq__s_Option__V = (function(x$1) {
  this.raw$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceFragmentModel$()
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.references__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().References$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit = (function(selector, transformation, errorHandler) {
  return $f_Lamf_core_model_document_BaseUnit__transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(this, selector, transformation, errorHandler)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.amf$core$model$document$BaseUnit$$run__s_Option = (function() {
  return this.amf$core$model$document$BaseUnit$$run$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V = (function(x$1) {
  this.amf$core$model$document$BaseUnit$$run$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.graphDependencies__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().GraphDependencies$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.raw__s_Option = (function() {
  return this.raw$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.composedDialects$und$eq__sci_Map__V = (function(x$1) {
  this.composedDialects$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.encodes__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_core_model_domain_DomainElement(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().Encodes$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.definedBy__Lamf_core_model_StrField = (function() {
  return $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().DefinedBy$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  $f_Lamf_core_model_document_BaseUnit__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_model_document_ComposedInstancesSupport__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.document.DialectInstanceFragment"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.document.DialectInstanceFragment;", depth))
}
var $d_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment: 0
}, false, "amf.plugins.document.vocabularies.model.document.DialectInstanceFragment", {
  Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment: 1,
  O: 1,
  Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_vocabularies_model_document_ExternalContext: 1,
  Lamf_core_model_document_EncodesModel: 1,
  Lamf_plugins_document_vocabularies_model_document_ComposedInstancesSupport: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_document_DialectInstanceFragment;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.composedDialects$1 = null;
  this.amf$core$model$document$BaseUnit$$run$1 = null;
  this.raw$1 = null;
  this.platform$1 = null;
  this.id$1 = null
}
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype = $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype;
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.productPrefix__T = (function() {
  return "DialectInstanceLibrary"
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary)) {
    var DialectInstanceLibrary$1 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary(x$1);
    var x = this.fields$1;
    var x$2 = DialectInstanceLibrary$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = DialectInstanceLibrary$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.raw$und$eq__s_Option__V = (function(x$1) {
  this.raw$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceLibraryModel$()
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.references__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().References$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit = (function(selector, transformation, errorHandler) {
  return $f_Lamf_core_model_document_BaseUnit__transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(this, selector, transformation, errorHandler)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.amf$core$model$document$BaseUnit$$run__s_Option = (function() {
  return this.amf$core$model$document$BaseUnit$$run$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.declares__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().Declares$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V = (function(x$1) {
  this.amf$core$model$document$BaseUnit$$run$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.graphDependencies__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().GraphDependencies$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.raw__s_Option = (function() {
  return this.raw$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.composedDialects$und$eq__sci_Map__V = (function(x$1) {
  this.composedDialects$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.definedBy__Lamf_core_model_StrField = (function() {
  return $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().DefinedBy$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  $f_Lamf_core_model_document_BaseUnit__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_model_document_ComposedInstancesSupport__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.document.DialectInstanceLibrary"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.document.DialectInstanceLibrary;", depth))
}
var $d_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary: 0
}, false, "amf.plugins.document.vocabularies.model.document.DialectInstanceLibrary", {
  Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary: 1,
  O: 1,
  Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_vocabularies_model_document_ExternalContext: 1,
  Lamf_core_model_document_DeclaresModel: 1,
  Lamf_plugins_document_vocabularies_model_document_ComposedInstancesSupport: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_document_DialectInstanceLibrary;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.amf$core$model$document$BaseUnit$$run$1 = null;
  this.raw$1 = null;
  this.platform$1 = null;
  this.id$1 = null
}
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype = $c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype;
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.productPrefix__T = (function() {
  return "DialectInstancePatch"
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch)) {
    var DialectInstancePatch$1 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch(x$1);
    var x = this.fields$1;
    var x$2 = DialectInstancePatch$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = DialectInstancePatch$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.raw$und$eq__s_Option__V = (function(x$1) {
  this.raw$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstancePatchModel$()
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.references__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().References$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit = (function(selector, transformation, errorHandler) {
  return $f_Lamf_core_model_document_BaseUnit__transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit(this, selector, transformation, errorHandler)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.amf$core$model$document$BaseUnit$$run__s_Option = (function() {
  return this.amf$core$model$document$BaseUnit$$run$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.declares__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().Declares$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V = (function(x$1) {
  this.amf$core$model$document$BaseUnit$$run$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.graphDependencies__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().GraphDependencies$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.raw__s_Option = (function() {
  return this.raw$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.encodes__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_core_model_domain_DomainElement(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().Encodes$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.definedBy__Lamf_core_model_StrField = (function() {
  return $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().DefinedBy$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  $f_Lamf_core_model_document_BaseUnit__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.document.DialectInstancePatch"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.document.DialectInstancePatch;", depth))
}
var $d_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch: 0
}, false, "amf.plugins.document.vocabularies.model.document.DialectInstancePatch", {
  Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch: 1,
  O: 1,
  Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_vocabularies_model_document_ExternalContext: 1,
  Lamf_core_model_document_DeclaresModel: 1,
  Lamf_core_model_document_EncodesModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_document_DialectInstancePatch;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.Name$1 = null;
  this.MergePolicy$1 = null;
  this.ALLOWED$undMERGE$undPOLICY$1 = null;
  this.linkAnnotations$1 = null;
  this.shouldLink$1 = false;
  this.isUnresolved$1 = false;
  this.unresolvedSeverity$1 = null;
  this.refName$1 = null;
  this.refAst$1 = null;
  this.refCtx$1 = null;
  this.amf$core$model$domain$Linkable$$linkCounter$1 = null;
  this.graph$1 = null;
  this.id$1 = null;
  this.bitmap$0$1 = false
}
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype = $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype;
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.unresolvedSeverity__T = (function() {
  return this.unresolvedSeverity$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.productPrefix__T = (function() {
  return "UnionNodeMapping"
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.unresolvedSeverity$und$eq__T__V = (function(x$1) {
  this.unresolvedSeverity$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.amf$plugins$document$vocabularies$metamodel$domain$NodeMappableModel$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedId) {
  /*<skip>*/
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.refName$und$eq__T__V = (function(x$1) {
  this.refName$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping)) {
    var UnionNodeMapping$1 = $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(x$1);
    var x = this.fields$1;
    var x$2 = UnionNodeMapping$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = UnionNodeMapping$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.MergePolicy__Lamf_core_metamodel_Field = (function() {
  return this.MergePolicy$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_vocabularies_metamodel_domain_UnionNodeMappingModel$()
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.refCtx__s_Option = (function() {
  return this.refCtx$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.amf$core$model$domain$Linkable$$undsetter$und$shouldLink$und$eq__Z__V = (function(x$1) {
  this.shouldLink$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.shouldLink__Z = (function() {
  return this.shouldLink$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.refAst__s_Option = (function() {
  return this.refAst$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O(this.Name$1));
  var this$2 = this$1.option$1;
  var str = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  var this$4 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$5 = this$4.platform$1;
  var url = this$4.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$5, url))
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.linkAnnotations$und$eq__s_Option__V = (function(x$1) {
  this.linkAnnotations$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_domain_AmfObject__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O = (function(label, annotations, unresolved, supportsRecursion) {
  return $f_Lamf_core_model_domain_Linkable__resolveUnreferencedLink__T__Lamf_core_parser_Annotations__O__Z__O(this, label, annotations, unresolved, supportsRecursion)
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.graph__Lamf_core_model_domain_Graph = (function() {
  return ((!this.bitmap$0$1) ? this.graph$lzycompute__p1__Lamf_core_model_domain_Graph() : this.graph$1)
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_AmfElement__location__s_Option(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return $f_Lamf_core_model_domain_Linkable__link__T__Lamf_core_parser_Annotations__O(this, label, annotations)
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.amf$plugins$document$vocabularies$metamodel$domain$MergeableMappingModel$$undsetter$und$MergePolicy$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.MergePolicy$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.graph$lzycompute__p1__Lamf_core_model_domain_Graph = (function() {
  if ((!this.bitmap$0$1)) {
    this.graph$1 = new $c_Lamf_core_model_domain_Graph().init___Lamf_core_model_domain_DomainElement(this);
    this.bitmap$0$1 = true
  };
  return this.graph$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.isUnresolved__Z = (function() {
  return this.isUnresolved$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.ALLOWED$undMERGE$undPOLICY__sci_Set = (function() {
  return this.ALLOWED$undMERGE$undPOLICY$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.refCtx$und$eq__s_Option__V = (function(x$1) {
  this.refCtx$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.amf$plugins$document$vocabularies$metamodel$domain$MergeableMappingModel$$undsetter$und$ALLOWED$undMERGE$undPOLICY$und$eq__sci_Set__V = (function(x$1) {
  this.ALLOWED$undMERGE$undPOLICY$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.refName__T = (function() {
  return this.refName$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return $f_Lamf_core_model_domain_Linkable__effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement(this, links)
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.refAst$und$eq__s_Option__V = (function(x$1) {
  this.refAst$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.isUnresolved$und$eq__Z__V = (function(x$1) {
  this.isUnresolved$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.withName__T__Lamf_plugins_document_vocabularies_model_domain_NodeMappable = (function(name) {
  var field = this.Name$1;
  return $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping($as_Lamf_plugins_document_vocabularies_model_domain_NodeMappable($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this, field, name)))
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.amf$core$model$domain$Linkable$$undsetter$und$amf$core$model$domain$Linkable$$linkCounter$und$eq__Lamf_core_utils_package$IdCounter__V = (function(x$1) {
  this.amf$core$model$domain$Linkable$$linkCounter$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_metamodel_domain_MergeableMappingModel__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappableModel__$$init$__V(this);
  return this
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.Name__Lamf_core_metamodel_Field = (function() {
  return this.Name$1
});
function $as_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.domain.UnionNodeMapping"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.domain.UnionNodeMapping;", depth))
}
var $d_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping: 0
}, false, "amf.plugins.document.vocabularies.model.domain.UnionNodeMapping", {
  Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_plugins_document_vocabularies_model_domain_MergeableMapping: 1,
  Lamf_plugins_document_vocabularies_metamodel_domain_MergeableMappingModel: 1,
  Lamf_plugins_document_vocabularies_model_domain_NodeWithDiscriminator: 1,
  Lamf_plugins_document_vocabularies_model_domain_NodeMappable: 1,
  Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappableModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_domain_UnionNodeMapping;
/** @constructor */
function $c_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext() {
  $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext.call(this);
  this.wrapped$5 = null;
  this.ds$5 = null;
  this.parentDeclarations$5 = null;
  this.declarations$5 = null
}
$c_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext();
$c_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext.prototype.constructor = $c_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext;
/** @constructor */
function $h_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext.prototype = $c_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext.prototype;
$c_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext.prototype.wrapped__Lamf_core_parser_ParserContext = (function() {
  return this.wrapped$5
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext.prototype.declarations__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations = (function() {
  return this.declarations$5
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext.prototype.init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions = (function(loc, refs, wrapped, ds, parentDeclarations, parserCount, contextType, options) {
  this.wrapped$5 = wrapped;
  this.ds$5 = ds;
  this.parentDeclarations$5 = parentDeclarations;
  $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext.prototype.init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions.call(this, loc, refs, wrapped, ds, contextType, options);
  if ((ds instanceof $c_s_Some)) {
    var x2 = $as_s_Some(ds);
    var dec = $as_Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations(x2.value$2);
    var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_ExtensionWebApiDeclarations().init___sci_Map__sci_Map__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations(dec.externalShapes$3, dec.externalLibs$3, parentDeclarations, dec.alias__s_Option(), dec.errorHandler__Lamf_core_errorhandling_ErrorHandler(), dec.futureDeclarations__Lamf_core_parser_FutureDeclarations())
  } else {
    var x = $m_s_None$();
    if ((x === ds)) {
      var x$2$2 = $m_s_None$();
      var x$3 = this.eh$1;
      var x$4 = this.futureDeclarations$1;
      var x$5 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
      var x$6 = $as_sci_Map($m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$()));
      var jsx$1 = new $c_Lamf_plugins_document_webapi_parser_spec_ExtensionWebApiDeclarations().init___sci_Map__sci_Map__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__s_Option__Lamf_core_errorhandling_ErrorHandler__Lamf_core_parser_FutureDeclarations(x$5, x$6, parentDeclarations, x$2$2, x$3, x$4)
    } else {
      var jsx$1;
      throw new $c_s_MatchError().init___O(ds)
    }
  };
  this.declarations$5 = jsx$1;
  return this
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext.prototype.clone__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext = (function(declarations) {
  var x$1 = this.rootContextDocument$1;
  var x$2 = this.refs$1;
  var x$3 = this.wrapped$5;
  var x$4 = new $c_s_Some().init___O(declarations);
  var x$5 = this.parentDeclarations$5;
  var x$6 = this.options$2;
  var x$7 = $m_s_None$();
  var x$8 = $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2;
  return new $c_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext().init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__Lamf_plugins_document_webapi_parser_spec_RamlWebApiDeclarations__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions(x$1, x$2, x$3, x$4, x$5, x$7, x$8, x$6)
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext.prototype.declarations__Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations = (function() {
  return this.declarations$5
});
function $as_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.contexts.parser.raml.ExtensionLikeWebApiContext"))
}
function $isArrayOf_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext)))
}
function $asArrayOf_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.contexts.parser.raml.ExtensionLikeWebApiContext;", depth))
}
var $d_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext = new $TypeData().initClass({
  Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext: 0
}, false, "amf.plugins.document.webapi.contexts.parser.raml.ExtensionLikeWebApiContext", {
  Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_WebApiContext: 1,
  Lamf_core_parser_ParserContext: 1,
  O: 1,
  Lorg_yaml_model_ParseErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_plugins_document_webapi_contexts_SpecAwareContext: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecAwareContext: 1
});
$c_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext.prototype.$classData = $d_Lamf_plugins_document_webapi_contexts_parser_raml_ExtensionLikeWebApiContext;
/** @constructor */
function $c_Lamf_plugins_document_webapi_model_Extension() {
  $c_Lamf_core_model_document_ExtensionLike.call(this);
  this.fields$3 = null;
  this.annotations$3 = null
}
$c_Lamf_plugins_document_webapi_model_Extension.prototype = new $h_Lamf_core_model_document_ExtensionLike();
$c_Lamf_plugins_document_webapi_model_Extension.prototype.constructor = $c_Lamf_plugins_document_webapi_model_Extension;
/** @constructor */
function $h_Lamf_plugins_document_webapi_model_Extension() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_model_Extension.prototype = $c_Lamf_plugins_document_webapi_model_Extension.prototype;
$c_Lamf_plugins_document_webapi_model_Extension.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_webapi_metamodel_ExtensionModel$()
});
$c_Lamf_plugins_document_webapi_model_Extension.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$3
});
$c_Lamf_plugins_document_webapi_model_Extension.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$3
});
$c_Lamf_plugins_document_webapi_model_Extension.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$3 = fields;
  this.annotations$3 = annotations;
  $c_Lamf_core_model_document_Document.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  return this
});
function $as_Lamf_plugins_document_webapi_model_Extension(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_model_Extension) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.model.Extension"))
}
function $isArrayOf_Lamf_plugins_document_webapi_model_Extension(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_model_Extension)))
}
function $asArrayOf_Lamf_plugins_document_webapi_model_Extension(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_model_Extension(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.model.Extension;", depth))
}
var $d_Lamf_plugins_document_webapi_model_Extension = new $TypeData().initClass({
  Lamf_plugins_document_webapi_model_Extension: 0
}, false, "amf.plugins.document.webapi.model.Extension", {
  Lamf_plugins_document_webapi_model_Extension: 1,
  Lamf_core_model_document_ExtensionLike: 1,
  Lamf_core_model_document_Document: 1,
  O: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_model_document_EncodesModel: 1,
  Lamf_core_model_document_DeclaresModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_model_Extension.prototype.$classData = $d_Lamf_plugins_document_webapi_model_Extension;
/** @constructor */
function $c_Lamf_plugins_document_webapi_model_Overlay() {
  $c_Lamf_core_model_document_ExtensionLike.call(this);
  this.fields$3 = null;
  this.annotations$3 = null
}
$c_Lamf_plugins_document_webapi_model_Overlay.prototype = new $h_Lamf_core_model_document_ExtensionLike();
$c_Lamf_plugins_document_webapi_model_Overlay.prototype.constructor = $c_Lamf_plugins_document_webapi_model_Overlay;
/** @constructor */
function $h_Lamf_plugins_document_webapi_model_Overlay() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_model_Overlay.prototype = $c_Lamf_plugins_document_webapi_model_Overlay.prototype;
$c_Lamf_plugins_document_webapi_model_Overlay.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_webapi_metamodel_OverlayModel$()
});
$c_Lamf_plugins_document_webapi_model_Overlay.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$3
});
$c_Lamf_plugins_document_webapi_model_Overlay.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$3
});
$c_Lamf_plugins_document_webapi_model_Overlay.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$3 = fields;
  this.annotations$3 = annotations;
  $c_Lamf_core_model_document_Document.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  return this
});
function $as_Lamf_plugins_document_webapi_model_Overlay(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_model_Overlay) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.model.Overlay"))
}
function $isArrayOf_Lamf_plugins_document_webapi_model_Overlay(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_model_Overlay)))
}
function $asArrayOf_Lamf_plugins_document_webapi_model_Overlay(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_model_Overlay(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.model.Overlay;", depth))
}
var $d_Lamf_plugins_document_webapi_model_Overlay = new $TypeData().initClass({
  Lamf_plugins_document_webapi_model_Overlay: 0
}, false, "amf.plugins.document.webapi.model.Overlay", {
  Lamf_plugins_document_webapi_model_Overlay: 1,
  Lamf_core_model_document_ExtensionLike: 1,
  Lamf_core_model_document_Document: 1,
  O: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_core_model_document_EncodesModel: 1,
  Lamf_core_model_document_DeclaresModel: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_model_Overlay.prototype.$classData = $d_Lamf_plugins_document_webapi_model_Overlay;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter() {
  $c_Lamf_plugins_domain_webapi_models_Parameter.call(this);
  this.idPart$2 = null;
  this.ast$2 = null;
  this.namespace$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter.prototype = new $h_Lamf_plugins_domain_webapi_models_Parameter();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter.prototype.productPrefix__T = (function() {
  return "ErrorParameter"
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter.prototype.namespace__T = (function() {
  return this.namespace$2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter.prototype.originalMeta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter.prototype.newErrorInstance__Lamf_core_annotations_ErrorDeclaration = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter().init___T__Lorg_yaml_model_YPart(this.idPart$2, this.ast$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter)) {
    var ErrorParameter$1 = $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter(x$1);
    if ((this.idPart$2 === ErrorParameter$1.idPart$2)) {
      var x = this.ast$2;
      var x$2 = ErrorParameter$1.ast$2;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.idPart$2;
      break
    }
    case 1: {
      return this.ast$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return new $c_Lamf_core_annotations_ErrorDeclaration$$anon$1().init___Lamf_core_annotations_ErrorDeclaration(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter.prototype.init___T__Lorg_yaml_model_YPart = (function(idPart, ast) {
  this.idPart$2 = idPart;
  this.ast$2 = ast;
  $c_Lamf_plugins_domain_webapi_models_Parameter.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, new $c_Lamf_core_parser_Fields().init___(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast));
  this.namespace$2 = "http://amferror.com/#errorParameter/";
  $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, idPart);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter.prototype.amf$core$annotations$ErrorDeclaration$$super$withId__T__Lamf_core_annotations_ErrorDeclaration = (function(value) {
  return $as_Lamf_core_annotations_ErrorDeclaration($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorParameter"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorParameter;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorParameter", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter: 1,
  Lamf_plugins_domain_webapi_models_Parameter: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_plugins_domain_webapi_models_SchemaContainer: 1,
  Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement: 1,
  Lamf_core_annotations_ErrorDeclaration: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorParameter;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest() {
  $c_Lamf_plugins_domain_webapi_models_Request.call(this);
  this.idPart$3 = null;
  this.ast$3 = null;
  this.namespace$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest.prototype = new $h_Lamf_plugins_domain_webapi_models_Request();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest.prototype.productPrefix__T = (function() {
  return "ErrorRequest"
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest.prototype.namespace__T = (function() {
  return this.namespace$3
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest.prototype.originalMeta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest.prototype.newErrorInstance__Lamf_core_annotations_ErrorDeclaration = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest().init___T__Lorg_yaml_model_YPart(this.idPart$3, this.ast$3)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest)) {
    var ErrorRequest$1 = $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest(x$1);
    if ((this.idPart$3 === ErrorRequest$1.idPart$3)) {
      var x = this.ast$3;
      var x$2 = ErrorRequest$1.ast$3;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.idPart$3;
      break
    }
    case 1: {
      return this.ast$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return new $c_Lamf_core_annotations_ErrorDeclaration$$anon$1().init___Lamf_core_annotations_ErrorDeclaration(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest.prototype.init___T__Lorg_yaml_model_YPart = (function(idPart, ast) {
  this.idPart$3 = idPart;
  this.ast$3 = ast;
  $c_Lamf_plugins_domain_webapi_models_Request.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, new $c_Lamf_core_parser_Fields().init___(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast));
  this.namespace$3 = "http://amferror.com/#errorRequest/";
  $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, idPart);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest.prototype.amf$core$annotations$ErrorDeclaration$$super$withId__T__Lamf_core_annotations_ErrorDeclaration = (function(value) {
  return $as_Lamf_core_annotations_ErrorDeclaration($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorRequest"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorRequest;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorRequest", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest: 1,
  Lamf_plugins_domain_webapi_models_Request: 1,
  Lamf_plugins_domain_webapi_models_Message: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_annotations_ErrorDeclaration: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorRequest;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse() {
  $c_Lamf_plugins_domain_webapi_models_Response.call(this);
  this.idPart$3 = null;
  this.ast$3 = null;
  this.namespace$3 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse.prototype = new $h_Lamf_plugins_domain_webapi_models_Response();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse.prototype.productPrefix__T = (function() {
  return "ErrorResponse"
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse.prototype.namespace__T = (function() {
  return this.namespace$3
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse.prototype.originalMeta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse.prototype.newErrorInstance__Lamf_core_annotations_ErrorDeclaration = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse().init___T__Lorg_yaml_model_YPart(this.idPart$3, this.ast$3)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse)) {
    var ErrorResponse$1 = $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse(x$1);
    if ((this.idPart$3 === ErrorResponse$1.idPart$3)) {
      var x = this.ast$3;
      var x$2 = ErrorResponse$1.ast$3;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.idPart$3;
      break
    }
    case 1: {
      return this.ast$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return new $c_Lamf_core_annotations_ErrorDeclaration$$anon$1().init___Lamf_core_annotations_ErrorDeclaration(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse.prototype.init___T__Lorg_yaml_model_YPart = (function(idPart, ast) {
  this.idPart$3 = idPart;
  this.ast$3 = ast;
  $c_Lamf_plugins_domain_webapi_models_Response.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, new $c_Lamf_core_parser_Fields().init___(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast));
  this.namespace$3 = "http://amferror.com/#errorResponse/";
  var this$2 = $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, idPart));
  var field = $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().StatusCode$1;
  $as_Lamf_plugins_domain_webapi_models_Response($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__T__Lamf_core_model_domain_AmfObject(this$2, field, "200"));
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse.prototype.amf$core$annotations$ErrorDeclaration$$super$withId__T__Lamf_core_annotations_ErrorDeclaration = (function(value) {
  return $as_Lamf_core_annotations_ErrorDeclaration($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorResponse"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorResponse;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorResponse", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse: 1,
  Lamf_plugins_domain_webapi_models_Response: 1,
  Lamf_plugins_domain_webapi_models_Message: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_annotations_ErrorDeclaration: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorResponse;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$() {
  $c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.call(this);
  this.type$2 = null;
  this.doc$2 = null
}
$c_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$.prototype = new $h_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape();
$c_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$.prototype.constructor = $c_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$.prototype = $c_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$.prototype;
$c_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$.prototype.init___ = (function() {
  $c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.init___.call(this);
  $n_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$ = this;
  $m_sci_List$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var array = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "ArrayShape")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$6 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$6);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().type$1;
  var this$7 = $m_sci_List$();
  this.type$2 = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$7.ReusableCBFInstance$2));
  this.doc$2 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "Array Shape", "Shape that contains a nested collection of data shapes", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$2
});
$c_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_shapes_models_ArrayShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$.prototype.modelInstance__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_shapes_models_ArrayShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$.prototype.type__sci_List = (function() {
  return this.type$2
});
var $d_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$: 0
}, false, "amf.plugins.domain.shapes.metamodel.ArrayShapeModel$", {
  Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$: 1,
  Lamf_plugins_domain_shapes_metamodel_DataArrangementShape: 1,
  O: 1,
  Lamf_plugins_domain_shapes_metamodel_AnyShapeModel: 1,
  Lamf_core_metamodel_domain_ShapeModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1,
  Lamf_core_metamodel_domain_ExternalSourceElementModel: 1,
  Lamf_plugins_domain_shapes_metamodel_common_ExamplesField: 1,
  Lamf_plugins_domain_shapes_metamodel_common_DocumentationField: 1
});
$c_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$.prototype.$classData = $d_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$;
var $n_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$ = (void 0);
function $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$() {
  if ((!$n_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$)) {
    $n_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$ = new $c_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$() {
  $c_O.call(this);
  this.FileTypes$1 = null;
  this.specificFields$1 = null;
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Pattern$1 = null;
  this.MinLength$1 = null;
  this.MaxLength$1 = null;
  this.Minimum$1 = null;
  this.Maximum$1 = null;
  this.ExclusiveMinimum$1 = null;
  this.ExclusiveMaximum$1 = null;
  this.Format$1 = null;
  this.MultipleOf$1 = null;
  this.commonOASFields$1 = null;
  this.XMLSerialization$1 = null;
  this.Comment$1 = null;
  this.Documentation$1 = null;
  this.Examples$1 = null;
  this.Raw$1 = null;
  this.ReferenceId$1 = null;
  this.Location$1 = null;
  this.Name$1 = null;
  this.DisplayName$1 = null;
  this.Default$1 = null;
  this.DefaultValueString$1 = null;
  this.Values$1 = null;
  this.Closure$1 = null;
  this.Inherits$1 = null;
  this.Or$1 = null;
  this.And$1 = null;
  this.Xone$1 = null;
  this.Not$1 = null;
  this.If$1 = null;
  this.Then$1 = null;
  this.Else$1 = null;
  this.ReadOnly$1 = null;
  this.WriteOnly$1 = null;
  this.Deprecated$1 = null;
  this.key$1 = null;
  this.CustomShapePropertyDefinitions$1 = null;
  this.CustomShapeProperties$1 = null;
  this.Description$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.constructor = $c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype = $c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype;
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.Minimum__Lamf_core_metamodel_Field = (function() {
  return this.Minimum$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$Comment$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Comment$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$XMLSerialization$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.XMLSerialization$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ShapeModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ExternalSourceElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_CommonShapeFields__$$init$__V(this);
  var jsx$1 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_Type$Str$());
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.FileTypes$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "fileType"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "file type", "Type of file described by this shape", $m_sci_Nil$()), true);
  $m_sci_List$();
  var array = [this.FileTypes$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$7 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$7);
    i = (((-1) + i) | 0)
  };
  this.specificFields$1 = result;
  var jsx$7 = this.specificFields$1;
  var jsx$6 = this.commonOASFields$1;
  var this$8 = $m_sci_List$();
  var jsx$5 = $as_sci_List(jsx$7.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$6, this$8.ReusableCBFInstance$2));
  var jsx$4 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().fields$1;
  var this$9 = $m_sci_List$();
  var jsx$3 = $as_sci_List(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$9.ReusableCBFInstance$2));
  var jsx$2 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$10 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$10.ReusableCBFInstance$2));
  $m_sci_List$();
  var this$11 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var array$1 = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$11, "FileShape")];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$16 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$16);
    i$1 = (((-1) + i$1) | 0)
  };
  var jsx$9 = result$1;
  var jsx$8 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().type$1;
  var this$17 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$9.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$8, this$17.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "File Shape", "Shape describing data uploaded in an API request", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Raw$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Raw$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$ReadOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReadOnly$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$MaxLength$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.MaxLength$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.ExclusiveMinimum__Lamf_core_metamodel_Field = (function() {
  return this.ExclusiveMinimum$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$Format$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Format$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$ExclusiveMinimum$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ExclusiveMinimum$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$common$DocumentationField$$undsetter$und$Documentation$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Documentation$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.MinLength__Lamf_core_metamodel_Field = (function() {
  return this.MinLength$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Deprecated$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Deprecated$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$ExclusiveMaximum$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ExclusiveMaximum$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.Maximum__Lamf_core_metamodel_Field = (function() {
  return this.Maximum$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$Pattern$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Pattern$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DefaultValueString$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DefaultValueString$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$Minimum$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Minimum$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.ExclusiveMaximum__Lamf_core_metamodel_Field = (function() {
  return this.ExclusiveMaximum$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$MultipleOf$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.MultipleOf$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$type$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$MinLength$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.MinLength$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.Format__Lamf_core_metamodel_Field = (function() {
  return this.Format$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$Maximum$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Maximum$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.MaxLength__Lamf_core_metamodel_Field = (function() {
  return this.MaxLength$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$WriteOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.WriteOnly$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DisplayName$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DisplayName$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$common$ExamplesField$$undsetter$und$Examples$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Examples$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$commonOASFields$und$eq__sci_List__V = (function(x$1) {
  this.commonOASFields$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.Pattern__Lamf_core_metamodel_Field = (function() {
  return this.Pattern$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$key$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.key$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Else$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Else$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Inherits$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Inherits$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$And$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.And$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_shapes_models_FileShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Not$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Not$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$If$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.If$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.MultipleOf__Lamf_core_metamodel_Field = (function() {
  return this.MultipleOf$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Closure$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Closure$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$ReferenceId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReferenceId$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Xone$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Xone$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.modelInstance__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_shapes_models_FileShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Values$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Values$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Or$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Or$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Then$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Then$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.Name__Lamf_core_metamodel_Field = (function() {
  return this.Name$1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Default$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Default$1 = x$1
});
var $d_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_metamodel_FileShapeModel$: 0
}, false, "amf.plugins.domain.shapes.metamodel.FileShapeModel$", {
  Lamf_plugins_domain_shapes_metamodel_FileShapeModel$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_metamodel_AnyShapeModel: 1,
  Lamf_core_metamodel_domain_ShapeModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1,
  Lamf_core_metamodel_domain_ExternalSourceElementModel: 1,
  Lamf_plugins_domain_shapes_metamodel_common_ExamplesField: 1,
  Lamf_plugins_domain_shapes_metamodel_common_DocumentationField: 1,
  Lamf_plugins_domain_shapes_metamodel_CommonShapeFields: 1
});
$c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$.prototype.$classData = $d_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$;
var $n_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$ = (void 0);
function $m_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$() {
  if ((!$n_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$)) {
    $n_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$ = new $c_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$() {
  $c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.call(this);
  this.type$2 = null;
  this.doc$2 = null
}
$c_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$.prototype = new $h_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape();
$c_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$.prototype.constructor = $c_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$.prototype = $c_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$.prototype;
$c_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$.prototype.init___ = (function() {
  $c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.init___.call(this);
  $n_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$ = this;
  $m_sci_List$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var jsx$2 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "MatrixShape");
  var this$3 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var array = [jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$3, "ArrayShape")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$8 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$8);
    i = (((-1) + i) | 0)
  };
  var jsx$3 = result;
  var jsx$1 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().type$1;
  var this$9 = $m_sci_List$();
  this.type$2 = $as_sci_List(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$9.ReusableCBFInstance$2));
  this.doc$2 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "Matrix Shape", "Data shape containing nested multi-dimensional collection shapes", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$2
});
$c_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_shapes_models_MatrixShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$.prototype.modelInstance__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_shapes_models_MatrixShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$.prototype.type__sci_List = (function() {
  return this.type$2
});
var $d_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$: 0
}, false, "amf.plugins.domain.shapes.metamodel.MatrixShapeModel$", {
  Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$: 1,
  Lamf_plugins_domain_shapes_metamodel_DataArrangementShape: 1,
  O: 1,
  Lamf_plugins_domain_shapes_metamodel_AnyShapeModel: 1,
  Lamf_core_metamodel_domain_ShapeModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1,
  Lamf_core_metamodel_domain_ExternalSourceElementModel: 1,
  Lamf_plugins_domain_shapes_metamodel_common_ExamplesField: 1,
  Lamf_plugins_domain_shapes_metamodel_common_DocumentationField: 1
});
$c_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$.prototype.$classData = $d_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$;
var $n_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$ = (void 0);
function $m_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$() {
  if ((!$n_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$)) {
    $n_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$ = new $c_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$() {
  $c_O.call(this);
  this.DataType$1 = null;
  this.specificFields$1 = null;
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Pattern$1 = null;
  this.MinLength$1 = null;
  this.MaxLength$1 = null;
  this.Minimum$1 = null;
  this.Maximum$1 = null;
  this.ExclusiveMinimum$1 = null;
  this.ExclusiveMaximum$1 = null;
  this.Format$1 = null;
  this.MultipleOf$1 = null;
  this.commonOASFields$1 = null;
  this.XMLSerialization$1 = null;
  this.Comment$1 = null;
  this.Documentation$1 = null;
  this.Examples$1 = null;
  this.Raw$1 = null;
  this.ReferenceId$1 = null;
  this.Location$1 = null;
  this.Name$1 = null;
  this.DisplayName$1 = null;
  this.Default$1 = null;
  this.DefaultValueString$1 = null;
  this.Values$1 = null;
  this.Closure$1 = null;
  this.Inherits$1 = null;
  this.Or$1 = null;
  this.And$1 = null;
  this.Xone$1 = null;
  this.Not$1 = null;
  this.If$1 = null;
  this.Then$1 = null;
  this.Else$1 = null;
  this.ReadOnly$1 = null;
  this.WriteOnly$1 = null;
  this.Deprecated$1 = null;
  this.key$1 = null;
  this.CustomShapePropertyDefinitions$1 = null;
  this.CustomShapeProperties$1 = null;
  this.Description$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.constructor = $c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype = $c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype;
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.Minimum__Lamf_core_metamodel_Field = (function() {
  return this.Minimum$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$Comment$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Comment$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$XMLSerialization$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.XMLSerialization$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ShapeModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ExternalSourceElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_CommonShapeFields__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Iri$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shacl$1;
  this.DataType$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "datatype"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ExternalModelVocabularies$().Shacl$1, "datatype", "Scalar range constraining this scalar shape", $m_sci_Nil$()), true);
  $m_sci_List$();
  var array = [this.DataType$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$7 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$7);
    i = (((-1) + i) | 0)
  };
  this.specificFields$1 = result;
  var jsx$7 = this.specificFields$1;
  var jsx$6 = this.commonOASFields$1;
  var this$8 = $m_sci_List$();
  var jsx$5 = $as_sci_List(jsx$7.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$6, this$8.ReusableCBFInstance$2));
  var jsx$4 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().fields$1;
  var this$9 = $m_sci_List$();
  var jsx$3 = $as_sci_List(jsx$5.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$9.ReusableCBFInstance$2));
  var jsx$2 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$10 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$3.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$2, this$10.ReusableCBFInstance$2));
  $m_sci_List$();
  var this$11 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var array$1 = [new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$11, "ScalarShape")];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$16 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$16);
    i$1 = (((-1) + i$1) | 0)
  };
  var jsx$9 = result$1;
  var jsx$8 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().type$1;
  var this$17 = $m_sci_List$();
  this.type$1 = $as_sci_List(jsx$9.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$8, this$17.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "Scalar Shape", "Data shape describing a scalar value in the input data model, reified as an scalar node in the mapped graph", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Raw$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Raw$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$ReadOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReadOnly$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$MaxLength$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.MaxLength$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.ExclusiveMinimum__Lamf_core_metamodel_Field = (function() {
  return this.ExclusiveMinimum$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$Format$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Format$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$ExclusiveMinimum$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ExclusiveMinimum$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Deprecated$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Deprecated$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$common$DocumentationField$$undsetter$und$Documentation$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Documentation$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.MinLength__Lamf_core_metamodel_Field = (function() {
  return this.MinLength$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$ExclusiveMaximum$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ExclusiveMaximum$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.Maximum__Lamf_core_metamodel_Field = (function() {
  return this.Maximum$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$Pattern$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Pattern$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DefaultValueString$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DefaultValueString$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$Minimum$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Minimum$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.ExclusiveMaximum__Lamf_core_metamodel_Field = (function() {
  return this.ExclusiveMaximum$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$MultipleOf$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.MultipleOf$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$type$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$MinLength$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.MinLength$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.Format__Lamf_core_metamodel_Field = (function() {
  return this.Format$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$Maximum$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Maximum$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.MaxLength__Lamf_core_metamodel_Field = (function() {
  return this.MaxLength$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$WriteOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.WriteOnly$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DisplayName$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DisplayName$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$common$ExamplesField$$undsetter$und$Examples$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Examples$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$CommonShapeFields$$undsetter$und$commonOASFields$und$eq__sci_List__V = (function(x$1) {
  this.commonOASFields$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$key$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.key$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.Pattern__Lamf_core_metamodel_Field = (function() {
  return this.Pattern$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Else$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Else$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Inherits$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Inherits$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$And$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.And$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_shapes_models_ScalarShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Not$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Not$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$If$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.If$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.MultipleOf__Lamf_core_metamodel_Field = (function() {
  return this.MultipleOf$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Closure$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Closure$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$ReferenceId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReferenceId$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Xone$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Xone$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.modelInstance__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_shapes_models_ScalarShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Values$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Values$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Or$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Or$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Then$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Then$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.Name__Lamf_core_metamodel_Field = (function() {
  return this.Name$1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Default$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Default$1 = x$1
});
var $d_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$: 0
}, false, "amf.plugins.domain.shapes.metamodel.ScalarShapeModel$", {
  Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_metamodel_AnyShapeModel: 1,
  Lamf_core_metamodel_domain_ShapeModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1,
  Lamf_core_metamodel_domain_ExternalSourceElementModel: 1,
  Lamf_plugins_domain_shapes_metamodel_common_ExamplesField: 1,
  Lamf_plugins_domain_shapes_metamodel_common_DocumentationField: 1,
  Lamf_plugins_domain_shapes_metamodel_CommonShapeFields: 1
});
$c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$.prototype.$classData = $d_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$;
var $n_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$ = (void 0);
function $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$() {
  if ((!$n_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$)) {
    $n_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$ = new $c_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$() {
  $c_O.call(this);
  this.MediaType$1 = null;
  this.specificFields$1 = null;
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.XMLSerialization$1 = null;
  this.Comment$1 = null;
  this.Documentation$1 = null;
  this.Examples$1 = null;
  this.Raw$1 = null;
  this.ReferenceId$1 = null;
  this.Location$1 = null;
  this.Name$1 = null;
  this.DisplayName$1 = null;
  this.Default$1 = null;
  this.DefaultValueString$1 = null;
  this.Values$1 = null;
  this.Closure$1 = null;
  this.Inherits$1 = null;
  this.Or$1 = null;
  this.And$1 = null;
  this.Xone$1 = null;
  this.Not$1 = null;
  this.If$1 = null;
  this.Then$1 = null;
  this.Else$1 = null;
  this.ReadOnly$1 = null;
  this.WriteOnly$1 = null;
  this.Deprecated$1 = null;
  this.key$1 = null;
  this.CustomShapePropertyDefinitions$1 = null;
  this.CustomShapeProperties$1 = null;
  this.Description$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.constructor = $c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype = $c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype;
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$XMLSerialization$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.XMLSerialization$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$Comment$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Comment$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ShapeModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_ExternalSourceElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel__$$init$__V(this);
  return this
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Raw$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Raw$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$ReadOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReadOnly$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$common$DocumentationField$$undsetter$und$Documentation$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Documentation$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Deprecated$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Deprecated$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DefaultValueString$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DefaultValueString$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$AnyShapeModel$$undsetter$und$type$und$eq__sci_List__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$WriteOnly$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.WriteOnly$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$DisplayName$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DisplayName$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$plugins$domain$shapes$metamodel$common$ExamplesField$$undsetter$und$Examples$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Examples$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$Location$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Location$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$key$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.key$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Else$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Else$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Inherits$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Inherits$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$And$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.And$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_shapes_models_SchemaShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Not$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Not$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$If$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.If$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Closure$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Closure$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$ExternalSourceElementModel$$undsetter$und$ReferenceId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.ReferenceId$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Xone$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Xone$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.modelInstance__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_shapes_models_SchemaShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Values$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Values$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Or$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Or$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Then$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Then$1 = x$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.Name__Lamf_core_metamodel_Field = (function() {
  return this.Name$1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.amf$core$metamodel$domain$ShapeModel$$undsetter$und$Default$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Default$1 = x$1
});
var $d_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$: 0
}, false, "amf.plugins.domain.shapes.metamodel.SchemaShapeModel$", {
  Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$: 1,
  O: 1,
  Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel: 1,
  Lamf_plugins_domain_shapes_metamodel_AnyShapeModel: 1,
  Lamf_core_metamodel_domain_ShapeModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1,
  Lamf_core_metamodel_domain_ExternalSourceElementModel: 1,
  Lamf_plugins_domain_shapes_metamodel_common_ExamplesField: 1,
  Lamf_plugins_domain_shapes_metamodel_common_DocumentationField: 1
});
$c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$.prototype.$classData = $d_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$;
var $n_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$ = (void 0);
function $m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$() {
  if ((!$n_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$)) {
    $n_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$ = new $c_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$() {
  $c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.call(this);
  this.ClosedItems$2 = null;
  this.AdditionalItemsSchema$2 = null;
  this.TupleItems$2 = null;
  this.type$2 = null;
  this.fields$2 = null;
  this.doc$2 = null
}
$c_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$.prototype = new $h_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape();
$c_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$.prototype.constructor = $c_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$.prototype = $c_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$.prototype;
$c_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$.prototype.init___ = (function() {
  $c_Lamf_plugins_domain_shapes_metamodel_DataArrangementShape.prototype.init___.call(this);
  $n_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$ = this;
  var jsx$1 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.ClosedItems$2 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "closedItems"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "closed items", "Constraint limiting additional shapes in the collection", $m_sci_Nil$()), true);
  var jsx$2 = $m_Lamf_core_metamodel_domain_ShapeModel$();
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.AdditionalItemsSchema$2 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "additionalItemsSchema"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "additional items schema", "Controls whether it\u2019s valid to have additional items in the array beyond what is defined", $m_sci_Nil$()), true);
  var jsx$3 = new $c_Lamf_core_metamodel_Type$SortedArray().init___Lamf_core_metamodel_Type($m_Lamf_core_metamodel_domain_ShapeModel$());
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  this.TupleItems$2 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$3, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "items"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "items", "Shapes contained in the Tuple Shape", $m_sci_Nil$()), true);
  $m_sci_List$();
  var this$10 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var jsx$5 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$10, "TupleShape");
  var this$12 = $m_Lamf_core_vocabulary_Namespace$().Shapes$1;
  var array = [jsx$5, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$12, "ArrayShape")];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$17 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$17);
    i = (((-1) + i) | 0)
  };
  var jsx$6 = result;
  var jsx$4 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().type$1;
  var this$18 = $m_sci_List$();
  this.type$2 = $as_sci_List(jsx$6.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$4, this$18.ReusableCBFInstance$2));
  $m_sci_List$();
  var array$1 = [this.TupleItems$2, this.MinItems$1, this.MaxItems$1, this.UniqueItems$1, this.ClosedItems$2, this.AdditionalItemsSchema$2, this.CollectionFormat$1];
  var i$1 = (((-1) + $uI(array$1.length)) | 0);
  var result$1 = $m_sci_Nil$();
  while ((i$1 >= 0)) {
    var this$22 = result$1;
    var index$1 = i$1;
    var x$1 = array$1[index$1];
    result$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$22);
    i$1 = (((-1) + i$1) | 0)
  };
  var jsx$10 = result$1;
  var jsx$9 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().fields$1;
  var this$23 = $m_sci_List$();
  var jsx$8 = $as_sci_List(jsx$10.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$9, this$23.ReusableCBFInstance$2));
  var jsx$7 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$24 = $m_sci_List$();
  this.fields$2 = $as_sci_List(jsx$8.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$7, this$24.ReusableCBFInstance$2));
  this.doc$2 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().Shapes$1, "Tuple Shape", "Data shape containing a multi-valued collection of shapes", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$2
});
$c_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$.prototype.fields__sci_List = (function() {
  return this.fields$2
});
$c_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_shapes_models_TupleShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$.prototype.modelInstance__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_shapes_models_TupleShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$.prototype.type__sci_List = (function() {
  return this.type$2
});
var $d_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$: 0
}, false, "amf.plugins.domain.shapes.metamodel.TupleShapeModel$", {
  Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$: 1,
  Lamf_plugins_domain_shapes_metamodel_DataArrangementShape: 1,
  O: 1,
  Lamf_plugins_domain_shapes_metamodel_AnyShapeModel: 1,
  Lamf_core_metamodel_domain_ShapeModel: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1,
  Lamf_core_metamodel_domain_ExternalSourceElementModel: 1,
  Lamf_plugins_domain_shapes_metamodel_common_ExamplesField: 1,
  Lamf_plugins_domain_shapes_metamodel_common_DocumentationField: 1
});
$c_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$.prototype.$classData = $d_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$;
var $n_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$ = (void 0);
function $m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$() {
  if ((!$n_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$)) {
    $n_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$ = new $c_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$().init___()
  };
  return $n_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_MessageModel$() {
  $c_O.call(this);
  this.fields$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.Payloads$1 = null;
  this.CorrelationId$1 = null;
  this.DisplayName$1 = null;
  this.Title$1 = null;
  this.Summary$1 = null;
  this.Bindings$1 = null;
  this.Headers$1 = null;
  this.QueryParameters$1 = null;
  this.QueryString$1 = null;
  this.UriParameters$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Description$1 = null;
  this.Name$1 = null;
  this.IsAbstract$1 = null;
  this.Documentation$1 = null;
  this.Examples$1 = null;
  this.Tags$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_MessageModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_MessageModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.Extends$lzycompute__p1__Lamf_core_metamodel_Field = (function() {
  if (((((1 & this.bitmap$0$1) << 24) >> 24) === 0)) {
    this.Extends$1 = $f_Lamf_core_metamodel_domain_DomainElementModel__Extends__Lamf_core_metamodel_Field(this);
    this.bitmap$0$1 = (((1 | this.bitmap$0$1) << 24) >> 24)
  };
  return this.Extends$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_MessageModel$ = this;
  $f_Lamf_plugins_domain_webapi_metamodel_TagsModel__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_AbstractModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_ParametersFieldModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_MessageModel__$$init$__V(this);
  $m_sci_List$();
  var array = [this.Name$1, this.Description$1, this.Payloads$1, this.CorrelationId$1, this.DisplayName$1, this.Title$1, this.Summary$1, this.Headers$1, this.Bindings$1, this.Tags$1, this.Examples$1, this.Documentation$1, this.IsAbstract$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$4 = result;
  var jsx$3 = $m_Lamf_core_metamodel_domain_LinkableElementModel$().fields$1;
  var this$5 = $m_sci_List$();
  var jsx$2 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$5.ReusableCBFInstance$2));
  var jsx$1 = $m_Lamf_core_metamodel_domain_DomainElementModel$().fields$1;
  var this$6 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$6.ReusableCBFInstance$2));
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "Message");
  var this$9 = $m_Lamf_core_metamodel_domain_DomainElementModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$9);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Message", "", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$plugins$domain$webapi$metamodel$ParametersFieldModel$$undsetter$und$UriParameters$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.UriParameters$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$plugins$domain$shapes$metamodel$common$DocumentationField$$undsetter$und$Documentation$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Documentation$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$plugins$domain$webapi$metamodel$AbstractModel$$undsetter$und$IsAbstract$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsAbstract$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$CorrelationId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.CorrelationId$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$Payloads$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Payloads$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.Extends__Lamf_core_metamodel_Field = (function() {
  return (((((1 & this.bitmap$0$1) << 24) >> 24) === 0) ? this.Extends$lzycompute__p1__Lamf_core_metamodel_Field() : this.Extends$1)
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$Bindings$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Bindings$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$Summary$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Summary$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$plugins$domain$shapes$metamodel$common$ExamplesField$$undsetter$und$Examples$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Examples$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$plugins$domain$webapi$metamodel$ParametersFieldModel$$undsetter$und$Headers$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Headers$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_Message().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$plugins$domain$webapi$metamodel$ParametersFieldModel$$undsetter$und$QueryParameters$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.QueryParameters$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$plugins$domain$webapi$metamodel$TagsModel$$undsetter$und$Tags$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Tags$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$Title$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Title$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$DisplayName$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DisplayName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.amf$plugins$domain$webapi$metamodel$ParametersFieldModel$$undsetter$und$QueryString$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.QueryString$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_MessageModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_MessageModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.MessageModel$", {
  Lamf_plugins_domain_webapi_metamodel_MessageModel$: 1,
  O: 1,
  Lamf_plugins_domain_webapi_metamodel_MessageModel: 1,
  Lamf_plugins_domain_webapi_metamodel_TagsModel: 1,
  Lamf_plugins_domain_shapes_metamodel_common_ExamplesField: 1,
  Lamf_plugins_domain_shapes_metamodel_common_DocumentationField: 1,
  Lamf_plugins_domain_webapi_metamodel_AbstractModel: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_domain_webapi_metamodel_ParametersFieldModel: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_MessageModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_MessageModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_MessageModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_MessageModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_MessageModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_MessageModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_MessageModel$
}
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_CustomRaml08WebApiContext() {
  $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext.call(this)
}
$c_Lamf_plugins_domain_webapi_resolution_CustomRaml08WebApiContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext();
$c_Lamf_plugins_domain_webapi_resolution_CustomRaml08WebApiContext.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_CustomRaml08WebApiContext;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_CustomRaml08WebApiContext() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_CustomRaml08WebApiContext.prototype = $c_Lamf_plugins_domain_webapi_resolution_CustomRaml08WebApiContext.prototype;
$c_Lamf_plugins_domain_webapi_resolution_CustomRaml08WebApiContext.prototype.init___ = (function() {
  var jsx$1 = $m_sci_Nil$();
  var x$1 = new $c_Lamf_client_parse_IgnoringErrorHandler().init___();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$4 = new $c_scm_ListBuffer().init___();
  var x$3 = this$4.toList__sci_List();
  var x$4 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$11 = new $c_scm_ListBuffer().init___();
  var x$5 = new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$11.toList__sci_List());
  $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext.prototype.init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions.call(this, "", jsx$1, new $c_Lamf_core_parser_ParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext("", x$3, x$4, x$1, x$5), $m_s_None$(), $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2, new $c_Lamf_core_client_ParsingOptions().init___());
  return this
});
var $d_Lamf_plugins_domain_webapi_resolution_CustomRaml08WebApiContext = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_CustomRaml08WebApiContext: 0
}, false, "amf.plugins.domain.webapi.resolution.CustomRaml08WebApiContext", {
  Lamf_plugins_domain_webapi_resolution_CustomRaml08WebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_parser_raml_Raml08WebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_WebApiContext: 1,
  Lamf_core_parser_ParserContext: 1,
  O: 1,
  Lorg_yaml_model_ParseErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_plugins_document_webapi_contexts_SpecAwareContext: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecAwareContext: 1
});
$c_Lamf_plugins_domain_webapi_resolution_CustomRaml08WebApiContext.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_CustomRaml08WebApiContext;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_resolution_CustomRaml10WebApiContext() {
  $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext.call(this)
}
$c_Lamf_plugins_domain_webapi_resolution_CustomRaml10WebApiContext.prototype = new $h_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext();
$c_Lamf_plugins_domain_webapi_resolution_CustomRaml10WebApiContext.prototype.constructor = $c_Lamf_plugins_domain_webapi_resolution_CustomRaml10WebApiContext;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_resolution_CustomRaml10WebApiContext() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_resolution_CustomRaml10WebApiContext.prototype = $c_Lamf_plugins_domain_webapi_resolution_CustomRaml10WebApiContext.prototype;
$c_Lamf_plugins_domain_webapi_resolution_CustomRaml10WebApiContext.prototype.init___ = (function() {
  var jsx$1 = $m_sci_Nil$();
  var x$1 = new $c_Lamf_client_parse_IgnoringErrorHandler().init___();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$4 = new $c_scm_ListBuffer().init___();
  var x$3 = this$4.toList__sci_List();
  var x$4 = new $c_Lamf_core_parser_EmptyFutureDeclarations$$anon$1().init___();
  $m_sc_Seq$();
  $m_sci_Seq$();
  var this$11 = new $c_scm_ListBuffer().init___();
  var x$5 = new $c_Lamf_core_plugin_PluginContext().init___sc_Seq(this$11.toList__sci_List());
  $c_Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext.prototype.init___T__sc_Seq__Lamf_core_parser_ParserContext__s_Option__s_Enumeration$Value__Lamf_core_client_ParsingOptions.call(this, "", jsx$1, new $c_Lamf_core_parser_ParserContext().init___T__sc_Seq__Lamf_core_parser_FutureDeclarations__Lamf_core_parser_errorhandler_ParserErrorHandler__Lamf_core_plugin_PluginContext("", x$3, x$4, x$1, x$5), $m_s_None$(), $m_Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContextType$().DEFAULT$2, new $c_Lamf_core_client_ParsingOptions().init___());
  return this
});
var $d_Lamf_plugins_domain_webapi_resolution_CustomRaml10WebApiContext = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_resolution_CustomRaml10WebApiContext: 0
}, false, "amf.plugins.domain.webapi.resolution.CustomRaml10WebApiContext", {
  Lamf_plugins_domain_webapi_resolution_CustomRaml10WebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_parser_raml_Raml10WebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_parser_raml_RamlWebApiContext: 1,
  Lamf_plugins_document_webapi_contexts_WebApiContext: 1,
  Lamf_core_parser_ParserContext: 1,
  O: 1,
  Lorg_yaml_model_ParseErrorHandler: 1,
  Lorg_yaml_model_IllegalTypeHandler: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_plugins_document_webapi_contexts_SpecAwareContext: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_contexts_parser_raml_RamlSpecAwareContext: 1
});
$c_Lamf_plugins_domain_webapi_resolution_CustomRaml10WebApiContext.prototype.$classData = $d_Lamf_plugins_domain_webapi_resolution_CustomRaml10WebApiContext;
function $is_sc_Iterable(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_Iterable)))
}
function $as_sc_Iterable(obj) {
  return (($is_sc_Iterable(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.Iterable"))
}
function $isArrayOf_sc_Iterable(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_Iterable)))
}
function $asArrayOf_sc_Iterable(obj, depth) {
  return (($isArrayOf_sc_Iterable(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.Iterable;", depth))
}
function $f_sc_MapLike__apply__O__O($thiz, key) {
  var x1 = $thiz.get__O__s_Option(key);
  var x = $m_s_None$();
  if ((x === x1)) {
    return $thiz.$default__O__O(key)
  } else if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var value = x2.value$2;
    return value
  } else {
    throw new $c_s_MatchError().init___O(x1)
  }
}
function $f_sc_MapLike__isEmpty__Z($thiz) {
  return ($thiz.size__I() === 0)
}
function $f_sc_MapLike__getOrElse__O__F0__O($thiz, key, $default) {
  var x1 = $thiz.get__O__s_Option(key);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var v = x2.value$2;
    return v
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      return $default.apply__O()
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
}
function $f_sc_MapLike__toBuffer__scm_Buffer($thiz) {
  var result = new $c_scm_ArrayBuffer().init___I($thiz.size__I());
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, result$1) {
    return (function(x$7$2) {
      var x$7 = $as_T2(x$7$2);
      return result$1.$$plus$eq__O__scm_ArrayBuffer(x$7)
    })
  })($thiz, result)));
  return result
}
function $f_sc_MapLike__$default__O__O($thiz, key) {
  throw new $c_ju_NoSuchElementException().init___T(("key not found: " + key))
}
function $f_sc_MapLike__contains__O__Z($thiz, key) {
  return $thiz.get__O__s_Option(key).isDefined__Z()
}
function $f_sc_MapLike__addString__scm_StringBuilder__T__T__T__scm_StringBuilder($thiz, b, start, sep, end) {
  var this$2 = $thiz.iterator__sc_Iterator();
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var k = x0$1.$$und1__O();
        var v = x0$1.$$und2__O();
        return (("" + $m_s_Predef$any2stringadd$().$$plus$extension__O__T__T(k, " -> ")) + v)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })($thiz));
  var this$3 = new $c_sc_Iterator$$anon$10().init___sc_Iterator__F1(this$2, f);
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this$3, b, start, sep, end)
}
function $f_sc_MapLike__toSeq__sc_Seq($thiz) {
  if ($thiz.isEmpty__Z()) {
    var this$1 = $m_s_package$().Vector$1;
    return this$1.NIL$6
  } else {
    $m_s_package$();
    var vb = new $c_sci_VectorBuilder().init___();
    $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, vb$1) {
      return (function(x$6$2) {
        var x$6 = $as_T2(x$6$2);
        return vb$1.$$plus$eq__O__scm_Builder(x$6)
      })
    })($thiz, vb)));
    return vb.result__sci_Vector()
  }
}
function $f_sc_MapLike__filterNot__F1__sc_Map($thiz, p) {
  var elem = $as_sc_Map($thiz);
  var res = new $c_sr_ObjectRef().init___O(elem);
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, p$1, res$1) {
    return (function(kv$2) {
      var kv = $as_T2(kv$2);
      if ($uZ(p$1.apply__O__O(kv))) {
        res$1.elem$1 = $as_sc_Map(res$1.elem$1).$$minus__O__sc_Map(kv.$$und1__O())
      }
    })
  })($thiz, p, res)));
  return $as_sc_Map(res.elem$1)
}
function $f_sc_MapLike__applyOrElse__O__F1__O($thiz, x, $default) {
  return $thiz.getOrElse__O__F0__O(x, new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, $default$1, x$1) {
    return (function() {
      return $default$1.apply__O__O(x$1)
    })
  })($thiz, $default, x)))
}
function $is_sc_MapLike(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_MapLike)))
}
function $as_sc_MapLike(obj) {
  return (($is_sc_MapLike(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.MapLike"))
}
function $isArrayOf_sc_MapLike(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_MapLike)))
}
function $asArrayOf_sc_MapLike(obj, depth) {
  return (($isArrayOf_sc_MapLike(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.MapLike;", depth))
}
function $f_sc_TraversableViewLike$Appended__foreach__F1__V($thiz, f) {
  $thiz.scala$collection$TraversableViewLike$Appended$$$outer__sc_TraversableViewLike().foreach__F1__V(f);
  $thiz.rest__sc_GenTraversable().foreach__F1__V(f)
}
function $f_sc_TraversableViewLike$DroppedWhile__foreach__F1__V($thiz, f) {
  var go = new $c_sr_BooleanRef().init___Z(false);
  $thiz.scala$collection$TraversableViewLike$DroppedWhile$$$outer__sc_TraversableViewLike().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, go$1, f$1) {
    return (function(x$2) {
      if (((!go$1.elem$1) && (!$uZ($this.pred__F1().apply__O__O(x$2))))) {
        go$1.elem$1 = true
      };
      return (go$1.elem$1 ? f$1.apply__O__O(x$2) : (void 0))
    })
  })($thiz, go, f)))
}
function $f_sc_TraversableViewLike$Filtered__foreach__F1__V($thiz, f) {
  $thiz.scala$collection$TraversableViewLike$Filtered$$$outer__sc_TraversableViewLike().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, f$1) {
    return (function(x$2) {
      return ($uZ($this.pred__F1().apply__O__O(x$2)) ? f$1.apply__O__O(x$2) : (void 0))
    })
  })($thiz, f)))
}
function $f_sc_TraversableViewLike$FlatMapped__foreach__F1__V($thiz, f) {
  $thiz.scala$collection$TraversableViewLike$FlatMapped$$$outer__sc_TraversableViewLike().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, f$1) {
    return (function(x$2) {
      $as_sc_GenTraversableOnce($this.mapping__F1().apply__O__O(x$2)).seq__sc_TraversableOnce().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, f$3) {
        return (function(y$2) {
          return f$3.apply__O__O(y$2)
        })
      })($this, f$1)))
    })
  })($thiz, f)))
}
function $f_sc_TraversableViewLike$Mapped__foreach__F1__V($thiz, f) {
  $thiz.scala$collection$TraversableViewLike$Mapped$$$outer__sc_TraversableViewLike().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, f$1) {
    return (function(x$2) {
      return f$1.apply__O__O($this.mapping__F1().apply__O__O(x$2))
    })
  })($thiz, f)))
}
function $f_sc_TraversableViewLike$Prepended__foreach__F1__V($thiz, f) {
  $thiz.fst__sc_GenTraversable().foreach__F1__V(f);
  $thiz.scala$collection$TraversableViewLike$Prepended$$$outer__sc_TraversableViewLike().foreach__F1__V(f)
}
function $f_sc_TraversableViewLike$TakenWhile__foreach__F1__V($thiz, f) {
  var nonLocalReturnKey3 = new $c_O().init___();
  try {
    $thiz.scala$collection$TraversableViewLike$TakenWhile$$$outer__sc_TraversableViewLike().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, nonLocalReturnKey3$1, f$1) {
      return (function(x$2) {
        if ((!$uZ($this.pred__F1().apply__O__O(x$2)))) {
          throw new $c_sr_NonLocalReturnControl$mcV$sp().init___O__sr_BoxedUnit(nonLocalReturnKey3$1, (void 0))
        };
        return f$1.apply__O__O(x$2)
      })
    })($thiz, nonLocalReturnKey3, f)))
  } catch (e) {
    if ((e instanceof $c_sr_NonLocalReturnControl)) {
      var ex = $as_sr_NonLocalReturnControl(e);
      if ((ex.key$2 === nonLocalReturnKey3)) {
        ex.value$mcV$sp__V()
      } else {
        throw ex
      }
    } else {
      throw e
    }
  }
}
/** @constructor */
function $c_Lamf_client_model_domain_MatrixShape() {
  $c_Lamf_client_model_domain_ArrayShape.call(this)
}
$c_Lamf_client_model_domain_MatrixShape.prototype = new $h_Lamf_client_model_domain_ArrayShape();
$c_Lamf_client_model_domain_MatrixShape.prototype.constructor = $c_Lamf_client_model_domain_MatrixShape;
/** @constructor */
function $h_Lamf_client_model_domain_MatrixShape() {
  /*<skip>*/
}
$h_Lamf_client_model_domain_MatrixShape.prototype = $c_Lamf_client_model_domain_MatrixShape.prototype;
$c_Lamf_client_model_domain_MatrixShape.prototype.init___ = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var _internal = new $c_Lamf_plugins_domain_shapes_models_ArrayShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $c_Lamf_client_model_domain_ArrayShape.prototype.init___Lamf_plugins_domain_shapes_models_ArrayShape.call(this, _internal);
  return this
});
$c_Lamf_client_model_domain_MatrixShape.prototype.init___Lamf_plugins_domain_shapes_models_ArrayShape = (function(_internal) {
  $c_Lamf_client_model_domain_ArrayShape.prototype.init___Lamf_plugins_domain_shapes_models_ArrayShape.call(this, _internal);
  return this
});
$c_Lamf_client_model_domain_MatrixShape.prototype.$$undinternal__Lamf_core_model_domain_Shape = (function() {
  return this.$$undinternal$3
});
$c_Lamf_client_model_domain_MatrixShape.prototype.$$undinternal__Lamf_core_model_domain_DomainElement = (function() {
  return this.$$undinternal$3
});
$c_Lamf_client_model_domain_MatrixShape.prototype.$$undinternal__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this.$$undinternal$3
});
$c_Lamf_client_model_domain_MatrixShape.prototype.$$undinternal__Lamf_plugins_domain_shapes_models_ArrayShape = (function() {
  return this.$$undinternal$3
});
$c_Lamf_client_model_domain_MatrixShape.prototype.$$undinternal__Lamf_plugins_domain_shapes_models_DataArrangementShape = (function() {
  return this.$$undinternal$3
});
$c_Lamf_client_model_domain_MatrixShape.prototype.$$undinternal__Lamf_core_model_domain_AmfObject = (function() {
  return this.$$undinternal$3
});
$c_Lamf_client_model_domain_MatrixShape.prototype.withItems__Lamf_client_model_domain_Shape__Lamf_client_model_domain_MatrixShape = (function(items) {
  if ((items instanceof $c_Lamf_client_model_domain_ArrayShape)) {
    return $as_Lamf_client_model_domain_MatrixShape($c_Lamf_client_model_domain_ArrayShape.prototype.withItems__Lamf_client_model_domain_Shape__Lamf_client_model_domain_ArrayShape.call(this, items))
  } else {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(new $c_jl_Exception().init___T("Matrix shapes can only accept arrays as items"))
  }
});
$c_Lamf_client_model_domain_MatrixShape.prototype.withItems__Lamf_client_model_domain_Shape__Lamf_client_model_domain_ArrayShape = (function(items) {
  return this.withItems__Lamf_client_model_domain_Shape__Lamf_client_model_domain_MatrixShape(items)
});
$c_Lamf_client_model_domain_MatrixShape.prototype.$$js$exported$meth$withItems__Lamf_client_model_domain_Shape__O = (function(items) {
  return this.withItems__Lamf_client_model_domain_Shape__Lamf_client_model_domain_MatrixShape(items)
});
function $as_Lamf_client_model_domain_MatrixShape(obj) {
  return (((obj instanceof $c_Lamf_client_model_domain_MatrixShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.client.model.domain.MatrixShape"))
}
function $isArrayOf_Lamf_client_model_domain_MatrixShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_client_model_domain_MatrixShape)))
}
function $asArrayOf_Lamf_client_model_domain_MatrixShape(obj, depth) {
  return (($isArrayOf_Lamf_client_model_domain_MatrixShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.client.model.domain.MatrixShape;", depth))
}
var $d_Lamf_client_model_domain_MatrixShape = new $TypeData().initClass({
  Lamf_client_model_domain_MatrixShape: 0
}, false, "amf.client.model.domain.MatrixShape", {
  Lamf_client_model_domain_MatrixShape: 1,
  Lamf_client_model_domain_ArrayShape: 1,
  Lamf_client_model_domain_DataArrangeShape: 1,
  Lamf_client_model_domain_AnyShape: 1,
  O: 1,
  Lamf_client_model_domain_Shape: 1,
  Lamf_client_model_domain_DomainElement: 1,
  Lamf_client_model_AmfObjectWrapper: 1,
  Lamf_client_model_Annotable: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_model_domain_Linkable: 1,
  Lamf_client_model_domain_NamedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_client_model_domain_MatrixShape.prototype.$classData = $d_Lamf_client_model_domain_MatrixShape;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_model_document_DialectInstance() {
  $c_O.call(this);
  this.fields$1 = null;
  this.annotations$1 = null;
  this.composedDialects$1 = null;
  this.amf$core$model$document$BaseUnit$$run$1 = null;
  this.raw$1 = null;
  this.platform$1 = null;
  this.id$1 = null
}
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype = new $h_O();
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.constructor = $c_Lamf_plugins_document_vocabularies_model_document_DialectInstance;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_model_document_DialectInstance() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype = $c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype;
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.productPrefix__T = (function() {
  return "DialectInstance"
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstance)) {
    var DialectInstance$1 = $as_Lamf_plugins_document_vocabularies_model_document_DialectInstance(x$1);
    var x = this.fields$1;
    var x$2 = DialectInstance$1.fields$1;
    if ((x === x$2)) {
      var x$3 = this.annotations$1;
      var x$4 = DialectInstance$1.annotations$1;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.raw$und$eq__s_Option__V = (function(x$1) {
  this.raw$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$1;
      break
    }
    case 1: {
      return this.annotations$1;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$()
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.componentId__T = (function() {
  return ""
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.references__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().References$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.cloneElement__scm_Map__Lamf_core_model_domain_AmfElement = (function(branch) {
  return $f_Lamf_core_model_document_BaseUnit__cloneElement__scm_Map__Lamf_core_model_domain_AmfObject(this, branch)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.transform__F1__F2__Lamf_core_errorhandling_ErrorHandler__Lamf_core_model_document_BaseUnit = (function(selector, transformation, errorHandler) {
  var domainElementAdapter = new $c_Lamf_core_traversal_DomainElementSelectorAdapter().init___F1(selector);
  var transformationAdapter = new $c_Lamf_core_traversal_DomainElementTransformationAdapter().init___F2(transformation);
  var qual$1 = new $c_Lamf_core_traversal_TransformationTraversal().init___Lamf_core_traversal_TransformationData(new $c_Lamf_core_traversal_TransformationData().init___F1__F2(domainElementAdapter, transformationAdapter));
  var x$2 = new $c_Lamf_core_traversal_ObjectIdTraversalPath().init___scm_Set($as_scm_Set($m_scm_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())));
  qual$1.traverse__Lamf_core_model_domain_AmfObject__Lamf_core_traversal_TraversalPath__Lamf_core_model_domain_AmfObject(this, x$2);
  return this
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_document_BaseUnit__location__s_Option(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.amf$core$model$document$BaseUnit$$run__s_Option = (function() {
  return this.amf$core$model$document$BaseUnit$$run$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.declares__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().Declares$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.amf$core$model$document$BaseUnit$$run$und$eq__s_Option__V = (function(x$1) {
  this.amf$core$model$document$BaseUnit$$run$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.graphDependencies__sc_Seq = (function() {
  return $as_sc_Seq(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().GraphDependencies$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.raw__s_Option = (function() {
  return this.raw$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.composedDialects$und$eq__sci_Map__V = (function(x$1) {
  this.composedDialects$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.encodes__Lamf_core_model_domain_DomainElement = (function() {
  return $as_Lamf_core_model_domain_DomainElement(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().Encodes$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.definedBy__Lamf_core_model_StrField = (function() {
  return $as_Lamf_core_model_StrField(this.fields$1.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_document_vocabularies_metamodel_document_DialectInstanceModel$().DefinedBy$1))
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.id__T = (function() {
  return this.id$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.id$und$eq__T__V = (function(x$1) {
  this.id$1 = x$1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$1 = fields;
  this.annotations$1 = annotations;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  $f_Lamf_core_model_document_BaseUnit__$$init$__V(this);
  $f_Lamf_plugins_document_vocabularies_model_document_ComposedInstancesSupport__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_document_vocabularies_model_document_DialectInstance(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_model_document_DialectInstance) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.model.document.DialectInstance"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_model_document_DialectInstance(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_model_document_DialectInstance)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_model_document_DialectInstance(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_model_document_DialectInstance(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.model.document.DialectInstance;", depth))
}
var $d_Lamf_plugins_document_vocabularies_model_document_DialectInstance = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_model_document_DialectInstance: 0
}, false, "amf.plugins.document.vocabularies.model.document.DialectInstance", {
  Lamf_plugins_document_vocabularies_model_document_DialectInstance: 1,
  O: 1,
  Lamf_plugins_document_vocabularies_model_document_DialectInstanceUnit: 1,
  Lamf_core_model_document_BaseUnit: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_metamodel_MetaModelTypeMapping: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_vocabularies_model_document_ExternalContext: 1,
  Lamf_core_model_document_DeclaresModel: 1,
  Lamf_core_model_document_EncodesModel: 1,
  Lamf_plugins_document_vocabularies_model_document_ComposedInstancesSupport: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_model_document_DialectInstance.prototype.$classData = $d_Lamf_plugins_document_vocabularies_model_document_DialectInstance;
/** @constructor */
function $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble() {
  $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.call(this);
  this.idPart$2 = null;
  this.part$2 = null;
  this.namespace$2 = null;
  this.$$outer$2 = null
}
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble.prototype = new $h_Lamf_plugins_document_vocabularies_model_domain_NodeMapping();
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble.prototype.constructor = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble;
/** @constructor */
function $h_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble() {
  /*<skip>*/
}
$h_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble.prototype = $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble.prototype;
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble.prototype.productPrefix__T = (function() {
  return "ErrorNodeMapabble"
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble.prototype.init___Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations__T__Lorg_yaml_model_YPart = (function($$outer, idPart, part) {
  this.idPart$2 = idPart;
  this.part$2 = part;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  $c_Lamf_plugins_document_vocabularies_model_domain_NodeMapping.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, new $c_Lamf_core_parser_Fields().init___(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(part));
  this.namespace$2 = "http://amferror.com/#errorNodeMappable/";
  $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, idPart);
  return this
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble.prototype.namespace__T = (function() {
  return this.namespace$2
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble.prototype.newErrorInstance__Lamf_core_annotations_ErrorDeclaration = (function() {
  return new $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble().init___Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations__T__Lorg_yaml_model_YPart(this.$$outer$2, this.idPart$2, this.part$2)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble.prototype.originalMeta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappingModel$()
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if (((x$1 instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble) && ($as_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble(x$1).$$outer$2 === this.$$outer$2))) {
    var ErrorNodeMapabble$1 = $as_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble(x$1);
    if ((this.idPart$2 === ErrorNodeMapabble$1.idPart$2)) {
      var x = this.part$2;
      var x$2 = ErrorNodeMapabble$1.part$2;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, value)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.idPart$2;
      break
    }
    case 1: {
      return this.part$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return new $c_Lamf_core_annotations_ErrorDeclaration$$anon$1().init___Lamf_core_annotations_ErrorDeclaration(this)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble.prototype.amf$core$annotations$ErrorDeclaration$$super$withId__T__Lamf_core_annotations_ErrorDeclaration = (function(value) {
  return $as_Lamf_core_annotations_ErrorDeclaration($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value))
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.vocabularies.parser.dialects.DialectDeclarations$ErrorNodeMapabble"))
}
function $isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble)))
}
function $asArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.vocabularies.parser.dialects.DialectDeclarations$ErrorNodeMapabble;", depth))
}
var $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble = new $TypeData().initClass({
  Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble: 0
}, false, "amf.plugins.document.vocabularies.parser.dialects.DialectDeclarations$ErrorNodeMapabble", {
  Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble: 1,
  Lamf_plugins_document_vocabularies_model_domain_NodeMapping: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_plugins_document_vocabularies_model_domain_MergeableMapping: 1,
  Lamf_plugins_document_vocabularies_metamodel_domain_MergeableMappingModel: 1,
  Lamf_plugins_document_vocabularies_model_domain_NodeMappable: 1,
  Lamf_plugins_document_vocabularies_metamodel_domain_NodeMappableModel: 1,
  Lamf_core_annotations_ErrorDeclaration: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble.prototype.$classData = $d_Lamf_plugins_document_vocabularies_parser_dialects_DialectDeclarations$ErrorNodeMapabble;
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait() {
  $c_Lamf_plugins_domain_webapi_models_Operation.call(this);
  this.idPart$2 = null;
  this.ast$2 = null;
  this.namespace$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait.prototype = new $h_Lamf_plugins_domain_webapi_models_Operation();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait.prototype.originalMeta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait.prototype.newErrorInstance__Lamf_core_annotations_ErrorDeclaration = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait().init___T__Lorg_yaml_model_YPart(this.idPart$2, this.ast$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait.prototype.namespace__T = (function() {
  return this.namespace$2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return new $c_Lamf_core_annotations_ErrorDeclaration$$anon$1().init___Lamf_core_annotations_ErrorDeclaration(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait.prototype.init___T__Lorg_yaml_model_YPart = (function(idPart, ast) {
  this.idPart$2 = idPart;
  this.ast$2 = ast;
  $c_Lamf_plugins_domain_webapi_models_Operation.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, new $c_Lamf_core_parser_Fields().init___(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast));
  this.namespace$2 = "http://amferror.com/#operationTraits/";
  $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, idPart);
  var field = $m_Lamf_plugins_domain_webapi_metamodel_OperationModel$().IsAbstract$1;
  $as_Lamf_plugins_domain_webapi_models_Operation($f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Z__Lamf_core_model_domain_AmfObject(this, field, true));
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait.prototype.amf$core$annotations$ErrorDeclaration$$super$withId__T__Lamf_core_annotations_ErrorDeclaration = (function(value) {
  return $as_Lamf_core_annotations_ErrorDeclaration($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value))
});
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorOperationTrait", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait: 1,
  Lamf_plugins_domain_webapi_models_Operation: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_plugins_domain_webapi_models_ExtensibleWebApiDomainElement: 1,
  Lamf_plugins_domain_webapi_models_ServerContainer: 1,
  Lamf_plugins_domain_webapi_models_DocumentedElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  Lamf_core_annotations_ErrorDeclaration: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorOperationTrait;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_RequestModel$() {
  $c_O.call(this);
  this.Required$1 = null;
  this.CookieParameters$1 = null;
  this.type$1 = null;
  this.doc$1 = null;
  this.key$1 = null;
  this.Payloads$1 = null;
  this.CorrelationId$1 = null;
  this.DisplayName$1 = null;
  this.Title$1 = null;
  this.Summary$1 = null;
  this.Bindings$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Description$1 = null;
  this.Name$1 = null;
  this.IsAbstract$1 = null;
  this.Documentation$1 = null;
  this.Examples$1 = null;
  this.Tags$1 = null;
  this.Headers$1 = null;
  this.QueryParameters$1 = null;
  this.QueryString$1 = null;
  this.UriParameters$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_RequestModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_RequestModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_RequestModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_ParametersFieldModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_TagsModel__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_AbstractModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_MessageModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Bool$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Required$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "required"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "required", "Marks the parameter as required", $m_sci_Nil$()), true);
  var jsx$2 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_ParameterModel$());
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.CookieParameters$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "cookieParameter"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "cookie parameter", "", $m_sci_Nil$()), true);
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "Request");
  var this$9 = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$9);
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Request", "Request information for an operation", $m_sci_Nil$());
  this.key$1 = this.Name$1;
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$plugins$domain$webapi$metamodel$ParametersFieldModel$$undsetter$und$UriParameters$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.UriParameters$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$CorrelationId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.CorrelationId$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$plugins$domain$webapi$metamodel$AbstractModel$$undsetter$und$IsAbstract$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsAbstract$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$plugins$domain$shapes$metamodel$common$DocumentationField$$undsetter$und$Documentation$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Documentation$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$Payloads$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Payloads$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$Bindings$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Bindings$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.fields__sci_List = (function() {
  $m_sci_List$();
  var array = [this.Required$1, this.QueryParameters$1, this.QueryString$1, this.UriParameters$1, this.CookieParameters$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$4 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$4);
    i = (((-1) + i) | 0)
  };
  var jsx$2 = result;
  var jsx$1 = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().fields$1;
  var this$5 = $m_sci_List$();
  return $as_sci_List(jsx$2.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$1, this$5.ReusableCBFInstance$2))
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$Summary$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Summary$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$plugins$domain$shapes$metamodel$common$ExamplesField$$undsetter$und$Examples$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Examples$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$plugins$domain$webapi$metamodel$ParametersFieldModel$$undsetter$und$Headers$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Headers$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_Request().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$plugins$domain$webapi$metamodel$ParametersFieldModel$$undsetter$und$QueryParameters$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.QueryParameters$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$plugins$domain$webapi$metamodel$TagsModel$$undsetter$und$Tags$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Tags$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$Title$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Title$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$plugins$domain$webapi$metamodel$ParametersFieldModel$$undsetter$und$QueryString$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.QueryString$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$DisplayName$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DisplayName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_RequestModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_RequestModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.RequestModel$", {
  Lamf_plugins_domain_webapi_metamodel_RequestModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_plugins_domain_webapi_metamodel_ParametersFieldModel: 1,
  Lamf_plugins_domain_webapi_metamodel_MessageModel: 1,
  Lamf_plugins_domain_webapi_metamodel_TagsModel: 1,
  Lamf_plugins_domain_shapes_metamodel_common_ExamplesField: 1,
  Lamf_plugins_domain_shapes_metamodel_common_DocumentationField: 1,
  Lamf_plugins_domain_webapi_metamodel_AbstractModel: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_RequestModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_RequestModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_RequestModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_RequestModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_RequestModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_RequestModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_RequestModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_RequestModel$
}
function $f_sc_SortedSetLike__subsetOf__sc_GenSet__Z($thiz, that) {
  if ($is_sc_SortedSet(that)) {
    var x2 = $as_sc_SortedSet(that);
    var x = x2.ordering$1;
    var x$2 = $thiz.ordering$1;
    if ((x === x$2)) {
      var j = $thiz.iterator__sc_Iterator();
      return $f_scg_Sorted__hasAll__sc_Iterator__Z(x2, j)
    }
  };
  var this$1 = $thiz.iterator__sc_Iterator();
  return $f_sc_Iterator__forall__F1__Z(this$1, that)
}
function $f_sci_MapLike__$$plus$plus__sc_GenTraversableOnce__sci_Map($thiz, xs) {
  var x$1 = $as_sci_Map($thiz);
  return $as_sci_Map(xs.seq__sc_TraversableOnce().$$div$colon__O__F2__O(x$1, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(x$2$2, x$3$2) {
      var x$2 = $as_sci_Map(x$2$2);
      var x$3 = $as_T2(x$3$2);
      return x$2.$$plus__T2__sci_Map(x$3)
    })
  })($thiz))))
}
function $f_sci_MapLike__updated__O__O__sci_Map($thiz, key, value) {
  return $thiz.$$plus__T2__sci_Map(new $c_T2().init___O__O(key, value))
}
function $is_sci_MapLike(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sci_MapLike)))
}
function $as_sci_MapLike(obj) {
  return (($is_sci_MapLike(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.MapLike"))
}
function $isArrayOf_sci_MapLike(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_MapLike)))
}
function $asArrayOf_sci_MapLike(obj, depth) {
  return (($isArrayOf_sci_MapLike(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.MapLike;", depth))
}
/** @constructor */
function $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample() {
  $c_Lamf_plugins_domain_shapes_models_Example.call(this);
  this.idPart$2 = null;
  this.ast$2 = null;
  this.namespace$2 = null
}
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample.prototype = new $h_Lamf_plugins_domain_shapes_models_Example();
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample.prototype.constructor = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample;
/** @constructor */
function $h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample() {
  /*<skip>*/
}
$h_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample.prototype = $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample.prototype;
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample.prototype.productPrefix__T = (function() {
  return "ErrorNamedExample"
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample.prototype.namespace__T = (function() {
  return this.namespace$2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample.prototype.originalMeta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_shapes_metamodel_ExampleModel$()
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample.prototype.newErrorInstance__Lamf_core_annotations_ErrorDeclaration = (function() {
  return new $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample().init___T__Lorg_yaml_model_YPart(this.idPart$2, this.ast$2)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample)) {
    var ErrorNamedExample$1 = $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample(x$1);
    if ((this.idPart$2 === ErrorNamedExample$1.idPart$2)) {
      var x = this.ast$2;
      var x$2 = ErrorNamedExample$1.ast$2;
      return ((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample.prototype.withId__T__Lamf_core_model_domain_AmfObject = (function(value) {
  return $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, value)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.idPart$2;
      break
    }
    case 1: {
      return this.ast$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return new $c_Lamf_core_annotations_ErrorDeclaration$$anon$1().init___Lamf_core_annotations_ErrorDeclaration(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample.prototype.init___T__Lorg_yaml_model_YPart = (function(idPart, ast) {
  this.idPart$2 = idPart;
  this.ast$2 = ast;
  $c_Lamf_plugins_domain_shapes_models_Example.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, new $c_Lamf_core_parser_Fields().init___(), $m_Lamf_core_parser_Annotations$().apply__Lorg_yaml_model_YPart__Lamf_core_parser_Annotations(ast));
  this.namespace$2 = "http://amferror.com/#errorNamedExample/";
  $f_Lamf_core_annotations_ErrorDeclaration__withId__T__Lamf_core_annotations_ErrorDeclaration(this, idPart);
  return this
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample.prototype.amf$core$annotations$ErrorDeclaration$$super$withId__T__Lamf_core_annotations_ErrorDeclaration = (function(value) {
  return $as_Lamf_core_annotations_ErrorDeclaration($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this, value))
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample(obj) {
  return (((obj instanceof $c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorNamedExample"))
}
function $isArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample)))
}
function $asArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample(obj, depth) {
  return (($isArrayOf_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorNamedExample;", depth))
}
var $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample = new $TypeData().initClass({
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample: 0
}, false, "amf.plugins.document.webapi.parser.spec.WebApiDeclarations$ErrorNamedExample", {
  Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample: 1,
  Lamf_plugins_domain_shapes_models_Example: 1,
  O: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_ExternalSourceElement: 1,
  Lamf_plugins_document_webapi_parser_spec_common_PayloadSerializer: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_domain_webapi_models_Key: 1,
  Lamf_core_annotations_ErrorDeclaration: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample.prototype.$classData = $d_Lamf_plugins_document_webapi_parser_spec_WebApiDeclarations$ErrorNamedExample;
/** @constructor */
function $c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$() {
  $c_O.call(this);
  this.StatusCode$1 = null;
  this.Links$1 = null;
  this.key$1 = null;
  this.type$1 = null;
  this.fields$1 = null;
  this.doc$1 = null;
  this.Payloads$1 = null;
  this.CorrelationId$1 = null;
  this.DisplayName$1 = null;
  this.Title$1 = null;
  this.Summary$1 = null;
  this.Bindings$1 = null;
  this.Headers$1 = null;
  this.QueryParameters$1 = null;
  this.QueryString$1 = null;
  this.UriParameters$1 = null;
  this.TargetId$1 = null;
  this.Target$1 = null;
  this.Label$1 = null;
  this.SupportsRecursion$1 = null;
  this.Description$1 = null;
  this.Name$1 = null;
  this.IsAbstract$1 = null;
  this.Documentation$1 = null;
  this.Examples$1 = null;
  this.Tags$1 = null;
  this.Optional$1 = null;
  this.Extends$1 = null;
  this.Sources$1 = null;
  this.CustomDomainProperties$1 = null;
  this.IsExternalLink$1 = null;
  this.bitmap$0$1 = 0
}
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype = new $h_O();
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.constructor = $c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$;
/** @constructor */
function $h_Lamf_plugins_domain_webapi_metamodel_ResponseModel$() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype = $c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype;
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Target$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Target$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$TargetId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.TargetId$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.init___ = (function() {
  $n_Lamf_plugins_domain_webapi_metamodel_ResponseModel$ = this;
  $f_Lamf_core_metamodel_Obj__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_DomainElementModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_templates_OptionalField__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_TagsModel__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField__$$init$__V(this);
  $f_Lamf_plugins_domain_shapes_metamodel_common_DocumentationField__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_AbstractModel__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_NameFieldSchema__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_common_DescriptionField__$$init$__V(this);
  $f_Lamf_core_metamodel_domain_LinkableElementModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_ParametersFieldModel__$$init$__V(this);
  $f_Lamf_plugins_domain_webapi_metamodel_MessageModel__$$init$__V(this);
  var jsx$1 = $m_Lamf_core_metamodel_Type$Str$();
  var this$1 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.StatusCode$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$1, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$1, "statusCode"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "status code", "HTTP status code returned by a response", $m_sci_Nil$()), true);
  var jsx$2 = new $c_Lamf_core_metamodel_Type$Array().init___Lamf_core_metamodel_Type($m_Lamf_plugins_domain_webapi_metamodel_TemplatedLinkModel$());
  var this$4 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  this.Links$1 = new $c_Lamf_core_metamodel_Field().init___Lamf_core_metamodel_Type__Lamf_core_vocabulary_ValueType__Lamf_core_metamodel_domain_ModelDoc__Z(jsx$2, new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$4, "link"), new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "links", "Structural definition of links on the source data shape AST", $m_sci_Nil$()), true);
  this.key$1 = this.StatusCode$1;
  var this$7 = $m_Lamf_core_vocabulary_Namespace$().ApiContract$1;
  var x$1 = new $c_Lamf_core_vocabulary_ValueType().init___Lamf_core_vocabulary_Namespace__T(this$7, "Response");
  var this$9 = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().type$1;
  this.type$1 = new $c_sci_$colon$colon().init___O__sci_List(x$1, this$9);
  $m_sci_List$();
  var array = [this.StatusCode$1, this.Links$1];
  var i = (((-1) + $uI(array.length)) | 0);
  var result = $m_sci_Nil$();
  while ((i >= 0)) {
    var this$13 = result;
    var index = i;
    var x = array[index];
    result = new $c_sci_$colon$colon().init___O__sci_List(x, this$13);
    i = (((-1) + i) | 0)
  };
  var jsx$4 = result;
  var jsx$3 = $m_Lamf_plugins_domain_webapi_metamodel_MessageModel$().fields$1;
  var this$14 = $m_sci_List$();
  this.fields$1 = $as_sci_List(jsx$4.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(jsx$3, this$14.ReusableCBFInstance$2));
  this.doc$1 = new $c_Lamf_core_metamodel_domain_ModelDoc().init___Lamf_core_metamodel_domain_ModelVocabulary__T__T__sc_Seq($m_Lamf_core_metamodel_domain_ModelVocabularies$().ApiContract$1, "Response", "Response information for an operation", $m_sci_Nil$());
  return this
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$Sources$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Sources$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$plugins$domain$webapi$metamodel$ParametersFieldModel$$undsetter$und$UriParameters$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.UriParameters$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$core$metamodel$domain$templates$OptionalField$$undsetter$und$Optional$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Optional$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$CorrelationId$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.CorrelationId$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$plugins$domain$webapi$metamodel$AbstractModel$$undsetter$und$IsAbstract$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsAbstract$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$plugins$domain$shapes$metamodel$common$DocumentationField$$undsetter$und$Documentation$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Documentation$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$core$metamodel$Obj$$undsetter$und$doc$und$eq__Lamf_core_metamodel_domain_ModelDoc__V = (function(x$1) {
  /*<skip>*/
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$Payloads$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Payloads$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$Bindings$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Bindings$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$SupportsRecursion$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.SupportsRecursion$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.doc__Lamf_core_metamodel_domain_ModelDoc = (function() {
  return this.doc$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.fields__sci_List = (function() {
  return this.fields$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$core$metamodel$domain$LinkableElementModel$$undsetter$und$Label$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Label$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$Summary$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Summary$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$plugins$domain$shapes$metamodel$common$ExamplesField$$undsetter$und$Examples$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Examples$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$plugins$domain$webapi$metamodel$ParametersFieldModel$$undsetter$und$Headers$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Headers$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$core$metamodel$domain$DomainElementModel$$undsetter$und$IsExternalLink$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.IsExternalLink$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.key__Lamf_core_metamodel_Field = (function() {
  return this.key$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$core$metamodel$domain$common$DescriptionField$$undsetter$und$Description$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Description$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.modelInstance__Lamf_core_model_domain_AmfObject = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  return new $c_Lamf_plugins_domain_webapi_models_Response().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations)
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$plugins$domain$webapi$metamodel$ParametersFieldModel$$undsetter$und$QueryParameters$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.QueryParameters$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.Optional__Lamf_core_metamodel_Field = (function() {
  return this.Optional$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$plugins$domain$webapi$metamodel$TagsModel$$undsetter$und$Tags$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Tags$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.type__sci_List = (function() {
  return this.type$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$Title$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Title$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$plugins$domain$webapi$metamodel$ParametersFieldModel$$undsetter$und$QueryString$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.QueryString$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$plugins$domain$webapi$metamodel$MessageModel$$undsetter$und$DisplayName$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.DisplayName$1 = x$1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.amf$core$metamodel$domain$common$NameFieldSchema$$undsetter$und$Name$und$eq__Lamf_core_metamodel_Field__V = (function(x$1) {
  this.Name$1 = x$1
});
var $d_Lamf_plugins_domain_webapi_metamodel_ResponseModel$ = new $TypeData().initClass({
  Lamf_plugins_domain_webapi_metamodel_ResponseModel$: 0
}, false, "amf.plugins.domain.webapi.metamodel.ResponseModel$", {
  Lamf_plugins_domain_webapi_metamodel_ResponseModel$: 1,
  O: 1,
  Lamf_core_metamodel_domain_DomainElementModel: 1,
  Lamf_core_metamodel_Obj: 1,
  Lamf_core_metamodel_Type: 1,
  Lamf_core_metamodel_ModelDefaultBuilder: 1,
  Lamf_core_metamodel_domain_templates_KeyField: 1,
  Lamf_core_metamodel_domain_templates_OptionalField: 1,
  Lamf_plugins_domain_webapi_metamodel_MessageModel: 1,
  Lamf_plugins_domain_webapi_metamodel_TagsModel: 1,
  Lamf_plugins_domain_shapes_metamodel_common_ExamplesField: 1,
  Lamf_plugins_domain_shapes_metamodel_common_DocumentationField: 1,
  Lamf_plugins_domain_webapi_metamodel_AbstractModel: 1,
  Lamf_core_metamodel_domain_common_NameFieldSchema: 1,
  Lamf_core_metamodel_domain_common_DescriptionField: 1,
  Lamf_core_metamodel_domain_LinkableElementModel: 1,
  Lamf_plugins_domain_webapi_metamodel_ParametersFieldModel: 1
});
$c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$.prototype.$classData = $d_Lamf_plugins_domain_webapi_metamodel_ResponseModel$;
var $n_Lamf_plugins_domain_webapi_metamodel_ResponseModel$ = (void 0);
function $m_Lamf_plugins_domain_webapi_metamodel_ResponseModel$() {
  if ((!$n_Lamf_plugins_domain_webapi_metamodel_ResponseModel$)) {
    $n_Lamf_plugins_domain_webapi_metamodel_ResponseModel$ = new $c_Lamf_plugins_domain_webapi_metamodel_ResponseModel$().init___()
  };
  return $n_Lamf_plugins_domain_webapi_metamodel_ResponseModel$
}
function $f_sci_StringLike__scala$collection$immutable$StringLike$$isLineBreak__C__Z($thiz, c) {
  return ((c === 10) || (c === 12))
}
function $f_sci_StringLike__parseBoolean__psci_StringLike__T__Z($thiz, s) {
  if ((s !== null)) {
    var x1 = $as_T(s.toLowerCase());
    if ((x1 === "true")) {
      return true
    } else if ((x1 === "false")) {
      return false
    } else {
      throw new $c_jl_IllegalArgumentException().init___T((("For input string: \"" + s) + "\""))
    }
  } else {
    throw new $c_jl_IllegalArgumentException().init___T("For input string: \"null\"")
  }
}
function $f_sci_StringLike__escape__psci_StringLike__C__T($thiz, ch) {
  return (((((ch >= 97) && (ch <= 122)) || ((ch >= 65) && (ch <= 90))) || ((ch >= 48) && (ch <= 57))) ? $as_T($g.String.fromCharCode(ch)) : ("\\" + new $c_jl_Character().init___C(ch)))
}
function $f_sci_StringLike__unwrapArg__psci_StringLike__O__O($thiz, arg) {
  if ((arg instanceof $c_s_math_ScalaNumber)) {
    var x2 = $as_s_math_ScalaNumber(arg);
    return x2.underlying__O()
  } else {
    return arg
  }
}
function $f_sci_StringLike__slice__I__I__O($thiz, from, until) {
  var start = ((from > 0) ? from : 0);
  var that = $thiz.length__I();
  var end = ((until < that) ? until : that);
  if ((start >= end)) {
    return $thiz.newBuilder__scm_Builder().result__O()
  } else {
    var jsx$1 = $thiz.newBuilder__scm_Builder();
    var thiz = $thiz.toString__T();
    var x = $as_T(thiz.substring(start, end));
    return $as_scm_Builder(jsx$1.$$plus$plus$eq__sc_TraversableOnce__scg_Growable(new $c_sci_StringOps().init___T(x))).result__O()
  }
}
function $f_sci_StringLike__split__C__AT($thiz, separator) {
  var thiz = $thiz.toString__T();
  var regex = $f_sci_StringLike__escape__psci_StringLike__C__T($thiz, separator);
  return $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, regex, 0)
}
function $f_sci_StringLike__$$times__I__T($thiz, n) {
  var buf = new $c_scm_StringBuilder().init___();
  var isEmpty$4 = (n <= 0);
  var scala$collection$immutable$Range$$lastElement$4 = (((-1) + n) | 0);
  if ((!isEmpty$4)) {
    var i = 0;
    while (true) {
      var arg1 = i;
      buf.append__T__scm_StringBuilder($thiz.toString__T());
      if ((i === scala$collection$immutable$Range$$lastElement$4)) {
        break
      };
      i = ((1 + i) | 0)
    }
  };
  return buf.underlying$5.java$lang$StringBuilder$$content$f
}
function $f_sci_StringLike__capitalize__T($thiz) {
  if (($thiz.toString__T() === null)) {
    return null
  } else {
    var thiz = $thiz.toString__T();
    if (($uI(thiz.length) === 0)) {
      return ""
    } else {
      var thiz$1 = $thiz.toString__T();
      var c = (65535 & $uI(thiz$1.charCodeAt(0)));
      var this$5 = $m_jl_Character$();
      if (this$5.isUpperCase__I__Z(c)) {
        return $thiz.toString__T()
      } else {
        var chars = $m_sjsr_RuntimeString$().toCharArray__T__AC($thiz.toString__T());
        var c$1 = chars.get(0);
        chars.set(0, $m_jl_Character$().toUpperCase__C__C(c$1));
        var this$8 = $m_sjsr_RuntimeString$();
        return this$8.newString__AC__I__I__T(chars, 0, chars.u.length)
      }
    }
  }
}
function $f_sci_StringLike__stripPrefix__T__T($thiz, prefix) {
  var thiz = $thiz.toString__T();
  if ((($uI(thiz.length) >= 0) && ($as_T(thiz.substring(0, $uI(prefix.length))) === prefix))) {
    var thiz$1 = $thiz.toString__T();
    var beginIndex = $uI(prefix.length);
    return $as_T(thiz$1.substring(beginIndex))
  } else {
    return $thiz.toString__T()
  }
}
function $f_sci_StringLike__stripSuffix__T__T($thiz, suffix) {
  if ($m_sjsr_RuntimeString$().endsWith__T__T__Z($thiz.toString__T(), suffix)) {
    var thiz$1 = $thiz.toString__T();
    var thiz = $thiz.toString__T();
    var endIndex = (($uI(thiz.length) - $uI(suffix.length)) | 0);
    return $as_T(thiz$1.substring(0, endIndex))
  } else {
    return $thiz.toString__T()
  }
}
function $f_sci_StringLike__stripMargin__C__T($thiz, marginChar) {
  var buf = new $c_scm_StringBuilder().init___();
  var this$1 = new $c_sci_StringLike$$anon$1().init___sci_StringLike($thiz);
  while (this$1.hasNext__Z()) {
    var arg1 = this$1.next__T();
    var len = $uI(arg1.length);
    var index = 0;
    while (true) {
      if ((index < len)) {
        var index$1 = index;
        var jsx$1 = ((65535 & $uI(arg1.charCodeAt(index$1))) <= 32)
      } else {
        var jsx$1 = false
      };
      if (jsx$1) {
        index = ((1 + index) | 0)
      } else {
        break
      }
    };
    if ((index < len)) {
      var index$2 = index;
      var jsx$3 = ((65535 & $uI(arg1.charCodeAt(index$2))) === marginChar)
    } else {
      var jsx$3 = false
    };
    if (jsx$3) {
      var beginIndex = ((1 + index) | 0);
      var jsx$2 = $as_T(arg1.substring(beginIndex))
    } else {
      var jsx$2 = arg1
    };
    buf.append__T__scm_StringBuilder(jsx$2)
  };
  return buf.underlying$5.java$lang$StringBuilder$$content$f
}
function $f_sci_StringLike__stripLineEnd__T($thiz) {
  var thiz = $thiz.toString__T();
  var len = $uI(thiz.length);
  if ((len === 0)) {
    return $thiz.toString__T()
  } else {
    var last = $thiz.apply__I__C((((-1) + len) | 0));
    if ($f_sci_StringLike__scala$collection$immutable$StringLike$$isLineBreak__C__Z($thiz, last)) {
      var thiz$1 = $thiz.toString__T();
      var endIndex = ((((last === 10) && (len >= 2)) && ($thiz.apply__I__C((((-2) + len) | 0)) === 13)) ? (((-2) + len) | 0) : (((-1) + len) | 0));
      return $as_T(thiz$1.substring(0, endIndex))
    } else {
      return $thiz.toString__T()
    }
  }
}
function $f_scm_LinkedListLike__head__O($thiz) {
  if ($f_scm_LinkedListLike__isEmpty__Z($thiz)) {
    throw new $c_ju_NoSuchElementException().init___()
  } else {
    return $thiz.elem$5
  }
}
function $f_scm_LinkedListLike__apply__I__O($thiz, n) {
  var loc = $f_scm_LinkedListLike__drop__I__scm_Seq($thiz, n);
  if (loc.nonEmpty__Z()) {
    return $as_scm_LinkedListLike(loc).elem$5
  } else {
    throw new $c_jl_IndexOutOfBoundsException().init___T(("" + n))
  }
}
function $f_scm_LinkedListLike__isEmpty__Z($thiz) {
  return ($thiz.next$5 === $thiz)
}
function $f_scm_LinkedListLike__length0__pscm_LinkedListLike__scm_Seq__I__I($thiz, elem, acc) {
  _length0: while (true) {
    var this$1 = $as_scm_LinkedListLike(elem);
    if ($f_scm_LinkedListLike__isEmpty__Z(this$1)) {
      return acc
    } else {
      var this$2 = $as_scm_LinkedListLike(elem);
      var temp$elem = this$2.next$5;
      var temp$acc = ((1 + acc) | 0);
      elem = temp$elem;
      acc = temp$acc;
      continue _length0
    }
  }
}
function $f_scm_LinkedListLike__foreach__F1__V($thiz, f) {
  var these = $thiz;
  while (true) {
    var this$1 = these;
    if ($f_sc_TraversableOnce__nonEmpty__Z(this$1)) {
      f.apply__O__O(these.elem$5);
      var this$2 = these;
      these = this$2.next$5
    } else {
      break
    }
  }
}
function $f_scm_LinkedListLike__tail__scm_Seq($thiz) {
  var requirement = $f_sc_TraversableOnce__nonEmpty__Z($thiz);
  if ((!requirement)) {
    throw new $c_jl_IllegalArgumentException().init___T("requirement failed: tail of empty list")
  };
  return $thiz.next$5
}
function $f_scm_LinkedListLike__drop__I__scm_Seq($thiz, n) {
  var i = 0;
  var these = $as_scm_Seq($thiz);
  while (true) {
    if ((i < n)) {
      var this$1 = $as_scm_LinkedListLike(these);
      var jsx$1 = (!$f_scm_LinkedListLike__isEmpty__Z(this$1))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      var this$2 = $as_scm_LinkedListLike(these);
      these = this$2.next$5;
      i = ((1 + i) | 0)
    } else {
      break
    }
  };
  return these
}
function $is_scm_LinkedListLike(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.scm_LinkedListLike)))
}
function $as_scm_LinkedListLike(obj) {
  return (($is_scm_LinkedListLike(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.LinkedListLike"))
}
function $isArrayOf_scm_LinkedListLike(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_LinkedListLike)))
}
function $asArrayOf_scm_LinkedListLike(obj, depth) {
  return (($isArrayOf_scm_LinkedListLike(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.LinkedListLike;", depth))
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_AnyShape() {
  $c_Lamf_core_model_domain_Shape.call(this);
  this.fields$2 = null;
  this.annotations$2 = null;
  this.subTypes$2 = null;
  this.superTypes$2 = null;
  this.inheritedIds$2 = null;
  this.platform$2 = null
}
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype = new $h_Lamf_core_model_domain_Shape();
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_AnyShape;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_AnyShape() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_AnyShape.prototype = $c_Lamf_plugins_domain_shapes_models_AnyShape.prototype;
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.validate__T__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future = (function(payload, exec) {
  var env = $m_Lamf_internal_environment_Environment$().apply__Lamf_client_execution_BaseExecutionEnvironment__Lamf_internal_environment_Environment(exec);
  return $m_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$().validateWithGuessing__Lamf_core_model_domain_Shape__T__T__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(this, payload, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, env, $m_Lamf_client_plugins_StrictValidationMode$(), exec)
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.payloadValidator__T__Lamf_client_execution_BaseExecutionEnvironment__s_Option = (function(mediaType, exec) {
  var env = $m_Lamf_internal_environment_Environment$().apply__Lamf_client_execution_BaseExecutionEnvironment__Lamf_internal_environment_Environment(exec);
  return $m_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$().payloadValidator__Lamf_core_model_domain_Shape__T__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__s_Option(this, mediaType, env, $m_Lamf_client_plugins_StrictValidationMode$())
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.documentations__sc_Seq = (function() {
  var jsx$1 = $m_sc_Seq$();
  var array = [$as_Lamf_plugins_domain_shapes_models_CreativeWork(this.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Documentation$1))];
  return $as_sc_Seq(jsx$1.apply__sc_Seq__sc_GenTraversable(new $c_sjs_js_WrappedArray().init___sjs_js_Array(array)))
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.validate__Lamf_core_model_document_PayloadFragment__Lamf_internal_environment_Environment__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future = (function(fragment, env, exec) {
  var x$3 = $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1;
  $m_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$();
  var x$6 = $m_Lamf_client_plugins_StrictValidationMode$();
  return $m_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$().validateFragment__Lamf_core_model_domain_Shape__Lamf_core_model_document_PayloadFragment__T__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(this, fragment, x$3, env, x$6, exec)
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.inlined__Z = (function() {
  return this.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_plugins_document_webapi_annotations_InlineDefinition.getClassOf()).isDefined__Z()
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  return this.linkCopy__Lamf_plugins_domain_shapes_models_AnyShape()
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return this.meta__Lamf_plugins_domain_shapes_metamodel_AnyShapeModel()
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.cloneShape$default$4__Z = (function() {
  return false
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.cloneShape$default$3__Lamf_core_traversal_ModelTraversalRegistry = (function() {
  return new $c_Lamf_core_traversal_ModelTraversalRegistry().init___()
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-any" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/any/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.location__s_Option = (function() {
  return $f_Lamf_core_model_domain_ExternalSourceElement__location__s_Option(this)
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.cloneShape__s_Option__s_Option__Lamf_core_traversal_ModelTraversalRegistry__Z__Lamf_core_model_domain_Shape = (function(recursionErrorHandler, withRecursionBase, traversal, cloneExamples) {
  return $f_Lamf_plugins_domain_shapes_models_ShapeHelpers__cloneShape__s_Option__s_Option__Lamf_core_traversal_ModelTraversalRegistry__Z__Lamf_core_model_domain_Shape(this, recursionErrorHandler, withRecursionBase, traversal, cloneExamples)
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_shapes_models_AnyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.ramlSyntaxKey__T = (function() {
  return "anyShape"
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.validate__Lamf_core_model_document_PayloadFragment__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future = (function(fragment, exec) {
  return this.validate__Lamf_core_model_document_PayloadFragment__Lamf_internal_environment_Environment__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(fragment, $m_Lamf_internal_environment_Environment$().apply__Lamf_client_execution_BaseExecutionEnvironment__Lamf_internal_environment_Environment(exec), exec)
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.parameterValidator__T__Lamf_client_execution_BaseExecutionEnvironment__s_Option = (function(mediaType, exec) {
  var env = $m_Lamf_internal_environment_Environment$().apply__Lamf_client_execution_BaseExecutionEnvironment__Lamf_internal_environment_Environment(exec);
  return $m_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$().payloadValidator__Lamf_core_model_domain_Shape__T__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__s_Option(this, mediaType, env, $m_Lamf_client_plugins_ScalarRelaxedValidationMode$())
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.validate__T__Lamf_internal_environment_Environment__s_concurrent_Future = (function(payload, env) {
  var this$1 = this.platform$2;
  var exec = this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  return $m_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$().validateWithGuessing__Lamf_core_model_domain_Shape__T__T__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(this, payload, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, env, $m_Lamf_client_plugins_StrictValidationMode$(), exec)
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.linkCopy__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var fields = new $c_Lamf_core_parser_Fields().init___();
  var this$5 = new $c_Lamf_plugins_domain_shapes_models_AnyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$5, value))
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.validateParameter__T__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future = (function(payload, exec) {
  var env = $m_Lamf_internal_environment_Environment$().apply__Lamf_client_execution_BaseExecutionEnvironment__Lamf_internal_environment_Environment(exec);
  return $m_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$().validateWithGuessing__Lamf_core_model_domain_Shape__T__T__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(this, payload, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, env, $m_Lamf_client_plugins_ScalarRelaxedValidationMode$(), exec)
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.validate__Lamf_core_model_document_PayloadFragment__s_concurrent_Future = (function(fragment) {
  var jsx$1 = $m_Lamf_internal_environment_Environment$().apply__Lamf_internal_environment_Environment();
  var this$1 = this.platform$2;
  return this.validate__Lamf_core_model_document_PayloadFragment__Lamf_internal_environment_Environment__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(fragment, jsx$1, this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment())
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.isDefaultEmpty__Z = (function() {
  if (this.meta__Lamf_plugins_domain_shapes_metamodel_AnyShapeModel().type__sci_List().equals__O__Z($m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().type$1)) {
    var this$1 = this.fields__Lamf_core_parser_Fields().filter__F1__Lamf_core_parser_Fields(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
      return (function(fe$2) {
        var fe = $as_T2(fe$2);
        var x = fe.$$und1__O();
        var x$2 = $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$().Examples$1;
        return (!((x === null) ? (x$2 === null) : $objectEquals(x, x$2)))
      })
    })(this)));
    var this$2 = this$1.fs$1;
    var jsx$1 = $f_sc_TraversableOnce__nonEmpty__Z(this$2)
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    return this.annotations__Lamf_core_parser_Annotations().find__jl_Class__s_Option($d_Lamf_plugins_domain_webapi_annotations_TypePropertyLexicalInfo.getClassOf()).isEmpty__Z()
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.trackedExample__T__s_Option = (function(trackId) {
  return $as_sc_Seq(this.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_common_ExamplesField$().Examples$1)).find__F1__s_Option(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, trackId$1) {
    return (function(x$4$2) {
      var x$4 = $as_Lamf_plugins_domain_shapes_models_Example(x$4$2);
      return $f_Lamf_core_model_domain_AmfElement__isTrackedBy__T__Z(x$4, trackId$1)
    })
  })(this, trackId)))
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.meta__Lamf_plugins_domain_shapes_metamodel_AnyShapeModel = (function() {
  return $m_Lamf_plugins_domain_shapes_metamodel_AnyShapeModel$()
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.validate__T__s_concurrent_Future = (function(payload) {
  var env = $m_Lamf_internal_environment_Environment$().apply__Lamf_internal_environment_Environment();
  var this$1 = this.platform$2;
  var exec = this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment();
  return $m_Lamf_plugins_domain_shapes_validation_PayloadValidationPluginsHandler$().validateWithGuessing__Lamf_core_model_domain_Shape__T__T__Lamf_internal_environment_Environment__Lamf_client_plugins_ValidationMode__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(this, payload, $m_Lamf_core_validation_SeverityLevels$().VIOLATION$1, env, $m_Lamf_client_plugins_StrictValidationMode$(), exec)
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.validate__Lamf_core_model_document_PayloadFragment__Lamf_internal_environment_Environment__s_concurrent_Future = (function(fragment, env) {
  var this$1 = this.platform$2;
  return this.validate__Lamf_core_model_document_PayloadFragment__Lamf_internal_environment_Environment__Lamf_client_execution_BaseExecutionEnvironment__s_concurrent_Future(fragment, env, this$1.defaultExecutionEnvironment__Lamf_client_execution_ExecutionEnvironment())
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.cloneShape$default$2__s_Option = (function() {
  return $m_s_None$()
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.copyAnyShape__Lamf_core_parser_Fields__Lamf_core_parser_Annotations__Lamf_plugins_domain_shapes_models_AnyShape = (function(fields, annotations) {
  var this$2 = new $c_Lamf_plugins_domain_shapes_models_AnyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$2, value))
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  this.fields$2 = fields;
  this.annotations$2 = annotations;
  $f_Lamf_core_model_domain_Linkable__$$init$__V(this);
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$2 = this$1.platform$1;
  $f_Lamf_plugins_domain_shapes_models_InheritanceChain__$$init$__V(this);
  return this
});
function $as_Lamf_plugins_domain_shapes_models_AnyShape(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_models_AnyShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.models.AnyShape"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_models_AnyShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_models_AnyShape)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_models_AnyShape(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_models_AnyShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.models.AnyShape;", depth))
}
var $d_Lamf_plugins_domain_shapes_models_AnyShape = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_AnyShape: 0
}, false, "amf.plugins.domain.shapes.models.AnyShape", {
  Lamf_plugins_domain_shapes_models_AnyShape: 1,
  Lamf_core_model_domain_Shape: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelper: 1,
  Lamf_plugins_domain_webapi_unsafe_JsonSchemaSecrets: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelpers: 1,
  Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer: 1,
  Lamf_core_model_domain_ExternalSourceElement: 1,
  Lamf_plugins_domain_shapes_models_InheritanceChain: 1,
  Lamf_plugins_domain_webapi_models_DocumentedElement: 1,
  Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement: 1
});
$c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_AnyShape;
/** @constructor */
function $c_sc_AbstractIterable() {
  $c_sc_AbstractTraversable.call(this)
}
$c_sc_AbstractIterable.prototype = new $h_sc_AbstractTraversable();
$c_sc_AbstractIterable.prototype.constructor = $c_sc_AbstractIterable;
/** @constructor */
function $h_sc_AbstractIterable() {
  /*<skip>*/
}
$h_sc_AbstractIterable.prototype = $c_sc_AbstractIterable.prototype;
$c_sc_AbstractIterable.prototype.seq__sc_TraversableOnce = (function() {
  return this.seq__sc_Iterable()
});
$c_sc_AbstractIterable.prototype.head__O = (function() {
  return this.iterator__sc_Iterator().next__O()
});
$c_sc_AbstractIterable.prototype.thisCollection__sc_Iterable = (function() {
  return this
});
$c_sc_AbstractIterable.prototype.toIterator__sc_Iterator = (function() {
  return this.iterator__sc_Iterator()
});
$c_sc_AbstractIterable.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IterableLike__sameElements__sc_GenIterable__Z(this, that)
});
$c_sc_AbstractIterable.prototype.exists__F1__Z = (function(p) {
  var this$1 = this.iterator__sc_Iterator();
  return $f_sc_Iterator__exists__F1__Z(this$1, p)
});
$c_sc_AbstractIterable.prototype.thisCollection__sc_Traversable = (function() {
  return this.thisCollection__sc_Iterable()
});
$c_sc_AbstractIterable.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sc_AbstractIterable.prototype.isEmpty__Z = (function() {
  return $f_sc_IterableLike__isEmpty__Z(this)
});
$c_sc_AbstractIterable.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sc_Iterable$()
});
$c_sc_AbstractIterable.prototype.forall__F1__Z = (function(p) {
  var this$1 = this.iterator__sc_Iterator();
  return $f_sc_Iterator__forall__F1__Z(this$1, p)
});
$c_sc_AbstractIterable.prototype.foreach__F1__V = (function(f) {
  var this$1 = this.iterator__sc_Iterator();
  $f_sc_Iterator__foreach__F1__V(this$1, f)
});
$c_sc_AbstractIterable.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_IterableLike__takeWhile__F1__O(this, p)
});
$c_sc_AbstractIterable.prototype.find__F1__s_Option = (function(p) {
  var this$1 = this.iterator__sc_Iterator();
  return $f_sc_Iterator__find__F1__s_Option(this$1, p)
});
$c_sc_AbstractIterable.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IterableLike__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_sc_AbstractIterable.prototype.take__I__O = (function(n) {
  return $f_sc_IterableLike__take__I__O(this, n)
});
$c_sc_AbstractIterable.prototype.toStream__sci_Stream = (function() {
  return this.iterator__sc_Iterator().toStream__sci_Stream()
});
$c_sc_AbstractIterable.prototype.drop__I__O = (function(n) {
  return $f_sc_IterableLike__drop__I__O(this, n)
});
$c_sc_AbstractIterable.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_sc_IterableLike__copyToArray__O__I__I__V(this, xs, start, len)
});
function $is_sci_Iterable(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sci_Iterable)))
}
function $as_sci_Iterable(obj) {
  return (($is_sci_Iterable(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.Iterable"))
}
function $isArrayOf_sci_Iterable(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_Iterable)))
}
function $asArrayOf_sci_Iterable(obj, depth) {
  return (($isArrayOf_sci_Iterable(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.Iterable;", depth))
}
var $d_sci_Iterable = new $TypeData().initClass({
  sci_Iterable: 0
}, true, "scala.collection.immutable.Iterable", {
  sci_Iterable: 1,
  sci_Traversable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  s_Immutable: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1
});
function $is_scm_Iterable(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.scm_Iterable)))
}
function $as_scm_Iterable(obj) {
  return (($is_scm_Iterable(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.Iterable"))
}
function $isArrayOf_scm_Iterable(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_Iterable)))
}
function $asArrayOf_scm_Iterable(obj, depth) {
  return (($isArrayOf_scm_Iterable(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.Iterable;", depth))
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_DataArrangementShape() {
  $c_Lamf_plugins_domain_shapes_models_AnyShape.call(this)
}
$c_Lamf_plugins_domain_shapes_models_DataArrangementShape.prototype = new $h_Lamf_plugins_domain_shapes_models_AnyShape();
$c_Lamf_plugins_domain_shapes_models_DataArrangementShape.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_DataArrangementShape;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_DataArrangementShape() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_DataArrangementShape.prototype = $c_Lamf_plugins_domain_shapes_models_DataArrangementShape.prototype;
$c_Lamf_plugins_domain_shapes_models_DataArrangementShape.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_shapes_models_DataArrangementShape.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return this.adopted__T__sc_Seq__Lamf_plugins_domain_shapes_models_DataArrangementShape(parent, cycle)
});
$c_Lamf_plugins_domain_shapes_models_DataArrangementShape.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields__Lamf_core_parser_Fields().field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-array" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/array/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_shapes_models_DataArrangementShape.prototype.ramlSyntaxKey__T = (function() {
  return "arrayShape"
});
$c_Lamf_plugins_domain_shapes_models_DataArrangementShape.prototype.adopted__T__sc_Seq__Lamf_plugins_domain_shapes_models_DataArrangementShape = (function(parent, cycle) {
  var isCycle = cycle.contains__O__Z(this.id$1);
  var thiz = ("" + parent);
  if (($uI(thiz.indexOf("#")) !== (-1))) {
    $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
  } else {
    var parent$1 = (parent + "#/");
    $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent$1)
  };
  if ((!isCycle)) {
    var x1 = this.fields$2.entry__Lamf_core_metamodel_Field__s_Option($m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1);
    if ((x1 instanceof $c_s_Some)) {
      var x2 = $as_s_Some(x1);
      var items = $as_Lamf_core_parser_FieldEntry(x2.value$2);
      var x1$2 = items.value$1.value$1;
      if ((x1$2 instanceof $c_Lamf_core_model_domain_Shape)) {
        var x2$2 = $as_Lamf_core_model_domain_Shape(x1$2);
        var jsx$2 = this.id$1;
        var jsx$1 = this.id$1;
        var this$4 = $m_sc_Seq$();
        $as_Lamf_core_model_domain_Shape(x2$2.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject((jsx$2 + "/items"), $as_sc_Seq(cycle.$$colon$plus__O__scg_CanBuildFrom__O(jsx$1, this$4.ReusableCBFInstance$2))))
      } else if ((x1$2 instanceof $c_Lamf_core_model_domain_AmfArray)) {
        var x3 = $as_Lamf_core_model_domain_AmfArray(x1$2);
        var parent$2 = ((this.id$1 + "/itemsTuple") + x3.values$1.length__I());
        $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent$2))
      } else {
        throw new $c_s_MatchError().init___O(x1$2)
      }
    }
  };
  return this
});
function $as_Lamf_plugins_domain_shapes_models_DataArrangementShape(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_models_DataArrangementShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.models.DataArrangementShape"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_models_DataArrangementShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_models_DataArrangementShape)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_models_DataArrangementShape(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_models_DataArrangementShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.models.DataArrangementShape;", depth))
}
function $f_sc_IterableViewLike__take__I__sc_IterableView($thiz, n) {
  var xs = $f_sc_SeqViewLike__newTaken__I__sc_SeqViewLike$Transformed($thiz, n);
  return xs
}
function $f_sc_IterableViewLike__zipWithIndex__scg_CanBuildFrom__O($thiz, bf) {
  var this$1 = $m_sci_Stream$();
  return $thiz.zip__sc_GenIterable__scg_CanBuildFrom__O(this$1.from__I__I__sci_Stream(0, 1), bf)
}
function $f_sc_IterableViewLike__drop__I__sc_IterableView($thiz, n) {
  var xs = $f_sc_SeqViewLike__newDropped__I__sc_SeqViewLike$Transformed($thiz, n);
  return xs
}
/** @constructor */
function $c_sci_StringOps() {
  $c_O.call(this);
  this.repr$1 = null
}
$c_sci_StringOps.prototype = new $h_O();
$c_sci_StringOps.prototype.constructor = $c_sci_StringOps;
/** @constructor */
function $h_sci_StringOps() {
  /*<skip>*/
}
$h_sci_StringOps.prototype = $c_sci_StringOps.prototype;
$c_sci_StringOps.prototype.seq__sc_TraversableOnce = (function() {
  var $$this = this.repr$1;
  return new $c_sci_WrappedString().init___T($$this)
});
$c_sci_StringOps.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_sci_StringOps.prototype.head__O = (function() {
  return $f_sc_IndexedSeqOptimized__head__O(this)
});
$c_sci_StringOps.prototype.apply__I__O = (function(idx) {
  var $$this = this.repr$1;
  var c = (65535 & $uI($$this.charCodeAt(idx)));
  return new $c_jl_Character().init___C(c)
});
$c_sci_StringOps.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_IndexedSeqOptimized__lengthCompare__I__I(this, len)
});
$c_sci_StringOps.prototype.toIterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $uI($$this.length))
});
$c_sci_StringOps.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IndexedSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_sci_StringOps.prototype.exists__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__exists__F1__Z(this, p)
});
$c_sci_StringOps.prototype.toList__sci_List = (function() {
  return $f_sc_IndexedSeqOptimized__toList__sci_List(this)
});
$c_sci_StringOps.prototype.isEmpty__Z = (function() {
  return $f_sc_IndexedSeqOptimized__isEmpty__Z(this)
});
$c_sci_StringOps.prototype.thisCollection__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_sci_WrappedString().init___T($$this)
});
$c_sci_StringOps.prototype.flatMap__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__flatMap__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_sci_StringOps.prototype.equals__O__Z = (function(x$1) {
  return $m_sci_StringOps$().equals$extension__T__O__Z(this.repr$1, x$1)
});
$c_sci_StringOps.prototype.apply__I__C = (function(index) {
  var $$this = this.repr$1;
  return (65535 & $uI($$this.charCodeAt(index)))
});
$c_sci_StringOps.prototype.scala$collection$IndexedSeqOptimized$$super$init__O = (function() {
  return $f_sc_TraversableLike__init__O(this)
});
$c_sci_StringOps.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__dropWhile__F1__O(this, p)
});
$c_sci_StringOps.prototype.mkString__T__T = (function(sep) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", sep, "")
});
$c_sci_StringOps.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_sci_StringOps.prototype.withFilter__F1__scg_FilterMonadic = (function(p) {
  return new $c_sc_TraversableLike$WithFilter().init___sc_TraversableLike__F1(this, p)
});
$c_sci_StringOps.prototype.forall__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__forall__F1__Z(this, p)
});
$c_sci_StringOps.prototype.$$colon$plus__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqLike__$$colon$plus__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_sci_StringOps.prototype.sorted__s_math_Ordering__O = (function(ord) {
  return $f_sc_SeqLike__sorted__s_math_Ordering__O(this, ord)
});
$c_sci_StringOps.prototype.toString__T = (function() {
  var $$this = this.repr$1;
  return $$this
});
$c_sci_StringOps.prototype.compareTo__O__I = (function(that) {
  var other = $as_T(that);
  var $$this = this.repr$1;
  return (($$this === other) ? 0 : ($uZ(($$this < other)) ? (-1) : 1))
});
$c_sci_StringOps.prototype.foreach__F1__V = (function(f) {
  $f_sc_IndexedSeqOptimized__foreach__F1__V(this, f)
});
$c_sci_StringOps.prototype.foldLeft__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $uI($$this.length);
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_sci_StringOps.prototype.compare__O__I = (function(that) {
  var other = $as_T(that);
  var $$this = this.repr$1;
  return (($$this === other) ? 0 : ($uZ(($$this < other)) ? (-1) : 1))
});
$c_sci_StringOps.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_IndexedSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_sci_StringOps.prototype.union__sc_GenSeq__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_sci_StringOps.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__takeWhile__F1__O(this, p)
});
$c_sci_StringOps.prototype.headOption__s_Option = (function() {
  return $f_sc_TraversableLike__headOption__s_Option(this)
});
$c_sci_StringOps.prototype.slice__I__I__O = (function(from, until) {
  return $m_sci_StringOps$().slice$extension__T__I__I__T(this.repr$1, from, until)
});
$c_sci_StringOps.prototype.intersect__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__intersect__sc_GenSeq__O(this, that)
});
$c_sci_StringOps.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sci_StringOps.prototype.filter__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, false)
});
$c_sci_StringOps.prototype.size__I = (function() {
  var $$this = this.repr$1;
  return $uI($$this.length)
});
$c_sci_StringOps.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_IndexedSeqLike__toBuffer__scm_Buffer(this)
});
$c_sci_StringOps.prototype.distinct__O = (function() {
  return $f_sc_SeqLike__distinct__O(this)
});
$c_sci_StringOps.prototype.iterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $uI($$this.length))
});
$c_sci_StringOps.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_IndexedSeqOptimized__find__F1__s_Option(this, p)
});
$c_sci_StringOps.prototype.span__F1__T2 = (function(p) {
  return $f_sc_IndexedSeqOptimized__span__F1__T2(this, p)
});
$c_sci_StringOps.prototype.diff__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__diff__sc_GenSeq__O(this, that)
});
$c_sci_StringOps.prototype.mkString__T = (function() {
  var $$this = this.repr$1;
  return $$this
});
$c_sci_StringOps.prototype.length__I = (function() {
  var $$this = this.repr$1;
  return $uI($$this.length)
});
$c_sci_StringOps.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IndexedSeqOptimized__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_sci_StringOps.prototype.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_sci_StringOps.prototype.scala$collection$IndexedSeqOptimized$$super$last__O = (function() {
  return $f_sc_TraversableLike__last__O(this)
});
$c_sci_StringOps.prototype.scala$collection$IndexedSeqOptimized$$super$tail__O = (function() {
  return $f_sc_TraversableLike__tail__O(this)
});
$c_sci_StringOps.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, true)
});
$c_sci_StringOps.prototype.sizeHintIfCheap__I = (function() {
  var $$this = this.repr$1;
  return $uI($$this.length)
});
$c_sci_StringOps.prototype.splitAt__I__T2 = (function(n) {
  return $f_sc_IndexedSeqOptimized__splitAt__I__T2(this, n)
});
$c_sci_StringOps.prototype.take__I__O = (function(n) {
  return $m_sci_StringOps$().slice$extension__T__I__I__T(this.repr$1, 0, n)
});
$c_sci_StringOps.prototype.toStream__sci_Stream = (function() {
  var $$this = this.repr$1;
  var this$3 = new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $uI($$this.length));
  return $f_sc_Iterator__toStream__sci_Stream(this$3)
});
$c_sci_StringOps.prototype.drop__I__O = (function(n) {
  var $$this = this.repr$1;
  var until = $uI($$this.length);
  return $m_sci_StringOps$().slice$extension__T__I__I__T(this.repr$1, n, until)
});
$c_sci_StringOps.prototype.contains__O__Z = (function(elem) {
  return $f_sc_SeqLike__contains__O__Z(this, elem)
});
$c_sci_StringOps.prototype.thisCollection__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_sci_WrappedString().init___T($$this)
});
$c_sci_StringOps.prototype.tail__O = (function() {
  return $f_sc_IndexedSeqOptimized__tail__O(this)
});
$c_sci_StringOps.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_sci_StringOps.prototype.toTraversable__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_sci_WrappedString().init___T($$this)
});
$c_sci_StringOps.prototype.sortBy__F1__s_math_Ordering__O = (function(f, ord) {
  return $f_sc_SeqLike__sortBy__F1__s_math_Ordering__O(this, f, ord)
});
$c_sci_StringOps.prototype.toSeq__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_sci_WrappedString().init___T($$this)
});
$c_sci_StringOps.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sci_StringOps.prototype.repr__O = (function() {
  return this.repr$1
});
$c_sci_StringOps.prototype.$$div$colon__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $uI($$this.length);
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_sci_StringOps.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_sc_IndexedSeqOptimized__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_sci_StringOps.prototype.isTraversableAgain__Z = (function() {
  return true
});
$c_sci_StringOps.prototype.hashCode__I = (function() {
  var $$this = this.repr$1;
  return $m_sjsr_RuntimeString$().hashCode__T__I($$this)
});
$c_sci_StringOps.prototype.groupBy__F1__sci_Map = (function(f) {
  return $f_sc_TraversableLike__groupBy__F1__sci_Map(this, f)
});
$c_sci_StringOps.prototype.init___T = (function(repr) {
  this.repr$1 = repr;
  return this
});
$c_sci_StringOps.prototype.scala$collection$IndexedSeqOptimized$$super$zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_IterableLike__zip__sc_GenIterable__scg_CanBuildFrom__O(this, that, bf)
});
$c_sci_StringOps.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var $$this = this.repr$1;
  var len = $uI($$this.length);
  while ((i < len)) {
    var arg1 = this.apply__I__O(i);
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  return $as_sci_Map(b.elems$1)
});
$c_sci_StringOps.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_sci_StringOps.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  var jsx$1 = $m_sjsr_RuntimeString$();
  var $$this = this.repr$1;
  return jsx$1.toCharArray__T__AC($$this)
});
$c_sci_StringOps.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_sci_StringOps.prototype.collect__s_PartialFunction__scg_CanBuildFrom__O = (function(pf, bf) {
  return $f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this, pf, bf)
});
$c_sci_StringOps.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_IndexedSeqOptimized__reduceLeft__F2__O(this, op)
});
$c_sci_StringOps.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_StringBuilder().init___()
});
$c_sci_StringOps.prototype.stringPrefix__T = (function() {
  return $f_sc_TraversableLike__stringPrefix__T(this)
});
$c_sci_StringOps.prototype.sortWith__F2__O = (function(lt) {
  return $f_sc_SeqLike__sortWith__F2__O(this, lt)
});
function $as_sci_StringOps(obj) {
  return (((obj instanceof $c_sci_StringOps) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.StringOps"))
}
function $isArrayOf_sci_StringOps(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_StringOps)))
}
function $asArrayOf_sci_StringOps(obj, depth) {
  return (($isArrayOf_sci_StringOps(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.StringOps;", depth))
}
var $d_sci_StringOps = new $TypeData().initClass({
  sci_StringOps: 0
}, false, "scala.collection.immutable.StringOps", {
  sci_StringOps: 1,
  O: 1,
  sci_StringLike: 1,
  sc_IndexedSeqOptimized: 1,
  sc_IndexedSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenIterableLike: 1,
  sc_GenSeqLike: 1,
  s_math_Ordered: 1,
  jl_Comparable: 1
});
$c_sci_StringOps.prototype.$classData = $d_sci_StringOps;
function $f_scm_ArrayOps__elementClass__pscm_ArrayOps__jl_Class($thiz) {
  var this$1 = $thiz.repr__O();
  return $objectGetClass(this$1).getComponentType__jl_Class()
}
function $f_scm_ArrayOps__slice__I__I__O($thiz, from, until) {
  var reprVal = $thiz.repr__O();
  var lo = ((from > 0) ? from : 0);
  var x = ((until > 0) ? until : 0);
  var y = $m_sr_ScalaRunTime$().array$undlength__O__I(reprVal);
  var hi = ((x < y) ? x : y);
  var x$1 = ((hi - lo) | 0);
  var size = ((x$1 > 0) ? x$1 : 0);
  var result = $m_jl_reflect_Array$().newInstance__jl_Class__I__O($f_scm_ArrayOps__elementClass__pscm_ArrayOps__jl_Class($thiz), size);
  if ((size > 0)) {
    $m_s_Array$().copy__O__I__O__I__I__V(reprVal, lo, result, 0, size)
  };
  return result
}
function $f_scm_ArrayOps__copyToArray__O__I__I__V($thiz, xs, start, len) {
  var that = $m_sr_ScalaRunTime$().array$undlength__O__I($thiz.repr__O());
  var x = ((len < that) ? len : that);
  var that$1 = (($m_sr_ScalaRunTime$().array$undlength__O__I(xs) - start) | 0);
  var l = ((x < that$1) ? x : that$1);
  if ((l > 0)) {
    $m_s_Array$().copy__O__I__O__I__I__V($thiz.repr__O(), 0, xs, start, l)
  }
}
function $f_scm_ArrayOps__toArray__s_reflect_ClassTag__O($thiz, evidence$1) {
  var thatElementClass = evidence$1.runtimeClass__jl_Class();
  return (($f_scm_ArrayOps__elementClass__pscm_ArrayOps__jl_Class($thiz) === thatElementClass) ? $thiz.repr__O() : $f_sc_TraversableOnce__toArray__s_reflect_ClassTag__O($thiz, evidence$1))
}
function $is_scm_ArrayOps(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.scm_ArrayOps)))
}
function $as_scm_ArrayOps(obj) {
  return (($is_scm_ArrayOps(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayOps"))
}
function $isArrayOf_scm_ArrayOps(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayOps)))
}
function $asArrayOf_scm_ArrayOps(obj, depth) {
  return (($isArrayOf_scm_ArrayOps(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayOps;", depth))
}
/** @constructor */
function $c_sc_MapLike$DefaultValuesIterable() {
  $c_sc_AbstractIterable.call(this);
  this.$$outer$3 = null
}
$c_sc_MapLike$DefaultValuesIterable.prototype = new $h_sc_AbstractIterable();
$c_sc_MapLike$DefaultValuesIterable.prototype.constructor = $c_sc_MapLike$DefaultValuesIterable;
/** @constructor */
function $h_sc_MapLike$DefaultValuesIterable() {
  /*<skip>*/
}
$h_sc_MapLike$DefaultValuesIterable.prototype = $c_sc_MapLike$DefaultValuesIterable.prototype;
$c_sc_MapLike$DefaultValuesIterable.prototype.foreach__F1__V = (function(f) {
  var this$1 = this.$$outer$3.valuesIterator__sc_Iterator();
  $f_sc_Iterator__foreach__F1__V(this$1, f)
});
$c_sc_MapLike$DefaultValuesIterable.prototype.size__I = (function() {
  return this.$$outer$3.size__I()
});
$c_sc_MapLike$DefaultValuesIterable.prototype.iterator__sc_Iterator = (function() {
  return this.$$outer$3.valuesIterator__sc_Iterator()
});
$c_sc_MapLike$DefaultValuesIterable.prototype.init___sc_MapLike = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$3 = $$outer
  };
  return this
});
var $d_sc_MapLike$DefaultValuesIterable = new $TypeData().initClass({
  sc_MapLike$DefaultValuesIterable: 0
}, false, "scala.collection.MapLike$DefaultValuesIterable", {
  sc_MapLike$DefaultValuesIterable: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sc_MapLike$DefaultValuesIterable.prototype.$classData = $d_sc_MapLike$DefaultValuesIterable;
function $is_sc_Seq(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_Seq)))
}
function $as_sc_Seq(obj) {
  return (($is_sc_Seq(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.Seq"))
}
function $isArrayOf_sc_Seq(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_Seq)))
}
function $asArrayOf_sc_Seq(obj, depth) {
  return (($isArrayOf_sc_Seq(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.Seq;", depth))
}
/** @constructor */
function $c_scm_ArrayOps$ofBoolean() {
  $c_O.call(this);
  this.repr$1 = null
}
$c_scm_ArrayOps$ofBoolean.prototype = new $h_O();
$c_scm_ArrayOps$ofBoolean.prototype.constructor = $c_scm_ArrayOps$ofBoolean;
/** @constructor */
function $h_scm_ArrayOps$ofBoolean() {
  /*<skip>*/
}
$h_scm_ArrayOps$ofBoolean.prototype = $c_scm_ArrayOps$ofBoolean.prototype;
$c_scm_ArrayOps$ofBoolean.prototype.seq__sc_TraversableOnce = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofBoolean().init___AZ($$this)
});
$c_scm_ArrayOps$ofBoolean.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_scm_ArrayOps$ofBoolean.prototype.head__O = (function() {
  return $f_sc_IndexedSeqOptimized__head__O(this)
});
$c_scm_ArrayOps$ofBoolean.prototype.apply__I__O = (function(idx) {
  var $$this = this.repr$1;
  return $$this.get(idx)
});
$c_scm_ArrayOps$ofBoolean.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_IndexedSeqOptimized__lengthCompare__I__I(this, len)
});
$c_scm_ArrayOps$ofBoolean.prototype.toIterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length)
});
$c_scm_ArrayOps$ofBoolean.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IndexedSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_scm_ArrayOps$ofBoolean.prototype.exists__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__exists__F1__Z(this, p)
});
$c_scm_ArrayOps$ofBoolean.prototype.toList__sci_List = (function() {
  return $f_sc_IndexedSeqOptimized__toList__sci_List(this)
});
$c_scm_ArrayOps$ofBoolean.prototype.isEmpty__Z = (function() {
  return $f_sc_IndexedSeqOptimized__isEmpty__Z(this)
});
$c_scm_ArrayOps$ofBoolean.prototype.thisCollection__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofBoolean().init___AZ($$this)
});
$c_scm_ArrayOps$ofBoolean.prototype.flatMap__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__flatMap__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_scm_ArrayOps$ofBoolean.prototype.equals__O__Z = (function(x$1) {
  return $m_scm_ArrayOps$ofBoolean$().equals$extension__AZ__O__Z(this.repr$1, x$1)
});
$c_scm_ArrayOps$ofBoolean.prototype.scala$collection$IndexedSeqOptimized$$super$init__O = (function() {
  return $f_sc_TraversableLike__init__O(this)
});
$c_scm_ArrayOps$ofBoolean.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__dropWhile__F1__O(this, p)
});
$c_scm_ArrayOps$ofBoolean.prototype.mkString__T__T = (function(sep) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", sep, "")
});
$c_scm_ArrayOps$ofBoolean.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_scm_ArrayOps$ofBoolean.prototype.withFilter__F1__scg_FilterMonadic = (function(p) {
  return new $c_sc_TraversableLike$WithFilter().init___sc_TraversableLike__F1(this, p)
});
$c_scm_ArrayOps$ofBoolean.prototype.forall__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__forall__F1__Z(this, p)
});
$c_scm_ArrayOps$ofBoolean.prototype.$$colon$plus__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqLike__$$colon$plus__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_scm_ArrayOps$ofBoolean.prototype.sorted__s_math_Ordering__O = (function(ord) {
  return $f_sc_SeqLike__sorted__s_math_Ordering__O(this, ord)
});
$c_scm_ArrayOps$ofBoolean.prototype.toString__T = (function() {
  return $f_sc_TraversableLike__toString__T(this)
});
$c_scm_ArrayOps$ofBoolean.prototype.foreach__F1__V = (function(f) {
  $f_sc_IndexedSeqOptimized__foreach__F1__V(this, f)
});
$c_scm_ArrayOps$ofBoolean.prototype.foldLeft__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $$this.u.length;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArrayOps$ofBoolean.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_IndexedSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_scm_ArrayOps$ofBoolean.prototype.union__sc_GenSeq__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofBoolean.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__takeWhile__F1__O(this, p)
});
$c_scm_ArrayOps$ofBoolean.prototype.headOption__s_Option = (function() {
  return $f_sc_TraversableLike__headOption__s_Option(this)
});
$c_scm_ArrayOps$ofBoolean.prototype.slice__I__I__O = (function(from, until) {
  return $f_scm_ArrayOps__slice__I__I__O(this, from, until)
});
$c_scm_ArrayOps$ofBoolean.prototype.intersect__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__intersect__sc_GenSeq__O(this, that)
});
$c_scm_ArrayOps$ofBoolean.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_ArrayOps$ofBoolean.prototype.filter__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, false)
});
$c_scm_ArrayOps$ofBoolean.prototype.size__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofBoolean.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_IndexedSeqLike__toBuffer__scm_Buffer(this)
});
$c_scm_ArrayOps$ofBoolean.prototype.distinct__O = (function() {
  return $f_sc_SeqLike__distinct__O(this)
});
$c_scm_ArrayOps$ofBoolean.prototype.iterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length)
});
$c_scm_ArrayOps$ofBoolean.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_IndexedSeqOptimized__find__F1__s_Option(this, p)
});
$c_scm_ArrayOps$ofBoolean.prototype.span__F1__T2 = (function(p) {
  return $f_sc_IndexedSeqOptimized__span__F1__T2(this, p)
});
$c_scm_ArrayOps$ofBoolean.prototype.diff__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__diff__sc_GenSeq__O(this, that)
});
$c_scm_ArrayOps$ofBoolean.prototype.mkString__T = (function() {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", "", "")
});
$c_scm_ArrayOps$ofBoolean.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IndexedSeqOptimized__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_scm_ArrayOps$ofBoolean.prototype.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofBoolean.prototype.length__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofBoolean.prototype.scala$collection$IndexedSeqOptimized$$super$last__O = (function() {
  return $f_sc_TraversableLike__last__O(this)
});
$c_scm_ArrayOps$ofBoolean.prototype.scala$collection$IndexedSeqOptimized$$super$tail__O = (function() {
  return $f_sc_TraversableLike__tail__O(this)
});
$c_scm_ArrayOps$ofBoolean.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, true)
});
$c_scm_ArrayOps$ofBoolean.prototype.sizeHintIfCheap__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofBoolean.prototype.splitAt__I__T2 = (function(n) {
  return $f_sc_IndexedSeqOptimized__splitAt__I__T2(this, n)
});
$c_scm_ArrayOps$ofBoolean.prototype.take__I__O = (function(n) {
  return $f_scm_ArrayOps__slice__I__I__O(this, 0, n)
});
$c_scm_ArrayOps$ofBoolean.prototype.toStream__sci_Stream = (function() {
  var $$this = this.repr$1;
  var this$2 = new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length);
  return $f_sc_Iterator__toStream__sci_Stream(this$2)
});
$c_scm_ArrayOps$ofBoolean.prototype.drop__I__O = (function(n) {
  var $$this = this.repr$1;
  var until = $$this.u.length;
  return $f_scm_ArrayOps__slice__I__I__O(this, n, until)
});
$c_scm_ArrayOps$ofBoolean.prototype.contains__O__Z = (function(elem) {
  return $f_sc_SeqLike__contains__O__Z(this, elem)
});
$c_scm_ArrayOps$ofBoolean.prototype.tail__O = (function() {
  return $f_sc_IndexedSeqOptimized__tail__O(this)
});
$c_scm_ArrayOps$ofBoolean.prototype.thisCollection__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofBoolean().init___AZ($$this)
});
$c_scm_ArrayOps$ofBoolean.prototype.toTraversable__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofBoolean().init___AZ($$this)
});
$c_scm_ArrayOps$ofBoolean.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_scm_ArrayOps$ofBoolean.prototype.sortBy__F1__s_math_Ordering__O = (function(f, ord) {
  return $f_sc_SeqLike__sortBy__F1__s_math_Ordering__O(this, f, ord)
});
$c_scm_ArrayOps$ofBoolean.prototype.toSeq__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofBoolean().init___AZ($$this)
});
$c_scm_ArrayOps$ofBoolean.prototype.init___AZ = (function(repr) {
  this.repr$1 = repr;
  return this
});
$c_scm_ArrayOps$ofBoolean.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_ArrayOps$ofBoolean.prototype.repr__O = (function() {
  return this.repr$1
});
$c_scm_ArrayOps$ofBoolean.prototype.$$div$colon__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $$this.u.length;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArrayOps$ofBoolean.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_scm_ArrayOps__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_scm_ArrayOps$ofBoolean.prototype.isTraversableAgain__Z = (function() {
  return true
});
$c_scm_ArrayOps$ofBoolean.prototype.groupBy__F1__sci_Map = (function(f) {
  return $f_sc_TraversableLike__groupBy__F1__sci_Map(this, f)
});
$c_scm_ArrayOps$ofBoolean.prototype.hashCode__I = (function() {
  var $$this = this.repr$1;
  return $$this.hashCode__I()
});
$c_scm_ArrayOps$ofBoolean.prototype.scala$collection$IndexedSeqOptimized$$super$zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_IterableLike__zip__sc_GenIterable__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofBoolean.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var $$this = this.repr$1;
  var len = $$this.u.length;
  while ((i < len)) {
    var idx = i;
    var $$this$1 = this.repr$1;
    var arg1 = $$this$1.get(idx);
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  return $as_sci_Map(b.elems$1)
});
$c_scm_ArrayOps$ofBoolean.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_scm_ArrayOps$ofBoolean.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_scm_ArrayOps__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_scm_ArrayOps$ofBoolean.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_scm_ArrayOps$ofBoolean.prototype.collect__s_PartialFunction__scg_CanBuildFrom__O = (function(pf, bf) {
  return $f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this, pf, bf)
});
$c_scm_ArrayOps$ofBoolean.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_IndexedSeqOptimized__reduceLeft__F2__O(this, op)
});
$c_scm_ArrayOps$ofBoolean.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_ArrayBuilder$ofBoolean().init___()
});
$c_scm_ArrayOps$ofBoolean.prototype.stringPrefix__T = (function() {
  return $f_sc_TraversableLike__stringPrefix__T(this)
});
$c_scm_ArrayOps$ofBoolean.prototype.sortWith__F2__O = (function(lt) {
  return $f_sc_SeqLike__sortWith__F2__O(this, lt)
});
function $as_scm_ArrayOps$ofBoolean(obj) {
  return (((obj instanceof $c_scm_ArrayOps$ofBoolean) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayOps$ofBoolean"))
}
function $isArrayOf_scm_ArrayOps$ofBoolean(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayOps$ofBoolean)))
}
function $asArrayOf_scm_ArrayOps$ofBoolean(obj, depth) {
  return (($isArrayOf_scm_ArrayOps$ofBoolean(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayOps$ofBoolean;", depth))
}
var $d_scm_ArrayOps$ofBoolean = new $TypeData().initClass({
  scm_ArrayOps$ofBoolean: 0
}, false, "scala.collection.mutable.ArrayOps$ofBoolean", {
  scm_ArrayOps$ofBoolean: 1,
  O: 1,
  scm_ArrayOps: 1,
  scm_ArrayLike: 1,
  scm_IndexedSeqOptimized: 1,
  scm_IndexedSeqLike: 1,
  sc_IndexedSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenIterableLike: 1,
  sc_GenSeqLike: 1,
  sc_IndexedSeqOptimized: 1,
  sc_CustomParallelizable: 1
});
$c_scm_ArrayOps$ofBoolean.prototype.$classData = $d_scm_ArrayOps$ofBoolean;
/** @constructor */
function $c_scm_ArrayOps$ofByte() {
  $c_O.call(this);
  this.repr$1 = null
}
$c_scm_ArrayOps$ofByte.prototype = new $h_O();
$c_scm_ArrayOps$ofByte.prototype.constructor = $c_scm_ArrayOps$ofByte;
/** @constructor */
function $h_scm_ArrayOps$ofByte() {
  /*<skip>*/
}
$h_scm_ArrayOps$ofByte.prototype = $c_scm_ArrayOps$ofByte.prototype;
$c_scm_ArrayOps$ofByte.prototype.seq__sc_TraversableOnce = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofByte().init___AB($$this)
});
$c_scm_ArrayOps$ofByte.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_scm_ArrayOps$ofByte.prototype.head__O = (function() {
  return $f_sc_IndexedSeqOptimized__head__O(this)
});
$c_scm_ArrayOps$ofByte.prototype.apply__I__O = (function(idx) {
  var $$this = this.repr$1;
  return $$this.get(idx)
});
$c_scm_ArrayOps$ofByte.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_IndexedSeqOptimized__lengthCompare__I__I(this, len)
});
$c_scm_ArrayOps$ofByte.prototype.toIterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length)
});
$c_scm_ArrayOps$ofByte.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IndexedSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_scm_ArrayOps$ofByte.prototype.exists__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__exists__F1__Z(this, p)
});
$c_scm_ArrayOps$ofByte.prototype.toList__sci_List = (function() {
  return $f_sc_IndexedSeqOptimized__toList__sci_List(this)
});
$c_scm_ArrayOps$ofByte.prototype.isEmpty__Z = (function() {
  return $f_sc_IndexedSeqOptimized__isEmpty__Z(this)
});
$c_scm_ArrayOps$ofByte.prototype.thisCollection__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofByte().init___AB($$this)
});
$c_scm_ArrayOps$ofByte.prototype.flatMap__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__flatMap__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_scm_ArrayOps$ofByte.prototype.equals__O__Z = (function(x$1) {
  return $m_scm_ArrayOps$ofByte$().equals$extension__AB__O__Z(this.repr$1, x$1)
});
$c_scm_ArrayOps$ofByte.prototype.scala$collection$IndexedSeqOptimized$$super$init__O = (function() {
  return $f_sc_TraversableLike__init__O(this)
});
$c_scm_ArrayOps$ofByte.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__dropWhile__F1__O(this, p)
});
$c_scm_ArrayOps$ofByte.prototype.mkString__T__T = (function(sep) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", sep, "")
});
$c_scm_ArrayOps$ofByte.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_scm_ArrayOps$ofByte.prototype.withFilter__F1__scg_FilterMonadic = (function(p) {
  return new $c_sc_TraversableLike$WithFilter().init___sc_TraversableLike__F1(this, p)
});
$c_scm_ArrayOps$ofByte.prototype.forall__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__forall__F1__Z(this, p)
});
$c_scm_ArrayOps$ofByte.prototype.$$colon$plus__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqLike__$$colon$plus__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_scm_ArrayOps$ofByte.prototype.sorted__s_math_Ordering__O = (function(ord) {
  return $f_sc_SeqLike__sorted__s_math_Ordering__O(this, ord)
});
$c_scm_ArrayOps$ofByte.prototype.toString__T = (function() {
  return $f_sc_TraversableLike__toString__T(this)
});
$c_scm_ArrayOps$ofByte.prototype.foreach__F1__V = (function(f) {
  $f_sc_IndexedSeqOptimized__foreach__F1__V(this, f)
});
$c_scm_ArrayOps$ofByte.prototype.foldLeft__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $$this.u.length;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArrayOps$ofByte.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_IndexedSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_scm_ArrayOps$ofByte.prototype.union__sc_GenSeq__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofByte.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__takeWhile__F1__O(this, p)
});
$c_scm_ArrayOps$ofByte.prototype.headOption__s_Option = (function() {
  return $f_sc_TraversableLike__headOption__s_Option(this)
});
$c_scm_ArrayOps$ofByte.prototype.slice__I__I__O = (function(from, until) {
  return $f_scm_ArrayOps__slice__I__I__O(this, from, until)
});
$c_scm_ArrayOps$ofByte.prototype.intersect__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__intersect__sc_GenSeq__O(this, that)
});
$c_scm_ArrayOps$ofByte.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_ArrayOps$ofByte.prototype.filter__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, false)
});
$c_scm_ArrayOps$ofByte.prototype.size__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofByte.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_IndexedSeqLike__toBuffer__scm_Buffer(this)
});
$c_scm_ArrayOps$ofByte.prototype.distinct__O = (function() {
  return $f_sc_SeqLike__distinct__O(this)
});
$c_scm_ArrayOps$ofByte.prototype.iterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length)
});
$c_scm_ArrayOps$ofByte.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_IndexedSeqOptimized__find__F1__s_Option(this, p)
});
$c_scm_ArrayOps$ofByte.prototype.span__F1__T2 = (function(p) {
  return $f_sc_IndexedSeqOptimized__span__F1__T2(this, p)
});
$c_scm_ArrayOps$ofByte.prototype.diff__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__diff__sc_GenSeq__O(this, that)
});
$c_scm_ArrayOps$ofByte.prototype.mkString__T = (function() {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", "", "")
});
$c_scm_ArrayOps$ofByte.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IndexedSeqOptimized__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_scm_ArrayOps$ofByte.prototype.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofByte.prototype.length__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofByte.prototype.scala$collection$IndexedSeqOptimized$$super$last__O = (function() {
  return $f_sc_TraversableLike__last__O(this)
});
$c_scm_ArrayOps$ofByte.prototype.scala$collection$IndexedSeqOptimized$$super$tail__O = (function() {
  return $f_sc_TraversableLike__tail__O(this)
});
$c_scm_ArrayOps$ofByte.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, true)
});
$c_scm_ArrayOps$ofByte.prototype.sizeHintIfCheap__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofByte.prototype.splitAt__I__T2 = (function(n) {
  return $f_sc_IndexedSeqOptimized__splitAt__I__T2(this, n)
});
$c_scm_ArrayOps$ofByte.prototype.take__I__O = (function(n) {
  return $f_scm_ArrayOps__slice__I__I__O(this, 0, n)
});
$c_scm_ArrayOps$ofByte.prototype.toStream__sci_Stream = (function() {
  var $$this = this.repr$1;
  var this$2 = new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length);
  return $f_sc_Iterator__toStream__sci_Stream(this$2)
});
$c_scm_ArrayOps$ofByte.prototype.drop__I__O = (function(n) {
  var $$this = this.repr$1;
  var until = $$this.u.length;
  return $f_scm_ArrayOps__slice__I__I__O(this, n, until)
});
$c_scm_ArrayOps$ofByte.prototype.contains__O__Z = (function(elem) {
  return $f_sc_SeqLike__contains__O__Z(this, elem)
});
$c_scm_ArrayOps$ofByte.prototype.tail__O = (function() {
  return $f_sc_IndexedSeqOptimized__tail__O(this)
});
$c_scm_ArrayOps$ofByte.prototype.thisCollection__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofByte().init___AB($$this)
});
$c_scm_ArrayOps$ofByte.prototype.toTraversable__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofByte().init___AB($$this)
});
$c_scm_ArrayOps$ofByte.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_scm_ArrayOps$ofByte.prototype.sortBy__F1__s_math_Ordering__O = (function(f, ord) {
  return $f_sc_SeqLike__sortBy__F1__s_math_Ordering__O(this, f, ord)
});
$c_scm_ArrayOps$ofByte.prototype.toSeq__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofByte().init___AB($$this)
});
$c_scm_ArrayOps$ofByte.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_ArrayOps$ofByte.prototype.repr__O = (function() {
  return this.repr$1
});
$c_scm_ArrayOps$ofByte.prototype.$$div$colon__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $$this.u.length;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArrayOps$ofByte.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_scm_ArrayOps__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_scm_ArrayOps$ofByte.prototype.isTraversableAgain__Z = (function() {
  return true
});
$c_scm_ArrayOps$ofByte.prototype.groupBy__F1__sci_Map = (function(f) {
  return $f_sc_TraversableLike__groupBy__F1__sci_Map(this, f)
});
$c_scm_ArrayOps$ofByte.prototype.hashCode__I = (function() {
  var $$this = this.repr$1;
  return $$this.hashCode__I()
});
$c_scm_ArrayOps$ofByte.prototype.scala$collection$IndexedSeqOptimized$$super$zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_IterableLike__zip__sc_GenIterable__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofByte.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var $$this = this.repr$1;
  var len = $$this.u.length;
  while ((i < len)) {
    var idx = i;
    var $$this$1 = this.repr$1;
    var arg1 = $$this$1.get(idx);
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  return $as_sci_Map(b.elems$1)
});
$c_scm_ArrayOps$ofByte.prototype.init___AB = (function(repr) {
  this.repr$1 = repr;
  return this
});
$c_scm_ArrayOps$ofByte.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_scm_ArrayOps$ofByte.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_scm_ArrayOps__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_scm_ArrayOps$ofByte.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_scm_ArrayOps$ofByte.prototype.collect__s_PartialFunction__scg_CanBuildFrom__O = (function(pf, bf) {
  return $f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this, pf, bf)
});
$c_scm_ArrayOps$ofByte.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_IndexedSeqOptimized__reduceLeft__F2__O(this, op)
});
$c_scm_ArrayOps$ofByte.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_ArrayBuilder$ofByte().init___()
});
$c_scm_ArrayOps$ofByte.prototype.stringPrefix__T = (function() {
  return $f_sc_TraversableLike__stringPrefix__T(this)
});
$c_scm_ArrayOps$ofByte.prototype.sortWith__F2__O = (function(lt) {
  return $f_sc_SeqLike__sortWith__F2__O(this, lt)
});
function $as_scm_ArrayOps$ofByte(obj) {
  return (((obj instanceof $c_scm_ArrayOps$ofByte) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayOps$ofByte"))
}
function $isArrayOf_scm_ArrayOps$ofByte(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayOps$ofByte)))
}
function $asArrayOf_scm_ArrayOps$ofByte(obj, depth) {
  return (($isArrayOf_scm_ArrayOps$ofByte(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayOps$ofByte;", depth))
}
var $d_scm_ArrayOps$ofByte = new $TypeData().initClass({
  scm_ArrayOps$ofByte: 0
}, false, "scala.collection.mutable.ArrayOps$ofByte", {
  scm_ArrayOps$ofByte: 1,
  O: 1,
  scm_ArrayOps: 1,
  scm_ArrayLike: 1,
  scm_IndexedSeqOptimized: 1,
  scm_IndexedSeqLike: 1,
  sc_IndexedSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenIterableLike: 1,
  sc_GenSeqLike: 1,
  sc_IndexedSeqOptimized: 1,
  sc_CustomParallelizable: 1
});
$c_scm_ArrayOps$ofByte.prototype.$classData = $d_scm_ArrayOps$ofByte;
/** @constructor */
function $c_scm_ArrayOps$ofChar() {
  $c_O.call(this);
  this.repr$1 = null
}
$c_scm_ArrayOps$ofChar.prototype = new $h_O();
$c_scm_ArrayOps$ofChar.prototype.constructor = $c_scm_ArrayOps$ofChar;
/** @constructor */
function $h_scm_ArrayOps$ofChar() {
  /*<skip>*/
}
$h_scm_ArrayOps$ofChar.prototype = $c_scm_ArrayOps$ofChar.prototype;
$c_scm_ArrayOps$ofChar.prototype.seq__sc_TraversableOnce = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofChar().init___AC($$this)
});
$c_scm_ArrayOps$ofChar.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_scm_ArrayOps$ofChar.prototype.head__O = (function() {
  return $f_sc_IndexedSeqOptimized__head__O(this)
});
$c_scm_ArrayOps$ofChar.prototype.apply__I__O = (function(idx) {
  var $$this = this.repr$1;
  var c = $$this.get(idx);
  return new $c_jl_Character().init___C(c)
});
$c_scm_ArrayOps$ofChar.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_IndexedSeqOptimized__lengthCompare__I__I(this, len)
});
$c_scm_ArrayOps$ofChar.prototype.toIterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length)
});
$c_scm_ArrayOps$ofChar.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IndexedSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_scm_ArrayOps$ofChar.prototype.exists__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__exists__F1__Z(this, p)
});
$c_scm_ArrayOps$ofChar.prototype.toList__sci_List = (function() {
  return $f_sc_IndexedSeqOptimized__toList__sci_List(this)
});
$c_scm_ArrayOps$ofChar.prototype.isEmpty__Z = (function() {
  return $f_sc_IndexedSeqOptimized__isEmpty__Z(this)
});
$c_scm_ArrayOps$ofChar.prototype.thisCollection__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofChar().init___AC($$this)
});
$c_scm_ArrayOps$ofChar.prototype.flatMap__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__flatMap__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_scm_ArrayOps$ofChar.prototype.equals__O__Z = (function(x$1) {
  return $m_scm_ArrayOps$ofChar$().equals$extension__AC__O__Z(this.repr$1, x$1)
});
$c_scm_ArrayOps$ofChar.prototype.scala$collection$IndexedSeqOptimized$$super$init__O = (function() {
  return $f_sc_TraversableLike__init__O(this)
});
$c_scm_ArrayOps$ofChar.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__dropWhile__F1__O(this, p)
});
$c_scm_ArrayOps$ofChar.prototype.mkString__T__T = (function(sep) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", sep, "")
});
$c_scm_ArrayOps$ofChar.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_scm_ArrayOps$ofChar.prototype.withFilter__F1__scg_FilterMonadic = (function(p) {
  return new $c_sc_TraversableLike$WithFilter().init___sc_TraversableLike__F1(this, p)
});
$c_scm_ArrayOps$ofChar.prototype.forall__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__forall__F1__Z(this, p)
});
$c_scm_ArrayOps$ofChar.prototype.$$colon$plus__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqLike__$$colon$plus__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_scm_ArrayOps$ofChar.prototype.sorted__s_math_Ordering__O = (function(ord) {
  return $f_sc_SeqLike__sorted__s_math_Ordering__O(this, ord)
});
$c_scm_ArrayOps$ofChar.prototype.toString__T = (function() {
  return $f_sc_TraversableLike__toString__T(this)
});
$c_scm_ArrayOps$ofChar.prototype.foreach__F1__V = (function(f) {
  $f_sc_IndexedSeqOptimized__foreach__F1__V(this, f)
});
$c_scm_ArrayOps$ofChar.prototype.foldLeft__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $$this.u.length;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArrayOps$ofChar.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_IndexedSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_scm_ArrayOps$ofChar.prototype.union__sc_GenSeq__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofChar.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__takeWhile__F1__O(this, p)
});
$c_scm_ArrayOps$ofChar.prototype.headOption__s_Option = (function() {
  return $f_sc_TraversableLike__headOption__s_Option(this)
});
$c_scm_ArrayOps$ofChar.prototype.slice__I__I__O = (function(from, until) {
  return $f_scm_ArrayOps__slice__I__I__O(this, from, until)
});
$c_scm_ArrayOps$ofChar.prototype.intersect__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__intersect__sc_GenSeq__O(this, that)
});
$c_scm_ArrayOps$ofChar.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_ArrayOps$ofChar.prototype.filter__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, false)
});
$c_scm_ArrayOps$ofChar.prototype.size__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofChar.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_IndexedSeqLike__toBuffer__scm_Buffer(this)
});
$c_scm_ArrayOps$ofChar.prototype.distinct__O = (function() {
  return $f_sc_SeqLike__distinct__O(this)
});
$c_scm_ArrayOps$ofChar.prototype.iterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length)
});
$c_scm_ArrayOps$ofChar.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_IndexedSeqOptimized__find__F1__s_Option(this, p)
});
$c_scm_ArrayOps$ofChar.prototype.span__F1__T2 = (function(p) {
  return $f_sc_IndexedSeqOptimized__span__F1__T2(this, p)
});
$c_scm_ArrayOps$ofChar.prototype.diff__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__diff__sc_GenSeq__O(this, that)
});
$c_scm_ArrayOps$ofChar.prototype.mkString__T = (function() {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", "", "")
});
$c_scm_ArrayOps$ofChar.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IndexedSeqOptimized__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_scm_ArrayOps$ofChar.prototype.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofChar.prototype.length__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofChar.prototype.scala$collection$IndexedSeqOptimized$$super$last__O = (function() {
  return $f_sc_TraversableLike__last__O(this)
});
$c_scm_ArrayOps$ofChar.prototype.scala$collection$IndexedSeqOptimized$$super$tail__O = (function() {
  return $f_sc_TraversableLike__tail__O(this)
});
$c_scm_ArrayOps$ofChar.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, true)
});
$c_scm_ArrayOps$ofChar.prototype.sizeHintIfCheap__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofChar.prototype.splitAt__I__T2 = (function(n) {
  return $f_sc_IndexedSeqOptimized__splitAt__I__T2(this, n)
});
$c_scm_ArrayOps$ofChar.prototype.take__I__O = (function(n) {
  return $f_scm_ArrayOps__slice__I__I__O(this, 0, n)
});
$c_scm_ArrayOps$ofChar.prototype.init___AC = (function(repr) {
  this.repr$1 = repr;
  return this
});
$c_scm_ArrayOps$ofChar.prototype.toStream__sci_Stream = (function() {
  var $$this = this.repr$1;
  var this$2 = new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length);
  return $f_sc_Iterator__toStream__sci_Stream(this$2)
});
$c_scm_ArrayOps$ofChar.prototype.drop__I__O = (function(n) {
  var $$this = this.repr$1;
  var until = $$this.u.length;
  return $f_scm_ArrayOps__slice__I__I__O(this, n, until)
});
$c_scm_ArrayOps$ofChar.prototype.contains__O__Z = (function(elem) {
  return $f_sc_SeqLike__contains__O__Z(this, elem)
});
$c_scm_ArrayOps$ofChar.prototype.tail__O = (function() {
  return $f_sc_IndexedSeqOptimized__tail__O(this)
});
$c_scm_ArrayOps$ofChar.prototype.thisCollection__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofChar().init___AC($$this)
});
$c_scm_ArrayOps$ofChar.prototype.toTraversable__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofChar().init___AC($$this)
});
$c_scm_ArrayOps$ofChar.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_scm_ArrayOps$ofChar.prototype.sortBy__F1__s_math_Ordering__O = (function(f, ord) {
  return $f_sc_SeqLike__sortBy__F1__s_math_Ordering__O(this, f, ord)
});
$c_scm_ArrayOps$ofChar.prototype.toSeq__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofChar().init___AC($$this)
});
$c_scm_ArrayOps$ofChar.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_ArrayOps$ofChar.prototype.repr__O = (function() {
  return this.repr$1
});
$c_scm_ArrayOps$ofChar.prototype.$$div$colon__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $$this.u.length;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArrayOps$ofChar.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_scm_ArrayOps__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_scm_ArrayOps$ofChar.prototype.isTraversableAgain__Z = (function() {
  return true
});
$c_scm_ArrayOps$ofChar.prototype.groupBy__F1__sci_Map = (function(f) {
  return $f_sc_TraversableLike__groupBy__F1__sci_Map(this, f)
});
$c_scm_ArrayOps$ofChar.prototype.hashCode__I = (function() {
  var $$this = this.repr$1;
  return $$this.hashCode__I()
});
$c_scm_ArrayOps$ofChar.prototype.scala$collection$IndexedSeqOptimized$$super$zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_IterableLike__zip__sc_GenIterable__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofChar.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var $$this = this.repr$1;
  var len = $$this.u.length;
  while ((i < len)) {
    var arg1 = this.apply__I__O(i);
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  return $as_sci_Map(b.elems$1)
});
$c_scm_ArrayOps$ofChar.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_scm_ArrayOps$ofChar.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_scm_ArrayOps__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_scm_ArrayOps$ofChar.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_scm_ArrayOps$ofChar.prototype.collect__s_PartialFunction__scg_CanBuildFrom__O = (function(pf, bf) {
  return $f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this, pf, bf)
});
$c_scm_ArrayOps$ofChar.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_IndexedSeqOptimized__reduceLeft__F2__O(this, op)
});
$c_scm_ArrayOps$ofChar.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_ArrayBuilder$ofChar().init___()
});
$c_scm_ArrayOps$ofChar.prototype.stringPrefix__T = (function() {
  return $f_sc_TraversableLike__stringPrefix__T(this)
});
$c_scm_ArrayOps$ofChar.prototype.sortWith__F2__O = (function(lt) {
  return $f_sc_SeqLike__sortWith__F2__O(this, lt)
});
function $as_scm_ArrayOps$ofChar(obj) {
  return (((obj instanceof $c_scm_ArrayOps$ofChar) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayOps$ofChar"))
}
function $isArrayOf_scm_ArrayOps$ofChar(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayOps$ofChar)))
}
function $asArrayOf_scm_ArrayOps$ofChar(obj, depth) {
  return (($isArrayOf_scm_ArrayOps$ofChar(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayOps$ofChar;", depth))
}
var $d_scm_ArrayOps$ofChar = new $TypeData().initClass({
  scm_ArrayOps$ofChar: 0
}, false, "scala.collection.mutable.ArrayOps$ofChar", {
  scm_ArrayOps$ofChar: 1,
  O: 1,
  scm_ArrayOps: 1,
  scm_ArrayLike: 1,
  scm_IndexedSeqOptimized: 1,
  scm_IndexedSeqLike: 1,
  sc_IndexedSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenIterableLike: 1,
  sc_GenSeqLike: 1,
  sc_IndexedSeqOptimized: 1,
  sc_CustomParallelizable: 1
});
$c_scm_ArrayOps$ofChar.prototype.$classData = $d_scm_ArrayOps$ofChar;
/** @constructor */
function $c_scm_ArrayOps$ofDouble() {
  $c_O.call(this);
  this.repr$1 = null
}
$c_scm_ArrayOps$ofDouble.prototype = new $h_O();
$c_scm_ArrayOps$ofDouble.prototype.constructor = $c_scm_ArrayOps$ofDouble;
/** @constructor */
function $h_scm_ArrayOps$ofDouble() {
  /*<skip>*/
}
$h_scm_ArrayOps$ofDouble.prototype = $c_scm_ArrayOps$ofDouble.prototype;
$c_scm_ArrayOps$ofDouble.prototype.seq__sc_TraversableOnce = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofDouble().init___AD($$this)
});
$c_scm_ArrayOps$ofDouble.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_scm_ArrayOps$ofDouble.prototype.head__O = (function() {
  return $f_sc_IndexedSeqOptimized__head__O(this)
});
$c_scm_ArrayOps$ofDouble.prototype.apply__I__O = (function(idx) {
  var $$this = this.repr$1;
  return $$this.get(idx)
});
$c_scm_ArrayOps$ofDouble.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_IndexedSeqOptimized__lengthCompare__I__I(this, len)
});
$c_scm_ArrayOps$ofDouble.prototype.toIterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length)
});
$c_scm_ArrayOps$ofDouble.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IndexedSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_scm_ArrayOps$ofDouble.prototype.exists__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__exists__F1__Z(this, p)
});
$c_scm_ArrayOps$ofDouble.prototype.toList__sci_List = (function() {
  return $f_sc_IndexedSeqOptimized__toList__sci_List(this)
});
$c_scm_ArrayOps$ofDouble.prototype.isEmpty__Z = (function() {
  return $f_sc_IndexedSeqOptimized__isEmpty__Z(this)
});
$c_scm_ArrayOps$ofDouble.prototype.thisCollection__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofDouble().init___AD($$this)
});
$c_scm_ArrayOps$ofDouble.prototype.flatMap__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__flatMap__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_scm_ArrayOps$ofDouble.prototype.equals__O__Z = (function(x$1) {
  return $m_scm_ArrayOps$ofDouble$().equals$extension__AD__O__Z(this.repr$1, x$1)
});
$c_scm_ArrayOps$ofDouble.prototype.scala$collection$IndexedSeqOptimized$$super$init__O = (function() {
  return $f_sc_TraversableLike__init__O(this)
});
$c_scm_ArrayOps$ofDouble.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__dropWhile__F1__O(this, p)
});
$c_scm_ArrayOps$ofDouble.prototype.mkString__T__T = (function(sep) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", sep, "")
});
$c_scm_ArrayOps$ofDouble.prototype.init___AD = (function(repr) {
  this.repr$1 = repr;
  return this
});
$c_scm_ArrayOps$ofDouble.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_scm_ArrayOps$ofDouble.prototype.withFilter__F1__scg_FilterMonadic = (function(p) {
  return new $c_sc_TraversableLike$WithFilter().init___sc_TraversableLike__F1(this, p)
});
$c_scm_ArrayOps$ofDouble.prototype.forall__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__forall__F1__Z(this, p)
});
$c_scm_ArrayOps$ofDouble.prototype.$$colon$plus__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqLike__$$colon$plus__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_scm_ArrayOps$ofDouble.prototype.sorted__s_math_Ordering__O = (function(ord) {
  return $f_sc_SeqLike__sorted__s_math_Ordering__O(this, ord)
});
$c_scm_ArrayOps$ofDouble.prototype.toString__T = (function() {
  return $f_sc_TraversableLike__toString__T(this)
});
$c_scm_ArrayOps$ofDouble.prototype.foreach__F1__V = (function(f) {
  $f_sc_IndexedSeqOptimized__foreach__F1__V(this, f)
});
$c_scm_ArrayOps$ofDouble.prototype.foldLeft__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $$this.u.length;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArrayOps$ofDouble.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_IndexedSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_scm_ArrayOps$ofDouble.prototype.union__sc_GenSeq__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofDouble.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__takeWhile__F1__O(this, p)
});
$c_scm_ArrayOps$ofDouble.prototype.headOption__s_Option = (function() {
  return $f_sc_TraversableLike__headOption__s_Option(this)
});
$c_scm_ArrayOps$ofDouble.prototype.slice__I__I__O = (function(from, until) {
  return $f_scm_ArrayOps__slice__I__I__O(this, from, until)
});
$c_scm_ArrayOps$ofDouble.prototype.intersect__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__intersect__sc_GenSeq__O(this, that)
});
$c_scm_ArrayOps$ofDouble.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_ArrayOps$ofDouble.prototype.filter__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, false)
});
$c_scm_ArrayOps$ofDouble.prototype.size__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofDouble.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_IndexedSeqLike__toBuffer__scm_Buffer(this)
});
$c_scm_ArrayOps$ofDouble.prototype.distinct__O = (function() {
  return $f_sc_SeqLike__distinct__O(this)
});
$c_scm_ArrayOps$ofDouble.prototype.iterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length)
});
$c_scm_ArrayOps$ofDouble.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_IndexedSeqOptimized__find__F1__s_Option(this, p)
});
$c_scm_ArrayOps$ofDouble.prototype.span__F1__T2 = (function(p) {
  return $f_sc_IndexedSeqOptimized__span__F1__T2(this, p)
});
$c_scm_ArrayOps$ofDouble.prototype.diff__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__diff__sc_GenSeq__O(this, that)
});
$c_scm_ArrayOps$ofDouble.prototype.mkString__T = (function() {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", "", "")
});
$c_scm_ArrayOps$ofDouble.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IndexedSeqOptimized__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_scm_ArrayOps$ofDouble.prototype.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofDouble.prototype.length__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofDouble.prototype.scala$collection$IndexedSeqOptimized$$super$last__O = (function() {
  return $f_sc_TraversableLike__last__O(this)
});
$c_scm_ArrayOps$ofDouble.prototype.scala$collection$IndexedSeqOptimized$$super$tail__O = (function() {
  return $f_sc_TraversableLike__tail__O(this)
});
$c_scm_ArrayOps$ofDouble.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, true)
});
$c_scm_ArrayOps$ofDouble.prototype.sizeHintIfCheap__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofDouble.prototype.splitAt__I__T2 = (function(n) {
  return $f_sc_IndexedSeqOptimized__splitAt__I__T2(this, n)
});
$c_scm_ArrayOps$ofDouble.prototype.take__I__O = (function(n) {
  return $f_scm_ArrayOps__slice__I__I__O(this, 0, n)
});
$c_scm_ArrayOps$ofDouble.prototype.toStream__sci_Stream = (function() {
  var $$this = this.repr$1;
  var this$2 = new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length);
  return $f_sc_Iterator__toStream__sci_Stream(this$2)
});
$c_scm_ArrayOps$ofDouble.prototype.drop__I__O = (function(n) {
  var $$this = this.repr$1;
  var until = $$this.u.length;
  return $f_scm_ArrayOps__slice__I__I__O(this, n, until)
});
$c_scm_ArrayOps$ofDouble.prototype.contains__O__Z = (function(elem) {
  return $f_sc_SeqLike__contains__O__Z(this, elem)
});
$c_scm_ArrayOps$ofDouble.prototype.tail__O = (function() {
  return $f_sc_IndexedSeqOptimized__tail__O(this)
});
$c_scm_ArrayOps$ofDouble.prototype.thisCollection__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofDouble().init___AD($$this)
});
$c_scm_ArrayOps$ofDouble.prototype.toTraversable__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofDouble().init___AD($$this)
});
$c_scm_ArrayOps$ofDouble.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_scm_ArrayOps$ofDouble.prototype.sortBy__F1__s_math_Ordering__O = (function(f, ord) {
  return $f_sc_SeqLike__sortBy__F1__s_math_Ordering__O(this, f, ord)
});
$c_scm_ArrayOps$ofDouble.prototype.toSeq__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofDouble().init___AD($$this)
});
$c_scm_ArrayOps$ofDouble.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_ArrayOps$ofDouble.prototype.repr__O = (function() {
  return this.repr$1
});
$c_scm_ArrayOps$ofDouble.prototype.$$div$colon__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $$this.u.length;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArrayOps$ofDouble.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_scm_ArrayOps__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_scm_ArrayOps$ofDouble.prototype.isTraversableAgain__Z = (function() {
  return true
});
$c_scm_ArrayOps$ofDouble.prototype.groupBy__F1__sci_Map = (function(f) {
  return $f_sc_TraversableLike__groupBy__F1__sci_Map(this, f)
});
$c_scm_ArrayOps$ofDouble.prototype.hashCode__I = (function() {
  var $$this = this.repr$1;
  return $$this.hashCode__I()
});
$c_scm_ArrayOps$ofDouble.prototype.scala$collection$IndexedSeqOptimized$$super$zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_IterableLike__zip__sc_GenIterable__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofDouble.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var $$this = this.repr$1;
  var len = $$this.u.length;
  while ((i < len)) {
    var idx = i;
    var $$this$1 = this.repr$1;
    var arg1 = $$this$1.get(idx);
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  return $as_sci_Map(b.elems$1)
});
$c_scm_ArrayOps$ofDouble.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_scm_ArrayOps$ofDouble.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_scm_ArrayOps__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_scm_ArrayOps$ofDouble.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_scm_ArrayOps$ofDouble.prototype.collect__s_PartialFunction__scg_CanBuildFrom__O = (function(pf, bf) {
  return $f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this, pf, bf)
});
$c_scm_ArrayOps$ofDouble.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_IndexedSeqOptimized__reduceLeft__F2__O(this, op)
});
$c_scm_ArrayOps$ofDouble.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_ArrayBuilder$ofDouble().init___()
});
$c_scm_ArrayOps$ofDouble.prototype.stringPrefix__T = (function() {
  return $f_sc_TraversableLike__stringPrefix__T(this)
});
$c_scm_ArrayOps$ofDouble.prototype.sortWith__F2__O = (function(lt) {
  return $f_sc_SeqLike__sortWith__F2__O(this, lt)
});
function $as_scm_ArrayOps$ofDouble(obj) {
  return (((obj instanceof $c_scm_ArrayOps$ofDouble) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayOps$ofDouble"))
}
function $isArrayOf_scm_ArrayOps$ofDouble(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayOps$ofDouble)))
}
function $asArrayOf_scm_ArrayOps$ofDouble(obj, depth) {
  return (($isArrayOf_scm_ArrayOps$ofDouble(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayOps$ofDouble;", depth))
}
var $d_scm_ArrayOps$ofDouble = new $TypeData().initClass({
  scm_ArrayOps$ofDouble: 0
}, false, "scala.collection.mutable.ArrayOps$ofDouble", {
  scm_ArrayOps$ofDouble: 1,
  O: 1,
  scm_ArrayOps: 1,
  scm_ArrayLike: 1,
  scm_IndexedSeqOptimized: 1,
  scm_IndexedSeqLike: 1,
  sc_IndexedSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenIterableLike: 1,
  sc_GenSeqLike: 1,
  sc_IndexedSeqOptimized: 1,
  sc_CustomParallelizable: 1
});
$c_scm_ArrayOps$ofDouble.prototype.$classData = $d_scm_ArrayOps$ofDouble;
/** @constructor */
function $c_scm_ArrayOps$ofFloat() {
  $c_O.call(this);
  this.repr$1 = null
}
$c_scm_ArrayOps$ofFloat.prototype = new $h_O();
$c_scm_ArrayOps$ofFloat.prototype.constructor = $c_scm_ArrayOps$ofFloat;
/** @constructor */
function $h_scm_ArrayOps$ofFloat() {
  /*<skip>*/
}
$h_scm_ArrayOps$ofFloat.prototype = $c_scm_ArrayOps$ofFloat.prototype;
$c_scm_ArrayOps$ofFloat.prototype.seq__sc_TraversableOnce = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofFloat().init___AF($$this)
});
$c_scm_ArrayOps$ofFloat.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_scm_ArrayOps$ofFloat.prototype.head__O = (function() {
  return $f_sc_IndexedSeqOptimized__head__O(this)
});
$c_scm_ArrayOps$ofFloat.prototype.apply__I__O = (function(idx) {
  var $$this = this.repr$1;
  return $$this.get(idx)
});
$c_scm_ArrayOps$ofFloat.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_IndexedSeqOptimized__lengthCompare__I__I(this, len)
});
$c_scm_ArrayOps$ofFloat.prototype.toIterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length)
});
$c_scm_ArrayOps$ofFloat.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IndexedSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_scm_ArrayOps$ofFloat.prototype.exists__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__exists__F1__Z(this, p)
});
$c_scm_ArrayOps$ofFloat.prototype.toList__sci_List = (function() {
  return $f_sc_IndexedSeqOptimized__toList__sci_List(this)
});
$c_scm_ArrayOps$ofFloat.prototype.isEmpty__Z = (function() {
  return $f_sc_IndexedSeqOptimized__isEmpty__Z(this)
});
$c_scm_ArrayOps$ofFloat.prototype.thisCollection__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofFloat().init___AF($$this)
});
$c_scm_ArrayOps$ofFloat.prototype.flatMap__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__flatMap__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_scm_ArrayOps$ofFloat.prototype.equals__O__Z = (function(x$1) {
  return $m_scm_ArrayOps$ofFloat$().equals$extension__AF__O__Z(this.repr$1, x$1)
});
$c_scm_ArrayOps$ofFloat.prototype.scala$collection$IndexedSeqOptimized$$super$init__O = (function() {
  return $f_sc_TraversableLike__init__O(this)
});
$c_scm_ArrayOps$ofFloat.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__dropWhile__F1__O(this, p)
});
$c_scm_ArrayOps$ofFloat.prototype.mkString__T__T = (function(sep) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", sep, "")
});
$c_scm_ArrayOps$ofFloat.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_scm_ArrayOps$ofFloat.prototype.withFilter__F1__scg_FilterMonadic = (function(p) {
  return new $c_sc_TraversableLike$WithFilter().init___sc_TraversableLike__F1(this, p)
});
$c_scm_ArrayOps$ofFloat.prototype.forall__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__forall__F1__Z(this, p)
});
$c_scm_ArrayOps$ofFloat.prototype.$$colon$plus__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqLike__$$colon$plus__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_scm_ArrayOps$ofFloat.prototype.sorted__s_math_Ordering__O = (function(ord) {
  return $f_sc_SeqLike__sorted__s_math_Ordering__O(this, ord)
});
$c_scm_ArrayOps$ofFloat.prototype.toString__T = (function() {
  return $f_sc_TraversableLike__toString__T(this)
});
$c_scm_ArrayOps$ofFloat.prototype.foreach__F1__V = (function(f) {
  $f_sc_IndexedSeqOptimized__foreach__F1__V(this, f)
});
$c_scm_ArrayOps$ofFloat.prototype.foldLeft__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $$this.u.length;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArrayOps$ofFloat.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_IndexedSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_scm_ArrayOps$ofFloat.prototype.union__sc_GenSeq__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofFloat.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__takeWhile__F1__O(this, p)
});
$c_scm_ArrayOps$ofFloat.prototype.headOption__s_Option = (function() {
  return $f_sc_TraversableLike__headOption__s_Option(this)
});
$c_scm_ArrayOps$ofFloat.prototype.slice__I__I__O = (function(from, until) {
  return $f_scm_ArrayOps__slice__I__I__O(this, from, until)
});
$c_scm_ArrayOps$ofFloat.prototype.intersect__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__intersect__sc_GenSeq__O(this, that)
});
$c_scm_ArrayOps$ofFloat.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_ArrayOps$ofFloat.prototype.filter__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, false)
});
$c_scm_ArrayOps$ofFloat.prototype.size__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofFloat.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_IndexedSeqLike__toBuffer__scm_Buffer(this)
});
$c_scm_ArrayOps$ofFloat.prototype.distinct__O = (function() {
  return $f_sc_SeqLike__distinct__O(this)
});
$c_scm_ArrayOps$ofFloat.prototype.iterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length)
});
$c_scm_ArrayOps$ofFloat.prototype.init___AF = (function(repr) {
  this.repr$1 = repr;
  return this
});
$c_scm_ArrayOps$ofFloat.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_IndexedSeqOptimized__find__F1__s_Option(this, p)
});
$c_scm_ArrayOps$ofFloat.prototype.span__F1__T2 = (function(p) {
  return $f_sc_IndexedSeqOptimized__span__F1__T2(this, p)
});
$c_scm_ArrayOps$ofFloat.prototype.diff__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__diff__sc_GenSeq__O(this, that)
});
$c_scm_ArrayOps$ofFloat.prototype.mkString__T = (function() {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", "", "")
});
$c_scm_ArrayOps$ofFloat.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IndexedSeqOptimized__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_scm_ArrayOps$ofFloat.prototype.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofFloat.prototype.length__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofFloat.prototype.scala$collection$IndexedSeqOptimized$$super$last__O = (function() {
  return $f_sc_TraversableLike__last__O(this)
});
$c_scm_ArrayOps$ofFloat.prototype.scala$collection$IndexedSeqOptimized$$super$tail__O = (function() {
  return $f_sc_TraversableLike__tail__O(this)
});
$c_scm_ArrayOps$ofFloat.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, true)
});
$c_scm_ArrayOps$ofFloat.prototype.sizeHintIfCheap__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofFloat.prototype.splitAt__I__T2 = (function(n) {
  return $f_sc_IndexedSeqOptimized__splitAt__I__T2(this, n)
});
$c_scm_ArrayOps$ofFloat.prototype.take__I__O = (function(n) {
  return $f_scm_ArrayOps__slice__I__I__O(this, 0, n)
});
$c_scm_ArrayOps$ofFloat.prototype.toStream__sci_Stream = (function() {
  var $$this = this.repr$1;
  var this$2 = new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length);
  return $f_sc_Iterator__toStream__sci_Stream(this$2)
});
$c_scm_ArrayOps$ofFloat.prototype.drop__I__O = (function(n) {
  var $$this = this.repr$1;
  var until = $$this.u.length;
  return $f_scm_ArrayOps__slice__I__I__O(this, n, until)
});
$c_scm_ArrayOps$ofFloat.prototype.contains__O__Z = (function(elem) {
  return $f_sc_SeqLike__contains__O__Z(this, elem)
});
$c_scm_ArrayOps$ofFloat.prototype.tail__O = (function() {
  return $f_sc_IndexedSeqOptimized__tail__O(this)
});
$c_scm_ArrayOps$ofFloat.prototype.thisCollection__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofFloat().init___AF($$this)
});
$c_scm_ArrayOps$ofFloat.prototype.toTraversable__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofFloat().init___AF($$this)
});
$c_scm_ArrayOps$ofFloat.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_scm_ArrayOps$ofFloat.prototype.sortBy__F1__s_math_Ordering__O = (function(f, ord) {
  return $f_sc_SeqLike__sortBy__F1__s_math_Ordering__O(this, f, ord)
});
$c_scm_ArrayOps$ofFloat.prototype.toSeq__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofFloat().init___AF($$this)
});
$c_scm_ArrayOps$ofFloat.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_ArrayOps$ofFloat.prototype.repr__O = (function() {
  return this.repr$1
});
$c_scm_ArrayOps$ofFloat.prototype.$$div$colon__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $$this.u.length;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArrayOps$ofFloat.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_scm_ArrayOps__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_scm_ArrayOps$ofFloat.prototype.isTraversableAgain__Z = (function() {
  return true
});
$c_scm_ArrayOps$ofFloat.prototype.groupBy__F1__sci_Map = (function(f) {
  return $f_sc_TraversableLike__groupBy__F1__sci_Map(this, f)
});
$c_scm_ArrayOps$ofFloat.prototype.hashCode__I = (function() {
  var $$this = this.repr$1;
  return $$this.hashCode__I()
});
$c_scm_ArrayOps$ofFloat.prototype.scala$collection$IndexedSeqOptimized$$super$zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_IterableLike__zip__sc_GenIterable__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofFloat.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var $$this = this.repr$1;
  var len = $$this.u.length;
  while ((i < len)) {
    var idx = i;
    var $$this$1 = this.repr$1;
    var arg1 = $$this$1.get(idx);
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  return $as_sci_Map(b.elems$1)
});
$c_scm_ArrayOps$ofFloat.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_scm_ArrayOps$ofFloat.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_scm_ArrayOps__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_scm_ArrayOps$ofFloat.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_scm_ArrayOps$ofFloat.prototype.collect__s_PartialFunction__scg_CanBuildFrom__O = (function(pf, bf) {
  return $f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this, pf, bf)
});
$c_scm_ArrayOps$ofFloat.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_IndexedSeqOptimized__reduceLeft__F2__O(this, op)
});
$c_scm_ArrayOps$ofFloat.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_ArrayBuilder$ofFloat().init___()
});
$c_scm_ArrayOps$ofFloat.prototype.stringPrefix__T = (function() {
  return $f_sc_TraversableLike__stringPrefix__T(this)
});
$c_scm_ArrayOps$ofFloat.prototype.sortWith__F2__O = (function(lt) {
  return $f_sc_SeqLike__sortWith__F2__O(this, lt)
});
function $as_scm_ArrayOps$ofFloat(obj) {
  return (((obj instanceof $c_scm_ArrayOps$ofFloat) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayOps$ofFloat"))
}
function $isArrayOf_scm_ArrayOps$ofFloat(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayOps$ofFloat)))
}
function $asArrayOf_scm_ArrayOps$ofFloat(obj, depth) {
  return (($isArrayOf_scm_ArrayOps$ofFloat(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayOps$ofFloat;", depth))
}
var $d_scm_ArrayOps$ofFloat = new $TypeData().initClass({
  scm_ArrayOps$ofFloat: 0
}, false, "scala.collection.mutable.ArrayOps$ofFloat", {
  scm_ArrayOps$ofFloat: 1,
  O: 1,
  scm_ArrayOps: 1,
  scm_ArrayLike: 1,
  scm_IndexedSeqOptimized: 1,
  scm_IndexedSeqLike: 1,
  sc_IndexedSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenIterableLike: 1,
  sc_GenSeqLike: 1,
  sc_IndexedSeqOptimized: 1,
  sc_CustomParallelizable: 1
});
$c_scm_ArrayOps$ofFloat.prototype.$classData = $d_scm_ArrayOps$ofFloat;
/** @constructor */
function $c_scm_ArrayOps$ofInt() {
  $c_O.call(this);
  this.repr$1 = null
}
$c_scm_ArrayOps$ofInt.prototype = new $h_O();
$c_scm_ArrayOps$ofInt.prototype.constructor = $c_scm_ArrayOps$ofInt;
/** @constructor */
function $h_scm_ArrayOps$ofInt() {
  /*<skip>*/
}
$h_scm_ArrayOps$ofInt.prototype = $c_scm_ArrayOps$ofInt.prototype;
$c_scm_ArrayOps$ofInt.prototype.seq__sc_TraversableOnce = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofInt().init___AI($$this)
});
$c_scm_ArrayOps$ofInt.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_scm_ArrayOps$ofInt.prototype.head__O = (function() {
  return $f_sc_IndexedSeqOptimized__head__O(this)
});
$c_scm_ArrayOps$ofInt.prototype.apply__I__O = (function(idx) {
  var $$this = this.repr$1;
  return $$this.get(idx)
});
$c_scm_ArrayOps$ofInt.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_IndexedSeqOptimized__lengthCompare__I__I(this, len)
});
$c_scm_ArrayOps$ofInt.prototype.toIterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length)
});
$c_scm_ArrayOps$ofInt.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IndexedSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_scm_ArrayOps$ofInt.prototype.exists__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__exists__F1__Z(this, p)
});
$c_scm_ArrayOps$ofInt.prototype.toList__sci_List = (function() {
  return $f_sc_IndexedSeqOptimized__toList__sci_List(this)
});
$c_scm_ArrayOps$ofInt.prototype.isEmpty__Z = (function() {
  return $f_sc_IndexedSeqOptimized__isEmpty__Z(this)
});
$c_scm_ArrayOps$ofInt.prototype.thisCollection__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofInt().init___AI($$this)
});
$c_scm_ArrayOps$ofInt.prototype.flatMap__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__flatMap__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_scm_ArrayOps$ofInt.prototype.equals__O__Z = (function(x$1) {
  return $m_scm_ArrayOps$ofInt$().equals$extension__AI__O__Z(this.repr$1, x$1)
});
$c_scm_ArrayOps$ofInt.prototype.scala$collection$IndexedSeqOptimized$$super$init__O = (function() {
  return $f_sc_TraversableLike__init__O(this)
});
$c_scm_ArrayOps$ofInt.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__dropWhile__F1__O(this, p)
});
$c_scm_ArrayOps$ofInt.prototype.mkString__T__T = (function(sep) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", sep, "")
});
$c_scm_ArrayOps$ofInt.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_scm_ArrayOps$ofInt.prototype.withFilter__F1__scg_FilterMonadic = (function(p) {
  return new $c_sc_TraversableLike$WithFilter().init___sc_TraversableLike__F1(this, p)
});
$c_scm_ArrayOps$ofInt.prototype.forall__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__forall__F1__Z(this, p)
});
$c_scm_ArrayOps$ofInt.prototype.$$colon$plus__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqLike__$$colon$plus__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_scm_ArrayOps$ofInt.prototype.sorted__s_math_Ordering__O = (function(ord) {
  return $f_sc_SeqLike__sorted__s_math_Ordering__O(this, ord)
});
$c_scm_ArrayOps$ofInt.prototype.toString__T = (function() {
  return $f_sc_TraversableLike__toString__T(this)
});
$c_scm_ArrayOps$ofInt.prototype.foreach__F1__V = (function(f) {
  $f_sc_IndexedSeqOptimized__foreach__F1__V(this, f)
});
$c_scm_ArrayOps$ofInt.prototype.foldLeft__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $$this.u.length;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArrayOps$ofInt.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_IndexedSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_scm_ArrayOps$ofInt.prototype.union__sc_GenSeq__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofInt.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__takeWhile__F1__O(this, p)
});
$c_scm_ArrayOps$ofInt.prototype.headOption__s_Option = (function() {
  return $f_sc_TraversableLike__headOption__s_Option(this)
});
$c_scm_ArrayOps$ofInt.prototype.slice__I__I__O = (function(from, until) {
  return $f_scm_ArrayOps__slice__I__I__O(this, from, until)
});
$c_scm_ArrayOps$ofInt.prototype.intersect__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__intersect__sc_GenSeq__O(this, that)
});
$c_scm_ArrayOps$ofInt.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_ArrayOps$ofInt.prototype.filter__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, false)
});
$c_scm_ArrayOps$ofInt.prototype.size__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofInt.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_IndexedSeqLike__toBuffer__scm_Buffer(this)
});
$c_scm_ArrayOps$ofInt.prototype.distinct__O = (function() {
  return $f_sc_SeqLike__distinct__O(this)
});
$c_scm_ArrayOps$ofInt.prototype.iterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length)
});
$c_scm_ArrayOps$ofInt.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_IndexedSeqOptimized__find__F1__s_Option(this, p)
});
$c_scm_ArrayOps$ofInt.prototype.span__F1__T2 = (function(p) {
  return $f_sc_IndexedSeqOptimized__span__F1__T2(this, p)
});
$c_scm_ArrayOps$ofInt.prototype.diff__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__diff__sc_GenSeq__O(this, that)
});
$c_scm_ArrayOps$ofInt.prototype.init___AI = (function(repr) {
  this.repr$1 = repr;
  return this
});
$c_scm_ArrayOps$ofInt.prototype.mkString__T = (function() {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", "", "")
});
$c_scm_ArrayOps$ofInt.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IndexedSeqOptimized__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_scm_ArrayOps$ofInt.prototype.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofInt.prototype.length__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofInt.prototype.scala$collection$IndexedSeqOptimized$$super$last__O = (function() {
  return $f_sc_TraversableLike__last__O(this)
});
$c_scm_ArrayOps$ofInt.prototype.scala$collection$IndexedSeqOptimized$$super$tail__O = (function() {
  return $f_sc_TraversableLike__tail__O(this)
});
$c_scm_ArrayOps$ofInt.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, true)
});
$c_scm_ArrayOps$ofInt.prototype.sizeHintIfCheap__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofInt.prototype.splitAt__I__T2 = (function(n) {
  return $f_sc_IndexedSeqOptimized__splitAt__I__T2(this, n)
});
$c_scm_ArrayOps$ofInt.prototype.take__I__O = (function(n) {
  return $f_scm_ArrayOps__slice__I__I__O(this, 0, n)
});
$c_scm_ArrayOps$ofInt.prototype.toStream__sci_Stream = (function() {
  var $$this = this.repr$1;
  var this$2 = new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length);
  return $f_sc_Iterator__toStream__sci_Stream(this$2)
});
$c_scm_ArrayOps$ofInt.prototype.drop__I__O = (function(n) {
  var $$this = this.repr$1;
  var until = $$this.u.length;
  return $f_scm_ArrayOps__slice__I__I__O(this, n, until)
});
$c_scm_ArrayOps$ofInt.prototype.contains__O__Z = (function(elem) {
  return $f_sc_SeqLike__contains__O__Z(this, elem)
});
$c_scm_ArrayOps$ofInt.prototype.tail__O = (function() {
  return $f_sc_IndexedSeqOptimized__tail__O(this)
});
$c_scm_ArrayOps$ofInt.prototype.thisCollection__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofInt().init___AI($$this)
});
$c_scm_ArrayOps$ofInt.prototype.toTraversable__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofInt().init___AI($$this)
});
$c_scm_ArrayOps$ofInt.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_scm_ArrayOps$ofInt.prototype.sortBy__F1__s_math_Ordering__O = (function(f, ord) {
  return $f_sc_SeqLike__sortBy__F1__s_math_Ordering__O(this, f, ord)
});
$c_scm_ArrayOps$ofInt.prototype.toSeq__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofInt().init___AI($$this)
});
$c_scm_ArrayOps$ofInt.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_ArrayOps$ofInt.prototype.repr__O = (function() {
  return this.repr$1
});
$c_scm_ArrayOps$ofInt.prototype.$$div$colon__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $$this.u.length;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArrayOps$ofInt.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_scm_ArrayOps__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_scm_ArrayOps$ofInt.prototype.isTraversableAgain__Z = (function() {
  return true
});
$c_scm_ArrayOps$ofInt.prototype.groupBy__F1__sci_Map = (function(f) {
  return $f_sc_TraversableLike__groupBy__F1__sci_Map(this, f)
});
$c_scm_ArrayOps$ofInt.prototype.hashCode__I = (function() {
  var $$this = this.repr$1;
  return $$this.hashCode__I()
});
$c_scm_ArrayOps$ofInt.prototype.scala$collection$IndexedSeqOptimized$$super$zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_IterableLike__zip__sc_GenIterable__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofInt.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var $$this = this.repr$1;
  var len = $$this.u.length;
  while ((i < len)) {
    var idx = i;
    var $$this$1 = this.repr$1;
    var arg1 = $$this$1.get(idx);
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  return $as_sci_Map(b.elems$1)
});
$c_scm_ArrayOps$ofInt.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_scm_ArrayOps$ofInt.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_scm_ArrayOps__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_scm_ArrayOps$ofInt.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_scm_ArrayOps$ofInt.prototype.collect__s_PartialFunction__scg_CanBuildFrom__O = (function(pf, bf) {
  return $f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this, pf, bf)
});
$c_scm_ArrayOps$ofInt.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_IndexedSeqOptimized__reduceLeft__F2__O(this, op)
});
$c_scm_ArrayOps$ofInt.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_ArrayBuilder$ofInt().init___()
});
$c_scm_ArrayOps$ofInt.prototype.stringPrefix__T = (function() {
  return $f_sc_TraversableLike__stringPrefix__T(this)
});
$c_scm_ArrayOps$ofInt.prototype.sortWith__F2__O = (function(lt) {
  return $f_sc_SeqLike__sortWith__F2__O(this, lt)
});
function $as_scm_ArrayOps$ofInt(obj) {
  return (((obj instanceof $c_scm_ArrayOps$ofInt) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayOps$ofInt"))
}
function $isArrayOf_scm_ArrayOps$ofInt(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayOps$ofInt)))
}
function $asArrayOf_scm_ArrayOps$ofInt(obj, depth) {
  return (($isArrayOf_scm_ArrayOps$ofInt(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayOps$ofInt;", depth))
}
var $d_scm_ArrayOps$ofInt = new $TypeData().initClass({
  scm_ArrayOps$ofInt: 0
}, false, "scala.collection.mutable.ArrayOps$ofInt", {
  scm_ArrayOps$ofInt: 1,
  O: 1,
  scm_ArrayOps: 1,
  scm_ArrayLike: 1,
  scm_IndexedSeqOptimized: 1,
  scm_IndexedSeqLike: 1,
  sc_IndexedSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenIterableLike: 1,
  sc_GenSeqLike: 1,
  sc_IndexedSeqOptimized: 1,
  sc_CustomParallelizable: 1
});
$c_scm_ArrayOps$ofInt.prototype.$classData = $d_scm_ArrayOps$ofInt;
/** @constructor */
function $c_scm_ArrayOps$ofLong() {
  $c_O.call(this);
  this.repr$1 = null
}
$c_scm_ArrayOps$ofLong.prototype = new $h_O();
$c_scm_ArrayOps$ofLong.prototype.constructor = $c_scm_ArrayOps$ofLong;
/** @constructor */
function $h_scm_ArrayOps$ofLong() {
  /*<skip>*/
}
$h_scm_ArrayOps$ofLong.prototype = $c_scm_ArrayOps$ofLong.prototype;
$c_scm_ArrayOps$ofLong.prototype.seq__sc_TraversableOnce = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofLong().init___AJ($$this)
});
$c_scm_ArrayOps$ofLong.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_scm_ArrayOps$ofLong.prototype.head__O = (function() {
  return $f_sc_IndexedSeqOptimized__head__O(this)
});
$c_scm_ArrayOps$ofLong.prototype.apply__I__O = (function(idx) {
  var $$this = this.repr$1;
  return $$this.get(idx)
});
$c_scm_ArrayOps$ofLong.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_IndexedSeqOptimized__lengthCompare__I__I(this, len)
});
$c_scm_ArrayOps$ofLong.prototype.toIterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length)
});
$c_scm_ArrayOps$ofLong.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IndexedSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_scm_ArrayOps$ofLong.prototype.exists__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__exists__F1__Z(this, p)
});
$c_scm_ArrayOps$ofLong.prototype.toList__sci_List = (function() {
  return $f_sc_IndexedSeqOptimized__toList__sci_List(this)
});
$c_scm_ArrayOps$ofLong.prototype.isEmpty__Z = (function() {
  return $f_sc_IndexedSeqOptimized__isEmpty__Z(this)
});
$c_scm_ArrayOps$ofLong.prototype.init___AJ = (function(repr) {
  this.repr$1 = repr;
  return this
});
$c_scm_ArrayOps$ofLong.prototype.thisCollection__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofLong().init___AJ($$this)
});
$c_scm_ArrayOps$ofLong.prototype.flatMap__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__flatMap__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_scm_ArrayOps$ofLong.prototype.equals__O__Z = (function(x$1) {
  return $m_scm_ArrayOps$ofLong$().equals$extension__AJ__O__Z(this.repr$1, x$1)
});
$c_scm_ArrayOps$ofLong.prototype.scala$collection$IndexedSeqOptimized$$super$init__O = (function() {
  return $f_sc_TraversableLike__init__O(this)
});
$c_scm_ArrayOps$ofLong.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__dropWhile__F1__O(this, p)
});
$c_scm_ArrayOps$ofLong.prototype.mkString__T__T = (function(sep) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", sep, "")
});
$c_scm_ArrayOps$ofLong.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_scm_ArrayOps$ofLong.prototype.withFilter__F1__scg_FilterMonadic = (function(p) {
  return new $c_sc_TraversableLike$WithFilter().init___sc_TraversableLike__F1(this, p)
});
$c_scm_ArrayOps$ofLong.prototype.forall__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__forall__F1__Z(this, p)
});
$c_scm_ArrayOps$ofLong.prototype.$$colon$plus__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqLike__$$colon$plus__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_scm_ArrayOps$ofLong.prototype.sorted__s_math_Ordering__O = (function(ord) {
  return $f_sc_SeqLike__sorted__s_math_Ordering__O(this, ord)
});
$c_scm_ArrayOps$ofLong.prototype.toString__T = (function() {
  return $f_sc_TraversableLike__toString__T(this)
});
$c_scm_ArrayOps$ofLong.prototype.foreach__F1__V = (function(f) {
  $f_sc_IndexedSeqOptimized__foreach__F1__V(this, f)
});
$c_scm_ArrayOps$ofLong.prototype.foldLeft__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $$this.u.length;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArrayOps$ofLong.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_IndexedSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_scm_ArrayOps$ofLong.prototype.union__sc_GenSeq__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofLong.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__takeWhile__F1__O(this, p)
});
$c_scm_ArrayOps$ofLong.prototype.headOption__s_Option = (function() {
  return $f_sc_TraversableLike__headOption__s_Option(this)
});
$c_scm_ArrayOps$ofLong.prototype.slice__I__I__O = (function(from, until) {
  return $f_scm_ArrayOps__slice__I__I__O(this, from, until)
});
$c_scm_ArrayOps$ofLong.prototype.intersect__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__intersect__sc_GenSeq__O(this, that)
});
$c_scm_ArrayOps$ofLong.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_ArrayOps$ofLong.prototype.filter__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, false)
});
$c_scm_ArrayOps$ofLong.prototype.size__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofLong.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_IndexedSeqLike__toBuffer__scm_Buffer(this)
});
$c_scm_ArrayOps$ofLong.prototype.distinct__O = (function() {
  return $f_sc_SeqLike__distinct__O(this)
});
$c_scm_ArrayOps$ofLong.prototype.iterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length)
});
$c_scm_ArrayOps$ofLong.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_IndexedSeqOptimized__find__F1__s_Option(this, p)
});
$c_scm_ArrayOps$ofLong.prototype.span__F1__T2 = (function(p) {
  return $f_sc_IndexedSeqOptimized__span__F1__T2(this, p)
});
$c_scm_ArrayOps$ofLong.prototype.diff__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__diff__sc_GenSeq__O(this, that)
});
$c_scm_ArrayOps$ofLong.prototype.mkString__T = (function() {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", "", "")
});
$c_scm_ArrayOps$ofLong.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IndexedSeqOptimized__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_scm_ArrayOps$ofLong.prototype.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofLong.prototype.length__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofLong.prototype.scala$collection$IndexedSeqOptimized$$super$last__O = (function() {
  return $f_sc_TraversableLike__last__O(this)
});
$c_scm_ArrayOps$ofLong.prototype.scala$collection$IndexedSeqOptimized$$super$tail__O = (function() {
  return $f_sc_TraversableLike__tail__O(this)
});
$c_scm_ArrayOps$ofLong.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, true)
});
$c_scm_ArrayOps$ofLong.prototype.sizeHintIfCheap__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofLong.prototype.splitAt__I__T2 = (function(n) {
  return $f_sc_IndexedSeqOptimized__splitAt__I__T2(this, n)
});
$c_scm_ArrayOps$ofLong.prototype.take__I__O = (function(n) {
  return $f_scm_ArrayOps__slice__I__I__O(this, 0, n)
});
$c_scm_ArrayOps$ofLong.prototype.toStream__sci_Stream = (function() {
  var $$this = this.repr$1;
  var this$2 = new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length);
  return $f_sc_Iterator__toStream__sci_Stream(this$2)
});
$c_scm_ArrayOps$ofLong.prototype.drop__I__O = (function(n) {
  var $$this = this.repr$1;
  var until = $$this.u.length;
  return $f_scm_ArrayOps__slice__I__I__O(this, n, until)
});
$c_scm_ArrayOps$ofLong.prototype.contains__O__Z = (function(elem) {
  return $f_sc_SeqLike__contains__O__Z(this, elem)
});
$c_scm_ArrayOps$ofLong.prototype.tail__O = (function() {
  return $f_sc_IndexedSeqOptimized__tail__O(this)
});
$c_scm_ArrayOps$ofLong.prototype.thisCollection__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofLong().init___AJ($$this)
});
$c_scm_ArrayOps$ofLong.prototype.toTraversable__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofLong().init___AJ($$this)
});
$c_scm_ArrayOps$ofLong.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_scm_ArrayOps$ofLong.prototype.sortBy__F1__s_math_Ordering__O = (function(f, ord) {
  return $f_sc_SeqLike__sortBy__F1__s_math_Ordering__O(this, f, ord)
});
$c_scm_ArrayOps$ofLong.prototype.toSeq__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofLong().init___AJ($$this)
});
$c_scm_ArrayOps$ofLong.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_ArrayOps$ofLong.prototype.repr__O = (function() {
  return this.repr$1
});
$c_scm_ArrayOps$ofLong.prototype.$$div$colon__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $$this.u.length;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArrayOps$ofLong.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_scm_ArrayOps__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_scm_ArrayOps$ofLong.prototype.isTraversableAgain__Z = (function() {
  return true
});
$c_scm_ArrayOps$ofLong.prototype.groupBy__F1__sci_Map = (function(f) {
  return $f_sc_TraversableLike__groupBy__F1__sci_Map(this, f)
});
$c_scm_ArrayOps$ofLong.prototype.hashCode__I = (function() {
  var $$this = this.repr$1;
  return $$this.hashCode__I()
});
$c_scm_ArrayOps$ofLong.prototype.scala$collection$IndexedSeqOptimized$$super$zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_IterableLike__zip__sc_GenIterable__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofLong.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var $$this = this.repr$1;
  var len = $$this.u.length;
  while ((i < len)) {
    var idx = i;
    var $$this$1 = this.repr$1;
    var t = $$this$1.get(idx);
    var lo = t.lo$2;
    var hi = t.hi$2;
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(new $c_sjsr_RuntimeLong().init___I__I(lo, hi)));
    i = ((1 + i) | 0)
  };
  return $as_sci_Map(b.elems$1)
});
$c_scm_ArrayOps$ofLong.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_scm_ArrayOps$ofLong.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_scm_ArrayOps__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_scm_ArrayOps$ofLong.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_scm_ArrayOps$ofLong.prototype.collect__s_PartialFunction__scg_CanBuildFrom__O = (function(pf, bf) {
  return $f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this, pf, bf)
});
$c_scm_ArrayOps$ofLong.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_IndexedSeqOptimized__reduceLeft__F2__O(this, op)
});
$c_scm_ArrayOps$ofLong.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_ArrayBuilder$ofLong().init___()
});
$c_scm_ArrayOps$ofLong.prototype.stringPrefix__T = (function() {
  return $f_sc_TraversableLike__stringPrefix__T(this)
});
$c_scm_ArrayOps$ofLong.prototype.sortWith__F2__O = (function(lt) {
  return $f_sc_SeqLike__sortWith__F2__O(this, lt)
});
function $as_scm_ArrayOps$ofLong(obj) {
  return (((obj instanceof $c_scm_ArrayOps$ofLong) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayOps$ofLong"))
}
function $isArrayOf_scm_ArrayOps$ofLong(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayOps$ofLong)))
}
function $asArrayOf_scm_ArrayOps$ofLong(obj, depth) {
  return (($isArrayOf_scm_ArrayOps$ofLong(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayOps$ofLong;", depth))
}
var $d_scm_ArrayOps$ofLong = new $TypeData().initClass({
  scm_ArrayOps$ofLong: 0
}, false, "scala.collection.mutable.ArrayOps$ofLong", {
  scm_ArrayOps$ofLong: 1,
  O: 1,
  scm_ArrayOps: 1,
  scm_ArrayLike: 1,
  scm_IndexedSeqOptimized: 1,
  scm_IndexedSeqLike: 1,
  sc_IndexedSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenIterableLike: 1,
  sc_GenSeqLike: 1,
  sc_IndexedSeqOptimized: 1,
  sc_CustomParallelizable: 1
});
$c_scm_ArrayOps$ofLong.prototype.$classData = $d_scm_ArrayOps$ofLong;
/** @constructor */
function $c_scm_ArrayOps$ofRef() {
  $c_O.call(this);
  this.repr$1 = null
}
$c_scm_ArrayOps$ofRef.prototype = new $h_O();
$c_scm_ArrayOps$ofRef.prototype.constructor = $c_scm_ArrayOps$ofRef;
/** @constructor */
function $h_scm_ArrayOps$ofRef() {
  /*<skip>*/
}
$h_scm_ArrayOps$ofRef.prototype = $c_scm_ArrayOps$ofRef.prototype;
$c_scm_ArrayOps$ofRef.prototype.seq__sc_TraversableOnce = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofRef().init___AO($$this)
});
$c_scm_ArrayOps$ofRef.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_scm_ArrayOps$ofRef.prototype.head__O = (function() {
  return $f_sc_IndexedSeqOptimized__head__O(this)
});
$c_scm_ArrayOps$ofRef.prototype.apply__I__O = (function(index) {
  var $$this = this.repr$1;
  return $$this.get(index)
});
$c_scm_ArrayOps$ofRef.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_IndexedSeqOptimized__lengthCompare__I__I(this, len)
});
$c_scm_ArrayOps$ofRef.prototype.toIterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length)
});
$c_scm_ArrayOps$ofRef.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IndexedSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_scm_ArrayOps$ofRef.prototype.exists__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__exists__F1__Z(this, p)
});
$c_scm_ArrayOps$ofRef.prototype.toList__sci_List = (function() {
  return $f_sc_IndexedSeqOptimized__toList__sci_List(this)
});
$c_scm_ArrayOps$ofRef.prototype.isEmpty__Z = (function() {
  return $f_sc_IndexedSeqOptimized__isEmpty__Z(this)
});
$c_scm_ArrayOps$ofRef.prototype.thisCollection__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofRef().init___AO($$this)
});
$c_scm_ArrayOps$ofRef.prototype.flatMap__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__flatMap__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_scm_ArrayOps$ofRef.prototype.equals__O__Z = (function(x$1) {
  return $m_scm_ArrayOps$ofRef$().equals$extension__AO__O__Z(this.repr$1, x$1)
});
$c_scm_ArrayOps$ofRef.prototype.scala$collection$IndexedSeqOptimized$$super$init__O = (function() {
  return $f_sc_TraversableLike__init__O(this)
});
$c_scm_ArrayOps$ofRef.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__dropWhile__F1__O(this, p)
});
$c_scm_ArrayOps$ofRef.prototype.mkString__T__T = (function(sep) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", sep, "")
});
$c_scm_ArrayOps$ofRef.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_scm_ArrayOps$ofRef.prototype.withFilter__F1__scg_FilterMonadic = (function(p) {
  return new $c_sc_TraversableLike$WithFilter().init___sc_TraversableLike__F1(this, p)
});
$c_scm_ArrayOps$ofRef.prototype.forall__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__forall__F1__Z(this, p)
});
$c_scm_ArrayOps$ofRef.prototype.$$colon$plus__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqLike__$$colon$plus__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_scm_ArrayOps$ofRef.prototype.sorted__s_math_Ordering__O = (function(ord) {
  return $f_sc_SeqLike__sorted__s_math_Ordering__O(this, ord)
});
$c_scm_ArrayOps$ofRef.prototype.toString__T = (function() {
  return $f_sc_TraversableLike__toString__T(this)
});
$c_scm_ArrayOps$ofRef.prototype.foreach__F1__V = (function(f) {
  $f_sc_IndexedSeqOptimized__foreach__F1__V(this, f)
});
$c_scm_ArrayOps$ofRef.prototype.foldLeft__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $$this.u.length;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArrayOps$ofRef.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_IndexedSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_scm_ArrayOps$ofRef.prototype.union__sc_GenSeq__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofRef.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__takeWhile__F1__O(this, p)
});
$c_scm_ArrayOps$ofRef.prototype.headOption__s_Option = (function() {
  return $f_sc_TraversableLike__headOption__s_Option(this)
});
$c_scm_ArrayOps$ofRef.prototype.slice__I__I__O = (function(from, until) {
  return $f_scm_ArrayOps__slice__I__I__O(this, from, until)
});
$c_scm_ArrayOps$ofRef.prototype.intersect__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__intersect__sc_GenSeq__O(this, that)
});
$c_scm_ArrayOps$ofRef.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_ArrayOps$ofRef.prototype.filter__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, false)
});
$c_scm_ArrayOps$ofRef.prototype.size__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofRef.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_IndexedSeqLike__toBuffer__scm_Buffer(this)
});
$c_scm_ArrayOps$ofRef.prototype.distinct__O = (function() {
  return $f_sc_SeqLike__distinct__O(this)
});
$c_scm_ArrayOps$ofRef.prototype.init___AO = (function(repr) {
  this.repr$1 = repr;
  return this
});
$c_scm_ArrayOps$ofRef.prototype.iterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length)
});
$c_scm_ArrayOps$ofRef.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_IndexedSeqOptimized__find__F1__s_Option(this, p)
});
$c_scm_ArrayOps$ofRef.prototype.span__F1__T2 = (function(p) {
  return $f_sc_IndexedSeqOptimized__span__F1__T2(this, p)
});
$c_scm_ArrayOps$ofRef.prototype.diff__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__diff__sc_GenSeq__O(this, that)
});
$c_scm_ArrayOps$ofRef.prototype.mkString__T = (function() {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", "", "")
});
$c_scm_ArrayOps$ofRef.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IndexedSeqOptimized__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_scm_ArrayOps$ofRef.prototype.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofRef.prototype.length__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofRef.prototype.scala$collection$IndexedSeqOptimized$$super$last__O = (function() {
  return $f_sc_TraversableLike__last__O(this)
});
$c_scm_ArrayOps$ofRef.prototype.scala$collection$IndexedSeqOptimized$$super$tail__O = (function() {
  return $f_sc_TraversableLike__tail__O(this)
});
$c_scm_ArrayOps$ofRef.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, true)
});
$c_scm_ArrayOps$ofRef.prototype.sizeHintIfCheap__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofRef.prototype.splitAt__I__T2 = (function(n) {
  return $f_sc_IndexedSeqOptimized__splitAt__I__T2(this, n)
});
$c_scm_ArrayOps$ofRef.prototype.take__I__O = (function(n) {
  return $f_scm_ArrayOps__slice__I__I__O(this, 0, n)
});
$c_scm_ArrayOps$ofRef.prototype.toStream__sci_Stream = (function() {
  var $$this = this.repr$1;
  var this$2 = new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length);
  return $f_sc_Iterator__toStream__sci_Stream(this$2)
});
$c_scm_ArrayOps$ofRef.prototype.drop__I__O = (function(n) {
  var $$this = this.repr$1;
  var until = $$this.u.length;
  return $f_scm_ArrayOps__slice__I__I__O(this, n, until)
});
$c_scm_ArrayOps$ofRef.prototype.contains__O__Z = (function(elem) {
  return $f_sc_SeqLike__contains__O__Z(this, elem)
});
$c_scm_ArrayOps$ofRef.prototype.tail__O = (function() {
  return $f_sc_IndexedSeqOptimized__tail__O(this)
});
$c_scm_ArrayOps$ofRef.prototype.thisCollection__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofRef().init___AO($$this)
});
$c_scm_ArrayOps$ofRef.prototype.toTraversable__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofRef().init___AO($$this)
});
$c_scm_ArrayOps$ofRef.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_scm_ArrayOps$ofRef.prototype.sortBy__F1__s_math_Ordering__O = (function(f, ord) {
  return $f_sc_SeqLike__sortBy__F1__s_math_Ordering__O(this, f, ord)
});
$c_scm_ArrayOps$ofRef.prototype.toSeq__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofRef().init___AO($$this)
});
$c_scm_ArrayOps$ofRef.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_ArrayOps$ofRef.prototype.repr__O = (function() {
  return this.repr$1
});
$c_scm_ArrayOps$ofRef.prototype.$$div$colon__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $$this.u.length;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArrayOps$ofRef.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_scm_ArrayOps__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_scm_ArrayOps$ofRef.prototype.isTraversableAgain__Z = (function() {
  return true
});
$c_scm_ArrayOps$ofRef.prototype.groupBy__F1__sci_Map = (function(f) {
  return $f_sc_TraversableLike__groupBy__F1__sci_Map(this, f)
});
$c_scm_ArrayOps$ofRef.prototype.hashCode__I = (function() {
  var $$this = this.repr$1;
  return $$this.hashCode__I()
});
$c_scm_ArrayOps$ofRef.prototype.scala$collection$IndexedSeqOptimized$$super$zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_IterableLike__zip__sc_GenIterable__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofRef.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var $$this = this.repr$1;
  var len = $$this.u.length;
  while ((i < len)) {
    var index = i;
    var $$this$1 = this.repr$1;
    var arg1 = $$this$1.get(index);
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  return $as_sci_Map(b.elems$1)
});
$c_scm_ArrayOps$ofRef.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_scm_ArrayOps$ofRef.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_scm_ArrayOps__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_scm_ArrayOps$ofRef.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_scm_ArrayOps$ofRef.prototype.collect__s_PartialFunction__scg_CanBuildFrom__O = (function(pf, bf) {
  return $f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this, pf, bf)
});
$c_scm_ArrayOps$ofRef.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_IndexedSeqOptimized__reduceLeft__F2__O(this, op)
});
$c_scm_ArrayOps$ofRef.prototype.newBuilder__scm_Builder = (function() {
  var $$this = this.repr$1;
  return new $c_scm_ArrayBuilder$ofRef().init___s_reflect_ClassTag($m_s_reflect_ClassTag$().apply__jl_Class__s_reflect_ClassTag($objectGetClass($$this).getComponentType__jl_Class()))
});
$c_scm_ArrayOps$ofRef.prototype.stringPrefix__T = (function() {
  return $f_sc_TraversableLike__stringPrefix__T(this)
});
$c_scm_ArrayOps$ofRef.prototype.sortWith__F2__O = (function(lt) {
  return $f_sc_SeqLike__sortWith__F2__O(this, lt)
});
function $as_scm_ArrayOps$ofRef(obj) {
  return (((obj instanceof $c_scm_ArrayOps$ofRef) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayOps$ofRef"))
}
function $isArrayOf_scm_ArrayOps$ofRef(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayOps$ofRef)))
}
function $asArrayOf_scm_ArrayOps$ofRef(obj, depth) {
  return (($isArrayOf_scm_ArrayOps$ofRef(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayOps$ofRef;", depth))
}
var $d_scm_ArrayOps$ofRef = new $TypeData().initClass({
  scm_ArrayOps$ofRef: 0
}, false, "scala.collection.mutable.ArrayOps$ofRef", {
  scm_ArrayOps$ofRef: 1,
  O: 1,
  scm_ArrayOps: 1,
  scm_ArrayLike: 1,
  scm_IndexedSeqOptimized: 1,
  scm_IndexedSeqLike: 1,
  sc_IndexedSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenIterableLike: 1,
  sc_GenSeqLike: 1,
  sc_IndexedSeqOptimized: 1,
  sc_CustomParallelizable: 1
});
$c_scm_ArrayOps$ofRef.prototype.$classData = $d_scm_ArrayOps$ofRef;
/** @constructor */
function $c_scm_ArrayOps$ofShort() {
  $c_O.call(this);
  this.repr$1 = null
}
$c_scm_ArrayOps$ofShort.prototype = new $h_O();
$c_scm_ArrayOps$ofShort.prototype.constructor = $c_scm_ArrayOps$ofShort;
/** @constructor */
function $h_scm_ArrayOps$ofShort() {
  /*<skip>*/
}
$h_scm_ArrayOps$ofShort.prototype = $c_scm_ArrayOps$ofShort.prototype;
$c_scm_ArrayOps$ofShort.prototype.seq__sc_TraversableOnce = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofShort().init___AS($$this)
});
$c_scm_ArrayOps$ofShort.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_scm_ArrayOps$ofShort.prototype.head__O = (function() {
  return $f_sc_IndexedSeqOptimized__head__O(this)
});
$c_scm_ArrayOps$ofShort.prototype.apply__I__O = (function(idx) {
  var $$this = this.repr$1;
  return $$this.get(idx)
});
$c_scm_ArrayOps$ofShort.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_IndexedSeqOptimized__lengthCompare__I__I(this, len)
});
$c_scm_ArrayOps$ofShort.prototype.toIterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length)
});
$c_scm_ArrayOps$ofShort.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IndexedSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_scm_ArrayOps$ofShort.prototype.exists__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__exists__F1__Z(this, p)
});
$c_scm_ArrayOps$ofShort.prototype.toList__sci_List = (function() {
  return $f_sc_IndexedSeqOptimized__toList__sci_List(this)
});
$c_scm_ArrayOps$ofShort.prototype.isEmpty__Z = (function() {
  return $f_sc_IndexedSeqOptimized__isEmpty__Z(this)
});
$c_scm_ArrayOps$ofShort.prototype.init___AS = (function(repr) {
  this.repr$1 = repr;
  return this
});
$c_scm_ArrayOps$ofShort.prototype.thisCollection__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofShort().init___AS($$this)
});
$c_scm_ArrayOps$ofShort.prototype.flatMap__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__flatMap__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_scm_ArrayOps$ofShort.prototype.equals__O__Z = (function(x$1) {
  return $m_scm_ArrayOps$ofShort$().equals$extension__AS__O__Z(this.repr$1, x$1)
});
$c_scm_ArrayOps$ofShort.prototype.scala$collection$IndexedSeqOptimized$$super$init__O = (function() {
  return $f_sc_TraversableLike__init__O(this)
});
$c_scm_ArrayOps$ofShort.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__dropWhile__F1__O(this, p)
});
$c_scm_ArrayOps$ofShort.prototype.mkString__T__T = (function(sep) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", sep, "")
});
$c_scm_ArrayOps$ofShort.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_scm_ArrayOps$ofShort.prototype.withFilter__F1__scg_FilterMonadic = (function(p) {
  return new $c_sc_TraversableLike$WithFilter().init___sc_TraversableLike__F1(this, p)
});
$c_scm_ArrayOps$ofShort.prototype.forall__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__forall__F1__Z(this, p)
});
$c_scm_ArrayOps$ofShort.prototype.$$colon$plus__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqLike__$$colon$plus__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_scm_ArrayOps$ofShort.prototype.sorted__s_math_Ordering__O = (function(ord) {
  return $f_sc_SeqLike__sorted__s_math_Ordering__O(this, ord)
});
$c_scm_ArrayOps$ofShort.prototype.toString__T = (function() {
  return $f_sc_TraversableLike__toString__T(this)
});
$c_scm_ArrayOps$ofShort.prototype.foreach__F1__V = (function(f) {
  $f_sc_IndexedSeqOptimized__foreach__F1__V(this, f)
});
$c_scm_ArrayOps$ofShort.prototype.foldLeft__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $$this.u.length;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArrayOps$ofShort.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_IndexedSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_scm_ArrayOps$ofShort.prototype.union__sc_GenSeq__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofShort.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__takeWhile__F1__O(this, p)
});
$c_scm_ArrayOps$ofShort.prototype.headOption__s_Option = (function() {
  return $f_sc_TraversableLike__headOption__s_Option(this)
});
$c_scm_ArrayOps$ofShort.prototype.slice__I__I__O = (function(from, until) {
  return $f_scm_ArrayOps__slice__I__I__O(this, from, until)
});
$c_scm_ArrayOps$ofShort.prototype.intersect__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__intersect__sc_GenSeq__O(this, that)
});
$c_scm_ArrayOps$ofShort.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_ArrayOps$ofShort.prototype.filter__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, false)
});
$c_scm_ArrayOps$ofShort.prototype.size__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofShort.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_IndexedSeqLike__toBuffer__scm_Buffer(this)
});
$c_scm_ArrayOps$ofShort.prototype.distinct__O = (function() {
  return $f_sc_SeqLike__distinct__O(this)
});
$c_scm_ArrayOps$ofShort.prototype.iterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length)
});
$c_scm_ArrayOps$ofShort.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_IndexedSeqOptimized__find__F1__s_Option(this, p)
});
$c_scm_ArrayOps$ofShort.prototype.span__F1__T2 = (function(p) {
  return $f_sc_IndexedSeqOptimized__span__F1__T2(this, p)
});
$c_scm_ArrayOps$ofShort.prototype.diff__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__diff__sc_GenSeq__O(this, that)
});
$c_scm_ArrayOps$ofShort.prototype.mkString__T = (function() {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", "", "")
});
$c_scm_ArrayOps$ofShort.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IndexedSeqOptimized__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_scm_ArrayOps$ofShort.prototype.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofShort.prototype.length__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofShort.prototype.scala$collection$IndexedSeqOptimized$$super$last__O = (function() {
  return $f_sc_TraversableLike__last__O(this)
});
$c_scm_ArrayOps$ofShort.prototype.scala$collection$IndexedSeqOptimized$$super$tail__O = (function() {
  return $f_sc_TraversableLike__tail__O(this)
});
$c_scm_ArrayOps$ofShort.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, true)
});
$c_scm_ArrayOps$ofShort.prototype.sizeHintIfCheap__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofShort.prototype.splitAt__I__T2 = (function(n) {
  return $f_sc_IndexedSeqOptimized__splitAt__I__T2(this, n)
});
$c_scm_ArrayOps$ofShort.prototype.take__I__O = (function(n) {
  return $f_scm_ArrayOps__slice__I__I__O(this, 0, n)
});
$c_scm_ArrayOps$ofShort.prototype.toStream__sci_Stream = (function() {
  var $$this = this.repr$1;
  var this$2 = new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length);
  return $f_sc_Iterator__toStream__sci_Stream(this$2)
});
$c_scm_ArrayOps$ofShort.prototype.drop__I__O = (function(n) {
  var $$this = this.repr$1;
  var until = $$this.u.length;
  return $f_scm_ArrayOps__slice__I__I__O(this, n, until)
});
$c_scm_ArrayOps$ofShort.prototype.contains__O__Z = (function(elem) {
  return $f_sc_SeqLike__contains__O__Z(this, elem)
});
$c_scm_ArrayOps$ofShort.prototype.tail__O = (function() {
  return $f_sc_IndexedSeqOptimized__tail__O(this)
});
$c_scm_ArrayOps$ofShort.prototype.thisCollection__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofShort().init___AS($$this)
});
$c_scm_ArrayOps$ofShort.prototype.toTraversable__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofShort().init___AS($$this)
});
$c_scm_ArrayOps$ofShort.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_scm_ArrayOps$ofShort.prototype.sortBy__F1__s_math_Ordering__O = (function(f, ord) {
  return $f_sc_SeqLike__sortBy__F1__s_math_Ordering__O(this, f, ord)
});
$c_scm_ArrayOps$ofShort.prototype.toSeq__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofShort().init___AS($$this)
});
$c_scm_ArrayOps$ofShort.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_ArrayOps$ofShort.prototype.repr__O = (function() {
  return this.repr$1
});
$c_scm_ArrayOps$ofShort.prototype.$$div$colon__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $$this.u.length;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArrayOps$ofShort.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_scm_ArrayOps__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_scm_ArrayOps$ofShort.prototype.isTraversableAgain__Z = (function() {
  return true
});
$c_scm_ArrayOps$ofShort.prototype.groupBy__F1__sci_Map = (function(f) {
  return $f_sc_TraversableLike__groupBy__F1__sci_Map(this, f)
});
$c_scm_ArrayOps$ofShort.prototype.hashCode__I = (function() {
  var $$this = this.repr$1;
  return $$this.hashCode__I()
});
$c_scm_ArrayOps$ofShort.prototype.scala$collection$IndexedSeqOptimized$$super$zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_IterableLike__zip__sc_GenIterable__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofShort.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var $$this = this.repr$1;
  var len = $$this.u.length;
  while ((i < len)) {
    var idx = i;
    var $$this$1 = this.repr$1;
    var arg1 = $$this$1.get(idx);
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  return $as_sci_Map(b.elems$1)
});
$c_scm_ArrayOps$ofShort.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_scm_ArrayOps$ofShort.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_scm_ArrayOps__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_scm_ArrayOps$ofShort.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_scm_ArrayOps$ofShort.prototype.collect__s_PartialFunction__scg_CanBuildFrom__O = (function(pf, bf) {
  return $f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this, pf, bf)
});
$c_scm_ArrayOps$ofShort.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_IndexedSeqOptimized__reduceLeft__F2__O(this, op)
});
$c_scm_ArrayOps$ofShort.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_ArrayBuilder$ofShort().init___()
});
$c_scm_ArrayOps$ofShort.prototype.stringPrefix__T = (function() {
  return $f_sc_TraversableLike__stringPrefix__T(this)
});
$c_scm_ArrayOps$ofShort.prototype.sortWith__F2__O = (function(lt) {
  return $f_sc_SeqLike__sortWith__F2__O(this, lt)
});
function $as_scm_ArrayOps$ofShort(obj) {
  return (((obj instanceof $c_scm_ArrayOps$ofShort) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayOps$ofShort"))
}
function $isArrayOf_scm_ArrayOps$ofShort(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayOps$ofShort)))
}
function $asArrayOf_scm_ArrayOps$ofShort(obj, depth) {
  return (($isArrayOf_scm_ArrayOps$ofShort(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayOps$ofShort;", depth))
}
var $d_scm_ArrayOps$ofShort = new $TypeData().initClass({
  scm_ArrayOps$ofShort: 0
}, false, "scala.collection.mutable.ArrayOps$ofShort", {
  scm_ArrayOps$ofShort: 1,
  O: 1,
  scm_ArrayOps: 1,
  scm_ArrayLike: 1,
  scm_IndexedSeqOptimized: 1,
  scm_IndexedSeqLike: 1,
  sc_IndexedSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenIterableLike: 1,
  sc_GenSeqLike: 1,
  sc_IndexedSeqOptimized: 1,
  sc_CustomParallelizable: 1
});
$c_scm_ArrayOps$ofShort.prototype.$classData = $d_scm_ArrayOps$ofShort;
/** @constructor */
function $c_scm_ArrayOps$ofUnit() {
  $c_O.call(this);
  this.repr$1 = null
}
$c_scm_ArrayOps$ofUnit.prototype = new $h_O();
$c_scm_ArrayOps$ofUnit.prototype.constructor = $c_scm_ArrayOps$ofUnit;
/** @constructor */
function $h_scm_ArrayOps$ofUnit() {
  /*<skip>*/
}
$h_scm_ArrayOps$ofUnit.prototype = $c_scm_ArrayOps$ofUnit.prototype;
$c_scm_ArrayOps$ofUnit.prototype.seq__sc_TraversableOnce = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofUnit().init___Asr_BoxedUnit($$this)
});
$c_scm_ArrayOps$ofUnit.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_scm_ArrayOps$ofUnit.prototype.head__O = (function() {
  return $f_sc_IndexedSeqOptimized__head__O(this)
});
$c_scm_ArrayOps$ofUnit.prototype.apply__I__O = (function(idx) {
  var $$this = this.repr$1;
  $$this.get(idx)
});
$c_scm_ArrayOps$ofUnit.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_IndexedSeqOptimized__lengthCompare__I__I(this, len)
});
$c_scm_ArrayOps$ofUnit.prototype.toIterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length)
});
$c_scm_ArrayOps$ofUnit.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IndexedSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_scm_ArrayOps$ofUnit.prototype.exists__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__exists__F1__Z(this, p)
});
$c_scm_ArrayOps$ofUnit.prototype.toList__sci_List = (function() {
  return $f_sc_IndexedSeqOptimized__toList__sci_List(this)
});
$c_scm_ArrayOps$ofUnit.prototype.isEmpty__Z = (function() {
  return $f_sc_IndexedSeqOptimized__isEmpty__Z(this)
});
$c_scm_ArrayOps$ofUnit.prototype.thisCollection__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofUnit().init___Asr_BoxedUnit($$this)
});
$c_scm_ArrayOps$ofUnit.prototype.flatMap__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__flatMap__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_scm_ArrayOps$ofUnit.prototype.equals__O__Z = (function(x$1) {
  return $m_scm_ArrayOps$ofUnit$().equals$extension__Asr_BoxedUnit__O__Z(this.repr$1, x$1)
});
$c_scm_ArrayOps$ofUnit.prototype.scala$collection$IndexedSeqOptimized$$super$init__O = (function() {
  return $f_sc_TraversableLike__init__O(this)
});
$c_scm_ArrayOps$ofUnit.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__dropWhile__F1__O(this, p)
});
$c_scm_ArrayOps$ofUnit.prototype.mkString__T__T = (function(sep) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", sep, "")
});
$c_scm_ArrayOps$ofUnit.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_scm_ArrayOps$ofUnit.prototype.withFilter__F1__scg_FilterMonadic = (function(p) {
  return new $c_sc_TraversableLike$WithFilter().init___sc_TraversableLike__F1(this, p)
});
$c_scm_ArrayOps$ofUnit.prototype.forall__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__forall__F1__Z(this, p)
});
$c_scm_ArrayOps$ofUnit.prototype.$$colon$plus__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqLike__$$colon$plus__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_scm_ArrayOps$ofUnit.prototype.sorted__s_math_Ordering__O = (function(ord) {
  return $f_sc_SeqLike__sorted__s_math_Ordering__O(this, ord)
});
$c_scm_ArrayOps$ofUnit.prototype.toString__T = (function() {
  return $f_sc_TraversableLike__toString__T(this)
});
$c_scm_ArrayOps$ofUnit.prototype.foreach__F1__V = (function(f) {
  $f_sc_IndexedSeqOptimized__foreach__F1__V(this, f)
});
$c_scm_ArrayOps$ofUnit.prototype.foldLeft__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $$this.u.length;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArrayOps$ofUnit.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_IndexedSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_scm_ArrayOps$ofUnit.prototype.union__sc_GenSeq__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofUnit.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__takeWhile__F1__O(this, p)
});
$c_scm_ArrayOps$ofUnit.prototype.headOption__s_Option = (function() {
  return $f_sc_TraversableLike__headOption__s_Option(this)
});
$c_scm_ArrayOps$ofUnit.prototype.slice__I__I__O = (function(from, until) {
  return $f_scm_ArrayOps__slice__I__I__O(this, from, until)
});
$c_scm_ArrayOps$ofUnit.prototype.intersect__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__intersect__sc_GenSeq__O(this, that)
});
$c_scm_ArrayOps$ofUnit.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_ArrayOps$ofUnit.prototype.filter__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, false)
});
$c_scm_ArrayOps$ofUnit.prototype.size__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofUnit.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_IndexedSeqLike__toBuffer__scm_Buffer(this)
});
$c_scm_ArrayOps$ofUnit.prototype.distinct__O = (function() {
  return $f_sc_SeqLike__distinct__O(this)
});
$c_scm_ArrayOps$ofUnit.prototype.iterator__sc_Iterator = (function() {
  var $$this = this.repr$1;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length)
});
$c_scm_ArrayOps$ofUnit.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_IndexedSeqOptimized__find__F1__s_Option(this, p)
});
$c_scm_ArrayOps$ofUnit.prototype.span__F1__T2 = (function(p) {
  return $f_sc_IndexedSeqOptimized__span__F1__T2(this, p)
});
$c_scm_ArrayOps$ofUnit.prototype.diff__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__diff__sc_GenSeq__O(this, that)
});
$c_scm_ArrayOps$ofUnit.prototype.mkString__T = (function() {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", "", "")
});
$c_scm_ArrayOps$ofUnit.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IndexedSeqOptimized__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_scm_ArrayOps$ofUnit.prototype.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofUnit.prototype.length__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofUnit.prototype.scala$collection$IndexedSeqOptimized$$super$last__O = (function() {
  return $f_sc_TraversableLike__last__O(this)
});
$c_scm_ArrayOps$ofUnit.prototype.scala$collection$IndexedSeqOptimized$$super$tail__O = (function() {
  return $f_sc_TraversableLike__tail__O(this)
});
$c_scm_ArrayOps$ofUnit.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, true)
});
$c_scm_ArrayOps$ofUnit.prototype.sizeHintIfCheap__I = (function() {
  var $$this = this.repr$1;
  return $$this.u.length
});
$c_scm_ArrayOps$ofUnit.prototype.splitAt__I__T2 = (function(n) {
  return $f_sc_IndexedSeqOptimized__splitAt__I__T2(this, n)
});
$c_scm_ArrayOps$ofUnit.prototype.take__I__O = (function(n) {
  return $f_scm_ArrayOps__slice__I__I__O(this, 0, n)
});
$c_scm_ArrayOps$ofUnit.prototype.toStream__sci_Stream = (function() {
  var $$this = this.repr$1;
  var this$2 = new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $$this.u.length);
  return $f_sc_Iterator__toStream__sci_Stream(this$2)
});
$c_scm_ArrayOps$ofUnit.prototype.drop__I__O = (function(n) {
  var $$this = this.repr$1;
  var until = $$this.u.length;
  return $f_scm_ArrayOps__slice__I__I__O(this, n, until)
});
$c_scm_ArrayOps$ofUnit.prototype.contains__O__Z = (function(elem) {
  return $f_sc_SeqLike__contains__O__Z(this, elem)
});
$c_scm_ArrayOps$ofUnit.prototype.tail__O = (function() {
  return $f_sc_IndexedSeqOptimized__tail__O(this)
});
$c_scm_ArrayOps$ofUnit.prototype.thisCollection__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofUnit().init___Asr_BoxedUnit($$this)
});
$c_scm_ArrayOps$ofUnit.prototype.init___Asr_BoxedUnit = (function(repr) {
  this.repr$1 = repr;
  return this
});
$c_scm_ArrayOps$ofUnit.prototype.toTraversable__sc_Traversable = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofUnit().init___Asr_BoxedUnit($$this)
});
$c_scm_ArrayOps$ofUnit.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_scm_ArrayOps$ofUnit.prototype.sortBy__F1__s_math_Ordering__O = (function(f, ord) {
  return $f_sc_SeqLike__sortBy__F1__s_math_Ordering__O(this, f, ord)
});
$c_scm_ArrayOps$ofUnit.prototype.toSeq__sc_Seq = (function() {
  var $$this = this.repr$1;
  return new $c_scm_WrappedArray$ofUnit().init___Asr_BoxedUnit($$this)
});
$c_scm_ArrayOps$ofUnit.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_ArrayOps$ofUnit.prototype.repr__O = (function() {
  return this.repr$1
});
$c_scm_ArrayOps$ofUnit.prototype.$$div$colon__O__F2__O = (function(z, op) {
  var start = 0;
  var $$this = this.repr$1;
  var end = $$this.u.length;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArrayOps$ofUnit.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_scm_ArrayOps__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_scm_ArrayOps$ofUnit.prototype.isTraversableAgain__Z = (function() {
  return true
});
$c_scm_ArrayOps$ofUnit.prototype.groupBy__F1__sci_Map = (function(f) {
  return $f_sc_TraversableLike__groupBy__F1__sci_Map(this, f)
});
$c_scm_ArrayOps$ofUnit.prototype.hashCode__I = (function() {
  var $$this = this.repr$1;
  return $$this.hashCode__I()
});
$c_scm_ArrayOps$ofUnit.prototype.scala$collection$IndexedSeqOptimized$$super$zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_IterableLike__zip__sc_GenIterable__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayOps$ofUnit.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var $$this = this.repr$1;
  var len = $$this.u.length;
  while ((i < len)) {
    var idx = i;
    var $$this$1 = this.repr$1;
    $$this$1.get(idx);
    var arg1 = (void 0);
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  return $as_sci_Map(b.elems$1)
});
$c_scm_ArrayOps$ofUnit.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_scm_ArrayOps$ofUnit.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_scm_ArrayOps__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_scm_ArrayOps$ofUnit.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_scm_ArrayOps$ofUnit.prototype.collect__s_PartialFunction__scg_CanBuildFrom__O = (function(pf, bf) {
  return $f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this, pf, bf)
});
$c_scm_ArrayOps$ofUnit.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_IndexedSeqOptimized__reduceLeft__F2__O(this, op)
});
$c_scm_ArrayOps$ofUnit.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_ArrayBuilder$ofUnit().init___()
});
$c_scm_ArrayOps$ofUnit.prototype.stringPrefix__T = (function() {
  return $f_sc_TraversableLike__stringPrefix__T(this)
});
$c_scm_ArrayOps$ofUnit.prototype.sortWith__F2__O = (function(lt) {
  return $f_sc_SeqLike__sortWith__F2__O(this, lt)
});
function $as_scm_ArrayOps$ofUnit(obj) {
  return (((obj instanceof $c_scm_ArrayOps$ofUnit) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayOps$ofUnit"))
}
function $isArrayOf_scm_ArrayOps$ofUnit(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayOps$ofUnit)))
}
function $asArrayOf_scm_ArrayOps$ofUnit(obj, depth) {
  return (($isArrayOf_scm_ArrayOps$ofUnit(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayOps$ofUnit;", depth))
}
var $d_scm_ArrayOps$ofUnit = new $TypeData().initClass({
  scm_ArrayOps$ofUnit: 0
}, false, "scala.collection.mutable.ArrayOps$ofUnit", {
  scm_ArrayOps$ofUnit: 1,
  O: 1,
  scm_ArrayOps: 1,
  scm_ArrayLike: 1,
  scm_IndexedSeqOptimized: 1,
  scm_IndexedSeqLike: 1,
  sc_IndexedSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenIterableLike: 1,
  sc_GenSeqLike: 1,
  sc_IndexedSeqOptimized: 1,
  sc_CustomParallelizable: 1
});
$c_scm_ArrayOps$ofUnit.prototype.$classData = $d_scm_ArrayOps$ofUnit;
function $f_sc_IterableViewLike$Transformed__isEmpty__Z($thiz) {
  return (!$thiz.iterator__sc_Iterator().hasNext__Z())
}
function $is_sc_Map(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_Map)))
}
function $as_sc_Map(obj) {
  return (($is_sc_Map(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.Map"))
}
function $isArrayOf_sc_Map(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_Map)))
}
function $asArrayOf_sc_Map(obj, depth) {
  return (($isArrayOf_sc_Map(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.Map;", depth))
}
function $is_sc_Set(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_Set)))
}
function $as_sc_Set(obj) {
  return (($is_sc_Set(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.Set"))
}
function $isArrayOf_sc_Set(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_Set)))
}
function $asArrayOf_sc_Set(obj, depth) {
  return (($isArrayOf_sc_Set(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.Set;", depth))
}
/** @constructor */
function $c_scm_AbstractIterable() {
  $c_sc_AbstractIterable.call(this)
}
$c_scm_AbstractIterable.prototype = new $h_sc_AbstractIterable();
$c_scm_AbstractIterable.prototype.constructor = $c_scm_AbstractIterable;
/** @constructor */
function $h_scm_AbstractIterable() {
  /*<skip>*/
}
$h_scm_AbstractIterable.prototype = $c_scm_AbstractIterable.prototype;
function $f_scm_BufferLike__clone__scm_Buffer($thiz) {
  var bf = $as_scg_GenericTraversableTemplate($thiz).newBuilder__scm_Builder();
  bf.$$plus$plus$eq__sc_TraversableOnce__scg_Growable($thiz);
  return $as_scm_Buffer(bf.result__O())
}
function $f_scm_BufferLike__$$minus$eq__O__scm_Buffer($thiz, x) {
  var i = $thiz.indexOf__O__I(x);
  if ((i !== (-1))) {
    $thiz.remove__I__O(i)
  };
  return $as_scm_Buffer($thiz)
}
function $is_scm_BufferLike(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.scm_BufferLike)))
}
function $as_scm_BufferLike(obj) {
  return (($is_scm_BufferLike(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.BufferLike"))
}
function $isArrayOf_scm_BufferLike(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_BufferLike)))
}
function $asArrayOf_scm_BufferLike(obj, depth) {
  return (($isArrayOf_scm_BufferLike(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.BufferLike;", depth))
}
/** @constructor */
function $c_scm_HashMap$$anon$2() {
  $c_sc_MapLike$DefaultValuesIterable.call(this);
  this.$$outer$4 = null
}
$c_scm_HashMap$$anon$2.prototype = new $h_sc_MapLike$DefaultValuesIterable();
$c_scm_HashMap$$anon$2.prototype.constructor = $c_scm_HashMap$$anon$2;
/** @constructor */
function $h_scm_HashMap$$anon$2() {
  /*<skip>*/
}
$h_scm_HashMap$$anon$2.prototype = $c_scm_HashMap$$anon$2.prototype;
$c_scm_HashMap$$anon$2.prototype.foreach__F1__V = (function(f) {
  var this$1 = this.$$outer$4;
  var iterTable = this$1.table$5;
  var idx = $f_scm_HashTable__scala$collection$mutable$HashTable$$lastPopulatedIndex__I(this$1);
  var es = iterTable.get(idx);
  while ((es !== null)) {
    var next = $as_scm_HashEntry(es.next__O());
    var arg1 = es;
    var e = $as_scm_DefaultEntry(arg1);
    f.apply__O__O(e.value$1);
    es = next;
    while (((es === null) && (idx > 0))) {
      idx = (((-1) + idx) | 0);
      es = iterTable.get(idx)
    }
  }
});
$c_scm_HashMap$$anon$2.prototype.init___scm_HashMap = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$4 = $$outer
  };
  $c_sc_MapLike$DefaultValuesIterable.prototype.init___sc_MapLike.call(this, $$outer);
  return this
});
var $d_scm_HashMap$$anon$2 = new $TypeData().initClass({
  scm_HashMap$$anon$2: 0
}, false, "scala.collection.mutable.HashMap$$anon$2", {
  scm_HashMap$$anon$2: 1,
  sc_MapLike$DefaultValuesIterable: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_HashMap$$anon$2.prototype.$classData = $d_scm_HashMap$$anon$2;
/** @constructor */
function $c_sjs_js_ArrayOps() {
  /*<skip>*/
}
function $as_sjs_js_ArrayOps(obj) {
  return (((obj instanceof $c_sjs_js_ArrayOps) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.scalajs.js.ArrayOps"))
}
function $isArrayOf_sjs_js_ArrayOps(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sjs_js_ArrayOps)))
}
function $asArrayOf_sjs_js_ArrayOps(obj, depth) {
  return (($isArrayOf_sjs_js_ArrayOps(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.scalajs.js.ArrayOps;", depth))
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_NilShape() {
  $c_Lamf_plugins_domain_shapes_models_AnyShape.call(this);
  this.meta$3 = null
}
$c_Lamf_plugins_domain_shapes_models_NilShape.prototype = new $h_Lamf_plugins_domain_shapes_models_AnyShape();
$c_Lamf_plugins_domain_shapes_models_NilShape.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_NilShape;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_NilShape() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_NilShape.prototype = $c_Lamf_plugins_domain_shapes_models_NilShape.prototype;
$c_Lamf_plugins_domain_shapes_models_NilShape.prototype.productPrefix__T = (function() {
  return "NilShape"
});
$c_Lamf_plugins_domain_shapes_models_NilShape.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_shapes_models_NilShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_shapes_models_NilShape)) {
    var NilShape$1 = $as_Lamf_plugins_domain_shapes_models_NilShape(x$1);
    var x = this.fields$2;
    var x$2 = NilShape$1.fields$2;
    if ((x === x$2)) {
      var x$3 = this.annotations$2;
      var x$4 = NilShape$1.annotations$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_models_NilShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$2;
      break
    }
    case 1: {
      return this.annotations$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_shapes_models_NilShape.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_NilShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_NilShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_shapes_models_NilShape.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return this.meta$3
});
$c_Lamf_plugins_domain_shapes_models_NilShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_shapes_models_NilShape.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_plugins_domain_shapes_models_NilShape.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-nil" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/nil/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_shapes_models_NilShape.prototype.ramlSyntaxKey__T = (function() {
  return "shape"
});
$c_Lamf_plugins_domain_shapes_models_NilShape.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_shapes_models_NilShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_shapes_models_NilShape.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_plugins_domain_shapes_models_NilShape.prototype.linkCopy__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_NilShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_NilShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_shapes_models_NilShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_shapes_models_NilShape.prototype.meta__Lamf_plugins_domain_shapes_metamodel_AnyShapeModel = (function() {
  return this.meta$3
});
$c_Lamf_plugins_domain_shapes_models_NilShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_shapes_models_NilShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  $c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  this.meta$3 = $m_Lamf_plugins_domain_shapes_metamodel_NilShapeModel$();
  return this
});
function $as_Lamf_plugins_domain_shapes_models_NilShape(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_models_NilShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.models.NilShape"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_models_NilShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_models_NilShape)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_models_NilShape(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_models_NilShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.models.NilShape;", depth))
}
var $d_Lamf_plugins_domain_shapes_models_NilShape = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_NilShape: 0
}, false, "amf.plugins.domain.shapes.models.NilShape", {
  Lamf_plugins_domain_shapes_models_NilShape: 1,
  Lamf_plugins_domain_shapes_models_AnyShape: 1,
  Lamf_core_model_domain_Shape: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelper: 1,
  Lamf_plugins_domain_webapi_unsafe_JsonSchemaSecrets: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelpers: 1,
  Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer: 1,
  Lamf_core_model_domain_ExternalSourceElement: 1,
  Lamf_plugins_domain_shapes_models_InheritanceChain: 1,
  Lamf_plugins_domain_webapi_models_DocumentedElement: 1,
  Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_NilShape.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_NilShape;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_NodeShape() {
  $c_Lamf_plugins_domain_shapes_models_AnyShape.call(this);
  this.meta$3 = null;
  this.ramlSyntaxKey$3 = null
}
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype = new $h_Lamf_plugins_domain_shapes_models_AnyShape();
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_NodeShape;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_NodeShape() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_NodeShape.prototype = $c_Lamf_plugins_domain_shapes_models_NodeShape.prototype;
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.withProperty__T__Lamf_core_model_domain_extensions_PropertyShape = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_core_model_domain_extensions_PropertyShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var result = $as_Lamf_core_model_domain_extensions_PropertyShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2));
  var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, result);
  return result
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.productPrefix__T = (function() {
  return "NodeShape"
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.adopted$default$2__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject = (function(parent, cycle) {
  return this.adopted__T__sc_Seq__Lamf_plugins_domain_shapes_models_NodeShape(parent, cycle)
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape)) {
    var NodeShape$1 = $as_Lamf_plugins_domain_shapes_models_NodeShape(x$1);
    var x = this.fields$2;
    var x$2 = NodeShape$1.fields$2;
    if ((x === x$2)) {
      var x$3 = this.annotations$2;
      var x$4 = NodeShape$1.annotations$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$2;
      break
    }
    case 1: {
      return this.annotations$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_NodeShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return this.meta$3
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.adopted__T__sc_Seq__Lamf_plugins_domain_shapes_models_NodeShape = (function(parent, cycle) {
  var isCycle = cycle.contains__O__Z(this.id$1);
  var this$1 = $m_s_Option$().apply__O__s_Option(parent);
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var x$1 = $as_T(arg1);
    var jsx$1 = ($uI(x$1.indexOf("#")) !== (-1))
  } else {
    var jsx$1 = false
  };
  if (jsx$1) {
    $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent)
  } else {
    var parent$1 = (parent + "#/");
    $f_Lamf_core_model_domain_AmfObject__simpleAdoption__T__Lamf_core_model_domain_AmfObject(this, parent$1)
  };
  if ((!isCycle)) {
    var jsx$2 = this.id$1;
    var this$5 = $m_sc_Seq$();
    var newCycle = $as_sc_Seq(cycle.$$colon$plus__O__scg_CanBuildFrom__O(jsx$2, this$5.ReusableCBFInstance$2));
    $as_sc_Seq(this.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Properties$1)).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2$1, newCycle$1) {
      return (function(x$2$2) {
        var x$2 = $as_Lamf_core_model_domain_extensions_PropertyShape(x$2$2);
        return x$2.adopted__T__sc_Seq__Lamf_core_model_domain_extensions_PropertyShape(this$2$1.id$1, newCycle$1)
      })
    })(this, newCycle)));
    var this$6 = $m_s_Option$().apply__O__s_Option($as_Lamf_core_model_domain_Shape(this.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().AdditionalPropertiesSchema$1)));
    if ((!this$6.isEmpty__Z())) {
      var arg1$1 = this$6.get__O();
      var shape = $as_Lamf_core_model_domain_Shape(arg1$1);
      $as_Lamf_core_model_domain_Shape(shape.adopted__T__sc_Seq__Lamf_core_model_domain_AmfObject(this.id$1, newCycle))
    }
  };
  return this
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-node" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.withInheritsObject__T__Lamf_plugins_domain_shapes_models_NodeShape = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_shapes_models_NodeShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var result = $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2));
  var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Inherits$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, result);
  return result
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.ramlSyntaxKey__T = (function() {
  return this.ramlSyntaxKey$3
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_shapes_models_NodeShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.linkCopy__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_NodeShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_NodeShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.withInheritsScalar__T__Lamf_plugins_domain_shapes_models_ScalarShape = (function(name) {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var qual$1 = new $c_Lamf_plugins_domain_shapes_models_ScalarShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  var result = $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, name, x$2));
  var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Inherits$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, result);
  return result
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.meta__Lamf_plugins_domain_shapes_metamodel_AnyShapeModel = (function() {
  return this.meta$3
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  $c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  this.meta$3 = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$();
  this.ramlSyntaxKey$3 = "nodeShape";
  return this
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.withDependency__Lamf_plugins_domain_shapes_models_PropertyDependencies = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var result = new $c_Lamf_plugins_domain_shapes_models_PropertyDependencies().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var field = $m_Lamf_plugins_domain_shapes_metamodel_NodeShapeModel$().Dependencies$1;
  $f_Lamf_core_model_domain_AmfObject__add__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, result);
  return result
});
function $as_Lamf_plugins_domain_shapes_models_NodeShape(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_models_NodeShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.models.NodeShape"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_models_NodeShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_models_NodeShape)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_models_NodeShape(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_models_NodeShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.models.NodeShape;", depth))
}
var $d_Lamf_plugins_domain_shapes_models_NodeShape = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_NodeShape: 0
}, false, "amf.plugins.domain.shapes.models.NodeShape", {
  Lamf_plugins_domain_shapes_models_NodeShape: 1,
  Lamf_plugins_domain_shapes_models_AnyShape: 1,
  Lamf_core_model_domain_Shape: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelper: 1,
  Lamf_plugins_domain_webapi_unsafe_JsonSchemaSecrets: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelpers: 1,
  Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer: 1,
  Lamf_core_model_domain_ExternalSourceElement: 1,
  Lamf_plugins_domain_shapes_models_InheritanceChain: 1,
  Lamf_plugins_domain_webapi_models_DocumentedElement: 1,
  Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_NodeShape.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_NodeShape;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_SchemaShape() {
  $c_Lamf_plugins_domain_shapes_models_AnyShape.call(this)
}
$c_Lamf_plugins_domain_shapes_models_SchemaShape.prototype = new $h_Lamf_plugins_domain_shapes_models_AnyShape();
$c_Lamf_plugins_domain_shapes_models_SchemaShape.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_SchemaShape;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_SchemaShape() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_SchemaShape.prototype = $c_Lamf_plugins_domain_shapes_models_SchemaShape.prototype;
$c_Lamf_plugins_domain_shapes_models_SchemaShape.prototype.productPrefix__T = (function() {
  return "SchemaShape"
});
$c_Lamf_plugins_domain_shapes_models_SchemaShape.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_shapes_models_SchemaShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_shapes_models_SchemaShape)) {
    var SchemaShape$1 = $as_Lamf_plugins_domain_shapes_models_SchemaShape(x$1);
    var x = this.fields$2;
    var x$2 = SchemaShape$1.fields$2;
    if ((x === x$2)) {
      var x$3 = this.annotations$2;
      var x$4 = SchemaShape$1.annotations$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_models_SchemaShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$2;
      break
    }
    case 1: {
      return this.annotations$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_shapes_models_SchemaShape.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_SchemaShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_SchemaShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_shapes_models_SchemaShape.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return $m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$()
});
$c_Lamf_plugins_domain_shapes_models_SchemaShape.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_plugins_domain_shapes_models_SchemaShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_shapes_models_SchemaShape.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-schema" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/schema/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_shapes_models_SchemaShape.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_shapes_models_SchemaShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_shapes_models_SchemaShape.prototype.ramlSyntaxKey__T = (function() {
  return "schemaShape"
});
$c_Lamf_plugins_domain_shapes_models_SchemaShape.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_plugins_domain_shapes_models_SchemaShape.prototype.linkCopy__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_SchemaShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_SchemaShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_shapes_models_SchemaShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_shapes_models_SchemaShape.prototype.meta__Lamf_plugins_domain_shapes_metamodel_AnyShapeModel = (function() {
  return $m_Lamf_plugins_domain_shapes_metamodel_SchemaShapeModel$()
});
$c_Lamf_plugins_domain_shapes_models_SchemaShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_shapes_models_SchemaShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  $c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  return this
});
function $as_Lamf_plugins_domain_shapes_models_SchemaShape(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_models_SchemaShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.models.SchemaShape"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_models_SchemaShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_models_SchemaShape)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_models_SchemaShape(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_models_SchemaShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.models.SchemaShape;", depth))
}
var $d_Lamf_plugins_domain_shapes_models_SchemaShape = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_SchemaShape: 0
}, false, "amf.plugins.domain.shapes.models.SchemaShape", {
  Lamf_plugins_domain_shapes_models_SchemaShape: 1,
  Lamf_plugins_domain_shapes_models_AnyShape: 1,
  Lamf_core_model_domain_Shape: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelper: 1,
  Lamf_plugins_domain_webapi_unsafe_JsonSchemaSecrets: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelpers: 1,
  Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer: 1,
  Lamf_core_model_domain_ExternalSourceElement: 1,
  Lamf_plugins_domain_shapes_models_InheritanceChain: 1,
  Lamf_plugins_domain_webapi_models_DocumentedElement: 1,
  Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_SchemaShape.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_SchemaShape;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_UnionShape() {
  $c_Lamf_plugins_domain_shapes_models_AnyShape.call(this);
  this.meta$3 = null
}
$c_Lamf_plugins_domain_shapes_models_UnionShape.prototype = new $h_Lamf_plugins_domain_shapes_models_AnyShape();
$c_Lamf_plugins_domain_shapes_models_UnionShape.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_UnionShape;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_UnionShape() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_UnionShape.prototype = $c_Lamf_plugins_domain_shapes_models_UnionShape.prototype;
$c_Lamf_plugins_domain_shapes_models_UnionShape.prototype.productPrefix__T = (function() {
  return "UnionShape"
});
$c_Lamf_plugins_domain_shapes_models_UnionShape.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_shapes_models_UnionShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape)) {
    var UnionShape$1 = $as_Lamf_plugins_domain_shapes_models_UnionShape(x$1);
    var x = this.fields$2;
    var x$2 = UnionShape$1.fields$2;
    if ((x === x$2)) {
      var x$3 = this.annotations$2;
      var x$4 = UnionShape$1.annotations$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_models_UnionShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$2;
      break
    }
    case 1: {
      return this.annotations$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_shapes_models_UnionShape.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_UnionShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_shapes_models_UnionShape.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return this.meta$3
});
$c_Lamf_plugins_domain_shapes_models_UnionShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_shapes_models_UnionShape.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_plugins_domain_shapes_models_UnionShape.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-union" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/union/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_shapes_models_UnionShape.prototype.ramlSyntaxKey__T = (function() {
  return "unionShape"
});
$c_Lamf_plugins_domain_shapes_models_UnionShape.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_shapes_models_UnionShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_shapes_models_UnionShape.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_plugins_domain_shapes_models_UnionShape.prototype.linkCopy__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_UnionShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_AnyShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_shapes_models_UnionShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_shapes_models_UnionShape.prototype.meta__Lamf_plugins_domain_shapes_metamodel_AnyShapeModel = (function() {
  return this.meta$3
});
$c_Lamf_plugins_domain_shapes_models_UnionShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_shapes_models_UnionShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  $c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  this.meta$3 = $m_Lamf_plugins_domain_shapes_metamodel_UnionShapeModel$();
  return this
});
function $as_Lamf_plugins_domain_shapes_models_UnionShape(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_models_UnionShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.models.UnionShape"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_models_UnionShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_models_UnionShape)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_models_UnionShape(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_models_UnionShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.models.UnionShape;", depth))
}
var $d_Lamf_plugins_domain_shapes_models_UnionShape = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_UnionShape: 0
}, false, "amf.plugins.domain.shapes.models.UnionShape", {
  Lamf_plugins_domain_shapes_models_UnionShape: 1,
  Lamf_plugins_domain_shapes_models_AnyShape: 1,
  Lamf_core_model_domain_Shape: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelper: 1,
  Lamf_plugins_domain_webapi_unsafe_JsonSchemaSecrets: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelpers: 1,
  Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer: 1,
  Lamf_core_model_domain_ExternalSourceElement: 1,
  Lamf_plugins_domain_shapes_models_InheritanceChain: 1,
  Lamf_plugins_domain_webapi_models_DocumentedElement: 1,
  Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_UnionShape.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_UnionShape;
function $f_sc_DefaultMap__$$plus__T2__sc_Map($thiz, kv) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(b, $thiz);
  var elem = new $c_T2().init___O__O(kv.$$und1__O(), kv.$$und2__O());
  b.$$plus$eq__T2__scm_MapBuilder(elem);
  return $as_sc_Map(b.elems$1)
}
function $f_sc_DefaultMap__$$minus__O__sc_Map($thiz, key) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($thiz.empty__sc_Map());
  var p = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, key$1) {
    return (function(x$1$2) {
      var x$1 = $as_T2(x$1$2);
      return (!$m_sr_BoxesRunTime$().equals__O__O__Z(key$1, x$1.$$und1__O()))
    })
  })($thiz, key));
  var xs = $as_sc_TraversableOnce($f_sc_TraversableLike__filterImpl__F1__Z__O($thiz, p, false));
  $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(b, xs);
  return $as_sc_Map(b.elems$1)
}
function $is_sc_IndexedSeq(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_IndexedSeq)))
}
function $as_sc_IndexedSeq(obj) {
  return (($is_sc_IndexedSeq(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.IndexedSeq"))
}
function $isArrayOf_sc_IndexedSeq(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_IndexedSeq)))
}
function $asArrayOf_sc_IndexedSeq(obj, depth) {
  return (($isArrayOf_sc_IndexedSeq(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.IndexedSeq;", depth))
}
function $f_sc_IterableViewLike$Zipped__iterator__sc_Iterator($thiz) {
  var this$1 = $thiz.scala$collection$IterableViewLike$Zipped$$$outer__sc_IterableViewLike().iterator__sc_Iterator();
  var that = $thiz.other__sc_GenIterable().iterator__sc_Iterator();
  return new $c_sc_Iterator$$anon$18().init___sc_Iterator__sc_Iterator(this$1, that)
}
function $is_sc_LinearSeq(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_LinearSeq)))
}
function $as_sc_LinearSeq(obj) {
  return (($is_sc_LinearSeq(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.LinearSeq"))
}
function $isArrayOf_sc_LinearSeq(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_LinearSeq)))
}
function $asArrayOf_sc_LinearSeq(obj, depth) {
  return (($isArrayOf_sc_LinearSeq(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.LinearSeq;", depth))
}
function $f_scm_MapLike__put__O__O__s_Option($thiz, key, value) {
  var r = $thiz.get__O__s_Option(key);
  $thiz.update__O__O__V(key, value);
  return r
}
function $f_scm_MapLike__remove__O__s_Option($thiz, key) {
  var r = $thiz.get__O__s_Option(key);
  $thiz.$$minus$eq__O__scm_MapLike(key);
  return r
}
function $f_scm_MapLike__update__O__O__V($thiz, key, value) {
  $thiz.$$plus$eq__T2__scm_MapLike(new $c_T2().init___O__O(key, value))
}
function $f_scm_MapLike__updated__O__O__scm_Map($thiz, key, value) {
  return $thiz.$$plus__T2__scm_Map(new $c_T2().init___O__O(key, value))
}
function $f_scm_MapLike__getOrElseUpdate__O__F0__O($thiz, key, op) {
  var x1 = $thiz.get__O__s_Option(key);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var v = x2.value$2;
    return v
  } else {
    var x = $m_s_None$();
    if ((x === x1)) {
      var d = op.apply__O();
      $thiz.update__O__O__V(key, d);
      return d
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
}
function $f_scm_MapLike__toSeq__sc_Seq($thiz) {
  var result = new $c_scm_ArrayBuffer().init___I($thiz.size__I());
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, result$1) {
    return (function(x$1$2) {
      var x$1 = $as_T2(x$1$2);
      return result$1.$$plus$eq__O__scm_ArrayBuffer(x$1)
    })
  })($thiz, result)));
  return result
}
function $f_scm_MapLike__clear__V($thiz) {
  var this$1 = $thiz.keysIterator__sc_Iterator();
  while (this$1.hasNext__Z()) {
    var arg1 = this$1.next__O();
    $thiz.$$minus$eq__O__scm_MapLike(arg1)
  }
}
function $is_scm_MapLike(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.scm_MapLike)))
}
function $as_scm_MapLike(obj) {
  return (($is_scm_MapLike(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.MapLike"))
}
function $isArrayOf_scm_MapLike(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_MapLike)))
}
function $asArrayOf_scm_MapLike(obj, depth) {
  return (($isArrayOf_scm_MapLike(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.MapLike;", depth))
}
function $f_scm_SetLike__clone__scm_Set($thiz) {
  var jsx$1 = $as_scg_Growable($thiz.empty__sc_Set());
  var this$1 = $as_scm_Set($thiz);
  return $as_scm_Set(jsx$1.$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$1))
}
function $f_scm_SetLike__toSeq__sc_Seq($thiz) {
  var result = new $c_scm_ArrayBuffer().init___I($thiz.size__I());
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, result$1) {
    return (function(x$1$2) {
      return result$1.$$plus$eq__O__scm_ArrayBuffer(x$1$2)
    })
  })($thiz, result)));
  return result
}
function $f_Lamf_client_convert_CoreBaseClientConverter__asClientMap__scm_Map__Lamf_client_convert_InternalClientMatcher__sjs_js_Dictionary($thiz, from, matcher) {
  var this$5 = $m_sjs_js_JSConverters$JSRichGenMap$();
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, matcher$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var k = $as_T(x0$1.$$und1__O());
        var v = x0$1.$$und2__O();
        var y = matcher$1.asClient__O__O(v);
        return new $c_T2().init___O__O(k, y)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })($thiz, matcher));
  var this$3 = $m_scm_Map$();
  var bf = new $c_scg_GenMapFactory$MapCanBuildFrom().init___scg_GenMapFactory(this$3);
  var map = $as_sc_GenMap($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(from, f, bf));
  var result = {};
  map.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, result$1) {
    return (function(x0$1$2$1) {
      var x0$1$1 = $as_T2(x0$1$2$1);
      if ((x0$1$1 !== null)) {
        var key = $as_T(x0$1$1.$$und1__O());
        var value = x0$1$1.$$und2__O();
        result$1[key] = value
      } else {
        throw new $c_s_MatchError().init___O(x0$1$1)
      }
    })
  })(this$5, result)));
  return result
}
function $f_Lamf_client_convert_CoreBaseClientConverter__asClientList__sc_Seq__Lamf_client_convert_InternalClientMatcher__sjs_js_Array($thiz, from, matcher) {
  var jsx$2 = $m_sjs_js_JSConverters$JSRichGenTraversableOnce$();
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, matcher$1) {
    return (function(from$2$2) {
      return matcher$1.asClient__O__O(from$2$2)
    })
  })($thiz, matcher));
  var this$1 = $m_sc_Seq$();
  var col = $as_sc_GenTraversableOnce(from.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  return jsx$2.toJSArray$extension__sc_GenTraversableOnce__sjs_js_Array(col)
}
function $f_Lamf_client_convert_CoreBaseClientConverter__asInternalSeqWithEC__sjs_js_Array__Lamf_client_convert_ClientInternalMatcherWithEC__s_concurrent_ExecutionContext__sc_Seq($thiz, from, matcher, executionContext) {
  $m_sc_Seq$();
  $m_sjs_js_WrappedArray$();
  var b = new $c_sjs_js_WrappedArray().init___();
  var x1 = $uI(from.length);
  switch (x1) {
    case (-1): {
      break
    }
  };
  var i = 0;
  var len = $uI(from.length);
  while ((i < len)) {
    var index = i;
    var arg1 = from[index];
    var elem = matcher.asInternal__O__s_concurrent_ExecutionContext__O(arg1, executionContext);
    b.array$6.push(elem);
    i = ((1 + i) | 0)
  };
  return b
}
function $f_Lamf_client_convert_CoreBaseClientConverter__asClientOptionWithEC__s_Option__Lamf_client_convert_InternalClientMatcherWithEC__s_concurrent_ExecutionContext__sjs_js_UndefOr($thiz, from, matcher, executionContext) {
  if (from.isEmpty__Z()) {
    var opt = $m_s_None$()
  } else {
    var arg1 = from.get__O();
    var opt = new $c_s_Some().init___O(matcher.asClient__O__s_concurrent_ExecutionContext__O(arg1, executionContext))
  };
  if (opt.isEmpty__Z()) {
    return (void 0)
  } else {
    var arg1$1 = opt.get__O();
    return arg1$1
  }
}
function $f_Lamf_client_convert_CoreBaseClientConverter__asClientImmutableMap__sci_Map__Lamf_client_convert_InternalClientMatcher__sjs_js_Dictionary($thiz, from, matcher) {
  var this$5 = $m_sjs_js_JSConverters$JSRichGenMap$();
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, matcher$1) {
    return (function(x0$1$2) {
      var x0$1 = $as_T2(x0$1$2);
      if ((x0$1 !== null)) {
        var k = $as_T(x0$1.$$und1__O());
        var v = x0$1.$$und2__O();
        var y = matcher$1.asClient__O__O(v);
        return new $c_T2().init___O__O(k, y)
      } else {
        throw new $c_s_MatchError().init___O(x0$1)
      }
    })
  })($thiz, matcher));
  var this$3 = $m_sci_Map$();
  var bf = new $c_scg_GenMapFactory$MapCanBuildFrom().init___scg_GenMapFactory(this$3);
  var map = $as_sc_GenMap($f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(from, f, bf));
  var result = {};
  map.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this$1, result$1) {
    return (function(x0$1$2$1) {
      var x0$1$1 = $as_T2(x0$1$2$1);
      if ((x0$1$1 !== null)) {
        var key = $as_T(x0$1$1.$$und1__O());
        var value = x0$1$1.$$und2__O();
        result$1[key] = value
      } else {
        throw new $c_s_MatchError().init___O(x0$1$1)
      }
    })
  })(this$5, result)));
  return result
}
function $f_Lamf_client_convert_CoreBaseClientConverter__toScalaOption__sjs_js_UndefOr__s_Option($thiz, from) {
  return ((from === (void 0)) ? $m_s_None$() : new $c_s_Some().init___O(from))
}
function $f_Lamf_client_convert_CoreBaseClientConverter__asClientFuture__s_concurrent_Future__s_concurrent_ExecutionContext__sjs_js_Promise($thiz, from, executionContext) {
  return $m_sjs_js_JSConverters$JSRichFuture$().toJSPromise$extension__s_concurrent_Future__s_concurrent_ExecutionContext__sjs_js_Promise(from, executionContext)
}
function $f_Lamf_client_convert_CoreBaseClientConverter__asClientOption__s_Option__Lamf_client_convert_InternalClientMatcher__sjs_js_UndefOr($thiz, from, matcher) {
  if (from.isEmpty__Z()) {
    var opt = $m_s_None$()
  } else {
    var arg1 = from.get__O();
    var opt = new $c_s_Some().init___O(matcher.asClient__O__O(arg1))
  };
  if (opt.isEmpty__Z()) {
    return (void 0)
  } else {
    var arg1$1 = opt.get__O();
    return arg1$1
  }
}
function $f_Lamf_client_convert_CoreBaseClientConverter__asInternalFuture__sjs_js_Promise__Lamf_client_convert_ClientInternalMatcher__s_concurrent_ExecutionContext__s_concurrent_Future($thiz, from, matcher, executionContext) {
  return $m_sjs_js_Thenable$ThenableOps$().toFuture$extension__sjs_js_Thenable__s_concurrent_Future(from).map__F1__s_concurrent_ExecutionContext__s_concurrent_Future(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, matcher$1) {
    return (function(from$2$2) {
      return matcher$1.asInternal__O__O(from$2$2)
    })
  })($thiz, matcher)), executionContext)
}
function $f_Lamf_client_convert_CoreBaseClientConverter__asInternalSeq__sjs_js_Array__Lamf_client_convert_ClientInternalMatcher__sc_Seq($thiz, from, matcher) {
  $m_sc_Seq$();
  $m_sjs_js_WrappedArray$();
  var b = new $c_sjs_js_WrappedArray().init___();
  var x1 = $uI(from.length);
  switch (x1) {
    case (-1): {
      break
    }
  };
  var i = 0;
  var len = $uI(from.length);
  while ((i < len)) {
    var index = i;
    var arg1 = from[index];
    var elem = matcher.asInternal__O__O(arg1);
    b.array$6.push(elem);
    i = ((1 + i) | 0)
  };
  return b
}
function $f_Lamf_client_convert_CoreBaseClientConverter__asClientListWithEC__sc_Seq__Lamf_client_convert_InternalClientMatcherWithEC__s_concurrent_ExecutionContext__sjs_js_Array($thiz, from, matcher, executionContext) {
  var jsx$2 = $m_sjs_js_JSConverters$JSRichGenTraversableOnce$();
  var jsx$1 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, matcher$1, executionContext$1) {
    return (function(from$2$2) {
      return matcher$1.asClient__O__s_concurrent_ExecutionContext__O(from$2$2, executionContext$1)
    })
  })($thiz, matcher, executionContext));
  var this$1 = $m_sc_Seq$();
  var col = $as_sc_GenTraversableOnce(from.map__F1__scg_CanBuildFrom__O(jsx$1, this$1.ReusableCBFInstance$2));
  return jsx$2.toJSArray$extension__sc_GenTraversableOnce__sjs_js_Array(col)
}
function $f_Lamf_client_convert_CoreBaseClientConverter__asInternalMap__sjs_js_Dictionary__Lamf_client_convert_ClientInternalMatcher__sci_Map($thiz, from, m) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var this$3 = new $c_sjs_js_WrappedDictionary$DictionaryIterator().init___sjs_js_Dictionary(from);
  while (this$3.hasNext__Z()) {
    var arg1 = this$3.next__T2();
    b.$$plus$eq__T2__scm_MapBuilder(arg1)
  };
  var this$6 = $as_sci_Map(b.elems$1);
  var z = $m_s_Predef$().Map$2.apply__sc_Seq__sc_GenMap($m_sci_Nil$());
  var op = new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this, m$1) {
    return (function(x0$1$2, x1$1$2) {
      var x0$1 = $as_sci_Map(x0$1$2);
      var x1$1 = $as_T2(x1$1$2);
      var x1 = new $c_T2().init___O__O(x0$1, x1$1);
      var acc = $as_sci_Map(x1.$$und1$f);
      var p2 = $as_T2(x1.$$und2$f);
      if ((p2 !== null)) {
        var e = $as_T(p2.$$und1__O());
        var i = p2.$$und2__O();
        var y = m$1.asInternal__O__O(i);
        return acc.$$plus__T2__sci_Map(new $c_T2().init___O__O(e, y))
      };
      throw new $c_s_MatchError().init___O(x1)
    })
  })($thiz, m));
  return $as_sci_Map($f_sc_TraversableOnce__foldLeft__O__F2__O(this$6, z, op))
}
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_ArrayShape() {
  $c_Lamf_plugins_domain_shapes_models_DataArrangementShape.call(this);
  this.meta$4 = null
}
$c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype = new $h_Lamf_plugins_domain_shapes_models_DataArrangementShape();
$c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_ArrayShape;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_ArrayShape() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_ArrayShape.prototype = $c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype;
$c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype.productPrefix__T = (function() {
  return "ArrayShape"
});
$c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype.toMatrixShape__Lamf_plugins_domain_shapes_models_MatrixShape = (function() {
  var this$1 = new $c_Lamf_plugins_domain_shapes_models_MatrixShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(this.fields$2, this.annotations$2);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_MatrixShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$1, value))
});
$c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape)) {
    var ArrayShape$1 = $as_Lamf_plugins_domain_shapes_models_ArrayShape(x$1);
    var x = this.fields$2;
    var x$2 = ArrayShape$1.fields$2;
    if ((x === x$2)) {
      var x$3 = this.annotations$2;
      var x$4 = ArrayShape$1.annotations$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$2;
      break
    }
    case 1: {
      return this.annotations$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_ArrayShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_ArrayShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return this.meta$4
});
$c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype.withItems__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_ArrayShape = (function(items) {
  this.fields$2.set__T__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_parser_Annotations__Lamf_core_parser_Fields((this.id$1 + "/items"), $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Items$1, items, ($m_Lamf_core_parser_Annotations$(), new $c_Lamf_core_parser_Annotations().init___()));
  return this
});
$c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_shapes_models_ArrayShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype.linkCopy__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_ArrayShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_ArrayShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype.withContains__Lamf_core_model_domain_Shape__Lamf_plugins_domain_shapes_models_ArrayShape = (function(contains) {
  var field = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$().Contains$1;
  $f_Lamf_core_model_domain_AmfObject__set__Lamf_core_metamodel_Field__Lamf_core_model_domain_AmfElement__Lamf_core_model_domain_AmfObject(this, field, contains);
  return this
});
$c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype.meta__Lamf_plugins_domain_shapes_metamodel_AnyShapeModel = (function() {
  return this.meta$4
});
$c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  $c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  this.meta$4 = $m_Lamf_plugins_domain_shapes_metamodel_ArrayShapeModel$();
  return this
});
function $as_Lamf_plugins_domain_shapes_models_ArrayShape(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_models_ArrayShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.models.ArrayShape"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_models_ArrayShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_models_ArrayShape)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_models_ArrayShape(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_models_ArrayShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.models.ArrayShape;", depth))
}
var $d_Lamf_plugins_domain_shapes_models_ArrayShape = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_ArrayShape: 0
}, false, "amf.plugins.domain.shapes.models.ArrayShape", {
  Lamf_plugins_domain_shapes_models_ArrayShape: 1,
  Lamf_plugins_domain_shapes_models_DataArrangementShape: 1,
  Lamf_plugins_domain_shapes_models_AnyShape: 1,
  Lamf_core_model_domain_Shape: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelper: 1,
  Lamf_plugins_domain_webapi_unsafe_JsonSchemaSecrets: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelpers: 1,
  Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer: 1,
  Lamf_core_model_domain_ExternalSourceElement: 1,
  Lamf_plugins_domain_shapes_models_InheritanceChain: 1,
  Lamf_plugins_domain_webapi_models_DocumentedElement: 1,
  Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_ArrayShape.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_ArrayShape;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_FileShape() {
  $c_Lamf_plugins_domain_shapes_models_AnyShape.call(this);
  this.meta$3 = null;
  this.ramlSyntaxKey$3 = null
}
$c_Lamf_plugins_domain_shapes_models_FileShape.prototype = new $h_Lamf_plugins_domain_shapes_models_AnyShape();
$c_Lamf_plugins_domain_shapes_models_FileShape.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_FileShape;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_FileShape() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_FileShape.prototype = $c_Lamf_plugins_domain_shapes_models_FileShape.prototype;
$c_Lamf_plugins_domain_shapes_models_FileShape.prototype.productPrefix__T = (function() {
  return "FileShape"
});
$c_Lamf_plugins_domain_shapes_models_FileShape.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_shapes_models_FileShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_shapes_models_FileShape)) {
    var FileShape$1 = $as_Lamf_plugins_domain_shapes_models_FileShape(x$1);
    var x = this.fields$2;
    var x$2 = FileShape$1.fields$2;
    if ((x === x$2)) {
      var x$3 = this.annotations$2;
      var x$4 = FileShape$1.annotations$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_models_FileShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$2;
      break
    }
    case 1: {
      return this.annotations$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_shapes_models_FileShape.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_FileShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_FileShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_shapes_models_FileShape.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return this.meta$3
});
$c_Lamf_plugins_domain_shapes_models_FileShape.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_plugins_domain_shapes_models_FileShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_shapes_models_FileShape.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-file" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_shapes_models_FileShape.prototype.ramlSyntaxKey__T = (function() {
  return this.ramlSyntaxKey$3
});
$c_Lamf_plugins_domain_shapes_models_FileShape.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_shapes_models_FileShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_shapes_models_FileShape.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_plugins_domain_shapes_models_FileShape.prototype.linkCopy__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_FileShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_FileShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_shapes_models_FileShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_shapes_models_FileShape.prototype.meta__Lamf_plugins_domain_shapes_metamodel_AnyShapeModel = (function() {
  return this.meta$3
});
$c_Lamf_plugins_domain_shapes_models_FileShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_shapes_models_FileShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  $c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  this.meta$3 = $m_Lamf_plugins_domain_shapes_metamodel_FileShapeModel$();
  this.ramlSyntaxKey$3 = "fileShape";
  return this
});
function $as_Lamf_plugins_domain_shapes_models_FileShape(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_models_FileShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.models.FileShape"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_models_FileShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_models_FileShape)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_models_FileShape(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_models_FileShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.models.FileShape;", depth))
}
var $d_Lamf_plugins_domain_shapes_models_FileShape = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_FileShape: 0
}, false, "amf.plugins.domain.shapes.models.FileShape", {
  Lamf_plugins_domain_shapes_models_FileShape: 1,
  Lamf_plugins_domain_shapes_models_AnyShape: 1,
  Lamf_core_model_domain_Shape: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelper: 1,
  Lamf_plugins_domain_webapi_unsafe_JsonSchemaSecrets: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelpers: 1,
  Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer: 1,
  Lamf_core_model_domain_ExternalSourceElement: 1,
  Lamf_plugins_domain_shapes_models_InheritanceChain: 1,
  Lamf_plugins_domain_webapi_models_DocumentedElement: 1,
  Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement: 1,
  Lamf_plugins_domain_shapes_models_CommonShapeFields: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_FileShape.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_FileShape;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_MatrixShape() {
  $c_Lamf_plugins_domain_shapes_models_DataArrangementShape.call(this);
  this.meta$4 = null
}
$c_Lamf_plugins_domain_shapes_models_MatrixShape.prototype = new $h_Lamf_plugins_domain_shapes_models_DataArrangementShape();
$c_Lamf_plugins_domain_shapes_models_MatrixShape.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_MatrixShape;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_MatrixShape() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_MatrixShape.prototype = $c_Lamf_plugins_domain_shapes_models_MatrixShape.prototype;
$c_Lamf_plugins_domain_shapes_models_MatrixShape.prototype.toArrayShape__Lamf_plugins_domain_shapes_models_ArrayShape = (function() {
  var array = new $c_Lamf_plugins_domain_shapes_models_ArrayShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(this.fields$2, this.annotations$2);
  var x1 = $m_s_Option$().apply__O__s_Option(this.id$1);
  if ((x1 instanceof $c_s_Some)) {
    var x2 = $as_s_Some(x1);
    var effectiveId = $as_T(x2.value$2);
    if ((effectiveId !== null)) {
      var res = $as_Lamf_plugins_domain_shapes_models_ArrayShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(array, effectiveId));
      return res
    }
  };
  var x = $m_s_None$();
  if ((x === x1)) {
    return array
  };
  throw new $c_s_MatchError().init___O(x1)
});
$c_Lamf_plugins_domain_shapes_models_MatrixShape.prototype.productPrefix__T = (function() {
  return "MatrixShape"
});
$c_Lamf_plugins_domain_shapes_models_MatrixShape.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_shapes_models_MatrixShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_shapes_models_MatrixShape)) {
    var MatrixShape$1 = $as_Lamf_plugins_domain_shapes_models_MatrixShape(x$1);
    var x = this.fields$2;
    var x$2 = MatrixShape$1.fields$2;
    if ((x === x$2)) {
      var x$3 = this.annotations$2;
      var x$4 = MatrixShape$1.annotations$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_models_MatrixShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$2;
      break
    }
    case 1: {
      return this.annotations$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_shapes_models_MatrixShape.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_MatrixShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_MatrixShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_shapes_models_MatrixShape.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return this.meta$4
});
$c_Lamf_plugins_domain_shapes_models_MatrixShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_shapes_models_MatrixShape.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_plugins_domain_shapes_models_MatrixShape.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_shapes_models_MatrixShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_shapes_models_MatrixShape.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_plugins_domain_shapes_models_MatrixShape.prototype.linkCopy__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_MatrixShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_MatrixShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_shapes_models_MatrixShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_shapes_models_MatrixShape.prototype.meta__Lamf_plugins_domain_shapes_metamodel_AnyShapeModel = (function() {
  return this.meta$4
});
$c_Lamf_plugins_domain_shapes_models_MatrixShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_shapes_models_MatrixShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  $c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  this.meta$4 = $m_Lamf_plugins_domain_shapes_metamodel_MatrixShapeModel$();
  return this
});
function $as_Lamf_plugins_domain_shapes_models_MatrixShape(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_models_MatrixShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.models.MatrixShape"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_models_MatrixShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_models_MatrixShape)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_models_MatrixShape(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_models_MatrixShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.models.MatrixShape;", depth))
}
var $d_Lamf_plugins_domain_shapes_models_MatrixShape = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_MatrixShape: 0
}, false, "amf.plugins.domain.shapes.models.MatrixShape", {
  Lamf_plugins_domain_shapes_models_MatrixShape: 1,
  Lamf_plugins_domain_shapes_models_DataArrangementShape: 1,
  Lamf_plugins_domain_shapes_models_AnyShape: 1,
  Lamf_core_model_domain_Shape: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelper: 1,
  Lamf_plugins_domain_webapi_unsafe_JsonSchemaSecrets: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelpers: 1,
  Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer: 1,
  Lamf_core_model_domain_ExternalSourceElement: 1,
  Lamf_plugins_domain_shapes_models_InheritanceChain: 1,
  Lamf_plugins_domain_webapi_models_DocumentedElement: 1,
  Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_MatrixShape.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_MatrixShape;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_ScalarShape() {
  $c_Lamf_plugins_domain_shapes_models_AnyShape.call(this);
  this.meta$3 = null
}
$c_Lamf_plugins_domain_shapes_models_ScalarShape.prototype = new $h_Lamf_plugins_domain_shapes_models_AnyShape();
$c_Lamf_plugins_domain_shapes_models_ScalarShape.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_ScalarShape;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_ScalarShape() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_ScalarShape.prototype = $c_Lamf_plugins_domain_shapes_models_ScalarShape.prototype;
$c_Lamf_plugins_domain_shapes_models_ScalarShape.prototype.productPrefix__T = (function() {
  return "ScalarShape"
});
$c_Lamf_plugins_domain_shapes_models_ScalarShape.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_shapes_models_ScalarShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape)) {
    var ScalarShape$1 = $as_Lamf_plugins_domain_shapes_models_ScalarShape(x$1);
    var x = this.fields$2;
    var x$2 = ScalarShape$1.fields$2;
    if ((x === x$2)) {
      var x$3 = this.annotations$2;
      var x$4 = ScalarShape$1.annotations$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_models_ScalarShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$2;
      break
    }
    case 1: {
      return this.annotations$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_shapes_models_ScalarShape.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_ScalarShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_shapes_models_ScalarShape.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return this.meta$3
});
$c_Lamf_plugins_domain_shapes_models_ScalarShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_shapes_models_ScalarShape.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_plugins_domain_shapes_models_ScalarShape.prototype.componentId__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1)).option$1;
  var str = $as_T((this$1.isEmpty__Z() ? "default-scalar" : this$1.get__O()));
  var this$3 = new $c_Lamf_core_utils_package$AmfStrings().init___T(str);
  var this$4 = this$3.platform$1;
  var url = this$3.str$1;
  return ("/scalar/" + $f_Lamf_core_remote_JsPlatform__encodeURIComponent__T__T(this$4, url))
});
$c_Lamf_plugins_domain_shapes_models_ScalarShape.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_shapes_models_ScalarShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_shapes_models_ScalarShape.prototype.ramlSyntaxKey__T = (function() {
  var this$1 = $as_Lamf_core_model_StrField(this.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$().DataType$1)).option$1;
  var thiz = $as_T((this$1.isEmpty__Z() ? "#shape" : this$1.get__O()));
  var xs = $m_sjsr_RuntimeString$().split__T__T__I__AT(thiz, "#", 0);
  var this$4 = new $c_scm_ArrayOps$ofRef().init___AO(xs);
  var x1 = $as_T($f_sc_IndexedSeqOptimized__last__O(this$4));
  return (((x1 === "integer") || ((x1 === "float") || ((x1 === "double") || ((x1 === "long") || (x1 === "number"))))) ? "numberScalarShape" : ((x1 === "string") ? "stringScalarShape" : ((x1 === "dateTime") ? "dateScalarShape" : "shape")))
});
$c_Lamf_plugins_domain_shapes_models_ScalarShape.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_plugins_domain_shapes_models_ScalarShape.prototype.linkCopy__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_ScalarShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_ScalarShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_shapes_models_ScalarShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_shapes_models_ScalarShape.prototype.meta__Lamf_plugins_domain_shapes_metamodel_AnyShapeModel = (function() {
  return this.meta$3
});
$c_Lamf_plugins_domain_shapes_models_ScalarShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_shapes_models_ScalarShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  $c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  this.meta$3 = $m_Lamf_plugins_domain_shapes_metamodel_ScalarShapeModel$();
  return this
});
function $as_Lamf_plugins_domain_shapes_models_ScalarShape(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_models_ScalarShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.models.ScalarShape"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_models_ScalarShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_models_ScalarShape)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_models_ScalarShape(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_models_ScalarShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.models.ScalarShape;", depth))
}
var $d_Lamf_plugins_domain_shapes_models_ScalarShape = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_ScalarShape: 0
}, false, "amf.plugins.domain.shapes.models.ScalarShape", {
  Lamf_plugins_domain_shapes_models_ScalarShape: 1,
  Lamf_plugins_domain_shapes_models_AnyShape: 1,
  Lamf_core_model_domain_Shape: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelper: 1,
  Lamf_plugins_domain_webapi_unsafe_JsonSchemaSecrets: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelpers: 1,
  Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer: 1,
  Lamf_core_model_domain_ExternalSourceElement: 1,
  Lamf_plugins_domain_shapes_models_InheritanceChain: 1,
  Lamf_plugins_domain_webapi_models_DocumentedElement: 1,
  Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement: 1,
  Lamf_plugins_domain_shapes_models_CommonShapeFields: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_ScalarShape.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_ScalarShape;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_TupleShape() {
  $c_Lamf_plugins_domain_shapes_models_DataArrangementShape.call(this);
  this.meta$4 = null
}
$c_Lamf_plugins_domain_shapes_models_TupleShape.prototype = new $h_Lamf_plugins_domain_shapes_models_DataArrangementShape();
$c_Lamf_plugins_domain_shapes_models_TupleShape.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_TupleShape;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_TupleShape() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_TupleShape.prototype = $c_Lamf_plugins_domain_shapes_models_TupleShape.prototype;
$c_Lamf_plugins_domain_shapes_models_TupleShape.prototype.productPrefix__T = (function() {
  return "TupleShape"
});
$c_Lamf_plugins_domain_shapes_models_TupleShape.prototype.productArity__I = (function() {
  return 2
});
$c_Lamf_plugins_domain_shapes_models_TupleShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_shapes_models_TupleShape)) {
    var TupleShape$1 = $as_Lamf_plugins_domain_shapes_models_TupleShape(x$1);
    var x = this.fields$2;
    var x$2 = TupleShape$1.fields$2;
    if ((x === x$2)) {
      var x$3 = this.annotations$2;
      var x$4 = TupleShape$1.annotations$2;
      return (x$3 === x$4)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_models_TupleShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$2;
      break
    }
    case 1: {
      return this.annotations$2;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_shapes_models_TupleShape.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_TupleShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_TupleShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_shapes_models_TupleShape.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return this.meta$4
});
$c_Lamf_plugins_domain_shapes_models_TupleShape.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_plugins_domain_shapes_models_TupleShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_shapes_models_TupleShape.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_shapes_models_TupleShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(fields, annotations)
    })
  })(this))
});
$c_Lamf_plugins_domain_shapes_models_TupleShape.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_plugins_domain_shapes_models_TupleShape.prototype.linkCopy__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  $m_Lamf_core_parser_Annotations$();
  var annotations = new $c_Lamf_core_parser_Annotations().init___();
  var this$4 = new $c_Lamf_plugins_domain_shapes_models_TupleShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations(new $c_Lamf_core_parser_Fields().init___(), annotations);
  var value = this.id$1;
  return $as_Lamf_plugins_domain_shapes_models_TupleShape($f_Lamf_core_model_domain_AmfObject__withId__T__Lamf_core_model_domain_AmfObject(this$4, value))
});
$c_Lamf_plugins_domain_shapes_models_TupleShape.prototype.hashCode__I = (function() {
  var this$2 = $m_s_util_hashing_MurmurHash3$();
  return this$2.productHash__s_Product__I__I(this, (-889275714))
});
$c_Lamf_plugins_domain_shapes_models_TupleShape.prototype.meta__Lamf_plugins_domain_shapes_metamodel_AnyShapeModel = (function() {
  return this.meta$4
});
$c_Lamf_plugins_domain_shapes_models_TupleShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_shapes_models_TupleShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations = (function(fields, annotations) {
  $c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  this.meta$4 = $m_Lamf_plugins_domain_shapes_metamodel_TupleShapeModel$();
  return this
});
function $as_Lamf_plugins_domain_shapes_models_TupleShape(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_models_TupleShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.models.TupleShape"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_models_TupleShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_models_TupleShape)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_models_TupleShape(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_models_TupleShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.models.TupleShape;", depth))
}
var $d_Lamf_plugins_domain_shapes_models_TupleShape = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_TupleShape: 0
}, false, "amf.plugins.domain.shapes.models.TupleShape", {
  Lamf_plugins_domain_shapes_models_TupleShape: 1,
  Lamf_plugins_domain_shapes_models_DataArrangementShape: 1,
  Lamf_plugins_domain_shapes_models_AnyShape: 1,
  Lamf_core_model_domain_Shape: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelper: 1,
  Lamf_plugins_domain_webapi_unsafe_JsonSchemaSecrets: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelpers: 1,
  Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer: 1,
  Lamf_core_model_domain_ExternalSourceElement: 1,
  Lamf_plugins_domain_shapes_models_InheritanceChain: 1,
  Lamf_plugins_domain_webapi_models_DocumentedElement: 1,
  Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_TupleShape.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_TupleShape;
/** @constructor */
function $c_Lamf_plugins_domain_shapes_models_UnresolvedShape() {
  $c_Lamf_plugins_domain_shapes_models_AnyShape.call(this);
  this.reference$3 = null;
  this.fatherExtensionParser$3 = null;
  this.updateFatherLink$3 = null;
  this.shouldLink$3 = false;
  this.meta$3 = null;
  this.ctx$3 = null
}
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype = new $h_Lamf_plugins_domain_shapes_models_AnyShape();
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.constructor = $c_Lamf_plugins_domain_shapes_models_UnresolvedShape;
/** @constructor */
function $h_Lamf_plugins_domain_shapes_models_UnresolvedShape() {
  /*<skip>*/
}
$h_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype = $c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype;
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.productPrefix__T = (function() {
  return "UnresolvedShape"
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.productArity__I = (function() {
  return 6
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.afterResolve__s_Option__T__V = (function(fatherSyntaxKey, resolvedKey) {
  var this$1 = this.fatherExtensionParser$3;
  if ((!this$1.isEmpty__Z())) {
    var arg1 = this$1.get__O();
    var parser = $as_F1(arg1);
    $as_Lamf_plugins_document_webapi_parser_spec_common_ShapeExtensionParser(parser.apply__O__O(fatherSyntaxKey)).parse__V()
  };
  var this$2 = this.updateFatherLink$3;
  if ((!this$2.isEmpty__Z())) {
    var arg1$1 = this$2.get__O();
    var f = $as_F1(arg1$1);
    f.apply__O__O(resolvedKey)
  }
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.equals__O__Z = (function(x$1) {
  if ((this === x$1)) {
    return true
  } else if ((x$1 instanceof $c_Lamf_plugins_domain_shapes_models_UnresolvedShape)) {
    var UnresolvedShape$1 = $as_Lamf_plugins_domain_shapes_models_UnresolvedShape(x$1);
    var x = this.fields$2;
    var x$2 = UnresolvedShape$1.fields$2;
    if ((x === x$2)) {
      var x$3 = this.annotations$2;
      var x$4 = UnresolvedShape$1.annotations$2;
      var jsx$3 = (x$3 === x$4)
    } else {
      var jsx$3 = false
    };
    if ((jsx$3 && (this.reference$3 === UnresolvedShape$1.reference$3))) {
      var x$5 = this.fatherExtensionParser$3;
      var x$6 = UnresolvedShape$1.fatherExtensionParser$3;
      var jsx$2 = ((x$5 === null) ? (x$6 === null) : x$5.equals__O__Z(x$6))
    } else {
      var jsx$2 = false
    };
    if (jsx$2) {
      var x$7 = this.updateFatherLink$3;
      var x$8 = UnresolvedShape$1.updateFatherLink$3;
      var jsx$1 = ((x$7 === null) ? (x$8 === null) : x$7.equals__O__Z(x$8))
    } else {
      var jsx$1 = false
    };
    if (jsx$1) {
      return (this.shouldLink$3 === UnresolvedShape$1.shouldLink$3)
    } else {
      return false
    }
  } else {
    return false
  }
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.fields$2;
      break
    }
    case 1: {
      return this.annotations$2;
      break
    }
    case 2: {
      return this.reference$3;
      break
    }
    case 3: {
      return this.fatherExtensionParser$3;
      break
    }
    case 4: {
      return this.updateFatherLink$3;
      break
    }
    case 5: {
      return this.shouldLink$3;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.linkCopy__Lamf_core_model_domain_Linkable = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.meta__Lamf_core_metamodel_Obj = (function() {
  return this.meta$3
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.effectiveLinkTarget$default$1__sc_Seq = (function() {
  return $as_sc_Seq($m_sc_Seq$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$()))
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.annotations__Lamf_core_parser_Annotations = (function() {
  return this.annotations$2
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.toString__T = (function() {
  return $m_sr_ScalaRunTime$().$$undtoString__s_Product__T(this)
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.shouldLink__Z = (function() {
  return this.shouldLink$3
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.componentId__T = (function() {
  return "/unresolved"
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.link__T__Lamf_core_parser_Annotations__O = (function(label, annotations) {
  return this
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.ramlSyntaxKey__T = (function() {
  return "unresolvedShape"
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.classConstructor__F2 = (function() {
  return new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(fields$2, annotations$2) {
      var fields = $as_Lamf_core_parser_Fields(fields$2);
      var annotations = $as_Lamf_core_parser_Annotations(annotations$2);
      return new $c_Lamf_plugins_domain_shapes_models_UnresolvedShape().init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations__T__s_Option__s_Option__Z(fields, annotations, $this.reference$3, $this.fatherExtensionParser$3, $m_s_None$(), true)
    })
  })(this))
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.fields__Lamf_core_parser_Fields = (function() {
  return this.fields$2
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.linkCopy__Lamf_plugins_domain_shapes_models_AnyShape = (function() {
  return this
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations__T__s_Option__s_Option__Z = (function(fields, annotations, reference, fatherExtensionParser, updateFatherLink, shouldLink) {
  this.reference$3 = reference;
  this.fatherExtensionParser$3 = fatherExtensionParser;
  this.updateFatherLink$3 = updateFatherLink;
  this.shouldLink$3 = shouldLink;
  $c_Lamf_plugins_domain_shapes_models_AnyShape.prototype.init___Lamf_core_parser_Fields__Lamf_core_parser_Annotations.call(this, fields, annotations);
  this.ctx$3 = $m_s_None$();
  this.meta$3 = new $c_Lamf_plugins_domain_shapes_models_UnresolvedShape$$anon$1().init___Lamf_plugins_domain_shapes_models_UnresolvedShape(this);
  return this
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.effectiveLinkTarget__sc_Seq__Lamf_core_model_domain_DomainElement = (function(links) {
  return this
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.hashCode__I = (function() {
  var acc = (-889275714);
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.fields$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.annotations$2));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.reference$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.fatherExtensionParser$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, $m_sr_Statics$().anyHash__O__I(this.updateFatherLink$3));
  acc = $m_sr_Statics$().mix__I__I__I(acc, (this.shouldLink$3 ? 1231 : 1237));
  return $m_sr_Statics$().finalizeHash__I__I__I(acc, 6)
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.meta__Lamf_plugins_domain_shapes_metamodel_AnyShapeModel = (function() {
  return this.meta$3
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.resolve__Lamf_core_model_domain_Shape__Lamf_core_model_domain_Shape = (function(target) {
  var qual$1 = $as_Lamf_core_model_domain_Shape(target.link__T__Lamf_core_parser_Annotations__O(this.reference$3, this.annotations$2));
  var this$1 = $as_Lamf_core_model_StrField(this.fields$2.field__Lamf_core_metamodel_Field__O($m_Lamf_core_metamodel_domain_ShapeModel$().Name$1));
  var this$2 = this$1.option$1;
  var x$1 = $as_T((this$2.isEmpty__Z() ? null : this$2.get__O()));
  $m_Lamf_core_parser_Annotations$();
  var x$2 = new $c_Lamf_core_parser_Annotations().init___();
  return $as_Lamf_core_model_domain_Shape($f_Lamf_core_model_domain_NamedDomainElement__withName__T__Lamf_core_parser_Annotations__Lamf_core_model_domain_NamedDomainElement(qual$1, x$1, x$2))
});
function $as_Lamf_plugins_domain_shapes_models_UnresolvedShape(obj) {
  return (((obj instanceof $c_Lamf_plugins_domain_shapes_models_UnresolvedShape) || (obj === null)) ? obj : $throwClassCastException(obj, "amf.plugins.domain.shapes.models.UnresolvedShape"))
}
function $isArrayOf_Lamf_plugins_domain_shapes_models_UnresolvedShape(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.Lamf_plugins_domain_shapes_models_UnresolvedShape)))
}
function $asArrayOf_Lamf_plugins_domain_shapes_models_UnresolvedShape(obj, depth) {
  return (($isArrayOf_Lamf_plugins_domain_shapes_models_UnresolvedShape(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lamf.plugins.domain.shapes.models.UnresolvedShape;", depth))
}
var $d_Lamf_plugins_domain_shapes_models_UnresolvedShape = new $TypeData().initClass({
  Lamf_plugins_domain_shapes_models_UnresolvedShape: 0
}, false, "amf.plugins.domain.shapes.models.UnresolvedShape", {
  Lamf_plugins_domain_shapes_models_UnresolvedShape: 1,
  Lamf_plugins_domain_shapes_models_AnyShape: 1,
  Lamf_core_model_domain_Shape: 1,
  O: 1,
  Lamf_core_model_domain_DomainElement: 1,
  Lamf_core_model_domain_AmfObject: 1,
  Lamf_core_model_domain_AmfElement: 1,
  Lamf_core_model_domain_Linkable: 1,
  Lamf_core_model_domain_NamedDomainElement: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelper: 1,
  Lamf_plugins_domain_webapi_unsafe_JsonSchemaSecrets: 1,
  Lamf_plugins_domain_shapes_models_ShapeHelpers: 1,
  Lamf_plugins_document_webapi_parser_spec_common_JsonSchemaSerializer: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_plugins_document_webapi_parser_spec_common_RamlDatatypeSerializer: 1,
  Lamf_core_model_domain_ExternalSourceElement: 1,
  Lamf_plugins_domain_shapes_models_InheritanceChain: 1,
  Lamf_plugins_domain_webapi_models_DocumentedElement: 1,
  Lamf_plugins_domain_shapes_models_ExemplifiedDomainElement: 1,
  Lamf_core_parser_UnresolvedReference: 1,
  s_Product: 1,
  s_Equals: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_plugins_domain_shapes_models_UnresolvedShape.prototype.$classData = $d_Lamf_plugins_domain_shapes_models_UnresolvedShape;
function $f_sc_IterableViewLike$Appended__iterator__sc_Iterator($thiz) {
  return $thiz.scala$collection$IterableViewLike$Appended$$$outer__sc_IterableViewLike().iterator__sc_Iterator().$$plus$plus__F0__sc_Iterator(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
    return (function() {
      return $this.rest__sc_GenTraversable()
    })
  })($thiz)))
}
function $f_sc_IterableViewLike$DroppedWhile__iterator__sc_Iterator($thiz) {
  var this$1 = $thiz.scala$collection$IterableViewLike$DroppedWhile$$$outer__sc_IterableViewLike().iterator__sc_Iterator();
  var p = $thiz.pred__F1();
  return new $c_sc_Iterator$$anon$17().init___sc_Iterator__F1(this$1, p)
}
function $f_sc_IterableViewLike$Filtered__iterator__sc_Iterator($thiz) {
  var this$1 = $thiz.scala$collection$IterableViewLike$Filtered$$$outer__sc_IterableViewLike().iterator__sc_Iterator();
  var p = $thiz.pred__F1();
  return new $c_sc_Iterator$$anon$12().init___sc_Iterator__F1(this$1, p)
}
function $f_sc_IterableViewLike$FlatMapped__iterator__sc_Iterator($thiz) {
  var this$1 = $thiz.scala$collection$IterableViewLike$FlatMapped$$$outer__sc_IterableViewLike().iterator__sc_Iterator();
  var f = $thiz.mapping__F1();
  return new $c_sc_Iterator$$anon$11().init___sc_Iterator__F1(this$1, f)
}
function $f_sc_IterableViewLike$Mapped__iterator__sc_Iterator($thiz) {
  var this$1 = $thiz.scala$collection$IterableViewLike$Mapped$$$outer__sc_IterableViewLike().iterator__sc_Iterator();
  var f = $thiz.mapping__F1();
  return new $c_sc_Iterator$$anon$10().init___sc_Iterator__F1(this$1, f)
}
function $f_sc_IterableViewLike$Prepended__iterator__sc_Iterator($thiz) {
  var this$1 = $thiz.fst__sc_GenTraversable();
  return this$1.iterator__sc_Iterator().$$plus$plus__F0__sc_Iterator(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
    return (function() {
      return $this.scala$collection$IterableViewLike$Prepended$$$outer__sc_IterableViewLike()
    })
  })($thiz)))
}
function $f_sc_IterableViewLike$TakenWhile__iterator__sc_Iterator($thiz) {
  var this$1 = $thiz.scala$collection$IterableViewLike$TakenWhile$$$outer__sc_IterableViewLike().iterator__sc_Iterator();
  var p = $thiz.pred__F1();
  return new $c_sc_Iterator$$anon$15().init___sc_Iterator__F1(this$1, p)
}
/** @constructor */
function $c_sc_AbstractSeq() {
  $c_sc_AbstractIterable.call(this)
}
$c_sc_AbstractSeq.prototype = new $h_sc_AbstractIterable();
$c_sc_AbstractSeq.prototype.constructor = $c_sc_AbstractSeq;
/** @constructor */
function $h_sc_AbstractSeq() {
  /*<skip>*/
}
$h_sc_AbstractSeq.prototype = $c_sc_AbstractSeq.prototype;
$c_sc_AbstractSeq.prototype.indexOf__O__I__I = (function(elem, from) {
  return $f_sc_GenSeqLike__indexOf__O__I__I(this, elem, from)
});
$c_sc_AbstractSeq.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_SeqLike__lengthCompare__I__I(this, len)
});
$c_sc_AbstractSeq.prototype.isEmpty__Z = (function() {
  return $f_sc_SeqLike__isEmpty__Z(this)
});
$c_sc_AbstractSeq.prototype.runWith__F1__F1 = (function(action) {
  return $f_s_PartialFunction__runWith__F1__F1(this, action)
});
$c_sc_AbstractSeq.prototype.equals__O__Z = (function(that) {
  return $f_sc_GenSeqLike__equals__O__Z(this, that)
});
$c_sc_AbstractSeq.prototype.$$colon$plus__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqLike__$$colon$plus__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_sc_AbstractSeq.prototype.sorted__s_math_Ordering__O = (function(ord) {
  return $f_sc_SeqLike__sorted__s_math_Ordering__O(this, ord)
});
$c_sc_AbstractSeq.prototype.toString__T = (function() {
  return $f_sc_TraversableLike__toString__T(this)
});
$c_sc_AbstractSeq.prototype.union__sc_GenSeq__scg_CanBuildFrom__O = (function(that, bf) {
  return this.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(that, bf)
});
$c_sc_AbstractSeq.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_SeqLike__indexWhere__F1__I__I(this, p, from)
});
$c_sc_AbstractSeq.prototype.intersect__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__intersect__sc_GenSeq__O(this, that)
});
$c_sc_AbstractSeq.prototype.reverse__O = (function() {
  return $f_sc_SeqLike__reverse__O(this)
});
$c_sc_AbstractSeq.prototype.size__I = (function() {
  return this.length__I()
});
$c_sc_AbstractSeq.prototype.$$plus$colon__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqLike__$$plus$colon__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_sc_AbstractSeq.prototype.distinct__O = (function() {
  return $f_sc_SeqLike__distinct__O(this)
});
$c_sc_AbstractSeq.prototype.apply$mcZI$sp__I__Z = (function(v1) {
  return $uZ(this.apply__O__O(v1))
});
$c_sc_AbstractSeq.prototype.diff__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqLike__diff__sc_GenSeq__O(this, that)
});
$c_sc_AbstractSeq.prototype.view__sc_SeqView = (function() {
  return new $c_sc_SeqLike$$anon$2().init___sc_SeqLike(this)
});
$c_sc_AbstractSeq.prototype.contains__O__Z = (function(elem) {
  return $f_sc_SeqLike__contains__O__Z(this, elem)
});
$c_sc_AbstractSeq.prototype.thisCollection__sc_Seq = (function() {
  return this
});
$c_sc_AbstractSeq.prototype.sortBy__F1__s_math_Ordering__O = (function(f, ord) {
  return $f_sc_SeqLike__sortBy__F1__s_math_Ordering__O(this, f, ord)
});
$c_sc_AbstractSeq.prototype.toSeq__sc_Seq = (function() {
  return this.thisCollection__sc_Seq()
});
$c_sc_AbstractSeq.prototype.indexOf__O__I = (function(elem) {
  return this.indexOf__O__I__I(elem, 0)
});
$c_sc_AbstractSeq.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return $f_s_PartialFunction__applyOrElse__O__F1__O(this, x, $default)
});
$c_sc_AbstractSeq.prototype.hashCode__I = (function() {
  return $m_s_util_hashing_MurmurHash3$().seqHash__sc_Seq__I(this.seq__sc_Seq())
});
$c_sc_AbstractSeq.prototype.sortWith__F2__O = (function(lt) {
  return $f_sc_SeqLike__sortWith__F2__O(this, lt)
});
function $is_sc_SortedSet(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_SortedSet)))
}
function $as_sc_SortedSet(obj) {
  return (($is_sc_SortedSet(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.SortedSet"))
}
function $isArrayOf_sc_SortedSet(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_SortedSet)))
}
function $asArrayOf_sc_SortedSet(obj, depth) {
  return (($isArrayOf_sc_SortedSet(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.SortedSet;", depth))
}
function $is_sci_Seq(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sci_Seq)))
}
function $as_sci_Seq(obj) {
  return (($is_sci_Seq(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.Seq"))
}
function $isArrayOf_sci_Seq(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_Seq)))
}
function $asArrayOf_sci_Seq(obj, depth) {
  return (($isArrayOf_sci_Seq(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.Seq;", depth))
}
/** @constructor */
function $c_Lamf_client_convert_CoreClientConverters$() {
  $c_O.call(this);
  this.StringMatcher$module$1 = null;
  this.BooleanMatcher$module$1 = null;
  this.IntMatcher$module$1 = null;
  this.DoubleMatcher$module$1 = null;
  this.FloatMatcher$module$1 = null;
  this.AnyMatcher$module$1 = null;
  this.UnitMatcher$module$1 = null;
  this.ProfileNameMatcher$module$1 = null;
  this.VendorMatcher$module$1 = null;
  this.ContentMatcher$module$1 = null;
  this.ReferenceResolverMatcher$module$1 = null;
  this.CachedReferenceMatcher$module$1 = null;
  this.PayloadFragmentMatcher$module$1 = null;
  this.ValidationShapeSetMatcher$module$1 = null;
  this.ValidationCandidateMatcher$module$1 = null;
  this.GraphDomainConverter$module$1 = null;
  this.ResourceLoaderMatcher$module$1 = null;
  this.BaseUnitMatcher$module$1 = null;
  this.DomainElementMatcher$module$1 = null;
  this.ValidationReportMatcher$module$1 = null;
  this.ValidationResultMatcher$module$1 = null;
  this.VariableValueMatcher$module$1 = null;
  this.AbstractDeclarationMatcher$module$1 = null;
  this.ParameterizedDeclarationMatcher$module$1 = null;
  this.DomainExtensionMatcher$module$1 = null;
  this.ObjectNodeMatcher$module$1 = null;
  this.ScalarNodeMatcher$module$1 = null;
  this.ArrayNodeMatcher$module$1 = null;
  this.DataNodeMatcher$module$1 = null;
  this.ShapeExtensionMatcher$module$1 = null;
  this.PropertyShapeMatcher$module$1 = null;
  this.ShapeMatcher$module$1 = null;
  this.CustomDomainPropertyMatcher$module$1 = null;
  this.StrFieldMatcher$module$1 = null;
  this.IntFieldMatcher$module$1 = null;
  this.BoolFieldMatcher$module$1 = null;
  this.DoubleFieldMatcher$module$1 = null;
  this.FloatFieldMatcher$module$1 = null;
  this.AnyFieldMatcher$module$1 = null;
  this.AnnotationsFieldMatcher$module$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_convert_CoreClientConverters$.prototype = new $h_O();
$c_Lamf_client_convert_CoreClientConverters$.prototype.constructor = $c_Lamf_client_convert_CoreClientConverters$;
/** @constructor */
function $h_Lamf_client_convert_CoreClientConverters$() {
  /*<skip>*/
}
$h_Lamf_client_convert_CoreClientConverters$.prototype = $c_Lamf_client_convert_CoreClientConverters$.prototype;
$c_Lamf_client_convert_CoreClientConverters$.prototype.AnnotationsFieldMatcher__Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().AnnotationsFieldMatcher$module$1 === null)) {
    this.AnnotationsFieldMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().AnnotationsFieldMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ValidationCandidateMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ValidationCandidateMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().ValidationCandidateMatcher$module$1 = new $c_Lamf_client_convert_ValidationCandidateConverter$ValidationCandidateMatcher$().init___Lamf_client_convert_ValidationCandidateConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.AbstractDeclarationMatcher__Lamf_client_convert_DeclarationsConverter$AbstractDeclarationMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().AbstractDeclarationMatcher$module$1 === null)) {
    this.AbstractDeclarationMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().AbstractDeclarationMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.BooleanMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().BooleanMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().BooleanMatcher$module$1 = new $c_Lamf_client_convert_CoreBaseConverter$BooleanMatcher$().init___Lamf_client_convert_CoreBaseConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ResourceLoaderMatcher__Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ResourceLoaderMatcher$module$1 === null)) {
    this.ResourceLoaderMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().ResourceLoaderMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.init___ = (function() {
  $n_Lamf_client_convert_CoreClientConverters$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ParameterizedDeclarationMatcher__Lamf_client_convert_DeclarationsConverter$ParameterizedDeclarationMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ParameterizedDeclarationMatcher$module$1 === null)) {
    this.ParameterizedDeclarationMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().ParameterizedDeclarationMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ReferenceResolverMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ReferenceResolverMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().ReferenceResolverMatcher$module$1 = new $c_Lamf_client_convert_ReferenceResolverConverter$ReferenceResolverMatcher$().init___Lamf_client_convert_ReferenceResolverConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ObjectNodeMatcher__Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ObjectNodeMatcher$module$1 === null)) {
    this.ObjectNodeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().ObjectNodeMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ScalarNodeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ScalarNodeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().ScalarNodeMatcher$module$1 = new $c_Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$().init___Lamf_client_convert_DataNodeConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ContentMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ContentMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().ContentMatcher$module$1 = new $c_Lamf_client_convert_CoreBaseConverter$ContentMatcher$().init___Lamf_client_convert_CoreBaseConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher$module$1 === null)) {
    this.StrFieldMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.DoubleMatcher__Lamf_client_convert_CoreBaseConverter$DoubleMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().DoubleMatcher$module$1 === null)) {
    this.DoubleMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().DoubleMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.VendorMatcher__Lamf_client_convert_CoreBaseConverter$VendorMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().VendorMatcher$module$1 === null)) {
    this.VendorMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().VendorMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.BoolFieldMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().BoolFieldMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().BoolFieldMatcher$module$1 = new $c_Lamf_client_convert_FieldConverter$BoolFieldMatcher$().init___Lamf_client_convert_FieldConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.AnyMatcher__Lamf_client_convert_CoreBaseConverter$AnyMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().AnyMatcher$module$1 === null)) {
    this.AnyMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().AnyMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.AnyMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().AnyMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().AnyMatcher$module$1 = new $c_Lamf_client_convert_CoreBaseConverter$AnyMatcher$().init___Lamf_client_convert_CoreBaseConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().StringMatcher$module$1 === null)) {
    this.StringMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().StringMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.DoubleMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().DoubleMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().DoubleMatcher$module$1 = new $c_Lamf_client_convert_CoreBaseConverter$DoubleMatcher$().init___Lamf_client_convert_CoreBaseConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.IntMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().IntMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().IntMatcher$module$1 = new $c_Lamf_client_convert_CoreBaseConverter$IntMatcher$().init___Lamf_client_convert_CoreBaseConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.DomainExtensionMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().DomainExtensionMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().DomainExtensionMatcher$module$1 = new $c_Lamf_client_convert_DomainExtensionConverter$DomainExtensionMatcher$().init___Lamf_client_convert_DomainExtensionConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ContentMatcher__Lamf_client_convert_CoreBaseConverter$ContentMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ContentMatcher$module$1 === null)) {
    this.ContentMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().ContentMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ProfileNameMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ProfileNameMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().ProfileNameMatcher$module$1 = new $c_Lamf_client_convert_CoreBaseConverter$ProfileNameMatcher$().init___Lamf_client_convert_CoreBaseConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.BaseUnitMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().BaseUnitMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().BaseUnitMatcher$module$1 = new $c_Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$().init___Lamf_client_convert_BaseUnitConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.DomainExtensionMatcher__Lamf_client_convert_DomainExtensionConverter$DomainExtensionMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().DomainExtensionMatcher$module$1 === null)) {
    this.DomainExtensionMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().DomainExtensionMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.IntMatcher__Lamf_client_convert_CoreBaseConverter$IntMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().IntMatcher$module$1 === null)) {
    this.IntMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().IntMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ValidationCandidateMatcher__Lamf_client_convert_ValidationCandidateConverter$ValidationCandidateMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ValidationCandidateMatcher$module$1 === null)) {
    this.ValidationCandidateMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().ValidationCandidateMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ReferenceResolverMatcher__Lamf_client_convert_ReferenceResolverConverter$ReferenceResolverMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ReferenceResolverMatcher$module$1 === null)) {
    this.ReferenceResolverMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().ReferenceResolverMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.CachedReferenceMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().CachedReferenceMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().CachedReferenceMatcher$module$1 = new $c_Lamf_client_convert_CachedReferenceConverter$CachedReferenceMatcher$().init___Lamf_client_convert_CachedReferenceConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.StringMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().StringMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().StringMatcher$module$1 = new $c_Lamf_client_convert_CoreBaseConverter$StringMatcher$().init___Lamf_client_convert_CoreBaseConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.AnnotationsFieldMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().AnnotationsFieldMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().AnnotationsFieldMatcher$module$1 = new $c_Lamf_client_convert_FieldConverter$AnnotationsFieldMatcher$().init___Lamf_client_convert_FieldConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ArrayNodeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ArrayNodeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().ArrayNodeMatcher$module$1 = new $c_Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$().init___Lamf_client_convert_DataNodeConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.PayloadFragmentMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().PayloadFragmentMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().PayloadFragmentMatcher$module$1 = new $c_Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$().init___Lamf_client_convert_PayloadFragmentConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ValidationReportMatcher$module$1 === null)) {
    this.ValidationReportMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().ValidationReportMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.VendorMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().VendorMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().VendorMatcher$module$1 = new $c_Lamf_client_convert_CoreBaseConverter$VendorMatcher$().init___Lamf_client_convert_CoreBaseConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ObjectNodeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ObjectNodeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().ObjectNodeMatcher$module$1 = new $c_Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$().init___Lamf_client_convert_DataNodeConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.UnitMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().UnitMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().UnitMatcher$module$1 = new $c_Lamf_client_convert_CoreBaseConverter$UnitMatcher$().init___Lamf_client_convert_CoreBaseConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.IntFieldMatcher__Lamf_client_convert_FieldConverter$IntFieldMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().IntFieldMatcher$module$1 === null)) {
    this.IntFieldMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().IntFieldMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.GraphDomainConverter$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().GraphDomainConverter$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().GraphDomainConverter$module$1 = new $c_Lamf_client_convert_GraphDomainConverter$GraphDomainConverter$().init___Lamf_client_convert_GraphDomainConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ProfileNameMatcher__Lamf_client_convert_CoreBaseConverter$ProfileNameMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ProfileNameMatcher$module$1 === null)) {
    this.ProfileNameMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().ProfileNameMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.StrFieldMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().StrFieldMatcher$module$1 = new $c_Lamf_client_convert_FieldConverter$StrFieldMatcher$().init___Lamf_client_convert_FieldConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().DataNodeMatcher$module$1 === null)) {
    this.DataNodeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().DataNodeMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ParameterizedDeclarationMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ParameterizedDeclarationMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().ParameterizedDeclarationMatcher$module$1 = new $c_Lamf_client_convert_DeclarationsConverter$ParameterizedDeclarationMatcher$().init___Lamf_client_convert_DeclarationsConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.CustomDomainPropertyMatcher__Lamf_client_convert_CustomDomainPropertyConverter$CustomDomainPropertyMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().CustomDomainPropertyMatcher$module$1 === null)) {
    this.CustomDomainPropertyMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().CustomDomainPropertyMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ShapeExtensionMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ShapeExtensionMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().ShapeExtensionMatcher$module$1 = new $c_Lamf_client_convert_ShapeExtensionConverter$ShapeExtensionMatcher$().init___Lamf_client_convert_ShapeExtensionConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ShapeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher$module$1 = new $c_Lamf_client_convert_ShapeConverter$ShapeMatcher$().init___Lamf_client_convert_ShapeConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.UnitMatcher__Lamf_client_convert_CoreBaseConverter$UnitMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().UnitMatcher$module$1 === null)) {
    this.UnitMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().UnitMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().BoolFieldMatcher$module$1 === null)) {
    this.BoolFieldMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().BoolFieldMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ValidationResultMatcher__Lamf_client_convert_ValidationConverter$ValidationResultMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ValidationResultMatcher$module$1 === null)) {
    this.ValidationResultMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().ValidationResultMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.BaseUnitMatcher__Lamf_client_convert_BaseUnitConverter$BaseUnitMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().BaseUnitMatcher$module$1 === null)) {
    this.BaseUnitMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().BaseUnitMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.BooleanMatcher__Lamf_client_convert_CoreBaseConverter$BooleanMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().BooleanMatcher$module$1 === null)) {
    this.BooleanMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().BooleanMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.VariableValueMatcher__Lamf_client_convert_VariableValueConverter$VariableValueMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().VariableValueMatcher$module$1 === null)) {
    this.VariableValueMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().VariableValueMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.AbstractDeclarationMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().AbstractDeclarationMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().AbstractDeclarationMatcher$module$1 = new $c_Lamf_client_convert_DeclarationsConverter$AbstractDeclarationMatcher$().init___Lamf_client_convert_DeclarationsConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ArrayNodeMatcher__Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ArrayNodeMatcher$module$1 === null)) {
    this.ArrayNodeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().ArrayNodeMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.DataNodeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().DataNodeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().DataNodeMatcher$module$1 = new $c_Lamf_client_convert_DataNodeConverter$DataNodeMatcher$().init___Lamf_client_convert_DataNodeConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ScalarNodeMatcher__Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ScalarNodeMatcher$module$1 === null)) {
    this.ScalarNodeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().ScalarNodeMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.DomainElementMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().DomainElementMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().DomainElementMatcher$module$1 = new $c_Lamf_client_convert_DomainElementConverter$DomainElementMatcher$().init___Lamf_client_convert_DomainElementConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.GraphDomainConverter__Lamf_client_convert_GraphDomainConverter$GraphDomainConverter$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().GraphDomainConverter$module$1 === null)) {
    this.GraphDomainConverter$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().GraphDomainConverter$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ValidationReportMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ValidationReportMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().ValidationReportMatcher$module$1 = new $c_Lamf_client_convert_ValidationConverter$ValidationReportMatcher$().init___Lamf_client_convert_ValidationConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.DomainElementMatcher__Lamf_client_convert_DomainElementConverter$DomainElementMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().DomainElementMatcher$module$1 === null)) {
    this.DomainElementMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().DomainElementMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.VariableValueMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().VariableValueMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().VariableValueMatcher$module$1 = new $c_Lamf_client_convert_VariableValueConverter$VariableValueMatcher$().init___Lamf_client_convert_VariableValueConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.IntFieldMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().IntFieldMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().IntFieldMatcher$module$1 = new $c_Lamf_client_convert_FieldConverter$IntFieldMatcher$().init___Lamf_client_convert_FieldConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.CustomDomainPropertyMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().CustomDomainPropertyMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().CustomDomainPropertyMatcher$module$1 = new $c_Lamf_client_convert_CustomDomainPropertyConverter$CustomDomainPropertyMatcher$().init___Lamf_client_convert_CustomDomainPropertyConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ResourceLoaderMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ResourceLoaderMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().ResourceLoaderMatcher$module$1 = new $c_Lamf_client_convert_ResourceLoaderConverter$ResourceLoaderMatcher$().init___Lamf_client_convert_ResourceLoaderConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ValidationResultMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ValidationResultMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().ValidationResultMatcher$module$1 = new $c_Lamf_client_convert_ValidationConverter$ValidationResultMatcher$().init___Lamf_client_convert_ValidationConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.PropertyShapeMatcher__Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().PropertyShapeMatcher$module$1 === null)) {
    this.PropertyShapeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().PropertyShapeMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.PropertyShapeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().PropertyShapeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_CoreClientConverters$().PropertyShapeMatcher$module$1 = new $c_Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$().init___Lamf_client_convert_PropertyShapeConverter(this)
  }
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher$module$1 === null)) {
    this.ShapeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().ShapeMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.ShapeExtensionMatcher__Lamf_client_convert_ShapeExtensionConverter$ShapeExtensionMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().ShapeExtensionMatcher$module$1 === null)) {
    this.ShapeExtensionMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().ShapeExtensionMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.PayloadFragmentMatcher__Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().PayloadFragmentMatcher$module$1 === null)) {
    this.PayloadFragmentMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().PayloadFragmentMatcher$module$1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.CachedReferenceMatcher__Lamf_client_convert_CachedReferenceConverter$CachedReferenceMatcher$ = (function() {
  if (($m_Lamf_client_convert_CoreClientConverters$().CachedReferenceMatcher$module$1 === null)) {
    this.CachedReferenceMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_CoreClientConverters$().CachedReferenceMatcher$module$1
});
var $d_Lamf_client_convert_CoreClientConverters$ = new $TypeData().initClass({
  Lamf_client_convert_CoreClientConverters$: 0
}, false, "amf.client.convert.CoreClientConverters$", {
  Lamf_client_convert_CoreClientConverters$: 1,
  O: 1,
  Lamf_client_convert_CoreBaseConverter: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_convert_CollectionConverter: 1,
  Lamf_client_convert_FutureConverter: 1,
  Lamf_client_convert_FieldConverter: 1,
  Lamf_client_convert_CustomDomainPropertyConverter: 1,
  Lamf_client_convert_ShapeConverter: 1,
  Lamf_client_convert_PropertyShapeConverter: 1,
  Lamf_client_convert_ShapeExtensionConverter: 1,
  Lamf_client_convert_DataNodeConverter: 1,
  Lamf_client_convert_DomainExtensionConverter: 1,
  Lamf_client_convert_DeclarationsConverter: 1,
  Lamf_client_convert_VariableValueConverter: 1,
  Lamf_client_convert_ValidationConverter: 1,
  Lamf_client_convert_DomainElementConverter: 1,
  Lamf_client_convert_BaseUnitConverter: 1,
  Lamf_client_convert_ResourceLoaderConverter: 1,
  Lamf_client_convert_GraphDomainConverter: 1,
  Lamf_client_convert_ValidationCandidateConverter: 1,
  Lamf_client_convert_ValidationShapeSetConverter: 1,
  Lamf_client_convert_PayloadFragmentConverter: 1,
  Lamf_client_convert_CachedReferenceConverter: 1,
  Lamf_client_convert_ReferenceResolverConverter: 1,
  Lamf_client_convert_CoreBaseClientConverter: 1
});
$c_Lamf_client_convert_CoreClientConverters$.prototype.$classData = $d_Lamf_client_convert_CoreClientConverters$;
var $n_Lamf_client_convert_CoreClientConverters$ = (void 0);
function $m_Lamf_client_convert_CoreClientConverters$() {
  if ((!$n_Lamf_client_convert_CoreClientConverters$)) {
    $n_Lamf_client_convert_CoreClientConverters$ = new $c_Lamf_client_convert_CoreClientConverters$().init___()
  };
  return $n_Lamf_client_convert_CoreClientConverters$
}
/** @constructor */
function $c_sc_AbstractMap() {
  $c_sc_AbstractIterable.call(this)
}
$c_sc_AbstractMap.prototype = new $h_sc_AbstractIterable();
$c_sc_AbstractMap.prototype.constructor = $c_sc_AbstractMap;
/** @constructor */
function $h_sc_AbstractMap() {
  /*<skip>*/
}
$h_sc_AbstractMap.prototype = $c_sc_AbstractMap.prototype;
$c_sc_AbstractMap.prototype.seq__sc_TraversableOnce = (function() {
  return this.seq__sc_Map()
});
$c_sc_AbstractMap.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_sc_AbstractMap.prototype.apply__O__O = (function(key) {
  return $f_sc_MapLike__apply__O__O(this, key)
});
$c_sc_AbstractMap.prototype.seq__sc_Iterable = (function() {
  return this.seq__sc_Map()
});
$c_sc_AbstractMap.prototype.isEmpty__Z = (function() {
  return $f_sc_MapLike__isEmpty__Z(this)
});
$c_sc_AbstractMap.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sc_AbstractMap.prototype.runWith__F1__F1 = (function(action) {
  return $f_s_PartialFunction__runWith__F1__F1(this, action)
});
$c_sc_AbstractMap.prototype.equals__O__Z = (function(that) {
  return $f_sc_GenMapLike__equals__O__Z(this, that)
});
$c_sc_AbstractMap.prototype.getOrElse__O__F0__O = (function(key, $default) {
  return $f_sc_MapLike__getOrElse__O__F0__O(this, key, $default)
});
$c_sc_AbstractMap.prototype.toString__T = (function() {
  return $f_sc_TraversableLike__toString__T(this)
});
$c_sc_AbstractMap.prototype.keysIterator__sc_Iterator = (function() {
  return new $c_sc_MapLike$$anon$1().init___sc_MapLike(this)
});
$c_sc_AbstractMap.prototype.empty__sc_Map = (function() {
  return $m_sci_Map$EmptyMap$()
});
$c_sc_AbstractMap.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_MapLike__toBuffer__scm_Buffer(this)
});
$c_sc_AbstractMap.prototype.seq__sc_Map = (function() {
  return this
});
$c_sc_AbstractMap.prototype.values__sc_Iterable = (function() {
  return new $c_sc_MapLike$DefaultValuesIterable().init___sc_MapLike(this)
});
$c_sc_AbstractMap.prototype.apply$mcZI$sp__I__Z = (function(v1) {
  return $uZ(this.apply__O__O(v1))
});
$c_sc_AbstractMap.prototype.valuesIterator__sc_Iterator = (function() {
  return new $c_sc_MapLike$$anon$2().init___sc_MapLike(this)
});
$c_sc_AbstractMap.prototype.$default__O__O = (function(key) {
  return $f_sc_MapLike__$default__O__O(this, key)
});
$c_sc_AbstractMap.prototype.filterNot__F1__O = (function(p) {
  return this.filterNot__F1__sc_Map(p)
});
$c_sc_AbstractMap.prototype.contains__O__Z = (function(key) {
  return $f_sc_MapLike__contains__O__Z(this, key)
});
$c_sc_AbstractMap.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_MapLike__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_sc_AbstractMap.prototype.toSeq__sc_Seq = (function() {
  return $f_sc_MapLike__toSeq__sc_Seq(this)
});
$c_sc_AbstractMap.prototype.filterNot__F1__sc_Map = (function(p) {
  return $f_sc_MapLike__filterNot__F1__sc_Map(this, p)
});
$c_sc_AbstractMap.prototype.isDefinedAt__O__Z = (function(key) {
  return this.contains__O__Z(key)
});
$c_sc_AbstractMap.prototype.keySet__sc_Set = (function() {
  return new $c_sc_MapLike$DefaultKeySet().init___sc_MapLike(this)
});
$c_sc_AbstractMap.prototype.toSeq__sc_GenSeq = (function() {
  return this.toSeq__sc_Seq()
});
$c_sc_AbstractMap.prototype.hashCode__I = (function() {
  var this$1 = $m_s_util_hashing_MurmurHash3$();
  var xs = this.seq__sc_Map();
  return this$1.unorderedHash__sc_TraversableOnce__I__I(xs, this$1.mapSeed$2)
});
$c_sc_AbstractMap.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return $f_sc_MapLike__applyOrElse__O__F1__O(this, x, $default)
});
$c_sc_AbstractMap.prototype.keys__sc_Iterable = (function() {
  return this.keySet__sc_Set()
});
$c_sc_AbstractMap.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_MapBuilder().init___sc_GenMap(this.empty__sc_Map())
});
$c_sc_AbstractMap.prototype.stringPrefix__T = (function() {
  return "Map"
});
/** @constructor */
function $c_sc_AbstractSet() {
  $c_sc_AbstractIterable.call(this)
}
$c_sc_AbstractSet.prototype = new $h_sc_AbstractIterable();
$c_sc_AbstractSet.prototype.constructor = $c_sc_AbstractSet;
/** @constructor */
function $h_sc_AbstractSet() {
  /*<skip>*/
}
$h_sc_AbstractSet.prototype = $c_sc_AbstractSet.prototype;
$c_sc_AbstractSet.prototype.seq__sc_TraversableOnce = (function() {
  return this.seq__sc_Set()
});
$c_sc_AbstractSet.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_sc_AbstractSet.prototype.apply__O__O = (function(v1) {
  return this.contains__O__Z(v1)
});
$c_sc_AbstractSet.prototype.seq__sc_Iterable = (function() {
  return this.seq__sc_Set()
});
$c_sc_AbstractSet.prototype.isEmpty__Z = (function() {
  return $f_sc_SetLike__isEmpty__Z(this)
});
$c_sc_AbstractSet.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sc_AbstractSet.prototype.equals__O__Z = (function(that) {
  return $f_sc_GenSetLike__equals__O__Z(this, that)
});
$c_sc_AbstractSet.prototype.toString__T = (function() {
  return $f_sc_TraversableLike__toString__T(this)
});
$c_sc_AbstractSet.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sc_Set$()
});
$c_sc_AbstractSet.prototype.subsetOf__sc_GenSet__Z = (function(that) {
  return this.forall__F1__Z(that)
});
$c_sc_AbstractSet.prototype.$$minus$minus__sc_GenTraversableOnce__scg_Subtractable = (function(xs) {
  return $f_scg_Subtractable__$$minus$minus__sc_GenTraversableOnce__scg_Subtractable(this, xs)
});
$c_sc_AbstractSet.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_SetLike__toBuffer__scm_Buffer(this)
});
$c_sc_AbstractSet.prototype.apply$mcZI$sp__I__Z = (function(v1) {
  return this.contains__O__Z(v1)
});
$c_sc_AbstractSet.prototype.empty__sc_Set = (function() {
  return $as_sc_Set(this.empty__sc_GenSet())
});
$c_sc_AbstractSet.prototype.seq__sc_Set = (function() {
  return this
});
$c_sc_AbstractSet.prototype.toSeq__sc_Seq = (function() {
  return $f_sc_SetLike__toSeq__sc_Seq(this)
});
$c_sc_AbstractSet.prototype.diff__sc_GenSet__sc_Set = (function(that) {
  return $as_sc_Set($f_scg_Subtractable__$$minus$minus__sc_GenTraversableOnce__scg_Subtractable(this, that))
});
$c_sc_AbstractSet.prototype.empty__sc_GenSet = (function() {
  return $as_sc_GenSet(this.companion__scg_GenericCompanion().empty__sc_GenTraversable())
});
$c_sc_AbstractSet.prototype.toSeq__sc_GenSeq = (function() {
  return $f_sc_SetLike__toSeq__sc_Seq(this)
});
$c_sc_AbstractSet.prototype.hashCode__I = (function() {
  var this$1 = $m_s_util_hashing_MurmurHash3$();
  var xs = this.seq__sc_Set();
  return this$1.unorderedHash__sc_TraversableOnce__I__I(xs, this$1.setSeed$2)
});
$c_sc_AbstractSet.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_sc_AbstractSet.prototype.intersect__sc_GenSet__O = (function(that) {
  return this.filter__F1__O(that)
});
$c_sc_AbstractSet.prototype.$$plus$plus__sc_GenTraversableOnce__sc_Set = (function(elems) {
  return $f_sc_SetLike__$$plus$plus__sc_GenTraversableOnce__sc_Set(this, elems)
});
$c_sc_AbstractSet.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_SetBuilder().init___sc_Set(this.empty__sc_Set())
});
$c_sc_AbstractSet.prototype.stringPrefix__T = (function() {
  return "Set"
});
$c_sc_AbstractSet.prototype.union__sc_GenSet__sc_Set = (function(that) {
  return this.$$plus$plus__sc_GenTraversableOnce__sc_Set(that)
});
function $f_sci_Set__toSet__sci_Set($thiz) {
  var sb = new $c_scm_SetBuilder().init___sc_Set($m_sci_Set$EmptySet$());
  $thiz.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, sb$1) {
    return (function(x$1$2) {
      return sb$1.$$plus$eq__O__scm_Builder(x$1$2)
    })
  })($thiz, sb)));
  return $as_sci_Set(sb.elems$1)
}
function $is_sci_Set(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sci_Set)))
}
function $as_sci_Set(obj) {
  return (($is_sci_Set(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.Set"))
}
function $isArrayOf_sci_Set(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_Set)))
}
function $asArrayOf_sci_Set(obj, depth) {
  return (($isArrayOf_sci_Set(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.Set;", depth))
}
function $f_sc_SeqViewLike__intersect__sc_GenSeq__sc_SeqView($thiz, that) {
  return $thiz.newForced__F0__sc_SeqViewLike$Transformed(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, that$1) {
    return (function() {
      return $as_sc_Seq($f_sc_ViewMkString__thisSeq__sc_Seq($this).intersect__sc_GenSeq__O(that$1))
    })
  })($thiz, that)))
}
function $f_sc_SeqViewLike__distinct__sc_SeqView($thiz) {
  return $thiz.newForced__F0__sc_SeqViewLike$Transformed(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
    return (function() {
      return $as_sc_Seq($f_sc_ViewMkString__thisSeq__sc_Seq($this).distinct__O())
    })
  })($thiz)))
}
function $f_sc_SeqViewLike__sortWith__F2__sc_SeqView($thiz, lt) {
  return $thiz.newForced__F0__sc_SeqViewLike$Transformed(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, lt$1) {
    return (function() {
      return $as_sc_Seq($f_sc_ViewMkString__thisSeq__sc_Seq($this).sortWith__F2__O(lt$1))
    })
  })($thiz, lt)))
}
function $f_sc_SeqViewLike__$$colon$plus__O__scg_CanBuildFrom__O($thiz, elem, bf) {
  $m_sc_Iterator$();
  var xs = new $c_sc_Iterator$$anon$3().init___O(elem);
  return $f_sc_TraversableViewLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O($thiz, xs, bf)
}
function $f_sc_SeqViewLike__sortBy__F1__s_math_Ordering__sc_SeqView($thiz, f, ord) {
  return $thiz.newForced__F0__sc_SeqViewLike$Transformed(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, f$1, ord$1) {
    return (function() {
      return $as_sc_Seq($f_sc_ViewMkString__thisSeq__sc_Seq($this).sortBy__F1__s_math_Ordering__O(f$1, ord$1))
    })
  })($thiz, f, ord)))
}
function $f_sc_SeqViewLike__union__sc_GenSeq__scg_CanBuildFrom__O($thiz, that, bf) {
  return $thiz.newForced__F0__sc_SeqViewLike$Transformed(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, that$1) {
    return (function() {
      var jsx$1 = $f_sc_ViewMkString__thisSeq__sc_Seq($this);
      var this$1 = $m_sc_Seq$();
      return $as_sc_Seq(jsx$1.union__sc_GenSeq__scg_CanBuildFrom__O(that$1, this$1.ReusableCBFInstance$2))
    })
  })($thiz, that)))
}
function $f_sc_SeqViewLike__diff__sc_GenSeq__sc_SeqView($thiz, that) {
  return $thiz.newForced__F0__sc_SeqViewLike$Transformed(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, that$1) {
    return (function() {
      return $as_sc_Seq($f_sc_ViewMkString__thisSeq__sc_Seq($this).diff__sc_GenSeq__O(that$1))
    })
  })($thiz, that)))
}
function $f_sc_SeqViewLike__$$plus$colon__O__scg_CanBuildFrom__O($thiz, elem, bf) {
  var this$1 = $m_sci_Nil$();
  return $thiz.newPrepended__sc_GenTraversable__sc_SeqViewLike$Transformed(new $c_sci_$colon$colon().init___O__sci_List(elem, this$1))
}
function $f_sc_SeqViewLike__newTaken__I__sc_SeqViewLike$Transformed($thiz, n) {
  return $thiz.newSliced__scg_SliceInterval__sc_SeqViewLike$Transformed($m_scg_SliceInterval$().apply__I__I__scg_SliceInterval(0, n))
}
function $f_sc_SeqViewLike__sorted__s_math_Ordering__sc_SeqView($thiz, ord) {
  return $thiz.newForced__F0__sc_SeqViewLike$Transformed(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, ord$1) {
    return (function() {
      return $as_sc_Seq($f_sc_ViewMkString__thisSeq__sc_Seq($this).sorted__s_math_Ordering__O(ord$1))
    })
  })($thiz, ord)))
}
function $f_sc_SeqViewLike__newDropped__I__sc_SeqViewLike$Transformed($thiz, n) {
  return $thiz.newSliced__scg_SliceInterval__sc_SeqViewLike$Transformed($m_scg_SliceInterval$().apply__I__I__scg_SliceInterval(n, 2147483647))
}
function $is_sci_Map(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sci_Map)))
}
function $as_sci_Map(obj) {
  return (($is_sci_Map(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.Map"))
}
function $isArrayOf_sci_Map(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_Map)))
}
function $asArrayOf_sci_Map(obj, depth) {
  return (($isArrayOf_sci_Map(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.Map;", depth))
}
/** @constructor */
function $c_sc_MapLike$FilteredKeys() {
  $c_sc_AbstractMap.call(this);
  this.p$4 = null;
  this.$$outer$4 = null
}
$c_sc_MapLike$FilteredKeys.prototype = new $h_sc_AbstractMap();
$c_sc_MapLike$FilteredKeys.prototype.constructor = $c_sc_MapLike$FilteredKeys;
/** @constructor */
function $h_sc_MapLike$FilteredKeys() {
  /*<skip>*/
}
$h_sc_MapLike$FilteredKeys.prototype = $c_sc_MapLike$FilteredKeys.prototype;
$c_sc_MapLike$FilteredKeys.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return this.$$minus__O__sc_Map(elem)
});
$c_sc_MapLike$FilteredKeys.prototype.$$plus__T2__sc_Map = (function(kv) {
  return $f_sc_DefaultMap__$$plus__T2__sc_Map(this, kv)
});
$c_sc_MapLike$FilteredKeys.prototype.foreach__F1__V = (function(f) {
  this.$$outer$4.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, f$1) {
    return (function(kv$2) {
      var kv = $as_T2(kv$2);
      return ($uZ($this.p$4.apply__O__O(kv.$$und1__O())) ? f$1.apply__O__O(kv) : (void 0))
    })
  })(this, f)))
});
$c_sc_MapLike$FilteredKeys.prototype.$$minus__O__sc_Map = (function(key) {
  return $f_sc_DefaultMap__$$minus__O__sc_Map(this, key)
});
$c_sc_MapLike$FilteredKeys.prototype.init___sc_MapLike__F1 = (function($$outer, p) {
  this.p$4 = p;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$4 = $$outer
  };
  return this
});
$c_sc_MapLike$FilteredKeys.prototype.iterator__sc_Iterator = (function() {
  var this$1 = this.$$outer$4.iterator__sc_Iterator();
  var p = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(kv$2) {
      var kv = $as_T2(kv$2);
      return $uZ($this.p$4.apply__O__O(kv.$$und1__O()))
    })
  })(this));
  return new $c_sc_Iterator$$anon$12().init___sc_Iterator__F1(this$1, p)
});
$c_sc_MapLike$FilteredKeys.prototype.get__O__s_Option = (function(key) {
  return ((!$uZ(this.p$4.apply__O__O(key))) ? $m_s_None$() : this.$$outer$4.get__O__s_Option(key))
});
$c_sc_MapLike$FilteredKeys.prototype.contains__O__Z = (function(key) {
  return ($uZ(this.p$4.apply__O__O(key)) && this.$$outer$4.contains__O__Z(key))
});
$c_sc_MapLike$FilteredKeys.prototype.$$plus__T2__sc_GenMap = (function(kv) {
  return this.$$plus__T2__sc_Map(kv)
});
var $d_sc_MapLike$FilteredKeys = new $TypeData().initClass({
  sc_MapLike$FilteredKeys: 0
}, false, "scala.collection.MapLike$FilteredKeys", {
  sc_MapLike$FilteredKeys: 1,
  sc_AbstractMap: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Map: 1,
  sc_GenMap: 1,
  sc_GenMapLike: 1,
  sc_MapLike: 1,
  s_PartialFunction: 1,
  F1: 1,
  scg_Subtractable: 1,
  sc_DefaultMap: 1
});
$c_sc_MapLike$FilteredKeys.prototype.$classData = $d_sc_MapLike$FilteredKeys;
/** @constructor */
function $c_sc_MapLike$MappedValues() {
  $c_sc_AbstractMap.call(this);
  this.f$4 = null;
  this.$$outer$4 = null
}
$c_sc_MapLike$MappedValues.prototype = new $h_sc_AbstractMap();
$c_sc_MapLike$MappedValues.prototype.constructor = $c_sc_MapLike$MappedValues;
/** @constructor */
function $h_sc_MapLike$MappedValues() {
  /*<skip>*/
}
$h_sc_MapLike$MappedValues.prototype = $c_sc_MapLike$MappedValues.prototype;
$c_sc_MapLike$MappedValues.prototype.foreach__F1__V = (function(g) {
  var this$1 = this.$$outer$4;
  var p = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(check$ifrefutable$1$2) {
      var check$ifrefutable$1 = $as_T2(check$ifrefutable$1$2);
      return (check$ifrefutable$1 !== null)
    })
  })(this));
  new $c_sc_TraversableLike$WithFilter().init___sc_TraversableLike__F1(this$1, p).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, g$1) {
    return (function(x$1$2) {
      var x$1 = $as_T2(x$1$2);
      if ((x$1 !== null)) {
        var k = x$1.$$und1__O();
        var v = x$1.$$und2__O();
        return g$1.apply__O__O(new $c_T2().init___O__O(k, this$2.f$4.apply__O__O(v)))
      } else {
        throw new $c_s_MatchError().init___O(x$1)
      }
    })
  })(this, g)))
});
$c_sc_MapLike$MappedValues.prototype.init___sc_MapLike__F1 = (function($$outer, f) {
  this.f$4 = f;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$4 = $$outer
  };
  return this
});
$c_sc_MapLike$MappedValues.prototype.size__I = (function() {
  return this.$$outer$4.size__I()
});
$c_sc_MapLike$MappedValues.prototype.iterator__sc_Iterator = (function() {
  var this$1 = this.$$outer$4.iterator__sc_Iterator();
  var p = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(check$ifrefutable$2$2) {
      var check$ifrefutable$2 = $as_T2(check$ifrefutable$2$2);
      return (check$ifrefutable$2 !== null)
    })
  })(this));
  var this$3 = new $c_sc_Iterator$$anon$12().init___sc_Iterator__F1(this$1, p);
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2) {
    return (function(x$2$2) {
      var x$2 = $as_T2(x$2$2);
      if ((x$2 !== null)) {
        var k = x$2.$$und1__O();
        var v = x$2.$$und2__O();
        return new $c_T2().init___O__O(k, this$2.f$4.apply__O__O(v))
      } else {
        throw new $c_s_MatchError().init___O(x$2)
      }
    })
  })(this));
  return new $c_sc_Iterator$$anon$10().init___sc_Iterator__F1(this$3, f)
});
$c_sc_MapLike$MappedValues.prototype.get__O__s_Option = (function(key) {
  var this$1 = this.$$outer$4.get__O__s_Option(key);
  var f = this.f$4;
  return (this$1.isEmpty__Z() ? $m_s_None$() : new $c_s_Some().init___O(f.apply__O__O(this$1.get__O())))
});
$c_sc_MapLike$MappedValues.prototype.contains__O__Z = (function(key) {
  return this.$$outer$4.contains__O__Z(key)
});
function $is_sc_SeqView(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sc_SeqView)))
}
function $as_sc_SeqView(obj) {
  return (($is_sc_SeqView(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.SeqView"))
}
function $isArrayOf_sc_SeqView(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sc_SeqView)))
}
function $asArrayOf_sc_SeqView(obj, depth) {
  return (($isArrayOf_sc_SeqView(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.SeqView;", depth))
}
function $f_sci_DefaultMap__$$plus__T2__sci_Map($thiz, kv) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(b, $thiz);
  var elem = new $c_T2().init___O__O(kv.$$und1__O(), kv.$$und2__O());
  b.$$plus$eq__T2__scm_MapBuilder(elem);
  return $as_sci_Map(b.elems$1)
}
function $f_sci_DefaultMap__$$minus__O__sci_Map($thiz, key) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var p = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, key$1) {
    return (function(kv$2) {
      var kv = $as_T2(kv$2);
      return (!$m_sr_BoxesRunTime$().equals__O__O__Z(kv.$$und1__O(), key$1))
    })
  })($thiz, key));
  new $c_sc_TraversableLike$WithFilter().init___sc_TraversableLike__F1($thiz, p).foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, b$1) {
    return (function(kv$3$2) {
      var kv$3 = $as_T2(kv$3$2);
      return b$1.$$plus$eq__O__scm_Builder(kv$3)
    })
  })($thiz, b)));
  return $as_sci_Map(b.elems$1)
}
function $is_sci_IndexedSeq(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.sci_IndexedSeq)))
}
function $as_sci_IndexedSeq(obj) {
  return (($is_sci_IndexedSeq(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.IndexedSeq"))
}
function $isArrayOf_sci_IndexedSeq(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_IndexedSeq)))
}
function $asArrayOf_sci_IndexedSeq(obj, depth) {
  return (($isArrayOf_sci_IndexedSeq(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.IndexedSeq;", depth))
}
/** @constructor */
function $c_sc_Map$WithDefault() {
  $c_sc_AbstractMap.call(this);
  this.underlying$4 = null;
  this.d$4 = null
}
$c_sc_Map$WithDefault.prototype = new $h_sc_AbstractMap();
$c_sc_Map$WithDefault.prototype.constructor = $c_sc_Map$WithDefault;
/** @constructor */
function $h_sc_Map$WithDefault() {
  /*<skip>*/
}
$h_sc_Map$WithDefault.prototype = $c_sc_Map$WithDefault.prototype;
$c_sc_Map$WithDefault.prototype.init___sc_Map__F1 = (function(underlying, d) {
  this.underlying$4 = underlying;
  this.d$4 = d;
  return this
});
$c_sc_Map$WithDefault.prototype.iterator__sc_Iterator = (function() {
  return this.underlying$4.iterator__sc_Iterator()
});
$c_sc_Map$WithDefault.prototype.size__I = (function() {
  return this.underlying$4.size__I()
});
$c_sc_Map$WithDefault.prototype.$default__O__O = (function(key) {
  return this.d$4.apply__O__O(key)
});
$c_sc_Map$WithDefault.prototype.get__O__s_Option = (function(key) {
  return this.underlying$4.get__O__s_Option(key)
});
/** @constructor */
function $c_sc_MapLike$DefaultKeySet() {
  $c_sc_AbstractSet.call(this);
  this.$$outer$4 = null
}
$c_sc_MapLike$DefaultKeySet.prototype = new $h_sc_AbstractSet();
$c_sc_MapLike$DefaultKeySet.prototype.constructor = $c_sc_MapLike$DefaultKeySet;
/** @constructor */
function $h_sc_MapLike$DefaultKeySet() {
  /*<skip>*/
}
$h_sc_MapLike$DefaultKeySet.prototype = $c_sc_MapLike$DefaultKeySet.prototype;
$c_sc_MapLike$DefaultKeySet.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return this.$$minus__O__sc_Set(elem)
});
$c_sc_MapLike$DefaultKeySet.prototype.foreach__F1__V = (function(f) {
  var this$1 = this.$$outer$4.keysIterator__sc_Iterator();
  $f_sc_Iterator__foreach__F1__V(this$1, f)
});
$c_sc_MapLike$DefaultKeySet.prototype.size__I = (function() {
  return this.$$outer$4.size__I()
});
$c_sc_MapLike$DefaultKeySet.prototype.iterator__sc_Iterator = (function() {
  return this.$$outer$4.keysIterator__sc_Iterator()
});
$c_sc_MapLike$DefaultKeySet.prototype.$$minus__O__sc_Set = (function(elem) {
  return $as_sc_SetLike($m_sc_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())).$$plus$plus__sc_GenTraversableOnce__sc_Set(this).$$minus__O__sc_Set(elem)
});
$c_sc_MapLike$DefaultKeySet.prototype.init___sc_MapLike = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$4 = $$outer
  };
  return this
});
$c_sc_MapLike$DefaultKeySet.prototype.contains__O__Z = (function(key) {
  return this.$$outer$4.contains__O__Z(key)
});
$c_sc_MapLike$DefaultKeySet.prototype.$$plus__O__sc_Set = (function(elem) {
  return $as_sc_SetLike($m_sc_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())).$$plus$plus__sc_GenTraversableOnce__sc_Set(this).$$plus__O__sc_Set(elem)
});
var $d_sc_MapLike$DefaultKeySet = new $TypeData().initClass({
  sc_MapLike$DefaultKeySet: 0
}, false, "scala.collection.MapLike$DefaultKeySet", {
  sc_MapLike$DefaultKeySet: 1,
  sc_AbstractSet: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Set: 1,
  F1: 1,
  sc_GenSet: 1,
  sc_GenSetLike: 1,
  scg_GenericSetTemplate: 1,
  sc_SetLike: 1,
  scg_Subtractable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sc_MapLike$DefaultKeySet.prototype.$classData = $d_sc_MapLike$DefaultKeySet;
function $is_scm_Seq(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.scm_Seq)))
}
function $as_scm_Seq(obj) {
  return (($is_scm_Seq(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.Seq"))
}
function $isArrayOf_scm_Seq(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_Seq)))
}
function $asArrayOf_scm_Seq(obj, depth) {
  return (($isArrayOf_scm_Seq(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.Seq;", depth))
}
/** @constructor */
function $c_sc_SeqLike$$anon$2() {
  $c_O.call(this);
  this.underlying$1 = null;
  this.bitmap$0$1 = false;
  this.$$outer$1 = null
}
$c_sc_SeqLike$$anon$2.prototype = new $h_O();
$c_sc_SeqLike$$anon$2.prototype.constructor = $c_sc_SeqLike$$anon$2;
/** @constructor */
function $h_sc_SeqLike$$anon$2() {
  /*<skip>*/
}
$h_sc_SeqLike$$anon$2.prototype = $c_sc_SeqLike$$anon$2.prototype;
$c_sc_SeqLike$$anon$2.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sc_SeqLike$$anon$2.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_sc_SeqLike$$anon$2.prototype.newSliced__scg_SliceInterval__sc_SeqViewLike$Transformed = (function(_endpoints) {
  return new $c_sc_SeqViewLike$$anon$7().init___sc_SeqViewLike__scg_SliceInterval(this, _endpoints)
});
$c_sc_SeqLike$$anon$2.prototype.head__O = (function() {
  return this.iterator__sc_Iterator().next__O()
});
$c_sc_SeqLike$$anon$2.prototype.apply__I__O = (function(idx) {
  return this.$$outer$1.apply__I__O(idx)
});
$c_sc_SeqLike$$anon$2.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_SeqLike__lengthCompare__I__I(this, len)
});
$c_sc_SeqLike$$anon$2.prototype.toIterator__sc_Iterator = (function() {
  return this.iterator__sc_Iterator()
});
$c_sc_SeqLike$$anon$2.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IterableLike__sameElements__sc_GenIterable__Z(this, that)
});
$c_sc_SeqLike$$anon$2.prototype.apply__O__O = (function(v1) {
  return this.apply__I__O($uI(v1))
});
$c_sc_SeqLike$$anon$2.prototype.flatten__F1__sc_GenTraversable = (function(asTraversable) {
  return new $c_sc_SeqViewLike$$anon$5().init___sc_SeqViewLike__F1(this, asTraversable)
});
$c_sc_SeqLike$$anon$2.prototype.exists__F1__Z = (function(p) {
  var this$1 = this.iterator__sc_Iterator();
  return $f_sc_Iterator__exists__F1__Z(this$1, p)
});
$c_sc_SeqLike$$anon$2.prototype.toList__sci_List = (function() {
  var this$1 = $m_sci_List$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_sci_List($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sc_SeqLike$$anon$2.prototype.isEmpty__Z = (function() {
  return $f_sc_SeqLike__isEmpty__Z(this)
});
$c_sc_SeqLike$$anon$2.prototype.scala$collection$TraversableViewLike$$super$tail__sc_TraversableView = (function() {
  return $as_sc_TraversableView($f_sc_TraversableLike__tail__O(this))
});
$c_sc_SeqLike$$anon$2.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sc_SeqLike$$anon$2.prototype.runWith__F1__F1 = (function(action) {
  return $f_s_PartialFunction__runWith__F1__F1(this, action)
});
$c_sc_SeqLike$$anon$2.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sc_SeqLike$$anon$2.prototype.flatMap__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return new $c_sc_SeqViewLike$$anon$5().init___sc_SeqViewLike__F1(this, f)
});
$c_sc_SeqLike$$anon$2.prototype.equals__O__Z = (function(that) {
  return $f_sc_GenSeqLike__equals__O__Z(this, that)
});
$c_sc_SeqLike$$anon$2.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_TraversableViewLike__dropWhile__F1__sc_TraversableView(this, p)
});
$c_sc_SeqLike$$anon$2.prototype.mkString__T__T = (function(sep) {
  return $f_sc_ViewMkString__mkString__T__T__T__T(this, "", sep, "")
});
$c_sc_SeqLike$$anon$2.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_ViewMkString__mkString__T__T__T__T(this, start, sep, end)
});
$c_sc_SeqLike$$anon$2.prototype.withFilter__F1__scg_FilterMonadic = (function(p) {
  return $f_sc_TraversableViewLike__withFilter__F1__sc_TraversableView(this, p)
});
$c_sc_SeqLike$$anon$2.prototype.forall__F1__Z = (function(p) {
  var this$1 = this.iterator__sc_Iterator();
  return $f_sc_Iterator__forall__F1__Z(this$1, p)
});
$c_sc_SeqLike$$anon$2.prototype.$$colon$plus__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqViewLike__$$colon$plus__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_sc_SeqLike$$anon$2.prototype.sorted__s_math_Ordering__O = (function(ord) {
  return $f_sc_SeqViewLike__sorted__s_math_Ordering__sc_SeqView(this, ord)
});
$c_sc_SeqLike$$anon$2.prototype.toString__T = (function() {
  return $f_sc_TraversableViewLike__viewToString__T(this)
});
$c_sc_SeqLike$$anon$2.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sc_Seq$()
});
$c_sc_SeqLike$$anon$2.prototype.foreach__F1__V = (function(f) {
  var this$1 = this.iterator__sc_Iterator();
  $f_sc_Iterator__foreach__F1__V(this$1, f)
});
$c_sc_SeqLike$$anon$2.prototype.foldLeft__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_sc_SeqLike$$anon$2.prototype.viewIdString__T = (function() {
  return ""
});
$c_sc_SeqLike$$anon$2.prototype.newPrepended__sc_GenTraversable__sc_SeqViewLike$Transformed = (function(that) {
  return new $c_sc_SeqViewLike$$anon$3().init___sc_SeqViewLike__sc_GenTraversable(this, that)
});
$c_sc_SeqLike$$anon$2.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_SeqLike__indexWhere__F1__I__I(this, p, from)
});
$c_sc_SeqLike$$anon$2.prototype.union__sc_GenSeq__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_SeqViewLike__union__sc_GenSeq__scg_CanBuildFrom__O(this, that, bf)
});
$c_sc_SeqLike$$anon$2.prototype.headOption__s_Option = (function() {
  return $f_sc_TraversableLike__headOption__s_Option(this)
});
$c_sc_SeqLike$$anon$2.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_TraversableViewLike__takeWhile__F1__sc_TraversableView(this, p)
});
$c_sc_SeqLike$$anon$2.prototype.intersect__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqViewLike__intersect__sc_GenSeq__sc_SeqView(this, that)
});
$c_sc_SeqLike$$anon$2.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sc_SeqLike$$anon$2.prototype.filter__F1__O = (function(p) {
  return $f_sc_TraversableViewLike__filter__F1__sc_TraversableView(this, p)
});
$c_sc_SeqLike$$anon$2.prototype.reverse__O = (function() {
  return new $c_sc_SeqViewLike$$anon$12().init___sc_SeqViewLike(this)
});
$c_sc_SeqLike$$anon$2.prototype.size__I = (function() {
  return this.length__I()
});
$c_sc_SeqLike$$anon$2.prototype.toBuffer__scm_Buffer = (function() {
  var this$1 = $m_scm_ArrayBuffer$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_scm_Buffer($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sc_SeqLike$$anon$2.prototype.distinct__O = (function() {
  return $f_sc_SeqViewLike__distinct__sc_SeqView(this)
});
$c_sc_SeqLike$$anon$2.prototype.$$plus$colon__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqViewLike__$$plus$colon__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_sc_SeqLike$$anon$2.prototype.apply$mcZI$sp__I__Z = (function(v1) {
  return $uZ(this.apply__I__O(v1))
});
$c_sc_SeqLike$$anon$2.prototype.iterator__sc_Iterator = (function() {
  return this.$$outer$1.iterator__sc_Iterator()
});
$c_sc_SeqLike$$anon$2.prototype.find__F1__s_Option = (function(p) {
  var this$1 = this.iterator__sc_Iterator();
  return $f_sc_Iterator__find__F1__s_Option(this$1, p)
});
$c_sc_SeqLike$$anon$2.prototype.span__F1__T2 = (function(p) {
  return $f_sc_TraversableViewLike__span__F1__T2(this, p)
});
$c_sc_SeqLike$$anon$2.prototype.diff__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqViewLike__diff__sc_GenSeq__sc_SeqView(this, that)
});
$c_sc_SeqLike$$anon$2.prototype.mkString__T = (function() {
  return $f_sc_ViewMkString__mkString__T__T__T__T(this, "", "", "")
});
$c_sc_SeqLike$$anon$2.prototype.newAppended__sc_GenTraversable__sc_TraversableViewLike$Transformed = (function(that) {
  return new $c_sc_SeqViewLike$$anon$2().init___sc_SeqViewLike__sc_GenTraversable(this, that)
});
$c_sc_SeqLike$$anon$2.prototype.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O = (function(xs, bf) {
  return $f_sc_TraversableViewLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, xs, bf)
});
$c_sc_SeqLike$$anon$2.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IterableViewLike__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_sc_SeqLike$$anon$2.prototype.length__I = (function() {
  return this.$$outer$1.length__I()
});
$c_sc_SeqLike$$anon$2.prototype.seq__sc_Seq = (function() {
  return this
});
$c_sc_SeqLike$$anon$2.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_TraversableViewLike__filterNot__F1__sc_TraversableView(this, p)
});
$c_sc_SeqLike$$anon$2.prototype.sizeHintIfCheap__I = (function() {
  return (-1)
});
$c_sc_SeqLike$$anon$2.prototype.partition__F1__T2 = (function(p) {
  return $f_sc_TraversableViewLike__partition__F1__T2(this, p)
});
$c_sc_SeqLike$$anon$2.prototype.newTakenWhile__F1__sc_TraversableViewLike$Transformed = (function(p) {
  return new $c_sc_SeqViewLike$$anon$9().init___sc_SeqViewLike__F1(this, p)
});
$c_sc_SeqLike$$anon$2.prototype.take__I__O = (function(n) {
  return $f_sc_IterableViewLike__take__I__sc_IterableView(this, n)
});
$c_sc_SeqLike$$anon$2.prototype.toStream__sci_Stream = (function() {
  return this.iterator__sc_Iterator().toStream__sci_Stream()
});
$c_sc_SeqLike$$anon$2.prototype.view__sc_SeqView = (function() {
  return new $c_sc_SeqLike$$anon$2().init___sc_SeqLike(this)
});
$c_sc_SeqLike$$anon$2.prototype.last__O = (function() {
  return $f_sc_TraversableLike__last__O(this)
});
$c_sc_SeqLike$$anon$2.prototype.drop__I__O = (function(n) {
  return $f_sc_IterableViewLike__drop__I__sc_IterableView(this, n)
});
$c_sc_SeqLike$$anon$2.prototype.newMapped__F1__sc_TraversableViewLike$Transformed = (function(f) {
  return new $c_sc_SeqViewLike$$anon$4().init___sc_SeqViewLike__F1(this, f)
});
$c_sc_SeqLike$$anon$2.prototype.contains__O__Z = (function(elem) {
  return $f_sc_SeqLike__contains__O__Z(this, elem)
});
$c_sc_SeqLike$$anon$2.prototype.thisCollection__sc_Seq = (function() {
  return this
});
$c_sc_SeqLike$$anon$2.prototype.tail__O = (function() {
  return $f_sc_TraversableViewLike__tail__sc_TraversableView(this)
});
$c_sc_SeqLike$$anon$2.prototype.toTraversable__sc_Traversable = (function() {
  return this
});
$c_sc_SeqLike$$anon$2.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_ViewMkString__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_sc_SeqLike$$anon$2.prototype.sortBy__F1__s_math_Ordering__O = (function(f, ord) {
  return $f_sc_SeqViewLike__sortBy__F1__s_math_Ordering__sc_SeqView(this, f, ord)
});
$c_sc_SeqLike$$anon$2.prototype.toSeq__sc_Seq = (function() {
  return this
});
$c_sc_SeqLike$$anon$2.prototype.filter__F1__sc_TraversableView = (function(p) {
  return $f_sc_TraversableViewLike__filter__F1__sc_TraversableView(this, p)
});
$c_sc_SeqLike$$anon$2.prototype.isDefinedAt__O__Z = (function(x) {
  var idx = $uI(x);
  return $f_sc_GenSeqLike__isDefinedAt__I__Z(this, idx)
});
$c_sc_SeqLike$$anon$2.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sc_SeqLike$$anon$2.prototype.repr__O = (function() {
  return this
});
$c_sc_SeqLike$$anon$2.prototype.$$div$colon__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_sc_SeqLike$$anon$2.prototype.newForced__F0__sc_SeqViewLike$Transformed = (function(xs) {
  return new $c_sc_SeqViewLike$$anon$1().init___sc_SeqViewLike__F0(this, xs)
});
$c_sc_SeqLike$$anon$2.prototype.newSliced__scg_SliceInterval__sc_TraversableViewLike$Transformed = (function(_endpoints) {
  return new $c_sc_SeqViewLike$$anon$7().init___sc_SeqViewLike__scg_SliceInterval(this, _endpoints)
});
$c_sc_SeqLike$$anon$2.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return $f_s_PartialFunction__applyOrElse__O__F1__O(this, x, $default)
});
$c_sc_SeqLike$$anon$2.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_sc_IterableLike__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_sc_SeqLike$$anon$2.prototype.isTraversableAgain__Z = (function() {
  return true
});
$c_sc_SeqLike$$anon$2.prototype.toSeq__sc_GenSeq = (function() {
  return this
});
$c_sc_SeqLike$$anon$2.prototype.hashCode__I = (function() {
  return $m_s_util_hashing_MurmurHash3$().seqHash__sc_Seq__I(this)
});
$c_sc_SeqLike$$anon$2.prototype.groupBy__F1__sci_Map = (function(f) {
  return $f_sc_TraversableViewLike__groupBy__F1__sci_Map(this, f)
});
$c_sc_SeqLike$$anon$2.prototype.newFiltered__F1__sc_TraversableViewLike$Transformed = (function(p) {
  return new $c_sc_SeqViewLike$$anon$6().init___sc_SeqViewLike__F1(this, p)
});
$c_sc_SeqLike$$anon$2.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var this$2 = this.iterator__sc_Iterator();
  while (this$2.hasNext__Z()) {
    var arg1 = this$2.next__O();
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1))
  };
  return $as_sci_Map(b.elems$1)
});
$c_sc_SeqLike$$anon$2.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return new $c_sc_SeqViewLike$$anon$4().init___sc_SeqViewLike__F1(this, f)
});
$c_sc_SeqLike$$anon$2.prototype.segmentLength__F1__I__I = (function(p, from) {
  return $f_sc_SeqLike__segmentLength__F1__I__I(this, p, from)
});
$c_sc_SeqLike$$anon$2.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_sc_TraversableOnce__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_sc_SeqLike$$anon$2.prototype.init___sc_SeqLike = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_sc_SeqLike$$anon$2.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_sc_SeqLike$$anon$2.prototype.newDroppedWhile__F1__sc_TraversableViewLike$Transformed = (function(p) {
  return new $c_sc_SeqViewLike$$anon$8().init___sc_SeqViewLike__F1(this, p)
});
$c_sc_SeqLike$$anon$2.prototype.collect__s_PartialFunction__scg_CanBuildFrom__O = (function(pf, bf) {
  return $f_sc_TraversableViewLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this, pf, bf)
});
$c_sc_SeqLike$$anon$2.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_TraversableOnce__reduceLeft__F2__O(this, op)
});
$c_sc_SeqLike$$anon$2.prototype.newBuilder__scm_Builder = (function() {
  return $f_sc_TraversableViewLike__newBuilder__scm_Builder(this)
});
$c_sc_SeqLike$$anon$2.prototype.newForced__F0__sc_TraversableViewLike$Transformed = (function(xs) {
  return new $c_sc_SeqViewLike$$anon$1().init___sc_SeqViewLike__F0(this, xs)
});
$c_sc_SeqLike$$anon$2.prototype.stringPrefix__T = (function() {
  return "SeqView"
});
$c_sc_SeqLike$$anon$2.prototype.sortWith__F2__O = (function(lt) {
  return $f_sc_SeqViewLike__sortWith__F2__sc_SeqView(this, lt)
});
$c_sc_SeqLike$$anon$2.prototype.zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return new $c_sc_SeqViewLike$$anon$10().init___sc_SeqViewLike__sc_GenIterable(this, that)
});
var $d_sc_SeqLike$$anon$2 = new $TypeData().initClass({
  sc_SeqLike$$anon$2: 0
}, false, "scala.collection.SeqLike$$anon$2", {
  sc_SeqLike$$anon$2: 1,
  O: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1
});
$c_sc_SeqLike$$anon$2.prototype.$classData = $d_sc_SeqLike$$anon$2;
/** @constructor */
function $c_scm_HashMap$$anon$1() {
  $c_sc_MapLike$DefaultKeySet.call(this);
  this.$$outer$5 = null
}
$c_scm_HashMap$$anon$1.prototype = new $h_sc_MapLike$DefaultKeySet();
$c_scm_HashMap$$anon$1.prototype.constructor = $c_scm_HashMap$$anon$1;
/** @constructor */
function $h_scm_HashMap$$anon$1() {
  /*<skip>*/
}
$h_scm_HashMap$$anon$1.prototype = $c_scm_HashMap$$anon$1.prototype;
$c_scm_HashMap$$anon$1.prototype.foreach__F1__V = (function(f) {
  var this$1 = this.$$outer$5;
  var iterTable = this$1.table$5;
  var idx = $f_scm_HashTable__scala$collection$mutable$HashTable$$lastPopulatedIndex__I(this$1);
  var es = iterTable.get(idx);
  while ((es !== null)) {
    var next = $as_scm_HashEntry(es.next__O());
    var arg1 = es;
    var e = $as_scm_DefaultEntry(arg1);
    f.apply__O__O(e.key$1);
    es = next;
    while (((es === null) && (idx > 0))) {
      idx = (((-1) + idx) | 0);
      es = iterTable.get(idx)
    }
  }
});
$c_scm_HashMap$$anon$1.prototype.init___scm_HashMap = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$5 = $$outer
  };
  $c_sc_MapLike$DefaultKeySet.prototype.init___sc_MapLike.call(this, $$outer);
  return this
});
var $d_scm_HashMap$$anon$1 = new $TypeData().initClass({
  scm_HashMap$$anon$1: 0
}, false, "scala.collection.mutable.HashMap$$anon$1", {
  scm_HashMap$$anon$1: 1,
  sc_MapLike$DefaultKeySet: 1,
  sc_AbstractSet: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Set: 1,
  F1: 1,
  sc_GenSet: 1,
  sc_GenSetLike: 1,
  scg_GenericSetTemplate: 1,
  sc_SetLike: 1,
  scg_Subtractable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_HashMap$$anon$1.prototype.$classData = $d_scm_HashMap$$anon$1;
/** @constructor */
function $c_scm_LinkedHashMap$DefaultKeySet() {
  $c_sc_MapLike$DefaultKeySet.call(this)
}
$c_scm_LinkedHashMap$DefaultKeySet.prototype = new $h_sc_MapLike$DefaultKeySet();
$c_scm_LinkedHashMap$DefaultKeySet.prototype.constructor = $c_scm_LinkedHashMap$DefaultKeySet;
/** @constructor */
function $h_scm_LinkedHashMap$DefaultKeySet() {
  /*<skip>*/
}
$h_scm_LinkedHashMap$DefaultKeySet.prototype = $c_scm_LinkedHashMap$DefaultKeySet.prototype;
$c_scm_LinkedHashMap$DefaultKeySet.prototype.empty__sc_Set = (function() {
  return new $c_scm_LinkedHashSet().init___()
});
$c_scm_LinkedHashMap$DefaultKeySet.prototype.empty__sc_GenSet = (function() {
  return new $c_scm_LinkedHashSet().init___()
});
$c_scm_LinkedHashMap$DefaultKeySet.prototype.init___scm_LinkedHashMap = (function($$outer) {
  $c_sc_MapLike$DefaultKeySet.prototype.init___sc_MapLike.call(this, $$outer);
  return this
});
var $d_scm_LinkedHashMap$DefaultKeySet = new $TypeData().initClass({
  scm_LinkedHashMap$DefaultKeySet: 0
}, false, "scala.collection.mutable.LinkedHashMap$DefaultKeySet", {
  scm_LinkedHashMap$DefaultKeySet: 1,
  sc_MapLike$DefaultKeySet: 1,
  sc_AbstractSet: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Set: 1,
  F1: 1,
  sc_GenSet: 1,
  sc_GenSetLike: 1,
  scg_GenericSetTemplate: 1,
  sc_SetLike: 1,
  scg_Subtractable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_LinkedHashMap$DefaultKeySet.prototype.$classData = $d_scm_LinkedHashMap$DefaultKeySet;
function $f_sc_SeqViewLike$Reversed__apply__I__O($thiz, idx) {
  return $thiz.scala$collection$SeqViewLike$Reversed$$$outer__sc_SeqViewLike().apply__I__O((((((-1) + $thiz.scala$collection$SeqViewLike$Reversed$$$outer__sc_SeqViewLike().length__I()) | 0) - idx) | 0))
}
function $f_sc_SeqViewLike$Reversed__createReversedIterator__psc_SeqViewLike$Reversed__sc_Iterator($thiz) {
  var elem = $m_sci_Nil$();
  var lst = new $c_sr_ObjectRef().init___O(elem);
  $thiz.scala$collection$SeqViewLike$Reversed$$$outer__sc_SeqViewLike().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, lst$1) {
    return (function(elem$2) {
      var this$2 = $as_sci_List(lst$1.elem$1);
      lst$1.elem$1 = new $c_sci_$colon$colon().init___O__sci_List(elem$2, this$2)
    })
  })($thiz, lst)));
  var this$3 = $as_sci_List(lst.elem$1);
  return new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$3)
}
/** @constructor */
function $c_sci_AbstractMap() {
  $c_sc_AbstractMap.call(this)
}
$c_sci_AbstractMap.prototype = new $h_sc_AbstractMap();
$c_sci_AbstractMap.prototype.constructor = $c_sci_AbstractMap;
/** @constructor */
function $h_sci_AbstractMap() {
  /*<skip>*/
}
$h_sci_AbstractMap.prototype = $c_sci_AbstractMap.prototype;
$c_sci_AbstractMap.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sci_AbstractMap.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_sci_AbstractMap.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sci_AbstractMap.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_AbstractMap.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sci_Iterable$()
});
$c_sci_AbstractMap.prototype.empty__sc_Map = (function() {
  return this.empty__sci_Map()
});
$c_sci_AbstractMap.prototype.empty__sci_Map = (function() {
  return $m_sci_Map$EmptyMap$()
});
$c_sci_AbstractMap.prototype.seq__sc_Map = (function() {
  return this
});
$c_sci_AbstractMap.prototype.$$plus$plus__sc_GenTraversableOnce__sci_Map = (function(xs) {
  return $f_sci_MapLike__$$plus$plus__sc_GenTraversableOnce__sci_Map(this, xs)
});
$c_sci_AbstractMap.prototype.filterNot__F1__O = (function(p) {
  return this.filterNot__F1__sc_Map(p)
});
$c_sci_AbstractMap.prototype.keySet__sc_Set = (function() {
  return new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(this)
});
$c_sci_AbstractMap.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  return this
});
$c_sci_AbstractMap.prototype.toSeq__sc_GenSeq = (function() {
  return $f_sc_MapLike__toSeq__sc_Seq(this)
});
/** @constructor */
function $c_sci_Stream$$anon$1() {
  $c_O.call(this);
  this.underlying$1 = null;
  this.bitmap$0$1 = false;
  this.$$outer$1 = null
}
$c_sci_Stream$$anon$1.prototype = new $h_O();
$c_sci_Stream$$anon$1.prototype.constructor = $c_sci_Stream$$anon$1;
/** @constructor */
function $h_sci_Stream$$anon$1() {
  /*<skip>*/
}
$h_sci_Stream$$anon$1.prototype = $c_sci_Stream$$anon$1.prototype;
$c_sci_Stream$$anon$1.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sci_Stream$$anon$1.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_sci_Stream$$anon$1.prototype.newSliced__scg_SliceInterval__sc_SeqViewLike$Transformed = (function(_endpoints) {
  return new $c_sci_StreamViewLike$$anon$7().init___sci_StreamViewLike__scg_SliceInterval(this, _endpoints)
});
$c_sci_Stream$$anon$1.prototype.head__O = (function() {
  return this.iterator__sc_Iterator().next__O()
});
$c_sci_Stream$$anon$1.prototype.apply__I__O = (function(idx) {
  var this$1 = this.$$outer$1;
  return $f_sc_LinearSeqOptimized__apply__I__O(this$1, idx)
});
$c_sci_Stream$$anon$1.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_SeqLike__lengthCompare__I__I(this, len)
});
$c_sci_Stream$$anon$1.prototype.toIterator__sc_Iterator = (function() {
  return this.iterator__sc_Iterator()
});
$c_sci_Stream$$anon$1.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IterableLike__sameElements__sc_GenIterable__Z(this, that)
});
$c_sci_Stream$$anon$1.prototype.apply__O__O = (function(v1) {
  return this.apply__I__O($uI(v1))
});
$c_sci_Stream$$anon$1.prototype.flatten__F1__sc_GenTraversable = (function(asTraversable) {
  return new $c_sci_StreamViewLike$$anon$5().init___sci_StreamViewLike__F1(this, asTraversable)
});
$c_sci_Stream$$anon$1.prototype.exists__F1__Z = (function(p) {
  var this$1 = this.iterator__sc_Iterator();
  return $f_sc_Iterator__exists__F1__Z(this$1, p)
});
$c_sci_Stream$$anon$1.prototype.toList__sci_List = (function() {
  var this$1 = $m_sci_List$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_sci_List($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sci_Stream$$anon$1.prototype.isEmpty__Z = (function() {
  return $f_sc_SeqLike__isEmpty__Z(this)
});
$c_sci_Stream$$anon$1.prototype.scala$collection$TraversableViewLike$$super$tail__sc_TraversableView = (function() {
  return $as_sc_TraversableView($f_sc_TraversableLike__tail__O(this))
});
$c_sci_Stream$$anon$1.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sci_Stream$$anon$1.prototype.runWith__F1__F1 = (function(action) {
  return $f_s_PartialFunction__runWith__F1__F1(this, action)
});
$c_sci_Stream$$anon$1.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_Stream$$anon$1.prototype.flatMap__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return new $c_sci_StreamViewLike$$anon$5().init___sci_StreamViewLike__F1(this, f)
});
$c_sci_Stream$$anon$1.prototype.equals__O__Z = (function(that) {
  return $f_sc_GenSeqLike__equals__O__Z(this, that)
});
$c_sci_Stream$$anon$1.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_TraversableViewLike__dropWhile__F1__sc_TraversableView(this, p)
});
$c_sci_Stream$$anon$1.prototype.mkString__T__T = (function(sep) {
  return $f_sc_ViewMkString__mkString__T__T__T__T(this, "", sep, "")
});
$c_sci_Stream$$anon$1.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_ViewMkString__mkString__T__T__T__T(this, start, sep, end)
});
$c_sci_Stream$$anon$1.prototype.withFilter__F1__scg_FilterMonadic = (function(p) {
  return $f_sc_TraversableViewLike__withFilter__F1__sc_TraversableView(this, p)
});
$c_sci_Stream$$anon$1.prototype.forall__F1__Z = (function(p) {
  var this$1 = this.iterator__sc_Iterator();
  return $f_sc_Iterator__forall__F1__Z(this$1, p)
});
$c_sci_Stream$$anon$1.prototype.$$colon$plus__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqViewLike__$$colon$plus__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_sci_Stream$$anon$1.prototype.sorted__s_math_Ordering__O = (function(ord) {
  return $f_sc_SeqViewLike__sorted__s_math_Ordering__sc_SeqView(this, ord)
});
$c_sci_Stream$$anon$1.prototype.toString__T = (function() {
  return $f_sc_TraversableViewLike__viewToString__T(this)
});
$c_sci_Stream$$anon$1.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sc_Seq$()
});
$c_sci_Stream$$anon$1.prototype.foreach__F1__V = (function(f) {
  var this$1 = this.iterator__sc_Iterator();
  $f_sc_Iterator__foreach__F1__V(this$1, f)
});
$c_sci_Stream$$anon$1.prototype.foldLeft__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_sci_Stream$$anon$1.prototype.viewIdString__T = (function() {
  return ""
});
$c_sci_Stream$$anon$1.prototype.newPrepended__sc_GenTraversable__sc_SeqViewLike$Transformed = (function(that) {
  return new $c_sci_StreamViewLike$$anon$3().init___sci_StreamViewLike__sc_GenTraversable(this, that)
});
$c_sci_Stream$$anon$1.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_SeqLike__indexWhere__F1__I__I(this, p, from)
});
$c_sci_Stream$$anon$1.prototype.union__sc_GenSeq__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_SeqViewLike__union__sc_GenSeq__scg_CanBuildFrom__O(this, that, bf)
});
$c_sci_Stream$$anon$1.prototype.headOption__s_Option = (function() {
  return $f_sc_TraversableLike__headOption__s_Option(this)
});
$c_sci_Stream$$anon$1.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_TraversableViewLike__takeWhile__F1__sc_TraversableView(this, p)
});
$c_sci_Stream$$anon$1.prototype.intersect__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqViewLike__intersect__sc_GenSeq__sc_SeqView(this, that)
});
$c_sci_Stream$$anon$1.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sci_Stream$$anon$1.prototype.init___sci_Stream = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_sci_Stream$$anon$1.prototype.filter__F1__O = (function(p) {
  return $f_sc_TraversableViewLike__filter__F1__sc_TraversableView(this, p)
});
$c_sci_Stream$$anon$1.prototype.reverse__O = (function() {
  return new $c_sci_StreamViewLike$$anon$12().init___sci_StreamViewLike(this)
});
$c_sci_Stream$$anon$1.prototype.size__I = (function() {
  return this.length__I()
});
$c_sci_Stream$$anon$1.prototype.toBuffer__scm_Buffer = (function() {
  var this$1 = $m_scm_ArrayBuffer$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_scm_Buffer($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sci_Stream$$anon$1.prototype.distinct__O = (function() {
  return $f_sc_SeqViewLike__distinct__sc_SeqView(this)
});
$c_sci_Stream$$anon$1.prototype.$$plus$colon__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqViewLike__$$plus$colon__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_sci_Stream$$anon$1.prototype.apply$mcZI$sp__I__Z = (function(v1) {
  return $uZ(this.apply__I__O(v1))
});
$c_sci_Stream$$anon$1.prototype.iterator__sc_Iterator = (function() {
  var this$1 = this.$$outer$1;
  return new $c_sci_StreamIterator().init___sci_Stream(this$1)
});
$c_sci_Stream$$anon$1.prototype.find__F1__s_Option = (function(p) {
  var this$1 = this.iterator__sc_Iterator();
  return $f_sc_Iterator__find__F1__s_Option(this$1, p)
});
$c_sci_Stream$$anon$1.prototype.span__F1__T2 = (function(p) {
  return $f_sc_TraversableViewLike__span__F1__T2(this, p)
});
$c_sci_Stream$$anon$1.prototype.diff__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqViewLike__diff__sc_GenSeq__sc_SeqView(this, that)
});
$c_sci_Stream$$anon$1.prototype.mkString__T = (function() {
  return $f_sc_ViewMkString__mkString__T__T__T__T(this, "", "", "")
});
$c_sci_Stream$$anon$1.prototype.newAppended__sc_GenTraversable__sc_TraversableViewLike$Transformed = (function(that) {
  return new $c_sci_StreamViewLike$$anon$2().init___sci_StreamViewLike__sc_GenTraversable(this, that)
});
$c_sci_Stream$$anon$1.prototype.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O = (function(xs, bf) {
  return $f_sc_TraversableViewLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, xs, bf)
});
$c_sci_Stream$$anon$1.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IterableViewLike__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_sci_Stream$$anon$1.prototype.length__I = (function() {
  return this.$$outer$1.length__I()
});
$c_sci_Stream$$anon$1.prototype.seq__sc_Seq = (function() {
  return this
});
$c_sci_Stream$$anon$1.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_TraversableViewLike__filterNot__F1__sc_TraversableView(this, p)
});
$c_sci_Stream$$anon$1.prototype.sizeHintIfCheap__I = (function() {
  return (-1)
});
$c_sci_Stream$$anon$1.prototype.partition__F1__T2 = (function(p) {
  return $f_sc_TraversableViewLike__partition__F1__T2(this, p)
});
$c_sci_Stream$$anon$1.prototype.newTakenWhile__F1__sc_TraversableViewLike$Transformed = (function(p) {
  return new $c_sci_StreamViewLike$$anon$9().init___sci_StreamViewLike__F1(this, p)
});
$c_sci_Stream$$anon$1.prototype.take__I__O = (function(n) {
  return $f_sc_IterableViewLike__take__I__sc_IterableView(this, n)
});
$c_sci_Stream$$anon$1.prototype.toStream__sci_Stream = (function() {
  return this.iterator__sc_Iterator().toStream__sci_Stream()
});
$c_sci_Stream$$anon$1.prototype.view__sc_SeqView = (function() {
  return new $c_sc_SeqLike$$anon$2().init___sc_SeqLike(this)
});
$c_sci_Stream$$anon$1.prototype.last__O = (function() {
  return $f_sc_TraversableLike__last__O(this)
});
$c_sci_Stream$$anon$1.prototype.drop__I__O = (function(n) {
  return $f_sc_IterableViewLike__drop__I__sc_IterableView(this, n)
});
$c_sci_Stream$$anon$1.prototype.newMapped__F1__sc_TraversableViewLike$Transformed = (function(f) {
  return new $c_sci_StreamViewLike$$anon$4().init___sci_StreamViewLike__F1(this, f)
});
$c_sci_Stream$$anon$1.prototype.contains__O__Z = (function(elem) {
  return $f_sc_SeqLike__contains__O__Z(this, elem)
});
$c_sci_Stream$$anon$1.prototype.thisCollection__sc_Seq = (function() {
  return this
});
$c_sci_Stream$$anon$1.prototype.tail__O = (function() {
  return $f_sc_TraversableViewLike__tail__sc_TraversableView(this)
});
$c_sci_Stream$$anon$1.prototype.toTraversable__sc_Traversable = (function() {
  return this
});
$c_sci_Stream$$anon$1.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_ViewMkString__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_sci_Stream$$anon$1.prototype.sortBy__F1__s_math_Ordering__O = (function(f, ord) {
  return $f_sc_SeqViewLike__sortBy__F1__s_math_Ordering__sc_SeqView(this, f, ord)
});
$c_sci_Stream$$anon$1.prototype.toSeq__sc_Seq = (function() {
  return this
});
$c_sci_Stream$$anon$1.prototype.filter__F1__sc_TraversableView = (function(p) {
  return $f_sc_TraversableViewLike__filter__F1__sc_TraversableView(this, p)
});
$c_sci_Stream$$anon$1.prototype.isDefinedAt__O__Z = (function(x) {
  var idx = $uI(x);
  return $f_sc_GenSeqLike__isDefinedAt__I__Z(this, idx)
});
$c_sci_Stream$$anon$1.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sci_Stream$$anon$1.prototype.repr__O = (function() {
  return this
});
$c_sci_Stream$$anon$1.prototype.$$div$colon__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_sci_Stream$$anon$1.prototype.newForced__F0__sc_SeqViewLike$Transformed = (function(xs) {
  return new $c_sci_StreamViewLike$$anon$1().init___sci_StreamViewLike__F0(this, xs)
});
$c_sci_Stream$$anon$1.prototype.newSliced__scg_SliceInterval__sc_TraversableViewLike$Transformed = (function(_endpoints) {
  return new $c_sci_StreamViewLike$$anon$7().init___sci_StreamViewLike__scg_SliceInterval(this, _endpoints)
});
$c_sci_Stream$$anon$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return $f_s_PartialFunction__applyOrElse__O__F1__O(this, x, $default)
});
$c_sci_Stream$$anon$1.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_sc_IterableLike__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_sci_Stream$$anon$1.prototype.isTraversableAgain__Z = (function() {
  return true
});
$c_sci_Stream$$anon$1.prototype.toSeq__sc_GenSeq = (function() {
  return this
});
$c_sci_Stream$$anon$1.prototype.hashCode__I = (function() {
  return $m_s_util_hashing_MurmurHash3$().seqHash__sc_Seq__I(this)
});
$c_sci_Stream$$anon$1.prototype.groupBy__F1__sci_Map = (function(f) {
  return $f_sc_TraversableViewLike__groupBy__F1__sci_Map(this, f)
});
$c_sci_Stream$$anon$1.prototype.newFiltered__F1__sc_TraversableViewLike$Transformed = (function(p) {
  return new $c_sci_StreamViewLike$$anon$6().init___sci_StreamViewLike__F1(this, p)
});
$c_sci_Stream$$anon$1.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var this$2 = this.iterator__sc_Iterator();
  while (this$2.hasNext__Z()) {
    var arg1 = this$2.next__O();
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1))
  };
  return $as_sci_Map(b.elems$1)
});
$c_sci_Stream$$anon$1.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return new $c_sci_StreamViewLike$$anon$4().init___sci_StreamViewLike__F1(this, f)
});
$c_sci_Stream$$anon$1.prototype.segmentLength__F1__I__I = (function(p, from) {
  return $f_sc_SeqLike__segmentLength__F1__I__I(this, p, from)
});
$c_sci_Stream$$anon$1.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_sc_TraversableOnce__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_sci_Stream$$anon$1.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_sci_Stream$$anon$1.prototype.newDroppedWhile__F1__sc_TraversableViewLike$Transformed = (function(p) {
  return new $c_sci_StreamViewLike$$anon$8().init___sci_StreamViewLike__F1(this, p)
});
$c_sci_Stream$$anon$1.prototype.collect__s_PartialFunction__scg_CanBuildFrom__O = (function(pf, bf) {
  return $f_sc_TraversableViewLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this, pf, bf)
});
$c_sci_Stream$$anon$1.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_TraversableOnce__reduceLeft__F2__O(this, op)
});
$c_sci_Stream$$anon$1.prototype.newBuilder__scm_Builder = (function() {
  return $f_sc_TraversableViewLike__newBuilder__scm_Builder(this)
});
$c_sci_Stream$$anon$1.prototype.newForced__F0__sc_TraversableViewLike$Transformed = (function(xs) {
  return new $c_sci_StreamViewLike$$anon$1().init___sci_StreamViewLike__F0(this, xs)
});
$c_sci_Stream$$anon$1.prototype.stringPrefix__T = (function() {
  return "StreamView"
});
$c_sci_Stream$$anon$1.prototype.sortWith__F2__O = (function(lt) {
  return $f_sc_SeqViewLike__sortWith__F2__sc_SeqView(this, lt)
});
$c_sci_Stream$$anon$1.prototype.zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return new $c_sci_StreamViewLike$$anon$10().init___sci_StreamViewLike__sc_GenIterable(this, that)
});
var $d_sci_Stream$$anon$1 = new $TypeData().initClass({
  sci_Stream$$anon$1: 0
}, false, "scala.collection.immutable.Stream$$anon$1", {
  sci_Stream$$anon$1: 1,
  O: 1,
  sci_StreamView: 1,
  sci_StreamViewLike: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1
});
$c_sci_Stream$$anon$1.prototype.$classData = $d_sci_Stream$$anon$1;
/** @constructor */
function $c_sc_SeqViewLike$AbstractTransformed() {
  $c_O.call(this);
  this.underlying$1 = null;
  this.bitmap$0$1 = false;
  this.$$outer$1 = null
}
$c_sc_SeqViewLike$AbstractTransformed.prototype = new $h_O();
$c_sc_SeqViewLike$AbstractTransformed.prototype.constructor = $c_sc_SeqViewLike$AbstractTransformed;
/** @constructor */
function $h_sc_SeqViewLike$AbstractTransformed() {
  /*<skip>*/
}
$h_sc_SeqViewLike$AbstractTransformed.prototype = $c_sc_SeqViewLike$AbstractTransformed.prototype;
$c_sc_SeqViewLike$AbstractTransformed.prototype.seq__sc_TraversableOnce = (function() {
  return this.seq__sc_Seq()
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.newSliced__scg_SliceInterval__sc_SeqViewLike$Transformed = (function(_endpoints) {
  return new $c_sc_SeqViewLike$$anon$7().init___sc_SeqViewLike__scg_SliceInterval(this, _endpoints)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.head__O = (function() {
  return this.iterator__sc_Iterator().next__O()
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_SeqLike__lengthCompare__I__I(this, len)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.take__I__sc_IterableView = (function(n) {
  return $f_sc_IterableViewLike__take__I__sc_IterableView(this, n)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.toIterator__sc_Iterator = (function() {
  return this.iterator__sc_Iterator()
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IterableLike__sameElements__sc_GenIterable__Z(this, that)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.flatten__F1__sc_GenTraversable = (function(asTraversable) {
  return this.newFlatMapped__F1__sc_TraversableViewLike$Transformed(asTraversable)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.exists__F1__Z = (function(p) {
  var this$1 = this.iterator__sc_Iterator();
  return $f_sc_Iterator__exists__F1__Z(this$1, p)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.toList__sci_List = (function() {
  var this$1 = $m_sci_List$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_sci_List($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.isEmpty__Z = (function() {
  return $f_sc_IterableViewLike$Transformed__isEmpty__Z(this)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.seq__sc_Iterable = (function() {
  return this.seq__sc_Seq()
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.scala$collection$TraversableViewLike$$super$tail__sc_TraversableView = (function() {
  return $as_sc_TraversableView($f_sc_TraversableLike__tail__O(this))
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.runWith__F1__F1 = (function(action) {
  return $f_s_PartialFunction__runWith__F1__F1(this, action)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.thisCollection__sc_Traversable = (function() {
  return this.thisCollection__sc_Seq()
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.init___sc_SeqViewLike = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.flatMap__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return this.newFlatMapped__F1__sc_TraversableViewLike$Transformed(f)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.equals__O__Z = (function(that) {
  return $f_sc_GenSeqLike__equals__O__Z(this, that)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.dropWhile__F1__O = (function(p) {
  return this.dropWhile__F1__sc_TraversableView(p)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.mkString__T__T = (function(sep) {
  return $f_sc_ViewMkString__mkString__T__T__T__T(this, "", sep, "")
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_ViewMkString__mkString__T__T__T__T(this, start, sep, end)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.newDroppedWhile__F1__sc_SeqViewLike$Transformed = (function(p) {
  return new $c_sc_SeqViewLike$$anon$8().init___sc_SeqViewLike__F1(this, p)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.withFilter__F1__scg_FilterMonadic = (function(p) {
  return $f_sc_TraversableViewLike__withFilter__F1__sc_TraversableView(this, p)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.forall__F1__Z = (function(p) {
  var this$1 = this.iterator__sc_Iterator();
  return $f_sc_Iterator__forall__F1__Z(this$1, p)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.$$colon$plus__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqViewLike__$$colon$plus__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.sorted__s_math_Ordering__O = (function(ord) {
  return $f_sc_SeqViewLike__sorted__s_math_Ordering__sc_SeqView(this, ord)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.newReversed__sc_SeqViewLike$Transformed = (function() {
  return new $c_sc_SeqViewLike$$anon$12().init___sc_SeqViewLike(this)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.toString__T = (function() {
  return $f_sc_TraversableViewLike__viewToString__T(this)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sc_Seq$()
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.newFiltered__F1__sc_SeqViewLike$Transformed = (function(p) {
  return new $c_sc_SeqViewLike$$anon$6().init___sc_SeqViewLike__F1(this, p)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.foreach__F1__V = (function(f) {
  var this$1 = this.iterator__sc_Iterator();
  $f_sc_Iterator__foreach__F1__V(this$1, f)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.takeWhile__F1__sc_TraversableView = (function(p) {
  return $f_sc_TraversableViewLike__takeWhile__F1__sc_TraversableView(this, p)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.scala$collection$TraversableViewLike$Transformed$$$outer__sc_TraversableViewLike = (function() {
  return this.$$outer$1
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.foldLeft__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.viewIdString__T = (function() {
  return $f_sc_TraversableViewLike$Transformed__viewIdString__T(this)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.newPrepended__sc_GenTraversable__sc_SeqViewLike$Transformed = (function(that) {
  return new $c_sc_SeqViewLike$$anon$3().init___sc_SeqViewLike__sc_GenTraversable(this, that)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_SeqLike__indexWhere__F1__I__I(this, p, from)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.union__sc_GenSeq__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_SeqViewLike__union__sc_GenSeq__scg_CanBuildFrom__O(this, that, bf)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.takeWhile__F1__O = (function(p) {
  return this.takeWhile__F1__sc_TraversableView(p)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.headOption__s_Option = (function() {
  return $f_sc_TraversableViewLike$Transformed__headOption__s_Option(this)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.intersect__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqViewLike__intersect__sc_GenSeq__sc_SeqView(this, that)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.filter__F1__O = (function(p) {
  return this.filter__F1__sc_TraversableView(p)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.reverse__O = (function() {
  return this.reverse__sc_SeqView()
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.size__I = (function() {
  return this.length__I()
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.toBuffer__scm_Buffer = (function() {
  var this$1 = $m_scm_ArrayBuffer$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_scm_Buffer($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.newFlatMapped__F1__sc_TraversableViewLike$Transformed = (function(f) {
  return this.newFlatMapped__F1__sc_SeqViewLike$Transformed(f)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.distinct__O = (function() {
  return $f_sc_SeqViewLike__distinct__sc_SeqView(this)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.$$plus$colon__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqViewLike__$$plus$colon__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.apply$mcZI$sp__I__Z = (function(v1) {
  return $uZ(this.apply__O__O(v1))
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.newTakenWhile__F1__sc_SeqViewLike$Transformed = (function(p) {
  return new $c_sc_SeqViewLike$$anon$9().init___sc_SeqViewLike__F1(this, p)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.find__F1__s_Option = (function(p) {
  var this$1 = this.iterator__sc_Iterator();
  return $f_sc_Iterator__find__F1__s_Option(this$1, p)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.span__F1__T2 = (function(p) {
  return $f_sc_TraversableViewLike__span__F1__T2(this, p)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.diff__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqViewLike__diff__sc_GenSeq__sc_SeqView(this, that)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.dropWhile__F1__sc_TraversableView = (function(p) {
  return $f_sc_TraversableViewLike__dropWhile__F1__sc_TraversableView(this, p)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.newMapped__F1__sc_SeqViewLike$Transformed = (function(f) {
  return new $c_sc_SeqViewLike$$anon$4().init___sc_SeqViewLike__F1(this, f)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.reverse__sc_SeqView = (function() {
  return this.newReversed__sc_SeqViewLike$Transformed()
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.newAppended__sc_GenTraversable__sc_TraversableViewLike$Transformed = (function(that) {
  return this.newAppended__sc_GenTraversable__sc_SeqViewLike$Transformed(that)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.mkString__T = (function() {
  return $f_sc_ViewMkString__mkString__T__T__T__T(this, "", "", "")
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O = (function(xs, bf) {
  return $f_sc_TraversableViewLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, xs, bf)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IterableViewLike__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_TraversableViewLike__filterNot__F1__sc_TraversableView(this, p)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.seq__sc_Seq = (function() {
  return this
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.newZipped__sc_GenIterable__sc_SeqViewLike$Transformed = (function(that) {
  return new $c_sc_SeqViewLike$$anon$10().init___sc_SeqViewLike__sc_GenIterable(this, that)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.sizeHintIfCheap__I = (function() {
  return (-1)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.partition__F1__T2 = (function(p) {
  return $f_sc_TraversableViewLike__partition__F1__T2(this, p)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.newTakenWhile__F1__sc_TraversableViewLike$Transformed = (function(p) {
  return this.newTakenWhile__F1__sc_SeqViewLike$Transformed(p)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.take__I__O = (function(n) {
  return this.take__I__sc_IterableView(n)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.drop__I__sc_IterableView = (function(n) {
  return $f_sc_IterableViewLike__drop__I__sc_IterableView(this, n)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.toStream__sci_Stream = (function() {
  return this.iterator__sc_Iterator().toStream__sci_Stream()
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.last__O = (function() {
  return $f_sc_TraversableViewLike$Transformed__last__O(this)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.view__sc_SeqView = (function() {
  return new $c_sc_SeqLike$$anon$2().init___sc_SeqLike(this)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.drop__I__O = (function(n) {
  return this.drop__I__sc_IterableView(n)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.newMapped__F1__sc_TraversableViewLike$Transformed = (function(f) {
  return this.newMapped__F1__sc_SeqViewLike$Transformed(f)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.contains__O__Z = (function(elem) {
  return $f_sc_SeqLike__contains__O__Z(this, elem)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.tail__O = (function() {
  return this.tail__sc_TraversableView()
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.thisCollection__sc_Seq = (function() {
  return this
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_ViewMkString__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.toTraversable__sc_Traversable = (function() {
  return this.thisCollection__sc_Traversable()
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.sortBy__F1__s_math_Ordering__O = (function(f, ord) {
  return $f_sc_SeqViewLike__sortBy__F1__s_math_Ordering__sc_SeqView(this, f, ord)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.toSeq__sc_Seq = (function() {
  return this.thisCollection__sc_Seq()
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.filter__F1__sc_TraversableView = (function(p) {
  return $f_sc_TraversableViewLike__filter__F1__sc_TraversableView(this, p)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.isDefinedAt__O__Z = (function(x) {
  var idx = $uI(x);
  return $f_sc_GenSeqLike__isDefinedAt__I__Z(this, idx)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.repr__O = (function() {
  return this
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.$$div$colon__O__F2__O = (function(z, op) {
  return this.foldLeft__O__F2__O(z, op)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.newForced__F0__sc_SeqViewLike$Transformed = (function(xs) {
  return new $c_sc_SeqViewLike$$anon$1().init___sc_SeqViewLike__F0(this, xs)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.newSliced__scg_SliceInterval__sc_TraversableViewLike$Transformed = (function(_endpoints) {
  return this.newSliced__scg_SliceInterval__sc_SeqViewLike$Transformed(_endpoints)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.newZipped__sc_GenIterable__sc_IterableViewLike$Transformed = (function(that) {
  return this.newZipped__sc_GenIterable__sc_SeqViewLike$Transformed(that)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return $f_s_PartialFunction__applyOrElse__O__F1__O(this, x, $default)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_sc_IterableLike__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.toSeq__sc_GenSeq = (function() {
  return this.thisCollection__sc_Seq()
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.isTraversableAgain__Z = (function() {
  return true
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.groupBy__F1__sci_Map = (function(f) {
  return $f_sc_TraversableViewLike__groupBy__F1__sci_Map(this, f)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.hashCode__I = (function() {
  return $m_s_util_hashing_MurmurHash3$().seqHash__sc_Seq__I(this.seq__sc_Seq())
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.newFiltered__F1__sc_TraversableViewLike$Transformed = (function(p) {
  return this.newFiltered__F1__sc_SeqViewLike$Transformed(p)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.newAppended__sc_GenTraversable__sc_SeqViewLike$Transformed = (function(that) {
  return new $c_sc_SeqViewLike$$anon$2().init___sc_SeqViewLike__sc_GenTraversable(this, that)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  this.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$1, ev$1) {
    return (function(x$2) {
      return b$1.$$plus$eq__O__scm_Builder(x$2)
    })
  })(this, b, ev)));
  return $as_sci_Map(b.elems$1)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return this.newMapped__F1__sc_TraversableViewLike$Transformed(f)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.segmentLength__F1__I__I = (function(p, from) {
  return $f_sc_SeqLike__segmentLength__F1__I__I(this, p, from)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.newFlatMapped__F1__sc_SeqViewLike$Transformed = (function(f) {
  return new $c_sc_SeqViewLike$$anon$5().init___sc_SeqViewLike__F1(this, f)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_sc_TraversableOnce__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.newDroppedWhile__F1__sc_TraversableViewLike$Transformed = (function(p) {
  return this.newDroppedWhile__F1__sc_SeqViewLike$Transformed(p)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.collect__s_PartialFunction__scg_CanBuildFrom__O = (function(pf, bf) {
  return $f_sc_TraversableViewLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this, pf, bf)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_TraversableOnce__reduceLeft__F2__O(this, op)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.newForced__F0__sc_TraversableViewLike$Transformed = (function(xs) {
  return this.newForced__F0__sc_SeqViewLike$Transformed(xs)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.newBuilder__scm_Builder = (function() {
  return $f_sc_TraversableViewLike__newBuilder__scm_Builder(this)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.stringPrefix__T = (function() {
  return "SeqView"
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.sortWith__F2__O = (function(lt) {
  return $f_sc_SeqViewLike__sortWith__F2__sc_SeqView(this, lt)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.tail__sc_TraversableView = (function() {
  return $f_sc_TraversableViewLike__tail__sc_TraversableView(this)
});
$c_sc_SeqViewLike$AbstractTransformed.prototype.zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return this.newZipped__sc_GenIterable__sc_IterableViewLike$Transformed(that)
});
function $f_sc_SeqViewLike$Zipped__length__I($thiz) {
  return (($thiz.thatSeq__sc_Seq().lengthCompare__I__I($thiz.scala$collection$SeqViewLike$Zipped$$$outer__sc_SeqViewLike().length__I()) <= 0) ? $thiz.thatSeq__sc_Seq().length__I() : $thiz.scala$collection$SeqViewLike$Zipped$$$outer__sc_SeqViewLike().length__I())
}
function $f_sc_SeqViewLike$Zipped__thatSeq__sc_Seq($thiz) {
  return $thiz.other__sc_GenIterable().seq__sc_Iterable().toSeq__sc_Seq()
}
function $f_sc_SeqViewLike$Zipped__apply__I__T2($thiz, idx) {
  return new $c_T2().init___O__O($thiz.scala$collection$SeqViewLike$Zipped$$$outer__sc_SeqViewLike().apply__I__O(idx), $thiz.thatSeq__sc_Seq().apply__I__O(idx))
}
/** @constructor */
function $c_sci_ListSet() {
  $c_sc_AbstractSet.call(this)
}
$c_sci_ListSet.prototype = new $h_sc_AbstractSet();
$c_sci_ListSet.prototype.constructor = $c_sci_ListSet;
/** @constructor */
function $h_sci_ListSet() {
  /*<skip>*/
}
$h_sci_ListSet.prototype = $c_sci_ListSet.prototype;
$c_sci_ListSet.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sci_ListSet.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_sci_ListSet.prototype.next__sci_ListSet = (function() {
  throw new $c_ju_NoSuchElementException().init___T("next of empty set")
});
$c_sci_ListSet.prototype.apply__O__O = (function(v1) {
  return this.contains__O__Z(v1)
});
$c_sci_ListSet.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return this.$$minus__O__sci_ListSet(elem)
});
$c_sci_ListSet.prototype.isEmpty__Z = (function() {
  return true
});
$c_sci_ListSet.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sci_ListSet.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_ListSet.prototype.$$plus__O__sci_ListSet = (function(elem) {
  return new $c_sci_ListSet$Node().init___sci_ListSet__O(this, elem)
});
$c_sci_ListSet.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sci_ListSet$()
});
$c_sci_ListSet.prototype.size__I = (function() {
  return 0
});
$c_sci_ListSet.prototype.iterator__sc_Iterator = (function() {
  var this$1 = this.reverseList$1__p4__sci_List();
  return new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$1)
});
$c_sci_ListSet.prototype.$$minus__O__sc_Set = (function(elem) {
  return this.$$minus__O__sci_ListSet(elem)
});
$c_sci_ListSet.prototype.empty__sc_Set = (function() {
  return $m_sci_ListSet$EmptyListSet$()
});
$c_sci_ListSet.prototype.reverseList$1__p4__sci_List = (function() {
  var curr = this;
  var res = $m_sci_Nil$();
  while ((!curr.isEmpty__Z())) {
    var x$4 = curr.elem__O();
    var this$1 = res;
    res = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$1);
    curr = curr.next__sci_ListSet()
  };
  return res
});
$c_sci_ListSet.prototype.seq__sc_Set = (function() {
  return this
});
$c_sci_ListSet.prototype.elem__O = (function() {
  throw new $c_ju_NoSuchElementException().init___T("elem of empty set")
});
$c_sci_ListSet.prototype.contains__O__Z = (function(elem) {
  return false
});
$c_sci_ListSet.prototype.$$plus$plus__sc_GenTraversableOnce__sci_ListSet = (function(xs) {
  return (xs.isEmpty__Z() ? this : $as_sci_ListSet(xs.$$div$colon__O__F2__O(this, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(x$2$2, x$3$2) {
      var x$2 = $as_sci_ListSet(x$2$2);
      return x$2.$$plus__O__sci_ListSet(x$3$2)
    })
  })(this)))))
});
$c_sci_ListSet.prototype.toSet__sci_Set = (function() {
  return this
});
$c_sci_ListSet.prototype.$$minus__O__sci_ListSet = (function(elem) {
  return this
});
$c_sci_ListSet.prototype.toSeq__sc_GenSeq = (function() {
  return $f_sc_SetLike__toSeq__sc_Seq(this)
});
$c_sci_ListSet.prototype.$$plus__O__sc_Set = (function(elem) {
  return this.$$plus__O__sci_ListSet(elem)
});
$c_sci_ListSet.prototype.$$plus$plus__sc_GenTraversableOnce__sc_Set = (function(elems) {
  return this.$$plus$plus__sc_GenTraversableOnce__sci_ListSet(elems)
});
$c_sci_ListSet.prototype.stringPrefix__T = (function() {
  return "ListSet"
});
function $as_sci_ListSet(obj) {
  return (((obj instanceof $c_sci_ListSet) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.ListSet"))
}
function $isArrayOf_sci_ListSet(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_ListSet)))
}
function $asArrayOf_sci_ListSet(obj, depth) {
  return (($isArrayOf_sci_ListSet(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.ListSet;", depth))
}
/** @constructor */
function $c_sci_Set$EmptySet$() {
  $c_sc_AbstractSet.call(this)
}
$c_sci_Set$EmptySet$.prototype = new $h_sc_AbstractSet();
$c_sci_Set$EmptySet$.prototype.constructor = $c_sci_Set$EmptySet$;
/** @constructor */
function $h_sci_Set$EmptySet$() {
  /*<skip>*/
}
$h_sci_Set$EmptySet$.prototype = $c_sci_Set$EmptySet$.prototype;
$c_sci_Set$EmptySet$.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sci_Set$EmptySet$.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_sci_Set$EmptySet$.prototype.init___ = (function() {
  return this
});
$c_sci_Set$EmptySet$.prototype.apply__O__O = (function(v1) {
  return false
});
$c_sci_Set$EmptySet$.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return this
});
$c_sci_Set$EmptySet$.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sci_Set$EmptySet$.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_Set$EmptySet$.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sci_Set$()
});
$c_sci_Set$EmptySet$.prototype.foreach__F1__V = (function(f) {
  /*<skip>*/
});
$c_sci_Set$EmptySet$.prototype.size__I = (function() {
  return 0
});
$c_sci_Set$EmptySet$.prototype.iterator__sc_Iterator = (function() {
  return $m_sc_Iterator$().empty$1
});
$c_sci_Set$EmptySet$.prototype.$$minus__O__sc_Set = (function(elem) {
  return this
});
$c_sci_Set$EmptySet$.prototype.empty__sc_Set = (function() {
  return $m_sci_Set$EmptySet$()
});
$c_sci_Set$EmptySet$.prototype.seq__sc_Set = (function() {
  return this
});
$c_sci_Set$EmptySet$.prototype.contains__O__Z = (function(elem) {
  return false
});
$c_sci_Set$EmptySet$.prototype.toSet__sci_Set = (function() {
  return this
});
$c_sci_Set$EmptySet$.prototype.toSeq__sc_GenSeq = (function() {
  return $f_sc_SetLike__toSeq__sc_Seq(this)
});
$c_sci_Set$EmptySet$.prototype.$$plus__O__sc_Set = (function(elem) {
  return new $c_sci_Set$Set1().init___O(elem)
});
var $d_sci_Set$EmptySet$ = new $TypeData().initClass({
  sci_Set$EmptySet$: 0
}, false, "scala.collection.immutable.Set$EmptySet$", {
  sci_Set$EmptySet$: 1,
  sc_AbstractSet: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Set: 1,
  F1: 1,
  sc_GenSet: 1,
  sc_GenSetLike: 1,
  scg_GenericSetTemplate: 1,
  sc_SetLike: 1,
  scg_Subtractable: 1,
  sci_Set: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_Set$EmptySet$.prototype.$classData = $d_sci_Set$EmptySet$;
var $n_sci_Set$EmptySet$ = (void 0);
function $m_sci_Set$EmptySet$() {
  if ((!$n_sci_Set$EmptySet$)) {
    $n_sci_Set$EmptySet$ = new $c_sci_Set$EmptySet$().init___()
  };
  return $n_sci_Set$EmptySet$
}
/** @constructor */
function $c_sci_Set$Set1() {
  $c_sc_AbstractSet.call(this);
  this.elem1$4 = null
}
$c_sci_Set$Set1.prototype = new $h_sc_AbstractSet();
$c_sci_Set$Set1.prototype.constructor = $c_sci_Set$Set1;
/** @constructor */
function $h_sci_Set$Set1() {
  /*<skip>*/
}
$h_sci_Set$Set1.prototype = $c_sci_Set$Set1.prototype;
$c_sci_Set$Set1.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sci_Set$Set1.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_sci_Set$Set1.prototype.head__O = (function() {
  return this.elem1$4
});
$c_sci_Set$Set1.prototype.apply__O__O = (function(v1) {
  return this.contains__O__Z(v1)
});
$c_sci_Set$Set1.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return this.$$minus__O__sci_Set(elem)
});
$c_sci_Set$Set1.prototype.exists__F1__Z = (function(p) {
  return $uZ(p.apply__O__O(this.elem1$4))
});
$c_sci_Set$Set1.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sci_Set$Set1.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_Set$Set1.prototype.forall__F1__Z = (function(p) {
  return $uZ(p.apply__O__O(this.elem1$4))
});
$c_sci_Set$Set1.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sci_Set$()
});
$c_sci_Set$Set1.prototype.foreach__F1__V = (function(f) {
  f.apply__O__O(this.elem1$4)
});
$c_sci_Set$Set1.prototype.size__I = (function() {
  return 1
});
$c_sci_Set$Set1.prototype.init___O = (function(elem1) {
  this.elem1$4 = elem1;
  return this
});
$c_sci_Set$Set1.prototype.iterator__sc_Iterator = (function() {
  $m_sc_Iterator$();
  var array = [this.elem1$4];
  var elems = new $c_sjs_js_WrappedArray().init___sjs_js_Array(array);
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(elems, 0, $uI(elems.array$6.length))
});
$c_sci_Set$Set1.prototype.$$minus__O__sc_Set = (function(elem) {
  return this.$$minus__O__sci_Set(elem)
});
$c_sci_Set$Set1.prototype.find__F1__s_Option = (function(p) {
  return ($uZ(p.apply__O__O(this.elem1$4)) ? new $c_s_Some().init___O(this.elem1$4) : $m_s_None$())
});
$c_sci_Set$Set1.prototype.empty__sc_Set = (function() {
  return $m_sci_Set$EmptySet$()
});
$c_sci_Set$Set1.prototype.$$plus__O__sci_Set = (function(elem) {
  return (this.contains__O__Z(elem) ? this : new $c_sci_Set$Set2().init___O__O(this.elem1$4, elem))
});
$c_sci_Set$Set1.prototype.seq__sc_Set = (function() {
  return this
});
$c_sci_Set$Set1.prototype.tail__O = (function() {
  return $m_sci_Set$EmptySet$()
});
$c_sci_Set$Set1.prototype.contains__O__Z = (function(elem) {
  return $m_sr_BoxesRunTime$().equals__O__O__Z(elem, this.elem1$4)
});
$c_sci_Set$Set1.prototype.toSet__sci_Set = (function() {
  return this
});
$c_sci_Set$Set1.prototype.toSeq__sc_GenSeq = (function() {
  return $f_sc_SetLike__toSeq__sc_Seq(this)
});
$c_sci_Set$Set1.prototype.$$plus__O__sc_Set = (function(elem) {
  return this.$$plus__O__sci_Set(elem)
});
$c_sci_Set$Set1.prototype.$$minus__O__sci_Set = (function(elem) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(elem, this.elem1$4) ? $m_sci_Set$EmptySet$() : this)
});
var $d_sci_Set$Set1 = new $TypeData().initClass({
  sci_Set$Set1: 0
}, false, "scala.collection.immutable.Set$Set1", {
  sci_Set$Set1: 1,
  sc_AbstractSet: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Set: 1,
  F1: 1,
  sc_GenSet: 1,
  sc_GenSetLike: 1,
  scg_GenericSetTemplate: 1,
  sc_SetLike: 1,
  scg_Subtractable: 1,
  sci_Set: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_Set$Set1.prototype.$classData = $d_sci_Set$Set1;
/** @constructor */
function $c_sci_Set$Set2() {
  $c_sc_AbstractSet.call(this);
  this.elem1$4 = null;
  this.elem2$4 = null
}
$c_sci_Set$Set2.prototype = new $h_sc_AbstractSet();
$c_sci_Set$Set2.prototype.constructor = $c_sci_Set$Set2;
/** @constructor */
function $h_sci_Set$Set2() {
  /*<skip>*/
}
$h_sci_Set$Set2.prototype = $c_sci_Set$Set2.prototype;
$c_sci_Set$Set2.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sci_Set$Set2.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_sci_Set$Set2.prototype.head__O = (function() {
  return this.elem1$4
});
$c_sci_Set$Set2.prototype.apply__O__O = (function(v1) {
  return this.contains__O__Z(v1)
});
$c_sci_Set$Set2.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return this.$$minus__O__sci_Set(elem)
});
$c_sci_Set$Set2.prototype.exists__F1__Z = (function(p) {
  return ($uZ(p.apply__O__O(this.elem1$4)) || $uZ(p.apply__O__O(this.elem2$4)))
});
$c_sci_Set$Set2.prototype.tail__sci_Set = (function() {
  return new $c_sci_Set$Set1().init___O(this.elem2$4)
});
$c_sci_Set$Set2.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sci_Set$Set2.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_Set$Set2.prototype.init___O__O = (function(elem1, elem2) {
  this.elem1$4 = elem1;
  this.elem2$4 = elem2;
  return this
});
$c_sci_Set$Set2.prototype.forall__F1__Z = (function(p) {
  return ($uZ(p.apply__O__O(this.elem1$4)) && $uZ(p.apply__O__O(this.elem2$4)))
});
$c_sci_Set$Set2.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sci_Set$()
});
$c_sci_Set$Set2.prototype.foreach__F1__V = (function(f) {
  f.apply__O__O(this.elem1$4);
  f.apply__O__O(this.elem2$4)
});
$c_sci_Set$Set2.prototype.size__I = (function() {
  return 2
});
$c_sci_Set$Set2.prototype.iterator__sc_Iterator = (function() {
  $m_sc_Iterator$();
  var array = [this.elem1$4, this.elem2$4];
  var elems = new $c_sjs_js_WrappedArray().init___sjs_js_Array(array);
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(elems, 0, $uI(elems.array$6.length))
});
$c_sci_Set$Set2.prototype.$$minus__O__sc_Set = (function(elem) {
  return this.$$minus__O__sci_Set(elem)
});
$c_sci_Set$Set2.prototype.find__F1__s_Option = (function(p) {
  return ($uZ(p.apply__O__O(this.elem1$4)) ? new $c_s_Some().init___O(this.elem1$4) : ($uZ(p.apply__O__O(this.elem2$4)) ? new $c_s_Some().init___O(this.elem2$4) : $m_s_None$()))
});
$c_sci_Set$Set2.prototype.empty__sc_Set = (function() {
  return $m_sci_Set$EmptySet$()
});
$c_sci_Set$Set2.prototype.$$plus__O__sci_Set = (function(elem) {
  return (this.contains__O__Z(elem) ? this : new $c_sci_Set$Set3().init___O__O__O(this.elem1$4, this.elem2$4, elem))
});
$c_sci_Set$Set2.prototype.seq__sc_Set = (function() {
  return this
});
$c_sci_Set$Set2.prototype.tail__O = (function() {
  return this.tail__sci_Set()
});
$c_sci_Set$Set2.prototype.contains__O__Z = (function(elem) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(elem, this.elem1$4) || $m_sr_BoxesRunTime$().equals__O__O__Z(elem, this.elem2$4))
});
$c_sci_Set$Set2.prototype.toSet__sci_Set = (function() {
  return this
});
$c_sci_Set$Set2.prototype.toSeq__sc_GenSeq = (function() {
  return $f_sc_SetLike__toSeq__sc_Seq(this)
});
$c_sci_Set$Set2.prototype.$$plus__O__sc_Set = (function(elem) {
  return this.$$plus__O__sci_Set(elem)
});
$c_sci_Set$Set2.prototype.$$minus__O__sci_Set = (function(elem) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(elem, this.elem1$4) ? new $c_sci_Set$Set1().init___O(this.elem2$4) : ($m_sr_BoxesRunTime$().equals__O__O__Z(elem, this.elem2$4) ? new $c_sci_Set$Set1().init___O(this.elem1$4) : this))
});
var $d_sci_Set$Set2 = new $TypeData().initClass({
  sci_Set$Set2: 0
}, false, "scala.collection.immutable.Set$Set2", {
  sci_Set$Set2: 1,
  sc_AbstractSet: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Set: 1,
  F1: 1,
  sc_GenSet: 1,
  sc_GenSetLike: 1,
  scg_GenericSetTemplate: 1,
  sc_SetLike: 1,
  scg_Subtractable: 1,
  sci_Set: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_Set$Set2.prototype.$classData = $d_sci_Set$Set2;
/** @constructor */
function $c_sci_Set$Set3() {
  $c_sc_AbstractSet.call(this);
  this.elem1$4 = null;
  this.elem2$4 = null;
  this.elem3$4 = null
}
$c_sci_Set$Set3.prototype = new $h_sc_AbstractSet();
$c_sci_Set$Set3.prototype.constructor = $c_sci_Set$Set3;
/** @constructor */
function $h_sci_Set$Set3() {
  /*<skip>*/
}
$h_sci_Set$Set3.prototype = $c_sci_Set$Set3.prototype;
$c_sci_Set$Set3.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sci_Set$Set3.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_sci_Set$Set3.prototype.head__O = (function() {
  return this.elem1$4
});
$c_sci_Set$Set3.prototype.apply__O__O = (function(v1) {
  return this.contains__O__Z(v1)
});
$c_sci_Set$Set3.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return this.$$minus__O__sci_Set(elem)
});
$c_sci_Set$Set3.prototype.exists__F1__Z = (function(p) {
  return (($uZ(p.apply__O__O(this.elem1$4)) || $uZ(p.apply__O__O(this.elem2$4))) || $uZ(p.apply__O__O(this.elem3$4)))
});
$c_sci_Set$Set3.prototype.tail__sci_Set = (function() {
  return new $c_sci_Set$Set2().init___O__O(this.elem2$4, this.elem3$4)
});
$c_sci_Set$Set3.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sci_Set$Set3.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_Set$Set3.prototype.forall__F1__Z = (function(p) {
  return (($uZ(p.apply__O__O(this.elem1$4)) && $uZ(p.apply__O__O(this.elem2$4))) && $uZ(p.apply__O__O(this.elem3$4)))
});
$c_sci_Set$Set3.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sci_Set$()
});
$c_sci_Set$Set3.prototype.foreach__F1__V = (function(f) {
  f.apply__O__O(this.elem1$4);
  f.apply__O__O(this.elem2$4);
  f.apply__O__O(this.elem3$4)
});
$c_sci_Set$Set3.prototype.size__I = (function() {
  return 3
});
$c_sci_Set$Set3.prototype.init___O__O__O = (function(elem1, elem2, elem3) {
  this.elem1$4 = elem1;
  this.elem2$4 = elem2;
  this.elem3$4 = elem3;
  return this
});
$c_sci_Set$Set3.prototype.iterator__sc_Iterator = (function() {
  $m_sc_Iterator$();
  var array = [this.elem1$4, this.elem2$4, this.elem3$4];
  var elems = new $c_sjs_js_WrappedArray().init___sjs_js_Array(array);
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(elems, 0, $uI(elems.array$6.length))
});
$c_sci_Set$Set3.prototype.$$minus__O__sc_Set = (function(elem) {
  return this.$$minus__O__sci_Set(elem)
});
$c_sci_Set$Set3.prototype.find__F1__s_Option = (function(p) {
  return ($uZ(p.apply__O__O(this.elem1$4)) ? new $c_s_Some().init___O(this.elem1$4) : ($uZ(p.apply__O__O(this.elem2$4)) ? new $c_s_Some().init___O(this.elem2$4) : ($uZ(p.apply__O__O(this.elem3$4)) ? new $c_s_Some().init___O(this.elem3$4) : $m_s_None$())))
});
$c_sci_Set$Set3.prototype.empty__sc_Set = (function() {
  return $m_sci_Set$EmptySet$()
});
$c_sci_Set$Set3.prototype.$$plus__O__sci_Set = (function(elem) {
  return (this.contains__O__Z(elem) ? this : new $c_sci_Set$Set4().init___O__O__O__O(this.elem1$4, this.elem2$4, this.elem3$4, elem))
});
$c_sci_Set$Set3.prototype.seq__sc_Set = (function() {
  return this
});
$c_sci_Set$Set3.prototype.tail__O = (function() {
  return this.tail__sci_Set()
});
$c_sci_Set$Set3.prototype.contains__O__Z = (function(elem) {
  return (($m_sr_BoxesRunTime$().equals__O__O__Z(elem, this.elem1$4) || $m_sr_BoxesRunTime$().equals__O__O__Z(elem, this.elem2$4)) || $m_sr_BoxesRunTime$().equals__O__O__Z(elem, this.elem3$4))
});
$c_sci_Set$Set3.prototype.toSet__sci_Set = (function() {
  return this
});
$c_sci_Set$Set3.prototype.toSeq__sc_GenSeq = (function() {
  return $f_sc_SetLike__toSeq__sc_Seq(this)
});
$c_sci_Set$Set3.prototype.$$plus__O__sc_Set = (function(elem) {
  return this.$$plus__O__sci_Set(elem)
});
$c_sci_Set$Set3.prototype.$$minus__O__sci_Set = (function(elem) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(elem, this.elem1$4) ? new $c_sci_Set$Set2().init___O__O(this.elem2$4, this.elem3$4) : ($m_sr_BoxesRunTime$().equals__O__O__Z(elem, this.elem2$4) ? new $c_sci_Set$Set2().init___O__O(this.elem1$4, this.elem3$4) : ($m_sr_BoxesRunTime$().equals__O__O__Z(elem, this.elem3$4) ? new $c_sci_Set$Set2().init___O__O(this.elem1$4, this.elem2$4) : this)))
});
var $d_sci_Set$Set3 = new $TypeData().initClass({
  sci_Set$Set3: 0
}, false, "scala.collection.immutable.Set$Set3", {
  sci_Set$Set3: 1,
  sc_AbstractSet: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Set: 1,
  F1: 1,
  sc_GenSet: 1,
  sc_GenSetLike: 1,
  scg_GenericSetTemplate: 1,
  sc_SetLike: 1,
  scg_Subtractable: 1,
  sci_Set: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_Set$Set3.prototype.$classData = $d_sci_Set$Set3;
/** @constructor */
function $c_sci_Set$Set4() {
  $c_sc_AbstractSet.call(this);
  this.elem1$4 = null;
  this.elem2$4 = null;
  this.elem3$4 = null;
  this.elem4$4 = null
}
$c_sci_Set$Set4.prototype = new $h_sc_AbstractSet();
$c_sci_Set$Set4.prototype.constructor = $c_sci_Set$Set4;
/** @constructor */
function $h_sci_Set$Set4() {
  /*<skip>*/
}
$h_sci_Set$Set4.prototype = $c_sci_Set$Set4.prototype;
$c_sci_Set$Set4.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sci_Set$Set4.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_sci_Set$Set4.prototype.head__O = (function() {
  return this.elem1$4
});
$c_sci_Set$Set4.prototype.apply__O__O = (function(v1) {
  return this.contains__O__Z(v1)
});
$c_sci_Set$Set4.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return this.$$minus__O__sci_Set(elem)
});
$c_sci_Set$Set4.prototype.exists__F1__Z = (function(p) {
  return ((($uZ(p.apply__O__O(this.elem1$4)) || $uZ(p.apply__O__O(this.elem2$4))) || $uZ(p.apply__O__O(this.elem3$4))) || $uZ(p.apply__O__O(this.elem4$4)))
});
$c_sci_Set$Set4.prototype.tail__sci_Set = (function() {
  return new $c_sci_Set$Set3().init___O__O__O(this.elem2$4, this.elem3$4, this.elem4$4)
});
$c_sci_Set$Set4.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sci_Set$Set4.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_Set$Set4.prototype.forall__F1__Z = (function(p) {
  return ((($uZ(p.apply__O__O(this.elem1$4)) && $uZ(p.apply__O__O(this.elem2$4))) && $uZ(p.apply__O__O(this.elem3$4))) && $uZ(p.apply__O__O(this.elem4$4)))
});
$c_sci_Set$Set4.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sci_Set$()
});
$c_sci_Set$Set4.prototype.foreach__F1__V = (function(f) {
  f.apply__O__O(this.elem1$4);
  f.apply__O__O(this.elem2$4);
  f.apply__O__O(this.elem3$4);
  f.apply__O__O(this.elem4$4)
});
$c_sci_Set$Set4.prototype.size__I = (function() {
  return 4
});
$c_sci_Set$Set4.prototype.iterator__sc_Iterator = (function() {
  $m_sc_Iterator$();
  var array = [this.elem1$4, this.elem2$4, this.elem3$4, this.elem4$4];
  var elems = new $c_sjs_js_WrappedArray().init___sjs_js_Array(array);
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(elems, 0, $uI(elems.array$6.length))
});
$c_sci_Set$Set4.prototype.$$minus__O__sc_Set = (function(elem) {
  return this.$$minus__O__sci_Set(elem)
});
$c_sci_Set$Set4.prototype.find__F1__s_Option = (function(p) {
  return ($uZ(p.apply__O__O(this.elem1$4)) ? new $c_s_Some().init___O(this.elem1$4) : ($uZ(p.apply__O__O(this.elem2$4)) ? new $c_s_Some().init___O(this.elem2$4) : ($uZ(p.apply__O__O(this.elem3$4)) ? new $c_s_Some().init___O(this.elem3$4) : ($uZ(p.apply__O__O(this.elem4$4)) ? new $c_s_Some().init___O(this.elem4$4) : $m_s_None$()))))
});
$c_sci_Set$Set4.prototype.empty__sc_Set = (function() {
  return $m_sci_Set$EmptySet$()
});
$c_sci_Set$Set4.prototype.$$plus__O__sci_Set = (function(elem) {
  return (this.contains__O__Z(elem) ? this : new $c_sci_HashSet().init___().$$plus__O__sci_HashSet(this.elem1$4).$$plus__O__sci_HashSet(this.elem2$4).$$plus__O__sci_HashSet(this.elem3$4).$$plus__O__sci_HashSet(this.elem4$4).$$plus__O__sci_HashSet(elem))
});
$c_sci_Set$Set4.prototype.seq__sc_Set = (function() {
  return this
});
$c_sci_Set$Set4.prototype.tail__O = (function() {
  return this.tail__sci_Set()
});
$c_sci_Set$Set4.prototype.contains__O__Z = (function(elem) {
  return ((($m_sr_BoxesRunTime$().equals__O__O__Z(elem, this.elem1$4) || $m_sr_BoxesRunTime$().equals__O__O__Z(elem, this.elem2$4)) || $m_sr_BoxesRunTime$().equals__O__O__Z(elem, this.elem3$4)) || $m_sr_BoxesRunTime$().equals__O__O__Z(elem, this.elem4$4))
});
$c_sci_Set$Set4.prototype.init___O__O__O__O = (function(elem1, elem2, elem3, elem4) {
  this.elem1$4 = elem1;
  this.elem2$4 = elem2;
  this.elem3$4 = elem3;
  this.elem4$4 = elem4;
  return this
});
$c_sci_Set$Set4.prototype.toSet__sci_Set = (function() {
  return this
});
$c_sci_Set$Set4.prototype.toSeq__sc_GenSeq = (function() {
  return $f_sc_SetLike__toSeq__sc_Seq(this)
});
$c_sci_Set$Set4.prototype.$$plus__O__sc_Set = (function(elem) {
  return this.$$plus__O__sci_Set(elem)
});
$c_sci_Set$Set4.prototype.$$minus__O__sci_Set = (function(elem) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(elem, this.elem1$4) ? new $c_sci_Set$Set3().init___O__O__O(this.elem2$4, this.elem3$4, this.elem4$4) : ($m_sr_BoxesRunTime$().equals__O__O__Z(elem, this.elem2$4) ? new $c_sci_Set$Set3().init___O__O__O(this.elem1$4, this.elem3$4, this.elem4$4) : ($m_sr_BoxesRunTime$().equals__O__O__Z(elem, this.elem3$4) ? new $c_sci_Set$Set3().init___O__O__O(this.elem1$4, this.elem2$4, this.elem4$4) : ($m_sr_BoxesRunTime$().equals__O__O__Z(elem, this.elem4$4) ? new $c_sci_Set$Set3().init___O__O__O(this.elem1$4, this.elem2$4, this.elem3$4) : this))))
});
var $d_sci_Set$Set4 = new $TypeData().initClass({
  sci_Set$Set4: 0
}, false, "scala.collection.immutable.Set$Set4", {
  sci_Set$Set4: 1,
  sc_AbstractSet: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Set: 1,
  F1: 1,
  sc_GenSet: 1,
  sc_GenSetLike: 1,
  scg_GenericSetTemplate: 1,
  sc_SetLike: 1,
  scg_Subtractable: 1,
  sci_Set: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_Set$Set4.prototype.$classData = $d_sci_Set$Set4;
function $f_sc_SeqViewLike$Appended__apply__I__O($thiz, idx) {
  return ((idx < $thiz.scala$collection$SeqViewLike$Appended$$$outer__sc_SeqViewLike().length__I()) ? $thiz.scala$collection$SeqViewLike$Appended$$$outer__sc_SeqViewLike().apply__I__O(idx) : $thiz.restSeq__sc_GenSeq().apply__I__O(((idx - $thiz.scala$collection$SeqViewLike$Appended$$$outer__sc_SeqViewLike().length__I()) | 0)))
}
function $f_sc_SeqViewLike$Appended__length__I($thiz) {
  return (($thiz.scala$collection$SeqViewLike$Appended$$$outer__sc_SeqViewLike().length__I() + $thiz.restSeq__sc_GenSeq().length__I()) | 0)
}
function $f_sc_SeqViewLike$DroppedWhile__apply__I__O($thiz, idx) {
  if ((idx >= 0)) {
    return $thiz.scala$collection$SeqViewLike$DroppedWhile$$$outer__sc_SeqViewLike().apply__I__O(((idx + $thiz.start__I()) | 0))
  } else {
    throw new $c_jl_IndexOutOfBoundsException().init___T(("" + idx))
  }
}
function $f_sc_SeqViewLike$DroppedWhile__length__I($thiz) {
  return (($thiz.scala$collection$SeqViewLike$DroppedWhile$$$outer__sc_SeqViewLike().length__I() - $thiz.start__I()) | 0)
}
function $f_sc_SeqViewLike$Filtered__apply__I__O($thiz, idx) {
  return $thiz.scala$collection$SeqViewLike$Filtered$$$outer__sc_SeqViewLike().apply__I__O($thiz.index__AI().get(idx))
}
function $f_sc_SeqViewLike$Filtered__length__I($thiz) {
  return $thiz.index__AI().u.length
}
function $f_sc_SeqViewLike$Filtered__index__AI($thiz) {
  var elem$1 = 0;
  elem$1 = 0;
  var arr = $newArrayObject($d_I.getArrayOf(), [$thiz.scala$collection$SeqViewLike$Filtered$$$outer__sc_SeqViewLike().length__I()]);
  var end = $thiz.scala$collection$SeqViewLike$Filtered$$$outer__sc_SeqViewLike().length__I();
  var isEmpty$4 = (end <= 0);
  var scala$collection$immutable$Range$$lastElement$4 = (((-1) + end) | 0);
  if ((!isEmpty$4)) {
    var i = 0;
    while (true) {
      var v1 = i;
      if ($uZ($thiz.pred__F1().apply__O__O($thiz.scala$collection$SeqViewLike$Filtered$$$outer__sc_SeqViewLike().apply__I__O(v1)))) {
        arr.set(elem$1, v1);
        elem$1 = ((1 + elem$1) | 0)
      };
      if ((i === scala$collection$immutable$Range$$lastElement$4)) {
        break
      };
      i = ((1 + i) | 0)
    }
  };
  var n = elem$1;
  var x = ((n > 0) ? n : 0);
  var y = arr.u.length;
  var hi$2 = ((x < y) ? x : y);
  var size = ((hi$2 > 0) ? hi$2 : 0);
  var result = $newArrayObject($d_I.getArrayOf(), [size]);
  if ((size > 0)) {
    $m_s_Array$().copy__O__I__O__I__I__V(arr, 0, result, 0, size)
  };
  return result
}
function $f_sc_SeqViewLike$FlatMapped__apply__I__O($thiz, idx) {
  if (((idx < 0) || (idx >= $f_sc_SeqViewLike$FlatMapped__length__I($thiz)))) {
    throw new $c_jl_IndexOutOfBoundsException().init___T(("" + idx))
  };
  var hi = (((-1) + $thiz.scala$collection$SeqViewLike$FlatMapped$$$outer__sc_SeqViewLike().length__I()) | 0);
  var row = $f_sc_SeqViewLike$FlatMapped__findRow__I__I__I__I($thiz, idx, 0, hi);
  return $as_sc_GenTraversableOnce($thiz.mapping__F1().apply__O__O($thiz.scala$collection$SeqViewLike$FlatMapped$$$outer__sc_SeqViewLike().apply__I__O(row))).seq__sc_TraversableOnce().toSeq__sc_Seq().apply__I__O(((idx - $thiz.index__AI().get(row)) | 0))
}
function $f_sc_SeqViewLike$FlatMapped__length__I($thiz) {
  return $thiz.index__AI().get($thiz.scala$collection$SeqViewLike$FlatMapped$$$outer__sc_SeqViewLike().length__I())
}
function $f_sc_SeqViewLike$FlatMapped__findRow__I__I__I__I($thiz, idx, lo, hi) {
  var mid = ((((lo + hi) | 0) / 2) | 0);
  if ((idx < $thiz.index__AI().get(mid))) {
    var hi$1 = (((-1) + mid) | 0);
    return $f_sc_SeqViewLike$FlatMapped__findRow__I__I__I__I($thiz, idx, lo, hi$1)
  } else if ((idx >= $thiz.index__AI().get(((1 + mid) | 0)))) {
    var lo$1 = ((1 + mid) | 0);
    return $f_sc_SeqViewLike$FlatMapped__findRow__I__I__I__I($thiz, idx, lo$1, hi)
  } else {
    return mid
  }
}
function $f_sc_SeqViewLike$FlatMapped__index__AI($thiz) {
  var index = $newArrayObject($d_I.getArrayOf(), [((1 + $thiz.scala$collection$SeqViewLike$FlatMapped$$$outer__sc_SeqViewLike().length__I()) | 0)]);
  index.set(0, 0);
  var end = $thiz.scala$collection$SeqViewLike$FlatMapped$$$outer__sc_SeqViewLike().length__I();
  var isEmpty$4 = (end <= 0);
  var scala$collection$immutable$Range$$lastElement$4 = (((-1) + end) | 0);
  if ((!isEmpty$4)) {
    var i = 0;
    while (true) {
      var v1 = i;
      index.set(((1 + v1) | 0), ((index.get(v1) + $as_sc_GenTraversableOnce($thiz.mapping__F1().apply__O__O($thiz.scala$collection$SeqViewLike$FlatMapped$$$outer__sc_SeqViewLike().apply__I__O(v1))).seq__sc_TraversableOnce().size__I()) | 0));
      if ((i === scala$collection$immutable$Range$$lastElement$4)) {
        break
      };
      i = ((1 + i) | 0)
    }
  };
  return index
}
function $f_sc_SeqViewLike$Mapped__apply__I__O($thiz, idx) {
  return $thiz.mapping__F1().apply__O__O($thiz.scala$collection$SeqViewLike$Mapped$$$outer__sc_SeqViewLike().apply__I__O(idx))
}
function $f_sc_SeqViewLike$Prepended__apply__I__O($thiz, idx) {
  return ((idx < $thiz.fstSeq__sc_GenSeq().length__I()) ? $thiz.fstSeq__sc_GenSeq().apply__I__O(idx) : $thiz.scala$collection$SeqViewLike$Prepended$$$outer__sc_SeqViewLike().apply__I__O(((idx - $thiz.fstSeq__sc_GenSeq().length__I()) | 0)))
}
function $f_sc_SeqViewLike$Prepended__length__I($thiz) {
  return (($thiz.fstSeq__sc_GenSeq().length__I() + $thiz.scala$collection$SeqViewLike$Prepended$$$outer__sc_SeqViewLike().length__I()) | 0)
}
function $f_sc_SeqViewLike$Sliced__apply__I__O($thiz, idx) {
  if (((idx >= 0) && (((idx + $thiz.endpoints__scg_SliceInterval().from$1) | 0) < $thiz.endpoints__scg_SliceInterval().until$1))) {
    return $thiz.scala$collection$SeqViewLike$Sliced$$$outer__sc_SeqViewLike().apply__I__O(((idx + $thiz.endpoints__scg_SliceInterval().from$1) | 0))
  } else {
    throw new $c_jl_IndexOutOfBoundsException().init___T(("" + idx))
  }
}
function $f_sc_SeqViewLike$Sliced__iterator__sc_Iterator($thiz) {
  return $thiz.scala$collection$SeqViewLike$Sliced$$$outer__sc_SeqViewLike().iterator__sc_Iterator().drop__I__sc_Iterator($thiz.endpoints__scg_SliceInterval().from$1).take__I__sc_Iterator($thiz.endpoints__scg_SliceInterval().width__I())
}
function $f_sc_SeqViewLike$TakenWhile__apply__I__O($thiz, idx) {
  if ((idx < $thiz.len__I())) {
    return $thiz.scala$collection$SeqViewLike$TakenWhile$$$outer__sc_SeqViewLike().apply__I__O(idx)
  } else {
    throw new $c_jl_IndexOutOfBoundsException().init___T(("" + idx))
  }
}
/** @constructor */
function $c_sci_HashSet() {
  $c_sc_AbstractSet.call(this)
}
$c_sci_HashSet.prototype = new $h_sc_AbstractSet();
$c_sci_HashSet.prototype.constructor = $c_sci_HashSet;
/** @constructor */
function $h_sci_HashSet() {
  /*<skip>*/
}
$h_sci_HashSet.prototype = $c_sci_HashSet.prototype;
$c_sci_HashSet.prototype.diff__sc_GenSet__sci_HashSet = (function(that) {
  if ((that instanceof $c_sci_HashSet)) {
    var x2 = $as_sci_HashSet(that);
    var size = this.size__I();
    var x = ((6 + size) | 0);
    var buffer = $newArrayObject($d_sci_HashSet.getArrayOf(), [((x < 224) ? x : 224)]);
    var s = this.diff0__sci_HashSet__I__Asci_HashSet__I__sci_HashSet(x2, 0, buffer, 0);
    return ((s === null) ? $m_sci_HashSet$EmptyHashSet$() : s)
  } else {
    return $as_sci_HashSet($as_sc_Set($f_scg_Subtractable__$$minus$minus__sc_GenTraversableOnce__scg_Subtractable(this, that)))
  }
});
$c_sci_HashSet.prototype.updated0__O__I__I__sci_HashSet = (function(key, hash, level) {
  return new $c_sci_HashSet$HashSet1().init___O__I(key, hash)
});
$c_sci_HashSet.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sci_HashSet.prototype.computeHash__O__I = (function(key) {
  return this.improve__I__I($m_sr_Statics$().anyHash__O__I(key))
});
$c_sci_HashSet.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_sci_HashSet.prototype.init___ = (function() {
  return this
});
$c_sci_HashSet.prototype.apply__O__O = (function(v1) {
  return this.contains__O__Z(v1)
});
$c_sci_HashSet.prototype.$$plus__O__sci_HashSet = (function(e) {
  return this.updated0__O__I__I__sci_HashSet(e, this.computeHash__O__I(e), 0)
});
$c_sci_HashSet.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return this.$$minus__O__sci_HashSet(elem)
});
$c_sci_HashSet.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sci_HashSet.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_HashSet.prototype.union0__sci_HashSet__I__Asci_HashSet__I__sci_HashSet = (function(that, level, buffer, offset0) {
  return that
});
$c_sci_HashSet.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sci_HashSet$()
});
$c_sci_HashSet.prototype.filter__F1__sci_HashSet = (function(p) {
  var size = this.size__I();
  var x = ((6 + size) | 0);
  var buffer = $newArrayObject($d_sci_HashSet.getArrayOf(), [((x < 224) ? x : 224)]);
  var s = this.filter0__F1__Z__I__Asci_HashSet__I__sci_HashSet(p, false, 0, buffer, 0);
  return ((s === null) ? $m_sci_HashSet$EmptyHashSet$() : s)
});
$c_sci_HashSet.prototype.foreach__F1__V = (function(f) {
  /*<skip>*/
});
$c_sci_HashSet.prototype.union0__sci_HashSet$LeafHashSet__I__sci_HashSet = (function(that, level) {
  return that
});
$c_sci_HashSet.prototype.subsetOf__sc_GenSet__Z = (function(that) {
  if ((that instanceof $c_sci_HashSet)) {
    var x2 = $as_sci_HashSet(that);
    return this.subsetOf0__sci_HashSet__I__Z(x2, 0)
  } else {
    var this$1 = this.iterator__sc_Iterator();
    return $f_sc_Iterator__forall__F1__Z(this$1, that)
  }
});
$c_sci_HashSet.prototype.filter__F1__O = (function(p) {
  return this.filter__F1__sci_HashSet(p)
});
$c_sci_HashSet.prototype.intersect__sc_GenSet__sci_HashSet = (function(that) {
  if ((that instanceof $c_sci_HashSet)) {
    var x2 = $as_sci_HashSet(that);
    var x = this.size__I();
    var that$1 = x2.size__I();
    var size = ((x < that$1) ? x : that$1);
    var x$1 = ((6 + size) | 0);
    var buffer = $newArrayObject($d_sci_HashSet.getArrayOf(), [((x$1 < 224) ? x$1 : 224)]);
    var s = this.intersect0__sci_HashSet__I__Asci_HashSet__I__sci_HashSet(x2, 0, buffer, 0);
    return ((s === null) ? $m_sci_HashSet$EmptyHashSet$() : s)
  } else {
    return this.filter__F1__sci_HashSet(that)
  }
});
$c_sci_HashSet.prototype.size__I = (function() {
  return 0
});
$c_sci_HashSet.prototype.filterNot__F1__sci_HashSet = (function(p) {
  var size = this.size__I();
  var x = ((6 + size) | 0);
  var buffer = $newArrayObject($d_sci_HashSet.getArrayOf(), [((x < 224) ? x : 224)]);
  var s = this.filter0__F1__Z__I__Asci_HashSet__I__sci_HashSet(p, true, 0, buffer, 0);
  return ((s === null) ? $m_sci_HashSet$EmptyHashSet$() : s)
});
$c_sci_HashSet.prototype.iterator__sc_Iterator = (function() {
  return $m_sc_Iterator$().empty$1
});
$c_sci_HashSet.prototype.$$minus__O__sc_Set = (function(elem) {
  return this.$$minus__O__sci_HashSet(elem)
});
$c_sci_HashSet.prototype.removed0__O__I__I__sci_HashSet = (function(key, hash, level) {
  return this
});
$c_sci_HashSet.prototype.empty__sc_Set = (function() {
  return $m_sci_HashSet$EmptyHashSet$()
});
$c_sci_HashSet.prototype.filterNot__F1__O = (function(p) {
  return this.filterNot__F1__sci_HashSet(p)
});
$c_sci_HashSet.prototype.improve__I__I = (function(hcode) {
  var h = ((hcode + (~(hcode << 9))) | 0);
  h = (h ^ ((h >>> 14) | 0));
  h = ((h + (h << 4)) | 0);
  return (h ^ ((h >>> 10) | 0))
});
$c_sci_HashSet.prototype.$$minus__O__sci_HashSet = (function(e) {
  var s = this.removed0__O__I__I__sci_HashSet(e, this.computeHash__O__I(e), 0);
  return ((s === null) ? $m_sci_HashSet$EmptyHashSet$() : s)
});
$c_sci_HashSet.prototype.intersect0__sci_HashSet__I__Asci_HashSet__I__sci_HashSet = (function(that, level, buffer, offset0) {
  return null
});
$c_sci_HashSet.prototype.seq__sc_Set = (function() {
  return this
});
$c_sci_HashSet.prototype.contains__O__Z = (function(e) {
  return this.get0__O__I__I__Z(e, this.computeHash__O__I(e), 0)
});
$c_sci_HashSet.prototype.union__sc_GenSet__sci_HashSet = (function(that) {
  if ((that instanceof $c_sci_HashSet)) {
    var x2 = $as_sci_HashSet(that);
    var size = ((this.size__I() + x2.size__I()) | 0);
    var x = ((6 + size) | 0);
    var buffer = $newArrayObject($d_sci_HashSet.getArrayOf(), [((x < 224) ? x : 224)]);
    var s = this.union0__sci_HashSet__I__Asci_HashSet__I__sci_HashSet(x2, 0, buffer, 0);
    return ((s === null) ? $m_sci_HashSet$EmptyHashSet$() : s)
  } else {
    return $as_sci_HashSet($f_sc_SetLike__$$plus$plus__sc_GenTraversableOnce__sc_Set(this, that))
  }
});
$c_sci_HashSet.prototype.tail__O = (function() {
  return this.tail__sci_HashSet()
});
$c_sci_HashSet.prototype.tail__sci_HashSet = (function() {
  return this.$$minus__O__sci_HashSet(this.head__O())
});
$c_sci_HashSet.prototype.diff__sc_GenSet__sc_Set = (function(that) {
  return this.diff__sc_GenSet__sci_HashSet(that)
});
$c_sci_HashSet.prototype.empty__sc_GenSet = (function() {
  return $m_sci_HashSet$EmptyHashSet$()
});
$c_sci_HashSet.prototype.toSet__sci_Set = (function() {
  return this
});
$c_sci_HashSet.prototype.diff0__sci_HashSet__I__Asci_HashSet__I__sci_HashSet = (function(that, level, buffer, offset0) {
  return null
});
$c_sci_HashSet.prototype.toSeq__sc_GenSeq = (function() {
  return $f_sc_SetLike__toSeq__sc_Seq(this)
});
$c_sci_HashSet.prototype.filter0__F1__Z__I__Asci_HashSet__I__sci_HashSet = (function(p, negate, level, buffer, offset0) {
  return null
});
$c_sci_HashSet.prototype.get0__O__I__I__Z = (function(key, hash, level) {
  return false
});
$c_sci_HashSet.prototype.intersect__sc_GenSet__O = (function(that) {
  return this.intersect__sc_GenSet__sci_HashSet(that)
});
$c_sci_HashSet.prototype.$$plus__O__sc_Set = (function(elem) {
  return this.$$plus__O__sci_HashSet(elem)
});
$c_sci_HashSet.prototype.subsetOf0__sci_HashSet__I__Z = (function(that, level) {
  return true
});
$c_sci_HashSet.prototype.union__sc_GenSet__sc_Set = (function(that) {
  return this.union__sc_GenSet__sci_HashSet(that)
});
function $as_sci_HashSet(obj) {
  return (((obj instanceof $c_sci_HashSet) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.HashSet"))
}
function $isArrayOf_sci_HashSet(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_HashSet)))
}
function $asArrayOf_sci_HashSet(obj, depth) {
  return (($isArrayOf_sci_HashSet(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.HashSet;", depth))
}
var $d_sci_HashSet = new $TypeData().initClass({
  sci_HashSet: 0
}, false, "scala.collection.immutable.HashSet", {
  sci_HashSet: 1,
  sc_AbstractSet: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Set: 1,
  F1: 1,
  sc_GenSet: 1,
  sc_GenSetLike: 1,
  scg_GenericSetTemplate: 1,
  sc_SetLike: 1,
  scg_Subtractable: 1,
  sci_Set: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_HashSet.prototype.$classData = $d_sci_HashSet;
/** @constructor */
function $c_sci_ListSet$EmptyListSet$() {
  $c_sci_ListSet.call(this)
}
$c_sci_ListSet$EmptyListSet$.prototype = new $h_sci_ListSet();
$c_sci_ListSet$EmptyListSet$.prototype.constructor = $c_sci_ListSet$EmptyListSet$;
/** @constructor */
function $h_sci_ListSet$EmptyListSet$() {
  /*<skip>*/
}
$h_sci_ListSet$EmptyListSet$.prototype = $c_sci_ListSet$EmptyListSet$.prototype;
$c_sci_ListSet$EmptyListSet$.prototype.init___ = (function() {
  return this
});
var $d_sci_ListSet$EmptyListSet$ = new $TypeData().initClass({
  sci_ListSet$EmptyListSet$: 0
}, false, "scala.collection.immutable.ListSet$EmptyListSet$", {
  sci_ListSet$EmptyListSet$: 1,
  sci_ListSet: 1,
  sc_AbstractSet: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Set: 1,
  F1: 1,
  sc_GenSet: 1,
  sc_GenSetLike: 1,
  scg_GenericSetTemplate: 1,
  sc_SetLike: 1,
  scg_Subtractable: 1,
  sci_Set: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_ListSet$EmptyListSet$.prototype.$classData = $d_sci_ListSet$EmptyListSet$;
var $n_sci_ListSet$EmptyListSet$ = (void 0);
function $m_sci_ListSet$EmptyListSet$() {
  if ((!$n_sci_ListSet$EmptyListSet$)) {
    $n_sci_ListSet$EmptyListSet$ = new $c_sci_ListSet$EmptyListSet$().init___()
  };
  return $n_sci_ListSet$EmptyListSet$
}
/** @constructor */
function $c_sci_ListSet$Node() {
  $c_sci_ListSet.call(this);
  this.elem$5 = null;
  this.$$outer$5 = null
}
$c_sci_ListSet$Node.prototype = new $h_sci_ListSet();
$c_sci_ListSet$Node.prototype.constructor = $c_sci_ListSet$Node;
/** @constructor */
function $h_sci_ListSet$Node() {
  /*<skip>*/
}
$h_sci_ListSet$Node.prototype = $c_sci_ListSet$Node.prototype;
$c_sci_ListSet$Node.prototype.next__sci_ListSet = (function() {
  return this.$$outer$5
});
$c_sci_ListSet$Node.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return this.removeInternal__p5__O__sci_ListSet__sci_List__sci_ListSet(elem, this, $m_sci_Nil$())
});
$c_sci_ListSet$Node.prototype.isEmpty__Z = (function() {
  return false
});
$c_sci_ListSet$Node.prototype.$$plus__O__sci_ListSet = (function(e) {
  return (this.containsInternal__p5__sci_ListSet__O__Z(this, e) ? this : new $c_sci_ListSet$Node().init___sci_ListSet__O(this, e))
});
$c_sci_ListSet$Node.prototype.sizeInternal__p5__sci_ListSet__I__I = (function(n, acc) {
  _sizeInternal: while (true) {
    if (n.isEmpty__Z()) {
      return acc
    } else {
      var temp$n = n.next__sci_ListSet();
      var temp$acc = ((1 + acc) | 0);
      n = temp$n;
      acc = temp$acc;
      continue _sizeInternal
    }
  }
});
$c_sci_ListSet$Node.prototype.size__I = (function() {
  return this.sizeInternal__p5__sci_ListSet__I__I(this, 0)
});
$c_sci_ListSet$Node.prototype.removeInternal__p5__O__sci_ListSet__sci_List__sci_ListSet = (function(k, cur, acc) {
  _removeInternal: while (true) {
    if (cur.isEmpty__Z()) {
      var this$1 = acc;
      return $as_sci_ListSet($f_sc_LinearSeqOptimized__last__O(this$1))
    } else if ($m_sr_BoxesRunTime$().equals__O__O__Z(k, cur.elem__O())) {
      var x$5 = cur.next__sci_ListSet();
      var this$2 = acc;
      var acc$1 = x$5;
      var these = this$2;
      while ((!these.isEmpty__Z())) {
        var arg1 = acc$1;
        var arg2 = these.head__O();
        var x0$1 = $as_sci_ListSet(arg1);
        var x1$1 = $as_sci_ListSet(arg2);
        acc$1 = new $c_sci_ListSet$Node().init___sci_ListSet__O(x0$1, x1$1.elem__O());
        these = $as_sc_LinearSeqOptimized(these.tail__O())
      };
      return $as_sci_ListSet(acc$1)
    } else {
      var temp$cur = cur.next__sci_ListSet();
      var x$6 = cur;
      var this$3 = acc;
      var temp$acc = new $c_sci_$colon$colon().init___O__sci_List(x$6, this$3);
      cur = temp$cur;
      acc = temp$acc;
      continue _removeInternal
    }
  }
});
$c_sci_ListSet$Node.prototype.$$minus__O__sc_Set = (function(elem) {
  return this.removeInternal__p5__O__sci_ListSet__sci_List__sci_ListSet(elem, this, $m_sci_Nil$())
});
$c_sci_ListSet$Node.prototype.init___sci_ListSet__O = (function($$outer, elem) {
  this.elem$5 = elem;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$5 = $$outer
  };
  return this
});
$c_sci_ListSet$Node.prototype.elem__O = (function() {
  return this.elem$5
});
$c_sci_ListSet$Node.prototype.contains__O__Z = (function(e) {
  return this.containsInternal__p5__sci_ListSet__O__Z(this, e)
});
$c_sci_ListSet$Node.prototype.$$minus__O__sci_ListSet = (function(e) {
  return this.removeInternal__p5__O__sci_ListSet__sci_List__sci_ListSet(e, this, $m_sci_Nil$())
});
$c_sci_ListSet$Node.prototype.containsInternal__p5__sci_ListSet__O__Z = (function(n, e) {
  _containsInternal: while (true) {
    if ((!n.isEmpty__Z())) {
      if ($m_sr_BoxesRunTime$().equals__O__O__Z(n.elem__O(), e)) {
        return true
      } else {
        n = n.next__sci_ListSet();
        continue _containsInternal
      }
    } else {
      return false
    }
  }
});
$c_sci_ListSet$Node.prototype.$$plus__O__sc_Set = (function(elem) {
  return this.$$plus__O__sci_ListSet(elem)
});
var $d_sci_ListSet$Node = new $TypeData().initClass({
  sci_ListSet$Node: 0
}, false, "scala.collection.immutable.ListSet$Node", {
  sci_ListSet$Node: 1,
  sci_ListSet: 1,
  sc_AbstractSet: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Set: 1,
  F1: 1,
  sc_GenSet: 1,
  sc_GenSetLike: 1,
  scg_GenericSetTemplate: 1,
  sc_SetLike: 1,
  scg_Subtractable: 1,
  sci_Set: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_ListSet$Node.prototype.$classData = $d_sci_ListSet$Node;
/** @constructor */
function $c_sci_MapLike$ImmutableDefaultKeySet() {
  $c_sc_MapLike$DefaultKeySet.call(this)
}
$c_sci_MapLike$ImmutableDefaultKeySet.prototype = new $h_sc_MapLike$DefaultKeySet();
$c_sci_MapLike$ImmutableDefaultKeySet.prototype.constructor = $c_sci_MapLike$ImmutableDefaultKeySet;
/** @constructor */
function $h_sci_MapLike$ImmutableDefaultKeySet() {
  /*<skip>*/
}
$h_sci_MapLike$ImmutableDefaultKeySet.prototype = $c_sci_MapLike$ImmutableDefaultKeySet.prototype;
$c_sci_MapLike$ImmutableDefaultKeySet.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sci_MapLike$ImmutableDefaultKeySet.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_sci_MapLike$ImmutableDefaultKeySet.prototype.apply__O__O = (function(v1) {
  return this.$$outer$4.contains__O__Z(v1)
});
$c_sci_MapLike$ImmutableDefaultKeySet.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return this.$$minus__O__sci_Set(elem)
});
$c_sci_MapLike$ImmutableDefaultKeySet.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sci_MapLike$ImmutableDefaultKeySet.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_MapLike$ImmutableDefaultKeySet.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sci_Set$()
});
$c_sci_MapLike$ImmutableDefaultKeySet.prototype.init___sci_MapLike = (function($$outer) {
  $c_sc_MapLike$DefaultKeySet.prototype.init___sc_MapLike.call(this, $$outer);
  return this
});
$c_sci_MapLike$ImmutableDefaultKeySet.prototype.$$minus__O__sc_Set = (function(elem) {
  return this.$$minus__O__sci_Set(elem)
});
$c_sci_MapLike$ImmutableDefaultKeySet.prototype.empty__sc_Set = (function() {
  return $m_sci_Set$EmptySet$()
});
$c_sci_MapLike$ImmutableDefaultKeySet.prototype.$$plus__O__sci_Set = (function(elem) {
  return (this.$$outer$4.contains__O__Z(elem) ? this : $as_sci_Set($as_sc_SetLike($m_sci_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())).$$plus$plus__sc_GenTraversableOnce__sc_Set(this).$$plus__O__sc_Set(elem)))
});
$c_sci_MapLike$ImmutableDefaultKeySet.prototype.seq__sc_Set = (function() {
  return this
});
$c_sci_MapLike$ImmutableDefaultKeySet.prototype.toSet__sci_Set = (function() {
  return this
});
$c_sci_MapLike$ImmutableDefaultKeySet.prototype.toSeq__sc_GenSeq = (function() {
  return $f_sc_SetLike__toSeq__sc_Seq(this)
});
$c_sci_MapLike$ImmutableDefaultKeySet.prototype.$$plus__O__sc_Set = (function(elem) {
  return this.$$plus__O__sci_Set(elem)
});
$c_sci_MapLike$ImmutableDefaultKeySet.prototype.$$minus__O__sci_Set = (function(elem) {
  return (this.$$outer$4.contains__O__Z(elem) ? $as_sci_Set($as_sc_SetLike($m_sci_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())).$$plus$plus__sc_GenTraversableOnce__sc_Set(this).$$minus__O__sc_Set(elem)) : this)
});
var $d_sci_MapLike$ImmutableDefaultKeySet = new $TypeData().initClass({
  sci_MapLike$ImmutableDefaultKeySet: 0
}, false, "scala.collection.immutable.MapLike$ImmutableDefaultKeySet", {
  sci_MapLike$ImmutableDefaultKeySet: 1,
  sc_MapLike$DefaultKeySet: 1,
  sc_AbstractSet: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Set: 1,
  F1: 1,
  sc_GenSet: 1,
  sc_GenSetLike: 1,
  scg_GenericSetTemplate: 1,
  sc_SetLike: 1,
  scg_Subtractable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  sci_Set: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1
});
$c_sci_MapLike$ImmutableDefaultKeySet.prototype.$classData = $d_sci_MapLike$ImmutableDefaultKeySet;
/** @constructor */
function $c_sci_TreeSet() {
  $c_O.call(this);
  this.tree$1 = null;
  this.ordering$1 = null
}
$c_sci_TreeSet.prototype = new $h_O();
$c_sci_TreeSet.prototype.constructor = $c_sci_TreeSet;
/** @constructor */
function $h_sci_TreeSet() {
  /*<skip>*/
}
$h_sci_TreeSet.prototype = $c_sci_TreeSet.prototype;
$c_sci_TreeSet.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sci_TreeSet.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_sci_TreeSet.prototype.tail__sci_TreeSet = (function() {
  return new $c_sci_TreeSet().init___sci_RedBlackTree$Tree__s_math_Ordering($m_sci_RedBlackTree$().$delete__sci_RedBlackTree$Tree__O__s_math_Ordering__sci_RedBlackTree$Tree(this.tree$1, this.head__O(), this.ordering$1), this.ordering$1)
});
$c_sci_TreeSet.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_sci_TreeSet.prototype.head__O = (function() {
  return $m_sci_RedBlackTree$().smallest__sci_RedBlackTree$Tree__sci_RedBlackTree$Tree(this.tree$1).key$1
});
$c_sci_TreeSet.prototype.toIterator__sc_Iterator = (function() {
  return this.iterator__sc_Iterator()
});
$c_sci_TreeSet.prototype.$$minus__O__sci_TreeSet = (function(elem) {
  if ((!$m_sci_RedBlackTree$().contains__sci_RedBlackTree$Tree__O__s_math_Ordering__Z(this.tree$1, elem, this.ordering$1))) {
    return this
  } else {
    var t = $m_sci_RedBlackTree$().$delete__sci_RedBlackTree$Tree__O__s_math_Ordering__sci_RedBlackTree$Tree(this.tree$1, elem, this.ordering$1);
    return new $c_sci_TreeSet().init___sci_RedBlackTree$Tree__s_math_Ordering(t, this.ordering$1)
  }
});
$c_sci_TreeSet.prototype.dropWhile__F1__sci_TreeSet = (function(p) {
  return this.drop__I__sci_TreeSet(this.countWhile__p1__F1__I(p))
});
$c_sci_TreeSet.prototype.apply__O__O = (function(v1) {
  return this.contains__O__Z(v1)
});
$c_sci_TreeSet.prototype.flatten__F1__sc_GenTraversable = (function(asTraversable) {
  return $f_scg_GenericTraversableTemplate__flatten__F1__sc_GenTraversable(this, asTraversable)
});
$c_sci_TreeSet.prototype.exists__F1__Z = (function(p) {
  var this$1 = this.iterator__sc_Iterator();
  return $f_sc_Iterator__exists__F1__Z(this$1, p)
});
$c_sci_TreeSet.prototype.take__I__sci_TreeSet = (function(n) {
  if ((n <= 0)) {
    var ordering = this.ordering$1;
    return new $c_sci_TreeSet().init___s_math_Ordering(ordering)
  } else if ((n >= this.size__I())) {
    return this
  } else {
    var t = $m_sci_RedBlackTree$().take__sci_RedBlackTree$Tree__I__s_math_Ordering__sci_RedBlackTree$Tree(this.tree$1, n, this.ordering$1);
    return new $c_sci_TreeSet().init___sci_RedBlackTree$Tree__s_math_Ordering(t, this.ordering$1)
  }
});
$c_sci_TreeSet.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return this.$$minus__O__sci_TreeSet(elem)
});
$c_sci_TreeSet.prototype.toList__sci_List = (function() {
  var this$1 = $m_sci_List$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_sci_List($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sci_TreeSet.prototype.isEmpty__Z = (function() {
  return $f_sc_SetLike__isEmpty__Z(this)
});
$c_sci_TreeSet.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sci_TreeSet.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_TreeSet.prototype.flatMap__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__flatMap__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_sci_TreeSet.prototype.equals__O__Z = (function(that) {
  return $f_sc_GenSetLike__equals__O__Z(this, that)
});
$c_sci_TreeSet.prototype.dropWhile__F1__O = (function(p) {
  return this.dropWhile__F1__sci_TreeSet(p)
});
$c_sci_TreeSet.prototype.mkString__T__T = (function(sep) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", sep, "")
});
$c_sci_TreeSet.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_sci_TreeSet.prototype.init___s_math_Ordering = (function(ordering) {
  $c_sci_TreeSet.prototype.init___sci_RedBlackTree$Tree__s_math_Ordering.call(this, null, ordering);
  return this
});
$c_sci_TreeSet.prototype.withFilter__F1__scg_FilterMonadic = (function(p) {
  return new $c_sc_TraversableLike$WithFilter().init___sc_TraversableLike__F1(this, p)
});
$c_sci_TreeSet.prototype.forall__F1__Z = (function(p) {
  var this$1 = this.iterator__sc_Iterator();
  return $f_sc_Iterator__forall__F1__Z(this$1, p)
});
$c_sci_TreeSet.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sci_Set$()
});
$c_sci_TreeSet.prototype.toString__T = (function() {
  return $f_sc_TraversableLike__toString__T(this)
});
$c_sci_TreeSet.prototype.foreach__F1__V = (function(f) {
  $m_sci_RedBlackTree$().foreachKey__sci_RedBlackTree$Tree__F1__V(this.tree$1, f)
});
$c_sci_TreeSet.prototype.foldLeft__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_sci_TreeSet.prototype.subsetOf__sc_GenSet__Z = (function(that) {
  return $f_sc_SortedSetLike__subsetOf__sc_GenSet__Z(this, that)
});
$c_sci_TreeSet.prototype.$$minus$minus__sc_GenTraversableOnce__scg_Subtractable = (function(xs) {
  return $f_scg_Subtractable__$$minus$minus__sc_GenTraversableOnce__scg_Subtractable(this, xs)
});
$c_sci_TreeSet.prototype.headOption__s_Option = (function() {
  return ($m_sci_RedBlackTree$().isEmpty__sci_RedBlackTree$Tree__Z(this.tree$1) ? $m_s_None$() : new $c_s_Some().init___O(this.head__O()))
});
$c_sci_TreeSet.prototype.takeWhile__F1__O = (function(p) {
  return this.takeWhile__F1__sci_TreeSet(p)
});
$c_sci_TreeSet.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sci_TreeSet.prototype.filter__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, false)
});
$c_sci_TreeSet.prototype.takeWhile__F1__sci_TreeSet = (function(p) {
  return this.take__I__sci_TreeSet(this.countWhile__p1__F1__I(p))
});
$c_sci_TreeSet.prototype.size__I = (function() {
  return $m_sci_RedBlackTree$().count__sci_RedBlackTree$Tree__I(this.tree$1)
});
$c_sci_TreeSet.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_SetLike__toBuffer__scm_Buffer(this)
});
$c_sci_TreeSet.prototype.apply$mcZI$sp__I__Z = (function(v1) {
  return this.contains__O__Z(v1)
});
$c_sci_TreeSet.prototype.iterator__sc_Iterator = (function() {
  var tree = this.tree$1;
  var start = $m_s_None$();
  var evidence$14 = this.ordering$1;
  return new $c_sci_RedBlackTree$KeysIterator().init___sci_RedBlackTree$Tree__s_Option__s_math_Ordering(tree, start, evidence$14)
});
$c_sci_TreeSet.prototype.find__F1__s_Option = (function(p) {
  var this$1 = this.iterator__sc_Iterator();
  return $f_sc_Iterator__find__F1__s_Option(this$1, p)
});
$c_sci_TreeSet.prototype.$$minus__O__sc_Set = (function(elem) {
  return this.$$minus__O__sci_TreeSet(elem)
});
$c_sci_TreeSet.prototype.span__F1__T2 = (function(p) {
  return this.splitAt__I__T2(this.countWhile__p1__F1__I(p))
});
$c_sci_TreeSet.prototype.drop__I__sci_TreeSet = (function(n) {
  if ((n <= 0)) {
    return this
  } else if ((n >= this.size__I())) {
    var ordering = this.ordering$1;
    return new $c_sci_TreeSet().init___s_math_Ordering(ordering)
  } else {
    var t = $m_sci_RedBlackTree$().drop__sci_RedBlackTree$Tree__I__s_math_Ordering__sci_RedBlackTree$Tree(this.tree$1, n, this.ordering$1);
    return new $c_sci_TreeSet().init___sci_RedBlackTree$Tree__s_math_Ordering(t, this.ordering$1)
  }
});
$c_sci_TreeSet.prototype.countWhile__p1__F1__I = (function(p) {
  var result = 0;
  var it = this.iterator__sc_Iterator();
  while ((it.hasNext__Z() && $uZ(p.apply__O__O(it.next__O())))) {
    result = ((1 + result) | 0)
  };
  return result
});
$c_sci_TreeSet.prototype.init___sci_RedBlackTree$Tree__s_math_Ordering = (function(tree, ordering) {
  this.tree$1 = tree;
  this.ordering$1 = ordering;
  if ((ordering === null)) {
    throw new $c_jl_NullPointerException().init___T("ordering must not be null")
  };
  return this
});
$c_sci_TreeSet.prototype.mkString__T = (function() {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "", "", "")
});
$c_sci_TreeSet.prototype.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
});
$c_sci_TreeSet.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IterableLike__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_sci_TreeSet.prototype.$$plus__O__sci_TreeSet = (function(elem) {
  var t = $m_sci_RedBlackTree$().update__sci_RedBlackTree$Tree__O__O__Z__s_math_Ordering__sci_RedBlackTree$Tree(this.tree$1, elem, (void 0), false, this.ordering$1);
  return new $c_sci_TreeSet().init___sci_RedBlackTree$Tree__s_math_Ordering(t, this.ordering$1)
});
$c_sci_TreeSet.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, p, true)
});
$c_sci_TreeSet.prototype.sizeHintIfCheap__I = (function() {
  return (-1)
});
$c_sci_TreeSet.prototype.splitAt__I__T2 = (function(n) {
  return new $c_T2().init___O__O(this.take__I__sci_TreeSet(n), this.drop__I__sci_TreeSet(n))
});
$c_sci_TreeSet.prototype.toStream__sci_Stream = (function() {
  return this.iterator__sc_Iterator().toStream__sci_Stream()
});
$c_sci_TreeSet.prototype.drop__I__O = (function(n) {
  return this.drop__I__sci_TreeSet(n)
});
$c_sci_TreeSet.prototype.contains__O__Z = (function(elem) {
  return $m_sci_RedBlackTree$().contains__sci_RedBlackTree$Tree__O__s_math_Ordering__Z(this.tree$1, elem, this.ordering$1)
});
$c_sci_TreeSet.prototype.tail__O = (function() {
  return this.tail__sci_TreeSet()
});
$c_sci_TreeSet.prototype.toTraversable__sc_Traversable = (function() {
  return this
});
$c_sci_TreeSet.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_sci_TreeSet.prototype.toSeq__sc_Seq = (function() {
  return $f_sc_SetLike__toSeq__sc_Seq(this)
});
$c_sci_TreeSet.prototype.diff__sc_GenSet__sc_Set = (function(that) {
  return $as_sc_Set($f_scg_Subtractable__$$minus$minus__sc_GenTraversableOnce__scg_Subtractable(this, that))
});
$c_sci_TreeSet.prototype.toSet__sci_Set = (function() {
  return $f_sci_Set__toSet__sci_Set(this)
});
$c_sci_TreeSet.prototype.repr__O = (function() {
  return this
});
$c_sci_TreeSet.prototype.$$div$colon__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_sci_TreeSet.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_sc_IterableLike__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_sci_TreeSet.prototype.isTraversableAgain__Z = (function() {
  return true
});
$c_sci_TreeSet.prototype.toSeq__sc_GenSeq = (function() {
  return $f_sc_SetLike__toSeq__sc_Seq(this)
});
$c_sci_TreeSet.prototype.groupBy__F1__sci_Map = (function(f) {
  return $f_sc_TraversableLike__groupBy__F1__sci_Map(this, f)
});
$c_sci_TreeSet.prototype.hashCode__I = (function() {
  var this$1 = $m_s_util_hashing_MurmurHash3$();
  return this$1.unorderedHash__sc_TraversableOnce__I__I(this, this$1.setSeed$2)
});
$c_sci_TreeSet.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  this.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, b$1, ev$1) {
    return (function(x$2) {
      return b$1.$$plus$eq__O__scm_Builder(x$2)
    })
  })(this, b, ev)));
  return $as_sci_Map(b.elems$1)
});
$c_sci_TreeSet.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_sci_TreeSet.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_sc_TraversableOnce__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_sci_TreeSet.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_sci_TreeSet.prototype.intersect__sc_GenSet__O = (function(that) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, that, false)
});
$c_sci_TreeSet.prototype.$$plus__O__sc_Set = (function(elem) {
  return this.$$plus__O__sci_TreeSet(elem)
});
$c_sci_TreeSet.prototype.$$plus$plus__sc_GenTraversableOnce__sc_Set = (function(elems) {
  return $f_sc_SetLike__$$plus$plus__sc_GenTraversableOnce__sc_Set(this, elems)
});
$c_sci_TreeSet.prototype.collect__s_PartialFunction__scg_CanBuildFrom__O = (function(pf, bf) {
  return $f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this, pf, bf)
});
$c_sci_TreeSet.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_TraversableOnce__reduceLeft__F2__O(this, op)
});
$c_sci_TreeSet.prototype.newBuilder__scm_Builder = (function() {
  var ordering = this.ordering$1;
  return new $c_scm_SetBuilder().init___sc_Set(new $c_sci_TreeSet().init___s_math_Ordering(ordering))
});
$c_sci_TreeSet.prototype.union__sc_GenSet__sc_Set = (function(that) {
  return $f_sc_SetLike__$$plus$plus__sc_GenTraversableOnce__sc_Set(this, that)
});
$c_sci_TreeSet.prototype.stringPrefix__T = (function() {
  return "TreeSet"
});
function $as_sci_TreeSet(obj) {
  return (((obj instanceof $c_sci_TreeSet) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.TreeSet"))
}
function $isArrayOf_sci_TreeSet(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_TreeSet)))
}
function $asArrayOf_sci_TreeSet(obj, depth) {
  return (($isArrayOf_sci_TreeSet(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.TreeSet;", depth))
}
var $d_sci_TreeSet = new $TypeData().initClass({
  sci_TreeSet: 0
}, false, "scala.collection.immutable.TreeSet", {
  sci_TreeSet: 1,
  O: 1,
  sci_SortedSet: 1,
  sci_Set: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  s_Immutable: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Set: 1,
  F1: 1,
  sc_GenSet: 1,
  sc_GenSetLike: 1,
  scg_GenericSetTemplate: 1,
  sc_SetLike: 1,
  scg_Subtractable: 1,
  sc_SortedSet: 1,
  sc_SortedSetLike: 1,
  scg_Sorted: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_TreeSet.prototype.$classData = $d_sci_TreeSet;
/** @constructor */
function $c_scm_AbstractSeq() {
  $c_sc_AbstractSeq.call(this)
}
$c_scm_AbstractSeq.prototype = new $h_sc_AbstractSeq();
$c_scm_AbstractSeq.prototype.constructor = $c_scm_AbstractSeq;
/** @constructor */
function $h_scm_AbstractSeq() {
  /*<skip>*/
}
$h_scm_AbstractSeq.prototype = $c_scm_AbstractSeq.prototype;
$c_scm_AbstractSeq.prototype.seq__sc_TraversableOnce = (function() {
  return this.seq__scm_Seq()
});
$c_scm_AbstractSeq.prototype.seq__sc_Iterable = (function() {
  return this.seq__scm_Seq()
});
$c_scm_AbstractSeq.prototype.seq__scm_Seq = (function() {
  return this
});
function $f_scm_Map__withDefaultValue__O__scm_Map($thiz, d) {
  return new $c_scm_Map$WithDefault().init___scm_Map__F1($thiz, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, d$1) {
    return (function(x$2) {
      return d$1
    })
  })($thiz, d)))
}
function $is_scm_Map(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.scm_Map)))
}
function $as_scm_Map(obj) {
  return (($is_scm_Map(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.Map"))
}
function $isArrayOf_scm_Map(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_Map)))
}
function $asArrayOf_scm_Map(obj, depth) {
  return (($isArrayOf_scm_Map(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.Map;", depth))
}
/** @constructor */
function $c_sc_SeqViewLike$$anon$12() {
  $c_sc_SeqViewLike$AbstractTransformed.call(this);
  this.$$outer$2 = null
}
$c_sc_SeqViewLike$$anon$12.prototype = new $h_sc_SeqViewLike$AbstractTransformed();
$c_sc_SeqViewLike$$anon$12.prototype.constructor = $c_sc_SeqViewLike$$anon$12;
/** @constructor */
function $h_sc_SeqViewLike$$anon$12() {
  /*<skip>*/
}
$h_sc_SeqViewLike$$anon$12.prototype = $c_sc_SeqViewLike$$anon$12.prototype;
$c_sc_SeqViewLike$$anon$12.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$Reversed__apply__I__O(this, idx)
});
$c_sc_SeqViewLike$$anon$12.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$Reversed__apply__I__O(this, idx)
});
$c_sc_SeqViewLike$$anon$12.prototype.init___sc_SeqViewLike = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  $c_sc_SeqViewLike$AbstractTransformed.prototype.init___sc_SeqViewLike.call(this, $$outer);
  return this
});
$c_sc_SeqViewLike$$anon$12.prototype.scala$collection$SeqViewLike$Reversed$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$2
});
$c_sc_SeqViewLike$$anon$12.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_SeqViewLike$Reversed__createReversedIterator__psc_SeqViewLike$Reversed__sc_Iterator(this)
});
$c_sc_SeqViewLike$$anon$12.prototype.viewIdentifier__T = (function() {
  return "R"
});
$c_sc_SeqViewLike$$anon$12.prototype.length__I = (function() {
  return this.$$outer$2.length__I()
});
var $d_sc_SeqViewLike$$anon$12 = new $TypeData().initClass({
  sc_SeqViewLike$$anon$12: 0
}, false, "scala.collection.SeqViewLike$$anon$12", {
  sc_SeqViewLike$$anon$12: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sc_SeqViewLike$Reversed: 1
});
$c_sc_SeqViewLike$$anon$12.prototype.$classData = $d_sc_SeqViewLike$$anon$12;
/** @constructor */
function $c_sci_HashSet$EmptyHashSet$() {
  $c_sci_HashSet.call(this)
}
$c_sci_HashSet$EmptyHashSet$.prototype = new $h_sci_HashSet();
$c_sci_HashSet$EmptyHashSet$.prototype.constructor = $c_sci_HashSet$EmptyHashSet$;
/** @constructor */
function $h_sci_HashSet$EmptyHashSet$() {
  /*<skip>*/
}
$h_sci_HashSet$EmptyHashSet$.prototype = $c_sci_HashSet$EmptyHashSet$.prototype;
$c_sci_HashSet$EmptyHashSet$.prototype.init___ = (function() {
  return this
});
$c_sci_HashSet$EmptyHashSet$.prototype.head__O = (function() {
  throw new $c_ju_NoSuchElementException().init___T("Empty Set")
});
$c_sci_HashSet$EmptyHashSet$.prototype.tail__O = (function() {
  return this.tail__sci_HashSet()
});
$c_sci_HashSet$EmptyHashSet$.prototype.tail__sci_HashSet = (function() {
  throw new $c_ju_NoSuchElementException().init___T("Empty Set")
});
var $d_sci_HashSet$EmptyHashSet$ = new $TypeData().initClass({
  sci_HashSet$EmptyHashSet$: 0
}, false, "scala.collection.immutable.HashSet$EmptyHashSet$", {
  sci_HashSet$EmptyHashSet$: 1,
  sci_HashSet: 1,
  sc_AbstractSet: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Set: 1,
  F1: 1,
  sc_GenSet: 1,
  sc_GenSetLike: 1,
  scg_GenericSetTemplate: 1,
  sc_SetLike: 1,
  scg_Subtractable: 1,
  sci_Set: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_HashSet$EmptyHashSet$.prototype.$classData = $d_sci_HashSet$EmptyHashSet$;
var $n_sci_HashSet$EmptyHashSet$ = (void 0);
function $m_sci_HashSet$EmptyHashSet$() {
  if ((!$n_sci_HashSet$EmptyHashSet$)) {
    $n_sci_HashSet$EmptyHashSet$ = new $c_sci_HashSet$EmptyHashSet$().init___()
  };
  return $n_sci_HashSet$EmptyHashSet$
}
/** @constructor */
function $c_sci_HashSet$HashTrieSet() {
  $c_sci_HashSet.call(this);
  this.bitmap$5 = 0;
  this.elems$5 = null;
  this.size0$5 = 0
}
$c_sci_HashSet$HashTrieSet.prototype = new $h_sci_HashSet();
$c_sci_HashSet$HashTrieSet.prototype.constructor = $c_sci_HashSet$HashTrieSet;
/** @constructor */
function $h_sci_HashSet$HashTrieSet() {
  /*<skip>*/
}
$h_sci_HashSet$HashTrieSet.prototype = $c_sci_HashSet$HashTrieSet.prototype;
$c_sci_HashSet$HashTrieSet.prototype.updated0__O__I__I__sci_HashSet = (function(key, hash, level) {
  var index = (31 & ((hash >>> level) | 0));
  var mask = (1 << index);
  var offset = $m_jl_Integer$().bitCount__I__I((this.bitmap$5 & (((-1) + mask) | 0)));
  if (((this.bitmap$5 & mask) !== 0)) {
    var sub = this.elems$5.get(offset);
    var subNew = sub.updated0__O__I__I__sci_HashSet(key, hash, ((5 + level) | 0));
    if ((sub === subNew)) {
      return this
    } else {
      var elemsNew = $newArrayObject($d_sci_HashSet.getArrayOf(), [this.elems$5.u.length]);
      $m_s_Array$().copy__O__I__O__I__I__V(this.elems$5, 0, elemsNew, 0, this.elems$5.u.length);
      elemsNew.set(offset, subNew);
      return new $c_sci_HashSet$HashTrieSet().init___I__Asci_HashSet__I(this.bitmap$5, elemsNew, ((this.size0$5 + ((subNew.size__I() - sub.size__I()) | 0)) | 0))
    }
  } else {
    var elemsNew$2 = $newArrayObject($d_sci_HashSet.getArrayOf(), [((1 + this.elems$5.u.length) | 0)]);
    $m_s_Array$().copy__O__I__O__I__I__V(this.elems$5, 0, elemsNew$2, 0, offset);
    elemsNew$2.set(offset, new $c_sci_HashSet$HashSet1().init___O__I(key, hash));
    $m_s_Array$().copy__O__I__O__I__I__V(this.elems$5, offset, elemsNew$2, ((1 + offset) | 0), ((this.elems$5.u.length - offset) | 0));
    var bitmapNew = (this.bitmap$5 | mask);
    return new $c_sci_HashSet$HashTrieSet().init___I__Asci_HashSet__I(bitmapNew, elemsNew$2, ((1 + this.size0$5) | 0))
  }
});
$c_sci_HashSet$HashTrieSet.prototype.removeAll$1__p5__sci_HashSet__sci_ListSet__sci_HashSet$HashSetCollision1__I__sci_HashSet = (function(s, r, x4$1, level$4) {
  _removeAll: while (true) {
    if ((r.isEmpty__Z() || (s === null))) {
      return s
    } else {
      var jsx$1 = s;
      var this$1 = r;
      var this$2 = this$1.reverseList$1__p4__sci_List();
      var temp$s = jsx$1.removed0__O__I__I__sci_HashSet(new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$2).next__O(), x4$1.hash$6, level$4);
      var this$3 = r;
      var temp$r = $as_sci_ListSet($f_sc_TraversableLike__tail__O(this$3));
      s = temp$s;
      r = temp$r;
      continue _removeAll
    }
  }
});
$c_sci_HashSet$HashTrieSet.prototype.union0__sci_HashSet__I__Asci_HashSet__I__sci_HashSet = (function(that, level, buffer, offset0) {
  if ((that === this)) {
    return this
  } else if ((that instanceof $c_sci_HashSet$LeafHashSet)) {
    var x2 = $as_sci_HashSet$LeafHashSet(that);
    return this.union0__sci_HashSet$LeafHashSet__I__sci_HashSet(x2, level)
  } else if ((that instanceof $c_sci_HashSet$HashTrieSet)) {
    var x3 = $as_sci_HashSet$HashTrieSet(that);
    var a = this.elems$5;
    var abm = this.bitmap$5;
    var ai = 0;
    var b = x3.elems$5;
    var bbm = x3.bitmap$5;
    var bi = 0;
    var offset = offset0;
    var rs = 0;
    while (((abm | bbm) !== 0)) {
      var alsb = (abm ^ (abm & (((-1) + abm) | 0)));
      var blsb = (bbm ^ (bbm & (((-1) + bbm) | 0)));
      if ((alsb === blsb)) {
        var sub1 = a.get(ai).union0__sci_HashSet__I__Asci_HashSet__I__sci_HashSet(b.get(bi), ((5 + level) | 0), buffer, offset);
        rs = ((rs + sub1.size__I()) | 0);
        buffer.set(offset, sub1);
        offset = ((1 + offset) | 0);
        abm = (abm & (~alsb));
        ai = ((1 + ai) | 0);
        bbm = (bbm & (~blsb));
        bi = ((1 + bi) | 0)
      } else {
        var i = (((-1) + alsb) | 0);
        var j = (((-1) + blsb) | 0);
        if ((((i < j) !== (i < 0)) !== (j < 0))) {
          var sub1$2 = a.get(ai);
          rs = ((rs + sub1$2.size__I()) | 0);
          buffer.set(offset, sub1$2);
          offset = ((1 + offset) | 0);
          abm = (abm & (~alsb));
          ai = ((1 + ai) | 0)
        } else {
          var sub1$3 = b.get(bi);
          rs = ((rs + sub1$3.size__I()) | 0);
          buffer.set(offset, sub1$3);
          offset = ((1 + offset) | 0);
          bbm = (bbm & (~blsb));
          bi = ((1 + bi) | 0)
        }
      }
    };
    if ((rs === this.size0$5)) {
      return this
    } else if ((rs === x3.size0$5)) {
      return x3
    } else {
      var length = ((offset - offset0) | 0);
      var elems = $newArrayObject($d_sci_HashSet.getArrayOf(), [length]);
      $systemArraycopy(buffer, offset0, elems, 0, length);
      return new $c_sci_HashSet$HashTrieSet().init___I__Asci_HashSet__I((this.bitmap$5 | x3.bitmap$5), elems, rs)
    }
  } else {
    return this
  }
});
$c_sci_HashSet$HashTrieSet.prototype.foreach__F1__V = (function(f) {
  var i = 0;
  while ((i < this.elems$5.u.length)) {
    this.elems$5.get(i).foreach__F1__V(f);
    i = ((1 + i) | 0)
  }
});
$c_sci_HashSet$HashTrieSet.prototype.union0__sci_HashSet$LeafHashSet__I__sci_HashSet = (function(that, level) {
  var index = (31 & ((that.hash__I() >>> level) | 0));
  var mask = (1 << index);
  var offset = $m_jl_Integer$().bitCount__I__I((this.bitmap$5 & (((-1) + mask) | 0)));
  if (((this.bitmap$5 & mask) !== 0)) {
    var sub = this.elems$5.get(offset);
    var sub1 = sub.union0__sci_HashSet$LeafHashSet__I__sci_HashSet(that, ((5 + level) | 0));
    if ((sub === sub1)) {
      return this
    } else {
      var elems1 = $newArrayObject($d_sci_HashSet.getArrayOf(), [this.elems$5.u.length]);
      $m_s_Array$().copy__O__I__O__I__I__V(this.elems$5, 0, elems1, 0, this.elems$5.u.length);
      elems1.set(offset, sub1);
      return new $c_sci_HashSet$HashTrieSet().init___I__Asci_HashSet__I(this.bitmap$5, elems1, ((this.size0$5 + ((sub1.size__I() - sub.size__I()) | 0)) | 0))
    }
  } else {
    var elems1$2 = $newArrayObject($d_sci_HashSet.getArrayOf(), [((1 + this.elems$5.u.length) | 0)]);
    $m_s_Array$().copy__O__I__O__I__I__V(this.elems$5, 0, elems1$2, 0, offset);
    elems1$2.set(offset, that);
    $m_s_Array$().copy__O__I__O__I__I__V(this.elems$5, offset, elems1$2, ((1 + offset) | 0), ((this.elems$5.u.length - offset) | 0));
    var bitmap1 = (this.bitmap$5 | mask);
    return new $c_sci_HashSet$HashTrieSet().init___I__Asci_HashSet__I(bitmap1, elems1$2, ((this.size0$5 + that.size__I()) | 0))
  }
});
$c_sci_HashSet$HashTrieSet.prototype.size__I = (function() {
  return this.size0$5
});
$c_sci_HashSet$HashTrieSet.prototype.iterator__sc_Iterator = (function() {
  return new $c_sci_HashSet$HashTrieSet$$anon$1().init___sci_HashSet$HashTrieSet(this)
});
$c_sci_HashSet$HashTrieSet.prototype.removed0__O__I__I__sci_HashSet = (function(key, hash, level) {
  var index = (31 & ((hash >>> level) | 0));
  var mask = (1 << index);
  var offset = $m_jl_Integer$().bitCount__I__I((this.bitmap$5 & (((-1) + mask) | 0)));
  if (((this.bitmap$5 & mask) !== 0)) {
    var sub = this.elems$5.get(offset);
    var subNew = sub.removed0__O__I__I__sci_HashSet(key, hash, ((5 + level) | 0));
    if ((sub === subNew)) {
      return this
    } else if ((subNew === null)) {
      var bitmapNew = (this.bitmap$5 ^ mask);
      if ((bitmapNew !== 0)) {
        var elemsNew = $newArrayObject($d_sci_HashSet.getArrayOf(), [(((-1) + this.elems$5.u.length) | 0)]);
        $m_s_Array$().copy__O__I__O__I__I__V(this.elems$5, 0, elemsNew, 0, offset);
        $m_s_Array$().copy__O__I__O__I__I__V(this.elems$5, ((1 + offset) | 0), elemsNew, offset, (((-1) + ((this.elems$5.u.length - offset) | 0)) | 0));
        var sizeNew = ((this.size0$5 - sub.size__I()) | 0);
        return (((elemsNew.u.length === 1) && (!(elemsNew.get(0) instanceof $c_sci_HashSet$HashTrieSet))) ? elemsNew.get(0) : new $c_sci_HashSet$HashTrieSet().init___I__Asci_HashSet__I(bitmapNew, elemsNew, sizeNew))
      } else {
        return null
      }
    } else if (((this.elems$5.u.length === 1) && (!(subNew instanceof $c_sci_HashSet$HashTrieSet)))) {
      return subNew
    } else {
      var elemsNew$2 = $newArrayObject($d_sci_HashSet.getArrayOf(), [this.elems$5.u.length]);
      $m_s_Array$().copy__O__I__O__I__I__V(this.elems$5, 0, elemsNew$2, 0, this.elems$5.u.length);
      elemsNew$2.set(offset, subNew);
      var sizeNew$2 = ((this.size0$5 + ((subNew.size__I() - sub.size__I()) | 0)) | 0);
      return new $c_sci_HashSet$HashTrieSet().init___I__Asci_HashSet__I(this.bitmap$5, elemsNew$2, sizeNew$2)
    }
  } else {
    return this
  }
});
$c_sci_HashSet$HashTrieSet.prototype.intersect0__sci_HashSet__I__Asci_HashSet__I__sci_HashSet = (function(that, level, buffer, offset0) {
  if ((that === this)) {
    return this
  } else if ((that instanceof $c_sci_HashSet$LeafHashSet)) {
    var x2 = $as_sci_HashSet$LeafHashSet(that);
    return x2.intersect0__sci_HashSet__I__Asci_HashSet__I__sci_HashSet(this, level, buffer, offset0)
  } else if ((that instanceof $c_sci_HashSet$HashTrieSet)) {
    var x3 = $as_sci_HashSet$HashTrieSet(that);
    var a = this.elems$5;
    var abm = this.bitmap$5;
    var ai = 0;
    var b = x3.elems$5;
    var bbm = x3.bitmap$5;
    var bi = 0;
    if (((abm & bbm) === 0)) {
      return null
    };
    var offset = offset0;
    var rs = 0;
    var rbm = 0;
    while (((abm & bbm) !== 0)) {
      var alsb = (abm ^ (abm & (((-1) + abm) | 0)));
      var blsb = (bbm ^ (bbm & (((-1) + bbm) | 0)));
      if ((alsb === blsb)) {
        var sub1 = a.get(ai).intersect0__sci_HashSet__I__Asci_HashSet__I__sci_HashSet(b.get(bi), ((5 + level) | 0), buffer, offset);
        if ((sub1 !== null)) {
          rs = ((rs + sub1.size__I()) | 0);
          rbm = (rbm | alsb);
          buffer.set(offset, sub1);
          offset = ((1 + offset) | 0)
        };
        abm = (abm & (~alsb));
        ai = ((1 + ai) | 0);
        bbm = (bbm & (~blsb));
        bi = ((1 + bi) | 0)
      } else {
        var i = (((-1) + alsb) | 0);
        var j = (((-1) + blsb) | 0);
        if ((((i < j) !== (i < 0)) !== (j < 0))) {
          abm = (abm & (~alsb));
          ai = ((1 + ai) | 0)
        } else {
          bbm = (bbm & (~blsb));
          bi = ((1 + bi) | 0)
        }
      }
    };
    if ((rbm === 0)) {
      return null
    } else if ((rs === this.size0$5)) {
      return this
    } else if ((rs === x3.size0$5)) {
      return x3
    } else {
      var length = ((offset - offset0) | 0);
      if (((length === 1) && (!(buffer.get(offset0) instanceof $c_sci_HashSet$HashTrieSet)))) {
        return buffer.get(offset0)
      } else {
        var elems = $newArrayObject($d_sci_HashSet.getArrayOf(), [length]);
        $systemArraycopy(buffer, offset0, elems, 0, length);
        return new $c_sci_HashSet$HashTrieSet().init___I__Asci_HashSet__I(rbm, elems, rs)
      }
    }
  } else {
    return null
  }
});
$c_sci_HashSet$HashTrieSet.prototype.diff0__sci_HashSet__I__Asci_HashSet__I__sci_HashSet = (function(that, level, buffer, offset0) {
  if ((that === this)) {
    return null
  } else if ((that instanceof $c_sci_HashSet$HashSet1)) {
    var x2 = $as_sci_HashSet$HashSet1(that);
    return this.removed0__O__I__I__sci_HashSet(x2.key$6, x2.hash$6, level)
  } else if ((that instanceof $c_sci_HashSet$HashTrieSet)) {
    var x3 = $as_sci_HashSet$HashTrieSet(that);
    var a = this.elems$5;
    var abm = this.bitmap$5;
    var ai = 0;
    var b = x3.elems$5;
    var bbm = x3.bitmap$5;
    var bi = 0;
    var offset = offset0;
    var rs = 0;
    var rbm = 0;
    while ((abm !== 0)) {
      var alsb = (abm ^ (abm & (((-1) + abm) | 0)));
      var blsb = (bbm ^ (bbm & (((-1) + bbm) | 0)));
      if ((alsb === blsb)) {
        var sub1 = a.get(ai).diff0__sci_HashSet__I__Asci_HashSet__I__sci_HashSet(b.get(bi), ((5 + level) | 0), buffer, offset);
        if ((sub1 !== null)) {
          rs = ((rs + sub1.size__I()) | 0);
          rbm = (rbm | alsb);
          buffer.set(offset, sub1);
          offset = ((1 + offset) | 0)
        };
        abm = (abm & (~alsb));
        ai = ((1 + ai) | 0);
        bbm = (bbm & (~blsb));
        bi = ((1 + bi) | 0)
      } else {
        var i = (((-1) + alsb) | 0);
        var j = (((-1) + blsb) | 0);
        if ((((i < j) !== (i < 0)) !== (j < 0))) {
          var sub1$2 = a.get(ai);
          rs = ((rs + sub1$2.size__I()) | 0);
          rbm = (rbm | alsb);
          buffer.set(offset, sub1$2);
          offset = ((1 + offset) | 0);
          abm = (abm & (~alsb));
          ai = ((1 + ai) | 0)
        } else {
          bbm = (bbm & (~blsb));
          bi = ((1 + bi) | 0)
        }
      }
    };
    if ((rbm === 0)) {
      return null
    } else if ((rs === this.size0$5)) {
      return this
    } else {
      var length = ((offset - offset0) | 0);
      if (((length === 1) && (!(buffer.get(offset0) instanceof $c_sci_HashSet$HashTrieSet)))) {
        return buffer.get(offset0)
      } else {
        var elems = $newArrayObject($d_sci_HashSet.getArrayOf(), [length]);
        $systemArraycopy(buffer, offset0, elems, 0, length);
        return new $c_sci_HashSet$HashTrieSet().init___I__Asci_HashSet__I(rbm, elems, rs)
      }
    }
  } else if ((that instanceof $c_sci_HashSet$HashSetCollision1)) {
    var x4 = $as_sci_HashSet$HashSetCollision1(that);
    return this.removeAll$1__p5__sci_HashSet__sci_ListSet__sci_HashSet$HashSetCollision1__I__sci_HashSet(this, x4.ks$6, x4, level)
  } else {
    return this
  }
});
$c_sci_HashSet$HashTrieSet.prototype.init___I__Asci_HashSet__I = (function(bitmap, elems, size0) {
  this.bitmap$5 = bitmap;
  this.elems$5 = elems;
  this.size0$5 = size0;
  $m_s_Predef$().assert__Z__V(($m_jl_Integer$().bitCount__I__I(bitmap) === elems.u.length));
  return this
});
$c_sci_HashSet$HashTrieSet.prototype.filter0__F1__Z__I__Asci_HashSet__I__sci_HashSet = (function(p, negate, level, buffer, offset0) {
  var offset = offset0;
  var rs = 0;
  var kept = 0;
  var i = 0;
  while ((i < this.elems$5.u.length)) {
    var result = this.elems$5.get(i).filter0__F1__Z__I__Asci_HashSet__I__sci_HashSet(p, negate, ((5 + level) | 0), buffer, offset);
    if ((result !== null)) {
      buffer.set(offset, result);
      offset = ((1 + offset) | 0);
      rs = ((rs + result.size__I()) | 0);
      kept = (kept | (1 << i))
    };
    i = ((1 + i) | 0)
  };
  if ((offset === offset0)) {
    return null
  } else if ((rs === this.size0$5)) {
    return this
  } else if (((offset === ((1 + offset0) | 0)) && (!(buffer.get(offset0) instanceof $c_sci_HashSet$HashTrieSet)))) {
    return buffer.get(offset0)
  } else {
    var length = ((offset - offset0) | 0);
    var elems1 = $newArrayObject($d_sci_HashSet.getArrayOf(), [length]);
    $systemArraycopy(buffer, offset0, elems1, 0, length);
    var bitmap1 = ((length === this.elems$5.u.length) ? this.bitmap$5 : $m_sci_HashSet$().scala$collection$immutable$HashSet$$keepBits__I__I__I(this.bitmap$5, kept));
    return new $c_sci_HashSet$HashTrieSet().init___I__Asci_HashSet__I(bitmap1, elems1, rs)
  }
});
$c_sci_HashSet$HashTrieSet.prototype.get0__O__I__I__Z = (function(key, hash, level) {
  var index = (31 & ((hash >>> level) | 0));
  var mask = (1 << index);
  if ((this.bitmap$5 === (-1))) {
    return this.elems$5.get((31 & index)).get0__O__I__I__Z(key, hash, ((5 + level) | 0))
  } else if (((this.bitmap$5 & mask) !== 0)) {
    var offset = $m_jl_Integer$().bitCount__I__I((this.bitmap$5 & (((-1) + mask) | 0)));
    return this.elems$5.get(offset).get0__O__I__I__Z(key, hash, ((5 + level) | 0))
  } else {
    return false
  }
});
$c_sci_HashSet$HashTrieSet.prototype.subsetOf0__sci_HashSet__I__Z = (function(that, level) {
  if ((that === this)) {
    return true
  } else {
    if ((that instanceof $c_sci_HashSet$HashTrieSet)) {
      var x2 = $as_sci_HashSet$HashTrieSet(that);
      if ((this.size0$5 <= x2.size0$5)) {
        var abm = this.bitmap$5;
        var a = this.elems$5;
        var ai = 0;
        var b = x2.elems$5;
        var bbm = x2.bitmap$5;
        var bi = 0;
        if (((abm & bbm) === abm)) {
          while ((abm !== 0)) {
            var alsb = (abm ^ (abm & (((-1) + abm) | 0)));
            var blsb = (bbm ^ (bbm & (((-1) + bbm) | 0)));
            if ((alsb === blsb)) {
              if ((!a.get(ai).subsetOf0__sci_HashSet__I__Z(b.get(bi), ((5 + level) | 0)))) {
                return false
              };
              abm = (abm & (~alsb));
              ai = ((1 + ai) | 0)
            };
            bbm = (bbm & (~blsb));
            bi = ((1 + bi) | 0)
          };
          return true
        } else {
          return false
        }
      }
    };
    return false
  }
});
function $as_sci_HashSet$HashTrieSet(obj) {
  return (((obj instanceof $c_sci_HashSet$HashTrieSet) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.HashSet$HashTrieSet"))
}
function $isArrayOf_sci_HashSet$HashTrieSet(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_HashSet$HashTrieSet)))
}
function $asArrayOf_sci_HashSet$HashTrieSet(obj, depth) {
  return (($isArrayOf_sci_HashSet$HashTrieSet(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.HashSet$HashTrieSet;", depth))
}
var $d_sci_HashSet$HashTrieSet = new $TypeData().initClass({
  sci_HashSet$HashTrieSet: 0
}, false, "scala.collection.immutable.HashSet$HashTrieSet", {
  sci_HashSet$HashTrieSet: 1,
  sci_HashSet: 1,
  sc_AbstractSet: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Set: 1,
  F1: 1,
  sc_GenSet: 1,
  sc_GenSetLike: 1,
  scg_GenericSetTemplate: 1,
  sc_SetLike: 1,
  scg_Subtractable: 1,
  sci_Set: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_HashSet$HashTrieSet.prototype.$classData = $d_sci_HashSet$HashTrieSet;
/** @constructor */
function $c_sci_HashSet$LeafHashSet() {
  $c_sci_HashSet.call(this)
}
$c_sci_HashSet$LeafHashSet.prototype = new $h_sci_HashSet();
$c_sci_HashSet$LeafHashSet.prototype.constructor = $c_sci_HashSet$LeafHashSet;
/** @constructor */
function $h_sci_HashSet$LeafHashSet() {
  /*<skip>*/
}
$h_sci_HashSet$LeafHashSet.prototype = $c_sci_HashSet$LeafHashSet.prototype;
function $as_sci_HashSet$LeafHashSet(obj) {
  return (((obj instanceof $c_sci_HashSet$LeafHashSet) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.HashSet$LeafHashSet"))
}
function $isArrayOf_sci_HashSet$LeafHashSet(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_HashSet$LeafHashSet)))
}
function $asArrayOf_sci_HashSet$LeafHashSet(obj, depth) {
  return (($isArrayOf_sci_HashSet$LeafHashSet(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.HashSet$LeafHashSet;", depth))
}
/** @constructor */
function $c_sci_ListMap() {
  $c_sci_AbstractMap.call(this)
}
$c_sci_ListMap.prototype = new $h_sci_AbstractMap();
$c_sci_ListMap.prototype.constructor = $c_sci_ListMap;
/** @constructor */
function $h_sci_ListMap() {
  /*<skip>*/
}
$h_sci_ListMap.prototype = $c_sci_ListMap.prototype;
$c_sci_ListMap.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_sci_ListMap.prototype.value__O = (function() {
  throw new $c_ju_NoSuchElementException().init___T("value of empty map")
});
$c_sci_ListMap.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return this.$$minus__O__sci_ListMap(elem)
});
$c_sci_ListMap.prototype.isEmpty__Z = (function() {
  return true
});
$c_sci_ListMap.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_ListMap.prototype.$$plus__T2__sci_Map = (function(kv) {
  return this.$$plus__T2__sci_ListMap(kv)
});
$c_sci_ListMap.prototype.empty__sc_Map = (function() {
  return $m_sci_ListMap$EmptyListMap$()
});
$c_sci_ListMap.prototype.$$minus__O__sc_Map = (function(key) {
  return this.$$minus__O__sci_ListMap(key)
});
$c_sci_ListMap.prototype.empty__sci_Map = (function() {
  return $m_sci_ListMap$EmptyListMap$()
});
$c_sci_ListMap.prototype.size__I = (function() {
  return 0
});
$c_sci_ListMap.prototype.$$plus$plus__sc_GenTraversableOnce__sci_Map = (function(xs) {
  return this.$$plus$plus__sc_GenTraversableOnce__sci_ListMap(xs)
});
$c_sci_ListMap.prototype.seq__sc_Map = (function() {
  return this
});
$c_sci_ListMap.prototype.key__O = (function() {
  throw new $c_ju_NoSuchElementException().init___T("key of empty map")
});
$c_sci_ListMap.prototype.iterator__sc_Iterator = (function() {
  var this$1 = this.reverseList$1__p5__sci_List();
  return new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$1)
});
$c_sci_ListMap.prototype.$$plus__T2__sci_ListMap = (function(kv) {
  return new $c_sci_ListMap$Node().init___sci_ListMap__O__O(this, kv.$$und1__O(), kv.$$und2__O())
});
$c_sci_ListMap.prototype.$$plus$plus__sc_GenTraversableOnce__sci_ListMap = (function(xs) {
  return (xs.isEmpty__Z() ? this : $as_sci_ListMap(xs.$$div$colon__O__F2__O(this, new $c_sjsr_AnonFunction2().init___sjs_js_Function2((function($this) {
    return (function(x$2$2, x$3$2) {
      var x$2 = $as_sci_ListMap(x$2$2);
      var x$3 = $as_T2(x$3$2);
      return x$2.$$plus__T2__sci_ListMap(x$3)
    })
  })(this)))))
});
$c_sci_ListMap.prototype.updated__O__O__sci_Map = (function(key, value) {
  return this.updated__O__O__sci_ListMap(key, value)
});
$c_sci_ListMap.prototype.updated__O__O__sci_ListMap = (function(key, value) {
  return new $c_sci_ListMap$Node().init___sci_ListMap__O__O(this, key, value)
});
$c_sci_ListMap.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_MapLike__filterNot__F1__sc_Map(this, p)
});
$c_sci_ListMap.prototype.$$minus__O__sci_ListMap = (function(key) {
  return this
});
$c_sci_ListMap.prototype.get__O__s_Option = (function(key) {
  return $m_s_None$()
});
$c_sci_ListMap.prototype.reverseList$1__p5__sci_List = (function() {
  var curr = this;
  var res = $m_sci_Nil$();
  while ((!curr.isEmpty__Z())) {
    var x$4 = new $c_T2().init___O__O(curr.key__O(), curr.value__O());
    var this$1 = res;
    res = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$1);
    curr = curr.next__sci_ListMap()
  };
  return res
});
$c_sci_ListMap.prototype.keySet__sc_Set = (function() {
  return new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(this)
});
$c_sci_ListMap.prototype.toSeq__sc_GenSeq = (function() {
  return $f_sc_MapLike__toSeq__sc_Seq(this)
});
$c_sci_ListMap.prototype.next__sci_ListMap = (function() {
  throw new $c_ju_NoSuchElementException().init___T("next of empty map")
});
$c_sci_ListMap.prototype.$$plus__T2__sc_GenMap = (function(kv) {
  return this.$$plus__T2__sci_ListMap(kv)
});
$c_sci_ListMap.prototype.stringPrefix__T = (function() {
  return "ListMap"
});
function $as_sci_ListMap(obj) {
  return (((obj instanceof $c_sci_ListMap) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.ListMap"))
}
function $isArrayOf_sci_ListMap(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_ListMap)))
}
function $asArrayOf_sci_ListMap(obj, depth) {
  return (($isArrayOf_sci_ListMap(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.ListMap;", depth))
}
/** @constructor */
function $c_sci_Map$EmptyMap$() {
  $c_sci_AbstractMap.call(this)
}
$c_sci_Map$EmptyMap$.prototype = new $h_sci_AbstractMap();
$c_sci_Map$EmptyMap$.prototype.constructor = $c_sci_Map$EmptyMap$;
/** @constructor */
function $h_sci_Map$EmptyMap$() {
  /*<skip>*/
}
$h_sci_Map$EmptyMap$.prototype = $c_sci_Map$EmptyMap$.prototype;
$c_sci_Map$EmptyMap$.prototype.init___ = (function() {
  return this
});
$c_sci_Map$EmptyMap$.prototype.apply__O__O = (function(key) {
  this.apply__O__sr_Nothing$(key)
});
$c_sci_Map$EmptyMap$.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return this
});
$c_sci_Map$EmptyMap$.prototype.getOrElse__O__F0__O = (function(key, $default) {
  return $default.apply__O()
});
$c_sci_Map$EmptyMap$.prototype.$$plus__T2__sci_Map = (function(kv) {
  var key = kv.$$und1__O();
  var value = kv.$$und2__O();
  return new $c_sci_Map$Map1().init___O__O(key, value)
});
$c_sci_Map$EmptyMap$.prototype.$$minus__O__sc_Map = (function(key) {
  return this
});
$c_sci_Map$EmptyMap$.prototype.size__I = (function() {
  return 0
});
$c_sci_Map$EmptyMap$.prototype.iterator__sc_Iterator = (function() {
  return $m_sc_Iterator$().empty$1
});
$c_sci_Map$EmptyMap$.prototype.updated__O__O__sci_Map = (function(key, value) {
  return new $c_sci_Map$Map1().init___O__O(key, value)
});
$c_sci_Map$EmptyMap$.prototype.get__O__s_Option = (function(key) {
  return $m_s_None$()
});
$c_sci_Map$EmptyMap$.prototype.contains__O__Z = (function(key) {
  return false
});
$c_sci_Map$EmptyMap$.prototype.apply__O__sr_Nothing$ = (function(key) {
  throw new $c_ju_NoSuchElementException().init___T(("key not found: " + key))
});
$c_sci_Map$EmptyMap$.prototype.$$plus__T2__sc_GenMap = (function(kv) {
  var key = kv.$$und1__O();
  var value = kv.$$und2__O();
  return new $c_sci_Map$Map1().init___O__O(key, value)
});
var $d_sci_Map$EmptyMap$ = new $TypeData().initClass({
  sci_Map$EmptyMap$: 0
}, false, "scala.collection.immutable.Map$EmptyMap$", {
  sci_Map$EmptyMap$: 1,
  sci_AbstractMap: 1,
  sc_AbstractMap: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Map: 1,
  sc_GenMap: 1,
  sc_GenMapLike: 1,
  sc_MapLike: 1,
  s_PartialFunction: 1,
  F1: 1,
  scg_Subtractable: 1,
  sci_Map: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sci_MapLike: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_Map$EmptyMap$.prototype.$classData = $d_sci_Map$EmptyMap$;
var $n_sci_Map$EmptyMap$ = (void 0);
function $m_sci_Map$EmptyMap$() {
  if ((!$n_sci_Map$EmptyMap$)) {
    $n_sci_Map$EmptyMap$ = new $c_sci_Map$EmptyMap$().init___()
  };
  return $n_sci_Map$EmptyMap$
}
/** @constructor */
function $c_sci_Map$Map1() {
  $c_sci_AbstractMap.call(this);
  this.key1$5 = null;
  this.value1$5 = null
}
$c_sci_Map$Map1.prototype = new $h_sci_AbstractMap();
$c_sci_Map$Map1.prototype.constructor = $c_sci_Map$Map1;
/** @constructor */
function $h_sci_Map$Map1() {
  /*<skip>*/
}
$h_sci_Map$Map1.prototype = $c_sci_Map$Map1.prototype;
$c_sci_Map$Map1.prototype.apply__O__O = (function(key) {
  if ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5)) {
    return this.value1$5
  } else {
    throw new $c_ju_NoSuchElementException().init___T(("key not found: " + key))
  }
});
$c_sci_Map$Map1.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return this.$$minus__O__sci_Map(elem)
});
$c_sci_Map$Map1.prototype.getOrElse__O__F0__O = (function(key, $default) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5) ? this.value1$5 : $default.apply__O())
});
$c_sci_Map$Map1.prototype.init___O__O = (function(key1, value1) {
  this.key1$5 = key1;
  this.value1$5 = value1;
  return this
});
$c_sci_Map$Map1.prototype.$$plus__T2__sci_Map = (function(kv) {
  return this.updated__O__O__sci_Map(kv.$$und1__O(), kv.$$und2__O())
});
$c_sci_Map$Map1.prototype.foreach__F1__V = (function(f) {
  f.apply__O__O(new $c_T2().init___O__O(this.key1$5, this.value1$5))
});
$c_sci_Map$Map1.prototype.$$minus__O__sc_Map = (function(key) {
  return this.$$minus__O__sci_Map(key)
});
$c_sci_Map$Map1.prototype.size__I = (function() {
  return 1
});
$c_sci_Map$Map1.prototype.iterator__sc_Iterator = (function() {
  $m_sc_Iterator$();
  var array = [new $c_T2().init___O__O(this.key1$5, this.value1$5)];
  var elems = new $c_sjs_js_WrappedArray().init___sjs_js_Array(array);
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(elems, 0, $uI(elems.array$6.length))
});
$c_sci_Map$Map1.prototype.updated__O__O__sci_Map = (function(key, value) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5) ? new $c_sci_Map$Map1().init___O__O(this.key1$5, value) : new $c_sci_Map$Map2().init___O__O__O__O(this.key1$5, this.value1$5, key, value))
});
$c_sci_Map$Map1.prototype.get__O__s_Option = (function(key) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5) ? new $c_s_Some().init___O(this.value1$5) : $m_s_None$())
});
$c_sci_Map$Map1.prototype.contains__O__Z = (function(key) {
  return $m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5)
});
$c_sci_Map$Map1.prototype.$$minus__O__sci_Map = (function(key) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5) ? $m_sci_Map$EmptyMap$() : this)
});
$c_sci_Map$Map1.prototype.$$plus__T2__sc_GenMap = (function(kv) {
  return this.updated__O__O__sci_Map(kv.$$und1__O(), kv.$$und2__O())
});
var $d_sci_Map$Map1 = new $TypeData().initClass({
  sci_Map$Map1: 0
}, false, "scala.collection.immutable.Map$Map1", {
  sci_Map$Map1: 1,
  sci_AbstractMap: 1,
  sc_AbstractMap: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Map: 1,
  sc_GenMap: 1,
  sc_GenMapLike: 1,
  sc_MapLike: 1,
  s_PartialFunction: 1,
  F1: 1,
  scg_Subtractable: 1,
  sci_Map: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sci_MapLike: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_Map$Map1.prototype.$classData = $d_sci_Map$Map1;
/** @constructor */
function $c_sci_Map$Map2() {
  $c_sci_AbstractMap.call(this);
  this.key1$5 = null;
  this.value1$5 = null;
  this.key2$5 = null;
  this.value2$5 = null
}
$c_sci_Map$Map2.prototype = new $h_sci_AbstractMap();
$c_sci_Map$Map2.prototype.constructor = $c_sci_Map$Map2;
/** @constructor */
function $h_sci_Map$Map2() {
  /*<skip>*/
}
$h_sci_Map$Map2.prototype = $c_sci_Map$Map2.prototype;
$c_sci_Map$Map2.prototype.apply__O__O = (function(key) {
  if ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5)) {
    return this.value1$5
  } else if ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key2$5)) {
    return this.value2$5
  } else {
    throw new $c_ju_NoSuchElementException().init___T(("key not found: " + key))
  }
});
$c_sci_Map$Map2.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return this.$$minus__O__sci_Map(elem)
});
$c_sci_Map$Map2.prototype.getOrElse__O__F0__O = (function(key, $default) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5) ? this.value1$5 : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key2$5) ? this.value2$5 : $default.apply__O()))
});
$c_sci_Map$Map2.prototype.$$plus__T2__sci_Map = (function(kv) {
  return this.updated__O__O__sci_Map(kv.$$und1__O(), kv.$$und2__O())
});
$c_sci_Map$Map2.prototype.foreach__F1__V = (function(f) {
  f.apply__O__O(new $c_T2().init___O__O(this.key1$5, this.value1$5));
  f.apply__O__O(new $c_T2().init___O__O(this.key2$5, this.value2$5))
});
$c_sci_Map$Map2.prototype.$$minus__O__sc_Map = (function(key) {
  return this.$$minus__O__sci_Map(key)
});
$c_sci_Map$Map2.prototype.size__I = (function() {
  return 2
});
$c_sci_Map$Map2.prototype.iterator__sc_Iterator = (function() {
  $m_sc_Iterator$();
  var array = [new $c_T2().init___O__O(this.key1$5, this.value1$5), new $c_T2().init___O__O(this.key2$5, this.value2$5)];
  var elems = new $c_sjs_js_WrappedArray().init___sjs_js_Array(array);
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(elems, 0, $uI(elems.array$6.length))
});
$c_sci_Map$Map2.prototype.updated__O__O__sci_Map = (function(key, value) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5) ? new $c_sci_Map$Map2().init___O__O__O__O(this.key1$5, value, this.key2$5, this.value2$5) : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key2$5) ? new $c_sci_Map$Map2().init___O__O__O__O(this.key1$5, this.value1$5, this.key2$5, value) : new $c_sci_Map$Map3().init___O__O__O__O__O__O(this.key1$5, this.value1$5, this.key2$5, this.value2$5, key, value)))
});
$c_sci_Map$Map2.prototype.get__O__s_Option = (function(key) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5) ? new $c_s_Some().init___O(this.value1$5) : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key2$5) ? new $c_s_Some().init___O(this.value2$5) : $m_s_None$()))
});
$c_sci_Map$Map2.prototype.contains__O__Z = (function(key) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5) || $m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key2$5))
});
$c_sci_Map$Map2.prototype.init___O__O__O__O = (function(key1, value1, key2, value2) {
  this.key1$5 = key1;
  this.value1$5 = value1;
  this.key2$5 = key2;
  this.value2$5 = value2;
  return this
});
$c_sci_Map$Map2.prototype.$$minus__O__sci_Map = (function(key) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5) ? new $c_sci_Map$Map1().init___O__O(this.key2$5, this.value2$5) : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key2$5) ? new $c_sci_Map$Map1().init___O__O(this.key1$5, this.value1$5) : this))
});
$c_sci_Map$Map2.prototype.$$plus__T2__sc_GenMap = (function(kv) {
  return this.updated__O__O__sci_Map(kv.$$und1__O(), kv.$$und2__O())
});
var $d_sci_Map$Map2 = new $TypeData().initClass({
  sci_Map$Map2: 0
}, false, "scala.collection.immutable.Map$Map2", {
  sci_Map$Map2: 1,
  sci_AbstractMap: 1,
  sc_AbstractMap: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Map: 1,
  sc_GenMap: 1,
  sc_GenMapLike: 1,
  sc_MapLike: 1,
  s_PartialFunction: 1,
  F1: 1,
  scg_Subtractable: 1,
  sci_Map: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sci_MapLike: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_Map$Map2.prototype.$classData = $d_sci_Map$Map2;
/** @constructor */
function $c_sci_Map$Map3() {
  $c_sci_AbstractMap.call(this);
  this.key1$5 = null;
  this.value1$5 = null;
  this.key2$5 = null;
  this.value2$5 = null;
  this.key3$5 = null;
  this.value3$5 = null
}
$c_sci_Map$Map3.prototype = new $h_sci_AbstractMap();
$c_sci_Map$Map3.prototype.constructor = $c_sci_Map$Map3;
/** @constructor */
function $h_sci_Map$Map3() {
  /*<skip>*/
}
$h_sci_Map$Map3.prototype = $c_sci_Map$Map3.prototype;
$c_sci_Map$Map3.prototype.apply__O__O = (function(key) {
  if ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5)) {
    return this.value1$5
  } else if ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key2$5)) {
    return this.value2$5
  } else if ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key3$5)) {
    return this.value3$5
  } else {
    throw new $c_ju_NoSuchElementException().init___T(("key not found: " + key))
  }
});
$c_sci_Map$Map3.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return this.$$minus__O__sci_Map(elem)
});
$c_sci_Map$Map3.prototype.getOrElse__O__F0__O = (function(key, $default) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5) ? this.value1$5 : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key2$5) ? this.value2$5 : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key3$5) ? this.value3$5 : $default.apply__O())))
});
$c_sci_Map$Map3.prototype.$$plus__T2__sci_Map = (function(kv) {
  return this.updated__O__O__sci_Map(kv.$$und1__O(), kv.$$und2__O())
});
$c_sci_Map$Map3.prototype.foreach__F1__V = (function(f) {
  f.apply__O__O(new $c_T2().init___O__O(this.key1$5, this.value1$5));
  f.apply__O__O(new $c_T2().init___O__O(this.key2$5, this.value2$5));
  f.apply__O__O(new $c_T2().init___O__O(this.key3$5, this.value3$5))
});
$c_sci_Map$Map3.prototype.$$minus__O__sc_Map = (function(key) {
  return this.$$minus__O__sci_Map(key)
});
$c_sci_Map$Map3.prototype.init___O__O__O__O__O__O = (function(key1, value1, key2, value2, key3, value3) {
  this.key1$5 = key1;
  this.value1$5 = value1;
  this.key2$5 = key2;
  this.value2$5 = value2;
  this.key3$5 = key3;
  this.value3$5 = value3;
  return this
});
$c_sci_Map$Map3.prototype.size__I = (function() {
  return 3
});
$c_sci_Map$Map3.prototype.iterator__sc_Iterator = (function() {
  $m_sc_Iterator$();
  var array = [new $c_T2().init___O__O(this.key1$5, this.value1$5), new $c_T2().init___O__O(this.key2$5, this.value2$5), new $c_T2().init___O__O(this.key3$5, this.value3$5)];
  var elems = new $c_sjs_js_WrappedArray().init___sjs_js_Array(array);
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(elems, 0, $uI(elems.array$6.length))
});
$c_sci_Map$Map3.prototype.updated__O__O__sci_Map = (function(key, value) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5) ? new $c_sci_Map$Map3().init___O__O__O__O__O__O(this.key1$5, value, this.key2$5, this.value2$5, this.key3$5, this.value3$5) : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key2$5) ? new $c_sci_Map$Map3().init___O__O__O__O__O__O(this.key1$5, this.value1$5, this.key2$5, value, this.key3$5, this.value3$5) : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key3$5) ? new $c_sci_Map$Map3().init___O__O__O__O__O__O(this.key1$5, this.value1$5, this.key2$5, this.value2$5, this.key3$5, value) : new $c_sci_Map$Map4().init___O__O__O__O__O__O__O__O(this.key1$5, this.value1$5, this.key2$5, this.value2$5, this.key3$5, this.value3$5, key, value))))
});
$c_sci_Map$Map3.prototype.get__O__s_Option = (function(key) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5) ? new $c_s_Some().init___O(this.value1$5) : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key2$5) ? new $c_s_Some().init___O(this.value2$5) : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key3$5) ? new $c_s_Some().init___O(this.value3$5) : $m_s_None$())))
});
$c_sci_Map$Map3.prototype.contains__O__Z = (function(key) {
  return (($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5) || $m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key2$5)) || $m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key3$5))
});
$c_sci_Map$Map3.prototype.$$minus__O__sci_Map = (function(key) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5) ? new $c_sci_Map$Map2().init___O__O__O__O(this.key2$5, this.value2$5, this.key3$5, this.value3$5) : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key2$5) ? new $c_sci_Map$Map2().init___O__O__O__O(this.key1$5, this.value1$5, this.key3$5, this.value3$5) : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key3$5) ? new $c_sci_Map$Map2().init___O__O__O__O(this.key1$5, this.value1$5, this.key2$5, this.value2$5) : this)))
});
$c_sci_Map$Map3.prototype.$$plus__T2__sc_GenMap = (function(kv) {
  return this.updated__O__O__sci_Map(kv.$$und1__O(), kv.$$und2__O())
});
var $d_sci_Map$Map3 = new $TypeData().initClass({
  sci_Map$Map3: 0
}, false, "scala.collection.immutable.Map$Map3", {
  sci_Map$Map3: 1,
  sci_AbstractMap: 1,
  sc_AbstractMap: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Map: 1,
  sc_GenMap: 1,
  sc_GenMapLike: 1,
  sc_MapLike: 1,
  s_PartialFunction: 1,
  F1: 1,
  scg_Subtractable: 1,
  sci_Map: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sci_MapLike: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_Map$Map3.prototype.$classData = $d_sci_Map$Map3;
/** @constructor */
function $c_sci_Map$Map4() {
  $c_sci_AbstractMap.call(this);
  this.key1$5 = null;
  this.value1$5 = null;
  this.key2$5 = null;
  this.value2$5 = null;
  this.key3$5 = null;
  this.value3$5 = null;
  this.key4$5 = null;
  this.value4$5 = null
}
$c_sci_Map$Map4.prototype = new $h_sci_AbstractMap();
$c_sci_Map$Map4.prototype.constructor = $c_sci_Map$Map4;
/** @constructor */
function $h_sci_Map$Map4() {
  /*<skip>*/
}
$h_sci_Map$Map4.prototype = $c_sci_Map$Map4.prototype;
$c_sci_Map$Map4.prototype.apply__O__O = (function(key) {
  if ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5)) {
    return this.value1$5
  } else if ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key2$5)) {
    return this.value2$5
  } else if ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key3$5)) {
    return this.value3$5
  } else if ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key4$5)) {
    return this.value4$5
  } else {
    throw new $c_ju_NoSuchElementException().init___T(("key not found: " + key))
  }
});
$c_sci_Map$Map4.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return this.$$minus__O__sci_Map(elem)
});
$c_sci_Map$Map4.prototype.getOrElse__O__F0__O = (function(key, $default) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5) ? this.value1$5 : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key2$5) ? this.value2$5 : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key3$5) ? this.value3$5 : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key4$5) ? this.value4$5 : $default.apply__O()))))
});
$c_sci_Map$Map4.prototype.$$plus__T2__sci_Map = (function(kv) {
  return this.updated__O__O__sci_Map(kv.$$und1__O(), kv.$$und2__O())
});
$c_sci_Map$Map4.prototype.foreach__F1__V = (function(f) {
  f.apply__O__O(new $c_T2().init___O__O(this.key1$5, this.value1$5));
  f.apply__O__O(new $c_T2().init___O__O(this.key2$5, this.value2$5));
  f.apply__O__O(new $c_T2().init___O__O(this.key3$5, this.value3$5));
  f.apply__O__O(new $c_T2().init___O__O(this.key4$5, this.value4$5))
});
$c_sci_Map$Map4.prototype.$$minus__O__sc_Map = (function(key) {
  return this.$$minus__O__sci_Map(key)
});
$c_sci_Map$Map4.prototype.size__I = (function() {
  return 4
});
$c_sci_Map$Map4.prototype.iterator__sc_Iterator = (function() {
  $m_sc_Iterator$();
  var array = [new $c_T2().init___O__O(this.key1$5, this.value1$5), new $c_T2().init___O__O(this.key2$5, this.value2$5), new $c_T2().init___O__O(this.key3$5, this.value3$5), new $c_T2().init___O__O(this.key4$5, this.value4$5)];
  var elems = new $c_sjs_js_WrappedArray().init___sjs_js_Array(array);
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(elems, 0, $uI(elems.array$6.length))
});
$c_sci_Map$Map4.prototype.init___O__O__O__O__O__O__O__O = (function(key1, value1, key2, value2, key3, value3, key4, value4) {
  this.key1$5 = key1;
  this.value1$5 = value1;
  this.key2$5 = key2;
  this.value2$5 = value2;
  this.key3$5 = key3;
  this.value3$5 = value3;
  this.key4$5 = key4;
  this.value4$5 = value4;
  return this
});
$c_sci_Map$Map4.prototype.updated__O__O__sci_Map = (function(key, value) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5) ? new $c_sci_Map$Map4().init___O__O__O__O__O__O__O__O(this.key1$5, value, this.key2$5, this.value2$5, this.key3$5, this.value3$5, this.key4$5, this.value4$5) : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key2$5) ? new $c_sci_Map$Map4().init___O__O__O__O__O__O__O__O(this.key1$5, this.value1$5, this.key2$5, value, this.key3$5, this.value3$5, this.key4$5, this.value4$5) : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key3$5) ? new $c_sci_Map$Map4().init___O__O__O__O__O__O__O__O(this.key1$5, this.value1$5, this.key2$5, this.value2$5, this.key3$5, value, this.key4$5, this.value4$5) : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key4$5) ? new $c_sci_Map$Map4().init___O__O__O__O__O__O__O__O(this.key1$5, this.value1$5, this.key2$5, this.value2$5, this.key3$5, this.value3$5, this.key4$5, value) : new $c_sci_HashMap().init___().updated__O__O__sci_HashMap(this.key1$5, this.value1$5).updated__O__O__sci_HashMap(this.key2$5, this.value2$5).updated__O__O__sci_HashMap(this.key3$5, this.value3$5).updated__O__O__sci_HashMap(this.key4$5, this.value4$5).updated__O__O__sci_HashMap(key, value)))))
});
$c_sci_Map$Map4.prototype.get__O__s_Option = (function(key) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5) ? new $c_s_Some().init___O(this.value1$5) : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key2$5) ? new $c_s_Some().init___O(this.value2$5) : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key3$5) ? new $c_s_Some().init___O(this.value3$5) : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key4$5) ? new $c_s_Some().init___O(this.value4$5) : $m_s_None$()))))
});
$c_sci_Map$Map4.prototype.contains__O__Z = (function(key) {
  return ((($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5) || $m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key2$5)) || $m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key3$5)) || $m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key4$5))
});
$c_sci_Map$Map4.prototype.$$minus__O__sci_Map = (function(key) {
  return ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key1$5) ? new $c_sci_Map$Map3().init___O__O__O__O__O__O(this.key2$5, this.value2$5, this.key3$5, this.value3$5, this.key4$5, this.value4$5) : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key2$5) ? new $c_sci_Map$Map3().init___O__O__O__O__O__O(this.key1$5, this.value1$5, this.key3$5, this.value3$5, this.key4$5, this.value4$5) : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key3$5) ? new $c_sci_Map$Map3().init___O__O__O__O__O__O(this.key1$5, this.value1$5, this.key2$5, this.value2$5, this.key4$5, this.value4$5) : ($m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key4$5) ? new $c_sci_Map$Map3().init___O__O__O__O__O__O(this.key1$5, this.value1$5, this.key2$5, this.value2$5, this.key3$5, this.value3$5) : this))))
});
$c_sci_Map$Map4.prototype.$$plus__T2__sc_GenMap = (function(kv) {
  return this.updated__O__O__sci_Map(kv.$$und1__O(), kv.$$und2__O())
});
var $d_sci_Map$Map4 = new $TypeData().initClass({
  sci_Map$Map4: 0
}, false, "scala.collection.immutable.Map$Map4", {
  sci_Map$Map4: 1,
  sci_AbstractMap: 1,
  sc_AbstractMap: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Map: 1,
  sc_GenMap: 1,
  sc_GenMapLike: 1,
  sc_MapLike: 1,
  s_PartialFunction: 1,
  F1: 1,
  scg_Subtractable: 1,
  sci_Map: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sci_MapLike: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_Map$Map4.prototype.$classData = $d_sci_Map$Map4;
/** @constructor */
function $c_sci_MapLike$$anon$1() {
  $c_sc_MapLike$FilteredKeys.call(this)
}
$c_sci_MapLike$$anon$1.prototype = new $h_sc_MapLike$FilteredKeys();
$c_sci_MapLike$$anon$1.prototype.constructor = $c_sci_MapLike$$anon$1;
/** @constructor */
function $h_sci_MapLike$$anon$1() {
  /*<skip>*/
}
$h_sci_MapLike$$anon$1.prototype = $c_sci_MapLike$$anon$1.prototype;
$c_sci_MapLike$$anon$1.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sci_MapLike$$anon$1.prototype.init___sci_MapLike__F1 = (function($$outer, p$1) {
  $c_sc_MapLike$FilteredKeys.prototype.init___sc_MapLike__F1.call(this, $$outer, p$1);
  return this
});
$c_sci_MapLike$$anon$1.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_sci_MapLike$$anon$1.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return $f_sci_DefaultMap__$$minus__O__sci_Map(this, elem)
});
$c_sci_MapLike$$anon$1.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sci_MapLike$$anon$1.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_MapLike$$anon$1.prototype.$$plus__T2__sc_Map = (function(kv) {
  return $f_sci_DefaultMap__$$plus__T2__sci_Map(this, kv)
});
$c_sci_MapLike$$anon$1.prototype.$$plus__T2__sci_Map = (function(kv) {
  return $f_sci_DefaultMap__$$plus__T2__sci_Map(this, kv)
});
$c_sci_MapLike$$anon$1.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sci_Iterable$()
});
$c_sci_MapLike$$anon$1.prototype.$$minus__O__sc_Map = (function(key) {
  return $f_sci_DefaultMap__$$minus__O__sci_Map(this, key)
});
$c_sci_MapLike$$anon$1.prototype.empty__sc_Map = (function() {
  return $m_sci_Map$EmptyMap$()
});
$c_sci_MapLike$$anon$1.prototype.$$plus$plus__sc_GenTraversableOnce__sci_Map = (function(xs) {
  return $f_sci_MapLike__$$plus$plus__sc_GenTraversableOnce__sci_Map(this, xs)
});
$c_sci_MapLike$$anon$1.prototype.seq__sc_Map = (function() {
  return this
});
$c_sci_MapLike$$anon$1.prototype.updated__O__O__sci_Map = (function(key, value) {
  return $f_sci_MapLike__updated__O__O__sci_Map(this, key, value)
});
$c_sci_MapLike$$anon$1.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_MapLike__filterNot__F1__sc_Map(this, p)
});
$c_sci_MapLike$$anon$1.prototype.keySet__sc_Set = (function() {
  return new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(this)
});
$c_sci_MapLike$$anon$1.prototype.toSeq__sc_GenSeq = (function() {
  return $f_sc_MapLike__toSeq__sc_Seq(this)
});
$c_sci_MapLike$$anon$1.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  return this
});
$c_sci_MapLike$$anon$1.prototype.$$plus__T2__sc_GenMap = (function(kv) {
  return $f_sci_DefaultMap__$$plus__T2__sci_Map(this, kv)
});
var $d_sci_MapLike$$anon$1 = new $TypeData().initClass({
  sci_MapLike$$anon$1: 0
}, false, "scala.collection.immutable.MapLike$$anon$1", {
  sci_MapLike$$anon$1: 1,
  sc_MapLike$FilteredKeys: 1,
  sc_AbstractMap: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Map: 1,
  sc_GenMap: 1,
  sc_GenMapLike: 1,
  sc_MapLike: 1,
  s_PartialFunction: 1,
  F1: 1,
  scg_Subtractable: 1,
  sc_DefaultMap: 1,
  sci_DefaultMap: 1,
  sci_Map: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sci_MapLike: 1
});
$c_sci_MapLike$$anon$1.prototype.$classData = $d_sci_MapLike$$anon$1;
/** @constructor */
function $c_sci_MapLike$$anon$2() {
  $c_sc_MapLike$MappedValues.call(this)
}
$c_sci_MapLike$$anon$2.prototype = new $h_sc_MapLike$MappedValues();
$c_sci_MapLike$$anon$2.prototype.constructor = $c_sci_MapLike$$anon$2;
/** @constructor */
function $h_sci_MapLike$$anon$2() {
  /*<skip>*/
}
$h_sci_MapLike$$anon$2.prototype = $c_sci_MapLike$$anon$2.prototype;
$c_sci_MapLike$$anon$2.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sci_MapLike$$anon$2.prototype.init___sci_MapLike__F1 = (function($$outer, f$1) {
  $c_sc_MapLike$MappedValues.prototype.init___sc_MapLike__F1.call(this, $$outer, f$1);
  return this
});
$c_sci_MapLike$$anon$2.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_sci_MapLike$$anon$2.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return $f_sci_DefaultMap__$$minus__O__sci_Map(this, elem)
});
$c_sci_MapLike$$anon$2.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sci_MapLike$$anon$2.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_MapLike$$anon$2.prototype.$$plus__T2__sci_Map = (function(kv) {
  return $f_sci_DefaultMap__$$plus__T2__sci_Map(this, kv)
});
$c_sci_MapLike$$anon$2.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sci_Iterable$()
});
$c_sci_MapLike$$anon$2.prototype.$$minus__O__sc_Map = (function(key) {
  return $f_sci_DefaultMap__$$minus__O__sci_Map(this, key)
});
$c_sci_MapLike$$anon$2.prototype.empty__sc_Map = (function() {
  return $m_sci_Map$EmptyMap$()
});
$c_sci_MapLike$$anon$2.prototype.$$plus$plus__sc_GenTraversableOnce__sci_Map = (function(xs) {
  return $f_sci_MapLike__$$plus$plus__sc_GenTraversableOnce__sci_Map(this, xs)
});
$c_sci_MapLike$$anon$2.prototype.seq__sc_Map = (function() {
  return this
});
$c_sci_MapLike$$anon$2.prototype.updated__O__O__sci_Map = (function(key, value) {
  return $f_sci_MapLike__updated__O__O__sci_Map(this, key, value)
});
$c_sci_MapLike$$anon$2.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_MapLike__filterNot__F1__sc_Map(this, p)
});
$c_sci_MapLike$$anon$2.prototype.keySet__sc_Set = (function() {
  return new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(this)
});
$c_sci_MapLike$$anon$2.prototype.toSeq__sc_GenSeq = (function() {
  return $f_sc_MapLike__toSeq__sc_Seq(this)
});
$c_sci_MapLike$$anon$2.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  return this
});
$c_sci_MapLike$$anon$2.prototype.$$plus__T2__sc_GenMap = (function(kv) {
  return $f_sci_DefaultMap__$$plus__T2__sci_Map(this, kv)
});
var $d_sci_MapLike$$anon$2 = new $TypeData().initClass({
  sci_MapLike$$anon$2: 0
}, false, "scala.collection.immutable.MapLike$$anon$2", {
  sci_MapLike$$anon$2: 1,
  sc_MapLike$MappedValues: 1,
  sc_AbstractMap: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Map: 1,
  sc_GenMap: 1,
  sc_GenMapLike: 1,
  sc_MapLike: 1,
  s_PartialFunction: 1,
  F1: 1,
  scg_Subtractable: 1,
  sc_DefaultMap: 1,
  sci_DefaultMap: 1,
  sci_Map: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sci_MapLike: 1
});
$c_sci_MapLike$$anon$2.prototype.$classData = $d_sci_MapLike$$anon$2;
function $is_scm_Set(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.scm_Set)))
}
function $as_scm_Set(obj) {
  return (($is_scm_Set(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.Set"))
}
function $isArrayOf_scm_Set(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_Set)))
}
function $asArrayOf_scm_Set(obj, depth) {
  return (($isArrayOf_scm_Set(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.Set;", depth))
}
/** @constructor */
function $c_sc_SeqViewLike$$anon$10() {
  $c_sc_SeqViewLike$AbstractTransformed.call(this);
  this.other$2 = null;
  this.thatSeq$2 = null;
  this.bitmap$0$2 = false;
  this.$$outer$2 = null
}
$c_sc_SeqViewLike$$anon$10.prototype = new $h_sc_SeqViewLike$AbstractTransformed();
$c_sc_SeqViewLike$$anon$10.prototype.constructor = $c_sc_SeqViewLike$$anon$10;
/** @constructor */
function $h_sc_SeqViewLike$$anon$10() {
  /*<skip>*/
}
$h_sc_SeqViewLike$$anon$10.prototype = $c_sc_SeqViewLike$$anon$10.prototype;
$c_sc_SeqViewLike$$anon$10.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$Zipped__apply__I__T2(this, idx)
});
$c_sc_SeqViewLike$$anon$10.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$Zipped__apply__I__T2(this, idx)
});
$c_sc_SeqViewLike$$anon$10.prototype.other__sc_GenIterable = (function() {
  return this.other$2
});
$c_sc_SeqViewLike$$anon$10.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_IterableViewLike$Zipped__iterator__sc_Iterator(this)
});
$c_sc_SeqViewLike$$anon$10.prototype.viewIdentifier__T = (function() {
  return "Z"
});
$c_sc_SeqViewLike$$anon$10.prototype.length__I = (function() {
  return $f_sc_SeqViewLike$Zipped__length__I(this)
});
$c_sc_SeqViewLike$$anon$10.prototype.scala$collection$IterableViewLike$Zipped$$$outer__sc_IterableViewLike = (function() {
  return this.$$outer$2
});
$c_sc_SeqViewLike$$anon$10.prototype.thatSeq__sc_Seq = (function() {
  return ((!this.bitmap$0$2) ? this.thatSeq$lzycompute__p2__sc_Seq() : this.thatSeq$2)
});
$c_sc_SeqViewLike$$anon$10.prototype.thatSeq$lzycompute__p2__sc_Seq = (function() {
  if ((!this.bitmap$0$2)) {
    this.thatSeq$2 = $f_sc_SeqViewLike$Zipped__thatSeq__sc_Seq(this);
    this.bitmap$0$2 = true
  };
  return this.thatSeq$2
});
$c_sc_SeqViewLike$$anon$10.prototype.init___sc_SeqViewLike__sc_GenIterable = (function($$outer, that$3) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.other$2 = that$3;
  $c_sc_SeqViewLike$AbstractTransformed.prototype.init___sc_SeqViewLike.call(this, $$outer);
  return this
});
$c_sc_SeqViewLike$$anon$10.prototype.scala$collection$SeqViewLike$Zipped$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$2
});
var $d_sc_SeqViewLike$$anon$10 = new $TypeData().initClass({
  sc_SeqViewLike$$anon$10: 0
}, false, "scala.collection.SeqViewLike$$anon$10", {
  sc_SeqViewLike$$anon$10: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sc_SeqViewLike$Zipped: 1,
  sc_IterableViewLike$Zipped: 1
});
$c_sc_SeqViewLike$$anon$10.prototype.$classData = $d_sc_SeqViewLike$$anon$10;
/** @constructor */
function $c_sci_HashMap() {
  $c_sci_AbstractMap.call(this)
}
$c_sci_HashMap.prototype = new $h_sci_AbstractMap();
$c_sci_HashMap.prototype.constructor = $c_sci_HashMap;
/** @constructor */
function $h_sci_HashMap() {
  /*<skip>*/
}
$h_sci_HashMap.prototype = $c_sci_HashMap.prototype;
$c_sci_HashMap.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sci_HashMap.prototype.computeHash__O__I = (function(key) {
  return this.improve__I__I($m_sr_Statics$().anyHash__O__I(key))
});
$c_sci_HashMap.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_sci_HashMap.prototype.init___ = (function() {
  return this
});
$c_sci_HashMap.prototype.filter__F1__sci_HashMap = (function(p) {
  $m_sci_HashMap$();
  var size = this.size__I();
  var x = ((6 + size) | 0);
  var buffer = $newArrayObject($d_sci_HashMap.getArrayOf(), [((x < 224) ? x : 224)]);
  $m_sci_HashMap$();
  var m = this.filter0__F1__Z__I__Asci_HashMap__I__sci_HashMap(p, false, 0, buffer, 0);
  return ((m === null) ? $m_sci_HashMap$EmptyHashMap$() : m)
});
$c_sci_HashMap.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return this.$$minus__O__sci_HashMap(elem)
});
$c_sci_HashMap.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_HashMap.prototype.updated0__O__I__I__O__T2__sci_HashMap$Merger__sci_HashMap = (function(key, hash, level, value, kv, merger) {
  return new $c_sci_HashMap$HashMap1().init___O__I__O__T2(key, hash, value, kv)
});
$c_sci_HashMap.prototype.get0__O__I__I__s_Option = (function(key, hash, level) {
  return $m_s_None$()
});
$c_sci_HashMap.prototype.$$plus__T2__sci_Map = (function(kv) {
  return this.$$plus__T2__sci_HashMap(kv)
});
$c_sci_HashMap.prototype.foreach__F1__V = (function(f) {
  /*<skip>*/
});
$c_sci_HashMap.prototype.$$plus__T2__sci_HashMap = (function(kv) {
  return this.updated0__O__I__I__O__T2__sci_HashMap$Merger__sci_HashMap(kv.$$und1__O(), this.computeHash__O__I(kv.$$und1__O()), 0, kv.$$und2__O(), kv, null)
});
$c_sci_HashMap.prototype.filterNot__F1__sci_HashMap = (function(p) {
  $m_sci_HashMap$();
  var size = this.size__I();
  var x = ((6 + size) | 0);
  var buffer = $newArrayObject($d_sci_HashMap.getArrayOf(), [((x < 224) ? x : 224)]);
  $m_sci_HashMap$();
  var m = this.filter0__F1__Z__I__Asci_HashMap__I__sci_HashMap(p, true, 0, buffer, 0);
  return ((m === null) ? $m_sci_HashMap$EmptyHashMap$() : m)
});
$c_sci_HashMap.prototype.updated__O__O__sci_HashMap = (function(key, value) {
  return this.updated0__O__I__I__O__T2__sci_HashMap$Merger__sci_HashMap(key, this.computeHash__O__I(key), 0, value, null, null)
});
$c_sci_HashMap.prototype.$$minus__O__sc_Map = (function(key) {
  return this.$$minus__O__sci_HashMap(key)
});
$c_sci_HashMap.prototype.empty__sc_Map = (function() {
  $m_sci_HashMap$();
  return $m_sci_HashMap$EmptyHashMap$()
});
$c_sci_HashMap.prototype.removed0__O__I__I__sci_HashMap = (function(key, hash, level) {
  return this
});
$c_sci_HashMap.prototype.filter0__F1__Z__I__Asci_HashMap__I__sci_HashMap = (function(p, negate, level, buffer, offset0) {
  return null
});
$c_sci_HashMap.prototype.$$minus__O__sci_HashMap = (function(key) {
  return this.removed0__O__I__I__sci_HashMap(key, this.computeHash__O__I(key), 0)
});
$c_sci_HashMap.prototype.filter__F1__O = (function(p) {
  return this.filter__F1__sci_HashMap(p)
});
$c_sci_HashMap.prototype.empty__sci_Map = (function() {
  $m_sci_HashMap$();
  return $m_sci_HashMap$EmptyHashMap$()
});
$c_sci_HashMap.prototype.size__I = (function() {
  return 0
});
$c_sci_HashMap.prototype.seq__sc_Map = (function() {
  return this
});
$c_sci_HashMap.prototype.iterator__sc_Iterator = (function() {
  return $m_sc_Iterator$().empty$1
});
$c_sci_HashMap.prototype.updated__O__O__sci_Map = (function(key, value) {
  return this.updated__O__O__sci_HashMap(key, value)
});
$c_sci_HashMap.prototype.tail__sci_HashMap = (function() {
  return this.$$minus__O__sci_HashMap($as_T2(this.head__O()).$$und1__O())
});
$c_sci_HashMap.prototype.filterNot__F1__O = (function(p) {
  return this.filterNot__F1__sci_HashMap(p)
});
$c_sci_HashMap.prototype.improve__I__I = (function(hcode) {
  var h = ((hcode + (~(hcode << 9))) | 0);
  h = (h ^ ((h >>> 14) | 0));
  h = ((h + (h << 4)) | 0);
  return (h ^ ((h >>> 10) | 0))
});
$c_sci_HashMap.prototype.get__O__s_Option = (function(key) {
  return this.get0__O__I__I__s_Option(key, this.computeHash__O__I(key), 0)
});
$c_sci_HashMap.prototype.contains0__O__I__I__Z = (function(key, hash, level) {
  return false
});
$c_sci_HashMap.prototype.contains__O__Z = (function(key) {
  return this.contains0__O__I__I__Z(key, this.computeHash__O__I(key), 0)
});
$c_sci_HashMap.prototype.tail__O = (function() {
  return this.tail__sci_HashMap()
});
$c_sci_HashMap.prototype.filterNot__F1__sc_Map = (function(p) {
  return this.filterNot__F1__sci_HashMap(p)
});
$c_sci_HashMap.prototype.keySet__sc_Set = (function() {
  return new $c_sci_MapLike$ImmutableDefaultKeySet().init___sci_MapLike(this)
});
$c_sci_HashMap.prototype.toSeq__sc_GenSeq = (function() {
  return $f_sc_MapLike__toSeq__sc_Seq(this)
});
$c_sci_HashMap.prototype.$$plus__T2__sc_GenMap = (function(kv) {
  return this.$$plus__T2__sci_HashMap(kv)
});
var $d_sci_HashMap = new $TypeData().initClass({
  sci_HashMap: 0
}, false, "scala.collection.immutable.HashMap", {
  sci_HashMap: 1,
  sci_AbstractMap: 1,
  sc_AbstractMap: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Map: 1,
  sc_GenMap: 1,
  sc_GenMapLike: 1,
  sc_MapLike: 1,
  s_PartialFunction: 1,
  F1: 1,
  scg_Subtractable: 1,
  sci_Map: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sci_MapLike: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  sc_CustomParallelizable: 1
});
$c_sci_HashMap.prototype.$classData = $d_sci_HashMap;
/** @constructor */
function $c_sci_HashSet$HashSet1() {
  $c_sci_HashSet$LeafHashSet.call(this);
  this.key$6 = null;
  this.hash$6 = 0
}
$c_sci_HashSet$HashSet1.prototype = new $h_sci_HashSet$LeafHashSet();
$c_sci_HashSet$HashSet1.prototype.constructor = $c_sci_HashSet$HashSet1;
/** @constructor */
function $h_sci_HashSet$HashSet1() {
  /*<skip>*/
}
$h_sci_HashSet$HashSet1.prototype = $c_sci_HashSet$HashSet1.prototype;
$c_sci_HashSet$HashSet1.prototype.updated0__O__I__I__sci_HashSet = (function(key, hash, level) {
  if (((hash === this.hash$6) && $m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key$6))) {
    return this
  } else if ((hash !== this.hash$6)) {
    return $m_sci_HashSet$().scala$collection$immutable$HashSet$$makeHashTrieSet__I__sci_HashSet__I__sci_HashSet__I__sci_HashSet$HashTrieSet(this.hash$6, this, hash, new $c_sci_HashSet$HashSet1().init___O__I(key, hash), level)
  } else {
    var this$2 = $m_sci_ListSet$EmptyListSet$();
    var elem = this.key$6;
    return new $c_sci_HashSet$HashSetCollision1().init___I__sci_ListSet(hash, new $c_sci_ListSet$Node().init___sci_ListSet__O(this$2, elem).$$plus__O__sci_ListSet(key))
  }
});
$c_sci_HashSet$HashSet1.prototype.union0__sci_HashSet__I__Asci_HashSet__I__sci_HashSet = (function(that, level, buffer, offset0) {
  return that.union0__sci_HashSet$LeafHashSet__I__sci_HashSet(this, level)
});
$c_sci_HashSet$HashSet1.prototype.init___O__I = (function(key, hash) {
  this.key$6 = key;
  this.hash$6 = hash;
  return this
});
$c_sci_HashSet$HashSet1.prototype.foreach__F1__V = (function(f) {
  f.apply__O__O(this.key$6)
});
$c_sci_HashSet$HashSet1.prototype.union0__sci_HashSet$LeafHashSet__I__sci_HashSet = (function(that, level) {
  if ((that.hash__I() !== this.hash$6)) {
    return $m_sci_HashSet$().scala$collection$immutable$HashSet$$makeHashTrieSet__I__sci_HashSet__I__sci_HashSet__I__sci_HashSet$HashTrieSet(this.hash$6, this, that.hash__I(), that, level)
  } else if ((that instanceof $c_sci_HashSet$HashSet1)) {
    var x2 = $as_sci_HashSet$HashSet1(that);
    if ($m_sr_BoxesRunTime$().equals__O__O__Z(this.key$6, x2.key$6)) {
      return this
    } else {
      var jsx$1 = this.hash$6;
      var this$2 = $m_sci_ListSet$EmptyListSet$();
      var elem = this.key$6;
      return new $c_sci_HashSet$HashSetCollision1().init___I__sci_ListSet(jsx$1, new $c_sci_ListSet$Node().init___sci_ListSet__O(this$2, elem).$$plus__O__sci_ListSet(x2.key$6))
    }
  } else if ((that instanceof $c_sci_HashSet$HashSetCollision1)) {
    var x3 = $as_sci_HashSet$HashSetCollision1(that);
    var ks1 = x3.ks$6.$$plus__O__sci_ListSet(this.key$6);
    return ((ks1.size__I() === x3.ks$6.size__I()) ? x3 : new $c_sci_HashSet$HashSetCollision1().init___I__sci_ListSet(this.hash$6, ks1))
  } else {
    throw new $c_s_MatchError().init___O(that)
  }
});
$c_sci_HashSet$HashSet1.prototype.size__I = (function() {
  return 1
});
$c_sci_HashSet$HashSet1.prototype.iterator__sc_Iterator = (function() {
  $m_sc_Iterator$();
  var array = [this.key$6];
  var elems = new $c_sjs_js_WrappedArray().init___sjs_js_Array(array);
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(elems, 0, $uI(elems.array$6.length))
});
$c_sci_HashSet$HashSet1.prototype.removed0__O__I__I__sci_HashSet = (function(key, hash, level) {
  return (((hash === this.hash$6) && $m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key$6)) ? null : this)
});
$c_sci_HashSet$HashSet1.prototype.intersect0__sci_HashSet__I__Asci_HashSet__I__sci_HashSet = (function(that, level, buffer, offset0) {
  return (that.get0__O__I__I__Z(this.key$6, this.hash$6, level) ? this : null)
});
$c_sci_HashSet$HashSet1.prototype.diff0__sci_HashSet__I__Asci_HashSet__I__sci_HashSet = (function(that, level, buffer, offset0) {
  return (that.get0__O__I__I__Z(this.key$6, this.hash$6, level) ? null : this)
});
$c_sci_HashSet$HashSet1.prototype.filter0__F1__Z__I__Asci_HashSet__I__sci_HashSet = (function(p, negate, level, buffer, offset0) {
  return ((negate !== $uZ(p.apply__O__O(this.key$6))) ? this : null)
});
$c_sci_HashSet$HashSet1.prototype.hash__I = (function() {
  return this.hash$6
});
$c_sci_HashSet$HashSet1.prototype.get0__O__I__I__Z = (function(key, hash, level) {
  return ((hash === this.hash$6) && $m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key$6))
});
$c_sci_HashSet$HashSet1.prototype.subsetOf0__sci_HashSet__I__Z = (function(that, level) {
  return that.get0__O__I__I__Z(this.key$6, this.hash$6, level)
});
function $as_sci_HashSet$HashSet1(obj) {
  return (((obj instanceof $c_sci_HashSet$HashSet1) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.HashSet$HashSet1"))
}
function $isArrayOf_sci_HashSet$HashSet1(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_HashSet$HashSet1)))
}
function $asArrayOf_sci_HashSet$HashSet1(obj, depth) {
  return (($isArrayOf_sci_HashSet$HashSet1(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.HashSet$HashSet1;", depth))
}
var $d_sci_HashSet$HashSet1 = new $TypeData().initClass({
  sci_HashSet$HashSet1: 0
}, false, "scala.collection.immutable.HashSet$HashSet1", {
  sci_HashSet$HashSet1: 1,
  sci_HashSet$LeafHashSet: 1,
  sci_HashSet: 1,
  sc_AbstractSet: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Set: 1,
  F1: 1,
  sc_GenSet: 1,
  sc_GenSetLike: 1,
  scg_GenericSetTemplate: 1,
  sc_SetLike: 1,
  scg_Subtractable: 1,
  sci_Set: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_HashSet$HashSet1.prototype.$classData = $d_sci_HashSet$HashSet1;
/** @constructor */
function $c_sci_HashSet$HashSetCollision1() {
  $c_sci_HashSet$LeafHashSet.call(this);
  this.hash$6 = 0;
  this.ks$6 = null
}
$c_sci_HashSet$HashSetCollision1.prototype = new $h_sci_HashSet$LeafHashSet();
$c_sci_HashSet$HashSetCollision1.prototype.constructor = $c_sci_HashSet$HashSetCollision1;
/** @constructor */
function $h_sci_HashSet$HashSetCollision1() {
  /*<skip>*/
}
$h_sci_HashSet$HashSetCollision1.prototype = $c_sci_HashSet$HashSetCollision1.prototype;
$c_sci_HashSet$HashSetCollision1.prototype.updated0__O__I__I__sci_HashSet = (function(key, hash, level) {
  return ((hash === this.hash$6) ? new $c_sci_HashSet$HashSetCollision1().init___I__sci_ListSet(hash, this.ks$6.$$plus__O__sci_ListSet(key)) : $m_sci_HashSet$().scala$collection$immutable$HashSet$$makeHashTrieSet__I__sci_HashSet__I__sci_HashSet__I__sci_HashSet$HashTrieSet(this.hash$6, this, hash, new $c_sci_HashSet$HashSet1().init___O__I(key, hash), level))
});
$c_sci_HashSet$HashSetCollision1.prototype.union0__sci_HashSet__I__Asci_HashSet__I__sci_HashSet = (function(that, level, buffer, offset0) {
  if ((that instanceof $c_sci_HashSet$LeafHashSet)) {
    var x2 = $as_sci_HashSet$LeafHashSet(that);
    return this.union0__sci_HashSet$LeafHashSet__I__sci_HashSet(x2, level)
  } else if ((that instanceof $c_sci_HashSet$HashTrieSet)) {
    var x3 = $as_sci_HashSet$HashTrieSet(that);
    return x3.union0__sci_HashSet$LeafHashSet__I__sci_HashSet(this, level)
  } else {
    return this
  }
});
$c_sci_HashSet$HashSetCollision1.prototype.foreach__F1__V = (function(f) {
  var this$1 = this.ks$6;
  var this$2 = this$1.reverseList$1__p4__sci_List();
  var this$3 = new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$2);
  $f_sc_Iterator__foreach__F1__V(this$3, f)
});
$c_sci_HashSet$HashSetCollision1.prototype.union0__sci_HashSet$LeafHashSet__I__sci_HashSet = (function(that, level) {
  if ((that.hash__I() !== this.hash$6)) {
    return $m_sci_HashSet$().scala$collection$immutable$HashSet$$makeHashTrieSet__I__sci_HashSet__I__sci_HashSet__I__sci_HashSet$HashTrieSet(this.hash$6, this, that.hash__I(), that, level)
  } else if ((that instanceof $c_sci_HashSet$HashSet1)) {
    var x2 = $as_sci_HashSet$HashSet1(that);
    var ks1 = this.ks$6.$$plus__O__sci_ListSet(x2.key$6);
    return ((ks1.size__I() === this.ks$6.size__I()) ? this : new $c_sci_HashSet$HashSetCollision1().init___I__sci_ListSet(this.hash$6, ks1))
  } else if ((that instanceof $c_sci_HashSet$HashSetCollision1)) {
    var x3 = $as_sci_HashSet$HashSetCollision1(that);
    var ks1$2 = this.ks$6.$$plus$plus__sc_GenTraversableOnce__sci_ListSet(x3.ks$6);
    var x1$2 = ks1$2.size__I();
    switch (x1$2) {
      default: {
        return ((x1$2 === this.ks$6.size__I()) ? this : ((x1$2 === x3.ks$6.size__I()) ? x3 : new $c_sci_HashSet$HashSetCollision1().init___I__sci_ListSet(this.hash$6, ks1$2)))
      }
    }
  } else {
    throw new $c_s_MatchError().init___O(that)
  }
});
$c_sci_HashSet$HashSetCollision1.prototype.size__I = (function() {
  return this.ks$6.size__I()
});
$c_sci_HashSet$HashSetCollision1.prototype.iterator__sc_Iterator = (function() {
  var this$1 = this.ks$6;
  var this$2 = this$1.reverseList$1__p4__sci_List();
  return new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$2)
});
$c_sci_HashSet$HashSetCollision1.prototype.removed0__O__I__I__sci_HashSet = (function(key, hash, level) {
  if ((hash === this.hash$6)) {
    var ks1 = this.ks$6.$$minus__O__sci_ListSet(key);
    var x1 = ks1.size__I();
    switch (x1) {
      case 0: {
        return null;
        break
      }
      case 1: {
        var this$1 = ks1.reverseList$1__p4__sci_List();
        return new $c_sci_HashSet$HashSet1().init___O__I(new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$1).next__O(), hash);
        break
      }
      default: {
        return ((x1 === this.ks$6.size__I()) ? this : new $c_sci_HashSet$HashSetCollision1().init___I__sci_ListSet(hash, ks1))
      }
    }
  } else {
    return this
  }
});
$c_sci_HashSet$HashSetCollision1.prototype.intersect0__sci_HashSet__I__Asci_HashSet__I__sci_HashSet = (function(that, level, buffer, offset0) {
  var this$1 = this.ks$6;
  var f = (function($this, that$1, level$1) {
    return (function(x$1$2) {
      return that$1.get0__O__I__I__Z(x$1$2, $this.hash$6, level$1)
    })
  })(this, that, level);
  if ((this$1 instanceof $c_sci_List)) {
    var x2 = $as_sci_List(this$1);
    var l = x2;
    var l$1 = l;
    x: {
      var result;
      _noneIn: while (true) {
        if (l$1.isEmpty__Z()) {
          var result = $m_sci_Nil$();
          break
        } else {
          var h = l$1.head__O();
          var t = $as_sci_List(l$1.tail__O());
          if (($uZ(f(h)) === false)) {
            l$1 = t;
            continue _noneIn
          };
          var start = l$1;
          var remaining = t;
          var remaining$1 = remaining;
          _allIn: while (true) {
            if (remaining$1.isEmpty__Z()) {
              var result = start;
              break x
            } else {
              var x$2 = remaining$1.head__O();
              if (($uZ(f(x$2)) !== false)) {
                remaining$1 = $as_sci_List(remaining$1.tail__O());
                continue _allIn
              };
              var firstMiss = remaining$1;
              var newHead = new $c_sci_$colon$colon().init___O__sci_List(start.head__O(), $m_sci_Nil$());
              var toProcess = $as_sci_List(start.tail__O());
              var currentLast = newHead;
              while ((toProcess !== firstMiss)) {
                var newElem = new $c_sci_$colon$colon().init___O__sci_List(toProcess.head__O(), $m_sci_Nil$());
                currentLast.tl$5 = newElem;
                currentLast = newElem;
                toProcess = $as_sci_List(toProcess.tail__O())
              };
              var next = $as_sci_List(firstMiss.tail__O());
              var nextToCopy = next;
              while ((!next.isEmpty__Z())) {
                var head = next.head__O();
                if (($uZ(f(head)) !== false)) {
                  next = $as_sci_List(next.tail__O())
                } else {
                  while ((nextToCopy !== next)) {
                    var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy.head__O(), $m_sci_Nil$());
                    currentLast.tl$5 = newElem$2;
                    currentLast = newElem$2;
                    nextToCopy = $as_sci_List(nextToCopy.tail__O())
                  };
                  nextToCopy = $as_sci_List(next.tail__O());
                  next = $as_sci_List(next.tail__O())
                }
              };
              if ((!nextToCopy.isEmpty__Z())) {
                currentLast.tl$5 = nextToCopy
              };
              var result = newHead;
              break x
            }
          }
        }
      }
    };
    var jsx$1 = result
  } else {
    var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_ListSet$EmptyListSet$());
    var this$3 = this$1.reverseList$1__p4__sci_List();
    var this$4 = new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$3);
    while (this$4.hasNext__Z()) {
      var arg1 = this$4.next__O();
      if (($uZ(f(arg1)) !== false)) {
        b.$$plus$eq__O__scm_SetBuilder(arg1)
      }
    };
    var jsx$1 = b.elems$1
  };
  var ks1 = $as_sci_ListSet(jsx$1);
  var x1 = ks1.size__I();
  if ((x1 === 0)) {
    return null
  } else if ((x1 === this.ks$6.size__I())) {
    return this
  } else if ((x1 === that.size__I())) {
    return that
  } else if ((x1 === 1)) {
    var this$5 = ks1.reverseList$1__p4__sci_List();
    return new $c_sci_HashSet$HashSet1().init___O__I(new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$5).next__O(), this.hash$6)
  } else {
    return new $c_sci_HashSet$HashSetCollision1().init___I__sci_ListSet(this.hash$6, ks1)
  }
});
$c_sci_HashSet$HashSetCollision1.prototype.init___I__sci_ListSet = (function(hash, ks) {
  this.hash$6 = hash;
  this.ks$6 = ks;
  return this
});
$c_sci_HashSet$HashSetCollision1.prototype.diff0__sci_HashSet__I__Asci_HashSet__I__sci_HashSet = (function(that, level, buffer, offset0) {
  var this$1 = this.ks$6;
  var f = (function($this, that$1, level$1) {
    return (function(x$2$2) {
      return that$1.get0__O__I__I__Z(x$2$2, $this.hash$6, level$1)
    })
  })(this, that, level);
  if ((this$1 instanceof $c_sci_List)) {
    var x2 = $as_sci_List(this$1);
    var l = x2;
    var l$1 = l;
    x: {
      var result;
      _noneIn: while (true) {
        if (l$1.isEmpty__Z()) {
          var result = $m_sci_Nil$();
          break
        } else {
          var h = l$1.head__O();
          var t = $as_sci_List(l$1.tail__O());
          if (($uZ(f(h)) === true)) {
            l$1 = t;
            continue _noneIn
          };
          var start = l$1;
          var remaining = t;
          var remaining$1 = remaining;
          _allIn: while (true) {
            if (remaining$1.isEmpty__Z()) {
              var result = start;
              break x
            } else {
              var x$2 = remaining$1.head__O();
              if (($uZ(f(x$2)) !== true)) {
                remaining$1 = $as_sci_List(remaining$1.tail__O());
                continue _allIn
              };
              var firstMiss = remaining$1;
              var newHead = new $c_sci_$colon$colon().init___O__sci_List(start.head__O(), $m_sci_Nil$());
              var toProcess = $as_sci_List(start.tail__O());
              var currentLast = newHead;
              while ((toProcess !== firstMiss)) {
                var newElem = new $c_sci_$colon$colon().init___O__sci_List(toProcess.head__O(), $m_sci_Nil$());
                currentLast.tl$5 = newElem;
                currentLast = newElem;
                toProcess = $as_sci_List(toProcess.tail__O())
              };
              var next = $as_sci_List(firstMiss.tail__O());
              var nextToCopy = next;
              while ((!next.isEmpty__Z())) {
                var head = next.head__O();
                if (($uZ(f(head)) !== true)) {
                  next = $as_sci_List(next.tail__O())
                } else {
                  while ((nextToCopy !== next)) {
                    var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(nextToCopy.head__O(), $m_sci_Nil$());
                    currentLast.tl$5 = newElem$2;
                    currentLast = newElem$2;
                    nextToCopy = $as_sci_List(nextToCopy.tail__O())
                  };
                  nextToCopy = $as_sci_List(next.tail__O());
                  next = $as_sci_List(next.tail__O())
                }
              };
              if ((!nextToCopy.isEmpty__Z())) {
                currentLast.tl$5 = nextToCopy
              };
              var result = newHead;
              break x
            }
          }
        }
      }
    };
    var jsx$1 = result
  } else {
    var b = new $c_scm_SetBuilder().init___sc_Set($m_sci_ListSet$EmptyListSet$());
    var this$3 = this$1.reverseList$1__p4__sci_List();
    var this$4 = new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$3);
    while (this$4.hasNext__Z()) {
      var arg1 = this$4.next__O();
      if (($uZ(f(arg1)) !== true)) {
        b.$$plus$eq__O__scm_SetBuilder(arg1)
      }
    };
    var jsx$1 = b.elems$1
  };
  var ks1 = $as_sci_ListSet(jsx$1);
  var x1 = ks1.size__I();
  if ((x1 === 0)) {
    return null
  } else if ((x1 === this.ks$6.size__I())) {
    return this
  } else if ((x1 === 1)) {
    var this$5 = ks1.reverseList$1__p4__sci_List();
    return new $c_sci_HashSet$HashSet1().init___O__I(new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$5).next__O(), this.hash$6)
  } else {
    return new $c_sci_HashSet$HashSetCollision1().init___I__sci_ListSet(this.hash$6, ks1)
  }
});
$c_sci_HashSet$HashSetCollision1.prototype.filter0__F1__Z__I__Asci_HashSet__I__sci_HashSet = (function(p, negate, level, buffer, offset0) {
  if (negate) {
    var this$1 = this.ks$6;
    var ks1 = $as_sci_ListSet($f_sc_TraversableLike__filterImpl__F1__Z__O(this$1, p, true))
  } else {
    var this$2 = this.ks$6;
    var ks1 = $as_sci_ListSet($f_sc_TraversableLike__filterImpl__F1__Z__O(this$2, p, false))
  };
  var x1 = ks1.size__I();
  switch (x1) {
    case 0: {
      return null;
      break
    }
    case 1: {
      var this$3 = ks1.reverseList$1__p4__sci_List();
      return new $c_sci_HashSet$HashSet1().init___O__I(new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$3).next__O(), this.hash$6);
      break
    }
    default: {
      return ((x1 === this.ks$6.size__I()) ? this : new $c_sci_HashSet$HashSetCollision1().init___I__sci_ListSet(this.hash$6, ks1))
    }
  }
});
$c_sci_HashSet$HashSetCollision1.prototype.hash__I = (function() {
  return this.hash$6
});
$c_sci_HashSet$HashSetCollision1.prototype.get0__O__I__I__Z = (function(key, hash, level) {
  return ((hash === this.hash$6) && this.ks$6.contains__O__Z(key))
});
$c_sci_HashSet$HashSetCollision1.prototype.subsetOf0__sci_HashSet__I__Z = (function(that, level) {
  var this$1 = this.ks$6;
  var this$2 = this$1.reverseList$1__p4__sci_List();
  var this$3 = new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$2);
  var res = true;
  while ((res && this$3.hasNext__Z())) {
    var arg1 = this$3.next__O();
    res = that.get0__O__I__I__Z(arg1, this.hash$6, level)
  };
  return res
});
function $as_sci_HashSet$HashSetCollision1(obj) {
  return (((obj instanceof $c_sci_HashSet$HashSetCollision1) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.HashSet$HashSetCollision1"))
}
function $isArrayOf_sci_HashSet$HashSetCollision1(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_HashSet$HashSetCollision1)))
}
function $asArrayOf_sci_HashSet$HashSetCollision1(obj, depth) {
  return (($isArrayOf_sci_HashSet$HashSetCollision1(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.HashSet$HashSetCollision1;", depth))
}
var $d_sci_HashSet$HashSetCollision1 = new $TypeData().initClass({
  sci_HashSet$HashSetCollision1: 0
}, false, "scala.collection.immutable.HashSet$HashSetCollision1", {
  sci_HashSet$HashSetCollision1: 1,
  sci_HashSet$LeafHashSet: 1,
  sci_HashSet: 1,
  sc_AbstractSet: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Set: 1,
  F1: 1,
  sc_GenSet: 1,
  sc_GenSetLike: 1,
  scg_GenericSetTemplate: 1,
  sc_SetLike: 1,
  scg_Subtractable: 1,
  sci_Set: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_HashSet$HashSetCollision1.prototype.$classData = $d_sci_HashSet$HashSetCollision1;
/** @constructor */
function $c_sci_ListMap$EmptyListMap$() {
  $c_sci_ListMap.call(this)
}
$c_sci_ListMap$EmptyListMap$.prototype = new $h_sci_ListMap();
$c_sci_ListMap$EmptyListMap$.prototype.constructor = $c_sci_ListMap$EmptyListMap$;
/** @constructor */
function $h_sci_ListMap$EmptyListMap$() {
  /*<skip>*/
}
$h_sci_ListMap$EmptyListMap$.prototype = $c_sci_ListMap$EmptyListMap$.prototype;
$c_sci_ListMap$EmptyListMap$.prototype.init___ = (function() {
  return this
});
var $d_sci_ListMap$EmptyListMap$ = new $TypeData().initClass({
  sci_ListMap$EmptyListMap$: 0
}, false, "scala.collection.immutable.ListMap$EmptyListMap$", {
  sci_ListMap$EmptyListMap$: 1,
  sci_ListMap: 1,
  sci_AbstractMap: 1,
  sc_AbstractMap: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Map: 1,
  sc_GenMap: 1,
  sc_GenMapLike: 1,
  sc_MapLike: 1,
  s_PartialFunction: 1,
  F1: 1,
  scg_Subtractable: 1,
  sci_Map: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sci_MapLike: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_ListMap$EmptyListMap$.prototype.$classData = $d_sci_ListMap$EmptyListMap$;
var $n_sci_ListMap$EmptyListMap$ = (void 0);
function $m_sci_ListMap$EmptyListMap$() {
  if ((!$n_sci_ListMap$EmptyListMap$)) {
    $n_sci_ListMap$EmptyListMap$ = new $c_sci_ListMap$EmptyListMap$().init___()
  };
  return $n_sci_ListMap$EmptyListMap$
}
/** @constructor */
function $c_sci_ListMap$Node() {
  $c_sci_ListMap.call(this);
  this.key$6 = null;
  this.value$6 = null;
  this.$$outer$6 = null
}
$c_sci_ListMap$Node.prototype = new $h_sci_ListMap();
$c_sci_ListMap$Node.prototype.constructor = $c_sci_ListMap$Node;
/** @constructor */
function $h_sci_ListMap$Node() {
  /*<skip>*/
}
$h_sci_ListMap$Node.prototype = $c_sci_ListMap$Node.prototype;
$c_sci_ListMap$Node.prototype.removeInternal__p6__O__sci_ListMap__sci_List__sci_ListMap = (function(k, cur, acc) {
  _removeInternal: while (true) {
    if (cur.isEmpty__Z()) {
      var this$1 = acc;
      return $as_sci_ListMap($f_sc_LinearSeqOptimized__last__O(this$1))
    } else if ($m_sr_BoxesRunTime$().equals__O__O__Z(k, cur.key__O())) {
      var x$5 = cur.next__sci_ListMap();
      var this$2 = acc;
      var acc$1 = x$5;
      var these = this$2;
      while ((!these.isEmpty__Z())) {
        var arg1 = acc$1;
        var arg2 = these.head__O();
        var x0$1 = $as_sci_ListMap(arg1);
        var x1$1 = $as_sci_ListMap(arg2);
        acc$1 = new $c_sci_ListMap$Node().init___sci_ListMap__O__O(x0$1, x1$1.key__O(), x1$1.value__O());
        these = $as_sc_LinearSeqOptimized(these.tail__O())
      };
      return $as_sci_ListMap(acc$1)
    } else {
      var temp$cur = cur.next__sci_ListMap();
      var x$6 = cur;
      var this$3 = acc;
      var temp$acc = new $c_sci_$colon$colon().init___O__sci_List(x$6, this$3);
      cur = temp$cur;
      acc = temp$acc;
      continue _removeInternal
    }
  }
});
$c_sci_ListMap$Node.prototype.apply__O__O = (function(k) {
  return this.applyInternal__p6__sci_ListMap__O__O(this, k)
});
$c_sci_ListMap$Node.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return this.removeInternal__p6__O__sci_ListMap__sci_List__sci_ListMap(elem, this, $m_sci_Nil$())
});
$c_sci_ListMap$Node.prototype.value__O = (function() {
  return this.value$6
});
$c_sci_ListMap$Node.prototype.isEmpty__Z = (function() {
  return false
});
$c_sci_ListMap$Node.prototype.applyInternal__p6__sci_ListMap__O__O = (function(cur, k) {
  _applyInternal: while (true) {
    if (cur.isEmpty__Z()) {
      throw new $c_ju_NoSuchElementException().init___T(("key not found: " + k))
    } else if ($m_sr_BoxesRunTime$().equals__O__O__Z(k, cur.key__O())) {
      return cur.value__O()
    } else {
      cur = cur.next__sci_ListMap();
      continue _applyInternal
    }
  }
});
$c_sci_ListMap$Node.prototype.getInternal__p6__sci_ListMap__O__s_Option = (function(cur, k) {
  _getInternal: while (true) {
    if (cur.isEmpty__Z()) {
      return $m_s_None$()
    } else if ($m_sr_BoxesRunTime$().equals__O__O__Z(k, cur.key__O())) {
      return new $c_s_Some().init___O(cur.value__O())
    } else {
      cur = cur.next__sci_ListMap();
      continue _getInternal
    }
  }
});
$c_sci_ListMap$Node.prototype.sizeInternal__p6__sci_ListMap__I__I = (function(cur, acc) {
  _sizeInternal: while (true) {
    if (cur.isEmpty__Z()) {
      return acc
    } else {
      var temp$cur = cur.next__sci_ListMap();
      var temp$acc = ((1 + acc) | 0);
      cur = temp$cur;
      acc = temp$acc;
      continue _sizeInternal
    }
  }
});
$c_sci_ListMap$Node.prototype.$$plus__T2__sci_Map = (function(kv) {
  return this.$$plus__T2__sci_ListMap(kv)
});
$c_sci_ListMap$Node.prototype.$$minus__O__sc_Map = (function(key) {
  return this.removeInternal__p6__O__sci_ListMap__sci_List__sci_ListMap(key, this, $m_sci_Nil$())
});
$c_sci_ListMap$Node.prototype.size__I = (function() {
  return this.sizeInternal__p6__sci_ListMap__I__I(this, 0)
});
$c_sci_ListMap$Node.prototype.key__O = (function() {
  return this.key$6
});
$c_sci_ListMap$Node.prototype.$$plus__T2__sci_ListMap = (function(kv) {
  var k = kv.$$und1__O();
  var m = this.removeInternal__p6__O__sci_ListMap__sci_List__sci_ListMap(k, this, $m_sci_Nil$());
  return new $c_sci_ListMap$Node().init___sci_ListMap__O__O(m, kv.$$und1__O(), kv.$$und2__O())
});
$c_sci_ListMap$Node.prototype.updated__O__O__sci_Map = (function(key, value) {
  return this.updated__O__O__sci_ListMap(key, value)
});
$c_sci_ListMap$Node.prototype.updated__O__O__sci_ListMap = (function(k, v) {
  var m = this.removeInternal__p6__O__sci_ListMap__sci_List__sci_ListMap(k, this, $m_sci_Nil$());
  return new $c_sci_ListMap$Node().init___sci_ListMap__O__O(m, k, v)
});
$c_sci_ListMap$Node.prototype.$$minus__O__sci_ListMap = (function(k) {
  return this.removeInternal__p6__O__sci_ListMap__sci_List__sci_ListMap(k, this, $m_sci_Nil$())
});
$c_sci_ListMap$Node.prototype.get__O__s_Option = (function(k) {
  return this.getInternal__p6__sci_ListMap__O__s_Option(this, k)
});
$c_sci_ListMap$Node.prototype.init___sci_ListMap__O__O = (function($$outer, key, value) {
  this.key$6 = key;
  this.value$6 = value;
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$6 = $$outer
  };
  return this
});
$c_sci_ListMap$Node.prototype.contains__O__Z = (function(k) {
  return this.containsInternal__p6__sci_ListMap__O__Z(this, k)
});
$c_sci_ListMap$Node.prototype.containsInternal__p6__sci_ListMap__O__Z = (function(cur, k) {
  _containsInternal: while (true) {
    if ((!cur.isEmpty__Z())) {
      if ($m_sr_BoxesRunTime$().equals__O__O__Z(k, cur.key__O())) {
        return true
      } else {
        cur = cur.next__sci_ListMap();
        continue _containsInternal
      }
    } else {
      return false
    }
  }
});
$c_sci_ListMap$Node.prototype.next__sci_ListMap = (function() {
  return this.$$outer$6
});
$c_sci_ListMap$Node.prototype.$$plus__T2__sc_GenMap = (function(kv) {
  return this.$$plus__T2__sci_ListMap(kv)
});
var $d_sci_ListMap$Node = new $TypeData().initClass({
  sci_ListMap$Node: 0
}, false, "scala.collection.immutable.ListMap$Node", {
  sci_ListMap$Node: 1,
  sci_ListMap: 1,
  sci_AbstractMap: 1,
  sc_AbstractMap: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Map: 1,
  sc_GenMap: 1,
  sc_GenMapLike: 1,
  sc_MapLike: 1,
  s_PartialFunction: 1,
  F1: 1,
  scg_Subtractable: 1,
  sci_Map: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sci_MapLike: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_ListMap$Node.prototype.$classData = $d_sci_ListMap$Node;
/** @constructor */
function $c_sci_Range() {
  $c_sc_AbstractSeq.call(this);
  this.start$4 = 0;
  this.end$4 = 0;
  this.step$4 = 0;
  this.isEmpty$4 = false;
  this.scala$collection$immutable$Range$$numRangeElements$4 = 0;
  this.scala$collection$immutable$Range$$lastElement$4 = 0
}
$c_sci_Range.prototype = new $h_sc_AbstractSeq();
$c_sci_Range.prototype.constructor = $c_sci_Range;
/** @constructor */
function $h_sci_Range() {
  /*<skip>*/
}
$h_sci_Range.prototype = $c_sci_Range.prototype;
$c_sci_Range.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sci_Range.prototype.isInclusive__Z = (function() {
  return false
});
$c_sci_Range.prototype.head__O = (function() {
  return this.head__I()
});
$c_sci_Range.prototype.apply__I__O = (function(idx) {
  return this.apply$mcII$sp__I__I(idx)
});
$c_sci_Range.prototype.thisCollection__sc_Iterable = (function() {
  return this
});
$c_sci_Range.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return this.apply$mcII$sp__I__I(idx)
});
$c_sci_Range.prototype.isEmpty__Z = (function() {
  return this.isEmpty$4
});
$c_sci_Range.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sci_Range.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_Range.prototype.longLength__p4__J = (function() {
  var t = this.gap__p4__J();
  var lo = t.lo$2;
  var hi$1 = t.hi$2;
  var value = this.step$4;
  var hi = (value >> 31);
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo$1 = this$1.divideImpl__I__I__I__I__I(lo, hi$1, value, hi);
  var hi$2 = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  var value$1 = (this.hasStub__p4__Z() ? 1 : 0);
  var hi$3 = (value$1 >> 31);
  var lo$2 = ((lo$1 + value$1) | 0);
  var hi$4 = ((((-2147483648) ^ lo$2) < ((-2147483648) ^ lo$1)) ? ((1 + ((hi$2 + hi$3) | 0)) | 0) : ((hi$2 + hi$3) | 0));
  return new $c_sjsr_RuntimeLong().init___I__I(lo$2, hi$4)
});
$c_sci_Range.prototype.locationAfterN__p4__I__I = (function(n) {
  return ((this.start$4 + $imul(this.step$4, n)) | 0)
});
$c_sci_Range.prototype.equals__O__Z = (function(other) {
  if ((other instanceof $c_sci_Range)) {
    var x2 = $as_sci_Range(other);
    if (this.isEmpty$4) {
      return x2.isEmpty$4
    } else if (($f_sc_TraversableOnce__nonEmpty__Z(x2) && (this.start$4 === x2.start$4))) {
      var l0 = this.last__I();
      return ((l0 === x2.last__I()) && ((this.start$4 === l0) || (this.step$4 === x2.step$4)))
    } else {
      return false
    }
  } else {
    return $f_sc_GenSeqLike__equals__O__Z(this, other)
  }
});
$c_sci_Range.prototype.argTakeWhile__p4__F1__J = (function(p) {
  if (this.isEmpty$4) {
    var value = this.start$4;
    var hi = (value >> 31);
    return new $c_sjsr_RuntimeLong().init___I__I(value, hi)
  } else {
    var current = this.start$4;
    var stop = this.last__I();
    while (((current !== stop) && p.apply$mcZI$sp__I__Z(current))) {
      current = ((current + this.step$4) | 0)
    };
    if (((current !== stop) || (!p.apply$mcZI$sp__I__Z(current)))) {
      var value$1 = current;
      var hi$1 = (value$1 >> 31);
      return new $c_sjsr_RuntimeLong().init___I__I(value$1, hi$1)
    } else {
      var value$2 = current;
      var hi$2 = (value$2 >> 31);
      var value$3 = this.step$4;
      var hi$3 = (value$3 >> 31);
      var lo = ((value$2 + value$3) | 0);
      var hi$4 = ((((-2147483648) ^ lo) < ((-2147483648) ^ value$2)) ? ((1 + ((hi$2 + hi$3) | 0)) | 0) : ((hi$2 + hi$3) | 0));
      return new $c_sjsr_RuntimeLong().init___I__I(lo, hi$4)
    }
  }
});
$c_sci_Range.prototype.apply$mcII$sp__I__I = (function(idx) {
  this.scala$collection$immutable$Range$$validateMaxLength__V();
  if (((idx < 0) || (idx >= this.scala$collection$immutable$Range$$numRangeElements$4))) {
    throw new $c_jl_IndexOutOfBoundsException().init___T(("" + idx))
  } else {
    return ((this.start$4 + $imul(this.step$4, idx)) | 0)
  }
});
$c_sci_Range.prototype.dropWhile__F1__O = (function(p) {
  return this.dropWhile__F1__sci_Range(p)
});
$c_sci_Range.prototype.init___I__I__I = (function(start, end, step) {
  this.start$4 = start;
  this.end$4 = end;
  this.step$4 = step;
  this.isEmpty$4 = ((((start > end) && (step > 0)) || ((start < end) && (step < 0))) || ((start === end) && (!this.isInclusive__Z())));
  if ((step === 0)) {
    var jsx$1;
    throw new $c_jl_IllegalArgumentException().init___T("step cannot be 0.")
  } else if (this.isEmpty$4) {
    var jsx$1 = 0
  } else {
    var t = this.longLength__p4__J();
    var lo = t.lo$2;
    var hi = t.hi$2;
    var jsx$1 = (((hi === 0) ? (((-2147483648) ^ lo) > (-1)) : (hi > 0)) ? (-1) : lo)
  };
  this.scala$collection$immutable$Range$$numRangeElements$4 = jsx$1;
  switch (step) {
    case 1: {
      var jsx$2 = (this.isInclusive__Z() ? end : (((-1) + end) | 0));
      break
    }
    case (-1): {
      var jsx$2 = (this.isInclusive__Z() ? end : ((1 + end) | 0));
      break
    }
    default: {
      var t$1 = this.gap__p4__J();
      var lo$1 = t$1.lo$2;
      var hi$2 = t$1.hi$2;
      var hi$1 = (step >> 31);
      var this$1 = $m_sjsr_RuntimeLong$();
      var lo$2 = this$1.remainderImpl__I__I__I__I__I(lo$1, hi$2, step, hi$1);
      var jsx$2 = ((lo$2 !== 0) ? ((end - lo$2) | 0) : (this.isInclusive__Z() ? end : ((end - step) | 0)))
    }
  };
  this.scala$collection$immutable$Range$$lastElement$4 = jsx$2;
  return this
});
$c_sci_Range.prototype.takeWhile__F1__sci_Range = (function(p) {
  var t = this.argTakeWhile__p4__F1__J(p);
  var lo = t.lo$2;
  var hi = t.hi$2;
  var value = this.start$4;
  var hi$1 = (value >> 31);
  if (((lo === value) && (hi === hi$1))) {
    var value$1 = this.start$4;
    return new $c_sci_Range().init___I__I__I(value$1, value$1, this.step$4)
  } else {
    var value$2 = this.step$4;
    var hi$2 = (value$2 >> 31);
    var lo$1 = ((lo - value$2) | 0);
    return ((lo$1 === this.last__I()) ? this : new $c_sci_Range$Inclusive().init___I__I__I(this.start$4, lo$1, this.step$4))
  }
});
$c_sci_Range.prototype.toString__T = (function() {
  var preposition = (this.isInclusive__Z() ? "to" : "until");
  var stepped = ((this.step$4 === 1) ? "" : (" by " + this.step$4));
  var prefix = (this.isEmpty$4 ? "empty " : ((!this.isExact__p4__Z()) ? "inexact " : ""));
  return (((((((prefix + "Range ") + this.start$4) + " ") + preposition) + " ") + this.end$4) + stepped)
});
$c_sci_Range.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sci_IndexedSeq$()
});
$c_sci_Range.prototype.foreach__F1__V = (function(f) {
  if ((!this.isEmpty$4)) {
    var i = this.start$4;
    while (true) {
      f.apply__O__O(i);
      if ((i === this.scala$collection$immutable$Range$$lastElement$4)) {
        return (void 0)
      };
      i = ((i + this.step$4) | 0)
    }
  }
});
$c_sci_Range.prototype.hasStub__p4__Z = (function() {
  return (this.isInclusive__Z() || (!this.isExact__p4__Z()))
});
$c_sci_Range.prototype.takeWhile__F1__O = (function(p) {
  return this.takeWhile__F1__sci_Range(p)
});
$c_sci_Range.prototype.copy__I__I__I__sci_Range = (function(start, end, step) {
  return new $c_sci_Range().init___I__I__I(start, end, step)
});
$c_sci_Range.prototype.tail__sci_Range = (function() {
  if (this.isEmpty$4) {
    $m_sci_Nil$().tail__sci_List()
  };
  return this.drop__I__sci_Range(1)
});
$c_sci_Range.prototype.reverse__O = (function() {
  return this.reverse__sci_Range()
});
$c_sci_Range.prototype.size__I = (function() {
  return this.length__I()
});
$c_sci_Range.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_IndexedSeqLike__toBuffer__scm_Buffer(this)
});
$c_sci_Range.prototype.iterator__sc_Iterator = (function() {
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, this.length__I())
});
$c_sci_Range.prototype.span__F1__T2 = (function(p) {
  var t = this.argTakeWhile__p4__F1__J(p);
  var lo = t.lo$2;
  var hi = t.hi$2;
  var value = this.start$4;
  var hi$1 = (value >> 31);
  if (((lo === value) && (hi === hi$1))) {
    var value$1 = this.start$4;
    return new $c_T2().init___O__O(new $c_sci_Range().init___I__I__I(value$1, value$1, this.step$4), this)
  } else {
    var value$2 = this.step$4;
    var hi$2 = (value$2 >> 31);
    var lo$1 = ((lo - value$2) | 0);
    if ((lo$1 === this.last__I())) {
      var value$3 = this.last__I();
      return new $c_T2().init___O__O(this, new $c_sci_Range().init___I__I__I(value$3, value$3, this.step$4))
    } else {
      return new $c_T2().init___O__O(new $c_sci_Range$Inclusive().init___I__I__I(this.start$4, lo$1, this.step$4), new $c_sci_Range$Inclusive().init___I__I__I(((lo$1 + this.step$4) | 0), this.last__I(), this.step$4))
    }
  }
});
$c_sci_Range.prototype.scala$collection$immutable$Range$$validateMaxLength__V = (function() {
  if ((this.scala$collection$immutable$Range$$numRangeElements$4 < 0)) {
    $m_sci_Range$().scala$collection$immutable$Range$$fail__I__I__I__Z__sr_Nothing$(this.start$4, this.end$4, this.step$4, this.isInclusive__Z())
  }
});
$c_sci_Range.prototype.dropWhile__F1__sci_Range = (function(p) {
  var t = this.argTakeWhile__p4__F1__J(p);
  var lo = t.lo$2;
  var hi = t.hi$2;
  var value = this.start$4;
  var hi$1 = (value >> 31);
  if (((lo === value) && (hi === hi$1))) {
    return this
  } else {
    var value$1 = this.step$4;
    var hi$2 = (value$1 >> 31);
    var lo$1 = ((lo - value$1) | 0);
    if ((lo$1 === this.last__I())) {
      var value$2 = this.last__I();
      return new $c_sci_Range().init___I__I__I(value$2, value$2, this.step$4)
    } else {
      return new $c_sci_Range$Inclusive().init___I__I__I(((lo$1 + this.step$4) | 0), this.last__I(), this.step$4)
    }
  }
});
$c_sci_Range.prototype.length__I = (function() {
  return ((this.scala$collection$immutable$Range$$numRangeElements$4 < 0) ? $m_sci_Range$().scala$collection$immutable$Range$$fail__I__I__I__Z__sr_Nothing$(this.start$4, this.end$4, this.step$4, this.isInclusive__Z()) : this.scala$collection$immutable$Range$$numRangeElements$4)
});
$c_sci_Range.prototype.seq__sc_Seq = (function() {
  return this
});
$c_sci_Range.prototype.sizeHintIfCheap__I = (function() {
  return this.length__I()
});
$c_sci_Range.prototype.drop__I__sci_Range = (function(n) {
  if (((n <= 0) || this.isEmpty$4)) {
    return this
  } else if (((n >= this.scala$collection$immutable$Range$$numRangeElements$4) && (this.scala$collection$immutable$Range$$numRangeElements$4 >= 0))) {
    var value = this.end$4;
    return new $c_sci_Range().init___I__I__I(value, value, this.step$4)
  } else {
    return this.copy__I__I__I__sci_Range(this.locationAfterN__p4__I__I(n), this.end$4, this.step$4)
  }
});
$c_sci_Range.prototype.take__I__O = (function(n) {
  return this.take__I__sci_Range(n)
});
$c_sci_Range.prototype.reverse__sci_Range = (function() {
  return (this.isEmpty$4 ? this : new $c_sci_Range$Inclusive().init___I__I__I(this.last__I(), this.start$4, ((-this.step$4) | 0)))
});
$c_sci_Range.prototype.isExact__p4__Z = (function() {
  var t = this.gap__p4__J();
  var lo = t.lo$2;
  var hi$1 = t.hi$2;
  var value = this.step$4;
  var hi = (value >> 31);
  var this$1 = $m_sjsr_RuntimeLong$();
  var lo$1 = this$1.remainderImpl__I__I__I__I__I(lo, hi$1, value, hi);
  var hi$2 = this$1.scala$scalajs$runtime$RuntimeLong$$hiReturn$f;
  return ((lo$1 === 0) && (hi$2 === 0))
});
$c_sci_Range.prototype.last__O = (function() {
  return this.last__I()
});
$c_sci_Range.prototype.drop__I__O = (function(n) {
  return this.drop__I__sci_Range(n)
});
$c_sci_Range.prototype.thisCollection__sc_Seq = (function() {
  return this
});
$c_sci_Range.prototype.tail__O = (function() {
  return this.tail__sci_Range()
});
$c_sci_Range.prototype.toSeq__sc_Seq = (function() {
  return this
});
$c_sci_Range.prototype.take__I__sci_Range = (function(n) {
  if (((n <= 0) || this.isEmpty$4)) {
    var value = this.start$4;
    return new $c_sci_Range().init___I__I__I(value, value, this.step$4)
  } else {
    return (((n >= this.scala$collection$immutable$Range$$numRangeElements$4) && (this.scala$collection$immutable$Range$$numRangeElements$4 >= 0)) ? this : new $c_sci_Range$Inclusive().init___I__I__I(this.start$4, this.locationAfterN__p4__I__I((((-1) + n) | 0)), this.step$4))
  }
});
$c_sci_Range.prototype.last__I = (function() {
  if (this.isEmpty$4) {
    var this$1 = $m_sci_Nil$();
    return $uI($f_sc_LinearSeqOptimized__last__O(this$1))
  } else {
    return this.scala$collection$immutable$Range$$lastElement$4
  }
});
$c_sci_Range.prototype.isDefinedAt__O__Z = (function(x) {
  var idx = $uI(x);
  return $f_sc_GenSeqLike__isDefinedAt__I__Z(this, idx)
});
$c_sci_Range.prototype.toSeq__sc_GenSeq = (function() {
  return this
});
$c_sci_Range.prototype.hashCode__I = (function() {
  return $m_s_util_hashing_MurmurHash3$().seqHash__sc_Seq__I(this)
});
$c_sci_Range.prototype.head__I = (function() {
  return (this.isEmpty$4 ? $m_sci_Nil$().head__sr_Nothing$() : this.start$4)
});
$c_sci_Range.prototype.gap__p4__J = (function() {
  var value = this.end$4;
  var hi = (value >> 31);
  var value$1 = this.start$4;
  var hi$1 = (value$1 >> 31);
  var lo = ((value - value$1) | 0);
  var hi$2 = ((((-2147483648) ^ lo) > ((-2147483648) ^ value)) ? (((-1) + ((hi - hi$1) | 0)) | 0) : ((hi - hi$1) | 0));
  return new $c_sjsr_RuntimeLong().init___I__I(lo, hi$2)
});
function $as_sci_Range(obj) {
  return (((obj instanceof $c_sci_Range) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.Range"))
}
function $isArrayOf_sci_Range(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_Range)))
}
function $asArrayOf_sci_Range(obj, depth) {
  return (($isArrayOf_sci_Range(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.Range;", depth))
}
var $d_sci_Range = new $TypeData().initClass({
  sci_Range: 0
}, false, "scala.collection.immutable.Range", {
  sci_Range: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sci_IndexedSeq: 1,
  sci_Seq: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_Range.prototype.$classData = $d_sci_Range;
/** @constructor */
function $c_sci_Stream() {
  $c_sc_AbstractSeq.call(this)
}
$c_sci_Stream.prototype = new $h_sc_AbstractSeq();
$c_sci_Stream.prototype.constructor = $c_sci_Stream;
/** @constructor */
function $h_sci_Stream() {
  /*<skip>*/
}
$h_sci_Stream.prototype = $c_sci_Stream.prototype;
$c_sci_Stream.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sci_Stream.prototype.reverse__sci_Stream = (function() {
  var elem = $m_sci_Stream$Empty$();
  var result = new $c_sr_ObjectRef().init___O(elem);
  var these = this;
  while ((!these.isEmpty__Z())) {
    $m_sci_Stream$();
    var stream = new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, result$1) {
      return (function() {
        return $as_sci_Stream(result$1.elem$1)
      })
    })(this, result));
    var r = new $c_sci_Stream$ConsWrapper().init___F0(stream).$$hash$colon$colon__O__sci_Stream(these.head__O());
    r.tail__O();
    result.elem$1 = r;
    these = $as_sci_Stream(these.tail__O())
  };
  return $as_sci_Stream(result.elem$1)
});
$c_sci_Stream.prototype.apply__I__O = (function(n) {
  return $f_sc_LinearSeqOptimized__apply__I__O(this, n)
});
$c_sci_Stream.prototype.thisCollection__sc_Iterable = (function() {
  return this
});
$c_sci_Stream.prototype.takeWhile__F1__sci_Stream = (function(p) {
  if (((!this.isEmpty__Z()) && $uZ(p.apply__O__O(this.head__O())))) {
    var hd = this.head__O();
    var tl = new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, p$1) {
      return (function() {
        return $as_sci_Stream($this.tail__O()).takeWhile__F1__sci_Stream(p$1)
      })
    })(this, p));
    return new $c_sci_Stream$Cons().init___O__F0(hd, tl)
  } else {
    return $m_sci_Stream$Empty$()
  }
});
$c_sci_Stream.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_LinearSeqOptimized__lengthCompare__I__I(this, len)
});
$c_sci_Stream.prototype.apply__O__O = (function(v1) {
  var n = $uI(v1);
  return $f_sc_LinearSeqOptimized__apply__I__O(this, n)
});
$c_sci_Stream.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_LinearSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_sci_Stream.prototype.flatten__F1__sc_GenTraversable = (function(asTraversable) {
  return this.flatten__F1__sci_Stream(asTraversable)
});
$c_sci_Stream.prototype.exists__F1__Z = (function(p) {
  return $f_sc_LinearSeqOptimized__exists__F1__Z(this, p)
});
$c_sci_Stream.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sci_Stream.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_Stream.prototype.equals__O__Z = (function(that) {
  return ((this === that) || $f_sc_GenSeqLike__equals__O__Z(this, that))
});
$c_sci_Stream.prototype.flatMap__F1__scg_CanBuildFrom__O = (function(f, bf) {
  if ((bf.apply__O__scm_Builder(this) instanceof $c_sci_Stream$StreamBuilder)) {
    if (this.isEmpty__Z()) {
      var x$1 = $m_sci_Stream$Empty$()
    } else {
      var nonEmptyPrefix = new $c_sr_ObjectRef().init___O(this);
      var prefix = $as_sc_GenTraversableOnce(f.apply__O__O($as_sci_Stream(nonEmptyPrefix.elem$1).head__O())).toStream__sci_Stream();
      while (((!$as_sci_Stream(nonEmptyPrefix.elem$1).isEmpty__Z()) && prefix.isEmpty__Z())) {
        nonEmptyPrefix.elem$1 = $as_sci_Stream($as_sci_Stream(nonEmptyPrefix.elem$1).tail__O());
        if ((!$as_sci_Stream(nonEmptyPrefix.elem$1).isEmpty__Z())) {
          prefix = $as_sc_GenTraversableOnce(f.apply__O__O($as_sci_Stream(nonEmptyPrefix.elem$1).head__O())).toStream__sci_Stream()
        }
      };
      var x$1 = ($as_sci_Stream(nonEmptyPrefix.elem$1).isEmpty__Z() ? ($m_sci_Stream$(), $m_sci_Stream$Empty$()) : prefix.append__F0__sci_Stream(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, nonEmptyPrefix$1, f$1) {
        return (function() {
          var x = $as_sci_Stream($as_sci_Stream(nonEmptyPrefix$1.elem$1).tail__O()).flatMap__F1__scg_CanBuildFrom__O(f$1, ($m_sci_Stream$(), new $c_sci_Stream$StreamCanBuildFrom().init___()));
          return $as_sci_Stream(x)
        })
      })(this, nonEmptyPrefix, f))))
    };
    return x$1
  } else {
    return $f_sc_TraversableLike__flatMap__F1__scg_CanBuildFrom__O(this, f, bf)
  }
});
$c_sci_Stream.prototype.filterImpl__F1__Z__sci_Stream = (function(p, isFlipped) {
  var rest = this;
  while (((!rest.isEmpty__Z()) && ($uZ(p.apply__O__O(rest.head__O())) === isFlipped))) {
    rest = $as_sci_Stream(rest.tail__O())
  };
  var this$1 = rest;
  if ($f_sc_TraversableOnce__nonEmpty__Z(this$1)) {
    return $m_sci_Stream$().filteredTail__sci_Stream__F1__Z__sci_Stream$Cons(rest, p, isFlipped)
  } else {
    return $m_sci_Stream$Empty$()
  }
});
$c_sci_Stream.prototype.drop__I__sc_LinearSeqOptimized = (function(n) {
  return this.drop__I__sci_Stream(n)
});
$c_sci_Stream.prototype.dropWhile__F1__O = (function(p) {
  return this.dropWhile__F1__sci_Stream(p)
});
$c_sci_Stream.prototype.mkString__T__T = (function(sep) {
  return this.mkString__T__T__T__T("", sep, "")
});
$c_sci_Stream.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  this.force__sci_Stream();
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, start, sep, end)
});
$c_sci_Stream.prototype.forall__F1__Z = (function(p) {
  return $f_sc_LinearSeqOptimized__forall__F1__Z(this, p)
});
$c_sci_Stream.prototype.withFilter__F1__scg_FilterMonadic = (function(p) {
  return new $c_sci_Stream$StreamWithFilter().init___F0__F1(new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
    return (function() {
      return $this
    })
  })(this)), p)
});
$c_sci_Stream.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sci_Stream$()
});
$c_sci_Stream.prototype.toString__T = (function() {
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this, "Stream(", ", ", ")")
});
$c_sci_Stream.prototype.foreach__F1__V = (function(f) {
  var _$this = this;
  _foreach: while (true) {
    if ((!_$this.isEmpty__Z())) {
      f.apply__O__O(_$this.head__O());
      _$this = $as_sci_Stream(_$this.tail__O());
      continue _foreach
    };
    break
  }
});
$c_sci_Stream.prototype.foldLeft__O__F2__O = (function(z, op) {
  var _$this = this;
  _foldLeft: while (true) {
    if (_$this.isEmpty__Z()) {
      return z
    } else {
      var temp$_$this = $as_sci_Stream(_$this.tail__O());
      var temp$z = op.apply__O__O__O(z, _$this.head__O());
      _$this = temp$_$this;
      z = temp$z;
      continue _foldLeft
    }
  }
});
$c_sci_Stream.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_LinearSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_sci_Stream.prototype.takeWhile__F1__O = (function(p) {
  return this.takeWhile__F1__sci_Stream(p)
});
$c_sci_Stream.prototype.loop$2__p4__sci_Set__sci_Stream__sci_Stream = (function(seen, rest) {
  _loop: while (true) {
    if (rest.isEmpty__Z()) {
      return rest
    } else {
      var elem = rest.head__O();
      if (seen.contains__O__Z(elem)) {
        rest = $as_sci_Stream(rest.tail__O());
        continue _loop
      } else {
        var hd = rest.head__O();
        var tl = new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, seen$1, rest$1) {
          return (function() {
            return $this.loop$2__p4__sci_Set__sci_Stream__sci_Stream($as_sci_Set(seen$1.$$plus__O__sc_Set(rest$1.head__O())), $as_sci_Stream(rest$1.tail__O()))
          })
        })(this, seen, rest));
        return new $c_sci_Stream$Cons().init___O__F0(hd, tl)
      }
    }
  }
});
$c_sci_Stream.prototype.reverse__O = (function() {
  return this.reverse__sci_Stream()
});
$c_sci_Stream.prototype.filterImpl__F1__Z__O = (function(p, isFlipped) {
  return this.filterImpl__F1__Z__sci_Stream(p, isFlipped)
});
$c_sci_Stream.prototype.distinct__O = (function() {
  return this.distinct__sci_Stream()
});
$c_sci_Stream.prototype.distinct__sci_Stream = (function() {
  return this.loop$2__p4__sci_Set__sci_Stream__sci_Stream($as_sci_Set($m_sci_Set$().apply__sc_Seq__sc_GenTraversable($m_sci_Nil$())), this)
});
$c_sci_Stream.prototype.$$plus$colon__O__scg_CanBuildFrom__O = (function(elem, bf) {
  if ((bf.apply__O__scm_Builder(this) instanceof $c_sci_Stream$StreamBuilder)) {
    var tl = new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
      return (function() {
        return $this
      })
    })(this));
    var x = new $c_sci_Stream$Cons().init___O__F0(elem, tl);
    return x
  } else {
    return $f_sc_SeqLike__$$plus$colon__O__scg_CanBuildFrom__O(this, elem, bf)
  }
});
$c_sci_Stream.prototype.iterator__sc_Iterator = (function() {
  return new $c_sci_StreamIterator().init___sci_Stream(this)
});
$c_sci_Stream.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_LinearSeqOptimized__find__F1__s_Option(this, p)
});
$c_sci_Stream.prototype.span__F1__T2 = (function(p) {
  return $f_sc_LinearSeqOptimized__span__F1__T2(this, p)
});
$c_sci_Stream.prototype.length__I = (function() {
  var len = 0;
  var left = this;
  while ((!left.isEmpty__Z())) {
    len = ((1 + len) | 0);
    left = $as_sci_Stream(left.tail__O())
  };
  return len
});
$c_sci_Stream.prototype.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O = (function(that, bf) {
  if ((bf.apply__O__scm_Builder(this) instanceof $c_sci_Stream$StreamBuilder)) {
    if (this.isEmpty__Z()) {
      var x$1 = that.toStream__sci_Stream()
    } else {
      var hd = this.head__O();
      var tl = new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, that$1) {
        return (function() {
          var x = $as_sci_Stream($this.tail__O()).$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(that$1, ($m_sci_Stream$(), new $c_sci_Stream$StreamCanBuildFrom().init___()));
          return $as_sci_Stream(x)
        })
      })(this, that));
      var x$1 = new $c_sci_Stream$Cons().init___O__F0(hd, tl)
    };
    return x$1
  } else {
    return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf)
  }
});
$c_sci_Stream.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  var this$1 = $m_sci_Stream$();
  return this.zip__sc_GenIterable__scg_CanBuildFrom__O(this$1.from__I__I__sci_Stream(0, 1), bf)
});
$c_sci_Stream.prototype.mkString__T = (function() {
  return this.mkString__T__T__T__T("", "", "")
});
$c_sci_Stream.prototype.seq__sc_Seq = (function() {
  return this
});
$c_sci_Stream.prototype.partition__F1__T2 = (function(p) {
  var p$2 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, p$1) {
    return (function(x$1$2) {
      return $uZ(p$1.apply__O__O(x$1$2))
    })
  })(this, p));
  var jsx$1 = this.filterImpl__F1__Z__sci_Stream(p$2, false);
  var p$4 = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function(this$2, p$3) {
    return (function(x$2$2) {
      return $uZ(p$3.apply__O__O(x$2$2))
    })
  })(this, p));
  return new $c_T2().init___O__O(jsx$1, this.filterImpl__F1__Z__sci_Stream(p$4, true))
});
$c_sci_Stream.prototype.take__I__O = (function(n) {
  return this.take__I__sci_Stream(n)
});
$c_sci_Stream.prototype.toStream__sci_Stream = (function() {
  return this
});
$c_sci_Stream.prototype.view__sc_SeqView = (function() {
  return new $c_sci_Stream$$anon$1().init___sci_Stream(this)
});
$c_sci_Stream.prototype.flatten__F1__sci_Stream = (function(asTraversable) {
  var st = new $c_sr_ObjectRef().init___O(this);
  while (true) {
    var this$2 = $as_sci_Stream(st.elem$1);
    if ($f_sc_TraversableOnce__nonEmpty__Z(this$2)) {
      var h = $as_sc_GenTraversableOnce(asTraversable.apply__O__O($as_sci_Stream(st.elem$1).head__O()));
      if (h.isEmpty__Z()) {
        st.elem$1 = $as_sci_Stream($as_sci_Stream(st.elem$1).tail__O())
      } else {
        var x$4 = h.toStream__sci_Stream();
        $m_sci_Stream$();
        var stream = new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, st$1, asTraversable$1) {
          return (function() {
            return $as_sci_Stream($as_sci_Stream(st$1.elem$1).tail__O()).flatten__F1__sci_Stream(asTraversable$1)
          })
        })(this, st, asTraversable));
        return new $c_sci_Stream$ConsWrapper().init___F0(stream).$$hash$colon$colon$colon__sci_Stream__sci_Stream(x$4)
      }
    } else {
      break
    }
  };
  $m_sci_Stream$();
  return $m_sci_Stream$Empty$()
});
$c_sci_Stream.prototype.last__O = (function() {
  return $f_sc_LinearSeqOptimized__last__O(this)
});
$c_sci_Stream.prototype.drop__I__O = (function(n) {
  return this.drop__I__sci_Stream(n)
});
$c_sci_Stream.prototype.drop__I__sci_Stream = (function(n) {
  var _$this = this;
  _drop: while (true) {
    if (((n <= 0) || _$this.isEmpty__Z())) {
      return _$this
    } else {
      var temp$_$this = $as_sci_Stream(_$this.tail__O());
      var temp$n = (((-1) + n) | 0);
      _$this = temp$_$this;
      n = temp$n;
      continue _drop
    }
  }
});
$c_sci_Stream.prototype.thisCollection__sc_Seq = (function() {
  return this
});
$c_sci_Stream.prototype.contains__O__Z = (function(elem) {
  return $f_sc_LinearSeqOptimized__contains__O__Z(this, elem)
});
$c_sci_Stream.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  b.append__T__scm_StringBuilder(start);
  if ((!this.isEmpty__Z())) {
    b.append__O__scm_StringBuilder(this.head__O());
    var cursor = this;
    var n = 1;
    if (cursor.tailDefined__Z()) {
      var scout = $as_sci_Stream(this.tail__O());
      if (scout.isEmpty__Z()) {
        b.append__T__scm_StringBuilder(end);
        return b
      };
      if ((cursor !== scout)) {
        cursor = scout;
        if (scout.tailDefined__Z()) {
          scout = $as_sci_Stream(scout.tail__O());
          while (((cursor !== scout) && scout.tailDefined__Z())) {
            b.append__T__scm_StringBuilder(sep).append__O__scm_StringBuilder(cursor.head__O());
            n = ((1 + n) | 0);
            cursor = $as_sci_Stream(cursor.tail__O());
            scout = $as_sci_Stream(scout.tail__O());
            if (scout.tailDefined__Z()) {
              scout = $as_sci_Stream(scout.tail__O())
            }
          }
        }
      };
      if ((!scout.tailDefined__Z())) {
        while ((cursor !== scout)) {
          b.append__T__scm_StringBuilder(sep).append__O__scm_StringBuilder(cursor.head__O());
          n = ((1 + n) | 0);
          cursor = $as_sci_Stream(cursor.tail__O())
        };
        var this$1 = cursor;
        if ($f_sc_TraversableOnce__nonEmpty__Z(this$1)) {
          b.append__T__scm_StringBuilder(sep).append__O__scm_StringBuilder(cursor.head__O())
        }
      } else {
        var runner = this;
        var k = 0;
        while ((runner !== scout)) {
          runner = $as_sci_Stream(runner.tail__O());
          scout = $as_sci_Stream(scout.tail__O());
          k = ((1 + k) | 0)
        };
        if (((cursor === scout) && (k > 0))) {
          b.append__T__scm_StringBuilder(sep).append__O__scm_StringBuilder(cursor.head__O());
          n = ((1 + n) | 0);
          cursor = $as_sci_Stream(cursor.tail__O())
        };
        while ((cursor !== scout)) {
          b.append__T__scm_StringBuilder(sep).append__O__scm_StringBuilder(cursor.head__O());
          n = ((1 + n) | 0);
          cursor = $as_sci_Stream(cursor.tail__O())
        };
        n = ((n - k) | 0)
      }
    };
    if ((!cursor.isEmpty__Z())) {
      if ((!cursor.tailDefined__Z())) {
        b.append__T__scm_StringBuilder(sep).append__T__scm_StringBuilder("?")
      } else {
        b.append__T__scm_StringBuilder(sep).append__T__scm_StringBuilder("...")
      }
    }
  };
  b.append__T__scm_StringBuilder(end);
  return b
});
$c_sci_Stream.prototype.toSeq__sc_Seq = (function() {
  return this
});
$c_sci_Stream.prototype.force__sci_Stream = (function() {
  var these = this;
  var those = this;
  if ((!these.isEmpty__Z())) {
    these = $as_sci_Stream(these.tail__O())
  };
  while ((those !== these)) {
    if (these.isEmpty__Z()) {
      return this
    };
    these = $as_sci_Stream(these.tail__O());
    if (these.isEmpty__Z()) {
      return this
    };
    these = $as_sci_Stream(these.tail__O());
    if ((these === those)) {
      return this
    };
    those = $as_sci_Stream(those.tail__O())
  };
  return this
});
$c_sci_Stream.prototype.isDefinedAt__O__Z = (function(x) {
  var x$1 = $uI(x);
  return $f_sc_LinearSeqOptimized__isDefinedAt__I__Z(this, x$1)
});
$c_sci_Stream.prototype.dropWhile__F1__sci_Stream = (function(p) {
  var these = this;
  while (((!these.isEmpty__Z()) && $uZ(p.apply__O__O(these.head__O())))) {
    these = $as_sci_Stream(these.tail__O())
  };
  return these
});
$c_sci_Stream.prototype.toSeq__sc_GenSeq = (function() {
  return this
});
$c_sci_Stream.prototype.hashCode__I = (function() {
  return $m_s_util_hashing_MurmurHash3$().seqHash__sc_Seq__I(this)
});
$c_sci_Stream.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  if ((bf.apply__O__scm_Builder(this) instanceof $c_sci_Stream$StreamBuilder)) {
    if (this.isEmpty__Z()) {
      var x$1 = $m_sci_Stream$Empty$()
    } else {
      var hd = f.apply__O__O(this.head__O());
      var tl = new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, f$1) {
        return (function() {
          var x = $as_sci_Stream($this.tail__O()).map__F1__scg_CanBuildFrom__O(f$1, ($m_sci_Stream$(), new $c_sci_Stream$StreamCanBuildFrom().init___()));
          return $as_sci_Stream(x)
        })
      })(this, f));
      var x$1 = new $c_sci_Stream$Cons().init___O__F0(hd, tl)
    };
    return x$1
  } else {
    return $f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this, f, bf)
  }
});
$c_sci_Stream.prototype.take__I__sci_Stream = (function(n) {
  if (((n <= 0) || this.isEmpty__Z())) {
    $m_sci_Stream$();
    return $m_sci_Stream$Empty$()
  } else if ((n === 1)) {
    var hd = this.head__O();
    var tl = new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
      return (function() {
        $m_sci_Stream$();
        return $m_sci_Stream$Empty$()
      })
    })(this));
    return new $c_sci_Stream$Cons().init___O__F0(hd, tl)
  } else {
    var hd$1 = this.head__O();
    var tl$1 = new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function(this$2$1, n$1) {
      return (function() {
        return $as_sci_Stream(this$2$1.tail__O()).take__I__sci_Stream((((-1) + n$1) | 0))
      })
    })(this, n));
    return new $c_sci_Stream$Cons().init___O__F0(hd$1, tl$1)
  }
});
$c_sci_Stream.prototype.collect__s_PartialFunction__scg_CanBuildFrom__O = (function(pf, bf) {
  if ((!(bf.apply__O__scm_Builder(this) instanceof $c_sci_Stream$StreamBuilder))) {
    return $f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this, pf, bf)
  } else {
    var rest = this;
    var newHead = new $c_sr_ObjectRef().init___O(null);
    var runWith = pf.runWith__F1__F1(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, newHead$1) {
      return (function(b$2) {
        newHead$1.elem$1 = b$2
      })
    })(this, newHead)));
    while (true) {
      var this$2 = rest;
      if (($f_sc_TraversableOnce__nonEmpty__Z(this$2) && (!$uZ(runWith.apply__O__O(rest.head__O()))))) {
        rest = $as_sci_Stream(rest.tail__O())
      } else {
        break
      }
    };
    return (rest.isEmpty__Z() ? $m_sci_Stream$Empty$() : $m_sci_Stream$().collectedTail__O__sci_Stream__s_PartialFunction__scg_CanBuildFrom__sci_Stream$Cons(newHead.elem$1, rest, pf, bf))
  }
});
$c_sci_Stream.prototype.reduceLeft__F2__O = (function(f) {
  if (this.isEmpty__Z()) {
    throw new $c_jl_UnsupportedOperationException().init___T("empty.reduceLeft")
  } else {
    var reducedRes = this.head__O();
    var left = $as_sci_Stream(this.tail__O());
    while ((!left.isEmpty__Z())) {
      reducedRes = f.apply__O__O__O(reducedRes, left.head__O());
      left = $as_sci_Stream(left.tail__O())
    };
    return reducedRes
  }
});
$c_sci_Stream.prototype.append__F0__sci_Stream = (function(rest) {
  if (this.isEmpty__Z()) {
    return $as_sc_GenTraversableOnce(rest.apply__O()).toStream__sci_Stream()
  } else {
    var hd = this.head__O();
    var tl = new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, rest$1) {
      return (function() {
        return $as_sci_Stream($this.tail__O()).append__F0__sci_Stream(rest$1)
      })
    })(this, rest));
    return new $c_sci_Stream$Cons().init___O__F0(hd, tl)
  }
});
$c_sci_Stream.prototype.stringPrefix__T = (function() {
  return "Stream"
});
$c_sci_Stream.prototype.zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  if ((bf.apply__O__scm_Builder(this) instanceof $c_sci_Stream$StreamBuilder)) {
    if ((this.isEmpty__Z() || that.isEmpty__Z())) {
      var x$1 = $m_sci_Stream$Empty$()
    } else {
      var hd = new $c_T2().init___O__O(this.head__O(), that.head__O());
      var tl = new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this, that$1) {
        return (function() {
          var x = $as_sci_Stream($this.tail__O()).zip__sc_GenIterable__scg_CanBuildFrom__O($as_sc_GenIterable(that$1.tail__O()), ($m_sci_Stream$(), new $c_sci_Stream$StreamCanBuildFrom().init___()));
          return $as_sci_Stream(x)
        })
      })(this, that));
      var x$1 = new $c_sci_Stream$Cons().init___O__F0(hd, tl)
    };
    return x$1
  } else {
    return $f_sc_IterableLike__zip__sc_GenIterable__scg_CanBuildFrom__O(this, that, bf)
  }
});
function $as_sci_Stream(obj) {
  return (((obj instanceof $c_sci_Stream) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.Stream"))
}
function $isArrayOf_sci_Stream(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_Stream)))
}
function $asArrayOf_sci_Stream(obj, depth) {
  return (($isArrayOf_sci_Stream(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.Stream;", depth))
}
function $is_scm_Buffer(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.scm_Buffer)))
}
function $as_scm_Buffer(obj) {
  return (($is_scm_Buffer(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.Buffer"))
}
function $isArrayOf_scm_Buffer(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_Buffer)))
}
function $asArrayOf_scm_Buffer(obj, depth) {
  return (($isArrayOf_scm_Buffer(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.Buffer;", depth))
}
function $f_scm_ResizableArray__apply__I__O($thiz, idx) {
  if ((idx >= $thiz.size0$6)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T(("" + idx))
  };
  return $thiz.array$6.get(idx)
}
function $f_scm_ResizableArray__update__I__O__V($thiz, idx, elem) {
  if ((idx >= $thiz.size0$6)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T(("" + idx))
  };
  $thiz.array$6.set(idx, elem)
}
function $f_scm_ResizableArray__foreach__F1__V($thiz, f) {
  var i = 0;
  var top = $thiz.size0$6;
  while ((i < top)) {
    f.apply__O__O($thiz.array$6.get(i));
    i = ((1 + i) | 0)
  }
}
function $f_scm_ResizableArray__ensureSize__I__V($thiz, n) {
  var value = $thiz.array$6.u.length;
  var hi = (value >> 31);
  var hi$1 = (n >> 31);
  if (((hi$1 === hi) ? (((-2147483648) ^ n) > ((-2147483648) ^ value)) : (hi$1 > hi))) {
    var lo = (value << 1);
    var hi$2 = (((value >>> 31) | 0) | (hi << 1));
    var newSize_$_lo$2 = lo;
    var newSize_$_hi$2 = hi$2;
    while (true) {
      var hi$3 = (n >> 31);
      var b_$_lo$2 = newSize_$_lo$2;
      var b_$_hi$2 = newSize_$_hi$2;
      var bhi = b_$_hi$2;
      if (((hi$3 === bhi) ? (((-2147483648) ^ n) > ((-2147483648) ^ b_$_lo$2)) : (hi$3 > bhi))) {
        var this$1_$_lo$2 = newSize_$_lo$2;
        var this$1_$_hi$2 = newSize_$_hi$2;
        var lo$1 = (this$1_$_lo$2 << 1);
        var hi$4 = (((this$1_$_lo$2 >>> 31) | 0) | (this$1_$_hi$2 << 1));
        var jsx$1_$_lo$2 = lo$1;
        var jsx$1_$_hi$2 = hi$4;
        newSize_$_lo$2 = jsx$1_$_lo$2;
        newSize_$_hi$2 = jsx$1_$_hi$2
      } else {
        break
      }
    };
    var this$2_$_lo$2 = newSize_$_lo$2;
    var this$2_$_hi$2 = newSize_$_hi$2;
    var ahi = this$2_$_hi$2;
    if (((ahi === 0) ? (((-2147483648) ^ this$2_$_lo$2) > (-1)) : (ahi > 0))) {
      var jsx$2_$_lo$2 = 2147483647;
      var jsx$2_$_hi$2 = 0;
      newSize_$_lo$2 = jsx$2_$_lo$2;
      newSize_$_hi$2 = jsx$2_$_hi$2
    };
    var this$3_$_lo$2 = newSize_$_lo$2;
    var this$3_$_hi$2 = newSize_$_hi$2;
    var newArray = $newArrayObject($d_O.getArrayOf(), [this$3_$_lo$2]);
    $systemArraycopy($thiz.array$6, 0, newArray, 0, $thiz.size0$6);
    $thiz.array$6 = newArray
  }
}
function $f_scm_ResizableArray__$$init$__V($thiz) {
  var x = $thiz.initialSize$6;
  $thiz.array$6 = $newArrayObject($d_O.getArrayOf(), [((x > 1) ? x : 1)]);
  $thiz.size0$6 = 0
}
function $f_scm_ResizableArray__reduceToSize__I__V($thiz, sz) {
  $m_s_Predef$().require__Z__V((sz <= $thiz.size0$6));
  while (($thiz.size0$6 > sz)) {
    $thiz.size0$6 = (((-1) + $thiz.size0$6) | 0);
    $thiz.array$6.set($thiz.size0$6, null)
  }
}
function $f_scm_ResizableArray__copyToArray__O__I__I__V($thiz, xs, start, len) {
  var that = (($m_sr_ScalaRunTime$().array$undlength__O__I(xs) - start) | 0);
  var x = ((len < that) ? len : that);
  var that$1 = $thiz.size0$6;
  var len1 = ((x < that$1) ? x : that$1);
  if ((len1 > 0)) {
    $m_s_Array$().copy__O__I__O__I__I__V($thiz.array$6, 0, xs, start, len1)
  }
}
/** @constructor */
function $c_sc_SeqViewLike$$anon$1() {
  $c_sc_SeqViewLike$AbstractTransformed.call(this);
  this.forced$2 = null;
  this.$$outer$2 = null
}
$c_sc_SeqViewLike$$anon$1.prototype = new $h_sc_SeqViewLike$AbstractTransformed();
$c_sc_SeqViewLike$$anon$1.prototype.constructor = $c_sc_SeqViewLike$$anon$1;
/** @constructor */
function $h_sc_SeqViewLike$$anon$1() {
  /*<skip>*/
}
$h_sc_SeqViewLike$$anon$1.prototype = $c_sc_SeqViewLike$$anon$1.prototype;
$c_sc_SeqViewLike$$anon$1.prototype.apply__I__O = (function(idx) {
  return this.forced$2.apply__I__O(idx)
});
$c_sc_SeqViewLike$$anon$1.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return this.forced$2.apply__I__O(idx)
});
$c_sc_SeqViewLike$$anon$1.prototype.init___sc_SeqViewLike__F0 = (function($$outer, xs$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  var forced = $as_sc_GenSeq(xs$1.apply__O());
  this.forced$2 = forced;
  $c_sc_SeqViewLike$AbstractTransformed.prototype.init___sc_SeqViewLike.call(this, $$outer);
  return this
});
$c_sc_SeqViewLike$$anon$1.prototype.foreach__F1__V = (function(f) {
  this.forced$2.foreach__F1__V(f)
});
$c_sc_SeqViewLike$$anon$1.prototype.iterator__sc_Iterator = (function() {
  return this.forced$2.iterator__sc_Iterator()
});
$c_sc_SeqViewLike$$anon$1.prototype.viewIdentifier__T = (function() {
  return "C"
});
$c_sc_SeqViewLike$$anon$1.prototype.length__I = (function() {
  return this.forced$2.length__I()
});
var $d_sc_SeqViewLike$$anon$1 = new $TypeData().initClass({
  sc_SeqViewLike$$anon$1: 0
}, false, "scala.collection.SeqViewLike$$anon$1", {
  sc_SeqViewLike$$anon$1: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sc_SeqViewLike$Forced: 1,
  sc_IterableViewLike$Forced: 1,
  sc_TraversableViewLike$Forced: 1
});
$c_sc_SeqViewLike$$anon$1.prototype.$classData = $d_sc_SeqViewLike$$anon$1;
/** @constructor */
function $c_sc_SeqViewLike$$anon$2() {
  $c_sc_SeqViewLike$AbstractTransformed.call(this);
  this.rest$2 = null;
  this.restSeq$2 = null;
  this.bitmap$0$2 = false;
  this.$$outer$2 = null
}
$c_sc_SeqViewLike$$anon$2.prototype = new $h_sc_SeqViewLike$AbstractTransformed();
$c_sc_SeqViewLike$$anon$2.prototype.constructor = $c_sc_SeqViewLike$$anon$2;
/** @constructor */
function $h_sc_SeqViewLike$$anon$2() {
  /*<skip>*/
}
$h_sc_SeqViewLike$$anon$2.prototype = $c_sc_SeqViewLike$$anon$2.prototype;
$c_sc_SeqViewLike$$anon$2.prototype.restSeq$lzycompute__p2__sc_GenSeq = (function() {
  if ((!this.bitmap$0$2)) {
    this.restSeq$2 = this.rest$2.toSeq__sc_GenSeq();
    this.bitmap$0$2 = true
  };
  return this.restSeq$2
});
$c_sc_SeqViewLike$$anon$2.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$Appended__apply__I__O(this, idx)
});
$c_sc_SeqViewLike$$anon$2.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$Appended__apply__I__O(this, idx)
});
$c_sc_SeqViewLike$$anon$2.prototype.foreach__F1__V = (function(f) {
  $f_sc_TraversableViewLike$Appended__foreach__F1__V(this, f)
});
$c_sc_SeqViewLike$$anon$2.prototype.init___sc_SeqViewLike__sc_GenTraversable = (function($$outer, that$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.rest$2 = that$1;
  $c_sc_SeqViewLike$AbstractTransformed.prototype.init___sc_SeqViewLike.call(this, $$outer);
  return this
});
$c_sc_SeqViewLike$$anon$2.prototype.scala$collection$TraversableViewLike$Appended$$$outer__sc_TraversableViewLike = (function() {
  return this.$$outer$2
});
$c_sc_SeqViewLike$$anon$2.prototype.rest__sc_GenTraversable = (function() {
  return this.rest$2
});
$c_sc_SeqViewLike$$anon$2.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_IterableViewLike$Appended__iterator__sc_Iterator(this)
});
$c_sc_SeqViewLike$$anon$2.prototype.viewIdentifier__T = (function() {
  return "A"
});
$c_sc_SeqViewLike$$anon$2.prototype.length__I = (function() {
  return $f_sc_SeqViewLike$Appended__length__I(this)
});
$c_sc_SeqViewLike$$anon$2.prototype.scala$collection$SeqViewLike$Appended$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$2
});
$c_sc_SeqViewLike$$anon$2.prototype.scala$collection$IterableViewLike$Appended$$$outer__sc_IterableViewLike = (function() {
  return this.$$outer$2
});
$c_sc_SeqViewLike$$anon$2.prototype.restSeq__sc_GenSeq = (function() {
  return ((!this.bitmap$0$2) ? this.restSeq$lzycompute__p2__sc_GenSeq() : this.restSeq$2)
});
var $d_sc_SeqViewLike$$anon$2 = new $TypeData().initClass({
  sc_SeqViewLike$$anon$2: 0
}, false, "scala.collection.SeqViewLike$$anon$2", {
  sc_SeqViewLike$$anon$2: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sc_SeqViewLike$Appended: 1,
  sc_IterableViewLike$Appended: 1,
  sc_TraversableViewLike$Appended: 1
});
$c_sc_SeqViewLike$$anon$2.prototype.$classData = $d_sc_SeqViewLike$$anon$2;
/** @constructor */
function $c_sc_SeqViewLike$$anon$3() {
  $c_sc_SeqViewLike$AbstractTransformed.call(this);
  this.fst$2 = null;
  this.fstSeq$2 = null;
  this.bitmap$0$2 = false;
  this.$$outer$2 = null
}
$c_sc_SeqViewLike$$anon$3.prototype = new $h_sc_SeqViewLike$AbstractTransformed();
$c_sc_SeqViewLike$$anon$3.prototype.constructor = $c_sc_SeqViewLike$$anon$3;
/** @constructor */
function $h_sc_SeqViewLike$$anon$3() {
  /*<skip>*/
}
$h_sc_SeqViewLike$$anon$3.prototype = $c_sc_SeqViewLike$$anon$3.prototype;
$c_sc_SeqViewLike$$anon$3.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$Prepended__apply__I__O(this, idx)
});
$c_sc_SeqViewLike$$anon$3.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$Prepended__apply__I__O(this, idx)
});
$c_sc_SeqViewLike$$anon$3.prototype.scala$collection$SeqViewLike$Prepended$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$2
});
$c_sc_SeqViewLike$$anon$3.prototype.fstSeq__sc_GenSeq = (function() {
  return ((!this.bitmap$0$2) ? this.fstSeq$lzycompute__p2__sc_GenSeq() : this.fstSeq$2)
});
$c_sc_SeqViewLike$$anon$3.prototype.fstSeq$lzycompute__p2__sc_GenSeq = (function() {
  if ((!this.bitmap$0$2)) {
    this.fstSeq$2 = this.fst$2.toSeq__sc_GenSeq();
    this.bitmap$0$2 = true
  };
  return this.fstSeq$2
});
$c_sc_SeqViewLike$$anon$3.prototype.foreach__F1__V = (function(f) {
  $f_sc_TraversableViewLike$Prepended__foreach__F1__V(this, f)
});
$c_sc_SeqViewLike$$anon$3.prototype.init___sc_SeqViewLike__sc_GenTraversable = (function($$outer, that$2) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.fst$2 = that$2;
  $c_sc_SeqViewLike$AbstractTransformed.prototype.init___sc_SeqViewLike.call(this, $$outer);
  return this
});
$c_sc_SeqViewLike$$anon$3.prototype.fst__sc_GenTraversable = (function() {
  return this.fst$2
});
$c_sc_SeqViewLike$$anon$3.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_IterableViewLike$Prepended__iterator__sc_Iterator(this)
});
$c_sc_SeqViewLike$$anon$3.prototype.viewIdentifier__T = (function() {
  return "A"
});
$c_sc_SeqViewLike$$anon$3.prototype.length__I = (function() {
  return $f_sc_SeqViewLike$Prepended__length__I(this)
});
$c_sc_SeqViewLike$$anon$3.prototype.scala$collection$TraversableViewLike$Prepended$$$outer__sc_TraversableViewLike = (function() {
  return this.$$outer$2
});
$c_sc_SeqViewLike$$anon$3.prototype.scala$collection$IterableViewLike$Prepended$$$outer__sc_IterableViewLike = (function() {
  return this.$$outer$2
});
var $d_sc_SeqViewLike$$anon$3 = new $TypeData().initClass({
  sc_SeqViewLike$$anon$3: 0
}, false, "scala.collection.SeqViewLike$$anon$3", {
  sc_SeqViewLike$$anon$3: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sc_SeqViewLike$Prepended: 1,
  sc_IterableViewLike$Prepended: 1,
  sc_TraversableViewLike$Prepended: 1
});
$c_sc_SeqViewLike$$anon$3.prototype.$classData = $d_sc_SeqViewLike$$anon$3;
/** @constructor */
function $c_sc_SeqViewLike$$anon$4() {
  $c_sc_SeqViewLike$AbstractTransformed.call(this);
  this.mapping$2 = null;
  this.$$outer$2 = null
}
$c_sc_SeqViewLike$$anon$4.prototype = new $h_sc_SeqViewLike$AbstractTransformed();
$c_sc_SeqViewLike$$anon$4.prototype.constructor = $c_sc_SeqViewLike$$anon$4;
/** @constructor */
function $h_sc_SeqViewLike$$anon$4() {
  /*<skip>*/
}
$h_sc_SeqViewLike$$anon$4.prototype = $c_sc_SeqViewLike$$anon$4.prototype;
$c_sc_SeqViewLike$$anon$4.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$Mapped__apply__I__O(this, idx)
});
$c_sc_SeqViewLike$$anon$4.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$Mapped__apply__I__O(this, idx)
});
$c_sc_SeqViewLike$$anon$4.prototype.foreach__F1__V = (function(f) {
  $f_sc_TraversableViewLike$Mapped__foreach__F1__V(this, f)
});
$c_sc_SeqViewLike$$anon$4.prototype.mapping__F1 = (function() {
  return this.mapping$2
});
$c_sc_SeqViewLike$$anon$4.prototype.scala$collection$SeqViewLike$Mapped$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$2
});
$c_sc_SeqViewLike$$anon$4.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_IterableViewLike$Mapped__iterator__sc_Iterator(this)
});
$c_sc_SeqViewLike$$anon$4.prototype.viewIdentifier__T = (function() {
  return "M"
});
$c_sc_SeqViewLike$$anon$4.prototype.length__I = (function() {
  return this.$$outer$2.length__I()
});
$c_sc_SeqViewLike$$anon$4.prototype.scala$collection$IterableViewLike$Mapped$$$outer__sc_IterableViewLike = (function() {
  return this.$$outer$2
});
$c_sc_SeqViewLike$$anon$4.prototype.init___sc_SeqViewLike__F1 = (function($$outer, f$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.mapping$2 = f$1;
  $c_sc_SeqViewLike$AbstractTransformed.prototype.init___sc_SeqViewLike.call(this, $$outer);
  return this
});
$c_sc_SeqViewLike$$anon$4.prototype.scala$collection$TraversableViewLike$Mapped$$$outer__sc_TraversableViewLike = (function() {
  return this.$$outer$2
});
var $d_sc_SeqViewLike$$anon$4 = new $TypeData().initClass({
  sc_SeqViewLike$$anon$4: 0
}, false, "scala.collection.SeqViewLike$$anon$4", {
  sc_SeqViewLike$$anon$4: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sc_SeqViewLike$Mapped: 1,
  sc_IterableViewLike$Mapped: 1,
  sc_TraversableViewLike$Mapped: 1
});
$c_sc_SeqViewLike$$anon$4.prototype.$classData = $d_sc_SeqViewLike$$anon$4;
/** @constructor */
function $c_sc_SeqViewLike$$anon$5() {
  $c_sc_SeqViewLike$AbstractTransformed.call(this);
  this.mapping$2 = null;
  this.index$2 = null;
  this.bitmap$0$2 = false;
  this.$$outer$2 = null
}
$c_sc_SeqViewLike$$anon$5.prototype = new $h_sc_SeqViewLike$AbstractTransformed();
$c_sc_SeqViewLike$$anon$5.prototype.constructor = $c_sc_SeqViewLike$$anon$5;
/** @constructor */
function $h_sc_SeqViewLike$$anon$5() {
  /*<skip>*/
}
$h_sc_SeqViewLike$$anon$5.prototype = $c_sc_SeqViewLike$$anon$5.prototype;
$c_sc_SeqViewLike$$anon$5.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$FlatMapped__apply__I__O(this, idx)
});
$c_sc_SeqViewLike$$anon$5.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$FlatMapped__apply__I__O(this, idx)
});
$c_sc_SeqViewLike$$anon$5.prototype.scala$collection$SeqViewLike$FlatMapped$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$2
});
$c_sc_SeqViewLike$$anon$5.prototype.foreach__F1__V = (function(f) {
  $f_sc_TraversableViewLike$FlatMapped__foreach__F1__V(this, f)
});
$c_sc_SeqViewLike$$anon$5.prototype.mapping__F1 = (function() {
  return this.mapping$2
});
$c_sc_SeqViewLike$$anon$5.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_IterableViewLike$FlatMapped__iterator__sc_Iterator(this)
});
$c_sc_SeqViewLike$$anon$5.prototype.viewIdentifier__T = (function() {
  return "N"
});
$c_sc_SeqViewLike$$anon$5.prototype.length__I = (function() {
  return $f_sc_SeqViewLike$FlatMapped__length__I(this)
});
$c_sc_SeqViewLike$$anon$5.prototype.scala$collection$IterableViewLike$FlatMapped$$$outer__sc_IterableViewLike = (function() {
  return this.$$outer$2
});
$c_sc_SeqViewLike$$anon$5.prototype.index$lzycompute__p2__AI = (function() {
  if ((!this.bitmap$0$2)) {
    this.index$2 = $f_sc_SeqViewLike$FlatMapped__index__AI(this);
    this.bitmap$0$2 = true
  };
  return this.index$2
});
$c_sc_SeqViewLike$$anon$5.prototype.scala$collection$TraversableViewLike$FlatMapped$$$outer__sc_TraversableViewLike = (function() {
  return this.$$outer$2
});
$c_sc_SeqViewLike$$anon$5.prototype.init___sc_SeqViewLike__F1 = (function($$outer, f$2) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.mapping$2 = f$2;
  $c_sc_SeqViewLike$AbstractTransformed.prototype.init___sc_SeqViewLike.call(this, $$outer);
  return this
});
$c_sc_SeqViewLike$$anon$5.prototype.index__AI = (function() {
  return ((!this.bitmap$0$2) ? this.index$lzycompute__p2__AI() : this.index$2)
});
var $d_sc_SeqViewLike$$anon$5 = new $TypeData().initClass({
  sc_SeqViewLike$$anon$5: 0
}, false, "scala.collection.SeqViewLike$$anon$5", {
  sc_SeqViewLike$$anon$5: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sc_SeqViewLike$FlatMapped: 1,
  sc_IterableViewLike$FlatMapped: 1,
  sc_TraversableViewLike$FlatMapped: 1
});
$c_sc_SeqViewLike$$anon$5.prototype.$classData = $d_sc_SeqViewLike$$anon$5;
/** @constructor */
function $c_sc_SeqViewLike$$anon$6() {
  $c_sc_SeqViewLike$AbstractTransformed.call(this);
  this.pred$2 = null;
  this.index$2 = null;
  this.bitmap$0$2 = false;
  this.$$outer$2 = null
}
$c_sc_SeqViewLike$$anon$6.prototype = new $h_sc_SeqViewLike$AbstractTransformed();
$c_sc_SeqViewLike$$anon$6.prototype.constructor = $c_sc_SeqViewLike$$anon$6;
/** @constructor */
function $h_sc_SeqViewLike$$anon$6() {
  /*<skip>*/
}
$h_sc_SeqViewLike$$anon$6.prototype = $c_sc_SeqViewLike$$anon$6.prototype;
$c_sc_SeqViewLike$$anon$6.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$Filtered__apply__I__O(this, idx)
});
$c_sc_SeqViewLike$$anon$6.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$Filtered__apply__I__O(this, idx)
});
$c_sc_SeqViewLike$$anon$6.prototype.scala$collection$IterableViewLike$Filtered$$$outer__sc_IterableViewLike = (function() {
  return this.$$outer$2
});
$c_sc_SeqViewLike$$anon$6.prototype.foreach__F1__V = (function(f) {
  $f_sc_TraversableViewLike$Filtered__foreach__F1__V(this, f)
});
$c_sc_SeqViewLike$$anon$6.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_IterableViewLike$Filtered__iterator__sc_Iterator(this)
});
$c_sc_SeqViewLike$$anon$6.prototype.viewIdentifier__T = (function() {
  return "F"
});
$c_sc_SeqViewLike$$anon$6.prototype.length__I = (function() {
  return $f_sc_SeqViewLike$Filtered__length__I(this)
});
$c_sc_SeqViewLike$$anon$6.prototype.index$lzycompute__p2__AI = (function() {
  if ((!this.bitmap$0$2)) {
    this.index$2 = $f_sc_SeqViewLike$Filtered__index__AI(this);
    this.bitmap$0$2 = true
  };
  return this.index$2
});
$c_sc_SeqViewLike$$anon$6.prototype.init___sc_SeqViewLike__F1 = (function($$outer, p$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.pred$2 = p$1;
  $c_sc_SeqViewLike$AbstractTransformed.prototype.init___sc_SeqViewLike.call(this, $$outer);
  return this
});
$c_sc_SeqViewLike$$anon$6.prototype.index__AI = (function() {
  return ((!this.bitmap$0$2) ? this.index$lzycompute__p2__AI() : this.index$2)
});
$c_sc_SeqViewLike$$anon$6.prototype.pred__F1 = (function() {
  return this.pred$2
});
$c_sc_SeqViewLike$$anon$6.prototype.scala$collection$SeqViewLike$Filtered$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$2
});
$c_sc_SeqViewLike$$anon$6.prototype.scala$collection$TraversableViewLike$Filtered$$$outer__sc_TraversableViewLike = (function() {
  return this.$$outer$2
});
var $d_sc_SeqViewLike$$anon$6 = new $TypeData().initClass({
  sc_SeqViewLike$$anon$6: 0
}, false, "scala.collection.SeqViewLike$$anon$6", {
  sc_SeqViewLike$$anon$6: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sc_SeqViewLike$Filtered: 1,
  sc_IterableViewLike$Filtered: 1,
  sc_TraversableViewLike$Filtered: 1
});
$c_sc_SeqViewLike$$anon$6.prototype.$classData = $d_sc_SeqViewLike$$anon$6;
/** @constructor */
function $c_sc_SeqViewLike$$anon$7() {
  $c_sc_SeqViewLike$AbstractTransformed.call(this);
  this.endpoints$2 = null;
  this.$$outer$2 = null
}
$c_sc_SeqViewLike$$anon$7.prototype = new $h_sc_SeqViewLike$AbstractTransformed();
$c_sc_SeqViewLike$$anon$7.prototype.constructor = $c_sc_SeqViewLike$$anon$7;
/** @constructor */
function $h_sc_SeqViewLike$$anon$7() {
  /*<skip>*/
}
$h_sc_SeqViewLike$$anon$7.prototype = $c_sc_SeqViewLike$$anon$7.prototype;
$c_sc_SeqViewLike$$anon$7.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$Sliced__apply__I__O(this, idx)
});
$c_sc_SeqViewLike$$anon$7.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$Sliced__apply__I__O(this, idx)
});
$c_sc_SeqViewLike$$anon$7.prototype.scala$collection$SeqViewLike$Sliced$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$2
});
$c_sc_SeqViewLike$$anon$7.prototype.foreach__F1__V = (function(f) {
  var this$1 = $f_sc_SeqViewLike$Sliced__iterator__sc_Iterator(this);
  $f_sc_Iterator__foreach__F1__V(this$1, f)
});
$c_sc_SeqViewLike$$anon$7.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_SeqViewLike$Sliced__iterator__sc_Iterator(this)
});
$c_sc_SeqViewLike$$anon$7.prototype.viewIdentifier__T = (function() {
  return "S"
});
$c_sc_SeqViewLike$$anon$7.prototype.length__I = (function() {
  var this$1 = $f_sc_SeqViewLike$Sliced__iterator__sc_Iterator(this);
  return $f_sc_TraversableOnce__size__I(this$1)
});
$c_sc_SeqViewLike$$anon$7.prototype.init___sc_SeqViewLike__scg_SliceInterval = (function($$outer, _endpoints$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.endpoints$2 = _endpoints$1;
  $c_sc_SeqViewLike$AbstractTransformed.prototype.init___sc_SeqViewLike.call(this, $$outer);
  return this
});
$c_sc_SeqViewLike$$anon$7.prototype.endpoints__scg_SliceInterval = (function() {
  return this.endpoints$2
});
var $d_sc_SeqViewLike$$anon$7 = new $TypeData().initClass({
  sc_SeqViewLike$$anon$7: 0
}, false, "scala.collection.SeqViewLike$$anon$7", {
  sc_SeqViewLike$$anon$7: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sc_SeqViewLike$Sliced: 1,
  sc_IterableViewLike$Sliced: 1,
  sc_TraversableViewLike$Sliced: 1
});
$c_sc_SeqViewLike$$anon$7.prototype.$classData = $d_sc_SeqViewLike$$anon$7;
/** @constructor */
function $c_sc_SeqViewLike$$anon$8() {
  $c_sc_SeqViewLike$AbstractTransformed.call(this);
  this.pred$2 = null;
  this.start$2 = 0;
  this.bitmap$0$2 = false;
  this.$$outer$2 = null
}
$c_sc_SeqViewLike$$anon$8.prototype = new $h_sc_SeqViewLike$AbstractTransformed();
$c_sc_SeqViewLike$$anon$8.prototype.constructor = $c_sc_SeqViewLike$$anon$8;
/** @constructor */
function $h_sc_SeqViewLike$$anon$8() {
  /*<skip>*/
}
$h_sc_SeqViewLike$$anon$8.prototype = $c_sc_SeqViewLike$$anon$8.prototype;
$c_sc_SeqViewLike$$anon$8.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$DroppedWhile__apply__I__O(this, idx)
});
$c_sc_SeqViewLike$$anon$8.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$DroppedWhile__apply__I__O(this, idx)
});
$c_sc_SeqViewLike$$anon$8.prototype.scala$collection$SeqViewLike$DroppedWhile$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$2
});
$c_sc_SeqViewLike$$anon$8.prototype.foreach__F1__V = (function(f) {
  $f_sc_TraversableViewLike$DroppedWhile__foreach__F1__V(this, f)
});
$c_sc_SeqViewLike$$anon$8.prototype.scala$collection$IterableViewLike$DroppedWhile$$$outer__sc_IterableViewLike = (function() {
  return this.$$outer$2
});
$c_sc_SeqViewLike$$anon$8.prototype.start$lzycompute__p2__I = (function() {
  if ((!this.bitmap$0$2)) {
    var this$1 = this.$$outer$2;
    var p = this.pred$2;
    this.start$2 = this$1.segmentLength__F1__I__I(p, 0);
    this.bitmap$0$2 = true
  };
  return this.start$2
});
$c_sc_SeqViewLike$$anon$8.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_IterableViewLike$DroppedWhile__iterator__sc_Iterator(this)
});
$c_sc_SeqViewLike$$anon$8.prototype.viewIdentifier__T = (function() {
  return "D"
});
$c_sc_SeqViewLike$$anon$8.prototype.length__I = (function() {
  return $f_sc_SeqViewLike$DroppedWhile__length__I(this)
});
$c_sc_SeqViewLike$$anon$8.prototype.scala$collection$TraversableViewLike$DroppedWhile$$$outer__sc_TraversableViewLike = (function() {
  return this.$$outer$2
});
$c_sc_SeqViewLike$$anon$8.prototype.start__I = (function() {
  return ((!this.bitmap$0$2) ? this.start$lzycompute__p2__I() : this.start$2)
});
$c_sc_SeqViewLike$$anon$8.prototype.init___sc_SeqViewLike__F1 = (function($$outer, p$2) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.pred$2 = p$2;
  $c_sc_SeqViewLike$AbstractTransformed.prototype.init___sc_SeqViewLike.call(this, $$outer);
  return this
});
$c_sc_SeqViewLike$$anon$8.prototype.pred__F1 = (function() {
  return this.pred$2
});
var $d_sc_SeqViewLike$$anon$8 = new $TypeData().initClass({
  sc_SeqViewLike$$anon$8: 0
}, false, "scala.collection.SeqViewLike$$anon$8", {
  sc_SeqViewLike$$anon$8: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sc_SeqViewLike$DroppedWhile: 1,
  sc_IterableViewLike$DroppedWhile: 1,
  sc_TraversableViewLike$DroppedWhile: 1
});
$c_sc_SeqViewLike$$anon$8.prototype.$classData = $d_sc_SeqViewLike$$anon$8;
/** @constructor */
function $c_sc_SeqViewLike$$anon$9() {
  $c_sc_SeqViewLike$AbstractTransformed.call(this);
  this.pred$2 = null;
  this.len$2 = 0;
  this.bitmap$0$2 = false;
  this.$$outer$2 = null
}
$c_sc_SeqViewLike$$anon$9.prototype = new $h_sc_SeqViewLike$AbstractTransformed();
$c_sc_SeqViewLike$$anon$9.prototype.constructor = $c_sc_SeqViewLike$$anon$9;
/** @constructor */
function $h_sc_SeqViewLike$$anon$9() {
  /*<skip>*/
}
$h_sc_SeqViewLike$$anon$9.prototype = $c_sc_SeqViewLike$$anon$9.prototype;
$c_sc_SeqViewLike$$anon$9.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$TakenWhile__apply__I__O(this, idx)
});
$c_sc_SeqViewLike$$anon$9.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$TakenWhile__apply__I__O(this, idx)
});
$c_sc_SeqViewLike$$anon$9.prototype.scala$collection$IterableViewLike$TakenWhile$$$outer__sc_IterableViewLike = (function() {
  return this.$$outer$2
});
$c_sc_SeqViewLike$$anon$9.prototype.len__I = (function() {
  return ((!this.bitmap$0$2) ? this.len$lzycompute__p2__I() : this.len$2)
});
$c_sc_SeqViewLike$$anon$9.prototype.foreach__F1__V = (function(f) {
  $f_sc_TraversableViewLike$TakenWhile__foreach__F1__V(this, f)
});
$c_sc_SeqViewLike$$anon$9.prototype.len$lzycompute__p2__I = (function() {
  if ((!this.bitmap$0$2)) {
    var this$1 = this.$$outer$2;
    var p = this.pred$2;
    this.len$2 = this$1.segmentLength__F1__I__I(p, 0);
    this.bitmap$0$2 = true
  };
  return this.len$2
});
$c_sc_SeqViewLike$$anon$9.prototype.scala$collection$TraversableViewLike$TakenWhile$$$outer__sc_TraversableViewLike = (function() {
  return this.$$outer$2
});
$c_sc_SeqViewLike$$anon$9.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_IterableViewLike$TakenWhile__iterator__sc_Iterator(this)
});
$c_sc_SeqViewLike$$anon$9.prototype.viewIdentifier__T = (function() {
  return "T"
});
$c_sc_SeqViewLike$$anon$9.prototype.length__I = (function() {
  return this.len__I()
});
$c_sc_SeqViewLike$$anon$9.prototype.scala$collection$SeqViewLike$TakenWhile$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$2
});
$c_sc_SeqViewLike$$anon$9.prototype.init___sc_SeqViewLike__F1 = (function($$outer, p$3) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$2 = $$outer
  };
  this.pred$2 = p$3;
  $c_sc_SeqViewLike$AbstractTransformed.prototype.init___sc_SeqViewLike.call(this, $$outer);
  return this
});
$c_sc_SeqViewLike$$anon$9.prototype.pred__F1 = (function() {
  return this.pred$2
});
var $d_sc_SeqViewLike$$anon$9 = new $TypeData().initClass({
  sc_SeqViewLike$$anon$9: 0
}, false, "scala.collection.SeqViewLike$$anon$9", {
  sc_SeqViewLike$$anon$9: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sc_SeqViewLike$TakenWhile: 1,
  sc_IterableViewLike$TakenWhile: 1,
  sc_TraversableViewLike$TakenWhile: 1
});
$c_sc_SeqViewLike$$anon$9.prototype.$classData = $d_sc_SeqViewLike$$anon$9;
/** @constructor */
function $c_sci_HashMap$EmptyHashMap$() {
  $c_sci_HashMap.call(this)
}
$c_sci_HashMap$EmptyHashMap$.prototype = new $h_sci_HashMap();
$c_sci_HashMap$EmptyHashMap$.prototype.constructor = $c_sci_HashMap$EmptyHashMap$;
/** @constructor */
function $h_sci_HashMap$EmptyHashMap$() {
  /*<skip>*/
}
$h_sci_HashMap$EmptyHashMap$.prototype = $c_sci_HashMap$EmptyHashMap$.prototype;
$c_sci_HashMap$EmptyHashMap$.prototype.init___ = (function() {
  return this
});
$c_sci_HashMap$EmptyHashMap$.prototype.head__O = (function() {
  return this.head__T2()
});
$c_sci_HashMap$EmptyHashMap$.prototype.head__T2 = (function() {
  throw new $c_ju_NoSuchElementException().init___T("Empty Map")
});
$c_sci_HashMap$EmptyHashMap$.prototype.tail__sci_HashMap = (function() {
  throw new $c_ju_NoSuchElementException().init___T("Empty Map")
});
$c_sci_HashMap$EmptyHashMap$.prototype.tail__O = (function() {
  return this.tail__sci_HashMap()
});
var $d_sci_HashMap$EmptyHashMap$ = new $TypeData().initClass({
  sci_HashMap$EmptyHashMap$: 0
}, false, "scala.collection.immutable.HashMap$EmptyHashMap$", {
  sci_HashMap$EmptyHashMap$: 1,
  sci_HashMap: 1,
  sci_AbstractMap: 1,
  sc_AbstractMap: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Map: 1,
  sc_GenMap: 1,
  sc_GenMapLike: 1,
  sc_MapLike: 1,
  s_PartialFunction: 1,
  F1: 1,
  scg_Subtractable: 1,
  sci_Map: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sci_MapLike: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  sc_CustomParallelizable: 1
});
$c_sci_HashMap$EmptyHashMap$.prototype.$classData = $d_sci_HashMap$EmptyHashMap$;
var $n_sci_HashMap$EmptyHashMap$ = (void 0);
function $m_sci_HashMap$EmptyHashMap$() {
  if ((!$n_sci_HashMap$EmptyHashMap$)) {
    $n_sci_HashMap$EmptyHashMap$ = new $c_sci_HashMap$EmptyHashMap$().init___()
  };
  return $n_sci_HashMap$EmptyHashMap$
}
/** @constructor */
function $c_sci_HashMap$HashMap1() {
  $c_sci_HashMap.call(this);
  this.key$6 = null;
  this.hash$6 = 0;
  this.value$6 = null;
  this.kv$6 = null
}
$c_sci_HashMap$HashMap1.prototype = new $h_sci_HashMap();
$c_sci_HashMap$HashMap1.prototype.constructor = $c_sci_HashMap$HashMap1;
/** @constructor */
function $h_sci_HashMap$HashMap1() {
  /*<skip>*/
}
$h_sci_HashMap$HashMap1.prototype = $c_sci_HashMap$HashMap1.prototype;
$c_sci_HashMap$HashMap1.prototype.ensurePair__T2 = (function() {
  if ((this.kv$6 !== null)) {
    return this.kv$6
  } else {
    this.kv$6 = new $c_T2().init___O__O(this.key$6, this.value$6);
    return this.kv$6
  }
});
$c_sci_HashMap$HashMap1.prototype.init___O__I__O__T2 = (function(key, hash, value, kv) {
  this.key$6 = key;
  this.hash$6 = hash;
  this.value$6 = value;
  this.kv$6 = kv;
  return this
});
$c_sci_HashMap$HashMap1.prototype.updated0__O__I__I__O__T2__sci_HashMap$Merger__sci_HashMap = (function(key, hash, level, value, kv, merger) {
  if (((hash === this.hash$6) && $m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key$6))) {
    if ((merger === null)) {
      return ((this.value$6 === value) ? this : new $c_sci_HashMap$HashMap1().init___O__I__O__T2(key, hash, value, kv))
    } else {
      var nkv = merger.apply__T2__T2__T2(this.ensurePair__T2(), ((kv !== null) ? kv : new $c_T2().init___O__O(key, value)));
      return new $c_sci_HashMap$HashMap1().init___O__I__O__T2(nkv.$$und1__O(), hash, nkv.$$und2__O(), nkv)
    }
  } else if ((hash !== this.hash$6)) {
    var that = new $c_sci_HashMap$HashMap1().init___O__I__O__T2(key, hash, value, kv);
    return $m_sci_HashMap$().scala$collection$immutable$HashMap$$makeHashTrieMap__I__sci_HashMap__I__sci_HashMap__I__I__sci_HashMap$HashTrieMap(this.hash$6, this, hash, that, level, 2)
  } else {
    var this$2 = $m_sci_ListMap$EmptyListMap$();
    var key$1 = this.key$6;
    var value$1 = this.value$6;
    return new $c_sci_HashMap$HashMapCollision1().init___I__sci_ListMap(hash, new $c_sci_ListMap$Node().init___sci_ListMap__O__O(this$2, key$1, value$1).updated__O__O__sci_ListMap(key, value))
  }
});
$c_sci_HashMap$HashMap1.prototype.get0__O__I__I__s_Option = (function(key, hash, level) {
  return (((hash === this.hash$6) && $m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key$6)) ? new $c_s_Some().init___O(this.value$6) : $m_s_None$())
});
$c_sci_HashMap$HashMap1.prototype.foreach__F1__V = (function(f) {
  f.apply__O__O(this.ensurePair__T2())
});
$c_sci_HashMap$HashMap1.prototype.removed0__O__I__I__sci_HashMap = (function(key, hash, level) {
  return (((hash === this.hash$6) && $m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key$6)) ? ($m_sci_HashMap$(), $m_sci_HashMap$EmptyHashMap$()) : this)
});
$c_sci_HashMap$HashMap1.prototype.filter0__F1__Z__I__Asci_HashMap__I__sci_HashMap = (function(p, negate, level, buffer, offset0) {
  return ((negate !== $uZ(p.apply__O__O(this.ensurePair__T2()))) ? this : null)
});
$c_sci_HashMap$HashMap1.prototype.size__I = (function() {
  return 1
});
$c_sci_HashMap$HashMap1.prototype.iterator__sc_Iterator = (function() {
  $m_sc_Iterator$();
  var array = [this.ensurePair__T2()];
  var elems = new $c_sjs_js_WrappedArray().init___sjs_js_Array(array);
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(elems, 0, $uI(elems.array$6.length))
});
$c_sci_HashMap$HashMap1.prototype.contains0__O__I__I__Z = (function(key, hash, level) {
  return ((hash === this.hash$6) && $m_sr_BoxesRunTime$().equals__O__O__Z(key, this.key$6))
});
function $as_sci_HashMap$HashMap1(obj) {
  return (((obj instanceof $c_sci_HashMap$HashMap1) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.HashMap$HashMap1"))
}
function $isArrayOf_sci_HashMap$HashMap1(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_HashMap$HashMap1)))
}
function $asArrayOf_sci_HashMap$HashMap1(obj, depth) {
  return (($isArrayOf_sci_HashMap$HashMap1(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.HashMap$HashMap1;", depth))
}
var $d_sci_HashMap$HashMap1 = new $TypeData().initClass({
  sci_HashMap$HashMap1: 0
}, false, "scala.collection.immutable.HashMap$HashMap1", {
  sci_HashMap$HashMap1: 1,
  sci_HashMap: 1,
  sci_AbstractMap: 1,
  sc_AbstractMap: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Map: 1,
  sc_GenMap: 1,
  sc_GenMapLike: 1,
  sc_MapLike: 1,
  s_PartialFunction: 1,
  F1: 1,
  scg_Subtractable: 1,
  sci_Map: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sci_MapLike: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  sc_CustomParallelizable: 1
});
$c_sci_HashMap$HashMap1.prototype.$classData = $d_sci_HashMap$HashMap1;
/** @constructor */
function $c_sci_HashMap$HashMapCollision1() {
  $c_sci_HashMap.call(this);
  this.hash$6 = 0;
  this.kvs$6 = null
}
$c_sci_HashMap$HashMapCollision1.prototype = new $h_sci_HashMap();
$c_sci_HashMap$HashMapCollision1.prototype.constructor = $c_sci_HashMap$HashMapCollision1;
/** @constructor */
function $h_sci_HashMap$HashMapCollision1() {
  /*<skip>*/
}
$h_sci_HashMap$HashMapCollision1.prototype = $c_sci_HashMap$HashMapCollision1.prototype;
$c_sci_HashMap$HashMapCollision1.prototype.updated0__O__I__I__O__T2__sci_HashMap$Merger__sci_HashMap = (function(key, hash, level, value, kv, merger) {
  if ((hash === this.hash$6)) {
    return (((merger === null) || (!this.kvs$6.contains__O__Z(key))) ? new $c_sci_HashMap$HashMapCollision1().init___I__sci_ListMap(hash, this.kvs$6.updated__O__O__sci_ListMap(key, value)) : new $c_sci_HashMap$HashMapCollision1().init___I__sci_ListMap(hash, this.kvs$6.$$plus__T2__sci_ListMap(merger.apply__T2__T2__T2(new $c_T2().init___O__O(key, this.kvs$6.apply__O__O(key)), kv))))
  } else {
    var that = new $c_sci_HashMap$HashMap1().init___O__I__O__T2(key, hash, value, kv);
    return $m_sci_HashMap$().scala$collection$immutable$HashMap$$makeHashTrieMap__I__sci_HashMap__I__sci_HashMap__I__I__sci_HashMap$HashTrieMap(this.hash$6, this, hash, that, level, ((1 + this.kvs$6.size__I()) | 0))
  }
});
$c_sci_HashMap$HashMapCollision1.prototype.get0__O__I__I__s_Option = (function(key, hash, level) {
  return ((hash === this.hash$6) ? this.kvs$6.get__O__s_Option(key) : $m_s_None$())
});
$c_sci_HashMap$HashMapCollision1.prototype.foreach__F1__V = (function(f) {
  var this$1 = this.kvs$6;
  var this$2 = this$1.reverseList$1__p5__sci_List();
  var this$3 = new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$2);
  $f_sc_Iterator__foreach__F1__V(this$3, f)
});
$c_sci_HashMap$HashMapCollision1.prototype.removed0__O__I__I__sci_HashMap = (function(key, hash, level) {
  if ((hash === this.hash$6)) {
    var kvs1 = this.kvs$6.$$minus__O__sci_ListMap(key);
    var x1 = kvs1.size__I();
    switch (x1) {
      case 0: {
        $m_sci_HashMap$();
        return $m_sci_HashMap$EmptyHashMap$();
        break
      }
      case 1: {
        var this$2 = kvs1.reverseList$1__p5__sci_List();
        var kv = $as_T2(new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$2).next__O());
        return new $c_sci_HashMap$HashMap1().init___O__I__O__T2(kv.$$und1__O(), hash, kv.$$und2__O(), kv);
        break
      }
      default: {
        return ((x1 === this.kvs$6.size__I()) ? this : new $c_sci_HashMap$HashMapCollision1().init___I__sci_ListMap(hash, kvs1))
      }
    }
  } else {
    return this
  }
});
$c_sci_HashMap$HashMapCollision1.prototype.filter0__F1__Z__I__Asci_HashMap__I__sci_HashMap = (function(p, negate, level, buffer, offset0) {
  if (negate) {
    var this$1 = this.kvs$6;
    var kvs1 = $as_sci_ListMap($f_sc_MapLike__filterNot__F1__sc_Map(this$1, p))
  } else {
    var this$2 = this.kvs$6;
    var kvs1 = $as_sci_ListMap($f_sc_TraversableLike__filterImpl__F1__Z__O(this$2, p, false))
  };
  var x1 = kvs1.size__I();
  switch (x1) {
    case 0: {
      return null;
      break
    }
    case 1: {
      var this$3 = kvs1.reverseList$1__p5__sci_List();
      var x1$2 = $as_T2(new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$3).next__O());
      if ((x1$2 === null)) {
        throw new $c_s_MatchError().init___O(x1$2)
      };
      var k = x1$2.$$und1__O();
      var v = x1$2.$$und2__O();
      return new $c_sci_HashMap$HashMap1().init___O__I__O__T2(k, this.hash$6, v, x1$2);
      break
    }
    default: {
      return ((x1 === this.kvs$6.size__I()) ? this : new $c_sci_HashMap$HashMapCollision1().init___I__sci_ListMap(this.hash$6, kvs1))
    }
  }
});
$c_sci_HashMap$HashMapCollision1.prototype.iterator__sc_Iterator = (function() {
  var this$1 = this.kvs$6;
  var this$2 = this$1.reverseList$1__p5__sci_List();
  return new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$2)
});
$c_sci_HashMap$HashMapCollision1.prototype.size__I = (function() {
  return this.kvs$6.size__I()
});
$c_sci_HashMap$HashMapCollision1.prototype.init___I__sci_ListMap = (function(hash, kvs) {
  this.hash$6 = hash;
  this.kvs$6 = kvs;
  return this
});
$c_sci_HashMap$HashMapCollision1.prototype.contains0__O__I__I__Z = (function(key, hash, level) {
  return ((hash === this.hash$6) && this.kvs$6.contains__O__Z(key))
});
var $d_sci_HashMap$HashMapCollision1 = new $TypeData().initClass({
  sci_HashMap$HashMapCollision1: 0
}, false, "scala.collection.immutable.HashMap$HashMapCollision1", {
  sci_HashMap$HashMapCollision1: 1,
  sci_HashMap: 1,
  sci_AbstractMap: 1,
  sc_AbstractMap: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Map: 1,
  sc_GenMap: 1,
  sc_GenMapLike: 1,
  sc_MapLike: 1,
  s_PartialFunction: 1,
  F1: 1,
  scg_Subtractable: 1,
  sci_Map: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sci_MapLike: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  sc_CustomParallelizable: 1
});
$c_sci_HashMap$HashMapCollision1.prototype.$classData = $d_sci_HashMap$HashMapCollision1;
/** @constructor */
function $c_sci_HashMap$HashTrieMap() {
  $c_sci_HashMap.call(this);
  this.bitmap$6 = 0;
  this.elems$6 = null;
  this.size0$6 = 0
}
$c_sci_HashMap$HashTrieMap.prototype = new $h_sci_HashMap();
$c_sci_HashMap$HashTrieMap.prototype.constructor = $c_sci_HashMap$HashTrieMap;
/** @constructor */
function $h_sci_HashMap$HashTrieMap() {
  /*<skip>*/
}
$h_sci_HashMap$HashTrieMap.prototype = $c_sci_HashMap$HashTrieMap.prototype;
$c_sci_HashMap$HashTrieMap.prototype.updated0__O__I__I__O__T2__sci_HashMap$Merger__sci_HashMap = (function(key, hash, level, value, kv, merger) {
  var index = (31 & ((hash >>> level) | 0));
  var mask = (1 << index);
  var offset = $m_jl_Integer$().bitCount__I__I((this.bitmap$6 & (((-1) + mask) | 0)));
  if (((this.bitmap$6 & mask) !== 0)) {
    var sub = this.elems$6.get(offset);
    var subNew = sub.updated0__O__I__I__O__T2__sci_HashMap$Merger__sci_HashMap(key, hash, ((5 + level) | 0), value, kv, merger);
    if ((subNew === sub)) {
      return this
    } else {
      var elemsNew = $newArrayObject($d_sci_HashMap.getArrayOf(), [this.elems$6.u.length]);
      $m_s_Array$().copy__O__I__O__I__I__V(this.elems$6, 0, elemsNew, 0, this.elems$6.u.length);
      elemsNew.set(offset, subNew);
      return new $c_sci_HashMap$HashTrieMap().init___I__Asci_HashMap__I(this.bitmap$6, elemsNew, ((this.size0$6 + ((subNew.size__I() - sub.size__I()) | 0)) | 0))
    }
  } else {
    var elemsNew$2 = $newArrayObject($d_sci_HashMap.getArrayOf(), [((1 + this.elems$6.u.length) | 0)]);
    $m_s_Array$().copy__O__I__O__I__I__V(this.elems$6, 0, elemsNew$2, 0, offset);
    elemsNew$2.set(offset, new $c_sci_HashMap$HashMap1().init___O__I__O__T2(key, hash, value, kv));
    $m_s_Array$().copy__O__I__O__I__I__V(this.elems$6, offset, elemsNew$2, ((1 + offset) | 0), ((this.elems$6.u.length - offset) | 0));
    return new $c_sci_HashMap$HashTrieMap().init___I__Asci_HashMap__I((this.bitmap$6 | mask), elemsNew$2, ((1 + this.size0$6) | 0))
  }
});
$c_sci_HashMap$HashTrieMap.prototype.get0__O__I__I__s_Option = (function(key, hash, level) {
  var index = (31 & ((hash >>> level) | 0));
  if ((this.bitmap$6 === (-1))) {
    return this.elems$6.get(index).get0__O__I__I__s_Option(key, hash, ((5 + level) | 0))
  } else {
    var mask = (1 << index);
    if (((this.bitmap$6 & mask) !== 0)) {
      var offset = $m_jl_Integer$().bitCount__I__I((this.bitmap$6 & (((-1) + mask) | 0)));
      return this.elems$6.get(offset).get0__O__I__I__s_Option(key, hash, ((5 + level) | 0))
    } else {
      return $m_s_None$()
    }
  }
});
$c_sci_HashMap$HashTrieMap.prototype.foreach__F1__V = (function(f) {
  var i = 0;
  while ((i < this.elems$6.u.length)) {
    this.elems$6.get(i).foreach__F1__V(f);
    i = ((1 + i) | 0)
  }
});
$c_sci_HashMap$HashTrieMap.prototype.removed0__O__I__I__sci_HashMap = (function(key, hash, level) {
  var index = (31 & ((hash >>> level) | 0));
  var mask = (1 << index);
  var offset = $m_jl_Integer$().bitCount__I__I((this.bitmap$6 & (((-1) + mask) | 0)));
  if (((this.bitmap$6 & mask) !== 0)) {
    var sub = this.elems$6.get(offset);
    var subNew = sub.removed0__O__I__I__sci_HashMap(key, hash, ((5 + level) | 0));
    if ((subNew === sub)) {
      return this
    } else if ($f_sc_MapLike__isEmpty__Z(subNew)) {
      var bitmapNew = (this.bitmap$6 ^ mask);
      if ((bitmapNew !== 0)) {
        var elemsNew = $newArrayObject($d_sci_HashMap.getArrayOf(), [(((-1) + this.elems$6.u.length) | 0)]);
        $m_s_Array$().copy__O__I__O__I__I__V(this.elems$6, 0, elemsNew, 0, offset);
        $m_s_Array$().copy__O__I__O__I__I__V(this.elems$6, ((1 + offset) | 0), elemsNew, offset, (((-1) + ((this.elems$6.u.length - offset) | 0)) | 0));
        var sizeNew = ((this.size0$6 - sub.size__I()) | 0);
        return (((elemsNew.u.length === 1) && (!(elemsNew.get(0) instanceof $c_sci_HashMap$HashTrieMap))) ? elemsNew.get(0) : new $c_sci_HashMap$HashTrieMap().init___I__Asci_HashMap__I(bitmapNew, elemsNew, sizeNew))
      } else {
        $m_sci_HashMap$();
        return $m_sci_HashMap$EmptyHashMap$()
      }
    } else if (((this.elems$6.u.length === 1) && (!(subNew instanceof $c_sci_HashMap$HashTrieMap)))) {
      return subNew
    } else {
      var elemsNew$2 = $newArrayObject($d_sci_HashMap.getArrayOf(), [this.elems$6.u.length]);
      $m_s_Array$().copy__O__I__O__I__I__V(this.elems$6, 0, elemsNew$2, 0, this.elems$6.u.length);
      elemsNew$2.set(offset, subNew);
      var sizeNew$2 = ((this.size0$6 + ((subNew.size__I() - sub.size__I()) | 0)) | 0);
      return new $c_sci_HashMap$HashTrieMap().init___I__Asci_HashMap__I(this.bitmap$6, elemsNew$2, sizeNew$2)
    }
  } else {
    return this
  }
});
$c_sci_HashMap$HashTrieMap.prototype.filter0__F1__Z__I__Asci_HashMap__I__sci_HashMap = (function(p, negate, level, buffer, offset0) {
  var offset = offset0;
  var rs = 0;
  var kept = 0;
  var i = 0;
  while ((i < this.elems$6.u.length)) {
    var result = this.elems$6.get(i).filter0__F1__Z__I__Asci_HashMap__I__sci_HashMap(p, negate, ((5 + level) | 0), buffer, offset);
    if ((result !== null)) {
      buffer.set(offset, result);
      offset = ((1 + offset) | 0);
      rs = ((rs + result.size__I()) | 0);
      kept = (kept | (1 << i))
    };
    i = ((1 + i) | 0)
  };
  if ((offset === offset0)) {
    return null
  } else if ((rs === this.size0$6)) {
    return this
  } else if (((offset === ((1 + offset0) | 0)) && (!(buffer.get(offset0) instanceof $c_sci_HashMap$HashTrieMap)))) {
    return buffer.get(offset0)
  } else {
    var length = ((offset - offset0) | 0);
    var elems1 = $newArrayObject($d_sci_HashMap.getArrayOf(), [length]);
    $systemArraycopy(buffer, offset0, elems1, 0, length);
    var bitmap1 = ((length === this.elems$6.u.length) ? this.bitmap$6 : $m_sci_HashMap$().scala$collection$immutable$HashMap$$keepBits__I__I__I(this.bitmap$6, kept));
    return new $c_sci_HashMap$HashTrieMap().init___I__Asci_HashMap__I(bitmap1, elems1, rs)
  }
});
$c_sci_HashMap$HashTrieMap.prototype.iterator__sc_Iterator = (function() {
  return new $c_sci_HashMap$HashTrieMap$$anon$3().init___sci_HashMap$HashTrieMap(this)
});
$c_sci_HashMap$HashTrieMap.prototype.size__I = (function() {
  return this.size0$6
});
$c_sci_HashMap$HashTrieMap.prototype.init___I__Asci_HashMap__I = (function(bitmap, elems, size0) {
  this.bitmap$6 = bitmap;
  this.elems$6 = elems;
  this.size0$6 = size0;
  return this
});
$c_sci_HashMap$HashTrieMap.prototype.contains0__O__I__I__Z = (function(key, hash, level) {
  var index = (31 & ((hash >>> level) | 0));
  if ((this.bitmap$6 === (-1))) {
    return this.elems$6.get(index).contains0__O__I__I__Z(key, hash, ((5 + level) | 0))
  } else {
    var mask = (1 << index);
    if (((this.bitmap$6 & mask) !== 0)) {
      var offset = $m_jl_Integer$().bitCount__I__I((this.bitmap$6 & (((-1) + mask) | 0)));
      return this.elems$6.get(offset).contains0__O__I__I__Z(key, hash, ((5 + level) | 0))
    } else {
      return false
    }
  }
});
function $as_sci_HashMap$HashTrieMap(obj) {
  return (((obj instanceof $c_sci_HashMap$HashTrieMap) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.HashMap$HashTrieMap"))
}
function $isArrayOf_sci_HashMap$HashTrieMap(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_HashMap$HashTrieMap)))
}
function $asArrayOf_sci_HashMap$HashTrieMap(obj, depth) {
  return (($isArrayOf_sci_HashMap$HashTrieMap(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.HashMap$HashTrieMap;", depth))
}
var $d_sci_HashMap$HashTrieMap = new $TypeData().initClass({
  sci_HashMap$HashTrieMap: 0
}, false, "scala.collection.immutable.HashMap$HashTrieMap", {
  sci_HashMap$HashTrieMap: 1,
  sci_HashMap: 1,
  sci_AbstractMap: 1,
  sc_AbstractMap: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Map: 1,
  sc_GenMap: 1,
  sc_GenMapLike: 1,
  sc_MapLike: 1,
  s_PartialFunction: 1,
  F1: 1,
  scg_Subtractable: 1,
  sci_Map: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sci_MapLike: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  sc_CustomParallelizable: 1
});
$c_sci_HashMap$HashTrieMap.prototype.$classData = $d_sci_HashMap$HashTrieMap;
/** @constructor */
function $c_sci_List() {
  $c_sc_AbstractSeq.call(this)
}
$c_sci_List.prototype = new $h_sc_AbstractSeq();
$c_sci_List.prototype.constructor = $c_sci_List;
/** @constructor */
function $h_sci_List() {
  /*<skip>*/
}
$h_sci_List.prototype = $c_sci_List.prototype;
$c_sci_List.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sci_List.prototype.takeRight__I__sci_List = (function(n) {
  return this.loop$2__p4__sci_List__sci_List__sci_List(this.drop__I__sci_List(n), this)
});
$c_sci_List.prototype.apply__I__O = (function(n) {
  return $f_sc_LinearSeqOptimized__apply__I__O(this, n)
});
$c_sci_List.prototype.thisCollection__sc_Iterable = (function() {
  return this
});
$c_sci_List.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_LinearSeqOptimized__lengthCompare__I__I(this, len)
});
$c_sci_List.prototype.apply__O__O = (function(v1) {
  var n = $uI(v1);
  return $f_sc_LinearSeqOptimized__apply__I__O(this, n)
});
$c_sci_List.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_LinearSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_sci_List.prototype.exists__F1__Z = (function(p) {
  return $f_sc_LinearSeqOptimized__exists__F1__Z(this, p)
});
$c_sci_List.prototype.toList__sci_List = (function() {
  return this
});
$c_sci_List.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sci_List.prototype.loop$2__p4__sci_List__sci_List__sci_List = (function(lead, lag) {
  _loop: while (true) {
    var x1 = lead;
    var x$2 = $m_sci_Nil$();
    if (x$2.equals__O__Z(x1)) {
      return lag
    } else if ((x1 instanceof $c_sci_$colon$colon)) {
      var x2 = $as_sci_$colon$colon(x1);
      var tail = x2.tl$5;
      var temp$lag = $as_sci_List(lag.tail__O());
      lead = tail;
      lag = temp$lag;
      continue _loop
    } else {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_sci_List.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_List.prototype.flatMap__F1__scg_CanBuildFrom__O = (function(f, bf) {
  if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
    if ((this === $m_sci_Nil$())) {
      return $m_sci_Nil$()
    } else {
      var rest = this;
      var found = new $c_sr_BooleanRef().init___Z(false);
      var h = new $c_sr_ObjectRef().init___O(null);
      var t = new $c_sr_ObjectRef().init___O(null);
      while ((rest !== $m_sci_Nil$())) {
        $as_sc_GenTraversableOnce(f.apply__O__O(rest.head__O())).seq__sc_TraversableOnce().foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, found$1, h$1, t$1) {
          return (function(b$2) {
            if ((!found$1.elem$1)) {
              h$1.elem$1 = new $c_sci_$colon$colon().init___O__sci_List(b$2, $m_sci_Nil$());
              t$1.elem$1 = $as_sci_$colon$colon(h$1.elem$1);
              found$1.elem$1 = true
            } else {
              var nx = new $c_sci_$colon$colon().init___O__sci_List(b$2, $m_sci_Nil$());
              $as_sci_$colon$colon(t$1.elem$1).tl$5 = nx;
              t$1.elem$1 = nx
            }
          })
        })(this, found, h, t)));
        rest = $as_sci_List(rest.tail__O())
      };
      return ((!found.elem$1) ? $m_sci_Nil$() : $as_sci_$colon$colon(h.elem$1))
    }
  } else {
    return $f_sc_TraversableLike__flatMap__F1__scg_CanBuildFrom__O(this, f, bf)
  }
});
$c_sci_List.prototype.drop__I__sc_LinearSeqOptimized = (function(n) {
  return this.drop__I__sci_List(n)
});
$c_sci_List.prototype.dropWhile__F1__O = (function(p) {
  return this.loop$3__p4__sci_List__F1__sci_List(this, p)
});
$c_sci_List.prototype.take__I__sci_List = (function(n) {
  if ((this.isEmpty__Z() || (n <= 0))) {
    return $m_sci_Nil$()
  } else {
    var h = new $c_sci_$colon$colon().init___O__sci_List(this.head__O(), $m_sci_Nil$());
    var t = h;
    var rest = $as_sci_List(this.tail__O());
    var i = 1;
    while (true) {
      if (rest.isEmpty__Z()) {
        return this
      };
      if ((i < n)) {
        i = ((1 + i) | 0);
        var nx = new $c_sci_$colon$colon().init___O__sci_List(rest.head__O(), $m_sci_Nil$());
        t.tl$5 = nx;
        t = nx;
        rest = $as_sci_List(rest.tail__O())
      } else {
        break
      }
    };
    return h
  }
});
$c_sci_List.prototype.forall__F1__Z = (function(p) {
  return $f_sc_LinearSeqOptimized__forall__F1__Z(this, p)
});
$c_sci_List.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sci_List$()
});
$c_sci_List.prototype.foreach__F1__V = (function(f) {
  var these = this;
  while ((!these.isEmpty__Z())) {
    f.apply__O__O(these.head__O());
    these = $as_sci_List(these.tail__O())
  }
});
$c_sci_List.prototype.foldLeft__O__F2__O = (function(z, op) {
  return $f_sc_LinearSeqOptimized__foldLeft__O__F2__O(this, z, op)
});
$c_sci_List.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_LinearSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_sci_List.prototype.takeWhile__F1__O = (function(p) {
  var b = new $c_scm_ListBuffer().init___();
  var these = this;
  while (((!these.isEmpty__Z()) && $uZ(p.apply__O__O(these.head__O())))) {
    b.$$plus$eq__O__scm_ListBuffer(these.head__O());
    these = $as_sci_List(these.tail__O())
  };
  return b.toList__sci_List()
});
$c_sci_List.prototype.$$colon$colon$colon__sci_List__sci_List = (function(prefix) {
  return (this.isEmpty__Z() ? prefix : (prefix.isEmpty__Z() ? this : new $c_scm_ListBuffer().init___().$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(prefix).prependToList__sci_List__sci_List(this)))
});
$c_sci_List.prototype.reverse__O = (function() {
  return this.reverse__sci_List()
});
$c_sci_List.prototype.$$plus$colon__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return ((bf instanceof $c_scg_GenTraversableFactory$GenericCanBuildFrom) ? new $c_sci_$colon$colon().init___O__sci_List(elem, this) : $f_sc_SeqLike__$$plus$colon__O__scg_CanBuildFrom__O(this, elem, bf))
});
$c_sci_List.prototype.iterator__sc_Iterator = (function() {
  return new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this)
});
$c_sci_List.prototype.drop__I__sci_List = (function(n) {
  var these = this;
  var count = n;
  while (((!these.isEmpty__Z()) && (count > 0))) {
    these = $as_sci_List(these.tail__O());
    count = (((-1) + count) | 0)
  };
  return these
});
$c_sci_List.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_LinearSeqOptimized__find__F1__s_Option(this, p)
});
$c_sci_List.prototype.span__F1__T2 = (function(p) {
  var b = new $c_scm_ListBuffer().init___();
  var these = this;
  while (((!these.isEmpty__Z()) && $uZ(p.apply__O__O(these.head__O())))) {
    b.$$plus$eq__O__scm_ListBuffer(these.head__O());
    these = $as_sci_List(these.tail__O())
  };
  return new $c_T2().init___O__O(b.toList__sci_List(), these)
});
$c_sci_List.prototype.loop$3__p4__sci_List__F1__sci_List = (function(xs, p$1) {
  _loop: while (true) {
    if ((xs.isEmpty__Z() || (!$uZ(p$1.apply__O__O(xs.head__O()))))) {
      return xs
    } else {
      xs = $as_sci_List(xs.tail__O());
      continue _loop
    }
  }
});
$c_sci_List.prototype.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O = (function(that, bf) {
  return ((bf === $m_sci_List$().ReusableCBFInstance$2) ? that.seq__sc_TraversableOnce().toList__sci_List().$$colon$colon$colon__sci_List__sci_List(this) : $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that, bf))
});
$c_sci_List.prototype.length__I = (function() {
  return $f_sc_LinearSeqOptimized__length__I(this)
});
$c_sci_List.prototype.seq__sc_Seq = (function() {
  return this
});
$c_sci_List.prototype.take__I__O = (function(n) {
  return this.take__I__sci_List(n)
});
$c_sci_List.prototype.toStream__sci_Stream = (function() {
  return (this.isEmpty__Z() ? $m_sci_Stream$Empty$() : new $c_sci_Stream$Cons().init___O__F0(this.head__O(), new $c_sjsr_AnonFunction0().init___sjs_js_Function0((function($this) {
    return (function() {
      return $as_sci_List($this.tail__O()).toStream__sci_Stream()
    })
  })(this))))
});
$c_sci_List.prototype.last__O = (function() {
  return $f_sc_LinearSeqOptimized__last__O(this)
});
$c_sci_List.prototype.drop__I__O = (function(n) {
  return this.drop__I__sci_List(n)
});
$c_sci_List.prototype.contains__O__Z = (function(elem) {
  return $f_sc_LinearSeqOptimized__contains__O__Z(this, elem)
});
$c_sci_List.prototype.thisCollection__sc_Seq = (function() {
  return this
});
$c_sci_List.prototype.toSeq__sc_Seq = (function() {
  return this
});
$c_sci_List.prototype.isDefinedAt__O__Z = (function(x) {
  var x$1 = $uI(x);
  return $f_sc_LinearSeqOptimized__isDefinedAt__I__Z(this, x$1)
});
$c_sci_List.prototype.hashCode__I = (function() {
  return $m_s_util_hashing_MurmurHash3$().seqHash__sc_Seq__I(this)
});
$c_sci_List.prototype.toSeq__sc_GenSeq = (function() {
  return this
});
$c_sci_List.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
    if ((this === $m_sci_Nil$())) {
      return $m_sci_Nil$()
    } else {
      var h = new $c_sci_$colon$colon().init___O__sci_List(f.apply__O__O(this.head__O()), $m_sci_Nil$());
      var t = h;
      var rest = $as_sci_List(this.tail__O());
      while ((rest !== $m_sci_Nil$())) {
        var nx = new $c_sci_$colon$colon().init___O__sci_List(f.apply__O__O(rest.head__O()), $m_sci_Nil$());
        t.tl$5 = nx;
        t = nx;
        rest = $as_sci_List(rest.tail__O())
      };
      return h
    }
  } else {
    return $f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this, f, bf)
  }
});
$c_sci_List.prototype.collect__s_PartialFunction__scg_CanBuildFrom__O = (function(pf, bf) {
  if ((bf === $m_sci_List$().ReusableCBFInstance$2)) {
    if ((this === $m_sci_Nil$())) {
      return $m_sci_Nil$()
    } else {
      var rest = this;
      var h = null;
      do {
        var x = pf.applyOrElse__O__F1__O(rest.head__O(), $m_sci_List$().partialNotApplied$5);
        if ((x !== $m_sci_List$().partialNotApplied$5)) {
          h = new $c_sci_$colon$colon().init___O__sci_List(x, $m_sci_Nil$())
        };
        rest = $as_sci_List(rest.tail__O());
        if ((rest === $m_sci_Nil$())) {
          return ((h === null) ? $m_sci_Nil$() : h)
        }
      } while ((h === null));
      var t = h;
      do {
        var x$2 = pf.applyOrElse__O__F1__O(rest.head__O(), $m_sci_List$().partialNotApplied$5);
        if ((x$2 !== $m_sci_List$().partialNotApplied$5)) {
          var nx = new $c_sci_$colon$colon().init___O__sci_List(x$2, $m_sci_Nil$());
          t.tl$5 = nx;
          t = nx
        };
        rest = $as_sci_List(rest.tail__O())
      } while ((rest !== $m_sci_Nil$()));
      return h
    }
  } else {
    return $f_sc_TraversableLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this, pf, bf)
  }
});
$c_sci_List.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_LinearSeqOptimized__reduceLeft__F2__O(this, op)
});
$c_sci_List.prototype.reverse__sci_List = (function() {
  var result = $m_sci_Nil$();
  var these = this;
  while ((!these.isEmpty__Z())) {
    var x$4 = these.head__O();
    var this$1 = result;
    result = new $c_sci_$colon$colon().init___O__sci_List(x$4, this$1);
    these = $as_sci_List(these.tail__O())
  };
  return result
});
$c_sci_List.prototype.stringPrefix__T = (function() {
  return "List"
});
function $as_sci_List(obj) {
  return (((obj instanceof $c_sci_List) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.List"))
}
function $isArrayOf_sci_List(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_List)))
}
function $asArrayOf_sci_List(obj, depth) {
  return (($isArrayOf_sci_List(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.List;", depth))
}
/** @constructor */
function $c_sci_Range$Inclusive() {
  $c_sci_Range.call(this)
}
$c_sci_Range$Inclusive.prototype = new $h_sci_Range();
$c_sci_Range$Inclusive.prototype.constructor = $c_sci_Range$Inclusive;
/** @constructor */
function $h_sci_Range$Inclusive() {
  /*<skip>*/
}
$h_sci_Range$Inclusive.prototype = $c_sci_Range$Inclusive.prototype;
$c_sci_Range$Inclusive.prototype.isInclusive__Z = (function() {
  return true
});
$c_sci_Range$Inclusive.prototype.init___I__I__I = (function(start, end, step) {
  $c_sci_Range.prototype.init___I__I__I.call(this, start, end, step);
  return this
});
$c_sci_Range$Inclusive.prototype.copy__I__I__I__sci_Range = (function(start, end, step) {
  return new $c_sci_Range$Inclusive().init___I__I__I(start, end, step)
});
var $d_sci_Range$Inclusive = new $TypeData().initClass({
  sci_Range$Inclusive: 0
}, false, "scala.collection.immutable.Range$Inclusive", {
  sci_Range$Inclusive: 1,
  sci_Range: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sci_IndexedSeq: 1,
  sci_Seq: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_Range$Inclusive.prototype.$classData = $d_sci_Range$Inclusive;
/** @constructor */
function $c_sci_Stream$Cons() {
  $c_sci_Stream.call(this);
  this.hd$5 = null;
  this.tlVal$5 = null;
  this.tlGen$5 = null
}
$c_sci_Stream$Cons.prototype = new $h_sci_Stream();
$c_sci_Stream$Cons.prototype.constructor = $c_sci_Stream$Cons;
/** @constructor */
function $h_sci_Stream$Cons() {
  /*<skip>*/
}
$h_sci_Stream$Cons.prototype = $c_sci_Stream$Cons.prototype;
$c_sci_Stream$Cons.prototype.head__O = (function() {
  return this.hd$5
});
$c_sci_Stream$Cons.prototype.tail__sci_Stream = (function() {
  if ((!this.tailDefined__Z())) {
    if ((!this.tailDefined__Z())) {
      this.tlVal$5 = $as_sci_Stream(this.tlGen$5.apply__O());
      this.tlGen$5 = null
    }
  };
  return this.tlVal$5
});
$c_sci_Stream$Cons.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  if ((that instanceof $c_sci_Stream$Cons)) {
    var x2 = $as_sci_Stream$Cons(that);
    return this.consEq$1__p5__sci_Stream$Cons__sci_Stream$Cons__Z(this, x2)
  } else {
    return $f_sc_LinearSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
  }
});
$c_sci_Stream$Cons.prototype.isEmpty__Z = (function() {
  return false
});
$c_sci_Stream$Cons.prototype.tailDefined__Z = (function() {
  return (this.tlGen$5 === null)
});
$c_sci_Stream$Cons.prototype.consEq$1__p5__sci_Stream$Cons__sci_Stream$Cons__Z = (function(a, b) {
  _consEq: while (true) {
    if ($m_sr_BoxesRunTime$().equals__O__O__Z(a.hd$5, b.hd$5)) {
      var x1 = a.tail__sci_Stream();
      if ((x1 instanceof $c_sci_Stream$Cons)) {
        var x2 = $as_sci_Stream$Cons(x1);
        var x1$2 = b.tail__sci_Stream();
        if ((x1$2 instanceof $c_sci_Stream$Cons)) {
          var x2$2 = $as_sci_Stream$Cons(x1$2);
          if ((x2 === x2$2)) {
            return true
          } else {
            a = x2;
            b = x2$2;
            continue _consEq
          }
        } else {
          return false
        }
      } else {
        return b.tail__sci_Stream().isEmpty__Z()
      }
    } else {
      return false
    }
  }
});
$c_sci_Stream$Cons.prototype.tail__O = (function() {
  return this.tail__sci_Stream()
});
$c_sci_Stream$Cons.prototype.init___O__F0 = (function(hd, tl) {
  this.hd$5 = hd;
  this.tlGen$5 = tl;
  return this
});
function $as_sci_Stream$Cons(obj) {
  return (((obj instanceof $c_sci_Stream$Cons) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.Stream$Cons"))
}
function $isArrayOf_sci_Stream$Cons(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_Stream$Cons)))
}
function $asArrayOf_sci_Stream$Cons(obj, depth) {
  return (($isArrayOf_sci_Stream$Cons(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.Stream$Cons;", depth))
}
var $d_sci_Stream$Cons = new $TypeData().initClass({
  sci_Stream$Cons: 0
}, false, "scala.collection.immutable.Stream$Cons", {
  sci_Stream$Cons: 1,
  sci_Stream: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sci_LinearSeq: 1,
  sci_Seq: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sc_LinearSeq: 1,
  sc_LinearSeqLike: 1,
  sc_LinearSeqOptimized: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_Stream$Cons.prototype.$classData = $d_sci_Stream$Cons;
/** @constructor */
function $c_sci_Stream$Empty$() {
  $c_sci_Stream.call(this)
}
$c_sci_Stream$Empty$.prototype = new $h_sci_Stream();
$c_sci_Stream$Empty$.prototype.constructor = $c_sci_Stream$Empty$;
/** @constructor */
function $h_sci_Stream$Empty$() {
  /*<skip>*/
}
$h_sci_Stream$Empty$.prototype = $c_sci_Stream$Empty$.prototype;
$c_sci_Stream$Empty$.prototype.head__O = (function() {
  this.head__sr_Nothing$()
});
$c_sci_Stream$Empty$.prototype.init___ = (function() {
  return this
});
$c_sci_Stream$Empty$.prototype.isEmpty__Z = (function() {
  return true
});
$c_sci_Stream$Empty$.prototype.tailDefined__Z = (function() {
  return false
});
$c_sci_Stream$Empty$.prototype.tail__sr_Nothing$ = (function() {
  throw new $c_jl_UnsupportedOperationException().init___T("tail of empty stream")
});
$c_sci_Stream$Empty$.prototype.head__sr_Nothing$ = (function() {
  throw new $c_ju_NoSuchElementException().init___T("head of empty stream")
});
$c_sci_Stream$Empty$.prototype.tail__O = (function() {
  this.tail__sr_Nothing$()
});
var $d_sci_Stream$Empty$ = new $TypeData().initClass({
  sci_Stream$Empty$: 0
}, false, "scala.collection.immutable.Stream$Empty$", {
  sci_Stream$Empty$: 1,
  sci_Stream: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sci_LinearSeq: 1,
  sci_Seq: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sc_LinearSeq: 1,
  sc_LinearSeqLike: 1,
  sc_LinearSeqOptimized: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_Stream$Empty$.prototype.$classData = $d_sci_Stream$Empty$;
var $n_sci_Stream$Empty$ = (void 0);
function $m_sci_Stream$Empty$() {
  if ((!$n_sci_Stream$Empty$)) {
    $n_sci_Stream$Empty$ = new $c_sci_Stream$Empty$().init___()
  };
  return $n_sci_Stream$Empty$
}
/** @constructor */
function $c_sci_StreamViewLike$AbstractTransformed() {
  $c_sc_SeqViewLike$AbstractTransformed.call(this)
}
$c_sci_StreamViewLike$AbstractTransformed.prototype = new $h_sc_SeqViewLike$AbstractTransformed();
$c_sci_StreamViewLike$AbstractTransformed.prototype.constructor = $c_sci_StreamViewLike$AbstractTransformed;
/** @constructor */
function $h_sci_StreamViewLike$AbstractTransformed() {
  /*<skip>*/
}
$h_sci_StreamViewLike$AbstractTransformed.prototype = $c_sci_StreamViewLike$AbstractTransformed.prototype;
$c_sci_StreamViewLike$AbstractTransformed.prototype.newSliced__scg_SliceInterval__sc_SeqViewLike$Transformed = (function(_endpoints) {
  return new $c_sci_StreamViewLike$$anon$7().init___sci_StreamViewLike__scg_SliceInterval(this, _endpoints)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.flatten__F1__sc_GenTraversable = (function(asTraversable) {
  return new $c_sci_StreamViewLike$$anon$5().init___sci_StreamViewLike__F1(this, asTraversable)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_TraversableViewLike__dropWhile__F1__sc_TraversableView(this, p)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.newDroppedWhile__F1__sc_SeqViewLike$Transformed = (function(p) {
  return new $c_sci_StreamViewLike$$anon$8().init___sci_StreamViewLike__F1(this, p)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.withFilter__F1__scg_FilterMonadic = (function(p) {
  return $f_sc_TraversableViewLike__withFilter__F1__sc_TraversableView(this, p)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.sorted__s_math_Ordering__O = (function(ord) {
  return $f_sc_SeqViewLike__sorted__s_math_Ordering__sc_SeqView(this, ord)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.toString__T = (function() {
  return $f_sc_TraversableViewLike__viewToString__T(this)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.newReversed__sc_SeqViewLike$Transformed = (function() {
  return new $c_sci_StreamViewLike$$anon$12().init___sci_StreamViewLike(this)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.newFiltered__F1__sc_SeqViewLike$Transformed = (function(p) {
  return new $c_sci_StreamViewLike$$anon$6().init___sci_StreamViewLike__F1(this, p)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.newPrepended__sc_GenTraversable__sc_SeqViewLike$Transformed = (function(that) {
  return new $c_sci_StreamViewLike$$anon$3().init___sci_StreamViewLike__sc_GenTraversable(this, that)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_TraversableViewLike__takeWhile__F1__sc_TraversableView(this, p)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.init___sci_StreamViewLike = (function($$outer) {
  $c_sc_SeqViewLike$AbstractTransformed.prototype.init___sc_SeqViewLike.call(this, $$outer);
  return this
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.intersect__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqViewLike__intersect__sc_GenSeq__sc_SeqView(this, that)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.filter__F1__O = (function(p) {
  return $f_sc_TraversableViewLike__filter__F1__sc_TraversableView(this, p)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.reverse__O = (function() {
  return new $c_sci_StreamViewLike$$anon$12().init___sci_StreamViewLike(this)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.distinct__O = (function() {
  return $f_sc_SeqViewLike__distinct__sc_SeqView(this)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.newFlatMapped__F1__sc_TraversableViewLike$Transformed = (function(f) {
  return new $c_sci_StreamViewLike$$anon$5().init___sci_StreamViewLike__F1(this, f)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.newTakenWhile__F1__sc_SeqViewLike$Transformed = (function(p) {
  return new $c_sci_StreamViewLike$$anon$9().init___sci_StreamViewLike__F1(this, p)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.diff__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqViewLike__diff__sc_GenSeq__sc_SeqView(this, that)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.newMapped__F1__sc_SeqViewLike$Transformed = (function(f) {
  return new $c_sci_StreamViewLike$$anon$4().init___sci_StreamViewLike__F1(this, f)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.newAppended__sc_GenTraversable__sc_TraversableViewLike$Transformed = (function(that) {
  return new $c_sci_StreamViewLike$$anon$2().init___sci_StreamViewLike__sc_GenTraversable(this, that)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_TraversableViewLike__filterNot__F1__sc_TraversableView(this, p)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.newZipped__sc_GenIterable__sc_SeqViewLike$Transformed = (function(that) {
  return new $c_sci_StreamViewLike$$anon$10().init___sci_StreamViewLike__sc_GenIterable(this, that)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.take__I__O = (function(n) {
  return $f_sc_IterableViewLike__take__I__sc_IterableView(this, n)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.newTakenWhile__F1__sc_TraversableViewLike$Transformed = (function(p) {
  return new $c_sci_StreamViewLike$$anon$9().init___sci_StreamViewLike__F1(this, p)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.drop__I__O = (function(n) {
  return $f_sc_IterableViewLike__drop__I__sc_IterableView(this, n)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.newMapped__F1__sc_TraversableViewLike$Transformed = (function(f) {
  return new $c_sci_StreamViewLike$$anon$4().init___sci_StreamViewLike__F1(this, f)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.tail__O = (function() {
  return $f_sc_TraversableViewLike__tail__sc_TraversableView(this)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.sortBy__F1__s_math_Ordering__O = (function(f, ord) {
  return $f_sc_SeqViewLike__sortBy__F1__s_math_Ordering__sc_SeqView(this, f, ord)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.isDefinedAt__O__Z = (function(x) {
  var idx = $uI(x);
  return $f_sc_GenSeqLike__isDefinedAt__I__Z(this, idx)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.newForced__F0__sc_SeqViewLike$Transformed = (function(xs) {
  return new $c_sci_StreamViewLike$$anon$1().init___sci_StreamViewLike__F0(this, xs)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.newSliced__scg_SliceInterval__sc_TraversableViewLike$Transformed = (function(_endpoints) {
  return new $c_sci_StreamViewLike$$anon$7().init___sci_StreamViewLike__scg_SliceInterval(this, _endpoints)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.newZipped__sc_GenIterable__sc_IterableViewLike$Transformed = (function(that) {
  return new $c_sci_StreamViewLike$$anon$10().init___sci_StreamViewLike__sc_GenIterable(this, that)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.toSeq__sc_GenSeq = (function() {
  return this
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.newAppended__sc_GenTraversable__sc_SeqViewLike$Transformed = (function(that) {
  return new $c_sci_StreamViewLike$$anon$2().init___sci_StreamViewLike__sc_GenTraversable(this, that)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.newFiltered__F1__sc_TraversableViewLike$Transformed = (function(p) {
  return new $c_sci_StreamViewLike$$anon$6().init___sci_StreamViewLike__F1(this, p)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.newFlatMapped__F1__sc_SeqViewLike$Transformed = (function(f) {
  return new $c_sci_StreamViewLike$$anon$5().init___sci_StreamViewLike__F1(this, f)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.newDroppedWhile__F1__sc_TraversableViewLike$Transformed = (function(p) {
  return new $c_sci_StreamViewLike$$anon$8().init___sci_StreamViewLike__F1(this, p)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.newForced__F0__sc_TraversableViewLike$Transformed = (function(xs) {
  return new $c_sci_StreamViewLike$$anon$1().init___sci_StreamViewLike__F0(this, xs)
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.stringPrefix__T = (function() {
  return "StreamView"
});
$c_sci_StreamViewLike$AbstractTransformed.prototype.sortWith__F2__O = (function(lt) {
  return $f_sc_SeqViewLike__sortWith__F2__sc_SeqView(this, lt)
});
/** @constructor */
function $c_sci_Vector() {
  $c_sc_AbstractSeq.call(this);
  this.startIndex$4 = 0;
  this.endIndex$4 = 0;
  this.focus$4 = 0;
  this.dirty$4 = false;
  this.depth$4 = 0;
  this.display0$4 = null;
  this.display1$4 = null;
  this.display2$4 = null;
  this.display3$4 = null;
  this.display4$4 = null;
  this.display5$4 = null
}
$c_sci_Vector.prototype = new $h_sc_AbstractSeq();
$c_sci_Vector.prototype.constructor = $c_sci_Vector;
/** @constructor */
function $h_sci_Vector() {
  /*<skip>*/
}
$h_sci_Vector.prototype = $c_sci_Vector.prototype;
$c_sci_Vector.prototype.checkRangeConvert__p4__I__I = (function(index) {
  var idx = ((index + this.startIndex$4) | 0);
  if (((index >= 0) && (idx < this.endIndex$4))) {
    return idx
  } else {
    throw new $c_jl_IndexOutOfBoundsException().init___T(("" + index))
  }
});
$c_sci_Vector.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sci_Vector.prototype.display3__AO = (function() {
  return this.display3$4
});
$c_sci_Vector.prototype.gotoPosWritable__p4__I__I__I__V = (function(oldIndex, newIndex, xor) {
  if (this.dirty$4) {
    $f_sci_VectorPointer__gotoPosWritable1__I__I__I__V(this, oldIndex, newIndex, xor)
  } else {
    $f_sci_VectorPointer__gotoPosWritable0__I__I__V(this, newIndex, xor);
    this.dirty$4 = true
  }
});
$c_sci_Vector.prototype.head__O = (function() {
  if ($f_sc_SeqLike__isEmpty__Z(this)) {
    throw new $c_jl_UnsupportedOperationException().init___T("empty.head")
  };
  return this.apply__I__O(0)
});
$c_sci_Vector.prototype.apply__I__O = (function(index) {
  var idx = this.checkRangeConvert__p4__I__I(index);
  var xor = (idx ^ this.focus$4);
  return $f_sci_VectorPointer__getElem__I__I__O(this, idx, xor)
});
$c_sci_Vector.prototype.thisCollection__sc_Iterable = (function() {
  return this
});
$c_sci_Vector.prototype.lengthCompare__I__I = (function(len) {
  return ((this.length__I() - len) | 0)
});
$c_sci_Vector.prototype.depth__I = (function() {
  return this.depth$4
});
$c_sci_Vector.prototype.apply__O__O = (function(v1) {
  return this.apply__I__O($uI(v1))
});
$c_sci_Vector.prototype.take__I__sci_Vector = (function(n) {
  if ((n <= 0)) {
    var this$1 = $m_sci_Vector$();
    return this$1.NIL$6
  } else {
    return ((this.startIndex$4 < ((this.endIndex$4 - n) | 0)) ? this.dropBack0__p4__I__sci_Vector(((this.startIndex$4 + n) | 0)) : this)
  }
});
$c_sci_Vector.prototype.initIterator__sci_VectorIterator__V = (function(s) {
  var depth = this.depth$4;
  $f_sci_VectorPointer__initFrom__sci_VectorPointer__I__V(s, this, depth);
  if (this.dirty$4) {
    var index = this.focus$4;
    $f_sci_VectorPointer__stabilize__I__V(s, index)
  };
  if ((s.depth$2 > 1)) {
    var index$1 = this.startIndex$4;
    var xor = (this.startIndex$4 ^ this.focus$4);
    $f_sci_VectorPointer__gotoPos__I__I__V(s, index$1, xor)
  }
});
$c_sci_Vector.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sci_Vector.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_Vector.prototype.init___I__I__I = (function(startIndex, endIndex, focus) {
  this.startIndex$4 = startIndex;
  this.endIndex$4 = endIndex;
  this.focus$4 = focus;
  this.dirty$4 = false;
  return this
});
$c_sci_Vector.prototype.display5$und$eq__AO__V = (function(x$1) {
  this.display5$4 = x$1
});
$c_sci_Vector.prototype.$$colon$plus__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return ((((bf === ($m_sci_IndexedSeq$(), $m_sc_IndexedSeq$().ReusableCBF$6)) || (bf === $m_sci_Seq$().ReusableCBFInstance$2)) || (bf === $m_sc_Seq$().ReusableCBFInstance$2)) ? this.appendBack__O__sci_Vector(elem) : $f_sc_SeqLike__$$colon$plus__O__scg_CanBuildFrom__O(this, elem, bf))
});
$c_sci_Vector.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sci_Vector$()
});
$c_sci_Vector.prototype.cleanLeftEdge__p4__I__V = (function(cutIndex) {
  if ((cutIndex < 32)) {
    this.zeroLeft__p4__AO__I__V(this.display0$4, cutIndex)
  } else if ((cutIndex < 1024)) {
    this.zeroLeft__p4__AO__I__V(this.display0$4, (31 & cutIndex));
    this.display1$4 = this.copyRight__p4__AO__I__AO(this.display1$4, ((cutIndex >>> 5) | 0))
  } else if ((cutIndex < 32768)) {
    this.zeroLeft__p4__AO__I__V(this.display0$4, (31 & cutIndex));
    this.display1$4 = this.copyRight__p4__AO__I__AO(this.display1$4, (31 & ((cutIndex >>> 5) | 0)));
    this.display2$4 = this.copyRight__p4__AO__I__AO(this.display2$4, ((cutIndex >>> 10) | 0))
  } else if ((cutIndex < 1048576)) {
    this.zeroLeft__p4__AO__I__V(this.display0$4, (31 & cutIndex));
    this.display1$4 = this.copyRight__p4__AO__I__AO(this.display1$4, (31 & ((cutIndex >>> 5) | 0)));
    this.display2$4 = this.copyRight__p4__AO__I__AO(this.display2$4, (31 & ((cutIndex >>> 10) | 0)));
    this.display3$4 = this.copyRight__p4__AO__I__AO(this.display3$4, ((cutIndex >>> 15) | 0))
  } else if ((cutIndex < 33554432)) {
    this.zeroLeft__p4__AO__I__V(this.display0$4, (31 & cutIndex));
    this.display1$4 = this.copyRight__p4__AO__I__AO(this.display1$4, (31 & ((cutIndex >>> 5) | 0)));
    this.display2$4 = this.copyRight__p4__AO__I__AO(this.display2$4, (31 & ((cutIndex >>> 10) | 0)));
    this.display3$4 = this.copyRight__p4__AO__I__AO(this.display3$4, (31 & ((cutIndex >>> 15) | 0)));
    this.display4$4 = this.copyRight__p4__AO__I__AO(this.display4$4, ((cutIndex >>> 20) | 0))
  } else if ((cutIndex < 1073741824)) {
    this.zeroLeft__p4__AO__I__V(this.display0$4, (31 & cutIndex));
    this.display1$4 = this.copyRight__p4__AO__I__AO(this.display1$4, (31 & ((cutIndex >>> 5) | 0)));
    this.display2$4 = this.copyRight__p4__AO__I__AO(this.display2$4, (31 & ((cutIndex >>> 10) | 0)));
    this.display3$4 = this.copyRight__p4__AO__I__AO(this.display3$4, (31 & ((cutIndex >>> 15) | 0)));
    this.display4$4 = this.copyRight__p4__AO__I__AO(this.display4$4, (31 & ((cutIndex >>> 20) | 0)));
    this.display5$4 = this.copyRight__p4__AO__I__AO(this.display5$4, ((cutIndex >>> 25) | 0))
  } else {
    throw new $c_jl_IllegalArgumentException().init___()
  }
});
$c_sci_Vector.prototype.display0__AO = (function() {
  return this.display0$4
});
$c_sci_Vector.prototype.display4__AO = (function() {
  return this.display4$4
});
$c_sci_Vector.prototype.display2$und$eq__AO__V = (function(x$1) {
  this.display2$4 = x$1
});
$c_sci_Vector.prototype.shiftTopLevel__p4__I__I__V = (function(oldLeft, newLeft) {
  var x1 = (((-1) + this.depth$4) | 0);
  switch (x1) {
    case 0: {
      var array = this.display0$4;
      this.display0$4 = $f_sci_VectorPointer__copyRange__AO__I__I__AO(this, array, oldLeft, newLeft);
      break
    }
    case 1: {
      var array$1 = this.display1$4;
      this.display1$4 = $f_sci_VectorPointer__copyRange__AO__I__I__AO(this, array$1, oldLeft, newLeft);
      break
    }
    case 2: {
      var array$2 = this.display2$4;
      this.display2$4 = $f_sci_VectorPointer__copyRange__AO__I__I__AO(this, array$2, oldLeft, newLeft);
      break
    }
    case 3: {
      var array$3 = this.display3$4;
      this.display3$4 = $f_sci_VectorPointer__copyRange__AO__I__I__AO(this, array$3, oldLeft, newLeft);
      break
    }
    case 4: {
      var array$4 = this.display4$4;
      this.display4$4 = $f_sci_VectorPointer__copyRange__AO__I__I__AO(this, array$4, oldLeft, newLeft);
      break
    }
    case 5: {
      var array$5 = this.display5$4;
      this.display5$4 = $f_sci_VectorPointer__copyRange__AO__I__I__AO(this, array$5, oldLeft, newLeft);
      break
    }
    default: {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_sci_Vector.prototype.tail__sci_Vector = (function() {
  if ($f_sc_SeqLike__isEmpty__Z(this)) {
    throw new $c_jl_UnsupportedOperationException().init___T("empty.tail")
  };
  return this.drop__I__sci_Vector(1)
});
$c_sci_Vector.prototype.toVector__sci_Vector = (function() {
  return this
});
$c_sci_Vector.prototype.appendBack__O__sci_Vector = (function(value) {
  if ((this.endIndex$4 !== this.startIndex$4)) {
    var blockIndex = ((-32) & this.endIndex$4);
    var lo = (31 & this.endIndex$4);
    if ((this.endIndex$4 !== blockIndex)) {
      var s = new $c_sci_Vector().init___I__I__I(this.startIndex$4, ((1 + this.endIndex$4) | 0), blockIndex);
      var depth = this.depth$4;
      $f_sci_VectorPointer__initFrom__sci_VectorPointer__I__V(s, this, depth);
      s.dirty$4 = this.dirty$4;
      s.gotoPosWritable__p4__I__I__I__V(this.focus$4, blockIndex, (this.focus$4 ^ blockIndex));
      s.display0$4.set(lo, value);
      return s
    } else {
      var shift = (this.startIndex$4 & (~(((-1) + (1 << $imul(5, (((-1) + this.depth$4) | 0)))) | 0)));
      var shiftBlocks = ((this.startIndex$4 >>> $imul(5, (((-1) + this.depth$4) | 0))) | 0);
      if ((shift !== 0)) {
        if ((this.depth$4 > 1)) {
          var newBlockIndex = ((blockIndex - shift) | 0);
          var newFocus = ((this.focus$4 - shift) | 0);
          var s$2 = new $c_sci_Vector().init___I__I__I(((this.startIndex$4 - shift) | 0), ((((1 + this.endIndex$4) | 0) - shift) | 0), newBlockIndex);
          var depth$1 = this.depth$4;
          $f_sci_VectorPointer__initFrom__sci_VectorPointer__I__V(s$2, this, depth$1);
          s$2.dirty$4 = this.dirty$4;
          s$2.shiftTopLevel__p4__I__I__V(shiftBlocks, 0);
          s$2.gotoFreshPosWritable__p4__I__I__I__V(newFocus, newBlockIndex, (newFocus ^ newBlockIndex));
          s$2.display0$4.set(lo, value);
          return s$2
        } else {
          var newBlockIndex$2 = (((-32) + blockIndex) | 0);
          var newFocus$2 = this.focus$4;
          var s$3 = new $c_sci_Vector().init___I__I__I(((this.startIndex$4 - shift) | 0), ((((1 + this.endIndex$4) | 0) - shift) | 0), newBlockIndex$2);
          var depth$2 = this.depth$4;
          $f_sci_VectorPointer__initFrom__sci_VectorPointer__I__V(s$3, this, depth$2);
          s$3.dirty$4 = this.dirty$4;
          s$3.shiftTopLevel__p4__I__I__V(shiftBlocks, 0);
          s$3.gotoPosWritable__p4__I__I__I__V(newFocus$2, newBlockIndex$2, (newFocus$2 ^ newBlockIndex$2));
          s$3.display0$4.set(((32 - shift) | 0), value);
          return s$3
        }
      } else {
        var newFocus$3 = this.focus$4;
        var s$4 = new $c_sci_Vector().init___I__I__I(this.startIndex$4, ((1 + this.endIndex$4) | 0), blockIndex);
        var depth$3 = this.depth$4;
        $f_sci_VectorPointer__initFrom__sci_VectorPointer__I__V(s$4, this, depth$3);
        s$4.dirty$4 = this.dirty$4;
        s$4.gotoFreshPosWritable__p4__I__I__I__V(newFocus$3, blockIndex, (newFocus$3 ^ blockIndex));
        s$4.display0$4.set(lo, value);
        return s$4
      }
    }
  } else {
    var elems = $newArrayObject($d_O.getArrayOf(), [32]);
    elems.set(0, value);
    var s$5 = new $c_sci_Vector().init___I__I__I(0, 1, 0);
    s$5.depth$4 = 1;
    s$5.display0$4 = elems;
    return s$5
  }
});
$c_sci_Vector.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_IndexedSeqLike__toBuffer__scm_Buffer(this)
});
$c_sci_Vector.prototype.cleanRightEdge__p4__I__V = (function(cutIndex) {
  if ((cutIndex <= 32)) {
    this.zeroRight__p4__AO__I__V(this.display0$4, cutIndex)
  } else if ((cutIndex <= 1024)) {
    this.zeroRight__p4__AO__I__V(this.display0$4, ((1 + (31 & (((-1) + cutIndex) | 0))) | 0));
    this.display1$4 = this.copyLeft__p4__AO__I__AO(this.display1$4, ((cutIndex >>> 5) | 0))
  } else if ((cutIndex <= 32768)) {
    this.zeroRight__p4__AO__I__V(this.display0$4, ((1 + (31 & (((-1) + cutIndex) | 0))) | 0));
    this.display1$4 = this.copyLeft__p4__AO__I__AO(this.display1$4, ((1 + (31 & (((((-1) + cutIndex) | 0) >>> 5) | 0))) | 0));
    this.display2$4 = this.copyLeft__p4__AO__I__AO(this.display2$4, ((cutIndex >>> 10) | 0))
  } else if ((cutIndex <= 1048576)) {
    this.zeroRight__p4__AO__I__V(this.display0$4, ((1 + (31 & (((-1) + cutIndex) | 0))) | 0));
    this.display1$4 = this.copyLeft__p4__AO__I__AO(this.display1$4, ((1 + (31 & (((((-1) + cutIndex) | 0) >>> 5) | 0))) | 0));
    this.display2$4 = this.copyLeft__p4__AO__I__AO(this.display2$4, ((1 + (31 & (((((-1) + cutIndex) | 0) >>> 10) | 0))) | 0));
    this.display3$4 = this.copyLeft__p4__AO__I__AO(this.display3$4, ((cutIndex >>> 15) | 0))
  } else if ((cutIndex <= 33554432)) {
    this.zeroRight__p4__AO__I__V(this.display0$4, ((1 + (31 & (((-1) + cutIndex) | 0))) | 0));
    this.display1$4 = this.copyLeft__p4__AO__I__AO(this.display1$4, ((1 + (31 & (((((-1) + cutIndex) | 0) >>> 5) | 0))) | 0));
    this.display2$4 = this.copyLeft__p4__AO__I__AO(this.display2$4, ((1 + (31 & (((((-1) + cutIndex) | 0) >>> 10) | 0))) | 0));
    this.display3$4 = this.copyLeft__p4__AO__I__AO(this.display3$4, ((1 + (31 & (((((-1) + cutIndex) | 0) >>> 15) | 0))) | 0));
    this.display4$4 = this.copyLeft__p4__AO__I__AO(this.display4$4, ((cutIndex >>> 20) | 0))
  } else if ((cutIndex <= 1073741824)) {
    this.zeroRight__p4__AO__I__V(this.display0$4, ((1 + (31 & (((-1) + cutIndex) | 0))) | 0));
    this.display1$4 = this.copyLeft__p4__AO__I__AO(this.display1$4, ((1 + (31 & (((((-1) + cutIndex) | 0) >>> 5) | 0))) | 0));
    this.display2$4 = this.copyLeft__p4__AO__I__AO(this.display2$4, ((1 + (31 & (((((-1) + cutIndex) | 0) >>> 10) | 0))) | 0));
    this.display3$4 = this.copyLeft__p4__AO__I__AO(this.display3$4, ((1 + (31 & (((((-1) + cutIndex) | 0) >>> 15) | 0))) | 0));
    this.display4$4 = this.copyLeft__p4__AO__I__AO(this.display4$4, ((1 + (31 & (((((-1) + cutIndex) | 0) >>> 20) | 0))) | 0));
    this.display5$4 = this.copyLeft__p4__AO__I__AO(this.display5$4, ((cutIndex >>> 25) | 0))
  } else {
    throw new $c_jl_IllegalArgumentException().init___()
  }
});
$c_sci_Vector.prototype.preClean__p4__I__V = (function(depth) {
  this.depth$4 = depth;
  var x1 = (((-1) + depth) | 0);
  switch (x1) {
    case 0: {
      this.display1$4 = null;
      this.display2$4 = null;
      this.display3$4 = null;
      this.display4$4 = null;
      this.display5$4 = null;
      break
    }
    case 1: {
      this.display2$4 = null;
      this.display3$4 = null;
      this.display4$4 = null;
      this.display5$4 = null;
      break
    }
    case 2: {
      this.display3$4 = null;
      this.display4$4 = null;
      this.display5$4 = null;
      break
    }
    case 3: {
      this.display4$4 = null;
      this.display5$4 = null;
      break
    }
    case 4: {
      this.display5$4 = null;
      break
    }
    case 5: {
      break
    }
    default: {
      throw new $c_s_MatchError().init___O(x1)
    }
  }
});
$c_sci_Vector.prototype.$$plus$colon__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return ((((bf === ($m_sci_IndexedSeq$(), $m_sc_IndexedSeq$().ReusableCBF$6)) || (bf === $m_sci_Seq$().ReusableCBFInstance$2)) || (bf === $m_sc_Seq$().ReusableCBFInstance$2)) ? this.appendFront__O__sci_Vector(elem) : $f_sc_SeqLike__$$plus$colon__O__scg_CanBuildFrom__O(this, elem, bf))
});
$c_sci_Vector.prototype.iterator__sc_Iterator = (function() {
  return this.iterator__sci_VectorIterator()
});
$c_sci_Vector.prototype.display1$und$eq__AO__V = (function(x$1) {
  this.display1$4 = x$1
});
$c_sci_Vector.prototype.zeroRight__p4__AO__I__V = (function(array, index) {
  var i = index;
  while ((i < array.u.length)) {
    array.set(i, null);
    i = ((1 + i) | 0)
  }
});
$c_sci_Vector.prototype.length__I = (function() {
  return ((this.endIndex$4 - this.startIndex$4) | 0)
});
$c_sci_Vector.prototype.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O = (function(that, bf) {
  if ((((bf === ($m_sci_IndexedSeq$(), $m_sc_IndexedSeq$().ReusableCBF$6)) || (bf === $m_sci_Seq$().ReusableCBFInstance$2)) || (bf === $m_sc_Seq$().ReusableCBFInstance$2))) {
    if (that.isEmpty__Z()) {
      return this
    } else {
      var again = ((!that.isTraversableAgain__Z()) ? that.toVector__sci_Vector() : that.seq__sc_TraversableOnce());
      var x1 = again.size__I();
      switch (x1) {
        default: {
          if (((x1 <= 2) || (x1 < ((this.length__I() >>> 5) | 0)))) {
            var v = new $c_sr_ObjectRef().init___O(this);
            again.foreach__F1__V(new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, v$1) {
              return (function(x$2) {
                v$1.elem$1 = $as_sci_Vector($as_sci_Vector(v$1.elem$1).$$colon$plus__O__scg_CanBuildFrom__O(x$2, ($m_sci_Vector$(), $m_sc_IndexedSeq$().ReusableCBF$6)))
              })
            })(this, v)));
            return $as_sci_Vector(v.elem$1)
          } else if (((this.length__I() < ((x1 >>> 5) | 0)) && (again instanceof $c_sci_Vector))) {
            var v$2 = $as_sci_Vector(again);
            var ri = new $c_sci_Vector$$anon$1().init___sci_Vector(this);
            while (ri.hasNext__Z()) {
              var x$1 = ri.next__O();
              v$2 = $as_sci_Vector(v$2.$$plus$colon__O__scg_CanBuildFrom__O(x$1, ($m_sci_Vector$(), $m_sc_IndexedSeq$().ReusableCBF$6)))
            };
            return v$2
          } else {
            return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, again, bf)
          }
        }
      }
    }
  } else {
    return $f_sc_TraversableLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, that.seq__sc_TraversableOnce(), bf)
  }
});
$c_sci_Vector.prototype.display4$und$eq__AO__V = (function(x$1) {
  this.display4$4 = x$1
});
$c_sci_Vector.prototype.seq__sc_Seq = (function() {
  return this
});
$c_sci_Vector.prototype.gotoFreshPosWritable__p4__I__I__I__V = (function(oldIndex, newIndex, xor) {
  if (this.dirty$4) {
    $f_sci_VectorPointer__gotoFreshPosWritable1__I__I__I__V(this, oldIndex, newIndex, xor)
  } else {
    $f_sci_VectorPointer__gotoFreshPosWritable0__I__I__I__V(this, oldIndex, newIndex, xor);
    this.dirty$4 = true
  }
});
$c_sci_Vector.prototype.sizeHintIfCheap__I = (function() {
  return this.length__I()
});
$c_sci_Vector.prototype.display1__AO = (function() {
  return this.display1$4
});
$c_sci_Vector.prototype.take__I__O = (function(n) {
  return this.take__I__sci_Vector(n)
});
$c_sci_Vector.prototype.last__O = (function() {
  if ($f_sc_SeqLike__isEmpty__Z(this)) {
    throw new $c_jl_UnsupportedOperationException().init___T("empty.last")
  };
  return this.apply__I__O((((-1) + this.length__I()) | 0))
});
$c_sci_Vector.prototype.display5__AO = (function() {
  return this.display5$4
});
$c_sci_Vector.prototype.drop__I__O = (function(n) {
  return this.drop__I__sci_Vector(n)
});
$c_sci_Vector.prototype.thisCollection__sc_Seq = (function() {
  return this
});
$c_sci_Vector.prototype.tail__O = (function() {
  return this.tail__sci_Vector()
});
$c_sci_Vector.prototype.toSeq__sc_Seq = (function() {
  return this
});
$c_sci_Vector.prototype.iterator__sci_VectorIterator = (function() {
  var s = new $c_sci_VectorIterator().init___I__I(this.startIndex$4, this.endIndex$4);
  this.initIterator__sci_VectorIterator__V(s);
  return s
});
$c_sci_Vector.prototype.requiredDepth__p4__I__I = (function(xor) {
  if ((xor < 32)) {
    return 1
  } else if ((xor < 1024)) {
    return 2
  } else if ((xor < 32768)) {
    return 3
  } else if ((xor < 1048576)) {
    return 4
  } else if ((xor < 33554432)) {
    return 5
  } else if ((xor < 1073741824)) {
    return 6
  } else {
    throw new $c_jl_IllegalArgumentException().init___()
  }
});
$c_sci_Vector.prototype.isDefinedAt__O__Z = (function(x) {
  var idx = $uI(x);
  return $f_sc_GenSeqLike__isDefinedAt__I__Z(this, idx)
});
$c_sci_Vector.prototype.dropBack0__p4__I__sci_Vector = (function(cutIndex) {
  var blockIndex = ((-32) & (((-1) + cutIndex) | 0));
  var xor = (this.startIndex$4 ^ (((-1) + cutIndex) | 0));
  var d = this.requiredDepth__p4__I__I(xor);
  var shift = (this.startIndex$4 & (~(((-1) + (1 << $imul(5, d))) | 0)));
  var s = new $c_sci_Vector().init___I__I__I(((this.startIndex$4 - shift) | 0), ((cutIndex - shift) | 0), ((blockIndex - shift) | 0));
  var depth = this.depth$4;
  $f_sci_VectorPointer__initFrom__sci_VectorPointer__I__V(s, this, depth);
  s.dirty$4 = this.dirty$4;
  s.gotoPosWritable__p4__I__I__I__V(this.focus$4, blockIndex, (this.focus$4 ^ blockIndex));
  s.preClean__p4__I__V(d);
  s.cleanRightEdge__p4__I__V(((cutIndex - shift) | 0));
  return s
});
$c_sci_Vector.prototype.zeroLeft__p4__AO__I__V = (function(array, index) {
  var i = 0;
  while ((i < index)) {
    array.set(i, null);
    i = ((1 + i) | 0)
  }
});
$c_sci_Vector.prototype.toSeq__sc_GenSeq = (function() {
  return this
});
$c_sci_Vector.prototype.hashCode__I = (function() {
  return $m_s_util_hashing_MurmurHash3$().seqHash__sc_Seq__I(this)
});
$c_sci_Vector.prototype.depth$und$eq__I__V = (function(x$1) {
  this.depth$4 = x$1
});
$c_sci_Vector.prototype.display2__AO = (function() {
  return this.display2$4
});
$c_sci_Vector.prototype.dropFront0__p4__I__sci_Vector = (function(cutIndex) {
  var blockIndex = ((-32) & cutIndex);
  var xor = (cutIndex ^ (((-1) + this.endIndex$4) | 0));
  var d = this.requiredDepth__p4__I__I(xor);
  var shift = (cutIndex & (~(((-1) + (1 << $imul(5, d))) | 0)));
  var s = new $c_sci_Vector().init___I__I__I(((cutIndex - shift) | 0), ((this.endIndex$4 - shift) | 0), ((blockIndex - shift) | 0));
  var depth = this.depth$4;
  $f_sci_VectorPointer__initFrom__sci_VectorPointer__I__V(s, this, depth);
  s.dirty$4 = this.dirty$4;
  s.gotoPosWritable__p4__I__I__I__V(this.focus$4, blockIndex, (this.focus$4 ^ blockIndex));
  s.preClean__p4__I__V(d);
  s.cleanLeftEdge__p4__I__V(((cutIndex - shift) | 0));
  return s
});
$c_sci_Vector.prototype.display0$und$eq__AO__V = (function(x$1) {
  this.display0$4 = x$1
});
$c_sci_Vector.prototype.drop__I__sci_Vector = (function(n) {
  if ((n <= 0)) {
    return this
  } else if ((this.startIndex$4 < ((this.endIndex$4 - n) | 0))) {
    return this.dropFront0__p4__I__sci_Vector(((this.startIndex$4 + n) | 0))
  } else {
    var this$1 = $m_sci_Vector$();
    return this$1.NIL$6
  }
});
$c_sci_Vector.prototype.appendFront__O__sci_Vector = (function(value) {
  if ((this.endIndex$4 !== this.startIndex$4)) {
    var blockIndex = ((-32) & (((-1) + this.startIndex$4) | 0));
    var lo = (31 & (((-1) + this.startIndex$4) | 0));
    if ((this.startIndex$4 !== ((32 + blockIndex) | 0))) {
      var s = new $c_sci_Vector().init___I__I__I((((-1) + this.startIndex$4) | 0), this.endIndex$4, blockIndex);
      var depth = this.depth$4;
      $f_sci_VectorPointer__initFrom__sci_VectorPointer__I__V(s, this, depth);
      s.dirty$4 = this.dirty$4;
      s.gotoPosWritable__p4__I__I__I__V(this.focus$4, blockIndex, (this.focus$4 ^ blockIndex));
      s.display0$4.set(lo, value);
      return s
    } else {
      var freeSpace = (((1 << $imul(5, this.depth$4)) - this.endIndex$4) | 0);
      var shift = (freeSpace & (~(((-1) + (1 << $imul(5, (((-1) + this.depth$4) | 0)))) | 0)));
      var shiftBlocks = ((freeSpace >>> $imul(5, (((-1) + this.depth$4) | 0))) | 0);
      if ((shift !== 0)) {
        if ((this.depth$4 > 1)) {
          var newBlockIndex = ((blockIndex + shift) | 0);
          var newFocus = ((this.focus$4 + shift) | 0);
          var s$2 = new $c_sci_Vector().init___I__I__I((((((-1) + this.startIndex$4) | 0) + shift) | 0), ((this.endIndex$4 + shift) | 0), newBlockIndex);
          var depth$1 = this.depth$4;
          $f_sci_VectorPointer__initFrom__sci_VectorPointer__I__V(s$2, this, depth$1);
          s$2.dirty$4 = this.dirty$4;
          s$2.shiftTopLevel__p4__I__I__V(0, shiftBlocks);
          s$2.gotoFreshPosWritable__p4__I__I__I__V(newFocus, newBlockIndex, (newFocus ^ newBlockIndex));
          s$2.display0$4.set(lo, value);
          return s$2
        } else {
          var newBlockIndex$2 = ((32 + blockIndex) | 0);
          var newFocus$2 = this.focus$4;
          var s$3 = new $c_sci_Vector().init___I__I__I((((((-1) + this.startIndex$4) | 0) + shift) | 0), ((this.endIndex$4 + shift) | 0), newBlockIndex$2);
          var depth$2 = this.depth$4;
          $f_sci_VectorPointer__initFrom__sci_VectorPointer__I__V(s$3, this, depth$2);
          s$3.dirty$4 = this.dirty$4;
          s$3.shiftTopLevel__p4__I__I__V(0, shiftBlocks);
          s$3.gotoPosWritable__p4__I__I__I__V(newFocus$2, newBlockIndex$2, (newFocus$2 ^ newBlockIndex$2));
          s$3.display0$4.set((((-1) + shift) | 0), value);
          return s$3
        }
      } else if ((blockIndex < 0)) {
        var move = (((1 << $imul(5, ((1 + this.depth$4) | 0))) - (1 << $imul(5, this.depth$4))) | 0);
        var newBlockIndex$3 = ((blockIndex + move) | 0);
        var newFocus$3 = ((this.focus$4 + move) | 0);
        var s$4 = new $c_sci_Vector().init___I__I__I((((((-1) + this.startIndex$4) | 0) + move) | 0), ((this.endIndex$4 + move) | 0), newBlockIndex$3);
        var depth$3 = this.depth$4;
        $f_sci_VectorPointer__initFrom__sci_VectorPointer__I__V(s$4, this, depth$3);
        s$4.dirty$4 = this.dirty$4;
        s$4.gotoFreshPosWritable__p4__I__I__I__V(newFocus$3, newBlockIndex$3, (newFocus$3 ^ newBlockIndex$3));
        s$4.display0$4.set(lo, value);
        return s$4
      } else {
        var newFocus$4 = this.focus$4;
        var s$5 = new $c_sci_Vector().init___I__I__I((((-1) + this.startIndex$4) | 0), this.endIndex$4, blockIndex);
        var depth$4 = this.depth$4;
        $f_sci_VectorPointer__initFrom__sci_VectorPointer__I__V(s$5, this, depth$4);
        s$5.dirty$4 = this.dirty$4;
        s$5.gotoFreshPosWritable__p4__I__I__I__V(newFocus$4, blockIndex, (newFocus$4 ^ blockIndex));
        s$5.display0$4.set(lo, value);
        return s$5
      }
    }
  } else {
    var elems = $newArrayObject($d_O.getArrayOf(), [32]);
    elems.set(31, value);
    var s$6 = new $c_sci_Vector().init___I__I__I(31, 32, 0);
    s$6.depth$4 = 1;
    s$6.display0$4 = elems;
    return s$6
  }
});
$c_sci_Vector.prototype.copyLeft__p4__AO__I__AO = (function(array, right) {
  var copy = $newArrayObject($d_O.getArrayOf(), [array.u.length]);
  $systemArraycopy(array, 0, copy, 0, right);
  return copy
});
$c_sci_Vector.prototype.copyRight__p4__AO__I__AO = (function(array, left) {
  var copy = $newArrayObject($d_O.getArrayOf(), [array.u.length]);
  $systemArraycopy(array, left, copy, left, ((copy.u.length - left) | 0));
  return copy
});
$c_sci_Vector.prototype.display3$und$eq__AO__V = (function(x$1) {
  this.display3$4 = x$1
});
function $as_sci_Vector(obj) {
  return (((obj instanceof $c_sci_Vector) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.Vector"))
}
function $isArrayOf_sci_Vector(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_Vector)))
}
function $asArrayOf_sci_Vector(obj, depth) {
  return (($isArrayOf_sci_Vector(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.Vector;", depth))
}
var $d_sci_Vector = new $TypeData().initClass({
  sci_Vector: 0
}, false, "scala.collection.immutable.Vector", {
  sci_Vector: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sci_IndexedSeq: 1,
  sci_Seq: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  sci_VectorPointer: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  sc_CustomParallelizable: 1
});
$c_sci_Vector.prototype.$classData = $d_sci_Vector;
/** @constructor */
function $c_sci_WrappedString() {
  $c_sc_AbstractSeq.call(this);
  this.self$4 = null
}
$c_sci_WrappedString.prototype = new $h_sc_AbstractSeq();
$c_sci_WrappedString.prototype.constructor = $c_sci_WrappedString;
/** @constructor */
function $h_sci_WrappedString() {
  /*<skip>*/
}
$h_sci_WrappedString.prototype = $c_sci_WrappedString.prototype;
$c_sci_WrappedString.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sci_WrappedString.prototype.head__O = (function() {
  return $f_sc_IndexedSeqOptimized__head__O(this)
});
$c_sci_WrappedString.prototype.apply__I__O = (function(idx) {
  var thiz = this.self$4;
  var c = (65535 & $uI(thiz.charCodeAt(idx)));
  return new $c_jl_Character().init___C(c)
});
$c_sci_WrappedString.prototype.thisCollection__sc_Iterable = (function() {
  return this
});
$c_sci_WrappedString.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_IndexedSeqOptimized__lengthCompare__I__I(this, len)
});
$c_sci_WrappedString.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IndexedSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_sci_WrappedString.prototype.apply__O__O = (function(v1) {
  var n = $uI(v1);
  var thiz = this.self$4;
  var c = (65535 & $uI(thiz.charCodeAt(n)));
  return new $c_jl_Character().init___C(c)
});
$c_sci_WrappedString.prototype.exists__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__exists__F1__Z(this, p)
});
$c_sci_WrappedString.prototype.toList__sci_List = (function() {
  return $f_sc_IndexedSeqOptimized__toList__sci_List(this)
});
$c_sci_WrappedString.prototype.isEmpty__Z = (function() {
  return $f_sc_IndexedSeqOptimized__isEmpty__Z(this)
});
$c_sci_WrappedString.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sci_WrappedString.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_WrappedString.prototype.apply__I__C = (function(n) {
  var thiz = this.self$4;
  return (65535 & $uI(thiz.charCodeAt(n)))
});
$c_sci_WrappedString.prototype.scala$collection$IndexedSeqOptimized$$super$init__O = (function() {
  return $f_sc_TraversableLike__init__O(this)
});
$c_sci_WrappedString.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__dropWhile__F1__O(this, p)
});
$c_sci_WrappedString.prototype.forall__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__forall__F1__Z(this, p)
});
$c_sci_WrappedString.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sci_IndexedSeq$()
});
$c_sci_WrappedString.prototype.toString__T = (function() {
  return this.self$4
});
$c_sci_WrappedString.prototype.compareTo__O__I = (function(that) {
  var other = $as_T(that);
  var thiz = this.self$4;
  return ((thiz === other) ? 0 : ($uZ((thiz < other)) ? (-1) : 1))
});
$c_sci_WrappedString.prototype.foreach__F1__V = (function(f) {
  $f_sc_IndexedSeqOptimized__foreach__F1__V(this, f)
});
$c_sci_WrappedString.prototype.foldLeft__O__F2__O = (function(z, op) {
  var start = 0;
  var thiz = this.self$4;
  var end = $uI(thiz.length);
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_sci_WrappedString.prototype.compare__O__I = (function(that) {
  var other = $as_T(that);
  var thiz = this.self$4;
  return ((thiz === other) ? 0 : ($uZ((thiz < other)) ? (-1) : 1))
});
$c_sci_WrappedString.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_IndexedSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_sci_WrappedString.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__takeWhile__F1__O(this, p)
});
$c_sci_WrappedString.prototype.slice__I__I__O = (function(from, until) {
  return this.slice__I__I__sci_WrappedString(from, until)
});
$c_sci_WrappedString.prototype.reverse__O = (function() {
  return $f_sc_IndexedSeqOptimized__reverse__O(this)
});
$c_sci_WrappedString.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_IndexedSeqLike__toBuffer__scm_Buffer(this)
});
$c_sci_WrappedString.prototype.iterator__sc_Iterator = (function() {
  var thiz = this.self$4;
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $uI(thiz.length))
});
$c_sci_WrappedString.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_IndexedSeqOptimized__find__F1__s_Option(this, p)
});
$c_sci_WrappedString.prototype.span__F1__T2 = (function(p) {
  return $f_sc_IndexedSeqOptimized__span__F1__T2(this, p)
});
$c_sci_WrappedString.prototype.mkString__T = (function() {
  return this.self$4
});
$c_sci_WrappedString.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IndexedSeqOptimized__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_sci_WrappedString.prototype.length__I = (function() {
  var thiz = this.self$4;
  return $uI(thiz.length)
});
$c_sci_WrappedString.prototype.scala$collection$IndexedSeqOptimized$$super$last__O = (function() {
  return $f_sc_TraversableLike__last__O(this)
});
$c_sci_WrappedString.prototype.scala$collection$IndexedSeqOptimized$$super$tail__O = (function() {
  return $f_sc_TraversableLike__tail__O(this)
});
$c_sci_WrappedString.prototype.seq__sc_Seq = (function() {
  return this
});
$c_sci_WrappedString.prototype.sizeHintIfCheap__I = (function() {
  var thiz = this.self$4;
  return $uI(thiz.length)
});
$c_sci_WrappedString.prototype.splitAt__I__T2 = (function(n) {
  return $f_sc_IndexedSeqOptimized__splitAt__I__T2(this, n)
});
$c_sci_WrappedString.prototype.take__I__O = (function(n) {
  return this.slice__I__I__sci_WrappedString(0, n)
});
$c_sci_WrappedString.prototype.last__O = (function() {
  return $f_sc_IndexedSeqOptimized__last__O(this)
});
$c_sci_WrappedString.prototype.drop__I__O = (function(n) {
  var thiz = this.self$4;
  var until = $uI(thiz.length);
  return this.slice__I__I__sci_WrappedString(n, until)
});
$c_sci_WrappedString.prototype.tail__O = (function() {
  return $f_sc_IndexedSeqOptimized__tail__O(this)
});
$c_sci_WrappedString.prototype.thisCollection__sc_Seq = (function() {
  return this
});
$c_sci_WrappedString.prototype.toSeq__sc_Seq = (function() {
  return this
});
$c_sci_WrappedString.prototype.isDefinedAt__O__Z = (function(x) {
  var idx = $uI(x);
  return $f_sc_GenSeqLike__isDefinedAt__I__Z(this, idx)
});
$c_sci_WrappedString.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_sc_IndexedSeqOptimized__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_sci_WrappedString.prototype.toSeq__sc_GenSeq = (function() {
  return this
});
$c_sci_WrappedString.prototype.hashCode__I = (function() {
  return $m_s_util_hashing_MurmurHash3$().seqHash__sc_Seq__I(this)
});
$c_sci_WrappedString.prototype.scala$collection$IndexedSeqOptimized$$super$zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_IterableLike__zip__sc_GenIterable__scg_CanBuildFrom__O(this, that, bf)
});
$c_sci_WrappedString.prototype.init___T = (function(self) {
  this.self$4 = self;
  return this
});
$c_sci_WrappedString.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $m_sjsr_RuntimeString$().toCharArray__T__AC(this.self$4)
});
$c_sci_WrappedString.prototype.slice__I__I__sci_WrappedString = (function(from, until) {
  var start = ((from < 0) ? 0 : from);
  if ((until <= start)) {
    var jsx$1 = true
  } else {
    var thiz = this.self$4;
    var jsx$1 = (start >= $uI(thiz.length))
  };
  if (jsx$1) {
    return new $c_sci_WrappedString().init___T("")
  };
  var thiz$1 = this.self$4;
  if ((until > $uI(thiz$1.length))) {
    var thiz$2 = this.self$4;
    var end = $uI(thiz$2.length)
  } else {
    var end = until
  };
  var thiz$3 = $m_s_Predef$().unwrapString__sci_WrappedString__T(this);
  return new $c_sci_WrappedString().init___T($as_T(thiz$3.substring(start, end)))
});
$c_sci_WrappedString.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_IndexedSeqOptimized__reduceLeft__F2__O(this, op)
});
$c_sci_WrappedString.prototype.newBuilder__scm_Builder = (function() {
  return $m_sci_WrappedString$().newBuilder__scm_Builder()
});
var $d_sci_WrappedString = new $TypeData().initClass({
  sci_WrappedString: 0
}, false, "scala.collection.immutable.WrappedString", {
  sci_WrappedString: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sci_IndexedSeq: 1,
  sci_Seq: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  sci_StringLike: 1,
  sc_IndexedSeqOptimized: 1,
  s_math_Ordered: 1,
  jl_Comparable: 1
});
$c_sci_WrappedString.prototype.$classData = $d_sci_WrappedString;
/** @constructor */
function $c_sci_$colon$colon() {
  $c_sci_List.call(this);
  this.head$5 = null;
  this.tl$5 = null
}
$c_sci_$colon$colon.prototype = new $h_sci_List();
$c_sci_$colon$colon.prototype.constructor = $c_sci_$colon$colon;
/** @constructor */
function $h_sci_$colon$colon() {
  /*<skip>*/
}
$h_sci_$colon$colon.prototype = $c_sci_$colon$colon.prototype;
$c_sci_$colon$colon.prototype.productPrefix__T = (function() {
  return "::"
});
$c_sci_$colon$colon.prototype.head__O = (function() {
  return this.head$5
});
$c_sci_$colon$colon.prototype.productArity__I = (function() {
  return 2
});
$c_sci_$colon$colon.prototype.isEmpty__Z = (function() {
  return false
});
$c_sci_$colon$colon.prototype.productElement__I__O = (function(x$1) {
  switch (x$1) {
    case 0: {
      return this.head$5;
      break
    }
    case 1: {
      return this.tl$5;
      break
    }
    default: {
      throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
    }
  }
});
$c_sci_$colon$colon.prototype.tail__O = (function() {
  return this.tl$5
});
$c_sci_$colon$colon.prototype.init___O__sci_List = (function(head, tl) {
  this.head$5 = head;
  this.tl$5 = tl;
  return this
});
$c_sci_$colon$colon.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
function $as_sci_$colon$colon(obj) {
  return (((obj instanceof $c_sci_$colon$colon) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.immutable.$colon$colon"))
}
function $isArrayOf_sci_$colon$colon(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sci_$colon$colon)))
}
function $asArrayOf_sci_$colon$colon(obj, depth) {
  return (($isArrayOf_sci_$colon$colon(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.immutable.$colon$colon;", depth))
}
var $d_sci_$colon$colon = new $TypeData().initClass({
  sci_$colon$colon: 0
}, false, "scala.collection.immutable.$colon$colon", {
  sci_$colon$colon: 1,
  sci_List: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sci_LinearSeq: 1,
  sci_Seq: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sc_LinearSeq: 1,
  sc_LinearSeqLike: 1,
  s_Product: 1,
  sc_LinearSeqOptimized: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_$colon$colon.prototype.$classData = $d_sci_$colon$colon;
/** @constructor */
function $c_sci_Nil$() {
  $c_sci_List.call(this)
}
$c_sci_Nil$.prototype = new $h_sci_List();
$c_sci_Nil$.prototype.constructor = $c_sci_Nil$;
/** @constructor */
function $h_sci_Nil$() {
  /*<skip>*/
}
$h_sci_Nil$.prototype = $c_sci_Nil$.prototype;
$c_sci_Nil$.prototype.productPrefix__T = (function() {
  return "Nil"
});
$c_sci_Nil$.prototype.head__O = (function() {
  this.head__sr_Nothing$()
});
$c_sci_Nil$.prototype.init___ = (function() {
  return this
});
$c_sci_Nil$.prototype.productArity__I = (function() {
  return 0
});
$c_sci_Nil$.prototype.isEmpty__Z = (function() {
  return true
});
$c_sci_Nil$.prototype.tail__sci_List = (function() {
  throw new $c_jl_UnsupportedOperationException().init___T("tail of empty list")
});
$c_sci_Nil$.prototype.equals__O__Z = (function(that) {
  if ($is_sc_GenSeq(that)) {
    var x2 = $as_sc_GenSeq(that);
    return x2.isEmpty__Z()
  } else {
    return false
  }
});
$c_sci_Nil$.prototype.productElement__I__O = (function(x$1) {
  throw new $c_jl_IndexOutOfBoundsException().init___T(("" + x$1))
});
$c_sci_Nil$.prototype.head__sr_Nothing$ = (function() {
  throw new $c_ju_NoSuchElementException().init___T("head of empty list")
});
$c_sci_Nil$.prototype.tail__O = (function() {
  return this.tail__sci_List()
});
$c_sci_Nil$.prototype.productIterator__sc_Iterator = (function() {
  return new $c_sr_ScalaRunTime$$anon$1().init___s_Product(this)
});
var $d_sci_Nil$ = new $TypeData().initClass({
  sci_Nil$: 0
}, false, "scala.collection.immutable.Nil$", {
  sci_Nil$: 1,
  sci_List: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sci_LinearSeq: 1,
  sci_Seq: 1,
  sci_Iterable: 1,
  sci_Traversable: 1,
  s_Immutable: 1,
  sc_LinearSeq: 1,
  sc_LinearSeqLike: 1,
  s_Product: 1,
  sc_LinearSeqOptimized: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sci_Nil$.prototype.$classData = $d_sci_Nil$;
var $n_sci_Nil$ = (void 0);
function $m_sci_Nil$() {
  if ((!$n_sci_Nil$)) {
    $n_sci_Nil$ = new $c_sci_Nil$().init___()
  };
  return $n_sci_Nil$
}
/** @constructor */
function $c_sci_StreamViewLike$$anon$12() {
  $c_O.call(this);
  this.underlying$1 = null;
  this.bitmap$0$1 = false;
  this.$$outer$1 = null
}
$c_sci_StreamViewLike$$anon$12.prototype = new $h_O();
$c_sci_StreamViewLike$$anon$12.prototype.constructor = $c_sci_StreamViewLike$$anon$12;
/** @constructor */
function $h_sci_StreamViewLike$$anon$12() {
  /*<skip>*/
}
$h_sci_StreamViewLike$$anon$12.prototype = $c_sci_StreamViewLike$$anon$12.prototype;
$c_sci_StreamViewLike$$anon$12.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sci_StreamViewLike$$anon$12.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_sci_StreamViewLike$$anon$12.prototype.newSliced__scg_SliceInterval__sc_SeqViewLike$Transformed = (function(_endpoints) {
  return new $c_sci_StreamViewLike$$anon$7().init___sci_StreamViewLike__scg_SliceInterval(this, _endpoints)
});
$c_sci_StreamViewLike$$anon$12.prototype.head__O = (function() {
  return $f_sc_SeqViewLike$Reversed__createReversedIterator__psc_SeqViewLike$Reversed__sc_Iterator(this).next__O()
});
$c_sci_StreamViewLike$$anon$12.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$Reversed__apply__I__O(this, idx)
});
$c_sci_StreamViewLike$$anon$12.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_SeqLike__lengthCompare__I__I(this, len)
});
$c_sci_StreamViewLike$$anon$12.prototype.toIterator__sc_Iterator = (function() {
  return $f_sc_SeqViewLike$Reversed__createReversedIterator__psc_SeqViewLike$Reversed__sc_Iterator(this)
});
$c_sci_StreamViewLike$$anon$12.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IterableLike__sameElements__sc_GenIterable__Z(this, that)
});
$c_sci_StreamViewLike$$anon$12.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$Reversed__apply__I__O(this, idx)
});
$c_sci_StreamViewLike$$anon$12.prototype.flatten__F1__sc_GenTraversable = (function(asTraversable) {
  return new $c_sci_StreamViewLike$$anon$5().init___sci_StreamViewLike__F1(this, asTraversable)
});
$c_sci_StreamViewLike$$anon$12.prototype.exists__F1__Z = (function(p) {
  var this$1 = $f_sc_SeqViewLike$Reversed__createReversedIterator__psc_SeqViewLike$Reversed__sc_Iterator(this);
  return $f_sc_Iterator__exists__F1__Z(this$1, p)
});
$c_sci_StreamViewLike$$anon$12.prototype.toList__sci_List = (function() {
  var this$1 = $m_sci_List$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_sci_List($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sci_StreamViewLike$$anon$12.prototype.isEmpty__Z = (function() {
  return $f_sc_IterableViewLike$Transformed__isEmpty__Z(this)
});
$c_sci_StreamViewLike$$anon$12.prototype.scala$collection$TraversableViewLike$$super$tail__sc_TraversableView = (function() {
  return $as_sc_TraversableView($f_sc_TraversableLike__tail__O(this))
});
$c_sci_StreamViewLike$$anon$12.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sci_StreamViewLike$$anon$12.prototype.runWith__F1__F1 = (function(action) {
  return $f_s_PartialFunction__runWith__F1__F1(this, action)
});
$c_sci_StreamViewLike$$anon$12.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sci_StreamViewLike$$anon$12.prototype.flatMap__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return new $c_sci_StreamViewLike$$anon$5().init___sci_StreamViewLike__F1(this, f)
});
$c_sci_StreamViewLike$$anon$12.prototype.equals__O__Z = (function(that) {
  return $f_sc_GenSeqLike__equals__O__Z(this, that)
});
$c_sci_StreamViewLike$$anon$12.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_TraversableViewLike__dropWhile__F1__sc_TraversableView(this, p)
});
$c_sci_StreamViewLike$$anon$12.prototype.mkString__T__T = (function(sep) {
  return $f_sc_ViewMkString__mkString__T__T__T__T(this, "", sep, "")
});
$c_sci_StreamViewLike$$anon$12.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_ViewMkString__mkString__T__T__T__T(this, start, sep, end)
});
$c_sci_StreamViewLike$$anon$12.prototype.scala$collection$SeqViewLike$Reversed$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$1
});
$c_sci_StreamViewLike$$anon$12.prototype.withFilter__F1__scg_FilterMonadic = (function(p) {
  return $f_sc_TraversableViewLike__withFilter__F1__sc_TraversableView(this, p)
});
$c_sci_StreamViewLike$$anon$12.prototype.forall__F1__Z = (function(p) {
  var this$1 = $f_sc_SeqViewLike$Reversed__createReversedIterator__psc_SeqViewLike$Reversed__sc_Iterator(this);
  return $f_sc_Iterator__forall__F1__Z(this$1, p)
});
$c_sci_StreamViewLike$$anon$12.prototype.$$colon$plus__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqViewLike__$$colon$plus__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_sci_StreamViewLike$$anon$12.prototype.sorted__s_math_Ordering__O = (function(ord) {
  return $f_sc_SeqViewLike__sorted__s_math_Ordering__sc_SeqView(this, ord)
});
$c_sci_StreamViewLike$$anon$12.prototype.toString__T = (function() {
  return $f_sc_TraversableViewLike__viewToString__T(this)
});
$c_sci_StreamViewLike$$anon$12.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sc_Seq$()
});
$c_sci_StreamViewLike$$anon$12.prototype.foreach__F1__V = (function(f) {
  var this$1 = $f_sc_SeqViewLike$Reversed__createReversedIterator__psc_SeqViewLike$Reversed__sc_Iterator(this);
  $f_sc_Iterator__foreach__F1__V(this$1, f)
});
$c_sci_StreamViewLike$$anon$12.prototype.foldLeft__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_sci_StreamViewLike$$anon$12.prototype.scala$collection$TraversableViewLike$Transformed$$$outer__sc_TraversableViewLike = (function() {
  return this.$$outer$1
});
$c_sci_StreamViewLike$$anon$12.prototype.viewIdString__T = (function() {
  return $f_sc_TraversableViewLike$Transformed__viewIdString__T(this)
});
$c_sci_StreamViewLike$$anon$12.prototype.newPrepended__sc_GenTraversable__sc_SeqViewLike$Transformed = (function(that) {
  return new $c_sci_StreamViewLike$$anon$3().init___sci_StreamViewLike__sc_GenTraversable(this, that)
});
$c_sci_StreamViewLike$$anon$12.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_SeqLike__indexWhere__F1__I__I(this, p, from)
});
$c_sci_StreamViewLike$$anon$12.prototype.union__sc_GenSeq__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_SeqViewLike__union__sc_GenSeq__scg_CanBuildFrom__O(this, that, bf)
});
$c_sci_StreamViewLike$$anon$12.prototype.headOption__s_Option = (function() {
  return $f_sc_TraversableViewLike$Transformed__headOption__s_Option(this)
});
$c_sci_StreamViewLike$$anon$12.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_TraversableViewLike__takeWhile__F1__sc_TraversableView(this, p)
});
$c_sci_StreamViewLike$$anon$12.prototype.intersect__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqViewLike__intersect__sc_GenSeq__sc_SeqView(this, that)
});
$c_sci_StreamViewLike$$anon$12.prototype.init___sci_StreamViewLike = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_sci_StreamViewLike$$anon$12.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sci_StreamViewLike$$anon$12.prototype.filter__F1__O = (function(p) {
  return $f_sc_TraversableViewLike__filter__F1__sc_TraversableView(this, p)
});
$c_sci_StreamViewLike$$anon$12.prototype.reverse__O = (function() {
  return new $c_sci_StreamViewLike$$anon$12().init___sci_StreamViewLike(this)
});
$c_sci_StreamViewLike$$anon$12.prototype.size__I = (function() {
  return this.$$outer$1.length__I()
});
$c_sci_StreamViewLike$$anon$12.prototype.toBuffer__scm_Buffer = (function() {
  var this$1 = $m_scm_ArrayBuffer$();
  var cbf = this$1.ReusableCBFInstance$2;
  return $as_scm_Buffer($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sci_StreamViewLike$$anon$12.prototype.distinct__O = (function() {
  return $f_sc_SeqViewLike__distinct__sc_SeqView(this)
});
$c_sci_StreamViewLike$$anon$12.prototype.$$plus$colon__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqViewLike__$$plus$colon__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_sci_StreamViewLike$$anon$12.prototype.apply$mcZI$sp__I__Z = (function(v1) {
  return $uZ($f_sc_SeqViewLike$Reversed__apply__I__O(this, v1))
});
$c_sci_StreamViewLike$$anon$12.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_SeqViewLike$Reversed__createReversedIterator__psc_SeqViewLike$Reversed__sc_Iterator(this)
});
$c_sci_StreamViewLike$$anon$12.prototype.find__F1__s_Option = (function(p) {
  var this$1 = $f_sc_SeqViewLike$Reversed__createReversedIterator__psc_SeqViewLike$Reversed__sc_Iterator(this);
  return $f_sc_Iterator__find__F1__s_Option(this$1, p)
});
$c_sci_StreamViewLike$$anon$12.prototype.span__F1__T2 = (function(p) {
  return $f_sc_TraversableViewLike__span__F1__T2(this, p)
});
$c_sci_StreamViewLike$$anon$12.prototype.diff__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqViewLike__diff__sc_GenSeq__sc_SeqView(this, that)
});
$c_sci_StreamViewLike$$anon$12.prototype.viewIdentifier__T = (function() {
  return "R"
});
$c_sci_StreamViewLike$$anon$12.prototype.mkString__T = (function() {
  return $f_sc_ViewMkString__mkString__T__T__T__T(this, "", "", "")
});
$c_sci_StreamViewLike$$anon$12.prototype.newAppended__sc_GenTraversable__sc_TraversableViewLike$Transformed = (function(that) {
  return new $c_sci_StreamViewLike$$anon$2().init___sci_StreamViewLike__sc_GenTraversable(this, that)
});
$c_sci_StreamViewLike$$anon$12.prototype.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O = (function(xs, bf) {
  return $f_sc_TraversableViewLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, xs, bf)
});
$c_sci_StreamViewLike$$anon$12.prototype.length__I = (function() {
  return this.$$outer$1.length__I()
});
$c_sci_StreamViewLike$$anon$12.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IterableViewLike__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_sci_StreamViewLike$$anon$12.prototype.seq__sc_Seq = (function() {
  return this
});
$c_sci_StreamViewLike$$anon$12.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_TraversableViewLike__filterNot__F1__sc_TraversableView(this, p)
});
$c_sci_StreamViewLike$$anon$12.prototype.sizeHintIfCheap__I = (function() {
  return (-1)
});
$c_sci_StreamViewLike$$anon$12.prototype.partition__F1__T2 = (function(p) {
  return $f_sc_TraversableViewLike__partition__F1__T2(this, p)
});
$c_sci_StreamViewLike$$anon$12.prototype.newTakenWhile__F1__sc_TraversableViewLike$Transformed = (function(p) {
  return new $c_sci_StreamViewLike$$anon$9().init___sci_StreamViewLike__F1(this, p)
});
$c_sci_StreamViewLike$$anon$12.prototype.take__I__O = (function(n) {
  return $f_sc_IterableViewLike__take__I__sc_IterableView(this, n)
});
$c_sci_StreamViewLike$$anon$12.prototype.toStream__sci_Stream = (function() {
  return $f_sc_SeqViewLike$Reversed__createReversedIterator__psc_SeqViewLike$Reversed__sc_Iterator(this).toStream__sci_Stream()
});
$c_sci_StreamViewLike$$anon$12.prototype.view__sc_SeqView = (function() {
  return new $c_sc_SeqLike$$anon$2().init___sc_SeqLike(this)
});
$c_sci_StreamViewLike$$anon$12.prototype.last__O = (function() {
  return $f_sc_TraversableViewLike$Transformed__last__O(this)
});
$c_sci_StreamViewLike$$anon$12.prototype.drop__I__O = (function(n) {
  return $f_sc_IterableViewLike__drop__I__sc_IterableView(this, n)
});
$c_sci_StreamViewLike$$anon$12.prototype.newMapped__F1__sc_TraversableViewLike$Transformed = (function(f) {
  return new $c_sci_StreamViewLike$$anon$4().init___sci_StreamViewLike__F1(this, f)
});
$c_sci_StreamViewLike$$anon$12.prototype.contains__O__Z = (function(elem) {
  return $f_sc_SeqLike__contains__O__Z(this, elem)
});
$c_sci_StreamViewLike$$anon$12.prototype.thisCollection__sc_Seq = (function() {
  return this
});
$c_sci_StreamViewLike$$anon$12.prototype.tail__O = (function() {
  return $f_sc_TraversableViewLike__tail__sc_TraversableView(this)
});
$c_sci_StreamViewLike$$anon$12.prototype.toTraversable__sc_Traversable = (function() {
  return this
});
$c_sci_StreamViewLike$$anon$12.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_ViewMkString__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_sci_StreamViewLike$$anon$12.prototype.sortBy__F1__s_math_Ordering__O = (function(f, ord) {
  return $f_sc_SeqViewLike__sortBy__F1__s_math_Ordering__sc_SeqView(this, f, ord)
});
$c_sci_StreamViewLike$$anon$12.prototype.toSeq__sc_Seq = (function() {
  return this
});
$c_sci_StreamViewLike$$anon$12.prototype.filter__F1__sc_TraversableView = (function(p) {
  return $f_sc_TraversableViewLike__filter__F1__sc_TraversableView(this, p)
});
$c_sci_StreamViewLike$$anon$12.prototype.isDefinedAt__O__Z = (function(x) {
  var idx = $uI(x);
  return $f_sc_GenSeqLike__isDefinedAt__I__Z(this, idx)
});
$c_sci_StreamViewLike$$anon$12.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_sci_StreamViewLike$$anon$12.prototype.repr__O = (function() {
  return this
});
$c_sci_StreamViewLike$$anon$12.prototype.$$div$colon__O__F2__O = (function(z, op) {
  return $f_sc_TraversableOnce__foldLeft__O__F2__O(this, z, op)
});
$c_sci_StreamViewLike$$anon$12.prototype.newForced__F0__sc_SeqViewLike$Transformed = (function(xs) {
  return new $c_sci_StreamViewLike$$anon$1().init___sci_StreamViewLike__F0(this, xs)
});
$c_sci_StreamViewLike$$anon$12.prototype.newSliced__scg_SliceInterval__sc_TraversableViewLike$Transformed = (function(_endpoints) {
  return new $c_sci_StreamViewLike$$anon$7().init___sci_StreamViewLike__scg_SliceInterval(this, _endpoints)
});
$c_sci_StreamViewLike$$anon$12.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return $f_s_PartialFunction__applyOrElse__O__F1__O(this, x, $default)
});
$c_sci_StreamViewLike$$anon$12.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_sc_IterableLike__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_sci_StreamViewLike$$anon$12.prototype.isTraversableAgain__Z = (function() {
  return true
});
$c_sci_StreamViewLike$$anon$12.prototype.toSeq__sc_GenSeq = (function() {
  return this
});
$c_sci_StreamViewLike$$anon$12.prototype.hashCode__I = (function() {
  return $m_s_util_hashing_MurmurHash3$().seqHash__sc_Seq__I(this)
});
$c_sci_StreamViewLike$$anon$12.prototype.groupBy__F1__sci_Map = (function(f) {
  return $f_sc_TraversableViewLike__groupBy__F1__sci_Map(this, f)
});
$c_sci_StreamViewLike$$anon$12.prototype.newFiltered__F1__sc_TraversableViewLike$Transformed = (function(p) {
  return new $c_sci_StreamViewLike$$anon$6().init___sci_StreamViewLike__F1(this, p)
});
$c_sci_StreamViewLike$$anon$12.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var this$2 = $f_sc_SeqViewLike$Reversed__createReversedIterator__psc_SeqViewLike$Reversed__sc_Iterator(this);
  while (this$2.hasNext__Z()) {
    var arg1 = this$2.next__O();
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1))
  };
  return $as_sci_Map(b.elems$1)
});
$c_sci_StreamViewLike$$anon$12.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return new $c_sci_StreamViewLike$$anon$4().init___sci_StreamViewLike__F1(this, f)
});
$c_sci_StreamViewLike$$anon$12.prototype.segmentLength__F1__I__I = (function(p, from) {
  return $f_sc_SeqLike__segmentLength__F1__I__I(this, p, from)
});
$c_sci_StreamViewLike$$anon$12.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_sc_TraversableOnce__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_sci_StreamViewLike$$anon$12.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_sci_StreamViewLike$$anon$12.prototype.newDroppedWhile__F1__sc_TraversableViewLike$Transformed = (function(p) {
  return new $c_sci_StreamViewLike$$anon$8().init___sci_StreamViewLike__F1(this, p)
});
$c_sci_StreamViewLike$$anon$12.prototype.collect__s_PartialFunction__scg_CanBuildFrom__O = (function(pf, bf) {
  return $f_sc_TraversableViewLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this, pf, bf)
});
$c_sci_StreamViewLike$$anon$12.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_TraversableOnce__reduceLeft__F2__O(this, op)
});
$c_sci_StreamViewLike$$anon$12.prototype.newBuilder__scm_Builder = (function() {
  return $f_sc_TraversableViewLike__newBuilder__scm_Builder(this)
});
$c_sci_StreamViewLike$$anon$12.prototype.newForced__F0__sc_TraversableViewLike$Transformed = (function(xs) {
  return new $c_sci_StreamViewLike$$anon$1().init___sci_StreamViewLike__F0(this, xs)
});
$c_sci_StreamViewLike$$anon$12.prototype.stringPrefix__T = (function() {
  return "StreamView"
});
$c_sci_StreamViewLike$$anon$12.prototype.sortWith__F2__O = (function(lt) {
  return $f_sc_SeqViewLike__sortWith__F2__sc_SeqView(this, lt)
});
$c_sci_StreamViewLike$$anon$12.prototype.zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return new $c_sci_StreamViewLike$$anon$10().init___sci_StreamViewLike__sc_GenIterable(this, that)
});
var $d_sci_StreamViewLike$$anon$12 = new $TypeData().initClass({
  sci_StreamViewLike$$anon$12: 0
}, false, "scala.collection.immutable.StreamViewLike$$anon$12", {
  sci_StreamViewLike$$anon$12: 1,
  O: 1,
  sci_StreamViewLike$Reversed: 1,
  sc_SeqViewLike$Reversed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_TraversableViewLike$Transformed: 1,
  sci_StreamViewLike$Transformed: 1,
  sci_StreamView: 1,
  sci_StreamViewLike: 1
});
$c_sci_StreamViewLike$$anon$12.prototype.$classData = $d_sci_StreamViewLike$$anon$12;
/** @constructor */
function $c_scm_AbstractMap() {
  $c_sc_AbstractMap.call(this)
}
$c_scm_AbstractMap.prototype = new $h_sc_AbstractMap();
$c_scm_AbstractMap.prototype.constructor = $c_scm_AbstractMap;
/** @constructor */
function $h_scm_AbstractMap() {
  /*<skip>*/
}
$h_scm_AbstractMap.prototype = $c_scm_AbstractMap.prototype;
$c_scm_AbstractMap.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_scm_AbstractMap.prototype.put__O__O__s_Option = (function(key, value) {
  return $f_scm_MapLike__put__O__O__s_Option(this, key, value)
});
$c_scm_AbstractMap.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_scm_AbstractMap.prototype.remove__O__s_Option = (function(key) {
  return $f_scm_MapLike__remove__O__s_Option(this, key)
});
$c_scm_AbstractMap.prototype.companion__scg_GenericCompanion = (function() {
  return $m_scm_Iterable$()
});
$c_scm_AbstractMap.prototype.$$plus__T2__scm_Map = (function(kv) {
  return $as_scm_Map($as_scm_Map($as_scg_Growable(this.empty__sc_Map()).$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this)).$$plus$eq__T2__scm_MapLike(kv))
});
$c_scm_AbstractMap.prototype.update__O__O__V = (function(key, value) {
  $f_scm_MapLike__update__O__O__V(this, key, value)
});
$c_scm_AbstractMap.prototype.withDefaultValue__O__scm_Map = (function(d) {
  return $f_scm_Map__withDefaultValue__O__scm_Map(this, d)
});
$c_scm_AbstractMap.prototype.sizeHintBounded__I__sc_TraversableLike__V = (function(size, boundingColl) {
  $f_scm_Builder__sizeHintBounded__I__sc_TraversableLike__V(this, size, boundingColl)
});
$c_scm_AbstractMap.prototype.updated__O__O__scm_Map = (function(key, value) {
  return $f_scm_MapLike__updated__O__O__scm_Map(this, key, value)
});
$c_scm_AbstractMap.prototype.getOrElseUpdate__O__F0__O = (function(key, op) {
  return $f_scm_MapLike__getOrElseUpdate__O__F0__O(this, key, op)
});
$c_scm_AbstractMap.prototype.toSeq__sc_Seq = (function() {
  return $f_scm_MapLike__toSeq__sc_Seq(this)
});
$c_scm_AbstractMap.prototype.sizeHint__I__V = (function(size) {
  /*<skip>*/
});
$c_scm_AbstractMap.prototype.$$minus__O__scm_Map = (function(key) {
  return $as_scm_Map($as_scm_Map($as_scg_Growable(this.empty__sc_Map()).$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this)).$$minus$eq__O__scm_MapLike(key))
});
$c_scm_AbstractMap.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs)
});
$c_scm_AbstractMap.prototype.newBuilder__scm_Builder = (function() {
  return $as_scm_Builder(this.empty__sc_Map())
});
/** @constructor */
function $c_Lamf_client_convert_VocabulariesClientConverter$() {
  $c_O.call(this);
  this.ClassTermMappingConverter$module$1 = null;
  this.ObjectPropertyMappingConverter$module$1 = null;
  this.DatatypePropertyMappingConverter$module$1 = null;
  this.DialectDomainElementConvertej$module$1 = null;
  this.NodeMappingConverter$module$1 = null;
  this.ExternalConverter$module$1 = null;
  this.VocabularyReferenceConverter$module$1 = null;
  this.DocumentMappingConverter$module$1 = null;
  this.DocumentModelConverter$module$1 = null;
  this.DialectConverter$module$1 = null;
  this.PublicNodeMappingConverter$module$1 = null;
  this.PropertyMappingConverter$module$1 = null;
  this.StringMatcher$module$1 = null;
  this.BooleanMatcher$module$1 = null;
  this.IntMatcher$module$1 = null;
  this.DoubleMatcher$module$1 = null;
  this.FloatMatcher$module$1 = null;
  this.AnyMatcher$module$1 = null;
  this.UnitMatcher$module$1 = null;
  this.ProfileNameMatcher$module$1 = null;
  this.VendorMatcher$module$1 = null;
  this.ContentMatcher$module$1 = null;
  this.ReferenceResolverMatcher$module$1 = null;
  this.CachedReferenceMatcher$module$1 = null;
  this.PayloadFragmentMatcher$module$1 = null;
  this.ValidationShapeSetMatcher$module$1 = null;
  this.ValidationCandidateMatcher$module$1 = null;
  this.GraphDomainConverter$module$1 = null;
  this.ResourceLoaderMatcher$module$1 = null;
  this.BaseUnitMatcher$module$1 = null;
  this.DomainElementMatcher$module$1 = null;
  this.ValidationReportMatcher$module$1 = null;
  this.ValidationResultMatcher$module$1 = null;
  this.VariableValueMatcher$module$1 = null;
  this.AbstractDeclarationMatcher$module$1 = null;
  this.ParameterizedDeclarationMatcher$module$1 = null;
  this.DomainExtensionMatcher$module$1 = null;
  this.ObjectNodeMatcher$module$1 = null;
  this.ScalarNodeMatcher$module$1 = null;
  this.ArrayNodeMatcher$module$1 = null;
  this.DataNodeMatcher$module$1 = null;
  this.ShapeExtensionMatcher$module$1 = null;
  this.PropertyShapeMatcher$module$1 = null;
  this.ShapeMatcher$module$1 = null;
  this.CustomDomainPropertyMatcher$module$1 = null;
  this.StrFieldMatcher$module$1 = null;
  this.IntFieldMatcher$module$1 = null;
  this.BoolFieldMatcher$module$1 = null;
  this.DoubleFieldMatcher$module$1 = null;
  this.FloatFieldMatcher$module$1 = null;
  this.AnyFieldMatcher$module$1 = null;
  this.AnnotationsFieldMatcher$module$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype = new $h_O();
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.constructor = $c_Lamf_client_convert_VocabulariesClientConverter$;
/** @constructor */
function $h_Lamf_client_convert_VocabulariesClientConverter$() {
  /*<skip>*/
}
$h_Lamf_client_convert_VocabulariesClientConverter$.prototype = $c_Lamf_client_convert_VocabulariesClientConverter$.prototype;
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.DocumentModelConverter$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().DocumentModelConverter$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().DocumentModelConverter$module$1 = new $c_Lamf_client_convert_DocumentsModelConverter$DocumentModelConverter$().init___Lamf_client_convert_DocumentsModelConverter(this)
  }
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.PropertyMappingConverter$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().PropertyMappingConverter$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().PropertyMappingConverter$module$1 = new $c_Lamf_client_convert_PropertyMappingConverter$PropertyMappingConverter$().init___Lamf_client_convert_PropertyMappingConverter(this)
  }
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.DocumentModelConverter__Lamf_client_convert_DocumentsModelConverter$DocumentModelConverter$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().DocumentModelConverter$module$1 === null)) {
    this.DocumentModelConverter$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().DocumentModelConverter$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.ClassTermMappingConverter__Lamf_client_convert_ClassTermMappingConverter$ClassTermMappingConverter$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().ClassTermMappingConverter$module$1 === null)) {
    this.ClassTermMappingConverter$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().ClassTermMappingConverter$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.init___ = (function() {
  $n_Lamf_client_convert_VocabulariesClientConverter$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.PublicNodeMappingConverter$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().PublicNodeMappingConverter$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().PublicNodeMappingConverter$module$1 = new $c_Lamf_client_convert_PublicNodeMappingConverter$PublicNodeMappingConverter$().init___Lamf_client_convert_PublicNodeMappingConverter(this)
  }
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.ObjectNodeMatcher__Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().ObjectNodeMatcher$module$1 === null)) {
    this.ObjectNodeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().ObjectNodeMatcher$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.ScalarNodeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().ScalarNodeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().ScalarNodeMatcher$module$1 = new $c_Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$().init___Lamf_client_convert_DataNodeConverter(this)
  }
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher$module$1 === null)) {
    this.StrFieldMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.AnyFieldMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().AnyFieldMatcher$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().AnyFieldMatcher$module$1 = new $c_Lamf_client_convert_FieldConverter$AnyFieldMatcher$().init___Lamf_client_convert_FieldConverter(this)
  }
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.BoolFieldMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().BoolFieldMatcher$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().BoolFieldMatcher$module$1 = new $c_Lamf_client_convert_FieldConverter$BoolFieldMatcher$().init___Lamf_client_convert_FieldConverter(this)
  }
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.AnyMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().AnyMatcher$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().AnyMatcher$module$1 = new $c_Lamf_client_convert_CoreBaseConverter$AnyMatcher$().init___Lamf_client_convert_CoreBaseConverter(this)
  }
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.AnyMatcher__Lamf_client_convert_CoreBaseConverter$AnyMatcher$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().AnyMatcher$module$1 === null)) {
    this.AnyMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().AnyMatcher$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().StringMatcher$module$1 === null)) {
    this.StringMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().StringMatcher$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.DatatypePropertyMappingConverter$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().DatatypePropertyMappingConverter$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().DatatypePropertyMappingConverter$module$1 = new $c_Lamf_client_convert_DatatypePropertyMappingConverter$DatatypePropertyMappingConverter$().init___Lamf_client_convert_DatatypePropertyMappingConverter(this)
  }
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.DoubleFieldMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().DoubleFieldMatcher$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().DoubleFieldMatcher$module$1 = new $c_Lamf_client_convert_FieldConverter$DoubleFieldMatcher$().init___Lamf_client_convert_FieldConverter(this)
  }
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.NodeMappingConverter__Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().NodeMappingConverter$module$1 === null)) {
    this.NodeMappingConverter$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().NodeMappingConverter$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.DocumentMappingConverter__Lamf_client_convert_DocumentMappingConverter$DocumentMappingConverter$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().DocumentMappingConverter$module$1 === null)) {
    this.DocumentMappingConverter$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().DocumentMappingConverter$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.StringMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().StringMatcher$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().StringMatcher$module$1 = new $c_Lamf_client_convert_CoreBaseConverter$StringMatcher$().init___Lamf_client_convert_CoreBaseConverter(this)
  }
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.ExternalConverter$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().ExternalConverter$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().ExternalConverter$module$1 = new $c_Lamf_client_convert_ExternalConverter$ExternalConverter$().init___Lamf_client_convert_ExternalConverter(this)
  }
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.ArrayNodeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().ArrayNodeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().ArrayNodeMatcher$module$1 = new $c_Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$().init___Lamf_client_convert_DataNodeConverter(this)
  }
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.ClassTermMappingConverter$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().ClassTermMappingConverter$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().ClassTermMappingConverter$module$1 = new $c_Lamf_client_convert_ClassTermMappingConverter$ClassTermMappingConverter$().init___Lamf_client_convert_ClassTermMappingConverter(this)
  }
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.AnyFieldMatcher__Lamf_client_convert_FieldConverter$AnyFieldMatcher$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().AnyFieldMatcher$module$1 === null)) {
    this.AnyFieldMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().AnyFieldMatcher$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.DatatypePropertyMappingConverter__Lamf_client_convert_DatatypePropertyMappingConverter$DatatypePropertyMappingConverter$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().DatatypePropertyMappingConverter$module$1 === null)) {
    this.DatatypePropertyMappingConverter$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().DatatypePropertyMappingConverter$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.ObjectNodeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().ObjectNodeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().ObjectNodeMatcher$module$1 = new $c_Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$().init___Lamf_client_convert_DataNodeConverter(this)
  }
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.IntFieldMatcher__Lamf_client_convert_FieldConverter$IntFieldMatcher$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().IntFieldMatcher$module$1 === null)) {
    this.IntFieldMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().IntFieldMatcher$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.StrFieldMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().StrFieldMatcher$module$1 = new $c_Lamf_client_convert_FieldConverter$StrFieldMatcher$().init___Lamf_client_convert_FieldConverter(this)
  }
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.NodeMappingConverter$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().NodeMappingConverter$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().NodeMappingConverter$module$1 = new $c_Lamf_client_convert_NodeMappingConverter$NodeMappingConverter$().init___Lamf_client_convert_NodeMappingConverter(this)
  }
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.VocabularyReferenceConverter__Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().VocabularyReferenceConverter$module$1 === null)) {
    this.VocabularyReferenceConverter$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().VocabularyReferenceConverter$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.ExternalConverter__Lamf_client_convert_ExternalConverter$ExternalConverter$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().ExternalConverter$module$1 === null)) {
    this.ExternalConverter$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().ExternalConverter$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.DialectDomainElementConvertej$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().DialectDomainElementConvertej$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().DialectDomainElementConvertej$module$1 = new $c_Lamf_client_convert_DialectDomainElementConverter$DialectDomainElementConvertej$().init___Lamf_client_convert_DialectDomainElementConverter(this)
  }
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.DialectConverter$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().DialectConverter$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().DialectConverter$module$1 = new $c_Lamf_client_convert_DialectConverter$DialectConverter$().init___Lamf_client_convert_DialectConverter(this)
  }
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().BoolFieldMatcher$module$1 === null)) {
    this.BoolFieldMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().BoolFieldMatcher$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.ObjectPropertyMappingConverter__Lamf_client_convert_ObjectPropertyMappingConverter$ObjectPropertyMappingConverter$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().ObjectPropertyMappingConverter$module$1 === null)) {
    this.ObjectPropertyMappingConverter$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().ObjectPropertyMappingConverter$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.DocumentMappingConverter$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().DocumentMappingConverter$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().DocumentMappingConverter$module$1 = new $c_Lamf_client_convert_DocumentMappingConverter$DocumentMappingConverter$().init___Lamf_client_convert_DocumentMappingConverter(this)
  }
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.PublicNodeMappingConverter__Lamf_client_convert_PublicNodeMappingConverter$PublicNodeMappingConverter$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().PublicNodeMappingConverter$module$1 === null)) {
    this.PublicNodeMappingConverter$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().PublicNodeMappingConverter$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.DoubleFieldMatcher__Lamf_client_convert_FieldConverter$DoubleFieldMatcher$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().DoubleFieldMatcher$module$1 === null)) {
    this.DoubleFieldMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().DoubleFieldMatcher$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.PropertyMappingConverter__Lamf_client_convert_PropertyMappingConverter$PropertyMappingConverter$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().PropertyMappingConverter$module$1 === null)) {
    this.PropertyMappingConverter$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().PropertyMappingConverter$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.ArrayNodeMatcher__Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().ArrayNodeMatcher$module$1 === null)) {
    this.ArrayNodeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().ArrayNodeMatcher$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.DialectDomainElementConvertej__Lamf_client_convert_DialectDomainElementConverter$DialectDomainElementConvertej$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().DialectDomainElementConvertej$module$1 === null)) {
    this.DialectDomainElementConvertej$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().DialectDomainElementConvertej$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.ScalarNodeMatcher__Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().ScalarNodeMatcher$module$1 === null)) {
    this.ScalarNodeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().ScalarNodeMatcher$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.DialectConverter__Lamf_client_convert_DialectConverter$DialectConverter$ = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().DialectConverter$module$1 === null)) {
    this.DialectConverter$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_VocabulariesClientConverter$().DialectConverter$module$1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.VocabularyReferenceConverter$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().VocabularyReferenceConverter$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().VocabularyReferenceConverter$module$1 = new $c_Lamf_client_convert_VocabularyReferenceConverter$VocabularyReferenceConverter$().init___Lamf_client_convert_VocabularyReferenceConverter(this)
  }
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.IntFieldMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().IntFieldMatcher$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().IntFieldMatcher$module$1 = new $c_Lamf_client_convert_FieldConverter$IntFieldMatcher$().init___Lamf_client_convert_FieldConverter(this)
  }
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.ObjectPropertyMappingConverter$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_VocabulariesClientConverter$().ObjectPropertyMappingConverter$module$1 === null)) {
    $m_Lamf_client_convert_VocabulariesClientConverter$().ObjectPropertyMappingConverter$module$1 = new $c_Lamf_client_convert_ObjectPropertyMappingConverter$ObjectPropertyMappingConverter$().init___Lamf_client_convert_ObjectPropertyMappingConverter(this)
  }
});
var $d_Lamf_client_convert_VocabulariesClientConverter$ = new $TypeData().initClass({
  Lamf_client_convert_VocabulariesClientConverter$: 0
}, false, "amf.client.convert.VocabulariesClientConverter$", {
  Lamf_client_convert_VocabulariesClientConverter$: 1,
  O: 1,
  Lamf_client_convert_VocabulariesBaseConverter: 1,
  Lamf_client_convert_CoreBaseConverter: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_convert_CollectionConverter: 1,
  Lamf_client_convert_FutureConverter: 1,
  Lamf_client_convert_FieldConverter: 1,
  Lamf_client_convert_CustomDomainPropertyConverter: 1,
  Lamf_client_convert_ShapeConverter: 1,
  Lamf_client_convert_PropertyShapeConverter: 1,
  Lamf_client_convert_ShapeExtensionConverter: 1,
  Lamf_client_convert_DataNodeConverter: 1,
  Lamf_client_convert_DomainExtensionConverter: 1,
  Lamf_client_convert_DeclarationsConverter: 1,
  Lamf_client_convert_VariableValueConverter: 1,
  Lamf_client_convert_ValidationConverter: 1,
  Lamf_client_convert_DomainElementConverter: 1,
  Lamf_client_convert_BaseUnitConverter: 1,
  Lamf_client_convert_ResourceLoaderConverter: 1,
  Lamf_client_convert_GraphDomainConverter: 1,
  Lamf_client_convert_ValidationCandidateConverter: 1,
  Lamf_client_convert_ValidationShapeSetConverter: 1,
  Lamf_client_convert_PayloadFragmentConverter: 1,
  Lamf_client_convert_CachedReferenceConverter: 1,
  Lamf_client_convert_ReferenceResolverConverter: 1,
  Lamf_client_convert_PropertyMappingConverter: 1,
  Lamf_client_convert_PublicNodeMappingConverter: 1,
  Lamf_client_convert_DialectConverter: 1,
  Lamf_client_convert_DocumentsModelConverter: 1,
  Lamf_client_convert_DocumentMappingConverter: 1,
  Lamf_client_convert_VocabularyReferenceConverter: 1,
  Lamf_client_convert_ExternalConverter: 1,
  Lamf_client_convert_NodeMappingConverter: 1,
  Lamf_client_convert_DialectDomainElementConverter: 1,
  Lamf_client_convert_DatatypePropertyMappingConverter: 1,
  Lamf_client_convert_ObjectPropertyMappingConverter: 1,
  Lamf_client_convert_ClassTermMappingConverter: 1,
  Lamf_client_convert_VocabulariesBaseClientConverter: 1,
  Lamf_client_convert_CoreBaseClientConverter: 1
});
$c_Lamf_client_convert_VocabulariesClientConverter$.prototype.$classData = $d_Lamf_client_convert_VocabulariesClientConverter$;
var $n_Lamf_client_convert_VocabulariesClientConverter$ = (void 0);
function $m_Lamf_client_convert_VocabulariesClientConverter$() {
  if ((!$n_Lamf_client_convert_VocabulariesClientConverter$)) {
    $n_Lamf_client_convert_VocabulariesClientConverter$ = new $c_Lamf_client_convert_VocabulariesClientConverter$().init___()
  };
  return $n_Lamf_client_convert_VocabulariesClientConverter$
}
/** @constructor */
function $c_scm_AbstractSet() {
  $c_scm_AbstractIterable.call(this)
}
$c_scm_AbstractSet.prototype = new $h_scm_AbstractIterable();
$c_scm_AbstractSet.prototype.constructor = $c_scm_AbstractSet;
/** @constructor */
function $h_scm_AbstractSet() {
  /*<skip>*/
}
$h_scm_AbstractSet.prototype = $c_scm_AbstractSet.prototype;
$c_scm_AbstractSet.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_scm_AbstractSet.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_scm_AbstractSet.prototype.isEmpty__Z = (function() {
  return $f_sc_SetLike__isEmpty__Z(this)
});
$c_scm_AbstractSet.prototype.equals__O__Z = (function(that) {
  return $f_sc_GenSetLike__equals__O__Z(this, that)
});
$c_scm_AbstractSet.prototype.toString__T = (function() {
  return $f_sc_TraversableLike__toString__T(this)
});
$c_scm_AbstractSet.prototype.subsetOf__sc_GenSet__Z = (function(that) {
  var this$1 = this.iterator__sc_Iterator();
  return $f_sc_Iterator__forall__F1__Z(this$1, that)
});
$c_scm_AbstractSet.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_SetLike__toBuffer__scm_Buffer(this)
});
$c_scm_AbstractSet.prototype.apply$mcZI$sp__I__Z = (function(v1) {
  return this.contains__O__Z(v1)
});
$c_scm_AbstractSet.prototype.sizeHintBounded__I__sc_TraversableLike__V = (function(size, boundingColl) {
  $f_scm_Builder__sizeHintBounded__I__sc_TraversableLike__V(this, size, boundingColl)
});
$c_scm_AbstractSet.prototype.toSeq__sc_Seq = (function() {
  return $f_scm_SetLike__toSeq__sc_Seq(this)
});
$c_scm_AbstractSet.prototype.hashCode__I = (function() {
  var this$1 = $m_s_util_hashing_MurmurHash3$();
  return this$1.unorderedHash__sc_TraversableOnce__I__I(this, this$1.setSeed$2)
});
$c_scm_AbstractSet.prototype.sizeHint__I__V = (function(size) {
  /*<skip>*/
});
$c_scm_AbstractSet.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return $f_sc_TraversableLike__map__F1__scg_CanBuildFrom__O(this, f, bf)
});
$c_scm_AbstractSet.prototype.intersect__sc_GenSet__O = (function(that) {
  return $f_sc_TraversableLike__filterImpl__F1__Z__O(this, that, false)
});
$c_scm_AbstractSet.prototype.newBuilder__scm_Builder = (function() {
  return $as_scm_Builder(this.empty__sc_Set())
});
$c_scm_AbstractSet.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs)
});
$c_scm_AbstractSet.prototype.stringPrefix__T = (function() {
  return "Set"
});
/** @constructor */
function $c_sci_StreamViewLike$$anon$10() {
  $c_sci_StreamViewLike$AbstractTransformed.call(this);
  this.other$3 = null;
  this.thatSeq$3 = null;
  this.bitmap$0$3 = false;
  this.$$outer$3 = null
}
$c_sci_StreamViewLike$$anon$10.prototype = new $h_sci_StreamViewLike$AbstractTransformed();
$c_sci_StreamViewLike$$anon$10.prototype.constructor = $c_sci_StreamViewLike$$anon$10;
/** @constructor */
function $h_sci_StreamViewLike$$anon$10() {
  /*<skip>*/
}
$h_sci_StreamViewLike$$anon$10.prototype = $c_sci_StreamViewLike$$anon$10.prototype;
$c_sci_StreamViewLike$$anon$10.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$Zipped__apply__I__T2(this, idx)
});
$c_sci_StreamViewLike$$anon$10.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$Zipped__apply__I__T2(this, idx)
});
$c_sci_StreamViewLike$$anon$10.prototype.init___sci_StreamViewLike__sc_GenIterable = (function($$outer, that$3) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$3 = $$outer
  };
  this.other$3 = that$3;
  $c_sci_StreamViewLike$AbstractTransformed.prototype.init___sci_StreamViewLike.call(this, $$outer);
  return this
});
$c_sci_StreamViewLike$$anon$10.prototype.other__sc_GenIterable = (function() {
  return this.other$3
});
$c_sci_StreamViewLike$$anon$10.prototype.thatSeq$lzycompute__p3__sc_Seq = (function() {
  if ((!this.bitmap$0$3)) {
    this.thatSeq$3 = $f_sc_SeqViewLike$Zipped__thatSeq__sc_Seq(this);
    this.bitmap$0$3 = true
  };
  return this.thatSeq$3
});
$c_sci_StreamViewLike$$anon$10.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_IterableViewLike$Zipped__iterator__sc_Iterator(this)
});
$c_sci_StreamViewLike$$anon$10.prototype.viewIdentifier__T = (function() {
  return "Z"
});
$c_sci_StreamViewLike$$anon$10.prototype.length__I = (function() {
  return $f_sc_SeqViewLike$Zipped__length__I(this)
});
$c_sci_StreamViewLike$$anon$10.prototype.scala$collection$IterableViewLike$Zipped$$$outer__sc_IterableViewLike = (function() {
  return this.$$outer$3
});
$c_sci_StreamViewLike$$anon$10.prototype.thatSeq__sc_Seq = (function() {
  return ((!this.bitmap$0$3) ? this.thatSeq$lzycompute__p3__sc_Seq() : this.thatSeq$3)
});
$c_sci_StreamViewLike$$anon$10.prototype.scala$collection$SeqViewLike$Zipped$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$3
});
var $d_sci_StreamViewLike$$anon$10 = new $TypeData().initClass({
  sci_StreamViewLike$$anon$10: 0
}, false, "scala.collection.immutable.StreamViewLike$$anon$10", {
  sci_StreamViewLike$$anon$10: 1,
  sci_StreamViewLike$AbstractTransformed: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sci_StreamViewLike$Transformed: 1,
  sci_StreamView: 1,
  sci_StreamViewLike: 1,
  sci_StreamViewLike$Zipped: 1,
  sc_SeqViewLike$Zipped: 1,
  sc_IterableViewLike$Zipped: 1
});
$c_sci_StreamViewLike$$anon$10.prototype.$classData = $d_sci_StreamViewLike$$anon$10;
/** @constructor */
function $c_scm_LinkedList() {
  $c_scm_AbstractSeq.call(this);
  this.elem$5 = null;
  this.next$5 = null
}
$c_scm_LinkedList.prototype = new $h_scm_AbstractSeq();
$c_scm_LinkedList.prototype.constructor = $c_scm_LinkedList;
/** @constructor */
function $h_scm_LinkedList() {
  /*<skip>*/
}
$h_scm_LinkedList.prototype = $c_scm_LinkedList.prototype;
$c_scm_LinkedList.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_scm_LinkedList.prototype.head__O = (function() {
  return $f_scm_LinkedListLike__head__O(this)
});
$c_scm_LinkedList.prototype.init___ = (function() {
  this.next$5 = this;
  return this
});
$c_scm_LinkedList.prototype.apply__I__O = (function(n) {
  return $f_scm_LinkedListLike__apply__I__O(this, n)
});
$c_scm_LinkedList.prototype.thisCollection__sc_Iterable = (function() {
  return this
});
$c_scm_LinkedList.prototype.apply__O__O = (function(v1) {
  var n = $uI(v1);
  return $f_scm_LinkedListLike__apply__I__O(this, n)
});
$c_scm_LinkedList.prototype.isEmpty__Z = (function() {
  return $f_scm_LinkedListLike__isEmpty__Z(this)
});
$c_scm_LinkedList.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_scm_LinkedList.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_scm_LinkedList.prototype.companion__scg_GenericCompanion = (function() {
  return $m_scm_LinkedList$()
});
$c_scm_LinkedList.prototype.foreach__F1__V = (function(f) {
  $f_scm_LinkedListLike__foreach__F1__V(this, f)
});
$c_scm_LinkedList.prototype.seq__scm_Seq = (function() {
  return this
});
$c_scm_LinkedList.prototype.iterator__sc_Iterator = (function() {
  return new $c_scm_LinkedListLike$$anon$1().init___scm_LinkedListLike(this)
});
$c_scm_LinkedList.prototype.length__I = (function() {
  var elem = this;
  var acc = 0;
  return $f_scm_LinkedListLike__length0__pscm_LinkedListLike__scm_Seq__I__I(this, elem, acc)
});
$c_scm_LinkedList.prototype.seq__sc_Seq = (function() {
  return this
});
$c_scm_LinkedList.prototype.drop__I__O = (function(n) {
  return $f_scm_LinkedListLike__drop__I__scm_Seq(this, n)
});
$c_scm_LinkedList.prototype.thisCollection__sc_Seq = (function() {
  return this
});
$c_scm_LinkedList.prototype.tail__O = (function() {
  return $f_scm_LinkedListLike__tail__scm_Seq(this)
});
$c_scm_LinkedList.prototype.isDefinedAt__O__Z = (function(x) {
  var idx = $uI(x);
  return $f_sc_GenSeqLike__isDefinedAt__I__Z(this, idx)
});
$c_scm_LinkedList.prototype.toSeq__sc_GenSeq = (function() {
  return this
});
$c_scm_LinkedList.prototype.hashCode__I = (function() {
  return $m_s_util_hashing_MurmurHash3$().seqHash__sc_Seq__I(this)
});
$c_scm_LinkedList.prototype.init___O__scm_LinkedList = (function(elem, next) {
  $c_scm_LinkedList.prototype.init___.call(this);
  if ((next !== null)) {
    this.elem$5 = elem;
    this.next$5 = next
  };
  return this
});
function $as_scm_LinkedList(obj) {
  return (((obj instanceof $c_scm_LinkedList) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.LinkedList"))
}
function $isArrayOf_scm_LinkedList(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_LinkedList)))
}
function $asArrayOf_scm_LinkedList(obj, depth) {
  return (($isArrayOf_scm_LinkedList(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.LinkedList;", depth))
}
var $d_scm_LinkedList = new $TypeData().initClass({
  scm_LinkedList: 0
}, false, "scala.collection.mutable.LinkedList", {
  scm_LinkedList: 1,
  scm_AbstractSeq: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_LinearSeq: 1,
  sc_LinearSeq: 1,
  sc_LinearSeqLike: 1,
  scm_LinkedListLike: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_LinkedList.prototype.$classData = $d_scm_LinkedList;
/** @constructor */
function $c_sci_StreamViewLike$$anon$1() {
  $c_sci_StreamViewLike$AbstractTransformed.call(this);
  this.forced$3 = null;
  this.$$outer$3 = null
}
$c_sci_StreamViewLike$$anon$1.prototype = new $h_sci_StreamViewLike$AbstractTransformed();
$c_sci_StreamViewLike$$anon$1.prototype.constructor = $c_sci_StreamViewLike$$anon$1;
/** @constructor */
function $h_sci_StreamViewLike$$anon$1() {
  /*<skip>*/
}
$h_sci_StreamViewLike$$anon$1.prototype = $c_sci_StreamViewLike$$anon$1.prototype;
$c_sci_StreamViewLike$$anon$1.prototype.apply__I__O = (function(idx) {
  return this.forced$3.apply__I__O(idx)
});
$c_sci_StreamViewLike$$anon$1.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return this.forced$3.apply__I__O(idx)
});
$c_sci_StreamViewLike$$anon$1.prototype.foreach__F1__V = (function(f) {
  this.forced$3.foreach__F1__V(f)
});
$c_sci_StreamViewLike$$anon$1.prototype.iterator__sc_Iterator = (function() {
  return this.forced$3.iterator__sc_Iterator()
});
$c_sci_StreamViewLike$$anon$1.prototype.viewIdentifier__T = (function() {
  return "C"
});
$c_sci_StreamViewLike$$anon$1.prototype.length__I = (function() {
  return this.forced$3.length__I()
});
$c_sci_StreamViewLike$$anon$1.prototype.init___sci_StreamViewLike__F0 = (function($$outer, xs$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$3 = $$outer
  };
  var forced = $as_sc_GenSeq(xs$1.apply__O());
  this.forced$3 = forced;
  $c_sci_StreamViewLike$AbstractTransformed.prototype.init___sci_StreamViewLike.call(this, $$outer);
  return this
});
var $d_sci_StreamViewLike$$anon$1 = new $TypeData().initClass({
  sci_StreamViewLike$$anon$1: 0
}, false, "scala.collection.immutable.StreamViewLike$$anon$1", {
  sci_StreamViewLike$$anon$1: 1,
  sci_StreamViewLike$AbstractTransformed: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sci_StreamViewLike$Transformed: 1,
  sci_StreamView: 1,
  sci_StreamViewLike: 1,
  sci_StreamViewLike$Forced: 1,
  sc_SeqViewLike$Forced: 1,
  sc_IterableViewLike$Forced: 1,
  sc_TraversableViewLike$Forced: 1
});
$c_sci_StreamViewLike$$anon$1.prototype.$classData = $d_sci_StreamViewLike$$anon$1;
/** @constructor */
function $c_sci_StreamViewLike$$anon$2() {
  $c_sci_StreamViewLike$AbstractTransformed.call(this);
  this.rest$3 = null;
  this.restSeq$3 = null;
  this.bitmap$0$3 = false;
  this.$$outer$3 = null
}
$c_sci_StreamViewLike$$anon$2.prototype = new $h_sci_StreamViewLike$AbstractTransformed();
$c_sci_StreamViewLike$$anon$2.prototype.constructor = $c_sci_StreamViewLike$$anon$2;
/** @constructor */
function $h_sci_StreamViewLike$$anon$2() {
  /*<skip>*/
}
$h_sci_StreamViewLike$$anon$2.prototype = $c_sci_StreamViewLike$$anon$2.prototype;
$c_sci_StreamViewLike$$anon$2.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$Appended__apply__I__O(this, idx)
});
$c_sci_StreamViewLike$$anon$2.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$Appended__apply__I__O(this, idx)
});
$c_sci_StreamViewLike$$anon$2.prototype.init___sci_StreamViewLike__sc_GenTraversable = (function($$outer, that$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$3 = $$outer
  };
  this.rest$3 = that$1;
  $c_sci_StreamViewLike$AbstractTransformed.prototype.init___sci_StreamViewLike.call(this, $$outer);
  return this
});
$c_sci_StreamViewLike$$anon$2.prototype.foreach__F1__V = (function(f) {
  $f_sc_TraversableViewLike$Appended__foreach__F1__V(this, f)
});
$c_sci_StreamViewLike$$anon$2.prototype.scala$collection$TraversableViewLike$Appended$$$outer__sc_TraversableViewLike = (function() {
  return this.$$outer$3
});
$c_sci_StreamViewLike$$anon$2.prototype.rest__sc_GenTraversable = (function() {
  return this.rest$3
});
$c_sci_StreamViewLike$$anon$2.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_IterableViewLike$Appended__iterator__sc_Iterator(this)
});
$c_sci_StreamViewLike$$anon$2.prototype.viewIdentifier__T = (function() {
  return "A"
});
$c_sci_StreamViewLike$$anon$2.prototype.length__I = (function() {
  return $f_sc_SeqViewLike$Appended__length__I(this)
});
$c_sci_StreamViewLike$$anon$2.prototype.restSeq$lzycompute__p3__sc_GenSeq = (function() {
  if ((!this.bitmap$0$3)) {
    this.restSeq$3 = this.rest$3.toSeq__sc_GenSeq();
    this.bitmap$0$3 = true
  };
  return this.restSeq$3
});
$c_sci_StreamViewLike$$anon$2.prototype.scala$collection$SeqViewLike$Appended$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$3
});
$c_sci_StreamViewLike$$anon$2.prototype.scala$collection$IterableViewLike$Appended$$$outer__sc_IterableViewLike = (function() {
  return this.$$outer$3
});
$c_sci_StreamViewLike$$anon$2.prototype.restSeq__sc_GenSeq = (function() {
  return ((!this.bitmap$0$3) ? this.restSeq$lzycompute__p3__sc_GenSeq() : this.restSeq$3)
});
var $d_sci_StreamViewLike$$anon$2 = new $TypeData().initClass({
  sci_StreamViewLike$$anon$2: 0
}, false, "scala.collection.immutable.StreamViewLike$$anon$2", {
  sci_StreamViewLike$$anon$2: 1,
  sci_StreamViewLike$AbstractTransformed: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sci_StreamViewLike$Transformed: 1,
  sci_StreamView: 1,
  sci_StreamViewLike: 1,
  sci_StreamViewLike$Appended: 1,
  sc_SeqViewLike$Appended: 1,
  sc_IterableViewLike$Appended: 1,
  sc_TraversableViewLike$Appended: 1
});
$c_sci_StreamViewLike$$anon$2.prototype.$classData = $d_sci_StreamViewLike$$anon$2;
/** @constructor */
function $c_sci_StreamViewLike$$anon$3() {
  $c_sci_StreamViewLike$AbstractTransformed.call(this);
  this.fst$3 = null;
  this.fstSeq$3 = null;
  this.bitmap$0$3 = false;
  this.$$outer$3 = null
}
$c_sci_StreamViewLike$$anon$3.prototype = new $h_sci_StreamViewLike$AbstractTransformed();
$c_sci_StreamViewLike$$anon$3.prototype.constructor = $c_sci_StreamViewLike$$anon$3;
/** @constructor */
function $h_sci_StreamViewLike$$anon$3() {
  /*<skip>*/
}
$h_sci_StreamViewLike$$anon$3.prototype = $c_sci_StreamViewLike$$anon$3.prototype;
$c_sci_StreamViewLike$$anon$3.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$Prepended__apply__I__O(this, idx)
});
$c_sci_StreamViewLike$$anon$3.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$Prepended__apply__I__O(this, idx)
});
$c_sci_StreamViewLike$$anon$3.prototype.scala$collection$SeqViewLike$Prepended$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$3
});
$c_sci_StreamViewLike$$anon$3.prototype.fstSeq__sc_GenSeq = (function() {
  return ((!this.bitmap$0$3) ? this.fstSeq$lzycompute__p3__sc_GenSeq() : this.fstSeq$3)
});
$c_sci_StreamViewLike$$anon$3.prototype.init___sci_StreamViewLike__sc_GenTraversable = (function($$outer, that$2) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$3 = $$outer
  };
  this.fst$3 = that$2;
  $c_sci_StreamViewLike$AbstractTransformed.prototype.init___sci_StreamViewLike.call(this, $$outer);
  return this
});
$c_sci_StreamViewLike$$anon$3.prototype.foreach__F1__V = (function(f) {
  $f_sc_TraversableViewLike$Prepended__foreach__F1__V(this, f)
});
$c_sci_StreamViewLike$$anon$3.prototype.fst__sc_GenTraversable = (function() {
  return this.fst$3
});
$c_sci_StreamViewLike$$anon$3.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_IterableViewLike$Prepended__iterator__sc_Iterator(this)
});
$c_sci_StreamViewLike$$anon$3.prototype.viewIdentifier__T = (function() {
  return "A"
});
$c_sci_StreamViewLike$$anon$3.prototype.length__I = (function() {
  return $f_sc_SeqViewLike$Prepended__length__I(this)
});
$c_sci_StreamViewLike$$anon$3.prototype.scala$collection$TraversableViewLike$Prepended$$$outer__sc_TraversableViewLike = (function() {
  return this.$$outer$3
});
$c_sci_StreamViewLike$$anon$3.prototype.fstSeq$lzycompute__p3__sc_GenSeq = (function() {
  if ((!this.bitmap$0$3)) {
    this.fstSeq$3 = this.fst$3.toSeq__sc_GenSeq();
    this.bitmap$0$3 = true
  };
  return this.fstSeq$3
});
$c_sci_StreamViewLike$$anon$3.prototype.scala$collection$IterableViewLike$Prepended$$$outer__sc_IterableViewLike = (function() {
  return this.$$outer$3
});
var $d_sci_StreamViewLike$$anon$3 = new $TypeData().initClass({
  sci_StreamViewLike$$anon$3: 0
}, false, "scala.collection.immutable.StreamViewLike$$anon$3", {
  sci_StreamViewLike$$anon$3: 1,
  sci_StreamViewLike$AbstractTransformed: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sci_StreamViewLike$Transformed: 1,
  sci_StreamView: 1,
  sci_StreamViewLike: 1,
  sci_StreamViewLike$Prepended: 1,
  sc_SeqViewLike$Prepended: 1,
  sc_IterableViewLike$Prepended: 1,
  sc_TraversableViewLike$Prepended: 1
});
$c_sci_StreamViewLike$$anon$3.prototype.$classData = $d_sci_StreamViewLike$$anon$3;
/** @constructor */
function $c_sci_StreamViewLike$$anon$4() {
  $c_sci_StreamViewLike$AbstractTransformed.call(this);
  this.mapping$3 = null;
  this.$$outer$3 = null
}
$c_sci_StreamViewLike$$anon$4.prototype = new $h_sci_StreamViewLike$AbstractTransformed();
$c_sci_StreamViewLike$$anon$4.prototype.constructor = $c_sci_StreamViewLike$$anon$4;
/** @constructor */
function $h_sci_StreamViewLike$$anon$4() {
  /*<skip>*/
}
$h_sci_StreamViewLike$$anon$4.prototype = $c_sci_StreamViewLike$$anon$4.prototype;
$c_sci_StreamViewLike$$anon$4.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$Mapped__apply__I__O(this, idx)
});
$c_sci_StreamViewLike$$anon$4.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$Mapped__apply__I__O(this, idx)
});
$c_sci_StreamViewLike$$anon$4.prototype.foreach__F1__V = (function(f) {
  $f_sc_TraversableViewLike$Mapped__foreach__F1__V(this, f)
});
$c_sci_StreamViewLike$$anon$4.prototype.mapping__F1 = (function() {
  return this.mapping$3
});
$c_sci_StreamViewLike$$anon$4.prototype.scala$collection$SeqViewLike$Mapped$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$3
});
$c_sci_StreamViewLike$$anon$4.prototype.init___sci_StreamViewLike__F1 = (function($$outer, f$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$3 = $$outer
  };
  this.mapping$3 = f$1;
  $c_sci_StreamViewLike$AbstractTransformed.prototype.init___sci_StreamViewLike.call(this, $$outer);
  return this
});
$c_sci_StreamViewLike$$anon$4.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_IterableViewLike$Mapped__iterator__sc_Iterator(this)
});
$c_sci_StreamViewLike$$anon$4.prototype.viewIdentifier__T = (function() {
  return "M"
});
$c_sci_StreamViewLike$$anon$4.prototype.length__I = (function() {
  return this.$$outer$3.length__I()
});
$c_sci_StreamViewLike$$anon$4.prototype.scala$collection$IterableViewLike$Mapped$$$outer__sc_IterableViewLike = (function() {
  return this.$$outer$3
});
$c_sci_StreamViewLike$$anon$4.prototype.scala$collection$TraversableViewLike$Mapped$$$outer__sc_TraversableViewLike = (function() {
  return this.$$outer$3
});
var $d_sci_StreamViewLike$$anon$4 = new $TypeData().initClass({
  sci_StreamViewLike$$anon$4: 0
}, false, "scala.collection.immutable.StreamViewLike$$anon$4", {
  sci_StreamViewLike$$anon$4: 1,
  sci_StreamViewLike$AbstractTransformed: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sci_StreamViewLike$Transformed: 1,
  sci_StreamView: 1,
  sci_StreamViewLike: 1,
  sci_StreamViewLike$Mapped: 1,
  sc_SeqViewLike$Mapped: 1,
  sc_IterableViewLike$Mapped: 1,
  sc_TraversableViewLike$Mapped: 1
});
$c_sci_StreamViewLike$$anon$4.prototype.$classData = $d_sci_StreamViewLike$$anon$4;
/** @constructor */
function $c_sci_StreamViewLike$$anon$5() {
  $c_sci_StreamViewLike$AbstractTransformed.call(this);
  this.mapping$3 = null;
  this.index$3 = null;
  this.bitmap$0$3 = false;
  this.$$outer$3 = null
}
$c_sci_StreamViewLike$$anon$5.prototype = new $h_sci_StreamViewLike$AbstractTransformed();
$c_sci_StreamViewLike$$anon$5.prototype.constructor = $c_sci_StreamViewLike$$anon$5;
/** @constructor */
function $h_sci_StreamViewLike$$anon$5() {
  /*<skip>*/
}
$h_sci_StreamViewLike$$anon$5.prototype = $c_sci_StreamViewLike$$anon$5.prototype;
$c_sci_StreamViewLike$$anon$5.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$FlatMapped__apply__I__O(this, idx)
});
$c_sci_StreamViewLike$$anon$5.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$FlatMapped__apply__I__O(this, idx)
});
$c_sci_StreamViewLike$$anon$5.prototype.scala$collection$SeqViewLike$FlatMapped$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$3
});
$c_sci_StreamViewLike$$anon$5.prototype.index$lzycompute__p3__AI = (function() {
  if ((!this.bitmap$0$3)) {
    this.index$3 = $f_sc_SeqViewLike$FlatMapped__index__AI(this);
    this.bitmap$0$3 = true
  };
  return this.index$3
});
$c_sci_StreamViewLike$$anon$5.prototype.foreach__F1__V = (function(f) {
  $f_sc_TraversableViewLike$FlatMapped__foreach__F1__V(this, f)
});
$c_sci_StreamViewLike$$anon$5.prototype.mapping__F1 = (function() {
  return this.mapping$3
});
$c_sci_StreamViewLike$$anon$5.prototype.init___sci_StreamViewLike__F1 = (function($$outer, f$2) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$3 = $$outer
  };
  this.mapping$3 = f$2;
  $c_sci_StreamViewLike$AbstractTransformed.prototype.init___sci_StreamViewLike.call(this, $$outer);
  return this
});
$c_sci_StreamViewLike$$anon$5.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_IterableViewLike$FlatMapped__iterator__sc_Iterator(this)
});
$c_sci_StreamViewLike$$anon$5.prototype.viewIdentifier__T = (function() {
  return "N"
});
$c_sci_StreamViewLike$$anon$5.prototype.length__I = (function() {
  return $f_sc_SeqViewLike$FlatMapped__length__I(this)
});
$c_sci_StreamViewLike$$anon$5.prototype.scala$collection$IterableViewLike$FlatMapped$$$outer__sc_IterableViewLike = (function() {
  return this.$$outer$3
});
$c_sci_StreamViewLike$$anon$5.prototype.scala$collection$TraversableViewLike$FlatMapped$$$outer__sc_TraversableViewLike = (function() {
  return this.$$outer$3
});
$c_sci_StreamViewLike$$anon$5.prototype.index__AI = (function() {
  return ((!this.bitmap$0$3) ? this.index$lzycompute__p3__AI() : this.index$3)
});
var $d_sci_StreamViewLike$$anon$5 = new $TypeData().initClass({
  sci_StreamViewLike$$anon$5: 0
}, false, "scala.collection.immutable.StreamViewLike$$anon$5", {
  sci_StreamViewLike$$anon$5: 1,
  sci_StreamViewLike$AbstractTransformed: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sci_StreamViewLike$Transformed: 1,
  sci_StreamView: 1,
  sci_StreamViewLike: 1,
  sci_StreamViewLike$FlatMapped: 1,
  sc_SeqViewLike$FlatMapped: 1,
  sc_IterableViewLike$FlatMapped: 1,
  sc_TraversableViewLike$FlatMapped: 1
});
$c_sci_StreamViewLike$$anon$5.prototype.$classData = $d_sci_StreamViewLike$$anon$5;
/** @constructor */
function $c_sci_StreamViewLike$$anon$6() {
  $c_sci_StreamViewLike$AbstractTransformed.call(this);
  this.pred$3 = null;
  this.index$3 = null;
  this.bitmap$0$3 = false;
  this.$$outer$3 = null
}
$c_sci_StreamViewLike$$anon$6.prototype = new $h_sci_StreamViewLike$AbstractTransformed();
$c_sci_StreamViewLike$$anon$6.prototype.constructor = $c_sci_StreamViewLike$$anon$6;
/** @constructor */
function $h_sci_StreamViewLike$$anon$6() {
  /*<skip>*/
}
$h_sci_StreamViewLike$$anon$6.prototype = $c_sci_StreamViewLike$$anon$6.prototype;
$c_sci_StreamViewLike$$anon$6.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$Filtered__apply__I__O(this, idx)
});
$c_sci_StreamViewLike$$anon$6.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$Filtered__apply__I__O(this, idx)
});
$c_sci_StreamViewLike$$anon$6.prototype.scala$collection$IterableViewLike$Filtered$$$outer__sc_IterableViewLike = (function() {
  return this.$$outer$3
});
$c_sci_StreamViewLike$$anon$6.prototype.index$lzycompute__p3__AI = (function() {
  if ((!this.bitmap$0$3)) {
    this.index$3 = $f_sc_SeqViewLike$Filtered__index__AI(this);
    this.bitmap$0$3 = true
  };
  return this.index$3
});
$c_sci_StreamViewLike$$anon$6.prototype.foreach__F1__V = (function(f) {
  $f_sc_TraversableViewLike$Filtered__foreach__F1__V(this, f)
});
$c_sci_StreamViewLike$$anon$6.prototype.init___sci_StreamViewLike__F1 = (function($$outer, p$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$3 = $$outer
  };
  this.pred$3 = p$1;
  $c_sci_StreamViewLike$AbstractTransformed.prototype.init___sci_StreamViewLike.call(this, $$outer);
  return this
});
$c_sci_StreamViewLike$$anon$6.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_IterableViewLike$Filtered__iterator__sc_Iterator(this)
});
$c_sci_StreamViewLike$$anon$6.prototype.viewIdentifier__T = (function() {
  return "F"
});
$c_sci_StreamViewLike$$anon$6.prototype.length__I = (function() {
  return $f_sc_SeqViewLike$Filtered__length__I(this)
});
$c_sci_StreamViewLike$$anon$6.prototype.index__AI = (function() {
  return ((!this.bitmap$0$3) ? this.index$lzycompute__p3__AI() : this.index$3)
});
$c_sci_StreamViewLike$$anon$6.prototype.pred__F1 = (function() {
  return this.pred$3
});
$c_sci_StreamViewLike$$anon$6.prototype.scala$collection$SeqViewLike$Filtered$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$3
});
$c_sci_StreamViewLike$$anon$6.prototype.scala$collection$TraversableViewLike$Filtered$$$outer__sc_TraversableViewLike = (function() {
  return this.$$outer$3
});
var $d_sci_StreamViewLike$$anon$6 = new $TypeData().initClass({
  sci_StreamViewLike$$anon$6: 0
}, false, "scala.collection.immutable.StreamViewLike$$anon$6", {
  sci_StreamViewLike$$anon$6: 1,
  sci_StreamViewLike$AbstractTransformed: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sci_StreamViewLike$Transformed: 1,
  sci_StreamView: 1,
  sci_StreamViewLike: 1,
  sci_StreamViewLike$Filtered: 1,
  sc_SeqViewLike$Filtered: 1,
  sc_IterableViewLike$Filtered: 1,
  sc_TraversableViewLike$Filtered: 1
});
$c_sci_StreamViewLike$$anon$6.prototype.$classData = $d_sci_StreamViewLike$$anon$6;
/** @constructor */
function $c_sci_StreamViewLike$$anon$7() {
  $c_sci_StreamViewLike$AbstractTransformed.call(this);
  this.endpoints$3 = null;
  this.$$outer$3 = null
}
$c_sci_StreamViewLike$$anon$7.prototype = new $h_sci_StreamViewLike$AbstractTransformed();
$c_sci_StreamViewLike$$anon$7.prototype.constructor = $c_sci_StreamViewLike$$anon$7;
/** @constructor */
function $h_sci_StreamViewLike$$anon$7() {
  /*<skip>*/
}
$h_sci_StreamViewLike$$anon$7.prototype = $c_sci_StreamViewLike$$anon$7.prototype;
$c_sci_StreamViewLike$$anon$7.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$Sliced__apply__I__O(this, idx)
});
$c_sci_StreamViewLike$$anon$7.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$Sliced__apply__I__O(this, idx)
});
$c_sci_StreamViewLike$$anon$7.prototype.scala$collection$SeqViewLike$Sliced$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$3
});
$c_sci_StreamViewLike$$anon$7.prototype.foreach__F1__V = (function(f) {
  var this$1 = $f_sc_SeqViewLike$Sliced__iterator__sc_Iterator(this);
  $f_sc_Iterator__foreach__F1__V(this$1, f)
});
$c_sci_StreamViewLike$$anon$7.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_SeqViewLike$Sliced__iterator__sc_Iterator(this)
});
$c_sci_StreamViewLike$$anon$7.prototype.viewIdentifier__T = (function() {
  return "S"
});
$c_sci_StreamViewLike$$anon$7.prototype.length__I = (function() {
  var this$1 = $f_sc_SeqViewLike$Sliced__iterator__sc_Iterator(this);
  return $f_sc_TraversableOnce__size__I(this$1)
});
$c_sci_StreamViewLike$$anon$7.prototype.init___sci_StreamViewLike__scg_SliceInterval = (function($$outer, _endpoints$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$3 = $$outer
  };
  this.endpoints$3 = _endpoints$1;
  $c_sci_StreamViewLike$AbstractTransformed.prototype.init___sci_StreamViewLike.call(this, $$outer);
  return this
});
$c_sci_StreamViewLike$$anon$7.prototype.endpoints__scg_SliceInterval = (function() {
  return this.endpoints$3
});
var $d_sci_StreamViewLike$$anon$7 = new $TypeData().initClass({
  sci_StreamViewLike$$anon$7: 0
}, false, "scala.collection.immutable.StreamViewLike$$anon$7", {
  sci_StreamViewLike$$anon$7: 1,
  sci_StreamViewLike$AbstractTransformed: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sci_StreamViewLike$Transformed: 1,
  sci_StreamView: 1,
  sci_StreamViewLike: 1,
  sci_StreamViewLike$Sliced: 1,
  sc_SeqViewLike$Sliced: 1,
  sc_IterableViewLike$Sliced: 1,
  sc_TraversableViewLike$Sliced: 1
});
$c_sci_StreamViewLike$$anon$7.prototype.$classData = $d_sci_StreamViewLike$$anon$7;
/** @constructor */
function $c_sci_StreamViewLike$$anon$8() {
  $c_sci_StreamViewLike$AbstractTransformed.call(this);
  this.pred$3 = null;
  this.start$3 = 0;
  this.bitmap$0$3 = false;
  this.$$outer$3 = null
}
$c_sci_StreamViewLike$$anon$8.prototype = new $h_sci_StreamViewLike$AbstractTransformed();
$c_sci_StreamViewLike$$anon$8.prototype.constructor = $c_sci_StreamViewLike$$anon$8;
/** @constructor */
function $h_sci_StreamViewLike$$anon$8() {
  /*<skip>*/
}
$h_sci_StreamViewLike$$anon$8.prototype = $c_sci_StreamViewLike$$anon$8.prototype;
$c_sci_StreamViewLike$$anon$8.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$DroppedWhile__apply__I__O(this, idx)
});
$c_sci_StreamViewLike$$anon$8.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$DroppedWhile__apply__I__O(this, idx)
});
$c_sci_StreamViewLike$$anon$8.prototype.scala$collection$SeqViewLike$DroppedWhile$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$3
});
$c_sci_StreamViewLike$$anon$8.prototype.foreach__F1__V = (function(f) {
  $f_sc_TraversableViewLike$DroppedWhile__foreach__F1__V(this, f)
});
$c_sci_StreamViewLike$$anon$8.prototype.scala$collection$IterableViewLike$DroppedWhile$$$outer__sc_IterableViewLike = (function() {
  return this.$$outer$3
});
$c_sci_StreamViewLike$$anon$8.prototype.init___sci_StreamViewLike__F1 = (function($$outer, p$2) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$3 = $$outer
  };
  this.pred$3 = p$2;
  $c_sci_StreamViewLike$AbstractTransformed.prototype.init___sci_StreamViewLike.call(this, $$outer);
  return this
});
$c_sci_StreamViewLike$$anon$8.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_IterableViewLike$DroppedWhile__iterator__sc_Iterator(this)
});
$c_sci_StreamViewLike$$anon$8.prototype.viewIdentifier__T = (function() {
  return "D"
});
$c_sci_StreamViewLike$$anon$8.prototype.length__I = (function() {
  return $f_sc_SeqViewLike$DroppedWhile__length__I(this)
});
$c_sci_StreamViewLike$$anon$8.prototype.scala$collection$TraversableViewLike$DroppedWhile$$$outer__sc_TraversableViewLike = (function() {
  return this.$$outer$3
});
$c_sci_StreamViewLike$$anon$8.prototype.start__I = (function() {
  return ((!this.bitmap$0$3) ? this.start$lzycompute__p3__I() : this.start$3)
});
$c_sci_StreamViewLike$$anon$8.prototype.pred__F1 = (function() {
  return this.pred$3
});
$c_sci_StreamViewLike$$anon$8.prototype.start$lzycompute__p3__I = (function() {
  if ((!this.bitmap$0$3)) {
    var this$1 = this.$$outer$3;
    var p = this.pred$3;
    this.start$3 = $f_sc_SeqLike__segmentLength__F1__I__I(this$1, p, 0);
    this.bitmap$0$3 = true
  };
  return this.start$3
});
var $d_sci_StreamViewLike$$anon$8 = new $TypeData().initClass({
  sci_StreamViewLike$$anon$8: 0
}, false, "scala.collection.immutable.StreamViewLike$$anon$8", {
  sci_StreamViewLike$$anon$8: 1,
  sci_StreamViewLike$AbstractTransformed: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sci_StreamViewLike$Transformed: 1,
  sci_StreamView: 1,
  sci_StreamViewLike: 1,
  sci_StreamViewLike$DroppedWhile: 1,
  sc_SeqViewLike$DroppedWhile: 1,
  sc_IterableViewLike$DroppedWhile: 1,
  sc_TraversableViewLike$DroppedWhile: 1
});
$c_sci_StreamViewLike$$anon$8.prototype.$classData = $d_sci_StreamViewLike$$anon$8;
/** @constructor */
function $c_sci_StreamViewLike$$anon$9() {
  $c_sci_StreamViewLike$AbstractTransformed.call(this);
  this.pred$3 = null;
  this.len$3 = 0;
  this.bitmap$0$3 = false;
  this.$$outer$3 = null
}
$c_sci_StreamViewLike$$anon$9.prototype = new $h_sci_StreamViewLike$AbstractTransformed();
$c_sci_StreamViewLike$$anon$9.prototype.constructor = $c_sci_StreamViewLike$$anon$9;
/** @constructor */
function $h_sci_StreamViewLike$$anon$9() {
  /*<skip>*/
}
$h_sci_StreamViewLike$$anon$9.prototype = $c_sci_StreamViewLike$$anon$9.prototype;
$c_sci_StreamViewLike$$anon$9.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$TakenWhile__apply__I__O(this, idx)
});
$c_sci_StreamViewLike$$anon$9.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$TakenWhile__apply__I__O(this, idx)
});
$c_sci_StreamViewLike$$anon$9.prototype.scala$collection$IterableViewLike$TakenWhile$$$outer__sc_IterableViewLike = (function() {
  return this.$$outer$3
});
$c_sci_StreamViewLike$$anon$9.prototype.len__I = (function() {
  return ((!this.bitmap$0$3) ? this.len$lzycompute__p3__I() : this.len$3)
});
$c_sci_StreamViewLike$$anon$9.prototype.foreach__F1__V = (function(f) {
  $f_sc_TraversableViewLike$TakenWhile__foreach__F1__V(this, f)
});
$c_sci_StreamViewLike$$anon$9.prototype.scala$collection$TraversableViewLike$TakenWhile$$$outer__sc_TraversableViewLike = (function() {
  return this.$$outer$3
});
$c_sci_StreamViewLike$$anon$9.prototype.init___sci_StreamViewLike__F1 = (function($$outer, p$3) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$3 = $$outer
  };
  this.pred$3 = p$3;
  $c_sci_StreamViewLike$AbstractTransformed.prototype.init___sci_StreamViewLike.call(this, $$outer);
  return this
});
$c_sci_StreamViewLike$$anon$9.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_IterableViewLike$TakenWhile__iterator__sc_Iterator(this)
});
$c_sci_StreamViewLike$$anon$9.prototype.viewIdentifier__T = (function() {
  return "T"
});
$c_sci_StreamViewLike$$anon$9.prototype.length__I = (function() {
  return this.len__I()
});
$c_sci_StreamViewLike$$anon$9.prototype.scala$collection$SeqViewLike$TakenWhile$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$3
});
$c_sci_StreamViewLike$$anon$9.prototype.len$lzycompute__p3__I = (function() {
  if ((!this.bitmap$0$3)) {
    var this$1 = this.$$outer$3;
    var p = this.pred$3;
    this.len$3 = $f_sc_SeqLike__segmentLength__F1__I__I(this$1, p, 0);
    this.bitmap$0$3 = true
  };
  return this.len$3
});
$c_sci_StreamViewLike$$anon$9.prototype.pred__F1 = (function() {
  return this.pred$3
});
var $d_sci_StreamViewLike$$anon$9 = new $TypeData().initClass({
  sci_StreamViewLike$$anon$9: 0
}, false, "scala.collection.immutable.StreamViewLike$$anon$9", {
  sci_StreamViewLike$$anon$9: 1,
  sci_StreamViewLike$AbstractTransformed: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sci_StreamViewLike$Transformed: 1,
  sci_StreamView: 1,
  sci_StreamViewLike: 1,
  sci_StreamViewLike$TakenWhile: 1,
  sc_SeqViewLike$TakenWhile: 1,
  sc_IterableViewLike$TakenWhile: 1,
  sc_TraversableViewLike$TakenWhile: 1
});
$c_sci_StreamViewLike$$anon$9.prototype.$classData = $d_sci_StreamViewLike$$anon$9;
/** @constructor */
function $c_scm_AbstractBuffer() {
  $c_scm_AbstractSeq.call(this)
}
$c_scm_AbstractBuffer.prototype = new $h_scm_AbstractSeq();
$c_scm_AbstractBuffer.prototype.constructor = $c_scm_AbstractBuffer;
/** @constructor */
function $h_scm_AbstractBuffer() {
  /*<skip>*/
}
$h_scm_AbstractBuffer.prototype = $c_scm_AbstractBuffer.prototype;
$c_scm_AbstractBuffer.prototype.clone__scm_Buffer = (function() {
  return $f_scm_BufferLike__clone__scm_Buffer(this)
});
$c_scm_AbstractBuffer.prototype.$$minus$eq__O__scm_Buffer = (function(x) {
  return $f_scm_BufferLike__$$minus$eq__O__scm_Buffer(this, x)
});
$c_scm_AbstractBuffer.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs)
});
/** @constructor */
function $c_scm_ListMap() {
  $c_scm_AbstractMap.call(this);
  this.elems$5 = null;
  this.siz$5 = 0
}
$c_scm_ListMap.prototype = new $h_scm_AbstractMap();
$c_scm_ListMap.prototype.constructor = $c_scm_ListMap;
/** @constructor */
function $h_scm_ListMap() {
  /*<skip>*/
}
$h_scm_ListMap.prototype = $c_scm_ListMap.prototype;
$c_scm_ListMap.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_scm_ListMap.prototype.init___ = (function() {
  this.elems$5 = $m_sci_Nil$();
  this.siz$5 = 0;
  return this
});
$c_scm_ListMap.prototype.$$minus$eq__O__scm_MapLike = (function(key) {
  return this.$$minus$eq__O__scm_ListMap(key)
});
$c_scm_ListMap.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  var this$2 = new $c_scm_ListMap().init___();
  return $as_scm_Map($as_scm_Map($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$2, this)).$$minus$eq__O__scm_MapLike(elem))
});
$c_scm_ListMap.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_scm_ListMap.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__T2__scm_ListMap($as_T2(elem))
});
$c_scm_ListMap.prototype.$$minus__O__sc_Map = (function(key) {
  var this$2 = new $c_scm_ListMap().init___();
  return $as_scm_Map($as_scm_Map($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$2, this)).$$minus$eq__O__scm_MapLike(key))
});
$c_scm_ListMap.prototype.empty__sc_Map = (function() {
  return new $c_scm_ListMap().init___()
});
$c_scm_ListMap.prototype.$$plus$eq__T2__scm_ListMap = (function(kv) {
  this.elems$5 = this.remove__p5__O__sci_List__sci_List__sci_List(kv.$$und1__O(), this.elems$5, $m_sci_Nil$());
  var this$1 = this.elems$5;
  this.elems$5 = new $c_sci_$colon$colon().init___O__sci_List(kv, this$1);
  this.siz$5 = ((1 + this.siz$5) | 0);
  return this
});
$c_scm_ListMap.prototype.size__I = (function() {
  return this.siz$5
});
$c_scm_ListMap.prototype.seq__sc_Map = (function() {
  return this
});
$c_scm_ListMap.prototype.result__O = (function() {
  return this
});
$c_scm_ListMap.prototype.iterator__sc_Iterator = (function() {
  var this$1 = this.elems$5;
  return new $c_sc_LinearSeqLike$$anon$1().init___sc_LinearSeqLike(this$1)
});
$c_scm_ListMap.prototype.empty__scm_Map = (function() {
  return new $c_scm_ListMap().init___()
});
$c_scm_ListMap.prototype.remove__p5__O__sci_List__sci_List__sci_List = (function(key, elems, acc) {
  _remove: while (true) {
    if (elems.isEmpty__Z()) {
      return acc
    } else if ($m_sr_BoxesRunTime$().equals__O__O__Z($as_T2(elems.head__O()).$$und1__O(), key)) {
      this.siz$5 = (((-1) + this.siz$5) | 0);
      var x$4 = acc;
      return $as_sci_List(elems.tail__O()).$$colon$colon$colon__sci_List__sci_List(x$4)
    } else {
      var temp$elems = $as_sci_List(elems.tail__O());
      var x$5 = $as_T2(elems.head__O());
      var this$1 = acc;
      var temp$acc = new $c_sci_$colon$colon().init___O__sci_List(x$5, this$1);
      elems = temp$elems;
      acc = temp$acc;
      continue _remove
    }
  }
});
$c_scm_ListMap.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_MapLike__filterNot__F1__sc_Map(this, p)
});
$c_scm_ListMap.prototype.get__O__s_Option = (function(key) {
  var this$1 = this.elems$5;
  inlinereturn$1: {
    var these = this$1;
    while ((!these.isEmpty__Z())) {
      var arg1 = these.head__O();
      var x$1 = $as_T2(arg1);
      if ($m_sr_BoxesRunTime$().equals__O__O__Z(x$1.$$und1__O(), key)) {
        var this$2 = new $c_s_Some().init___O(these.head__O());
        break inlinereturn$1
      };
      these = $as_sc_LinearSeqOptimized(these.tail__O())
    };
    var this$2 = $m_s_None$()
  };
  if (this$2.isEmpty__Z()) {
    return $m_s_None$()
  } else {
    var arg1$1 = this$2.get__O();
    var x$2 = $as_T2(arg1$1);
    return new $c_s_Some().init___O(x$2.$$und2__O())
  }
});
$c_scm_ListMap.prototype.$$plus$eq__T2__scm_MapLike = (function(kv) {
  return this.$$plus$eq__T2__scm_ListMap(kv)
});
$c_scm_ListMap.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__T2__scm_ListMap($as_T2(elem))
});
$c_scm_ListMap.prototype.toSeq__sc_GenSeq = (function() {
  return $f_scm_MapLike__toSeq__sc_Seq(this)
});
$c_scm_ListMap.prototype.$$minus$eq__O__scg_Shrinkable = (function(elem) {
  return this.$$minus$eq__O__scm_ListMap(elem)
});
$c_scm_ListMap.prototype.clear__V = (function() {
  this.elems$5 = $m_sci_Nil$();
  this.siz$5 = 0
});
$c_scm_ListMap.prototype.$$minus$eq__O__scm_ListMap = (function(key) {
  this.elems$5 = this.remove__p5__O__sci_List__sci_List__sci_List(key, this.elems$5, $m_sci_Nil$());
  return this
});
$c_scm_ListMap.prototype.$$plus__T2__sc_GenMap = (function(kv) {
  var this$2 = new $c_scm_ListMap().init___();
  return $as_scm_Map($as_scm_Map($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$2, this)).$$plus$eq__T2__scm_MapLike(kv))
});
function $as_scm_ListMap(obj) {
  return (((obj instanceof $c_scm_ListMap) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ListMap"))
}
function $isArrayOf_scm_ListMap(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ListMap)))
}
function $asArrayOf_scm_ListMap(obj, depth) {
  return (($isArrayOf_scm_ListMap(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ListMap;", depth))
}
var $d_scm_ListMap = new $TypeData().initClass({
  scm_ListMap: 0
}, false, "scala.collection.mutable.ListMap", {
  scm_ListMap: 1,
  scm_AbstractMap: 1,
  sc_AbstractMap: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Map: 1,
  sc_GenMap: 1,
  sc_GenMapLike: 1,
  sc_MapLike: 1,
  s_PartialFunction: 1,
  F1: 1,
  scg_Subtractable: 1,
  scm_Map: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_MapLike: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  scg_Shrinkable: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_ListMap.prototype.$classData = $d_scm_ListMap;
/** @constructor */
function $c_scm_Map$WithDefault() {
  $c_sc_Map$WithDefault.call(this);
  this.underlying$5 = null;
  this.d$5 = null
}
$c_scm_Map$WithDefault.prototype = new $h_sc_Map$WithDefault();
$c_scm_Map$WithDefault.prototype.constructor = $c_scm_Map$WithDefault;
/** @constructor */
function $h_scm_Map$WithDefault() {
  /*<skip>*/
}
$h_scm_Map$WithDefault.prototype = $c_scm_Map$WithDefault.prototype;
$c_scm_Map$WithDefault.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_scm_Map$WithDefault.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_scm_Map$WithDefault.prototype.updated__O__O__scm_Map$WithDefault = (function(key, value) {
  return new $c_scm_Map$WithDefault().init___scm_Map__F1(this.underlying$5.updated__O__O__scm_Map(key, value), this.d$5)
});
$c_scm_Map$WithDefault.prototype.put__O__O__s_Option = (function(key, value) {
  return $f_scm_MapLike__put__O__O__s_Option(this, key, value)
});
$c_scm_Map$WithDefault.prototype.$$minus$eq__O__scm_MapLike = (function(key) {
  return this.$$minus$eq__O__scm_Map$WithDefault(key)
});
$c_scm_Map$WithDefault.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return this.$$minus__O__scm_Map$WithDefault(elem)
});
$c_scm_Map$WithDefault.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_scm_Map$WithDefault.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_scm_Map$WithDefault.prototype.remove__O__s_Option = (function(key) {
  return $f_scm_MapLike__remove__O__s_Option(this, key)
});
$c_scm_Map$WithDefault.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__T2__scm_Map$WithDefault($as_T2(elem))
});
$c_scm_Map$WithDefault.prototype.$$minus__O__scm_Map$WithDefault = (function(key) {
  return new $c_scm_Map$WithDefault().init___scm_Map__F1(this.underlying$5.$$minus__O__scm_Map(key), this.d$5)
});
$c_scm_Map$WithDefault.prototype.companion__scg_GenericCompanion = (function() {
  return $m_scm_Iterable$()
});
$c_scm_Map$WithDefault.prototype.$$plus__T2__scm_Map = (function(kv) {
  return this.updated__O__O__scm_Map$WithDefault(kv.$$und1__O(), kv.$$und2__O())
});
$c_scm_Map$WithDefault.prototype.$$minus__O__sc_Map = (function(key) {
  return this.$$minus__O__scm_Map$WithDefault(key)
});
$c_scm_Map$WithDefault.prototype.empty__sc_Map = (function() {
  return this.empty__scm_Map$WithDefault()
});
$c_scm_Map$WithDefault.prototype.update__O__O__V = (function(key, value) {
  $f_scm_MapLike__update__O__O__V(this, key, value)
});
$c_scm_Map$WithDefault.prototype.seq__sc_Map = (function() {
  return this
});
$c_scm_Map$WithDefault.prototype.result__O = (function() {
  return this
});
$c_scm_Map$WithDefault.prototype.withDefaultValue__O__scm_Map = (function(d) {
  return new $c_scm_Map$WithDefault().init___scm_Map__F1(this.underlying$5, new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this, d$1) {
    return (function(x$2) {
      return d$1
    })
  })(this, d)))
});
$c_scm_Map$WithDefault.prototype.empty__scm_Map = (function() {
  return this.empty__scm_Map$WithDefault()
});
$c_scm_Map$WithDefault.prototype.sizeHintBounded__I__sc_TraversableLike__V = (function(size, boundingColl) {
  $f_scm_Builder__sizeHintBounded__I__sc_TraversableLike__V(this, size, boundingColl)
});
$c_scm_Map$WithDefault.prototype.$$minus$eq__O__scm_Map$WithDefault = (function(key) {
  this.underlying$5.$$minus$eq__O__scm_MapLike(key);
  return this
});
$c_scm_Map$WithDefault.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_MapLike__filterNot__F1__sc_Map(this, p)
});
$c_scm_Map$WithDefault.prototype.updated__O__O__scm_Map = (function(key, value) {
  return this.updated__O__O__scm_Map$WithDefault(key, value)
});
$c_scm_Map$WithDefault.prototype.getOrElseUpdate__O__F0__O = (function(key, op) {
  return $f_scm_MapLike__getOrElseUpdate__O__F0__O(this, key, op)
});
$c_scm_Map$WithDefault.prototype.$$plus$eq__T2__scm_MapLike = (function(kv) {
  return this.$$plus$eq__T2__scm_Map$WithDefault(kv)
});
$c_scm_Map$WithDefault.prototype.toSeq__sc_Seq = (function() {
  return $f_scm_MapLike__toSeq__sc_Seq(this)
});
$c_scm_Map$WithDefault.prototype.init___scm_Map__F1 = (function(underlying, d) {
  this.underlying$5 = underlying;
  this.d$5 = d;
  $c_sc_Map$WithDefault.prototype.init___sc_Map__F1.call(this, underlying, d);
  return this
});
$c_scm_Map$WithDefault.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__T2__scm_Map$WithDefault($as_T2(elem))
});
$c_scm_Map$WithDefault.prototype.empty__scm_Map$WithDefault = (function() {
  return new $c_scm_Map$WithDefault().init___scm_Map__F1(this.underlying$5.empty__scm_Map(), this.d$5)
});
$c_scm_Map$WithDefault.prototype.sizeHint__I__V = (function(size) {
  /*<skip>*/
});
$c_scm_Map$WithDefault.prototype.toSeq__sc_GenSeq = (function() {
  return $f_scm_MapLike__toSeq__sc_Seq(this)
});
$c_scm_Map$WithDefault.prototype.$$minus$eq__O__scg_Shrinkable = (function(elem) {
  return this.$$minus$eq__O__scm_Map$WithDefault(elem)
});
$c_scm_Map$WithDefault.prototype.$$plus$eq__T2__scm_Map$WithDefault = (function(kv) {
  this.underlying$5.$$plus$eq__T2__scm_MapLike(kv);
  return this
});
$c_scm_Map$WithDefault.prototype.clear__V = (function() {
  $f_scm_MapLike__clear__V(this)
});
$c_scm_Map$WithDefault.prototype.$$minus__O__scm_Map = (function(key) {
  return this.$$minus__O__scm_Map$WithDefault(key)
});
$c_scm_Map$WithDefault.prototype.$$plus__T2__sc_GenMap = (function(kv) {
  return this.updated__O__O__scm_Map$WithDefault(kv.$$und1__O(), kv.$$und2__O())
});
$c_scm_Map$WithDefault.prototype.newBuilder__scm_Builder = (function() {
  return this.empty__scm_Map$WithDefault()
});
$c_scm_Map$WithDefault.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs)
});
var $d_scm_Map$WithDefault = new $TypeData().initClass({
  scm_Map$WithDefault: 0
}, false, "scala.collection.mutable.Map$WithDefault", {
  scm_Map$WithDefault: 1,
  sc_Map$WithDefault: 1,
  sc_AbstractMap: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Map: 1,
  sc_GenMap: 1,
  sc_GenMapLike: 1,
  sc_MapLike: 1,
  s_PartialFunction: 1,
  F1: 1,
  scg_Subtractable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1,
  scm_Map: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_MapLike: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  scg_Shrinkable: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1
});
$c_scm_Map$WithDefault.prototype.$classData = $d_scm_Map$WithDefault;
function $f_scm_IndexedSeqView__slice__I__I__scm_IndexedSeqView($thiz, from, until) {
  var jsx$1 = $m_scg_SliceInterval$();
  var that = $thiz.length__I();
  var _endpoints = jsx$1.apply__I__I__scg_SliceInterval(from, ((until < that) ? until : that));
  return new $c_scm_IndexedSeqView$$anon$2().init___scm_IndexedSeqView__scg_SliceInterval($thiz, _endpoints)
}
function $f_scm_IndexedSeqView__span__F1__T2($thiz, p) {
  return new $c_T2().init___O__O(new $c_scm_IndexedSeqView$$anon$4().init___scm_IndexedSeqView__F1($thiz, p), new $c_scm_IndexedSeqView$$anon$3().init___scm_IndexedSeqView__F1($thiz, p))
}
function $f_scm_IndexedSeqView__splitAt__I__T2($thiz, n) {
  return new $c_T2().init___O__O($f_scm_IndexedSeqView__take__I__scm_IndexedSeqView($thiz, n), $f_scm_IndexedSeqView__drop__I__scm_IndexedSeqView($thiz, n))
}
function $f_scm_IndexedSeqView__tail__scm_IndexedSeqView($thiz) {
  if ($f_sc_IndexedSeqOptimized__isEmpty__Z($thiz)) {
    return $thiz.scala$collection$mutable$IndexedSeqView$$super$tail__scm_IndexedSeqView()
  } else {
    var until = $thiz.length__I();
    return $f_scm_IndexedSeqView__slice__I__I__scm_IndexedSeqView($thiz, 1, until)
  }
}
function $f_scm_IndexedSeqView__drop__I__scm_IndexedSeqView($thiz, n) {
  var _endpoints = $m_scg_SliceInterval$().apply__I__I__scg_SliceInterval(n, $thiz.length__I());
  return new $c_scm_IndexedSeqView$$anon$2().init___scm_IndexedSeqView__scg_SliceInterval($thiz, _endpoints)
}
function $f_scm_IndexedSeqView__take__I__scm_IndexedSeqView($thiz, n) {
  var jsx$1 = $m_scg_SliceInterval$();
  var that = $thiz.length__I();
  var _endpoints = jsx$1.apply__I__I__scg_SliceInterval(0, ((n < that) ? n : that));
  return new $c_scm_IndexedSeqView$$anon$2().init___scm_IndexedSeqView__scg_SliceInterval($thiz, _endpoints)
}
function $is_scm_IndexedSeqView(obj) {
  return (!(!((obj && obj.$classData) && obj.$classData.ancestors.scm_IndexedSeqView)))
}
function $as_scm_IndexedSeqView(obj) {
  return (($is_scm_IndexedSeqView(obj) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.IndexedSeqView"))
}
function $isArrayOf_scm_IndexedSeqView(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_IndexedSeqView)))
}
function $asArrayOf_scm_IndexedSeqView(obj, depth) {
  return (($isArrayOf_scm_IndexedSeqView(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.IndexedSeqView;", depth))
}
/** @constructor */
function $c_scm_WrappedArray() {
  $c_scm_AbstractSeq.call(this)
}
$c_scm_WrappedArray.prototype = new $h_scm_AbstractSeq();
$c_scm_WrappedArray.prototype.constructor = $c_scm_WrappedArray;
/** @constructor */
function $h_scm_WrappedArray() {
  /*<skip>*/
}
$h_scm_WrappedArray.prototype = $c_scm_WrappedArray.prototype;
$c_scm_WrappedArray.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_scm_WrappedArray.prototype.head__O = (function() {
  return $f_sc_IndexedSeqOptimized__head__O(this)
});
$c_scm_WrappedArray.prototype.thisCollection__sc_Iterable = (function() {
  return this
});
$c_scm_WrappedArray.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_IndexedSeqOptimized__lengthCompare__I__I(this, len)
});
$c_scm_WrappedArray.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IndexedSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_scm_WrappedArray.prototype.exists__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__exists__F1__Z(this, p)
});
$c_scm_WrappedArray.prototype.isEmpty__Z = (function() {
  return $f_sc_IndexedSeqOptimized__isEmpty__Z(this)
});
$c_scm_WrappedArray.prototype.toList__sci_List = (function() {
  return $f_sc_IndexedSeqOptimized__toList__sci_List(this)
});
$c_scm_WrappedArray.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_scm_WrappedArray.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_scm_WrappedArray.prototype.scala$collection$IndexedSeqOptimized$$super$init__O = (function() {
  return $f_sc_TraversableLike__init__O(this)
});
$c_scm_WrappedArray.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__dropWhile__F1__O(this, p)
});
$c_scm_WrappedArray.prototype.forall__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__forall__F1__Z(this, p)
});
$c_scm_WrappedArray.prototype.companion__scg_GenericCompanion = (function() {
  return $m_scm_IndexedSeq$()
});
$c_scm_WrappedArray.prototype.foreach__F1__V = (function(f) {
  $f_sc_IndexedSeqOptimized__foreach__F1__V(this, f)
});
$c_scm_WrappedArray.prototype.foldLeft__O__F2__O = (function(z, op) {
  var start = 0;
  var end = this.length__I();
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_WrappedArray.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_IndexedSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_scm_WrappedArray.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__takeWhile__F1__O(this, p)
});
$c_scm_WrappedArray.prototype.slice__I__I__O = (function(from, until) {
  return $f_sc_IndexedSeqOptimized__slice__I__I__O(this, from, until)
});
$c_scm_WrappedArray.prototype.reverse__O = (function() {
  return $f_sc_IndexedSeqOptimized__reverse__O(this)
});
$c_scm_WrappedArray.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_IndexedSeqLike__toBuffer__scm_Buffer(this)
});
$c_scm_WrappedArray.prototype.seq__scm_Seq = (function() {
  return this
});
$c_scm_WrappedArray.prototype.iterator__sc_Iterator = (function() {
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, this.length__I())
});
$c_scm_WrappedArray.prototype.span__F1__T2 = (function(p) {
  return $f_sc_IndexedSeqOptimized__span__F1__T2(this, p)
});
$c_scm_WrappedArray.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_IndexedSeqOptimized__find__F1__s_Option(this, p)
});
$c_scm_WrappedArray.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IndexedSeqOptimized__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_scm_WrappedArray.prototype.scala$collection$IndexedSeqOptimized$$super$tail__O = (function() {
  return $f_sc_TraversableLike__tail__O(this)
});
$c_scm_WrappedArray.prototype.scala$collection$IndexedSeqOptimized$$super$last__O = (function() {
  return $f_sc_TraversableLike__last__O(this)
});
$c_scm_WrappedArray.prototype.seq__sc_Seq = (function() {
  return this
});
$c_scm_WrappedArray.prototype.sizeHintIfCheap__I = (function() {
  return this.length__I()
});
$c_scm_WrappedArray.prototype.splitAt__I__T2 = (function(n) {
  return $f_sc_IndexedSeqOptimized__splitAt__I__T2(this, n)
});
$c_scm_WrappedArray.prototype.take__I__O = (function(n) {
  return $f_sc_IndexedSeqOptimized__slice__I__I__O(this, 0, n)
});
$c_scm_WrappedArray.prototype.last__O = (function() {
  return $f_sc_IndexedSeqOptimized__last__O(this)
});
$c_scm_WrappedArray.prototype.view__sc_SeqView = (function() {
  return new $c_scm_IndexedSeqLike$$anon$1().init___scm_IndexedSeqLike(this)
});
$c_scm_WrappedArray.prototype.drop__I__O = (function(n) {
  var until = this.length__I();
  return $f_sc_IndexedSeqOptimized__slice__I__I__O(this, n, until)
});
$c_scm_WrappedArray.prototype.thisCollection__sc_Seq = (function() {
  return this
});
$c_scm_WrappedArray.prototype.tail__O = (function() {
  return $f_sc_IndexedSeqOptimized__tail__O(this)
});
$c_scm_WrappedArray.prototype.isDefinedAt__O__Z = (function(x) {
  var idx = $uI(x);
  return $f_sc_GenSeqLike__isDefinedAt__I__Z(this, idx)
});
$c_scm_WrappedArray.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_sc_IndexedSeqOptimized__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_scm_WrappedArray.prototype.toSeq__sc_GenSeq = (function() {
  return this
});
$c_scm_WrappedArray.prototype.scala$collection$IndexedSeqOptimized$$super$zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_IterableLike__zip__sc_GenIterable__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_WrappedArray.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  var thatElementClass = evidence$1.runtimeClass__jl_Class();
  return ((this.elementClass__p5__jl_Class() === thatElementClass) ? this.array__O() : $f_sc_TraversableOnce__toArray__s_reflect_ClassTag__O(this, evidence$1))
});
$c_scm_WrappedArray.prototype.elementClass__p5__jl_Class = (function() {
  var this$1 = this.array__O();
  return $objectGetClass(this$1).getComponentType__jl_Class()
});
$c_scm_WrappedArray.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_IndexedSeqOptimized__reduceLeft__F2__O(this, op)
});
$c_scm_WrappedArray.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_WrappedArrayBuilder().init___s_reflect_ClassTag(this.elemTag__s_reflect_ClassTag())
});
$c_scm_WrappedArray.prototype.stringPrefix__T = (function() {
  return "WrappedArray"
});
function $as_scm_WrappedArray(obj) {
  return (((obj instanceof $c_scm_WrappedArray) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.WrappedArray"))
}
function $isArrayOf_scm_WrappedArray(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_WrappedArray)))
}
function $asArrayOf_scm_WrappedArray(obj, depth) {
  return (($isArrayOf_scm_WrappedArray(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.WrappedArray;", depth))
}
/** @constructor */
function $c_scm_ArraySeq() {
  $c_scm_AbstractSeq.call(this);
  this.length$5 = 0;
  this.array$5 = null
}
$c_scm_ArraySeq.prototype = new $h_scm_AbstractSeq();
$c_scm_ArraySeq.prototype.constructor = $c_scm_ArraySeq;
/** @constructor */
function $h_scm_ArraySeq() {
  /*<skip>*/
}
$h_scm_ArraySeq.prototype = $c_scm_ArraySeq.prototype;
$c_scm_ArraySeq.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_scm_ArraySeq.prototype.head__O = (function() {
  return $f_sc_IndexedSeqOptimized__head__O(this)
});
$c_scm_ArraySeq.prototype.apply__I__O = (function(idx) {
  if ((idx >= this.length$5)) {
    throw new $c_jl_IndexOutOfBoundsException().init___T(("" + idx))
  };
  return this.array$5.get(idx)
});
$c_scm_ArraySeq.prototype.thisCollection__sc_Iterable = (function() {
  return this
});
$c_scm_ArraySeq.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_IndexedSeqOptimized__lengthCompare__I__I(this, len)
});
$c_scm_ArraySeq.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IndexedSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_scm_ArraySeq.prototype.apply__O__O = (function(v1) {
  return this.apply__I__O($uI(v1))
});
$c_scm_ArraySeq.prototype.exists__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__exists__F1__Z(this, p)
});
$c_scm_ArraySeq.prototype.toList__sci_List = (function() {
  return $f_sc_IndexedSeqOptimized__toList__sci_List(this)
});
$c_scm_ArraySeq.prototype.isEmpty__Z = (function() {
  return $f_sc_IndexedSeqOptimized__isEmpty__Z(this)
});
$c_scm_ArraySeq.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_scm_ArraySeq.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_scm_ArraySeq.prototype.scala$collection$IndexedSeqOptimized$$super$init__O = (function() {
  return $f_sc_TraversableLike__init__O(this)
});
$c_scm_ArraySeq.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__dropWhile__F1__O(this, p)
});
$c_scm_ArraySeq.prototype.forall__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__forall__F1__Z(this, p)
});
$c_scm_ArraySeq.prototype.companion__scg_GenericCompanion = (function() {
  return $m_scm_ArraySeq$()
});
$c_scm_ArraySeq.prototype.foreach__F1__V = (function(f) {
  var i = 0;
  while ((i < this.length$5)) {
    f.apply__O__O(this.array$5.get(i));
    i = ((1 + i) | 0)
  }
});
$c_scm_ArraySeq.prototype.foldLeft__O__F2__O = (function(z, op) {
  var start = 0;
  var end = this.length$5;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArraySeq.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_IndexedSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_scm_ArraySeq.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__takeWhile__F1__O(this, p)
});
$c_scm_ArraySeq.prototype.slice__I__I__O = (function(from, until) {
  return $f_sc_IndexedSeqOptimized__slice__I__I__O(this, from, until)
});
$c_scm_ArraySeq.prototype.reverse__O = (function() {
  return $f_sc_IndexedSeqOptimized__reverse__O(this)
});
$c_scm_ArraySeq.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_IndexedSeqLike__toBuffer__scm_Buffer(this)
});
$c_scm_ArraySeq.prototype.iterator__sc_Iterator = (function() {
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, this.length$5)
});
$c_scm_ArraySeq.prototype.seq__scm_Seq = (function() {
  return this
});
$c_scm_ArraySeq.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_IndexedSeqOptimized__find__F1__s_Option(this, p)
});
$c_scm_ArraySeq.prototype.span__F1__T2 = (function(p) {
  return $f_sc_IndexedSeqOptimized__span__F1__T2(this, p)
});
$c_scm_ArraySeq.prototype.init___I = (function(length) {
  this.length$5 = length;
  this.array$5 = $newArrayObject($d_O.getArrayOf(), [length]);
  return this
});
$c_scm_ArraySeq.prototype.length__I = (function() {
  return this.length$5
});
$c_scm_ArraySeq.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IndexedSeqOptimized__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_scm_ArraySeq.prototype.scala$collection$IndexedSeqOptimized$$super$last__O = (function() {
  return $f_sc_TraversableLike__last__O(this)
});
$c_scm_ArraySeq.prototype.scala$collection$IndexedSeqOptimized$$super$tail__O = (function() {
  return $f_sc_TraversableLike__tail__O(this)
});
$c_scm_ArraySeq.prototype.seq__sc_Seq = (function() {
  return this
});
$c_scm_ArraySeq.prototype.sizeHintIfCheap__I = (function() {
  return this.length$5
});
$c_scm_ArraySeq.prototype.splitAt__I__T2 = (function(n) {
  return $f_sc_IndexedSeqOptimized__splitAt__I__T2(this, n)
});
$c_scm_ArraySeq.prototype.take__I__O = (function(n) {
  return $f_sc_IndexedSeqOptimized__slice__I__I__O(this, 0, n)
});
$c_scm_ArraySeq.prototype.view__sc_SeqView = (function() {
  return new $c_scm_IndexedSeqLike$$anon$1().init___scm_IndexedSeqLike(this)
});
$c_scm_ArraySeq.prototype.last__O = (function() {
  return $f_sc_IndexedSeqOptimized__last__O(this)
});
$c_scm_ArraySeq.prototype.drop__I__O = (function(n) {
  var until = this.length$5;
  return $f_sc_IndexedSeqOptimized__slice__I__I__O(this, n, until)
});
$c_scm_ArraySeq.prototype.thisCollection__sc_Seq = (function() {
  return this
});
$c_scm_ArraySeq.prototype.tail__O = (function() {
  return $f_sc_IndexedSeqOptimized__tail__O(this)
});
$c_scm_ArraySeq.prototype.isDefinedAt__O__Z = (function(x) {
  var idx = $uI(x);
  return $f_sc_GenSeqLike__isDefinedAt__I__Z(this, idx)
});
$c_scm_ArraySeq.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  var that = (($m_sr_ScalaRunTime$().array$undlength__O__I(xs) - start) | 0);
  var x = ((len < that) ? len : that);
  var that$1 = this.length$5;
  var len1 = ((x < that$1) ? x : that$1);
  if ((len1 > 0)) {
    $m_s_Array$().copy__O__I__O__I__I__V(this.array$5, 0, xs, start, len1)
  }
});
$c_scm_ArraySeq.prototype.toSeq__sc_GenSeq = (function() {
  return this
});
$c_scm_ArraySeq.prototype.hashCode__I = (function() {
  return $m_s_util_hashing_MurmurHash3$().seqHash__sc_Seq__I(this)
});
$c_scm_ArraySeq.prototype.scala$collection$IndexedSeqOptimized$$super$zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_IterableLike__zip__sc_GenIterable__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArraySeq.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_IndexedSeqOptimized__reduceLeft__F2__O(this, op)
});
var $d_scm_ArraySeq = new $TypeData().initClass({
  scm_ArraySeq: 0
}, false, "scala.collection.mutable.ArraySeq", {
  scm_ArraySeq: 1,
  scm_AbstractSeq: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_IndexedSeq: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  scm_IndexedSeqLike: 1,
  scm_IndexedSeqOptimized: 1,
  sc_IndexedSeqOptimized: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_ArraySeq.prototype.$classData = $d_scm_ArraySeq;
/** @constructor */
function $c_scm_LinkedHashMap() {
  $c_scm_AbstractMap.call(this);
  this.firstEntry$5 = null;
  this.lastEntry$5 = null;
  this.$$undloadFactor$5 = 0;
  this.table$5 = null;
  this.tableSize$5 = 0;
  this.threshold$5 = 0;
  this.sizemap$5 = null;
  this.seedvalue$5 = 0
}
$c_scm_LinkedHashMap.prototype = new $h_scm_AbstractMap();
$c_scm_LinkedHashMap.prototype.constructor = $c_scm_LinkedHashMap;
/** @constructor */
function $h_scm_LinkedHashMap() {
  /*<skip>*/
}
$h_scm_LinkedHashMap.prototype = $c_scm_LinkedHashMap.prototype;
$c_scm_LinkedHashMap.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_scm_LinkedHashMap.prototype.put__O__O__s_Option = (function(key, value) {
  var e = $as_scm_LinkedEntry($f_scm_HashTable__findOrAddEntry__O__O__scm_HashEntry(this, key, value));
  if ((e === null)) {
    return $m_s_None$()
  } else {
    var v = e.value$1;
    e.value$1 = value;
    return new $c_s_Some().init___O(v)
  }
});
$c_scm_LinkedHashMap.prototype.init___ = (function() {
  $f_scm_HashTable__$$init$__V(this);
  this.firstEntry$5 = null;
  this.lastEntry$5 = null;
  return this
});
$c_scm_LinkedHashMap.prototype.$$minus$eq__O__scm_MapLike = (function(key) {
  return this.$$minus$eq__O__scm_LinkedHashMap(key)
});
$c_scm_LinkedHashMap.prototype.seedvalue$und$eq__I__V = (function(x$1) {
  this.seedvalue$5 = x$1
});
$c_scm_LinkedHashMap.prototype.tableSize__I = (function() {
  return this.tableSize$5
});
$c_scm_LinkedHashMap.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  var this$2 = new $c_scm_LinkedHashMap().init___();
  return $as_scm_Map($as_scm_Map($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$2, this)).$$minus$eq__O__scm_MapLike(elem))
});
$c_scm_LinkedHashMap.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_scm_LinkedHashMap.prototype.remove__O__s_Option = (function(key) {
  var e = $as_scm_LinkedEntry($f_scm_HashTable__removeEntry__O__scm_HashEntry(this, key));
  if ((e === null)) {
    return $m_s_None$()
  } else {
    if ((e.earlier$1 === null)) {
      this.firstEntry$5 = e.later$1
    } else {
      e.earlier$1.later$1 = e.later$1
    };
    if ((e.later$1 === null)) {
      this.lastEntry$5 = e.earlier$1
    } else {
      e.later$1.earlier$1 = e.earlier$1
    };
    e.earlier$1 = null;
    e.later$1 = null;
    return new $c_s_Some().init___O(e.value$1)
  }
});
$c_scm_LinkedHashMap.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__T2__scm_LinkedHashMap($as_T2(elem))
});
$c_scm_LinkedHashMap.prototype.$$minus$eq__O__scm_LinkedHashMap = (function(key) {
  this.remove__O__s_Option(key);
  return this
});
$c_scm_LinkedHashMap.prototype.foreach__F1__V = (function(f) {
  var cur = this.firstEntry$5;
  while ((cur !== null)) {
    f.apply__O__O(new $c_T2().init___O__O(cur.key$1, cur.value$1));
    cur = cur.later$1
  }
});
$c_scm_LinkedHashMap.prototype.keysIterator__sc_Iterator = (function() {
  return new $c_scm_LinkedHashMap$$anon$2().init___scm_LinkedHashMap(this)
});
$c_scm_LinkedHashMap.prototype.$$minus__O__sc_Map = (function(key) {
  var this$2 = new $c_scm_LinkedHashMap().init___();
  return $as_scm_Map($as_scm_Map($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$2, this)).$$minus$eq__O__scm_MapLike(key))
});
$c_scm_LinkedHashMap.prototype.empty__sc_Map = (function() {
  return new $c_scm_LinkedHashMap().init___()
});
$c_scm_LinkedHashMap.prototype.table__Ascm_HashEntry = (function() {
  return this.table$5
});
$c_scm_LinkedHashMap.prototype.size__I = (function() {
  return this.tableSize$5
});
$c_scm_LinkedHashMap.prototype.seq__sc_Map = (function() {
  return this
});
$c_scm_LinkedHashMap.prototype.result__O = (function() {
  return this
});
$c_scm_LinkedHashMap.prototype.iterator__sc_Iterator = (function() {
  return new $c_scm_LinkedHashMap$$anon$1().init___scm_LinkedHashMap(this)
});
$c_scm_LinkedHashMap.prototype.empty__scm_Map = (function() {
  return new $c_scm_LinkedHashMap().init___()
});
$c_scm_LinkedHashMap.prototype.valuesIterator__sc_Iterator = (function() {
  return new $c_scm_LinkedHashMap$$anon$3().init___scm_LinkedHashMap(this)
});
$c_scm_LinkedHashMap.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_MapLike__filterNot__F1__sc_Map(this, p)
});
$c_scm_LinkedHashMap.prototype.createNewEntry__O__O__scm_HashEntry = (function(key, value) {
  return this.createNewEntry__O__O__scm_LinkedEntry(key, value)
});
$c_scm_LinkedHashMap.prototype.get__O__s_Option = (function(key) {
  var e = $as_scm_LinkedEntry($f_scm_HashTable__findEntry__O__scm_HashEntry(this, key));
  return ((e === null) ? $m_s_None$() : new $c_s_Some().init___O(e.value$1))
});
$c_scm_LinkedHashMap.prototype.$$plus$eq__T2__scm_MapLike = (function(kv) {
  return this.$$plus$eq__T2__scm_LinkedHashMap(kv)
});
$c_scm_LinkedHashMap.prototype.sizemap$und$eq__AI__V = (function(x$1) {
  this.sizemap$5 = x$1
});
$c_scm_LinkedHashMap.prototype.seedvalue__I = (function() {
  return this.seedvalue$5
});
$c_scm_LinkedHashMap.prototype.table$und$eq__Ascm_HashEntry__V = (function(x$1) {
  this.table$5 = x$1
});
$c_scm_LinkedHashMap.prototype.initialSize__I = (function() {
  return 16
});
$c_scm_LinkedHashMap.prototype.$$undloadFactor__I = (function() {
  return this.$$undloadFactor$5
});
$c_scm_LinkedHashMap.prototype.threshold__I = (function() {
  return this.threshold$5
});
$c_scm_LinkedHashMap.prototype.keySet__sc_Set = (function() {
  return new $c_scm_LinkedHashMap$DefaultKeySet().init___scm_LinkedHashMap(this)
});
$c_scm_LinkedHashMap.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__T2__scm_LinkedHashMap($as_T2(elem))
});
$c_scm_LinkedHashMap.prototype.toSeq__sc_GenSeq = (function() {
  return $f_scm_MapLike__toSeq__sc_Seq(this)
});
$c_scm_LinkedHashMap.prototype.$$minus$eq__O__scg_Shrinkable = (function(elem) {
  return this.$$minus$eq__O__scm_LinkedHashMap(elem)
});
$c_scm_LinkedHashMap.prototype.clear__V = (function() {
  $f_scm_HashTable__clearTable__V(this);
  this.firstEntry$5 = null;
  this.lastEntry$5 = null
});
$c_scm_LinkedHashMap.prototype.sizemap__AI = (function() {
  return this.sizemap$5
});
$c_scm_LinkedHashMap.prototype.createNewEntry__O__O__scm_LinkedEntry = (function(key, value) {
  var e = new $c_scm_LinkedEntry().init___O__O(key, value);
  if ((this.firstEntry$5 === null)) {
    this.firstEntry$5 = e
  } else {
    this.lastEntry$5.later$1 = e;
    e.earlier$1 = this.lastEntry$5
  };
  this.lastEntry$5 = e;
  return e
});
$c_scm_LinkedHashMap.prototype.$$plus$eq__T2__scm_LinkedHashMap = (function(kv) {
  this.put__O__O__s_Option(kv.$$und1__O(), kv.$$und2__O());
  return this
});
$c_scm_LinkedHashMap.prototype.$$undloadFactor$und$eq__I__V = (function(x$1) {
  this.$$undloadFactor$5 = x$1
});
$c_scm_LinkedHashMap.prototype.threshold$und$eq__I__V = (function(x$1) {
  this.threshold$5 = x$1
});
$c_scm_LinkedHashMap.prototype.$$plus__T2__sc_GenMap = (function(kv) {
  var this$2 = new $c_scm_LinkedHashMap().init___();
  return $as_scm_Map($as_scm_Map($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$2, this)).$$plus$eq__T2__scm_MapLike(kv))
});
$c_scm_LinkedHashMap.prototype.tableSize$und$eq__I__V = (function(x$1) {
  this.tableSize$5 = x$1
});
function $as_scm_LinkedHashMap(obj) {
  return (((obj instanceof $c_scm_LinkedHashMap) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.LinkedHashMap"))
}
function $isArrayOf_scm_LinkedHashMap(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_LinkedHashMap)))
}
function $asArrayOf_scm_LinkedHashMap(obj, depth) {
  return (($isArrayOf_scm_LinkedHashMap(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.LinkedHashMap;", depth))
}
var $d_scm_LinkedHashMap = new $TypeData().initClass({
  scm_LinkedHashMap: 0
}, false, "scala.collection.mutable.LinkedHashMap", {
  scm_LinkedHashMap: 1,
  scm_AbstractMap: 1,
  sc_AbstractMap: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Map: 1,
  sc_GenMap: 1,
  sc_GenMapLike: 1,
  sc_MapLike: 1,
  s_PartialFunction: 1,
  F1: 1,
  scg_Subtractable: 1,
  scm_Map: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_MapLike: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  scg_Shrinkable: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_HashTable: 1,
  scm_HashTable$HashUtils: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_LinkedHashMap.prototype.$classData = $d_scm_LinkedHashMap;
/** @constructor */
function $c_scm_MutableList() {
  $c_scm_AbstractSeq.call(this);
  this.first0$5 = null;
  this.last0$5 = null;
  this.len$5 = 0
}
$c_scm_MutableList.prototype = new $h_scm_AbstractSeq();
$c_scm_MutableList.prototype.constructor = $c_scm_MutableList;
/** @constructor */
function $h_scm_MutableList() {
  /*<skip>*/
}
$h_scm_MutableList.prototype = $c_scm_MutableList.prototype;
$c_scm_MutableList.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_scm_MutableList.prototype.head__O = (function() {
  if ($f_sc_TraversableOnce__nonEmpty__Z(this)) {
    var this$1 = this.first0$5;
    return $f_scm_LinkedListLike__head__O(this$1)
  } else {
    throw new $c_ju_NoSuchElementException().init___()
  }
});
$c_scm_MutableList.prototype.init___ = (function() {
  this.first0$5 = new $c_scm_LinkedList().init___();
  this.last0$5 = this.first0$5;
  this.len$5 = 0;
  return this
});
$c_scm_MutableList.prototype.apply__I__O = (function(n) {
  var this$1 = this.first0$5;
  return $f_scm_LinkedListLike__apply__I__O(this$1, n)
});
$c_scm_MutableList.prototype.thisCollection__sc_Iterable = (function() {
  return this
});
$c_scm_MutableList.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_LinearSeqOptimized__lengthCompare__I__I(this, len)
});
$c_scm_MutableList.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_LinearSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_scm_MutableList.prototype.apply__O__O = (function(v1) {
  var n = $uI(v1);
  var this$1 = this.first0$5;
  return $f_scm_LinkedListLike__apply__I__O(this$1, n)
});
$c_scm_MutableList.prototype.exists__F1__Z = (function(p) {
  return $f_sc_LinearSeqOptimized__exists__F1__Z(this, p)
});
$c_scm_MutableList.prototype.toList__sci_List = (function() {
  var this$1 = this.first0$5;
  var this$2 = $m_sci_List$();
  var cbf = this$2.ReusableCBFInstance$2;
  return $as_sci_List($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this$1, cbf))
});
$c_scm_MutableList.prototype.isEmpty__Z = (function() {
  return (this.len$5 === 0)
});
$c_scm_MutableList.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_scm_MutableList.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_scm_MutableList.prototype.prependElem__O__V = (function(elem) {
  this.first0$5 = new $c_scm_LinkedList().init___O__scm_LinkedList(elem, this.first0$5);
  if ((this.len$5 === 0)) {
    this.last0$5 = this.first0$5
  };
  this.len$5 = ((1 + this.len$5) | 0)
});
$c_scm_MutableList.prototype.drop__I__sc_LinearSeqOptimized = (function(n) {
  return $f_sc_LinearSeqOptimized__drop__I__sc_LinearSeqOptimized(this, n)
});
$c_scm_MutableList.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__O__scm_MutableList(elem)
});
$c_scm_MutableList.prototype.forall__F1__Z = (function(p) {
  return $f_sc_LinearSeqOptimized__forall__F1__Z(this, p)
});
$c_scm_MutableList.prototype.companion__scg_GenericCompanion = (function() {
  return $m_scm_MutableList$()
});
$c_scm_MutableList.prototype.foreach__F1__V = (function(f) {
  $f_sc_LinearSeqOptimized__foreach__F1__V(this, f)
});
$c_scm_MutableList.prototype.foldLeft__O__F2__O = (function(z, op) {
  return $f_sc_LinearSeqOptimized__foldLeft__O__F2__O(this, z, op)
});
$c_scm_MutableList.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_LinearSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_scm_MutableList.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_LinearSeqOptimized__takeWhile__F1__sc_LinearSeqOptimized(this, p)
});
$c_scm_MutableList.prototype.tailImpl__scm_MutableList__V = (function(tl) {
  var requirement = $f_sc_TraversableOnce__nonEmpty__Z(this);
  if ((!requirement)) {
    throw new $c_jl_IllegalArgumentException().init___T("requirement failed: tail of empty list")
  };
  var this$2 = this.first0$5;
  tl.first0$5 = $as_scm_LinkedList($f_scm_LinkedListLike__tail__scm_Seq(this$2));
  tl.len$5 = (((-1) + this.len$5) | 0);
  tl.last0$5 = ((tl.len$5 === 0) ? tl.first0$5 : this.last0$5)
});
$c_scm_MutableList.prototype.result__O = (function() {
  return this
});
$c_scm_MutableList.prototype.iterator__sc_Iterator = (function() {
  return (this.isEmpty__Z() ? $m_sc_Iterator$().empty$1 : new $c_scm_MutableList$$anon$1().init___scm_MutableList(this))
});
$c_scm_MutableList.prototype.seq__scm_Seq = (function() {
  return this
});
$c_scm_MutableList.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_LinearSeqOptimized__find__F1__s_Option(this, p)
});
$c_scm_MutableList.prototype.sizeHintBounded__I__sc_TraversableLike__V = (function(size, boundingColl) {
  $f_scm_Builder__sizeHintBounded__I__sc_TraversableLike__V(this, size, boundingColl)
});
$c_scm_MutableList.prototype.span__F1__T2 = (function(p) {
  return $f_sc_LinearSeqOptimized__span__F1__T2(this, p)
});
$c_scm_MutableList.prototype.length__I = (function() {
  return this.len$5
});
$c_scm_MutableList.prototype.seq__sc_Seq = (function() {
  return this
});
$c_scm_MutableList.prototype.take__I__O = (function(n) {
  return $f_sc_LinearSeqOptimized__take__I__sc_LinearSeqOptimized(this, n)
});
$c_scm_MutableList.prototype.last__O = (function() {
  if (this.isEmpty__Z()) {
    throw new $c_ju_NoSuchElementException().init___T("MutableList.empty.last")
  };
  return this.last0$5.elem$5
});
$c_scm_MutableList.prototype.drop__I__O = (function(n) {
  return $f_sc_LinearSeqOptimized__drop__I__sc_LinearSeqOptimized(this, n)
});
$c_scm_MutableList.prototype.contains__O__Z = (function(elem) {
  return $f_sc_LinearSeqOptimized__contains__O__Z(this, elem)
});
$c_scm_MutableList.prototype.thisCollection__sc_Seq = (function() {
  return this
});
$c_scm_MutableList.prototype.tail__O = (function() {
  return this.tail__scm_MutableList()
});
$c_scm_MutableList.prototype.appendElem__O__V = (function(elem) {
  if ((this.len$5 === 0)) {
    this.prependElem__O__V(elem)
  } else {
    var this$1 = this.last0$5;
    var x$1 = new $c_scm_LinkedList().init___();
    this$1.next$5 = x$1;
    var this$2 = this.last0$5;
    this.last0$5 = this$2.next$5;
    this.last0$5.elem$5 = elem;
    var this$3 = this.last0$5;
    var x$1$1 = new $c_scm_LinkedList().init___();
    this$3.next$5 = x$1$1;
    this.len$5 = ((1 + this.len$5) | 0)
  }
});
$c_scm_MutableList.prototype.isDefinedAt__O__Z = (function(x) {
  var x$1 = $uI(x);
  return $f_sc_LinearSeqOptimized__isDefinedAt__I__Z(this, x$1)
});
$c_scm_MutableList.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__O__scm_MutableList(elem)
});
$c_scm_MutableList.prototype.sizeHint__I__V = (function(size) {
  /*<skip>*/
});
$c_scm_MutableList.prototype.toSeq__sc_GenSeq = (function() {
  return this
});
$c_scm_MutableList.prototype.hashCode__I = (function() {
  return $m_s_util_hashing_MurmurHash3$().seqHash__sc_Seq__I(this)
});
$c_scm_MutableList.prototype.$$plus$eq__O__scm_MutableList = (function(elem) {
  this.appendElem__O__V(elem);
  return this
});
$c_scm_MutableList.prototype.tail__scm_MutableList = (function() {
  var tl = new $c_scm_MutableList().init___();
  this.tailImpl__scm_MutableList__V(tl);
  return tl
});
$c_scm_MutableList.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_LinearSeqOptimized__reduceLeft__F2__O(this, op)
});
$c_scm_MutableList.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_MutableList().init___()
});
$c_scm_MutableList.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs)
});
function $as_scm_MutableList(obj) {
  return (((obj instanceof $c_scm_MutableList) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.MutableList"))
}
function $isArrayOf_scm_MutableList(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_MutableList)))
}
function $asArrayOf_scm_MutableList(obj, depth) {
  return (($isArrayOf_scm_MutableList(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.MutableList;", depth))
}
var $d_scm_MutableList = new $TypeData().initClass({
  scm_MutableList: 0
}, false, "scala.collection.mutable.MutableList", {
  scm_MutableList: 1,
  scm_AbstractSeq: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_LinearSeq: 1,
  sc_LinearSeq: 1,
  sc_LinearSeqLike: 1,
  sc_LinearSeqOptimized: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_MutableList.prototype.$classData = $d_scm_MutableList;
/** @constructor */
function $c_scm_HashMap() {
  $c_scm_AbstractMap.call(this);
  this.$$undloadFactor$5 = 0;
  this.table$5 = null;
  this.tableSize$5 = 0;
  this.threshold$5 = 0;
  this.sizemap$5 = null;
  this.seedvalue$5 = 0
}
$c_scm_HashMap.prototype = new $h_scm_AbstractMap();
$c_scm_HashMap.prototype.constructor = $c_scm_HashMap;
/** @constructor */
function $h_scm_HashMap() {
  /*<skip>*/
}
$h_scm_HashMap.prototype = $c_scm_HashMap.prototype;
$c_scm_HashMap.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_scm_HashMap.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_scm_HashMap.prototype.put__O__O__s_Option = (function(key, value) {
  var e = $as_scm_DefaultEntry($f_scm_HashTable__findOrAddEntry__O__O__scm_HashEntry(this, key, value));
  if ((e === null)) {
    return $m_s_None$()
  } else {
    var v = e.value$1;
    e.value$1 = value;
    return new $c_s_Some().init___O(v)
  }
});
$c_scm_HashMap.prototype.init___ = (function() {
  $c_scm_HashMap.prototype.init___scm_HashTable$Contents.call(this, null);
  return this
});
$c_scm_HashMap.prototype.$$minus$eq__O__scm_MapLike = (function(key) {
  return this.$$minus$eq__O__scm_HashMap(key)
});
$c_scm_HashMap.prototype.seedvalue$und$eq__I__V = (function(x$1) {
  this.seedvalue$5 = x$1
});
$c_scm_HashMap.prototype.apply__O__O = (function(key) {
  var result = $as_scm_DefaultEntry($f_scm_HashTable__findEntry__O__scm_HashEntry(this, key));
  return ((result === null) ? this.$default__O__O(key) : result.value$1)
});
$c_scm_HashMap.prototype.tableSize__I = (function() {
  return this.tableSize$5
});
$c_scm_HashMap.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  var this$2 = new $c_scm_HashMap().init___();
  return $as_scm_Map($as_scm_Map($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$2, this)).$$minus$eq__O__scm_MapLike(elem))
});
$c_scm_HashMap.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_scm_HashMap.prototype.remove__O__s_Option = (function(key) {
  var e = $as_scm_DefaultEntry($f_scm_HashTable__removeEntry__O__scm_HashEntry(this, key));
  return ((e !== null) ? new $c_s_Some().init___O(e.value$1) : $m_s_None$())
});
$c_scm_HashMap.prototype.addEntry0__p5__scm_DefaultEntry__I__V = (function(e, h) {
  var x$1 = $as_scm_DefaultEntry(this.table$5.get(h));
  e.next$1 = x$1;
  this.table$5.set(h, e);
  this.tableSize$5 = ((1 + this.tableSize$5) | 0);
  $f_scm_HashTable__nnSizeMapAdd__I__V(this, h)
});
$c_scm_HashMap.prototype.$$plus$eq__T2__scm_HashMap = (function(kv) {
  var key = kv.$$und1__O();
  var value = kv.$$und2__O();
  var e = $as_scm_DefaultEntry($f_scm_HashTable__findOrAddEntry__O__O__scm_HashEntry(this, key, value));
  if ((e !== null)) {
    e.value$1 = kv.$$und2__O()
  };
  return this
});
$c_scm_HashMap.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__T2__scm_HashMap($as_T2(elem))
});
$c_scm_HashMap.prototype.foreach__F1__V = (function(f) {
  var iterTable = this.table$5;
  var idx = $f_scm_HashTable__scala$collection$mutable$HashTable$$lastPopulatedIndex__I(this);
  var es = iterTable.get(idx);
  while ((es !== null)) {
    var next = $as_scm_HashEntry(es.next__O());
    var arg1 = es;
    var e = $as_scm_DefaultEntry(arg1);
    f.apply__O__O(new $c_T2().init___O__O(e.key$1, e.value$1));
    es = next;
    while (((es === null) && (idx > 0))) {
      idx = (((-1) + idx) | 0);
      es = iterTable.get(idx)
    }
  }
});
$c_scm_HashMap.prototype.findEntry__p5__O__I__scm_DefaultEntry = (function(key, h) {
  var e = $as_scm_DefaultEntry(this.table$5.get(h));
  while (this.notFound__p5__O__scm_DefaultEntry__Z(key, e)) {
    var this$1 = e;
    e = this$1.next$1
  };
  return e
});
$c_scm_HashMap.prototype.keysIterator__sc_Iterator = (function() {
  return new $c_scm_HashMap$$anon$3().init___scm_HashMap(this)
});
$c_scm_HashMap.prototype.$$minus__O__sc_Map = (function(key) {
  var this$2 = new $c_scm_HashMap().init___();
  return $as_scm_Map($as_scm_Map($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$2, this)).$$minus$eq__O__scm_MapLike(key))
});
$c_scm_HashMap.prototype.empty__sc_Map = (function() {
  return new $c_scm_HashMap().init___()
});
$c_scm_HashMap.prototype.table__Ascm_HashEntry = (function() {
  return this.table$5
});
$c_scm_HashMap.prototype.update__O__O__V = (function(key, value) {
  this.put__O__O__s_Option(key, value)
});
$c_scm_HashMap.prototype.size__I = (function() {
  return this.tableSize$5
});
$c_scm_HashMap.prototype.seq__sc_Map = (function() {
  return this
});
$c_scm_HashMap.prototype.result__O = (function() {
  return this
});
$c_scm_HashMap.prototype.values__sc_Iterable = (function() {
  return new $c_scm_HashMap$$anon$2().init___scm_HashMap(this)
});
$c_scm_HashMap.prototype.iterator__sc_Iterator = (function() {
  var this$1 = new $c_scm_HashTable$$anon$1().init___scm_HashTable(this);
  var f = new $c_sjsr_AnonFunction1().init___sjs_js_Function1((function($this) {
    return (function(e$2) {
      var e = $as_scm_DefaultEntry(e$2);
      return new $c_T2().init___O__O(e.key$1, e.value$1)
    })
  })(this));
  return new $c_sc_Iterator$$anon$10().init___sc_Iterator__F1(this$1, f)
});
$c_scm_HashMap.prototype.empty__scm_Map = (function() {
  return new $c_scm_HashMap().init___()
});
$c_scm_HashMap.prototype.valuesIterator__sc_Iterator = (function() {
  return new $c_scm_HashMap$$anon$4().init___scm_HashMap(this)
});
$c_scm_HashMap.prototype.init___scm_HashTable$Contents = (function(contents) {
  $f_scm_HashTable__$$init$__V(this);
  $f_scm_HashTable__initWithContents__scm_HashTable$Contents__V(this, contents);
  return this
});
$c_scm_HashMap.prototype.notFound__p5__O__scm_DefaultEntry__Z = (function(key, e) {
  if ((e !== null)) {
    var key1 = e.key$1;
    return (!$m_sr_BoxesRunTime$().equals__O__O__Z(key1, key))
  } else {
    return false
  }
});
$c_scm_HashMap.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_MapLike__filterNot__F1__sc_Map(this, p)
});
$c_scm_HashMap.prototype.getOrElseUpdate__O__F0__O = (function(key, defaultValue) {
  var hash = $m_sr_Statics$().anyHash__O__I(key);
  var i = $f_scm_HashTable__index__I__I(this, hash);
  var firstEntry = this.findEntry__p5__O__I__scm_DefaultEntry(key, i);
  if ((firstEntry !== null)) {
    return firstEntry.value$1
  } else {
    var table0 = this.table$5;
    var $default = defaultValue.apply__O();
    var newEntryIndex = ((table0 === this.table$5) ? i : $f_scm_HashTable__index__I__I(this, hash));
    var e = new $c_scm_DefaultEntry().init___O__O(key, $default);
    var secondEntry = this.findEntry__p5__O__I__scm_DefaultEntry(key, newEntryIndex);
    if ((secondEntry === null)) {
      this.addEntry__p5__scm_DefaultEntry__I__O(e, newEntryIndex)
    } else {
      secondEntry.value$1 = $default
    };
    return $default
  }
});
$c_scm_HashMap.prototype.createNewEntry__O__O__scm_HashEntry = (function(key, value) {
  return new $c_scm_DefaultEntry().init___O__O(key, value)
});
$c_scm_HashMap.prototype.get__O__s_Option = (function(key) {
  var e = $as_scm_DefaultEntry($f_scm_HashTable__findEntry__O__scm_HashEntry(this, key));
  return ((e === null) ? $m_s_None$() : new $c_s_Some().init___O(e.value$1))
});
$c_scm_HashMap.prototype.$$plus$eq__T2__scm_MapLike = (function(kv) {
  return this.$$plus$eq__T2__scm_HashMap(kv)
});
$c_scm_HashMap.prototype.sizemap$und$eq__AI__V = (function(x$1) {
  this.sizemap$5 = x$1
});
$c_scm_HashMap.prototype.$$minus$eq__O__scm_HashMap = (function(key) {
  $f_scm_HashTable__removeEntry__O__scm_HashEntry(this, key);
  return this
});
$c_scm_HashMap.prototype.contains__O__Z = (function(key) {
  return ($f_scm_HashTable__findEntry__O__scm_HashEntry(this, key) !== null)
});
$c_scm_HashMap.prototype.seedvalue__I = (function() {
  return this.seedvalue$5
});
$c_scm_HashMap.prototype.table$und$eq__Ascm_HashEntry__V = (function(x$1) {
  this.table$5 = x$1
});
$c_scm_HashMap.prototype.initialSize__I = (function() {
  return 16
});
$c_scm_HashMap.prototype.$$undloadFactor__I = (function() {
  return this.$$undloadFactor$5
});
$c_scm_HashMap.prototype.threshold__I = (function() {
  return this.threshold$5
});
$c_scm_HashMap.prototype.keySet__sc_Set = (function() {
  return new $c_scm_HashMap$$anon$1().init___scm_HashMap(this)
});
$c_scm_HashMap.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__T2__scm_HashMap($as_T2(elem))
});
$c_scm_HashMap.prototype.toSeq__sc_GenSeq = (function() {
  return $f_scm_MapLike__toSeq__sc_Seq(this)
});
$c_scm_HashMap.prototype.$$minus$eq__O__scg_Shrinkable = (function(elem) {
  return this.$$minus$eq__O__scm_HashMap(elem)
});
$c_scm_HashMap.prototype.addEntry__p5__scm_DefaultEntry__I__O = (function(e, h) {
  if ((this.tableSize$5 >= this.threshold$5)) {
    $f_scm_HashTable__addEntry__scm_HashEntry__V(this, e)
  } else {
    this.addEntry0__p5__scm_DefaultEntry__I__V(e, h)
  };
  return e.value$1
});
$c_scm_HashMap.prototype.clear__V = (function() {
  $f_scm_HashTable__clearTable__V(this)
});
$c_scm_HashMap.prototype.sizemap__AI = (function() {
  return this.sizemap$5
});
$c_scm_HashMap.prototype.$$undloadFactor$und$eq__I__V = (function(x$1) {
  this.$$undloadFactor$5 = x$1
});
$c_scm_HashMap.prototype.threshold$und$eq__I__V = (function(x$1) {
  this.threshold$5 = x$1
});
$c_scm_HashMap.prototype.$$plus__T2__sc_GenMap = (function(kv) {
  var this$2 = new $c_scm_HashMap().init___();
  return $as_scm_Map($as_scm_Map($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$2, this)).$$plus$eq__T2__scm_MapLike(kv))
});
$c_scm_HashMap.prototype.tableSize$und$eq__I__V = (function(x$1) {
  this.tableSize$5 = x$1
});
function $as_scm_HashMap(obj) {
  return (((obj instanceof $c_scm_HashMap) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.HashMap"))
}
function $isArrayOf_scm_HashMap(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_HashMap)))
}
function $asArrayOf_scm_HashMap(obj, depth) {
  return (($isArrayOf_scm_HashMap(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.HashMap;", depth))
}
var $d_scm_HashMap = new $TypeData().initClass({
  scm_HashMap: 0
}, false, "scala.collection.mutable.HashMap", {
  scm_HashMap: 1,
  scm_AbstractMap: 1,
  sc_AbstractMap: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Map: 1,
  sc_GenMap: 1,
  sc_GenMapLike: 1,
  sc_MapLike: 1,
  s_PartialFunction: 1,
  F1: 1,
  scg_Subtractable: 1,
  scm_Map: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_MapLike: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  scg_Shrinkable: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_HashTable: 1,
  scm_HashTable$HashUtils: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_HashMap.prototype.$classData = $d_scm_HashMap;
/** @constructor */
function $c_scm_IndexedSeqLike$$anon$1() {
  $c_O.call(this);
  this.underlying$1 = null;
  this.bitmap$0$1 = false;
  this.$$outer$1 = null
}
$c_scm_IndexedSeqLike$$anon$1.prototype = new $h_O();
$c_scm_IndexedSeqLike$$anon$1.prototype.constructor = $c_scm_IndexedSeqLike$$anon$1;
/** @constructor */
function $h_scm_IndexedSeqLike$$anon$1() {
  /*<skip>*/
}
$h_scm_IndexedSeqLike$$anon$1.prototype = $c_scm_IndexedSeqLike$$anon$1.prototype;
$c_scm_IndexedSeqLike$$anon$1.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_scm_IndexedSeqLike$$anon$1.prototype.copyToArray__O__I__V = (function(xs, start) {
  $f_sc_TraversableOnce__copyToArray__O__I__V(this, xs, start)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.newSliced__scg_SliceInterval__sc_SeqViewLike$Transformed = (function(_endpoints) {
  return new $c_scm_IndexedSeqView$$anon$2().init___scm_IndexedSeqView__scg_SliceInterval(this, _endpoints)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.head__O = (function() {
  return $f_sc_IndexedSeqOptimized__head__O(this)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.apply__I__O = (function(idx) {
  return this.$$outer$1.apply__I__O(idx)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_IndexedSeqOptimized__lengthCompare__I__I(this, len)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.toIterator__sc_Iterator = (function() {
  return this.iterator__sc_Iterator()
});
$c_scm_IndexedSeqLike$$anon$1.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IndexedSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.apply__O__O = (function(v1) {
  return this.apply__I__O($uI(v1))
});
$c_scm_IndexedSeqLike$$anon$1.prototype.flatten__F1__sc_GenTraversable = (function(asTraversable) {
  return new $c_sc_SeqViewLike$$anon$5().init___sc_SeqViewLike__F1(this, asTraversable)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.exists__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__exists__F1__Z(this, p)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.toList__sci_List = (function() {
  return $f_sc_IndexedSeqOptimized__toList__sci_List(this)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.isEmpty__Z = (function() {
  return $f_sc_IndexedSeqOptimized__isEmpty__Z(this)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.scala$collection$TraversableViewLike$$super$tail__sc_TraversableView = (function() {
  return $as_sc_TraversableView($f_sc_IndexedSeqOptimized__tail__O(this))
});
$c_scm_IndexedSeqLike$$anon$1.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_scm_IndexedSeqLike$$anon$1.prototype.runWith__F1__F1 = (function(action) {
  return $f_s_PartialFunction__runWith__F1__F1(this, action)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_scm_IndexedSeqLike$$anon$1.prototype.flatMap__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return new $c_sc_SeqViewLike$$anon$5().init___sc_SeqViewLike__F1(this, f)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.equals__O__Z = (function(that) {
  return $f_sc_GenSeqLike__equals__O__Z(this, that)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.scala$collection$IndexedSeqOptimized$$super$init__O = (function() {
  return $f_sc_TraversableLike__init__O(this)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.dropWhile__F1__O = (function(p) {
  return new $c_scm_IndexedSeqView$$anon$3().init___scm_IndexedSeqView__F1(this, p)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.mkString__T__T = (function(sep) {
  return $f_sc_ViewMkString__mkString__T__T__T__T(this, "", sep, "")
});
$c_scm_IndexedSeqLike$$anon$1.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  return $f_sc_ViewMkString__mkString__T__T__T__T(this, start, sep, end)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.withFilter__F1__scg_FilterMonadic = (function(p) {
  return $f_sc_TraversableViewLike__withFilter__F1__sc_TraversableView(this, p)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.forall__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__forall__F1__Z(this, p)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.$$colon$plus__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqViewLike__$$colon$plus__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.sorted__s_math_Ordering__O = (function(ord) {
  return $f_sc_SeqViewLike__sorted__s_math_Ordering__sc_SeqView(this, ord)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.toString__T = (function() {
  return $f_sc_TraversableViewLike__viewToString__T(this)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.companion__scg_GenericCompanion = (function() {
  return $m_scm_IndexedSeq$()
});
$c_scm_IndexedSeqLike$$anon$1.prototype.foreach__F1__V = (function(f) {
  $f_sc_IndexedSeqOptimized__foreach__F1__V(this, f)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.foldLeft__O__F2__O = (function(z, op) {
  var start = 0;
  var end = this.length__I();
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.viewIdString__T = (function() {
  return ""
});
$c_scm_IndexedSeqLike$$anon$1.prototype.newPrepended__sc_GenTraversable__sc_SeqViewLike$Transformed = (function(that) {
  return new $c_sc_SeqViewLike$$anon$3().init___sc_SeqViewLike__sc_GenTraversable(this, that)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_IndexedSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.union__sc_GenSeq__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_SeqViewLike__union__sc_GenSeq__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.headOption__s_Option = (function() {
  return $f_sc_TraversableLike__headOption__s_Option(this)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.takeWhile__F1__O = (function(p) {
  return new $c_scm_IndexedSeqView$$anon$4().init___scm_IndexedSeqView__F1(this, p)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.slice__I__I__O = (function(from, until) {
  return $f_scm_IndexedSeqView__slice__I__I__scm_IndexedSeqView(this, from, until)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.intersect__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqViewLike__intersect__sc_GenSeq__sc_SeqView(this, that)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.toVector__sci_Vector = (function() {
  $m_sci_Vector$();
  var cbf = $m_sc_IndexedSeq$().ReusableCBF$6;
  return $as_sci_Vector($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_IndexedSeqLike$$anon$1.prototype.filter__F1__O = (function(p) {
  return new $c_scm_IndexedSeqView$$anon$1().init___scm_IndexedSeqView__F1(this, p)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.reverse__O = (function() {
  return new $c_scm_IndexedSeqView$$anon$5().init___scm_IndexedSeqView(this)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.size__I = (function() {
  return this.length__I()
});
$c_scm_IndexedSeqLike$$anon$1.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_IndexedSeqLike__toBuffer__scm_Buffer(this)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.scala$collection$mutable$IndexedSeqView$$super$tail__scm_IndexedSeqView = (function() {
  return $as_scm_IndexedSeqView($f_sc_TraversableViewLike__tail__sc_TraversableView(this))
});
$c_scm_IndexedSeqLike$$anon$1.prototype.distinct__O = (function() {
  return $f_sc_SeqViewLike__distinct__sc_SeqView(this)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.$$plus$colon__O__scg_CanBuildFrom__O = (function(elem, bf) {
  return $f_sc_SeqViewLike__$$plus$colon__O__scg_CanBuildFrom__O(this, elem, bf)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.apply$mcZI$sp__I__Z = (function(v1) {
  return $uZ(this.apply__I__O(v1))
});
$c_scm_IndexedSeqLike$$anon$1.prototype.iterator__sc_Iterator = (function() {
  return this.$$outer$1.iterator__sc_Iterator()
});
$c_scm_IndexedSeqLike$$anon$1.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_IndexedSeqOptimized__find__F1__s_Option(this, p)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.span__F1__T2 = (function(p) {
  return $f_scm_IndexedSeqView__span__F1__T2(this, p)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.diff__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqViewLike__diff__sc_GenSeq__sc_SeqView(this, that)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.init___scm_IndexedSeqLike = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$1 = $$outer
  };
  return this
});
$c_scm_IndexedSeqLike$$anon$1.prototype.mkString__T = (function() {
  return $f_sc_ViewMkString__mkString__T__T__T__T(this, "", "", "")
});
$c_scm_IndexedSeqLike$$anon$1.prototype.newAppended__sc_GenTraversable__sc_TraversableViewLike$Transformed = (function(that) {
  return new $c_sc_SeqViewLike$$anon$2().init___sc_SeqViewLike__sc_GenTraversable(this, that)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O = (function(xs, bf) {
  return $f_sc_TraversableViewLike__$$plus$plus__sc_GenTraversableOnce__scg_CanBuildFrom__O(this, xs, bf)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IterableViewLike__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.length__I = (function() {
  return this.$$outer$1.length__I()
});
$c_scm_IndexedSeqLike$$anon$1.prototype.scala$collection$IndexedSeqOptimized$$super$tail__O = (function() {
  return $f_sc_TraversableLike__tail__O(this)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.scala$collection$IndexedSeqOptimized$$super$last__O = (function() {
  return $f_sc_TraversableLike__last__O(this)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.seq__sc_Seq = (function() {
  return this
});
$c_scm_IndexedSeqLike$$anon$1.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_TraversableViewLike__filterNot__F1__sc_TraversableView(this, p)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.sizeHintIfCheap__I = (function() {
  return this.length__I()
});
$c_scm_IndexedSeqLike$$anon$1.prototype.partition__F1__T2 = (function(p) {
  return $f_sc_TraversableViewLike__partition__F1__T2(this, p)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.splitAt__I__T2 = (function(n) {
  return $f_scm_IndexedSeqView__splitAt__I__T2(this, n)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.newTakenWhile__F1__sc_TraversableViewLike$Transformed = (function(p) {
  return new $c_scm_IndexedSeqView$$anon$4().init___scm_IndexedSeqView__F1(this, p)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.take__I__O = (function(n) {
  return $f_scm_IndexedSeqView__take__I__scm_IndexedSeqView(this, n)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.toStream__sci_Stream = (function() {
  return this.iterator__sc_Iterator().toStream__sci_Stream()
});
$c_scm_IndexedSeqLike$$anon$1.prototype.view__sc_SeqView = (function() {
  return new $c_scm_IndexedSeqLike$$anon$1().init___scm_IndexedSeqLike(this)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.last__O = (function() {
  return $f_sc_IndexedSeqOptimized__last__O(this)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.drop__I__O = (function(n) {
  return $f_scm_IndexedSeqView__drop__I__scm_IndexedSeqView(this, n)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.newMapped__F1__sc_TraversableViewLike$Transformed = (function(f) {
  return new $c_sc_SeqViewLike$$anon$4().init___sc_SeqViewLike__F1(this, f)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.contains__O__Z = (function(elem) {
  return $f_sc_SeqLike__contains__O__Z(this, elem)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.thisCollection__sc_Seq = (function() {
  return this
});
$c_scm_IndexedSeqLike$$anon$1.prototype.tail__O = (function() {
  return $f_scm_IndexedSeqView__tail__scm_IndexedSeqView(this)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  return $f_sc_ViewMkString__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this, b, start, sep, end)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.toTraversable__sc_Traversable = (function() {
  return this
});
$c_scm_IndexedSeqLike$$anon$1.prototype.sortBy__F1__s_math_Ordering__O = (function(f, ord) {
  return $f_sc_SeqViewLike__sortBy__F1__s_math_Ordering__sc_SeqView(this, f, ord)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.toSeq__sc_Seq = (function() {
  return this
});
$c_scm_IndexedSeqLike$$anon$1.prototype.filter__F1__sc_TraversableView = (function(p) {
  return new $c_scm_IndexedSeqView$$anon$1().init___scm_IndexedSeqView__F1(this, p)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.isDefinedAt__O__Z = (function(x) {
  var idx = $uI(x);
  return $f_sc_GenSeqLike__isDefinedAt__I__Z(this, idx)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.toSet__sci_Set = (function() {
  var this$1 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$1);
  return $as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this, cbf))
});
$c_scm_IndexedSeqLike$$anon$1.prototype.repr__O = (function() {
  return this
});
$c_scm_IndexedSeqLike$$anon$1.prototype.$$div$colon__O__F2__O = (function(z, op) {
  var start = 0;
  var end = this.length__I();
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.newForced__F0__sc_SeqViewLike$Transformed = (function(xs) {
  return new $c_sc_SeqViewLike$$anon$1().init___sc_SeqViewLike__F0(this, xs)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.newSliced__scg_SliceInterval__sc_TraversableViewLike$Transformed = (function(_endpoints) {
  return new $c_scm_IndexedSeqView$$anon$2().init___scm_IndexedSeqView__scg_SliceInterval(this, _endpoints)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.applyOrElse__O__F1__O = (function(x, $default) {
  return $f_s_PartialFunction__applyOrElse__O__F1__O(this, x, $default)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_sc_IndexedSeqOptimized__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.isTraversableAgain__Z = (function() {
  return true
});
$c_scm_IndexedSeqLike$$anon$1.prototype.toSeq__sc_GenSeq = (function() {
  return this
});
$c_scm_IndexedSeqLike$$anon$1.prototype.hashCode__I = (function() {
  return $m_s_util_hashing_MurmurHash3$().seqHash__sc_Seq__I(this)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.groupBy__F1__sci_Map = (function(f) {
  return $f_sc_TraversableViewLike__groupBy__F1__sci_Map(this, f)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.newFiltered__F1__sc_TraversableViewLike$Transformed = (function(p) {
  return new $c_scm_IndexedSeqView$$anon$1().init___scm_IndexedSeqView__F1(this, p)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.scala$collection$IndexedSeqOptimized$$super$zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_IterableLike__zip__sc_GenIterable__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var i = 0;
  var len = this.length__I();
  while ((i < len)) {
    var arg1 = this.apply__I__O(i);
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    i = ((1 + i) | 0)
  };
  return $as_sci_Map(b.elems$1)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.map__F1__scg_CanBuildFrom__O = (function(f, bf) {
  return new $c_sc_SeqViewLike$$anon$4().init___sc_SeqViewLike__F1(this, f)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.segmentLength__F1__I__I = (function(p, from) {
  return $f_sc_IndexedSeqOptimized__segmentLength__F1__I__I(this, p, from)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $f_sc_TraversableOnce__toArray__s_reflect_ClassTag__O(this, evidence$1)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.nonEmpty__Z = (function() {
  return $f_sc_TraversableOnce__nonEmpty__Z(this)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.newDroppedWhile__F1__sc_TraversableViewLike$Transformed = (function(p) {
  return new $c_scm_IndexedSeqView$$anon$3().init___scm_IndexedSeqView__F1(this, p)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.collect__s_PartialFunction__scg_CanBuildFrom__O = (function(pf, bf) {
  return $f_sc_TraversableViewLike__collect__s_PartialFunction__scg_CanBuildFrom__O(this, pf, bf)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_IndexedSeqOptimized__reduceLeft__F2__O(this, op)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.newBuilder__scm_Builder = (function() {
  return $f_sc_TraversableViewLike__newBuilder__scm_Builder(this)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.newForced__F0__sc_TraversableViewLike$Transformed = (function(xs) {
  return new $c_sc_SeqViewLike$$anon$1().init___sc_SeqViewLike__F0(this, xs)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.stringPrefix__T = (function() {
  return "SeqView"
});
$c_scm_IndexedSeqLike$$anon$1.prototype.sortWith__F2__O = (function(lt) {
  return $f_sc_SeqViewLike__sortWith__F2__sc_SeqView(this, lt)
});
$c_scm_IndexedSeqLike$$anon$1.prototype.zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return new $c_sc_SeqViewLike$$anon$10().init___sc_SeqViewLike__sc_GenIterable(this, that)
});
var $d_scm_IndexedSeqLike$$anon$1 = new $TypeData().initClass({
  scm_IndexedSeqLike$$anon$1: 0
}, false, "scala.collection.mutable.IndexedSeqLike$$anon$1", {
  scm_IndexedSeqLike$$anon$1: 1,
  O: 1,
  scm_IndexedSeqView: 1,
  scm_IndexedSeq: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  s_Mutable: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  scm_IndexedSeqLike: 1,
  scm_IndexedSeqOptimized: 1,
  sc_IndexedSeqOptimized: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1
});
$c_scm_IndexedSeqLike$$anon$1.prototype.$classData = $d_scm_IndexedSeqLike$$anon$1;
/** @constructor */
function $c_scm_LinkedHashSet() {
  $c_scm_AbstractSet.call(this);
  this.firstEntry$5 = null;
  this.lastEntry$5 = null;
  this.$$undloadFactor$5 = 0;
  this.table$5 = null;
  this.tableSize$5 = 0;
  this.threshold$5 = 0;
  this.sizemap$5 = null;
  this.seedvalue$5 = 0
}
$c_scm_LinkedHashSet.prototype = new $h_scm_AbstractSet();
$c_scm_LinkedHashSet.prototype.constructor = $c_scm_LinkedHashSet;
/** @constructor */
function $h_scm_LinkedHashSet() {
  /*<skip>*/
}
$h_scm_LinkedHashSet.prototype = $c_scm_LinkedHashSet.prototype;
$c_scm_LinkedHashSet.prototype.$$minus$eq__O__scm_SetLike = (function(elem) {
  return this.$$minus$eq__O__scm_LinkedHashSet(elem)
});
$c_scm_LinkedHashSet.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_scm_LinkedHashSet.prototype.init___ = (function() {
  $f_scm_HashTable__$$init$__V(this);
  this.firstEntry$5 = null;
  this.lastEntry$5 = null;
  return this
});
$c_scm_LinkedHashSet.prototype.seedvalue$und$eq__I__V = (function(x$1) {
  this.seedvalue$5 = x$1
});
$c_scm_LinkedHashSet.prototype.apply__O__O = (function(v1) {
  return this.contains__O__Z(v1)
});
$c_scm_LinkedHashSet.prototype.tableSize__I = (function() {
  return this.tableSize$5
});
$c_scm_LinkedHashSet.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return $as_scm_Set($f_scm_SetLike__clone__scm_Set(this).$$minus$eq__O__scm_SetLike(elem))
});
$c_scm_LinkedHashSet.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_scm_LinkedHashSet.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__O__scm_LinkedHashSet(elem)
});
$c_scm_LinkedHashSet.prototype.companion__scg_GenericCompanion = (function() {
  return $m_scm_LinkedHashSet$()
});
$c_scm_LinkedHashSet.prototype.foreach__F1__V = (function(f) {
  var cur = this.firstEntry$5;
  while ((cur !== null)) {
    f.apply__O__O(cur.key$1);
    cur = cur.later$1
  }
});
$c_scm_LinkedHashSet.prototype.$$plus$eq__O__scm_LinkedHashSet = (function(elem) {
  this.add__O__Z(elem);
  return this
});
$c_scm_LinkedHashSet.prototype.$$minus$minus__sc_GenTraversableOnce__scg_Subtractable = (function(xs) {
  var this$1 = $f_scm_SetLike__clone__scm_Set(this);
  var xs$1 = xs.seq__sc_TraversableOnce();
  return $as_scm_Set($f_scg_Shrinkable__$$minus$minus$eq__sc_TraversableOnce__scg_Shrinkable(this$1, xs$1))
});
$c_scm_LinkedHashSet.prototype.$$plus$eq__O__scm_SetLike = (function(elem) {
  return this.$$plus$eq__O__scm_LinkedHashSet(elem)
});
$c_scm_LinkedHashSet.prototype.$$minus$eq__O__scm_LinkedHashSet = (function(elem) {
  this.remove__O__Z(elem);
  return this
});
$c_scm_LinkedHashSet.prototype.table__Ascm_HashEntry = (function() {
  return this.table$5
});
$c_scm_LinkedHashSet.prototype.size__I = (function() {
  return this.tableSize$5
});
$c_scm_LinkedHashSet.prototype.result__O = (function() {
  return this
});
$c_scm_LinkedHashSet.prototype.iterator__sc_Iterator = (function() {
  return new $c_scm_LinkedHashSet$$anon$1().init___scm_LinkedHashSet(this)
});
$c_scm_LinkedHashSet.prototype.$$minus__O__sc_Set = (function(elem) {
  return $as_scm_Set($f_scm_SetLike__clone__scm_Set(this).$$minus$eq__O__scm_SetLike(elem))
});
$c_scm_LinkedHashSet.prototype.empty__sc_Set = (function() {
  return new $c_scm_LinkedHashSet().init___()
});
$c_scm_LinkedHashSet.prototype.createNewEntry__O__O__scm_HashEntry = (function(key, value) {
  return this.createNewEntry__O__O__scm_LinkedHashSet$Entry(key, value)
});
$c_scm_LinkedHashSet.prototype.sizemap$und$eq__AI__V = (function(x$1) {
  this.sizemap$5 = x$1
});
$c_scm_LinkedHashSet.prototype.contains__O__Z = (function(elem) {
  return ($f_scm_HashTable__findEntry__O__scm_HashEntry(this, elem) !== null)
});
$c_scm_LinkedHashSet.prototype.seedvalue__I = (function() {
  return this.seedvalue$5
});
$c_scm_LinkedHashSet.prototype.table$und$eq__Ascm_HashEntry__V = (function(x$1) {
  this.table$5 = x$1
});
$c_scm_LinkedHashSet.prototype.initialSize__I = (function() {
  return 16
});
$c_scm_LinkedHashSet.prototype.$$undloadFactor__I = (function() {
  return this.$$undloadFactor$5
});
$c_scm_LinkedHashSet.prototype.threshold__I = (function() {
  return this.threshold$5
});
$c_scm_LinkedHashSet.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__O__scm_LinkedHashSet(elem)
});
$c_scm_LinkedHashSet.prototype.toSeq__sc_GenSeq = (function() {
  return $f_scm_SetLike__toSeq__sc_Seq(this)
});
$c_scm_LinkedHashSet.prototype.$$minus$eq__O__scg_Shrinkable = (function(elem) {
  return this.$$minus$eq__O__scm_LinkedHashSet(elem)
});
$c_scm_LinkedHashSet.prototype.remove__O__Z = (function(elem) {
  var e = $as_scm_LinkedHashSet$Entry($f_scm_HashTable__removeEntry__O__scm_HashEntry(this, elem));
  if ((e !== null)) {
    if ((e.earlier$1 === null)) {
      this.firstEntry$5 = e.later$1
    } else {
      e.earlier$1.later$1 = e.later$1
    };
    if ((e.later$1 === null)) {
      this.lastEntry$5 = e.earlier$1
    } else {
      e.later$1.earlier$1 = e.earlier$1
    };
    e.earlier$1 = null;
    e.later$1 = null;
    return true
  } else {
    return false
  }
});
$c_scm_LinkedHashSet.prototype.sizemap__AI = (function() {
  return this.sizemap$5
});
$c_scm_LinkedHashSet.prototype.createNewEntry__O__O__scm_LinkedHashSet$Entry = (function(key, dummy) {
  var e = new $c_scm_LinkedHashSet$Entry().init___O(key);
  if ((this.firstEntry$5 === null)) {
    this.firstEntry$5 = e
  } else {
    this.lastEntry$5.later$1 = e;
    e.earlier$1 = this.lastEntry$5
  };
  this.lastEntry$5 = e;
  return e
});
$c_scm_LinkedHashSet.prototype.add__O__Z = (function(elem) {
  return ($f_scm_HashTable__findOrAddEntry__O__O__scm_HashEntry(this, elem, null) === null)
});
$c_scm_LinkedHashSet.prototype.$$plus__O__sc_Set = (function(elem) {
  return $as_scm_Set($f_scm_SetLike__clone__scm_Set(this).$$plus$eq__O__scm_SetLike(elem))
});
$c_scm_LinkedHashSet.prototype.$$plus$plus__sc_GenTraversableOnce__sc_Set = (function(elems) {
  var this$1 = $f_scm_SetLike__clone__scm_Set(this);
  var xs = elems.seq__sc_TraversableOnce();
  return $as_scm_Set($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$1, xs))
});
$c_scm_LinkedHashSet.prototype.$$undloadFactor$und$eq__I__V = (function(x$1) {
  this.$$undloadFactor$5 = x$1
});
$c_scm_LinkedHashSet.prototype.threshold$und$eq__I__V = (function(x$1) {
  this.threshold$5 = x$1
});
$c_scm_LinkedHashSet.prototype.tableSize$und$eq__I__V = (function(x$1) {
  this.tableSize$5 = x$1
});
var $d_scm_LinkedHashSet = new $TypeData().initClass({
  scm_LinkedHashSet: 0
}, false, "scala.collection.mutable.LinkedHashSet", {
  scm_LinkedHashSet: 1,
  scm_AbstractSet: 1,
  scm_AbstractIterable: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_Set: 1,
  sc_Set: 1,
  F1: 1,
  sc_GenSet: 1,
  sc_GenSetLike: 1,
  scg_GenericSetTemplate: 1,
  sc_SetLike: 1,
  scg_Subtractable: 1,
  scm_SetLike: 1,
  sc_script_Scriptable: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  scg_Shrinkable: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_HashTable: 1,
  scm_HashTable$HashUtils: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_LinkedHashSet.prototype.$classData = $d_scm_LinkedHashSet;
/** @constructor */
function $c_scm_Queue() {
  $c_scm_MutableList.call(this)
}
$c_scm_Queue.prototype = new $h_scm_MutableList();
$c_scm_Queue.prototype.constructor = $c_scm_Queue;
/** @constructor */
function $h_scm_Queue() {
  /*<skip>*/
}
$h_scm_Queue.prototype = $c_scm_Queue.prototype;
$c_scm_Queue.prototype.init___scm_LinkedList__scm_LinkedList__I = (function(fst, lst, lng) {
  $c_scm_MutableList.prototype.init___.call(this);
  this.first0$5 = fst;
  this.last0$5 = lst;
  this.len$5 = lng;
  return this
});
$c_scm_Queue.prototype.init___ = (function() {
  $c_scm_MutableList.prototype.init___.call(this);
  return this
});
$c_scm_Queue.prototype.thisCollection__sc_Iterable = (function() {
  return this
});
$c_scm_Queue.prototype.dequeue__O = (function() {
  if (this.isEmpty__Z()) {
    throw new $c_ju_NoSuchElementException().init___T("queue empty")
  } else {
    var res = this.first0$5.elem$5;
    var this$1 = this.first0$5;
    this.first0$5 = this$1.next$5;
    this.decrementLength__p6__V();
    return res
  }
});
$c_scm_Queue.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_scm_Queue.prototype.companion__scg_GenericCompanion = (function() {
  return $m_scm_Queue$()
});
$c_scm_Queue.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_LinearSeqOptimized__takeWhile__F1__sc_LinearSeqOptimized(this, p)
});
$c_scm_Queue.prototype.seq__sc_Seq = (function() {
  return this
});
$c_scm_Queue.prototype.take__I__O = (function(n) {
  return $f_sc_LinearSeqOptimized__take__I__sc_LinearSeqOptimized(this, n)
});
$c_scm_Queue.prototype.drop__I__O = (function(n) {
  return $f_sc_LinearSeqOptimized__drop__I__sc_LinearSeqOptimized(this, n)
});
$c_scm_Queue.prototype.decrementLength__p6__V = (function() {
  this.len$5 = (((-1) + this.len$5) | 0);
  if ((this.len$5 === 0)) {
    this.last0$5 = this.first0$5
  }
});
$c_scm_Queue.prototype.tail__O = (function() {
  return this.tail__scm_Queue()
});
$c_scm_Queue.prototype.thisCollection__sc_Seq = (function() {
  return this
});
$c_scm_Queue.prototype.isDefinedAt__O__Z = (function(x) {
  var x$1 = $uI(x);
  return $f_sc_LinearSeqOptimized__isDefinedAt__I__Z(this, x$1)
});
$c_scm_Queue.prototype.toSeq__sc_GenSeq = (function() {
  return this
});
$c_scm_Queue.prototype.tail__scm_Queue = (function() {
  var tl = new $c_scm_Queue().init___();
  this.tailImpl__scm_MutableList__V(tl);
  return tl
});
$c_scm_Queue.prototype.tail__scm_MutableList = (function() {
  return this.tail__scm_Queue()
});
$c_scm_Queue.prototype.newBuilder__scm_Builder = (function() {
  return $m_scm_Queue$().newBuilder__scm_Builder()
});
var $d_scm_Queue = new $TypeData().initClass({
  scm_Queue: 0
}, false, "scala.collection.mutable.Queue", {
  scm_Queue: 1,
  scm_MutableList: 1,
  scm_AbstractSeq: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_LinearSeq: 1,
  sc_LinearSeq: 1,
  sc_LinearSeqLike: 1,
  sc_LinearSeqOptimized: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_Queue.prototype.$classData = $d_scm_Queue;
/** @constructor */
function $c_Lamf_core_registries_AMFDomainRegistry$$anon$1() {
  $c_scm_HashMap.call(this)
}
$c_Lamf_core_registries_AMFDomainRegistry$$anon$1.prototype = new $h_scm_HashMap();
$c_Lamf_core_registries_AMFDomainRegistry$$anon$1.prototype.constructor = $c_Lamf_core_registries_AMFDomainRegistry$$anon$1;
/** @constructor */
function $h_Lamf_core_registries_AMFDomainRegistry$$anon$1() {
  /*<skip>*/
}
$h_Lamf_core_registries_AMFDomainRegistry$$anon$1.prototype = $c_Lamf_core_registries_AMFDomainRegistry$$anon$1.prototype;
$c_Lamf_core_registries_AMFDomainRegistry$$anon$1.prototype.init___ = (function() {
  $c_scm_HashMap.prototype.init___scm_HashTable$Contents.call(this, null);
  return this
});
$c_Lamf_core_registries_AMFDomainRegistry$$anon$1.prototype.initialSize__I = (function() {
  return this.tableSize$5
});
var $d_Lamf_core_registries_AMFDomainRegistry$$anon$1 = new $TypeData().initClass({
  Lamf_core_registries_AMFDomainRegistry$$anon$1: 0
}, false, "amf.core.registries.AMFDomainRegistry$$anon$1", {
  Lamf_core_registries_AMFDomainRegistry$$anon$1: 1,
  scm_HashMap: 1,
  scm_AbstractMap: 1,
  sc_AbstractMap: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Map: 1,
  sc_GenMap: 1,
  sc_GenMapLike: 1,
  sc_MapLike: 1,
  s_PartialFunction: 1,
  F1: 1,
  scg_Subtractable: 1,
  scm_Map: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_MapLike: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  scg_Shrinkable: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_HashTable: 1,
  scm_HashTable$HashUtils: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_Lamf_core_registries_AMFDomainRegistry$$anon$1.prototype.$classData = $d_Lamf_core_registries_AMFDomainRegistry$$anon$1;
/** @constructor */
function $c_sc_SeqLike$$anon$1() {
  $c_scm_HashMap.call(this)
}
$c_sc_SeqLike$$anon$1.prototype = new $h_scm_HashMap();
$c_sc_SeqLike$$anon$1.prototype.constructor = $c_sc_SeqLike$$anon$1;
/** @constructor */
function $h_sc_SeqLike$$anon$1() {
  /*<skip>*/
}
$h_sc_SeqLike$$anon$1.prototype = $c_sc_SeqLike$$anon$1.prototype;
$c_sc_SeqLike$$anon$1.prototype.$default__O__O = (function(key) {
  return 0
});
$c_sc_SeqLike$$anon$1.prototype.init___sc_SeqLike = (function($$outer) {
  $c_scm_HashMap.prototype.init___scm_HashTable$Contents.call(this, null);
  return this
});
var $d_sc_SeqLike$$anon$1 = new $TypeData().initClass({
  sc_SeqLike$$anon$1: 0
}, false, "scala.collection.SeqLike$$anon$1", {
  sc_SeqLike$$anon$1: 1,
  scm_HashMap: 1,
  scm_AbstractMap: 1,
  sc_AbstractMap: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Map: 1,
  sc_GenMap: 1,
  sc_GenMapLike: 1,
  sc_MapLike: 1,
  s_PartialFunction: 1,
  F1: 1,
  scg_Subtractable: 1,
  scm_Map: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_MapLike: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  scg_Shrinkable: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_HashTable: 1,
  scm_HashTable$HashUtils: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_sc_SeqLike$$anon$1.prototype.$classData = $d_sc_SeqLike$$anon$1;
/** @constructor */
function $c_scm_HashSet() {
  $c_scm_AbstractSet.call(this);
  this.$$undloadFactor$5 = 0;
  this.table$5 = null;
  this.tableSize$5 = 0;
  this.threshold$5 = 0;
  this.sizemap$5 = null;
  this.seedvalue$5 = 0
}
$c_scm_HashSet.prototype = new $h_scm_AbstractSet();
$c_scm_HashSet.prototype.constructor = $c_scm_HashSet;
/** @constructor */
function $h_scm_HashSet() {
  /*<skip>*/
}
$h_scm_HashSet.prototype = $c_scm_HashSet.prototype;
$c_scm_HashSet.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_scm_HashSet.prototype.$$minus$eq__O__scm_SetLike = (function(elem) {
  return this.$$minus$eq__O__scm_HashSet(elem)
});
$c_scm_HashSet.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_scm_HashSet.prototype.init___ = (function() {
  $c_scm_HashSet.prototype.init___scm_FlatHashTable$Contents.call(this, null);
  return this
});
$c_scm_HashSet.prototype.apply__O__O = (function(v1) {
  return $f_scm_FlatHashTable__containsElem__O__Z(this, v1)
});
$c_scm_HashSet.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  var this$1 = new $c_scm_HashSet().init___();
  var this$2 = $as_scm_HashSet($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$1, this));
  return this$2.$$minus$eq__O__scm_HashSet(elem)
});
$c_scm_HashSet.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_scm_HashSet.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__O__scm_HashSet(elem)
});
$c_scm_HashSet.prototype.companion__scg_GenericCompanion = (function() {
  return $m_scm_HashSet$()
});
$c_scm_HashSet.prototype.foreach__F1__V = (function(f) {
  var i = 0;
  var len = this.table$5.u.length;
  while ((i < len)) {
    var curEntry = this.table$5.get(i);
    if ((curEntry !== null)) {
      f.apply__O__O($f_scm_FlatHashTable$HashUtils__entryToElem__O__O(this, curEntry))
    };
    i = ((1 + i) | 0)
  }
});
$c_scm_HashSet.prototype.$$minus$minus__sc_GenTraversableOnce__scg_Subtractable = (function(xs) {
  var this$1 = new $c_scm_HashSet().init___();
  var this$2 = $as_scm_HashSet($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$1, this));
  var xs$1 = xs.seq__sc_TraversableOnce();
  return $as_scm_Set($f_scg_Shrinkable__$$minus$minus$eq__sc_TraversableOnce__scg_Shrinkable(this$2, xs$1))
});
$c_scm_HashSet.prototype.$$plus$eq__O__scm_SetLike = (function(elem) {
  return this.$$plus$eq__O__scm_HashSet(elem)
});
$c_scm_HashSet.prototype.size__I = (function() {
  return this.tableSize$5
});
$c_scm_HashSet.prototype.result__O = (function() {
  return this
});
$c_scm_HashSet.prototype.iterator__sc_Iterator = (function() {
  return new $c_scm_FlatHashTable$$anon$1().init___scm_FlatHashTable(this)
});
$c_scm_HashSet.prototype.$$minus__O__sc_Set = (function(elem) {
  var this$1 = new $c_scm_HashSet().init___();
  var this$2 = $as_scm_HashSet($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$1, this));
  return this$2.$$minus$eq__O__scm_HashSet(elem)
});
$c_scm_HashSet.prototype.empty__sc_Set = (function() {
  return new $c_scm_HashSet().init___()
});
$c_scm_HashSet.prototype.contains__O__Z = (function(elem) {
  return $f_scm_FlatHashTable__containsElem__O__Z(this, elem)
});
$c_scm_HashSet.prototype.init___scm_FlatHashTable$Contents = (function(contents) {
  $f_scm_FlatHashTable__$$init$__V(this);
  $f_scm_FlatHashTable__initWithContents__scm_FlatHashTable$Contents__V(this, contents);
  return this
});
$c_scm_HashSet.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__O__scm_HashSet(elem)
});
$c_scm_HashSet.prototype.toSeq__sc_GenSeq = (function() {
  return $f_scm_SetLike__toSeq__sc_Seq(this)
});
$c_scm_HashSet.prototype.$$minus$eq__O__scg_Shrinkable = (function(elem) {
  return this.$$minus$eq__O__scm_HashSet(elem)
});
$c_scm_HashSet.prototype.$$minus$eq__O__scm_HashSet = (function(elem) {
  $f_scm_FlatHashTable__removeElem__O__Z(this, elem);
  return this
});
$c_scm_HashSet.prototype.add__O__Z = (function(elem) {
  return $f_scm_FlatHashTable__addElem__O__Z(this, elem)
});
$c_scm_HashSet.prototype.$$plus__O__sc_Set = (function(elem) {
  var this$1 = new $c_scm_HashSet().init___();
  var this$2 = $as_scm_HashSet($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$1, this));
  return this$2.$$plus$eq__O__scm_HashSet(elem)
});
$c_scm_HashSet.prototype.$$plus$plus__sc_GenTraversableOnce__sc_Set = (function(elems) {
  var this$1 = new $c_scm_HashSet().init___();
  var this$2 = $as_scm_HashSet($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$1, this));
  var xs = elems.seq__sc_TraversableOnce();
  return $as_scm_Set($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this$2, xs))
});
$c_scm_HashSet.prototype.$$plus$eq__O__scm_HashSet = (function(elem) {
  $f_scm_FlatHashTable__addElem__O__Z(this, elem);
  return this
});
function $as_scm_HashSet(obj) {
  return (((obj instanceof $c_scm_HashSet) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.HashSet"))
}
function $isArrayOf_scm_HashSet(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_HashSet)))
}
function $asArrayOf_scm_HashSet(obj, depth) {
  return (($isArrayOf_scm_HashSet(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.HashSet;", depth))
}
var $d_scm_HashSet = new $TypeData().initClass({
  scm_HashSet: 0
}, false, "scala.collection.mutable.HashSet", {
  scm_HashSet: 1,
  scm_AbstractSet: 1,
  scm_AbstractIterable: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_Set: 1,
  sc_Set: 1,
  F1: 1,
  sc_GenSet: 1,
  sc_GenSetLike: 1,
  scg_GenericSetTemplate: 1,
  sc_SetLike: 1,
  scg_Subtractable: 1,
  scm_SetLike: 1,
  sc_script_Scriptable: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  scg_Shrinkable: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_FlatHashTable: 1,
  scm_FlatHashTable$HashUtils: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_HashSet.prototype.$classData = $d_scm_HashSet;
/** @constructor */
function $c_scm_WrappedArray$ofBoolean() {
  $c_scm_WrappedArray.call(this);
  this.array$6 = null
}
$c_scm_WrappedArray$ofBoolean.prototype = new $h_scm_WrappedArray();
$c_scm_WrappedArray$ofBoolean.prototype.constructor = $c_scm_WrappedArray$ofBoolean;
/** @constructor */
function $h_scm_WrappedArray$ofBoolean() {
  /*<skip>*/
}
$h_scm_WrappedArray$ofBoolean.prototype = $c_scm_WrappedArray$ofBoolean.prototype;
$c_scm_WrappedArray$ofBoolean.prototype.apply__I__O = (function(index) {
  return this.apply$mcZI$sp__I__Z(index)
});
$c_scm_WrappedArray$ofBoolean.prototype.apply__O__O = (function(v1) {
  var index = $uI(v1);
  return this.apply$mcZI$sp__I__Z(index)
});
$c_scm_WrappedArray$ofBoolean.prototype.update__I__O__V = (function(index, elem) {
  this.update__I__Z__V(index, $uZ(elem))
});
$c_scm_WrappedArray$ofBoolean.prototype.equals__O__Z = (function(that) {
  if ((that instanceof $c_scm_WrappedArray$ofBoolean)) {
    var x2 = $as_scm_WrappedArray$ofBoolean(that);
    return $m_ju_Arrays$().equals__AZ__AZ__Z(this.array$6, x2.array$6)
  } else {
    return $f_sc_GenSeqLike__equals__O__Z(this, that)
  }
});
$c_scm_WrappedArray$ofBoolean.prototype.apply$mcZI$sp__I__Z = (function(index) {
  return this.array$6.get(index)
});
$c_scm_WrappedArray$ofBoolean.prototype.length__I = (function() {
  return this.array$6.u.length
});
$c_scm_WrappedArray$ofBoolean.prototype.update__I__Z__V = (function(index, elem) {
  this.array$6.set(index, elem)
});
$c_scm_WrappedArray$ofBoolean.prototype.elemTag__s_reflect_ClassTag = (function() {
  return $m_s_reflect_ManifestFactory$BooleanManifest$()
});
$c_scm_WrappedArray$ofBoolean.prototype.array__O = (function() {
  return this.array$6
});
$c_scm_WrappedArray$ofBoolean.prototype.init___AZ = (function(array) {
  this.array$6 = array;
  return this
});
$c_scm_WrappedArray$ofBoolean.prototype.hashCode__I = (function() {
  var this$1 = $m_s_util_hashing_MurmurHash3$();
  var a = this.array$6;
  return this$1.arrayHash$mZc$sp__AZ__I__I(a, this$1.seqSeed$2)
});
function $as_scm_WrappedArray$ofBoolean(obj) {
  return (((obj instanceof $c_scm_WrappedArray$ofBoolean) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.WrappedArray$ofBoolean"))
}
function $isArrayOf_scm_WrappedArray$ofBoolean(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_WrappedArray$ofBoolean)))
}
function $asArrayOf_scm_WrappedArray$ofBoolean(obj, depth) {
  return (($isArrayOf_scm_WrappedArray$ofBoolean(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.WrappedArray$ofBoolean;", depth))
}
var $d_scm_WrappedArray$ofBoolean = new $TypeData().initClass({
  scm_WrappedArray$ofBoolean: 0
}, false, "scala.collection.mutable.WrappedArray$ofBoolean", {
  scm_WrappedArray$ofBoolean: 1,
  scm_WrappedArray: 1,
  scm_AbstractSeq: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_IndexedSeq: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  scm_IndexedSeqLike: 1,
  scm_ArrayLike: 1,
  scm_IndexedSeqOptimized: 1,
  sc_IndexedSeqOptimized: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_WrappedArray$ofBoolean.prototype.$classData = $d_scm_WrappedArray$ofBoolean;
/** @constructor */
function $c_scm_WrappedArray$ofByte() {
  $c_scm_WrappedArray.call(this);
  this.array$6 = null
}
$c_scm_WrappedArray$ofByte.prototype = new $h_scm_WrappedArray();
$c_scm_WrappedArray$ofByte.prototype.constructor = $c_scm_WrappedArray$ofByte;
/** @constructor */
function $h_scm_WrappedArray$ofByte() {
  /*<skip>*/
}
$h_scm_WrappedArray$ofByte.prototype = $c_scm_WrappedArray$ofByte.prototype;
$c_scm_WrappedArray$ofByte.prototype.apply__I__O = (function(index) {
  return this.apply__I__B(index)
});
$c_scm_WrappedArray$ofByte.prototype.apply__O__O = (function(v1) {
  return this.apply__I__B($uI(v1))
});
$c_scm_WrappedArray$ofByte.prototype.update__I__O__V = (function(index, elem) {
  this.update__I__B__V(index, $uB(elem))
});
$c_scm_WrappedArray$ofByte.prototype.equals__O__Z = (function(that) {
  if ((that instanceof $c_scm_WrappedArray$ofByte)) {
    var x2 = $as_scm_WrappedArray$ofByte(that);
    return $m_ju_Arrays$().equals__AB__AB__Z(this.array$6, x2.array$6)
  } else {
    return $f_sc_GenSeqLike__equals__O__Z(this, that)
  }
});
$c_scm_WrappedArray$ofByte.prototype.apply__I__B = (function(index) {
  return this.array$6.get(index)
});
$c_scm_WrappedArray$ofByte.prototype.length__I = (function() {
  return this.array$6.u.length
});
$c_scm_WrappedArray$ofByte.prototype.elemTag__s_reflect_ClassTag = (function() {
  return $m_s_reflect_ManifestFactory$ByteManifest$()
});
$c_scm_WrappedArray$ofByte.prototype.array__O = (function() {
  return this.array$6
});
$c_scm_WrappedArray$ofByte.prototype.hashCode__I = (function() {
  var this$1 = $m_s_util_hashing_MurmurHash3$();
  var data = this.array$6;
  return this$1.arrayHash$mBc$sp__AB__I__I(data, this$1.seqSeed$2)
});
$c_scm_WrappedArray$ofByte.prototype.init___AB = (function(array) {
  this.array$6 = array;
  return this
});
$c_scm_WrappedArray$ofByte.prototype.update__I__B__V = (function(index, elem) {
  this.array$6.set(index, elem)
});
function $as_scm_WrappedArray$ofByte(obj) {
  return (((obj instanceof $c_scm_WrappedArray$ofByte) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.WrappedArray$ofByte"))
}
function $isArrayOf_scm_WrappedArray$ofByte(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_WrappedArray$ofByte)))
}
function $asArrayOf_scm_WrappedArray$ofByte(obj, depth) {
  return (($isArrayOf_scm_WrappedArray$ofByte(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.WrappedArray$ofByte;", depth))
}
var $d_scm_WrappedArray$ofByte = new $TypeData().initClass({
  scm_WrappedArray$ofByte: 0
}, false, "scala.collection.mutable.WrappedArray$ofByte", {
  scm_WrappedArray$ofByte: 1,
  scm_WrappedArray: 1,
  scm_AbstractSeq: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_IndexedSeq: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  scm_IndexedSeqLike: 1,
  scm_ArrayLike: 1,
  scm_IndexedSeqOptimized: 1,
  sc_IndexedSeqOptimized: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_WrappedArray$ofByte.prototype.$classData = $d_scm_WrappedArray$ofByte;
/** @constructor */
function $c_scm_WrappedArray$ofChar() {
  $c_scm_WrappedArray.call(this);
  this.array$6 = null
}
$c_scm_WrappedArray$ofChar.prototype = new $h_scm_WrappedArray();
$c_scm_WrappedArray$ofChar.prototype.constructor = $c_scm_WrappedArray$ofChar;
/** @constructor */
function $h_scm_WrappedArray$ofChar() {
  /*<skip>*/
}
$h_scm_WrappedArray$ofChar.prototype = $c_scm_WrappedArray$ofChar.prototype;
$c_scm_WrappedArray$ofChar.prototype.apply__I__O = (function(index) {
  var c = this.apply__I__C(index);
  return new $c_jl_Character().init___C(c)
});
$c_scm_WrappedArray$ofChar.prototype.apply__O__O = (function(v1) {
  var c = this.apply__I__C($uI(v1));
  return new $c_jl_Character().init___C(c)
});
$c_scm_WrappedArray$ofChar.prototype.update__I__O__V = (function(index, elem) {
  if ((elem === null)) {
    var jsx$1 = 0
  } else {
    var this$2 = $as_jl_Character(elem);
    var jsx$1 = this$2.value$1
  };
  this.update__I__C__V(index, jsx$1)
});
$c_scm_WrappedArray$ofChar.prototype.equals__O__Z = (function(that) {
  if ((that instanceof $c_scm_WrappedArray$ofChar)) {
    var x2 = $as_scm_WrappedArray$ofChar(that);
    return $m_ju_Arrays$().equals__AC__AC__Z(this.array$6, x2.array$6)
  } else {
    return $f_sc_GenSeqLike__equals__O__Z(this, that)
  }
});
$c_scm_WrappedArray$ofChar.prototype.apply__I__C = (function(index) {
  return this.array$6.get(index)
});
$c_scm_WrappedArray$ofChar.prototype.update__I__C__V = (function(index, elem) {
  this.array$6.set(index, elem)
});
$c_scm_WrappedArray$ofChar.prototype.length__I = (function() {
  return this.array$6.u.length
});
$c_scm_WrappedArray$ofChar.prototype.init___AC = (function(array) {
  this.array$6 = array;
  return this
});
$c_scm_WrappedArray$ofChar.prototype.elemTag__s_reflect_ClassTag = (function() {
  return $m_s_reflect_ManifestFactory$CharManifest$()
});
$c_scm_WrappedArray$ofChar.prototype.array__O = (function() {
  return this.array$6
});
$c_scm_WrappedArray$ofChar.prototype.hashCode__I = (function() {
  var this$1 = $m_s_util_hashing_MurmurHash3$();
  var a = this.array$6;
  return this$1.arrayHash$mCc$sp__AC__I__I(a, this$1.seqSeed$2)
});
function $as_scm_WrappedArray$ofChar(obj) {
  return (((obj instanceof $c_scm_WrappedArray$ofChar) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.WrappedArray$ofChar"))
}
function $isArrayOf_scm_WrappedArray$ofChar(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_WrappedArray$ofChar)))
}
function $asArrayOf_scm_WrappedArray$ofChar(obj, depth) {
  return (($isArrayOf_scm_WrappedArray$ofChar(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.WrappedArray$ofChar;", depth))
}
var $d_scm_WrappedArray$ofChar = new $TypeData().initClass({
  scm_WrappedArray$ofChar: 0
}, false, "scala.collection.mutable.WrappedArray$ofChar", {
  scm_WrappedArray$ofChar: 1,
  scm_WrappedArray: 1,
  scm_AbstractSeq: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_IndexedSeq: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  scm_IndexedSeqLike: 1,
  scm_ArrayLike: 1,
  scm_IndexedSeqOptimized: 1,
  sc_IndexedSeqOptimized: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_WrappedArray$ofChar.prototype.$classData = $d_scm_WrappedArray$ofChar;
/** @constructor */
function $c_scm_WrappedArray$ofDouble() {
  $c_scm_WrappedArray.call(this);
  this.array$6 = null
}
$c_scm_WrappedArray$ofDouble.prototype = new $h_scm_WrappedArray();
$c_scm_WrappedArray$ofDouble.prototype.constructor = $c_scm_WrappedArray$ofDouble;
/** @constructor */
function $h_scm_WrappedArray$ofDouble() {
  /*<skip>*/
}
$h_scm_WrappedArray$ofDouble.prototype = $c_scm_WrappedArray$ofDouble.prototype;
$c_scm_WrappedArray$ofDouble.prototype.apply__I__O = (function(index) {
  return this.apply$mcDI$sp__I__D(index)
});
$c_scm_WrappedArray$ofDouble.prototype.apply__O__O = (function(v1) {
  var index = $uI(v1);
  return this.apply$mcDI$sp__I__D(index)
});
$c_scm_WrappedArray$ofDouble.prototype.update__I__O__V = (function(index, elem) {
  this.update__I__D__V(index, $uD(elem))
});
$c_scm_WrappedArray$ofDouble.prototype.equals__O__Z = (function(that) {
  if ((that instanceof $c_scm_WrappedArray$ofDouble)) {
    var x2 = $as_scm_WrappedArray$ofDouble(that);
    return $m_ju_Arrays$().equals__AD__AD__Z(this.array$6, x2.array$6)
  } else {
    return $f_sc_GenSeqLike__equals__O__Z(this, that)
  }
});
$c_scm_WrappedArray$ofDouble.prototype.init___AD = (function(array) {
  this.array$6 = array;
  return this
});
$c_scm_WrappedArray$ofDouble.prototype.length__I = (function() {
  return this.array$6.u.length
});
$c_scm_WrappedArray$ofDouble.prototype.elemTag__s_reflect_ClassTag = (function() {
  return $m_s_reflect_ManifestFactory$DoubleManifest$()
});
$c_scm_WrappedArray$ofDouble.prototype.update__I__D__V = (function(index, elem) {
  this.array$6.set(index, elem)
});
$c_scm_WrappedArray$ofDouble.prototype.array__O = (function() {
  return this.array$6
});
$c_scm_WrappedArray$ofDouble.prototype.hashCode__I = (function() {
  var this$1 = $m_s_util_hashing_MurmurHash3$();
  var a = this.array$6;
  return this$1.arrayHash$mDc$sp__AD__I__I(a, this$1.seqSeed$2)
});
$c_scm_WrappedArray$ofDouble.prototype.apply$mcDI$sp__I__D = (function(index) {
  return this.array$6.get(index)
});
function $as_scm_WrappedArray$ofDouble(obj) {
  return (((obj instanceof $c_scm_WrappedArray$ofDouble) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.WrappedArray$ofDouble"))
}
function $isArrayOf_scm_WrappedArray$ofDouble(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_WrappedArray$ofDouble)))
}
function $asArrayOf_scm_WrappedArray$ofDouble(obj, depth) {
  return (($isArrayOf_scm_WrappedArray$ofDouble(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.WrappedArray$ofDouble;", depth))
}
var $d_scm_WrappedArray$ofDouble = new $TypeData().initClass({
  scm_WrappedArray$ofDouble: 0
}, false, "scala.collection.mutable.WrappedArray$ofDouble", {
  scm_WrappedArray$ofDouble: 1,
  scm_WrappedArray: 1,
  scm_AbstractSeq: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_IndexedSeq: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  scm_IndexedSeqLike: 1,
  scm_ArrayLike: 1,
  scm_IndexedSeqOptimized: 1,
  sc_IndexedSeqOptimized: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_WrappedArray$ofDouble.prototype.$classData = $d_scm_WrappedArray$ofDouble;
/** @constructor */
function $c_scm_WrappedArray$ofFloat() {
  $c_scm_WrappedArray.call(this);
  this.array$6 = null
}
$c_scm_WrappedArray$ofFloat.prototype = new $h_scm_WrappedArray();
$c_scm_WrappedArray$ofFloat.prototype.constructor = $c_scm_WrappedArray$ofFloat;
/** @constructor */
function $h_scm_WrappedArray$ofFloat() {
  /*<skip>*/
}
$h_scm_WrappedArray$ofFloat.prototype = $c_scm_WrappedArray$ofFloat.prototype;
$c_scm_WrappedArray$ofFloat.prototype.apply__I__O = (function(index) {
  return this.apply$mcFI$sp__I__F(index)
});
$c_scm_WrappedArray$ofFloat.prototype.apply__O__O = (function(v1) {
  var index = $uI(v1);
  return this.apply$mcFI$sp__I__F(index)
});
$c_scm_WrappedArray$ofFloat.prototype.update__I__O__V = (function(index, elem) {
  this.update__I__F__V(index, $uF(elem))
});
$c_scm_WrappedArray$ofFloat.prototype.equals__O__Z = (function(that) {
  if ((that instanceof $c_scm_WrappedArray$ofFloat)) {
    var x2 = $as_scm_WrappedArray$ofFloat(that);
    return $m_ju_Arrays$().equals__AF__AF__Z(this.array$6, x2.array$6)
  } else {
    return $f_sc_GenSeqLike__equals__O__Z(this, that)
  }
});
$c_scm_WrappedArray$ofFloat.prototype.init___AF = (function(array) {
  this.array$6 = array;
  return this
});
$c_scm_WrappedArray$ofFloat.prototype.length__I = (function() {
  return this.array$6.u.length
});
$c_scm_WrappedArray$ofFloat.prototype.apply$mcFI$sp__I__F = (function(index) {
  return this.array$6.get(index)
});
$c_scm_WrappedArray$ofFloat.prototype.update__I__F__V = (function(index, elem) {
  this.array$6.set(index, elem)
});
$c_scm_WrappedArray$ofFloat.prototype.elemTag__s_reflect_ClassTag = (function() {
  return $m_s_reflect_ManifestFactory$FloatManifest$()
});
$c_scm_WrappedArray$ofFloat.prototype.array__O = (function() {
  return this.array$6
});
$c_scm_WrappedArray$ofFloat.prototype.hashCode__I = (function() {
  var this$1 = $m_s_util_hashing_MurmurHash3$();
  var a = this.array$6;
  return this$1.arrayHash$mFc$sp__AF__I__I(a, this$1.seqSeed$2)
});
function $as_scm_WrappedArray$ofFloat(obj) {
  return (((obj instanceof $c_scm_WrappedArray$ofFloat) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.WrappedArray$ofFloat"))
}
function $isArrayOf_scm_WrappedArray$ofFloat(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_WrappedArray$ofFloat)))
}
function $asArrayOf_scm_WrappedArray$ofFloat(obj, depth) {
  return (($isArrayOf_scm_WrappedArray$ofFloat(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.WrappedArray$ofFloat;", depth))
}
var $d_scm_WrappedArray$ofFloat = new $TypeData().initClass({
  scm_WrappedArray$ofFloat: 0
}, false, "scala.collection.mutable.WrappedArray$ofFloat", {
  scm_WrappedArray$ofFloat: 1,
  scm_WrappedArray: 1,
  scm_AbstractSeq: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_IndexedSeq: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  scm_IndexedSeqLike: 1,
  scm_ArrayLike: 1,
  scm_IndexedSeqOptimized: 1,
  sc_IndexedSeqOptimized: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_WrappedArray$ofFloat.prototype.$classData = $d_scm_WrappedArray$ofFloat;
/** @constructor */
function $c_scm_WrappedArray$ofInt() {
  $c_scm_WrappedArray.call(this);
  this.array$6 = null
}
$c_scm_WrappedArray$ofInt.prototype = new $h_scm_WrappedArray();
$c_scm_WrappedArray$ofInt.prototype.constructor = $c_scm_WrappedArray$ofInt;
/** @constructor */
function $h_scm_WrappedArray$ofInt() {
  /*<skip>*/
}
$h_scm_WrappedArray$ofInt.prototype = $c_scm_WrappedArray$ofInt.prototype;
$c_scm_WrappedArray$ofInt.prototype.apply__I__O = (function(index) {
  return this.apply$mcII$sp__I__I(index)
});
$c_scm_WrappedArray$ofInt.prototype.apply__O__O = (function(v1) {
  var index = $uI(v1);
  return this.apply$mcII$sp__I__I(index)
});
$c_scm_WrappedArray$ofInt.prototype.update__I__O__V = (function(index, elem) {
  this.update__I__I__V(index, $uI(elem))
});
$c_scm_WrappedArray$ofInt.prototype.update__I__I__V = (function(index, elem) {
  this.array$6.set(index, elem)
});
$c_scm_WrappedArray$ofInt.prototype.equals__O__Z = (function(that) {
  if ((that instanceof $c_scm_WrappedArray$ofInt)) {
    var x2 = $as_scm_WrappedArray$ofInt(that);
    return $m_ju_Arrays$().equals__AI__AI__Z(this.array$6, x2.array$6)
  } else {
    return $f_sc_GenSeqLike__equals__O__Z(this, that)
  }
});
$c_scm_WrappedArray$ofInt.prototype.apply$mcII$sp__I__I = (function(index) {
  return this.array$6.get(index)
});
$c_scm_WrappedArray$ofInt.prototype.init___AI = (function(array) {
  this.array$6 = array;
  return this
});
$c_scm_WrappedArray$ofInt.prototype.length__I = (function() {
  return this.array$6.u.length
});
$c_scm_WrappedArray$ofInt.prototype.elemTag__s_reflect_ClassTag = (function() {
  return $m_s_reflect_ManifestFactory$IntManifest$()
});
$c_scm_WrappedArray$ofInt.prototype.array__O = (function() {
  return this.array$6
});
$c_scm_WrappedArray$ofInt.prototype.hashCode__I = (function() {
  var this$1 = $m_s_util_hashing_MurmurHash3$();
  var a = this.array$6;
  return this$1.arrayHash$mIc$sp__AI__I__I(a, this$1.seqSeed$2)
});
function $as_scm_WrappedArray$ofInt(obj) {
  return (((obj instanceof $c_scm_WrappedArray$ofInt) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.WrappedArray$ofInt"))
}
function $isArrayOf_scm_WrappedArray$ofInt(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_WrappedArray$ofInt)))
}
function $asArrayOf_scm_WrappedArray$ofInt(obj, depth) {
  return (($isArrayOf_scm_WrappedArray$ofInt(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.WrappedArray$ofInt;", depth))
}
var $d_scm_WrappedArray$ofInt = new $TypeData().initClass({
  scm_WrappedArray$ofInt: 0
}, false, "scala.collection.mutable.WrappedArray$ofInt", {
  scm_WrappedArray$ofInt: 1,
  scm_WrappedArray: 1,
  scm_AbstractSeq: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_IndexedSeq: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  scm_IndexedSeqLike: 1,
  scm_ArrayLike: 1,
  scm_IndexedSeqOptimized: 1,
  sc_IndexedSeqOptimized: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_WrappedArray$ofInt.prototype.$classData = $d_scm_WrappedArray$ofInt;
/** @constructor */
function $c_scm_WrappedArray$ofLong() {
  $c_scm_WrappedArray.call(this);
  this.array$6 = null
}
$c_scm_WrappedArray$ofLong.prototype = new $h_scm_WrappedArray();
$c_scm_WrappedArray$ofLong.prototype.constructor = $c_scm_WrappedArray$ofLong;
/** @constructor */
function $h_scm_WrappedArray$ofLong() {
  /*<skip>*/
}
$h_scm_WrappedArray$ofLong.prototype = $c_scm_WrappedArray$ofLong.prototype;
$c_scm_WrappedArray$ofLong.prototype.apply__I__O = (function(index) {
  return this.apply$mcJI$sp__I__J(index)
});
$c_scm_WrappedArray$ofLong.prototype.apply__O__O = (function(v1) {
  var index = $uI(v1);
  return this.apply$mcJI$sp__I__J(index)
});
$c_scm_WrappedArray$ofLong.prototype.init___AJ = (function(array) {
  this.array$6 = array;
  return this
});
$c_scm_WrappedArray$ofLong.prototype.update__I__O__V = (function(index, elem) {
  this.update__I__J__V(index, $uJ(elem))
});
$c_scm_WrappedArray$ofLong.prototype.equals__O__Z = (function(that) {
  if ((that instanceof $c_scm_WrappedArray$ofLong)) {
    var x2 = $as_scm_WrappedArray$ofLong(that);
    return $m_ju_Arrays$().equals__AJ__AJ__Z(this.array$6, x2.array$6)
  } else {
    return $f_sc_GenSeqLike__equals__O__Z(this, that)
  }
});
$c_scm_WrappedArray$ofLong.prototype.length__I = (function() {
  return this.array$6.u.length
});
$c_scm_WrappedArray$ofLong.prototype.elemTag__s_reflect_ClassTag = (function() {
  return $m_s_reflect_ManifestFactory$LongManifest$()
});
$c_scm_WrappedArray$ofLong.prototype.update__I__J__V = (function(index, elem) {
  this.array$6.set(index, elem)
});
$c_scm_WrappedArray$ofLong.prototype.array__O = (function() {
  return this.array$6
});
$c_scm_WrappedArray$ofLong.prototype.hashCode__I = (function() {
  var this$1 = $m_s_util_hashing_MurmurHash3$();
  var a = this.array$6;
  return this$1.arrayHash$mJc$sp__AJ__I__I(a, this$1.seqSeed$2)
});
$c_scm_WrappedArray$ofLong.prototype.apply$mcJI$sp__I__J = (function(index) {
  return this.array$6.get(index)
});
function $as_scm_WrappedArray$ofLong(obj) {
  return (((obj instanceof $c_scm_WrappedArray$ofLong) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.WrappedArray$ofLong"))
}
function $isArrayOf_scm_WrappedArray$ofLong(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_WrappedArray$ofLong)))
}
function $asArrayOf_scm_WrappedArray$ofLong(obj, depth) {
  return (($isArrayOf_scm_WrappedArray$ofLong(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.WrappedArray$ofLong;", depth))
}
var $d_scm_WrappedArray$ofLong = new $TypeData().initClass({
  scm_WrappedArray$ofLong: 0
}, false, "scala.collection.mutable.WrappedArray$ofLong", {
  scm_WrappedArray$ofLong: 1,
  scm_WrappedArray: 1,
  scm_AbstractSeq: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_IndexedSeq: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  scm_IndexedSeqLike: 1,
  scm_ArrayLike: 1,
  scm_IndexedSeqOptimized: 1,
  sc_IndexedSeqOptimized: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_WrappedArray$ofLong.prototype.$classData = $d_scm_WrappedArray$ofLong;
/** @constructor */
function $c_scm_WrappedArray$ofRef() {
  $c_scm_WrappedArray.call(this);
  this.elemTag$6 = null;
  this.array$6 = null;
  this.bitmap$0$6 = false
}
$c_scm_WrappedArray$ofRef.prototype = new $h_scm_WrappedArray();
$c_scm_WrappedArray$ofRef.prototype.constructor = $c_scm_WrappedArray$ofRef;
/** @constructor */
function $h_scm_WrappedArray$ofRef() {
  /*<skip>*/
}
$h_scm_WrappedArray$ofRef.prototype = $c_scm_WrappedArray$ofRef.prototype;
$c_scm_WrappedArray$ofRef.prototype.apply__I__O = (function(index) {
  return this.array$6.get(index)
});
$c_scm_WrappedArray$ofRef.prototype.apply__O__O = (function(v1) {
  return this.apply__I__O($uI(v1))
});
$c_scm_WrappedArray$ofRef.prototype.update__I__O__V = (function(index, elem) {
  this.array$6.set(index, elem)
});
$c_scm_WrappedArray$ofRef.prototype.elemTag$lzycompute__p6__s_reflect_ClassTag = (function() {
  if ((!this.bitmap$0$6)) {
    var jsx$1 = $m_s_reflect_ClassTag$();
    var this$1 = this.array$6;
    this.elemTag$6 = jsx$1.apply__jl_Class__s_reflect_ClassTag($objectGetClass(this$1).getComponentType__jl_Class());
    this.bitmap$0$6 = true
  };
  return this.elemTag$6
});
$c_scm_WrappedArray$ofRef.prototype.init___AO = (function(array) {
  this.array$6 = array;
  return this
});
$c_scm_WrappedArray$ofRef.prototype.length__I = (function() {
  return this.array$6.u.length
});
$c_scm_WrappedArray$ofRef.prototype.elemTag__s_reflect_ClassTag = (function() {
  return ((!this.bitmap$0$6) ? this.elemTag$lzycompute__p6__s_reflect_ClassTag() : this.elemTag$6)
});
$c_scm_WrappedArray$ofRef.prototype.array__O = (function() {
  return this.array$6
});
$c_scm_WrappedArray$ofRef.prototype.hashCode__I = (function() {
  var this$1 = $m_s_util_hashing_MurmurHash3$();
  var a = this.array$6;
  return this$1.arrayHash__O__I__I(a, this$1.seqSeed$2)
});
function $as_scm_WrappedArray$ofRef(obj) {
  return (((obj instanceof $c_scm_WrappedArray$ofRef) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.WrappedArray$ofRef"))
}
function $isArrayOf_scm_WrappedArray$ofRef(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_WrappedArray$ofRef)))
}
function $asArrayOf_scm_WrappedArray$ofRef(obj, depth) {
  return (($isArrayOf_scm_WrappedArray$ofRef(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.WrappedArray$ofRef;", depth))
}
var $d_scm_WrappedArray$ofRef = new $TypeData().initClass({
  scm_WrappedArray$ofRef: 0
}, false, "scala.collection.mutable.WrappedArray$ofRef", {
  scm_WrappedArray$ofRef: 1,
  scm_WrappedArray: 1,
  scm_AbstractSeq: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_IndexedSeq: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  scm_IndexedSeqLike: 1,
  scm_ArrayLike: 1,
  scm_IndexedSeqOptimized: 1,
  sc_IndexedSeqOptimized: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_WrappedArray$ofRef.prototype.$classData = $d_scm_WrappedArray$ofRef;
/** @constructor */
function $c_scm_WrappedArray$ofShort() {
  $c_scm_WrappedArray.call(this);
  this.array$6 = null
}
$c_scm_WrappedArray$ofShort.prototype = new $h_scm_WrappedArray();
$c_scm_WrappedArray$ofShort.prototype.constructor = $c_scm_WrappedArray$ofShort;
/** @constructor */
function $h_scm_WrappedArray$ofShort() {
  /*<skip>*/
}
$h_scm_WrappedArray$ofShort.prototype = $c_scm_WrappedArray$ofShort.prototype;
$c_scm_WrappedArray$ofShort.prototype.apply__I__O = (function(index) {
  return this.apply__I__S(index)
});
$c_scm_WrappedArray$ofShort.prototype.apply__O__O = (function(v1) {
  return this.apply__I__S($uI(v1))
});
$c_scm_WrappedArray$ofShort.prototype.update__I__S__V = (function(index, elem) {
  this.array$6.set(index, elem)
});
$c_scm_WrappedArray$ofShort.prototype.init___AS = (function(array) {
  this.array$6 = array;
  return this
});
$c_scm_WrappedArray$ofShort.prototype.update__I__O__V = (function(index, elem) {
  this.update__I__S__V(index, $uS(elem))
});
$c_scm_WrappedArray$ofShort.prototype.equals__O__Z = (function(that) {
  if ((that instanceof $c_scm_WrappedArray$ofShort)) {
    var x2 = $as_scm_WrappedArray$ofShort(that);
    return $m_ju_Arrays$().equals__AS__AS__Z(this.array$6, x2.array$6)
  } else {
    return $f_sc_GenSeqLike__equals__O__Z(this, that)
  }
});
$c_scm_WrappedArray$ofShort.prototype.length__I = (function() {
  return this.array$6.u.length
});
$c_scm_WrappedArray$ofShort.prototype.elemTag__s_reflect_ClassTag = (function() {
  return $m_s_reflect_ManifestFactory$ShortManifest$()
});
$c_scm_WrappedArray$ofShort.prototype.array__O = (function() {
  return this.array$6
});
$c_scm_WrappedArray$ofShort.prototype.hashCode__I = (function() {
  var this$1 = $m_s_util_hashing_MurmurHash3$();
  var a = this.array$6;
  return this$1.arrayHash$mSc$sp__AS__I__I(a, this$1.seqSeed$2)
});
$c_scm_WrappedArray$ofShort.prototype.apply__I__S = (function(index) {
  return this.array$6.get(index)
});
function $as_scm_WrappedArray$ofShort(obj) {
  return (((obj instanceof $c_scm_WrappedArray$ofShort) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.WrappedArray$ofShort"))
}
function $isArrayOf_scm_WrappedArray$ofShort(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_WrappedArray$ofShort)))
}
function $asArrayOf_scm_WrappedArray$ofShort(obj, depth) {
  return (($isArrayOf_scm_WrappedArray$ofShort(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.WrappedArray$ofShort;", depth))
}
var $d_scm_WrappedArray$ofShort = new $TypeData().initClass({
  scm_WrappedArray$ofShort: 0
}, false, "scala.collection.mutable.WrappedArray$ofShort", {
  scm_WrappedArray$ofShort: 1,
  scm_WrappedArray: 1,
  scm_AbstractSeq: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_IndexedSeq: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  scm_IndexedSeqLike: 1,
  scm_ArrayLike: 1,
  scm_IndexedSeqOptimized: 1,
  sc_IndexedSeqOptimized: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_WrappedArray$ofShort.prototype.$classData = $d_scm_WrappedArray$ofShort;
/** @constructor */
function $c_scm_WrappedArray$ofUnit() {
  $c_scm_WrappedArray.call(this);
  this.array$6 = null
}
$c_scm_WrappedArray$ofUnit.prototype = new $h_scm_WrappedArray();
$c_scm_WrappedArray$ofUnit.prototype.constructor = $c_scm_WrappedArray$ofUnit;
/** @constructor */
function $h_scm_WrappedArray$ofUnit() {
  /*<skip>*/
}
$h_scm_WrappedArray$ofUnit.prototype = $c_scm_WrappedArray$ofUnit.prototype;
$c_scm_WrappedArray$ofUnit.prototype.apply$mcVI$sp__I__V = (function(index) {
  this.array$6.get(index)
});
$c_scm_WrappedArray$ofUnit.prototype.apply__I__O = (function(index) {
  this.apply$mcVI$sp__I__V(index)
});
$c_scm_WrappedArray$ofUnit.prototype.apply__O__O = (function(v1) {
  var index = $uI(v1);
  this.apply$mcVI$sp__I__V(index)
});
$c_scm_WrappedArray$ofUnit.prototype.update__I__O__V = (function(index, elem) {
  this.update__I__sr_BoxedUnit__V(index, $asUnit(elem))
});
$c_scm_WrappedArray$ofUnit.prototype.equals__O__Z = (function(that) {
  if ((that instanceof $c_scm_WrappedArray$ofUnit)) {
    var x2 = $as_scm_WrappedArray$ofUnit(that);
    return (this.array$6.u.length === x2.array$6.u.length)
  } else {
    return $f_sc_GenSeqLike__equals__O__Z(this, that)
  }
});
$c_scm_WrappedArray$ofUnit.prototype.length__I = (function() {
  return this.array$6.u.length
});
$c_scm_WrappedArray$ofUnit.prototype.elemTag__s_reflect_ClassTag = (function() {
  return $m_s_reflect_ManifestFactory$UnitManifest$()
});
$c_scm_WrappedArray$ofUnit.prototype.init___Asr_BoxedUnit = (function(array) {
  this.array$6 = array;
  return this
});
$c_scm_WrappedArray$ofUnit.prototype.array__O = (function() {
  return this.array$6
});
$c_scm_WrappedArray$ofUnit.prototype.hashCode__I = (function() {
  var this$1 = $m_s_util_hashing_MurmurHash3$();
  var a = this.array$6;
  return this$1.arrayHash$mVc$sp__Asr_BoxedUnit__I__I(a, this$1.seqSeed$2)
});
$c_scm_WrappedArray$ofUnit.prototype.update__I__sr_BoxedUnit__V = (function(index, elem) {
  this.array$6.set(index, elem)
});
function $as_scm_WrappedArray$ofUnit(obj) {
  return (((obj instanceof $c_scm_WrappedArray$ofUnit) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.WrappedArray$ofUnit"))
}
function $isArrayOf_scm_WrappedArray$ofUnit(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_WrappedArray$ofUnit)))
}
function $asArrayOf_scm_WrappedArray$ofUnit(obj, depth) {
  return (($isArrayOf_scm_WrappedArray$ofUnit(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.WrappedArray$ofUnit;", depth))
}
var $d_scm_WrappedArray$ofUnit = new $TypeData().initClass({
  scm_WrappedArray$ofUnit: 0
}, false, "scala.collection.mutable.WrappedArray$ofUnit", {
  scm_WrappedArray$ofUnit: 1,
  scm_WrappedArray: 1,
  scm_AbstractSeq: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_IndexedSeq: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  scm_IndexedSeqLike: 1,
  scm_ArrayLike: 1,
  scm_IndexedSeqOptimized: 1,
  sc_IndexedSeqOptimized: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_WrappedArray$ofUnit.prototype.$classData = $d_scm_WrappedArray$ofUnit;
/** @constructor */
function $c_scm_IndexedSeqView$AbstractTransformed() {
  $c_sc_SeqViewLike$AbstractTransformed.call(this)
}
$c_scm_IndexedSeqView$AbstractTransformed.prototype = new $h_sc_SeqViewLike$AbstractTransformed();
$c_scm_IndexedSeqView$AbstractTransformed.prototype.constructor = $c_scm_IndexedSeqView$AbstractTransformed;
/** @constructor */
function $h_scm_IndexedSeqView$AbstractTransformed() {
  /*<skip>*/
}
$h_scm_IndexedSeqView$AbstractTransformed.prototype = $c_scm_IndexedSeqView$AbstractTransformed.prototype;
$c_scm_IndexedSeqView$AbstractTransformed.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.newSliced__scg_SliceInterval__sc_SeqViewLike$Transformed = (function(_endpoints) {
  return new $c_scm_IndexedSeqView$$anon$2().init___scm_IndexedSeqView__scg_SliceInterval(this, _endpoints)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.head__O = (function() {
  return $f_sc_IndexedSeqOptimized__head__O(this)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_IndexedSeqOptimized__lengthCompare__I__I(this, len)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.take__I__sc_IterableView = (function(n) {
  return $f_scm_IndexedSeqView__take__I__scm_IndexedSeqView(this, n)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IndexedSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.flatten__F1__sc_GenTraversable = (function(asTraversable) {
  return new $c_sc_SeqViewLike$$anon$5().init___sc_SeqViewLike__F1(this, asTraversable)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.exists__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__exists__F1__Z(this, p)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.toList__sci_List = (function() {
  return $f_sc_IndexedSeqOptimized__toList__sci_List(this)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.isEmpty__Z = (function() {
  return $f_sc_IndexedSeqOptimized__isEmpty__Z(this)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.scala$collection$IndexedSeqOptimized$$super$init__O = (function() {
  return $f_sc_TraversableViewLike__init__sc_TraversableView(this)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.dropWhile__F1__O = (function(p) {
  return new $c_scm_IndexedSeqView$$anon$3().init___scm_IndexedSeqView__F1(this, p)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.newDroppedWhile__F1__sc_SeqViewLike$Transformed = (function(p) {
  return new $c_scm_IndexedSeqView$$anon$3().init___scm_IndexedSeqView__F1(this, p)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.withFilter__F1__scg_FilterMonadic = (function(p) {
  return $f_sc_TraversableViewLike__withFilter__F1__sc_TraversableView(this, p)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.forall__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__forall__F1__Z(this, p)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.sorted__s_math_Ordering__O = (function(ord) {
  return $f_sc_SeqViewLike__sorted__s_math_Ordering__sc_SeqView(this, ord)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.companion__scg_GenericCompanion = (function() {
  return $m_scm_IndexedSeq$()
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.toString__T = (function() {
  return $f_sc_TraversableViewLike__viewToString__T(this)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.newReversed__sc_SeqViewLike$Transformed = (function() {
  return new $c_scm_IndexedSeqView$$anon$5().init___scm_IndexedSeqView(this)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.newFiltered__F1__sc_SeqViewLike$Transformed = (function(p) {
  return new $c_scm_IndexedSeqView$$anon$1().init___scm_IndexedSeqView__F1(this, p)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.foreach__F1__V = (function(f) {
  $f_sc_IndexedSeqOptimized__foreach__F1__V(this, f)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.takeWhile__F1__sc_TraversableView = (function(p) {
  return new $c_scm_IndexedSeqView$$anon$4().init___scm_IndexedSeqView__F1(this, p)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.foldLeft__O__F2__O = (function(z, op) {
  var start = 0;
  var end = this.length__I();
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_IndexedSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.takeWhile__F1__O = (function(p) {
  return new $c_scm_IndexedSeqView$$anon$4().init___scm_IndexedSeqView__F1(this, p)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.slice__I__I__O = (function(from, until) {
  return $f_scm_IndexedSeqView__slice__I__I__scm_IndexedSeqView(this, from, until)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.intersect__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqViewLike__intersect__sc_GenSeq__sc_SeqView(this, that)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.filter__F1__O = (function(p) {
  return new $c_scm_IndexedSeqView$$anon$1().init___scm_IndexedSeqView__F1(this, p)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.reverse__O = (function() {
  return new $c_scm_IndexedSeqView$$anon$5().init___scm_IndexedSeqView(this)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_IndexedSeqLike__toBuffer__scm_Buffer(this)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.scala$collection$mutable$IndexedSeqView$$super$tail__scm_IndexedSeqView = (function() {
  return $as_scm_IndexedSeqView($f_sc_IndexedSeqOptimized__tail__O(this))
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.newFlatMapped__F1__sc_TraversableViewLike$Transformed = (function(f) {
  return new $c_sc_SeqViewLike$$anon$5().init___sc_SeqViewLike__F1(this, f)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.distinct__O = (function() {
  return $f_sc_SeqViewLike__distinct__sc_SeqView(this)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.newTakenWhile__F1__sc_SeqViewLike$Transformed = (function(p) {
  return new $c_scm_IndexedSeqView$$anon$4().init___scm_IndexedSeqView__F1(this, p)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_IndexedSeqOptimized__find__F1__s_Option(this, p)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.span__F1__T2 = (function(p) {
  return $f_scm_IndexedSeqView__span__F1__T2(this, p)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.diff__sc_GenSeq__O = (function(that) {
  return $f_sc_SeqViewLike__diff__sc_GenSeq__sc_SeqView(this, that)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.dropWhile__F1__sc_TraversableView = (function(p) {
  return new $c_scm_IndexedSeqView$$anon$3().init___scm_IndexedSeqView__F1(this, p)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.reverse__sc_SeqView = (function() {
  return new $c_scm_IndexedSeqView$$anon$5().init___scm_IndexedSeqView(this)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.newAppended__sc_GenTraversable__sc_TraversableViewLike$Transformed = (function(that) {
  return new $c_sc_SeqViewLike$$anon$2().init___sc_SeqViewLike__sc_GenTraversable(this, that)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IndexedSeqOptimized__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.scala$collection$IndexedSeqOptimized$$super$tail__O = (function() {
  return $f_sc_TraversableViewLike__tail__sc_TraversableView(this)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.scala$collection$IndexedSeqOptimized$$super$last__O = (function() {
  return $f_sc_TraversableViewLike$Transformed__last__O(this)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.filterNot__F1__O = (function(p) {
  return $f_sc_TraversableViewLike__filterNot__F1__sc_TraversableView(this, p)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.seq__sc_Seq = (function() {
  return this
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.sizeHintIfCheap__I = (function() {
  return this.length__I()
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.splitAt__I__T2 = (function(n) {
  return $f_scm_IndexedSeqView__splitAt__I__T2(this, n)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.take__I__O = (function(n) {
  return $f_scm_IndexedSeqView__take__I__scm_IndexedSeqView(this, n)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.drop__I__sc_IterableView = (function(n) {
  return $f_scm_IndexedSeqView__drop__I__scm_IndexedSeqView(this, n)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.newTakenWhile__F1__sc_TraversableViewLike$Transformed = (function(p) {
  return new $c_scm_IndexedSeqView$$anon$4().init___scm_IndexedSeqView__F1(this, p)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.last__O = (function() {
  return $f_sc_IndexedSeqOptimized__last__O(this)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.view__sc_SeqView = (function() {
  return new $c_scm_IndexedSeqLike$$anon$1().init___scm_IndexedSeqLike(this)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.drop__I__O = (function(n) {
  return $f_scm_IndexedSeqView__drop__I__scm_IndexedSeqView(this, n)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.newMapped__F1__sc_TraversableViewLike$Transformed = (function(f) {
  return new $c_sc_SeqViewLike$$anon$4().init___sc_SeqViewLike__F1(this, f)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.thisCollection__sc_Seq = (function() {
  return this
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.tail__O = (function() {
  return $f_scm_IndexedSeqView__tail__scm_IndexedSeqView(this)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.sortBy__F1__s_math_Ordering__O = (function(f, ord) {
  return $f_sc_SeqViewLike__sortBy__F1__s_math_Ordering__sc_SeqView(this, f, ord)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.filter__F1__sc_TraversableView = (function(p) {
  return new $c_scm_IndexedSeqView$$anon$1().init___scm_IndexedSeqView__F1(this, p)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.isDefinedAt__O__Z = (function(x) {
  var idx = $uI(x);
  return $f_sc_GenSeqLike__isDefinedAt__I__Z(this, idx)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.init___scm_IndexedSeqView = (function($$outer) {
  $c_sc_SeqViewLike$AbstractTransformed.prototype.init___sc_SeqViewLike.call(this, $$outer);
  return this
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.newSliced__scg_SliceInterval__sc_TraversableViewLike$Transformed = (function(_endpoints) {
  return new $c_scm_IndexedSeqView$$anon$2().init___scm_IndexedSeqView__scg_SliceInterval(this, _endpoints)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.newZipped__sc_GenIterable__sc_IterableViewLike$Transformed = (function(that) {
  return new $c_sc_SeqViewLike$$anon$10().init___sc_SeqViewLike__sc_GenIterable(this, that)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_sc_IndexedSeqOptimized__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.toSeq__sc_GenSeq = (function() {
  return this
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.hashCode__I = (function() {
  return $m_s_util_hashing_MurmurHash3$().seqHash__sc_Seq__I(this)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.newFiltered__F1__sc_TraversableViewLike$Transformed = (function(p) {
  return new $c_scm_IndexedSeqView$$anon$1().init___scm_IndexedSeqView__F1(this, p)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.scala$collection$IndexedSeqOptimized$$super$zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return new $c_sc_SeqViewLike$$anon$10().init___sc_SeqViewLike__sc_GenIterable(this, that)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.segmentLength__F1__I__I = (function(p, from) {
  return $f_sc_IndexedSeqOptimized__segmentLength__F1__I__I(this, p, from)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.newDroppedWhile__F1__sc_TraversableViewLike$Transformed = (function(p) {
  return new $c_scm_IndexedSeqView$$anon$3().init___scm_IndexedSeqView__F1(this, p)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_IndexedSeqOptimized__reduceLeft__F2__O(this, op)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.newForced__F0__sc_TraversableViewLike$Transformed = (function(xs) {
  return new $c_sc_SeqViewLike$$anon$1().init___sc_SeqViewLike__F0(this, xs)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.sortWith__F2__O = (function(lt) {
  return $f_sc_SeqViewLike__sortWith__F2__sc_SeqView(this, lt)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.tail__sc_TraversableView = (function() {
  return $f_scm_IndexedSeqView__tail__scm_IndexedSeqView(this)
});
$c_scm_IndexedSeqView$AbstractTransformed.prototype.zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_IndexedSeqOptimized__zip__sc_GenIterable__scg_CanBuildFrom__O(this, that, bf)
});
/** @constructor */
function $c_scm_ListBuffer() {
  $c_scm_AbstractBuffer.call(this);
  this.scala$collection$mutable$ListBuffer$$start$6 = null;
  this.last0$6 = null;
  this.exported$6 = false;
  this.len$6 = 0
}
$c_scm_ListBuffer.prototype = new $h_scm_AbstractBuffer();
$c_scm_ListBuffer.prototype.constructor = $c_scm_ListBuffer;
/** @constructor */
function $h_scm_ListBuffer() {
  /*<skip>*/
}
$h_scm_ListBuffer.prototype = $c_scm_ListBuffer.prototype;
$c_scm_ListBuffer.prototype.indexOf__O__I__I = (function(elem, from) {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  return $f_sc_GenSeqLike__indexOf__O__I__I(this$1, elem, from)
});
$c_scm_ListBuffer.prototype.copyToArray__O__I__V = (function(xs, start) {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  $f_sc_TraversableOnce__copyToArray__O__I__V(this$1, xs, start)
});
$c_scm_ListBuffer.prototype.copy__p6__V = (function() {
  if (this.isEmpty__Z()) {
    return (void 0)
  };
  var cursor = this.scala$collection$mutable$ListBuffer$$start$6;
  var this$1 = this.last0$6;
  var limit = this$1.tl$5;
  this.clear__V();
  while ((cursor !== limit)) {
    this.$$plus$eq__O__scm_ListBuffer(cursor.head__O());
    cursor = $as_sci_List(cursor.tail__O())
  }
});
$c_scm_ListBuffer.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_scm_ListBuffer.prototype.head__O = (function() {
  return this.scala$collection$mutable$ListBuffer$$start$6.head__O()
});
$c_scm_ListBuffer.prototype.init___ = (function() {
  this.scala$collection$mutable$ListBuffer$$start$6 = $m_sci_Nil$();
  this.exported$6 = false;
  this.len$6 = 0;
  return this
});
$c_scm_ListBuffer.prototype.apply__I__O = (function(n) {
  if (((n < 0) || (n >= this.len$6))) {
    throw new $c_jl_IndexOutOfBoundsException().init___T(("" + n))
  } else {
    var this$2 = this.scala$collection$mutable$ListBuffer$$start$6;
    return $f_sc_LinearSeqOptimized__apply__I__O(this$2, n)
  }
});
$c_scm_ListBuffer.prototype.thisCollection__sc_Iterable = (function() {
  return this
});
$c_scm_ListBuffer.prototype.lengthCompare__I__I = (function(len) {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  return $f_sc_LinearSeqOptimized__lengthCompare__I__I(this$1, len)
});
$c_scm_ListBuffer.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  return $f_sc_LinearSeqOptimized__sameElements__sc_GenIterable__Z(this$1, that)
});
$c_scm_ListBuffer.prototype.apply__O__O = (function(v1) {
  return this.apply__I__O($uI(v1))
});
$c_scm_ListBuffer.prototype.exists__F1__Z = (function(p) {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  return $f_sc_LinearSeqOptimized__exists__F1__Z(this$1, p)
});
$c_scm_ListBuffer.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  var this$1 = new $c_scm_ListBuffer().init___().$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(this);
  return this$1.$$minus$eq__O__scm_ListBuffer(elem)
});
$c_scm_ListBuffer.prototype.toList__sci_List = (function() {
  this.exported$6 = (!this.isEmpty__Z());
  return this.scala$collection$mutable$ListBuffer$$start$6
});
$c_scm_ListBuffer.prototype.isEmpty__Z = (function() {
  return (this.len$6 === 0)
});
$c_scm_ListBuffer.prototype.update__I__O__V = (function(n, x) {
  if (((n < 0) || (n >= this.len$6))) {
    throw new $c_jl_IndexOutOfBoundsException().init___T(("" + n))
  };
  this.ensureUnaliased__p6__V();
  if ((n === 0)) {
    var newElem = new $c_sci_$colon$colon().init___O__sci_List(x, $as_sci_List(this.scala$collection$mutable$ListBuffer$$start$6.tail__O()));
    if ((this.last0$6 === this.scala$collection$mutable$ListBuffer$$start$6)) {
      this.last0$6 = newElem
    };
    this.scala$collection$mutable$ListBuffer$$start$6 = newElem
  } else {
    var cursor = this.scala$collection$mutable$ListBuffer$$start$6;
    var i = 1;
    while ((i < n)) {
      cursor = $as_sci_List(cursor.tail__O());
      i = ((1 + i) | 0)
    };
    var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(x, $as_sci_List($as_sc_TraversableLike(cursor.tail__O()).tail__O()));
    if ((this.last0$6 === cursor.tail__O())) {
      this.last0$6 = newElem$2
    };
    $as_sci_$colon$colon(cursor).tl$5 = newElem$2
  }
});
$c_scm_ListBuffer.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_scm_ListBuffer.prototype.equals__O__Z = (function(that) {
  if ((that instanceof $c_scm_ListBuffer)) {
    var x2 = $as_scm_ListBuffer(that);
    return this.scala$collection$mutable$ListBuffer$$start$6.equals__O__Z(x2.scala$collection$mutable$ListBuffer$$start$6)
  } else {
    return $f_sc_GenSeqLike__equals__O__Z(this, that)
  }
});
$c_scm_ListBuffer.prototype.mkString__T__T = (function(sep) {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this$1, "", sep, "")
});
$c_scm_ListBuffer.prototype.mkString__T__T__T__T = (function(start, sep, end) {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this$1, start, sep, end)
});
$c_scm_ListBuffer.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__O__scm_ListBuffer(elem)
});
$c_scm_ListBuffer.prototype.clone__scm_Buffer = (function() {
  return new $c_scm_ListBuffer().init___().$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(this)
});
$c_scm_ListBuffer.prototype.forall__F1__Z = (function(p) {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  return $f_sc_LinearSeqOptimized__forall__F1__Z(this$1, p)
});
$c_scm_ListBuffer.prototype.companion__scg_GenericCompanion = (function() {
  return $m_scm_ListBuffer$()
});
$c_scm_ListBuffer.prototype.foreach__F1__V = (function(f) {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  var these = this$1;
  while ((!these.isEmpty__Z())) {
    f.apply__O__O(these.head__O());
    these = $as_sci_List(these.tail__O())
  }
});
$c_scm_ListBuffer.prototype.foldLeft__O__F2__O = (function(z, op) {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  return $f_sc_LinearSeqOptimized__foldLeft__O__F2__O(this$1, z, op)
});
$c_scm_ListBuffer.prototype.indexWhere__F1__I__I = (function(p, from) {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  return $f_sc_LinearSeqOptimized__indexWhere__F1__I__I(this$1, p, from)
});
$c_scm_ListBuffer.prototype.headOption__s_Option = (function() {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  return $f_sc_TraversableLike__headOption__s_Option(this$1)
});
$c_scm_ListBuffer.prototype.size__I = (function() {
  return this.len$6
});
$c_scm_ListBuffer.prototype.toBuffer__scm_Buffer = (function() {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  var this$2 = $m_scm_ArrayBuffer$();
  var cbf = this$2.ReusableCBFInstance$2;
  return $as_scm_Buffer($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this$1, cbf))
});
$c_scm_ListBuffer.prototype.result__O = (function() {
  return this.toList__sci_List()
});
$c_scm_ListBuffer.prototype.iterator__sc_Iterator = (function() {
  return new $c_scm_ListBuffer$$anon$1().init___scm_ListBuffer(this)
});
$c_scm_ListBuffer.prototype.sizeHintBounded__I__sc_TraversableLike__V = (function(size, boundingColl) {
  $f_scm_Builder__sizeHintBounded__I__sc_TraversableLike__V(this, size, boundingColl)
});
$c_scm_ListBuffer.prototype.find__F1__s_Option = (function(p) {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  return $f_sc_LinearSeqOptimized__find__F1__s_Option(this$1, p)
});
$c_scm_ListBuffer.prototype.mkString__T = (function() {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  return $f_sc_TraversableOnce__mkString__T__T__T__T(this$1, "", "", "")
});
$c_scm_ListBuffer.prototype.length__I = (function() {
  return this.len$6
});
$c_scm_ListBuffer.prototype.seq__sc_Seq = (function() {
  return this
});
$c_scm_ListBuffer.prototype.remove__I__O = (function(n) {
  if (((n < 0) || (n >= this.len$6))) {
    throw new $c_jl_IndexOutOfBoundsException().init___T(("" + n))
  };
  this.ensureUnaliased__p6__V();
  var old = this.scala$collection$mutable$ListBuffer$$start$6.head__O();
  if ((n === 0)) {
    this.scala$collection$mutable$ListBuffer$$start$6 = $as_sci_List(this.scala$collection$mutable$ListBuffer$$start$6.tail__O())
  } else {
    var cursor = this.scala$collection$mutable$ListBuffer$$start$6;
    var i = 1;
    while ((i < n)) {
      cursor = $as_sci_List(cursor.tail__O());
      i = ((1 + i) | 0)
    };
    old = $as_sc_IterableLike(cursor.tail__O()).head__O();
    if ((this.last0$6 === cursor.tail__O())) {
      this.last0$6 = $as_sci_$colon$colon(cursor)
    };
    $as_sci_$colon$colon(cursor).tl$5 = $as_sci_List($as_sc_TraversableLike(cursor.tail__O()).tail__O())
  };
  this.reduceLengthBy__p6__I__V(1);
  return old
});
$c_scm_ListBuffer.prototype.$$minus$eq__O__scm_ListBuffer = (function(elem) {
  this.ensureUnaliased__p6__V();
  if ((!this.isEmpty__Z())) {
    if ($m_sr_BoxesRunTime$().equals__O__O__Z(this.scala$collection$mutable$ListBuffer$$start$6.head__O(), elem)) {
      this.scala$collection$mutable$ListBuffer$$start$6 = $as_sci_List(this.scala$collection$mutable$ListBuffer$$start$6.tail__O());
      this.reduceLengthBy__p6__I__V(1)
    } else {
      var cursor = this.scala$collection$mutable$ListBuffer$$start$6;
      while (((!$as_sc_SeqLike(cursor.tail__O()).isEmpty__Z()) && (!$m_sr_BoxesRunTime$().equals__O__O__Z($as_sc_IterableLike(cursor.tail__O()).head__O(), elem)))) {
        cursor = $as_sci_List(cursor.tail__O())
      };
      if ((!$as_sc_SeqLike(cursor.tail__O()).isEmpty__Z())) {
        var z = $as_sci_$colon$colon(cursor);
        var x = z.tl$5;
        var x$2 = this.last0$6;
        if (((x === null) ? (x$2 === null) : x.equals__O__Z(x$2))) {
          this.last0$6 = z
        };
        z.tl$5 = $as_sci_List($as_sc_TraversableLike(cursor.tail__O()).tail__O());
        this.reduceLengthBy__p6__I__V(1)
      }
    }
  };
  return this
});
$c_scm_ListBuffer.prototype.toStream__sci_Stream = (function() {
  return this.scala$collection$mutable$ListBuffer$$start$6.toStream__sci_Stream()
});
$c_scm_ListBuffer.prototype.last__O = (function() {
  if ((this.last0$6 === null)) {
    throw new $c_ju_NoSuchElementException().init___T("last of empty ListBuffer")
  } else {
    return this.last0$6.head$5
  }
});
$c_scm_ListBuffer.prototype.reduceLengthBy__p6__I__V = (function(num) {
  this.len$6 = ((this.len$6 - num) | 0);
  if ((this.len$6 <= 0)) {
    this.last0$6 = null
  }
});
$c_scm_ListBuffer.prototype.prependToList__sci_List__sci_List = (function(xs) {
  if (this.isEmpty__Z()) {
    return xs
  } else {
    this.ensureUnaliased__p6__V();
    this.last0$6.tl$5 = xs;
    return this.toList__sci_List()
  }
});
$c_scm_ListBuffer.prototype.contains__O__Z = (function(elem) {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  return $f_sc_LinearSeqOptimized__contains__O__Z(this$1, elem)
});
$c_scm_ListBuffer.prototype.addString__scm_StringBuilder__T__T__T__scm_StringBuilder = (function(b, start, sep, end) {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  return $f_sc_TraversableOnce__addString__scm_StringBuilder__T__T__T__scm_StringBuilder(this$1, b, start, sep, end)
});
$c_scm_ListBuffer.prototype.$$plus$eq__O__scm_ListBuffer = (function(x) {
  this.ensureUnaliased__p6__V();
  var last1 = new $c_sci_$colon$colon().init___O__sci_List(x, $m_sci_Nil$());
  if ((this.len$6 === 0)) {
    this.scala$collection$mutable$ListBuffer$$start$6 = last1
  } else {
    this.last0$6.tl$5 = last1
  };
  this.last0$6 = last1;
  this.len$6 = ((1 + this.len$6) | 0);
  return this
});
$c_scm_ListBuffer.prototype.toSeq__sc_Seq = (function() {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  return this$1
});
$c_scm_ListBuffer.prototype.isDefinedAt__O__Z = (function(x) {
  var x$1 = $uI(x);
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  return $f_sc_LinearSeqOptimized__isDefinedAt__I__Z(this$1, x$1)
});
$c_scm_ListBuffer.prototype.$$minus$eq__O__scm_Buffer = (function(x) {
  return this.$$minus$eq__O__scm_ListBuffer(x)
});
$c_scm_ListBuffer.prototype.toSet__sci_Set = (function() {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  var this$2 = $m_sci_Set$();
  var cbf = new $c_scg_GenSetFactory$$anon$1().init___scg_GenSetFactory(this$2);
  return $as_sci_Set($f_sc_TraversableLike__to__scg_CanBuildFrom__O(this$1, cbf))
});
$c_scm_ListBuffer.prototype.$$div$colon__O__F2__O = (function(z, op) {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  return $f_sc_LinearSeqOptimized__foldLeft__O__F2__O(this$1, z, op)
});
$c_scm_ListBuffer.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__O__scm_ListBuffer(elem)
});
$c_scm_ListBuffer.prototype.indexOf__O__I = (function(elem) {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  return $f_sc_GenSeqLike__indexOf__O__I__I(this$1, elem, 0)
});
$c_scm_ListBuffer.prototype.sizeHint__I__V = (function(size) {
  /*<skip>*/
});
$c_scm_ListBuffer.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  $f_sc_IterableLike__copyToArray__O__I__I__V(this$1, xs, start, len)
});
$c_scm_ListBuffer.prototype.toSeq__sc_GenSeq = (function() {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  return this$1
});
$c_scm_ListBuffer.prototype.toMap__s_Predef$$less$colon$less__sci_Map = (function(ev) {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  var b = new $c_scm_MapBuilder().init___sc_GenMap($m_sci_Map$EmptyMap$());
  var these = this$1;
  while ((!these.isEmpty__Z())) {
    var arg1 = these.head__O();
    b.$$plus$eq__T2__scm_MapBuilder($as_T2(arg1));
    these = $as_sci_List(these.tail__O())
  };
  return $as_sci_Map(b.elems$1)
});
$c_scm_ListBuffer.prototype.$$minus$eq__O__scg_Shrinkable = (function(elem) {
  return this.$$minus$eq__O__scm_ListBuffer(elem)
});
$c_scm_ListBuffer.prototype.clear__V = (function() {
  this.scala$collection$mutable$ListBuffer$$start$6 = $m_sci_Nil$();
  this.last0$6 = null;
  this.exported$6 = false;
  this.len$6 = 0
});
$c_scm_ListBuffer.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  return $f_sc_TraversableOnce__toArray__s_reflect_ClassTag__O(this$1, evidence$1)
});
$c_scm_ListBuffer.prototype.insertAll__I__sc_Traversable__V = (function(n, seq) {
  if (((n < 0) || (n > this.len$6))) {
    throw new $c_jl_IndexOutOfBoundsException().init___T(("" + n))
  };
  this.ensureUnaliased__p6__V();
  var elems = seq.toList__sci_List().reverse__sci_List();
  var jsx$1 = this.len$6;
  var this$2 = elems;
  this.len$6 = ((jsx$1 + $f_sc_LinearSeqOptimized__length__I(this$2)) | 0);
  if ((n === 0)) {
    while ((!elems.isEmpty__Z())) {
      var newElem = new $c_sci_$colon$colon().init___O__sci_List(elems.head__O(), this.scala$collection$mutable$ListBuffer$$start$6);
      if (this.scala$collection$mutable$ListBuffer$$start$6.isEmpty__Z()) {
        this.last0$6 = newElem
      };
      this.scala$collection$mutable$ListBuffer$$start$6 = newElem;
      elems = $as_sci_List(elems.tail__O())
    }
  } else {
    var cursor = this.scala$collection$mutable$ListBuffer$$start$6;
    var i = 1;
    while ((i < n)) {
      cursor = $as_sci_List(cursor.tail__O());
      i = ((1 + i) | 0)
    };
    while ((!elems.isEmpty__Z())) {
      var newElem$2 = new $c_sci_$colon$colon().init___O__sci_List(elems.head__O(), $as_sci_List(cursor.tail__O()));
      if ($as_sc_SeqLike(cursor.tail__O()).isEmpty__Z()) {
        this.last0$6 = newElem$2
      };
      $as_sci_$colon$colon(cursor).tl$5 = newElem$2;
      elems = $as_sci_List(elems.tail__O())
    }
  }
});
$c_scm_ListBuffer.prototype.ensureUnaliased__p6__V = (function() {
  if (this.exported$6) {
    this.copy__p6__V()
  }
});
$c_scm_ListBuffer.prototype.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer = (function(xs) {
  _$plus$plus$eq: while (true) {
    var x1 = xs;
    if ((x1 !== null)) {
      if ((x1 === this)) {
        var n = this.len$6;
        xs = $as_sc_TraversableOnce($f_sc_IterableLike__take__I__O(this, n));
        continue _$plus$plus$eq
      }
    };
    return $as_scm_ListBuffer($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs))
  }
});
$c_scm_ListBuffer.prototype.nonEmpty__Z = (function() {
  return (this.len$6 > 0)
});
$c_scm_ListBuffer.prototype.reduceLeft__F2__O = (function(op) {
  var this$1 = this.scala$collection$mutable$ListBuffer$$start$6;
  return $f_sc_LinearSeqOptimized__reduceLeft__F2__O(this$1, op)
});
$c_scm_ListBuffer.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return this.$$plus$plus$eq__sc_TraversableOnce__scm_ListBuffer(xs)
});
$c_scm_ListBuffer.prototype.stringPrefix__T = (function() {
  return "ListBuffer"
});
function $as_scm_ListBuffer(obj) {
  return (((obj instanceof $c_scm_ListBuffer) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ListBuffer"))
}
function $isArrayOf_scm_ListBuffer(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ListBuffer)))
}
function $asArrayOf_scm_ListBuffer(obj, depth) {
  return (($isArrayOf_scm_ListBuffer(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ListBuffer;", depth))
}
var $d_scm_ListBuffer = new $TypeData().initClass({
  scm_ListBuffer: 0
}, false, "scala.collection.mutable.ListBuffer", {
  scm_ListBuffer: 1,
  scm_AbstractBuffer: 1,
  scm_AbstractSeq: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_Buffer: 1,
  scm_BufferLike: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  scg_Shrinkable: 1,
  sc_script_Scriptable: 1,
  scg_Subtractable: 1,
  scm_ReusableBuilder: 1,
  scm_Builder: 1,
  scg_SeqForwarder: 1,
  scg_IterableForwarder: 1,
  scg_TraversableForwarder: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_ListBuffer.prototype.$classData = $d_scm_ListBuffer;
/** @constructor */
function $c_scm_StringBuilder() {
  $c_scm_AbstractSeq.call(this);
  this.underlying$5 = null
}
$c_scm_StringBuilder.prototype = new $h_scm_AbstractSeq();
$c_scm_StringBuilder.prototype.constructor = $c_scm_StringBuilder;
/** @constructor */
function $h_scm_StringBuilder() {
  /*<skip>*/
}
$h_scm_StringBuilder.prototype = $c_scm_StringBuilder.prototype;
$c_scm_StringBuilder.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_scm_StringBuilder.prototype.head__O = (function() {
  return $f_sc_IndexedSeqOptimized__head__O(this)
});
$c_scm_StringBuilder.prototype.$$plus$eq__C__scm_StringBuilder = (function(x) {
  this.append__C__scm_StringBuilder(x);
  return this
});
$c_scm_StringBuilder.prototype.init___ = (function() {
  $c_scm_StringBuilder.prototype.init___I__T.call(this, 16, "");
  return this
});
$c_scm_StringBuilder.prototype.apply__I__O = (function(idx) {
  var c = this.underlying$5.charAt__I__C(idx);
  return new $c_jl_Character().init___C(c)
});
$c_scm_StringBuilder.prototype.thisCollection__sc_Iterable = (function() {
  return this
});
$c_scm_StringBuilder.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_IndexedSeqOptimized__lengthCompare__I__I(this, len)
});
$c_scm_StringBuilder.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IndexedSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_scm_StringBuilder.prototype.apply__O__O = (function(v1) {
  var index = $uI(v1);
  var c = this.underlying$5.charAt__I__C(index);
  return new $c_jl_Character().init___C(c)
});
$c_scm_StringBuilder.prototype.exists__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__exists__F1__Z(this, p)
});
$c_scm_StringBuilder.prototype.toList__sci_List = (function() {
  return $f_sc_IndexedSeqOptimized__toList__sci_List(this)
});
$c_scm_StringBuilder.prototype.isEmpty__Z = (function() {
  return $f_sc_IndexedSeqOptimized__isEmpty__Z(this)
});
$c_scm_StringBuilder.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_scm_StringBuilder.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_scm_StringBuilder.prototype.subSequence__I__I__jl_CharSequence = (function(start, end) {
  return this.underlying$5.substring__I__I__T(start, end)
});
$c_scm_StringBuilder.prototype.apply__I__C = (function(index) {
  return this.underlying$5.charAt__I__C(index)
});
$c_scm_StringBuilder.prototype.scala$collection$IndexedSeqOptimized$$super$init__O = (function() {
  return $f_sc_TraversableLike__init__O(this)
});
$c_scm_StringBuilder.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__dropWhile__F1__O(this, p)
});
$c_scm_StringBuilder.prototype.$$plus$plus$eq__T__scm_StringBuilder = (function(s) {
  var this$1 = this.underlying$5;
  this$1.java$lang$StringBuilder$$content$f = (("" + this$1.java$lang$StringBuilder$$content$f) + s);
  return this
});
$c_scm_StringBuilder.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  if ((elem === null)) {
    var jsx$1 = 0
  } else {
    var this$2 = $as_jl_Character(elem);
    var jsx$1 = this$2.value$1
  };
  return this.$$plus$eq__C__scm_StringBuilder(jsx$1)
});
$c_scm_StringBuilder.prototype.forall__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__forall__F1__Z(this, p)
});
$c_scm_StringBuilder.prototype.companion__scg_GenericCompanion = (function() {
  return $m_scm_IndexedSeq$()
});
$c_scm_StringBuilder.prototype.toString__T = (function() {
  return this.underlying$5.java$lang$StringBuilder$$content$f
});
$c_scm_StringBuilder.prototype.compareTo__O__I = (function(that) {
  var other = $as_T(that);
  var thiz = this.underlying$5.java$lang$StringBuilder$$content$f;
  return ((thiz === other) ? 0 : ($uZ((thiz < other)) ? (-1) : 1))
});
$c_scm_StringBuilder.prototype.foreach__F1__V = (function(f) {
  $f_sc_IndexedSeqOptimized__foreach__F1__V(this, f)
});
$c_scm_StringBuilder.prototype.foldLeft__O__F2__O = (function(z, op) {
  var start = 0;
  var end = this.underlying$5.length__I();
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_StringBuilder.prototype.compare__O__I = (function(that) {
  var other = $as_T(that);
  var thiz = this.underlying$5.java$lang$StringBuilder$$content$f;
  return ((thiz === other) ? 0 : ($uZ((thiz < other)) ? (-1) : 1))
});
$c_scm_StringBuilder.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_IndexedSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_scm_StringBuilder.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__takeWhile__F1__O(this, p)
});
$c_scm_StringBuilder.prototype.slice__I__I__O = (function(from, until) {
  return $f_sci_StringLike__slice__I__I__O(this, from, until)
});
$c_scm_StringBuilder.prototype.reverse__O = (function() {
  return this.reverse__scm_StringBuilder()
});
$c_scm_StringBuilder.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_IndexedSeqLike__toBuffer__scm_Buffer(this)
});
$c_scm_StringBuilder.prototype.result__O = (function() {
  return this.underlying$5.java$lang$StringBuilder$$content$f
});
$c_scm_StringBuilder.prototype.append__T__scm_StringBuilder = (function(s) {
  var this$1 = this.underlying$5;
  this$1.java$lang$StringBuilder$$content$f = (("" + this$1.java$lang$StringBuilder$$content$f) + s);
  return this
});
$c_scm_StringBuilder.prototype.iterator__sc_Iterator = (function() {
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, this.underlying$5.length__I())
});
$c_scm_StringBuilder.prototype.seq__scm_Seq = (function() {
  return this
});
$c_scm_StringBuilder.prototype.sizeHintBounded__I__sc_TraversableLike__V = (function(size, boundingColl) {
  $f_scm_Builder__sizeHintBounded__I__sc_TraversableLike__V(this, size, boundingColl)
});
$c_scm_StringBuilder.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_IndexedSeqOptimized__find__F1__s_Option(this, p)
});
$c_scm_StringBuilder.prototype.span__F1__T2 = (function(p) {
  return $f_sc_IndexedSeqOptimized__span__F1__T2(this, p)
});
$c_scm_StringBuilder.prototype.init___I = (function(capacity) {
  $c_scm_StringBuilder.prototype.init___I__T.call(this, capacity, "");
  return this
});
$c_scm_StringBuilder.prototype.init___I__T = (function(initCapacity, initValue) {
  var this$2 = new $c_jl_StringBuilder().init___I((($uI(initValue.length) + initCapacity) | 0));
  this$2.java$lang$StringBuilder$$content$f = (("" + this$2.java$lang$StringBuilder$$content$f) + initValue);
  $c_scm_StringBuilder.prototype.init___jl_StringBuilder.call(this, this$2);
  return this
});
$c_scm_StringBuilder.prototype.mkString__T = (function() {
  return this.underlying$5.java$lang$StringBuilder$$content$f
});
$c_scm_StringBuilder.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IndexedSeqOptimized__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_scm_StringBuilder.prototype.length__I = (function() {
  return this.underlying$5.length__I()
});
$c_scm_StringBuilder.prototype.scala$collection$IndexedSeqOptimized$$super$tail__O = (function() {
  return $f_sc_TraversableLike__tail__O(this)
});
$c_scm_StringBuilder.prototype.scala$collection$IndexedSeqOptimized$$super$last__O = (function() {
  return $f_sc_TraversableLike__last__O(this)
});
$c_scm_StringBuilder.prototype.seq__sc_Seq = (function() {
  return this
});
$c_scm_StringBuilder.prototype.sizeHintIfCheap__I = (function() {
  return this.underlying$5.length__I()
});
$c_scm_StringBuilder.prototype.splitAt__I__T2 = (function(n) {
  return $f_sc_IndexedSeqOptimized__splitAt__I__T2(this, n)
});
$c_scm_StringBuilder.prototype.take__I__O = (function(n) {
  return $f_sci_StringLike__slice__I__I__O(this, 0, n)
});
$c_scm_StringBuilder.prototype.last__O = (function() {
  return $f_sc_IndexedSeqOptimized__last__O(this)
});
$c_scm_StringBuilder.prototype.view__sc_SeqView = (function() {
  return new $c_scm_IndexedSeqLike$$anon$1().init___scm_IndexedSeqLike(this)
});
$c_scm_StringBuilder.prototype.drop__I__O = (function(n) {
  var until = this.underlying$5.length__I();
  return $f_sci_StringLike__slice__I__I__O(this, n, until)
});
$c_scm_StringBuilder.prototype.tail__O = (function() {
  return $f_sc_IndexedSeqOptimized__tail__O(this)
});
$c_scm_StringBuilder.prototype.thisCollection__sc_Seq = (function() {
  return this
});
$c_scm_StringBuilder.prototype.init___jl_StringBuilder = (function(underlying) {
  this.underlying$5 = underlying;
  return this
});
$c_scm_StringBuilder.prototype.append__O__scm_StringBuilder = (function(x) {
  var this$2 = this.underlying$5;
  var str = ("" + x);
  this$2.java$lang$StringBuilder$$content$f = (this$2.java$lang$StringBuilder$$content$f + str);
  return this
});
$c_scm_StringBuilder.prototype.isDefinedAt__O__Z = (function(x) {
  var idx = $uI(x);
  return $f_sc_GenSeqLike__isDefinedAt__I__Z(this, idx)
});
$c_scm_StringBuilder.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  if ((elem === null)) {
    var jsx$1 = 0
  } else {
    var this$2 = $as_jl_Character(elem);
    var jsx$1 = this$2.value$1
  };
  return this.$$plus$eq__C__scm_StringBuilder(jsx$1)
});
$c_scm_StringBuilder.prototype.sizeHint__I__V = (function(size) {
  /*<skip>*/
});
$c_scm_StringBuilder.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_sc_IndexedSeqOptimized__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_scm_StringBuilder.prototype.toSeq__sc_GenSeq = (function() {
  return this
});
$c_scm_StringBuilder.prototype.hashCode__I = (function() {
  return $m_s_util_hashing_MurmurHash3$().seqHash__sc_Seq__I(this)
});
$c_scm_StringBuilder.prototype.scala$collection$IndexedSeqOptimized$$super$zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_IterableLike__zip__sc_GenIterable__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_StringBuilder.prototype.toArray__s_reflect_ClassTag__O = (function(evidence$1) {
  return $m_sjsr_RuntimeString$().toCharArray__T__AC(this.underlying$5.java$lang$StringBuilder$$content$f)
});
$c_scm_StringBuilder.prototype.reverse__scm_StringBuilder = (function() {
  return new $c_scm_StringBuilder().init___jl_StringBuilder(new $c_jl_StringBuilder().init___jl_CharSequence(this.underlying$5).reverse__jl_StringBuilder())
});
$c_scm_StringBuilder.prototype.append__C__scm_StringBuilder = (function(x) {
  this.underlying$5.append__C__jl_StringBuilder(x);
  return this
});
$c_scm_StringBuilder.prototype.charAt__I__C = (function(index) {
  return this.underlying$5.charAt__I__C(index)
});
$c_scm_StringBuilder.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_IndexedSeqOptimized__reduceLeft__F2__O(this, op)
});
$c_scm_StringBuilder.prototype.newBuilder__scm_Builder = (function() {
  return new $c_scm_GrowingBuilder().init___scg_Growable(new $c_scm_StringBuilder().init___())
});
$c_scm_StringBuilder.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return $f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs)
});
var $d_scm_StringBuilder = new $TypeData().initClass({
  scm_StringBuilder: 0
}, false, "scala.collection.mutable.StringBuilder", {
  scm_StringBuilder: 1,
  scm_AbstractSeq: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  jl_CharSequence: 1,
  scm_IndexedSeq: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  scm_IndexedSeqLike: 1,
  sci_StringLike: 1,
  sc_IndexedSeqOptimized: 1,
  s_math_Ordered: 1,
  jl_Comparable: 1,
  scm_ReusableBuilder: 1,
  scm_Builder: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_StringBuilder.prototype.$classData = $d_scm_StringBuilder;
/** @constructor */
function $c_sjs_js_WrappedArray() {
  $c_scm_AbstractBuffer.call(this);
  this.array$6 = null
}
$c_sjs_js_WrappedArray.prototype = new $h_scm_AbstractBuffer();
$c_sjs_js_WrappedArray.prototype.constructor = $c_sjs_js_WrappedArray;
/** @constructor */
function $h_sjs_js_WrappedArray() {
  /*<skip>*/
}
$h_sjs_js_WrappedArray.prototype = $c_sjs_js_WrappedArray.prototype;
$c_sjs_js_WrappedArray.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_sjs_js_WrappedArray.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_sjs_js_WrappedArray.prototype.head__O = (function() {
  return $f_sc_IndexedSeqOptimized__head__O(this)
});
$c_sjs_js_WrappedArray.prototype.init___ = (function() {
  $c_sjs_js_WrappedArray.prototype.init___sjs_js_Array.call(this, []);
  return this
});
$c_sjs_js_WrappedArray.prototype.apply__I__O = (function(index) {
  return this.array$6[index]
});
$c_sjs_js_WrappedArray.prototype.thisCollection__sc_Iterable = (function() {
  return this
});
$c_sjs_js_WrappedArray.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_IndexedSeqOptimized__lengthCompare__I__I(this, len)
});
$c_sjs_js_WrappedArray.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IndexedSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_sjs_js_WrappedArray.prototype.apply__O__O = (function(v1) {
  var index = $uI(v1);
  return this.array$6[index]
});
$c_sjs_js_WrappedArray.prototype.exists__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__exists__F1__Z(this, p)
});
$c_sjs_js_WrappedArray.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return $f_scm_BufferLike__clone__scm_Buffer(this).$$minus$eq__O__scm_Buffer(elem)
});
$c_sjs_js_WrappedArray.prototype.toList__sci_List = (function() {
  return $f_sc_IndexedSeqOptimized__toList__sci_List(this)
});
$c_sjs_js_WrappedArray.prototype.isEmpty__Z = (function() {
  return $f_sc_IndexedSeqOptimized__isEmpty__Z(this)
});
$c_sjs_js_WrappedArray.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_sjs_js_WrappedArray.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_sjs_js_WrappedArray.prototype.scala$collection$IndexedSeqOptimized$$super$init__O = (function() {
  return $f_sc_TraversableLike__init__O(this)
});
$c_sjs_js_WrappedArray.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__dropWhile__F1__O(this, p)
});
$c_sjs_js_WrappedArray.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  this.array$6.push(elem);
  return this
});
$c_sjs_js_WrappedArray.prototype.forall__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__forall__F1__Z(this, p)
});
$c_sjs_js_WrappedArray.prototype.companion__scg_GenericCompanion = (function() {
  return $m_sjs_js_WrappedArray$()
});
$c_sjs_js_WrappedArray.prototype.foreach__F1__V = (function(f) {
  $f_sc_IndexedSeqOptimized__foreach__F1__V(this, f)
});
$c_sjs_js_WrappedArray.prototype.foldLeft__O__F2__O = (function(z, op) {
  var start = 0;
  var end = $uI(this.array$6.length);
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_sjs_js_WrappedArray.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_IndexedSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_sjs_js_WrappedArray.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__takeWhile__F1__O(this, p)
});
$c_sjs_js_WrappedArray.prototype.slice__I__I__O = (function(from, until) {
  return $f_sc_IndexedSeqOptimized__slice__I__I__O(this, from, until)
});
$c_sjs_js_WrappedArray.prototype.reverse__O = (function() {
  return $f_sc_IndexedSeqOptimized__reverse__O(this)
});
$c_sjs_js_WrappedArray.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_IndexedSeqLike__toBuffer__scm_Buffer(this)
});
$c_sjs_js_WrappedArray.prototype.result__O = (function() {
  return this
});
$c_sjs_js_WrappedArray.prototype.iterator__sc_Iterator = (function() {
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, $uI(this.array$6.length))
});
$c_sjs_js_WrappedArray.prototype.seq__scm_Seq = (function() {
  return this
});
$c_sjs_js_WrappedArray.prototype.sizeHintBounded__I__sc_TraversableLike__V = (function(size, boundingColl) {
  $f_scm_Builder__sizeHintBounded__I__sc_TraversableLike__V(this, size, boundingColl)
});
$c_sjs_js_WrappedArray.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_IndexedSeqOptimized__find__F1__s_Option(this, p)
});
$c_sjs_js_WrappedArray.prototype.span__F1__T2 = (function(p) {
  return $f_sc_IndexedSeqOptimized__span__F1__T2(this, p)
});
$c_sjs_js_WrappedArray.prototype.length__I = (function() {
  return $uI(this.array$6.length)
});
$c_sjs_js_WrappedArray.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IndexedSeqOptimized__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_sjs_js_WrappedArray.prototype.scala$collection$IndexedSeqOptimized$$super$last__O = (function() {
  return $f_sc_TraversableLike__last__O(this)
});
$c_sjs_js_WrappedArray.prototype.scala$collection$IndexedSeqOptimized$$super$tail__O = (function() {
  return $f_sc_TraversableLike__tail__O(this)
});
$c_sjs_js_WrappedArray.prototype.seq__sc_Seq = (function() {
  return this
});
$c_sjs_js_WrappedArray.prototype.sizeHintIfCheap__I = (function() {
  return $uI(this.array$6.length)
});
$c_sjs_js_WrappedArray.prototype.remove__I__O = (function(n) {
  if (((n < 0) || (n >= $uI(this.array$6.length)))) {
    throw new $c_jl_IndexOutOfBoundsException().init___()
  };
  return this.array$6.splice(n, 1)[0]
});
$c_sjs_js_WrappedArray.prototype.splitAt__I__T2 = (function(n) {
  return $f_sc_IndexedSeqOptimized__splitAt__I__T2(this, n)
});
$c_sjs_js_WrappedArray.prototype.take__I__O = (function(n) {
  return $f_sc_IndexedSeqOptimized__slice__I__I__O(this, 0, n)
});
$c_sjs_js_WrappedArray.prototype.last__O = (function() {
  return $f_sc_IndexedSeqOptimized__last__O(this)
});
$c_sjs_js_WrappedArray.prototype.view__sc_SeqView = (function() {
  return new $c_scm_IndexedSeqLike$$anon$1().init___scm_IndexedSeqLike(this)
});
$c_sjs_js_WrappedArray.prototype.drop__I__O = (function(n) {
  var until = $uI(this.array$6.length);
  return $f_sc_IndexedSeqOptimized__slice__I__I__O(this, n, until)
});
$c_sjs_js_WrappedArray.prototype.tail__O = (function() {
  return $f_sc_IndexedSeqOptimized__tail__O(this)
});
$c_sjs_js_WrappedArray.prototype.thisCollection__sc_Seq = (function() {
  return this
});
$c_sjs_js_WrappedArray.prototype.isDefinedAt__O__Z = (function(x) {
  var idx = $uI(x);
  return $f_sc_GenSeqLike__isDefinedAt__I__Z(this, idx)
});
$c_sjs_js_WrappedArray.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  this.array$6.push(elem);
  return this
});
$c_sjs_js_WrappedArray.prototype.sizeHint__I__V = (function(size) {
  /*<skip>*/
});
$c_sjs_js_WrappedArray.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_sc_IndexedSeqOptimized__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_sjs_js_WrappedArray.prototype.toSeq__sc_GenSeq = (function() {
  return this
});
$c_sjs_js_WrappedArray.prototype.hashCode__I = (function() {
  return $m_s_util_hashing_MurmurHash3$().seqHash__sc_Seq__I(this)
});
$c_sjs_js_WrappedArray.prototype.scala$collection$IndexedSeqOptimized$$super$zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_IterableLike__zip__sc_GenIterable__scg_CanBuildFrom__O(this, that, bf)
});
$c_sjs_js_WrappedArray.prototype.$$minus$eq__O__scg_Shrinkable = (function(elem) {
  return $f_scm_BufferLike__$$minus$eq__O__scm_Buffer(this, elem)
});
$c_sjs_js_WrappedArray.prototype.init___sjs_js_Array = (function(array) {
  this.array$6 = array;
  return this
});
$c_sjs_js_WrappedArray.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_IndexedSeqOptimized__reduceLeft__F2__O(this, op)
});
$c_sjs_js_WrappedArray.prototype.stringPrefix__T = (function() {
  return "WrappedArray"
});
function $as_sjs_js_WrappedArray(obj) {
  return (((obj instanceof $c_sjs_js_WrappedArray) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.scalajs.js.WrappedArray"))
}
function $isArrayOf_sjs_js_WrappedArray(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.sjs_js_WrappedArray)))
}
function $asArrayOf_sjs_js_WrappedArray(obj, depth) {
  return (($isArrayOf_sjs_js_WrappedArray(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.scalajs.js.WrappedArray;", depth))
}
var $d_sjs_js_WrappedArray = new $TypeData().initClass({
  sjs_js_WrappedArray: 0
}, false, "scala.scalajs.js.WrappedArray", {
  sjs_js_WrappedArray: 1,
  scm_AbstractBuffer: 1,
  scm_AbstractSeq: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_Buffer: 1,
  scm_BufferLike: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  scg_Shrinkable: 1,
  sc_script_Scriptable: 1,
  scg_Subtractable: 1,
  scm_IndexedSeq: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  scm_IndexedSeqLike: 1,
  scm_ArrayLike: 1,
  scm_IndexedSeqOptimized: 1,
  sc_IndexedSeqOptimized: 1,
  scm_Builder: 1
});
$c_sjs_js_WrappedArray.prototype.$classData = $d_sjs_js_WrappedArray;
/** @constructor */
function $c_scm_IndexedSeqView$$anon$5() {
  $c_scm_IndexedSeqView$AbstractTransformed.call(this);
  this.$$outer$3 = null
}
$c_scm_IndexedSeqView$$anon$5.prototype = new $h_scm_IndexedSeqView$AbstractTransformed();
$c_scm_IndexedSeqView$$anon$5.prototype.constructor = $c_scm_IndexedSeqView$$anon$5;
/** @constructor */
function $h_scm_IndexedSeqView$$anon$5() {
  /*<skip>*/
}
$h_scm_IndexedSeqView$$anon$5.prototype = $c_scm_IndexedSeqView$$anon$5.prototype;
$c_scm_IndexedSeqView$$anon$5.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$Reversed__apply__I__O(this, idx)
});
$c_scm_IndexedSeqView$$anon$5.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$Reversed__apply__I__O(this, idx)
});
$c_scm_IndexedSeqView$$anon$5.prototype.scala$collection$SeqViewLike$Reversed$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$3
});
$c_scm_IndexedSeqView$$anon$5.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_SeqViewLike$Reversed__createReversedIterator__psc_SeqViewLike$Reversed__sc_Iterator(this)
});
$c_scm_IndexedSeqView$$anon$5.prototype.viewIdentifier__T = (function() {
  return "R"
});
$c_scm_IndexedSeqView$$anon$5.prototype.length__I = (function() {
  return this.$$outer$3.length__I()
});
$c_scm_IndexedSeqView$$anon$5.prototype.init___scm_IndexedSeqView = (function($$outer) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$3 = $$outer
  };
  $c_scm_IndexedSeqView$AbstractTransformed.prototype.init___scm_IndexedSeqView.call(this, $$outer);
  return this
});
var $d_scm_IndexedSeqView$$anon$5 = new $TypeData().initClass({
  scm_IndexedSeqView$$anon$5: 0
}, false, "scala.collection.mutable.IndexedSeqView$$anon$5", {
  scm_IndexedSeqView$$anon$5: 1,
  scm_IndexedSeqView$AbstractTransformed: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  scm_IndexedSeqView$Transformed: 1,
  scm_IndexedSeqView: 1,
  scm_IndexedSeq: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  scm_IndexedSeqLike: 1,
  scm_IndexedSeqOptimized: 1,
  sc_IndexedSeqOptimized: 1,
  scm_IndexedSeqView$Reversed: 1,
  sc_SeqViewLike$Reversed: 1
});
$c_scm_IndexedSeqView$$anon$5.prototype.$classData = $d_scm_IndexedSeqView$$anon$5;
/** @constructor */
function $c_scm_ArrayBuffer() {
  $c_scm_AbstractBuffer.call(this);
  this.initialSize$6 = 0;
  this.array$6 = null;
  this.size0$6 = 0
}
$c_scm_ArrayBuffer.prototype = new $h_scm_AbstractBuffer();
$c_scm_ArrayBuffer.prototype.constructor = $c_scm_ArrayBuffer;
/** @constructor */
function $h_scm_ArrayBuffer() {
  /*<skip>*/
}
$h_scm_ArrayBuffer.prototype = $c_scm_ArrayBuffer.prototype;
$c_scm_ArrayBuffer.prototype.seq__sc_TraversableOnce = (function() {
  return this
});
$c_scm_ArrayBuffer.prototype.repr__scg_Subtractable = (function() {
  return this
});
$c_scm_ArrayBuffer.prototype.$$plus$eq__O__scm_ArrayBuffer = (function(elem) {
  var n = ((1 + this.size0$6) | 0);
  $f_scm_ResizableArray__ensureSize__I__V(this, n);
  this.array$6.set(this.size0$6, elem);
  this.size0$6 = ((1 + this.size0$6) | 0);
  return this
});
$c_scm_ArrayBuffer.prototype.head__O = (function() {
  return $f_sc_IndexedSeqOptimized__head__O(this)
});
$c_scm_ArrayBuffer.prototype.init___ = (function() {
  $c_scm_ArrayBuffer.prototype.init___I.call(this, 16);
  return this
});
$c_scm_ArrayBuffer.prototype.apply__I__O = (function(idx) {
  return $f_scm_ResizableArray__apply__I__O(this, idx)
});
$c_scm_ArrayBuffer.prototype.remove__I__I__V = (function(n, count) {
  if ((count < 0)) {
    throw new $c_jl_IllegalArgumentException().init___T((("removing negative number of elements: " + "") + count))
  } else if ((count === 0)) {
    return (void 0)
  };
  if (((n < 0) || (n > ((this.size0$6 - count) | 0)))) {
    throw new $c_jl_IndexOutOfBoundsException().init___T(((((("at " + "") + n) + " deleting ") + "") + count))
  };
  var m = ((n + count) | 0);
  var len = ((this.size0$6 - ((n + count) | 0)) | 0);
  var src = this.array$6;
  var dest = this.array$6;
  $systemArraycopy(src, m, dest, n, len);
  var sz = ((this.size0$6 - count) | 0);
  $f_scm_ResizableArray__reduceToSize__I__V(this, sz)
});
$c_scm_ArrayBuffer.prototype.thisCollection__sc_Iterable = (function() {
  return this
});
$c_scm_ArrayBuffer.prototype.lengthCompare__I__I = (function(len) {
  return $f_sc_IndexedSeqOptimized__lengthCompare__I__I(this, len)
});
$c_scm_ArrayBuffer.prototype.sameElements__sc_GenIterable__Z = (function(that) {
  return $f_sc_IndexedSeqOptimized__sameElements__sc_GenIterable__Z(this, that)
});
$c_scm_ArrayBuffer.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_scm_ResizableArray__apply__I__O(this, idx)
});
$c_scm_ArrayBuffer.prototype.exists__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__exists__F1__Z(this, p)
});
$c_scm_ArrayBuffer.prototype.$$minus__O__scg_Subtractable = (function(elem) {
  return $f_scm_BufferLike__clone__scm_Buffer(this).$$minus$eq__O__scm_Buffer(elem)
});
$c_scm_ArrayBuffer.prototype.toList__sci_List = (function() {
  return $f_sc_IndexedSeqOptimized__toList__sci_List(this)
});
$c_scm_ArrayBuffer.prototype.isEmpty__Z = (function() {
  return $f_sc_IndexedSeqOptimized__isEmpty__Z(this)
});
$c_scm_ArrayBuffer.prototype.seq__sc_Iterable = (function() {
  return this
});
$c_scm_ArrayBuffer.prototype.thisCollection__sc_Traversable = (function() {
  return this
});
$c_scm_ArrayBuffer.prototype.scala$collection$IndexedSeqOptimized$$super$init__O = (function() {
  return $f_sc_TraversableLike__init__O(this)
});
$c_scm_ArrayBuffer.prototype.dropWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__dropWhile__F1__O(this, p)
});
$c_scm_ArrayBuffer.prototype.$$plus$eq__O__scg_Growable = (function(elem) {
  return this.$$plus$eq__O__scm_ArrayBuffer(elem)
});
$c_scm_ArrayBuffer.prototype.forall__F1__Z = (function(p) {
  return $f_sc_IndexedSeqOptimized__forall__F1__Z(this, p)
});
$c_scm_ArrayBuffer.prototype.companion__scg_GenericCompanion = (function() {
  return $m_scm_ArrayBuffer$()
});
$c_scm_ArrayBuffer.prototype.foreach__F1__V = (function(f) {
  $f_scm_ResizableArray__foreach__F1__V(this, f)
});
$c_scm_ArrayBuffer.prototype.foldLeft__O__F2__O = (function(z, op) {
  var start = 0;
  var end = this.size0$6;
  var z$1 = z;
  return $f_sc_IndexedSeqOptimized__foldl__psc_IndexedSeqOptimized__I__I__O__F2__O(this, start, end, z$1, op)
});
$c_scm_ArrayBuffer.prototype.indexWhere__F1__I__I = (function(p, from) {
  return $f_sc_IndexedSeqOptimized__indexWhere__F1__I__I(this, p, from)
});
$c_scm_ArrayBuffer.prototype.takeWhile__F1__O = (function(p) {
  return $f_sc_IndexedSeqOptimized__takeWhile__F1__O(this, p)
});
$c_scm_ArrayBuffer.prototype.slice__I__I__O = (function(from, until) {
  return $f_sc_IndexedSeqOptimized__slice__I__I__O(this, from, until)
});
$c_scm_ArrayBuffer.prototype.reverse__O = (function() {
  return $f_sc_IndexedSeqOptimized__reverse__O(this)
});
$c_scm_ArrayBuffer.prototype.toBuffer__scm_Buffer = (function() {
  return $f_sc_IndexedSeqLike__toBuffer__scm_Buffer(this)
});
$c_scm_ArrayBuffer.prototype.result__O = (function() {
  return this
});
$c_scm_ArrayBuffer.prototype.iterator__sc_Iterator = (function() {
  return new $c_sc_IndexedSeqLike$Elements().init___sc_IndexedSeqLike__I__I(this, 0, this.size0$6)
});
$c_scm_ArrayBuffer.prototype.seq__scm_Seq = (function() {
  return this
});
$c_scm_ArrayBuffer.prototype.sizeHintBounded__I__sc_TraversableLike__V = (function(size, boundingColl) {
  $f_scm_Builder__sizeHintBounded__I__sc_TraversableLike__V(this, size, boundingColl)
});
$c_scm_ArrayBuffer.prototype.find__F1__s_Option = (function(p) {
  return $f_sc_IndexedSeqOptimized__find__F1__s_Option(this, p)
});
$c_scm_ArrayBuffer.prototype.span__F1__T2 = (function(p) {
  return $f_sc_IndexedSeqOptimized__span__F1__T2(this, p)
});
$c_scm_ArrayBuffer.prototype.init___I = (function(initialSize) {
  this.initialSize$6 = initialSize;
  $f_scm_ResizableArray__$$init$__V(this);
  return this
});
$c_scm_ArrayBuffer.prototype.zipWithIndex__scg_CanBuildFrom__O = (function(bf) {
  return $f_sc_IndexedSeqOptimized__zipWithIndex__scg_CanBuildFrom__O(this, bf)
});
$c_scm_ArrayBuffer.prototype.length__I = (function() {
  return this.size0$6
});
$c_scm_ArrayBuffer.prototype.scala$collection$IndexedSeqOptimized$$super$tail__O = (function() {
  return $f_sc_TraversableLike__tail__O(this)
});
$c_scm_ArrayBuffer.prototype.scala$collection$IndexedSeqOptimized$$super$last__O = (function() {
  return $f_sc_TraversableLike__last__O(this)
});
$c_scm_ArrayBuffer.prototype.seq__sc_Seq = (function() {
  return this
});
$c_scm_ArrayBuffer.prototype.sizeHintIfCheap__I = (function() {
  return this.size0$6
});
$c_scm_ArrayBuffer.prototype.remove__I__O = (function(n) {
  var result = $f_scm_ResizableArray__apply__I__O(this, n);
  this.remove__I__I__V(n, 1);
  return result
});
$c_scm_ArrayBuffer.prototype.splitAt__I__T2 = (function(n) {
  return $f_sc_IndexedSeqOptimized__splitAt__I__T2(this, n)
});
$c_scm_ArrayBuffer.prototype.take__I__O = (function(n) {
  return $f_sc_IndexedSeqOptimized__slice__I__I__O(this, 0, n)
});
$c_scm_ArrayBuffer.prototype.last__O = (function() {
  return $f_sc_IndexedSeqOptimized__last__O(this)
});
$c_scm_ArrayBuffer.prototype.view__sc_SeqView = (function() {
  return new $c_scm_IndexedSeqLike$$anon$1().init___scm_IndexedSeqLike(this)
});
$c_scm_ArrayBuffer.prototype.drop__I__O = (function(n) {
  var until = this.size0$6;
  return $f_sc_IndexedSeqOptimized__slice__I__I__O(this, n, until)
});
$c_scm_ArrayBuffer.prototype.tail__O = (function() {
  return $f_sc_IndexedSeqOptimized__tail__O(this)
});
$c_scm_ArrayBuffer.prototype.thisCollection__sc_Seq = (function() {
  return this
});
$c_scm_ArrayBuffer.prototype.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuffer = (function(xs) {
  if ($is_sc_IndexedSeqLike(xs)) {
    var x2 = $as_sc_IndexedSeqLike(xs);
    var n = x2.length__I();
    var n$1 = ((this.size0$6 + n) | 0);
    $f_scm_ResizableArray__ensureSize__I__V(this, n$1);
    x2.copyToArray__O__I__I__V(this.array$6, this.size0$6, n);
    this.size0$6 = ((this.size0$6 + n) | 0);
    return this
  } else {
    return $as_scm_ArrayBuffer($f_scg_Growable__$$plus$plus$eq__sc_TraversableOnce__scg_Growable(this, xs))
  }
});
$c_scm_ArrayBuffer.prototype.isDefinedAt__O__Z = (function(x) {
  var idx = $uI(x);
  return $f_sc_GenSeqLike__isDefinedAt__I__Z(this, idx)
});
$c_scm_ArrayBuffer.prototype.$$plus$eq__O__scm_Builder = (function(elem) {
  return this.$$plus$eq__O__scm_ArrayBuffer(elem)
});
$c_scm_ArrayBuffer.prototype.sizeHint__I__V = (function(len) {
  if (((len > this.size0$6) && (len >= 1))) {
    var newarray = $newArrayObject($d_O.getArrayOf(), [len]);
    $systemArraycopy(this.array$6, 0, newarray, 0, this.size0$6);
    this.array$6 = newarray
  }
});
$c_scm_ArrayBuffer.prototype.copyToArray__O__I__I__V = (function(xs, start, len) {
  $f_scm_ResizableArray__copyToArray__O__I__I__V(this, xs, start, len)
});
$c_scm_ArrayBuffer.prototype.toSeq__sc_GenSeq = (function() {
  return this
});
$c_scm_ArrayBuffer.prototype.hashCode__I = (function() {
  return $m_s_util_hashing_MurmurHash3$().seqHash__sc_Seq__I(this)
});
$c_scm_ArrayBuffer.prototype.scala$collection$IndexedSeqOptimized$$super$zip__sc_GenIterable__scg_CanBuildFrom__O = (function(that, bf) {
  return $f_sc_IterableLike__zip__sc_GenIterable__scg_CanBuildFrom__O(this, that, bf)
});
$c_scm_ArrayBuffer.prototype.$$minus$eq__O__scg_Shrinkable = (function(elem) {
  return $f_scm_BufferLike__$$minus$eq__O__scm_Buffer(this, elem)
});
$c_scm_ArrayBuffer.prototype.reduceLeft__F2__O = (function(op) {
  return $f_sc_IndexedSeqOptimized__reduceLeft__F2__O(this, op)
});
$c_scm_ArrayBuffer.prototype.$$plus$plus$eq__sc_TraversableOnce__scg_Growable = (function(xs) {
  return this.$$plus$plus$eq__sc_TraversableOnce__scm_ArrayBuffer(xs)
});
$c_scm_ArrayBuffer.prototype.stringPrefix__T = (function() {
  return "ArrayBuffer"
});
function $as_scm_ArrayBuffer(obj) {
  return (((obj instanceof $c_scm_ArrayBuffer) || (obj === null)) ? obj : $throwClassCastException(obj, "scala.collection.mutable.ArrayBuffer"))
}
function $isArrayOf_scm_ArrayBuffer(obj, depth) {
  return (!(!(((obj && obj.$classData) && (obj.$classData.arrayDepth === depth)) && obj.$classData.arrayBase.ancestors.scm_ArrayBuffer)))
}
function $asArrayOf_scm_ArrayBuffer(obj, depth) {
  return (($isArrayOf_scm_ArrayBuffer(obj, depth) || (obj === null)) ? obj : $throwArrayCastException(obj, "Lscala.collection.mutable.ArrayBuffer;", depth))
}
var $d_scm_ArrayBuffer = new $TypeData().initClass({
  scm_ArrayBuffer: 0
}, false, "scala.collection.mutable.ArrayBuffer", {
  scm_ArrayBuffer: 1,
  scm_AbstractBuffer: 1,
  scm_AbstractSeq: 1,
  sc_AbstractSeq: 1,
  sc_AbstractIterable: 1,
  sc_AbstractTraversable: 1,
  O: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_Iterable: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  scm_Buffer: 1,
  scm_BufferLike: 1,
  scg_Growable: 1,
  scg_Clearable: 1,
  scg_Shrinkable: 1,
  sc_script_Scriptable: 1,
  scg_Subtractable: 1,
  scm_IndexedSeqOptimized: 1,
  scm_IndexedSeqLike: 1,
  sc_IndexedSeqLike: 1,
  sc_IndexedSeqOptimized: 1,
  scm_Builder: 1,
  scm_ResizableArray: 1,
  scm_IndexedSeq: 1,
  sc_IndexedSeq: 1,
  sc_CustomParallelizable: 1,
  s_Serializable: 1,
  Ljava_io_Serializable: 1
});
$c_scm_ArrayBuffer.prototype.$classData = $d_scm_ArrayBuffer;
/** @constructor */
function $c_scm_IndexedSeqView$$anon$1() {
  $c_scm_IndexedSeqView$AbstractTransformed.call(this);
  this.pred$3 = null;
  this.index$3 = null;
  this.bitmap$0$3 = false;
  this.$$outer$3 = null
}
$c_scm_IndexedSeqView$$anon$1.prototype = new $h_scm_IndexedSeqView$AbstractTransformed();
$c_scm_IndexedSeqView$$anon$1.prototype.constructor = $c_scm_IndexedSeqView$$anon$1;
/** @constructor */
function $h_scm_IndexedSeqView$$anon$1() {
  /*<skip>*/
}
$h_scm_IndexedSeqView$$anon$1.prototype = $c_scm_IndexedSeqView$$anon$1.prototype;
$c_scm_IndexedSeqView$$anon$1.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$Filtered__apply__I__O(this, idx)
});
$c_scm_IndexedSeqView$$anon$1.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$Filtered__apply__I__O(this, idx)
});
$c_scm_IndexedSeqView$$anon$1.prototype.scala$collection$IterableViewLike$Filtered$$$outer__sc_IterableViewLike = (function() {
  return this.$$outer$3
});
$c_scm_IndexedSeqView$$anon$1.prototype.index$lzycompute__p3__AI = (function() {
  if ((!this.bitmap$0$3)) {
    this.index$3 = $f_sc_SeqViewLike$Filtered__index__AI(this);
    this.bitmap$0$3 = true
  };
  return this.index$3
});
$c_scm_IndexedSeqView$$anon$1.prototype.foreach__F1__V = (function(f) {
  $f_sc_TraversableViewLike$Filtered__foreach__F1__V(this, f)
});
$c_scm_IndexedSeqView$$anon$1.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_IterableViewLike$Filtered__iterator__sc_Iterator(this)
});
$c_scm_IndexedSeqView$$anon$1.prototype.viewIdentifier__T = (function() {
  return "F"
});
$c_scm_IndexedSeqView$$anon$1.prototype.length__I = (function() {
  return $f_sc_SeqViewLike$Filtered__length__I(this)
});
$c_scm_IndexedSeqView$$anon$1.prototype.init___scm_IndexedSeqView__F1 = (function($$outer, p$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$3 = $$outer
  };
  this.pred$3 = p$1;
  $c_scm_IndexedSeqView$AbstractTransformed.prototype.init___scm_IndexedSeqView.call(this, $$outer);
  return this
});
$c_scm_IndexedSeqView$$anon$1.prototype.index__AI = (function() {
  return ((!this.bitmap$0$3) ? this.index$lzycompute__p3__AI() : this.index$3)
});
$c_scm_IndexedSeqView$$anon$1.prototype.pred__F1 = (function() {
  return this.pred$3
});
$c_scm_IndexedSeqView$$anon$1.prototype.scala$collection$SeqViewLike$Filtered$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$3
});
$c_scm_IndexedSeqView$$anon$1.prototype.scala$collection$TraversableViewLike$Filtered$$$outer__sc_TraversableViewLike = (function() {
  return this.$$outer$3
});
var $d_scm_IndexedSeqView$$anon$1 = new $TypeData().initClass({
  scm_IndexedSeqView$$anon$1: 0
}, false, "scala.collection.mutable.IndexedSeqView$$anon$1", {
  scm_IndexedSeqView$$anon$1: 1,
  scm_IndexedSeqView$AbstractTransformed: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  scm_IndexedSeqView$Transformed: 1,
  scm_IndexedSeqView: 1,
  scm_IndexedSeq: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  scm_IndexedSeqLike: 1,
  scm_IndexedSeqOptimized: 1,
  sc_IndexedSeqOptimized: 1,
  scm_IndexedSeqView$Filtered: 1,
  sc_SeqViewLike$Filtered: 1,
  sc_IterableViewLike$Filtered: 1,
  sc_TraversableViewLike$Filtered: 1
});
$c_scm_IndexedSeqView$$anon$1.prototype.$classData = $d_scm_IndexedSeqView$$anon$1;
/** @constructor */
function $c_scm_IndexedSeqView$$anon$2() {
  $c_scm_IndexedSeqView$AbstractTransformed.call(this);
  this.endpoints$3 = null;
  this.$$outer$3 = null
}
$c_scm_IndexedSeqView$$anon$2.prototype = new $h_scm_IndexedSeqView$AbstractTransformed();
$c_scm_IndexedSeqView$$anon$2.prototype.constructor = $c_scm_IndexedSeqView$$anon$2;
/** @constructor */
function $h_scm_IndexedSeqView$$anon$2() {
  /*<skip>*/
}
$h_scm_IndexedSeqView$$anon$2.prototype = $c_scm_IndexedSeqView$$anon$2.prototype;
$c_scm_IndexedSeqView$$anon$2.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$Sliced__apply__I__O(this, idx)
});
$c_scm_IndexedSeqView$$anon$2.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$Sliced__apply__I__O(this, idx)
});
$c_scm_IndexedSeqView$$anon$2.prototype.scala$collection$SeqViewLike$Sliced$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$3
});
$c_scm_IndexedSeqView$$anon$2.prototype.foreach__F1__V = (function(f) {
  var this$1 = $f_sc_SeqViewLike$Sliced__iterator__sc_Iterator(this);
  $f_sc_Iterator__foreach__F1__V(this$1, f)
});
$c_scm_IndexedSeqView$$anon$2.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_SeqViewLike$Sliced__iterator__sc_Iterator(this)
});
$c_scm_IndexedSeqView$$anon$2.prototype.viewIdentifier__T = (function() {
  return "S"
});
$c_scm_IndexedSeqView$$anon$2.prototype.length__I = (function() {
  return this.endpoints$3.width__I()
});
$c_scm_IndexedSeqView$$anon$2.prototype.init___scm_IndexedSeqView__scg_SliceInterval = (function($$outer, _endpoints$1) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$3 = $$outer
  };
  this.endpoints$3 = _endpoints$1;
  $c_scm_IndexedSeqView$AbstractTransformed.prototype.init___scm_IndexedSeqView.call(this, $$outer);
  return this
});
$c_scm_IndexedSeqView$$anon$2.prototype.endpoints__scg_SliceInterval = (function() {
  return this.endpoints$3
});
var $d_scm_IndexedSeqView$$anon$2 = new $TypeData().initClass({
  scm_IndexedSeqView$$anon$2: 0
}, false, "scala.collection.mutable.IndexedSeqView$$anon$2", {
  scm_IndexedSeqView$$anon$2: 1,
  scm_IndexedSeqView$AbstractTransformed: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  scm_IndexedSeqView$Transformed: 1,
  scm_IndexedSeqView: 1,
  scm_IndexedSeq: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  scm_IndexedSeqLike: 1,
  scm_IndexedSeqOptimized: 1,
  sc_IndexedSeqOptimized: 1,
  scm_IndexedSeqView$Sliced: 1,
  sc_SeqViewLike$Sliced: 1,
  sc_IterableViewLike$Sliced: 1,
  sc_TraversableViewLike$Sliced: 1
});
$c_scm_IndexedSeqView$$anon$2.prototype.$classData = $d_scm_IndexedSeqView$$anon$2;
/** @constructor */
function $c_scm_IndexedSeqView$$anon$3() {
  $c_scm_IndexedSeqView$AbstractTransformed.call(this);
  this.pred$3 = null;
  this.start$3 = 0;
  this.bitmap$0$3 = false;
  this.$$outer$3 = null
}
$c_scm_IndexedSeqView$$anon$3.prototype = new $h_scm_IndexedSeqView$AbstractTransformed();
$c_scm_IndexedSeqView$$anon$3.prototype.constructor = $c_scm_IndexedSeqView$$anon$3;
/** @constructor */
function $h_scm_IndexedSeqView$$anon$3() {
  /*<skip>*/
}
$h_scm_IndexedSeqView$$anon$3.prototype = $c_scm_IndexedSeqView$$anon$3.prototype;
$c_scm_IndexedSeqView$$anon$3.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$DroppedWhile__apply__I__O(this, idx)
});
$c_scm_IndexedSeqView$$anon$3.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$DroppedWhile__apply__I__O(this, idx)
});
$c_scm_IndexedSeqView$$anon$3.prototype.scala$collection$SeqViewLike$DroppedWhile$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$3
});
$c_scm_IndexedSeqView$$anon$3.prototype.foreach__F1__V = (function(f) {
  $f_sc_TraversableViewLike$DroppedWhile__foreach__F1__V(this, f)
});
$c_scm_IndexedSeqView$$anon$3.prototype.scala$collection$IterableViewLike$DroppedWhile$$$outer__sc_IterableViewLike = (function() {
  return this.$$outer$3
});
$c_scm_IndexedSeqView$$anon$3.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_IterableViewLike$DroppedWhile__iterator__sc_Iterator(this)
});
$c_scm_IndexedSeqView$$anon$3.prototype.viewIdentifier__T = (function() {
  return "D"
});
$c_scm_IndexedSeqView$$anon$3.prototype.length__I = (function() {
  return $f_sc_SeqViewLike$DroppedWhile__length__I(this)
});
$c_scm_IndexedSeqView$$anon$3.prototype.init___scm_IndexedSeqView__F1 = (function($$outer, p$2) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$3 = $$outer
  };
  this.pred$3 = p$2;
  $c_scm_IndexedSeqView$AbstractTransformed.prototype.init___scm_IndexedSeqView.call(this, $$outer);
  return this
});
$c_scm_IndexedSeqView$$anon$3.prototype.scala$collection$TraversableViewLike$DroppedWhile$$$outer__sc_TraversableViewLike = (function() {
  return this.$$outer$3
});
$c_scm_IndexedSeqView$$anon$3.prototype.start__I = (function() {
  return ((!this.bitmap$0$3) ? this.start$lzycompute__p3__I() : this.start$3)
});
$c_scm_IndexedSeqView$$anon$3.prototype.pred__F1 = (function() {
  return this.pred$3
});
$c_scm_IndexedSeqView$$anon$3.prototype.start$lzycompute__p3__I = (function() {
  if ((!this.bitmap$0$3)) {
    var this$1 = this.$$outer$3;
    var p = this.pred$3;
    this.start$3 = $f_sc_IndexedSeqOptimized__segmentLength__F1__I__I(this$1, p, 0);
    this.bitmap$0$3 = true
  };
  return this.start$3
});
var $d_scm_IndexedSeqView$$anon$3 = new $TypeData().initClass({
  scm_IndexedSeqView$$anon$3: 0
}, false, "scala.collection.mutable.IndexedSeqView$$anon$3", {
  scm_IndexedSeqView$$anon$3: 1,
  scm_IndexedSeqView$AbstractTransformed: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  scm_IndexedSeqView$Transformed: 1,
  scm_IndexedSeqView: 1,
  scm_IndexedSeq: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  scm_IndexedSeqLike: 1,
  scm_IndexedSeqOptimized: 1,
  sc_IndexedSeqOptimized: 1,
  scm_IndexedSeqView$DroppedWhile: 1,
  sc_SeqViewLike$DroppedWhile: 1,
  sc_IterableViewLike$DroppedWhile: 1,
  sc_TraversableViewLike$DroppedWhile: 1
});
$c_scm_IndexedSeqView$$anon$3.prototype.$classData = $d_scm_IndexedSeqView$$anon$3;
/** @constructor */
function $c_scm_IndexedSeqView$$anon$4() {
  $c_scm_IndexedSeqView$AbstractTransformed.call(this);
  this.pred$3 = null;
  this.len$3 = 0;
  this.bitmap$0$3 = false;
  this.$$outer$3 = null
}
$c_scm_IndexedSeqView$$anon$4.prototype = new $h_scm_IndexedSeqView$AbstractTransformed();
$c_scm_IndexedSeqView$$anon$4.prototype.constructor = $c_scm_IndexedSeqView$$anon$4;
/** @constructor */
function $h_scm_IndexedSeqView$$anon$4() {
  /*<skip>*/
}
$h_scm_IndexedSeqView$$anon$4.prototype = $c_scm_IndexedSeqView$$anon$4.prototype;
$c_scm_IndexedSeqView$$anon$4.prototype.apply__I__O = (function(idx) {
  return $f_sc_SeqViewLike$TakenWhile__apply__I__O(this, idx)
});
$c_scm_IndexedSeqView$$anon$4.prototype.apply__O__O = (function(v1) {
  var idx = $uI(v1);
  return $f_sc_SeqViewLike$TakenWhile__apply__I__O(this, idx)
});
$c_scm_IndexedSeqView$$anon$4.prototype.scala$collection$IterableViewLike$TakenWhile$$$outer__sc_IterableViewLike = (function() {
  return this.$$outer$3
});
$c_scm_IndexedSeqView$$anon$4.prototype.len__I = (function() {
  return ((!this.bitmap$0$3) ? this.len$lzycompute__p3__I() : this.len$3)
});
$c_scm_IndexedSeqView$$anon$4.prototype.foreach__F1__V = (function(f) {
  $f_sc_TraversableViewLike$TakenWhile__foreach__F1__V(this, f)
});
$c_scm_IndexedSeqView$$anon$4.prototype.scala$collection$TraversableViewLike$TakenWhile$$$outer__sc_TraversableViewLike = (function() {
  return this.$$outer$3
});
$c_scm_IndexedSeqView$$anon$4.prototype.iterator__sc_Iterator = (function() {
  return $f_sc_IterableViewLike$TakenWhile__iterator__sc_Iterator(this)
});
$c_scm_IndexedSeqView$$anon$4.prototype.viewIdentifier__T = (function() {
  return "T"
});
$c_scm_IndexedSeqView$$anon$4.prototype.length__I = (function() {
  return this.len__I()
});
$c_scm_IndexedSeqView$$anon$4.prototype.init___scm_IndexedSeqView__F1 = (function($$outer, p$3) {
  if (($$outer === null)) {
    throw $m_sjsr_package$().unwrapJavaScriptException__jl_Throwable__O(null)
  } else {
    this.$$outer$3 = $$outer
  };
  this.pred$3 = p$3;
  $c_scm_IndexedSeqView$AbstractTransformed.prototype.init___scm_IndexedSeqView.call(this, $$outer);
  return this
});
$c_scm_IndexedSeqView$$anon$4.prototype.scala$collection$SeqViewLike$TakenWhile$$$outer__sc_SeqViewLike = (function() {
  return this.$$outer$3
});
$c_scm_IndexedSeqView$$anon$4.prototype.len$lzycompute__p3__I = (function() {
  if ((!this.bitmap$0$3)) {
    var this$1 = this.$$outer$3;
    var p = this.pred$3;
    this.len$3 = $f_sc_IndexedSeqOptimized__segmentLength__F1__I__I(this$1, p, 0);
    this.bitmap$0$3 = true
  };
  return this.len$3
});
$c_scm_IndexedSeqView$$anon$4.prototype.pred__F1 = (function() {
  return this.pred$3
});
var $d_scm_IndexedSeqView$$anon$4 = new $TypeData().initClass({
  scm_IndexedSeqView$$anon$4: 0
}, false, "scala.collection.mutable.IndexedSeqView$$anon$4", {
  scm_IndexedSeqView$$anon$4: 1,
  scm_IndexedSeqView$AbstractTransformed: 1,
  sc_SeqViewLike$AbstractTransformed: 1,
  O: 1,
  sc_Seq: 1,
  s_PartialFunction: 1,
  F1: 1,
  sc_Iterable: 1,
  sc_Traversable: 1,
  sc_TraversableLike: 1,
  scg_HasNewBuilder: 1,
  scg_FilterMonadic: 1,
  sc_TraversableOnce: 1,
  sc_GenTraversableOnce: 1,
  sc_GenTraversableLike: 1,
  sc_Parallelizable: 1,
  sc_GenTraversable: 1,
  scg_GenericTraversableTemplate: 1,
  sc_GenIterable: 1,
  sc_GenIterableLike: 1,
  sc_IterableLike: 1,
  s_Equals: 1,
  sc_GenSeq: 1,
  sc_GenSeqLike: 1,
  sc_SeqLike: 1,
  sc_IterableViewLike$Transformed: 1,
  sc_IterableView: 1,
  sc_IterableViewLike: 1,
  sc_TraversableView: 1,
  sc_TraversableViewLike: 1,
  sc_ViewMkString: 1,
  sc_TraversableViewLike$Transformed: 1,
  sc_SeqViewLike$Transformed: 1,
  sc_SeqView: 1,
  sc_SeqViewLike: 1,
  scm_IndexedSeqView$Transformed: 1,
  scm_IndexedSeqView: 1,
  scm_IndexedSeq: 1,
  scm_Seq: 1,
  scm_Iterable: 1,
  scm_Traversable: 1,
  s_Mutable: 1,
  scm_SeqLike: 1,
  scm_Cloneable: 1,
  s_Cloneable: 1,
  jl_Cloneable: 1,
  sc_IndexedSeq: 1,
  sc_IndexedSeqLike: 1,
  scm_IndexedSeqLike: 1,
  scm_IndexedSeqOptimized: 1,
  sc_IndexedSeqOptimized: 1,
  scm_IndexedSeqView$TakenWhile: 1,
  sc_SeqViewLike$TakenWhile: 1,
  sc_IterableViewLike$TakenWhile: 1,
  sc_TraversableViewLike$TakenWhile: 1
});
$c_scm_IndexedSeqView$$anon$4.prototype.$classData = $d_scm_IndexedSeqView$$anon$4;
/** @constructor */
function $c_Lamf_client_convert_WebApiClientConverters$() {
  $c_O.call(this);
  this.PropertyDependenciesMatcher$module$1 = null;
  this.UnionShapeMatcher$module$1 = null;
  this.ExampleMatcher$module$1 = null;
  this.XMLSerializerMatcher$module$1 = null;
  this.TupleShapeMatcher$module$1 = null;
  this.ArrayShapeMatcher$module$1 = null;
  this.AnyShapeMatcher$module$1 = null;
  this.FileShapeMatcher$module$1 = null;
  this.ScalarShapeMatcher$module$1 = null;
  this.NodeShapeMatcher$module$1 = null;
  this.SchemaShapeMatcher$module$1 = null;
  this.NilShapeMatcher$module$1 = null;
  this.ServerBindingMatcher$module$1 = null;
  this.MessageBindingMatcher$module$1 = null;
  this.OperationBindingMatcher$module$1 = null;
  this.ChannelBindingMatcher$module$1 = null;
  this.Amqp091QueueMatcher$module$1 = null;
  this.Amqp091ChannelExchangeMatcher$module$1 = null;
  this.MqttServerLastWillMatcher$module$1 = null;
  this.WebSocketsChannelBindingMatcher$module$1 = null;
  this.MqttServerBindingMatcher$module$1 = null;
  this.MqttOperationBindingMatcher$module$1 = null;
  this.MqttMessageBindingMatcher$module$1 = null;
  this.KafkaOperationBindingMatcher$module$1 = null;
  this.KafkaMessageBindingMatcher$module$1 = null;
  this.HttpOperationBindingMatcher$module$1 = null;
  this.HttpMessageBindingMatcher$module$1 = null;
  this.EmptyBindingMatcher$module$1 = null;
  this.DynamicBindingMatcher$module$1 = null;
  this.Amqp091OperationBindingMatcher$module$1 = null;
  this.Amqp091MessageBindingMatcher$module$1 = null;
  this.Amqp091ChannelBindingMatcher$module$1 = null;
  this.MessageBindingsMatcher$module$1 = null;
  this.ServerBindingsMatcher$module$1 = null;
  this.OperationBindingsMatcher$module$1 = null;
  this.ChannelBindingsMatcher$module$1 = null;
  this.CorrelationIdMatcher$module$1 = null;
  this.SecurityRequirementMatcher$module$1 = null;
  this.OAuth2FlowMatcher$module$1 = null;
  this.PayloadValidatorMatcher$module$1 = null;
  this.EncodingMatcher$module$1 = null;
  this.CallbackMatcher$module$1 = null;
  this.TemplatedLinkConverter$module$1 = null;
  this.IriTemplateMappingConverter$module$1 = null;
  this.ServerMatcher$module$1 = null;
  this.ScopeMatcher$module$1 = null;
  this.OAuth1SettingsMatcher$module$1 = null;
  this.OAuth2SettingsMatcher$module$1 = null;
  this.ApiKeySettingsMatcher$module$1 = null;
  this.HttpApiKeySettingsMatcher$module$1 = null;
  this.HttpSettingsMatcher$module$1 = null;
  this.OpenIdConnectSettingsMatcher$module$1 = null;
  this.SettingsMatcher$module$1 = null;
  this.SecuritySchemeMatcher$module$1 = null;
  this.ParametrizedSecuritySchemeMatcher$module$1 = null;
  this.PayloadMatcher$module$1 = null;
  this.ParameterMatcher$module$1 = null;
  this.TagMatcher$module$1 = null;
  this.OperationMatcher$module$1 = null;
  this.ResponseMatcher$module$1 = null;
  this.RequestMatcher$module$1 = null;
  this.MessageMatcher$module$1 = null;
  this.CreativeWorkMatcher$module$1 = null;
  this.LicenseMatcher$module$1 = null;
  this.OrganizationMatcher$module$1 = null;
  this.TraitMatcher$module$1 = null;
  this.ResourceTypeMatcher$module$1 = null;
  this.EndPointMatcher$module$1 = null;
  this.StringMatcher$module$1 = null;
  this.BooleanMatcher$module$1 = null;
  this.IntMatcher$module$1 = null;
  this.DoubleMatcher$module$1 = null;
  this.FloatMatcher$module$1 = null;
  this.AnyMatcher$module$1 = null;
  this.UnitMatcher$module$1 = null;
  this.ProfileNameMatcher$module$1 = null;
  this.VendorMatcher$module$1 = null;
  this.ContentMatcher$module$1 = null;
  this.ReferenceResolverMatcher$module$1 = null;
  this.CachedReferenceMatcher$module$1 = null;
  this.PayloadFragmentMatcher$module$1 = null;
  this.ValidationShapeSetMatcher$module$1 = null;
  this.ValidationCandidateMatcher$module$1 = null;
  this.GraphDomainConverter$module$1 = null;
  this.ResourceLoaderMatcher$module$1 = null;
  this.BaseUnitMatcher$module$1 = null;
  this.DomainElementMatcher$module$1 = null;
  this.ValidationReportMatcher$module$1 = null;
  this.ValidationResultMatcher$module$1 = null;
  this.VariableValueMatcher$module$1 = null;
  this.AbstractDeclarationMatcher$module$1 = null;
  this.ParameterizedDeclarationMatcher$module$1 = null;
  this.DomainExtensionMatcher$module$1 = null;
  this.ObjectNodeMatcher$module$1 = null;
  this.ScalarNodeMatcher$module$1 = null;
  this.ArrayNodeMatcher$module$1 = null;
  this.DataNodeMatcher$module$1 = null;
  this.ShapeExtensionMatcher$module$1 = null;
  this.PropertyShapeMatcher$module$1 = null;
  this.ShapeMatcher$module$1 = null;
  this.CustomDomainPropertyMatcher$module$1 = null;
  this.StrFieldMatcher$module$1 = null;
  this.IntFieldMatcher$module$1 = null;
  this.BoolFieldMatcher$module$1 = null;
  this.DoubleFieldMatcher$module$1 = null;
  this.FloatFieldMatcher$module$1 = null;
  this.AnyFieldMatcher$module$1 = null;
  this.AnnotationsFieldMatcher$module$1 = null;
  this.platform$1 = null
}
$c_Lamf_client_convert_WebApiClientConverters$.prototype = new $h_O();
$c_Lamf_client_convert_WebApiClientConverters$.prototype.constructor = $c_Lamf_client_convert_WebApiClientConverters$;
/** @constructor */
function $h_Lamf_client_convert_WebApiClientConverters$() {
  /*<skip>*/
}
$h_Lamf_client_convert_WebApiClientConverters$.prototype = $c_Lamf_client_convert_WebApiClientConverters$.prototype;
$c_Lamf_client_convert_WebApiClientConverters$.prototype.Amqp091QueueMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().Amqp091QueueMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().Amqp091QueueMatcher$module$1 = new $c_Lamf_client_convert_Amqp091QueueConverter$Amqp091QueueMatcher$().init___Lamf_client_convert_Amqp091QueueConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.DynamicBindingMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().DynamicBindingMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().DynamicBindingMatcher$module$1 = new $c_Lamf_client_convert_DynamicBindingConverter$DynamicBindingMatcher$().init___Lamf_client_convert_DynamicBindingConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.TupleShapeMatcher__Lamf_client_convert_TupleShapeConverter$TupleShapeMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().TupleShapeMatcher$module$1 === null)) {
    this.TupleShapeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().TupleShapeMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ResourceTypeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ResourceTypeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().ResourceTypeMatcher$module$1 = new $c_Lamf_client_convert_ResourceTypeConverter$ResourceTypeMatcher$().init___Lamf_client_convert_ResourceTypeConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ExampleMatcher__Lamf_client_convert_ExampleConverter$ExampleMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ExampleMatcher$module$1 === null)) {
    this.ExampleMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().ExampleMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ServerBindingMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ServerBindingMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().ServerBindingMatcher$module$1 = new $c_Lamf_client_convert_ServerBindingConverter$ServerBindingMatcher$().init___Lamf_client_convert_ServerBindingConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.BooleanMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().BooleanMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().BooleanMatcher$module$1 = new $c_Lamf_client_convert_CoreBaseConverter$BooleanMatcher$().init___Lamf_client_convert_CoreBaseConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.MessageBindingsMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().MessageBindingsMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().MessageBindingsMatcher$module$1 = new $c_Lamf_client_convert_MessageBindingsConverter$MessageBindingsMatcher$().init___Lamf_client_convert_MessageBindingsConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.PropertyDependenciesMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().PropertyDependenciesMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().PropertyDependenciesMatcher$module$1 = new $c_Lamf_client_convert_PropertyDependenciesConverter$PropertyDependenciesMatcher$().init___Lamf_client_convert_PropertyDependenciesConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.MqttServerBindingMatcher__Lamf_client_convert_MqttServerBindingConverter$MqttServerBindingMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().MqttServerBindingMatcher$module$1 === null)) {
    this.MqttServerBindingMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().MqttServerBindingMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.init___ = (function() {
  $n_Lamf_client_convert_WebApiClientConverters$ = this;
  var this$1 = $m_Lamf_core_unsafe_PlatformBuilder$();
  this.platform$1 = this$1.platform$1;
  return this
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.Amqp091OperationBindingMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().Amqp091OperationBindingMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().Amqp091OperationBindingMatcher$module$1 = new $c_Lamf_client_convert_Amqp091OperationBindingConverter$Amqp091OperationBindingMatcher$().init___Lamf_client_convert_Amqp091OperationBindingConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.AnyShapeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().AnyShapeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().AnyShapeMatcher$module$1 = new $c_Lamf_client_convert_AnyShapeConverter$AnyShapeMatcher$().init___Lamf_client_convert_AnyShapeConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ObjectNodeMatcher__Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ObjectNodeMatcher$module$1 === null)) {
    this.ObjectNodeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().ObjectNodeMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ScalarNodeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ScalarNodeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().ScalarNodeMatcher$module$1 = new $c_Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$().init___Lamf_client_convert_DataNodeConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ResponseMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ResponseMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().ResponseMatcher$module$1 = new $c_Lamf_client_convert_MessageConverter$ResponseMatcher$().init___Lamf_client_convert_MessageConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ScopeMatcher__Lamf_client_convert_ScopeConverter$ScopeMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ScopeMatcher$module$1 === null)) {
    this.ScopeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().ScopeMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ResponseMatcher__Lamf_client_convert_MessageConverter$ResponseMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ResponseMatcher$module$1 === null)) {
    this.ResponseMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().ResponseMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ChannelBindingMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ChannelBindingMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().ChannelBindingMatcher$module$1 = new $c_Lamf_client_convert_ChannelBindingConverter$ChannelBindingMatcher$().init___Lamf_client_convert_ChannelBindingConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.PayloadValidatorMatcher__Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().PayloadValidatorMatcher$module$1 === null)) {
    this.PayloadValidatorMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().PayloadValidatorMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.NodeShapeMatcher__Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().NodeShapeMatcher$module$1 === null)) {
    this.NodeShapeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().NodeShapeMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.HttpMessageBindingMatcher__Lamf_client_convert_HttpMessageBindingConverter$HttpMessageBindingMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().HttpMessageBindingMatcher$module$1 === null)) {
    this.HttpMessageBindingMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().HttpMessageBindingMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ChannelBindingsMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ChannelBindingsMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().ChannelBindingsMatcher$module$1 = new $c_Lamf_client_convert_ChannelBindingsConverter$ChannelBindingsMatcher$().init___Lamf_client_convert_ChannelBindingsConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ParametrizedSecuritySchemeMatcher__Lamf_client_convert_ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ParametrizedSecuritySchemeMatcher$module$1 === null)) {
    this.ParametrizedSecuritySchemeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().ParametrizedSecuritySchemeMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.StrFieldMatcher__Lamf_client_convert_FieldConverter$StrFieldMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher$module$1 === null)) {
    this.StrFieldMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.CorrelationIdMatcher__Lamf_client_convert_CorrelationIdConverter$CorrelationIdMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().CorrelationIdMatcher$module$1 === null)) {
    this.CorrelationIdMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().CorrelationIdMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.Amqp091QueueMatcher__Lamf_client_convert_Amqp091QueueConverter$Amqp091QueueMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().Amqp091QueueMatcher$module$1 === null)) {
    this.Amqp091QueueMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().Amqp091QueueMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.Amqp091ChannelExchangeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().Amqp091ChannelExchangeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().Amqp091ChannelExchangeMatcher$module$1 = new $c_Lamf_client_convert_Amqp091ChannelExchangeConverter$Amqp091ChannelExchangeMatcher$().init___Lamf_client_convert_Amqp091ChannelExchangeConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.Amqp091ChannelExchangeMatcher__Lamf_client_convert_Amqp091ChannelExchangeConverter$Amqp091ChannelExchangeMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().Amqp091ChannelExchangeMatcher$module$1 === null)) {
    this.Amqp091ChannelExchangeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().Amqp091ChannelExchangeMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.OperationBindingMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().OperationBindingMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().OperationBindingMatcher$module$1 = new $c_Lamf_client_convert_OperationBindingConverter$OperationBindingMatcher$().init___Lamf_client_convert_OperationBindingConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.MqttServerLastWillMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().MqttServerLastWillMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().MqttServerLastWillMatcher$module$1 = new $c_Lamf_client_convert_MqttServerLastWillConverter$MqttServerLastWillMatcher$().init___Lamf_client_convert_MqttServerLastWillConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.OAuth2SettingsMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().OAuth2SettingsMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().OAuth2SettingsMatcher$module$1 = new $c_Lamf_client_convert_SettingsConverter$OAuth2SettingsMatcher$().init___Lamf_client_convert_SettingsConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.XMLSerializerMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().XMLSerializerMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().XMLSerializerMatcher$module$1 = new $c_Lamf_client_convert_XMLSerializerConverter$XMLSerializerMatcher$().init___Lamf_client_convert_XMLSerializerConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.MessageBindingMatcher__Lamf_client_convert_MessageBindingConverter$MessageBindingMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().MessageBindingMatcher$module$1 === null)) {
    this.MessageBindingMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().MessageBindingMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.BoolFieldMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher$module$1 = new $c_Lamf_client_convert_FieldConverter$BoolFieldMatcher$().init___Lamf_client_convert_FieldConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.platform__Lamf_core_remote_Platform = (function() {
  return this.platform$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ServerBindingsMatcher__Lamf_client_convert_ServerBindingsConverter$ServerBindingsMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ServerBindingsMatcher$module$1 === null)) {
    this.ServerBindingsMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().ServerBindingsMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ServerBindingMatcher__Lamf_client_convert_ServerBindingConverter$ServerBindingMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ServerBindingMatcher$module$1 === null)) {
    this.ServerBindingMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().ServerBindingMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.SecuritySchemeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().SecuritySchemeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().SecuritySchemeMatcher$module$1 = new $c_Lamf_client_convert_SecuritySchemeConverter$SecuritySchemeMatcher$().init___Lamf_client_convert_SecuritySchemeConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.SecurityRequirementMatcher__Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().SecurityRequirementMatcher$module$1 === null)) {
    this.SecurityRequirementMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().SecurityRequirementMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.StringMatcher__Lamf_client_convert_CoreBaseConverter$StringMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().StringMatcher$module$1 === null)) {
    this.StringMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().StringMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.OrganizationMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().OrganizationMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().OrganizationMatcher$module$1 = new $c_Lamf_client_convert_OrganizationConverter$OrganizationMatcher$().init___Lamf_client_convert_OrganizationConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.OperationMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().OperationMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().OperationMatcher$module$1 = new $c_Lamf_client_convert_OperationConverter$OperationMatcher$().init___Lamf_client_convert_OperationConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.RequestMatcher__Lamf_client_convert_MessageConverter$RequestMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().RequestMatcher$module$1 === null)) {
    this.RequestMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().RequestMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.NilShapeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().NilShapeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().NilShapeMatcher$module$1 = new $c_Lamf_client_convert_NilShapeConverter$NilShapeMatcher$().init___Lamf_client_convert_NilShapeConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.EmptyBindingMatcher__Lamf_client_convert_EmptyBindingConverter$EmptyBindingMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().EmptyBindingMatcher$module$1 === null)) {
    this.EmptyBindingMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().EmptyBindingMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.TagMatcher__Lamf_client_convert_TagConverter$TagMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().TagMatcher$module$1 === null)) {
    this.TagMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().TagMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.SchemaShapeMatcher__Lamf_client_convert_SchemaShapeConverter$SchemaShapeMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().SchemaShapeMatcher$module$1 === null)) {
    this.SchemaShapeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().SchemaShapeMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.EncodingMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().EncodingMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().EncodingMatcher$module$1 = new $c_Lamf_client_convert_EncodingConverter$EncodingMatcher$().init___Lamf_client_convert_EncodingConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.TraitMatcher__Lamf_client_convert_TraitConverter$TraitMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().TraitMatcher$module$1 === null)) {
    this.TraitMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().TraitMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.OperationMatcher__Lamf_client_convert_OperationConverter$OperationMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().OperationMatcher$module$1 === null)) {
    this.OperationMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().OperationMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.Amqp091ChannelBindingMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().Amqp091ChannelBindingMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().Amqp091ChannelBindingMatcher$module$1 = new $c_Lamf_client_convert_Amqp091ChannelBindingConverter$Amqp091ChannelBindingMatcher$().init___Lamf_client_convert_Amqp091ChannelBindingConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.OAuth1SettingsMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().OAuth1SettingsMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().OAuth1SettingsMatcher$module$1 = new $c_Lamf_client_convert_SettingsConverter$OAuth1SettingsMatcher$().init___Lamf_client_convert_SettingsConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.Amqp091MessageBindingMatcher__Lamf_client_convert_Amqp091MessageBindingConverter$Amqp091MessageBindingMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().Amqp091MessageBindingMatcher$module$1 === null)) {
    this.Amqp091MessageBindingMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().Amqp091MessageBindingMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.TagMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().TagMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().TagMatcher$module$1 = new $c_Lamf_client_convert_TagConverter$TagMatcher$().init___Lamf_client_convert_TagConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.DoubleFieldMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().DoubleFieldMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().DoubleFieldMatcher$module$1 = new $c_Lamf_client_convert_FieldConverter$DoubleFieldMatcher$().init___Lamf_client_convert_FieldConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.PayloadMatcher__Lamf_client_convert_PayloadConverter$PayloadMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().PayloadMatcher$module$1 === null)) {
    this.PayloadMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().PayloadMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ScalarShapeMatcher__Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ScalarShapeMatcher$module$1 === null)) {
    this.ScalarShapeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().ScalarShapeMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.WebSocketsChannelBindingMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().WebSocketsChannelBindingMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().WebSocketsChannelBindingMatcher$module$1 = new $c_Lamf_client_convert_WebSocketsChannelBindingConverter$WebSocketsChannelBindingMatcher$().init___Lamf_client_convert_WebSocketsChannelBindingConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.CallbackMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().CallbackMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().CallbackMatcher$module$1 = new $c_Lamf_client_convert_CallbackConverter$CallbackMatcher$().init___Lamf_client_convert_CallbackConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.PayloadValidatorMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().PayloadValidatorMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().PayloadValidatorMatcher$module$1 = new $c_Lamf_client_convert_PayloadValidatorConverter$PayloadValidatorMatcher$().init___Lamf_client_convert_PayloadValidatorConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.IriTemplateMappingConverter$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().IriTemplateMappingConverter$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().IriTemplateMappingConverter$module$1 = new $c_Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$().init___Lamf_client_convert_IriTemplateMappingConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ScopeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ScopeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().ScopeMatcher$module$1 = new $c_Lamf_client_convert_ScopeConverter$ScopeMatcher$().init___Lamf_client_convert_ScopeConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ResourceTypeMatcher__Lamf_client_convert_ResourceTypeConverter$ResourceTypeMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ResourceTypeMatcher$module$1 === null)) {
    this.ResourceTypeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().ResourceTypeMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.FileShapeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().FileShapeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().FileShapeMatcher$module$1 = new $c_Lamf_client_convert_FileShapeConverter$FileShapeMatcher$().init___Lamf_client_convert_FileShapeConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.HttpSettingsMatcher__Lamf_client_convert_SettingsConverter$HttpSettingsMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().HttpSettingsMatcher$module$1 === null)) {
    this.HttpSettingsMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().HttpSettingsMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.StringMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().StringMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().StringMatcher$module$1 = new $c_Lamf_client_convert_CoreBaseConverter$StringMatcher$().init___Lamf_client_convert_CoreBaseConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.OperationBindingMatcher__Lamf_client_convert_OperationBindingConverter$OperationBindingMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().OperationBindingMatcher$module$1 === null)) {
    this.OperationBindingMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().OperationBindingMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.EndPointMatcher__Lamf_client_convert_EndPointConverter$EndPointMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().EndPointMatcher$module$1 === null)) {
    this.EndPointMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().EndPointMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.OAuth1SettingsMatcher__Lamf_client_convert_SettingsConverter$OAuth1SettingsMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().OAuth1SettingsMatcher$module$1 === null)) {
    this.OAuth1SettingsMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().OAuth1SettingsMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.SecuritySchemeMatcher__Lamf_client_convert_SecuritySchemeConverter$SecuritySchemeMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().SecuritySchemeMatcher$module$1 === null)) {
    this.SecuritySchemeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().SecuritySchemeMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ArrayNodeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ArrayNodeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().ArrayNodeMatcher$module$1 = new $c_Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$().init___Lamf_client_convert_DataNodeConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.TupleShapeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().TupleShapeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().TupleShapeMatcher$module$1 = new $c_Lamf_client_convert_TupleShapeConverter$TupleShapeMatcher$().init___Lamf_client_convert_TupleShapeConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ChannelBindingsMatcher__Lamf_client_convert_ChannelBindingsConverter$ChannelBindingsMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ChannelBindingsMatcher$module$1 === null)) {
    this.ChannelBindingsMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().ChannelBindingsMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.PayloadFragmentMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().PayloadFragmentMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().PayloadFragmentMatcher$module$1 = new $c_Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$().init___Lamf_client_convert_PayloadFragmentConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.PropertyDependenciesMatcher__Lamf_client_convert_PropertyDependenciesConverter$PropertyDependenciesMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().PropertyDependenciesMatcher$module$1 === null)) {
    this.PropertyDependenciesMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().PropertyDependenciesMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.MqttMessageBindingMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().MqttMessageBindingMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().MqttMessageBindingMatcher$module$1 = new $c_Lamf_client_convert_MqttMessageBindingConverter$MqttMessageBindingMatcher$().init___Lamf_client_convert_MqttMessageBindingConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ValidationReportMatcher__Lamf_client_convert_ValidationConverter$ValidationReportMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ValidationReportMatcher$module$1 === null)) {
    this.ValidationReportMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().ValidationReportMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.KafkaOperationBindingMatcher__Lamf_client_convert_KafkaOperationBindingConverter$KafkaOperationBindingMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().KafkaOperationBindingMatcher$module$1 === null)) {
    this.KafkaOperationBindingMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().KafkaOperationBindingMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.MqttServerLastWillMatcher__Lamf_client_convert_MqttServerLastWillConverter$MqttServerLastWillMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().MqttServerLastWillMatcher$module$1 === null)) {
    this.MqttServerLastWillMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().MqttServerLastWillMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.OAuth2FlowMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().OAuth2FlowMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().OAuth2FlowMatcher$module$1 = new $c_Lamf_client_convert_OAuth2FlowConverter$OAuth2FlowMatcher$().init___Lamf_client_convert_OAuth2FlowConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.KafkaOperationBindingMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().KafkaOperationBindingMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().KafkaOperationBindingMatcher$module$1 = new $c_Lamf_client_convert_KafkaOperationBindingConverter$KafkaOperationBindingMatcher$().init___Lamf_client_convert_KafkaOperationBindingConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.TemplatedLinkConverter$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().TemplatedLinkConverter$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().TemplatedLinkConverter$module$1 = new $c_Lamf_client_convert_TemplatedLinkConverter$TemplatedLinkConverter$().init___Lamf_client_convert_TemplatedLinkConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.HttpApiKeySettingsMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().HttpApiKeySettingsMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().HttpApiKeySettingsMatcher$module$1 = new $c_Lamf_client_convert_SettingsConverter$HttpApiKeySettingsMatcher$().init___Lamf_client_convert_SettingsConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.CallbackMatcher__Lamf_client_convert_CallbackConverter$CallbackMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().CallbackMatcher$module$1 === null)) {
    this.CallbackMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().CallbackMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ObjectNodeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ObjectNodeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().ObjectNodeMatcher$module$1 = new $c_Lamf_client_convert_DataNodeConverter$ObjectNodeMatcher$().init___Lamf_client_convert_DataNodeConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.EmptyBindingMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().EmptyBindingMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().EmptyBindingMatcher$module$1 = new $c_Lamf_client_convert_EmptyBindingConverter$EmptyBindingMatcher$().init___Lamf_client_convert_EmptyBindingConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.TraitMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().TraitMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().TraitMatcher$module$1 = new $c_Lamf_client_convert_TraitConverter$TraitMatcher$().init___Lamf_client_convert_TraitConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.LicenseMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().LicenseMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().LicenseMatcher$module$1 = new $c_Lamf_client_convert_LicenseConverter$LicenseMatcher$().init___Lamf_client_convert_LicenseConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.CreativeWorkMatcher__Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().CreativeWorkMatcher$module$1 === null)) {
    this.CreativeWorkMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().CreativeWorkMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ServerBindingsMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ServerBindingsMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().ServerBindingsMatcher$module$1 = new $c_Lamf_client_convert_ServerBindingsConverter$ServerBindingsMatcher$().init___Lamf_client_convert_ServerBindingsConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ApiKeySettingsMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ApiKeySettingsMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().ApiKeySettingsMatcher$module$1 = new $c_Lamf_client_convert_SettingsConverter$ApiKeySettingsMatcher$().init___Lamf_client_convert_SettingsConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.NilShapeMatcher__Lamf_client_convert_NilShapeConverter$NilShapeMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().NilShapeMatcher$module$1 === null)) {
    this.NilShapeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().NilShapeMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.IntFieldMatcher__Lamf_client_convert_FieldConverter$IntFieldMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().IntFieldMatcher$module$1 === null)) {
    this.IntFieldMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().IntFieldMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.CorrelationIdMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().CorrelationIdMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().CorrelationIdMatcher$module$1 = new $c_Lamf_client_convert_CorrelationIdConverter$CorrelationIdMatcher$().init___Lamf_client_convert_CorrelationIdConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.MessageBindingsMatcher__Lamf_client_convert_MessageBindingsConverter$MessageBindingsMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().MessageBindingsMatcher$module$1 === null)) {
    this.MessageBindingsMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().MessageBindingsMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.MqttMessageBindingMatcher__Lamf_client_convert_MqttMessageBindingConverter$MqttMessageBindingMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().MqttMessageBindingMatcher$module$1 === null)) {
    this.MqttMessageBindingMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().MqttMessageBindingMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.StrFieldMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().StrFieldMatcher$module$1 = new $c_Lamf_client_convert_FieldConverter$StrFieldMatcher$().init___Lamf_client_convert_FieldConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.DataNodeMatcher__Lamf_client_convert_DataNodeConverter$DataNodeMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().DataNodeMatcher$module$1 === null)) {
    this.DataNodeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().DataNodeMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.HttpMessageBindingMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().HttpMessageBindingMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().HttpMessageBindingMatcher$module$1 = new $c_Lamf_client_convert_HttpMessageBindingConverter$HttpMessageBindingMatcher$().init___Lamf_client_convert_HttpMessageBindingConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ServerMatcher__Lamf_client_convert_ServerConverter$ServerMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ServerMatcher$module$1 === null)) {
    this.ServerMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().ServerMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.OAuth2SettingsMatcher__Lamf_client_convert_SettingsConverter$OAuth2SettingsMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().OAuth2SettingsMatcher$module$1 === null)) {
    this.OAuth2SettingsMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().OAuth2SettingsMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.IriTemplateMappingConverter__Lamf_client_convert_IriTemplateMappingConverter$IriTemplateMappingConverter$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().IriTemplateMappingConverter$module$1 === null)) {
    this.IriTemplateMappingConverter$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().IriTemplateMappingConverter$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.MessageBindingMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().MessageBindingMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().MessageBindingMatcher$module$1 = new $c_Lamf_client_convert_MessageBindingConverter$MessageBindingMatcher$().init___Lamf_client_convert_MessageBindingConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ExampleMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ExampleMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().ExampleMatcher$module$1 = new $c_Lamf_client_convert_ExampleConverter$ExampleMatcher$().init___Lamf_client_convert_ExampleConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ShapeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher$module$1 = new $c_Lamf_client_convert_ShapeConverter$ShapeMatcher$().init___Lamf_client_convert_ShapeConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.RequestMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().RequestMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().RequestMatcher$module$1 = new $c_Lamf_client_convert_MessageConverter$RequestMatcher$().init___Lamf_client_convert_MessageConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.KafkaMessageBindingMatcher__Lamf_client_convert_KafkaMessageBindingConverter$KafkaMessageBindingMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().KafkaMessageBindingMatcher$module$1 === null)) {
    this.KafkaMessageBindingMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().KafkaMessageBindingMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.PayloadMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().PayloadMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().PayloadMatcher$module$1 = new $c_Lamf_client_convert_PayloadConverter$PayloadMatcher$().init___Lamf_client_convert_PayloadConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.OpenIdConnectSettingsMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().OpenIdConnectSettingsMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().OpenIdConnectSettingsMatcher$module$1 = new $c_Lamf_client_convert_SettingsConverter$OpenIdConnectSettingsMatcher$().init___Lamf_client_convert_SettingsConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.HttpApiKeySettingsMatcher__Lamf_client_convert_SettingsConverter$HttpApiKeySettingsMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().HttpApiKeySettingsMatcher$module$1 === null)) {
    this.HttpApiKeySettingsMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().HttpApiKeySettingsMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.OAuth2FlowMatcher__Lamf_client_convert_OAuth2FlowConverter$OAuth2FlowMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().OAuth2FlowMatcher$module$1 === null)) {
    this.OAuth2FlowMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().OAuth2FlowMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.BoolFieldMatcher__Lamf_client_convert_FieldConverter$BoolFieldMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher$module$1 === null)) {
    this.BoolFieldMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().BoolFieldMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.SecurityRequirementMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().SecurityRequirementMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().SecurityRequirementMatcher$module$1 = new $c_Lamf_client_convert_SecurityRequirementConverter$SecurityRequirementMatcher$().init___Lamf_client_convert_SecurityRequirementConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.DynamicBindingMatcher__Lamf_client_convert_DynamicBindingConverter$DynamicBindingMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().DynamicBindingMatcher$module$1 === null)) {
    this.DynamicBindingMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().DynamicBindingMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.MqttOperationBindingMatcher__Lamf_client_convert_MqttOperationBindingConverter$MqttOperationBindingMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().MqttOperationBindingMatcher$module$1 === null)) {
    this.MqttOperationBindingMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().MqttOperationBindingMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.MqttOperationBindingMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().MqttOperationBindingMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().MqttOperationBindingMatcher$module$1 = new $c_Lamf_client_convert_MqttOperationBindingConverter$MqttOperationBindingMatcher$().init___Lamf_client_convert_MqttOperationBindingConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ChannelBindingMatcher__Lamf_client_convert_ChannelBindingConverter$ChannelBindingMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ChannelBindingMatcher$module$1 === null)) {
    this.ChannelBindingMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().ChannelBindingMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.OpenIdConnectSettingsMatcher__Lamf_client_convert_SettingsConverter$OpenIdConnectSettingsMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().OpenIdConnectSettingsMatcher$module$1 === null)) {
    this.OpenIdConnectSettingsMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().OpenIdConnectSettingsMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ParameterMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher$module$1 = new $c_Lamf_client_convert_ParameterConverter$ParameterMatcher$().init___Lamf_client_convert_ParameterConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.DoubleFieldMatcher__Lamf_client_convert_FieldConverter$DoubleFieldMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().DoubleFieldMatcher$module$1 === null)) {
    this.DoubleFieldMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().DoubleFieldMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ServerMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ServerMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().ServerMatcher$module$1 = new $c_Lamf_client_convert_ServerConverter$ServerMatcher$().init___Lamf_client_convert_ServerConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.MessageMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().MessageMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().MessageMatcher$module$1 = new $c_Lamf_client_convert_MessageConverter$MessageMatcher$().init___Lamf_client_convert_MessageConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.NodeShapeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().NodeShapeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().NodeShapeMatcher$module$1 = new $c_Lamf_client_convert_NodeShapeConverter$NodeShapeMatcher$().init___Lamf_client_convert_NodeShapeConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.HttpSettingsMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().HttpSettingsMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().HttpSettingsMatcher$module$1 = new $c_Lamf_client_convert_SettingsConverter$HttpSettingsMatcher$().init___Lamf_client_convert_SettingsConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.Amqp091ChannelBindingMatcher__Lamf_client_convert_Amqp091ChannelBindingConverter$Amqp091ChannelBindingMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().Amqp091ChannelBindingMatcher$module$1 === null)) {
    this.Amqp091ChannelBindingMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().Amqp091ChannelBindingMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.BooleanMatcher__Lamf_client_convert_CoreBaseConverter$BooleanMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().BooleanMatcher$module$1 === null)) {
    this.BooleanMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().BooleanMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.Amqp091MessageBindingMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().Amqp091MessageBindingMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().Amqp091MessageBindingMatcher$module$1 = new $c_Lamf_client_convert_Amqp091MessageBindingConverter$Amqp091MessageBindingMatcher$().init___Lamf_client_convert_Amqp091MessageBindingConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.WebSocketsChannelBindingMatcher__Lamf_client_convert_WebSocketsChannelBindingConverter$WebSocketsChannelBindingMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().WebSocketsChannelBindingMatcher$module$1 === null)) {
    this.WebSocketsChannelBindingMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().WebSocketsChannelBindingMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ScalarShapeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ScalarShapeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().ScalarShapeMatcher$module$1 = new $c_Lamf_client_convert_ScalarShapeConverter$ScalarShapeMatcher$().init___Lamf_client_convert_ScalarShapeConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.HttpOperationBindingMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().HttpOperationBindingMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().HttpOperationBindingMatcher$module$1 = new $c_Lamf_client_convert_HttpOperationBindingConverter$HttpOperationBindingMatcher$().init___Lamf_client_convert_HttpOperationBindingConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ApiKeySettingsMatcher__Lamf_client_convert_SettingsConverter$ApiKeySettingsMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ApiKeySettingsMatcher$module$1 === null)) {
    this.ApiKeySettingsMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().ApiKeySettingsMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.HttpOperationBindingMatcher__Lamf_client_convert_HttpOperationBindingConverter$HttpOperationBindingMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().HttpOperationBindingMatcher$module$1 === null)) {
    this.HttpOperationBindingMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().HttpOperationBindingMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.CreativeWorkMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().CreativeWorkMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().CreativeWorkMatcher$module$1 = new $c_Lamf_client_convert_CreativeWorkConverter$CreativeWorkMatcher$().init___Lamf_client_convert_CreativeWorkConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.OperationBindingsMatcher__Lamf_client_convert_OperationBindingsConverter$OperationBindingsMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().OperationBindingsMatcher$module$1 === null)) {
    this.OperationBindingsMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().OperationBindingsMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.EncodingMatcher__Lamf_client_convert_EncodingConverter$EncodingMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().EncodingMatcher$module$1 === null)) {
    this.EncodingMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().EncodingMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.OrganizationMatcher__Lamf_client_convert_OrganizationConverter$OrganizationMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().OrganizationMatcher$module$1 === null)) {
    this.OrganizationMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().OrganizationMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ArrayNodeMatcher__Lamf_client_convert_DataNodeConverter$ArrayNodeMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ArrayNodeMatcher$module$1 === null)) {
    this.ArrayNodeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().ArrayNodeMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ParametrizedSecuritySchemeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ParametrizedSecuritySchemeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().ParametrizedSecuritySchemeMatcher$module$1 = new $c_Lamf_client_convert_ParametrizedSecuritySchemeConverter$ParametrizedSecuritySchemeMatcher$().init___Lamf_client_convert_ParametrizedSecuritySchemeConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ScalarNodeMatcher__Lamf_client_convert_DataNodeConverter$ScalarNodeMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ScalarNodeMatcher$module$1 === null)) {
    this.ScalarNodeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().ScalarNodeMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.DataNodeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().DataNodeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().DataNodeMatcher$module$1 = new $c_Lamf_client_convert_DataNodeConverter$DataNodeMatcher$().init___Lamf_client_convert_DataNodeConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.DomainElementMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().DomainElementMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().DomainElementMatcher$module$1 = new $c_Lamf_client_convert_DomainElementConverter$DomainElementMatcher$().init___Lamf_client_convert_DomainElementConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.FileShapeMatcher__Lamf_client_convert_FileShapeConverter$FileShapeMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().FileShapeMatcher$module$1 === null)) {
    this.FileShapeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().FileShapeMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.SettingsMatcher__Lamf_client_convert_SettingsConverter$SettingsMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().SettingsMatcher$module$1 === null)) {
    this.SettingsMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().SettingsMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ValidationReportMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ValidationReportMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().ValidationReportMatcher$module$1 = new $c_Lamf_client_convert_ValidationConverter$ValidationReportMatcher$().init___Lamf_client_convert_ValidationConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.DomainElementMatcher__Lamf_client_convert_DomainElementConverter$DomainElementMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().DomainElementMatcher$module$1 === null)) {
    this.DomainElementMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().DomainElementMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.LicenseMatcher__Lamf_client_convert_LicenseConverter$LicenseMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().LicenseMatcher$module$1 === null)) {
    this.LicenseMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().LicenseMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.XMLSerializerMatcher__Lamf_client_convert_XMLSerializerConverter$XMLSerializerMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().XMLSerializerMatcher$module$1 === null)) {
    this.XMLSerializerMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().XMLSerializerMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.EndPointMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().EndPointMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().EndPointMatcher$module$1 = new $c_Lamf_client_convert_EndPointConverter$EndPointMatcher$().init___Lamf_client_convert_EndPointConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.IntFieldMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().IntFieldMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().IntFieldMatcher$module$1 = new $c_Lamf_client_convert_FieldConverter$IntFieldMatcher$().init___Lamf_client_convert_FieldConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.MessageMatcher__Lamf_client_convert_MessageConverter$MessageMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().MessageMatcher$module$1 === null)) {
    this.MessageMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().MessageMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ParameterMatcher__Lamf_client_convert_ParameterConverter$ParameterMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher$module$1 === null)) {
    this.ParameterMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().ParameterMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.PropertyShapeMatcher__Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().PropertyShapeMatcher$module$1 === null)) {
    this.PropertyShapeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().PropertyShapeMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.TemplatedLinkConverter__Lamf_client_convert_TemplatedLinkConverter$TemplatedLinkConverter$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().TemplatedLinkConverter$module$1 === null)) {
    this.TemplatedLinkConverter$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().TemplatedLinkConverter$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.KafkaMessageBindingMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().KafkaMessageBindingMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().KafkaMessageBindingMatcher$module$1 = new $c_Lamf_client_convert_KafkaMessageBindingConverter$KafkaMessageBindingMatcher$().init___Lamf_client_convert_KafkaMessageBindingConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.PropertyShapeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().PropertyShapeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().PropertyShapeMatcher$module$1 = new $c_Lamf_client_convert_PropertyShapeConverter$PropertyShapeMatcher$().init___Lamf_client_convert_PropertyShapeConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.ShapeMatcher__Lamf_client_convert_ShapeConverter$ShapeMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher$module$1 === null)) {
    this.ShapeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().ShapeMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.SettingsMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().SettingsMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().SettingsMatcher$module$1 = new $c_Lamf_client_convert_SettingsConverter$SettingsMatcher$().init___Lamf_client_convert_SettingsConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.AnyShapeMatcher__Lamf_client_convert_AnyShapeConverter$AnyShapeMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().AnyShapeMatcher$module$1 === null)) {
    this.AnyShapeMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().AnyShapeMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.OperationBindingsMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().OperationBindingsMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().OperationBindingsMatcher$module$1 = new $c_Lamf_client_convert_OperationBindingsConverter$OperationBindingsMatcher$().init___Lamf_client_convert_OperationBindingsConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.PayloadFragmentMatcher__Lamf_client_convert_PayloadFragmentConverter$PayloadFragmentMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().PayloadFragmentMatcher$module$1 === null)) {
    this.PayloadFragmentMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().PayloadFragmentMatcher$module$1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.SchemaShapeMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().SchemaShapeMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().SchemaShapeMatcher$module$1 = new $c_Lamf_client_convert_SchemaShapeConverter$SchemaShapeMatcher$().init___Lamf_client_convert_SchemaShapeConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.MqttServerBindingMatcher$lzycompute$1__p1__V = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().MqttServerBindingMatcher$module$1 === null)) {
    $m_Lamf_client_convert_WebApiClientConverters$().MqttServerBindingMatcher$module$1 = new $c_Lamf_client_convert_MqttServerBindingConverter$MqttServerBindingMatcher$().init___Lamf_client_convert_MqttServerBindingConverter(this)
  }
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.Amqp091OperationBindingMatcher__Lamf_client_convert_Amqp091OperationBindingConverter$Amqp091OperationBindingMatcher$ = (function() {
  if (($m_Lamf_client_convert_WebApiClientConverters$().Amqp091OperationBindingMatcher$module$1 === null)) {
    this.Amqp091OperationBindingMatcher$lzycompute$1__p1__V()
  };
  return $m_Lamf_client_convert_WebApiClientConverters$().Amqp091OperationBindingMatcher$module$1
});
var $d_Lamf_client_convert_WebApiClientConverters$ = new $TypeData().initClass({
  Lamf_client_convert_WebApiClientConverters$: 0
}, false, "amf.client.convert.WebApiClientConverters$", {
  Lamf_client_convert_WebApiClientConverters$: 1,
  O: 1,
  Lamf_client_convert_WebApiBaseConverter: 1,
  Lamf_client_convert_CoreBaseConverter: 1,
  Lamf_core_unsafe_PlatformSecrets: 1,
  Lamf_client_convert_CollectionConverter: 1,
  Lamf_client_convert_FutureConverter: 1,
  Lamf_client_convert_FieldConverter: 1,
  Lamf_client_convert_CustomDomainPropertyConverter: 1,
  Lamf_client_convert_ShapeConverter: 1,
  Lamf_client_convert_PropertyShapeConverter: 1,
  Lamf_client_convert_ShapeExtensionConverter: 1,
  Lamf_client_convert_DataNodeConverter: 1,
  Lamf_client_convert_DomainExtensionConverter: 1,
  Lamf_client_convert_DeclarationsConverter: 1,
  Lamf_client_convert_VariableValueConverter: 1,
  Lamf_client_convert_ValidationConverter: 1,
  Lamf_client_convert_DomainElementConverter: 1,
  Lamf_client_convert_BaseUnitConverter: 1,
  Lamf_client_convert_ResourceLoaderConverter: 1,
  Lamf_client_convert_GraphDomainConverter: 1,
  Lamf_client_convert_ValidationCandidateConverter: 1,
  Lamf_client_convert_ValidationShapeSetConverter: 1,
  Lamf_client_convert_PayloadFragmentConverter: 1,
  Lamf_client_convert_CachedReferenceConverter: 1,
  Lamf_client_convert_ReferenceResolverConverter: 1,
  Lamf_client_convert_EndPointConverter: 1,
  Lamf_client_convert_ResourceTypeConverter: 1,
  Lamf_client_convert_TraitConverter: 1,
  Lamf_client_convert_OrganizationConverter: 1,
  Lamf_client_convert_LicenseConverter: 1,
  Lamf_client_convert_CreativeWorkConverter: 1,
  Lamf_client_convert_MessageConverter: 1,
  Lamf_client_convert_OperationConverter: 1,
  Lamf_client_convert_TagConverter: 1,
  Lamf_client_convert_ParameterConverter: 1,
  Lamf_client_convert_PayloadConverter: 1,
  Lamf_client_convert_ParametrizedSecuritySchemeConverter: 1,
  Lamf_client_convert_SecuritySchemeConverter: 1,
  Lamf_client_convert_SettingsConverter: 1,
  Lamf_client_convert_ScopeConverter: 1,
  Lamf_client_convert_ServerConverter: 1,
  Lamf_client_convert_IriTemplateMappingConverter: 1,
  Lamf_client_convert_TemplatedLinkConverter: 1,
  Lamf_client_convert_CallbackConverter: 1,
  Lamf_client_convert_EncodingConverter: 1,
  Lamf_client_convert_PayloadValidatorConverter: 1,
  Lamf_client_convert_OAuth2FlowConverter: 1,
  Lamf_client_convert_SecurityRequirementConverter: 1,
  Lamf_client_convert_CorrelationIdConverter: 1,
  Lamf_client_convert_ChannelBindingsConverter: 1,
  Lamf_client_convert_OperationBindingsConverter: 1,
  Lamf_client_convert_ServerBindingsConverter: 1,
  Lamf_client_convert_MessageBindingsConverter: 1,
  Lamf_client_convert_Amqp091ChannelBindingConverter: 1,
  Lamf_client_convert_Amqp091MessageBindingConverter: 1,
  Lamf_client_convert_Amqp091OperationBindingConverter: 1,
  Lamf_client_convert_DynamicBindingConverter: 1,
  Lamf_client_convert_EmptyBindingConverter: 1,
  Lamf_client_convert_HttpMessageBindingConverter: 1,
  Lamf_client_convert_HttpOperationBindingConverter: 1,
  Lamf_client_convert_KafkaMessageBindingConverter: 1,
  Lamf_client_convert_KafkaOperationBindingConverter: 1,
  Lamf_client_convert_MqttMessageBindingConverter: 1,
  Lamf_client_convert_MqttOperationBindingConverter: 1,
  Lamf_client_convert_MqttServerBindingConverter: 1,
  Lamf_client_convert_WebSocketsChannelBindingConverter: 1,
  Lamf_client_convert_MqttServerLastWillConverter: 1,
  Lamf_client_convert_Amqp091ChannelExchangeConverter: 1,
  Lamf_client_convert_Amqp091QueueConverter: 1,
  Lamf_client_convert_ChannelBindingConverter: 1,
  Lamf_client_convert_OperationBindingConverter: 1,
  Lamf_client_convert_MessageBindingConverter: 1,
  Lamf_client_convert_ServerBindingConverter: 1,
  Lamf_client_convert_DataShapesBaseConverter: 1,
  Lamf_client_convert_NilShapeConverter: 1,
  Lamf_client_convert_SchemaShapeConverter: 1,
  Lamf_client_convert_NodeShapeConverter: 1,
  Lamf_client_convert_ScalarShapeConverter: 1,
  Lamf_client_convert_FileShapeConverter: 1,
  Lamf_client_convert_AnyShapeConverter: 1,
  Lamf_client_convert_ArrayShapeConverter: 1,
  Lamf_client_convert_TupleShapeConverter: 1,
  Lamf_client_convert_XMLSerializerConverter: 1,
  Lamf_client_convert_ExampleConverter: 1,
  Lamf_client_convert_UnionShapeConverter: 1,
  Lamf_client_convert_PropertyDependenciesConverter: 1,
  Lamf_client_convert_WebApiBaseClientConverter: 1,
  Lamf_client_convert_CoreBaseClientConverter: 1,
  Lamf_client_convert_DataShapesBaseClientConverter: 1
});
$c_Lamf_client_convert_WebApiClientConverters$.prototype.$classData = $d_Lamf_client_convert_WebApiClientConverters$;
var $n_Lamf_client_convert_WebApiClientConverters$ = (void 0);
function $m_Lamf_client_convert_WebApiClientConverters$() {
  if ((!$n_Lamf_client_convert_WebApiClientConverters$)) {
    $n_Lamf_client_convert_WebApiClientConverters$ = new $c_Lamf_client_convert_WebApiClientConverters$().init___()
  };
  return $n_Lamf_client_convert_WebApiClientConverters$
}
$e.MessageStyles = $m_Lamf_MessageStyles$();
$e.ProfileNames = $m_Lamf_ProfileNames$();
$e.Core = $m_Lamf_client_CoreWrapper$();
$e.plugins = $m_Lamf_client_PluginsWrapper$();
$e.client = ($e.client || {});
$e.client.DefaultExecutionEnvironment = $m_Lamf_client_execution_DefaultExecutionEnvironment$();
$e.ErrorHandler = $m_Lamf_client_handler_ErrorHandler$();
$e.client = ($e.client || {});
$e.client.model = ($e.client.model || {});
$e.client.model.DataTypes = $m_Lamf_client_model_DataTypes$();
$e.ValidationMode = $m_Lamf_client_plugins_ValidationMode$();
$e.DialectRegistry = $m_Lamf_client_registry_DialectRegistry$();
$e.JSONSchemaVersions = $m_Lamf_client_render_JSONSchemaVersions$();
$e.render = ($e.render || {});
/** @constructor */
$e.render.RenderOptions = (function() {
  var $thiz = new $c_Lamf_client_render_RenderOptions();
  $c_Lamf_client_render_RenderOptions.prototype.init___.call($thiz);
  return $thiz
});
$e.render.RenderOptions.prototype = $c_Lamf_client_render_RenderOptions.prototype;
$e.render = ($e.render || {});
/** @constructor */
$e.render.ShapeRenderOptions = (function() {
  var $thiz = new $c_Lamf_client_render_ShapeRenderOptions();
  $c_Lamf_client_render_ShapeRenderOptions.prototype.init___.call($thiz);
  return $thiz
});
$e.render.ShapeRenderOptions.prototype = $c_Lamf_client_render_ShapeRenderOptions.prototype;
/** @constructor */
$e.Resolver = (function(arg) {
  var $thiz = new $c_Lamf_client_resolve_Resolver();
  var prep = $as_T(arg);
  $c_Lamf_client_resolve_Resolver.prototype.init___T.call($thiz, prep);
  return $thiz
});
$e.Resolver.prototype = $c_Lamf_client_resolve_Resolver.prototype;
$e.client = ($e.client || {});
$e.client.validate = ($e.client.validate || {});
/** @constructor */
$e.client.validate.PayloadParsingResult = (function(arg, arg$2) {
  var $thiz = new $c_Lamf_client_validate_PayloadParsingResult();
  var prep = $as_Lamf_client_model_document_PayloadFragment(arg);
  var prep$2 = arg$2;
  $c_Lamf_client_validate_PayloadParsingResult.prototype.init___Lamf_client_model_document_PayloadFragment__sjs_js_Array.call($thiz, prep, prep$2);
  return $thiz
});
$e.client.validate.PayloadParsingResult.prototype = $c_Lamf_client_validate_PayloadParsingResult.prototype;
$e.client = ($e.client || {});
$e.client.validate = ($e.client.validate || {});
/** @constructor */
$e.client.validate.ValidationReport = (function(arg, arg$2, arg$3, arg$4) {
  var $thiz = new $c_Lamf_client_validate_ValidationReport();
  var prep = $uZ(arg);
  var prep$2 = $as_T(arg$2);
  var prep$3 = $as_Lamf_ProfileName(arg$3);
  var prep$4 = arg$4;
  $c_Lamf_client_validate_ValidationReport.prototype.init___Z__T__Lamf_ProfileName__sjs_js_Array.call($thiz, prep, prep$2, prep$3, prep$4);
  return $thiz
});
$e.client.validate.ValidationReport.prototype = $c_Lamf_client_validate_ValidationReport.prototype;
$e.client = ($e.client || {});
$e.client.validate = ($e.client.validate || {});
/** @constructor */
$e.client.validate.ValidationResult = (function(arg, arg$2, arg$3, arg$4, arg$5, arg$6, arg$7) {
  var $thiz = new $c_Lamf_client_validate_ValidationResult();
  var prep = $as_T(arg);
  var prep$2 = $as_T(arg$2);
  var prep$3 = $as_T(arg$3);
  var prep$4 = $as_T(arg$4);
  var prep$5 = $as_T(arg$5);
  var prep$6 = $as_Lamf_core_parser_Range(arg$6);
  var prep$7 = $as_T(arg$7);
  $c_Lamf_client_validate_ValidationResult.prototype.init___T__T__T__T__T__Lamf_core_parser_Range__T.call($thiz, prep, prep$2, prep$3, prep$4, prep$5, prep$6, prep$7);
  return $thiz
});
$e.client.validate.ValidationResult.prototype = $c_Lamf_client_validate_ValidationResult.prototype;
$e.ExecutionLog = $m_Lamf_core_benchmark_ExecutionLog$();
$e.parser = ($e.parser || {});
/** @constructor */
$e.parser.ParsingOptions = (function() {
  var $thiz = new $c_Lamf_core_client_ParsingOptions();
  $c_Lamf_core_client_ParsingOptions.prototype.init___.call($thiz);
  return $thiz
});
$e.parser.ParsingOptions.prototype = $c_Lamf_core_client_ParsingOptions.prototype;
$e.core = ($e.core || {});
$e.core.Vendor = $m_Lamf_core_remote_Vendor$();
$e.ResolutionPipeline = $m_Lamf_core_resolution_pipelines_ResolutionPipeline$();
$e.core = ($e.core || {});
$e.core.validation = ($e.core.validation || {});
$e.core.validation.SeverityLevels = $m_Lamf_core_validation_SeverityLevels$();
$e.Main = $m_Lamf_Main$();
$e.AMF = $m_Lamf_client_AMF$();
$e.client = ($e.client || {});
$e.client.DefaultEnvironment = $m_Lamf_client_environment_DefaultEnvironment$();
/** @constructor */
$e.AmfGraphParser = (function() {
  var $thiz = new $c_Lamf_client_parse_AmfGraphParser();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      $c_Lamf_client_parse_AmfGraphParser.prototype.init___.call($thiz);
      break
    }
    case 1: {
      var prep = $as_Lamf_client_environment_Environment(rest[0]);
      $c_Lamf_client_parse_AmfGraphParser.prototype.init___Lamf_client_environment_Environment.call($thiz, prep);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.AmfGraphParser.prototype = $c_Lamf_client_parse_AmfGraphParser.prototype;
/** @constructor */
$e.Aml10Parser = (function() {
  var $thiz = new $c_Lamf_client_parse_Aml10Parser();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 2: {
      var prep = $as_T(rest[0]);
      var prep$2 = $as_Lamf_client_environment_Environment(rest[1]);
      $c_Lamf_client_parse_Aml10Parser.prototype.init___T__Lamf_client_environment_Environment.call($thiz, prep, prep$2);
      break
    }
    case 0: {
      $c_Lamf_client_parse_Aml10Parser.prototype.init___.call($thiz);
      break
    }
    case 1: {
      if ($is_T(rest[0])) {
        var prep$4 = $as_T(rest[0]);
        $c_Lamf_client_parse_Aml10Parser.prototype.init___T.call($thiz, prep$4)
      } else if ((rest[0] instanceof $c_Lamf_client_environment_Environment)) {
        var prep$3 = $as_Lamf_client_environment_Environment(rest[0]);
        $c_Lamf_client_parse_Aml10Parser.prototype.init___Lamf_client_environment_Environment.call($thiz, prep$3)
      } else {
        throw "No matching overload"
      };
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.Aml10Parser.prototype = $c_Lamf_client_parse_Aml10Parser.prototype;
/** @constructor */
$e.Async20JsonParser = (function() {
  var $thiz = new $c_Lamf_client_parse_Async20JsonParser();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      $c_Lamf_client_parse_Async20JsonParser.prototype.init___.call($thiz);
      break
    }
    case 1: {
      var prep = $as_Lamf_client_environment_Environment(rest[0]);
      $c_Lamf_client_parse_Async20JsonParser.prototype.init___Lamf_client_environment_Environment.call($thiz, prep);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.Async20JsonParser.prototype = $c_Lamf_client_parse_Async20JsonParser.prototype;
/** @constructor */
$e.Async20Parser = (function() {
  var $thiz = new $c_Lamf_client_parse_Async20Parser();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_client_environment_Environment(rest[0]);
      $c_Lamf_client_parse_Async20Parser.prototype.init___Lamf_client_environment_Environment.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_parse_Async20Parser.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.Async20Parser.prototype = $c_Lamf_client_parse_Async20Parser.prototype;
/** @constructor */
$e.JsonPayloadParser = (function() {
  var $thiz = new $c_Lamf_client_parse_JsonPayloadParser();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_client_environment_Environment(rest[0]);
      $c_Lamf_client_parse_JsonPayloadParser.prototype.init___Lamf_client_environment_Environment.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_parse_JsonPayloadParser.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.JsonPayloadParser.prototype = $c_Lamf_client_parse_JsonPayloadParser.prototype;
/** @constructor */
$e.Oas20Parser = (function() {
  var $thiz = new $c_Lamf_client_parse_Oas20Parser();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      $c_Lamf_client_parse_Oas20Parser.prototype.init___.call($thiz);
      break
    }
    case 1: {
      var prep = $as_Lamf_client_environment_Environment(rest[0]);
      $c_Lamf_client_parse_Oas20Parser.prototype.init___Lamf_client_environment_Environment.call($thiz, prep);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.Oas20Parser.prototype = $c_Lamf_client_parse_Oas20Parser.prototype;
/** @constructor */
$e.Oas20YamlParser = (function() {
  var $thiz = new $c_Lamf_client_parse_Oas20YamlParser();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      $c_Lamf_client_parse_Oas20YamlParser.prototype.init___.call($thiz);
      break
    }
    case 1: {
      var prep = $as_Lamf_client_environment_Environment(rest[0]);
      $c_Lamf_client_parse_Oas20YamlParser.prototype.init___Lamf_client_environment_Environment.call($thiz, prep);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.Oas20YamlParser.prototype = $c_Lamf_client_parse_Oas20YamlParser.prototype;
/** @constructor */
$e.Oas30Parser = (function() {
  var $thiz = new $c_Lamf_client_parse_Oas30Parser();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_client_environment_Environment(rest[0]);
      $c_Lamf_client_parse_Oas30Parser.prototype.init___Lamf_client_environment_Environment.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_parse_Oas30Parser.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.Oas30Parser.prototype = $c_Lamf_client_parse_Oas30Parser.prototype;
/** @constructor */
$e.Oas30YamlParser = (function() {
  var $thiz = new $c_Lamf_client_parse_Oas30YamlParser();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_client_environment_Environment(rest[0]);
      $c_Lamf_client_parse_Oas30YamlParser.prototype.init___Lamf_client_environment_Environment.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_parse_Oas30YamlParser.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.Oas30YamlParser.prototype = $c_Lamf_client_parse_Oas30YamlParser.prototype;
/** @constructor */
$e.Raml08Parser = (function() {
  var $thiz = new $c_Lamf_client_parse_Raml08Parser();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      $c_Lamf_client_parse_Raml08Parser.prototype.init___.call($thiz);
      break
    }
    case 1: {
      var prep = $as_Lamf_client_environment_Environment(rest[0]);
      $c_Lamf_client_parse_Raml08Parser.prototype.init___Lamf_client_environment_Environment.call($thiz, prep);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.Raml08Parser.prototype = $c_Lamf_client_parse_Raml08Parser.prototype;
/** @constructor */
$e.Raml10Parser = (function() {
  var $thiz = new $c_Lamf_client_parse_Raml10Parser();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_client_environment_Environment(rest[0]);
      $c_Lamf_client_parse_Raml10Parser.prototype.init___Lamf_client_environment_Environment.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_parse_Raml10Parser.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.Raml10Parser.prototype = $c_Lamf_client_parse_Raml10Parser.prototype;
/** @constructor */
$e.RamlParser = (function() {
  var $thiz = new $c_Lamf_client_parse_RamlParser();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_client_environment_Environment(rest[0]);
      $c_Lamf_client_parse_RamlParser.prototype.init___Lamf_client_environment_Environment.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_parse_RamlParser.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.RamlParser.prototype = $c_Lamf_client_parse_RamlParser.prototype;
/** @constructor */
$e.YamlPayloadParser = (function() {
  var $thiz = new $c_Lamf_client_parse_YamlPayloadParser();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_client_environment_Environment(rest[0]);
      $c_Lamf_client_parse_YamlPayloadParser.prototype.init___Lamf_client_environment_Environment.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_parse_YamlPayloadParser.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.YamlPayloadParser.prototype = $c_Lamf_client_parse_YamlPayloadParser.prototype;
/** @constructor */
$e.AmfGraphResolver = (function() {
  var $thiz = new $c_Lamf_client_resolve_AmfGraphResolver();
  $c_Lamf_client_resolve_AmfGraphResolver.prototype.init___.call($thiz);
  return $thiz
});
$e.AmfGraphResolver.prototype = $c_Lamf_client_resolve_AmfGraphResolver.prototype;
/** @constructor */
$e.Async20Resolver = (function() {
  var $thiz = new $c_Lamf_client_resolve_Async20Resolver();
  $c_Lamf_client_resolve_Async20Resolver.prototype.init___.call($thiz);
  return $thiz
});
$e.Async20Resolver.prototype = $c_Lamf_client_resolve_Async20Resolver.prototype;
/** @constructor */
$e.Oas20Resolver = (function() {
  var $thiz = new $c_Lamf_client_resolve_Oas20Resolver();
  $c_Lamf_client_resolve_Oas20Resolver.prototype.init___.call($thiz);
  return $thiz
});
$e.Oas20Resolver.prototype = $c_Lamf_client_resolve_Oas20Resolver.prototype;
/** @constructor */
$e.Oas30Resolver = (function() {
  var $thiz = new $c_Lamf_client_resolve_Oas30Resolver();
  $c_Lamf_client_resolve_Oas30Resolver.prototype.init___.call($thiz);
  return $thiz
});
$e.Oas30Resolver.prototype = $c_Lamf_client_resolve_Oas30Resolver.prototype;
/** @constructor */
$e.Raml08Resolver = (function() {
  var $thiz = new $c_Lamf_client_resolve_Raml08Resolver();
  $c_Lamf_client_resolve_Raml08Resolver.prototype.init___.call($thiz);
  return $thiz
});
$e.Raml08Resolver.prototype = $c_Lamf_client_resolve_Raml08Resolver.prototype;
/** @constructor */
$e.Raml10Resolver = (function() {
  var $thiz = new $c_Lamf_client_resolve_Raml10Resolver();
  $c_Lamf_client_resolve_Raml10Resolver.prototype.init___.call($thiz);
  return $thiz
});
$e.Raml10Resolver.prototype = $c_Lamf_client_resolve_Raml10Resolver.prototype;
$e.org = ($e.org || {});
$e.org.yaml = ($e.org.yaml || {});
$e.org.yaml.builder = ($e.org.yaml.builder || {});
/** @constructor */
$e.org.yaml.builder.JsOutputBuilder = (function() {
  var $thiz = new $c_Lorg_yaml_builder_JsOutputBuilder();
  $c_Lorg_yaml_builder_JsOutputBuilder.prototype.init___.call($thiz);
  return $thiz
});
$e.org.yaml.builder.JsOutputBuilder.prototype = $c_Lorg_yaml_builder_JsOutputBuilder.prototype;
/** @constructor */
$e.AmfGraphRenderer = (function() {
  var $thiz = new $c_Lamf_client_render_AmfGraphRenderer();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      $c_Lamf_client_render_AmfGraphRenderer.prototype.init___.call($thiz);
      break
    }
    case 1: {
      var prep = $as_Lamf_client_environment_Environment(rest[0]);
      $c_Lamf_client_render_AmfGraphRenderer.prototype.init___Lamf_client_environment_Environment.call($thiz, prep);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.AmfGraphRenderer.prototype = $c_Lamf_client_render_AmfGraphRenderer.prototype;
/** @constructor */
$e.Aml10Renderer = (function() {
  var $thiz = new $c_Lamf_client_render_Aml10Renderer();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_T(rest[0]);
      $c_Lamf_client_render_Aml10Renderer.prototype.init___T.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_render_Aml10Renderer.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.Aml10Renderer.prototype = $c_Lamf_client_render_Aml10Renderer.prototype;
/** @constructor */
$e.Async20Renderer = (function() {
  var $thiz = new $c_Lamf_client_render_Async20Renderer();
  $c_Lamf_client_render_Async20Renderer.prototype.init___.call($thiz);
  return $thiz
});
$e.Async20Renderer.prototype = $c_Lamf_client_render_Async20Renderer.prototype;
/** @constructor */
$e.JsonPayloadRenderer = (function() {
  var $thiz = new $c_Lamf_client_render_JsonPayloadRenderer();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_client_environment_Environment(rest[0]);
      $c_Lamf_client_render_JsonPayloadRenderer.prototype.init___Lamf_client_environment_Environment.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_render_JsonPayloadRenderer.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.JsonPayloadRenderer.prototype = $c_Lamf_client_render_JsonPayloadRenderer.prototype;
/** @constructor */
$e.JsonldRenderer = (function() {
  var $thiz = new $c_Lamf_client_render_JsonldRenderer();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_client_environment_Environment(rest[0]);
      $c_Lamf_client_render_JsonldRenderer.prototype.init___Lamf_client_environment_Environment.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_render_JsonldRenderer.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.JsonldRenderer.prototype = $c_Lamf_client_render_JsonldRenderer.prototype;
/** @constructor */
$e.Oas20Renderer = (function() {
  var $thiz = new $c_Lamf_client_render_Oas20Renderer();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_client_environment_Environment(rest[0]);
      $c_Lamf_client_render_Oas20Renderer.prototype.init___Lamf_client_environment_Environment.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_render_Oas20Renderer.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.Oas20Renderer.prototype = $c_Lamf_client_render_Oas20Renderer.prototype;
/** @constructor */
$e.Oas30Renderer = (function() {
  var $thiz = new $c_Lamf_client_render_Oas30Renderer();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_client_environment_Environment(rest[0]);
      $c_Lamf_client_render_Oas30Renderer.prototype.init___Lamf_client_environment_Environment.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_render_Oas30Renderer.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.Oas30Renderer.prototype = $c_Lamf_client_render_Oas30Renderer.prototype;
/** @constructor */
$e.Raml08Renderer = (function() {
  var $thiz = new $c_Lamf_client_render_Raml08Renderer();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_client_environment_Environment(rest[0]);
      $c_Lamf_client_render_Raml08Renderer.prototype.init___Lamf_client_environment_Environment.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_render_Raml08Renderer.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.Raml08Renderer.prototype = $c_Lamf_client_render_Raml08Renderer.prototype;
/** @constructor */
$e.Raml10Renderer = (function() {
  var $thiz = new $c_Lamf_client_render_Raml10Renderer();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_client_environment_Environment(rest[0]);
      $c_Lamf_client_render_Raml10Renderer.prototype.init___Lamf_client_environment_Environment.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_render_Raml10Renderer.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.Raml10Renderer.prototype = $c_Lamf_client_render_Raml10Renderer.prototype;
/** @constructor */
$e.YamlPayloadRenderer = (function() {
  var $thiz = new $c_Lamf_client_render_YamlPayloadRenderer();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_client_environment_Environment(rest[0]);
      $c_Lamf_client_render_YamlPayloadRenderer.prototype.init___Lamf_client_environment_Environment.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_render_YamlPayloadRenderer.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.YamlPayloadRenderer.prototype = $c_Lamf_client_render_YamlPayloadRenderer.prototype;
/** @constructor */
$e.ResourceNotFound = (function(arg) {
  var $thiz = new $c_Lamf_client_resource_ResourceNotFound();
  var prep = $as_T(arg);
  $c_Lamf_client_resource_ResourceNotFound.prototype.init___T.call($thiz, prep);
  return $thiz
});
$e.ResourceNotFound.prototype = $c_Lamf_client_resource_ResourceNotFound.prototype;
/** @constructor */
$e.SHACLValidator = (function() {
  var $thiz = new $c_Lamf_plugins_features_validation_SHACLValidator();
  $c_Lamf_plugins_features_validation_SHACLValidator.prototype.init___.call($thiz);
  return $thiz
});
$e.SHACLValidator.prototype = $c_Lamf_plugins_features_validation_SHACLValidator.prototype;
/** @constructor */
$e.ProfileName = (function(arg) {
  var $thiz = new $c_Lamf_ProfileName();
  var prep = $as_T(arg);
  $c_Lamf_ProfileName.prototype.init___T.call($thiz, prep);
  return $thiz
});
$e.ProfileName.prototype = $c_Lamf_ProfileName.prototype;
$e.model = ($e.model || {});
/** @constructor */
$e.model.Annotations = (function() {
  var $thiz = new $c_Lamf_client_model_Annotations();
  $c_Lamf_client_model_Annotations.prototype.init___.call($thiz);
  return $thiz
});
$e.model.Annotations.prototype = $c_Lamf_client_model_Annotations.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Settings = (function() {
  var $thiz = new $c_Lamf_client_model_domain_Settings();
  $c_Lamf_client_model_domain_Settings.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.Settings.prototype = $c_Lamf_client_model_domain_Settings.prototype;
$e.client = ($e.client || {});
$e.client.remote = ($e.client.remote || {});
/** @constructor */
$e.client.remote.CachedReference = (function(arg, arg$2, arg$3) {
  var $thiz = new $c_Lamf_client_reference_CachedReference();
  var prep = $as_T(arg);
  var prep$2 = $as_Lamf_client_model_document_BaseUnit(arg$2);
  var prep$3 = $uZ(arg$3);
  $c_Lamf_client_reference_CachedReference.prototype.init___T__Lamf_client_model_document_BaseUnit__Z.call($thiz, prep, prep$2, prep$3);
  return $thiz
});
$e.client.remote.CachedReference.prototype = $c_Lamf_client_reference_CachedReference.prototype;
$e.client = ($e.client || {});
$e.client.remote = ($e.client.remote || {});
/** @constructor */
$e.client.remote.Content = (function(arg, arg$2) {
  var $thiz = new $c_Lamf_client_remote_Content();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 2;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      var prep = $as_T(arg);
      var prep$2 = $as_T(arg$2);
      $c_Lamf_client_remote_Content.prototype.init___T__T.call($thiz, prep, prep$2);
      break
    }
    case 1: {
      var prep$3 = $as_T(arg);
      var prep$4 = $as_T(arg$2);
      var prep$5 = $as_T(rest[0]);
      $c_Lamf_client_remote_Content.prototype.init___T__T__T.call($thiz, prep$3, prep$4, prep$5);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.client.remote.Content.prototype = $c_Lamf_client_remote_Content.prototype;
$e.client = ($e.client || {});
$e.client.plugins = ($e.client.plugins || {});
/** @constructor */
$e.client.plugins.ValidationCandidate = (function(arg, arg$2) {
  var $thiz = new $c_Lamf_client_validate_ValidationCandidate();
  var prep = $as_Lamf_client_model_domain_Shape(arg);
  var prep$2 = $as_Lamf_client_model_document_PayloadFragment(arg$2);
  $c_Lamf_client_validate_ValidationCandidate.prototype.init___Lamf_client_model_domain_Shape__Lamf_client_model_document_PayloadFragment.call($thiz, prep, prep$2);
  return $thiz
});
$e.client.plugins.ValidationCandidate.prototype = $c_Lamf_client_validate_ValidationCandidate.prototype;
$e.client = ($e.client || {});
$e.client.plugins = ($e.client.plugins || {});
/** @constructor */
$e.client.plugins.ValidationShapeSet = (function(arg, arg$2, arg$3) {
  var $thiz = new $c_Lamf_client_validate_ValidationShapeSet();
  var prep = arg;
  var prep$2 = arg$2;
  var prep$3 = $as_T(arg$3);
  $c_Lamf_client_validate_ValidationShapeSet.prototype.init___sjs_js_Array__sjs_js_Array__T.call($thiz, prep, prep$2, prep$3);
  return $thiz
});
$e.client.plugins.ValidationShapeSet.prototype = $c_Lamf_client_validate_ValidationShapeSet.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Variable = (function(arg, arg$2) {
  var $thiz = new $c_Lamf_core_model_domain_templates_Variable();
  var prep = $as_T(arg);
  var prep$2 = $as_Lamf_core_model_domain_DataNode(arg$2);
  $c_Lamf_core_model_domain_templates_Variable.prototype.init___T__Lamf_core_model_domain_DataNode.call($thiz, prep, prep$2);
  return $thiz
});
$e.model.domain.Variable.prototype = $c_Lamf_core_model_domain_templates_Variable.prototype;
$e.core = ($e.core || {});
$e.core.parser = ($e.core.parser || {});
/** @constructor */
$e.core.parser.Range = (function(arg, arg$2) {
  var $thiz = new $c_Lamf_core_parser_Range();
  var prep = $as_Lamf_core_parser_Position(arg);
  var prep$2 = $as_Lamf_core_parser_Position(arg$2);
  $c_Lamf_core_parser_Range.prototype.init___Lamf_core_parser_Position__Lamf_core_parser_Position.call($thiz, prep, prep$2);
  return $thiz
});
$e.core.parser.Range.prototype = $c_Lamf_core_parser_Range.prototype;
$e.org = ($e.org || {});
$e.org.mulesoft = ($e.org.mulesoft || {});
$e.org.mulesoft.common = ($e.org.mulesoft.common || {});
$e.org.mulesoft.common.io = ($e.org.mulesoft.common.io || {});
/** @constructor */
$e.org.mulesoft.common.io.LimitedStringBuffer = (function(arg) {
  var $thiz = new $c_Lorg_mulesoft_common_io_LimitedStringBuffer();
  var prep = $uI(arg);
  $c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype.init___I.call($thiz, prep);
  return $thiz
});
$e.org.mulesoft.common.io.LimitedStringBuffer.prototype = $c_Lorg_mulesoft_common_io_LimitedStringBuffer.prototype;
$e.client = ($e.client || {});
$e.client.environment = ($e.client.environment || {});
/** @constructor */
$e.client.environment.Environment = (function() {
  var $thiz = new $c_Lamf_client_environment_Environment();
  $c_Lamf_client_environment_Environment.prototype.init___.call($thiz);
  return $thiz
});
$e.client.environment.Environment.prototype = $c_Lamf_client_environment_Environment.prototype;
$e.client = ($e.client || {});
$e.client.execution = ($e.client.execution || {});
/** @constructor */
$e.client.execution.ExecutionEnvironment = (function() {
  var $thiz = new $c_Lamf_client_execution_ExecutionEnvironment();
  $c_Lamf_client_execution_ExecutionEnvironment.prototype.init___.call($thiz);
  return $thiz
});
$e.client.execution.ExecutionEnvironment.prototype = $c_Lamf_client_execution_ExecutionEnvironment.prototype;
$e.model = ($e.model || {});
$e.model.document = ($e.model.document || {});
/** @constructor */
$e.model.document.DialectFragment = (function() {
  var $thiz = new $c_Lamf_client_model_document_DialectFragment();
  $c_Lamf_client_model_document_DialectFragment.prototype.init___.call($thiz);
  return $thiz
});
$e.model.document.DialectFragment.prototype = $c_Lamf_client_model_document_DialectFragment.prototype;
$e.model = ($e.model || {});
$e.model.document = ($e.model.document || {});
/** @constructor */
$e.model.document.DialectInstanceFragment = (function() {
  var $thiz = new $c_Lamf_client_model_document_DialectInstanceFragment();
  $c_Lamf_client_model_document_DialectInstanceFragment.prototype.init___.call($thiz);
  return $thiz
});
$e.model.document.DialectInstanceFragment.prototype = $c_Lamf_client_model_document_DialectInstanceFragment.prototype;
$e.model = ($e.model || {});
$e.model.document = ($e.model.document || {});
/** @constructor */
$e.model.document.DialectInstanceLibrary = (function() {
  var $thiz = new $c_Lamf_client_model_document_DialectInstanceLibrary();
  $c_Lamf_client_model_document_DialectInstanceLibrary.prototype.init___.call($thiz);
  return $thiz
});
$e.model.document.DialectInstanceLibrary.prototype = $c_Lamf_client_model_document_DialectInstanceLibrary.prototype;
$e.model = ($e.model || {});
$e.model.document = ($e.model.document || {});
/** @constructor */
$e.model.document.DialectLibrary = (function() {
  var $thiz = new $c_Lamf_client_model_document_DialectLibrary();
  $c_Lamf_client_model_document_DialectLibrary.prototype.init___.call($thiz);
  return $thiz
});
$e.model.document.DialectLibrary.prototype = $c_Lamf_client_model_document_DialectLibrary.prototype;
$e.model = ($e.model || {});
$e.model.document = ($e.model.document || {});
/** @constructor */
$e.model.document.Vocabulary = (function() {
  var $thiz = new $c_Lamf_client_model_document_Vocabulary();
  $c_Lamf_client_model_document_Vocabulary.prototype.init___.call($thiz);
  return $thiz
});
$e.model.document.Vocabulary.prototype = $c_Lamf_client_model_document_Vocabulary.prototype;
$e.core = ($e.core || {});
$e.core.parser = ($e.core.parser || {});
/** @constructor */
$e.core.parser.Position = (function(arg, arg$2) {
  var $thiz = new $c_Lamf_core_parser_Position();
  var prep = $uI(arg);
  var prep$2 = $uI(arg$2);
  $c_Lamf_core_parser_Position.prototype.init___I__I.call($thiz, prep, prep$2);
  return $thiz
});
$e.core.parser.Position.prototype = $c_Lamf_core_parser_Position.prototype;
$e.model = ($e.model || {});
$e.model.document = ($e.model.document || {});
/** @constructor */
$e.model.document.DialectInstance = (function() {
  var $thiz = new $c_Lamf_client_model_document_DialectInstance();
  $c_Lamf_client_model_document_DialectInstance.prototype.init___.call($thiz);
  return $thiz
});
$e.model.document.DialectInstance.prototype = $c_Lamf_client_model_document_DialectInstance.prototype;
$e.model = ($e.model || {});
$e.model.document = ($e.model.document || {});
/** @constructor */
$e.model.document.DialectInstancePatch = (function() {
  var $thiz = new $c_Lamf_client_model_document_DialectInstancePatch();
  $c_Lamf_client_model_document_DialectInstancePatch.prototype.init___.call($thiz);
  return $thiz
});
$e.model.document.DialectInstancePatch.prototype = $c_Lamf_client_model_document_DialectInstancePatch.prototype;
$e.model = ($e.model || {});
$e.model.document = ($e.model.document || {});
/** @constructor */
$e.model.document.Document = (function() {
  var $thiz = new $c_Lamf_client_model_document_Document();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      $c_Lamf_client_model_document_Document.prototype.init___.call($thiz);
      break
    }
    case 1: {
      var prep = $as_Lamf_client_model_domain_DomainElement(rest[0]);
      $c_Lamf_client_model_document_Document.prototype.init___Lamf_client_model_domain_DomainElement.call($thiz, prep);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.model.document.Document.prototype = $c_Lamf_client_model_document_Document.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.AbstractDeclaration = (function(arg) {
  var $thiz = new $c_Lamf_client_model_domain_AbstractDeclaration();
  var prep = $as_Lamf_core_model_domain_templates_AbstractDeclaration(arg);
  $c_Lamf_client_model_domain_AbstractDeclaration.prototype.init___Lamf_core_model_domain_templates_AbstractDeclaration.call($thiz, prep);
  return $thiz
});
$e.model.domain.AbstractDeclaration.prototype = $c_Lamf_client_model_domain_AbstractDeclaration.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Message = (function() {
  var $thiz = new $c_Lamf_client_model_domain_Message();
  $c_Lamf_client_model_domain_Message.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.Message.prototype = $c_Lamf_client_model_domain_Message.prototype;
/** @constructor */
$e.JsBrowserHttpResourceLoader = (function() {
  var $thiz = new $c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader();
  $c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader.prototype.init___.call($thiz);
  return $thiz
});
$e.JsBrowserHttpResourceLoader.prototype = $c_Lamf_core_remote_browser_JsBrowserHttpResourceLoader.prototype;
/** @constructor */
$e.JsServerFileResourceLoader = (function() {
  var $thiz = new $c_Lamf_core_remote_server_JsServerFileResourceLoader();
  $c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype.init___.call($thiz);
  return $thiz
});
$e.JsServerFileResourceLoader.prototype = $c_Lamf_core_remote_server_JsServerFileResourceLoader.prototype;
/** @constructor */
$e.JsServerHttpResourceLoader = (function() {
  var $thiz = new $c_Lamf_core_remote_server_JsServerHttpResourceLoader();
  $c_Lamf_core_remote_server_JsServerHttpResourceLoader.prototype.init___.call($thiz);
  return $thiz
});
$e.JsServerHttpResourceLoader.prototype = $c_Lamf_core_remote_server_JsServerHttpResourceLoader.prototype;
$e.org = ($e.org || {});
$e.org.mulesoft = ($e.org.mulesoft || {});
$e.org.mulesoft.common = ($e.org.mulesoft.common || {});
$e.org.mulesoft.common.io = ($e.org.mulesoft.common.io || {});
/** @constructor */
$e.org.mulesoft.common.io.LimitReachedException = (function() {
  var $thiz = new $c_Lorg_mulesoft_common_io_LimitReachedException();
  $c_Lorg_mulesoft_common_io_LimitReachedException.prototype.init___.call($thiz);
  return $thiz
});
$e.org.mulesoft.common.io.LimitReachedException.prototype = $c_Lorg_mulesoft_common_io_LimitReachedException.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.AnyShape = (function() {
  var $thiz = new $c_Lamf_client_model_domain_AnyShape();
  $c_Lamf_client_model_domain_AnyShape.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.AnyShape.prototype = $c_Lamf_client_model_domain_AnyShape.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.ClassTerm = (function() {
  var $thiz = new $c_Lamf_client_model_domain_ClassTerm();
  $c_Lamf_client_model_domain_ClassTerm.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.ClassTerm.prototype = $c_Lamf_client_model_domain_ClassTerm.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.CreativeWork = (function() {
  var $thiz = new $c_Lamf_client_model_domain_CreativeWork();
  $c_Lamf_client_model_domain_CreativeWork.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.CreativeWork.prototype = $c_Lamf_client_model_domain_CreativeWork.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.DialectDomainElement = (function() {
  var $thiz = new $c_Lamf_client_model_domain_DialectDomainElement();
  $c_Lamf_client_model_domain_DialectDomainElement.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.DialectDomainElement.prototype = $c_Lamf_client_model_domain_DialectDomainElement.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.DocumentMapping = (function() {
  var $thiz = new $c_Lamf_client_model_domain_DocumentMapping();
  $c_Lamf_client_model_domain_DocumentMapping.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.DocumentMapping.prototype = $c_Lamf_client_model_domain_DocumentMapping.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.DocumentsModel = (function() {
  var $thiz = new $c_Lamf_client_model_domain_DocumentsModel();
  $c_Lamf_client_model_domain_DocumentsModel.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.DocumentsModel.prototype = $c_Lamf_client_model_domain_DocumentsModel.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.DomainExtension = (function() {
  var $thiz = new $c_Lamf_client_model_domain_DomainExtension();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_core_model_domain_extensions_DomainExtension(rest[0]);
      $c_Lamf_client_model_domain_DomainExtension.prototype.init___Lamf_core_model_domain_extensions_DomainExtension.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_model_domain_DomainExtension.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.model.domain.DomainExtension.prototype = $c_Lamf_client_model_domain_DomainExtension.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Encoding = (function() {
  var $thiz = new $c_Lamf_client_model_domain_Encoding();
  $c_Lamf_client_model_domain_Encoding.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.Encoding.prototype = $c_Lamf_client_model_domain_Encoding.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.External = (function() {
  var $thiz = new $c_Lamf_client_model_domain_External();
  $c_Lamf_client_model_domain_External.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.External.prototype = $c_Lamf_client_model_domain_External.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.ExternalDomainElement = (function() {
  var $thiz = new $c_Lamf_client_model_domain_ExternalDomainElement();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_core_model_domain_ExternalDomainElement(rest[0]);
      $c_Lamf_client_model_domain_ExternalDomainElement.prototype.init___Lamf_core_model_domain_ExternalDomainElement.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_model_domain_ExternalDomainElement.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.model.domain.ExternalDomainElement.prototype = $c_Lamf_client_model_domain_ExternalDomainElement.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.IriTemplateMapping = (function() {
  var $thiz = new $c_Lamf_client_model_domain_IriTemplateMapping();
  $c_Lamf_client_model_domain_IriTemplateMapping.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.IriTemplateMapping.prototype = $c_Lamf_client_model_domain_IriTemplateMapping.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.MqttServerLastWill = (function() {
  var $thiz = new $c_Lamf_client_model_domain_MqttServerLastWill();
  $c_Lamf_client_model_domain_MqttServerLastWill.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.MqttServerLastWill.prototype = $c_Lamf_client_model_domain_MqttServerLastWill.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.OAuth2Flow = (function() {
  var $thiz = new $c_Lamf_client_model_domain_OAuth2Flow();
  $c_Lamf_client_model_domain_OAuth2Flow.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.OAuth2Flow.prototype = $c_Lamf_client_model_domain_OAuth2Flow.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.ParametrizedSecurityScheme = (function() {
  var $thiz = new $c_Lamf_client_model_domain_ParametrizedSecurityScheme();
  $c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.ParametrizedSecurityScheme.prototype = $c_Lamf_client_model_domain_ParametrizedSecurityScheme.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.PropertyDependencies = (function() {
  var $thiz = new $c_Lamf_client_model_domain_PropertyDependencies();
  $c_Lamf_client_model_domain_PropertyDependencies.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.PropertyDependencies.prototype = $c_Lamf_client_model_domain_PropertyDependencies.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.PropertyMapping = (function() {
  var $thiz = new $c_Lamf_client_model_domain_PropertyMapping();
  $c_Lamf_client_model_domain_PropertyMapping.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.PropertyMapping.prototype = $c_Lamf_client_model_domain_PropertyMapping.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.PublicNodeMapping = (function() {
  var $thiz = new $c_Lamf_client_model_domain_PublicNodeMapping();
  $c_Lamf_client_model_domain_PublicNodeMapping.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.PublicNodeMapping.prototype = $c_Lamf_client_model_domain_PublicNodeMapping.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Scope = (function() {
  var $thiz = new $c_Lamf_client_model_domain_Scope();
  $c_Lamf_client_model_domain_Scope.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.Scope.prototype = $c_Lamf_client_model_domain_Scope.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.SecurityRequirement = (function() {
  var $thiz = new $c_Lamf_client_model_domain_SecurityRequirement();
  $c_Lamf_client_model_domain_SecurityRequirement.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.SecurityRequirement.prototype = $c_Lamf_client_model_domain_SecurityRequirement.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Server = (function() {
  var $thiz = new $c_Lamf_client_model_domain_Server();
  $c_Lamf_client_model_domain_Server.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.Server.prototype = $c_Lamf_client_model_domain_Server.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.ShapeExtension = (function() {
  var $thiz = new $c_Lamf_client_model_domain_ShapeExtension();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_core_model_domain_extensions_ShapeExtension(rest[0]);
      $c_Lamf_client_model_domain_ShapeExtension.prototype.init___Lamf_core_model_domain_extensions_ShapeExtension.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_model_domain_ShapeExtension.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.model.domain.ShapeExtension.prototype = $c_Lamf_client_model_domain_ShapeExtension.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.VocabularyReference = (function() {
  var $thiz = new $c_Lamf_client_model_domain_VocabularyReference();
  $c_Lamf_client_model_domain_VocabularyReference.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.VocabularyReference.prototype = $c_Lamf_client_model_domain_VocabularyReference.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.XMLSerializer = (function() {
  var $thiz = new $c_Lamf_client_model_domain_XMLSerializer();
  $c_Lamf_client_model_domain_XMLSerializer.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.XMLSerializer.prototype = $c_Lamf_client_model_domain_XMLSerializer.prototype;
$e.model = ($e.model || {});
$e.model.document = ($e.model.document || {});
/** @constructor */
$e.model.document.Module = (function() {
  var $thiz = new $c_Lamf_client_model_document_Module();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_core_model_document_Module(rest[0]);
      $c_Lamf_client_model_document_Module.prototype.init___Lamf_core_model_document_Module.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_model_document_Module.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.model.document.Module.prototype = $c_Lamf_client_model_document_Module.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Amqp091ChannelExchange = (function() {
  var $thiz = new $c_Lamf_client_model_domain_Amqp091ChannelExchange();
  $c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.Amqp091ChannelExchange.prototype = $c_Lamf_client_model_domain_Amqp091ChannelExchange.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Amqp091Queue = (function() {
  var $thiz = new $c_Lamf_client_model_domain_Amqp091Queue();
  $c_Lamf_client_model_domain_Amqp091Queue.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.Amqp091Queue.prototype = $c_Lamf_client_model_domain_Amqp091Queue.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.ApiKeySettings = (function() {
  var $thiz = new $c_Lamf_client_model_domain_ApiKeySettings();
  $c_Lamf_client_model_domain_ApiKeySettings.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.ApiKeySettings.prototype = $c_Lamf_client_model_domain_ApiKeySettings.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.ArrayNode = (function() {
  var $thiz = new $c_Lamf_client_model_domain_ArrayNode();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_core_model_domain_ArrayNode(rest[0]);
      $c_Lamf_client_model_domain_ArrayNode.prototype.init___Lamf_core_model_domain_ArrayNode.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_model_domain_ArrayNode.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.model.domain.ArrayNode.prototype = $c_Lamf_client_model_domain_ArrayNode.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Callback = (function() {
  var $thiz = new $c_Lamf_client_model_domain_Callback();
  $c_Lamf_client_model_domain_Callback.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.Callback.prototype = $c_Lamf_client_model_domain_Callback.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.CustomDomainProperty = (function() {
  var $thiz = new $c_Lamf_client_model_domain_CustomDomainProperty();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_core_model_domain_extensions_CustomDomainProperty(rest[0]);
      $c_Lamf_client_model_domain_CustomDomainProperty.prototype.init___Lamf_core_model_domain_extensions_CustomDomainProperty.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_model_domain_CustomDomainProperty.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.model.domain.CustomDomainProperty.prototype = $c_Lamf_client_model_domain_CustomDomainProperty.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.DatatypePropertyTerm = (function() {
  var $thiz = new $c_Lamf_client_model_domain_DatatypePropertyTerm();
  $c_Lamf_client_model_domain_DatatypePropertyTerm.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.DatatypePropertyTerm.prototype = $c_Lamf_client_model_domain_DatatypePropertyTerm.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.EndPoint = (function() {
  var $thiz = new $c_Lamf_client_model_domain_EndPoint();
  $c_Lamf_client_model_domain_EndPoint.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.EndPoint.prototype = $c_Lamf_client_model_domain_EndPoint.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.HttpApiKeySettings = (function() {
  var $thiz = new $c_Lamf_client_model_domain_HttpApiKeySettings();
  $c_Lamf_client_model_domain_HttpApiKeySettings.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.HttpApiKeySettings.prototype = $c_Lamf_client_model_domain_HttpApiKeySettings.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.HttpSettings = (function() {
  var $thiz = new $c_Lamf_client_model_domain_HttpSettings();
  $c_Lamf_client_model_domain_HttpSettings.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.HttpSettings.prototype = $c_Lamf_client_model_domain_HttpSettings.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.License = (function() {
  var $thiz = new $c_Lamf_client_model_domain_License();
  $c_Lamf_client_model_domain_License.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.License.prototype = $c_Lamf_client_model_domain_License.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.NodeMapping = (function() {
  var $thiz = new $c_Lamf_client_model_domain_NodeMapping();
  $c_Lamf_client_model_domain_NodeMapping.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.NodeMapping.prototype = $c_Lamf_client_model_domain_NodeMapping.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.OAuth1Settings = (function() {
  var $thiz = new $c_Lamf_client_model_domain_OAuth1Settings();
  $c_Lamf_client_model_domain_OAuth1Settings.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.OAuth1Settings.prototype = $c_Lamf_client_model_domain_OAuth1Settings.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.OAuth2Settings = (function() {
  var $thiz = new $c_Lamf_client_model_domain_OAuth2Settings();
  $c_Lamf_client_model_domain_OAuth2Settings.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.OAuth2Settings.prototype = $c_Lamf_client_model_domain_OAuth2Settings.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.ObjectNode = (function() {
  var $thiz = new $c_Lamf_client_model_domain_ObjectNode();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_core_model_domain_ObjectNode(rest[0]);
      $c_Lamf_client_model_domain_ObjectNode.prototype.init___Lamf_core_model_domain_ObjectNode.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_model_domain_ObjectNode.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.model.domain.ObjectNode.prototype = $c_Lamf_client_model_domain_ObjectNode.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.ObjectPropertyTerm = (function() {
  var $thiz = new $c_Lamf_client_model_domain_ObjectPropertyTerm();
  $c_Lamf_client_model_domain_ObjectPropertyTerm.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.ObjectPropertyTerm.prototype = $c_Lamf_client_model_domain_ObjectPropertyTerm.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.OpenIdConnectSettings = (function() {
  var $thiz = new $c_Lamf_client_model_domain_OpenIdConnectSettings();
  $c_Lamf_client_model_domain_OpenIdConnectSettings.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.OpenIdConnectSettings.prototype = $c_Lamf_client_model_domain_OpenIdConnectSettings.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Organization = (function() {
  var $thiz = new $c_Lamf_client_model_domain_Organization();
  $c_Lamf_client_model_domain_Organization.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.Organization.prototype = $c_Lamf_client_model_domain_Organization.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Parameter = (function() {
  var $thiz = new $c_Lamf_client_model_domain_Parameter();
  $c_Lamf_client_model_domain_Parameter.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.Parameter.prototype = $c_Lamf_client_model_domain_Parameter.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Payload = (function() {
  var $thiz = new $c_Lamf_client_model_domain_Payload();
  $c_Lamf_client_model_domain_Payload.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.Payload.prototype = $c_Lamf_client_model_domain_Payload.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.ScalarNode = (function() {
  var $thiz = new $c_Lamf_client_model_domain_ScalarNode();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      $c_Lamf_client_model_domain_ScalarNode.prototype.init___.call($thiz);
      break
    }
    case 2: {
      var prep = $as_T(rest[0]);
      var prep$2 = $as_T(rest[1]);
      $c_Lamf_client_model_domain_ScalarNode.prototype.init___T__T.call($thiz, prep, prep$2);
      break
    }
    case 1: {
      var prep$3 = $as_Lamf_core_model_domain_ScalarNode(rest[0]);
      $c_Lamf_client_model_domain_ScalarNode.prototype.init___Lamf_core_model_domain_ScalarNode.call($thiz, prep$3);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.model.domain.ScalarNode.prototype = $c_Lamf_client_model_domain_ScalarNode.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.SecurityScheme = (function() {
  var $thiz = new $c_Lamf_client_model_domain_SecurityScheme();
  $c_Lamf_client_model_domain_SecurityScheme.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.SecurityScheme.prototype = $c_Lamf_client_model_domain_SecurityScheme.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Tag = (function() {
  var $thiz = new $c_Lamf_client_model_domain_Tag();
  $c_Lamf_client_model_domain_Tag.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.Tag.prototype = $c_Lamf_client_model_domain_Tag.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.TemplatedLink = (function() {
  var $thiz = new $c_Lamf_client_model_domain_TemplatedLink();
  $c_Lamf_client_model_domain_TemplatedLink.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.TemplatedLink.prototype = $c_Lamf_client_model_domain_TemplatedLink.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.UnionNodeMapping = (function() {
  var $thiz = new $c_Lamf_client_model_domain_UnionNodeMapping();
  $c_Lamf_client_model_domain_UnionNodeMapping.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.UnionNodeMapping.prototype = $c_Lamf_client_model_domain_UnionNodeMapping.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.WebApi = (function() {
  var $thiz = new $c_Lamf_client_model_domain_WebApi();
  $c_Lamf_client_model_domain_WebApi.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.WebApi.prototype = $c_Lamf_client_model_domain_WebApi.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.AnnotationTypeDeclaration = (function() {
  var $thiz = new $c_Lamf_client_model_document_AnnotationTypeDeclaration();
  $c_Lamf_client_model_document_AnnotationTypeDeclaration.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.AnnotationTypeDeclaration.prototype = $c_Lamf_client_model_document_AnnotationTypeDeclaration.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.DataType = (function() {
  var $thiz = new $c_Lamf_client_model_document_DataType();
  $c_Lamf_client_model_document_DataType.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.DataType.prototype = $c_Lamf_client_model_document_DataType.prototype;
$e.model = ($e.model || {});
$e.model.document = ($e.model.document || {});
/** @constructor */
$e.model.document.Dialect = (function() {
  var $thiz = new $c_Lamf_client_model_document_Dialect();
  $c_Lamf_client_model_document_Dialect.prototype.init___.call($thiz);
  return $thiz
});
$e.model.document.Dialect.prototype = $c_Lamf_client_model_document_Dialect.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.DocumentationItem = (function() {
  var $thiz = new $c_Lamf_client_model_document_DocumentationItem();
  $c_Lamf_client_model_document_DocumentationItem.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.DocumentationItem.prototype = $c_Lamf_client_model_document_DocumentationItem.prototype;
$e.model = ($e.model || {});
$e.model.document = ($e.model.document || {});
/** @constructor */
$e.model.document.ExternalFragment = (function() {
  var $thiz = new $c_Lamf_client_model_document_ExternalFragment();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      $c_Lamf_client_model_document_ExternalFragment.prototype.init___.call($thiz);
      break
    }
    case 1: {
      var prep = $as_Lamf_core_model_document_ExternalFragment(rest[0]);
      $c_Lamf_client_model_document_ExternalFragment.prototype.init___Lamf_core_model_document_ExternalFragment.call($thiz, prep);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.model.document.ExternalFragment.prototype = $c_Lamf_client_model_document_ExternalFragment.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.NamedExample = (function() {
  var $thiz = new $c_Lamf_client_model_document_NamedExample();
  $c_Lamf_client_model_document_NamedExample.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.NamedExample.prototype = $c_Lamf_client_model_document_NamedExample.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.PayloadFragment = (function(arg, arg$2) {
  var $thiz = new $c_Lamf_client_model_document_PayloadFragment();
  if ((arg instanceof $c_Lamf_client_model_domain_ScalarNode)) {
    var prep$5 = $as_Lamf_client_model_domain_ScalarNode(arg);
    var prep$6 = $as_T(arg$2);
    $c_Lamf_client_model_document_PayloadFragment.prototype.init___Lamf_client_model_domain_ScalarNode__T.call($thiz, prep$5, prep$6)
  } else if ((arg instanceof $c_Lamf_client_model_domain_ObjectNode)) {
    var prep$3 = $as_Lamf_client_model_domain_ObjectNode(arg);
    var prep$4 = $as_T(arg$2);
    $c_Lamf_client_model_document_PayloadFragment.prototype.init___Lamf_client_model_domain_ObjectNode__T.call($thiz, prep$3, prep$4)
  } else if ((arg instanceof $c_Lamf_client_model_domain_ArrayNode)) {
    var prep = $as_Lamf_client_model_domain_ArrayNode(arg);
    var prep$2 = $as_T(arg$2);
    $c_Lamf_client_model_document_PayloadFragment.prototype.init___Lamf_client_model_domain_ArrayNode__T.call($thiz, prep, prep$2)
  } else {
    throw "No matching overload"
  };
  return $thiz
});
$e.model.domain.PayloadFragment.prototype = $c_Lamf_client_model_document_PayloadFragment.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.ResourceTypeFragment = (function() {
  var $thiz = new $c_Lamf_client_model_document_ResourceTypeFragment();
  $c_Lamf_client_model_document_ResourceTypeFragment.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.ResourceTypeFragment.prototype = $c_Lamf_client_model_document_ResourceTypeFragment.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.SecuritySchemeFragment = (function() {
  var $thiz = new $c_Lamf_client_model_document_SecuritySchemeFragment();
  $c_Lamf_client_model_document_SecuritySchemeFragment.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.SecuritySchemeFragment.prototype = $c_Lamf_client_model_document_SecuritySchemeFragment.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.TraitFragment = (function() {
  var $thiz = new $c_Lamf_client_model_document_TraitFragment();
  $c_Lamf_client_model_document_TraitFragment.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.TraitFragment.prototype = $c_Lamf_client_model_document_TraitFragment.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.ChannelBindings = (function() {
  var $thiz = new $c_Lamf_client_model_domain_ChannelBindings();
  $c_Lamf_client_model_domain_ChannelBindings.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.ChannelBindings.prototype = $c_Lamf_client_model_domain_ChannelBindings.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.CorrelationId = (function() {
  var $thiz = new $c_Lamf_client_model_domain_CorrelationId();
  $c_Lamf_client_model_domain_CorrelationId.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.CorrelationId.prototype = $c_Lamf_client_model_domain_CorrelationId.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Example = (function() {
  var $thiz = new $c_Lamf_client_model_domain_Example();
  $c_Lamf_client_model_domain_Example.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.Example.prototype = $c_Lamf_client_model_domain_Example.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.MessageBindings = (function() {
  var $thiz = new $c_Lamf_client_model_domain_MessageBindings();
  $c_Lamf_client_model_domain_MessageBindings.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.MessageBindings.prototype = $c_Lamf_client_model_domain_MessageBindings.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Operation = (function() {
  var $thiz = new $c_Lamf_client_model_domain_Operation();
  $c_Lamf_client_model_domain_Operation.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.Operation.prototype = $c_Lamf_client_model_domain_Operation.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.OperationBindings = (function() {
  var $thiz = new $c_Lamf_client_model_domain_OperationBindings();
  $c_Lamf_client_model_domain_OperationBindings.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.OperationBindings.prototype = $c_Lamf_client_model_domain_OperationBindings.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.ParametrizedResourceType = (function() {
  var $thiz = new $c_Lamf_client_model_domain_ParametrizedResourceType();
  $c_Lamf_client_model_domain_ParametrizedResourceType.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.ParametrizedResourceType.prototype = $c_Lamf_client_model_domain_ParametrizedResourceType.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.ParametrizedTrait = (function() {
  var $thiz = new $c_Lamf_client_model_domain_ParametrizedTrait();
  $c_Lamf_client_model_domain_ParametrizedTrait.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.ParametrizedTrait.prototype = $c_Lamf_client_model_domain_ParametrizedTrait.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.ServerBindings = (function() {
  var $thiz = new $c_Lamf_client_model_domain_ServerBindings();
  $c_Lamf_client_model_domain_ServerBindings.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.ServerBindings.prototype = $c_Lamf_client_model_domain_ServerBindings.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Extension = (function() {
  var $thiz = new $c_Lamf_client_model_document_Extension();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_plugins_document_webapi_model_Extension(rest[0]);
      $c_Lamf_client_model_document_Extension.prototype.init___Lamf_plugins_document_webapi_model_Extension.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_model_document_Extension.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.model.domain.Extension.prototype = $c_Lamf_client_model_document_Extension.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Overlay = (function() {
  var $thiz = new $c_Lamf_client_model_document_Overlay();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 1: {
      var prep = $as_Lamf_plugins_document_webapi_model_Overlay(rest[0]);
      $c_Lamf_client_model_document_Overlay.prototype.init___Lamf_plugins_document_webapi_model_Overlay.call($thiz, prep);
      break
    }
    case 0: {
      $c_Lamf_client_model_document_Overlay.prototype.init___.call($thiz);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.model.domain.Overlay.prototype = $c_Lamf_client_model_document_Overlay.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Amqp091ChannelBinding = (function() {
  var $thiz = new $c_Lamf_client_model_domain_Amqp091ChannelBinding();
  $c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.Amqp091ChannelBinding.prototype = $c_Lamf_client_model_domain_Amqp091ChannelBinding.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Amqp091MessageBinding = (function() {
  var $thiz = new $c_Lamf_client_model_domain_Amqp091MessageBinding();
  $c_Lamf_client_model_domain_Amqp091MessageBinding.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.Amqp091MessageBinding.prototype = $c_Lamf_client_model_domain_Amqp091MessageBinding.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Amqp091OperationBinding = (function() {
  var $thiz = new $c_Lamf_client_model_domain_Amqp091OperationBinding();
  $c_Lamf_client_model_domain_Amqp091OperationBinding.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.Amqp091OperationBinding.prototype = $c_Lamf_client_model_domain_Amqp091OperationBinding.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.HttpMessageBinding = (function() {
  var $thiz = new $c_Lamf_client_model_domain_HttpMessageBinding();
  $c_Lamf_client_model_domain_HttpMessageBinding.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.HttpMessageBinding.prototype = $c_Lamf_client_model_domain_HttpMessageBinding.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.HttpOperationBinding = (function() {
  var $thiz = new $c_Lamf_client_model_domain_HttpOperationBinding();
  $c_Lamf_client_model_domain_HttpOperationBinding.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.HttpOperationBinding.prototype = $c_Lamf_client_model_domain_HttpOperationBinding.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.KafkaMessageBinding = (function() {
  var $thiz = new $c_Lamf_client_model_domain_KafkaMessageBinding();
  $c_Lamf_client_model_domain_KafkaMessageBinding.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.KafkaMessageBinding.prototype = $c_Lamf_client_model_domain_KafkaMessageBinding.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.KafkaOperationBinding = (function() {
  var $thiz = new $c_Lamf_client_model_domain_KafkaOperationBinding();
  $c_Lamf_client_model_domain_KafkaOperationBinding.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.KafkaOperationBinding.prototype = $c_Lamf_client_model_domain_KafkaOperationBinding.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.MqttMessageBinding = (function() {
  var $thiz = new $c_Lamf_client_model_domain_MqttMessageBinding();
  $c_Lamf_client_model_domain_MqttMessageBinding.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.MqttMessageBinding.prototype = $c_Lamf_client_model_domain_MqttMessageBinding.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.MqttOperationBinding = (function() {
  var $thiz = new $c_Lamf_client_model_domain_MqttOperationBinding();
  $c_Lamf_client_model_domain_MqttOperationBinding.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.MqttOperationBinding.prototype = $c_Lamf_client_model_domain_MqttOperationBinding.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.MqttServerBinding = (function() {
  var $thiz = new $c_Lamf_client_model_domain_MqttServerBinding();
  $c_Lamf_client_model_domain_MqttServerBinding.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.MqttServerBinding.prototype = $c_Lamf_client_model_domain_MqttServerBinding.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.PropertyShape = (function() {
  var $thiz = new $c_Lamf_client_model_domain_PropertyShape();
  var jsx$1 = (arguments.length | 0);
  var jsx$2 = 0;
  var rest = [];
  while ((jsx$2 < jsx$1)) {
    rest.push(arguments[jsx$2]);
    jsx$2 = ((jsx$2 + 1) | 0)
  };
  switch ($uI(rest.length)) {
    case 0: {
      $c_Lamf_client_model_domain_PropertyShape.prototype.init___.call($thiz);
      break
    }
    case 1: {
      var prep = $as_Lamf_core_model_domain_extensions_PropertyShape(rest[0]);
      $c_Lamf_client_model_domain_PropertyShape.prototype.init___Lamf_core_model_domain_extensions_PropertyShape.call($thiz, prep);
      break
    }
    default: {
      throw "No matching overload"
    }
  };
  return $thiz
});
$e.model.domain.PropertyShape.prototype = $c_Lamf_client_model_domain_PropertyShape.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.RecursiveShape = (function(arg) {
  var $thiz = new $c_Lamf_client_model_domain_RecursiveShape();
  var prep = $as_Lamf_core_model_domain_RecursiveShape(arg);
  $c_Lamf_client_model_domain_RecursiveShape.prototype.init___Lamf_core_model_domain_RecursiveShape.call($thiz, prep);
  return $thiz
});
$e.model.domain.RecursiveShape.prototype = $c_Lamf_client_model_domain_RecursiveShape.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Request = (function() {
  var $thiz = new $c_Lamf_client_model_domain_Request();
  $c_Lamf_client_model_domain_Request.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.Request.prototype = $c_Lamf_client_model_domain_Request.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.ResourceType = (function() {
  var $thiz = new $c_Lamf_client_model_domain_ResourceType();
  $c_Lamf_client_model_domain_ResourceType.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.ResourceType.prototype = $c_Lamf_client_model_domain_ResourceType.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Response = (function() {
  var $thiz = new $c_Lamf_client_model_domain_Response();
  $c_Lamf_client_model_domain_Response.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.Response.prototype = $c_Lamf_client_model_domain_Response.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.Trait = (function() {
  var $thiz = new $c_Lamf_client_model_domain_Trait();
  $c_Lamf_client_model_domain_Trait.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.Trait.prototype = $c_Lamf_client_model_domain_Trait.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.WebSocketsChannelBinding = (function() {
  var $thiz = new $c_Lamf_client_model_domain_WebSocketsChannelBinding();
  $c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.WebSocketsChannelBinding.prototype = $c_Lamf_client_model_domain_WebSocketsChannelBinding.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.FileShape = (function() {
  var $thiz = new $c_Lamf_client_model_domain_FileShape();
  $c_Lamf_client_model_domain_FileShape.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.FileShape.prototype = $c_Lamf_client_model_domain_FileShape.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.NilShape = (function() {
  var $thiz = new $c_Lamf_client_model_domain_NilShape();
  $c_Lamf_client_model_domain_NilShape.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.NilShape.prototype = $c_Lamf_client_model_domain_NilShape.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.NodeShape = (function() {
  var $thiz = new $c_Lamf_client_model_domain_NodeShape();
  $c_Lamf_client_model_domain_NodeShape.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.NodeShape.prototype = $c_Lamf_client_model_domain_NodeShape.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.ScalarShape = (function() {
  var $thiz = new $c_Lamf_client_model_domain_ScalarShape();
  $c_Lamf_client_model_domain_ScalarShape.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.ScalarShape.prototype = $c_Lamf_client_model_domain_ScalarShape.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.SchemaShape = (function() {
  var $thiz = new $c_Lamf_client_model_domain_SchemaShape();
  $c_Lamf_client_model_domain_SchemaShape.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.SchemaShape.prototype = $c_Lamf_client_model_domain_SchemaShape.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.UnionShape = (function() {
  var $thiz = new $c_Lamf_client_model_domain_UnionShape();
  $c_Lamf_client_model_domain_UnionShape.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.UnionShape.prototype = $c_Lamf_client_model_domain_UnionShape.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.ArrayShape = (function() {
  var $thiz = new $c_Lamf_client_model_domain_ArrayShape();
  $c_Lamf_client_model_domain_ArrayShape.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.ArrayShape.prototype = $c_Lamf_client_model_domain_ArrayShape.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.DynamicBinding = (function() {
  var $thiz = new $c_Lamf_client_model_domain_DynamicBinding();
  $c_Lamf_client_model_domain_DynamicBinding.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.DynamicBinding.prototype = $c_Lamf_client_model_domain_DynamicBinding.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.EmptyBinding = (function() {
  var $thiz = new $c_Lamf_client_model_domain_EmptyBinding();
  $c_Lamf_client_model_domain_EmptyBinding.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.EmptyBinding.prototype = $c_Lamf_client_model_domain_EmptyBinding.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.TupleShape = (function() {
  var $thiz = new $c_Lamf_client_model_domain_TupleShape();
  $c_Lamf_client_model_domain_TupleShape.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.TupleShape.prototype = $c_Lamf_client_model_domain_TupleShape.prototype;
$e.model = ($e.model || {});
$e.model.domain = ($e.model.domain || {});
/** @constructor */
$e.model.domain.MatrixShape = (function() {
  var $thiz = new $c_Lamf_client_model_domain_MatrixShape();
  $c_Lamf_client_model_domain_MatrixShape.prototype.init___.call($thiz);
  return $thiz
});
$e.model.domain.MatrixShape.prototype = $c_Lamf_client_model_domain_MatrixShape.prototype;
//# sourceMappingURL=amf-client-fastopt.js.map
